diff --git a/Documentation/00-INDEX b/Documentation/00-INDEX
index 3acc4f1..4a5a887 100644
--- a/Documentation/00-INDEX
+++ b/Documentation/00-INDEX
@@ -436,6 +436,8 @@ sysrq.txt
 	- info on the magic SysRq key.
 target/
 	- directory with info on generating TCM v4 fabric .ko modules
+tee.txt
+	- info on the TEE subsystem and drivers
 this_cpu_ops.txt
 	- List rationale behind and the way to use this_cpu operations.
 thermal/
diff --git a/Documentation/ABI/testing/sysfs-class-dual-role-usb b/Documentation/ABI/testing/sysfs-class-dual-role-usb
new file mode 100644
index 00000000..a900fd7
--- /dev/null
+++ b/Documentation/ABI/testing/sysfs-class-dual-role-usb
@@ -0,0 +1,71 @@
+What:		/sys/class/dual_role_usb/.../
+Date:		June 2015
+Contact:	Badhri Jagan Sridharan<badhri@google.com>
+Description:
+		Provide a generic interface to monitor and change
+		the state of dual role usb ports. The name here
+		refers to the name mentioned in the
+		dual_role_phy_desc that is passed while registering
+		the dual_role_phy_intstance through
+		devm_dual_role_instance_register.
+
+What:           /sys/class/dual_role_usb/.../supported_modes
+Date:           June 2015
+Contact:        Badhri Jagan Sridharan<badhri@google.com>
+Description:
+		This is a static node, once initialized this
+		is not expected to change during runtime. "dfp"
+		refers to "downstream facing port" i.e. port can
+		only act as host. "ufp" refers to "upstream
+		facing port" i.e. port can only act as device.
+		"dfp ufp" refers to "dual role port" i.e. the port
+		can either be a host port or a device port.
+
+What:		/sys/class/dual_role_usb/.../mode
+Date:		June 2015
+Contact:	Badhri Jagan Sridharan<badhri@google.com>
+Description:
+		The mode node refers to the current mode in which the
+		port is operating. "dfp" for host ports. "ufp" for device
+		ports and "none" when cable is not connected.
+
+		On devices where the USB mode is software-controllable,
+		userspace can change the mode by writing "dfp" or "ufp".
+		On devices where the USB mode is fixed in hardware,
+		this attribute is read-only.
+
+What:		/sys/class/dual_role_usb/.../power_role
+Date:		June 2015
+Contact:	Badhri Jagan Sridharan<badhri@google.com>
+Description:
+		The power_role node mentions whether the port
+		is "sink"ing or "source"ing power. "none" if
+		they are not connected.
+
+		On devices implementing USB Power Delivery,
+		userspace can control the power role by writing "sink" or
+		"source". On devices without USB-PD, this attribute is
+		read-only.
+
+What:		/sys/class/dual_role_usb/.../data_role
+Date:		June 2015
+Contact:	Badhri Jagan Sridharan<badhri@google.com>
+Description:
+		The data_role node mentions whether the port
+		is acting as "host" or "device" for USB data connection.
+		"none" if there is no active data link.
+
+		On devices implementing USB Power Delivery, userspace
+		can control the data role by writing "host" or "device".
+		On devices without USB-PD, this attribute is read-only
+
+What:		/sys/class/dual_role_usb/.../powers_vconn
+Date:		June 2015
+Contact:	Badhri Jagan Sridharan<badhri@google.com>
+Description:
+		The powers_vconn node mentions whether the port
+		is supplying power for VCONN pin.
+
+		On devices with software control of VCONN,
+		userspace can disable the power supply to VCONN by writing "n",
+		or enable the power supply by writing "y".
diff --git a/Documentation/ABI/testing/sysfs-fs-f2fs b/Documentation/ABI/testing/sysfs-fs-f2fs
index a809f60..f82da9b 100644
--- a/Documentation/ABI/testing/sysfs-fs-f2fs
+++ b/Documentation/ABI/testing/sysfs-fs-f2fs
@@ -51,12 +51,33 @@ Description:
 		 Controls the dirty page count condition for the in-place-update
 		 policies.
 
+What:		/sys/fs/f2fs/<disk>/min_hot_blocks
+Date:		March 2017
+Contact:	"Jaegeuk Kim" <jaegeuk@kernel.org>
+Description:
+		 Controls the dirty page count condition for redefining hot data.
+
+What:		/sys/fs/f2fs/<disk>/min_ssr_sections
+Date:		October 2017
+Contact:	"Chao Yu" <yuchao0@huawei.com>
+Description:
+		 Controls the fee section threshold to trigger SSR allocation.
+
 What:		/sys/fs/f2fs/<disk>/max_small_discards
 Date:		November 2013
 Contact:	"Jaegeuk Kim" <jaegeuk.kim@samsung.com>
 Description:
 		 Controls the issue rate of small discard commands.
 
+What:          /sys/fs/f2fs/<disk>/discard_granularity
+Date:          July 2017
+Contact:       "Chao Yu" <yuchao0@huawei.com>
+Description:
+		Controls discard granularity of inner discard thread, inner thread
+		will not issue discards with size that is smaller than granularity.
+		The unit size is one block, now only support configuring in range
+		of [1, 512].
+
 What:		/sys/fs/f2fs/<disk>/max_victim_search
 Date:		January 2014
 Contact:	"Jaegeuk Kim" <jaegeuk.kim@samsung.com>
@@ -80,6 +101,7 @@ Date:		February 2015
 Contact:	"Jaegeuk Kim" <jaegeuk@kernel.org>
 Description:
 		 Controls the trimming rate in batch mode.
+		 <deprecated>
 
 What:		/sys/fs/f2fs/<disk>/cp_interval
 Date:		October 2015
@@ -93,6 +115,12 @@ Contact:	"Jaegeuk Kim" <jaegeuk@kernel.org>
 Description:
 		 Controls the idle timing.
 
+What:		/sys/fs/f2fs/<disk>/iostat_enable
+Date:		August 2017
+Contact:	"Chao Yu" <yuchao0@huawei.com>
+Description:
+		 Controls to enable/disable IO stat.
+
 What:		/sys/fs/f2fs/<disk>/ra_nid_pages
 Date:		October 2015
 Contact:	"Chao Yu" <chao2.yu@samsung.com>
@@ -112,3 +140,67 @@ Date:		January 2016
 Contact:	"Shuoran Liu" <liushuoran@huawei.com>
 Description:
 		 Shows total written kbytes issued to disk.
+
+What:		/sys/fs/f2fs/<disk>/feature
+Date:		July 2017
+Contact:	"Jaegeuk Kim" <jaegeuk@kernel.org>
+Description:
+		 Shows all enabled features in current device.
+
+What:		/sys/fs/f2fs/<disk>/inject_rate
+Date:		May 2016
+Contact:	"Sheng Yong" <shengyong1@huawei.com>
+Description:
+		 Controls the injection rate.
+
+What:		/sys/fs/f2fs/<disk>/inject_type
+Date:		May 2016
+Contact:	"Sheng Yong" <shengyong1@huawei.com>
+Description:
+		 Controls the injection type.
+
+What:		/sys/fs/f2fs/<disk>/reserved_blocks
+Date:		June 2017
+Contact:	"Chao Yu" <yuchao0@huawei.com>
+Description:
+		 Controls target reserved blocks in system, the threshold
+		 is soft, it could exceed current available user space.
+
+What:		/sys/fs/f2fs/<disk>/current_reserved_blocks
+Date:		October 2017
+Contact:	"Yunlong Song" <yunlong.song@huawei.com>
+Contact:	"Chao Yu" <yuchao0@huawei.com>
+Description:
+		 Shows current reserved blocks in system, it may be temporarily
+		 smaller than target_reserved_blocks, but will gradually
+		 increase to target_reserved_blocks when more free blocks are
+		 freed by user later.
+
+What:		/sys/fs/f2fs/<disk>/gc_urgent
+Date:		August 2017
+Contact:	"Jaegeuk Kim" <jaegeuk@kernel.org>
+Description:
+		 Do background GC agressively
+
+What:		/sys/fs/f2fs/<disk>/gc_urgent_sleep_time
+Date:		August 2017
+Contact:	"Jaegeuk Kim" <jaegeuk@kernel.org>
+Description:
+		 Controls sleep time of GC urgent mode
+
+What:		/sys/fs/f2fs/<disk>/readdir_ra
+Date:		November 2017
+Contact:	"Sheng Yong" <shengyong1@huawei.com>
+Description:
+		 Controls readahead inode block in readdir.
+
+What:		/sys/fs/f2fs/<disk>/extension_list
+Date:		Feburary 2018
+Contact:	"Chao Yu" <yuchao0@huawei.com>
+Description:
+		 Used to control configure extension list:
+		 - Query: cat /sys/fs/f2fs/<disk>/extension_list
+		 - Add: echo '[h/c]extension' > /sys/fs/f2fs/<disk>/extension_list
+		 - Del: echo '[h/c]!extension' > /sys/fs/f2fs/<disk>/extension_list
+		 - [h] means add/del hot file extension
+		 - [c] means add/del cold file extension
diff --git a/Documentation/ABI/testing/sysfs-kernel-wakeup_reasons b/Documentation/ABI/testing/sysfs-kernel-wakeup_reasons
new file mode 100644
index 00000000..acb19b9
--- /dev/null
+++ b/Documentation/ABI/testing/sysfs-kernel-wakeup_reasons
@@ -0,0 +1,16 @@
+What:		/sys/kernel/wakeup_reasons/last_resume_reason
+Date:		February 2014
+Contact:	Ruchi Kandoi <kandoiruchi@google.com>
+Description:
+		The /sys/kernel/wakeup_reasons/last_resume_reason is
+		used to report wakeup reasons after system exited suspend.
+
+What:		/sys/kernel/wakeup_reasons/last_suspend_time
+Date:		March 2015
+Contact:	jinqian <jinqian@google.com>
+Description:
+		The /sys/kernel/wakeup_reasons/last_suspend_time is
+		used to report time spent in last suspend cycle. It contains
+		two numbers (in seconds) separated by space. First number is
+		the time spent in suspend and resume processes. Second number
+		is the time spent in sleep state.
\ No newline at end of file
diff --git a/Documentation/android.txt b/Documentation/android.txt
new file mode 100644
index 00000000..0f40a78
--- /dev/null
+++ b/Documentation/android.txt
@@ -0,0 +1,121 @@
+				=============
+				A N D R O I D
+				=============
+
+Copyright (C) 2009 Google, Inc.
+Written by Mike Chan <mike@android.com>
+
+CONTENTS:
+---------
+
+1. Android
+  1.1 Required enabled config options
+  1.2 Required disabled config options
+  1.3 Recommended enabled config options
+2. Contact
+
+
+1. Android
+==========
+
+Android (www.android.com) is an open source operating system for mobile devices.
+This document describes configurations needed to run the Android framework on
+top of the Linux kernel.
+
+To see a working defconfig look at msm_defconfig or goldfish_defconfig
+which can be found at http://android.git.kernel.org in kernel/common.git
+and kernel/msm.git
+
+
+1.1 Required enabled config options
+-----------------------------------
+After building a standard defconfig, ensure that these options are enabled in
+your .config or defconfig if they are not already. Based off the msm_defconfig.
+You should keep the rest of the default options enabled in the defconfig
+unless you know what you are doing.
+
+ANDROID_PARANOID_NETWORK
+ASHMEM
+CONFIG_FB_MODE_HELPERS
+CONFIG_FONT_8x16
+CONFIG_FONT_8x8
+CONFIG_YAFFS_SHORT_NAMES_IN_RAM
+DAB
+EARLYSUSPEND
+FB
+FB_CFB_COPYAREA
+FB_CFB_FILLRECT
+FB_CFB_IMAGEBLIT
+FB_DEFERRED_IO
+FB_TILEBLITTING
+HIGH_RES_TIMERS
+INOTIFY
+INOTIFY_USER
+INPUT_EVDEV
+INPUT_GPIO
+INPUT_MISC
+LEDS_CLASS
+LEDS_GPIO
+LOCK_KERNEL
+LkOGGER
+LOW_MEMORY_KILLER
+MISC_DEVICES
+NEW_LEDS
+NO_HZ
+POWER_SUPPLY
+PREEMPT
+RAMFS
+RTC_CLASS
+RTC_LIB
+SWITCH
+SWITCH_GPIO
+TMPFS
+UID_STAT
+UID16
+USB_FUNCTION
+USB_FUNCTION_ADB
+USER_WAKELOCK
+VIDEO_OUTPUT_CONTROL
+WAKELOCK
+YAFFS_AUTO_YAFFS2
+YAFFS_FS
+YAFFS_YAFFS1
+YAFFS_YAFFS2
+
+
+1.2 Required disabled config options
+------------------------------------
+CONFIG_YAFFS_DISABLE_LAZY_LOAD
+DNOTIFY
+
+
+1.3 Recommended enabled config options
+------------------------------
+ANDROID_PMEM
+PSTORE_CONSOLE
+PSTORE_RAM
+SCHEDSTATS
+DEBUG_PREEMPT
+DEBUG_MUTEXES
+DEBUG_SPINLOCK_SLEEP
+DEBUG_INFO
+FRAME_POINTER
+CPU_FREQ
+CPU_FREQ_TABLE
+CPU_FREQ_DEFAULT_GOV_ONDEMAND
+CPU_FREQ_GOV_ONDEMAND
+CRC_CCITT
+EMBEDDED
+INPUT_TOUCHSCREEN
+I2C
+I2C_BOARDINFO
+LOG_BUF_SHIFT=17
+SERIAL_CORE
+SERIAL_CORE_CONSOLE
+
+
+2. Contact
+==========
+website: http://android.git.kernel.org
+
+mailing-lists: android-kernel@googlegroups.com
diff --git a/Documentation/block/00-INDEX b/Documentation/block/00-INDEX
index e55103a..a542b9f 100644
--- a/Documentation/block/00-INDEX
+++ b/Documentation/block/00-INDEX
@@ -30,3 +30,9 @@ switching-sched.txt
 	- Switching I/O schedulers at runtime
 writeback_cache_control.txt
 	- Control of volatile write back caches
+mmc-max-speed.txt
+	- eMMC layer speed simulation, related to /sys/block/mmcblk*/
+          attributes:
+            max_read_speed
+            max_write_speed
+            cache_size
diff --git a/Documentation/block/mmc-max-speed.txt b/Documentation/block/mmc-max-speed.txt
new file mode 100644
index 00000000..3f052b9
--- /dev/null
+++ b/Documentation/block/mmc-max-speed.txt
@@ -0,0 +1,38 @@
+eMMC Block layer simulation speed controls in /sys/block/mmcblk*/
+===============================================
+
+Turned on with CONFIG_MMC_SIMULATE_MAX_SPEED which enables MMC device speed
+limiting. Used to test and simulate the behavior of the system when
+confronted with a slow MMC.
+
+Enables max_read_speed, max_write_speed and cache_size attributes and module
+default parameters to control the write or read maximum KB/second speed
+behaviors.
+
+NB: There is room for improving the algorithm for aspects tied directly to
+eMMC specific behavior. For instance, wear leveling and stalls from an
+exhausted erase pool. We would expect that if there was a need to provide
+similar speed simulation controls to other types of block devices, aspects of
+their behavior are modelled separately (e.g. head seek times, heat assist,
+shingling and rotational latency).
+
+/sys/block/mmcblk0/max_read_speed:
+
+Number of KB/second reads allowed to the block device. Used to test and
+simulate the behavior of the system when confronted with a slow reading MMC.
+Set to 0 or "off" to place no speed limit.
+
+/sys/block/mmcblk0/max_write_speed:
+
+Number of KB/second writes allowed to the block device. Used to test and
+simulate the behavior of the system when confronted with a slow writing MMC.
+Set to 0 or "off" to place no speed limit.
+
+/sys/block/mmcblk0/cache_size:
+
+Number of MB of high speed memory or high speed SLC cache expected on the
+eMMC device being simulated. Used to help simulate the write-back behavior
+more accurately. The assumption is the cache has no delay, but draws down
+in the background to the MLC/TLC primary store at the max_write_speed rate.
+Any write speed delays will show up when the cache is full, or when an I/O
+request to flush is issued.
diff --git a/Documentation/cpu-freq/governors.txt b/Documentation/cpu-freq/governors.txt
index c15aa75..0cf9a6b 100644
--- a/Documentation/cpu-freq/governors.txt
+++ b/Documentation/cpu-freq/governors.txt
@@ -28,6 +28,7 @@ Contents:
 2.3  Userspace
 2.4  Ondemand
 2.5  Conservative
+2.6  Interactive
 
 3.   The Governor Interface in the CPUfreq Core
 
@@ -218,6 +219,91 @@ a decision on when to decrease the frequency while running in any
 speed. Load for frequency increase is still evaluated every
 sampling rate.
 
+2.6 Interactive
+---------------
+
+The CPUfreq governor "interactive" is designed for latency-sensitive,
+interactive workloads. This governor sets the CPU speed depending on
+usage, similar to "ondemand" and "conservative" governors, but with a
+different set of configurable behaviors.
+
+The tunable values for this governor are:
+
+above_hispeed_delay: When speed is at or above hispeed_freq, wait for
+this long before raising speed in response to continued high load.
+The format is a single delay value, optionally followed by pairs of
+CPU speeds and the delay to use at or above those speeds.  Colons can
+be used between the speeds and associated delays for readability.  For
+example:
+
+   80000 1300000:200000 1500000:40000
+
+uses delay 80000 uS until CPU speed 1.3 GHz, at which speed delay
+200000 uS is used until speed 1.5 GHz, at which speed (and above)
+delay 40000 uS is used.  If speeds are specified these must appear in
+ascending order.  Default is 20000 uS.
+
+boost: If non-zero, immediately boost speed of all CPUs to at least
+hispeed_freq until zero is written to this attribute.  If zero, allow
+CPU speeds to drop below hispeed_freq according to load as usual.
+Default is zero.
+
+boostpulse: On each write, immediately boost speed of all CPUs to
+hispeed_freq for at least the period of time specified by
+boostpulse_duration, after which speeds are allowed to drop below
+hispeed_freq according to load as usual. Its a write-only file.
+
+boostpulse_duration: Length of time to hold CPU speed at hispeed_freq
+on a write to boostpulse, before allowing speed to drop according to
+load as usual.  Default is 80000 uS.
+
+go_hispeed_load: The CPU load at which to ramp to hispeed_freq.
+Default is 99%.
+
+hispeed_freq: An intermediate "high speed" at which to initially ramp
+when CPU load hits the value specified in go_hispeed_load.  If load
+stays high for the amount of time specified in above_hispeed_delay,
+then speed may be bumped higher.  Default is the maximum speed allowed
+by the policy at governor initialization time.
+
+io_is_busy: If set, the governor accounts IO time as CPU busy time.
+
+min_sample_time: The minimum amount of time to spend at the current
+frequency before ramping down. Default is 80000 uS.
+
+target_loads: CPU load values used to adjust speed to influence the
+current CPU load toward that value.  In general, the lower the target
+load, the more often the governor will raise CPU speeds to bring load
+below the target.  The format is a single target load, optionally
+followed by pairs of CPU speeds and CPU loads to target at or above
+those speeds.  Colons can be used between the speeds and associated
+target loads for readability.  For example:
+
+   85 1000000:90 1700000:99
+
+targets CPU load 85% below speed 1GHz, 90% at or above 1GHz, until
+1.7GHz and above, at which load 99% is targeted.  If speeds are
+specified these must appear in ascending order.  Higher target load
+values are typically specified for higher speeds, that is, target load
+values also usually appear in an ascending order. The default is
+target load 90% for all speeds.
+
+timer_rate: Sample rate for reevaluating CPU load when the CPU is not
+idle.  A deferrable timer is used, such that the CPU will not be woken
+from idle to service this timer until something else needs to run.
+(The maximum time to allow deferring this timer when not running at
+minimum speed is configurable via timer_slack.)  Default is 20000 uS.
+
+timer_slack: Maximum additional time to defer handling the governor
+sampling timer beyond timer_rate when running at speeds above the
+minimum.  For platforms that consume additional power at idle when
+CPUs are running at speeds greater than minimum, this places an upper
+bound on how long the timer will be deferred prior to re-evaluating
+load and dropping speed.  For example, if timer_rate is 20000uS and
+timer_slack is 10000uS then timers will be deferred for up to 30msec
+when not at lowest speed.  A value of -1 means defer timers
+indefinitely at all speeds.  Default is 80000 uS.
+
 3. The Governor Interface in the CPUfreq Core
 =============================================
 
diff --git a/Documentation/device-mapper/boot.txt b/Documentation/device-mapper/boot.txt
new file mode 100644
index 00000000..adcaad5
--- /dev/null
+++ b/Documentation/device-mapper/boot.txt
@@ -0,0 +1,42 @@
+Boot time creation of mapped devices
+===================================
+
+It is possible to configure a device mapper device to act as the root
+device for your system in two ways.
+
+The first is to build an initial ramdisk which boots to a minimal
+userspace which configures the device, then pivot_root(8) in to it.
+
+For simple device mapper configurations, it is possible to boot directly
+using the following kernel command line:
+
+dm="<name> <uuid> <ro>,table line 1,...,table line n"
+
+name = the name to associate with the device
+	after boot, udev, if used, will use that name to label
+	the device node.
+uuid = may be 'none' or the UUID desired for the device.
+ro = may be "ro" or "rw".  If "ro", the device and device table will be
+	marked read-only.
+
+Each table line may be as normal when using the dmsetup tool except for
+two variations:
+1. Any use of commas will be interpreted as a newline
+2. Quotation marks cannot be escaped and cannot be used without
+   terminating the dm= argument.
+
+Unless renamed by udev, the device node created will be dm-0 as the
+first minor number for the device-mapper is used during early creation.
+
+Example
+=======
+
+- Booting to a linear array made up of user-mode linux block devices:
+
+  dm="lroot none 0, 0 4096 linear 98:16 0, 4096 4096 linear 98:32 0" \
+  root=/dev/dm-0
+
+Will boot to a rw dm-linear target of 8192 sectors split across two
+block devices identified by their major:minor numbers.  After boot, udev
+will rename this target to /dev/mapper/lroot (depending on the rules).
+No uuid was assigned.
diff --git a/Documentation/device-mapper/verity.txt b/Documentation/device-mapper/verity.txt
index 89fd8f9..b3d2e4a 100644
--- a/Documentation/device-mapper/verity.txt
+++ b/Documentation/device-mapper/verity.txt
@@ -109,6 +109,17 @@ fec_start <offset>
     This is the offset, in <data_block_size> blocks, from the start of the
     FEC device to the beginning of the encoding data.
 
+check_at_most_once
+    Verify data blocks only the first time they are read from the data device,
+    rather than every time.  This reduces the overhead of dm-verity so that it
+    can be used on systems that are memory and/or CPU constrained.  However, it
+    provides a reduced level of security because only offline tampering of the
+    data device's content will be detected, not online tampering.
+
+    Hash blocks are still verified each time they are read from the hash device,
+    since verification of hash blocks is less performance critical than data
+    blocks, and a hash block will not be verified any more after all the data
+    blocks it covers have been verified anyway.
 
 Theory of operation
 ===================
diff --git a/Documentation/devicetree/bindings/arm/firmware/linaro,optee-tz.txt b/Documentation/devicetree/bindings/arm/firmware/linaro,optee-tz.txt
new file mode 100644
index 00000000..d38834c
--- /dev/null
+++ b/Documentation/devicetree/bindings/arm/firmware/linaro,optee-tz.txt
@@ -0,0 +1,31 @@
+OP-TEE Device Tree Bindings
+
+OP-TEE is a piece of software using hardware features to provide a Trusted
+Execution Environment. The security can be provided with ARM TrustZone, but
+also by virtualization or a separate chip.
+
+We're using "linaro" as the first part of the compatible property for
+the reference implementation maintained by Linaro.
+
+* OP-TEE based on ARM TrustZone required properties:
+
+- compatible     : should contain "linaro,optee-tz"
+
+- method         : The method of calling the OP-TEE Trusted OS. Permitted
+                   values are:
+
+                   "smc" : SMC #0, with the register assignments specified
+		           in drivers/tee/optee/optee_smc.h
+
+                   "hvc" : HVC #0, with the register assignments specified
+		           in drivers/tee/optee/optee_smc.h
+
+
+
+Example:
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
diff --git a/Documentation/devicetree/bindings/clock/realtek,clocks.txt b/Documentation/devicetree/bindings/clock/realtek,clocks.txt
new file mode 100644
index 00000000..3ed904c
--- /dev/null
+++ b/Documentation/devicetree/bindings/clock/realtek,clocks.txt
@@ -0,0 +1,81 @@
+Realtek Clock Controller
+========================
+
+Clock controllers for Realtek Platform
+
+--------------
+Clock Provider
+--------------
+
+Required properties :
+- compatible : shall contain only one of the following:
+
+        "realtek,clock-controller" for Platform Clock Controller
+	"realtek,tee-clock-controller" for TEE Clock Controller
+        "realtek,clock-gate-controller" for Clock Gate Controller
+
+- #clock-cells : shall contain 1
+
+Must contain one of the following properties:
+
+- reg : iomem address required
+
+- realtek,mmio : referring to a regmap for iomem
+
+Optional Properties of Clock Gate Controller :
+
+- ignore-unused-clocks: shall contain a list of strings with clk_name in the
+                        contoller, if a clock is in the list, the
+                        CLK_IGNORE_UNUSED flags will be applied to the clock.
+
+- ignore-pm-clocks: shall contain a list of strings with clk_name in the
+                    contoller, if a clock is in the list, the clock will not
+                    be managed in pm callbacks.
+
+- has-write-en -or- realtek,hse-web: an bool property which indicates the
+                                     controller to setup the gate clock with
+                                     using write-en bit located in (gate_bit+1)
+
+- clock-output-names: shall contain a list of strings of the clock name, to
+                      be created. For those name with prefix 'unused', it
+                      won't be created.
+
+Example:
+
+	cc: clock-controlller@98000000 {
+		compatible   = "realtek,clock-controller";
+		reg = <0x98000000 0x600>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	tcc: tee-clocks {
+		compatible   = "realtek,tee-clock-controller";
+		#clock-cells = <0>;
+	};
+
+	ce1: clk-en@9800000c {
+		compatible   = "realtek,clock-gate-controller";
+		reg = <0x9800000c 0x4>;
+		#clock-cells = <1>;
+		realtek,cgc,id = <0>;
+		realtek,mmio = <&crt_mmio 0xc>;
+	};
+
+--------------
+Clock consumer
+--------------
+The clock id for clock-controller/clock-gate-contoller is defined in
+
+        dt-bindings/clock/rtk,clock-rtd119x.h
+        dt-bindings/clock/rtk,clock-rtd129x.h,
+        dt-bindings/clock/rtk,clock-rtd139x.h,
+        dt-bindings/clock/rtk,clock-rtd16xx.h,
+        dt-bindings/clock/rtk,clock-rtd13xx.h.
+
+Example:
+
+	device {
+		clocks = <&cc CC_PLL_SCPU>, <&ce1 CLK_EN_GPU>;
+	};
+
diff --git a/Documentation/devicetree/bindings/cpufreq/cpufreq-rtk.txt b/Documentation/devicetree/bindings/cpufreq/cpufreq-rtk.txt
new file mode 100644
index 00000000..1b9b6e1
--- /dev/null
+++ b/Documentation/devicetree/bindings/cpufreq/cpufreq-rtk.txt
@@ -0,0 +1,52 @@
+Realtek CPU Driver DT-bindings
+==============================
+
+DVFS node (platform device node)
+-------------------------------
+
+Required properties :
+- compatible : shall contain only any of the following:
+	"realtek,rtd129x-dvfs",
+	"realtek,rtd139x-dvfs",
+	"realtek,cpu-dvfs",
+	"realtek,dummy-dvfs".
+
+CPU node
+--------
+
+When using the dummy cpufreq driver, please put the following properties in the DVFS node.
+
+- OPP binding:
+  See also 'Documentation/devicetree/bindings/opp/opp.txt'
+
+  Only support for operating-points-v2.
+
+- CPU Cooling Dev binding (optional):
+  See also 'Documentation/devicetree/bindings/thermal/thermal.txt'
+
+- Clock binding:
+  See also 'Documentation/devicetree/bindings/regulator/cpu.txt'
+
+- Regulator binding (optional):
+  See also 'Documentation/devicetree/bindings/regulator/regulator.txt'
+
+Exmaple:
+	cpus {
+		cpu@0 {
+			clocks = <&cc CC_PLL_SCPU>;
+                        cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			cooling-min-level = <0>;
+			cooling-max-level = <11>;
+			#cooling-cells = <2>; /* min followed by max */
+		};
+	};
+
+	cpu_opps: opp-table-0 {
+		...
+	};
+
+	dvfs {
+		compatible = "realtek,rtk129x-dvfs";
+	};
+
diff --git a/Documentation/devicetree/bindings/devfreq/realtek,busfreq.txt b/Documentation/devicetree/bindings/devfreq/realtek,busfreq.txt
new file mode 100644
index 00000000..9753bdc
--- /dev/null
+++ b/Documentation/devicetree/bindings/devfreq/realtek,busfreq.txt
@@ -0,0 +1,85 @@
+Realtek Bus DFS DT-bindings
+===========================
+
+BUSFreq node
+------------
+
+Required properties :
+
+- compatible : shall contain the following :
+	"realtek,busfreq".
+
+- operating-points-v2 : a phandle to a operating-points-v2.
+
+- clocks : a phandle to bus clock
+
+- devfreq-events: one or more phandles to devfreq event device(s).
+
+- method: shall contain a string,
+	"ltl" for long term load calculator,
+	"passive" for passive.
+
+- devfreq: only required when method is "passive", a phandle of a reference
+	devfreq device.
+
+Optional propertise :
+
+- ltl-data: data for ltl governor
+
+
+Bandwith Event node
+-------------------
+
+Required properties :
+
+- compatible:  shall contain the following :
+	"realtek,bw-event-dcsys", for a dcsys event,
+	"realtek,bw-event-dmc", for a dmc event,
+
+	and a fixed 2nd compatible
+
+	"devfreq-event".
+
+- perfcnts: shall contain a phandle to a perfcnt.
+
+
+Example :
+
+	event0: dcsys-bandwitdh-event {
+		compatible = "realtek,bw-event-dcsys",
+			"devfreq-event";
+		perfcnts = <&pc0>;
+		status = "okay";
+	};
+
+	event1: dmc-bandwitdh-event {
+		compatible = "realtek,bw-event-dmc",
+			"devfreq-event";
+		perfcnts = <&pc1>;
+		status = "okay";
+	};
+
+	dcsb-dfs {
+		compatible = "realtek,busfreq";
+		clocks = <&cc CC_PLL_DCSB>;
+		devfreq-events = <&event0>, <&event1>;
+		operating-points-v2 = <&dcsb_opps>;
+		ltl-data = <0 0 0>;
+		status = "okay";
+
+		dcsb_opps: opp-table {
+			compatible = "operating-points-v2";
+			opp-low {
+				opp-hz = /bits/ 64 <275000000>;
+				clock-latency-ns = <150000>;
+				suspend-opp;
+			};
+			opp-high {
+				opp-hz = /bits/ 64 <550000000>;
+				clock-latency-ns = <150000>;
+			};
+		};
+	};
+
+
+
diff --git a/Documentation/devicetree/bindings/display/realtek/realtek,rtd-hdcptx.txt b/Documentation/devicetree/bindings/display/realtek/realtek,rtd-hdcptx.txt
new file mode 100644
index 00000000..b36566b2
--- /dev/null
+++ b/Documentation/devicetree/bindings/display/realtek/realtek,rtd-hdcptx.txt
@@ -0,0 +1 @@
+- compatible: "realtek,rtk129x-hdcptx", "realtek,rtk139x-hdcptx"
diff --git a/Documentation/devicetree/bindings/gpio/realtek,gpio.txt b/Documentation/devicetree/bindings/gpio/realtek,gpio.txt
new file mode 100644
index 00000000..35f00fb
--- /dev/null
+++ b/Documentation/devicetree/bindings/gpio/realtek,gpio.txt
@@ -0,0 +1,2 @@
+- compatible: one of "realtek,rtk139x-iso-gpio-irq-mux", 
+"realtek,rtk-misc-gpio-irq-mux","realtek,rtk-iso-gpio-irq-mux"
\ No newline at end of file
diff --git a/Documentation/devicetree/bindings/i2c/i2c-rtk.txt b/Documentation/devicetree/bindings/i2c/i2c-rtk.txt
new file mode 100644
index 00000000..027a4c0
--- /dev/null
+++ b/Documentation/devicetree/bindings/i2c/i2c-rtk.txt
@@ -0,0 +1 @@
+- compatible: must be "realtek,rtk-i2c"
\ No newline at end of file
diff --git a/Documentation/devicetree/bindings/media/realtek,cvbs.txt b/Documentation/devicetree/bindings/media/realtek,cvbs.txt
new file mode 100644
index 00000000..07159dd
--- /dev/null
+++ b/Documentation/devicetree/bindings/media/realtek,cvbs.txt
@@ -0,0 +1 @@
+- compatible: "realtek,rtd1395-cvbs-switch"
\ No newline at end of file
diff --git a/Documentation/devicetree/bindings/mfd/apw888x.txt b/Documentation/devicetree/bindings/mfd/apw888x.txt
new file mode 100644
index 00000000..55c04d8
--- /dev/null
+++ b/Documentation/devicetree/bindings/mfd/apw888x.txt
@@ -0,0 +1,68 @@
+Anpec APW888X series PMIC DT-bindings
+=====================================
+
+Anpec APW888X serise PMIC contains the following sub devices:
+	g22xx-powerkey,
+	g22xx-poweroff,
+	apw8889-regulator for Anpec APW8889,
+	apw8886-regulator for Anper APW8886.
+
+Sub nodes:
+
+powerkey
+--------
+	This is compatible to g22xx-powerkey.
+	See also Documentation/devicetree/bindings/mfd/g22xx.txt
+
+poweroff
+--------
+	This is compatible to g22xx-poweroff.
+	See also Documentation/devicetree/bindings/mfd/g22xx.txt
+
+regulators
+----------
+
+Required properties:
+
+* compatible: shall contains one of the following
+	"anpec,apw8889-regulator",
+	"anpec,apw8886-regulator".
+
+See also Documentation/devicetree/bindings/regulator/regulator.txt.
+
+Properties for sub nodes
+
+Optional properties:
+
+* apw888x-discharge-disable: disable discharge when suspend state is configured
+	to regulator-off-in-suspend in the sub nodes
+	regulator-state-mem/regulator-state-coldboot.
+
+Example:
+
+	&i2c_0 {
+		status = "okay";
+
+		apw8889: apw8889@12 {
+			compatible = "anpec,apw8889";
+			reg = <0x12>;
+			status = "okay";
+
+			powerkey: powerkey {
+				compatible = "gmt,g22xx-powerkey";
+				lp-handler = "sw";
+				it-handler = "sw";
+				time-sel = <0 0 3>;
+				status = "okay";
+			};
+			poweroff: poweroff {
+				compatible = "gmt,g22xx-poweroff";
+				system-power-controller;
+				status = "disabled";
+			};
+			regulators: regulators {
+				compatible = "anpec,apw8889-regulator";
+				status = "okay";
+			};
+		};
+	};
diff --git a/Documentation/devicetree/bindings/mfd/g22xx.txt b/Documentation/devicetree/bindings/mfd/g22xx.txt
new file mode 100644
index 00000000..366829e
--- /dev/null
+++ b/Documentation/devicetree/bindings/mfd/g22xx.txt
@@ -0,0 +1,93 @@
+GMT-G2227/G2237 PMIC DT-bindings
+================================
+
+G22XX series PMIC contains the following sub devices:
+	g22xx-powerkey,
+	g22xx-poweroff,
+	g2227-regulator for G2227,
+	g2237-regulator for G2237.
+
+Sub nodes:
+
+
+powerkey
+--------
+
+Optional propertise:
+
+* lp-handler: a string, shall contains "hw", "sw", "off".
+	use the configuration to handle longpress.
+
+* it-handler: a string, shall contains "sw", "off".
+	 use the configuration to handle short press event.
+
+* time-sel: an integer array, shall contains 3 integer, time selection.
+	<it-time, lp-time, lpoff-time>
+	it-time
+		0: 128ms
+		1: 500ms
+		2: 1000ms
+		3: 1500ms
+	lp-time
+		0: 1s
+		1: 2s
+		2: 3s
+		3: 4s
+	lpoff-time
+		0: 6s
+		1: 7s
+		2: 8s
+		3: 10s
+
+* lpoff-act: an integer, shall contains 0 or 1. specify which action to do
+	when using hw lp-handler.
+	0: reset
+	1: nothing
+
+poweroff
+--------
+
+Required properties:
+
+	system-power-controller: a bool to indicate this device is a system
+	power controller.
+
+regulators
+----------
+
+Required properties:
+
+* compatible: shall contains one of the following
+	"gmt,g2227-regulator",
+	"gmt,g2237-regulator".
+
+	See also Documentation/devicetree/bindings/regulator/regulator.txt.
+
+Example:
+
+	&i2c_0 {
+		status = "okay";
+
+		g2237: g2237@12 {
+			compatible = "gmt,g2237";
+			reg = <0x12>;
+			status = "okay";
+
+			powerkey: powerkey {
+				compatible = "gmt,g22xx-powerkey";
+				lp-handler = "sw";
+				it-handler = "sw";
+				time-sel = <0 0 3>;
+				status = "okay";
+			};
+			poweroff: poweroff {
+				compatible = "gmt,g22xx-poweroff";
+				system-power-controller;
+				status = "disabled";
+			};
+			regulators: regulators {
+				compatible = "gmt,g2237-regulator";
+				status = "okay";
+			};
+		};
+	};
diff --git a/Documentation/devicetree/bindings/misc/memory-state-time.txt b/Documentation/devicetree/bindings/misc/memory-state-time.txt
new file mode 100644
index 00000000..c99a506
--- /dev/null
+++ b/Documentation/devicetree/bindings/misc/memory-state-time.txt
@@ -0,0 +1,8 @@
+Memory bandwidth and frequency state tracking
+
+Required properties:
+- compatible : should be:
+       "memory-state-time"
+- freq-tbl: Should contain entries with each frequency in Hz.
+- bw-buckets: Should contain upper-bound limits for each bandwidth bucket in Mbps.
+       Must match the framework power_profile.xml for the device.
diff --git a/Documentation/devicetree/bindings/net/realtek,rfkill.txt b/Documentation/devicetree/bindings/net/realtek,rfkill.txt
new file mode 100644
index 00000000..c5e2275
--- /dev/null
+++ b/Documentation/devicetree/bindings/net/realtek,rfkill.txt
@@ -0,0 +1 @@
+- compatible: one of "realtek,rfkill"
\ No newline at end of file
diff --git a/Documentation/devicetree/bindings/nvmem/rtk-efuse.txt b/Documentation/devicetree/bindings/nvmem/rtk-efuse.txt
new file mode 100644
index 00000000..0a94231
--- /dev/null
+++ b/Documentation/devicetree/bindings/nvmem/rtk-efuse.txt
@@ -0,0 +1,11 @@
+Realtek eFuse DT-bindings
+=========================
+
+See also 'Documentation/devicetree/bindings/nvmem/nvmem.txt'
+
+Requried properties :
+- compatible : shall contain the following :
+	"realtek,efuse".
+
+- nvmem-cells & nvmem-cell-names : efuse data for display in sysfs.
+
diff --git a/Documentation/devicetree/bindings/pci/realtek-pcie.txt b/Documentation/devicetree/bindings/pci/realtek-pcie.txt
new file mode 100644
index 00000000..f8639eb
--- /dev/null
+++ b/Documentation/devicetree/bindings/pci/realtek-pcie.txt
@@ -0,0 +1 @@
+- compatible: "realtek,rtk-pcie-slot1", "realtek,rtk-pcie-slot2" , "realtek,rtd139x-pcie"
\ No newline at end of file
diff --git a/Documentation/devicetree/bindings/pinctrl/Realtek,pinctrl.txt b/Documentation/devicetree/bindings/pinctrl/Realtek,pinctrl.txt
new file mode 100644
index 00000000..0759f06
--- /dev/null
+++ b/Documentation/devicetree/bindings/pinctrl/Realtek,pinctrl.txt
@@ -0,0 +1 @@
+- compatible: one of "realtek,rtk129x-pinctrl", "realtek,rtk139x-pinctrl"
\ No newline at end of file
diff --git a/Documentation/devicetree/bindings/regulator/realtek-pwm-regulator.txt b/Documentation/devicetree/bindings/regulator/realtek-pwm-regulator.txt
new file mode 100644
index 00000000..6947534
--- /dev/null
+++ b/Documentation/devicetree/bindings/regulator/realtek-pwm-regulator.txt
@@ -0,0 +1,52 @@
+Bindings for the Realtek PWM Regulator
+======================================
+
+Required properties:
+
+
+- compatible:     Shall contain "realtek,pwm-regulator".
+
+- pwms:           PWM specification (See: ../pwm/pwm.txt)
+
+- voltage-table:  Shall contain an array of triples with (voltage, duty, and period)
+
+Optional properties:
+
+Generic Regulator properties (See regulator.txt)
+
+Example:
+
+	cpu_supp: sy8089a-regulator {
+		compatible = "realtek,pwm-regulator";
+		pwms = <&pwm 2 75>;
+		status = "okay";
+
+		regulator-name = "sy8089a-0";
+		regulator-min-microvolt = <800000>;
+		regulator-max-microvolt = <1100000>;
+		regulator-boot-on;
+		regulator-always-on;
+
+		voltage-table = <
+			1100000    0   75
+			1088000   76 1260
+			1070000  152 1260
+			1050000  227 1260
+			1030000  303 1260
+			1016000  378 1260
+			 998000  454 1260
+			 980000  530 1260
+			 962000  605 1260
+			 943000  688 1260
+			 925000  744 1260
+			 907000  819 1260
+			 888000  895 1260
+			 870000  971 1260
+			 850000 1046 1260
+			 833000 1122 1260
+			 816000 1197 1260
+			 800000 1260 1260
+		>;
+	};
+
+
diff --git a/Documentation/devicetree/bindings/regulator/sy8827e-regulator.txt b/Documentation/devicetree/bindings/regulator/sy8827e-regulator.txt
new file mode 100644
index 00000000..31db4df
--- /dev/null
+++ b/Documentation/devicetree/bindings/regulator/sy8827e-regulator.txt
@@ -0,0 +1,13 @@
+Binding for Silergy-SY8827E Regulator
+=====================================
+
+Required Properties:
+
+* reg : shall contains an i2c address.
+
+* compatible : shall contains "silergy,sy8827e".
+
+Optional properties:
+
+Generic Regulator properties (See regulator.txt)
+
diff --git a/Documentation/devicetree/bindings/reset/realtek,reset.txt b/Documentation/devicetree/bindings/reset/realtek,reset.txt
new file mode 100644
index 00000000..3e9bfdf
--- /dev/null
+++ b/Documentation/devicetree/bindings/reset/realtek,reset.txt
@@ -0,0 +1,79 @@
+Realtek Reset Controller
+========================
+
+1. Generic Reset Controller
+
+Required properties :
+
+- compatible : shall contain:
+	"realtek,reset-controller"
+
+- #reset-cells: shall contain 1
+
+- realtek,mmio: shall contain a phandle to mmio node and an offset.
+
+Optional properties :
+
+- async-group: contains an unsigned int. Only the groups with the same id,
+	will be triggered when do_sync.
+
+- no-pm: ingore the pm callbacks.
+
+- boot-clear-bits : contains an unsigned int. A bit mask, which
+        the register value will be clear.
+
+- pm-ignore-bits: contains an unsigned int. A bit mask to tell which bits
+	shall be ignored when restoring register value in pm callbacks.
+
+- has-write-en: : an empty property which indicates the controlller to setup the reset bit with
+	using write-en bit located in (reset_bit+1). (for Thor)
+
+Example: 
+	asr1: async-soft-reset@98000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000000 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+
+		async-group = <0>;
+		no-pm;
+	};
+
+	asr2: async-soft-reset@98000004 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000004 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+
+		async-group = <0>;
+		no-pm;
+	};
+
+	consumer {
+		...
+		resets = <&asr1 RTK_RSTN_DO_SYNC>,
+			<&asr1 0>,
+			<&asr2 1>;
+	};
+
+
+2. Platform Specific Reset Controller
+
+Required properties :
+
+- compatible : shall contain one of the following depended on the platform
+	"realtek,rtd16xx-reset-controller",
+	"realtek,rtd13xx-reset-controller"
+
+- #reset-cells: shall contain 1
+
+- realtek,mmio: shall contain a phandle to mmio node and an offset.
+
+Example:
+	crst: soft-reset@98000000 {
+		compatible = "realtek,rtd16xx-reset-controller";
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		#reset-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
diff --git a/Documentation/devicetree/bindings/rtc/rtc-rtk.txt b/Documentation/devicetree/bindings/rtc/rtc-rtk.txt
new file mode 100644
index 00000000..3626984
--- /dev/null
+++ b/Documentation/devicetree/bindings/rtc/rtc-rtk.txt
@@ -0,0 +1,4 @@
+Realtek real timer driver
+
+Required properties:
+- compatible: must be "realtek,rtk-rtc"
\ No newline at end of file
diff --git a/Documentation/devicetree/bindings/soc/realtek/dcsys_debug.txt b/Documentation/devicetree/bindings/soc/realtek/dcsys_debug.txt
new file mode 100644
index 00000000..e81ceff
--- /dev/null
+++ b/Documentation/devicetree/bindings/soc/realtek/dcsys_debug.txt
@@ -0,0 +1,99 @@
+Realtek DC system bus debug
+=====================
+
+Required properties:
+
+- compatible : shall contain only the following:
+        "realtek,rtk-dcsys-debug".
+
+- reg : hall contain DC system bus configure  address
+
+Example:
+	dc_sys_debug@98008000 {
+		compatible = "realtek,rtk-dcsys-debug";
+		reg = <0x98008000 0x1000>;
+		interrupts = <0 35 4>;
+		err_cmd_detect = <0x0>, /* Enable over DRAM access detection */
+			<0x0>; /* interrupt to CPU */
+		mt_0 = <0x0>,  /* NUM0 Enable memory trash detection */
+			<0x0>, /* NUM0 start address*/
+			<0x0>, /* NUM0 end address*/
+			<0x0>, /* NUM0 module ID0*/
+			<0x0>, /* NUM0 module ID1*/
+			<0x0>, /* NUM0 module ID2*/
+			<0x0>, /* NUM0 module ID3*/
+			<0x0>, /* NUM0 interrupt to CPU*/
+			<0x3>, /* NUM0 access type*/
+			<0x0>; /* NUM0 mode*/
+		mt_1 = <0x0>, /* NUM1 Enable memory trash detection */
+			<0x0>, /* NUM1 start address*/
+			<0x0>, /* NUM1 end address*/
+			<0x0>, /* NUM1 module ID0*/
+			<0x0>, /* NUM1 module ID1*/
+			<0x0>, /* NUM1 module ID2*/
+			<0x0>, /* NUM1 module ID3*/
+			<0x0>, /* NUM1 interrupt to CPU*/
+			<0x0>, /* NUM1 access type*/
+			<0x0>; /* NUM1 mode*/
+		mt_2 = <0x0>, /* NUM2 Enable memory trash detection */
+			<0x0>, /* NUM2 start address*/
+			<0x0>, /* NUM2 end address*/
+			<0x0>, /* NUM2 module ID0*/
+			<0x0>, /* NUM2 module ID1*/
+			<0x0>, /* NUM2 module ID2*/
+			<0x0>, /* NUM2 module ID3*/
+			<0x0>, /* NUM2 interrupt to CPU*/
+			<0x0>, /* NUM2 access type*/
+			<0x0>; /* NUM2 mode*/
+		mt_3 = <0x0>,  /* NUM3 Enable memory trash detection */
+			<0x0>, /* NUM3 start address*/
+			<0x0>, /* NUM3 end address*/
+			<0x0>, /* NUM3 module ID0*/
+			<0x0>, /* NUM3 module ID1*/
+			<0x0>, /* NUM3 module ID2*/
+			<0x0>, /* NUM3 module ID3*/
+			<0x0>, /* NUM3 interrupt to CPU*/
+			<0x0>, /* NUM3 access type*/
+			<0x0>; /* NUM3 mode*/
+		mt_4 = <0x0>,  /* NUM4 Enable memory trash detection */
+			<0x0>, /* NUM4 start address*/
+			<0x0>, /* NUM4 end address*/
+			<0x0>, /* NUM4 module ID0*/
+			<0x0>, /* NUM4 module ID1*/
+			<0x0>, /* NUM4 module ID2*/
+			<0x0>, /* NUM4 module ID3*/
+			<0x0>, /* NUM4 interrupt to CPU*/
+			<0x0>, /* NUM4 access type*/
+			<0x0>; /* NUM4 mode*/
+		mt_5 = <0x0>,  /* NUM5 Enable memory trash detection */
+			<0x0>, /* NUM5 start address*/
+			<0x0>, /* NUM5 end address*/
+			<0x0>, /* NUM5 module ID0*/
+			<0x0>, /* NUM5 module ID1*/
+			<0x0>, /* NUM5 module ID2*/
+			<0x0>, /* NUM5 module ID3*/
+			<0x0>, /* NUM5 interrupt to CPU*/
+			<0x0>, /* NUM5 access type*/
+			<0x0>; /* NUM5 mode*/
+		mt_6 = <0x0>,  /* NUM6 Enable memory trash detection */
+			<0x0>, /* NUM6 start address*/
+			<0x0>, /* NUM6 end address*/
+			<0x0>, /* NUM6 module ID0*/
+			<0x0>, /* NUM6 module ID1*/
+			<0x0>, /* NUM6 module ID2*/
+			<0x0>, /* NUM6 module ID3*/
+			<0x0>, /* NUM6 interrupt to CPU*/
+			<0x0>, /* NUM6 access type*/
+			<0x0>; /* NUM6 mode*/
+		mt_7 = <0x0>,  /* NUM7 Enable memory trash detection */
+			<0x0>, /* NUM7 start address*/
+			<0x0>, /* NUM7 end address*/
+			<0x0>, /* NUM7 module ID0*/
+			<0x0>, /* NUM7 module ID1*/
+			<0x0>, /* NUM7 module ID2*/
+			<0x0>, /* NUM7 module ID3*/
+			<0x0>, /* NUM7 interrupt to CPU*/
+			<0x0>, /* NUM7 access type*/
+			<0x0>; /* NUM7 mode*/
+		status = "okay";
+	};
diff --git a/Documentation/devicetree/bindings/soc/realtek/demod.txt b/Documentation/devicetree/bindings/soc/realtek/demod.txt
new file mode 100644
index 00000000..be0e660
--- /dev/null
+++ b/Documentation/devicetree/bindings/soc/realtek/demod.txt
@@ -0,0 +1,39 @@
+Realtek Demod DT-binding
+========================
+
+* required properties:
+
+- compatible: shall contain "realtek,demod".
+
+- reg: shall contain register address/size of demod.
+
+- clocks / clock-names: shall contain 2 clocks:
+	"pll" for demod pll,
+	"cablerx" for clk_en of demod.
+
+  See also Documentation/devicetree/bindings/clock/clock-bindings.txt
+
+- resets: shall contain a reset control of demod.
+
+  See also Documentation/devicetree/bindings/pinctrl/reset/reset.txt
+
+* optional properties:
+
+- pinctrl-names / pinctrl-0: shall contain a pinctrl list of demod.
+
+  See also Documentation/devicetree/bindings/pinctrl/pinctrl-bindings.txt
+
+Example:
+
+	demod@9801E000 {
+		compatible = "realtek,demod";
+		reg = <0x0 0x9801E000 0x0 0x1000>;
+		clocks = <&clk_en_2 CLK_EN_CABLERX>, <&cc CC_PLL_DIF>;
+		clock-names = "cablerx", "pll";
+		resets = <&rst3 RSTN_CABLERX>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&demod_pins>;
+		status = "okay";
+	};
+
+
diff --git a/Documentation/devicetree/bindings/soc/realtek/hse.txt b/Documentation/devicetree/bindings/soc/realtek/hse.txt
new file mode 100644
index 00000000..255e5c8
--- /dev/null
+++ b/Documentation/devicetree/bindings/soc/realtek/hse.txt
@@ -0,0 +1,18 @@
+Realtek HSE DT-binding
+======================
+
+* required properties:
+
+- compatible: shall contain "realtek,highspeed-streaming-engine".
+
+- reg: shall contain register address/size of demod.
+
+- clocks: shall a clk phandle of hse.
+
+See also Documentation/devicetree/bindings/clock/clock-bindings.txt
+
+- resets: shall contain a reset control phandle of hse.
+
+See also Documentation/devicetree/bindings/pinctrl/reset/reset.txt
+
+
diff --git a/Documentation/devicetree/bindings/soc/realtek/mmio.txt b/Documentation/devicetree/bindings/soc/realtek/mmio.txt
new file mode 100644
index 00000000..1bd88a8
--- /dev/null
+++ b/Documentation/devicetree/bindings/soc/realtek/mmio.txt
@@ -0,0 +1,20 @@
+Realtek MMIO db-bindings
+========================
+
+Required properties :
+- compatible : shall contain only the following:
+	"realtek,mmio"
+
+- reg : shall contain the mmio address
+
+Optional properties :
+- realtek,sb2-lock : a phandle to sb2 sem, if not configured, only spinlock
+	is used.
+
+Exmaple:
+	crt_mmio: mmio@98000000 {
+		compatible = "realtek,mmio";
+		reg = <0x98000000 0x600>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
diff --git a/Documentation/devicetree/bindings/soc/realtek/perfcnt.txt b/Documentation/devicetree/bindings/soc/realtek/perfcnt.txt
new file mode 100644
index 00000000..2316e66
--- /dev/null
+++ b/Documentation/devicetree/bindings/soc/realtek/perfcnt.txt
@@ -0,0 +1,20 @@
+Realtek PerfCnt(Performance Counter) DT-binding
+===============================================
+
+consumer
+--------
+
+* perfcnts: phandles of provides
+
+* perfcnt-names: ids of phandles
+
+usage:
+	pc: pc {
+	
+	};
+
+
+	consumer {
+		perfcnts = <&pc>;
+		perfcnt-names = "pc";
+	};
diff --git a/Documentation/devicetree/bindings/soc/realtek/power.txt b/Documentation/devicetree/bindings/soc/realtek/power.txt
new file mode 100644
index 00000000..97e483b
--- /dev/null
+++ b/Documentation/devicetree/bindings/soc/realtek/power.txt
@@ -0,0 +1,24 @@
+Realtek Power Control DT-bindings
+=================================
+
+Power Controller
+----------------
+
+* Required properities:
+
+- compatible : shall contain the followings :
+	"realtek,rtd129x-crt-power",
+	"realtek,rtd139x-power-controller",
+	"realtek,rtd16xx-power-controller",
+	"realtek,rtd13xx-power-controller"
+
+- reg : shall contain the base address of io memory. 
+
+* Optional properities:
+
+- #power-domain-cells : shall contain unsigned int 1, required if the
+			power-controller is a power domain provider.
+
+- #powerctrl-cells : shall contain unsigned int 1, required if
+		     power-controller is a power control provider.
+
diff --git a/Documentation/devicetree/bindings/soc/realtek/r2rdsc.txt b/Documentation/devicetree/bindings/soc/realtek/r2rdsc.txt
new file mode 100644
index 00000000..f932072
--- /dev/null
+++ b/Documentation/devicetree/bindings/soc/realtek/r2rdsc.txt
@@ -0,0 +1,32 @@
+Realtek R2RDSC DT-binding
+=========================
+
+* required properties:
+
+- compatible: shall contain "realtek,r2rdsc".
+
+- reg: shall contain register address/size of r2rdsc.
+
+- clocks / clock-names: shall contain 2 clocks:
+	"r2rdsc" for clk_en of r2rdsc.
+
+  See also Documentation/devicetree/bindings/clock/clock-bindings.txt
+
+- resets: shall contain 2 reset controls:
+	"r2rdsc" for soft-reset of r2rdsc.
+
+  See also Documentation/devicetree/bindings/pinctrl/reset/reset.txt
+
+
+Example:
+
+r2rdsc@9800b800 {
+	compatible = "realtek,r2rdsc";
+	reg = <0x0 0x9800b000 0x0 0x1000>;
+	clocks = <&clk_en_4 CLK_EN_R2RDSC>;
+	clock-names = "r2rdsc";
+	resets = <&mux_rst0 RSTN_MUX_R2RDSC>;
+	reset-names = "r2rdsc";
+	status = "okay";
+};
+
diff --git a/Documentation/devicetree/bindings/soc/realtek/sb2-sem.txt b/Documentation/devicetree/bindings/soc/realtek/sb2-sem.txt
new file mode 100644
index 00000000..9a92373
--- /dev/null
+++ b/Documentation/devicetree/bindings/soc/realtek/sb2-sem.txt
@@ -0,0 +1,29 @@
+Reaktek SB2 Semaphore
+=====================
+
+Required properties:
+
+- compatible :
+        "realtek,sb2-sem", is required for all sb2 semaphore node, and
+        "realtek,sb2-sem-dev" should be contained if a devfs should be
+		created for the semaphore.
+
+- reg : hall contain he semaphore address
+
+Alias:
+	hwsem
+
+Example:
+	alias {
+		hwsem1 = &sb2_lock1;
+	};
+
+	sb2_lock0: sb2-lock@9801A000 {
+		compatible = "realtek,sb2-sem";
+		reg = <0x9801A000 0x4>;
+	};
+
+	sb2_lock1: sb2-lock@9801A620 {
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+		reg = <0x9801A620 0x4>;
+	};
diff --git a/Documentation/devicetree/bindings/soc/realtek/tp.txt b/Documentation/devicetree/bindings/soc/realtek/tp.txt
new file mode 100644
index 00000000..57e302b
--- /dev/null
+++ b/Documentation/devicetree/bindings/soc/realtek/tp.txt
@@ -0,0 +1,35 @@
+Realtek TP DT-binding
+========================
+
+* required properties:
+
+- compatible: shall contain "realtek,tp".
+
+- reg: shall contain 2 register address/size of tp and tpb.
+
+- clocks / clock-names: shall contain 2 clocks:
+	"tp" for clk_en of tp,
+	"tpb" for clk_en of tpb.
+
+  See also Documentation/devicetree/bindings/clock/clock-bindings.txt
+
+- resets: shall contain 2 reset controls:
+	"tp" for soft-reset of tp,
+	"tpb" for soft-reset of tpb.
+
+  See also Documentation/devicetree/bindings/pinctrl/reset/reset.txt
+
+
+Example:
+
+tp@98014000 {
+	compatible = "realtek,tp";
+	reg = <0x0 0x98014000 0x0 0x1000>,
+	<0x0 0x98039000 0x0 0x1000>;
+	clocks = <&clk_en_2 CLK_EN_TP>, <&clk_en_2 CLK_EN_TPB>;
+	clock-names = "tp", "tpb";
+	resets = <&mux_rst0 RSTN_MUX_TP>, <&mux_rst0 RSTN_MUX_TPB>;
+	reset-names = "tp", "tpb";
+	status = "okay";
+};
+
diff --git a/Documentation/devicetree/bindings/soc/realtek/uio_devices.txt b/Documentation/devicetree/bindings/soc/realtek/uio_devices.txt
new file mode 100644
index 00000000..0d7b711
--- /dev/null
+++ b/Documentation/devicetree/bindings/soc/realtek/uio_devices.txt
@@ -0,0 +1,32 @@
+Realtek UIO devices dt-bindings
+===============================
+
+Required properties :
+
+* reg : shall contain to address for a uio device
+
+* compatible : shall contain the followings :
+	"realtek,md" for MD,
+	"realtek,se" for SE,
+	"realtek,hse" for HSE,
+	"realtek,uio" for Generic Uio Device,
+
+
+Optional properties :
+
+* clocks : shall contain the relative clock(s).
+
+* resets : shall contain the relative reset(s).
+
+* interrupts : shall contain the relative interrupt(s), which only supported
+	by SE, MD, HSE.
+
+Example:
+
+	tp@98014000 {
+		reg = <0x98014000 0x1000>;
+		compatible = "realtek,uio";
+		clocks = <&clk_en_1 CLK_EN_TP>;
+		resets = <&rst1 RSTN_TP>;
+		status = "okay";
+	};
diff --git a/Documentation/devicetree/bindings/sound/realtek,audio-notifier.txt b/Documentation/devicetree/bindings/sound/realtek,audio-notifier.txt
new file mode 100644
index 00000000..9dcf28ba
--- /dev/null
+++ b/Documentation/devicetree/bindings/sound/realtek,audio-notifier.txt
@@ -0,0 +1,102 @@
+Realtek Audio Notifier DT-bindings
+----------------------------------
+
+1 Common Properties
+
+Required properties:
+
+- compatible : shall contain 
+
+	for an audio-in device:  "realtek,audio-in" with one of
+
+		"alc5279", "wm8782", "adc" for an adc device, 
+		"analog-in" for an analog-in device,
+		"adc-amic" for an adc-amic device,
+
+		if none, the audio-in device will be configured ad an adc device.
+
+	"realtek,audio-out", for an audio-out device.
+
+1.1 AI device
+
+Required properties:
+
+Optional properties:
+
+- ai,type : shall contain "i2s" for a i2s deivce;
+
+- ai,i2s-pin-shared: an empty property, indicates the i2s device is pin-shared.
+
+- ai,i2s-master: an empty property, indicates the i2s device is a master-device.
+
+1.1.1 Example 1:
+
+	wm8782 {
+		compatible = "realtek,audio-in", "wm8782";
+		status = "okay";
+	};
+
+1.1.2 Example 2:
+
+	i2s {
+		compatible = "realtek,audio-in", "adc";
+		status = "okay";
+
+		ai,type = "i2s";
+		ai,i2s-pin-shared;
+		ai,i2s-master;
+	};
+
+1.2 AO device
+
+Please add subnode(s) for each AO device.
+
+1.2.1 Properties for a Subnode
+
+Required properties:
+
+- compatible : shall contain one of the followings:
+	"dac",
+	"spdif",
+	"i2s",
+	"hdmi",
+	"global".
+
+Optional properties:
+
+- channel: only works when compatible is "i2s", shall contains a unsigned int,
+	8 for 8 channels,
+	others for 2 channels.
+
+	default value is 2.
+
+- slave-mode: only works when compatible is "i2s", a empty property, if this
+	property exists, configure ao/i2s to slave mode. otherwise master mode.
+
+1.2.2 Example :
+
+	aodev {
+		compatible = "realtek,audio-out";
+		dac {
+			compatible = "dac"
+			status = "okay";
+		};
+		spdif {
+			compatible = "spdif"
+			status = "okay";
+		};
+		i2s {
+			compatible = "i2s"
+			status = "okay";
+		};
+		hdmi {
+			compatible = "hdmi"
+			status = "okay";
+		};
+		global {
+			compatible = "global"
+			status = "okay";
+		};
+	};
+
+
diff --git a/Documentation/devicetree/bindings/thermal/realtek-thermal.txt b/Documentation/devicetree/bindings/thermal/realtek-thermal.txt
new file mode 100644
index 00000000..cbd8c44
--- /dev/null
+++ b/Documentation/devicetree/bindings/thermal/realtek-thermal.txt
@@ -0,0 +1,30 @@
+Realtek Thermal Sensor 
+======================
+
+* Sensor node
+-------------
+Required properties :
+- compatible : shall contain one of the following :
+	"realtek,rtd119x-thermal-sensor",
+	"realtek,rtd129x-thermal-sensor",
+	"realtek,rtd139x-thermal-sensor",
+	"realtek,rtd16xx-thermal-sensor",
+	"realtek,rtd13xx-thermal-sensor".
+
+- #thermal-sensor-cells : shall contain 0.
+
+Optional properties:
+- eoh-restore-ms: shall contain a interger, lock-freq time in ms for eoh,
+	only vaild if eoh configured.
+
+See also 'Documentation/devicetree/bindings/thermal/thermal.txt'
+
+Exmaple :
+	cpu-tsensor {
+		tible = "realtek,rtd129x-thermal-sensor";
+		reg = <0x9801D150 0x1C>;
+		#thermal-sensor-cells = <0>;
+		
+		status = "okay";
+	};
+
diff --git a/Documentation/devicetree/bindings/vendor-prefixes.txt b/Documentation/devicetree/bindings/vendor-prefixes.txt
index bceffff..d0526e0 100644
--- a/Documentation/devicetree/bindings/vendor-prefixes.txt
+++ b/Documentation/devicetree/bindings/vendor-prefixes.txt
@@ -156,6 +156,7 @@ lacie	LaCie
 lantiq	Lantiq Semiconductor
 lenovo	Lenovo Group Ltd.
 lg	LG Corporation
+linaro	Linaro Limited
 linux	Linux-specific binding
 lltc	Linear Technology Corporation
 lsi	LSI Corp. (LSI Logic)
diff --git a/Documentation/devicetree/bindings/watchdog/rtk-wdt.txt b/Documentation/devicetree/bindings/watchdog/rtk-wdt.txt
new file mode 100644
index 00000000..3535d09
--- /dev/null
+++ b/Documentation/devicetree/bindings/watchdog/rtk-wdt.txt
@@ -0,0 +1,13 @@
+Realtek  watchdog timer
+
+Required properties:
+- compatible : should be "realtek,rtk-watchdog"
+- reg : specifies base physical address and size of the registers
+- timeout-sec: contains the watchdog timeout in seconds
+
+Example:
+watchdog@0x10000000 {
+	compatible = "realtek,rtk-watchdog";
+	reg = <0x10000000 0x100>;
+	timeout-sec = <20>;
+};
diff --git a/Documentation/filesystems/f2fs.txt b/Documentation/filesystems/f2fs.txt
index 753dd4f..193a034 100644
--- a/Documentation/filesystems/f2fs.txt
+++ b/Documentation/filesystems/f2fs.txt
@@ -157,6 +157,39 @@ data_flush             Enable data flushing before checkpoint in order to
 mode=%s                Control block allocation mode which supports "adaptive"
                        and "lfs". In "lfs" mode, there should be no random
                        writes towards main area.
+io_bits=%u             Set the bit size of write IO requests. It should be set
+                       with "mode=lfs".
+usrquota               Enable plain user disk quota accounting.
+grpquota               Enable plain group disk quota accounting.
+prjquota               Enable plain project quota accounting.
+usrjquota=<file>       Appoint specified file and type during mount, so that quota
+grpjquota=<file>       information can be properly updated during recovery flow,
+prjjquota=<file>       <quota file>: must be in root directory;
+jqfmt=<quota type>     <quota type>: [vfsold,vfsv0,vfsv1].
+offusrjquota           Turn off user journelled quota.
+offgrpjquota           Turn off group journelled quota.
+offprjjquota           Turn off project journelled quota.
+quota                  Enable plain user disk quota accounting.
+noquota                Disable all plain disk quota option.
+whint_mode=%s          Control which write hints are passed down to block
+                       layer. This supports "off", "user-based", and
+                       "fs-based".  In "off" mode (default), f2fs does not pass
+                       down hints. In "user-based" mode, f2fs tries to pass
+                       down hints given by users. And in "fs-based" mode, f2fs
+                       passes down hints with its policy.
+alloc_mode=%s          Adjust block allocation policy, which supports "reuse"
+                       and "default".
+fsync_mode=%s          Control the policy of fsync. Currently supports "posix",
+                       "strict", and "nobarrier". In "posix" mode, which is
+                       default, fsync will follow POSIX semantics and does a
+                       light operation to improve the filesystem performance.
+                       In "strict" mode, fsync will be heavy and behaves in line
+                       with xfs, ext4 and btrfs, where xfstest generic/342 will
+                       pass, but the performance will regress. "nobarrier" is
+                       based on "posix", but doesn't issue flush command for
+                       non-atomic files likewise "nobarrier" mount option.
+test_dummy_encryption  Enable dummy encryption, which provides a fake fscrypt
+                       context. The fake fscrypt context is used by xfstests.
 
 ================================================================================
 DEBUGFS ENTRIES
@@ -202,6 +235,15 @@ Files in /sys/fs/f2fs/<devname>
                               gc_idle = 1 will select the Cost Benefit approach
                               & setting gc_idle = 2 will select the greedy approach.
 
+ gc_urgent                    This parameter controls triggering background GCs
+                              urgently or not. Setting gc_urgent = 0 [default]
+                              makes back to default behavior, while if it is set
+                              to 1, background thread starts to do GC by given
+                              gc_urgent_sleep_time interval.
+
+ gc_urgent_sleep_time         This parameter controls sleep time for gc_urgent.
+                              500 ms is set by default. See above gc_urgent.
+
  reclaim_segments             This parameter controls the number of prefree
                               segments to be reclaimed. If the number of prefree
 			      segments is larger than the number of segments
diff --git a/Documentation/filesystems/fscrypt.rst b/Documentation/filesystems/fscrypt.rst
new file mode 100644
index 00000000..48b424d
--- /dev/null
+++ b/Documentation/filesystems/fscrypt.rst
@@ -0,0 +1,626 @@
+=====================================
+Filesystem-level encryption (fscrypt)
+=====================================
+
+Introduction
+============
+
+fscrypt is a library which filesystems can hook into to support
+transparent encryption of files and directories.
+
+Note: "fscrypt" in this document refers to the kernel-level portion,
+implemented in ``fs/crypto/``, as opposed to the userspace tool
+`fscrypt <https://github.com/google/fscrypt>`_.  This document only
+covers the kernel-level portion.  For command-line examples of how to
+use encryption, see the documentation for the userspace tool `fscrypt
+<https://github.com/google/fscrypt>`_.  Also, it is recommended to use
+the fscrypt userspace tool, or other existing userspace tools such as
+`fscryptctl <https://github.com/google/fscryptctl>`_ or `Android's key
+management system
+<https://source.android.com/security/encryption/file-based>`_, over
+using the kernel's API directly.  Using existing tools reduces the
+chance of introducing your own security bugs.  (Nevertheless, for
+completeness this documentation covers the kernel's API anyway.)
+
+Unlike dm-crypt, fscrypt operates at the filesystem level rather than
+at the block device level.  This allows it to encrypt different files
+with different keys and to have unencrypted files on the same
+filesystem.  This is useful for multi-user systems where each user's
+data-at-rest needs to be cryptographically isolated from the others.
+However, except for filenames, fscrypt does not encrypt filesystem
+metadata.
+
+Unlike eCryptfs, which is a stacked filesystem, fscrypt is integrated
+directly into supported filesystems --- currently ext4, F2FS, and
+UBIFS.  This allows encrypted files to be read and written without
+caching both the decrypted and encrypted pages in the pagecache,
+thereby nearly halving the memory used and bringing it in line with
+unencrypted files.  Similarly, half as many dentries and inodes are
+needed.  eCryptfs also limits encrypted filenames to 143 bytes,
+causing application compatibility issues; fscrypt allows the full 255
+bytes (NAME_MAX).  Finally, unlike eCryptfs, the fscrypt API can be
+used by unprivileged users, with no need to mount anything.
+
+fscrypt does not support encrypting files in-place.  Instead, it
+supports marking an empty directory as encrypted.  Then, after
+userspace provides the key, all regular files, directories, and
+symbolic links created in that directory tree are transparently
+encrypted.
+
+Threat model
+============
+
+Offline attacks
+---------------
+
+Provided that userspace chooses a strong encryption key, fscrypt
+protects the confidentiality of file contents and filenames in the
+event of a single point-in-time permanent offline compromise of the
+block device content.  fscrypt does not protect the confidentiality of
+non-filename metadata, e.g. file sizes, file permissions, file
+timestamps, and extended attributes.  Also, the existence and location
+of holes (unallocated blocks which logically contain all zeroes) in
+files is not protected.
+
+fscrypt is not guaranteed to protect confidentiality or authenticity
+if an attacker is able to manipulate the filesystem offline prior to
+an authorized user later accessing the filesystem.
+
+Online attacks
+--------------
+
+fscrypt (and storage encryption in general) can only provide limited
+protection, if any at all, against online attacks.  In detail:
+
+fscrypt is only resistant to side-channel attacks, such as timing or
+electromagnetic attacks, to the extent that the underlying Linux
+Cryptographic API algorithms are.  If a vulnerable algorithm is used,
+such as a table-based implementation of AES, it may be possible for an
+attacker to mount a side channel attack against the online system.
+Side channel attacks may also be mounted against applications
+consuming decrypted data.
+
+After an encryption key has been provided, fscrypt is not designed to
+hide the plaintext file contents or filenames from other users on the
+same system, regardless of the visibility of the keyring key.
+Instead, existing access control mechanisms such as file mode bits,
+POSIX ACLs, LSMs, or mount namespaces should be used for this purpose.
+Also note that as long as the encryption keys are *anywhere* in
+memory, an online attacker can necessarily compromise them by mounting
+a physical attack or by exploiting any kernel security vulnerability
+which provides an arbitrary memory read primitive.
+
+While it is ostensibly possible to "evict" keys from the system,
+recently accessed encrypted files will remain accessible at least
+until the filesystem is unmounted or the VFS caches are dropped, e.g.
+using ``echo 2 > /proc/sys/vm/drop_caches``.  Even after that, if the
+RAM is compromised before being powered off, it will likely still be
+possible to recover portions of the plaintext file contents, if not
+some of the encryption keys as well.  (Since Linux v4.12, all
+in-kernel keys related to fscrypt are sanitized before being freed.
+However, userspace would need to do its part as well.)
+
+Currently, fscrypt does not prevent a user from maliciously providing
+an incorrect key for another user's existing encrypted files.  A
+protection against this is planned.
+
+Key hierarchy
+=============
+
+Master Keys
+-----------
+
+Each encrypted directory tree is protected by a *master key*.  Master
+keys can be up to 64 bytes long, and must be at least as long as the
+greater of the key length needed by the contents and filenames
+encryption modes being used.  For example, if AES-256-XTS is used for
+contents encryption, the master key must be 64 bytes (512 bits).  Note
+that the XTS mode is defined to require a key twice as long as that
+required by the underlying block cipher.
+
+To "unlock" an encrypted directory tree, userspace must provide the
+appropriate master key.  There can be any number of master keys, each
+of which protects any number of directory trees on any number of
+filesystems.
+
+Userspace should generate master keys either using a cryptographically
+secure random number generator, or by using a KDF (Key Derivation
+Function).  Note that whenever a KDF is used to "stretch" a
+lower-entropy secret such as a passphrase, it is critical that a KDF
+designed for this purpose be used, such as scrypt, PBKDF2, or Argon2.
+
+Per-file keys
+-------------
+
+Master keys are not used to encrypt file contents or names directly.
+Instead, a unique key is derived for each encrypted file, including
+each regular file, directory, and symbolic link.  This has several
+advantages:
+
+- In cryptosystems, the same key material should never be used for
+  different purposes.  Using the master key as both an XTS key for
+  contents encryption and as a CTS-CBC key for filenames encryption
+  would violate this rule.
+- Per-file keys simplify the choice of IVs (Initialization Vectors)
+  for contents encryption.  Without per-file keys, to ensure IV
+  uniqueness both the inode and logical block number would need to be
+  encoded in the IVs.  This would make it impossible to renumber
+  inodes, which e.g. ``resize2fs`` can do when resizing an ext4
+  filesystem.  With per-file keys, it is sufficient to encode just the
+  logical block number in the IVs.
+- Per-file keys strengthen the encryption of filenames, where IVs are
+  reused out of necessity.  With a unique key per directory, IV reuse
+  is limited to within a single directory.
+- Per-file keys allow individual files to be securely erased simply by
+  securely erasing their keys.  (Not yet implemented.)
+
+A KDF (Key Derivation Function) is used to derive per-file keys from
+the master key.  This is done instead of wrapping a randomly-generated
+key for each file because it reduces the size of the encryption xattr,
+which for some filesystems makes the xattr more likely to fit in-line
+in the filesystem's inode table.  With a KDF, only a 16-byte nonce is
+required --- long enough to make key reuse extremely unlikely.  A
+wrapped key, on the other hand, would need to be up to 64 bytes ---
+the length of an AES-256-XTS key.  Furthermore, currently there is no
+requirement to support unlocking a file with multiple alternative
+master keys or to support rotating master keys.  Instead, the master
+keys may be wrapped in userspace, e.g. as done by the `fscrypt
+<https://github.com/google/fscrypt>`_ tool.
+
+The current KDF encrypts the master key using the 16-byte nonce as an
+AES-128-ECB key.  The output is used as the derived key.  If the
+output is longer than needed, then it is truncated to the needed
+length.  Truncation is the norm for directories and symlinks, since
+those use the CTS-CBC encryption mode which requires a key half as
+long as that required by the XTS encryption mode.
+
+Note: this KDF meets the primary security requirement, which is to
+produce unique derived keys that preserve the entropy of the master
+key, assuming that the master key is already a good pseudorandom key.
+However, it is nonstandard and has some problems such as being
+reversible, so it is generally considered to be a mistake!  It may be
+replaced with HKDF or another more standard KDF in the future.
+
+Encryption modes and usage
+==========================
+
+fscrypt allows one encryption mode to be specified for file contents
+and one encryption mode to be specified for filenames.  Different
+directory trees are permitted to use different encryption modes.
+Currently, the following pairs of encryption modes are supported:
+
+- AES-256-XTS for contents and AES-256-CTS-CBC for filenames
+- AES-128-CBC for contents and AES-128-CTS-CBC for filenames
+- Speck128/256-XTS for contents and Speck128/256-CTS-CBC for filenames
+
+It is strongly recommended to use AES-256-XTS for contents encryption.
+AES-128-CBC was added only for low-powered embedded devices with
+crypto accelerators such as CAAM or CESA that do not support XTS.
+
+Similarly, Speck128/256 support was only added for older or low-end
+CPUs which cannot do AES fast enough -- especially ARM CPUs which have
+NEON instructions but not the Cryptography Extensions -- and for which
+it would not otherwise be feasible to use encryption at all.  It is
+not recommended to use Speck on CPUs that have AES instructions.
+Speck support is only available if it has been enabled in the crypto
+API via CONFIG_CRYPTO_SPECK.  Also, on ARM platforms, to get
+acceptable performance CONFIG_CRYPTO_SPECK_NEON must be enabled.
+
+New encryption modes can be added relatively easily, without changes
+to individual filesystems.  However, authenticated encryption (AE)
+modes are not currently supported because of the difficulty of dealing
+with ciphertext expansion.
+
+For file contents, each filesystem block is encrypted independently.
+Currently, only the case where the filesystem block size is equal to
+the system's page size (usually 4096 bytes) is supported.  With the
+XTS mode of operation (recommended), the logical block number within
+the file is used as the IV.  With the CBC mode of operation (not
+recommended), ESSIV is used; specifically, the IV for CBC is the
+logical block number encrypted with AES-256, where the AES-256 key is
+the SHA-256 hash of the inode's data encryption key.
+
+For filenames, the full filename is encrypted at once.  Because of the
+requirements to retain support for efficient directory lookups and
+filenames of up to 255 bytes, a constant initialization vector (IV) is
+used.  However, each encrypted directory uses a unique key, which
+limits IV reuse to within a single directory.  Note that IV reuse in
+the context of CTS-CBC encryption means that when the original
+filenames share a common prefix at least as long as the cipher block
+size (16 bytes for AES), the corresponding encrypted filenames will
+also share a common prefix.  This is undesirable; it may be fixed in
+the future by switching to an encryption mode that is a strong
+pseudorandom permutation on arbitrary-length messages, e.g. the HEH
+(Hash-Encrypt-Hash) mode.
+
+Since filenames are encrypted with the CTS-CBC mode of operation, the
+plaintext and ciphertext filenames need not be multiples of the AES
+block size, i.e. 16 bytes.  However, the minimum size that can be
+encrypted is 16 bytes, so shorter filenames are NUL-padded to 16 bytes
+before being encrypted.  In addition, to reduce leakage of filename
+lengths via their ciphertexts, all filenames are NUL-padded to the
+next 4, 8, 16, or 32-byte boundary (configurable).  32 is recommended
+since this provides the best confidentiality, at the cost of making
+directory entries consume slightly more space.  Note that since NUL
+(``\0``) is not otherwise a valid character in filenames, the padding
+will never produce duplicate plaintexts.
+
+Symbolic link targets are considered a type of filename and are
+encrypted in the same way as filenames in directory entries.  Each
+symlink also uses a unique key; hence, the hardcoded IV is not a
+problem for symlinks.
+
+User API
+========
+
+Setting an encryption policy
+----------------------------
+
+The FS_IOC_SET_ENCRYPTION_POLICY ioctl sets an encryption policy on an
+empty directory or verifies that a directory or regular file already
+has the specified encryption policy.  It takes in a pointer to a
+:c:type:`struct fscrypt_policy`, defined as follows::
+
+    #define FS_KEY_DESCRIPTOR_SIZE  8
+
+    struct fscrypt_policy {
+            __u8 version;
+            __u8 contents_encryption_mode;
+            __u8 filenames_encryption_mode;
+            __u8 flags;
+            __u8 master_key_descriptor[FS_KEY_DESCRIPTOR_SIZE];
+    };
+
+This structure must be initialized as follows:
+
+- ``version`` must be 0.
+
+- ``contents_encryption_mode`` and ``filenames_encryption_mode`` must
+  be set to constants from ``<linux/fs.h>`` which identify the
+  encryption modes to use.  If unsure, use
+  FS_ENCRYPTION_MODE_AES_256_XTS (1) for ``contents_encryption_mode``
+  and FS_ENCRYPTION_MODE_AES_256_CTS (4) for
+  ``filenames_encryption_mode``.
+
+- ``flags`` must be set to a value from ``<linux/fs.h>`` which
+  identifies the amount of NUL-padding to use when encrypting
+  filenames.  If unsure, use FS_POLICY_FLAGS_PAD_32 (0x3).
+
+- ``master_key_descriptor`` specifies how to find the master key in
+  the keyring; see `Adding keys`_.  It is up to userspace to choose a
+  unique ``master_key_descriptor`` for each master key.  The e4crypt
+  and fscrypt tools use the first 8 bytes of
+  ``SHA-512(SHA-512(master_key))``, but this particular scheme is not
+  required.  Also, the master key need not be in the keyring yet when
+  FS_IOC_SET_ENCRYPTION_POLICY is executed.  However, it must be added
+  before any files can be created in the encrypted directory.
+
+If the file is not yet encrypted, then FS_IOC_SET_ENCRYPTION_POLICY
+verifies that the file is an empty directory.  If so, the specified
+encryption policy is assigned to the directory, turning it into an
+encrypted directory.  After that, and after providing the
+corresponding master key as described in `Adding keys`_, all regular
+files, directories (recursively), and symlinks created in the
+directory will be encrypted, inheriting the same encryption policy.
+The filenames in the directory's entries will be encrypted as well.
+
+Alternatively, if the file is already encrypted, then
+FS_IOC_SET_ENCRYPTION_POLICY validates that the specified encryption
+policy exactly matches the actual one.  If they match, then the ioctl
+returns 0.  Otherwise, it fails with EEXIST.  This works on both
+regular files and directories, including nonempty directories.
+
+Note that the ext4 filesystem does not allow the root directory to be
+encrypted, even if it is empty.  Users who want to encrypt an entire
+filesystem with one key should consider using dm-crypt instead.
+
+FS_IOC_SET_ENCRYPTION_POLICY can fail with the following errors:
+
+- ``EACCES``: the file is not owned by the process's uid, nor does the
+  process have the CAP_FOWNER capability in a namespace with the file
+  owner's uid mapped
+- ``EEXIST``: the file is already encrypted with an encryption policy
+  different from the one specified
+- ``EINVAL``: an invalid encryption policy was specified (invalid
+  version, mode(s), or flags)
+- ``ENOTDIR``: the file is unencrypted and is a regular file, not a
+  directory
+- ``ENOTEMPTY``: the file is unencrypted and is a nonempty directory
+- ``ENOTTY``: this type of filesystem does not implement encryption
+- ``EOPNOTSUPP``: the kernel was not configured with encryption
+  support for this filesystem, or the filesystem superblock has not
+  had encryption enabled on it.  (For example, to use encryption on an
+  ext4 filesystem, CONFIG_EXT4_ENCRYPTION must be enabled in the
+  kernel config, and the superblock must have had the "encrypt"
+  feature flag enabled using ``tune2fs -O encrypt`` or ``mkfs.ext4 -O
+  encrypt``.)
+- ``EPERM``: this directory may not be encrypted, e.g. because it is
+  the root directory of an ext4 filesystem
+- ``EROFS``: the filesystem is readonly
+
+Getting an encryption policy
+----------------------------
+
+The FS_IOC_GET_ENCRYPTION_POLICY ioctl retrieves the :c:type:`struct
+fscrypt_policy`, if any, for a directory or regular file.  See above
+for the struct definition.  No additional permissions are required
+beyond the ability to open the file.
+
+FS_IOC_GET_ENCRYPTION_POLICY can fail with the following errors:
+
+- ``EINVAL``: the file is encrypted, but it uses an unrecognized
+  encryption context format
+- ``ENODATA``: the file is not encrypted
+- ``ENOTTY``: this type of filesystem does not implement encryption
+- ``EOPNOTSUPP``: the kernel was not configured with encryption
+  support for this filesystem
+
+Note: if you only need to know whether a file is encrypted or not, on
+most filesystems it is also possible to use the FS_IOC_GETFLAGS ioctl
+and check for FS_ENCRYPT_FL, or to use the statx() system call and
+check for STATX_ATTR_ENCRYPTED in stx_attributes.
+
+Getting the per-filesystem salt
+-------------------------------
+
+Some filesystems, such as ext4 and F2FS, also support the deprecated
+ioctl FS_IOC_GET_ENCRYPTION_PWSALT.  This ioctl retrieves a randomly
+generated 16-byte value stored in the filesystem superblock.  This
+value is intended to used as a salt when deriving an encryption key
+from a passphrase or other low-entropy user credential.
+
+FS_IOC_GET_ENCRYPTION_PWSALT is deprecated.  Instead, prefer to
+generate and manage any needed salt(s) in userspace.
+
+Adding keys
+-----------
+
+To provide a master key, userspace must add it to an appropriate
+keyring using the add_key() system call (see:
+``Documentation/security/keys/core.rst``).  The key type must be
+"logon"; keys of this type are kept in kernel memory and cannot be
+read back by userspace.  The key description must be "fscrypt:"
+followed by the 16-character lower case hex representation of the
+``master_key_descriptor`` that was set in the encryption policy.  The
+key payload must conform to the following structure::
+
+    #define FS_MAX_KEY_SIZE 64
+
+    struct fscrypt_key {
+            u32 mode;
+            u8 raw[FS_MAX_KEY_SIZE];
+            u32 size;
+    };
+
+``mode`` is ignored; just set it to 0.  The actual key is provided in
+``raw`` with ``size`` indicating its size in bytes.  That is, the
+bytes ``raw[0..size-1]`` (inclusive) are the actual key.
+
+The key description prefix "fscrypt:" may alternatively be replaced
+with a filesystem-specific prefix such as "ext4:".  However, the
+filesystem-specific prefixes are deprecated and should not be used in
+new programs.
+
+There are several different types of keyrings in which encryption keys
+may be placed, such as a session keyring, a user session keyring, or a
+user keyring.  Each key must be placed in a keyring that is "attached"
+to all processes that might need to access files encrypted with it, in
+the sense that request_key() will find the key.  Generally, if only
+processes belonging to a specific user need to access a given
+encrypted directory and no session keyring has been installed, then
+that directory's key should be placed in that user's user session
+keyring or user keyring.  Otherwise, a session keyring should be
+installed if needed, and the key should be linked into that session
+keyring, or in a keyring linked into that session keyring.
+
+Note: introducing the complex visibility semantics of keyrings here
+was arguably a mistake --- especially given that by design, after any
+process successfully opens an encrypted file (thereby setting up the
+per-file key), possessing the keyring key is not actually required for
+any process to read/write the file until its in-memory inode is
+evicted.  In the future there probably should be a way to provide keys
+directly to the filesystem instead, which would make the intended
+semantics clearer.
+
+Access semantics
+================
+
+With the key
+------------
+
+With the encryption key, encrypted regular files, directories, and
+symlinks behave very similarly to their unencrypted counterparts ---
+after all, the encryption is intended to be transparent.  However,
+astute users may notice some differences in behavior:
+
+- Unencrypted files, or files encrypted with a different encryption
+  policy (i.e. different key, modes, or flags), cannot be renamed or
+  linked into an encrypted directory; see `Encryption policy
+  enforcement`_.  Attempts to do so will fail with EPERM.  However,
+  encrypted files can be renamed within an encrypted directory, or
+  into an unencrypted directory.
+
+- Direct I/O is not supported on encrypted files.  Attempts to use
+  direct I/O on such files will fall back to buffered I/O.
+
+- The fallocate operations FALLOC_FL_COLLAPSE_RANGE,
+  FALLOC_FL_INSERT_RANGE, and FALLOC_FL_ZERO_RANGE are not supported
+  on encrypted files and will fail with EOPNOTSUPP.
+
+- Online defragmentation of encrypted files is not supported.  The
+  EXT4_IOC_MOVE_EXT and F2FS_IOC_MOVE_RANGE ioctls will fail with
+  EOPNOTSUPP.
+
+- The ext4 filesystem does not support data journaling with encrypted
+  regular files.  It will fall back to ordered data mode instead.
+
+- DAX (Direct Access) is not supported on encrypted files.
+
+- The st_size of an encrypted symlink will not necessarily give the
+  length of the symlink target as required by POSIX.  It will actually
+  give the length of the ciphertext, which will be slightly longer
+  than the plaintext due to NUL-padding and an extra 2-byte overhead.
+
+- The maximum length of an encrypted symlink is 2 bytes shorter than
+  the maximum length of an unencrypted symlink.  For example, on an
+  EXT4 filesystem with a 4K block size, unencrypted symlinks can be up
+  to 4095 bytes long, while encrypted symlinks can only be up to 4093
+  bytes long (both lengths excluding the terminating null).
+
+Note that mmap *is* supported.  This is possible because the pagecache
+for an encrypted file contains the plaintext, not the ciphertext.
+
+Without the key
+---------------
+
+Some filesystem operations may be performed on encrypted regular
+files, directories, and symlinks even before their encryption key has
+been provided:
+
+- File metadata may be read, e.g. using stat().
+
+- Directories may be listed, in which case the filenames will be
+  listed in an encoded form derived from their ciphertext.  The
+  current encoding algorithm is described in `Filename hashing and
+  encoding`_.  The algorithm is subject to change, but it is
+  guaranteed that the presented filenames will be no longer than
+  NAME_MAX bytes, will not contain the ``/`` or ``\0`` characters, and
+  will uniquely identify directory entries.
+
+  The ``.`` and ``..`` directory entries are special.  They are always
+  present and are not encrypted or encoded.
+
+- Files may be deleted.  That is, nondirectory files may be deleted
+  with unlink() as usual, and empty directories may be deleted with
+  rmdir() as usual.  Therefore, ``rm`` and ``rm -r`` will work as
+  expected.
+
+- Symlink targets may be read and followed, but they will be presented
+  in encrypted form, similar to filenames in directories.  Hence, they
+  are unlikely to point to anywhere useful.
+
+Without the key, regular files cannot be opened or truncated.
+Attempts to do so will fail with ENOKEY.  This implies that any
+regular file operations that require a file descriptor, such as
+read(), write(), mmap(), fallocate(), and ioctl(), are also forbidden.
+
+Also without the key, files of any type (including directories) cannot
+be created or linked into an encrypted directory, nor can a name in an
+encrypted directory be the source or target of a rename, nor can an
+O_TMPFILE temporary file be created in an encrypted directory.  All
+such operations will fail with ENOKEY.
+
+It is not currently possible to backup and restore encrypted files
+without the encryption key.  This would require special APIs which
+have not yet been implemented.
+
+Encryption policy enforcement
+=============================
+
+After an encryption policy has been set on a directory, all regular
+files, directories, and symbolic links created in that directory
+(recursively) will inherit that encryption policy.  Special files ---
+that is, named pipes, device nodes, and UNIX domain sockets --- will
+not be encrypted.
+
+Except for those special files, it is forbidden to have unencrypted
+files, or files encrypted with a different encryption policy, in an
+encrypted directory tree.  Attempts to link or rename such a file into
+an encrypted directory will fail with EPERM.  This is also enforced
+during ->lookup() to provide limited protection against offline
+attacks that try to disable or downgrade encryption in known locations
+where applications may later write sensitive data.  It is recommended
+that systems implementing a form of "verified boot" take advantage of
+this by validating all top-level encryption policies prior to access.
+
+Implementation details
+======================
+
+Encryption context
+------------------
+
+An encryption policy is represented on-disk by a :c:type:`struct
+fscrypt_context`.  It is up to individual filesystems to decide where
+to store it, but normally it would be stored in a hidden extended
+attribute.  It should *not* be exposed by the xattr-related system
+calls such as getxattr() and setxattr() because of the special
+semantics of the encryption xattr.  (In particular, there would be
+much confusion if an encryption policy were to be added to or removed
+from anything other than an empty directory.)  The struct is defined
+as follows::
+
+    #define FS_KEY_DESCRIPTOR_SIZE  8
+    #define FS_KEY_DERIVATION_NONCE_SIZE 16
+
+    struct fscrypt_context {
+            u8 format;
+            u8 contents_encryption_mode;
+            u8 filenames_encryption_mode;
+            u8 flags;
+            u8 master_key_descriptor[FS_KEY_DESCRIPTOR_SIZE];
+            u8 nonce[FS_KEY_DERIVATION_NONCE_SIZE];
+    };
+
+Note that :c:type:`struct fscrypt_context` contains the same
+information as :c:type:`struct fscrypt_policy` (see `Setting an
+encryption policy`_), except that :c:type:`struct fscrypt_context`
+also contains a nonce.  The nonce is randomly generated by the kernel
+and is used to derive the inode's encryption key as described in
+`Per-file keys`_.
+
+Data path changes
+-----------------
+
+For the read path (->readpage()) of regular files, filesystems can
+read the ciphertext into the page cache and decrypt it in-place.  The
+page lock must be held until decryption has finished, to prevent the
+page from becoming visible to userspace prematurely.
+
+For the write path (->writepage()) of regular files, filesystems
+cannot encrypt data in-place in the page cache, since the cached
+plaintext must be preserved.  Instead, filesystems must encrypt into a
+temporary buffer or "bounce page", then write out the temporary
+buffer.  Some filesystems, such as UBIFS, already use temporary
+buffers regardless of encryption.  Other filesystems, such as ext4 and
+F2FS, have to allocate bounce pages specially for encryption.
+
+Filename hashing and encoding
+-----------------------------
+
+Modern filesystems accelerate directory lookups by using indexed
+directories.  An indexed directory is organized as a tree keyed by
+filename hashes.  When a ->lookup() is requested, the filesystem
+normally hashes the filename being looked up so that it can quickly
+find the corresponding directory entry, if any.
+
+With encryption, lookups must be supported and efficient both with and
+without the encryption key.  Clearly, it would not work to hash the
+plaintext filenames, since the plaintext filenames are unavailable
+without the key.  (Hashing the plaintext filenames would also make it
+impossible for the filesystem's fsck tool to optimize encrypted
+directories.)  Instead, filesystems hash the ciphertext filenames,
+i.e. the bytes actually stored on-disk in the directory entries.  When
+asked to do a ->lookup() with the key, the filesystem just encrypts
+the user-supplied name to get the ciphertext.
+
+Lookups without the key are more complicated.  The raw ciphertext may
+contain the ``\0`` and ``/`` characters, which are illegal in
+filenames.  Therefore, readdir() must base64-encode the ciphertext for
+presentation.  For most filenames, this works fine; on ->lookup(), the
+filesystem just base64-decodes the user-supplied name to get back to
+the raw ciphertext.
+
+However, for very long filenames, base64 encoding would cause the
+filename length to exceed NAME_MAX.  To prevent this, readdir()
+actually presents long filenames in an abbreviated form which encodes
+a strong "hash" of the ciphertext filename, along with the optional
+filesystem-specific hash(es) needed for directory lookups.  This
+allows the filesystem to still, with a high degree of confidence, map
+the filename given in ->lookup() back to a particular directory entry
+that was previously listed by readdir().  See :c:type:`struct
+fscrypt_digested_name` in the source for more details.
+
+Note that the precise way that filenames are presented to userspace
+without the key is subject to change in the future.  It is only meant
+as a way to temporarily present valid filenames so that commands like
+``rm -r`` work as expected on encrypted directories.
diff --git a/Documentation/filesystems/proc.txt b/Documentation/filesystems/proc.txt
index 74329fd..6e027ae 100644
--- a/Documentation/filesystems/proc.txt
+++ b/Documentation/filesystems/proc.txt
@@ -392,6 +392,8 @@ is not associated with a file:
  [stack]                  = the stack of the main process
  [vdso]                   = the "virtual dynamic shared object",
                             the kernel system call handler
+ [anon:<name>]            = an anonymous mapping that has been
+                            named by userspace
 
  or if empty, the mapping is anonymous.
 
@@ -419,6 +421,7 @@ KernelPageSize:        4 kB
 MMUPageSize:           4 kB
 Locked:                0 kB
 VmFlags: rd ex mr mw me dw
+Name:           name from userspace
 
 the first of these lines shows the same information as is displayed for the
 mapping in /proc/PID/maps.  The remaining lines show the size of the mapping
@@ -486,6 +489,9 @@ Note that there is no guarantee that every flag and associated mnemonic will
 be present in all further kernel releases. Things get changed, the flags may
 be vanished or the reverse -- new added.
 
+The "Name" field will only be present on a mapping that has been named by
+userspace, and will show the name passed in by userspace.
+
 This file is only present if the CONFIG_MMU kernel configuration option is
 enabled.
 
diff --git a/Documentation/gpu/drm-kms.rst b/Documentation/gpu/drm-kms.rst
index 53b872c..db86cda 100644
--- a/Documentation/gpu/drm-kms.rst
+++ b/Documentation/gpu/drm-kms.rst
@@ -308,6 +308,12 @@ Color Management Properties
 .. kernel-doc:: drivers/gpu/drm/drm_color_mgmt.c
    :export:
 
+Explicit Fencing Properties
+---------------------------
+
+.. kernel-doc:: drivers/gpu/drm/drm_atomic.c
+   :doc: explicit fencing properties
+
 Existing KMS Properties
 -----------------------
 
diff --git a/Documentation/ioctl/ioctl-number.txt b/Documentation/ioctl/ioctl-number.txt
index 81c7f2b..efb38da 100644
--- a/Documentation/ioctl/ioctl-number.txt
+++ b/Documentation/ioctl/ioctl-number.txt
@@ -308,6 +308,7 @@ Code  Seq#(hex)	Include File		Comments
 0xA3	80-8F	Port ACL		in development:
 					<mailto:tlewis@mindspring.com>
 0xA3	90-9F	linux/dtlk.h
+0xA4	00-1F	uapi/linux/tee.h	Generic TEE subsystem
 0xAA	00-3F	linux/uapi/linux/userfaultfd.h
 0xAB	00-1F	linux/nbd.h
 0xAC	00-1F	linux/raw.h
diff --git a/Documentation/kernel-parameters.txt b/Documentation/kernel-parameters.txt
index a16f87e..541fcd0 100644
--- a/Documentation/kernel-parameters.txt
+++ b/Documentation/kernel-parameters.txt
@@ -87,6 +87,7 @@ parameter is applicable:
 	BLACKFIN Blackfin architecture is enabled.
 	CLK	Common clock infrastructure is enabled.
 	CMA	Contiguous Memory Area support is enabled.
+	DM	Device mapper support is enabled.
 	DRM	Direct Rendering Management support is enabled.
 	DYNAMIC_DEBUG Build in debug messages and enable them at runtime
 	EDD	BIOS Enhanced Disk Drive Services (EDD) is enabled
@@ -1035,6 +1036,11 @@ bytes respectively. Such letter suffixes can also be entirely omitted.
 
 	dis_ucode_ldr	[X86] Disable the microcode loader.
 
+	dm=		[DM] Allows early creation of a device-mapper device.
+			See Documentation/device-mapper/boot.txt.
+
+	dmasound=	[HW,OSS] Sound subsystem buff
+
 	dma_debug=off	If the kernel is compiled with DMA_API_DEBUG support,
 			this option disables the debugging code at boot.
 
@@ -1903,6 +1909,12 @@ bytes respectively. Such letter suffixes can also be entirely omitted.
 			kernel and module base offset ASLR (Address Space
 			Layout Randomization).
 
+	kasan_multi_shot
+			[KNL] Enforce KASAN (Kernel Address Sanitizer) to print
+			report on every invalid memory access. Without this
+			parameter KASAN will print report only for the first
+			invalid access.
+
 	keepinitrd	[HW,ARM]
 
 	kernelcore=	[KNL,X86,IA-64,PPC]
diff --git a/Documentation/networking/ip-sysctl.txt b/Documentation/networking/ip-sysctl.txt
index 3db8c67d..f9154c5 100644
--- a/Documentation/networking/ip-sysctl.txt
+++ b/Documentation/networking/ip-sysctl.txt
@@ -603,6 +603,16 @@ tcp_fastopen - INTEGER
 	Note that that additional client or server features are only
 	effective if the basic support (0x1 and 0x2) are enabled respectively.
 
+tcp_fwmark_accept - BOOLEAN
+	If set, incoming connections to listening sockets that do not have a
+	socket mark will set the mark of the accepting socket to the fwmark of
+	the incoming SYN packet. This will cause all packets on that connection
+	(starting from the first SYNACK) to be sent with that fwmark. The
+	listening socket's mark is unchanged. Listening sockets that already
+	have a fwmark set via setsockopt(SOL_SOCKET, SO_MARK, ...) are
+	unaffected.
+	Default: 0
+
 tcp_syn_retries - INTEGER
 	Number of times initial SYNs for an active TCP connection attempt
 	will be retransmitted. Should not be higher than 127. Default value
@@ -1442,11 +1452,20 @@ accept_ra_pinfo - BOOLEAN
 	Functional default: enabled if accept_ra is enabled.
 			    disabled if accept_ra is disabled.
 
+accept_ra_rt_info_min_plen - INTEGER
+	Minimum prefix length of Route Information in RA.
+
+	Route Information w/ prefix smaller than this variable shall
+	be ignored.
+
+	Functional default: 0 if accept_ra_rtr_pref is enabled.
+			    -1 if accept_ra_rtr_pref is disabled.
+
 accept_ra_rt_info_max_plen - INTEGER
 	Maximum prefix length of Route Information in RA.
 
-	Route Information w/ prefix larger than or equal to this
-	variable shall be ignored.
+	Route Information w/ prefix larger than this variable shall
+	be ignored.
 
 	Functional default: 0 if accept_ra_rtr_pref is enabled.
 			    -1 if accept_ra_rtr_pref is disabled.
diff --git a/Documentation/scheduler/sched-energy.txt b/Documentation/scheduler/sched-energy.txt
new file mode 100644
index 00000000..dab2f90
--- /dev/null
+++ b/Documentation/scheduler/sched-energy.txt
@@ -0,0 +1,362 @@
+Energy cost model for energy-aware scheduling (EXPERIMENTAL)
+
+Introduction
+=============
+
+The basic energy model uses platform energy data stored in sched_group_energy
+data structures attached to the sched_groups in the sched_domain hierarchy. The
+energy cost model offers two functions that can be used to guide scheduling
+decisions:
+
+1.	static unsigned int sched_group_energy(struct energy_env *eenv)
+2.	static int energy_diff(struct energy_env *eenv)
+
+sched_group_energy() estimates the energy consumed by all cpus in a specific
+sched_group including any shared resources owned exclusively by this group of
+cpus. Resources shared with other cpus are excluded (e.g. later level caches).
+
+energy_diff() estimates the total energy impact of a utilization change. That
+is, adding, removing, or migrating utilization (tasks).
+
+Both functions use a struct energy_env to specify the scenario to be evaluated:
+
+	struct energy_env {
+		struct sched_group      *sg_top;
+		struct sched_group      *sg_cap;
+		int                     cap_idx;
+		int                     util_delta;
+		int                     src_cpu;
+		int                     dst_cpu;
+		int                     energy;
+	};
+
+sg_top: sched_group to be evaluated. Not used by energy_diff().
+
+sg_cap: sched_group covering the cpus in the same frequency domain. Set by
+sched_group_energy().
+
+cap_idx: Capacity state to be used for energy calculations. Set by
+find_new_capacity().
+
+util_delta: Amount of utilization to be added, removed, or migrated.
+
+src_cpu: Source cpu from where 'util_delta' utilization is removed. Should be
+-1 if no source (e.g. task wake-up).
+
+dst_cpu: Destination cpu where 'util_delta' utilization is added. Should be -1
+if utilization is removed (e.g. terminating tasks).
+
+energy: Result of sched_group_energy().
+
+The metric used to represent utilization is the actual per-entity running time
+averaged over time using a geometric series. Very similar to the existing
+per-entity load-tracking, but _not_ scaled by task priority and capped by the
+capacity of the cpu. The latter property does mean that utilization may
+underestimate the compute requirements for task on fully/over utilized cpus.
+The greatest potential for energy savings without affecting performance too much
+is scenarios where the system isn't fully utilized. If the system is deemed
+fully utilized load-balancing should be done with task load (includes task
+priority) instead in the interest of fairness and performance.
+
+
+Background and Terminology
+===========================
+
+To make it clear from the start:
+
+energy = [joule] (resource like a battery on powered devices)
+power = energy/time = [joule/second] = [watt]
+
+The goal of energy-aware scheduling is to minimize energy, while still getting
+the job done. That is, we want to maximize:
+
+	performance [inst/s]
+	--------------------
+	    power [W]
+
+which is equivalent to minimizing:
+
+	energy [J]
+	-----------
+	instruction
+
+while still getting 'good' performance. It is essentially an alternative
+optimization objective to the current performance-only objective for the
+scheduler. This alternative considers two objectives: energy-efficiency and
+performance. Hence, there needs to be a user controllable knob to switch the
+objective. Since it is early days, this is currently a sched_feature
+(ENERGY_AWARE).
+
+The idea behind introducing an energy cost model is to allow the scheduler to
+evaluate the implications of its decisions rather than applying energy-saving
+techniques blindly that may only have positive effects on some platforms. At
+the same time, the energy cost model must be as simple as possible to minimize
+the scheduler latency impact.
+
+Platform topology
+------------------
+
+The system topology (cpus, caches, and NUMA information, not peripherals) is
+represented in the scheduler by the sched_domain hierarchy which has
+sched_groups attached at each level that covers one or more cpus (see
+sched-domains.txt for more details). To add energy awareness to the scheduler
+we need to consider power and frequency domains.
+
+Power domain:
+
+A power domain is a part of the system that can be powered on/off
+independently. Power domains are typically organized in a hierarchy where you
+may be able to power down just a cpu or a group of cpus along with any
+associated resources (e.g.  shared caches). Powering up a cpu means that all
+power domains it is a part of in the hierarchy must be powered up. Hence, it is
+more expensive to power up the first cpu that belongs to a higher level power
+domain than powering up additional cpus in the same high level domain. Two
+level power domain hierarchy example:
+
+		Power source
+		         +-------------------------------+----...
+per group PD		 G                               G
+		         |           +----------+        |
+		    +--------+-------| Shared   |  (other groups)
+per-cpu PD	    G        G       | resource |
+		    |        |       +----------+
+		+-------+ +-------+
+		| CPU 0 | | CPU 1 |
+		+-------+ +-------+
+
+Frequency domain:
+
+Frequency domains (P-states) typically cover the same group of cpus as one of
+the power domain levels. That is, there might be several smaller power domains
+sharing the same frequency (P-state) or there might be a power domain spanning
+multiple frequency domains.
+
+From a scheduling point of view there is no need to know the actual frequencies
+[Hz]. All the scheduler cares about is the compute capacity available at the
+current state (P-state) the cpu is in and any other available states. For that
+reason, and to also factor in any cpu micro-architecture differences, compute
+capacity scaling states are called 'capacity states' in this document. For SMP
+systems this is equivalent to P-states. For mixed micro-architecture systems
+(like ARM big.LITTLE) it is P-states scaled according to the micro-architecture
+performance relative to the other cpus in the system.
+
+Energy modelling:
+------------------
+
+Due to the hierarchical nature of the power domains, the most obvious way to
+model energy costs is therefore to associate power and energy costs with
+domains (groups of cpus). Energy costs of shared resources are associated with
+the group of cpus that share the resources, only the cost of powering the
+cpu itself and any private resources (e.g. private L1 caches) is associated
+with the per-cpu groups (lowest level).
+
+For example, for an SMP system with per-cpu power domains and a cluster level
+(group of cpus) power domain we get the overall energy costs to be:
+
+	energy = energy_cluster + n * energy_cpu
+
+where 'n' is the number of cpus powered up and energy_cluster is the cost paid
+as soon as any cpu in the cluster is powered up.
+
+The power and frequency domains can naturally be mapped onto the existing
+sched_domain hierarchy and sched_groups by adding the necessary data to the
+existing data structures.
+
+The energy model considers energy consumption from two contributors (shown in
+the illustration below):
+
+1. Busy energy: Energy consumed while a cpu and the higher level groups that it
+belongs to are busy running tasks. Busy energy is associated with the state of
+the cpu, not an event. The time the cpu spends in this state varies. Thus, the
+most obvious platform parameter for this contribution is busy power
+(energy/time).
+
+2. Idle energy: Energy consumed while a cpu and higher level groups that it
+belongs to are idle (in a C-state). Like busy energy, idle energy is associated
+with the state of the cpu. Thus, the platform parameter for this contribution
+is idle power (energy/time).
+
+Energy consumed during transitions from an idle-state (C-state) to a busy state
+(P-state) or going the other way is ignored by the model to simplify the energy
+model calculations.
+
+
+	Power
+	^
+	|            busy->idle             idle->busy
+	|            transition             transition
+	|
+	|                _                      __
+	|               / \                    /  \__________________
+	|______________/   \                  /
+	|                   \                /
+	|  Busy              \    Idle      /        Busy
+	|  low P-state        \____________/         high P-state
+	|
+	+------------------------------------------------------------> time
+
+Busy    |--------------|                          |-----------------|
+
+Wakeup                 |------|            |------|
+
+Idle                          |------------|
+
+
+The basic algorithm
+====================
+
+The basic idea is to determine the total energy impact when utilization is
+added or removed by estimating the impact at each level in the sched_domain
+hierarchy starting from the bottom (sched_group contains just a single cpu).
+The energy cost comes from busy time (sched_group is awake because one or more
+cpus are busy) and idle time (in an idle-state). Energy model numbers account
+for energy costs associated with all cpus in the sched_group as a group.
+
+	for_each_domain(cpu, sd) {
+		sg = sched_group_of(cpu)
+		energy_before = curr_util(sg) * busy_power(sg)
+				+ (1-curr_util(sg)) * idle_power(sg)
+		energy_after = new_util(sg) * busy_power(sg)
+				+ (1-new_util(sg)) * idle_power(sg)
+		energy_diff += energy_before - energy_after
+
+	}
+
+	return energy_diff
+
+{curr, new}_util: The cpu utilization at the lowest level and the overall
+non-idle time for the entire group for higher levels. Utilization is in the
+range 0.0 to 1.0 in the pseudo-code.
+
+busy_power: The power consumption of the sched_group.
+
+idle_power: The power consumption of the sched_group when idle.
+
+Note: It is a fundamental assumption that the utilization is (roughly) scale
+invariant. Task utilization tracking factors in any frequency scaling and
+performance scaling differences due to difference cpu microarchitectures such
+that task utilization can be used across the entire system.
+
+
+Platform energy data
+=====================
+
+struct sched_group_energy can be attached to sched_groups in the sched_domain
+hierarchy and has the following members:
+
+cap_states:
+	List of struct capacity_state representing the supported capacity states
+	(P-states). struct capacity_state has two members: cap and power, which
+	represents the compute capacity and the busy_power of the state. The
+	list must be ordered by capacity low->high.
+
+nr_cap_states:
+	Number of capacity states in cap_states list.
+
+idle_states:
+	List of struct idle_state containing idle_state power cost for each
+	idle-state supported by the system orderd by shallowest state first.
+	All states must be included at all level in the hierarchy, i.e. a
+	sched_group spanning just a single cpu must also include coupled
+	idle-states (cluster states). In addition to the cpuidle idle-states,
+	the list must also contain an entry for the idling using the arch
+	default idle (arch_idle_cpu()). Despite this state may not be a true
+	hardware idle-state it is considered the shallowest idle-state in the
+	energy model and must be the first entry. cpus may enter this state
+	(possibly 'active idling') if cpuidle decides not enter a cpuidle
+	idle-state. Default idle may not be used when cpuidle is enabled.
+	In this case, it should just be a copy of the first cpuidle idle-state.
+
+nr_idle_states:
+	Number of idle states in idle_states list.
+
+There are no unit requirements for the energy cost data. Data can be normalized
+with any reference, however, the normalization must be consistent across all
+energy cost data. That is, one bogo-joule/watt must be the same quantity for
+data, but we don't care what it is.
+
+A recipe for platform characterization
+=======================================
+
+Obtaining the actual model data for a particular platform requires some way of
+measuring power/energy. There isn't a tool to help with this (yet). This
+section provides a recipe for use as reference. It covers the steps used to
+characterize the ARM TC2 development platform. This sort of measurements is
+expected to be done anyway when tuning cpuidle and cpufreq for a given
+platform.
+
+The energy model needs two types of data (struct sched_group_energy holds
+these) for each sched_group where energy costs should be taken into account:
+
+1. Capacity state information
+
+A list containing the compute capacity and power consumption when fully
+utilized attributed to the group as a whole for each available capacity state.
+At the lowest level (group contains just a single cpu) this is the power of the
+cpu alone without including power consumed by resources shared with other cpus.
+It basically needs to fit the basic modelling approach described in "Background
+and Terminology" section:
+
+	energy_system = energy_shared + n * energy_cpu
+
+for a system containing 'n' busy cpus. Only 'energy_cpu' should be included at
+the lowest level. 'energy_shared' is included at the next level which
+represents the group of cpus among which the resources are shared.
+
+This model is, of course, a simplification of reality. Thus, power/energy
+attributions might not always exactly represent how the hardware is designed.
+Also, busy power is likely to depend on the workload. It is therefore
+recommended to use a representative mix of workloads when characterizing the
+capacity states.
+
+If the group has no capacity scaling support, the list will contain a single
+state where power is the busy power attributed to the group. The capacity
+should be set to a default value (1024).
+
+When frequency domains include multiple power domains, the group representing
+the frequency domain and all child groups share capacity states. This must be
+indicated by setting the SD_SHARE_CAP_STATES sched_domain flag. All groups at
+all levels that share the capacity state must have the list of capacity states
+with the power set to the contribution of the individual group.
+
+2. Idle power information
+
+Stored in the idle_states list. The power number is the group idle power
+consumption in each idle state as well when the group is idle but has not
+entered an idle-state ('active idle' as mentioned earlier). Due to the way the
+energy model is defined, the idle power of the deepest group idle state can
+alternatively be accounted for in the parent group busy power. In that case the
+group idle state power values are offset such that the idle power of the
+deepest state is zero. It is less intuitive, but it is easier to measure as
+idle power consumed by the group and the busy/idle power of the parent group
+cannot be distinguished without per group measurement points.
+
+Measuring capacity states and idle power:
+
+The capacity states' capacity and power can be estimated by running a benchmark
+workload at each available capacity state. By restricting the benchmark to run
+on subsets of cpus it is possible to extrapolate the power consumption of
+shared resources.
+
+ARM TC2 has two clusters of two and three cpus respectively. Each cluster has a
+shared L2 cache. TC2 has on-chip energy counters per cluster. Running a
+benchmark workload on just one cpu in a cluster means that power is consumed in
+the cluster (higher level group) and a single cpu (lowest level group). Adding
+another benchmark task to another cpu increases the power consumption by the
+amount consumed by the additional cpu. Hence, it is possible to extrapolate the
+cluster busy power.
+
+For platforms that don't have energy counters or equivalent instrumentation
+built-in, it may be possible to use an external DAQ to acquire similar data.
+
+If the benchmark includes some performance score (for example sysbench cpu
+benchmark), this can be used to record the compute capacity.
+
+Measuring idle power requires insight into the idle state implementation on the
+particular platform. Specifically, if the platform has coupled idle-states (or
+package states). To measure non-coupled per-cpu idle-states it is necessary to
+keep one cpu busy to keep any shared resources alive to isolate the idle power
+of the cpu from idle/busy power of the shared resources. The cpu can be tricked
+into different per-cpu idle states by disabling the other states. Based on
+various combinations of measurements with specific cpus busy and disabling
+idle-states it is possible to extrapolate the idle-state power.
diff --git a/Documentation/scheduler/sched-tune.txt b/Documentation/scheduler/sched-tune.txt
new file mode 100644
index 00000000..9bd2231
--- /dev/null
+++ b/Documentation/scheduler/sched-tune.txt
@@ -0,0 +1,366 @@
+             Central, scheduler-driven, power-performance control
+                               (EXPERIMENTAL)
+
+Abstract
+========
+
+The topic of a single simple power-performance tunable, that is wholly
+scheduler centric, and has well defined and predictable properties has come up
+on several occasions in the past [1,2]. With techniques such as a scheduler
+driven DVFS [3], we now have a good framework for implementing such a tunable.
+This document describes the overall ideas behind its design and implementation.
+
+
+Table of Contents
+=================
+
+1. Motivation
+2. Introduction
+3. Signal Boosting Strategy
+4. OPP selection using boosted CPU utilization
+5. Per task group boosting
+6. Question and Answers
+   - What about "auto" mode?
+   - What about boosting on a congested system?
+   - How CPUs are boosted when we have tasks with multiple boost values?
+7. References
+
+
+1. Motivation
+=============
+
+Sched-DVFS [3] is a new event-driven cpufreq governor which allows the
+scheduler to select the optimal DVFS operating point (OPP) for running a task
+allocated to a CPU. The introduction of sched-DVFS enables running workloads at
+the most energy efficient OPPs.
+
+However, sometimes it may be desired to intentionally boost the performance of
+a workload even if that could imply a reasonable increase in energy
+consumption. For example, in order to reduce the response time of a task, we
+may want to run the task at a higher OPP than the one that is actually required
+by it's CPU bandwidth demand.
+
+This last requirement is especially important if we consider that one of the
+main goals of the sched-DVFS component is to replace all currently available
+CPUFreq policies. Since sched-DVFS is event based, as opposed to the sampling
+driven governors we currently have, it is already more responsive at selecting
+the optimal OPP to run tasks allocated to a CPU. However, just tracking the
+actual task load demand may not be enough from a performance standpoint.  For
+example, it is not possible to get behaviors similar to those provided by the
+"performance" and "interactive" CPUFreq governors.
+
+This document describes an implementation of a tunable, stacked on top of the
+sched-DVFS which extends its functionality to support task performance
+boosting.
+
+By "performance boosting" we mean the reduction of the time required to
+complete a task activation, i.e. the time elapsed from a task wakeup to its
+next deactivation (e.g. because it goes back to sleep or it terminates).  For
+example, if we consider a simple periodic task which executes the same workload
+for 5[s] every 20[s] while running at a certain OPP, a boosted execution of
+that task must complete each of its activations in less than 5[s].
+
+A previous attempt [5] to introduce such a boosting feature has not been
+successful mainly because of the complexity of the proposed solution.  The
+approach described in this document exposes a single simple interface to
+user-space.  This single tunable knob allows the tuning of system wide
+scheduler behaviours ranging from energy efficiency at one end through to
+incremental performance boosting at the other end.  This first tunable affects
+all tasks. However, a more advanced extension of the concept is also provided
+which uses CGroups to boost the performance of only selected tasks while using
+the energy efficient default for all others.
+
+The rest of this document introduces in more details the proposed solution
+which has been named SchedTune.
+
+
+2. Introduction
+===============
+
+SchedTune exposes a simple user-space interface with a single power-performance
+tunable:
+
+  /proc/sys/kernel/sched_cfs_boost
+
+This permits expressing a boost value as an integer in the range [0..100].
+
+A value of 0 (default) configures the CFS scheduler for maximum energy
+efficiency. This means that sched-DVFS runs the tasks at the minimum OPP
+required to satisfy their workload demand.
+A value of 100 configures scheduler for maximum performance, which translates
+to the selection of the maximum OPP on that CPU.
+
+The range between 0 and 100 can be set to satisfy other scenarios suitably. For
+example to satisfy interactive response or depending on other system events
+(battery level etc).
+
+A CGroup based extension is also provided, which permits further user-space
+defined task classification to tune the scheduler for different goals depending
+on the specific nature of the task, e.g. background vs interactive vs
+low-priority.
+
+The overall design of the SchedTune module is built on top of "Per-Entity Load
+Tracking" (PELT) signals and sched-DVFS by introducing a bias on the Operating
+Performance Point (OPP) selection.
+Each time a task is allocated on a CPU, sched-DVFS has the opportunity to tune
+the operating frequency of that CPU to better match the workload demand. The
+selection of the actual OPP being activated is influenced by the global boost
+value, or the boost value for the task CGroup when in use.
+
+This simple biasing approach leverages existing frameworks, which means minimal
+modifications to the scheduler, and yet it allows to achieve a range of
+different behaviours all from a single simple tunable knob.
+The only new concept introduced is that of signal boosting.
+
+
+3. Signal Boosting Strategy
+===========================
+
+The whole PELT machinery works based on the value of a few load tracking signals
+which basically track the CPU bandwidth requirements for tasks and the capacity
+of CPUs. The basic idea behind the SchedTune knob is to artificially inflate
+some of these load tracking signals to make a task or RQ appears more demanding
+that it actually is.
+
+Which signals have to be inflated depends on the specific "consumer".  However,
+independently from the specific (signal, consumer) pair, it is important to
+define a simple and possibly consistent strategy for the concept of boosting a
+signal.
+
+A boosting strategy defines how the "abstract" user-space defined
+sched_cfs_boost value is translated into an internal "margin" value to be added
+to a signal to get its inflated value:
+
+  margin         := boosting_strategy(sched_cfs_boost, signal)
+  boosted_signal := signal + margin
+
+Different boosting strategies were identified and analyzed before selecting the
+one found to be most effective.
+
+Signal Proportional Compensation (SPC)
+--------------------------------------
+
+In this boosting strategy the sched_cfs_boost value is used to compute a
+margin which is proportional to the complement of the original signal.
+When a signal has a maximum possible value, its complement is defined as
+the delta from the actual value and its possible maximum.
+
+Since the tunable implementation uses signals which have SCHED_LOAD_SCALE as
+the maximum possible value, the margin becomes:
+
+	margin := sched_cfs_boost * (SCHED_LOAD_SCALE - signal)
+
+Using this boosting strategy:
+- a 100% sched_cfs_boost means that the signal is scaled to the maximum value
+- each value in the range of sched_cfs_boost effectively inflates the signal in
+  question by a quantity which is proportional to the maximum value.
+
+For example, by applying the SPC boosting strategy to the selection of the OPP
+to run a task it is possible to achieve these behaviors:
+
+-   0% boosting: run the task at the minimum OPP required by its workload
+- 100% boosting: run the task at the maximum OPP available for the CPU
+-  50% boosting: run at the half-way OPP between minimum and maximum
+
+Which means that, at 50% boosting, a task will be scheduled to run at half of
+the maximum theoretically achievable performance on the specific target
+platform.
+
+A graphical representation of an SPC boosted signal is represented in the
+following figure where:
+ a) "-" represents the original signal
+ b) "b" represents a  50% boosted signal
+ c) "p" represents a 100% boosted signal
+
+
+   ^
+   |  SCHED_LOAD_SCALE
+   +-----------------------------------------------------------------+
+   |pppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppp
+   |
+   |                                             boosted_signal
+   |                                          bbbbbbbbbbbbbbbbbbbbbbbb
+   |
+   |                                            original signal
+   |                  bbbbbbbbbbbbbbbbbbbbbbbb+----------------------+
+   |                                          |
+   |bbbbbbbbbbbbbbbbbb                        |
+   |                                          |
+   |                                          |
+   |                                          |
+   |                  +-----------------------+
+   |                  |
+   |                  |
+   |                  |
+   |------------------+
+   |
+   |
+   +----------------------------------------------------------------------->
+
+The plot above shows a ramped load signal (titled 'original_signal') and it's
+boosted equivalent. For each step of the original signal the boosted signal
+corresponding to a 50% boost is midway from the original signal and the upper
+bound. Boosting by 100% generates a boosted signal which is always saturated to
+the upper bound.
+
+
+4. OPP selection using boosted CPU utilization
+==============================================
+
+It is worth calling out that the implementation does not introduce any new load
+signals. Instead, it provides an API to tune existing signals. This tuning is
+done on demand and only in scheduler code paths where it is sensible to do so.
+The new API calls are defined to return either the default signal or a boosted
+one, depending on the value of sched_cfs_boost. This is a clean an non invasive
+modification of the existing existing code paths.
+
+The signal representing a CPU's utilization is boosted according to the
+previously described SPC boosting strategy. To sched-DVFS, this allows a CPU
+(ie CFS run-queue) to appear more used then it actually is.
+
+Thus, with the sched_cfs_boost enabled we have the following main functions to
+get the current utilization of a CPU:
+
+  cpu_util()
+  boosted_cpu_util()
+
+The new boosted_cpu_util() is similar to the first but returns a boosted
+utilization signal which is a function of the sched_cfs_boost value.
+
+This function is used in the CFS scheduler code paths where sched-DVFS needs to
+decide the OPP to run a CPU at.
+For example, this allows selecting the highest OPP for a CPU which has
+the boost value set to 100%.
+
+
+5. Per task group boosting
+==========================
+
+The availability of a single knob which is used to boost all tasks in the
+system is certainly a simple solution but it quite likely doesn't fit many
+utilization scenarios, especially in the mobile device space.
+
+For example, on battery powered devices there usually are many background
+services which are long running and need energy efficient scheduling. On the
+other hand, some applications are more performance sensitive and require an
+interactive response and/or maximum performance, regardless of the energy cost.
+To better service such scenarios, the SchedTune implementation has an extension
+that provides a more fine grained boosting interface.
+
+A new CGroup controller, namely "schedtune", could be enabled which allows to
+defined and configure task groups with different boosting values.
+Tasks that require special performance can be put into separate CGroups.
+The value of the boost associated with the tasks in this group can be specified
+using a single knob exposed by the CGroup controller:
+
+   schedtune.boost
+
+This knob allows the definition of a boost value that is to be used for
+SPC boosting of all tasks attached to this group.
+
+The current schedtune controller implementation is really simple and has these
+main characteristics:
+
+  1) It is only possible to create 1 level depth hierarchies
+
+     The root control groups define the system-wide boost value to be applied
+     by default to all tasks. Its direct subgroups are named "boost groups" and
+     they define the boost value for specific set of tasks.
+     Further nested subgroups are not allowed since they do not have a sensible
+     meaning from a user-space standpoint.
+
+  2) It is possible to define only a limited number of "boost groups"
+
+     This number is defined at compile time and by default configured to 16.
+     This is a design decision motivated by two main reasons:
+     a) In a real system we do not expect utilization scenarios with more then few
+	boost groups. For example, a reasonable collection of groups could be
+        just "background", "interactive" and "performance".
+     b) It simplifies the implementation considerably, especially for the code
+	which has to compute the per CPU boosting once there are multiple
+        RUNNABLE tasks with different boost values.
+
+Such a simple design should allow servicing the main utilization scenarios identified
+so far. It provides a simple interface which can be used to manage the
+power-performance of all tasks or only selected tasks.
+Moreover, this interface can be easily integrated by user-space run-times (e.g.
+Android, ChromeOS) to implement a QoS solution for task boosting based on tasks
+classification, which has been a long standing requirement.
+
+Setup and usage
+---------------
+
+0. Use a kernel with CGROUP_SCHEDTUNE support enabled
+
+1. Check that the "schedtune" CGroup controller is available:
+
+   root@linaro-nano:~# cat /proc/cgroups
+   #subsys_name	hierarchy	num_cgroups	enabled
+   cpuset  	0		1		1
+   cpu     	0		1		1
+   schedtune	0		1		1
+
+2. Mount a tmpfs to create the CGroups mount point (Optional)
+
+   root@linaro-nano:~# sudo mount -t tmpfs cgroups /sys/fs/cgroup
+
+3. Mount the "schedtune" controller
+
+   root@linaro-nano:~# mkdir /sys/fs/cgroup/stune
+   root@linaro-nano:~# sudo mount -t cgroup -o schedtune stune /sys/fs/cgroup/stune
+
+4. Setup the system-wide boost value (Optional)
+
+   If not configured the root control group has a 0% boost value, which
+   basically disables boosting for all tasks in the system thus running in
+   an energy-efficient mode.
+
+   root@linaro-nano:~# echo $SYSBOOST > /sys/fs/cgroup/stune/schedtune.boost
+
+5. Create task groups and configure their specific boost value (Optional)
+
+   For example here we create a "performance" boost group configure to boost
+   all its tasks to 100%
+
+   root@linaro-nano:~# mkdir /sys/fs/cgroup/stune/performance
+   root@linaro-nano:~# echo 100 > /sys/fs/cgroup/stune/performance/schedtune.boost
+
+6. Move tasks into the boost group
+
+   For example, the following moves the tasks with PID $TASKPID (and all its
+   threads) into the "performance" boost group.
+
+   root@linaro-nano:~# echo "TASKPID > /sys/fs/cgroup/stune/performance/cgroup.procs
+
+This simple configuration allows only the threads of the $TASKPID task to run,
+when needed, at the highest OPP in the most capable CPU of the system.
+
+
+6. Question and Answers
+=======================
+
+What about "auto" mode?
+-----------------------
+
+The 'auto' mode as described in [5] can be implemented by interfacing SchedTune
+with some suitable user-space element. This element could use the exposed
+system-wide or cgroup based interface.
+
+How are multiple groups of tasks with different boost values managed?
+---------------------------------------------------------------------
+
+The current SchedTune implementation keeps track of the boosted RUNNABLE tasks
+on a CPU. Once sched-DVFS selects the OPP to run a CPU at, the CPU utilization
+is boosted with a value which is the maximum of the boost values of the
+currently RUNNABLE tasks in its RQ.
+
+This allows sched-DVFS to boost a CPU only while there are boosted tasks ready
+to run and switch back to the energy efficient mode as soon as the last boosted
+task is dequeued.
+
+
+7. References
+=============
+[1] http://lwn.net/Articles/552889
+[2] http://lkml.org/lkml/2012/5/18/91
+[3] http://lkml.org/lkml/2015/6/26/620
diff --git a/Documentation/security/keys.txt b/Documentation/security/keys.txt
index 3849814..0e03baf 100644
--- a/Documentation/security/keys.txt
+++ b/Documentation/security/keys.txt
@@ -1151,8 +1151,21 @@ access the data:
      usage.  This is called key->payload.rcu_data0.  The following accessors
      wrap the RCU calls to this element:
 
-	rcu_assign_keypointer(struct key *key, void *data);
-	void *rcu_dereference_key(struct key *key);
+     (a) Set or change the first payload pointer:
+
+		rcu_assign_keypointer(struct key *key, void *data);
+
+     (b) Read the first payload pointer with the key semaphore held:
+
+		[const] void *dereference_key_locked([const] struct key *key);
+
+	 Note that the return value will inherit its constness from the key
+	 parameter.  Static analysis will give an error if it things the lock
+	 isn't held.
+
+     (c) Read the first payload pointer with the RCU read lock held:
+
+		const void *dereference_key_rcu(const struct key *key);
 
 
 ===================
diff --git a/Documentation/sync.txt b/Documentation/sync.txt
new file mode 100644
index 00000000..a2d05e7
--- /dev/null
+++ b/Documentation/sync.txt
@@ -0,0 +1,75 @@
+Motivation:
+
+In complicated DMA pipelines such as graphics (multimedia, camera, gpu, display)
+a consumer of a buffer needs to know when the producer has finished producing
+it.  Likewise the producer needs to know when the consumer is finished with the
+buffer so it can reuse it.  A particular buffer may be consumed by multiple
+consumers which will retain the buffer for different amounts of time.  In
+addition, a consumer may consume multiple buffers atomically.
+The sync framework adds an API which allows synchronization between the
+producers and consumers in a generic way while also allowing platforms which
+have shared hardware synchronization primitives to exploit them.
+
+Goals:
+	* provide a generic API for expressing synchronization dependencies
+	* allow drivers to exploit hardware synchronization between hardware
+	  blocks
+	* provide a userspace API that allows a compositor to manage
+	  dependencies.
+	* provide rich telemetry data to allow debugging slowdowns and stalls of
+	   the graphics pipeline.
+
+Objects:
+	* sync_timeline
+	* sync_pt
+	* sync_fence
+
+sync_timeline:
+
+A sync_timeline is an abstract monotonically increasing counter. In general,
+each driver/hardware block context will have one of these.  They can be backed
+by the appropriate hardware or rely on the generic sw_sync implementation.
+Timelines are only ever created through their specific implementations
+(i.e. sw_sync.)
+
+sync_pt:
+
+A sync_pt is an abstract value which marks a point on a sync_timeline. Sync_pts
+have a single timeline parent.  They have 3 states: active, signaled, and error.
+They start in active state and transition, once, to either signaled (when the
+timeline counter advances beyond the sync_pt’s value) or error state.
+
+sync_fence:
+
+Sync_fences are the primary primitives used by drivers to coordinate
+synchronization of their buffers.  They are a collection of sync_pts which may
+or may not have the same timeline parent.  A sync_pt can only exist in one fence
+and the fence's list of sync_pts is immutable once created.  Fences can be
+waited on synchronously or asynchronously.  Two fences can also be merged to
+create a third fence containing a copy of the two fences’ sync_pts.  Fences are
+backed by file descriptors to allow userspace to coordinate the display pipeline
+dependencies.
+
+Use:
+
+A driver implementing sync support should have a work submission function which:
+     * takes a fence argument specifying when to begin work
+     * asynchronously queues that work to kick off when the fence is signaled
+     * returns a fence to indicate when its work will be done.
+     * signals the returned fence once the work is completed.
+
+Consider an imaginary display driver that has the following API:
+/*
+ * assumes buf is ready to be displayed.
+ * blocks until the buffer is on screen.
+ */
+    void display_buffer(struct dma_buf *buf);
+
+The new API will become:
+/*
+ * will display buf when fence is signaled.
+ * returns immediately with a fence that will signal when buf
+ * is no longer displayed.
+ */
+struct sync_fence* display_buffer(struct dma_buf *buf,
+                                 struct sync_fence *fence);
diff --git a/Documentation/sysctl/kernel.txt b/Documentation/sysctl/kernel.txt
index ffab8b5..52daff6 100644
--- a/Documentation/sysctl/kernel.txt
+++ b/Documentation/sysctl/kernel.txt
@@ -659,12 +659,14 @@ allowed to execute.
 perf_event_paranoid:
 
 Controls use of the performance events system by unprivileged
-users (without CAP_SYS_ADMIN).  The default value is 2.
+users (without CAP_SYS_ADMIN).  The default value is 3 if
+CONFIG_SECURITY_PERF_EVENTS_RESTRICT is set, or 2 otherwise.
 
  -1: Allow use of (almost) all events by all users
 >=0: Disallow raw tracepoint access by users without CAP_IOC_LOCK
 >=1: Disallow CPU event access by users without CAP_SYS_ADMIN
 >=2: Disallow kernel profiling by users without CAP_SYS_ADMIN
+>=3: Disallow all event access by users without CAP_SYS_ADMIN
 
 ==============================================================
 
diff --git a/Documentation/sysctl/vm.txt b/Documentation/sysctl/vm.txt
index 95ccbe6..206c9b0 100644
--- a/Documentation/sysctl/vm.txt
+++ b/Documentation/sysctl/vm.txt
@@ -30,6 +30,7 @@ Currently, these files are in /proc/sys/vm:
 - dirty_writeback_centisecs
 - drop_caches
 - extfrag_threshold
+- extra_free_kbytes
 - hugepages_treat_as_movable
 - hugetlb_shm_group
 - laptop_mode
@@ -240,6 +241,21 @@ fragmentation index is <= extfrag_threshold. The default value is 500.
 
 ==============================================================
 
+extra_free_kbytes
+
+This parameter tells the VM to keep extra free memory between the threshold
+where background reclaim (kswapd) kicks in, and the threshold where direct
+reclaim (by allocating processes) kicks in.
+
+This is useful for workloads that require low latency memory allocations
+and have a bounded burstiness in memory allocations, for example a
+realtime application that receives and transmits network traffic
+(causing in-kernel memory allocations) with a maximum total message burst
+size of 200MB may need 200MB of extra free memory to avoid direct reclaim
+related latencies.
+
+==============================================================
+
 hugepages_treat_as_movable
 
 This parameter controls whether we can allocate hugepages from ZONE_MOVABLE
diff --git a/Documentation/tee.txt b/Documentation/tee.txt
new file mode 100644
index 00000000..56ea85f
--- /dev/null
+++ b/Documentation/tee.txt
@@ -0,0 +1,127 @@
+=============
+TEE subsystem
+=============
+
+This document describes the TEE subsystem in Linux.
+
+A TEE (Trusted Execution Environment) is a trusted OS running in some
+secure environment, for example, TrustZone on ARM CPUs, or a separate
+secure co-processor etc. A TEE driver handles the details needed to
+communicate with the TEE.
+
+This subsystem deals with:
+
+- Registration of TEE drivers
+
+- Managing shared memory between Linux and the TEE
+
+- Providing a generic API to the TEE
+
+The TEE interface
+=================
+
+include/uapi/linux/tee.h defines the generic interface to a TEE.
+
+User space (the client) connects to the driver by opening /dev/tee[0-9]* or
+/dev/teepriv[0-9]*.
+
+- TEE_IOC_SHM_ALLOC allocates shared memory and returns a file descriptor
+  which user space can mmap. When user space doesn't need the file
+  descriptor any more, it should be closed. When shared memory isn't needed
+  any longer it should be unmapped with munmap() to allow the reuse of
+  memory.
+
+- TEE_IOC_VERSION lets user space know which TEE this driver handles and
+  the its capabilities.
+
+- TEE_IOC_OPEN_SESSION opens a new session to a Trusted Application.
+
+- TEE_IOC_INVOKE invokes a function in a Trusted Application.
+
+- TEE_IOC_CANCEL may cancel an ongoing TEE_IOC_OPEN_SESSION or TEE_IOC_INVOKE.
+
+- TEE_IOC_CLOSE_SESSION closes a session to a Trusted Application.
+
+There are two classes of clients, normal clients and supplicants. The latter is
+a helper process for the TEE to access resources in Linux, for example file
+system access. A normal client opens /dev/tee[0-9]* and a supplicant opens
+/dev/teepriv[0-9].
+
+Much of the communication between clients and the TEE is opaque to the
+driver. The main job for the driver is to receive requests from the
+clients, forward them to the TEE and send back the results. In the case of
+supplicants the communication goes in the other direction, the TEE sends
+requests to the supplicant which then sends back the result.
+
+OP-TEE driver
+=============
+
+The OP-TEE driver handles OP-TEE [1] based TEEs. Currently it is only the ARM
+TrustZone based OP-TEE solution that is supported.
+
+Lowest level of communication with OP-TEE builds on ARM SMC Calling
+Convention (SMCCC) [2], which is the foundation for OP-TEE's SMC interface
+[3] used internally by the driver. Stacked on top of that is OP-TEE Message
+Protocol [4].
+
+OP-TEE SMC interface provides the basic functions required by SMCCC and some
+additional functions specific for OP-TEE. The most interesting functions are:
+
+- OPTEE_SMC_FUNCID_CALLS_UID (part of SMCCC) returns the version information
+  which is then returned by TEE_IOC_VERSION
+
+- OPTEE_SMC_CALL_GET_OS_UUID returns the particular OP-TEE implementation, used
+  to tell, for instance, a TrustZone OP-TEE apart from an OP-TEE running on a
+  separate secure co-processor.
+
+- OPTEE_SMC_CALL_WITH_ARG drives the OP-TEE message protocol
+
+- OPTEE_SMC_GET_SHM_CONFIG lets the driver and OP-TEE agree on which memory
+  range to used for shared memory between Linux and OP-TEE.
+
+The GlobalPlatform TEE Client API [5] is implemented on top of the generic
+TEE API.
+
+Picture of the relationship between the different components in the
+OP-TEE architecture::
+
+      User space                  Kernel                   Secure world
+      ~~~~~~~~~~                  ~~~~~~                   ~~~~~~~~~~~~
+   +--------+                                             +-------------+
+   | Client |                                             | Trusted     |
+   +--------+                                             | Application |
+      /\                                                  +-------------+
+      || +----------+                                           /\
+      || |tee-      |                                           ||
+      || |supplicant|                                           \/
+      || +----------+                                     +-------------+
+      \/      /\                                          | TEE Internal|
+   +-------+  ||                                          | API         |
+   + TEE   |  ||            +--------+--------+           +-------------+
+   | Client|  ||            | TEE    | OP-TEE |           | OP-TEE      |
+   | API   |  \/            | subsys | driver |           | Trusted OS  |
+   +-------+----------------+----+-------+----+-----------+-------------+
+   |      Generic TEE API        |       |     OP-TEE MSG               |
+   |      IOCTL (TEE_IOC_*)      |       |     SMCCC (OPTEE_SMC_CALL_*) |
+   +-----------------------------+       +------------------------------+
+
+RPC (Remote Procedure Call) are requests from secure world to kernel driver
+or tee-supplicant. An RPC is identified by a special range of SMCCC return
+values from OPTEE_SMC_CALL_WITH_ARG. RPC messages which are intended for the
+kernel are handled by the kernel driver. Other RPC messages will be forwarded to
+tee-supplicant without further involvement of the driver, except switching
+shared memory buffer representation.
+
+References
+==========
+
+[1] https://github.com/OP-TEE/optee_os
+
+[2] http://infocenter.arm.com/help/topic/com.arm.doc.den0028a/index.html
+
+[3] drivers/tee/optee/optee_smc.h
+
+[4] drivers/tee/optee/optee_msg.h
+
+[5] http://www.globalplatform.org/specificationsdevice.asp look for
+    "TEE Client API Specification v1.0" and click download.
diff --git a/Documentation/trace/events-power.txt b/Documentation/trace/events-power.txt
index 21d514c..4d817d5 100644
--- a/Documentation/trace/events-power.txt
+++ b/Documentation/trace/events-power.txt
@@ -25,6 +25,7 @@ cpufreq.
 
 cpu_idle		"state=%lu cpu_id=%lu"
 cpu_frequency		"state=%lu cpu_id=%lu"
+cpu_frequency_limits	"min=%lu max=%lu cpu_id=%lu"
 
 A suspend event is used to indicate the system going in and out of the
 suspend mode:
diff --git a/Documentation/trace/ftrace.txt b/Documentation/trace/ftrace.txt
index 185c39f..91723ed 100644
--- a/Documentation/trace/ftrace.txt
+++ b/Documentation/trace/ftrace.txt
@@ -362,6 +362,26 @@ of ftrace. Here is a list of some of the key files:
 		  to correlate events across hypervisor/guest if
 		  tb_offset is known.
 
+	  mono: This uses the fast monotonic clock (CLOCK_MONOTONIC)
+		which is monotonic and is subject to NTP rate adjustments.
+
+	  mono_raw:
+		This is the raw monotonic clock (CLOCK_MONOTONIC_RAW)
+		which is montonic but is not subject to any rate adjustments
+		and ticks at the same rate as the hardware clocksource.
+
+	  boot: This is the boot clock (CLOCK_BOOTTIME) and is based on the
+		fast monotonic clock, but also accounts for time spent in
+		suspend. Since the clock access is designed for use in
+		tracing in the suspend path, some side effects are possible
+		if clock is accessed after the suspend time is accounted before
+		the fast mono clock is updated. In this case, the clock update
+		appears to happen slightly sooner than it normally would have.
+		Also on 32-bit systems, it's possible that the 64-bit boot offset
+		sees a partial update. These effects are rare and post
+		processing should be able to handle them. See comments in the
+		ktime_get_boot_fast_ns() function for more information.
+
 	To set a clock, simply echo the clock name into this file.
 
 	  echo global > trace_clock
@@ -2102,6 +2122,35 @@ will produce:
  1)   1.449 us    |             }
 
 
+You can disable the hierarchical function call formatting and instead print a
+flat list of function entry and return events.  This uses the format described
+in the Output Formatting section and respects all the trace options that
+control that formatting.  Hierarchical formatting is the default.
+
+	hierachical: echo nofuncgraph-flat > trace_options
+	flat: echo funcgraph-flat > trace_options
+
+  ie:
+
+  # tracer: function_graph
+  #
+  # entries-in-buffer/entries-written: 68355/68355   #P:2
+  #
+  #                              _-----=> irqs-off
+  #                             / _----=> need-resched
+  #                            | / _---=> hardirq/softirq
+  #                            || / _--=> preempt-depth
+  #                            ||| /     delay
+  #           TASK-PID   CPU#  ||||    TIMESTAMP  FUNCTION
+  #              | |       |   ||||       |         |
+                sh-1806  [001] d...   198.843443: graph_ent: func=_raw_spin_lock
+                sh-1806  [001] d...   198.843445: graph_ent: func=__raw_spin_lock
+                sh-1806  [001] d..1   198.843447: graph_ret: func=__raw_spin_lock
+                sh-1806  [001] d..1   198.843449: graph_ret: func=_raw_spin_lock
+                sh-1806  [001] d..1   198.843451: graph_ent: func=_raw_spin_unlock_irqrestore
+                sh-1806  [001] d...   198.843453: graph_ret: func=_raw_spin_unlock_irqrestore
+
+
 You might find other useful features for this tracer in the
 following "dynamic ftrace" section such as tracing only specific
 functions or tasks.
diff --git a/Kbuild b/Kbuild
index 3d0ae15..94c7527 100644
--- a/Kbuild
+++ b/Kbuild
@@ -7,31 +7,6 @@
 # 4) Check for missing system calls
 # 5) Generate constants.py (may need bounds.h)
 
-# Default sed regexp - multiline due to syntax constraints
-define sed-y
-	"/^->/{s:->#\(.*\):/* \1 */:; \
-	s:^->\([^ ]*\) [\$$#]*\([-0-9]*\) \(.*\):#define \1 \2 /* \3 */:; \
-	s:^->\([^ ]*\) [\$$#]*\([^ ]*\) \(.*\):#define \1 \2 /* \3 */:; \
-	s:->::; p;}"
-endef
-
-# Use filechk to avoid rebuilds when a header changes, but the resulting file
-# does not
-define filechk_offsets
-	(set -e; \
-	 echo "#ifndef $2"; \
-	 echo "#define $2"; \
-	 echo "/*"; \
-	 echo " * DO NOT MODIFY."; \
-	 echo " *"; \
-	 echo " * This file was generated by Kbuild"; \
-	 echo " */"; \
-	 echo ""; \
-	 sed -ne $(sed-y); \
-	 echo ""; \
-	 echo "#endif" )
-endef
-
 #####
 # 1) Generate bounds.h
 
diff --git a/MAINTAINERS b/MAINTAINERS
index 63cefa6..a419303 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -9010,6 +9010,11 @@ F:	arch/*/oprofile/
 F:	drivers/oprofile/
 F:	include/linux/oprofile.h
 
+OP-TEE DRIVER
+M:	Jens Wiklander <jens.wiklander@linaro.org>
+S:	Maintained
+F:	drivers/tee/optee/
+
 ORACLE CLUSTER FILESYSTEM 2 (OCFS2)
 M:	Mark Fasheh <mfasheh@versity.com>
 M:	Joel Becker <jlbec@evilplan.org>
@@ -10655,6 +10660,14 @@ F:	drivers/hwtracing/stm/
 F:	include/linux/stm.h
 F:	include/uapi/linux/stm.h
 
+TEE SUBSYSTEM
+M:	Jens Wiklander <jens.wiklander@linaro.org>
+S:	Maintained
+F:	include/linux/tee_drv.h
+F:	include/uapi/linux/tee.h
+F:	drivers/tee/
+F:	Documentation/tee.txt
+
 THUNDERBOLT DRIVER
 M:	Andreas Noever <andreas.noever@gmail.com>
 S:	Maintained
diff --git a/Makefile b/Makefile
index 0723bbe..dcbf0d1 100644
--- a/Makefile
+++ b/Makefile
@@ -303,8 +303,8 @@ CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
 
 HOSTCC       = gcc
 HOSTCXX      = g++
-HOSTCFLAGS   = -Wall -Wmissing-prototypes -Wstrict-prototypes -O2 -fomit-frame-pointer -std=gnu89
-HOSTCXXFLAGS = -O2
+HOSTCFLAGS   := -Wall -Wmissing-prototypes -Wstrict-prototypes -O3 -fomit-frame-pointer -std=gnu89
+HOSTCXXFLAGS = -O3
 
 ifeq ($(shell $(HOSTCC) -v 2>&1 | grep -c "clang version"), 1)
 HOSTCFLAGS  += -Wno-unused-value -Wno-unused-parameter \
@@ -348,6 +348,7 @@ include scripts/Kbuild.include
 # Make variables (CC, etc...)
 AS		= $(CROSS_COMPILE)as
 LD		= $(CROSS_COMPILE)ld
+LDGOLD		= $(CROSS_COMPILE)ld.gold
 CC		= $(CROSS_COMPILE)gcc
 CPP		= $(CC) -E
 AR		= $(CROSS_COMPILE)ar
@@ -397,7 +398,8 @@ KBUILD_CFLAGS   := -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \
 		   -fno-strict-aliasing -fno-common \
 		   -Werror-implicit-function-declaration \
 		   -Wno-format-security \
-		   -std=gnu89
+		   -std=gnu89 \
+		   -DJPU_FRAGMENT_FRAME_BITSTREAM
 KBUILD_CPPFLAGS := -D__KERNEL__
 KBUILD_AFLAGS_KERNEL :=
 KBUILD_CFLAGS_KERNEL :=
@@ -623,6 +625,20 @@ CFLAGS_GCOV	:= -fprofile-arcs -ftest-coverage -fno-tree-loop-im $(call cc-disabl
 CFLAGS_KCOV	:= $(call cc-option,-fsanitize-coverage=trace-pc,)
 export CFLAGS_GCOV CFLAGS_KCOV
 
+# Make toolchain changes before including arch/$(SRCARCH)/Makefile to ensure
+# ar/cc/ld-* macros return correct values.
+ifdef CONFIG_LTO_CLANG
+# use GNU gold with LLVMgold for LTO linking, and LD for vmlinux_link
+LDFINAL_vmlinux := $(LD)
+LD		:= $(LDGOLD)
+LDFLAGS		+= -plugin LLVMgold.so
+# use llvm-ar for building symbol tables from IR files, and llvm-dis instead
+# of objdump for processing symbol versions and exports
+LLVM_AR		:= llvm-ar
+LLVM_DIS	:= llvm-dis
+export LLVM_AR LLVM_DIS
+endif
+
 # The arch Makefile can set ARCH_{CPP,A,C}FLAGS to override the default
 # values of the respective KBUILD_* variables
 ARCH_CPPFLAGS :=
@@ -642,8 +658,56 @@ KBUILD_CFLAGS	+= $(call cc-option,-ffunction-sections,)
 KBUILD_CFLAGS	+= $(call cc-option,-fdata-sections,)
 endif
 
+ifdef CONFIG_LTO_CLANG
+lto-clang-flags	:= -flto -fvisibility=hidden
+
+# allow disabling only clang LTO where needed
+DISABLE_LTO_CLANG := -fno-lto -fvisibility=default
+export DISABLE_LTO_CLANG
+endif
+
+ifdef CONFIG_LTO
+lto-flags	:= $(lto-clang-flags)
+KBUILD_CFLAGS	+= $(lto-flags)
+
+DISABLE_LTO	:= $(DISABLE_LTO_CLANG)
+export DISABLE_LTO
+
+# LDFINAL_vmlinux and LDFLAGS_FINAL_vmlinux can be set to override
+# the linker and flags for vmlinux_link.
+export LDFINAL_vmlinux LDFLAGS_FINAL_vmlinux
+endif
+
+ifdef CONFIG_CFI_CLANG
+cfi-clang-flags	+= -fsanitize=cfi
+DISABLE_CFI_CLANG := -fno-sanitize=cfi
+ifdef CONFIG_MODULES
+cfi-clang-flags	+= -fsanitize-cfi-cross-dso
+DISABLE_CFI_CLANG += -fno-sanitize-cfi-cross-dso
+endif
+ifdef CONFIG_CFI_PERMISSIVE
+cfi-clang-flags	+= -fsanitize-recover=cfi -fno-sanitize-trap=cfi
+endif
+
+# also disable CFI when LTO is disabled
+DISABLE_LTO_CLANG += $(DISABLE_CFI_CLANG)
+# allow disabling only clang CFI where needed
+export DISABLE_CFI_CLANG
+endif
+
+ifdef CONFIG_CFI
+# cfi-flags are re-tested in prepare-compiler-check
+cfi-flags	:= $(cfi-clang-flags)
+KBUILD_CFLAGS	+= $(cfi-flags)
+
+DISABLE_CFI	:= $(DISABLE_CFI_CLANG)
+DISABLE_LTO	+= $(DISABLE_CFI)
+export DISABLE_CFI
+endif
+
 ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
-KBUILD_CFLAGS	+= -Os $(call cc-disable-warning,maybe-uninitialized,)
+KBUILD_CFLAGS	+= $(call cc-option,-Oz,-Os)
+KBUILD_CFLAGS	+= $(call cc-disable-warning,maybe-uninitialized,)
 else
 ifdef CONFIG_PROFILE_ALL_BRANCHES
 KBUILD_CFLAGS	+= -O2 $(call cc-disable-warning,maybe-uninitialized,)
@@ -703,11 +767,22 @@ endif
 KBUILD_CFLAGS += $(stackp-flag)
 
 ifeq ($(cc-name),clang)
+ifneq ($(CROSS_COMPILE),)
+CLANG_TRIPLE    ?= $(CROSS_COMPILE)
+CLANG_TARGET	:= --target=$(notdir $(CLANG_TRIPLE:%-=%))
+GCC_TOOLCHAIN	:= $(realpath $(dir $(shell which $(LD)))/..)
+endif
+ifneq ($(GCC_TOOLCHAIN),)
+CLANG_GCC_TC	:= --gcc-toolchain=$(GCC_TOOLCHAIN)
+endif
+KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC)
+KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC)
 KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
-KBUILD_CPPFLAGS += $(call cc-option,-Wno-unknown-warning-option,)
 KBUILD_CFLAGS += $(call cc-disable-warning, unused-variable)
 KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
 KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
+KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
+KBUILD_CFLAGS += $(call cc-disable-warning, duplicate-decl-specifier)
 # Quiet clang warning: comparison of unsigned expression < 0 is always false
 KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
 # CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
@@ -715,6 +790,8 @@ KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
 # See modpost pattern 2
 KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
 KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
+KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
+KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
 else
 
 # These warnings generated too much noise in a regular build.
@@ -1079,6 +1156,22 @@ prepare-objtool: $(objtool_target)
 # CC_STACKPROTECTOR_STRONG! Why did it build with _REGULAR?!")
 PHONY += prepare-compiler-check
 prepare-compiler-check: FORCE
+# Make sure we're using a supported toolchain with LTO_CLANG
+ifdef CONFIG_LTO_CLANG
+  ifneq ($(call clang-ifversion, -ge, 0500, y), y)
+	@echo Cannot use CONFIG_LTO_CLANG: requires clang 5.0 or later >&2 && exit 1
+  endif
+  ifneq ($(call gold-ifversion, -ge, 112000000, y), y)
+	@echo Cannot use CONFIG_LTO_CLANG: requires GNU gold 1.12 or later >&2 && exit 1
+  endif
+endif
+# Make sure compiler supports LTO flags
+ifdef lto-flags
+  ifeq ($(call cc-option, $(lto-flags)),)
+	@echo Cannot use CONFIG_LTO: $(lto-flags) not supported by compiler \
+		>&2 && exit 1
+  endif
+endif
 # Make sure compiler supports requested stack protector flag.
 ifdef stackp-name
   ifeq ($(call cc-option, $(stackp-flag)),)
@@ -1093,6 +1186,11 @@ ifdef stackp-check
                   $(stackp-flag) available but compiler is broken >&2 && exit 1
   endif
 endif
+ifdef cfi-flags
+  ifeq ($(call cc-option, $(cfi-flags)),)
+	@echo Cannot use CONFIG_CFI: $(cfi-flags) not supported by compiler >&2 && exit 1
+  endif
+endif
 	@:
 
 # Generate some files
@@ -1378,6 +1476,8 @@ help:
 	@echo  '                    (default: $$(INSTALL_MOD_PATH)/lib/firmware)'
 	@echo  '  dir/            - Build all files in dir and below'
 	@echo  '  dir/file.[ois]  - Build specified target only'
+	@echo  '  dir/file.ll     - Build the LLVM assembly file'
+	@echo  '                    (requires compiler support for LLVM assembly generation)'
 	@echo  '  dir/file.lst    - Build specified mixed source/assembly target only'
 	@echo  '                    (requires a recent binutils and recent build (System.map))'
 	@echo  '  dir/file.ko     - Build module including final link'
@@ -1562,7 +1662,9 @@ clean: $(clean-dirs)
 		-o -name '*.symtypes' -o -name 'modules.order' \
 		-o -name modules.builtin -o -name '.tmp_*.o.*' \
 		-o -name '*.c.[012]*.*' \
-		-o -name '*.gcno' \) -type f -print | xargs rm -f
+		-o -name '*.ll' \
+		-o -name '*.gcno' \
+		-o -name '*.*.symversions' \) -type f -print | xargs rm -f
 
 # Generate tags for editors
 # ---------------------------------------------------------------------------
@@ -1665,6 +1767,8 @@ endif
 	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
 %.symtypes: %.c prepare scripts FORCE
 	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
+%.ll: %.c prepare scripts FORCE
+	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
 
 # Modules
 /: prepare scripts FORCE
diff --git a/android/configs/android-32bit.cfg b/android/configs/android-32bit.cfg
new file mode 100644
index 00000000..2d1b4f0
--- /dev/null
+++ b/android/configs/android-32bit.cfg
@@ -0,0 +1 @@
+CONFIG_ANDROID_BINDER_IPC_32BIT=y
diff --git a/android/configs/android-64bit.cfg b/android/configs/android-64bit.cfg
new file mode 100644
index 00000000..2270113
--- /dev/null
+++ b/android/configs/android-64bit.cfg
@@ -0,0 +1 @@
+# CONFIG_ANDROID_BINDER_IPC_32BIT is not set
diff --git a/android/configs/hdcp-disable.cfg b/android/configs/hdcp-disable.cfg
new file mode 100644
index 00000000..13d313f3
--- /dev/null
+++ b/android/configs/hdcp-disable.cfg
@@ -0,0 +1,2 @@
+# CONFIG_RTK_HDCP_1x is not set
+# CONFIG_RTK_HDCPRX_2P2 is not set
diff --git a/android/configs/hdcp-rx-1Px-TEE.cfg b/android/configs/hdcp-rx-1Px-TEE.cfg
new file mode 100644
index 00000000..139a560
--- /dev/null
+++ b/android/configs/hdcp-rx-1Px-TEE.cfg
@@ -0,0 +1 @@
+CONFIG_RTK_HDCPRX_1P4_TEE=y
diff --git a/android/configs/hdcp-rx-1Px.cfg b/android/configs/hdcp-rx-1Px.cfg
new file mode 100644
index 00000000..46682cbc
--- /dev/null
+++ b/android/configs/hdcp-rx-1Px.cfg
@@ -0,0 +1,2 @@
+CONFIG_RTK_HDCP_1x=y
+# CONFIG_RTK_HDCPRX_2P2 is not set
diff --git a/android/configs/hdcp-rx-2P2.cfg b/android/configs/hdcp-rx-2P2.cfg
new file mode 100644
index 00000000..2a884b9
--- /dev/null
+++ b/android/configs/hdcp-rx-2P2.cfg
@@ -0,0 +1,3 @@
+CONFIG_RTK_HDCP_1x=y
+CONFIG_RTK_HDCPRX_2P2=y
+
diff --git a/android/configs/hdcp-rx-TEE-disable.cfg b/android/configs/hdcp-rx-TEE-disable.cfg
new file mode 100644
index 00000000..ecd9f7b
--- /dev/null
+++ b/android/configs/hdcp-rx-TEE-disable.cfg
@@ -0,0 +1 @@
+# CONFIG_RTK_HDCPRX_1P4_TEE is not set
diff --git a/android/configs/hdcp-tx-1Px.cfg b/android/configs/hdcp-tx-1Px.cfg
new file mode 100644
index 00000000..05eeca2f4
--- /dev/null
+++ b/android/configs/hdcp-tx-1Px.cfg
@@ -0,0 +1,2 @@
+CONFIG_RTK_HDCP_1x=y
+
diff --git a/android/configs/hdcp-tx-2P2.cfg b/android/configs/hdcp-tx-2P2.cfg
new file mode 100644
index 00000000..05eeca2f4
--- /dev/null
+++ b/android/configs/hdcp-tx-2P2.cfg
@@ -0,0 +1,2 @@
+CONFIG_RTK_HDCP_1x=y
+
diff --git a/android/configs/hdcp-tx-TEE-disable.cfg b/android/configs/hdcp-tx-TEE-disable.cfg
new file mode 100755
index 00000000..96df6f7
--- /dev/null
+++ b/android/configs/hdcp-tx-TEE-disable.cfg
@@ -0,0 +1 @@
+# CONFIG_RTK_HDCP_1x_TEE is not set
diff --git a/android/configs/hdcp-tx-TEE.cfg b/android/configs/hdcp-tx-TEE.cfg
new file mode 100755
index 00000000..11db89d
--- /dev/null
+++ b/android/configs/hdcp-tx-TEE.cfg
@@ -0,0 +1 @@
+CONFIG_RTK_HDCP_1x_TEE=y
diff --git a/android/configs/tee-driver-disable.cfg b/android/configs/tee-driver-disable.cfg
new file mode 100644
index 00000000..accc7a8
--- /dev/null
+++ b/android/configs/tee-driver-disable.cfg
@@ -0,0 +1 @@
+# CONFIG_TEE is not set
diff --git a/android/configs/tee-driver-enable.cfg b/android/configs/tee-driver-enable.cfg
new file mode 100644
index 00000000..6a44aec
--- /dev/null
+++ b/android/configs/tee-driver-enable.cfg
@@ -0,0 +1 @@
+CONFIG_TEE=y
diff --git a/android/configs/vmx-drm-disable.cfg b/android/configs/vmx-drm-disable.cfg
new file mode 100755
index 00000000..e30c352
--- /dev/null
+++ b/android/configs/vmx-drm-disable.cfg
@@ -0,0 +1 @@
+# CONFIG_RTK_VMX_DRM is not set
diff --git a/android/configs/vmx-drm.cfg b/android/configs/vmx-drm.cfg
new file mode 100755
index 00000000..a7f3094
--- /dev/null
+++ b/android/configs/vmx-drm.cfg
@@ -0,0 +1 @@
+CONFIG_RTK_VMX_DRM=y
diff --git a/android/configs/vmx-ultra-boot-disable.cfg b/android/configs/vmx-ultra-boot-disable.cfg
new file mode 100755
index 00000000..74adb08
--- /dev/null
+++ b/android/configs/vmx-ultra-boot-disable.cfg
@@ -0,0 +1 @@
+# CONFIG_RTK_VMX_ULTRA is not set
diff --git a/android/configs/vmx-ultra-boot.cfg b/android/configs/vmx-ultra-boot.cfg
new file mode 100755
index 00000000..af85a2f
--- /dev/null
+++ b/android/configs/vmx-ultra-boot.cfg
@@ -0,0 +1 @@
+CONFIG_RTK_VMX_ULTRA=y
diff --git a/arch/Kconfig b/arch/Kconfig
index 659bdd0..0847b5d 100644
--- a/arch/Kconfig
+++ b/arch/Kconfig
@@ -489,6 +489,74 @@ config LD_DEAD_CODE_DATA_ELIMINATION
 	  sections (e.g., '.text.init'). Typically '.' in section names
 	  is used to distinguish them from label names / C identifiers.
 
+config LTO
+	def_bool n
+
+config ARCH_SUPPORTS_LTO_CLANG
+	bool
+	help
+	  An architecture should select this option it supports:
+	  - compiling with clang,
+	  - compiling inline assembly with clang's integrated assembler,
+	  - and linking with either lld or GNU gold w/ LLVMgold.
+
+choice
+	prompt "Link-Time Optimization (LTO) (EXPERIMENTAL)"
+	default LTO_NONE
+	help
+	  This option turns on Link-Time Optimization (LTO).
+
+config LTO_NONE
+	bool "None"
+
+config LTO_CLANG
+	bool "Use clang Link Time Optimization (LTO) (EXPERIMENTAL)"
+	depends on ARCH_SUPPORTS_LTO_CLANG
+	depends on !FTRACE_MCOUNT_RECORD || HAVE_C_RECORDMCOUNT
+	select LTO
+	select THIN_ARCHIVES
+	select LD_DEAD_CODE_DATA_ELIMINATION
+	help
+          This option enables clang's Link Time Optimization (LTO), which allows
+          the compiler to optimize the kernel globally at link time. If you
+          enable this option, the compiler generates LLVM IR instead of object
+          files, and the actual compilation from IR occurs at the LTO link step,
+          which may take several minutes.
+
+          If you select this option, you must compile the kernel with clang >=
+          5.0 (make CC=clang) and GNU gold from binutils >= 2.27, and have the
+          LLVMgold plug-in in LD_LIBRARY_PATH.
+
+endchoice
+
+config CFI
+	bool
+
+config CFI_PERMISSIVE
+	bool "Use CFI in permissive mode"
+	depends on CFI
+	help
+	  When selected, Control Flow Integrity (CFI) violations result in a
+	  warning instead of a kernel panic. This option is useful for finding
+	  CFI violations in drivers during development.
+
+config CFI_CLANG
+	bool "Use clang Control Flow Integrity (CFI) (EXPERIMENTAL)"
+	depends on LTO_CLANG
+	depends on KALLSYMS
+	select CFI
+	help
+	  This option enables clang Control Flow Integrity (CFI), which adds
+	  runtime checking for indirect function calls.
+
+config CFI_CLANG_SHADOW
+	bool "Use CFI shadow to speed up cross-module checks"
+	default y
+	depends on CFI_CLANG
+	help
+	  If you select this option, the kernel builds a fast look-up table of
+	  CFI check functions in loaded modules to reduce overhead.
+
 config HAVE_ARCH_WITHIN_STACK_FRAMES
 	bool
 	help
diff --git a/arch/alpha/include/uapi/asm/socket.h b/arch/alpha/include/uapi/asm/socket.h
index 9e46d6e..fa47df6a 100644
--- a/arch/alpha/include/uapi/asm/socket.h
+++ b/arch/alpha/include/uapi/asm/socket.h
@@ -97,4 +97,6 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif /* _UAPI_ASM_SOCKET_H */
diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index b5d529f..0ad1092 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -278,7 +278,12 @@ config PHYS_OFFSET
 			ARCH_INTEGRATOR || \
 			ARCH_IOP13XX || \
 			ARCH_KS8695 || \
-			ARCH_REALVIEW
+			ARCH_REALVIEW || \
+			ARCH_RTD119X || \
+			ARCH_RTD129x || \
+			ARCH_RTD139x || \
+			ARCH_RTD16xx || \
+			ARCH_RTD13xx
 	default 0x10000000 if ARCH_OMAP1 || ARCH_RPC
 	default 0x20000000 if ARCH_S5PV210
 	default 0xc0000000 if ARCH_SA1100
@@ -642,8 +647,24 @@ config ARCH_OMAP1
 	help
 	  Support for older TI OMAP1 (omap7xx, omap15xx or omap16xx)
 
+source "arch/arm/mach-rtd119x/Kconfig"
+
+source "arch/arm/mach-rtd129x/Kconfig"
+
+source "arch/arm/mach-rtd139x/Kconfig"
+
+source "arch/arm/mach-rtd16xx/Kconfig"
+
+source "arch/arm/mach-rtd13xx/Kconfig"
+
 endchoice
 
+config RTK_PLATFORM
+	def_bool n
+
+config RTK_PLATFORM_PSCI
+        def_bool n
+
 menu "Multiple platform selection"
 	depends on ARCH_MULTIPLATFORM
 
@@ -704,6 +725,7 @@ config ARCH_VIRT
 	select ARM_GIC_V2M if PCI
 	select ARM_GIC_V3
 	select ARM_PSCI
+	select ARM_PMUV3 if PERF_EVENTS
 	select HAVE_ARM_ARCH_TIMER
 
 #
@@ -819,6 +841,7 @@ source "arch/arm/mach-s3c64xx/Kconfig"
 source "arch/arm/mach-s5pv210/Kconfig"
 
 source "arch/arm/mach-exynos/Kconfig"
+
 source "arch/arm/plat-samsung/Kconfig"
 
 source "arch/arm/mach-shmobile/Kconfig"
@@ -840,6 +863,7 @@ source "arch/arm/mach-ux500/Kconfig"
 source "arch/arm/mach-versatile/Kconfig"
 
 source "arch/arm/mach-vexpress/Kconfig"
+
 source "arch/arm/plat-versatile/Kconfig"
 
 source "arch/arm/mach-vt8500/Kconfig"
@@ -1289,6 +1313,12 @@ endmenu
 
 menu "Kernel Features"
 
+config ARM_NORMAL_WORLD_OS
+        bool "Enable TrustZone"
+        default n
+        help
+		Enable TrustZone configuration
+
 config HAVE_SMP
 	bool
 	help
@@ -1836,6 +1866,15 @@ config XEN
 	help
 	  Say Y if you want to run Linux in a Virtual Machine on Xen on ARM.
 
+config ARM_FLUSH_CONSOLE_ON_RESTART
+	bool "Force flush the console on restart"
+	help
+	  If the console is locked while the system is rebooted, the messages
+	  in the temporary logbuffer would not have propogated to all the
+	  console drivers. This option forces the console lock to be
+	  released if it failed to be acquired, which will cause all the
+	  pending messages to be flushed.
+
 endmenu
 
 menu "Boot options"
@@ -1864,6 +1903,21 @@ config DEPRECATED_PARAM_STRUCT
 	  This was deprecated in 2001 and announced to live on for 5 years.
 	  Some old boot loaders still use this way.
 
+config BUILD_ARM_APPENDED_DTB_IMAGE
+	bool "Build a concatenated zImage/dtb by default"
+	depends on OF
+	help
+	  Enabling this option will cause a concatenated zImage and list of
+	  DTBs to be built by default (instead of a standalone zImage.)
+	  The image will built in arch/arm/boot/zImage-dtb
+
+config BUILD_ARM_APPENDED_DTB_IMAGE_NAMES
+	string "Default dtb names"
+	depends on BUILD_ARM_APPENDED_DTB_IMAGE
+	help
+	  Space separated list of names of dtbs to append when
+	  building a concatenated zImage-dtb.
+
 # Compressed boot loader in ROM.  Yes, we really want to ask about
 # TEXT and BSS so we preserve their values in the config files.
 config ZBOOT_ROM_TEXT
diff --git a/arch/arm/Kconfig.debug b/arch/arm/Kconfig.debug
index d83f7c3..11933ed 100644
--- a/arch/arm/Kconfig.debug
+++ b/arch/arm/Kconfig.debug
@@ -1246,6 +1246,15 @@ choice
 		  If you have a ZC702 board and want early boot messages to
 		  appear on the USB serial adaptor, select this option.
 
+	config DEBUG_LL_UART_NONE
+                bool "No low-level debugging UART"
+                depends on !ARCH_MULTIPLATFORM
+                help
+                  Say Y here if your platform doesn't provide a UART option
+                  below. This relies on your platform choosing the right UART
+                  definition internally in order for low-level debugging to
+                  work.
+
 	config DEBUG_ICEDCC
 		bool "Kernel low-level debugging via EmbeddedICE DCC channel"
 		help
@@ -1712,7 +1721,8 @@ config DEBUG_UNCOMPRESS
 config UNCOMPRESS_INCLUDE
 	string
 	default "debug/uncompress.h" if ARCH_MULTIPLATFORM || ARCH_MSM || \
-					PLAT_SAMSUNG || ARM_SINGLE_ARMV7M
+					PLAT_SAMSUNG || ARM_SINGLE_ARMV7M || \
+					RTK_PLATFORM
 	default "mach/uncompress.h"
 
 config EARLY_PRINTK
@@ -1723,6 +1733,14 @@ config EARLY_PRINTK
 	  kernel low-level debugging functions. Add earlyprintk to your
 	  kernel parameters to enable this console.
 
+config EARLY_PRINTK_DIRECT
+	bool "Early printk direct"
+	depends on DEBUG_LL
+	help
+	  Say Y here if you want to have an early console using the
+	  kernel low-level debugging functions and EARLY_PRINTK is
+	  not early enough.
+
 config ARM_KPROBES_TEST
 	tristate "Kprobes test module"
 	depends on KPROBES && MODULES
diff --git a/arch/arm/Makefile b/arch/arm/Makefile
index 6be9ee1..a03bd25 100644
--- a/arch/arm/Makefile
+++ b/arch/arm/Makefile
@@ -66,6 +66,7 @@ KBUILD_CFLAGS	+= $(call cc-option,-fno-ipa-sra)
 # testing for a specific architecture or later rather impossible.
 arch-$(CONFIG_CPU_32v7M)	=-D__LINUX_ARM_ARCH__=7 -march=armv7-m -Wa,-march=armv7-m
 arch-$(CONFIG_CPU_32v7)		=-D__LINUX_ARM_ARCH__=7 $(call cc-option,-march=armv7-a,-march=armv5t -Wa$(comma)-march=armv7-a)
+arch-$(CONFIG_CPU_32v8)		=-D__LINUX_ARM_ARCH__=7 $(call cc-option,-march=armv8-a,-march=armv7-a -Wa$(comma)-march=armv8-a)
 arch-$(CONFIG_CPU_32v6)		=-D__LINUX_ARM_ARCH__=6 $(call cc-option,-march=armv6,-march=armv5t -Wa$(comma)-march=armv6)
 # Only override the compiler option if ARMv6. The ARMv6K extensions are
 # always available in ARMv7
@@ -127,6 +128,10 @@ CFLAGS_ISA	:=$(call cc-option,-marm,)
 AFLAGS_ISA	:=$(CFLAGS_ISA)
 endif
 
+ifeq ($(CONFIG_THUMB2_KERNEL),y)
+CFLAGS_MODULE  +=-mlong-calls
+endif
+
 # Need -Uarm for gcc < 3.x
 KBUILD_CFLAGS	+=$(CFLAGS_ABI) $(CFLAGS_ISA) $(arch-y) $(tune-y) $(call cc-option,-mshort-load-bytes,$(call cc-option,-malignment-traps,)) -msoft-float -Uarm
 KBUILD_AFLAGS	+=$(CFLAGS_ABI) $(AFLAGS_ISA) $(arch-y) $(tune-y) -include asm/unified.h -msoft-float
@@ -148,6 +153,11 @@ endif
 textofs-$(CONFIG_ARCH_MSM8X60) := 0x00208000
 textofs-$(CONFIG_ARCH_MSM8960) := 0x00208000
 textofs-$(CONFIG_ARCH_AXXIA) := 0x00308000
+textofs-$(CONFIG_ARCH_RTD119X) := 0x00108000
+textofs-$(CONFIG_ARCH_RTD129x) := 0x00208000
+textofs-$(CONFIG_ARCH_RTD139x) := 0x00208000
+textofs-$(CONFIG_ARCH_RTD16xx) := 0x00208000
+textofs-$(CONFIG_ARCH_RTD13xx) := 0x00208000
 
 # Machine directory name.  This list is sorted alphanumerically
 # by CONFIG_* macro name.
@@ -222,6 +232,11 @@ machine-$(CONFIG_ARCH_W90X900)		+= w90x900
 machine-$(CONFIG_ARCH_ZX)		+= zx
 machine-$(CONFIG_ARCH_ZYNQ)		+= zynq
 machine-$(CONFIG_PLAT_SPEAR)		+= spear
+machine-$(CONFIG_ARCH_RTD119X)	+= rtd119x
+machine-$(CONFIG_ARCH_RTD129x)	+= rtd129x
+machine-$(CONFIG_ARCH_RTD139x)	+= rtd139x
+machine-$(CONFIG_ARCH_RTD16xx)  += rtd16xx
+machine-$(CONFIG_ARCH_RTD13xx)  += rtd13xx
 
 # Platform directory name.  This list is sorted alphanumerically
 # by CONFIG_* macro name.
@@ -235,6 +250,7 @@ plat-$(CONFIG_PLAT_PXA)		+= pxa
 plat-$(CONFIG_PLAT_S3C24XX)	+= samsung
 plat-$(CONFIG_PLAT_VERSATILE)	+= versatile
 
+
 ifeq ($(CONFIG_ARCH_EBSA110),y)
 # This is what happens if you forget the IOCS16 line.
 # PCMCIA cards stop working.
@@ -298,6 +314,8 @@ libs-y				:= arch/arm/lib/ $(libs-y)
 # Default target when executing plain make
 ifeq ($(CONFIG_XIP_KERNEL),y)
 KBUILD_IMAGE := xipImage
+else ifeq ($(CONFIG_BUILD_ARM_APPENDED_DTB_IMAGE),y)
+KBUILD_IMAGE := zImage-dtb
 else
 KBUILD_IMAGE := zImage
 endif
@@ -349,6 +367,9 @@ ifeq ($(CONFIG_VDSO),y)
 	$(Q)$(MAKE) $(build)=arch/arm/vdso $@
 endif
 
+zImage-dtb: vmlinux scripts dtbs
+	$(Q)$(MAKE) $(build)=$(boot) MACHINE=$(MACHINE) $(boot)/$@
+
 # We use MRPROPER_FILES and CLEAN_FILES now
 archclean:
 	$(Q)$(MAKE) $(clean)=$(boot)
diff --git a/arch/arm/boot/.gitignore b/arch/arm/boot/.gitignore
index 3c79f85..ad7a025 100644
--- a/arch/arm/boot/.gitignore
+++ b/arch/arm/boot/.gitignore
@@ -4,3 +4,4 @@ xipImage
 bootpImage
 uImage
 *.dtb
+zImage-dtb
\ No newline at end of file
diff --git a/arch/arm/boot/Makefile b/arch/arm/boot/Makefile
index 50f8d1be..da75630 100644
--- a/arch/arm/boot/Makefile
+++ b/arch/arm/boot/Makefile
@@ -16,6 +16,7 @@ OBJCOPYFLAGS	:=-O binary -R .comment -S
 ifneq ($(MACHINE),)
 include $(MACHINE)/Makefile.boot
 endif
+include $(srctree)/arch/arm/boot/dts/Makefile
 
 # Note: the following conditions must always be true:
 #   ZRELADDR == virt_to_phys(PAGE_OFFSET + TEXT_OFFSET)
@@ -29,6 +30,14 @@ export ZRELADDR INITRD_PHYS PARAMS_PHYS
 
 targets := Image zImage xipImage bootpImage uImage
 
+DTB_NAMES := $(subst $\",,$(CONFIG_BUILD_ARM_APPENDED_DTB_IMAGE_NAMES))
+ifneq ($(DTB_NAMES),)
+DTB_LIST := $(addsuffix .dtb,$(DTB_NAMES))
+else
+DTB_LIST := $(dtb-y)
+endif
+DTB_OBJS := $(addprefix $(obj)/dts/,$(DTB_LIST))
+
 ifeq ($(CONFIG_XIP_KERNEL),y)
 
 $(obj)/xipImage: vmlinux FORCE
@@ -55,6 +64,10 @@ $(obj)/compressed/vmlinux: $(obj)/Image FORCE
 $(obj)/zImage:	$(obj)/compressed/vmlinux FORCE
 	$(call if_changed,objcopy)
 
+$(obj)/zImage-dtb:	$(obj)/zImage $(DTB_OBJS) FORCE
+	$(call if_changed,cat)
+	@echo '  Kernel: $@ is ready'
+
 endif
 
 ifneq ($(LOADADDR),)
diff --git a/arch/arm/boot/compressed/head.S b/arch/arm/boot/compressed/head.S
index fc6d541..51fc9fb 100644
--- a/arch/arm/boot/compressed/head.S
+++ b/arch/arm/boot/compressed/head.S
@@ -781,6 +781,8 @@ __armv7_mmu_cache_on:
 		bic     r6, r6, #1 << 31        @ 32-bit translation system
 		bic     r6, r6, #(7 << 0) | (1 << 4)	@ use only ttbr0
 		mcrne	p15, 0, r3, c2, c0, 0	@ load page table pointer
+		mcrne	p15, 0, r0, c8, c7, 0	@ flush I,D TLBs
+		mcr	p15, 0, r0, c7, c5, 4	@ ISB
 		mcrne	p15, 0, r1, c3, c0, 0	@ load domain access control
 		mcrne   p15, 0, r6, c2, c0, 2   @ load ttb control
 #endif
diff --git a/arch/arm/boot/dts/Makefile b/arch/arm/boot/dts/Makefile
index 7037201..5b80a69 100644
--- a/arch/arm/boot/dts/Makefile
+++ b/arch/arm/boot/dts/Makefile
@@ -957,8 +957,24 @@ dtb-$(CONFIG_ARCH_ASPEED) += aspeed-bmc-opp-palmetto.dtb \
 	aspeed-ast2500-evb.dtb
 endif
 
+
+dts-dirs += realtek
+
+subdir-y	:= $(dts-dirs)
+
 dtstree		:= $(srctree)/$(src)
-dtb-$(CONFIG_OF_ALL_DTBS) := $(patsubst $(dtstree)/%.dts,%.dtb, $(wildcard $(dtstree)/*.dts))
+dtb-$(CONFIG_OF_ALL_DTBS) := $(patsubst $(dtstree)/%.dts,%.dtb,  $(foreach d,$(dts-dirs), $(wildcard $(dtstree)/*.dts)))
+
+
+DTB_NAMES := $(subst $\",,$(CONFIG_BUILD_ARM_APPENDED_DTB_IMAGE_NAMES))
+ifneq ($(DTB_NAMES),)
+DTB_LIST := $(addsuffix .dtb,$(DTB_NAMES))
+else
+DTB_LIST := $(dtb-y)
+endif
+
+targets += dtbs dtbs_install
+targets += $(DTB_LIST)
 
-always		:= $(dtb-y)
+always		:= $(DTB_LIST)
 clean-files	:= *.dtb
diff --git a/arch/arm/boot/dts/realtek/Makefile b/arch/arm/boot/dts/realtek/Makefile
new file mode 100644
index 00000000..39127ed
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/Makefile
@@ -0,0 +1,9 @@
+dts-dirs += rtd139x
+dts-dirs += rtd119x
+dts-dirs += rtd16xx
+dts-dirs += rtd13xx
+
+always		:= $(dtb-y)
+subdir-y	:= $(dts-dirs)
+clean-files	:= rtd119x/*.dtb rtd139x/*.dtb rtd16xx/*.dtb rtd13xx/*.dtb *.dtb
+
diff --git a/arch/arm/boot/dts/realtek/rtd119x/Makefile b/arch/arm/boot/dts/realtek/rtd119x/Makefile
new file mode 100644
index 00000000..d083704
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/Makefile
@@ -0,0 +1,11 @@
+dtb-$(CONFIG_ARCH_RTD119X) += \
+        rtd-119x-horseradish.dtb \
+        rtd-119x-horseradish-tee.dtb \
+        rtd-119x-qa-rescue.dtb \
+	rtd-119x-horseradish-nand.dtb \
+	rtd-119x-qa-rescue-nand.dtb
+
+
+always		:= $(dtb-y)
+subdir-y	:= $(dts-dirs)
+clean-files	:= *.dtb
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-1195-usb.dtsi b/arch/arm/boot/dts/realtek/rtd119x/rtd-1195-usb.dtsi
new file mode 100644
index 00000000..4f3ee64
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-1195-usb.dtsi
@@ -0,0 +1,30 @@
+
+/ {
+	/include/ "rtd-119x-usb.dtsi"
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+
+		status = "okay";
+	};
+
+	dwc3: rtk_dwc3@18013200 {
+		status = "okay";
+
+		dwc3@18020000 {
+			dr_mode = "host";
+		};
+	};
+
+	ehci@18013000 {
+		compatible = "Realtek,rtd119x-ehci";
+
+		status = "okay";
+	};
+
+	ohci@18013400 {
+		compatible = "Realtek,rtd119x-ohci";
+
+		status = "okay";
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-cpu-dvfs.dtsi b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-cpu-dvfs.dtsi
new file mode 100644
index 00000000..4254918
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-cpu-dvfs.dtsi
@@ -0,0 +1,113 @@
+/*
+ * RTD-119X Generic CPU DVFS
+ */
+#include <dt-bindings/thermal/thermal.h>
+
+/ {
+	cpu_supp: gpio-regulator {
+		compatible = "realtek,rtd119x-gpio-regulator";
+		gpios = <&rtk_iso_gpio 15 1 1>, <&rtk_iso_gpio 16 1 1>;
+		regulator-min-microvolt = <900000>;
+		regulator-max-microvolt = <1200000>;
+		regulator-boot-on;
+		regulator-always-on;
+		regulator-ramp-delay = <300>;
+		status = "okay";
+	};
+
+	cpu-sramctl {
+		compatible = "realtek,scpu-sramctl";
+		reg = <0x1801D000 0x4>;
+		cpu-supply = <&cpu_supp>;
+		status = "okay";
+	};
+};
+
+&cpu0 {
+	clocks = <&cc CC_PLL_SCPU>;
+	operating-points-v2 = <&cpu_opps>;
+	cpu-supply = <&cpu_supp>;
+	#cooling-cells = <2>;
+};
+
+&cpu1 {
+	clocks = <&cc CC_PLL_SCPU>;
+	operating-points-v2 = <&cpu_opps>;
+	cpu-supply = <&cpu_supp>;
+	#cooling-cells = <2>;
+};
+
+/* cpu opp table */
+&dvfs {
+	cpu_opps: cpu-opp-table-0 {
+		compatible = "operating-points-v2";
+		opp-shared;
+		opp290: opp-290mhz {
+			opp-hz = /bits/ 64 <290000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <500000>;
+			status = "okay";
+		};
+		opp300: opp-300mhz {
+			opp-hz = /bits/ 64 <300000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <500000>;
+			status = "okay";
+		};
+		opp390: opp-390mhz {
+			opp-hz = /bits/ 64 <390000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <500000>;
+			status = "okay";
+		};
+		opp400: opp-400mhz {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <500000>;
+			status = "okay";
+		};
+		opp500: opp-500mhz {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-microvolt = <1050000>;
+			clock-latency-ns = <500000>;
+			status = "okay";
+		};
+		opp600: opp-600mhz {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-microvolt = <1050000>;
+			clock-latency-ns = <500000>;
+			status = "okay";
+		};
+		opp720: opp-720mhz {
+			opp-hz = /bits/ 64 <720000000>;
+			opp-microvolt = <1050000>;
+			clock-latency-ns = <500000>;
+			status = "okay";
+		};
+		opp800: opp-800mhz {
+			opp-hz = /bits/ 64 <800000000>;
+			opp-microvolt = <1050000>;
+			clock-latency-ns = <500000>;
+			opp-suspend;
+			status = "okay";
+		};
+	};
+};
+
+&cpu_thermal {
+	trips {
+		tm_alert0: cpu-alert0 {
+			temperature = <105000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+	};
+	cooling-maps {
+		cpu-map0 {
+			trip = <&tm_alert0>;
+			cooling-device = <&cpu0 THERMAL_NO_LIMIT 1>;
+			contribution = <70>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish-nand.dts b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish-nand.dts
new file mode 100644
index 00000000..7d3ad91
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish-nand.dts
@@ -0,0 +1,196 @@
+/*
+ *
+ */
+
+/dts-v1/;
+
+#include "../../mach-rtd119x/include/mach/memory.h"
+
+/memreserve/ 0x00000000			SYS_BOOTCODE_MEMSIZE;
+/memreserve/ 0x0000c000                 0xf4000;
+/memreserve/ 0x17fff000                 0x1000;
+/memreserve/ PLAT_NOR_PHYS 	PLAT_NOR_SIZE;
+/memreserve/ ACPU_FIREWARE_PHYS 	ACPU_FIREWARE_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS 		RPC_RINGBUF_SIZE;
+/memreserve/ PLAT_SECURE_PHYS 	PLAT_SECURE_SIZE;
+/memreserve/ ION_AUDIO_HEAP_PHYS	ION_AUDIO_HEAP_SIZE;
+
+/*
+/memreserve/ 0x00000000		0xc000;
+/memreserve/ 0x18100000         0x1000000;
+/memreserve/ 0x01b00000		0x400000;
+/memreserve/ 0x01ffe000		0x4000;                                
+/memreserve/ 0x0ca00000		0x100000;
+/memreserve/ 0x0cb00000		0x3500000;
+/memreserve/ 0x10100000		0x7f00000;
+/memreserve/ 0x1e600000		0x1a00000;
+/memreserve/ 0x18100000		0x1a00000;
+*/
+#include "rtd-119x.dtsi"
+#include "rtd-1195-usb.dtsi"
+
+/ {
+	model= "Realtek_CA7_CA7";
+	compatible = "Realtek,FPGA_v6", "Realtek,rtd-119x";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 loglevel=4 clk_ignore_unused ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		linux,initrd-start = <0x02200000>;
+                linux,initrd-end = <0x02e00000>;
+	};
+
+	chosen {
+                cma-region-enable = <1>;
+                cma-region-info = <0x00000000 0x02000000 0x20000000>;
+        };
+	memory {
+		device_type = "memory";
+		reg =  <0x00000000 0x40000000>;	/* 1024 MB */
+	};
+
+
+	soc {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x18000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+
+	};
+	timer0@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	timer1@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	uart0: serial0@18007800 {
+		clock-frequency = <27000000>;
+	};
+	uart1: serial1@1801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@1801b100 {
+		gpios =
+		<&rtk_misc_gpio 4 0 0>,	/*install button, input, default N/A */
+		<&rtk_misc_gpio 8 1 1>;	/*audio dac unmute , output, default high */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@18007100 {
+ 		gpios = <&rtk_iso_gpio 13 1 1>;         /*wifi power , output, default high */
+	};
+	nic: gmac@18016000 {
+		rtl-features = <2>;
+//		mac-address = [00 10 20 30 40 50];
+		status = "okay";
+	};
+	crsd@18010400 {
+		gpios = <&rtk_misc_gpio 23 1 1>; 		/*sd power , output, default high  (poweroff) */
+	};
+	sb2@1801a000 {
+		status = "okay";
+	};
+	scpu_wrapper@1801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x1801d000 0x500>;
+		interrupts = <0 46 4>;
+	};
+	pmu {
+		status = "okay";
+	};
+
+	rfkill: rfkilligpio{   /* GPIO for rtk_rfkill to disable/enable BT */
+		compatible = "Realtek,rfkill";
+                gpios = <&rtk_iso_gpio 3 1 0>;                  /*bt enable , output, default low */
+                status = "okay";
+        };
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 {        /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+                        reg = <0>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@1 {        /* System contig */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <1>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@4 {        /* DMA_HEAP */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <4>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@8 {        /* Audio */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <8>;
+			rtk,memory-reserve = <ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE ION_AUDIO_HEAP_FLAG>;
+                };
+                rtk,ion-heap@7 {        /* TYPE_MEDIA */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 ION_MEDIA_HEAP_FLAG2
+				ION_MEDIA_HEAP_PHYS3 ION_MEDIA_HEAP_SIZE3 ION_MEDIA_HEAP_FLAG3
+				ION_MEDIA_HEAP_PHYS4 ION_MEDIA_HEAP_SIZE4 ION_MEDIA_HEAP_FLAG4
+			>;
+                };
+        };
+        fb {
+                compatible = "Realtek,rtk-fb";
+                buffer-cnt = <3>;
+                resolution = <1280 720>;
+                fps = <60>;
+        };
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+                };
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+                };
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+/*
+                gic@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "gic";
+			reg = <0xff010000 0x10000>;
+		};
+
+		spi@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "spi";
+			reg = <SPI_RBUS_PHYS SPI_RBUS_SIZE>;
+		};
+*/
+	};
+
+        nand@18010000 { status = "okay"; };
+        emmc@18012000 { status = "disabled"; };
+
+};
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish-rescue.dts b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish-rescue.dts
new file mode 100644
index 00000000..b301ec5
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish-rescue.dts
@@ -0,0 +1,173 @@
+/*
+ *
+ */
+
+/dts-v1/;
+
+#include "../../mach-rtd119x/include/mach/memory.h"
+
+/memreserve/ 0x00000000			SYS_BOOTCODE_MEMSIZE;				/* ROM code */
+/memreserve/ PLAT_NOR_PHYS 	PLAT_NOR_SIZE;						/* NOR */
+/memreserve/ ACPU_FIREWARE_PHYS 	ACPU_FIREWARE_SIZE;					/* Audio Firmware */
+/memreserve/ RPC_RINGBUF_PHYS 		RPC_RINGBUF_SIZE;					/* RPC ring buffer */
+
+#include "rtd-119x.dtsi"
+#include "rtd-1195-usb.dtsi"
+
+/ {
+	model= "Realtek_CA7_CA7";
+	compatible = "Realtek,FPGA_v6", "Realtek,rtd-119x";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x18007800 console=ttyS0,115200 loglevel=4 clk_ignore_unused";
+	        linux,initrd-start = <0x02200000>;
+        	linux,initrd-end = <0x02e00000>;
+	};
+
+	memory {
+		device_type = "memory";
+		reg =  <0x00000000 0x40000000>;					/* 1024 MB */
+	};
+
+
+	soc {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x18000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+
+	};
+	timer0@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	timer1@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	uart0: serial0@18007800 {
+		clock-frequency = <27000000>;
+	};
+	uart1: serial1@1801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@1801b100 {
+		gpios =
+		<&rtk_misc_gpio 4 0 0>, 				/*install button, input, default N/A */
+	//	<&rtk_misc_gpio 5 1 1>, 				/*usb3 power , output, default high */
+		<&rtk_misc_gpio 8 1 1>; 				/*audio dac unmute , output, default high */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@18007100 {
+ 		gpios = <&rtk_iso_gpio 13 1 1>;         /*wifi power , output, default high */
+	};
+	nic: gmac@18016000 {
+		rtl-features = <2>;
+//		mac-address = [00 10 20 30 40 50];
+		status = "okay";
+	};
+	usb_ss: rtk_dwc3@18013200 {
+		realtek,rst-gpio = <&rtk_misc_gpio 5 1 0>;		/*usb3 power , output, default low */
+		dwc3@18020000 {
+			dr_mode = "host";
+		};
+	};
+	crsd@18010400 {
+		gpios = <&rtk_misc_gpio 23 1 1>; 		/*sd power , output, default high  (poweroff) */
+	};
+	sb2@1801a000 {
+		status = "okay";
+	};
+	scpu_wrapper@1801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x1801d000 0x500>;
+		interrupts = <0 46 4>;
+	};
+    pmu {
+        status = "okay";
+    };
+	rtk,ion {
+                compatible = "Realtek,rtk-ion";
+                #address-cells = <1>;
+                #size-cells = <0>;
+
+                rtk,ion-heap@0 {        /* SYSTEM_HEAP */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <0>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@1 {        /* System contig */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <1>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@4 {        /* DMA_HEAP */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <4>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@8 {        /* Audio */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <8>;
+			rtk,memory-reserve = <ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE ION_AUDIO_HEAP_FLAG>;
+                };
+                rtk,ion-heap@7 {        /* TYPE_MEDIA */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 ION_MEDIA_HEAP_FLAG2
+				ION_MEDIA_HEAP_PHYS3 ION_MEDIA_HEAP_SIZE3 ION_MEDIA_HEAP_FLAG3
+				ION_MEDIA_HEAP_PHYS4 ION_MEDIA_HEAP_SIZE4 ION_MEDIA_HEAP_FLAG4
+			>;
+                };
+        };
+        fb {
+                compatible = "Realtek,rtk-fb";
+                buffer-cnt = <3>;
+                resolution = <1280 720>;
+                fps = <60>;
+        };
+	reserved-memory {
+                #address-cells = <1>;
+                #size-cells = <1>;
+                ranges;
+
+                rbus@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "rbus";
+                        reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+                        rtk_rbus_barrier_flag;
+                };
+
+                common@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "common";
+                        reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+                };
+
+                ringbuf@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "ringbuf";
+                        reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+                };
+/*
+                gic@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "gic";
+                        reg = <0xff010000 0x10000>;
+                };
+
+                spi@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "spi";
+                        reg = <SPI_RBUS_PHYS SPI_RBUS_SIZE>;
+                };
+*/
+        };
+};
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish-tee.dts b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish-tee.dts
new file mode 100755
index 00000000..24a5e03
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish-tee.dts
@@ -0,0 +1,206 @@
+/*
+ *
+ */
+
+/dts-v1/;
+
+#define CONFIG_ARM_NORMAL_WORLD_OS
+
+#include "../../mach-rtd119x/include/mach/memory.h"
+
+/memreserve/ 0x00000000			SYS_BOOTCODE_MEMSIZE;
+/memreserve/ 0x0000c000                 0xf4000;
+/memreserve/ 0x17fff000                 0x1000;
+/memreserve/ PLAT_NOR_PHYS 	PLAT_NOR_SIZE;
+/memreserve/ ACPU_FIREWARE_PHYS 	ACPU_FIREWARE_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS 		RPC_RINGBUF_SIZE;
+/memreserve/ PLAT_SECURE_PHYS 	PLAT_SECURE_SIZE;
+/memreserve/ ION_AUDIO_HEAP_PHYS	ION_AUDIO_HEAP_SIZE;
+/memreserve/ ION_MEDIA_HEAP_PHYS1   ION_MEDIA_HEAP_SIZE1;
+/memreserve/ ION_MEDIA_HEAP_PHYS2   ION_MEDIA_HEAP_SIZE2;
+/memreserve/ ION_MEDIA_HEAP_PHYS3   ION_MEDIA_HEAP_SIZE3;
+/memreserve/ ION_MEDIA_HEAP_PHYS4   ION_MEDIA_HEAP_SIZE4;
+/memreserve/ PLAT_SECUREOS_BASE_PHYS    PLAT_SECUREOS_SIZE;
+
+/*
+/memreserve/ 0x00000000		0xc000;
+/memreserve/ 0x18100000         0x1000000;
+/memreserve/ 0x01b00000		0x400000;
+/memreserve/ 0x01ffe000		0x4000;
+/memreserve/ 0x0ca00000		0x100000;
+/memreserve/ 0x0cb00000		0x3500000;
+/memreserve/ 0x10100000		0x7f00000;
+/memreserve/ 0x1e600000		0x1a00000;
+/memreserve/ 0x18100000		0x1a00000;
+*/
+#include "rtd-119x.dtsi"
+#include "rtd-1195-usb.dtsi"
+
+/ {
+	model= "Realtek_CA7_CA7";
+	compatible = "Realtek,FPGA_v6", "Realtek,rtd-119x";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x18007800 console=ttyS0,115200 loglevel=4 clk_ignore_unused";
+		linux,initrd-start = <0x02200000>;
+		linux,initrd-end = <0x02e00000>;
+	};
+
+	chosen {
+                cma-region-enable = <1>;
+                cma-region-info = <0x00000000 0x02000000 0x20000000>;
+        };
+	memory {
+		device_type = "memory";
+		reg =  <0x00000000 0x40000000>;	/* 1024 MB */
+	};
+
+	firmware {
+		optee {
+                       compatible = "linaro,optee-tz";
+                       method = "smc";
+                };
+	};
+
+	soc {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x18000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+
+	};
+	timer0@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	timer1@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	uart0: serial0@18007800 {
+		clock-frequency = <27000000>;
+	};
+	uart1: serial1@1801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@1801b100 {
+		gpios =
+		<&rtk_misc_gpio 4 0 0>,	/*install button, input, default N/A */
+		<&rtk_misc_gpio 8 1 1>;	/*audio dac unmute , output, default high */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@18007100 {
+                gpios = <&rtk_iso_gpio 13 1 1>;         /*wifi power , output, default high */
+	};
+	nic: gmac@18016000 {
+		rtl-features = <2>;
+//		mac-address = [00 10 20 30 40 50];
+		status = "okay";
+	};
+	crsd@18010400 {
+		gpios = <&rtk_misc_gpio 23 1 1>; 		/*sd power , output, default high  (poweroff) */
+	};
+	sb2@1801a000 {
+		status = "okay";
+	};
+	scpu_wrapper@1801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x1801d000 0x500>;
+		interrupts = <0 46 4>;
+	};
+	pmu {
+		status = "okay";
+	};
+
+	rfkill: rfkilligpio{   /* GPIO for rtk_rfkill to disable/enable BT */
+		compatible = "Realtek,rfkill";
+                gpios = <&rtk_iso_gpio 3 1 0>;                  /*bt enable , output, default low */
+                status = "okay";
+        };
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 {        /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+                        reg = <0>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@1 {        /* System contig */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <1>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@4 {        /* DMA_HEAP */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <4>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@8 {        /* Audio */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <8>;
+			rtk,memory-reserve = <ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE ION_AUDIO_HEAP_FLAG>;
+                };
+                rtk,ion-heap@7 {        /* TYPE_MEDIA */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 ION_MEDIA_HEAP_FLAG2
+				ION_MEDIA_HEAP_PHYS3 ION_MEDIA_HEAP_SIZE3 ION_MEDIA_HEAP_FLAG3
+				ION_MEDIA_HEAP_PHYS4 ION_MEDIA_HEAP_SIZE4 ION_MEDIA_HEAP_FLAG4
+			>;
+                };
+        };
+        fb {
+                compatible = "Realtek,rtk-fb";
+                buffer-cnt = <3>;
+                resolution = <1280 720>;
+                fps = <60>;
+        };
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+                };
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+                };
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+/*
+                gic@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "gic";
+			reg = <0xff010000 0x10000>;
+		};
+
+		spi@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "spi";
+			reg = <SPI_RBUS_PHYS SPI_RBUS_SIZE>;
+		};
+*/
+	};
+
+};
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish.dts b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish.dts
new file mode 100644
index 00000000..8466e4a
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-horseradish.dts
@@ -0,0 +1,193 @@
+/*
+ *
+ */
+
+/dts-v1/;
+
+#include "../../mach-rtd119x/include/mach/memory.h"
+
+/memreserve/ 0x00000000			SYS_BOOTCODE_MEMSIZE;
+/memreserve/ 0x0000c000                 0xf4000;
+/memreserve/ 0x17fff000                 0x1000;
+/memreserve/ PLAT_NOR_PHYS 	PLAT_NOR_SIZE;
+/memreserve/ ACPU_FIREWARE_PHYS 	ACPU_FIREWARE_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS 		RPC_RINGBUF_SIZE;
+/memreserve/ PLAT_SECURE_PHYS 	PLAT_SECURE_SIZE;
+/memreserve/ ION_AUDIO_HEAP_PHYS	ION_AUDIO_HEAP_SIZE;
+
+/*
+/memreserve/ 0x00000000		0xc000;
+/memreserve/ 0x18100000         0x1000000;
+/memreserve/ 0x01b00000		0x400000;
+/memreserve/ 0x01ffe000		0x4000;                                
+/memreserve/ 0x0ca00000		0x100000;
+/memreserve/ 0x0cb00000		0x3500000;
+/memreserve/ 0x10100000		0x7f00000;
+/memreserve/ 0x1e600000		0x1a00000;
+/memreserve/ 0x18100000		0x1a00000;
+*/
+#include "rtd-119x.dtsi"
+#include "rtd-1195-usb.dtsi"
+
+/ {
+	model= "Realtek_CA7_CA7";
+	compatible = "Realtek,FPGA_v6", "Realtek,rtd-119x";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x18007800 console=ttyS0,115200 loglevel=4 clk_ignore_unused";
+		linux,initrd-start = <0x02200000>;
+		linux,initrd-end = <0x02e00000>;
+	};
+
+	chosen {
+                cma-region-enable = <1>;
+                cma-region-info = <0x00000000 0x02000000 0x20000000>;
+        };
+	memory {
+		device_type = "memory";
+		reg =  <0x00000000 0x40000000>;	/* 1024 MB */
+	};
+
+
+	soc {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x18000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+
+	};
+	timer0@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	timer1@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	uart0: serial0@18007800 {
+		clock-frequency = <27000000>;
+	};
+	uart1: serial1@1801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@1801b100 {
+		gpios =
+		<&rtk_misc_gpio 4 0 0>,	/*install button, input, default N/A */
+		<&rtk_misc_gpio 8 1 1>;	/*audio dac unmute , output, default high */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@18007100 {
+ 		gpios = <&rtk_iso_gpio 13 1 1>;         /*wifi power , output, default high */
+	};
+	nic: gmac@18016000 {
+		rtl-features = <2>;
+//		mac-address = [00 10 20 30 40 50];
+		status = "okay";
+	};
+	crsd@18010400 {
+		gpios = <&rtk_misc_gpio 23 1 1>; 		/*sd power , output, default high  (poweroff) */
+	};
+	sb2@1801a000 {
+		status = "okay";
+	};
+	scpu_wrapper@1801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x1801d000 0x500>;
+		interrupts = <0 46 4>;
+	};
+	pmu {
+		status = "okay";
+	};
+
+	rfkill: rfkilligpio{   /* GPIO for rtk_rfkill to disable/enable BT */
+		compatible = "Realtek,rfkill";
+                gpios = <&rtk_iso_gpio 3 1 0>;                  /*bt enable , output, default low */
+                status = "okay";
+        };
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 {        /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+                        reg = <0>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@1 {        /* System contig */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <1>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@4 {        /* DMA_HEAP */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <4>;
+                        rtk,memory-reservation-size = <0x0>;
+                };
+                rtk,ion-heap@8 {        /* Audio */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <8>;
+			rtk,memory-reserve = <ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE ION_AUDIO_HEAP_FLAG>;
+                };
+                rtk,ion-heap@7 {        /* TYPE_MEDIA */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 ION_MEDIA_HEAP_FLAG2
+				ION_MEDIA_HEAP_PHYS3 ION_MEDIA_HEAP_SIZE3 ION_MEDIA_HEAP_FLAG3
+				ION_MEDIA_HEAP_PHYS4 ION_MEDIA_HEAP_SIZE4 ION_MEDIA_HEAP_FLAG4
+			>;
+                };
+        };
+        fb {
+                compatible = "Realtek,rtk-fb";
+                buffer-cnt = <3>;
+                resolution = <1280 720>;
+                fps = <60>;
+        };
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+                };
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+                };
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+/*
+                gic@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "gic";
+			reg = <0xff010000 0x10000>;
+		};
+
+		spi@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "spi";
+			reg = <SPI_RBUS_PHYS SPI_RBUS_SIZE>;
+		};
+*/
+	};
+
+};
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-irda.dtsi b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-irda.dtsi
new file mode 100644
index 00000000..822e11f
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-irda.dtsi
@@ -0,0 +1,51 @@
+/*
+ * rtd-1395-irda.dtsi - IRDA remote Device Tree Include file for REALTEK 1295 family SoC
+ */
+
+/ {
+	irda@18007400 {
+		irda_rx0 {
+			irrx-protocol = "NEC";
+			transcode-mode = <1>;
+
+			cust-code = <0x7F80>;
+			scancode-msk = <0x00FF0000>;
+			custcode-msk = <0x0000FFFF>;
+			keymap-tbl = <
+			// scancode	keycode
+				0x18 	116		//KEY_POWER		//POWER
+				0x5A 	353		//KEY_SELECT		//SOURCE
+				0x58 	154		//KEY_CYCLEWINDOWS	//PIP
+				0x1A 	377		//KEY_TV		//TV SYSTEM
+				0x14 	102		//KEY_HOME		//HOME
+				0x56 	357		//KEY_OPTION		//OPTION MENU
+				0x54	358		//KEY_INFO		//MEDIA_INFO
+				0x19 	232		//KEY_REPLY		//REPEAT
+				0x57 	158		//KEY_BACK		//RETURN
+				0x55 	207		//KEY_PLAY		//PLAY/PAUSE
+				0x17 	128		//KEY_STOP		//STOP
+				0x15 	372		//KEY_ZOOM		//ZOOM_IN
+				0x4F 	168		//KEY_REWIND		//FR
+				0x4D 	103		//KEY_UP		//UP
+				0x16 	208		//KEY_FASTFORWARD	//FF
+				0x0C 	105		//KEY_LEFT		//LEFT
+				0x4C 	352		//KEY_OK		//OK
+				0x0E 	106		//KEY_RIGHT		//RIGHT
+				0x08 	412		//KEY_PREVIOUS		//PREVIOUS
+				0x48 	108		//KEY_DOWN		//DOWN
+				0x09 	407		//KEY_NEXT		//NEXT
+				0x4B 	114		//KEY_VOLUMEDOWN	//VOL-
+				0x49 	115		//KEY_VOLUMEUP		//VOL+
+				0x0B 	532		//KEY_TOUCHPAD_OFF	//CURSOR
+				0x0A 	531		//KEY_TOUCHPAD_ON	//GESTURE
+				0xEEEE	0		//REL_X			//mouse X-axi	0xEEEE : REL event type
+				0xEEEE	1		//REL_Y			//mouse Y-axi	0xEEEE : REL event type
+				0xFFFF	272		//BTN_LEFT		//mouse left key	0xFFFF : KEY event type
+				0xFFFF	113     	//KEY_MUTE 		//mute key in AirFunAPP	0xFFFF : KEY event type	
+			>;
+			reg-ir-dpir = <50>;	/*IR detect interval, NEC default=50ms, should less than 100ms, and bigger than 9ms*/
+			sample-rate = <40>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-qa-rescue-nand.dts b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-qa-rescue-nand.dts
new file mode 100644
index 00000000..7f87a13
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-qa-rescue-nand.dts
@@ -0,0 +1,186 @@
+/*
+ *
+ */
+
+/dts-v1/;
+
+#include "../../mach-rtd119x/include/mach/memory.h"
+
+/memreserve/ 0x00000000			SYS_BOOTCODE_MEMSIZE;				/* ROM code */
+/memreserve/ PLAT_NOR_PHYS 	PLAT_NOR_SIZE;						/* NOR */
+/memreserve/ ACPU_FIREWARE_PHYS 	ACPU_FIREWARE_SIZE;					/* Audio Firmware */
+/memreserve/ RPC_RINGBUF_PHYS 		RPC_RINGBUF_SIZE;					/* RPC ring buffer */
+
+#include "rtd-119x.dtsi"
+#include "rtd-1195-usb.dtsi"
+
+/ {
+	model= "Realtek_CA7_CA7";
+	compatible = "Realtek,FPGA_v6", "Realtek,rtd-119x";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x18007800 console=ttyS0,115200 loglevel=4 clk_ignore_unused";
+	        linux,initrd-start = <0x02200000>;
+        	linux,initrd-end = <0x02e00000>;
+	};
+
+	memory {
+		device_type = "memory";
+		reg =  <0x00000000 0x40000000>;					/* 1024 MB */
+	};
+
+
+	soc {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x18000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+
+	};
+	timer0@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	timer1@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	uart0: serial0@18007800 {
+		clock-frequency = <27000000>;
+	};
+	uart1: serial1@1801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@1801b100 {
+		gpios =
+		<&rtk_misc_gpio 4 0 0>, 				/*install button, input, default N/A */
+	//	<&rtk_misc_gpio 5 1 1>, 				/*usb3 power , output, default high */
+		<&rtk_misc_gpio 8 1 1>; 				/*audio dac unmute , output, default high */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@18007100 {
+ 		gpios = <&rtk_iso_gpio 13 1 1>;         /*wifi power , output, default high */
+	};
+	nic: gmac@18016000 {
+		rtl-features = <2>;
+//		mac-address = [00 10 20 30 40 50];
+		status = "okay";
+	};
+	usb_ss: rtk_dwc3@18013200 {
+		realtek,rst-gpio = <&rtk_misc_gpio 5 1 0>;		/*usb3 power , output, default low */
+		dwc3@18020000 {
+			dr_mode = "host";
+		};
+	};
+	crsd@18010400 {
+		gpios = <&rtk_misc_gpio 23 1 1>; 		/*sd power , output, default high  (poweroff) */
+	};
+	sb2@1801a000 {
+		status = "okay";
+	};
+	scpu_wrapper@1801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x1801d000 0x500>;
+		interrupts = <0 46 4>;
+	};
+    pmu {
+        status = "okay";
+    };
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 {        /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+		rtk,ion-heap@1 {        /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+		rtk,ion-heap@4 {        /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+		rtk,ion-heap@8 {        /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE ION_AUDIO_HEAP_FLAG>;
+                };
+		rtk,ion-heap@7 {        /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 ION_MEDIA_HEAP_FLAG2
+				ION_MEDIA_HEAP_PHYS3 ION_MEDIA_HEAP_SIZE3 ION_MEDIA_HEAP_FLAG3
+				ION_MEDIA_HEAP_PHYS4 ION_MEDIA_HEAP_SIZE4 ION_MEDIA_HEAP_FLAG4
+			>;
+		};
+	};
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+	/*mem_remap {
+		compatible = "Realtek,rtk1195-mem_remap";
+		reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>,
+			<RPC_COMM_PHYS RPC_COMM_SIZE>,
+			<ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE>,
+			<0xff010000 0x10000>,
+			<RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>,
+			<0x18100000 0x01000000>;
+	};*/
+	reserved-memory {
+                #address-cells = <1>;
+                #size-cells = <1>;
+                ranges;
+
+                rbus@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "rbus";
+                        reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+                        rtk_rbus_barrier_flag;
+                };
+
+                common@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "common";
+                        reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+                };
+
+                ringbuf@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "ringbuf";
+                        reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+                };
+/*
+                gic@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "gic";
+                        reg = <0xff010000 0x10000>;
+                };
+
+                spi@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "spi";
+                        reg = <SPI_RBUS_PHYS SPI_RBUS_SIZE>;
+                };
+*/
+        };
+
+	nand@18010000 { status = "okay"; };
+        emmc@18012000 { status = "disabled"; };
+};
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-qa-rescue.dts b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-qa-rescue.dts
new file mode 100644
index 00000000..8bbef5f
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-qa-rescue.dts
@@ -0,0 +1,184 @@
+/*
+ *
+ */
+
+/dts-v1/;
+
+#include "../../mach-rtd119x/include/mach/memory.h"
+
+/memreserve/ 0x00000000			SYS_BOOTCODE_MEMSIZE;				/* ROM code */
+/memreserve/ PLAT_NOR_PHYS 	PLAT_NOR_SIZE;						/* NOR */
+/memreserve/ ACPU_FIREWARE_PHYS 	ACPU_FIREWARE_SIZE;					/* Audio Firmware */
+/memreserve/ RPC_RINGBUF_PHYS 		RPC_RINGBUF_SIZE;					/* RPC ring buffer */
+
+#include "rtd-119x.dtsi"
+#include "rtd-1195-usb.dtsi"
+
+/ {
+	model= "Realtek_CA7_CA7";
+	compatible = "Realtek,FPGA_v6", "Realtek,rtd-119x";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x18007800 console=ttyS0,115200 loglevel=4 clk_ignore_unused";
+	        linux,initrd-start = <0x02200000>;
+		linux,initrd-end = <0x02e00000>;
+	};
+
+	memory {
+		device_type = "memory";
+		reg =  <0x00000000 0x40000000>;					/* 1024 MB */
+	};
+
+
+	soc {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x18000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+
+	};
+	timer0@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	timer1@1801b000 {
+		clock-frequency = <27000000>;
+	};
+	uart0: serial0@18007800 {
+		clock-frequency = <27000000>;
+	};
+	uart1: serial1@1801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@1801b100 {
+		gpios =
+		<&rtk_misc_gpio 4 0 0>, 				/*install button, input, default N/A */
+	//	<&rtk_misc_gpio 5 1 1>, 				/*usb3 power , output, default high */
+		<&rtk_misc_gpio 8 1 1>; 				/*audio dac unmute , output, default high */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@18007100 {
+ 		gpios = <&rtk_iso_gpio 13 1 1>;         /*wifi power , output, default high */
+	};
+	nic: gmac@18016000 {
+		rtl-features = <2>;
+//		mac-address = [00 10 20 30 40 50];
+		status = "okay";
+	};
+	usb_ss: rtk_dwc3@18013200 {
+		realtek,rst-gpio = <&rtk_misc_gpio 5 1 0>;		/*usb3 power , output, default low */
+		dwc3@18020000 {
+			dr_mode = "host";
+		};
+	};
+	crsd@18010400 {
+		gpios = <&rtk_misc_gpio 23 1 1>; 		/*sd power , output, default high  (poweroff) */
+	};
+	sb2@1801a000 {
+		status = "okay";
+	};
+	scpu_wrapper@1801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x1801d000 0x500>;
+		interrupts = <0 46 4>;
+	};
+    pmu {
+        status = "okay";
+    };
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 {        /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+		rtk,ion-heap@1 {        /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+		rtk,ion-heap@4 {        /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+		rtk,ion-heap@8 {        /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE ION_AUDIO_HEAP_FLAG>;
+                };
+		rtk,ion-heap@7 {        /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 ION_MEDIA_HEAP_FLAG2
+				ION_MEDIA_HEAP_PHYS3 ION_MEDIA_HEAP_SIZE3 ION_MEDIA_HEAP_FLAG3
+				ION_MEDIA_HEAP_PHYS4 ION_MEDIA_HEAP_SIZE4 ION_MEDIA_HEAP_FLAG4
+			>;
+		};
+	};
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+	/*mem_remap {
+		compatible = "Realtek,rtk1195-mem_remap";
+		reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>,
+			<RPC_COMM_PHYS RPC_COMM_SIZE>,
+			<ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE>,
+			<0xff010000 0x10000>,
+			<RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>,
+			<0x18100000 0x01000000>;
+	};*/
+	reserved-memory {
+                #address-cells = <1>;
+                #size-cells = <1>;
+                ranges;
+
+                rbus@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "rbus";
+                        reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+                        rtk_rbus_barrier_flag;
+                };
+
+                common@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "common";
+                        reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+                };
+
+                ringbuf@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "ringbuf";
+                        reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+                };
+/*
+                gic@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "gic";
+                        reg = <0xff010000 0x10000>;
+                };
+
+                spi@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "spi";
+                        reg = <SPI_RBUS_PHYS SPI_RBUS_SIZE>;
+                };
+*/
+        };
+
+};
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-usb.dtsi b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-usb.dtsi
new file mode 100644
index 00000000..f894dcf
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x-usb.dtsi
@@ -0,0 +1,190 @@
+/*
+ * realtek,port0-power-gpio: port 0 power, output, default low
+ * realtek,port1-power-gpio: port 1 power, output, default low
+ * realtek,port2-power-gpio: port 2  power, output, default low
+ * realtek,port3-power-gpio: 1296 port 3 power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+
+rtk_usb_power_manager@0 {
+	compatible = "Realtek,usb-manager";
+	reg = <0x18000000 0x10>;
+
+	dis_hub_autosuspend;
+	en_usb_storage_reprobe; /* To enable usb storage re-probe*/
+	//rescue_usb; /* For rescue dtb use */
+
+	clocks = <&clk_en_1 4>; /* clk_en_usb */
+	clock-names = "clk_en_usb"; /*clk_en_usb*/
+
+	resets = <&rst_1 9>,
+		<&rst_1 8>,
+		<&rst_1 6>,
+		<&rst_1 4>,
+		<&rst_1 2>;
+	reset-names = "u2phy1",
+		"u2phy0",
+		"usb",
+		"u3phy0",
+		"u3mdio0";
+
+	gpio0: gpio0 {
+		realtek,power-gpio = <&rtk_misc_gpio 5 1 0>; /*usb3 power , output, default low */
+	};
+
+	port0 {
+		usb = <&dwc3>;
+		gpio = <&gpio0>;
+	};
+	port1 {
+		usb = <&ehci &ohci>;
+		//gpio = <&gpio1>;
+	};
+
+	//rtk_usb {
+	//};
+};
+
+dwc3_usb3phy: dwc3_usb3phy@0 {
+	compatible = "Realtek,usb3phy";
+	reg = <0x18013210 0x4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	phyN = <1>;
+	phy0 {
+		phy_data_size = <0x30>;
+		phy_data_addr = /bits/ 8
+			<0x00 0x01 0x02 0x03 0x04 0x05 0x06 0x07 0x08 0x09
+			0x0A 0x0B 0x0C 0x0D 0x0E 0x0F 0x10 0x11 0x12 0x13
+			0x14 0x15 0x16 0x17 0x18 0x19 0x1A 0x1B 0x1C 0x1D
+			0x1E 0x1F 0x20 0x21 0x22 0x23 0x24 0x25 0x26 0x27
+			0x28 0x29 0x2A 0x2B 0x2C 0x2D 0x2E 0x2F>;
+		phy_data_revA = /bits/ 16
+			<0x4008 0xA878 0x6046 0x2771 0xB2F5 0x2AD7 0x0001 0x3200 0x3590 0x325C
+			 0xD643 0xE909 0xC008 0xFF28 0x2010 0x8000 0x000C 0x4C00 0xFC00 0x0C81
+			 0xDE01 0x0000 0x0000 0x0000 0x0000 0x7004 0x1260 0xFF0C 0xCB1C 0xA03F
+			 0xC200 0x9000 0xD4FF 0xAAFF 0x0051 0xDB60 0x0800 0x0000 0x0004 0x01D6
+			 0xF882 0x3080 0x3083 0x2038 0xFFFF 0xFFFF 0x0000 0x0040>;
+		phy_data_revB = /bits/ 16
+			<0x4008 0xA878 0x6046 0x2771 0xB2F5 0x2AD7 0x0001 0x3200 0x3592 0x325C
+			 0xD643 0xA909 0xC008 0xFF28 0x2010 0x8000 0x000C 0x4C00 0xFC00 0x0C81
+			 0xDE01 0x0000 0x0000 0x0000 0x0000 0x3804 0x1260 0xFF0C 0xCB1C 0xA03F
+			 0xC200 0x9000 0xD4FF 0xAAFF 0x0051 0xDB60 0x0800 0x0000 0x0004 0x01D6
+			 0xF840 0x3080 0x3083 0x2038 0xFFFF 0xFFFF 0x0000 0x0040>;
+		phy_data_revC = /bits/ 16
+			<0x4008 0xA878 0x6046 0x2771 0xB2F5 0x2AD7 0x0001 0x3200 0x3592 0x325C
+			 0xD643 0xA909 0xC008 0xFF28 0x2010 0x8000 0x000C 0x4C00 0xFC00 0x0C81
+			 0xDE01 0x0000 0x0000 0x0000 0x0000 0x3804 0x1260 0xFF0C 0xCB1C 0xA03F
+			 0xC200 0x9000 0x94FF 0xAAFF 0x0051 0xDB60 0x0800 0x0000 0x0004 0x01D6
+			 0xF840 0x3080 0x3083 0x2038 0xFFFF 0xFFFF 0x0000 0x0040>;
+		phy_data_revD = /bits/ 16
+			<0x4008 0xA878 0x6046 0x2771 0xB2F5 0x2AD7 0x0001 0x3200 0x3592 0x325C
+			 0xD643 0xA909 0xC008 0xFF28 0x2010 0x8000 0x000C 0x4C00 0xFC00 0x0C81
+			 0xDE01 0x0000 0x0000 0x0000 0x0000 0x3804 0x1260 0xFF0C 0xCB1C 0xA03F
+			 0xC200 0x9000 0x94FF 0xAAFF 0x0051 0xDB60 0x0800 0x0000 0x0004 0x01D6
+			 0xF840 0x3080 0x3083 0x2038 0xFFFF 0xFFFF 0x0000 0x0040>;
+		//do_toggle;
+	};
+};
+
+dwc3_usb2phy: dwc3_usb2phy@0 {
+	compatible = "Realtek,usb2phy";
+	reg = <0x18028280 0x4>, <0x18013214 0x4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	phyN = <1>;
+	phy0 {
+		phy_data_page0_size = <16>;
+		phy_data_page0_addr = /bits/ 8
+			<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+			0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+		phy_data_page0_data = /bits/ 8
+			<0xA1 0x30 0x9A 0x8D 0xD6 0x1D 0xC0 0xB1 0xFC 0x9C
+			0x00 0x11 0x9B 0x81 0x00 0x02>;
+		phy_data_page1_size = <8>;
+		phy_data_page1_addr = /bits/ 8
+			<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+		phy_data_page1_data = /bits/ 8
+			<0x35 0xAF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+		//do_toggle;
+		//check_efuse;
+	};
+};
+
+dwc3: rtk_dwc3@18013200 {
+	compatible = "Realtek,dwc3";
+	reg = <0x18013200 0x200>;
+	interrupts = <0 21 4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	//delay_probe_work; //To delay probe work
+	//ordered_probe; // ordered probe in delay work
+
+	dwc3@18020000 {
+		compatible = "synopsys,dwc3";
+		reg = <0x18020000 0x9000>;
+		interrupts = <0 21 4>;
+		usb-phy = <&dwc3_usb2phy &dwc3_usb3phy>;
+		dr_mode = "host";		/* peripheral */
+		//tx-fifo-resize;
+		snps,dis_u2_susphy_quirk;
+	};
+};
+
+phy_rle0599: usb_phy_rle0599@0 {
+	compatible = "Realtek,rtd119x-usb_phy_rle0599";
+	reg = <0x18013824 0x4>, <0x180130A4 0x4>;
+	//Note reg addr: REG_WRAP_VStatusOut2, REG_EHCI_INSNREG05
+	phyN = <1>;
+	phy_data_page0_size = <16>;
+	phy_data_page0_addr = /bits/ 8
+		<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+		0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+	phy_data_page0_data = /bits/ 8
+		<0xA0 0x30 0x9A 0x8D 0xD6 0x1D 0xC0 0xB1 0xFC 0x9C
+		0x00 0x11 0x9B 0x81 0x00 0x02>;
+	phy_data_page1_size = <8>;
+	phy_data_page1_addr = /bits/ 8
+		<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+	phy_data_page1_data = /bits/ 8
+		<0x35 0xAF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+	//check_efuse;
+};
+
+ehci: ehci@18013000 {
+	compatible = "Realtek,rtd119x-ehci";
+	reg = <0x18013000 0x100>;
+	interrupts = <0 21 4>;
+	usb-phy = <&phy_rle0599>;
+	//delay_probe_work; //To delay probe work
+	//ordered_probe; // ordered probe in delay work
+	//fixed_async_list_addr_bug; // add to fixed async_list_addr bug
+};
+
+ohci: ohci@18013400 {
+	compatible = "Realtek,rtd119x-ohci";
+	reg = <0x18013400 0x100>;
+	interrupts = <0 21 4>;
+	usb-phy = <&phy_rle0599>;
+	//delay_probe_work; //To delay probe work
+	//ordered_probe; // ordered probe in delay work
+
+	//wrap_reg = <0x18013820>;
+};
+
+usb2_udc: usb2_udc@18038000 {
+	compatible = "Realtek,rtd119x-usb2-udc";
+	reg = <0x18038000 0x8000>, <0x18013800 0x80>;
+	interrupts = <0 21 4>;
+	usb-phy = <&phy_rle0599>;
+
+	status = "disable";
+};
+
+
diff --git a/arch/arm/boot/dts/realtek/rtd119x/rtd-119x.dtsi b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x.dtsi
new file mode 100644
index 00000000..674f40a
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd119x/rtd-119x.dtsi
@@ -0,0 +1,892 @@
+#include <dt-bindings/clock/rtk,clock-rtd119x.h>
+#include <dt-bindings/reset/rtk,reset-rtd119x.h>
+
+/include/ "rtd-119x-irda.dtsi"
+/ {
+	interrupt-parent = <&gic>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		cpu0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a7";
+			reg = <0x0>;
+			clock-frequency = <1000000000>;
+		};
+		cpu1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a7";
+			reg = <0x1>;
+			clock-frequency = <1000000000>;
+		};
+	};
+	timer {
+		compatible = "arm,armv7-timer";
+		interrupts = <1 13 0xf08>,			/* secure */
+			     <1 14 0xf08>;				/* non-secure */
+//			     <1 11 0xf08>,				/* virtual */
+//			     <1 10 0xf08>;				/* hypervisor */
+		clock-frequency = <27000000>;
+	};
+	gic: intc@ff01000 {
+		compatible = "arm,cortex-a9-gic";
+		#interrupt-cells = <3>;
+		interrupt-controller;
+		reg = <0xff011000 0x1000>,
+		      <0xff012000 0x1000>;
+	};
+
+	pinctrl: pinctrl@18007000 {
+		compatible = "rtk119x,rtk119x-pinctrl";
+		reg = <0x018000000 0x500>, <0x18007000 0x400>;
+		#gpio-range-cells = <3>;
+
+		pinctrl-names = "default";
+		pinctrl-0 = <&ir_rx_pins>,<&ir_tx_pins>,<&i2c_pins_0>,<&i2c_pins_1>,<&i2c_pins_5>,<&i2c_pins_6>,<&sdio_pins>,<&uart1_pins_loc_iso>,<&vfd_pins>,<&mmc_pins>;
+
+		nand_pins: nand@0 {
+			rtk119x,pins =
+			"nf_dd_0", 	"nf_dd_1",	"nf_dd_2", 	"nf_dd_3",	"nf_dd_4", 	"nf_dd_5",
+			"nf_dd_6", 	"nf_dd_7",	"nf_rdy", 		"nf_rd_n",	"nf_wr_n", 	"nf_ale",
+			"nf_cle", 		"nf_ce_n_0",	"nf_ce_n_1", 	"i2c_scl_5",	"i2c_sda_5";
+			rtk119x,function = "nand";
+			rtk119x,pull_en = <0>;
+		};
+		emmc_pins: emmc@0 {
+			rtk119x,pins=
+			"nf_dd_0", 	"nf_dd_1",	"nf_dd_2", 	"nf_dd_3",	"nf_dd_4", 	"nf_dd_5",
+			"nf_dd_6", 	"nf_dd_7",	"nf_rdy", 		"nf_rd_n",	"nf_cle";
+			rtk119x,function = "emmc";
+			rtk119x,pull_en = <0>;
+		};
+		hif_pins_loc_nf: hif@0 {
+			rtk119x,pins =
+			"nf_dd_4", 	"nf_wr_n",	"nf_ale", 		"nf_cle", 		"hi_loc";
+			rtk119x,function = "hif_loc_nf";
+			rtk119x,pull_en = <0>;
+		};
+		hif_pins_loc_misc: hif@1 {
+			rtk119x,pins =
+			"gpio_0", 	"gpio_1"	,	"gpio_2", 	"gpio_3", 	"hi_loc",	"sf_en";
+			rtk119x,function = "hif_loc_misc";
+			rtk119x,pull_en = <0>;
+		};
+		avcpu_ejtag_pins_loc_nf: avcpu_ejtag@0 {
+			rtk119x,pins =
+			"nf_dd_5", 	"nf_dd_6",	"nf_dd_7", 	"nf_rdy",		"nf_rd_n",	"ejtag_avcpu_loc";
+			rtk119x,function = "avcpu_ejtag_loc_nf";
+			rtk119x,pull_en = <0>;
+		};
+		avcpu_ejtag_pins_loc_iso: avcpu_ejtag@1 {
+			rtk119x,pins =
+			"usb0", 		"usb1",		"vfd_cs_n", 	"vfd_clk",		"vfd_d",		"ejtag_avcpu_loc";
+			rtk119x,function = "avcpu_ejtag_loc_iso";
+			rtk119x,pull_en = <0>;
+		};
+		i2c_pins_0: i2c@0 {
+			rtk119x,pins =
+			"i2c_scl_0", "i2c_sda_0";
+			rtk119x,function = "i2c0";
+			rtk119x,pull_en = <0>;
+
+//			rtk119x,schmitt = <1>;		//0: schmitt_disable, 1:schmitt_enable
+//			rtk119x,drive = <4>;		//drive current : 2=2mA  4=4mA 8=8mA
+//			rtk119x,pull_en = <1>;		//0: pull_disable, 1:pull_enable
+//			rtk119x,pull_sel = <1>;		//0: pull_low, 1:pull_high
+		};
+		i2c_pins_1: i2c@1 {
+			rtk119x,pins =
+			"i2c_scl_1", 	"i2c_sda_1";
+			rtk119x,function = "i2c1";
+			rtk119x,pull_en = <0>;
+		};
+		i2c_pins_2: i2c@2 {
+			rtk119x,pins =
+			"tp1_clk",		"tp1_sync",	"vfd_d";
+			rtk119x,function = "i2c2";
+			rtk119x,pull_en = <0>;
+		};
+		i2c_pins_3: i2c@3 {
+			rtk119x,pins =
+			"tp1_data", 	"tp1_valid";
+			rtk119x,function = "i2c3";
+			rtk119x,pull_en = <0>;
+		};
+		i2c_pins_4: i2c@4 {
+			rtk119x,pins =
+			"i2c_scl_4", 	"i2c_sda_4";
+			rtk119x,function = "i2c4";
+			rtk119x,pull_en = <0>;
+		};
+		i2c_pins_5: i2c@5 {
+			rtk119x,pins =
+			"i2c_scl_5",	"i2c_sda_5";
+			rtk119x,function = "i2c5";
+			rtk119x,pull_en = <0>;
+
+//			rtk119x,schmitt = <1>;		//0: schmitt_disable, 1:schmitt_enable
+//			rtk119x,drive = <2>;		//drive current : 2=2mA  4=4mA 8=8mA
+//			rtk119x,pull_en = <1>;		//0: pull_disable, 1:pull_enable
+//			rtk119x,pull_sel = <1>;		//0: pull_low, 1:pull_high
+		};
+		i2c_pins_6: i2c@6 {
+			rtk119x,pins =
+			"i2c_scl_6",	"i2c_sda_6";
+			rtk119x,function = "i2c6";
+			rtk119x,pull_en = <0>;
+		};
+		mmc_pins: mmc@0 {
+			rtk119x,pins =
+			"mmc_data_0", 	"mmc_data_1",	"mmc_data_2", 	"mmc_data_3",	"mmc_clk", 	"mmc_cmd",
+			"mmc_wp", 		"mmc_cd";
+			rtk119x,function = "mmc";
+			rtk119x,pull_en = <0>;
+		};
+		scpu_ejtag_pins_loc_cr: scpu_ejtag@0 {
+			rtk119x,pins =
+			"mmc_data_0", 	"mmc_data_3",	"mmc_clk", 	"mmc_cmd",	"mmc_wp",	"ejtag_scpu_loc";
+			rtk119x,function = "scpu_ejtag_loc_cr";
+			rtk119x,pull_en = <0>;
+		};
+		scpu_ejtag_pins_loc_misc: scpu_ejtag@1 {
+			rtk119x,pins =
+			"gpio_4", 		"gpio_5",			"gpio_6", 	"gpio_7",		"gpio_8",		"ejtag_scpu_loc";
+			rtk119x,function = "scpu_ejtag_loc_misc";
+			rtk119x,pull_en = <0>;
+		};
+		sdio_pins: sdio@0 {
+			rtk119x,pins =
+			"sdio_clk", 	"sdio_data_0",		"sdio_data_1", 	"sdio_data_2",		"sdio_data_3", 	"sdio_cmd";
+			rtk119x,function = "sdio";
+			rtk119x,pull_en = <0>;
+		};
+		tp1_pins: tp@1 {
+			rtk119x,pins =
+			"tp1_data", 	"tp1_clk",		"tp1_valid", 	"tp1_sync";
+			rtk119x,function = "tp1";
+			rtk119x,pull_en = <0>;
+		};
+		tp0_pins: tp@0 {
+			rtk119x,pins =
+			"tp0_data", 	"tp0_clk",		"tp0_valid", 	"tp0_sync";
+			rtk119x,function = "tp0";
+			rtk119x,pull_en = <0>;
+		};
+		ao_pins_loc_tp: ao@0 {
+			rtk119x,pins =
+			"tp0_data", 	"tp0_clk",		"tp0_valid", 	"tp0_sync",	"ao_loc";
+			rtk119x,function = "ao_loc_tp";
+			rtk119x,pull_en = <0>;
+		};
+		ao_pins_loc_misc: ao@1 {
+			rtk119x,pins =
+			"gpio_4", 	"gpio_5",		"gpio_6", 	"gpio_7",		"ao_loc";
+			rtk119x,function = "ao_loc_misc";
+			rtk119x,pull_en = <0>;
+		};
+		ai_pins_loc_iso_ur: ai@0 {
+			rtk119x,pins =
+			"ur1_rx", 	"ur1_tx",		"ur1_cts_n", 	"ur1_rts_n",	"ai_loc";
+			rtk119x,function = "ai_loc_iso_ur";
+			rtk119x,pull_en = <0>;
+		};
+		ai_pins_loc_iso_usb: ai@1 {
+			rtk119x,pins =
+			"usb0", 		"usb1",		"vfd_cs_n", 	"vfd_clk",		"ai_loc";
+			rtk119x,function = "ai_loc_iso_usb";
+			rtk119x,pull_en = <0>;
+		};
+
+		spdif_pins: spdif@0 {
+			rtk119x,pins =
+			"spdif";
+			rtk119x,function = "spdif";
+			rtk119x,pull_en = <0>;
+		};
+		spi_pins: spi@0 {
+			rtk119x,pins =
+			"gpio_0", 	"gpio_1"	,	"gpio_2", 	"gpio_3",		"sf_en";
+			rtk119x,function = "spi";
+			rtk119x,pull_en = <0>;
+		};
+		uart1_pins_loc_misc: uart1@0 {
+			rtk119x,pins =
+			"gpio_0", 	"gpio_1"	,	"gpio_2", 	"gpio_3",		"ur1_loc",	"sf_en";
+			rtk119x,function = "uart1_loc_misc";
+			rtk119x,pull_en = <0>;
+		};
+		uart1_pins_loc_iso: uart1@1 {
+			rtk119x,pins =
+			"ur1_rx", 	"ur1_tx",		"ur1_cts_n", 	"ur1_rts_n",	"ur1_loc";
+			rtk119x,function = "uart1_loc_iso";
+			rtk119x,pull_en = <0>;
+		};
+		uart0_pins: uart0@0 {
+			rtk119x,pins =
+			"ur0_rx", 	"ur0_tx";
+			rtk119x,function = "uart0";
+			rtk119x,pull_en = <0>;
+		};
+		gspi_pins: gspi@0 {
+			rtk119x,pins =
+			"gpio_0", 	"gpio_1"	,	"gpio_2", 	"gpio_3",		"sf_en";
+			rtk119x,function = "gspi";
+			rtk119x,pull_en = <0>;
+		};
+		hdmi_pins: hdmi@0 {
+			rtk119x,pins =
+			"hdmi_hpd";
+			rtk119x,function = "hdmi";
+			rtk119x,pull_en = <0>;
+		};
+		usb_pins: usb@0 {
+			rtk119x,pins=
+			"usb_id";
+			rtk119x,function = "usb";
+			rtk119x,pull_en = <0>;
+		};
+		sensor_pins: sensor@0 {
+			rtk119x,pins =
+			"sensor_cko_0", 	"sensor_cko_",	"sensor_rst", 		"sensor_stb_0",	"sensor_stb_1";
+			rtk119x,function = "sensor";
+			rtk119x,pull_en = <0>;
+		};
+		cpu_loop_test: cpu_loop_test@0 {
+			rtk119x,pins=
+			"usb_id";
+			rtk119x,function = "cpu_loop";
+			rtk119x,pull_en = <0>;
+		};
+		vfd_pins: vfd@0 {
+			rtk119x,pins =
+			"vfd_cs_n", 	"vfd_clk",		"vfd_d";
+			rtk119x,function = "vfd";
+			rtk119x,pull_en = <0>;
+		};
+		pwm_pins_0_L1: pwm0@0 {
+			rtk119x,pins =
+			"ur1_rx";
+			rtk119x,function = "pwm";
+			rtk119x,pull_en = <0>;
+		};
+		pwm_pins_1_L1: pwm1@0 {
+			rtk119x,pins =
+			"ur1_tx";
+			rtk119x,function = "pwm";
+			rtk119x,pull_en = <0>;
+		};
+		pwm_pins_2: pwm2@0 {
+			rtk119x,pins =
+			"ur0_tx";
+			rtk119x,function = "pwm";
+			rtk119x,pull_en = <0>;
+		};
+		pwm_pins_3: pwm3@0 {
+			rtk119x,pins =
+			"ur0_rx";
+			rtk119x,function = "pwm";
+			rtk119x,pull_en = <0>;
+		};
+		pwm_pins_0_L2: pwm4@0 {
+			rtk119x,pins =
+			"etn_led_link";
+			rtk119x,function = "pwm";
+			rtk119x,pull_en = <0>;
+		};
+		pwm_pins_1_L2: pwm5@0 {
+			rtk119x,pins =
+			"etn_led_rxtx";
+			rtk119x,function = "pwm";
+			rtk119x,pull_en = <0>;
+		};
+		ir_rx_pins: ir@0 {
+			rtk119x,pins =
+			"ir_rx";
+			rtk119x,function = "irrx";
+			rtk119x,pull_en = <0>;
+		};
+		ir_tx_pins: ir@1 {
+			rtk119x,pins =
+			"ir_tx";
+			rtk119x,function = "irtx";
+			rtk119x,pull_en = <0>;
+		};
+		etn_led_pins: etn_led@0 {
+			rtk119x,pins =
+			"etn_led_link", 	"etn_led_rxtx";
+			rtk119x,function = "etn_led";
+			rtk119x,pull_en = <0>;
+		};
+		standby_dbg_pins: standby_dbg@0 {
+			rtk119x,pins =
+			"usb0",	"usb1",   "ir_rx";
+			rtk119x,function = "standby_dbg";
+			rtk119x,pull_en = <0>;
+		};
+	};
+
+	i2c_0: i2c@0x18007D00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x18007D00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 8>;
+		i2c-num = <0>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iso_clk_en CLK_EN_I2C0>;
+		resets = <&iso_rst IRSTN_I2C_0>;
+	};
+	i2c_1: i2c@0x1801B300 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x1801B300 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 4>;
+		i2c-num = <1>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_1>;
+		resets = <&rst_2 RSTN_I2C_1>;
+	};
+	i2c_2: i2c@0x1801B700 {
+		compatible = "Realtek,rtk-i2c";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		reg = <0x1801B700 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 26>;
+		i2c-num = <2>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_2>;
+		resets = <&rst_2 RSTN_I2C_2>;
+	};
+	i2c_3: i2c@0x1801B900 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x1801B900 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 23>;
+		i2c-num = <3>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_3>;
+		resets = <&rst_2 RSTN_I2C_3>;
+	};
+	i2c_4: i2c@0x1801BA00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x1801BA00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 15>;
+		i2c-num = <4>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_4>;
+		resets = <&rst_2 RSTN_I2C_4>;
+	};
+	i2c_5: i2c@0x1801BB00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x1801BB00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 14>;
+		i2c-num = <5>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+		resets = <&rst_2 RSTN_I2C_5>;
+	};
+	i2c_6: i2c@0x18007E00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x18007E00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 10>;
+		i2c-num = <6>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iso_clk_en CLK_EN_I2C6>;
+		resets = <&iso_rst IRSTN_I2C_6>;
+	};
+
+	mux_intc: intc@1801b000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x1801b000 0x100>, <0x18007000 0x100>;		/* MISC_TOP MISC_ISO */
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@1801b100 {
+		compatible = "Realtek,rtk-misc-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;								/*must be the same with gpiochip.of_gpio_n_cells*/
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <60>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <0 19>, <0 20>;						/*GPIOA_INT   GPIODA_INT*/
+		reg = <0x1801b000 0x100>, <0x1801b100 0x100>;		/* MISC_SYS MISC_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 60>;
+	};
+
+
+	rtk_iso_gpio: rtk_iso_gpio@18007100 {
+		compatible = "Realtek,rtk-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <60>;
+		Realtek,gpio_numbers = <21>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <1 19>, <1 20>;						/*GPIOA_INT   GPIODA_INT*/
+		reg = <0x18007000 0x100>, <0x18007100 0x100>;		/* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 64 21>;
+	};
+
+	rst_1: soft-reset@18000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x18000000 0x4>;
+		#reset-cells = <1>;
+	};
+
+	rst_2: soft-reset@18000004 {
+		compatible = "realtek,reset-controller";
+		reg = <0x18000004 0x4>;
+		#reset-cells = <1>;
+	};
+
+	iso_rst: soft-reset@18007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x18007088 0x4>;
+		#reset-cells = <1>;
+	};
+
+	osc27M: osc27M {
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <27000000>;
+		clock-output-names = "osc27M";
+	};
+
+	clk_en_1: clk-en@1800000c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x1800000c 0x4>;
+		#clock-cells = <1>;
+		clock-output-names =
+			"",           "hdmirx",     "",           "gspi",
+			"usb",        "",           "",           "",
+			"hdmi",       "etn",        "",           "gpu",
+			"ve_h264",    "jpeg",       "",           "",
+			"",           "se",         "",           "cp",
+			"md",         "tp",         "",           "nf",
+			"emmc",       "cr",         "sdio_ip",    "mipi",
+			"emmic_ip",   "ve_h265",    "sdio",       "sd_ip";
+	};
+
+	clk_en_2: clk-en@18000010 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x18000010 0x4>;
+		#clock-cells = <1>;
+		clock-output-names =
+			"",           "misc_i2c_5", "",           "",
+			"vpu",        "",           "",           "",
+			"",           "misc_rtc",   "",           "",
+			"",           "misc_i2c_4", "misc_i2c_3", "misc_i2c_2",
+			"misc_i2c_1", "",           "",           "",
+			"",           "",           "",           "",
+			"",           "",           "",           "",
+			"ur1",        "",           "",           "";
+	};
+
+	iso_clk_en: clk-en@1800708c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x1800708c 0x4>;
+		#clock-cells = <1>;
+		clock-output-names =
+			"",           "",           "cec0",       "cbusrx_sys",
+			"cbustx_sys", "cbus_sys",   "cbus_osc",   "misc_ir",
+			"misc_ur0",   "i2c0",       "i2c6",       "etn_250m",
+			"etn_sys";
+	};
+
+	cc: clock-controller@18000000 {
+		compatible = "realtek,clock-controller";
+		reg = <0x18000000 0x1000>;
+		#clock-cells = <1>;
+	};
+
+    suspend@18007400 {
+        compatible = "Realtek,suspend";
+        suspend-mode = <0>; // 0:SUSPEND_TO_RAM 1:SUSPEND_TO_COOLBOOT 2:SUSPEND_TO_WFI
+        reg-restore = <0x18000000 0x18000004 0x18000008 0x1800000c 0x18000010>;
+        reg-restore-size = <5>;
+    };
+
+	timer0@1801b000 {
+		compatible = "Realtek,rtd119x-timer0";
+		reg = <0x1801b000 0x600>;
+		interrupts = <0 17 4>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+	};
+	timer1@1801b000 {
+		compatible = "Realtek,rtd119x-timer1";
+		reg = <0x1801b000 0x600>;
+		interrupts = <0 18 4>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+	};
+
+	rtk_wdt@1801b5b0 {
+		compatible = "Realtek,rtk-watchdog";
+		reg = <0x18007680 0x10>;
+	};
+
+	rtc@0x1801B600 {
+		compatible = "Realtek,rtk-rtc";
+		reg =   <0x1801B600 0x100>,
+			<0x18007000 0x100>;
+			rtc-base-year = <2016>;
+			status = "okay";
+		clocks = <&clk_en_2 CLK_EN_MISC_RTC>;
+		resets = <&rst_2 RSTN_RTC>;
+	};
+
+
+	refclk@1801b540 {
+		compatible = "Realtek,rtk119x-refclk";
+		reg = <0x1801b000 0x1000>;
+	};
+
+	uart0: serial0@18007800 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x18007800 0x400>, <0x18007000 0x100>;
+        interrupts-st-mask = <0x4>;
+		interrupts = <1 2>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+		clocks = <&iso_clk_en CLK_EN_MISC_UR0>;
+		resets = <&iso_rst IRSTN_UR0>;
+	};
+	uart1: serial1@1801B200 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x1801B200 0x100>, <0x1801b00c 0x100>;
+        interrupts-st-mask = <0x8>;
+		interrupts = <0 3>, <0 5>;	/*UR1_INT and UR1_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+		clocks = <&clk_en_2 CLK_EN_UR1>;
+		resets = <&rst_2 RSTN_UR1>;
+	};
+
+	irda@18007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x18007000 0x400>, <0x18007400 0x100>;
+		interrupts = <1 5>;
+//		pinctrl-names = "default";
+//		pinctrl-0 = <&i2c_pins_5>;
+//		status = "default";
+//		gpios = <&rtk_iso_gpio 7>;
+		clocks = <&iso_clk_en CLK_EN_MISC_IR>;
+		resets = <&iso_rst IRSTN_IR>;
+	};
+
+	se@1800c000 {
+		compatible = "realtek,se";
+		reg = <0x1800c000 0x600>;
+		interrupts = <0 20 4>;
+		clocks = <&clk_en_1 CLK_EN_SE>;
+		resets = <&rst_1 RSTN_SE>;
+	};
+
+	md@1800b000 {
+		compatible = "Realtek,rtk119x-md";
+		reg = <0x1800b000 0x100>;
+		interrupts = <0 38 4>;
+		clocks = <&clk_en_1 CLK_EN_MD>;
+		resets = <&rst_1 RSTN_MD>;
+	};
+
+	uio_rtk_ao {
+		compatible = "Realtek,uio_rtk_ao";
+		reg = <0x18000000 0x1000>, <0x18006000 0x1000>, <0x1800D000 0x1000>, <0x18071200 0x1000>;
+	};
+
+	fb {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x1E800000 0x1800000>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+	rpc@1801a104 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x1801a104 0xc>;
+		interrupts = <0 33 4>;
+	};
+	sb2@1801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x1801a000 0x900>;
+		interrupts = <0 36 4>;
+	};
+	hdmirx@1800F000 {
+		compatible = "Realtek,rtk119x-mipi-top";
+		reg = <0x1800F000 0x418>,<0x1800FB00 0x100>,<0x18037200 0xDC>,<0x18037300 0x14>,<0x1800F600 0x1c>,<0x18037400 0x40>,<0x1800F000 0x200>,<0x1800F200 0x60>,<0x1800F260 0xA0>,<0x1800F300 0xC0>,<0x1800F3C0 0x20>,<0x1800F3E0 0x10>,<0x1800d1b0 0x10>,<0x18037700 0x98>,<0x18037600 0x98>,<0x18004100 0x100>,<0x18004000 0xf0>,<0x1800FF00 0x28>, <0x1800FD00 0x50>;
+		interrupts = <0 23 4>;
+		gpio-rx-hpd-ctrl = <&rtk_iso_gpio 5 1 0>;
+		mipi_input_type = <1>;/* 0:camera in ;1:HDMI_RX in */
+		mipi_camera_type = <2>; /* 1:fixed pattern; 2:mipi camera*/
+		power-saving = <0>; /* 1:ON,0:OFF; Turn off RX when cable unplugged */
+//		status = "disabled";
+		gpio-rx-5v-detect {
+			compatible = "gpio-rx-5v-detect";
+			gpios =  <&rtk_iso_gpio 4 0 0>;
+			interrupt-parent = <&rtk_iso_gpio>;
+			interrupts = <4>;
+		};
+	};
+	nic: gmac@18016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x18016000 0x1000>;
+		interrupts = <0 22 4>;
+		rtl-config = <1>;
+		mac-version = <42>;		/* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>;		/* BIT(2) GMii */
+		led-cfg = <0x70CA>;
+		status = "okay";
+		clocks = <&clk_en_1 CLK_EN_ETN>,
+			<&iso_clk_en CLK_EN_ETN_250M>,
+			<&iso_clk_en CLK_EN_ETN_SYS>;
+		clock-names = "etn", "etn_250m", "etn_sys";
+		resets = <&rst_1 RSTN_ETN>;
+		reset-names = "rst_etn";
+	};
+	cec0@18007500 {
+		compatible = "Realtek,rtk-cec0";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x18007500 0xe0>,<0x18007040 0xa>;
+		interrupts = <1 22>;
+		module-enable = <0>;
+		status = "okay";
+	};
+	cec1@18037200 {
+	    compatible = "Realtek,rtk119x-cec1";
+	    reg = <0x18037200 0xf0>,<0x18007000 0xF00>,<0x18037500 0x10>;
+		interrupts = <0 34 4>;
+		module-enable = <1>;
+		status = "disabled";
+    };
+	hdmitx@1800D000 {
+		compatible = "realtek,rtd119x-hdmitx";
+		reg = <0x1800d000 0x400>;
+		gpio-hpd-detect = <&rtk_iso_gpio 6 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&rst_1 RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		status = "okay";
+	};
+	sdio@18010c00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 13 1 1>;
+		reg = <0x18010c00 0x200>,<0x18000000 0x200000>;
+		interrupts = <0 45 4>;
+		clocks = <&clk_en_1 CLK_EN_SDIO>, <&clk_en_1 CLK_EN_SDIO_IP>;
+		clock-names = "clk_en_sdio", "clk_en_sdio_ip";
+		resets = <&rst_2 RSTN_SDIO>;
+	};
+	nand@18010000 {
+		compatible = "Realtek,rtk1195-nand";
+		reg = <0x18010000 0x400>, /* NWC */
+		      <0x1802F000 0x400>; /* SWC */
+		clocks = <&clk_en_1 CLK_EN_NF>;
+		resets = <&rst_1 RSTN_NF>;
+		status = "disabled";
+	};
+        emmc@18012000 {
+                compatible = "Realtek,rtk119x-emmc";
+                reg = <0x18012000 0x400>,<0x18000000 0x400>,<0x18010400 0x200>,<0x1801A000 0x80>,<0x18010C00 0x40>;     /*EMMC CRT CRSD BS2 SDIO */
+                interrupts = <0 42 4>;
+                speed-step = <0>;                               /* 0: sdr50, 1: ddr50, 2: hs200 */
+		clocks = <&clk_en_1 CLK_EN_EMMC>, <&clk_en_1 CLK_EN_EMMC_IP>, <&clk_en_1 CLK_EN_CR>;
+		clock-names = "emmc", "emmc_ip", "cr";
+		resets = <&rst_2 RSTN_EMMC>;
+
+        };
+	sdmmc@18010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_misc_gpio 23 1 0>;
+		reg = <0x18000000 0x400>,<0x18010400 0x200>,<0x1801A000 0x80>,<0x18012000 0x10>,<0x18010C00 0x40>;	/*CRT CRSD BS2 EMMC SDIO */
+		interrupts = <0 44 4>;
+		clocks = <&clk_en_1 CLK_EN_CR>, <&clk_en_1 CLK_EN_SD_IP>;
+		clock-names = "clk_en_cr", "clk_en_sd_ip";
+		resets = <&rst_2 RSTN_CR>;
+	};
+
+	pmu {
+		compatible = "arm,cortex-a7-pmu";
+		interrupts = <0 48 4>, <0 49 4>;
+		status = "disabled";
+	};
+	vfd@18007200 {
+		compatible = "Realtek,rtk119x-vfd";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x18007000 0x100>, <0x18007200 0x100>;
+		interrupts = <1 15>,<1 16>,<1 17>,<1 18>;
+		clocks = <&iso_clk_en CLK_EN_MISC_VFD>;
+		resets = <&iso_rst IRSTN_VFD>;
+	};
+	mhltx@0x18037000 {
+		compatible = "Realtek,rtk119x-mhltx";
+		interrupts = <0 34 4>;
+		reg = <0x18037000 0x150>, <0x1800d000 0x400>;
+		status = "disabled";
+	};
+	hdcp@1800D000 {
+		compatible = "Realtek,rtk119x-hdcp";
+		reg = <0x1800d000 0x400>;
+		interrupts = <0 31 4>;   /*gen Ri*/
+	};
+	spi_0: spi@1801bd00 {
+		compatible = "Realtek,rtk119x-spi";
+		reg = <0x1801bd00 40>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins>;
+		spi-cs-gpio = <&rtk_misc_gpio 2 1 1>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		resets = <&rst_1 RSTN_GSPI>;
+		status = "disabled";
+	};
+	rtd1195-pwm@pwm {
+		compatible = "Realtek,rtd1195-pwm";
+		#pwm-cells = <2>;
+		pwm_idx = <0>;
+		enable = <0>;
+		duty_rate = <80>;
+		clksrc_div = <8>;
+		status = "disabled";
+	};
+	rtd1195-lsadc@0x1801bc00 {
+		compatible = "Realtek,rtd1195-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 21>;
+		status = "disabled";
+		rtd1195-lsadc-pad0@0 {
+			//compatible = "Realtek,rtd1195-lsadc-pad0";
+			activate = 	<1>;			/* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; 			/* 0: Voltage mode; 1:Current mode*/
+			sw_idx = 	<0>;			/* 0: External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>;	/* 8 bit : 0 ~ 255 */
+		};
+		rtd1195-lsadc-pad1@0 {
+			//compatible = "Realtek,rtd1195-lsadc-pad1";
+			activate = 	<1>;			/* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; 			/* 0: Voltage mode; 1:Current mode*/
+			sw_idx = 	<0>;			/* 0: External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>;	/* 8 bit : 0 ~ 255 */
+		};
+	};
+
+	mcp@0x18015000 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x18015000 0x1000>, <0x18014000 0x1000>;
+		interrupts = <0 2 4>;
+		clocks = <&clk_en_1 CLK_EN_CP>;
+		resets = <&rst_1 RSTN_CP>;
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x18000000 0x200000>;
+	};
+
+	nas_rtk_hub_params {
+		compatible = "Realtek,nas-rtk-hub-params";
+		applied_port = <0x4>; /* only apply to port3*/
+	};
+
+	efuse@18017000 {
+		compatible = "realtek,efuse";
+		reg = <0x18017000 0x400>;
+		read-only;
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		nvmem-cells = <&tcal0>, <&tcal1>;
+		nvmem-cell-names = "tc0", "tc1";
+
+		tcal1: thermal-calibration@1 {
+			reg = <0x1CA 0x2>;
+			bits = <2 7>;
+		};
+		tcal0: thermal-calibration@0 {
+			reg = <0x1CB 0x1>;
+			bits = <1 7>;
+		};
+	};
+
+	dvfs: cpu-dvfs {
+	};
+
+	cpu_tm: thermal-sensor@18000310 {
+		compatible = "realtek,rtd119x-thermal-sensor";
+		reg = <0x18000310 0x4>, <0x18000314 0x4>;
+		#thermal-sensor-cells = <0>;
+		status = "okay";
+		nvmem-cells = <&tcal0>, <&tcal1>;
+		nvmem-cell-names = "calibration0", "calibration1";
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+			trips {
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <0>;
+					type = "critical";
+				};
+			};
+			cooling-maps {};
+		};
+	};
+
+	gpu: gpu@18030000 {
+		compatible = "arm,mali-400", "arm,mali-utgard";
+		reg = <0x18003000 0x1000>;
+		clocks = <&cc CC_CLK_GPU>;
+		clock-names = "clk_mali";
+		resets = <&rst_1 RSTN_GPU>;
+		interrupts =
+			<0 24 4>, <0 25 4>,
+			<0 26 4>, <0 27 4>,
+			<0 28 4>, <0 29 4>;
+		interrupt-names =
+			"IRQGP", "IRQGPMMU",
+			"IRQPP0", "IRQPPMMU0",
+			"IRQPP1", "IRQPPMMU1";
+		status = "okay";
+	};
+	pu_pll@98000000 {
+                compatible = "Realtek,rtk1195-pu_pll";
+                reg = <0x18047000 0xC00>;
+		interrupts = <0 51 4>;	
+        };
+
+
+};
+
+#include "rtd-119x-cpu-dvfs.dtsi"
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/Makefile b/arch/arm/boot/dts/realtek/rtd139x/Makefile
new file mode 100644
index 00000000..2e14c3a
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/Makefile
@@ -0,0 +1,43 @@
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-avb.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-avb-ab.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-tee-vmx.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-avb-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-avb-tee-vmx.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-avb-tee-ab.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-1GB-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-2GB-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-qa-rescue-vmx.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB.atv.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB.atv-avb.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB.atv-avb-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1.5GB.atv-avb.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-papermulberry-glinux-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-papermulberry-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-1GB.atv-avb.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-1GB.atv-avb-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-384MB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-384MB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-512MB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-768MB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-avb-dp.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-avb-dp-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-glinux-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-glinux-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-glinux-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-glinux-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-glinux-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-nand-glinux-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-nand-glinux-2GB.dtb
+
+always		:= $(dtb-y)
+subdir-y	:= $(dts-dirs)
+clean-files	:= *.dtb
diff --git a/arch/arm/boot/dts/realtek/rtd139x/dtbo/rtd-1395-lionskin-overlay.dts b/arch/arm/boot/dts/realtek/rtd139x/dtbo/rtd-1395-lionskin-overlay.dts
new file mode 100644
index 00000000..7319544
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/dtbo/rtd-1395-lionskin-overlay.dts
@@ -0,0 +1,81 @@
+/dts-v1/;
+/plugin/;
+
+
+/ {
+	board_id = <0x0>;
+};
+
+
+&uart0 {
+	status = "okay";
+};
+
+&uart1 {
+	status = "okay";
+};
+
+&uart2{
+	status = "disabled";
+};
+
+&nic{
+	status = "okay";
+};
+
+&i2c_0{
+	status = "okay";
+};
+
+&i2c_1{
+	status = "okay";
+};
+
+&i2c_5{
+	status = "okay";
+};
+
+&spi_0{
+	status = "disabled";
+};
+
+&pwm{
+	status = "okay";
+};
+
+&sd{
+	status = "okay";
+};
+
+&sdio{
+	status = "okay";
+};
+
+&emmc{
+	status = "okay";
+};
+
+&gpu{
+	status = "okay";
+};
+
+&cpu_tm{
+	status = "okay";
+};
+
+&md{
+	status = "okay";
+};
+
+&se{
+	status = "okay";
+};
+
+&jpeg{
+	status = "okay";
+};
+
+&ve1{
+	status = "okay";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/dtbo/rtd-139x-dtboimg.cfg b/arch/arm/boot/dts/realtek/rtd139x/dtbo/rtd-139x-dtboimg.cfg
new file mode 100644
index 00000000..3611ed9
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/dtbo/rtd-139x-dtboimg.cfg
@@ -0,0 +1,3 @@
+#global options
+rtd-1395-lionskin-overlay.dtbo
+    id=/:board_id
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-1GB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-1GB.dts
new file mode 100644
index 00000000..22c0fe8
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-1GB.dts
@@ -0,0 +1,217 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0b800000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_1GB";
+	model_hex= <0x0000054B>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-2GB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-2GB.dts
new file mode 100644
index 00000000..5353d48
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-2GB.dts
@@ -0,0 +1,216 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_2GB";
+	model_hex= <0x0000054B>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub.dtsi
new file mode 100644
index 00000000..f429311
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-139x.dtsi"
+#include "rtd-139x-dvfs.dtsi"
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-qa-rescue.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-qa-rescue.dts
new file mode 100644
index 00000000..503de43
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1355-qa-rescue.dts
@@ -0,0 +1,189 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-139x.dtsi"
+
+/ {
+	model= "Realtek_RTD1355";
+	model_hex= <0x0000054B>;
+	compatible = "realtek,rtd1355";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-1GB-qa-rescue-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-1GB-qa-rescue-tee.dts
new file mode 100644
index 00000000..aca663c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-1GB-qa-rescue-tee.dts
@@ -0,0 +1,244 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12c00000;
+
+#define SECURE_AUDIO_SIZE               (0x00200000) // 2MB
+#define SECURE_MD_SIZE                  (0x00100000) // 1MB
+#define SECURE_HEAP_SIZE_0              (0x04600000) // 70MB
+
+#define ION_SECURE_AUDIO_PHYS_0         (0x20800000)
+#define ION_SECURE_AUDIO_SIZE_0         (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0         (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0            (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0            (SECURE_MD_SIZE)
+
+#define ION_SECURE_HEAP_PHYS_0          (ION_SECURE_MD_PHYS_0 + ION_SECURE_MD_SIZE_0)
+#define ION_SECURE_HEAP_SIZE_0          (SECURE_HEAP_SIZE_0)
+#define ION_SECURE_HEAP_FLAG_0          (RTK_FLAG_HWIPACC)
+
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+#include "rtd-139x.dtsi"
+
+/ {
+	model= "Realtek_RTD1395";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				compatible = "android,fstab";
+				/*
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				*/
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait,avb";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+				ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+				>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-2GB-qa-rescue-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-2GB-qa-rescue-tee.dts
new file mode 100644
index 00000000..6b4f1f2
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-2GB-qa-rescue-tee.dts
@@ -0,0 +1,212 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-139x-ion-2GB-tee.dtsi"
+#include "rtd-139x.dtsi"
+
+/ {
+	model= "Realtek_RTD1395";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				compatible = "android,fstab";
+				/*
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				*/
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait,avb";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.CMAx2.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.CMAx2.dts
new file mode 100755
index 00000000..9119846
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.CMAx2.dts
@@ -0,0 +1,219 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-avb-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-avb-tee.dts
new file mode 100644
index 00000000..3fff2fe
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-avb-tee.dts
@@ -0,0 +1,12 @@
+#include "rtd-1395-arete-1GB.atv-tee.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_ARETE_1GB_AVB";
+	rtk_dwc3_drd@98013200 {
+		rtk_dwc3_drd_type_c@0 {
+			/delete-property/ drd_mode;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-avb.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-avb.dts
new file mode 100644
index 00000000..cdeff9b
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-avb.dts
@@ -0,0 +1,12 @@
+#include "rtd-1395-arete-1GB.atv.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_ARETE_1GB_AVB";
+	rtk_dwc3_drd@98013200 {
+		rtk_dwc3_drd_type_c@0 {
+			/delete-property/ drd_mode;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-tee.dts
new file mode 100644
index 00000000..20227aa
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-tee.dts
@@ -0,0 +1,266 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_30MB_PHYS TEE_OS_30MB_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_AUDIO_SIZE               (0x00200000) // 2MB
+#define SECURE_MD_SIZE                  (0x00100000) // 1MB
+#define SECURE_HEAP_SIZE_0              (0x04600000) // 70MB
+
+#define ION_SECURE_AUDIO_PHYS_0         (0x20800000)
+#define ION_SECURE_AUDIO_SIZE_0         (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0         (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0            (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0            (SECURE_MD_SIZE)
+
+#define ION_SECURE_HEAP_PHYS_0          (ION_SECURE_MD_PHYS_0 + ION_SECURE_MD_SIZE_0)
+#define ION_SECURE_HEAP_SIZE_0          (SECURE_HEAP_SIZE_0)
+#define ION_SECURE_HEAP_FLAG_0          (RTK_FLAG_HWIPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0      ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0      ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 loop.max_part=7";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x12000000 0x09400000>; /* offset 288MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+				ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+				>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv.dts
new file mode 100644
index 00000000..95ed821
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv.dts
@@ -0,0 +1,239 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 loop.max_part=7";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.dts
new file mode 100755
index 00000000..8e3ecc4
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.dts
@@ -0,0 +1,204 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.CMAx2.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.CMAx2.dts
new file mode 100755
index 00000000..ff6da39
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.CMAx2.dts
@@ -0,0 +1,240 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_384MB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		saving-section-page-table = <1>;
+		reg = <0 0x18000000>; /* 384 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x04400000 0x09400000>; /* offset 68MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x0f000000 0x00800000>; /* offset 240MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.dts
new file mode 100755
index 00000000..08c4180
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.dts
@@ -0,0 +1,235 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0c700000) // 199M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03C00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (0x10100000) // over-lay with tee region, please remove tee reserved region in bootcode
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_384MB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		saving-section-page-table = <1>;
+		reg = <0 0x18000000>; /* 384 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x15000000 0x00800000>; /* offset 336MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-512MB.CMAx2.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-512MB.CMAx2.dts
new file mode 100755
index 00000000..837c834
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-512MB.CMAx2.dts
@@ -0,0 +1,239 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_512MB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		saving-section-page-table = <1>;
+		reg = <0 0x20000000>; /* 512 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x04400000 0x09400000>; /* offset 68MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x0f000000 0x00800000>; /* offset 240MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-768MB.CMAx2.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-768MB.CMAx2.dts
new file mode 100755
index 00000000..9a20bb29
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-768MB.CMAx2.dts
@@ -0,0 +1,239 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_768MB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		saving-section-page-table = <1>;
+		reg = <0 0x38000000>; /* 768 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x04400000 0x09400000>; /* offset 68MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x0f000000 0x00800000>; /* offset 240MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-rescue.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-rescue.dts
new file mode 100755
index 00000000..eaf39c1
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete-rescue.dts
@@ -0,0 +1,191 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x0d500000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_384MB";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x18000000>; /* 384 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete.dtsi
new file mode 100644
index 00000000..3605d65
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-arete.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-139x.dtsi"
+#include "rtd-139x-dfs.dtsi"
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1.5GB.atv-avb.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1.5GB.atv-avb.dts
new file mode 100644
index 00000000..54869a2
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1.5GB.atv-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-1.5GB.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1.5GB_AVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1.5GB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1.5GB.dts
new file mode 100644
index 00000000..b508dcb
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1.5GB.dts
@@ -0,0 +1,191 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_3.5GB";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x60000000>; /* 1536 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.CMAx2.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.CMAx2.dts
new file mode 100755
index 00000000..197752d
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.CMAx2.dts
@@ -0,0 +1,227 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x03000000) // 48M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#define SHARED_DMA_POOL_ALIGNMENT (0x400000)
+#define SHARED_DMA_POOL_SIZE(s) ((s) - ((s) & (SHARED_DMA_POOL_ALIGNMENT - 1)))
+
+#define SHARED_DMA_POOL_SIZE_0 SHARED_DMA_POOL_SIZE(0x0ce00000) // 206MB
+#define SHARED_DMA_POOL_SIZE_1 SHARED_DMA_POOL_SIZE(0x03C00000) // 60MB
+
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc androidboot.serialno=hercules loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,ion_0 {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <SHARED_DMA_POOL_SIZE_0>;
+			alignment = <SHARED_DMA_POOL_ALIGNMENT>;
+			linux,contiguous-region;
+		};
+
+		linux,ion_1 {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <SHARED_DMA_POOL_SIZE_1>;
+			alignment = <SHARED_DMA_POOL_ALIGNMENT>;
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+            rtk,use-cma-pools;
+            rtk,cma-pools-skip-dma-default-array;
+            rtk,cma-pool-flags=<(RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | RTK_FLAG_HWIPACC)>;
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-avb-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-avb-tee.dts
new file mode 100644
index 00000000..5e94f95
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-avb-tee.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-1GB.atv-tee.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB_AVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-avb.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-avb.dts
new file mode 100644
index 00000000..9c2dbd2
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-1GB.atv.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB_AVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-tee.dts
new file mode 100644
index 00000000..85292fd
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-tee.dts
@@ -0,0 +1,265 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_30MB_PHYS TEE_OS_30MB_SIZE;
+
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_AUDIO_SIZE               (0x00200000) // 2MB
+#define SECURE_MD_SIZE                  (0x00100000) // 1MB
+#define SECURE_HEAP_SIZE_0              (0x05600000) // 86MB
+
+#define ION_SECURE_AUDIO_PHYS_0         (0x20800000)
+#define ION_SECURE_AUDIO_SIZE_0         (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0         (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0            (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0            (SECURE_MD_SIZE)
+
+#define ION_SECURE_HEAP_PHYS_0          (ION_SECURE_MD_PHYS_0 + ION_SECURE_MD_SIZE_0)
+#define ION_SECURE_HEAP_SIZE_0          (SECURE_HEAP_SIZE_0)
+#define ION_SECURE_HEAP_FLAG_0          (RTK_FLAG_HWIPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0      ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0      ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 loop.max_part=7";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x12000000 0x09400000>; /* offset 288MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+				ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+				>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+};
+
+&ve1 {
+	assigned-clocks =        <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>;
+	assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>;
+	assigned-clock-rates =   <459000000>,      <567000000>;
+};
+
+&gpu {
+	assigned-clocks =      <&cc CC_PLL_GPU>;
+	assigned-clock-rates = <600000000>;
+};
+&gopp300 {
+	status = "okay";
+};
+&gopp400 {
+	status = "okay";
+};
+&gopp500 {
+	status = "okay";
+};
+/delete-node/ &gopp700;
+/delete-node/ &gopp750;
+/delete-node/ &opp1400;
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv.dts
new file mode 100644
index 00000000..1fc9a27
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv.dts
@@ -0,0 +1,207 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x08700000) // 135M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x09000000) // 144M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-ab.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-ab.dts
new file mode 100644
index 00000000..99b0c9e
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-ab.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-2GB-tee.dts"
+#include "rtd-139x-avb-ab.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB_AVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-dp-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-dp-tee.dts
new file mode 100644
index 00000000..790037a
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-dp-tee.dts
@@ -0,0 +1,19 @@
+#include "rtd-1395-lionskin-2GB-tee.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB_AVB";
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				/delete-node/ system;
+				/delete-node/ vendor;
+			};
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-dp.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-dp.dts
new file mode 100644
index 00000000..78b90bc
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-dp.dts
@@ -0,0 +1,19 @@
+#include "rtd-1395-lionskin-2GB.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB_AVB";
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				/delete-node/ system;
+				/delete-node/ vendor;
+			};
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee-ab.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee-ab.dts
new file mode 100644
index 00000000..7363de4
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee-ab.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-2GB-tee-ab.dts"
+#include "rtd-139x-avb-ab.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB_AVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee-vmx.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee-vmx.dts
new file mode 100644
index 00000000..cf7b811
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee-vmx.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-2GB-tee-vmx.dts"
+#include "rtd-139x-avb-vmx.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB_AVB_VMX";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee.dts
new file mode 100644
index 00000000..fe48bc0
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-2GB-tee.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB_AVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb.dts
new file mode 100644
index 00000000..597261a
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-2GB.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB_AVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee-ab.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee-ab.dts
new file mode 100644
index 00000000..32b3453
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee-ab.dts
@@ -0,0 +1,173 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-139x-ion-2GB-tee.dtsi"
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait,slotselect";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait,slotselect";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee-vmx.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee-vmx.dts
new file mode 100644
index 00000000..3cdeecf
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee-vmx.dts
@@ -0,0 +1,173 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-139x-ion-2GB-tee-vmx.dtsi"
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee.dts
new file mode 100644
index 00000000..193bbb8
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee.dts
@@ -0,0 +1,173 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-139x-ion-2GB-tee.dtsi"
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB.dts
new file mode 100644
index 00000000..5c8300b
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB.dts
@@ -0,0 +1,191 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-1GB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-1GB.dts
new file mode 100644
index 00000000..1856df3
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-1GB.dts
@@ -0,0 +1,177 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0b800000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB-tee.dts
new file mode 100644
index 00000000..333e29c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB-tee.dts
@@ -0,0 +1,159 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-139x-ion-2GB-tee.dtsi"
+#include "rtd-1395-lionskin.dtsi"
+
+
+/ {
+    model= "Realtek_Lion_Skin_2GB";
+    model_hex= <0x00000573>;
+
+    /*
+     * NOTE:
+     * <flag size base>
+     * flag: reserved
+     * size: unit is byte
+     * base: unit is byte
+     *
+     * Array size not over 8;
+     * You may change the max array size in KConfig,
+     * max CMA array size is CONFIG_CMA_AREAS+1.
+     *
+     * If cma-region-enable is enabled<1>,
+     * kernel driver will use cma-region-info to initial CMA memory.
+     *
+     * If cma-region-enable is disabled<0>,
+     * kernel driver will use cma= to initial CMA memory.
+     *
+     * if both setting is loaded, cma-region-info had higher priority.
+     */
+
+    chosen {
+        linux,initrd-start = <ROOTFS_NORMAL_START>;
+        linux,initrd-end = <ROOTFS_NORMAL_END>;
+        bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+        swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+        swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+        cma-region-enable = <1>;
+        cma-region-info = <0x00000000 0x02000000 0x20000000>;
+        /*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+    };
+
+    memory@0 {
+        device_type = "memory";
+        reg = <0 0x80000000>; /* 2048 MB */
+    };
+
+    firmware {
+        optee {
+            compatible = "linaro,optee-tz";
+            method = "smc";
+        };
+    };
+
+    reserved-memory {
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        rbus@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "rbus";
+            reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+            rtk_rbus_barrier_flag;
+        };
+
+        common@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "common";
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+
+        ringbuf@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "ringbuf";
+            reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+        };
+
+        tee_reserved: tee {
+            no-map;
+            size = <0x04100000>;
+            alloc-ranges = <TEE_OS_PHYS TEE_OS_SIZE>;
+        }; 
+    };
+
+    rtk_avcpu {
+        compatible = "Realtek,rtk-avcpu";
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        crt@0 {
+            reg = <0x98000000 0x200000>;
+        };
+
+        rpc@0 {
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+    };
+
+    rtk,ion {
+        compatible = "Realtek,rtk-ion";
+        #address-cells = <1>;
+        #size-cells = <0>;
+
+        rtk,ion-heap@0 { /* SYSTEM_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <0>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@1 { /* System contig */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <1>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@4 { /* DMA_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <4>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@8 { /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                ION_AUDIO_HEAP_PHYS_0
+                ION_AUDIO_HEAP_SIZE_0
+                ION_AUDIO_HEAP_FLAG_0>;
+        };
+
+        rtk,ion-heap@7 { /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+                ION_MEDIA_HEAP_PHYS_0
+                ION_MEDIA_HEAP_SIZE_0
+                ION_MEDIA_HEAP_FLAG_0
+                ION_MEDIA_HEAP_PHYS_1
+                ION_MEDIA_HEAP_SIZE_1
+                ION_MEDIA_HEAP_FLAG_1>;
+        };
+    };
+
+    rtk-fb {
+        compatible = "Realtek,rtk-fb";
+        buffer-cnt = <3>;
+        resolution = <1920 1080>;
+        fps = <60>;
+    };
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB.dts
new file mode 100644
index 00000000..b477f76
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB.dts
@@ -0,0 +1,190 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-1GB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-1GB.dts
new file mode 100644
index 00000000..62ddb8c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-1GB.dts
@@ -0,0 +1,180 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0b800000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex = <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+        bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+    nand@98010000 { status = "okay"; };
+    emmc@98012000 { status = "disabled"; };
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-2GB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-2GB.dts
new file mode 100644
index 00000000..0185d7f
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-2GB.dts
@@ -0,0 +1,180 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+        bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+    nand@98010000 { status = "okay"; };
+    emmc@98012000 { status = "disabled"; };
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin.dtsi
new file mode 100644
index 00000000..f429311
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-lionskin.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-139x.dtsi"
+#include "rtd-139x-dvfs.dtsi"
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-glinux-1GB.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-glinux-1GB.dts
new file mode 100644
index 00000000..7deb8ef
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-glinux-1GB.dts
@@ -0,0 +1,209 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0b800000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-papermulberry.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
+&emmc {
+	status = "disabled";
+};
+
+&gpu {
+	assigned-clocks =      <&cc CC_CLK_GPU>;
+	assigned-clock-rates = <500000000>;
+};
+
+&nand {
+	status = "okay";
+};
+
+&i2c_5 {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&ve1 {
+	assigned-clocks =        <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>;
+	assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>;
+	assigned-clock-rates =   <270000000>,      <189000000>;
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-qa-rescue.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-qa-rescue.dts
new file mode 100644
index 00000000..4d85032
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-qa-rescue.dts
@@ -0,0 +1,206 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-1395-papermulberry.dtsi"
+
+/ {
+	model= "Realtek_RTD1355";
+	model_hex = <0x0000054B>;
+	compatible = "realtek,rtd1355";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&emmc {
+	status = "disabled";
+};
+
+&gpu {
+	assigned-clocks = <&cc CC_CLK_GPU>;
+	assigned-clock-rates = <500000000>;
+};
+
+&jpeg {
+	status = "disabled";
+};
+
+&md {
+	status = "disabled";
+};
+
+&nand {
+	status = "okay";
+};
+
+&i2c_5 {
+        status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&se {
+	status = "disabled";
+};
+
+&ve1 {
+	status = "disabled";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-papermulberry.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-papermulberry.dtsi
new file mode 100644
index 00000000..2498325
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-papermulberry.dtsi
@@ -0,0 +1,48 @@
+#include "rtd-139x.dtsi"
+#include "rtd-139x-dvfs.dtsi"
+
+/* CPU OPP table */
+
+&opp900 {
+	opp-suspend;
+};
+
+&opp1200 {
+	/delete-property/ opp-suspend;
+	status = "disabled";
+};
+
+&opp1300 {
+	status = "disabled";
+};
+
+&opp1400 {
+	status = "disabled";
+};
+
+/* GPU OPP table */
+
+&gopp300 {
+	status = "okay";
+};
+
+&gopp400 {
+	status = "okay";
+};
+
+&gopp500 {
+	status = "okay";
+};
+
+&gopp600 {
+	status = "disabled";
+};
+
+&gopp700 {
+	status = "disabled";
+};
+
+&gopp750 {
+	status = "disabled";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-tee.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-tee.dts
new file mode 100644
index 00000000..aca663c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-tee.dts
@@ -0,0 +1,244 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12c00000;
+
+#define SECURE_AUDIO_SIZE               (0x00200000) // 2MB
+#define SECURE_MD_SIZE                  (0x00100000) // 1MB
+#define SECURE_HEAP_SIZE_0              (0x04600000) // 70MB
+
+#define ION_SECURE_AUDIO_PHYS_0         (0x20800000)
+#define ION_SECURE_AUDIO_SIZE_0         (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0         (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0            (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0            (SECURE_MD_SIZE)
+
+#define ION_SECURE_HEAP_PHYS_0          (ION_SECURE_MD_PHYS_0 + ION_SECURE_MD_SIZE_0)
+#define ION_SECURE_HEAP_SIZE_0          (SECURE_HEAP_SIZE_0)
+#define ION_SECURE_HEAP_FLAG_0          (RTK_FLAG_HWIPACC)
+
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+#include "rtd-139x.dtsi"
+
+/ {
+	model= "Realtek_RTD1395";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				compatible = "android,fstab";
+				/*
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				*/
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait,avb";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+				ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+				>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-vmx.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-vmx.dts
new file mode 100644
index 00000000..1dd2b5a
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-vmx.dts
@@ -0,0 +1,213 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x1fc00000 ~ 0x1fc00fff */
+/memreserve/ ACPU_BOOTCODE_PHYS ACPU_BOOTCODE_SIZE;
+/* Framebuffer */
+/memreserve/ 0x22000000 0x17BB000;
+/* TEE OS */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* Watermark */
+/memreserve/ 0x32600000 0x00200000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x17c00000;
+/* TP */
+/memreserve/ 0x31600000 0x01000000;
+/* TEE MCP BUFFER*/
+/memreserve/ 0x42700000 0x06300000;
+/* ION VMX BUFFER*/
+/memreserve/ 0x4A700000 0x17C00000;
+
+#include "rtd-139x.dtsi"
+
+/ {
+    model= "Realtek_RTD1395_VMX";
+    model_hex= <0x00000573>;
+    compatible = "realtek,rtd1395";
+
+    chosen {
+        linux,initrd-start = <ROOTFS_RESCUE_START>;
+        linux,initrd-end = <ROOTFS_RESCUE_END>;
+        bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=64m@576m init=/init androidboot.hardware=hercules androidboot.storage=emmc androidboot.vmx=ultra loglevel=4";
+    };
+
+    memory@0 {
+        device_type = "memory";
+        reg = <0 0x80000000>; /* 2048 MB */
+    };
+
+    firmware {
+        optee {
+            compatible = "linaro,optee-tz";
+            method = "smc";
+        };
+    };
+
+    reserved-memory {
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        rbus@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "rbus";
+            reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+            rtk_rbus_barrier_flag;
+        };
+
+        common@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "common";
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+
+        ringbuf@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "ringbuf";
+            reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+        };
+
+        tee_reserved: tee {
+            no-map;
+            size = <0x04100000>;
+            alloc-ranges = <TEE_OS_PHYS TEE_OS_SIZE>;
+        }; 
+    };
+
+    timer {
+        clock-frequency = <27000000>;
+    };
+
+    timer0 {
+        clock-frequency = <27000000>;
+    };
+
+    timer1 {
+        clock-frequency = <27000000>;
+    };
+
+    serial0@98007800 {
+        clock-frequency = <27000000>;
+    };
+
+    rtk,ion {
+        compatible = "Realtek,rtk-ion";
+        #address-cells = <1>;
+        #size-cells = <0>;
+
+        rtk,ion-heap@0 { /* SYSTEM_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <0>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@1 { /* System contig */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <1>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@4 { /* DMA_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <4>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@8 { /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                0x03000000
+                0x00100000
+                ION_AUDIO_HEAP_FLAG>;
+        };
+
+        rtk,ion-heap@7 { /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+		0x03100000 0x06000000 ION_MEDIA_HEAP_FLAG1
+		0x4A700000 0x17C00000 ION_MEDIA_HEAP_FLAG1 >;
+        };
+
+	rtk,ion-heap@9 { /* TYPE_VMX */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                0x31600000 0x01000000 RTK_FLAG_SECURE_AUDIO >;
+        };
+    };
+
+    fb@0 {
+        compatible = "Realtek,rtk-fb";
+        reg = <0x22000000 0xA8C000>;
+        buffer-cnt = <3>;
+        resolution = <1920 1080>;
+        fps = <60>;
+    };
+
+    test_vo@98005000 {
+        compatible = "Realtek,rtk1295-test_vo";
+        reg = <0x98005000 0x1000>,
+            <0x9800D000 0x1000>,
+            <0x98000000 0x1000>;
+        //interrupts = <0 31 4>;
+        interrupts = <0 34 4>;
+    };
+
+    serial1@9801B200 {
+        status = "disabled";
+    };
+
+    sdmmc@98010400 {
+        status = "disabled";
+    };
+
+    md@9800b000 {
+        status = "disabled";
+    };
+
+    se@9800c000 {
+        status = "disabled";
+    };
+
+    jpeg@9803e000 {
+        status = "disabled";
+    };
+
+    ve1@98040000 {
+        status = "disabled";
+    };
+
+    rtk_avcpu {
+        compatible = "Realtek,rtk-avcpu";
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        crt@0 {
+            reg = <0x98000000 0x200000>;
+        };
+
+        rpc@0 {
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+    };
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue.dts b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue.dts
new file mode 100644
index 00000000..71024a0
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue.dts
@@ -0,0 +1,216 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x0d500000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+
+#include "rtd-139x.dtsi"
+
+/ {
+	model= "Realtek_RTD1395";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				compatible = "android,fstab";
+				/*
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				*/
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait,avb";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-usb.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-usb.dtsi
new file mode 100644
index 00000000..98d3265
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-1395-usb.dtsi
@@ -0,0 +1,36 @@
+/*
+ * realtek,type_c-power-gpio: TypeC power, output, default low
+ * realtek,u2host-power-gpio: ehci and u2host power, output, default low
+ * realtek,u3host-power-gpio: 1296 u3host power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+/ {
+	/include/ "rtd-139x-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		status = "okay";
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+		};
+
+		rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			drd_mode; //depend on dr_mode = "peripheral"
+			status = "okay";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-avb-ab.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-avb-ab.dtsi
new file mode 100644
index 00000000..d3a050b
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-avb-ab.dtsi
@@ -0,0 +1,18 @@
+/ {
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				/delete-node/ system;
+				vendor {
+					fsmgr_flags = "wait,avb,slotselect";
+				};
+			};
+		};
+	};
+
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-avb-vmx.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-avb-vmx.dtsi
new file mode 100644
index 00000000..be87bfc
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-avb-vmx.dtsi
@@ -0,0 +1,20 @@
+/ {
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hercules androidboot.storage=emmc androidboot.vmx=ultra loglevel=4 ramfs_vendor";
+	};
+
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system";
+			};
+			fstab {
+				/delete-node/ system;
+				/delete-node/ vendor;
+			};
+		};
+	};
+
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-avb.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-avb.dtsi
new file mode 100644
index 00000000..3bb5c17
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-avb.dtsi
@@ -0,0 +1,18 @@
+/ {
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				/delete-node/ system;
+				vendor {
+					fsmgr_flags = "wait,avb";
+				};
+			};
+		};
+	};
+
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-dcsys-debug.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-dcsys-debug.dtsi
new file mode 100644
index 00000000..980c92d
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-dcsys-debug.dtsi
@@ -0,0 +1,142 @@
+/*
+[Module ID table]
+VO1 0x0
+AIO: 0xa
+CP: 0x11
+MD: 0x13
+JPEG: 0x15
+TP: 0x17
+GPU: 0x19
+SCPU_NWC: 0x20
+SCPU_SWC: 0x25
+ACPU: 0x23
+HIF: 0x22
+AEE: 0x28
+ADE: 0x29
+USB: 0x2a
+SD: 0x2b
+PCIE: 0x2c
+SDIO: 0x2d
+ETN: 0x2e
+EMMC: 0x80
+NF: 0x83
+VE1: 0x30
+VE2: 0x31
+SE: 0x38
+MIPI: 0x40
+SATA: 0x48
+DIP: 0x88
+HSE_REE: 0x90
+HSE_TEE: 0x9
+
+[access type]
+invalid: 0x0
+read: 0x1
+write: 0x2
+read or write: 0x3
+
+[memory trash detection mode]
+mode1: 0x1 (Given a region, trap if module_ID and access_type match)
+mode2: 0x2 (Given a region, trap if module_ID not match and access_type match)
+mode3: 0x3 (Given a module_ID and access_type, trap if request falls out of range)
+
+[Over DRAM access detection]
+Disable: 0x0
+Enable: 0x1
+
+[interrupt to CPU]
+SCPU: 0x0
+ACPU: 0x1
+VCPU: 0x2
+*/
+
+/{
+	dc_sys_debug@98008000 {
+		compatible = "realtek,rtk-dcsys-debug";
+		reg = <0x98008000 0x1000>;
+		interrupts = <0 35 4>;
+		err_cmd_detect = <0x1>, /* Enable over DRAM access detection */
+			<0x0>; /* interrupt to CPU */
+		mt_0 = <0x0>,  /* NUM0 Enable memory trash detection */
+			<0x0>, /* NUM0 start address*/
+			<0x0>, /* NUM0 end address*/
+			<0x0>, /* NUM0 module ID0*/
+			<0xa>, /* NUM0 module ID1*/
+			<0x0>, /* NUM0 module ID2*/
+			<0x0>, /* NUM0 module ID3*/
+			<0x0>, /* NUM0 interrupt to CPU*/
+			<0x3>, /* NUM0 access type*/
+			<0x1>; /* NUM0 mode*/
+		mt_1 = <0x0>, /* NUM1 Enable memory trash detection */
+			<0x0>, /* NUM1 start address*/
+			<0x0>, /* NUM1 end address*/
+			<0x0>, /* NUM1 module ID0*/
+			<0x0>, /* NUM1 module ID1*/
+			<0x0>, /* NUM1 module ID2*/
+			<0x0>, /* NUM1 module ID3*/
+			<0x0>, /* NUM1 interrupt to CPU*/
+			<0x0>, /* NUM1 access type*/
+			<0x0>; /* NUM1 mode*/
+		mt_2 = <0x0>, /* NUM2 Enable memory trash detection */
+			<0x0>, /* NUM2 start address*/
+			<0x0>, /* NUM2 end address*/
+			<0x0>, /* NUM2 module ID0*/
+			<0x0>, /* NUM2 module ID1*/
+			<0x0>, /* NUM2 module ID2*/
+			<0x0>, /* NUM2 module ID3*/
+			<0x0>, /* NUM2 interrupt to CPU*/
+			<0x0>, /* NUM2 access type*/
+			<0x0>; /* NUM2 mode*/
+		mt_3 = <0x0>,  /* NUM3 Enable memory trash detection */
+			<0x0>, /* NUM3 start address*/
+			<0x0>, /* NUM3 end address*/
+			<0x0>, /* NUM3 module ID0*/
+			<0x0>, /* NUM3 module ID1*/
+			<0x0>, /* NUM3 module ID2*/
+			<0x0>, /* NUM3 module ID3*/
+			<0x0>, /* NUM3 interrupt to CPU*/
+			<0x0>, /* NUM3 access type*/
+			<0x0>; /* NUM3 mode*/
+		mt_4 = <0x0>,  /* NUM4 Enable memory trash detection */
+			<0x0>, /* NUM4 start address*/
+			<0x0>, /* NUM4 end address*/
+			<0x0>, /* NUM4 module ID0*/
+			<0x0>, /* NUM4 module ID1*/
+			<0x0>, /* NUM4 module ID2*/
+			<0x0>, /* NUM4 module ID3*/
+			<0x0>, /* NUM4 interrupt to CPU*/
+			<0x0>, /* NUM4 access type*/
+			<0x0>; /* NUM4 mode*/
+		mt_5 = <0x0>,  /* NUM5 Enable memory trash detection */
+			<0x0>, /* NUM5 start address*/
+			<0x0>, /* NUM5 end address*/
+			<0x0>, /* NUM5 module ID0*/
+			<0x0>, /* NUM5 module ID1*/
+			<0x0>, /* NUM5 module ID2*/
+			<0x0>, /* NUM5 module ID3*/
+			<0x0>, /* NUM5 interrupt to CPU*/
+			<0x0>, /* NUM5 access type*/
+			<0x0>; /* NUM5 mode*/
+		mt_6 = <0x0>,  /* NUM6 Enable memory trash detection */
+			<0x0>, /* NUM6 start address*/
+			<0x0>, /* NUM6 end address*/
+			<0x0>, /* NUM6 module ID0*/
+			<0x0>, /* NUM6 module ID1*/
+			<0x0>, /* NUM6 module ID2*/
+			<0x0>, /* NUM6 module ID3*/
+			<0x0>, /* NUM6 interrupt to CPU*/
+			<0x0>, /* NUM6 access type*/
+			<0x0>; /* NUM6 mode*/
+		mt_7 = <0x0>,  /* NUM7 Enable memory trash detection */
+			<0x0>, /* NUM7 start address*/
+			<0x0>, /* NUM7 end address*/
+			<0x0>, /* NUM7 module ID0*/
+			<0x0>, /* NUM7 module ID1*/
+			<0x0>, /* NUM7 module ID2*/
+			<0x0>, /* NUM7 module ID3*/
+			<0x0>, /* NUM7 interrupt to CPU*/
+			<0x0>, /* NUM7 access type*/
+			<0x0>; /* NUM7 mode*/
+		status = "okay";
+	};
+};
\ No newline at end of file
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-dfs.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-dfs.dtsi
new file mode 100644
index 00000000..7a23fc8
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-dfs.dtsi
@@ -0,0 +1,58 @@
+/*
+ * RTD-139X DFS with fixed CPU Voltage
+ */
+#include <dt-bindings/thermal/thermal.h>
+#include "rtd-139x-dvfs.dtsi"
+
+&i2c_0 {
+	status = "disabled";
+	/delete-node/ g2237;
+};
+
+&A53_0 {
+	/delete-property/ cpu-supply;
+};
+
+&A53_1 {
+	/delete-property/ cpu-supply;
+};
+
+&A53_2 {
+	/delete-property/ cpu-supply;
+};
+
+&A53_3 {
+	/delete-property/ cpu-supply;
+};
+
+&gpu {
+};
+
+&opp1000 {
+	opp-suspend;
+};
+
+&opp1200 {
+	/delete-property/ opp-suspend;
+	status = "disabled";
+};
+
+&opp1300 {
+	status = "disabled";
+};
+
+&opp1400 {
+	status = "disabled";
+};
+
+&cpu_thermal {
+	cooling-maps {
+		cpu-map0 {
+			cooling-device = <&A53_0 THERMAL_NO_LIMIT 3>;
+		};
+		cpu-map1 {
+			cooling-device = <&A53_0 4 THERMAL_NO_LIMIT>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-dvfs.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-dvfs.dtsi
new file mode 100644
index 00000000..9aa148c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-dvfs.dtsi
@@ -0,0 +1,313 @@
+/*
+ * RTD-139X DVFS with GMT G2237 PMIC
+ */
+#include <dt-bindings/regulator/gmt,g22xx.h>
+#include <dt-bindings/thermal/thermal.h>
+
+/* PMIC */
+&i2c_0 {
+	status = "okay";
+
+	g2237: g2237@12 {
+		compatible = "gmt,g2237";
+		reg = <0x12>;
+		status = "okay";
+		powerkey: powerkey {
+			compatible = "gmt,g22xx-powerkey";
+			lp-handler = "sw";
+			it-handler = "sw";
+			time-sel = <0 0 3>;
+			status = "disabled";
+		};
+		poweroff: poweroff {
+			compatible = "gmt,g22xx-poweroff";
+			system-power-controller;
+			status = "disabled";
+		};
+		regulators: regulators {
+			compatible = "gmt,g2237-regulator";
+			status = "okay";
+		};
+	};
+};
+
+&g2237 {
+	regulators {
+		vd33_supp: dc1 {
+			regulator-name = "vd33";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3700000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_FORCE_PWM>;
+
+		};
+		gpu_supp: dc2 {
+			regulator-name = "core";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+		};
+		cpu_supp: dc3 {
+			regulator-name = "cpudvs";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		ddr_supp: dc4 {
+			regulator-name = "ddr";
+			regulator-min-microvolt = <1500000>;
+			regulator-max-microvolt = <1500000>;
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-coldboot {
+				regulator-off-in-suspend;
+			};
+
+		};
+		vd18_supp: dc5 {
+			regulator-name = "vd18";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <2500000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+		};
+		vd25_supp: ldo1 {
+			regulator-name = "vd25";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3000000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_LDO_MODE_NORMAL>;
+			regulator-state-coldboot {
+				regulator-off-in-suspend;
+			};
+		};
+	};
+};
+
+/* CPU nodes */
+&A53_0 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+	dynamic-power-coefficient = <150>;
+};
+
+&A53_1 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+	dynamic-power-coefficient = <150>;
+};
+
+&A53_2 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+	dynamic-power-coefficient = <150>;
+};
+
+&A53_3 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+	dynamic-power-coefficient = <150>;
+};
+
+/* cpu opp table */
+&dvfs {
+	cpu_opps: opp-table-0 {
+		compatible = "operating-points-v2";
+		opp-shared;
+		opp300: opp-300mhz {
+			opp-hz = /bits/ 64 <300000000>;
+			opp-microvolt = <825000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp400: opp-400mhz {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-microvolt = <825000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		opp500: opp-500mhz {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-microvolt = <825000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp600: opp-600mhz {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-microvolt     = <825000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp700: opp-700mhz {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-microvolt     = <887500>;
+			opp-microvolt-a00 = <875000>;
+			opp-microvolt-a01 = <862500>;
+			opp-microvolt-a02 = <887500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp800: opp-800mhz {
+			opp-hz = /bits/ 64 <800000000>;
+			opp-microvolt     = <925000>;
+			opp-microvolt-a00 = <912500>;
+			opp-microvolt-a01 = <900000>;
+			opp-microvolt-a02 = <925000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp900: opp-900mhz {
+			opp-hz = /bits/ 64 <900000000>;
+			opp-microvolt     = <975000>;
+			opp-microvolt-a00 = <975000>;
+			opp-microvolt-a01 = <937500>;
+			opp-microvolt-a02 = <962500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1000: opp-1000mhz {
+			opp-hz = /bits/ 64 <1000000000>;
+			opp-microvolt     = <987500>;
+			opp-microvolt-a01 = <962500>;
+			opp-microvolt-a02 = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1100: opp-1100mhz {
+			opp-hz = /bits/ 64 <1100000000>;
+			opp-microvolt     = <1000000>;
+			opp-microvolt-a02 = <1050000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1200: opp-1200mhz {
+			opp-hz = /bits/ 64 <1200000000>;
+			opp-microvolt     = <1062500>;
+			opp-microvolt-a02 = <1100000>;
+			clock-latency-ns = <150000>;
+			opp-suspend;
+			status = "okay";
+		};
+		opp1300: opp-1300mhz {
+			opp-hz = /bits/ 64 <1300000000>;
+			opp-microvolt     = <1100000>;
+			opp-microvolt-a02 = <1150000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1400: opp-1400mhz {
+			opp-hz = /bits/ 64 <1400000000>;
+			opp-microvolt     = <1150000>;
+			opp-microvolt-a02 = <0>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+	};
+};
+
+/*
+ * thermal_zone
+ */
+&cpu_thermal {
+	trips {
+		tm_alert0: cpu-alert0 {
+			temperature = <105000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+		tm_alert1: cpu-alert1 {
+			temperature = <115000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+	};
+	cooling-maps {
+		cpu-map0 {
+			trip = <&tm_alert0>;
+			cooling-device = <&A53_0 THERMAL_NO_LIMIT 6>;
+			contribution = <70>;
+		};
+		cpu-map1 {
+			trip = <&tm_alert1>;
+			cooling-device = <&A53_0 7 THERMAL_NO_LIMIT>;
+			contribution = <70>;
+		};
+		gpu-map0 {
+			trip = <&tm_alert0>;
+			cooling-device = <&gpu THERMAL_NO_LIMIT THERMAL_NO_LIMIT>;
+			contribution = <30>;
+		};
+	};
+};
+
+&gpu {
+	#cooling-cells = <2>;
+	operating-points-v2 = <&gpu_opps>;
+	assigned-clocks =      <&cc CC_PLL_GPU>;
+	assigned-clock-rates = <750000000>;
+
+	gpu_opps: gpu-opp-table-0 {
+		compatible = "operating-points-v2";
+		opp-shared;
+		gopp300: opp-300mhz {
+			opp-hz = /bits/ 64 <300000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		gopp400: opp-400mhz {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		gopp500: opp-500mhz {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		gopp600: opp-600mhz {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		gopp700: opp-700mhz {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		gopp750: opp-750mhz {
+			opp-hz = /bits/ 64 <750000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee-vmx.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee-vmx.dtsi
new file mode 100755
index 00000000..1c77fde
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee-vmx.dtsi
@@ -0,0 +1,94 @@
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+//#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_REQ_SIZE_0       (0x15400000) // 340M
+#define SECURE_AUDIO_SIZE_1     (0x02800000) // 40M (4 audio decoder 20M + CVBS 19M)
+
+//#define SECURE_REQ_SIZE_0       (0xFA00000) // 300M-50M=250M
+//#define SECURE_AUDIO_SIZE_1     (0x03200000) // 50M (4 audio decoder 20M + DP 29M)
+
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+#define SECURE_AUDIO_REQ_SIZE   (0x00200000) // 2M
+//#define SECURE_TP_SIZE          (0x00300000) // 3M (single)
+//#define SECURE_TP_SIZE          (0x00600000) // 6M (dual)
+//#define SECURE_TP_SIZE          (0x00A10000) // 6M (dual) + DVR 4M + 64K
+#define SECURE_TP_SIZE            (0x01000000) // 16M
+
+#define ION_SECURE_AUDIO_PHYS_1  (0x32b00000) // 0x32b00000 should be equal to (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_AUDIO_SIZE_1  (SECURE_AUDIO_SIZE_1)
+#define ION_SECURE_AUDIO_FLAG_1  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_HEAP_PHYS_0   (ION_SECURE_AUDIO_PHYS_1 + SECURE_AUDIO_SIZE_1)
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+#define ION_SECURE_AUDIO_REQ_PHYS_0  (0x32600000)
+#define ION_SECURE_AUDIO_REQ_SIZE_0  (SECURE_AUDIO_REQ_SIZE)
+#define ION_SECURE_AUDIO_REQ_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0      ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0      ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1      ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_PHYS_1    ION_SECURE_AUDIO_SIZE_1;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_REQ_PHYS_0     ION_SECURE_AUDIO_REQ_SIZE_0;
+/memreserve/ ION_SECURE_TP_PHYS_0       ION_SECURE_TP_SIZE_0;
+
+/ {
+    rtk,ion {
+        rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+                ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+		ION_SECURE_AUDIO_PHYS_1 ION_SECURE_AUDIO_SIZE_1 ION_SECURE_AUDIO_FLAG_1
+                ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0 ION_SECURE_TP_FLAG_0
+                >;
+        };
+        rtk,ion-heap@8 {    /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                ION_AUDIO_HEAP_PHYS_0 ION_AUDIO_HEAP_SIZE_0 ION_AUDIO_HEAP_FLAG_0
+                >;
+        };
+        rtk,ion-heap@7 {    /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+                ION_MEDIA_HEAP_PHYS_0 ION_MEDIA_HEAP_SIZE_0 ION_MEDIA_HEAP_FLAG_0
+                ION_MEDIA_HEAP_PHYS_1 ION_MEDIA_HEAP_SIZE_1 ION_MEDIA_HEAP_FLAG_1
+                >;
+        };
+    };
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee.dtsi
new file mode 100755
index 00000000..57de94d
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee.dtsi
@@ -0,0 +1,66 @@
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0      ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0      ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1      ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+/ {
+    rtk,ion {
+        rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+                ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+                >;
+        };
+        rtk,ion-heap@8 {    /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                ION_AUDIO_HEAP_PHYS_0 ION_AUDIO_HEAP_SIZE_0 ION_AUDIO_HEAP_FLAG_0
+                >;
+        };
+        rtk,ion-heap@7 {    /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+                ION_MEDIA_HEAP_PHYS_0 ION_MEDIA_HEAP_SIZE_0 ION_MEDIA_HEAP_FLAG_0
+                ION_MEDIA_HEAP_PHYS_1 ION_MEDIA_HEAP_SIZE_1 ION_MEDIA_HEAP_FLAG_1
+                >;
+        };
+    };
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-irT377.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-irT377.dtsi
new file mode 100644
index 00000000..7711af7
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-irT377.dtsi
@@ -0,0 +1,61 @@
+/*
+ * rtd-139x-irT377.dtsi - IRDA remote Device Tree Include file for REALTEK 139x family SoC
+ */
+
+/ {
+	/*
+	 * IR RX protocol:
+	 * NEC = 1,  RC5 = 2, SHARP = 3, SONY = 4, C03 = 5,
+	 * RC6 = 6, RAW_NEC = 7, RCA = 8, PANASONIC = 9, KONKA=10,
+	 * RAW_RC6 = 11, RC6_MODE_6, TOSHIBA = 13
+	 * ----------------
+	 * IR RX protocol:
+	 * NEC_TX = 1, RC5_TX = 2, SHARP_TX = 3, SONY_TX = 4, C03_TX = 5
+	 * RC6_TX = 6, RCA_TX = 7, PANASONIC_TX = 8, KONKA_TX=9
+	 */
+	irda@98007400 {
+		Realtek,irrx-protocol = <1>;
+		Realtek,irtx-protocol = <1>;
+
+		Realtek,cust-code = <0x7F80>;
+		Realtek,scancode-msk = <0x00FF0000>;
+		Realtek,custcode-msk = <0x0000FFFF>;
+		Realtek,keymap-tbl = <
+			//scancode keycode
+			0x18 116 //KEY_POWER //POWER
+			0x5A 353 //KEY_SELECT //SOURCE
+			0x58 154 //KEY_CYCLEWINDOWS //PIP
+			0x1A 377 //KEY_TV //TV SYSTEM
+			0x14 102 //KEY_HOME //HOME
+			0x56 357 //KEY_OPTION //OPTION MENU
+			0x54 358 //KEY_INFO //MEDIA_INFO
+			0x19 232 //KEY_REPLY //REPEAT
+			0x57 158 //KEY_BACK //RETURN
+			0x55 207 //KEY_PLAY //PLAY/PAUSE
+			0x17 128 //KEY_STOP //STOP
+			0x15 372 //KEY_ZOOM //ZOOM_IN
+			0x4F 168 //KEY_REWIND //FR
+			0x4D 103 //KEY_UP //UP
+			0x16 208 //KEY_FASTFORWARD //FF
+			0x0C 105 //KEY_LEFT //LEFT
+			0x4C 352 //KEY_OK //OK
+			0x0E 106 //KEY_RIGHT //RIGHT
+			0x08 412 //KEY_PREVIOUS //PREVIOUS
+			0x48 108 //KEY_DOWN //DOWN
+			0x09 407 //KEY_NEXT //NEXT
+			0x4B 114 //KEY_VOLUMEDOWN //VOL-
+			0x49 115 //KEY_VOLUMEUP //VOL+
+			0x0B 532 //KEY_TOUCHPAD_OFF //CURSOR
+			0x0A 531 //KEY_TOUCHPAD_ON //GESTURE
+			0xEEEE 0 //REL_X //mouse X-axi 0xEEEE : REL event type
+			0xEEEE 1 //REL_Y //mouse Y-axi 0xEEEE : REL event type
+			0xFFFF 272 //BTN_LEFT //mouse left key	0xFFFF : KEY event type
+			0xFFFF 113 //KEY_MUTE //mute key in AirFunAPP 0xFFFF : KEY event type
+			>;
+		/*
+		 *  IR detect interval, NEC default=50ms, should less than 100ms,
+		 * and bigger than 9ms
+		 */
+		Realtek,reg-ir-dpir = <50>;
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-irda.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-irda.dtsi
new file mode 100644
index 00000000..b0ae4cd
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-irda.dtsi
@@ -0,0 +1,51 @@
+/*
+ * rtd-1395-irda.dtsi - IRDA remote Device Tree Include file for REALTEK 1295 family SoC
+ */
+
+/ {
+	irda@98007400 {
+		irda_rx0 {
+			irrx-protocol = "NEC";
+			transcode-mode = <1>;
+
+			cust-code = <0x7F80>;
+			scancode-msk = <0x00FF0000>;
+			custcode-msk = <0x0000FFFF>;
+			keymap-tbl = <
+			// scancode	keycode
+				0x18 	116		//KEY_POWER		//POWER
+				0x5A 	353		//KEY_SELECT		//SOURCE
+				0x58 	154		//KEY_CYCLEWINDOWS	//PIP
+				0x1A 	377		//KEY_TV		//TV SYSTEM
+				0x14 	102		//KEY_HOME		//HOME
+				0x56 	357		//KEY_OPTION		//OPTION MENU
+				0x54	358		//KEY_INFO		//MEDIA_INFO
+				0x19 	232		//KEY_REPLY		//REPEAT
+				0x57 	158		//KEY_BACK		//RETURN
+				0x55 	207		//KEY_PLAY		//PLAY/PAUSE
+				0x17 	128		//KEY_STOP		//STOP
+				0x15 	372		//KEY_ZOOM		//ZOOM_IN
+				0x4F 	168		//KEY_REWIND		//FR
+				0x4D 	103		//KEY_UP		//UP
+				0x16 	208		//KEY_FASTFORWARD	//FF
+				0x0C 	105		//KEY_LEFT		//LEFT
+				0x4C 	352		//KEY_OK		//OK
+				0x0E 	106		//KEY_RIGHT		//RIGHT
+				0x08 	412		//KEY_PREVIOUS		//PREVIOUS
+				0x48 	108		//KEY_DOWN		//DOWN
+				0x09 	407		//KEY_NEXT		//NEXT
+				0x4B 	114		//KEY_VOLUMEDOWN	//VOL-
+				0x49 	115		//KEY_VOLUMEUP		//VOL+
+				0x0B 	532		//KEY_TOUCHPAD_OFF	//CURSOR
+				0x0A 	531		//KEY_TOUCHPAD_ON	//GESTURE
+				0xEEEE	0		//REL_X			//mouse X-axi	0xEEEE : REL event type
+				0xEEEE	1		//REL_Y			//mouse Y-axi	0xEEEE : REL event type
+				0xFFFF	272		//BTN_LEFT		//mouse left key	0xFFFF : KEY event type
+				0xFFFF	113     	//KEY_MUTE 		//mute key in AirFunAPP	0xFFFF : KEY event type	
+			>;
+			reg-ir-dpir = <50>;	/*IR detect interval, NEC default=50ms, should less than 100ms, and bigger than 9ms*/
+			sample-rate = <40>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-pcie.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-pcie.dtsi
new file mode 100644
index 00000000..f785c70
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-pcie.dtsi
@@ -0,0 +1,72 @@
+/ {
+	pcie: pcie@98060000 {
+		compatible = "realtek,rtk139x-pcie";
+		reg = <0x98060000 0x00001000
+			0x98061000 0x00001000
+			0x9801C800 0x00000100
+			0x9801A000 0x00000300>;
+		/*interrupt-names = "rtk-pcie1-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic GIC_SPI 61 IRQ_TYPE_LEVEL_HIGH>;*/
+		interrupts =  <0 61 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <0>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 29 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys = <0x00000003>, /* #Write soft reset */
+			<0x27710301>,
+			<0x52F50401>,/* #F code,close SSC */
+			<0xead70501>,/* #modify N code */
+			<0x00080601>,/* #modify CMU ICP(TX jitter) */
+			<0xb6530a01>,/* #modify CMU RS(tx jitter) */
+			<0xc4552001>,/* #modify AMP */
+			<0x8EA01B01>,
+			<0x8EA05B01>,
+			<0x55552101>,
+			<0x505c0101>,/* #modify Rx parameter */
+			<0xa8032b01>,/* #clk driving */
+			<0x27e94301>,/* #EQ */
+			<0x52f54401>,/* #F code,close SSC */
+			<0xead74501>,/* #modify N code */
+			<0x00004601>,/* #modify CMU ICP(TX jitter) */
+			<0x86534a01>,/* #modify CMU RS(tx jitter) */
+			<0xc4666001>,/* #modify AMP */
+			<0x55556101>,
+			<0xa84a4101>,/* #modify Rx parameter */
+			<0xa8036b01>,/* #clk driving */
+			<0x01225a01>,
+			<0xf8022801>,
+			<0x521C0901>,
+			<0x501C0901>,
+			<0x521C0901>;
+
+		//speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x98062000  0x98062000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00030000  0x00030000 0x00000000 0x00010000>;
+		resets = <&rst2 RSTN_PCIE0>,
+			<&rst2 RSTN_PCIE0_CORE>,
+			<&rst2 RSTN_PCIE0_POWER>,
+			<&rst2 RSTN_PCIE0_NONSTITCH>,
+			<&rst2 RSTN_PCIE0_STITCH>,
+			<&rst2 RSTN_PCIE0_PHY>,
+			<&rst4 RSTN_PCIE0_PHY_MDIO>,
+			<&rst4 RSTN_PCIE0_SGMII_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio",
+			"sgmii_mdio";
+		clocks = <&clk_en_1 CLK_EN_PCIE0>;
+		status = "okay";
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-pinctrl.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-pinctrl.dtsi
new file mode 100644
index 00000000..95d2ff1
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-pinctrl.dtsi
@@ -0,0 +1,339 @@
+
+/ {
+	pinctrl@9804E000 {
+	sdcard_pins_low: sdcard_low {
+	        realtek,pins= "gpio_39",
+		"gpio_38",
+		"gpio_37",
+		"gpio_36",
+		"gpio_33",
+		"gpio_32";
+	        realtek,function="mmc";
+	        realtek,pull_en = <1>;
+	        realtek,pull_sel = <0>;
+	};
+
+	sdcard_pins_high: sdcard_high {
+	        realtek,pins="gpio_35", "gpio_34";
+	        realtek,function="mmc";
+	        realtek,pull_en = <1>;
+	        realtek,pull_sel = <1>;
+	};
+
+	sdio_pins_0: sdio_pins_0 {
+	        realtek,pins = "gpio_32",
+		"gpio_33",
+		"gpio_36",
+		"gpio_37",
+		"gpio_38",
+		"gpio_39",
+		"sdio_loc";
+	        realtek,function = "sdio_loc0";
+	};
+
+		sdio_pins_1: sdio_pins_1 {
+	        realtek,pins = "gpio_40",
+		"gpio_41",
+		"gpio_42",
+		"gpio_43",
+		"gpio_44",
+		"gpio_45",
+		"sdio_loc";
+	        realtek,function = "sdio_loc1";
+	};
+
+
+	uart0_pins: uart0_pins {
+	        realtek,pins = "ur0_rx",
+		"ur0_tx";
+	        realtek,function = "uart0";
+	};
+
+	uart1_pins: uart1_pins {
+	        realtek,pins = "gpio_8",
+		"gpio_9";
+	        realtek,function = "uart1";
+	};
+
+	uart2_pins_0: uart2_pins_0 {
+	        realtek,pins = "ur2_loc",
+		"gpio_18",
+		"gpio_19",
+		"gpio_20",
+		"gpio_31";
+	        realtek,function = "uart2_loc0";
+	};
+
+	uart2_pins_1: uart2_pins_1 {
+	        realtek,pins ="ur2_loc",
+		"gpio_25",
+		"gpio_26",
+		"gpio_27",
+		"gpiio_28";
+	        realtek,function = "uart2_loc1";
+	};
+
+	i2c_pins_0: i2c_pins_0 {
+	        realtek,pins = "gpio_12",
+		"gpio_13";
+	        realtek,function = "i2c0";
+	};
+
+	i2c_pins_1: i2c_pins_1 {
+	        realtek,pins = "gpio_16",
+		"gpio_17";
+	        realtek,function = "i2c1";
+	};
+
+
+	i2c_pins_5: i2c_pins_5 {
+	        realtek,pins = "spi_ce_n",
+		"spi_si";
+	        realtek,function = "i2c5";
+	};
+
+	spi_pins_loc_spi: spi_pins_loc_spi {
+	        realtek,pins = "spi_ce_n",
+		"spi_sck",
+		"spi_so",
+		"spi_si",
+		"sf_en";
+	        realtek,function = "spi";
+	};
+
+	gspi_pins_0: gspi_pins_0 {
+	        realtek,pins = "gspi_loc",
+		"gpio_18",
+		"gpio_19",
+		"gpio_20",
+				"gpio_31";
+	        realtek,function = "gspi_loc0";
+	};
+
+		gspi_pins_1: gspi_pins_1 {
+	        realtek,pins = "gspi_loc",
+		"gpio_25",
+		"gpio_26",
+		"gpio_27",
+				"gpio_28";
+	        realtek,function = "gspi_loc1";
+	};
+
+		smartcard_pins:smartcard_pins{
+			realtek,pins = "gpio_18",
+		"gpio_19",
+		"gpio_20",
+		"gpio_31";
+	        realtek,function = "sc_loc0";
+		};
+
+	tp0_loc_tp0_pins: tp0_loc_tp0_pins {
+	        realtek,pins = "gpio_8",
+		"gpio_9",
+		"gpio_10",
+		"gpio_11";
+	        realtek,function = "tp0";
+	};
+
+	tp1_loc_tp1_pins: tp1_loc_tp1_pins {
+	        realtek,pins = "gpio_36",
+		"gpio_37",
+		"gpio_38",
+		"gpio_39";
+	        realtek,function = "tp1_loc_tp1";
+	};
+
+	ir_rx_pins: ir_rx_pins {
+	        realtek,pins = "ir_rx";
+	        realtek,function = "ir_rx";
+	};
+
+	spdif_pins: spdif_pins {
+	        realtek,pins = "gpio_50";
+	        realtek,function = "spdif";
+	};
+
+	i2s_out_4pins: i2s_out_4pins {
+	        realtek,pins ="gpio_2",
+		"gpio_3",
+		"gpio_4",
+		"gpio_5";
+	        realtek,function = "ao";
+	};
+
+	i2s_in_pins: i2s_in_pins {
+		realtek,pins = "gpio_6";
+		realtek,function = "ai";
+	};
+
+	etn_led_pins: etn_led_pins {
+	        realtek,pins = "gpio_14",
+		"gpio_15";
+	        realtek,function = "etn_led";
+	};
+
+	sgmii_mdio_pins: sgmii_mdio_pins {
+	        realtek,pins = "gpio_29",
+		"gpio_46";
+	        realtek,function = "extphy";
+	};
+
+	pcie_clk_pins: pcie_clk_pins {
+	        realtek,pins = "gpio_46";
+	        realtek,function = "pcie";
+	};
+
+	scpu_ejtag_pins_loc_0: scpu_ejtag_pins_loc_0 {
+	        realtek,pins = "gpio_2",
+		"gpio_3",
+		"gpio_4",
+		"gpio_5",
+		"gpio_6",
+		"ejtag_scpu_loc";
+	        realtek,function = "scpu_ejtag_loc0";
+	};
+
+	scpu_ejtag_pins_loc_1: scpu_ejtag_pins_loc_1 {
+	        realtek,pins = "gpio_32",
+		"gpio_33",
+		"gpio_36",
+		"gpio_37",
+		"gpio_39",
+		"ejtag_scpu_loc";
+	        realtek,function = "scpu_ejtag_loc1";
+	};
+
+		acpu_ejtag_pins_loc_0: acpu_ejtag_pins_loc_0 {
+	        realtek,pins = "gpio_2",
+		"gpio_3",
+		"gpio_4",
+		"gpio_5",
+		"gpio_6",
+		"ejtag_acpu_loc";
+	        realtek,function = "acpu_ejtag_loc0";
+	};
+
+	acpu_ejtag_pins_loc_1: acpu_ejtag_pins_loc_1 {
+	        realtek,pins = "gpio_32",
+		"gpio_33",
+		"gpio_36",
+		"gpio_37",
+		"gpio_39",
+		"ejtag_avcpu_loc";
+	        realtek,function = "acpu_ejtag_loc1";
+	};
+
+	dc_fan_sensor_pins: dc_fan_sensor_pins {
+	        realtek,pins = "gpio_47";
+	        realtek,function = "dc_fan_sensor";
+	};
+
+	pwm0_0_pins: pwm0_0_pins {
+	        realtek,pins = "gpio_12";
+	        realtek,function = "pwm0";
+	};
+
+	pwm0_1_pins: pwm0_1_pins {
+	        realtek,pins = "gpio_20";
+	        realtek,function = "pwm0";
+	};
+
+	pwm1_0_pins: pwm1_0_pins {
+	        realtek,pins = "gpio_13";
+	        realtek,function = "pwm1";
+	};
+
+	pwm1_1_pins: pwm1_1_pins {
+	        realtek,pins = "gpio_21";
+	        realtek,function = "pwm1";
+	};
+
+	pwm2_0_pins: pwm2_0_pins {
+	        realtek,pins = "gpio_14";
+	        realtek,function = "pwm2";
+	};
+
+	pwm2_1_pins: pwm2_1_pins {
+	        realtek,pins = "gpio_22";
+	        realtek,function = "pwm2";
+	};
+
+	pwm3_0_pins: pwm3_0_pins {
+	        realtek,pins = "gpio_15";
+	        realtek,function = "pwm3";
+	};
+
+	pwm3_1_pins: pwm3_1_pins {
+	        realtek,pins = "gpio_23";
+	        realtek,function = "pwm3";
+	};
+
+	pwm0_0_pins_disable: pwm0_0_pins_disable {
+	        realtek,pins = "gpio_12";
+	        realtek,function = "gpio";
+	};
+
+	pwm0_1_pins_disable: pwm0_1_pins_disable {
+	        realtek,pins = "gpio_20";
+	        realtek,function = "gpio";
+	};
+
+	pwm1_0_pins_disable: pwm1_0_pins_disable {
+	        realtek,pins = "gpio_13";
+	        realtek,function = "gpio";
+	};
+
+	pwm1_1_pins_disable: pwm1_1_pins_disable {
+	        realtek,pins = "gpio_21";
+	        realtek,function = "gpio";
+	};
+
+	pwm2_0_pins_disable: pwm2_0_pins_disable {
+	        realtek,pins = "gpio_14";
+	        realtek,function = "gpio";
+	};
+
+	pwm2_1_pins_disable: pwm2_1_pins_disable {
+	        realtek,pins = "gpio_22";
+	        realtek,function = "gpio";
+	};
+
+	pwm3_0_pins_disable: pwm3_0_pins_disable {
+	        realtek,pins = "gpio_15";
+	        realtek,function = "gpio";
+	};
+
+	pwm3_1_pins_disable: pwm3_1_pins_disable {
+	        realtek,pins = "gpio_23";
+	        realtek,function = "gpio";
+	};
+
+		usb_cc1_pins: usb_cc1_pins {
+			realtek,pins = "usb_cc1";
+	        realtek,function = "usb_cc1";
+		};
+
+		usb_cc2_pins: usb_cc2_pins {
+	        realtek,pins = "usb_cc2";
+	        realtek,function = "usb_cc2";
+	};
+
+		rtc_pins: rtc_pins {
+			realtek,pins = "gpio_25";
+	        realtek,function = "rtc";
+		};
+
+		prob0_pins: prob0_pins{
+			realtek,pins = "prob_0";
+	        realtek,function = "gpio";
+		};
+
+		prob1_pins: prob1_pins{
+	        realtek,pins = "prob_1";
+	        realtek,function = "gpio";
+	};
+
+
+        };
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-usb.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-usb.dtsi
new file mode 100644
index 00000000..fb2397a
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x-usb.dtsi
@@ -0,0 +1,246 @@
+/*
+ * realtek,type_c-power-gpio: TypeC power, output, default low
+ * realtek,u2host-power-gpio: ehci and u2host power, output, default low
+ * realtek,u3host-power-gpio: 1296 u3host power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		reg = <0x98000000 0x10>;
+
+		//usb_iso_mode;  /* ISO mode is only port suspend (Default disable) */
+		//en_usb_storage_reprobe; /* To enable usb storage re-probe*/
+		//rescue_usb; /* For rescue dtb use */
+
+		clocks = <&iclk_en 16>, /* clk_en_usb */
+			<&iclk_en 13>,  /* clk_en_usb_drd */
+			<&iclk_en 14>,  /* clk_en_usb_host_0 */
+			<&iclk_en 15>;  /* clk_en_usb_host_1 */
+		clock-names = "clk_en_usb", /*clk_en_usb*/
+			"clk_en_phy0_to_host", /*clk_en_usb_drd*/
+			"clk_en_phy1_to_host", /*clk_en_usb_host_0*/
+			"clk_en_phy2_to_host"; /*clk_en_usb_host_1*/
+
+		resets =
+			<&iasr 0x100>,
+			<&irst 14>, /* rstn_usb_drd */
+			<&irst 15>, /* rstn_usb_host */
+			<&iasr 16>, /* rstn_usb_phy_0 */
+			<&iasr 17>, /* rstn_usb_phy_1 */
+			<&iasr 18>, /* rstn_usb_phy_2 */
+			<&irst 19>, /* rstn_usb */
+			<&irst 20>; /* rstn_type_c */
+
+		reset-names = "apply",
+			"usb_host0", /*rstn_usb_drd*/
+			"usb_host1", /*rstn_usb_host*/
+			"u2phy0", /*rstn_usb_phy_0*/
+			"u2phy1", /*rstn_usb_phy_1*/
+			"u2phy2", /*rstn_usb_phy_2*/
+			"usb", /*rstn_usb*/
+			"type_c"; /*rstn_type_c*/
+
+		gpio0: gpio0 {
+			realtek,power-gpio = <&rtk_iso_gpio 48 1 3>;
+			power_low_active;
+
+		};
+		gpio1: gpio1 {
+			realtek,power-gpio = <&rtk_iso_gpio 49 1 3>;
+			power_low_active;
+		};
+
+		port0 {
+			usb = <&dwc3_drd>;
+			type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+			gpio = <&gpio0>;
+		};
+		port1 {
+			usb = <&dwc3_u2host>;
+			//gpio = <&gpio1>;
+		};
+		port2 {
+			usb = <&dwc3_u2host>;
+			gpio = <&gpio1>;
+		};
+
+		rtk_usb {
+			power_ctrl_reg {
+				usb_ctrl = <0x98007fb0>;
+				/* Port 0~2 */
+				usb0_sram_pwr3 = <0x98007f7c>;
+				usb0_sram_pwr4 = <0x98007f80>;
+
+				/* l4_icg */
+				p0_l4_icg = <0x98013364>;
+				p1_l4_icg = <0x98013d60>;
+
+				usb_power_cut; /* Non ISO mode and power cut (Default disable power cut) */
+				               /* Note if enable ISO mode, then power_cut will not effective*/
+			};
+			type_c {
+				realtek,connector_switch-gpio = <&rtk_iso_gpio 11 1 1>;
+			};
+		};
+	};
+
+	dwc3_drd_usb2phy: dwc3_drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x98028280 0x4>, <0x98013214 0x4>;
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0x81 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		reg = <0x98013200 0x200>;
+		interrupts = <0 21 4>;
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x98020000 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_drd_usb2phy>;
+			dr_mode = "peripheral"; /*otg, host, peripheral*/
+			//tx-fifo-resize;
+			snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+		};
+
+		dwc3_type_c: rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			reg = <0x98013200 0x200 0x98007220 0x20>;
+			interrupts = <0 60 4>;
+			drd_mode;  /*depend on dwc3 dr_mode = "peripheral"*/
+			//debug; /*to enable debug log*/
+			delay_probe_work; /*To delay probe work*/
+			ordered_probe; /*ordered probe in delay work*/
+			boot_check_time = <30000>; /*ms (At boot Device switch Host time)*/
+			filter_config_channel_signal; /* A sw debounce to filter cc signal */
+
+			default_revision = <0xA00>;
+			A00 {
+				cc_dfp_mode = "dfp_3_0"; /*dfp_3_0, dfp_1_5, dfp_usb*/
+				rd_config = "internal"; /*internal, extrenal*/
+				cc1_rp_4p7k_code = <0xC>;
+				cc1_rp_36k_code = <0xB>;
+				cc1_rp_12k_code = <0xE>;
+				cc1_rd_code = <0x10>; /*for internal rd*/
+				cc1_vref_ufp = /bits/ 8
+					<0x1 0x0 0x0>; /*<1p23v,0p66v,0p2v>*/
+				cc1_vref_dfp_usb = /bits/ 8
+					<0x7 0x0 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc1_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x0>; /*<1_1p6v,0p4v,0p2v>*/
+				cc1_vref_dfp_3_0 = /bits/ 8
+					<0x0 0x0 0x0>; /*<2p6v,0p8v,0p2v>*/
+				cc2_rp_4p7k_code = <0xB>;
+				cc2_rp_36k_code = <0x9>;
+				cc2_rp_12k_code = <0xE>;
+				cc2_rd_code = <0xF>; /*for internal rd*/
+				cc2_vref_ufp = /bits/ 8
+					<0x3 0x2 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc2_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc2_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc2_vref_dfp_3_0 = /bits/ 8
+					<0x1 0x3 0x2>; /*<2p6v,0p8v,0p2v>*/
+			};
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x98031280 0x4>, <0x98031284 0x4>, <0x98013C14 0x4>;
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+		phyN = <2>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0x81 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+		phy1 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0x81 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x98013C00 0x200>;
+		interrupts = <0 21 4>;
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "okay";
+
+		dwc3_u2host@98029000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x98029000 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_u2host_usb2phy>;
+			dr_mode = "host"; /*only host*/
+			//tx-fifo-resize;
+			snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+		};
+	};
diff --git a/arch/arm/boot/dts/realtek/rtd139x/rtd-139x.dtsi b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x.dtsi
new file mode 100644
index 00000000..e49a18c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd139x/rtd-139x.dtsi
@@ -0,0 +1,1102 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include <dt-bindings/thermal/thermal.h>
+#include <dt-bindings/clock/rtk,clock-rtd139x.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <dt-bindings/reset/rtk,reset-rtd139x.h>
+#include <dt-bindings/power/rtk,power-rtd139x.h>
+/include/ "rtd-139x-pinctrl.dtsi"
+/include/ "rtd-139x-irda.dtsi"
+/include/ "rtd-1395-usb.dtsi"
+/include/ "rtd-139x-dcsys-debug.dtsi"
+
+/{
+	compatible = "realtek,rtd1395";
+	interrupt-parent = <&gic>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+
+	aliases {
+		serial0 = &uart0;
+		i2c0 = &i2c_0;
+		i2c1 = &i2c_1;
+		i2c5 = &i2c_5;
+		hwsem0 = &sb2_lock1;
+		hwsem1 = &sb2_lock2;
+	};
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A53_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x0>;
+			enable-method = "rtk-spin-table";
+			next-level-cache = <&a53_l2>;
+		};
+
+		A53_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x1>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a53_l2>;
+		};
+
+		A53_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x02>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a53_l2>;
+		};
+
+		A53_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x03>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a53_l2>;
+		};
+
+		a53_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	soc@0 {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x98000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+	};
+
+	efuse@98017000 {
+		compatible = "realtek,efuse";
+		reg = <0x98017000 0x400>;
+		read-only;
+		status = "okay";
+
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		nvmem-cells = <&otp_cpu_iddq>, <&otp_top_iddq>;
+		nvmem-cell-names = "cpu-iddq", "top-iddq";
+
+		otp_cpu_iddq: cpu-iddq@2C5 {
+			reg = <0x2C5 0x1>;
+			bits = <0 8>;
+		};
+		otp_top_iddq: top-iddq@2C6 {
+			reg = <0x2C6 0x1>;
+			bits = <0 8>;
+		};
+	};
+
+	sb2_lock0: sb2-lock@9801A000 {
+		compatible = "realtek,sb2-sem";
+		reg = <0x9801A000 0x4>;
+	};
+
+	sb2_lock1: sb2-lock@9801A620 {
+		reg = <0x9801A620 0x4>;
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+	};
+
+	sb2_lock2: sb2-lock@9801A624 {
+		reg = <0x9801A624 0x4>;
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+	};
+
+	sb2_lock3: sb2-lock@9801A63C {
+		reg = <0x9801A63C 0x4>;
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-avlog";
+	};
+
+	/* fixed clock */
+	osc27M: osc27M {
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <27000000>;
+		clock-output-names = "osc27M";
+	};
+
+	/* mmio */
+	crt_mmio: mmio@98000000 {
+		compatible = "realtek,mmio";
+		reg = <0x98000000 0x600>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	iso_mmio: mmio@98007088 {
+		compatible = "realtek,mmio";
+		reg = <0x98007088 0x8>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	/* clock-controller */
+	clk_en_1: clk-en@9800000c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x9800000c 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0xc>;
+		clock-output-names =
+		/* 0 ~ 7 */	"clk_en_misc",      "clk_en_pcie0",
+				"",                 "clk_en_gspi",
+				"",                 "",
+				"clk_en_iso_misc",  "clk_en_sds",
+		/* 8 ~ 15 */	"clk_en_hdmi",      "",
+				"",                 "",
+				"",                 "",
+				"",                 "",
+		/* 16 ~ 23 */	"clk_en_lsadc",     "clk_en_se",
+				"",                 "clk_en_cp",
+				"clk_en_md",        "clk_en_tp",
+				"clk_en_rsa",       "clk_en_nf",
+		/* 24 ~ 31 */	"clk_en_emmc",      "clk_en_cr",
+				"clk_en_sdio_ip",   "clk_en_mipi",
+				"clk_en_emmc_ip",   "",
+				"clk_en_sdio",      "clk_en_sd_ip";
+		ignore-unused-clocks =
+			"clk_en_misc",
+			"clk_en_iso_misc",
+			"clk_en_cp",
+			"clk_en_md",
+			"clk_en_tp",
+			"clk_en_hdmi";
+		ignore-pm-clocks =
+			"clk_en_hdmi";
+	};
+
+	clk_en_2: clk-en@98000010 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x98000010 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x10>;
+		clock-output-names =
+		/* 0 ~ 7 */	"",                 "clk_en_misc_i2c_5",
+				"",		    "clk_en_jpeg",
+				"",                 "",
+				"clk_en_misc_sc",   "",
+		/* 8 ~ 15 */	"",                 "",
+				"",                 "",
+				"",                 "",
+				"",                 "",
+		/* 16 ~ 23 */	"",                 "",
+				"",                 "",
+				"",                 "",
+				"",                 "",
+		/* 24 ~ 31 */	"",                 "clk_en_hse",
+				"",                 "clk_en_ur2",
+				"clk_en_ur1",       "clk_en_fan",
+				"clk_en_dcphy_0",   "clk_en_dcphy_1";
+		ignore-unused-clocks =
+			"clk_en_dcphy_0",
+			"clk_en_dcphy_1";
+	};
+
+	iclk_en: clk-en@9800708c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x9800708c 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&iso_mmio 0x4>;
+		clock-output-names =
+		/* 0 ~ 7 */	"",                  "",
+				"clk_en_misc_cec0",  "clk_en_cbusrx_sys",
+				"clk_en_cbustx_sys", "clk_en_cbus_sys",
+				"clk_en_cbus_osc",   "clk_en_misc_ir",
+		/* 8 ~ 15 */	"clk_en_ur0",        "clk_en_i2c0",
+				"clk_en_i2c1",       "clk_en_etn_250m",
+				"clk_en_etn_sys",    "clk_en_usb_drd",
+				"clk_en_usb_host_0", "clk_en_usb_host_1",
+		/* 16 */	"clk_en_usb";
+	};
+
+	cc: clock-controller@98000000 {
+		compatible = "realtek,clock-controller";
+		reg = <0x98000000 0x600>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	/* reset-controller */
+	rst1: soft-reset@98000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000000 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+		pm-ignore-bits = <0x00001000>;
+	};
+
+	rst2: soft-reset@98000004 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000004 0x4>;
+		realtek,mmio = <&crt_mmio 0x4>;
+		#reset-cells = <1>;
+	};
+
+	rst3: soft-reset@98000008 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000008 0x4>;
+		realtek,mmio = <&crt_mmio 0x8>;
+		#reset-cells = <1>;
+	};
+
+	rst4: soft-reset@98000050 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000050 0x4>;
+		realtek,mmio = <&crt_mmio 0x50>;
+		#reset-cells = <1>;
+	};
+
+	irst: soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98007088 0x4>;
+		realtek,mmio = <&iso_mmio 0x0>;
+		#reset-cells = <1>;
+	};
+
+	iasr: usb-async-soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98007088 0x4>;
+		realtek,mmio = <&iso_mmio 0x0>;
+		#reset-cells = <1>;
+		async-group = <0>;
+	};
+
+	pd0: power-controller@98007000 {
+		compatible = "realtek,rtd139x-power-controller", "simple-bus";
+		reg = <0x98007000 0x1000>;
+		resets = <&rst1 RSTN_VE1>, <&rst1 RSTN_VE2>;
+		reset-names = "ve1", "ve2";
+		#power-domain-cells = <1>;
+	};
+
+	timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <1 13 0xf08>,
+			<1 14 0xf08>,
+			<1 11 0xf08>,
+			<1 10 0xf08>;
+		clock-frequency = <27000000>;
+	};
+
+	gic: interrupt-controller@FF010000 {
+		compatible = "arm,gic-400";
+		#interrupt-cells = <3>;
+		interrupt-controller;
+		reg = <0xFF011000 0x1000>,
+			<0xFF012000 0x1000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <0 48 4>;
+	};
+
+	pinctrl: pinctrl@9804E000 {
+		compatible = "realtek,rtk139x-pinctrl";
+		reg = <0x9804E000 0x86>;
+		#gpio-range-cells = <3>;
+		pinctrl-names = "default";
+		pinctrl-0 = /* <&spi_pins_loc_gpio>, */ /* <&spi_pins_loc_gpio>: GPIO0~3 mux to gpio; <&spi_pins_loc_spi>: GPIO0~3 mux to SPI*/
+			<&spdif_pins>,
+			<&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>,
+			<&scpu_ejtag_pins_loc_0>;
+		status = "okay";
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x9801B000 0x100>, <0x98007000 0x100>;/* MISC_TOP, MISC_ISO */
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk139x-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <57>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x98007000 0x100>,
+			<0x98007100 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 57>;
+		status = "okay";
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd129x-hdmitx";
+		reg = <0x9800d000 0x560>, /* HDMITX */
+			<0x98007200 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 7 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&rst1 RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		status = "okay";
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 31>;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtk139x-hdcptx";
+		reg = <0x9800d000 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		status = "okay";
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007800 0x400>,
+			<0x98007000 0x100>;
+		interrupts-st-mask = <0x4>;
+		interrupts = <1 2>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart0_pins>;
+		clocks = <&iclk_en CLK_EN_MISC_UR0>;
+		clock-frequency = <27000000>; /* This value must be override by the board. */
+		status = "okay";
+	};
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B200 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart1_pins>;
+		clocks = <&clk_en_2 CLK_EN_UR1>;
+		resets = <&rst2 RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "okay";
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B400 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR2>;
+		resets = <&rst2 RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "disabled"; /* Disable UR2 first since we don't use it now */
+	};
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x98016000 0x1000>,   /* ETN */
+			<0x98007000 0x1000>, /* ISO */
+			<0x9801c000 0x2000>, /* SBX and SC_WRAP for ACP ctrl */
+			<0x980172c8 0x20>,    /* EFUSE_OTP_REG */
+			<0x981c8000 0x2000>, /* SDS */
+			<0x9804e000 0x1000>; /* ISO pinmux */
+		interrupts = <0 22 4>;
+		pinctrl-names = "default",
+				"sgmii";
+		pinctrl-0 = <&etn_led_pins>;
+		pinctrl-1 = <&sgmii_mdio_pins>;
+		local-mac-address = [00 10 20 30 40 50];
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		wake-mask0 = [3f 30 80 c0 3f 10 80 ff ff 1f 00 00 00 00 00 00];
+		wake-crc0 = <0x8d25>;
+		wake-mask1 = [3f 30 80 c0 3f 10 00 00 c0 ff ff 0f 00 00 00 00];
+		wake-crc1 = <0x8d25>;
+		wake-mask2 = [3f 30 80 c0 3f 10 00 00 00 00 00 00 80 ff ff 1f];
+		wake-crc2 = <0x8d25>;
+		wake-mask3 = [3f 30 10 00 c0 ff ff 03 01 f8 ff ff 01 00 00 00];
+		wake-crc3 = <0x11da>;
+		wake-mask4 = [3f 30 10 00 c0 ff ff 03 01 00 00 fc ff ff 00 00];
+		wake-crc4 = <0x11da>;
+		wake-mask5 = [3f 30 10 00 c0 ff ff 03 01 00 00 00 00 00 00 f8];
+		wake-crc5 = <0x15f8>;
+		output-mode = <0>; /* 0:embedded PHY, 1:SGMII to MAC, 2:SGMII to PHY */
+		ext-phy-id = <3>; /* 0 ~ 31, only valid when output-mode = 2 */
+		bypass = <1>; /* 0: disable, 1: enable */
+		acp = <0>; /* 0: disable, 1: enable */
+		eee = <1>; /* 0: disable, 1: enable */
+		clocks = <&iclk_en CLK_EN_ETN_250M>,
+			<&iclk_en CLK_EN_ETN_SYS>,
+			<&clk_en_1 CLK_EN_SDS>;
+		clock-names = "etn_250m",
+			"etn_sys",
+			"sds";
+		resets = <&irst IRSTN_GMAC>,
+			<&irst IRSTN_GPHY>,
+			<&rst1 RSTN_SDS_REG>,
+			<&rst1 RSTN_SDS>,
+			<&rst2 RSTN_PCIE0_POWER>,
+			<&rst2 RSTN_PCIE0_PHY>,
+			<&rst4 RSTN_PCIE0_SGMII_MDIO>,
+			<&rst4 RSTN_PCIE0_PHY_MDIO>;
+		reset-names = "gmac",
+			"gphy",
+			"sds_reg",
+			"sds",
+			"pcie0_power",
+			"pcie0_phy",
+			"pcie0_sgmii_mdio",
+			"pcie0_phy_mdio";
+		status = "okay";
+	};
+
+	timer0@9801B000 {
+		compatible = "realtek,rtk-timer0";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 17 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	timer1@9801B000 {
+		compatible = "realtek,rtk-timer1";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 18 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	sdio: sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 27 1 1>;
+		reg = <0x98010c00 0x200>,
+			<0x98000000 0x200000>;
+		interrupts = <0 45 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdio_pins_1>;
+		clocks = <&clk_en_1 CLK_EN_SDIO>,
+			<&clk_en_1 CLK_EN_SDIO_IP>;
+		clock-names = "sdio",
+			"sdio_ip";
+		resets = <&rst2 RSTN_SDIO>;
+		status = "okay";
+	};
+
+	sd: sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_iso_gpio 30 1 0>, /*sd power , output, default high  (poweroff) */
+			<&rtk_iso_gpio 34 0 1>,
+			<&rtk_iso_gpio 35 0 1>;
+		reg = <0x98000000 0x400>, /* CRT */
+			<0x98010400 0x200>, /* SDMMC */
+			<0x9801A000 0x400>, /* BS2 */
+			<0x9804E000 0x40>, /* ISO */
+			<0x98010A00 0x40>, /* SDIO */
+			<0x98007000 0x200>;
+		interrupts = <0 44 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>;
+			    /*<&sdcard_pins_high>;*/
+		clocks = <&clk_en_1 CLK_EN_CR>,
+			<&clk_en_1 CLK_EN_SD_IP>;
+		clock-names = "sd",
+			"sd_ip";
+		resets = <&rst2 RSTN_CR>;
+		status = "okay";
+	};
+
+	nand: nand@98010000 {
+		compatible = "Realtek,rtk1295-nand";
+		reg = <0x98010000 0x400>, /* NWC */
+			<0x9801F000 0x400>; /* SWC */
+		clocks = <&clk_en_1 CLK_EN_NF>;
+		resets = <&rst1 RSTN_NF>;
+		status = "disabled";
+	};
+
+	emmc: emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		reg = <0x98012000 0xa00>, /*EMMC*/
+			<0x98000000 0x600>, /*CRT */
+			<0x9801A000 0x80>, /*SB2*/
+			<0x9801B000 0x150>, /*MISC*/
+			<0x9801a954 0x20>,  /*SB2_DBG*/
+			<0x9804E000 0x100>; /* ISO */
+		interrupts = <0 42 4>;
+		speed-step = <2>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_1 CLK_EN_EMMC>,
+			<&clk_en_1 CLK_EN_EMMC_IP>;
+		clock-names = "emmc",
+			"emmc_ip";
+		resets = <&rst2 RSTN_EMMC>;
+		reset-names = "emmc";
+		status = "okay";
+		pddrive_nf_s0 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+		pddrive_nf_s1 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for ddr50 */
+		pddrive_nf_s2 = <1 0x4 0x4 0x4 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+		pddrive_nf_s3 = <1 0x7 0x2 0x3 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs400 */
+		phase_tuning = <0 0>; /* arg0: tx tuning switch, arg1: rx tuning switch*/
+		dqs_tuning = <1>;
+	};
+
+	gpu: gpu@981d0000 {
+		compatible = "arm,mali-470", "arm,mali-utgard";
+		reg = <0x981D0000 0x30000>;
+		interrupts =
+			<0 75 4>, <0 76 4>,
+			<0 77 4>, <0 78 4>,
+			<0 79 4>, <0 80 4>,
+			<0 81 4>, <0 82 4>,
+			<0 83 4>, <0 84 4>,
+			<0 85 4>, <0 86 4>;
+		interrupt-names =
+			"IRQPP0", "IRQPPMMU0",
+			"IRQPP1", "IRQPPMMU1",
+			"IRQPP2", "IRQPPMMU2",
+			"IRQPP3", "IRQPPMMU3",
+			"IRQGP", "IRQGPMMU",
+			"IRQPMU", "IRQPP";
+		power-domains = <&pd0 RTD139X_PD_GPU>;
+		pmu_domain_config = <0x1 0x1 0x2 0x4 0x8 0x0 0x0 0x0 0x0 0x0 0x1 0x0>;
+		pmu_switch_delay = <0xff>;
+		clocks = <&cc CC_CLK_GPU>;
+		clock-names = "clk_mali";
+		resets = <&rst1 RSTN_GPU>;
+		status = "okay";
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk1295-pu_pll";
+		reg = <0x98000000 0x200>;
+	};
+
+	jpeg: jpeg@9803e000 {
+		compatible = "Realtek,rtk1295-jpeg";
+		reg = <0x9803e000 0x1000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_2 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&rst2 RSTN_JPEG>;
+		status = "okay";
+	};
+
+	ve1: ve1@98040000 {
+		compatible = "Realtek,rtk1295-ve1";
+		reg = <0x98040000 0x8000>,
+			<0x98008000 0x1000>,
+			<0x98007000 0x30>;
+		interrupts = <0 53 4>, <0 54 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			<&cc CC_CLK_VE2>,
+			<&cc CC_CLK_VE2_BPU>,
+			<&cc CC_CLK_SYSH>,
+			<&cc CC_PLL_VE1>,
+			<&cc CC_PLL_VE2>;
+		clock-names = "clk_ve1",
+			"clk_ve2",
+			"clk_ve2_bpu",
+			"clk_sysh",
+			"pll_ve1",
+			"pll_ve2";
+		resets = <&rst1 RSTN_VE1>,
+			<&rst1 RSTN_VE2>;
+		reset-names = "ve1",
+			"ve2";
+		assigned-clocks =        <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>, <&cc CC_CLK_VE2_BPU>;
+		assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>, <&cc CC_PLL_VE1>;
+		assigned-clock-rates =   <550000000>,      <715000000>,      <550000000>;
+		status = "okay";
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x98000000 0x200000>;
+		status = "okay";
+	};
+
+	md: md@9800b000 {
+		compatible = "realtek,md";
+		reg = <0x9800b000 0x1000>;
+		interrupts = <0 38 4>;
+		clocks = <&clk_en_1 CLK_EN_MD>;
+		resets = <&rst1 RSTN_MD>;
+		status = "okay";
+	};
+
+	se: se@9800c000 {
+		compatible = "realtek,se";
+		reg = <0x9800c000 0x1000>;
+		interrupts = <0 20 4>;
+		clocks = <&clk_en_1 CLK_EN_SE>;
+		resets = <&rst1 RSTN_SE>;
+		status = "okay";
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x9801b000 0x1000>;
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x9801d000 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x9801a000 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	rpc@9801a104 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x9801a104 0xc>, /* rpc intr en */
+			<0x01ffe000 0x4000>, /* rpc ring buffer */
+			<0x0002f000 0x1000>, /* rpc common */
+			<0x9801a020 0x4>; /* rbus sync */
+		interrupts = <0 33 4>;
+		status = "okay";
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007000 0x400>,
+			<0x98007400 0x100>;
+		interrupts = <1 5>;
+		resets = <&irst IRSTN_IR>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&ir_rx_pins>;
+		clocks = <&iclk_en CLK_EN_MISC_IR>;
+		status = "okay";
+	};
+        watchdog@0x98007680 {
+                compatible = "realtek,rtk-watchdog";
+                reg = <0x9801b5b0 0x20>, /*misc watchdog for SCPU NMI */
+                        <0x9801b000 0x10>,
+                        <0x98007680 0x100>; /*iso watchdog for oe workaround */
+                interrupts = <0 0 4>;
+                rst-oe = <0>; /* 0:input, 1:output */
+                rst-oe-for-init = <1>; /* 0:input, 1:output */
+                timeout-sec = <20>;
+                status = "okay";
+        };
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x98007600 0x100>;
+		rst-reg-offset = <0x40>;
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x98007D00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 8>;
+		i2c-num = <0>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_0>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C0>;
+		resets = <&irst IRSTN_I2C_0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x98007C00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 11>;
+		i2c-num = <1>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_1>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C1>;
+		resets = <&irst IRSTN_I2C_1>;
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x9801BB00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 14>;
+		i2c-num = <5>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_5>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+		resets = <&rst2 RSTN_I2C_5>;
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk-dw-apb-ssi";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 27>; /* SPI_INT */
+		reg = <0x9801BD00 0x100>, /* DW SPI */
+			<0x9801B300 0x18>; /* SPI wrapper */
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins_0>;
+		/*spi-cs-gpio = <&rtk_iso_gpio 6 1 1>;*/
+		num-chipselect = <1>;
+		bus-num = <0>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		clock-frequency = <256000000>;
+		resets = <&rst1 RSTN_GSPI>;
+		status = "disabled";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x980070D0 0xC>;
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm0_0_pins>;
+			pinctrl-1 = <&pwm0_0_pins_disable>;
+			pinctrl-2 = <&pwm0_1_pins>;
+			pinctrl-3 = <&pwm0_1_pins_disable>;
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm1_0_pins>;
+			pinctrl-1 = <&pwm1_0_pins_disable>;
+			pinctrl-2 = <&pwm1_1_pins>;
+			pinctrl-3 = <&pwm1_1_pins_disable>;
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm2_0_pins>;
+			pinctrl-1 = <&pwm2_0_pins_disable>;
+			pinctrl-2 = <&pwm2_1_pins>;
+			pinctrl-3 = <&pwm2_1_pins_disable>;
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm3_0_pins>;
+			pinctrl-1 = <&pwm3_0_pins_disable>;
+			pinctrl-2 = <&pwm3_1_pins>;
+			pinctrl-3 = <&pwm3_1_pins_disable>;
+		};
+	};
+
+	rtk_fan: rtk_fan@9801BC00 {
+		compatible = "Realtek,rtd129x-fan";
+		reg = <0x9801BC00 0x14>, <0x9801A910 0x4>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 29>;
+		status = "disabled";
+
+		pwms = <&pwm 1 37878>; // (1) pwm node (2) pwm id (3) out period_ns (1/26400 ns)
+
+		timer_target = <0x100000>;
+		fan_debounce = <0x0>;// 0x0~0x7
+		clocks = <&clk_en_2 CLK_EN_FAN>;
+		resets = <&rst4 RSTN_FAN>;
+	};
+
+	rtk-lsadc@98007900 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 16>, <1 17>; /* LSADC0_INT, LSADC1_INT */
+		reg = <0x98007000 0x4>, /* ISO_ISR */
+			<0x98007900 0x200>, /* LSADC */
+			<0x9800034C 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>, /* LSADC0 0:disable; 1:enable */
+						<1>; /* LSADC1 0:disable; 1:enable */
+		vdd_mux_sel = <0>; /* 0:VDD1; 1:VDD2 */
+		vdd_mux1 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux2 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux_en = <1>; /* 0:disable; 1:enable */
+		clocks = <&clk_en_1 CLK_EN_LSADC>;
+		resets = <&rst1 RSTN_LSADC>;
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <1>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc1-pad0 {
+			//compatible = "Realtek,rtk-lsadc1-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <0>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+
+		rtk-lsadc1-pad1 {
+			//compatible = "Realtek,rtk-lsadc1-pad1";
+			activate = <1>; /* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0: Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <1>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+	};
+
+	cec0@98037800 {
+		compatible = "Realtek,rtk-cec0";
+		reg = <0x98037800 0xe0>,
+			<0x98007000 0x100>,
+			<0x98037500 0x100>;
+		interrupts = <0 26 4>;
+		module-enable = <1>;
+		clocks = <&cc CC_CLK_SYS>,
+			<&iclk_en CLK_EN_CBUS_OSC>,
+			<&iclk_en CLK_EN_CBUS_SYS>,
+			<&iclk_en CLK_EN_CBUSTX_SYS>,
+			<&iclk_en CLK_EN_CBUSRX_SYS>;
+		clock-names = "sys",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys";
+		resets = <&irst IRSTN_CBUS>,
+			<&irst IRSTN_CBUSTX>,
+			<&irst IRSTN_CBUSRX>;
+		reset-names = "cbus",
+			"cbustx",
+			"cbusrx";
+		status = "okay";
+	};
+
+	rfkill: rfkilligpio {
+		compatible = "Realtek,rfkill";
+		gpios = <&rtk_iso_gpio 28 1 0>; /*bt power , output, default low */
+		status = "okay";
+	};
+
+	/*
+	 * Suspend GPIO control
+	 *
+	 * [wakeup-gpio-list]
+	 * rtk_iso_gpio 10: BT wakeup host pin
+	 * rtk_iso_gpio 26: WiFi wakeup host pin
+	 *
+	 * [wakeup-gpio-enable]
+	 * Wakeup from BT: <0> disable
+	 * Wakeup from WiFi: <0> disable
+	 *
+	 * [wakeup-gpio-activity]
+	 * BT pin: <0> active low
+	 * WIFI pin: <0> active low
+	 */
+	power-management@0 {
+		compatible = "Realtek,power-management";
+		system-power-controller;
+		reg = <0x98000000 0x1800>, /* CRT */
+			<0x98006000 0x1000>, /* AIO */
+			<0x98007000 0x1000>, /* ISO */
+			<0x98018000 0x2000>, /* TVE */
+			<0x9801A000 0x1000>, /* SB2 */
+			<0x9801B000 0x1000>; /* MISC */
+		suspend-mode = <0>; // 0:SUSPEND_TO_RAM, 1:SUSPEND_TO_COOLBOOT, 2:SUSPEND_TO_WFI
+		pwms = <&pwm 0 37878>;
+		wakeup-gpio-list = <&rtk_iso_gpio 10 0 1>,<&rtk_iso_gpio 26 0 1>;
+		wakeup-gpio-enable = <1>, <1>;
+		wakeup-gpio-activity = <0>, <0>;
+		status = "okay";
+	};
+
+	rng@98001000 {
+		compatible = "Realtek,rtk-rng";
+		reg = <0x98001000 0x40>;
+	};
+
+	smartcard@9801BE00 {
+		compatible = "Realtek,rtk-smc";
+		interrupts = <0 63 4>;      /* SC0_INT*/
+		reg = <0x9801B000 0x100>, /* MISC interrupt */
+			<0x9801BE00 0x80>; /* SmartCard */
+		smc-num = <0>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&smartcard_pins>;
+		clock-names = "clk_en_misc_sc";
+		clocks = <&clk_en_2 CLK_EN_MISC_SC>;
+		resets = <&rst2 RSTN_MISC_SC>;
+		status = "okay";
+		lsic_control{
+			pin_cmd_vcc = <&rtk_iso_gpio 22 1 0>;  /* pin cmd_vcc , default low */
+			pin_pwr_sel = <&rtk_iso_gpio 53 1 0>;  /* pin pwr_sel , default 0 */
+			cmd_vcc_en = <1>;
+			cmd_vcc_polarity = <0>; /* low active */
+			pwr_sel_en = <1>;
+			pwr_sel_polarity = <1>; /* high actve 1: 5v */
+		};
+	};
+
+	dvfs: cpu-dvfs {
+	};
+
+	cpu_tm: thermal-sensor@9801D150 {
+		compatible = "realtek,rtd139x-thermal-sensor";
+		reg = <0x9801D150 0x1C>;
+		#thermal-sensor-cells = <0>;
+		status = "okay";
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+			sustainable-power = <1200>;
+
+			trips {
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <0>;
+					type = "critical";
+				};
+			};
+		};
+	};
+
+	mcp@0 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x98015000 0x1000>,
+			<0x98014000 0x1000>;
+		status = "okay";
+	};
+
+	rtk_fw_dbg_info {
+		compatible = "Realtek,rtk_fw_dbg_info";
+		status = "okay";
+	};
+
+	rtk_cvbs_detect {
+		compatible = "realtek,rtd1395-cvbs-switch";
+		gpio_mute = <&rtk_iso_gpio 47 1 0>; /*audio DAC mute*/
+		gpios = <&rtk_iso_gpio 21 0 2>;
+		gpio-activity = <1>; /*0: low active  1: high active*/
+		detect-mode = <1>; /* 0:vdac detect, 1: gpio detect*/
+		status = "okay";
+	};
+
+	hse: hse@98005000 {
+		compatible = "realtek,highspeed-streaming-engine";
+		reg = <0x98005000 0x1000>;
+		interrupts = <0 27 4>;
+		clocks = <&clk_en_2 CLK_EN_HSE>;
+		resets = <&rst1 RSTN_HSE>;
+		status = "okay";
+
+		engine-0-enabled;
+		engine-1-disabled;
+	};
+
+	rtktrace@3b100000 {
+		compatible = "Realtek,trace";
+		/* This is only temporary address, adjust it if feature desired */
+		reg = <0x3b100000 0x100000>,
+			<0x3b200000 0x40000>;
+		reg-names = "rtk_trace_res",
+			"rtk_trace_vmap";
+		status = "disabled";
+	};
+
+	audio_in: audio-in {
+		compatible = "realtek,audio-in", "adc";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2s_out_4pins>, <&i2s_in_pins>;
+		status = "disabled";
+	};
+};
+
+#include "rtd-139x-dvfs.dtsi"
+#include "rtd-139x-pcie.dtsi"
+
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/Makefile b/arch/arm/boot/dts/realtek/rtd13xx/Makefile
new file mode 100755
index 00000000..a1b4b88
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/Makefile
@@ -0,0 +1,19 @@
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-2GB-avb.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-2GB-avb-tee.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-nand-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1315-reddiscs-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1315-reddiscs-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1315-reddiscs-512MB.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1315-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1315-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += hank-fpga.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-2GB-avb-dp.dtb
+always          := $(dtb-y)
+subdir-y        := $(dts-dirs)
+clean-files     := *.dtb
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/dtbo/rtd-1319-pymparticle-overlay.dts b/arch/arm/boot/dts/realtek/rtd13xx/dtbo/rtd-1319-pymparticle-overlay.dts
new file mode 100644
index 00000000..ace0231
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/dtbo/rtd-1319-pymparticle-overlay.dts
@@ -0,0 +1,78 @@
+/dts-v1/;
+/plugin/;
+
+
+/ {
+	board_id = <0x0>;
+
+};
+
+
+&uart0 {
+	status = "okay";
+};
+
+&uart1 {
+	status = "okay";
+};
+
+&uart2{
+	status = "disabled";
+};
+
+&nic{
+	status = "okay";
+};
+
+&i2c_0{
+	status = "okay";
+};
+
+&i2c_1{
+	status = "okay";
+};
+
+&i2c_3{
+	status = "okay";
+};
+
+&i2c_5{
+	status = "okay";
+};
+
+&spi_0{
+	status = "disabled";
+};
+
+&pwm{
+	status = "okay";
+};
+
+&sd{
+	status = "okay";
+};
+
+&sdio{
+	status = "okay";
+};
+
+&emmc{
+	status = "okay";
+};
+
+&gpu{
+	status = "okay";
+};
+
+&cpu_tm{
+	status = "okay";
+};
+
+&jpeg{
+	status = "okay";
+};
+
+&ve1{
+	status = "okay";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/dtbo/rtd-13xx-dtboimg.cfg b/arch/arm/boot/dts/realtek/rtd13xx/dtbo/rtd-13xx-dtboimg.cfg
new file mode 100644
index 00000000..343eb43
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/dtbo/rtd-13xx-dtboimg.cfg
@@ -0,0 +1,3 @@
+#global options
+rtd-1319-pymparticle-overlay.dtbo
+     id=/:board_id
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/hank-fpga.dts b/arch/arm/boot/dts/realtek/rtd13xx/hank-fpga.dts
new file mode 100644
index 00000000..8c05570
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/hank-fpga.dts
@@ -0,0 +1,54 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+
+#include "hank-fpga.dtsi"
+
+/ {
+	model= "Realtek_Hank_FPGA";
+	compatible =  "realtek,hank";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init loglevel=7";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x20000000>;	/* 512 MB */
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/hank-fpga.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/hank-fpga.dtsi
new file mode 100644
index 00000000..ee09449
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/hank-fpga.dtsi
@@ -0,0 +1,140 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+
+/{
+	compatible = "realtek,hank";
+	interrupt-parent = <&gic>;
+	#address-cells = <0x2>;
+	#size-cells = <0x2>;
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A55_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x000>;
+			enable-method = "rtk-spin-table";
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x100>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		a55_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	rtk_pm@0 {
+		compatible = "realtek,pm";
+		system-power-controller;
+		reg = <0x0 0x98000000 0x0 0x1800>, /* CRT */
+			<0x0 0x98007000 0x0 0x1000>, /* ISO */
+			<0x0 0x9801A000 0x0 0x1000>; /* SB2 */
+		wakeup-flags = <0x3F>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+		status = "okay";
+	};
+
+	soc@0 {
+		reg = <0x0 0x98000000 0x0 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x0 0x98000000 0x0 0x200000>;
+	};
+
+	gic: interrupt-controller@FF100000 {
+		compatible = "arm,gic-v3";
+		#interrupt-cells = <3>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		interrupt-controller;
+		redistributor-stride = <0x0 0x20000>;
+		#redistributor-regions = <1>;
+		reg = <0x0 0xFF100000 0x0 0x10000>, // GICD
+		      <0x0 0xFF140000 0x0 0x200000>; // GICR
+		interrupts = <GIC_PPI 9 4>;
+	};
+
+	timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <GIC_PPI 13 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 14 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 11 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 10 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>;
+		clock-frequency = <33000000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <0 48 4>;
+		interrupt-affinity = <&A55_0>;
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP MISC_ISO */
+			  <0x0 0x98007000 0x0 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x98007800 0x0 0x400>,
+			  <0x0 0x98007000 0x0 0x100>;
+		interrupts = <0 68 4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clock-frequency = <27000000>; /* This value must be override by the board. */
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x0 0x9801d000 0x0 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x0 0x9801a000 0x0 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	watchdog@98007680 {
+		compatible = "Realtek,rtk-watchdog";
+		reg = <0x0 0x98007680 0x0 0x100>;
+		rst-oe = <0>; /* 0:input, 1:output */
+		status = "okay";
+	};
+
+	rtk-rstctrl@98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x0 0x98007640 0x0 0x10>;
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue-tee.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue-tee.dts
new file mode 100644
index 00000000..2f41a52
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue-tee.dts
@@ -0,0 +1,176 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-13xx.dtsi"
+#include "rtd-1315-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB_TEE";
+	model_hex= <0x00000527>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init androidboot.hardware=hank androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+
+		rtk,ion-heap@9 { /* SECURE */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <9>;
+                        rtk,memory-reserve = <
+                                0x32b00000
+                                0x12C00000
+                                ION_SECURE_HEAP_FLAG>;
+		};
+
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue.dts
new file mode 100644
index 00000000..375b7ca
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue.dts
@@ -0,0 +1,166 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-13xx.dtsi"
+#include "rtd-1315-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB";
+	model_hex= <0x00000527>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init androidboot.hardware=hank androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-1GB.CMAx2.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-1GB.CMAx2.dts
new file mode 100644
index 00000000..8069b06c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-1GB.CMAx2.dts
@@ -0,0 +1,236 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0a000000) // 100M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#define SHARED_DMA_POOL_ALIGNMENT (0x1000000)
+#define SHARED_DMA_POOL_SIZE(s) ((s) - ((s) & (SHARED_DMA_POOL_ALIGNMENT - 1)))
+#define SHARED_DMA_POOL_SIZE_0 SHARED_DMA_POOL_SIZE(0x0b000000)
+
+#include "rtd-1315-reddiscs.dtsi"
+#include "rtd-1315-usb.dtsi"
+#include "rtd-1315-sata.dtsi"
+
+/ {
+	model= "Realtek_red_discs_1GB_CMAx2";
+	model_hex= <0x00000523>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init vmalloc=360M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=hank loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x0 SHARED_DMA_POOL_SIZE_0>;
+			alignment = <0x0 SHARED_DMA_POOL_ALIGNMENT>;
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+            rtk,use-cma-pools;
+            rtk,cma-pool-flags=<(RTK_FLAG_SCPUACC | RTK_FLAG_HWIPACC| RTK_FLAG_CMA)>;
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	pcie2: pcie2@980A0000 {
+		status = "disabled";
+	};
+
+	pcie3: pcie3@980C0000 {
+		status = "disabled";
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpio-unused = <22>, <23>, <25>, <40>, <41>, <42>, <43>, <45>,
+			<52>, <53>, <65>, <66>, <67>, <68>, <69>, <70>,
+			<71>, <72>, <73>, <74>, <75>, <76>;
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-2GB.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-2GB.dts
new file mode 100644
index 00000000..3567deb
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-2GB.dts
@@ -0,0 +1,232 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1315-reddiscs.dtsi"
+#include "rtd-1315-usb.dtsi"
+#include "rtd-1315-sata.dtsi"
+
+/ {
+	model= "Realtek_RedDiscs_2GB";
+	model_hex= <0x00000523>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init androidboot.storage=emmc androidboot.hardware=hank loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	pcie2: pcie2@980A0000 {
+		status = "disabled";
+	};
+
+	pcie3: pcie3@980C0000 {
+		status = "disabled";
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpio-unused = <22>, <23>, <25>, <40>, <41>, <42>, <43>, <45>,
+			<52>, <53>, <65>, <66>, <67>, <68>, <69>, <70>,
+			<71>, <72>, <73>, <74>, <75>, <76>;
+	};
+
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-512MB.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-512MB.dts
new file mode 100644
index 00000000..51dd7bd
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-512MB.dts
@@ -0,0 +1,211 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-13xx.dtsi"
+#include "rtd-1319-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_reddiscs_512MB";
+	model_hex= <0x00000523>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init vmalloc=360M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=hank loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		saving-section-page-table = <1>;
+		reg = <0x0 0x0 0x0 0x20000000>; /* 512 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0x04400000 0x09400000>; /* offset 68MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x00800000>; /* size 8MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0x0f000000 0x00800000>; /* offset 240MB, size 8MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs.dtsi
new file mode 100644
index 00000000..3aceae9
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-1315.dtsi"
+#include "rtd-13xx-dvfs.dtsi"
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-sata.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-sata.dtsi
new file mode 100644
index 00000000..ec3ed3a
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-sata.dtsi
@@ -0,0 +1,25 @@
+/* PLEASE include this file inside a node */
+
+#include "rtd-13xx-sata.dtsi"
+
+/ {
+	sata_phy: sata_phy@9803FF60 {
+		status = "disabled";
+		sata-phy@0 {
+			status = "disabled";
+		};
+		sata-phy@1 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		status = "disabled";
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+		sata-port@1 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-usb.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-usb.dtsi
new file mode 100644
index 00000000..97e914e
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315-usb.dtsi
@@ -0,0 +1,78 @@
+/*
+ * rtd-1315-usb.dtsi
+ */
+/ {
+	/include/ "rtd-13xx-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		status = "okay";
+
+		port0 {
+			type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+			gpio = <&gpio0>;
+		};
+
+		port1 {
+			gpio = <&gpio1>;
+		};
+
+		port2 {
+			/delete-property/gpio;
+		};
+
+		rtk_usb {
+			pcie_usb3phy_sel = <0x9800705c>;
+
+			type_c {
+				// For 1315, 1317, u2drd
+				realtek,connector_switch-gpio = <&rtk_iso_gpio 25 1 3>;
+			};
+		};
+	};
+
+	dwc3_u2drd_usb2phy: dwc3_u2drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2drd: rtk_dwc3_u2drd@98013200 {
+		status = "okay";
+
+		dwc3_u2drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		dwc3_type_c: rtk_dwc3_type_c@0 {
+			drd_mode; //depend on dr_mode = "peripheral"
+			boot_check_time = <30000>; /*ms (At boot Device switch Host time)*/
+			status = "okay";
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb3phy: dwc3_u3drd_usb3phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb2phy: dwc3_u3drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd: rtk_dwc3_u3drd@98013E00 {
+		status = "okay";
+
+		dwc3_u3drd@981F0000 {
+			dr_mode = "host"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		/delete-node/rtk_dwc3_type_c@0;
+	};
+
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315.dtsi
new file mode 100644
index 00000000..e9d7d2c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1315.dtsi
@@ -0,0 +1 @@
+#include "rtd-13xx.dtsi"
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1317-usb.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1317-usb.dtsi
new file mode 100644
index 00000000..4f70426
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1317-usb.dtsi
@@ -0,0 +1,71 @@
+/*
+ * rtd-1317-usb.dtsi
+ */
+/ {
+	/include/ "rtd-13xx-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		status = "okay";
+
+		port0 {
+			type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+		};
+
+		port1 {
+			/delete-property/gpio;
+		};
+
+		rtk_usb {
+			pcie_usb3phy_sel = <0x9800705c>;
+
+			type_c {
+				// For 1315, 1317, u2drd
+				realtek,connector_switch-gpio = <&rtk_iso_gpio 25 1 3>;
+			};
+		};
+	};
+
+	dwc3_u2drd_usb2phy: dwc3_u2drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2drd: rtk_dwc3_u2drd@98013200 {
+		status = "okay";
+
+		dwc3_u2drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		dwc3_type_c: rtk_dwc3_type_c@0 {
+			drd_mode; //depend on dr_mode = "peripheral"
+			status = "okay";
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb3phy: dwc3_u3drd_usb3phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb2phy: dwc3_u3drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd: rtk_dwc3_u3drd@98013E00 {
+		status = "okay";
+
+		dwc3_u3drd@981F0000 {
+			dr_mode = "host"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		/delete-node/rtk_dwc3_type_c@0;
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-irda.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-irda.dtsi
new file mode 100644
index 00000000..954f434
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-irda.dtsi
@@ -0,0 +1,51 @@
+/*
+ * rtd-1319-irda.dtsi - IRDA remote Device Tree Include file for REALTEK family SoC
+ */
+
+/ {
+	irda@98007400 {
+		irda_rx0 {
+			irrx-protocol = "NEC";
+			transcode-mode = <1>;
+
+			cust-code = <0x7F80>;
+			scancode-msk = <0x00FF0000>;  
+			custcode-msk = <0x0000FFFF>;  
+			keymap-tbl = <
+			// scancode	keycode
+				0x18 	116		//KEY_POWER		//POWER
+				0x5A 	353		//KEY_SELECT		//SOURCE
+				0x58 	154		//KEY_CYCLEWINDOWS	//PIP
+				0x1A 	377		//KEY_TV		//TV SYSTEM
+				0x14 	102		//KEY_HOME		//HOME
+				0x56 	357		//KEY_OPTION		//OPTION MENU
+				0x54	358		//KEY_INFO		//MEDIA_INFO
+				0x19 	232		//KEY_REPLY		//REPEAT
+				0x57 	158		//KEY_BACK		//RETURN
+				0x55 	207		//KEY_PLAY		//PLAY/PAUSE
+				0x17 	128		//KEY_STOP		//STOP
+				0x15 	372		//KEY_ZOOM		//ZOOM_IN
+				0x4F 	168		//KEY_REWIND		//FR
+				0x4D 	103		//KEY_UP		//UP
+				0x16 	208		//KEY_FASTFORWARD	//FF
+				0x0C 	105		//KEY_LEFT		//LEFT
+				0x4C 	352		//KEY_OK		//OK
+				0x0E 	106		//KEY_RIGHT		//RIGHT
+				0x08 	412		//KEY_PREVIOUS		//PREVIOUS
+				0x48 	108		//KEY_DOWN		//DOWN
+				0x09 	407		//KEY_NEXT		//NEXT
+				0x4B 	114		//KEY_VOLUMEDOWN	//VOL-
+				0x49 	115		//KEY_VOLUMEUP		//VOL+
+				0x0B 	532		//KEY_TOUCHPAD_OFF	//CURSOR
+				0x0A 	531		//KEY_TOUCHPAD_ON	//GESTURE
+				0xEEEE	0		//REL_X			//mouse X-axi	0xEEEE : REL event type
+				0xEEEE	1		//REL_Y			//mouse Y-axi	0xEEEE : REL event type
+				0xFFFF	272		//BTN_LEFT		//mouse left key	0xFFFF : KEY event type
+				0xFFFF	113     	//KEY_MUTE 		//mute key in AirFunAPP	0xFFFF : KEY event type	
+           		>; 
+			reg-ir-dpir = <50>;	/*IR detect interval, NEC default=50ms, should less than 100ms, and bigger than 9ms*/
+			sample-rate = <40>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-1GB.CMAx2.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-1GB.CMAx2.dts
new file mode 100644
index 00000000..83b0129
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-1GB.CMAx2.dts
@@ -0,0 +1,232 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#define SHARED_DMA_POOL_ALIGNMENT (0x1000000)
+#define SHARED_DMA_POOL_SIZE(s) ((s) - ((s) & (SHARED_DMA_POOL_ALIGNMENT - 1)))
+#define SHARED_DMA_POOL_SIZE_1 SHARED_DMA_POOL_SIZE(0x0b000000)
+
+#include "rtd-1319-pymparticle.dtsi"
+#include "rtd-1319-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_1GB_CMAx2";
+	model_hex= <0x00000527>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init vmalloc=360M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=hank loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x0 SHARED_DMA_POOL_SIZE_1>;
+			alignment = <0x0 SHARED_DMA_POOL_ALIGNMENT>;
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x00800000>; /* size 8MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+            rtk,use-cma-pools;
+            rtk,cma-pool-flags=<(RTK_FLAG_SCPUACC | RTK_FLAG_HWIPACC| RTK_FLAG_CMA | RTK_FLAG_ACPUACC)>;
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			gpios = <&rtk_iso_gpio 80 1 1>;
+		};
+		sata-port@1 {
+			gpios = <&rtk_iso_gpio 81 1 1>;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb-dp.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb-dp.dts
new file mode 100644
index 00000000..13f3b4a
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb-dp.dts
@@ -0,0 +1,21 @@
+#include "rtd-1319-pymparticle-2GB.dts"
+#include "rtd-13xx-avb.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB_AVB_DP";
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor,product";
+				};
+			fstab {
+				/delete-node/ system;
+				/delete-node/ vendor;
+				/delete-node/ product;
+			};
+		};
+	};
+
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb-tee.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb-tee.dts
new file mode 100644
index 00000000..d0f9955
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb-tee.dts
@@ -0,0 +1,7 @@
+#include "rtd-1319-pymparticle-2GB-tee.dts"
+#include "rtd-13xx-avb.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB_AVB_TEE";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb.dts
new file mode 100644
index 00000000..51bbaab
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1319-pymparticle-2GB.dts"
+#include "rtd-13xx-avb.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB_AVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-tee.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-tee.dts
new file mode 100644
index 00000000..b6ea775
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-tee.dts
@@ -0,0 +1,245 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+
+#include "rtd-1319-pymparticle.dtsi"
+#include "rtd-1319-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB_TEE";
+	model_hex= <0x00000527>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=hank androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS_0 
+                ION_SECURE_HEAP_SIZE_0 
+                ION_SECURE_HEAP_FLAG_0
+                ION_SECURE_AUDIO_PHYS_0 
+                ION_SECURE_AUDIO_SIZE_0 
+                ION_SECURE_AUDIO_FLAG_0
+                >;
+        };
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			gpios = <&rtk_iso_gpio 80 1 1>;
+		};
+		sata-port@1 {
+			gpios = <&rtk_iso_gpio 81 1 1>;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB.dts
new file mode 100644
index 00000000..64532e7
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB.dts
@@ -0,0 +1,227 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#define SHARED_DMA_POOL_ALIGNMENT (0x1000000)
+#define SHARED_DMA_POOL_SIZE(s) ((s) - ((s) & (SHARED_DMA_POOL_ALIGNMENT - 1)))
+#define SHARED_DMA_POOL_SIZE_0 SHARED_DMA_POOL_SIZE(0x0a000000)
+
+#include "rtd-1319-pymparticle.dtsi"
+#include "rtd-1319-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB";
+	model_hex= <0x00000527>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init vmalloc=360M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=hank loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x0 SHARED_DMA_POOL_SIZE_0>;
+			alignment = <0x0 SHARED_DMA_POOL_ALIGNMENT>;
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+            rtk,use-cma-pools;
+            rtk,cma-pool-flags=<(RTK_FLAG_SCPUACC | RTK_FLAG_HWIPACC| RTK_FLAG_CMA)>;
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			gpios = <&rtk_iso_gpio 80 1 1>;
+		};
+		sata-port@1 {
+			gpios = <&rtk_iso_gpio 81 1 1>;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-nand-2GB.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-nand-2GB.dts
new file mode 100644
index 00000000..47738329
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-nand-2GB.dts
@@ -0,0 +1,215 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1319-pymparticle.dtsi"
+#include "rtd-1319-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB_NAND";
+	model_hex= <0x00000527>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init androidboot.hardware=hank androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			gpios = <&rtk_iso_gpio 80 1 1>;
+		};
+		sata-port@1 {
+			gpios = <&rtk_iso_gpio 81 1 1>;
+		};
+	};
+
+	nand@98010000 { status = "okay"; };
+	emmc@98012000 { status = "disabled"; };
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle.dtsi
new file mode 100644
index 00000000..6a4526d
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-1319.dtsi"
+#include "rtd-13xx-dvfs.dtsi"
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue-tee.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue-tee.dts
new file mode 100644
index 00000000..7f3b9de
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue-tee.dts
@@ -0,0 +1,176 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-13xx.dtsi"
+#include "rtd-1319-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB_TEE";
+	model_hex= <0x00000527>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init androidboot.hardware=hank androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+
+		rtk,ion-heap@9 { /* SECURE */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <9>;
+                        rtk,memory-reserve = <
+                                0x32b00000
+                                0x12C00000
+                                ION_SECURE_HEAP_FLAG>;
+		};
+
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue.dts b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue.dts
new file mode 100644
index 00000000..3f7d7df
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue.dts
@@ -0,0 +1,166 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-13xx.dtsi"
+#include "rtd-1319-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB";
+	model_hex= <0x00000527>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init androidboot.hardware=hank androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-sata.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-sata.dtsi
new file mode 100644
index 00000000..c45eeb9
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-sata.dtsi
@@ -0,0 +1,19 @@
+/* PLEASE include this file inside a node */
+
+#include "rtd-13xx-sata.dtsi"
+
+/ {
+	sata_phy: sata_phy@9803FF60 {
+		status = "okay";
+		sata-phy@0 {
+			status = "okay";
+		};
+		sata-phy@1 {
+			status = "okay";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		status = "okay";
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-usb.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-usb.dtsi
new file mode 100644
index 00000000..9dd1682
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319-usb.dtsi
@@ -0,0 +1,68 @@
+/*
+ * rtd-1319-usb.dtsi
+ */
+/ {
+	/include/ "rtd-13xx-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		status = "okay";
+
+		port2 {
+			type_c = <&dwc3_type_c>; /* for port 2 type c driver */
+		};
+
+		rtk_usb {
+			pcie_usb3phy_sel = <0x9800705c>; /* Only for RTD1319 */
+
+			type_c {
+				/* For 1319, u3drd */
+				realtek,plug_side_switch-gpio = <&rtk_iso_gpio 53 1 3>;
+			};
+
+		};
+	};
+
+	dwc3_u2drd_usb2phy: dwc3_u2drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2drd: rtk_dwc3_u2drd@98013200 {
+		status = "okay";
+
+		dwc3_u2drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+			status = "okay";
+		};
+		/delete-node/rtk_dwc3_type_c@0;
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb3phy: dwc3_u3drd_usb3phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb2phy: dwc3_u3drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd: rtk_dwc3_u3drd@98013E00 {
+		status = "okay";
+
+		dwc3_u3drd@981F0000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		dwc3_type_c: rtk_dwc3_type_c@0 {
+			drd_mode; //depend on dr_mode = "peripheral"
+			status = "okay";
+		};
+	};
+
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319.dtsi
new file mode 100644
index 00000000..e9d7d2c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-1319.dtsi
@@ -0,0 +1 @@
+#include "rtd-13xx.dtsi"
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-avb.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-avb.dtsi
new file mode 100644
index 00000000..60e2d6f
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-avb.dtsi
@@ -0,0 +1,17 @@
+/ {
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				/delete-node/ system;
+				vendor {
+					fsmgr_flags = "wait,avb";
+				};
+			};
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-dvfs.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-dvfs.dtsi
new file mode 100644
index 00000000..ef66b53
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-dvfs.dtsi
@@ -0,0 +1,280 @@
+/*
+ * RTD-13XX DVFS with Anpec APW8889 PMIC
+ */
+#include <dt-bindings/regulator/anpec,apw888x.h>
+#include <dt-bindings/thermal/thermal.h>
+
+/* PMIC */
+&i2c_0 {
+	status = "okay";
+
+	apw8886: apw8886g@12 {
+		compatible = "anpec,apw8886";
+		reg = <0x12>;
+
+		status = "okay";
+
+		powerkey_1: powerkey {
+			compatible = "gmt,g22xx-powerkey";
+			status = "disabled";
+		};
+		poweroff_1: poweroff {
+			compatible = "gmt,g22xx-poweroff";
+			system-power-controller;
+			statis = "disabled";
+		};
+		regulators_1: regulators {
+			compatible = "anpec,apw8886-regulator";
+			status = "okay";
+		};
+
+	};
+};
+
+&apw8886 {
+	regulators {
+		vd33_supp: dc1 {
+			regulator-name = "vd33";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3777500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <3200000>;
+			};
+		};
+		core_supp: dc2 {
+			regulator-name = "core";
+			regulator-min-microvolt = <550000>;
+			regulator-max-microvolt = <1337500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <900000>;
+			};
+		};
+		cpu_supp: dc3 {
+			regulator-name = "cpudvs";
+			regulator-min-microvolt = <550000>;
+			regulator-max-microvolt = <1337500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_DC_MODE_AUTO>;
+			regulator-ramp-delay = <625>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		vd18_supp: dc4 {
+			regulator-name = "vd18";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <2060000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_DC_MODE_AUTO>;
+		};
+		ddr_supp: dc5 {
+			regulator-name = "ddr";
+			regulator-min-microvolt = <1200000>;
+			regulator-max-microvolt = <1200000>;
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_DC_MODE_AUTO>;
+		};
+		vd25_supp: ldo1 {
+			regulator-name = "vd25";
+			regulator-min-microvolt = <1780000>;
+			regulator-max-microvolt = <3020000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_LDO_MODE_NORMAL>;
+		};
+	};
+};
+
+/* CPU nodes */
+&A55_0 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_1 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_2 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_3 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+/* cpu opp table */
+&dvfs {
+	cpu_opps: cpu-opp-table {
+		compatible = "operating-points-v2";
+		opp-shared;
+		opp300: opp-300mhz {
+			opp-hz = /bits/ 64 <300000000>;
+			opp-microvolt = <787500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp400: opp-400mhz {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		opp500: opp-500mhz {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp600: opp-600mhz {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp700: opp-700mhz {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp800: opp-800mhz {
+			opp-hz = /bits/ 64 <800000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp900: opp-900mhz {
+			opp-hz = /bits/ 64 <900000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1000: opp-1000mhz {
+			opp-hz = /bits/ 64 <1000000000>;
+			opp-microvolt = <937500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1100: opp-1100mhz {
+			opp-hz = /bits/ 64 <1100000000>;
+			opp-microvolt = <987500>;
+			clock-latency-ns = <150000>;
+			opp-suspend;
+			status = "okay";
+		};
+		opp1200: opp-1200mhz {
+			opp-hz = /bits/ 64 <1200000000>;
+			opp-microvolt = <1025000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1300: opp-1300mhz {
+			opp-hz = /bits/ 64 <1300000000>;
+			opp-microvolt = <1050000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1400: opp-1400mhz {
+			opp-hz = /bits/ 64 <1400000000>;
+			opp-microvolt = <1125000>;
+			clock-latency-ns = <150000>;
+			status = "dis";
+		};
+	};
+};
+
+&cpu_thermal {
+	trips {
+		tm_alert0: cpu-alert0 {
+			temperature = <105000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+		tm_alert1: cpu-alert1 {
+			temperature = <115000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+	};
+	cooling-maps {
+		cpu-map0 {
+			trip = <&tm_alert0>;
+			cooling-device = <&A55_0 THERMAL_NO_LIMIT 6>;
+			contribution = <70>;
+		};
+		cpu-map1 {
+			trip = <&tm_alert1>;
+			cooling-device = <&A55_0 7 THERMAL_NO_LIMIT>;
+			contribution = <70>;
+		};
+	};
+};
+
+
+&gpu {
+	mali-supply = <&core_supp>;
+	operating-points-v2 = <&gpu_opps>;
+	assigned-clocks = <&cc CC_CLK_GPU>;
+	assigned-clock-rates = <400000000>;
+
+	gpu_opps: gpu-opp-table {
+		compatible = "operating-points-v2",
+			     "operating-points-v2-mali";
+
+		opp-400 {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <900000>;
+			opp-suspend;
+		};
+		opp-500 {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-hz-real = /bits/ 64 <500000000>;
+			opp-microvolt = <900000>;
+		};
+		opp-600 {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-hz-real = /bits/ 64 <600000000>;
+			opp-microvolt = <900000>;
+		};
+		opp-650 {
+			opp-hz = /bits/ 64 <650000000>;
+			opp-hz-real = /bits/ 64 <650000000>;
+			opp-microvolt = <900000>;
+		};
+		opp-720 {
+			opp-hz = /bits/ 64 <720000000>;
+			opp-hz-real = /bits/ 64 <720000000>;
+			opp-microvolt = <950000>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-hdmirxEDID.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-hdmirxEDID.dtsi
new file mode 100644
index 00000000..b127445
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-hdmirxEDID.dtsi
@@ -0,0 +1,59 @@
+/*
+ * rtd-16xx-hdmirxEDID.dtsi - HDMI Rx EDID table for REALTEK 16xx SoC
+ */
+
+/{
+	hdmirx@98034000 {
+		Realtek,edid-table = <
+			0x00 0xFF 0xFF 0xFF 0xFF 0xFF 0xFF 0x00 0x4A 0x8B 0x95
+			0x12 0x00 0x00 0x00 0x00 0xFF 0x1A 0x01 0x03 0x81 0x46
+			0x27 0x78 0x8A 0xA5 0x8E 0xA6 0x54 0x4A 0x9C 0x26 0x12
+			0x45 0x46 0x21 0x08 0x00 0xD1 0xC0 0x81 0xC0 0x01 0x01
+			0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x02
+			0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C 0x45 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x01 0x1D 0x00 0x72 0x51
+			0xD0 0x1E 0x20 0x6E 0x28 0x55 0x00 0x20 0xC2 0x31 0x00
+			0x00 0x1E 0x00 0x00 0x00 0xFD 0x00 0x32 0x4B 0x18 0x3C
+			0x0B 0x00 0x0A 0x20 0x20 0x20 0x20 0x20 0x20 0x00 0x00
+			0x00 0xFC 0x00 0x52 0x54 0x44 0x31 0x32 0x39 0x35 0x0A
+			0x20 0x20 0x20 0x20 0x20 0x01 0xAC 0x02 0x03 0x29 0x71
+			0x83 0x01 0x00 0x00 0x6E 0x03 0x0C 0x00 0x10 0x00 0x00
+			0x3C 0x20 0x00 0x80 0x01 0x02 0x03 0x04 0x49 0x90 0x1F
+			0x22 0x20 0x05 0x14 0x04 0x11 0x02 0x23 0x09 0x7F 0x07
+			0xE3 0x05 0x03 0x00 0x02 0x3A 0x80 0x18 0x71 0x38 0x2D
+			0x40 0x58 0x2C 0x45 0x00 0x20 0xC2 0x31 0x00 0x00 0x1E
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x7F>;
+
+		Realtek,edid2p0-table = <
+			0x00 0xFF 0xFF 0xFF 0xFF 0xFF 0xFF 0x00 0x4A 0x8B 0x95
+			0x12 0x00 0x00 0x00 0x00 0xFF 0x1A 0x01 0x03 0x81 0x46
+			0x27 0x78 0x8A 0xA5 0x8E 0xA6 0x54 0x4A 0x9C 0x26 0x12
+			0x45 0x46 0x21 0x08 0x00 0xD1 0xC0 0x81 0xC0 0x01 0x01
+			0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x02
+			0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C 0x45 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x01 0x1D 0x00 0x72 0x51
+			0xD0 0x1E 0x20 0x6E 0x28 0x55 0x00 0x20 0xC2 0x31 0x00
+			0x00 0x1E 0x00 0x00 0x00 0xFD 0x00 0x32 0x4B 0x18 0x3C
+			0x0B 0x00 0x0A 0x20 0x20 0x20 0x20 0x20 0x20 0x00 0x00
+			0x00 0xFC 0x00 0x52 0x54 0x44 0x31 0x32 0x39 0x35 0x0A
+			0x20 0x20 0x20 0x20 0x20 0x01 0xAC 0x02 0x03 0x3A 0x71
+			0x83 0x01 0x00 0x00 0x6E 0x03 0x0C 0x00 0x10 0x00 0x00
+			0x3C 0x20 0x00 0x80 0x01 0x02 0x03 0x04 0x67 0xD8 0x5D
+			0xC4 0x01 0x77 0x80 0x00 0x4F 0x5D 0x5E 0x5F 0x60 0x61
+			0x62 0x90 0x1F 0x22 0x20 0x05 0x14 0x04 0x11 0x02 0x23
+			0x09 0x7F 0x07 0xE3 0x05 0x03 0x00 0xE2 0x0F 0x18 0x08
+			0xE8 0x00 0x30 0xF2 0x70 0x5A 0x80 0xB0 0x58 0x8A 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x8F>;
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-pcie.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-pcie.dtsi
new file mode 100644
index 00000000..fb267fa
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-pcie.dtsi
@@ -0,0 +1,216 @@
+/ {
+	pcie: pcie@98060000 {
+		compatible = "realtek,rtk13xx-pcie-slot1";
+		reg = <0x0 0x98060000 0x0 0x00001000
+		       0x0 0x98061000 0x0 0x00001000
+		       0x0 0x9801C800 0x0 0x00000100
+		       0x0 0x9800705C 0x0 0x00000010>;
+		interrupt-names = "rtk-pcie1-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic 0 0 GIC_SPI 61 IRQ_TYPE_LEVEL_HIGH>;
+		interrupts = <0 61 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins_0>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <0>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 19 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys = <0x000f0601>,
+			<0x86700a01>,
+			<0xff002901>,
+			<0x520c0901>,
+			<0x4f082401>,
+			<0xf7120d01>,
+			<0xbb662301>,
+			<0x000f4601>,
+			<0xc4772001>,
+			<0x33772101>,
+			<0x00132201>,
+			<0x61BD2f01>,
+			<0x500c0901>,
+			<0x520c0901>,
+			<0x000f4601>,
+			<0x86704a01>,
+			<0xff006901>,
+			<0xa80a4101>,
+			<0x520c4901>,
+			<0x4f0c6401>,
+			<0xf7124d01>,
+			<0xbb666301>,
+			<0xc4776001>,
+			<0x33776101>,
+			<0x00136201>,
+			<0x61bd6f01>,
+			<0x500c4901>,
+			<0x520c4901>;
+
+		//speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x98062000 0x0 0x98062000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00030000 0x0 0x00030000 0x00000000 0x00010000>;
+		resets = <&crst RSTN_PCIE0>,
+			<&crst RSTN_PCIE0_CORE>,
+			<&crst RSTN_PCIE0_POWER>,
+			<&crst RSTN_PCIE0_NONSTITCH>,
+			<&crst RSTN_PCIE0_STITCH>,
+			<&crst RSTN_PCIE0_PHY>,
+			<&crst RSTN_PCIE0_PHY_MDIO>,
+			<&crst RSTN_PCIE0_SGMII_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio",
+			"sgmii_mdio";
+		clocks = <&clk_en_1 CLK_EN_PCIE0>;
+		status = "okay";
+	};
+
+	pcie2: pcie2@980A0000 {
+		compatible = "realtek,rtk13xx-pcie-slot2";
+		reg = <0x0 0x980A0000 0x0 0x00001000
+		       0x0 0x980A1000 0x0 0x00001000
+		       0x0 0x9801C600 0x0 0x00000100
+		       0x0 0x9804F000 0x0 0x00000100>;
+		interrupt-names = "rtk-pcie2-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic 0 0 GIC_SPI 62 IRQ_TYPE_LEVEL_HIGH>;
+		interrupts = <0 62 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins_1>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <1>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 80 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys = <0x000f0601>,
+			<0x86700a01>,
+			<0xff002901>,
+			<0x520c0901>,
+			<0x4f082401>,
+			<0xf7120d01>,
+			<0xbb662301>,
+			<0x000f4601>,
+			<0xc4772001>,
+			<0x33772101>,
+			<0x00132201>,
+			<0x61BD2f01>,
+			<0x500c0901>,
+			<0x520c0901>,
+			<0x000f4601>,
+			<0x86704a01>,
+			<0xff006901>,
+			<0xa80a4101>,
+			<0x520c4901>,
+			<0x4f0c6401>,
+			<0xf7124d01>,
+			<0xbb666301>,
+			<0xc4776001>,
+			<0x33776101>,
+			<0x00136201>,
+			<0x61bd6f01>,
+			<0x500c4901>,
+			<0x520c4901>;
+
+		//speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x980A2000 0x0 0x980A2000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00040000 0x0 0x00040000 0x00000000 0x00010000>;
+		resets = <&crst RSTN_PCIE1>,
+			<&crst RSTN_PCIE1_CORE>,
+			<&crst RSTN_PCIE1_POWER>,
+			<&crst RSTN_PCIE1_NONSTITCH>,
+			<&crst RSTN_PCIE1_STITCH>,
+			<&crst RSTN_PCIE1_PHY>,
+			<&crst RSTN_PCIE1_PHY_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_4 CLK_EN_PCIE1>;
+		status = "okay";
+	};
+
+	pcie3: pcie3@980C0000 {
+		compatible = "realtek,rtk13xx-pcie-slot3";
+		reg = <0x0 0x980C0000 0x0 0x00001000
+		       0x0 0x980C1000 0x0 0x00001000
+		       0x0 0x9801C600 0x0 0x00000100
+		       0x0 0x9804F000 0x0 0x00000100>;
+		interrupt-names = "rtk-pcie3-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic 0 0 GIC_SPI 62 IRQ_TYPE_LEVEL_HIGH>;
+		interrupts = <0 62 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins_2>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <2>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 81 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys = <0x000f0601>,
+			<0x86700a01>,
+			<0xff002901>,
+			<0x520c0901>,
+			<0x4f082401>,
+			<0xf7120d01>,
+			<0xbb662301>,
+			<0x000f4601>,
+			<0xc4772001>,
+			<0x33772101>,
+			<0x00132201>,
+			<0x61BD2f01>,
+			<0x500c0901>,
+			<0x520c0901>,
+			<0x000f4601>,
+			<0x86704a01>,
+			<0xff006901>,
+			<0xa80a4101>,
+			<0x520c4901>,
+			<0x4f0c6401>,
+			<0xf7124d01>,
+			<0xbb666301>,
+			<0xc4776001>,
+			<0x33776101>,
+			<0x00136201>,
+			<0x61bd6f01>,
+			<0x500c4901>,
+			<0x520c4901>;
+
+		//speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x980C2000 0x0 0x980C2000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00040000 0x0 0x00040000 0x00000000 0x00010000>;
+		resets = <&crst RSTN_PCIE2>,
+			<&crst RSTN_PCIE2_CORE>,
+			<&crst RSTN_PCIE2_POWER>,
+			<&crst RSTN_PCIE2_NONSTITCH>,
+			<&crst RSTN_PCIE2_STITCH>,
+			<&crst RSTN_PCIE2_PHY>,
+			<&crst RSTN_PCIE2_PHY_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_7 CLK_EN_PCIE2>;
+		status = "okay";
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-pinctrl.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-pinctrl.dtsi
new file mode 100644
index 00000000..48a19ee
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-pinctrl.dtsi
@@ -0,0 +1,536 @@
+
+/ {
+	pinctrl@9804E000 {
+		sdcard_pins_low: sdcard_low {
+			realtek,pins= "gpio_32",
+			"gpio_33",
+			"hif_data",
+			"hif_en",
+			"hif_rdy",
+			"hif_clk";
+			realtek,function="sd";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <0>;
+		};
+
+		sdcard_pins_high: sdcard_high {
+			realtek,pins="gpio_35", "gpio_34";
+			realtek,function="mmc";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <1>;
+		};
+
+		sdio_pins_0: sdio_pins_0 {
+			realtek,pins= "gpio_32",
+			"gpio_33",
+			"hif_data",
+			"hif_en",
+			"hif_rdy",
+			"hif_clk",
+			"sdio_loc";
+			realtek,function = "sdio_loc0";
+		};
+
+		sdio_pins_1: sdio_pins_1 {
+			realtek,pins = "gpio_40",
+			"gpio_41",
+			"gpio_42",
+			"gpio_43",
+			"gpio_44",
+			"gpio_45",
+			"sdio_loc";
+			realtek,function = "sdio_loc1";
+		};
+
+		rgmii_mdio_pins: rgmii_mdio_pins {
+			realtek,pins = "gpio_14",
+			"gpio_15";
+			realtek,function = "rgmii";
+		};
+
+		rgmii_txrx_pins: rgmii_txrx_pins {
+			realtek,pins = "gpio_65",
+			"gpio_66",
+			"gpio_67",
+			"gpio_68",
+			"gpio_69",
+			"gpio_70",
+			"gpio_71",
+			"gpio_72",
+			"gpio_73",
+			"gpio_74",
+			"gpio_75",
+			"gpio_76";
+			realtek,function = "rgmii";
+		};
+
+		uart0_pins: uart0_pins {
+			realtek,pins = "ur0_rx",
+			"ur0_tx";
+			realtek,function = "uart0";
+		};
+
+		uart1_pins: uart1_pins {
+			realtek,pins = "gpio_8",
+			"gpio_9";
+			realtek,function = "uart1";
+		};
+
+		uart2_pins_0: uart2_pins_0 {
+			realtek,pins = "ur2_loc",
+			"gpio_18",
+			"gpio_19";
+			realtek,function = "uart2_loc0";
+		};
+
+		uart2_pins_1: uart2_pins_1 {
+			realtek,pins ="ur2_loc",
+			"gpio_26",
+			"gpio_27";
+			realtek,function = "uart2_loc1";
+		};
+
+		i2c_pins_0: i2c_pins_0 {
+			realtek,pins = "gpio_12",
+			"gpio_13";
+			realtek,function = "i2c0";
+			realtek,drive = <4>;
+		};
+
+		i2c_pins_0_HS: i2c_pins_0_HS {
+			realtek,pins = "gpio_12",
+			"gpio_13";
+			realtek,function = "i2c0";
+			realtek,drive = <8>;
+		};
+
+		i2c_pins_1: i2c_pins_1 {
+			realtek,pins = "gpio_16",
+			"gpio_17";
+			realtek,function = "i2c1";
+		};
+
+
+		i2c_pins_3: i2c_pins_3 {
+			realtek,pins = "gpio_63",
+			"gpio_64";
+			realtek,function = "i2c3";
+		};
+
+
+		i2c_pins_5: i2c_pins_5 {
+			realtek,pins = "gpio_29",
+			"gpio_46";
+			realtek,function = "i2c5";
+		};
+
+		spi_pins_enable: spi-pins-enable {
+			realtek,pins = "sf_en";
+			realtek,function = "sf_enable";
+		};
+
+		spi_pins_loc_spi: spi_pins_loc_spi {
+			realtek,pins = "spi_ce_n",
+			"spi_sck",
+			"spi_so",
+			"spi_si";
+			realtek,function = "spi";
+		};
+
+		gspi_pins_0: gspi_pins_0 {
+			realtek,pins = "gspi_loc",
+			"gpio_18",
+			"gpio_19",
+			"gpio_20",
+			"gpio_31";
+			realtek,function = "gspi_loc0";
+		};
+
+		gspi_pins_1: gspi_pins_1 {
+			realtek,pins = "gspi_loc",
+			"gpio_8",
+			"gpio_9",
+			"gpio_10",
+			"gpio_11";
+			realtek,function = "gspi_loc1";
+		};
+
+		iso_gspi_pins_0: iso_gspi_pins_0 {
+			realtek,pins = "iso_gspi_loc",
+			"gpio_18",
+			"gpio_19",
+			"gpio_20",
+			"gpio_31";
+			realtek,function = "iso_gspi_loc0";
+		};
+
+		iso_gspi_pins_1: iso_gspi_pins_1 {
+			realtek,pins = "iso_gspi_loc",
+			"gpio_8",
+			"gpio_9",
+			"gpio_10",
+			"gpio_11";
+			realtek,function = "iso_gspi_loc1";
+		};
+
+		smartcard_pins_0:smartcard_pins_0{
+			realtek,pins = "gpio_18",
+			"gpio_19",
+			"gpio_20",
+			"gpio_31";
+			realtek,function = "sc0";
+		};
+
+		smartcard_pins_1:smartcard_pins_1{
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5";
+			realtek,function = "sc1";
+		};
+
+		tp0_loc_tp0_pins: tp0_loc_tp0_pins {
+			realtek,pins = "gpio_66",
+			"gpio_67",
+			"gpio_68",
+			"gpio_69",
+			"gpio_70",
+			"gpio_71",
+			"gpio_72",
+			"gpio_73",
+			"gpio_74",
+			"gpio_75",
+			"gpio_76";
+			realtek,function = "tp0";
+		};
+
+		tp1_loc_tp1_pins: tp1_loc_tp1_pins {
+			realtek,pins = "gpio_69",
+			"gpio_70",
+			"gpio_71",
+			"gpio_72";
+			realtek,function = "tp1";
+		};
+
+		ao_pins: ao_pins {
+			realtek,pins = "gpio_66",
+			"gpio_67",
+			"gpio_68",
+			"gpio_69",
+			"gpio_70",
+			"gpio_71",
+			"gpio_72";
+			realtek,function = "ao";
+		};
+
+		ir_rx_pins: ir_rx_pins {
+			realtek,pins = "ir_rx";
+			realtek,function = "ir_rx";
+		};
+
+		spdif_pins: spdif_pins {
+			realtek,pins = "gpio_50";
+			realtek,function = "spdif";
+		};
+
+		/*spdif_optical_pins: spdif_optical_pins {
+			realtek,pins = "gpio_21", "gpio_68", "gpio_85";
+			realtek,function = "spdif";
+			realtek,pull_en =  <0>;
+		};*/
+
+		ai_loc0_pins: ai_loc0_pins {
+			realtek,pins = "gpio_57",
+				"gpio_58",
+				"gpio_59",
+				"gpio_60",
+				"gpio_61",
+				"gpio_62",
+				"gpio_63";
+			realtek,function = "ai_loc0";
+		};
+
+		ai_loc1_pins: ai_loc1_pins {
+			realtek,pins = "gpio_32",
+				"gpio_33",
+				"gpio_34",
+				"hif_data",
+				"hif_en",
+				"hif_rdy",
+				"hif_clk";
+			realtek,function = "ai_loc1";
+		};
+
+		dmic_loc0_pins: dmic_loc0_pins {
+			realtek,pins = "dmic_loc",
+				"gpio_57",
+				"gpio_58",
+				"gpio_59",
+				"gpio_60",
+				"gpio_61",
+				"gpio_62",
+				"gpio_63",
+				"gpio_64";
+			realtek,function = "dmic_loc0";
+		};
+
+		dmic_loc1_pins: dmic_loc1_pins {
+			realtek,pins = "dmic_loc",
+				"gpio_32",
+				"gpio_33",
+				"gpio_34",
+				"gpio_35",
+				"hif_data",
+				"hif_en",
+				"hif_rdy",
+				"hif_clk";
+			realtek,function = "dmic_loc1";
+		};
+
+		tdm_loc0_pins: tdm_loc0_pins {
+			realtek,pins =
+				"gpio_57",
+				"gpio_58",
+				"gpio_59",
+				"gpio_60";
+			realtek,function = "tdm_ai_loc0";
+		};
+
+
+		tdm_loc1_pins: tdm_loc1_pins {
+			realtek,pins =
+				"hif_data",
+				"hif_en",
+				"hif_rdy",
+				"hif_clk";
+			realtek,function = "tdm_ai_loc1";
+		};
+
+
+		/*i2s_out_4pins: i2s_out_4pins {
+			realtek,pins ="tp_data_1",
+			"tp_data_2",
+			"tp_data_3",
+			"tp_data_4";
+			realtek,function = "ao";
+		};*/
+
+		/*i2s_in_pins: i2s_in_pins {
+			realtek,pins = "gpio_6";
+			realtek,function = "ai";
+		};*/
+
+		etn_led_pins: etn_led_pins {
+			realtek,pins = "gpio_14",
+			"gpio_15";
+			realtek,function = "etn_led";
+		};
+
+
+		pcie_clk_pins_0: pcie_clk_pins_0 {
+			realtek,pins = "gpio_46";
+			realtek,function = "pcie0";
+		};
+
+		pcie_clk_pins_1: pcie_clk_pins_1 {
+			realtek,pins = "gpio_25";
+			realtek,function = "pcie1";
+		};
+
+		pcie_clk_pins_2: pcie_clk_pins_2 {
+			realtek,pins = "gpio_52";
+			realtek,function = "pcie2";
+		};
+
+		scpu_ejtag_pins_loc_0: scpu_ejtag_pins_loc_0 {
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5",
+			"gpio_6",
+			"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc0";
+		};
+
+		scpu_ejtag_pins_loc_1: scpu_ejtag_pins_loc_1 {
+			realtek,pins = "gpio_32",
+			"gpio_33",
+			"hif_data",
+			"hif_en",
+			"hif_clk",
+			"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc1";
+		};
+
+		scpu_ejtag_pins_disable: scpu_ejtag_pins_disable {
+			realtek,pins = "ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_disable";
+		};
+
+		acpu_ejtag_pins_loc_0: acpu_ejtag_pins_loc_0 {
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5",
+			"gpio_6",
+			"ejtag_acpu_loc";
+			realtek,function = "acpu_ejtag_loc0";
+		};
+
+		acpu_ejtag_pins_loc_1: acpu_ejtag_pins_loc_1 {
+			realtek,pins = "gpio_32",
+			"gpio_33",
+			"hif_data",
+			"hif_en",
+			"hif_clk",
+			"ejtag_acpu_loc";
+			realtek,function = "acpu_ejtag_loc1";
+		};
+
+		acpu_ejtag_pins_disable:acpu_ejtag_pins_disable{
+			realtek,pins = "ejtag_acpu_loc";
+			realtek,function = "acpu_ejtag_disable";
+		};
+
+		vcpu_ejtag_pins_loc_0: avpu_ejtag_pins_loc_0 {
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5",
+			"gpio_6",
+			"ejtag_vcpu_loc";
+			realtek,function = "vcpu_ejtag_loc0";
+		};
+
+		vcpu_ejtag_pins_loc_1: vcpu_ejtag_pins_loc_1 {
+			realtek,pins = "gpio_32",
+			"gpio_33",
+			"hif_data",
+			"hif_en",
+			"hif_clk",
+			"ejtag_vcpu_loc";
+			realtek,function = "vcpu_ejtag_loc1";
+		};
+
+		vcpu_ejtag_pins_disable:vcpu_ejtag_pins_disable{
+			realtek,pins = "ejtag_vcpu_loc";
+			realtek,function = "vcpu_ejtag_disable";
+		};
+
+		dc_fan_sensor_pins: dc_fan_sensor_pins {
+			realtek,pins = "gpio_47";
+			realtek,function = "dc_fan";
+		};
+
+		pwm0_0_pins: pwm0_0_pins {
+			realtek,pins = "gpio_12";
+			realtek,function = "pwm0";
+		};
+
+		pwm0_1_pins: pwm0_1_pins {
+			realtek,pins = "gpio_20";
+			realtek,function = "pwm0";
+		};
+
+		pwm1_0_pins: pwm1_0_pins {
+			realtek,pins = "gpio_13";
+			realtek,function = "pwm1";
+		};
+
+		pwm1_1_pins: pwm1_1_pins {
+			realtek,pins = "gpio_21";
+			realtek,function = "pwm1";
+		};
+
+		pwm2_0_pins: pwm2_0_pins {
+			realtek,pins = "gpio_14";
+			realtek,function = "pwm2";
+		};
+
+		pwm2_1_pins: pwm2_1_pins {
+			realtek,pins = "gpio_22";
+			realtek,function = "pwm2";
+		};
+
+		pwm3_0_pins: pwm3_0_pins {
+			realtek,pins = "gpio_15";
+			realtek,function = "pwm3";
+		};
+
+		pwm3_1_pins: pwm3_1_pins {
+			realtek,pins = "gpio_23";
+			realtek,function = "pwm3";
+		};
+
+		pwm0_0_pins_disable: pwm0_0_pins_disable {
+			realtek,pins = "gpio_12";
+			realtek,function = "gpio";
+		};
+
+		pwm0_1_pins_disable: pwm0_1_pins_disable {
+			realtek,pins = "gpio_20";
+			realtek,function = "gpio";
+		};
+
+		pwm1_0_pins_disable: pwm1_0_pins_disable {
+			realtek,pins = "gpio_13";
+			realtek,function = "gpio";
+		};
+
+		pwm1_1_pins_disable: pwm1_1_pins_disable {
+			realtek,pins = "gpio_21";
+			realtek,function = "gpio";
+		};
+
+		pwm2_0_pins_disable: pwm2_0_pins_disable {
+			realtek,pins = "gpio_14";
+			realtek,function = "gpio";
+		};
+
+		pwm2_1_pins_disable: pwm2_1_pins_disable {
+			realtek,pins = "gpio_22";
+			realtek,function = "gpio";
+		};
+
+		pwm3_0_pins_disable: pwm3_0_pins_disable {
+			realtek,pins = "gpio_15";
+			realtek,function = "gpio";
+		};
+
+		pwm3_1_pins_disable: pwm3_1_pins_disable {
+			realtek,pins = "gpio_23";
+			realtek,function = "gpio";
+		};
+
+		usb_cc1_pins: usb_cc1_pins {
+			realtek,pins = "usb_cc1";
+			realtek,function = "usb_cc1";
+		};
+
+		usb_cc2_pins: usb_cc2_pins {
+			realtek,pins = "usb_cc2";
+			realtek,function = "usb_cc2";
+		};
+
+		demod_pins: demod-pins {
+			realtek,pins = "gpio_21";
+			realtek,function = "qam_agc_if";
+		};
+
+		/*rtc_pins: rtc_pins {
+			realtek,pins = "gpio_25";
+			realtek,function = "rtc";
+		};*/
+
+		/*prob0_pins: prob0_pins{
+			realtek,pins = "prob_0";
+	        realtek,function = "gpio";
+		};
+
+		prob1_pins: prob1_pins{
+	        realtek,pins = "prob_1";
+	        realtek,function = "gpio";
+		};*/
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-sata.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-sata.dtsi
new file mode 100644
index 00000000..3eecdc5
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-sata.dtsi
@@ -0,0 +1,85 @@
+#include <dt-bindings/reset/rtk,reset-rtd13xx.h>
+#include <dt-bindings/clock/rtk,clock-rtd13xx.h>
+/ {
+	sata_phy: sata_phy@9803FF60 {
+		compatible = "Realtek,rtk-sata-phy";
+		reg = <0x0 0x9803FF00 0x0 0x100>,
+			<0x0 0x9804f050 0x0 0x10>;
+		clocks = <&clk_en_4 CLK_EN_SATA_WRAP_SYS>,
+			<&clk_en_4 CLK_EN_SATA_WRAP_SYSH>;
+		resets = <&crst RSTN_SATA_WRAP>;
+
+		#address-cells = <1>;
+		#size-cells = <0>;
+		#phy-cells = <1>;
+
+		sata-phy@0 {
+			reg = <0>;
+			resets = <&crst RSTN_SATA_MDIO0>,
+				<&crst RSTN_SATA_PHY_POW0>;
+			spread-spectrum = <0>;
+			phy-param = <0x20100E11>, <0x20004E11>, <0x20008E11>,
+				<0x000E0611>, <0x000E4611>, <0x000E8611>,
+				<0x86600A11>, <0x86604A11>, <0x86608A11>,
+				<0x040E2611>, <0x040E6611>, <0x040EA611>,
+				<0xE0500111>, <0xE0484111>, <0xE0448111>,
+				<0xBB662311>, <0xBB666311>, <0xBB66A311>,
+				<0xEF540D11>, <0xEF544D11>, <0xEF548D11>,
+				<0x00132211>, <0x00136211>, <0x0013A211>,
+				<0xBB762311>, <0xBB766311>, <0xBB76A311>,
+				<0xFF041B11>, <0xFF045B11>, <0xFF049B11>,
+				<0x60460211>, <0x60464211>, <0x60468211>,
+				<0x520c0911>, <0x520c4911>, <0x520c8911>,
+				<0x500c0911>, <0x500c4911>, <0x500c8911>,
+				<0x520c0911>, <0x520c4911>, <0x520c8911>;
+			tx-driving-tbl = // user can define tx driving here //
+					<0x40a82011>, <0x40a86011>, <0x40a8a011>,
+					<0x988a2111>, <0x988a6111>, <0x988aa111>;
+		};
+		sata-phy@1 {
+			reg = <1>;
+			resets = <&crst RSTN_SATA_MDIO1>,
+				<&crst RSTN_SATA_PHY_POW1>;
+			spread-spectrum = <0>;
+			phy-param = <0x20100E11>, <0x20004E11>, <0x20008E11>,
+				<0x000E0611>, <0x000E4611>, <0x000E8611>,
+				<0x86600A11>, <0x86604A11>, <0x86608A11>,
+				<0x040E2611>, <0x040E6611>, <0x040EA611>,
+				<0xE0500111>, <0xE0484111>, <0xE0448111>,
+				<0xBB662311>, <0xBB666311>, <0xBB66A311>,
+				<0xEF540D11>, <0xEF544D11>, <0xEF548D11>,
+				<0x00132211>, <0x00136211>, <0x0013A211>,
+				<0xBB762311>, <0xBB766311>, <0xBB76A311>,
+				<0xFF041B11>, <0xFF045B11>, <0xFF049B11>,
+				<0x60460211>, <0x60464211>, <0x60468211>,
+				<0x520c0911>, <0x520c4911>, <0x520c8911>,
+				<0x500c0911>, <0x500c4911>, <0x500c8911>,
+				<0x520c0911>, <0x520c4911>, <0x520c8911>;
+			tx-driving-tbl = // user can define tx driving here //
+					<0x40a82011>, <0x40a86011>, <0x40a8a011>,
+					<0x988a2111>, <0x988a6111>, <0x988aa111>;
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		compatible = "Realtek,ahci-sata";
+		reg = <0x0 0x9803F000 0x0 0x1000>;
+		interrupts = <0 49 4>;
+		clocks = <&clk_en_4 CLK_EN_SATA_MAC_SYSH>;
+		resets = <&crst RSTN_SATA_MAC_COM>;
+
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		sata-port@0 {
+			reg = <0>;
+			phys = <&sata_phy 0>;
+			resets = <&crst RSTN_SATA_MAC_P0>;
+		};
+		sata-port@1 {
+			reg = <1>;
+			phys = <&sata_phy 1>;
+			resets = <&crst RSTN_SATA_MAC_P1>;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-usb.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-usb.dtsi
new file mode 100644
index 00000000..bba44de
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx-usb.dtsi
@@ -0,0 +1,372 @@
+/*
+ * rtd-13xx-usb.dtsi
+ */
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		reg = <0x0 0x98000000 0x0 0x10>;
+
+		//usb_iso_mode;  /* ISO mode is only port suspend (Default disable) */
+		//en_usb_storage_reprobe; /* To enable usb storage re-probe*/
+		//rescue_usb; /* For rescue dtb use */
+
+		clocks = <&iso_clk_en 16>, /* clk_en_usb */
+			<&iso_clk_en 13>,  /* clk_en_usb_drd (port0 phy to u2drd clock) */
+			<&iso_clk_en 14>,  /* clk_en_usb_host0 (port1 phy to u2host clock) */
+			<&iso_clk_en 15>;  /* clk_en_usb_host1 (port2 phy to u3drd clock) */
+		clock-names = "clk_en_usb", /*clk_en_usb*/
+			"clk_en_phy0_to_host", /*clk_en_usb_drd (port0 phy to u2drd clock) */
+			"clk_en_phy1_to_host", /*clk_en_usb_u2host (port1 phy to u2host clock */
+			"clk_en_phy2_to_host"; /*clk_en_usb_u3host (port2 phy to u3drd clock */
+
+		resets =
+			<&iso_asrst 0x100>,
+			<&iso_rst 14>, /* rstn_usb_u2drd */
+			<&iso_rst 15>, /* rstn_usb_u2host */
+			<&iso_asrst 16>, /* rstn_usb_phy0 */
+			<&iso_asrst 17>, /* rstn_usb_phy1 */
+			<&iso_asrst 18>, /* rstn_usb_phy2 */
+			<&iso_rst 19>, /* rstn_usb */
+			<&iso_rst 20>, /* rstn_type c */
+			<&iso_rst 21>, /* rstn_usb_u3drd */
+			<&iso_rst 22>, /* rstn_usb3_phy0 */
+			<&iso_rst 23>, /* rstn_usb3_phy0_mdio */
+			<&iso_rst 24>, /* rstn_usb3_phy1 */
+			<&iso_rst 25>; /* rstn_usb3_phy1_mdio */
+
+		reset-names = "apply",
+			"usb_host0", /*rstn_usb_u2drd*/
+			"usb_host1", /*rstn_usb_u2host*/
+			"u2phy0", /*rstn_usb_phy0*/
+			"u2phy1", /*rstn_usb_phy1*/
+			"u2phy2", /*rstn_usb_phy2*/
+			"usb", /*rstn_usb*/
+			"type_c", /*rstn_type_c*/
+			"usb_host2", /*rstn_usb_u3drd*/
+			"u3phy0", /*rstn_usb3_phy0*/
+			"u3mdio0", /*rstn_usb3_phy0_mdio*/
+			"u3phy1", /*rstn_usb3_phy1*/
+			"u3mdio1"; /*rstn_usb3_phy1_mdio*/
+
+		status = "disabled";
+
+		gpio0: gpio0 {
+			realtek,power-gpio = <&rtk_iso_gpio 48 1 3>;
+			power_low_active;
+
+		};
+		gpio1: gpio1 {
+			realtek,power-gpio = <&rtk_iso_gpio 49 1 3>;
+			power_low_active;
+
+		};
+
+		port0 {
+			usb = <&dwc3_u2drd>;
+			//type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+			gpio = <&gpio0>;
+		};
+		port1 {
+			usb = <&dwc3_u2host>;
+			gpio = <&gpio0>;
+		};
+		port2 {
+			usb = <&dwc3_u3drd>;
+			//type_c = <&dwc3_type_c>; /* for port 2 type c driver */
+			gpio = <&gpio1>;
+		};
+
+		rtk_usb {
+			//pcie_usb3phy_sel = <0x9800705c>; /* Only for RTD1319 */
+
+			power_ctrl_reg {
+				/* l4_icg */
+				p0_l4_icg = <0x98013364>;
+				p1_l4_icg = <0x98013d60>;
+				p2_l4_icg = <0x98013f60>;
+
+				usb_power_cut; /* Non ISO mode and power cut (Default disable power cut) */
+				               /* Note if enable ISO mode, then power_cut will not effective*/
+			};
+			type_c {
+				/* For 1315, 1317, u2drd */
+				//realtek,connector_switch-gpio = <&rtk_iso_gpio 25 1 3>;
+				/* For 1319, u3drd */
+				//realtek,plug_side_switch-gpio = <&rtk_iso_gpio 53 1 3>;
+			};
+		};
+	};
+
+	dwc3_u2drd_usb2phy: dwc3_u2drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98028280 0x0 0x4>, <0x0 0x98013214 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "disabled";
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u2drd: rtk_dwc3_u2drd@98013200 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013200 0x0 0x200>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "disabled";
+
+		dwc3_u2drd@98020000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98020000 0x0 0x9000>;
+			interrupts = <0 95 4>;
+			usb-phy = <&dwc3_u2drd_usb2phy>;
+			dr_mode = "host"; /*otg, host, peripheral*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+
+			status = "disabled";
+		};
+
+		/* u2drd type_c Only For 1317, 1315 */
+		rtk_dwc3_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			reg = <0x0 0x98013200 0x0 0x200>,  <0x0 0x98007220 0x0 0x20>;
+			interrupts = <0 60 4>;
+			drd_mode;  /*depend on dwc3 dr_mode = "peripheral"*/
+			//debug; /*to enable debug log*/
+			delay_probe_work; /*To delay probe work*/
+			ordered_probe; /*ordered probe in delay work*/
+			boot_check_time = <(-1)>; /*ms (At boot Device switch Host time)*/
+			pinctrl-names = "default";
+			pinctrl-0 = <&usb_cc1_pins>, <&usb_cc2_pins>;
+
+			status = "disabled";
+
+			default_revision = <0xA00>;
+			A00 {
+				cc_dfp_mode = "dfp_3_0"; /*dfp_3_0, dfp_1_5, dfp_usb*/
+				rd_config = "internal"; /*internal, extrenal*/
+				cc1_rp_4p7k_code = <0xC>;
+				cc1_rp_36k_code = <0xF>;
+				cc1_rp_12k_code = <0xE>;
+				cc1_rd_code = <0x11>; /*for internal rd*/
+				cc1_vref_ufp = /bits/ 8
+					<0x7 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc1_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc1_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc1_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+				cc2_rp_4p7k_code = <0xC>;
+				cc2_rp_36k_code = <0xF>;
+				cc2_rp_12k_code = <0xE>;
+				cc2_rd_code = <0xF>; /*for internal rd*/
+				cc2_vref_ufp = /bits/ 8
+					<0x8 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc2_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc2_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc2_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+			};
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98031280 0x0 0x4>, <0x0 0x98013C14 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "disabled";
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013C00 0x0 0x200>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "disabled";
+
+		dwc3_u2host@98029000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98029000 0x0 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_u2host_usb2phy>;
+			dr_mode = "host"; /*only host*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+		};
+	};
+
+	dwc3_u3drd_usb3phy: dwc3_u3drd_usb3phy@0 {
+		compatible = "Realtek,usb3phy";
+		reg = <0x0 0x98013E10 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "disabled";
+		phyN = <1>;
+		phy0 {
+			phy_data_size = <0x30>;
+			phy_data_addr = /bits/ 8
+				<0x00 0x01 0x02 0x03 0x04 0x05 0x06
+				0x07 0x08 0x09 0x0A 0x0B 0x0C 0x0D
+				0x0E 0x0F 0x10 0x11 0x12 0x13 0x14
+				0x15 0x16 0x17 0x18 0x19 0x1A 0x1B
+				0x1C 0x1D 0x1E 0x1F 0x20 0x21 0x22
+				0x23 0x24 0x25 0x26 0x27 0x28 0x29
+				0x2A 0x2B 0x2C 0x2D 0x2E 0x2F>;
+			phy_data_revA = /bits/ 16
+				<0x400C 0xAD08 0x6042 0x2771 0x72F5 0x2AD3 0x0003
+				 0x2E00 0x3591 0x565C 0xB608 0xA905 0xC000 0xEF1E
+				 0x2000 0x8D50 0x000C 0x4C10 0xFC00 0x0C81 0xDE01
+				 0x0000 0x0000 0x0000 0x0000 0x6000 0x0085 0x2014
+				 0xC900 0xA03F 0xC2E0 0x7E00 0x70AA 0x88AA 0x0053
+				 0xAB66 0x4770 0x126C 0x840A 0x01D6 0xF802 0xff00
+				 0x3040 0x8028 0xFFFF 0xFFFF 0x0000 0x8600>;
+			do_toggle;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u3drd_usb2phy: dwc3_u3drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98058280 0x0 0x4>, <0x0 0x98013E14 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "disabled";
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x6B 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u3drd: rtk_dwc3_u3drd@98013E00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013E00 0x0 0x200>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+
+		status = "disabled";
+
+		dwc3_u3drd@981F0000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98050000 0x0 0x9000>;
+			interrupts = <0 94 4>;
+			usb-phy = <&dwc3_u3drd_usb2phy &dwc3_u3drd_usb3phy>;
+			dr_mode = "peripheral"; /*only host*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+
+			status = "disabled";
+		};
+
+		/* u3drd type_c Only For 1319 */
+		rtk_dwc3_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			reg = <0x0 0x98013e00 0x0 0x200>,  <0x0 0x98007220 0x0 0x20>;
+			interrupts = <0 60 4>;
+			drd_mode;  /*depend on dwc3 dr_mode = "peripheral"*/
+			//debug; /*to enable debug log*/
+			delay_probe_work; /*To delay probe work*/
+			ordered_probe; /*ordered probe in delay work*/
+			boot_check_time = <(-1)>; /*ms (At boot Device switch Host time)*/
+			pinctrl-names = "default";
+			pinctrl-0 = <&usb_cc1_pins>, <&usb_cc2_pins>;
+
+			status = "disabled";
+
+			default_revision = <0xA00>;
+			A00 {
+				cc_dfp_mode = "dfp_3_0"; /*dfp_3_0, dfp_1_5, dfp_usb*/
+				rd_config = "internal"; /*internal, extrenal*/
+				cc1_rp_4p7k_code = <0xC>;
+				cc1_rp_36k_code = <0xF>;
+				cc1_rp_12k_code = <0xE>;
+				cc1_rd_code = <0x11>; /*for internal rd*/
+				cc1_vref_ufp = /bits/ 8
+					<0x7 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc1_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc1_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc1_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+				cc2_rp_4p7k_code = <0xC>;
+				cc2_rp_36k_code = <0xF>;
+				cc2_rp_12k_code = <0xE>;
+				cc2_rd_code = <0xF>; /*for internal rd*/
+				cc2_vref_ufp = /bits/ 8
+					<0x8 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc2_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc2_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc2_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+			};
+		};
+	};
+
diff --git a/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx.dtsi b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx.dtsi
new file mode 100755
index 00000000..f1058bd
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd13xx/rtd-13xx.dtsi
@@ -0,0 +1,1063 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include <dt-bindings/clock/rtk,clock-rtd13xx.h>
+#include <dt-bindings/reset/rtk,reset-rtd13xx.h>
+#include <dt-bindings/power/rtk,power-rtd13xx.h>
+/include/ "rtd-13xx-pinctrl.dtsi"
+
+/{
+	compatible = "realtek,rtd1319";
+	interrupt-parent = <&gic>;
+	#address-cells = <0x2>;
+	#size-cells = <0x2>;
+
+	aliases {
+		serial0 = &uart0;
+		i2c0 = &i2c_0;
+		i2c1 = &i2c_1;
+		i2c3 = &i2c_3;
+		i2c5 = &i2c_5;
+	};
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A55_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x000>;
+			enable-method = "rtk-spin-table";
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x100>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x200>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x300>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		a55_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	rtk_pm@0 {
+		compatible = "realtek,pm";
+		system-power-controller;
+		reg = <0x0 0x98000000 0x0 0x1800>, /* CRT */
+			<0x0 0x98007000 0x0 0x1000>, /* ISO */
+			<0x0 0x9801A000 0x0 0x1000>; /* SB2 */
+		wakeup-flags = <0x3F>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+		status = "okay";
+	};
+
+	soc@0 {
+		reg = <0x0 0x98000000 0x0 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+	};
+
+	sb2_lock0: sb2-lock@9801A000 {
+		compatible = "realtek,sb2-sem";
+		reg = <0x0 0x9801A000 0x0 0x4>;
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x0 0x9801a000 0x0 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	crt_mmio: mmio@98000000 {
+		compatible = "realtek,mmio";
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	iso_mmio: mmio@98007088 {
+		compatible = "realtek,mmio";
+		reg = <0x0 0x98007088 0x0 0x8>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	efuse@98017000 {
+		compatible = "realtek,efuse";
+		reg = <0x0 0x98017000 0x0 0x1000>;
+		read-only;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		nvmem-cells =
+			<&otp_bond_id>,
+			<&otp_cpu_iddq>,
+			<&otp_top_iddq>,
+			<&otp_etn_para>,
+			<&otp_etn_idca>,
+			<&otp_usb_cc1_comp_cal>,
+			<&otp_usb_cc2_comp_cal>,
+			<&otp_usb_cc1_4_7k_cal>,
+			<&otp_usb_cc1_12k_cal>,
+			<&otp_usb_cc2_4_7k_cal>,
+			<&otp_usb_cc2_12k_cal>,
+			<&otp_usb_cc1_1k_cal>,
+			<&otp_usb_cc2_1k_cal>,
+			<&otp_usb_cc_en>,
+			<&otp_package_id>,
+			<&otp_chip_id>;
+
+		nvmem-cell-names =
+			"bond_id",
+			"cpu_iddq",
+			"top_iddq",
+			"etn_para",
+			"etn_idca",
+			"usb_cc1_comp_cal",
+			"usb_cc2_comp_cal",
+			"usb_cc1_4.7k_cal",
+			"usb_cc1_12k_cal",
+			"usb_cc2_4.7k_cal",
+			"usb_cc2_12k_cal",
+			"otp_usb_cc1_1k_cal",
+			"otp_usb_cc2_1k_cal",
+			"usb_cc_en",
+			"package_id",
+			"chip_id";
+
+		otp_bond_id: bond-id@4f4 {
+			reg = <0x4f4 0x4>;
+			bits = <0 32>;
+		};
+		otp_cpu_iddq: cpu-iddq@4f8 {
+			reg = <0x4f8 0x1>;
+			bits = <0 8>;
+		};
+		otp_top_iddq: top-iddq@4f9 {
+			reg = <0x4f9 0x1>;
+			bits = <0 8>;
+		};
+		otp_etn_para: etn-para@4fc {
+			reg = <0x4fc 0x1>;
+			bits = <0 4>;
+		};
+		otp_etn_idca: etn-idca@500 {
+			reg = <0x500 0x1>;
+			bits = <0 8>;
+		};
+		otp_usb_cc1_comp_cal: usb_cc1_comp_cal@528 {
+			reg = <0x528 0x3>;
+			bits = <0 24>;
+		};
+		otp_usb_cc2_comp_cal: usb_cc2_comp_cal@52b {
+			reg = <0x52b 0x3>;
+			bits = <0 24>;
+		};
+		otp_usb_cc1_4_7k_cal: usb_cc1_4_7k_cal@52e {
+			reg = <0x52e 0x1>;
+			bits = <0 4>;
+		};
+		otp_usb_cc1_12k_cal: usb_cc1_12k_cal@52e {
+			reg = <0x52e 0x1>;
+			bits = <4 4>;
+		};
+		otp_usb_cc2_4_7k_cal: usb_cc2_4_7k_cal@52f {
+			reg = <0x52f 0x1>;
+			bits = <0 4>;
+		};
+		otp_usb_cc2_12k_cal: usb_cc2_12k_cal@52f {
+			reg = <0x52f 0x1>;
+			bits = <4 4>;
+		};
+		otp_usb_cc1_1k_cal: usb_cc1_1k_cal@530 {
+			reg = <0x530 0x1>;
+			bits = <0 4>;
+		};
+		otp_usb_cc2_1k_cal: usb_cc2_1k_cal@530 {
+			reg = <0x530 0x1>;
+			bits = <4 4>;
+		};
+		otp_usb_cc_en: usb_cc_en@50b {
+			reg = <0x531 0x1>;
+			bits = <4 1>;
+		};
+		otp_package_id: package_id@48d {
+			reg = <0x48d 0x1>;
+			bits = <5 2>;
+		};
+		otp_chip_id: chip_id@3cc {
+			reg = <0x3cc 0x10>;
+			bits = <0 128>;
+		};
+	};
+
+	osc27M: osc27M {
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <27000000>;
+		clock-output-names = "osc27M";
+	};
+
+	cc: clocks@98000000 {
+		compatible = "realtek,clock-controller";
+		#clock-cells = <1>;
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		clocks = <&osc27M>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	clk_en_1: clk-en@98000050 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000050 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "unused", "pcie0", "unused", "gspi",
+				     "unused", "unused", "sds", "hdmi",
+				     "unused", "unused", "unused", "unused",
+				     "unused", "unused", "lsadc", "se";
+		ignore-unused-clocks = "hdmi";
+		ignore-pm-clocks = "hdmi";
+	};
+
+	clk_en_2: clk-en@98000054 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000054 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "unused", "cp", "md", "tp",
+				     "rsa", "nf", "emmc", "sd",
+				     "sdio_ip", "mipi", "emmc_ip", "sdio",
+				     "sd_ip", "cablerx", "tpb", "sc1";
+		ignore-unused-clocks = "cp", "md", "tp";
+	};
+
+	clk_en_3: clk-en@98000058 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000058 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "i2c_3", "unused", "jpeg", "unused",
+				     "unused", "sc0", "unused", "unused",
+				     "unused", "unused", "unused", "unused",
+				     "unused", "hdmirx", "hse", "ur2";
+	};
+
+	clk_en_4: clk-en@9800005c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800005c 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "ur1", "fan", "unused", "unused",
+				     "sata_wrap_sys", "sata_wrap_sysh",
+				     "sata_mac_sysh", "r2rdsc",
+				     "unused", "pcie1", "i2c_4", "i2c_5",
+				     "unused", "unused", "edp", "unused";
+	};
+
+	clk_en_7: clk-en@9800008c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800008c 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "pcie2", "unused", "earc";
+	};
+
+	iso_clk_en: clk-en@9800708c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800708c 0x0 0x4>;
+		#clock-cells = <1>;
+		clock-output-names = "lsadc_ecoa2", "unused", "cec0", "cbusrx_sys",
+				     "cbustx_sys", "cbus_sys", "cbus_osc", "ir",
+				     "ur0", "i2c0", "i2c1", "etn_250m",
+				     "etn_sys", "usb_drd", "usb_host",
+				     "usb_u3_host", "usb";
+	};
+
+	iso_clk_en_2: clk-en@98007064 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98007064 0x0 0x4>;
+		#clock-cells = <1>;
+		clock-output-names = "unused", "unused", "unused", "unused",
+				     "unused", "unused", "unused", "unused",
+				     "unused", "iso_gspi";
+	};
+
+	crst: soft-reset@98000000 {
+		compatible = "realtek,rtd13xx-reset-controller";
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		#reset-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	iso_rst: soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98007088 0x0 0x4>;
+		#reset-cells = <1>;
+		realtek,mmio = <&iso_mmio 0x0>;
+	};
+
+	iso_asrst: usb-async-soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98007088 0x0 0x4>;
+		#reset-cells = <1>;
+		async-group = <0>;
+		realtek,mmio = <&iso_mmio 0x0>;
+	};
+
+	pd: power-domain@98007000 {
+		compatible = "realtek,rtd13xx-power-controller";
+		reg = <0x0 0x98007000 0x0 0x1000>;
+		#power-domain-cells = <1>;
+		#powerctrl-cells = <1>;
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x0 0x98000000 0x0 0x200000>;
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x0 0x9801b000 0x0 0x1000>;
+		status = "okay";
+	};
+
+	gic: interrupt-controller@FF100000 {
+		compatible = "arm,gic-v3";
+		#interrupt-cells = <3>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		interrupt-controller;
+		redistributor-stride = <0x0 0x20000>;
+		#redistributor-regions = <1>;
+		reg = <0x0 0xFF100000 0x0 0x10000>, /*  GICD */
+			<0x0 0xFF140000 0x0 0x200000>; /*  GICR */
+		interrupts = <GIC_PPI 9 4>;
+	};
+
+	timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <GIC_PPI 13 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 14 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 11 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 10 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>;
+		clock-frequency = <27000000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <GIC_PPI 7 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>;
+	};
+
+	pinctrl: pinctrl@9804E000 {
+                compatible = "realtek,rtk13xx-pinctrl";
+                reg = <0x0 0x9804E000 0x0 0x130>;
+                #gpio-range-cells = <3>;
+                status = "okay";
+        };
+
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP MISC_ISO */
+			  <0x0 0x98007000 0x0 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	/*
+	 * Suspend GPIO control
+	 *
+	 * [wakeup-gpio-list]
+	 * rtk_iso_gpio 10: BT wakeup host pin
+	 * rtk_iso_gpio 26: WiFi wakeup host pin
+	 *
+	 * [wakeup-gpio-enable]
+	 * Wakeup from BT: <0> disable
+	 * Wakeup from WiFi: <0> disable
+	 *
+	 * [wakeup-gpio-activity]
+	 * BT pin: <0> active low
+	 * WIFI pin: <0> active low
+	 */
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk13xx-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <82>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <51 4>, <52 4>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x0 0x98007000 0x0 0x100>,
+			<0x0 0x98007100 0x0 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 82>;
+		wakeup-gpio-list = <&rtk_iso_gpio 10 0 1>,<&rtk_iso_gpio 26 0 1>;
+		wakeup-gpio-enable = <1>, <1>;
+		wakeup-gpio-activity = <0>, <0>;
+		status = "okay";
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x98007800 0x0 0x400>,
+			  <0x0 0x98007000 0x0 0x100>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		interrupts = <0 68 4>;
+		clock-frequency = <432000000>; /* This value must be override by the board. */
+		clocks = <&iso_clk_en CLK_EN_MISC_UR0>;
+		resets = <&iso_rst RSTN_UR0>;
+		status = "okay";
+	};
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x9801B200 0x0 0x100>,
+			<0x0 0x9801B00c 0x0 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 89 4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart1_pins>;
+		clocks = <&clk_en_4 CLK_EN_UR1>;
+		resets = <&crst RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "okay";
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x9801B400 0x0 0x100>,
+			<0x0 0x9801B00c 0x0 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts =  <0 90 4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_3 CLK_EN_UR2>;
+		resets = <&crst RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "disabled"; /* Disable UR2 first since we don't use it now */
+	};
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x0 0x98016000 0x0 0x1000>,   /* ETN */
+			<0x0 0x98007000 0x0 0x1000>, /* ISO */
+			<0x0 0x9801c000 0x0 0x2000>, /* SBX and SC_WRAP for ACP ctrl */
+			<0x0 0x980174fc 0x0 0x10>,    /* EFUSE_OTP_REG */
+			<0x0 0x9804e000 0x0 0x1000>; /* ISO pinmux */
+		interrupts = <0 22 4>;
+		pinctrl-names = "default",
+				"rgmii";
+		pinctrl-0 = <&etn_led_pins>;
+		pinctrl-1 = <&rgmii_mdio_pins>,
+			<&rgmii_txrx_pins>;
+		local-mac-address = [00 10 20 30 40 50];
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		wake-mask0 = [3f 30 80 c0 3f 10 80 ff ff 1f 00 00 00 00 00 00];
+		wake-crc0 = <0x8d25>;
+		wake-mask1 = [3f 30 80 c0 3f 10 00 00 c0 ff ff 0f 00 00 00 00];
+		wake-crc1 = <0x8d25>;
+		wake-mask2 = [3f 30 80 c0 3f 10 00 00 00 00 00 00 80 ff ff 1f];
+		wake-crc2 = <0x8d25>;
+		wake-mask3 = [3f 30 10 00 c0 ff ff 03 01 f8 ff ff 01 00 00 00];
+		wake-crc3 = <0x11da>;
+		wake-mask4 = [3f 30 10 00 c0 ff ff 03 01 00 00 fc ff ff 00 00];
+		wake-crc4 = <0x11da>;
+		wake-mask5 = [3f 30 10 00 c0 ff ff 03 01 00 00 00 00 00 00 f8];
+		wake-crc5 = <0x15f8>;
+		output-mode = <0>; /* 0:embedded PHY, 1:RGMII to MAC, 2:RGMII to PHY, 3:RMII */
+		voltage = <1>; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+		tx-delay = <0>; /* 0: 0ns, 1: 2ns */
+		rx-delay = <0>; /* 0 ~ 7   x 0.5ns */
+		ext-phy-id = <1>; /* 0 ~ 31, only valid when output-mode = 2 or 4 */
+		bypass = <1>; /* 0: disable, 1: enable */
+		acp = <0>; /* 0: disable, 1: enable */
+		eee = <0>; /* 0: disable, 1: enable */
+		clocks = <&iso_clk_en CLK_EN_ETN_250M>,
+			<&iso_clk_en CLK_EN_ETN_SYS>;
+		clock-names = "etn_250m",
+			"etn_sys";
+		resets = <&iso_rst RSTN_GMAC>,
+			<&iso_rst RSTN_GPHY>;
+		reset-names = "gmac",
+			"gphy";
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x0 0x9801d000 0x0 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+        watchdog@0x98007680 {
+                compatible = "realtek,rtk-watchdog";
+                reg = <0x0 0x9801b5b0 0x0 0x20>, /*misc watchdog for SCPU NMI */
+                        <0x0 0x9801b000 0x0 0x10>,
+                        <0x0 0x98007680 0x0 0x100>; /*iso watchdog for oe workaround */
+                interrupts = <0 0 4>;
+                rst-oe = <0>; /* 0:input, 1:output */
+                rst-oe-for-init = <1>; /* 0:input, 1:output */
+                timeout-sec = <10>;
+                status = "okay";
+        };
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x0 0x98007640 0x0 0x10>;
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x98007D00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <40 4>;
+		i2c-num = <0>;
+		status = "okay";
+		pinctrl-names = "default", "high_speed";
+		pinctrl-0 = <&i2c_pins_0>;
+		pinctrl-1 = <&i2c_pins_0_HS>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iso_clk_en CLK_EN_I2C0>;
+		resets = <&iso_rst RSTN_I2C_0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x98007C00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <43 4>;
+		i2c-num = <1>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_1>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iso_clk_en CLK_EN_I2C1>;
+		resets = <&iso_rst RSTN_I2C_1>;
+	};
+
+	i2c_3: i2c@0x9801B900 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x9801B900 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <23 4>;
+		i2c-num = <3>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_3>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_3 CLK_EN_MISC_I2C_3>;
+		resets = <&crst RSTN_I2C_3>;
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x9801BB00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <14 4>;
+		i2c-num = <5>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_5>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_4 CLK_EN_MISC_I2C_5>;
+		resets = <&crst RSTN_I2C_5>;
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk-dw-apb-ssi";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <27 4>; /* SPI_INT */
+		reg = <0x0 0x9801BD00 0x0 0x100>, /* DW SPI */
+			<0x0 0x9801B300 0x0 0x18>; /* SPI wrapper */
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins_0>;
+		/*spi-cs-gpio = <&rtk_iso_gpio 6 1 1>;*/
+		num-chipselect = <1>;
+		bus-num = <0>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		clock-frequency = <256000000>;
+		resets = <&crst RSTN_GSPI>;
+		status = "disabled";
+	};
+
+	spi_1: spi@98007500 {
+		compatible = "Realtek,rtk-dw-apb-ssi";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <38 4>; /* SPI1_INT */
+		reg = <0x0 0x98007500 0x0 0x100>, /* DW SPI */
+			<0x0 0x980072E4 0x0 0x1C>; /* SPI wrapper */
+		pinctrl-names = "default";
+		pinctrl-0 = <&iso_gspi_pins_0>;
+		num-chipselect = <1>;
+		bus-num = <0>;
+		clocks = <&iso_clk_en_2 CLK_EN_ISO_GSPI>;
+		clock-frequency = <256000000>;
+		resets = <&iso_rst RSTN_ISO_GSPI>;
+		status = "disabled";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x0 0x980070D0 0x0 0xC>;
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm0_0_pins>;
+			pinctrl-1 = <&pwm0_0_pins_disable>;
+			pinctrl-2 = <&pwm0_1_pins>;
+			pinctrl-3 = <&pwm0_1_pins_disable>;
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm1_0_pins>;
+			pinctrl-1 = <&pwm1_0_pins_disable>;
+			pinctrl-2 = <&pwm1_1_pins>;
+			pinctrl-3 = <&pwm1_1_pins_disable>;
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm2_0_pins>;
+			pinctrl-1 = <&pwm2_0_pins_disable>;
+			pinctrl-2 = <&pwm2_1_pins>;
+			pinctrl-3 = <&pwm2_1_pins_disable>;
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm3_0_pins>;
+			pinctrl-1 = <&pwm3_0_pins_disable>;
+			pinctrl-2 = <&pwm3_1_pins>;
+			pinctrl-3 = <&pwm3_1_pins_disable>;
+		};
+	};
+
+	rtk-lsadc@98007900 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <35 4>; /* LSADC0_INT */
+		reg = <0x0 0x98007000 0x0 0x4>, /* ISO_ISR */
+			<0x0 0x98007900 0x0 0x200>, /* LSADC */
+			<0x0 0x9800034C 0x0 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>; /* LSADC0 0:disable; 1:enable */
+		vdd_mux_sel = <0>; /* 0:VDD1; 1:VDD2 */
+		vdd_mux1 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux2 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux_en = <1>; /* 0:disable; 1:enable */
+		clocks = <&iso_clk_en CLK_EN_LSADC_ECOA2>;
+		resets = <&iso_rst RSTN_LSADC_ECOA2>;
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <1>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd161x-hdmitx";
+		reg = <0x0 0x9800d000 0x0 0x560>, /* HDMITX */
+			<0x0 0x98007200 0x0 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 7 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&crst RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		status = "okay";
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <63 4>;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtd161x-hdcptx";
+		reg = <0x0 0x9800d000 0x0 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		status = "okay";
+	};
+
+	sd: sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_iso_gpio 30 1 0>, /*sd power , output, default high  (poweroff) */
+			<&rtk_iso_gpio 34 0 1>,
+			<&rtk_iso_gpio 35 0 1>;
+		reg =   <0x0 0x98000000 0x0 0x400>, /* CRT */
+			<0x0 0x98010400 0x0 0x200>, /* SDMMC */
+			<0x0 0x9801A000 0x0 0x400>, /* BS2 */
+			<0x0 0x9804E000 0x0 0x60>, /* ISO */
+			<0x0 0x98010A00 0x0 0x40>, /* SDIO */
+			<0x0 0x98007000 0x0 0x200>;
+		interrupts = <0 44 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>, <&scpu_ejtag_pins_disable>; /*<&sdcard_pins_high>;*/
+		clocks = <&clk_en_2 CLK_EN_SD>, <&clk_en_2 CLK_EN_SD_IP>;
+		clock-names = "sd", "sd_ip";
+		resets = <&crst RSTN_SD>;
+		status = "okay";
+	};
+
+	sdio: sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 27 1 1>;
+		reg = <0x0 0x98010c00 0x0 0x200>,
+			<0x0 0x98000000 0x0 0x200000>;
+		interrupts = <0 45 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdio_pins_1>;
+		clocks = <&clk_en_2 CLK_EN_SDIO>,
+			<&clk_en_2 CLK_EN_SDIO_IP>;
+		clock-names = "sdio", "sdio_ip";
+		resets = <&crst RSTN_SDIO>;
+		status = "okay";
+	};
+
+	emmc: emmc@98012000 {
+                compatible = "Realtek,rtk13xx-emmc";
+		gpios = <&rtk_iso_gpio 20 1 0>;
+                reg =   <0x0 0x98012000 0x0 0xa00>, /*EMMC*/
+                        <0x0 0x98000000 0x0 0x600>, /*CRT */
+                        <0x0 0x9801A000 0x0 0x80>, /*SB2*/
+                        <0x0 0x9804E000 0x0 0x100>, /* ISO */
+                        <0x0 0x98007E00 0x0 0x20>,
+                        <0x0 0x9804F000 0x0 0x100>;  /*m2tmx*/
+                interrupts = <0 42 4>;
+                speed-step = <0>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_2 CLK_EN_EMMC>, <&clk_en_2 CLK_EN_EMMC_IP>;
+                clock-names = "emmc", "emmc_ip";
+                resets = <&crst RSTN_EMMC>;
+                reset-names = "emmc";
+                status = "okay";
+                pddrive_nf_s0 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+                pddrive_nf_s1 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for ddr50 */
+                pddrive_nf_s2 = <1 0x4 0x4 0x4 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+                pddrive_nf_s3 = <1 0x4 0x4 0x4 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs400 */
+                phase_tuning = <1 1>; /* arg0: tx tuning switch, arg1: rx tuning switch, if we want to set user defined tx or rx, we should set 0 for tx or rx*/
+                reference_phase = <0 0x0 0 0x0>; /* arg0: switch user defined tx, arg1: tx reference phase value, arg2: switch user defined rx, arg3: rx reference phase value*/
+                dqs_tuning = <1>;
+		dqs_dly_tape = <0x0>;
+        };
+
+	nand@98010000 {
+		compatible = "Realtek,rtk1295-nand";
+		reg = <0x0 0x98010000 0x0 0x400>, /* NWC */
+			<0x0 0x9801F000 0x0 0x400>; /* SWC */
+		clocks = <&clk_en_2 CLK_EN_NF>;
+		resets = <&crst RSTN_NF>;
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+                compatible = "Realtek,rfkill";
+                gpios = <&rtk_iso_gpio 11 1 0>; /*bt power , output, default low */
+                status = "okay";
+        };
+
+	rng@98001000 {
+                compatible = "Realtek,rtk-rng";
+		reg = <0x0 0x98001000 0x0 0x70>;
+		status = "okay";
+        };
+
+
+	smartcard@9801BE00 {
+		compatible = "Realtek,rtk-smc";
+		interrupts = <0 63 4>; /* SC0_INT*/
+		reg = <0x0 0x9801B000 0x0 0x100>, /* MISC interrupt */
+			<0x0 0x9801BE00 0x0 0x80>; /* SmartCard */
+		smc-num = <0>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&smartcard_pins_0>;
+		clock-names = "clk_en_misc_sc";
+		clocks = <&clk_en_3 CLK_EN_MISC_SC0>;
+		resets = <&crst RSTN_MISC_SC0>;
+		status = "okay";
+		lsic_control{
+			pin_cmd_vcc = <&rtk_iso_gpio 63 1 0>; /* pin cmd_vcc , default low */
+			pin_pwr_sel = <&rtk_iso_gpio 64 1 0>; /* pin pwr_sel , default 0 */
+			cmd_vcc_en = <1>;
+			cmd_vcc_polarity = <0>; /* low active */
+			pwr_sel_en = <1>;
+			pwr_sel_polarity = <1>; /* high actve 1: 5v */
+		};
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x0 0x98007000 0x0 0x400>,
+			<0x0 0x98007400 0x0 0x100>;
+		interrupts = <37 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&ir_rx_pins>;
+		resets = <&iso_rst RSTN_IR>;
+		clocks = <&iso_clk_en CLK_EN_MISC_IR>;
+		status = "okay";
+	};
+
+        rtc@9801B600 {
+                compatible = "realtek,rtk-rtc";
+                reg = <0x0 0x9801B600 0x0 0x34>,
+                        <0x0 0x98007000 0x0 0x100>;
+                rtc-base-year = <2018>;
+                status = "okay";
+        };
+
+	rpc@9801aa80 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x0 0x9801aa80 0x0 0xc>; /* rpc intr en */
+		interrupts = <0 33 4>,
+			<0 92 4>;
+		status = "okay";
+	};
+
+	dvfs: cpu-dvfs {
+	};
+
+	gpu: gpu@981D0000 {
+		compatible = "arm,mali-midgard";
+		reg = <0x0 0x981D0000 0x0 0x10000>,
+		      <0x0 0x98007000 0x0 0x01000>;
+		interrupts = <GIC_SPI 76 4>, <GIC_SPI 77 4>, <GIC_SPI 75 4>;
+		interrupt-names = "JOB", "MMU", "GPU";
+		clocks = <&cc CC_CLK_GPU>;
+		clock-name = "clk_mali";
+		resets = <&crst RSTN_GPU>, <&crst RSTN_GPU_BIST>;
+		reset-names = "core", "bist";
+		power-domains = <&pd PD_SRAM_GPU>;
+		status = "okay";
+	};
+
+	cpu_tm: thermal-sensor@9801d000 {
+		compatible = "realtek,rtd13xx-thermal-sensor";
+		reg = <0x0 0x9801d000 0x0 0x1000>;
+		#thermal-sensor-cells = <0>;
+		status = "okay";
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+			trips {
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <0>;
+					type = "critical";
+				};
+			};
+			cooling-maps {};
+		};
+	};
+
+	hse@98005000 {
+		reg = <0x0 0x98005000 0x0 0x1000>;
+		compatible = "realtek,highspeed-streaming-engine";
+		interrupts = <GIC_SPI 27 4>;
+		clocks = <&clk_en_3 CLK_EN_HSE>;
+		resets = <&crst RSTN_HSE>;
+		status = "okay";
+
+		engine-0-enabled;
+		engine-1-disabled;
+	};
+
+	mcp@0 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x0 0x98015000 0x0 0x1000>,
+			<0x0 0x98014000 0x0 0x1000>;
+		status = "okay";
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk16xx-pu_pll";
+		reg = <0x0 0x98000000 0x0 0x200>;
+	};
+
+	jpeg: jpeg@9803e000 {
+		compatible = "Realtek,rtk16xx-jpeg";
+		reg = <0x0 0x9803e000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x200>,
+			<0x0 0x98007000 0x0 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_3 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&crst RSTN_JPEG>;
+		status = "okay";
+	};
+
+	ve1: ve1@98040000 {
+		compatible = "Realtek,rtk13xx-ve1";
+		reg = <0x0 0x98040000 0x0 0xc000>,
+			<0x0 0x98008000 0x0 0x1000>,
+			<0x0 0x98007000 0x0 0x30>,
+			<0x0 0x9800E000 0x0 0x1000>;
+		interrupts = <0 53 4>, <0 55 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			 <&cc CC_CLK_VE3>;
+		clock-names = "clk_ve1",
+			      "clk_ve3";
+		resets = <&crst RSTN_VE1>,
+			 <&crst RSTN_VE1_BIST>,
+			 <&crst RSTN_VE3>,
+			 <&crst RSTN_VE3_BIST>;
+		reset-names = "ve1",
+			      "ve1_bist",
+			      "ve3",
+			      "ve3_bist";
+		assigned-clocks        = <&cc CC_CLK_VE1>, <&cc CC_CLK_VE3>;
+		assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE1>;
+		assigned-clock-rates   = <550000000>, <550000000>;
+		status = "okay";
+	};
+	
+	cec0@98037800 {
+		compatible = "Realtek,rtk-cec0";
+		reg = <0x0 0x98037800 0x0 0xe0>,
+			<0x0 0x98007000 0x0 0x100>,
+			<0x0 0x98037500 0x0 0x100>;
+		interrupts = <0 26 4>;
+		clocks = <&iso_clk_en CLK_EN_CBUS_OSC>,
+			<&iso_clk_en CLK_EN_CBUS_SYS>,
+			<&iso_clk_en CLK_EN_CBUSTX_SYS>,
+			<&iso_clk_en CLK_EN_CBUSRX_SYS>;
+		clock-names = "cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys";
+		resets = <&iso_rst RSTN_CBUS>,
+			<&iso_rst RSTN_CBUSTX>,
+			<&iso_rst RSTN_CBUSRX>;
+		reset-names = "cbus",
+			"cbustx",
+			"cbusrx";
+		status = "okay";
+	};
+
+	spdif {
+		compatible = "realtek,audio";
+		gpios = <&rtk_iso_gpio 22 1 1>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>;
+		status = "okay";
+	};
+
+	demod@9801E000 {
+		compatible = "realtek,demod";
+		reg = <0x0 0x9801E000 0x0 0x1000>;
+		clocks = <&clk_en_2 CLK_EN_CABLERX>, <&cc CC_PLL_DIF>;
+		clock-names = "cablerx", "pll";
+		resets = <&crst RSTN_CABLERX>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&demod_pins>;
+		status = "okay";
+	};
+};
+
+#include "rtd-13xx-pcie.dtsi"
+#include "rtd-1319-irda.dtsi"
+#include "rtd-1319-sata.dtsi"
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/Makefile b/arch/arm/boot/dts/realtek/rtd16xx/Makefile
new file mode 100755
index 00000000..722f1bb
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/Makefile
@@ -0,0 +1,33 @@
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-melon.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-tee-melon.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-tee-dvb.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-tee-melon.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-tee-dvb.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-3GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-4GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-qa-rescue-tee-melon.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-qa-rescue-tee-dvb.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-nand-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-megingjord-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-megingjord-2GB-avb.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-dp.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-dp-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-megingjord-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-megingjord-2GB-tee-dvb.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-megingjord-2GB-avb-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-megingjord-2GB-avb-tee-dvb.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-8ch.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-tee-8ch.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-tee-8ch-melon.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-tee-8ch-dvb.dtb
+always          := $(dtb-y)
+subdir-y        := $(dts-dirs)
+clean-files     := *.dtb
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/dtbo/rtd-1619-mjolnir-overlay.dts b/arch/arm/boot/dts/realtek/rtd16xx/dtbo/rtd-1619-mjolnir-overlay.dts
new file mode 100644
index 00000000..6e10ceb
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/dtbo/rtd-1619-mjolnir-overlay.dts
@@ -0,0 +1,90 @@
+/dts-v1/;
+/plugin/;
+
+
+/ {
+	board_id = <0x0>;
+
+};
+
+
+&uart0 {
+	status = "okay";
+};
+
+&uart1 {
+	status = "okay";
+};
+
+&uart2{
+	status = "disabled";
+};
+
+&nic{
+	status = "okay";
+};
+
+&i2c_0{
+	status = "okay";
+};
+
+&i2c_1{
+	status = "okay";
+};
+
+&i2c_3{
+	status = "okay";
+};
+
+&i2c_4{
+	status = "okay";
+};
+
+&i2c_5{
+	status = "okay";
+};
+
+&spi_0{
+	status = "disabled";
+};
+
+&pwm{
+	status = "okay";
+};
+
+&sd{
+	status = "okay";
+};
+
+&sdio{
+	status = "okay";
+};
+
+&emmc{
+	status = "okay";
+};
+
+&gpu{
+	status = "okay";
+};
+
+&cpu_tm{
+	status = "okay";
+};
+
+&md{
+	status = "okay";
+};
+
+&se{
+	status = "okay";
+};
+
+&jpeg{
+	status = "okay";
+};
+
+&ve1{
+	status = "okay";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/dtbo/rtd-16xx-dtboimg.cfg b/arch/arm/boot/dts/realtek/rtd16xx/dtbo/rtd-16xx-dtboimg.cfg
new file mode 100644
index 00000000..9099771
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/dtbo/rtd-16xx-dtboimg.cfg
@@ -0,0 +1,3 @@
+#global options
+rtd-1619-mjolnir-overlay.dtbo
+     id=/:board_id
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-irda.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-irda.dtsi
new file mode 100644
index 00000000..a61baba
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-irda.dtsi
@@ -0,0 +1,51 @@
+/*
+ * rtd-1295-irda.dtsi - IRDA remote Device Tree Include file for REALTEK 1295 family SoC
+ */
+
+/ {
+	irda@98007400 {
+		irda_rx0 {
+			irrx-protocol = "NEC";
+			transcode-mode = <1>;
+
+			cust-code = <0x7F80>;
+			scancode-msk = <0x00FF0000>;  
+			custcode-msk = <0x0000FFFF>;  
+			keymap-tbl = <
+			// scancode	keycode
+				0x18 	116		//KEY_POWER		//POWER
+				0x5A 	353		//KEY_SELECT		//SOURCE
+				0x58 	154		//KEY_CYCLEWINDOWS	//PIP
+				0x1A 	377		//KEY_TV		//TV SYSTEM
+				0x14 	102		//KEY_HOME		//HOME
+				0x56 	357		//KEY_OPTION		//OPTION MENU
+				0x54	358		//KEY_INFO		//MEDIA_INFO
+				0x19 	232		//KEY_REPLY		//REPEAT
+				0x57 	158		//KEY_BACK		//RETURN
+				0x55 	207		//KEY_PLAY		//PLAY/PAUSE
+				0x17 	128		//KEY_STOP		//STOP
+				0x15 	372		//KEY_ZOOM		//ZOOM_IN
+				0x4F 	168		//KEY_REWIND		//FR
+				0x4D 	103		//KEY_UP		//UP
+				0x16 	208		//KEY_FASTFORWARD	//FF
+				0x0C 	105		//KEY_LEFT		//LEFT
+				0x4C 	352		//KEY_OK		//OK
+				0x0E 	106		//KEY_RIGHT		//RIGHT
+				0x08 	412		//KEY_PREVIOUS		//PREVIOUS
+				0x48 	108		//KEY_DOWN		//DOWN
+				0x09 	407		//KEY_NEXT		//NEXT
+				0x4B 	114		//KEY_VOLUMEDOWN	//VOL-
+				0x49 	115		//KEY_VOLUMEUP		//VOL+
+				0x0B 	532		//KEY_TOUCHPAD_OFF	//CURSOR
+				0x0A 	531		//KEY_TOUCHPAD_ON	//GESTURE
+				0xEEEE	0		//REL_X			//mouse X-axi	0xEEEE : REL event type
+				0xEEEE	1		//REL_Y			//mouse Y-axi	0xEEEE : REL event type
+				0xFFFF	272		//BTN_LEFT		//mouse left key	0xFFFF : KEY event type
+				0xFFFF	113     	//KEY_MUTE 		//mute key in AirFunAPP	0xFFFF : KEY event type	
+           		>; 
+			reg-ir-dpir = <50>;	/*IR detect interval, NEC default=50ms, should less than 100ms, and bigger than 9ms*/
+			sample-rate = <40>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb-tee-dvb.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb-tee-dvb.dts
new file mode 100755
index 00000000..8f7eb20
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb-tee-dvb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-megingjord-2GB-tee-dvb.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	        model= "Realtek_megingjord_2GB_AVB_TEE_DVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb-tee.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb-tee.dts
new file mode 100644
index 00000000..f4539977
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb-tee.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-megingjord-2GB-tee.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	        model= "Realtek_megingjord_2GB_AVB_TEE";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb.dts
new file mode 100644
index 00000000..6be22b3
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-megingjord-2GB.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	        model= "Realtek_megingjord_2GB_AVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-tee-dvb.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-tee-dvb.dts
new file mode 100755
index 00000000..e4a596e
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-tee-dvb.dts
@@ -0,0 +1,329 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+#define SECURE_TP_SIZE          (0x01000000) // 16M
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0;
+
+#include "rtd-1619-megingjord.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB_TEE_DVB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=320M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+			ION_SECURE_HEAP_PHYS_0
+			ION_SECURE_HEAP_SIZE_0
+			ION_SECURE_HEAP_FLAG_0
+			ION_SECURE_AUDIO_PHYS_0
+			ION_SECURE_AUDIO_SIZE_0
+			ION_SECURE_AUDIO_FLAG_0
+			ION_SECURE_TP_PHYS_0
+			ION_SECURE_TP_SIZE_0
+			ION_SECURE_TP_FLAG_0>;
+		};
+
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	rtk_usb_power_manager@0 {
+		gpio1: gpio1 {
+			/delete-property/realtek,power-gpio; //gpio48
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+		};
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "disabled";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		/delete-property/dis_u3_port; // Disable usb 3.0 port
+
+		dwc3_u3host@981F0000 {
+			/delete-property/snps,dis_u3_susphy_quirk;
+		};
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	spdif {
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		status = "disabled";
+	};
+
+	uart1: serial1@9801B200 {
+		status = "disabled";
+	};
+
+	uart2: serial2@9801B400 {
+		status = "disabled";
+	};
+
+	hse@98005000 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 60 1 1>;
+		wakeup-gpio-list = <&rtk_iso_gpio 26 0 1>;
+		wakeup-gpio-enable = <0>;
+		wakeup-gpio-activity = <0>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		gpios = <&rtk_iso_gpio 67 1 1>,
+			<&rtk_iso_gpio 62 1 1>,
+			<&rtk_iso_gpio 63 1 1>,
+			<&rtk_iso_gpio 64 1 1>;
+		sata-port@0 {
+			/delete-property/ gpios;
+		};
+		sata-port@1 {
+			/delete-property/ gpios;
+		};
+	};
+
+	dptx@9803D000 {
+		status = "okay";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 78 0 0>; /*HPD, input, default N/A */
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-tee.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-tee.dts
new file mode 100644
index 00000000..f94e638c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-tee.dts
@@ -0,0 +1,320 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+#include "rtd-1619-megingjord.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB_TEE";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=320M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+			ION_SECURE_HEAP_PHYS_0
+			ION_SECURE_HEAP_SIZE_0
+			ION_SECURE_HEAP_FLAG_0
+			ION_SECURE_AUDIO_PHYS_0
+			ION_SECURE_AUDIO_SIZE_0
+			ION_SECURE_AUDIO_FLAG_0>;
+		};
+
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	rtk_usb_power_manager@0 {
+		gpio1: gpio1 {
+			/delete-property/realtek,power-gpio; //gpio48
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+		};
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "disabled";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		/delete-property/dis_u3_port; // Disable usb 3.0 port
+
+		dwc3_u3host@981F0000 {
+			/delete-property/snps,dis_u3_susphy_quirk;
+		};
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	spdif {
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		status = "disabled";
+	};
+
+	uart1: serial1@9801B200 {
+		status = "disabled";
+	};
+
+	uart2: serial2@9801B400 {
+		status = "disabled";
+	};
+
+	hse@98005000 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 60 1 1>;
+		wakeup-gpio-list = <&rtk_iso_gpio 26 0 1>;
+		wakeup-gpio-enable = <0>;
+		wakeup-gpio-activity = <0>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		gpios = <&rtk_iso_gpio 67 1 1>,
+			<&rtk_iso_gpio 62 1 1>,
+			<&rtk_iso_gpio 63 1 1>,
+			<&rtk_iso_gpio 64 1 1>;
+		sata-port@0 {
+			/delete-property/ gpios;
+		};
+		sata-port@1 {
+			/delete-property/ gpios;
+		};
+	};
+
+	dptx@9803D000 {
+		status = "okay";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 78 0 0>; /*HPD, input, default N/A */
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB.dts
new file mode 100644
index 00000000..41c2376
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB.dts
@@ -0,0 +1,289 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000;
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-megingjord.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=320M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	rtk_usb_power_manager@0 {
+		gpio1: gpio1 {
+			/delete-property/realtek,power-gpio; //gpio48
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+		};
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "disabled";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		/delete-property/dis_u3_port; // Disable usb 3.0 port
+
+		dwc3_u3host@981F0000 {
+			/delete-property/snps,dis_u3_susphy_quirk;
+		};
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	spdif {
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		status = "disabled";
+	};
+
+	uart1: serial1@9801B200 {
+		status = "disabled";
+	};
+
+	uart2: serial2@9801B400 {
+		status = "disabled";
+	};
+
+	hse@98005000 {
+		status = "disabled";
+	};
+
+	dptx@9803D000 {
+		status = "okay";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 78 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 60 1 1>;
+		wakeup-gpio-list = <&rtk_iso_gpio 26 0 1>;
+		wakeup-gpio-enable = <0>;
+		wakeup-gpio-activity = <0>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		gpios = <&rtk_iso_gpio 67 1 1>,
+			<&rtk_iso_gpio 62 1 1>,
+			<&rtk_iso_gpio 63 1 1>,
+			<&rtk_iso_gpio 64 1 1>;
+		sata-port@0 {
+			/delete-property/ gpios;
+		};
+		sata-port@1 {
+			/delete-property/ gpios;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord.dtsi
new file mode 100644
index 00000000..548efb7
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-megingjord.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-16xx.dtsi"
+#include "rtd-16xx-dvfs.dtsi"
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-1GB.CMAx2.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-1GB.CMAx2.dts
new file mode 100755
index 00000000..ff278e0
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-1GB.CMAx2.dts
@@ -0,0 +1,237 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_1GB_CMAx2";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=320M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0 0x0b000000>; /* size 176MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x14000000 0 0x0b000000>; /* offset 320MB, size 176MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x00800000>; /* size 8MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		status = "okay";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-8ch.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-8ch.dts
new file mode 100644
index 00000000..821599b
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-8ch.dts
@@ -0,0 +1,8 @@
+#include "rtd-1619-mjolnir-2GB.dts"
+#include "rtd-16xx-avb.dtsi"
+#include "rtd-16xx-ao_i2s_8ch.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB_8CH";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-dp-tee.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-dp-tee.dts
new file mode 100644
index 00000000..4d25bbb
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-dp-tee.dts
@@ -0,0 +1,19 @@
+#include "rtd-1619-mjolnir-2GB-tee.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB";
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				/delete-node/ system;
+				/delete-node/ vendor;
+			};
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-dp.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-dp.dts
new file mode 100644
index 00000000..62d13320
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-dp.dts
@@ -0,0 +1,20 @@
+#include "rtd-1619-mjolnir-2GB.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB";
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor,product";
+			};
+			fstab {
+				/delete-node/ system;
+				/delete-node/ vendor;
+				/delete-node/ product;
+			};
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch-dvb.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch-dvb.dts
new file mode 100755
index 00000000..05b5f5c
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch-dvb.dts
@@ -0,0 +1,8 @@
+#include "rtd-1619-mjolnir-2GB-tee-dvb.dts"
+#include "rtd-16xx-avb.dtsi"
+#include "rtd-16xx-ao_i2s_8ch.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB_TEE_8CH_DVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch-melon.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch-melon.dts
new file mode 100755
index 00000000..f991030
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch-melon.dts
@@ -0,0 +1,8 @@
+#include "rtd-1619-mjolnir-2GB-tee-melon.dts"
+#include "rtd-16xx-avb.dtsi"
+#include "rtd-16xx-ao_i2s_8ch.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB_8CH_TEE_MELON";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch.dts
new file mode 100644
index 00000000..afb3328
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch.dts
@@ -0,0 +1,8 @@
+#include "rtd-1619-mjolnir-2GB-tee.dts"
+#include "rtd-16xx-avb.dtsi"
+#include "rtd-16xx-ao_i2s_8ch.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB_TEE_8CH";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-dvb.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-dvb.dts
new file mode 100755
index 00000000..626a6ff
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-dvb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-mjolnir-2GB-tee-dvb.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB_TEE_DVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-melon.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-melon.dts
new file mode 100755
index 00000000..e923b53
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-melon.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-mjolnir-2GB-tee-melon.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB_TEE_MELON";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee.dts
new file mode 100644
index 00000000..aaa1b19
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-mjolnir-2GB-tee.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB_TEE";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb.dts
new file mode 100644
index 00000000..048cb53
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-mjolnir-2GB.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB";
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-melon.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-melon.dts
new file mode 100755
index 00000000..99dc5f2
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-melon.dts
@@ -0,0 +1,243 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ 0x10200000 0x03A00000;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ HIF_EMMC_RSV_PHYS HIF_EMMC_RSV_SIZE;
+
+#define SECURE_AUDIO_REQ_SIZE   (0x00200000) // 2M
+#define SECURE_TP_SIZE          (0x01000000) // 16M
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define ION_SECURE_AUDIO_REQ_PHYS_0  (0x32600000)
+#define ION_SECURE_AUDIO_REQ_SIZE_0  (SECURE_AUDIO_REQ_SIZE)
+#define ION_SECURE_AUDIO_REQ_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_REQ_PHYS_0 ION_SECURE_AUDIO_REQ_SIZE_0;
+/memreserve/ ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0;
+
+#include "rtd-1619-mjolnir-tcc.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_MELON";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=320M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		status = "disabled";
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee-dvb.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee-dvb.dts
new file mode 100755
index 00000000..006d848
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee-dvb.dts
@@ -0,0 +1,262 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+#define SECURE_TP_SIZE          (0x01000000) // 16M
+
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_TEE_DVB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				ION_SECURE_HEAP_PHYS_0
+				ION_SECURE_HEAP_SIZE_0
+				ION_SECURE_HEAP_FLAG_0
+				ION_SECURE_AUDIO_PHYS_0
+				ION_SECURE_AUDIO_SIZE_0
+				ION_SECURE_AUDIO_FLAG_0
+				ION_SECURE_TP_PHYS_0
+				ION_SECURE_TP_SIZE_0
+				ION_SECURE_TP_FLAG_0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		status = "okay";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee-melon.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee-melon.dts
new file mode 100755
index 00000000..02f6df3
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee-melon.dts
@@ -0,0 +1,266 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ 0x10200000 0x03A00000;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ HIF_EMMC_RSV_PHYS HIF_EMMC_RSV_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+#define SECURE_AUDIO_REQ_SIZE   (0x00200000) // 2M
+#define SECURE_TP_SIZE          (0x01000000) // 16M
+
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+#define ION_SECURE_AUDIO_REQ_PHYS_0  (0x32600000)
+#define ION_SECURE_AUDIO_REQ_SIZE_0  (SECURE_AUDIO_REQ_SIZE)
+#define ION_SECURE_AUDIO_REQ_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0 ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0 ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1 ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0 ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_REQ_PHYS_0 ION_SECURE_AUDIO_REQ_SIZE_0;
+/memreserve/ ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0;
+
+#include "rtd-1619-mjolnir-tcc.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_TEE_MELON";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=360M loop.max_part=7 androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				ION_SECURE_HEAP_PHYS_0
+				ION_SECURE_HEAP_SIZE_0
+				ION_SECURE_HEAP_FLAG_0
+				ION_SECURE_AUDIO_PHYS_0
+				ION_SECURE_AUDIO_SIZE_0
+				ION_SECURE_AUDIO_FLAG_0
+				ION_SECURE_TP_PHYS_0
+				ION_SECURE_TP_SIZE_0
+				ION_SECURE_TP_FLAG_0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		status = "disabled";
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee.dts
new file mode 100644
index 00000000..00f20a1
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee.dts
@@ -0,0 +1,255 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_TEE";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=320M loop.max_part=7 androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS_0 
+                ION_SECURE_HEAP_SIZE_0 
+                ION_SECURE_HEAP_FLAG_0
+                ION_SECURE_AUDIO_PHYS_0 
+                ION_SECURE_AUDIO_SIZE_0 
+                ION_SECURE_AUDIO_FLAG_0
+                >;
+        };
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		status = "okay";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB.dts
new file mode 100755
index 00000000..c6c18c7
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB.dts
@@ -0,0 +1,232 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=320M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		status = "okay";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-3GB.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-3GB.dts
new file mode 100644
index 00000000..88edf83
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-3GB.dts
@@ -0,0 +1,233 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_3GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=320M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x00000000 0x00000000 0x00000000 0x98000000>,
+		      <0x00000000 0x99000000 0x00000000 0x27000000>; /* 3072 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		status = "okay";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-4GB.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-4GB.dts
new file mode 100644
index 00000000..b531d50
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-4GB.dts
@@ -0,0 +1,233 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_4GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init vmalloc=320M loop.max_part=7 androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x00000000 0x00000000 0x00000000 0x98000000>,
+		      <0x00000000 0x99000000 0x00000000 0x66000000>; /* 4096 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		status = "okay";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-nand-2GB.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-nand-2GB.dts
new file mode 100644
index 00000000..af77bd0
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-nand-2GB.dts
@@ -0,0 +1,222 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_NAND";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=thor androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	nand@98010000 { status = "okay"; };
+	emmc@98012000 { status = "disabled"; };
+	
+	dptx@9803D000 {
+		status = "disabled";
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-tcc.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-tcc.dtsi
new file mode 100644
index 00000000..c1407da
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-tcc.dtsi
@@ -0,0 +1,36 @@
+/*
+ * RTD-1619 Mjolnir with Tee Clock Controller
+ */
+#include "rtd-1619-mjolnir.dtsi"
+
+/{
+	tcc: tee-clocks {
+		compatible = "realtek,tee-clock-controller";
+		#clock-cells = <0>;
+	};
+};
+
+/* CPU nodes */
+&A55_0 {
+	clocks = <&tcc>;
+};
+
+&A55_1 {
+	clocks = <&tcc>;
+};
+
+&A55_2 {
+	clocks = <&tcc>;
+};
+
+&A55_3 {
+	clocks = <&tcc>;
+};
+
+&A55_4 {
+	clocks = <&tcc>;
+};
+
+&A55_5 {
+	clocks = <&tcc>;
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir.dtsi
new file mode 100644
index 00000000..548efb7
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-16xx.dtsi"
+#include "rtd-16xx-dvfs.dtsi"
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee-dvb.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee-dvb.dts
new file mode 100755
index 00000000..784d25f
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee-dvb.dts
@@ -0,0 +1,186 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+#define SECURE_TP_SIZE          (0x01000000) // 16M
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/memreserve/ ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-16xx.dtsi"
+#include "rtd-1619-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB_TEE_DVB";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+
+		rtk,ion-heap@9 { /* SECURE */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <9>;
+                        rtk,memory-reserve = <
+                                0x32b00000
+                                0x12C00000
+                                ION_SECURE_HEAP_FLAG>;
+		};
+
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee-melon.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee-melon.dts
new file mode 100644
index 00000000..e995edc
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee-melon.dts
@@ -0,0 +1,199 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+#define SECURE_AUDIO_REQ_SIZE   (0x00200000) // 2M
+#define SECURE_TP_SIZE          (0x01000000) // 16M
+
+#define ION_SECURE_AUDIO_REQ_PHYS_0  (0x32600000)
+#define ION_SECURE_AUDIO_REQ_SIZE_0  (SECURE_AUDIO_REQ_SIZE)
+#define ION_SECURE_AUDIO_REQ_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/memreserve/ ION_SECURE_AUDIO_REQ_PHYS_0 ION_SECURE_AUDIO_REQ_SIZE_0;
+/memreserve/ ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-16xx.dtsi"
+#include "rtd-1619-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB_TEE_MELON";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+
+		rtk,ion-heap@9 { /* SECURE */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <9>;
+                        rtk,memory-reserve = <
+                                0x32b00000
+                                0x12C00000
+                                ION_SECURE_HEAP_FLAG>;
+		};
+
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&pcie2 {
+	status = "disabled";
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee.dts
new file mode 100644
index 00000000..23ebf4ab
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee.dts
@@ -0,0 +1,176 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-16xx.dtsi"
+#include "rtd-1619-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB_TEE";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+
+		rtk,ion-heap@9 { /* SECURE */
+                        compatible = "Realtek,rtk-ion-reserve";
+                        reg = <9>;
+                        rtk,memory-reserve = <
+                                0x32b00000
+                                0x12C00000
+                                ION_SECURE_HEAP_FLAG>;
+		};
+
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue.dts b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue.dts
new file mode 100644
index 00000000..dca599b
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue.dts
@@ -0,0 +1,166 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-16xx.dtsi"
+#include "rtd-1619-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-sata.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-sata.dtsi
new file mode 100644
index 00000000..6c1d64f
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-sata.dtsi
@@ -0,0 +1,68 @@
+#include <dt-bindings/reset/rtk,reset-rtd16xx.h>
+#include <dt-bindings/clock/rtk,clock-rtd16xx.h>
+/ {
+	/include/ "rtd-16xx-sata.dtsi"
+
+	sata_phy: sata_phy@9803FF60 {
+		clocks = <&clk_en_4 CLK_EN_SATA_WRAP_SYS>,
+			<&clk_en_4 CLK_EN_SATA_WRAP_SYSH>;
+		resets = <&crst RSTN_SATA_WRAP>;
+		sata-phy@0 {
+			reg = <0>;
+			resets = <&crst RSTN_SATA_MDIO0>,
+				<&crst RSTN_SATA_PHY_POW0>;
+			spread-spectrum = <0>;
+			phy-param = <0x70000211>, <0x70004211>, <0x70008211>,
+				<0x336a0511>, <0x336a4511>, <0x336a8511>,
+				<0xa9040b11>, <0xa9044b11>, <0xa9048b11>,
+				<0x500b1411>, <0x500b5411>, <0x500b9411>,
+				<0x77771511>, <0x77775511>, <0x77779511>,
+				<0x00231711>, <0x00235711>, <0x00239711>,
+				<0x00632211>, <0x00636211>, <0x0063a211>,
+				<0xab762311>, <0xab766311>, <0xab76a311>;
+			tx-driving-tbl = // user can define tx driving here //
+					<0x40aa2011>, <0x40aa6011>, <0x40a8a011>,
+					<0x88aa2111>, <0x88aa6111>, <0x88aaa111>;
+			rx-sense-tbl = // user can define rx sensitivity here //
+					<0x42100911>, <0x42104911>, <0x42108911>,
+					<0x27660311>, <0x276a4311>, <0x27668311>;
+		};
+		sata-phy@1 {
+			reg = <1>;
+			resets = <&crst RSTN_SATA_MDIO1>,
+				<&crst RSTN_SATA_PHY_POW1>;
+			spread-spectrum = <0>;
+			phy-param = <0x70000211>, <0x70004211>, <0x70008211>,
+				<0x336a0511>, <0x336a4511>, <0x336a8511>,
+				<0xa9040b11>, <0xa9044b11>, <0xa9048b11>,
+				<0x500b1411>, <0x500b5411>, <0x500b9411>,
+				<0x77771511>, <0x77775511>, <0x77779511>,
+				<0x00231711>, <0x00235711>, <0x00239711>,
+				<0x00632211>, <0x00636211>, <0x0063a211>,
+				<0xab762311>, <0xab766311>, <0xab76a311>;
+			tx-driving-tbl = // user can define tx driving here //
+					<0x40aa2011>, <0x40aa6011>, <0x40a8a011>,
+					<0x88aa2111>, <0x88aa6111>, <0x88aaa111>;
+			rx-sense-tbl = // user can define rx sensitivity here //
+					<0x42100911>, <0x42104911>, <0x42108911>,
+					<0x27660311>, <0x276a4311>, <0x27668311>;
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		clocks = <&clk_en_4 CLK_EN_SATA_MAC_SYSH>;
+		resets = <&crst RSTN_SATA_MAC_COM>;
+		sata-port@0 {
+			reg = <0>;
+			phys = <&sata_phy 0>;
+			resets = <&crst RSTN_SATA_MAC_P0>;
+			gpios = <&rtk_iso_gpio 65 1 1>;
+		};
+		sata-port@1 {
+			reg = <1>;
+			phys = <&sata_phy 1>;
+			resets = <&crst RSTN_SATA_MAC_P1>;
+			gpios = <&rtk_iso_gpio 67 1 1>;
+		};
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-usb.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-usb.dtsi
new file mode 100644
index 00000000..a6c825b
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-1619-usb.dtsi
@@ -0,0 +1,48 @@
+/*
+ * realtek,port0-power-gpio: drd TypeC power, output, default low
+ * realtek,port1-power-gpio: u2host power, output, default low
+ * realtek,port2-power-gpio: u3host power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+/ {
+	/include/ "rtd-16xx-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+
+		status = "okay";
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+		};
+
+		rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			drd_mode; //depend on dr_mode = "peripheral"
+			status = "okay";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+		dwc3_u3host@981F0000 {
+			compatible = "synopsys,dwc3";
+			status = "okay";
+		};
+
+	};
+
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-ao_i2s_8ch.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-ao_i2s_8ch.dtsi
new file mode 100644
index 00000000..42be099
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-ao_i2s_8ch.dtsi
@@ -0,0 +1,9 @@
+
+&audio_out {
+	status = "okay";
+	clocks = <&cc CC_PLL_DDSA>, <&cc CC_PLL_PSAUD1A>, <&cc CC_PLL_PSAUD2A>;
+	clock-names = "ddsa", "psaud1a", "psaud2a";
+	i2s {
+		channel = <8>;
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-avb.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-avb.dtsi
new file mode 100644
index 00000000..60e2d6f
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-avb.dtsi
@@ -0,0 +1,17 @@
+/ {
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				/delete-node/ system;
+				vendor {
+					fsmgr_flags = "wait,avb";
+				};
+			};
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-dvfs.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-dvfs.dtsi
new file mode 100644
index 00000000..edc1989
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-dvfs.dtsi
@@ -0,0 +1,441 @@
+/*
+ * RTD-16XX CPU DVFS with GMT G2237 / SILERGY SY8827E / ANPEC APW8889
+ */
+#include <dt-bindings/regulator/gmt,g22xx.h>
+#include <dt-bindings/regulator/anpec,apw888x.h>
+#include <dt-bindings/thermal/thermal.h>
+
+&i2c_0 {
+	status = "okay";
+
+	cpu_supp_0: sy8827e: sy8827e@41 {
+		compatible = "silergy,sy8827e";
+		reg = <0x41>;
+		regulator-name = "cpudvs";
+		regulator-min-microvolt = <712500>;
+		regulator-max-microvolt = <1500000>;
+		regulator-ramp-delay = <2000>;
+		regulator-boot-on;
+		regulator-always-on;
+		status = "okay";
+	};
+
+	reg_sel: selector@12 {
+		compatible = "realtek,regulator-selector";
+		reg = <0x12>;
+		status = "okay";
+		cpu_supp: cpu-selector {
+			compatible = "supply-selector";
+			g2237-supply = <&cpu_supp_0>;
+			apw8889-supply = <&cpu_supp_1>;
+		};
+		gpu_supp: gpu-selector {
+			compatible = "supply-selector";
+			g2237-supply = <&gpu_supp_0>;
+			apw8889-supply = <&gpu_supp_1>;
+		};
+	};
+
+	g2237: g2237@12 {
+		compatible = "gmt,g2237";
+		reg = <0x12>;
+
+		/*** should be disabled ***/
+		status = "disabled";
+
+		powerkey_0: powerkey {
+			compatible = "gmt,g22xx-powerkey";
+			status = "disabled";
+		};
+		poweroff_0: poweroff {
+			compatible = "gmt,g22xx-poweroff";
+			system-power-controller;
+			status = "disabled";
+		};
+		regulators_0: regulators {
+			compatible = "gmt,g2237-regulator";
+			status = "okay";
+		};
+	};
+
+	apw8889: apw8889@12 {
+		compatible = "anpec,apw8889";
+		reg = <0x12>;
+
+		/*** should be disabled ***/
+		status = "disabled";
+
+		powerkey_1: powerkey {
+			compatible = "gmt,g22xx-powerkey";
+			status = "disabled";
+		};
+		poweroff_1: poweroff {
+			compatible = "gmt,g22xx-poweroff";
+			system-power-controller;
+			status = "disabled";
+		};
+		regulators_1: regulators {
+			compatible = "anpec,apw8889-regulator";
+			status = "okay";
+		};
+
+	};
+};
+
+&g2237 {
+	regulators {
+		vd33_supp_0: dc1 {
+			regulator-name = "vd33";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3700000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <3200000>;
+			};
+		};
+		gpu_supp_0: dc2 {
+			regulator-name = "gpudvs";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-ramp-delay = <625>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		core_supp_0: dc3 {
+			regulator-name = "core";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <900000>;
+			};
+		};
+		ddr_supp_0: dc4 {
+			regulator-name = "ddr";
+			regulator-min-microvolt = <1200000>;
+			regulator-max-microvolt = <1200000>;
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+
+		};
+		vd18_supp_0: dc5 {
+			regulator-name = "vd18";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <2500000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+		};
+		vd25_supp_0: ldo1 {
+			regulator-name = "vd25";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3000000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_LDO_MODE_NORMAL>;
+		};
+	};
+};
+
+&apw8889 {
+	regulators {
+		vd33_supp_1: dc1 {
+			regulator-name = "vd33";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3777500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <3200000>;
+			};
+		};
+		core_supp_1: dc2 {
+			regulator-name = "core";
+			regulator-min-microvolt = <550000>;
+			regulator-max-microvolt = <1337500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <900000>;
+			};
+		};
+		cpu_supp_1: dc3 {
+			regulator-name = "cpudvs";
+			regulator-min-microvolt = <550000>;
+			regulator-max-microvolt = <1337500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+			regulator-ramp-delay = <625>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		gpu_supp_1: dc4 {
+			regulator-name = "gpudvs";
+			regulator-min-microvolt = <550000>;
+			regulator-max-microvolt = <1337500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+			regulator-ramp-delay = <625>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		ddr_supp_1: dc5 {
+			regulator-name = "ddr";
+			regulator-min-microvolt = <1200000>;
+			regulator-max-microvolt = <1200000>;
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+		};
+		vd18_supp_1: dc6 {
+			regulator-name = "vd18";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <2060000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+		};
+		vd25_supp_1: ldo1 {
+			regulator-name = "vd25";
+			regulator-min-microvolt = <1780000>;
+			regulator-max-microvolt = <3020000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_LDO_MODE_NORMAL>;
+		};
+	};
+};
+
+/* CPU nodes */
+&A55_0 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_1 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_2 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_3 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_4 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_5 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&dvfs {
+	cpu_opps: cpu-opp-table {
+		compatible = "operating-points-v2";
+		opp-shared;
+		opp300: opp-300mhz {
+			opp-hz = /bits/ 64 <300000000>;
+			opp-microvolt = <787500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp400: opp-400mhz {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-microvolt = <787500>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		opp500: opp-500mhz {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-microvolt = <787500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp600: opp-600mhz {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-microvolt = <787500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp700: opp-700mhz {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-microvolt = <812500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp800: opp-800mhz {
+			opp-hz = /bits/ 64 <800000000>;
+			opp-microvolt    = <850000>;
+			opp-microvolt-tt = <837500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp900: opp-900mhz {
+			opp-hz = /bits/ 64 <900000000>;
+			opp-microvolt    = <900000>;
+			opp-microvolt-tt = <887500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1000: opp-1000mhz {
+			opp-hz = /bits/ 64 <1000000000>;
+			opp-microvolt    = <950000>;
+			opp-microvolt-tt = <937500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1100: opp-1100mhz {
+			opp-hz = /bits/ 64 <1100000000>;
+			opp-microvolt    = <1012500>;
+			opp-microvolt-tt = <987500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1200: opp-1200mhz {
+			opp-hz = /bits/ 64 <1200000000>;
+			opp-microvolt    = <1062500>;
+			opp-microvolt-tt = <1025000>;
+			clock-latency-ns = <150000>;
+			opp-suspend;
+			status = "okay";
+		};
+		opp1300: opp-1300mhz {
+			opp-hz = /bits/ 64 <1300000000>;
+			opp-microvolt    = <1125000>;
+			opp-microvolt-tt = <1075000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1400: opp-1400mhz {
+			opp-hz = /bits/ 64 <1400000000>;
+			opp-microvolt = <1125000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+	};
+};
+
+&cpu_thermal {
+	trips {
+		tm_alert0: cpu-alert0 {
+			temperature = <105000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+		tm_alert1: cpu-alert1 {
+			temperature = <115000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+	};
+	cooling-maps {
+		cpu-map0 {
+			trip = <&tm_alert0>;
+			cooling-device = <&A55_0 THERMAL_NO_LIMIT 6>;
+			contribution = <70>;
+		};
+		cpu-map1 {
+			trip = <&tm_alert1>;
+			cooling-device = <&A55_0 7 THERMAL_NO_LIMIT>;
+			contribution = <70>;
+		};
+	};
+};
+
+
+&gpu {
+	mali-supply = <&gpu_supp>;
+	operating-points-v2 = <&gpu_opps>;
+	assigned-clocks = <&cc CC_CLK_GPU>;
+	assigned-clock-rates = <400000000>;
+
+	gpu_opps: gpu-opp-table {
+		compatible = "operating-points-v2",
+			"operating-points-v2-mali";
+
+		opp-1x400 {
+			opp-hz = /bits/ 64 <133000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			opp-core-mask = /bits/ 64 <0x2>;
+		};
+		opp-2x400 {
+			opp-hz = /bits/ 64 <266000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			opp-core-mask = /bits/ 64 <0x1>;
+		};
+		opp-3x400 {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			opp-suspend;
+		};
+		opp-3x500 {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-hz-real = /bits/ 64 <500000000>;
+			opp-microvolt = <1000000>;
+		};
+		opp-3x600 {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-hz-real = /bits/ 64 <600000000>;
+			opp-microvolt = <1000000>;
+		};
+		opp-3x700 {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-hz-real = /bits/ 64 <700000000>;
+			opp-microvolt = <1000000>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-gpu-dvfs.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-gpu-dvfs.dtsi
new file mode 100644
index 00000000..1032fe4
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-gpu-dvfs.dtsi
@@ -0,0 +1,48 @@
+
+
+&gpu {
+	mali-supply = <&gpu_supp>;
+	operating-points-v2 = <&gpu_opps>;
+	assigned-clocks = <&cc CC_CLK_GPU>;
+	assigned-clock-rates = <400000000>;
+
+	gpu_opps: gpu-opp-table {
+		compatible = "operating-points-v2",
+			"operating-points-v2-mali";
+
+		opp-1x400 {
+			opp-hz = /bits/ 64 <133000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			opp-core-mask = /bits/ 64 <0x2>;
+		};
+		opp-2x400 {
+			opp-hz = /bits/ 64 <266000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			opp-core-mask = /bits/ 64 <0x1>;
+		};
+		opp-3x400 {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			opp-suspend;
+		};
+		opp-3x500 {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-hz-real = /bits/ 64 <500000000>;
+			opp-microvolt = <1000000>;
+		};
+		opp-3x600 {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-hz-real = /bits/ 64 <600000000>;
+			opp-microvolt = <1000000>;
+		};
+		opp-3x700 {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-hz-real = /bits/ 64 <700000000>;
+			opp-microvolt = <1000000>;
+		};
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-hdmirxEDID.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-hdmirxEDID.dtsi
new file mode 100644
index 00000000..b127445
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-hdmirxEDID.dtsi
@@ -0,0 +1,59 @@
+/*
+ * rtd-16xx-hdmirxEDID.dtsi - HDMI Rx EDID table for REALTEK 16xx SoC
+ */
+
+/{
+	hdmirx@98034000 {
+		Realtek,edid-table = <
+			0x00 0xFF 0xFF 0xFF 0xFF 0xFF 0xFF 0x00 0x4A 0x8B 0x95
+			0x12 0x00 0x00 0x00 0x00 0xFF 0x1A 0x01 0x03 0x81 0x46
+			0x27 0x78 0x8A 0xA5 0x8E 0xA6 0x54 0x4A 0x9C 0x26 0x12
+			0x45 0x46 0x21 0x08 0x00 0xD1 0xC0 0x81 0xC0 0x01 0x01
+			0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x02
+			0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C 0x45 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x01 0x1D 0x00 0x72 0x51
+			0xD0 0x1E 0x20 0x6E 0x28 0x55 0x00 0x20 0xC2 0x31 0x00
+			0x00 0x1E 0x00 0x00 0x00 0xFD 0x00 0x32 0x4B 0x18 0x3C
+			0x0B 0x00 0x0A 0x20 0x20 0x20 0x20 0x20 0x20 0x00 0x00
+			0x00 0xFC 0x00 0x52 0x54 0x44 0x31 0x32 0x39 0x35 0x0A
+			0x20 0x20 0x20 0x20 0x20 0x01 0xAC 0x02 0x03 0x29 0x71
+			0x83 0x01 0x00 0x00 0x6E 0x03 0x0C 0x00 0x10 0x00 0x00
+			0x3C 0x20 0x00 0x80 0x01 0x02 0x03 0x04 0x49 0x90 0x1F
+			0x22 0x20 0x05 0x14 0x04 0x11 0x02 0x23 0x09 0x7F 0x07
+			0xE3 0x05 0x03 0x00 0x02 0x3A 0x80 0x18 0x71 0x38 0x2D
+			0x40 0x58 0x2C 0x45 0x00 0x20 0xC2 0x31 0x00 0x00 0x1E
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x7F>;
+
+		Realtek,edid2p0-table = <
+			0x00 0xFF 0xFF 0xFF 0xFF 0xFF 0xFF 0x00 0x4A 0x8B 0x95
+			0x12 0x00 0x00 0x00 0x00 0xFF 0x1A 0x01 0x03 0x81 0x46
+			0x27 0x78 0x8A 0xA5 0x8E 0xA6 0x54 0x4A 0x9C 0x26 0x12
+			0x45 0x46 0x21 0x08 0x00 0xD1 0xC0 0x81 0xC0 0x01 0x01
+			0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x02
+			0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C 0x45 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x01 0x1D 0x00 0x72 0x51
+			0xD0 0x1E 0x20 0x6E 0x28 0x55 0x00 0x20 0xC2 0x31 0x00
+			0x00 0x1E 0x00 0x00 0x00 0xFD 0x00 0x32 0x4B 0x18 0x3C
+			0x0B 0x00 0x0A 0x20 0x20 0x20 0x20 0x20 0x20 0x00 0x00
+			0x00 0xFC 0x00 0x52 0x54 0x44 0x31 0x32 0x39 0x35 0x0A
+			0x20 0x20 0x20 0x20 0x20 0x01 0xAC 0x02 0x03 0x3A 0x71
+			0x83 0x01 0x00 0x00 0x6E 0x03 0x0C 0x00 0x10 0x00 0x00
+			0x3C 0x20 0x00 0x80 0x01 0x02 0x03 0x04 0x67 0xD8 0x5D
+			0xC4 0x01 0x77 0x80 0x00 0x4F 0x5D 0x5E 0x5F 0x60 0x61
+			0x62 0x90 0x1F 0x22 0x20 0x05 0x14 0x04 0x11 0x02 0x23
+			0x09 0x7F 0x07 0xE3 0x05 0x03 0x00 0xE2 0x0F 0x18 0x08
+			0xE8 0x00 0x30 0xF2 0x70 0x5A 0x80 0xB0 0x58 0x8A 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x8F>;
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-pcie.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-pcie.dtsi
new file mode 100644
index 00000000..7d25fbe
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-pcie.dtsi
@@ -0,0 +1,193 @@
+/ {
+	pcie: pcie@98060000 {
+		compatible = "realtek,rtk16xx-pcie-slot1";
+		reg = <0x0 0x98060000 0x0 0x00001000
+		       0x0 0x98061000 0x0 0x00001000
+		       0x0 0x9801C800 0x0 0x00000100
+		       0x0 0x9801A000 0x0 0x00000300>;
+		interrupt-names = "rtk-pcie1-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic 0 0 GIC_SPI 61 IRQ_TYPE_LEVEL_HIGH>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins_0>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <0>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 29 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys =<0x00000003>,
+		<0x40080001>,
+		<0x2E000701>,
+		<0x35910801>,
+		<0x521C0901>,
+		<0x7C421901>,
+		<0x00011C01>,
+		<0x32001D01>,
+		<0x20EB1E01>,
+		<0xF8001F01>,
+		<0x3D402A01>,
+		<0x81BD2F01>,
+		<0x52F50401>,
+		<0x27E90301>,
+		<0xead70501>,
+		<0x00080601>,
+		<0xB6730a01>,
+		<0x84552001>,
+		<0x55552101>,
+		<0xA85C0101>,
+		<0x60420201>,
+		<0xAB632301>,
+		<0x080C2401>,
+		<0xa8032b01>,
+		<0x80A11B01>,
+		<0x27e94301>,
+		<0x52f54401>,
+		<0xead74501>,
+		<0x00064601>,
+		<0x86734a01>,
+		<0x84666001>,
+		<0x55AA6101>,
+		<0xa84a4101>,
+		<0x60424201>,
+		<0xAB636301>,
+		<0x08106401>,
+		<0xa8036b01>,
+		<0xf8022801>,
+		<0xf8026801>,
+		<0x69050B01>,
+		<0x69054B01>,
+		<0xC0080C01>,
+		<0xC0084C01>,
+		<0xF7060D01>,
+		<0xF7064D01>,
+		<0x10000E01>,
+		<0x10004E01>,
+		<0x720C0901>,
+		<0x700C0901>,
+		<0x720C0901>,
+		<0x720C4901>,
+		<0x700C4901>,
+		<0x720C4901>;
+
+		//speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x98062000 0x0 0x98062000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00030000 0x0 0x00030000 0x00000000 0x00010000>;
+		resets = <&crst RSTN_PCIE0>,
+			<&crst RSTN_PCIE0_CORE>,
+			<&crst RSTN_PCIE0_POWER>,
+			<&crst RSTN_PCIE0_NONSTITCH>,
+			<&crst RSTN_PCIE0_STITCH>,
+			<&crst RSTN_PCIE0_PHY>,
+			<&crst RSTN_PCIE0_PHY_MDIO>,
+			<&crst RSTN_PCIE0_SGMII_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio",
+			"sgmii_mdio";
+		clocks = <&clk_en_1 CLK_EN_PCIE0>;
+		status = "okay";
+	};
+
+	pcie2: pcie2@980A0000 {
+		compatible = "realtek,rtk16xx-pcie-slot2";
+		reg = <0x0 0x980A0000 0x0 0x00001000
+		       0x0 0x980A1000 0x0 0x00001000
+		       0x0 0x9801C600 0x0 0x00000100
+		       0x0 0x9804F000 0x0 0x00000100>;
+		interrupt-names = "rtk-pcie2-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic 0 0 GIC_SPI 62 IRQ_TYPE_LEVEL_HIGH>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins_1>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <1>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 65 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys =<0x00000003>,
+		<0x40080001>,
+		<0x2E000701>,
+		<0x35910801>,
+		<0x521C0901>,
+		<0x7C421901>,
+		<0x00011C01>,
+		<0x32001D01>,
+		<0x20EB1E01>,
+		<0xF8001F01>,
+		<0x3D402A01>,
+		<0x81BD2F01>,
+		<0x52F50401>,
+		<0x27E90301>,
+		<0xead70501>,
+		<0x00080601>,
+		<0xB6730a01>,
+		<0x84552001>,
+		<0x55552101>,
+		<0xA85C0101>,
+		<0x60420201>,
+		<0xAB632301>,
+		<0x080C2401>,
+		<0xa8032b01>,
+		<0x80A11B01>,
+		<0x27e94301>,
+		<0x52f54401>,
+		<0xead74501>,
+		<0x00064601>,
+		<0x86734a01>,
+		<0x84666001>,
+		<0x55AA6101>,
+		<0xa84a4101>,
+		<0x60424201>,
+		<0xAB636301>,
+		<0x08106401>,
+		<0xa8036b01>,
+		<0xf8022801>,
+		<0xf8026801>,
+		<0x69050B01>,
+		<0x69054B01>,
+		<0xC0080C01>,
+		<0xC0084C01>,
+		<0xF7060D01>,
+		<0xF7064D01>,
+		<0x10000E01>,
+		<0x10004E01>,
+		<0x720C0901>,
+		<0x700C0901>,
+		<0x720C0901>,
+		<0x720C4901>,
+		<0x700C4901>,
+		<0x720C4901>;
+
+		//speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x980A2000 0x0 0x980A2000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00040000 0x0 0x00040000 0x00000000 0x00010000>;
+		resets = <&crst RSTN_PCIE1>,
+			<&crst RSTN_PCIE1_CORE>,
+			<&crst RSTN_PCIE1_POWER>,
+			<&crst RSTN_PCIE1_NONSTITCH>,
+			<&crst RSTN_PCIE1_STITCH>,
+			<&crst RSTN_PCIE1_PHY>,
+			<&crst RSTN_PCIE1_PHY_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_4 CLK_EN_PCIE1>;
+		status = "okay";
+	};
+};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-pinctrl.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-pinctrl.dtsi
new file mode 100644
index 00000000..95a7030
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-pinctrl.dtsi
@@ -0,0 +1,490 @@
+
+/ {
+	pinctrl@9804E000 {
+		sdcard_pins_low: sdcard_low {
+			realtek,pins= "sd3_data_3",
+			"sd3_data_2",
+			"sd3_data_1",
+			"sd3_data_0",
+			"sd3_clk",
+			"sd3_cmd";
+			realtek,function="sd";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <0>;
+		};
+
+		sdcard_pins_high: sdcard_high {
+			realtek,pins="gpio_35", "gpio_34";
+			realtek,function="mmc";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <1>;
+		};
+
+		sdio_pins_0: sdio_pins_0 {
+			realtek,pins= "sd3_data_3",
+			"sd3_data_2",
+			"sd3_data_1",
+			"sd3_data_0",
+			"sd3_clk",
+			"sd3_cmd",
+			"sdio_loc";
+			realtek,function = "sdio_loc0";
+		};
+
+		sdio_pins_1: sdio_pins_1 {
+			realtek,pins = "gpio_40",
+			"gpio_41",
+			"gpio_42",
+			"gpio_43",
+			"gpio_44",
+			"gpio_45",
+			"sdio_loc";
+			realtek,function = "sdio_loc1";
+		};
+
+
+		uart0_pins: uart0_pins {
+			realtek,pins = "ur0_rx",
+			"ur0_tx";
+			realtek,function = "uart0";
+		};
+
+		uart1_pins: uart1_pins {
+			realtek,pins = "gpio_8",
+			"gpio_9";
+			realtek,function = "uart1";
+		};
+
+		uart2_pins_0: uart2_pins_0 {
+			realtek,pins = "ur2_loc",
+			"gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5";
+			realtek,function = "uart2_loc0";
+		};
+
+		uart2_pins_1: uart2_pins_1 {
+			realtek,pins ="ur2_loc",
+			"gpio_25",
+			"gpio_26",
+			"gpio_27",
+			"gpiio_28";
+			realtek,function = "uart2_loc1";
+		};
+
+		i2c_pins_0: i2c_pins_0 {
+			realtek,pins = "gpio_12",
+			"gpio_13";
+			realtek,function = "i2c0";
+			realtek,drive = <4>;
+		};
+
+		i2c_pins_0_HS: i2c_pins_0_HS {
+			realtek,pins = "gpio_12",
+			"gpio_13";
+			realtek,function = "i2c0";
+			realtek,drive = <8>;
+		};
+
+		i2c_pins_1: i2c_pins_1 {
+			realtek,pins = "gpio_16",
+			"gpio_17";
+			realtek,function = "i2c1";
+		};
+
+		i2c_pins_2: i2c_pins_2 {
+			realtek,pins = "gpio_18",
+			"gpio_19";
+			realtek,function = "i2c2";
+		};
+
+		i2c_pins_3: i2c_pins_3 {
+			realtek,pins = "gpio_34",
+			"gpio_35";
+			realtek,function = "i2c3";
+		};
+
+		i2c_pins_4: i2c_pins_4 {
+			realtek,pins = "gpio_83",
+			"gpio_84";
+			realtek,function = "i2c4";
+		};
+
+		i2c_pins_5: i2c_pins_5 {
+			realtek,pins = "gpio_5",
+			"gpio_6";
+			realtek,function = "i2c5";
+		};
+
+		spi_pins_enable: spi-pins-enable {
+			realtek,pins = "sf_en";
+			realtek,function = "sf_enable";
+		};
+
+		spi_pins_loc_spi: spi_pins_loc_spi {
+			realtek,pins = "gpio_25",
+			"gpio_26",
+			"gpio_27",
+			"gpio_28";
+			realtek,function = "spi";
+		};
+
+		gspi_pins_0: gspi_pins_0 {
+			realtek,pins = "gspi_loc",
+			"gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5";
+			realtek,function = "gspi_loc0";
+		};
+
+		gspi_pins_1: gspi_pins_1 {
+			realtek,pins = "gspi_loc",
+			"gpio_25",
+			"gpio_26",
+			"gpio_27",
+			"gpio_28";
+			realtek,function = "gspi_loc1";
+		};
+
+		smartcard_pins_0:smartcard_pins_0{
+			realtek,pins = "gpio_59",
+			"gpio_60",
+			"gpio_61",
+			"gpio_62";
+			realtek,function = "sc0";
+		};
+
+		smartcard_pins_1:smartcard_pins_1{
+			realtek,pins = "sd3_cmd",
+			"sd3_clk",
+			"sd3_data_0",
+			"sd3_data_1";
+			realtek,function = "sc1";
+		};
+
+		tp0_loc_tp0_pins: tp0_loc_tp0_pins {
+			realtek,pins = "tp_sync",
+			"tp_valid",
+			"tp_clk",
+			"tp_data_0",
+			"tp_data_1",
+			"tp_data_2",
+			"tp_data_3",
+			"tp_data_4",
+			"tp_data_5",
+			"tp_data_6",
+			"tp_data_7";
+			realtek,function = "tp0";
+		};
+
+		tp1_loc_tp1_pins: tp1_loc_tp1_pins {
+			realtek,pins = "tp_data_1",
+			"tp_data_2",
+			"tp_data_3",
+			"tp_data_4";
+			realtek,function = "tp1";
+		};
+
+		ao_pins: ao_pins {
+			realtek,pins =
+				"tp_data_1",
+				"tp_data_2",
+				"tp_data_3",
+				"tp_data_4",
+				"tp_data_5",
+				"tp_data_6",
+				"tp_data_7";
+			realtek,function = "ao";
+		};
+
+		ir_rx_pins: ir_rx_pins {
+			realtek,pins = "ir_rx";
+			realtek,function = "ir_rx";
+		};
+
+		spdif_pins: spdif_pins {
+			realtek,pins = "gpio_50";
+			realtek,function = "spdif";
+		};
+
+		spdif_optical_pins: spdif_optical_pins {
+			realtek,pins = "gpio_21", "gpio_68", "gpio_85";
+			realtek,function = "spdif";
+			realtek,pull_en =  <0>;
+		};
+
+		ai_loc0_pins: ai_loc0_pins {
+			realtek,pins = "gpio_59",
+				"gpio_60",
+				"gpio_61",
+				"gpio_62",
+				"tp_sync",
+				"tp_valid",
+				"tp_clk";
+			realtek,function = "ai_loc0";
+		};
+
+		ai_loc1_pins: ai_loc1_pins {
+			realtek,pins = "gpio_40",
+				"gpio_41",
+				"gpio_42",
+				"gpio_43",
+				"gpio_44",
+				"gpio_45",
+				"gpio_57";
+			realtek,function = "ai_loc1";
+		};
+
+		dmic_loc0_pins: dmic_loc0_pins {
+			realtek,pins = "dmic_loc",
+				"gpio_59",
+				"gpio_60",
+				"gpio_61",
+				"gpio_62",
+				"tp_sync",
+				"tp_valid",
+				"tp_clk",
+				"tp_data_0";
+			realtek,function = "dmic_loc0";
+		};
+
+		dmic_loc1_pins: dmic_loc1_pins {
+			realtek,pins = "dmic_loc",
+				"gpio_40",
+				"gpio_41",
+				"gpio_42",
+				"gpio_43",
+				"gpio_44",
+				"gpio_45",
+				"gpio_57",
+				"gpio_58";
+			realtek,function = "dmic_loc1";
+		};
+
+		tdm_loc0_pins: tdm_loc0_pins {
+			realtek,pins =
+				"tp_sync",
+				"tp_valid",
+				"tp_clk",
+				"tp_data_0";
+			realtek,function = "tdm_ai_loc0";
+		};
+
+		tdm_dmic_loc0_pins:  tdm_dmic_loc0_pins {
+			realtek,pins = "dmic_loc";
+			realtek,function = "dmic_loc0";
+		};
+
+		tdm_loc1_pins: tdm_loc1_pins {
+			realtek,pins =
+				"gpio_40",
+				"gpio_41",
+				"gpio_42",
+				"gpio_43";
+			realtek,function = "tdm_ai_loc1";
+		};
+
+		tdm_dmic_loc1_pins:  tdm_dmic_loc1_pins {
+			realtek,pins = "dmic_loc";
+			realtek,function = "dmic_loc1";
+		};
+
+		/*i2s_out_4pins: i2s_out_4pins {
+			realtek,pins ="tp_data_1",
+			"tp_data_2",
+			"tp_data_3",
+			"tp_data_4";
+			realtek,function = "ao";
+		};*/
+
+		/*i2s_in_pins: i2s_in_pins {
+			realtek,pins = "gpio_6";
+			realtek,function = "ai";
+		};*/
+
+		etn_led_pins: etn_led_pins {
+			realtek,pins = "gpio_14",
+			"gpio_15",
+			"gpio_51";
+			realtek,function = "etn_led";
+		};
+
+		sgmii_mdio_pins: sgmii_mdio_pins {
+			realtek,pins = "gpio_29",
+			"gpio_46";
+			realtek,function = "extphy";
+		};
+
+		pcie_clk_pins_0: pcie_clk_pins_0 {
+			realtek,pins = "gpio_46";
+			realtek,function = "pcie0";
+		};
+
+		pcie_clk_pins_1: pcie_clk_pins_1 {
+			realtek,pins = "gpio_66";
+			realtek,function = "pcie1";
+		};
+
+		scpu_ejtag_pins_loc_0: scpu_ejtag_pins_loc_0 {
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5",
+			"gpio_6",
+			"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc0";
+		};
+
+		scpu_ejtag_pins_loc_1: scpu_ejtag_pins_loc_1 {
+			realtek,pins = "sd3_cmd",
+			"sd3_data_0",
+			"sd3_data_1",
+			"sd3_data_3",
+			"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc1";
+		};
+
+		scpu_ejtag_pins_disable: scpu_ejtag_pins_disable {
+			realtek,pins = "ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_disable";
+		};
+
+		lx_ejtag_pins_loc_0: lx_ejtag_pins_loc_0 {
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5",
+			"gpio_6",
+			"ejtag_avcpu_loc";
+			realtek,function = "lx_ejtag_loc0";
+		};
+
+		acpu_ejtag_pins_loc_1: acpu_ejtag_pins_loc_1 {
+			realtek,pins = "sd3_cmd",
+			"sd3_clk",
+			"sd3_data_0",
+			"sd3_data_1",
+			"sd3_data_3",
+			"ejtag_avcpu_loc";
+			realtek,function = "lx_ejtag_loc1";
+		};
+
+		dc_fan_sensor_pins: dc_fan_sensor_pins {
+			realtek,pins = "gpio_47";
+			realtek,function = "dc_fan_sensor";
+		};
+
+		pwm0_0_pins: pwm0_0_pins {
+			realtek,pins = "gpio_12";
+			realtek,function = "pwm0";
+		};
+
+		pwm0_1_pins: pwm0_1_pins {
+			realtek,pins = "gpio_20";
+			realtek,function = "pwm0";
+		};
+
+		pwm1_0_pins: pwm1_0_pins {
+			realtek,pins = "gpio_13";
+			realtek,function = "pwm1";
+		};
+
+		pwm1_1_pins: pwm1_1_pins {
+			realtek,pins = "gpio_21";
+			realtek,function = "pwm1";
+		};
+
+		pwm2_0_pins: pwm2_0_pins {
+			realtek,pins = "gpio_14";
+			realtek,function = "pwm2";
+		};
+
+		pwm2_1_pins: pwm2_1_pins {
+			realtek,pins = "gpio_22";
+			realtek,function = "pwm2";
+		};
+
+		pwm3_0_pins: pwm3_0_pins {
+			realtek,pins = "gpio_15";
+			realtek,function = "pwm3";
+		};
+
+		pwm3_1_pins: pwm3_1_pins {
+			realtek,pins = "gpio_23";
+			realtek,function = "pwm3";
+		};
+
+		pwm0_0_pins_disable: pwm0_0_pins_disable {
+			realtek,pins = "gpio_12";
+			realtek,function = "gpio";
+		};
+
+		pwm0_1_pins_disable: pwm0_1_pins_disable {
+			realtek,pins = "gpio_20";
+			realtek,function = "gpio";
+		};
+
+		pwm1_0_pins_disable: pwm1_0_pins_disable {
+			realtek,pins = "gpio_13";
+			realtek,function = "gpio";
+		};
+
+		pwm1_1_pins_disable: pwm1_1_pins_disable {
+			realtek,pins = "gpio_21";
+			realtek,function = "gpio";
+		};
+
+		pwm2_0_pins_disable: pwm2_0_pins_disable {
+			realtek,pins = "gpio_14";
+			realtek,function = "gpio";
+		};
+
+		pwm2_1_pins_disable: pwm2_1_pins_disable {
+			realtek,pins = "gpio_22";
+			realtek,function = "gpio";
+		};
+
+		pwm3_0_pins_disable: pwm3_0_pins_disable {
+			realtek,pins = "gpio_15";
+			realtek,function = "gpio";
+		};
+
+		pwm3_1_pins_disable: pwm3_1_pins_disable {
+			realtek,pins = "gpio_23";
+			realtek,function = "gpio";
+		};
+
+		usb_cc1_pins: usb_cc1_pins {
+			realtek,pins = "usb_cc1";
+			realtek,function = "usb_cc1";
+		};
+
+		usb_cc2_pins: usb_cc2_pins {
+			realtek,pins = "usb_cc2";
+			realtek,function = "usb_cc2";
+		};
+
+		demod_pins: demod-pins {
+			realtek,pins = "demod_agc";
+			realtek,function = "qam_agc_if";
+		};
+
+		/*rtc_pins: rtc_pins {
+			realtek,pins = "gpio_25";
+			realtek,function = "rtc";
+		};*/
+
+		/*prob0_pins: prob0_pins{
+			realtek,pins = "prob_0";
+	        realtek,function = "gpio";
+		};
+
+		prob1_pins: prob1_pins{
+	        realtek,pins = "prob_1";
+	        realtek,function = "gpio";
+		};*/
+	};
+};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-sata.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-sata.dtsi
new file mode 100644
index 00000000..b6dff98
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-sata.dtsi
@@ -0,0 +1,19 @@
+/* PLEASE include this file inside a node */
+	sata_phy: sata_phy@9803FF60 {
+		compatible = "Realtek,rtk-sata-phy";
+		reg = <0x0 0x9803FF00 0x0 0x100>,
+			<0x0 0x9804f050 0x0 0x10>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		#phy-cells = <1>;
+		status = "okay";
+	};
+
+	ahci_sata: sata@9803F000 {
+		compatible = "Realtek,ahci-sata";
+		reg = <0x0 0x9803F000 0x0 0x1000>;
+		interrupts = <0 49 4>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+	};
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-usb.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-usb.dtsi
new file mode 100644
index 00000000..c725d96
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx-usb.dtsi
@@ -0,0 +1,358 @@
+/*
+ * realtek,port0-power-gpio: drd type_C power, output, default low
+ * realtek,port1-power-gpio: u2host power, output, default low
+ * realtek,port2-power-gpio: u3host power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		reg = <0x0 0x98000000 0x0 0x10>;
+
+		//usb_iso_mode;  /* ISO mode is only port suspend (Default disable) */
+		//en_usb_storage_reprobe; /* To enable usb storage re-probe*/
+		//rescue_usb; /* For rescue dtb use */
+
+		clocks = <&iso_clk_en 16>, /* clk_en_usb */
+			<&iso_clk_en 13>,  /* clk_en_usb_drd (port0 phy to drd clock) */
+			<&iso_clk_en 14>,  /* clk_en_usb_host0 (port1 phy to u2host clock) */
+			<&iso_clk_en 15>;  /* clk_en_usb_host1 (port2 phy to u3host clock) */
+		clock-names = "clk_en_usb", /*clk_en_usb*/
+			"clk_en_phy0_to_host", /*clk_en_usb_drd (port0 phy to drd clock) */
+			"clk_en_phy1_to_host", /*clk_en_usb_u2host (port1 phy to u2host clock */
+			"clk_en_phy2_to_host"; /*clk_en_usb_u3host (port2 phy to u3host clock */
+
+		resets =
+			<&iso_asrst 0x100>,
+			<&iso_rst 14>, /* rstn_usb_drd */
+			<&iso_rst 15>, /* rstn_usb_host */
+			<&iso_asrst 16>, /* rstn_usb_phy0 */
+			<&iso_asrst 17>, /* rstn_usb_phy1 */
+			<&iso_asrst 18>, /* rstn_usb_phy2 */
+			<&iso_rst 19>, /* rstn_usb */
+			<&iso_rst 20>, /* rstn_usb */
+			<&iso_rst 21>, /* rstn_usb_u3host */
+			<&iso_rst 22>, /* rstn_usb3_phy0 */
+			<&iso_rst 23>, /* rstn_usb3_phy0_mdio */
+			<&iso_rst 24>, /* rstn_usb3_phy1 */
+			<&iso_rst 25>; /* rstn_usb3_phy1_mdio */
+
+		reset-names = "apply",
+			"usb_host0", /*rstn_usb_drd*/
+			"usb_host1", /*rstn_usb_u2host*/
+			"u2phy0", /*rstn_usb_phy0*/
+			"u2phy1", /*rstn_usb_phy1*/
+			"u2phy2", /*rstn_usb_phy2*/
+			"usb", /*rstn_usb*/
+			"type_c", /*rstn_type_c*/
+			"usb_host2", /*rstn_usb_u3host*/
+			"u3phy0", /*rstn_usb3_phy0*/
+			"u3mdio0", /*rstn_usb3_phy0_mdio*/
+			"u3phy1", /*rstn_usb3_phy1*/
+			"u3mdio1"; /*rstn_usb3_phy1_mdio*/
+
+		gpio0: gpio0 {
+			realtek,power-gpio = <&rtk_iso_gpio 57 1 3>;
+			//power_low_active; /* type c use high active */
+
+		};
+		gpio1: gpio1 {
+			realtek,power-gpio = <&rtk_iso_gpio 48 1 3>;
+			power_low_active;
+
+		};
+		gpio2: gpio2 {
+			realtek,power-gpio = <&rtk_iso_gpio 49 1 3>;
+			power_low_active;
+		};
+
+		port0 {
+			usb = <&dwc3_drd>;
+			type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+			gpio = <&gpio0>;
+		};
+		port1 {
+			usb = <&dwc3_u2host>;
+			gpio = <&gpio1>;
+		};
+		port2 {
+			usb = <&dwc3_u3host>;
+			gpio = <&gpio2>;
+		};
+
+		rtk_usb {
+			power_ctrl_reg {
+				/* l4_icg */
+				p0_l4_icg = <0x98013364>;
+				p1_l4_icg = <0x98013d60>;
+				p2_l4_icg = <0x98013f60>;
+
+				usb_power_cut; /* Non ISO mode and power cut (Default disable power cut) */
+				               /* Note if enable ISO mode, then power_cut will not effective*/
+			};
+			type_c {
+				drd_wrap_base = <0x98013200>;
+				u3host_wrap_base = <0x98013e00>;
+				drd_u3_portsc = <0x98020430>;
+				drd_u3_sus_en = <0x980282c0>;
+				u3host_u3_sus_en = <0x980582c0>;
+			};
+		};
+	};
+
+	dwc3_drd_usb3phy: dwc3_drd_usb3phy@0 {
+		compatible = "Realtek,usb3phy";
+		reg = <0x0 0x98013210 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		phyN = <1>;
+		phy0 {
+			phy_data_size = <0x30>;
+			phy_data_addr = /bits/ 8
+				<0x00 0x01 0x02 0x03 0x04 0x05 0x06
+				0x07 0x08 0x09 0x0A 0x0B 0x0C 0x0D
+				0x0E 0x0F 0x10 0x11 0x12 0x13 0x14
+				0x15 0x16 0x17 0x18 0x19 0x1A 0x1B
+				0x1C 0x1D 0x1E 0x1F 0x20 0x21 0x22
+				0x23 0x24 0x25 0x26 0x27 0x28 0x29
+				0x2A 0x2B 0x2C 0x2D 0x2E 0x2F>;
+			phy_data_revA = /bits/ 16
+				<0x400C 0xAC43 0x6042 0x2771 0x72F5 0x2AD3 0x0006
+				 0x2E00 0x3591 0x565C 0x8608 0xAB05 0xC000 0xF70A
+				 0x2000 0x8D50 0x000C 0x4C10 0xFC00 0x0C81 0xDE01
+				 0x0000 0x0000 0x0000 0x0000 0x6020 0x0085 0x2014
+				 0xC900 0xA03F 0xC2E0 0xA000 0x403A 0x88AA 0x0053
+				 0xBB66 0x00E0 0x1260 0x840B 0x01D6 0xF842 0xff00
+				 0x3040 0x8028 0xFFFF 0xFFFF 0x0000 0x8635>;
+			do_toggle;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_drd_usb2phy: dwc3_drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98028280 0x0 0x4>, <0x0 0x98013214 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013200 0x0 0x200>;
+		interrupts = <0 21 4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98020000 0x0 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_drd_usb2phy &dwc3_drd_usb3phy>;
+			dr_mode = "peripheral"; /*otg, host, peripheral*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_u3_susphy_quirk; // DRD port is recommended disable suspend by specification
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+		};
+
+		dwc3_type_c: rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			reg = <0x0 0x98013200 0x0 0x200>,  <0x0 0x98007220 0x0 0x20>;
+			interrupts = <0 60 4>;
+			drd_mode;  /*depend on dwc3 dr_mode = "peripheral"*/
+			//debug; /*to enable debug log*/
+			delay_probe_work; /*To delay probe work*/
+			ordered_probe; /*ordered probe in delay work*/
+			boot_check_time = <(-1)>; /*ms (At boot Device switch Host time)*/
+
+			default_revision = <0xA00>;
+			A00 {
+				cc_dfp_mode = "dfp_3_0"; /*dfp_3_0, dfp_1_5, dfp_usb*/
+				rd_config = "internal"; /*internal, extrenal*/
+				cc1_rp_4p7k_code = <0xC>;
+				cc1_rp_36k_code = <0xF>;
+				cc1_rp_12k_code = <0xE>;
+				cc1_rd_code = <0x11>; /*for internal rd*/
+				cc1_vref_ufp = /bits/ 8
+					<0x7 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc1_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc1_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc1_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+				cc2_rp_4p7k_code = <0xC>;
+				cc2_rp_36k_code = <0xF>;
+				cc2_rp_12k_code = <0xE>;
+				cc2_rd_code = <0xF>; /*for internal rd*/
+				cc2_vref_ufp = /bits/ 8
+					<0x8 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc2_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc2_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc2_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+			};
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98031280 0x0 0x4>, <0x0 0x98013C14 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x67 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013C00 0x0 0x200>;
+		interrupts = <0 21 4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "okay";
+
+		dwc3_u2host@98029000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98029000 0x0 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_u2host_usb2phy>;
+			dr_mode = "host"; /*only host*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+		};
+	};
+
+	dwc3_u3host_usb3phy: dwc3_u3host_usb3phy@0 {
+		compatible = "Realtek,usb3phy";
+		reg = <0x0 0x98013E10 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "okay";
+		phyN = <1>;
+		phy0 {
+			phy_data_size = <0x30>;
+			phy_data_addr = /bits/ 8
+				<0x00 0x01 0x02 0x03 0x04 0x05 0x06
+				0x07 0x08 0x09 0x0A 0x0B 0x0C 0x0D
+				0x0E 0x0F 0x10 0x11 0x12 0x13 0x14
+				0x15 0x16 0x17 0x18 0x19 0x1A 0x1B
+				0x1C 0x1D 0x1E 0x1F 0x20 0x21 0x22
+				0x23 0x24 0x25 0x26 0x27 0x28 0x29
+				0x2A 0x2B 0x2C 0x2D 0x2E 0x2F>;
+			phy_data_revA = /bits/ 16
+				<0x400C 0xAC43 0x6042 0x2771 0x72F5 0x2AD3 0x0006
+				 0x2E00 0x3591 0x565C 0x8608 0xAB05 0xC000 0xF70A
+				 0x2000 0x8D50 0x000C 0x4C10 0xFC00 0x0C81 0xDE01
+				 0x0000 0x0000 0x0000 0x0000 0x6020 0x0085 0x2014
+				 0xC900 0xA03F 0xC2E0 0xA000 0x403A 0x88AA 0x0053
+				 0xBB66 0x00E0 0x1260 0x840B 0x01D6 0xF842 0xff00
+				 0x3040 0x8028 0xFFFF 0xFFFF 0x0000 0x8635>;
+			do_toggle;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u3host_usb2phy: dwc3_u3host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98058280 0x0 0x4>, <0x0 0x98013E14 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "okay";
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x6B 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013E00 0x0 0x200>;
+		interrupts = <0 21 4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		dis_u3_port; // Disable usb 3.0 port
+		status = "okay";
+
+		dwc3_u3host@981F0000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98050000 0x0 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_u3host_usb2phy &dwc3_u3host_usb3phy>;
+			dr_mode = "host"; /*only host*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_u3_susphy_quirk;
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+		};
+	};
+
diff --git a/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx.dtsi b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx.dtsi
new file mode 100644
index 00000000..3ff1bbb
--- /dev/null
+++ b/arch/arm/boot/dts/realtek/rtd16xx/rtd-16xx.dtsi
@@ -0,0 +1,1254 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include <dt-bindings/clock/rtk,clock-rtd16xx.h>
+#include <dt-bindings/reset/rtk,reset-rtd16xx.h>
+#include <dt-bindings/power/rtk,power-rtd16xx.h>
+/include/ "rtd-16xx-pinctrl.dtsi"
+/include/ "rtd-16xx-hdmirxEDID.dtsi"
+
+/{
+	compatible = "realtek,rtd1619";
+	interrupt-parent = <&gic>;
+	#address-cells = <0x2>;
+	#size-cells = <0x2>;
+
+	aliases {
+		serial0 = &uart0;
+		i2c0 = &i2c_0;
+		i2c1 = &i2c_1;
+		i2c3 = &i2c_3;
+		i2c4 = &i2c_4;
+		i2c5 = &i2c_5;
+	};
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A55_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x000>;
+			enable-method = "rtk-spin-table";
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x100>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x200>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x300>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_4: cpu@4 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x400>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_5: cpu@5 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x500>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		a55_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	rtk_pm@0 {
+		compatible = "realtek,pm";
+		system-power-controller;
+		reg = <0x0 0x98000000 0x0 0x1800>, /* CRT */
+			<0x0 0x98007000 0x0 0x1000>, /* ISO */
+			<0x0 0x9801A000 0x0 0x1000>; /* SB2 */
+		wakeup-flags = <0x3F>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+		status = "okay";
+	};
+
+	soc@0 {
+		reg = <0x0 0x98000000 0x0 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+	};
+
+	sb2_lock0: sb2-lock@9801A000 {
+		compatible = "realtek,sb2-sem";
+		reg = <0x0 0x9801A000 0x0 0x4>;
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x0 0x9801a000 0x0 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	crt_mmio: mmio@98000000 {
+		compatible = "realtek,mmio";
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	iso_mmio: mmio@98007088 {
+		compatible = "realtek,mmio";
+		reg = <0x0 0x98007088 0x0 0x8>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	efuse@98017000 {
+		compatible = "realtek,efuse";
+		reg = <0x0 0x98017000 0x0 0x1000>;
+		read-only;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		nvmem-cells =
+			<&otp_bond_id>,
+			<&otp_cpu_iddq>,
+			<&otp_top_iddq>,
+			<&otp_etn_rc>,
+			<&otp_etn_amp>,
+			<&otp_etn_adc>,
+			<&otp_etn_r>,
+			<&otp_usb_cc1_comp_cal>,
+			<&otp_usb_cc2_comp_cal>,
+			<&otp_usb_cc1_4_7k_cal>,
+			<&otp_usb_cc1_12k_cal>,
+			<&otp_usb_cc2_4_7k_cal>,
+			<&otp_usb_cc2_12k_cal>,
+			<&otp_usb_dc_cal>,
+			<&otp_usb_cc_en>,
+			<&otp_package_id>,
+			<&otp_chip_id>;
+
+		nvmem-cell-names =
+			"bond_id",
+			"cpu_iddq",
+			"top_iddq",
+			"etn_rc",
+			"etn_amp",
+			"etn_adc",
+			"etn_r",
+			"usb_cc1_comp_cal",
+			"usb_cc2_comp_cal",
+			"usb_cc1_4.7k_cal",
+			"usb_cc1_12k_cal",
+			"usb_cc2_4.7k_cal",
+			"usb_cc2_12k_cal",
+			"usb_dc_cal",
+			"usb_cc_en",
+			"package_id",
+			"chip_id";
+
+		otp_bond_id: bond-id@4f4 {
+			reg = <0x4f4 0x4>;
+			bits = <0 32>;
+		};
+
+		otp_cpu_iddq: cpu-iddq@4f8 {
+			reg = <0x4f8 0x1>;
+			bits = <0 8>;
+		};
+		otp_top_iddq: top-iddq@4f9 {
+			reg = <0x4f9 0x1>;
+			bits = <0 8>;
+		};
+
+		otp_etn_rc: etn-rc@4fb {
+			reg = <0x4fb 0x1>;
+			bits = <0 4>;
+		};
+		otp_etn_amp: etn-amp@4fc {
+			reg = <0x4fc 0x2>;
+			bits = <0 16>;
+		};
+		otp_etn_adc: etn-adc@4fe {
+			reg = <0x4fe 0x2>;
+			bits = <0 16>;
+		};
+		otp_etn_r: etn-r@501 {
+			reg = <0x501 0x2>;
+			bits = <7 4>;
+		};
+		otp_usb_cc1_comp_cal: usb_cc1_comp_cal@502 {
+			reg = <0x502 0x4>;
+			bits = <3 24>;
+		};
+		otp_usb_cc2_comp_cal: usb_cc2_comp_cal@505 {
+			reg = <0x505 0x4>;
+			bits = <3 24>;
+		};
+		otp_usb_cc1_4_7k_cal: usb_cc1_4_7k_cal@508 {
+			reg = <0x508 0x1>;
+			bits = <3 4>;
+		};
+		otp_usb_cc1_12k_cal: usb_cc1_12k_cal@508 {
+			reg = <0x508 0x2>;
+			bits = <7 4>;
+		};
+		otp_usb_cc2_4_7k_cal: usb_cc2_4_7k_cal@509 {
+			reg = <0x509 0x1>;
+			bits = <3 4>;
+		};
+		otp_usb_cc2_12k_cal: usb_cc2_12k_cal@509 {
+			reg = <0x509 0x2>;
+			bits = <7 4>;
+		};
+		otp_usb_dc_cal: usb_dc_cal@50a {
+			reg = <0x50a 0x2>;
+			bits = <3 12>;
+		};
+		otp_usb_cc_en: usb_cc_en@50b {
+			reg = <0x50b 0x1>;
+			bits = <7 1>;
+		};
+		otp_package_id: package_id@48d {
+			reg = <0x48d 0x1>;
+			bits = <5 2>;
+		};
+		otp_chip_id: chip_id@3cc {
+			reg = <0x3cc 0x10>;
+			bits = <0 128>;
+		};
+	};
+
+	osc27M: osc27M {
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <27000000>;
+		clock-output-names = "osc27M";
+	};
+
+	cc: clocks@98000000 {
+		compatible = "realtek,clock-controller";
+		#clock-cells = <1>;
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		clocks = <&osc27M>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	clk_en_1: clk-en@98000050 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000050 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "unused", "pcie0", "unused", "gspi",
+				     "unused", "unused", "sds", "hdmi",
+				     "unused", "unused", "unused", "unused",
+				     "unused", "unused", "lsadc", "se";
+		ignore-unused-clocks = "hdmi";
+		ignore-pm-clocks = "hdmi";
+	};
+
+	clk_en_2: clk-en@98000054 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000054 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "unused", "cp", "md", "tp",
+				     "rsa", "nf", "emmc", "sd",
+				     "sdio_ip", "mipi", "emmc_ip", "sdio",
+				     "sd_ip", "cablerx", "tpb", "sc1";
+		ignore-unused-clocks = "cp", "md", "tp";
+	};
+
+	clk_en_3: clk-en@98000058 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000058 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "i2c_3", "unused", "jpeg", "unused",
+				     "unused", "sc0", "unused", "unused",
+				     "unused", "unused", "unused", "unused",
+				     "unused", "hdmirx", "hse", "ur2";
+	};
+
+	clk_en_4: clk-en@9800005c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800005c 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "ur1", "fan", "unused", "unused",
+				     "sata_wrap_sys", "sata_wrap_sysh",
+				     "sata_mac_sysh", "r2rdsc",
+				     "unused", "pcie1", "i2c_4", "i2c_5",
+				     "unused", "unused", "edp", "unused";
+	};
+
+	iso_clk_en: clk-en@9800708c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800708c 0x0 0x4>;
+		#clock-cells = <1>;
+		clock-output-names = "unused", "unused", "cec0", "cbusrx_sys",
+				     "cbustx_sys", "cbus_sys", "cbus_osc", "ir",
+				     "ur0", "i2c0", "i2c1", "etn_250m",
+				     "etn_sys", "usb_drd", "usb_host",
+				     "usb_u3_host", "usb";
+	};
+
+	crst: soft-reset@98000000 {
+		compatible = "realtek,rtd16xx-reset-controller";
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		#reset-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	iso_rst: soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98007088 0x0 0x4>;
+		#reset-cells = <1>;
+		realtek,mmio = <&iso_mmio 0x0>;
+	};
+
+	iso_asrst: usb-async-soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98007088 0x0 0x4>;
+		#reset-cells = <1>;
+		async-group = <0>;
+		realtek,mmio = <&iso_mmio 0x0>;
+	};
+
+	pd: power-domain@98007000 {
+		compatible = "realtek,rtd16xx-power-controller";
+		reg = <0x0 0x98007000 0x0 0x1000>;
+		#power-domain-cells = <1>;
+		#powerctrl-cells = <1>;
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x0 0x98000000 0x0 0x200000>;
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x0 0x9801b000 0x0 0x1000>;
+		status = "okay";
+	};
+
+	gic: interrupt-controller@FF100000 {
+		compatible = "arm,gic-v3";
+		#interrupt-cells = <3>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		interrupt-controller;
+		redistributor-stride = <0x0 0x20000>;
+		#redistributor-regions = <1>;
+		reg = <0x0 0xFF100000 0x0 0x10000>, /*  GICD */
+			<0x0 0xFF140000 0x0 0x200000>; /*  GICR */
+		interrupts = <GIC_PPI 9 4>;
+	};
+
+	timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <GIC_PPI 13 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 14 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 11 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 10 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>;
+		clock-frequency = <27000000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <GIC_PPI 7 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>;
+	};
+
+	pinctrl: pinctrl@9804E000 {
+		compatible = "realtek,rtk16xx-pinctrl";
+		reg = <0x0 0x9804E000 0x0 0x100>,
+			<0x0 0x9804F000 0x0 0x100>;
+		#gpio-range-cells = <3>;
+		status = "okay";
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP MISC_ISO */
+			  <0x0 0x98007000 0x0 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	/*
+	 * Suspend GPIO control
+	 *
+	 * [wakeup-gpio-list]
+	 * rtk_iso_gpio 10: BT wakeup host pin
+	 * rtk_iso_gpio 26: WiFi wakeup host pin
+	 *
+	 * [wakeup-gpio-enable]
+	 * Wakeup from BT: <0> disable
+	 * Wakeup from WiFi: <0> disable
+	 *
+	 * [wakeup-gpio-activity]
+	 * BT pin: <0> active low
+	 * WIFI pin: <0> active low
+	 */
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk16xx-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <86>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <51 4>, <52 4>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x0 0x98007000 0x0 0x100>,
+			<0x0 0x98007100 0x0 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 86>;
+		wakeup-gpio-list = <&rtk_iso_gpio 10 0 1>,<&rtk_iso_gpio 26 0 1>;
+		wakeup-gpio-enable = <1>, <1>;
+		wakeup-gpio-activity = <0>, <0>;
+		status = "okay";
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x98007800 0x0 0x400>,
+			  <0x0 0x98007000 0x0 0x100>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		interrupts = <0 68 4>;
+		clock-frequency = <27000000>; /* This value must be override by the board. */
+		clocks = <&iso_clk_en CLK_EN_MISC_UR0>;
+		resets = <&iso_rst RSTN_UR0>;
+		status = "okay";
+	};
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x9801B200 0x0 0x100>,
+			<0x0 0x9801B00c 0x0 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 89 4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart1_pins>;
+		clocks = <&clk_en_4 CLK_EN_UR1>;
+		resets = <&crst RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "okay";
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x9801B400 0x0 0x100>,
+			<0x0 0x9801B00c 0x0 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts =  <0 90 4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_3 CLK_EN_UR2>;
+		resets = <&crst RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "disabled"; /* Disable UR2 first since we don't use it now */
+	};
+
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x0 0x98016000 0x0 0x1000>,   /* ETN */
+			<0x0 0x98007000 0x0 0x1000>, /* ISO */
+			<0x0 0x9801c000 0x0 0x2000>, /* SBX and SC_WRAP for ACP ctrl */
+			<0x0 0x980174f8 0x0 0x20>,    /* EFUSE_OTP_REG */
+			<0x0 0x981c8000 0x0 0x2000>, /* SDS */
+			<0x0 0x9804e000 0x0 0x1000>; /* ISO pinmux */
+		interrupts = <0 22 4>;
+		pinctrl-names = "default",
+				"sgmii";
+		pinctrl-0 = <&etn_led_pins>;
+		pinctrl-1 = <&sgmii_mdio_pins>;
+		local-mac-address = [00 10 20 30 40 50];
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		wake-mask0 = [3f 30 80 c0 3f 10 80 ff ff 1f 00 00 00 00 00 00];
+		wake-crc0 = <0x8d25>;
+		wake-mask1 = [3f 30 80 c0 3f 10 00 00 c0 ff ff 0f 00 00 00 00];
+		wake-crc1 = <0x8d25>;
+		wake-mask2 = [3f 30 80 c0 3f 10 00 00 00 00 00 00 80 ff ff 1f];
+		wake-crc2 = <0x8d25>;
+		wake-mask3 = [3f 30 10 00 c0 ff ff 03 01 f8 ff ff 01 00 00 00];
+		wake-crc3 = <0x11da>;
+		wake-mask4 = [3f 30 10 00 c0 ff ff 03 01 00 00 fc ff ff 00 00];
+		wake-crc4 = <0x11da>;
+		wake-mask5 = [3f 30 10 00 c0 ff ff 03 01 00 00 00 00 00 00 f8];
+		wake-crc5 = <0x15f8>;
+		output-mode = <0>; /* 0:embedded PHY, 1:SGMII to MAC, 2:SGMII to PHY */
+		ext-phy-id = <3>; /* 0 ~ 31, only valid when output-mode = 2 */
+		sgmii-swing = <0>; /* 0:640mV, 1:380mV, 2:250mV, 3:190mV */
+		bypass = <1>; /* 0: disable, 1: enable */
+		acp = <0>; /* 0: disable, 1: enable */
+		eee = <1>; /* 0: disable, 1: enable */
+		clocks = <&iso_clk_en CLK_EN_ETN_250M>,
+			<&iso_clk_en CLK_EN_ETN_SYS>,
+			<&clk_en_1 CLK_EN_SDS>;
+		clock-names = "etn_250m",
+			"etn_sys",
+			"sds";
+		resets = <&iso_rst RSTN_GMAC>,
+			<&iso_rst RSTN_GPHY>,
+			<&crst RSTN_SDS_REG>,
+			<&crst RSTN_SDS>,
+			<&crst RSTN_PCIE0_POWER>,
+			<&crst RSTN_PCIE0_PHY>,
+			<&crst RSTN_PCIE0_SGMII_MDIO>,
+			<&crst RSTN_PCIE0_PHY_MDIO>;
+		reset-names = "gmac",
+			"gphy",
+			"sds_reg",
+			"sds",
+			"pcie0_power",
+			"pcie0_phy",
+			"pcie0_sgmii_mdio",
+			"pcie0_phy_mdio";
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x0 0x9801d000 0x0 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	watchdog@0x98007680 {
+                compatible = "realtek,rtk-watchdog";
+                reg = <0x0 0x9801b5b0 0x0 0x20>, /*misc watchdog for SCPU NMI */
+                        <0x0 0x9801b000 0x0 0x10>,
+                        <0x0 0x98007680 0x0 0x100>; /*iso watchdog for oe workaround */
+                interrupts = <0 0 4>;
+                rst-oe = <0>; /* 0:input, 1:output */
+                rst-oe-for-init = <1>; /* 0:input, 1:output */
+                timeout-sec = <10>;
+                status = "okay";
+        };
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x0 0x98007640 0x0 0x10>;
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x98007D00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <40 4>;
+		i2c-num = <0>;
+		status = "okay";
+		pinctrl-names = "default", "high_speed";
+		pinctrl-0 = <&i2c_pins_0>;
+		pinctrl-1 = <&i2c_pins_0_HS>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iso_clk_en CLK_EN_I2C0>;
+		resets = <&iso_rst RSTN_I2C_0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x98007C00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <43 4>;
+		i2c-num = <1>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_1>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iso_clk_en CLK_EN_I2C1>;
+		resets = <&iso_rst RSTN_I2C_1>;
+	};
+
+	i2c_3: i2c@0x9801B900 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x9801B900 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <23 4>;
+		i2c-num = <3>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_3>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_3 CLK_EN_MISC_I2C_3>;
+		resets = <&crst RSTN_I2C_3>;
+	};
+
+	i2c_4: i2c@0x9801BA00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x9801BA00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <15 4>;
+		i2c-num = <4>;
+		status = "okay";
+		pinctrl-names = "default";
+		/*pinctrl-0 = <&i2c_pins_4>;*/
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_4 CLK_EN_MISC_I2C_4>;
+		resets = <&crst RSTN_I2C_4>;
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x9801BB00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <14 4>;
+		i2c-num = <5>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_5>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_4 CLK_EN_MISC_I2C_5>;
+		resets = <&crst RSTN_I2C_5>;
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk-dw-apb-ssi";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <27 4>; /* SPI_INT */
+		reg = <0x0 0x9801BD00 0x0 0x100>, /* DW SPI */
+			<0x0 0x9801B300 0x0 0x18>; /* SPI wrapper */
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins_0>;
+		/*spi-cs-gpio = <&rtk_iso_gpio 6 1 1>;*/
+		num-chipselect = <1>;
+		bus-num = <0>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		clock-frequency = <256000000>;
+		resets = <&crst RSTN_GSPI>;
+		status = "disabled";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x0 0x980070D0 0x0 0xC>;
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm0_0_pins>;
+			pinctrl-1 = <&pwm0_0_pins_disable>;
+			pinctrl-2 = <&pwm0_1_pins>;
+			pinctrl-3 = <&pwm0_1_pins_disable>;
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm1_0_pins>;
+			pinctrl-1 = <&pwm1_0_pins_disable>;
+			pinctrl-2 = <&pwm1_1_pins>;
+			pinctrl-3 = <&pwm1_1_pins_disable>;
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm2_0_pins>;
+			pinctrl-1 = <&pwm2_0_pins_disable>;
+			pinctrl-2 = <&pwm2_1_pins>;
+			pinctrl-3 = <&pwm2_1_pins_disable>;
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm3_0_pins>;
+			pinctrl-1 = <&pwm3_0_pins_disable>;
+			pinctrl-2 = <&pwm3_1_pins>;
+			pinctrl-3 = <&pwm3_1_pins_disable>;
+		};
+	};
+
+	rtk-lsadc@98007900 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <35 4>, <36 4>; /* LSADC0_INT, LSADC1_INT */
+		reg = <0x0 0x98007000 0x0 0x4>, /* ISO_ISR */
+			<0x0 0x98007900 0x0 0x200>, /* LSADC */
+			<0x0 0x9800034C 0x0 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>, /* LSADC0 0:disable; 1:enable */
+						<1>; /* LSADC1 0:disable; 1:enable */
+		vdd_mux_sel = <0>; /* 0:VDD1; 1:VDD2 */
+		vdd_mux1 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux2 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux_en = <1>; /* 0:disable; 1:enable */
+		clocks = <&clk_en_1 CLK_EN_LSADC>;
+		resets = <&crst RSTN_LSADC>;
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <1>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc1-pad0 {
+			//compatible = "Realtek,rtk-lsadc1-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <0>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+
+		rtk-lsadc1-pad1 {
+			//compatible = "Realtek,rtk-lsadc1-pad1";
+			activate = <1>; /* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0: Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <1>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd161x-hdmitx";
+		reg = <0x0 0x9800d000 0x0 0x560>, /* HDMITX */
+			<0x0 0x98007200 0x0 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 7 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&crst RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		status = "okay";
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <63 4>;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtd161x-hdcptx";
+		reg = <0x0 0x9800d000 0x0 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		status = "okay";
+	};
+
+	hdmirx@98034000 {
+		compatible = "realtek,rtd161x-hdmirx";
+		reg = <0x0 0x98037000 0x0 0xE0>,
+			<0x0 0x98034000 0x0 0xF54>,
+			<0x0 0x98035F00 0x0 0x4C>,
+			<0x0 0x98037700 0x0 0x98>,
+			<0x0 0x98004000 0x0 0x224>,
+			<0x0 0x9801B500 0x0 0x48>;
+		interrupts = <0 23 4>;
+		gpio-rx-hpd-ctrl = <&rtk_iso_gpio 31 1 1>; /* Low active */
+		gpio-5v-detect = <&rtk_iso_gpio 20 0 0>;
+		clocks = <&clk_en_3 CLK_EN_HDMIRX>,
+			<&clk_en_2 CLK_EN_MIPI>,
+			<&iso_clk_en CLK_EN_CBUS_OSC>,
+			<&iso_clk_en CLK_EN_CBUS_SYS>,
+			<&iso_clk_en CLK_EN_CBUSTX_SYS>,
+			<&iso_clk_en CLK_EN_CBUSRX_SYS>,
+			<&clk_en_2 CLK_EN_TP>,
+			<&clk_en_2 CLK_EN_CP>;
+		clock-names = "hdmirx",
+			"mipi",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys",
+			"tp",
+			"cp";
+		resets = <&crst RSTN_HDMIRX>,
+			<&crst RSTN_HDMIRX_WRAP>,
+			<&crst RSTN_MIPI>,
+			<&iso_rst RSTN_CBUS>,
+			<&iso_rst RSTN_CBUSTX>,
+			<&iso_rst RSTN_CBUSRX>;
+		reset-names = "hdmirx",
+			"hdmirx_wrap",
+			"mipi",
+			"cbus",
+			"cbustx",
+			"cbusrx";
+		powerctrls = <&pd PD_SRAM_HDMIRX>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_2>;
+		status = "okay";
+	};
+
+	sd: sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_iso_gpio 30 1 0>, /*sd power , output, default high  (poweroff) */
+			<&rtk_iso_gpio 34 0 1>,
+			<&rtk_iso_gpio 35 0 1>;
+		reg =   <0x0 0x98000000 0x0 0x400>, /* CRT */
+			<0x0 0x98010400 0x0 0x200>, /* SDMMC */
+			<0x0 0x9801A000 0x0 0x400>, /* BS2 */
+			<0x0 0x9804f000 0x0 0x40>, /* ISO */
+			<0x0 0x98010A00 0x0 0x40>, /* SDIO */
+			<0x0 0x98007000 0x0 0x200>;
+		interrupts = <0 44 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>, <&scpu_ejtag_pins_disable>; /*<&sdcard_pins_high>;*/
+		clocks = <&clk_en_2 CLK_EN_SD>, <&clk_en_2 CLK_EN_SD_IP>;
+		clock-names = "sd", "sd_ip";
+		resets = <&crst RSTN_SD>;
+		status = "okay";
+	};
+
+	sdio: sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 27 1 1>;
+		reg = <0x0 0x98010c00 0x0 0x200>,
+			<0x0 0x98000000 0x0 0x200000>;
+		interrupts = <0 45 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdio_pins_1>;
+		clocks = <&clk_en_2 CLK_EN_SDIO>,
+			<&clk_en_2 CLK_EN_SDIO_IP>;
+		clock-names = "sdio", "sdio_ip";
+		resets = <&crst RSTN_SDIO>;
+		status = "okay";
+	};
+
+	emmc: emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		reg = <0x0 0x98012000 0x0 0xa00>, /*EMMC*/
+			<0x0 0x98000000 0x0 0x600>, /*CRT */
+			<0x0 0x9801A000 0x0 0x80>, /*SB2*/
+			<0x0 0x9801B000 0x0 0x150>, /*MISC*/
+			<0x0 0x9801a954 0x0 0x20>,  /*SB2_DBG*/
+			<0x0 0x9804f000 0x0 0x100>; /* ISO */
+		interrupts = <0 42 4>;
+		speed-step = <3>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_2 CLK_EN_EMMC>, <&clk_en_2 CLK_EN_EMMC_IP>;
+		clock-names = "emmc", "emmc_ip";
+		resets = <&crst RSTN_EMMC>;
+		reset-names = "emmc";
+		status = "okay";
+		pddrive_nf_s0 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+		pddrive_nf_s1 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for ddr50 */
+		pddrive_nf_s2 = <1 0x4 0x4 0x4 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+		pddrive_nf_s3 = <1 0x4 0x4 0x4 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs400 */
+		phase_tuning = <0 1>; /* arg0: tx tuning switch, arg1: rx tuning switch, if we want to set user defined tx or rx, we should set 0 for tx or rx*/
+		reference_phase = <1 0x9 0 0x0>; /* arg0: switch user defined tx, arg1: tx reference phase value, arg2: switch user defined rx, arg3: rx reference phase value*/
+		dqs_tuning = <1>;
+		mbr_tuning_addr = <0x9a0e00>;
+	};
+
+	nand@98010000 {
+		compatible = "Realtek,rtk1295-nand";
+		reg = <0x0 0x98010000 0x0 0x400>, /* NWC */
+			<0x0 0x9801F000 0x0 0x400>; /* SWC */
+		clocks = <&clk_en_2 CLK_EN_NF>;
+		resets = <&crst RSTN_NF>;
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+                compatible = "Realtek,rfkill";
+                gpios = <&rtk_iso_gpio 11 1 0>; /*bt power , output, default low */
+                status = "okay";
+        };
+
+	rng@98001000 {
+                compatible = "Realtek,rtk-rng";
+		reg = <0x0 0x98001000 0x0 0x70>;
+		status = "okay";
+        };
+
+
+	smartcard@9801BE00 {
+		compatible = "Realtek,rtk-smc";
+		interrupts = <0 63 4>; /* SC0_INT*/
+		reg = <0x0 0x9801B000 0x0 0x100>, /* MISC interrupt */
+			<0x0 0x9801BE00 0x0 0x80>; /* SmartCard */
+		smc-num = <0>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&smartcard_pins_0>;
+		clock-names = "clk_en_misc_sc";
+		clocks = <&clk_en_3 CLK_EN_MISC_SC0>;
+		resets = <&crst RSTN_MISC_SC0>;
+		status = "okay";
+		lsic_control{
+			pin_cmd_vcc = <&rtk_iso_gpio 63 1 0>; /* pin cmd_vcc , default low */
+			pin_pwr_sel = <&rtk_iso_gpio 64 1 0>; /* pin pwr_sel , default 0 */
+			cmd_vcc_en = <1>;
+			cmd_vcc_polarity = <0>; /* low active */
+			pwr_sel_en = <1>;
+			pwr_sel_polarity = <1>; /* high actve 1: 5v */
+		};
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x0 0x98007000 0x0 0x400>,
+			<0x0 0x98007400 0x0 0x100>;
+		interrupts = <37 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&ir_rx_pins>;
+		resets = <&iso_rst RSTN_IR>;
+		clocks = <&iso_clk_en CLK_EN_MISC_IR>;
+		status = "okay";
+	};
+
+        rtc@9801B600 {
+                compatible = "realtek,rtk-rtc";
+                reg = <0x0 0x9801B600 0x0 0x34>,
+                        <0x0 0x98007000 0x0 0x100>;
+                rtc-base-year = <2018>;
+		rtc-bias = <0x2>;
+		interrupts = <0 39 4>;
+                status = "okay";
+        };
+
+
+
+
+	rpc@9801a104 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x0 0x9801a104 0x0 0xc>, /* rpc intr en */
+			<0x0 0x01ffe000 0x0 0x4000>, /* rpc ring buffer */
+			<0x0 0x0002f000 0x0 0x1000>, /* rpc common */
+			<0x0 0x9801a020 0x0 0x4>; /* rbus sync */
+		interrupts = <0 33 4>;
+		status = "okay";
+	};
+
+	dvfs: cpu-dvfs {
+	};
+
+	gpu: gpu@981D0000 {
+		compatible = "arm,mali-midgard";
+		reg = <0x0 0x981D0000 0x0 0x10000>,
+		      <0x0 0x98007000 0x0 0x01000>;
+		interrupts = <GIC_SPI 76 4>, <GIC_SPI 77 4>, <GIC_SPI 75 4>;
+		interrupt-names = "JOB", "MMU", "GPU";
+		clocks = <&cc CC_CLK_GPU>;
+		clock-name = "clk_mali";
+		resets = <&crst RSTN_GPU>;
+		power-domains = <&pd PD_SRAM_GPU>;
+		status = "okay";
+	};
+
+	cpu_tm: thermal-sensor@9801db00 {
+		compatible = "realtek,rtd16xx-thermal-sensor";
+		reg = <0x0 0x9801db00 0x0 0x50>;
+		#thermal-sensor-cells = <0>;
+		status = "okay";
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+			trips {
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <0>;
+					type = "critical";
+				};
+			};
+			cooling-maps {};
+		};
+	};
+
+	hse@98005000 {
+		reg = <0x0 0x98005000 0x0 0x1000>;
+		compatible = "realtek,highspeed-streaming-engine";
+		interrupts = <GIC_SPI 27 4>;
+		clocks = <&clk_en_3 CLK_EN_HSE>;
+		resets = <&crst RSTN_HSE>;
+		status = "okay";
+
+		engine-0-enabled;
+		engine-1-disabled;
+	};
+
+	md: md@9800b000 {
+		compatible = "realtek,md";
+		reg = <0 0x9800b000 0 0x1000>;
+		interrupts = <0 38 4>;
+		clocks = <&clk_en_2 CLK_EN_MD>;
+		resets = <&crst RSTN_MD>;
+		status = "okay";
+	};
+
+	se: se@9800c000 {
+		compatible = "realtek,se";
+		reg = <0 0x9800c000 0 0x1000>;
+		interrupts = <0 20 4>;
+		clocks = <&clk_en_1 CLK_EN_SE>;
+		resets = <&crst RSTN_SE>;
+		status = "okay";
+	};
+
+	mcp@0 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x0 0x98015000 0x0 0x1000>,
+			<0x0 0x98014000 0x0 0x1000>;
+		status = "okay";
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk16xx-pu_pll";
+		reg = <0x0 0x98000000 0x0 0x200>;
+	};
+
+	jpeg: jpeg@9803e000 {
+		compatible = "Realtek,rtk16xx-jpeg";
+		reg = <0x0 0x9803e000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x200>,
+			<0x0 0x98007000 0x0 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_3 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&crst RSTN_JPEG>;
+		status = "okay";
+	};
+
+	ve1: ve1@98040000 {
+		compatible = "Realtek,rtk16xx-ve1";
+		reg = <0x0 0x98040000 0x0 0xC000>,
+			<0x0 0x98008000 0x0 0x1000>,
+			<0x0 0x98007000 0x0 0x30>,
+			<0x0 0x9800E000 0x0 0x1000>;
+		interrupts = <0 53 4>, <0 54 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			<&cc CC_CLK_VE2>,
+			<&cc CC_CLK_VE2_BPU>,
+			<&cc CC_CLK_VE3>,
+			<&cc CC_CLK_SYSH>,
+			<&cc CC_PLL_VE1>,
+			<&cc CC_PLL_VE2>;
+		clock-names = "clk_ve1",
+			"clk_ve2",
+			"clk_ve2_bpu",
+			"clk_ve3",
+			"clk_sysh",
+			"pll_ve1",
+			"pll_ve2";
+		resets = <&crst RSTN_VE1>,
+			<&crst RSTN_VE2>,
+			<&crst RSTN_VE3>;
+		reset-names = "ve1",
+			"ve2",
+			"ve3";
+		assigned-clocks = <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>, <&cc CC_CLK_VE2_BPU>, <&cc CC_CLK_VE3>;
+		assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>, <&cc CC_PLL_VE1>, <&cc CC_PLL_VE1>;
+		assigned-clock-rates = <550000000>, <715000000>, <550000000>, <550000000>;
+		status = "okay";
+	};
+	
+	cec0@98037800 {
+		compatible = "Realtek,rtk-cec0";
+		reg = <0x0 0x98037800 0x0 0xe0>,
+			<0x0 0x98007000 0x0 0x100>,
+			<0x0 0x98037500 0x0 0x100>;
+		interrupts = <0 26 4>;
+		clocks = <&iso_clk_en CLK_EN_CBUS_OSC>,
+			<&iso_clk_en CLK_EN_CBUS_SYS>,
+			<&iso_clk_en CLK_EN_CBUSTX_SYS>,
+			<&iso_clk_en CLK_EN_CBUSRX_SYS>;
+		clock-names = "cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys";
+		resets = <&iso_rst RSTN_CBUS>,
+			<&iso_rst RSTN_CBUSTX>,
+			<&iso_rst RSTN_CBUSRX>;
+		reset-names = "cbus",
+			"cbustx",
+			"cbusrx";
+		status = "okay";
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+	};
+
+	spdif {
+		compatible = "realtek,audio";
+		gpios = <&rtk_iso_gpio 22 1 1>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>;
+		status = "okay";
+	};
+
+	audio_out: audio-out-devices {
+		compatible = "realtek,audio-out";
+		pinctrl-names = "default";
+		pinctrl-0 = <&ao_pins>;
+		status = "disabled";
+
+		dac {
+			compatible = "dac";
+			status = "okay";
+		};
+		spdif {
+			compatible = "spdif";
+			status = "okay";
+		};
+		i2s {
+			compatible = "i2s";
+			channel = <2>;
+			status = "okay";
+		};
+		hdmi {
+			compatible = "hdmi";
+			status = "okay";
+		};
+		global {
+			compatible = "global";
+			status = "okay";
+		};
+	};
+
+	demod@9801E000 {
+		compatible = "realtek,demod";
+		reg = <0x0 0x9801E000 0x0 0x1000>;
+		clocks = <&clk_en_2 CLK_EN_CABLERX>, <&cc CC_PLL_DIF>;
+		clock-names = "cablerx", "pll";
+		resets = <&crst RSTN_CABLERX>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&demod_pins>;
+		status = "okay";
+	};
+
+	tp@98014000 {
+		compatible = "realtek,tp";
+		reg = <0x0 0x98014000 0x0 0x1000>,
+		      <0x0 0x98039000 0x0 0x1000>;
+		clocks = <&clk_en_2 CLK_EN_TP>, <&clk_en_2 CLK_EN_TPB>;
+		clock-names = "tp", "tpb";
+		resets = <&crst RSTN_TP>, <&crst RSTN_TPB>;
+		reset-names = "tp", "tpb";
+		status = "okay";
+	};
+
+	r2rdsc@9800b800 {
+		compatible = "realtek,r2rdsc";
+		reg = <0x0 0x9800b000 0x0 0x1000>;
+		clocks = <&clk_en_4 CLK_EN_R2RDSC>;
+		clock-names = "r2rdsc";
+		resets = <&crst RSTN_R2RDSC>;
+		reset-names = "r2rdsc";
+		status = "okay";
+	};
+};
+
+#include "rtd-16xx-pcie.dtsi"
+#include "rtd-1619-irda.dtsi"
+#include "rtd-1619-sata.dtsi"
+
diff --git a/arch/arm/common/Kconfig b/arch/arm/common/Kconfig
index 9353184..ce01364 100644
--- a/arch/arm/common/Kconfig
+++ b/arch/arm/common/Kconfig
@@ -17,3 +17,7 @@ config SHARP_PARAM
 
 config SHARP_SCOOP
 	bool
+
+config FIQ_GLUE
+	bool
+	select FIQ
diff --git a/arch/arm/common/Makefile b/arch/arm/common/Makefile
index 27f23b1..04aca89 100644
--- a/arch/arm/common/Makefile
+++ b/arch/arm/common/Makefile
@@ -4,6 +4,7 @@
 
 obj-y				+= firmware.o
 
+obj-$(CONFIG_FIQ_GLUE)		+= fiq_glue.o fiq_glue_setup.o
 obj-$(CONFIG_ICST)		+= icst.o
 obj-$(CONFIG_SA1111)		+= sa1111.o
 obj-$(CONFIG_DMABOUNCE)		+= dmabounce.o
diff --git a/arch/arm/common/fiq_glue.S b/arch/arm/common/fiq_glue.S
new file mode 100644
index 00000000..24b42ce
--- /dev/null
+++ b/arch/arm/common/fiq_glue.S
@@ -0,0 +1,118 @@
+/*
+ * Copyright (C) 2008 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/linkage.h>
+#include <asm/assembler.h>
+
+		.text
+
+		.global fiq_glue_end
+
+		/* fiq stack: r0-r15,cpsr,spsr of interrupted mode */
+
+ENTRY(fiq_glue)
+		/* store pc, cpsr from previous mode, reserve space for spsr */
+		mrs	r12, spsr
+		sub	lr, lr, #4
+		subs	r10, #1
+		bne	nested_fiq
+
+		str	r12, [sp, #-8]!
+		str	lr, [sp, #-4]!
+
+		/* store r8-r14 from previous mode */
+		sub	sp, sp, #(7 * 4)
+		stmia	sp, {r8-r14}^
+		nop
+
+		/* store r0-r7 from previous mode */
+		stmfd	sp!, {r0-r7}
+
+		/* setup func(data,regs) arguments */
+		mov	r0, r9
+		mov	r1, sp
+		mov	r3, r8
+
+		mov	r7, sp
+
+		/* Get sp and lr from non-user modes */
+		and	r4, r12, #MODE_MASK
+		cmp	r4, #USR_MODE
+		beq	fiq_from_usr_mode
+
+		mov	r7, sp
+		orr	r4, r4, #(PSR_I_BIT | PSR_F_BIT)
+		msr	cpsr_c, r4
+		str	sp, [r7, #(4 * 13)]
+		str	lr, [r7, #(4 * 14)]
+		mrs	r5, spsr
+		str	r5, [r7, #(4 * 17)]
+
+		cmp	r4, #(SVC_MODE | PSR_I_BIT | PSR_F_BIT)
+		/* use fiq stack if we reenter this mode */
+		subne	sp, r7, #(4 * 3)
+
+fiq_from_usr_mode:
+		msr	cpsr_c, #(SVC_MODE | PSR_I_BIT | PSR_F_BIT)
+		mov	r2, sp
+		sub	sp, r7, #12
+		stmfd	sp!, {r2, ip, lr}
+		/* call func(data,regs) */
+		blx	r3
+		ldmfd	sp, {r2, ip, lr}
+		mov	sp, r2
+
+		/* restore/discard saved state */
+		cmp	r4, #USR_MODE
+		beq	fiq_from_usr_mode_exit
+
+		msr	cpsr_c, r4
+		ldr	sp, [r7, #(4 * 13)]
+		ldr	lr, [r7, #(4 * 14)]
+		msr	spsr_cxsf, r5
+
+fiq_from_usr_mode_exit:
+		msr	cpsr_c, #(FIQ_MODE | PSR_I_BIT | PSR_F_BIT)
+
+		ldmfd	sp!, {r0-r7}
+		ldr	lr, [sp, #(4 * 7)]
+		ldr	r12, [sp, #(4 * 8)]
+		add	sp, sp, #(10 * 4)
+exit_fiq:
+		msr	spsr_cxsf, r12
+		add	r10, #1
+		cmp	r11, #0
+		moveqs	pc, lr
+		bx	r11 /* jump to custom fiq return function */
+
+nested_fiq:
+		orr	r12, r12, #(PSR_F_BIT)
+		b	exit_fiq
+
+fiq_glue_end:
+
+ENTRY(fiq_glue_setup) /* func, data, sp, smc call number */
+		stmfd		sp!, {r4}
+		mrs		r4, cpsr
+		msr		cpsr_c, #(FIQ_MODE | PSR_I_BIT | PSR_F_BIT)
+		movs		r8, r0
+		mov		r9, r1
+		mov		sp, r2
+		mov		r11, r3
+		moveq		r10, #0
+		movne		r10, #1
+		msr		cpsr_c, r4
+		ldmfd		sp!, {r4}
+		bx		lr
+
diff --git a/arch/arm/common/fiq_glue_setup.c b/arch/arm/common/fiq_glue_setup.c
new file mode 100644
index 00000000..8cb1b61
--- /dev/null
+++ b/arch/arm/common/fiq_glue_setup.c
@@ -0,0 +1,147 @@
+/*
+ * Copyright (C) 2010 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include <linux/kernel.h>
+#include <linux/percpu.h>
+#include <linux/slab.h>
+#include <asm/fiq.h>
+#include <asm/fiq_glue.h>
+
+extern unsigned char fiq_glue, fiq_glue_end;
+extern void fiq_glue_setup(void *func, void *data, void *sp,
+			   fiq_return_handler_t fiq_return_handler);
+
+static struct fiq_handler fiq_debbuger_fiq_handler = {
+	.name = "fiq_glue",
+};
+DEFINE_PER_CPU(void *, fiq_stack);
+static struct fiq_glue_handler *current_handler;
+static fiq_return_handler_t fiq_return_handler;
+static DEFINE_MUTEX(fiq_glue_lock);
+
+static void fiq_glue_setup_helper(void *info)
+{
+	struct fiq_glue_handler *handler = info;
+	fiq_glue_setup(handler->fiq, handler,
+		__get_cpu_var(fiq_stack) + THREAD_START_SP,
+		fiq_return_handler);
+}
+
+int fiq_glue_register_handler(struct fiq_glue_handler *handler)
+{
+	int ret;
+	int cpu;
+
+	if (!handler || !handler->fiq)
+		return -EINVAL;
+
+	mutex_lock(&fiq_glue_lock);
+	if (fiq_stack) {
+		ret = -EBUSY;
+		goto err_busy;
+	}
+
+	for_each_possible_cpu(cpu) {
+		void *stack;
+		stack = (void *)__get_free_pages(GFP_KERNEL, THREAD_SIZE_ORDER);
+		if (WARN_ON(!stack)) {
+			ret = -ENOMEM;
+			goto err_alloc_fiq_stack;
+		}
+		per_cpu(fiq_stack, cpu) = stack;
+	}
+
+	ret = claim_fiq(&fiq_debbuger_fiq_handler);
+	if (WARN_ON(ret))
+		goto err_claim_fiq;
+
+	current_handler = handler;
+	on_each_cpu(fiq_glue_setup_helper, handler, true);
+	set_fiq_handler(&fiq_glue, &fiq_glue_end - &fiq_glue);
+
+	mutex_unlock(&fiq_glue_lock);
+	return 0;
+
+err_claim_fiq:
+err_alloc_fiq_stack:
+	for_each_possible_cpu(cpu) {
+		__free_pages(per_cpu(fiq_stack, cpu), THREAD_SIZE_ORDER);
+		per_cpu(fiq_stack, cpu) = NULL;
+	}
+err_busy:
+	mutex_unlock(&fiq_glue_lock);
+	return ret;
+}
+
+static void fiq_glue_update_return_handler(void (*fiq_return)(void))
+{
+	fiq_return_handler = fiq_return;
+	if (current_handler)
+		on_each_cpu(fiq_glue_setup_helper, current_handler, true);
+}
+
+int fiq_glue_set_return_handler(void (*fiq_return)(void))
+{
+	int ret;
+
+	mutex_lock(&fiq_glue_lock);
+	if (fiq_return_handler) {
+		ret = -EBUSY;
+		goto err_busy;
+	}
+	fiq_glue_update_return_handler(fiq_return);
+	ret = 0;
+err_busy:
+	mutex_unlock(&fiq_glue_lock);
+
+	return ret;
+}
+EXPORT_SYMBOL(fiq_glue_set_return_handler);
+
+int fiq_glue_clear_return_handler(void (*fiq_return)(void))
+{
+	int ret;
+
+	mutex_lock(&fiq_glue_lock);
+	if (WARN_ON(fiq_return_handler != fiq_return)) {
+		ret = -EINVAL;
+		goto err_inval;
+	}
+	fiq_glue_update_return_handler(NULL);
+	ret = 0;
+err_inval:
+	mutex_unlock(&fiq_glue_lock);
+
+	return ret;
+}
+EXPORT_SYMBOL(fiq_glue_clear_return_handler);
+
+/**
+ * fiq_glue_resume - Restore fiqs after suspend or low power idle states
+ *
+ * This must be called before calling local_fiq_enable after returning from a
+ * power state where the fiq mode registers were lost. If a driver provided
+ * a resume hook when it registered the handler it will be called.
+ */
+
+void fiq_glue_resume(void)
+{
+	if (!current_handler)
+		return;
+	fiq_glue_setup(current_handler->fiq, current_handler,
+		__get_cpu_var(fiq_stack) + THREAD_START_SP,
+		fiq_return_handler);
+	if (current_handler->resume)
+		current_handler->resume(current_handler);
+}
+
diff --git a/arch/arm/configs/ranchu_defconfig b/arch/arm/configs/ranchu_defconfig
new file mode 100644
index 00000000..49e7bbd
--- /dev/null
+++ b/arch/arm/configs/ranchu_defconfig
@@ -0,0 +1,316 @@
+# CONFIG_LOCALVERSION_AUTO is not set
+CONFIG_AUDIT=y
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_LOG_BUF_SHIFT=14
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_DEBUG=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_BLK_DEV_INITRD=y
+CONFIG_KALLSYMS_ALL=y
+CONFIG_EMBEDDED=y
+CONFIG_PROFILING=y
+CONFIG_OPROFILE=y
+CONFIG_ARCH_MMAP_RND_BITS=16
+# CONFIG_BLK_DEV_BSG is not set
+# CONFIG_IOSCHED_DEADLINE is not set
+# CONFIG_IOSCHED_CFQ is not set
+CONFIG_ARCH_VIRT=y
+CONFIG_ARM_KERNMEM_PERMS=y
+CONFIG_SMP=y
+CONFIG_PREEMPT=y
+CONFIG_AEABI=y
+CONFIG_HIGHMEM=y
+CONFIG_KSM=y
+CONFIG_SECCOMP=y
+CONFIG_CMDLINE="console=ttyAMA0"
+CONFIG_VFP=y
+CONFIG_NEON=y
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_PM_AUTOSLEEP=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_XFRM_USER=y
+CONFIG_NET_KEY=y
+CONFIG_INET=y
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_INET_ESP=y
+# CONFIG_INET_LRO is not set
+CONFIG_IPV6_ROUTER_PREF=y
+CONFIG_IPV6_ROUTE_INFO=y
+CONFIG_IPV6_OPTIMISTIC_DAD=y
+CONFIG_INET6_AH=y
+CONFIG_INET6_ESP=y
+CONFIG_INET6_IPCOMP=y
+CONFIG_IPV6_MIP6=y
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_NETFILTER=y
+CONFIG_NF_CONNTRACK=y
+CONFIG_NF_CONNTRACK_SECMARK=y
+CONFIG_NF_CONNTRACK_EVENTS=y
+CONFIG_NF_CT_PROTO_DCCP=y
+CONFIG_NF_CT_PROTO_SCTP=y
+CONFIG_NF_CT_PROTO_UDPLITE=y
+CONFIG_NF_CONNTRACK_AMANDA=y
+CONFIG_NF_CONNTRACK_FTP=y
+CONFIG_NF_CONNTRACK_H323=y
+CONFIG_NF_CONNTRACK_IRC=y
+CONFIG_NF_CONNTRACK_NETBIOS_NS=y
+CONFIG_NF_CONNTRACK_PPTP=y
+CONFIG_NF_CONNTRACK_SANE=y
+CONFIG_NF_CONNTRACK_TFTP=y
+CONFIG_NF_CT_NETLINK=y
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=y
+CONFIG_NETFILTER_XT_TARGET_CONNMARK=y
+CONFIG_NETFILTER_XT_TARGET_CONNSECMARK=y
+CONFIG_NETFILTER_XT_TARGET_IDLETIMER=y
+CONFIG_NETFILTER_XT_TARGET_MARK=y
+CONFIG_NETFILTER_XT_TARGET_NFLOG=y
+CONFIG_NETFILTER_XT_TARGET_NFQUEUE=y
+CONFIG_NETFILTER_XT_TARGET_TPROXY=y
+CONFIG_NETFILTER_XT_TARGET_TRACE=y
+CONFIG_NETFILTER_XT_TARGET_SECMARK=y
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=y
+CONFIG_NETFILTER_XT_MATCH_COMMENT=y
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=y
+CONFIG_NETFILTER_XT_MATCH_CONNMARK=y
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=y
+CONFIG_NETFILTER_XT_MATCH_HASHLIMIT=y
+CONFIG_NETFILTER_XT_MATCH_HELPER=y
+CONFIG_NETFILTER_XT_MATCH_IPRANGE=y
+CONFIG_NETFILTER_XT_MATCH_LENGTH=y
+CONFIG_NETFILTER_XT_MATCH_LIMIT=y
+CONFIG_NETFILTER_XT_MATCH_MAC=y
+CONFIG_NETFILTER_XT_MATCH_MARK=y
+CONFIG_NETFILTER_XT_MATCH_POLICY=y
+CONFIG_NETFILTER_XT_MATCH_PKTTYPE=y
+CONFIG_NETFILTER_XT_MATCH_QTAGUID=y
+CONFIG_NETFILTER_XT_MATCH_QUOTA=y
+CONFIG_NETFILTER_XT_MATCH_QUOTA2=y
+CONFIG_NETFILTER_XT_MATCH_SOCKET=y
+CONFIG_NETFILTER_XT_MATCH_STATE=y
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=y
+CONFIG_NETFILTER_XT_MATCH_STRING=y
+CONFIG_NETFILTER_XT_MATCH_TIME=y
+CONFIG_NETFILTER_XT_MATCH_U32=y
+CONFIG_NF_CONNTRACK_IPV4=y
+CONFIG_IP_NF_IPTABLES=y
+CONFIG_IP_NF_MATCH_AH=y
+CONFIG_IP_NF_MATCH_ECN=y
+CONFIG_IP_NF_MATCH_TTL=y
+CONFIG_IP_NF_FILTER=y
+CONFIG_IP_NF_TARGET_REJECT=y
+CONFIG_IP_NF_MANGLE=y
+CONFIG_IP_NF_RAW=y
+CONFIG_IP_NF_SECURITY=y
+CONFIG_IP_NF_ARPTABLES=y
+CONFIG_IP_NF_ARPFILTER=y
+CONFIG_IP_NF_ARP_MANGLE=y
+CONFIG_NF_CONNTRACK_IPV6=y
+CONFIG_IP6_NF_IPTABLES=y
+CONFIG_IP6_NF_FILTER=y
+CONFIG_IP6_NF_TARGET_REJECT=y
+CONFIG_IP6_NF_MANGLE=y
+CONFIG_IP6_NF_RAW=y
+CONFIG_BRIDGE=y
+CONFIG_NET_SCHED=y
+CONFIG_NET_SCH_HTB=y
+CONFIG_NET_CLS_U32=y
+CONFIG_NET_EMATCH=y
+CONFIG_NET_EMATCH_U32=y
+CONFIG_NET_CLS_ACT=y
+# CONFIG_WIRELESS is not set
+CONFIG_UEVENT_HELPER_PATH="/sbin/hotplug"
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+CONFIG_MTD_CFI=y
+CONFIG_MTD_CFI_INTELEXT=y
+CONFIG_MTD_CFI_AMDSTD=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_RAM_SIZE=8192
+CONFIG_VIRTIO_BLK=y
+CONFIG_MD=y
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=y
+CONFIG_DM_UEVENT=y
+CONFIG_DM_VERITY=y
+CONFIG_DM_VERITY_FEC=y
+CONFIG_NETDEVICES=y
+CONFIG_TUN=y
+CONFIG_VIRTIO_NET=y
+CONFIG_SMSC911X=y
+CONFIG_PPP=y
+CONFIG_PPP_BSDCOMP=y
+CONFIG_PPP_DEFLATE=y
+CONFIG_PPP_MPPE=y
+CONFIG_PPPOLAC=y
+CONFIG_PPPOPNS=y
+CONFIG_USB_USBNET=y
+# CONFIG_WLAN is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_INPUT_KEYRESET=y
+CONFIG_KEYBOARD_GOLDFISH_EVENTS=y
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_JOYSTICK=y
+CONFIG_JOYSTICK_XPAD=y
+CONFIG_JOYSTICK_XPAD_FF=y
+CONFIG_JOYSTICK_XPAD_LEDS=y
+CONFIG_INPUT_TABLET=y
+CONFIG_TABLET_USB_ACECAD=y
+CONFIG_TABLET_USB_AIPTEK=y
+CONFIG_TABLET_USB_GTCO=y
+CONFIG_TABLET_USB_HANWANG=y
+CONFIG_TABLET_USB_KBTAB=y
+CONFIG_INPUT_MISC=y
+CONFIG_INPUT_KEYCHORD=y
+CONFIG_INPUT_UINPUT=y
+CONFIG_INPUT_GPIO=y
+# CONFIG_SERIO_SERPORT is not set
+CONFIG_SERIO_AMBAKMI=y
+# CONFIG_VT is not set
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_AMBA_PL011=y
+CONFIG_SERIAL_AMBA_PL011_CONSOLE=y
+CONFIG_VIRTIO_CONSOLE=y
+# CONFIG_HW_RANDOM is not set
+# CONFIG_HWMON is not set
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_FB=y
+CONFIG_FB_GOLDFISH=y
+CONFIG_FB_SIMPLE=y
+CONFIG_BACKLIGHT_LCD_SUPPORT=y
+CONFIG_LOGO=y
+# CONFIG_LOGO_LINUX_MONO is not set
+# CONFIG_LOGO_LINUX_VGA16 is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_HIDRAW=y
+CONFIG_UHID=y
+CONFIG_HID_A4TECH=y
+CONFIG_HID_ACRUX=y
+CONFIG_HID_ACRUX_FF=y
+CONFIG_HID_APPLE=y
+CONFIG_HID_BELKIN=y
+CONFIG_HID_CHERRY=y
+CONFIG_HID_CHICONY=y
+CONFIG_HID_PRODIKEYS=y
+CONFIG_HID_CYPRESS=y
+CONFIG_HID_DRAGONRISE=y
+CONFIG_DRAGONRISE_FF=y
+CONFIG_HID_EMS_FF=y
+CONFIG_HID_ELECOM=y
+CONFIG_HID_EZKEY=y
+CONFIG_HID_HOLTEK=y
+CONFIG_HID_KEYTOUCH=y
+CONFIG_HID_KYE=y
+CONFIG_HID_UCLOGIC=y
+CONFIG_HID_WALTOP=y
+CONFIG_HID_GYRATION=y
+CONFIG_HID_TWINHAN=y
+CONFIG_HID_KENSINGTON=y
+CONFIG_HID_LCPOWER=y
+CONFIG_HID_LOGITECH=y
+CONFIG_HID_LOGITECH_DJ=y
+CONFIG_LOGITECH_FF=y
+CONFIG_LOGIRUMBLEPAD2_FF=y
+CONFIG_LOGIG940_FF=y
+CONFIG_HID_MAGICMOUSE=y
+CONFIG_HID_MICROSOFT=y
+CONFIG_HID_MONTEREY=y
+CONFIG_HID_MULTITOUCH=y
+CONFIG_HID_NTRIG=y
+CONFIG_HID_ORTEK=y
+CONFIG_HID_PANTHERLORD=y
+CONFIG_PANTHERLORD_FF=y
+CONFIG_HID_PETALYNX=y
+CONFIG_HID_PICOLCD=y
+CONFIG_HID_PRIMAX=y
+CONFIG_HID_ROCCAT=y
+CONFIG_HID_SAITEK=y
+CONFIG_HID_SAMSUNG=y
+CONFIG_HID_SONY=y
+CONFIG_HID_SPEEDLINK=y
+CONFIG_HID_SUNPLUS=y
+CONFIG_HID_GREENASIA=y
+CONFIG_GREENASIA_FF=y
+CONFIG_HID_SMARTJOYPLUS=y
+CONFIG_SMARTJOYPLUS_FF=y
+CONFIG_HID_TIVO=y
+CONFIG_HID_TOPSEED=y
+CONFIG_HID_THRUSTMASTER=y
+CONFIG_HID_WACOM=y
+CONFIG_HID_WIIMOTE=y
+CONFIG_HID_ZEROPLUS=y
+CONFIG_HID_ZYDACRON=y
+CONFIG_USB_HIDDEV=y
+CONFIG_USB_ANNOUNCE_NEW_DEVICES=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_OTG_WAKELOCK=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_PL031=y
+CONFIG_VIRTIO_MMIO=y
+CONFIG_STAGING=y
+CONFIG_ASHMEM=y
+CONFIG_ANDROID_LOW_MEMORY_KILLER=y
+CONFIG_SYNC=y
+CONFIG_SW_SYNC=y
+CONFIG_SW_SYNC_USER=y
+CONFIG_ION=y
+CONFIG_GOLDFISH_AUDIO=y
+CONFIG_GOLDFISH=y
+CONFIG_GOLDFISH_PIPE=y
+CONFIG_ANDROID=y
+CONFIG_ANDROID_BINDER_IPC=y
+CONFIG_EXT4_FS=y
+CONFIG_EXT4_FS_SECURITY=y
+CONFIG_QUOTA=y
+CONFIG_FUSE_FS=y
+CONFIG_CUSE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_POSIX_ACL=y
+CONFIG_PSTORE=y
+CONFIG_PSTORE_CONSOLE=y
+CONFIG_PSTORE_RAM=y
+CONFIG_NFS_FS=y
+CONFIG_ROOT_NFS=y
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_DEBUG_INFO=y
+CONFIG_MAGIC_SYSRQ=y
+CONFIG_DETECT_HUNG_TASK=y
+CONFIG_PANIC_TIMEOUT=5
+# CONFIG_SCHED_DEBUG is not set
+CONFIG_SCHEDSTATS=y
+CONFIG_TIMER_STATS=y
+CONFIG_ENABLE_DEFAULT_TRACERS=y
+CONFIG_SECURITY=y
+CONFIG_SECURITY_NETWORK=y
+CONFIG_SECURITY_SELINUX=y
+CONFIG_VIRTUALIZATION=y
diff --git a/arch/arm/crypto/Kconfig b/arch/arm/crypto/Kconfig
index 27ed1b1..72aa5ec 100644
--- a/arch/arm/crypto/Kconfig
+++ b/arch/arm/crypto/Kconfig
@@ -120,4 +120,11 @@ config CRYPTO_GHASH_ARM_CE
 	  that uses the 64x64 to 128 bit polynomial multiplication (vmull.p64)
 	  that is part of the ARMv8 Crypto Extensions
 
+config CRYPTO_SPECK_NEON
+	tristate "NEON accelerated Speck cipher algorithms"
+	depends on KERNEL_MODE_NEON
+	select CRYPTO_BLKCIPHER
+	select CRYPTO_GF128MUL
+	select CRYPTO_SPECK
+
 endif
diff --git a/arch/arm/crypto/Makefile b/arch/arm/crypto/Makefile
index fc51507..1d0448a 100644
--- a/arch/arm/crypto/Makefile
+++ b/arch/arm/crypto/Makefile
@@ -8,6 +8,7 @@ obj-$(CONFIG_CRYPTO_SHA1_ARM) += sha1-arm.o
 obj-$(CONFIG_CRYPTO_SHA1_ARM_NEON) += sha1-arm-neon.o
 obj-$(CONFIG_CRYPTO_SHA256_ARM) += sha256-arm.o
 obj-$(CONFIG_CRYPTO_SHA512_ARM) += sha512-arm.o
+obj-$(CONFIG_CRYPTO_SPECK_NEON) += speck-neon.o
 
 ce-obj-$(CONFIG_CRYPTO_AES_ARM_CE) += aes-arm-ce.o
 ce-obj-$(CONFIG_CRYPTO_SHA1_ARM_CE) += sha1-arm-ce.o
@@ -36,6 +37,7 @@ sha1-arm-ce-y	:= sha1-ce-core.o sha1-ce-glue.o
 sha2-arm-ce-y	:= sha2-ce-core.o sha2-ce-glue.o
 aes-arm-ce-y	:= aes-ce-core.o aes-ce-glue.o
 ghash-arm-ce-y	:= ghash-ce-core.o ghash-ce-glue.o
+speck-neon-y := speck-neon-core.o speck-neon-glue.o
 
 quiet_cmd_perl = PERL    $@
       cmd_perl = $(PERL) $(<) > $(@)
diff --git a/arch/arm/crypto/speck-neon-core.S b/arch/arm/crypto/speck-neon-core.S
new file mode 100644
index 00000000..3c1e203
--- /dev/null
+++ b/arch/arm/crypto/speck-neon-core.S
@@ -0,0 +1,432 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * NEON-accelerated implementation of Speck128-XTS and Speck64-XTS
+ *
+ * Copyright (c) 2018 Google, Inc
+ *
+ * Author: Eric Biggers <ebiggers@google.com>
+ */
+
+#include <linux/linkage.h>
+
+	.text
+	.fpu		neon
+
+	// arguments
+	ROUND_KEYS	.req	r0	// const {u64,u32} *round_keys
+	NROUNDS		.req	r1	// int nrounds
+	DST		.req	r2	// void *dst
+	SRC		.req	r3	// const void *src
+	NBYTES		.req	r4	// unsigned int nbytes
+	TWEAK		.req	r5	// void *tweak
+
+	// registers which hold the data being encrypted/decrypted
+	X0		.req	q0
+	X0_L		.req	d0
+	X0_H		.req	d1
+	Y0		.req	q1
+	Y0_H		.req	d3
+	X1		.req	q2
+	X1_L		.req	d4
+	X1_H		.req	d5
+	Y1		.req	q3
+	Y1_H		.req	d7
+	X2		.req	q4
+	X2_L		.req	d8
+	X2_H		.req	d9
+	Y2		.req	q5
+	Y2_H		.req	d11
+	X3		.req	q6
+	X3_L		.req	d12
+	X3_H		.req	d13
+	Y3		.req	q7
+	Y3_H		.req	d15
+
+	// the round key, duplicated in all lanes
+	ROUND_KEY	.req	q8
+	ROUND_KEY_L	.req	d16
+	ROUND_KEY_H	.req	d17
+
+	// index vector for vtbl-based 8-bit rotates
+	ROTATE_TABLE	.req	d18
+
+	// multiplication table for updating XTS tweaks
+	GF128MUL_TABLE	.req	d19
+	GF64MUL_TABLE	.req	d19
+
+	// current XTS tweak value(s)
+	TWEAKV		.req	q10
+	TWEAKV_L	.req	d20
+	TWEAKV_H	.req	d21
+
+	TMP0		.req	q12
+	TMP0_L		.req	d24
+	TMP0_H		.req	d25
+	TMP1		.req	q13
+	TMP2		.req	q14
+	TMP3		.req	q15
+
+	.align		4
+.Lror64_8_table:
+	.byte		1, 2, 3, 4, 5, 6, 7, 0
+.Lror32_8_table:
+	.byte		1, 2, 3, 0, 5, 6, 7, 4
+.Lrol64_8_table:
+	.byte		7, 0, 1, 2, 3, 4, 5, 6
+.Lrol32_8_table:
+	.byte		3, 0, 1, 2, 7, 4, 5, 6
+.Lgf128mul_table:
+	.byte		0, 0x87
+	.fill		14
+.Lgf64mul_table:
+	.byte		0, 0x1b, (0x1b << 1), (0x1b << 1) ^ 0x1b
+	.fill		12
+
+/*
+ * _speck_round_128bytes() - Speck encryption round on 128 bytes at a time
+ *
+ * Do one Speck encryption round on the 128 bytes (8 blocks for Speck128, 16 for
+ * Speck64) stored in X0-X3 and Y0-Y3, using the round key stored in all lanes
+ * of ROUND_KEY.  'n' is the lane size: 64 for Speck128, or 32 for Speck64.
+ *
+ * The 8-bit rotates are implemented using vtbl instead of vshr + vsli because
+ * the vtbl approach is faster on some processors and the same speed on others.
+ */
+.macro _speck_round_128bytes	n
+
+	// x = ror(x, 8)
+	vtbl.8		X0_L, {X0_L}, ROTATE_TABLE
+	vtbl.8		X0_H, {X0_H}, ROTATE_TABLE
+	vtbl.8		X1_L, {X1_L}, ROTATE_TABLE
+	vtbl.8		X1_H, {X1_H}, ROTATE_TABLE
+	vtbl.8		X2_L, {X2_L}, ROTATE_TABLE
+	vtbl.8		X2_H, {X2_H}, ROTATE_TABLE
+	vtbl.8		X3_L, {X3_L}, ROTATE_TABLE
+	vtbl.8		X3_H, {X3_H}, ROTATE_TABLE
+
+	// x += y
+	vadd.u\n	X0, Y0
+	vadd.u\n	X1, Y1
+	vadd.u\n	X2, Y2
+	vadd.u\n	X3, Y3
+
+	// x ^= k
+	veor		X0, ROUND_KEY
+	veor		X1, ROUND_KEY
+	veor		X2, ROUND_KEY
+	veor		X3, ROUND_KEY
+
+	// y = rol(y, 3)
+	vshl.u\n	TMP0, Y0, #3
+	vshl.u\n	TMP1, Y1, #3
+	vshl.u\n	TMP2, Y2, #3
+	vshl.u\n	TMP3, Y3, #3
+	vsri.u\n	TMP0, Y0, #(\n - 3)
+	vsri.u\n	TMP1, Y1, #(\n - 3)
+	vsri.u\n	TMP2, Y2, #(\n - 3)
+	vsri.u\n	TMP3, Y3, #(\n - 3)
+
+	// y ^= x
+	veor		Y0, TMP0, X0
+	veor		Y1, TMP1, X1
+	veor		Y2, TMP2, X2
+	veor		Y3, TMP3, X3
+.endm
+
+/*
+ * _speck_unround_128bytes() - Speck decryption round on 128 bytes at a time
+ *
+ * This is the inverse of _speck_round_128bytes().
+ */
+.macro _speck_unround_128bytes	n
+
+	// y ^= x
+	veor		TMP0, Y0, X0
+	veor		TMP1, Y1, X1
+	veor		TMP2, Y2, X2
+	veor		TMP3, Y3, X3
+
+	// y = ror(y, 3)
+	vshr.u\n	Y0, TMP0, #3
+	vshr.u\n	Y1, TMP1, #3
+	vshr.u\n	Y2, TMP2, #3
+	vshr.u\n	Y3, TMP3, #3
+	vsli.u\n	Y0, TMP0, #(\n - 3)
+	vsli.u\n	Y1, TMP1, #(\n - 3)
+	vsli.u\n	Y2, TMP2, #(\n - 3)
+	vsli.u\n	Y3, TMP3, #(\n - 3)
+
+	// x ^= k
+	veor		X0, ROUND_KEY
+	veor		X1, ROUND_KEY
+	veor		X2, ROUND_KEY
+	veor		X3, ROUND_KEY
+
+	// x -= y
+	vsub.u\n	X0, Y0
+	vsub.u\n	X1, Y1
+	vsub.u\n	X2, Y2
+	vsub.u\n	X3, Y3
+
+	// x = rol(x, 8);
+	vtbl.8		X0_L, {X0_L}, ROTATE_TABLE
+	vtbl.8		X0_H, {X0_H}, ROTATE_TABLE
+	vtbl.8		X1_L, {X1_L}, ROTATE_TABLE
+	vtbl.8		X1_H, {X1_H}, ROTATE_TABLE
+	vtbl.8		X2_L, {X2_L}, ROTATE_TABLE
+	vtbl.8		X2_H, {X2_H}, ROTATE_TABLE
+	vtbl.8		X3_L, {X3_L}, ROTATE_TABLE
+	vtbl.8		X3_H, {X3_H}, ROTATE_TABLE
+.endm
+
+.macro _xts128_precrypt_one	dst_reg, tweak_buf, tmp
+
+	// Load the next source block
+	vld1.8		{\dst_reg}, [SRC]!
+
+	// Save the current tweak in the tweak buffer
+	vst1.8		{TWEAKV}, [\tweak_buf:128]!
+
+	// XOR the next source block with the current tweak
+	veor		\dst_reg, TWEAKV
+
+	/*
+	 * Calculate the next tweak by multiplying the current one by x,
+	 * modulo p(x) = x^128 + x^7 + x^2 + x + 1.
+	 */
+	vshr.u64	\tmp, TWEAKV, #63
+	vshl.u64	TWEAKV, #1
+	veor		TWEAKV_H, \tmp\()_L
+	vtbl.8		\tmp\()_H, {GF128MUL_TABLE}, \tmp\()_H
+	veor		TWEAKV_L, \tmp\()_H
+.endm
+
+.macro _xts64_precrypt_two	dst_reg, tweak_buf, tmp
+
+	// Load the next two source blocks
+	vld1.8		{\dst_reg}, [SRC]!
+
+	// Save the current two tweaks in the tweak buffer
+	vst1.8		{TWEAKV}, [\tweak_buf:128]!
+
+	// XOR the next two source blocks with the current two tweaks
+	veor		\dst_reg, TWEAKV
+
+	/*
+	 * Calculate the next two tweaks by multiplying the current ones by x^2,
+	 * modulo p(x) = x^64 + x^4 + x^3 + x + 1.
+	 */
+	vshr.u64	\tmp, TWEAKV, #62
+	vshl.u64	TWEAKV, #2
+	vtbl.8		\tmp\()_L, {GF64MUL_TABLE}, \tmp\()_L
+	vtbl.8		\tmp\()_H, {GF64MUL_TABLE}, \tmp\()_H
+	veor		TWEAKV, \tmp
+.endm
+
+/*
+ * _speck_xts_crypt() - Speck-XTS encryption/decryption
+ *
+ * Encrypt or decrypt NBYTES bytes of data from the SRC buffer to the DST buffer
+ * using Speck-XTS, specifically the variant with a block size of '2n' and round
+ * count given by NROUNDS.  The expanded round keys are given in ROUND_KEYS, and
+ * the current XTS tweak value is given in TWEAK.  It's assumed that NBYTES is a
+ * nonzero multiple of 128.
+ */
+.macro _speck_xts_crypt	n, decrypting
+	push		{r4-r7}
+	mov		r7, sp
+
+	/*
+	 * The first four parameters were passed in registers r0-r3.  Load the
+	 * additional parameters, which were passed on the stack.
+	 */
+	ldr		NBYTES, [sp, #16]
+	ldr		TWEAK, [sp, #20]
+
+	/*
+	 * If decrypting, modify the ROUND_KEYS parameter to point to the last
+	 * round key rather than the first, since for decryption the round keys
+	 * are used in reverse order.
+	 */
+.if \decrypting
+.if \n == 64
+	add		ROUND_KEYS, ROUND_KEYS, NROUNDS, lsl #3
+	sub		ROUND_KEYS, #8
+.else
+	add		ROUND_KEYS, ROUND_KEYS, NROUNDS, lsl #2
+	sub		ROUND_KEYS, #4
+.endif
+.endif
+
+	// Load the index vector for vtbl-based 8-bit rotates
+.if \decrypting
+	ldr		r12, =.Lrol\n\()_8_table
+.else
+	ldr		r12, =.Lror\n\()_8_table
+.endif
+	vld1.8		{ROTATE_TABLE}, [r12:64]
+
+	// One-time XTS preparation
+
+	/*
+	 * Allocate stack space to store 128 bytes worth of tweaks.  For
+	 * performance, this space is aligned to a 16-byte boundary so that we
+	 * can use the load/store instructions that declare 16-byte alignment.
+	 */
+	sub		sp, #128
+	bic		sp, #0xf
+
+.if \n == 64
+	// Load first tweak
+	vld1.8		{TWEAKV}, [TWEAK]
+
+	// Load GF(2^128) multiplication table
+	ldr		r12, =.Lgf128mul_table
+	vld1.8		{GF128MUL_TABLE}, [r12:64]
+.else
+	// Load first tweak
+	vld1.8		{TWEAKV_L}, [TWEAK]
+
+	// Load GF(2^64) multiplication table
+	ldr		r12, =.Lgf64mul_table
+	vld1.8		{GF64MUL_TABLE}, [r12:64]
+
+	// Calculate second tweak, packing it together with the first
+	vshr.u64	TMP0_L, TWEAKV_L, #63
+	vtbl.u8		TMP0_L, {GF64MUL_TABLE}, TMP0_L
+	vshl.u64	TWEAKV_H, TWEAKV_L, #1
+	veor		TWEAKV_H, TMP0_L
+.endif
+
+.Lnext_128bytes_\@:
+
+	/*
+	 * Load the source blocks into {X,Y}[0-3], XOR them with their XTS tweak
+	 * values, and save the tweaks on the stack for later.  Then
+	 * de-interleave the 'x' and 'y' elements of each block, i.e. make it so
+	 * that the X[0-3] registers contain only the second halves of blocks,
+	 * and the Y[0-3] registers contain only the first halves of blocks.
+	 * (Speck uses the order (y, x) rather than the more intuitive (x, y).)
+	 */
+	mov		r12, sp
+.if \n == 64
+	_xts128_precrypt_one	X0, r12, TMP0
+	_xts128_precrypt_one	Y0, r12, TMP0
+	_xts128_precrypt_one	X1, r12, TMP0
+	_xts128_precrypt_one	Y1, r12, TMP0
+	_xts128_precrypt_one	X2, r12, TMP0
+	_xts128_precrypt_one	Y2, r12, TMP0
+	_xts128_precrypt_one	X3, r12, TMP0
+	_xts128_precrypt_one	Y3, r12, TMP0
+	vswp		X0_L, Y0_H
+	vswp		X1_L, Y1_H
+	vswp		X2_L, Y2_H
+	vswp		X3_L, Y3_H
+.else
+	_xts64_precrypt_two	X0, r12, TMP0
+	_xts64_precrypt_two	Y0, r12, TMP0
+	_xts64_precrypt_two	X1, r12, TMP0
+	_xts64_precrypt_two	Y1, r12, TMP0
+	_xts64_precrypt_two	X2, r12, TMP0
+	_xts64_precrypt_two	Y2, r12, TMP0
+	_xts64_precrypt_two	X3, r12, TMP0
+	_xts64_precrypt_two	Y3, r12, TMP0
+	vuzp.32		Y0, X0
+	vuzp.32		Y1, X1
+	vuzp.32		Y2, X2
+	vuzp.32		Y3, X3
+.endif
+
+	// Do the cipher rounds
+
+	mov		r12, ROUND_KEYS
+	mov		r6, NROUNDS
+
+.Lnext_round_\@:
+.if \decrypting
+.if \n == 64
+	vld1.64		ROUND_KEY_L, [r12]
+	sub		r12, #8
+	vmov		ROUND_KEY_H, ROUND_KEY_L
+.else
+	vld1.32		{ROUND_KEY_L[],ROUND_KEY_H[]}, [r12]
+	sub		r12, #4
+.endif
+	_speck_unround_128bytes	\n
+.else
+.if \n == 64
+	vld1.64		ROUND_KEY_L, [r12]!
+	vmov		ROUND_KEY_H, ROUND_KEY_L
+.else
+	vld1.32		{ROUND_KEY_L[],ROUND_KEY_H[]}, [r12]!
+.endif
+	_speck_round_128bytes	\n
+.endif
+	subs		r6, r6, #1
+	bne		.Lnext_round_\@
+
+	// Re-interleave the 'x' and 'y' elements of each block
+.if \n == 64
+	vswp		X0_L, Y0_H
+	vswp		X1_L, Y1_H
+	vswp		X2_L, Y2_H
+	vswp		X3_L, Y3_H
+.else
+	vzip.32		Y0, X0
+	vzip.32		Y1, X1
+	vzip.32		Y2, X2
+	vzip.32		Y3, X3
+.endif
+
+	// XOR the encrypted/decrypted blocks with the tweaks we saved earlier
+	mov		r12, sp
+	vld1.8		{TMP0, TMP1}, [r12:128]!
+	vld1.8		{TMP2, TMP3}, [r12:128]!
+	veor		X0, TMP0
+	veor		Y0, TMP1
+	veor		X1, TMP2
+	veor		Y1, TMP3
+	vld1.8		{TMP0, TMP1}, [r12:128]!
+	vld1.8		{TMP2, TMP3}, [r12:128]!
+	veor		X2, TMP0
+	veor		Y2, TMP1
+	veor		X3, TMP2
+	veor		Y3, TMP3
+
+	// Store the ciphertext in the destination buffer
+	vst1.8		{X0, Y0}, [DST]!
+	vst1.8		{X1, Y1}, [DST]!
+	vst1.8		{X2, Y2}, [DST]!
+	vst1.8		{X3, Y3}, [DST]!
+
+	// Continue if there are more 128-byte chunks remaining, else return
+	subs		NBYTES, #128
+	bne		.Lnext_128bytes_\@
+
+	// Store the next tweak
+.if \n == 64
+	vst1.8		{TWEAKV}, [TWEAK]
+.else
+	vst1.8		{TWEAKV_L}, [TWEAK]
+.endif
+
+	mov		sp, r7
+	pop		{r4-r7}
+	bx		lr
+.endm
+
+ENTRY(speck128_xts_encrypt_neon)
+	_speck_xts_crypt	n=64, decrypting=0
+ENDPROC(speck128_xts_encrypt_neon)
+
+ENTRY(speck128_xts_decrypt_neon)
+	_speck_xts_crypt	n=64, decrypting=1
+ENDPROC(speck128_xts_decrypt_neon)
+
+ENTRY(speck64_xts_encrypt_neon)
+	_speck_xts_crypt	n=32, decrypting=0
+ENDPROC(speck64_xts_encrypt_neon)
+
+ENTRY(speck64_xts_decrypt_neon)
+	_speck_xts_crypt	n=32, decrypting=1
+ENDPROC(speck64_xts_decrypt_neon)
diff --git a/arch/arm/crypto/speck-neon-glue.c b/arch/arm/crypto/speck-neon-glue.c
new file mode 100644
index 00000000..ea36c3a
--- /dev/null
+++ b/arch/arm/crypto/speck-neon-glue.c
@@ -0,0 +1,314 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * NEON-accelerated implementation of Speck128-XTS and Speck64-XTS
+ *
+ * Copyright (c) 2018 Google, Inc
+ *
+ * Note: the NIST recommendation for XTS only specifies a 128-bit block size,
+ * but a 64-bit version (needed for Speck64) is fairly straightforward; the math
+ * is just done in GF(2^64) instead of GF(2^128), with the reducing polynomial
+ * x^64 + x^4 + x^3 + x + 1 from the original XEX paper (Rogaway, 2004:
+ * "Efficient Instantiations of Tweakable Blockciphers and Refinements to Modes
+ * OCB and PMAC"), represented as 0x1B.
+ */
+
+#include <asm/hwcap.h>
+#include <asm/neon.h>
+#include <asm/simd.h>
+#include <crypto/algapi.h>
+#include <crypto/gf128mul.h>
+#include <crypto/speck.h>
+#include <crypto/xts.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+
+/* The assembly functions only handle multiples of 128 bytes */
+#define SPECK_NEON_CHUNK_SIZE	128
+
+/* Speck128 */
+
+struct speck128_xts_tfm_ctx {
+	struct speck128_tfm_ctx main_key;
+	struct speck128_tfm_ctx tweak_key;
+};
+
+asmlinkage void speck128_xts_encrypt_neon(const u64 *round_keys, int nrounds,
+					  void *dst, const void *src,
+					  unsigned int nbytes, void *tweak);
+
+asmlinkage void speck128_xts_decrypt_neon(const u64 *round_keys, int nrounds,
+					  void *dst, const void *src,
+					  unsigned int nbytes, void *tweak);
+
+typedef void (*speck128_crypt_one_t)(const struct speck128_tfm_ctx *,
+				     u8 *, const u8 *);
+typedef void (*speck128_xts_crypt_many_t)(const u64 *, int, void *,
+					  const void *, unsigned int, void *);
+
+static __always_inline int
+__speck128_xts_crypt(struct blkcipher_desc *desc, struct scatterlist *dst,
+		     struct scatterlist *src, unsigned int nbytes,
+		     speck128_crypt_one_t crypt_one,
+		     speck128_xts_crypt_many_t crypt_many)
+{
+	struct crypto_blkcipher *tfm = desc->tfm;
+	const struct speck128_xts_tfm_ctx *ctx = crypto_blkcipher_ctx(tfm);
+	struct blkcipher_walk walk;
+	le128 tweak;
+	int err;
+
+	blkcipher_walk_init(&walk, dst, src, nbytes);
+	err = blkcipher_walk_virt_block(desc, &walk, SPECK_NEON_CHUNK_SIZE);
+
+	crypto_speck128_encrypt(&ctx->tweak_key, (u8 *)&tweak, walk.iv);
+
+	while (walk.nbytes > 0) {
+		unsigned int nbytes = walk.nbytes;
+		u8 *dst = walk.dst.virt.addr;
+		const u8 *src = walk.src.virt.addr;
+
+		if (nbytes >= SPECK_NEON_CHUNK_SIZE && may_use_simd()) {
+			unsigned int count;
+
+			count = round_down(nbytes, SPECK_NEON_CHUNK_SIZE);
+			kernel_neon_begin();
+			(*crypt_many)(ctx->main_key.round_keys,
+				      ctx->main_key.nrounds,
+				      dst, src, count, &tweak);
+			kernel_neon_end();
+			dst += count;
+			src += count;
+			nbytes -= count;
+		}
+
+		/* Handle any remainder with generic code */
+		while (nbytes >= sizeof(tweak)) {
+			le128_xor((le128 *)dst, (const le128 *)src, &tweak);
+			(*crypt_one)(&ctx->main_key, dst, dst);
+			le128_xor((le128 *)dst, (const le128 *)dst, &tweak);
+			gf128mul_x_ble((be128 *)&tweak, (const be128 *)&tweak);
+
+			dst += sizeof(tweak);
+			src += sizeof(tweak);
+			nbytes -= sizeof(tweak);
+		}
+		err = blkcipher_walk_done(desc, &walk, nbytes);
+	}
+
+	return err;
+}
+
+static int speck128_xts_encrypt(struct blkcipher_desc *desc,
+				struct scatterlist *dst,
+				struct scatterlist *src,
+				unsigned int nbytes)
+{
+	return __speck128_xts_crypt(desc, dst, src, nbytes,
+				    crypto_speck128_encrypt,
+				    speck128_xts_encrypt_neon);
+}
+
+static int speck128_xts_decrypt(struct blkcipher_desc *desc,
+				struct scatterlist *dst,
+				struct scatterlist *src,
+				unsigned int nbytes)
+{
+	return __speck128_xts_crypt(desc, dst, src, nbytes,
+				    crypto_speck128_decrypt,
+				    speck128_xts_decrypt_neon);
+}
+
+static int speck128_xts_setkey(struct crypto_tfm *tfm, const u8 *key,
+			       unsigned int keylen)
+{
+	struct speck128_xts_tfm_ctx *ctx = crypto_tfm_ctx(tfm);
+	int err;
+
+	if (keylen % 2)
+		return -EINVAL;
+
+	keylen /= 2;
+
+	err = crypto_speck128_setkey(&ctx->main_key, key, keylen);
+	if (err)
+		return err;
+
+	return crypto_speck128_setkey(&ctx->tweak_key, key + keylen, keylen);
+}
+
+/* Speck64 */
+
+struct speck64_xts_tfm_ctx {
+	struct speck64_tfm_ctx main_key;
+	struct speck64_tfm_ctx tweak_key;
+};
+
+asmlinkage void speck64_xts_encrypt_neon(const u32 *round_keys, int nrounds,
+					 void *dst, const void *src,
+					 unsigned int nbytes, void *tweak);
+
+asmlinkage void speck64_xts_decrypt_neon(const u32 *round_keys, int nrounds,
+					 void *dst, const void *src,
+					 unsigned int nbytes, void *tweak);
+
+typedef void (*speck64_crypt_one_t)(const struct speck64_tfm_ctx *,
+				    u8 *, const u8 *);
+typedef void (*speck64_xts_crypt_many_t)(const u32 *, int, void *,
+					 const void *, unsigned int, void *);
+
+static __always_inline int
+__speck64_xts_crypt(struct blkcipher_desc *desc, struct scatterlist *dst,
+		    struct scatterlist *src, unsigned int nbytes,
+		    speck64_crypt_one_t crypt_one,
+		    speck64_xts_crypt_many_t crypt_many)
+{
+	struct crypto_blkcipher *tfm = desc->tfm;
+	const struct speck64_xts_tfm_ctx *ctx = crypto_blkcipher_ctx(tfm);
+	struct blkcipher_walk walk;
+	__le64 tweak;
+	int err;
+
+	blkcipher_walk_init(&walk, dst, src, nbytes);
+	err = blkcipher_walk_virt_block(desc, &walk, SPECK_NEON_CHUNK_SIZE);
+
+	crypto_speck64_encrypt(&ctx->tweak_key, (u8 *)&tweak, walk.iv);
+
+	while (walk.nbytes > 0) {
+		unsigned int nbytes = walk.nbytes;
+		u8 *dst = walk.dst.virt.addr;
+		const u8 *src = walk.src.virt.addr;
+
+		if (nbytes >= SPECK_NEON_CHUNK_SIZE && may_use_simd()) {
+			unsigned int count;
+
+			count = round_down(nbytes, SPECK_NEON_CHUNK_SIZE);
+			kernel_neon_begin();
+			(*crypt_many)(ctx->main_key.round_keys,
+				      ctx->main_key.nrounds,
+				      dst, src, count, &tweak);
+			kernel_neon_end();
+			dst += count;
+			src += count;
+			nbytes -= count;
+		}
+
+		/* Handle any remainder with generic code */
+		while (nbytes >= sizeof(tweak)) {
+			*(__le64 *)dst = *(__le64 *)src ^ tweak;
+			(*crypt_one)(&ctx->main_key, dst, dst);
+			*(__le64 *)dst ^= tweak;
+			tweak = cpu_to_le64((le64_to_cpu(tweak) << 1) ^
+					    ((tweak & cpu_to_le64(1ULL << 63)) ?
+					     0x1B : 0));
+			dst += sizeof(tweak);
+			src += sizeof(tweak);
+			nbytes -= sizeof(tweak);
+		}
+		err = blkcipher_walk_done(desc, &walk, nbytes);
+	}
+
+	return err;
+}
+
+static int speck64_xts_encrypt(struct blkcipher_desc *desc,
+			       struct scatterlist *dst, struct scatterlist *src,
+			       unsigned int nbytes)
+{
+	return __speck64_xts_crypt(desc, dst, src, nbytes,
+				   crypto_speck64_encrypt,
+				   speck64_xts_encrypt_neon);
+}
+
+static int speck64_xts_decrypt(struct blkcipher_desc *desc,
+			       struct scatterlist *dst, struct scatterlist *src,
+			       unsigned int nbytes)
+{
+	return __speck64_xts_crypt(desc, dst, src, nbytes,
+				   crypto_speck64_decrypt,
+				   speck64_xts_decrypt_neon);
+}
+
+static int speck64_xts_setkey(struct crypto_tfm *tfm, const u8 *key,
+			      unsigned int keylen)
+{
+	struct speck64_xts_tfm_ctx *ctx = crypto_tfm_ctx(tfm);
+	int err;
+
+	if (keylen % 2)
+		return -EINVAL;
+
+	keylen /= 2;
+
+	err = crypto_speck64_setkey(&ctx->main_key, key, keylen);
+	if (err)
+		return err;
+
+	return crypto_speck64_setkey(&ctx->tweak_key, key + keylen, keylen);
+}
+
+static struct crypto_alg speck_algs[] = {
+	{
+		.cra_name		= "xts(speck128)",
+		.cra_driver_name	= "xts-speck128-neon",
+		.cra_priority		= 300,
+		.cra_flags		= CRYPTO_ALG_TYPE_BLKCIPHER,
+		.cra_blocksize		= SPECK128_BLOCK_SIZE,
+		.cra_type		= &crypto_blkcipher_type,
+		.cra_ctxsize		= sizeof(struct speck128_xts_tfm_ctx),
+		.cra_alignmask		= 7,
+		.cra_module		= THIS_MODULE,
+		.cra_u = {
+			.blkcipher = {
+				.min_keysize		= 2 * SPECK128_128_KEY_SIZE,
+				.max_keysize		= 2 * SPECK128_256_KEY_SIZE,
+				.ivsize			= SPECK128_BLOCK_SIZE,
+				.setkey			= speck128_xts_setkey,
+				.encrypt		= speck128_xts_encrypt,
+				.decrypt		= speck128_xts_decrypt,
+			}
+		}
+	}, {
+		.cra_name		= "xts(speck64)",
+		.cra_driver_name	= "xts-speck64-neon",
+		.cra_priority		= 300,
+		.cra_flags		= CRYPTO_ALG_TYPE_BLKCIPHER,
+		.cra_blocksize		= SPECK64_BLOCK_SIZE,
+		.cra_type		= &crypto_blkcipher_type,
+		.cra_ctxsize		= sizeof(struct speck64_xts_tfm_ctx),
+		.cra_alignmask		= 7,
+		.cra_module		= THIS_MODULE,
+		.cra_u = {
+			.blkcipher = {
+				.min_keysize		= 2 * SPECK64_96_KEY_SIZE,
+				.max_keysize		= 2 * SPECK64_128_KEY_SIZE,
+				.ivsize			= SPECK64_BLOCK_SIZE,
+				.setkey			= speck64_xts_setkey,
+				.encrypt		= speck64_xts_encrypt,
+				.decrypt		= speck64_xts_decrypt,
+			}
+		}
+	}
+};
+
+static int __init speck_neon_module_init(void)
+{
+	if (!(elf_hwcap & HWCAP_NEON))
+		return -ENODEV;
+	return crypto_register_algs(speck_algs, ARRAY_SIZE(speck_algs));
+}
+
+static void __exit speck_neon_module_exit(void)
+{
+	crypto_unregister_algs(speck_algs, ARRAY_SIZE(speck_algs));
+}
+
+module_init(speck_neon_module_init);
+module_exit(speck_neon_module_exit);
+
+MODULE_DESCRIPTION("Speck block cipher (NEON-accelerated)");
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Eric Biggers <ebiggers@google.com>");
+MODULE_ALIAS_CRYPTO("xts(speck128)");
+MODULE_ALIAS_CRYPTO("xts-speck128-neon");
+MODULE_ALIAS_CRYPTO("xts(speck64)");
+MODULE_ALIAS_CRYPTO("xts-speck64-neon");
diff --git a/arch/arm/include/asm/arm_pmuv3.h b/arch/arm/include/asm/arm_pmuv3.h
new file mode 100644
index 00000000..e0f66c1
--- /dev/null
+++ b/arch/arm/include/asm/arm_pmuv3.h
@@ -0,0 +1,125 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (C) 2012 ARM Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __ASM_PMUV3_H
+#define __ASM_PMUV3_H
+
+#include <asm/cp15.h>
+#include <asm/cputype.h>
+
+#define PMCCNTR		__ACCESS_CP15_64(0, c9)
+
+#define PMCR		__ACCESS_CP15(c9, 0, c12, 0)
+#define PMCNTENSET	__ACCESS_CP15(c9, 0, c12, 1)
+#define PMCNTENCLR	__ACCESS_CP15(c9, 0, c12, 2)
+#define PMOVSR		__ACCESS_CP15(c9, 0, c12, 3)
+#define PMSELR		__ACCESS_CP15(c9, 0, c12, 5)
+#define PMCEID0		__ACCESS_CP15(c9, 0, c12, 6)
+#define PMCEID1		__ACCESS_CP15(c9, 0, c12, 7)
+#define PMXEVTYPER	__ACCESS_CP15(c9, 0, c13, 1)
+#define PMXEVCNTR	__ACCESS_CP15(c9, 0, c13, 2)
+#define PMINTENSET	__ACCESS_CP15(c9, 0, c14, 1)
+#define PMINTENCLR	__ACCESS_CP15(c9, 0, c14, 2)
+
+static inline int read_pmuver(void)
+{
+	/* PMUVers is not a signed field */
+	u32 dfr0 = read_cpuid_ext(CPUID_EXT_DFR0);
+	return (dfr0 >> 24) & 0xf;
+}
+
+static inline void write_pmcr(u32 val)
+{
+	write_sysreg(val, PMCR);
+}
+
+static inline u32 read_pmcr(void)
+{
+	return read_sysreg(PMCR);
+}
+
+static inline void write_pmselr(u32 val)
+{
+	write_sysreg(val, PMSELR);
+}
+
+static inline void write_pmccntr(u64 val)
+{
+	write_sysreg(val, PMCCNTR);
+}
+
+static inline u64 read_pmccntr(void)
+{
+	return read_sysreg(PMCCNTR);
+}
+
+static inline void write_pmxevcntr(u32 val)
+{
+	write_sysreg(val, PMXEVCNTR);
+}
+
+static inline u32 read_pmxevcntr(void)
+{
+	return read_sysreg(PMXEVCNTR);
+}
+
+static inline void write_pmxevtyper(u32 val)
+{
+	write_sysreg(val, PMXEVTYPER);
+}
+
+static inline void write_pmcntenset(u32 val)
+{
+	write_sysreg(val, PMCNTENSET);
+}
+
+static inline void write_pmcntenclr(u32 val)
+{
+	write_sysreg(val, PMCNTENCLR);
+}
+
+static inline void write_pmintenset(u32 val)
+{
+	write_sysreg(val, PMINTENSET);
+}
+
+static inline void write_pmintenclr(u32 val)
+{
+	write_sysreg(val, PMINTENCLR);
+}
+
+static inline void write_pmovsclr(u32 val)
+{
+	write_sysreg(val, PMOVSR);
+}
+
+static inline u32 read_pmovsclr(void)
+{
+	return read_sysreg(PMOVSR);
+}
+
+static inline u32 read_pmceid0(void)
+{
+	return read_sysreg(PMCEID0);
+}
+
+static inline u32 read_pmceid1(void)
+{
+	return read_sysreg(PMCEID1);
+}
+
+#endif
diff --git a/arch/arm/include/asm/barrier.h b/arch/arm/include/asm/barrier.h
index f5d6981..2ee92a8 100644
--- a/arch/arm/include/asm/barrier.h
+++ b/arch/arm/include/asm/barrier.h
@@ -3,6 +3,10 @@
 
 #ifndef __ASSEMBLY__
 
+#ifdef CONFIG_RTK_RBUS_BARRIER
+extern void rtk_bus_sync(void);
+#endif /* CONFIG_RTK_RBUS_BARRIER */
+
 #define nop() __asm__ __volatile__("mov\tr0,r0\t@ nop\n\t");
 
 #if __LINUX_ARM_ARCH__ >= 7 ||		\
@@ -47,7 +51,11 @@
 #if defined(CONFIG_ARM_DMA_MEM_BUFFERABLE) || defined(CONFIG_SMP)
 #define mb()		__arm_heavy_mb()
 #define rmb()		dsb()
+#ifdef CONFIG_RTK_RBUS_BARRIER
+#define wmb()		do { __arm_heavy_mb(st); rtk_bus_sync(); } while (0)
+#else
 #define wmb()		__arm_heavy_mb(st)
+#endif /* CONFIG_RTK_RBUS_BARRIER */
 #define dma_rmb()	dmb(osh)
 #define dma_wmb()	dmb(oshst)
 #else
diff --git a/arch/arm/include/asm/elf.h b/arch/arm/include/asm/elf.h
index f13ae15..d2315ff 100644
--- a/arch/arm/include/asm/elf.h
+++ b/arch/arm/include/asm/elf.h
@@ -112,8 +112,12 @@
 #define CORE_DUMP_USE_REGSET
 #define ELF_EXEC_PAGESIZE	4096
 
-/* This is the base location for PIE (ET_DYN with INTERP) loads. */
-#define ELF_ET_DYN_BASE		0x400000UL
+/* This is the location that an ET_DYN program is loaded if exec'ed.  Typical
+   use of this is to invoke "./ld.so someprog" to test out a new version of
+   the loader.  We need to make sure that it is out of the way of the program
+   that it will "exec", and that there is sufficient room for the brk.  */
+
+#define ELF_ET_DYN_BASE	(TASK_SIZE / 3 * 2)
 
 /* When the program starts, a1 contains a pointer to a function to be 
    registered with atexit, as per the SVR4 ABI.  A value of 0 means we 
diff --git a/arch/arm/include/asm/fiq_glue.h b/arch/arm/include/asm/fiq_glue.h
new file mode 100644
index 00000000..a9e244f9
--- /dev/null
+++ b/arch/arm/include/asm/fiq_glue.h
@@ -0,0 +1,33 @@
+/*
+ * Copyright (C) 2010 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef __ASM_FIQ_GLUE_H
+#define __ASM_FIQ_GLUE_H
+
+struct fiq_glue_handler {
+	void (*fiq)(struct fiq_glue_handler *h, void *regs, void *svc_sp);
+	void (*resume)(struct fiq_glue_handler *h);
+};
+typedef void (*fiq_return_handler_t)(void);
+
+int fiq_glue_register_handler(struct fiq_glue_handler *handler);
+int fiq_glue_set_return_handler(fiq_return_handler_t fiq_return);
+int fiq_glue_clear_return_handler(fiq_return_handler_t fiq_return);
+
+#ifdef CONFIG_FIQ_GLUE
+void fiq_glue_resume(void);
+#else
+static inline void fiq_glue_resume(void) {}
+#endif
+
+#endif
diff --git a/arch/arm/include/asm/hardware/debug-8250.S b/arch/arm/include/asm/hardware/debug-8250.S
new file mode 100644
index 00000000..22c6892
--- /dev/null
+++ b/arch/arm/include/asm/hardware/debug-8250.S
@@ -0,0 +1,29 @@
+/*
+ * arch/arm/include/asm/hardware/debug-8250.S
+ *
+ *  Copyright (C) 1994-1999 Russell King
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#include <linux/serial_reg.h>
+
+		.macro	senduart,rd,rx
+		strb	\rd, [\rx, #UART_TX << UART_SHIFT]
+		.endm
+
+		.macro	busyuart,rd,rx
+1002:		ldrb	\rd, [\rx, #UART_LSR << UART_SHIFT]
+		and	\rd, \rd, #UART_LSR_TEMT | UART_LSR_THRE
+		teq	\rd, #UART_LSR_TEMT | UART_LSR_THRE
+		bne	1002b
+		.endm
+
+		.macro	waituart,rd,rx
+#ifdef FLOW_CONTROL
+1001:		ldrb	\rd, [\rx, #UART_MSR << UART_SHIFT]
+		tst	\rd, #UART_MSR_CTS
+		beq	1001b
+#endif
+		.endm
diff --git a/arch/arm/include/asm/io.h b/arch/arm/include/asm/io.h
index 021692c..d2de67e 100644
--- a/arch/arm/include/asm/io.h
+++ b/arch/arm/include/asm/io.h
@@ -296,6 +296,22 @@ static inline void pci_ioremap_set_mem_type(int mem_type) {}
 #define writew_relaxed(v,c)	__raw_writew((__force u16) cpu_to_le16(v),c)
 #define writel_relaxed(v,c)	__raw_writel((__force u32) cpu_to_le32(v),c)
 
+#define readb_relaxed_no_log(c) readb_relaxed(c)
+#define readw_relaxed_no_log(c) readw_relaxed(c)
+#define readl_relaxed_no_log(c) readl_relaxed(c)
+
+#define writeb_relaxed_no_log(v, c)     writeb_relaxed(v,c)
+#define writew_relaxed_no_log(v, c)     writew_relaxed(v,c)
+#define writel_relaxed_no_log(v, c)     writel_relaxed(v,c)
+
+#define readb_no_log(c)         ({ u8  __v = readb_relaxed_no_log(c); __iormb(); __v; })
+#define readw_no_log(c)         ({ u16 __v = readw_relaxed_no_log(c); __iormb(); __v; })
+#define readl_no_log(c)         ({ u32 __v = readl_relaxed_no_log(c); __iormb(); __v; })
+
+#define writeb_no_log(v, c)     ({ __iowmb(); writeb_relaxed_no_log((v), (c)); })
+#define writew_no_log(v, c)     ({ __iowmb(); writew_relaxed_no_log((v), (c)); })
+#define writel_no_log(v, c)     ({ __iowmb(); writel_relaxed_no_log((v), (c)); })
+
 #define readb(c)		({ u8  __v = readb_relaxed(c); __iormb(); __v; })
 #define readw(c)		({ u16 __v = readw_relaxed(c); __iormb(); __v; })
 #define readl(c)		({ u32 __v = readl_relaxed(c); __iormb(); __v; })
diff --git a/arch/arm/include/asm/irq.h b/arch/arm/include/asm/irq.h
index e53638c..99e43fe 100644
--- a/arch/arm/include/asm/irq.h
+++ b/arch/arm/include/asm/irq.h
@@ -3,11 +3,16 @@
 
 #define NR_IRQS_LEGACY	16
 
+
+#ifdef CONFIG_ARCH_RTD119X
+#include <mach/irqs.h>
+#else
 #ifndef CONFIG_SPARSE_IRQ
 #include <mach/irqs.h>
 #else
 #define NR_IRQS NR_IRQS_LEGACY
 #endif
+#endif
 
 #ifndef irq_canonicalize
 #define irq_canonicalize(i)	(i)
diff --git a/arch/arm/include/asm/pgtable-2level-hwdef.h b/arch/arm/include/asm/pgtable-2level-hwdef.h
index 3f82e9d..526de23 100644
--- a/arch/arm/include/asm/pgtable-2level-hwdef.h
+++ b/arch/arm/include/asm/pgtable-2level-hwdef.h
@@ -39,6 +39,7 @@
 #define PMD_SECT_S		(_AT(pmdval_t, 1) << 16)	/* v6 */
 #define PMD_SECT_nG		(_AT(pmdval_t, 1) << 17)	/* v6 */
 #define PMD_SECT_SUPER		(_AT(pmdval_t, 1) << 18)	/* v6 */
+#define PMD_SECT_NS		(_AT(pmdval_t, 1) << 19)	/* v6 */
 #define PMD_SECT_AF		(_AT(pmdval_t, 0))
 
 #define PMD_SECT_UNCACHED	(_AT(pmdval_t, 0))
diff --git a/arch/arm/include/asm/topology.h b/arch/arm/include/asm/topology.h
index 370f7a7..4e9b957 100644
--- a/arch/arm/include/asm/topology.h
+++ b/arch/arm/include/asm/topology.h
@@ -3,6 +3,7 @@
 
 #ifdef CONFIG_ARM_CPU_TOPOLOGY
 
+#include <linux/cpufreq.h>
 #include <linux/cpumask.h>
 
 struct cputopo_arm {
@@ -24,6 +25,14 @@ struct cputopo_arm {
 void store_cpu_topology(unsigned int cpuid);
 const struct cpumask *cpu_coregroup_mask(int cpu);
 
+#ifdef CONFIG_CPU_FREQ
+#define arch_scale_freq_capacity cpufreq_scale_freq_capacity
+#define arch_scale_max_freq_capacity cpufreq_scale_max_freq_capacity
+#define arch_scale_min_freq_capacity cpufreq_scale_min_freq_capacity
+#endif
+#define arch_scale_cpu_capacity scale_cpu_capacity
+extern unsigned long scale_cpu_capacity(struct sched_domain *sd, int cpu);
+
 #else
 
 static inline void init_cpu_topology(void) { }
diff --git a/arch/arm/include/asm/traps.h b/arch/arm/include/asm/traps.h
index f555bb3..683d923 100644
--- a/arch/arm/include/asm/traps.h
+++ b/arch/arm/include/asm/traps.h
@@ -18,7 +18,6 @@ struct undef_hook {
 void register_undef_hook(struct undef_hook *hook);
 void unregister_undef_hook(struct undef_hook *hook);
 
-#ifdef CONFIG_FUNCTION_GRAPH_TRACER
 static inline int __in_irqentry_text(unsigned long ptr)
 {
 	extern char __irqentry_text_start[];
@@ -27,12 +26,6 @@ static inline int __in_irqentry_text(unsigned long ptr)
 	return ptr >= (unsigned long)&__irqentry_text_start &&
 	       ptr < (unsigned long)&__irqentry_text_end;
 }
-#else
-static inline int __in_irqentry_text(unsigned long ptr)
-{
-	return 0;
-}
-#endif
 
 static inline int in_exception_text(unsigned long ptr)
 {
diff --git a/arch/arm/include/asm/xen/hypercall.h b/arch/arm/include/asm/xen/hypercall.h
index 9d874db..96e6859 100644
--- a/arch/arm/include/asm/xen/hypercall.h
+++ b/arch/arm/include/asm/xen/hypercall.h
@@ -60,6 +60,9 @@ static inline int HYPERVISOR_platform_op(struct xen_platform_op *op)
 	return HYPERVISOR_platform_op_raw(op);
 }
 int HYPERVISOR_multicall(struct multicall_entry *calls, uint32_t nr);
+#ifdef CONFIG_RTK_XEN_HYPERCALL
+int HYPERVISOR_rtk_hypercall_op(unsigned int cmd, void *arg);
+#endif
 
 static inline int
 HYPERVISOR_suspend(unsigned long start_info_mfn)
diff --git a/arch/arm/include/uapi/asm/setup.h b/arch/arm/include/uapi/asm/setup.h
index 979ff40..b4d1bea 100644
--- a/arch/arm/include/uapi/asm/setup.h
+++ b/arch/arm/include/uapi/asm/setup.h
@@ -16,7 +16,7 @@
 
 #include <linux/types.h>
 
-#define COMMAND_LINE_SIZE 1024
+#define COMMAND_LINE_SIZE 2048
 
 /* The list ends with an ATAG_NONE node. */
 #define ATAG_NONE	0x00000000
diff --git a/arch/arm/kernel/head.S b/arch/arm/kernel/head.S
index 04286fd..47e7e05 100644
--- a/arch/arm/kernel/head.S
+++ b/arch/arm/kernel/head.S
@@ -23,6 +23,10 @@
 #include <asm/thread_info.h>
 #include <asm/pgtable.h>
 
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD13xx) || defined(CONFIG_ARCH_RTD129x)
+#define SCTLR_U    (1 << 20)       /* Unprivileged write permission implies PL1 Execute Never (XN) */
+#endif
+
 #if defined(CONFIG_DEBUG_LL) && !defined(CONFIG_DEBUG_SEMIHOSTING)
 #include CONFIG_DEBUG_LL_INCLUDE
 #endif
@@ -461,6 +465,9 @@ __enable_mmu:
 #ifdef CONFIG_CPU_ICACHE_DISABLE
 	bic	r0, r0, #CR_I
 #endif
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD13xx) || defined(CONFIG_ARCH_RTD129x)
+	bic	r0, r0, #SCTLR_U
+#endif
 #ifdef CONFIG_ARM_LPAE
 	mcrr	p15, 0, r4, r5, c2		@ load TTBR0
 #else
diff --git a/arch/arm/kernel/kgdb.c b/arch/arm/kernel/kgdb.c
index 9232cae..f3c6622 100644
--- a/arch/arm/kernel/kgdb.c
+++ b/arch/arm/kernel/kgdb.c
@@ -140,6 +140,8 @@ int kgdb_arch_handle_exception(int exception_vector, int signo,
 
 static int kgdb_brk_fn(struct pt_regs *regs, unsigned int instr)
 {
+	if (user_mode(regs))
+		return -1;
 	kgdb_handle_exception(1, SIGTRAP, 0, regs);
 
 	return 0;
@@ -147,6 +149,8 @@ static int kgdb_brk_fn(struct pt_regs *regs, unsigned int instr)
 
 static int kgdb_compiled_brk_fn(struct pt_regs *regs, unsigned int instr)
 {
+	if (user_mode(regs))
+		return -1;
 	compiled_break = 1;
 	kgdb_handle_exception(1, SIGTRAP, 0, regs);
 
diff --git a/arch/arm/kernel/process.c b/arch/arm/kernel/process.c
index 91d2d5b..369928c 100644
--- a/arch/arm/kernel/process.c
+++ b/arch/arm/kernel/process.c
@@ -91,6 +91,77 @@ void arch_cpu_idle_exit(void)
 	ledtrig_cpu(CPU_LED_IDLE_END);
 }
 
+/*
+ * dump a block of kernel memory from around the given address
+ */
+static void show_data(unsigned long addr, int nbytes, const char *name)
+{
+	int	i, j;
+	int	nlines;
+	u32	*p;
+
+	/*
+	 * don't attempt to dump non-kernel addresses or
+	 * values that are probably just small negative numbers
+	 */
+	if (addr < PAGE_OFFSET || addr > -256UL)
+		return;
+
+	printk("\n%s: %#lx:\n", name, addr);
+
+	/*
+	 * round address down to a 32 bit boundary
+	 * and always dump a multiple of 32 bytes
+	 */
+	p = (u32 *)(addr & ~(sizeof(u32) - 1));
+	nbytes += (addr & (sizeof(u32) - 1));
+	nlines = (nbytes + 31) / 32;
+
+
+	for (i = 0; i < nlines; i++) {
+		/*
+		 * just display low 16 bits of address to keep
+		 * each line of the dump < 80 characters
+		 */
+		printk("%04lx ", (unsigned long)p & 0xffff);
+		for (j = 0; j < 8; j++) {
+			u32	data;
+			if (probe_kernel_address(p, data)) {
+				pr_cont(" ********");
+			} else {
+				pr_cont(" %08x", data);
+			}
+			++p;
+		}
+		pr_cont("\n");
+	}
+}
+
+static void show_extra_register_data(struct pt_regs *regs, int nbytes)
+{
+	mm_segment_t fs;
+
+	fs = get_fs();
+	set_fs(KERNEL_DS);
+	show_data(regs->ARM_pc - nbytes, nbytes * 2, "PC");
+	show_data(regs->ARM_lr - nbytes, nbytes * 2, "LR");
+	show_data(regs->ARM_sp - nbytes, nbytes * 2, "SP");
+	show_data(regs->ARM_ip - nbytes, nbytes * 2, "IP");
+	show_data(regs->ARM_fp - nbytes, nbytes * 2, "FP");
+	show_data(regs->ARM_r0 - nbytes, nbytes * 2, "R0");
+	show_data(regs->ARM_r1 - nbytes, nbytes * 2, "R1");
+	show_data(regs->ARM_r2 - nbytes, nbytes * 2, "R2");
+	show_data(regs->ARM_r3 - nbytes, nbytes * 2, "R3");
+	show_data(regs->ARM_r4 - nbytes, nbytes * 2, "R4");
+	show_data(regs->ARM_r5 - nbytes, nbytes * 2, "R5");
+	show_data(regs->ARM_r6 - nbytes, nbytes * 2, "R6");
+	show_data(regs->ARM_r7 - nbytes, nbytes * 2, "R7");
+	show_data(regs->ARM_r8 - nbytes, nbytes * 2, "R8");
+	show_data(regs->ARM_r9 - nbytes, nbytes * 2, "R9");
+	show_data(regs->ARM_r10 - nbytes, nbytes * 2, "R10");
+	set_fs(fs);
+}
+
 void __show_regs(struct pt_regs *regs)
 {
 	unsigned long flags;
@@ -182,6 +253,8 @@ void __show_regs(struct pt_regs *regs)
 		printk("Control: %08x%s\n", ctrl, buf);
 	}
 #endif
+
+	show_extra_register_data(regs, 128);
 }
 
 void show_regs(struct pt_regs * regs)
diff --git a/arch/arm/kernel/reboot.c b/arch/arm/kernel/reboot.c
index 3fa867a..d704df8 100644
--- a/arch/arm/kernel/reboot.c
+++ b/arch/arm/kernel/reboot.c
@@ -6,6 +6,7 @@
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation.
  */
+#include <linux/console.h>
 #include <linux/cpu.h>
 #include <linux/delay.h>
 #include <linux/reboot.h>
@@ -122,6 +123,31 @@ void machine_power_off(void)
 		pm_power_off();
 }
 
+#ifdef CONFIG_ARM_FLUSH_CONSOLE_ON_RESTART
+void arm_machine_flush_console(void)
+{
+	printk("\n");
+	pr_emerg("Restarting %s\n", linux_banner);
+	if (console_trylock()) {
+		console_unlock();
+		return;
+	}
+
+	mdelay(50);
+
+	local_irq_disable();
+	if (!console_trylock())
+		pr_emerg("arm_restart: Console was locked! Busting\n");
+	else
+		pr_emerg("arm_restart: Console was locked!\n");
+	console_unlock();
+}
+#else
+void arm_machine_flush_console(void)
+{
+}
+#endif
+
 /*
  * Restart requires that the secondary CPUs stop performing any activity
  * while the primary CPU resets the system. Systems with a single CPU can
@@ -138,6 +164,10 @@ void machine_restart(char *cmd)
 	local_irq_disable();
 	smp_send_stop();
 
+	/* Flush the console to make sure all the relevant messages make it
+	 * out to the console drivers */
+	arm_machine_flush_console();
+
 	if (arm_pm_restart)
 		arm_pm_restart(reboot_mode, cmd);
 	else
diff --git a/arch/arm/kernel/topology.c b/arch/arm/kernel/topology.c
index ec279d1..07b0812 100644
--- a/arch/arm/kernel/topology.c
+++ b/arch/arm/kernel/topology.c
@@ -42,7 +42,7 @@
  */
 static DEFINE_PER_CPU(unsigned long, cpu_scale) = SCHED_CAPACITY_SCALE;
 
-unsigned long arch_scale_cpu_capacity(struct sched_domain *sd, int cpu)
+unsigned long scale_cpu_capacity(struct sched_domain *sd, int cpu)
 {
 	return per_cpu(cpu_scale, cpu);
 }
@@ -153,6 +153,8 @@ static void __init parse_dt_topology(void)
 
 }
 
+static const struct sched_group_energy * const cpu_core_energy(int cpu);
+
 /*
  * Look for a customed capacity of a CPU in the cpu_capacity table during the
  * boot. The update of all CPUs is in O(n^2) for heteregeneous system but the
@@ -160,10 +162,14 @@ static void __init parse_dt_topology(void)
  */
 static void update_cpu_capacity(unsigned int cpu)
 {
-	if (!cpu_capacity(cpu))
-		return;
+	unsigned long capacity = SCHED_CAPACITY_SCALE;
 
-	set_capacity_scale(cpu, cpu_capacity(cpu) / middle_capacity);
+	if (cpu_core_energy(cpu)) {
+		int max_cap_idx = cpu_core_energy(cpu)->nr_cap_states - 1;
+		capacity = cpu_core_energy(cpu)->cap_states[max_cap_idx].cap;
+	}
+
+	set_capacity_scale(cpu, capacity);
 
 	pr_info("CPU%u: update cpu_capacity %lu\n",
 		cpu, arch_scale_cpu_capacity(NULL, cpu));
@@ -275,17 +281,138 @@ void store_cpu_topology(unsigned int cpuid)
 		cpu_topology[cpuid].socket_id, mpidr);
 }
 
+/*
+ * ARM TC2 specific energy cost model data. There are no unit requirements for
+ * the data. Data can be normalized to any reference point, but the
+ * normalization must be consistent. That is, one bogo-joule/watt must be the
+ * same quantity for all data, but we don't care what it is.
+ */
+static struct idle_state idle_states_cluster_a7[] = {
+	 { .power = 25 }, /* arch_cpu_idle() (active idle) = WFI */
+	 { .power = 25 }, /* WFI */
+	 { .power = 10 }, /* cluster-sleep-l */
+	};
+
+static struct idle_state idle_states_cluster_a15[] = {
+	 { .power = 70 }, /* arch_cpu_idle() (active idle) = WFI */
+	 { .power = 70 }, /* WFI */
+	 { .power = 25 }, /* cluster-sleep-b */
+	};
+
+static struct capacity_state cap_states_cluster_a7[] = {
+	/* Cluster only power */
+	 { .cap =  150, .power = 2967, }, /*  350 MHz */
+	 { .cap =  172, .power = 2792, }, /*  400 MHz */
+	 { .cap =  215, .power = 2810, }, /*  500 MHz */
+	 { .cap =  258, .power = 2815, }, /*  600 MHz */
+	 { .cap =  301, .power = 2919, }, /*  700 MHz */
+	 { .cap =  344, .power = 2847, }, /*  800 MHz */
+	 { .cap =  387, .power = 3917, }, /*  900 MHz */
+	 { .cap =  430, .power = 4905, }, /* 1000 MHz */
+	};
+
+static struct capacity_state cap_states_cluster_a15[] = {
+	/* Cluster only power */
+	 { .cap =  426, .power =  7920, }, /*  500 MHz */
+	 { .cap =  512, .power =  8165, }, /*  600 MHz */
+	 { .cap =  597, .power =  8172, }, /*  700 MHz */
+	 { .cap =  682, .power =  8195, }, /*  800 MHz */
+	 { .cap =  768, .power =  8265, }, /*  900 MHz */
+	 { .cap =  853, .power =  8446, }, /* 1000 MHz */
+	 { .cap =  938, .power = 11426, }, /* 1100 MHz */
+	 { .cap = 1024, .power = 15200, }, /* 1200 MHz */
+	};
+
+static struct sched_group_energy energy_cluster_a7 = {
+	  .nr_idle_states = ARRAY_SIZE(idle_states_cluster_a7),
+	  .idle_states    = idle_states_cluster_a7,
+	  .nr_cap_states  = ARRAY_SIZE(cap_states_cluster_a7),
+	  .cap_states     = cap_states_cluster_a7,
+};
+
+static struct sched_group_energy energy_cluster_a15 = {
+	  .nr_idle_states = ARRAY_SIZE(idle_states_cluster_a15),
+	  .idle_states    = idle_states_cluster_a15,
+	  .nr_cap_states  = ARRAY_SIZE(cap_states_cluster_a15),
+	  .cap_states     = cap_states_cluster_a15,
+};
+
+static struct idle_state idle_states_core_a7[] = {
+	 { .power = 0 }, /* arch_cpu_idle (active idle) = WFI */
+	 { .power = 0 }, /* WFI */
+	 { .power = 0 }, /* cluster-sleep-l */
+	};
+
+static struct idle_state idle_states_core_a15[] = {
+	 { .power = 0 }, /* arch_cpu_idle (active idle) = WFI */
+	 { .power = 0 }, /* WFI */
+	 { .power = 0 }, /* cluster-sleep-b */
+	};
+
+static struct capacity_state cap_states_core_a7[] = {
+	/* Power per cpu */
+	 { .cap =  150, .power =  187, }, /*  350 MHz */
+	 { .cap =  172, .power =  275, }, /*  400 MHz */
+	 { .cap =  215, .power =  334, }, /*  500 MHz */
+	 { .cap =  258, .power =  407, }, /*  600 MHz */
+	 { .cap =  301, .power =  447, }, /*  700 MHz */
+	 { .cap =  344, .power =  549, }, /*  800 MHz */
+	 { .cap =  387, .power =  761, }, /*  900 MHz */
+	 { .cap =  430, .power = 1024, }, /* 1000 MHz */
+	};
+
+static struct capacity_state cap_states_core_a15[] = {
+	/* Power per cpu */
+	 { .cap =  426, .power = 2021, }, /*  500 MHz */
+	 { .cap =  512, .power = 2312, }, /*  600 MHz */
+	 { .cap =  597, .power = 2756, }, /*  700 MHz */
+	 { .cap =  682, .power = 3125, }, /*  800 MHz */
+	 { .cap =  768, .power = 3524, }, /*  900 MHz */
+	 { .cap =  853, .power = 3846, }, /* 1000 MHz */
+	 { .cap =  938, .power = 5177, }, /* 1100 MHz */
+	 { .cap = 1024, .power = 6997, }, /* 1200 MHz */
+	};
+
+static struct sched_group_energy energy_core_a7 = {
+	  .nr_idle_states = ARRAY_SIZE(idle_states_core_a7),
+	  .idle_states    = idle_states_core_a7,
+	  .nr_cap_states  = ARRAY_SIZE(cap_states_core_a7),
+	  .cap_states     = cap_states_core_a7,
+};
+
+static struct sched_group_energy energy_core_a15 = {
+	  .nr_idle_states = ARRAY_SIZE(idle_states_core_a15),
+	  .idle_states    = idle_states_core_a15,
+	  .nr_cap_states  = ARRAY_SIZE(cap_states_core_a15),
+	  .cap_states     = cap_states_core_a15,
+};
+
+/* sd energy functions */
+static inline
+const struct sched_group_energy * const cpu_cluster_energy(int cpu)
+{
+	return cpu_topology[cpu].socket_id ? &energy_cluster_a7 :
+			&energy_cluster_a15;
+}
+
+static inline
+const struct sched_group_energy * const cpu_core_energy(int cpu)
+{
+	return cpu_topology[cpu].socket_id ? &energy_core_a7 :
+			&energy_core_a15;
+}
+
 static inline int cpu_corepower_flags(void)
 {
-	return SD_SHARE_PKG_RESOURCES  | SD_SHARE_POWERDOMAIN;
+	return SD_SHARE_PKG_RESOURCES  | SD_SHARE_POWERDOMAIN | \
+	       SD_SHARE_CAP_STATES;
 }
 
 static struct sched_domain_topology_level arm_topology[] = {
 #ifdef CONFIG_SCHED_MC
-	{ cpu_corepower_mask, cpu_corepower_flags, SD_INIT_NAME(GMC) },
-	{ cpu_coregroup_mask, cpu_core_flags, SD_INIT_NAME(MC) },
+	{ cpu_coregroup_mask, cpu_corepower_flags, cpu_core_energy, SD_INIT_NAME(MC) },
 #endif
-	{ cpu_cpu_mask, SD_INIT_NAME(DIE) },
+	{ cpu_cpu_mask, NULL, cpu_cluster_energy, SD_INIT_NAME(DIE) },
 	{ NULL, },
 };
 
diff --git a/arch/arm/mach-rtd119x/Kconfig b/arch/arm/mach-rtd119x/Kconfig
new file mode 100644
index 00000000..1c6ca69
--- /dev/null
+++ b/arch/arm/mach-rtd119x/Kconfig
@@ -0,0 +1,26 @@
+config ARCH_RTD119X
+	bool "Realtek RTD119x family"
+	select ARM_GIC
+	select ARM_AMBA
+	select CLKDEV_LOOKUP
+	select CPU_V7
+	select HAVE_SMP
+	select HAVE_MACH_CLKDEV
+	select GENERIC_CLOCKEVENTS
+	select NEED_MACH_MEMORY_H
+	select ARM_PATCH_PHYS_VIRT
+	select ZONE_DMA
+	select HAVE_SCHED_CLOCK
+	select ARCH_HAS_CPUFREQ
+	select CLKSRC_OF
+	select ARCH_REQUIRE_GPIOLIB
+	select GENERIC_IRQ_CHIP
+	select IRQ_DOMAIN
+	select PINCTRL
+	select COMMON_CLK
+	select ARCH_HAS_BARRIERS
+	select SPARSE_IRQ
+	select RTK_PLATFORM
+	select PM_OPP
+	help
+	  Support for Realtek RTD119x family.
diff --git a/arch/arm/mach-rtd119x/Makefile b/arch/arm/mach-rtd119x/Makefile
new file mode 100644
index 00000000..030c67a
--- /dev/null
+++ b/arch/arm/mach-rtd119x/Makefile
@@ -0,0 +1,4 @@
+ccflags-$(CONFIG_ARCH_RTD119X)	:= -I$(srctree)
+
+obj-$(CONFIG_ARCH_RTD119X)	+= rtd119x.o 
+obj-$(CONFIG_SMP)		+= platsmp.o headsmp.o
diff --git a/arch/arm/mach-rtd119x/Makefile.boot b/arch/arm/mach-rtd119x/Makefile.boot
new file mode 100644
index 00000000..4c23c5d
--- /dev/null
+++ b/arch/arm/mach-rtd119x/Makefile.boot
@@ -0,0 +1 @@
+zreladdr-$(CONFIG_ARCH_RTD119X)	+= 0x00108000
diff --git a/arch/arm/mach-rtd119x/headsmp.S b/arch/arm/mach-rtd119x/headsmp.S
new file mode 100644
index 00000000..5cb0e70
--- /dev/null
+++ b/arch/arm/mach-rtd119x/headsmp.S
@@ -0,0 +1,12 @@
+#include <linux/linkage.h>
+#include <linux/init.h>
+
+	.section ".text.head", "ax"
+
+ENTRY(rtk119x_secondary_startup)
+	b	secondary_startup
+ENDPROC(rtk119x_secondary_startup)
+
+	.align 2
+1:	.long	.
+	.long	pen_release
diff --git a/arch/arm/mach-rtd119x/include/mach/barriers.h b/arch/arm/mach-rtd119x/include/mach/barriers.h
new file mode 100644
index 00000000..df05b71
--- /dev/null
+++ b/arch/arm/mach-rtd119x/include/mach/barriers.h
@@ -0,0 +1,15 @@
+/*
+ * Realtek memory barrier header.
+ *
+ */
+
+#ifndef __MACH_BARRIERS_H
+#define __MACH_BARRIERS_H
+
+extern void rtk_bus_sync(void);
+
+#define rmb()		dsb()
+#define wmb()		do { dmb(); rtk_bus_sync(); } while (0)
+#define mb()		wmb()
+
+#endif	/* __MACH_BARRIERS_H */
diff --git a/arch/arm/mach-rtd119x/include/mach/cpu.h b/arch/arm/mach-rtd119x/include/mach/cpu.h
new file mode 100644
index 00000000..71f5dc8
--- /dev/null
+++ b/arch/arm/mach-rtd119x/include/mach/cpu.h
@@ -0,0 +1,29 @@
+#ifndef __REALTEK_PLAT_CPU_H__
+#define __REALTEK_PLAT_CPU_H__
+
+extern unsigned long realtek_cpu_id;
+
+#define RTK1195_CPU_ID		0x00006329
+#define RTK1195_CPU_MASK	0x0000FFFF
+#define RTK1195_REV_A		(0x0)
+#define RTK1195_REV_B		(0x1)
+#define RTK1195_REV_C		(0x2)
+#define RTK1195_REV_D           (0x3)
+
+#define IS_REALTEK_CPU(name, id, mask)		\
+static inline int is_realtek_##name(void)	\
+{											\
+	return ((realtek_cpu_id & mask) == (id & mask));	\
+}
+
+IS_REALTEK_CPU(rtk1195, RTK1195_CPU_ID, RTK1195_CPU_MASK)
+
+#if defined(CONFIG_ARCH_RTD119X)
+#define soc_is_rtk1195()	is_realtek_rtk1195()
+#else
+#define soc_is_rtk1195()	0
+#endif
+
+extern unsigned int realtek_rev(void);
+
+#endif /* __REALTEK_PLAT_CPU_H__ */
diff --git a/arch/arm/mach-rtd119x/include/mach/debug-macro.S b/arch/arm/mach-rtd119x/include/mach/debug-macro.S
new file mode 100644
index 00000000..0f485b6
--- /dev/null
+++ b/arch/arm/mach-rtd119x/include/mach/debug-macro.S
@@ -0,0 +1,22 @@
+/*
+ * arch/arm/mach-rtk119x/include/mach/debug-macro.S
+ *
+ * Debugging macro include header
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+*/
+
+#define RBUS_PHYS_BASE			0x18000000
+#define RBUS_VIRT_BASE			IOMEM(0xfe000000)
+
+	.macro  addruart, rp, rv, tmp
+	ldr	\rp, =RBUS_PHYS_BASE
+	ldr	\rv, =RBUS_VIRT_BASE
+	orr	\rp, \rp, #0x00007800
+	orr	\rv, \rv, #0x00007800
+	.endm
+
+#define UART_SHIFT	2
+#include <asm/hardware/debug-8250.S>
diff --git a/arch/arm/mach-rtd119x/include/mach/irqs.h b/arch/arm/mach-rtd119x/include/mach/irqs.h
new file mode 100644
index 00000000..716575d
--- /dev/null
+++ b/arch/arm/mach-rtd119x/include/mach/irqs.h
@@ -0,0 +1,49 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License.  See the file "COPYING" in the main directory of this archive
+ * for more details.
+ *
+ * Copyright (C) 2012 by Chuck Chen <ycchen@realtek.com>
+ *
+ */
+
+#ifndef __ASM_ARCH_IRQS_H
+#define __ASM_ARCH_IRQS_H
+
+//#define NR_IRQS			256  // sync as hardware gic configuration
+#ifndef CONFIG_MACH_RTK1192
+#define NR_IRQS			320  // sync as hardware gic configuration
+#else
+#define NR_IRQS         360
+#endif
+
+#define IRQ_WDOG_NMI	32
+#define IRQ_RTC			33
+#define IRQ_TIMER		34
+#define IRQ_CPU2CPU		35	// ACPU/VCPU/VCPU2 to SCPU
+#define IRQ_DCSYS		36	// DCSYS-PHY, DCSYS/TVSB/SB2 to SCPU
+#define IRQ_L2CACHE		37
+#define IRQ_IMDOMAIN	38	// VODMA1/VODMA2/DCC/APLL/I/M-DOMAIN
+#define IRQ_DDOMAIN		39	// DCT/UZ/OSD
+#define IRQ_AXI			40
+#define IRQ_VDEC		41
+#define IRQ_VBI			42
+#define IRQ_SE			43
+#define IRQ_MCP			44
+#define IRQ_MD			45
+#define IRQ_GPU			46
+#define IRQ_IFDEMOD		47
+#define IRQ_NF			49	// NF/EMMC
+#define IRQ_CR			74
+#define IRQ_CRSD		76
+#define IRQ_MISC		51	// GPIO/I2C/UART/SC/PCMCIA/EFUSE
+#define IRQ_ETH			52	// ETH/GETH
+#define IRQ_USB			53
+#define IRQ_TP			54
+#define IRQ_HDMI		55
+#define IRQ_SDIO		56
+#define IRQ_CEC			57	// CEC/CBUS/MISC_ISO_ON/MISC_ISO_OFF/SYNCP
+#define IRQ_SB2			68
+#define IRQ_VE			83
+
+#endif
diff --git a/arch/arm/mach-rtd119x/include/mach/memory.h b/arch/arm/mach-rtd119x/include/mach/memory.h
new file mode 100644
index 00000000..caf9765
--- /dev/null
+++ b/arch/arm/mach-rtd119x/include/mach/memory.h
@@ -0,0 +1,188 @@
+/*
+ * memory.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __ASM_ARCH_MEMORY_H
+#define __ASM_ARCH_MEMORY_H
+
+#define RTK_FLAG_NONCACHED (1U << 0)
+#define RTK_FLAG_SCPUACC (1U << 1)
+#define RTK_FLAG_ACPUACC (1U << 2)
+#define RTK_FLAG_HWIPACC (1U << 3)
+#define RTK_FLAG_VE_SPEC (1U << 4)
+#define RTK_FLAG_SECURE_AUDIO (1U << 5)
+#define RTK_FLAG_SECURE_TPACC (1U << 6)
+
+#define RTK_FLAG_DEAULT         (RTK_FLAG_NONCACHED | RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | RTK_FLAG_HWIPACC)
+
+#define PLAT_MEM_SIZE (512*1024*1024)
+
+/* 0x00000000 ~ 0x0001efff */ /* (X) ALL*/
+#define SYS_BOOTCODE_MEMBASE (PLAT_PHYS_OFFSET)
+
+#define SYS_BOOTCODE_MEMSIZE            (0x0000C000)
+
+#define RPC_COMM_PHYS (0x0000B000)
+#define RPC_COMM_VIRT (RBUS_BASE_VIRT+RBUS_BASE_SIZE)
+#define RPC_COMM_SIZE (0x00001000)
+
+#if 0
+/* 0x00030000 ~ 0x000fffff */
+#define RESERVED_832KB_PHYS (0x00030000)
+#define RESERVED_832KB_SIZE (0x000D0000)
+#endif
+
+#define RPC_RINGBUF_PHYS                (0x01ffe000)
+#define RPC_RINGBUF_VIRT                (0xFC7F8000+0x00004000)
+#define RPC_RINGBUF_SIZE                (0x00004000)
+
+#if 0
+/* 0x02200000 ~ 0x025fffff */
+#ifdef CONFIG_RTK_VMX_ULTRA
+#define ROOTFS_NORMAL_START (0x32b00000)
+#define ROOTFS_NORMAL_SIZE  (0x12C00000) /*300MB*/
+#else
+#define ROOTFS_NORMAL_START (0x02200000)
+#define ROOTFS_NORMAL_SIZE (0x00400000) /*4MB*/
+#endif
+
+#define ROOTFS_NORMAL_END \
+	(ROOTFS_NORMAL_START + ROOTFS_NORMAL_SIZE)
+/* 0x02200000 ~ 0x02dfffff */
+#define ROOTFS_RESCUE_START (0x02200000)
+#define ROOTFS_RESCUE_SIZE (0x00C00000) /*12MB*/
+#define ROOTFS_RESCUE_END (ROOTFS_RESCUE_START + ROOTFS_RESCUE_SIZE)
+/* 0x02600000 ~ 0x02bfffff */
+#define MEM_SLOT_PHYS_1 (0x02600000)
+#define MEM_SLOT_SIZE_1	 (0x00c00000) /* Max : 12M*/
+#define MEM_SLOT_FLAG_1 (RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | \
+		RTK_FLAG_HWIPACC)
+/* 0x03200000 ~ 0x0f8fffff */
+#define MEM_SLOT_PHYS_0 (0x03200000)
+#define MEM_SLOT_SIZE_0	 (0x0c700000) /* Max : 199M*/
+#define MEM_SLOT_FLAG_0 (RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | \
+		RTK_FLAG_HWIPACC)
+#endif
+
+#define ACPU_FIREWARE_PHYS (0x01b00000)
+#define ACPU_FIREWARE_SIZE (0x00400000)
+
+#if 0
+/* 0x10000000 ~ 0x10013fff */ /* (X) ALL*/
+#define ACPU_IDMEM_PHYS (0x10000000)
+#define ACPU_IDMEM_SIZE (0x00014000)
+/* 0x10100000 ~ 0x141fffff */ /* (X) ALL*/
+/* Kernel will resrved memory for TEE OS if kernel config is for DRM */
+#define TEE_OS_PHYS     (0x10100000)
+#define TEE_OS_SIZE     (0x04100000)
+/* Kernel will resrved memory for TEE OS if kernel config is for 1GB ATV w/ DRM */
+#define TEE_OS_30MB_PHYS   (0x10100000)
+#define TEE_OS_30MB_SIZE   (0x01E00000)
+/* For memtester tool */
+#define MEMTESTER_RSV_PHYS (0x22000000)
+#define MEMTESTER_RSV_SIZE (0x04000000)
+
+/* 0x14200000 ~ 0x1e7fffff */
+#define MEM_SLOT_PHYS_2 (0x14200000)
+#define MEM_SLOT_SIZE_2	(0x0a600000) /* Max : 166M*/
+#define MEM_SLOT_FLAG_2 (RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | \
+		RTK_FLAG_HWIPACC)
+/* 0x1e800000 ~ 0x1effffff */
+#define MEM_SLOT_PHYS_3 (0x1e800000)
+#define MEM_SLOT_SIZE_3	 (0x00800000) /* Max : 8M*/
+#define MEM_SLOT_FLAG_3 (RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | \
+		RTK_FLAG_HWIPACC)
+
+/* 0x1fc00000 ~ 0x1fc00fff */ /* (X) ALL*/
+#define ACPU_BOOTCODE_PHYS (0x1FC00000)
+#define ACPU_BOOTCODE_SIZE (0x00001000)
+/* 0x32800000 ~ 0x3effffff */
+#define MEM_SLOT_PHYS_4 (0x32b00000)
+#define MEM_SLOT_SIZE_4 (0x12c00000)
+#define MEM_SLOT_FLAG_4 (RTK_FLAG_SCPUACC | RTK_FLAG_HWIPACC)
+#endif
+
+#define PLAT_SECURE_PHYS           (0x10000000)
+#define PLAT_SECURE_SIZE           (0x00100000)
+
+#ifdef CONFIG_ARM_NORMAL_WORLD_OS
+#define PLAT_SECUREOS_BASE_PHYS	   (0x0C000000)
+#define PLAT_SECUREOS_SIZE		   (0x00300000)
+#endif
+
+#define PLAT_NOR_PHYS (0x18100000)
+#define PLAT_NOR_SIZE (0x01000000)
+
+#define RBUS_BASE_PHYS                  (0x18000000)
+#define RBUS_BASE_VIRT                  (0xFE000000)
+#define RBUS_BASE_SIZE                  (0x00070000)
+
+#if 0
+#define ROOTFS_BIST_START (0x30000000)
+#define ROOTFS_BIST_SIZE (0x00C00000) /*12MB*/
+#define ROOTFS_BIST_END (ROOTFS_BIST_START + ROOTFS_BIST_SIZE)
+
+#define HW_LIMITATION_PHYS (0x3FFFF000)
+#define HW_LIMITATION_SIZE (0x00001000) /*4KB*/
+#define HW_LIMITATION_START (HW_LIMITATION_PHYS)
+#define HW_LIMITATION_END (HW_LIMITATION_START + HW_LIMITATION_SIZE)
+
+
+#define MEM_SLOT_PHYS_BY(_nr, req_size) (MEM_SLOT_PHYS_##_nr##)
+#define MEM_SLOT_SIZE_BY(_nr, req_size) ( \
+		(req_size  > MEM_SLOT_SIZE_##_nr##) ? MEM_SLOT_SIZE_##_nr## : \
+		req_size)
+#define MEM_SLOT_FLAG_BY(_nr, req_size) (MEM_SLOT_FLAG_##_nr##)
+#define MEM_SLOT(_nr, _type, req_size) \
+	MEM_SLOT_##_type##_BY(_nr, req_size)
+#endif
+
+#define ION_MEDIA_HEAP_SIZE1    (ION_MEDIA_HEAP_SIZE   - ION_MEDIA_HEAP_SIZE2 - ION_MEDIA_HEAP_SIZE3 - ION_MEDIA_HEAP_SIZE4)
+#define ION_MEDIA_HEAP_PHYS1    (PLAT_SECURE_PHYS - ION_MEDIA_HEAP_SIZE1)
+#define ION_MEDIA_HEAP_FLAG1    (RTK_FLAG_DEAULT)
+
+#define ION_AUDIO_HEAP_SIZE             (1024*1024*12)
+#define ION_AUDIO_HEAP_PHYS             (PLAT_SECURE_PHYS  - ION_AUDIO_HEAP_SIZE)
+#define ION_AUDIO_HEAP_FLAG     	(RTK_FLAG_DEAULT)
+
+#define ION_MEDIA_HEAP_PHYS2    (PLAT_SECURE_PHYS + PLAT_SECURE_SIZE)
+#define ION_MEDIA_HEAP_SIZE2    (0x18000000 - ION_MEDIA_HEAP_PHYS2)
+#define ION_MEDIA_HEAP_FLAG2    (RTK_FLAG_DEAULT)
+
+#define ION_MEDIA_HEAP_PHYS3    (0x1E600000)
+#define ION_MEDIA_HEAP_SIZE3    (0x01A00000)
+#define ION_MEDIA_HEAP_FLAG3    (RTK_FLAG_NONCACHED | RTK_FLAG_HWIPACC)
+
+#define ION_MEDIA_HEAP_PHYS4    PLAT_NOR_PHYS
+#define ION_MEDIA_HEAP_SIZE4    (PLAT_NOR_SIZE + 0x00A00000)
+#define ION_MEDIA_HEAP_FLAG4    (RTK_FLAG_NONCACHED | RTK_FLAG_HWIPACC)
+
+#if 0
+/* legacy : 200 M */
+#define ION_SECURE_HEAP_PHYS (MEM_SLOT(4, PHYS, 0x0c800000))
+#define ION_SECURE_HEAP_SIZE (MEM_SLOT(4, SIZE, 0x0c800000))
+#define ION_SECURE_HEAP_FLAG (RTK_FLAG_HWIPACC)
+#endif
+
+#define SYSTEM_GIC_BASE_PHYS            (0xff010000)
+#define SYSTEM_GIC_BASE_VIRT            IOMEM(0xff010000)
+#define SYSTEM_GIC_CPU_BASE             IOMEM(0xff012000)
+#define SYSTEM_GIC_DIST_BASE            IOMEM(0xff011000)
+
+#define SPI_RBUS_PHYS 0x18100000
+#define SPI_RBUS_VIRT 0xfb000000
+#define SPI_RBUS_SIZE 0x01000000
+
+#define ION_MEDIA_HEAP_SIZE             (1024*1024*39 + VE_ION_SIZE + PLAT_FRAME_BUFFER_SIZE)
+#define VE_ION_SIZE                     (1024*1024*169)
+#define PLAT_FRAME_BUFFER_SIZE		(0x01800000)
+
+#endif
+
diff --git a/arch/arm/mach-rtd119x/include/mach/system.h b/arch/arm/mach-rtd119x/include/mach/system.h
new file mode 100644
index 00000000..925067e
--- /dev/null
+++ b/arch/arm/mach-rtd119x/include/mach/system.h
@@ -0,0 +1,15 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License.  See the file "COPYING" in the main directory of this archive
+ * for more details.
+ *
+ * Copyright (C) 2012 by Chuck Chen <ycchen@realtek.com>
+ *
+ */
+
+#ifndef _ASM_MACH_SYSTME_H_
+#define _ASM_MACH_SYSTEM_H_
+
+#define GET_MAPPED_RBUS_ADDR(x)		(x - 0x18000000 + RBUS_BASE_VIRT)
+
+#endif
diff --git a/arch/arm/mach-rtd119x/include/mach/uncompress.h b/arch/arm/mach-rtd119x/include/mach/uncompress.h
new file mode 100644
index 00000000..c967fb7
--- /dev/null
+++ b/arch/arm/mach-rtd119x/include/mach/uncompress.h
@@ -0,0 +1,124 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License.  See the file "COPYING" in the main directory of this archive
+ * for more details.
+ *
+ * Copyright (C) 2012 by Chuck Chen <ycchen@realtek.com>
+ *
+ * Serial port stubs for kernel decompress status messages
+ */
+
+#include <linux/types.h>
+#include <linux/serial_reg.h>
+
+#include <asm/memory.h>
+#include <asm/mach-types.h>
+
+
+#define SYSTEM_CONSOLE		0
+#define UART_CLOCK		27000000
+#define DEFAULT_BAUNDRATE	115200
+
+volatile u8 *uart_base;
+int uart_shift;
+
+static void putc(int c)
+{
+    if (!uart_base)
+        return;
+
+    while (!(uart_base[UART_LSR << uart_shift] & UART_LSR_THRE))
+        barrier();
+
+    uart_base[UART_TX << uart_shift] = c;
+}
+
+static inline void flush(void)
+{
+}
+
+static int uart_setBaudrate(u32 baudrate)
+{
+    u8 tmp_LCR;
+    u32 divisor;
+
+    switch (baudrate) {
+    case 9600:
+    case 19200:
+    case 38400:
+    case 57600:
+    case 115200:
+    case 230400:
+    case 460800:
+    case 921600:
+        break;
+    default:
+        return -1;
+    }
+
+    /* Enable access to the divisor latches by setting DLAB in LCR. */
+    tmp_LCR = uart_base[UART_LCR << uart_shift];
+
+    /* Set divisor latches. */
+    uart_base[UART_LCR << uart_shift] = tmp_LCR | 0x80;
+    divisor = ((UART_CLOCK + 8 * baudrate)/16 /baudrate );
+
+    uart_base[UART_DLL << uart_shift] = divisor & 0xff;
+    uart_base[UART_DLM << uart_shift] = ((divisor & 0xff00 ) >> 8);
+
+    /* Restore line control register */
+    uart_base[UART_LCR << uart_shift] = tmp_LCR;
+
+    return 0;
+}
+
+#define U1RBR_THR_DLL		0x1801B200
+
+static inline void __arch_decomp_setup(unsigned long arch_id)
+{
+    /*
+     * Initialize the port based on the machine ID from the bootloader.
+     * Note that we're using macros here instead of switch statement
+     * as machine_is functions are optimized out for the boards that
+     * are not selected.
+     */
+    do {
+        switch(SYSTEM_CONSOLE)
+        {
+        case 0:
+            uart_base = (u8 *)U1RBR_THR_DLL;
+            break;
+        default:
+        case 1:
+            uart_base = (u8 *)U1RBR_THR_DLL;
+            break;
+#if 0
+        case 2:
+            uart_base = (u8 *)U2RBR_THR_DLL;
+            break;
+        case 3:
+            uart_base = (u8 *)U3RBR_THR_DLL;
+            break;
+#endif
+        }
+
+        uart_shift = 2;
+
+        uart_base[UART_LCR << uart_shift] = 0x3;
+
+        uart_setBaudrate(DEFAULT_BAUNDRATE);
+
+        // Reset Tx/Rx FIFO
+        uart_base[UART_FCR << uart_shift] = 0x6;
+        // Enable FIFO
+        uart_base[UART_FCR << uart_shift] = 0x1;
+        uart_base[UART_MCR << uart_shift] = 0x0;
+    } while (0);
+}
+
+#define arch_decomp_setup()	__arch_decomp_setup(arch_id)
+
+/*
+ * nothing to do
+ */
+#define arch_decomp_wdog()
diff --git a/arch/arm/mach-rtd119x/platsmp.c b/arch/arm/mach-rtd119x/platsmp.c
new file mode 100644
index 00000000..3838b2e
--- /dev/null
+++ b/arch/arm/mach-rtd119x/platsmp.c
@@ -0,0 +1,92 @@
+#include <linux/init.h>
+#include <linux/delay.h>
+#include <linux/jiffies.h>
+#include <linux/io.h>
+#include <linux/memory.h>
+#include <linux/smp.h>
+
+#include <asm/smp_plat.h>
+#include <asm/cacheflush.h>
+
+void secondary_startup(void);
+void rtk119x_secondary_startup(void);
+
+static void write_pen_release(int val)
+{
+    pen_release = val;
+    smp_wmb();
+    __cpuc_flush_dcache_area((void*)&pen_release, sizeof(pen_release));
+}
+
+static DEFINE_SPINLOCK(cpu_lock);
+
+static void rtk119x_secondary_init(unsigned int cpu)
+{
+    /* let primary processor know we are out of pen */
+    write_pen_release(-1);
+
+    /* syn with the boot thread */
+    spin_lock(&cpu_lock);
+    spin_unlock(&cpu_lock);
+}
+
+static int rtk119x_boot_secondary(unsigned int cpu, struct task_struct *idle)
+{
+    unsigned long timeout;
+    unsigned long phys_cpu = cpu_logical_map(cpu);
+
+    spin_lock(&cpu_lock);
+
+    write_pen_release(phys_cpu);
+
+#ifndef CONFIG_ARM_NORMAL_WORLD_OS
+    writel(readl(IOMEM(0xfe01d100)) | BIT(5), IOMEM(0xfe01d100));		// wrap_a7 issue nCORERESET
+    writel(virt_to_phys(rtk119x_secondary_startup), IOMEM(0xfe007064));
+#else
+    writel(virt_to_phys(secondary_startup), IOMEM(0xfe007064));
+#endif
+    arch_send_wakeup_ipi_mask(cpumask_of(cpu));
+
+    timeout = jiffies + (1*HZ);
+    while (time_before(jiffies, timeout)) {
+        smp_rmb();
+        if (pen_release == -1)
+            break;
+        udelay(10);
+    }
+
+    /* now the 2nd core is starting up */
+    spin_unlock(&cpu_lock);
+
+    return pen_release != -1 ? -ENOSYS : 0;
+}
+
+void rtk119x_prepare_cpus(unsigned int max_cpus)
+{
+    int i;
+
+    for (i=0; i<max_cpus; i++) {
+        set_cpu_present(i, true);
+    }
+    smp_wmb();
+}
+
+static void __init rtk119x_init_cpus(void)
+{
+#ifndef CONFIG_ARM_NORMAL_WORLD_OS
+    writel(readl(IOMEM(0xfe01d100)) & ~BIT(5), IOMEM(0xfe01d100));		// wrap_a7 issue nCORERESET
+    writel(virt_to_phys(rtk119x_secondary_startup), IOMEM(0xfe007064));
+#endif
+}
+
+extern void rtk119x_cpu_die(unsigned int cpu);
+
+struct smp_operations rtk119x_smp_ops __initdata = {
+    .smp_prepare_cpus		= rtk119x_prepare_cpus,
+    .smp_init_cpus			= rtk119x_init_cpus,
+    .smp_secondary_init		= rtk119x_secondary_init,
+    .smp_boot_secondary		= rtk119x_boot_secondary,
+#ifdef CONFIG_HOTPLUG_CPU
+    .cpu_die			= rtk119x_cpu_die,
+#endif
+};
diff --git a/arch/arm/mach-rtd119x/rtd119x.c b/arch/arm/mach-rtd119x/rtd119x.c
new file mode 100644
index 00000000..1ec1fbc
--- /dev/null
+++ b/arch/arm/mach-rtd119x/rtd119x.c
@@ -0,0 +1,126 @@
+#include <linux/clk-provider.h>
+#include <linux/clocksource.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/irqchip.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_platform.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/delay.h>
+#include <asm/mach/arch.h>
+#include <asm/mach/map.h>
+#include <asm/system_misc.h>
+#include <asm/system_info.h>
+#include <mach/memory.h>
+#include <mach/cpu.h>
+
+extern struct smp_operations rtk119x_smp_ops;
+
+unsigned long realtek_cpu_id;
+
+static struct map_desc rtk119x_io_desc[] __initdata = {
+    {
+        .virtual	= (unsigned long) IOMEM(RBUS_BASE_VIRT),
+        .pfn		= __phys_to_pfn(RBUS_BASE_PHYS),
+        .length		= RBUS_BASE_SIZE,
+        .type		= MT_DEVICE,
+    },
+    {
+        .virtual	= (unsigned long) SYSTEM_GIC_BASE_VIRT,
+        .pfn		= __phys_to_pfn(SYSTEM_GIC_BASE_PHYS),
+        .length		= 0x10000,
+        .type		= MT_DEVICE,
+    },
+    {
+         /*
+         * RPC ring buffer
+         * 0xfc8000000 - 0x4000 = 0xfc7fc000
+         */
+        .virtual	= (unsigned long) IOMEM(RPC_RINGBUF_VIRT),
+        .pfn		= __phys_to_pfn(RPC_RINGBUF_PHYS),
+        .length		= RPC_RINGBUF_SIZE,
+        .type		= MT_DEVICE,
+    },
+    {
+        .virtual	= (unsigned long) IOMEM(RPC_COMM_VIRT),
+        .pfn		= __phys_to_pfn(RPC_COMM_PHYS),
+        .length		= RPC_COMM_SIZE,
+        .type		= MT_DEVICE,
+    },
+    {
+                .virtual        = (unsigned long) IOMEM(SPI_RBUS_VIRT),
+                .pfn            = __phys_to_pfn(SPI_RBUS_PHYS),
+                .length         = SPI_RBUS_SIZE,
+                .type           = MT_DEVICE,
+    }
+};
+
+void __init rtk119x_map_io(void)
+{
+    debug_ll_io_init();
+
+    iotable_init(rtk119x_io_desc, ARRAY_SIZE(rtk119x_io_desc));
+}
+
+static int __init rtk_memblock_remove(phys_addr_t base, phys_addr_t size)
+{
+    int ret = memblock_remove(base, size);
+
+    if (ret)
+        printk(KERN_ERR "Failed to remove memory (%ld bytes at 0x%08lx)\n",
+               (long)size, (unsigned long)base);
+    else
+        printk(KERN_INFO "remove memory (%ld bytes at 0x%08lx)\n",
+               (long)size, (unsigned long)base);
+
+    return ret;
+}
+
+void __init rtk_reserve(void)
+{
+    rtk_memblock_remove(RBUS_BASE_PHYS, 0x00100000);
+    rtk_memblock_remove(PLAT_NOR_PHYS, PLAT_NOR_SIZE);
+    rtk_memblock_remove(PLAT_SECURE_PHYS, PLAT_SECURE_SIZE);
+}
+
+static void __init rtk119x_dt_init(void)
+{
+    system_rev = readl(IOMEM(0xfe01A204));
+    realtek_cpu_id = readl(IOMEM(0xfe01A200));
+
+    of_platform_populate(NULL, of_default_bus_match_table, NULL, NULL);
+
+    /* setting SCPU wrapper to force as buffable */
+    writel(((readl(IOMEM(0xfe01d000)) & ~(0x3<<12)) | (0x1 <<12)), IOMEM(0xfe01d000));
+    writel(0x1234, IOMEM(0xfe01a020));	/* latch */
+}
+
+static const char * const rtk119x_board_dt_compat[] = {
+    "Realtek,rtd-119x",
+    NULL,
+};
+
+static void __init rtk119x_timer_init(void)
+{
+    writel(0x1, IOMEM(0xff018000));
+
+    of_clk_init(NULL);
+    clocksource_probe();
+}
+
+// ------------------------ ~COMMON ---------------------------------
+unsigned int realtek_rev(void)
+{
+    return (system_rev>>16);
+}
+
+DT_MACHINE_START(RTD119X_DT, "phoenix")
+	.init_machine		= rtk119x_dt_init,
+	.reserve		= rtk_reserve,
+	.map_io			= rtk119x_map_io,
+	.init_time		= rtk119x_timer_init,
+	.dt_compat		= rtk119x_board_dt_compat,
+	.smp                    = smp_ops(rtk119x_smp_ops),
+MACHINE_END
diff --git a/arch/arm/mach-rtd129x/Kconfig b/arch/arm/mach-rtd129x/Kconfig
new file mode 100644
index 00000000..46daa91
--- /dev/null
+++ b/arch/arm/mach-rtd129x/Kconfig
@@ -0,0 +1,26 @@
+config ARCH_RTD129x
+	bool "Realtek RTD129x family"
+	select ARM_AMBA
+	select ARM_GIC
+	select ARM_GLOBAL_TIMER
+	select CLKDEV_LOOKUP
+	select CPU_V7
+	select CPU_32v8
+	select HAVE_SMP
+	select HAVE_MACH_CLKDEV
+	select GENERIC_CLOCKEVENTS
+	select ZONE_DMA
+	select HAVE_SCHED_CLOCK
+	select ARCH_HAS_CPUFREQ
+	select CLKSRC_OF
+	select ARCH_REQUIRE_GPIOLIB
+	select GENERIC_IRQ_CHIP
+	select IRQ_DOMAIN
+	select PINCTRL
+	select COMMON_CLK
+	select ARCH_HAS_BARRIERS
+	select SPARSE_IRQ
+	select RTK_PLATFORM
+	select PM_OPP
+	help
+	  Support for Realtek RTD129x Platform
diff --git a/arch/arm/mach-rtd129x/Makefile b/arch/arm/mach-rtd129x/Makefile
new file mode 100644
index 00000000..cc57afa
--- /dev/null
+++ b/arch/arm/mach-rtd129x/Makefile
@@ -0,0 +1,4 @@
+#ccflags-$(CONFIG_ARCH_RTD139x)	:= -I$(srctree)/arch/arm/mach-rtd129x/include
+
+#obj-$(CONFIG_ARCH_RTD139x)	+= rtd129x.o 
+#obj-$(CONFIG_SMP)	+= platsmp.o headsmp.o
\ No newline at end of file
diff --git a/arch/arm/mach-rtd139x/Kconfig b/arch/arm/mach-rtd139x/Kconfig
new file mode 100644
index 00000000..f99517f
--- /dev/null
+++ b/arch/arm/mach-rtd139x/Kconfig
@@ -0,0 +1,33 @@
+config ARCH_RTD139x
+	bool "Realtek RTD139x family"
+	select ARM_AMBA
+	select CPU_32v8
+	select ARM_GIC
+	select ARM_GLOBAL_TIMER
+	select CLKDEV_LOOKUP
+	select CPU_V7
+	select HAVE_SMP
+	select HAVE_MACH_CLKDEV
+	select GENERIC_CLOCKEVENTS
+	select ZONE_DMA
+	select HAVE_SCHED_CLOCK
+	select ARCH_HAS_CPUFREQ
+	select CLKSRC_OF
+	select ARCH_REQUIRE_GPIOLIB
+	select GENERIC_IRQ_CHIP
+	select IRQ_DOMAIN
+	select PINCTRL
+	select COMMON_CLK
+	select ARCH_HAS_BARRIERS
+	select SPARSE_IRQ
+	select RTK_PLATFORM
+	select PM_OPP
+	select ARM_HAS_SG_CHAIN
+	select ARM_PATCH_PHYS_VIRT
+	select AUTO_ZRELADDR
+	select MIGHT_HAVE_PCI
+	select MULTI_IRQ_HANDLER
+	select PCI_DOMAINS if PCI
+	select USE_OF
+	help
+	  Support for Realtek RTD139x Platform
diff --git a/arch/arm/mach-rtd139x/Makefile b/arch/arm/mach-rtd139x/Makefile
new file mode 100644
index 00000000..3e8ccff
--- /dev/null
+++ b/arch/arm/mach-rtd139x/Makefile
@@ -0,0 +1,4 @@
+ccflags-$(CONFIG_ARCH_RTD139x)	:= -I$(srctree)/arch/arm/mach-rtd139x/include
+
+obj-$(CONFIG_ARCH_RTD139x)	+= rtd139x.o 
+obj-$(CONFIG_SMP)	+= platsmp.o headsmp.o
\ No newline at end of file
diff --git a/arch/arm/mach-rtd139x/Makefile.boot b/arch/arm/mach-rtd139x/Makefile.boot
new file mode 100644
index 00000000..12c3296
--- /dev/null
+++ b/arch/arm/mach-rtd139x/Makefile.boot
@@ -0,0 +1 @@
+zreladdr-$(CONFIG_ARCH_RTD139x)	+= 0x00208000
diff --git a/arch/arm/mach-rtd139x/headsmp.S b/arch/arm/mach-rtd139x/headsmp.S
new file mode 100755
index 00000000..63b60e0
--- /dev/null
+++ b/arch/arm/mach-rtd139x/headsmp.S
@@ -0,0 +1,25 @@
+#include <linux/linkage.h>
+#include <linux/init.h>
+
+#include <asm/assembler.h>
+	.text
+	.arm
+ENTRY(rtd139x_secondary_startup)
+	THUMB( badr r9, 1f ) @ Kernel is entered in ARM.
+	THUMB( bx r9 ) @ If this is a Thumb-2 kernel,
+	THUMB( .thumb ) @ switch to Thumb now.
+	THUMB(1: )
+	mrc	p15, 0, r0, c0, c0, 5 @ read MPIDR
+	and	r0, r0, #15
+	adr	r4, 1f
+	ldmia	r4, {r5, r6}
+	sub	r4, r4, r5
+	add	r6, r6, r4
+pen:	ldr	r7, [r6]
+	cmp	r7, r0
+	bne	pen
+	b secondary_startup
+ENDPROC(rtd139x_secondary_startup)
+	.align	2
+1:	.long .
+	.long	pen_release
diff --git a/arch/arm/mach-rtd139x/include/mach/memory.h b/arch/arm/mach-rtd139x/include/mach/memory.h
new file mode 100644
index 00000000..e47de69
--- /dev/null
+++ b/arch/arm/mach-rtd139x/include/mach/memory.h
@@ -0,0 +1,7 @@
+#ifndef __ASM_ARCH_MEMORY_H
+#define __ASM_ARCH_MEMORY_H
+#endif
+
+#define RBUS_BASE_PHYS (0x98000000)
+#define RBUS_BASE_VIRT (0xFE000000)
+#define RBUS_BASE_SIZE (0x00100000)
\ No newline at end of file
diff --git a/arch/arm/mach-rtd139x/platsmp.c b/arch/arm/mach-rtd139x/platsmp.c
new file mode 100755
index 00000000..ec76afb
--- /dev/null
+++ b/arch/arm/mach-rtd139x/platsmp.c
@@ -0,0 +1,117 @@
+#include <linux/init.h>
+#include <linux/delay.h>
+#include <linux/jiffies.h>
+#include <linux/io.h>
+#include <linux/memory.h>
+#include <linux/smp.h>
+#include <linux/of.h>
+#include <asm/smp_plat.h>
+#include <asm/cacheflush.h>
+#include <asm/cp15.h>
+
+void rtd139x_secondary_startup(void);
+
+extern void _rtk_cpu_power_up(int cpu);
+extern void cpu_do_lowpower(void);
+
+static int cpu_hotplug = 0;
+
+static DEFINE_SPINLOCK(cpu_lock);
+
+static void write_pen_release(int val)
+{
+	pen_release = val;
+	smp_wmb();
+	sync_cache_w(&pen_release);
+}
+
+static void rtd139x_secondary_init(unsigned int cpu)
+{
+	/* let primary processor know we are out of pen */
+	write_pen_release(-1);
+
+	/* syn with the boot thread */
+	spin_lock(&cpu_lock);
+	spin_unlock(&cpu_lock);
+}
+
+static int rtd139x_boot_secondary(unsigned int cpu, struct task_struct *idle)
+{
+	unsigned long timeout;
+	unsigned long phys_cpu = cpu_logical_map(cpu);
+
+	if(cpu_hotplug == 1){
+		_rtk_cpu_power_up(cpu);
+		arch_send_wakeup_ipi_mask(cpumask_of(cpu));
+	}
+
+	write_pen_release(phys_cpu);
+
+	arch_send_wakeup_ipi_mask(cpumask_of(cpu));
+
+	timeout = jiffies + (1*HZ);
+	while(time_before(jiffies, timeout)) {
+		smp_wmb();
+		if (pen_release == -1)
+			break;
+		udelay(10);
+	}
+
+	return pen_release != -1 ? -ENOSYS : 0;
+}
+
+void rtd139x_prepare_cpus(unsigned int max_cpus)
+{
+	int i;
+
+	for (i = 0 ; i < max_cpus ; i++) {
+		set_cpu_present(i, true);
+	}
+
+	smp_wmb();
+}
+
+static void __init rtd139x_init_cpus(void)
+{
+	void __iomem *rbus_base;
+
+	rbus_base = ioremap(0x98007F30, 0x10);
+
+	writel(virt_to_phys(rtd139x_secondary_startup), rbus_base);
+
+	iounmap(rbus_base);
+}
+
+#ifdef CONFIG_HOTPLUG_CPU
+
+static void rtd139x_cpu_die(unsigned int cpu)
+{
+	/*
+	 * Set the fake core0 resume address to BL31
+	 * to let Bl31 know slave cpu will resume
+	 */
+	asm volatile(".arch_extension sec" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("ldr r1, =0x20000" : : : "cc");
+	asm volatile("ldr r0, =0x8400ff04" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+
+	cpu_hotplug = 1;
+
+	v7_exit_coherency_flush(louis);
+
+	cpu_do_lowpower();
+}
+#endif
+
+struct smp_operations rtd139x_smp_ops __initdata = {
+	.smp_prepare_cpus = rtd139x_prepare_cpus,
+	.smp_init_cpus = rtd139x_init_cpus,
+	.smp_secondary_init = rtd139x_secondary_init,
+	.smp_boot_secondary = rtd139x_boot_secondary,
+#ifdef CONFIG_HOTPLUG_CPU
+	.cpu_die = rtd139x_cpu_die,
+#endif
+};
diff --git a/arch/arm/mach-rtd139x/rtd139x.c b/arch/arm/mach-rtd139x/rtd139x.c
new file mode 100644
index 00000000..85748ad
--- /dev/null
+++ b/arch/arm/mach-rtd139x/rtd139x.c
@@ -0,0 +1,52 @@
+#include <linux/clk-provider.h>
+#include <linux/clocksource.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/irqchip.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_platform.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/delay.h>
+#include <asm/mach/arch.h>
+#include <asm/mach/map.h>
+#include <asm/system_misc.h>
+#include <asm/system_info.h>
+
+#include <mach/memory.h>
+
+extern struct smp_operations rtd139x_smp_ops;
+
+static struct map_desc rtd139x_io_desc[] __initdata = {
+	{
+	.virtual = (unsigned long) IOMEM(RBUS_BASE_VIRT),
+	.pfn = __phys_to_pfn(RBUS_BASE_PHYS),
+	.length = RBUS_BASE_SIZE,
+	.type = MT_DEVICE,
+	},
+};
+
+void __init rtd139x_map_io(void)
+{
+	debug_ll_io_init();
+
+	iotable_init(rtd139x_io_desc, ARRAY_SIZE(rtd139x_io_desc));
+}
+
+static const char * const rtd139x_board_dt_compat[] = {
+	"realtek,rtd1395",
+	NULL,
+};
+
+static void __init rtk139x_dt_init(void)
+{
+	of_platform_populate(NULL, of_default_bus_match_table, NULL, NULL);
+}
+
+DT_MACHINE_START(RTD1395, "Hercules")
+	.map_io = rtd139x_map_io,
+	.init_machine = rtk139x_dt_init,
+	.dt_compat = rtd139x_board_dt_compat,
+	.smp = smp_ops(rtd139x_smp_ops),
+MACHINE_END
diff --git a/arch/arm/mach-rtd13xx/Kconfig b/arch/arm/mach-rtd13xx/Kconfig
new file mode 100644
index 00000000..7152c54
--- /dev/null
+++ b/arch/arm/mach-rtd13xx/Kconfig
@@ -0,0 +1,37 @@
+config ARCH_RTD13xx
+	bool "Realtek RTD13xx family"
+	select ARM_AMBA
+	select CPU_32v8
+	select ARM_GIC
+	select ARM_GIC_V3
+	select ARM_PSCI
+	select ARM_GLOBAL_TIMER
+	select CLKDEV_LOOKUP
+	select CPU_V7
+	select HAVE_SMP
+	select HAVE_MACH_CLKDEV
+	select GENERIC_CLOCKEVENTS
+	select ZONE_DMA
+	select HAVE_SCHED_CLOCK
+	select ARCH_HAS_CPUFREQ
+	select CLKSRC_OF
+	select ARCH_REQUIRE_GPIOLIB
+	select GENERIC_IRQ_CHIP
+	select IRQ_DOMAIN
+	select PINCTRL
+	select COMMON_CLK
+	select ARCH_HAS_BARRIERS
+	select SPARSE_IRQ
+	select RTK_PLATFORM
+	select RTK_PLATFORM_PSCI
+	select PM_OPP
+	select ARM_HAS_SG_CHAIN
+	select ARM_PATCH_PHYS_VIRT
+	select AUTO_ZRELADDR
+	select MIGHT_HAVE_PCI
+	select MULTI_IRQ_HANDLER
+	select PCI_DOMAINS if PCI
+	select USE_OF
+	select RTK_BUFLOCK
+	help
+	  Support for Realtek RTD13xx Platform
diff --git a/arch/arm/mach-rtd13xx/Makefile b/arch/arm/mach-rtd13xx/Makefile
new file mode 100644
index 00000000..6751aa3
--- /dev/null
+++ b/arch/arm/mach-rtd13xx/Makefile
@@ -0,0 +1,4 @@
+ccflags-$(CONFIG_ARCH_RTD13xx)	:= -I$(srctree)/arch/arm/mach-rtd13xx/include
+
+obj-$(CONFIG_ARCH_RTD13xx)	+= rtd13xx.o 
+obj-$(CONFIG_SMP)	+= platsmp.o headsmp.o
diff --git a/arch/arm/mach-rtd13xx/Makefile.boot b/arch/arm/mach-rtd13xx/Makefile.boot
new file mode 100644
index 00000000..80aa6f3
--- /dev/null
+++ b/arch/arm/mach-rtd13xx/Makefile.boot
@@ -0,0 +1 @@
+zreladdr-$(CONFIG_ARCH_RTD16xx)	+= 0x00208000
diff --git a/arch/arm/mach-rtd13xx/headsmp.S b/arch/arm/mach-rtd13xx/headsmp.S
new file mode 100644
index 00000000..eb4d056
--- /dev/null
+++ b/arch/arm/mach-rtd13xx/headsmp.S
@@ -0,0 +1,22 @@
+#include <linux/linkage.h>
+#include <linux/init.h>
+
+#include <asm/assembler.h>
+
+ENTRY(rtd13xx_secondary_startup)
+        mrc     p15, 0, r0, c0, c0, 5 @ read MPIDR
+        ldr     r8, =0xff00
+        and     r0, r0, r8
+        adr     r4, 1f
+        ldmia   r4, {r5, r6}
+        sub     r4, r4, r5
+        add     r6, r6, r4
+pen:    ldr     r7, [r6]
+        cmp     r7, r0
+        bne     pen
+	b	secondary_startup
+ENDPROC(rtd13xx_secondary_startup)
+
+	.align 2
+1: 	.long	.
+	.long	pen_release
diff --git a/arch/arm/mach-rtd13xx/include/mach/memory.h b/arch/arm/mach-rtd13xx/include/mach/memory.h
new file mode 100644
index 00000000..e47de69
--- /dev/null
+++ b/arch/arm/mach-rtd13xx/include/mach/memory.h
@@ -0,0 +1,7 @@
+#ifndef __ASM_ARCH_MEMORY_H
+#define __ASM_ARCH_MEMORY_H
+#endif
+
+#define RBUS_BASE_PHYS (0x98000000)
+#define RBUS_BASE_VIRT (0xFE000000)
+#define RBUS_BASE_SIZE (0x00100000)
\ No newline at end of file
diff --git a/arch/arm/mach-rtd13xx/platsmp.c b/arch/arm/mach-rtd13xx/platsmp.c
new file mode 100644
index 00000000..44dc5ab
--- /dev/null
+++ b/arch/arm/mach-rtd13xx/platsmp.c
@@ -0,0 +1,110 @@
+#include <linux/init.h>
+#include <linux/delay.h>
+#include <linux/jiffies.h>
+#include <linux/io.h>
+#include <linux/memory.h>
+#include <linux/smp.h>
+#include <linux/of.h>
+#include <linux/arm-smccc.h>
+#include <asm/smp_plat.h>
+#include <asm/cacheflush.h>
+#include <asm/cp15.h>
+
+#define BL31_CMD 0x8400ff04
+#define BL31_DAT 0x00001319
+
+void rtd13xx_secondary_startup(void);
+
+extern void cpu_do_lowpower(unsigned long secondary_entry_addr);
+
+static int cpu_hotplug = 0;
+
+static DEFINE_SPINLOCK(cpu_lock);
+
+static void write_pen_release(int val)
+{
+	pen_release = val;
+	smp_wmb();
+	sync_cache_w(&pen_release);
+}
+
+static void rtd13xx_secondary_init(unsigned int cpu)
+{
+	/* let primary processor know we are out of pen */
+	write_pen_release(-1);
+
+	/* syn with the boot thread */
+	spin_lock(&cpu_lock);
+	spin_unlock(&cpu_lock);
+}
+
+static int rtd13xx_boot_secondary(unsigned int cpu, struct task_struct *idle)
+{
+	unsigned long timeout;
+	unsigned long phys_cpu = cpu_logical_map(cpu);
+
+	if(cpu_hotplug == 1){
+		arch_send_wakeup_ipi_mask(cpumask_of(cpu));
+	}
+
+	write_pen_release(phys_cpu);
+
+	arch_send_wakeup_ipi_mask(cpumask_of(cpu));
+
+	timeout = jiffies + (1*HZ);
+	while(time_before(jiffies, timeout)) {
+		smp_wmb();
+		if (pen_release == -1)
+			break;
+		udelay(10);
+	}
+
+	return pen_release != -1 ? -ENOSYS : 0;
+}
+
+void rtd13xx_prepare_cpus(unsigned int max_cpus)
+{
+	int i;
+
+	for (i = 0 ; i < max_cpus ; i++) {
+		set_cpu_present(i, true);
+	}
+
+	smp_wmb();
+}
+
+static void __init rtd13xx_init_cpus(void)
+{
+	void __iomem *rbus_base;
+
+	rbus_base = ioremap(0x98007F30, 0x10);
+
+	writel(virt_to_phys(rtd13xx_secondary_startup), rbus_base);
+
+	iounmap(rbus_base);
+}
+
+#ifdef CONFIG_HOTPLUG_CPU
+
+static void rtd13xx_cpu_die(unsigned int cpu)
+{
+	struct arm_smccc_res res;
+
+	/* notify BL31 cpu hotplug */
+	arm_smccc_smc(BL31_CMD, BL31_DAT, 0, 0, 0, 0, 0, 0, &res);
+	cpu_hotplug = 1;
+	v7_exit_coherency_flush(louis);
+
+	cpu_do_lowpower(0x98007F30);
+}
+#endif
+
+struct smp_operations rtd13xx_smp_ops __initdata = {
+	.smp_prepare_cpus = rtd13xx_prepare_cpus,
+	.smp_init_cpus = rtd13xx_init_cpus,
+	.smp_secondary_init = rtd13xx_secondary_init,
+	.smp_boot_secondary = rtd13xx_boot_secondary,
+#ifdef CONFIG_HOTPLUG_CPU
+	.cpu_die = rtd13xx_cpu_die,
+#endif
+};
diff --git a/arch/arm/mach-rtd13xx/rtd13xx.c b/arch/arm/mach-rtd13xx/rtd13xx.c
new file mode 100644
index 00000000..023765c
--- /dev/null
+++ b/arch/arm/mach-rtd13xx/rtd13xx.c
@@ -0,0 +1,60 @@
+#include <linux/clk-provider.h>
+#include <linux/clocksource.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/irqchip.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_platform.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/delay.h>
+#include <asm/mach/arch.h>
+#include <asm/mach/map.h>
+#include <asm/system_misc.h>
+#include <asm/system_info.h>
+
+#include <mach/memory.h>
+
+extern struct smp_operations rtd13xx_smp_ops;
+
+static struct map_desc rtd13xx_io_desc[] __initdata = {
+	{
+	.virtual = (unsigned long) IOMEM(RBUS_BASE_VIRT),
+	.pfn = __phys_to_pfn(RBUS_BASE_PHYS),
+	.length = RBUS_BASE_SIZE,
+	.type = MT_DEVICE,
+	},
+};
+
+void __init rtd13xx_map_io(void)
+{
+	debug_ll_io_init();
+
+	iotable_init(rtd13xx_io_desc, ARRAY_SIZE(rtd13xx_io_desc));
+}
+
+static const char * const rtd13xx_board_dt_compat[] = {
+	"realtek,rtd1319",
+	"realtek,hank",
+	NULL,
+};
+
+static void __init rtk13xx_dt_init(void)
+{
+	of_platform_populate(NULL, of_default_bus_match_table, NULL, NULL);
+}
+
+bool __init rtd13xx_smp_init_ops(void)
+{
+	smp_set_ops(smp_ops(rtd13xx_smp_ops));
+	return true;
+}
+
+DT_MACHINE_START(RTD1319, "Hank")
+	.map_io = rtd13xx_map_io,
+	.init_machine = rtk13xx_dt_init,
+	.dt_compat = rtd13xx_board_dt_compat,
+	.smp = smp_ops(rtd13xx_smp_ops),
+	.smp_init = smp_init_ops(rtd13xx_smp_init_ops),
+MACHINE_END
diff --git a/arch/arm/mach-rtd16xx/Kconfig b/arch/arm/mach-rtd16xx/Kconfig
new file mode 100644
index 00000000..ba88dd5
--- /dev/null
+++ b/arch/arm/mach-rtd16xx/Kconfig
@@ -0,0 +1,37 @@
+config ARCH_RTD16xx
+	bool "Realtek RTD16xx family"
+	select ARM_AMBA
+	select CPU_32v8
+	select ARM_GIC
+	select ARM_GIC_V3
+	select ARM_PSCI
+	select ARM_GLOBAL_TIMER
+	select CLKDEV_LOOKUP
+	select CPU_V7
+	select HAVE_SMP
+	select HAVE_MACH_CLKDEV
+	select GENERIC_CLOCKEVENTS
+	select ZONE_DMA
+	select HAVE_SCHED_CLOCK
+	select ARCH_HAS_CPUFREQ
+	select CLKSRC_OF
+	select ARCH_REQUIRE_GPIOLIB
+	select GENERIC_IRQ_CHIP
+	select IRQ_DOMAIN
+	select PINCTRL
+	select COMMON_CLK
+	select ARCH_HAS_BARRIERS
+	select SPARSE_IRQ
+	select RTK_PLATFORM
+	select RTK_PLATFORM_PSCI
+	select PM_OPP
+	select ARM_HAS_SG_CHAIN
+	select ARM_PATCH_PHYS_VIRT
+	select AUTO_ZRELADDR
+	select MIGHT_HAVE_PCI
+	select MULTI_IRQ_HANDLER
+	select PCI_DOMAINS if PCI
+	select USE_OF
+	select ARM_GIC_V3_DEBUGFS
+	help
+	  Support for Realtek RTD16xx Platform
diff --git a/arch/arm/mach-rtd16xx/Makefile b/arch/arm/mach-rtd16xx/Makefile
new file mode 100644
index 00000000..dd384e3
--- /dev/null
+++ b/arch/arm/mach-rtd16xx/Makefile
@@ -0,0 +1,4 @@
+ccflags-$(CONFIG_ARCH_RTD16xx)	:= -I$(srctree)/arch/arm/mach-rtd16xx/include
+
+obj-$(CONFIG_ARCH_RTD16xx)	+= rtd16xx.o 
+obj-$(CONFIG_SMP)	+= platsmp.o
diff --git a/arch/arm/mach-rtd16xx/Makefile.boot b/arch/arm/mach-rtd16xx/Makefile.boot
new file mode 100644
index 00000000..80aa6f3
--- /dev/null
+++ b/arch/arm/mach-rtd16xx/Makefile.boot
@@ -0,0 +1 @@
+zreladdr-$(CONFIG_ARCH_RTD16xx)	+= 0x00208000
diff --git a/arch/arm/mach-rtd16xx/include/mach/memory.h b/arch/arm/mach-rtd16xx/include/mach/memory.h
new file mode 100644
index 00000000..e47de69
--- /dev/null
+++ b/arch/arm/mach-rtd16xx/include/mach/memory.h
@@ -0,0 +1,7 @@
+#ifndef __ASM_ARCH_MEMORY_H
+#define __ASM_ARCH_MEMORY_H
+#endif
+
+#define RBUS_BASE_PHYS (0x98000000)
+#define RBUS_BASE_VIRT (0xFE000000)
+#define RBUS_BASE_SIZE (0x00100000)
\ No newline at end of file
diff --git a/arch/arm/mach-rtd16xx/platsmp.c b/arch/arm/mach-rtd16xx/platsmp.c
new file mode 100644
index 00000000..bd90af8
--- /dev/null
+++ b/arch/arm/mach-rtd16xx/platsmp.c
@@ -0,0 +1,81 @@
+#include <linux/init.h>
+#include <linux/delay.h>
+#include <linux/jiffies.h>
+#include <linux/io.h>
+#include <linux/memory.h>
+#include <linux/smp.h>
+#include <linux/of.h>
+#include <linux/arm-smccc.h>
+#include <asm/smp_plat.h>
+#include <asm/cacheflush.h>
+#include <asm/cp15.h>
+#include <asm/barrier.h>
+
+#define BL31_CMD 0x8400ff04
+#define BL31_DAT 0x00001619
+#define RELEASE_ADDR 0x98007F30
+#define CPUID 28
+
+#define CPUPWRCTLR __ACCESS_CP15(c15, 0, c2, 7)
+
+static u32 __iomem *cpu_release_virt;
+
+static int rtd16xx_boot_secondary(unsigned int cpu, struct task_struct *idle)
+{
+	unsigned long entry_pa = __pa_symbol(secondary_startup);
+
+	writel_relaxed(entry_pa | (cpu << CPUID), cpu_release_virt);
+
+	arch_send_wakeup_ipi_mask(cpumask_of(cpu));
+
+	return 0;
+}
+
+void rtd16xx_prepare_cpus(unsigned int max_cpus)
+{
+	struct device_node *np;
+	int cpu;
+
+	cpu_release_virt = ioremap(RELEASE_ADDR, sizeof(u32));
+
+	for_each_possible_cpu(cpu) {
+
+		np = of_get_cpu_node(cpu, NULL);
+		if (!np)
+			continue;
+
+		set_cpu_present(cpu, true);
+	}
+}
+
+#ifdef CONFIG_HOTPLUG_CPU
+
+static void rtd16xx_cpu_die(unsigned int cpu)
+{
+	struct arm_smccc_res res;
+	unsigned int cpu_pwr_ctrl;
+
+	writel_relaxed(0x0, cpu_release_virt);
+
+	/* notify BL31 cpu hotplug */
+	arm_smccc_smc(BL31_CMD, BL31_DAT, 0, 0, 0, 0, 0, 0, &res);
+	v7_exit_coherency_flush(louis);
+
+	cpu_pwr_ctrl = read_sysreg(CPUPWRCTLR);
+	cpu_pwr_ctrl |= 0x1;
+	write_sysreg(cpu_pwr_ctrl, CPUPWRCTLR);
+
+	dsb(sy);
+
+	for (;;)
+		wfi();
+}
+#endif
+
+struct smp_operations rtd16xx_smp_ops __initdata = {
+	.smp_prepare_cpus = rtd16xx_prepare_cpus,
+	.smp_boot_secondary = rtd16xx_boot_secondary,
+#ifdef CONFIG_HOTPLUG_CPU
+	.cpu_die = rtd16xx_cpu_die,
+#endif
+};
diff --git a/arch/arm/mach-rtd16xx/rtd16xx.c b/arch/arm/mach-rtd16xx/rtd16xx.c
new file mode 100755
index 00000000..69a187d0
--- /dev/null
+++ b/arch/arm/mach-rtd16xx/rtd16xx.c
@@ -0,0 +1,70 @@
+#include <linux/clk-provider.h>
+#include <linux/clocksource.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/irqchip.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_platform.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/delay.h>
+#include <linux/clockchips.h>
+#include <asm/mach/arch.h>
+#include <asm/mach/map.h>
+#include <asm/system_misc.h>
+#include <asm/system_info.h>
+
+#include <mach/memory.h>
+
+extern struct smp_operations rtd16xx_smp_ops;
+
+static struct map_desc rtd16xx_io_desc[] __initdata = {
+	{
+	.virtual = (unsigned long) IOMEM(RBUS_BASE_VIRT),
+	.pfn = __phys_to_pfn(RBUS_BASE_PHYS),
+	.length = RBUS_BASE_SIZE,
+	.type = MT_DEVICE,
+	},
+};
+
+void __init rtd16xx_map_io(void)
+{
+	debug_ll_io_init();
+
+	iotable_init(rtd16xx_io_desc, ARRAY_SIZE(rtd16xx_io_desc));
+}
+
+static const char * const rtd16xx_board_dt_compat[] = {
+	"realtek,rtd1619",
+	NULL,
+};
+
+static void __init rtk16xx_dt_init(void)
+{
+	of_platform_populate(NULL, of_default_bus_match_table, NULL, NULL);
+}
+
+static void __init rtk16xx_timer_init(void)
+{
+#ifdef CONFIG_COMMON_CLK
+	of_clk_init(NULL);
+#endif
+	clocksource_probe();
+	tick_setup_hrtimer_broadcast();
+}
+
+bool __init rtd16xx_smp_init_ops(void)
+{
+	smp_set_ops(smp_ops(rtd16xx_smp_ops));
+	return true;
+}
+
+DT_MACHINE_START(RTD1619, "Thor")
+	.map_io = rtd16xx_map_io,
+	.init_machine = rtk16xx_dt_init,
+	.init_time = rtk16xx_timer_init,
+	.dt_compat = rtd16xx_board_dt_compat,
+	.smp = smp_ops(rtd16xx_smp_ops),
+	.smp_init = smp_init_ops(rtd16xx_smp_init_ops),
+MACHINE_END
diff --git a/arch/arm/mm/Kconfig b/arch/arm/mm/Kconfig
index c1799dd..144a67e 100644
--- a/arch/arm/mm/Kconfig
+++ b/arch/arm/mm/Kconfig
@@ -383,7 +383,7 @@ config CPU_V6K
 	select CPU_PABRT_V6
 	select CPU_TLB_V6 if MMU
 
-# ARMv7
+# ARMv7 and ARMv8 architectures
 config CPU_V7
 	bool
 	select CPU_32v6K
@@ -454,6 +454,9 @@ config CPU_32v6K
 config CPU_32v7
 	bool
 
+config CPU_32v8
+	bool
+
 config CPU_32v7M
 	bool
 
diff --git a/arch/arm/mm/cache-v6.S b/arch/arm/mm/cache-v6.S
index 2465995..11da0f5 100644
--- a/arch/arm/mm/cache-v6.S
+++ b/arch/arm/mm/cache-v6.S
@@ -270,6 +270,11 @@ v6_dma_clean_range:
  *	- end     - virtual end address of region
  */
 ENTRY(v6_dma_flush_range)
+#ifdef CONFIG_CACHE_FLUSH_RANGE_LIMIT
+	sub	r2, r1, r0
+	cmp	r2, #CONFIG_CACHE_FLUSH_RANGE_LIMIT
+	bhi	v6_dma_flush_dcache_all
+#endif
 #ifdef CONFIG_DMA_CACHE_RWFO
 	ldrb	r2, [r0]		@ read for ownership
 	strb	r2, [r0]		@ write for ownership
@@ -292,6 +297,18 @@ ENTRY(v6_dma_flush_range)
 	mcr	p15, 0, r0, c7, c10, 4		@ drain write buffer
 	ret	lr
 
+#ifdef CONFIG_CACHE_FLUSH_RANGE_LIMIT
+v6_dma_flush_dcache_all:
+	mov	r0, #0
+#ifdef HARVARD_CACHE
+	mcr	p15, 0, r0, c7, c14, 0		@ D cache clean+invalidate
+#else
+	mcr	p15, 0, r0, c7, c15, 0		@ Cache clean+invalidate
+#endif
+	mcr	p15, 0, r0, c7, c10, 4		@ drain write buffer
+	mov	pc, lr
+#endif
+
 /*
  *	dma_map_area(start, size, dir)
  *	- start	- kernel virtual start address
diff --git a/arch/arm/mm/fault.c b/arch/arm/mm/fault.c
index f7861dc..a9ef54d 100644
--- a/arch/arm/mm/fault.c
+++ b/arch/arm/mm/fault.c
@@ -273,10 +273,10 @@ static inline bool access_error(unsigned int fsr, struct vm_area_struct *vma)
 		local_irq_enable();
 
 	/*
-	 * If we're in an interrupt or have no user
+	 * If we're in an interrupt, or have no irqs, or have no user
 	 * context, we must not take the fault..
 	 */
-	if (faulthandler_disabled() || !mm)
+	if (faulthandler_disabled() || irqs_disabled() || !mm)
 		goto no_context;
 
 	if (user_mode(regs))
diff --git a/arch/arm/mm/ioremap.c b/arch/arm/mm/ioremap.c
index ff0eed2..1b5219c 100644
--- a/arch/arm/mm/ioremap.c
+++ b/arch/arm/mm/ioremap.c
@@ -300,8 +300,10 @@ static void __iomem * __arm_ioremap_pfn_caller(unsigned long pfn,
 	 * Don't allow RAM to be mapped with mismatched attributes - this
 	 * causes problems with ARMv6+
 	 */
+#ifndef CONFIG_RTK_MEM_REMAP /* Allow Realtek platform to mapping RAM area */
 	if (WARN_ON(pfn_valid(pfn) && mtype != MT_MEMORY_RW))
 		return NULL;
+#endif
 
 	area = get_vm_area_caller(size, VM_IOREMAP, caller);
  	if (!area)
diff --git a/arch/arm/mm/mmu.c b/arch/arm/mm/mmu.c
index f7c7413..e66cba8 100644
--- a/arch/arm/mm/mmu.c
+++ b/arch/arm/mm/mmu.c
@@ -1117,7 +1117,11 @@ void __init debug_ll_io_init(void)
 	map.virtual &= PAGE_MASK;
 	map.length = PAGE_SIZE;
 	map.type = MT_DEVICE;
+#if defined(CONFIG_RTK_PLATFORM)
+	create_mapping(&map);
+#else
 	iotable_init(&map, 1);
+#endif
 }
 #endif
 
diff --git a/arch/arm/mm/proc-v7-2level.S b/arch/arm/mm/proc-v7-2level.S
index c6141a5..6063e29 100644
--- a/arch/arm/mm/proc-v7-2level.S
+++ b/arch/arm/mm/proc-v7-2level.S
@@ -25,8 +25,11 @@
 
 /* PTWs cacheable, inner WBWA shareable, outer WBWA not shareable */
 #define TTB_FLAGS_SMP	TTB_IRGN_WBWA|TTB_S|TTB_NOS|TTB_RGN_OC_WBWA
+#if CONFIG_ARM_NORMAL_WORLD_OS
+#define PMD_FLAGS_SMP	PMD_SECT_WBWA|PMD_SECT_S|PMD_SECT_NS
+#else
 #define PMD_FLAGS_SMP	PMD_SECT_WBWA|PMD_SECT_S
-
+#endif
 /*
  *	cpu_v7_switch_mm(pgd_phys, tsk)
  *
diff --git a/arch/arm/xen/enlighten.c b/arch/arm/xen/enlighten.c
index 4986dc0..2aa30ae 100644
--- a/arch/arm/xen/enlighten.c
+++ b/arch/arm/xen/enlighten.c
@@ -59,6 +59,12 @@
 
 static __read_mostly unsigned int xen_events_irq;
 
+#ifdef CONFIG_RTK_XEN_SUPPORT
+void (*xen_pre_restart)(void);
+void (*xen_pre_power_off)(void);
+extern void rtk_machine_restart(char mode, const char *cmd);
+#endif /* End of CONFIG_RTK_XEN_SUPPORT */
+
 int xen_remap_domain_gfn_array(struct vm_area_struct *vma,
 			       unsigned long addr,
 			       xen_pfn_t *gfn, int nr,
@@ -195,6 +201,23 @@ static void xen_restart(enum reboot_mode reboot_mode, const char *cmd)
 {
 	struct sched_shutdown r = { .reason = SHUTDOWN_reboot };
 	int rc;
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_pre_restart)
+		xen_pre_restart();
+	// Handle recovery PATH inorder to perform OTA
+	if (cmd) {
+		if (xen_initial_domain()) {
+			// go into SOC reset if under Dom0
+			rtk_machine_restart(reboot_mode, cmd);
+		} else {
+			if (!strncmp(cmd, "recovery", 9)) {
+				r.reason = SHUTDOWN_android_recovery;
+			} else if (!strncmp(cmd, "recovery_domu", 14)) {
+				r.reason = SHUTDOWN_android_recovery_domu;
+			}
+		}
+	}
+#endif /* End of CONFIG_RTK_XEN_SUPPORT */
 	rc = HYPERVISOR_sched_op(SCHEDOP_shutdown, &r);
 	BUG_ON(rc);
 }
@@ -203,6 +226,10 @@ static void xen_power_off(void)
 {
 	struct sched_shutdown r = { .reason = SHUTDOWN_poweroff };
 	int rc;
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_pre_power_off)
+		xen_pre_power_off();
+#endif /* End of CONFIG_RTK_XEN_SUPPORT */
 	rc = HYPERVISOR_sched_op(SCHEDOP_shutdown, &r);
 	BUG_ON(rc);
 }
@@ -396,7 +423,9 @@ static int __init xen_guest_init(void)
 	 * cpu idle and cpu freq.
 	 */
 	disable_cpuidle();
+#ifndef CONFIG_ARM_REALTEK_CPUFREQ_XEN
 	disable_cpufreq();
+#endif
 
 	xen_init_IRQ();
 
@@ -458,3 +487,6 @@ void xen_arch_suspend(void) { }
 EXPORT_SYMBOL_GPL(HYPERVISOR_multicall);
 EXPORT_SYMBOL_GPL(HYPERVISOR_vm_assist);
 EXPORT_SYMBOL_GPL(privcmd_call);
+#ifdef CONFIG_RTK_XEN_HYPERCALL
+EXPORT_SYMBOL_GPL(HYPERVISOR_rtk_hypercall_op);
+#endif
diff --git a/arch/arm64/Kconfig b/arch/arm64/Kconfig
index 3e43874..514dd68 100644
--- a/arch/arm64/Kconfig
+++ b/arch/arm64/Kconfig
@@ -15,6 +15,7 @@ config ARM64
 	select ARCH_HAS_SG_CHAIN
 	select ARCH_HAS_TICK_BROADCAST if GENERIC_CLOCKEVENTS_BROADCAST
 	select ARCH_USE_CMPXCHG_LOCKREF
+	select ARCH_SUPPORTS_LTO_CLANG
 	select ARCH_SUPPORTS_ATOMIC_RMW
 	select ARCH_SUPPORTS_NUMA_BALANCING
 	select ARCH_WANT_COMPAT_IPC_PARSE_VERSION
@@ -109,6 +110,7 @@ config ARM64
 	select POWER_SUPPLY
 	select SPARSE_IRQ
 	select SYSCTL_EXCEPTION_TRACE
+	select THREAD_INFO_IN_TASK
 	help
 	  ARM 64-bit (AArch64) Linux support.
 
@@ -417,7 +419,7 @@ config ARM64_ERRATUM_845719
 
 config ARM64_ERRATUM_843419
 	bool "Cortex-A53: 843419: A load or store might access an incorrect address"
-	default y
+	default y if !LTO_CLANG
 	select ARM64_MODULE_CMODEL_LARGE if MODULES
 	help
 	  This option links the kernel with '--fix-cortex-a53-843419' and
@@ -852,6 +854,14 @@ config SETEND_EMULATION
 	  If unsure, say Y
 endif
 
+config ARM64_SW_TTBR0_PAN
+	bool "Emulate Privileged Access Never using TTBR0_EL1 switching"
+	help
+	  Enabling this option prevents the kernel from accessing
+	  user-space memory directly by pointing TTBR0_EL1 to a reserved
+	  zeroed area and reserved ASID. The user access routines
+	  restore the valid TTBR0_EL1 temporarily.
+
 menu "ARMv8.1 architectural features"
 
 config ARM64_HW_AFDBM
@@ -977,7 +987,7 @@ config RANDOMIZE_BASE
 
 config RANDOMIZE_MODULE_REGION_FULL
 	bool "Randomize the module region independently from the core kernel"
-	depends on RANDOMIZE_BASE && !DYNAMIC_FTRACE
+	depends on RANDOMIZE_BASE && !DYNAMIC_FTRACE && !LTO_CLANG
 	default y
 	help
 	  Randomizes the location of the module region without considering the
@@ -1011,6 +1021,23 @@ config CMDLINE
 	  entering them here. As a minimum, you should specify the the
 	  root device (e.g. root=/dev/nfs).
 
+choice
+	prompt "Kernel command line type" if CMDLINE != ""
+	default CMDLINE_FROM_BOOTLOADER
+
+config CMDLINE_FROM_BOOTLOADER
+	bool "Use bootloader kernel arguments if available"
+	help
+	  Uses the command-line options passed by the boot loader. If
+	  the boot loader doesn't provide any, the default kernel command
+	  string provided in CMDLINE will be used.
+
+config CMDLINE_EXTEND
+	bool "Extend bootloader kernel arguments"
+	help
+	  The command-line arguments provided by the boot loader will be
+	  appended to the default kernel command string.
+
 config CMDLINE_FORCE
 	bool "Always use the default kernel command string"
 	help
@@ -1018,6 +1045,7 @@ config CMDLINE_FORCE
 	  loader passes other arguments to the kernel.
 	  This is useful if you cannot or don't want to change the
 	  command-line options your boot loader passes to the kernel.
+endchoice
 
 config EFI_STUB
 	bool
@@ -1050,6 +1078,41 @@ config DMI
 	  However, even with this option, the resultant kernel should
 	  continue to boot on existing non-UEFI platforms.
 
+config BUILD_ARM64_APPENDED_DTB_IMAGE
+	bool "Build a concatenated Image.gz/dtb by default"
+	depends on OF
+	help
+	  Enabling this option will cause a concatenated Image.gz and list of
+	  DTBs to be built by default (instead of a standalone Image.gz.)
+	  The image will built in arch/arm64/boot/Image.gz-dtb
+
+choice
+	prompt "Appended DTB Kernel Image name"
+	depends on BUILD_ARM64_APPENDED_DTB_IMAGE
+	help
+	  Enabling this option will cause a specific kernel image Image or
+	  Image.gz to be used for final image creation.
+	  The image will built in arch/arm64/boot/IMAGE-NAME-dtb
+
+	config IMG_GZ_DTB
+		bool "Image.gz-dtb"
+	config IMG_DTB
+		bool "Image-dtb"
+endchoice
+
+config BUILD_ARM64_APPENDED_KERNEL_IMAGE_NAME
+	string
+	depends on BUILD_ARM64_APPENDED_DTB_IMAGE
+	default "Image.gz-dtb" if IMG_GZ_DTB
+	default "Image-dtb" if IMG_DTB
+
+config BUILD_ARM64_APPENDED_DTB_IMAGE_NAMES
+	string "Default dtb names"
+	depends on BUILD_ARM64_APPENDED_DTB_IMAGE
+	help
+	  Space separated list of names of dtbs to append when
+	  building a concatenated Image.gz-dtb.
+
 endmenu
 
 menu "Userspace binary formats"
diff --git a/arch/arm64/Kconfig.platforms b/arch/arm64/Kconfig.platforms
index 08a4497..888aed8 100644
--- a/arch/arm64/Kconfig.platforms
+++ b/arch/arm64/Kconfig.platforms
@@ -230,4 +230,57 @@ config ARCH_ZYNQMP
 	help
 	  This enables support for Xilinx ZynqMP Family
 
+config ARCH_RTD129x
+	bool "Realtek RTD129x SoC Family"
+	select ARM_GIC
+	select CLKSRC_OF
+	select PINCTRL
+	select RTK_PLATFORM
+	select PM_OPP
+	#select IRDA
+	help
+	  This enables support for Realtek RTD129x SoC Family
+
+config ARCH_RTD139x
+	bool "Realtek RTD139x SoC Family"
+	select ARM_GIC
+	select CLKSRC_OF
+	select PINCTRL
+	select RTK_PLATFORM
+	select PM_OPP
+	#select IRDA
+	help
+	  This enables support for Realtek RTD139x SoC Family
+
+config ARCH_RTD16xx
+	bool "Realtek RTD16xx SoC Family"
+	select ARM_GIC
+	select CLKSRC_OF
+	select PINCTRL
+	select RTK_PLATFORM
+	select RTK_PLATFORM_PSCI
+	select PM_OPP
+	#select IRDA
+	select ARM_GIC_V3_DEBUGFS
+	help
+	  This enables support for Realtek RTD16xx SoC Family
+
+config ARCH_RTD13xx
+	bool "Realtek RTD13xx SoC Family"
+	select ARM_GIC
+	select CLKSRC_OF
+	select PINCTRL
+	select RTK_PLATFORM
+	select RTK_PLATFORM_PSCI
+	select PM_OPP
+	#select IRDA
+	help
+	  This enables support for Realtek RTD13xx SoC Family
+
+config RTK_PLATFORM
+	def_bool n
+
+config RTK_PLATFORM_PSCI
+	def_bool n
+
 endmenu
diff --git a/arch/arm64/Makefile b/arch/arm64/Makefile
index 92110c2..152baf5 100644
--- a/arch/arm64/Makefile
+++ b/arch/arm64/Makefile
@@ -26,8 +26,17 @@ ifeq ($(CONFIG_ARM64_ERRATUM_843419),y)
   ifeq ($(call ld-option, --fix-cortex-a53-843419),)
 $(warning ld does not support --fix-cortex-a53-843419; kernel may be susceptible to erratum)
   else
+    ifeq ($(call gold-ifversion, -lt, 114000000, y), y)
+$(warning This version of GNU gold may generate incorrect code with --fix-cortex-a53-843419;\
+	see https://sourceware.org/bugzilla/show_bug.cgi?id=21491)
+    endif
 LDFLAGS_vmlinux	+= --fix-cortex-a53-843419
   endif
+else
+  ifeq ($(ld-name),gold)
+# Pass --no-fix-cortex-a53-843419 to ensure the erratum fix is disabled
+LDFLAGS	+= --no-fix-cortex-a53-843419
+  endif
 endif
 
 KBUILD_DEFCONFIG := defconfig
@@ -41,9 +50,17 @@ $(warning LSE atomics not supported by binutils)
   endif
 endif
 
-KBUILD_CFLAGS	+= -mgeneral-regs-only $(lseinstr)
+ifeq ($(cc-name),clang)
+# This is a workaround for https://bugs.llvm.org/show_bug.cgi?id=30792.
+# TODO: revert when this is fixed in LLVM.
+KBUILD_CFLAGS	+= -mno-implicit-float
+else
+KBUILD_CFLAGS	+= -mgeneral-regs-only
+endif
+KBUILD_CFLAGS	+= $(lseinstr)
 KBUILD_CFLAGS	+= -fno-asynchronous-unwind-tables
 KBUILD_CFLAGS	+= $(call cc-option, -mpc-relative-literal-loads)
+KBUILD_CFLAGS	+= -fno-pic
 KBUILD_AFLAGS	+= $(lseinstr)
 
 ifeq ($(CONFIG_CPU_BIG_ENDIAN), y)
@@ -62,6 +79,10 @@ CHECKFLAGS	+= -D__aarch64__
 
 ifeq ($(CONFIG_ARM64_MODULE_CMODEL_LARGE), y)
 KBUILD_CFLAGS_MODULE	+= -mcmodel=large
+ifeq ($(CONFIG_LTO_CLANG), y)
+# Code model is not stored in LLVM IR, so we need to pass it also to LLVMgold
+LDFLAGS		+= -plugin-opt=-code-model=large
+endif
 endif
 
 ifeq ($(CONFIG_ARM64_MODULE_PLTS),y)
@@ -77,7 +98,11 @@ TEXT_OFFSET := $(shell awk "BEGIN {srand(); printf \"0x%06x\n\", \
 		 int(2 * 1024 * 1024 / (2 ^ $(CONFIG_ARM64_PAGE_SHIFT)) * \
 		 rand()) * (2 ^ $(CONFIG_ARM64_PAGE_SHIFT))}")
 else
-TEXT_OFFSET := 0x00080000
+TEXT_OFFSET := 0x00280000
+endif
+
+ifeq ($(cc-name),clang)
+KBUILD_CFLAGS += $(call cc-disable-warning, asm-operand-widths)
 endif
 
 # KASAN_SHADOW_OFFSET = VA_START + (1 << (VA_BITS - 3)) - (1 << 61)
@@ -98,7 +123,12 @@ libs-y		:= arch/arm64/lib/ $(libs-y)
 core-$(CONFIG_EFI_STUB) += $(objtree)/drivers/firmware/efi/libstub/lib.a
 
 # Default target when executing plain make
+ifeq ($(CONFIG_BUILD_ARM64_APPENDED_DTB_IMAGE),y)
+KBUILD_IMAGE	:= $(subst $\",,$(CONFIG_BUILD_ARM64_APPENDED_KERNEL_IMAGE_NAME))
+else
 KBUILD_IMAGE	:= Image.gz
+endif
+
 KBUILD_DTBS	:= dtbs
 
 all:	$(KBUILD_IMAGE) $(KBUILD_DTBS)
@@ -125,6 +155,9 @@ dtbs: prepare scripts
 dtbs_install:
 	$(Q)$(MAKE) $(dtbinst)=$(boot)/dts
 
+Image-dtb Image.gz-dtb: vmlinux scripts dtbs
+	$(Q)$(MAKE) $(build)=$(boot) $(boot)/$@
+
 PHONY += vdso_install
 vdso_install:
 	$(Q)$(MAKE) $(build)=arch/arm64/kernel/vdso $@
diff --git a/arch/arm64/boot/.gitignore b/arch/arm64/boot/.gitignore
index 8dab0bb..34e3520 100644
--- a/arch/arm64/boot/.gitignore
+++ b/arch/arm64/boot/.gitignore
@@ -1,2 +1,4 @@
 Image
+Image-dtb
 Image.gz
+Image.gz-dtb
diff --git a/arch/arm64/boot/Makefile b/arch/arm64/boot/Makefile
index 1f012c5..2c8cb86 100644
--- a/arch/arm64/boot/Makefile
+++ b/arch/arm64/boot/Makefile
@@ -14,16 +14,29 @@
 # Based on the ia64 boot/Makefile.
 #
 
+include $(srctree)/arch/arm64/boot/dts/Makefile
+
 OBJCOPYFLAGS_Image :=-O binary -R .note -R .note.gnu.build-id -R .comment -S
 
 targets := Image Image.gz
 
+DTB_NAMES := $(subst $\",,$(CONFIG_BUILD_ARM64_APPENDED_DTB_IMAGE_NAMES))
+ifneq ($(DTB_NAMES),)
+DTB_LIST := $(addsuffix .dtb,$(DTB_NAMES))
+else
+DTB_LIST := $(dtb-y)
+endif
+DTB_OBJS := $(addprefix $(obj)/dts/,$(DTB_LIST))
+
 $(obj)/Image: vmlinux FORCE
 	$(call if_changed,objcopy)
 
 $(obj)/Image.bz2: $(obj)/Image FORCE
 	$(call if_changed,bzip2)
 
+$(obj)/Image-dtb: $(obj)/Image $(DTB_OBJS) FORCE
+	$(call if_changed,cat)
+
 $(obj)/Image.gz: $(obj)/Image FORCE
 	$(call if_changed,gzip)
 
@@ -36,6 +49,9 @@ $(obj)/Image.lzma: $(obj)/Image FORCE
 $(obj)/Image.lzo: $(obj)/Image FORCE
 	$(call if_changed,lzo)
 
+$(obj)/Image.gz-dtb: $(obj)/Image.gz $(DTB_OBJS) FORCE
+	$(call if_changed,cat)
+
 install:
 	$(CONFIG_SHELL) $(srctree)/$(src)/install.sh $(KERNELRELEASE) \
 	$(obj)/Image System.map "$(INSTALL_PATH)"
diff --git a/arch/arm64/boot/dts/Makefile b/arch/arm64/boot/dts/Makefile
index 6684f97..b81ab8e 100644
--- a/arch/arm64/boot/dts/Makefile
+++ b/arch/arm64/boot/dts/Makefile
@@ -20,6 +20,7 @@ dts-dirs += sprd
 dts-dirs += xilinx
 dts-dirs += lg
 dts-dirs += zte
+dts-dirs += realtek
 
 subdir-y	:= $(dts-dirs)
 
@@ -28,3 +29,17 @@ dtstree		:= $(srctree)/$(src)
 dtb-$(CONFIG_OF_ALL_DTBS) := $(patsubst $(dtstree)/%.dts,%.dtb, $(foreach d,$(dts-dirs), $(wildcard $(dtstree)/$(d)/*.dts)))
 
 always		:= $(dtb-y)
+
+targets += dtbs
+
+DTB_NAMES := $(subst $\",,$(CONFIG_BUILD_ARM64_APPENDED_DTB_IMAGE_NAMES))
+ifneq ($(DTB_NAMES),)
+DTB_LIST := $(addsuffix .dtb,$(DTB_NAMES))
+else
+DTB_LIST := $(dtb-y)
+endif
+targets += $(DTB_LIST)
+
+dtbs: $(addprefix $(obj)/, $(DTB_LIST))
+
+clean-files := dts/*.dtb *.dtb
diff --git a/arch/arm64/boot/dts/realtek/Makefile b/arch/arm64/boot/dts/realtek/Makefile
new file mode 100644
index 00000000..7172be1
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/Makefile
@@ -0,0 +1,11 @@
+dts-dirs += rtd129x
+dts-dirs += rtd139x
+dts-dirs += rtd16xx
+dts-dirs += rtd13xx
+
+always		:= $(dtb-y)
+subdir-y	:= $(dts-dirs)
+clean-files	:= rtd129x/*.dtb *.dtb
+clean-files	:= rtd139x/*.dtb *.dtb
+clean-files	:= rtd16xx/*.dtb *.dtb
+clean-files	:= rtd13xx/*.dtb *.dtb
\ No newline at end of file
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/Makefile b/arch/arm64/boot/dts/realtek/rtd129x/Makefile
new file mode 100644
index 00000000..af58433
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/Makefile
@@ -0,0 +1,38 @@
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-fpga.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-giraffe-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-giraffe-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-giraffe-1GB.SATA.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-giraffe-1.5GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-giraffe-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-giraffe-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1294-giraffe-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-3GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-qa-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-milii-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-pinnata-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-pinnata-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-bist.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-milii-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-pinnata-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1295-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-qa-rescue-tee.dtb
+
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-2GB-xendom0.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-3GB-xendom0.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-xenott.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-xenott-3GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-saola-xenott-3GB-tee.dtb
+
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-nas-saola-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-mmnas-saola-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-videonas-saola-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD129x) += rtd-1296-nas-qa-rescue.dtb
+always		:= $(dtb-y)
+subdir-y	:= $(dts-dirs)
+clean-files	:= *.dtb
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294-giraffe-1GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294-giraffe-1GB.dts
new file mode 100644
index 00000000..007eceb
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294-giraffe-1GB.dts
@@ -0,0 +1,97 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#include "rtd-129x-ion-1GB.dtsi"
+#include "rtd-1294.dtsi"
+#include "rtd-1294-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 * s
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>;   /* 1024 MB */
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294-giraffe-common.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294-giraffe-common.dtsi
new file mode 100644
index 00000000..861b997
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294-giraffe-common.dtsi
@@ -0,0 +1,99 @@
+#include "rtd-1294.dtsi"
+
+/ {
+	model= "Realtek_RTD1294";
+	compatible = "Realtek,rtd-1294";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	arch_timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0@9801B000 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1@9801B000 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	serial1@9801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	serial2@9801B400 {
+		clock-frequency = <432000000>;
+	};
+
+	chosen {
+		swiotlb-memory-reservation-size = <512>;
+		swiotlb-force = <0>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+		};
+	};
+
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button, input, default N/A */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute , output, default high */
+	};
+
+	rfkilligpio {
+		gpios = <&rtk_iso_gpio 24 1 0>; /*bt power , output, default low */
+		status = "okay";
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294-usb.dtsi
new file mode 100644
index 00000000..6aac418
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294-usb.dtsi
@@ -0,0 +1,37 @@
+
+/ {
+    /include/ "rtd-129x-usb.dtsi"
+
+	rtk_usb_power_manager {
+		compatible = "Realtek,rtd129x-usb-power-manager";
+
+		status = "okay";
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,rtd129x-dwc3-drd";
+
+		status = "okay";
+		dwc3_drd@98020000 {
+			dr_mode = "host";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,rtd129x-dwc3-u2h";
+
+		status = "okay";
+	};
+
+	ehci@98013000 {
+		compatible = "Realtek,rtd129x-ehci";
+
+		status = "okay";
+	};
+
+	ohci@98013400 {
+		compatible = "Realtek,rtd129x-ohci";
+
+		status = "okay";
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294.dtsi
new file mode 100644
index 00000000..6c4545b
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1294.dtsi
@@ -0,0 +1,912 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include "rtd-129x-common.dtsi"
+/include/ "rtd-1295-pinctrl.dtsi"
+/include/ "rtd-1295-irT377.dtsi"
+/include/ "rtd-1294-usb.dtsi"
+/include/ "rtd-129x-dcsys-debug.dtsi"
+
+/{
+	compatible = "realtek,rtd1294";
+	interrupt-parent = <&gic>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A53_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x0>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x1>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x02>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x03>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		a53_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	soc@0 {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x98000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+	};
+
+	arch_timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <1 13 0xf08>,
+			<1 14 0xf08>,
+			<1 11 0xf08>,
+			<1 10 0xf08>;
+		clock-frequency = <27000000>;
+	};
+
+	gic: interrupt-controller@FF010000 {
+		compatible = "arm,cortex-a15-gic";
+		#interrupt-cells = <3>;
+		interrupt-controller;
+		reg = <0xFF011000 0x1000>,
+			<0xFF012000 0x1000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <0 48 4>;
+		interrupt-affinity = <&A53_0>,
+			<&A53_1>,
+			<&A53_2>,
+			<&A53_3>;
+	};
+
+	pinctrl: pinctrl@9801A000 {
+		compatible = "realtek,rtk129x-pinctrl";
+		reg = <0x9801A000 0x97c>,
+			<0x9804d000 0x010>,
+			<0x98012000 0x640>,
+			<0x98007000 0x340>;
+		#gpio-range-cells = <3>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>,
+			<&sdcard_pins_high>,
+			<&uart0_pins>,
+			<&uart1_pins>,
+			<&uart2_pins_0>,
+			<&i2c_pins_0>,
+			<&i2c_pins_1>,
+			<&i2c_pins_5>,
+			<&i2c_pins_6>,
+			<&pcie1_clk_pins>,
+			<&pcie2_clk_pins>,
+			<&rgmii0_pins>,
+			<&ir_rx_pins>,
+			<&ir_tx_pins>,
+			<&spdif_pins>,
+			<&pwm0_0_pins>,
+			<&etn_led_pins>;
+		status = "okay";
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x9801B000 0x100>, /* MISC_TOP MISC_ISO */
+			<0x98007000 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		compatible = "realtek,rtk-misc-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>; /*must be the same with gpiochip.of_gpio_n_cells*/
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <101>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <0 19>, <0 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x9801b000 0x100>,
+			<0x9801b100 0x100>; /* MISC_SYS MISC_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 101>;
+		status = "okay";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <101>;
+		Realtek,gpio_numbers = <35>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x98007000 0x100>,
+			<0x98007100 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 101 35>;
+		status = "okay";
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x98000000 0x200000>;
+		status = "okay";
+	};
+
+	md@9800b000 {
+		compatible = "realtek,md";
+		reg = <0x9800b000 0x1000>;
+		interrupts = <0 38 4>; /* 70 - 32 = 38 */
+		clocks = <&clk_en_1 CLK_EN_MD>;
+		resets = <&rst1 RSTN_MD>;
+		status = "okay";
+	};
+
+	se@9800c000 {
+		compatible = "realtek,se";
+		reg = <0x9800c000 0x1000>;
+		interrupts = <0 20 4>; /* 52 - 32 = 20 */
+		clocks = <&clk_en_1 CLK_EN_SE>;
+		resets = <&rst1 RSTN_SE>;
+		power-domains = <&pd0 PD_SRAM_DISP_SE>;
+		status = "okay";
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x9801b000 0x1000>;
+		status = "okay";
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd129x-hdmitx";
+		reg = <0x9800d000 0x560>, /* HDMITX */
+			<0x98007200 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 6 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&rst1 RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		status = "okay";
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 31>;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtk129x-hdcptx";
+		reg = <0x9800d000 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		status = "okay";
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007800 0x400>,
+			<0x98007000 0x100>;
+		interrupts-st-mask = <0x4>;
+		interrupts = <1 2>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&iclk_en CLK_EN_MISC_UR0>;
+		clock-frequency = <27000000>; /* This value must be override by the board. */
+		status = "okay";
+	};
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B200 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR1>;
+		resets = <&rst2 RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+		status = "okay";
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B400 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR2>;
+		resets = <&rst2 RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+		status = "disabled"; /* Disable UR2 first since we don't use it now */
+	};
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x98016000 0x1000>,
+			<0x98007000 0x1000>;
+		interrupts = <0 22 4>;
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		output-mode = <0>; /* 0:embedded PHY, 1:RGMII to MAC, 2:RGMII to PHY */
+		rgmii-voltage = <1>; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+		rgmii-tx-delay = <0>; /* 0: 0ns, 1: 2ns */
+		rgmii-rx-delay = <0>; /* 0: 0ns, 1: 2ns */
+		ext-phy-id = <1>; /* 0 ~ 31, only valid when output-mode = 2 */
+		clocks = <&iclk_en CLK_EN_ETN_250M>,
+			<&iclk_en CLK_EN_ETN_SYS>;
+		clock-names = "etn_250m",
+			"etn_sys";
+		resets = <&irst IRSTN_GMAC>,
+			<&irst IRSTN_GPHY>;
+		reset-names = "gmac",
+			"gphy";
+		status = "okay";
+	};
+
+	timer0@9801B000 {
+		compatible = "realtek,rtk-timer0";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 17 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	timer1@9801B000 {
+		compatible = "realtek,rtk-timer1";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 18 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	pcie@9804E000 {
+		compatible = "realtek,rtk-pcie-slot1";
+		reg = <0x9804E000 0x00001000
+			0x9804F000 0x00001000
+			0x9801C600 0x00000100
+			0x9801A000 0x00000300
+			0x98012000 0x00001000>;
+		interrupt-names = "rtk-pcie1-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic GIC_SPI 61 IRQ_TYPE_LEVEL_HIGH>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <0>;
+		device_type = "pci";
+		gpios = <&rtk_misc_gpio 18 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		ranges = <0x02000000 0x00000000 0xC0000000  0xC0000000 0x00000000 0x01000000
+			0x01000000 0x00000000 0x00030000  0x00030000 0x00000000 0x00010000>;
+		resets = <&rst2 RSTN_PCIE0>,
+			<&rst2 RSTN_PCIE0_CORE>,
+			<&rst2 RSTN_PCIE0_POWER>,
+			<&rst2 RSTN_PCIE0_NONSTITCH>,
+			<&rst2 RSTN_PCIE0_STITCH>,
+			<&rst2 RSTN_PCIE0_PHY>,
+			<&rst4 RSTN_PCIE0_PHY_MDIO>;
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_1 CLK_EN_PCIE0>;
+		status = "okay";
+		phys_a = <0x31810801>,
+			<0xB2001101>,
+			<0x00100001>;
+		phys_b = <0x00000003>,
+			<0x00900001>,
+			<0x40080401>,
+			<0x5AC10801>,
+			<0x32b40f01>,
+			<0x72001101>;
+	};
+
+	sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 23 1 1>;
+		reg = <0x98010c00 0x200>,
+			<0x98000000 0x200000>;
+		interrupts = <0 45 4>;
+		clocks = <&clk_en_1 CLK_EN_SDIO>,
+			<&clk_en_1 CLK_EN_SDIO_IP>;
+		clock-names = "sdio",
+			"sdio_ip";
+		resets = <&rst2 RSTN_SDIO>;
+		status = "okay";
+	};
+
+	sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_misc_gpio 99 1 0>; /*sd power , output, default high  (poweroff) */
+		reg = <0x98000000 0x400>, /* CRT */
+			<0x98010400 0x200>, /* SDMMC */
+			<0x9801A000 0x400>, /* BS2 */
+			<0x98012000 0xa00>, /* EMMC */
+			<0x98010A00 0x40>; /* SDIO */
+		interrupts = <0 44 4>;
+		clocks = <&clk_en_1 CLK_EN_CR>,
+			<&clk_en_1 CLK_EN_SD_IP>;
+		clock-names = "cr",
+			"sd_ip";
+		status = "okay";
+	};
+
+	emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		reg = <0x98012000 0xa00>, /*EMMC*/
+			<0x98000000 0x600>, /*CRT */
+			<0x9801A000 0x80>, /*SB2*/
+			<0x9801B000 0x150>; /*MISC*/
+		interrupts = <0 42 4>;
+		speed-step = <2>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_1 CLK_EN_EMMC>,
+			<&clk_en_1 CLK_EN_EMMC_IP>,
+			<&clk_en_1 CLK_EN_CR>;
+		clock-names = "emmc",
+			"emmc_ip",
+			"cr";
+		resets = <&rst2 RSTN_EMMC>;
+		reset-names = "emmc";
+		status = "okay";
+		pddrive_nf_s0 = <1 0x77 0x77 0x77 0x33>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+		pddrive_nf_s2 = <1 0xbb 0xbb 0xbb 0x33>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+		phase_tuning = <0 0>; /* arg0: tx tuning switch, arg1: rx tuning switch*/
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk1295-pu_pll";
+		reg = <0x98000000 0x200>;
+	};
+
+	jpeg@9803e000 {
+		compatible = "Realtek,rtk1295-jpeg";
+		reg = <0x9803e000 0x1000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_2 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&rst2 RSTN_JPEG>;
+		status = "okay";
+	};
+
+	ve1@98040000 {
+		compatible = "Realtek,rtk1295-ve1";
+		reg = <0x98040000 0x8000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 53 4>, <0 54 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			<&cc CC_CLK_VE2>;
+		clock-names = "clk_ve1",
+			"clk_ve2";
+		resets = <&rst1 RSTN_VE1>,
+			<&rst1 RSTN_VE2>;
+		reset-names = "ve1",
+			"ve2";
+		status = "okay";
+	};
+
+	ve3@98048000 {
+		compatible = "Realtek,rtk1295-ve3";
+		reg = <0x98048000 0x4000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 55 4>;
+		clocks = <&cc CC_CLK_VE3>;
+		resets = <&rst1 RSTN_VE3>;
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x9801d000 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x9801a000 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	rpc@9801a104 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x9801a104 0xc>, /* rpc intr en */
+			<0x01ffe000 0x4000>, /* rpc ring buffer */
+			<0x0001f000 0x1000>, /* rpc common */
+			<0x9801a020 0x4>; /* rbus sync */
+		interrupts = <0 33 4>;
+		status = "okay";
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007000 0x400>,
+			<0x98007400 0x100>;
+		interrupts = <1 5>;
+		resets = <&irst IRSTN_IR>;
+		clocks = <&iclk_en CLK_EN_MISC_IR>;
+		status = "okay";
+	};
+
+	rtc@0x9801B600 {
+		compatible = "realtek,rtk-rtc";
+		reg = <0x9801B600 0x100>,
+			<0x98007000 0x100>;
+		rtc-base-year = <2014>;
+		clocks = <&clk_en_2 CLK_EN_MISC_RTC>;
+		status = "okay";
+	};
+
+	watchdog@0x98007680 {
+		compatible = "realtek,rtk-watchdog";
+		reg = <0x98007680 0x100>;
+		timeout-sec = <20>;
+		status = "okay";
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x98007D00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 8>;
+		i2c-num = <0>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x98007C00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 11>;
+		i2c-num = <1>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C1>;
+	};
+
+	i2c_2: i2c@0x9801B700 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801B700 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 26>;
+		i2c-num = <2>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_2>;
+	};
+
+	i2c_3: i2c@0x9801B900 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801B900 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 23>;
+		i2c-num = <3>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_3>;
+	};
+
+	i2c_4: i2c@0x9801BA00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801BA00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 15>;
+		i2c-num = <4>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_4>;
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801BB00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 14>;
+		i2c-num = <5>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk129x-spi";
+		reg = <0x9801BD00 50>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins>;
+		spi-cs-gpio = <&rtk_misc_gpio 6 1 1>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		resets = <&rst1 RSTN_GSPI>;
+		status = "disabled";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x980070D0 0xC>;
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+	};
+
+	rtk-lsadc@0x98012800 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 21>, <0 22>; /* LSADC0_INT, LSADC1_INT */
+		reg = <0x9801B00C 0x4>, /* MISC_ISR */
+			<0x98012800 0x200>, /* LSADC */
+			<0x9800034C 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>, /* LSADC0 0:disable; 1:enable */
+			<1>; /* LSADC1 0:disable; 1:enable */
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc1-pad0 {
+			//compatible = "Realtek,rtk-lsadc1-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <1>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+
+		rtk-lsadc1-pad1 {
+			//compatible = "Realtek,rtk-lsadc1-pad1";
+			activate = <1>; /* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0: Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <1>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+	};
+
+	rfkill: rfkilligpio {
+		compatible = "realtek,rfkill";
+		gpios = <&rtk_iso_gpio 24 1 0>; /*bt power , output, default low */
+		status = "disabled";
+	};
+
+	rtk-gpio-regulator {
+		compatible = "rtkgpio-regulator";
+		gpios = <&rtk_iso_gpio 16 1 0>, <&rtk_iso_gpio 17 1 1>;
+		//status = "disabled";
+		status = "okay";
+		vdd: rtkgpio_regulator {
+			regulator-min-microvolt = <850000>;
+			regulator-max-microvolt = <1050000>;
+		};
+	};
+
+	cec0@98037800 {
+		compatible = "Realtek,rtk-cec0";
+		reg = <0x98037800 0xe0>,<0x98007000 0x100>,<0x98037500 0x100>;
+		interrupts = <0 26 4>;
+		module-enable = <1>;
+		clocks = <&cc CC_CLK_SYS>,
+			<&iclk_en CLK_EN_CBUS_OSC>,
+			<&iclk_en CLK_EN_CBUS_SYS>,
+			<&iclk_en CLK_EN_CBUSTX_SYS>,
+			<&iclk_en CLK_EN_CBUSRX_SYS>;
+		clock-names = "sys",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys";
+		resets = <&irst IRSTN_CBUS>,
+			<&irst IRSTN_CBUSTX>,
+			<&irst IRSTN_CBUSRX>;
+		reset-names = "cbus",
+			"cbustx",
+			"cbusrx";
+		status = "okay";
+	};
+
+	power-management@0 {
+		compatible = "Realtek,power-management";
+		system-power-controller;
+		reg = <0x98000000 0x1800>, /* CRT */
+			<0x98006000 0x1000>, /* AIO */
+			<0x98007000 0x1000>, /* ISO */
+			<0x98018000 0x2000>, /* TVE */
+			<0x9801A000 0x1000>, /* SB2 */
+			<0x9801B000 0x1000>; /* MISC */
+		suspend-mode = <0>; // 0:SUSPEND_TO_RAM, 1:SUSPEND_TO_COOLBOOT, 2:SUSPEND_TO_WFI
+		pwms = <&pwm 0 37878>;
+		status = "okay";
+	};
+
+	mcp@0 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x98015000 0x1000>,
+			<0x98014000 0x1000>;
+		status = "okay";
+	};
+
+	rtk_boot {
+		compatible = "Realtek,rtk_boot";
+		resume-entry-addr = <0x00021000>;
+		status = "okay";
+	};
+
+	cpu_tm: thermal-sensor@9801D150 {
+		compatible = "realtek,rtd129x-thermal-sensor";
+		reg = <0x9801D150 0x1C>;
+		#thermal-sensor-cells = <0>;
+
+		userspace-trip = <&cpu_userspace 30000>;
+		status = "okay";
+	};
+
+	cr_tm: thermal-sensor@980124B4 {
+		compatible = "realtek,rtd129x-thermal-sensor";
+		reg = <0x980124B4 0x1C>;
+		#thermal-sensor-cells = <0>;
+		status = "okay";
+	};
+
+	gpu: gpu@98050000 {
+		compatible = "arm,mali-midgard";
+		reg = <0x98050000 0xffff>;
+		interrupts = <0 67 4>, <0 68 4>, <0 66 4>;
+		interrupt-names = "JOB", "MMU", "GPU";
+		clocks = <&cc CC_CLK_GPU>;
+		clock-names = "clk_mali";
+		resets = <&rst1 RSTN_GPU>;
+		mali-supply = <&gpu_supp>;
+		#cooling-cells = <2>;
+		status = "okay";
+		power-model {
+			compatible = "arm,mali-simple-power-model";
+			static-coefficient = <2427750>;
+			dynamic-coefficient = <4687>;
+			ts = <20000 2000 (-20) 2>;
+			thermal-zone = "cpu-thermal";
+		};
+	};
+
+	audio-in-device {
+		compatible = "realtek,audio-in";
+		status = "disabled";
+	};
+
+	audio-out-devices {
+		compatible = "realtek,audio-out";
+		status = "okay";
+		dac {
+			compatible = "dac";
+			status = "okay";
+		};
+		spdif {
+			compatible = "spdif";
+			status = "okay";
+		};
+		i2s {
+			compatible = "i2s";
+			status = "okay";
+		};
+		hdmi {
+			compatible = "hdmi";
+			status = "okay";
+		};
+		global {
+			compatible = "global";
+			status = "okay";
+		};
+	};
+
+	busfreq {
+		compatible = "realtek,rtd129x-busfreq";
+		enable = <1>;
+		polling-ms = <1000>;
+		clocks = <&cc CC_PLL_BUS_H>;
+		status = "okay";
+
+		clk-0 {
+			clocks = <&cc CC_CLK_SYS>;
+			rate = <128 256>;
+		};
+		clk-1 {
+			clocks = <&cc CC_PLL_BUS_H>;
+			rate = <200 459>;
+		};
+	};
+
+	dvfs: dvfs {
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+
+			trips {
+				cpu_alert0: cpu-alert0 {
+					temperature = <105000>;
+					hysteresis = <3000>;
+					type = "passive";
+				};
+				cpu_alert1: cpu-alert1 {
+					temperature = <115000>;
+					hysteresis = <3000>;
+					type = "passive";
+				};
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <2000>;
+					type = "critical";
+				};
+				gpu_alert0: gpu-alert0 {
+					temperature = <95000>;
+					hysteresis = <4000>;
+					type = "passive";
+				};
+				gpu_alert1: gpu-alert1 {
+					temperature = <100000>;
+					hysteresis = <4000>;
+					type = "passive";
+				};
+				cpu_userspace: cpu-userspace {
+					temperature = <150000>;
+					hysteresis = <0>;
+					type = "passive";
+				};
+			};
+
+			cooling-maps {
+				map0 {
+					trip = <&cpu_alert0>;
+					cooling-device = <&A53_0 1 6>;
+				};
+				map1 {
+					trip = <&cpu_alert1>;
+					cooling-device = <&A53_0 7 11>;
+				};
+				map2 {
+					trip = <&gpu_alert0>;
+					cooling-device = <&gpu 2 2>;
+				};
+				map3 {
+					trip = <&gpu_alert1>;
+					cooling-device = <&gpu 5 5>;
+				};
+				map4 {
+					trip = <&cpu_userspace>;
+					cooling-device = <&A53_0 9 9>;
+				};
+			};
+		};
+
+		cr-thermal {
+			polling-delay-passive = <0>;
+			polling-delay = <0>;
+			thermal-sensors = <&cr_tm>;
+		};
+	};
+};
+
+#include "rtd-129x-g2227-regulator.dtsi"
+#include "rtd-129x-gpu-dvfs.dtsi"
+#include "rtd-129x-cpu-dvfs.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-bist.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-bist.dts
new file mode 100644
index 00000000..1246fe2
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-bist.dts
@@ -0,0 +1,110 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#include "rtd-129x-ion-1GB-lm.dtsi"
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_BIST_START>;
+		linux,initrd-end = <ROOTFS_BIST_END>;
+		bootargs = "earlycon=uart8250, mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <720 480>;
+		fps = <60>;
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-fpga.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-fpga.dts
new file mode 100644
index 00000000..c7bf0ea
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-fpga.dts
@@ -0,0 +1,131 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02600000 ~ 0x031fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE;
+/* 0x03200000 ~ 0x0e9fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x1fc00000 ~ 0x1fc00fff */
+/memreserve/ ACPU_BOOTCODE_PHYS ACPU_BOOTCODE_SIZE;
+/* 0x11000000 ~ 0x181fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2;
+
+#include "rtd-1295.dtsi"
+
+/ {
+	model= "Realtek_RTD1295";
+	compatible = "Realtek,rtd-1295";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		bootargs = "earlycon=uart8250, mmio32,0x98007800 console=ttyS0,115200 loglevel=7 cma=16m@64m";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x20000000>; /* 512 MB */
+	};
+
+	timer0 {
+		clock-frequency = <33000000>;
+	};
+
+	uart0: serial0@98007800 {
+		clock-frequency = <33000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS
+				ION_AUDIO_HEAP_SIZE
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1
+				ION_MEDIA_HEAP_SIZE1
+				ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2
+				ION_MEDIA_HEAP_SIZE2
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&A53_0 {
+	/delete-property/ cpu-supply;
+	/delete-property/ operating-points-v2;
+};
+&A53_1 {
+	/delete-property/ cpu-supply;
+	/delete-property/ operating-points-v2;
+};
+&A53_2 {
+	/delete-property/ cpu-supply;
+	/delete-property/ operating-points-v2;
+};
+&A53_3 {
+	/delete-property/ cpu-supply;
+	/delete-property/ operating-points-v2;
+};
+&gpu {
+	/delete-property/ mali-supply;
+};
+/{
+	/delete-node/ dvfs;
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1.5GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1.5GB.dts
new file mode 100644
index 00000000..606936a
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1.5GB.dts
@@ -0,0 +1,146 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x02600000 ~ 0x031fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE;
+/* 0x03200000 ~ 0x0e9fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x11000000 ~ 0x181fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2;
+/* Reserved 4KB for 1.5GB  */
+/memreserve/ HW_LIMITATION_START HW_LIMITATION_SIZE;
+
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x60000000>; /* 1536 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS
+				ION_AUDIO_HEAP_SIZE
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 {/* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1
+				ION_MEDIA_HEAP_SIZE1
+				ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2
+				ION_MEDIA_HEAP_SIZE2
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		tee_reserved: tee {
+			no-map;
+			size = <0x00F00000>;
+			alloc-ranges = <0x10100000 0x00F00000>;
+		};
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1GB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1GB.CMAx2.dts
new file mode 100644
index 00000000..5e92a42
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1GB.CMAx2.dts
@@ -0,0 +1,131 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE; /* 0x00000000 ~ 0x0002ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE; /* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE; /* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; /* 0x02200000 ~ 0x025fffff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE; /* 0x10000000 ~ 0x10013fff */
+
+#include "rtd-129x-ion-1GB-lm.dtsi"
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1GB.SATA.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1GB.SATA.dts
new file mode 100644
index 00000000..2ba7ccc
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1GB.SATA.dts
@@ -0,0 +1,125 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x02600000 ~ 0x031fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE;
+/* 0x03200000 ~ 0x0e9fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x11000000 ~ 0x181fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2;
+
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=sata loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS
+				ION_AUDIO_HEAP_SIZE
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1
+				ION_MEDIA_HEAP_SIZE1
+				ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2
+				ION_MEDIA_HEAP_SIZE2
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1GB.dts
new file mode 100644
index 00000000..a3f6bbb
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-1GB.dts
@@ -0,0 +1,110 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#include "rtd-129x-ion-1GB.dtsi"
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-2GB-tee.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-2GB-tee.dts
new file mode 100644
index 00000000..0d48c3b
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-2GB-tee.dts
@@ -0,0 +1,133 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS	 RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-129x-ion-2GB-tee.dtsi"
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		tee_reserved: tee {
+			no-map;
+			size = <0x04100000>;
+			alloc-ranges = <0x10100000 0x04100000>;
+		};
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-2GB.dts
new file mode 100644
index 00000000..ea7c250
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-2GB.dts
@@ -0,0 +1,136 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#include "rtd-129x-ion-2GB.dtsi"
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		tee_reserved: tee {
+			no-map;
+			size = <0x00F00000>;
+			alloc-ranges = <0x10100000 0x00F00000>;
+		};
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-common.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-common.dtsi
new file mode 100644
index 00000000..d49f528
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-giraffe-common.dtsi
@@ -0,0 +1,128 @@
+#include "rtd-1295.dtsi"
+
+/ {
+	model= "Realtek_RTD1295";
+	compatible = "Realtek,rtd-1295";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	arch_timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0@9801B000 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1@9801B000 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	serial1@9801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	serial2@9801B400 {
+		clock-frequency = <432000000>;
+	};
+
+	chosen {
+		/*  512: 1MB */
+		/* 2048: 4MB */
+		swiotlb-memory-reservation-size = <512>;
+		/* 0: SWIOTLB_NORMAL */
+		/* 1: SWIOTLB_FORCE */
+		/* 2: SWIOTLB_NO_FORCE */
+		swiotlb-force = <0>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+		};
+	};
+
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	/* audio dac unmute , output, default high */
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute */
+	};
+
+	rfkill: rfkilligpio {
+		gpios = <&rtk_iso_gpio 24 1 0>; /* bt power */
+		status = "okay";
+	};
+
+	/*
+	 * Suspend GPIO control
+	 * 
+	 * [wakeup-gpio-list]
+	 * rtk_iso_gpio 14: BT wakeup host pin 
+	 * rtk_iso_gpio 33: WiFi wakeup host pin
+	 * 
+	 * [wakeup-gpio-enable]
+	 * Wakeup from BT: <1>enabele 
+	 * Wakeup from WiFi: <0> disable
+	 * 
+	 * [wakeup-gpio-activity]
+	 * BT pin: <1>active high
+	 * WIFI pin: <1>active high
+	 */
+	power-management@0 {
+		compatible = "Realtek,power-management";
+		wakeup-gpio-list = <&rtk_iso_gpio 14 0 0>,
+			<&rtk_iso_gpio 33 0 0>;
+		wakeup-gpio-enable = <1>, <0>;
+		wakeup-gpio-activity = <1>, <1>;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-hdmirxEDID.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-hdmirxEDID.dtsi
new file mode 100644
index 00000000..821da2f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-hdmirxEDID.dtsi
@@ -0,0 +1,59 @@
+/*
+ * rtd-1295-hdmirxEDID.dtsi - HDMI Rx EDID table for REALTEK 1295 SoC
+ */
+
+/{
+	hdmirx@98034000 {
+		Realtek,edid-table = <
+			0x00 0xFF 0xFF 0xFF 0xFF 0xFF 0xFF 0x00 0x4A 0x8B 0x95
+			0x12 0x00 0x00 0x00 0x00 0xFF 0x1A 0x01 0x03 0x81 0x46
+			0x27 0x78 0x8A 0xA5 0x8E 0xA6 0x54 0x4A 0x9C 0x26 0x12
+			0x45 0x46 0x21 0x08 0x00 0xD1 0xC0 0x81 0xC0 0x01 0x01
+			0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x02
+			0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C 0x45 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x01 0x1D 0x00 0x72 0x51
+			0xD0 0x1E 0x20 0x6E 0x28 0x55 0x00 0x20 0xC2 0x31 0x00
+			0x00 0x1E 0x00 0x00 0x00 0xFD 0x00 0x32 0x4B 0x18 0x3C
+			0x0B 0x00 0x0A 0x20 0x20 0x20 0x20 0x20 0x20 0x00 0x00
+			0x00 0xFC 0x00 0x52 0x54 0x44 0x31 0x32 0x39 0x35 0x0A
+			0x20 0x20 0x20 0x20 0x20 0x01 0xAC 0x02 0x03 0x29 0x71
+			0x83 0x01 0x00 0x00 0x6E 0x03 0x0C 0x00 0x10 0x00 0x00
+			0x3C 0x20 0x00 0x80 0x01 0x02 0x03 0x04 0x49 0x90 0x1F
+			0x22 0x20 0x05 0x14 0x04 0x11 0x02 0x23 0x09 0x7F 0x07
+			0xE3 0x05 0x03 0x00 0x02 0x3A 0x80 0x18 0x71 0x38 0x2D
+			0x40 0x58 0x2C 0x45 0x00 0x20 0xC2 0x31 0x00 0x00 0x1E
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x7F>;
+
+		Realtek,edid2p0-table = <
+			0x00 0xFF 0xFF 0xFF 0xFF 0xFF 0xFF 0x00 0x4A 0x8B 0x95
+			0x12 0x00 0x00 0x00 0x00 0xFF 0x1A 0x01 0x03 0x81 0x46
+			0x27 0x78 0x8A 0xA5 0x8E 0xA6 0x54 0x4A 0x9C 0x26 0x12
+			0x45 0x46 0x21 0x08 0x00 0xD1 0xC0 0x81 0xC0 0x01 0x01
+			0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x02
+			0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C 0x45 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x01 0x1D 0x00 0x72 0x51
+			0xD0 0x1E 0x20 0x6E 0x28 0x55 0x00 0x20 0xC2 0x31 0x00
+			0x00 0x1E 0x00 0x00 0x00 0xFD 0x00 0x32 0x4B 0x18 0x3C
+			0x0B 0x00 0x0A 0x20 0x20 0x20 0x20 0x20 0x20 0x00 0x00
+			0x00 0xFC 0x00 0x52 0x54 0x44 0x31 0x32 0x39 0x35 0x0A
+			0x20 0x20 0x20 0x20 0x20 0x01 0xAC 0x02 0x03 0x3A 0x71
+			0x83 0x01 0x00 0x00 0x6E 0x03 0x0C 0x00 0x10 0x00 0x00
+			0x3C 0x20 0x00 0x80 0x01 0x02 0x03 0x04 0x67 0xD8 0x5D
+			0xC4 0x01 0x77 0x80 0x00 0x4F 0x5D 0x5E 0x5F 0x60 0x61
+			0x62 0x90 0x1F 0x22 0x20 0x05 0x14 0x04 0x11 0x02 0x23
+			0x09 0x7F 0x07 0xE3 0x05 0x03 0x00 0xE2 0x0F 0x18 0x08
+			0xE8 0x00 0x30 0xF2 0x70 0x5A 0x80 0xB0 0x58 0x8A 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x8F>;
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-irT377.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-irT377.dtsi
new file mode 100644
index 00000000..00b299a
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-irT377.dtsi
@@ -0,0 +1,62 @@
+/*
+ * rtd-1295-irT377.dtsi - IRDA remote Device Tree Include file for REALTEK 1295 family SoC
+ */
+
+/ {
+	/*
+	 * IR RX protocol:
+	 * NEC = 1,  RC5 = 2, SHARP = 3, SONY = 4, C03 = 5,
+	 * RC6 = 6, RAW_NEC = 7, RCA = 8, PANASONIC = 9, KONKA=10,
+	 * RAW_RC6 = 11, RC6_MODE_6, TOSHIBA = 13
+	 * ----------------
+	 * IR RX protocol:
+	 * NEC_TX = 1, RC5_TX = 2, SHARP_TX = 3, SONY_TX = 4, C03_TX = 5
+	 * RC6_TX = 6, RCA_TX = 7, PANASONIC_TX = 8, KONKA_TX=9
+	 */
+	irda@98007400 {
+		Realtek,irrx-protocol = <1>;
+		Realtek,irtx-protocol = <1>;
+
+		Realtek,cust-code = <0x7F80>;
+		Realtek,scancode-msk = <0x00FF0000>;
+		Realtek,custcode-msk = <0x0000FFFF>;
+		Realtek,keymap-tbl = <
+			//scancode keycode
+			0x18 116 //KEY_POWER //POWER
+			0x5A 353 //KEY_SELECT //SOURCE
+			0x58 154 //KEY_CYCLEWINDOWS //PIP
+			0x1A 377 //KEY_TV //TV SYSTEM
+			0x14 102 //KEY_HOME //HOME
+			0x56 357 //KEY_OPTION //OPTION MENU
+			0x54 358 //KEY_INFO //MEDIA_INFO
+			0x19 232 //KEY_REPLY //REPEAT
+			0x57 158 //KEY_BACK //RETURN
+			0x55 207 //KEY_PLAY //PLAY/PAUSE
+			0x17 128 //KEY_STOP //STOP
+			0x15 372 //KEY_ZOOM //ZOOM_IN
+			0x4F 168 //KEY_REWIND //FR
+			0x4D 103 //KEY_UP //UP
+			0x16 208 //KEY_FASTFORWARD //FF
+			0x0C 105 //KEY_LEFT //LEFT
+			0x4C 352 //KEY_OK //OK
+			0x0E 106 //KEY_RIGHT //RIGHT
+			0x08 412 //KEY_PREVIOUS //PREVIOUS
+			0x48 108 //KEY_DOWN //DOWN
+			0x09 407 //KEY_NEXT //NEXT
+			0x4B 114 //KEY_VOLUMEDOWN //VOL-
+			0x49 115 //KEY_VOLUMEUP //VOL+
+			0x0B 532 //KEY_TOUCHPAD_OFF //CURSOR
+			0x0A 531 //KEY_TOUCHPAD_ON //GESTURE
+			0xEEEE 0 //REL_X //mouse X-axi 0xEEEE : REL event type
+			0xEEEE 1 //REL_Y //mouse Y-axi 0xEEEE : REL event type
+			0xFFFF 272 //BTN_LEFT //mouse left key	0xFFFF : KEY event type
+			0xFFFF 113 //KEY_MUTE //mute key in AirFunAPP 0xFFFF : KEY event type
+			>;
+		/*
+		 *  IR detect interval, NEC default=50ms, should less than 100ms,
+		 * and bigger than 9ms
+		 */
+		Realtek,reg-ir-dpir = <50>;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-irda.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-irda.dtsi
new file mode 100644
index 00000000..a61baba
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-irda.dtsi
@@ -0,0 +1,51 @@
+/*
+ * rtd-1295-irda.dtsi - IRDA remote Device Tree Include file for REALTEK 1295 family SoC
+ */
+
+/ {
+	irda@98007400 {
+		irda_rx0 {
+			irrx-protocol = "NEC";
+			transcode-mode = <1>;
+
+			cust-code = <0x7F80>;
+			scancode-msk = <0x00FF0000>;  
+			custcode-msk = <0x0000FFFF>;  
+			keymap-tbl = <
+			// scancode	keycode
+				0x18 	116		//KEY_POWER		//POWER
+				0x5A 	353		//KEY_SELECT		//SOURCE
+				0x58 	154		//KEY_CYCLEWINDOWS	//PIP
+				0x1A 	377		//KEY_TV		//TV SYSTEM
+				0x14 	102		//KEY_HOME		//HOME
+				0x56 	357		//KEY_OPTION		//OPTION MENU
+				0x54	358		//KEY_INFO		//MEDIA_INFO
+				0x19 	232		//KEY_REPLY		//REPEAT
+				0x57 	158		//KEY_BACK		//RETURN
+				0x55 	207		//KEY_PLAY		//PLAY/PAUSE
+				0x17 	128		//KEY_STOP		//STOP
+				0x15 	372		//KEY_ZOOM		//ZOOM_IN
+				0x4F 	168		//KEY_REWIND		//FR
+				0x4D 	103		//KEY_UP		//UP
+				0x16 	208		//KEY_FASTFORWARD	//FF
+				0x0C 	105		//KEY_LEFT		//LEFT
+				0x4C 	352		//KEY_OK		//OK
+				0x0E 	106		//KEY_RIGHT		//RIGHT
+				0x08 	412		//KEY_PREVIOUS		//PREVIOUS
+				0x48 	108		//KEY_DOWN		//DOWN
+				0x09 	407		//KEY_NEXT		//NEXT
+				0x4B 	114		//KEY_VOLUMEDOWN	//VOL-
+				0x49 	115		//KEY_VOLUMEUP		//VOL+
+				0x0B 	532		//KEY_TOUCHPAD_OFF	//CURSOR
+				0x0A 	531		//KEY_TOUCHPAD_ON	//GESTURE
+				0xEEEE	0		//REL_X			//mouse X-axi	0xEEEE : REL event type
+				0xEEEE	1		//REL_Y			//mouse Y-axi	0xEEEE : REL event type
+				0xFFFF	272		//BTN_LEFT		//mouse left key	0xFFFF : KEY event type
+				0xFFFF	113     	//KEY_MUTE 		//mute key in AirFunAPP	0xFFFF : KEY event type	
+           		>; 
+			reg-ir-dpir = <50>;	/*IR detect interval, NEC default=50ms, should less than 100ms, and bigger than 9ms*/
+			sample-rate = <40>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-milii-1GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-milii-1GB.dts
new file mode 100644
index 00000000..84a96ad
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-milii-1GB.dts
@@ -0,0 +1,144 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#include "rtd-129x-ion-1GB.dtsi"
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	gmac@98016000 {
+		status = "disabled";
+	};
+
+	gmac@98060000 {
+		status = "disabled";
+	};
+
+	sdio@98010A00 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	pcie2@9803B000 {
+		speed-mode = <0>;
+	};
+
+	/* USB P2 */
+	ehci@98013000 {
+		status = "disabled";
+	};
+
+	ohci@98013400 {
+		status = "disabled";
+	};
+
+	sata@9803F000 {
+		status = "disabled";
+	};
+
+	i2c@0x98007D00 {
+		pmic@12 {
+			ldo2 {
+				regulator-state-mem {
+					regulator-on-in-suspend;
+				};
+			};
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-milii-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-milii-2GB.dts
new file mode 100644
index 00000000..5739c9d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-milii-2GB.dts
@@ -0,0 +1,170 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x00030000 */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x02900000 ~ 0x08cfffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1;
+/* 0x01b00000 ~ 0x01efffff */
+/memreserve/ ACPU_FIREWARE_PHYS ACPU_FIREWARE_SIZE;
+/* 0x02600000 ~ 0x028fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x11000000 ~ 0x141fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* RootFS */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 1024 MB */
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS
+				ION_AUDIO_HEAP_SIZE
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1
+				ION_MEDIA_HEAP_SIZE1
+				ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2
+				ION_MEDIA_HEAP_SIZE2
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	gmac@98016000 {
+		status = "disabled";
+	};
+
+	gmac@98060000 {
+		status = "disabled";
+	};
+
+	sdio@98010A00 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	pcie2@9803B000 {
+		speed-mode = <0>;
+	};
+
+	/* USB P2 */
+	ehci@98013000 {
+		status = "disabled";
+	};
+
+	ohci@98013400 {
+		status = "disabled";
+	};
+
+	sata@9803F000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&vd18_supp {
+	/delete-property/ regulator-state-mem;
+	regulator-state-mem {
+		regulator-on-in-suspend;
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-mmnas-giraffe-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-mmnas-giraffe-2GB.dts
new file mode 100644
index 00000000..1cec10a0
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-mmnas-giraffe-2GB.dts
@@ -0,0 +1,156 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE */
+/memreserve/ 0x00000000 0x00030000;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01b00000 ~ 0x01efffff ACPU_FIREWARE_PHYS ACPU_FIREWARE_SIZE */
+/memreserve/ 0x01B00000 0x00400000;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02600000 ~ 0x02dfffff ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE */
+/memreserve/ 0x02600000 0x00800000;
+/* 0x02E00000 ~ 0x0fffffff ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 */
+/memreserve/ 0x02E00000 0x0D200000;
+/* 0x10000000 ~ 0x10013fff ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE */
+/memreserve/ 0x10000000 0x00014000;
+/* 0x12000000 ~ 0x1f4fffff ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 */
+/memreserve/ 0x12000000 0x0D500000;
+
+
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x02600000
+				0x00800000
+				ION_AUDIO_HEAP_FLAG>;
+	};
+
+	rtk,ion-heap@7 { /* TYPE_MEDIA */
+		compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x02E00000
+				0x0D200000
+				ION_MEDIA_HEAP_FLAG1
+				0x12000000
+				0x0D500000
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};		
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-nas-giraffe-2GB-initrd.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-nas-giraffe-2GB-initrd.dts
new file mode 100644
index 00000000..d4487e6
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-nas-giraffe-2GB-initrd.dts
@@ -0,0 +1,133 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+#define INITRD_START (0x04000000)
+/* OpenWRT will check the initrd filesize < INITRD_SIZE by this macro */
+#define INITRD_SIZE (0x1400000)
+#define INITRD_END (INITRD_START + INITRD_SIZE)
+
+/* 0x00000000 ~ 0x0002ffff SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE */
+/memreserve/ 0x00000000 0x00030000;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01b00000 ~ 0x01efffff ACPU_FIREWARE_PHYS ACPU_FIREWARE_SIZE */
+/memreserve/ 0x01B00000 0x00400000;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x04000000 ~ 0x05134ffff INITRD_START INITRD_END */
+/memreserve/ INITRD_START INITRD_SIZE;
+
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		linux,initrd-start = <INITRD_START>;
+		linux,initrd-end = <INITRD_END>;
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};		
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-nas-giraffe-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-nas-giraffe-2GB.dts
new file mode 100644
index 00000000..0ec50ba7
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-nas-giraffe-2GB.dts
@@ -0,0 +1,125 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE */
+/memreserve/ 0x00000000 0x00030000;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01b00000 ~ 0x01efffff ACPU_FIREWARE_PHYS ACPU_FIREWARE_SIZE */
+/memreserve/ 0x01B00000 0x00400000;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+
+
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};		
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-nas-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-nas-qa-rescue.dts
new file mode 100644
index 00000000..c4719a6
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-nas-qa-rescue.dts
@@ -0,0 +1,168 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+#undef ROOTFS_RESCUE_END
+#define ROOTFS_RESCUE_END (ROOTFS_RESCUE_START + 0x00100000)
+
+/* 0x00000000 ~ 0x0002ffff SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE */
+/memreserve/ 0x00000000 0x00030000;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x022fffff */
+/memreserve/ ROOTFS_RESCUE_START 0x00100000;
+
+
+#include "rtd-1295.dtsi"
+
+/ {
+	model= "Realtek_RTD1295";
+	compatible = "Realtek,rtd-1295";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	fb@0 {
+		status = "disabled";
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button, input, default N/A */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute , output, default high */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 21 1 0>; /* igpio21, output, default low */
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	rtc@9801B600 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	ve3@98048000 {
+		status = "disabled";
+	};
+
+	gpu@98050000 {
+		status = "disabled";
+	};
+
+	power_control {
+		dc1_pll {
+			status = "disabled";
+		} ;
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-pinctrl.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-pinctrl.dtsi
new file mode 100644
index 00000000..a9751ad
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-pinctrl.dtsi
@@ -0,0 +1,353 @@
+
+/ {
+	pinctrl@9801A000 {
+		sdcard_pins_low: sdcard_low {
+			realtek,pins= "mmc_data_3",
+				"mmc_data_2",
+				"mmc_data_1",
+				"mmc_data_0",
+				"mmc_clk",
+				"mmc_cmd";
+			realtek,function="sd_card";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <0>;
+		};
+
+		sdcard_pins_high: sdcard_high {
+			realtek,pins="mmc_cd", "mmc_wp";
+			realtek,function="sd_card";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <1>;
+		};
+
+		sdio_pins: sdio_pins {
+			realtek,pins = "sdio_cmd",
+				"sdio_data_0",
+				"sdio_data_1",
+				"sdio_data_2",
+				"sdio_data_3",
+				"sdio_clk";
+			realtek,function = "sdio";
+		};
+
+		uart0_pins: uart0_pins {
+			realtek,pins = "ur0_rx",
+				"ur0_tx";
+			realtek,function = "uart0";
+		};
+
+		uart1_pins: uart1_pins {
+			realtek,pins = "ur1_rx",
+				"ur1_tx",
+				"ur1_cts_n",
+				"ur1_rts_n";
+			realtek,function = "uart1";
+		};
+
+		uart2_pins_0: uart2_pins_0 {
+			realtek,pins = "ur2_loc",
+				"iso_gpio_2",
+				"iso_gpio_3",
+				"iso_gpio_4",
+				"iso_gpio_5";
+			realtek,function = "uart2_0";//iso_2_3_4_5
+		};
+
+		uart2_pins_1: uart2_pins_1 {
+			realtek,pins ="ur2_loc",
+				"iso_gpio_23",
+				"iso_gpio_24",
+				"iso_gpio_33",
+				"iso_gpio_34";
+			realtek,function = "uart2_1";//iso_23_24_33_34
+		};
+
+		i2c_pins_0: i2c_pins_0 {
+			realtek,pins = "i2c_scl_0",
+				"i2c_sda_0";
+			realtek,function = "i2c0";
+		};
+
+		i2c_pins_1: i2c_pins_1 {
+			realtek,pins = "i2c_scl_1",
+				"i2c_sda_1";
+			realtek,function = "i2c1";
+			realtek,pull_sel = <0>;
+		};
+
+		i2c_pins_2: i2c_pins_2 {
+			realtek,pins = "tp1_clk",
+				"tp1_sync";
+			realtek,function = "i2c2";
+			realtek,pull_sel = <0>;
+		};
+
+		i2c_pins_3: i2c_pins_3 {
+			realtek,pins = "tp1_data",
+				"tp1_valid";
+			realtek,function = "i2c3";
+			realtek,pull_sel = <0>;
+		};
+
+		i2c_pins_4: i2c_pins_4 {
+			realtek,pins = "i2c_sda_4",
+				"i2c_scl_4";
+			realtek,function = "i2c4";
+			realtek,pull_sel = <0>;
+		};
+
+		i2c_pins_5: i2c_pins_5 {
+			realtek,pins = "i2c_sda_5",
+				"i2c_scl_5";
+			realtek,function = "i2c5";
+			realtek,pull_sel = <0>;
+		};
+
+		i2c_pins_6: i2c_pins_6 {
+			realtek,pins = "i2c_scl_6",
+				"i2c_sda_6";
+			realtek,function = "i2c6";
+			realtek,pull_sel = <0>;
+		};
+
+		spi_pins_loc_spi: spi_pins_loc_spi {
+			realtek,pins = "gpio_0",
+				"gpio_1",
+				"gpio_2",
+				"gpio_3",
+				"sf_en";
+			realtek,function = "spi";
+		};
+
+		spi_pins_loc_gpio: spi_pins_loc_gpio {
+			realtek,pins = "gpio_0",
+				"gpio_1",
+				"gpio_2",
+				"gpio_3",
+				"sf_en";
+			realtek,function = "gpio";
+		};
+
+		gspi_pins: gspi_pins {
+			realtek,pins = "gpio_4",
+				"gpio_5",
+				"gpio_6",
+				"gpio_7";
+			realtek,function = "gspi";
+		};
+
+		tp0_loc_tp0_pins: tp0_loc_tp0_pins {
+			realtek,pins = "tp0_loc",
+				"tp0_data",
+				"tp0_sync",
+				"tp0_valid",
+				"tp0_clk";
+			realtek,function = "tp0_loc_tp0";
+		};
+
+		tp0_loc_rgmii_pins: tp0_loc_rgmii_pins {
+			realtek,pins = "tp0_loc",
+				"rgmii0_txd_0",
+				"rgmii0_txd_1",
+				"rgmii0_txd_2",
+				"rgmii0_txd_3";
+			realtek,function = "tp0_loc_rgmii0_tx";
+		};
+
+		tp1_loc_tp1_pins: tp1_loc_tp1_pins {
+			realtek,pins = "tp1_loc",
+				"tp1_data",
+				"tp1_sync",
+				"tp1_valid",
+				"tp1_clk";
+			realtek,function = "tp1_loc_tp1";
+		};
+
+		tp1_loc_rgmii_pins: tp1_loc_rgmii_pins {
+			realtek,pins = "tp1_loc",
+				"rgmii0_rxd_0",
+				"rgmii0_rxd_1",
+				"rgmii0_rxd_2",
+				"rgmii0_rxd_3";
+			realtek,function = "tp1_loc_rgmii0_rx";
+		};
+
+		ir_rx_pins: ir_rx_pins {
+			realtek,pins = "ir_rx";
+			realtek,function = "ir_rx";
+		};
+
+		ir_tx_pins: ir_tx_pins {
+			realtek,pins = "ir_tx";
+			realtek,function = "ir_tx";
+		};
+
+		spdif_pins: spdif_pins {
+			realtek,pins = "spdif";
+			realtek,function = "spdif_out";
+		};
+
+		i2s_out_4pins: i2s_out_4pins {
+			realtek,pins ="ao_lrck",
+				"ao_bck",
+				"aock",
+				"ao_sd_0";
+			realtek,function = "ao";
+		};
+
+		i2s_out_6pins: i2s_out_6pins {
+			realtek,pins = "ao_lrck",
+				"ao_bck",
+				"aock",
+				"ao_sd_0",
+				"ao_sd_1",
+				"ao_sd_2";
+			realtek,function = "ao";
+		};
+
+		etn_led_pins: etn_led_pins {
+			realtek,pins = "etn_led_link",
+				"etn_led_rxtx";
+			realtek,function = "etn_led";
+		};
+
+		nat_led_pins: nat_led_pins {
+			realtek,pins = "nat_led_0", "nat_led_2";
+			realtek,function = "nat_led";
+		};
+
+		mdio_pins: mdio_pins {
+			realtek,pins = "rgmii0_mdio",
+				"rgmii0_mdc";
+			realtek,function = "rgmii";
+		};
+
+		rgmii0_pins: rgmii0_pins {
+			realtek,pins = "rgmii0_txc",
+				"rgmii0_tx_ctl",
+				"rgmii0_txd_0",
+				"rgmii0_txd_1",
+				"rgmii0_txd_2",
+				"rgmii0_txd_3",
+				"rgmii0_rxc",
+				"rgmii0_rx_ctl",
+				"rgmii0_rxd_0",
+				"rgmii0_rxd_1",
+				"rgmii0_rxd_2",
+				"rgmii0_rxd_3",
+				"rgmii0_mdio",
+				"rgmii0_mdc";
+			realtek,function = "rgmii";
+		};
+
+		rgmii1_pins: rgmii1_pins {
+			realtek,pins = "rgmii1_txc",
+				"rgmii1_tx_ctl",
+				"rgmii1_txd_0",
+				"rgmii1_txd_1",
+				"rgmii1_txd_2",
+				"rgmii1_txd_3",
+				"rgmii1_rxc",
+				"rgmii1_rx_ctl",
+				"rgmii1_rxd_0",
+				"rgmii1_rxd_1",
+				"rgmii1_rxd_2",
+				"rgmii1_rxd_3";
+			realtek,function = "rgmii";
+		};
+
+		pcie1_clk_pins: pcie1_clk_pins {
+			realtek,pins = "pcie_clkreq_0";
+			realtek,function = "pcie";
+		};
+
+		pcie2_clk_pins: pcie2_clk_pins {
+			realtek,pins = "pcie_clkreq_1";
+			realtek,function = "pcie";
+		};
+
+		scpu_ejtag_pins_loc_gpio: scpu_ejtag_pins_loc_gpio {
+			realtek,pins = "gpio_4",
+				"gpio_5",
+				"gpio_6",
+				"gpio_7",
+				"gpio_8",
+				"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc_gpio";
+		};
+
+		scpu_ejtag_pins_loc_cr: scpu_ejtag_pins_loc_cr {
+			realtek,pins = "mmc_cmd",
+				"mmc_clk",
+				"mmc_wp",
+				"mmc_data_0",
+				"mmc_data_3",
+				"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc_cr";
+		};
+
+		acpu_ejtag_pins_loc_iso: acpu_ejtag_pins_loc_iso {
+			realtek,pins = "iso_gpio_4",
+				"iso_gpio_5",
+				"iso_gpio_7",
+				"iso_gpio_2",
+				"iso_gpio_3",
+				"ejtag_avcpu_loc";
+			realtek,function = "acpu_ejtag_loc_iso";
+		};
+
+		dc_fan_sensor_pins: dc_fan_sensor_pins {
+			realtek,pins = "gpio_9";
+			realtek,function = "dc_fan_sensor";
+		};
+
+		pwm0_0_pins: pwm0_0_pins {
+			realtek,pins = "iso_gpio_21";
+			realtek,function = "pwm";
+		};
+
+		pwm0_1_pins: pwm0_1_pins {
+			realtek,pins = "etn_led_link";
+			realtek,function = "pwm";
+		};
+
+		pwm1_0_pins: pwm1_0_pins {
+			realtek,pins = "iso_gpio_22";
+			realtek,function = "pwm";
+		};
+
+		pwm1_1_pins: pwm1_1_pins {
+			realtek,pins = "etn_led_rxtx";
+			realtek,function = "pwm";
+		};
+
+		pwm2_0_pins: pwm2_0_pins {
+			realtek,pins = "iso_gpio_23";
+			realtek,function = "pwm";
+		};
+
+		pwm2_1_pins: pwm2_1_pins {
+			realtek,pins = "nat_led_0";
+			realtek,function = "pwm";
+		};
+
+		pwm3_0_pins: pwm3_0_pins {
+			realtek,pins = "iso_gpio_24";
+			realtek,function = "pwm";
+		};
+
+		pwm3_1_pins: pwm3_1_pins {
+			realtek,pins = "nat_led_1";
+			realtek,function = "pwm";
+		};
+
+		smart_card_pins: smart_card_pins {
+			realtek,pins = "nat_led_0",
+				"nat_led_1",
+				"nat_led_2",
+				"nat_led_3";
+			realtek,function = "sc";
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-qa-rescue-tee.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-qa-rescue-tee.dts
new file mode 100644
index 00000000..ae0c6da
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-qa-rescue-tee.dts
@@ -0,0 +1,227 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x1fc00000 ~ 0x1fc00fff */
+/memreserve/ ACPU_BOOTCODE_PHYS ACPU_BOOTCODE_SIZE;
+/* Framebuffer */
+/memreserve/ 0x22000000 0x17BB000;
+/* TEE OS */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12c00000;
+
+
+
+#include "rtd-1295.dtsi"
+
+/ {
+	model= "Realtek_RTD1295";
+	compatible = "Realtek,rtd-1295";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=64m@576m init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x22000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button, input, default N/A */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute , output, default high */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 21 1 0>; /* igpio21, output, default low */
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	rtc@9801B600 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	ve3@98048000 {
+		status = "disabled";
+	};
+
+	gpu@98050000 {
+		status = "disabled";
+	};
+
+	power_control {
+		dc1_pll {
+			status = "disabled";
+		} ;
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-qa-rescue.dts
new file mode 100644
index 00000000..72fc78d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-qa-rescue.dts
@@ -0,0 +1,225 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x1fc00000 ~ 0x1fc00fff */
+/memreserve/ ACPU_BOOTCODE_PHYS ACPU_BOOTCODE_SIZE;
+/* Framebuffer */
+/memreserve/ 0x22000000 0x17BB000;
+/* TEE OS */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12c00000;
+
+#include "rtd-1295.dtsi"
+
+/ {
+	model= "Realtek_RTD1295";
+	compatible = "Realtek,rtd-1295";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=64m@576m init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x22000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button, input, default N/A */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute , output, default high */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 21 1 0>; /* igpio21, output, default low */
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	rtc@9801B600 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	ve3@98048000 {
+		status = "disabled";
+	};
+
+	gpu@98050000 {
+		status = "disabled";
+	};
+
+	power_control {
+		dc1_pll {
+			status = "disabled";
+		} ;
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-sata.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-sata.dtsi
new file mode 100644
index 00000000..60109ea
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-sata.dtsi
@@ -0,0 +1,48 @@
+/ {
+	/include/ "rtd-129x-sata.dtsi"
+
+	sata_phy: sata_phy@9803FF60 {
+		clocks = <&clk_en_1 7>;
+		sata-phy@0 {
+			reg = <0>;
+			resets = <&rst1 10>;
+			reset-names = "rstn_sata_phy_pow_0";
+			spread-spectrum = <0>;
+			phy-param = <0x00001111>, <0x00005111>, <0x00009111>,
+					<0x336a0511>, <0x336a4511>, <0x336a8511>,
+					<0xE0700111>, <0xE05C4111>, <0xE04A8111>,
+					<0x00150611>, <0x00154611>, <0x00158611>,
+					<0xC6000A11>, <0xC6004A11>, <0xC6008A11>,
+					<0x70000211>, <0x70004211>, <0x70008211>,
+					<0xC6600A11>, <0xC6604A11>, <0xC6608A11>,
+					<0x20041911>, <0x20045911>, <0x20049911>,
+					<0x94aa2011>, <0x94aa6011>, <0x94aaa011>,
+					<0x17171511>, <0x17175511>, <0x17179511>,
+					<0x07701611>, <0x07705611>, <0x07709611>,
+					<0x40002a11>, <0x40006a11>, <0x4000aa11>,
+					<0x27710311>, <0x27684311>, <0x27648311>,
+					<0x29001011>, <0x29005011>, <0x29009011>,
+					<0x40000C11>, <0x40004C11>, <0x40008C11>,
+					<0x00271711>, <0x00275711>, <0x00279711>;
+			/delete-property/ phy-param;
+			tx-driving = <2>;
+			
+			tx-driving-tbl = // user can define tx driving here //
+					<0x94a72011>, <0x94a76011>, <0x94a7a011>,
+					<0x587a2111>, <0x587a6111>, <0x587aa111>;
+			/delete-property/ tx-driving-tbl;
+		};
+	};
+	
+	ahci_sata: sata@9803F000 {
+		clocks = <&clk_en_1 2>, <&clk_en_1 7>;
+		sata-port@0 {
+			reg = <0>;
+			phys = <&sata_phy 0>;
+			resets = <&rst1 5>, <&rst1 7>;
+			reset-names = "rstn_sata_0",
+					"rstn_sata_phy_0";
+			gpios = <&rtk_misc_gpio 16 1 1>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-usb.dtsi
new file mode 100644
index 00000000..01695b7
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-usb.dtsi
@@ -0,0 +1,43 @@
+
+/ {
+	/include/ "rtd-129x-usb.dtsi"
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+
+		status = "okay";
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+		};
+
+		rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			drd_mode; //depend on dr_mode = "peripheral"
+		};
+
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,dwc3";
+
+		status = "okay";
+	};
+
+	ehci@98013000 {
+		compatible = "Realtek,rtd129x-ehci";
+
+		status = "okay";
+	};
+
+	ohci@98013400 {
+		compatible = "Realtek,rtd129x-ohci";
+
+		status = "okay";
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-videonas-giraffe-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-videonas-giraffe-2GB.dts
new file mode 100644
index 00000000..760b7de
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-videonas-giraffe-2GB.dts
@@ -0,0 +1,164 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE */
+/memreserve/ 0x00000000 0x00030000;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01b00000 ~ 0x01efffff ACPU_FIREWARE_PHYS ACPU_FIREWARE_SIZE */
+/memreserve/ 0x01B00000 0x00400000;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02600000 ~ 0x02dfffff ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE */
+/memreserve/ 0x02600000 0x00800000;
+/* 0x02E00000 ~ 0x0fffffff ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 */
+/memreserve/ 0x02E00000 0x0D200000;
+/* 0x10000000 ~ 0x10013fff ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE */
+/memreserve/ 0x10000000 0x00014000;
+/* 0x12000000 ~ 0x1f4fffff ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 */
+/memreserve/ 0x12000000 0x0D500000;
+
+
+#include "rtd-1295.dtsi"
+#include "rtd-1295-giraffe-common.dtsi"
+
+/ {
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x02600000
+				0x00800000
+				ION_AUDIO_HEAP_FLAG>;
+	};
+
+	rtk,ion-heap@7 { /* TYPE_MEDIA */
+		compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x02E00000
+				0x0D200000
+				ION_MEDIA_HEAP_FLAG1
+				0x12000000
+				0x0D500000
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <1>;
+		resolution = <1920 1080>;
+		fps = <60>;
+		osd-init = <1>;
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};		
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-xen-hdmirxEDID.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-xen-hdmirxEDID.dtsi
new file mode 100644
index 00000000..b4a653d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-xen-hdmirxEDID.dtsi
@@ -0,0 +1,61 @@
+/*
+ * rtd-1295-hdmirxEDID.dtsi - HDMI Rx EDID table for REALTEK 1295 SoC
+ */
+
+/{
+	passthrough{
+	hdmirx@98034000 {
+		Realtek,edid-table = <
+			0x00 0xFF 0xFF 0xFF 0xFF 0xFF 0xFF 0x00 0x4A 0x8B 0x95
+			0x12 0x00 0x00 0x00 0x00 0xFF 0x1A 0x01 0x03 0x81 0x46
+			0x27 0x78 0x8A 0xA5 0x8E 0xA6 0x54 0x4A 0x9C 0x26 0x12
+			0x45 0x46 0x21 0x08 0x00 0xD1 0xC0 0x81 0xC0 0x01 0x01
+			0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x02
+			0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C 0x45 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x01 0x1D 0x00 0x72 0x51
+			0xD0 0x1E 0x20 0x6E 0x28 0x55 0x00 0x20 0xC2 0x31 0x00
+			0x00 0x1E 0x00 0x00 0x00 0xFD 0x00 0x32 0x4B 0x18 0x3C
+			0x0B 0x00 0x0A 0x20 0x20 0x20 0x20 0x20 0x20 0x00 0x00
+			0x00 0xFC 0x00 0x52 0x54 0x44 0x31 0x32 0x39 0x35 0x0A
+			0x20 0x20 0x20 0x20 0x20 0x01 0xAC 0x02 0x03 0x29 0x71
+			0x83 0x01 0x00 0x00 0x6E 0x03 0x0C 0x00 0x10 0x00 0x00
+			0x3C 0x20 0x00 0x80 0x01 0x02 0x03 0x04 0x49 0x90 0x1F
+			0x22 0x20 0x05 0x14 0x04 0x11 0x02 0x23 0x09 0x7F 0x07
+			0xE3 0x05 0x03 0x00 0x02 0x3A 0x80 0x18 0x71 0x38 0x2D
+			0x40 0x58 0x2C 0x45 0x00 0x20 0xC2 0x31 0x00 0x00 0x1E
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x7F>;
+
+		Realtek,edid2p0-table = <
+			0x00 0xFF 0xFF 0xFF 0xFF 0xFF 0xFF 0x00 0x4A 0x8B 0x95
+			0x12 0x00 0x00 0x00 0x00 0xFF 0x1A 0x01 0x03 0x81 0x46
+			0x27 0x78 0x8A 0xA5 0x8E 0xA6 0x54 0x4A 0x9C 0x26 0x12
+			0x45 0x46 0x21 0x08 0x00 0xD1 0xC0 0x81 0xC0 0x01 0x01
+			0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x01 0x02
+			0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C 0x45 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x01 0x1D 0x00 0x72 0x51
+			0xD0 0x1E 0x20 0x6E 0x28 0x55 0x00 0x20 0xC2 0x31 0x00
+			0x00 0x1E 0x00 0x00 0x00 0xFD 0x00 0x32 0x4B 0x18 0x3C
+			0x0B 0x00 0x0A 0x20 0x20 0x20 0x20 0x20 0x20 0x00 0x00
+			0x00 0xFC 0x00 0x52 0x54 0x44 0x31 0x32 0x39 0x35 0x0A
+			0x20 0x20 0x20 0x20 0x20 0x01 0xAC 0x02 0x03 0x3A 0x71
+			0x83 0x01 0x00 0x00 0x6E 0x03 0x0C 0x00 0x10 0x00 0x00
+			0x3C 0x20 0x00 0x80 0x01 0x02 0x03 0x04 0x67 0xD8 0x5D
+			0xC4 0x01 0x77 0x80 0x00 0x4F 0x5D 0x5E 0x5F 0x60 0x61
+			0x62 0x90 0x1F 0x22 0x20 0x05 0x14 0x04 0x11 0x02 0x23
+			0x09 0x7F 0x07 0xE3 0x05 0x03 0x00 0xE2 0x0F 0x18 0x08
+			0xE8 0x00 0x30 0xF2 0x70 0x5A 0x80 0xB0 0x58 0x8A 0x00
+			0x20 0xC2 0x31 0x00 0x00 0x1E 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x8F>;
+	};
+	}; /* passthrough */
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-xen-irda.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-xen-irda.dtsi
new file mode 100644
index 00000000..bcb1f8a
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-xen-irda.dtsi
@@ -0,0 +1,53 @@
+/*
+ * rtd-1295-irda.dtsi - IRDA remote Device Tree Include file for REALTEK 1295 family SoC
+ */
+
+/ {
+	passthrough {
+	irda@98007400 {
+		irda_rx0 {
+			irrx-protocol = "NEC";
+			transcode-mode = <1>;
+
+			cust-code = <0x7F80>;
+			scancode-msk = <0x00FF0000>;  
+			custcode-msk = <0x0000FFFF>;  
+			keymap-tbl = <
+			// scancode	keycode
+				0x18 	116		//KEY_POWER		//POWER
+				0x5A 	353		//KEY_SELECT		//SOURCE
+				0x58 	154		//KEY_CYCLEWINDOWS	//PIP
+				0x1A 	377		//KEY_TV		//TV SYSTEM
+				0x14 	102		//KEY_HOME		//HOME
+				0x56 	357		//KEY_OPTION		//OPTION MENU
+				0x54	358		//KEY_INFO		//MEDIA_INFO
+				0x19 	232		//KEY_REPLY		//REPEAT
+				0x57 	158		//KEY_BACK		//RETURN
+				0x55 	207		//KEY_PLAY		//PLAY/PAUSE
+				0x17 	128		//KEY_STOP		//STOP
+				0x15 	372		//KEY_ZOOM		//ZOOM_IN
+				0x4F 	168		//KEY_REWIND		//FR
+				0x4D 	103		//KEY_UP		//UP
+				0x16 	208		//KEY_FASTFORWARD	//FF
+				0x0C 	105		//KEY_LEFT		//LEFT
+				0x4C 	352		//KEY_OK		//OK
+				0x0E 	106		//KEY_RIGHT		//RIGHT
+				0x08 	412		//KEY_PREVIOUS		//PREVIOUS
+				0x48 	108		//KEY_DOWN		//DOWN
+				0x09 	407		//KEY_NEXT		//NEXT
+				0x4B 	114		//KEY_VOLUMEDOWN	//VOL-
+				0x49 	115		//KEY_VOLUMEUP		//VOL+
+				0x0B 	532		//KEY_TOUCHPAD_OFF	//CURSOR
+				0x0A 	531		//KEY_TOUCHPAD_ON	//GESTURE
+				0xEEEE	0		//REL_X			//mouse X-axi	0xEEEE : REL event type
+				0xEEEE	1		//REL_Y			//mouse Y-axi	0xEEEE : REL event type
+				0xFFFF	272		//BTN_LEFT		//mouse left key	0xFFFF : KEY event type
+				0xFFFF	113     	//KEY_MUTE 		//mute key in AirFunAPP	0xFFFF : KEY event type	
+           		>; 
+			reg-ir-dpir = <50>;	/*IR detect interval, NEC default=50ms, should less than 100ms, and bigger than 9ms*/
+			sample-rate = <40>;
+		};
+	};
+	}; /* passthrough */
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-xen-pinctrl-domu.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-xen-pinctrl-domu.dtsi
new file mode 100644
index 00000000..79fdfc8
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295-xen-pinctrl-domu.dtsi
@@ -0,0 +1,344 @@
+
+/ {
+	passthrough {
+	pinctrl@9801A000 {
+		sdcard_pins_low: sdcard_low {
+			realtek,pins= "mmc_data_3",
+				"mmc_data_2",
+				"mmc_data_1",
+				"mmc_data_0",
+				"mmc_clk",
+				"mmc_cmd";
+			realtek,function="sd_card";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <0>;
+		};
+
+		sdcard_pins_high: sdcard_high {
+			realtek,pins="mmc_cd", "mmc_wp";
+			realtek,function="sd_card";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <1>;
+		};
+
+		sdio_pins: sdio_pins {
+			realtek,pins = "sdio_cmd",
+				"sdio_data_0",
+				"sdio_data_1",
+				"sdio_data_2",
+				"sdio_data_3",
+				"sdio_clk";
+			realtek,function = "sdio";
+		};
+
+		uart0_pins: uart0_pins {
+			realtek,pins = "ur0_rx",
+				"ur0_tx";
+			realtek,function = "uart0";
+		};
+
+		uart1_pins: uart1_pins {
+			realtek,pins = "ur1_rx",
+				"ur1_tx",
+				"ur1_cts_n",
+				"ur1_rts_n";
+			realtek,function = "uart1";
+		};
+
+		uart2_pins_0: uart2_pins_0 {
+			realtek,pins = "ur2_loc",
+				"iso_gpio_2",
+				"iso_gpio_3",
+				"iso_gpio_4",
+				"iso_gpio_5";
+			realtek,function = "uart2_0";//iso_2_3_4_5
+		};
+
+		uart2_pins_1: uart2_pins_1 {
+			realtek,pins ="ur2_loc",
+				"iso_gpio_23",
+				"iso_gpio_24",
+				"iso_gpio_33",
+				"iso_gpio_34";
+			realtek,function = "uart2_1";//iso_23_24_33_34
+		};
+
+		i2c_pins_0: i2c_pins_0 {
+			realtek,pins = "i2c_scl_0",
+				"i2c_sda_0";
+			realtek,function = "i2c0";
+		};
+
+		i2c_pins_1: i2c_pins_1 {
+			realtek,pins = "i2c_scl_1",
+				"i2c_sda_1";
+			realtek,function = "i2c1";
+		};
+
+		i2c_pins_2: i2c_pins_2 {
+			realtek,pins = "tp1_clk",
+				"tp1_sync";
+			realtek,function = "i2c2";
+		};
+
+		i2c_pins_3: i2c_pins_3 {
+			realtek,pins = "tp1_data",
+				"tp1_valid";
+			realtek,function = "i2c3";
+		};
+
+		i2c_pins_4: i2c_pins_4 {
+			realtek,pins = "i2c_sda_4",
+				"i2c_scl_4";
+			realtek,function = "i2c4";
+		};
+
+		i2c_pins_5: i2c_pins_5 {
+			realtek,pins = "i2c_sda_5",
+				"i2c_scl_5";
+			realtek,function = "i2c5";
+		};
+
+		i2c_pins_6: i2c_pins_6 {
+			realtek,pins = "i2c_scl_6",
+				"i2c_sda_6";
+			realtek,function = "i2c6";
+		};
+
+		spi_pins_loc_spi: spi_pins_loc_spi {
+			realtek,pins = "gpio_0",
+				"gpio_1",
+				"gpio_2",
+				"gpio_3",
+				"sf_en";
+			realtek,function = "spi";
+		};
+
+		spi_pins_loc_gpio: spi_pins_loc_gpio {
+			realtek,pins = "gpio_0",
+				"gpio_1",
+				"gpio_2",
+				"gpio_3",
+				"sf_en";
+			realtek,function = "gpio";
+		};
+
+		gspi_pins: gspi_pins {
+			realtek,pins = "gpio_4",
+				"gpio_5",
+				"gpio_6",
+				"gpio_7";
+			realtek,function = "gspi";
+		};
+
+		tp0_loc_tp0_pins: tp0_loc_tp0_pins {
+			realtek,pins = "tp0_loc",
+				"tp0_data",
+				"tp0_sync",
+				"tp0_valid",
+				"tp0_clk";
+			realtek,function = "tp0_loc_tp0";
+		};
+
+		tp0_loc_rgmii_pins: tp0_loc_rgmii_pins {
+			realtek,pins = "tp0_loc",
+				"rgmii0_txd_0",
+				"rgmii0_txd_1",
+				"rgmii0_txd_2",
+				"rgmii0_txd_3";
+			realtek,function = "tp0_loc_rgmii0_tx";
+		};
+
+		tp1_loc_tp1_pins: tp1_loc_tp1_pins {
+			realtek,pins = "tp1_loc",
+				"tp1_data",
+				"tp1_sync",
+				"tp1_valid",
+				"tp1_clk";
+			realtek,function = "tp1_loc_tp1";
+		};
+
+		tp1_loc_rgmii_pins: tp1_loc_rgmii_pins {
+			realtek,pins = "tp1_loc",
+				"rgmii0_rxd_0",
+				"rgmii0_rxd_1",
+				"rgmii0_rxd_2",
+				"rgmii0_rxd_3";
+			realtek,function = "tp1_loc_rgmii0_rx";
+		};
+
+		ir_rx_pins: ir_rx_pins {
+			realtek,pins = "ir_rx";
+			realtek,function = "ir_rx";
+		};
+
+		ir_tx_pins: ir_tx_pins {
+			realtek,pins = "ir_tx";
+			realtek,function = "ir_tx";
+		};
+
+		spdif_pins: spdif_pins {
+			realtek,pins = "spdif";
+			realtek,function = "spdif_out";
+		};
+
+		i2s_out_4pins: i2s_out_4pins {
+			realtek,pins ="ao_lrck",
+				"ao_bck",
+				"aock",
+				"ao_sd_0";
+			realtek,function = "ao";
+		};
+
+		i2s_out_6pins: i2s_out_6pins {
+			realtek,pins = "ao_lrck",
+				"ao_bck",
+				"aock",
+				"ao_sd_0",
+				"ao_sd_1",
+				"ao_sd_2";
+			realtek,function = "ao";
+		};
+
+		etn_led_pins: etn_led_pins {
+			realtek,pins = "etn_led_link",
+				"etn_led_rxtx";
+			realtek,function = "etn_led";
+		};
+
+		mdio_pins: mdio_pins {
+			realtek,pins = "rgmii0_mdio",
+				"rgmii0_mdc";
+			realtek,function = "rgmii";
+		};
+
+		rgmii0_pins: rgmii0_pins {
+			realtek,pins = "rgmii0_txc",
+				"rgmii0_tx_ctl",
+				"rgmii0_txd_0",
+				"rgmii0_txd_1",
+				"rgmii0_txd_2",
+				"rgmii0_txd_3",
+				"rgmii0_rxc",
+				"rgmii0_rx_ctl",
+				"rgmii0_rxd_0",
+				"rgmii0_rxd_1",
+				"rgmii0_rxd_2",
+				"rgmii0_rxd_3",
+				"rgmii0_mdio",
+				"rgmii0_mdc";
+			realtek,function = "rgmii";
+		};
+
+		rgmii1_pins: rgmii1_pins {
+			realtek,pins = "rgmii1_txc",
+				"rgmii1_tx_ctl",
+				"rgmii1_txd_0",
+				"rgmii1_txd_1",
+				"rgmii1_txd_2",
+				"rgmii1_txd_3",
+				"rgmii1_rxc",
+				"rgmii1_rx_ctl",
+				"rgmii1_rxd_0",
+				"rgmii1_rxd_1",
+				"rgmii1_rxd_2",
+				"rgmii1_rxd_3";
+			realtek,function = "rgmii";
+		};
+
+		pcie1_clk_pins: pcie1_clk_pins {
+			realtek,pins = "pcie_clkreq_0";
+			realtek,function = "pcie";
+		};
+
+		pcie2_clk_pins: pcie2_clk_pins {
+			realtek,pins = "pcie_clkreq_1";
+			realtek,function = "pcie";
+		};
+
+		scpu_ejtag_pins_loc_gpio: scpu_ejtag_pins_loc_gpio {
+			realtek,pins = "gpio_4",
+				"gpio_5",
+				"gpio_6",
+				"gpio_7",
+				"gpio_8",
+				"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc_gpio";
+		};
+
+		scpu_ejtag_pins_loc_cr: scpu_ejtag_pins_loc_cr {
+			realtek,pins = "mmc_cmd",
+				"mmc_clk",
+				"mmc_wp",
+				"mmc_data_0",
+				"mmc_data_3",
+				"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc_cr";
+		};
+
+		acpu_ejtag_pins_loc_iso: acpu_ejtag_pins_loc_iso {
+			realtek,pins = "iso_gpio_4",
+				"iso_gpio_5",
+				"iso_gpio_7",
+				"iso_gpio_2",
+				"iso_gpio_3",
+				"ejtag_avcpu_loc";
+			realtek,function = "acpu_ejtag_loc_iso";
+		};
+
+		dc_fan_sensor_pins: dc_fan_sensor_pins {
+			realtek,pins = "gpio_9";
+			realtek,function = "dc_fan_sensor";
+		};
+
+		pwm0_0_pins: pwm0_0_pins {
+			realtek,pins = "iso_gpio_21";
+			realtek,function = "pwm";
+		};
+
+		pwm0_1_pins: pwm0_1_pins {
+			realtek,pins = "etn_led_link";
+			realtek,function = "pwm";
+		};
+
+		pwm1_0_pins: pwm1_0_pins {
+			realtek,pins = "iso_gpio_22";
+			realtek,function = "pwm";
+		};
+
+		pwm1_1_pins: pwm1_1_pins {
+			realtek,pins = "etn_led_rxtx";
+			realtek,function = "pwm";
+		};
+
+		pwm2_0_pins: pwm2_0_pins {
+			realtek,pins = "iso_gpio_23";
+			realtek,function = "pwm";
+		};
+
+		pwm2_1_pins: pwm2_1_pins {
+			realtek,pins = "nat_led_0";
+			realtek,function = "pwm";
+		};
+
+		pwm3_0_pins: pwm3_0_pins {
+			realtek,pins = "iso_gpio_24";
+			realtek,function = "pwm";
+		};
+
+		pwm3_1_pins: pwm3_1_pins {
+			realtek,pins = "nat_led_1";
+			realtek,function = "pwm";
+		};
+
+		smart_card_pins: smart_card_pins {
+			realtek,pins = "nat_led_0",
+				"nat_led_1",
+				"nat_led_2",
+				"nat_led_3";
+			realtek,function = "sc";
+		};
+	};
+	}; /* passthrough */
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295.dtsi
new file mode 100644
index 00000000..8205de5
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1295.dtsi
@@ -0,0 +1,1177 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include "rtd-129x-common.dtsi"
+/include/ "rtd-1295-pinctrl.dtsi"
+/include/ "rtd-1295-irda.dtsi"
+/include/ "rtd-1295-usb.dtsi"
+/include/ "rtd-1295-sata.dtsi"
+/include/ "rtd-1295-hdmirxEDID.dtsi"
+/include/ "rtd-129x-dcsys-debug.dtsi"
+
+/{
+	compatible = "realtek,rtd1295";
+	interrupt-parent = <&gic>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A53_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x0>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x1>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x02>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x03>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		a53_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	soc@0 {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x98000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+	};
+
+	arch_timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <1 13 0xf08>,
+			<1 14 0xf08>,
+			<1 11 0xf08>,
+			<1 10 0xf08>;
+		clock-frequency = <27000000>;
+	};
+
+	gic: interrupt-controller@FF010000 {
+		compatible = "arm,cortex-a15-gic";
+		#interrupt-cells = <3>;
+		interrupt-controller;
+		reg = <0xFF011000 0x1000>,
+			<0xFF012000 0x1000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <0 48 4>;
+		interrupt-affinity = <&A53_0>,
+			<&A53_1>,
+			<&A53_2>,
+			<&A53_3>;
+	};
+
+	pinctrl: pinctrl@9801A000 {
+		compatible = "realtek,rtk129x-pinctrl";
+		reg = <0x9801A000 0x97c>,
+			<0x9804d000 0x010>,
+			<0x98012000 0x640>,
+			<0x98007000 0x340>;
+		#gpio-range-cells = <3>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_6>,
+			<&spdif_pins>,
+			<&spi_pins_loc_gpio>,
+			<&sdcard_pins_low>,
+			<&sdcard_pins_high>;
+		status = "okay";
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x9801B000 0x100>, /* MISC_TOP MISC_ISO */
+			<0x98007000 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		compatible = "realtek,rtk-misc-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>; /*must be the same with gpiochip.of_gpio_n_cells*/
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <101>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <0 19>, <0 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x9801b000 0x100>,
+			<0x9801b100 0x100>; /* MISC_SYS MISC_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 101>;
+		status = "okay";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <101>;
+		Realtek,gpio_numbers = <35>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x98007000 0x100>,
+			<0x98007100 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 101 35>;
+		status = "okay";
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x98000000 0x200000>;
+		status = "okay";
+	};
+
+	md@9800b000 {
+		compatible = "realtek,md";
+		reg = <0x9800b000 0x1000>;
+		interrupts = <0 38 4>; /* 70 - 32 = 38 */
+		clocks = <&clk_en_1 CLK_EN_MD>;
+		resets = <&rst1 RSTN_MD>;
+		status = "okay";
+	};
+
+	se@9800c000 {
+		compatible = "realtek,se";
+		reg = <0x9800c000 0x1000>;
+		interrupts = <0 20 4>; /* 52 - 32 = 20 */
+		clocks = <&clk_en_1 CLK_EN_SE>;
+		resets = <&rst1 RSTN_SE>;
+		power-domains = <&pd0 PD_SRAM_DISP_SE>;
+		status = "okay";
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x9801b000 0x1000>;
+		status = "okay";
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd129x-hdmitx";
+		reg = <0x9800d000 0x560>, /* HDMITX */
+			<0x98007200 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 6 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&rst1 RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		status = "okay";
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 31>;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtk129x-hdcptx";
+		reg = <0x9800d000 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		status = "okay";
+	};
+
+	hdmirx@98034000 {
+		compatible = "Realtek,rtk-mipi-top";
+		reg = <0x98037000 0xE0>,
+			<0x98034000 0xF54>,
+			<0x98035F00 0x2C>,
+			<0x98037700 0x98>,
+			<0x98004000 0xF0>,
+			<0x98004100 0x104>;
+		interrupts = <0 23 4>;
+		gpio-rx-hpd-ctrl = <&rtk_iso_gpio 22 1 0>;
+		//gpio-5v-detect = <&rtk_iso_gpio 21 0 0>;
+		clocks = <&clk_en_2 CLK_EN_HDMIRX>,
+			<&clk_en_1 CLK_EN_MIPI>,
+			<&clk_en_2 CLK_EN_CBUS_TX>,
+			<&iclk_en CLK_EN_CBUS_OSC>,
+			<&iclk_en CLK_EN_CBUS_SYS>,
+			<&iclk_en CLK_EN_CBUSTX_SYS>,
+			<&iclk_en CLK_EN_CBUSRX_SYS>,
+			<&clk_en_1 CLK_EN_TP>,
+			<&clk_en_1 CLK_EN_CP>;
+		clock-names = "hdmirx",
+			"mipi",
+			"cbus_tx",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys",
+			"tp",
+			"cp";
+		resets = <&rst4 RSTN_HDMIRX>,
+			<&rst4 RSTN_HDMIRX_WRAP>,
+			<&rst1 RSTN_MIPI>,
+			<&rst2 RSTN_CBUS_TX>,
+			<&irst IRSTN_CBUS>,
+			<&irst IRSTN_CBUSTX>,
+			<&irst IRSTN_CBUSRX>,
+			<&rst1 RSTN_TP>,
+			<&rst1 RSTN_CP>;
+		reset-names = "hdmirx",
+			"hdmirx_wrap",
+			"mipi",
+			"cbus_tx",
+			"cbus",
+			"cbustx",
+			"cbusrx",
+			"tp",
+			"cp";
+		power-domains = <&pd0 PD_SRAM_DISP_HDMIRX>;
+		status = "okay";
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007800 0x400>,
+			<0x98007000 0x100>;
+		interrupts-st-mask = <0x4>;
+		interrupts = <1 2>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart0_pins>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&iclk_en CLK_EN_MISC_UR0>;
+		clock-frequency = <27000000>; /* This value must be override by the board. */
+		status = "okay";
+	};
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B200 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart1_pins>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR1>;
+		resets = <&rst2 RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+		status = "okay";
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B400 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart2_pins_0>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR2>;
+		resets = <&rst2 RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+		status = "disabled"; /* Disable UR2 first since we don't use it now */
+	};
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x98016000 0x1000>,
+			<0x98007000 0x1000>;
+		interrupts = <0 22 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&rgmii0_pins>,
+			<&etn_led_pins>;
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		output-mode = <0>; /* 0:embedded PHY, 1:RGMII to MAC, 2:RGMII to PHY */
+		rgmii-voltage = <1>; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+		rgmii-tx-delay = <0>; /* 0: 0ns, 1: 2ns */
+		rgmii-rx-delay = <0>; /* 0: 0ns, 1: 2ns */
+		ext-phy-id = <1>; /* 0 ~ 31, only valid when output-mode = 2 */
+		clocks = <&iclk_en CLK_EN_ETN_250M>,
+			<&iclk_en CLK_EN_ETN_SYS>;
+		clock-names = "etn_250m",
+			"etn_sys";
+		resets = <&irst IRSTN_GMAC>,
+			<&irst IRSTN_GPHY>;
+		reset-names = "gmac",
+			"gphy";
+		status = "okay";
+	};
+
+	hwnat: gmac@98060000 {
+		compatible = "Realtek,rtd1295-hwnat";
+		reg = <0x98060000 0x170000>, /* NAT */
+			<0x98000000 0x20000>, /* CLK SYS */
+			<0x9803FF00 0x100>; /* SATA Wrapper */
+		interrupts = <0 24 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&rgmii0_pins>,
+			<&nat_led_pins>;
+		offload_enable = <0>; /* 0:disable, 1:enable HW NAT offload */
+		rgmii_voltage = <1>; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+		rgmii0_tx_delay = <0>; /* 0 to 7: 0.5ns per step */
+		rgmii0_rx_delay = <4>; /* 0 to 7: 0.5ns per step */
+		rgmii1_tx_delay = <0>; /* 0 to 7: 0.5ns per step */
+		rgmii1_rx_delay = <4>; /* 0 to 7: 0.5ns per step */
+		rgmii_enable = <1>; /* 0:disable, 1:enable */
+		mac0_enable = <0>; /* 0:disable, 1:enable */
+		mac0_mode = <1>; /* 0:RGMII to PHY, 1:SGMII to PHY, 2: RGMII to MAC, 3: SGMII to MAC */
+		mac5_conn_to = <0>; /* 0:PHY, 1:MAC */
+		mac0_phy_id = <3>; /* PHY ID 2 for RGMII, 3 for SGMII */
+		mac4_phy_id = <4>;
+		mac5_phy_id = <1>;
+		led_mode = <1>; /* 0~3: SCAN_0~3, 4~6: DIRECT 0~2 */
+		gpio_link_led_enable = <0>; /* 0:disable, 1:enable */
+		gpios = <&rtk_iso_gpio 27 1 0>; /* Link LED, output, default low */
+
+		clocks = <&cc CC_PLL_DDSA>,
+			<&clk_en_1 CLK_EN_SATA_0>,
+			<&clk_en_1 CLK_EN_SATA_ALIVE_0>,
+			<&clk_en_2 CLK_EN_SATA_1>,
+			<&clk_en_2 CLK_EN_SATA_ALIVE_1>,
+			<&cc CC_PLL_DDSB>,
+			<&clk_en_2 CLK_EN_NAT>,
+			<&iclk_en CLK_EN_ETN_250M>,
+			<&iclk_en CLK_EN_ETN_SYS>;
+		clock-names = "pll_ddsa",
+			"sata_0",
+			"sata_alive_0",
+			"sata_1",
+			"sata_alive_1",
+			"pll_ddsb",
+			"nat",
+			"etn_250m",
+			"etn_sys";
+		resets = <&rst1 RSTN_SATA_0>,
+			<&rst1 RSTN_SATA_PHY_0>,
+			<&rst1 RSTN_SATA_PHY_POW_0>,
+			<&rst1 SATA_FUNC_EXIST_0>,
+			<&rst2 RSTN_SDS_PHY>,
+			<&rst1 RSTN_NAT>,
+			<&irst IRSTN_GMAC>,
+			<&irst IRSTN_GPHY>;
+		reset-names = "sata_0",
+			"sata_phy_0",
+			"sata_phy_pow_0",
+			"sata_func_exist_0",
+			"rstn_sds_phy",
+			"nat",
+			"gmac",
+			"gphy";
+		power-domains = <&pd0 PD_SRAM_NAT>;
+		status = "disabled";
+	};
+
+	timer0@9801B000 {
+		compatible = "realtek,rtk-timer0";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 17 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	timer1@9801B000 {
+		compatible = "realtek,rtk-timer1";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 18 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	pcie@9804E000 {
+		compatible = "realtek,rtk-pcie-slot1";
+		reg = <0x9804E000 0x00001000
+			0x9804F000 0x00001000
+			0x9801C600 0x00000100
+			0x9801A000 0x00000300
+			0x98012000 0x00001000>;
+		interrupt-names = "rtk-pcie1-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic GIC_SPI 61 IRQ_TYPE_LEVEL_HIGH>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie1_clk_pins>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <0>;
+		device_type = "pci";
+		gpios = <&rtk_misc_gpio 18 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		ranges = <0x02000000 0x00000000 0xC0000000  0xC0000000 0x00000000 0x01000000
+			0x01000000 0x00000000 0x00030000  0x00030000 0x00000000 0x00010000>;
+		resets = <&rst2 RSTN_PCIE0>,
+			<&rst2 RSTN_PCIE0_CORE>,
+			<&rst2 RSTN_PCIE0_POWER>,
+			<&rst2 RSTN_PCIE0_NONSTITCH>,
+			<&rst2 RSTN_PCIE0_STITCH>,
+			<&rst2 RSTN_PCIE0_PHY>,
+			<&rst4 RSTN_PCIE0_PHY_MDIO>;
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_1 CLK_EN_PCIE0>;
+		debug-mode = <0>;
+		status = "okay";
+		phys_a = <0x31810801>,
+			<0xB2001101>,
+			<0x00100001>;
+		phys_b = <0x00000003>,
+			<0x00900001>,
+			<0x40080401>,
+			<0x5AC10801>,
+			<0x32b40f01>,
+			<0x72001101>;
+	};
+
+	pcie2@9803B000 {
+		compatible = "realtek,rtk-pcie-slot2";
+		reg = <0x9803B000 0x00001000
+			0x9803C000 0x00001000
+			0x9801C600 0x00000100
+			0x9801A000 0x00000300
+			0x98012000 0x00001000>;
+		interrupt-names = "rtk-pcie2-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic GIC_SPI 62 IRQ_TYPE_LEVEL_HIGH>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie2_clk_pins>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <1>;
+		device_type = "pci";
+		gpios = <&rtk_misc_gpio 20 1 0>;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		ranges = <0x02000000 0x00000000 0xC1000000  0xC1000000 0x00000000 0x01000000
+			0x01000000 0x00000000 0x00040000  0x00040000 0x00000000 0x00010000>;
+		speed-mode = <0>; // 0:GEN1, 1:GEN2
+		debug-mode = <0>;
+		resets = <&rst2 RSTN_PCIE1>,
+			<&rst2 RSTN_PCIE1_CORE>,
+			<&rst2 RSTN_PCIE1_POWER>,
+			<&rst2 RSTN_PCIE1_NONSTITCH>,
+			<&rst2 RSTN_PCIE1_STITCH>,
+			<&rst2 RSTN_PCIE1_PHY>,
+			<&rst4 RSTN_PCIE1_PHY_MDIO>;
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_2 CLK_EN_PCIE1>;
+		status = "okay";
+		phys = <0x00000003>, /* #Write soft reset */
+			<0x27E90301>,
+			<0x52F50401>, /* #F code,close SSC */
+			<0xead70501>, /* #modify N code */
+			<0x000c0601>, /* #modify CMU ICP(TX jitter) */
+			<0xa6530a01>, /* #modify CMU RS(tx jitter) */
+			<0xC4662001>, /* #modify AMP */
+			<0x8EA01B01>,
+			<0x8EA05B01>,
+			<0xa84a0101>, /* #modify Rx parameter */
+			<0xb8032b01>, /* #clk driving */
+			<0x27e94301>, /* #EQ */
+			<0x52f54401>, /* #F code,close SSC */
+			<0xead74501>, /* #modify N code */
+			<0x000c4601>, /* #modify CMU ICP(TX jitter) */
+			<0xa6534a01>, /* #modify CMU RS(tx jitter) */
+			<0xd4776001>, /* #modify AMP */
+			<0xa84a4101>, /* #modify Rx parameter */
+			<0xa8036b01>, /* #clk driving */
+			<0x01225a01>,
+			<0x521C0901>, /* #for calibration bit[9]=1" */
+			<0x501C0901>, /* #for calibration bit[9]=0" */
+			<0x521C0901>, /* #for calibration bit[9]=1" */
+			<0x08282401>,
+			<0x08286401>;
+	};
+
+	sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 23 1 1>;
+		reg = <0x98010c00 0x200>,
+			<0x98000000 0x200000>;
+		interrupts = <0 45 4>;
+		clocks = <&clk_en_1 CLK_EN_SDIO>,
+			<&clk_en_1 CLK_EN_SDIO_IP>;
+		clock-names = "sdio",
+			"sdio_ip";
+		resets = <&rst2 RSTN_SDIO>;
+		status = "okay";
+	};
+
+	sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_misc_gpio 99 1 0>; /*sd power , output, default high  (poweroff) */
+		reg = <0x98000000 0x400>, /* CRT */
+			<0x98010400 0x200>, /* SDMMC */
+			<0x9801A000 0x400>, /* BS2 */
+			<0x98012000 0xa00>, /* EMMC */
+			<0x98010A00 0x40>; /* SDIO */
+		interrupts = <0 44 4>;
+		/*pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>,
+			<&sdcard_pins_high>;*/
+		resets = <&rst2 RSTN_CR>;
+		clocks = <&clk_en_1 CLK_EN_CR>,
+			<&clk_en_1 CLK_EN_SD_IP>;
+		clock-names = "cr",
+			"sd_ip";
+		status = "okay";
+	};
+
+	emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		reg = <0x98012000 0xa00>, /*EMMC*/
+			<0x98000000 0x600>, /*CRT */
+			<0x9801A000 0x80>, /*SB2*/
+			<0x9801B000 0x150>, /*MISC*/
+			<0x9801a954 0x20>;  /*SB2_DBG*/
+		interrupts = <0 42 4>;
+		speed-step = <2>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_1 CLK_EN_EMMC>,
+			<&clk_en_1 CLK_EN_EMMC_IP>,
+			<&clk_en_1 CLK_EN_CR>;
+		clock-names = "emmc",
+			"emmc_ip",
+			"cr";
+		resets = <&rst2 RSTN_EMMC>;
+		reset-names = "emmc";
+		status = "okay";
+		pddrive_nf_s0 = <1 0x77 0x77 0x77 0x33>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+		pddrive_nf_s2 = <1 0xbb 0xbb 0xbb 0x33>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+		pddrive_nf_s3 = <1 0xff 0x99 0xaa 0x33>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs400 */
+		phase_tuning = <0 0>; /* arg0: tx tuning switch, arg1: rx tuning switch*/
+		dqs_tuning = <1>;
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk1295-pu_pll";
+		reg = <0x98000000 0x200>;
+	};
+
+	jpeg@9803e000 {
+		compatible = "Realtek,rtk1295-jpeg";
+		reg = <0x9803e000 0x1000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_2 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&rst2 RSTN_JPEG>;
+		status = "okay";
+	};
+
+	ve1@98040000 {
+		compatible = "Realtek,rtk1295-ve1";
+		reg = <0x98040000 0x8000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 53 4>, <0 54 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			<&cc CC_CLK_VE2>;
+		clock-names = "clk_ve1",
+			"clk_ve2";
+		resets = <&rst1 RSTN_VE1>,
+			<&rst1 RSTN_VE2>;
+		reset-names = "ve1",
+			"ve2";
+		status = "okay";
+	};
+
+	ve3@98048000 {
+		compatible = "Realtek,rtk1295-ve3";
+		reg = <0x98048000 0x4000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 55 4>;
+		clocks = <&cc CC_CLK_VE3>;
+		resets = <&rst1 RSTN_VE3>;
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x9801d000 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	sb2_lock_avlog: sb2-lock@9801A63C {
+		reg = <0x9801A63C 0x4>;
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-avlog";
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x9801a000 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	rpc@9801a104 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x9801a104 0xc>, /* rpc intr en */
+			<0x01ffe000 0x4000>, /* rpc ring buffer */
+			<0x0001f000 0x1000>, /* rpc common */
+			<0x9801a020 0x4>; /* rbus sync */
+		interrupts = <0 33 4>;
+		status = "okay";
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007000 0x400>,
+			<0x98007400 0x100>;
+		interrupts = <1 5>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&ir_rx_pins>,
+			<&ir_tx_pins>;
+		resets = <&irst IRSTN_IR>;
+		clocks = <&iclk_en CLK_EN_MISC_IR>;
+		status = "okay";
+	};
+
+	rtc@9801B600 {
+		compatible = "realtek,rtk-rtc";
+		reg = <0x9801B600 0x100>,
+			<0x98007000 0x100>;
+		rtc-base-year = <2014>;
+		clocks = <&clk_en_2 CLK_EN_MISC_RTC>;
+		status = "okay";
+	};
+
+	watchdog@0x98007680 {
+		compatible = "realtek,rtk-watchdog";
+		reg = <0x98007680 0x100>;
+		rst-oe = <0>; /* 0:input, 1:output */
+		timeout-sec = <20>;
+		status = "okay";
+	};
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x98007600 0x100>;
+		rst-reg-offset = <0x40>;
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x98007D00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 8>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_0>;
+		i2c-num = <0>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x98007C00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 11>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_1>;
+		i2c-num = <1>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C1>;
+	};
+
+	i2c_2: i2c@0x9801B700 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801B700 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 26>;
+		i2c-num = <2>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_2>;
+	};
+
+	i2c_3: i2c@0x9801B900 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801B900 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 23>;
+		i2c-num = <3>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_3>;
+	};
+
+	i2c_4: i2c@0x9801BA00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801BA00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 15>;
+		i2c-num = <4>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_4>;
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801BB00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 14>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_5>;
+		i2c-num = <5>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk129x-spi";
+		reg = <0x9801BD00 50>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins>;
+		spi-cs-gpio = <&rtk_misc_gpio 6 1 1>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		resets = <&rst1 RSTN_GSPI>;
+		status = "disabled";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x980070D0 0xC>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pwm0_0_pins>;
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+	};
+
+	rtk_fan: rtk_fan@9801BC00 {
+		compatible = "Realtek,rtd129x-fan";
+		reg = <0x9801BC00 0x14>, <0x9801A910 0x4>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 29>;
+		status = "disabled";
+
+		pwms = <&pwm 1 37878>; // (1) pwm node (2) pwm id (3) out period_ns (1/26400 ns)
+
+		timer_target = <0x100000>;
+		fan_debounce = <0x0>;// 0x0~0x7
+		clocks = <&clk_en_2 CLK_EN_FAN>;
+		resets = <&rst4 RSTN_FAN>;
+	};
+
+	rtk-lsadc@0x98012800 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 21>, <0 22>; /* LSADC0_INT, LSADC1_INT */
+		reg = <0x9801B00C 0x4>, /* MISC_ISR */
+			<0x98012800 0x200>, /* LSADC */
+			<0x9800034C 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>, /* LSADC0 0:disable; 1:enable */
+						<1>; /* LSADC1 0:disable; 1:enable */
+		vdd_mux_sel = <0>; /* 0:VDD1; 1:VDD2 */
+		vdd_mux1 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux2 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux_en = <1>; /* 0:disable; 1:enable */
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <1>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc1-pad0 {
+			//compatible = "Realtek,rtk-lsadc1-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <0>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+
+		rtk-lsadc1-pad1 {
+			//compatible = "Realtek,rtk-lsadc1-pad1";
+			activate = <1>; /* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0: Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <1>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+	};
+
+	cec0@98037800 {
+		compatible = "Realtek,rtk-cec0";
+		reg = <0x98037800 0xe0>,
+			<0x98007000 0x100>,
+			<0x98037500 0x100>;
+		interrupts = <0 26 4>;
+		module-enable = <1>;
+		clocks = <&cc CC_CLK_SYS>,
+			<&iclk_en CLK_EN_CBUS_OSC>,
+			<&iclk_en CLK_EN_CBUS_SYS>,
+			<&iclk_en CLK_EN_CBUSTX_SYS>,
+			<&iclk_en CLK_EN_CBUSRX_SYS>;
+		clock-names = "sys",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys";
+		resets = <&irst IRSTN_CBUS>,
+			<&irst IRSTN_CBUSTX>,
+			<&irst IRSTN_CBUSRX>;
+		reset-names = "cbus",
+			"cbustx",
+			"cbusrx";
+		status = "okay";
+	};
+
+	rfkill: rfkilligpio {
+		compatible = "realtek,rfkill";
+		gpios = <&rtk_iso_gpio 24 1 0>; /*bt power , output, default low */
+		status = "disabled";
+	};
+
+	rtk-gpio-regulator {
+		compatible = "rtkgpio-regulator";
+		gpios = <&rtk_iso_gpio 16 1 0>, <&rtk_iso_gpio 17 1 1>;
+		//status = "disabled";
+		status = "okay";
+		vdd: rtkgpio_regulator {
+			regulator-min-microvolt = <850000>;
+			regulator-max-microvolt = <1050000>;
+		};
+	};
+
+	power-management@0 {
+		compatible = "Realtek,power-management";
+		system-power-controller;
+		reg = <0x98000000 0x1800>, /* CRT */
+			<0x98006000 0x1000>, /* AIO */
+			<0x98007000 0x1000>, /* ISO */
+			<0x98018000 0x2000>, /* TVE */
+			<0x9801A000 0x1000>, /* SB2 */
+			<0x9801B000 0x1000>; /* MISC */
+		suspend-mode = <0>; // 0:SUSPEND_TO_RAM, 1:SUSPEND_TO_COOLBOOT, 2:SUSPEND_TO_WFI
+		pwms = <&pwm 0 37878>;
+		status = "okay";
+	};
+
+	rng@9801AA00 {
+		compatible = "Realtek,rtk-rng";
+		reg = <0x9801AA00 0x48>;
+	};
+
+	smartcard@9801BE00 {
+		compatible = "Realtek,rtk-smc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 24>; /* SC0_INT*/
+		reg = <0x9801B000 0x100>, /* MISC interrupt */
+			<0x9801BE00 0x28>; /* SmartCard */
+		smc-num = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_SC>;
+		resets = <&rst2 RSTN_MISC_SC>;
+		status = "okay";
+		lsic_control{
+			gpios = <&rtk_misc_gpio 11 1 0>, /* pin cmd_vcc , default low */
+				<&rtk_misc_gpio 12 1 0>; /* pin pwr_sel , default 0 */
+			cmd_vcc_en = <1>;
+			cmd_vcc_polarity = <0>; /* low active */
+			pwr_sel_en = <1>;
+			pwr_sel_polarity = <1>; /* high actve 1: 5v */
+		};
+	};
+
+	mcp@0 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x98015000 0x1000>,
+			<0x98014000 0x1000>;
+		status = "okay";
+	};
+
+	rtk_fw_dbg_info {
+		compatible = "Realtek,rtk_fw_dbg_info";
+		status = "okay";
+	};
+
+	rtk_boot {
+		compatible = "Realtek,rtk_boot";
+		resume-entry-addr = <0x00021000>;
+		status = "okay";
+	};
+
+	cpu_tm: thermal-sensor@9801D150 {
+		compatible = "realtek,rtd129x-thermal-sensor";
+		reg = <0x9801D150 0x1C>;
+		#thermal-sensor-cells = <0>;
+
+		userspace-trip = <&cpu_userspace 30000>;
+		status = "okay";
+	};
+
+	cr_tm: thermal-sensor@980124B4 {
+		compatible = "realtek,rtd129x-thermal-sensor";
+		reg = <0x980124B4 0x1C>;
+		#thermal-sensor-cells = <0>;
+		status = "okay";
+	};
+
+	gpu: gpu@98050000 {
+		compatible = "arm,mali-midgard";
+		reg = <0x98050000 0xffff>;
+		interrupts = <0 67 4>, <0 68 4>, <0 66 4>;
+		interrupt-names = "JOB", "MMU", "GPU";
+		clocks = <&cc CC_CLK_GPU>;
+		clock-names = "clk_mali";
+		resets = <&rst1 RSTN_GPU>;
+		mali-supply = <&gpu_supp>;
+		#cooling-cells = <2>;
+		status = "okay";
+		power-model {
+			compatible = "arm,mali-simple-power-model";
+			static-coefficient = <2427750>;
+			dynamic-coefficient = <4687>;
+			ts = <20000 2000 (-20) 2>;
+			thermal-zone = "cpu-thermal";
+		};
+	};
+
+	audio-in-device {
+		compatible = "realtek,audio-in";
+		status = "disabled";
+	};
+
+	audio-out-devices {
+		compatible = "realtek,audio-out";
+		status = "okay";
+		dac {
+			compatible = "dac";
+			status = "okay";
+		};
+		spdif {
+			compatible = "spdif";
+			status = "okay";
+		};
+		i2s {
+			compatible = "i2s";
+			status = "okay";
+		};
+		hdmi {
+			compatible = "hdmi";
+			status = "okay";
+		};
+		global {
+			compatible = "global";
+			status = "okay";
+		};
+	};
+
+	busfreq {
+		compatible = "realtek,rtd129x-busfreq";
+		enable = <1>;
+		polling-ms = <1000>;
+		clocks = <&cc CC_PLL_BUS_H>;
+		status = "okay";
+
+		clk-0 {
+			clocks = <&cc CC_CLK_SYS>;
+			rate = <128 256>;
+		};
+		clk-1 {
+			clocks = <&cc CC_PLL_BUS_H>;
+			rate = <200 459>;
+		};
+	};
+
+	dvfs: dvfs {
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+
+			trips {
+				cpu_alert0: cpu-alert0 {
+					temperature = <105000>;
+					hysteresis = <3000>;
+					type = "passive";
+				};
+				cpu_alert1: cpu-alert1 {
+					temperature = <115000>;
+					hysteresis = <3000>;
+					type = "passive";
+				};
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <2000>;
+					type = "critical";
+				};
+				gpu_alert0: gpu-alert0 {
+					temperature = <95000>;
+					hysteresis = <4000>;
+					type = "passive";
+				};
+				gpu_alert1: gpu-alert1 {
+					temperature = <100000>;
+					hysteresis = <4000>;
+					type = "passive";
+				};
+				cpu_userspace: cpu-userspace {
+					temperature = <150000>;
+					hysteresis = <0>;
+					type = "passive";
+				};
+			};
+
+			cooling-maps {
+				map0 {
+					trip = <&cpu_alert0>;
+					cooling-device = <&A53_0 1 6>;
+				};
+				map1 {
+					trip = <&cpu_alert1>;
+					cooling-device = <&A53_0 7 11>;
+				};
+				map2 {
+					trip = <&gpu_alert0>;
+					cooling-device = <&gpu 2 2>;
+				};
+				map3 {
+					trip = <&gpu_alert1>;
+					cooling-device = <&gpu 5 5>;
+				};
+				map4 {
+					trip = <&cpu_userspace>;
+					cooling-device = <&A53_0 9 9>;
+				};
+			};
+		};
+
+		cr-thermal {
+			polling-delay-passive = <0>;
+			polling-delay = <0>;
+			thermal-sensors = <&cr_tm>;
+		};
+	};
+};
+
+#include "rtd-129x-g2227-regulator.dtsi"
+#include "rtd-129x-gpu-dvfs.dtsi"
+#include "rtd-129x-cpu-dvfs.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-mmnas-saola-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-mmnas-saola-2GB.dts
new file mode 100644
index 00000000..7b27f842
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-mmnas-saola-2GB.dts
@@ -0,0 +1,156 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE */
+/memreserve/ 0x00000000 0x00030000;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01b00000 ~ 0x01efffff ACPU_FIREWARE_PHYS ACPU_FIREWARE_SIZE */
+/memreserve/ 0x01B00000 0x00400000;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02600000 ~ 0x02dfffff ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE */
+/memreserve/ 0x02600000 0x00800000;
+/* 0x02E00000 ~ 0x0fffffff ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 */
+/memreserve/ 0x02E00000 0x0D200000;
+/* 0x10000000 ~ 0x10013fff ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE */
+/memreserve/ 0x10000000 0x00014000;
+/* 0x12000000 ~ 0x1f4fffff ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 */
+/memreserve/ 0x12000000 0x0D500000;
+
+
+#include "rtd-1296.dtsi"
+#include "rtd-1296-saola-common.dtsi"
+
+/ {
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x02600000
+				0x00800000
+				ION_AUDIO_HEAP_FLAG>;
+	};
+
+	rtk,ion-heap@7 { /* TYPE_MEDIA */
+		compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x02E00000
+				0x0D200000
+				ION_MEDIA_HEAP_FLAG1
+				0x12000000
+				0x0D500000
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+	
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-nas-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-nas-qa-rescue.dts
new file mode 100644
index 00000000..3825f49
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-nas-qa-rescue.dts
@@ -0,0 +1,161 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+#undef ROOTFS_RESCUE_END
+#define ROOTFS_RESCUE_END (ROOTFS_RESCUE_START + 0x00100000)
+
+/* 0x00000000 ~ 0x0002ffff SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE */
+/memreserve/ 0x00000000 0x00030000;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02600000 ~ 0x02dfffff ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE */
+/memreserve/ 0x02600000 0x00800000;
+/* 0x02E00000 ~ 0x0fffffff ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 */
+/memreserve/ 0x02E00000 0x0D200000;
+/* 0x10000000 ~ 0x10013fff ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE */
+/memreserve/ 0x10000000 0x00014000;
+/* 0x12000000 ~ 0x1f4fffff ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 */
+/memreserve/ 0x12000000 0x0D500000;
+
+
+#include "rtd-1296.dtsi"
+
+/ {
+	model= "Realtek_RTD1296";
+	compatible = "Realtek,rtd-1296";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x02600000
+				0x00800000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x02E00000
+				0x0D200000
+				ION_MEDIA_HEAP_FLAG1
+				0x12000000
+				0x0D500000
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios =<&rtk_iso_gpio 21 1 0>;  /* igpio21, output, default low */
+	};
+
+	/* 
+	 * pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50
+	 * pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200
+	 */
+	 emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		pddrive_nf_s0 = <0x77 0x77 0x77 0x77 0x77>;
+		pddrive_nf_s2 = <0xbb 0xbb 0xbb 0xbb 0xbb>;
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-nas-saola-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-nas-saola-2GB.dts
new file mode 100644
index 00000000..11065b4
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-nas-saola-2GB.dts
@@ -0,0 +1,156 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE */
+/memreserve/ 0x00000000 0x00030000;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01b00000 ~ 0x01efffff ACPU_FIREWARE_PHYS ACPU_FIREWARE_SIZE */
+/memreserve/ 0x01B00000 0x00400000;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02600000 ~ 0x02dfffff ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE */
+/memreserve/ 0x02600000 0x00800000;
+/* 0x02E00000 ~ 0x0fffffff ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 */
+/memreserve/ 0x02E00000 0x0D200000;
+/* 0x10000000 ~ 0x10013fff ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE */
+/memreserve/ 0x10000000 0x00014000;
+/* 0x12000000 ~ 0x1f4fffff ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 */
+/memreserve/ 0x12000000 0x0D500000;
+
+
+#include "rtd-1296.dtsi"
+#include "rtd-1296-saola-common.dtsi"
+
+/ {
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x02600000
+				0x00800000
+				ION_AUDIO_HEAP_FLAG>;
+	};
+
+	rtk,ion-heap@7 { /* TYPE_MEDIA */
+		compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x02E00000
+				0x0D200000
+				ION_MEDIA_HEAP_FLAG1
+				0x12000000
+				0x0D500000
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};		
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-1GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-1GB.dts
new file mode 100644
index 00000000..90e4fec
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-1GB.dts
@@ -0,0 +1,104 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS	 RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#include "rtd-129x-ion-1GB.dtsi"
+#include "rtd-1296.dtsi"
+#include "rtd-1296-pinnata-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <720 480>;
+		fps = <60>;
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-2GB-tee.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-2GB-tee.dts
new file mode 100644
index 00000000..d0567a5
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-2GB-tee.dts
@@ -0,0 +1,180 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS	 RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-129x-ion-2GB-tee.dtsi"
+#include "rtd-1296.dtsi"
+#include "rtd-1296-pinnata-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+		tee_reserved: tee {
+                        no-map;
+                        size = <0x04100000>;
+                        alloc-ranges = <0x10100000 0x04100000>;
+                };
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_dwc3_drd@98013200 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+	
+	alc5680_sound {
+		compatible = "Realtek,rtk-alc5680";
+		gpios =
+			<&rtk_misc_gpio 6 1 1>,  /* chip sel, output, default high */
+			<&rtk_misc_gpio 54 1 0>; /* reset pin, output, default low */	
+		status = "okay";
+	};
+};
+
+&i2c_4 {
+		adc3x01_codec01: codec@18 {
+			compatible = "ti,tlv320adc3x01";
+			reg = <0x18>;
+			status = "disabled";
+		};
+		
+		adc3x01_codec02: codec@19 {
+			compatible = "ti,tlv320adc3x01";
+			reg = <0x19>;
+			status = "disabled";
+		};
+		
+		adc3x01_codec03: codec@1a {
+			compatible = "ti,tlv320adc3x01";
+			reg = <0x1a>;
+			status = "disabled";
+		};
+		
+		adc3x01_codec04: codec@1b {
+			compatible = "ti,tlv320adc3x01";
+			reg = <0x1b>;
+			status = "disabled";
+		};
+		
+		alc5680_codec: codec@2d {
+			compatible = "rtk,alc5680";
+			reg = <0x2d>;
+			status = "okay";
+		};
+		
+		alc5640_codec: codec@1c {
+			compatible = "rtk,alc5640";
+			reg = <0x1c>;
+			status = "okay";
+		};
+		
+		fl3236_led: led@3c {
+			compatible = "rtk,fl3236";
+			reg = <0x3c>;
+			status = "okay";
+		};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-2GB.dts
new file mode 100644
index 00000000..d50a32c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-2GB.dts
@@ -0,0 +1,207 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+ /* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS	 RPC_RINGBUF_SIZE;
+ /* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x02600000 ~ 0x031fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE;
+/* 0x03200000 ~ 0x0e9fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1;
+ /* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x11000000 ~ 0x181fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2;
+
+#include "rtd-1296.dtsi"
+#include "rtd-1296-pinnata-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS
+				ION_AUDIO_HEAP_SIZE
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1
+				ION_MEDIA_HEAP_SIZE1
+				ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2
+				ION_MEDIA_HEAP_SIZE2
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	rtk_dwc3_drd@98013200 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+	
+	alc5680_sound {
+		compatible = "Realtek,rtk-alc5680";
+		gpios =
+			<&rtk_misc_gpio 6 1 1>,  /* chip sel, output, default high */
+			<&rtk_misc_gpio 54 1 0>; /* reset pin, output, default low */	
+		status = "okay";
+	};
+};
+
+&i2c_4 {
+		adc3x01_codec01: codec@18 {
+			compatible = "ti,tlv320adc3x01";
+			reg = <0x18>;
+			status = "disabled";
+		};
+		
+		adc3x01_codec02: codec@19 {
+			compatible = "ti,tlv320adc3x01";
+			reg = <0x19>;
+			status = "disabled";
+		};
+		
+		adc3x01_codec03: codec@1a {
+			compatible = "ti,tlv320adc3x01";
+			reg = <0x1a>;
+			status = "disabled";
+		};
+		
+		adc3x01_codec04: codec@1b {
+			compatible = "ti,tlv320adc3x01";
+			reg = <0x1b>;
+			status = "disabled";
+		};
+		
+		alc5680_codec: codec@2d {
+			compatible = "rtk,alc5680";
+			reg = <0x2d>;
+			status = "okay";
+		};
+		
+		alc5640_codec: codec@1c {
+			compatible = "rtk,alc5640";
+			reg = <0x1c>;
+			status = "okay";
+		};
+		
+		fl3236_led: led@3c {
+			compatible = "rtk,fl3236";
+			reg = <0x3c>;
+			status = "okay";
+		};
+};
\ No newline at end of file
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-common.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-common.dtsi
new file mode 100644
index 00000000..fec04ee
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-pinnata-common.dtsi
@@ -0,0 +1,167 @@
+#include "rtd-1296.dtsi"
+
+/ {
+	model= "Realtek_RTD1296";
+	compatible = "Realtek,rtd-1296";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0 {
+		clock-frequency = <27000000>;
+	};
+
+	serial1@9801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	serial2@9801B400 {
+		clock-frequency = <432000000>;
+	};
+
+	chosen {
+		swiotlb-memory-reservation-size = <512>;
+		swiotlb-force = <0>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+		};
+	};
+
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button */
+			<&rtk_misc_gpio 16 1 1>, /* HV_EN, enable regulator */
+			<&rtk_misc_gpio 100 1 1>, /* audio dac unmute */
+			<&rtk_misc_gpio 21 1 0>, /* LED*/
+			<&rtk_misc_gpio 22 1 0>; /* LED*/
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios =<&rtk_iso_gpio 22 1 0>; /* LED */
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd129x-hdmitx";
+		gpio-i2s-ctrl = <&rtk_misc_gpio 23 1 0>; /* I2S output control */
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "realtek,rtk-i2c";
+		status = "disabled"; /* disable rts5400 */
+	};
+
+	gpio_cmd {
+		compatible = "gpio-cmds";
+
+		/*5679_gpio2 =
+			<&rtk_misc_gpio 18 0 0>; /* 5679_GPIO2 */
+		/*5679_gpio3 =
+			<&rtk_misc_gpio 54 0 0>; /* 5679_GPIO3 */
+		/*5679_gpio12 =
+			<&rtk_misc_gpio 61 0 0>; /* 5679_GPIO12 */
+		/*5679_gpio13 =
+			<&rtk_misc_gpio 62 0 0>; /* 5679_GPIO13 */
+		/*5679_ldo =
+			<&rtk_misc_gpio 23 0 1>; /* 5679_LDO */
+
+		status = "okay";
+
+		button {
+			gpios = <&rtk_iso_gpio 34 0 0>; /* igpio34, ALc_IRQ */
+		};
+	};
+
+	 alc5279@0 {
+		compatible = "alc5279";
+		reg	 = <0x9804d008 0x4>; /* DISP_MUXPAD0 */
+		muxpad0 = <0x281540>;
+		status  = "okay";
+	};
+
+	rfkilligpio {
+		gpios = <&rtk_iso_gpio 24 1 0>; /*bt power */
+		status = "okay";
+	};
+
+	/*
+	 * Suspend GPIO control
+	 *
+	 * [wakeup-gpio-list]
+	 * rtk_iso_gpio 14: BT wakeup host pin
+	 * rtk_iso_gpio 33: WiFi wakeup host pin
+	 *
+	 * [wakeup-gpio-enable]
+	 * Wakeup from BT: <0>disabele
+	 * Wakeup from WiFi: <1> enable
+	 *
+	 * [wakeup-gpio-activity]
+	 * BT pin: <1>active high
+	 * WIFI pin: <0>active low
+	 */
+	power-management {
+		compatible = "Realtek,power-management";
+		wakeup-gpio-list = <&rtk_iso_gpio 14 0 0>,
+			<&rtk_iso_gpio 33 0 0>;
+		wakeup-gpio-enable = <0>, <1>;
+		wakeup-gpio-activity = <1>, <0>;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-qa-rescue-tee.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-qa-rescue-tee.dts
new file mode 100644
index 00000000..5f64287
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-qa-rescue-tee.dts
@@ -0,0 +1,189 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x1fc00000 ~ 0x1fc00fff */
+/memreserve/ ACPU_BOOTCODE_PHYS ACPU_BOOTCODE_SIZE;
+/* Framebuffer */
+/memreserve/ 0x22000000 0x17BB000;
+/* TEE OS */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12c00000;
+
+
+
+
+#include "rtd-1296.dtsi"
+
+/ {
+	model= "Realtek_RTD1296";
+	compatible = "Realtek,rtd-1296";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=64m@576m init=/init androidboot.hardware=kylin loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+	firmware {
+                optee {
+                        compatible = "linaro,optee-tz";
+                        method = "smc";
+                };
+        };
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x22000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios =<&rtk_iso_gpio 21 1 0>;  /* igpio21, output, default low */
+	};
+
+	/* 
+	 * pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50
+	 * pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200
+	 */
+	 emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		pddrive_nf_s0 = <0x77 0x77 0x77 0x77 0x77>;
+		pddrive_nf_s2 = <0xbb 0xbb 0xbb 0xbb 0xbb>;
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-qa-rescue.dts
new file mode 100644
index 00000000..cd6438f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-qa-rescue.dts
@@ -0,0 +1,218 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000  0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x1fc00000 ~ 0x1fc00fff */
+/memreserve/ ACPU_BOOTCODE_PHYS ACPU_BOOTCODE_SIZE;
+/* Framebuffer */
+/memreserve/ 0x22000000	 0x17BB000 ;
+/* TEE OS */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12c00000;
+
+#include "rtd-1296.dtsi"
+
+/ {
+	model= "Realtek_RTD1295";
+	compatible = "Realtek,FPGA_v7", "Realtek,rtd-1295";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=64m@576m init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	uart0: serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x22000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button, input, default N/A */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute , output, default high */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios =<&rtk_iso_gpio 21 1 0>; /* igpio21, output, default low */
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	rtc@9801B600 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	ve3@98048000 {
+		status = "disabled";
+	};
+
+	gpu@98050000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-1GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-1GB.dts
new file mode 100644
index 00000000..50142e8
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-1GB.dts
@@ -0,0 +1,131 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+ /* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+ /* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x02600000 ~ 0x031fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE;
+/* 0x03200000 ~ 0x0e9fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1;
+ /* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x11000000 ~ 0x181fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2;
+
+#include "rtd-1296.dtsi"
+#include "rtd-1296-saola-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS
+				ION_AUDIO_HEAP_SIZE
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1
+				ION_MEDIA_HEAP_SIZE1
+				ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2
+				ION_MEDIA_HEAP_SIZE2
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-2GB-tee.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-2GB-tee.dts
new file mode 100644
index 00000000..4d5290f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-2GB-tee.dts
@@ -0,0 +1,132 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS  RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-129x-ion-2GB-tee.dtsi"
+#include "rtd-1296.dtsi"
+#include "rtd-1296-saola-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		tee_reserved: tee {
+			no-map;
+			size = <0x04100000>;
+			alloc-ranges = <0x10100000 0x04100000>;
+		};
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-2GB-xendom0.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-2GB-xendom0.dts
new file mode 100644
index 00000000..f37c3c2
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-2GB-xendom0.dts
@@ -0,0 +1,116 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS	 RPC_RINGBUF_SIZE;
+/* 0x02600000 ~ 0x031fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE;
+/* 0x03200000 ~ 0x0e9fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1  ION_MEDIA_HEAP_SIZE1;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x11000000 ~ 0x181fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2;
+
+/* "rtd-1296-xen.dtsi" already include from following commont.dtsi */
+
+#include "rtd-1296-xen-saola-common.dtsi"
+
+
+
+/ {
+	chosen {
+		#address-cells = <0x1>;
+		#size-cells = <0x1>;
+		bootargs = "console=dtuart dtuart=serial0 dom0_mem=256MB dom0_max_vcpus=2 sync_console=true";
+
+		module@04000000 {
+			compatible = "xen,linux-zimage", "xen,multiboot-module";
+			reg = <0x04000000 0x01000000>;
+			bootargs = "console=hvc0 debug loglevel=4 swiotlb=512 clk_ignore_unused";
+		};
+	};
+
+	rtk_xen_mempool@0 {
+		reg = <0x0 0x6c000000>;
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	/* no need of ion under normal dom0 */
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-2GB.dts
new file mode 100644
index 00000000..37f5d8f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-2GB.dts
@@ -0,0 +1,158 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS	 RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x02600000 ~ 0x031fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE;
+/* 0x03200000 ~ 0x0e9fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1  ION_MEDIA_HEAP_SIZE1;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x11000000 ~ 0x181fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2;
+
+#include "rtd-1296.dtsi"
+#include "rtd-1296-saola-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS
+				ION_AUDIO_HEAP_SIZE
+				ION_AUDIO_HEAP_FLAG>;
+	};
+
+	rtk,ion-heap@7 { /* TYPE_MEDIA */
+		compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1
+				ION_MEDIA_HEAP_SIZE1
+				ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2
+				ION_MEDIA_HEAP_SIZE2
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-3GB-xendom0.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-3GB-xendom0.dts
new file mode 100644
index 00000000..1154c1d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-3GB-xendom0.dts
@@ -0,0 +1,120 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS	 RPC_RINGBUF_SIZE;
+/* 0x02600000 ~ 0x031fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE;
+/* 0x03200000 ~ 0x0e9fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1  ION_MEDIA_HEAP_SIZE1;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x11000000 ~ 0x181fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2;
+/* 0x7fff0000 ~ 0x7fffffff */
+/memreserve/ HW_LIMITATION_3GB_START HW_LIMITATION_3GB_SIZE;
+/* 0x80000000 ~ 0x80007fff */
+/memreserve/ HW_SECURE_RAM_START HW_SECURE_RAM_SIZE;
+/* 0x88100000 ~ 0x8A0FFFFF */
+/memreserve/ HW_NOR_REMAP_START HW_NOR_REMAP_SIZE;
+
+/* "rtd-1296-xen.dtsi" already include from following commont.dtsi */
+#include "rtd-1296-xen-saola-common.dtsi"
+
+
+/ {
+	chosen {
+		#address-cells = <0x1>;
+		#size-cells = <0x1>;
+		bootargs = "console=dtuart dtuart=serial0 dom0_mem=256MB dom0_max_vcpus=2 sync_console=true";
+
+		module@04000000 {
+			compatible = "xen,linux-zimage", "xen,multiboot-module";
+			reg = <0x04000000 0x01000000>;
+			bootargs = "console=hvc0 debug loglevel=4 swiotlb=512 clk_ignore_unused";
+		};
+	};
+
+	rtk_xen_mempool@0 {
+		reg = <0x0 0xa8000000>;
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0xc0000000>; /* 3072 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	/* no need of ion under normal dom0 */
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-3GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-3GB.dts
new file mode 100644
index 00000000..f49f077
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-3GB.dts
@@ -0,0 +1,165 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS	 RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x02600000 ~ 0x031fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE;
+/* 0x03200000 ~ 0x0e9fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1  ION_MEDIA_HEAP_SIZE1;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x11000000 ~ 0x181fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2;
+/* 0x7fff0000 ~ 0x7fffffff */
+/memreserve/ HW_LIMITATION_3GB_START HW_LIMITATION_3GB_SIZE;
+/* 0x80000000 ~ 0x80007fff */
+/memreserve/ HW_SECURE_RAM_START HW_SECURE_RAM_SIZE;
+/* 0x88100000 ~ 0x8A0FFFFF */
+/memreserve/ HW_NOR_REMAP_START HW_NOR_REMAP_SIZE;
+
+#include "rtd-1296.dtsi"
+#include "rtd-1296-saola-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0xc0000000>; /* 3072 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+			no-map;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS
+				ION_AUDIO_HEAP_SIZE
+				ION_AUDIO_HEAP_FLAG>;
+	};
+
+	rtk,ion-heap@7 { /* TYPE_MEDIA */
+		compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1
+				ION_MEDIA_HEAP_SIZE1
+				ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2
+				ION_MEDIA_HEAP_SIZE2
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-common.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-common.dtsi
new file mode 100644
index 00000000..a0bcb02
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-common.dtsi
@@ -0,0 +1,122 @@
+#include "rtd-1296.dtsi"
+
+/ {
+	model= "Realtek_RTD1296";
+	compatible = "Realtek,rtd-1296";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	arch_timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0@9801B000 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1@9801B000 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	serial1@9801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	serial2@9801B400 {
+		clock-frequency = <432000000>;
+	};
+
+	chosen {
+		swiotlb-memory-reservation-size = <512>;
+		swiotlb-force = <0>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+		};
+	};
+
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute */
+	};
+
+	rfkilligpio{
+		gpios = <&rtk_iso_gpio 24 1 0>; /* bt power */
+		status = "okay";
+	};
+
+	/*
+	 * Suspend GPIO control
+	 *
+	 * [wakeup-gpio-list]
+	 * rtk_iso_gpio 14: BT wakeup host pin
+	 * rtk_iso_gpio 33: WiFi wakeup host pin
+	 *
+	 * [wakeup-gpio-enable]
+	 * Wakeup from BT: <0>disabele
+	 * Wakeup from WiFi: <1> enable
+	 *
+	 * [wakeup-gpio-activity]
+	 * BT pin: <1>active high
+	 * WIFI pin: <0>active low
+	 */
+	power-management@0  {
+		compatible = "Realtek,power-management";
+		wakeup-gpio-list = <&rtk_iso_gpio 14 0 0>,
+			<&rtk_iso_gpio 33 0 0>;
+		wakeup-gpio-enable = <0>, <1>;
+		wakeup-gpio-activity =<1>, <0>;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-qa-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-qa-2GB.dts
new file mode 100644
index 00000000..4c6211c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-qa-2GB.dts
@@ -0,0 +1,139 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+ /* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE ;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x025fffff */
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/* 0x02600000 ~ 0x031fffff */
+/memreserve/ ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE ;
+/* 0x03200000 ~ 0x0e9fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS1  ION_MEDIA_HEAP_SIZE1;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+ /* 0x11000000 ~ 0x181fffff */
+/memreserve/ ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2	;
+
+#include "rtd-1296.dtsi"
+#include "rtd-1296-saola-common.dtsi"
+
+/ {
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS
+				ION_AUDIO_HEAP_SIZE
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS1
+				ION_MEDIA_HEAP_SIZE1
+				ION_MEDIA_HEAP_FLAG1
+				ION_MEDIA_HEAP_PHYS2
+				ION_MEDIA_HEAP_SIZE2
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	/*
+	 * pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50
+	 * pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200
+	 */
+	emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		pddrive_nf_s0 = <0x77 0x77 0x77 0x77 0x77>;
+		pddrive_nf_s2 = <0xbb 0xbb 0xbb 0xbb 0xbb>;
+	};
+
+	dptx@9803D000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-qa-rescue.dts
new file mode 100644
index 00000000..5722c6fe
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-qa-rescue.dts
@@ -0,0 +1,174 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x1fc00000 ~ 0x1fc00fff */
+/memreserve/ ACPU_BOOTCODE_PHYS ACPU_BOOTCODE_SIZE;
+/* Framebuffer */
+/memreserve/ 0x22000000 0x17BB000;
+
+#include "rtd-1296.dtsi"
+
+/ {
+	model= "Realtek_RTD1296";
+	compatible = "Realtek,rtd-1296";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=64m@576m init=/init androidboot.hardware=kylin loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x22000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios =<&rtk_iso_gpio 21 1 0>;  /* igpio21, output, default low */
+	};
+
+	/* 
+	 * pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50
+	 * pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200
+	 */
+	 emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		pddrive_nf_s0 = <0x77 0x77 0x77 0x77 0x77>;
+		pddrive_nf_s2 = <0xbb 0xbb 0xbb 0xbb 0xbb>;
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-xenott-3GB-tee.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-xenott-3GB-tee.dts
new file mode 100644
index 00000000..6c7a921
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-xenott-3GB-tee.dts
@@ -0,0 +1,602 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-129x-ion-2GB-tee.dtsi"
+#include "rtd-129x-xen-common-domu.dtsi"
+#include "rtd-1295-xen-hdmirxEDID.dtsi"
+#include "rtd-1296-xen-usb-domu.dtsi"
+/include/ "rtd-1295-xen-pinctrl-domu.dtsi"
+/include/ "rtd-1295-xen-irda.dtsi"
+
+#define MEDIA_REQ_SIZE_3        (0x03000000) // 48M
+#define ION_MEDIA_HEAP_PHYS3   (MEM_SLOT(5, PHYS, MEDIA_REQ_SIZE_3))
+#define ION_MEDIA_HEAP_SIZE3   (MEM_SLOT(5, SIZE, MEDIA_REQ_SIZE_3))
+#define ION_MEDIA_HEAP_FLAG3   (MEM_SLOT(5, FLAG, MEDIA_REQ_SIZE_3) | RTK_FLAG_VE_SPEC)
+
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+
+
+/{
+	/* #*cells are here to keep DTC happy */
+	#address-cells = <2>;
+	#size-cells = <2>;
+
+	aliases {
+		serial1 = &uart1;
+		i2c1 = &i2c_1;
+		i2c2 = &i2c_2;
+		i2c3 = &i2c_3;
+		i2c4 = &i2c_4;
+		i2c5 = &i2c_5;
+	};
+
+	/*
+	 * Do not add other settings here other than CMA info since XEN only
+	 * bypass CMA properties
+	 */
+	chosen {
+		compatible = "Realtek,rtk1295-cma_info", "Realtek,DomU-cma_info";
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+	};
+
+	/* Extra node add by RTK so DTB could control reserve memory */
+	reserved-memory {
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+			no-map;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		phys_resv@0 {
+			reg = <0x0 SYS_BOOTCODE_MEMBASE 0x0 SYS_BOOTCODE_MEMSIZE>,
+			      <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>,
+			      <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>,
+			      <0x0 ION_AUDIO_HEAP_PHYS 0x0 ION_AUDIO_HEAP_SIZE>,
+			      <0x0 ION_MEDIA_HEAP_PHYS1 0x0 ION_MEDIA_HEAP_SIZE1>,
+			      <0x0 ACPU_IDMEM_PHYS 0x0 ACPU_IDMEM_SIZE>,
+			      <0x0 ION_MEDIA_HEAP_PHYS2 0x0 ION_MEDIA_HEAP_SIZE2>,
+			      <0x0 HW_LIMITATION_3GB_START 0x0 HW_LIMITATION_3GB_SIZE>,
+			      <0x0 HW_SECURE_RAM_START 0x0 HW_SECURE_RAM_SIZE>,
+			      <0x0 ION_SECURE_HEAP_PHYS 0x0 ION_SECURE_HEAP_SIZE>,
+			      <0x0 ION_MEDIA_HEAP_PHYS3 0x0 ION_MEDIA_HEAP_SIZE3>,
+			      <0x0 ION_SECURE_AUDIO_PHYS_0 0x0 ION_SECURE_AUDIO_SIZE_0>,
+			      <0x0 ION_SECURE_MD_PHYS_0 0x0 ION_SECURE_MD_SIZE_0>,
+			      <0x0 HW_NOR_REMAP_START 0x0 HW_NOR_REMAP_SIZE>;
+		};
+
+		Tee_reserved: tee@0 {
+			no-map;
+			reg = <0x0 0x10100000 0x0 0x04100000>;
+		};
+	};
+
+	passthrough {
+		compatible = "simple-bus";
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		firmware {
+			android {
+				compatible = "android,firmware";
+
+				fstab {
+					compatible = "android,fstab";
+
+					/* 51712 is MAJOR number of xenblk defined under include/uapi/linux/major.h */
+					system {
+						compatible = "android,system";
+						dev = "/dev/block/vbd/51712/by-name/system";
+						type = "ext4";
+						mnt_flags = "ro,noatime";
+						fsmgr_flags = "wait";
+					};
+					vendor {
+						compatible = "android,vendor";
+						dev = "/dev/block/vbd/51712/by-name/vendor";
+						type = "ext4";
+						mnt_flags = "ro,noatime";
+						fsmgr_flags = "wait";
+					};
+				};
+			};
+			optee {
+				compatible = "linaro,optee-tz";
+				method = "smc";
+			};
+		};
+
+		pinctrl: pinctrl@9801A000 {
+			compatible = "realtek,rtk129x-pinctrl";
+			reg = <0x0 0x9801A000 0x0 0x97c>,
+			      <0x0 0x9804d000 0x0 0x010>,
+			      <0x0 0x98012000 0x0 0x640>,
+			      <0x0 0x98007000 0x0 0x340>;
+			#gpio-range-cells = <3>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&sdcard_pins_low>,
+				    <&sdcard_pins_high>;
+			status = "okay";
+		};
+
+		mux_intc: intc@9801B000 {
+			compatible = "Realtek,rtk-irq-mux";
+			Realtek,mux-nr = <2>;
+			#interrupt-cells = <2>;
+			interrupt-controller;
+			reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP MISC_ISO */
+			      <0x0 0x98007000 0x0 0x100>;
+			interrupts = <0 40 4>, <0 41 4>;
+			intr-status = <0xc>, <0x0>;
+			intr-en = <0x80>, <0x40>;
+			status = "okay";
+		};
+
+		rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+			compatible = "realtek,rtk-misc-gpio-irq-mux";
+			gpio-controller;
+			#gpio-cells = <3>; /*must be the same with gpiochip.of_gpio_n_cells*/
+			Realtek,gpio_base = <0>;
+			Realtek,gpio_numbers = <101>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <0 19>, <0 20>; /*GPIOA_INT   GPIODA_INT*/
+			reg = <0x0 0x9801b000 0x0 0x100>,
+			      <0x0 0x9801b100 0x0 0x100>; /* MISC_SYS MISC_GPIO*/
+			gpio-ranges = <&pinctrl 0 0 101>;
+			status = "okay";
+		};
+
+		rtk_iso_gpio: rtk_iso_gpio@98007100 {
+			compatible = "realtek,rtk-iso-gpio-irq-mux";
+			gpio-controller;
+			#gpio-cells = <3>;
+			Realtek,gpio_base = <101>;
+			Realtek,gpio_numbers = <35>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+			reg = <0x0 0x98007000 0x0 0x100>,
+			      <0x0 0x98007100 0x0 0x100>; /* ISO_SYS ISO_GPIO*/
+			gpio-ranges = <&pinctrl 0 101 35>;
+			status = "okay";
+		};
+
+		rfkill: rfkilligpio {
+			compatible = "Realtek,rfkill";
+			gpios = <&rtk_iso_gpio 24 1 0>; /*bt power , output, default low */
+			status = "okay";
+		};
+
+		rtk,ion {
+			compatible = "Realtek,rtk-ion";
+			#address-cells = <1>;
+			#size-cells = <0>;
+
+			rtk,ion-heap@0 { /* SYSTEM_HEAP */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <0>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@1 { /* System contig */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <1>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@4 { /* DMA_HEAP */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <4>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS 
+                ION_SECURE_HEAP_SIZE 
+                ION_SECURE_HEAP_FLAG
+                ION_SECURE_AUDIO_PHYS_0 
+                ION_SECURE_AUDIO_SIZE_0 
+                ION_SECURE_AUDIO_FLAG_0>;
+            };
+
+			rtk,ion-heap@8 { /* Audio */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <8>;
+				rtk,memory-reserve = <
+					ION_AUDIO_HEAP_PHYS
+					ION_AUDIO_HEAP_SIZE
+					ION_AUDIO_HEAP_FLAG>;
+			};
+
+			rtk,ion-heap@7 { /* TYPE_MEDIA */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <7>;
+				rtk,memory-reserve = <
+					ION_MEDIA_HEAP_PHYS1
+					ION_MEDIA_HEAP_SIZE1
+					ION_MEDIA_HEAP_FLAG1
+					ION_MEDIA_HEAP_PHYS2
+					ION_MEDIA_HEAP_SIZE2
+					ION_MEDIA_HEAP_FLAG2
+					ION_MEDIA_HEAP_PHYS3
+					ION_MEDIA_HEAP_SIZE3
+					ION_MEDIA_HEAP_FLAG3>;
+			};
+		}; /* rtk,ion */
+
+		fb {
+			compatible = "Realtek,rtk-fb";
+			buffer-cnt = <3>;
+			resolution = <1920 1080>;
+			fps = <60>;
+		};
+
+		rbus@98000000 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		md@9800b000 {
+			compatible = "realtek,md";
+			reg = <0x0 0x9800b000 0x0 0x1000>;
+			interrupts = <0 38 4>; /* 70 - 32 = 38 */
+			clocks = <&clk_en_1 CLK_EN_MD>;
+			resets = <&rst1 RSTN_MD>;
+		};
+
+		se@9800c000 {
+			compatible = "realtek,se";
+			reg = <0x0 0x9800c000 0x0 0x1000>;
+			interrupts = <0 20 4>; /* 52 - 32 = 20 */
+			clocks = <&clk_en_1 CLK_EN_SE>;
+			resets = <&rst1 RSTN_SE>;
+			power-domains = <&pd0 PD_SRAM_DISP_SE>;
+		};
+
+		refclk@9801b540 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x9801b000 0x0 0x1000>;
+		};
+
+		hdmitx@9800D000 {
+			compatible = "realtek,rtd129x-hdmitx";
+			reg = <0x0 0x9800d000 0x0 0x560>, /* HDMITX */
+			      <0x0 0x98007200 0x0 0x4>; /* I2C1_REQ_CTRL */
+			gpio-hpd-detect = <&rtk_iso_gpio 6 0 0>; /* Hotplug detect pin */
+			clocks = <&clk_en_1 CLK_EN_HDMI>;
+			clock-names = "clk_en_hdmi";
+			resets = <&rst1 RSTN_HDMI>;
+			reset-names = "rstn_hdmi";
+
+			scdc_rr {
+				enable-scdc-rr = <0>;
+				interrupt-parent = <&mux_intc>;
+				#interrupt-cells = <1>;
+				interrupt-controller;
+				interrupts = <1 31>;
+			};
+		};
+
+		hdcptx@9800D000 {
+			compatible = "realtek,rtk129x-hdcptx";
+			reg = <0x0 0x9800d000 0x0 0x400>;
+			interrupts = <0 31 4>; /*gen Ri*/
+		};
+
+		hdmirx@98034000 {
+			compatible = "Realtek,rtk-mipi-top";
+			reg = <0x0 0x98037000 0x0 0xE0>,
+			      <0x0 0x98034000 0x0 0xF54>,
+			      <0x0 0x98035F00 0x0 0x2C>,
+			      <0x0 0x98037700 0x0 0x98>,
+			      <0x0 0x98004000 0x0 0xF0>,
+			      <0x0 0x98004100 0x0 0x104>;
+			interrupts = <0 23 4>;
+			gpio-rx-hpd-ctrl = <&rtk_iso_gpio 22 1 0>;
+			power-saving = <0>; /* 1:ON,0:OFF; Turn off RX when cable unplugged */
+			clocks = <&clk_en_2 CLK_EN_HDMIRX>,
+			         <&clk_en_1 CLK_EN_MIPI>,
+			         <&clk_en_2 CLK_EN_CBUS_TX>,
+			         <&iclk_en CLK_EN_CBUS_OSC>,
+			         <&iclk_en CLK_EN_CBUS_SYS>,
+			         <&iclk_en CLK_EN_CBUSTX_SYS>,
+			         <&iclk_en CLK_EN_CBUSRX_SYS>,
+			         <&clk_en_1 CLK_EN_TP>,
+			         <&clk_en_1 CLK_EN_CP>;
+			clock-names = "hdmirx",
+				      "mipi",
+				      "cbus_tx",
+				      "cbus_osc",
+				      "cbus_sys",
+				      "cbustx_sys",
+				      "cbusrx_sys",
+				      "tp",
+				      "cp";
+			resets = <&rst4 RSTN_HDMIRX>,
+				 <&rst4 RSTN_HDMIRX_WRAP>,
+				 <&rst1 RSTN_MIPI>,
+				 <&rst2 RSTN_CBUS_TX>,
+				 <&irst IRSTN_CBUS>,
+				 <&irst IRSTN_CBUSTX>,
+				 <&irst IRSTN_CBUSRX>,
+				 <&rst1 RSTN_TP>,
+				 <&rst1 RSTN_CP>;
+			reset-names = "hdmirx",
+				      "hdmirx_wrap",
+				      "mipi",
+				      "cbus_tx",
+				      "cbus",
+				      "cbustx",
+				      "cbusrx",
+				      "tp",
+				      "cp";
+			power-domains = <&pd0 PD_SRAM_DISP_HDMIRX>;
+		};
+
+		uart1: serial1@9801B200 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B200 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x8>;
+			interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			clocks = <&clk_en_2 CLK_EN_UR1>;
+			resets = <&rst2 RSTN_UR1>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		uart2: serial2@9801B400 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B400 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x100>;
+			interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			clocks = <&clk_en_2 CLK_EN_UR2>;
+			resets = <&rst2 RSTN_UR2>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		sdmmc@98010400 {
+			compatible = "Realtek,rtk1295-sdmmc";
+			gpios = <&rtk_misc_gpio 99 1 0>; /*sd power , output, default high  (poweroff) */
+			reg = <0x0 0x98000000 0x0 0x400>, /* CRT */
+			      <0x0 0x98010400 0x0 0x200>, /* SDMMC */
+			      <0x0 0x9801A000 0x0 0x400>, /* BS2 */
+			      <0x0 0x98012000 0x0 0xa00>, /* EMMC */
+			      <0x0 0x98010A00 0x0 0x40>; /* SDIO */
+			interrupts = <0 44 4>;
+			clocks = <&clk_en_1 CLK_EN_CR>,
+				 <&clk_en_1 CLK_EN_SD_IP>;
+			clock-names = "cr",
+				      "sd_ip";
+		};
+
+		pu_pll@98000000 {
+			compatible = "Realtek,rtk1295-pu_pll";
+			reg = <0x0 0x98000000 0x0 0x200>;
+		};
+
+		jpeg@9803e000 {
+			compatible = "Realtek,rtk1295-jpeg";
+			reg = <0x0 0x9803e000 0x0 0x1000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 52 4>;
+			clocks = <&clk_en_2 CLK_EN_JPEG>;
+			clock-names = "jpeg";
+			resets = <&rst2 RSTN_JPEG>;
+		};
+
+		ve1@98040000 {
+			compatible = "Realtek,rtk1295-ve1";
+			reg = <0x0 0x98040000 0x0 0x8000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 53 4>, <0 54 4>;
+			clocks = <&cc CC_CLK_VE1>,
+				 <&cc CC_CLK_VE2>;
+			clock-names = "clk_ve1",
+				      "clk_ve2";
+			resets = <&rst1 RSTN_VE1>,
+				 <&rst1 RSTN_VE2>;
+			reset-names = "ve1",
+				      "ve2";
+		};
+
+		ve3@98048000 {
+			compatible = "Realtek,rtk1295-ve3";
+			reg = <0x0 0x98048000 0x0 0x4000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 55 4>;
+			clocks = <&cc CC_CLK_VE3>;
+			resets = <&rst1 RSTN_VE3>;
+		};
+
+		rpc@9801a104 {
+			compatible = "Realtek,rtk-rpc";
+			reg = <0x0 0x9801a104 0x0 0xc>, /* rpc intr en */
+			      <0x0 0x01ffe000 0x0 0x4000>, /* rpc ring buffer */
+			      <0x0 0x0001f000 0x0 0x1000>, /* rpc common */
+			      <0x0 0x9801a020 0x0 0x4>; /* rbus sync */
+			interrupts = <0 33 4>;
+		};
+
+		irda@98007400 {
+			compatible = "Realtek,rtk-irda";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x98007000 0x0 0X400>,
+			      <0x0 0x98007400 0x0 0x100>;
+			interrupts = <1 5>;
+			resets = <&irst IRSTN_IR>;
+			clocks = <&iclk_en CLK_EN_MISC_IR>;
+			status = "okay";
+		};
+
+		regulators {
+			compatible = "xen,vreg";
+
+			gpu_supp: dcdc3 {
+				regulator-compatible = "dcdc3";
+				regulator-init-microvolt = <1000000>;
+			};
+		};
+
+		i2c_1: i2c@0x98007C00 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x98007C00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <1 11>;
+			i2c-num = <1>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&iclk_en CLK_EN_I2C1>;
+		};
+
+		i2c_2: i2c@0x9801B700 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801B700 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 26>;
+			i2c-num = <2>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_2>;
+		};
+
+		i2c_3: i2c@0x9801B900 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801B900 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 23>;
+			i2c-num = <3>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_3>;
+		};
+
+		i2c_4: i2c@0x9801BA00 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801BA00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 15>;
+			i2c-num = <4>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_4>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&i2c_pins_4>;
+		};
+
+		i2c_5: i2c@0x9801BB00 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801BB00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 14>;
+			i2c-num = <5>;
+			status = "okay";
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+
+			rts5400@6A {
+				compatible = "rtk-rts5400";
+				reg = <0x6A>;
+				realtek,12v-power-gpio = <&rtk_misc_gpio 16 1 0>; /*1296 u3host power, output, default low */
+			};
+		};
+
+		dptx@9803D000 {
+			compatible = "Realtek,rtk129x-dptx";
+			reg = <0x0 0x9803D000 0x0 0x1000>,
+			      <0x0 0x98000000 0x0 0x1000>,
+			      <0x0 0x98009400 0x0 0x600>,
+			      <0x0 0x98005000 0x0 0x1000>;
+			interrupts = <0 29 4>; /*gen Ri*/
+			clocks = <&clk_en_1 CLK_EN_TVE>,
+				 <&clk_en_1 CLK_EN_VO>,
+				 <&clk_en_1 CLK_EN_LVDS>;
+			resets = <&irst IRSTN_DP>,
+				 <&rst1 RSTN_TVE>,
+				 <&rst1 RSTN_VO>,
+				 <&rst1 RSTN_LVDS>;
+			reset-names = "dp",
+				      "tve",
+				      "vo",
+				      "lvds";
+			dp_hpd {
+				gpios = <&rtk_iso_gpio 7 0 0>; /*HPD, input, default N/A */
+				interrupt-parent = <&rtk_iso_gpio>;
+				interrupts = <7>; /*HPD*/
+			};
+		};
+
+		gpu: gpu@98050000 {
+			compatible = "arm,mali-midgard";
+			reg = <0x0 0x98050000 0x0 0xffff>;
+			interrupts = <0 67 4>, <0 68 4>, <0 66 4>;
+			interrupt-names = "JOB", "MMU", "GPU";
+			clocks = <&cc CC_CLK_GPU>;
+			clock-names = "clk_mali";
+			resets = <&rst1 RSTN_GPU>;
+			mali-supply = <&gpu_supp>;
+			#cooling-cells = <2>;
+			status = "okay";
+			power-model {
+				compatible = "arm,mali-simple-power-model";
+				static-coefficient = <2427750>;
+				dynamic-coefficient = <4687>;
+				ts = <20000 2000 (-20) 2>;
+				thermal-zone = "cpu-thermal";
+			};
+		};
+
+		pmu {
+			compatible = "arm,armv8-pmuv3";
+			interrupts = <0 48 4>;
+		};
+	}; /* passthrough */
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-xenott-3GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-xenott-3GB.dts
new file mode 100644
index 00000000..0fd16d5
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-xenott-3GB.dts
@@ -0,0 +1,566 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-129x-ion-2GB-tee.dtsi"
+#include "rtd-129x-xen-common-domu.dtsi"
+#include "rtd-1295-xen-hdmirxEDID.dtsi"
+#include "rtd-1296-xen-usb-domu.dtsi"
+/include/ "rtd-1295-xen-pinctrl-domu.dtsi"
+/include/ "rtd-1295-xen-irda.dtsi"
+
+/{
+	/* #*cells are here to keep DTC happy */
+	#address-cells = <2>;
+	#size-cells = <2>;
+
+	aliases {
+		serial1 = &uart1;
+		i2c1 = &i2c_1;
+		i2c2 = &i2c_2;
+		i2c3 = &i2c_3;
+		i2c4 = &i2c_4;
+		i2c5 = &i2c_5;
+	};
+
+	/*
+	 * Do not add other settings here other than CMA info since XEN only
+	 * bypass CMA properties
+	 */
+	chosen {
+		compatible = "Realtek,rtk1295-cma_info", "Realtek,DomU-cma_info";
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+	};
+
+	/* Extra node add by RTK so DTB could control reserve memory */
+	reserved-memory {
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+			no-map;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		phys_resv@0 {
+			reg = <0x0 SYS_BOOTCODE_MEMBASE 0x0 SYS_BOOTCODE_MEMSIZE>,
+			      <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>,
+			      <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>,
+			      <0x0 ION_AUDIO_HEAP_PHYS 0x0 ION_AUDIO_HEAP_SIZE>,
+			      <0x0 ION_MEDIA_HEAP_PHYS1 0x0 ION_MEDIA_HEAP_SIZE1>,
+			      <0x0 ACPU_IDMEM_PHYS 0x0 ACPU_IDMEM_SIZE>,
+			      <0x0 ION_MEDIA_HEAP_PHYS2 0x0 ION_MEDIA_HEAP_SIZE2>,
+			      <0x0 HW_LIMITATION_3GB_START 0x0 HW_LIMITATION_3GB_SIZE>,
+			      <0x0 HW_SECURE_RAM_START 0x0 HW_SECURE_RAM_SIZE>,
+			      <0x0 HW_NOR_REMAP_START 0x0 HW_NOR_REMAP_SIZE>;
+		};
+
+		Tee_reserved: tee@0 {
+			no-map;
+			reg = <0x0 0x10100000 0x0 0x00F00000>;
+		};
+	};
+
+	passthrough {
+		compatible = "simple-bus";
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		firmware {
+			android {
+				compatible = "android,firmware";
+
+				fstab {
+					compatible = "android,fstab";
+
+					/* 51712 is MAJOR number of xenblk defined under include/uapi/linux/major.h */
+					system {
+						compatible = "android,system";
+						dev = "/dev/block/vbd/51712/by-name/system";
+						type = "ext4";
+						mnt_flags = "ro,noatime";
+						fsmgr_flags = "wait";
+					};
+					vendor {
+						compatible = "android,vendor";
+						dev = "/dev/block/vbd/51712/by-name/vendor";
+						type = "ext4";
+						mnt_flags = "ro,noatime";
+						fsmgr_flags = "wait";
+					};
+				};
+			};
+			optee {
+				compatible = "linaro,optee-tz";
+				method = "smc";
+			};
+		};
+
+		pinctrl: pinctrl@9801A000 {
+			compatible = "realtek,rtk129x-pinctrl";
+			reg = <0x0 0x9801A000 0x0 0x97c>,
+			      <0x0 0x9804d000 0x0 0x010>,
+			      <0x0 0x98012000 0x0 0x640>,
+			      <0x0 0x98007000 0x0 0x340>;
+			#gpio-range-cells = <3>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&sdcard_pins_low>,
+				    <&sdcard_pins_high>;
+			status = "okay";
+		};
+
+		mux_intc: intc@9801B000 {
+			compatible = "Realtek,rtk-irq-mux";
+			Realtek,mux-nr = <2>;
+			#interrupt-cells = <2>;
+			interrupt-controller;
+			reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP MISC_ISO */
+			      <0x0 0x98007000 0x0 0x100>;
+			interrupts = <0 40 4>, <0 41 4>;
+			intr-status = <0xc>, <0x0>;
+			intr-en = <0x80>, <0x40>;
+			status = "okay";
+		};
+
+		rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+			compatible = "realtek,rtk-misc-gpio-irq-mux";
+			gpio-controller;
+			#gpio-cells = <3>; /*must be the same with gpiochip.of_gpio_n_cells*/
+			Realtek,gpio_base = <0>;
+			Realtek,gpio_numbers = <101>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <0 19>, <0 20>; /*GPIOA_INT   GPIODA_INT*/
+			reg = <0x0 0x9801b000 0x0 0x100>,
+			      <0x0 0x9801b100 0x0 0x100>; /* MISC_SYS MISC_GPIO*/
+			gpio-ranges = <&pinctrl 0 0 101>;
+			status = "okay";
+		};
+
+		rtk_iso_gpio: rtk_iso_gpio@98007100 {
+			compatible = "realtek,rtk-iso-gpio-irq-mux";
+			gpio-controller;
+			#gpio-cells = <3>;
+			Realtek,gpio_base = <101>;
+			Realtek,gpio_numbers = <35>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+			reg = <0x0 0x98007000 0x0 0x100>,
+			      <0x0 0x98007100 0x0 0x100>; /* ISO_SYS ISO_GPIO*/
+			gpio-ranges = <&pinctrl 0 101 35>;
+			status = "okay";
+		};
+
+		rfkill: rfkilligpio {
+			compatible = "Realtek,rfkill";
+			gpios = <&rtk_iso_gpio 24 1 0>; /*bt power , output, default low */
+			status = "okay";
+		};
+
+		rtk,ion {
+			compatible = "Realtek,rtk-ion";
+			#address-cells = <1>;
+			#size-cells = <0>;
+
+			rtk,ion-heap@0 { /* SYSTEM_HEAP */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <0>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@1 { /* System contig */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <1>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@4 { /* DMA_HEAP */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <4>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@8 { /* Audio */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <8>;
+				rtk,memory-reserve = <
+					ION_AUDIO_HEAP_PHYS
+					ION_AUDIO_HEAP_SIZE
+					ION_AUDIO_HEAP_FLAG>;
+			};
+
+			rtk,ion-heap@7 { /* TYPE_MEDIA */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <7>;
+				rtk,memory-reserve = <
+					ION_MEDIA_HEAP_PHYS1
+					ION_MEDIA_HEAP_SIZE1
+					ION_MEDIA_HEAP_FLAG1
+					ION_MEDIA_HEAP_PHYS2
+					ION_MEDIA_HEAP_SIZE2
+					ION_MEDIA_HEAP_FLAG2>;
+			};
+		}; /* rtk,ion */
+
+		fb {
+			compatible = "Realtek,rtk-fb";
+			buffer-cnt = <3>;
+			resolution = <1920 1080>;
+			fps = <60>;
+		};
+
+		rbus@98000000 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		md@9800b000 {
+			compatible = "realtek,md";
+			reg = <0x0 0x9800b000 0x0 0x1000>;
+			interrupts = <0 38 4>; /* 70 - 32 = 38 */
+			clocks = <&clk_en_1 CLK_EN_MD>;
+			resets = <&rst1 RSTN_MD>;
+		};
+
+		se@9800c000 {
+			compatible = "realtek,se";
+			reg = <0x0 0x9800c000 0x0 0x1000>;
+			interrupts = <0 20 4>; /* 52 - 32 = 20 */
+			clocks = <&clk_en_1 CLK_EN_SE>;
+			resets = <&rst1 RSTN_SE>;
+			power-domains = <&pd0 PD_SRAM_DISP_SE>;
+		};
+
+		refclk@9801b540 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x9801b000 0x0 0x1000>;
+		};
+
+		hdmitx@9800D000 {
+			compatible = "realtek,rtd129x-hdmitx";
+			reg = <0x0 0x9800d000 0x0 0x560>, /* HDMITX */
+			      <0x0 0x98007200 0x0 0x4>; /* I2C1_REQ_CTRL */
+			gpio-hpd-detect = <&rtk_iso_gpio 6 0 0>; /* Hotplug detect pin */
+			clocks = <&clk_en_1 CLK_EN_HDMI>;
+			clock-names = "clk_en_hdmi";
+			resets = <&rst1 RSTN_HDMI>;
+			reset-names = "rstn_hdmi";
+
+			scdc_rr {
+				enable-scdc-rr = <0>;
+				interrupt-parent = <&mux_intc>;
+				#interrupt-cells = <1>;
+				interrupt-controller;
+				interrupts = <1 31>;
+			};
+		};
+
+		hdcptx@9800D000 {
+			compatible = "realtek,rtk129x-hdcptx";
+			reg = <0x0 0x9800d000 0x0 0x400>;
+			interrupts = <0 31 4>; /*gen Ri*/
+		};
+
+		hdmirx@98034000 {
+			compatible = "Realtek,rtk-mipi-top";
+			reg = <0x0 0x98037000 0x0 0xE0>,
+			      <0x0 0x98034000 0x0 0xF54>,
+			      <0x0 0x98035F00 0x0 0x2C>,
+			      <0x0 0x98037700 0x0 0x98>,
+			      <0x0 0x98004000 0x0 0xF0>,
+			      <0x0 0x98004100 0x0 0x104>;
+			interrupts = <0 23 4>;
+			gpio-rx-hpd-ctrl = <&rtk_iso_gpio 22 1 0>;
+			power-saving = <0>; /* 1:ON,0:OFF; Turn off RX when cable unplugged */
+			clocks = <&clk_en_2 CLK_EN_HDMIRX>,
+			         <&clk_en_1 CLK_EN_MIPI>,
+			         <&clk_en_2 CLK_EN_CBUS_TX>,
+			         <&iclk_en CLK_EN_CBUS_OSC>,
+			         <&iclk_en CLK_EN_CBUS_SYS>,
+			         <&iclk_en CLK_EN_CBUSTX_SYS>,
+			         <&iclk_en CLK_EN_CBUSRX_SYS>,
+			         <&clk_en_1 CLK_EN_TP>,
+			         <&clk_en_1 CLK_EN_CP>;
+			clock-names = "hdmirx",
+				      "mipi",
+				      "cbus_tx",
+				      "cbus_osc",
+				      "cbus_sys",
+				      "cbustx_sys",
+				      "cbusrx_sys",
+				      "tp",
+				      "cp";
+			resets = <&rst4 RSTN_HDMIRX>,
+				 <&rst4 RSTN_HDMIRX_WRAP>,
+				 <&rst1 RSTN_MIPI>,
+				 <&rst2 RSTN_CBUS_TX>,
+				 <&irst IRSTN_CBUS>,
+				 <&irst IRSTN_CBUSTX>,
+				 <&irst IRSTN_CBUSRX>,
+				 <&rst1 RSTN_TP>,
+				 <&rst1 RSTN_CP>;
+			reset-names = "hdmirx",
+				      "hdmirx_wrap",
+				      "mipi",
+				      "cbus_tx",
+				      "cbus",
+				      "cbustx",
+				      "cbusrx",
+				      "tp",
+				      "cp";
+			power-domains = <&pd0 PD_SRAM_DISP_HDMIRX>;
+		};
+
+		uart1: serial1@9801B200 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B200 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x8>;
+			interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			clocks = <&clk_en_2 CLK_EN_UR1>;
+			resets = <&rst2 RSTN_UR1>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		uart2: serial2@9801B400 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B400 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x100>;
+			interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			clocks = <&clk_en_2 CLK_EN_UR2>;
+			resets = <&rst2 RSTN_UR2>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		sdmmc@98010400 {
+			compatible = "Realtek,rtk1295-sdmmc";
+			gpios = <&rtk_misc_gpio 99 1 0>; /*sd power , output, default high  (poweroff) */
+			reg = <0x0 0x98000000 0x0 0x400>, /* CRT */
+			      <0x0 0x98010400 0x0 0x200>, /* SDMMC */
+			      <0x0 0x9801A000 0x0 0x400>, /* BS2 */
+			      <0x0 0x98012000 0x0 0xa00>, /* EMMC */
+			      <0x0 0x98010A00 0x0 0x40>; /* SDIO */
+			interrupts = <0 44 4>;
+			clocks = <&clk_en_1 CLK_EN_CR>,
+				 <&clk_en_1 CLK_EN_SD_IP>;
+			clock-names = "cr",
+				      "sd_ip";
+		};
+
+		pu_pll@98000000 {
+			compatible = "Realtek,rtk1295-pu_pll";
+			reg = <0x0 0x98000000 0x0 0x200>;
+		};
+
+		jpeg@9803e000 {
+			compatible = "Realtek,rtk1295-jpeg";
+			reg = <0x0 0x9803e000 0x0 0x1000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 52 4>;
+			clocks = <&clk_en_2 CLK_EN_JPEG>;
+			clock-names = "jpeg";
+			resets = <&rst2 RSTN_JPEG>;
+		};
+
+		ve1@98040000 {
+			compatible = "Realtek,rtk1295-ve1";
+			reg = <0x0 0x98040000 0x0 0x8000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 53 4>, <0 54 4>;
+			clocks = <&cc CC_CLK_VE1>,
+				 <&cc CC_CLK_VE2>;
+			clock-names = "clk_ve1",
+				      "clk_ve2";
+			resets = <&rst1 RSTN_VE1>,
+				 <&rst1 RSTN_VE2>;
+			reset-names = "ve1",
+				      "ve2";
+		};
+
+		ve3@98048000 {
+			compatible = "Realtek,rtk1295-ve3";
+			reg = <0x0 0x98048000 0x0 0x4000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 55 4>;
+			clocks = <&cc CC_CLK_VE3>;
+			resets = <&rst1 RSTN_VE3>;
+		};
+
+		rpc@9801a104 {
+			compatible = "Realtek,rtk-rpc";
+			reg = <0x0 0x9801a104 0x0 0xc>, /* rpc intr en */
+			      <0x0 0x01ffe000 0x0 0x4000>, /* rpc ring buffer */
+			      <0x0 0x0001f000 0x0 0x1000>, /* rpc common */
+			      <0x0 0x9801a020 0x0 0x4>; /* rbus sync */
+			interrupts = <0 33 4>;
+		};
+
+		irda@98007400 {
+			compatible = "Realtek,rtk-irda";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x98007000 0x0 0X400>,
+			      <0x0 0x98007400 0x0 0x100>;
+			interrupts = <1 5>;
+			resets = <&irst IRSTN_IR>;
+			clocks = <&iclk_en CLK_EN_MISC_IR>;
+			status = "okay";
+		};
+
+		regulators {
+			compatible = "xen,vreg";
+
+			gpu_supp: dcdc3 {
+				regulator-compatible = "dcdc3";
+				regulator-init-microvolt = <1000000>;
+			};
+		};
+
+		i2c_1: i2c@0x98007C00 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x98007C00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <1 11>;
+			i2c-num = <1>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&iclk_en CLK_EN_I2C1>;
+		};
+
+		i2c_2: i2c@0x9801B700 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801B700 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 26>;
+			i2c-num = <2>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_2>;
+		};
+
+		i2c_3: i2c@0x9801B900 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801B900 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 23>;
+			i2c-num = <3>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_3>;
+		};
+
+		i2c_4: i2c@0x9801BA00 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801BA00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 15>;
+			i2c-num = <4>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_4>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&i2c_pins_4>;
+		};
+
+		i2c_5: i2c@0x9801BB00 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801BB00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 14>;
+			i2c-num = <5>;
+			status = "okay";
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+
+			rts5400@6A {
+				compatible = "rtk-rts5400";
+				reg = <0x6A>;
+				realtek,12v-power-gpio = <&rtk_misc_gpio 16 1 0>; /*1296 u3host power, output, default low */
+			};
+		};
+
+		dptx@9803D000 {
+			compatible = "Realtek,rtk129x-dptx";
+			reg = <0x0 0x9803D000 0x0 0x1000>,
+			      <0x0 0x98000000 0x0 0x1000>,
+			      <0x0 0x98009400 0x0 0x600>,
+			      <0x0 0x98005000 0x0 0x1000>;
+			interrupts = <0 29 4>; /*gen Ri*/
+			clocks = <&clk_en_1 CLK_EN_TVE>,
+				 <&clk_en_1 CLK_EN_VO>,
+				 <&clk_en_1 CLK_EN_LVDS>;
+			resets = <&irst IRSTN_DP>,
+				 <&rst1 RSTN_TVE>,
+				 <&rst1 RSTN_VO>,
+				 <&rst1 RSTN_LVDS>;
+			reset-names = "dp",
+				      "tve",
+				      "vo",
+				      "lvds";
+			dp_hpd {
+				gpios = <&rtk_iso_gpio 7 0 0>; /*HPD, input, default N/A */
+				interrupt-parent = <&rtk_iso_gpio>;
+				interrupts = <7>; /*HPD*/
+			};
+		};
+
+		gpu: gpu@98050000 {
+			compatible = "arm,mali-midgard";
+			reg = <0x0 0x98050000 0x0 0xffff>;
+			interrupts = <0 67 4>, <0 68 4>, <0 66 4>;
+			interrupt-names = "JOB", "MMU", "GPU";
+			clocks = <&cc CC_CLK_GPU>;
+			clock-names = "clk_mali";
+			resets = <&rst1 RSTN_GPU>;
+			mali-supply = <&gpu_supp>;
+			#cooling-cells = <2>;
+			status = "okay";
+			power-model {
+				compatible = "arm,mali-simple-power-model";
+				static-coefficient = <2427750>;
+				dynamic-coefficient = <4687>;
+				ts = <20000 2000 (-20) 2>;
+				thermal-zone = "cpu-thermal";
+			};
+		};
+
+		pmu {
+			compatible = "arm,armv8-pmuv3";
+			interrupts = <0 48 4>;
+		};
+	}; /* passthrough */
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-xenott.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-xenott.dts
new file mode 100644
index 00000000..63f6998
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-saola-xenott.dts
@@ -0,0 +1,562 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-129x-ion-2GB-tee.dtsi"
+#include "rtd-129x-xen-common-domu.dtsi"
+#include "rtd-1295-xen-hdmirxEDID.dtsi"
+#include "rtd-1296-xen-usb-domu.dtsi"
+/include/ "rtd-1295-xen-pinctrl-domu.dtsi"
+/include/ "rtd-1295-xen-irda.dtsi"
+
+/{
+	/* #*cells are here to keep DTC happy */
+	#address-cells = <2>;
+	#size-cells = <2>;
+
+	aliases {
+		serial1 = &uart1;
+		i2c1 = &i2c_1;
+		i2c2 = &i2c_2;
+		i2c3 = &i2c_3;
+		i2c4 = &i2c_4;
+		i2c5 = &i2c_5;
+	};
+
+	/*
+	 * Do not add other settings here other than CMA info since XEN only
+	 * bypass CMA properties
+	 */
+	chosen {
+		compatible = "Realtek,rtk1295-cma_info", "Realtek,DomU-cma_info";
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+	};
+
+	/* Extra node add by RTK so DTB could control reserve memory */
+	reserved-memory {
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		phys_resv@0 {
+			reg = <0x0 SYS_BOOTCODE_MEMBASE 0x0 SYS_BOOTCODE_MEMSIZE>,
+			      <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>,
+			      <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>,
+			      <0x0 ION_AUDIO_HEAP_PHYS 0x0 ION_AUDIO_HEAP_SIZE>,
+			      <0x0 ION_MEDIA_HEAP_PHYS1 0x0 ION_MEDIA_HEAP_SIZE1>,
+			      <0x0 ACPU_IDMEM_PHYS 0x0 ACPU_IDMEM_SIZE>,
+			      <0x0 ION_MEDIA_HEAP_PHYS2 0x0 ION_MEDIA_HEAP_SIZE2>;
+		};
+
+		Tee_reserved: tee@0 {
+			no-map;
+			reg = <0x0 0x10100000 0x0 0x00F00000>;
+		};
+	};
+
+	passthrough {
+		compatible = "simple-bus";
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		firmware {
+			android {
+				compatible = "android,firmware";
+
+				fstab {
+					compatible = "android,fstab";
+
+					/* 51712 is MAJOR number of xenblk defined under include/uapi/linux/major.h */
+					system {
+						compatible = "android,system";
+						dev = "/dev/block/vbd/51712/by-name/system";
+						type = "ext4";
+						mnt_flags = "ro,noatime";
+						fsmgr_flags = "wait";
+					};
+					vendor {
+						compatible = "android,vendor";
+						dev = "/dev/block/vbd/51712/by-name/vendor";
+						type = "ext4";
+						mnt_flags = "ro,noatime";
+						fsmgr_flags = "wait";
+					};
+				};
+			};
+			optee {
+				compatible = "linaro,optee-tz";
+				method = "smc";
+			};
+		};
+
+		pinctrl: pinctrl@9801A000 {
+			compatible = "realtek,rtk129x-pinctrl";
+			reg = <0x0 0x9801A000 0x0 0x97c>,
+			      <0x0 0x9804d000 0x0 0x010>,
+			      <0x0 0x98012000 0x0 0x640>,
+			      <0x0 0x98007000 0x0 0x340>;
+			#gpio-range-cells = <3>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&sdcard_pins_low>,
+				    <&sdcard_pins_high>;
+			status = "okay";
+		};
+
+		mux_intc: intc@9801B000 {
+			compatible = "Realtek,rtk-irq-mux";
+			Realtek,mux-nr = <2>;
+			#interrupt-cells = <2>;
+			interrupt-controller;
+			reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP MISC_ISO */
+			      <0x0 0x98007000 0x0 0x100>;
+			interrupts = <0 40 4>, <0 41 4>;
+			intr-status = <0xc>, <0x0>;
+			intr-en = <0x80>, <0x40>;
+			status = "okay";
+		};
+
+		rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+			compatible = "realtek,rtk-misc-gpio-irq-mux";
+			gpio-controller;
+			#gpio-cells = <3>; /*must be the same with gpiochip.of_gpio_n_cells*/
+			Realtek,gpio_base = <0>;
+			Realtek,gpio_numbers = <101>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <0 19>, <0 20>; /*GPIOA_INT   GPIODA_INT*/
+			reg = <0x0 0x9801b000 0x0 0x100>,
+			      <0x0 0x9801b100 0x0 0x100>; /* MISC_SYS MISC_GPIO*/
+			gpio-ranges = <&pinctrl 0 0 101>;
+			status = "okay";
+		};
+
+		rtk_iso_gpio: rtk_iso_gpio@98007100 {
+			compatible = "realtek,rtk-iso-gpio-irq-mux";
+			gpio-controller;
+			#gpio-cells = <3>;
+			Realtek,gpio_base = <101>;
+			Realtek,gpio_numbers = <35>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+			reg = <0x0 0x98007000 0x0 0x100>,
+			      <0x0 0x98007100 0x0 0x100>; /* ISO_SYS ISO_GPIO*/
+			gpio-ranges = <&pinctrl 0 101 35>;
+			status = "okay";
+		};
+
+		rfkill: rfkilligpio {
+			compatible = "Realtek,rfkill";
+			gpios = <&rtk_iso_gpio 24 1 0>; /*bt power , output, default low */
+			status = "okay";
+		};
+
+		rtk,ion {
+			compatible = "Realtek,rtk-ion";
+			#address-cells = <1>;
+			#size-cells = <0>;
+
+			rtk,ion-heap@0 { /* SYSTEM_HEAP */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <0>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@1 { /* System contig */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <1>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@4 { /* DMA_HEAP */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <4>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@8 { /* Audio */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <8>;
+				rtk,memory-reserve = <
+					ION_AUDIO_HEAP_PHYS
+					ION_AUDIO_HEAP_SIZE
+					ION_AUDIO_HEAP_FLAG>;
+			};
+
+			rtk,ion-heap@7 { /* TYPE_MEDIA */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <7>;
+				rtk,memory-reserve = <
+					ION_MEDIA_HEAP_PHYS1
+					ION_MEDIA_HEAP_SIZE1
+					ION_MEDIA_HEAP_FLAG1
+					ION_MEDIA_HEAP_PHYS2
+					ION_MEDIA_HEAP_SIZE2
+					ION_MEDIA_HEAP_FLAG2>;
+			};
+		}; /* rtk,ion */
+
+		fb {
+			compatible = "Realtek,rtk-fb";
+			buffer-cnt = <3>;
+			resolution = <1920 1080>;
+			fps = <60>;
+		};
+
+		rbus@98000000 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		md@9800b000 {
+			compatible = "realtek,md";
+			reg = <0x0 0x9800b000 0x0 0x1000>;
+			interrupts = <0 38 4>; /* 70 - 32 = 38 */
+			clocks = <&clk_en_1 CLK_EN_MD>;
+			resets = <&rst1 RSTN_MD>;
+		};
+
+		se@9800c000 {
+			compatible = "realtek,se";
+			reg = <0x0 0x9800c000 0x0 0x1000>;
+			interrupts = <0 20 4>; /* 52 - 32 = 20 */
+			clocks = <&clk_en_1 CLK_EN_SE>;
+			resets = <&rst1 RSTN_SE>;
+			power-domains = <&pd0 PD_SRAM_DISP_SE>;
+		};
+
+		refclk@9801b540 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x9801b000 0x0 0x1000>;
+		};
+
+		hdmitx@9800D000 {
+			compatible = "realtek,rtd129x-hdmitx";
+			reg = <0x0 0x9800d000 0x0 0x560>, /* HDMITX */
+			      <0x0 0x98007200 0x0 0x4>; /* I2C1_REQ_CTRL */
+			gpio-hpd-detect = <&rtk_iso_gpio 6 0 0>; /* Hotplug detect pin */
+			clocks = <&clk_en_1 CLK_EN_HDMI>;
+			clock-names = "clk_en_hdmi";
+			resets = <&rst1 RSTN_HDMI>;
+			reset-names = "rstn_hdmi";
+
+			scdc_rr {
+				enable-scdc-rr = <0>;
+				interrupt-parent = <&mux_intc>;
+				#interrupt-cells = <1>;
+				interrupt-controller;
+				interrupts = <1 31>;
+			};
+		};
+
+		hdcptx@9800D000 {
+			compatible = "realtek,rtk129x-hdcptx";
+			reg = <0x0 0x9800d000 0x0 0x400>;
+			interrupts = <0 31 4>; /*gen Ri*/
+		};
+
+		hdmirx@98034000 {
+			compatible = "Realtek,rtk-mipi-top";
+			reg = <0x0 0x98037000 0x0 0xE0>,
+			      <0x0 0x98034000 0x0 0xF54>,
+			      <0x0 0x98035F00 0x0 0x2C>,
+			      <0x0 0x98037700 0x0 0x98>,
+			      <0x0 0x98004000 0x0 0xF0>,
+			      <0x0 0x98004100 0x0 0x104>;
+			interrupts = <0 23 4>;
+			gpio-rx-hpd-ctrl = <&rtk_iso_gpio 22 1 0>;
+			power-saving = <0>; /* 1:ON,0:OFF; Turn off RX when cable unplugged */
+			clocks = <&clk_en_2 CLK_EN_HDMIRX>,
+			         <&clk_en_1 CLK_EN_MIPI>,
+			         <&clk_en_2 CLK_EN_CBUS_TX>,
+			         <&iclk_en CLK_EN_CBUS_OSC>,
+			         <&iclk_en CLK_EN_CBUS_SYS>,
+			         <&iclk_en CLK_EN_CBUSTX_SYS>,
+			         <&iclk_en CLK_EN_CBUSRX_SYS>,
+			         <&clk_en_1 CLK_EN_TP>,
+			         <&clk_en_1 CLK_EN_CP>;
+			clock-names = "hdmirx",
+				      "mipi",
+				      "cbus_tx",
+				      "cbus_osc",
+				      "cbus_sys",
+				      "cbustx_sys",
+				      "cbusrx_sys",
+				      "tp",
+				      "cp";
+			resets = <&rst4 RSTN_HDMIRX>,
+				 <&rst4 RSTN_HDMIRX_WRAP>,
+				 <&rst1 RSTN_MIPI>,
+				 <&rst2 RSTN_CBUS_TX>,
+				 <&irst IRSTN_CBUS>,
+				 <&irst IRSTN_CBUSTX>,
+				 <&irst IRSTN_CBUSRX>,
+				 <&rst1 RSTN_TP>,
+				 <&rst1 RSTN_CP>;
+			reset-names = "hdmirx",
+				      "hdmirx_wrap",
+				      "mipi",
+				      "cbus_tx",
+				      "cbus",
+				      "cbustx",
+				      "cbusrx",
+				      "tp",
+				      "cp";
+			power-domains = <&pd0 PD_SRAM_DISP_HDMIRX>;
+		};
+
+		uart1: serial1@9801B200 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B200 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x8>;
+			interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			clocks = <&clk_en_2 CLK_EN_UR1>;
+			resets = <&rst2 RSTN_UR1>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		uart2: serial2@9801B400 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B400 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x100>;
+			interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			clocks = <&clk_en_2 CLK_EN_UR2>;
+			resets = <&rst2 RSTN_UR2>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		sdmmc@98010400 {
+			compatible = "Realtek,rtk1295-sdmmc";
+			gpios = <&rtk_misc_gpio 99 1 0>; /*sd power , output, default high  (poweroff) */
+			reg = <0x0 0x98000000 0x0 0x400>, /* CRT */
+			      <0x0 0x98010400 0x0 0x200>, /* SDMMC */
+			      <0x0 0x9801A000 0x0 0x400>, /* BS2 */
+			      <0x0 0x98012000 0x0 0xa00>, /* EMMC */
+			      <0x0 0x98010A00 0x0 0x40>; /* SDIO */
+			interrupts = <0 44 4>;
+			clocks = <&clk_en_1 CLK_EN_CR>,
+				 <&clk_en_1 CLK_EN_SD_IP>;
+			clock-names = "cr",
+				      "sd_ip";
+		};
+
+		pu_pll@98000000 {
+			compatible = "Realtek,rtk1295-pu_pll";
+			reg = <0x0 0x98000000 0x0 0x200>;
+		};
+
+		jpeg@9803e000 {
+			compatible = "Realtek,rtk1295-jpeg";
+			reg = <0x0 0x9803e000 0x0 0x1000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 52 4>;
+			clocks = <&clk_en_2 CLK_EN_JPEG>;
+			clock-names = "jpeg";
+			resets = <&rst2 RSTN_JPEG>;
+		};
+
+		ve1@98040000 {
+			compatible = "Realtek,rtk1295-ve1";
+			reg = <0x0 0x98040000 0x0 0x8000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 53 4>, <0 54 4>;
+			clocks = <&cc CC_CLK_VE1>,
+				 <&cc CC_CLK_VE2>;
+			clock-names = "clk_ve1",
+				      "clk_ve2";
+			resets = <&rst1 RSTN_VE1>,
+				 <&rst1 RSTN_VE2>;
+			reset-names = "ve1",
+				      "ve2";
+		};
+
+		ve3@98048000 {
+			compatible = "Realtek,rtk1295-ve3";
+			reg = <0x0 0x98048000 0x0 0x4000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 55 4>;
+			clocks = <&cc CC_CLK_VE3>;
+			resets = <&rst1 RSTN_VE3>;
+		};
+
+		rpc@9801a104 {
+			compatible = "Realtek,rtk-rpc";
+			reg = <0x0 0x9801a104 0x0 0xc>, /* rpc intr en */
+			      <0x0 0x01ffe000 0x0 0x4000>, /* rpc ring buffer */
+			      <0x0 0x0001f000 0x0 0x1000>, /* rpc common */
+			      <0x0 0x9801a020 0x0 0x4>; /* rbus sync */
+			interrupts = <0 33 4>;
+		};
+
+		irda@98007400 {
+			compatible = "Realtek,rtk-irda";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x98007000 0x0 0X400>,
+			      <0x0 0x98007400 0x0 0x100>;
+			interrupts = <1 5>;
+			resets = <&irst IRSTN_IR>;
+			clocks = <&iclk_en CLK_EN_MISC_IR>;
+			status = "okay";
+		};
+
+		regulators {
+			compatible = "xen,vreg";
+
+			gpu_supp: dcdc3 {
+				regulator-compatible = "dcdc3";
+				regulator-init-microvolt = <1000000>;
+			};
+		};
+
+		i2c_1: i2c@0x98007C00 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x98007C00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <1 11>;
+			i2c-num = <1>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&iclk_en CLK_EN_I2C1>;
+		};
+
+		i2c_2: i2c@0x9801B700 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801B700 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 26>;
+			i2c-num = <2>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_2>;
+		};
+
+		i2c_3: i2c@0x9801B900 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801B900 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 23>;
+			i2c-num = <3>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_3>;
+		};
+
+		i2c_4: i2c@0x9801BA00 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801BA00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 15>;
+			i2c-num = <4>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_4>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&i2c_pins_4>;
+		};
+
+		i2c_5: i2c@0x9801BB00 {
+			compatible = "realtek,rtk-i2c";
+			reg = <0x0 0x9801BB00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <0 14>;
+			i2c-num = <5>;
+			status = "okay";
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+
+			rts5400@6A {
+				compatible = "rtk-rts5400";
+				reg = <0x6A>;
+				realtek,12v-power-gpio = <&rtk_misc_gpio 16 1 0>; /*1296 u3host power, output, default low */
+			};
+		};
+
+		dptx@9803D000 {
+			compatible = "Realtek,rtk129x-dptx";
+			reg = <0x0 0x9803D000 0x0 0x1000>,
+			      <0x0 0x98000000 0x0 0x1000>,
+			      <0x0 0x98009400 0x0 0x600>,
+			      <0x0 0x98005000 0x0 0x1000>;
+			interrupts = <0 29 4>; /*gen Ri*/
+			clocks = <&clk_en_1 CLK_EN_TVE>,
+				 <&clk_en_1 CLK_EN_VO>,
+				 <&clk_en_1 CLK_EN_LVDS>;
+			resets = <&irst IRSTN_DP>,
+				 <&rst1 RSTN_TVE>,
+				 <&rst1 RSTN_VO>,
+				 <&rst1 RSTN_LVDS>;
+			reset-names = "dp",
+				      "tve",
+				      "vo",
+				      "lvds";
+			dp_hpd {
+				gpios = <&rtk_iso_gpio 7 0 0>; /*HPD, input, default N/A */
+				interrupt-parent = <&rtk_iso_gpio>;
+				interrupts = <7>; /*HPD*/
+			};
+		};
+
+		gpu: gpu@98050000 {
+			compatible = "arm,mali-midgard";
+			reg = <0x0 0x98050000 0x0 0xffff>;
+			interrupts = <0 67 4>, <0 68 4>, <0 66 4>;
+			interrupt-names = "JOB", "MMU", "GPU";
+			clocks = <&cc CC_CLK_GPU>;
+			clock-names = "clk_mali";
+			resets = <&rst1 RSTN_GPU>;
+			mali-supply = <&gpu_supp>;
+			#cooling-cells = <2>;
+			status = "okay";
+			power-model {
+				compatible = "arm,mali-simple-power-model";
+				static-coefficient = <2427750>;
+				dynamic-coefficient = <4687>;
+				ts = <20000 2000 (-20) 2>;
+				thermal-zone = "cpu-thermal";
+			};
+		};
+
+		pmu {
+			compatible = "arm,armv8-pmuv3";
+			interrupts = <0 48 4>;
+		};
+	}; /* passthrough */
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-sata.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-sata.dtsi
new file mode 100644
index 00000000..025a983
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-sata.dtsi
@@ -0,0 +1,90 @@
+/ {
+	/include/ "rtd-129x-sata.dtsi"
+
+	sata_phy: sata_phy@9803FF60 {
+		clocks = <&clk_en_1 7>;
+		sata-phy@0 {
+			reg = <0>;
+			resets = <&rst1 10>;
+			reset-names = "rstn_sata_phy_pow_0";
+			spread-spectrum = <0>;
+			phy-param = <0x00001111>, <0x00005111>, <0x00009111>,
+					<0x336a0511>, <0x336a4511>, <0x336a8511>,
+					<0xE0700111>, <0xE05C4111>, <0xE04A8111>,
+					<0x00150611>, <0x00154611>, <0x00158611>,
+					<0xC6000A11>, <0xC6004A11>, <0xC6008A11>,
+					<0x70000211>, <0x70004211>, <0x70008211>,
+					<0xC6600A11>, <0xC6604A11>, <0xC6608A11>,
+					<0x20041911>, <0x20045911>, <0x20049911>,
+					<0x94aa2011>, <0x94aa6011>, <0x94aaa011>,
+					<0x17171511>, <0x17175511>, <0x17179511>,
+					<0x07701611>, <0x07705611>, <0x07709611>,
+					<0x40002a11>, <0x40006a11>, <0x4000aa11>,
+					<0x27710311>, <0x27684311>, <0x27648311>,
+					<0x29001011>, <0x29005011>, <0x29009011>,
+					<0x40000C11>, <0x40004C11>, <0x40008C11>,
+					<0x00271711>, <0x00275711>, <0x00279711>;
+			/delete-property/ phy-param;
+			tx-driving = <2>;
+			
+			tx-driving-tbl = // user can define tx driving here //
+					<0x94a72011>, <0x94a76011>, <0x94a7a011>,
+					<0x587a2111>, <0x587a6111>, <0x587aa111>;
+			/delete-property/ tx-driving-tbl;
+		};
+		sata-phy@1 {
+			reg = <1>;
+			resets = <&rst4 7>;
+			reset-names = "rstn_sata_phy_pow_1";
+			spread-spectrum = <0>;
+			phy-param = <0x00001111>, <0x00005111>, <0x00009111>,
+					<0x336a0511>, <0x336a4511>, <0x336a8511>,
+					<0xE0700111>, <0xE05C4111>, <0xE04A8111>,
+					<0x00150611>, <0x00154611>, <0x00158611>,
+					<0xC6000A11>, <0xC6004A11>, <0xC6008A11>,
+					<0x70000211>, <0x70004211>, <0x70008211>,
+					<0xC6600A11>, <0xC6604A11>, <0xC6608A11>,
+					<0x20041911>, <0x20045911>, <0x20049911>,
+					<0x94aa2011>, <0x94aa6011>, <0x94aaa011>,
+					<0x17171511>, <0x17175511>, <0x17179511>,
+					<0x07701611>, <0x07705611>, <0x07709611>,
+					<0x40002a11>, <0x40006a11>, <0x4000aa11>,
+					<0x27710311>, <0x27684311>, <0x27648311>,
+					<0x29001011>, <0x29005011>, <0x29009011>,
+					<0x40000C11>, <0x40004C11>, <0x40008C11>,
+					<0x00271711>, <0x00275711>, <0x00279711>;
+			/delete-property/ phy-param;
+			tx-driving = <2>;
+			
+			tx-driving-tbl = // user can define tx driving here //
+					<0x94a72011>, <0x94a76011>, <0x94a7a011>,
+					<0x587a2111>, <0x587a6111>, <0x587aa111>;
+			/delete-property/ tx-driving-tbl;
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		clocks = <&clk_en_1 2>,
+			<&clk_en_1 7>,
+			<&clk_en_2 25>,
+			<&clk_en_2 26>;
+		sata-port@0 {
+			reg = <0>;
+			phys = <&sata_phy 0>;
+			resets = <&rst1 5>,
+				<&rst1 7>;
+			reset-names = "rstn_sata_0",
+				"rstn_sata_phy_0";
+			gpios = <&rtk_misc_gpio 56 1 1>;
+		};
+		sata-port@1 {
+			reg = <1>;
+			phys = <&sata_phy 1>;
+			resets = <&rst4 10>,
+				<&rst4 9>;
+			reset-names = "rstn_sata_1",
+				"rstn_sata_phy_1";
+			gpios = <&rtk_iso_gpio 15 1 1>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-usb-xen-pass.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-usb-xen-pass.dtsi
new file mode 100644
index 00000000..0e9d667a
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-usb-xen-pass.dtsi
@@ -0,0 +1,84 @@
+
+/ {
+	/include/ "rtd-129x-usb.dtsi"
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		xen,passthrough;
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		xen,passthrough;
+
+		dwc3_drd@98020000 {
+			xen,passthrough;
+		};
+
+		rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			xen,passthrough;
+		};
+
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,dwc3";
+		xen,passthrough;
+
+		dwc3_u2host@98029000 {
+			xen,passthrough;
+		};
+	};
+
+	ehci@98013000 {
+		compatible = "Realtek,rtd129x-ehci";
+		xen,passthrough;
+	};
+
+	ohci@98013400 {
+		compatible = "Realtek,rtd129x-ohci";
+		xen,passthrough;
+	};
+
+	dwc3_u3host_usb3phy@0 {
+		compatible = "Realtek,usb3phy";
+		xen,passthrough;
+	};
+
+	dwc3_u3host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		xen,passthrough;
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		compatible = "Realtek,dwc3";
+		xen,passthrough;
+
+		dwc3_u3host@981F0000 {
+			xen,passthrough;
+		};
+	};
+
+};
+
+/* Nodes under rtd-129x-usb.dtsi which need passthrough */
+&dwc3_drd_usb3phy {
+	xen,passthrough;
+};
+
+&dwc3_drd_usb2phy {
+	xen,passthrough;
+};
+
+&dwc3_u2host_usb2phy {
+	xen,passthrough;
+};
+
+&ehci_phy_rle0599 {
+	xen,passthrough;
+};
+
+&usb2_udc {
+	xen,passthrough;
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-usb.dtsi
new file mode 100644
index 00000000..e3eb31f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-usb.dtsi
@@ -0,0 +1,74 @@
+
+/ {
+	/include/ "rtd-129x-usb.dtsi"
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+
+		status = "okay";
+		/* For port0 */
+		gpio0: gpio0 {
+			realtek,power-gpio = <&rtk_iso_gpio 1 1 0>;
+		};
+		/* For port1 and port2 */
+		gpio1: gpio1 {
+			realtek,power-gpio = <&rtk_iso_gpio 31 1 0>;
+		};
+		/* For port2 */
+		gpio2: gpio2 {
+			realtek,power-gpio = <&rtk_iso_gpio 32 1 0>;
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+		};
+
+		rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			drd_mode;  //depend on dr_mode = "peripheral"
+		};
+
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,dwc3";
+
+		status = "okay";
+	};
+
+	ehci@98013000 {
+		compatible = "Realtek,rtd129x-ehci";
+
+		status = "okay";
+	};
+
+	ohci@98013400 {
+		compatible = "Realtek,rtd129x-ohci";
+
+		status = "okay";
+	};
+
+	dwc3_u3host_usb3phy@0 {
+		compatible = "Realtek,usb3phy";
+
+		status = "okay";
+	};
+
+	dwc3_u3host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+
+		status = "okay";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		compatible = "Realtek,dwc3";
+
+		status = "okay";
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-videonas-saola-2GB.dts b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-videonas-saola-2GB.dts
new file mode 100644
index 00000000..8dea5ca
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-videonas-saola-2GB.dts
@@ -0,0 +1,163 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE */
+/memreserve/ 0x00000000 0x00030000;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01b00000 ~ 0x01efffff ACPU_FIREWARE_PHYS ACPU_FIREWARE_SIZE */
+/memreserve/ 0x01B00000 0x00400000;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02600000 ~ 0x02dfffff ION_AUDIO_HEAP_PHYS ION_AUDIO_HEAP_SIZE */
+/memreserve/ 0x02600000 0x00800000;
+/* 0x02E00000 ~ 0x0fffffff ION_MEDIA_HEAP_PHYS1 ION_MEDIA_HEAP_SIZE1 */
+/memreserve/ 0x02E00000 0x0D200000;
+/* 0x10000000 ~ 0x10013fff ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE */
+/memreserve/ 0x10000000 0x00014000;
+/* 0x12000000 ~ 0x1f4fffff ION_MEDIA_HEAP_PHYS2 ION_MEDIA_HEAP_SIZE2 */
+/memreserve/ 0x12000000 0x0D500000;
+
+
+#include "rtd-1296.dtsi"
+#include "rtd-1296-saola-common.dtsi"
+
+/ {
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+	};
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+	chosen {
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>,
+			<0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x02600000
+				0x00800000
+				ION_AUDIO_HEAP_FLAG>;
+	};
+
+	rtk,ion-heap@7 { /* TYPE_MEDIA */
+		compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x02E00000
+				0x0D200000
+				ION_MEDIA_HEAP_FLAG1
+				0x12000000
+				0x0D500000
+				ION_MEDIA_HEAP_FLAG2>;
+		};
+	};
+
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <1>;
+		resolution = <1920 1080>;
+		fps = <60>;
+		osd-init = <1>;
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-xen-saola-common.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-xen-saola-common.dtsi
new file mode 100644
index 00000000..b0f6c1e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-xen-saola-common.dtsi
@@ -0,0 +1,100 @@
+#include "rtd-1296-xen.dtsi"
+
+/ {
+	model= "Realtek_RTD1296";
+	compatible = "Realtek,rtd-1296";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	arch_timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0@9801B000 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1@9801B000 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	serial1@9801B200 {
+		clock-frequency = <432000000>;
+	};
+
+	serial2@9801B400 {
+		clock-frequency = <432000000>;
+	};
+
+	chosen {
+		swiotlb-memory-reservation-size = <512>;
+		swiotlb-force = <0>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		status = "disabled";
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+		};
+	};
+
+	fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+		status = "disabled";
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		gpios = <&rtk_misc_gpio 8 0 0>, /* install button */
+			<&rtk_misc_gpio 100 1 1>; /* audio dac unmute */
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 21 1 0>;         /* igpio21, output, default low */
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-xen-usb-domu.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-xen-usb-domu.dtsi
new file mode 100644
index 00000000..f0fb139
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-xen-usb-domu.dtsi
@@ -0,0 +1,108 @@
+
+/ {
+	passthrough {
+
+	/include/ "rtd-129x-usb.dtsi"
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		reg = <0x0 0x98000000 0x0 0x10>;
+		realtek,port1-power-gpio = <&rtk_iso_gpio 31 1 0>; /*u2host power, output, default low */
+		realtek,port2-power-gpio = <&rtk_misc_gpio 19 1 0>; /*ehci power, output, default low */
+		realtek,port3-power-gpio = <&rtk_iso_gpio 32 1 0>; /*1296 u3host power, output, default low */
+
+		status = "okay";
+	};
+
+	dwc3_drd_usb3phy: dwc3_drd_usb3phy@0 {
+		compatible = "Realtek,usb3phy";
+		reg = <0x0 0x98013210 0x0 0x4>;
+		ranges = <0x98000000 0x0 0x98000000 0x200000>;
+	};
+
+	dwc3_drd_usb2phy: dwc3_drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98028280 0x0 0x4>,
+		      <0x0 0x98013214 0x0 0x4>;
+		ranges = <0x98000000 0x0 0x98000000 0x200000>;
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013200 0x0 0x200>;
+		status = "okay";
+		ranges = <0x98000000 0x0 0x98000000 0x200000>;
+
+		dwc3_drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+		};
+
+		rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			drd_mode;  //depend on dr_mode = "peripheral"
+		};
+
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98031280 0x0 0x4>,
+		      <0x0 0x98013C14 0x0 0x4>;
+		ranges = <0x98000000 0x0 0x98000000 0x200000>;
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013C00 0x0 0x200>;
+		status = "okay";
+		ranges = <0x98000000 0x0 0x98000000 0x200000>;
+	};
+
+	ehci_phy_rle0599: usb_phy_rle0599@0 {
+		compatible = "Realtek,rtd129x-usb_phy_rle0599";
+		reg = <0x0 0x98013824 0x0 0x4>,
+		      <0x0 0x980130A4 0x0 0x4>;
+	};
+
+	ehci@98013000 {
+		compatible = "Realtek,rtd129x-ehci";
+		reg = <0x0 0x98013000 0x0 0x100>;
+		status = "okay";
+	};
+
+	ohci@98013400 {
+		compatible = "Realtek,rtd129x-ohci";
+		reg = <0x0 0x98013400 0x0 0x100>;
+		status = "okay";
+	};
+
+	usb2_udc: usb2_udc@981E0000 {
+		compatible = "Realtek,rtd129x-usb2-udc";
+		reg = <0x0 0x981E0000 0x0 0x8000>,
+		      <0x0 0x98013800 0x0 0x80>;
+	};
+
+	dwc3_u3host_usb3phy@0 {
+		compatible = "Realtek,usb3phy";
+		reg = <0x0 0x98013E10 0x0 0x4>;
+		status = "okay";
+		ranges = <0x98000000 0x0 0x98000000 0x200000>;
+	};
+
+	dwc3_u3host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x981F8280 0x0 0x4>,
+		      <0x0 0x98013E14 0x0 0x4>;
+		status = "okay";
+		ranges = <0x98000000 0x0 0x98000000 0x200000>;
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013E00 0x0 0x200>;
+		status = "okay";
+		ranges = <0x98000000 0x0 0x98000000 0x200000>;
+	};
+
+	}; /* passthrough */
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-xen.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-xen.dtsi
new file mode 100644
index 00000000..965e5c2
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296-xen.dtsi
@@ -0,0 +1,1083 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include "rtd-129x-common.dtsi"
+/include/ "rtd-1295-pinctrl.dtsi"
+/include/ "rtd-1295-irda.dtsi"
+/* /include/ "rtd-1296-usb.dtsi" */
+/include/ "rtd-1296-usb-xen-pass.dtsi"
+/include/ "rtd-1296-sata.dtsi"
+/include/ "rtd-129x-dcsys-debug.dtsi"
+
+/{
+	compatible = "realtek,rtd1296";
+	interrupt-parent = <&gic>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A53_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x0>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x1>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x02>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x03>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		a53_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	soc@0 {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x98000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+
+
+	};
+
+
+
+	arch_timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <1 13 0xf08>,
+			<1 14 0xf08>,
+			<1 11 0xf08>,
+			<1 10 0xf08>;
+		clock-frequency = <27000000>;
+	};
+
+	gic: interrupt-controller@FF010000 {
+		compatible = "arm,cortex-a15-gic", "arm,gic-400";
+		#interrupt-cells = <3>;
+		interrupt-controller;
+		reg = <0xFF011000 0x1000>,
+		      <0xFF012000 0x1000>,
+		      <0xFF014000 0x2000>,
+		      <0xFF016000 0x2000>;
+		interrupts = <1 9 0xf04>;
+		linux,phandle = <0x1>;
+		phandle = <0x1>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <0 48 4>;
+		xen,passthrough;
+	};
+
+	pinctrl: pinctrl@9801A000 {
+		compatible = "realtek,rtk129x-pinctrl";
+		reg = <0x9801A000 0x97c>,
+			<0x9804d000 0x010>,
+			<0x98012000 0x640>,
+			<0x98007000 0x340>;
+		#gpio-range-cells = <3>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>,
+			<&sdcard_pins_high>,
+			<&uart0_pins>,
+			<&uart1_pins>,
+			<&uart2_pins_0>,
+			<&i2c_pins_0>,
+			<&i2c_pins_1>,
+			<&i2c_pins_5>,
+			<&i2c_pins_6>,
+			<&pcie1_clk_pins>,
+			<&pcie2_clk_pins>,
+			<&rgmii0_pins>,
+			<&ir_rx_pins>,
+			<&ir_tx_pins>,
+			<&spdif_pins>,
+			<&pwm0_0_pins>,
+			<&etn_led_pins>;
+		status = "okay";
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x9801B000 0x100>, /* MISC_TOP MISC_ISO */
+			<0x98007000 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		compatible = "realtek,rtk-misc-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>; /*must be the same with gpiochip.of_gpio_n_cells*/
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <101>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <0 19>, <0 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x9801b000 0x100>,
+			<0x9801b100 0x100>; /* MISC_SYS MISC_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 101>;
+		status = "okay";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <101>;
+		Realtek,gpio_numbers = <35>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x98007000 0x100>,
+			<0x98007100 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 101 35>;
+		status = "okay";
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x98000000 0x200000>;
+		xen,passthrough;
+	};
+
+	md@9800b000 {
+		compatible = "realtek,md";
+		reg = <0x9800b000 0x1000>;
+		interrupts = <0 38 4>; /* 70 - 32 = 38 */
+		clocks = <&clk_en_1 CLK_EN_MD>;
+		resets = <&rst1 RSTN_MD>;
+		xen,passthrough;
+	};
+
+	se@9800c000 {
+		compatible = "realtek,se";
+		reg = <0x9800c000 0x1000>;
+		interrupts = <0 20 4>; /* 52 - 32 = 20 */
+		clocks = <&clk_en_1 CLK_EN_SE>;
+		resets = <&rst1 RSTN_SE>;
+		power-domains = <&pd0 PD_SRAM_DISP_SE>;
+		xen,passthrough;
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x9801b000 0x1000>;
+		xen,passthrough;
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd129x-hdmitx";
+		reg = <0x9800d000 0x560>, /* HDMITX */
+			<0x98007200 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 6 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&rst1 RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		xen,passthrough;
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 31>;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtk129x-hdcptx";
+		reg = <0x9800d000 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		xen,passthrough;
+	};
+
+	hdmirx@98034000 {
+		compatible = "Realtek,rtk-mipi-top";
+		reg = <0x98037000 0xE0>,
+			<0x98034000 0xF54>,
+			<0x98035F00 0x2C>,
+			<0x98037700 0x98>,
+			<0x98004000 0xF0>,
+			<0x98004100 0x104>;
+		interrupts = <0 23 4>;
+		gpio-rx-hpd-ctrl = <&rtk_iso_gpio 22 1 0>;
+		power-saving = <0>; /* 1:ON,0:OFF; Turn off RX when cable unplugged */
+		clocks = <&clk_en_2 CLK_EN_HDMIRX>,
+			<&clk_en_1 CLK_EN_MIPI>,
+			<&clk_en_2 CLK_EN_CBUS_TX>,
+			<&iclk_en CLK_EN_CBUS_OSC>,
+			<&iclk_en CLK_EN_CBUS_SYS>,
+			<&iclk_en CLK_EN_CBUSTX_SYS>,
+			<&iclk_en CLK_EN_CBUSRX_SYS>,
+			<&clk_en_1 CLK_EN_TP>,
+			<&clk_en_1 CLK_EN_CP>;
+		clock-names = "hdmirx",
+			"mipi",
+			"cbus_tx",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys",
+			"tp",
+			"cp";
+		resets = <&rst4 RSTN_HDMIRX>,
+			<&rst4 RSTN_HDMIRX_WRAP>,
+			<&rst1 RSTN_MIPI>,
+			<&rst2 RSTN_CBUS_TX>,
+			<&irst IRSTN_CBUS>,
+			<&irst IRSTN_CBUSTX>,
+			<&irst IRSTN_CBUSRX>,
+			<&rst1 RSTN_TP>,
+			<&rst1 RSTN_CP>;
+		reset-names = "hdmirx",
+			"hdmirx_wrap",
+			"mipi",
+			"cbus_tx",
+			"cbus",
+			"cbustx",
+			"cbusrx",
+			"tp",
+			"cp";
+		power-domains = <&pd0 PD_SRAM_DISP_HDMIRX>;
+		xen,passthrough;
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&gic>;
+		reg = <0x98007800 0x400>;
+		interrupts-st-mask = <0x4>;
+		interrupts = <0x0 0x29 0x4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clock-frequency = <2700000>; /* This value must be override by the board. */
+	};
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B200 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR1>;
+		resets = <&rst2 RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+		xen,passthrough;
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B400 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR2>;
+		resets = <&rst2 RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+		xen,passthrough;
+	};
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x98016000 0x1000>,
+			<0x98007000 0x1000>;
+		interrupts = <0 22 4>;
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		output-mode = <0>; /* 0:embedded PHY, 1:RGMII to MAC, 2:RGMII to PHY */
+		rgmii-voltage = <1>; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+		rgmii-tx-delay = <0>; /* 0: 0ns, 1: 2ns */
+		rgmii-rx-delay = <0>; /* 0: 0ns, 1: 2ns */
+		ext-phy-id = <1>; /* 0 ~ 31, only valid when output-mode = 2 */
+		clocks = <&iclk_en CLK_EN_ETN_250M>,
+			<&iclk_en CLK_EN_ETN_SYS>;
+		clock-names = "etn_250m",
+			"etn_sys";
+		resets = <&irst IRSTN_GMAC>,
+			<&irst IRSTN_GPHY>;
+		reset-names = "gmac",
+			"gphy";
+		status = "okay";
+	};
+
+	hwnat: gmac@98060000 {
+		compatible = "Realtek,rtd1295-hwnat";
+		reg = <0x98060000 0x170000>, /* NAT */
+			<0x98000000 0x20000>, /* CLK SYS */
+			<0x9803FF00 0x100>; /* SATA Wrapper */
+		interrupts = <0 24 4>;
+		offload_enable = <0>; /* 0:disable, 1:enable HW NAT offload */
+		rgmii_voltage = <1>; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+		rgmii0_tx_delay = <0>; /* 0 to 7: 0.5ns per step */
+		rgmii0_rx_delay = <4>; /* 0 to 7: 0.5ns per step */
+		rgmii1_tx_delay = <0>; /* 0 to 7: 0.5ns per step */
+		rgmii1_rx_delay = <4>; /* 0 to 7: 0.5ns per step */
+		rgmii_enable = <1>; /* 0:disable, 1:enable */
+		mac0_enable = <1>; /* 0:disable, 1:enable */
+		mac0_mode = <0>; /* 0:RGMII to PHY, 1:SGMII to PHY, 2: RGMII to MAC, 3: SGMII to MAC */
+		mac5_conn_to = <0>; /* 0:PHY, 1:MAC */
+		mac0_phy_id = <2>; /* PHY ID 2 for RGMII, 3 for SGMII */
+		mac4_phy_id = <4>;
+		mac5_phy_id = <1>;
+		led_mode = <1>; /* 0~3: SCAN_0~3, 4~6: DIRECT 0~2 */
+		gpio_link_led_enable = <0>; /* 0:disable, 1:enable */
+		gpios = <&rtk_iso_gpio 27 1 0>; /* Link LED, output, default low */
+
+		clocks = <&cc CC_PLL_DDSA>,
+			<&clk_en_1 CLK_EN_SATA_0>,
+			<&clk_en_1 CLK_EN_SATA_ALIVE_0>,
+			<&clk_en_2 CLK_EN_SATA_1>,
+			<&clk_en_2 CLK_EN_SATA_ALIVE_1>,
+			<&cc CC_PLL_DDSB>,
+			<&clk_en_2 CLK_EN_NAT>,
+			<&iclk_en CLK_EN_ETN_250M>,
+			<&iclk_en CLK_EN_ETN_SYS>;
+		clock-names = "pll_ddsa",
+			"sata_0",
+			"sata_alive_0",
+			"sata_1",
+			"sata_alive_1",
+			"pll_ddsb",
+			"nat",
+			"etn_250m",
+			"etn_sys";
+		resets = <&rst1 RSTN_SATA_0>,
+			<&rst1 RSTN_SATA_PHY_0>,
+			<&rst1 RSTN_SATA_PHY_POW_0>,
+			<&rst1 SATA_FUNC_EXIST_0>,
+			<&rst2 RSTN_SDS_PHY>,
+			<&rst1 RSTN_NAT>,
+			<&irst IRSTN_GMAC>,
+			<&irst IRSTN_GPHY>;
+		reset-names = "sata_0",
+			"sata_phy_0",
+			"sata_phy_pow_0",
+			"sata_func_exist_0",
+			"rstn_sds_phy",
+			"nat",
+			"gmac",
+			"gphy";
+		power-domains = <&pd0 PD_SRAM_NAT>;
+		status = "disabled";
+	};
+
+	timer0@9801B000 {
+		compatible = "realtek,rtk-timer0";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 17 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	timer1@9801B000 {
+		compatible = "realtek,rtk-timer1";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 18 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	pcie@9804E000 {
+		compatible = "realtek,rtk-pcie-slot1";
+		reg = <0x9804E000 0x00001000
+			0x9804F000 0x00001000
+			0x9801C600 0x00000100
+			0x9801A000 0x00000300
+			0x98012000 0x00001000>;
+		interrupt-names = "rtk-pcie1-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic GIC_SPI 61 IRQ_TYPE_LEVEL_HIGH>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <0>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 29 1 1 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		ranges = <0x02000000 0x00000000 0xC0000000  0xC0000000 0x00000000 0x01000000
+			0x01000000 0x00000000 0x00030000  0x00030000 0x00000000 0x00010000>;
+		resets = <&rst2 RSTN_PCIE0>,
+			<&rst2 RSTN_PCIE0_CORE>,
+			<&rst2 RSTN_PCIE0_POWER>,
+			<&rst2 RSTN_PCIE0_NONSTITCH>,
+			<&rst2 RSTN_PCIE0_STITCH>,
+			<&rst2 RSTN_PCIE0_PHY>,
+			<&rst4 RSTN_PCIE0_PHY_MDIO>;
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_1 CLK_EN_PCIE0>;
+		status = "okay";
+		phys_a = <0x31810801>,
+			<0xB2001101>,
+			<0x00100001>;
+		phys_b = <0x00000003>,
+			<0x00900001>,
+			<0x40080401>,
+			<0x5AC10801>,
+			<0x32b40f01>,
+			<0x72001101>;
+	};
+
+	pcie2@9803B000 {
+		compatible = "realtek,rtk-pcie-slot2";
+		reg = <0x9803B000 0x00001000
+			0x9803C000 0x00001000
+			0x9801C600 0x00000100
+			0x9801A000 0x00000300
+			0x98012000 0x00001000>;
+		interrupt-names = "rtk-pcie2-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic GIC_SPI 62 IRQ_TYPE_LEVEL_HIGH>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <1>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 30 1 1>;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		ranges = <0x02000000 0x00000000 0xC1000000  0xC1000000 0x00000000 0x01000000
+			0x01000000 0x00000000 0x00040000  0x00040000 0x00000000 0x00010000>;
+		speed-mode = <0>; // 0:GEN1, 1:GEN2
+		resets = <&rst2 RSTN_PCIE1>,
+			<&rst2 RSTN_PCIE1_CORE>,
+			<&rst2 RSTN_PCIE1_POWER>,
+			<&rst2 RSTN_PCIE1_NONSTITCH>,
+			<&rst2 RSTN_PCIE1_STITCH>,
+			<&rst2 RSTN_PCIE1_PHY>,
+			<&rst4 RSTN_PCIE1_PHY_MDIO>;
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_2 CLK_EN_PCIE1>;
+		status = "okay";
+		phys = <0x00000003>, /* #Write soft reset */
+			<0x27f10301>,
+			<0x52F50401>,/* #F code,close SSC */
+			<0xead70501>,/* #modify N code */
+			<0x000c0601>,/* #modify CMU ICP(TX jitter) */
+			<0xa6530a01>,/* #modify CMU RS(tx jitter) */
+			<0xd4662001>,/* #modify AMP */
+			<0xa84a0101>,/* #modify Rx parameter */
+			<0xb8032b01>,/* #clk driving */
+			<0x27e94301>,/* #EQ */
+			<0x52f54401>,/* #F code,close SSC */
+			<0xead74501>,/* #modify N code */
+			<0x000c4601>,/* #modify CMU ICP(TX jitter) */
+			<0xa6534a01>,/* #modify CMU RS(tx jitter) */
+			<0xd4776001>,/* #modify AMP */
+			<0xa84a4101>,/* #modify Rx parameter */
+			<0xa8036b01>,/* #clk driving */
+			<0x01225a01>;
+	};
+
+	sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 23 1 1>;
+		reg = <0x98010c00 0x200>,
+			<0x98000000 0x200000>;
+		interrupts = <0 45 4>;
+		clocks = <&clk_en_1 CLK_EN_SDIO>,
+			<&clk_en_1 CLK_EN_SDIO_IP>;
+		clock-names = "sdio",
+			"sdio_ip";
+		resets = <&rst2 RSTN_SDIO>;
+		status = "okay";
+	};
+
+	sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_misc_gpio 99 1 0>; /*sd power , output, default high  (poweroff) */
+		reg = <0x98000000 0x400>, /* CRT */
+			<0x98010400 0x200>, /* SDMMC */
+			<0x9801A000 0x400>, /* BS2 */
+			<0x98012000 0xa00>, /* EMMC */
+			<0x98010A00 0x40>; /* SDIO */
+		interrupts = <0 44 4>;
+		clocks = <&clk_en_1 CLK_EN_CR>,
+			<&clk_en_1 CLK_EN_SD_IP>;
+		clock-names = "cr",
+			"sd_ip";
+		xen,passthrough;
+	};
+
+	emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		reg = <0x98012000 0xa00>, /*EMMC*/
+			<0x98000000 0x600>, /*CRT */
+			<0x9801A000 0x80>, /*SB2*/
+			<0x9801B000 0x150>; /*MISC*/
+		interrupts = <0 42 4>;
+		speed-step = <2>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_1 CLK_EN_EMMC>,
+			<&clk_en_1 CLK_EN_EMMC_IP>,
+			<&clk_en_1 CLK_EN_CR>;
+		clock-names = "emmc",
+			"emmc_ip",
+			"cr";
+		resets = <&rst2 RSTN_EMMC>;
+		reset-names = "emmc";
+		status = "okay";
+		pddrive_nf_s0 = <1 0x77 0x77 0x77 0x33>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+		pddrive_nf_s2 = <1 0xbb 0xbb 0xbb 0x33>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+		phase_tuning = <0 0>; /* arg0: tx tuning switch, arg1: rx tuning switch*/
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk1295-pu_pll";
+		reg = <0x98000000 0x200>;
+		xen,passthrough;
+	};
+
+	jpeg@9803e000 {
+		compatible = "Realtek,rtk1295-jpeg";
+		reg = <0x9803e000 0x1000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_2 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&rst2 RSTN_JPEG>;
+		xen,passthrough;
+	};
+
+	ve1@98040000 {
+		compatible = "Realtek,rtk1295-ve1";
+		reg = <0x98040000 0x8000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 53 4>, <0 54 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			<&cc CC_CLK_VE2>;
+		clock-names = "clk_ve1",
+			"clk_ve2";
+		resets = <&rst1 RSTN_VE1>,
+			<&rst1 RSTN_VE2>;
+		reset-names = "ve1",
+			"ve2";
+		xen,passthrough;
+	};
+
+	ve3@98048000 {
+		compatible = "Realtek,rtk1295-ve3";
+		reg = <0x98048000 0x4000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 55 4>;
+		clocks = <&cc CC_CLK_VE3>;
+		resets = <&rst1 RSTN_VE3>;
+		xen,passthrough;
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x9801d000 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x9801a000 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	rpc@9801a104 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x9801a104 0xc>, /* rpc intr en */
+			<0x01ffe000 0x4000>, /* rpc ring buffer */
+			<0x0001f000 0x1000>, /* rpc common */
+			<0x9801a020 0x4>; /* rbus sync */
+		interrupts = <0 33 4>;
+		xen,passthrough;
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007000 0x400>,
+			<0x98007400 0x100>;
+		interrupts = <1 5>;
+		resets = <&irst IRSTN_IR>;
+		clocks = <&iclk_en CLK_EN_MISC_IR>;
+		status = "okay";
+	};
+
+	rtc@9801B600 {
+		compatible = "realtek,rtk-rtc";
+		reg = <0x9801B600 0x100>,
+			<0x98007000 0x100>;
+		rtc-base-year = <2014>;
+		clocks = <&clk_en_2 CLK_EN_MISC_RTC>;
+		status = "okay";
+	};
+
+	watchdog@0x98007680 {
+		compatible = "realtek,rtk-watchdog";
+		reg = <0x98007680 0x100>;
+		rst-oe = <0>; /* 0:input, 1:output */
+		timeout-sec = <20>;
+		status = "okay";
+	};
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x98007600 0x100>;
+		rst-reg-offset = <0x40>;
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x98007D00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 8>;
+		i2c-num = <0>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x98007C00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 11>;
+		i2c-num = <1>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C1>;
+		xen,passthrough;
+	};
+
+	i2c_2: i2c@0x9801B700 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801B700 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 26>;
+		i2c-num = <2>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_2>;
+		xen,passthrough;
+	};
+
+	i2c_3: i2c@0x9801B900 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801B900 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 23>;
+		i2c-num = <3>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_3>;
+		xen,passthrough;
+	};
+
+	i2c_4: i2c@0x9801BA00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801BA00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 15>;
+		i2c-num = <4>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_4>;		
+		xen,passthrough;
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801BB00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 14>;
+		i2c-num = <5>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+		xen,passthrough;
+
+		rts5400@6A {
+			compatible = "rtk-rts5400";
+			reg = <0x6A>;
+			realtek,12v-power-gpio = <&rtk_misc_gpio 16 1 0>; /*1296 u3host power, output, default low */
+			xen,passthrough;
+		};
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk129x-spi";
+		reg = <0x9801BD00 50>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins>;
+		spi-cs-gpio = <&rtk_misc_gpio 6 1 1>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		resets = <&rst1 RSTN_GSPI>;
+		status = "okay";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x980070D0 0xC>;
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+	};
+
+	rtk-lsadc@0x98012800 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 21>, <0 22>; /* LSADC0_INT, LSADC1_INT */
+		reg = <0x9801B00C 0x4>, /* MISC_ISR */
+			<0x98012800 0x200>, /* LSADC */
+			<0x9800034C 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>, /* LSADC0 0:disable; 1:enable */
+						<1>; /* LSADC1 0:disable; 1:enable */
+		vdd_mux_sel = <0>; /* 0:VDD1; 1:VDD2 */
+		vdd_mux1 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux2 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux_en = <1>; /* 0:disable; 1:enable */
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <1>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc1-pad0 {
+			//compatible = "Realtek,rtk-lsadc1-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <0>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+
+		rtk-lsadc1-pad1 {
+			//compatible = "Realtek,rtk-lsadc1-pad1";
+			activate = <1>; /* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0: Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <1>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+	};
+
+	sata@9803F000 {
+		compatible = "Realtek,ahci-sata";
+		reg = <0x9803F000 0x1000>,
+			<0x9801a900 0x100>;
+		interrupts = <0 28 4>;
+		clocks = <&clk_en_1 CLK_EN_SATA_0>,
+			<&clk_en_1 CLK_EN_SATA_ALIVE_0>,
+			<&clk_en_2 CLK_EN_SATA_1>,
+			<&clk_en_2 CLK_EN_SATA_ALIVE_1>;
+		resets = <&rst1 RSTN_SATA_0>,
+			<&rst1 RSTN_SATA_PHY_0>,
+			<&rst1 RSTN_SATA_PHY_POW_0>,
+			<&rst4 RSTN_SATA_1>,
+			<&rst4 RSTN_SATA_PHY_1>,
+			<&rst4 RSTN_SATA_PHY_POW_1>;
+		reset-names = "rstn_sata_0",
+			"rstn_sata_phy_0",
+			"rstn_sata_phy_pow_0",
+			"rstn_sata_1",
+			"rstn_sata_phy_1",
+			"rstn_sata_phy_pow_1";
+
+		status = "okay";
+		hotplug-en = <0>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		sata0: sata-port@0 {
+			reg = <0>;
+			gpios = <&rtk_misc_gpio 56 1 1>;
+		};
+
+		sata1: sata-port@1 {
+			reg = <1>;
+			gpios = <&rtk_iso_gpio 15 1 1>;
+		};
+	};
+
+	cec0@98037800 {
+		compatible = "Realtek,rtk-cec0";
+		reg = <0x98037800 0xe0>,
+			<0x98007000 0x100>,
+			<0x98037500 0x100>;
+		interrupts = <0 26 4>;
+		module-enable = <1>;
+		clocks = <&cc CC_CLK_SYS>,
+			<&iclk_en CLK_EN_CBUS_OSC>,
+			<&iclk_en CLK_EN_CBUS_SYS>,
+			<&iclk_en CLK_EN_CBUSTX_SYS>,
+			<&iclk_en CLK_EN_CBUSRX_SYS>;
+		clock-names = "sys",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys";
+		resets = <&irst IRSTN_CBUS>,
+			<&irst IRSTN_CBUSTX>,
+			<&irst IRSTN_CBUSRX>;
+		reset-names = "cbus",
+			"cbustx",
+			"cbusrx";
+		status = "okay";
+	};
+
+	rfkill: rfkilligpio {
+		compatible = "realtek,rfkill";
+		gpios = <&rtk_iso_gpio 24 1 0>; /*bt power , output, default low */
+		status = "disabled";
+	};
+
+	rtk-gpio-regulator {
+		compatible = "rtkgpio-regulator";
+		gpios = <&rtk_iso_gpio 16 1 0>, <&rtk_iso_gpio 17 1 1>;
+		status = "disabled";
+		//status = "okay";
+		vdd: rtkgpio_regulator {
+			regulator-min-microvolt = <850000>;
+			regulator-max-microvolt = <1050000>;
+		};
+	};
+
+	power-management@0 {
+		compatible = "Realtek,power-management";
+		system-power-controller;
+		reg = <0x98000000 0x1800>, /* CRT */
+			<0x98006000 0x1000>, /* AIO */
+			<0x98007000 0x1000>, /* ISO */
+			<0x98018000 0x2000>, /* TVE */
+			<0x9801A000 0x1000>, /* SB2 */
+			<0x9801B000 0x1000>; /* MISC */
+		suspend-mode = <0>; // 0:SUSPEND_TO_RAM, 1:SUSPEND_TO_COOLBOOT, 2:SUSPEND_TO_WFI
+		pwms = <&pwm 0 37878>;
+		status = "okay";
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk129x-dptx";
+		reg = <0x9803D000 0x1000>, <0x98000000 0x1000>, <0x98009400 0x600>, <0x98005000 0x1000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>,
+			<&clk_en_1 CLK_EN_LVDS>;
+		resets = <&irst IRSTN_DP>,
+			<&rst1 RSTN_TVE>,
+			<&rst1 RSTN_VO>,
+			<&rst1 RSTN_LVDS>;
+		reset-names = "dp",
+			"tve",
+			"vo",
+			"lvds";
+		xen,passthrough;
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 7 0 0>; /*HPD, input, default N/A */
+			interrupt-parent = <&rtk_iso_gpio>;
+			interrupts = <7>; /*HPD*/
+			xen,passthrough;
+		};
+	};
+
+	mcp@0 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x98015000 0x1000>,
+			<0x98014000 0x1000>;
+		status = "okay";
+	};
+
+	rtk_boot {
+		compatible = "Realtek,rtk_boot";
+		resume-entry-addr = <0x00021000>;
+		status = "okay";
+	};
+
+	cpu_tm: thermal-sensor@9801D150 {
+		compatible = "realtek,rtd129x-thermal-sensor";
+		reg = <0x9801D150 0x1C>;
+		#thermal-sensor-cells = <0>;
+
+		status = "okay";
+	};
+
+	gpu: gpu@98050000 {
+		compatible = "arm,mali-midgard";
+		reg = <0x98050000 0xffff>;
+		interrupts = <0 67 4>, <0 68 4>, <0 66 4>;
+		interrupt-names = "JOB", "MMU", "GPU";
+		xen,passthrough;
+	};
+
+	dvfs: dvfs {
+		compatible = "realtek,rtd129x-dvfs";
+		status = "okay";
+		l2-supply = <&l2_supp>;
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+
+			trips {
+				cpu_alert0: cpu-alert0 {
+					temperature = <105000>;
+					hysteresis = <3000>;
+					type = "passive";
+				};
+				cpu_alert1: cpu-alert1 {
+					temperature = <115000>;
+					hysteresis = <3000>;
+					type = "passive";
+				};
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <2000>;
+					type = "critical";
+				};
+			};
+
+			cooling-maps {
+				map0 {
+					trip = <&cpu_alert0>;
+					cooling-device = <&A53_0 1 6>;
+				};
+				map1 {
+					trip = <&cpu_alert1>;
+					cooling-device = <&A53_0 7 11>;
+				};
+			};
+		};
+	};
+};
+
+#include "rtd-129x-g2227-regulator.dtsi"
+#include "rtd-129x-gpu-dvfs.dtsi"
+#include "rtd-129x-cpu-dvfs.dtsi"
+
+/* invalidate the following pds, since they are used in OTT */
+&pd0 {
+	invalid-power-domains =
+		"ve1_pd", "ve2_pd", "ve3_pd", "gpu_pd",
+		"se_pd", "mipi_pd", "hdmirx_pd";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296.dtsi
new file mode 100644
index 00000000..1d8666d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-1296.dtsi
@@ -0,0 +1,1147 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include "rtd-129x-common.dtsi"
+/include/ "rtd-1295-pinctrl.dtsi"
+/include/ "rtd-1295-irda.dtsi"
+/include/ "rtd-1296-usb.dtsi"
+/include/ "rtd-1296-sata.dtsi"
+/include/ "rtd-1295-hdmirxEDID.dtsi"
+/include/ "rtd-129x-dcsys-debug.dtsi"
+
+/{
+	compatible = "realtek,rtd1296";
+	interrupt-parent = <&gic>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A53_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x0>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x1>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x02>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		A53_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x03>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x9801AA44>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+		};
+
+		a53_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	soc@0 {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x98000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+
+
+	};
+
+
+
+	arch_timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <1 13 0xf08>,
+			<1 14 0xf08>,
+			<1 11 0xf08>,
+			<1 10 0xf08>;
+		clock-frequency = <27000000>;
+	};
+
+	gic: interrupt-controller@FF010000 {
+		compatible = "arm,cortex-a15-gic";
+		#interrupt-cells = <3>;
+		interrupt-controller;
+		reg = <0xFF011000 0x1000>,
+			<0xFF012000 0x1000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <0 48 4>;
+		interrupt-affinity = <&A53_0>,
+			<&A53_1>,
+			<&A53_2>,
+			<&A53_3>;
+	};
+
+	pinctrl: pinctrl@9801A000 {
+		compatible = "realtek,rtk129x-pinctrl";
+		reg = <0x9801A000 0x97c>,
+			<0x9804d000 0x010>,
+			<0x98012000 0x640>,
+			<0x98007000 0x340>;
+		#gpio-range-cells = <3>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>,
+			<&sdcard_pins_high>,
+			<&uart0_pins>,
+			<&uart1_pins>,
+			<&uart2_pins_0>,
+			<&i2c_pins_0>,
+			<&i2c_pins_1>,
+			<&i2c_pins_5>,
+			<&i2c_pins_6>,
+			<&pcie1_clk_pins>,
+			<&pcie2_clk_pins>,
+			<&rgmii0_pins>,
+			<&ir_rx_pins>,
+			<&ir_tx_pins>,
+			<&spdif_pins>,
+			<&pwm0_0_pins>,
+			<&etn_led_pins>;
+		status = "okay";
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x9801B000 0x100>, /* MISC_TOP MISC_ISO */
+			<0x98007000 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	rtk_misc_gpio: rtk_misc_gpio@9801b100 {
+		compatible = "realtek,rtk-misc-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>; /*must be the same with gpiochip.of_gpio_n_cells*/
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <101>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <0 19>, <0 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x9801b000 0x100>,
+			<0x9801b100 0x100>; /* MISC_SYS MISC_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 101>;
+		status = "okay";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <101>;
+		Realtek,gpio_numbers = <35>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x98007000 0x100>,
+			<0x98007100 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 101 35>;
+		status = "okay";
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x98000000 0x200000>;
+		status = "okay";
+	};
+
+	md@9800b000 {
+		compatible = "realtek,md";
+		reg = <0x9800b000 0x1000>;
+		interrupts = <0 38 4>; /* 70 - 32 = 38 */
+		clocks = <&clk_en_1 CLK_EN_MD>;
+		resets = <&rst1 RSTN_MD>;
+		status = "okay";
+	};
+
+	se@9800c000 {
+		compatible = "realtek,se";
+		reg = <0x9800c000 0x1000>;
+		interrupts = <0 20 4>; /* 52 - 32 = 20 */
+		clocks = <&clk_en_1 CLK_EN_SE>;
+		resets = <&rst1 RSTN_SE>;
+		power-domains = <&pd0 PD_SRAM_DISP_SE>;
+		status = "okay";
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x9801b000 0x1000>;
+		status = "okay";
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd129x-hdmitx";
+		reg = <0x9800d000 0x560>, /* HDMITX */
+			<0x98007200 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 6 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&rst1 RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		status = "okay";
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 31>;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtk129x-hdcptx";
+		reg = <0x9800d000 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		status = "okay";
+	};
+
+	hdmirx@98034000 {
+		compatible = "Realtek,rtk-mipi-top";
+		reg = <0x98037000 0xE0>,
+			<0x98034000 0xF54>,
+			<0x98035F00 0x2C>,
+			<0x98037700 0x98>,
+			<0x98004000 0xF0>,
+			<0x98004100 0x104>;
+		interrupts = <0 23 4>;
+		gpio-rx-hpd-ctrl = <&rtk_iso_gpio 22 1 0>;
+		power-saving = <0>; /* 1:ON,0:OFF; Turn off RX when cable unplugged */
+		clocks = <&clk_en_2 CLK_EN_HDMIRX>,
+			<&clk_en_1 CLK_EN_MIPI>,
+			<&clk_en_2 CLK_EN_CBUS_TX>,
+			<&iclk_en CLK_EN_CBUS_OSC>,
+			<&iclk_en CLK_EN_CBUS_SYS>,
+			<&iclk_en CLK_EN_CBUSTX_SYS>,
+			<&iclk_en CLK_EN_CBUSRX_SYS>,
+			<&clk_en_1 CLK_EN_TP>,
+			<&clk_en_1 CLK_EN_CP>;
+		clock-names = "hdmirx",
+			"mipi",
+			"cbus_tx",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys",
+			"tp",
+			"cp";
+		resets = <&rst4 RSTN_HDMIRX>,
+			<&rst4 RSTN_HDMIRX_WRAP>,
+			<&rst1 RSTN_MIPI>,
+			<&rst2 RSTN_CBUS_TX>,
+			<&irst IRSTN_CBUS>,
+			<&irst IRSTN_CBUSTX>,
+			<&irst IRSTN_CBUSRX>,
+			<&rst1 RSTN_TP>,
+			<&rst1 RSTN_CP>;
+		reset-names = "hdmirx",
+			"hdmirx_wrap",
+			"mipi",
+			"cbus_tx",
+			"cbus",
+			"cbustx",
+			"cbusrx",
+			"tp",
+			"cp";
+		power-domains = <&pd0 PD_SRAM_DISP_HDMIRX>;
+		status = "okay";
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007800 0x400>,
+			<0x98007000 0x100>;
+		interrupts-st-mask = <0x4>;
+		interrupts = <1 2>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&iclk_en CLK_EN_MISC_UR0>;
+		clock-frequency = <27000000>; /* This value must be override by the board. */
+		status = "okay";
+	};
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B200 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR1>;
+		resets = <&rst2 RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+		status = "okay";
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B400 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR2>;
+		resets = <&rst2 RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <0>;
+		status = "disabled"; /* Disable UR2 first since we don't use it now */
+	};
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x98016000 0x1000>,
+			<0x98007000 0x1000>;
+		interrupts = <0 22 4>;
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		output-mode = <0>; /* 0:embedded PHY, 1:RGMII to MAC, 2:RGMII to PHY */
+		rgmii-voltage = <1>; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+		rgmii-tx-delay = <0>; /* 0: 0ns, 1: 2ns */
+		rgmii-rx-delay = <0>; /* 0: 0ns, 1: 2ns */
+		ext-phy-id = <1>; /* 0 ~ 31, only valid when output-mode = 2 */
+		clocks = <&iclk_en CLK_EN_ETN_250M>,
+			<&iclk_en CLK_EN_ETN_SYS>;
+		clock-names = "etn_250m",
+			"etn_sys";
+		resets = <&irst IRSTN_GMAC>,
+			<&irst IRSTN_GPHY>;
+		reset-names = "gmac",
+			"gphy";
+		status = "okay";
+	};
+
+	hwnat: gmac@98060000 {
+		compatible = "Realtek,rtd1295-hwnat";
+		reg = <0x98060000 0x170000>, /* NAT */
+			<0x98000000 0x20000>, /* CLK SYS */
+			<0x9803FF00 0x100>; /* SATA Wrapper */
+		interrupts = <0 24 4>;
+		offload_enable = <0>; /* 0:disable, 1:enable HW NAT offload */
+		rgmii_voltage = <1>; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+		rgmii0_tx_delay = <0>; /* 0 to 7: 0.5ns per step */
+		rgmii0_rx_delay = <4>; /* 0 to 7: 0.5ns per step */
+		rgmii1_tx_delay = <0>; /* 0 to 7: 0.5ns per step */
+		rgmii1_rx_delay = <4>; /* 0 to 7: 0.5ns per step */
+		rgmii_enable = <1>; /* 0:disable, 1:enable */
+		mac0_enable = <1>; /* 0:disable, 1:enable */
+		mac0_mode = <0>; /* 0:RGMII to PHY, 1:SGMII to PHY, 2: RGMII to MAC, 3: SGMII to MAC */
+		mac5_conn_to = <0>; /* 0:PHY, 1:MAC */
+		mac0_phy_id = <2>; /* PHY ID 2 for RGMII, 3 for SGMII */
+		mac4_phy_id = <4>;
+		mac5_phy_id = <1>;
+		led_mode = <1>; /* 0~3: SCAN_0~3, 4~6: DIRECT 0~2 */
+		gpio_link_led_enable = <0>; /* 0:disable, 1:enable */
+		gpios = <&rtk_iso_gpio 27 1 0>; /* Link LED, output, default low */
+
+		clocks = <&cc CC_PLL_DDSA>,
+			<&clk_en_1 CLK_EN_SATA_0>,
+			<&clk_en_1 CLK_EN_SATA_ALIVE_0>,
+			<&clk_en_2 CLK_EN_SATA_1>,
+			<&clk_en_2 CLK_EN_SATA_ALIVE_1>,
+			<&cc CC_PLL_DDSB>,
+			<&clk_en_2 CLK_EN_NAT>,
+			<&iclk_en CLK_EN_ETN_250M>,
+			<&iclk_en CLK_EN_ETN_SYS>;
+		clock-names = "pll_ddsa",
+			"sata_0",
+			"sata_alive_0",
+			"sata_1",
+			"sata_alive_1",
+			"pll_ddsb",
+			"nat",
+			"etn_250m",
+			"etn_sys";
+		resets = <&rst1 RSTN_SATA_0>,
+			<&rst1 RSTN_SATA_PHY_0>,
+			<&rst1 RSTN_SATA_PHY_POW_0>,
+			<&rst1 SATA_FUNC_EXIST_0>,
+			<&rst2 RSTN_SDS_PHY>,
+			<&rst1 RSTN_NAT>,
+			<&irst IRSTN_GMAC>,
+			<&irst IRSTN_GPHY>;
+		reset-names = "sata_0",
+			"sata_phy_0",
+			"sata_phy_pow_0",
+			"sata_func_exist_0",
+			"rstn_sds_phy",
+			"nat",
+			"gmac",
+			"gphy";
+		power-domains = <&pd0 PD_SRAM_NAT>;
+		status = "disabled";
+	};
+
+	timer0@9801B000 {
+		compatible = "realtek,rtk-timer0";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 17 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	timer1@9801B000 {
+		compatible = "realtek,rtk-timer1";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 18 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	pcie@9804E000 {
+		compatible = "realtek,rtk-pcie-slot1";
+		reg = <0x9804E000 0x00001000
+			0x9804F000 0x00001000
+			0x9801C600 0x00000100
+			0x9801A000 0x00000300
+			0x98012000 0x00001000>;
+		interrupt-names = "rtk-pcie1-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic GIC_SPI 61 IRQ_TYPE_LEVEL_HIGH>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <0>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 29 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		ranges = <0x02000000 0x00000000 0xC0000000  0xC0000000 0x00000000 0x01000000
+			0x01000000 0x00000000 0x00030000  0x00030000 0x00000000 0x00010000>;
+		resets = <&rst2 RSTN_PCIE0>,
+			<&rst2 RSTN_PCIE0_CORE>,
+			<&rst2 RSTN_PCIE0_POWER>,
+			<&rst2 RSTN_PCIE0_NONSTITCH>,
+			<&rst2 RSTN_PCIE0_STITCH>,
+			<&rst2 RSTN_PCIE0_PHY>,
+			<&rst4 RSTN_PCIE0_PHY_MDIO>;
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_1 CLK_EN_PCIE0>;
+		status = "okay";
+		phys_a = <0x31810801>,
+			<0xB2001101>,
+			<0x00100001>;
+		phys_b = <0x00000003>,
+			<0x00900001>,
+			<0x40080401>,
+			<0x5AC10801>,
+			<0x32b40f01>,
+			<0x72001101>;
+	};
+
+	pcie2@9803B000 {
+		compatible = "realtek,rtk-pcie-slot2";
+		reg = <0x9803B000 0x00001000
+			0x9803C000 0x00001000
+			0x9801C600 0x00000100
+			0x9801A000 0x00000300
+			0x98012000 0x00001000>;
+		interrupt-names = "rtk-pcie2-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic GIC_SPI 62 IRQ_TYPE_LEVEL_HIGH>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <1>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 30 1 0>;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		ranges = <0x02000000 0x00000000 0xC1000000  0xC1000000 0x00000000 0x01000000
+			0x01000000 0x00000000 0x00040000  0x00040000 0x00000000 0x00010000>;
+		speed-mode = <0>; // 0:GEN1, 1:GEN2
+		resets = <&rst2 RSTN_PCIE1>,
+			<&rst2 RSTN_PCIE1_CORE>,
+			<&rst2 RSTN_PCIE1_POWER>,
+			<&rst2 RSTN_PCIE1_NONSTITCH>,
+			<&rst2 RSTN_PCIE1_STITCH>,
+			<&rst2 RSTN_PCIE1_PHY>,
+			<&rst4 RSTN_PCIE1_PHY_MDIO>;
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_2 CLK_EN_PCIE1>;
+		status = "okay";
+		phys = <0x00000003>, /* #Write soft reset */
+			<0x27E90301>,
+			<0x52F50401>, /* #F code,close SSC */
+			<0xead70501>, /* #modify N code */
+			<0x000c0601>, /* #modify CMU ICP(TX jitter) */
+			<0xa6530a01>, /* #modify CMU RS(tx jitter) */
+			<0xC4662001>, /* #modify AMP */
+			<0x8EA01B01>,
+			<0x8EA05B01>,
+			<0xa84a0101>, /* #modify Rx parameter */
+			<0xb8032b01>, /* #clk driving */
+			<0x27e94301>, /* #EQ */
+			<0x52f54401>, /* #F code,close SSC */
+			<0xead74501>, /* #modify N code */
+			<0x000c4601>, /* #modify CMU ICP(TX jitter) */
+			<0xa6534a01>, /* #modify CMU RS(tx jitter) */
+			<0xd4776001>, /* #modify AMP */
+			<0xa84a4101>, /* #modify Rx parameter */
+			<0xa8036b01>, /* #clk driving */
+			<0x01225a01>,
+			<0x521C0901>, /* #for calibration bit[9]=1" */
+			<0x501C0901>, /* #for calibration bit[9]=0" */
+			<0x521C0901>, /* #for calibration bit[9]=1" */
+			<0x08282401>,
+			<0x08286401>;
+	};
+
+	sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 23 1 1>;
+		reg = <0x98010c00 0x200>,
+			<0x98000000 0x200000>;
+		interrupts = <0 45 4>;
+		clocks = <&clk_en_1 CLK_EN_SDIO>,
+			<&clk_en_1 CLK_EN_SDIO_IP>;
+		clock-names = "sdio",
+			"sdio_ip";
+		resets = <&rst2 RSTN_SDIO>;
+		status = "okay";
+	};
+
+	sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_misc_gpio 99 1 0>; /*sd power , output, default high  (poweroff) */
+		reg = <0x98000000 0x400>, /* CRT */
+			<0x98010400 0x200>, /* SDMMC */
+			<0x9801A000 0x400>, /* BS2 */
+			<0x98012000 0xa00>, /* EMMC */
+			<0x98010A00 0x40>; /* SDIO */
+		interrupts = <0 44 4>;
+		resets = <&rst2 RSTN_CR>;
+		clocks = <&clk_en_1 CLK_EN_CR>,
+			<&clk_en_1 CLK_EN_SD_IP>;
+		clock-names = "cr",
+			"sd_ip";
+		status = "okay";
+	};
+
+	emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		reg = <0x98012000 0xa00>, /*EMMC*/
+			<0x98000000 0x600>, /*CRT */
+			<0x9801A000 0x80>, /*SB2*/
+			<0x9801B000 0x150>; /*MISC*/
+		interrupts = <0 42 4>;
+		speed-step = <2>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_1 CLK_EN_EMMC>,
+			<&clk_en_1 CLK_EN_EMMC_IP>,
+			<&clk_en_1 CLK_EN_CR>;
+		clock-names = "emmc",
+			"emmc_ip",
+			"cr";
+		resets = <&rst2 RSTN_EMMC>;
+		reset-names = "emmc";
+		status = "okay";
+		pddrive_nf_s0 = <1 0x77 0x77 0x77 0x33>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+		pddrive_nf_s2 = <1 0xbb 0xbb 0xbb 0x33>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+		phase_tuning = <0 0>; /* arg0: tx tuning switch, arg1: rx tuning switch*/
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk1295-pu_pll";
+		reg = <0x98000000 0x200>;
+	};
+
+	jpeg@9803e000 {
+		compatible = "Realtek,rtk1295-jpeg";
+		reg = <0x9803e000 0x1000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_2 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&rst2 RSTN_JPEG>;
+		status = "okay";
+	};
+
+	ve1@98040000 {
+		compatible = "Realtek,rtk1295-ve1";
+		reg = <0x98040000 0x8000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 53 4>, <0 54 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			<&cc CC_CLK_VE2>;
+		clock-names = "clk_ve1",
+			"clk_ve2";
+		resets = <&rst1 RSTN_VE1>,
+			<&rst1 RSTN_VE2>;
+		reset-names = "ve1",
+			"ve2";
+		status = "okay";
+	};
+
+	ve3@98048000 {
+		compatible = "Realtek,rtk1295-ve3";
+		reg = <0x98048000 0x4000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 55 4>;
+		clocks = <&cc CC_CLK_VE3>;
+		resets = <&rst1 RSTN_VE3>;
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x9801d000 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	sb2_lock_avlog: sb2-lock@9801A63C {
+		reg = <0x9801A63C 0x4>;
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-avlog";
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x9801a000 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	rpc@9801a104 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x9801a104 0xc>, /* rpc intr en */
+			<0x01ffe000 0x4000>, /* rpc ring buffer */
+			<0x0001f000 0x1000>, /* rpc common */
+			<0x9801a020 0x4>; /* rbus sync */
+		interrupts = <0 33 4>;
+		status = "okay";
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007000 0x400>,
+			<0x98007400 0x100>;
+		interrupts = <1 5>;
+		resets = <&irst IRSTN_IR>;
+		clocks = <&iclk_en CLK_EN_MISC_IR>;
+		status = "okay";
+	};
+
+	rtc@9801B600 {
+		compatible = "realtek,rtk-rtc";
+		reg = <0x9801B600 0x100>,
+			<0x98007000 0x100>;
+		rtc-base-year = <2014>;
+		clocks = <&clk_en_2 CLK_EN_MISC_RTC>;
+		status = "okay";
+	};
+
+	watchdog@0x98007680 {
+		compatible = "realtek,rtk-watchdog";
+		reg = <0x98007680 0x100>;
+		rst-oe = <0>; /* 0:input, 1:output */
+		timeout-sec = <20>;
+		status = "okay";
+	};
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x98007600 0x100>;
+		rst-reg-offset = <0x40>;
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x98007D00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 8>;
+		i2c-num = <0>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x98007C00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 11>;
+		i2c-num = <1>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C1>;
+	};
+
+	i2c_2: i2c@0x9801B700 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801B700 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 26>;
+		i2c-num = <2>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_2>;
+	};
+
+	i2c_3: i2c@0x9801B900 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801B900 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 23>;
+		i2c-num = <3>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_3>;
+	};
+
+	i2c_4: i2c@0x9801BA00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801BA00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 15>;
+		i2c-num = <4>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_4>;		
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "realtek,rtk-i2c";
+		reg = <0x9801BB00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 14>;
+		i2c-num = <5>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+
+		rts5400@6A {
+			compatible = "rtk-rts5400";
+			reg = <0x6A>;
+			realtek,12v-power-gpio = <&rtk_misc_gpio 16 1 0>; /*1296 u3host power, output, default low */
+		};
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk129x-spi";
+		reg = <0x9801BD00 50>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins>;
+		spi-cs-gpio = <&rtk_misc_gpio 6 1 1>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		resets = <&rst1 RSTN_GSPI>;
+		status = "okay";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x980070D0 0xC>;
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+	};
+
+	rtk-lsadc@0x98012800 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 21>, <0 22>; /* LSADC0_INT, LSADC1_INT */
+		reg = <0x9801B00C 0x4>, /* MISC_ISR */
+			<0x98012800 0x200>, /* LSADC */
+			<0x9800034C 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>, /* LSADC0 0:disable; 1:enable */
+						<1>; /* LSADC1 0:disable; 1:enable */
+		vdd_mux_sel = <0>; /* 0:VDD1; 1:VDD2 */
+		vdd_mux1 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux2 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux_en = <1>; /* 0:disable; 1:enable */
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <1>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc1-pad0 {
+			//compatible = "Realtek,rtk-lsadc1-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <0>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+
+		rtk-lsadc1-pad1 {
+			//compatible = "Realtek,rtk-lsadc1-pad1";
+			activate = <1>; /* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0: Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <1>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+	};
+
+	cec0@98037800 {
+		compatible = "Realtek,rtk-cec0";
+		reg = <0x98037800 0xe0>,
+			<0x98007000 0x100>,
+			<0x98037500 0x100>;
+		interrupts = <0 26 4>;
+		module-enable = <1>;
+		clocks = <&cc CC_CLK_SYS>,
+			<&iclk_en CLK_EN_CBUS_OSC>,
+			<&iclk_en CLK_EN_CBUS_SYS>,
+			<&iclk_en CLK_EN_CBUSTX_SYS>,
+			<&iclk_en CLK_EN_CBUSRX_SYS>;
+		clock-names = "sys",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys";
+		resets = <&irst IRSTN_CBUS>,
+			<&irst IRSTN_CBUSTX>,
+			<&irst IRSTN_CBUSRX>;
+		reset-names = "cbus",
+			"cbustx",
+			"cbusrx";
+		status = "okay";
+	};
+
+	rfkill: rfkilligpio {
+		compatible = "realtek,rfkill";
+		gpios = <&rtk_iso_gpio 24 1 0>; /*bt power , output, default low */
+		status = "disabled";
+	};
+
+	rtk-gpio-regulator {
+		compatible = "rtkgpio-regulator";
+		gpios = <&rtk_iso_gpio 16 1 0>, <&rtk_iso_gpio 17 1 1>;
+		//status = "disabled";
+		status = "okay";
+		vdd: rtkgpio_regulator {
+			regulator-min-microvolt = <850000>;
+			regulator-max-microvolt = <1050000>;
+		};
+	};
+
+	power-management@0 {
+		compatible = "Realtek,power-management";
+		system-power-controller;
+		reg = <0x98000000 0x1800>, /* CRT */
+			<0x98006000 0x1000>, /* AIO */
+			<0x98007000 0x1000>, /* ISO */
+			<0x98018000 0x2000>, /* TVE */
+			<0x9801A000 0x1000>, /* SB2 */
+			<0x9801B000 0x1000>; /* MISC */
+		suspend-mode = <0>; // 0:SUSPEND_TO_RAM, 1:SUSPEND_TO_COOLBOOT, 2:SUSPEND_TO_WFI
+		pwms = <&pwm 0 37878>;
+		status = "okay";
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x9803D000 0x1000>, <0x98000000 0x1000>, <0x98009400 0x600>, <0x98005000 0x1000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>,
+			<&clk_en_1 CLK_EN_LVDS>;
+		clock-names = "clk_en_tve",
+			"clk_en_vo",
+			"clk_en_lvds";
+		resets = <&rst4 RSTN_DISP>,
+			<&rst1 RSTN_TVE>,
+			<&rst1 RSTN_VO>,
+			<&rst1 RSTN_LVDS>;
+		reset-names = "dp",
+			"tve",
+			"vo",
+			"lvds";
+		status = "okay";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 7 0 0>; /*HPD, input, default N/A */
+			interrupt-parent = <&rtk_iso_gpio>;
+			interrupts = <7>; /*HPD*/
+		};
+	};
+
+	mcp@0 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x98015000 0x1000>,
+			<0x98014000 0x1000>;
+		status = "okay";
+	};
+
+	rtk_boot {
+		compatible = "Realtek,rtk_boot";
+		resume-entry-addr = <0x00021000>;
+		status = "okay";
+	};
+
+	cpu_tm: thermal-sensor@9801D150 {
+		compatible = "realtek,rtd129x-thermal-sensor";
+		reg = <0x9801D150 0x1C>;
+		#thermal-sensor-cells = <0>;
+
+		userspace-trip = <&cpu_userspace 30000>;
+		status = "okay";
+	};
+
+	cr_tm: thermal-sensor@980124B4 {
+		compatible = "realtek,rtd129x-thermal-sensor";
+		reg = <0x980124B4 0x1C>;
+		#thermal-sensor-cells = <0>;
+		status = "okay";
+	};
+
+	gpu: gpu@98050000 {
+		compatible = "arm,mali-midgard";
+		reg = <0x98050000 0xffff>;
+		interrupts = <0 67 4>, <0 68 4>, <0 66 4>;
+		interrupt-names = "JOB", "MMU", "GPU";
+		clocks = <&cc CC_CLK_GPU>;
+		clock-names = "clk_mali";
+		resets = <&rst1 RSTN_GPU>;
+		mali-supply = <&gpu_supp>;
+		#cooling-cells = <2>;
+		status = "okay";
+		power-model {
+			compatible = "arm,mali-simple-power-model";
+			static-coefficient = <2427750>;
+			dynamic-coefficient = <4687>;
+			ts = <20000 2000 (-20) 2>;
+			thermal-zone = "cpu-thermal";
+		};
+	};
+
+	audio-in-device {
+		compatible = "realtek,audio-in";
+		status = "disabled";
+	};
+
+	audio-out-devices {
+		compatible = "realtek,audio-out";
+		status = "okay";
+		dac {
+			compatible = "dac";
+			status = "okay";
+		};
+		spdif {
+			compatible = "spdif";
+			status = "okay";
+		};
+		i2s {
+			compatible = "i2s";
+			status = "okay";
+		};
+		hdmi {
+			compatible = "hdmi";
+			status = "okay";
+		};
+		global {
+			compatible = "global";
+			status = "okay";
+		};
+	};
+
+	busfreq {
+		compatible = "realtek,rtd129x-busfreq";
+		enable = <1>;
+		polling-ms = <1000>;
+		clocks = <&cc CC_PLL_BUS_H>;
+		status = "okay";
+
+		clk-0 {
+			clocks = <&cc CC_CLK_SYS>;
+			rate = <128 256>;
+		};
+		clk-1 {
+			clocks = <&cc CC_PLL_BUS_H>;
+			rate = <200 459>;
+		};
+	};
+
+	dvfs: dvfs {
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+
+			trips {
+				cpu_alert0: cpu-alert0 {
+					temperature = <105000>;
+					hysteresis = <3000>;
+					type = "passive";
+				};
+				cpu_alert1: cpu-alert1 {
+					temperature = <115000>;
+					hysteresis = <3000>;
+					type = "passive";
+				};
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <2000>;
+					type = "critical";
+				};
+				gpu_alert0: gpu-alert0 {
+					temperature = <95000>;
+					hysteresis = <4000>;
+					type = "passive";
+				};
+				gpu_alert1: gpu-alert1 {
+					temperature = <100000>;
+					hysteresis = <4000>;
+					type = "passive";
+				};
+				cpu_userspace: cpu-userspace {
+					temperature = <150000>;
+					hysteresis = <0>;
+					type = "passive";
+				};
+			};
+
+			cooling-maps {
+				map0 {
+					trip = <&cpu_alert0>;
+					cooling-device = <&A53_0 1 6>;
+				};
+				map1 {
+					trip = <&cpu_alert1>;
+					cooling-device = <&A53_0 7 11>;
+				};
+				map2 {
+					trip = <&gpu_alert0>;
+					cooling-device = <&gpu 2 2>;
+				};
+				map3 {
+					trip = <&gpu_alert1>;
+					cooling-device = <&gpu 5 5>;
+				};
+				map4 {
+					trip = <&cpu_userspace>;
+					cooling-device = <&A53_0 9 9>;
+				};
+			};
+		};
+
+		cr-thermal {
+			polling-delay-passive = <0>;
+			polling-delay = <0>;
+			thermal-sensors = <&cr_tm>;
+		};
+	};
+};
+
+#include "rtd-129x-g2227-regulator.dtsi"
+#include "rtd-129x-gpu-dvfs.dtsi"
+#include "rtd-129x-cpu-dvfs.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-common.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-common.dtsi
new file mode 100644
index 00000000..56d77b8
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-common.dtsi
@@ -0,0 +1,364 @@
+#include <dt-bindings/clock/rtk,clock-rtd129x.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <dt-bindings/reset/rtk,reset-rtd129x.h>
+#include <dt-bindings/power/rtk,power-rtd129x.h>
+#include <dt-bindings/thermal/thermal.h>
+
+/{
+	efuse@98017000 {
+		compatible = "realtek,efuse";
+		reg = <0x98017000 0x400>;
+		read-only;
+		status = "okay";
+
+		#address-cells = <1>;
+		#size-cells = <1>;
+		nvmem-cells =
+			<&efuse_uuid>,
+			<&efuse_etn_phy>,
+			<&efuse_etn_phy_rc>,
+			<&efuse_etn_phy_r>,
+			<&efuse_etn_phy_amp>,
+			<&efuse_etn_phy_adc>,
+			<&efuse_pwr_id>,
+			<&efuse_package_id>,
+			<&efuse_usb_cc_en>,
+			<&efuse_usb_cc1_4_7_k_cal>,
+			<&efuse_usb_cc1_12_k_cal>,
+			<&efuse_usb_cc2_4_7_k_cal>,
+			<&efuse_usb_cc2_12_k_cal>,
+			<&efuse_top_iddq>,
+			<&efuse_cpu_iddq>,
+			<&efuse_usb_dp_dm>,
+			<&efuse_cc_cal>,
+			<&efuse_chip_id>,
+			<&efuse_prog_rvd>;
+		nvmem-cell-names =
+			"uuid",
+			"etn_phy",
+			"etn_phy_rc",
+			"etn_phy_r",
+			"etn_phy_amp",
+			"etn_phy_adc",
+			"pwr_id",
+			"package_id",
+			"usb_cc_en",
+			"usb_cc1_4_7_k_cal",
+			"usb_cc1_12_k_cal",
+			"usb_cc2_4_7_k_cal",
+			"usb_cc2_12_k_cal",
+			"top_iddq",
+			"cpu_iddq",
+			"usb_dp_dm",
+			"cc_cal",
+			"chip_id",
+			"prog_rvd";
+		efuse_uuid: uuid@1A4 {
+			reg = <0x1A4 0xC>;
+			bits = <0 96>;
+		};
+		efuse_etn_phy: etn_phy@1B9 {
+			reg = <0x1B9 0x9>;
+			bits = <2 64>;
+		};
+		efuse_etn_phy_rc: etn_phy_rc@1BF {
+			reg = <0x1BF 0x2>;
+			bits = <5 4>;
+		};
+		efuse_etn_phy_r: etn_phy_r@1BF {
+			reg = <0x1BF 0x1>;
+			bits = <1 4>;
+		};
+		efuse_etn_phy_amp: etn_phy_amp@1B9 {
+			reg = <0x1B9 0x3>;
+			bits = <2 16>;
+		};
+		efuse_etn_phy_adc: etn_phy_adc@1BB {
+			reg = <0x1BB 0x3>;
+			bits = <2 16>;
+		};
+		efuse_pwr_id: pwr_id@1CC {
+			reg = <0x1CC 0x1>;
+			bits = <6 2>;
+		};
+		efuse_package_id: package_id@1D8 {
+			reg = <0x1D8 0x1>;
+			bits = <0 2>;
+		};
+		efuse_usb_cc_en: usb_cc_en@1D8 {
+			reg = <0x1D8 0x1>;
+			bits = <2 1>;
+		};
+		efuse_usb_cc1_4_7_k_cal: usb_cc1_4_7_k_cal@1D8 {
+			reg = <0x1D8 0x1>;
+			bits = <3 4>;
+		};
+		efuse_usb_cc1_12_k_cal: usb_cc1_12_k_cal@1D8 {
+			reg = <0x1D8 0x2>;
+			bits = <7 4>;
+		};
+		efuse_usb_cc2_4_7_k_cal: usb_cc2_4_7_k_cal@1D9 {
+			reg = <0x1D9 0x1>;
+			bits = <3 4>;
+		};
+		efuse_usb_cc2_12_k_cal: usb_cc2_12_k_cal@1D9 {
+			reg = <0x1D9 0x2>;
+			bits = <7 4>;
+		};
+		efuse_top_iddq: top_iddq@1DA {
+			reg = <0x1DA 0x2>;
+			bits = <3 6>;
+		};
+		efuse_cpu_iddq: cpu_iddq@1DB {
+			reg = <0x1DB 0x1>;
+			bits = <1 6>;
+		};
+		efuse_usb_dp_dm: usb_dp_dm@1DC {
+			reg = <0x1DC 0x1>;
+			bits = <0 4>;
+		};
+		efuse_cc_cal: cc_cal@1DC {
+			reg = <0x1DC 0x4>;
+			bits = <4 24>;
+		};
+		efuse_chip_id: chip_id@200 {
+			reg = <0x200 0x10>;
+			bits = <0 128>;
+		};
+		efuse_prog_rvd: prog_rvd@3FC {
+			reg = <0x3FC 0x4>;
+			bits = <0 32>;
+		};
+	};
+
+	sb2_lock0: sb2-lock@9801A000 {
+		compatible = "realtek,sb2-sem";
+		reg = <0x9801A000 0x4>;
+	};
+
+	/* fixed clock */
+	osc27M: osc27M {
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <27000000>;
+		clock-output-names = "osc27M";
+	};
+
+	/* mmio */
+	crt_mmio: mmio@98000000 {
+		compatible = "realtek,mmio";
+		reg = <0x98000000 0x600>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	iso_mmio: mmio@98007088 {
+		compatible = "realtek,mmio";
+		reg = <0x98007088 0x8>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	/* clock-controller */
+	clk_en_1: clk-en@9800000c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x9800000c 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0xc>;
+		clock-output-names =
+			"clk_en_misc",
+			"clk_en_pcie0",
+			"clk_en_sata_0",
+			"clk_en_gspi",
+			"clk_en_usb",
+			"",
+			"clk_en_iso_misc",
+			"clk_en_sata_alive_0",
+			"clk_en_hdmi",
+			"clk_en_etn",
+			"",
+			"",
+			"",
+			"",
+			"",
+			"",
+			"clk_en_lvds",
+			"clk_en_se",
+			"",
+			"clk_en_cp",
+			"clk_en_md",
+			"clk_en_tp",
+			"",
+			"clk_en_nf",
+			"clk_en_emmc",
+			"clk_en_cr",
+			"clk_en_sdio_ip",
+			"clk_en_mipi",
+			"clk_en_emmc_ip",
+			"",
+			"clk_en_sdio",
+			"clk_en_sd_ip";
+		ignore-unused-clocks =
+			"clk_en_misc",
+			"clk_en_iso_misc",
+			"clk_en_cp",
+			"clk_en_md",
+			"clk_en_tp",
+			"clk_en_hdmi";
+		ignore-pm-clocks =
+			"clk_en_hdmi";
+	};
+
+	clk_en_2: clk-en@98000010 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x98000010 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x10>;
+		clock-output-names =
+			"clk_en_nat",
+			"clk_en_misc_i2c_5",
+			"",
+			"clk_en_jpeg",
+			"",
+			"clk_en_pcie1",
+			"clk_en_misc_sc",
+			"clk_en_cbus_tx",
+			"",
+			"",
+			"clk_en_misc_rtc",
+			"",
+			"",
+			"clk_en_misc_i2c_4",
+			"clk_en_misc_i2c_3",
+			"clk_en_misc_i2c_2",
+			"clk_en_misc_i2c_1",
+			"",
+			"",
+			"",
+			"",
+			"",
+			"",
+			"",
+			"clk_en_hdmirx",
+			"clk_en_sata_1",
+			"clk_en_sata_alive_1",
+			"clk_en_ur2",
+			"clk_en_ur1",
+			"clk_en_fan",
+			"clk_en_dcphy_0",
+			"clk_en_dcphy_1";
+		ignore-unused-clocks =
+			"clk_en_dcphy_0",
+			"clk_en_dcphy_1";
+	};
+
+	clk_en_3: clk-en@98000450 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x98000450 0x4>;
+		#clock-cells = <1>;
+		clock-output-names =
+			"",
+			"",
+			"clk_en_lsadc";
+	};
+
+	iclk_en: clk-en@9800708c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x9800708c 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&iso_mmio 0x4>;
+		clock-output-names =
+			"",
+			"",
+			"clk_en_misc_cec0",
+			"clk_en_cbusrx_sys",
+			"clk_en_cbustx_sys",
+			"clk_en_cbus_sys",
+			"clk_en_cbus_osc",
+			"clk_en_misc_ir",
+			"clk_en_misc_ur0",
+			"clk_en_i2c0",
+			"clk_en_i2c1",
+			"clk_en_etn_250m",
+			"clk_en_etn_sys";
+		ignore-unused-clocks =
+			"clk_en_etn_250m",
+			"clk_en_etn_sys";
+	};
+
+	cc: clock-controller@98000000 {
+		compatible   = "realtek,clock-controller";
+		reg = <0x98000000 0x600>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	/* reset-controller */
+	rst1: soft-reset@98000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000000 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+		pm-ignore-bits = <0x00001000>;
+	};
+
+	srst1: shadow-soft-reset@98000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000000 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+		pm-ignore-bits = <0x00001000>;
+	};
+
+	rst2: soft-reset@98000004 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000004 0x4>;
+		realtek,mmio = <&crt_mmio 0x4>;
+		#reset-cells = <1>;
+	};
+
+	rst3: soft-reset@98000008 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000008 0x4>;
+		realtek,mmio = <&crt_mmio 0x8>;
+		#reset-cells = <1>;
+	};
+
+	rst4: soft-reset@98000050 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000050 0x4>;
+		realtek,mmio = <&crt_mmio 0x50>;
+		#reset-cells = <1>;
+	};
+
+	irst: soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98007088 0x4>;
+		realtek,mmio = <&iso_mmio 0x0>;
+		#reset-cells = <1>;
+	};
+
+	asr1: async-soft-reset@98000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000000 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+		async-group = <0>;
+	};
+
+	asr2: async-soft-reset@98000004 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000004 0x4>;
+		realtek,mmio = <&crt_mmio 0x4>;
+		#reset-cells = <1>;
+		async-group = <0>;
+	};
+
+	pd0: power-controller@98000000 {
+		reg = <0x98000000 0x1000>;
+		compatible = "realtek,rtd129x-crt-power", "simple-bus";
+		resets = <&srst1 RSTN_VE1>, <&srst1 RSTN_VE2>, <&srst1 RSTN_VE3>,
+			<&srst1 RSTN_NAT>;
+		reset-names = "ve1", "ve2", "ve3", "nat";
+		#power-domain-cells = <1>;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-cpu-dvfs.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-cpu-dvfs.dtsi
new file mode 100644
index 00000000..39d916b
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-cpu-dvfs.dtsi
@@ -0,0 +1,80 @@
+&dvfs {
+	cpu_opps: opp-table-0 {
+		compatible = "operating-points-v2";
+		opp-shared;
+
+		opp-300mhz {
+			opp-hz = /bits/ 64 <300000000>;
+			opp-microvolt = <800000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp-400mhz {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-microvolt = <800000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		opp-500mhz {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-microvolt = <800000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp-600mhz {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-microvolt = <825000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp-700mhz {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-microvolt = <850000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp-800mhz {
+			opp-hz = /bits/ 64 <800000000>;
+			opp-microvolt = <875000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp-900mhz {
+			opp-hz = /bits/ 64 <900000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp-1000mhz {
+			opp-hz = /bits/ 64 <1000000000>;
+			opp-microvolt = <925000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp-1100mhz {
+			opp-hz = /bits/ 64 <1100000000>;
+			opp-microvolt = <962500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp-1200mhz {
+			opp-hz = /bits/ 64 <1200000000>;
+			opp-microvolt = <1012500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp-1300mhz {
+			opp-hz = /bits/ 64 <1300000000>;
+			opp-microvolt = <1062500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp-1400mhz {
+			opp-hz = /bits/ 64 <1400000000>;
+			opp-microvolt = <1100000>;
+			clock-latency-ns = <150000>;
+			opp-suspend;
+			status = "okay";
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-dcsys-debug.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-dcsys-debug.dtsi
new file mode 100644
index 00000000..c67464e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-dcsys-debug.dtsi
@@ -0,0 +1,141 @@
+/*
+[Module ID table]
+VO1: 0x0
+AIO: 0x0a
+CP: 0x11
+NAT: 0x12
+MD: 0x13
+NAT2: 0x14
+JPEG: 0x15
+TP: 0x17
+GPU: 0x19
+SCPU_NWC: 0x20
+SCPU_SWC: 0x21
+ACPU: 0x23
+HIF: 0x24
+AEE: 0x28
+ADE: 0x29
+USB: 0x2a
+ETN: 0x2e
+CR: 0x80
+NF: 0x83
+PCIE0: 0x84
+PCIE1: 0x86
+VE1: 0x30
+VE2: 0x31
+VE3: 0x32
+SE: 0x38
+MIPI: 0x40
+SATA: 0x48
+
+[access type]
+invalid: 0x0
+read: 0x1
+write: 0x2
+read or write: 0x3
+
+[memory trash detection mode]
+mode1: 0x1 (Given a region, trap if module_ID and access_type match)
+mode2: 0x2 (Given a region, trap if module_ID not match and access_type match)
+mode3: 0x3 (Given a module_ID and access_type, trap if request falls out of range)
+
+[Over DRAM access detection]
+Disable: 0x0
+Enable: 0x1
+
+[interrupt to CPU]
+SCPU: 0x0
+ACPU: 0x1
+VCPU: 0x2
+*/
+
+/{
+	dc_sys_debug@98008000 {
+		compatible = "realtek,rtk-dcsys-debug";
+		reg = <0x98008000 0x1000>;
+		interrupts = <0 35 4>;
+		err_cmd_detect = <0x1>, /* Enable over DRAM access detection */
+			<0x0>; /* interrupt to CPU */
+		mt_0 = <0x0>,  /* NUM0 Enable memory trash detection */
+			<0x0>, /* NUM0 start address*/
+			<0x0>, /* NUM0 end address*/
+			<0x0>, /* NUM0 module ID0*/
+			<0xa>, /* NUM0 module ID1*/
+			<0x0>, /* NUM0 module ID2*/
+			<0x0>, /* NUM0 module ID3*/
+			<0x0>, /* NUM0 interrupt to CPU*/
+			<0x3>, /* NUM0 access type*/
+			<0x1>; /* NUM0 mode*/
+		mt_1 = <0x0>, /* NUM1 Enable memory trash detection */
+			<0x0>, /* NUM1 start address*/
+			<0x0>, /* NUM1 end address*/
+			<0x0>, /* NUM1 module ID0*/
+			<0x0>, /* NUM1 module ID1*/
+			<0x0>, /* NUM1 module ID2*/
+			<0x0>, /* NUM1 module ID3*/
+			<0x0>, /* NUM1 interrupt to CPU*/
+			<0x0>, /* NUM1 access type*/
+			<0x0>; /* NUM1 mode*/
+		mt_2 = <0x0>, /* NUM2 Enable memory trash detection */
+			<0x0>, /* NUM2 start address*/
+			<0x0>, /* NUM2 end address*/
+			<0x0>, /* NUM2 module ID0*/
+			<0x0>, /* NUM2 module ID1*/
+			<0x0>, /* NUM2 module ID2*/
+			<0x0>, /* NUM2 module ID3*/
+			<0x0>, /* NUM2 interrupt to CPU*/
+			<0x0>, /* NUM2 access type*/
+			<0x0>; /* NUM2 mode*/
+		mt_3 = <0x0>,  /* NUM3 Enable memory trash detection */
+			<0x0>, /* NUM3 start address*/
+			<0x0>, /* NUM3 end address*/
+			<0x0>, /* NUM3 module ID0*/
+			<0x0>, /* NUM3 module ID1*/
+			<0x0>, /* NUM3 module ID2*/
+			<0x0>, /* NUM3 module ID3*/
+			<0x0>, /* NUM3 interrupt to CPU*/
+			<0x0>, /* NUM3 access type*/
+			<0x0>; /* NUM3 mode*/
+		mt_4 = <0x0>,  /* NUM4 Enable memory trash detection */
+			<0x0>, /* NUM4 start address*/
+			<0x0>, /* NUM4 end address*/
+			<0x0>, /* NUM4 module ID0*/
+			<0x0>, /* NUM4 module ID1*/
+			<0x0>, /* NUM4 module ID2*/
+			<0x0>, /* NUM4 module ID3*/
+			<0x0>, /* NUM4 interrupt to CPU*/
+			<0x0>, /* NUM4 access type*/
+			<0x0>; /* NUM4 mode*/
+		mt_5 = <0x0>,  /* NUM5 Enable memory trash detection */
+			<0x0>, /* NUM5 start address*/
+			<0x0>, /* NUM5 end address*/
+			<0x0>, /* NUM5 module ID0*/
+			<0x0>, /* NUM5 module ID1*/
+			<0x0>, /* NUM5 module ID2*/
+			<0x0>, /* NUM5 module ID3*/
+			<0x0>, /* NUM5 interrupt to CPU*/
+			<0x0>, /* NUM5 access type*/
+			<0x0>; /* NUM5 mode*/
+		mt_6 = <0x0>,  /* NUM6 Enable memory trash detection */
+			<0x0>, /* NUM6 start address*/
+			<0x0>, /* NUM6 end address*/
+			<0x0>, /* NUM6 module ID0*/
+			<0x0>, /* NUM6 module ID1*/
+			<0x0>, /* NUM6 module ID2*/
+			<0x0>, /* NUM6 module ID3*/
+			<0x0>, /* NUM6 interrupt to CPU*/
+			<0x0>, /* NUM6 access type*/
+			<0x0>; /* NUM6 mode*/
+		mt_7 = <0x0>,  /* NUM7 Enable memory trash detection */
+			<0x0>, /* NUM7 start address*/
+			<0x0>, /* NUM7 end address*/
+			<0x0>, /* NUM7 module ID0*/
+			<0x0>, /* NUM7 module ID1*/
+			<0x0>, /* NUM7 module ID2*/
+			<0x0>, /* NUM7 module ID3*/
+			<0x0>, /* NUM7 interrupt to CPU*/
+			<0x0>, /* NUM7 access type*/
+			<0x0>; /* NUM7 mode*/
+		status = "okay";
+	};
+};
\ No newline at end of file
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-g2227-regulator.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-g2227-regulator.dtsi
new file mode 100644
index 00000000..3a51611
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-g2227-regulator.dtsi
@@ -0,0 +1,119 @@
+#include <dt-bindings/regulator/gmt,g22xx.h>
+
+&i2c_0 {
+	g2227: g2227@12 {
+		compatible = "gmt,g2227";
+		reg = <0x12>;
+		status = "okay";
+		powerkey {
+			compatible = "gmt,g22xx-powerkey";
+			status = "disabled";
+		};
+		poweroff {
+			compatible = "gmt,g22xx-poweroff";
+			system-power-controller;
+			status = "disabled";
+		};
+		regulators {
+			compatible = "gmt,g2227-regulator";
+			status = "okay";
+		};
+	};
+};
+&g2227 {
+	regulators {
+		vd33_supp: dc1 {
+			regulator-name = "vd33";
+			regulator-min-microvolt = <3000000>;
+			regulator-max-microvolt = <3300000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_FORCE_PWM>;
+		};
+
+		cpu_supp: dc2 {
+			regulator-name = "cpudvs";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		gpu_supp: dc3 {
+			regulator-name = "gpudvs";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-ramp-delay = <625>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		ddr_supp: dc4 {
+			regulator-name = "ddr";
+			regulator-min-microvolt = <1500000>;
+			regulator-max-microvolt = <1500000>;
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-coldboot {
+				regulator-off-in-suspend;
+			};
+
+		};
+		iso_supp: dc5 {
+			regulator-name = "iso";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+		};
+		top_supp: dc6 {
+			regulator-name = "top";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		vd18_supp: ldo2 {
+			regulator-name = "ldo2";
+			regulator-min-microvolt = <1500000>;
+			regulator-max-microvolt = <1900000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_LDO_MODE_NORMAL>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		l2_supp: ldo3 {
+			regulator-name = "ldo3";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1200000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_LDO_MODE_NORMAL>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-gpu-dvfs.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-gpu-dvfs.dtsi
new file mode 100644
index 00000000..f836d1c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-gpu-dvfs.dtsi
@@ -0,0 +1,19 @@
+/*
+*  GPU DVFS table
+*/
+&gpu {
+	operating-points =
+		/* KHz uV */
+		<620000 1100000>,
+		<600000 1100000>,
+		<580000 1075000>,
+		<560000 1075000>,
+		<540000 1050000>,
+		<520000 1025000>,
+		<500000 1000000>,
+		<460000 1000000>,
+		<440000 1000000>,
+		<400000 1000000>,
+		<380000 975000>;
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-1GB-lm.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-1GB-lm.dtsi
new file mode 100644
index 00000000..7a909d8
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-1GB-lm.dtsi
@@ -0,0 +1,37 @@
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+#define MEDIA_REQ_SIZE_0 (0x06e00000) // 110M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0 ;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0 ;
+
+/ {
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-1GB.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-1GB.dtsi
new file mode 100644
index 00000000..793434e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-1GB.dtsi
@@ -0,0 +1,46 @@
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+#define MEDIA_REQ_SIZE_0 (0x0b800000) // 184M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+/ {
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-2GB-tee.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-2GB-tee.dtsi
new file mode 100644
index 00000000..c3e6a29
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-2GB-tee.dtsi
@@ -0,0 +1,82 @@
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+
+#define MEDIA_REQ_SIZE_0        (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0   (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0   (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0   (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0        (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0   (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0   (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0   (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1        (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1   (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1   (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1   (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define MEDIA_REQ_SIZE_2        (0x00800000) // 8M
+#define ION_MEDIA_HEAP_PHYS_2   (MEM_SLOT(3, PHYS, MEDIA_REQ_SIZE_2))
+#define ION_MEDIA_HEAP_SIZE_2   (MEM_SLOT(3, SIZE, MEDIA_REQ_SIZE_2))
+#define ION_MEDIA_HEAP_FLAG_2   (MEM_SLOT(3, FLAG, MEDIA_REQ_SIZE_2) | RTK_FLAG_VE_SPEC)
+
+#define MEDIA_REQ_SIZE_3        (0x03000000) // 48M
+#define ION_MEDIA_HEAP_PHYS_3   (MEM_SLOT(5, PHYS, MEDIA_REQ_SIZE_3))
+#define ION_MEDIA_HEAP_SIZE_3   (MEM_SLOT(5, SIZE, MEDIA_REQ_SIZE_3))
+#define ION_MEDIA_HEAP_FLAG_3   (MEM_SLOT(5, FLAG, MEDIA_REQ_SIZE_3) | RTK_FLAG_VE_SPEC)
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0      ION_MEDIA_HEAP_SIZE_0   ;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0      ION_AUDIO_HEAP_SIZE_0   ;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1      ION_MEDIA_HEAP_SIZE_1   ;
+/memreserve/ ION_MEDIA_HEAP_PHYS_2      ION_MEDIA_HEAP_SIZE_2   ;
+/memreserve/ ION_MEDIA_HEAP_PHYS_3      ION_MEDIA_HEAP_SIZE_3   ;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0  ;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0 ;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0    ;
+
+/ {
+    rtk,ion {
+        rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+                ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+                >;
+        };
+        rtk,ion-heap@8 {    /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                ION_AUDIO_HEAP_PHYS_0 ION_AUDIO_HEAP_SIZE_0 ION_AUDIO_HEAP_FLAG_0
+                >;
+        };
+        rtk,ion-heap@7 {    /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+                ION_MEDIA_HEAP_PHYS_0 ION_MEDIA_HEAP_SIZE_0 ION_MEDIA_HEAP_FLAG_0
+                ION_MEDIA_HEAP_PHYS_1 ION_MEDIA_HEAP_SIZE_1 ION_MEDIA_HEAP_FLAG_1
+                ION_MEDIA_HEAP_PHYS_2 ION_MEDIA_HEAP_SIZE_2 ION_MEDIA_HEAP_FLAG_2
+                ION_MEDIA_HEAP_PHYS_3 ION_MEDIA_HEAP_SIZE_3 ION_MEDIA_HEAP_FLAG_3
+                >;
+        };
+    };
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-2GB.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-2GB.dtsi
new file mode 100644
index 00000000..8e423b8
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ion-2GB.dtsi
@@ -0,0 +1,46 @@
+#include <dt-bindings/soc/rtd129x,memory.h>
+
+#define MEDIA_REQ_SIZE_0 (0x0b800000) // 184M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x09200000) // 146M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0 ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0 ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1 ION_MEDIA_HEAP_SIZE_1;
+
+/ {
+	rtk,ion {
+		rtk,ion-heap@8 { /* Audio */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <8>;
+				rtk,memory-reserve = <
+					ION_AUDIO_HEAP_PHYS_0
+					ION_AUDIO_HEAP_SIZE_0
+					ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <7>;
+				rtk,memory-reserve = <
+					ION_MEDIA_HEAP_PHYS_0
+					ION_MEDIA_HEAP_SIZE_0
+					ION_MEDIA_HEAP_FLAG_0
+					ION_MEDIA_HEAP_PHYS_1
+					ION_MEDIA_HEAP_SIZE_1
+					ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ramoops.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ramoops.dtsi
new file mode 100644
index 00000000..1307cee
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-ramoops.dtsi
@@ -0,0 +1,22 @@
+/{
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		ramoops_mem: ramoops_mem@0 {
+			reg = <0x22000000 0x00200000>; /* 2 MB */
+			reg-names = "ramoops_mem";
+			no-map;
+		};
+	};
+
+	ramoops@10014000 {
+		compatible = "ramoops";
+		record-size = <0 0x00004000>; /* 16 KB */
+		console-size = <0 0x00100000>; /*  1 MB */
+		ftrace-size = <0 0x00004000>; /* 16 KB */
+		memory-region = <&ramoops_mem>;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-sata.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-sata.dtsi
new file mode 100644
index 00000000..5a6ef1e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-sata.dtsi
@@ -0,0 +1,18 @@
+/* PLEASE include this file inside a node */
+	sata_phy: sata_phy@9803FF60 {
+		compatible = "Realtek,rtk-sata-phy";
+		reg = <0x9803FF00 0x100>, <0x9801a980 0x10>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		#phy-cells = <1>;
+		status = "okay";
+	};
+
+	ahci_sata: sata@9803F000 {
+		compatible = "Realtek,ahci-sata";
+		reg = <0x9803F000 0x1000>;
+		interrupts = <0 28 4>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+	};
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-usb.dtsi
new file mode 100644
index 00000000..2274183
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-usb.dtsi
@@ -0,0 +1,436 @@
+/*
+ * realtek,port0-power-gpio: port 0 power, output, default low
+ * realtek,port1-power-gpio: port 1 power, output, default low
+ * realtek,port2-power-gpio: port 2  power, output, default low
+ * realtek,port3-power-gpio: 1296 port 3 power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+
+rtk_usb_power_manager@0 {
+	compatible = "Realtek,usb-manager";
+	reg = <0x98000000 0x10>;
+
+	//usb_iso_mode;
+	//en_usb_storage_reprobe; /* To enable usb storage re-probe*/
+	//rescue_usb; /* For rescue dtb use */
+
+	resets = <&asr1 0x100>,
+		<&asr1 8>,
+		<&asr1 9>,
+		<&asr2 3>,
+		<&asr2 2>,
+		<&asr1 2>,
+		<&asr2 4>,
+		<&rst1 4>,
+		<&rst2 5>,
+		<&rst1 6>;
+	reset-names = "apply",
+		"u2phy0",
+		"u2phy1",
+		"u2phy2",
+		"u2phy3",
+		"u3phy0",
+		"u3phy1",
+		"u3mdio0",
+		"u3mdio1",
+		"usb";
+
+	/* For port0 */
+	gpio0: gpio0 {
+		realtek,power-gpio = <&rtk_iso_gpio 1 1 0>;
+		//power_low_active; /* type c use high active */
+
+	};
+	/* For port1 and port2 */
+	gpio1: gpio1 {
+		realtek,power-gpio = <&rtk_misc_gpio 19 1 0>;
+		//power_low_active;
+
+	};
+	/* For port2 */
+	gpio2: gpio2 {
+		//realtek,power-gpio = <&rtk_iso_gpio 32 1 0>;
+		//power_low_active;
+	};
+
+	port0 {
+		usb = <&dwc3_drd>;
+		type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+		gpio = <&gpio0>;
+	};
+	port1 {
+		usb = <&dwc3_u2host>;
+		gpio = <&gpio1>;
+	};
+	port2 {
+		usb = <&ehci &ohci>;
+		gpio = <&gpio1>;
+	};
+	port3 {
+		usb = <&dwc3_u3host>;
+		gpio = <&gpio2>;
+	};
+
+	rtk_usb {
+		power_ctrl_reg {
+			usb_ctrl = <0x98007fb0>;
+			/* Port 0~2 */
+			usb0_sram_pwr = <0x98007f7c>;
+			usb0_sram_pwr_ctrl = <0x98007f80>;
+			/* Port 3 */
+			usb1_sram_pwr = <0x98007f9c>;
+			usb1_sram_pwr_ctrl = <0x98007fa0>;
+
+			p0_l4_icg = <0x98013364>;
+			p1_l4_icg = <0x98013d60>;
+			/* Port 2 l4_icg have bug */
+			//p2_l4_icg = <0x98013868>;
+			p3_l4_icg = <0x98013f60>;
+
+			/* for power cut */
+			usb_phy_ctrl = <0x98013340>;
+
+			p0_utmi_reset = <0x98013208>;
+			p1_utmi_reset = <0x98013c08>;
+			p2_utmi_reset = <0x9801382c>;
+			p3_utmi_reset = <0x98013E08>;
+
+			p0_pipe_reset = <0x9801320c>;
+			p3_pipe_reset = <0x98013e0c>;
+
+			/* for suspend */
+			p0_gusb2phycfg = <0x98028200>;
+			p0_gusb3pipectl = <0x980282c0>;
+
+			p1_gusb2phycfg = <0x98031200>;
+
+			p3_gusb2phycfg = <0x981F8200>;
+			p3_gusb3pipectl = <0x981F82c0>;
+
+			//usb_power_cut;
+		};
+
+		type_c {
+			usb_typec_ctrl_cc1_0 = <0x9801334c>;
+		};
+	};
+};
+
+dwc3_drd_usb3phy: dwc3_drd_usb3phy@0 {
+	compatible = "Realtek,usb3phy";
+	reg = <0x98013210 0x4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	phyN = <1>;
+	phy0 {
+		phy_data_size = <0x30>;
+		phy_data_addr = /bits/ 8
+			<0x00 0x01 0x02 0x03 0x04 0x05 0x06 0x07 0x08 0x09
+			0x0A 0x0B 0x0C 0x0D 0x0E 0x0F 0x10 0x11 0x12 0x13
+			0x14 0x15 0x16 0x17 0x18 0x19 0x1A 0x1B 0x1C 0x1D
+			0x1E 0x1F 0x20 0x21 0x22 0x23 0x24 0x25 0x26 0x27
+			0x28 0x29 0x2A 0x2B 0x2C 0x2D 0x2E 0x2F>;
+		phy_data_revA = /bits/ 16
+			<0x4008 0xE046 0x6046 0x2779 0x72F5 0x2AD3 0x000E
+			0x2E00 0x3591 0x525C 0xA600 0xA904 0xC000 0xEF1C
+			0x2000 0x0000 0x000C 0x4C00 0xFC00 0x0C81 0xDE01
+			0x0000 0x0000 0x0000 0x0000 0x4004 0x1260 0xFF00
+			0xCB00 0xA03F 0xC2E0 0x2807 0x947A 0x88AA 0x0057
+			0xAB66 0x0800 0x0000 0x040A 0x01D6 0xF8C2 0x3080
+			0x3082 0x2078 0xFFFF 0xFFFF 0x0000 0x0040>;
+		do_toggle;
+	};
+};
+
+dwc3_drd_usb2phy: dwc3_drd_usb2phy@0 {
+	compatible = "Realtek,usb2phy";
+	reg = <0x98028280 0x4>, <0x98013214 0x4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	phyN = <1>;
+	phy0 {
+		phy_data_page0_size = <16>;
+		phy_data_page0_addr = /bits/ 8
+			<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+			0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+		phy_data_page0_data = /bits/ 8
+			<0x90 0x30 0x3A 0x8D 0xA8 0x65 0x91 0x81 0xFC 0x8C
+			0x00 0x11 0x9B 0x81 0x00 0x02>;
+		phy_data_page1_size = <8>;
+		phy_data_page1_addr = /bits/ 8
+			<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+		phy_data_page1_data = /bits/ 8
+			<0x25 0xEF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+		do_toggle;
+		//check_efuse;
+	};
+};
+
+dwc3_drd: rtk_dwc3_drd@98013200 {
+	compatible = "Realtek,dwc3";
+	reg = <0x98013200 0x200>;
+	interrupts = <0 21 4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	delay_probe_work; //To delay probe work
+	ordered_probe; // ordered probe in delay work
+	dwc3_drd@98020000 {
+		compatible = "synopsys,dwc3";
+		reg = <0x98020000 0x9000>;
+		interrupts = <0 21 4>;
+		usb-phy = <&dwc3_drd_usb2phy &dwc3_drd_usb3phy>;
+		dr_mode = "host"; /*otg, host, peripheral*/
+		//tx-fifo-resize;
+		snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+	};
+
+	dwc3_type_c: rtk_dwc3_drd_type_c@0 {
+		//compatible = "Realtek,dwc3-type_c";
+		reg = <0x98013200 0x200>;
+		realtek,rd_ctrl-gpio = <&rtk_iso_gpio 34 1 0>; /*TypeC Rd control, output, default low */
+		interrupts = <0 60 4>;
+		//drd_mode;  /*depend on dwc3 dr_mode = "peripheral"*/
+		//debug; /*to enable debug log*/
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+
+		default_revision = <0xA01>;
+		A00 {
+			cc_dfp_mode = "dfp_3_0"; /*dfp_3_0, dfp_1_5, dfp_usb*/
+			rd_config = "internal"; /*internal, extrenal*/
+			cc1_rp_4p7k_code = <0x9>;
+			cc1_rp_36k_code = <0x14>;
+			cc1_rp_12k_code = <0xf>;
+			cc1_rd_code = <0>; /*for internal rd*/
+			cc1_vref_ufp = /bits/ 8
+				<0x0 0x0 0x2>; /*<1p23v,0p66v,0p2v>*/
+			cc1_vref_dfp_usb = /bits/ 8
+				<0x0 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+			cc1_vref_dfp_1_5 = /bits/ 8
+				<0x0 0x0 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+			cc1_vref_dfp_3_0 = /bits/ 8
+				<0x0 0x1 0x2>; /*<2p6v,0p8v,0p2v>*/
+			cc2_rp_4p7k_code = <0x2>;
+			cc2_rp_36k_code = <0x15>;
+			cc2_rp_12k_code = <0xe>;
+			cc2_rd_code = <0>; /*for internal rd*/
+			cc2_vref_ufp = /bits/ 8
+				<0x0 0x0 0x3>; /*<1p23v,0p66v,0p2v>*/
+			cc2_vref_dfp_usb = /bits/ 8
+				<0x0 0x3 0x0>; /*<0_1p6v,0p2v,unused>*/
+			cc2_vref_dfp_1_5 = /bits/ 8
+				<0x0 0x0 0x3>; /*<1_1p6v,0p4v,0p2v>*/
+			cc2_vref_dfp_3_0 = /bits/ 8
+				<0x0 0x3 0x3>; /*<2p6v,0p8v,0p2v>*/
+		};
+
+		A01 {
+			cc_dfp_mode = "dfp_3_0"; /*dfp_3_0, dfp_1_5, dfp_usb*/
+			rd_config = "internal"; /*internal, extrenal*/
+			cc1_rp_4p7k_code = <0xb>;
+			cc1_rp_36k_code = <0x17>;
+			cc1_rp_12k_code = <0x10>;
+			cc1_rd_code = <0>; /*for internal rd*/
+			cc1_vref_ufp = /bits/ 8
+				<0x0 0x0 0x4>; /*<1p23v,0p66v,0p2v>*/
+			cc1_vref_dfp_usb = /bits/ 8
+				<0x0 0x4 0x0>; /*<0_1p6v,0p2v,unused>*/
+			cc1_vref_dfp_1_5 = /bits/ 8
+				<0x0 0x0 0x4>; /*<1_1p6v,0p4v,0p2v>*/
+			cc1_vref_dfp_3_0 = /bits/ 8
+				<0x0 0x3 0x4>; /*<2p6v,0p8v,0p2v>*/
+			cc2_rp_4p7k_code = <0xc>;
+			cc2_rp_36k_code = <0x17>;
+			cc2_rp_12k_code = <0x12>;
+			cc2_rd_code = <0>; /*for internal rd*/
+			cc2_vref_ufp = /bits/ 8
+				<0x0 0x0 0x5>; /*<1p23v,0p66v,0p2v>*/
+			cc2_vref_dfp_usb = /bits/ 8
+				<0x0 0x5 0x0>; /*<0_1p6v,0p2v,unused>*/
+			cc2_vref_dfp_1_5 = /bits/ 8
+				<0x0 0x0 0x5>; /*<1_1p6v,0p4v,0p2v>*/
+			cc2_vref_dfp_3_0 = /bits/ 8
+				<0x2 0x3 0x5>; /*<2p6v,0p8v,0p2v>*/
+		};
+	};
+};
+
+dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+	compatible = "Realtek,usb2phy";
+	reg = <0x98031280 0x4>, <0x98013C14 0x4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	phyN = <1>;
+	phy0 {
+		phy_data_page0_size = <16>;
+		phy_data_page0_addr = /bits/ 8
+			<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+			0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+		phy_data_page0_data = /bits/ 8
+			<0x90 0x30 0x3A 0x8D 0xA6 0x65 0x91 0x81 0xFC 0x8C
+			0x00 0x11 0x9B 0x81 0x00 0x02>;
+		phy_data_page1_size = <8>;
+		phy_data_page1_addr = /bits/ 8
+			<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+		phy_data_page1_data = /bits/ 8
+			<0x25 0xEF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+		do_toggle;
+		//check_efuse;
+	};
+};
+
+dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+	compatible = "Realtek,dwc3";
+	reg = <0x98013C00 0x200>;
+	interrupts = <0 21 4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	delay_probe_work; //To delay probe work
+	ordered_probe; // ordered probe in delay work
+	dwc3_u2host@98029000 {
+		compatible = "synopsys,dwc3";
+		reg = <0x98029000 0x9000>;
+		interrupts = <0 21 4>;
+		usb-phy = <&dwc3_u2host_usb2phy>;
+		dr_mode = "host"; /*only host*/
+		//tx-fifo-resize;
+		snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+	};
+};
+
+ehci_phy_rle0599: usb_phy_rle0599@0 {
+	compatible = "Realtek,rtd129x-usb_phy_rle0599";
+	reg = <0x98013824 0x4>, <0x980130A4 0x4>;
+	//Note reg addr: REG_WRAP_VStatusOut2, REG_EHCI_INSNREG05
+	phyN = <1>;
+	phy_data_page0_size = <16>;
+	phy_data_page0_addr = /bits/ 8
+		<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+		0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+	phy_data_page0_data = /bits/ 8
+		<0x90 0x30 0x3A 0x8D 0xA9 0x65 0x91 0x81 0xFC 0x8C
+		0x00 0x11 0x9B 0x81 0x00 0x02>;
+	phy_data_page1_size = <8>;
+	phy_data_page1_addr = /bits/ 8
+		<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+	phy_data_page1_data = /bits/ 8
+		<0x25 0xEF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+	do_toggle;
+	//check_efuse;
+};
+
+ehci: ehci@98013000 {
+	compatible = "Realtek,rtd129x-ehci";
+	reg = <0x98013000 0x100>;
+	interrupts = <0 21 4>;
+	usb-phy = <&ehci_phy_rle0599>;
+	delay_probe_work; //To delay probe work
+	ordered_probe; // ordered probe in delay work
+	fixed_async_list_addr_bug; // add to fixed async_list_addr bug
+};
+
+ohci: ohci@98013400 {
+	compatible = "Realtek,rtd129x-ohci";
+	reg = <0x98013400 0x100>;
+	interrupts = <0 21 4>;
+	usb-phy = <&ehci_phy_rle0599>;
+	delay_probe_work; //To delay probe work
+	ordered_probe; // ordered probe in delay work
+
+	wrap_reg = <0x98013820>;
+};
+
+usb2_udc: usb2_udc@981E0000 {
+	compatible = "Realtek,rtd129x-usb2-udc";
+	reg = <0x981E0000 0x8000>, <0x98013800 0x80>;
+	interrupts = <0 21 4>;
+	usb-phy = <&ehci_phy_rle0599>;
+
+	status = "disable";
+};
+
+dwc3_u3host_usb3phy: dwc3_u3host_usb3phy@0 {
+	//compatible = "Realtek,rtd129x-usb3phy";
+	reg = <0x98013E10 0x4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	status = "disable";
+	phyN = <1>;
+	phy0 {
+		phy_data_size = <0x30>;
+		phy_data_addr = /bits/ 8
+			<0x00 0x01 0x02 0x03 0x04 0x05 0x06 0x07 0x08 0x09
+			0x0A 0x0B 0x0C 0x0D 0x0E 0x0F 0x10 0x11 0x12 0x13
+			0x14 0x15 0x16 0x17 0x18 0x19 0x1A 0x1B 0x1C 0x1D
+			0x1E 0x1F 0x20 0x21 0x22 0x23 0x24 0x25 0x26 0x27
+			0x28 0x29 0x2A 0x2B 0x2C 0x2D 0x2E 0x2F>;
+		phy_data_revA = /bits/ 16
+			<0x4008 0xE046 0x6046 0x2779 0x72F5 0x2AD3 0x000E
+			0x2E00 0x3591 0x525C 0xA600 0xA904 0xC000 0xEF1C
+			0x2000 0x0000 0x000C 0x4C00 0xFC00 0x0C81 0xDE01
+			0x0000 0x0000 0x0000 0x0000 0x4004 0x1260 0xFF00
+			0xCB00 0xA03F 0xC2E0 0x2807 0x9424 0x284A 0x0057
+			0xAB66 0x0800 0x0000 0x040A 0x01D6 0xF8C2 0x3080
+			0x3082 0x2078 0xFFFF 0xFFFF 0x0000 0x0040>;
+		do_toggle;
+	};
+};
+
+dwc3_u3host_usb2phy: dwc3_u3host_usb2phy@0 {
+	//compatible = "Realtek,usb2phy";
+	reg = <0x981F8280 0x4>, <0x98013E14 0x4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	status = "disable";
+	phyN = <1>;
+	phy0 {
+		phy_data_page0_size = <16>;
+		phy_data_page0_addr = /bits/ 8
+			<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+			0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+		phy_data_page0_data = /bits/ 8
+			<0x90 0x30 0x3A 0x8D 0xA6 0x65 0x91 0x81 0xFC 0x8C
+			0x00 0x11 0x9B 0x81 0x00 0x02>;
+		phy_data_page1_size = <8>;
+		phy_data_page1_addr = /bits/ 8
+			<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+		phy_data_page1_data = /bits/ 8
+			<0x25 0xEF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+		do_toggle;
+		//check_efuse;
+	};
+};
+
+dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+	//compatible = "Realtek,dwc3";
+	reg = <0x98013E00 0x200>;
+	interrupts = <0 21 4>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+	ranges;
+	delay_probe_work; //To delay probe work
+	ordered_probe; // ordered probe in delay work
+
+	status = "disable";
+
+	dwc3_u3host@981F0000 {
+		compatible = "synopsys,dwc3";
+		reg = <0x981F0000 0x9000>;
+		interrupts = <0 21 4>;
+		usb-phy = <&dwc3_u3host_usb2phy &dwc3_u3host_usb3phy>;
+		dr_mode = "host"; /*only host*/
+		//tx-fifo-resize;
+		snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-xen-common-domu.dtsi b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-xen-common-domu.dtsi
new file mode 100644
index 00000000..49ecaf1
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd129x/rtd-129x-xen-common-domu.dtsi
@@ -0,0 +1,378 @@
+#include <dt-bindings/clock/rtk,clock-rtd129x.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <dt-bindings/reset/rtk,reset-rtd129x.h>
+#include <dt-bindings/power/rtk,power-rtd129x.h>
+#include <dt-bindings/thermal/thermal.h>
+
+/{
+	passthrough{
+	efuse@98017000 {
+		compatible = "realtek,efuse";
+		reg = <0x0 0x98017000 0x0 0x400>;
+		read-only;
+		status = "okay";
+
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges = <0x0 0x0 0x0 0x10000000>;
+		nvmem-cells =
+			<&efuse_uuid>,
+			<&efuse_etn_phy>,
+			<&efuse_etn_phy_rc>,
+			<&efuse_etn_phy_r>,
+			<&efuse_etn_phy_amp>,
+			<&efuse_etn_phy_adc>,
+			<&efuse_pwr_id>,
+			<&efuse_package_id>,
+			<&efuse_usb_cc_en>,
+			<&efuse_usb_cc1_4_7_k_cal>,
+			<&efuse_usb_cc1_12_k_cal>,
+			<&efuse_usb_cc2_4_7_k_cal>,
+			<&efuse_usb_cc2_12_k_cal>,
+			<&efuse_top_iddq>,
+			<&efuse_cpu_iddq>,
+			<&efuse_usb_dp_dm>,
+			<&efuse_cc_cal>,
+			<&efuse_chip_id>,
+			<&efuse_prog_rvd>;
+		nvmem-cell-names =
+			"uuid",
+			"etn_phy",
+			"etn_phy_rc",
+			"etn_phy_r",
+			"etn_phy_amp",
+			"etn_phy_adc",
+			"pwr_id",
+			"package_id",
+			"usb_cc_en",
+			"usb_cc1_4_7_k_cal",
+			"usb_cc1_12_k_cal",
+			"usb_cc2_4_7_k_cal",
+			"usb_cc2_12_k_cal",
+			"top_iddq",
+			"cpu_iddq",
+			"usb_dp_dm",
+			"cc_cal",
+			"chip_id",
+			"prog_rvd";
+		efuse_uuid: uuid@1A4 {
+			reg = <0x1A4 0xC>;
+			bits = <0 96>;
+		};
+		efuse_etn_phy: etn_phy@1B9 {
+			reg = <0x1B9 0x9>;
+			bits = <2 64>;
+		};
+		efuse_etn_phy_rc: etn_phy_rc@1BF {
+			reg = <0x1BF 0x2>;
+			bits = <5 4>;
+		};
+		efuse_etn_phy_r: etn_phy_r@1BF {
+			reg = <0x1BF 0x1>;
+			bits = <1 4>;
+		};
+		efuse_etn_phy_amp: etn_phy_amp@1B9 {
+			reg = <0x1B9 0x3>;
+			bits = <2 16>;
+		};
+		efuse_etn_phy_adc: etn_phy_adc@1BB {
+			reg = <0x1BB 0x3>;
+			bits = <2 16>;
+		};
+		efuse_pwr_id: pwr_id@1CC {
+			reg = <0x1CC 0x1>;
+			bits = <6 2>;
+		};
+		efuse_package_id: package_id@1D8 {
+			reg = <0x1D8 0x1>;
+			bits = <0 2>;
+		};
+		efuse_usb_cc_en: usb_cc_en@1D8 {
+			reg = <0x1D8 0x1>;
+			bits = <2 1>;
+		};
+		efuse_usb_cc1_4_7_k_cal: usb_cc1_4_7_k_cal@1D8 {
+			reg = <0x1D8 0x1>;
+			bits = <3 4>;
+		};
+		efuse_usb_cc1_12_k_cal: usb_cc1_12_k_cal@1D8 {
+			reg = <0x1D8 0x2>;
+			bits = <7 4>;
+		};
+		efuse_usb_cc2_4_7_k_cal: usb_cc2_4_7_k_cal@1D9 {
+			reg = <0x1D9 0x1>;
+			bits = <3 4>;
+		};
+		efuse_usb_cc2_12_k_cal: usb_cc2_12_k_cal@1D9 {
+			reg = <0x1D9 0x2>;
+			bits = <7 4>;
+		};
+		efuse_top_iddq: top_iddq@1DA {
+			reg = <0x1DA 0x2>;
+			bits = <3 6>;
+		};
+		efuse_cpu_iddq: cpu_iddq@1DB {
+			reg = <0x1DB 0x1>;
+			bits = <1 6>;
+		};
+		efuse_usb_dp_dm: usb_dp_dm@1DC {
+			reg = <0x1DC 0x1>;
+			bits = <0 4>;
+		};
+		efuse_cc_cal: cc_cal@1DC {
+			reg = <0x1DC 0x4>;
+			bits = <4 24>;
+		};
+		efuse_chip_id: chip_id@200 {
+			reg = <0x200 0x10>;
+			bits = <0 128>;
+		};
+		efuse_prog_rvd: prog_rvd@3FC {
+			reg = <0x3FC 0x4>;
+			bits = <0 32>;
+		};
+	};
+
+	sb2_lock0: sb2-lock@9801A000 {
+		compatible = "realtek,sb2-sem";
+		reg = <0x0 0x9801A000 0x0 0x4>;
+	};
+
+	/* fixed clock */
+	osc27M: osc27M {
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <27000000>;
+		clock-output-names = "osc27M";
+	};
+
+	/* mmio */
+	crt_mmio: mmio@98000000 {
+		compatible = "realtek,mmio";
+		reg = <0x0 0x98000000 0x0 0x600>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	iso_mmio: mmio@98007088 {
+		compatible = "realtek,mmio";
+		reg = <0x0 0x98007088 0x0 0x8>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	/* clock-controller */
+	clk_en_1: clk-en@9800000c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800000c 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0xc>;
+		clock-output-names =
+			"clk_en_misc",
+			"clk_en_pcie0",
+			"clk_en_sata_0",
+			"clk_en_gspi",
+			"clk_en_usb",
+			"",
+			"clk_en_iso_misc",
+			"clk_en_sata_alive_0",
+			"clk_en_hdmi",
+			"clk_en_etn",
+			"",
+			"",
+			"",
+			"",
+			"",
+			"",
+			"clk_en_lvds",
+			"clk_en_se",
+			"",
+			"clk_en_cp",
+			"clk_en_md",
+			"clk_en_tp",
+			"",
+			"clk_en_nf",
+			"clk_en_emmc",
+			"clk_en_cr",
+			"clk_en_sdio_ip",
+			"clk_en_mipi",
+			"clk_en_emmc_ip",
+			"",
+			"clk_en_sdio",
+			"clk_en_sd_ip";
+		ignore-unused-clocks =
+			"clk_en_misc",
+			"clk_en_iso_misc",
+			"clk_en_cp",
+			"clk_en_md",
+			"clk_en_tp",
+			"clk_en_hdmi";
+		ignore-pm-clocks =
+			"clk_en_hdmi";
+	};
+
+	clk_en_2: clk-en@98000010 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000010 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x10>;
+		clock-output-names =
+			"clk_en_nat",
+			"clk_en_misc_i2c_5",
+			"",
+			"clk_en_jpeg",
+			"",
+			"clk_en_pcie1",
+			"clk_en_misc_sc",
+			"clk_en_cbus_tx",
+			"",
+			"",
+			"clk_en_misc_rtc",
+			"",
+			"",
+			"clk_en_misc_i2c_4",
+			"clk_en_misc_i2c_3",
+			"clk_en_misc_i2c_2",
+			"clk_en_misc_i2c_1",
+			"",
+			"",
+			"",
+			"",
+			"",
+			"",
+			"",
+			"clk_en_hdmirx",
+			"clk_en_sata_1",
+			"clk_en_sata_alive_1",
+			"clk_en_ur2",
+			"clk_en_ur1",
+			"clk_en_fan",
+			"clk_en_dcphy_0",
+			"clk_en_dcphy_1";
+		ignore-unused-clocks =
+			"clk_en_dcphy_0",
+			"clk_en_dcphy_1";
+	};
+
+	clk_en_3: clk-en@98000450 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000450 0x0 0x4>;
+		#clock-cells = <1>;
+		clock-output-names =
+			"",
+			"",
+			"clk_en_lsadc";
+	};
+
+	iclk_en: clk-en@9800708c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800708c 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&iso_mmio 0x4>;
+		clock-output-names =
+			"",
+			"",
+			"clk_en_misc_cec0",
+			"clk_en_cbusrx_sys",
+			"clk_en_cbustx_sys",
+			"clk_en_cbus_sys",
+			"clk_en_cbus_osc",
+			"clk_en_misc_ir",
+			"clk_en_misc_ur0",
+			"clk_en_i2c0",
+			"clk_en_i2c1",
+			"clk_en_etn_250m",
+			"clk_en_etn_sys";
+		ignore-unused-clocks =
+			"clk_en_etn_250m",
+			"clk_en_etn_sys";
+	};
+
+	cc: clock-controller@98000000 {
+		compatible   = "realtek,clock-controller";
+		reg = <0x0 0x98000000 0x0 0x600>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	/* reset-controller */
+	rst1: soft-reset@98000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98000000 0x0 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+		pm-ignore-bits = <0x00001000>;
+	};
+
+	srst1: shadow-soft-reset@98000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98000000 0x0 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+		pm-ignore-bits = <0x00001000>;
+	};
+
+	rst2: soft-reset@98000004 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98000004 0x0 0x4>;
+		realtek,mmio = <&crt_mmio 0x4>;
+		#reset-cells = <1>;
+	};
+
+	rst3: soft-reset@98000008 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98000008 0x0 0x4>;
+		realtek,mmio = <&crt_mmio 0x8>;
+		#reset-cells = <1>;
+	};
+
+	rst4: soft-reset@98000050 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98000050 0x0 0x4>;
+		realtek,mmio = <&crt_mmio 0x50>;
+		#reset-cells = <1>;
+	};
+
+	irst: soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98007088 0x0 0x4>;
+		realtek,mmio = <&iso_mmio 0x0>;
+		#reset-cells = <1>;
+	};
+
+	asr1: async-soft-reset@98000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98000000 0x0 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+		async-group = <0>;
+	};
+
+	asr2: async-soft-reset@98000004 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98000004 0x0 0x4>;
+		realtek,mmio = <&crt_mmio 0x4>;
+		#reset-cells = <1>;
+		async-group = <0>;
+	};
+
+	pd0: power-controller@98000000 {
+		reg = <0 0x98000000 0 0x1000>;
+		compatible = "realtek,rtd129x-crt-power", "simple-bus";
+		resets = <&srst1 RSTN_VE1>, <&srst1 RSTN_VE2>, <&srst1 RSTN_VE3>,
+			<&srst1 RSTN_NAT>;
+		reset-names = "ve1", "ve2", "ve3", "nat";
+		#power-domain-cells = <1>;
+		invalid-power-domains = "nat_pd";
+	};
+
+	dvfs: cpu-dvfs {
+		 compatible = "realtek,dummy-dvfs";
+		 clocks = <&cc CC_PLL_SCPU>;
+		 operating-points-v2 = <&cpu_opps>;
+		 status = "okay";
+	};
+
+	}; /* passthrough */
+};
+
+#include "rtd-129x-cpu-dvfs.dtsi"
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/Makefile b/arch/arm64/boot/dts/realtek/rtd139x/Makefile
new file mode 100755
index 00000000..bbf93b8
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/Makefile
@@ -0,0 +1,67 @@
+dtb-$(CONFIG_ARCH_RTD139x) += hercules-fpga.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-384MB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-512MB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB.atv.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB.atv-avb.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB.atv-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB.CMAx2.MEMTEST.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-avb.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-avb-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB.MEMTEST.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-1GB.atv.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-1GB.atv-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-1GB.CMAx2.MEMTEST.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-2GB.MEMTEST.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-1GB.atv.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-1GB.atv-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-768MB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-512MB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-384MB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-384MB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-arete-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-qa-rescue-nand.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-nand-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-nand-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-nand-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-papermulberry-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-papermulberry-qa-rescue.dtb
+
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-ab.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-verity.dtb
+
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-tee-vmx.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-1GB-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-2GB-qa-rescue-tee.dtb
+
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-qa-rescue-vmx.dtb
+
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-glinux-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-glinux-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-glinux-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1355-gnarledclub-glinux-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-nand-glinux-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-nand-glinux-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-papermulberry-glinux-1GB.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-glinux-2GB-tee.dtb
+
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-1GB-xendom0.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-2GB-xendom0.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-xenott.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-xenott.low.dtb
+dtb-$(CONFIG_ARCH_RTD139x) += rtd-1395-lionskin-xenott.CMAx2.dtb
+
+always		:= $(dtb-y)
+subdir-y	:= $(dts-dirs)
+clean-files	:= *.dtb
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/dtbo/rtd-1395-lionskin-overlay.dts b/arch/arm64/boot/dts/realtek/rtd139x/dtbo/rtd-1395-lionskin-overlay.dts
new file mode 100644
index 00000000..7319544
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/dtbo/rtd-1395-lionskin-overlay.dts
@@ -0,0 +1,81 @@
+/dts-v1/;
+/plugin/;
+
+
+/ {
+	board_id = <0x0>;
+};
+
+
+&uart0 {
+	status = "okay";
+};
+
+&uart1 {
+	status = "okay";
+};
+
+&uart2{
+	status = "disabled";
+};
+
+&nic{
+	status = "okay";
+};
+
+&i2c_0{
+	status = "okay";
+};
+
+&i2c_1{
+	status = "okay";
+};
+
+&i2c_5{
+	status = "okay";
+};
+
+&spi_0{
+	status = "disabled";
+};
+
+&pwm{
+	status = "okay";
+};
+
+&sd{
+	status = "okay";
+};
+
+&sdio{
+	status = "okay";
+};
+
+&emmc{
+	status = "okay";
+};
+
+&gpu{
+	status = "okay";
+};
+
+&cpu_tm{
+	status = "okay";
+};
+
+&md{
+	status = "okay";
+};
+
+&se{
+	status = "okay";
+};
+
+&jpeg{
+	status = "okay";
+};
+
+&ve1{
+	status = "okay";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/dtbo/rtd-139x-dtboimg.cfg b/arch/arm64/boot/dts/realtek/rtd139x/dtbo/rtd-139x-dtboimg.cfg
new file mode 100644
index 00000000..3611ed9
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/dtbo/rtd-139x-dtboimg.cfg
@@ -0,0 +1,3 @@
+#global options
+rtd-1395-lionskin-overlay.dtbo
+    id=/:board_id
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/hercules-fpga.dts b/arch/arm64/boot/dts/realtek/rtd139x/hercules-fpga.dts
new file mode 100644
index 00000000..8adc553
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/hercules-fpga.dts
@@ -0,0 +1,54 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+
+#include "hercules-fpga.dtsi"
+
+/ {
+	model= "Realtek_Hercules_FPGA";
+	compatible =  "realtek,hercules";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init loglevel=7";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x20000000>;	/* 512 MB */
+	};
+	
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/hercules-fpga.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/hercules-fpga.dtsi
new file mode 100644
index 00000000..92aba76
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/hercules-fpga.dtsi
@@ -0,0 +1,128 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+
+/{
+	compatible = "realtek,hercules";
+	interrupt-parent = <&gic>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A53_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x0>;
+			/*enable-method = "psci";*/
+			enable-method = "rtk-spin-table";
+			next-level-cache = <&a53_l2>;
+		};
+
+		A53_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x1>;
+			/*enable-method = "psci";*/
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a53_l2>;
+		};
+
+		a53_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	soc@0 {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x98000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x98000000 0x200000>;
+		status = "okay";
+	};
+
+	timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <1 13 0xf08>,
+					 <1 14 0xf08>,
+					 <1 11 0xf08>,
+					 <1 10 0xf08>;
+		clock-frequency = <27000000>;
+	};
+
+	gic: interrupt-controller@FF010000 {
+		compatible = "arm,cortex-a15-gic";
+		#interrupt-cells = <3>;
+		interrupt-controller;
+		reg = <0xFF011000 0x1000>,
+			    <0xFF012000 0x1000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <0 48 4>;
+		interrupt-affinity = <&A53_0>, <&A53_1>;
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x9801B000 0x100>, /* MISC_TOP MISC_ISO */
+			  <0x98007000 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+		
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007800 0x400>,
+			  <0x98007000 0x100>;
+		interrupts-st-mask = <0x4>;
+		interrupts = <1 2>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clock-frequency = <33000000>; /* This value must be override by the board. */
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x9801d000 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x9801a000 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+	
+	watchdog@0x98007680 {
+		compatible = "Realtek,rtk-watchdog";
+		reg = <0x98007680 0x100>;
+		rst-oe = <0>; /* 0:input, 1:output */
+		status = "okay";
+	};
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x98007600 0x100>;
+		rst-reg-offset = <0x40>;
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.CMAx2.MEMTEST.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.CMAx2.MEMTEST.dts
new file mode 100644
index 00000000..46d3ac0
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.CMAx2.MEMTEST.dts
@@ -0,0 +1,252 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ (0x10000000) (0x20000000);
+
+#define MEDIA_REQ_SIZE_0 (0x00e00000) // 14M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_1GB";
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive no_console_suspend=1";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x01800000>; /* size 24MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x04000000 0x01800000>; /* offset 64MB, size 24MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x05800000 0x00800000>; /* offset 88MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.CMAx2.dts
new file mode 100644
index 00000000..b128c0e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.CMAx2.dts
@@ -0,0 +1,251 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_1GB";
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.atv-tee.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.atv-tee.dts
new file mode 100644
index 00000000..fa1d918
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.atv-tee.dts
@@ -0,0 +1,279 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_30MB_PHYS TEE_OS_30MB_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_AUDIO_SIZE               (0x00200000) // 2MB
+#define SECURE_MD_SIZE                  (0x00100000) // 1MB
+#define SECURE_HEAP_SIZE_0              (0x03c00000) // 60MB
+
+#define ION_SECURE_AUDIO_PHYS_0         (0x20800000)
+#define ION_SECURE_AUDIO_SIZE_0         (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0         (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0            (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0            (SECURE_MD_SIZE)
+
+#define ION_SECURE_HEAP_PHYS_0          (ION_SECURE_MD_PHYS_0 + ION_SECURE_MD_SIZE_0)
+#define ION_SECURE_HEAP_SIZE_0          (SECURE_HEAP_SIZE_0)
+#define ION_SECURE_HEAP_FLAG_0          (RTK_FLAG_HWIPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0      ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0      ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_1GB";
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x12000000 0x09400000>; /* offset 288MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+
+        rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+                ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+                >;
+        };
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.atv.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.atv.dts
new file mode 100644
index 00000000..34e62e1
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.atv.dts
@@ -0,0 +1,251 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_1GB";
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.dts
new file mode 100644
index 00000000..379bd39
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-1GB.dts
@@ -0,0 +1,217 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_1GB";
+	model_hex= <0x0000054B>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-2GB.MEMTEST.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-2GB.MEMTEST.dts
new file mode 100644
index 00000000..2a60cee
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-2GB.MEMTEST.dts
@@ -0,0 +1,237 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ MEMTESTER_RSV_PHYS MEMTESTER_RSV_SIZE; /* 64MB@0x22000000 */
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_2GB";
+	model_hex= <0x0000054B>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-2GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-2GB.dts
new file mode 100644
index 00000000..5353d48
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-2GB.dts
@@ -0,0 +1,216 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_2GB";
+	model_hex= <0x0000054B>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-1GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-1GB.dts
new file mode 100644
index 00000000..22c0fe8
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-1GB.dts
@@ -0,0 +1,217 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0b800000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_1GB";
+	model_hex= <0x0000054B>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-2GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-2GB.dts
new file mode 100644
index 00000000..5353d48
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub-glinux-2GB.dts
@@ -0,0 +1,216 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1355-gnarledclub.dtsi"
+
+/ {
+	model= "Realtek_Gnarled_Club_2GB";
+	model_hex= <0x0000054B>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+                pinctrl-0 = <&prob0_pins>,
+			<&prob1_pins>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&hse {
+	status = "disabled";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub.dtsi
new file mode 100644
index 00000000..f429311
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-gnarledclub.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-139x.dtsi"
+#include "rtd-139x-dvfs.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-qa-rescue.dts
new file mode 100644
index 00000000..503de43
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1355-qa-rescue.dts
@@ -0,0 +1,189 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-139x.dtsi"
+
+/ {
+	model= "Realtek_RTD1355";
+	model_hex= <0x0000054B>;
+	compatible = "realtek,rtd1355";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	nic: gmac@98016000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-1GB-qa-rescue-tee.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-1GB-qa-rescue-tee.dts
new file mode 100644
index 00000000..a6eb02f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-1GB-qa-rescue-tee.dts
@@ -0,0 +1,224 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+/* TEE OS */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x0d500000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+
+#define SECURE_AUDIO_SIZE               (0x00200000) // 2MB
+#define SECURE_MD_SIZE                  (0x00100000) // 1MB
+#define SECURE_HEAP_SIZE_0              (0x04600000) // 70MB
+
+#define ION_SECURE_AUDIO_PHYS_0         (0x20800000)
+#define ION_SECURE_AUDIO_SIZE_0         (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0         (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0            (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0            (SECURE_MD_SIZE)
+
+#define ION_SECURE_HEAP_PHYS_0          (ION_SECURE_MD_PHYS_0 + ION_SECURE_MD_SIZE_0)
+#define ION_SECURE_HEAP_SIZE_0          (SECURE_HEAP_SIZE_0)
+#define ION_SECURE_HEAP_FLAG_0          (RTK_FLAG_HWIPACC)
+
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+
+#include "rtd-139x.dtsi"
+
+/ {
+	model= "Realtek_RTD1395";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+		tee_reserved: tee {
+            no-map;
+            size = <0x04100000>;
+            alloc-ranges = <TEE_OS_PHYS TEE_OS_SIZE>;
+        };
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+				ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+			>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-2GB-qa-rescue-tee.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-2GB-qa-rescue-tee.dts
new file mode 100644
index 00000000..13d6cd5
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-2GB-qa-rescue-tee.dts
@@ -0,0 +1,193 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+/* TEE OS */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-139x-ion-2GB-tee.dtsi"
+#include "rtd-139x.dtsi"
+
+/ {
+	model= "Realtek_RTD1395";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+		tee_reserved: tee {
+            no-map;
+            size = <0x04100000>;
+            alloc-ranges = <TEE_OS_PHYS TEE_OS_SIZE>;
+        };
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.CMAx2.dts
new file mode 100644
index 00000000..622f59a
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.CMAx2.dts
@@ -0,0 +1,219 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-tee.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-tee.dts
new file mode 100644
index 00000000..6e0175c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv-tee.dts
@@ -0,0 +1,266 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_30MB_PHYS TEE_OS_30MB_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_AUDIO_SIZE               (0x00200000) // 2MB
+#define SECURE_MD_SIZE                  (0x00100000) // 1MB
+#define SECURE_HEAP_SIZE_0              (0x03c00000) // 60MB
+
+#define ION_SECURE_AUDIO_PHYS_0         (0x20800000)
+#define ION_SECURE_AUDIO_SIZE_0         (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0         (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0            (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0            (SECURE_MD_SIZE)
+
+#define ION_SECURE_HEAP_PHYS_0          (ION_SECURE_MD_PHYS_0 + ION_SECURE_MD_SIZE_0)
+#define ION_SECURE_HEAP_SIZE_0          (SECURE_HEAP_SIZE_0)
+#define ION_SECURE_HEAP_FLAG_0          (RTK_FLAG_HWIPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0      ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0      ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x12000000 0x09400000>; /* offset 288MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+				ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+				>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv.dts
new file mode 100644
index 00000000..f27fb53
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.atv.dts
@@ -0,0 +1,239 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.dts
new file mode 100644
index 00000000..588ddd05
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-1GB.dts
@@ -0,0 +1,204 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.CMAx2.dts
new file mode 100755
index 00000000..bd1a845
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.CMAx2.dts
@@ -0,0 +1,240 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_384MB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		saving-section-page-table = <1>;
+		reg = <0 0x18000000>; /* 384 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x04400000 0x09400000>; /* offset 68MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x0f000000 0x00800000>; /* offset 240MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.dts
new file mode 100755
index 00000000..d428279
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-384MB.dts
@@ -0,0 +1,235 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0c700000) // 199M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03C00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (0x10100000) // over-lay with tee region, please remove tee reserved region in bootcode
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_384MB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		saving-section-page-table = <1>;
+		reg = <0 0x18000000>; /* 384 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x15000000 0x00800000>; /* offset 336MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-512MB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-512MB.CMAx2.dts
new file mode 100755
index 00000000..0c13bbb
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-512MB.CMAx2.dts
@@ -0,0 +1,239 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_512MB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		saving-section-page-table = <1>;
+		reg = <0 0x20000000>; /* 512 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x04400000 0x09400000>; /* offset 68MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x0f000000 0x00800000>; /* offset 240MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-768MB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-768MB.CMAx2.dts
new file mode 100755
index 00000000..e7ccb20
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-768MB.CMAx2.dts
@@ -0,0 +1,239 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_768MB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		saving-section-page-table = <1>;
+		reg = <0 0x38000000>; /* 768 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x04400000 0x09400000>; /* offset 68MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x0f000000 0x00800000>; /* offset 240MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	pinctrl@9804E000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>,
+                        <&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>;
+		/*gpio_11 UR1_RTS_N*/
+		uart1_pins: uart1_pins {
+                        realtek,pins = "gpio_8",
+                                "gpio_9",
+				"gpio_11";
+                        realtek,function = "uart1";
+                };
+
+	};
+
+	i2c@0x98007D00 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-rescue.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-rescue.dts
new file mode 100644
index 00000000..d56edb1
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete-rescue.dts
@@ -0,0 +1,191 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x0d500000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+
+#include "rtd-1395-arete.dtsi"
+
+/ {
+	model= "Realtek_Arete_384MB";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x18000000>; /* 384 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete.dtsi
new file mode 100644
index 00000000..3605d65
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-arete.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-139x.dtsi"
+#include "rtd-139x-dfs.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB-xendom0.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB-xendom0.dts
new file mode 100644
index 00000000..1df9c1a
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB-xendom0.dts
@@ -0,0 +1,215 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-139x-xen.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+	compatible = "Realtek,rtd-1395";
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		#address-cells = <0x1>;
+		#size-cells = <0x1>;
+		bootargs = "console=dtuart dtuart=serial0 dom0_mem=122MB dom0_max_vcpus=2";
+
+		module@04000000 {
+			compatible = "xen,linux-zimage", "xen,multiboot-module";
+			reg = <0x04000000 0x01100000>;
+			bootargs = "console=hvc0 debug loglevel=4 swiotlb=512 sspt=1 cma=8m";
+		};
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	rtk_xen_mempool@0 {
+		reg = <0x0 0x35800000>;
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	/* no need of ion under normal dom0 */
+	/*
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 {
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 {
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 {
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 {
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 {
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+	*/
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+		status = "disabled";
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+        dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+                compatible = "Realtek,dwc3";
+		usbhost_backend;
+                status = "disabled";
+        };
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.CMAx2.MEMTEST.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.CMAx2.MEMTEST.dts
new file mode 100644
index 00000000..94b08db
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.CMAx2.MEMTEST.dts
@@ -0,0 +1,213 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ (0x10000000) (0x20000000);
+
+#define MEDIA_REQ_SIZE_0 (0x00E00000) // 14M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 androidboot.selinux=permissive no_console_suspend=1";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x01800000>; /* size 24MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x04000000 0x01800000>; /* offset 64MB, size 24MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x05800000 0x00800000>; /* offset 88MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+};
\ No newline at end of file
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.CMAx2.dts
new file mode 100644
index 00000000..aca3321
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.CMAx2.dts
@@ -0,0 +1,212 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+};
\ No newline at end of file
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-avb.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-avb.dts
new file mode 100644
index 00000000..9c2dbd2
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-1GB.atv.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB_AVB";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-tee.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-tee.dts
new file mode 100644
index 00000000..cd366ec
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv-tee.dts
@@ -0,0 +1,241 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_30MB_PHYS TEE_OS_30MB_SIZE;
+
+
+#define MEDIA_REQ_SIZE_0 (0x01000000) // 16M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x00000000) // 0M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_AUDIO_SIZE               (0x00200000) // 2MB
+#define SECURE_MD_SIZE                  (0x00100000) // 1MB
+#define SECURE_HEAP_SIZE_0              (0x03c00000) // 60MB
+
+#define ION_SECURE_AUDIO_PHYS_0         (0x20800000)
+#define ION_SECURE_AUDIO_SIZE_0         (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0         (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0            (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0            (SECURE_MD_SIZE)
+
+#define ION_SECURE_HEAP_PHYS_0          (ION_SECURE_MD_PHYS_0 + ION_SECURE_MD_SIZE_0)
+#define ION_SECURE_HEAP_SIZE_0          (SECURE_HEAP_SIZE_0)
+#define ION_SECURE_HEAP_FLAG_0          (RTK_FLAG_HWIPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0      ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0      ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 loop.max_part=7";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x12000000 0x09400000>; /* offset 288MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+				ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+				>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv.dts
new file mode 100644
index 00000000..824ea63
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.atv.dts
@@ -0,0 +1,208 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x08700000) // 135M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x09000000) // 144M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 loop.max_part=7";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.dts
new file mode 100644
index 00000000..a565f83
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-1GB.dts
@@ -0,0 +1,193 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
+&powerkey {
+	status = "okay";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-ab.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-ab.dts
new file mode 100644
index 00000000..3830b57
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-ab.dts
@@ -0,0 +1,190 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait,slotselect";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait,slotselect";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee.dts
new file mode 100644
index 00000000..fe48bc0
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb-tee.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-2GB-tee.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB_AVB";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb.dts
new file mode 100644
index 00000000..597261a
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1395-lionskin-2GB.dts"
+#include "rtd-139x-avb.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB_AVB";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee-vmx.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee-vmx.dts
new file mode 100755
index 00000000..6f71523
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee-vmx.dts
@@ -0,0 +1,180 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-139x-ion-2GB-tee-vmx.dtsi"
+#include "rtd-1395-lionskin.dtsi"
+
+
+/ {
+    model= "Realtek_Lion_Skin_2GB";
+    model_hex= <0x00000573>;
+
+    /*
+     * NOTE:
+     * <flag size base>
+     * flag: reserved
+     * size: unit is byte
+     * base: unit is byte
+     *
+     * Array size not over 8;
+     * You may change the max array size in KConfig,
+     * max CMA array size is CONFIG_CMA_AREAS+1.
+     *
+     * If cma-region-enable is enabled<1>,
+     * kernel driver will use cma-region-info to initial CMA memory.
+     *
+     * If cma-region-enable is disabled<0>,
+     * kernel driver will use cma= to initial CMA memory.
+     *
+     * if both setting is loaded, cma-region-info had higher priority.
+     */
+
+    chosen {
+        linux,initrd-start = <ROOTFS_NORMAL_START>;
+        linux,initrd-end = <ROOTFS_NORMAL_END>;
+        bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc androidboot.vmx=ultra loglevel=4";
+        swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+        swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+        cma-region-enable = <1>;
+        cma-region-info = <0x00000000 0x02000000 0x20000000>;
+        /*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+    };
+
+    memory@0 {
+        device_type = "memory";
+        reg = <0 0x80000000>; /* 2048 MB */
+    };
+
+    firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+        optee {
+            compatible = "linaro,optee-tz";
+            method = "smc";
+        };
+    };
+
+    reserved-memory {
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        rbus@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "rbus";
+            reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+            rtk_rbus_barrier_flag;
+        };
+
+        common@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "common";
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+
+        ringbuf@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "ringbuf";
+            reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+        };
+
+        tee_reserved: tee {
+            no-map;
+            size = <0x04100000>;
+            alloc-ranges = <TEE_OS_PHYS TEE_OS_SIZE>;
+        }; 
+    };
+
+    rtk_avcpu {
+        compatible = "Realtek,rtk-avcpu";
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        crt@0 {
+            reg = <0x98000000 0x200000>;
+        };
+
+        rpc@0 {
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+    };
+
+    rtk,ion {
+        compatible = "Realtek,rtk-ion";
+        #address-cells = <1>;
+        #size-cells = <0>;
+
+        rtk,ion-heap@0 { /* SYSTEM_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <0>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@1 { /* System contig */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <1>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@4 { /* DMA_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <4>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@8 { /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                ION_AUDIO_HEAP_PHYS_0
+                ION_AUDIO_HEAP_SIZE_0
+                ION_AUDIO_HEAP_FLAG_0>;
+        };
+
+        rtk,ion-heap@7 { /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+                ION_MEDIA_HEAP_PHYS_0
+                ION_MEDIA_HEAP_SIZE_0
+                ION_MEDIA_HEAP_FLAG_0
+                ION_MEDIA_HEAP_PHYS_1
+                ION_MEDIA_HEAP_SIZE_1
+                ION_MEDIA_HEAP_FLAG_1>;
+        };
+    };
+
+    rtk-fb {
+        compatible = "Realtek,rtk-fb";
+        buffer-cnt = <3>;
+        resolution = <1920 1080>;
+        fps = <60>;
+    };
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee.dts
new file mode 100644
index 00000000..802441d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-tee.dts
@@ -0,0 +1,195 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-139x-ion-2GB-tee.dtsi"
+#include "rtd-1395-lionskin.dtsi"
+
+
+/ {
+    model= "Realtek_Lion_Skin_2GB";
+    model_hex= <0x00000573>;
+
+    /*
+     * NOTE:
+     * <flag size base>
+     * flag: reserved
+     * size: unit is byte
+     * base: unit is byte
+     *
+     * Array size not over 8;
+     * You may change the max array size in KConfig,
+     * max CMA array size is CONFIG_CMA_AREAS+1.
+     *
+     * If cma-region-enable is enabled<1>,
+     * kernel driver will use cma-region-info to initial CMA memory.
+     *
+     * If cma-region-enable is disabled<0>,
+     * kernel driver will use cma= to initial CMA memory.
+     *
+     * if both setting is loaded, cma-region-info had higher priority.
+     */
+
+    chosen {
+        linux,initrd-start = <ROOTFS_NORMAL_START>;
+        linux,initrd-end = <ROOTFS_NORMAL_END>;
+        bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 loop.max_part=7";
+        swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+        swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+        cma-region-enable = <1>;
+        cma-region-info = <0x00000000 0x02000000 0x20000000>;
+        /*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+    };
+
+    memory@0 {
+        device_type = "memory";
+        reg = <0 0x80000000>; /* 2048 MB */
+    };
+
+    firmware {
+        android {
+            compatible = "android,firmware";
+            fstab {
+                compatible = "android,fstab";
+                system {
+                    compatible = "android,system";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/system";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+                vendor {
+                    compatible = "android,vendor";
+                    dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+                    type = "ext4";
+                    mnt_flags = "ro,noatime";
+                    fsmgr_flags = "wait";
+                };
+            };
+        };
+        optee {
+            compatible = "linaro,optee-tz";
+            method = "smc";
+        };
+    };
+
+    reserved-memory {
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        rbus@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "rbus";
+            reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+            rtk_rbus_barrier_flag;
+        };
+
+        common@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "common";
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+
+        ringbuf@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "ringbuf";
+            reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+        };
+
+        tee_reserved: tee {
+            no-map;
+            size = <0x04100000>;
+            alloc-ranges = <TEE_OS_PHYS TEE_OS_SIZE>;
+        }; 
+    };
+
+    rtk_avcpu {
+        compatible = "Realtek,rtk-avcpu";
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        crt@0 {
+            reg = <0x98000000 0x200000>;
+        };
+
+        rpc@0 {
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+    };
+
+    rtk,ion {
+        compatible = "Realtek,rtk-ion";
+        #address-cells = <1>;
+        #size-cells = <0>;
+
+        rtk,ion-heap@0 { /* SYSTEM_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <0>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@1 { /* System contig */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <1>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@4 { /* DMA_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <4>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@8 { /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                ION_AUDIO_HEAP_PHYS_0
+                ION_AUDIO_HEAP_SIZE_0
+                ION_AUDIO_HEAP_FLAG_0>;
+        };
+
+        rtk,ion-heap@7 { /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+                ION_MEDIA_HEAP_PHYS_0
+                ION_MEDIA_HEAP_SIZE_0
+                ION_MEDIA_HEAP_FLAG_0
+                ION_MEDIA_HEAP_PHYS_1
+                ION_MEDIA_HEAP_SIZE_1
+                ION_MEDIA_HEAP_FLAG_1>;
+        };
+    };
+
+    rtk-fb {
+        compatible = "Realtek,rtk-fb";
+        buffer-cnt = <3>;
+        resolution = <1920 1080>;
+        fps = <60>;
+    };
+};
+
+/*
+ * Enable audio-in device. Since gpio_2 is required by i2s_out_4pins,
+ * remove scpu_ejtag_pins_loc_0 of pinctrl-0 in the pinctrl node.
+ */
+&pinctrl {
+	pinctrl-0 =
+		<&spdif_pins>,
+		<&rtc_pins>,
+		<&prob0_pins>,
+		<&prob1_pins>;
+};
+&audio_in {
+	status = "okay";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-verity.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-verity.dts
new file mode 100644
index 00000000..fca91ba
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-verity.dts
@@ -0,0 +1,190 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait,verify=/dev/block/platform/98012000.emmc/by-name/verify";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-xendom0.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-xendom0.dts
new file mode 100644
index 00000000..8fc4031
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB-xendom0.dts
@@ -0,0 +1,220 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-139x-xen.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+	compatible = "Realtek,rtd-1395";
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		#address-cells = <0x1>;
+		#size-cells = <0x1>;
+		bootargs = "console=dtuart dtuart=serial0 dom0_mem=256MB dom0_max_vcpus=2 sync_console=true";
+
+		module@04000000 {
+			compatible = "xen,linux-zimage", "xen,multiboot-module";
+			reg = <0x04000000 0x01100000>;
+			bootargs = "console=hvc0 debug loglevel=4 swiotlb=512";
+		};
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	rtk_xen_mempool@0 {
+		reg = <0x0 0x6c000000>;
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	/* no need of ion under normal dom0 */
+	/*
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 {
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 {
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 {
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 {
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 {
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+	*/
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+		status = "disabled";
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+        dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+                compatible = "Realtek,dwc3";
+		usbhost_backend;
+                status = "disabled";
+        };
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB.MEMTEST.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB.MEMTEST.dts
new file mode 100644
index 00000000..4e1d233
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB.MEMTEST.dts
@@ -0,0 +1,191 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ (0x22000000) (0x20000000);
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB.dts
new file mode 100644
index 00000000..1e5c5ac
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-2GB.dts
@@ -0,0 +1,199 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4 loop.max_part=7";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
+&powerkey {
+	status = "okay";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-384MB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-384MB.CMAx2.dts
new file mode 100644
index 00000000..8418cfd
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-384MB.CMAx2.dts
@@ -0,0 +1,200 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ 0x10100000  MEDIA_REQ_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_384MB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x18000000>; /* 384 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+/*
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x04000000>; 
+*/
+/* size 64MB; size were 60MB in 1GB.dts */
+/*
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x04000000>; 
+*/
+/* offset 273MB, size 64MB */
+/*
+			linux,contiguous-region;
+		};
+*/
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x15000000 0x00800000>; /* offset 337MB, size 8MB, after CMA1 */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+0x10100000 MEDIA_REQ_SIZE_1 ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+};
\ No newline at end of file
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-512MB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-512MB.CMAx2.dts
new file mode 100644
index 00000000..14bc630
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-512MB.CMAx2.dts
@@ -0,0 +1,192 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_512MB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x20000000>; /* 512 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x1a400000 0x00800000>; /* offset 420MB, size 8MB, after CMA1 */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1280 720>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+};
\ No newline at end of file
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-1GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-1GB.dts
new file mode 100644
index 00000000..1856df3
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-1GB.dts
@@ -0,0 +1,177 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0b800000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB-tee.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB-tee.dts
new file mode 100644
index 00000000..333e29c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB-tee.dts
@@ -0,0 +1,159 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+
+#include "rtd-139x-ion-2GB-tee.dtsi"
+#include "rtd-1395-lionskin.dtsi"
+
+
+/ {
+    model= "Realtek_Lion_Skin_2GB";
+    model_hex= <0x00000573>;
+
+    /*
+     * NOTE:
+     * <flag size base>
+     * flag: reserved
+     * size: unit is byte
+     * base: unit is byte
+     *
+     * Array size not over 8;
+     * You may change the max array size in KConfig,
+     * max CMA array size is CONFIG_CMA_AREAS+1.
+     *
+     * If cma-region-enable is enabled<1>,
+     * kernel driver will use cma-region-info to initial CMA memory.
+     *
+     * If cma-region-enable is disabled<0>,
+     * kernel driver will use cma= to initial CMA memory.
+     *
+     * if both setting is loaded, cma-region-info had higher priority.
+     */
+
+    chosen {
+        linux,initrd-start = <ROOTFS_NORMAL_START>;
+        linux,initrd-end = <ROOTFS_NORMAL_END>;
+        bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+        swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+        swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+        cma-region-enable = <1>;
+        cma-region-info = <0x00000000 0x02000000 0x20000000>;
+        /*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+    };
+
+    memory@0 {
+        device_type = "memory";
+        reg = <0 0x80000000>; /* 2048 MB */
+    };
+
+    firmware {
+        optee {
+            compatible = "linaro,optee-tz";
+            method = "smc";
+        };
+    };
+
+    reserved-memory {
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        rbus@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "rbus";
+            reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+            rtk_rbus_barrier_flag;
+        };
+
+        common@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "common";
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+
+        ringbuf@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "ringbuf";
+            reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+        };
+
+        tee_reserved: tee {
+            no-map;
+            size = <0x04100000>;
+            alloc-ranges = <TEE_OS_PHYS TEE_OS_SIZE>;
+        }; 
+    };
+
+    rtk_avcpu {
+        compatible = "Realtek,rtk-avcpu";
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        crt@0 {
+            reg = <0x98000000 0x200000>;
+        };
+
+        rpc@0 {
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+    };
+
+    rtk,ion {
+        compatible = "Realtek,rtk-ion";
+        #address-cells = <1>;
+        #size-cells = <0>;
+
+        rtk,ion-heap@0 { /* SYSTEM_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <0>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@1 { /* System contig */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <1>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@4 { /* DMA_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <4>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@8 { /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                ION_AUDIO_HEAP_PHYS_0
+                ION_AUDIO_HEAP_SIZE_0
+                ION_AUDIO_HEAP_FLAG_0>;
+        };
+
+        rtk,ion-heap@7 { /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+                ION_MEDIA_HEAP_PHYS_0
+                ION_MEDIA_HEAP_SIZE_0
+                ION_MEDIA_HEAP_FLAG_0
+                ION_MEDIA_HEAP_PHYS_1
+                ION_MEDIA_HEAP_SIZE_1
+                ION_MEDIA_HEAP_FLAG_1>;
+        };
+    };
+
+    rtk-fb {
+        compatible = "Realtek,rtk-fb";
+        buffer-cnt = <3>;
+        resolution = <1920 1080>;
+        fps = <60>;
+    };
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB.dts
new file mode 100644
index 00000000..b477f76
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-glinux-2GB.dts
@@ -0,0 +1,190 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-1GB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-1GB.CMAx2.dts
new file mode 100644
index 00000000..56da1ff
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-1GB.CMAx2.dts
@@ -0,0 +1,195 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+        bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x11000000 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x00800000>; /* size 8MB */
+			alignment = <0x00100000>;
+			alloc-ranges = <0x20000000 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+    nand@98010000 { status = "okay"; };
+    emmc@98012000 { status = "disabled"; };
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-1GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-1GB.dts
new file mode 100644
index 00000000..7b0dabe
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-1GB.dts
@@ -0,0 +1,181 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex = <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	nand@98010000 { status = "okay"; };
+	emmc@98012000 { status = "disabled"; };
+	i2c@9801BB00 { status = "disabled"; }; /* i2c_5 */
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-2GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-2GB.dts
new file mode 100644
index 00000000..bddc8ba
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-2GB.dts
@@ -0,0 +1,181 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex = <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+	nand@98010000 { status = "okay"; };
+	emmc@98012000 { status = "disabled"; };
+	i2c@9801BB00 { status = "disabled"; }; /* i2c_5 */
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-1GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-1GB.dts
new file mode 100644
index 00000000..62ddb8c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-1GB.dts
@@ -0,0 +1,180 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0b800000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex = <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+        bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+    nand@98010000 { status = "okay"; };
+    emmc@98012000 { status = "disabled"; };
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-2GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-2GB.dts
new file mode 100644
index 00000000..0185d7f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-nand-glinux-2GB.dts
@@ -0,0 +1,180 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-lionskin.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_2GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+        bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=kylin androidboot.storage=emmc loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		interrupts = <0 34 4>;
+	};
+
+    nand@98010000 { status = "okay"; };
+    emmc@98012000 { status = "disabled"; };
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-xenott.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-xenott.CMAx2.dts
new file mode 100644
index 00000000..400c35e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-xenott.CMAx2.dts
@@ -0,0 +1,642 @@
+/dts-v1/;
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include <dt-bindings/clock/rtk,clock-rtd139x.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <dt-bindings/reset/rtk,reset-rtd139x.h>
+#include <dt-bindings/power/rtk,power-rtd139x.h>
+#include <dt-bindings/soc/rtd139x,memory.h>
+#include "rtd-139x-xen-pinctrl-domu.dtsi"
+#include "rtd-139x-xen-irda-domu.dtsi"
+/* /include/ "rtd-1395-usb-xen-domu.dtsi" */
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+
+/{
+	/* #*cells are here to keep DTC happy */
+	#address-cells = <2>;
+	#size-cells = <2>;
+
+	aliases {
+		serial1 = &uart1;
+		i2c1 = &i2c_1;
+		hwsem0 = &sb2_lock1;
+		hwsem1 = &sb2_lock2;
+	};
+
+	/*
+	 * Do not add other settings here other than CMA info since XEN only
+	 * bypass CMA properties
+	 */
+	chosen {
+		compatible = "Realtek,rtk1395-cma_info", "Realtek,DomU-cma_info";
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+	};
+
+        reserved-memory {
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0x0 0x09400000>; /* size 148MB; size were 60MB in 1GB.dts */
+			alignment = <0x0 0x00100000>;
+			alloc-ranges = <0x0 0x11000000 0x0 0x09400000>; /* offset 272MB, size 148MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x0 0x00800000>; /* size 8MB */
+			alignment = <0x0 0x00100000>;
+			alloc-ranges = <0x0 0x20000000 0x0 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		phys_resv@0 {
+			reg = <0x0 SYS_BOOTCODE_MEMBASE 0x0 SYS_BOOTCODE_MEMSIZE>,
+			      <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>,
+			      <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>,
+			      <0x0 ACPU_IDMEM_PHYS 0x0 ACPU_IDMEM_SIZE>,
+			      <0x0 ION_MEDIA_HEAP_PHYS_0 0x0 ION_MEDIA_HEAP_SIZE_0>,
+			      <0x0 ION_AUDIO_HEAP_PHYS_0 0x0 ION_AUDIO_HEAP_SIZE_0>;
+		};
+        };
+
+	passthrough {
+		compatible = "simple-bus";
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		sb2_lock0: sb2-lock@9801A000 {
+			compatible = "realtek,sb2-sem";
+			reg = <0x0 0x9801A000 0x0 0x4>;
+		};
+
+		sb2_lock1: sb2-lock@9801A620 {
+			compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+			reg = <0x0 0x9801A620 0x0 0x4>;
+		};
+
+		sb2_lock2: sb2-lock@9801A624 {
+			compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+			reg = <0x0 0x9801A624 0x0 0x4>;
+		};
+
+		/* fixed clock */
+		osc27M: osc27M {
+			compatible = "fixed-clock";
+			#clock-cells = <0>;
+			clock-frequency = <27000000>;
+			clock-output-names = "osc27M";
+		};
+
+		/* mmio */
+		crt_mmio: mmio@98000000 {
+			compatible = "realtek,mmio";
+			reg = <0x0 0x98000000 0x0 0x600>;
+			realtek,sb2-lock = <&sb2_lock0>;
+		};
+
+		iso_mmio: mmio@98007088 {
+			compatible = "realtek,mmio";
+			reg = <0x0 0x98007088 0x0 0x8>;
+			realtek,sb2-lock = <&sb2_lock0>;
+		};
+
+		/* clock-controller */
+		clk_en_1: clk-en@9800000c {
+			compatible = "realtek,clock-gate-controller";
+			reg = <0x0 0x9800000c 0x0 0x4>;
+			#clock-cells = <1>;
+			realtek,mmio = <&crt_mmio 0xc>;
+			clock-output-names =
+			/* 0 ~ 7 */	"clk_en_misc",      "clk_en_pcie0",
+					"",                 "clk_en_gspi",
+					"",                 "",
+					"clk_en_iso_misc",  "clk_en_sds",
+			/* 8 ~ 15 */	"clk_en_hdmi",      "",
+					"",                 "",
+					"",                 "",
+					"",                 "",
+			/* 16 ~ 23 */	"clk_en_lsadc",     "clk_en_se",
+					"",                 "clk_en_cp",
+					"clk_en_md",        "clk_en_tp",
+					"clk_en_rsa",       "clk_en_nf",
+			/* 24 ~ 31 */	"clk_en_emmc",      "clk_en_cr",
+					"clk_en_sdio_ip",   "clk_en_mipi",
+					"clk_en_emmc_ip",   "",
+					"clk_en_sdio",      "clk_en_sd_ip";
+			ignore-unused-clocks =
+				"clk_en_misc",
+				"clk_en_iso_misc",
+				"clk_en_cp",
+				"clk_en_md",
+				"clk_en_tp",
+				"clk_en_hdmi",
+				"clk_en_pcie0",
+				"clk_en_emmc",
+				"clk_en_emmc_ip";
+			ignore-pm-clocks =
+				"clk_en_hdmi";
+		};
+
+		clk_en_2: clk-en@98000010 {
+			compatible = "realtek,clock-gate-controller";
+			reg = <0x0 0x98000010 0x0 0x4>;
+			#clock-cells = <1>;
+			realtek,mmio = <&crt_mmio 0x10>;
+			clock-output-names =
+			/* 0 ~ 7 */	"",                 "clk_en_misc_i2c_5",
+					"",		    "clk_en_jpeg",
+					"",                 "",
+					"clk_en_misc_sc",   "",
+			/* 8 ~ 15 */	"",                 "",
+					"",                 "",
+					"",                 "",
+					"",                 "",
+			/* 16 ~ 23 */	"",                 "",
+					"",                 "",
+					"",                 "",
+					"",                 "",
+			/* 24 ~ 31 */	"",                 "clk_en_hse",
+					"",                 "clk_en_ur2",
+					"clk_en_ur1",       "clk_en_fan",
+					"clk_en_dcphy_0",   "clk_en_dcphy_1";
+			ignore-unused-clocks =
+				"clk_en_dcphy_0",
+				"clk_en_dcphy_1";
+		};
+
+		iclk_en: clk-en@9800708c {
+			compatible = "realtek,clock-gate-controller";
+			reg = <0x0 0x9800708c 0x0 0x4>;
+			#clock-cells = <1>;
+			realtek,mmio = <&iso_mmio 0x4>;
+			clock-output-names =
+			/* 0 ~ 7 */	"",                  "",
+					"clk_en_misc_cec0",  "clk_en_cbusrx_sys",
+					"clk_en_cbustx_sys", "clk_en_cbus_sys",
+					"clk_en_cbus_osc",   "clk_en_misc_ir",
+			/* 8 ~ 15 */	"clk_en_ur0",        "clk_en_i2c0",
+					"clk_en_i2c1",       "clk_en_etn_250m",
+					"clk_en_etn_sys",    "clk_en_usb_drd",
+					"clk_en_usb_host_0", "clk_en_usb_host_1",
+			/* 16 */	"clk_en_usb";
+			ignore-unused-clocks = 
+				"clk_en_ur0",
+				"clk_en_i2c0",
+				"clk_en_etn_250m",
+				"clk_en_etn_sys",
+				"clk_en_usb_drd",
+				"clk_en_usb_host_0",
+				"clk_en_usb_host_1",
+				"clk_en_usb";
+		};
+
+		cc: clock-controller@98000000 {
+			compatible = "realtek,clock-controller";
+			reg = <0x0 0x98000000 0x0 0x600>;
+			#clock-cells = <1>;
+			realtek,mmio = <&crt_mmio 0x0>;
+			invalid-clocks =
+				"pll_ddsa",
+				"pll_ddsb";
+		};
+
+		/* reset-controller */
+		rst1: soft-reset@98000000 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000000 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x0>;
+			#reset-cells = <1>;
+			pm-ignore-bits = <0x00001000>;
+		};
+
+		rst2: soft-reset@98000004 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000004 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x4>;
+			#reset-cells = <1>;
+		};
+
+		rst3: soft-reset@98000008 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000008 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x8>;
+			#reset-cells = <1>;
+		};
+
+		rst4: soft-reset@98000050 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000050 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x50>;
+			#reset-cells = <1>;
+		};
+
+		irst: soft-reset@98007088 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98007088 0x0 0x4>;
+			realtek,mmio = <&iso_mmio 0x0>;
+			#reset-cells = <1>;
+		};
+
+		iasr: usb-async-soft-reset@98007088 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98007088 0x0 0x4>;
+			realtek,mmio = <&iso_mmio 0x0>;
+			#reset-cells = <1>;
+			async-group = <0>;
+		};
+
+		pd0: power-controller@98007000 {
+			compatible = "realtek,rtd139x-power-controller", "simple-bus";
+			reg = <0x0 0x98007000 0x0 0x1000>;
+			resets = <&rst1 RSTN_VE1>, <&rst1 RSTN_VE2>;
+			reset-names = "ve1", "ve2";
+			#power-domain-cells = <1>;
+		};
+
+		rfkill: rfkilligpio {
+			compatible = "Realtek,rfkill";
+			gpios = <&rtk_iso_gpio 28 1 0>; /*bt power , output, default low */
+		};
+
+		rtk,ion {
+			compatible = "Realtek,rtk-ion";
+			#address-cells = <1>;
+			#size-cells = <0>;
+
+			rtk,ion-heap@0 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <0>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@1 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <1>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@4 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <4>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@8 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <8>;
+				rtk,memory-reserve = <
+					ION_AUDIO_HEAP_PHYS_0
+					ION_AUDIO_HEAP_SIZE_0
+					ION_AUDIO_HEAP_FLAG_0>;
+			};
+
+			rtk,ion-heap@7 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <7>;
+				rtk,memory-reserve = <
+					ION_MEDIA_HEAP_PHYS_0
+					ION_MEDIA_HEAP_SIZE_0
+					ION_MEDIA_HEAP_FLAG_0>;
+			};
+		}; /* rtk,ion */
+
+		rbus@98000000 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		md@9800b000 {
+			compatible = "realtek,md";
+			reg = <0x0 0x9800b000 0x0 0x1000>;
+			interrupts = <0 38 4>;
+			clocks = <&clk_en_1 CLK_EN_MD>;
+			resets = <&rst1 RSTN_MD>;
+		};
+
+		se@9800c000 {
+			compatible = "realtek,se";
+			reg = <0x0 0x9800c000 0x0 0x1000>;
+			interrupts = <0 20 4>;
+			clocks = <&clk_en_1 CLK_EN_SE>;
+			resets = <&rst1 RSTN_SE>;
+		};
+
+		rpc@9801a104 {
+			compatible = "Realtek,rtk-rpc";
+			reg = <0x0 0x9801a104 0x0 0xc>, /* rpc intr en */
+			      <0x0 0x01ffe000 0x0 0x4000>, /* rpc ring buffer */
+			      <0x0 0x0002f000 0x0 0x1000>, /* rpc common */
+			      <0x0 0x9801a020 0x0 0x4>; /* rbus sync */
+			interrupts = <0 33 4>;
+		};
+
+		refclk@9801b540 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x9801b000 0x0 0x1000>;
+		};
+
+		pinctrl: pinctrl@9804E000 {
+			compatible = "realtek,rtk139x-pinctrl";
+			reg = <0x0 0x9804E000 0x0 0x86>;
+			#gpio-range-cells = <3>;
+			pinctrl-names = "default";
+			/* pinctrl-0 = ; */
+			status = "okay";
+		};
+
+		mux_intc: intc@9801B000 {
+			compatible = "Realtek,rtk-irq-mux";
+			Realtek,mux-nr = <2>;
+			#interrupt-cells = <2>;
+			interrupt-controller;
+			reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP */
+			      <0x0 0x98007000 0x0 0x100>; /* MISC_ISO */
+			interrupts = <0 40 4>, <0 41 4>;
+			intr-status = <0xc>, <0x0>;
+			intr-en = <0x80>, <0x40>;
+			status = "okay";
+		};
+
+		rtk_iso_gpio: rtk_iso_gpio@98007100 {
+			compatible = "realtek,rtk139x-iso-gpio-irq-mux";
+			gpio-controller;
+			#gpio-cells = <3>;
+			Realtek,gpio_base = <0>;
+			Realtek,gpio_numbers = <57>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+			reg = <0x0 0x98007000 0x0 0x100>,
+			      <0x0 0x98007100 0x0 0x100>; /* ISO_SYS ISO_GPIO*/
+			gpio-ranges = <&pinctrl 0 0 57>;
+			status = "okay";
+		};
+
+		hdmitx@9800D000 {
+			compatible = "realtek,rtd129x-hdmitx";
+			reg = <0x0 0x9800d000 0x0 0x560>, /* HDMITX */
+			      <0x0 0x98007200 0x0 0x4>; /* I2C1_REQ_CTRL */
+			gpio-hpd-detect = <&rtk_iso_gpio 7 0 0>; /* Hotplug detect pin */
+			clocks = <&clk_en_1 CLK_EN_HDMI>;
+			clock-names = "clk_en_hdmi";
+			resets = <&rst1 RSTN_HDMI>;
+			reset-names = "rstn_hdmi";
+
+			scdc_rr {
+				enable-scdc-rr = <0>;
+				interrupt-parent = <&mux_intc>;
+				#interrupt-cells = <1>;
+				interrupt-controller;
+				interrupts = <1 31>;
+			};
+		};
+
+		hdcptx@9800D000 {
+			compatible = "realtek,rtk139x-hdcptx";
+			reg = <0x0 0x9800d000 0x0 0x400>;
+			interrupts = <0 31 4>; /*gen Ri*/
+		};
+
+		sd: sdmmc@98010400 {
+			compatible = "Realtek,rtk1295-sdmmc";
+			gpios = <&rtk_iso_gpio 30 1 0>, /*sd power , output, default high  (poweroff) */
+			        <&rtk_iso_gpio 34 0 1>,
+			        <&rtk_iso_gpio 35 0 1>;
+			reg = <0x0 0x98000000 0x0 0x400>, /* CRT */
+			      <0x0 0x98010400 0x0 0x200>, /* SDMMC */
+			      <0x0 0x9801A000 0x0 0x400>, /* BS2 */
+			      <0x0 0x9804E000 0x0 0x40>, /* ISO */
+			      <0x0 0x98010A00 0x0 0x40>, /* SDIO */
+			      <0x0 0x98007000 0x0 0x200>;
+			interrupts = <0 44 4>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&sdcard_pins_low>;
+			            /*<&sdcard_pins_high>;*/
+			clocks = <&clk_en_1 CLK_EN_CR>,
+			        <&clk_en_1 CLK_EN_SD_IP>;
+			clock-names = "cr",
+			        "sd_ip";
+			resets = <&rst2 RSTN_CR>;
+		};
+
+		gpu: gpu@981d0000 {
+			compatible = "arm,mali-470", "arm,mali-utgard";
+			reg = <0x0 0x981D0000 0x0 0x30000>;
+			interrupts =
+				<0 75 4>, <0 76 4>,
+				<0 77 4>, <0 78 4>,
+				<0 79 4>, <0 80 4>,
+				<0 81 4>, <0 82 4>,
+				<0 83 4>, <0 84 4>,
+				<0 85 4>, <0 86 4>;
+			interrupt-names =
+				"IRQPP0", "IRQPPMMU0",
+				"IRQPP1", "IRQPPMMU1",
+				"IRQPP2", "IRQPPMMU2",
+				"IRQPP3", "IRQPPMMU3",
+				"IRQGP", "IRQGPMMU",
+				"IRQPMU", "IRQPP";
+			power-domains = <&pd0 RTD139X_PD_GPU>;
+			pmu_domain_config = <0x1 0x1 0x2 0x4 0x8 0x0 0x0 0x0 0x0 0x0 0x1 0x0>;
+			pmu_switch_delay = <0xff>;
+			clocks = <&cc CC_CLK_GPU>;
+			clock-names = "clk_mali";
+			resets = <&rst1 RSTN_GPU>;
+		};
+
+		pu_pll@98000000 {
+			compatible = "Realtek,rtk1295-pu_pll";
+			reg = <0x0 0x98000000 0x0 0x200>;
+		};
+
+		jpeg: jpeg@9803e000 {
+			compatible = "Realtek,rtk1295-jpeg";
+			reg = <0x0 0x9803e000 0x0 0x1000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 52 4>;
+			clocks = <&clk_en_2 CLK_EN_JPEG>;
+			clock-names = "jpeg";
+			resets = <&rst2 RSTN_JPEG>;
+		};
+
+		ve1: ve1@98040000 {
+			compatible = "Realtek,rtk1295-ve1";
+			reg = <0x0 0x98040000 0x0 0x8000>,
+			      <0x0 0x98008000 0x0 0x1000>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 53 4>, <0 54 4>;
+			clocks = <&cc CC_CLK_VE1>,
+			         <&cc CC_CLK_VE2>,
+			         <&cc CC_CLK_VE2_BPU>,
+			         <&cc CC_CLK_SYSH>,
+			         <&cc CC_PLL_VE1>,
+			         <&cc CC_PLL_VE2>;
+			clock-names = "clk_ve1",
+			              "clk_ve2",
+			              "clk_ve2_bpu",
+			              "clk_sysh",
+			              "pll_ve1",
+			              "pll_ve2";
+			resets = <&rst1 RSTN_VE1>,
+			         <&rst1 RSTN_VE2>;
+			reset-names = "ve1",
+			              "ve2";
+			assigned-clocks = <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>, <&cc CC_CLK_VE2_BPU>;
+			assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>, <&cc CC_PLL_VE1>;
+			assigned-clock-rates = <550000000>, <715000000>, <550000000>;
+		};
+
+		rtk-fb {
+			compatible = "Realtek,rtk-fb";
+			buffer-cnt = <3>;
+			resolution = <1920 1080>;
+			fps = <60>;
+		};
+
+		irda@98007400 {
+			compatible = "Realtek,rtk-irda";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x98007000 0x0 0x400>,
+			      <0x0 0x98007400 0x0 0x100>;
+			interrupts = <1 5>;
+			resets = <&irst IRSTN_IR>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&ir_rx_pins>;
+			clocks = <&iclk_en CLK_EN_MISC_IR>;
+		};
+
+		i2c_1: i2c@0x98007C00 {
+			compatible = "Realtek,rtk-i2c";
+			reg = <0x0 0x98007C00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <1 11>;
+			i2c-num = <1>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&i2c_pins_1>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&iclk_en CLK_EN_I2C1>;
+			resets = <&irst IRSTN_I2C_1>;
+		};
+
+		uart1: serial1@9801B200 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B200 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x8>;
+			interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&uart1_pins>;
+			clocks = <&clk_en_2 CLK_EN_UR1>;
+			resets = <&rst2 RSTN_UR1>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		uart2: serial2@9801B400 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B400 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x100>;
+			interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			clocks = <&clk_en_2 CLK_EN_UR2>;
+			resets = <&rst2 RSTN_UR2>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		hse: hse@98005000 {
+			compatible = "realtek,hse";
+			reg = <0x0 0x98005000 0x0 0x1000>;
+			interrupts = <0 7 4>, <0 27 4>;
+			clocks = <&clk_en_2 CLK_EN_HSE>;
+			resets = <&rst1 RSTN_HSE>;
+		};
+
+		dvfs: cpu-dvfs {
+			compatible = "realtek,dummy-dvfs";
+			clocks = <&cc CC_PLL_SCPU>;
+			operating-points-v2 = <&cpu_opps>;
+			status ="okay";
+		};
+
+		cpu_tm: thermal-sensor@9801D150 {
+			compatible = "realtek,rtd139x-thermal-sensor";
+			reg = <0 0x9801D150 0 0x1C>;
+			#thermal-sensor-cells = <0>;
+			status = "okay";
+		};
+
+		thermal-zones {
+			cpu_thermal: cpu-thermal {
+				polling-delay-passive = <250>;
+				polling-delay = <1000>;
+				thermal-sensors = <&cpu_tm>;
+
+				trips {
+					cpu_crit: cpu-crit {
+						temperature = <130000>;
+						hysteresis = <0>;
+						type = "critical";
+					};
+				};
+				cooling-maps {
+				};
+			};
+		};
+
+		xencec {
+			compatible = "xen,cec";
+			module-enable = <1>;
+			status = "okay";
+		};
+
+	}; /* passthrough */
+};
+
+#include "rtd-139x-dvfs-xenott.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-xenott.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-xenott.dts
new file mode 100644
index 00000000..88cfb5e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-xenott.dts
@@ -0,0 +1,632 @@
+/dts-v1/;
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include <dt-bindings/clock/rtk,clock-rtd139x.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <dt-bindings/reset/rtk,reset-rtd139x.h>
+#include <dt-bindings/power/rtk,power-rtd139x.h>
+#include <dt-bindings/soc/rtd139x,memory.h>
+#include "rtd-139x-xen-pinctrl-domu.dtsi"
+#include "rtd-139x-xen-irda-domu.dtsi"
+#include "rtd-1395-usb-xen-domu.dtsi"
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+
+/{
+	/* #*cells are here to keep DTC happy */
+	#address-cells = <2>;
+	#size-cells = <2>;
+
+	aliases {
+		serial1 = &uart1;
+		i2c1 = &i2c_1;
+		hwsem0 = &sb2_lock1;
+		hwsem1 = &sb2_lock2;
+	};
+
+	/*
+	 * Do not add other settings here other than CMA info since XEN only
+	 * bypass CMA properties
+	 */
+	chosen {
+		compatible = "Realtek,rtk1395-cma_info", "Realtek,DomU-cma_info";
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+	};
+
+        reserved-memory {
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+                rbus@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "rbus";
+                        reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+                        rtk_rbus_barrier_flag;
+                };
+
+                common@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "common";
+                        reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+                };
+
+                ringbuf@0 {
+                        compatible = "rsvmem-remap";
+                        save_remap_name = "ringbuf";
+                        reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+                };
+
+		phys_resv@0 {
+			reg = <0x0 SYS_BOOTCODE_MEMBASE 0x0 SYS_BOOTCODE_MEMSIZE>,
+			      <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>,
+			      <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>,
+			      <0x0 ACPU_IDMEM_PHYS 0x0 ACPU_IDMEM_SIZE>,
+			      <0x0 ION_MEDIA_HEAP_PHYS_0 0x0 ION_MEDIA_HEAP_SIZE_0>,
+			      <0x0 ION_AUDIO_HEAP_PHYS_0 0x0 ION_AUDIO_HEAP_SIZE_0>,
+			      <0x0 ION_MEDIA_HEAP_PHYS_1 0x0 ION_MEDIA_HEAP_SIZE_1>;
+		};
+        };
+
+	passthrough {
+		compatible = "simple-bus";
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		sb2_lock0: sb2-lock@9801A000 {
+			compatible = "realtek,sb2-sem";
+			reg = <0x0 0x9801A000 0x0 0x4>;
+		};
+
+		sb2_lock1: sb2-lock@9801A620 {
+			compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+			reg = <0x0 0x9801A620 0x0 0x4>;
+		};
+
+		sb2_lock2: sb2-lock@9801A624 {
+			compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+			reg = <0x0 0x9801A624 0x0 0x4>;
+		};
+
+		/* fixed clock */
+		osc27M: osc27M {
+			compatible = "fixed-clock";
+			#clock-cells = <0>;
+			clock-frequency = <27000000>;
+			clock-output-names = "osc27M";
+		};
+
+		/* mmio */
+		crt_mmio: mmio@98000000 {
+			compatible = "realtek,mmio";
+			reg = <0x0 0x98000000 0x0 0x600>;
+			realtek,sb2-lock = <&sb2_lock0>;
+		};
+
+		iso_mmio: mmio@98007088 {
+			compatible = "realtek,mmio";
+			reg = <0x0 0x98007088 0x0 0x8>;
+			realtek,sb2-lock = <&sb2_lock0>;
+		};
+
+		/* clock-controller */
+		clk_en_1: clk-en@9800000c {
+			compatible = "realtek,clock-gate-controller";
+			reg = <0x0 0x9800000c 0x0 0x4>;
+			#clock-cells = <1>;
+			realtek,mmio = <&crt_mmio 0xc>;
+			clock-output-names =
+			/* 0 ~ 7 */	"clk_en_misc",      "clk_en_pcie0",
+					"",                 "clk_en_gspi",
+					"",                 "",
+					"clk_en_iso_misc",  "clk_en_sds",
+			/* 8 ~ 15 */	"clk_en_hdmi",      "",
+					"",                 "",
+					"",                 "",
+					"",                 "",
+			/* 16 ~ 23 */	"clk_en_lsadc",     "clk_en_se",
+					"",                 "clk_en_cp",
+					"clk_en_md",        "clk_en_tp",
+					"clk_en_rsa",       "clk_en_nf",
+			/* 24 ~ 31 */	"clk_en_emmc",      "clk_en_cr",
+					"clk_en_sdio_ip",   "clk_en_mipi",
+					"clk_en_emmc_ip",   "",
+					"clk_en_sdio",      "clk_en_sd_ip";
+			ignore-unused-clocks =
+				"clk_en_misc",
+				"clk_en_iso_misc",
+				"clk_en_cp",
+				"clk_en_md",
+				"clk_en_tp",
+				"clk_en_hdmi",
+				"clk_en_pcie0",
+				"clk_en_emmc",
+				"clk_en_emmc_ip";
+			ignore-pm-clocks =
+				"clk_en_hdmi";
+		};
+
+		clk_en_2: clk-en@98000010 {
+			compatible = "realtek,clock-gate-controller";
+			reg = <0x0 0x98000010 0x0 0x4>;
+			#clock-cells = <1>;
+			realtek,mmio = <&crt_mmio 0x10>;
+			clock-output-names =
+			/* 0 ~ 7 */	"",                 "clk_en_misc_i2c_5",
+					"",		    "clk_en_jpeg",
+					"",                 "",
+					"clk_en_misc_sc",   "",
+			/* 8 ~ 15 */	"",                 "",
+					"",                 "",
+					"",                 "",
+					"",                 "",
+			/* 16 ~ 23 */	"",                 "",
+					"",                 "",
+					"",                 "",
+					"",                 "",
+			/* 24 ~ 31 */	"",                 "clk_en_hse",
+					"",                 "clk_en_ur2",
+					"clk_en_ur1",       "clk_en_fan",
+					"clk_en_dcphy_0",   "clk_en_dcphy_1";
+			ignore-unused-clocks =
+				"clk_en_dcphy_0",
+				"clk_en_dcphy_1";
+		};
+
+		iclk_en: clk-en@9800708c {
+			compatible = "realtek,clock-gate-controller";
+			reg = <0x0 0x9800708c 0x0 0x4>;
+			#clock-cells = <1>;
+			realtek,mmio = <&iso_mmio 0x4>;
+			clock-output-names =
+			/* 0 ~ 7 */	"",                  "",
+					"clk_en_misc_cec0",  "clk_en_cbusrx_sys",
+					"clk_en_cbustx_sys", "clk_en_cbus_sys",
+					"clk_en_cbus_osc",   "clk_en_misc_ir",
+			/* 8 ~ 15 */	"clk_en_ur0",        "clk_en_i2c0",
+					"clk_en_i2c1",       "clk_en_etn_250m",
+					"clk_en_etn_sys",    "clk_en_usb_drd",
+					"clk_en_usb_host_0", "clk_en_usb_host_1",
+			/* 16 */	"clk_en_usb";
+			ignore-unused-clocks = 
+				"clk_en_ur0",
+				"clk_en_i2c0",
+				"clk_en_etn_250m",
+				"clk_en_etn_sys",
+				"clk_en_usb_drd",
+				"clk_en_usb_host_0",
+				"clk_en_usb_host_1",
+				"clk_en_usb";
+		};
+
+		cc: clock-controller@98000000 {
+			compatible = "realtek,clock-controller";
+			reg = <0x0 0x98000000 0x0 0x600>;
+			#clock-cells = <1>;
+			realtek,mmio = <&crt_mmio 0x0>;
+			invalid-clocks =
+				"pll_ddsa",
+				"pll_ddsb";
+		};
+
+		/* reset-controller */
+		rst1: soft-reset@98000000 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000000 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x0>;
+			#reset-cells = <1>;
+			pm-ignore-bits = <0x00001000>;
+		};
+
+		rst2: soft-reset@98000004 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000004 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x4>;
+			#reset-cells = <1>;
+		};
+
+		rst3: soft-reset@98000008 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000008 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x8>;
+			#reset-cells = <1>;
+		};
+
+		rst4: soft-reset@98000050 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000050 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x50>;
+			#reset-cells = <1>;
+		};
+
+		irst: soft-reset@98007088 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98007088 0x0 0x4>;
+			realtek,mmio = <&iso_mmio 0x0>;
+			#reset-cells = <1>;
+		};
+
+		iasr: usb-async-soft-reset@98007088 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98007088 0x0 0x4>;
+			realtek,mmio = <&iso_mmio 0x0>;
+			#reset-cells = <1>;
+			async-group = <0>;
+		};
+
+		pd0: power-controller@98007000 {
+			compatible = "realtek,rtd139x-power-controller", "simple-bus";
+			reg = <0x0 0x98007000 0x0 0x1000>;
+			resets = <&rst1 RSTN_VE1>, <&rst1 RSTN_VE2>;
+			reset-names = "ve1", "ve2";
+			#power-domain-cells = <1>;
+		};
+
+		rfkill: rfkilligpio {
+			compatible = "Realtek,rfkill";
+			gpios = <&rtk_iso_gpio 28 1 0>; /*bt power , output, default low */
+		};
+
+		rtk,ion {
+			compatible = "Realtek,rtk-ion";
+			#address-cells = <1>;
+			#size-cells = <0>;
+
+			rtk,ion-heap@0 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <0>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@1 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <1>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@4 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <4>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@8 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <8>;
+				rtk,memory-reserve = <
+					ION_AUDIO_HEAP_PHYS_0
+					ION_AUDIO_HEAP_SIZE_0
+					ION_AUDIO_HEAP_FLAG_0>;
+			};
+
+			rtk,ion-heap@7 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <7>;
+				rtk,memory-reserve = <
+					ION_MEDIA_HEAP_PHYS_0
+					ION_MEDIA_HEAP_SIZE_0
+					ION_MEDIA_HEAP_FLAG_0
+					ION_MEDIA_HEAP_PHYS_1
+					ION_MEDIA_HEAP_SIZE_1
+					ION_MEDIA_HEAP_FLAG_1>;
+			};
+		}; /* rtk,ion */
+
+		rbus@98000000 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		md@9800b000 {
+			compatible = "realtek,md";
+			reg = <0x0 0x9800b000 0x0 0x1000>;
+			interrupts = <0 38 4>;
+			clocks = <&clk_en_1 CLK_EN_MD>;
+			resets = <&rst1 RSTN_MD>;
+		};
+
+		se@9800c000 {
+			compatible = "realtek,se";
+			reg = <0x0 0x9800c000 0x0 0x1000>;
+			interrupts = <0 20 4>;
+			clocks = <&clk_en_1 CLK_EN_SE>;
+			resets = <&rst1 RSTN_SE>;
+		};
+
+		rpc@9801a104 {
+			compatible = "Realtek,rtk-rpc";
+			reg = <0x0 0x9801a104 0x0 0xc>, /* rpc intr en */
+			      <0x0 0x01ffe000 0x0 0x4000>, /* rpc ring buffer */
+			      <0x0 0x0002f000 0x0 0x1000>, /* rpc common */
+			      <0x0 0x9801a020 0x0 0x4>; /* rbus sync */
+			interrupts = <0 33 4>;
+		};
+
+		refclk@9801b540 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x9801b000 0x0 0x1000>;
+		};
+
+		pinctrl: pinctrl@9804E000 {
+			compatible = "realtek,rtk139x-pinctrl";
+			reg = <0x0 0x9804E000 0x0 0x86>;
+			#gpio-range-cells = <3>;
+			pinctrl-names = "default";
+			/* pinctrl-0 = ; */
+			status = "okay";
+		};
+
+		mux_intc: intc@9801B000 {
+			compatible = "Realtek,rtk-irq-mux";
+			Realtek,mux-nr = <2>;
+			#interrupt-cells = <2>;
+			interrupt-controller;
+			reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP */
+			      <0x0 0x98007000 0x0 0x100>; /* MISC_ISO */
+			interrupts = <0 40 4>, <0 41 4>;
+			intr-status = <0xc>, <0x0>;
+			intr-en = <0x80>, <0x40>;
+			status = "okay";
+		};
+
+		rtk_iso_gpio: rtk_iso_gpio@98007100 {
+			compatible = "realtek,rtk139x-iso-gpio-irq-mux";
+			gpio-controller;
+			#gpio-cells = <3>;
+			Realtek,gpio_base = <0>;
+			Realtek,gpio_numbers = <57>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+			reg = <0x0 0x98007000 0x0 0x100>,
+			      <0x0 0x98007100 0x0 0x100>; /* ISO_SYS ISO_GPIO*/
+			gpio-ranges = <&pinctrl 0 0 57>;
+			status = "okay";
+		};
+
+		hdmitx@9800D000 {
+			compatible = "realtek,rtd129x-hdmitx";
+			reg = <0x0 0x9800d000 0x0 0x560>, /* HDMITX */
+			      <0x0 0x98007200 0x0 0x4>; /* I2C1_REQ_CTRL */
+			gpio-hpd-detect = <&rtk_iso_gpio 7 0 0>; /* Hotplug detect pin */
+			clocks = <&clk_en_1 CLK_EN_HDMI>;
+			clock-names = "clk_en_hdmi";
+			resets = <&rst1 RSTN_HDMI>;
+			reset-names = "rstn_hdmi";
+
+			scdc_rr {
+				enable-scdc-rr = <0>;
+				interrupt-parent = <&mux_intc>;
+				#interrupt-cells = <1>;
+				interrupt-controller;
+				interrupts = <1 31>;
+			};
+		};
+
+		hdcptx@9800D000 {
+			compatible = "realtek,rtk139x-hdcptx";
+			reg = <0x0 0x9800d000 0x0 0x400>;
+			interrupts = <0 31 4>; /*gen Ri*/
+		};
+
+		sd: sdmmc@98010400 {
+			compatible = "Realtek,rtk1295-sdmmc";
+			gpios = <&rtk_iso_gpio 30 1 0>, /*sd power , output, default high  (poweroff) */
+			        <&rtk_iso_gpio 34 0 1>,
+			        <&rtk_iso_gpio 35 0 1>;
+			reg = <0x0 0x98000000 0x0 0x400>, /* CRT */
+			      <0x0 0x98010400 0x0 0x200>, /* SDMMC */
+			      <0x0 0x9801A000 0x0 0x400>, /* BS2 */
+			      <0x0 0x9804E000 0x0 0x40>, /* ISO */
+			      <0x0 0x98010A00 0x0 0x40>, /* SDIO */
+			      <0x0 0x98007000 0x0 0x200>;
+			interrupts = <0 44 4>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&sdcard_pins_low>;
+			            /*<&sdcard_pins_high>;*/
+			clocks = <&clk_en_1 CLK_EN_CR>,
+			        <&clk_en_1 CLK_EN_SD_IP>;
+			clock-names = "cr",
+			        "sd_ip";
+			resets = <&rst2 RSTN_CR>;
+		};
+
+		gpu: gpu@981d0000 {
+			compatible = "arm,mali-470", "arm,mali-utgard";
+			reg = <0x0 0x981D0000 0x0 0x30000>;
+			interrupts =
+				<0 75 4>, <0 76 4>,
+				<0 77 4>, <0 78 4>,
+				<0 79 4>, <0 80 4>,
+				<0 81 4>, <0 82 4>,
+				<0 83 4>, <0 84 4>,
+				<0 85 4>, <0 86 4>;
+			interrupt-names =
+				"IRQPP0", "IRQPPMMU0",
+				"IRQPP1", "IRQPPMMU1",
+				"IRQPP2", "IRQPPMMU2",
+				"IRQPP3", "IRQPPMMU3",
+				"IRQGP", "IRQGPMMU",
+				"IRQPMU", "IRQPP";
+			power-domains = <&pd0 RTD139X_PD_GPU>;
+			pmu_domain_config = <0x1 0x1 0x2 0x4 0x8 0x0 0x0 0x0 0x0 0x0 0x1 0x0>;
+			pmu_switch_delay = <0xff>;
+			clocks = <&cc CC_CLK_GPU>;
+			clock-names = "clk_mali";
+			resets = <&rst1 RSTN_GPU>;
+		};
+
+		pu_pll@98000000 {
+			compatible = "Realtek,rtk1295-pu_pll";
+			reg = <0x0 0x98000000 0x0 0x200>;
+		};
+
+		jpeg: jpeg@9803e000 {
+			compatible = "Realtek,rtk1295-jpeg";
+			reg = <0x0 0x9803e000 0x0 0x1000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 52 4>;
+			clocks = <&clk_en_2 CLK_EN_JPEG>;
+			clock-names = "jpeg";
+			resets = <&rst2 RSTN_JPEG>;
+		};
+
+		ve1: ve1@98040000 {
+			compatible = "Realtek,rtk1295-ve1";
+			reg = <0x0 0x98040000 0x0 0x8000>,
+			      <0x0 0x98008000 0x0 0x1000>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 53 4>, <0 54 4>;
+			clocks = <&cc CC_CLK_VE1>,
+			         <&cc CC_CLK_VE2>,
+			         <&cc CC_CLK_VE2_BPU>,
+			         <&cc CC_CLK_SYSH>,
+			         <&cc CC_PLL_VE1>,
+			         <&cc CC_PLL_VE2>;
+			clock-names = "clk_ve1",
+			              "clk_ve2",
+			              "clk_ve2_bpu",
+			              "clk_sysh",
+			              "pll_ve1",
+			              "pll_ve2";
+			resets = <&rst1 RSTN_VE1>,
+			         <&rst1 RSTN_VE2>;
+			reset-names = "ve1",
+			              "ve2";
+			assigned-clocks = <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>, <&cc CC_CLK_VE2_BPU>;
+			assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>, <&cc CC_PLL_VE1>;
+			assigned-clock-rates = <550000000>, <715000000>, <550000000>;
+		};
+
+		rtk-fb {
+			compatible = "Realtek,rtk-fb";
+			buffer-cnt = <3>;
+			resolution = <1920 1080>;
+			fps = <60>;
+		};
+
+		irda@98007400 {
+			compatible = "Realtek,rtk-irda";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x98007000 0x0 0x400>,
+			      <0x0 0x98007400 0x0 0x100>;
+			interrupts = <1 5>;
+			resets = <&irst IRSTN_IR>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&ir_rx_pins>;
+			clocks = <&iclk_en CLK_EN_MISC_IR>;
+		};
+
+		i2c_1: i2c@0x98007C00 {
+			compatible = "Realtek,rtk-i2c";
+			reg = <0x0 0x98007C00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <1 11>;
+			i2c-num = <1>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&i2c_pins_1>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&iclk_en CLK_EN_I2C1>;
+			resets = <&irst IRSTN_I2C_1>;
+		};
+
+		uart1: serial1@9801B200 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B200 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x8>;
+			interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&uart1_pins>;
+			clocks = <&clk_en_2 CLK_EN_UR1>;
+			resets = <&rst2 RSTN_UR1>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		uart2: serial2@9801B400 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B400 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x100>;
+			interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			clocks = <&clk_en_2 CLK_EN_UR2>;
+			resets = <&rst2 RSTN_UR2>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		hse: hse@98005000 {
+			compatible = "realtek,hse";
+			reg = <0x0 0x98005000 0x0 0x1000>;
+			interrupts = <0 7 4>, <0 27 4>;
+			clocks = <&clk_en_2 CLK_EN_HSE>;
+			resets = <&rst1 RSTN_HSE>;
+		};
+
+		dvfs: cpu-dvfs {
+			compatible = "realtek,dummy-dvfs";
+			clocks = <&cc CC_PLL_SCPU>;
+			operating-points-v2 = <&cpu_opps>;
+			status ="okay";
+		};
+
+		cpu_tm: thermal-sensor@9801D150 {
+			compatible = "realtek,rtd139x-thermal-sensor";
+			reg = <0 0x9801D150 0 0x1C>;
+			#thermal-sensor-cells = <0>;
+			status = "okay";
+		};
+
+		thermal-zones {
+			cpu_thermal: cpu-thermal {
+				polling-delay-passive = <250>;
+				polling-delay = <1000>;
+				thermal-sensors = <&cpu_tm>;
+
+				trips {
+					cpu_crit: cpu-crit {
+						temperature = <130000>;
+						hysteresis = <0>;
+						type = "critical";
+					};
+				};
+				cooling-maps {
+				};
+			};
+		};
+
+		xencec {
+			compatible = "xen,cec";
+			module-enable = <1>;
+			status = "okay";
+		};
+
+	}; /* passthrough */
+};
+
+#include "rtd-139x-dvfs-xenott.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-xenott.low.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-xenott.low.dts
new file mode 100644
index 00000000..6c348cd
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin-xenott.low.dts
@@ -0,0 +1,642 @@
+/dts-v1/;
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include <dt-bindings/clock/rtk,clock-rtd139x.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <dt-bindings/reset/rtk,reset-rtd139x.h>
+#include <dt-bindings/power/rtk,power-rtd139x.h>
+#include <dt-bindings/soc/rtd139x,memory.h>
+#include "rtd-139x-xen-pinctrl-domu.dtsi"
+#include "rtd-139x-xen-irda-domu.dtsi"
+#include "rtd-1395-usb-xen-domu.dtsi"
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (0x11000000) // (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (0x05000000) // (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+
+/{
+	/* #*cells are here to keep DTC happy */
+	#address-cells = <2>;
+	#size-cells = <2>;
+
+	aliases {
+		serial1 = &uart1;
+		i2c1 = &i2c_1;
+		hwsem0 = &sb2_lock1;
+		hwsem1 = &sb2_lock2;
+	};
+
+	/*
+	 * Do not add other settings here other than CMA info since XEN only
+	 * bypass CMA properties
+	 */
+	chosen {
+		compatible = "Realtek,rtk1395-cma_info", "Realtek,DomU-cma_info";
+		cma-region-enable = <0>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+	};
+
+        reserved-memory {
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0x0 0x00800000>; /* size 8MB */
+			alignment = <0x0 0x00100000>;
+			alloc-ranges = <0x0 0x20000000 0x0 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+
+		phys_resv@0 {
+			reg = <0x0 SYS_BOOTCODE_MEMBASE 0x0 SYS_BOOTCODE_MEMSIZE>,
+			      <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>,
+			      <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>,
+			      <0x0 ACPU_IDMEM_PHYS 0x0 ACPU_IDMEM_SIZE>,
+			      <0x0 ION_MEDIA_HEAP_PHYS_0 0x0 ION_MEDIA_HEAP_SIZE_0>,
+			      <0x0 ION_AUDIO_HEAP_PHYS_0 0x0 ION_AUDIO_HEAP_SIZE_0>,
+			      <0x0 ION_MEDIA_HEAP_PHYS_1 0x0 ION_MEDIA_HEAP_SIZE_1>;
+		};
+        };
+
+	passthrough {
+		compatible = "simple-bus";
+		ranges;
+		#address-cells = <2>;
+		#size-cells = <2>;
+
+		sb2_lock0: sb2-lock@9801A000 {
+			compatible = "realtek,sb2-sem";
+			reg = <0x0 0x9801A000 0x0 0x4>;
+		};
+
+		sb2_lock1: sb2-lock@9801A620 {
+			compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+			reg = <0x0 0x9801A620 0x0 0x4>;
+		};
+
+		sb2_lock2: sb2-lock@9801A624 {
+			compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+			reg = <0x0 0x9801A624 0x0 0x4>;
+		};
+
+		/* fixed clock */
+		osc27M: osc27M {
+			compatible = "fixed-clock";
+			#clock-cells = <0>;
+			clock-frequency = <27000000>;
+			clock-output-names = "osc27M";
+		};
+
+		/* mmio */
+		crt_mmio: mmio@98000000 {
+			compatible = "realtek,mmio";
+			reg = <0x0 0x98000000 0x0 0x600>;
+			realtek,sb2-lock = <&sb2_lock0>;
+		};
+
+		iso_mmio: mmio@98007088 {
+			compatible = "realtek,mmio";
+			reg = <0x0 0x98007088 0x0 0x8>;
+			realtek,sb2-lock = <&sb2_lock0>;
+		};
+
+		/* clock-controller */
+		clk_en_1: clk-en@9800000c {
+			compatible = "realtek,clock-gate-controller";
+			reg = <0x0 0x9800000c 0x0 0x4>;
+			#clock-cells = <1>;
+			realtek,mmio = <&crt_mmio 0xc>;
+			clock-output-names =
+			/* 0 ~ 7 */	"clk_en_misc",      "clk_en_pcie0",
+					"",                 "clk_en_gspi",
+					"",                 "",
+					"clk_en_iso_misc",  "clk_en_sds",
+			/* 8 ~ 15 */	"clk_en_hdmi",      "",
+					"",                 "",
+					"",                 "",
+					"",                 "",
+			/* 16 ~ 23 */	"clk_en_lsadc",     "clk_en_se",
+					"",                 "clk_en_cp",
+					"clk_en_md",        "clk_en_tp",
+					"clk_en_rsa",       "clk_en_nf",
+			/* 24 ~ 31 */	"clk_en_emmc",      "clk_en_cr",
+					"clk_en_sdio_ip",   "clk_en_mipi",
+					"clk_en_emmc_ip",   "",
+					"clk_en_sdio",      "clk_en_sd_ip";
+			ignore-unused-clocks =
+				"clk_en_misc",
+				"clk_en_iso_misc",
+				"clk_en_cp",
+				"clk_en_md",
+				"clk_en_tp",
+				"clk_en_hdmi",
+				"clk_en_pcie0",
+				"clk_en_emmc",
+				"clk_en_emmc_ip";
+			ignore-pm-clocks =
+				"clk_en_hdmi";
+		};
+
+		clk_en_2: clk-en@98000010 {
+			compatible = "realtek,clock-gate-controller";
+			reg = <0x0 0x98000010 0x0 0x4>;
+			#clock-cells = <1>;
+			realtek,mmio = <&crt_mmio 0x10>;
+			clock-output-names =
+			/* 0 ~ 7 */	"",                 "clk_en_misc_i2c_5",
+					"",		    "clk_en_jpeg",
+					"",                 "",
+					"clk_en_misc_sc",   "",
+			/* 8 ~ 15 */	"",                 "",
+					"",                 "",
+					"",                 "",
+					"",                 "",
+			/* 16 ~ 23 */	"",                 "",
+					"",                 "",
+					"",                 "",
+					"",                 "",
+			/* 24 ~ 31 */	"",                 "clk_en_hse",
+					"",                 "clk_en_ur2",
+					"clk_en_ur1",       "clk_en_fan",
+					"clk_en_dcphy_0",   "clk_en_dcphy_1";
+			ignore-unused-clocks =
+				"clk_en_dcphy_0",
+				"clk_en_dcphy_1";
+		};
+
+		iclk_en: clk-en@9800708c {
+			compatible = "realtek,clock-gate-controller";
+			reg = <0x0 0x9800708c 0x0 0x4>;
+			#clock-cells = <1>;
+			realtek,mmio = <&iso_mmio 0x4>;
+			clock-output-names =
+			/* 0 ~ 7 */	"",                  "",
+					"clk_en_misc_cec0",  "clk_en_cbusrx_sys",
+					"clk_en_cbustx_sys", "clk_en_cbus_sys",
+					"clk_en_cbus_osc",   "clk_en_misc_ir",
+			/* 8 ~ 15 */	"clk_en_ur0",        "clk_en_i2c0",
+					"clk_en_i2c1",       "clk_en_etn_250m",
+					"clk_en_etn_sys",    "clk_en_usb_drd",
+					"clk_en_usb_host_0", "clk_en_usb_host_1",
+			/* 16 */	"clk_en_usb";
+			ignore-unused-clocks = 
+				"clk_en_ur0",
+				"clk_en_i2c0",
+				"clk_en_etn_250m",
+				"clk_en_etn_sys",
+				"clk_en_usb_drd",
+				"clk_en_usb_host_0",
+				"clk_en_usb_host_1",
+				"clk_en_usb";
+		};
+
+		cc: clock-controller@98000000 {
+			compatible = "realtek,clock-controller";
+			reg = <0x0 0x98000000 0x0 0x600>;
+			#clock-cells = <1>;
+			realtek,mmio = <&crt_mmio 0x0>;
+			invalid-clocks =
+				"pll_ddsa",
+				"pll_ddsb";
+		};
+
+		/* reset-controller */
+		rst1: soft-reset@98000000 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000000 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x0>;
+			#reset-cells = <1>;
+			pm-ignore-bits = <0x00001000>;
+		};
+
+		rst2: soft-reset@98000004 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000004 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x4>;
+			#reset-cells = <1>;
+		};
+
+		rst3: soft-reset@98000008 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000008 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x8>;
+			#reset-cells = <1>;
+		};
+
+		rst4: soft-reset@98000050 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98000050 0x0 0x4>;
+			realtek,mmio = <&crt_mmio 0x50>;
+			#reset-cells = <1>;
+		};
+
+		irst: soft-reset@98007088 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98007088 0x0 0x4>;
+			realtek,mmio = <&iso_mmio 0x0>;
+			#reset-cells = <1>;
+		};
+
+		iasr: usb-async-soft-reset@98007088 {
+			compatible = "realtek,reset-controller";
+			reg = <0x0 0x98007088 0x0 0x4>;
+			realtek,mmio = <&iso_mmio 0x0>;
+			#reset-cells = <1>;
+			async-group = <0>;
+		};
+
+		pd0: power-controller@98007000 {
+			compatible = "realtek,rtd139x-power-controller", "simple-bus";
+			reg = <0x0 0x98007000 0x0 0x1000>;
+			resets = <&rst1 RSTN_VE1>, <&rst1 RSTN_VE2>;
+			reset-names = "ve1", "ve2";
+			#power-domain-cells = <1>;
+		};
+
+		rfkill: rfkilligpio {
+			compatible = "Realtek,rfkill";
+			gpios = <&rtk_iso_gpio 28 1 0>; /*bt power , output, default low */
+		};
+
+		rtk,ion {
+			compatible = "Realtek,rtk-ion";
+			#address-cells = <1>;
+			#size-cells = <0>;
+
+			rtk,ion-heap@0 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <0>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@1 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <1>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@4 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <4>;
+				rtk,memory-reservation-size = <0x0>;
+			};
+
+			rtk,ion-heap@8 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <8>;
+				rtk,memory-reserve = <
+					ION_AUDIO_HEAP_PHYS_0
+					ION_AUDIO_HEAP_SIZE_0
+					ION_AUDIO_HEAP_FLAG_0>;
+			};
+
+			rtk,ion-heap@7 {
+				compatible = "Realtek,rtk-ion-reserve";
+				reg = <7>;
+				rtk,memory-reserve = <
+					ION_MEDIA_HEAP_PHYS_0
+					ION_MEDIA_HEAP_SIZE_0
+					ION_MEDIA_HEAP_FLAG_0
+					ION_MEDIA_HEAP_PHYS_1
+					ION_MEDIA_HEAP_SIZE_1
+					ION_MEDIA_HEAP_FLAG_1>;
+			};
+		}; /* rtk,ion */
+
+		rbus@98000000 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		md@9800b000 {
+			compatible = "realtek,md";
+			reg = <0x0 0x9800b000 0x0 0x1000>;
+			interrupts = <0 38 4>;
+			clocks = <&clk_en_1 CLK_EN_MD>;
+			resets = <&rst1 RSTN_MD>;
+		};
+
+		se@9800c000 {
+			compatible = "realtek,se";
+			reg = <0x0 0x9800c000 0x0 0x1000>;
+			interrupts = <0 20 4>;
+			clocks = <&clk_en_1 CLK_EN_SE>;
+			resets = <&rst1 RSTN_SE>;
+		};
+
+		rpc@9801a104 {
+			compatible = "Realtek,rtk-rpc";
+			reg = <0x0 0x9801a104 0x0 0xc>, /* rpc intr en */
+			      <0x0 0x01ffe000 0x0 0x4000>, /* rpc ring buffer */
+			      <0x0 0x0002f000 0x0 0x1000>, /* rpc common */
+			      <0x0 0x9801a020 0x0 0x4>; /* rbus sync */
+			interrupts = <0 33 4>;
+		};
+
+		refclk@9801b540 {
+			compatible = "realtek,uio";
+			reg = <0x0 0x9801b000 0x0 0x1000>;
+		};
+
+		pinctrl: pinctrl@9804E000 {
+			compatible = "realtek,rtk139x-pinctrl";
+			reg = <0x0 0x9804E000 0x0 0x86>;
+			#gpio-range-cells = <3>;
+			pinctrl-names = "default";
+			/* pinctrl-0 = ; */
+			status = "okay";
+		};
+
+		mux_intc: intc@9801B000 {
+			compatible = "Realtek,rtk-irq-mux";
+			Realtek,mux-nr = <2>;
+			#interrupt-cells = <2>;
+			interrupt-controller;
+			reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP */
+			      <0x0 0x98007000 0x0 0x100>; /* MISC_ISO */
+			interrupts = <0 40 4>, <0 41 4>;
+			intr-status = <0xc>, <0x0>;
+			intr-en = <0x80>, <0x40>;
+			status = "okay";
+		};
+
+		rtk_iso_gpio: rtk_iso_gpio@98007100 {
+			compatible = "realtek,rtk139x-iso-gpio-irq-mux";
+			gpio-controller;
+			#gpio-cells = <3>;
+			Realtek,gpio_base = <0>;
+			Realtek,gpio_numbers = <57>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+			reg = <0x0 0x98007000 0x0 0x100>,
+			      <0x0 0x98007100 0x0 0x100>; /* ISO_SYS ISO_GPIO*/
+			gpio-ranges = <&pinctrl 0 0 57>;
+			status = "okay";
+		};
+
+		hdmitx@9800D000 {
+			compatible = "realtek,rtd129x-hdmitx";
+			reg = <0x0 0x9800d000 0x0 0x560>, /* HDMITX */
+			      <0x0 0x98007200 0x0 0x4>; /* I2C1_REQ_CTRL */
+			gpio-hpd-detect = <&rtk_iso_gpio 7 0 0>; /* Hotplug detect pin */
+			clocks = <&clk_en_1 CLK_EN_HDMI>;
+			clock-names = "clk_en_hdmi";
+			resets = <&rst1 RSTN_HDMI>;
+			reset-names = "rstn_hdmi";
+
+			scdc_rr {
+				enable-scdc-rr = <0>;
+				interrupt-parent = <&mux_intc>;
+				#interrupt-cells = <1>;
+				interrupt-controller;
+				interrupts = <1 31>;
+			};
+		};
+
+		hdcptx@9800D000 {
+			compatible = "realtek,rtk139x-hdcptx";
+			reg = <0x0 0x9800d000 0x0 0x400>;
+			interrupts = <0 31 4>; /*gen Ri*/
+		};
+
+		sd: sdmmc@98010400 {
+			compatible = "Realtek,rtk1295-sdmmc";
+			gpios = <&rtk_iso_gpio 30 1 0>, /*sd power , output, default high  (poweroff) */
+			        <&rtk_iso_gpio 34 0 1>,
+			        <&rtk_iso_gpio 35 0 1>;
+			reg = <0x0 0x98000000 0x0 0x400>, /* CRT */
+			      <0x0 0x98010400 0x0 0x200>, /* SDMMC */
+			      <0x0 0x9801A000 0x0 0x400>, /* BS2 */
+			      <0x0 0x9804E000 0x0 0x40>, /* ISO */
+			      <0x0 0x98010A00 0x0 0x40>, /* SDIO */
+			      <0x0 0x98007000 0x0 0x200>;
+			interrupts = <0 44 4>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&sdcard_pins_low>;
+			            /*<&sdcard_pins_high>;*/
+			clocks = <&clk_en_1 CLK_EN_CR>,
+			        <&clk_en_1 CLK_EN_SD_IP>;
+			clock-names = "cr",
+			        "sd_ip";
+			resets = <&rst2 RSTN_CR>;
+		};
+
+		gpu: gpu@981d0000 {
+			compatible = "arm,mali-470", "arm,mali-utgard";
+			reg = <0x0 0x981D0000 0x0 0x30000>;
+			interrupts =
+				<0 75 4>, <0 76 4>,
+				<0 77 4>, <0 78 4>,
+				<0 79 4>, <0 80 4>,
+				<0 81 4>, <0 82 4>,
+				<0 83 4>, <0 84 4>,
+				<0 85 4>, <0 86 4>;
+			interrupt-names =
+				"IRQPP0", "IRQPPMMU0",
+				"IRQPP1", "IRQPPMMU1",
+				"IRQPP2", "IRQPPMMU2",
+				"IRQPP3", "IRQPPMMU3",
+				"IRQGP", "IRQGPMMU",
+				"IRQPMU", "IRQPP";
+			power-domains = <&pd0 RTD139X_PD_GPU>;
+			pmu_domain_config = <0x1 0x1 0x2 0x4 0x8 0x0 0x0 0x0 0x0 0x0 0x1 0x0>;
+			pmu_switch_delay = <0xff>;
+			clocks = <&cc CC_CLK_GPU>;
+			clock-names = "clk_mali";
+			resets = <&rst1 RSTN_GPU>;
+		};
+
+		pu_pll@98000000 {
+			compatible = "Realtek,rtk1295-pu_pll";
+			reg = <0x0 0x98000000 0x0 0x200>;
+		};
+
+		jpeg: jpeg@9803e000 {
+			compatible = "Realtek,rtk1295-jpeg";
+			reg = <0x0 0x9803e000 0x0 0x1000>,
+			      <0x0 0x98000000 0x0 0x200>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 52 4>;
+			clocks = <&clk_en_2 CLK_EN_JPEG>;
+			clock-names = "jpeg";
+			resets = <&rst2 RSTN_JPEG>;
+		};
+
+		ve1: ve1@98040000 {
+			compatible = "Realtek,rtk1295-ve1";
+			reg = <0x0 0x98040000 0x0 0x8000>,
+			      <0x0 0x98008000 0x0 0x1000>,
+			      <0x0 0x98007000 0x0 0x30>;
+			interrupts = <0 53 4>, <0 54 4>;
+			clocks = <&cc CC_CLK_VE1>,
+			         <&cc CC_CLK_VE2>,
+			         <&cc CC_CLK_VE2_BPU>,
+			         <&cc CC_CLK_SYSH>,
+			         <&cc CC_PLL_VE1>,
+			         <&cc CC_PLL_VE2>;
+			clock-names = "clk_ve1",
+			              "clk_ve2",
+			              "clk_ve2_bpu",
+			              "clk_sysh",
+			              "pll_ve1",
+			              "pll_ve2";
+			resets = <&rst1 RSTN_VE1>,
+			         <&rst1 RSTN_VE2>;
+			reset-names = "ve1",
+			              "ve2";
+			assigned-clocks = <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>, <&cc CC_CLK_VE2_BPU>;
+			assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>, <&cc CC_PLL_VE1>;
+			assigned-clock-rates = <550000000>, <715000000>, <550000000>;
+		};
+
+		rtk-fb {
+			compatible = "Realtek,rtk-fb";
+			buffer-cnt = <3>;
+			resolution = <1920 1080>;
+			fps = <60>;
+		};
+
+		irda@98007400 {
+			compatible = "Realtek,rtk-irda";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x98007000 0x0 0x400>,
+			      <0x0 0x98007400 0x0 0x100>;
+			interrupts = <1 5>;
+			resets = <&irst IRSTN_IR>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&ir_rx_pins>;
+			clocks = <&iclk_en CLK_EN_MISC_IR>;
+		};
+
+		i2c_1: i2c@0x98007C00 {
+			compatible = "Realtek,rtk-i2c";
+			reg = <0x0 0x98007C00 0x0 0x400>;
+			interrupt-parent = <&mux_intc>;
+			interrupts = <1 11>;
+			i2c-num = <1>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&i2c_pins_1>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			clocks = <&iclk_en CLK_EN_I2C1>;
+			resets = <&irst IRSTN_I2C_1>;
+		};
+
+		uart1: serial1@9801B200 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B200 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x8>;
+			interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			pinctrl-names = "default";
+			pinctrl-0 = <&uart1_pins>;
+			clocks = <&clk_en_2 CLK_EN_UR1>;
+			resets = <&rst2 RSTN_UR1>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		uart2: serial2@9801B400 {
+			compatible = "snps,dw-apb-uart";
+			interrupt-parent = <&mux_intc>;
+			reg = <0x0 0x9801B400 0x0 0x100>,
+			      <0x0 0x9801B00c 0x0 0x100>;
+			interrupts-st-mask = <0x100>;
+			interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+			reg-shift = <2>;
+			reg-io-width = <4>;
+			clocks = <&clk_en_2 CLK_EN_UR2>;
+			resets = <&rst2 RSTN_UR2>;
+			/* This value must be overriden by the board. */
+			clock-frequency = <432000000>;
+		};
+
+		hse: hse@98005000 {
+			compatible = "realtek,hse";
+			reg = <0x0 0x98005000 0x0 0x1000>;
+			interrupts = <0 7 4>, <0 27 4>;
+			clocks = <&clk_en_2 CLK_EN_HSE>;
+			resets = <&rst1 RSTN_HSE>;
+		};
+
+		dvfs: cpu-dvfs {
+			compatible = "realtek,dummy-dvfs";
+			clocks = <&cc CC_PLL_SCPU>;
+			operating-points-v2 = <&cpu_opps>;
+			status ="okay";
+		};
+
+		cpu_tm: thermal-sensor@9801D150 {
+			compatible = "realtek,rtd139x-thermal-sensor";
+			reg = <0 0x9801D150 0 0x1C>;
+			#thermal-sensor-cells = <0>;
+			status = "okay";
+		};
+
+		thermal-zones {
+			cpu_thermal: cpu-thermal {
+				polling-delay-passive = <250>;
+				polling-delay = <1000>;
+				thermal-sensors = <&cpu_tm>;
+
+				trips {
+					cpu_crit: cpu-crit {
+						temperature = <130000>;
+						hysteresis = <0>;
+						type = "critical";
+					};
+				};
+				cooling-maps {
+				};
+			};
+		};
+
+		xencec {
+			compatible = "xen,cec";
+			module-enable = <1>;
+			status = "okay";
+		};
+
+	}; /* passthrough */
+};
+
+#include "rtd-139x-dvfs-xenott.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin.dtsi
new file mode 100644
index 00000000..f429311
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-lionskin.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-139x.dtsi"
+#include "rtd-139x-dvfs.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-1GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-1GB.dts
new file mode 100644
index 00000000..79342df
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-1GB.dts
@@ -0,0 +1,205 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x03c00000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-papermulberry.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
+&emmc {
+	status = "disabled";
+};
+
+&gpu {
+	assigned-clocks =      <&cc CC_CLK_GPU>;
+	assigned-clock-rates = <500000000>;
+};
+
+&nand {
+	status = "okay";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&ve1 {
+	assigned-clocks =        <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>;
+	assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>;
+	assigned-clock-rates =   <270000000>,      <189000000>;
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-glinux-1GB.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-glinux-1GB.dts
new file mode 100644
index 00000000..7deb8ef
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-glinux-1GB.dts
@@ -0,0 +1,209 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0b800000) // 60M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1395-papermulberry.dtsi"
+
+/ {
+	model= "Realtek_Lion_Skin_1GB";
+	model_hex= <0x00000573>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hercules androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+};
+
+&emmc {
+	status = "disabled";
+};
+
+&gpu {
+	assigned-clocks =      <&cc CC_CLK_GPU>;
+	assigned-clock-rates = <500000000>;
+};
+
+&nand {
+	status = "okay";
+};
+
+&i2c_5 {
+	status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&ve1 {
+	assigned-clocks =        <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>;
+	assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>;
+	assigned-clock-rates =   <270000000>,      <189000000>;
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-qa-rescue.dts
new file mode 100644
index 00000000..4d85032
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry-qa-rescue.dts
@@ -0,0 +1,206 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-1395-papermulberry.dtsi"
+
+/ {
+	model= "Realtek_RTD1355";
+	model_hex = <0x0000054B>;
+	compatible = "realtek,rtd1355";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&emmc {
+	status = "disabled";
+};
+
+&gpu {
+	assigned-clocks = <&cc CC_CLK_GPU>;
+	assigned-clock-rates = <500000000>;
+};
+
+&jpeg {
+	status = "disabled";
+};
+
+&md {
+	status = "disabled";
+};
+
+&nand {
+	status = "okay";
+};
+
+&i2c_5 {
+        status = "disabled";
+};
+
+&nic {
+	status = "disabled";
+};
+
+&pcie {
+	status = "disabled";
+};
+
+
+&sd {
+	status = "disabled";
+};
+
+&sdio {
+	status = "disabled";
+};
+
+&se {
+	status = "disabled";
+};
+
+&ve1 {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry.dtsi
new file mode 100644
index 00000000..2498325
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-papermulberry.dtsi
@@ -0,0 +1,48 @@
+#include "rtd-139x.dtsi"
+#include "rtd-139x-dvfs.dtsi"
+
+/* CPU OPP table */
+
+&opp900 {
+	opp-suspend;
+};
+
+&opp1200 {
+	/delete-property/ opp-suspend;
+	status = "disabled";
+};
+
+&opp1300 {
+	status = "disabled";
+};
+
+&opp1400 {
+	status = "disabled";
+};
+
+/* GPU OPP table */
+
+&gopp300 {
+	status = "okay";
+};
+
+&gopp400 {
+	status = "okay";
+};
+
+&gopp500 {
+	status = "okay";
+};
+
+&gopp600 {
+	status = "disabled";
+};
+
+&gopp700 {
+	status = "disabled";
+};
+
+&gopp750 {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-nand.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-nand.dts
new file mode 100644
index 00000000..fc3b6ce
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-nand.dts
@@ -0,0 +1,195 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-139x.dtsi"
+
+/ {
+	model= "Realtek_RTD1395";
+	model_hex = <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	nand@98010000 { 
+		status = "okay"; 
+	};
+
+	emmc@98012000 { 
+		status = "disabled"; 
+	};
+
+	i2c@9801BB00 { status = "disabled"; }; /* i2c_5 */
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-tee.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-tee.dts
new file mode 100644
index 00000000..3c3d68f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-tee.dts
@@ -0,0 +1,197 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+/* TEE OS */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12c00000;
+
+#include "rtd-139x.dtsi"
+
+/ {
+    model= "Realtek_RTD1395";
+    model_hex= <0x00000573>;
+    compatible = "realtek,rtd1395";
+
+    chosen {
+        linux,initrd-start = <ROOTFS_RESCUE_START>;
+        linux,initrd-end = <ROOTFS_RESCUE_END>;
+        bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+    };
+
+    memory@0 {
+        device_type = "memory";
+        reg = <0 0x40000000>; /* 1024 MB */
+    };
+
+    firmware {
+        optee {
+            compatible = "linaro,optee-tz";
+            method = "smc";
+        };
+    };
+
+    reserved-memory {
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        rbus@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "rbus";
+            reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+            rtk_rbus_barrier_flag;
+        };
+
+        common@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "common";
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+
+        ringbuf@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "ringbuf";
+            reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+        };
+
+        tee_reserved: tee {
+            no-map;
+            size = <0x04100000>;
+            alloc-ranges = <TEE_OS_PHYS TEE_OS_SIZE>;
+        }; 
+    };
+
+    timer {
+        clock-frequency = <27000000>;
+    };
+
+    timer0 {
+        clock-frequency = <27000000>;
+    };
+
+    timer1 {
+        clock-frequency = <27000000>;
+    };
+
+    serial0@98007800 {
+        clock-frequency = <27000000>;
+    };
+
+    rtk,ion {
+        compatible = "Realtek,rtk-ion";
+        #address-cells = <1>;
+        #size-cells = <0>;
+
+        rtk,ion-heap@0 { /* SYSTEM_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <0>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@1 { /* System contig */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <1>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@4 { /* DMA_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <4>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@8 { /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                0x03000000
+                0x00100000
+                ION_AUDIO_HEAP_FLAG>;
+        };
+
+        rtk,ion-heap@7 { /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+                0x03100000
+                0x06000000
+                ION_MEDIA_HEAP_FLAG1>;
+        };
+    };
+
+    fb@0 {
+        compatible = "Realtek,rtk-fb";
+        reg = <0x15000000 0xA8C000>;
+        buffer-cnt = <3>;
+        resolution = <1920 1080>;
+        fps = <60>;
+    };
+
+    test_vo@98005000 {
+        compatible = "Realtek,rtk1295-test_vo";
+        reg = <0x98005000 0x1000>,
+            <0x9800D000 0x1000>,
+            <0x98000000 0x1000>;
+        //interrupts = <0 31 4>;
+        interrupts = <0 34 4>;
+    };
+
+    serial1@9801B200 {
+        status = "disabled";
+    };
+
+    sdmmc@98010400 {
+        status = "disabled";
+    };
+
+    md@9800b000 {
+        status = "disabled";
+    };
+
+    se@9800c000 {
+        status = "disabled";
+    };
+
+    jpeg@9803e000 {
+        status = "disabled";
+    };
+
+    ve1@98040000 {
+        status = "disabled";
+    };
+
+    rtk_avcpu {
+        compatible = "Realtek,rtk-avcpu";
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        crt@0 {
+            reg = <0x98000000 0x200000>;
+        };
+
+        rpc@0 {
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+    };
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-vmx.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-vmx.dts
new file mode 100755
index 00000000..fad58b9
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue-vmx.dts
@@ -0,0 +1,213 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/* 0x1fc00000 ~ 0x1fc00fff */
+/memreserve/ ACPU_BOOTCODE_PHYS ACPU_BOOTCODE_SIZE;
+/* Framebuffer */
+/memreserve/ 0x22000000 0x17BB000;
+/* TEE OS */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* Watermark */
+/memreserve/ 0x32600000 0x00200000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x17c00000;
+/* TP */
+/memreserve/ 0x31600000 0x01000000;
+/* TEE MCP BUFFER*/
+/memreserve/ 0x42700000 0x06300000;
+/* ION VMX BUFFER*/
+/memreserve/ 0x4A700000 0x17C00000;
+
+#include "rtd-139x.dtsi"
+
+/ {
+    model= "Realtek_RTD1395";
+    model_hex= <0x00000573>;
+    compatible = "realtek,rtd1395";
+
+    chosen {
+        linux,initrd-start = <ROOTFS_RESCUE_START>;
+        linux,initrd-end = <ROOTFS_RESCUE_END>;
+        bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=64m@576m init=/init androidboot.hardware=hercules androidboot.storage=emmc androidboot.vmx=ultra loglevel=4";
+    };
+
+    memory@0 {
+        device_type = "memory";
+        reg = <0 0x80000000>; /* 2048 MB */
+    };
+
+    firmware {
+        optee {
+            compatible = "linaro,optee-tz";
+            method = "smc";
+        };
+    };
+
+    reserved-memory {
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        rbus@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "rbus";
+            reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+            rtk_rbus_barrier_flag;
+        };
+
+        common@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "common";
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+
+        ringbuf@0 {
+            compatible = "rsvmem-remap";
+            save_remap_name = "ringbuf";
+            reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+        };
+
+        tee_reserved: tee {
+            no-map;
+            size = <0x04100000>;
+            alloc-ranges = <TEE_OS_PHYS TEE_OS_SIZE>;
+        }; 
+    };
+
+    timer {
+        clock-frequency = <27000000>;
+    };
+
+    timer0 {
+        clock-frequency = <27000000>;
+    };
+
+    timer1 {
+        clock-frequency = <27000000>;
+    };
+
+    serial0@98007800 {
+        clock-frequency = <27000000>;
+    };
+
+    rtk,ion {
+        compatible = "Realtek,rtk-ion";
+        #address-cells = <1>;
+        #size-cells = <0>;
+
+        rtk,ion-heap@0 { /* SYSTEM_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <0>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@1 { /* System contig */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <1>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@4 { /* DMA_HEAP */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <4>;
+            rtk,memory-reservation-size = <0x0>;
+        };
+
+        rtk,ion-heap@8 { /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                0x03000000
+                0x00100000
+                ION_AUDIO_HEAP_FLAG>;
+        };
+
+        rtk,ion-heap@7 { /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+		0x03100000 0x06000000 ION_MEDIA_HEAP_FLAG1
+		0x4A700000 0x17C00000 ION_MEDIA_HEAP_FLAG1 >;
+        };
+
+	rtk,ion-heap@9 { /* TYPE_VMX */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                0x31600000 0x01000000 RTK_FLAG_SECURE_AUDIO >;
+        };
+    };
+
+    fb@0 {
+        compatible = "Realtek,rtk-fb";
+        reg = <0x22000000 0xA8C000>;
+        buffer-cnt = <3>;
+        resolution = <1920 1080>;
+        fps = <60>;
+    };
+
+    test_vo@98005000 {
+        compatible = "Realtek,rtk1295-test_vo";
+        reg = <0x98005000 0x1000>,
+            <0x9800D000 0x1000>,
+            <0x98000000 0x1000>;
+        //interrupts = <0 31 4>;
+        interrupts = <0 34 4>;
+    };
+
+    serial1@9801B200 {
+        status = "disabled";
+    };
+
+    sdmmc@98010400 {
+        status = "disabled";
+    };
+
+    md@9800b000 {
+        status = "disabled";
+    };
+
+    se@9800c000 {
+        status = "disabled";
+    };
+
+    jpeg@9803e000 {
+        status = "disabled";
+    };
+
+    ve1@98040000 {
+        status = "disabled";
+    };
+
+    rtk_avcpu {
+        compatible = "Realtek,rtk-avcpu";
+        #address-cells = <1>;
+        #size-cells = <1>;
+        ranges;
+
+        crt@0 {
+            reg = <0x98000000 0x200000>;
+        };
+
+        rpc@0 {
+            reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+        };
+    };
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue.dts
new file mode 100644
index 00000000..2dc9064
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-qa-rescue.dts
@@ -0,0 +1,196 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+/* TEE OS */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x0d500000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+
+#include "rtd-139x.dtsi"
+
+/ {
+	model= "Realtek_RTD1395";
+	model_hex= <0x00000573>;
+	compatible = "realtek,rtd1395";
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init androidboot.hardware=hercules androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <RBUS_BASE_PHYS RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE>;
+		};
+		tee_reserved: tee {
+            no-map;
+            size = <0x04100000>;
+            alloc-ranges = <TEE_OS_PHYS TEE_OS_SIZE>;
+        };
+	};
+
+	timer {
+		clock-frequency = <27000000>;
+	};
+
+	timer0 {
+		clock-frequency = <27000000>;
+	};
+
+	timer1 {
+		clock-frequency = <27000000>;
+	};
+
+	serial0@98007800 {
+		clock-frequency = <27000000>;
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x15000000 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x98005000 0x1000>,
+			<0x9800D000 0x1000>,
+			<0x98000000 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	serial1@9801B200 {
+		status = "disabled";
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	md@9800b000 {
+		status = "disabled";
+	};
+
+	se@9800c000 {
+		status = "disabled";
+	};
+
+	jpeg@9803e000 {
+		status = "disabled";
+	};
+
+	ve1@98040000 {
+		status = "disabled";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-usb-xen-domu.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-usb-xen-domu.dtsi
new file mode 100644
index 00000000..f44d4ce
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-usb-xen-domu.dtsi
@@ -0,0 +1,73 @@
+/*
+ * realtek,type_c-power-gpio: TypeC power, output, default low
+ * realtek,u2host-power-gpio: ehci and u2host power, output, default low
+ * realtek,u3host-power-gpio: 1296 u3host power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+/ {
+	passthrough {
+
+	/include/ "rtd-139x-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		reg = <0x0 0x98000000 0x0 0x10>;
+		status = "disabled";
+	};
+
+	dwc3_drd_usb2phy: dwc3_drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98028280 0x0 0x4>,
+		      <0x0 0x98013214 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013200 0x0 0x200>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		status = "disabled";
+
+		dwc3_drd@98020000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98020000 0x0 0x9000>;
+			dr_mode = "peripheral"; /*host, peripheral*/
+		};
+
+		dwc3_type_c: rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			reg = <0x0 0x98013200 0x0 0x200>,
+			      <0x0 0x98007220 0x0 0x20>;
+			drd_mode; //depend on dr_mode = "peripheral"
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98031280 0x0 0x4>,
+		      <0x0 0x98031284 0x0 0x4>,
+		      <0x0 0x98013C14 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013C00 0x0 0x200>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		status = "disabled";
+
+		dwc3_u2host@98029000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98029000 0x0 0x9000>;
+		};
+	};
+
+
+	}; /* passthrough */
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-usb-xen-pass.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-usb-xen-pass.dtsi
new file mode 100644
index 00000000..6a553c0
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-usb-xen-pass.dtsi
@@ -0,0 +1,67 @@
+/*
+ * realtek,type_c-power-gpio: TypeC power, output, default low
+ * realtek,u2host-power-gpio: ehci and u2host power, output, default low
+ * realtek,u3host-power-gpio: 1296 u3host power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+/ {
+	/include/ "rtd-139x-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		xen,passthrough;
+
+		power_ctrl_reg {
+			xen,passthrough;
+		};
+	};
+
+	dwc3_drd_usb2phy: dwc3_drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		xen,passthrough;
+
+		phy0 {
+			xen,passthrough;
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		xen,passthrough;
+
+		dwc3_drd@98020000 {
+			compatible = "synopsys,dwc3";
+			xen,passthrough;
+		};
+
+		dwc3_type_c: rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			xen,passthrough;
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		xen,passthrough;
+
+		phy0 {
+			xen,passthrough;
+		};
+
+		phy1 {
+			xen,passthrough;
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,dwc3";
+		xen,passthrough;
+
+		dwc3_u2host@98029000 {
+			compatible = "synopsys,dwc3";
+			xen,passthrough;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-usb.dtsi
new file mode 100644
index 00000000..98d3265
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-1395-usb.dtsi
@@ -0,0 +1,36 @@
+/*
+ * realtek,type_c-power-gpio: TypeC power, output, default low
+ * realtek,u2host-power-gpio: ehci and u2host power, output, default low
+ * realtek,u3host-power-gpio: 1296 u3host power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+/ {
+	/include/ "rtd-139x-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		status = "okay";
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+		};
+
+		rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			drd_mode; //depend on dr_mode = "peripheral"
+			status = "okay";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-avb.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-avb.dtsi
new file mode 100644
index 00000000..60e2d6f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-avb.dtsi
@@ -0,0 +1,17 @@
+/ {
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				/delete-node/ system;
+				vendor {
+					fsmgr_flags = "wait,avb";
+				};
+			};
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dcsys-debug.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dcsys-debug.dtsi
new file mode 100644
index 00000000..980c92d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dcsys-debug.dtsi
@@ -0,0 +1,142 @@
+/*
+[Module ID table]
+VO1 0x0
+AIO: 0xa
+CP: 0x11
+MD: 0x13
+JPEG: 0x15
+TP: 0x17
+GPU: 0x19
+SCPU_NWC: 0x20
+SCPU_SWC: 0x25
+ACPU: 0x23
+HIF: 0x22
+AEE: 0x28
+ADE: 0x29
+USB: 0x2a
+SD: 0x2b
+PCIE: 0x2c
+SDIO: 0x2d
+ETN: 0x2e
+EMMC: 0x80
+NF: 0x83
+VE1: 0x30
+VE2: 0x31
+SE: 0x38
+MIPI: 0x40
+SATA: 0x48
+DIP: 0x88
+HSE_REE: 0x90
+HSE_TEE: 0x9
+
+[access type]
+invalid: 0x0
+read: 0x1
+write: 0x2
+read or write: 0x3
+
+[memory trash detection mode]
+mode1: 0x1 (Given a region, trap if module_ID and access_type match)
+mode2: 0x2 (Given a region, trap if module_ID not match and access_type match)
+mode3: 0x3 (Given a module_ID and access_type, trap if request falls out of range)
+
+[Over DRAM access detection]
+Disable: 0x0
+Enable: 0x1
+
+[interrupt to CPU]
+SCPU: 0x0
+ACPU: 0x1
+VCPU: 0x2
+*/
+
+/{
+	dc_sys_debug@98008000 {
+		compatible = "realtek,rtk-dcsys-debug";
+		reg = <0x98008000 0x1000>;
+		interrupts = <0 35 4>;
+		err_cmd_detect = <0x1>, /* Enable over DRAM access detection */
+			<0x0>; /* interrupt to CPU */
+		mt_0 = <0x0>,  /* NUM0 Enable memory trash detection */
+			<0x0>, /* NUM0 start address*/
+			<0x0>, /* NUM0 end address*/
+			<0x0>, /* NUM0 module ID0*/
+			<0xa>, /* NUM0 module ID1*/
+			<0x0>, /* NUM0 module ID2*/
+			<0x0>, /* NUM0 module ID3*/
+			<0x0>, /* NUM0 interrupt to CPU*/
+			<0x3>, /* NUM0 access type*/
+			<0x1>; /* NUM0 mode*/
+		mt_1 = <0x0>, /* NUM1 Enable memory trash detection */
+			<0x0>, /* NUM1 start address*/
+			<0x0>, /* NUM1 end address*/
+			<0x0>, /* NUM1 module ID0*/
+			<0x0>, /* NUM1 module ID1*/
+			<0x0>, /* NUM1 module ID2*/
+			<0x0>, /* NUM1 module ID3*/
+			<0x0>, /* NUM1 interrupt to CPU*/
+			<0x0>, /* NUM1 access type*/
+			<0x0>; /* NUM1 mode*/
+		mt_2 = <0x0>, /* NUM2 Enable memory trash detection */
+			<0x0>, /* NUM2 start address*/
+			<0x0>, /* NUM2 end address*/
+			<0x0>, /* NUM2 module ID0*/
+			<0x0>, /* NUM2 module ID1*/
+			<0x0>, /* NUM2 module ID2*/
+			<0x0>, /* NUM2 module ID3*/
+			<0x0>, /* NUM2 interrupt to CPU*/
+			<0x0>, /* NUM2 access type*/
+			<0x0>; /* NUM2 mode*/
+		mt_3 = <0x0>,  /* NUM3 Enable memory trash detection */
+			<0x0>, /* NUM3 start address*/
+			<0x0>, /* NUM3 end address*/
+			<0x0>, /* NUM3 module ID0*/
+			<0x0>, /* NUM3 module ID1*/
+			<0x0>, /* NUM3 module ID2*/
+			<0x0>, /* NUM3 module ID3*/
+			<0x0>, /* NUM3 interrupt to CPU*/
+			<0x0>, /* NUM3 access type*/
+			<0x0>; /* NUM3 mode*/
+		mt_4 = <0x0>,  /* NUM4 Enable memory trash detection */
+			<0x0>, /* NUM4 start address*/
+			<0x0>, /* NUM4 end address*/
+			<0x0>, /* NUM4 module ID0*/
+			<0x0>, /* NUM4 module ID1*/
+			<0x0>, /* NUM4 module ID2*/
+			<0x0>, /* NUM4 module ID3*/
+			<0x0>, /* NUM4 interrupt to CPU*/
+			<0x0>, /* NUM4 access type*/
+			<0x0>; /* NUM4 mode*/
+		mt_5 = <0x0>,  /* NUM5 Enable memory trash detection */
+			<0x0>, /* NUM5 start address*/
+			<0x0>, /* NUM5 end address*/
+			<0x0>, /* NUM5 module ID0*/
+			<0x0>, /* NUM5 module ID1*/
+			<0x0>, /* NUM5 module ID2*/
+			<0x0>, /* NUM5 module ID3*/
+			<0x0>, /* NUM5 interrupt to CPU*/
+			<0x0>, /* NUM5 access type*/
+			<0x0>; /* NUM5 mode*/
+		mt_6 = <0x0>,  /* NUM6 Enable memory trash detection */
+			<0x0>, /* NUM6 start address*/
+			<0x0>, /* NUM6 end address*/
+			<0x0>, /* NUM6 module ID0*/
+			<0x0>, /* NUM6 module ID1*/
+			<0x0>, /* NUM6 module ID2*/
+			<0x0>, /* NUM6 module ID3*/
+			<0x0>, /* NUM6 interrupt to CPU*/
+			<0x0>, /* NUM6 access type*/
+			<0x0>; /* NUM6 mode*/
+		mt_7 = <0x0>,  /* NUM7 Enable memory trash detection */
+			<0x0>, /* NUM7 start address*/
+			<0x0>, /* NUM7 end address*/
+			<0x0>, /* NUM7 module ID0*/
+			<0x0>, /* NUM7 module ID1*/
+			<0x0>, /* NUM7 module ID2*/
+			<0x0>, /* NUM7 module ID3*/
+			<0x0>, /* NUM7 interrupt to CPU*/
+			<0x0>, /* NUM7 access type*/
+			<0x0>; /* NUM7 mode*/
+		status = "okay";
+	};
+};
\ No newline at end of file
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dfs.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dfs.dtsi
new file mode 100644
index 00000000..7a23fc8
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dfs.dtsi
@@ -0,0 +1,58 @@
+/*
+ * RTD-139X DFS with fixed CPU Voltage
+ */
+#include <dt-bindings/thermal/thermal.h>
+#include "rtd-139x-dvfs.dtsi"
+
+&i2c_0 {
+	status = "disabled";
+	/delete-node/ g2237;
+};
+
+&A53_0 {
+	/delete-property/ cpu-supply;
+};
+
+&A53_1 {
+	/delete-property/ cpu-supply;
+};
+
+&A53_2 {
+	/delete-property/ cpu-supply;
+};
+
+&A53_3 {
+	/delete-property/ cpu-supply;
+};
+
+&gpu {
+};
+
+&opp1000 {
+	opp-suspend;
+};
+
+&opp1200 {
+	/delete-property/ opp-suspend;
+	status = "disabled";
+};
+
+&opp1300 {
+	status = "disabled";
+};
+
+&opp1400 {
+	status = "disabled";
+};
+
+&cpu_thermal {
+	cooling-maps {
+		cpu-map0 {
+			cooling-device = <&A53_0 THERMAL_NO_LIMIT 3>;
+		};
+		cpu-map1 {
+			cooling-device = <&A53_0 4 THERMAL_NO_LIMIT>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dvfs-xenott.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dvfs-xenott.dtsi
new file mode 100644
index 00000000..1c7aab1
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dvfs-xenott.dtsi
@@ -0,0 +1,39 @@
+/*
+ * RTD-139x XEN OTT CPU DVFS
+ */
+
+/ {
+	/*
+	 * There is no following label in xenott dt, so create one to pervent
+	 * compile error and delete it later.
+	 */
+	A53_0:
+	A53_1:
+	A53_2:
+	A53_3:
+	i2c_0:
+	dummy:
+	dummy {};
+};
+
+#include "rtd-139x-dvfs.dtsi"
+
+/delete-node/ &dummy;
+
+&dvfs {
+	/delete-property/ cpu-supply;
+};
+
+/* remove cpu cooling device */
+&cpu_thermal {
+	trips {
+		/delete-node/ cpu-alert0;
+		/delete-node/ cpu-alert1;
+	};
+	cooling-maps {
+		/delete-node/ cpu-map0;
+		/delete-node/ cpu-map1;
+		/delete-node/ gpu-map0;
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dvfs.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dvfs.dtsi
new file mode 100644
index 00000000..9aa148c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-dvfs.dtsi
@@ -0,0 +1,313 @@
+/*
+ * RTD-139X DVFS with GMT G2237 PMIC
+ */
+#include <dt-bindings/regulator/gmt,g22xx.h>
+#include <dt-bindings/thermal/thermal.h>
+
+/* PMIC */
+&i2c_0 {
+	status = "okay";
+
+	g2237: g2237@12 {
+		compatible = "gmt,g2237";
+		reg = <0x12>;
+		status = "okay";
+		powerkey: powerkey {
+			compatible = "gmt,g22xx-powerkey";
+			lp-handler = "sw";
+			it-handler = "sw";
+			time-sel = <0 0 3>;
+			status = "disabled";
+		};
+		poweroff: poweroff {
+			compatible = "gmt,g22xx-poweroff";
+			system-power-controller;
+			status = "disabled";
+		};
+		regulators: regulators {
+			compatible = "gmt,g2237-regulator";
+			status = "okay";
+		};
+	};
+};
+
+&g2237 {
+	regulators {
+		vd33_supp: dc1 {
+			regulator-name = "vd33";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3700000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_FORCE_PWM>;
+
+		};
+		gpu_supp: dc2 {
+			regulator-name = "core";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+		};
+		cpu_supp: dc3 {
+			regulator-name = "cpudvs";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		ddr_supp: dc4 {
+			regulator-name = "ddr";
+			regulator-min-microvolt = <1500000>;
+			regulator-max-microvolt = <1500000>;
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-coldboot {
+				regulator-off-in-suspend;
+			};
+
+		};
+		vd18_supp: dc5 {
+			regulator-name = "vd18";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <2500000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+		};
+		vd25_supp: ldo1 {
+			regulator-name = "vd25";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3000000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_LDO_MODE_NORMAL>;
+			regulator-state-coldboot {
+				regulator-off-in-suspend;
+			};
+		};
+	};
+};
+
+/* CPU nodes */
+&A53_0 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+	dynamic-power-coefficient = <150>;
+};
+
+&A53_1 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+	dynamic-power-coefficient = <150>;
+};
+
+&A53_2 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+	dynamic-power-coefficient = <150>;
+};
+
+&A53_3 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+	dynamic-power-coefficient = <150>;
+};
+
+/* cpu opp table */
+&dvfs {
+	cpu_opps: opp-table-0 {
+		compatible = "operating-points-v2";
+		opp-shared;
+		opp300: opp-300mhz {
+			opp-hz = /bits/ 64 <300000000>;
+			opp-microvolt = <825000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp400: opp-400mhz {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-microvolt = <825000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		opp500: opp-500mhz {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-microvolt = <825000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp600: opp-600mhz {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-microvolt     = <825000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp700: opp-700mhz {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-microvolt     = <887500>;
+			opp-microvolt-a00 = <875000>;
+			opp-microvolt-a01 = <862500>;
+			opp-microvolt-a02 = <887500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp800: opp-800mhz {
+			opp-hz = /bits/ 64 <800000000>;
+			opp-microvolt     = <925000>;
+			opp-microvolt-a00 = <912500>;
+			opp-microvolt-a01 = <900000>;
+			opp-microvolt-a02 = <925000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp900: opp-900mhz {
+			opp-hz = /bits/ 64 <900000000>;
+			opp-microvolt     = <975000>;
+			opp-microvolt-a00 = <975000>;
+			opp-microvolt-a01 = <937500>;
+			opp-microvolt-a02 = <962500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1000: opp-1000mhz {
+			opp-hz = /bits/ 64 <1000000000>;
+			opp-microvolt     = <987500>;
+			opp-microvolt-a01 = <962500>;
+			opp-microvolt-a02 = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1100: opp-1100mhz {
+			opp-hz = /bits/ 64 <1100000000>;
+			opp-microvolt     = <1000000>;
+			opp-microvolt-a02 = <1050000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1200: opp-1200mhz {
+			opp-hz = /bits/ 64 <1200000000>;
+			opp-microvolt     = <1062500>;
+			opp-microvolt-a02 = <1100000>;
+			clock-latency-ns = <150000>;
+			opp-suspend;
+			status = "okay";
+		};
+		opp1300: opp-1300mhz {
+			opp-hz = /bits/ 64 <1300000000>;
+			opp-microvolt     = <1100000>;
+			opp-microvolt-a02 = <1150000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1400: opp-1400mhz {
+			opp-hz = /bits/ 64 <1400000000>;
+			opp-microvolt     = <1150000>;
+			opp-microvolt-a02 = <0>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+	};
+};
+
+/*
+ * thermal_zone
+ */
+&cpu_thermal {
+	trips {
+		tm_alert0: cpu-alert0 {
+			temperature = <105000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+		tm_alert1: cpu-alert1 {
+			temperature = <115000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+	};
+	cooling-maps {
+		cpu-map0 {
+			trip = <&tm_alert0>;
+			cooling-device = <&A53_0 THERMAL_NO_LIMIT 6>;
+			contribution = <70>;
+		};
+		cpu-map1 {
+			trip = <&tm_alert1>;
+			cooling-device = <&A53_0 7 THERMAL_NO_LIMIT>;
+			contribution = <70>;
+		};
+		gpu-map0 {
+			trip = <&tm_alert0>;
+			cooling-device = <&gpu THERMAL_NO_LIMIT THERMAL_NO_LIMIT>;
+			contribution = <30>;
+		};
+	};
+};
+
+&gpu {
+	#cooling-cells = <2>;
+	operating-points-v2 = <&gpu_opps>;
+	assigned-clocks =      <&cc CC_PLL_GPU>;
+	assigned-clock-rates = <750000000>;
+
+	gpu_opps: gpu-opp-table-0 {
+		compatible = "operating-points-v2";
+		opp-shared;
+		gopp300: opp-300mhz {
+			opp-hz = /bits/ 64 <300000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		gopp400: opp-400mhz {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		gopp500: opp-500mhz {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		gopp600: opp-600mhz {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		gopp700: opp-700mhz {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		gopp750: opp-750mhz {
+			opp-hz = /bits/ 64 <750000000>;
+			opp-microvolt = <1000000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-ion-1.5GB-vmx.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-ion-1.5GB-vmx.dtsi
new file mode 100644
index 00000000..0fae077
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-ion-1.5GB-vmx.dtsi
@@ -0,0 +1,21 @@
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+#define VMX_REQ_SIZE_0          (0x15E00000) // 350M
+
+#define ION_VMX_PHYS_0          (0x45800000)
+#define ION_VMX_SIZE_0  	(VMX_REQ_SIZE_0)
+#define ION_VMX_FLAG    	(RTK_FLAG_DEAULT)
+
+/memreserve/ ION_VMX_PHYS_0     VMX_REQ_SIZE_0;
+
+/ {
+    rtk,ion {
+	rtk,ion-heap@10 {    /* TYPE_VMX */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <10>;
+            rtk,memory-reserve = <
+                ION_VMX_PHYS_0 ION_VMX_SIZE_0 ION_VMX_FLAG
+                >;
+        };
+    };
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee-vmx.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee-vmx.dtsi
new file mode 100755
index 00000000..0e05072
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee-vmx.dtsi
@@ -0,0 +1,94 @@
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x15400000) // 340M
+#define SECURE_AUDIO_SIZE_1     (0x02800000) // 40M (4 audio decoder 20M + CVBS 19M)
+
+//#define SECURE_REQ_SIZE_0       (0xFA00000) // 300M-50M=250M
+//#define SECURE_AUDIO_SIZE_1     (0x03200000) // 50M (4 audio decoder 20M + DP 29M)
+
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+#define SECURE_AUDIO_REQ_SIZE   (0x00200000) // 2M
+//#define SECURE_TP_SIZE          (0x00300000) // 3M (single)
+//#define SECURE_TP_SIZE          (0x00600000) // 6M (dual)
+//#define SECURE_TP_SIZE          (0x00A10000) // 6M (dual) + DVR 4M + 64K
+#define SECURE_TP_SIZE            (0x01000000) // 16M
+
+
+#define ION_SECURE_AUDIO_PHYS_1  (0x32b00000) // 0x32b00000 should be equal to (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_AUDIO_SIZE_1  (SECURE_AUDIO_SIZE_1)
+#define ION_SECURE_AUDIO_FLAG_1  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_HEAP_PHYS_0   (ION_SECURE_AUDIO_PHYS_1 + SECURE_AUDIO_SIZE_1)
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+#define ION_SECURE_AUDIO_REQ_PHYS_0  (0x32600000)
+#define ION_SECURE_AUDIO_REQ_SIZE_0  (SECURE_AUDIO_REQ_SIZE)
+#define ION_SECURE_AUDIO_REQ_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0      ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0      ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1      ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_PHYS_1    ION_SECURE_AUDIO_SIZE_1;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_REQ_PHYS_0     ION_SECURE_AUDIO_REQ_SIZE_0;
+/memreserve/ ION_SECURE_TP_PHYS_0       ION_SECURE_TP_SIZE_0;
+
+/ {
+    rtk,ion {
+        rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+                ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+		ION_SECURE_AUDIO_PHYS_1 ION_SECURE_AUDIO_SIZE_1 ION_SECURE_AUDIO_FLAG_1
+                ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0 ION_SECURE_TP_FLAG_0 
+                >;
+        };
+        rtk,ion-heap@8 {    /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                ION_AUDIO_HEAP_PHYS_0 ION_AUDIO_HEAP_SIZE_0 ION_AUDIO_HEAP_FLAG_0
+                >;
+        };
+        rtk,ion-heap@7 {    /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+                ION_MEDIA_HEAP_PHYS_0 ION_MEDIA_HEAP_SIZE_0 ION_MEDIA_HEAP_FLAG_0
+                ION_MEDIA_HEAP_PHYS_1 ION_MEDIA_HEAP_SIZE_1 ION_MEDIA_HEAP_FLAG_1
+                >;
+        };
+    };
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee.dtsi
new file mode 100755
index 00000000..57de94d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-ion-2GB-tee.dtsi
@@ -0,0 +1,66 @@
+#include <dt-bindings/soc/rtd139x,memory.h>
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0      ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0      ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1      ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+/ {
+    rtk,ion {
+        rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0 ION_SECURE_HEAP_FLAG_0
+                ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0 ION_SECURE_AUDIO_FLAG_0
+                >;
+        };
+        rtk,ion-heap@8 {    /* Audio */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <8>;
+            rtk,memory-reserve = <
+                ION_AUDIO_HEAP_PHYS_0 ION_AUDIO_HEAP_SIZE_0 ION_AUDIO_HEAP_FLAG_0
+                >;
+        };
+        rtk,ion-heap@7 {    /* TYPE_MEDIA */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <7>;
+            rtk,memory-reserve = <
+                ION_MEDIA_HEAP_PHYS_0 ION_MEDIA_HEAP_SIZE_0 ION_MEDIA_HEAP_FLAG_0
+                ION_MEDIA_HEAP_PHYS_1 ION_MEDIA_HEAP_SIZE_1 ION_MEDIA_HEAP_FLAG_1
+                >;
+        };
+    };
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-irT377.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-irT377.dtsi
new file mode 100644
index 00000000..7711af7
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-irT377.dtsi
@@ -0,0 +1,61 @@
+/*
+ * rtd-139x-irT377.dtsi - IRDA remote Device Tree Include file for REALTEK 139x family SoC
+ */
+
+/ {
+	/*
+	 * IR RX protocol:
+	 * NEC = 1,  RC5 = 2, SHARP = 3, SONY = 4, C03 = 5,
+	 * RC6 = 6, RAW_NEC = 7, RCA = 8, PANASONIC = 9, KONKA=10,
+	 * RAW_RC6 = 11, RC6_MODE_6, TOSHIBA = 13
+	 * ----------------
+	 * IR RX protocol:
+	 * NEC_TX = 1, RC5_TX = 2, SHARP_TX = 3, SONY_TX = 4, C03_TX = 5
+	 * RC6_TX = 6, RCA_TX = 7, PANASONIC_TX = 8, KONKA_TX=9
+	 */
+	irda@98007400 {
+		Realtek,irrx-protocol = <1>;
+		Realtek,irtx-protocol = <1>;
+
+		Realtek,cust-code = <0x7F80>;
+		Realtek,scancode-msk = <0x00FF0000>;
+		Realtek,custcode-msk = <0x0000FFFF>;
+		Realtek,keymap-tbl = <
+			//scancode keycode
+			0x18 116 //KEY_POWER //POWER
+			0x5A 353 //KEY_SELECT //SOURCE
+			0x58 154 //KEY_CYCLEWINDOWS //PIP
+			0x1A 377 //KEY_TV //TV SYSTEM
+			0x14 102 //KEY_HOME //HOME
+			0x56 357 //KEY_OPTION //OPTION MENU
+			0x54 358 //KEY_INFO //MEDIA_INFO
+			0x19 232 //KEY_REPLY //REPEAT
+			0x57 158 //KEY_BACK //RETURN
+			0x55 207 //KEY_PLAY //PLAY/PAUSE
+			0x17 128 //KEY_STOP //STOP
+			0x15 372 //KEY_ZOOM //ZOOM_IN
+			0x4F 168 //KEY_REWIND //FR
+			0x4D 103 //KEY_UP //UP
+			0x16 208 //KEY_FASTFORWARD //FF
+			0x0C 105 //KEY_LEFT //LEFT
+			0x4C 352 //KEY_OK //OK
+			0x0E 106 //KEY_RIGHT //RIGHT
+			0x08 412 //KEY_PREVIOUS //PREVIOUS
+			0x48 108 //KEY_DOWN //DOWN
+			0x09 407 //KEY_NEXT //NEXT
+			0x4B 114 //KEY_VOLUMEDOWN //VOL-
+			0x49 115 //KEY_VOLUMEUP //VOL+
+			0x0B 532 //KEY_TOUCHPAD_OFF //CURSOR
+			0x0A 531 //KEY_TOUCHPAD_ON //GESTURE
+			0xEEEE 0 //REL_X //mouse X-axi 0xEEEE : REL event type
+			0xEEEE 1 //REL_Y //mouse Y-axi 0xEEEE : REL event type
+			0xFFFF 272 //BTN_LEFT //mouse left key	0xFFFF : KEY event type
+			0xFFFF 113 //KEY_MUTE //mute key in AirFunAPP 0xFFFF : KEY event type
+			>;
+		/*
+		 *  IR detect interval, NEC default=50ms, should less than 100ms,
+		 * and bigger than 9ms
+		 */
+		Realtek,reg-ir-dpir = <50>;
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-irda.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-irda.dtsi
new file mode 100644
index 00000000..b0ae4cd
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-irda.dtsi
@@ -0,0 +1,51 @@
+/*
+ * rtd-1395-irda.dtsi - IRDA remote Device Tree Include file for REALTEK 1295 family SoC
+ */
+
+/ {
+	irda@98007400 {
+		irda_rx0 {
+			irrx-protocol = "NEC";
+			transcode-mode = <1>;
+
+			cust-code = <0x7F80>;
+			scancode-msk = <0x00FF0000>;
+			custcode-msk = <0x0000FFFF>;
+			keymap-tbl = <
+			// scancode	keycode
+				0x18 	116		//KEY_POWER		//POWER
+				0x5A 	353		//KEY_SELECT		//SOURCE
+				0x58 	154		//KEY_CYCLEWINDOWS	//PIP
+				0x1A 	377		//KEY_TV		//TV SYSTEM
+				0x14 	102		//KEY_HOME		//HOME
+				0x56 	357		//KEY_OPTION		//OPTION MENU
+				0x54	358		//KEY_INFO		//MEDIA_INFO
+				0x19 	232		//KEY_REPLY		//REPEAT
+				0x57 	158		//KEY_BACK		//RETURN
+				0x55 	207		//KEY_PLAY		//PLAY/PAUSE
+				0x17 	128		//KEY_STOP		//STOP
+				0x15 	372		//KEY_ZOOM		//ZOOM_IN
+				0x4F 	168		//KEY_REWIND		//FR
+				0x4D 	103		//KEY_UP		//UP
+				0x16 	208		//KEY_FASTFORWARD	//FF
+				0x0C 	105		//KEY_LEFT		//LEFT
+				0x4C 	352		//KEY_OK		//OK
+				0x0E 	106		//KEY_RIGHT		//RIGHT
+				0x08 	412		//KEY_PREVIOUS		//PREVIOUS
+				0x48 	108		//KEY_DOWN		//DOWN
+				0x09 	407		//KEY_NEXT		//NEXT
+				0x4B 	114		//KEY_VOLUMEDOWN	//VOL-
+				0x49 	115		//KEY_VOLUMEUP		//VOL+
+				0x0B 	532		//KEY_TOUCHPAD_OFF	//CURSOR
+				0x0A 	531		//KEY_TOUCHPAD_ON	//GESTURE
+				0xEEEE	0		//REL_X			//mouse X-axi	0xEEEE : REL event type
+				0xEEEE	1		//REL_Y			//mouse Y-axi	0xEEEE : REL event type
+				0xFFFF	272		//BTN_LEFT		//mouse left key	0xFFFF : KEY event type
+				0xFFFF	113     	//KEY_MUTE 		//mute key in AirFunAPP	0xFFFF : KEY event type	
+			>;
+			reg-ir-dpir = <50>;	/*IR detect interval, NEC default=50ms, should less than 100ms, and bigger than 9ms*/
+			sample-rate = <40>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-pcie.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-pcie.dtsi
new file mode 100644
index 00000000..1004c1d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-pcie.dtsi
@@ -0,0 +1,72 @@
+/ {
+	pcie: pcie@98060000 {
+		compatible = "realtek,rtk139x-pcie";
+		reg = <0x98060000 0x00001000
+			0x98061000 0x00001000
+			0x9801C800 0x00000100
+			0x9801A000 0x00000300>;
+		interrupt-names = "rtk-pcie1-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic GIC_SPI 61 IRQ_TYPE_LEVEL_HIGH>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <0>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 29 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys = <0x00000003>, /* #Write soft reset */
+			<0x27710301>,
+			<0x52F50401>,/* #F code,close SSC */
+			<0xead70501>,/* #modify N code */
+			<0x00080601>,/* #modify CMU ICP(TX jitter) */
+			<0xb6530a01>,/* #modify CMU RS(tx jitter) */
+			<0xc4552001>,/* #modify AMP */
+			<0x8EA01B01>,
+			<0x8EA05B01>,
+			<0x55552101>,
+			<0x505c0101>,/* #modify Rx parameter */
+			<0xa8032b01>,/* #clk driving */
+			<0x27e94301>,/* #EQ */
+			<0x52f54401>,/* #F code,close SSC */
+			<0xead74501>,/* #modify N code */
+			<0x00004601>,/* #modify CMU ICP(TX jitter) */
+			<0x86534a01>,/* #modify CMU RS(tx jitter) */
+			<0xc4666001>,/* #modify AMP */
+			<0x55556101>,
+			<0xa84a4101>,/* #modify Rx parameter */
+			<0xa8036b01>,/* #clk driving */
+			<0x01225a01>,
+			<0xf8022801>,
+			<0x521C0901>,
+			<0x501C0901>,
+			<0x521C0901>;
+
+		debug-mode = <0>;
+		//speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x98062000  0x98062000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00030000  0x00030000 0x00000000 0x00010000>;
+		resets = <&rst2 RSTN_PCIE0>,
+			<&rst2 RSTN_PCIE0_CORE>,
+			<&rst2 RSTN_PCIE0_POWER>,
+			<&rst2 RSTN_PCIE0_NONSTITCH>,
+			<&rst2 RSTN_PCIE0_STITCH>,
+			<&rst2 RSTN_PCIE0_PHY>,
+			<&rst4 RSTN_PCIE0_PHY_MDIO>,
+			<&rst4 RSTN_PCIE0_SGMII_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio",
+			"sgmii_mdio";
+		clocks = <&clk_en_1 CLK_EN_PCIE0>;
+		status = "okay";
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-pinctrl.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-pinctrl.dtsi
new file mode 100644
index 00000000..95d2ff1
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-pinctrl.dtsi
@@ -0,0 +1,339 @@
+
+/ {
+	pinctrl@9804E000 {
+	sdcard_pins_low: sdcard_low {
+	        realtek,pins= "gpio_39",
+		"gpio_38",
+		"gpio_37",
+		"gpio_36",
+		"gpio_33",
+		"gpio_32";
+	        realtek,function="mmc";
+	        realtek,pull_en = <1>;
+	        realtek,pull_sel = <0>;
+	};
+
+	sdcard_pins_high: sdcard_high {
+	        realtek,pins="gpio_35", "gpio_34";
+	        realtek,function="mmc";
+	        realtek,pull_en = <1>;
+	        realtek,pull_sel = <1>;
+	};
+
+	sdio_pins_0: sdio_pins_0 {
+	        realtek,pins = "gpio_32",
+		"gpio_33",
+		"gpio_36",
+		"gpio_37",
+		"gpio_38",
+		"gpio_39",
+		"sdio_loc";
+	        realtek,function = "sdio_loc0";
+	};
+
+		sdio_pins_1: sdio_pins_1 {
+	        realtek,pins = "gpio_40",
+		"gpio_41",
+		"gpio_42",
+		"gpio_43",
+		"gpio_44",
+		"gpio_45",
+		"sdio_loc";
+	        realtek,function = "sdio_loc1";
+	};
+
+
+	uart0_pins: uart0_pins {
+	        realtek,pins = "ur0_rx",
+		"ur0_tx";
+	        realtek,function = "uart0";
+	};
+
+	uart1_pins: uart1_pins {
+	        realtek,pins = "gpio_8",
+		"gpio_9";
+	        realtek,function = "uart1";
+	};
+
+	uart2_pins_0: uart2_pins_0 {
+	        realtek,pins = "ur2_loc",
+		"gpio_18",
+		"gpio_19",
+		"gpio_20",
+		"gpio_31";
+	        realtek,function = "uart2_loc0";
+	};
+
+	uart2_pins_1: uart2_pins_1 {
+	        realtek,pins ="ur2_loc",
+		"gpio_25",
+		"gpio_26",
+		"gpio_27",
+		"gpiio_28";
+	        realtek,function = "uart2_loc1";
+	};
+
+	i2c_pins_0: i2c_pins_0 {
+	        realtek,pins = "gpio_12",
+		"gpio_13";
+	        realtek,function = "i2c0";
+	};
+
+	i2c_pins_1: i2c_pins_1 {
+	        realtek,pins = "gpio_16",
+		"gpio_17";
+	        realtek,function = "i2c1";
+	};
+
+
+	i2c_pins_5: i2c_pins_5 {
+	        realtek,pins = "spi_ce_n",
+		"spi_si";
+	        realtek,function = "i2c5";
+	};
+
+	spi_pins_loc_spi: spi_pins_loc_spi {
+	        realtek,pins = "spi_ce_n",
+		"spi_sck",
+		"spi_so",
+		"spi_si",
+		"sf_en";
+	        realtek,function = "spi";
+	};
+
+	gspi_pins_0: gspi_pins_0 {
+	        realtek,pins = "gspi_loc",
+		"gpio_18",
+		"gpio_19",
+		"gpio_20",
+				"gpio_31";
+	        realtek,function = "gspi_loc0";
+	};
+
+		gspi_pins_1: gspi_pins_1 {
+	        realtek,pins = "gspi_loc",
+		"gpio_25",
+		"gpio_26",
+		"gpio_27",
+				"gpio_28";
+	        realtek,function = "gspi_loc1";
+	};
+
+		smartcard_pins:smartcard_pins{
+			realtek,pins = "gpio_18",
+		"gpio_19",
+		"gpio_20",
+		"gpio_31";
+	        realtek,function = "sc_loc0";
+		};
+
+	tp0_loc_tp0_pins: tp0_loc_tp0_pins {
+	        realtek,pins = "gpio_8",
+		"gpio_9",
+		"gpio_10",
+		"gpio_11";
+	        realtek,function = "tp0";
+	};
+
+	tp1_loc_tp1_pins: tp1_loc_tp1_pins {
+	        realtek,pins = "gpio_36",
+		"gpio_37",
+		"gpio_38",
+		"gpio_39";
+	        realtek,function = "tp1_loc_tp1";
+	};
+
+	ir_rx_pins: ir_rx_pins {
+	        realtek,pins = "ir_rx";
+	        realtek,function = "ir_rx";
+	};
+
+	spdif_pins: spdif_pins {
+	        realtek,pins = "gpio_50";
+	        realtek,function = "spdif";
+	};
+
+	i2s_out_4pins: i2s_out_4pins {
+	        realtek,pins ="gpio_2",
+		"gpio_3",
+		"gpio_4",
+		"gpio_5";
+	        realtek,function = "ao";
+	};
+
+	i2s_in_pins: i2s_in_pins {
+		realtek,pins = "gpio_6";
+		realtek,function = "ai";
+	};
+
+	etn_led_pins: etn_led_pins {
+	        realtek,pins = "gpio_14",
+		"gpio_15";
+	        realtek,function = "etn_led";
+	};
+
+	sgmii_mdio_pins: sgmii_mdio_pins {
+	        realtek,pins = "gpio_29",
+		"gpio_46";
+	        realtek,function = "extphy";
+	};
+
+	pcie_clk_pins: pcie_clk_pins {
+	        realtek,pins = "gpio_46";
+	        realtek,function = "pcie";
+	};
+
+	scpu_ejtag_pins_loc_0: scpu_ejtag_pins_loc_0 {
+	        realtek,pins = "gpio_2",
+		"gpio_3",
+		"gpio_4",
+		"gpio_5",
+		"gpio_6",
+		"ejtag_scpu_loc";
+	        realtek,function = "scpu_ejtag_loc0";
+	};
+
+	scpu_ejtag_pins_loc_1: scpu_ejtag_pins_loc_1 {
+	        realtek,pins = "gpio_32",
+		"gpio_33",
+		"gpio_36",
+		"gpio_37",
+		"gpio_39",
+		"ejtag_scpu_loc";
+	        realtek,function = "scpu_ejtag_loc1";
+	};
+
+		acpu_ejtag_pins_loc_0: acpu_ejtag_pins_loc_0 {
+	        realtek,pins = "gpio_2",
+		"gpio_3",
+		"gpio_4",
+		"gpio_5",
+		"gpio_6",
+		"ejtag_acpu_loc";
+	        realtek,function = "acpu_ejtag_loc0";
+	};
+
+	acpu_ejtag_pins_loc_1: acpu_ejtag_pins_loc_1 {
+	        realtek,pins = "gpio_32",
+		"gpio_33",
+		"gpio_36",
+		"gpio_37",
+		"gpio_39",
+		"ejtag_avcpu_loc";
+	        realtek,function = "acpu_ejtag_loc1";
+	};
+
+	dc_fan_sensor_pins: dc_fan_sensor_pins {
+	        realtek,pins = "gpio_47";
+	        realtek,function = "dc_fan_sensor";
+	};
+
+	pwm0_0_pins: pwm0_0_pins {
+	        realtek,pins = "gpio_12";
+	        realtek,function = "pwm0";
+	};
+
+	pwm0_1_pins: pwm0_1_pins {
+	        realtek,pins = "gpio_20";
+	        realtek,function = "pwm0";
+	};
+
+	pwm1_0_pins: pwm1_0_pins {
+	        realtek,pins = "gpio_13";
+	        realtek,function = "pwm1";
+	};
+
+	pwm1_1_pins: pwm1_1_pins {
+	        realtek,pins = "gpio_21";
+	        realtek,function = "pwm1";
+	};
+
+	pwm2_0_pins: pwm2_0_pins {
+	        realtek,pins = "gpio_14";
+	        realtek,function = "pwm2";
+	};
+
+	pwm2_1_pins: pwm2_1_pins {
+	        realtek,pins = "gpio_22";
+	        realtek,function = "pwm2";
+	};
+
+	pwm3_0_pins: pwm3_0_pins {
+	        realtek,pins = "gpio_15";
+	        realtek,function = "pwm3";
+	};
+
+	pwm3_1_pins: pwm3_1_pins {
+	        realtek,pins = "gpio_23";
+	        realtek,function = "pwm3";
+	};
+
+	pwm0_0_pins_disable: pwm0_0_pins_disable {
+	        realtek,pins = "gpio_12";
+	        realtek,function = "gpio";
+	};
+
+	pwm0_1_pins_disable: pwm0_1_pins_disable {
+	        realtek,pins = "gpio_20";
+	        realtek,function = "gpio";
+	};
+
+	pwm1_0_pins_disable: pwm1_0_pins_disable {
+	        realtek,pins = "gpio_13";
+	        realtek,function = "gpio";
+	};
+
+	pwm1_1_pins_disable: pwm1_1_pins_disable {
+	        realtek,pins = "gpio_21";
+	        realtek,function = "gpio";
+	};
+
+	pwm2_0_pins_disable: pwm2_0_pins_disable {
+	        realtek,pins = "gpio_14";
+	        realtek,function = "gpio";
+	};
+
+	pwm2_1_pins_disable: pwm2_1_pins_disable {
+	        realtek,pins = "gpio_22";
+	        realtek,function = "gpio";
+	};
+
+	pwm3_0_pins_disable: pwm3_0_pins_disable {
+	        realtek,pins = "gpio_15";
+	        realtek,function = "gpio";
+	};
+
+	pwm3_1_pins_disable: pwm3_1_pins_disable {
+	        realtek,pins = "gpio_23";
+	        realtek,function = "gpio";
+	};
+
+		usb_cc1_pins: usb_cc1_pins {
+			realtek,pins = "usb_cc1";
+	        realtek,function = "usb_cc1";
+		};
+
+		usb_cc2_pins: usb_cc2_pins {
+	        realtek,pins = "usb_cc2";
+	        realtek,function = "usb_cc2";
+	};
+
+		rtc_pins: rtc_pins {
+			realtek,pins = "gpio_25";
+	        realtek,function = "rtc";
+		};
+
+		prob0_pins: prob0_pins{
+			realtek,pins = "prob_0";
+	        realtek,function = "gpio";
+		};
+
+		prob1_pins: prob1_pins{
+	        realtek,pins = "prob_1";
+	        realtek,function = "gpio";
+	};
+
+
+        };
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-usb.dtsi
new file mode 100644
index 00000000..fb2397a
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-usb.dtsi
@@ -0,0 +1,246 @@
+/*
+ * realtek,type_c-power-gpio: TypeC power, output, default low
+ * realtek,u2host-power-gpio: ehci and u2host power, output, default low
+ * realtek,u3host-power-gpio: 1296 u3host power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		reg = <0x98000000 0x10>;
+
+		//usb_iso_mode;  /* ISO mode is only port suspend (Default disable) */
+		//en_usb_storage_reprobe; /* To enable usb storage re-probe*/
+		//rescue_usb; /* For rescue dtb use */
+
+		clocks = <&iclk_en 16>, /* clk_en_usb */
+			<&iclk_en 13>,  /* clk_en_usb_drd */
+			<&iclk_en 14>,  /* clk_en_usb_host_0 */
+			<&iclk_en 15>;  /* clk_en_usb_host_1 */
+		clock-names = "clk_en_usb", /*clk_en_usb*/
+			"clk_en_phy0_to_host", /*clk_en_usb_drd*/
+			"clk_en_phy1_to_host", /*clk_en_usb_host_0*/
+			"clk_en_phy2_to_host"; /*clk_en_usb_host_1*/
+
+		resets =
+			<&iasr 0x100>,
+			<&irst 14>, /* rstn_usb_drd */
+			<&irst 15>, /* rstn_usb_host */
+			<&iasr 16>, /* rstn_usb_phy_0 */
+			<&iasr 17>, /* rstn_usb_phy_1 */
+			<&iasr 18>, /* rstn_usb_phy_2 */
+			<&irst 19>, /* rstn_usb */
+			<&irst 20>; /* rstn_type_c */
+
+		reset-names = "apply",
+			"usb_host0", /*rstn_usb_drd*/
+			"usb_host1", /*rstn_usb_host*/
+			"u2phy0", /*rstn_usb_phy_0*/
+			"u2phy1", /*rstn_usb_phy_1*/
+			"u2phy2", /*rstn_usb_phy_2*/
+			"usb", /*rstn_usb*/
+			"type_c"; /*rstn_type_c*/
+
+		gpio0: gpio0 {
+			realtek,power-gpio = <&rtk_iso_gpio 48 1 3>;
+			power_low_active;
+
+		};
+		gpio1: gpio1 {
+			realtek,power-gpio = <&rtk_iso_gpio 49 1 3>;
+			power_low_active;
+		};
+
+		port0 {
+			usb = <&dwc3_drd>;
+			type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+			gpio = <&gpio0>;
+		};
+		port1 {
+			usb = <&dwc3_u2host>;
+			//gpio = <&gpio1>;
+		};
+		port2 {
+			usb = <&dwc3_u2host>;
+			gpio = <&gpio1>;
+		};
+
+		rtk_usb {
+			power_ctrl_reg {
+				usb_ctrl = <0x98007fb0>;
+				/* Port 0~2 */
+				usb0_sram_pwr3 = <0x98007f7c>;
+				usb0_sram_pwr4 = <0x98007f80>;
+
+				/* l4_icg */
+				p0_l4_icg = <0x98013364>;
+				p1_l4_icg = <0x98013d60>;
+
+				usb_power_cut; /* Non ISO mode and power cut (Default disable power cut) */
+				               /* Note if enable ISO mode, then power_cut will not effective*/
+			};
+			type_c {
+				realtek,connector_switch-gpio = <&rtk_iso_gpio 11 1 1>;
+			};
+		};
+	};
+
+	dwc3_drd_usb2phy: dwc3_drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x98028280 0x4>, <0x98013214 0x4>;
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0x81 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		reg = <0x98013200 0x200>;
+		interrupts = <0 21 4>;
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x98020000 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_drd_usb2phy>;
+			dr_mode = "peripheral"; /*otg, host, peripheral*/
+			//tx-fifo-resize;
+			snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+		};
+
+		dwc3_type_c: rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			reg = <0x98013200 0x200 0x98007220 0x20>;
+			interrupts = <0 60 4>;
+			drd_mode;  /*depend on dwc3 dr_mode = "peripheral"*/
+			//debug; /*to enable debug log*/
+			delay_probe_work; /*To delay probe work*/
+			ordered_probe; /*ordered probe in delay work*/
+			boot_check_time = <30000>; /*ms (At boot Device switch Host time)*/
+			filter_config_channel_signal; /* A sw debounce to filter cc signal */
+
+			default_revision = <0xA00>;
+			A00 {
+				cc_dfp_mode = "dfp_3_0"; /*dfp_3_0, dfp_1_5, dfp_usb*/
+				rd_config = "internal"; /*internal, extrenal*/
+				cc1_rp_4p7k_code = <0xC>;
+				cc1_rp_36k_code = <0xB>;
+				cc1_rp_12k_code = <0xE>;
+				cc1_rd_code = <0x10>; /*for internal rd*/
+				cc1_vref_ufp = /bits/ 8
+					<0x1 0x0 0x0>; /*<1p23v,0p66v,0p2v>*/
+				cc1_vref_dfp_usb = /bits/ 8
+					<0x7 0x0 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc1_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x0>; /*<1_1p6v,0p4v,0p2v>*/
+				cc1_vref_dfp_3_0 = /bits/ 8
+					<0x0 0x0 0x0>; /*<2p6v,0p8v,0p2v>*/
+				cc2_rp_4p7k_code = <0xB>;
+				cc2_rp_36k_code = <0x9>;
+				cc2_rp_12k_code = <0xE>;
+				cc2_rd_code = <0xF>; /*for internal rd*/
+				cc2_vref_ufp = /bits/ 8
+					<0x3 0x2 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc2_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc2_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc2_vref_dfp_3_0 = /bits/ 8
+					<0x1 0x3 0x2>; /*<2p6v,0p8v,0p2v>*/
+			};
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x98031280 0x4>, <0x98031284 0x4>, <0x98013C14 0x4>;
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+		phyN = <2>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0x81 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+		phy1 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0x81 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x00 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013E00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x98013C00 0x200>;
+		interrupts = <0 21 4>;
+		#address-cells = <1>;
+		#size-cells = <1>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "okay";
+
+		dwc3_u2host@98029000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x98029000 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_u2host_usb2phy>;
+			dr_mode = "host"; /*only host*/
+			//tx-fifo-resize;
+			snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+		};
+	};
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-xen-irda-domu.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-xen-irda-domu.dtsi
new file mode 100644
index 00000000..2d96926
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-xen-irda-domu.dtsi
@@ -0,0 +1,53 @@
+/*
+ * rtd-1395-irda.dtsi - IRDA remote Device Tree Include file for REALTEK 1295 family SoC
+ */
+
+/ {
+	passthrough {
+	irda@98007400 {
+		irda_rx0 {
+			irrx-protocol = "NEC";
+			transcode-mode = <1>;
+
+			cust-code = <0x7F80>;
+			scancode-msk = <0x00FF0000>;
+			custcode-msk = <0x0000FFFF>;
+			keymap-tbl = <
+			// scancode	keycode
+				0x18 	116		//KEY_POWER		//POWER
+				0x5A 	353		//KEY_SELECT		//SOURCE
+				0x58 	154		//KEY_CYCLEWINDOWS	//PIP
+				0x1A 	377		//KEY_TV		//TV SYSTEM
+				0x14 	102		//KEY_HOME		//HOME
+				0x56 	357		//KEY_OPTION		//OPTION MENU
+				0x54	358		//KEY_INFO		//MEDIA_INFO
+				0x19 	232		//KEY_REPLY		//REPEAT
+				0x57 	158		//KEY_BACK		//RETURN
+				0x55 	207		//KEY_PLAY		//PLAY/PAUSE
+				0x17 	128		//KEY_STOP		//STOP
+				0x15 	372		//KEY_ZOOM		//ZOOM_IN
+				0x4F 	168		//KEY_REWIND		//FR
+				0x4D 	103		//KEY_UP		//UP
+				0x16 	208		//KEY_FASTFORWARD	//FF
+				0x0C 	105		//KEY_LEFT		//LEFT
+				0x4C 	352		//KEY_OK		//OK
+				0x0E 	106		//KEY_RIGHT		//RIGHT
+				0x08 	412		//KEY_PREVIOUS		//PREVIOUS
+				0x48 	108		//KEY_DOWN		//DOWN
+				0x09 	407		//KEY_NEXT		//NEXT
+				0x4B 	114		//KEY_VOLUMEDOWN	//VOL-
+				0x49 	115		//KEY_VOLUMEUP		//VOL+
+				0x0B 	532		//KEY_TOUCHPAD_OFF	//CURSOR
+				0x0A 	531		//KEY_TOUCHPAD_ON	//GESTURE
+				0xEEEE	0		//REL_X			//mouse X-axi	0xEEEE : REL event type
+				0xEEEE	1		//REL_Y			//mouse Y-axi	0xEEEE : REL event type
+				0xFFFF	272		//BTN_LEFT		//mouse left key	0xFFFF : KEY event type
+				0xFFFF	113     	//KEY_MUTE 		//mute key in AirFunAPP	0xFFFF : KEY event type	
+			>;
+			reg-ir-dpir = <50>;	/*IR detect interval, NEC default=50ms, should less than 100ms, and bigger than 9ms*/
+			sample-rate = <40>;
+		};
+	};
+	}; /* passthrough */
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-xen-pinctrl-domu.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-xen-pinctrl-domu.dtsi
new file mode 100644
index 00000000..3c3dfec
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-xen-pinctrl-domu.dtsi
@@ -0,0 +1,301 @@
+
+/ {
+	passthrough {
+	pinctrl@9804E000 {
+	sdcard_pins_low: sdcard_low {
+	        realtek,pins= "gpio_39",
+		"gpio_38",
+		"gpio_37",
+		"gpio_36",
+		"gpio_33",
+		"gpio_32";
+	        realtek,function="mmc";
+	        realtek,pull_en = <1>;
+	        realtek,pull_sel = <0>;
+	};
+
+	sdcard_pins_high: sdcard_high {
+	        realtek,pins="gpio_35", "gpio_34";
+	        realtek,function="mmc";
+	        realtek,pull_en = <1>;
+	        realtek,pull_sel = <1>;
+	};
+
+	sdio_pins_0: sdio_pins_0 {
+	        realtek,pins = "gpio_32",
+		"gpio_33",
+		"gpio_36",
+		"gpio_37",
+		"gpio_38",
+		"gpio_39",
+		"sdio_loc";
+	        realtek,function = "sdio_loc0";
+	};
+
+		sdio_pins_1: sdio_pins_1 {
+	        realtek,pins = "gpio_40",
+		"gpio_41",
+		"gpio_42",
+		"gpio_43",
+		"gpio_44",
+		"gpio_45",
+		"sdio_loc";
+	        realtek,function = "sdio_loc1";
+	};
+
+
+	uart0_pins: uart0_pins {
+	        realtek,pins = "ur0_rx",
+		"ur0_tx";
+	        realtek,function = "uart0";
+	};
+
+	uart1_pins: uart1_pins {
+	        realtek,pins = "gpio_8",
+		"gpio_9";
+	        realtek,function = "uart1";
+	};
+
+	uart2_pins_0: uart2_pins_0 {
+	        realtek,pins = "ur2_loc",
+		"gpio_18",
+		"gpio_19",
+		"gpio_20",
+		"gpio_31";
+	        realtek,function = "uart2_loc0";
+	};
+
+	uart2_pins_1: uart2_pins_1 {
+	        realtek,pins ="ur2_loc",
+		"gpio_25",
+		"gpio_26",
+		"gpio_27",
+		"gpiio_28";
+	        realtek,function = "uart2_loc1";
+	};
+
+	i2c_pins_0: i2c_pins_0 {
+	        realtek,pins = "gpio_12",
+		"gpio_13";
+	        realtek,function = "i2c0";
+	};
+
+	i2c_pins_1: i2c_pins_1 {
+	        realtek,pins = "gpio_16",
+		"gpio_17";
+	        realtek,function = "i2c1";
+	};
+
+
+	i2c_pins_5: i2c_pins_5 {
+	        realtek,pins = "spi_ce_n",
+		"spi_si";
+	        realtek,function = "i2c5";
+	};
+
+	spi_pins_loc_spi: spi_pins_loc_spi {
+	        realtek,pins = "spi_ce_n",
+		"spi_sck",
+		"spi_so",
+		"spi_si",
+		"sf_en";
+	        realtek,function = "spi";
+	};
+
+	gspi_pins_0: gspi_pins_0 {
+	        realtek,pins = "gspi_loc",
+		"gpio_18",
+		"gpio_19",
+		"gpio_20",
+				"gpio_31";
+	        realtek,function = "gspi_loc0";
+	};
+
+		gspi_pins_1: gspi_pins_1 {
+	        realtek,pins = "gspi_loc",
+		"gpio_25",
+		"gpio_26",
+		"gpio_27",
+				"gpio_28";
+	        realtek,function = "gspi_loc1";
+	};
+
+		smartcard_pins:smartcard_pins{
+			realtek,pins = "gpio_18",
+		"gpio_19",
+		"gpio_20",
+		"gpio_31";
+	        realtek,function = "sc_loc0";
+		};
+
+	tp0_loc_tp0_pins: tp0_loc_tp0_pins {
+	        realtek,pins = "gpio_8",
+		"gpio_9",
+		"gpio_10",
+		"gpio_11";
+	        realtek,function = "tp0";
+	};
+
+	tp1_loc_tp1_pins: tp1_loc_tp1_pins {
+	        realtek,pins = "gpio_36",
+		"gpio_37",
+		"gpio_38",
+		"gpio_39";
+	        realtek,function = "tp1_loc_tp1";
+	};
+
+	ir_rx_pins: ir_rx_pins {
+	        realtek,pins = "ir_rx";
+	        realtek,function = "ir_rx";
+	};
+
+	spdif_pins: spdif_pins {
+	        realtek,pins = "gpio_50";
+	        realtek,function = "spdif";
+	};
+
+	i2s_out_4pins: i2s_out_4pins {
+	        realtek,pins ="gpio_2",
+		"gpio_3",
+		"gpio_4",
+		"gpio_5";
+	        realtek,function = "ao";
+	};
+
+	i2s_in_pins: i2s_in_pins {
+		realtek,pins = "gpio_6";
+		realtek,function = "ai";
+	};
+
+	etn_led_pins: etn_led_pins {
+	        realtek,pins = "gpio_14",
+		"gpio_15";
+	        realtek,function = "etn_led";
+	};
+
+	sgmii_mdio_pins: sgmii_mdio_pins {
+	        realtek,pins = "gpio_29",
+		"gpio_46";
+	        realtek,function = "extphy";
+	};
+
+	pcie_clk_pins: pcie_clk_pins {
+	        realtek,pins = "gpio_46";
+	        realtek,function = "pcie";
+	};
+
+	scpu_ejtag_pins_loc_0: scpu_ejtag_pins_loc_0 {
+	        realtek,pins = "gpio_2",
+		"gpio_3",
+		"gpio_4",
+		"gpio_5",
+		"gpio_6",
+		"ejtag_scpu_loc";
+	        realtek,function = "scpu_ejtag_loc0";
+	};
+
+	scpu_ejtag_pins_loc_1: scpu_ejtag_pins_loc_1 {
+	        realtek,pins = "gpio_32",
+		"gpio_33",
+		"gpio_36",
+		"gpio_37",
+		"gpio_39",
+		"ejtag_scpu_loc";
+	        realtek,function = "scpu_ejtag_loc1";
+	};
+
+		acpu_ejtag_pins_loc_0: acpu_ejtag_pins_loc_0 {
+	        realtek,pins = "gpio_2",
+		"gpio_3",
+		"gpio_4",
+		"gpio_5",
+		"gpio_6",
+		"ejtag_acpu_loc";
+	        realtek,function = "acpu_ejtag_loc0";
+	};
+
+	acpu_ejtag_pins_loc_1: acpu_ejtag_pins_loc_1 {
+	        realtek,pins = "gpio_32",
+		"gpio_33",
+		"gpio_36",
+		"gpio_37",
+		"gpio_39",
+		"ejtag_avcpu_loc";
+	        realtek,function = "acpu_ejtag_loc1";
+	};
+
+	dc_fan_sensor_pins: dc_fan_sensor_pins {
+	        realtek,pins = "gpio_47";
+	        realtek,function = "dc_fan_sensor";
+	};
+
+	pwm0_0_pins: pwm0_0_pins {
+	        realtek,pins = "gpio_12";
+	        realtek,function = "pwm0";
+	};
+
+	pwm0_1_pins: pwm0_1_pins {
+	        realtek,pins = "gpio_20";
+	        realtek,function = "pwm0";
+	};
+
+	pwm1_0_pins: pwm1_0_pins {
+	        realtek,pins = "gpio_13";
+	        realtek,function = "pwm1";
+	};
+
+	pwm1_1_pins: pwm1_1_pins {
+	        realtek,pins = "gpio_21";
+	        realtek,function = "pwm1";
+	};
+
+	pwm2_0_pins: pwm2_0_pins {
+	        realtek,pins = "gpio_14";
+	        realtek,function = "pwm2";
+	};
+
+	pwm2_1_pins: pwm2_1_pins {
+	        realtek,pins = "gpio_22";
+	        realtek,function = "pwm2";
+	};
+
+	pwm3_0_pins: pwm3_0_pins {
+	        realtek,pins = "gpio_15";
+	        realtek,function = "pwm3";
+	};
+
+	pwm3_1_pins: pwm3_1_pins {
+	        realtek,pins = "gpio_23";
+	        realtek,function = "pwm3";
+	};
+
+		usb_cc1_pins: usb_cc1_pins {
+			realtek,pins = "usb_cc1";
+	        realtek,function = "usb_cc1";
+		};
+
+		usb_cc2_pins: usb_cc2_pins {
+	        realtek,pins = "usb_cc2";
+	        realtek,function = "usb_cc2";
+	};
+
+		rtc_pins: rtc_pins {
+			realtek,pins = "gpio_25";
+	        realtek,function = "rtc";
+		};
+
+		prob0_pins: prob0_pins{
+			realtek,pins = "prob_0";
+	        realtek,function = "gpio";
+		};
+
+		prob1_pins: prob1_pins{
+	        realtek,pins = "prob_1";
+	        realtek,function = "gpio";
+	};
+
+
+        }; /* pinctrl@9804E000 */
+	}; /* passthrough */
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-xen.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-xen.dtsi
new file mode 100644
index 00000000..036bdfb
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x-xen.dtsi
@@ -0,0 +1,1136 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include <dt-bindings/thermal/thermal.h>
+#include <dt-bindings/clock/rtk,clock-rtd139x.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <dt-bindings/reset/rtk,reset-rtd139x.h>
+#include <dt-bindings/power/rtk,power-rtd139x.h>
+/include/ "rtd-139x-pinctrl.dtsi"
+/include/ "rtd-139x-irda.dtsi"
+/include/ "rtd-1395-usb.dtsi"
+/* /include/ "rtd-1395-usb-xen-pass.dtsi" */
+/include/ "rtd-139x-dcsys-debug.dtsi"
+
+/{
+	compatible = "realtek,rtd1395";
+	interrupt-parent = <&gic>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+
+	aliases {
+		serial0 = &uart0;
+		i2c0 = &i2c_0;
+		/* i2c1 = &i2c_1; */
+		i2c5 = &i2c_5;
+		hwsem0 = &sb2_lock1;
+		hwsem1 = &sb2_lock2;
+	};
+
+
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A53_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x0>;
+			enable-method = "rtk-spin-table";
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+			dynamic-power-coefficient = <150>;
+		};
+
+		A53_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x1>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+			dynamic-power-coefficient = <150>;
+		};
+
+		A53_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x02>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+			dynamic-power-coefficient = <150>;
+		};
+
+		A53_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x03>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a53_l2>;
+			clocks = <&cc CC_PLL_SCPU>;
+			cpu-supply = <&cpu_supp>;
+			operating-points-v2 = <&cpu_opps>;
+			#cooling-cells = <2>;
+			dynamic-power-coefficient = <150>;
+		};
+
+		a53_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	soc@0 {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x98000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+	};
+
+	efuse@98017000 {
+		compatible = "realtek,efuse";
+		reg = <0x98017000 0x400>;
+		read-only;
+		status = "okay";
+
+		#address-cells = <1>;
+		#size-cells = <1>;
+	};
+
+	/* maybe used in domu */
+	sb2_lock0: sb2-lock@9801A000 {
+		compatible = "realtek,sb2-sem";
+		reg = <0x9801A000 0x4>;
+	};
+
+	sb2_lock1: sb2-lock@9801A620 {
+		reg = <0x9801A620 0x4>;
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+	};
+
+	sb2_lock2: sb2-lock@9801A624 {
+		reg = <0x9801A624 0x4>;
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+	};
+
+	/* fixed clock */
+	osc27M: osc27M {
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <27000000>;
+		clock-output-names = "osc27M";
+	};
+
+	/* maybe used in domu */
+	/* mmio */
+	crt_mmio: mmio@98000000 {
+		compatible = "realtek,mmio";
+		reg = <0x98000000 0x600>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	iso_mmio: mmio@98007088 {
+		compatible = "realtek,mmio";
+		reg = <0x98007088 0x8>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	/* clock-controller */
+	clk_en_1: clk-en@9800000c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x9800000c 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0xc>;
+		clock-output-names =
+		/* 0 ~ 7 */	"clk_en_misc",      "clk_en_pcie0",
+				"",                 "clk_en_gspi",
+				"",                 "",
+				"clk_en_iso_misc",  "clk_en_sds",
+		/* 8 ~ 15 */	"clk_en_hdmi",      "",
+				"",                 "",
+				"",                 "",
+				"",                 "",
+		/* 16 ~ 23 */	"clk_en_lsadc",     "clk_en_se",
+				"",                 "clk_en_cp",
+				"clk_en_md",        "clk_en_tp",
+				"clk_en_rsa",       "clk_en_nf",
+		/* 24 ~ 31 */	"clk_en_emmc",      "clk_en_cr",
+				"clk_en_sdio_ip",   "clk_en_mipi",
+				"clk_en_emmc_ip",   "",
+				"clk_en_sdio",      "clk_en_sd_ip";
+		ignore-unused-clocks =
+			"clk_en_misc",
+			"clk_en_iso_misc",
+			"clk_en_cp",
+			"clk_en_md",
+			"clk_en_tp",
+			"clk_en_hdmi",
+			"clk_en_cr",
+			"clk_en_sd_ip",
+			"clk_en_se";
+		ignore-pm-clocks =
+			"clk_en_hdmi";
+	};
+
+	clk_en_2: clk-en@98000010 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x98000010 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x10>;
+		clock-output-names =
+		/* 0 ~ 7 */	"",                 "clk_en_misc_i2c_5",
+				"",		    "clk_en_jpeg",
+				"",                 "",
+				"clk_en_misc_sc",   "",
+		/* 8 ~ 15 */	"",                 "",
+				"",                 "",
+				"",                 "",
+				"",                 "",
+		/* 16 ~ 23 */	"",                 "",
+				"",                 "",
+				"",                 "",
+				"",                 "",
+		/* 24 ~ 31 */	"",                 "clk_en_hse",
+				"",                 "clk_en_ur2",
+				"clk_en_ur1",       "clk_en_fan",
+				"clk_en_dcphy_0",   "clk_en_dcphy_1";
+		ignore-unused-clocks =
+			"clk_en_hse",
+			"clk_en_jpeg",
+			"clk_en_dcphy_0",
+			"clk_en_dcphy_1";
+	};
+
+	iclk_en: clk-en@9800708c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x9800708c 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&iso_mmio 0x4>;
+		clock-output-names =
+		/* 0 ~ 7 */	"",                  "",
+				"clk_en_misc_cec0",  "clk_en_cbusrx_sys",
+				"clk_en_cbustx_sys", "clk_en_cbus_sys",
+				"clk_en_cbus_osc",   "clk_en_misc_ir",
+		/* 8 ~ 15 */	"clk_en_ur0",        "clk_en_i2c0",
+				"clk_en_i2c1",       "clk_en_etn_250m",
+				"clk_en_etn_sys",    "clk_en_usb_drd",
+				"clk_en_usb_host_0", "clk_en_usb_host_1",
+		/* 16 */	"clk_en_usb";
+		ignore-unused-clocks =
+			"clk_en_ur0",
+			"clk_en_i2c1";
+	};
+
+	cc: clock-controller@98000000 {
+		compatible = "realtek,clock-controller";
+		reg = <0x98000000 0x600>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		invalid-clocks =
+			"clk_gpu",
+			"pll_gpu",
+			"pll_ve1",
+			"pll_ve2",
+			"clk_ve1",
+			"clk_ve2",
+			"clk_ve2_bpu";
+	};
+
+	/* reset-controller */
+	rst1: soft-reset@98000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000000 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+		pm-ignore-bits = <0x00001000>;
+	};
+
+	rst2: soft-reset@98000004 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000004 0x4>;
+		realtek,mmio = <&crt_mmio 0x4>;
+		#reset-cells = <1>;
+	};
+
+	rst3: soft-reset@98000008 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000008 0x4>;
+		realtek,mmio = <&crt_mmio 0x8>;
+		#reset-cells = <1>;
+	};
+
+	rst4: soft-reset@98000050 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000050 0x4>;
+		realtek,mmio = <&crt_mmio 0x50>;
+		#reset-cells = <1>;
+	};
+
+	irst: soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98007088 0x4>;
+		realtek,mmio = <&iso_mmio 0x0>;
+		#reset-cells = <1>;
+	};
+
+	iasr: usb-async-soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98007088 0x4>;
+		realtek,mmio = <&iso_mmio 0x0>;
+		#reset-cells = <1>;
+		async-group = <0>;
+	};
+
+	pd0: power-controller@98007000 {
+		compatible = "realtek,rtd139x-power-controller", "simple-bus";
+		reg = <0x98007000 0x1000>;
+		resets = <&rst1 RSTN_VE1>, <&rst1 RSTN_VE2>;
+		reset-names = "ve1", "ve2";
+		#power-domain-cells = <1>;
+	};
+
+	timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <1 13 0xf08>,
+			<1 14 0xf08>,
+			<1 11 0xf08>,
+			<1 10 0xf08>;
+		clock-frequency = <27000000>;
+	};
+
+	gic: interrupt-controller@FF010000 {
+		compatible = "arm,cortex-a15-gic", "arm,gic-400";
+		#interrupt-cells = <3>;
+		interrupt-controller;
+		reg = <0xFF011000 0x1000>,
+		      <0xFF012000 0x1000>,
+		      <0xFF014000 0x2000>,
+		      <0xFF016000 0x2000>;
+		interrupts = <1 9 0xf04>;
+		linux,phandle = <0x1>;
+		phandle = <0x1>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <0 48 4>;
+	};
+
+	pinctrl: pinctrl@9804E000 {
+		compatible = "realtek,rtk139x-pinctrl";
+		reg = <0x9804E000 0x86>;
+		#gpio-range-cells = <3>;
+		pinctrl-names = "default";
+		pinctrl-0 = /* <&spi_pins_loc_gpio>, */ /* <&spi_pins_loc_gpio>: GPIO0~3 mux to gpio; <&spi_pins_loc_spi>: GPIO0~3 mux to SPI*/
+			<&spdif_pins>,
+			<&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>,
+			<&scpu_ejtag_pins_loc_0>;
+		status = "okay";
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x9801B000 0x100>, <0x98007000 0x100>;/* MISC_TOP, MISC_ISO */
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk139x-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <57>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x98007000 0x100>,
+			<0x98007100 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 57>;
+		status = "okay";
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd129x-hdmitx";
+		reg = <0x9800d000 0x560>, /* HDMITX */
+			<0x98007200 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 7 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&rst1 RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		xen,passthrough;
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 31>;
+			xen,passthrough;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtk139x-hdcptx";
+		reg = <0x9800d000 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		xen,passthrough;
+	};
+
+	/* UART0 need to follow pure gic setting so driver work under xen */
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&gic>;
+		reg = <0x98007800 0x400>;
+		interrupts-st-mask = <0x4>;
+		interrupts = <0x0 0x29 0x4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clock-frequency = <3300000>; /* This value must be override by the board. */
+	};
+	/*
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007800 0x400>,
+			<0x98007000 0x100>;
+		interrupts-st-mask = <0x4>;
+		interrupts = <1 2>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart0_pins>;
+		clocks = <&iclk_en CLK_EN_MISC_UR0>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+	*/
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B200 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart1_pins>;
+		clocks = <&clk_en_2 CLK_EN_UR1>;
+		resets = <&rst2 RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		xen,passthrough;
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B400 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR2>;
+		resets = <&rst2 RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		xen,passthrough;
+	};
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x98016000 0x1000>,   /* ETN */
+			<0x98007000 0x1000>, /* ISO */
+			<0x9801c000 0x2000>, /* SBX and SC_WRAP for ACP ctrl */
+			<0x980172d0 0x10>,    /* EFUSE_OTP_REG */
+			<0x981c8000 0x2000>, /* SDS */
+			<0x9804e000 0x1000>; /* ISO pinmux */
+		interrupts = <0 22 4>;
+		pinctrl-names = "default",
+				"sgmii";
+		pinctrl-0 = <&etn_led_pins>;
+		pinctrl-1 = <&sgmii_mdio_pins>;
+		local-mac-address = [00 10 20 30 40 50];
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		output-mode = <0>; /* 0:embedded PHY, 1:SGMII to MAC, 2:SGMII to PHY */
+		ext-phy-id = <3>; /* 0 ~ 31, only valid when output-mode = 2 */
+		bypass = <1>; /* 0: disable, 1: enable */
+		acp = <0>; /* 0: disable, 1: enable */
+		eee = <1>; /* 0: disable, 1: enable */
+		clocks = <&iclk_en CLK_EN_ETN_250M>,
+			<&iclk_en CLK_EN_ETN_SYS>,
+			<&clk_en_1 CLK_EN_SDS>;
+		clock-names = "etn_250m",
+			"etn_sys",
+			"sds";
+		resets = <&irst IRSTN_GMAC>,
+			<&irst IRSTN_GPHY>,
+			<&rst1 RSTN_SDS_REG>,
+			<&rst1 RSTN_SDS>,
+			<&rst2 RSTN_PCIE0_POWER>,
+			<&rst2 RSTN_PCIE0_PHY>,
+			<&rst4 RSTN_PCIE0_SGMII_MDIO>,
+			<&rst4 RSTN_PCIE0_PHY_MDIO>;
+		reset-names = "gmac",
+			"gphy",
+			"sds_reg",
+			"sds",
+			"pcie0_power",
+			"pcie0_phy",
+			"pcie0_sgmii_mdio",
+			"pcie0_phy_mdio";
+		status = "okay";
+	};
+
+	timer0@9801B000 {
+		compatible = "realtek,rtk-timer0";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 17 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	timer1@9801B000 {
+		compatible = "realtek,rtk-timer1";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 18 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	sdio: sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 27 1 1>;
+		reg = <0x98010c00 0x200>,
+			<0x98000000 0x200000>;
+		interrupts = <0 45 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdio_pins_1>;
+		clocks = <&clk_en_1 CLK_EN_SDIO>,
+			<&clk_en_1 CLK_EN_SDIO_IP>;
+		clock-names = "sdio",
+			"sdio_ip";
+		resets = <&rst2 RSTN_SDIO>;
+		status = "okay";
+	};
+
+	sd: sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_iso_gpio 30 1 0>, /*sd power , output, default high  (poweroff) */
+			<&rtk_iso_gpio 34 0 1>,
+			<&rtk_iso_gpio 35 0 1>;
+		reg = <0x98000000 0x400>, /* CRT */
+			<0x98010400 0x200>, /* SDMMC */
+			<0x9801A000 0x400>, /* BS2 */
+			<0x9804E000 0x40>, /* ISO */
+			<0x98010A00 0x40>, /* SDIO */
+			<0x98007000 0x200>;
+		interrupts = <0 44 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>;
+			    /*<&sdcard_pins_high>;*/
+		clocks = <&clk_en_1 CLK_EN_CR>,
+			<&clk_en_1 CLK_EN_SD_IP>;
+		clock-names = "cr",
+			"sd_ip";
+		resets = <&rst2 RSTN_CR>;
+		xen,passthrough;
+	};
+
+	nand: nand@98010000 {
+        	compatible = "Realtek,rtk1295-nand";
+        	reg = <0x98010000 0x400>, /* NWC */
+              		<0x9801F000 0x400>; /* SWC */
+        	clocks = <&clk_en_1 CLK_EN_NF>;
+        	resets = <&rst1 RSTN_NF>;
+        	status = "disabled";
+    	};
+
+	emmc: emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		reg = <0x98012000 0xa00>, /*EMMC*/
+			<0x98000000 0x600>, /*CRT */
+			<0x9801A000 0x80>, /*SB2*/
+			<0x9801B000 0x150>, /*MISC*/
+			<0x9801a954 0x20>,  /*SB2_DBG*/
+			<0x9804E000 0x100>; /* ISO */
+		interrupts = <0 42 4>;
+		speed-step = <2>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_1 CLK_EN_EMMC>,
+			<&clk_en_1 CLK_EN_EMMC_IP>;
+		clock-names = "emmc",
+			"emmc_ip";
+		resets = <&rst2 RSTN_EMMC>;
+		reset-names = "emmc";
+		status = "okay";
+		pddrive_nf_s0 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+		pddrive_nf_s1 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for ddr50 */
+		pddrive_nf_s2 = <1 0x4 0x4 0x4 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+		pddrive_nf_s3 = <1 0x7 0x2 0x3 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs400 */
+		phase_tuning = <0 0>; /* arg0: tx tuning switch, arg1: rx tuning switch*/
+		dqs_tuning = <1>;
+	};
+
+	gpu: gpu@981d0000 {
+		compatible = "arm,mali-470", "arm,mali-utgard";
+		reg = <0x981D0000 0x30000>;
+		interrupts =
+			<0 75 4>, <0 76 4>,
+			<0 77 4>, <0 78 4>,
+			<0 79 4>, <0 80 4>,
+			<0 81 4>, <0 82 4>,
+			<0 83 4>, <0 84 4>,
+			<0 85 4>, <0 86 4>;
+		interrupt-names =
+			"IRQPP0", "IRQPPMMU0",
+			"IRQPP1", "IRQPPMMU1",
+			"IRQPP2", "IRQPPMMU2",
+			"IRQPP3", "IRQPPMMU3",
+			"IRQGP", "IRQGPMMU",
+			"IRQPMU", "IRQPP";
+		power-domains = <&pd0 RTD139X_PD_GPU>;
+		pmu_domain_config = <0x1 0x1 0x2 0x4 0x8 0x0 0x0 0x0 0x0 0x0 0x1 0x0>;
+		pmu_switch_delay = <0xff>;
+		clocks = <&cc CC_CLK_GPU>;
+		clock-names = "clk_mali";
+		resets = <&rst1 RSTN_GPU>;
+		xen,passthrough;
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk1295-pu_pll";
+		reg = <0x98000000 0x200>;
+		xen,passthrough;
+	};
+
+	jpeg: jpeg@9803e000 {
+		compatible = "Realtek,rtk1295-jpeg";
+		reg = <0x9803e000 0x1000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_2 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&rst2 RSTN_JPEG>;
+		xen,passthrough;
+	};
+
+	ve1: ve1@98040000 {
+		compatible = "Realtek,rtk1295-ve1";
+		reg = <0x98040000 0x8000>,
+			<0x98008000 0x1000>,
+			<0x98007000 0x30>;
+		interrupts = <0 53 4>, <0 54 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			<&cc CC_CLK_VE2>,
+			<&cc CC_CLK_VE2_BPU>,
+			<&cc CC_CLK_SYSH>,
+			<&cc CC_PLL_VE1>,
+			<&cc CC_PLL_VE2>;
+		clock-names = "clk_ve1",
+			"clk_ve2",
+			"clk_ve2_bpu",
+			"clk_sysh",
+			"pll_ve1",
+			"pll_ve2";
+		resets = <&rst1 RSTN_VE1>,
+			<&rst1 RSTN_VE2>;
+		reset-names = "ve1",
+			"ve2";
+		assigned-clocks =        <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>, <&cc CC_CLK_VE2_BPU>;
+		assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>, <&cc CC_PLL_VE1>;
+		assigned-clock-rates =   <550000000>,      <715000000>,      <550000000>;
+		xen,passthrough;
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x98000000 0x200000>;
+		xen,passthrough;
+	};
+
+	md: md@9800b000 {
+		compatible = "realtek,md";
+		reg = <0x9800b000 0x1000>;
+		interrupts = <0 38 4>;
+		clocks = <&clk_en_1 CLK_EN_MD>;
+		resets = <&rst1 RSTN_MD>;
+		xen,passthrough;
+	};
+
+	se: se@9800c000 {
+		compatible = "realtek,se";
+		reg = <0x9800c000 0x1000>;
+		interrupts = <0 20 4>;
+		clocks = <&clk_en_1 CLK_EN_SE>;
+		resets = <&rst1 RSTN_SE>;
+		xen,passthrough;
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x9801b000 0x1000>;
+		xen,passthrough;
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x9801d000 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x9801a000 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	rpc@9801a104 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x9801a104 0xc>, /* rpc intr en */
+			<0x01ffe000 0x4000>, /* rpc ring buffer */
+			<0x0002f000 0x1000>, /* rpc common */
+			<0x9801a020 0x4>; /* rbus sync */
+		interrupts = <0 33 4>;
+		xen,passthrough;
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007000 0x400>,
+			<0x98007400 0x100>;
+		interrupts = <1 5>;
+		resets = <&irst IRSTN_IR>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&ir_rx_pins>;
+		clocks = <&iclk_en CLK_EN_MISC_IR>;
+		status = "okay";
+	};
+
+	watchdog@0x98007680 {
+		compatible = "realtek,rtk-watchdog";
+		reg = <0x98007680 0x100>;
+		rst-oe = <0>; /* 0:input, 1:output */
+		rst-oe-for-init = <1>; /* 0:input, 1:output */
+		timeout-sec = <20>;
+		status = "okay";
+	};
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x98007600 0x100>;
+		rst-reg-offset = <0x40>;
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x98007D00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 8>;
+		i2c-num = <0>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_0>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C0>;
+		resets = <&irst IRSTN_I2C_0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x98007C00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 11>;
+		i2c-num = <1>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_1>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C1>;
+		resets = <&irst IRSTN_I2C_1>;
+		xen,passthrough;
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x9801BB00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 14>;
+		i2c-num = <5>;
+		status = "disabled";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_5>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+		resets = <&rst2 RSTN_I2C_5>;
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk-dw-apb-ssi";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 27>; /* SPI_INT */
+		reg = <0x9801BD00 0x100>, /* DW SPI */
+			<0x9801B300 0x18>; /* SPI wrapper */
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins_0>;
+		/*spi-cs-gpio = <&rtk_iso_gpio 6 1 1>;*/
+		num-chipselect = <1>;
+		bus-num = <0>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		clock-frequency = <256000000>;
+		resets = <&rst1 RSTN_GSPI>;
+		status = "disabled";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x980070D0 0xC>;
+		/*pinctrl-names = "default";
+		pinctrl-0 = <&pwm0_0_pins>;*/
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+		};
+	};
+
+	rtk_fan: rtk_fan@9801BC00 {
+		compatible = "Realtek,rtd129x-fan";
+		reg = <0x9801BC00 0x14>, <0x9801A910 0x4>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 29>;
+		status = "disabled";
+
+		pwms = <&pwm 1 37878>; // (1) pwm node (2) pwm id (3) out period_ns (1/26400 ns)
+
+		timer_target = <0x100000>;
+		fan_debounce = <0x0>;// 0x0~0x7
+		clocks = <&clk_en_2 CLK_EN_FAN>;
+		resets = <&rst4 RSTN_FAN>;
+	};
+
+	rtk-lsadc@98007900 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 16>, <1 17>; /* LSADC0_INT, LSADC1_INT */
+		reg = <0x98007000 0x4>, /* ISO_ISR */
+			<0x98007900 0x200>, /* LSADC */
+			<0x9800034C 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>, /* LSADC0 0:disable; 1:enable */
+						<1>; /* LSADC1 0:disable; 1:enable */
+		vdd_mux_sel = <0>; /* 0:VDD1; 1:VDD2 */
+		vdd_mux1 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux2 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux_en = <1>; /* 0:disable; 1:enable */
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <1>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc1-pad0 {
+			//compatible = "Realtek,rtk-lsadc1-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <0>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+
+		rtk-lsadc1-pad1 {
+			//compatible = "Realtek,rtk-lsadc1-pad1";
+			activate = <1>; /* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0: Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <1>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+	};
+
+	cec0@98037800 {
+		compatible = "Realtek,rtk-cec0";
+		reg = <0x98037800 0xe0>,
+			<0x98007000 0x100>,
+			<0x98037500 0x100>;
+		interrupts = <0 26 4>;
+		module-enable = <1>;
+		clocks = <&cc CC_CLK_SYS>,
+			<&iclk_en CLK_EN_CBUS_OSC>,
+			<&iclk_en CLK_EN_CBUS_SYS>,
+			<&iclk_en CLK_EN_CBUSTX_SYS>,
+			<&iclk_en CLK_EN_CBUSRX_SYS>;
+		clock-names = "sys",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys";
+		resets = <&irst IRSTN_CBUS>,
+			<&irst IRSTN_CBUSTX>,
+			<&irst IRSTN_CBUSRX>;
+		reset-names = "cbus",
+			"cbustx",
+			"cbusrx";
+		status = "okay";
+	};
+
+	rfkill: rfkilligpio {
+		compatible = "Realtek,rfkill";
+		gpios = <&rtk_iso_gpio 28 1 0>; /*bt power , output, default low */
+		xen,passthrough;
+	};
+
+	/*
+	 * Suspend GPIO control
+	 *
+	 * [wakeup-gpio-list]
+	 * rtk_iso_gpio 10: BT wakeup host pin
+	 * rtk_iso_gpio 26: WiFi wakeup host pin
+	 *
+	 * [wakeup-gpio-enable]
+	 * Wakeup from BT: <0> disable
+	 * Wakeup from WiFi: <0> disable
+	 *
+	 * [wakeup-gpio-activity]
+	 * BT pin: <0> active low
+	 * WIFI pin: <0> active low
+	 */
+	power-management@0 {
+		compatible = "Realtek,power-management";
+		system-power-controller;
+		reg = <0x98000000 0x1800>, /* CRT */
+			<0x98006000 0x1000>, /* AIO */
+			<0x98007000 0x1000>, /* ISO */
+			<0x98018000 0x2000>, /* TVE */
+			<0x9801A000 0x1000>, /* SB2 */
+			<0x9801B000 0x1000>; /* MISC */
+		suspend-mode = <0>; // 0:SUSPEND_TO_RAM, 1:SUSPEND_TO_COOLBOOT, 2:SUSPEND_TO_WFI
+		pwms = <&pwm 0 37878>;
+		wakeup-gpio-list = <&rtk_iso_gpio 10 0 1>,<&rtk_iso_gpio 26 0 1>;
+		wakeup-gpio-enable = <0>, <0>;
+		wakeup-gpio-activity = <0>, <0>;
+		status = "okay";
+	};
+
+	rng@98001000 {
+		compatible = "Realtek,rtk-rng";
+		reg = <0x98001000 0x40>;
+	};
+
+	smartcard@9801BE00 {
+		compatible = "Realtek,rtk-smc";
+		interrupts = <0 63 4>;      /* SC0_INT*/
+		reg = <0x9801B000 0x100>, /* MISC interrupt */
+			<0x9801BE00 0x80>; /* SmartCard */
+		smc-num = <0>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&smartcard_pins>;
+        	clock-names = "clk_en_misc_sc";
+		clocks = <&clk_en_2 CLK_EN_MISC_SC>;
+		resets = <&rst2 RSTN_MISC_SC>;
+		status = "okay";
+		lsic_control{
+			pin_cmd_vcc = <&rtk_iso_gpio 22 1 0>;  /* pin cmd_vcc , default low */
+			pin_pwr_sel = <&rtk_iso_gpio 53 1 0>;  /* pin pwr_sel , default 0 */
+			cmd_vcc_en = <1>;
+			cmd_vcc_polarity = <0>; /* low active */
+			pwr_sel_en = <1>;
+			pwr_sel_polarity = <1>; /* high actve 1: 5v */
+		};
+	};
+
+	dvfs: dvfs {
+		compatible = "realtek,rtd139x-dvfs";
+		cpu-supply = <&cpu_supp>;
+		status = "okay";
+	};
+
+	cpu_tm: thermal-sensor@9801D150 {
+		compatible = "realtek,rtd139x-thermal-sensor";
+		reg = <0x9801D150 0x1C>;
+		#thermal-sensor-cells = <0>;
+
+		status = "okay";
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+
+			trips {
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <0>;
+					type = "critical";
+				};
+			};
+		};
+	};
+
+	mcp@0 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x98015000 0x1000>,
+			<0x98014000 0x1000>;
+		status = "okay";
+	};
+
+	rtk_fw_dbg_info {
+		compatible = "Realtek,rtk_fw_dbg_info";
+		status = "okay";
+	};
+
+	rtk_cvbs_detect {
+		compatible = "realtek,rtd1395-cvbs-switch";
+		gpio_mute = <&rtk_iso_gpio 47 1 0>; /*audio DAC mute*/
+		gpios = <&rtk_iso_gpio 21 0 2>;
+		gpio-activity = <1>; /*0: low active  1: high active*/
+		detect-mode = <1>; /* 0:vdac detect, 1: gpio detect*/
+		xen,passthrough;
+	};
+
+	hse: hse@98005000 {
+		compatible = "realtek,hse";
+		reg = <0x98005000 0x1000>;
+		interrupts = <0 7 4>, <0 27 4>;
+		clocks = <&clk_en_2 CLK_EN_HSE>;
+		resets = <&rst1 RSTN_HSE>;
+		xen,passthrough;
+	};
+
+	dcsys-pc@98008000 {
+		compatible = "realtek,dcsys-pc", "simple-bus";
+		reg = <0x98008000 0x1000>;
+		clocks = <&cc CC_PLL_BUS_H>;
+		clock-names = "ref";
+		status = "okay";
+
+		dcsys_event: event {
+			compatible = "realtek,dcsys-event", "devfreq-event";
+			status = "okay";
+		};
+
+		uio {
+			compatible = "realtek,dcsys-pc-uio";
+			status = "okay";
+		};
+	};
+
+	bush_dfs: dcsb {
+		compatible = "realtek,busfreq";
+		clocks = <&cc CC_PLL_BUS_H>;
+		devfreq-events = <&dcsys_event>;
+		operating-points-v2 = <&bush_opps>;
+		status = "disabled";
+
+		bush_opps: opp-table {
+			compatible = "operating-points-v2";
+			opp-low {
+				opp-hz = /bits/ 64 <250000000>;
+				clock-latency-ns = <150000>;
+			};
+			opp-high {
+				opp-hz = /bits/ 64 <500000000>;
+				clock-latency-ns = <150000>;
+			};
+		};
+	};
+
+	bus {
+		compatible = "realtek,busfreq";
+		clocks = <&cc CC_PLL_BUS>;
+		operating-points-v2 = <&bus_opps>;
+		devfreq = <&bush_dfs>;
+		status = "disabled";
+
+		bus_opps: opp-table {
+			compatible = "operating-points-v2";
+			opp-low {
+				opp-hz = /bits/ 64 <128250000>;
+				clock-latency-ns = <150000>;
+			};
+			opp-high {
+				opp-hz = /bits/ 64 <256500000>;
+				clock-latency-ns = <150000>;
+			};
+		};
+	};
+
+
+
+};
+
+#include "rtd-139x-dvfs.dtsi"
+#include "rtd-139x-pcie.dtsi"
+
+
diff --git a/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x.dtsi b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x.dtsi
new file mode 100755
index 00000000..471207e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd139x/rtd-139x.dtsi
@@ -0,0 +1,1104 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include <dt-bindings/thermal/thermal.h>
+#include <dt-bindings/clock/rtk,clock-rtd139x.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <dt-bindings/reset/rtk,reset-rtd139x.h>
+#include <dt-bindings/power/rtk,power-rtd139x.h>
+/include/ "rtd-139x-pinctrl.dtsi"
+/include/ "rtd-139x-irda.dtsi"
+/include/ "rtd-1395-usb.dtsi"
+/include/ "rtd-139x-dcsys-debug.dtsi"
+
+/{
+	compatible = "realtek,rtd1395";
+	interrupt-parent = <&gic>;
+	#address-cells = <1>;
+	#size-cells = <1>;
+
+	aliases {
+		serial0 = &uart0;
+		i2c0 = &i2c_0;
+		i2c1 = &i2c_1;
+		i2c5 = &i2c_5;
+		hwsem0 = &sb2_lock1;
+		hwsem1 = &sb2_lock2;
+	};
+
+
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A53_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x0>;
+			enable-method = "rtk-spin-table";
+			next-level-cache = <&a53_l2>;
+		};
+
+		A53_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x1>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a53_l2>;
+		};
+
+		A53_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x02>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a53_l2>;
+		};
+
+		A53_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a53", "arm,armv8";
+			reg = <0x03>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a53_l2>;
+		};
+
+		a53_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	soc@0 {
+		#address-cells = <1>;
+		#size-cells = <1>;
+		reg = <0x98000000 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+		ranges;
+	};
+
+	efuse@98017000 {
+		compatible = "realtek,efuse";
+		reg = <0x98017000 0x400>;
+		read-only;
+		status = "okay";
+
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		nvmem-cells = <&otp_cpu_iddq>, <&otp_top_iddq>;
+		nvmem-cell-names = "cpu-iddq", "top-iddq";
+
+		otp_cpu_iddq: cpu-iddq@2C5 {
+			reg = <0x2C5 0x1>;
+			bits = <0 8>;
+		};
+		otp_top_iddq: top-iddq@2C6 {
+			reg = <0x2C6 0x1>;
+			bits = <0 8>;
+		};
+	};
+
+	sb2_lock0: sb2-lock@9801A000 {
+		compatible = "realtek,sb2-sem";
+		reg = <0x9801A000 0x4>;
+	};
+
+	sb2_lock1: sb2-lock@9801A620 {
+		reg = <0x9801A620 0x4>;
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+	};
+
+	sb2_lock2: sb2-lock@9801A624 {
+		reg = <0x9801A624 0x4>;
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-dev";
+	};
+
+	sb2_lock_avlog: sb2-lock@9801A63C {
+		reg = <0x9801A63C 0x4>;
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-avlog";
+	};
+
+	/* fixed clock */
+	osc27M: osc27M {
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <27000000>;
+		clock-output-names = "osc27M";
+	};
+
+	/* mmio */
+	crt_mmio: mmio@98000000 {
+		compatible = "realtek,mmio";
+		reg = <0x98000000 0x600>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	iso_mmio: mmio@98007088 {
+		compatible = "realtek,mmio";
+		reg = <0x98007088 0x8>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	/* clock-controller */
+	clk_en_1: clk-en@9800000c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x9800000c 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0xc>;
+		clock-output-names =
+		/* 0 ~ 7 */	"clk_en_misc",      "clk_en_pcie0",
+				"",                 "clk_en_gspi",
+				"",                 "",
+				"clk_en_iso_misc",  "clk_en_sds",
+		/* 8 ~ 15 */	"clk_en_hdmi",      "",
+				"",                 "",
+				"",                 "",
+				"",                 "",
+		/* 16 ~ 23 */	"clk_en_lsadc",     "clk_en_se",
+				"",                 "clk_en_cp",
+				"clk_en_md",        "clk_en_tp",
+				"clk_en_rsa",       "clk_en_nf",
+		/* 24 ~ 31 */	"clk_en_emmc",      "clk_en_cr",
+				"clk_en_sdio_ip",   "clk_en_mipi",
+				"clk_en_emmc_ip",   "",
+				"clk_en_sdio",      "clk_en_sd_ip";
+		ignore-unused-clocks =
+			"clk_en_misc",
+			"clk_en_iso_misc",
+			"clk_en_cp",
+			"clk_en_md",
+			"clk_en_tp",
+			"clk_en_hdmi";
+		ignore-pm-clocks =
+			"clk_en_hdmi";
+	};
+
+	clk_en_2: clk-en@98000010 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x98000010 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x10>;
+		clock-output-names =
+		/* 0 ~ 7 */	"",                 "clk_en_misc_i2c_5",
+				"",		    "clk_en_jpeg",
+				"",                 "",
+				"clk_en_misc_sc",   "",
+		/* 8 ~ 15 */	"",                 "",
+				"",                 "",
+				"",                 "",
+				"",                 "",
+		/* 16 ~ 23 */	"",                 "",
+				"",                 "",
+				"",                 "",
+				"",                 "",
+		/* 24 ~ 31 */	"",                 "clk_en_hse",
+				"",                 "clk_en_ur2",
+				"clk_en_ur1",       "clk_en_fan",
+				"clk_en_dcphy_0",   "clk_en_dcphy_1";
+		ignore-unused-clocks =
+			"clk_en_dcphy_0",
+			"clk_en_dcphy_1";
+	};
+
+	iclk_en: clk-en@9800708c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x9800708c 0x4>;
+		#clock-cells = <1>;
+		realtek,mmio = <&iso_mmio 0x4>;
+		clock-output-names =
+		/* 0 ~ 7 */	"",                  "",
+				"clk_en_misc_cec0",  "clk_en_cbusrx_sys",
+				"clk_en_cbustx_sys", "clk_en_cbus_sys",
+				"clk_en_cbus_osc",   "clk_en_misc_ir",
+		/* 8 ~ 15 */	"clk_en_ur0",        "clk_en_i2c0",
+				"clk_en_i2c1",       "clk_en_etn_250m",
+				"clk_en_etn_sys",    "clk_en_usb_drd",
+				"clk_en_usb_host_0", "clk_en_usb_host_1",
+		/* 16 */	"clk_en_usb";
+	};
+
+	cc: clock-controller@98000000 {
+		compatible = "realtek,clock-controller";
+		reg = <0x98000000 0x600>;
+		#clock-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	/* reset-controller */
+	rst1: soft-reset@98000000 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000000 0x4>;
+		realtek,mmio = <&crt_mmio 0x0>;
+		#reset-cells = <1>;
+		pm-ignore-bits = <0x00001000>;
+	};
+
+	rst2: soft-reset@98000004 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000004 0x4>;
+		realtek,mmio = <&crt_mmio 0x4>;
+		#reset-cells = <1>;
+	};
+
+	rst3: soft-reset@98000008 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000008 0x4>;
+		realtek,mmio = <&crt_mmio 0x8>;
+		#reset-cells = <1>;
+	};
+
+	rst4: soft-reset@98000050 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98000050 0x4>;
+		realtek,mmio = <&crt_mmio 0x50>;
+		#reset-cells = <1>;
+	};
+
+	irst: soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98007088 0x4>;
+		realtek,mmio = <&iso_mmio 0x0>;
+		#reset-cells = <1>;
+	};
+
+	iasr: usb-async-soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x98007088 0x4>;
+		realtek,mmio = <&iso_mmio 0x0>;
+		#reset-cells = <1>;
+		async-group = <0>;
+	};
+
+	pd0: power-controller@98007000 {
+		compatible = "realtek,rtd139x-power-controller", "simple-bus";
+		reg = <0x98007000 0x1000>;
+		resets = <&rst1 RSTN_VE1>, <&rst1 RSTN_VE2>;
+		reset-names = "ve1", "ve2";
+		#power-domain-cells = <1>;
+	};
+
+	timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <1 13 0xf08>,
+			<1 14 0xf08>,
+			<1 11 0xf08>,
+			<1 10 0xf08>;
+		clock-frequency = <27000000>;
+	};
+
+	gic: interrupt-controller@FF010000 {
+		compatible = "arm,gic-400";
+		#interrupt-cells = <3>;
+		interrupt-controller;
+		reg = <0xFF011000 0x1000>,
+			<0xFF012000 0x1000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <0 48 4>;
+	};
+
+	pinctrl: pinctrl@9804E000 {
+		compatible = "realtek,rtk139x-pinctrl";
+		reg = <0x9804E000 0x86>;
+		#gpio-range-cells = <3>;
+		pinctrl-names = "default";
+		pinctrl-0 = /* <&spi_pins_loc_gpio>, */ /* <&spi_pins_loc_gpio>: GPIO0~3 mux to gpio; <&spi_pins_loc_spi>: GPIO0~3 mux to SPI*/
+			<&spdif_pins>,
+			<&rtc_pins>,
+			<&prob0_pins>,
+			<&prob1_pins>,
+			<&scpu_ejtag_pins_loc_0>;
+		status = "okay";
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x9801B000 0x100>, <0x98007000 0x100>;/* MISC_TOP, MISC_ISO */
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk139x-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <57>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <1 19>, <1 20>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x98007000 0x100>,
+			<0x98007100 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 57>;
+		status = "okay";
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd129x-hdmitx";
+		reg = <0x9800d000 0x560>, /* HDMITX */
+			<0x98007200 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 7 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&rst1 RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		status = "okay";
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <1 31>;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtk139x-hdcptx";
+		reg = <0x9800d000 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		status = "okay";
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007800 0x400>,
+			<0x98007000 0x100>;
+		interrupts-st-mask = <0x4>;
+		interrupts = <1 2>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart0_pins>;
+		clocks = <&iclk_en CLK_EN_MISC_UR0>;
+		clock-frequency = <27000000>; /* This value must be override by the board. */
+		status = "okay";
+	};
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B200 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 3>, <0 5>; /*UR1_INT and UR1_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart1_pins>;
+		clocks = <&clk_en_2 CLK_EN_UR1>;
+		resets = <&rst2 RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "okay";
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x9801B400 0x100>,
+			<0x9801B00c 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts = <0 8>, <0 13>; /*UR2_INT and UR2_TO_INT*/
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clocks = <&clk_en_2 CLK_EN_UR2>;
+		resets = <&rst2 RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "disabled"; /* Disable UR2 first since we don't use it now */
+	};
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x98016000 0x1000>,   /* ETN */
+			<0x98007000 0x1000>, /* ISO */
+			<0x9801c000 0x2000>, /* SBX and SC_WRAP for ACP ctrl */
+			<0x980172c8 0x20>,    /* EFUSE_OTP_REG */
+			<0x981c8000 0x2000>, /* SDS */
+			<0x9804e000 0x1000>; /* ISO pinmux */
+		interrupts = <0 22 4>;
+		pinctrl-names = "default",
+				"sgmii";
+		pinctrl-0 = <&etn_led_pins>;
+		pinctrl-1 = <&sgmii_mdio_pins>;
+		local-mac-address = [00 10 20 30 40 50];
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		wake-mask0 = [3f 30 80 c0 3f 10 80 ff ff 1f 00 00 00 00 00 00];
+		wake-crc0 = <0x8d25>;
+		wake-mask1 = [3f 30 80 c0 3f 10 00 00 c0 ff ff 0f 00 00 00 00];
+		wake-crc1 = <0x8d25>;
+		wake-mask2 = [3f 30 80 c0 3f 10 00 00 00 00 00 00 80 ff ff 1f];
+		wake-crc2 = <0x8d25>;
+		wake-mask3 = [3f 30 10 00 c0 ff ff 03 01 f8 ff ff 01 00 00 00];
+		wake-crc3 = <0x11da>;
+		wake-mask4 = [3f 30 10 00 c0 ff ff 03 01 00 00 fc ff ff 00 00];
+		wake-crc4 = <0x11da>;
+		wake-mask5 = [3f 30 10 00 c0 ff ff 03 01 00 00 00 00 00 00 f8];
+		wake-crc5 = <0x15f8>;
+		output-mode = <0>; /* 0:embedded PHY, 1:SGMII to MAC, 2:SGMII to PHY */
+		ext-phy-id = <3>; /* 0 ~ 31, only valid when output-mode = 2 */
+		bypass = <1>; /* 0: disable, 1: enable */
+		acp = <0>; /* 0: disable, 1: enable */
+		eee = <1>; /* 0: disable, 1: enable */
+		clocks = <&iclk_en CLK_EN_ETN_250M>,
+			<&iclk_en CLK_EN_ETN_SYS>,
+			<&clk_en_1 CLK_EN_SDS>;
+		clock-names = "etn_250m",
+			"etn_sys",
+			"sds";
+		resets = <&irst IRSTN_GMAC>,
+			<&irst IRSTN_GPHY>,
+			<&rst1 RSTN_SDS_REG>,
+			<&rst1 RSTN_SDS>,
+			<&rst2 RSTN_PCIE0_POWER>,
+			<&rst2 RSTN_PCIE0_PHY>,
+			<&rst4 RSTN_PCIE0_SGMII_MDIO>,
+			<&rst4 RSTN_PCIE0_PHY_MDIO>;
+		reset-names = "gmac",
+			"gphy",
+			"sds_reg",
+			"sds",
+			"pcie0_power",
+			"pcie0_phy",
+			"pcie0_sgmii_mdio",
+			"pcie0_phy_mdio";
+		status = "okay";
+	};
+
+	timer0@9801B000 {
+		compatible = "realtek,rtk-timer0";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 17 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	timer1@9801B000 {
+		compatible = "realtek,rtk-timer1";
+		reg = <0x9801B000 0x600>,
+			<0xFF018000 0x10>;
+		interrupts = <0 18 4>;
+		clock-frequency = <27000000>;
+		status = "okay";
+	};
+
+	sdio: sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 27 1 1>;
+		reg = <0x98010c00 0x200>,
+			<0x98000000 0x200000>;
+		interrupts = <0 45 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdio_pins_1>;
+		clocks = <&clk_en_1 CLK_EN_SDIO>,
+			<&clk_en_1 CLK_EN_SDIO_IP>;
+		clock-names = "sdio",
+			"sdio_ip";
+		resets = <&rst2 RSTN_SDIO>;
+		status = "okay";
+	};
+
+	sd: sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_iso_gpio 30 1 0>, /*sd power , output, default high  (poweroff) */
+			<&rtk_iso_gpio 34 0 1>,
+			<&rtk_iso_gpio 35 0 1>;
+		reg = <0x98000000 0x400>, /* CRT */
+			<0x98010400 0x200>, /* SDMMC */
+			<0x9801A000 0x400>, /* BS2 */
+			<0x9804E000 0x40>, /* ISO */
+			<0x98010A00 0x40>, /* SDIO */
+			<0x98007000 0x200>;
+		interrupts = <0 44 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>;
+			    /*<&sdcard_pins_high>;*/
+		clocks = <&clk_en_1 CLK_EN_CR>,
+			<&clk_en_1 CLK_EN_SD_IP>;
+		clock-names = "sd",
+			"sd_ip";
+		resets = <&rst2 RSTN_CR>;
+		status = "okay";
+	};
+
+	nand: nand@98010000 {
+        	compatible = "Realtek,rtk1295-nand";
+        	reg = <0x98010000 0x400>, /* NWC */
+              		<0x9801F000 0x400>; /* SWC */
+        	clocks = <&clk_en_1 CLK_EN_NF>;
+        	resets = <&rst1 RSTN_NF>;
+        	status = "disabled";
+    	};
+
+	emmc: emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		reg = <0x98012000 0xa00>, /*EMMC*/
+			<0x98000000 0x600>, /*CRT */
+			<0x9801A000 0x80>, /*SB2*/
+			<0x9801B000 0x150>, /*MISC*/
+			<0x9801a954 0x20>,  /*SB2_DBG*/
+			<0x9804E000 0x100>; /* ISO */
+		interrupts = <0 42 4>;
+		speed-step = <2>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_1 CLK_EN_EMMC>,
+			<&clk_en_1 CLK_EN_EMMC_IP>;
+		clock-names = "emmc",
+			"emmc_ip";
+		resets = <&rst2 RSTN_EMMC>;
+		reset-names = "emmc";
+		status = "okay";
+		pddrive_nf_s0 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+		pddrive_nf_s1 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for ddr50 */
+		pddrive_nf_s2 = <1 0x4 0x4 0x4 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+		pddrive_nf_s3 = <1 0x7 0x2 0x3 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs400 */
+		phase_tuning = <0 0>; /* arg0: tx tuning switch, arg1: rx tuning switch*/
+		dqs_tuning = <1>;
+	};
+
+	gpu: gpu@981d0000 {
+		compatible = "arm,mali-470", "arm,mali-utgard";
+		reg = <0x981D0000 0x30000>;
+		interrupts =
+			<0 75 4>, <0 76 4>,
+			<0 77 4>, <0 78 4>,
+			<0 79 4>, <0 80 4>,
+			<0 81 4>, <0 82 4>,
+			<0 83 4>, <0 84 4>,
+			<0 85 4>, <0 86 4>;
+		interrupt-names =
+			"IRQPP0", "IRQPPMMU0",
+			"IRQPP1", "IRQPPMMU1",
+			"IRQPP2", "IRQPPMMU2",
+			"IRQPP3", "IRQPPMMU3",
+			"IRQGP", "IRQGPMMU",
+			"IRQPMU", "IRQPP";
+		power-domains = <&pd0 RTD139X_PD_GPU>;
+		pmu_domain_config = <0x1 0x1 0x2 0x4 0x8 0x0 0x0 0x0 0x0 0x0 0x1 0x0>;
+		pmu_switch_delay = <0xff>;
+		clocks = <&cc CC_CLK_GPU>;
+		clock-names = "clk_mali";
+		resets = <&rst1 RSTN_GPU>;
+		status = "okay";
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk1295-pu_pll";
+		reg = <0x98000000 0x200>;
+	};
+
+	jpeg: jpeg@9803e000 {
+		compatible = "Realtek,rtk1295-jpeg";
+		reg = <0x9803e000 0x1000>,
+			<0x98000000 0x200>,
+			<0x98007000 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_2 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&rst2 RSTN_JPEG>;
+		status = "okay";
+	};
+
+	ve1: ve1@98040000 {
+		compatible = "Realtek,rtk1295-ve1";
+		reg = <0x98040000 0x8000>,
+			<0x98008000 0x1000>,
+			<0x98007000 0x30>;
+		interrupts = <0 53 4>, <0 54 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			<&cc CC_CLK_VE2>,
+			<&cc CC_CLK_VE2_BPU>,
+			<&cc CC_CLK_SYSH>,
+			<&cc CC_PLL_VE1>,
+			<&cc CC_PLL_VE2>;
+		clock-names = "clk_ve1",
+			"clk_ve2",
+			"clk_ve2_bpu",
+			"clk_sysh",
+			"pll_ve1",
+			"pll_ve2";
+		resets = <&rst1 RSTN_VE1>,
+			<&rst1 RSTN_VE2>;
+		reset-names = "ve1",
+			"ve2";
+		assigned-clocks =        <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>, <&cc CC_CLK_VE2_BPU>;
+		assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>, <&cc CC_PLL_VE1>;
+		assigned-clock-rates =   <550000000>,      <715000000>,      <550000000>;
+		status = "okay";
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x98000000 0x200000>;
+		status = "okay";
+	};
+
+	md: md@9800b000 {
+		compatible = "realtek,md";
+		reg = <0x9800b000 0x1000>;
+		interrupts = <0 38 4>;
+		clocks = <&clk_en_1 CLK_EN_MD>;
+		resets = <&rst1 RSTN_MD>;
+		status = "okay";
+	};
+
+	se: se@9800c000 {
+		compatible = "realtek,se";
+		reg = <0x9800c000 0x1000>;
+		interrupts = <0 20 4>;
+		clocks = <&clk_en_1 CLK_EN_SE>;
+		resets = <&rst1 RSTN_SE>;
+		status = "okay";
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x9801b000 0x1000>;
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x9801d000 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x9801a000 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	rpc@9801a104 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x9801a104 0xc>, /* rpc intr en */
+			<0x01ffe000 0x4000>, /* rpc ring buffer */
+			<0x0002f000 0x1000>, /* rpc common */
+			<0x9801a020 0x4>; /* rbus sync */
+		interrupts = <0 33 4>;
+		status = "okay";
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x98007000 0x400>,
+			<0x98007400 0x100>;
+		interrupts = <1 5>;
+		resets = <&irst IRSTN_IR>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&ir_rx_pins>;
+		clocks = <&iclk_en CLK_EN_MISC_IR>;
+		status = "okay";
+	};
+
+	watchdog@0x98007680 {
+		compatible = "realtek,rtk-watchdog";
+                reg = <0x9801b5b0 0x20>, /*misc watchdog for SCPU NMI */
+                        <0x9801b000 0x10>, 
+                        <0x98007680 0x100>; /*iso watchdog for oe workaround */
+                interrupts = <0 0 4>;
+                rst-oe = <0>; /* 0:input, 1:output */
+                rst-oe-for-init = <1>; /* 0:input, 1:output */
+		timeout-sec = <20>;
+		status = "okay";
+	};
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x98007600 0x100>;
+		rst-reg-offset = <0x40>;
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x98007D00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 8>;
+		i2c-num = <0>;
+		status = "disabled";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_0>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C0>;
+		resets = <&irst IRSTN_I2C_0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x98007C00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 11>;
+		i2c-num = <1>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_1>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iclk_en CLK_EN_I2C1>;
+		resets = <&irst IRSTN_I2C_1>;
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x9801BB00 0x400>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 14>;
+		i2c-num = <5>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_5>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_2 CLK_EN_MISC_I2C_5>;
+		resets = <&rst2 RSTN_I2C_5>;
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk-dw-apb-ssi";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 27>; /* SPI_INT */
+		reg = <0x9801BD00 0x100>, /* DW SPI */
+			<0x9801B300 0x18>; /* SPI wrapper */
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins_0>;
+		/*spi-cs-gpio = <&rtk_iso_gpio 6 1 1>;*/
+		num-chipselect = <1>;
+		bus-num = <0>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		clock-frequency = <256000000>;
+		resets = <&rst1 RSTN_GSPI>;
+		status = "disabled";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x980070D0 0xC>;
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm0_0_pins>;
+			pinctrl-1 = <&pwm0_0_pins_disable>;
+			pinctrl-2 = <&pwm0_1_pins>;
+			pinctrl-3 = <&pwm0_1_pins_disable>;
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm1_0_pins>;
+			pinctrl-1 = <&pwm1_0_pins_disable>;
+			pinctrl-2 = <&pwm1_1_pins>;
+			pinctrl-3 = <&pwm1_1_pins_disable>;
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm2_0_pins>;
+			pinctrl-1 = <&pwm2_0_pins_disable>;
+			pinctrl-2 = <&pwm2_1_pins>;
+			pinctrl-3 = <&pwm2_1_pins_disable>;
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm3_0_pins>;
+			pinctrl-1 = <&pwm3_0_pins_disable>;
+			pinctrl-2 = <&pwm3_1_pins>;
+			pinctrl-3 = <&pwm3_1_pins_disable>;
+		};
+	};
+
+	rtk_fan: rtk_fan@9801BC00 {
+		compatible = "Realtek,rtd129x-fan";
+		reg = <0x9801BC00 0x14>, <0x9801A910 0x4>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <0 29>;
+		status = "disabled";
+
+		pwms = <&pwm 1 37878>; // (1) pwm node (2) pwm id (3) out period_ns (1/26400 ns)
+
+		timer_target = <0x100000>;
+		fan_debounce = <0x0>;// 0x0~0x7
+		clocks = <&clk_en_2 CLK_EN_FAN>;
+		resets = <&rst4 RSTN_FAN>;
+	};
+
+	rtk-lsadc@98007900 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <1 16>, <1 17>; /* LSADC0_INT, LSADC1_INT */
+		reg = <0x98007000 0x4>, /* ISO_ISR */
+			<0x98007900 0x200>, /* LSADC */
+			<0x9800034C 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>, /* LSADC0 0:disable; 1:enable */
+						<1>; /* LSADC1 0:disable; 1:enable */
+		vdd_mux_sel = <0>; /* 0:VDD1; 1:VDD2 */
+		vdd_mux1 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux2 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux_en = <1>; /* 0:disable; 1:enable */
+		clocks = <&clk_en_1 CLK_EN_LSADC>;
+		resets = <&rst1 RSTN_LSADC>;
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <1>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc1-pad0 {
+			//compatible = "Realtek,rtk-lsadc1-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <0>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+
+		rtk-lsadc1-pad1 {
+			//compatible = "Realtek,rtk-lsadc1-pad1";
+			activate = <1>; /* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0: Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <1>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+	};
+
+	cec0@98037800 {
+		compatible = "Realtek,rtk-cec0";
+		reg = <0x98037800 0xe0>,
+			<0x98007000 0x100>,
+			<0x98037500 0x100>;
+		interrupts = <0 26 4>;
+		module-enable = <1>;
+		clocks = <&cc CC_CLK_SYS>,
+			<&iclk_en CLK_EN_CBUS_OSC>,
+			<&iclk_en CLK_EN_CBUS_SYS>,
+			<&iclk_en CLK_EN_CBUSTX_SYS>,
+			<&iclk_en CLK_EN_CBUSRX_SYS>;
+		clock-names = "sys",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys";
+		resets = <&irst IRSTN_CBUS>,
+			<&irst IRSTN_CBUSTX>,
+			<&irst IRSTN_CBUSRX>;
+		reset-names = "cbus",
+			"cbustx",
+			"cbusrx";
+		status = "okay";
+	};
+
+	rfkill: rfkilligpio {
+		compatible = "Realtek,rfkill";
+		gpios = <&rtk_iso_gpio 28 1 0>; /*bt power , output, default low */
+		status = "okay";
+	};
+
+	/*
+	 * Suspend GPIO control
+	 *
+	 * [wakeup-gpio-list]
+	 * rtk_iso_gpio 10: BT wakeup host pin
+	 * rtk_iso_gpio 26: WiFi wakeup host pin
+	 *
+	 * [wakeup-gpio-enable]
+	 * Wakeup from BT: <0> disable
+	 * Wakeup from WiFi: <0> disable
+	 *
+	 * [wakeup-gpio-activity]
+	 * BT pin: <0> active low
+	 * WIFI pin: <0> active low
+	 */
+	power-management@0 {
+		compatible = "Realtek,power-management";
+		system-power-controller;
+		reg = <0x98000000 0x1800>, /* CRT */
+			<0x98006000 0x1000>, /* AIO */
+			<0x98007000 0x1000>, /* ISO */
+			<0x98018000 0x2000>, /* TVE */
+			<0x9801A000 0x1000>, /* SB2 */
+			<0x9801B000 0x1000>; /* MISC */
+		suspend-mode = <0>; // 0:SUSPEND_TO_RAM, 1:SUSPEND_TO_COOLBOOT, 2:SUSPEND_TO_WFI
+		pwms = <&pwm 0 37878>;
+		wakeup-gpio-list = <&rtk_iso_gpio 10 0 1>,<&rtk_iso_gpio 26 0 1>;
+		wakeup-gpio-enable = <1>, <0>;
+		wakeup-gpio-activity = <0>, <0>;
+		status = "okay";
+	};
+
+	rng@98001000 {
+		compatible = "Realtek,rtk-rng";
+		reg = <0x98001000 0x40>;
+	};
+
+	smartcard@9801BE00 {
+		compatible = "Realtek,rtk-smc";
+		interrupts = <0 63 4>;      /* SC0_INT*/
+		reg = <0x9801B000 0x100>, /* MISC interrupt */
+			<0x9801BE00 0x80>; /* SmartCard */
+		smc-num = <0>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&smartcard_pins>;
+        	clock-names = "clk_en_misc_sc";
+		clocks = <&clk_en_2 CLK_EN_MISC_SC>;
+		resets = <&rst2 RSTN_MISC_SC>;
+		status = "okay";
+		lsic_control{
+			pin_cmd_vcc = <&rtk_iso_gpio 22 1 0>;  /* pin cmd_vcc , default low */
+			pin_pwr_sel = <&rtk_iso_gpio 53 1 0>;  /* pin pwr_sel , default 0 */
+			cmd_vcc_en = <1>;
+			cmd_vcc_polarity = <0>; /* low active */
+			pwr_sel_en = <1>;
+			pwr_sel_polarity = <1>; /* high actve 1: 5v */
+		};
+	};
+
+	dvfs: cpu-dvfs {
+	};
+
+	cpu_tm: thermal-sensor@9801D150 {
+		compatible = "realtek,rtd139x-thermal-sensor";
+		reg = <0x9801D150 0x1C>;
+		#thermal-sensor-cells = <0>;
+		status = "okay";
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+			sustainable-power = <1200>;
+
+			trips {
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <0>;
+					type = "critical";
+				};
+			};
+		};
+	};
+
+	mcp@0 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x98015000 0x1000>,
+			<0x98014000 0x1000>;
+		status = "okay";
+	};
+
+	rtk_fw_dbg_info {
+		compatible = "Realtek,rtk_fw_dbg_info";
+		status = "okay";
+	};
+
+	rtk_cvbs_detect {
+		compatible = "realtek,rtd1395-cvbs-switch";
+		gpio_mute = <&rtk_iso_gpio 47 1 0>; /*audio DAC mute*/
+		gpios = <&rtk_iso_gpio 21 0 2>;
+		gpio-activity = <1>; /*0: low active  1: high active*/
+		detect-mode = <1>; /* 0:vdac detect, 1: gpio detect*/
+		status = "okay";
+	};
+
+	hse: hse@98005000 {
+		compatible = "realtek,highspeed-streaming-engine";
+		reg = <0x98005000 0x1000>;
+		interrupts = <0 27 4>;
+		clocks = <&clk_en_2 CLK_EN_HSE>;
+		resets = <&rst1 RSTN_HSE>;
+		status = "okay";
+
+		engine-0-enabled;
+		engine-1-disabled;
+	};
+
+	rtktrace@3b100000 {
+		compatible = "Realtek,trace";
+		/* This is only temporary address, adjust it if feature desired */
+		reg = <0x3b100000 0x100000>,
+			<0x3b200000 0x40000>;
+		reg-names = "rtk_trace_res",
+			"rtk_trace_vmap";
+		status = "disabled";
+	};
+
+	audio_in: audio-in {
+		compatible = "realtek,audio-in", "adc";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2s_out_4pins>, <&i2s_in_pins>;
+		status = "disabled";
+	};
+};
+
+#include "rtd-139x-pcie.dtsi"
+
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/Makefile b/arch/arm64/boot/dts/realtek/rtd13xx/Makefile
new file mode 100644
index 00000000..230c24a
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/Makefile
@@ -0,0 +1,16 @@
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-2GB-avb.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-2GB-avb-tee.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-nand-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-pymparticle-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1315-reddiscs-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1315-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1315-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-nas-pymparticles-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD13xx) += rtd-1319-nas-qa-rescue.dtb
+always          := $(dtb-y)
+subdir-y        := $(dts-dirs)
+clean-files     := *.dtb
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue-tee.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue-tee.dts
new file mode 100644
index 00000000..7f2e4fb
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue-tee.dts
@@ -0,0 +1,183 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-13xx.dtsi"
+#include "rtd-1315-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB_TEE";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hank androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 { /* SECURE */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				0x32b00000
+				0x12C00000
+				ION_SECURE_HEAP_FLAG>;
+                };
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&pcie2 {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue.dts
new file mode 100644
index 00000000..4a079de
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-qa-rescue.dts
@@ -0,0 +1,173 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-13xx.dtsi"
+#include "rtd-1315-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hank androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&pcie2 {
+	status = "disabled";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-2GB.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-2GB.dts
new file mode 100644
index 00000000..c52b528
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs-2GB.dts
@@ -0,0 +1,225 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1315-reddiscs.dtsi"
+#include "rtd-1315-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_RedDiscs_2GB";
+	model_hex= <0x00000523>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.storage=emmc androidboot.hardware=hank loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs.dtsi
new file mode 100644
index 00000000..3aceae9
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-reddiscs.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-1315.dtsi"
+#include "rtd-13xx-dvfs.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-usb.dtsi
new file mode 100644
index 00000000..97e914e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315-usb.dtsi
@@ -0,0 +1,78 @@
+/*
+ * rtd-1315-usb.dtsi
+ */
+/ {
+	/include/ "rtd-13xx-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		status = "okay";
+
+		port0 {
+			type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+			gpio = <&gpio0>;
+		};
+
+		port1 {
+			gpio = <&gpio1>;
+		};
+
+		port2 {
+			/delete-property/gpio;
+		};
+
+		rtk_usb {
+			pcie_usb3phy_sel = <0x9800705c>;
+
+			type_c {
+				// For 1315, 1317, u2drd
+				realtek,connector_switch-gpio = <&rtk_iso_gpio 25 1 3>;
+			};
+		};
+	};
+
+	dwc3_u2drd_usb2phy: dwc3_u2drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2drd: rtk_dwc3_u2drd@98013200 {
+		status = "okay";
+
+		dwc3_u2drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		dwc3_type_c: rtk_dwc3_type_c@0 {
+			drd_mode; //depend on dr_mode = "peripheral"
+			boot_check_time = <30000>; /*ms (At boot Device switch Host time)*/
+			status = "okay";
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb3phy: dwc3_u3drd_usb3phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb2phy: dwc3_u3drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd: rtk_dwc3_u3drd@98013E00 {
+		status = "okay";
+
+		dwc3_u3drd@981F0000 {
+			dr_mode = "host"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		/delete-node/rtk_dwc3_type_c@0;
+	};
+
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315.dtsi
new file mode 100644
index 00000000..e9d7d2c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1315.dtsi
@@ -0,0 +1 @@
+#include "rtd-13xx.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1317-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1317-usb.dtsi
new file mode 100644
index 00000000..4f70426
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1317-usb.dtsi
@@ -0,0 +1,71 @@
+/*
+ * rtd-1317-usb.dtsi
+ */
+/ {
+	/include/ "rtd-13xx-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		status = "okay";
+
+		port0 {
+			type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+		};
+
+		port1 {
+			/delete-property/gpio;
+		};
+
+		rtk_usb {
+			pcie_usb3phy_sel = <0x9800705c>;
+
+			type_c {
+				// For 1315, 1317, u2drd
+				realtek,connector_switch-gpio = <&rtk_iso_gpio 25 1 3>;
+			};
+		};
+	};
+
+	dwc3_u2drd_usb2phy: dwc3_u2drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2drd: rtk_dwc3_u2drd@98013200 {
+		status = "okay";
+
+		dwc3_u2drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		dwc3_type_c: rtk_dwc3_type_c@0 {
+			drd_mode; //depend on dr_mode = "peripheral"
+			status = "okay";
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb3phy: dwc3_u3drd_usb3phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb2phy: dwc3_u3drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd: rtk_dwc3_u3drd@98013E00 {
+		status = "okay";
+
+		dwc3_u3drd@981F0000 {
+			dr_mode = "host"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		/delete-node/rtk_dwc3_type_c@0;
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-nas-pymparticles-2GB.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-nas-pymparticles-2GB.dts
new file mode 100644
index 00000000..1c2fe69
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-nas-pymparticles-2GB.dts
@@ -0,0 +1,222 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1319-pymparticle.dtsi"
+#include "rtd-1319-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB";
+	model_hex= <0x00000527>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			gpios = <&rtk_iso_gpio 80 1 1>;
+		};
+		sata-port@1 {
+			gpios = <&rtk_iso_gpio 81 1 1>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-nas-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-nas-qa-rescue.dts
new file mode 100644
index 00000000..cb61284
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-nas-qa-rescue.dts
@@ -0,0 +1,173 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START 0x00100000;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-13xx.dtsi"
+#include "rtd-1319-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <0x02300000>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init androidboot.hardware=hank androidboot.storage=emmc loglevel=8";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&pcie2 {
+	status = "disabled";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-1GB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-1GB.CMAx2.dts
new file mode 100644
index 00000000..33131ca
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-1GB.CMAx2.dts
@@ -0,0 +1,227 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1319-pymparticle.dtsi"
+#include "rtd-1319-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_1GB_CMAx2";
+	model_hex= <0x00000527>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.storage=emmc androidboot.hardware=hank loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0 0x0b000000>; /* size 176MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x14000000 0 0x0b000000>; /* offset 320MB, size 176MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x00800000>; /* size 8MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			gpios = <&rtk_iso_gpio 80 1 1>;
+		};
+		sata-port@1 {
+			gpios = <&rtk_iso_gpio 81 1 1>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb-tee.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb-tee.dts
new file mode 100644
index 00000000..d0f9955
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb-tee.dts
@@ -0,0 +1,7 @@
+#include "rtd-1319-pymparticle-2GB-tee.dts"
+#include "rtd-13xx-avb.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB_AVB_TEE";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb.dts
new file mode 100644
index 00000000..51bbaab
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1319-pymparticle-2GB.dts"
+#include "rtd-13xx-avb.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB_AVB";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-tee.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-tee.dts
new file mode 100644
index 00000000..732b564
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB-tee.dts
@@ -0,0 +1,245 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+
+#include "rtd-1319-pymparticle.dtsi"
+#include "rtd-1319-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB_TEE";
+	model_hex= <0x00000527>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hank androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS_0 
+                ION_SECURE_HEAP_SIZE_0 
+                ION_SECURE_HEAP_FLAG_0
+                ION_SECURE_AUDIO_PHYS_0 
+                ION_SECURE_AUDIO_SIZE_0 
+                ION_SECURE_AUDIO_FLAG_0
+                >;
+        };
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			gpios = <&rtk_iso_gpio 80 1 1>;
+		};
+		sata-port@1 {
+			gpios = <&rtk_iso_gpio 81 1 1>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB.dts
new file mode 100644
index 00000000..a4f1648
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-2GB.dts
@@ -0,0 +1,222 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1319-pymparticle.dtsi"
+#include "rtd-1319-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB";
+	model_hex= <0x00000527>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,460800 init=/init androidboot.storage=emmc androidboot.hardware=hank loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			gpios = <&rtk_iso_gpio 80 1 1>;
+		};
+		sata-port@1 {
+			gpios = <&rtk_iso_gpio 81 1 1>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-nand-2GB.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-nand-2GB.dts
new file mode 100644
index 00000000..32ed5878
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle-nand-2GB.dts
@@ -0,0 +1,215 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1319-pymparticle.dtsi"
+#include "rtd-1319-usb.dtsi"
+#include "rtd-1319-sata.dtsi"
+
+/ {
+	model= "Realtek_PymParticle_2GB_NAND";
+	model_hex= <0x00000527>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hank androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	nand@98010000 { status = "okay"; };
+	emmc@98012000 { status = "disabled"; };
+	
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			gpios = <&rtk_iso_gpio 80 1 1>;
+		};
+		sata-port@1 {
+			gpios = <&rtk_iso_gpio 81 1 1>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle.dtsi
new file mode 100644
index 00000000..6a4526d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-pymparticle.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-1319.dtsi"
+#include "rtd-13xx-dvfs.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue-tee.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue-tee.dts
new file mode 100644
index 00000000..ab25c1b
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue-tee.dts
@@ -0,0 +1,183 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-13xx.dtsi"
+#include "rtd-1319-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB_TEE";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hank androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 { /* SECURE */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				0x32b00000
+				0x12C00000
+				ION_SECURE_HEAP_FLAG>;
+                };
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&pcie2 {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue.dts
new file mode 100644
index 00000000..d46b8b1
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-qa-rescue.dts
@@ -0,0 +1,173 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd13xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-13xx.dtsi"
+#include "rtd-1319-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=hank androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&pcie2 {
+	status = "disabled";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-sata.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-sata.dtsi
new file mode 100644
index 00000000..c45eeb9
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-sata.dtsi
@@ -0,0 +1,19 @@
+/* PLEASE include this file inside a node */
+
+#include "rtd-13xx-sata.dtsi"
+
+/ {
+	sata_phy: sata_phy@9803FF60 {
+		status = "okay";
+		sata-phy@0 {
+			status = "okay";
+		};
+		sata-phy@1 {
+			status = "okay";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		status = "okay";
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-usb.dtsi
new file mode 100644
index 00000000..9dd1682
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319-usb.dtsi
@@ -0,0 +1,68 @@
+/*
+ * rtd-1319-usb.dtsi
+ */
+/ {
+	/include/ "rtd-13xx-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		status = "okay";
+
+		port2 {
+			type_c = <&dwc3_type_c>; /* for port 2 type c driver */
+		};
+
+		rtk_usb {
+			pcie_usb3phy_sel = <0x9800705c>; /* Only for RTD1319 */
+
+			type_c {
+				/* For 1319, u3drd */
+				realtek,plug_side_switch-gpio = <&rtk_iso_gpio 53 1 3>;
+			};
+
+		};
+	};
+
+	dwc3_u2drd_usb2phy: dwc3_u2drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2drd: rtk_dwc3_u2drd@98013200 {
+		status = "okay";
+
+		dwc3_u2drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+			status = "okay";
+		};
+		/delete-node/rtk_dwc3_type_c@0;
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb3phy: dwc3_u3drd_usb3phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd_usb2phy: dwc3_u3drd_usb2phy@0 {
+		status = "okay";
+	};
+
+	dwc3_u3drd: rtk_dwc3_u3drd@98013E00 {
+		status = "okay";
+
+		dwc3_u3drd@981F0000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+			status = "okay";
+		};
+
+		dwc3_type_c: rtk_dwc3_type_c@0 {
+			drd_mode; //depend on dr_mode = "peripheral"
+			status = "okay";
+		};
+	};
+
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319.dtsi
new file mode 100644
index 00000000..e9d7d2c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-1319.dtsi
@@ -0,0 +1 @@
+#include "rtd-13xx.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-avb.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-avb.dtsi
new file mode 100644
index 00000000..60e2d6f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-avb.dtsi
@@ -0,0 +1,17 @@
+/ {
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				/delete-node/ system;
+				vendor {
+					fsmgr_flags = "wait,avb";
+				};
+			};
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-cpu-dvfs-extreme.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-cpu-dvfs-extreme.dtsi
new file mode 100644
index 00000000..e2f69e2
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-cpu-dvfs-extreme.dtsi
@@ -0,0 +1,79 @@
+#include "rtd-13xx-cpu-dvfs.dtsi"
+
+/*
+ * Frequnecy overview
+ *
+ *    CDEV                             CDEV  CDEV  CDEV  CDEV
+ *      ST  FREQUENCY   HLS   SUSPEND  MAP0  MAP1  MAP2  MAP3
+ *       0       1700    V                                |
+ *       1       1600    V                                |
+ *       2       1500    V                                |
+ *       3       1400    V                         -+-   -+-
+ *       4       1300                  -+-         -+-
+ *       5       1200            V      |
+ *       6       1100                   |
+ *       7       1000                   |
+ *       8        900                   |
+ *       9        800                  -+-
+ *      10        700                        -+-
+ *      11        600                         |
+ *      12        500                         |
+ *      13        400                         |
+ *      14        300                         |
+ */
+
+&A55_0 {
+};
+&A55_1 {
+};
+&A55_2 {
+};
+&A55_3 {
+};
+
+&cpu_opps {
+	opp1500: opp-1500mhz {
+		opp-hz = /bits/ 64 <1500000000>;
+		opp-microvolt = <1187500>;
+		clock-latency-ns = <150000>;
+		status = "okay";
+	};
+	opp1600: opp-1600mhz {
+		opp-hz = /bits/ 64 <1600000000>;
+		opp-microvolt = <1262500>;
+		clock-latency-ns = <150000>;
+		status = "okay";
+	};
+	opp1700: opp-1700mhz {
+		opp-hz = /bits/ 64 <1700000000>;
+		opp-microvolt = <1337500>;
+		clock-latency-ns = <150000>;
+		status = "okay";
+	};
+};
+&cpu_thermal {
+	trips {
+		tm_alert4: cpu-alert4 {
+			temperature = <85000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+	};
+	cooling-maps {
+		cpu-map0 {
+			cooling-device = <&A55_0 4 10>;
+		};
+		cpu-map1 {
+			cooling-device = <&A55_0 10 THERMAL_NO_LIMIT>;
+		};
+		cpu-map2 {
+			cooling-device = <&A55_0 3 4>;
+		};
+		cpu-map3 {
+			trip = <&tm_alert4>;
+			cooling-device = <&A55_0 THERMAL_NO_LIMIT 3>;
+			contribution = <70>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-dvfs.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-dvfs.dtsi
new file mode 100644
index 00000000..ef66b53
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-dvfs.dtsi
@@ -0,0 +1,280 @@
+/*
+ * RTD-13XX DVFS with Anpec APW8889 PMIC
+ */
+#include <dt-bindings/regulator/anpec,apw888x.h>
+#include <dt-bindings/thermal/thermal.h>
+
+/* PMIC */
+&i2c_0 {
+	status = "okay";
+
+	apw8886: apw8886g@12 {
+		compatible = "anpec,apw8886";
+		reg = <0x12>;
+
+		status = "okay";
+
+		powerkey_1: powerkey {
+			compatible = "gmt,g22xx-powerkey";
+			status = "disabled";
+		};
+		poweroff_1: poweroff {
+			compatible = "gmt,g22xx-poweroff";
+			system-power-controller;
+			statis = "disabled";
+		};
+		regulators_1: regulators {
+			compatible = "anpec,apw8886-regulator";
+			status = "okay";
+		};
+
+	};
+};
+
+&apw8886 {
+	regulators {
+		vd33_supp: dc1 {
+			regulator-name = "vd33";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3777500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <3200000>;
+			};
+		};
+		core_supp: dc2 {
+			regulator-name = "core";
+			regulator-min-microvolt = <550000>;
+			regulator-max-microvolt = <1337500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <900000>;
+			};
+		};
+		cpu_supp: dc3 {
+			regulator-name = "cpudvs";
+			regulator-min-microvolt = <550000>;
+			regulator-max-microvolt = <1337500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_DC_MODE_AUTO>;
+			regulator-ramp-delay = <625>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		vd18_supp: dc4 {
+			regulator-name = "vd18";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <2060000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_DC_MODE_AUTO>;
+		};
+		ddr_supp: dc5 {
+			regulator-name = "ddr";
+			regulator-min-microvolt = <1200000>;
+			regulator-max-microvolt = <1200000>;
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_DC_MODE_AUTO>;
+		};
+		vd25_supp: ldo1 {
+			regulator-name = "vd25";
+			regulator-min-microvolt = <1780000>;
+			regulator-max-microvolt = <3020000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW888X_LDO_MODE_NORMAL>;
+		};
+	};
+};
+
+/* CPU nodes */
+&A55_0 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_1 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_2 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_3 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+/* cpu opp table */
+&dvfs {
+	cpu_opps: cpu-opp-table {
+		compatible = "operating-points-v2";
+		opp-shared;
+		opp300: opp-300mhz {
+			opp-hz = /bits/ 64 <300000000>;
+			opp-microvolt = <787500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp400: opp-400mhz {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		opp500: opp-500mhz {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp600: opp-600mhz {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp700: opp-700mhz {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp800: opp-800mhz {
+			opp-hz = /bits/ 64 <800000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp900: opp-900mhz {
+			opp-hz = /bits/ 64 <900000000>;
+			opp-microvolt = <900000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1000: opp-1000mhz {
+			opp-hz = /bits/ 64 <1000000000>;
+			opp-microvolt = <937500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1100: opp-1100mhz {
+			opp-hz = /bits/ 64 <1100000000>;
+			opp-microvolt = <987500>;
+			clock-latency-ns = <150000>;
+			opp-suspend;
+			status = "okay";
+		};
+		opp1200: opp-1200mhz {
+			opp-hz = /bits/ 64 <1200000000>;
+			opp-microvolt = <1025000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1300: opp-1300mhz {
+			opp-hz = /bits/ 64 <1300000000>;
+			opp-microvolt = <1050000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1400: opp-1400mhz {
+			opp-hz = /bits/ 64 <1400000000>;
+			opp-microvolt = <1125000>;
+			clock-latency-ns = <150000>;
+			status = "dis";
+		};
+	};
+};
+
+&cpu_thermal {
+	trips {
+		tm_alert0: cpu-alert0 {
+			temperature = <105000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+		tm_alert1: cpu-alert1 {
+			temperature = <115000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+	};
+	cooling-maps {
+		cpu-map0 {
+			trip = <&tm_alert0>;
+			cooling-device = <&A55_0 THERMAL_NO_LIMIT 6>;
+			contribution = <70>;
+		};
+		cpu-map1 {
+			trip = <&tm_alert1>;
+			cooling-device = <&A55_0 7 THERMAL_NO_LIMIT>;
+			contribution = <70>;
+		};
+	};
+};
+
+
+&gpu {
+	mali-supply = <&core_supp>;
+	operating-points-v2 = <&gpu_opps>;
+	assigned-clocks = <&cc CC_CLK_GPU>;
+	assigned-clock-rates = <400000000>;
+
+	gpu_opps: gpu-opp-table {
+		compatible = "operating-points-v2",
+			     "operating-points-v2-mali";
+
+		opp-400 {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <900000>;
+			opp-suspend;
+		};
+		opp-500 {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-hz-real = /bits/ 64 <500000000>;
+			opp-microvolt = <900000>;
+		};
+		opp-600 {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-hz-real = /bits/ 64 <600000000>;
+			opp-microvolt = <900000>;
+		};
+		opp-650 {
+			opp-hz = /bits/ 64 <650000000>;
+			opp-hz-real = /bits/ 64 <650000000>;
+			opp-microvolt = <900000>;
+		};
+		opp-720 {
+			opp-hz = /bits/ 64 <720000000>;
+			opp-hz-real = /bits/ 64 <720000000>;
+			opp-microvolt = <950000>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-irda.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-irda.dtsi
new file mode 100644
index 00000000..1f20960
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-irda.dtsi
@@ -0,0 +1,51 @@
+/*
+ * rtd-13xx-irda.dtsi - IRDA remote Device Tree Include file for REALTEK family SoC
+ */
+
+/ {
+	irda@98007400 {
+		irda_rx0 {
+			irrx-protocol = "NEC";
+			transcode-mode = <1>;
+
+			cust-code = <0x7F80>;
+			scancode-msk = <0x00FF0000>;  
+			custcode-msk = <0x0000FFFF>;  
+			keymap-tbl = <
+			// scancode	keycode
+				0x18 	116		//KEY_POWER		//POWER
+				0x5A 	353		//KEY_SELECT		//SOURCE
+				0x58 	154		//KEY_CYCLEWINDOWS	//PIP
+				0x1A 	377		//KEY_TV		//TV SYSTEM
+				0x14 	102		//KEY_HOME		//HOME
+				0x56 	357		//KEY_OPTION		//OPTION MENU
+				0x54	358		//KEY_INFO		//MEDIA_INFO
+				0x19 	232		//KEY_REPLY		//REPEAT
+				0x57 	158		//KEY_BACK		//RETURN
+				0x55 	207		//KEY_PLAY		//PLAY/PAUSE
+				0x17 	128		//KEY_STOP		//STOP
+				0x15 	372		//KEY_ZOOM		//ZOOM_IN
+				0x4F 	168		//KEY_REWIND		//FR
+				0x4D 	103		//KEY_UP		//UP
+				0x16 	208		//KEY_FASTFORWARD	//FF
+				0x0C 	105		//KEY_LEFT		//LEFT
+				0x4C 	352		//KEY_OK		//OK
+				0x0E 	106		//KEY_RIGHT		//RIGHT
+				0x08 	412		//KEY_PREVIOUS		//PREVIOUS
+				0x48 	108		//KEY_DOWN		//DOWN
+				0x09 	407		//KEY_NEXT		//NEXT
+				0x4B 	114		//KEY_VOLUMEDOWN	//VOL-
+				0x49 	115		//KEY_VOLUMEUP		//VOL+
+				0x0B 	532		//KEY_TOUCHPAD_OFF	//CURSOR
+				0x0A 	531		//KEY_TOUCHPAD_ON	//GESTURE
+				0xEEEE	0		//REL_X			//mouse X-axi	0xEEEE : REL event type
+				0xEEEE	1		//REL_Y			//mouse Y-axi	0xEEEE : REL event type
+				0xFFFF	272		//BTN_LEFT		//mouse left key	0xFFFF : KEY event type
+				0xFFFF	113     	//KEY_MUTE 		//mute key in AirFunAPP	0xFFFF : KEY event type	
+			>; 
+			reg-ir-dpir = <50>;	/*IR detect interval, NEC default=50ms, should less than 100ms, and bigger than 9ms*/
+			sample-rate = <40>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-pcie.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-pcie.dtsi
new file mode 100644
index 00000000..fb267fa
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-pcie.dtsi
@@ -0,0 +1,216 @@
+/ {
+	pcie: pcie@98060000 {
+		compatible = "realtek,rtk13xx-pcie-slot1";
+		reg = <0x0 0x98060000 0x0 0x00001000
+		       0x0 0x98061000 0x0 0x00001000
+		       0x0 0x9801C800 0x0 0x00000100
+		       0x0 0x9800705C 0x0 0x00000010>;
+		interrupt-names = "rtk-pcie1-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic 0 0 GIC_SPI 61 IRQ_TYPE_LEVEL_HIGH>;
+		interrupts = <0 61 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins_0>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <0>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 19 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys = <0x000f0601>,
+			<0x86700a01>,
+			<0xff002901>,
+			<0x520c0901>,
+			<0x4f082401>,
+			<0xf7120d01>,
+			<0xbb662301>,
+			<0x000f4601>,
+			<0xc4772001>,
+			<0x33772101>,
+			<0x00132201>,
+			<0x61BD2f01>,
+			<0x500c0901>,
+			<0x520c0901>,
+			<0x000f4601>,
+			<0x86704a01>,
+			<0xff006901>,
+			<0xa80a4101>,
+			<0x520c4901>,
+			<0x4f0c6401>,
+			<0xf7124d01>,
+			<0xbb666301>,
+			<0xc4776001>,
+			<0x33776101>,
+			<0x00136201>,
+			<0x61bd6f01>,
+			<0x500c4901>,
+			<0x520c4901>;
+
+		//speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x98062000 0x0 0x98062000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00030000 0x0 0x00030000 0x00000000 0x00010000>;
+		resets = <&crst RSTN_PCIE0>,
+			<&crst RSTN_PCIE0_CORE>,
+			<&crst RSTN_PCIE0_POWER>,
+			<&crst RSTN_PCIE0_NONSTITCH>,
+			<&crst RSTN_PCIE0_STITCH>,
+			<&crst RSTN_PCIE0_PHY>,
+			<&crst RSTN_PCIE0_PHY_MDIO>,
+			<&crst RSTN_PCIE0_SGMII_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio",
+			"sgmii_mdio";
+		clocks = <&clk_en_1 CLK_EN_PCIE0>;
+		status = "okay";
+	};
+
+	pcie2: pcie2@980A0000 {
+		compatible = "realtek,rtk13xx-pcie-slot2";
+		reg = <0x0 0x980A0000 0x0 0x00001000
+		       0x0 0x980A1000 0x0 0x00001000
+		       0x0 0x9801C600 0x0 0x00000100
+		       0x0 0x9804F000 0x0 0x00000100>;
+		interrupt-names = "rtk-pcie2-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic 0 0 GIC_SPI 62 IRQ_TYPE_LEVEL_HIGH>;
+		interrupts = <0 62 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins_1>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <1>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 80 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys = <0x000f0601>,
+			<0x86700a01>,
+			<0xff002901>,
+			<0x520c0901>,
+			<0x4f082401>,
+			<0xf7120d01>,
+			<0xbb662301>,
+			<0x000f4601>,
+			<0xc4772001>,
+			<0x33772101>,
+			<0x00132201>,
+			<0x61BD2f01>,
+			<0x500c0901>,
+			<0x520c0901>,
+			<0x000f4601>,
+			<0x86704a01>,
+			<0xff006901>,
+			<0xa80a4101>,
+			<0x520c4901>,
+			<0x4f0c6401>,
+			<0xf7124d01>,
+			<0xbb666301>,
+			<0xc4776001>,
+			<0x33776101>,
+			<0x00136201>,
+			<0x61bd6f01>,
+			<0x500c4901>,
+			<0x520c4901>;
+
+		//speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x980A2000 0x0 0x980A2000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00040000 0x0 0x00040000 0x00000000 0x00010000>;
+		resets = <&crst RSTN_PCIE1>,
+			<&crst RSTN_PCIE1_CORE>,
+			<&crst RSTN_PCIE1_POWER>,
+			<&crst RSTN_PCIE1_NONSTITCH>,
+			<&crst RSTN_PCIE1_STITCH>,
+			<&crst RSTN_PCIE1_PHY>,
+			<&crst RSTN_PCIE1_PHY_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_4 CLK_EN_PCIE1>;
+		status = "okay";
+	};
+
+	pcie3: pcie3@980C0000 {
+		compatible = "realtek,rtk13xx-pcie-slot3";
+		reg = <0x0 0x980C0000 0x0 0x00001000
+		       0x0 0x980C1000 0x0 0x00001000
+		       0x0 0x9801C600 0x0 0x00000100
+		       0x0 0x9804F000 0x0 0x00000100>;
+		interrupt-names = "rtk-pcie3-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic 0 0 GIC_SPI 62 IRQ_TYPE_LEVEL_HIGH>;
+		interrupts = <0 62 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins_2>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <2>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 81 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys = <0x000f0601>,
+			<0x86700a01>,
+			<0xff002901>,
+			<0x520c0901>,
+			<0x4f082401>,
+			<0xf7120d01>,
+			<0xbb662301>,
+			<0x000f4601>,
+			<0xc4772001>,
+			<0x33772101>,
+			<0x00132201>,
+			<0x61BD2f01>,
+			<0x500c0901>,
+			<0x520c0901>,
+			<0x000f4601>,
+			<0x86704a01>,
+			<0xff006901>,
+			<0xa80a4101>,
+			<0x520c4901>,
+			<0x4f0c6401>,
+			<0xf7124d01>,
+			<0xbb666301>,
+			<0xc4776001>,
+			<0x33776101>,
+			<0x00136201>,
+			<0x61bd6f01>,
+			<0x500c4901>,
+			<0x520c4901>;
+
+		//speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x980C2000 0x0 0x980C2000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00040000 0x0 0x00040000 0x00000000 0x00010000>;
+		resets = <&crst RSTN_PCIE2>,
+			<&crst RSTN_PCIE2_CORE>,
+			<&crst RSTN_PCIE2_POWER>,
+			<&crst RSTN_PCIE2_NONSTITCH>,
+			<&crst RSTN_PCIE2_STITCH>,
+			<&crst RSTN_PCIE2_PHY>,
+			<&crst RSTN_PCIE2_PHY_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_7 CLK_EN_PCIE2>;
+		status = "okay";
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-pinctrl.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-pinctrl.dtsi
new file mode 100644
index 00000000..62692b3
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-pinctrl.dtsi
@@ -0,0 +1,536 @@
+
+/ {
+	pinctrl@9804E000 {
+		sdcard_pins_low: sdcard_low {
+			realtek,pins= "gpio_32",
+			"gpio_33",
+			"hif_data",
+			"hif_en",
+			"hif_rdy",
+			"hif_clk";
+			realtek,function="sd";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <0>;
+		};
+
+		sdcard_pins_high: sdcard_high {
+			realtek,pins="gpio_35", "gpio_34";
+			realtek,function="mmc";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <1>;
+		};
+
+		sdio_pins_0: sdio_pins_0 {
+			realtek,pins= "gpio_32",
+			"gpio_33",
+			"hif_data",
+			"hif_en",
+			"hif_rdy",
+			"hif_clk",
+			"sdio_loc";
+			realtek,function = "sdio_loc0";
+		};
+
+		sdio_pins_1: sdio_pins_1 {
+			realtek,pins = "gpio_40",
+			"gpio_41",
+			"gpio_42",
+			"gpio_43",
+			"gpio_44",
+			"gpio_45",
+			"sdio_loc";
+			realtek,function = "sdio_loc1";
+		};
+
+
+		uart0_pins: uart0_pins {
+			realtek,pins = "ur0_rx",
+			"ur0_tx";
+			realtek,function = "uart0";
+		};
+
+		uart1_pins: uart1_pins {
+			realtek,pins = "gpio_8",
+			"gpio_9";
+			realtek,function = "uart1";
+		};
+
+		uart2_pins_0: uart2_pins_0 {
+			realtek,pins = "ur2_loc",
+			"gpio_18",
+			"gpio_19";
+			realtek,function = "uart2_loc0";
+		};
+
+		uart2_pins_1: uart2_pins_1 {
+			realtek,pins ="ur2_loc",
+			"gpio_26",
+			"gpio_27";
+			realtek,function = "uart2_loc1";
+		};
+
+		i2c_pins_0: i2c_pins_0 {
+			realtek,pins = "gpio_12",
+			"gpio_13";
+			realtek,function = "i2c0";
+			realtek,drive = <4>;
+		};
+
+		i2c_pins_0_HS: i2c_pins_0_HS {
+			realtek,pins = "gpio_12",
+			"gpio_13";
+			realtek,function = "i2c0";
+			realtek,drive = <8>;
+		};
+
+		i2c_pins_1: i2c_pins_1 {
+			realtek,pins = "gpio_16",
+			"gpio_17";
+			realtek,function = "i2c1";
+		};
+
+
+		i2c_pins_3: i2c_pins_3 {
+			realtek,pins = "gpio_63",
+			"gpio_64";
+			realtek,function = "i2c3";
+		};
+
+
+		i2c_pins_5: i2c_pins_5 {
+			realtek,pins = "gpio_29",
+			"gpio_46";
+			realtek,function = "i2c5";
+		};
+
+		spi_pins_enable: spi-pins-enable {
+			realtek,pins = "sf_en";
+			realtek,function = "sf_enable";
+		};
+
+		spi_pins_loc_spi: spi_pins_loc_spi {
+			realtek,pins = "spi_ce_n",
+			"spi_sck",
+			"spi_so",
+			"spi_si";
+			realtek,function = "spi";
+		};
+
+		gspi_pins_0: gspi_pins_0 {
+			realtek,pins = "gspi_loc",
+			"gpio_18",
+			"gpio_19",
+			"gpio_20",
+			"gpio_31";
+			realtek,function = "gspi_loc0";
+		};
+
+		gspi_pins_1: gspi_pins_1 {
+			realtek,pins = "gspi_loc",
+			"gpio_8",
+			"gpio_9",
+			"gpio_10",
+			"gpio_11";
+			realtek,function = "gspi_loc1";
+		};
+
+		iso_gspi_pins_0: iso_gspi_pins_0 {
+			realtek,pins = "iso_gspi_loc",
+			"gpio_18",
+			"gpio_19",
+			"gpio_20",
+			"gpio_31";
+			realtek,function = "iso_gspi_loc0";
+		};
+
+		iso_gspi_pins_1: iso_gspi_pins_1 {
+			realtek,pins = "iso_gspi_loc",
+			"gpio_8",
+			"gpio_9",
+			"gpio_10",
+			"gpio_11";
+			realtek,function = "iso_gspi_loc1";
+		};
+
+		smartcard_pins_0:smartcard_pins_0{
+			realtek,pins = "gpio_18",
+			"gpio_19",
+			"gpio_20",
+			"gpio_31";
+			realtek,function = "sc0";
+		};
+
+		smartcard_pins_1:smartcard_pins_1{
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5";
+			realtek,function = "sc1";
+		};
+
+		tp0_loc_tp0_pins: tp0_loc_tp0_pins {
+			realtek,pins = "gpio_66",
+			"gpio_67",
+			"gpio_68",
+			"gpio_69",
+			"gpio_70",
+			"gpio_71",
+			"gpio_72",
+			"gpio_73",
+			"gpio_74",
+			"gpio_75",
+			"gpio_76";
+			realtek,function = "tp0";
+		};
+
+		tp1_loc_tp1_pins: tp1_loc_tp1_pins {
+			realtek,pins = "gpio_69",
+			"gpio_70",
+			"gpio_71",
+			"gpio_72";
+			realtek,function = "tp1";
+		};
+
+		ao_pins: ao_pins {
+			realtek,pins = "gpio_66",
+			"gpio_67",
+			"gpio_68",
+			"gpio_69",
+			"gpio_70",
+			"gpio_71",
+			"gpio_72";
+			realtek,function = "ao";
+		};
+
+		ir_rx_pins: ir_rx_pins {
+			realtek,pins = "ir_rx";
+			realtek,function = "ir_rx";
+		};
+
+		spdif_pins: spdif_pins {
+			realtek,pins = "gpio_50";
+			realtek,function = "spdif";
+		};
+
+		/*spdif_optical_pins: spdif_optical_pins {
+			realtek,pins = "gpio_21", "gpio_68", "gpio_85";
+			realtek,function = "spdif";
+			realtek,pull_en =  <0>;
+		};*/
+
+		ai_loc0_pins: ai_loc0_pins {
+			realtek,pins = "gpio_57",
+				"gpio_58",
+				"gpio_59",
+				"gpio_60",
+				"gpio_61",
+				"gpio_62",
+				"gpio_63";
+			realtek,function = "ai_loc0";
+		};
+
+		ai_loc1_pins: ai_loc1_pins {
+			realtek,pins = "gpio_32",
+				"gpio_33",
+				"gpio_34",
+				"hif_data",
+				"hif_en",
+				"hif_rdy",
+				"hif_clk";
+			realtek,function = "ai_loc1";
+		};
+
+		dmic_loc0_pins: dmic_loc0_pins {
+			realtek,pins = "dmic_loc",
+				"gpio_57",
+				"gpio_58",
+				"gpio_59",
+				"gpio_60",
+				"gpio_61",
+				"gpio_62",
+				"gpio_63",
+				"gpio_64";
+			realtek,function = "dmic_loc0";
+		};
+
+		dmic_loc1_pins: dmic_loc1_pins {
+			realtek,pins = "dmic_loc",
+				"gpio_32",
+				"gpio_33",
+				"gpio_34",
+				"gpio_35",
+				"hif_data",
+				"hif_en",
+				"hif_rdy",
+				"hif_clk";
+			realtek,function = "dmic_loc1";
+		};
+
+		tdm_loc0_pins: tdm_loc0_pins {
+			realtek,pins =
+				"gpio_57",
+				"gpio_58",
+				"gpio_59",
+				"gpio_60";
+			realtek,function = "tdm_ai_loc0";
+		};
+
+
+		tdm_loc1_pins: tdm_loc1_pins {
+			realtek,pins =
+				"hif_data",
+				"hif_en",
+				"hif_rdy",
+				"hif_clk";
+			realtek,function = "tdm_ai_loc1";
+		};
+
+
+		/*i2s_out_4pins: i2s_out_4pins {
+			realtek,pins ="tp_data_1",
+			"tp_data_2",
+			"tp_data_3",
+			"tp_data_4";
+			realtek,function = "ao";
+		};*/
+
+		/*i2s_in_pins: i2s_in_pins {
+			realtek,pins = "gpio_6";
+			realtek,function = "ai";
+		};*/
+
+		etn_led_pins: etn_led_pins {
+			realtek,pins = "gpio_14",
+			"gpio_15";
+			realtek,function = "etn_led";
+		};
+
+		rgmii_mdio_pins: rgmii_mdio_pins {
+			realtek,pins = "gpio_14",
+			"gpio_15";
+			realtek,function = "rgmii";
+		};
+
+		rgmii_txrx_pins: rgmii_txrx_pins {
+			realtek,pins = "gpio_65",
+			"gpio_66",
+			"gpio_67",
+			"gpio_68",
+			"gpio_69",
+			"gpio_70",
+			"gpio_71",
+			"gpio_72",
+			"gpio_73",
+			"gpio_74",
+			"gpio_75",
+			"gpio_76";
+			realtek,function = "rgmii";
+		};
+
+		pcie_clk_pins_0: pcie_clk_pins_0 {
+			realtek,pins = "gpio_46";
+			realtek,function = "pcie0";
+		};
+
+		pcie_clk_pins_1: pcie_clk_pins_1 {
+			realtek,pins = "gpio_25";
+			realtek,function = "pcie1";
+		};
+
+		pcie_clk_pins_2: pcie_clk_pins_2 {
+			realtek,pins = "gpio_52";
+			realtek,function = "pcie2";
+		};
+
+		scpu_ejtag_pins_loc_0: scpu_ejtag_pins_loc_0 {
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5",
+			"gpio_6",
+			"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc0";
+		};
+
+		scpu_ejtag_pins_loc_1: scpu_ejtag_pins_loc_1 {
+			realtek,pins = "gpio_32",
+			"gpio_33",
+			"hif_data",
+			"hif_en",
+			"hif_clk",
+			"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc1";
+		};
+
+		scpu_ejtag_pins_disable: scpu_ejtag_pins_disable {
+			realtek,pins = "ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_disable";
+		};
+
+		acpu_ejtag_pins_loc_0: acpu_ejtag_pins_loc_0 {
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5",
+			"gpio_6",
+			"ejtag_acpu_loc";
+			realtek,function = "acpu_ejtag_loc0";
+		};
+
+		acpu_ejtag_pins_loc_1: acpu_ejtag_pins_loc_1 {
+			realtek,pins = "gpio_32",
+			"gpio_33",
+			"hif_data",
+			"hif_en",
+			"hif_clk",
+			"ejtag_acpu_loc";
+			realtek,function = "acpu_ejtag_loc1";
+		};
+
+		acpu_ejtag_pins_disable:acpu_ejtag_pins_disable{
+			realtek,pins = "ejtag_acpu_loc";
+			realtek,function = "acpu_ejtag_disable";
+		};
+
+		vcpu_ejtag_pins_loc_0: avpu_ejtag_pins_loc_0 {
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5",
+			"gpio_6",
+			"ejtag_vcpu_loc";
+			realtek,function = "vcpu_ejtag_loc0";
+		};
+
+		vcpu_ejtag_pins_loc_1: vcpu_ejtag_pins_loc_1 {
+			realtek,pins = "gpio_32",
+			"gpio_33",
+			"hif_data",
+			"hif_en",
+			"hif_clk",
+			"ejtag_vcpu_loc";
+			realtek,function = "vcpu_ejtag_loc1";
+		};
+
+		vcpu_ejtag_pins_disable:vcpu_ejtag_pins_disable{
+			realtek,pins = "ejtag_vcpu_loc";
+			realtek,function = "vcpu_ejtag_disable";
+		};
+
+		dc_fan_sensor_pins: dc_fan_sensor_pins {
+			realtek,pins = "gpio_47";
+			realtek,function = "dc_fan";
+		};
+
+		pwm0_0_pins: pwm0_0_pins {
+			realtek,pins = "gpio_12";
+			realtek,function = "pwm0";
+		};
+
+		pwm0_1_pins: pwm0_1_pins {
+			realtek,pins = "gpio_20";
+			realtek,function = "pwm0";
+		};
+
+		pwm1_0_pins: pwm1_0_pins {
+			realtek,pins = "gpio_13";
+			realtek,function = "pwm1";
+		};
+
+		pwm1_1_pins: pwm1_1_pins {
+			realtek,pins = "gpio_21";
+			realtek,function = "pwm1";
+		};
+
+		pwm2_0_pins: pwm2_0_pins {
+			realtek,pins = "gpio_14";
+			realtek,function = "pwm2";
+		};
+
+		pwm2_1_pins: pwm2_1_pins {
+			realtek,pins = "gpio_22";
+			realtek,function = "pwm2";
+		};
+
+		pwm3_0_pins: pwm3_0_pins {
+			realtek,pins = "gpio_15";
+			realtek,function = "pwm3";
+		};
+
+		pwm3_1_pins: pwm3_1_pins {
+			realtek,pins = "gpio_23";
+			realtek,function = "pwm3";
+		};
+
+		pwm0_0_pins_disable: pwm0_0_pins_disable {
+			realtek,pins = "gpio_12";
+			realtek,function = "gpio";
+		};
+
+		pwm0_1_pins_disable: pwm0_1_pins_disable {
+			realtek,pins = "gpio_20";
+			realtek,function = "gpio";
+		};
+
+		pwm1_0_pins_disable: pwm1_0_pins_disable {
+			realtek,pins = "gpio_13";
+			realtek,function = "gpio";
+		};
+
+		pwm1_1_pins_disable: pwm1_1_pins_disable {
+			realtek,pins = "gpio_21";
+			realtek,function = "gpio";
+		};
+
+		pwm2_0_pins_disable: pwm2_0_pins_disable {
+			realtek,pins = "gpio_14";
+			realtek,function = "gpio";
+		};
+
+		pwm2_1_pins_disable: pwm2_1_pins_disable {
+			realtek,pins = "gpio_22";
+			realtek,function = "gpio";
+		};
+
+		pwm3_0_pins_disable: pwm3_0_pins_disable {
+			realtek,pins = "gpio_15";
+			realtek,function = "gpio";
+		};
+
+		pwm3_1_pins_disable: pwm3_1_pins_disable {
+			realtek,pins = "gpio_23";
+			realtek,function = "gpio";
+		};
+
+		usb_cc1_pins: usb_cc1_pins {
+			realtek,pins = "usb_cc1";
+			realtek,function = "usb_cc1";
+		};
+
+		usb_cc2_pins: usb_cc2_pins {
+			realtek,pins = "usb_cc2";
+			realtek,function = "usb_cc2";
+		};
+
+		demod_pins: demod-pins {
+			realtek,pins = "gpio_21";
+			realtek,function = "qam_agc_if";
+		};
+
+		/*rtc_pins: rtc_pins {
+			realtek,pins = "gpio_25";
+			realtek,function = "rtc";
+		};*/
+
+		/*prob0_pins: prob0_pins{
+			realtek,pins = "prob_0";
+	        realtek,function = "gpio";
+		};
+
+		prob1_pins: prob1_pins{
+	        realtek,pins = "prob_1";
+	        realtek,function = "gpio";
+		};*/
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-psci.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-psci.dtsi
new file mode 100644
index 00000000..e1047fa
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-psci.dtsi
@@ -0,0 +1,18 @@
+#include "rtd-13xx.dtsi"
+
+&A55_0 {
+	enable-method = "psci";
+};
+&A55_1 {
+	enable-method = "psci";
+	/delete-property/ cpu-release-addr;
+};
+&A55_2 {
+	enable-method = "psci";
+	/delete-property/ cpu-release-addr;
+};
+&A55_3 {
+	enable-method = "psci";
+	/delete-property/ cpu-release-addr;
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-sata.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-sata.dtsi
new file mode 100644
index 00000000..3eecdc5
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-sata.dtsi
@@ -0,0 +1,85 @@
+#include <dt-bindings/reset/rtk,reset-rtd13xx.h>
+#include <dt-bindings/clock/rtk,clock-rtd13xx.h>
+/ {
+	sata_phy: sata_phy@9803FF60 {
+		compatible = "Realtek,rtk-sata-phy";
+		reg = <0x0 0x9803FF00 0x0 0x100>,
+			<0x0 0x9804f050 0x0 0x10>;
+		clocks = <&clk_en_4 CLK_EN_SATA_WRAP_SYS>,
+			<&clk_en_4 CLK_EN_SATA_WRAP_SYSH>;
+		resets = <&crst RSTN_SATA_WRAP>;
+
+		#address-cells = <1>;
+		#size-cells = <0>;
+		#phy-cells = <1>;
+
+		sata-phy@0 {
+			reg = <0>;
+			resets = <&crst RSTN_SATA_MDIO0>,
+				<&crst RSTN_SATA_PHY_POW0>;
+			spread-spectrum = <0>;
+			phy-param = <0x20100E11>, <0x20004E11>, <0x20008E11>,
+				<0x000E0611>, <0x000E4611>, <0x000E8611>,
+				<0x86600A11>, <0x86604A11>, <0x86608A11>,
+				<0x040E2611>, <0x040E6611>, <0x040EA611>,
+				<0xE0500111>, <0xE0484111>, <0xE0448111>,
+				<0xBB662311>, <0xBB666311>, <0xBB66A311>,
+				<0xEF540D11>, <0xEF544D11>, <0xEF548D11>,
+				<0x00132211>, <0x00136211>, <0x0013A211>,
+				<0xBB762311>, <0xBB766311>, <0xBB76A311>,
+				<0xFF041B11>, <0xFF045B11>, <0xFF049B11>,
+				<0x60460211>, <0x60464211>, <0x60468211>,
+				<0x520c0911>, <0x520c4911>, <0x520c8911>,
+				<0x500c0911>, <0x500c4911>, <0x500c8911>,
+				<0x520c0911>, <0x520c4911>, <0x520c8911>;
+			tx-driving-tbl = // user can define tx driving here //
+					<0x40a82011>, <0x40a86011>, <0x40a8a011>,
+					<0x988a2111>, <0x988a6111>, <0x988aa111>;
+		};
+		sata-phy@1 {
+			reg = <1>;
+			resets = <&crst RSTN_SATA_MDIO1>,
+				<&crst RSTN_SATA_PHY_POW1>;
+			spread-spectrum = <0>;
+			phy-param = <0x20100E11>, <0x20004E11>, <0x20008E11>,
+				<0x000E0611>, <0x000E4611>, <0x000E8611>,
+				<0x86600A11>, <0x86604A11>, <0x86608A11>,
+				<0x040E2611>, <0x040E6611>, <0x040EA611>,
+				<0xE0500111>, <0xE0484111>, <0xE0448111>,
+				<0xBB662311>, <0xBB666311>, <0xBB66A311>,
+				<0xEF540D11>, <0xEF544D11>, <0xEF548D11>,
+				<0x00132211>, <0x00136211>, <0x0013A211>,
+				<0xBB762311>, <0xBB766311>, <0xBB76A311>,
+				<0xFF041B11>, <0xFF045B11>, <0xFF049B11>,
+				<0x60460211>, <0x60464211>, <0x60468211>,
+				<0x520c0911>, <0x520c4911>, <0x520c8911>,
+				<0x500c0911>, <0x500c4911>, <0x500c8911>,
+				<0x520c0911>, <0x520c4911>, <0x520c8911>;
+			tx-driving-tbl = // user can define tx driving here //
+					<0x40a82011>, <0x40a86011>, <0x40a8a011>,
+					<0x988a2111>, <0x988a6111>, <0x988aa111>;
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		compatible = "Realtek,ahci-sata";
+		reg = <0x0 0x9803F000 0x0 0x1000>;
+		interrupts = <0 49 4>;
+		clocks = <&clk_en_4 CLK_EN_SATA_MAC_SYSH>;
+		resets = <&crst RSTN_SATA_MAC_COM>;
+
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		sata-port@0 {
+			reg = <0>;
+			phys = <&sata_phy 0>;
+			resets = <&crst RSTN_SATA_MAC_P0>;
+		};
+		sata-port@1 {
+			reg = <1>;
+			phys = <&sata_phy 1>;
+			resets = <&crst RSTN_SATA_MAC_P1>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-usb.dtsi
new file mode 100644
index 00000000..bba44de
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx-usb.dtsi
@@ -0,0 +1,372 @@
+/*
+ * rtd-13xx-usb.dtsi
+ */
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		reg = <0x0 0x98000000 0x0 0x10>;
+
+		//usb_iso_mode;  /* ISO mode is only port suspend (Default disable) */
+		//en_usb_storage_reprobe; /* To enable usb storage re-probe*/
+		//rescue_usb; /* For rescue dtb use */
+
+		clocks = <&iso_clk_en 16>, /* clk_en_usb */
+			<&iso_clk_en 13>,  /* clk_en_usb_drd (port0 phy to u2drd clock) */
+			<&iso_clk_en 14>,  /* clk_en_usb_host0 (port1 phy to u2host clock) */
+			<&iso_clk_en 15>;  /* clk_en_usb_host1 (port2 phy to u3drd clock) */
+		clock-names = "clk_en_usb", /*clk_en_usb*/
+			"clk_en_phy0_to_host", /*clk_en_usb_drd (port0 phy to u2drd clock) */
+			"clk_en_phy1_to_host", /*clk_en_usb_u2host (port1 phy to u2host clock */
+			"clk_en_phy2_to_host"; /*clk_en_usb_u3host (port2 phy to u3drd clock */
+
+		resets =
+			<&iso_asrst 0x100>,
+			<&iso_rst 14>, /* rstn_usb_u2drd */
+			<&iso_rst 15>, /* rstn_usb_u2host */
+			<&iso_asrst 16>, /* rstn_usb_phy0 */
+			<&iso_asrst 17>, /* rstn_usb_phy1 */
+			<&iso_asrst 18>, /* rstn_usb_phy2 */
+			<&iso_rst 19>, /* rstn_usb */
+			<&iso_rst 20>, /* rstn_type c */
+			<&iso_rst 21>, /* rstn_usb_u3drd */
+			<&iso_rst 22>, /* rstn_usb3_phy0 */
+			<&iso_rst 23>, /* rstn_usb3_phy0_mdio */
+			<&iso_rst 24>, /* rstn_usb3_phy1 */
+			<&iso_rst 25>; /* rstn_usb3_phy1_mdio */
+
+		reset-names = "apply",
+			"usb_host0", /*rstn_usb_u2drd*/
+			"usb_host1", /*rstn_usb_u2host*/
+			"u2phy0", /*rstn_usb_phy0*/
+			"u2phy1", /*rstn_usb_phy1*/
+			"u2phy2", /*rstn_usb_phy2*/
+			"usb", /*rstn_usb*/
+			"type_c", /*rstn_type_c*/
+			"usb_host2", /*rstn_usb_u3drd*/
+			"u3phy0", /*rstn_usb3_phy0*/
+			"u3mdio0", /*rstn_usb3_phy0_mdio*/
+			"u3phy1", /*rstn_usb3_phy1*/
+			"u3mdio1"; /*rstn_usb3_phy1_mdio*/
+
+		status = "disabled";
+
+		gpio0: gpio0 {
+			realtek,power-gpio = <&rtk_iso_gpio 48 1 3>;
+			power_low_active;
+
+		};
+		gpio1: gpio1 {
+			realtek,power-gpio = <&rtk_iso_gpio 49 1 3>;
+			power_low_active;
+
+		};
+
+		port0 {
+			usb = <&dwc3_u2drd>;
+			//type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+			gpio = <&gpio0>;
+		};
+		port1 {
+			usb = <&dwc3_u2host>;
+			gpio = <&gpio0>;
+		};
+		port2 {
+			usb = <&dwc3_u3drd>;
+			//type_c = <&dwc3_type_c>; /* for port 2 type c driver */
+			gpio = <&gpio1>;
+		};
+
+		rtk_usb {
+			//pcie_usb3phy_sel = <0x9800705c>; /* Only for RTD1319 */
+
+			power_ctrl_reg {
+				/* l4_icg */
+				p0_l4_icg = <0x98013364>;
+				p1_l4_icg = <0x98013d60>;
+				p2_l4_icg = <0x98013f60>;
+
+				usb_power_cut; /* Non ISO mode and power cut (Default disable power cut) */
+				               /* Note if enable ISO mode, then power_cut will not effective*/
+			};
+			type_c {
+				/* For 1315, 1317, u2drd */
+				//realtek,connector_switch-gpio = <&rtk_iso_gpio 25 1 3>;
+				/* For 1319, u3drd */
+				//realtek,plug_side_switch-gpio = <&rtk_iso_gpio 53 1 3>;
+			};
+		};
+	};
+
+	dwc3_u2drd_usb2phy: dwc3_u2drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98028280 0x0 0x4>, <0x0 0x98013214 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "disabled";
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u2drd: rtk_dwc3_u2drd@98013200 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013200 0x0 0x200>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "disabled";
+
+		dwc3_u2drd@98020000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98020000 0x0 0x9000>;
+			interrupts = <0 95 4>;
+			usb-phy = <&dwc3_u2drd_usb2phy>;
+			dr_mode = "host"; /*otg, host, peripheral*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+
+			status = "disabled";
+		};
+
+		/* u2drd type_c Only For 1317, 1315 */
+		rtk_dwc3_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			reg = <0x0 0x98013200 0x0 0x200>,  <0x0 0x98007220 0x0 0x20>;
+			interrupts = <0 60 4>;
+			drd_mode;  /*depend on dwc3 dr_mode = "peripheral"*/
+			//debug; /*to enable debug log*/
+			delay_probe_work; /*To delay probe work*/
+			ordered_probe; /*ordered probe in delay work*/
+			boot_check_time = <(-1)>; /*ms (At boot Device switch Host time)*/
+			pinctrl-names = "default";
+			pinctrl-0 = <&usb_cc1_pins>, <&usb_cc2_pins>;
+
+			status = "disabled";
+
+			default_revision = <0xA00>;
+			A00 {
+				cc_dfp_mode = "dfp_3_0"; /*dfp_3_0, dfp_1_5, dfp_usb*/
+				rd_config = "internal"; /*internal, extrenal*/
+				cc1_rp_4p7k_code = <0xC>;
+				cc1_rp_36k_code = <0xF>;
+				cc1_rp_12k_code = <0xE>;
+				cc1_rd_code = <0x11>; /*for internal rd*/
+				cc1_vref_ufp = /bits/ 8
+					<0x7 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc1_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc1_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc1_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+				cc2_rp_4p7k_code = <0xC>;
+				cc2_rp_36k_code = <0xF>;
+				cc2_rp_12k_code = <0xE>;
+				cc2_rd_code = <0xF>; /*for internal rd*/
+				cc2_vref_ufp = /bits/ 8
+					<0x8 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc2_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc2_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc2_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+			};
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98031280 0x0 0x4>, <0x0 0x98013C14 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "disabled";
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013C00 0x0 0x200>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "disabled";
+
+		dwc3_u2host@98029000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98029000 0x0 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_u2host_usb2phy>;
+			dr_mode = "host"; /*only host*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+		};
+	};
+
+	dwc3_u3drd_usb3phy: dwc3_u3drd_usb3phy@0 {
+		compatible = "Realtek,usb3phy";
+		reg = <0x0 0x98013E10 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "disabled";
+		phyN = <1>;
+		phy0 {
+			phy_data_size = <0x30>;
+			phy_data_addr = /bits/ 8
+				<0x00 0x01 0x02 0x03 0x04 0x05 0x06
+				0x07 0x08 0x09 0x0A 0x0B 0x0C 0x0D
+				0x0E 0x0F 0x10 0x11 0x12 0x13 0x14
+				0x15 0x16 0x17 0x18 0x19 0x1A 0x1B
+				0x1C 0x1D 0x1E 0x1F 0x20 0x21 0x22
+				0x23 0x24 0x25 0x26 0x27 0x28 0x29
+				0x2A 0x2B 0x2C 0x2D 0x2E 0x2F>;
+			phy_data_revA = /bits/ 16
+				<0x400C 0xAD08 0x6042 0x2771 0x72F5 0x2AD3 0x0003
+				 0x2E00 0x3591 0x565C 0xB608 0xA905 0xC000 0xEF1E
+				 0x2000 0x8D50 0x000C 0x4C10 0xFC00 0x0C81 0xDE01
+				 0x0000 0x0000 0x0000 0x0000 0x6000 0x0085 0x2014
+				 0xC900 0xA03F 0xC2E0 0x7E00 0x70AA 0x88AA 0x0053
+				 0xAB66 0x4770 0x126C 0x840A 0x01D6 0xF802 0xff00
+				 0x3040 0x8028 0xFFFF 0xFFFF 0x0000 0x8600>;
+			do_toggle;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u3drd_usb2phy: dwc3_u3drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98058280 0x0 0x4>, <0x0 0x98013E14 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "disabled";
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x6B 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u3drd: rtk_dwc3_u3drd@98013E00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013E00 0x0 0x200>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+
+		status = "disabled";
+
+		dwc3_u3drd@981F0000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98050000 0x0 0x9000>;
+			interrupts = <0 94 4>;
+			usb-phy = <&dwc3_u3drd_usb2phy &dwc3_u3drd_usb3phy>;
+			dr_mode = "peripheral"; /*only host*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+
+			status = "disabled";
+		};
+
+		/* u3drd type_c Only For 1319 */
+		rtk_dwc3_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			reg = <0x0 0x98013e00 0x0 0x200>,  <0x0 0x98007220 0x0 0x20>;
+			interrupts = <0 60 4>;
+			drd_mode;  /*depend on dwc3 dr_mode = "peripheral"*/
+			//debug; /*to enable debug log*/
+			delay_probe_work; /*To delay probe work*/
+			ordered_probe; /*ordered probe in delay work*/
+			boot_check_time = <(-1)>; /*ms (At boot Device switch Host time)*/
+			pinctrl-names = "default";
+			pinctrl-0 = <&usb_cc1_pins>, <&usb_cc2_pins>;
+
+			status = "disabled";
+
+			default_revision = <0xA00>;
+			A00 {
+				cc_dfp_mode = "dfp_3_0"; /*dfp_3_0, dfp_1_5, dfp_usb*/
+				rd_config = "internal"; /*internal, extrenal*/
+				cc1_rp_4p7k_code = <0xC>;
+				cc1_rp_36k_code = <0xF>;
+				cc1_rp_12k_code = <0xE>;
+				cc1_rd_code = <0x11>; /*for internal rd*/
+				cc1_vref_ufp = /bits/ 8
+					<0x7 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc1_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc1_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc1_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+				cc2_rp_4p7k_code = <0xC>;
+				cc2_rp_36k_code = <0xF>;
+				cc2_rp_12k_code = <0xE>;
+				cc2_rd_code = <0xF>; /*for internal rd*/
+				cc2_vref_ufp = /bits/ 8
+					<0x8 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc2_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc2_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc2_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+			};
+		};
+	};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx.dtsi b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx.dtsi
new file mode 100755
index 00000000..2f42253
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd13xx/rtd-13xx.dtsi
@@ -0,0 +1,1060 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include <dt-bindings/clock/rtk,clock-rtd13xx.h>
+#include <dt-bindings/reset/rtk,reset-rtd13xx.h>
+#include <dt-bindings/power/rtk,power-rtd13xx.h>
+/include/ "rtd-13xx-pinctrl.dtsi"
+
+/{
+	compatible = "realtek,rtd1319";
+	interrupt-parent = <&gic>;
+	#address-cells = <0x2>;
+	#size-cells = <0x2>;
+
+	aliases {
+		serial0 = &uart0;
+		i2c0 = &i2c_0;
+		i2c1 = &i2c_1;
+		i2c3 = &i2c_3;
+		i2c5 = &i2c_5;
+	};
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A55_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x000>;
+			enable-method = "rtk-spin-table";
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x100>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x200>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x300>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		a55_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	rtk_pm@0 {
+		compatible = "realtek,pm";
+		system-power-controller;
+		reg = <0x0 0x98000000 0x0 0x1800>, /* CRT */
+			<0x0 0x98007000 0x0 0x1000>, /* ISO */
+			<0x0 0x9801A000 0x0 0x1000>; /* SB2 */
+		wakeup-flags = <0x3F>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+		status = "okay";
+	};
+
+	soc@0 {
+		reg = <0x0 0x98000000 0x0 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+	};
+
+	sb2_lock0: sb2-lock@9801A000 {
+		compatible = "realtek,sb2-sem";
+		reg = <0x0 0x9801A000 0x0 0x4>;
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x0 0x9801a000 0x0 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	crt_mmio: mmio@98000000 {
+		compatible = "realtek,mmio";
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	iso_mmio: mmio@98007088 {
+		compatible = "realtek,mmio";
+		reg = <0x0 0x98007088 0x0 0x8>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	efuse@98017000 {
+		compatible = "realtek,efuse";
+		reg = <0x0 0x98017000 0x0 0x1000>;
+		read-only;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		nvmem-cells =
+			<&otp_bond_id>,
+			<&otp_cpu_iddq>,
+			<&otp_top_iddq>,
+			<&otp_etn_para>,
+			<&otp_etn_idca>,
+			<&otp_usb_cc1_comp_cal>,
+			<&otp_usb_cc2_comp_cal>,
+			<&otp_usb_cc1_4_7k_cal>,
+			<&otp_usb_cc1_12k_cal>,
+			<&otp_usb_cc2_4_7k_cal>,
+			<&otp_usb_cc2_12k_cal>,
+			<&otp_usb_cc1_1k_cal>,
+			<&otp_usb_cc2_1k_cal>,
+			<&otp_usb_cc_en>,
+			<&otp_package_id>,
+			<&otp_chip_id>;
+
+		nvmem-cell-names =
+			"bond_id",
+			"cpu_iddq",
+			"top_iddq",
+			"etn_para",
+			"etn_idca",
+			"usb_cc1_comp_cal",
+			"usb_cc2_comp_cal",
+			"usb_cc1_4.7k_cal",
+			"usb_cc1_12k_cal",
+			"usb_cc2_4.7k_cal",
+			"usb_cc2_12k_cal",
+			"otp_usb_cc1_1k_cal",
+			"otp_usb_cc2_1k_cal",
+			"usb_cc_en",
+			"package_id",
+			"chip_id";
+
+		otp_bond_id: bond-id@4f4 {
+			reg = <0x4f4 0x4>;
+			bits = <0 32>;
+		};
+		otp_cpu_iddq: cpu-iddq@4f8 {
+			reg = <0x4f8 0x1>;
+			bits = <0 8>;
+		};
+		otp_top_iddq: top-iddq@4f9 {
+			reg = <0x4f9 0x1>;
+			bits = <0 8>;
+		};
+		otp_etn_para: etn-para@4fc {
+			reg = <0x4fc 0x1>;
+			bits = <0 4>;
+		};
+		otp_etn_idca: etn-idca@500 {
+			reg = <0x500 0x1>;
+			bits = <0 8>;
+		};
+		otp_usb_cc1_comp_cal: usb_cc1_comp_cal@528 {
+			reg = <0x528 0x3>;
+			bits = <0 24>;
+		};
+		otp_usb_cc2_comp_cal: usb_cc2_comp_cal@52b {
+			reg = <0x52b 0x3>;
+			bits = <0 24>;
+		};
+		otp_usb_cc1_4_7k_cal: usb_cc1_4_7k_cal@52e {
+			reg = <0x52e 0x1>;
+			bits = <0 4>;
+		};
+		otp_usb_cc1_12k_cal: usb_cc1_12k_cal@52e {
+			reg = <0x52e 0x1>;
+			bits = <4 4>;
+		};
+		otp_usb_cc2_4_7k_cal: usb_cc2_4_7k_cal@52f {
+			reg = <0x52f 0x1>;
+			bits = <0 4>;
+		};
+		otp_usb_cc2_12k_cal: usb_cc2_12k_cal@52f {
+			reg = <0x52f 0x1>;
+			bits = <4 4>;
+		};
+		otp_usb_cc1_1k_cal: usb_cc1_1k_cal@530 {
+			reg = <0x530 0x1>;
+			bits = <0 4>;
+		};
+		otp_usb_cc2_1k_cal: usb_cc2_1k_cal@530 {
+			reg = <0x530 0x1>;
+			bits = <4 4>;
+		};
+		otp_usb_cc_en: usb_cc_en@50b {
+			reg = <0x531 0x1>;
+			bits = <4 1>;
+		};
+		otp_package_id: package_id@48d {
+			reg = <0x48d 0x1>;
+			bits = <5 2>;
+		};
+		otp_chip_id: chip_id@3cc {
+			reg = <0x3cc 0x10>;
+			bits = <0 128>;
+		};
+	};
+
+	osc27M: osc27M {
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <27000000>;
+		clock-output-names = "osc27M";
+	};
+
+	cc: clocks@98000000 {
+		compatible = "realtek,clock-controller";
+		#clock-cells = <1>;
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		clocks = <&osc27M>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	clk_en_1: clk-en@98000050 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000050 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "unused", "pcie0", "unused", "gspi",
+				     "unused", "unused", "sds", "hdmi",
+				     "unused", "unused", "unused", "unused",
+				     "unused", "unused", "lsadc", "se";
+		ignore-unused-clocks = "hdmi";
+		ignore-pm-clocks = "hdmi";
+	};
+
+	clk_en_2: clk-en@98000054 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000054 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "unused", "cp", "md", "tp",
+				     "rsa", "nf", "emmc", "sd",
+				     "sdio_ip", "mipi", "emmc_ip", "sdio",
+				     "sd_ip", "cablerx", "tpb", "sc1";
+		ignore-unused-clocks = "cp", "md", "tp";
+	};
+
+	clk_en_3: clk-en@98000058 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000058 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "i2c_3", "unused", "jpeg", "unused",
+				     "unused", "sc0", "unused", "unused",
+				     "unused", "unused", "unused", "unused",
+				     "unused", "hdmirx", "hse", "ur2";
+	};
+
+	clk_en_4: clk-en@9800005c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800005c 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "ur1", "fan", "unused", "unused",
+				     "sata_wrap_sys", "sata_wrap_sysh",
+				     "sata_mac_sysh", "r2rdsc",
+				     "unused", "pcie1", "i2c_4", "i2c_5",
+				     "unused", "unused", "edp", "unused";
+	};
+
+	clk_en_7: clk-en@9800008c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800008c 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "pcie2", "unused", "earc";
+	};
+
+	iso_clk_en: clk-en@9800708c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800708c 0x0 0x4>;
+		#clock-cells = <1>;
+		clock-output-names = "lsadc_ecoa2", "unused", "cec0", "cbusrx_sys",
+				     "cbustx_sys", "cbus_sys", "cbus_osc", "ir",
+				     "ur0", "i2c0", "i2c1", "etn_250m",
+				     "etn_sys", "usb_drd", "usb_host",
+				     "usb_u3_host", "usb";
+	};
+
+	iso_clk_en_2: clk-en@98007064 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98007064 0x0 0x4>;
+		#clock-cells = <1>;
+		clock-output-names = "unused", "unused", "unused", "unused",
+				     "unused", "unused", "unused", "unused",
+				     "unused", "iso_gspi";
+	};
+
+	crst: soft-reset@98000000 {
+		compatible = "realtek,rtd13xx-reset-controller";
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		#reset-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	iso_rst: soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98007088 0x0 0x4>;
+		#reset-cells = <1>;
+		realtek,mmio = <&iso_mmio 0x0>;
+	};
+
+	iso_asrst: usb-async-soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98007088 0x0 0x4>;
+		#reset-cells = <1>;
+		async-group = <0>;
+		realtek,mmio = <&iso_mmio 0x0>;
+	};
+
+	pd: power-domain@98007000 {
+		compatible = "realtek,rtd13xx-power-controller";
+		reg = <0x0 0x98007000 0x0 0x1000>;
+		#power-domain-cells = <1>;
+		#powerctrl-cells = <1>;
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x0 0x98000000 0x0 0x200000>;
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x0 0x9801b000 0x0 0x1000>;
+		status = "okay";
+	};
+
+	gic: interrupt-controller@FF100000 {
+		compatible = "arm,gic-v3";
+		#interrupt-cells = <3>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		interrupt-controller;
+		redistributor-stride = <0x0 0x20000>;
+		#redistributor-regions = <1>;
+		reg = <0x0 0xFF100000 0x0 0x10000>, /*  GICD */
+			<0x0 0xFF140000 0x0 0x200000>; /*  GICR */
+		interrupts = <GIC_PPI 9 4>;
+	};
+
+	timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <GIC_PPI 13 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 14 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 11 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 10 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>;
+		clock-frequency = <27000000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <GIC_PPI 7 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>;
+	};
+
+	pinctrl: pinctrl@9804E000 {
+		compatible = "realtek,rtk13xx-pinctrl";
+		reg = <0x0 0x9804E000 0x0 0x130>;
+		#gpio-range-cells = <3>;
+		status = "okay";
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP MISC_ISO */
+			  <0x0 0x98007000 0x0 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	/*
+	 * Suspend GPIO control
+	 *
+	 * [wakeup-gpio-list]
+	 * rtk_iso_gpio 10: BT wakeup host pin
+	 * rtk_iso_gpio 26: WiFi wakeup host pin
+	 *
+	 * [wakeup-gpio-enable]
+	 * Wakeup from BT: <0> disable
+	 * Wakeup from WiFi: <0> disable
+	 *
+	 * [wakeup-gpio-activity]
+	 * BT pin: <0> active low
+	 * WIFI pin: <0> active low
+	 */
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk13xx-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <82>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <51 4>, <52 4>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x0 0x98007000 0x0 0x100>,
+			<0x0 0x98007100 0x0 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 82>;
+		wakeup-gpio-list = <&rtk_iso_gpio 10 0 1>,<&rtk_iso_gpio 26 0 1>;
+		wakeup-gpio-enable = <1>, <1>;
+		wakeup-gpio-activity = <0>, <0>;
+		status = "okay";
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x98007800 0x0 0x400>,
+			  <0x0 0x98007000 0x0 0x100>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		interrupts = <0 68 4>;
+		clock-frequency = <27000000>; /* This value must be override by the board. */
+		clocks = <&iso_clk_en CLK_EN_MISC_UR0>;
+		resets = <&iso_rst RSTN_UR0>;
+		status = "okay";
+	};
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x9801B200 0x0 0x100>,
+			<0x0 0x9801B00c 0x0 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 89 4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart1_pins>;
+		clocks = <&clk_en_4 CLK_EN_UR1>;
+		resets = <&crst RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "okay";
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x9801B400 0x0 0x100>,
+			<0x0 0x9801B00c 0x0 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts =  <0 90 4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart2_pins_0>;
+		clocks = <&clk_en_3 CLK_EN_UR2>;
+		resets = <&crst RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "disabled"; /* Disable UR2 first since we don't use it now */
+	};
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x0 0x98016000 0x0 0x1000>,   /* ETN */
+			<0x0 0x98007000 0x0 0x1000>, /* ISO */
+			<0x0 0x9801c000 0x0 0x2000>, /* SBX and SC_WRAP for ACP ctrl */
+			<0x0 0x980174fc 0x0 0x10>,    /* EFUSE_OTP_REG */
+			<0x0 0x9804e000 0x0 0x1000>; /* ISO pinmux */
+		interrupts = <0 22 4>;
+		pinctrl-names = "default",
+				"rgmii";
+		pinctrl-0 = <&etn_led_pins>;
+		pinctrl-1 = <&rgmii_mdio_pins>,
+			<&rgmii_txrx_pins>;
+		local-mac-address = [00 10 20 30 40 50];
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		wake-mask0 = [3f 30 80 c0 3f 10 80 ff ff 1f 00 00 00 00 00 00];
+		wake-crc0 = <0x8d25>;
+		wake-mask1 = [3f 30 80 c0 3f 10 00 00 c0 ff ff 0f 00 00 00 00];
+		wake-crc1 = <0x8d25>;
+		wake-mask2 = [3f 30 80 c0 3f 10 00 00 00 00 00 00 80 ff ff 1f];
+		wake-crc2 = <0x8d25>;
+		wake-mask3 = [3f 30 10 00 c0 ff ff 03 01 f8 ff ff 01 00 00 00];
+		wake-crc3 = <0x11da>;
+		wake-mask4 = [3f 30 10 00 c0 ff ff 03 01 00 00 fc ff ff 00 00];
+		wake-crc4 = <0x11da>;
+		wake-mask5 = [3f 30 10 00 c0 ff ff 03 01 00 00 00 00 00 00 f8];
+		wake-crc5 = <0x15f8>;
+		output-mode = <0>; /* 0:embedded PHY, 1:RGMII to MAC, 2:RGMII to PHY, 3:RMII */
+		voltage = <1>; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+		tx-delay = <0>; /* 0: 0ns, 1: 2ns */
+		rx-delay = <0>; /* 0 ~ 7   x 0.5ns */
+		ext-phy-id = <1>; /* 0 ~ 31, only valid when output-mode = 2 or 4 */
+		bypass = <1>; /* 0: disable, 1: enable */
+		acp = <0>; /* 0: disable, 1: enable */
+		eee = <0>; /* 0: disable, 1: enable */
+		clocks = <&iso_clk_en CLK_EN_ETN_250M>,
+			<&iso_clk_en CLK_EN_ETN_SYS>;
+		clock-names = "etn_250m",
+			"etn_sys";
+		resets = <&iso_rst RSTN_GMAC>,
+			<&iso_rst RSTN_GPHY>;
+		reset-names = "gmac",
+			"gphy";
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x0 0x9801d000 0x0 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	watchdog@0x98007680 {
+		compatible = "realtek,rtk-watchdog";
+		reg = <0x0 0x9801b5b0 0x0 0x20>, /*misc watchdog for SCPU NMI */
+			<0x0 0x9801b000 0x0 0x10>,
+			<0x0 0x98007680 0x0 0x100>; /*iso watchdog for oe workaround */
+		interrupts = <0 0 4>;
+		rst-oe = <0>; /* 0:input, 1:output */
+		rst-oe-for-init = <1>; /* 0:input, 1:output */
+		timeout-sec = <10>;
+		status = "okay";
+	};
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x0 0x98007640 0x0 0x10>;
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x98007D00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <40 4>;
+		i2c-num = <0>;
+		status = "okay";
+		pinctrl-names = "default", "high_speed";
+		pinctrl-0 = <&i2c_pins_0>;
+		pinctrl-1 = <&i2c_pins_0_HS>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iso_clk_en CLK_EN_I2C0>;
+		resets = <&iso_rst RSTN_I2C_0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x98007C00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <43 4>;
+		i2c-num = <1>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_1>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iso_clk_en CLK_EN_I2C1>;
+		resets = <&iso_rst RSTN_I2C_1>;
+	};
+
+	i2c_3: i2c@0x9801B900 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x9801B900 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <23 4>;
+		i2c-num = <3>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_3>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_3 CLK_EN_MISC_I2C_3>;
+		resets = <&crst RSTN_I2C_3>;
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x9801BB00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <14 4>;
+		i2c-num = <5>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_5>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_4 CLK_EN_MISC_I2C_5>;
+		resets = <&crst RSTN_I2C_5>;
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk-dw-apb-ssi";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <27 4>; /* SPI_INT */
+		reg = <0x0 0x9801BD00 0x0 0x100>, /* DW SPI */
+			<0x0 0x9801B300 0x0 0x18>; /* SPI wrapper */
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins_0>;
+		/*spi-cs-gpio = <&rtk_iso_gpio 6 1 1>;*/
+		num-chipselect = <1>;
+		bus-num = <0>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		clock-frequency = <256000000>;
+		resets = <&crst RSTN_GSPI>;
+		status = "disabled";
+	};
+
+	spi_1: spi@98007500 {
+		compatible = "Realtek,rtk-dw-apb-ssi";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <38 4>; /* SPI1_INT */
+		reg = <0x0 0x98007500 0x0 0x100>, /* DW SPI */
+			<0x0 0x980072E4 0x0 0x1C>; /* SPI wrapper */
+		pinctrl-names = "default";
+		pinctrl-0 = <&iso_gspi_pins_0>;
+		num-chipselect = <1>;
+		bus-num = <0>;
+		clocks = <&iso_clk_en_2 CLK_EN_ISO_GSPI>;
+		clock-frequency = <256000000>;
+		resets = <&iso_rst RSTN_ISO_GSPI>;
+		status = "disabled";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x0 0x980070D0 0x0 0xC>;
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm0_0_pins>;
+			pinctrl-1 = <&pwm0_0_pins_disable>;
+			pinctrl-2 = <&pwm0_1_pins>;
+			pinctrl-3 = <&pwm0_1_pins_disable>;
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm1_0_pins>;
+			pinctrl-1 = <&pwm1_0_pins_disable>;
+			pinctrl-2 = <&pwm1_1_pins>;
+			pinctrl-3 = <&pwm1_1_pins_disable>;
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm2_0_pins>;
+			pinctrl-1 = <&pwm2_0_pins_disable>;
+			pinctrl-2 = <&pwm2_1_pins>;
+			pinctrl-3 = <&pwm2_1_pins_disable>;
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm3_0_pins>;
+			pinctrl-1 = <&pwm3_0_pins_disable>;
+			pinctrl-2 = <&pwm3_1_pins>;
+			pinctrl-3 = <&pwm3_1_pins_disable>;
+		};
+	};
+
+	rtk-lsadc@98007900 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <35 4>; /* LSADC0_INT */
+		reg = <0x0 0x98007000 0x0 0x4>, /* ISO_ISR */
+			<0x0 0x98007900 0x0 0x200>, /* LSADC */
+			<0x0 0x9800034C 0x0 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>; /* LSADC0 0:disable; 1:enable */
+		vdd_mux_sel = <0>; /* 0:VDD1; 1:VDD2 */
+		vdd_mux1 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux2 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux_en = <1>; /* 0:disable; 1:enable */
+		clocks = <&iso_clk_en CLK_EN_LSADC_ECOA2>;
+		resets = <&iso_rst RSTN_LSADC_ECOA2>;
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <1>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd161x-hdmitx";
+		reg = <0x0 0x9800d000 0x0 0x560>, /* HDMITX */
+			<0x0 0x98007200 0x0 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 7 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&crst RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		status = "okay";
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <63 4>;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtd161x-hdcptx";
+		reg = <0x0 0x9800d000 0x0 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		status = "okay";
+	};
+
+	sd: sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_iso_gpio 30 1 0>, /*sd power , output, default high  (poweroff) */
+			<&rtk_iso_gpio 34 0 1>,
+			<&rtk_iso_gpio 35 0 1>;
+		reg =   <0x0 0x98000000 0x0 0x400>, /* CRT */
+			<0x0 0x98010400 0x0 0x200>, /* SDMMC */
+			<0x0 0x9801A000 0x0 0x400>, /* BS2 */
+			<0x0 0x9804E000 0x0 0x60>, /* ISO */
+			<0x0 0x98010A00 0x0 0x40>, /* SDIO */
+			<0x0 0x98007000 0x0 0x200>;
+		interrupts = <0 44 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>, <&scpu_ejtag_pins_disable>; /*<&sdcard_pins_high>;*/
+		clocks = <&clk_en_2 CLK_EN_SD>, <&clk_en_2 CLK_EN_SD_IP>;
+		clock-names = "sd", "sd_ip";
+		resets = <&crst RSTN_SD>;
+		status = "okay";
+	};
+
+	sdio: sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 27 1 1>;
+		reg = <0x0 0x98010c00 0x0 0x200>,
+			<0x0 0x98000000 0x0 0x200000>;
+		interrupts = <0 45 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdio_pins_1>;
+		clocks = <&clk_en_2 CLK_EN_SDIO>,
+			<&clk_en_2 CLK_EN_SDIO_IP>;
+		clock-names = "sdio", "sdio_ip";
+		resets = <&crst RSTN_SDIO>;
+		status = "okay";
+	};
+
+	emmc: emmc@98012000 {
+                compatible = "Realtek,rtk13xx-emmc";
+		gpios = <&rtk_iso_gpio 20 1 0>;
+                reg =   <0x0 0x98012000 0x0 0xa00>, /*EMMC*/
+                        <0x0 0x98000000 0x0 0x600>, /*CRT */
+                        <0x0 0x9801A000 0x0 0x80>, /*SB2*/
+                        <0x0 0x9804E000 0x0 0x100>, /* ISO */
+                        <0x0 0x98007E00 0x0 0x20>,
+                        <0x0 0x9804F000 0x0 0x100>;  /*m2tmx*/
+                interrupts = <0 42 4>;
+                speed-step = <0>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_2 CLK_EN_EMMC>, <&clk_en_2 CLK_EN_EMMC_IP>;
+		clock-names = "emmc", "emmc_ip";
+		resets = <&crst RSTN_EMMC>;
+		reset-names = "emmc";
+                status = "okay";
+                pddrive_nf_s0 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+                pddrive_nf_s1 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for ddr50 */
+                pddrive_nf_s2 = <1 0x4 0x4 0x4 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+                pddrive_nf_s3 = <1 0x7 0x2 0x3 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs400 */
+                phase_tuning = <1 1>; /* arg0: tx tuning switch, arg1: rx tuning switch, if we want to set user defined tx or rx, we should set 0 for tx or rx*/
+		reference_phase = <0 0x0 0 0x0>; /* arg0: switch user defined tx, arg1: tx reference phase value, arg2: switch user defined rx, arg3: rx reference phase value*/
+                dqs_tuning = <1>;
+		dqs_dly_tape = <0x0>;
+        };
+
+	nand@98010000 {
+		compatible = "Realtek,rtk1295-nand";
+		reg = <0x0 0x98010000 0x0 0x400>, /* NWC */
+			<0x0 0x9801F000 0x0 0x400>; /* SWC */
+		clocks = <&clk_en_2 CLK_EN_NF>;
+		resets = <&crst RSTN_NF>;
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		compatible = "Realtek,rfkill";
+		gpios = <&rtk_iso_gpio 11 1 0>; /*bt power , output, default low */
+		status = "okay";
+	};
+
+	rng@98001000 {
+		compatible = "Realtek,rtk-rng";
+		reg = <0x0 0x98001000 0x0 0x70>;
+		status = "okay";
+	};
+
+	smartcard@9801BE00 {
+		compatible = "Realtek,rtk-smc";
+		interrupts = <0 63 4>; /* SC0_INT*/
+		reg = <0x0 0x9801B000 0x0 0x100>, /* MISC interrupt */
+			<0x0 0x9801BE00 0x0 0x80>; /* SmartCard */
+		smc-num = <0>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&smartcard_pins_0>;
+		clock-names = "clk_en_misc_sc";
+		clocks = <&clk_en_3 CLK_EN_MISC_SC0>;
+		resets = <&crst RSTN_MISC_SC0>;
+		status = "okay";
+		lsic_control{
+			pin_cmd_vcc = <&rtk_iso_gpio 63 1 0>; /* pin cmd_vcc , default low */
+			pin_pwr_sel = <&rtk_iso_gpio 64 1 0>; /* pin pwr_sel , default 0 */
+			cmd_vcc_en = <1>;
+			cmd_vcc_polarity = <0>; /* low active */
+			pwr_sel_en = <1>;
+			pwr_sel_polarity = <1>; /* high actve 1: 5v */
+		};
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x0 0x98007000 0x0 0x400>,
+			<0x0 0x98007400 0x0 0x100>;
+		interrupts = <37 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&ir_rx_pins>;
+		resets = <&iso_rst RSTN_IR>;
+		clocks = <&iso_clk_en CLK_EN_MISC_IR>;
+		status = "okay";
+	};
+
+	rtc@9801B600 {
+		compatible = "realtek,rtk-rtc";
+		reg = <0x0 0x9801B600 0x0 0x34>,
+			<0x0 0x98007000 0x0 0x100>;
+		rtc-base-year = <2018>;
+		status = "okay";
+	};
+
+	rpc@9801aa80 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x0 0x9801aa80 0x0 0xc>; /* rpc intr en */
+		interrupts = <0 33 4>,
+			<0 92 4>;
+		status = "okay";
+	};
+
+	dvfs: cpu-dvfs {
+	};
+
+	gpu: gpu@981D0000 {
+		compatible = "arm,mali-midgard";
+		reg = <0x0 0x981D0000 0x0 0x10000>,
+		      <0x0 0x98007000 0x0 0x01000>;
+		interrupts = <GIC_SPI 76 4>, <GIC_SPI 77 4>, <GIC_SPI 75 4>;
+		interrupt-names = "JOB", "MMU", "GPU";
+		clocks = <&cc CC_CLK_GPU>;
+		clock-name = "clk_mali";
+		resets = <&crst RSTN_GPU>, <&crst RSTN_GPU_BIST>;
+		reset-names = "core", "bist";
+		power-domains = <&pd PD_SRAM_GPU>;
+		status = "okay";
+	};
+
+	cpu_tm: thermal-sensor@9801d000 {
+		compatible = "realtek,rtd13xx-thermal-sensor";
+		reg = <0x0 0x9801d000 0x0 0x1000>;
+		#thermal-sensor-cells = <0>;
+		status = "okay";
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+			trips {
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <0>;
+					type = "critical";
+				};
+			};
+			cooling-maps {};
+		};
+	};
+
+	hse@98005000 {
+		reg = <0x0 0x98005000 0x0 0x1000>;
+		compatible = "realtek,highspeed-streaming-engine";
+		interrupts = <GIC_SPI 27 4>;
+		clocks = <&clk_en_3 CLK_EN_HSE>;
+		resets = <&crst RSTN_HSE>;
+		status = "okay";
+
+		engine-0-enabled;
+		engine-1-disabled;
+	};
+
+	mcp@98015000 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x0 0x98015000 0x0 0x1000>,
+			<0x0 0x98014000 0x0 0x1000>;
+		status = "okay";
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk16xx-pu_pll";
+		reg = <0x0 0x98000000 0x0 0x200>;
+	};
+
+	jpeg: jpeg@9803e000 {
+		compatible = "Realtek,rtk16xx-jpeg";
+		reg = <0x0 0x9803e000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x200>,
+			<0x0 0x98007000 0x0 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_3 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&crst RSTN_JPEG>;
+		status = "okay";
+	};
+
+	ve1: ve1@98040000 {
+		compatible = "Realtek,rtk13xx-ve1";
+		reg = <0x0 0x98040000 0x0 0xc000>,
+			<0x0 0x98008000 0x0 0x1000>,
+			<0x0 0x98007000 0x0 0x30>,
+			<0x0 0x9800E000 0x0 0x1000>;
+		interrupts = <0 53 4>, <0 55 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			 <&cc CC_CLK_VE3>;
+		clock-names = "clk_ve1",
+			      "clk_ve3";
+		resets = <&crst RSTN_VE1>,
+			 <&crst RSTN_VE1_BIST>,
+			 <&crst RSTN_VE3>,
+			 <&crst RSTN_VE3_BIST>;
+		reset-names = "ve1",
+			      "ve1_bist",
+			      "ve3",
+			      "ve3_bist";
+		assigned-clocks        = <&cc CC_CLK_VE1>, <&cc CC_CLK_VE3>;
+		assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE1>;
+		assigned-clock-rates   = <550000000>, <550000000>;
+		status = "okay";
+	};
+	
+	cec0@98037800 {
+		compatible = "Realtek,rtk-cec0";
+		reg = <0x0 0x98037800 0x0 0xe0>,
+			<0x0 0x98007000 0x0 0x100>,
+			<0x0 0x98037500 0x0 0x100>;
+		interrupts = <0 26 4>;
+		clocks = <&iso_clk_en CLK_EN_CBUS_OSC>,
+			<&iso_clk_en CLK_EN_CBUS_SYS>,
+			<&iso_clk_en CLK_EN_CBUSTX_SYS>,
+			<&iso_clk_en CLK_EN_CBUSRX_SYS>;
+		clock-names = "cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys";
+		resets = <&iso_rst RSTN_CBUS>,
+			<&iso_rst RSTN_CBUSTX>,
+			<&iso_rst RSTN_CBUSRX>;
+		reset-names = "cbus",
+			"cbustx",
+			"cbusrx";
+		status = "okay";
+	};
+
+	spdif {
+		compatible = "realtek,audio";
+		gpios = <&rtk_iso_gpio 22 1 1>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>;
+		status = "okay";
+	};
+
+	demod@9801E000 {
+		compatible = "realtek,demod";
+		reg = <0x0 0x9801E000 0x0 0x1000>;
+		clocks = <&clk_en_2 CLK_EN_CABLERX>, <&cc CC_PLL_DIF>;
+		clock-names = "cablerx", "pll";
+		resets = <&crst RSTN_CABLERX>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&demod_pins>;
+		status = "okay";
+	};
+};
+#include "rtd-13xx-pcie.dtsi"
+#include "rtd-13xx-irda.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/Makefile b/arch/arm64/boot/dts/realtek/rtd16xx/Makefile
new file mode 100644
index 00000000..c064f4b
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/Makefile
@@ -0,0 +1,38 @@
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-melon.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-tee-melon.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-3GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-4GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-qa-rescue-tee-melon.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += thor-fpga.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-nand-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-qa-rescue-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-megingjord-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-megingjord-2GB-avb.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-1GB.CMAx2.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-megingjord-2GB-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-megingjord-2GB-avb-tee.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-8ch.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mjolnir-2GB-avb-tee-8ch.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-nas-megingjord-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mmnas-megingjord-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-nas-mjolnir-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mmnas-mjolnir-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-nas-mjolnir-3GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mmnas-mjolnir-3GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-nas-mjolnir-4GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mmnas-mjolnir-4GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-nas-qa-rescue.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-nas-mjolnir-nand-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-mmnas-mjolnir-nand-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-videonas-megingjord-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-videonas-mjolnir-2GB.dtb
+dtb-$(CONFIG_ARCH_RTD16xx) += rtd-1619-videonas-megingjord-4GB.dtb
+always          := $(dtb-y)
+subdir-y        := $(dts-dirs)
+clean-files     := *.dtb
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/dtbo/rtd-1619-mjolnir-overlay.dts b/arch/arm64/boot/dts/realtek/rtd16xx/dtbo/rtd-1619-mjolnir-overlay.dts
new file mode 100644
index 00000000..6e10ceb
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/dtbo/rtd-1619-mjolnir-overlay.dts
@@ -0,0 +1,90 @@
+/dts-v1/;
+/plugin/;
+
+
+/ {
+	board_id = <0x0>;
+
+};
+
+
+&uart0 {
+	status = "okay";
+};
+
+&uart1 {
+	status = "okay";
+};
+
+&uart2{
+	status = "disabled";
+};
+
+&nic{
+	status = "okay";
+};
+
+&i2c_0{
+	status = "okay";
+};
+
+&i2c_1{
+	status = "okay";
+};
+
+&i2c_3{
+	status = "okay";
+};
+
+&i2c_4{
+	status = "okay";
+};
+
+&i2c_5{
+	status = "okay";
+};
+
+&spi_0{
+	status = "disabled";
+};
+
+&pwm{
+	status = "okay";
+};
+
+&sd{
+	status = "okay";
+};
+
+&sdio{
+	status = "okay";
+};
+
+&emmc{
+	status = "okay";
+};
+
+&gpu{
+	status = "okay";
+};
+
+&cpu_tm{
+	status = "okay";
+};
+
+&md{
+	status = "okay";
+};
+
+&se{
+	status = "okay";
+};
+
+&jpeg{
+	status = "okay";
+};
+
+&ve1{
+	status = "okay";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/dtbo/rtd-16xx-dtboimg.cfg b/arch/arm64/boot/dts/realtek/rtd16xx/dtbo/rtd-16xx-dtboimg.cfg
new file mode 100644
index 00000000..9099771
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/dtbo/rtd-16xx-dtboimg.cfg
@@ -0,0 +1,3 @@
+#global options
+rtd-1619-mjolnir-overlay.dtbo
+     id=/:board_id
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-irda.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-irda.dtsi
new file mode 100644
index 00000000..a61baba
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-irda.dtsi
@@ -0,0 +1,51 @@
+/*
+ * rtd-1295-irda.dtsi - IRDA remote Device Tree Include file for REALTEK 1295 family SoC
+ */
+
+/ {
+	irda@98007400 {
+		irda_rx0 {
+			irrx-protocol = "NEC";
+			transcode-mode = <1>;
+
+			cust-code = <0x7F80>;
+			scancode-msk = <0x00FF0000>;  
+			custcode-msk = <0x0000FFFF>;  
+			keymap-tbl = <
+			// scancode	keycode
+				0x18 	116		//KEY_POWER		//POWER
+				0x5A 	353		//KEY_SELECT		//SOURCE
+				0x58 	154		//KEY_CYCLEWINDOWS	//PIP
+				0x1A 	377		//KEY_TV		//TV SYSTEM
+				0x14 	102		//KEY_HOME		//HOME
+				0x56 	357		//KEY_OPTION		//OPTION MENU
+				0x54	358		//KEY_INFO		//MEDIA_INFO
+				0x19 	232		//KEY_REPLY		//REPEAT
+				0x57 	158		//KEY_BACK		//RETURN
+				0x55 	207		//KEY_PLAY		//PLAY/PAUSE
+				0x17 	128		//KEY_STOP		//STOP
+				0x15 	372		//KEY_ZOOM		//ZOOM_IN
+				0x4F 	168		//KEY_REWIND		//FR
+				0x4D 	103		//KEY_UP		//UP
+				0x16 	208		//KEY_FASTFORWARD	//FF
+				0x0C 	105		//KEY_LEFT		//LEFT
+				0x4C 	352		//KEY_OK		//OK
+				0x0E 	106		//KEY_RIGHT		//RIGHT
+				0x08 	412		//KEY_PREVIOUS		//PREVIOUS
+				0x48 	108		//KEY_DOWN		//DOWN
+				0x09 	407		//KEY_NEXT		//NEXT
+				0x4B 	114		//KEY_VOLUMEDOWN	//VOL-
+				0x49 	115		//KEY_VOLUMEUP		//VOL+
+				0x0B 	532		//KEY_TOUCHPAD_OFF	//CURSOR
+				0x0A 	531		//KEY_TOUCHPAD_ON	//GESTURE
+				0xEEEE	0		//REL_X			//mouse X-axi	0xEEEE : REL event type
+				0xEEEE	1		//REL_Y			//mouse Y-axi	0xEEEE : REL event type
+				0xFFFF	272		//BTN_LEFT		//mouse left key	0xFFFF : KEY event type
+				0xFFFF	113     	//KEY_MUTE 		//mute key in AirFunAPP	0xFFFF : KEY event type	
+           		>; 
+			reg-ir-dpir = <50>;	/*IR detect interval, NEC default=50ms, should less than 100ms, and bigger than 9ms*/
+			sample-rate = <40>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb-tee.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb-tee.dts
new file mode 100644
index 00000000..baeb71c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb-tee.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-megingjord-2GB-tee.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB_AVB_TEE";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb.dts
new file mode 100644
index 00000000..0e596fc
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-megingjord-2GB.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB_AVB";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-tee.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-tee.dts
new file mode 100755
index 00000000..7f044d8
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB-tee.dts
@@ -0,0 +1,347 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+
+#include "rtd-1619-megingjord.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB_TEE";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+			ION_SECURE_HEAP_PHYS_0
+			ION_SECURE_HEAP_SIZE_0
+			ION_SECURE_HEAP_FLAG_0
+			ION_SECURE_AUDIO_PHYS_0
+			ION_SECURE_AUDIO_SIZE_0
+			ION_SECURE_AUDIO_FLAG_0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	rtk_usb_power_manager@0 {
+		gpio1: gpio1 {
+			/delete-property/realtek,power-gpio; //gpio48
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+		};
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "disabled";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		/delete-property/dis_u3_port; // Disable usb 3.0 port
+
+		dwc3_u3host@981F0000 {
+			/delete-property/snps,dis_u3_susphy_quirk;
+		};
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	spdif {
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		status = "disabled";
+	};
+
+	uart1: serial1@9801B200 {
+		status = "disabled";
+	};
+
+	uart2: serial2@9801B400 {
+		status = "disabled";
+	};
+
+	hse@98005000 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 60 1 1>;
+		wakeup-gpio-list = <&rtk_iso_gpio 26 0 1>;
+                wakeup-gpio-enable = <1>;
+                wakeup-gpio-activity = <0>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 78 0 0>; /*HPD, input, default N/A */
+		};
+	};
+	ahci_sata: sata@9803F000 {
+		gpios = <&rtk_iso_gpio 67 1 1>,
+			<&rtk_iso_gpio 62 1 1>,
+			<&rtk_iso_gpio 63 1 1>,
+			<&rtk_iso_gpio 64 1 1>;
+		sata-port@0 {
+			/delete-property/ gpios;
+		};
+		sata-port@1 {
+			/delete-property/ gpios;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB.dts
new file mode 100755
index 00000000..08e4324
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord-2GB.dts
@@ -0,0 +1,315 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-megingjord.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	rtk_usb_power_manager@0 {
+		gpio1: gpio1 {
+			/delete-property/realtek,power-gpio; //gpio48
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+		};
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "disabled";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		/delete-property/dis_u3_port; // Disable usb 3.0 port
+
+		dwc3_u3host@981F0000 {
+			/delete-property/snps,dis_u3_susphy_quirk;
+		};
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	spdif {
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		status = "disabled";
+	};
+
+	uart1: serial1@9801B200 {
+		status = "disabled";
+	};
+
+	uart2: serial2@9801B400 {
+		status = "disabled";
+	};
+
+	hse@98005000 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 60 1 1>;
+		wakeup-gpio-list = <&rtk_iso_gpio 26 0 1>;
+                wakeup-gpio-enable = <1>;
+                wakeup-gpio-activity = <0>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 78 0 0>; /*HPD, input, default N/A */
+		};
+	};
+	ahci_sata: sata@9803F000 {
+		gpios = <&rtk_iso_gpio 67 1 1>,
+			<&rtk_iso_gpio 62 1 1>,
+			<&rtk_iso_gpio 63 1 1>,
+			<&rtk_iso_gpio 64 1 1>;
+		sata-port@0 {
+			/delete-property/ gpios;
+		};
+		sata-port@1 {
+			/delete-property/ gpios;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord.dtsi
new file mode 100644
index 00000000..548efb7
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-megingjord.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-16xx.dtsi"
+#include "rtd-16xx-dvfs.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-1GB.CMAx2.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-1GB.CMAx2.dts
new file mode 100755
index 00000000..f9d9b5c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-1GB.CMAx2.dts
@@ -0,0 +1,236 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_1GB_CMAx2";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,ion_media_heap1_in_cma {
+			compatible = "shared-dma-pool";
+			reusable;
+			size = <0 0x0b000000>; /* size 176MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x14000000 0 0x0b000000>; /* offset 320MB, size 176MB */
+			linux,contiguous-region;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x00800000>; /* size 8MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x00800000>; /* offset 512MB, size 8MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-8ch.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-8ch.dts
new file mode 100644
index 00000000..821599b
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-8ch.dts
@@ -0,0 +1,8 @@
+#include "rtd-1619-mjolnir-2GB.dts"
+#include "rtd-16xx-avb.dtsi"
+#include "rtd-16xx-ao_i2s_8ch.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB_8CH";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch.dts
new file mode 100644
index 00000000..afb3328
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee-8ch.dts
@@ -0,0 +1,8 @@
+#include "rtd-1619-mjolnir-2GB-tee.dts"
+#include "rtd-16xx-avb.dtsi"
+#include "rtd-16xx-ao_i2s_8ch.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB_TEE_8CH";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee.dts
new file mode 100644
index 00000000..aaa1b19
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb-tee.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-mjolnir-2GB-tee.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB_TEE";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb.dts
new file mode 100644
index 00000000..048cb53
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-avb.dts
@@ -0,0 +1,7 @@
+#include "rtd-1619-mjolnir-2GB.dts"
+#include "rtd-16xx-avb.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_AVB";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-melon.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-melon.dts
new file mode 100644
index 00000000..c6c0b70
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-melon.dts
@@ -0,0 +1,247 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ 0x10200000 0x03A00000;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ HIF_EMMC_RSV_PHYS HIF_EMMC_RSV_SIZE;
+
+#define SECURE_AUDIO_REQ_SIZE   (0x00200000) // 2M
+#define SECURE_TP_SIZE          (0x01000000) // 16M
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define ION_SECURE_AUDIO_REQ_PHYS_0  (0x32600000)
+#define ION_SECURE_AUDIO_REQ_SIZE_0  (SECURE_AUDIO_REQ_SIZE)
+#define ION_SECURE_AUDIO_REQ_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_REQ_PHYS_0 ION_SECURE_AUDIO_REQ_SIZE_0;
+/memreserve/ ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0;
+
+#include "rtd-1619-mjolnir-tcc.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_MELON";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+    
+	uart2: serial2@9801B400 {
+		clock-frequency = <36000000>;
+		pinctrl-0 = <&uart2_pins_0>,
+			<&scpu_ejtag_pins_disable>,
+			<&acpu_ejtag_pins_disable>;
+		status = "okay"; /* Disable UR2 first since we don't use it now */
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee-melon.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee-melon.dts
new file mode 100644
index 00000000..620f728
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee-melon.dts
@@ -0,0 +1,286 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ 0x10200000 0x03A00000;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+/memreserve/ HIF_EMMC_RSV_PHYS HIF_EMMC_RSV_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+#define SECURE_AUDIO_REQ_SIZE   (0x00200000) // 2M
+#define SECURE_TP_SIZE          (0x01000000) // 16M
+
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+#define ION_SECURE_AUDIO_REQ_PHYS_0  (0x32600000)
+#define ION_SECURE_AUDIO_REQ_SIZE_0  (SECURE_AUDIO_REQ_SIZE)
+#define ION_SECURE_AUDIO_REQ_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0 ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0 ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1 ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0 ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0 ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0 ION_SECURE_HEAP_SIZE_0;
+/memreserve/ ION_SECURE_AUDIO_REQ_PHYS_0 ION_SECURE_AUDIO_REQ_SIZE_0;
+/memreserve/ ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0;
+
+#include "rtd-1619-mjolnir-tcc.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_TEE_MELON";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				ION_SECURE_HEAP_PHYS_0
+				ION_SECURE_HEAP_SIZE_0
+				ION_SECURE_HEAP_FLAG_0
+				ION_SECURE_AUDIO_PHYS_0
+				ION_SECURE_AUDIO_SIZE_0
+				ION_SECURE_AUDIO_FLAG_0
+				ION_SECURE_TP_PHYS_0
+				ION_SECURE_TP_SIZE_0
+				ION_SECURE_TP_FLAG_0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+
+	uart2: serial2@9801B400 {
+		clock-frequency = <36000000>;
+		pinctrl-0 = <&uart2_pins_0>,
+			<&scpu_ejtag_pins_disable>,
+			<&acpu_ejtag_pins_disable>;
+		status = "okay"; /* Disable UR2 first since we don't use it now */
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee.dts
new file mode 100644
index 00000000..00ce9ca
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB-tee.dts
@@ -0,0 +1,254 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/memreserve/ 0x32b00000 0x12C00000;
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#define SECURE_REQ_SIZE_0       (0x12c00000) // 300M
+#define SECURE_AUDIO_SIZE       (0x00200000) // 2M
+#define SECURE_MD_SIZE          (0x00100000) // 1M
+
+#define ION_SECURE_HEAP_PHYS_0   (MEM_SLOT(4, PHYS, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_SIZE_0   (MEM_SLOT(4, SIZE, SECURE_REQ_SIZE_0))
+#define ION_SECURE_HEAP_FLAG_0   (RTK_FLAG_HWIPACC)
+
+#define ION_SECURE_AUDIO_PHYS_0  (0x32800000)
+#define ION_SECURE_AUDIO_SIZE_0  (SECURE_AUDIO_SIZE)
+#define ION_SECURE_AUDIO_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_MD_PHYS_0     (ION_SECURE_AUDIO_PHYS_0 + SECURE_AUDIO_SIZE)
+#define ION_SECURE_MD_SIZE_0     (SECURE_MD_SIZE)
+
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+/memreserve/ ION_SECURE_AUDIO_PHYS_0    ION_SECURE_AUDIO_SIZE_0;
+/memreserve/ ION_SECURE_MD_PHYS_0       ION_SECURE_MD_SIZE_0;
+/memreserve/ ION_SECURE_HEAP_PHYS_0     ION_SECURE_HEAP_SIZE_0;
+
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_TEE";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 {    /* Secure */
+            compatible = "Realtek,rtk-ion-reserve";
+            reg = <9>;
+            rtk,memory-reserve = <
+                ION_SECURE_HEAP_PHYS_0 
+                ION_SECURE_HEAP_SIZE_0 
+                ION_SECURE_HEAP_FLAG_0
+                ION_SECURE_AUDIO_PHYS_0 
+                ION_SECURE_AUDIO_SIZE_0 
+                ION_SECURE_AUDIO_FLAG_0
+                >;
+        };
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB.dts
new file mode 100755
index 00000000..270f0cd
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-2GB.dts
@@ -0,0 +1,259 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-3GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-3GB.dts
new file mode 100755
index 00000000..ff44869
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-3GB.dts
@@ -0,0 +1,265 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/* platform reserved region */
+/memreserve/ 0x80000000 0x00020000; /* CP: 128KB in 1619 */
+/memreserve/ 0x88100000 0x02000000; /* NOR remap address: 32MB */
+/memreserve/ 0xFF000000 0x01000000; /* JTAG+GIC: 16MB */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_3GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x00000000 0x00000000 0x00000000 0x98000000>,
+		      <0x00000000 0x99000000 0x00000000 0x27000000>; /* 3072 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-4GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-4GB.dts
new file mode 100755
index 00000000..f224908
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-4GB.dts
@@ -0,0 +1,266 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/* platform reserved region */
+/memreserve/ 0x80000000 0x00020000; /* CP: 128KB in 1619 */
+/memreserve/ 0x88100000 0x02000000; /* NOR remap address: 32MB */
+/memreserve/ 0xFF000000 0x01000000; /* JTAG+GIC: 16MB */
+
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_4GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.storage=emmc androidboot.hardware=thor loglevel=4";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x00000000 0x00000000 0x00000000 0x98000000>,
+		      <0x00000000 0x99000000 0x00000000 0x66000000>; /* 4096 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-nand-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-nand-2GB.dts
new file mode 100755
index 00000000..3b4d31b
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-nand-2GB.dts
@@ -0,0 +1,223 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE;
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB_NAND";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		linux,initrd-start = <ROOTFS_NORMAL_START>;
+		linux,initrd-end = <ROOTFS_NORMAL_END>;
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=thor androidboot.storage=nand loglevel=4 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	nand@98010000 { status = "okay"; };
+	emmc@98012000 { status = "disabled"; };
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-tcc.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-tcc.dtsi
new file mode 100644
index 00000000..c1407da
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir-tcc.dtsi
@@ -0,0 +1,36 @@
+/*
+ * RTD-1619 Mjolnir with Tee Clock Controller
+ */
+#include "rtd-1619-mjolnir.dtsi"
+
+/{
+	tcc: tee-clocks {
+		compatible = "realtek,tee-clock-controller";
+		#clock-cells = <0>;
+	};
+};
+
+/* CPU nodes */
+&A55_0 {
+	clocks = <&tcc>;
+};
+
+&A55_1 {
+	clocks = <&tcc>;
+};
+
+&A55_2 {
+	clocks = <&tcc>;
+};
+
+&A55_3 {
+	clocks = <&tcc>;
+};
+
+&A55_4 {
+	clocks = <&tcc>;
+};
+
+&A55_5 {
+	clocks = <&tcc>;
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir.dtsi
new file mode 100644
index 00000000..548efb7
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mjolnir.dtsi
@@ -0,0 +1,2 @@
+#include "rtd-16xx.dtsi"
+#include "rtd-16xx-dvfs.dtsi"
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-megingjord-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-megingjord-2GB.dts
new file mode 100755
index 00000000..81a5e5f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-megingjord-2GB.dts
@@ -0,0 +1,337 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/*/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;*/
+/memreserve/ 0x0F900000 0x00307000;
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#undef MEM_SLOT_PHYS_2
+#undef MEM_SLOT_SIZE_2
+#define MEM_SLOT_PHYS_2 (0x16200000)
+#define MEM_SLOT_SIZE_2	(0x19E00000) // Max : 414M
+
+#define MEDIA_REQ_SIZE_1 (0x015300000) // 339M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-megingjord.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x14200000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <1>;
+		resolution = <1920 1080>;
+		fps = <60>;
+		osd-init = <1>;
+	};
+
+	rtk_usb_power_manager@0 {
+		gpio1: gpio1 {
+			/delete-property/realtek,power-gpio; //gpio48
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+		};
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "disabled";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		/delete-property/dis_u3_port; // Disable usb 3.0 port
+
+		dwc3_u3host@981F0000 {
+			/delete-property/snps,dis_u3_susphy_quirk;
+		};
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	spdif {
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		status = "disabled";
+	};
+
+	uart1: serial1@9801B200 {
+		status = "disabled";
+	};
+
+	uart2: serial2@9801B400 {
+		status = "disabled";
+	};
+
+	hse@98005000 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 60 1 1>;
+                autorepeat;
+                label = "gpio-keys";
+                power-button {
+                       wakeup-source;
+                       gpios = <&rtk_iso_gpio 2 0 1>;
+                       label = "Power Button";
+                       linux,code = <0x74>;
+                       key-is-active-low;
+                };
+
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 78 0 0>; /*HPD, input, default N/A */
+		};
+	};
+	ahci_sata: sata@9803F000 {
+		gpios = <&rtk_iso_gpio 67 1 1>,
+			<&rtk_iso_gpio 62 1 1>,
+			<&rtk_iso_gpio 63 1 1>,
+			<&rtk_iso_gpio 64 1 1>;
+		sata-port@0 {
+			/delete-property/ gpios;
+		};
+		sata-port@1 {
+			/delete-property/ gpios;
+		};
+	};
+
+	rtk_pm@0 {
+		wakeup-flags = <0x3d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};
+	watchdog@0x98007680 {
+                status = "disabled";
+        };			
+
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-2GB.dts
new file mode 100755
index 00000000..c2c2767
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-2GB.dts
@@ -0,0 +1,266 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/*/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;*/
+ /memreserve/ 0x0F900000 0x00307000;
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+		
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+	rtk_pm@0 {
+		wakeup-flags = <0x1d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};
+	watchdog@0x98007680 {
+                status = "disabled";
+        };			
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-3GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-3GB.dts
new file mode 100755
index 00000000..a2f18d6
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-3GB.dts
@@ -0,0 +1,270 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/*/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;*/
+ /memreserve/ 0x0F900000 0x00307000;
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/* platform reserved region */
+/memreserve/ 0x80000000 0x00020000; /* CP: 128KB in 1619 */
+/memreserve/ 0x88100000 0x02000000; /* NOR remap address: 32MB */
+/memreserve/ 0xFF000000 0x01000000; /* JTAG+GIC: 16MB */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x00000000 0x00000000 0x00000000 0x98000000>,
+		      <0x00000000 0x99000000 0x00000000 0x27000000>; /* 3072 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+	rtk_pm@0 {
+		wakeup-flags = <0x3d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};	
+	
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-4GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-4GB.dts
new file mode 100755
index 00000000..05bd7fd
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-4GB.dts
@@ -0,0 +1,271 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/*/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;*/
+ /memreserve/ 0x0F900000 0x00307000;
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/* platform reserved region */
+/memreserve/ 0x80000000 0x00020000; /* CP: 128KB in 1619 */
+/memreserve/ 0x88100000 0x02000000; /* NOR remap address: 32MB */
+/memreserve/ 0xFF000000 0x01000000; /* JTAG+GIC: 16MB */
+
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x00000000 0x00000000 0x00000000 0x98000000>,
+		      <0x00000000 0x99000000 0x00000000 0x66000000>; /* 4096 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+	rtk_pm@0 {
+		wakeup-flags = <0x3d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};	
+	
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-nand-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-nand-2GB.dts
new file mode 100644
index 00000000..418e9cc
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-mmnas-mjolnir-nand-2GB.dts
@@ -0,0 +1,221 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/* /memreserve/ 0x10200000 0x03A00000; */
+/memreserve/ 0x0F900000 0x00307000;
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-16xx.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	nand@98010000 { status = "okay"; };
+	emmc@98012000 { status = "disabled"; };
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-megingjord-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-megingjord-2GB.dts
new file mode 100644
index 00000000..0ef193e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-megingjord-2GB.dts
@@ -0,0 +1,320 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/* /memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE; */
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* /memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE; */
+/* /memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE; */
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/* /memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE; */
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#include "rtd-1619-megingjord.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		status = "disabled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	rtk_usb_power_manager@0 {
+		gpio1: gpio1 {
+			/delete-property/realtek,power-gpio; //gpio48
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+		};
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "disabled";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		/delete-property/dis_u3_port; // Disable usb 3.0 port
+
+		dwc3_u3host@981F0000 {
+			/delete-property/snps,dis_u3_susphy_quirk;
+		};
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	spdif {
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		status = "disabled";
+	};
+
+	uart1: serial1@9801B200 {
+		status = "disabled";
+	};
+
+	uart2: serial2@9801B400 {
+		status = "disabled";
+	};
+
+	hse@98005000 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 60 1 1>;
+                autorepeat;
+                label = "gpio-keys";
+                power-button {
+                       wakeup-source;
+                       gpios = <&rtk_iso_gpio 2 0 1>;
+                       label = "Power Button";
+                       linux,code = <0x74>;
+                       key-is-active-low;
+                };
+
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 78 0 0>; /*HPD, input, default N/A */
+		};
+	};
+	ahci_sata: sata@9803F000 {
+		gpios = <&rtk_iso_gpio 67 1 1>,
+			<&rtk_iso_gpio 62 1 1>,
+			<&rtk_iso_gpio 63 1 1>,
+			<&rtk_iso_gpio 64 1 1>;
+		sata-port@0 {
+			/delete-property/ gpios;
+		};
+		sata-port@1 {
+			/delete-property/ gpios;
+		};
+	};
+	rtk_pm@0 {
+		wakeup-flags = <0x1d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};
+	watchdog@0x98007680 {
+                status = "disabled";
+        };			
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-2GB.dts
new file mode 100755
index 00000000..6334fd2
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-2GB.dts
@@ -0,0 +1,257 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/* /memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE; */
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* /memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE; */
+/* /memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE; */
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/* /memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE; */
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		status = "disabled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+	rtk_pm@0 {
+		wakeup-flags = <0x1d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};
+	watchdog@0x98007680 {
+                status = "disabled";
+        };			
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-3GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-3GB.dts
new file mode 100755
index 00000000..ef43318
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-3GB.dts
@@ -0,0 +1,261 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/* /memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE; */
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/* platform reserved region */
+/memreserve/ 0x80000000 0x00020000; /* CP: 128KB in 1619 */
+/memreserve/ 0x88100000 0x02000000; /* NOR remap address: 32MB */
+/memreserve/ 0xFF000000 0x01000000; /* JTAG+GIC: 16MB */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* /memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE; */
+/* /memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE; */
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/* /memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE; */
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x00000000 0x00000000 0x00000000 0x98000000>,
+		      <0x00000000 0x99000000 0x00000000 0x27000000>; /* 3072 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		status = "disabled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+	rtk_pm@0 {
+		wakeup-flags = <0x3d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};	
+	
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-4GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-4GB.dts
new file mode 100755
index 00000000..018ccc3
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-4GB.dts
@@ -0,0 +1,262 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/* /memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE; */
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/* platform reserved region */
+/memreserve/ 0x80000000 0x00020000; /* CP: 128KB in 1619 */
+/memreserve/ 0x88100000 0x02000000; /* NOR remap address: 32MB */
+/memreserve/ 0xFF000000 0x01000000; /* JTAG+GIC: 16MB */
+
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* /memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE; */
+/* /memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE; */
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/* /memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE; */
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x00000000 0x00000000 0x00000000 0x98000000>,
+		      <0x00000000 0x99000000 0x00000000 0x66000000>; /* 4096 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		status = "disabled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+	rtk_pm@0 {
+		wakeup-flags = <0x3d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};	
+	
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-nand-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-nand-2GB.dts
new file mode 100644
index 00000000..a900274
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-mjolnir-nand-2GB.dts
@@ -0,0 +1,219 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/* /memreserve/ 0x10200000 0x03A00000; */
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* /memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE; */
+/* /memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE; */
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/* /memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE; */
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+#include "rtd-16xx.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 ubi.mtd=1 rootfstype=ubifs rw root=ubi0_0";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		status = "disabled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	nand@98010000 { status = "okay"; };
+	emmc@98012000 { status = "disabled"; };
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+	rtk_pm@0 {
+		wakeup-flags = <0x3d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};	
+	
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-qa-rescue.dts
new file mode 100644
index 00000000..2af21f4
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nas-qa-rescue.dts
@@ -0,0 +1,175 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+#undef ROOTFS_RESCUE_SIZE
+#define ROOTFS_RESCUE_SIZE 0x00100000
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-16xx.dtsi"
+#include "rtd-1619-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 cma=8m@240m init=/init loglevel=8";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+		status = "disabled";
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&pcie2 {
+	status = "disabled";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nvr-megingjord-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nvr-megingjord-2GB.dts
new file mode 100644
index 00000000..b82ef5c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-nvr-megingjord-2GB.dts
@@ -0,0 +1,333 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/*/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;*/
+/memreserve/ 0x0F900000 0x00307000;
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#undef MEM_SLOT_PHYS_2
+#undef MEM_SLOT_SIZE_2
+#define MEM_SLOT_PHYS_2 (0x16200000)
+#define MEM_SLOT_SIZE_2	(0x50000000) // 1280M
+
+#define MEDIA_REQ_SIZE_1 (0x50000000) // 1280M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-megingjord.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x14200000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <1>;
+		resolution = <1920 1080>;
+		fps = <60>;
+		osd-init = <1>;
+	};
+
+	rtk-vfb {
+		compatible = "Realtek,rtk-vfb";
+        	buffer-cnt = <2>;
+        	resolution = <3840 2160>;
+        	fps = <60>;
+    	};
+
+	rtk_usb_power_manager@0 {
+		gpio1: gpio1 {
+			/delete-property/realtek,power-gpio; //gpio48
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+		};
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "disabled";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		/delete-property/dis_u3_port; // Disable usb 3.0 port
+
+		dwc3_u3host@981F0000 {
+			/delete-property/snps,dis_u3_susphy_quirk;
+		};
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	spdif {
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		status = "disabled";
+	};
+
+	uart1: serial1@9801B200 {
+		status = "disabled";
+	};
+
+	uart2: serial2@9801B400 {
+		status = "disabled";
+	};
+
+	hse@98005000 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 60 1 1>;
+                autorepeat;
+                label = "gpio-keys";
+                power-button {
+                       wakeup-source;
+                       gpios = <&rtk_iso_gpio 2 0 1>;
+                       label = "Power Button";
+                       linux,code = <0x74>;
+                       key-is-active-low;
+                };
+
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 78 0 0>; /*HPD, input, default N/A */
+		};
+	};
+	ahci_sata: sata@9803F000 {
+		gpios = <&rtk_iso_gpio 67 1 1>,
+			<&rtk_iso_gpio 62 1 1>,
+			<&rtk_iso_gpio 63 1 1>,
+			<&rtk_iso_gpio 64 1 1>;
+		sata-port@0 {
+			/delete-property/ gpios;
+		};
+		sata-port@1 {
+			/delete-property/ gpios;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee-melon.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee-melon.dts
new file mode 100644
index 00000000..b8be08c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee-melon.dts
@@ -0,0 +1,189 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+#define SECURE_AUDIO_REQ_SIZE   (0x00200000) // 2M
+#define SECURE_TP_SIZE          (0x01000000) // 16M
+
+#define ION_SECURE_AUDIO_REQ_PHYS_0  (0x32600000)
+#define ION_SECURE_AUDIO_REQ_SIZE_0  (SECURE_AUDIO_REQ_SIZE)
+#define ION_SECURE_AUDIO_REQ_FLAG_0  (RTK_FLAG_SECURE_AUDIO)
+
+#define ION_SECURE_TP_PHYS_0     (0x31600000)
+#define ION_SECURE_TP_SIZE_0     (SECURE_TP_SIZE)
+#define ION_SECURE_TP_FLAG_0     (RTK_FLAG_SECURE_TPACC)
+
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/* /memreserve/ 0x0F900000 0x00307000; */
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+
+/memreserve/ ION_SECURE_AUDIO_REQ_PHYS_0 ION_SECURE_AUDIO_REQ_SIZE_0;
+/memreserve/ ION_SECURE_TP_PHYS_0 ION_SECURE_TP_SIZE_0;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-16xx.dtsi"
+#include "rtd-1619-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB_TEE_MELON";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&pcie2 {
+	status = "disabled";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee.dts
new file mode 100644
index 00000000..ea14870
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue-tee.dts
@@ -0,0 +1,183 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-16xx.dtsi"
+#include "rtd-1619-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB_TEE";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@9 { /* SECURE */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <9>;
+			rtk,memory-reserve = <
+				0x32b00000
+				0x12C00000
+				ION_SECURE_HEAP_FLAG>;
+                };
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&pcie2 {
+	status = "disabled";
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue.dts
new file mode 100644
index 00000000..ed87591
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-qa-rescue.dts
@@ -0,0 +1,173 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/memreserve/ TEE_OS_PHYS TEE_OS_SIZE;
+/memreserve/ 0x0F900000 0x00307000;
+/memreserve/ 0x0FC07000 0x001F9000;
+/memreserve/ 0x00000000 0x00001000;
+/memreserve/ 0x00002000 0x00001000;
+/* ION SECURE AUDIO BUFFER */
+/memreserve/ 0x32800000 0x00300000;
+/* ION SECURE BUFFER */
+/memreserve/ 0x32b00000 0x12C00000;
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* 0x02200000 ~ 0x02dfffff */
+/memreserve/ ROOTFS_RESCUE_START ROOTFS_RESCUE_SIZE;
+/memreserve/ 0x03000000 0x00100000;
+/memreserve/ 0x03100000 0x06000000;
+/* 0x10000000 ~ 0x10013fff */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+/* Framebuffer */
+/memreserve/ 0x15000000 0x17BB000;
+
+#include "rtd-16xx.dtsi"
+#include "rtd-1619-usb.dtsi"
+
+/ {
+	model= "Realtek_Rescue_1GB";
+	model_hex= <0x00000653>;
+
+	chosen {
+		linux,initrd-start = <ROOTFS_RESCUE_START>;
+		linux,initrd-end = <ROOTFS_RESCUE_END>;
+		bootargs ="earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init androidboot.hardware=thor androidboot.storage=emmc loglevel=4";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x40000000>; /* 1024 MB */
+	};
+
+	firmware {
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				0x03000000
+				0x00100000
+				ION_AUDIO_HEAP_FLAG>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				0x03100000
+				0x06000000
+				ION_MEDIA_HEAP_FLAG1>;
+		};
+	};
+
+	fb@0 {
+		compatible = "Realtek,rtk-fb";
+		reg = <0x0 0x15000000 0x0 0xA8C000>;
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	test_vo@98005000 {
+		compatible = "Realtek,rtk1295-test_vo";
+		reg = <0x0 0x98005000 0x0 0x1000>,
+			<0x0 0x9800D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>;
+		//interrupts = <0 31 4>;
+		interrupts = <0 34 4>;
+	};
+
+	sdmmc@98010400 {
+		status = "disabled";
+	};
+
+	emmc@98012000 {
+		kernel_hs400_tuning = <1>;
+	};
+
+	mcp@0 {
+		status = "okay";
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x0 0x98000000 0x0 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+	};
+};
+
+&pcie {
+	status = "disabled";
+};
+
+&pcie2 {
+	status = "disabled";
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-sata.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-sata.dtsi
new file mode 100644
index 00000000..7d7176e
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-sata.dtsi
@@ -0,0 +1,69 @@
+#include <dt-bindings/reset/rtk,reset-rtd16xx.h>
+#include <dt-bindings/clock/rtk,clock-rtd16xx.h>
+/ {
+	/include/ "rtd-16xx-sata.dtsi"
+
+	sata_phy: sata_phy@9803FF60 {
+		clocks = <&clk_en_4 CLK_EN_SATA_WRAP_SYS>,
+			<&clk_en_4 CLK_EN_SATA_WRAP_SYSH>;
+		resets = <&crst RSTN_SATA_WRAP>;
+		sata-phy@0 {
+			reg = <0>;
+			resets = <&crst RSTN_SATA_MDIO0>,
+				<&crst RSTN_SATA_PHY_POW0>;
+			spread-spectrum = <0>;
+			phy-param = <0x70000211>, <0x70004211>, <0x70008211>,
+				<0x336a0511>, <0x336a4511>, <0x336a8511>,
+				<0xa9040b11>, <0xa9044b11>, <0xa9048b11>,
+				<0x500b1411>, <0x500b5411>, <0x500b9411>,
+				<0x77771511>, <0x77775511>, <0x77779511>,
+				<0x00231711>, <0x00235711>, <0x00239711>,
+				<0x00632211>, <0x00636211>, <0x0063a211>,
+				<0xab762311>, <0xab766311>, <0xab76a311>;
+			tx-driving-tbl = // user can define tx driving here //
+					<0x40aa2011>, <0x40aa6011>, <0x40a8a011>,
+					<0x88aa2111>, <0x88aa6111>, <0x88aaa111>;
+			rx-sense-tbl = // user can define rx sensitivity here //
+					<0x42100911>, <0x42104911>, <0x42108911>,
+					<0x276a0311>, <0x276a4311>, <0x27668311>;
+		};
+		sata-phy@1 {
+			reg = <1>;
+			resets = <&crst RSTN_SATA_MDIO1>,
+				<&crst RSTN_SATA_PHY_POW1>;
+			spread-spectrum = <0>;
+			phy-param = <0x70000211>, <0x70004211>, <0x70008211>,
+				<0x336a0511>, <0x336a4511>, <0x336a8511>,
+				<0xa9040b11>, <0xa9044b11>, <0xa9048b11>,
+				<0x500b1411>, <0x500b5411>, <0x500b9411>,
+				<0x77771511>, <0x77775511>, <0x77779511>,
+				<0x00231711>, <0x00235711>, <0x00239711>,
+				<0x00632211>, <0x00636211>, <0x0063a211>,
+				<0xab762311>, <0xab766311>, <0xab76a311>;
+			tx-driving-tbl = // user can define tx driving here //
+					<0x40aa2011>, <0x40aa6011>, <0x40a8a011>,
+					<0x88aa2111>, <0x88aa6111>, <0x88aaa111>;
+			rx-sense-tbl = // user can define rx sensitivity here //
+					<0x42100911>, <0x42104911>, <0x42108911>,
+					<0x276a0311>, <0x276a4311>, <0x27668311>;
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		clocks = <&clk_en_4 CLK_EN_SATA_MAC_SYSH>;
+		resets = <&crst RSTN_SATA_MAC_COM>;
+		hostinit-mode = <0>;
+		sata-port@0 {
+			reg = <0>;
+			phys = <&sata_phy 0>;
+			resets = <&crst RSTN_SATA_MAC_P0>;
+			gpios = <&rtk_iso_gpio 65 1 1>;
+		};
+		sata-port@1 {
+			reg = <1>;
+			phys = <&sata_phy 1>;
+			resets = <&crst RSTN_SATA_MAC_P1>;
+			gpios = <&rtk_iso_gpio 67 1 1>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-usb.dtsi
new file mode 100644
index 00000000..a6c825b
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-usb.dtsi
@@ -0,0 +1,48 @@
+/*
+ * realtek,port0-power-gpio: drd TypeC power, output, default low
+ * realtek,port1-power-gpio: u2host power, output, default low
+ * realtek,port2-power-gpio: u3host power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+/ {
+	/include/ "rtd-16xx-usb.dtsi"
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+
+		status = "okay";
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			dr_mode = "peripheral"; /*host, peripheral*/
+		};
+
+		rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			drd_mode; //depend on dr_mode = "peripheral"
+			status = "okay";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		compatible = "Realtek,dwc3";
+		status = "okay";
+		dwc3_u3host@981F0000 {
+			compatible = "synopsys,dwc3";
+			status = "okay";
+		};
+
+	};
+
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-videonas-megingjord-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-videonas-megingjord-2GB.dts
new file mode 100755
index 00000000..09bde74
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-videonas-megingjord-2GB.dts
@@ -0,0 +1,336 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/*/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;*/
+/memreserve/ 0x0F900000 0x00307000;
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#undef MEM_SLOT_PHYS_2
+#undef MEM_SLOT_SIZE_2
+#define MEM_SLOT_PHYS_2 (0x16200000)
+#define MEM_SLOT_SIZE_2	(0x19E00000) // Max : 414M
+
+#define MEDIA_REQ_SIZE_1 (0x19B00000) // 411M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-megingjord.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x14200000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <1>;
+		resolution = <1920 1080>;
+		fps = <60>;
+		osd-init = <1>;
+	};
+
+	rtk_usb_power_manager@0 {
+		gpio1: gpio1 {
+			/delete-property/realtek,power-gpio; //gpio48
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+		};
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "disabled";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		/delete-property/dis_u3_port; // Disable usb 3.0 port
+
+		dwc3_u3host@981F0000 {
+			/delete-property/snps,dis_u3_susphy_quirk;
+		};
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	spdif {
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		status = "disabled";
+	};
+
+	uart1: serial1@9801B200 {
+		status = "disabled";
+	};
+
+	uart2: serial2@9801B400 {
+		status = "disabled";
+	};
+
+	hse@98005000 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 60 1 1>;
+                autorepeat;
+                label = "gpio-keys";
+                power-button {
+                       wakeup-source;
+                       gpios = <&rtk_iso_gpio 2 0 1>;
+                       label = "Power Button";
+                       linux,code = <0x74>;
+                       key-is-active-low;
+                };
+
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 78 0 0>; /*HPD, input, default N/A */
+		};
+	};
+	ahci_sata: sata@9803F000 {
+		gpios = <&rtk_iso_gpio 67 1 1>,
+			<&rtk_iso_gpio 62 1 1>,
+			<&rtk_iso_gpio 63 1 1>,
+			<&rtk_iso_gpio 64 1 1>;
+		sata-port@0 {
+			/delete-property/ gpios;
+		};
+		sata-port@1 {
+			/delete-property/ gpios;
+		};
+	};
+
+	rtk_pm@0 {
+		wakeup-flags = <0x3d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};
+	watchdog@0x98007680 {
+                status = "disabled";
+        };			
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-videonas-megingjord-4GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-videonas-megingjord-4GB.dts
new file mode 100755
index 00000000..2f72985c
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-videonas-megingjord-4GB.dts
@@ -0,0 +1,341 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/*/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;*/
+/memreserve/ 0x0F900000 0x00307000;
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/* platform reserved region */
+/memreserve/ 0x80000000 0x00020000; /* CP: 128KB in 1619 */
+/memreserve/ 0x88100000 0x02000000; /* NOR remap address: 32MB */
+/memreserve/ 0xFF000000 0x01000000; /* JTAG+GIC: 16MB */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#undef MEM_SLOT_PHYS_2
+#undef MEM_SLOT_SIZE_2
+#define MEM_SLOT_PHYS_2 (0x16200000)
+#define MEM_SLOT_SIZE_2	(0x19E00000) // Max : 414M
+
+#define MEDIA_REQ_SIZE_1 (0x19B00000) // 411M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-megingjord.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Megingjord_4GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x14200000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x00000000 0x00000000 0x00000000 0x98000000>,
+		      <0x00000000 0x99000000 0x00000000 0x66000000>; /* 4096 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <1>;
+		resolution = <1920 1080>;
+		fps = <60>;
+		osd-init = <1>;
+	};
+
+	rtk_usb_power_manager@0 {
+		gpio1: gpio1 {
+			/delete-property/realtek,power-gpio; //gpio48
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		dwc3_drd@98020000 {
+			dr_mode = "host"; /*host, peripheral*/
+		};
+		rtk_dwc3_drd_type_c@0 {
+			status = "disabled";
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		status = "disabled";
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		/delete-property/dis_u3_port; // Disable usb 3.0 port
+
+		dwc3_u3host@981F0000 {
+			/delete-property/snps,dis_u3_susphy_quirk;
+		};
+	};
+
+	sdio: sdio@98010A00 {
+		status = "disabled";
+	};
+
+	hdmirx@98034000 {
+		status = "disabled";
+	};
+
+	smartcard@9801BE00 {
+		status = "disabled";
+	};
+
+	spdif {
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+		status = "disabled";
+	};
+
+	uart1: serial1@9801B200 {
+		status = "disabled";
+	};
+
+	uart2: serial2@9801B400 {
+		status = "disabled";
+	};
+
+	hse@98005000 {
+		status = "disabled";
+	};
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		gpios = <&rtk_iso_gpio 60 1 1>;
+                autorepeat;
+                label = "gpio-keys";
+                power-button {
+                       wakeup-source;
+                       gpios = <&rtk_iso_gpio 2 0 1>;
+                       label = "Power Button";
+                       linux,code = <0x74>;
+                       key-is-active-low;
+                };
+
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 78 0 0>; /*HPD, input, default N/A */
+		};
+	};
+	ahci_sata: sata@9803F000 {
+		gpios = <&rtk_iso_gpio 67 1 1>,
+			<&rtk_iso_gpio 62 1 1>,
+			<&rtk_iso_gpio 63 1 1>,
+			<&rtk_iso_gpio 64 1 1>;
+		sata-port@0 {
+			/delete-property/ gpios;
+		};
+		sata-port@1 {
+			/delete-property/ gpios;
+		};
+	};
+
+	rtk_pm@0 {
+		wakeup-flags = <0x3d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};
+	watchdog@0x98007680 {
+                status = "disabled";
+        };			
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-videonas-mjolnir-2GB.dts b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-videonas-mjolnir-2GB.dts
new file mode 100755
index 00000000..ce81f4a
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-1619-videonas-mjolnir-2GB.dts
@@ -0,0 +1,266 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* DRM protect region */
+/*/memreserve/ TEE_OS_SLIM_PHYS TEE_OS_SLIM_SIZE;*/
+ /memreserve/ 0x0F900000 0x00307000;
+/* /memreserve/ 0x0FC07000 0x001F9000; */
+/* /memreserve/ 0x00000000 0x00001000; */
+/* /memreserve/ 0x00002000 0x00001000; */
+/* /memreserve/ 0x32b00000 0x12C00000; */
+
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+/* /memreserve/ ROOTFS_NORMAL_START ROOTFS_NORMAL_SIZE; */
+/memreserve/ ACPU_IDMEM_PHYS ACPU_IDMEM_SIZE;
+
+#define MEDIA_REQ_SIZE_0 (0x0ce00000) // 206M
+#define ION_MEDIA_HEAP_PHYS_0 (MEM_SLOT(0, PHYS, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_SIZE_0 (MEM_SLOT(0, SIZE, MEDIA_REQ_SIZE_0))
+#define ION_MEDIA_HEAP_FLAG_0 (MEM_SLOT(0, FLAG, MEDIA_REQ_SIZE_0))
+
+#define AUDIO_REQ_SIZE_0 (0x00c00000) // 12M
+#define ION_AUDIO_HEAP_PHYS_0 (MEM_SLOT(1, PHYS, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_SIZE_0 (MEM_SLOT(1, SIZE, AUDIO_REQ_SIZE_0))
+#define ION_AUDIO_HEAP_FLAG_0 (MEM_SLOT(1, FLAG, AUDIO_REQ_SIZE_0))
+
+#define MEDIA_REQ_SIZE_1 (0x0C400000) // 196M
+#define ION_MEDIA_HEAP_PHYS_1 (MEM_SLOT(2, PHYS, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_SIZE_1 (MEM_SLOT(2, SIZE, MEDIA_REQ_SIZE_1))
+#define ION_MEDIA_HEAP_FLAG_1 (MEM_SLOT(2, FLAG, MEDIA_REQ_SIZE_1))
+
+/memreserve/ ION_MEDIA_HEAP_PHYS_0  ION_MEDIA_HEAP_SIZE_0;
+/memreserve/ ION_AUDIO_HEAP_PHYS_0  ION_AUDIO_HEAP_SIZE_0;
+/memreserve/ ION_MEDIA_HEAP_PHYS_1  ION_MEDIA_HEAP_SIZE_1;
+
+#include "rtd-1619-mjolnir.dtsi"
+#include "rtd-1619-usb.dtsi"
+#include "rtd-1619-sata.dtsi"
+
+/ {
+	model= "Realtek_Mjolnir_2GB";
+	model_hex= <0x00000653>;
+
+	/*
+	 * NOTE:
+	 * <flag size base>
+	 * flag: reserved
+	 * size: unit is byte
+	 * base: unit is byte
+	 *
+	 * Array size not over 8;
+	 * You may change the max array size in KConfig,
+	 * max CMA array size is CONFIG_CMA_AREAS+1.
+	 *
+	 * If cma-region-enable is enabled<1>,
+	 * kernel driver will use cma-region-info to initial CMA memory.
+	 *
+	 * If cma-region-enable is disabled<0>,
+	 * kernel driver will use cma= to initial CMA memory.
+	 *
+	 * if both setting is loaded, cma-region-info had higher priority.
+	 */
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200";
+		swiotlb-memory-reservation-size = <512>; /*  512: 1MB,  2048: 4MB*/
+		swiotlb-force = <0>; /* 0: SWIOTLB_NORMAL, 1: SWIOTLB_FORCE, 2: SWIOTLB_NO_FORCE */
+		cma-region-enable = <1>;
+		cma-region-info = <0x00000000 0x02000000 0x20000000>;
+		/*cma-region-info = <0x00000000 0x01000000 0x12c00000>, <0x00000000 0x12c00000 0x20000000>;*/
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x80000000>; /* 2048 MB */
+	};
+
+	firmware {
+		android {
+			compatible = "android,firmware";
+			fstab {
+				compatible = "android,fstab";
+				system {
+					compatible = "android,system";
+					dev = "/dev/block/platform/98012000.emmc/by-name/system";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+				vendor {
+					compatible = "android,vendor";
+					dev = "/dev/block/platform/98012000.emmc/by-name/vendor";
+					type = "ext4";
+					mnt_flags = "ro,noatime";
+					fsmgr_flags = "wait";
+				};
+			};
+		};
+		optee {
+			compatible = "linaro,optee-tz";
+			method = "smc";
+		};
+	};
+
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+
+		linux,default_cma {
+			compatible = "shared-dma-pool";
+			linux,cma-default;
+			reusable;
+			size = <0 0x02000000>; /* size 32MB */
+			alignment = <0 0x00100000>;
+			alloc-ranges = <0 0x20000000 0 0x02000000>; /* offset 512MB, size 32MB */
+			linux,contiguous-region;
+		};
+	};
+
+	rtk_avcpu {
+		compatible = "Realtek,rtk-avcpu";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		crt@0 {
+			reg = <0x98000000 0x200000>;
+		};
+
+		rpc@0 {
+			reg = <RPC_COMM_PHYS RPC_COMM_SIZE>;
+		};
+
+		avlog {
+			sync_lock = <&sb2_lock_avlog>;
+			sync_lock_timeout = <500>; /* ms */
+			log_check_period = <500>; /* ms */
+		};
+	};
+
+	rtk,ion {
+		compatible = "Realtek,rtk-ion";
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		rtk,ion-heap@0 { /* SYSTEM_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <0>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@1 { /* System contig */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <1>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@4 { /* DMA_HEAP */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <4>;
+			rtk,memory-reservation-size = <0x0>;
+		};
+
+		rtk,ion-heap@8 { /* Audio */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <8>;
+			rtk,memory-reserve = <
+				ION_AUDIO_HEAP_PHYS_0
+				ION_AUDIO_HEAP_SIZE_0
+				ION_AUDIO_HEAP_FLAG_0>;
+		};
+
+		rtk,ion-heap@7 { /* TYPE_MEDIA */
+			compatible = "Realtek,rtk-ion-reserve";
+			reg = <7>;
+			rtk,memory-reserve = <
+				ION_MEDIA_HEAP_PHYS_0
+				ION_MEDIA_HEAP_SIZE_0
+				ION_MEDIA_HEAP_FLAG_0
+				ION_MEDIA_HEAP_PHYS_1
+				ION_MEDIA_HEAP_SIZE_1
+				ION_MEDIA_HEAP_FLAG_1>;
+		};
+	};
+
+	rtk-fb {
+		compatible = "Realtek,rtk-fb";
+		buffer-cnt = <3>;
+		resolution = <1920 1080>;
+		fps = <60>;
+	};
+
+	dptx@9803D000 {
+		compatible = "Realtek,rtk-dptx";
+		reg = <0x0 0x9803D000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x1000>,
+			<0x0 0x98009400 0x0 0x600>,
+			<0x0 0x98080000 0x0 0x2000>;
+		interrupts = <0 29 4>; /*gen Ri*/
+		clocks = <&clk_en_4 CLK_EN_EDP>,
+			<&clk_en_4 CLK_EN_TSIO_TRX>,
+			<&clk_en_1 CLK_EN_TVE>,
+			<&clk_en_1 CLK_EN_VO>;
+		clock-names = "clk_en_edp",
+			"clk_en_tsio_trx",
+			"clk_en_tve",
+			"clk_en_vo";
+		resets = <&iso_rst RSTN_DP>,
+			<&crst RSTN_EDP>,
+			<&crst RSTN_TVE>,
+			<&crst RSTN_VO>;
+		reset-names = "dp",
+			"edp",
+			"tve",
+			"vo";
+		dp_hpd {
+			gpios = <&rtk_iso_gpio 25 0 0>; /*HPD, input, default N/A */
+		};
+	};
+
+	sata_phy: sata_phy@9803FF60 {
+		sata-phy@0 {
+			status = "disabled";
+		};
+	};
+
+	ahci_sata: sata@9803F000 {
+		sata-port@0 {
+			/delete-property/ phys;
+		};
+	};
+	rtk_pm@0 {
+		wakeup-flags = <0x3d>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+	};	
+	spi_0: spi@9801BD00 {
+		status = "okay";
+	};
+	watchdog@0x98007680 {
+                status = "disabled";
+        };			
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-ao_i2s_8ch.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-ao_i2s_8ch.dtsi
new file mode 100644
index 00000000..42be099
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-ao_i2s_8ch.dtsi
@@ -0,0 +1,9 @@
+
+&audio_out {
+	status = "okay";
+	clocks = <&cc CC_PLL_DDSA>, <&cc CC_PLL_PSAUD1A>, <&cc CC_PLL_PSAUD2A>;
+	clock-names = "ddsa", "psaud1a", "psaud2a";
+	i2s {
+		channel = <8>;
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-avb.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-avb.dtsi
new file mode 100644
index 00000000..60e2d6f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-avb.dtsi
@@ -0,0 +1,17 @@
+/ {
+	firmware {
+		android {
+			vbmeta {
+				compatible = "android,vbmeta";
+				parts = "vbmeta,system,vendor";
+			};
+			fstab {
+				/delete-node/ system;
+				vendor {
+					fsmgr_flags = "wait,avb";
+				};
+			};
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-dvfs.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-dvfs.dtsi
new file mode 100644
index 00000000..5e4b4b6
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-dvfs.dtsi
@@ -0,0 +1,449 @@
+/*
+ * RTD-16XX CPU DVFS with GMT G2237 / SILERGY SY8827E / ANPEC APW8889
+ */
+#include <dt-bindings/regulator/gmt,g22xx.h>
+#include <dt-bindings/regulator/anpec,apw888x.h>
+#include <dt-bindings/thermal/thermal.h>
+
+&i2c_0 {
+	status = "okay";
+
+	cpu_supp_0: sy8827e: sy8827e@41 {
+		compatible = "silergy,sy8827e";
+		reg = <0x41>;
+		regulator-name = "cpudvs";
+		regulator-min-microvolt = <712500>;
+		regulator-max-microvolt = <1500000>;
+		regulator-ramp-delay = <2000>;
+		regulator-boot-on;
+		regulator-always-on;
+		status = "okay";
+	};
+
+	reg_sel: selector@12 {
+		compatible = "realtek,regulator-selector";
+		reg = <0x12>;
+		status = "okay";
+		cpu_supp: cpu-selector {
+			compatible = "supply-selector";
+			g2237-supply = <&cpu_supp_0>;
+			apw8889-supply = <&cpu_supp_1>;
+		};
+		gpu_supp: gpu-selector {
+			compatible = "supply-selector";
+			g2237-supply = <&gpu_supp_0>;
+			apw8889-supply = <&gpu_supp_1>;
+		};
+	};
+
+	g2237: g2237@12 {
+		compatible = "gmt,g2237";
+		reg = <0x12>;
+
+		/*** should be disabled ***/
+		status = "disabled";
+
+		powerkey_0: powerkey {
+			compatible = "gmt,g22xx-powerkey";
+			status = "disabled";
+		};
+		poweroff_0: poweroff {
+			compatible = "gmt,g22xx-poweroff";
+			system-power-controller;
+			status = "disabled";
+		};
+		regulators_0: regulators {
+			compatible = "gmt,g2237-regulator";
+			status = "okay";
+		};
+	};
+
+	apw8889: apw8889@12 {
+		compatible = "anpec,apw8889";
+		reg = <0x12>;
+
+		/*** should be disabled ***/
+		status = "disabled";
+
+		powerkey_1: powerkey {
+			compatible = "gmt,g22xx-powerkey";
+			status = "disabled";
+		};
+		poweroff_1: poweroff {
+			compatible = "gmt,g22xx-poweroff";
+			system-power-controller;
+			status = "disabled";
+		};
+		regulators_1: regulators {
+			compatible = "anpec,apw8889-regulator";
+			status = "okay";
+		};
+
+	};
+};
+
+&g2237 {
+	regulators {
+		vd33_supp_0: dc1 {
+			regulator-name = "vd33";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3700000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <3200000>;
+			};
+		};
+		gpu_supp_0: dc2 {
+			regulator-name = "gpudvs";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-ramp-delay = <625>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		core_supp_0: dc3 {
+			regulator-name = "core";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <1187500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <900000>;
+			};
+		};
+		ddr_supp_0: dc4 {
+			regulator-name = "ddr";
+			regulator-min-microvolt = <1200000>;
+			regulator-max-microvolt = <1200000>;
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+
+		};
+		vd18_supp_0: dc5 {
+			regulator-name = "vd18";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <2500000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_DC_MODE_AUTO>;
+		};
+		vd25_supp_0: ldo1 {
+			regulator-name = "vd25";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3000000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <G22XX_LDO_MODE_NORMAL>;
+		};
+	};
+};
+
+&apw8889 {
+	regulators {
+		vd33_supp_1: dc1 {
+			regulator-name = "vd33";
+			regulator-min-microvolt = <2200000>;
+			regulator-max-microvolt = <3777500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <3200000>;
+			};
+		};
+		core_supp_1: dc2 {
+			regulator-name = "core";
+			regulator-min-microvolt = <550000>;
+			regulator-max-microvolt = <1337500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-on-in-suspend;
+				regulator-suspend-microvolt = <900000>;
+			};
+		};
+		cpu_supp_1: dc3 {
+			regulator-name = "cpudvs";
+			regulator-min-microvolt = <550000>;
+			regulator-max-microvolt = <1337500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+			regulator-ramp-delay = <625>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		gpu_supp_1: dc4 {
+			regulator-name = "gpudvs";
+			regulator-min-microvolt = <550000>;
+			regulator-max-microvolt = <1337500>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+			regulator-ramp-delay = <625>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+		ddr_supp_1: dc5 {
+			regulator-name = "ddr";
+			regulator-min-microvolt = <1200000>;
+			regulator-max-microvolt = <1200000>;
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+
+
+		};
+		vd18_supp_1: dc6 {
+			regulator-name = "vd18";
+			regulator-min-microvolt = <800000>;
+			regulator-max-microvolt = <2060000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_DC_MODE_AUTO>;
+		};
+		vd25_supp_1: ldo1 {
+			regulator-name = "vd25";
+			regulator-min-microvolt = <1780000>;
+			regulator-max-microvolt = <3020000>;
+
+			regulator-boot-on;
+			regulator-always-on;
+			regulator-initial-mode = <APW8889_LDO_MODE_NORMAL>;
+			regulator-state-mem {
+				regulator-off-in-suspend;
+			};
+		};
+	};
+};
+
+/* CPU nodes */
+&A55_0 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_1 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_2 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_3 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_4 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&A55_5 {
+	clocks = <&cc CC_PLL_SCPU>;
+	cpu-supply = <&cpu_supp>;
+	operating-points-v2 = <&cpu_opps>;
+	#cooling-cells = <2>;
+};
+
+&dvfs {
+	cpu_opps: cpu-opp-table {
+		compatible = "operating-points-v2";
+		opp-shared;
+		opp300: opp-300mhz {
+			opp-hz = /bits/ 64 <300000000>;
+			opp-microvolt = <787500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp400: opp-400mhz {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-microvolt = <787500>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+		opp500: opp-500mhz {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-microvolt = <787500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp600: opp-600mhz {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-microvolt = <787500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp700: opp-700mhz {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-microvolt = <812500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp800: opp-800mhz {
+			opp-hz = /bits/ 64 <800000000>;
+			opp-microvolt    = <850000>;
+			opp-microvolt-tt = <837500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp900: opp-900mhz {
+			opp-hz = /bits/ 64 <900000000>;
+			opp-microvolt    = <900000>;
+			opp-microvolt-tt = <887500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1000: opp-1000mhz {
+			opp-hz = /bits/ 64 <1000000000>;
+			opp-microvolt    = <950000>;
+			opp-microvolt-tt = <937500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1100: opp-1100mhz {
+			opp-hz = /bits/ 64 <1100000000>;
+			opp-microvolt    = <1012500>;
+			opp-microvolt-tt = <987500>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1200: opp-1200mhz {
+			opp-hz = /bits/ 64 <1200000000>;
+			opp-microvolt    = <1062500>;
+			opp-microvolt-tt = <1025000>;
+			clock-latency-ns = <150000>;
+			opp-suspend;
+			status = "okay";
+		};
+		opp1300: opp-1300mhz {
+			opp-hz = /bits/ 64 <1300000000>;
+			opp-microvolt    = <1125000>;
+			opp-microvolt-tt = <1075000>;
+			clock-latency-ns = <150000>;
+			status = "okay";
+		};
+		opp1400: opp-1400mhz {
+			opp-hz = /bits/ 64 <1400000000>;
+			opp-microvolt = <1125000>;
+			clock-latency-ns = <150000>;
+			status = "disabled";
+		};
+	};
+};
+
+&cpu_thermal {
+	trips {
+		tm_alert0: cpu-alert0 {
+			temperature = <105000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+		tm_alert1: cpu-alert1 {
+			temperature = <115000>;
+			hysteresis = <0>;
+			type = "passive";
+		};
+	};
+	cooling-maps {
+		cpu-map0 {
+			trip = <&tm_alert0>;
+			cooling-device = <&A55_0 THERMAL_NO_LIMIT 6>;
+			contribution = <70>;
+		};
+		cpu-map1 {
+			trip = <&tm_alert1>;
+			cooling-device = <&A55_0 7 THERMAL_NO_LIMIT>;
+			contribution = <70>;
+		};
+	};
+};
+
+
+&gpu {
+	mali-supply = <&gpu_supp>;
+	operating-points-v2 = <&gpu_opps>;
+	assigned-clocks = <&cc CC_CLK_GPU>;
+	assigned-clock-rates = <400000000>;
+
+	gpu_opps: gpu-opp-table {
+		compatible = "operating-points-v2",
+			"operating-points-v2-mali";
+
+		opp-1x400 {
+			opp-hz = /bits/ 64 <133000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			opp-core-mask = /bits/ 64 <0x2>;
+		};
+		opp-2x400 {
+			opp-hz = /bits/ 64 <266000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			opp-core-mask = /bits/ 64 <0x1>;
+		};
+		opp-3x400 {
+			opp-hz = /bits/ 64 <400000000>;
+			opp-hz-real = /bits/ 64 <400000000>;
+			opp-microvolt = <1000000>;
+			opp-suspend;
+		};
+		opp-3x500 {
+			opp-hz = /bits/ 64 <500000000>;
+			opp-hz-real = /bits/ 64 <500000000>;
+			opp-microvolt = <1000000>;
+		};
+		opp-3x600 {
+			opp-hz = /bits/ 64 <600000000>;
+			opp-hz-real = /bits/ 64 <600000000>;
+			opp-microvolt = <1000000>;
+		};
+		opp-3x700 {
+			opp-hz = /bits/ 64 <700000000>;
+			opp-hz-real = /bits/ 64 <700000000>;
+			opp-microvolt = <1000000>;
+		};
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-hdmirxEDID.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-hdmirxEDID.dtsi
new file mode 100644
index 00000000..51ee382
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-hdmirxEDID.dtsi
@@ -0,0 +1,45 @@
+/*
+ * rtd-16xx-hdmirxEDID.dtsi - HDMI Rx EDID table for REALTEK 16xx SoC
+ */
+
+/{
+	hdmirx@98034000 {
+		Realtek,edid-table = <
+			0x00 0xFF 0xFF 0xFF 0xFF 0xFF 0xFF 0x00 0x4A 0x8B 0x19 0x16 0x00 0x00 0x00 0x00
+			0xFF 0x1C 0x01 0x03 0x81 0x46 0x27 0x78 0x8A 0xA5 0x8E 0xA6 0x54 0x4A 0x9C 0x26
+			0x12 0x45 0x46 0x21 0x08 0x00 0xD1 0xC0 0x81 0xC0 0x01 0x01 0x01 0x01 0x01 0x01
+			0x01 0x01 0x01 0x01 0x01 0x01 0x02 0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C
+			0x45 0x00 0x20 0xC2 0x31 0x00 0x00 0x1E 0x01 0x1D 0x00 0x72 0x51 0xD0 0x1E 0x20
+			0x6E 0x28 0x55 0x00 0x20 0xC2 0x31 0x00 0x00 0x1E 0x00 0x00 0x00 0xFD 0x00 0x32
+			0x4B 0x18 0x3C 0x0B 0x00 0x0A 0x20 0x20 0x20 0x20 0x20 0x20 0x00 0x00 0x00 0xFC
+			0x00 0x52 0x54 0x44 0x31 0x36 0x31 0x39 0x0A 0x20 0x20 0x20 0x20 0x20 0x01 0x22
+			0x02 0x03 0x32 0x71 0x83 0x2F 0x00 0x00 0x6E 0x03 0x0C 0x00 0x10 0x00 0x00 0x3C
+			0x20 0x00 0x80 0x01 0x02 0x03 0x04 0x49 0x90 0x1F 0x22 0x20 0x05 0x14 0x04 0x11
+			0x02 0x2C 0x0F 0x7F 0x07 0x15 0x07 0x00 0x5F 0x7F 0x00 0x67 0x40 0x00 0xE3 0x05
+			0x03 0x01 0x02 0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C 0x45 0x00 0x20 0xC2
+			0x31 0x00 0x00 0x1E 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x97
+			>;
+
+		Realtek,edid2p0-table = <
+			0x00 0xFF 0xFF 0xFF 0xFF 0xFF 0xFF 0x00 0x4A 0x8B 0x19 0x16 0x00 0x00 0x00 0x00
+			0xFF 0x1C 0x01 0x03 0x81 0x46 0x27 0x78 0x8A 0xA5 0x8E 0xA6 0x54 0x4A 0x9C 0x26
+			0x12 0x45 0x46 0x21 0x08 0x00 0xD1 0xC0 0x81 0xC0 0x01 0x01 0x01 0x01 0x01 0x01
+			0x01 0x01 0x01 0x01 0x01 0x01 0x02 0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C
+			0x45 0x00 0x20 0xC2 0x31 0x00 0x00 0x1E 0x01 0x1D 0x00 0x72 0x51 0xD0 0x1E 0x20
+			0x6E 0x28 0x55 0x00 0x20 0xC2 0x31 0x00 0x00 0x1E 0x00 0x00 0x00 0xFD 0x00 0x32
+			0x4B 0x18 0x3C 0x0B 0x00 0x0A 0x20 0x20 0x20 0x20 0x20 0x20 0x00 0x00 0x00 0xFC
+			0x00 0x52 0x54 0x44 0x31 0x36 0x31 0x39 0x0A 0x20 0x20 0x20 0x20 0x20 0x01 0x22
+			0x02 0x03 0x43 0x71 0x83 0x2F 0x00 0x00 0x6E 0x03 0x0C 0x00 0x10 0x00 0x00 0x3C
+			0x20 0x00 0x80 0x01 0x02 0x03 0x04 0x67 0xD8 0x5D 0xC4 0x01 0x77 0x80 0x00 0x4F
+			0x5D 0x5E 0x5F 0x60 0x61 0x62 0x90 0x1F 0x22 0x20 0x05 0x14 0x04 0x11 0x02 0xE2
+			0x0F 0x18 0x2C 0x0F 0x7F 0x07 0x15 0x07 0x00 0x5F 0x7F 0x00 0x67 0x40 0x00 0xE3
+			0x05 0x03 0x01 0x02 0x3A 0x80 0x18 0x71 0x38 0x2D 0x40 0x58 0x2C 0x45 0x00 0x20
+			0xC2 0x31 0x00 0x00 0x1E 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00
+			0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0xE2
+		>;
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-pcie.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-pcie.dtsi
new file mode 100644
index 00000000..e38d7fe
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-pcie.dtsi
@@ -0,0 +1,193 @@
+/ {
+	pcie: pcie@98060000 {
+		compatible = "realtek,rtk16xx-pcie-slot1";
+		reg = <0x0 0x98060000 0x0 0x00001000
+		       0x0 0x98061000 0x0 0x00001000
+		       0x0 0x9801C800 0x0 0x00000100
+		       0x0 0x9801A000 0x0 0x00000300>;
+		interrupt-names = "rtk-pcie1-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic 0 0 GIC_SPI 61 IRQ_TYPE_LEVEL_HIGH>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins_0>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <0>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 29 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys =<0x00000003>,
+		<0x40080001>,
+		<0x2E000701>,
+		<0x35910801>,
+		<0x521C0901>,
+		<0x7C421901>,
+		<0x00011C01>,
+		<0x32001D01>,
+		<0x20EB1E01>,
+		<0xF8001F01>,
+		<0x3D402A01>,
+		<0x81BD2F01>,
+		<0x52F50401>,
+		<0x27E90301>,
+		<0xead70501>,
+		<0x00080601>,
+		<0xB6730a01>,
+		<0x84552001>,
+		<0x55552101>,
+		<0xA85C0101>,
+		<0x60420201>,
+		<0xAB632301>,
+		<0x080C2401>,
+		<0xa8032b01>,
+		<0x80A11B01>,
+		<0x27e94301>,
+		<0x52f54401>,
+		<0xead74501>,
+		<0x00064601>,
+		<0x86734a01>,
+		<0x84666001>,
+		<0x55AA6101>,
+		<0xa84a4101>,
+		<0x60424201>,
+		<0xAB636301>,
+		<0x08106401>,
+		<0xa8036b01>,
+		<0xf8022801>,
+		<0xf8026801>,
+		<0x69050B01>,
+		<0x69054B01>,
+		<0xC0080C01>,
+		<0xC0084C01>,
+		<0xF7060D01>,
+		<0xF7064D01>,
+		<0x10000E01>,
+		<0x10004E01>,
+		<0x720C0901>,
+		<0x700C0901>,
+		<0x720C0901>,
+		<0x720C4901>,
+		<0x700C4901>,
+		<0x720C4901>;
+
+		speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x98062000 0x0 0x98062000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00030000 0x0 0x00030000 0x00000000 0x00010000>;
+		resets = <&crst RSTN_PCIE0>,
+			<&crst RSTN_PCIE0_CORE>,
+			<&crst RSTN_PCIE0_POWER>,
+			<&crst RSTN_PCIE0_NONSTITCH>,
+			<&crst RSTN_PCIE0_STITCH>,
+			<&crst RSTN_PCIE0_PHY>,
+			<&crst RSTN_PCIE0_PHY_MDIO>,
+			<&crst RSTN_PCIE0_SGMII_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio",
+			"sgmii_mdio";
+		clocks = <&clk_en_1 CLK_EN_PCIE0>;
+		status = "okay";
+	};
+
+	pcie2: pcie2@980A0000 {
+		compatible = "realtek,rtk16xx-pcie-slot2";
+		reg = <0x0 0x980A0000 0x0 0x00001000
+		       0x0 0x980A1000 0x0 0x00001000
+		       0x0 0x9801C600 0x0 0x00000100
+		       0x0 0x9804F000 0x0 0x00000100>;
+		interrupt-names = "rtk-pcie2-intr";
+		#interrupt-cells = <1>;
+		interrupt-map-mask = <0 0 0 0>;
+		interrupt-map = <0 0 0 0 &gic 0 0 GIC_SPI 62 IRQ_TYPE_LEVEL_HIGH>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pcie_clk_pins_1>;
+		bus-range = <0x00 0xff>;
+		linux,pci-domain = <1>;
+		device_type = "pci";
+		gpios = <&rtk_iso_gpio 65 1 0 >;
+		#size-cells = <2>;
+		#address-cells = <3>;
+		num-lanes = <1>;
+		phys =<0x00000003>,
+		<0x40080001>,
+		<0x2E000701>,
+		<0x35910801>,
+		<0x521C0901>,
+		<0x7C421901>,
+		<0x00011C01>,
+		<0x32001D01>,
+		<0x20EB1E01>,
+		<0xF8001F01>,
+		<0x3D402A01>,
+		<0x81BD2F01>,
+		<0x52F50401>,
+		<0x27E90301>,
+		<0xead70501>,
+		<0x00080601>,
+		<0xB6730a01>,
+		<0x84552001>,
+		<0x55552101>,
+		<0xA85C0101>,
+		<0x60420201>,
+		<0xAB632301>,
+		<0x080C2401>,
+		<0xa8032b01>,
+		<0x80A11B01>,
+		<0x27e94301>,
+		<0x52f54401>,
+		<0xead74501>,
+		<0x00064601>,
+		<0x86734a01>,
+		<0x84666001>,
+		<0x55AA6101>,
+		<0xa84a4101>,
+		<0x60424201>,
+		<0xAB636301>,
+		<0x08106401>,
+		<0xa8036b01>,
+		<0xf8022801>,
+		<0xf8026801>,
+		<0x69050B01>,
+		<0x69054B01>,
+		<0xC0080C01>,
+		<0xC0084C01>,
+		<0xF7060D01>,
+		<0xF7064D01>,
+		<0x10000E01>,
+		<0x10004E01>,
+		<0x720C0901>,
+		<0x700C0901>,
+		<0x720C0901>,
+		<0x720C4901>,
+		<0x700C4901>,
+		<0x720C4901>;
+
+		speed-mode = <1>; // 0:GEN1, 1:GEN2
+		ranges = <0x02000000 0x00000000 0x980A2000 0x0 0x980A2000 0x00000000 0x0001E000
+			0x01000000 0x00000000 0x00040000 0x0 0x00040000 0x00000000 0x00010000>;
+		resets = <&crst RSTN_PCIE1>,
+			<&crst RSTN_PCIE1_CORE>,
+			<&crst RSTN_PCIE1_POWER>,
+			<&crst RSTN_PCIE1_NONSTITCH>,
+			<&crst RSTN_PCIE1_STITCH>,
+			<&crst RSTN_PCIE1_PHY>,
+			<&crst RSTN_PCIE1_PHY_MDIO>;
+
+		reset-names = "rstn",
+			"core",
+			"power",
+			"nonstitch",
+			"stitch",
+			"phy",
+			"phy_mdio";
+		clocks = <&clk_en_4 CLK_EN_PCIE1>;
+		status = "disabled";
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-pinctrl.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-pinctrl.dtsi
new file mode 100644
index 00000000..cf95e2d
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-pinctrl.dtsi
@@ -0,0 +1,492 @@
+
+/ {
+	pinctrl@9804E000 {
+		sdcard_pins_low: sdcard_low {
+			realtek,pins= "sd3_data_3",
+			"sd3_data_2",
+			"sd3_data_1",
+			"sd3_data_0",
+			"sd3_clk",
+			"sd3_cmd";
+			realtek,function="sd";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <0>;
+		};
+
+		sdcard_pins_high: sdcard_high {
+			realtek,pins="gpio_35", "gpio_34";
+			realtek,function="mmc";
+			realtek,pull_en = <1>;
+			realtek,pull_sel = <1>;
+		};
+
+		sdio_pins_0: sdio_pins_0 {
+			realtek,pins= "sd3_data_3",
+			"sd3_data_2",
+			"sd3_data_1",
+			"sd3_data_0",
+			"sd3_clk",
+			"sd3_cmd",
+			"sdio_loc";
+			realtek,function = "sdio_loc0";
+		};
+
+		sdio_pins_1: sdio_pins_1 {
+			realtek,pins = "gpio_40",
+			"gpio_41",
+			"gpio_42",
+			"gpio_43",
+			"gpio_44",
+			"gpio_45",
+			"sdio_loc";
+			realtek,function = "sdio_loc1";
+		};
+
+
+		uart0_pins: uart0_pins {
+			realtek,pins = "ur0_rx",
+			"ur0_tx";
+			realtek,function = "uart0";
+		};
+
+		uart1_pins: uart1_pins {
+			realtek,pins = "gpio_8",
+			"gpio_9";
+			realtek,function = "uart1";
+		};
+
+		uart2_pins_0: uart2_pins_0 {
+			realtek,pins = "ur2_loc",
+			"gpio_2",
+			"gpio_3";
+			realtek,function = "uart2_loc0";
+		};
+
+		uart2_pins_1: uart2_pins_1 {
+			realtek,pins ="ur2_loc",
+			"gpio_25",
+			"gpio_26",
+			"gpio_27",
+			"gpiio_28";
+			realtek,function = "uart2_loc1";
+		};
+
+		i2c_pins_0: i2c_pins_0 {
+			realtek,pins = "gpio_12",
+			"gpio_13";
+			realtek,function = "i2c0";
+			realtek,drive = <4>;
+		};
+
+		i2c_pins_0_HS: i2c_pins_0_HS {
+			realtek,pins = "gpio_12",
+			"gpio_13";
+			realtek,function = "i2c0";
+			realtek,drive = <8>;
+		};
+
+		i2c_pins_1: i2c_pins_1 {
+			realtek,pins = "gpio_16",
+			"gpio_17";
+			realtek,function = "i2c1";
+		};
+
+		i2c_pins_2: i2c_pins_2 {
+			realtek,pins = "gpio_18",
+			"gpio_19";
+			realtek,function = "i2c2";
+		};
+
+		i2c_pins_3: i2c_pins_3 {
+			realtek,pins = "gpio_34",
+			"gpio_35";
+			realtek,function = "i2c3";
+		};
+
+		i2c_pins_4: i2c_pins_4 {
+			realtek,pins = "gpio_83",
+			"gpio_84";
+			realtek,function = "i2c4";
+		};
+
+		i2c_pins_5: i2c_pins_5 {
+			realtek,pins = "gpio_5",
+			"gpio_6";
+			realtek,function = "i2c5";
+		};
+
+		spi_pins_enable: spi-pins-enable {
+			realtek,pins = "sf_en";
+			realtek,function = "sf_enable";
+		};
+
+		spi_pins_loc_spi: spi_pins_loc_spi {
+			realtek,pins = "gpio_25",
+			"gpio_26",
+			"gpio_27",
+			"gpio_28";
+			realtek,function = "spi";
+		};
+
+		gspi_pins_0: gspi_pins_0 {
+			realtek,pins = "gspi_loc",
+			"gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5";
+			realtek,function = "gspi_loc0";
+		};
+
+		gspi_pins_1: gspi_pins_1 {
+			realtek,pins = "gspi_loc",
+			"gpio_25",
+			"gpio_26",
+			"gpio_27",
+			"gpio_28";
+			realtek,function = "gspi_loc1";
+		};
+
+		smartcard_pins_0:smartcard_pins_0{
+			realtek,pins = "gpio_59",
+			"gpio_60",
+			"gpio_61",
+			"gpio_62";
+			realtek,function = "sc0";
+		};
+
+		smartcard_pins_1:smartcard_pins_1{
+			realtek,pins = "sd3_cmd",
+			"sd3_clk",
+			"sd3_data_0",
+			"sd3_data_1";
+			realtek,function = "sc1";
+		};
+
+		tp0_loc_tp0_pins: tp0_loc_tp0_pins {
+			realtek,pins = "tp_sync",
+			"tp_valid",
+			"tp_clk",
+			"tp_data_0",
+			"tp_data_1",
+			"tp_data_2",
+			"tp_data_3",
+			"tp_data_4",
+			"tp_data_5",
+			"tp_data_6",
+			"tp_data_7";
+			realtek,function = "tp0";
+		};
+
+		tp1_loc_tp1_pins: tp1_loc_tp1_pins {
+			realtek,pins = "tp_data_1",
+			"tp_data_2",
+			"tp_data_3",
+			"tp_data_4";
+			realtek,function = "tp1";
+		};
+
+		ao_pins: ao_pins {
+			realtek,pins =
+				"tp_data_1",
+				"tp_data_2",
+				"tp_data_3",
+				"tp_data_4",
+				"tp_data_5",
+				"tp_data_6",
+				"tp_data_7";
+			realtek,function = "ao";
+		};
+
+		ir_rx_pins: ir_rx_pins {
+			realtek,pins = "ir_rx";
+			realtek,function = "ir_rx";
+		};
+
+		spdif_pins: spdif_pins {
+			realtek,pins = "gpio_50";
+			realtek,function = "spdif";
+		};
+
+		spdif_optical_pins: spdif_optical_pins {
+			realtek,pins = "gpio_21", "gpio_68", "gpio_85";
+			realtek,function = "spdif";
+			realtek,pull_en =  <0>;
+		};
+
+		ai_loc0_pins: ai_loc0_pins {
+			realtek,pins = "gpio_59",
+				"gpio_60",
+				"gpio_61",
+				"gpio_62",
+				"tp_sync",
+				"tp_valid",
+				"tp_clk";
+			realtek,function = "ai_loc0";
+		};
+
+		ai_loc1_pins: ai_loc1_pins {
+			realtek,pins = "gpio_40",
+				"gpio_41",
+				"gpio_42",
+				"gpio_43",
+				"gpio_44",
+				"gpio_45",
+				"gpio_57";
+			realtek,function = "ai_loc1";
+		};
+
+		dmic_loc0_pins: dmic_loc0_pins {
+			realtek,pins = "dmic_loc",
+				"gpio_59",
+				"gpio_60",
+				"gpio_61",
+				"gpio_62",
+				"tp_sync",
+				"tp_valid",
+				"tp_clk",
+				"tp_data_0";
+			realtek,function = "dmic_loc0";
+		};
+
+		dmic_loc1_pins: dmic_loc1_pins {
+			realtek,pins = "dmic_loc",
+				"gpio_40",
+				"gpio_41",
+				"gpio_42",
+				"gpio_43",
+				"gpio_44",
+				"gpio_45",
+				"gpio_57",
+				"gpio_58";
+			realtek,function = "dmic_loc1";
+		};
+
+		tdm_loc0_pins: tdm_loc0_pins {
+			realtek,pins =
+				"tp_sync",
+				"tp_valid",
+				"tp_clk",
+				"tp_data_0";
+			realtek,function = "tdm_ai_loc0";
+		};
+
+		tdm_dmic_loc0_pins:  tdm_dmic_loc0_pins {
+			realtek,pins = "dmic_loc";
+			realtek,function = "dmic_loc0";
+		};
+
+		tdm_loc1_pins: tdm_loc1_pins {
+			realtek,pins =
+				"gpio_40",
+				"gpio_41",
+				"gpio_42",
+				"gpio_43";
+			realtek,function = "tdm_ai_loc1";
+		};
+
+		tdm_dmic_loc1_pins:  tdm_dmic_loc1_pins {
+			realtek,pins = "dmic_loc";
+			realtek,function = "dmic_loc1";
+		};
+
+		/*i2s_out_4pins: i2s_out_4pins {
+			realtek,pins ="tp_data_1",
+			"tp_data_2",
+			"tp_data_3",
+			"tp_data_4";
+			realtek,function = "ao";
+		};*/
+
+		/*i2s_in_pins: i2s_in_pins {
+			realtek,pins = "gpio_6";
+			realtek,function = "ai";
+		};*/
+
+		etn_led_pins: etn_led_pins {
+			realtek,pins = "gpio_14",
+			"gpio_15",
+			"gpio_51";
+			realtek,function = "etn_led";
+		};
+
+		sgmii_mdio_pins: sgmii_mdio_pins {
+			realtek,pins = "gpio_29",
+			"gpio_46";
+			realtek,function = "extphy";
+		};
+
+		pcie_clk_pins_0: pcie_clk_pins_0 {
+			realtek,pins = "gpio_46";
+			realtek,function = "pcie0";
+		};
+
+		pcie_clk_pins_1: pcie_clk_pins_1 {
+			realtek,pins = "gpio_66";
+			realtek,function = "pcie1";
+		};
+
+		scpu_ejtag_pins_loc_0: scpu_ejtag_pins_loc_0 {
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5",
+			"gpio_6",
+			"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc0";
+		};
+
+		scpu_ejtag_pins_loc_1: scpu_ejtag_pins_loc_1 {
+			realtek,pins = "sd3_cmd",
+			"sd3_data_0",
+			"sd3_data_1",
+			"sd3_data_3",
+			"ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_loc1";
+		};
+
+		scpu_ejtag_pins_disable: scpu_ejtag_pins_disable {
+			realtek,pins = "ejtag_scpu_loc";
+			realtek,function = "scpu_ejtag_disable";
+		};
+
+		lx_ejtag_pins_loc_0: lx_ejtag_pins_loc_0 {
+			realtek,pins = "gpio_2",
+			"gpio_3",
+			"gpio_4",
+			"gpio_5",
+			"gpio_6",
+			"ejtag_avcpu_loc";
+			realtek,function = "lx_ejtag_loc0";
+		};
+
+		acpu_ejtag_pins_loc_1: acpu_ejtag_pins_loc_1 {
+			realtek,pins = "sd3_cmd",
+			"sd3_clk",
+			"sd3_data_0",
+			"sd3_data_1",
+			"sd3_data_3",
+			"ejtag_avcpu_loc";
+			realtek,function = "lx_ejtag_loc1";
+		};
+
+		acpu_ejtag_pins_disable:acpu_ejtag_pins_disable{
+			realtek,pins = "ejtag_avcpu_loc";
+			realtek,function = "lx_ejtag_disable";
+		};
+		dc_fan_sensor_pins: dc_fan_sensor_pins {
+			realtek,pins = "gpio_47";
+			realtek,function = "dc_fan_sensor";
+		};
+
+		pwm0_0_pins: pwm0_0_pins {
+			realtek,pins = "gpio_12";
+			realtek,function = "pwm0";
+		};
+
+		pwm0_1_pins: pwm0_1_pins {
+			realtek,pins = "gpio_20";
+			realtek,function = "pwm0";
+		};
+
+		pwm1_0_pins: pwm1_0_pins {
+			realtek,pins = "gpio_13";
+			realtek,function = "pwm1";
+		};
+
+		pwm1_1_pins: pwm1_1_pins {
+			realtek,pins = "gpio_21";
+			realtek,function = "pwm1";
+		};
+
+		pwm2_0_pins: pwm2_0_pins {
+			realtek,pins = "gpio_14";
+			realtek,function = "pwm2";
+		};
+
+		pwm2_1_pins: pwm2_1_pins {
+			realtek,pins = "gpio_22";
+			realtek,function = "pwm2";
+		};
+
+		pwm3_0_pins: pwm3_0_pins {
+			realtek,pins = "gpio_15";
+			realtek,function = "pwm3";
+		};
+
+		pwm3_1_pins: pwm3_1_pins {
+			realtek,pins = "gpio_23";
+			realtek,function = "pwm3";
+		};
+
+		pwm0_0_pins_disable: pwm0_0_pins_disable {
+			realtek,pins = "gpio_12";
+			realtek,function = "gpio";
+		};
+
+		pwm0_1_pins_disable: pwm0_1_pins_disable {
+			realtek,pins = "gpio_20";
+			realtek,function = "gpio";
+		};
+
+		pwm1_0_pins_disable: pwm1_0_pins_disable {
+			realtek,pins = "gpio_13";
+			realtek,function = "gpio";
+		};
+
+		pwm1_1_pins_disable: pwm1_1_pins_disable {
+			realtek,pins = "gpio_21";
+			realtek,function = "gpio";
+		};
+
+		pwm2_0_pins_disable: pwm2_0_pins_disable {
+			realtek,pins = "gpio_14";
+			realtek,function = "gpio";
+		};
+
+		pwm2_1_pins_disable: pwm2_1_pins_disable {
+			realtek,pins = "gpio_22";
+			realtek,function = "gpio";
+		};
+
+		pwm3_0_pins_disable: pwm3_0_pins_disable {
+			realtek,pins = "gpio_15";
+			realtek,function = "gpio";
+		};
+
+		pwm3_1_pins_disable: pwm3_1_pins_disable {
+			realtek,pins = "gpio_23";
+			realtek,function = "gpio";
+		};
+
+		usb_cc1_pins: usb_cc1_pins {
+			realtek,pins = "usb_cc1";
+			realtek,function = "usb_cc1";
+		};
+
+		usb_cc2_pins: usb_cc2_pins {
+			realtek,pins = "usb_cc2";
+			realtek,function = "usb_cc2";
+		};
+
+		demod_pins: demod-pins {
+			realtek,pins = "demod_agc";
+			realtek,function = "qam_agc_if";
+		};
+
+		/*rtc_pins: rtc_pins {
+			realtek,pins = "gpio_25";
+			realtek,function = "rtc";
+		};*/
+
+		/*prob0_pins: prob0_pins{
+			realtek,pins = "prob_0";
+	        realtek,function = "gpio";
+		};
+
+		prob1_pins: prob1_pins{
+	        realtek,pins = "prob_1";
+	        realtek,function = "gpio";
+		};*/
+	};
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-psci.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-psci.dtsi
new file mode 100755
index 00000000..6553aa7
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-psci.dtsi
@@ -0,0 +1,26 @@
+#include "rtd-16xx.dtsi"
+
+&A55_0 {
+	enable-method = "psci";
+};
+&A55_1 {
+	enable-method = "psci";
+	/delete-property/ cpu-release-addr;
+};
+&A55_2 {
+	enable-method = "psci";
+	/delete-property/ cpu-release-addr;
+};
+&A55_3 {
+	enable-method = "psci";
+	/delete-property/ cpu-release-addr;
+};
+&A55_4 {
+	enable-method = "psci";
+	/delete-property/ cpu-release-addr;
+};
+&A55_5 {
+	enable-method = "psci";
+	/delete-property/ cpu-release-addr;
+};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-sata.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-sata.dtsi
new file mode 100644
index 00000000..b6dff98
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-sata.dtsi
@@ -0,0 +1,19 @@
+/* PLEASE include this file inside a node */
+	sata_phy: sata_phy@9803FF60 {
+		compatible = "Realtek,rtk-sata-phy";
+		reg = <0x0 0x9803FF00 0x0 0x100>,
+			<0x0 0x9804f050 0x0 0x10>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		#phy-cells = <1>;
+		status = "okay";
+	};
+
+	ahci_sata: sata@9803F000 {
+		compatible = "Realtek,ahci-sata";
+		reg = <0x0 0x9803F000 0x0 0x1000>;
+		interrupts = <0 49 4>;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <0>;
+	};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-usb.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-usb.dtsi
new file mode 100644
index 00000000..c725d96
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx-usb.dtsi
@@ -0,0 +1,358 @@
+/*
+ * realtek,port0-power-gpio: drd type_C power, output, default low
+ * realtek,port1-power-gpio: u2host power, output, default low
+ * realtek,port2-power-gpio: u3host power, output, default low
+ *
+ * usb_iso_mode: ISO mode is only port suspend (Default disable)
+ * usb_power_cut: Non ISO mode and power cut (Default disable power cut)
+ * Note if enable ISO mode, then power_cut will not effective
+ */
+
+	rtk_usb_power_manager@0 {
+		compatible = "Realtek,usb-manager";
+		reg = <0x0 0x98000000 0x0 0x10>;
+
+		//usb_iso_mode;  /* ISO mode is only port suspend (Default disable) */
+		//en_usb_storage_reprobe; /* To enable usb storage re-probe*/
+		//rescue_usb; /* For rescue dtb use */
+
+		clocks = <&iso_clk_en 16>, /* clk_en_usb */
+			<&iso_clk_en 13>,  /* clk_en_usb_drd (port0 phy to drd clock) */
+			<&iso_clk_en 14>,  /* clk_en_usb_host0 (port1 phy to u2host clock) */
+			<&iso_clk_en 15>;  /* clk_en_usb_host1 (port2 phy to u3host clock) */
+		clock-names = "clk_en_usb", /*clk_en_usb*/
+			"clk_en_phy0_to_host", /*clk_en_usb_drd (port0 phy to drd clock) */
+			"clk_en_phy1_to_host", /*clk_en_usb_u2host (port1 phy to u2host clock */
+			"clk_en_phy2_to_host"; /*clk_en_usb_u3host (port2 phy to u3host clock */
+
+		resets =
+			<&iso_asrst 0x100>,
+			<&iso_rst 14>, /* rstn_usb_drd */
+			<&iso_rst 15>, /* rstn_usb_host */
+			<&iso_asrst 16>, /* rstn_usb_phy0 */
+			<&iso_asrst 17>, /* rstn_usb_phy1 */
+			<&iso_asrst 18>, /* rstn_usb_phy2 */
+			<&iso_rst 19>, /* rstn_usb */
+			<&iso_rst 20>, /* rstn_usb */
+			<&iso_rst 21>, /* rstn_usb_u3host */
+			<&iso_rst 22>, /* rstn_usb3_phy0 */
+			<&iso_rst 23>, /* rstn_usb3_phy0_mdio */
+			<&iso_rst 24>, /* rstn_usb3_phy1 */
+			<&iso_rst 25>; /* rstn_usb3_phy1_mdio */
+
+		reset-names = "apply",
+			"usb_host0", /*rstn_usb_drd*/
+			"usb_host1", /*rstn_usb_u2host*/
+			"u2phy0", /*rstn_usb_phy0*/
+			"u2phy1", /*rstn_usb_phy1*/
+			"u2phy2", /*rstn_usb_phy2*/
+			"usb", /*rstn_usb*/
+			"type_c", /*rstn_type_c*/
+			"usb_host2", /*rstn_usb_u3host*/
+			"u3phy0", /*rstn_usb3_phy0*/
+			"u3mdio0", /*rstn_usb3_phy0_mdio*/
+			"u3phy1", /*rstn_usb3_phy1*/
+			"u3mdio1"; /*rstn_usb3_phy1_mdio*/
+
+		gpio0: gpio0 {
+			realtek,power-gpio = <&rtk_iso_gpio 57 1 3>;
+			//power_low_active; /* type c use high active */
+
+		};
+		gpio1: gpio1 {
+			realtek,power-gpio = <&rtk_iso_gpio 48 1 3>;
+			power_low_active;
+
+		};
+		gpio2: gpio2 {
+			realtek,power-gpio = <&rtk_iso_gpio 49 1 3>;
+			power_low_active;
+		};
+
+		port0 {
+			usb = <&dwc3_drd>;
+			type_c = <&dwc3_type_c>; /* for port 0 type c driver */
+			gpio = <&gpio0>;
+		};
+		port1 {
+			usb = <&dwc3_u2host>;
+			gpio = <&gpio1>;
+		};
+		port2 {
+			usb = <&dwc3_u3host>;
+			gpio = <&gpio2>;
+		};
+
+		rtk_usb {
+			power_ctrl_reg {
+				/* l4_icg */
+				p0_l4_icg = <0x98013364>;
+				p1_l4_icg = <0x98013d60>;
+				p2_l4_icg = <0x98013f60>;
+
+				usb_power_cut; /* Non ISO mode and power cut (Default disable power cut) */
+				               /* Note if enable ISO mode, then power_cut will not effective*/
+			};
+			type_c {
+				drd_wrap_base = <0x98013200>;
+				u3host_wrap_base = <0x98013e00>;
+				drd_u3_portsc = <0x98020430>;
+				drd_u3_sus_en = <0x980282c0>;
+				u3host_u3_sus_en = <0x980582c0>;
+			};
+		};
+	};
+
+	dwc3_drd_usb3phy: dwc3_drd_usb3phy@0 {
+		compatible = "Realtek,usb3phy";
+		reg = <0x0 0x98013210 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		phyN = <1>;
+		phy0 {
+			phy_data_size = <0x30>;
+			phy_data_addr = /bits/ 8
+				<0x00 0x01 0x02 0x03 0x04 0x05 0x06
+				0x07 0x08 0x09 0x0A 0x0B 0x0C 0x0D
+				0x0E 0x0F 0x10 0x11 0x12 0x13 0x14
+				0x15 0x16 0x17 0x18 0x19 0x1A 0x1B
+				0x1C 0x1D 0x1E 0x1F 0x20 0x21 0x22
+				0x23 0x24 0x25 0x26 0x27 0x28 0x29
+				0x2A 0x2B 0x2C 0x2D 0x2E 0x2F>;
+			phy_data_revA = /bits/ 16
+				<0x400C 0xAC43 0x6042 0x2771 0x72F5 0x2AD3 0x0006
+				 0x2E00 0x3591 0x565C 0x8608 0xAB05 0xC000 0xF70A
+				 0x2000 0x8D50 0x000C 0x4C10 0xFC00 0x0C81 0xDE01
+				 0x0000 0x0000 0x0000 0x0000 0x6020 0x0085 0x2014
+				 0xC900 0xA03F 0xC2E0 0xA000 0x403A 0x88AA 0x0053
+				 0xBB66 0x00E0 0x1260 0x840B 0x01D6 0xF842 0xff00
+				 0x3040 0x8028 0xFFFF 0xFFFF 0x0000 0x8635>;
+			do_toggle;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_drd_usb2phy: dwc3_drd_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98028280 0x0 0x4>, <0x0 0x98013214 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x68 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_drd: rtk_dwc3_drd@98013200 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013200 0x0 0x200>;
+		interrupts = <0 21 4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "okay";
+
+		dwc3_drd@98020000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98020000 0x0 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_drd_usb2phy &dwc3_drd_usb3phy>;
+			dr_mode = "peripheral"; /*otg, host, peripheral*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_u3_susphy_quirk; // DRD port is recommended disable suspend by specification
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+		};
+
+		dwc3_type_c: rtk_dwc3_drd_type_c@0 {
+			compatible = "Realtek,dwc3-type_c";
+			reg = <0x0 0x98013200 0x0 0x200>,  <0x0 0x98007220 0x0 0x20>;
+			interrupts = <0 60 4>;
+			drd_mode;  /*depend on dwc3 dr_mode = "peripheral"*/
+			//debug; /*to enable debug log*/
+			delay_probe_work; /*To delay probe work*/
+			ordered_probe; /*ordered probe in delay work*/
+			boot_check_time = <(-1)>; /*ms (At boot Device switch Host time)*/
+
+			default_revision = <0xA00>;
+			A00 {
+				cc_dfp_mode = "dfp_3_0"; /*dfp_3_0, dfp_1_5, dfp_usb*/
+				rd_config = "internal"; /*internal, extrenal*/
+				cc1_rp_4p7k_code = <0xC>;
+				cc1_rp_36k_code = <0xF>;
+				cc1_rp_12k_code = <0xE>;
+				cc1_rd_code = <0x11>; /*for internal rd*/
+				cc1_vref_ufp = /bits/ 8
+					<0x7 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc1_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc1_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc1_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+				cc2_rp_4p7k_code = <0xC>;
+				cc2_rp_36k_code = <0xF>;
+				cc2_rp_12k_code = <0xE>;
+				cc2_rd_code = <0xF>; /*for internal rd*/
+				cc2_vref_ufp = /bits/ 8
+					<0x8 0xA 0x2>; /*<1p23v,0p66v,0p2v>*/
+				cc2_vref_dfp_usb = /bits/ 8
+					<0x7 0x2 0x0>; /*<0_1p6v,0p2v,unused>*/
+				cc2_vref_dfp_1_5 = /bits/ 8
+					<0x7 0x3 0x2>; /*<1_1p6v,0p4v,0p2v>*/
+				cc2_vref_dfp_3_0 = /bits/ 8
+					<0x5 0xA 0x2>; /*<2p6v,0p8v,0p2v>*/
+			};
+		};
+	};
+
+	dwc3_u2host_usb2phy: dwc3_u2host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98031280 0x0 0x4>, <0x0 0x98013C14 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x67 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u2host: rtk_dwc3_u2host@98013C00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013C00 0x0 0x200>;
+		interrupts = <0 21 4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		status = "okay";
+
+		dwc3_u2host@98029000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98029000 0x0 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_u2host_usb2phy>;
+			dr_mode = "host"; /*only host*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+		};
+	};
+
+	dwc3_u3host_usb3phy: dwc3_u3host_usb3phy@0 {
+		compatible = "Realtek,usb3phy";
+		reg = <0x0 0x98013E10 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "okay";
+		phyN = <1>;
+		phy0 {
+			phy_data_size = <0x30>;
+			phy_data_addr = /bits/ 8
+				<0x00 0x01 0x02 0x03 0x04 0x05 0x06
+				0x07 0x08 0x09 0x0A 0x0B 0x0C 0x0D
+				0x0E 0x0F 0x10 0x11 0x12 0x13 0x14
+				0x15 0x16 0x17 0x18 0x19 0x1A 0x1B
+				0x1C 0x1D 0x1E 0x1F 0x20 0x21 0x22
+				0x23 0x24 0x25 0x26 0x27 0x28 0x29
+				0x2A 0x2B 0x2C 0x2D 0x2E 0x2F>;
+			phy_data_revA = /bits/ 16
+				<0x400C 0xAC43 0x6042 0x2771 0x72F5 0x2AD3 0x0006
+				 0x2E00 0x3591 0x565C 0x8608 0xAB05 0xC000 0xF70A
+				 0x2000 0x8D50 0x000C 0x4C10 0xFC00 0x0C81 0xDE01
+				 0x0000 0x0000 0x0000 0x0000 0x6020 0x0085 0x2014
+				 0xC900 0xA03F 0xC2E0 0xA000 0x403A 0x88AA 0x0053
+				 0xBB66 0x00E0 0x1260 0x840B 0x01D6 0xF842 0xff00
+				 0x3040 0x8028 0xFFFF 0xFFFF 0x0000 0x8635>;
+			do_toggle;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u3host_usb2phy: dwc3_u3host_usb2phy@0 {
+		compatible = "Realtek,usb2phy";
+		reg = <0x0 0x98058280 0x0 0x4>, <0x0 0x98013E14 0x0 0x4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		status = "okay";
+		phyN = <1>;
+		phy0 {
+			phy_data_page0_size = <16>;
+			phy_data_page0_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7 0xF0 0xF1
+				0xF2 0xF3 0xF4 0xF5 0xF6 0xF7>;
+			phy_data_page0_data = /bits/ 8
+				<0xE0 0x30 0x79 0x8D 0x6B 0x65 0x01 0xF1 0xFC 0x8C
+				0x00 0x11 0x9B 0x00 0x00 0x02>;
+			phy_data_page1_size = <8>;
+			phy_data_page1_addr = /bits/ 8
+				<0xE0 0xE1 0xE2 0xE3 0xE4 0xE5 0xE6 0xE7>;
+			phy_data_page1_data = /bits/ 8
+				<0x25 0xEF 0x60 0x48 0x00 0x0F 0x18 0xE3>;
+			do_toggle;
+			//check_efuse;
+			//use_default_parameter;
+		};
+	};
+
+	dwc3_u3host: rtk_dwc3_u3host@98013E00 {
+		compatible = "Realtek,dwc3";
+		reg = <0x0 0x98013E00 0x0 0x200>;
+		interrupts = <0 21 4>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		delay_probe_work; //To delay probe work
+		ordered_probe; // ordered probe in delay work
+		dis_u3_port; // Disable usb 3.0 port
+		status = "okay";
+
+		dwc3_u3host@981F0000 {
+			compatible = "synopsys,dwc3";
+			reg = <0x0 0x98050000 0x0 0x9000>;
+			interrupts = <0 21 4>;
+			usb-phy = <&dwc3_u3host_usb2phy &dwc3_u3host_usb3phy>;
+			dr_mode = "host"; /*only host*/
+			//tx-fifo-resize;
+			//snps,dis_u2_susphy_quirk; // Add workaround for Usb3.0 hub suspend
+			snps,dis_u3_susphy_quirk;
+			snps,dis_ss_park_mode; // disable usb3.0 park mode
+		};
+	};
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx.dtsi
new file mode 100644
index 00000000..aaa544b
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/rtd-16xx.dtsi
@@ -0,0 +1,1238 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+#include <dt-bindings/clock/rtk,clock-rtd16xx.h>
+#include <dt-bindings/reset/rtk,reset-rtd16xx.h>
+#include <dt-bindings/power/rtk,power-rtd16xx.h>
+/include/ "rtd-16xx-pinctrl.dtsi"
+/include/ "rtd-16xx-hdmirxEDID.dtsi"
+
+/{
+	compatible = "realtek,rtd1619";
+	interrupt-parent = <&gic>;
+	#address-cells = <0x2>;
+	#size-cells = <0x2>;
+
+	aliases {
+		serial0 = &uart0;
+		i2c0 = &i2c_0;
+		i2c1 = &i2c_1;
+		i2c3 = &i2c_3;
+		i2c4 = &i2c_4;
+		i2c5 = &i2c_5;
+	};
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A55_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x000>;
+			enable-method = "rtk-spin-table";
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x100>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_2: cpu@2 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x200>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_3: cpu@3 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x300>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_4: cpu@4 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x400>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_5: cpu@5 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x500>;
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		a55_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	rtk_pm@0 {
+		compatible = "realtek,pm";
+		system-power-controller;
+		reg = <0x0 0x98000000 0x0 0x1800>, /* CRT */
+			<0x0 0x98007000 0x0 0x1000>, /* ISO */
+			<0x0 0x9801A000 0x0 0x1000>; /* SB2 */
+		wakeup-flags = <0x3F>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+		status = "okay";
+	};
+
+	soc@0 {
+		reg = <0x0 0x98000000 0x0 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+	};
+
+	sb2_lock0: sb2-lock@9801A000 {
+		compatible = "realtek,sb2-sem";
+		reg = <0x0 0x9801A000 0x0 0x4>;
+	};
+
+	sb2_lock_avlog: sb2-lock@9801A63C {
+		compatible = "realtek,sb2-sem", "realtek,sb2-sem-avlog";
+		reg = <0x0 0x9801A63C 0x0 0x4>;
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x0 0x9801a000 0x0 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+
+	crt_mmio: mmio@98000000 {
+		compatible = "realtek,mmio";
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	iso_mmio: mmio@98007088 {
+		compatible = "realtek,mmio";
+		reg = <0x0 0x98007088 0x0 0x8>;
+		realtek,sb2-lock = <&sb2_lock0>;
+	};
+
+	efuse@98017000 {
+		compatible = "realtek,efuse";
+		reg = <0x0 0x98017000 0x0 0x1000>;
+		read-only;
+		status = "okay";
+		#address-cells = <1>;
+		#size-cells = <1>;
+
+		nvmem-cells =
+			<&otp_bond_id>,
+			<&otp_cpu_iddq>,
+			<&otp_top_iddq>,
+			<&otp_etn_rc>,
+			<&otp_etn_amp>,
+			<&otp_etn_adc>,
+			<&otp_etn_r>,
+			<&otp_usb_cc1_comp_cal>,
+			<&otp_usb_cc2_comp_cal>,
+			<&otp_usb_cc1_4_7k_cal>,
+			<&otp_usb_cc1_12k_cal>,
+			<&otp_usb_cc2_4_7k_cal>,
+			<&otp_usb_cc2_12k_cal>,
+			<&otp_usb_dc_cal>,
+			<&otp_usb_cc_en>,
+			<&otp_package_id>,
+			<&otp_chip_id>;
+
+		nvmem-cell-names =
+			"bond_id",
+			"cpu_iddq",
+			"top_iddq",
+			"etn_rc",
+			"etn_amp",
+			"etn_adc",
+			"etn_r",
+			"usb_cc1_comp_cal",
+			"usb_cc2_comp_cal",
+			"usb_cc1_4.7k_cal",
+			"usb_cc1_12k_cal",
+			"usb_cc2_4.7k_cal",
+			"usb_cc2_12k_cal",
+			"usb_dc_cal",
+			"usb_cc_en",
+			"package_id",
+			"chip_id";
+
+		otp_bond_id: bond-id@4f4 {
+			reg = <0x4f4 0x4>;
+			bits = <0 32>;
+		};
+
+		otp_cpu_iddq: cpu-iddq@4f8 {
+			reg = <0x4f8 0x1>;
+			bits = <0 8>;
+		};
+		otp_top_iddq: top-iddq@4f9 {
+			reg = <0x4f9 0x1>;
+			bits = <0 8>;
+		};
+
+		otp_etn_rc: etn-rc@4fb {
+			reg = <0x4fb 0x1>;
+			bits = <0 4>;
+		};
+		otp_etn_amp: etn-amp@4fc {
+			reg = <0x4fc 0x2>;
+			bits = <0 16>;
+		};
+		otp_etn_adc: etn-adc@4fe {
+			reg = <0x4fe 0x2>;
+			bits = <0 16>;
+		};
+		otp_etn_r: etn-r@501 {
+			reg = <0x501 0x2>;
+			bits = <7 4>;
+		};
+		otp_usb_cc1_comp_cal: usb_cc1_comp_cal@502 {
+			reg = <0x502 0x4>;
+			bits = <3 24>;
+		};
+		otp_usb_cc2_comp_cal: usb_cc2_comp_cal@505 {
+			reg = <0x505 0x4>;
+			bits = <3 24>;
+		};
+		otp_usb_cc1_4_7k_cal: usb_cc1_4_7k_cal@508 {
+			reg = <0x508 0x1>;
+			bits = <3 4>;
+		};
+		otp_usb_cc1_12k_cal: usb_cc1_12k_cal@508 {
+			reg = <0x508 0x2>;
+			bits = <7 4>;
+		};
+		otp_usb_cc2_4_7k_cal: usb_cc2_4_7k_cal@509 {
+			reg = <0x509 0x1>;
+			bits = <3 4>;
+		};
+		otp_usb_cc2_12k_cal: usb_cc2_12k_cal@509 {
+			reg = <0x509 0x2>;
+			bits = <7 4>;
+		};
+		otp_usb_dc_cal: usb_dc_cal@50a {
+			reg = <0x50a 0x2>;
+			bits = <3 12>;
+		};
+		otp_usb_cc_en: usb_cc_en@50b {
+			reg = <0x50b 0x1>;
+			bits = <7 1>;
+		};
+		otp_package_id: package_id@48d {
+			reg = <0x48d 0x1>;
+			bits = <5 2>;
+		};
+		otp_chip_id: chip_id@3cc {
+			reg = <0x3cc 0x10>;
+			bits = <0 128>;
+		};
+	};
+
+	osc27M: osc27M {
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <27000000>;
+		clock-output-names = "osc27M";
+	};
+
+	cc: clocks@98000000 {
+		compatible = "realtek,clock-controller";
+		#clock-cells = <1>;
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		clocks = <&osc27M>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	clk_en_1: clk-en@98000050 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000050 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "unused", "pcie0", "unused", "gspi",
+				     "unused", "unused", "sds", "hdmi",
+				     "unused", "unused", "unused", "unused",
+				     "unused", "unused", "lsadc", "se";
+		ignore-unused-clocks = "hdmi";
+		ignore-pm-clocks = "hdmi";
+	};
+
+	clk_en_2: clk-en@98000054 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000054 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "unused", "cp", "md", "tp",
+				     "rsa", "nf", "emmc", "sd",
+				     "sdio_ip", "mipi", "emmc_ip", "sdio",
+				     "sd_ip", "cablerx", "tpb", "sc1";
+		ignore-unused-clocks = "cp", "md", "tp";
+	};
+
+	clk_en_3: clk-en@98000058 {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x98000058 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "i2c_3", "unused", "jpeg", "unused",
+				     "unused", "sc0", "unused", "unused",
+				     "unused", "unused", "unused", "unused",
+				     "unused", "hdmirx", "hse", "ur2";
+	};
+
+	clk_en_4: clk-en@9800005c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800005c 0x0 0x4>;
+		#clock-cells = <1>;
+		realtek,has-web;
+		clock-output-names = "ur1", "fan", "unused", "unused",
+				     "sata_wrap_sys", "sata_wrap_sysh",
+				     "sata_mac_sysh", "r2rdsc",
+				     "unused", "pcie1", "i2c_4", "i2c_5",
+				     "unused", "unused", "edp", "unused";
+	};
+
+	iso_clk_en: clk-en@9800708c {
+		compatible = "realtek,clock-gate-controller";
+		reg = <0x0 0x9800708c 0x0 0x4>;
+		#clock-cells = <1>;
+		clock-output-names = "unused", "unused", "cec0", "cbusrx_sys",
+				     "cbustx_sys", "cbus_sys", "cbus_osc", "ir",
+				     "ur0", "i2c0", "i2c1", "etn_250m",
+				     "etn_sys", "usb_drd", "usb_host",
+				     "usb_u3_host", "usb";
+	};
+
+	crst: soft-reset@98000000 {
+		compatible = "realtek,rtd16xx-reset-controller";
+		reg = <0x0 0x98000000 0x0 0x1000>;
+		#reset-cells = <1>;
+		realtek,mmio = <&crt_mmio 0x0>;
+	};
+
+	iso_rst: soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98007088 0x0 0x4>;
+		#reset-cells = <1>;
+		realtek,mmio = <&iso_mmio 0x0>;
+	};
+
+	iso_asrst: usb-async-soft-reset@98007088 {
+		compatible = "realtek,reset-controller";
+		reg = <0x0 0x98007088 0x0 0x4>;
+		#reset-cells = <1>;
+		async-group = <0>;
+		realtek,mmio = <&iso_mmio 0x0>;
+	};
+
+	pd: power-domain@98007000 {
+		compatible = "realtek,rtd16xx-power-controller";
+		reg = <0x0 0x98007000 0x0 0x1000>;
+		#power-domain-cells = <1>;
+		#powerctrl-cells = <1>;
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x0 0x98000000 0x0 0x200000>;
+	};
+
+	refclk@9801b540 {
+		compatible = "realtek,uio";
+		reg = <0x0 0x9801b000 0x0 0x1000>;
+		status = "okay";
+	};
+
+	gic: interrupt-controller@FF100000 {
+		compatible = "arm,gic-v3";
+		#interrupt-cells = <3>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		interrupt-controller;
+		redistributor-stride = <0x0 0x20000>;
+		#redistributor-regions = <1>;
+		reg = <0x0 0xFF100000 0x0 0x10000>, /*  GICD */
+			<0x0 0xFF140000 0x0 0x200000>; /*  GICR */
+		interrupts = <GIC_PPI 9 4>;
+	};
+
+	timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <GIC_PPI 13 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 14 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 11 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 10 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>;
+		clock-frequency = <27000000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <GIC_PPI 7 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>;
+	};
+
+	pinctrl: pinctrl@9804E000 {
+		compatible = "realtek,rtk16xx-pinctrl";
+		reg = <0x0 0x9804E000 0x0 0x100>,
+			<0x0 0x9804F000 0x0 0x100>;
+		#gpio-range-cells = <3>;
+		status = "okay";
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP MISC_ISO */
+			  <0x0 0x98007000 0x0 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+
+	/*
+	 * Suspend GPIO control
+	 *
+	 * [wakeup-gpio-list]
+	 * rtk_iso_gpio 10: BT wakeup host pin
+	 * rtk_iso_gpio 26: WiFi wakeup host pin
+	 *
+	 * [wakeup-gpio-enable]
+	 * Wakeup from BT: <0> disable
+	 * Wakeup from WiFi: <0> disable
+	 *
+	 * [wakeup-gpio-activity]
+	 * BT pin: <0> active low
+	 * WIFI pin: <0> active low
+	 */
+
+	rtk_iso_gpio: rtk_iso_gpio@98007100 {
+		compatible = "realtek,rtk16xx-iso-gpio-irq-mux";
+		gpio-controller;
+		#gpio-cells = <3>;
+		Realtek,gpio_base = <0>;
+		Realtek,gpio_numbers = <86>;
+		interrupt-parent = <&mux_intc>;
+		#interrupt-cells = <1>;
+		interrupt-controller;
+		interrupts = <51 4>, <52 4>; /*GPIOA_INT   GPIODA_INT*/
+		reg = <0x0 0x98007000 0x0 0x100>,
+			<0x0 0x98007100 0x0 0x100>; /* ISO_SYS ISO_GPIO*/
+		gpio-ranges = <&pinctrl 0 0 86>;
+		wakeup-gpio-list = <&rtk_iso_gpio 10 0 1>,<&rtk_iso_gpio 26 0 1>;
+		wakeup-gpio-enable = <1>, <1>;
+		wakeup-gpio-activity = <0>, <0>;
+		status = "okay";
+	};
+
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x98007800 0x0 0x400>,
+			  <0x0 0x98007000 0x0 0x100>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		interrupts = <0 68 4>;
+		clock-frequency = <27000000>; /* This value must be override by the board. */
+		clocks = <&iso_clk_en CLK_EN_MISC_UR0>;
+		resets = <&iso_rst RSTN_UR0>;
+		status = "okay";
+	};
+
+	uart1: serial1@9801B200 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x9801B200 0x0 0x100>,
+			<0x0 0x9801B00c 0x0 0x100>;
+		interrupts-st-mask = <0x8>;
+		interrupts = <0 89 4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart1_pins>;
+		clocks = <&clk_en_4 CLK_EN_UR1>;
+		resets = <&crst RSTN_UR1>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "okay";
+	};
+
+	uart2: serial2@9801B400 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x9801B400 0x0 0x100>,
+			<0x0 0x9801B00c 0x0 0x100>;
+		interrupts-st-mask = <0x100>;
+		interrupts =  <0 90 4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&uart2_pins_0>;
+		clocks = <&clk_en_3 CLK_EN_UR2>;
+		resets = <&crst RSTN_UR2>;
+		/* This value must be overriden by the board. */
+		clock-frequency = <432000000>;
+		status = "disabled"; /* Disable UR2 first since we don't use it now */
+	};
+
+
+	nic: gmac@98016000 {
+		compatible = "Realtek,r8168";
+		reg = <0x0 0x98016000 0x0 0x1000>,   /* ETN */
+			<0x0 0x98007000 0x0 0x1000>, /* ISO */
+			<0x0 0x9801c000 0x0 0x2000>, /* SBX and SC_WRAP for ACP ctrl */
+			<0x0 0x980174f8 0x0 0x20>,    /* EFUSE_OTP_REG */
+			<0x0 0x981c8000 0x0 0x2000>, /* SDS */
+			<0x0 0x9804e000 0x0 0x1000>; /* ISO pinmux */
+		interrupts = <0 22 4>;
+		pinctrl-names = "default",
+				"sgmii";
+		pinctrl-0 = <&etn_led_pins>;
+		pinctrl-1 = <&sgmii_mdio_pins>;
+		local-mac-address = [00 10 20 30 40 50];
+		rtl-config = <1>;
+		mac-version = <42>; /* RTL_GIGA_MAC_VER_42 */
+		rtl-features = <2>; /* BIT(2) GMii */
+		wake-mask0 = [3f 30 80 c0 3f 10 80 ff ff 1f 00 00 00 00 00 00];
+		wake-crc0 = <0x8d25>;
+		wake-mask1 = [3f 30 80 c0 3f 10 00 00 c0 ff ff 0f 00 00 00 00];
+		wake-crc1 = <0x8d25>;
+		wake-mask2 = [3f 30 80 c0 3f 10 00 00 00 00 00 00 80 ff ff 1f];
+		wake-crc2 = <0x8d25>;
+		wake-mask3 = [3f 30 10 00 c0 ff ff 03 01 f8 ff ff 01 00 00 00];
+		wake-crc3 = <0x11da>;
+		wake-mask4 = [3f 30 10 00 c0 ff ff 03 01 00 00 fc ff ff 00 00];
+		wake-crc4 = <0x11da>;
+		wake-mask5 = [3f 30 10 00 c0 ff ff 03 01 00 00 00 00 00 00 f8];
+		wake-crc5 = <0x15f8>;
+		output-mode = <0>; /* 0:embedded PHY, 1:SGMII to MAC, 2:SGMII to PHY */
+		ext-phy-id = <3>; /* 0 ~ 31, only valid when output-mode = 2 */
+		sgmii-swing = <0>; /* 0:640mV, 1:380mV, 2:250mV, 3:190mV */
+		bypass = <1>; /* 0: disable, 1: enable */
+		acp = <0>; /* 0: disable, 1: enable */
+		eee = <0>; /* 0: disable, 1: enable */
+		clocks = <&iso_clk_en CLK_EN_ETN_250M>,
+			<&iso_clk_en CLK_EN_ETN_SYS>,
+			<&clk_en_1 CLK_EN_SDS>;
+		clock-names = "etn_250m",
+			"etn_sys",
+			"sds";
+		resets = <&iso_rst RSTN_GMAC>,
+			<&iso_rst RSTN_GPHY>,
+			<&crst RSTN_SDS_REG>,
+			<&crst RSTN_SDS>,
+			<&crst RSTN_PCIE0_POWER>,
+			<&crst RSTN_PCIE0_PHY>,
+			<&crst RSTN_PCIE0_SGMII_MDIO>,
+			<&crst RSTN_PCIE0_PHY_MDIO>;
+		reset-names = "gmac",
+			"gphy",
+			"sds_reg",
+			"sds",
+			"pcie0_power",
+			"pcie0_phy",
+			"pcie0_sgmii_mdio",
+			"pcie0_phy_mdio";
+		status = "okay";
+		phy_0 {
+			interrupt-parent = <&mux_intc>;
+			interrupts = <60 4>,
+				<61 4>,
+				<62 4>;
+		};
+
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x0 0x9801d000 0x0 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	watchdog@0x98007680 {
+                compatible = "realtek,rtk-watchdog";
+                reg = <0x0 0x9801b5b0 0x0 0x20>, /*misc watchdog for SCPU NMI */
+                        <0x0 0x9801b000 0x0 0x10>,
+                        <0x0 0x98007680 0x0 0x100>; /*iso watchdog for oe workaround */
+                interrupts = <0 0 4>;
+                rst-oe = <0>; /* 0:input, 1:output */
+                rst-oe-for-init = <1>; /* 0:input, 1:output */
+                timeout-sec = <10>;
+                status = "okay";
+        };
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x0 0x98007640 0x0 0x10>;
+	};
+
+	i2c_0: i2c@0x98007D00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x98007D00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <40 4>;
+		i2c-num = <0>;
+		status = "okay";
+		pinctrl-names = "default", "high_speed";
+		pinctrl-0 = <&i2c_pins_0>;
+		pinctrl-1 = <&i2c_pins_0_HS>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iso_clk_en CLK_EN_I2C0>;
+		resets = <&iso_rst RSTN_I2C_0>;
+	};
+
+	i2c_1: i2c@0x98007C00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x98007C00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <43 4>;
+		i2c-num = <1>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_1>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&iso_clk_en CLK_EN_I2C1>;
+		resets = <&iso_rst RSTN_I2C_1>;
+	};
+
+	i2c_3: i2c@0x9801B900 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x9801B900 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <23 4>;
+		i2c-num = <3>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_3>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_3 CLK_EN_MISC_I2C_3>;
+		resets = <&crst RSTN_I2C_3>;
+	};
+
+	i2c_4: i2c@0x9801BA00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x9801BA00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <15 4>;
+		i2c-num = <4>;
+		status = "okay";
+		pinctrl-names = "default";
+		/*pinctrl-0 = <&i2c_pins_4>;*/
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_4 CLK_EN_MISC_I2C_4>;
+		resets = <&crst RSTN_I2C_4>;
+	};
+
+	i2c_5: i2c@0x9801BB00 {
+		compatible = "Realtek,rtk-i2c";
+		reg = <0x0 0x9801BB00 0x0 0x100>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <14 4>;
+		i2c-num = <5>;
+		status = "okay";
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_5>;
+		#address-cells = <1>;
+		#size-cells = <0>;
+		clocks = <&clk_en_4 CLK_EN_MISC_I2C_5>;
+		resets = <&crst RSTN_I2C_5>;
+	};
+
+	spi_0: spi@9801BD00 {
+		compatible = "Realtek,rtk-dw-apb-ssi";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		interrupt-parent = <&mux_intc>;
+		interrupts = <27 4>; /* SPI_INT */
+		reg = <0x0 0x9801BD00 0x0 0x100>, /* DW SPI */
+			<0x0 0x9801B300 0x0 0x18>; /* SPI wrapper */
+		pinctrl-names = "default";
+		pinctrl-0 = <&gspi_pins_0>;
+		/*spi-cs-gpio = <&rtk_iso_gpio 6 1 1>;*/
+		num-chipselect = <1>;
+		bus-num = <0>;
+		clocks = <&clk_en_1 CLK_EN_GSPI>;
+		clock-frequency = <256000000>;
+		resets = <&crst RSTN_GSPI>;
+		status = "disabled";
+	};
+
+	pwm: pwm@980070D0 {
+		compatible = "Realtek,rtd1295-pwm";
+		#pwm-cells = <2>;
+		reg = <0x0 0x980070D0 0x0 0xC>;
+		status = "okay";
+		pwm_0 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <5>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm0_0_pins>;
+			pinctrl-1 = <&pwm0_0_pins_disable>;
+			pinctrl-2 = <&pwm0_1_pins>;
+			pinctrl-3 = <&pwm0_1_pins_disable>;
+		};
+		pwm_1 {
+			enable = <1>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm1_0_pins>;
+			pinctrl-1 = <&pwm1_0_pins_disable>;
+			pinctrl-2 = <&pwm1_1_pins>;
+			pinctrl-3 = <&pwm1_1_pins_disable>;
+		};
+		pwm_2 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm2_0_pins>;
+			pinctrl-1 = <&pwm2_0_pins_disable>;
+			pinctrl-2 = <&pwm2_1_pins>;
+			pinctrl-3 = <&pwm2_1_pins_disable>;
+		};
+		pwm_3 {
+			enable = <0>;
+			clkout_div = <0xff>; //default OCD: from 0x0 to 0xff
+			clksrc_div = <0x1>; //default OSD: from 0x0 to 0xf
+			duty_rate = <50>; //default duty_rate 0 ~ 100
+
+			default-loc = <0>;
+			pinctrl-names = "loc-0-enable",
+					"loc-0-disable",
+					"loc-1-enable",
+					"loc-1-disable";
+			pinctrl-0 = <&pwm3_0_pins>;
+			pinctrl-1 = <&pwm3_0_pins_disable>;
+			pinctrl-2 = <&pwm3_1_pins>;
+			pinctrl-3 = <&pwm3_1_pins_disable>;
+		};
+	};
+
+	rtk-lsadc@98007900 {
+		compatible = "Realtek,rtk-lsadc";
+		interrupt-parent = <&mux_intc>;
+		interrupts = <35 4>, <36 4>; /* LSADC0_INT, LSADC1_INT */
+		reg = <0x0 0x98007000 0x0 0x4>, /* ISO_ISR */
+			<0x0 0x98007900 0x0 0x200>, /* LSADC */
+			<0x0 0x9800034C 0x0 0x4>; /* LSADC_PG */
+		status = "disabled";
+		clk_gating_en = <1>, /* LSADC0 0:disable; 1:enable */
+						<1>; /* LSADC1 0:disable; 1:enable */
+		vdd_mux_sel = <0>; /* 0:VDD1; 1:VDD2 */
+		vdd_mux1 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux2 = <0>; /* 0 ~ 15: VDD_IN source selection */
+		vdd_mux_en = <1>; /* 0:disable; 1:enable */
+		clocks = <&clk_en_1 CLK_EN_LSADC>;
+		resets = <&crst RSTN_LSADC>;
+
+		rtk-lsadc0-pad0 {
+			//compatible = "Realtek,rtk-lsadc0-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc0-pad1 {
+			//compatible = "Realtek,rtk-lsadc0-pad1";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <1>; /* 0:External input pin 0; 1:External input pin 1 */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+		};
+
+		rtk-lsadc1-pad0 {
+			//compatible = "Realtek,rtk-lsadc1-pad0";
+			activate = <1>; /* 0:in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0:Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <32>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <0>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+
+		rtk-lsadc1-pad1 {
+			//compatible = "Realtek,rtk-lsadc1-pad1";
+			activate = <1>; /* 0: in-activate; 1:activate */
+			ctrl_mode = <0>; /* 0: Voltage mode; 1:Current mode*/
+			sw_idx = <0>; /* 0:VDD; 1:GND */
+			voltage_threshold = <16>; /* 8 bit : 0 ~ 255 */
+			detect_range_ctrl = <1>; /* 0:0V ~ 1.024V; 1:0.5V ~ 1.524V */
+		};
+	};
+
+	hdmitx@9800D000 {
+		compatible = "realtek,rtd161x-hdmitx";
+		reg = <0x0 0x9800d000 0x0 0x560>, /* HDMITX */
+			<0x0 0x98007200 0x0 0x4>; /* I2C1_REQ_CTRL */
+		gpio-hpd-detect = <&rtk_iso_gpio 7 0 0>; /* Hotplug detect pin */
+		clocks = <&clk_en_1 CLK_EN_HDMI>;
+		clock-names = "clk_en_hdmi";
+		resets = <&crst RSTN_HDMI>;
+		reset-names = "rstn_hdmi";
+		status = "okay";
+
+		scdc_rr {
+			enable-scdc-rr = <0>;
+			interrupt-parent = <&mux_intc>;
+			#interrupt-cells = <1>;
+			interrupt-controller;
+			interrupts = <63 4>;
+		};
+	};
+
+	hdcptx@9800D000 {
+		compatible = "realtek,rtd161x-hdcptx";
+		reg = <0x0 0x9800d000 0x0 0x400>;
+		interrupts = <0 31 4>; /*gen Ri*/
+		status = "okay";
+	};
+
+	hdmirx@98034000 {
+		compatible = "realtek,rtd161x-hdmirx";
+		reg = <0x0 0x98037000 0x0 0xE0>,
+			<0x0 0x98034000 0x0 0xF54>,
+			<0x0 0x98035F00 0x0 0x4C>,
+			<0x0 0x98037700 0x0 0x98>,
+			<0x0 0x98004000 0x0 0x224>,
+			<0x0 0x9801B500 0x0 0x48>;
+		interrupts = <0 23 4>;
+		gpio-rx-hpd-ctrl = <&rtk_iso_gpio 31 1 1>; /* Low active */
+		gpio-5v-detect = <&rtk_iso_gpio 20 0 0>;
+		clocks = <&clk_en_3 CLK_EN_HDMIRX>,
+			<&clk_en_2 CLK_EN_MIPI>,
+			<&iso_clk_en CLK_EN_CBUS_OSC>,
+			<&iso_clk_en CLK_EN_CBUS_SYS>,
+			<&iso_clk_en CLK_EN_CBUSTX_SYS>,
+			<&iso_clk_en CLK_EN_CBUSRX_SYS>,
+			<&clk_en_2 CLK_EN_TP>,
+			<&clk_en_2 CLK_EN_CP>;
+		clock-names = "hdmirx",
+			"mipi",
+			"cbus_osc",
+			"cbus_sys",
+			"cbustx_sys",
+			"cbusrx_sys",
+			"tp",
+			"cp";
+		resets = <&crst RSTN_HDMIRX>,
+			<&crst RSTN_HDMIRX_WRAP>,
+			<&crst RSTN_MIPI>,
+			<&iso_rst RSTN_CBUS>,
+			<&iso_rst RSTN_CBUSTX>,
+			<&iso_rst RSTN_CBUSRX>;
+		reset-names = "hdmirx",
+			"hdmirx_wrap",
+			"mipi",
+			"cbus",
+			"cbustx",
+			"cbusrx";
+		powerctrls = <&pd PD_SRAM_HDMIRX>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&i2c_pins_2>;
+		status = "okay";
+	};
+
+	sd: sdmmc@98010400 {
+		compatible = "Realtek,rtk1295-sdmmc";
+		gpios = <&rtk_iso_gpio 30 1 0>, /*sd power , output, default high  (poweroff) */
+			<&rtk_iso_gpio 34 0 1>,
+			<&rtk_iso_gpio 35 0 1>;
+		reg =   <0x0 0x98000000 0x0 0x400>, /* CRT */
+			<0x0 0x98010400 0x0 0x200>, /* SDMMC */
+			<0x0 0x9801A000 0x0 0x400>, /* BS2 */
+			<0x0 0x9804f000 0x0 0x40>, /* ISO */
+			<0x0 0x98010A00 0x0 0x40>, /* SDIO */
+			<0x0 0x98007000 0x0 0x200>;
+		interrupts = <0 44 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdcard_pins_low>, <&scpu_ejtag_pins_disable>; /*<&sdcard_pins_high>;*/
+		clocks = <&clk_en_2 CLK_EN_SD>, <&clk_en_2 CLK_EN_SD_IP>;
+		clock-names = "sd", "sd_ip";
+		resets = <&crst RSTN_SD>;
+		status = "okay";
+	};
+
+	sdio: sdio@98010A00 {
+		compatible = "Realtek,rtk1295-sdio";
+		gpios = <&rtk_iso_gpio 27 1 1>;
+		reg = <0x0 0x98010c00 0x0 0x200>,
+			<0x0 0x98000000 0x0 0x200000>;
+		interrupts = <0 45 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&sdio_pins_1>;
+		clocks = <&clk_en_2 CLK_EN_SDIO>,
+			<&clk_en_2 CLK_EN_SDIO_IP>;
+		clock-names = "sdio", "sdio_ip";
+		resets = <&crst RSTN_SDIO>;
+		status = "okay";
+	};
+
+	emmc: emmc@98012000 {
+		compatible = "Realtek,rtk1295-emmc";
+		reg = <0x0 0x98012000 0x0 0xa00>, /*EMMC*/
+			<0x0 0x98000000 0x0 0x600>, /*CRT */
+			<0x0 0x9801A000 0x0 0x80>, /*SB2*/
+			<0x0 0x9801B000 0x0 0x150>, /*MISC*/
+			<0x0 0x9801a954 0x0 0x20>,  /*SB2_DBG*/
+			<0x0 0x9804f000 0x0 0x100>; /* ISO */
+		interrupts = <0 42 4>;
+		speed-step = <3>; /* 0: sdr50, 1: ddr50, 2: hs200, 3: hs400 */
+		clocks = <&clk_en_2 CLK_EN_EMMC>, <&clk_en_2 CLK_EN_EMMC_IP>;
+		clock-names = "emmc", "emmc_ip";
+		resets = <&crst RSTN_EMMC>;
+		reset-names = "emmc";
+		status = "okay";
+		pddrive_nf_s0 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for sdr50 */
+		pddrive_nf_s1 = <1 0x0 0x0 0x0 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for ddr50 */
+		pddrive_nf_s2 = <1 0x4 0x4 0x4 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs200 */
+		pddrive_nf_s3 = <1 0x4 0x4 0x4 0x0>; /* pddrive_nf0, pddrive_nf1, pddrive_nf2, pddrive_nf3, pddrive_nf4 ; for hs400 */
+		phase_tuning = <0 1>; /* arg0: tx tuning switch, arg1: rx tuning switch, if we want to set user defined tx or rx, we should set 0 for tx or rx*/
+		reference_phase = <1 0x9 0 0x0>; /* arg0: switch user defined tx, arg1: tx reference phase value, arg2: switch user defined rx, arg3: rx reference phase value*/
+		dqs_tuning = <1>;
+		mbr_tuning_addr = <0x9a0e00>;
+	};
+
+	nand@98010000 {
+		compatible = "Realtek,rtk1295-nand";
+		reg = <0x0 0x98010000 0x0 0x400>, /* NWC */
+			<0x0 0x9801F000 0x0 0x400>; /* SWC */
+		clocks = <&clk_en_2 CLK_EN_NF>;
+		resets = <&crst RSTN_NF>;
+		status = "disabled";
+	};
+
+	rfkill: rfkilligpio {
+                compatible = "Realtek,rfkill";
+                gpios = <&rtk_iso_gpio 11 1 1>, /*bt disable, output, default high */
+                        <&rtk_iso_gpio 27 1 1>; /*wifi disable, output, default high */
+                status = "disabled";
+        };
+
+	rng@98001000 {
+                compatible = "Realtek,rtk-rng";
+		reg = <0x0 0x98001000 0x0 0x70>;
+		status = "okay";
+        };
+
+
+	smartcard@9801BE00 {
+		compatible = "Realtek,rtk-smc";
+		interrupts = <0 63 4>; /* SC0_INT*/
+		reg = <0x0 0x9801B000 0x0 0x100>, /* MISC interrupt */
+			<0x0 0x9801BE00 0x0 0x80>; /* SmartCard */
+		smc-num = <0>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&smartcard_pins_0>;
+		clock-names = "clk_en_misc_sc";
+		clocks = <&clk_en_3 CLK_EN_MISC_SC0>;
+		resets = <&crst RSTN_MISC_SC0>;
+		status = "okay";
+		lsic_control{
+			pin_cmd_vcc = <&rtk_iso_gpio 63 1 0>; /* pin cmd_vcc , default low */
+			pin_pwr_sel = <&rtk_iso_gpio 64 1 0>; /* pin pwr_sel , default 0 */
+			cmd_vcc_en = <1>;
+			cmd_vcc_polarity = <0>; /* low active */
+			pwr_sel_en = <1>;
+			pwr_sel_polarity = <1>; /* high actve 1: 5v */
+		};
+	};
+
+	irda@98007400 {
+		compatible = "Realtek,rtk-irda";
+		interrupt-parent = <&mux_intc>;
+		reg = <0x0 0x98007000 0x0 0x400>,
+			<0x0 0x98007400 0x0 0x100>;
+		interrupts = <37 4>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&ir_rx_pins>;
+		resets = <&iso_rst RSTN_IR>;
+		clocks = <&iso_clk_en CLK_EN_MISC_IR>;
+		status = "disabled";
+	};
+
+        rtc@9801B600 {
+                compatible = "realtek,rtk-rtc";
+                reg = <0x0 0x9801B600 0x0 0x34>,
+                        <0x0 0x98007000 0x0 0x100>;
+                rtc-base-year = <2018>;
+		rtc-bias = <0x2>;
+		interrupts = <0 39 4>;
+                status = "okay";
+        };
+
+
+
+
+	rpc@9801a104 {
+		compatible = "Realtek,rtk-rpc";
+		reg = <0x0 0x9801a104 0x0 0xc>, /* rpc intr en */
+			<0x0 0x01ffe000 0x0 0x4000>, /* rpc ring buffer */
+			<0x0 0x0002f000 0x0 0x1000>, /* rpc common */
+			<0x0 0x9801a020 0x0 0x4>; /* rbus sync */
+		interrupts = <0 33 4>;
+		status = "okay";
+	};
+
+	dvfs: cpu-dvfs {
+	};
+
+	gpu: gpu@981D0000 {
+		compatible = "arm,mali-midgard";
+		reg = <0x0 0x981D0000 0x0 0x10000>,
+		      <0x0 0x98007000 0x0 0x01000>;
+		interrupts = <GIC_SPI 76 4>, <GIC_SPI 77 4>, <GIC_SPI 75 4>;
+		interrupt-names = "JOB", "MMU", "GPU";
+		clocks = <&cc CC_CLK_GPU>;
+		clock-name = "clk_mali";
+		resets = <&crst RSTN_GPU>;
+		power-domains = <&pd PD_SRAM_GPU>;
+		status = "okay";
+	};
+
+	cpu_tm: thermal-sensor@9801db00 {
+		compatible = "realtek,rtd16xx-thermal-sensor";
+		reg = <0x0 0x9801db00 0x0 0x50>;
+		#thermal-sensor-cells = <0>;
+		status = "okay";
+	};
+
+	thermal-zones {
+		cpu_thermal: cpu-thermal {
+			polling-delay-passive = <250>;
+			polling-delay = <1000>;
+			thermal-sensors = <&cpu_tm>;
+			trips {
+				cpu_crit: cpu-crit {
+					temperature = <130000>;
+					hysteresis = <0>;
+					type = "critical";
+				};
+			};
+			cooling-maps {};
+		};
+	};
+
+	hse@98005000 {
+		reg = <0x0 0x98005000 0x0 0x1000>;
+		compatible = "realtek,highspeed-streaming-engine";
+		interrupts = <GIC_SPI 27 4>;
+		clocks = <&clk_en_3 CLK_EN_HSE>;
+		resets = <&crst RSTN_HSE>;
+		status = "okay";
+
+		engine-0-enabled;
+		engine-1-disabled;
+	};
+
+	md: md@9800b000 {
+		compatible = "realtek,md";
+		reg = <0 0x9800b000 0 0x1000>;
+		interrupts = <0 38 4>;
+		clocks = <&clk_en_2 CLK_EN_MD>;
+		resets = <&crst RSTN_MD>;
+		status = "okay";
+	};
+
+	se: se@9800c000 {
+		compatible = "realtek,se";
+		reg = <0 0x9800c000 0 0x1000>;
+		interrupts = <0 20 4>;
+		clocks = <&clk_en_1 CLK_EN_SE>;
+		resets = <&crst RSTN_SE>;
+		status = "okay";
+	};
+
+	mcp@0 {
+		compatible = "Realtek,rtk-mcp";
+		reg = <0x0 0x98015000 0x0 0x1000>,
+			<0x0 0x98014000 0x0 0x1000>;
+		status = "okay";
+	};
+
+	pu_pll@98000000 {
+		compatible = "Realtek,rtk16xx-pu_pll";
+		reg = <0x0 0x98000000 0x0 0x200>;
+	};
+
+	jpeg: jpeg@9803e000 {
+		compatible = "Realtek,rtk16xx-jpeg";
+		reg = <0x0 0x9803e000 0x0 0x1000>,
+			<0x0 0x98000000 0x0 0x200>,
+			<0x0 0x98007000 0x0 0x30>;
+		interrupts = <0 52 4>;
+		clocks = <&clk_en_3 CLK_EN_JPEG>;
+		clock-names = "jpeg";
+		resets = <&crst RSTN_JPEG>;
+		status = "okay";
+	};
+
+	ve1: ve1@98040000 {
+		compatible = "Realtek,rtk16xx-ve1";
+		reg = <0x0 0x98040000 0x0 0xC000>,
+			<0x0 0x98008000 0x0 0x1000>,
+			<0x0 0x98007000 0x0 0x30>,
+			<0x0 0x9800E000 0x0 0x1000>;
+		interrupts = <0 53 4>, <0 54 4>;
+		clocks = <&cc CC_CLK_VE1>,
+			<&cc CC_CLK_VE2>,
+			<&cc CC_CLK_VE2_BPU>,
+			<&cc CC_CLK_VE3>,
+			<&cc CC_CLK_SYSH>,
+			<&cc CC_PLL_VE1>,
+			<&cc CC_PLL_VE2>;
+		clock-names = "clk_ve1",
+			"clk_ve2",
+			"clk_ve2_bpu",
+			"clk_ve3",
+			"clk_sysh",
+			"pll_ve1",
+			"pll_ve2";
+		resets = <&crst RSTN_VE1>,
+			<&crst RSTN_VE2>,
+			<&crst RSTN_VE3>;
+		reset-names = "ve1",
+			"ve2",
+			"ve3";
+		assigned-clocks = <&cc CC_CLK_VE1>, <&cc CC_CLK_VE2>, <&cc CC_CLK_VE2_BPU>, <&cc CC_CLK_VE3>;
+		assigned-clock-parents = <&cc CC_PLL_VE1>, <&cc CC_PLL_VE2>, <&cc CC_PLL_VE1>, <&cc CC_PLL_VE1>;
+		assigned-clock-rates = <550000000>, <715000000>, <550000000>, <550000000>;
+		status = "okay";
+	};
+	
+	cec@98037800 {
+		compatible = "Realtek,rtk-cec";
+		reg = <0x0 0x98037800 0x0 0xe0>,
+			<0x0 0x98037500 0x0 0x100>;
+		interrupts = <0 26 4>;
+		clocks = <&iso_clk_en CLK_EN_CBUS_OSC>,
+			<&iso_clk_en CLK_EN_CBUS_SYS>,
+			<&iso_clk_en CLK_EN_CBUSTX_SYS>;
+		clock-names = "cbus_osc",
+			"cbus_sys",
+			"cbustx_sys";
+		resets = <&iso_rst RSTN_CBUS>,
+			<&iso_rst RSTN_CBUSTX>;
+		reset-names = "cbus",
+			"cbustx";
+		status = "okay";
+	};
+
+	spdif {
+		compatible = "realtek,audio";
+		gpios = <&rtk_iso_gpio 22 1 1>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&spdif_pins>;
+		status = "okay";
+	};
+
+	audio_out: audio-out-devices {
+		compatible = "realtek,audio-out";
+		pinctrl-names = "default";
+		pinctrl-0 = <&ao_pins>;
+		status = "disabled";
+
+		dac {
+			compatible = "dac";
+			status = "okay";
+		};
+		spdif {
+			compatible = "spdif";
+			status = "okay";
+		};
+		i2s {
+			compatible = "i2s";
+			channel = <2>;
+			status = "okay";
+		};
+		hdmi {
+			compatible = "hdmi";
+			status = "okay";
+		};
+		global {
+			compatible = "global";
+			status = "okay";
+		};
+	};
+
+	demod@9801E000 {
+		compatible = "realtek,demod";
+		reg = <0x0 0x9801E000 0x0 0x1000>;
+		clocks = <&clk_en_2 CLK_EN_CABLERX>, <&cc CC_PLL_DIF>;
+		clock-names = "cablerx", "pll";
+		resets = <&crst RSTN_CABLERX>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&demod_pins>;
+		status = "okay";
+	};
+
+	tp@98014000 {
+		compatible = "realtek,tp";
+		reg = <0x0 0x98014000 0x0 0x1000>,
+		      <0x0 0x98039000 0x0 0x1000>;
+		clocks = <&clk_en_2 CLK_EN_TP>, <&clk_en_2 CLK_EN_TPB>;
+		clock-names = "tp", "tpb";
+		resets = <&crst RSTN_TP>, <&crst RSTN_TPB>;
+		reset-names = "tp", "tpb";
+		status = "okay";
+	};
+
+	r2rdsc@9800b800 {
+		compatible = "realtek,r2rdsc";
+		reg = <0x0 0x9800b000 0x0 0x1000>;
+		clocks = <&clk_en_4 CLK_EN_R2RDSC>;
+		clock-names = "r2rdsc";
+		resets = <&crst RSTN_R2RDSC>;
+		reset-names = "r2rdsc";
+		status = "okay";
+	};
+};
+
+#include "rtd-16xx-pcie.dtsi"
+#include "rtd-1619-irda.dtsi"
+
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/thor-fpga.dts b/arch/arm64/boot/dts/realtek/rtd16xx/thor-fpga.dts
new file mode 100644
index 00000000..8f78886
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/thor-fpga.dts
@@ -0,0 +1,54 @@
+/dts-v1/;
+#include <dt-bindings/soc/rtd16xx,memory.h>
+
+/* 0x00000000 ~ 0x0002ffff */
+/memreserve/ SYS_BOOTCODE_MEMBASE SYS_BOOTCODE_MEMSIZE;
+/* 0x0001f000 ~ 0x0001ffff */
+/memreserve/ RPC_COMM_PHYS RPC_COMM_SIZE;
+/* 0x01ffe000 ~ 0x02001fff */
+/memreserve/ RPC_RINGBUF_PHYS RPC_RINGBUF_SIZE;
+
+#include "thor-fpga.dtsi"
+
+/ {
+	model= "Realtek_Thor_FPGA";
+	compatible =  "realtek,thor";
+
+	aliases {
+		serial0 = &uart0;
+	};
+
+	chosen {
+		bootargs = "earlycon=uart8250,mmio32,0x98007800 console=ttyS0,115200 init=/init loglevel=7";
+	};
+
+	memory@0 {
+		device_type = "memory";
+		reg = <0x0 0x0 0x0 0x20000000>;	/* 512 MB */
+	};
+	
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		rbus@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "rbus";
+			reg = <0x0 RBUS_BASE_PHYS 0x0 RBUS_BASE_SIZE>;
+			rtk_rbus_barrier_flag;
+		};
+
+		common@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "common";
+			reg = <0x0 RPC_COMM_PHYS 0x0 RPC_COMM_SIZE>;
+		};
+
+		ringbuf@0 {
+			compatible = "rsvmem-remap";
+			save_remap_name = "ringbuf";
+			reg = <0x0 RPC_RINGBUF_PHYS 0x0 RPC_RINGBUF_SIZE>;
+		};
+	};
+};
diff --git a/arch/arm64/boot/dts/realtek/rtd16xx/thor-fpga.dtsi b/arch/arm64/boot/dts/realtek/rtd16xx/thor-fpga.dtsi
new file mode 100644
index 00000000..c818b9f
--- /dev/null
+++ b/arch/arm64/boot/dts/realtek/rtd16xx/thor-fpga.dtsi
@@ -0,0 +1,143 @@
+#include <dt-bindings/interrupt-controller/irq.h>
+#include <dt-bindings/interrupt-controller/arm-gic.h>
+
+/{
+	compatible = "realtek,thor";
+	interrupt-parent = <&gic>;
+	#address-cells = <0x2>;
+	#size-cells = <0x2>;
+
+	cpus {
+		#address-cells = <1>;
+		#size-cells = <0>;
+
+		A55_0: cpu@0 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x000>;
+			/*enable-method = "psci";*/
+			enable-method = "rtk-spin-table";
+			next-level-cache = <&a55_l2>;
+		};
+
+		A55_1: cpu@1 {
+			device_type = "cpu";
+			compatible = "arm,cortex-a55", "arm,armv8";
+			reg = <0x100>;
+			/*enable-method = "psci";*/
+			enable-method = "rtk-spin-table";
+			cpu-release-addr = <0x0 0x98007F30>;
+			next-level-cache = <&a55_l2>;
+		};
+
+		a55_l2: l2-cache {
+			compatible = "cache";
+		};
+	};
+
+	arm_psci {
+		compatible = "arm,psci-0.2";
+		method = "smc";
+	};
+
+	rtk_pm@0 {
+		compatible = "realtek,pm";
+		system-power-controller;
+		reg = <0x0 0x98000000 0x0 0x1800>, /* CRT */
+			<0x0 0x98007000 0x0 0x1000>, /* ISO */
+			<0x0 0x9801A000 0x0 0x1000>; /* SB2 */
+		wakeup-flags = <0x3F>; /* Bits [5] CEC [4] timer [3]Alarm [2]GPIO [1]IR [0]LAN  */
+		status = "okay";
+	};
+
+	soc@0 {
+		reg = <0x0 0x98000000 0x0 0x70000>;
+		compatible = "simple-bus";
+		device_type = "soc";
+	};
+
+	rbus@98000000 {
+		compatible = "realtek,uio";
+		reg = <0x0 0x98000000 0x0 0x200000>;
+	};
+
+	gic: interrupt-controller@FF100000 {
+		compatible = "arm,gic-v3";
+		#interrupt-cells = <3>;
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+		interrupt-controller;
+		redistributor-stride = <0x0 0x20000>;
+		#redistributor-regions = <1>;
+		reg = <0x0 0xFF100000 0x0 0x10000>,       // GICD
+		      <0x0 0xFF140000 0x0 0x200000>;      // GICR
+		interrupts = <GIC_PPI 9 4>;
+	};
+	
+	timer {
+		compatible = "arm,armv8-timer";
+		interrupts = <GIC_PPI 13 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 14 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 11 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>,
+					<GIC_PPI 10 (GIC_CPU_MASK_SIMPLE(4) | IRQ_TYPE_LEVEL_LOW)>;
+		clock-frequency = <33000000>;
+	};
+
+	pmu {
+		compatible = "arm,armv8-pmuv3";
+		interrupts = <0 48 4>;
+		interrupt-affinity = <&A55_0>;
+	};
+
+	mux_intc: intc@9801B000 {
+		compatible = "Realtek,rtk-irq-mux";
+		Realtek,mux-nr = <2>;
+		#interrupt-cells = <2>;
+		interrupt-controller;
+		reg = <0x0 0x9801B000 0x0 0x100>, /* MISC_TOP MISC_ISO */
+			  <0x0 0x98007000 0x0 0x100>;
+		interrupts = <0 40 4>, <0 41 4>;
+		intr-status = <0xc>, <0x0>;
+		intr-en = <0x80>, <0x40>;
+		status = "okay";
+	};
+		
+	uart0: serial0@98007800 {
+		compatible = "snps,dw-apb-uart";
+		reg = <0x0 0x98007800 0x0 0x400>,
+			  <0x0 0x98007000 0x0 0x100>;
+		interrupts = <0 68 4>;
+		reg-shift = <2>;
+		reg-io-width = <4>;
+		clock-frequency = <33000000>; /* This value must be override by the board. */
+		status = "okay";
+	};
+
+	scpu_wrapper@9801d000 {
+		compatible = "Realtek,rtk-scpu_wrapper";
+		reg = <0x0 0x9801d000 0x0 0x500>;
+		interrupts = <0 46 4>;
+		status = "okay";
+	};
+
+	sb2@9801a000 {
+		compatible = "Realtek,rtk-sb2";
+		reg = <0x0 0x9801a000 0x0 0x900>;
+		interrupts = <0 36 4>;
+		status = "okay";
+	};
+	
+	watchdog@0x98007680 {
+		compatible = "Realtek,rtk-watchdog";
+		reg = <0x0 0x98007680 0x0 0x100>;
+		rst-oe = <0>; /* 0:input, 1:output */
+		status = "okay";
+	};
+
+	rtk-rstctrl@0x98007000 {
+		compatible = "Realtek,rtk-rstctrl";
+		reg = <0x0 0x98007600 0x0 0x100>;
+		rst-reg-offset = <0x40>;
+	};
+};
diff --git a/arch/arm64/configs/ranchu64_defconfig b/arch/arm64/configs/ranchu64_defconfig
new file mode 100644
index 00000000..fc55008
--- /dev/null
+++ b/arch/arm64/configs/ranchu64_defconfig
@@ -0,0 +1,312 @@
+# CONFIG_LOCALVERSION_AUTO is not set
+# CONFIG_SWAP is not set
+CONFIG_POSIX_MQUEUE=y
+CONFIG_AUDIT=y
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_BSD_PROCESS_ACCT=y
+CONFIG_BSD_PROCESS_ACCT_V3=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_LOG_BUF_SHIFT=14
+CONFIG_CGROUP_DEBUG=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_SCHED_AUTOGROUP=y
+CONFIG_BLK_DEV_INITRD=y
+CONFIG_KALLSYMS_ALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_COMPAT_BRK is not set
+CONFIG_PROFILING=y
+CONFIG_ARCH_MMAP_RND_BITS=24
+CONFIG_ARCH_MMAP_RND_COMPAT_BITS=16
+# CONFIG_BLK_DEV_BSG is not set
+# CONFIG_IOSCHED_DEADLINE is not set
+CONFIG_ARCH_VEXPRESS=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+CONFIG_KSM=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+CONFIG_CMDLINE="console=ttyAMA0"
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_AUTOSLEEP=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_XFRM_USER=y
+CONFIG_NET_KEY=y
+CONFIG_INET=y
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_INET_ESP=y
+# CONFIG_INET_LRO is not set
+CONFIG_IPV6_ROUTER_PREF=y
+CONFIG_IPV6_ROUTE_INFO=y
+CONFIG_IPV6_OPTIMISTIC_DAD=y
+CONFIG_INET6_AH=y
+CONFIG_INET6_ESP=y
+CONFIG_INET6_IPCOMP=y
+CONFIG_IPV6_MIP6=y
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_NETFILTER=y
+CONFIG_NF_CONNTRACK=y
+CONFIG_NF_CONNTRACK_SECMARK=y
+CONFIG_NF_CONNTRACK_EVENTS=y
+CONFIG_NF_CT_PROTO_DCCP=y
+CONFIG_NF_CT_PROTO_SCTP=y
+CONFIG_NF_CT_PROTO_UDPLITE=y
+CONFIG_NF_CONNTRACK_AMANDA=y
+CONFIG_NF_CONNTRACK_FTP=y
+CONFIG_NF_CONNTRACK_H323=y
+CONFIG_NF_CONNTRACK_IRC=y
+CONFIG_NF_CONNTRACK_NETBIOS_NS=y
+CONFIG_NF_CONNTRACK_PPTP=y
+CONFIG_NF_CONNTRACK_SANE=y
+CONFIG_NF_CONNTRACK_TFTP=y
+CONFIG_NF_CT_NETLINK=y
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=y
+CONFIG_NETFILTER_XT_TARGET_CONNMARK=y
+CONFIG_NETFILTER_XT_TARGET_CONNSECMARK=y
+CONFIG_NETFILTER_XT_TARGET_IDLETIMER=y
+CONFIG_NETFILTER_XT_TARGET_MARK=y
+CONFIG_NETFILTER_XT_TARGET_NFLOG=y
+CONFIG_NETFILTER_XT_TARGET_NFQUEUE=y
+CONFIG_NETFILTER_XT_TARGET_TPROXY=y
+CONFIG_NETFILTER_XT_TARGET_TRACE=y
+CONFIG_NETFILTER_XT_TARGET_SECMARK=y
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=y
+CONFIG_NETFILTER_XT_MATCH_COMMENT=y
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=y
+CONFIG_NETFILTER_XT_MATCH_CONNMARK=y
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=y
+CONFIG_NETFILTER_XT_MATCH_HASHLIMIT=y
+CONFIG_NETFILTER_XT_MATCH_HELPER=y
+CONFIG_NETFILTER_XT_MATCH_IPRANGE=y
+CONFIG_NETFILTER_XT_MATCH_LENGTH=y
+CONFIG_NETFILTER_XT_MATCH_LIMIT=y
+CONFIG_NETFILTER_XT_MATCH_MAC=y
+CONFIG_NETFILTER_XT_MATCH_MARK=y
+CONFIG_NETFILTER_XT_MATCH_POLICY=y
+CONFIG_NETFILTER_XT_MATCH_PKTTYPE=y
+CONFIG_NETFILTER_XT_MATCH_QTAGUID=y
+CONFIG_NETFILTER_XT_MATCH_QUOTA=y
+CONFIG_NETFILTER_XT_MATCH_QUOTA2=y
+CONFIG_NETFILTER_XT_MATCH_SOCKET=y
+CONFIG_NETFILTER_XT_MATCH_STATE=y
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=y
+CONFIG_NETFILTER_XT_MATCH_STRING=y
+CONFIG_NETFILTER_XT_MATCH_TIME=y
+CONFIG_NETFILTER_XT_MATCH_U32=y
+CONFIG_NF_CONNTRACK_IPV4=y
+CONFIG_IP_NF_IPTABLES=y
+CONFIG_IP_NF_MATCH_AH=y
+CONFIG_IP_NF_MATCH_ECN=y
+CONFIG_IP_NF_MATCH_RPFILTER=y
+CONFIG_IP_NF_MATCH_TTL=y
+CONFIG_IP_NF_FILTER=y
+CONFIG_IP_NF_TARGET_REJECT=y
+CONFIG_IP_NF_MANGLE=y
+CONFIG_IP_NF_TARGET_ECN=y
+CONFIG_IP_NF_TARGET_TTL=y
+CONFIG_IP_NF_RAW=y
+CONFIG_IP_NF_SECURITY=y
+CONFIG_IP_NF_ARPTABLES=y
+CONFIG_IP_NF_ARPFILTER=y
+CONFIG_IP_NF_ARP_MANGLE=y
+CONFIG_NF_CONNTRACK_IPV6=y
+CONFIG_IP6_NF_IPTABLES=y
+CONFIG_IP6_NF_MATCH_AH=y
+CONFIG_IP6_NF_MATCH_EUI64=y
+CONFIG_IP6_NF_MATCH_FRAG=y
+CONFIG_IP6_NF_MATCH_OPTS=y
+CONFIG_IP6_NF_MATCH_HL=y
+CONFIG_IP6_NF_MATCH_IPV6HEADER=y
+CONFIG_IP6_NF_MATCH_MH=y
+CONFIG_IP6_NF_MATCH_RT=y
+CONFIG_IP6_NF_TARGET_HL=y
+CONFIG_IP6_NF_FILTER=y
+CONFIG_IP6_NF_TARGET_REJECT=y
+CONFIG_IP6_NF_MANGLE=y
+CONFIG_IP6_NF_RAW=y
+CONFIG_BRIDGE=y
+CONFIG_NET_SCHED=y
+CONFIG_NET_SCH_HTB=y
+CONFIG_NET_CLS_U32=y
+CONFIG_NET_EMATCH=y
+CONFIG_NET_EMATCH_U32=y
+CONFIG_NET_CLS_ACT=y
+# CONFIG_WIRELESS is not set
+CONFIG_UEVENT_HELPER_PATH="/sbin/hotplug"
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_RAM_SIZE=8192
+CONFIG_VIRTIO_BLK=y
+CONFIG_SCSI=y
+# CONFIG_SCSI_PROC_FS is not set
+CONFIG_BLK_DEV_SD=y
+# CONFIG_SCSI_LOWLEVEL is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=y
+CONFIG_DM_UEVENT=y
+CONFIG_DM_VERITY=y
+CONFIG_DM_VERITY_FEC=y
+CONFIG_NETDEVICES=y
+CONFIG_TUN=y
+CONFIG_VIRTIO_NET=y
+CONFIG_SMC91X=y
+CONFIG_PPP=y
+CONFIG_PPP_BSDCOMP=y
+CONFIG_PPP_DEFLATE=y
+CONFIG_PPP_MPPE=y
+CONFIG_PPPOLAC=y
+CONFIG_PPPOPNS=y
+# CONFIG_WLAN is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_INPUT_KEYRESET=y
+CONFIG_KEYBOARD_GOLDFISH_EVENTS=y
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_JOYSTICK=y
+CONFIG_INPUT_TABLET=y
+CONFIG_INPUT_MISC=y
+CONFIG_INPUT_KEYCHORD=y
+CONFIG_INPUT_UINPUT=y
+CONFIG_INPUT_GPIO=y
+# CONFIG_SERIO_SERPORT is not set
+# CONFIG_VT is not set
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_AMBA_PL011=y
+CONFIG_SERIAL_AMBA_PL011_CONSOLE=y
+CONFIG_VIRTIO_CONSOLE=y
+# CONFIG_HW_RANDOM is not set
+CONFIG_BATTERY_GOLDFISH=y
+# CONFIG_HWMON is not set
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_FB=y
+CONFIG_FB_GOLDFISH=y
+CONFIG_FB_SIMPLE=y
+CONFIG_BACKLIGHT_LCD_SUPPORT=y
+CONFIG_LOGO=y
+# CONFIG_LOGO_LINUX_MONO is not set
+# CONFIG_LOGO_LINUX_VGA16 is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_HIDRAW=y
+CONFIG_UHID=y
+CONFIG_HID_A4TECH=y
+CONFIG_HID_ACRUX=y
+CONFIG_HID_ACRUX_FF=y
+CONFIG_HID_APPLE=y
+CONFIG_HID_BELKIN=y
+CONFIG_HID_CHERRY=y
+CONFIG_HID_CHICONY=y
+CONFIG_HID_PRODIKEYS=y
+CONFIG_HID_CYPRESS=y
+CONFIG_HID_DRAGONRISE=y
+CONFIG_DRAGONRISE_FF=y
+CONFIG_HID_EMS_FF=y
+CONFIG_HID_ELECOM=y
+CONFIG_HID_EZKEY=y
+CONFIG_HID_KEYTOUCH=y
+CONFIG_HID_KYE=y
+CONFIG_HID_WALTOP=y
+CONFIG_HID_GYRATION=y
+CONFIG_HID_TWINHAN=y
+CONFIG_HID_KENSINGTON=y
+CONFIG_HID_LCPOWER=y
+CONFIG_HID_LOGITECH=y
+CONFIG_HID_LOGITECH_DJ=y
+CONFIG_LOGITECH_FF=y
+CONFIG_LOGIRUMBLEPAD2_FF=y
+CONFIG_LOGIG940_FF=y
+CONFIG_HID_MAGICMOUSE=y
+CONFIG_HID_MICROSOFT=y
+CONFIG_HID_MONTEREY=y
+CONFIG_HID_MULTITOUCH=y
+CONFIG_HID_ORTEK=y
+CONFIG_HID_PANTHERLORD=y
+CONFIG_PANTHERLORD_FF=y
+CONFIG_HID_PETALYNX=y
+CONFIG_HID_PICOLCD=y
+CONFIG_HID_PRIMAX=y
+CONFIG_HID_SAITEK=y
+CONFIG_HID_SAMSUNG=y
+CONFIG_HID_SPEEDLINK=y
+CONFIG_HID_SUNPLUS=y
+CONFIG_HID_GREENASIA=y
+CONFIG_GREENASIA_FF=y
+CONFIG_HID_SMARTJOYPLUS=y
+CONFIG_SMARTJOYPLUS_FF=y
+CONFIG_HID_TIVO=y
+CONFIG_HID_TOPSEED=y
+CONFIG_HID_THRUSTMASTER=y
+CONFIG_HID_WACOM=y
+CONFIG_HID_WIIMOTE=y
+CONFIG_HID_ZEROPLUS=y
+CONFIG_HID_ZYDACRON=y
+# CONFIG_USB_SUPPORT is not set
+CONFIG_RTC_CLASS=y
+CONFIG_VIRTIO_MMIO=y
+CONFIG_STAGING=y
+CONFIG_ASHMEM=y
+CONFIG_ANDROID_TIMED_GPIO=y
+CONFIG_ANDROID_LOW_MEMORY_KILLER=y
+CONFIG_SYNC=y
+CONFIG_SW_SYNC=y
+CONFIG_SW_SYNC_USER=y
+CONFIG_ION=y
+CONFIG_GOLDFISH_AUDIO=y
+CONFIG_GOLDFISH=y
+CONFIG_GOLDFISH_PIPE=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_ANDROID=y
+CONFIG_ANDROID_BINDER_IPC=y
+CONFIG_EXT2_FS=y
+CONFIG_EXT4_FS=y
+CONFIG_EXT4_FS_SECURITY=y
+CONFIG_QUOTA=y
+CONFIG_FUSE_FS=y
+CONFIG_CUSE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_POSIX_ACL=y
+# CONFIG_MISC_FILESYSTEMS is not set
+CONFIG_NFS_FS=y
+CONFIG_ROOT_NFS=y
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_FS=y
+CONFIG_MAGIC_SYSRQ=y
+CONFIG_PANIC_TIMEOUT=5
+# CONFIG_SCHED_DEBUG is not set
+CONFIG_SCHEDSTATS=y
+CONFIG_TIMER_STATS=y
+# CONFIG_FTRACE is not set
+CONFIG_ATOMIC64_SELFTEST=y
+CONFIG_DEBUG_RODATA=y
+CONFIG_SECURITY=y
+CONFIG_SECURITY_NETWORK=y
+CONFIG_SECURITY_SELINUX=y
diff --git a/arch/arm64/configs/rtd1295_lede_emmc_defconfig b/arch/arm64/configs/rtd1295_lede_emmc_defconfig
new file mode 100644
index 00000000..9979bfd
--- /dev/null
+++ b/arch/arm64/configs/rtd1295_lede_emmc_defconfig
@@ -0,0 +1,437 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_SYSFS_DEPRECATED=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_COMPRESS_OFFLOAD=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+# CONFIG_SND_REALTEK is not set
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_MMC=y
+CONFIG_MMC_RTK_EMMC=y
+CONFIG_MMC_RTK_SDMMC=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+CONFIG_F2FS_FS=y
+# CONFIG_F2FS_FS_POSIX_ACL is not set
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=m
+# CONFIG_NFS_V2 is not set
+CONFIG_NFS_V4=m
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1295_lede_spi_defconfig b/arch/arm64/configs/rtd1295_lede_spi_defconfig
new file mode 100644
index 00000000..7ec299d
--- /dev/null
+++ b/arch/arm64/configs/rtd1295_lede_spi_defconfig
@@ -0,0 +1,444 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_SYSFS_DEPRECATED=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+CONFIG_MTD_RTK_SFC_PSTORE=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_COMPRESS_OFFLOAD=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+# CONFIG_SND_REALTEK is not set
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_JFFS2_FS=y
+CONFIG_JFFS2_SUMMARY=y
+CONFIG_JFFS2_FS_XATTR=y
+# CONFIG_JFFS2_FS_POSIX_ACL is not set
+# CONFIG_JFFS2_FS_SECURITY is not set
+CONFIG_JFFS2_COMPRESSION_OPTIONS=y
+# CONFIG_JFFS2_ZLIB is not set
+CONFIG_JFFS2_LZMA=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=m
+# CONFIG_NFS_V2 is not set
+CONFIG_NFS_V4=m
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_CRC32=y
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1295_lede_transcode_emmc_defconfig b/arch/arm64/configs/rtd1295_lede_transcode_emmc_defconfig
new file mode 100644
index 00000000..4a3b4e8
--- /dev/null
+++ b/arch/arm64/configs/rtd1295_lede_transcode_emmc_defconfig
@@ -0,0 +1,448 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_MMC=y
+CONFIG_MMC_RTK_EMMC=y
+CONFIG_MMC_RTK_SDMMC=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_VE1_CODEC=y
+CONFIG_VE3_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+CONFIG_F2FS_FS=y
+# CONFIG_F2FS_FS_POSIX_ACL is not set
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1295_lede_transcode_spi_defconfig b/arch/arm64/configs/rtd1295_lede_transcode_spi_defconfig
new file mode 100644
index 00000000..700b2b3
--- /dev/null
+++ b/arch/arm64/configs/rtd1295_lede_transcode_spi_defconfig
@@ -0,0 +1,455 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+CONFIG_MTD_RTK_SFC_PSTORE=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_VE1_CODEC=y
+CONFIG_VE3_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_JFFS2_FS=y
+CONFIG_JFFS2_SUMMARY=y
+CONFIG_JFFS2_FS_XATTR=y
+# CONFIG_JFFS2_FS_POSIX_ACL is not set
+# CONFIG_JFFS2_FS_SECURITY is not set
+CONFIG_JFFS2_COMPRESSION_OPTIONS=y
+# CONFIG_JFFS2_ZLIB is not set
+CONFIG_JFFS2_LZMA=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_CRC32=y
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1295_lede_video_emmc_defconfig b/arch/arm64/configs/rtd1295_lede_video_emmc_defconfig
new file mode 100644
index 00000000..6198b65
--- /dev/null
+++ b/arch/arm64/configs/rtd1295_lede_video_emmc_defconfig
@@ -0,0 +1,453 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_KEYBOARD_GPIO=y
+CONFIG_INPUT_MISC=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_RTK_HDMITX=y
+CONFIG_RTK_HDCP_1x=y
+CONFIG_RTK_DPTX=y
+# CONFIG_DVB_TUNER_DIB0070 is not set
+# CONFIG_DVB_TUNER_DIB0090 is not set
+# CONFIG_VGA_ARB is not set
+CONFIG_DRM=y
+CONFIG_DRM_RTK=y
+CONFIG_FB_SIMPLE=y
+CONFIG_FRAMEBUFFER_CONSOLE=y
+CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+CONFIG_SND_HRTIMER=y
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_USB_AUDIO=y
+CONFIG_SND_SOC=y
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_MMC=y
+CONFIG_MMC_RTK_EMMC=y
+CONFIG_MMC_RTK_SDMMC=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_MCP=y
+CONFIG_RTK_AVCPU_LOG=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_VE1_CODEC=y
+CONFIG_VE3_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+CONFIG_F2FS_FS=y
+# CONFIG_F2FS_FS_POSIX_ACL is not set
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1295_lede_video_spi_defconfig b/arch/arm64/configs/rtd1295_lede_video_spi_defconfig
new file mode 100644
index 00000000..0b8967e
--- /dev/null
+++ b/arch/arm64/configs/rtd1295_lede_video_spi_defconfig
@@ -0,0 +1,460 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+CONFIG_MTD_RTK_SFC_PSTORE=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_KEYBOARD_GPIO=y
+CONFIG_INPUT_MISC=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_RTK_HDMITX=y
+CONFIG_RTK_HDCP_1x=y
+CONFIG_RTK_DPTX=y
+# CONFIG_DVB_TUNER_DIB0070 is not set
+# CONFIG_DVB_TUNER_DIB0090 is not set
+# CONFIG_VGA_ARB is not set
+CONFIG_DRM=y
+CONFIG_DRM_RTK=y
+CONFIG_FB_SIMPLE=y
+CONFIG_FRAMEBUFFER_CONSOLE=y
+CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+CONFIG_SND_HRTIMER=y
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_USB_AUDIO=y
+CONFIG_SND_SOC=y
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_MCP=y
+CONFIG_RTK_AVCPU_LOG=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_VE1_CODEC=y
+CONFIG_VE3_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_JFFS2_FS=y
+CONFIG_JFFS2_SUMMARY=y
+CONFIG_JFFS2_FS_XATTR=y
+# CONFIG_JFFS2_FS_POSIX_ACL is not set
+# CONFIG_JFFS2_FS_SECURITY is not set
+CONFIG_JFFS2_COMPRESSION_OPTIONS=y
+# CONFIG_JFFS2_ZLIB is not set
+CONFIG_JFFS2_LZMA=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_CRC32=y
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1296_lede_emmc_defconfig b/arch/arm64/configs/rtd1296_lede_emmc_defconfig
new file mode 100644
index 00000000..7ec299d
--- /dev/null
+++ b/arch/arm64/configs/rtd1296_lede_emmc_defconfig
@@ -0,0 +1,444 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_SYSFS_DEPRECATED=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+CONFIG_MTD_RTK_SFC_PSTORE=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_COMPRESS_OFFLOAD=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+# CONFIG_SND_REALTEK is not set
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_JFFS2_FS=y
+CONFIG_JFFS2_SUMMARY=y
+CONFIG_JFFS2_FS_XATTR=y
+# CONFIG_JFFS2_FS_POSIX_ACL is not set
+# CONFIG_JFFS2_FS_SECURITY is not set
+CONFIG_JFFS2_COMPRESSION_OPTIONS=y
+# CONFIG_JFFS2_ZLIB is not set
+CONFIG_JFFS2_LZMA=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=m
+# CONFIG_NFS_V2 is not set
+CONFIG_NFS_V4=m
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_CRC32=y
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1296_lede_spi_defconfig b/arch/arm64/configs/rtd1296_lede_spi_defconfig
new file mode 100644
index 00000000..7ec299d
--- /dev/null
+++ b/arch/arm64/configs/rtd1296_lede_spi_defconfig
@@ -0,0 +1,444 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_SYSFS_DEPRECATED=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+CONFIG_MTD_RTK_SFC_PSTORE=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_COMPRESS_OFFLOAD=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+# CONFIG_SND_REALTEK is not set
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_JFFS2_FS=y
+CONFIG_JFFS2_SUMMARY=y
+CONFIG_JFFS2_FS_XATTR=y
+# CONFIG_JFFS2_FS_POSIX_ACL is not set
+# CONFIG_JFFS2_FS_SECURITY is not set
+CONFIG_JFFS2_COMPRESSION_OPTIONS=y
+# CONFIG_JFFS2_ZLIB is not set
+CONFIG_JFFS2_LZMA=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=m
+# CONFIG_NFS_V2 is not set
+CONFIG_NFS_V4=m
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_CRC32=y
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1296_lede_transcode_emmc_defconfig b/arch/arm64/configs/rtd1296_lede_transcode_emmc_defconfig
new file mode 100644
index 00000000..4a3b4e8
--- /dev/null
+++ b/arch/arm64/configs/rtd1296_lede_transcode_emmc_defconfig
@@ -0,0 +1,448 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_MMC=y
+CONFIG_MMC_RTK_EMMC=y
+CONFIG_MMC_RTK_SDMMC=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_VE1_CODEC=y
+CONFIG_VE3_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+CONFIG_F2FS_FS=y
+# CONFIG_F2FS_FS_POSIX_ACL is not set
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1296_lede_transcode_spi_defconfig b/arch/arm64/configs/rtd1296_lede_transcode_spi_defconfig
new file mode 100644
index 00000000..700b2b3
--- /dev/null
+++ b/arch/arm64/configs/rtd1296_lede_transcode_spi_defconfig
@@ -0,0 +1,455 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+CONFIG_MTD_RTK_SFC_PSTORE=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_VE1_CODEC=y
+CONFIG_VE3_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_JFFS2_FS=y
+CONFIG_JFFS2_SUMMARY=y
+CONFIG_JFFS2_FS_XATTR=y
+# CONFIG_JFFS2_FS_POSIX_ACL is not set
+# CONFIG_JFFS2_FS_SECURITY is not set
+CONFIG_JFFS2_COMPRESSION_OPTIONS=y
+# CONFIG_JFFS2_ZLIB is not set
+CONFIG_JFFS2_LZMA=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_CRC32=y
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1296_lede_video_emmc_defconfig b/arch/arm64/configs/rtd1296_lede_video_emmc_defconfig
new file mode 100644
index 00000000..6198b65
--- /dev/null
+++ b/arch/arm64/configs/rtd1296_lede_video_emmc_defconfig
@@ -0,0 +1,453 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_KEYBOARD_GPIO=y
+CONFIG_INPUT_MISC=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_RTK_HDMITX=y
+CONFIG_RTK_HDCP_1x=y
+CONFIG_RTK_DPTX=y
+# CONFIG_DVB_TUNER_DIB0070 is not set
+# CONFIG_DVB_TUNER_DIB0090 is not set
+# CONFIG_VGA_ARB is not set
+CONFIG_DRM=y
+CONFIG_DRM_RTK=y
+CONFIG_FB_SIMPLE=y
+CONFIG_FRAMEBUFFER_CONSOLE=y
+CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+CONFIG_SND_HRTIMER=y
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_USB_AUDIO=y
+CONFIG_SND_SOC=y
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_MMC=y
+CONFIG_MMC_RTK_EMMC=y
+CONFIG_MMC_RTK_SDMMC=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_MCP=y
+CONFIG_RTK_AVCPU_LOG=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_VE1_CODEC=y
+CONFIG_VE3_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+CONFIG_F2FS_FS=y
+# CONFIG_F2FS_FS_POSIX_ACL is not set
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd1296_lede_video_spi_defconfig b/arch/arm64/configs/rtd1296_lede_video_spi_defconfig
new file mode 100644
index 00000000..0b8967e
--- /dev/null
+++ b/arch/arm64/configs/rtd1296_lede_video_spi_defconfig
@@ -0,0 +1,460 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD129x=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD129x_SLOT1=y
+CONFIG_PCIE_RTD129x_SLOT2=y
+# CONFIG_ARM64_ERRATUM_1024718 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=4
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_CPUFREQ_DT=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+CONFIG_MTD_RTK_SFC_PSTORE=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_NVME=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_KEYBOARD_GPIO=y
+CONFIG_INPUT_MISC=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_MFD_G2227_I2C=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_G2227=y
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_RTK_HDMITX=y
+CONFIG_RTK_HDCP_1x=y
+CONFIG_RTK_DPTX=y
+# CONFIG_DVB_TUNER_DIB0070 is not set
+# CONFIG_DVB_TUNER_DIB0090 is not set
+# CONFIG_VGA_ARB is not set
+CONFIG_DRM=y
+CONFIG_DRM_RTK=y
+CONFIG_FB_SIMPLE=y
+CONFIG_FRAMEBUFFER_CONSOLE=y
+CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+CONFIG_SND_HRTIMER=y
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_USB_AUDIO=y
+CONFIG_SND_SOC=y
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_ROOT_HUB_TT=y
+CONFIG_USB_EHCI_RTK=y
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_OHCI_RTK=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_USB_GADGET=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_DMADEVICES=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_MCP=y
+CONFIG_RTK_AVCPU_LOG=y
+CONFIG_POWER_CONTROL=y
+CONFIG_RTK_HSE=y
+CONFIG_RTK_FAN=y
+CONFIG_VE1_CODEC=y
+CONFIG_VE3_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_JFFS2_FS=y
+CONFIG_JFFS2_SUMMARY=y
+CONFIG_JFFS2_FS_XATTR=y
+# CONFIG_JFFS2_FS_POSIX_ACL is not set
+# CONFIG_JFFS2_FS_SECURITY is not set
+CONFIG_JFFS2_COMPRESSION_OPTIONS=y
+# CONFIG_JFFS2_ZLIB is not set
+CONFIG_JFFS2_LZMA=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_CRC32=y
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd16xx_lede_emmc_defconfig b/arch/arm64/configs/rtd16xx_lede_emmc_defconfig
new file mode 100644
index 00000000..d481079d
--- /dev/null
+++ b/arch/arm64/configs/rtd16xx_lede_emmc_defconfig
@@ -0,0 +1,452 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD16xx=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD16xx_SLOT1=y
+CONFIG_PCIE_RTD16xx_SLOT2=y
+# CONFIG_ARM64_ERRATUM_826319 is not set
+# CONFIG_ARM64_ERRATUM_827319 is not set
+# CONFIG_ARM64_ERRATUM_824069 is not set
+# CONFIG_ARM64_ERRATUM_819472 is not set
+# CONFIG_ARM64_ERRATUM_832075 is not set
+# CONFIG_ARM64_ERRATUM_845719 is not set
+# CONFIG_ARM64_ERRATUM_843419 is not set
+# CONFIG_CAVIUM_ERRATUM_22375 is not set
+# CONFIG_CAVIUM_ERRATUM_23154 is not set
+# CONFIG_CAVIUM_ERRATUM_27456 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=6
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8125=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+CONFIG_USB_NET_DRIVERS=m
+CONFIG_USB_RTL8152=m
+CONFIG_USB_USBNET=m
+# CONFIG_USB_NET_AX8817X is not set
+# CONFIG_USB_NET_AX88179_178A is not set
+# CONFIG_USB_NET_CDCETHER is not set
+# CONFIG_USB_NET_CDC_NCM is not set
+# CONFIG_USB_NET_NET1080 is not set
+# CONFIG_USB_NET_CDC_SUBSET is not set
+# CONFIG_USB_NET_ZAURUS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_SY8827E=y
+CONFIG_REGULATOR_I2C_SELECTOR=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_COMPRESS_OFFLOAD=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+# CONFIG_SND_REALTEK is not set
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_RTK_USB_RLE0599_PHY=y
+CONFIG_USB_GADGET=y
+CONFIG_MMC=y
+CONFIG_MMC_RTK_EMMC=y
+CONFIG_MMC_RTK_SDMMC=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_SB2_SECURITY_DEBG=y
+CONFIG_RTK_MCP=y
+# CONFIG_RTK_RPC is not set
+CONFIG_POWER_CONTROL=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+CONFIG_F2FS_FS=y
+# CONFIG_F2FS_FS_POSIX_ACL is not set
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd16xx_lede_spi_defconfig b/arch/arm64/configs/rtd16xx_lede_spi_defconfig
new file mode 100644
index 00000000..3f213b0
--- /dev/null
+++ b/arch/arm64/configs/rtd16xx_lede_spi_defconfig
@@ -0,0 +1,463 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD16xx=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD16xx_SLOT1=y
+CONFIG_PCIE_RTD16xx_SLOT2=y
+# CONFIG_ARM64_ERRATUM_826319 is not set
+# CONFIG_ARM64_ERRATUM_827319 is not set
+# CONFIG_ARM64_ERRATUM_824069 is not set
+# CONFIG_ARM64_ERRATUM_819472 is not set
+# CONFIG_ARM64_ERRATUM_832075 is not set
+# CONFIG_ARM64_ERRATUM_845719 is not set
+# CONFIG_ARM64_ERRATUM_843419 is not set
+# CONFIG_CAVIUM_ERRATUM_22375 is not set
+# CONFIG_CAVIUM_ERRATUM_23154 is not set
+# CONFIG_CAVIUM_ERRATUM_27456 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=6
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+CONFIG_MTD_RTK_SFC=y
+CONFIG_MTD_RTK_SFC_READ_MD=y
+CONFIG_MTD_RTK_SFC_WRITE_MD=y
+CONFIG_NOR_AUTO_HW_POLLING=y
+CONFIG_MTD_RTK_SFC_PSTORE=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8125=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+CONFIG_USB_NET_DRIVERS=m
+CONFIG_USB_RTL8152=m
+CONFIG_USB_USBNET=m
+# CONFIG_USB_NET_AX8817X is not set
+# CONFIG_USB_NET_AX88179_178A is not set
+# CONFIG_USB_NET_CDCETHER is not set
+# CONFIG_USB_NET_CDC_NCM is not set
+# CONFIG_USB_NET_NET1080 is not set
+# CONFIG_USB_NET_CDC_SUBSET is not set
+# CONFIG_USB_NET_ZAURUS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_SY8827E=y
+CONFIG_REGULATOR_I2C_SELECTOR=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_COMPRESS_OFFLOAD=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+# CONFIG_SND_REALTEK is not set
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_RTK_USB_RLE0599_PHY=y
+CONFIG_USB_GADGET=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_SB2_SECURITY_DEBG=y
+CONFIG_RTK_MCP=y
+# CONFIG_RTK_RPC is not set
+CONFIG_POWER_CONTROL=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_JFFS2_FS=y
+CONFIG_JFFS2_SUMMARY=y
+CONFIG_JFFS2_FS_XATTR=y
+# CONFIG_JFFS2_FS_POSIX_ACL is not set
+# CONFIG_JFFS2_FS_SECURITY is not set
+CONFIG_JFFS2_COMPRESSION_OPTIONS=y
+# CONFIG_JFFS2_ZLIB is not set
+CONFIG_JFFS2_LZMA=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_CRC32=y
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd16xx_lede_transconde_emmc_defconfig b/arch/arm64/configs/rtd16xx_lede_transconde_emmc_defconfig
new file mode 100644
index 00000000..e787af0
--- /dev/null
+++ b/arch/arm64/configs/rtd16xx_lede_transconde_emmc_defconfig
@@ -0,0 +1,456 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD16xx=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD16xx_SLOT1=y
+CONFIG_PCIE_RTD16xx_SLOT2=y
+# CONFIG_ARM64_ERRATUM_826319 is not set
+# CONFIG_ARM64_ERRATUM_827319 is not set
+# CONFIG_ARM64_ERRATUM_824069 is not set
+# CONFIG_ARM64_ERRATUM_819472 is not set
+# CONFIG_ARM64_ERRATUM_832075 is not set
+# CONFIG_ARM64_ERRATUM_845719 is not set
+# CONFIG_ARM64_ERRATUM_843419 is not set
+# CONFIG_CAVIUM_ERRATUM_22375 is not set
+# CONFIG_CAVIUM_ERRATUM_23154 is not set
+# CONFIG_CAVIUM_ERRATUM_27456 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=6
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8125=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+CONFIG_USB_NET_DRIVERS=m
+CONFIG_USB_RTL8152=m
+CONFIG_USB_USBNET=m
+# CONFIG_USB_NET_AX8817X is not set
+# CONFIG_USB_NET_AX88179_178A is not set
+# CONFIG_USB_NET_CDCETHER is not set
+# CONFIG_USB_NET_CDC_NCM is not set
+# CONFIG_USB_NET_NET1080 is not set
+# CONFIG_USB_NET_CDC_SUBSET is not set
+# CONFIG_USB_NET_ZAURUS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_SY8827E=y
+CONFIG_REGULATOR_I2C_SELECTOR=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_RTK_USB_RLE0599_PHY=y
+CONFIG_USB_GADGET=y
+CONFIG_MMC=y
+CONFIG_MMC_RTK_EMMC=y
+CONFIG_MMC_RTK_SDMMC=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_SB2_SECURITY_DEBG=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_VE1_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+CONFIG_F2FS_FS=y
+# CONFIG_F2FS_FS_POSIX_ACL is not set
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd16xx_lede_transconde_spi_defconfig b/arch/arm64/configs/rtd16xx_lede_transconde_spi_defconfig
new file mode 100644
index 00000000..32e9acb
--- /dev/null
+++ b/arch/arm64/configs/rtd16xx_lede_transconde_spi_defconfig
@@ -0,0 +1,467 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD16xx=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD16xx_SLOT1=y
+CONFIG_PCIE_RTD16xx_SLOT2=y
+# CONFIG_ARM64_ERRATUM_826319 is not set
+# CONFIG_ARM64_ERRATUM_827319 is not set
+# CONFIG_ARM64_ERRATUM_824069 is not set
+# CONFIG_ARM64_ERRATUM_819472 is not set
+# CONFIG_ARM64_ERRATUM_832075 is not set
+# CONFIG_ARM64_ERRATUM_845719 is not set
+# CONFIG_ARM64_ERRATUM_843419 is not set
+# CONFIG_CAVIUM_ERRATUM_22375 is not set
+# CONFIG_CAVIUM_ERRATUM_23154 is not set
+# CONFIG_CAVIUM_ERRATUM_27456 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=6
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+CONFIG_MTD_RTK_SFC=y
+CONFIG_MTD_RTK_SFC_READ_MD=y
+CONFIG_MTD_RTK_SFC_WRITE_MD=y
+CONFIG_NOR_AUTO_HW_POLLING=y
+CONFIG_MTD_RTK_SFC_PSTORE=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8125=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+CONFIG_USB_NET_DRIVERS=m
+CONFIG_USB_RTL8152=m
+CONFIG_USB_USBNET=m
+# CONFIG_USB_NET_AX8817X is not set
+# CONFIG_USB_NET_AX88179_178A is not set
+# CONFIG_USB_NET_CDCETHER is not set
+# CONFIG_USB_NET_CDC_NCM is not set
+# CONFIG_USB_NET_NET1080 is not set
+# CONFIG_USB_NET_CDC_SUBSET is not set
+# CONFIG_USB_NET_ZAURUS is not set
+# CONFIG_WLAN is not set
+# CONFIG_INPUT_MOUSEDEV is not set
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_MISC=y
+# CONFIG_SERIO is not set
+CONFIG_VT_HW_CONSOLE_BINDING=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_I2C=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_SY8827E=y
+CONFIG_REGULATOR_I2C_SELECTOR=y
+# CONFIG_VGA_ARB is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_HWDEP=m
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+# CONFIG_SND_SUPPORT_OLD_API is not set
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_SOC=y
+# CONFIG_HID is not set
+# CONFIG_USB_HID is not set
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_RTK_USB_RLE0599_PHY=y
+CONFIG_USB_GADGET=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_SYNC_FILE=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_SB2_SECURITY_DEBG=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_VE1_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_JFFS2_FS=y
+CONFIG_JFFS2_SUMMARY=y
+CONFIG_JFFS2_FS_XATTR=y
+# CONFIG_JFFS2_FS_POSIX_ACL is not set
+# CONFIG_JFFS2_FS_SECURITY is not set
+CONFIG_JFFS2_COMPRESSION_OPTIONS=y
+# CONFIG_JFFS2_ZLIB is not set
+CONFIG_JFFS2_LZMA=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_CRC32=y
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd16xx_lede_video_emmc_defconfig b/arch/arm64/configs/rtd16xx_lede_video_emmc_defconfig
new file mode 100644
index 00000000..9ad0285
--- /dev/null
+++ b/arch/arm64/configs/rtd16xx_lede_video_emmc_defconfig
@@ -0,0 +1,462 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD16xx=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD16xx_SLOT1=y
+CONFIG_PCIE_RTD16xx_SLOT2=y
+# CONFIG_ARM64_ERRATUM_826319 is not set
+# CONFIG_ARM64_ERRATUM_827319 is not set
+# CONFIG_ARM64_ERRATUM_824069 is not set
+# CONFIG_ARM64_ERRATUM_819472 is not set
+# CONFIG_ARM64_ERRATUM_832075 is not set
+# CONFIG_ARM64_ERRATUM_845719 is not set
+# CONFIG_ARM64_ERRATUM_843419 is not set
+# CONFIG_CAVIUM_ERRATUM_22375 is not set
+# CONFIG_CAVIUM_ERRATUM_23154 is not set
+# CONFIG_CAVIUM_ERRATUM_27456 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=6
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8125=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+CONFIG_USB_NET_DRIVERS=m
+CONFIG_USB_RTL8152=m
+CONFIG_USB_USBNET=m
+# CONFIG_USB_NET_AX8817X is not set
+# CONFIG_USB_NET_AX88179_178A is not set
+# CONFIG_USB_NET_CDCETHER is not set
+# CONFIG_USB_NET_CDC_NCM is not set
+# CONFIG_USB_NET_NET1080 is not set
+# CONFIG_USB_NET_CDC_SUBSET is not set
+# CONFIG_USB_NET_ZAURUS is not set
+# CONFIG_WLAN is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_KEYBOARD_GPIO=y
+CONFIG_INPUT_MISC=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_SY8827E=y
+CONFIG_REGULATOR_I2C_SELECTOR=y
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_RTK_HDMITX=y
+CONFIG_RTK_HDCP_1x=y
+CONFIG_RTK_DPTX=y
+# CONFIG_DVB_TUNER_DIB0070 is not set
+# CONFIG_DVB_TUNER_DIB0090 is not set
+CONFIG_CEC=y
+CONFIG_RTK_CEC=y
+# CONFIG_VGA_ARB is not set
+CONFIG_DRM=y
+CONFIG_DRM_RTK=y
+CONFIG_FB_SIMPLE=y
+CONFIG_FRAMEBUFFER_CONSOLE=y
+CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+CONFIG_SND_HRTIMER=y
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_USB_AUDIO=y
+CONFIG_SND_SOC=y
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_RTK_USB_RLE0599_PHY=y
+CONFIG_USB_GADGET=y
+CONFIG_MMC=y
+CONFIG_MMC_RTK_EMMC=y
+CONFIG_MMC_RTK_SDMMC=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_SB2_SECURITY_DEBG=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_VE1_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+CONFIG_F2FS_FS=y
+# CONFIG_F2FS_FS_POSIX_ACL is not set
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd16xx_lede_video_spi_defconfig b/arch/arm64/configs/rtd16xx_lede_video_spi_defconfig
new file mode 100644
index 00000000..10922a4
--- /dev/null
+++ b/arch/arm64/configs/rtd16xx_lede_video_spi_defconfig
@@ -0,0 +1,471 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD16xx=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD16xx_SLOT1=y
+CONFIG_PCIE_RTD16xx_SLOT2=y
+# CONFIG_ARM64_ERRATUM_826319 is not set
+# CONFIG_ARM64_ERRATUM_827319 is not set
+# CONFIG_ARM64_ERRATUM_824069 is not set
+# CONFIG_ARM64_ERRATUM_819472 is not set
+# CONFIG_ARM64_ERRATUM_832075 is not set
+# CONFIG_ARM64_ERRATUM_845719 is not set
+# CONFIG_ARM64_ERRATUM_843419 is not set
+# CONFIG_CAVIUM_ERRATUM_22375 is not set
+# CONFIG_CAVIUM_ERRATUM_23154 is not set
+# CONFIG_CAVIUM_ERRATUM_27456 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=6
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_MTD=y
+CONFIG_MTD_CMDLINE_PARTS=y
+CONFIG_MTD_BLOCK=y
+# CONFIG_MTD_RTK_SFC_READ_MD is not set
+# CONFIG_MTD_RTK_SFC_WRITE_MD is not set
+CONFIG_MTD_RTK_SFC_PSTORE=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8125=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+CONFIG_USB_NET_DRIVERS=m
+CONFIG_USB_RTL8152=m
+CONFIG_USB_USBNET=m
+# CONFIG_USB_NET_AX8817X is not set
+# CONFIG_USB_NET_AX88179_178A is not set
+# CONFIG_USB_NET_CDCETHER is not set
+# CONFIG_USB_NET_CDC_NCM is not set
+# CONFIG_USB_NET_NET1080 is not set
+# CONFIG_USB_NET_CDC_SUBSET is not set
+# CONFIG_USB_NET_ZAURUS is not set
+# CONFIG_WLAN is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_KEYBOARD_GPIO=y
+CONFIG_INPUT_MISC=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_SY8827E=y
+CONFIG_REGULATOR_I2C_SELECTOR=y
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_RTK_HDMITX=y
+CONFIG_RTK_HDCP_1x=y
+CONFIG_RTK_DPTX=y
+# CONFIG_DVB_TUNER_DIB0070 is not set
+# CONFIG_DVB_TUNER_DIB0090 is not set
+CONFIG_CEC=y
+CONFIG_RTK_CEC=y
+# CONFIG_VGA_ARB is not set
+CONFIG_DRM=y
+CONFIG_DRM_RTK=y
+CONFIG_FB_SIMPLE=y
+CONFIG_FRAMEBUFFER_CONSOLE=y
+CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+CONFIG_SND_HRTIMER=y
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_USB_AUDIO=y
+CONFIG_SND_SOC=y
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_RTK_USB_RLE0599_PHY=y
+CONFIG_USB_GADGET=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_SB2_SECURITY_DEBG=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_VE1_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_JFFS2_FS=y
+CONFIG_JFFS2_SUMMARY=y
+CONFIG_JFFS2_FS_XATTR=y
+# CONFIG_JFFS2_FS_POSIX_ACL is not set
+# CONFIG_JFFS2_FS_SECURITY is not set
+CONFIG_JFFS2_COMPRESSION_OPTIONS=y
+# CONFIG_JFFS2_ZLIB is not set
+CONFIG_JFFS2_LZMA=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_CRC32=y
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/configs/rtd16xx_systemd_video_emmc_defconfig b/arch/arm64/configs/rtd16xx_systemd_video_emmc_defconfig
new file mode 100644
index 00000000..d18c9df
--- /dev/null
+++ b/arch/arm64/configs/rtd16xx_systemd_video_emmc_defconfig
@@ -0,0 +1,459 @@
+CONFIG_CROSS_COMPILE="aarch64-linux-"
+CONFIG_DEFAULT_HOSTNAME="Realtek-SoC"
+CONFIG_SYSVIPC=y
+# CONFIG_CROSS_MEMORY_ATTACH is not set
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_RCU_EXPERT=y
+CONFIG_RCU_FANOUT=32
+CONFIG_IKCONFIG=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_PIDS=y
+CONFIG_CGROUP_DEVICE=y
+CONFIG_CPUSETS=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_BLK_CGROUP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_CFS_BANDWIDTH=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_NAMESPACES=y
+CONFIG_SYSFS_DEPRECATED=y
+CONFIG_CRASHLOG=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_BZIP2 is not set
+# CONFIG_RD_LZMA is not set
+# CONFIG_RD_XZ is not set
+# CONFIG_RD_LZO is not set
+# CONFIG_RD_LZ4 is not set
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_KALLSYMS_UNCOMPRESSED=y
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_VM_EVENT_COUNTERS is not set
+# CONFIG_COMPAT_BRK is not set
+CONFIG_SLAB=y
+CONFIG_PROFILING=y
+CONFIG_JUMP_LABEL=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODULE_STRIPPED=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_ARCH_RTD16xx=y
+CONFIG_PCI=y
+CONFIG_PCIE_RTD16xx_SLOT1=y
+CONFIG_PCIE_RTD16xx_SLOT2=y
+# CONFIG_ARM64_ERRATUM_826319 is not set
+# CONFIG_ARM64_ERRATUM_827319 is not set
+# CONFIG_ARM64_ERRATUM_824069 is not set
+# CONFIG_ARM64_ERRATUM_819472 is not set
+# CONFIG_ARM64_ERRATUM_832075 is not set
+# CONFIG_ARM64_ERRATUM_845719 is not set
+# CONFIG_ARM64_ERRATUM_843419 is not set
+# CONFIG_CAVIUM_ERRATUM_22375 is not set
+# CONFIG_CAVIUM_ERRATUM_23154 is not set
+# CONFIG_CAVIUM_ERRATUM_27456 is not set
+# CONFIG_QCOM_QDF2400_ERRATUM_0065 is not set
+CONFIG_SCHED_MC=y
+CONFIG_SCHED_SMT=y
+CONFIG_NR_CPUS=6
+CONFIG_PREEMPT=y
+# CONFIG_COMPACTION is not set
+CONFIG_KSM=y
+CONFIG_CMA=y
+CONFIG_CMA_DEBUGFS=y
+CONFIG_ZSMALLOC=y
+CONFIG_SECCOMP=y
+CONFIG_ARMV8_DEPRECATED=y
+CONFIG_SWP_EMULATION=y
+CONFIG_CP15_BARRIER_EMULATION=y
+CONFIG_SETEND_EMULATION=y
+# CONFIG_ARM64_VHE is not set
+CONFIG_RANDOMIZE_BASE=y
+# CONFIG_EFI is not set
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_COMPAT=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_WQ_POWER_EFFICIENT_DEFAULT=y
+CONFIG_CPU_IDLE_GOV_LADDER=y
+CONFIG_ARM_CPUIDLE=y
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_STAT=y
+CONFIG_CPU_FREQ_STAT_DETAILS=y
+CONFIG_CPU_FREQ_GOV_POWERSAVE=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_CONSERVATIVE=y
+CONFIG_CPU_FREQ_GOV_INTERACTIVE=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_NET_IPGRE_DEMUX=m
+CONFIG_NET_IPGRE=m
+CONFIG_NET_IPGRE_BROADCAST=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_MROUTE_MULTIPLE_TABLES=y
+CONFIG_SYN_COOKIES=y
+# CONFIG_INET_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+CONFIG_TCP_CONG_HTCP=y
+CONFIG_TCP_CONG_LP=y
+CONFIG_DEFAULT_HTCP=y
+# CONFIG_INET6_XFRM_MODE_TRANSPORT is not set
+# CONFIG_INET6_XFRM_MODE_TUNNEL is not set
+# CONFIG_INET6_XFRM_MODE_BEET is not set
+# CONFIG_IPV6_SIT is not set
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_IPV6_SUBTREES=y
+CONFIG_IPV6_MROUTE=y
+# CONFIG_ANDROID_PARANOID_NETWORK is not set
+CONFIG_NETFILTER=y
+# CONFIG_BRIDGE_NETFILTER is not set
+# CONFIG_NETFILTER_INGRESS is not set
+CONFIG_NF_CONNTRACK=m
+CONFIG_NF_CONNTRACK_RTCACHE=m
+CONFIG_NF_CONNTRACK_FTP=m
+CONFIG_NETFILTER_XT_MARK=m
+CONFIG_NETFILTER_XT_CONNMARK=m
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=m
+CONFIG_NETFILTER_XT_TARGET_DSCP=m
+CONFIG_NETFILTER_XT_TARGET_HL=m
+CONFIG_NETFILTER_XT_TARGET_LOG=m
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_COMMENT=m
+CONFIG_NETFILTER_XT_MATCH_CONNBYTES=m
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=m
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=m
+CONFIG_NETFILTER_XT_MATCH_DSCP=m
+CONFIG_NETFILTER_XT_MATCH_ECN=m
+CONFIG_NETFILTER_XT_MATCH_HELPER=m
+CONFIG_NETFILTER_XT_MATCH_HL=m
+CONFIG_NETFILTER_XT_MATCH_LENGTH=m
+CONFIG_NETFILTER_XT_MATCH_LIMIT=m
+CONFIG_NETFILTER_XT_MATCH_MAC=m
+CONFIG_NETFILTER_XT_MATCH_MULTIPORT=m
+CONFIG_NETFILTER_XT_MATCH_RECENT=m
+CONFIG_NETFILTER_XT_MATCH_STATE=m
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=m
+CONFIG_NETFILTER_XT_MATCH_TCPMSS=m
+CONFIG_NETFILTER_XT_MATCH_TIME=m
+CONFIG_NF_CONNTRACK_IPV4=m
+CONFIG_IP_NF_IPTABLES=m
+CONFIG_IP_NF_FILTER=m
+CONFIG_IP_NF_TARGET_REJECT=m
+CONFIG_IP_NF_NAT=m
+CONFIG_IP_NF_TARGET_MASQUERADE=m
+CONFIG_IP_NF_TARGET_REDIRECT=m
+CONFIG_IP_NF_MANGLE=m
+CONFIG_IP_NF_TARGET_ECN=m
+CONFIG_NF_CONNTRACK_IPV6=m
+CONFIG_IP6_NF_IPTABLES=m
+CONFIG_IP6_NF_FILTER=m
+CONFIG_IP6_NF_TARGET_REJECT=m
+CONFIG_IP6_NF_MANGLE=m
+CONFIG_BRIDGE=y
+CONFIG_VLAN_8021Q=y
+# CONFIG_RTK_IR is not set
+CONFIG_WIRELESS_EXT=y
+CONFIG_WEXT_SPY=y
+CONFIG_WEXT_PRIV=y
+CONFIG_DEVTMPFS=y
+CONFIG_DEVTMPFS_MOUNT=y
+# CONFIG_FIRMWARE_IN_KERNEL is not set
+CONFIG_FW_LOADER_USER_HELPER_FALLBACK=y
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=32
+CONFIG_CMA_ALIGNMENT=4
+CONFIG_ARM_CCI400_PMU=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_ATA=y
+# CONFIG_ATA_VERBOSE_ERROR is not set
+# CONFIG_SATA_PMP is not set
+CONFIG_SATA_AHCI=y
+CONFIG_AHCI_RTK=y
+# CONFIG_ATA_SFF is not set
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=m
+CONFIG_MD_LINEAR=m
+CONFIG_MD_RAID0=m
+CONFIG_MD_RAID1=m
+CONFIG_MD_RAID10=m
+CONFIG_MD_RAID456=m
+CONFIG_MD_MULTIPATH=m
+CONFIG_BCACHE=m
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=m
+CONFIG_DM_MIRROR=m
+CONFIG_NETDEVICES=y
+CONFIG_BONDING=y
+CONFIG_NET_TEAM=y
+CONFIG_NET_TEAM_MODE_BROADCAST=y
+CONFIG_NET_TEAM_MODE_ROUNDROBIN=y
+CONFIG_NET_TEAM_MODE_RANDOM=y
+CONFIG_NET_TEAM_MODE_ACTIVEBACKUP=y
+CONFIG_NET_TEAM_MODE_LOADBALANCE=y
+# CONFIG_NET_VENDOR_3COM is not set
+# CONFIG_NET_VENDOR_ADAPTEC is not set
+# CONFIG_NET_VENDOR_AGERE is not set
+# CONFIG_NET_VENDOR_ALTEON is not set
+# CONFIG_NET_VENDOR_AMAZON is not set
+# CONFIG_NET_VENDOR_AMD is not set
+# CONFIG_NET_VENDOR_ARC is not set
+# CONFIG_NET_VENDOR_ATHEROS is not set
+# CONFIG_NET_CADENCE is not set
+# CONFIG_NET_VENDOR_BROADCOM is not set
+# CONFIG_NET_VENDOR_BROCADE is not set
+# CONFIG_NET_VENDOR_CAVIUM is not set
+# CONFIG_NET_VENDOR_CHELSIO is not set
+# CONFIG_NET_VENDOR_CISCO is not set
+# CONFIG_NET_VENDOR_DEC is not set
+# CONFIG_NET_VENDOR_DLINK is not set
+# CONFIG_NET_VENDOR_EMULEX is not set
+# CONFIG_NET_VENDOR_EZCHIP is not set
+# CONFIG_NET_VENDOR_EXAR is not set
+# CONFIG_NET_VENDOR_HISILICON is not set
+# CONFIG_NET_VENDOR_HP is not set
+# CONFIG_NET_VENDOR_INTEL is not set
+# CONFIG_NET_VENDOR_MARVELL is not set
+# CONFIG_NET_VENDOR_MELLANOX is not set
+# CONFIG_NET_VENDOR_MICREL is not set
+# CONFIG_NET_VENDOR_MYRI is not set
+# CONFIG_NET_VENDOR_NATSEMI is not set
+# CONFIG_NET_VENDOR_NETRONOME is not set
+# CONFIG_NET_VENDOR_NVIDIA is not set
+# CONFIG_NET_VENDOR_OKI is not set
+# CONFIG_NET_PACKET_ENGINE is not set
+# CONFIG_NET_VENDOR_QLOGIC is not set
+# CONFIG_NET_VENDOR_QUALCOMM is not set
+CONFIG_R8168=m
+CONFIG_R8169SOC=y
+# CONFIG_NET_VENDOR_RENESAS is not set
+# CONFIG_NET_VENDOR_RDC is not set
+# CONFIG_NET_VENDOR_ROCKER is not set
+# CONFIG_NET_VENDOR_SAMSUNG is not set
+# CONFIG_NET_VENDOR_SEEQ is not set
+# CONFIG_NET_VENDOR_SILAN is not set
+# CONFIG_NET_VENDOR_SIS is not set
+# CONFIG_NET_VENDOR_SMSC is not set
+# CONFIG_NET_VENDOR_STMICRO is not set
+# CONFIG_NET_VENDOR_SUN is not set
+# CONFIG_NET_VENDOR_SYNOPSYS is not set
+# CONFIG_NET_VENDOR_TEHUTI is not set
+# CONFIG_NET_VENDOR_TI is not set
+# CONFIG_NET_VENDOR_VIA is not set
+# CONFIG_NET_VENDOR_WIZNET is not set
+# CONFIG_USB_NET_DRIVERS is not set
+# CONFIG_WLAN is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_INPUT_MISC=y
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_RTK=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_CAVIUM is not set
+CONFIG_HW_RANDOM_REALTEK=y
+CONFIG_I2C_CHARDEV=y
+CONFIG_I2C_MUX=y
+CONFIG_I2C_RTK=y
+CONFIG_GPIOLIB=y
+CONFIG_GPIO_SYSFS=y
+CONFIG_THERMAL=y
+# CONFIG_THERMAL_HWMON is not set
+CONFIG_THERMAL_WRITABLE_TRIPS=y
+CONFIG_THERMAL_GOV_POWER_ALLOCATOR=y
+CONFIG_CPU_THERMAL=y
+CONFIG_DEVFREQ_THERMAL=y
+CONFIG_RTK_THERMAL_EOH=y
+CONFIG_WATCHDOG=y
+CONFIG_RTK_WATCHDOG=y
+CONFIG_REGULATOR=y
+CONFIG_REGULATOR_SY8827E=y
+CONFIG_REGULATOR_I2C_SELECTOR=y
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_RTK_HDMITX=y
+CONFIG_RTK_HDCP_1x=y
+CONFIG_RTK_DPTX=y
+# CONFIG_DVB_TUNER_DIB0070 is not set
+# CONFIG_DVB_TUNER_DIB0090 is not set
+CONFIG_CEC=y
+CONFIG_RTK_CEC=y
+# CONFIG_VGA_ARB is not set
+CONFIG_DRM=y
+CONFIG_DRM_RTK=y
+CONFIG_FB_SIMPLE=y
+CONFIG_FRAMEBUFFER_CONSOLE=y
+CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_SND_SEQUENCER=y
+CONFIG_SND_SEQ_DUMMY=y
+CONFIG_SND_MIXER_OSS=y
+CONFIG_SND_PCM_OSS=y
+CONFIG_SND_SEQUENCER_OSS=y
+CONFIG_SND_HRTIMER=y
+CONFIG_SND_VIRMIDI=m
+CONFIG_SND_USB_AUDIO=y
+CONFIG_SND_SOC=y
+CONFIG_USB=y
+CONFIG_USB_XHCI_HCD=y
+CONFIG_USB_OHCI_HCD=y
+# CONFIG_USB_OHCI_HCD_PCI is not set
+CONFIG_USB_STORAGE=y
+CONFIG_USB_STORAGE_REALTEK=y
+CONFIG_USB_UAS=y
+CONFIG_USB_DWC3=y
+CONFIG_USB_RTK_DWC3_DRD_MODE=y
+CONFIG_RTK_USB_RLE0599_PHY=y
+CONFIG_USB_GADGET=y
+CONFIG_MMC=y
+CONFIG_MMC_RTK_EMMC=y
+CONFIG_MMC_RTK_SDMMC=y
+CONFIG_RTC_CLASS=y
+CONFIG_RTC_DRV_RTK=y
+CONFIG_UIO=y
+CONFIG_UIO_RTK_SE=y
+CONFIG_UIO_RTK_MD=y
+CONFIG_STAGING=y
+CONFIG_ION=y
+CONFIG_ION_RTK=y
+# CONFIG_COMMON_CLK_XGENE is not set
+CONFIG_RTK_TIMER=y
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_SENDFILE_PATCH=y
+CONFIG_RTK_CODEC=y
+CONFIG_RTK_RESERVE_MEMORY=y
+CONFIG_IMAGE_CODEC=y
+CONFIG_RTK_SB2_SECURITY_DEBG=y
+CONFIG_RTK_MCP=y
+CONFIG_POWER_CONTROL=y
+CONFIG_VE1_CODEC=y
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_PM_DEVFREQ_EVENT=y
+CONFIG_PWM=y
+CONFIG_PWM_RTK=y
+CONFIG_PHY_RTK_SATA=y
+CONFIG_ANDROID=y
+CONFIG_NVMEM=y
+CONFIG_ACPI=y
+# CONFIG_ACPI_BUTTON is not set
+# CONFIG_ACPI_THERMAL is not set
+CONFIG_EXT2_FS=y
+CONFIG_EXT2_FS_XATTR=y
+CONFIG_EXT2_FS_POSIX_ACL=y
+CONFIG_EXT2_FS_SECURITY=y
+CONFIG_EXT3_FS=y
+CONFIG_EXT3_FS_POSIX_ACL=y
+CONFIG_EXT3_FS_SECURITY=y
+CONFIG_F2FS_FS=y
+# CONFIG_F2FS_FS_POSIX_ACL is not set
+# CONFIG_MANDATORY_FILE_LOCKING is not set
+# CONFIG_DNOTIFY is not set
+CONFIG_OVERLAY_FS=y
+CONFIG_FSCACHE=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_STRIPPED=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_XATTR=y
+CONFIG_ECRYPT_FS=y
+CONFIG_SQUASHFS=y
+CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU=y
+# CONFIG_SQUASHFS_ZLIB is not set
+CONFIG_SQUASHFS_XZ=y
+CONFIG_NFS_FS=y
+CONFIG_NFS_V3_ACL=y
+CONFIG_NFS_V4=y
+CONFIG_NFS_V4_1=y
+CONFIG_NFS_V4_2=y
+CONFIG_NFS_V4_1_MIGRATION=y
+CONFIG_ROOT_NFS=y
+CONFIG_NFSD=m
+CONFIG_NFSD_V4=y
+CONFIG_CIFS=y
+CONFIG_CIFS_STATS=y
+# CONFIG_CIFS_DEBUG is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DYNAMIC_DEBUG=y
+CONFIG_DEBUG_INFO=y
+CONFIG_DEBUG_INFO_REDUCED=y
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_STRIP_ASM_SYMS=y
+CONFIG_MAGIC_SYSRQ=y
+# CONFIG_MAGIC_SYSRQ_SERIAL is not set
+CONFIG_PAGE_EXTENSION=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_LOCKUP_DETECTOR=y
+# CONFIG_DETECT_HUNG_TASK is not set
+CONFIG_PANIC_ON_OOPS=y
+CONFIG_PANIC_TIMEOUT=1
+# CONFIG_SCHED_DEBUG is not set
+# CONFIG_DEBUG_PREEMPT is not set
+# CONFIG_DEBUG_BUGVERBOSE is not set
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_FUNCTION_TRACER=y
+# CONFIG_TRACING_EVENTS_GPIO is not set
+# CONFIG_DEBUG_SET_MODULE_RONX is not set
+CONFIG_SECURITY_DMESG_RESTRICT=y
+CONFIG_CRYPTO_USER=y
+CONFIG_CRYPTO_PCRYPT=y
+CONFIG_CRYPTO_AUTHENC=y
+CONFIG_CRYPTO_CCM=m
+CONFIG_CRYPTO_GCM=m
+# CONFIG_CRYPTO_ECHAINIV is not set
+CONFIG_CRYPTO_CTS=m
+CONFIG_CRYPTO_XTS=m
+CONFIG_CRYPTO_SHA1=y
+CONFIG_CRYPTO_SHA512=m
+CONFIG_CRYPTO_USER_API_HASH=y
+CONFIG_ARM64_CRYPTO=y
+CONFIG_CRYPTO_SHA1_ARM64_CE=y
+CONFIG_CRYPTO_SHA2_ARM64_CE=y
+CONFIG_CRYPTO_GHASH_ARM64_CE=y
+CONFIG_CRYPTO_AES_ARM64_CE_CCM=y
+CONFIG_CRYPTO_AES_ARM64_CE_BLK=y
+CONFIG_CRYPTO_AES_ARM64_NEON_BLK=y
+CONFIG_CRYPTO_CRC32_ARM64=y
+CONFIG_CRC32_SARWATE=y
+# CONFIG_XZ_DEC_X86 is not set
+# CONFIG_XZ_DEC_POWERPC is not set
+# CONFIG_XZ_DEC_IA64 is not set
+# CONFIG_XZ_DEC_ARM is not set
+# CONFIG_XZ_DEC_ARMTHUMB is not set
+# CONFIG_XZ_DEC_SPARC is not set
+CONFIG_TEXTSEARCH=y
diff --git a/arch/arm64/crypto/Kconfig b/arch/arm64/crypto/Kconfig
index 2cf32e9..2b10984 100644
--- a/arch/arm64/crypto/Kconfig
+++ b/arch/arm64/crypto/Kconfig
@@ -53,4 +53,11 @@ config CRYPTO_CRC32_ARM64
 	tristate "CRC32 and CRC32C using optional ARMv8 instructions"
 	depends on ARM64
 	select CRYPTO_HASH
+
+config CRYPTO_SPECK_NEON
+	tristate "NEON accelerated Speck cipher algorithms"
+	depends on KERNEL_MODE_NEON
+	select CRYPTO_BLKCIPHER
+	select CRYPTO_GF128MUL
+	select CRYPTO_SPECK
 endif
diff --git a/arch/arm64/crypto/Makefile b/arch/arm64/crypto/Makefile
index abb79b3..9908765 100644
--- a/arch/arm64/crypto/Makefile
+++ b/arch/arm64/crypto/Makefile
@@ -18,7 +18,8 @@ obj-$(CONFIG_CRYPTO_GHASH_ARM64_CE) += ghash-ce.o
 ghash-ce-y := ghash-ce-glue.o ghash-ce-core.o
 
 obj-$(CONFIG_CRYPTO_AES_ARM64_CE) += aes-ce-cipher.o
-CFLAGS_aes-ce-cipher.o += -march=armv8-a+crypto
+aes-ce-cipher-y := aes-ce-cipher-glue.o aes-ce-cipher-core.o
+CFLAGS_aes-ce-cipher-core.o += -march=armv8-a+crypto -Wa,-march=armv8-a+crypto $(DISABLE_LTO)
 
 obj-$(CONFIG_CRYPTO_AES_ARM64_CE_CCM) += aes-ce-ccm.o
 aes-ce-ccm-y := aes-ce-ccm-glue.o aes-ce-ccm-core.o
@@ -29,6 +30,9 @@ aes-ce-blk-y := aes-glue-ce.o aes-ce.o
 obj-$(CONFIG_CRYPTO_AES_ARM64_NEON_BLK) += aes-neon-blk.o
 aes-neon-blk-y := aes-glue-neon.o aes-neon.o
 
+obj-$(CONFIG_CRYPTO_SPECK_NEON) += speck-neon.o
+speck-neon-y := speck-neon-core.o speck-neon-glue.o
+
 AFLAGS_aes-ce.o		:= -DINTERLEAVE=4
 AFLAGS_aes-neon.o	:= -DINTERLEAVE=4
 
diff --git a/arch/arm64/crypto/aes-ce-cipher-core.c b/arch/arm64/crypto/aes-ce-cipher-core.c
new file mode 100644
index 00000000..9f41917
--- /dev/null
+++ b/arch/arm64/crypto/aes-ce-cipher-core.c
@@ -0,0 +1,219 @@
+/*
+ * aes-ce-cipher-core.c - core AES cipher using ARMv8 Crypto Extensions
+ *
+ * Copyright (C) 2013 - 2014 Linaro Ltd <ard.biesheuvel@linaro.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <asm/neon.h>
+#include <crypto/aes.h>
+#include <linux/crypto.h>
+
+#include "aes-ce-setkey.h"
+
+struct aes_block {
+	u8 b[AES_BLOCK_SIZE];
+};
+
+static int num_rounds(struct crypto_aes_ctx *ctx)
+{
+	/*
+	 * # of rounds specified by AES:
+	 * 128 bit key		10 rounds
+	 * 192 bit key		12 rounds
+	 * 256 bit key		14 rounds
+	 * => n byte key	=> 6 + (n/4) rounds
+	 */
+	return 6 + ctx->key_length / 4;
+}
+
+void aes_cipher_encrypt(struct crypto_tfm *tfm, u8 dst[], u8 const src[])
+{
+	struct crypto_aes_ctx *ctx = crypto_tfm_ctx(tfm);
+	struct aes_block *out = (struct aes_block *)dst;
+	struct aes_block const *in = (struct aes_block *)src;
+	void *dummy0;
+	int dummy1;
+
+	kernel_neon_begin_partial(4);
+
+	__asm__("	ld1	{v0.16b}, %[in]			;"
+		"	ld1	{v1.16b}, [%[key]], #16		;"
+		"	cmp	%w[rounds], #10			;"
+		"	bmi	0f				;"
+		"	bne	3f				;"
+		"	mov	v3.16b, v1.16b			;"
+		"	b	2f				;"
+		"0:	mov	v2.16b, v1.16b			;"
+		"	ld1	{v3.16b}, [%[key]], #16		;"
+		"1:	aese	v0.16b, v2.16b			;"
+		"	aesmc	v0.16b, v0.16b			;"
+		"2:	ld1	{v1.16b}, [%[key]], #16		;"
+		"	aese	v0.16b, v3.16b			;"
+		"	aesmc	v0.16b, v0.16b			;"
+		"3:	ld1	{v2.16b}, [%[key]], #16		;"
+		"	subs	%w[rounds], %w[rounds], #3	;"
+		"	aese	v0.16b, v1.16b			;"
+		"	aesmc	v0.16b, v0.16b			;"
+		"	ld1	{v3.16b}, [%[key]], #16		;"
+		"	bpl	1b				;"
+		"	aese	v0.16b, v2.16b			;"
+		"	eor	v0.16b, v0.16b, v3.16b		;"
+		"	st1	{v0.16b}, %[out]		;"
+
+	:	[out]		"=Q"(*out),
+		[key]		"=r"(dummy0),
+		[rounds]	"=r"(dummy1)
+	:	[in]		"Q"(*in),
+				"1"(ctx->key_enc),
+				"2"(num_rounds(ctx) - 2)
+	:	"cc");
+
+	kernel_neon_end();
+}
+
+void aes_cipher_decrypt(struct crypto_tfm *tfm, u8 dst[], u8 const src[])
+{
+	struct crypto_aes_ctx *ctx = crypto_tfm_ctx(tfm);
+	struct aes_block *out = (struct aes_block *)dst;
+	struct aes_block const *in = (struct aes_block *)src;
+	void *dummy0;
+	int dummy1;
+
+	kernel_neon_begin_partial(4);
+
+	__asm__("	ld1	{v0.16b}, %[in]			;"
+		"	ld1	{v1.16b}, [%[key]], #16		;"
+		"	cmp	%w[rounds], #10			;"
+		"	bmi	0f				;"
+		"	bne	3f				;"
+		"	mov	v3.16b, v1.16b			;"
+		"	b	2f				;"
+		"0:	mov	v2.16b, v1.16b			;"
+		"	ld1	{v3.16b}, [%[key]], #16		;"
+		"1:	aesd	v0.16b, v2.16b			;"
+		"	aesimc	v0.16b, v0.16b			;"
+		"2:	ld1	{v1.16b}, [%[key]], #16		;"
+		"	aesd	v0.16b, v3.16b			;"
+		"	aesimc	v0.16b, v0.16b			;"
+		"3:	ld1	{v2.16b}, [%[key]], #16		;"
+		"	subs	%w[rounds], %w[rounds], #3	;"
+		"	aesd	v0.16b, v1.16b			;"
+		"	aesimc	v0.16b, v0.16b			;"
+		"	ld1	{v3.16b}, [%[key]], #16		;"
+		"	bpl	1b				;"
+		"	aesd	v0.16b, v2.16b			;"
+		"	eor	v0.16b, v0.16b, v3.16b		;"
+		"	st1	{v0.16b}, %[out]		;"
+
+	:	[out]		"=Q"(*out),
+		[key]		"=r"(dummy0),
+		[rounds]	"=r"(dummy1)
+	:	[in]		"Q"(*in),
+				"1"(ctx->key_dec),
+				"2"(num_rounds(ctx) - 2)
+	:	"cc");
+
+	kernel_neon_end();
+}
+
+/*
+ * aes_sub() - use the aese instruction to perform the AES sbox substitution
+ *             on each byte in 'input'
+ */
+static u32 aes_sub(u32 input)
+{
+	u32 ret;
+
+	__asm__("dup	v1.4s, %w[in]		;"
+		"movi	v0.16b, #0		;"
+		"aese	v0.16b, v1.16b		;"
+		"umov	%w[out], v0.4s[0]	;"
+
+	:	[out]	"=r"(ret)
+	:	[in]	"r"(input)
+	:		"v0","v1");
+
+	return ret;
+}
+
+int ce_aes_expandkey(struct crypto_aes_ctx *ctx, const u8 *in_key,
+		     unsigned int key_len)
+{
+	/*
+	 * The AES key schedule round constants
+	 */
+	static u8 const rcon[] = {
+		0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36,
+	};
+
+	u32 kwords = key_len / sizeof(u32);
+	struct aes_block *key_enc, *key_dec;
+	int i, j;
+
+	if (key_len != AES_KEYSIZE_128 &&
+	    key_len != AES_KEYSIZE_192 &&
+	    key_len != AES_KEYSIZE_256)
+		return -EINVAL;
+
+	memcpy(ctx->key_enc, in_key, key_len);
+	ctx->key_length = key_len;
+
+	kernel_neon_begin_partial(2);
+	for (i = 0; i < sizeof(rcon); i++) {
+		u32 *rki = ctx->key_enc + (i * kwords);
+		u32 *rko = rki + kwords;
+
+#ifndef CONFIG_CPU_BIG_ENDIAN
+		rko[0] = ror32(aes_sub(rki[kwords - 1]), 8) ^ rcon[i] ^ rki[0];
+#else
+		rko[0] = rol32(aes_sub(rki[kwords - 1]), 8) ^ (rcon[i] << 24) ^
+			 rki[0];
+#endif
+		rko[1] = rko[0] ^ rki[1];
+		rko[2] = rko[1] ^ rki[2];
+		rko[3] = rko[2] ^ rki[3];
+
+		if (key_len == AES_KEYSIZE_192) {
+			if (i >= 7)
+				break;
+			rko[4] = rko[3] ^ rki[4];
+			rko[5] = rko[4] ^ rki[5];
+		} else if (key_len == AES_KEYSIZE_256) {
+			if (i >= 6)
+				break;
+			rko[4] = aes_sub(rko[3]) ^ rki[4];
+			rko[5] = rko[4] ^ rki[5];
+			rko[6] = rko[5] ^ rki[6];
+			rko[7] = rko[6] ^ rki[7];
+		}
+	}
+
+	/*
+	 * Generate the decryption keys for the Equivalent Inverse Cipher.
+	 * This involves reversing the order of the round keys, and applying
+	 * the Inverse Mix Columns transformation on all but the first and
+	 * the last one.
+	 */
+	key_enc = (struct aes_block *)ctx->key_enc;
+	key_dec = (struct aes_block *)ctx->key_dec;
+	j = num_rounds(ctx);
+
+	key_dec[0] = key_enc[j];
+	for (i = 1, j--; j > 0; i++, j--)
+		__asm__("ld1	{v0.16b}, %[in]		;"
+			"aesimc	v1.16b, v0.16b		;"
+			"st1	{v1.16b}, %[out]	;"
+
+		:	[out]	"=Q"(key_dec[i])
+		:	[in]	"Q"(key_enc[j])
+		:		"v0","v1");
+	key_dec[i] = key_enc[0];
+
+	kernel_neon_end();
+	return 0;
+}
+EXPORT_SYMBOL(ce_aes_expandkey);
diff --git a/arch/arm64/crypto/aes-ce-cipher-glue.c b/arch/arm64/crypto/aes-ce-cipher-glue.c
new file mode 100644
index 00000000..442949e
--- /dev/null
+++ b/arch/arm64/crypto/aes-ce-cipher-glue.c
@@ -0,0 +1,83 @@
+/*
+ * aes-ce-cipher.c - core AES cipher using ARMv8 Crypto Extensions
+ *
+ * Copyright (C) 2013 - 2014 Linaro Ltd <ard.biesheuvel@linaro.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <crypto/aes.h>
+#include <linux/cpufeature.h>
+#include <linux/crypto.h>
+#include <linux/module.h>
+
+#include "aes-ce-setkey.h"
+
+MODULE_DESCRIPTION("Synchronous AES cipher using ARMv8 Crypto Extensions");
+MODULE_AUTHOR("Ard Biesheuvel <ard.biesheuvel@linaro.org>");
+MODULE_LICENSE("GPL v2");
+
+extern void aes_cipher_encrypt(struct crypto_tfm *tfm, u8 dst[], u8 const src[]);
+extern void aes_cipher_decrypt(struct crypto_tfm *tfm, u8 dst[], u8 const src[]);
+
+#ifdef CONFIG_CFI_CLANG
+static inline void __cfi_aes_cipher_encrypt(struct crypto_tfm *tfm, u8 dst[], u8 const src[])
+{
+	aes_cipher_encrypt(tfm, dst, src);
+}
+
+static inline void __cfi_aes_cipher_decrypt(struct crypto_tfm *tfm, u8 dst[], u8 const src[])
+{
+	aes_cipher_decrypt(tfm, dst, src);
+}
+
+#define aes_cipher_encrypt __cfi_aes_cipher_encrypt
+#define aes_cipher_decrypt __cfi_aes_cipher_decrypt
+#endif
+
+int ce_aes_setkey(struct crypto_tfm *tfm, const u8 *in_key,
+		  unsigned int key_len)
+{
+	struct crypto_aes_ctx *ctx = crypto_tfm_ctx(tfm);
+	int ret;
+
+	ret = ce_aes_expandkey(ctx, in_key, key_len);
+	if (!ret)
+		return 0;
+
+	tfm->crt_flags |= CRYPTO_TFM_RES_BAD_KEY_LEN;
+	return -EINVAL;
+}
+EXPORT_SYMBOL(ce_aes_setkey);
+
+static struct crypto_alg aes_alg = {
+	.cra_name		= "aes",
+	.cra_driver_name	= "aes-ce",
+	.cra_priority		= 250,
+	.cra_flags		= CRYPTO_ALG_TYPE_CIPHER,
+	.cra_blocksize		= AES_BLOCK_SIZE,
+	.cra_ctxsize		= sizeof(struct crypto_aes_ctx),
+	.cra_module		= THIS_MODULE,
+	.cra_cipher = {
+		.cia_min_keysize	= AES_MIN_KEY_SIZE,
+		.cia_max_keysize	= AES_MAX_KEY_SIZE,
+		.cia_setkey		= ce_aes_setkey,
+		.cia_encrypt		= aes_cipher_encrypt,
+		.cia_decrypt		= aes_cipher_decrypt
+	}
+};
+
+static int __init aes_mod_init(void)
+{
+	return crypto_register_alg(&aes_alg);
+}
+
+static void __exit aes_mod_exit(void)
+{
+	crypto_unregister_alg(&aes_alg);
+}
+
+module_cpu_feature_match(AES, aes_mod_init);
+module_exit(aes_mod_exit);
diff --git a/arch/arm64/crypto/aes-ce-cipher.c b/arch/arm64/crypto/aes-ce-cipher.c
deleted file mode 100644
index 50d9fe1..00000000
--- a/arch/arm64/crypto/aes-ce-cipher.c
+++ /dev/null
@@ -1,270 +0,0 @@
-/*
- * aes-ce-cipher.c - core AES cipher using ARMv8 Crypto Extensions
- *
- * Copyright (C) 2013 - 2014 Linaro Ltd <ard.biesheuvel@linaro.org>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation.
- */
-
-#include <asm/neon.h>
-#include <crypto/aes.h>
-#include <linux/cpufeature.h>
-#include <linux/crypto.h>
-#include <linux/module.h>
-
-#include "aes-ce-setkey.h"
-
-MODULE_DESCRIPTION("Synchronous AES cipher using ARMv8 Crypto Extensions");
-MODULE_AUTHOR("Ard Biesheuvel <ard.biesheuvel@linaro.org>");
-MODULE_LICENSE("GPL v2");
-
-struct aes_block {
-	u8 b[AES_BLOCK_SIZE];
-};
-
-static int num_rounds(struct crypto_aes_ctx *ctx)
-{
-	/*
-	 * # of rounds specified by AES:
-	 * 128 bit key		10 rounds
-	 * 192 bit key		12 rounds
-	 * 256 bit key		14 rounds
-	 * => n byte key	=> 6 + (n/4) rounds
-	 */
-	return 6 + ctx->key_length / 4;
-}
-
-static void aes_cipher_encrypt(struct crypto_tfm *tfm, u8 dst[], u8 const src[])
-{
-	struct crypto_aes_ctx *ctx = crypto_tfm_ctx(tfm);
-	struct aes_block *out = (struct aes_block *)dst;
-	struct aes_block const *in = (struct aes_block *)src;
-	void *dummy0;
-	int dummy1;
-
-	kernel_neon_begin_partial(4);
-
-	__asm__("	ld1	{v0.16b}, %[in]			;"
-		"	ld1	{v1.16b}, [%[key]], #16		;"
-		"	cmp	%w[rounds], #10			;"
-		"	bmi	0f				;"
-		"	bne	3f				;"
-		"	mov	v3.16b, v1.16b			;"
-		"	b	2f				;"
-		"0:	mov	v2.16b, v1.16b			;"
-		"	ld1	{v3.16b}, [%[key]], #16		;"
-		"1:	aese	v0.16b, v2.16b			;"
-		"	aesmc	v0.16b, v0.16b			;"
-		"2:	ld1	{v1.16b}, [%[key]], #16		;"
-		"	aese	v0.16b, v3.16b			;"
-		"	aesmc	v0.16b, v0.16b			;"
-		"3:	ld1	{v2.16b}, [%[key]], #16		;"
-		"	subs	%w[rounds], %w[rounds], #3	;"
-		"	aese	v0.16b, v1.16b			;"
-		"	aesmc	v0.16b, v0.16b			;"
-		"	ld1	{v3.16b}, [%[key]], #16		;"
-		"	bpl	1b				;"
-		"	aese	v0.16b, v2.16b			;"
-		"	eor	v0.16b, v0.16b, v3.16b		;"
-		"	st1	{v0.16b}, %[out]		;"
-
-	:	[out]		"=Q"(*out),
-		[key]		"=r"(dummy0),
-		[rounds]	"=r"(dummy1)
-	:	[in]		"Q"(*in),
-				"1"(ctx->key_enc),
-				"2"(num_rounds(ctx) - 2)
-	:	"cc");
-
-	kernel_neon_end();
-}
-
-static void aes_cipher_decrypt(struct crypto_tfm *tfm, u8 dst[], u8 const src[])
-{
-	struct crypto_aes_ctx *ctx = crypto_tfm_ctx(tfm);
-	struct aes_block *out = (struct aes_block *)dst;
-	struct aes_block const *in = (struct aes_block *)src;
-	void *dummy0;
-	int dummy1;
-
-	kernel_neon_begin_partial(4);
-
-	__asm__("	ld1	{v0.16b}, %[in]			;"
-		"	ld1	{v1.16b}, [%[key]], #16		;"
-		"	cmp	%w[rounds], #10			;"
-		"	bmi	0f				;"
-		"	bne	3f				;"
-		"	mov	v3.16b, v1.16b			;"
-		"	b	2f				;"
-		"0:	mov	v2.16b, v1.16b			;"
-		"	ld1	{v3.16b}, [%[key]], #16		;"
-		"1:	aesd	v0.16b, v2.16b			;"
-		"	aesimc	v0.16b, v0.16b			;"
-		"2:	ld1	{v1.16b}, [%[key]], #16		;"
-		"	aesd	v0.16b, v3.16b			;"
-		"	aesimc	v0.16b, v0.16b			;"
-		"3:	ld1	{v2.16b}, [%[key]], #16		;"
-		"	subs	%w[rounds], %w[rounds], #3	;"
-		"	aesd	v0.16b, v1.16b			;"
-		"	aesimc	v0.16b, v0.16b			;"
-		"	ld1	{v3.16b}, [%[key]], #16		;"
-		"	bpl	1b				;"
-		"	aesd	v0.16b, v2.16b			;"
-		"	eor	v0.16b, v0.16b, v3.16b		;"
-		"	st1	{v0.16b}, %[out]		;"
-
-	:	[out]		"=Q"(*out),
-		[key]		"=r"(dummy0),
-		[rounds]	"=r"(dummy1)
-	:	[in]		"Q"(*in),
-				"1"(ctx->key_dec),
-				"2"(num_rounds(ctx) - 2)
-	:	"cc");
-
-	kernel_neon_end();
-}
-
-/*
- * aes_sub() - use the aese instruction to perform the AES sbox substitution
- *             on each byte in 'input'
- */
-static u32 aes_sub(u32 input)
-{
-	u32 ret;
-
-	__asm__("dup	v1.4s, %w[in]		;"
-		"movi	v0.16b, #0		;"
-		"aese	v0.16b, v1.16b		;"
-		"umov	%w[out], v0.4s[0]	;"
-
-	:	[out]	"=r"(ret)
-	:	[in]	"r"(input)
-	:		"v0","v1");
-
-	return ret;
-}
-
-int ce_aes_expandkey(struct crypto_aes_ctx *ctx, const u8 *in_key,
-		     unsigned int key_len)
-{
-	/*
-	 * The AES key schedule round constants
-	 */
-	static u8 const rcon[] = {
-		0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36,
-	};
-
-	u32 kwords = key_len / sizeof(u32);
-	struct aes_block *key_enc, *key_dec;
-	int i, j;
-
-	if (key_len != AES_KEYSIZE_128 &&
-	    key_len != AES_KEYSIZE_192 &&
-	    key_len != AES_KEYSIZE_256)
-		return -EINVAL;
-
-	memcpy(ctx->key_enc, in_key, key_len);
-	ctx->key_length = key_len;
-
-	kernel_neon_begin_partial(2);
-	for (i = 0; i < sizeof(rcon); i++) {
-		u32 *rki = ctx->key_enc + (i * kwords);
-		u32 *rko = rki + kwords;
-
-#ifndef CONFIG_CPU_BIG_ENDIAN
-		rko[0] = ror32(aes_sub(rki[kwords - 1]), 8) ^ rcon[i] ^ rki[0];
-#else
-		rko[0] = rol32(aes_sub(rki[kwords - 1]), 8) ^ (rcon[i] << 24) ^
-			 rki[0];
-#endif
-		rko[1] = rko[0] ^ rki[1];
-		rko[2] = rko[1] ^ rki[2];
-		rko[3] = rko[2] ^ rki[3];
-
-		if (key_len == AES_KEYSIZE_192) {
-			if (i >= 7)
-				break;
-			rko[4] = rko[3] ^ rki[4];
-			rko[5] = rko[4] ^ rki[5];
-		} else if (key_len == AES_KEYSIZE_256) {
-			if (i >= 6)
-				break;
-			rko[4] = aes_sub(rko[3]) ^ rki[4];
-			rko[5] = rko[4] ^ rki[5];
-			rko[6] = rko[5] ^ rki[6];
-			rko[7] = rko[6] ^ rki[7];
-		}
-	}
-
-	/*
-	 * Generate the decryption keys for the Equivalent Inverse Cipher.
-	 * This involves reversing the order of the round keys, and applying
-	 * the Inverse Mix Columns transformation on all but the first and
-	 * the last one.
-	 */
-	key_enc = (struct aes_block *)ctx->key_enc;
-	key_dec = (struct aes_block *)ctx->key_dec;
-	j = num_rounds(ctx);
-
-	key_dec[0] = key_enc[j];
-	for (i = 1, j--; j > 0; i++, j--)
-		__asm__("ld1	{v0.16b}, %[in]		;"
-			"aesimc	v1.16b, v0.16b		;"
-			"st1	{v1.16b}, %[out]	;"
-
-		:	[out]	"=Q"(key_dec[i])
-		:	[in]	"Q"(key_enc[j])
-		:		"v0","v1");
-	key_dec[i] = key_enc[0];
-
-	kernel_neon_end();
-	return 0;
-}
-EXPORT_SYMBOL(ce_aes_expandkey);
-
-int ce_aes_setkey(struct crypto_tfm *tfm, const u8 *in_key,
-		  unsigned int key_len)
-{
-	struct crypto_aes_ctx *ctx = crypto_tfm_ctx(tfm);
-	int ret;
-
-	ret = ce_aes_expandkey(ctx, in_key, key_len);
-	if (!ret)
-		return 0;
-
-	tfm->crt_flags |= CRYPTO_TFM_RES_BAD_KEY_LEN;
-	return -EINVAL;
-}
-EXPORT_SYMBOL(ce_aes_setkey);
-
-static struct crypto_alg aes_alg = {
-	.cra_name		= "aes",
-	.cra_driver_name	= "aes-ce",
-	.cra_priority		= 250,
-	.cra_flags		= CRYPTO_ALG_TYPE_CIPHER,
-	.cra_blocksize		= AES_BLOCK_SIZE,
-	.cra_ctxsize		= sizeof(struct crypto_aes_ctx),
-	.cra_module		= THIS_MODULE,
-	.cra_cipher = {
-		.cia_min_keysize	= AES_MIN_KEY_SIZE,
-		.cia_max_keysize	= AES_MAX_KEY_SIZE,
-		.cia_setkey		= ce_aes_setkey,
-		.cia_encrypt		= aes_cipher_encrypt,
-		.cia_decrypt		= aes_cipher_decrypt
-	}
-};
-
-static int __init aes_mod_init(void)
-{
-	return crypto_register_alg(&aes_alg);
-}
-
-static void __exit aes_mod_exit(void)
-{
-	crypto_unregister_alg(&aes_alg);
-}
-
-module_cpu_feature_match(AES, aes_mod_init);
-module_exit(aes_mod_exit);
diff --git a/arch/arm64/crypto/sha1-ce-core.S b/arch/arm64/crypto/sha1-ce-core.S
index c98e7e8..8550408 100644
--- a/arch/arm64/crypto/sha1-ce-core.S
+++ b/arch/arm64/crypto/sha1-ce-core.S
@@ -82,7 +82,8 @@ ENTRY(sha1_ce_transform)
 	ldr		dgb, [x0, #16]
 
 	/* load sha1_ce_state::finalize */
-	ldr		w4, [x0, #:lo12:sha1_ce_offsetof_finalize]
+	ldr_l		w4, sha1_ce_offsetof_finalize, x4
+	ldr		w4, [x0, x4]
 
 	/* load input */
 0:	ld1		{v8.4s-v11.4s}, [x1], #64
@@ -132,7 +133,8 @@ CPU_LE(	rev32		v11.16b, v11.16b	)
 	 * the padding is handled by the C code in that case.
 	 */
 	cbz		x4, 3f
-	ldr		x4, [x0, #:lo12:sha1_ce_offsetof_count]
+	ldr_l		w4, sha1_ce_offsetof_count, x4
+	ldr		x4, [x0, x4]
 	movi		v9.2d, #0
 	mov		x8, #0x80000000
 	movi		v10.2d, #0
diff --git a/arch/arm64/crypto/sha1-ce-glue.c b/arch/arm64/crypto/sha1-ce-glue.c
index aefda98..f08ecf4 100644
--- a/arch/arm64/crypto/sha1-ce-glue.c
+++ b/arch/arm64/crypto/sha1-ce-glue.c
@@ -17,9 +17,6 @@
 #include <linux/crypto.h>
 #include <linux/module.h>
 
-#define ASM_EXPORT(sym, val) \
-	asm(".globl " #sym "; .set " #sym ", %0" :: "I"(val));
-
 MODULE_DESCRIPTION("SHA1 secure hash using ARMv8 Crypto Extensions");
 MODULE_AUTHOR("Ard Biesheuvel <ard.biesheuvel@linaro.org>");
 MODULE_LICENSE("GPL v2");
@@ -31,6 +28,17 @@ struct sha1_ce_state {
 
 asmlinkage void sha1_ce_transform(struct sha1_ce_state *sst, u8 const *src,
 				  int blocks);
+#ifdef CONFIG_CFI_CLANG
+static inline void __cfi_sha1_ce_transform(struct sha1_state *sst,
+					   u8 const *src, int blocks)
+{
+	sha1_ce_transform((struct sha1_ce_state *)sst, src, blocks);
+}
+#define sha1_ce_transform __cfi_sha1_ce_transform
+#endif
+
+const u32 sha1_ce_offsetof_count = offsetof(struct sha1_ce_state, sst.count);
+const u32 sha1_ce_offsetof_finalize = offsetof(struct sha1_ce_state, finalize);
 
 static int sha1_ce_update(struct shash_desc *desc, const u8 *data,
 			  unsigned int len)
@@ -52,11 +60,6 @@ static int sha1_ce_finup(struct shash_desc *desc, const u8 *data,
 	struct sha1_ce_state *sctx = shash_desc_ctx(desc);
 	bool finalize = !sctx->sst.count && !(len % SHA1_BLOCK_SIZE);
 
-	ASM_EXPORT(sha1_ce_offsetof_count,
-		   offsetof(struct sha1_ce_state, sst.count));
-	ASM_EXPORT(sha1_ce_offsetof_finalize,
-		   offsetof(struct sha1_ce_state, finalize));
-
 	/*
 	 * Allow the asm code to perform the finalization if there is no
 	 * partial data and the input is a round multiple of the block size.
diff --git a/arch/arm64/crypto/sha2-ce-core.S b/arch/arm64/crypto/sha2-ce-core.S
index 01cfee0..679c6c0 100644
--- a/arch/arm64/crypto/sha2-ce-core.S
+++ b/arch/arm64/crypto/sha2-ce-core.S
@@ -88,7 +88,8 @@ ENTRY(sha2_ce_transform)
 	ld1		{dgav.4s, dgbv.4s}, [x0]
 
 	/* load sha256_ce_state::finalize */
-	ldr		w4, [x0, #:lo12:sha256_ce_offsetof_finalize]
+	ldr_l		w4, sha256_ce_offsetof_finalize, x4
+	ldr		w4, [x0, x4]
 
 	/* load input */
 0:	ld1		{v16.4s-v19.4s}, [x1], #64
@@ -136,7 +137,8 @@ CPU_LE(	rev32		v19.16b, v19.16b	)
 	 * the padding is handled by the C code in that case.
 	 */
 	cbz		x4, 3f
-	ldr		x4, [x0, #:lo12:sha256_ce_offsetof_count]
+	ldr_l		w4, sha256_ce_offsetof_count, x4
+	ldr		x4, [x0, x4]
 	movi		v17.2d, #0
 	mov		x8, #0x80000000
 	movi		v18.2d, #0
diff --git a/arch/arm64/crypto/sha2-ce-glue.c b/arch/arm64/crypto/sha2-ce-glue.c
index 7cd5875..c243221 100644
--- a/arch/arm64/crypto/sha2-ce-glue.c
+++ b/arch/arm64/crypto/sha2-ce-glue.c
@@ -17,9 +17,6 @@
 #include <linux/crypto.h>
 #include <linux/module.h>
 
-#define ASM_EXPORT(sym, val) \
-	asm(".globl " #sym "; .set " #sym ", %0" :: "I"(val));
-
 MODULE_DESCRIPTION("SHA-224/SHA-256 secure hash using ARMv8 Crypto Extensions");
 MODULE_AUTHOR("Ard Biesheuvel <ard.biesheuvel@linaro.org>");
 MODULE_LICENSE("GPL v2");
@@ -31,6 +28,19 @@ struct sha256_ce_state {
 
 asmlinkage void sha2_ce_transform(struct sha256_ce_state *sst, u8 const *src,
 				  int blocks);
+#ifdef CONFIG_CFI_CLANG
+static inline void __cfi_sha2_ce_transform(struct sha256_state *sst,
+					   u8 const *src, int blocks)
+{
+	sha2_ce_transform((struct sha256_ce_state *)sst, src, blocks);
+}
+#define sha2_ce_transform __cfi_sha2_ce_transform
+#endif
+
+const u32 sha256_ce_offsetof_count = offsetof(struct sha256_ce_state,
+					      sst.count);
+const u32 sha256_ce_offsetof_finalize = offsetof(struct sha256_ce_state,
+						 finalize);
 
 static int sha256_ce_update(struct shash_desc *desc, const u8 *data,
 			    unsigned int len)
@@ -52,11 +62,6 @@ static int sha256_ce_finup(struct shash_desc *desc, const u8 *data,
 	struct sha256_ce_state *sctx = shash_desc_ctx(desc);
 	bool finalize = !sctx->sst.count && !(len % SHA256_BLOCK_SIZE);
 
-	ASM_EXPORT(sha256_ce_offsetof_count,
-		   offsetof(struct sha256_ce_state, sst.count));
-	ASM_EXPORT(sha256_ce_offsetof_finalize,
-		   offsetof(struct sha256_ce_state, finalize));
-
 	/*
 	 * Allow the asm code to perform the finalization if there is no
 	 * partial data and the input is a round multiple of the block size.
diff --git a/arch/arm64/crypto/speck-neon-core.S b/arch/arm64/crypto/speck-neon-core.S
new file mode 100644
index 00000000..b144634
--- /dev/null
+++ b/arch/arm64/crypto/speck-neon-core.S
@@ -0,0 +1,352 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * ARM64 NEON-accelerated implementation of Speck128-XTS and Speck64-XTS
+ *
+ * Copyright (c) 2018 Google, Inc
+ *
+ * Author: Eric Biggers <ebiggers@google.com>
+ */
+
+#include <linux/linkage.h>
+
+	.text
+
+	// arguments
+	ROUND_KEYS	.req	x0	// const {u64,u32} *round_keys
+	NROUNDS		.req	w1	// int nrounds
+	NROUNDS_X	.req	x1
+	DST		.req	x2	// void *dst
+	SRC		.req	x3	// const void *src
+	NBYTES		.req	w4	// unsigned int nbytes
+	TWEAK		.req	x5	// void *tweak
+
+	// registers which hold the data being encrypted/decrypted
+	// (underscores avoid a naming collision with ARM64 registers x0-x3)
+	X_0		.req	v0
+	Y_0		.req	v1
+	X_1		.req	v2
+	Y_1		.req	v3
+	X_2		.req	v4
+	Y_2		.req	v5
+	X_3		.req	v6
+	Y_3		.req	v7
+
+	// the round key, duplicated in all lanes
+	ROUND_KEY	.req	v8
+
+	// index vector for tbl-based 8-bit rotates
+	ROTATE_TABLE	.req	v9
+	ROTATE_TABLE_Q	.req	q9
+
+	// temporary registers
+	TMP0		.req	v10
+	TMP1		.req	v11
+	TMP2		.req	v12
+	TMP3		.req	v13
+
+	// multiplication table for updating XTS tweaks
+	GFMUL_TABLE	.req	v14
+	GFMUL_TABLE_Q	.req	q14
+
+	// next XTS tweak value(s)
+	TWEAKV_NEXT	.req	v15
+
+	// XTS tweaks for the blocks currently being encrypted/decrypted
+	TWEAKV0		.req	v16
+	TWEAKV1		.req	v17
+	TWEAKV2		.req	v18
+	TWEAKV3		.req	v19
+	TWEAKV4		.req	v20
+	TWEAKV5		.req	v21
+	TWEAKV6		.req	v22
+	TWEAKV7		.req	v23
+
+	.align		4
+.Lror64_8_table:
+	.octa		0x080f0e0d0c0b0a090007060504030201
+.Lror32_8_table:
+	.octa		0x0c0f0e0d080b0a090407060500030201
+.Lrol64_8_table:
+	.octa		0x0e0d0c0b0a09080f0605040302010007
+.Lrol32_8_table:
+	.octa		0x0e0d0c0f0a09080b0605040702010003
+.Lgf128mul_table:
+	.octa		0x00000000000000870000000000000001
+.Lgf64mul_table:
+	.octa		0x0000000000000000000000002d361b00
+
+/*
+ * _speck_round_128bytes() - Speck encryption round on 128 bytes at a time
+ *
+ * Do one Speck encryption round on the 128 bytes (8 blocks for Speck128, 16 for
+ * Speck64) stored in X0-X3 and Y0-Y3, using the round key stored in all lanes
+ * of ROUND_KEY.  'n' is the lane size: 64 for Speck128, or 32 for Speck64.
+ * 'lanes' is the lane specifier: "2d" for Speck128 or "4s" for Speck64.
+ */
+.macro _speck_round_128bytes	n, lanes
+
+	// x = ror(x, 8)
+	tbl		X_0.16b, {X_0.16b}, ROTATE_TABLE.16b
+	tbl		X_1.16b, {X_1.16b}, ROTATE_TABLE.16b
+	tbl		X_2.16b, {X_2.16b}, ROTATE_TABLE.16b
+	tbl		X_3.16b, {X_3.16b}, ROTATE_TABLE.16b
+
+	// x += y
+	add		X_0.\lanes, X_0.\lanes, Y_0.\lanes
+	add		X_1.\lanes, X_1.\lanes, Y_1.\lanes
+	add		X_2.\lanes, X_2.\lanes, Y_2.\lanes
+	add		X_3.\lanes, X_3.\lanes, Y_3.\lanes
+
+	// x ^= k
+	eor		X_0.16b, X_0.16b, ROUND_KEY.16b
+	eor		X_1.16b, X_1.16b, ROUND_KEY.16b
+	eor		X_2.16b, X_2.16b, ROUND_KEY.16b
+	eor		X_3.16b, X_3.16b, ROUND_KEY.16b
+
+	// y = rol(y, 3)
+	shl		TMP0.\lanes, Y_0.\lanes, #3
+	shl		TMP1.\lanes, Y_1.\lanes, #3
+	shl		TMP2.\lanes, Y_2.\lanes, #3
+	shl		TMP3.\lanes, Y_3.\lanes, #3
+	sri		TMP0.\lanes, Y_0.\lanes, #(\n - 3)
+	sri		TMP1.\lanes, Y_1.\lanes, #(\n - 3)
+	sri		TMP2.\lanes, Y_2.\lanes, #(\n - 3)
+	sri		TMP3.\lanes, Y_3.\lanes, #(\n - 3)
+
+	// y ^= x
+	eor		Y_0.16b, TMP0.16b, X_0.16b
+	eor		Y_1.16b, TMP1.16b, X_1.16b
+	eor		Y_2.16b, TMP2.16b, X_2.16b
+	eor		Y_3.16b, TMP3.16b, X_3.16b
+.endm
+
+/*
+ * _speck_unround_128bytes() - Speck decryption round on 128 bytes at a time
+ *
+ * This is the inverse of _speck_round_128bytes().
+ */
+.macro _speck_unround_128bytes	n, lanes
+
+	// y ^= x
+	eor		TMP0.16b, Y_0.16b, X_0.16b
+	eor		TMP1.16b, Y_1.16b, X_1.16b
+	eor		TMP2.16b, Y_2.16b, X_2.16b
+	eor		TMP3.16b, Y_3.16b, X_3.16b
+
+	// y = ror(y, 3)
+	ushr		Y_0.\lanes, TMP0.\lanes, #3
+	ushr		Y_1.\lanes, TMP1.\lanes, #3
+	ushr		Y_2.\lanes, TMP2.\lanes, #3
+	ushr		Y_3.\lanes, TMP3.\lanes, #3
+	sli		Y_0.\lanes, TMP0.\lanes, #(\n - 3)
+	sli		Y_1.\lanes, TMP1.\lanes, #(\n - 3)
+	sli		Y_2.\lanes, TMP2.\lanes, #(\n - 3)
+	sli		Y_3.\lanes, TMP3.\lanes, #(\n - 3)
+
+	// x ^= k
+	eor		X_0.16b, X_0.16b, ROUND_KEY.16b
+	eor		X_1.16b, X_1.16b, ROUND_KEY.16b
+	eor		X_2.16b, X_2.16b, ROUND_KEY.16b
+	eor		X_3.16b, X_3.16b, ROUND_KEY.16b
+
+	// x -= y
+	sub		X_0.\lanes, X_0.\lanes, Y_0.\lanes
+	sub		X_1.\lanes, X_1.\lanes, Y_1.\lanes
+	sub		X_2.\lanes, X_2.\lanes, Y_2.\lanes
+	sub		X_3.\lanes, X_3.\lanes, Y_3.\lanes
+
+	// x = rol(x, 8)
+	tbl		X_0.16b, {X_0.16b}, ROTATE_TABLE.16b
+	tbl		X_1.16b, {X_1.16b}, ROTATE_TABLE.16b
+	tbl		X_2.16b, {X_2.16b}, ROTATE_TABLE.16b
+	tbl		X_3.16b, {X_3.16b}, ROTATE_TABLE.16b
+.endm
+
+.macro _next_xts_tweak	next, cur, tmp, n
+.if \n == 64
+	/*
+	 * Calculate the next tweak by multiplying the current one by x,
+	 * modulo p(x) = x^128 + x^7 + x^2 + x + 1.
+	 */
+	sshr		\tmp\().2d, \cur\().2d, #63
+	and		\tmp\().16b, \tmp\().16b, GFMUL_TABLE.16b
+	shl		\next\().2d, \cur\().2d, #1
+	ext		\tmp\().16b, \tmp\().16b, \tmp\().16b, #8
+	eor		\next\().16b, \next\().16b, \tmp\().16b
+.else
+	/*
+	 * Calculate the next two tweaks by multiplying the current ones by x^2,
+	 * modulo p(x) = x^64 + x^4 + x^3 + x + 1.
+	 */
+	ushr		\tmp\().2d, \cur\().2d, #62
+	shl		\next\().2d, \cur\().2d, #2
+	tbl		\tmp\().16b, {GFMUL_TABLE.16b}, \tmp\().16b
+	eor		\next\().16b, \next\().16b, \tmp\().16b
+.endif
+.endm
+
+/*
+ * _speck_xts_crypt() - Speck-XTS encryption/decryption
+ *
+ * Encrypt or decrypt NBYTES bytes of data from the SRC buffer to the DST buffer
+ * using Speck-XTS, specifically the variant with a block size of '2n' and round
+ * count given by NROUNDS.  The expanded round keys are given in ROUND_KEYS, and
+ * the current XTS tweak value is given in TWEAK.  It's assumed that NBYTES is a
+ * nonzero multiple of 128.
+ */
+.macro _speck_xts_crypt	n, lanes, decrypting
+
+	/*
+	 * If decrypting, modify the ROUND_KEYS parameter to point to the last
+	 * round key rather than the first, since for decryption the round keys
+	 * are used in reverse order.
+	 */
+.if \decrypting
+	mov		NROUNDS, NROUNDS	/* zero the high 32 bits */
+.if \n == 64
+	add		ROUND_KEYS, ROUND_KEYS, NROUNDS_X, lsl #3
+	sub		ROUND_KEYS, ROUND_KEYS, #8
+.else
+	add		ROUND_KEYS, ROUND_KEYS, NROUNDS_X, lsl #2
+	sub		ROUND_KEYS, ROUND_KEYS, #4
+.endif
+.endif
+
+	// Load the index vector for tbl-based 8-bit rotates
+.if \decrypting
+	ldr		ROTATE_TABLE_Q, .Lrol\n\()_8_table
+.else
+	ldr		ROTATE_TABLE_Q, .Lror\n\()_8_table
+.endif
+
+	// One-time XTS preparation
+.if \n == 64
+	// Load first tweak
+	ld1		{TWEAKV0.16b}, [TWEAK]
+
+	// Load GF(2^128) multiplication table
+	ldr		GFMUL_TABLE_Q, .Lgf128mul_table
+.else
+	// Load first tweak
+	ld1		{TWEAKV0.8b}, [TWEAK]
+
+	// Load GF(2^64) multiplication table
+	ldr		GFMUL_TABLE_Q, .Lgf64mul_table
+
+	// Calculate second tweak, packing it together with the first
+	ushr		TMP0.2d, TWEAKV0.2d, #63
+	shl		TMP1.2d, TWEAKV0.2d, #1
+	tbl		TMP0.8b, {GFMUL_TABLE.16b}, TMP0.8b
+	eor		TMP0.8b, TMP0.8b, TMP1.8b
+	mov		TWEAKV0.d[1], TMP0.d[0]
+.endif
+
+.Lnext_128bytes_\@:
+
+	// Calculate XTS tweaks for next 128 bytes
+	_next_xts_tweak	TWEAKV1, TWEAKV0, TMP0, \n
+	_next_xts_tweak	TWEAKV2, TWEAKV1, TMP0, \n
+	_next_xts_tweak	TWEAKV3, TWEAKV2, TMP0, \n
+	_next_xts_tweak	TWEAKV4, TWEAKV3, TMP0, \n
+	_next_xts_tweak	TWEAKV5, TWEAKV4, TMP0, \n
+	_next_xts_tweak	TWEAKV6, TWEAKV5, TMP0, \n
+	_next_xts_tweak	TWEAKV7, TWEAKV6, TMP0, \n
+	_next_xts_tweak	TWEAKV_NEXT, TWEAKV7, TMP0, \n
+
+	// Load the next source blocks into {X,Y}[0-3]
+	ld1		{X_0.16b-Y_1.16b}, [SRC], #64
+	ld1		{X_2.16b-Y_3.16b}, [SRC], #64
+
+	// XOR the source blocks with their XTS tweaks
+	eor		TMP0.16b, X_0.16b, TWEAKV0.16b
+	eor		Y_0.16b,  Y_0.16b, TWEAKV1.16b
+	eor		TMP1.16b, X_1.16b, TWEAKV2.16b
+	eor		Y_1.16b,  Y_1.16b, TWEAKV3.16b
+	eor		TMP2.16b, X_2.16b, TWEAKV4.16b
+	eor		Y_2.16b,  Y_2.16b, TWEAKV5.16b
+	eor		TMP3.16b, X_3.16b, TWEAKV6.16b
+	eor		Y_3.16b,  Y_3.16b, TWEAKV7.16b
+
+	/*
+	 * De-interleave the 'x' and 'y' elements of each block, i.e. make it so
+	 * that the X[0-3] registers contain only the second halves of blocks,
+	 * and the Y[0-3] registers contain only the first halves of blocks.
+	 * (Speck uses the order (y, x) rather than the more intuitive (x, y).)
+	 */
+	uzp2		X_0.\lanes, TMP0.\lanes, Y_0.\lanes
+	uzp1		Y_0.\lanes, TMP0.\lanes, Y_0.\lanes
+	uzp2		X_1.\lanes, TMP1.\lanes, Y_1.\lanes
+	uzp1		Y_1.\lanes, TMP1.\lanes, Y_1.\lanes
+	uzp2		X_2.\lanes, TMP2.\lanes, Y_2.\lanes
+	uzp1		Y_2.\lanes, TMP2.\lanes, Y_2.\lanes
+	uzp2		X_3.\lanes, TMP3.\lanes, Y_3.\lanes
+	uzp1		Y_3.\lanes, TMP3.\lanes, Y_3.\lanes
+
+	// Do the cipher rounds
+	mov		x6, ROUND_KEYS
+	mov		w7, NROUNDS
+.Lnext_round_\@:
+.if \decrypting
+	ld1r		{ROUND_KEY.\lanes}, [x6]
+	sub		x6, x6, #( \n / 8 )
+	_speck_unround_128bytes	\n, \lanes
+.else
+	ld1r		{ROUND_KEY.\lanes}, [x6], #( \n / 8 )
+	_speck_round_128bytes	\n, \lanes
+.endif
+	subs		w7, w7, #1
+	bne		.Lnext_round_\@
+
+	// Re-interleave the 'x' and 'y' elements of each block
+	zip1		TMP0.\lanes, Y_0.\lanes, X_0.\lanes
+	zip2		Y_0.\lanes,  Y_0.\lanes, X_0.\lanes
+	zip1		TMP1.\lanes, Y_1.\lanes, X_1.\lanes
+	zip2		Y_1.\lanes,  Y_1.\lanes, X_1.\lanes
+	zip1		TMP2.\lanes, Y_2.\lanes, X_2.\lanes
+	zip2		Y_2.\lanes,  Y_2.\lanes, X_2.\lanes
+	zip1		TMP3.\lanes, Y_3.\lanes, X_3.\lanes
+	zip2		Y_3.\lanes,  Y_3.\lanes, X_3.\lanes
+
+	// XOR the encrypted/decrypted blocks with the tweaks calculated earlier
+	eor		X_0.16b, TMP0.16b, TWEAKV0.16b
+	eor		Y_0.16b, Y_0.16b,  TWEAKV1.16b
+	eor		X_1.16b, TMP1.16b, TWEAKV2.16b
+	eor		Y_1.16b, Y_1.16b,  TWEAKV3.16b
+	eor		X_2.16b, TMP2.16b, TWEAKV4.16b
+	eor		Y_2.16b, Y_2.16b,  TWEAKV5.16b
+	eor		X_3.16b, TMP3.16b, TWEAKV6.16b
+	eor		Y_3.16b, Y_3.16b,  TWEAKV7.16b
+	mov		TWEAKV0.16b, TWEAKV_NEXT.16b
+
+	// Store the ciphertext in the destination buffer
+	st1		{X_0.16b-Y_1.16b}, [DST], #64
+	st1		{X_2.16b-Y_3.16b}, [DST], #64
+
+	// Continue if there are more 128-byte chunks remaining
+	subs		NBYTES, NBYTES, #128
+	bne		.Lnext_128bytes_\@
+
+	// Store the next tweak and return
+.if \n == 64
+	st1		{TWEAKV_NEXT.16b}, [TWEAK]
+.else
+	st1		{TWEAKV_NEXT.8b}, [TWEAK]
+.endif
+	ret
+.endm
+
+ENTRY(speck128_xts_encrypt_neon)
+	_speck_xts_crypt	n=64, lanes=2d, decrypting=0
+ENDPROC(speck128_xts_encrypt_neon)
+
+ENTRY(speck128_xts_decrypt_neon)
+	_speck_xts_crypt	n=64, lanes=2d, decrypting=1
+ENDPROC(speck128_xts_decrypt_neon)
+
+ENTRY(speck64_xts_encrypt_neon)
+	_speck_xts_crypt	n=32, lanes=4s, decrypting=0
+ENDPROC(speck64_xts_encrypt_neon)
+
+ENTRY(speck64_xts_decrypt_neon)
+	_speck_xts_crypt	n=32, lanes=4s, decrypting=1
+ENDPROC(speck64_xts_decrypt_neon)
diff --git a/arch/arm64/crypto/speck-neon-glue.c b/arch/arm64/crypto/speck-neon-glue.c
new file mode 100644
index 00000000..c7d1856
--- /dev/null
+++ b/arch/arm64/crypto/speck-neon-glue.c
@@ -0,0 +1,308 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * NEON-accelerated implementation of Speck128-XTS and Speck64-XTS
+ * (64-bit version; based on the 32-bit version)
+ *
+ * Copyright (c) 2018 Google, Inc
+ */
+
+#include <asm/hwcap.h>
+#include <asm/neon.h>
+#include <asm/simd.h>
+#include <crypto/algapi.h>
+#include <crypto/gf128mul.h>
+#include <crypto/speck.h>
+#include <crypto/xts.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+
+/* The assembly functions only handle multiples of 128 bytes */
+#define SPECK_NEON_CHUNK_SIZE	128
+
+/* Speck128 */
+
+struct speck128_xts_tfm_ctx {
+	struct speck128_tfm_ctx main_key;
+	struct speck128_tfm_ctx tweak_key;
+};
+
+asmlinkage void speck128_xts_encrypt_neon(const u64 *round_keys, int nrounds,
+					  void *dst, const void *src,
+					  unsigned int nbytes, void *tweak);
+
+asmlinkage void speck128_xts_decrypt_neon(const u64 *round_keys, int nrounds,
+					  void *dst, const void *src,
+					  unsigned int nbytes, void *tweak);
+
+typedef void (*speck128_crypt_one_t)(const struct speck128_tfm_ctx *,
+				     u8 *, const u8 *);
+typedef void (*speck128_xts_crypt_many_t)(const u64 *, int, void *,
+					  const void *, unsigned int, void *);
+
+static __always_inline int
+__speck128_xts_crypt(struct blkcipher_desc *desc, struct scatterlist *dst,
+		     struct scatterlist *src, unsigned int nbytes,
+		     speck128_crypt_one_t crypt_one,
+		     speck128_xts_crypt_many_t crypt_many)
+{
+	struct crypto_blkcipher *tfm = desc->tfm;
+	const struct speck128_xts_tfm_ctx *ctx = crypto_blkcipher_ctx(tfm);
+	struct blkcipher_walk walk;
+	le128 tweak;
+	int err;
+
+	blkcipher_walk_init(&walk, dst, src, nbytes);
+	err = blkcipher_walk_virt_block(desc, &walk, SPECK_NEON_CHUNK_SIZE);
+
+	crypto_speck128_encrypt(&ctx->tweak_key, (u8 *)&tweak, walk.iv);
+
+	while (walk.nbytes > 0) {
+		unsigned int nbytes = walk.nbytes;
+		u8 *dst = walk.dst.virt.addr;
+		const u8 *src = walk.src.virt.addr;
+
+		if (nbytes >= SPECK_NEON_CHUNK_SIZE && may_use_simd()) {
+			unsigned int count;
+
+			count = round_down(nbytes, SPECK_NEON_CHUNK_SIZE);
+			kernel_neon_begin();
+			(*crypt_many)(ctx->main_key.round_keys,
+				      ctx->main_key.nrounds,
+				      dst, src, count, &tweak);
+			kernel_neon_end();
+			dst += count;
+			src += count;
+			nbytes -= count;
+		}
+
+		/* Handle any remainder with generic code */
+		while (nbytes >= sizeof(tweak)) {
+			le128_xor((le128 *)dst, (const le128 *)src, &tweak);
+			(*crypt_one)(&ctx->main_key, dst, dst);
+			le128_xor((le128 *)dst, (const le128 *)dst, &tweak);
+			gf128mul_x_ble((be128 *)&tweak, (const be128 *)&tweak);
+
+			dst += sizeof(tweak);
+			src += sizeof(tweak);
+			nbytes -= sizeof(tweak);
+		}
+		err = blkcipher_walk_done(desc, &walk, nbytes);
+	}
+
+	return err;
+}
+
+static int speck128_xts_encrypt(struct blkcipher_desc *desc,
+				struct scatterlist *dst,
+				struct scatterlist *src,
+				unsigned int nbytes)
+{
+	return __speck128_xts_crypt(desc, dst, src, nbytes,
+				    crypto_speck128_encrypt,
+				    speck128_xts_encrypt_neon);
+}
+
+static int speck128_xts_decrypt(struct blkcipher_desc *desc,
+				struct scatterlist *dst,
+				struct scatterlist *src,
+				unsigned int nbytes)
+{
+	return __speck128_xts_crypt(desc, dst, src, nbytes,
+				    crypto_speck128_decrypt,
+				    speck128_xts_decrypt_neon);
+}
+
+static int speck128_xts_setkey(struct crypto_tfm *tfm, const u8 *key,
+			       unsigned int keylen)
+{
+	struct speck128_xts_tfm_ctx *ctx = crypto_tfm_ctx(tfm);
+	int err;
+
+	if (keylen % 2)
+		return -EINVAL;
+
+	keylen /= 2;
+
+	err = crypto_speck128_setkey(&ctx->main_key, key, keylen);
+	if (err)
+		return err;
+
+	return crypto_speck128_setkey(&ctx->tweak_key, key + keylen, keylen);
+}
+
+/* Speck64 */
+
+struct speck64_xts_tfm_ctx {
+	struct speck64_tfm_ctx main_key;
+	struct speck64_tfm_ctx tweak_key;
+};
+
+asmlinkage void speck64_xts_encrypt_neon(const u32 *round_keys, int nrounds,
+					 void *dst, const void *src,
+					 unsigned int nbytes, void *tweak);
+
+asmlinkage void speck64_xts_decrypt_neon(const u32 *round_keys, int nrounds,
+					 void *dst, const void *src,
+					 unsigned int nbytes, void *tweak);
+
+typedef void (*speck64_crypt_one_t)(const struct speck64_tfm_ctx *,
+				    u8 *, const u8 *);
+typedef void (*speck64_xts_crypt_many_t)(const u32 *, int, void *,
+					 const void *, unsigned int, void *);
+
+static __always_inline int
+__speck64_xts_crypt(struct blkcipher_desc *desc, struct scatterlist *dst,
+		    struct scatterlist *src, unsigned int nbytes,
+		    speck64_crypt_one_t crypt_one,
+		    speck64_xts_crypt_many_t crypt_many)
+{
+	struct crypto_blkcipher *tfm = desc->tfm;
+	const struct speck64_xts_tfm_ctx *ctx = crypto_blkcipher_ctx(tfm);
+	struct blkcipher_walk walk;
+	__le64 tweak;
+	int err;
+
+	blkcipher_walk_init(&walk, dst, src, nbytes);
+	err = blkcipher_walk_virt_block(desc, &walk, SPECK_NEON_CHUNK_SIZE);
+
+	crypto_speck64_encrypt(&ctx->tweak_key, (u8 *)&tweak, walk.iv);
+
+	while (walk.nbytes > 0) {
+		unsigned int nbytes = walk.nbytes;
+		u8 *dst = walk.dst.virt.addr;
+		const u8 *src = walk.src.virt.addr;
+
+		if (nbytes >= SPECK_NEON_CHUNK_SIZE && may_use_simd()) {
+			unsigned int count;
+
+			count = round_down(nbytes, SPECK_NEON_CHUNK_SIZE);
+			kernel_neon_begin();
+			(*crypt_many)(ctx->main_key.round_keys,
+				      ctx->main_key.nrounds,
+				      dst, src, count, &tweak);
+			kernel_neon_end();
+			dst += count;
+			src += count;
+			nbytes -= count;
+		}
+
+		/* Handle any remainder with generic code */
+		while (nbytes >= sizeof(tweak)) {
+			*(__le64 *)dst = *(__le64 *)src ^ tweak;
+			(*crypt_one)(&ctx->main_key, dst, dst);
+			*(__le64 *)dst ^= tweak;
+			tweak = cpu_to_le64((le64_to_cpu(tweak) << 1) ^
+					    ((tweak & cpu_to_le64(1ULL << 63)) ?
+					     0x1B : 0));
+			dst += sizeof(tweak);
+			src += sizeof(tweak);
+			nbytes -= sizeof(tweak);
+		}
+		err = blkcipher_walk_done(desc, &walk, nbytes);
+	}
+
+	return err;
+}
+
+static int speck64_xts_encrypt(struct blkcipher_desc *desc,
+			       struct scatterlist *dst, struct scatterlist *src,
+			       unsigned int nbytes)
+{
+	return __speck64_xts_crypt(desc, dst, src, nbytes,
+				   crypto_speck64_encrypt,
+				   speck64_xts_encrypt_neon);
+}
+
+static int speck64_xts_decrypt(struct blkcipher_desc *desc,
+			       struct scatterlist *dst, struct scatterlist *src,
+			       unsigned int nbytes)
+{
+	return __speck64_xts_crypt(desc, dst, src, nbytes,
+				   crypto_speck64_decrypt,
+				   speck64_xts_decrypt_neon);
+}
+
+static int speck64_xts_setkey(struct crypto_tfm *tfm, const u8 *key,
+			      unsigned int keylen)
+{
+	struct speck64_xts_tfm_ctx *ctx = crypto_tfm_ctx(tfm);
+	int err;
+
+	if (keylen % 2)
+		return -EINVAL;
+
+	keylen /= 2;
+
+	err = crypto_speck64_setkey(&ctx->main_key, key, keylen);
+	if (err)
+		return err;
+
+	return crypto_speck64_setkey(&ctx->tweak_key, key + keylen, keylen);
+}
+
+static struct crypto_alg speck_algs[] = {
+	{
+		.cra_name		= "xts(speck128)",
+		.cra_driver_name	= "xts-speck128-neon",
+		.cra_priority		= 300,
+		.cra_flags		= CRYPTO_ALG_TYPE_BLKCIPHER,
+		.cra_blocksize		= SPECK128_BLOCK_SIZE,
+		.cra_type		= &crypto_blkcipher_type,
+		.cra_ctxsize		= sizeof(struct speck128_xts_tfm_ctx),
+		.cra_alignmask		= 7,
+		.cra_module		= THIS_MODULE,
+		.cra_u = {
+			.blkcipher = {
+				.min_keysize		= 2 * SPECK128_128_KEY_SIZE,
+				.max_keysize		= 2 * SPECK128_256_KEY_SIZE,
+				.ivsize			= SPECK128_BLOCK_SIZE,
+				.setkey			= speck128_xts_setkey,
+				.encrypt		= speck128_xts_encrypt,
+				.decrypt		= speck128_xts_decrypt,
+			}
+		}
+	}, {
+		.cra_name		= "xts(speck64)",
+		.cra_driver_name	= "xts-speck64-neon",
+		.cra_priority		= 300,
+		.cra_flags		= CRYPTO_ALG_TYPE_BLKCIPHER,
+		.cra_blocksize		= SPECK64_BLOCK_SIZE,
+		.cra_type		= &crypto_blkcipher_type,
+		.cra_ctxsize		= sizeof(struct speck64_xts_tfm_ctx),
+		.cra_alignmask		= 7,
+		.cra_module		= THIS_MODULE,
+		.cra_u = {
+			.blkcipher = {
+				.min_keysize		= 2 * SPECK64_96_KEY_SIZE,
+				.max_keysize		= 2 * SPECK64_128_KEY_SIZE,
+				.ivsize			= SPECK64_BLOCK_SIZE,
+				.setkey			= speck64_xts_setkey,
+				.encrypt		= speck64_xts_encrypt,
+				.decrypt		= speck64_xts_decrypt,
+			}
+		}
+	}
+};
+
+static int __init speck_neon_module_init(void)
+{
+	if (!(elf_hwcap & HWCAP_ASIMD))
+		return -ENODEV;
+	return crypto_register_algs(speck_algs, ARRAY_SIZE(speck_algs));
+}
+
+static void __exit speck_neon_module_exit(void)
+{
+	crypto_unregister_algs(speck_algs, ARRAY_SIZE(speck_algs));
+}
+
+module_init(speck_neon_module_init);
+module_exit(speck_neon_module_exit);
+
+MODULE_DESCRIPTION("Speck block cipher (NEON-accelerated)");
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Eric Biggers <ebiggers@google.com>");
+MODULE_ALIAS_CRYPTO("xts(speck128)");
+MODULE_ALIAS_CRYPTO("xts-speck128-neon");
+MODULE_ALIAS_CRYPTO("xts(speck64)");
+MODULE_ALIAS_CRYPTO("xts-speck64-neon");
diff --git a/arch/arm64/include/asm/Kbuild b/arch/arm64/include/asm/Kbuild
index 44e1d7f..28196b1 100644
--- a/arch/arm64/include/asm/Kbuild
+++ b/arch/arm64/include/asm/Kbuild
@@ -1,7 +1,6 @@
 generic-y += bugs.h
 generic-y += clkdev.h
 generic-y += cputime.h
-generic-y += current.h
 generic-y += delay.h
 generic-y += div64.h
 generic-y += dma.h
diff --git a/arch/arm64/include/asm/arch_gicv3.h b/arch/arm64/include/asm/arch_gicv3.h
index f8ae6d6..fecf7bf 100644
--- a/arch/arm64/include/asm/arch_gicv3.h
+++ b/arch/arm64/include/asm/arch_gicv3.h
@@ -83,14 +83,20 @@
 #define read_gicreg(r)							\
 	({								\
 		u64 reg;						\
-		asm volatile("mrs_s %0, " __stringify(r) : "=r" (reg));	\
+		asm volatile(DEFINE_MRS_S				\
+			"mrs_s %0, " __stringify(r) "\n"		\
+			UNDEFINE_MRS_S					\
+			: "=r" (reg));					\
 		reg;							\
 	})
 
 #define write_gicreg(v,r)						\
 	do {								\
 		u64 __val = (v);					\
-		asm volatile("msr_s " __stringify(r) ", %0" : : "r" (__val));\
+		asm volatile(DEFINE_MSR_S				\
+			"msr_s " __stringify(r) ", %0\n"		\
+			UNDEFINE_MSR_S					\
+			: : "r" (__val));				\
 	} while (0)
 
 /*
@@ -102,13 +108,19 @@
 
 static inline void gic_write_eoir(u32 irq)
 {
-	asm volatile("msr_s " __stringify(ICC_EOIR1_EL1) ", %0" : : "r" ((u64)irq));
+	asm volatile(DEFINE_MSR_S
+		"msr_s " __stringify(ICC_EOIR1_EL1) ", %0\n"
+		UNDEFINE_MSR_S
+		: : "r" ((u64)irq));
 	isb();
 }
 
 static inline void gic_write_dir(u32 irq)
 {
-	asm volatile("msr_s " __stringify(ICC_DIR_EL1) ", %0" : : "r" ((u64)irq));
+	asm volatile(DEFINE_MSR_S
+		"msr_s " __stringify(ICC_DIR_EL1) ", %0\n"
+		UNDEFINE_MSR_S
+		: : "r" ((u64)irq));
 	isb();
 }
 
@@ -116,7 +128,10 @@ static inline u64 gic_read_iar_common(void)
 {
 	u64 irqstat;
 
-	asm volatile("mrs_s %0, " __stringify(ICC_IAR1_EL1) : "=r" (irqstat));
+	asm volatile(DEFINE_MRS_S
+		"mrs_s %0, " __stringify(ICC_IAR1_EL1) "\n"
+		UNDEFINE_MRS_S
+		: "=r" (irqstat));
 	dsb(sy);
 	return irqstat;
 }
@@ -135,7 +150,9 @@ static inline u64 gic_read_iar_cavium_thunderx(void)
 	asm volatile(
 		"nop;nop;nop;nop\n\t"
 		"nop;nop;nop;nop\n\t"
+		DEFINE_MRS_S
 		"mrs_s %0, " __stringify(ICC_IAR1_EL1) "\n\t"
+		UNDEFINE_MRS_S
 		"nop;nop;nop;nop"
 		: "=r" (irqstat));
 	mb();
@@ -145,43 +162,68 @@ static inline u64 gic_read_iar_cavium_thunderx(void)
 
 static inline void gic_write_pmr(u32 val)
 {
-	asm volatile("msr_s " __stringify(ICC_PMR_EL1) ", %0" : : "r" ((u64)val));
+	asm volatile(DEFINE_MSR_S
+		"msr_s " __stringify(ICC_PMR_EL1) ", %0\n"
+		UNDEFINE_MSR_S
+		: : "r" ((u64)val));
+	/* As per the architecture specification */
+	mb();
 }
 
 static inline void gic_write_ctlr(u32 val)
 {
-	asm volatile("msr_s " __stringify(ICC_CTLR_EL1) ", %0" : : "r" ((u64)val));
+	asm volatile(DEFINE_MSR_S
+		"msr_s " __stringify(ICC_CTLR_EL1) ", %0\n"
+		UNDEFINE_MSR_S
+		: : "r" ((u64)val));
 	isb();
 }
 
 static inline void gic_write_grpen1(u32 val)
 {
-	asm volatile("msr_s " __stringify(ICC_GRPEN1_EL1) ", %0" : : "r" ((u64)val));
+	asm volatile(DEFINE_MSR_S
+		"msr_s " __stringify(ICC_GRPEN1_EL1) ", %0\n"
+		UNDEFINE_MSR_S
+		: : "r" ((u64)val));
 	isb();
 }
 
 static inline void gic_write_sgi1r(u64 val)
 {
-	asm volatile("msr_s " __stringify(ICC_SGI1R_EL1) ", %0" : : "r" (val));
+	asm volatile(DEFINE_MSR_S
+		"msr_s " __stringify(ICC_SGI1R_EL1) ", %0\n"
+		UNDEFINE_MSR_S
+		: : "r" (val));
+	/* As per the architecture specification */
+	mb();
 }
 
 static inline u32 gic_read_sre(void)
 {
 	u64 val;
 
-	asm volatile("mrs_s %0, " __stringify(ICC_SRE_EL1) : "=r" (val));
+	asm volatile(DEFINE_MRS_S
+		"mrs_s %0, " __stringify(ICC_SRE_EL1) "\n"
+		UNDEFINE_MRS_S
+		: "=r" (val));
 	return val;
 }
 
 static inline void gic_write_sre(u32 val)
 {
-	asm volatile("msr_s " __stringify(ICC_SRE_EL1) ", %0" : : "r" ((u64)val));
+	asm volatile(DEFINE_MSR_S
+		"msr_s " __stringify(ICC_SRE_EL1) ", %0\n"
+		UNDEFINE_MSR_S
+		: : "r" ((u64)val));
 	isb();
 }
 
 static inline void gic_write_bpr1(u32 val)
 {
-	asm volatile("msr_s " __stringify(ICC_BPR1_EL1) ", %0" : : "r" (val));
+	asm volatile(DEFINE_MSR_S
+		"msr_s " __stringify(ICC_BPR1_EL1) ", %x0\n"
+		UNDEFINE_MSR_S
+		: : "rZ" (val));
 }
 
 #define gic_read_typer(c)		readq_relaxed(c)
diff --git a/arch/arm64/include/asm/arm_pmuv3.h b/arch/arm64/include/asm/arm_pmuv3.h
new file mode 100644
index 00000000..558ed16
--- /dev/null
+++ b/arch/arm64/include/asm/arm_pmuv3.h
@@ -0,0 +1,111 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (C) 2012 ARM Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __ASM_PMUV3_H
+#define __ASM_PMUV3_H
+
+#include <asm/cpufeature.h>
+#include <asm/sysreg.h>
+
+static inline int read_pmuver(void)
+{
+	u64 dfr0 = read_sysreg(id_aa64dfr0_el1);
+	return cpuid_feature_extract_unsigned_field(dfr0,
+						    ID_AA64DFR0_PMUVER_SHIFT);
+}
+
+static inline void write_pmcr(u32 val)
+{
+	write_sysreg(val, pmcr_el0);
+}
+
+static inline u32 read_pmcr(void)
+{
+	return read_sysreg(pmcr_el0);
+}
+
+static inline void write_pmselr(u32 val)
+{
+	write_sysreg(val, pmselr_el0);
+}
+
+static inline void write_pmccntr(u64 val)
+{
+	write_sysreg(val, pmccntr_el0);
+}
+
+static inline u64 read_pmccntr(void)
+{
+	return read_sysreg(pmccntr_el0);
+}
+
+static inline void write_pmxevcntr(u32 val)
+{
+	write_sysreg(val, pmxevcntr_el0);
+}
+
+static inline u32 read_pmxevcntr(void)
+{
+	return read_sysreg(pmxevcntr_el0);
+}
+
+static inline void write_pmxevtyper(u32 val)
+{
+	write_sysreg(val, pmxevtyper_el0);
+}
+
+static inline void write_pmcntenset(u32 val)
+{
+	write_sysreg(val, pmcntenset_el0);
+}
+
+static inline void write_pmcntenclr(u32 val)
+{
+	write_sysreg(val, pmcntenclr_el0);
+}
+
+static inline void write_pmintenset(u32 val)
+{
+	write_sysreg(val, pmintenset_el1);
+}
+
+static inline void write_pmintenclr(u32 val)
+{
+	write_sysreg(val, pmintenclr_el1);
+}
+
+static inline void write_pmovsclr(u32 val)
+{
+	write_sysreg(val, pmovsclr_el0);
+}
+
+static inline u32 read_pmovsclr(void)
+{
+	return read_sysreg(pmovsclr_el0);
+}
+
+static inline u32 read_pmceid0(void)
+{
+	return read_sysreg(pmceid0_el0);
+}
+
+static inline u32 read_pmceid1(void)
+{
+	return read_sysreg(pmceid1_el0);
+}
+
+#endif
diff --git a/arch/arm64/include/asm/assembler.h b/arch/arm64/include/asm/assembler.h
index 3f85bbc..75bad61 100644
--- a/arch/arm64/include/asm/assembler.h
+++ b/arch/arm64/include/asm/assembler.h
@@ -42,6 +42,29 @@
 	msr	daifclr, #2
 	.endm
 
+	.macro	save_and_disable_irq, flags
+	mrs	\flags, daif
+	msr	daifset, #2
+	.endm
+
+	.macro	restore_irq, flags
+	msr	daif, \flags
+	.endm
+
+#ifdef CONFIG_RTK_PLATFORM
+/*
+* Save/disable and restore interrupts.
+*/
+	.macro  save_and_disable_irqs, olddaif
+	mrs     \olddaif, daif
+	disable_irq
+	.endm
+
+	.macro  restore_irqs, olddaif
+	msr     daif, \olddaif
+	.endm
+#endif /* CONFIG_RTK_PLATFORM */
+
 /*
  * Enable and disable debug exceptions.
  */
@@ -451,6 +474,13 @@
 	movk	\reg, :abs_g0_nc:\val
 	.endm
 
+/*
+ * Return the current thread_info.
+ */
+	.macro	get_thread_info, rd
+	mrs	\rd, sp_el0
+	.endm
+
 	.macro	pte_to_phys, phys, pte
 	and	\phys, \pte, #(((1 << (48 - PAGE_SHIFT)) - 1) << PAGE_SHIFT)
 	.endm
diff --git a/arch/arm64/include/asm/barrier.h b/arch/arm64/include/asm/barrier.h
index 0b0755c..6aeb98f 100644
--- a/arch/arm64/include/asm/barrier.h
+++ b/arch/arm64/include/asm/barrier.h
@@ -20,6 +20,10 @@
 
 #ifndef __ASSEMBLY__
 
+#ifdef CONFIG_RTK_RBUS_BARRIER
+extern void rtk_bus_sync(void);
+#endif /* CONFIG_RTK_RBUS_BARRIER */
+
 #define __nops(n)	".rept	" #n "\nnop\n.endr\n"
 #define nops(n)		asm volatile(__nops(n))
 
@@ -35,7 +39,12 @@
 
 #define mb()		dsb(sy)
 #define rmb()		dsb(ld)
+
+#ifdef CONFIG_RTK_RBUS_BARRIER
+#define wmb()		do { dsb(st); rtk_bus_sync(); } while (0)
+#else
 #define wmb()		dsb(st)
+#endif /* CONFIG_RTK_RBUS_BARRIER */
 
 #define dma_rmb()	dmb(oshld)
 #define dma_wmb()	dmb(oshst)
diff --git a/arch/arm64/include/asm/cacheflush.h b/arch/arm64/include/asm/cacheflush.h
index 2e5fb97..93ae6ec 100644
--- a/arch/arm64/include/asm/cacheflush.h
+++ b/arch/arm64/include/asm/cacheflush.h
@@ -65,6 +65,9 @@
  *		- kaddr  - page address
  *		- size   - region size
  */
+#ifdef CONFIG_RTK_PLATFORM
+extern void flush_cache_all(void);
+#endif /* CONFIG_RTK_PLATFORM */
 extern void flush_cache_range(struct vm_area_struct *vma, unsigned long start, unsigned long end);
 extern void flush_icache_range(unsigned long start, unsigned long end);
 extern void __flush_dcache_area(void *addr, size_t len);
diff --git a/arch/arm64/include/asm/cpufeature.h b/arch/arm64/include/asm/cpufeature.h
index 15868ec..1dc16f5 100644
--- a/arch/arm64/include/asm/cpufeature.h
+++ b/arch/arm64/include/asm/cpufeature.h
@@ -221,6 +221,12 @@ static inline bool system_supports_mixed_endian_el0(void)
 	return id_aa64mmfr0_mixed_endian_el0(read_system_reg(SYS_ID_AA64MMFR0_EL1));
 }
 
+static inline bool system_uses_ttbr0_pan(void)
+{
+	return IS_ENABLED(CONFIG_ARM64_SW_TTBR0_PAN) &&
+		!cpus_have_cap(ARM64_HAS_PAN);
+}
+
 #define ARM64_SSBD_UNKNOWN		-1
 #define ARM64_SSBD_FORCE_DISABLE	0
 #define ARM64_SSBD_KERNEL		1
diff --git a/arch/arm64/include/asm/current.h b/arch/arm64/include/asm/current.h
new file mode 100644
index 00000000..86c4041
--- /dev/null
+++ b/arch/arm64/include/asm/current.h
@@ -0,0 +1,30 @@
+#ifndef __ASM_CURRENT_H
+#define __ASM_CURRENT_H
+
+#include <linux/compiler.h>
+
+#include <asm/sysreg.h>
+
+#ifndef __ASSEMBLY__
+
+struct task_struct;
+
+/*
+ * We don't use read_sysreg() as we want the compiler to cache the value where
+ * possible.
+ */
+static __always_inline struct task_struct *get_current(void)
+{
+	unsigned long sp_el0;
+
+	asm ("mrs %0, sp_el0" : "=r" (sp_el0));
+
+	return (struct task_struct *)sp_el0;
+}
+
+#define current get_current()
+
+#endif /* __ASSEMBLY__ */
+
+#endif /* __ASM_CURRENT_H */
+
diff --git a/arch/arm64/include/asm/dma-mapping.h b/arch/arm64/include/asm/dma-mapping.h
index ccea82c..068d8ab 100644
--- a/arch/arm64/include/asm/dma-mapping.h
+++ b/arch/arm64/include/asm/dma-mapping.h
@@ -66,16 +66,25 @@ static inline bool is_device_dma_coherent(struct device *dev)
 
 static inline dma_addr_t phys_to_dma(struct device *dev, phys_addr_t paddr)
 {
+#ifdef CONFIG_RTK_PLATFORM
+	return (dma_addr_t)paddr;
+#else
 	dma_addr_t dev_addr = (dma_addr_t)paddr;
 
 	return dev_addr - ((dma_addr_t)dev->dma_pfn_offset << PAGE_SHIFT);
+#endif /* CONFIG_RTK_PLATFORM */
+
 }
 
 static inline phys_addr_t dma_to_phys(struct device *dev, dma_addr_t dev_addr)
 {
+#ifdef CONFIG_RTK_PLATFORM
+	return (phys_addr_t)dev_addr;
+#else
 	phys_addr_t paddr = (phys_addr_t)dev_addr;
 
 	return paddr + ((phys_addr_t)dev->dma_pfn_offset << PAGE_SHIFT);
+#endif /* CONFIG_RTK_PLATFORM */
 }
 
 static inline bool dma_capable(struct device *dev, dma_addr_t addr, size_t size)
diff --git a/arch/arm64/include/asm/efi.h b/arch/arm64/include/asm/efi.h
index a9e54aa..6c4f9e8 100644
--- a/arch/arm64/include/asm/efi.h
+++ b/arch/arm64/include/asm/efi.h
@@ -1,6 +1,7 @@
 #ifndef _ASM_EFI_H
 #define _ASM_EFI_H
 
+#include <asm/cpufeature.h>
 #include <asm/io.h>
 #include <asm/mmu_context.h>
 #include <asm/neon.h>
@@ -54,6 +55,9 @@
 #define alloc_screen_info(x...)		&screen_info
 #define free_screen_info(x...)
 
+/* redeclare as 'hidden' so the compiler will generate relative references */
+extern struct screen_info screen_info __attribute__((__visibility__("hidden")));
+
 static inline void efifb_setup_from_dmi(struct screen_info *si, const char *opt)
 {
 }
@@ -75,7 +79,32 @@ static inline void efifb_setup_from_dmi(struct screen_info *si, const char *opt)
 
 static inline void efi_set_pgd(struct mm_struct *mm)
 {
-	switch_mm(NULL, mm, NULL);
+	__switch_mm(mm);
+
+	if (system_uses_ttbr0_pan()) {
+		if (mm != current->active_mm) {
+			/*
+			 * Update the current thread's saved ttbr0 since it is
+			 * restored as part of a return from exception. Enable
+			 * access to the valid TTBR0_EL1 and invoke the errata
+			 * workaround directly since there is no return from
+			 * exception when invoking the EFI run-time services.
+			 */
+			update_saved_ttbr0(current, mm);
+			uaccess_ttbr0_enable();
+			post_ttbr_update_workaround();
+		} else {
+			/*
+			 * Defer the switch to the current thread's TTBR0_EL1
+			 * until uaccess_enable(). Restore the current
+			 * thread's saved ttbr0 corresponding to its active_mm
+			 * (if different from init_mm).
+			 */
+			uaccess_ttbr0_disable();
+			if (current->active_mm != &init_mm)
+				update_saved_ttbr0(current, current->active_mm);
+		}
+	}
 }
 
 void efi_virtmap_load(void);
diff --git a/arch/arm64/include/asm/elf.h b/arch/arm64/include/asm/elf.h
index 1fb0230..07972ba 100644
--- a/arch/arm64/include/asm/elf.h
+++ b/arch/arm64/include/asm/elf.h
@@ -168,8 +168,13 @@ extern int arch_setup_additional_pages(struct linux_binprm *bprm,
 
 #ifdef CONFIG_COMPAT
 
+#ifdef CONFIG_ANDROID_KK
 /* PIE load location for compat arm. Must match ARM ELF_ET_DYN_BASE. */
-#define COMPAT_ELF_ET_DYN_BASE		0x000400000UL
+#define COMPAT_ELF_ET_DYN_BASE          0x000400000UL
+#else
+/* PIE load location for compat arm. Must match ARM ELF_ET_DYN_BASE. */
+#define COMPAT_ELF_ET_DYN_BASE          (2 * TASK_SIZE_32 / 3)
+#endif /* CONFIG_ANDROID_KK */
 
 /* AArch32 registers. */
 #define COMPAT_ELF_NGREG		18
diff --git a/arch/arm64/include/asm/esr.h b/arch/arm64/include/asm/esr.h
index d14c478..85997c0 100644
--- a/arch/arm64/include/asm/esr.h
+++ b/arch/arm64/include/asm/esr.h
@@ -175,6 +175,12 @@
 #define ESR_ELx_SYS64_ISS_SYS_CTR_READ	(ESR_ELx_SYS64_ISS_SYS_CTR | \
 					 ESR_ELx_SYS64_ISS_DIR_READ)
 
+#define ESR_ELx_SYS64_ISS_SYS_CNTVCT	(ESR_ELx_SYS64_ISS_SYS_VAL(3, 3, 2, 14, 0) | \
+					 ESR_ELx_SYS64_ISS_DIR_READ)
+
+#define ESR_ELx_SYS64_ISS_SYS_CNTFRQ	(ESR_ELx_SYS64_ISS_SYS_VAL(3, 3, 0, 14, 0) | \
+					 ESR_ELx_SYS64_ISS_DIR_READ)
+
 #ifndef __ASSEMBLY__
 #include <asm/types.h>
 
diff --git a/arch/arm64/include/asm/futex.h b/arch/arm64/include/asm/futex.h
index 2a5090f..a891bb6 100644
--- a/arch/arm64/include/asm/futex.h
+++ b/arch/arm64/include/asm/futex.h
@@ -21,15 +21,12 @@
 #include <linux/futex.h>
 #include <linux/uaccess.h>
 
-#include <asm/alternative.h>
-#include <asm/cpufeature.h>
 #include <asm/errno.h>
-#include <asm/sysreg.h>
 
 #define __futex_atomic_op(insn, ret, oldval, uaddr, tmp, oparg)		\
+do {									\
+	uaccess_enable();						\
 	asm volatile(							\
-	ALTERNATIVE("nop", SET_PSTATE_PAN(0), ARM64_HAS_PAN,		\
-		    CONFIG_ARM64_PAN)					\
 "	prfm	pstl1strm, %2\n"					\
 "1:	ldxr	%w1, %2\n"						\
 	insn "\n"							\
@@ -44,11 +41,11 @@
 "	.popsection\n"							\
 	_ASM_EXTABLE(1b, 4b)						\
 	_ASM_EXTABLE(2b, 4b)						\
-	ALTERNATIVE("nop", SET_PSTATE_PAN(1), ARM64_HAS_PAN,		\
-		    CONFIG_ARM64_PAN)					\
 	: "=&r" (ret), "=&r" (oldval), "+Q" (*uaddr), "=&r" (tmp)	\
 	: "r" (oparg), "Ir" (-EFAULT)					\
-	: "memory")
+	: "memory");							\
+	uaccess_disable();						\
+} while (0)
 
 static inline int
 arch_futex_atomic_op_inuser(int op, int oparg, int *oval, u32 __user *uaddr)
@@ -102,8 +99,8 @@
 		return -EFAULT;
 
 	uaddr = __uaccess_mask_ptr(_uaddr);
+	uaccess_enable();
 	asm volatile("// futex_atomic_cmpxchg_inatomic\n"
-ALTERNATIVE("nop", SET_PSTATE_PAN(0), ARM64_HAS_PAN, CONFIG_ARM64_PAN)
 "	prfm	pstl1strm, %2\n"
 "1:	ldxr	%w1, %2\n"
 "	sub	%w3, %w1, %w4\n"
@@ -118,10 +115,10 @@
 "	.popsection\n"
 	_ASM_EXTABLE(1b, 4b)
 	_ASM_EXTABLE(2b, 4b)
-ALTERNATIVE("nop", SET_PSTATE_PAN(1), ARM64_HAS_PAN, CONFIG_ARM64_PAN)
 	: "+r" (ret), "=&r" (val), "+Q" (*uaddr), "=&r" (tmp)
 	: "r" (oldval), "r" (newval), "Ir" (-EFAULT)
 	: "memory");
+	uaccess_disable();
 
 	*uval = val;
 	return ret;
diff --git a/arch/arm64/include/asm/hw_breakpoint.h b/arch/arm64/include/asm/hw_breakpoint.h
index 9510ace..b6b167a 100644
--- a/arch/arm64/include/asm/hw_breakpoint.h
+++ b/arch/arm64/include/asm/hw_breakpoint.h
@@ -77,7 +77,11 @@ static inline void decode_ctrl_reg(u32 reg,
 /* Lengths */
 #define ARM_BREAKPOINT_LEN_1	0x1
 #define ARM_BREAKPOINT_LEN_2	0x3
+#define ARM_BREAKPOINT_LEN_3	0x7
 #define ARM_BREAKPOINT_LEN_4	0xf
+#define ARM_BREAKPOINT_LEN_5	0x1f
+#define ARM_BREAKPOINT_LEN_6	0x3f
+#define ARM_BREAKPOINT_LEN_7	0x7f
 #define ARM_BREAKPOINT_LEN_8	0xff
 
 /* Kernel stepping */
@@ -119,7 +123,7 @@ static inline void decode_ctrl_reg(u32 reg,
 struct pmu;
 
 extern int arch_bp_generic_fields(struct arch_hw_breakpoint_ctrl ctrl,
-				  int *gen_len, int *gen_type);
+				  int *gen_len, int *gen_type, int *offset);
 extern int arch_check_bp_in_kernelspace(struct perf_event *bp);
 extern int arch_validate_hwbkpt_settings(struct perf_event *bp);
 extern int hw_breakpoint_exceptions_notify(struct notifier_block *unused,
diff --git a/arch/arm64/include/asm/io.h b/arch/arm64/include/asm/io.h
index 0bba427..b342ddd 100644
--- a/arch/arm64/include/asm/io.h
+++ b/arch/arm64/include/asm/io.h
@@ -23,6 +23,7 @@
 
 #include <linux/types.h>
 #include <linux/blk_types.h>
+#include <linux/rtk_trace.h>
 
 #include <asm/byteorder.h>
 #include <asm/barrier.h>
@@ -37,32 +38,27 @@
 /*
  * Generic IO read/write.  These perform native-endian accesses.
  */
-#define __raw_writeb __raw_writeb
-static inline void __raw_writeb(u8 val, volatile void __iomem *addr)
+static inline void __raw_writeb_no_log(u8 val, volatile void __iomem *addr)
 {
 	asm volatile("strb %w0, [%1]" : : "rZ" (val), "r" (addr));
 }
 
-#define __raw_writew __raw_writew
-static inline void __raw_writew(u16 val, volatile void __iomem *addr)
+static inline void __raw_writew_no_log(u16 val, volatile void __iomem *addr)
 {
 	asm volatile("strh %w0, [%1]" : : "rZ" (val), "r" (addr));
 }
 
-#define __raw_writel __raw_writel
-static inline void __raw_writel(u32 val, volatile void __iomem *addr)
+static inline void __raw_writel_no_log(u32 val, volatile void __iomem *addr)
 {
 	asm volatile("str %w0, [%1]" : : "rZ" (val), "r" (addr));
 }
 
-#define __raw_writeq __raw_writeq
-static inline void __raw_writeq(u64 val, volatile void __iomem *addr)
+static inline void __raw_writeq_no_log(u64 val, volatile void __iomem *addr)
 {
 	asm volatile("str %x0, [%1]" : : "rZ" (val), "r" (addr));
 }
 
-#define __raw_readb __raw_readb
-static inline u8 __raw_readb(const volatile void __iomem *addr)
+static inline u8 __raw_readb_no_log(const volatile void __iomem *addr)
 {
 	u8 val;
 	asm volatile(ALTERNATIVE("ldrb %w0, [%1]",
@@ -72,8 +68,7 @@ static inline u8 __raw_readb(const volatile void __iomem *addr)
 	return val;
 }
 
-#define __raw_readw __raw_readw
-static inline u16 __raw_readw(const volatile void __iomem *addr)
+static inline u16 __raw_readw_no_log(const volatile void __iomem *addr)
 {
 	u16 val;
 
@@ -84,8 +79,7 @@ static inline u16 __raw_readw(const volatile void __iomem *addr)
 	return val;
 }
 
-#define __raw_readl __raw_readl
-static inline u32 __raw_readl(const volatile void __iomem *addr)
+static inline u32 __raw_readl_no_log(const volatile void __iomem *addr)
 {
 	u32 val;
 	asm volatile(ALTERNATIVE("ldr %w0, [%1]",
@@ -95,8 +89,7 @@ static inline u32 __raw_readl(const volatile void __iomem *addr)
 	return val;
 }
 
-#define __raw_readq __raw_readq
-static inline u64 __raw_readq(const volatile void __iomem *addr)
+static inline u64 __raw_readq_no_log(const volatile void __iomem *addr)
 {
 	u64 val;
 	asm volatile(ALTERNATIVE("ldr %0, [%1]",
@@ -112,6 +105,38 @@ static inline u64 __raw_readq(const volatile void __iomem *addr)
 
 #define mmiowb()		do { } while (0)
 
+#define __raw_write_logged(v, a, _t) ({ \
+	int _ret; \
+	void *_addr = (void *)(a); \
+	_ret = uncached_logk(LOGK_WRITEL, _addr); \
+	ETB_WAYPOINT; \
+	__raw_write##_t##_no_log((v), _addr); \
+	if (_ret) \
+		LOG_BARRIER; \
+	})
+
+#define __raw_writeb(v, a)	__raw_write_logged((v), a, b)
+#define __raw_writew(v, a)	__raw_write_logged((v), a, w)
+#define __raw_writel(v, a)	__raw_write_logged((v), a, l)
+#define __raw_writeq(v, a)	__raw_write_logged((v), a, q)
+
+#define __raw_read_logged(a, _l, _t)    ({ \
+	_t __a; \
+	void *_addr = (void *)(a); \
+	int _ret; \
+	_ret = uncached_logk(LOGK_READL, _addr); \
+	ETB_WAYPOINT; \
+	__a = __raw_read##_l##_no_log(_addr); \
+	if (_ret) \
+		LOG_BARRIER; \
+	__a; \
+	})
+
+#define __raw_readb(a)		__raw_read_logged((a), b, u8)
+#define __raw_readw(a)		__raw_read_logged((a), w, u16)
+#define __raw_readl(a)		__raw_read_logged((a), l, u32)
+#define __raw_readq(a)		__raw_read_logged((a), q, u64)
+
 /*
  * Relaxed I/O memory access primitives. These follow the Device memory
  * ordering rules but do not guarantee any ordering relative to Normal memory
@@ -127,6 +152,16 @@ static inline u64 __raw_readq(const volatile void __iomem *addr)
 #define writel_relaxed(v,c)	((void)__raw_writel((__force u32)cpu_to_le32(v),(c)))
 #define writeq_relaxed(v,c)	((void)__raw_writeq((__force u64)cpu_to_le64(v),(c)))
 
+#define readb_relaxed_no_log(c)	({ u8 __v = __raw_readb_no_log(c); __v; })
+#define readw_relaxed_no_log(c)	({ u16 __v = le16_to_cpu((__force __le16)__raw_readw_no_log(c)); __v; })
+#define readl_relaxed_no_log(c)	({ u32 __v = le32_to_cpu((__force __le32)__raw_readl_no_log(c)); __v; })
+#define readq_relaxed_no_log(c)	({ u64 __v = le64_to_cpu((__force __le64)__raw_readq_no_log(c)); __v; })
+
+#define writeb_relaxed_no_log(v, c)	((void)__raw_writeb_no_log((v), (c)))
+#define writew_relaxed_no_log(v, c)	((void)__raw_writew_no_log((__force u16)cpu_to_le16(v), (c)))
+#define writel_relaxed_no_log(v, c)	((void)__raw_writel_no_log((__force u32)cpu_to_le32(v), (c)))
+#define writeq_relaxed_no_log(v, c)	((void)__raw_writeq_no_log((__force u64)cpu_to_le64(v), (c)))
+
 /*
  * I/O memory access primitives. Reads are ordered relative to any
  * following Normal memory access. Writes are ordered relative to any prior
@@ -142,6 +177,15 @@ static inline u64 __raw_readq(const volatile void __iomem *addr)
 #define writel(v,c)		({ __iowmb(); writel_relaxed((v),(c)); })
 #define writeq(v,c)		({ __iowmb(); writeq_relaxed((v),(c)); })
 
+#define readb_no_log(c)		({ u8  __v = readb_relaxed_no_log(c); __iormb(); __v; })
+#define readw_no_log(c)		({ u16 __v = readw_relaxed_no_log(c); __iormb(); __v; })
+#define readl_no_log(c)		({ u32 __v = readl_relaxed_no_log(c); __iormb(); __v; })
+#define readq_no_log(c)		({ u64 __v = readq_relaxed_no_log(c); __iormb(); __v; })
+
+#define writeb_no_log(v, c)	({ __iowmb(); writeb_relaxed_no_log((v), (c)); })
+#define writew_no_log(v, c)	({ __iowmb(); writew_relaxed_no_log((v), (c)); })
+#define writel_no_log(v, c)	({ __iowmb(); writel_relaxed_no_log((v), (c)); })
+#define writeq_no_log(v, c)	({ __iowmb(); writeq_relaxed_no_log((v), (c)); })
 /*
  *  I/O port access primitives.
  */
diff --git a/arch/arm64/include/asm/kernel-pgtable.h b/arch/arm64/include/asm/kernel-pgtable.h
index 7e51d1b..7803343 100644
--- a/arch/arm64/include/asm/kernel-pgtable.h
+++ b/arch/arm64/include/asm/kernel-pgtable.h
@@ -19,6 +19,7 @@
 #ifndef __ASM_KERNEL_PGTABLE_H
 #define __ASM_KERNEL_PGTABLE_H
 
+#include <asm/pgtable.h>
 #include <asm/sparsemem.h>
 
 /*
@@ -54,6 +55,12 @@
 #define SWAPPER_DIR_SIZE	(SWAPPER_PGTABLE_LEVELS * PAGE_SIZE)
 #define IDMAP_DIR_SIZE		(IDMAP_PGTABLE_LEVELS * PAGE_SIZE)
 
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+#define RESERVED_TTBR0_SIZE	(PAGE_SIZE)
+#else
+#define RESERVED_TTBR0_SIZE	(0)
+#endif
+
 /* Initial memory map size */
 #if ARM64_SWAPPER_USES_SECTION_MAPS
 #define SWAPPER_BLOCK_SHIFT	SECTION_SHIFT
diff --git a/arch/arm64/include/asm/kvm_hyp.h b/arch/arm64/include/asm/kvm_hyp.h
index b18e852..36d6758 100644
--- a/arch/arm64/include/asm/kvm_hyp.h
+++ b/arch/arm64/include/asm/kvm_hyp.h
@@ -29,7 +29,9 @@
 	({								\
 		u64 reg;						\
 		asm volatile(ALTERNATIVE("mrs %0, " __stringify(r##nvh),\
-					 "mrs_s %0, " __stringify(r##vh),\
+					 DEFINE_MRS_S			\
+					 "mrs_s %0, " __stringify(r##vh) "\n"\
+					 UNDEFINE_MRS_S,		\
 					 ARM64_HAS_VIRT_HOST_EXTN)	\
 			     : "=r" (reg));				\
 		reg;							\
@@ -39,7 +41,9 @@
 	do {								\
 		u64 __val = (u64)(v);					\
 		asm volatile(ALTERNATIVE("msr " __stringify(r##nvh) ", %x0",\
-					 "msr_s " __stringify(r##vh) ", %x0",\
+					 DEFINE_MSR_S			\
+					 "msr_s " __stringify(r##vh) ", %x0\n"\
+					 UNDEFINE_MSR_S,		\
 					 ARM64_HAS_VIRT_HOST_EXTN)	\
 					 : : "rZ" (__val));		\
 	} while (0)
diff --git a/arch/arm64/include/asm/kvm_mmu.h b/arch/arm64/include/asm/kvm_mmu.h
index 547519a..4287acb 100644
--- a/arch/arm64/include/asm/kvm_mmu.h
+++ b/arch/arm64/include/asm/kvm_mmu.h
@@ -47,7 +47,7 @@
  * If the page is in the bottom half, we have to use the top half. If
  * the page is in the top half, we have to use the bottom half:
  *
- * T = __virt_to_phys(__hyp_idmap_text_start)
+ * T = __pa_symbol(__hyp_idmap_text_start)
  * if (T & BIT(VA_BITS - 1))
  *	HYP_VA_MIN = 0  //idmap in upper half
  * else
@@ -290,7 +290,7 @@ static inline void __kvm_flush_dcache_pud(pud_t pud)
 	kvm_flush_dcache_to_poc(page_address(page), PUD_SIZE);
 }
 
-#define kvm_virt_to_phys(x)		__virt_to_phys((unsigned long)(x))
+#define kvm_virt_to_phys(x)		__pa_symbol(x)
 
 void kvm_set_way_flush(struct kvm_vcpu *vcpu);
 void kvm_toggle_cache(struct kvm_vcpu *vcpu, bool was_enabled);
diff --git a/arch/arm64/include/asm/memory.h b/arch/arm64/include/asm/memory.h
index ba917be..3450209 100644
--- a/arch/arm64/include/asm/memory.h
+++ b/arch/arm64/include/asm/memory.h
@@ -152,6 +152,11 @@
 /* the offset between the kernel virtual and physical mappings */
 extern u64			kimage_voffset;
 
+static inline unsigned long kaslr_offset(void)
+{
+	return kimage_vaddr - KIMAGE_VADDR;
+}
+
 /*
  * Allow all memory at the discovery stage. We will clip it later.
  */
@@ -192,6 +197,7 @@ static inline void *phys_to_virt(phys_addr_t x)
 #define __va(x)			((void *)__phys_to_virt((phys_addr_t)(x)))
 #define pfn_to_kaddr(pfn)	__va((pfn) << PAGE_SHIFT)
 #define virt_to_pfn(x)      __phys_to_pfn(__virt_to_phys(x))
+#define sym_to_pfn(x)	    __phys_to_pfn(__pa_symbol(x))
 
 /*
  *  virt_to_page(k)	convert a _valid_ virtual address to struct page *
diff --git a/arch/arm64/include/asm/mmu.h b/arch/arm64/include/asm/mmu.h
index 6ac34c7..5ea3135 100644
--- a/arch/arm64/include/asm/mmu.h
+++ b/arch/arm64/include/asm/mmu.h
@@ -16,7 +16,9 @@
 #ifndef __ASM_MMU_H
 #define __ASM_MMU_H
 
+
 #define USER_ASID_FLAG	(UL(1) << 48)
+#define TTBR_ASID_MASK	(UL(0xffff) << 48)
 
 #ifndef __ASSEMBLY__
 
@@ -79,6 +81,11 @@ static inline void arm64_apply_bp_hardening(void)	{ }
 
 extern void paging_init(void);
 extern void bootmem_init(void);
+
+#ifdef CONFIG_RTK_PLATFORM
+extern void setup_mm_for_reboot(void);
+#endif
+
 extern void __iomem *early_io_map(phys_addr_t phys, unsigned long virt);
 extern void init_mem_pgprot(void);
 extern void create_pgd_mapping(struct mm_struct *mm, phys_addr_t phys,
diff --git a/arch/arm64/include/asm/mmu_context.h b/arch/arm64/include/asm/mmu_context.h
index b96c4799..c0ae91c 100644
--- a/arch/arm64/include/asm/mmu_context.h
+++ b/arch/arm64/include/asm/mmu_context.h
@@ -23,6 +23,7 @@
 #include <linux/sched.h>
 
 #include <asm/cacheflush.h>
+#include <asm/cpufeature.h>
 #include <asm/proc-fns.h>
 #include <asm-generic/mm_hooks.h>
 #include <asm/cputype.h>
@@ -44,7 +45,7 @@ static inline void contextidr_thread_switch(struct task_struct *next)
  */
 static inline void cpu_set_reserved_ttbr0(void)
 {
-	unsigned long ttbr = virt_to_phys(empty_zero_page);
+	unsigned long ttbr = __pa_symbol(empty_zero_page);
 
 	write_sysreg(ttbr, ttbr0_el1);
 	isb();
@@ -110,7 +111,7 @@ static inline void cpu_uninstall_idmap(void)
 	local_flush_tlb_all();
 	cpu_set_default_tcr_t0sz();
 
-	if (mm != &init_mm)
+	if (mm != &init_mm && !system_uses_ttbr0_pan())
 		cpu_switch_mm(mm->pgd, mm);
 }
 
@@ -120,14 +121,14 @@ static inline void cpu_install_idmap(void)
 	local_flush_tlb_all();
 	cpu_set_idmap_tcr_t0sz();
 
-	cpu_switch_mm(idmap_pg_dir, &init_mm);
+	cpu_switch_mm(lm_alias(idmap_pg_dir), &init_mm);
 }
 
 /*
  * Atomically replaces the active TTBR1_EL1 PGD with a new VA-compatible PGD,
  * avoiding the possibility of conflicting TLB entries being allocated.
  */
-static inline void cpu_replace_ttbr1(pgd_t *pgd)
+static inline void __nocfi cpu_replace_ttbr1(pgd_t *pgd)
 {
 	typedef void (ttbr_replace_func)(phys_addr_t);
 	extern ttbr_replace_func idmap_cpu_replace_ttbr1;
@@ -135,7 +136,7 @@ static inline void cpu_replace_ttbr1(pgd_t *pgd)
 
 	phys_addr_t pgd_phys = virt_to_phys(pgd);
 
-	replace_phys = (void *)virt_to_phys(idmap_cpu_replace_ttbr1);
+	replace_phys = (void *)__pa_symbol(idmap_cpu_replace_ttbr1);
 
 	cpu_install_idmap();
 	replace_phys(pgd_phys);
@@ -170,20 +171,27 @@ static inline void cpu_replace_ttbr1(pgd_t *pgd)
 {
 }
 
-/*
- * This is the actual mm switch as far as the scheduler
- * is concerned.  No registers are touched.  We avoid
- * calling the CPU specific function when the mm hasn't
- * actually changed.
- */
-static inline void
-switch_mm(struct mm_struct *prev, struct mm_struct *next,
-	  struct task_struct *tsk)
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+static inline void update_saved_ttbr0(struct task_struct *tsk,
+				      struct mm_struct *mm)
 {
-	unsigned int cpu = smp_processor_id();
+	if (system_uses_ttbr0_pan()) {
+		u64 ttbr;
+		BUG_ON(mm->pgd == swapper_pg_dir);
+		ttbr = virt_to_phys(mm->pgd) | ASID(mm) << 48;
+		WRITE_ONCE(task_thread_info(tsk)->ttbr0, ttbr);
+	}
+}
+#else
+static inline void update_saved_ttbr0(struct task_struct *tsk,
+				      struct mm_struct *mm)
+{
+}
+#endif
 
-	if (prev == next)
-		return;
+static inline void __switch_mm(struct mm_struct *next)
+{
+	unsigned int cpu = smp_processor_id();
 
 	/*
 	 * init_mm.pgd does not contain any user mappings and it is always
@@ -197,9 +205,28 @@ static inline void cpu_replace_ttbr1(pgd_t *pgd)
 	check_and_switch_context(next, cpu);
 }
 
+static inline void
+switch_mm(struct mm_struct *prev, struct mm_struct *next,
+	  struct task_struct *tsk)
+{
+	if (prev != next)
+		__switch_mm(next);
+
+	/*
+	 * Update the saved TTBR0_EL1 of the scheduled-in task as the previous
+	 * value may have not been initialised yet (activate_mm caller) or the
+	 * ASID has changed since the last run (following the context switch
+	 * of another thread of the same process). Avoid setting the reserved
+	 * TTBR0_EL1 to swapper_pg_dir (init_mm; e.g. via idle_task_exit).
+	 */
+	if (next != &init_mm)
+		update_saved_ttbr0(tsk, next);
+}
+
 #define deactivate_mm(tsk,mm)	do { } while (0)
-#define activate_mm(prev,next)	switch_mm(prev, next, NULL)
+#define activate_mm(prev,next)	switch_mm(prev, next, current)
 
 void verify_cpu_asid_bits(void);
+void post_ttbr_update_workaround(void);
 
 #endif
diff --git a/arch/arm64/include/asm/percpu.h b/arch/arm64/include/asm/percpu.h
index 0d55157..a2f6bd2 100644
--- a/arch/arm64/include/asm/percpu.h
+++ b/arch/arm64/include/asm/percpu.h
@@ -16,6 +16,7 @@
 #ifndef __ASM_PERCPU_H
 #define __ASM_PERCPU_H
 
+#include <asm/stack_pointer.h>
 #include <asm/alternative.h>
 
 static inline void set_my_cpu_offset(unsigned long off)
diff --git a/arch/arm64/include/asm/perf_event.h b/arch/arm64/include/asm/perf_event.h
index 38b6a2b..91b6be0 100644
--- a/arch/arm64/include/asm/perf_event.h
+++ b/arch/arm64/include/asm/perf_event.h
@@ -17,60 +17,7 @@
 #ifndef __ASM_PERF_EVENT_H
 #define __ASM_PERF_EVENT_H
 
-#define	ARMV8_PMU_MAX_COUNTERS	32
-#define	ARMV8_PMU_COUNTER_MASK	(ARMV8_PMU_MAX_COUNTERS - 1)
-
-/*
- * Per-CPU PMCR: config reg
- */
-#define ARMV8_PMU_PMCR_E	(1 << 0) /* Enable all counters */
-#define ARMV8_PMU_PMCR_P	(1 << 1) /* Reset all counters */
-#define ARMV8_PMU_PMCR_C	(1 << 2) /* Cycle counter reset */
-#define ARMV8_PMU_PMCR_D	(1 << 3) /* CCNT counts every 64th cpu cycle */
-#define ARMV8_PMU_PMCR_X	(1 << 4) /* Export to ETM */
-#define ARMV8_PMU_PMCR_DP	(1 << 5) /* Disable CCNT if non-invasive debug*/
-#define ARMV8_PMU_PMCR_LC	(1 << 6) /* Overflow on 64 bit cycle counter */
-#define	ARMV8_PMU_PMCR_N_SHIFT	11	 /* Number of counters supported */
-#define	ARMV8_PMU_PMCR_N_MASK	0x1f
-#define	ARMV8_PMU_PMCR_MASK	0x7f	 /* Mask for writable bits */
-
-/*
- * PMOVSR: counters overflow flag status reg
- */
-#define	ARMV8_PMU_OVSR_MASK		0xffffffff	/* Mask for writable bits */
-#define	ARMV8_PMU_OVERFLOWED_MASK	ARMV8_PMU_OVSR_MASK
-
-/*
- * PMXEVTYPER: Event selection reg
- */
-#define	ARMV8_PMU_EVTYPE_MASK	0xc800ffff	/* Mask for writable bits */
-#define	ARMV8_PMU_EVTYPE_EVENT	0xffff		/* Mask for EVENT bits */
-
-/*
- * PMUv3 event types: required events
- */
-#define ARMV8_PMUV3_PERFCTR_SW_INCR				0x00
-#define ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL			0x03
-#define ARMV8_PMUV3_PERFCTR_L1D_CACHE				0x04
-#define ARMV8_PMUV3_PERFCTR_BR_MIS_PRED				0x10
-#define ARMV8_PMUV3_PERFCTR_CPU_CYCLES				0x11
-#define ARMV8_PMUV3_PERFCTR_BR_PRED				0x12
-
-/*
- * Event filters for PMUv3
- */
-#define	ARMV8_PMU_EXCLUDE_EL1	(1 << 31)
-#define	ARMV8_PMU_EXCLUDE_EL0	(1 << 30)
-#define	ARMV8_PMU_INCLUDE_EL2	(1 << 27)
-
-/*
- * PMUSERENR: user enable reg
- */
-#define ARMV8_PMU_USERENR_MASK	0xf		/* Mask for writable bits */
-#define ARMV8_PMU_USERENR_EN	(1 << 0) /* PMU regs can be accessed at EL0 */
-#define ARMV8_PMU_USERENR_SW	(1 << 1) /* PMSWINC can be written at EL0 */
-#define ARMV8_PMU_USERENR_CR	(1 << 2) /* Cycle counter can be read at EL0 */
-#define ARMV8_PMU_USERENR_ER	(1 << 3) /* Event counter can be read at EL0 */
+#include <asm/stack_pointer.h>
 
 #ifdef CONFIG_PERF_EVENTS
 struct pt_regs;
diff --git a/arch/arm64/include/asm/pgtable.h b/arch/arm64/include/asm/pgtable.h
index 3a30a39..7bcd8b9 100644
--- a/arch/arm64/include/asm/pgtable.h
+++ b/arch/arm64/include/asm/pgtable.h
@@ -52,7 +52,7 @@
  * for zero-mapped memory areas etc..
  */
 extern unsigned long empty_zero_page[PAGE_SIZE / sizeof(unsigned long)];
-#define ZERO_PAGE(vaddr)	pfn_to_page(PHYS_PFN(__pa(empty_zero_page)))
+#define ZERO_PAGE(vaddr)	phys_to_page(__pa_symbol(empty_zero_page))
 
 #define pte_ERROR(pte)		__pte_error(__FILE__, __LINE__, pte_val(pte))
 
diff --git a/arch/arm64/include/asm/signal32.h b/arch/arm64/include/asm/signal32.h
index eeaa975..81abea0 100644
--- a/arch/arm64/include/asm/signal32.h
+++ b/arch/arm64/include/asm/signal32.h
@@ -22,8 +22,6 @@
 
 #define AARCH32_KERN_SIGRET_CODE_OFFSET	0x500
 
-extern const compat_ulong_t aarch32_sigret_code[6];
-
 int compat_setup_frame(int usig, struct ksignal *ksig, sigset_t *set,
 		       struct pt_regs *regs);
 int compat_setup_rt_frame(int usig, struct ksignal *ksig, sigset_t *set,
diff --git a/arch/arm64/include/asm/smp.h b/arch/arm64/include/asm/smp.h
index 0226447..d050d72 100644
--- a/arch/arm64/include/asm/smp.h
+++ b/arch/arm64/include/asm/smp.h
@@ -29,11 +29,22 @@
 
 #ifndef __ASSEMBLY__
 
+#include <asm/percpu.h>
+
 #include <linux/threads.h>
 #include <linux/cpumask.h>
 #include <linux/thread_info.h>
 
-#define raw_smp_processor_id() (current_thread_info()->cpu)
+DECLARE_PER_CPU_READ_MOSTLY(int, cpu_number);
+
+/*
+ * We don't use this_cpu_read(cpu_number) as that has implicit writes to
+ * preempt_count, and associated (compiler) barriers, that we'd like to avoid
+ * the expense of. If we're preemptible, the value can be stale at use anyway.
+ * And we can't use this_cpu_ptr() either, as that winds up recursing back
+ * here under CONFIG_DEBUG_PREEMPT=y.
+ */
+#define raw_smp_processor_id() (*raw_cpu_ptr(&cpu_number))
 
 struct seq_file;
 
@@ -73,6 +84,7 @@
  */
 struct secondary_data {
 	void *stack;
+	struct task_struct *task;
 	long status;
 };
 
diff --git a/arch/arm64/include/asm/stack_pointer.h b/arch/arm64/include/asm/stack_pointer.h
new file mode 100644
index 00000000..ffcdf74
--- /dev/null
+++ b/arch/arm64/include/asm/stack_pointer.h
@@ -0,0 +1,9 @@
+#ifndef __ASM_STACK_POINTER_H
+#define __ASM_STACK_POINTER_H
+
+/*
+ * how to get the current stack pointer from C
+ */
+register unsigned long current_stack_pointer asm ("sp");
+
+#endif /* __ASM_STACK_POINTER_H */
diff --git a/arch/arm64/include/asm/suspend.h b/arch/arm64/include/asm/suspend.h
index b8a313f..de5600f 100644
--- a/arch/arm64/include/asm/suspend.h
+++ b/arch/arm64/include/asm/suspend.h
@@ -1,7 +1,7 @@
 #ifndef __ASM_SUSPEND_H
 #define __ASM_SUSPEND_H
 
-#define NR_CTX_REGS 10
+#define NR_CTX_REGS 12
 #define NR_CALLEE_SAVED_REGS 12
 
 /*
diff --git a/arch/arm64/include/asm/sysreg.h b/arch/arm64/include/asm/sysreg.h
index 88bbe36..8546afc 100644
--- a/arch/arm64/include/asm/sysreg.h
+++ b/arch/arm64/include/asm/sysreg.h
@@ -246,20 +246,39 @@
 
 #include <linux/types.h>
 
-asm(
-"	.irp	num,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30\n"
-"	.equ	.L__reg_num_x\\num, \\num\n"
-"	.endr\n"
+#define __DEFINE_MRS_MSR_S_REGNUM				\
+"	.irp	num,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30\n" \
+"	.equ	.L__reg_num_x\\num, \\num\n"			\
+"	.endr\n"						\
 "	.equ	.L__reg_num_xzr, 31\n"
-"\n"
-"	.macro	mrs_s, rt, sreg\n"
-"	.inst	0xd5200000|(\\sreg)|(.L__reg_num_\\rt)\n"
+
+#define DEFINE_MRS_S						\
+	__DEFINE_MRS_MSR_S_REGNUM				\
+"	.macro	mrs_s, rt, sreg\n"				\
+"	.inst 0xd5200000|(\\sreg)|(.L__reg_num_\\rt)\n"	\
 "	.endm\n"
-"\n"
-"	.macro	msr_s, sreg, rt\n"
-"	.inst	0xd5000000|(\\sreg)|(.L__reg_num_\\rt)\n"
+
+#define DEFINE_MSR_S						\
+	__DEFINE_MRS_MSR_S_REGNUM				\
+"	.macro	msr_s, sreg, rt\n"				\
+"	.inst 0xd5000000|(\\sreg)|(.L__reg_num_\\rt)\n"		\
 "	.endm\n"
-);
+
+#define UNDEFINE_MRS_S						\
+"	.purgem	mrs_s\n"
+
+#define UNDEFINE_MSR_S						\
+"	.purgem	msr_s\n"
+
+#define __mrs_s(r, v)						\
+	DEFINE_MRS_S						\
+"	mrs_s %0, " __stringify(r) "\n"				\
+	UNDEFINE_MRS_S : "=r" (v)
+
+#define __msr_s(r, v)						\
+	DEFINE_MSR_S						\
+"	msr_s " __stringify(r) ", %x0\n"			\
+	UNDEFINE_MSR_S : : "rZ" (v)
 
 /*
  * Unlike read_cpuid, calls to read_sysreg are never expected to be
@@ -285,15 +304,15 @@
  * For registers without architectural names, or simply unsupported by
  * GAS.
  */
-#define read_sysreg_s(r) ({						\
-	u64 __val;							\
-	asm volatile("mrs_s %0, " __stringify(r) : "=r" (__val));	\
-	__val;								\
+#define read_sysreg_s(r) ({					\
+	u64 __val;						\
+	asm volatile(__mrs_s(r, __val));			\
+	__val;							\
 })
 
-#define write_sysreg_s(v, r) do {					\
-	u64 __val = (u64)v;						\
-	asm volatile("msr_s " __stringify(r) ", %x0" : : "rZ" (__val));	\
+#define write_sysreg_s(v, r) do {				\
+	u64 __val = (u64)(v);					\
+	asm volatile(__msr_s(r, __val));			\
 } while (0)
 
 static inline void config_sctlr_el1(u32 clear, u32 set)
diff --git a/arch/arm64/include/asm/thread_info.h b/arch/arm64/include/asm/thread_info.h
index 0dd1bc1..a309f9f 100644
--- a/arch/arm64/include/asm/thread_info.h
+++ b/arch/arm64/include/asm/thread_info.h
@@ -36,58 +36,31 @@
 
 struct task_struct;
 
+#include <asm/stack_pointer.h>
 #include <asm/types.h>
 
 typedef unsigned long mm_segment_t;
 
 /*
  * low level task data that entry.S needs immediate access to.
- * __switch_to() assumes cpu_context follows immediately after cpu_domain.
  */
 struct thread_info {
 	unsigned long		flags;		/* low level flags */
 	mm_segment_t		addr_limit;	/* address limit */
-	struct task_struct	*task;		/* main task structure */
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+	u64			ttbr0;		/* saved TTBR0_EL1 */
+#endif
 	int			preempt_count;	/* 0 => preemptable, <0 => bug */
-	int			cpu;		/* cpu */
 };
 
 #define INIT_THREAD_INFO(tsk)						\
 {									\
-	.task		= &tsk,						\
-	.flags		= 0,						\
 	.preempt_count	= INIT_PREEMPT_COUNT,				\
 	.addr_limit	= KERNEL_DS,					\
 }
 
-#define init_thread_info	(init_thread_union.thread_info)
 #define init_stack		(init_thread_union.stack)
 
-/*
- * how to get the current stack pointer from C
- */
-register unsigned long current_stack_pointer asm ("sp");
-
-/*
- * how to get the thread information struct from C
- */
-static inline struct thread_info *current_thread_info(void) __attribute_const__;
-
-/*
- * struct thread_info can be accessed directly via sp_el0.
- *
- * We don't use read_sysreg() as we want the compiler to cache the value where
- * possible.
- */
-static inline struct thread_info *current_thread_info(void)
-{
-	unsigned long sp_el0;
-
-	asm ("mrs %0, sp_el0" : "=r" (sp_el0));
-
-	return (struct thread_info *)sp_el0;
-}
-
 #define thread_saved_pc(tsk)	\
 	((unsigned long)(tsk->thread.cpu_context.pc))
 #define thread_saved_sp(tsk)	\
diff --git a/arch/arm64/include/asm/topology.h b/arch/arm64/include/asm/topology.h
index 8b57339..a4f86ded 100644
--- a/arch/arm64/include/asm/topology.h
+++ b/arch/arm64/include/asm/topology.h
@@ -31,6 +31,17 @@ struct cpu_topology {
 				 cpumask_of_node(pcibus_to_node(bus)))
 
 #endif /* CONFIG_NUMA */
+struct sched_domain;
+#ifdef CONFIG_CPU_FREQ
+#define arch_scale_freq_capacity cpufreq_scale_freq_capacity
+extern unsigned long cpufreq_scale_freq_capacity(struct sched_domain *sd, int cpu);
+#define arch_scale_max_freq_capacity cpufreq_scale_max_freq_capacity
+extern unsigned long cpufreq_scale_max_freq_capacity(struct sched_domain *sd, int cpu);
+#define arch_scale_min_freq_capacity cpufreq_scale_min_freq_capacity
+extern unsigned long cpufreq_scale_min_freq_capacity(struct sched_domain *sd, int cpu);
+#endif
+#define arch_scale_cpu_capacity scale_cpu_capacity
+extern unsigned long scale_cpu_capacity(struct sched_domain *sd, int cpu);
 
 #include <asm-generic/topology.h>
 
diff --git a/arch/arm64/include/asm/traps.h b/arch/arm64/include/asm/traps.h
index 02e9035..47a9066 100644
--- a/arch/arm64/include/asm/traps.h
+++ b/arch/arm64/include/asm/traps.h
@@ -37,18 +37,11 @@ struct undef_hook {
 
 void arm64_notify_segfault(struct pt_regs *regs, unsigned long addr);
 
-#ifdef CONFIG_FUNCTION_GRAPH_TRACER
 static inline int __in_irqentry_text(unsigned long ptr)
 {
 	return ptr >= (unsigned long)&__irqentry_text_start &&
 	       ptr < (unsigned long)&__irqentry_text_end;
 }
-#else
-static inline int __in_irqentry_text(unsigned long ptr)
-{
-	return 0;
-}
-#endif
 
 static inline int in_exception_text(unsigned long ptr)
 {
diff --git a/arch/arm64/include/asm/uaccess.h b/arch/arm64/include/asm/uaccess.h
index 1d047d6..ed846af 100644
--- a/arch/arm64/include/asm/uaccess.h
+++ b/arch/arm64/include/asm/uaccess.h
@@ -18,6 +18,13 @@
 #ifndef __ASM_UACCESS_H
 #define __ASM_UACCESS_H
 
+#include <asm/alternative.h>
+#include <asm/kernel-pgtable.h>
+#include <asm/mmu.h>
+#include <asm/sysreg.h>
+
+#ifndef __ASSEMBLY__
+
 /*
  * User space memory access functions
  */
@@ -26,11 +33,9 @@
 #include <linux/string.h>
 #include <linux/thread_info.h>
 
-#include <asm/alternative.h>
 #include <asm/cpufeature.h>
 #include <asm/processor.h>
 #include <asm/ptrace.h>
-#include <asm/sysreg.h>
 #include <asm/errno.h>
 #include <asm/memory.h>
 #include <asm/compiler.h>
@@ -136,6 +141,115 @@ static inline unsigned long __range_ok(unsigned long addr, unsigned long size)
 	"	.popsection\n"
 
 /*
+ * User access enabling/disabling.
+ */
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+static inline void __uaccess_ttbr0_disable(void)
+{
+	unsigned long flags, ttbr;
+
+	local_irq_save(flags);
+	ttbr = read_sysreg(ttbr1_el1);
+	ttbr &= ~TTBR_ASID_MASK;
+	/* reserved_ttbr0 placed at the end of swapper_pg_dir */
+	write_sysreg(ttbr + SWAPPER_DIR_SIZE, ttbr0_el1);
+	isb();
+	/* Set reserved ASID */
+	write_sysreg(ttbr, ttbr1_el1);
+	isb();
+	local_irq_restore(flags);
+}
+
+static inline void __uaccess_ttbr0_enable(void)
+{
+	unsigned long flags, ttbr0, ttbr1;
+
+	/*
+	 * Disable interrupts to avoid preemption between reading the 'ttbr0'
+	 * variable and the MSR. A context switch could trigger an ASID
+	 * roll-over and an update of 'ttbr0'.
+	 */
+	local_irq_save(flags);
+	ttbr0 = READ_ONCE(current_thread_info()->ttbr0);
+
+	/* Restore active ASID */
+	ttbr1 = read_sysreg(ttbr1_el1);
+	ttbr1 &= ~TTBR_ASID_MASK;		/* safety measure */
+	ttbr1 |= ttbr0 & TTBR_ASID_MASK;
+	write_sysreg(ttbr1, ttbr1_el1);
+	isb();
+
+	/* Restore user page table */
+	write_sysreg(ttbr0, ttbr0_el1);
+	isb();
+	local_irq_restore(flags);
+}
+
+static inline bool uaccess_ttbr0_disable(void)
+{
+	if (!system_uses_ttbr0_pan())
+		return false;
+	__uaccess_ttbr0_disable();
+	return true;
+}
+
+static inline bool uaccess_ttbr0_enable(void)
+{
+	if (!system_uses_ttbr0_pan())
+		return false;
+	__uaccess_ttbr0_enable();
+	return true;
+}
+#else
+static inline bool uaccess_ttbr0_disable(void)
+{
+	return false;
+}
+
+static inline bool uaccess_ttbr0_enable(void)
+{
+	return false;
+}
+#endif
+
+#define __uaccess_disable(alt)						\
+do {									\
+	if (!uaccess_ttbr0_disable())					\
+		asm(ALTERNATIVE("nop", SET_PSTATE_PAN(1), alt,		\
+				CONFIG_ARM64_PAN));			\
+} while (0)
+
+#define __uaccess_enable(alt)						\
+do {									\
+	if (!uaccess_ttbr0_enable())					\
+		asm(ALTERNATIVE("nop", SET_PSTATE_PAN(0), alt,		\
+				CONFIG_ARM64_PAN));			\
+} while (0)
+
+static inline void uaccess_disable(void)
+{
+	__uaccess_disable(ARM64_HAS_PAN);
+}
+
+static inline void uaccess_enable(void)
+{
+	__uaccess_enable(ARM64_HAS_PAN);
+}
+
+/*
+ * These functions are no-ops when UAO is present.
+ */
+static inline void uaccess_disable_not_uao(void)
+{
+	__uaccess_disable(ARM64_ALT_PAN_NOT_UAO);
+}
+
+static inline void uaccess_enable_not_uao(void)
+{
+	__uaccess_enable(ARM64_ALT_PAN_NOT_UAO);
+}
+
+/*
  * Sanitise a uaccess pointer such that it becomes NULL if above the
  * current addr_limit.
  */
@@ -182,8 +296,7 @@ static inline void __user *__uaccess_mask_ptr(const void __user *ptr)
 do {									\
 	unsigned long __gu_val;						\
 	__chk_user_ptr(ptr);						\
-	asm(ALTERNATIVE("nop", SET_PSTATE_PAN(0), ARM64_ALT_PAN_NOT_UAO,\
-			CONFIG_ARM64_PAN));				\
+	uaccess_enable_not_uao();					\
 	switch (sizeof(*(ptr))) {					\
 	case 1:								\
 		__get_user_asm("ldrb", "ldtrb", "%w", __gu_val, (ptr),  \
@@ -198,15 +311,14 @@ static inline void __user *__uaccess_mask_ptr(const void __user *ptr)
 			       (err), ARM64_HAS_UAO);			\
 		break;							\
 	case 8:								\
-		__get_user_asm("ldr", "ldtr", "%",  __gu_val, (ptr),	\
+		__get_user_asm("ldr", "ldtr", "%x",  __gu_val, (ptr),	\
 			       (err), ARM64_HAS_UAO);			\
 		break;							\
 	default:							\
 		BUILD_BUG();						\
 	}								\
+	uaccess_disable_not_uao();					\
 	(x) = (__force __typeof__(*(ptr)))__gu_val;			\
-	asm(ALTERNATIVE("nop", SET_PSTATE_PAN(1), ARM64_ALT_PAN_NOT_UAO,\
-			CONFIG_ARM64_PAN));				\
 } while (0)
 
 #define __get_user_check(x, ptr, err)					\
@@ -256,8 +368,7 @@ static inline void __user *__uaccess_mask_ptr(const void __user *ptr)
 do {									\
 	__typeof__(*(ptr)) __pu_val = (x);				\
 	__chk_user_ptr(ptr);						\
-	asm(ALTERNATIVE("nop", SET_PSTATE_PAN(0), ARM64_ALT_PAN_NOT_UAO,\
-			CONFIG_ARM64_PAN));				\
+	uaccess_enable_not_uao();					\
 	switch (sizeof(*(ptr))) {					\
 	case 1:								\
 		__put_user_asm("strb", "sttrb", "%w", __pu_val, (ptr),	\
@@ -272,14 +383,13 @@ static inline void __user *__uaccess_mask_ptr(const void __user *ptr)
 			       (err), ARM64_HAS_UAO);			\
 		break;							\
 	case 8:								\
-		__put_user_asm("str", "sttr", "%", __pu_val, (ptr),	\
+		__put_user_asm("str", "sttr", "%x", __pu_val, (ptr),	\
 			       (err), ARM64_HAS_UAO);			\
 		break;							\
 	default:							\
 		BUILD_BUG();						\
 	}								\
-	asm(ALTERNATIVE("nop", SET_PSTATE_PAN(1), ARM64_ALT_PAN_NOT_UAO,\
-			CONFIG_ARM64_PAN));				\
+	uaccess_disable_not_uao();					\
 } while (0)
 
 #define __put_user_check(x, ptr, err)					\
@@ -379,4 +489,77 @@ static inline unsigned long __must_check __clear_user(void __user *to, unsigned
 extern __must_check long strlen_user(const char __user *str);
 extern __must_check long strnlen_user(const char __user *str, long n);
 
+#else	/* __ASSEMBLY__ */
+
+#include <asm/assembler.h>
+
+/*
+ * User access enabling/disabling macros.
+ */
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+	.macro	__uaccess_ttbr0_disable, tmp1
+	mrs	\tmp1, ttbr1_el1		// swapper_pg_dir
+	bic     \tmp1, \tmp1, #TTBR_ASID_MASK
+	add	\tmp1, \tmp1, #SWAPPER_DIR_SIZE	// reserved_ttbr0 at the end of swapper_pg_dir
+	msr	ttbr0_el1, \tmp1		// set reserved TTBR0_EL1
+	isb
+	sub     \tmp1, \tmp1, #SWAPPER_DIR_SIZE
+	msr     ttbr1_el1, \tmp1                // set reserved ASID
+	isb
+	.endm
+
+	.macro	__uaccess_ttbr0_enable, tmp1, tmp2
+	get_thread_info \tmp1
+	ldr	\tmp1, [\tmp1, #TSK_TI_TTBR0]	// load saved TTBR0_EL1
+	mrs     \tmp2, ttbr1_el1
+	extr    \tmp2, \tmp2, \tmp1, #48
+	ror     \tmp2, \tmp2, #16
+	msr     ttbr1_el1, \tmp2                // set the active ASID
+	isb
+	msr	ttbr0_el1, \tmp1		// set the non-PAN TTBR0_EL1
+	isb
+	.endm
+
+	.macro	uaccess_ttbr0_disable, tmp1, tmp2
+alternative_if_not ARM64_HAS_PAN
+	save_and_disable_irq \tmp2		// avoid preemption
+	__uaccess_ttbr0_disable \tmp1
+	restore_irq \tmp2
+alternative_else_nop_endif
+	.endm
+
+	.macro	uaccess_ttbr0_enable, tmp1, tmp2, tmp3
+alternative_if_not ARM64_HAS_PAN
+	save_and_disable_irq \tmp3		// avoid preemption
+	__uaccess_ttbr0_enable \tmp1, \tmp2
+	restore_irq \tmp3
+alternative_else_nop_endif
+	.endm
+#else
+	.macro	uaccess_ttbr0_disable, tmp1, tmp2
+	.endm
+
+	.macro	uaccess_ttbr0_enable, tmp1, tmp2, tmp3
+	.endm
+#endif
+
+/*
+ * These macros are no-ops when UAO is present.
+ */
+	.macro	uaccess_disable_not_uao, tmp1, tmp2
+	uaccess_ttbr0_disable \tmp1, \tmp2
+alternative_if ARM64_ALT_PAN_NOT_UAO
+	SET_PSTATE_PAN(1)
+alternative_else_nop_endif
+	.endm
+
+	.macro	uaccess_enable_not_uao, tmp1, tmp2, tmp3
+	uaccess_ttbr0_enable \tmp1, \tmp2, \tmp3
+alternative_if ARM64_ALT_PAN_NOT_UAO
+	SET_PSTATE_PAN(0)
+alternative_else_nop_endif
+	.endm
+
+#endif	/* __ASSEMBLY__ */
+
 #endif /* __ASM_UACCESS_H */
diff --git a/arch/arm64/kernel/Makefile b/arch/arm64/kernel/Makefile
index 6dadaae..89b1bbd 100644
--- a/arch/arm64/kernel/Makefile
+++ b/arch/arm64/kernel/Makefile
@@ -19,7 +19,7 @@ arm64-obj-y		:= debug-monitors.o entry.o irq.o fpsimd.o		\
 			   hyp-stub.o psci.o cpu_ops.o insn.o	\
 			   return_address.o cpuinfo.o cpu_errata.o		\
 			   cpufeature.o alternative.o cacheinfo.o		\
-			   smp.o smp_spin_table.o topology.o smccc-call.o
+			   smp.o smp_spin_table.o topology.o smccc-call.o	\
 
 extra-$(CONFIG_EFI)			:= efi-entry.o
 
@@ -33,7 +33,6 @@ arm64-obj-$(CONFIG_FUNCTION_TRACER)	+= ftrace.o entry-ftrace.o
 arm64-obj-$(CONFIG_MODULES)		+= arm64ksyms.o module.o
 arm64-obj-$(CONFIG_ARM64_MODULE_PLTS)	+= module-plts.o
 arm64-obj-$(CONFIG_PERF_EVENTS)		+= perf_regs.o perf_callchain.o
-arm64-obj-$(CONFIG_HW_PERF_EVENTS)	+= perf_event.o
 arm64-obj-$(CONFIG_HAVE_HW_BREAKPOINT)	+= hw_breakpoint.o
 arm64-obj-$(CONFIG_CPU_PM)		+= sleep.o suspend.o
 arm64-obj-$(CONFIG_CPU_IDLE)		+= cpuidle.o
diff --git a/arch/arm64/kernel/acpi_parking_protocol.c b/arch/arm64/kernel/acpi_parking_protocol.c
index a32b401..1f5655c 100644
--- a/arch/arm64/kernel/acpi_parking_protocol.c
+++ b/arch/arm64/kernel/acpi_parking_protocol.c
@@ -17,6 +17,7 @@
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #include <linux/acpi.h>
+#include <linux/mm.h>
 #include <linux/types.h>
 
 #include <asm/cpu_ops.h>
@@ -109,7 +110,7 @@ static int acpi_parking_protocol_cpu_boot(unsigned int cpu)
 	 * that read this address need to convert this address to the
 	 * Boot-Loader's endianness before jumping.
 	 */
-	writeq_relaxed(__pa(secondary_entry), &mailbox->entry_point);
+	writeq_relaxed(__pa_symbol(secondary_entry), &mailbox->entry_point);
 	writel_relaxed(cpu_entry->gic_cpu_id, &mailbox->cpu_id);
 
 	arch_send_wakeup_ipi_mask(cpumask_of(cpu));
diff --git a/arch/arm64/kernel/armv8_deprecated.c b/arch/arm64/kernel/armv8_deprecated.c
index c0ede23..29d2ad8 100644
--- a/arch/arm64/kernel/armv8_deprecated.c
+++ b/arch/arm64/kernel/armv8_deprecated.c
@@ -14,7 +14,6 @@
 #include <linux/slab.h>
 #include <linux/sysctl.h>
 
-#include <asm/alternative.h>
 #include <asm/cpufeature.h>
 #include <asm/insn.h>
 #include <asm/opcodes.h>
@@ -285,10 +284,10 @@ static void __init register_insn_emulation_sysctl(struct ctl_table *table)
 #define __SWP_LL_SC_LOOPS	4
 
 #define __user_swpX_asm(data, addr, res, temp, temp2, B)	\
+do {								\
+	uaccess_enable();					\
 	__asm__ __volatile__(					\
 	"	mov		%w3, %w7\n"			\
-	ALTERNATIVE("nop", SET_PSTATE_PAN(0), ARM64_HAS_PAN,	\
-		    CONFIG_ARM64_PAN)				\
 	"0:	ldxr"B"		%w2, [%4]\n"			\
 	"1:	stxr"B"		%w0, %w1, [%4]\n"		\
 	"	cbz		%w0, 2f\n"			\
@@ -306,13 +305,13 @@ static void __init register_insn_emulation_sysctl(struct ctl_table *table)
 	"	.popsection"					\
 	_ASM_EXTABLE(0b, 4b)					\
 	_ASM_EXTABLE(1b, 4b)					\
-	ALTERNATIVE("nop", SET_PSTATE_PAN(1), ARM64_HAS_PAN,	\
-		CONFIG_ARM64_PAN)				\
 	: "=&r" (res), "+r" (data), "=&r" (temp), "=&r" (temp2)	\
 	: "r" ((unsigned long)addr), "i" (-EAGAIN),		\
 	  "i" (-EFAULT),					\
 	  "i" (__SWP_LL_SC_LOOPS)				\
-	: "memory")
+	: "memory");						\
+	uaccess_disable();					\
+} while (0)
 
 #define __user_swp_asm(data, addr, res, temp, temp2) \
 	__user_swpX_asm(data, addr, res, temp, temp2, "")
diff --git a/arch/arm64/kernel/asm-offsets.c b/arch/arm64/kernel/asm-offsets.c
index bd239b1..61ae19e 100644
--- a/arch/arm64/kernel/asm-offsets.c
+++ b/arch/arm64/kernel/asm-offsets.c
@@ -37,11 +37,13 @@ int main(void)
 {
   DEFINE(TSK_ACTIVE_MM,		offsetof(struct task_struct, active_mm));
   BLANK();
-  DEFINE(TI_FLAGS,		offsetof(struct thread_info, flags));
-  DEFINE(TI_PREEMPT,		offsetof(struct thread_info, preempt_count));
-  DEFINE(TI_ADDR_LIMIT,		offsetof(struct thread_info, addr_limit));
-  DEFINE(TI_TASK,		offsetof(struct thread_info, task));
-  DEFINE(TI_CPU,		offsetof(struct thread_info, cpu));
+  DEFINE(TSK_TI_FLAGS,		offsetof(struct task_struct, thread_info.flags));
+  DEFINE(TSK_TI_PREEMPT,	offsetof(struct task_struct, thread_info.preempt_count));
+  DEFINE(TSK_TI_ADDR_LIMIT,	offsetof(struct task_struct, thread_info.addr_limit));
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+  DEFINE(TSK_TI_TTBR0,		offsetof(struct task_struct, thread_info.ttbr0));
+#endif
+  DEFINE(TSK_STACK,		offsetof(struct task_struct, stack));
   BLANK();
   DEFINE(THREAD_CPU_CONTEXT,	offsetof(struct task_struct, thread.cpu_context));
   BLANK();
@@ -124,6 +126,7 @@ int main(void)
   DEFINE(TZ_DSTTIME,		offsetof(struct timezone, tz_dsttime));
   BLANK();
   DEFINE(CPU_BOOT_STACK,	offsetof(struct secondary_data, stack));
+  DEFINE(CPU_BOOT_TASK,		offsetof(struct secondary_data, task));
   BLANK();
 #ifdef CONFIG_KVM_ARM_HOST
   DEFINE(VCPU_CONTEXT,		offsetof(struct kvm_vcpu, arch.ctxt));
diff --git a/arch/arm64/kernel/cpu-reset.h b/arch/arm64/kernel/cpu-reset.h
index d4e9ecb..6c2b1b4 100644
--- a/arch/arm64/kernel/cpu-reset.h
+++ b/arch/arm64/kernel/cpu-reset.h
@@ -24,7 +24,7 @@ static inline void __noreturn cpu_soft_restart(unsigned long el2_switch,
 
 	el2_switch = el2_switch && !is_kernel_in_hyp_mode() &&
 		is_hyp_mode_available();
-	restart = (void *)virt_to_phys(__cpu_soft_restart);
+	restart = (void *)__pa_symbol(__cpu_soft_restart);
 
 	cpu_install_idmap();
 	restart(el2_switch, entry, arg0, arg1, arg2);
diff --git a/arch/arm64/kernel/cpu_ops.c b/arch/arm64/kernel/cpu_ops.c
index e137cea..25c2757 100644
--- a/arch/arm64/kernel/cpu_ops.c
+++ b/arch/arm64/kernel/cpu_ops.c
@@ -29,10 +29,17 @@
 extern const struct cpu_operations acpi_parking_protocol_ops;
 extern const struct cpu_operations cpu_psci_ops;
 
+#ifdef CONFIG_RTK_PLATFORM
+extern const struct cpu_operations rtk_smp_spin_table_ops;
+#endif /* CONFIG_RTK_PLATFORM */
+
 const struct cpu_operations *cpu_ops[NR_CPUS] __ro_after_init;
 
 static const struct cpu_operations *dt_supported_cpu_ops[] __initconst = {
 	&smp_spin_table_ops,
+#ifdef CONFIG_RTK_PLATFORM
+	&rtk_smp_spin_table_ops,
+#endif /* CONFIG_RTK_PLATFORM */
 	&cpu_psci_ops,
 	NULL,
 };
diff --git a/arch/arm64/kernel/cpufeature.c b/arch/arm64/kernel/cpufeature.c
index ab15747..eb8839a 100644
--- a/arch/arm64/kernel/cpufeature.c
+++ b/arch/arm64/kernel/cpufeature.c
@@ -23,6 +23,7 @@
 #include <linux/sort.h>
 #include <linux/stop_machine.h>
 #include <linux/types.h>
+#include <linux/mm.h>
 #include <asm/cpu.h>
 #include <asm/cpufeature.h>
 #include <asm/cpu_ops.h>
@@ -739,7 +740,7 @@ static bool runs_at_el2(const struct arm64_cpu_capabilities *entry, int __unused
 static bool hyp_offset_low(const struct arm64_cpu_capabilities *entry,
 			   int __unused)
 {
-	phys_addr_t idmap_addr = virt_to_phys(__hyp_idmap_text_start);
+	phys_addr_t idmap_addr = __pa_symbol(__hyp_idmap_text_start);
 
 	/*
 	 * Activate the lower HYP offset only if:
@@ -791,7 +792,7 @@ static bool unmap_kernel_at_el0(const struct arm64_cpu_capabilities *entry,
 						     ID_AA64PFR0_CSV3_SHIFT);
 }
 
-static int kpti_install_ng_mappings(void *__unused)
+static int __nocfi kpti_install_ng_mappings(void *__unused)
 {
 	typedef void (kpti_remap_fn)(int, int, phys_addr_t);
 	extern kpti_remap_fn idmap_kpti_install_ng_mappings;
diff --git a/arch/arm64/kernel/entry.S b/arch/arm64/kernel/entry.S
index ca978d7..ecebb48c7 100644
--- a/arch/arm64/kernel/entry.S
+++ b/arch/arm64/kernel/entry.S
@@ -32,7 +32,9 @@
 #include <asm/memory.h>
 #include <asm/mmu.h>
 #include <asm/processor.h>
+#include <asm/ptrace.h>
 #include <asm/thread_info.h>
+#include <asm/uaccess.h>
 #include <asm/asm-uaccess.h>
 #include <asm/unistd.h>
 #include <asm/kernel-pgtable.h>
@@ -105,7 +107,7 @@ alternative_cb	arm64_enable_wa2_handling
 alternative_cb_end
 	ldr_this_cpu	\tmp2, arm64_ssbd_callback_required, \tmp1
 	cbz	\tmp2, \targ
-	ldr	\tmp2, [tsk, #TI_FLAGS]
+	ldr	\tmp2, [tsk, #TSK_TI_FLAGS]
 	tbnz	\tmp2, #TIF_SSBD, \targ
 	mov	w0, #ARM_SMCCC_ARCH_WORKAROUND_2
 	mov	w1, #\state
@@ -137,9 +139,8 @@ alternative_cb_end
 
 	.if	\el == 0
 	mrs	x21, sp_el0
-	mov	tsk, sp
-	and	tsk, tsk, #~(THREAD_SIZE - 1)	// Ensure MDSCR_EL1.SS is clear,
-	ldr	x19, [tsk, #TI_FLAGS]		// since we can unmask debug
+	ldr_this_cpu	tsk, __entry_task, x20	// Ensure MDSCR_EL1.SS is clear,
+	ldr	x19, [tsk, #TSK_TI_FLAGS]	// since we can unmask debug
 	disable_step_tsk x19, x20		// exceptions when scheduling.
 
 	apply_ssbd 1, 1f, x22, x23
@@ -155,15 +156,41 @@ alternative_cb_end
 	add	x21, sp, #S_FRAME_SIZE
 	get_thread_info tsk
 	/* Save the task's original addr_limit and set USER_DS */
-	ldr	x20, [tsk, #TI_ADDR_LIMIT]
+	ldr	x20, [tsk, #TSK_TI_ADDR_LIMIT]
 	str	x20, [sp, #S_ORIG_ADDR_LIMIT]
 	mov	x20, #USER_DS
-	str	x20, [tsk, #TI_ADDR_LIMIT]
+	str	x20, [tsk, #TSK_TI_ADDR_LIMIT]
 	/* No need to reset PSTATE.UAO, hardware's already set it to 0 for us */
 	.endif /* \el == 0 */
 	mrs	x22, elr_el1
 	mrs	x23, spsr_el1
 	stp	lr, x21, [sp, #S_LR]
+
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+	/*
+	 * Set the TTBR0 PAN bit in SPSR. When the exception is taken from
+	 * EL0, there is no need to check the state of TTBR0_EL1 since
+	 * accesses are always enabled.
+	 * Note that the meaning of this bit differs from the ARMv8.1 PAN
+	 * feature as all TTBR0_EL1 accesses are disabled, not just those to
+	 * user mappings.
+	 */
+alternative_if ARM64_HAS_PAN
+	b	1f				// skip TTBR0 PAN
+alternative_else_nop_endif
+
+	.if	\el != 0
+	mrs	x21, ttbr0_el1
+	tst	x21, #TTBR_ASID_MASK		// Check for the reserved ASID
+	orr	x23, x23, #PSR_PAN_BIT		// Set the emulated PAN in the saved SPSR
+	b.eq	1f				// TTBR0 access already disabled
+	and	x23, x23, #~PSR_PAN_BIT		// Clear the emulated PAN in the saved SPSR
+	.endif
+
+	__uaccess_ttbr0_disable x21
+1:
+#endif
+
 	stp	x22, x23, [sp, #S_PC]
 
 	/*
@@ -194,7 +221,7 @@ alternative_cb_end
 	.if	\el != 0
 	/* Restore the task's original addr_limit. */
 	ldr	x20, [sp, #S_ORIG_ADDR_LIMIT]
-	str	x20, [tsk, #TI_ADDR_LIMIT]
+	str	x20, [tsk, #TSK_TI_ADDR_LIMIT]
 
 	/* No need to restore UAO, it will be restored from SPSR_EL1 */
 	.endif
@@ -202,6 +229,40 @@ alternative_cb_end
 	ldp	x21, x22, [sp, #S_PC]		// load ELR, SPSR
 	.if	\el == 0
 	ct_user_enter
+	.endif
+
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+	/*
+	 * Restore access to TTBR0_EL1. If returning to EL0, no need for SPSR
+	 * PAN bit checking.
+	 */
+alternative_if ARM64_HAS_PAN
+	b	2f				// skip TTBR0 PAN
+alternative_else_nop_endif
+
+	.if	\el != 0
+	tbnz	x22, #22, 1f			// Skip re-enabling TTBR0 access if the PSR_PAN_BIT is set
+	.endif
+
+	__uaccess_ttbr0_enable x0, x1
+
+	.if	\el == 0
+	/*
+	 * Enable errata workarounds only if returning to user. The only
+	 * workaround currently required for TTBR0_EL1 changes are for the
+	 * Cavium erratum 27456 (broadcast TLBI instructions may cause I-cache
+	 * corruption).
+	 */
+	bl	post_ttbr_update_workaround
+	.endif
+1:
+	.if	\el != 0
+	and	x22, x22, #~PSR_PAN_BIT		// ARMv8.0 CPUs do not understand this bit
+	.endif
+2:
+#endif
+
+	.if	\el == 0
 	ldr	x23, [sp, #S_SP]		// load return stack pointer
 	msr	sp_el0, x23
 	tst	x22, #PSR_MODE32_BIT		// native task?
@@ -221,6 +282,7 @@ alternative_else_nop_endif
 	apply_ssbd 0, 5f, x0, x1
 5:
 	.endif
+
 	msr	elr_el1, x21			// set up the return data
 	msr	spsr_el1, x22
 	ldp	x0, x1, [sp, #16 * 0]
@@ -257,21 +319,18 @@ alternative_insn eret, nop, ARM64_UNMAP_KERNEL_AT_EL0
 	.endif
 	.endm
 
-	.macro	get_thread_info, rd
-	mrs	\rd, sp_el0
-	.endm
-
 	.macro	irq_stack_entry
 	mov	x19, sp			// preserve the original sp
 
 	/*
-	 * Compare sp with the current thread_info, if the top
-	 * ~(THREAD_SIZE - 1) bits match, we are on a task stack, and
-	 * should switch to the irq stack.
+	 * Compare sp with the base of the task stack.
+	 * If the top ~(THREAD_SIZE - 1) bits match, we are on a task stack,
+	 * and should switch to the irq stack.
 	 */
-	and	x25, x19, #~(THREAD_SIZE - 1)
-	cmp	x25, tsk
-	b.ne	9998f
+	ldr	x25, [tsk, TSK_STACK]
+	eor	x25, x25, x19
+	and	x25, x25, #~(THREAD_SIZE - 1)
+	cbnz	x25, 9998f
 
 	adr_this_cpu x25, irq_stack, x26
 	mov	x26, #IRQ_STACK_START_SP
@@ -501,9 +560,9 @@ el1_irq:
 	irq_handler
 
 #ifdef CONFIG_PREEMPT
-	ldr	w24, [tsk, #TI_PREEMPT]		// get preempt count
+	ldr	w24, [tsk, #TSK_TI_PREEMPT]	// get preempt count
 	cbnz	w24, 1f				// preempt count != 0
-	ldr	x0, [tsk, #TI_FLAGS]		// get flags
+	ldr	x0, [tsk, #TSK_TI_FLAGS]	// get flags
 	tbz	x0, #TIF_NEED_RESCHED, 1f	// needs rescheduling?
 	bl	el1_preempt
 1:
@@ -518,7 +577,7 @@ ENDPROC(el1_irq)
 el1_preempt:
 	mov	x24, lr
 1:	bl	preempt_schedule_irq		// irq en/disable is done inside
-	ldr	x0, [tsk, #TI_FLAGS]		// get new tasks TI_FLAGS
+	ldr	x0, [tsk, #TSK_TI_FLAGS]	// get new tasks TI_FLAGS
 	tbnz	x0, #TIF_NEED_RESCHED, 1b	// needs rescheduling?
 	ret	x24
 #endif
@@ -757,8 +816,7 @@ ENTRY(cpu_switch_to)
 	ldp	x29, x9, [x8], #16
 	ldr	lr, [x8]
 	mov	sp, x9
-	and	x9, x9, #~(THREAD_SIZE - 1)
-	msr	sp_el0, x9
+	msr	sp_el0, x1
 	ret
 ENDPROC(cpu_switch_to)
 
@@ -769,7 +827,7 @@ ENDPROC(cpu_switch_to)
 ret_fast_syscall:
 	disable_irq				// disable interrupts
 	str	x0, [sp, #S_X0]			// returned x0
-	ldr	x1, [tsk, #TI_FLAGS]		// re-check for syscall tracing
+	ldr	x1, [tsk, #TSK_TI_FLAGS]	// re-check for syscall tracing
 	and	x2, x1, #_TIF_SYSCALL_WORK
 	cbnz	x2, ret_fast_syscall_trace
 	and	x2, x1, #_TIF_WORK_MASK
@@ -789,14 +847,14 @@ work_pending:
 #ifdef CONFIG_TRACE_IRQFLAGS
 	bl	trace_hardirqs_on		// enabled while in userspace
 #endif
-	ldr	x1, [tsk, #TI_FLAGS]		// re-check for single-step
+	ldr	x1, [tsk, #TSK_TI_FLAGS]	// re-check for single-step
 	b	finish_ret_to_user
 /*
  * "slow" syscall return path.
  */
 ret_to_user:
 	disable_irq				// disable interrupts
-	ldr	x1, [tsk, #TI_FLAGS]
+	ldr	x1, [tsk, #TSK_TI_FLAGS]
 	and	x2, x1, #_TIF_WORK_MASK
 	cbnz	x2, work_pending
 finish_ret_to_user:
@@ -829,7 +887,7 @@ el0_svc_naked:					// compat entry point
 	enable_dbg_and_irq
 	ct_user_exit 1
 
-	ldr	x16, [tsk, #TI_FLAGS]		// check for syscall hooks
+	ldr	x16, [tsk, #TSK_TI_FLAGS]	// check for syscall hooks
 	tst	x16, #_TIF_SYSCALL_WORK
 	b.ne	__sys_trace
 	cmp     scno, sc_nr                     // check upper syscall limit
@@ -891,14 +949,24 @@ __ni_sys_trace:
 
 	.macro tramp_map_kernel, tmp
 	mrs	\tmp, ttbr1_el1
-	sub	\tmp, \tmp, #SWAPPER_DIR_SIZE
+	sub	\tmp, \tmp, #(SWAPPER_DIR_SIZE + RESERVED_TTBR0_SIZE)
 	bic	\tmp, \tmp, #USER_ASID_FLAG
 	msr	ttbr1_el1, \tmp
+#ifdef CONFIG_ARCH_MSM8996
+	/* ASID already in \tmp[63:48] */
+	movk	\tmp, #:abs_g2_nc:(TRAMP_VALIAS >> 12)
+	movk	\tmp, #:abs_g1_nc:(TRAMP_VALIAS >> 12)
+	/* 2MB boundary containing the vectors, so we nobble the walk cache */
+	movk	\tmp, #:abs_g0_nc:((TRAMP_VALIAS & ~(SZ_2M - 1)) >> 12)
+	isb
+	tlbi	vae1, \tmp
+	dsb	nsh
+#endif /* CONFIG_ARCH_MSM8996 */
 	.endm
 
 	.macro tramp_unmap_kernel, tmp
 	mrs	\tmp, ttbr1_el1
-	add	\tmp, \tmp, #SWAPPER_DIR_SIZE
+	add	\tmp, \tmp, #(SWAPPER_DIR_SIZE + RESERVED_TTBR0_SIZE)
 	orr	\tmp, \tmp, #USER_ASID_FLAG
 	msr	ttbr1_el1, \tmp
 	/*
@@ -925,7 +993,9 @@ __ni_sys_trace:
 	tramp_map_kernel	x30
 #ifdef CONFIG_RANDOMIZE_BASE
 	adr	x30, tramp_vectors + PAGE_SIZE
+#ifndef CONFIG_ARCH_MSM8996
 	isb
+#endif
 	ldr	x30, [x30]
 #else
 	ldr	x30, =vectors
diff --git a/arch/arm64/kernel/head.S b/arch/arm64/kernel/head.S
index fa52817..bb8a828 100644
--- a/arch/arm64/kernel/head.S
+++ b/arch/arm64/kernel/head.S
@@ -49,9 +49,14 @@
 #elif (PAGE_OFFSET & 0x1fffff) != 0
 #error PAGE_OFFSET must be at least 2MB aligned
 #elif TEXT_OFFSET > 0x1fffff
+#ifndef CONFIG_RTK_PLATFORM
 #error TEXT_OFFSET must be less than 2MB
+#endif /* CONFIG_RTK_PLATFORM */
 #endif
 
+#ifdef CONFIG_RTK_PLATFORM_FPGA
+#define DTB_ADDR 0x02100000
+#endif /* CONFIG_RTK_PLATFORM_FPGA */
 /*
  * Kernel startup entry point.
  * ---------------------------
@@ -219,6 +224,19 @@ efi_header_end:
 	 *  x19/x20    __primary_switch()         callee preserved temp registers
 	 */
 ENTRY(stext)
+#ifdef CONFIG_RTK_PLATFORM_FPGA
+#ifdef CONFIG_ARCH_RTD16xx
+	bl	gicv3_pre_init
+#endif
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD139x)
+	bl	gic_pre_init
+#endif
+	bl	armv8_switch_to_el2
+	ldr	x0, =DTB_ADDR
+	ldr	x1, =0x0
+	ldr	x2, =0x0
+	ldr	x3, =0x0
+#endif /* CONFIG_RTK_PLATFORM_FPGA */
 	bl	preserve_boot_args
 	bl	el2_setup			// Drop to EL1, w0=cpu_boot_mode
 	adrp	x23, __PHYS_OFFSET
@@ -326,14 +344,14 @@ __create_page_tables:
 	 * dirty cache lines being evicted.
 	 */
 	adrp	x0, idmap_pg_dir
-	adrp	x1, swapper_pg_dir + SWAPPER_DIR_SIZE
+	adrp	x1, swapper_pg_dir + SWAPPER_DIR_SIZE + RESERVED_TTBR0_SIZE
 	bl	__inval_cache_range
 
 	/*
 	 * Clear the idmap and swapper page tables.
 	 */
 	adrp	x0, idmap_pg_dir
-	adrp	x6, swapper_pg_dir + SWAPPER_DIR_SIZE
+	adrp	x6, swapper_pg_dir + SWAPPER_DIR_SIZE + RESERVED_TTBR0_SIZE
 1:	stp	xzr, xzr, [x0], #16
 	stp	xzr, xzr, [x0], #16
 	stp	xzr, xzr, [x0], #16
@@ -412,7 +430,7 @@ __create_page_tables:
 	 * tables again to remove any speculatively loaded cache lines.
 	 */
 	adrp	x0, idmap_pg_dir
-	adrp	x1, swapper_pg_dir + SWAPPER_DIR_SIZE
+	adrp	x1, swapper_pg_dir + SWAPPER_DIR_SIZE + RESERVED_TTBR0_SIZE
 	dmb	sy
 	bl	__inval_cache_range
 
@@ -428,7 +446,8 @@ ENDPROC(__create_page_tables)
 __primary_switched:
 	adrp	x4, init_thread_union
 	add	sp, x4, #THREAD_SIZE
-	msr	sp_el0, x4			// Save thread_info
+	adr_l	x5, init_task
+	msr	sp_el0, x5			// Save thread_info
 
 	adr_l	x8, vectors			// load VBAR_EL1 with virtual
 	msr	vbar_el1, x8			// vector table address
@@ -656,17 +675,74 @@ ENTRY(__early_cpu_boot_status)
 
 	.popsection
 
+#ifdef CONFIG_RTK_PLATFORM
+.macro  switch_el, xreg, el3_label, el2_label, el1_label
+	mrs	\xreg, CurrentEL
+	cmp	\xreg, 0xc
+	b.eq	\el3_label
+	cmp	\xreg, 0x8
+	b.eq	\el2_label
+	cmp	\xreg, 0x4
+	b.eq	\el1_label
+.endm
+
+.macro armv8_switch_to_el2_m, xreg1
+	/* 64bit EL2 | HCE | SMD | RES1 (Bits[5:4]) | Non-secure EL0/EL1 */
+	mov	\xreg1, #0x5b1
+	msr	scr_el3, \xreg1
+	msr	cptr_el3, xzr	/* Disable coprocessor traps to EL3 */
+	mov	\xreg1, #0x33ff
+	msr	cptr_el2, \xreg1	/* Disable coprocessor traps to EL2 */
+
+	/* Initialize Generic Timers */
+	msr	cntvoff_el2, xzr
+
+	/* Initialize SCTLR_EL2
+	 *
+	 * setting RES1 bits (29,28,23,22,18,16,11,5,4) to 1
+	 * and RES0 bits (31,30,27,26,24,21,20,17,15-13,10-6) +
+	 * EE,WXN,I,SA,C,A,M to 0
+	 */
+	mov	 \xreg1, #0x0830
+	movk	\xreg1, #0x30C5, lsl #16
+	msr	sctlr_el2, \xreg1
+
+	/* Return to the EL2_SP2 mode from EL3 */
+	mov	\xreg1, sp
+	msr	sp_el2, \xreg1		/* Migrate SP */
+	mrs	\xreg1, vbar_el3
+	msr	vbar_el2, \xreg1		/* Migrate VBAR */
+	mov	\xreg1, #0x3c9
+	msr	spsr_el3, \xreg1		/* EL2_SP2 | D | A | I | F */
+	msr	elr_el3, lr
+	eret
+.endm
+
+ENTRY(armv8_switch_to_el2)
+	switch_el x0, 1f, 0f, 0f
+0:	ret
+1:	armv8_switch_to_el2_m x0
+ENDPROC(armv8_switch_to_el2)
+#endif /* CONFIG_RTK_PLATFORM */
+
 	/*
 	 * This provides a "holding pen" for platforms to hold all secondary
 	 * cores are held until we're ready for them to initialise.
 	 */
 ENTRY(secondary_holding_pen)
+#ifdef CONFIG_RTK_PLATFORM
+	bl armv8_switch_to_el2
+#endif /* CONFIG_RTK_PLATFORM */
 	bl	el2_setup			// Drop to EL1, w0=cpu_boot_mode
 	bl	set_cpu_boot_mode_flag
 	mrs	x0, mpidr_el1
 	mov_q	x1, MPIDR_HWID_BITMASK
 	and	x0, x0, x1
+#ifdef CONFIG_RTK_PLATFORM
+	adr_l	x3, rtk_secondary_holding_pen_release
+#else
 	adr_l	x3, secondary_holding_pen_release
+#endif /* CONFIG_RTK_PLATFORM */
 pen:	ldr	x4, [x3]
 	cmp	x4, x0
 	b.eq	secondary_startup
@@ -700,10 +776,10 @@ __secondary_switched:
 	isb
 
 	adr_l	x0, secondary_data
-	ldr	x0, [x0, #CPU_BOOT_STACK]	// get secondary_data.stack
-	mov	sp, x0
-	and	x0, x0, #~(THREAD_SIZE - 1)
-	msr	sp_el0, x0			// save thread_info
+	ldr	x1, [x0, #CPU_BOOT_STACK]	// get secondary_data.stack
+	mov	sp, x1
+	ldr	x2, [x0, #CPU_BOOT_TASK]
+	msr	sp_el0, x2
 	mov	x29, #0
 	b	secondary_start_kernel
 ENDPROC(__secondary_switched)
diff --git a/arch/arm64/kernel/hibernate.c b/arch/arm64/kernel/hibernate.c
index f6e71c7..db603cd 100644
--- a/arch/arm64/kernel/hibernate.c
+++ b/arch/arm64/kernel/hibernate.c
@@ -50,9 +50,6 @@
  */
 extern int in_suspend;
 
-/* Find a symbols alias in the linear map */
-#define LMADDR(x)	phys_to_virt(virt_to_phys(x))
-
 /* Do we need to reset el2? */
 #define el2_reset_needed() (is_hyp_mode_available() && !is_kernel_in_hyp_mode())
 
@@ -102,8 +99,8 @@ static inline void arch_hdr_invariants(struct arch_hibernate_hdr_invariants *i)
 
 int pfn_is_nosave(unsigned long pfn)
 {
-	unsigned long nosave_begin_pfn = virt_to_pfn(&__nosave_begin);
-	unsigned long nosave_end_pfn = virt_to_pfn(&__nosave_end - 1);
+	unsigned long nosave_begin_pfn = sym_to_pfn(&__nosave_begin);
+	unsigned long nosave_end_pfn = sym_to_pfn(&__nosave_end - 1);
 
 	return (pfn >= nosave_begin_pfn) && (pfn <= nosave_end_pfn);
 }
@@ -125,12 +122,12 @@ int arch_hibernation_header_save(void *addr, unsigned int max_size)
 		return -EOVERFLOW;
 
 	arch_hdr_invariants(&hdr->invariants);
-	hdr->ttbr1_el1		= virt_to_phys(swapper_pg_dir);
+	hdr->ttbr1_el1		= __pa_symbol(swapper_pg_dir);
 	hdr->reenter_kernel	= _cpu_resume;
 
 	/* We can't use __hyp_get_vectors() because kvm may still be loaded */
 	if (el2_reset_needed())
-		hdr->__hyp_stub_vectors = virt_to_phys(__hyp_stub_vectors);
+		hdr->__hyp_stub_vectors = __pa_symbol(__hyp_stub_vectors);
 	else
 		hdr->__hyp_stub_vectors = 0;
 
@@ -471,7 +468,6 @@ int swsusp_arch_resume(void)
 	void *zero_page;
 	size_t exit_size;
 	pgd_t *tmp_pg_dir;
-	void *lm_restore_pblist;
 	phys_addr_t phys_hibernate_exit;
 	void __noreturn (*hibernate_exit)(phys_addr_t, phys_addr_t, void *,
 					  void *, phys_addr_t, phys_addr_t);
@@ -492,12 +488,6 @@ int swsusp_arch_resume(void)
 		goto out;
 
 	/*
-	 * Since we only copied the linear map, we need to find restore_pblist's
-	 * linear map address.
-	 */
-	lm_restore_pblist = LMADDR(restore_pblist);
-
-	/*
 	 * We need a zero page that is zero before & after resume in order to
 	 * to break before make on the ttbr1 page tables.
 	 */
@@ -548,7 +538,7 @@ int swsusp_arch_resume(void)
 	}
 
 	hibernate_exit(virt_to_phys(tmp_pg_dir), resume_hdr.ttbr1_el1,
-		       resume_hdr.reenter_kernel, lm_restore_pblist,
+		       resume_hdr.reenter_kernel, restore_pblist,
 		       resume_hdr.__hyp_stub_vectors, virt_to_phys(zero_page));
 
 out:
diff --git a/arch/arm64/kernel/hw_breakpoint.c b/arch/arm64/kernel/hw_breakpoint.c
index 0b9e5f6..fb0082a 100644
--- a/arch/arm64/kernel/hw_breakpoint.c
+++ b/arch/arm64/kernel/hw_breakpoint.c
@@ -318,9 +318,21 @@ static int get_hbp_len(u8 hbp_len)
 	case ARM_BREAKPOINT_LEN_2:
 		len_in_bytes = 2;
 		break;
+	case ARM_BREAKPOINT_LEN_3:
+		len_in_bytes = 3;
+		break;
 	case ARM_BREAKPOINT_LEN_4:
 		len_in_bytes = 4;
 		break;
+	case ARM_BREAKPOINT_LEN_5:
+		len_in_bytes = 5;
+		break;
+	case ARM_BREAKPOINT_LEN_6:
+		len_in_bytes = 6;
+		break;
+	case ARM_BREAKPOINT_LEN_7:
+		len_in_bytes = 7;
+		break;
 	case ARM_BREAKPOINT_LEN_8:
 		len_in_bytes = 8;
 		break;
@@ -350,7 +362,7 @@ int arch_check_bp_in_kernelspace(struct perf_event *bp)
  * to generic breakpoint descriptions.
  */
 int arch_bp_generic_fields(struct arch_hw_breakpoint_ctrl ctrl,
-			   int *gen_len, int *gen_type)
+			   int *gen_len, int *gen_type, int *offset)
 {
 	/* Type */
 	switch (ctrl.type) {
@@ -370,17 +382,33 @@ int arch_bp_generic_fields(struct arch_hw_breakpoint_ctrl ctrl,
 		return -EINVAL;
 	}
 
+	if (!ctrl.len)
+		return -EINVAL;
+	*offset = __ffs(ctrl.len);
+
 	/* Len */
-	switch (ctrl.len) {
+	switch (ctrl.len >> *offset) {
 	case ARM_BREAKPOINT_LEN_1:
 		*gen_len = HW_BREAKPOINT_LEN_1;
 		break;
 	case ARM_BREAKPOINT_LEN_2:
 		*gen_len = HW_BREAKPOINT_LEN_2;
 		break;
+	case ARM_BREAKPOINT_LEN_3:
+		*gen_len = HW_BREAKPOINT_LEN_3;
+		break;
 	case ARM_BREAKPOINT_LEN_4:
 		*gen_len = HW_BREAKPOINT_LEN_4;
 		break;
+	case ARM_BREAKPOINT_LEN_5:
+		*gen_len = HW_BREAKPOINT_LEN_5;
+		break;
+	case ARM_BREAKPOINT_LEN_6:
+		*gen_len = HW_BREAKPOINT_LEN_6;
+		break;
+	case ARM_BREAKPOINT_LEN_7:
+		*gen_len = HW_BREAKPOINT_LEN_7;
+		break;
 	case ARM_BREAKPOINT_LEN_8:
 		*gen_len = HW_BREAKPOINT_LEN_8;
 		break;
@@ -424,9 +452,21 @@ static int arch_build_bp_info(struct perf_event *bp)
 	case HW_BREAKPOINT_LEN_2:
 		info->ctrl.len = ARM_BREAKPOINT_LEN_2;
 		break;
+	case HW_BREAKPOINT_LEN_3:
+		info->ctrl.len = ARM_BREAKPOINT_LEN_3;
+		break;
 	case HW_BREAKPOINT_LEN_4:
 		info->ctrl.len = ARM_BREAKPOINT_LEN_4;
 		break;
+	case HW_BREAKPOINT_LEN_5:
+		info->ctrl.len = ARM_BREAKPOINT_LEN_5;
+		break;
+	case HW_BREAKPOINT_LEN_6:
+		info->ctrl.len = ARM_BREAKPOINT_LEN_6;
+		break;
+	case HW_BREAKPOINT_LEN_7:
+		info->ctrl.len = ARM_BREAKPOINT_LEN_7;
+		break;
 	case HW_BREAKPOINT_LEN_8:
 		info->ctrl.len = ARM_BREAKPOINT_LEN_8;
 		break;
@@ -518,18 +558,17 @@ int arch_validate_hwbkpt_settings(struct perf_event *bp)
 		default:
 			return -EINVAL;
 		}
-
-		info->address &= ~alignment_mask;
-		info->ctrl.len <<= offset;
 	} else {
 		if (info->ctrl.type == ARM_BREAKPOINT_EXECUTE)
 			alignment_mask = 0x3;
 		else
 			alignment_mask = 0x7;
-		if (info->address & alignment_mask)
-			return -EINVAL;
+		offset = info->address & alignment_mask;
 	}
 
+	info->address &= ~alignment_mask;
+	info->ctrl.len <<= offset;
+
 	/*
 	 * Disallow per-task kernel breakpoints since these would
 	 * complicate the stepping code.
@@ -662,12 +701,47 @@ static int breakpoint_handler(unsigned long unused, unsigned int esr,
 }
 NOKPROBE_SYMBOL(breakpoint_handler);
 
+/*
+ * Arm64 hardware does not always report a watchpoint hit address that matches
+ * one of the watchpoints set. It can also report an address "near" the
+ * watchpoint if a single instruction access both watched and unwatched
+ * addresses. There is no straight-forward way, short of disassembling the
+ * offending instruction, to map that address back to the watchpoint. This
+ * function computes the distance of the memory access from the watchpoint as a
+ * heuristic for the likelyhood that a given access triggered the watchpoint.
+ *
+ * See Section D2.10.5 "Determining the memory location that caused a Watchpoint
+ * exception" of ARMv8 Architecture Reference Manual for details.
+ *
+ * The function returns the distance of the address from the bytes watched by
+ * the watchpoint. In case of an exact match, it returns 0.
+ */
+static u64 get_distance_from_watchpoint(unsigned long addr, u64 val,
+					struct arch_hw_breakpoint_ctrl *ctrl)
+{
+	u64 wp_low, wp_high;
+	u32 lens, lene;
+
+	lens = __ffs(ctrl->len);
+	lene = __fls(ctrl->len);
+
+	wp_low = val + lens;
+	wp_high = val + lene;
+	if (addr < wp_low)
+		return wp_low - addr;
+	else if (addr > wp_high)
+		return addr - wp_high;
+	else
+		return 0;
+}
+
 static int watchpoint_handler(unsigned long addr, unsigned int esr,
 			      struct pt_regs *regs)
 {
-	int i, step = 0, *kernel_step, access;
+	int i, step = 0, *kernel_step, access, closest_match = 0;
+	u64 min_dist = -1, dist;
 	u32 ctrl_reg;
-	u64 val, alignment_mask;
+	u64 val;
 	struct perf_event *wp, **slots;
 	struct debug_info *debug_info;
 	struct arch_hw_breakpoint *info;
@@ -676,35 +750,15 @@ static int watchpoint_handler(unsigned long addr, unsigned int esr,
 	slots = this_cpu_ptr(wp_on_reg);
 	debug_info = &current->thread.debug;
 
+	/*
+	 * Find all watchpoints that match the reported address. If no exact
+	 * match is found. Attribute the hit to the closest watchpoint.
+	 */
+	rcu_read_lock();
 	for (i = 0; i < core_num_wrps; ++i) {
-		rcu_read_lock();
-
 		wp = slots[i];
-
 		if (wp == NULL)
-			goto unlock;
-
-		info = counter_arch_bp(wp);
-		/* AArch32 watchpoints are either 4 or 8 bytes aligned. */
-		if (is_compat_task()) {
-			if (info->ctrl.len == ARM_BREAKPOINT_LEN_8)
-				alignment_mask = 0x7;
-			else
-				alignment_mask = 0x3;
-		} else {
-			alignment_mask = 0x7;
-		}
-
-		/* Check if the watchpoint value matches. */
-		val = read_wb_reg(AARCH64_DBG_REG_WVR, i);
-		if (val != (untagged_addr(addr) & ~alignment_mask))
-			goto unlock;
-
-		/* Possible match, check the byte address select to confirm. */
-		ctrl_reg = read_wb_reg(AARCH64_DBG_REG_WCR, i);
-		decode_ctrl_reg(ctrl_reg, &ctrl);
-		if (!((1 << (addr & alignment_mask)) & ctrl.len))
-			goto unlock;
+			continue;
 
 		/*
 		 * Check that the access type matches.
@@ -713,18 +767,41 @@ static int watchpoint_handler(unsigned long addr, unsigned int esr,
 		access = (esr & AARCH64_ESR_ACCESS_MASK) ? HW_BREAKPOINT_W :
 			 HW_BREAKPOINT_R;
 		if (!(access & hw_breakpoint_type(wp)))
-			goto unlock;
+			continue;
 
+		/* Check if the watchpoint value and byte select match. */
+		val = read_wb_reg(AARCH64_DBG_REG_WVR, i);
+		ctrl_reg = read_wb_reg(AARCH64_DBG_REG_WCR, i);
+		decode_ctrl_reg(ctrl_reg, &ctrl);
+		dist = get_distance_from_watchpoint(addr, val, &ctrl);
+		if (dist < min_dist) {
+			min_dist = dist;
+			closest_match = i;
+		}
+		/* Is this an exact match? */
+		if (dist != 0)
+			continue;
+
+		info = counter_arch_bp(wp);
 		info->trigger = addr;
 		perf_bp_event(wp, regs);
 
 		/* Do we need to handle the stepping? */
 		if (is_default_overflow_handler(wp))
 			step = 1;
+	}
+	if (min_dist > 0 && min_dist != -1) {
+		/* No exact match found. */
+		wp = slots[closest_match];
+		info = counter_arch_bp(wp);
+		info->trigger = addr;
+		perf_bp_event(wp, regs);
 
-unlock:
-		rcu_read_unlock();
+		/* Do we need to handle the stepping? */
+		if (is_default_overflow_handler(wp))
+			step = 1;
 	}
+	rcu_read_unlock();
 
 	if (!step)
 		return 0;
diff --git a/arch/arm64/kernel/insn.c b/arch/arm64/kernel/insn.c
index 6f2ac4f..f607b38 100644
--- a/arch/arm64/kernel/insn.c
+++ b/arch/arm64/kernel/insn.c
@@ -97,7 +97,7 @@ static void __kprobes *patch_map(void *addr, int fixmap)
 	if (module && IS_ENABLED(CONFIG_DEBUG_SET_MODULE_RONX))
 		page = vmalloc_to_page(addr);
 	else if (!module)
-		page = pfn_to_page(PHYS_PFN(__pa(addr)));
+		page = phys_to_page(__pa_symbol(addr));
 	else
 		return addr;
 
diff --git a/arch/arm64/kernel/io.c b/arch/arm64/kernel/io.c
index 354be2a..9b36267 100644
--- a/arch/arm64/kernel/io.c
+++ b/arch/arm64/kernel/io.c
@@ -25,23 +25,22 @@
  */
 void __memcpy_fromio(void *to, const volatile void __iomem *from, size_t count)
 {
-	while (count && (!IS_ALIGNED((unsigned long)from, 8) ||
-			 !IS_ALIGNED((unsigned long)to, 8))) {
-		*(u8 *)to = __raw_readb(from);
+	while (count && !IS_ALIGNED((unsigned long)from, 8)) {
+		*(u8 *)to = __raw_readb_no_log(from);
 		from++;
 		to++;
 		count--;
 	}
 
 	while (count >= 8) {
-		*(u64 *)to = __raw_readq(from);
+		*(u64 *)to = __raw_readq_no_log(from);
 		from += 8;
 		to += 8;
 		count -= 8;
 	}
 
 	while (count) {
-		*(u8 *)to = __raw_readb(from);
+		*(u8 *)to = __raw_readb_no_log(from);
 		from++;
 		to++;
 		count--;
@@ -54,23 +53,22 @@ void __memcpy_fromio(void *to, const volatile void __iomem *from, size_t count)
  */
 void __memcpy_toio(volatile void __iomem *to, const void *from, size_t count)
 {
-	while (count && (!IS_ALIGNED((unsigned long)to, 8) ||
-			 !IS_ALIGNED((unsigned long)from, 8))) {
-		__raw_writeb(*(volatile u8 *)from, to);
+	while (count && !IS_ALIGNED((unsigned long)to, 8)) {
+		__raw_writeb_no_log(*(u8 *)from, to);
 		from++;
 		to++;
 		count--;
 	}
 
 	while (count >= 8) {
-		__raw_writeq(*(volatile u64 *)from, to);
+		__raw_writeq_no_log(*(u64 *)from, to);
 		from += 8;
 		to += 8;
 		count -= 8;
 	}
 
 	while (count) {
-		__raw_writeb(*(volatile u8 *)from, to);
+		__raw_writeb_no_log(*(u8 *)from, to);
 		from++;
 		to++;
 		count--;
@@ -90,19 +88,19 @@ void __memset_io(volatile void __iomem *dst, int c, size_t count)
 	qc |= qc << 32;
 
 	while (count && !IS_ALIGNED((unsigned long)dst, 8)) {
-		__raw_writeb(c, dst);
+		__raw_writeb_no_log(c, dst);
 		dst++;
 		count--;
 	}
 
 	while (count >= 8) {
-		__raw_writeq(qc, dst);
+		__raw_writeq_no_log(qc, dst);
 		dst += 8;
 		count -= 8;
 	}
 
 	while (count) {
-		__raw_writeb(c, dst);
+		__raw_writeb_no_log(c, dst);
 		dst++;
 		count--;
 	}
diff --git a/arch/arm64/kernel/module.lds b/arch/arm64/kernel/module.lds
index 8949f6c..05881e2 100644
--- a/arch/arm64/kernel/module.lds
+++ b/arch/arm64/kernel/module.lds
@@ -1,3 +1,3 @@
 SECTIONS {
-	.plt (NOLOAD) : { BYTE(0) }
+	.plt : { BYTE(0) }
 }
diff --git a/arch/arm64/kernel/perf_event.c b/arch/arm64/kernel/perf_event.c
deleted file mode 100644
index 199a23f..00000000
--- a/arch/arm64/kernel/perf_event.c
+++ /dev/null
@@ -1,1121 +0,0 @@
-/*
- * PMU support
- *
- * Copyright (C) 2012 ARM Limited
- * Author: Will Deacon <will.deacon@arm.com>
- *
- * This code is based heavily on the ARMv7 perf event code.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#include <asm/irq_regs.h>
-#include <asm/perf_event.h>
-#include <asm/sysreg.h>
-#include <asm/virt.h>
-
-#include <linux/acpi.h>
-#include <linux/of.h>
-#include <linux/perf/arm_pmu.h>
-#include <linux/platform_device.h>
-
-/*
- * ARMv8 PMUv3 Performance Events handling code.
- * Common event types (some are defined in asm/perf_event.h).
- */
-
-/* At least one of the following is required. */
-#define ARMV8_PMUV3_PERFCTR_INST_RETIRED			0x08
-#define ARMV8_PMUV3_PERFCTR_INST_SPEC				0x1B
-
-/* Common architectural events. */
-#define ARMV8_PMUV3_PERFCTR_LD_RETIRED				0x06
-#define ARMV8_PMUV3_PERFCTR_ST_RETIRED				0x07
-#define ARMV8_PMUV3_PERFCTR_EXC_TAKEN				0x09
-#define ARMV8_PMUV3_PERFCTR_EXC_RETURN				0x0A
-#define ARMV8_PMUV3_PERFCTR_CID_WRITE_RETIRED			0x0B
-#define ARMV8_PMUV3_PERFCTR_PC_WRITE_RETIRED			0x0C
-#define ARMV8_PMUV3_PERFCTR_BR_IMMED_RETIRED			0x0D
-#define ARMV8_PMUV3_PERFCTR_BR_RETURN_RETIRED			0x0E
-#define ARMV8_PMUV3_PERFCTR_UNALIGNED_LDST_RETIRED		0x0F
-#define ARMV8_PMUV3_PERFCTR_TTBR_WRITE_RETIRED			0x1C
-#define ARMV8_PMUV3_PERFCTR_CHAIN				0x1E
-#define ARMV8_PMUV3_PERFCTR_BR_RETIRED				0x21
-
-/* Common microarchitectural events. */
-#define ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL			0x01
-#define ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL			0x02
-#define ARMV8_PMUV3_PERFCTR_L1D_TLB_REFILL			0x05
-#define ARMV8_PMUV3_PERFCTR_MEM_ACCESS				0x13
-#define ARMV8_PMUV3_PERFCTR_L1I_CACHE				0x14
-#define ARMV8_PMUV3_PERFCTR_L1D_CACHE_WB			0x15
-#define ARMV8_PMUV3_PERFCTR_L2D_CACHE				0x16
-#define ARMV8_PMUV3_PERFCTR_L2D_CACHE_REFILL			0x17
-#define ARMV8_PMUV3_PERFCTR_L2D_CACHE_WB			0x18
-#define ARMV8_PMUV3_PERFCTR_BUS_ACCESS				0x19
-#define ARMV8_PMUV3_PERFCTR_MEMORY_ERROR			0x1A
-#define ARMV8_PMUV3_PERFCTR_BUS_CYCLES				0x1D
-#define ARMV8_PMUV3_PERFCTR_L1D_CACHE_ALLOCATE			0x1F
-#define ARMV8_PMUV3_PERFCTR_L2D_CACHE_ALLOCATE			0x20
-#define ARMV8_PMUV3_PERFCTR_BR_MIS_PRED_RETIRED			0x22
-#define ARMV8_PMUV3_PERFCTR_STALL_FRONTEND			0x23
-#define ARMV8_PMUV3_PERFCTR_STALL_BACKEND			0x24
-#define ARMV8_PMUV3_PERFCTR_L1D_TLB				0x25
-#define ARMV8_PMUV3_PERFCTR_L1I_TLB				0x26
-#define ARMV8_PMUV3_PERFCTR_L2I_CACHE				0x27
-#define ARMV8_PMUV3_PERFCTR_L2I_CACHE_REFILL			0x28
-#define ARMV8_PMUV3_PERFCTR_L3D_CACHE_ALLOCATE			0x29
-#define ARMV8_PMUV3_PERFCTR_L3D_CACHE_REFILL			0x2A
-#define ARMV8_PMUV3_PERFCTR_L3D_CACHE				0x2B
-#define ARMV8_PMUV3_PERFCTR_L3D_CACHE_WB			0x2C
-#define ARMV8_PMUV3_PERFCTR_L2D_TLB_REFILL			0x2D
-#define ARMV8_PMUV3_PERFCTR_L2I_TLB_REFILL			0x2E
-#define ARMV8_PMUV3_PERFCTR_L2D_TLB				0x2F
-#define ARMV8_PMUV3_PERFCTR_L2I_TLB				0x30
-
-/* ARMv8 recommended implementation defined event types */
-#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_RD			0x40
-#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WR			0x41
-#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_RD		0x42
-#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_WR		0x43
-#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_INNER		0x44
-#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_OUTER		0x45
-#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WB_VICTIM		0x46
-#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WB_CLEAN			0x47
-#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_INVAL			0x48
-
-#define ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_RD			0x4C
-#define ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_WR			0x4D
-#define ARMV8_IMPDEF_PERFCTR_L1D_TLB_RD				0x4E
-#define ARMV8_IMPDEF_PERFCTR_L1D_TLB_WR				0x4F
-#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_RD			0x50
-#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_WR			0x51
-#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_REFILL_RD		0x52
-#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_REFILL_WR		0x53
-
-#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_WB_VICTIM		0x56
-#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_WB_CLEAN			0x57
-#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_INVAL			0x58
-
-#define ARMV8_IMPDEF_PERFCTR_L2D_TLB_REFILL_RD			0x5C
-#define ARMV8_IMPDEF_PERFCTR_L2D_TLB_REFILL_WR			0x5D
-#define ARMV8_IMPDEF_PERFCTR_L2D_TLB_RD				0x5E
-#define ARMV8_IMPDEF_PERFCTR_L2D_TLB_WR				0x5F
-
-#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_RD			0x60
-#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_WR			0x61
-#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_SHARED			0x62
-#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_NOT_SHARED		0x63
-#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_NORMAL			0x64
-#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_PERIPH			0x65
-
-#define ARMV8_IMPDEF_PERFCTR_MEM_ACCESS_RD			0x66
-#define ARMV8_IMPDEF_PERFCTR_MEM_ACCESS_WR			0x67
-#define ARMV8_IMPDEF_PERFCTR_UNALIGNED_LD_SPEC			0x68
-#define ARMV8_IMPDEF_PERFCTR_UNALIGNED_ST_SPEC			0x69
-#define ARMV8_IMPDEF_PERFCTR_UNALIGNED_LDST_SPEC		0x6A
-
-#define ARMV8_IMPDEF_PERFCTR_LDREX_SPEC				0x6C
-#define ARMV8_IMPDEF_PERFCTR_STREX_PASS_SPEC			0x6D
-#define ARMV8_IMPDEF_PERFCTR_STREX_FAIL_SPEC			0x6E
-#define ARMV8_IMPDEF_PERFCTR_STREX_SPEC				0x6F
-#define ARMV8_IMPDEF_PERFCTR_LD_SPEC				0x70
-#define ARMV8_IMPDEF_PERFCTR_ST_SPEC				0x71
-#define ARMV8_IMPDEF_PERFCTR_LDST_SPEC				0x72
-#define ARMV8_IMPDEF_PERFCTR_DP_SPEC				0x73
-#define ARMV8_IMPDEF_PERFCTR_ASE_SPEC				0x74
-#define ARMV8_IMPDEF_PERFCTR_VFP_SPEC				0x75
-#define ARMV8_IMPDEF_PERFCTR_PC_WRITE_SPEC			0x76
-#define ARMV8_IMPDEF_PERFCTR_CRYPTO_SPEC			0x77
-#define ARMV8_IMPDEF_PERFCTR_BR_IMMED_SPEC			0x78
-#define ARMV8_IMPDEF_PERFCTR_BR_RETURN_SPEC			0x79
-#define ARMV8_IMPDEF_PERFCTR_BR_INDIRECT_SPEC			0x7A
-
-#define ARMV8_IMPDEF_PERFCTR_ISB_SPEC				0x7C
-#define ARMV8_IMPDEF_PERFCTR_DSB_SPEC				0x7D
-#define ARMV8_IMPDEF_PERFCTR_DMB_SPEC				0x7E
-
-#define ARMV8_IMPDEF_PERFCTR_EXC_UNDEF				0x81
-#define ARMV8_IMPDEF_PERFCTR_EXC_SVC				0x82
-#define ARMV8_IMPDEF_PERFCTR_EXC_PABORT				0x83
-#define ARMV8_IMPDEF_PERFCTR_EXC_DABORT				0x84
-
-#define ARMV8_IMPDEF_PERFCTR_EXC_IRQ				0x86
-#define ARMV8_IMPDEF_PERFCTR_EXC_FIQ				0x87
-#define ARMV8_IMPDEF_PERFCTR_EXC_SMC				0x88
-
-#define ARMV8_IMPDEF_PERFCTR_EXC_HVC				0x8A
-#define ARMV8_IMPDEF_PERFCTR_EXC_TRAP_PABORT			0x8B
-#define ARMV8_IMPDEF_PERFCTR_EXC_TRAP_DABORT			0x8C
-#define ARMV8_IMPDEF_PERFCTR_EXC_TRAP_OTHER			0x8D
-#define ARMV8_IMPDEF_PERFCTR_EXC_TRAP_IRQ			0x8E
-#define ARMV8_IMPDEF_PERFCTR_EXC_TRAP_FIQ			0x8F
-#define ARMV8_IMPDEF_PERFCTR_RC_LD_SPEC				0x90
-#define ARMV8_IMPDEF_PERFCTR_RC_ST_SPEC				0x91
-
-#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_RD			0xA0
-#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_WR			0xA1
-#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_REFILL_RD		0xA2
-#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_REFILL_WR		0xA3
-
-#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_WB_VICTIM		0xA6
-#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_WB_CLEAN			0xA7
-#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_INVAL			0xA8
-
-/* ARMv8 Cortex-A53 specific event types. */
-#define ARMV8_A53_PERFCTR_PREF_LINEFILL				0xC2
-
-/* ARMv8 Cavium ThunderX specific event types. */
-#define ARMV8_THUNDER_PERFCTR_L1D_CACHE_MISS_ST			0xE9
-#define ARMV8_THUNDER_PERFCTR_L1D_CACHE_PREF_ACCESS		0xEA
-#define ARMV8_THUNDER_PERFCTR_L1D_CACHE_PREF_MISS		0xEB
-#define ARMV8_THUNDER_PERFCTR_L1I_CACHE_PREF_ACCESS		0xEC
-#define ARMV8_THUNDER_PERFCTR_L1I_CACHE_PREF_MISS		0xED
-
-/* PMUv3 HW events mapping. */
-
-/*
- * ARMv8 Architectural defined events, not all of these may
- * be supported on any given implementation. Undefined events will
- * be disabled at run-time.
- */
-static const unsigned armv8_pmuv3_perf_map[PERF_COUNT_HW_MAX] = {
-	PERF_MAP_ALL_UNSUPPORTED,
-	[PERF_COUNT_HW_CPU_CYCLES]		= ARMV8_PMUV3_PERFCTR_CPU_CYCLES,
-	[PERF_COUNT_HW_INSTRUCTIONS]		= ARMV8_PMUV3_PERFCTR_INST_RETIRED,
-	[PERF_COUNT_HW_CACHE_REFERENCES]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
-	[PERF_COUNT_HW_CACHE_MISSES]		= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
-	[PERF_COUNT_HW_BRANCH_INSTRUCTIONS]	= ARMV8_PMUV3_PERFCTR_PC_WRITE_RETIRED,
-	[PERF_COUNT_HW_BRANCH_MISSES]		= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-	[PERF_COUNT_HW_BUS_CYCLES]		= ARMV8_PMUV3_PERFCTR_BUS_CYCLES,
-	[PERF_COUNT_HW_STALLED_CYCLES_FRONTEND]	= ARMV8_PMUV3_PERFCTR_STALL_FRONTEND,
-	[PERF_COUNT_HW_STALLED_CYCLES_BACKEND]	= ARMV8_PMUV3_PERFCTR_STALL_BACKEND,
-};
-
-/* ARM Cortex-A53 HW events mapping. */
-static const unsigned armv8_a53_perf_map[PERF_COUNT_HW_MAX] = {
-	PERF_MAP_ALL_UNSUPPORTED,
-	[PERF_COUNT_HW_CPU_CYCLES]		= ARMV8_PMUV3_PERFCTR_CPU_CYCLES,
-	[PERF_COUNT_HW_INSTRUCTIONS]		= ARMV8_PMUV3_PERFCTR_INST_RETIRED,
-	[PERF_COUNT_HW_CACHE_REFERENCES]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
-	[PERF_COUNT_HW_CACHE_MISSES]		= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
-	[PERF_COUNT_HW_BRANCH_INSTRUCTIONS]	= ARMV8_PMUV3_PERFCTR_PC_WRITE_RETIRED,
-	[PERF_COUNT_HW_BRANCH_MISSES]		= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-	[PERF_COUNT_HW_BUS_CYCLES]		= ARMV8_PMUV3_PERFCTR_BUS_CYCLES,
-};
-
-/* ARM Cortex-A57 and Cortex-A72 events mapping. */
-static const unsigned armv8_a57_perf_map[PERF_COUNT_HW_MAX] = {
-	PERF_MAP_ALL_UNSUPPORTED,
-	[PERF_COUNT_HW_CPU_CYCLES]		= ARMV8_PMUV3_PERFCTR_CPU_CYCLES,
-	[PERF_COUNT_HW_INSTRUCTIONS]		= ARMV8_PMUV3_PERFCTR_INST_RETIRED,
-	[PERF_COUNT_HW_CACHE_REFERENCES]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
-	[PERF_COUNT_HW_CACHE_MISSES]		= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
-	[PERF_COUNT_HW_BRANCH_MISSES]		= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-	[PERF_COUNT_HW_BUS_CYCLES]		= ARMV8_PMUV3_PERFCTR_BUS_CYCLES,
-};
-
-static const unsigned armv8_thunder_perf_map[PERF_COUNT_HW_MAX] = {
-	PERF_MAP_ALL_UNSUPPORTED,
-	[PERF_COUNT_HW_CPU_CYCLES]		= ARMV8_PMUV3_PERFCTR_CPU_CYCLES,
-	[PERF_COUNT_HW_INSTRUCTIONS]		= ARMV8_PMUV3_PERFCTR_INST_RETIRED,
-	[PERF_COUNT_HW_CACHE_REFERENCES]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
-	[PERF_COUNT_HW_CACHE_MISSES]		= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
-	[PERF_COUNT_HW_BRANCH_INSTRUCTIONS]	= ARMV8_PMUV3_PERFCTR_PC_WRITE_RETIRED,
-	[PERF_COUNT_HW_BRANCH_MISSES]		= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-	[PERF_COUNT_HW_STALLED_CYCLES_FRONTEND] = ARMV8_PMUV3_PERFCTR_STALL_FRONTEND,
-	[PERF_COUNT_HW_STALLED_CYCLES_BACKEND]	= ARMV8_PMUV3_PERFCTR_STALL_BACKEND,
-};
-
-/* Broadcom Vulcan events mapping */
-static const unsigned armv8_vulcan_perf_map[PERF_COUNT_HW_MAX] = {
-	PERF_MAP_ALL_UNSUPPORTED,
-	[PERF_COUNT_HW_CPU_CYCLES]		= ARMV8_PMUV3_PERFCTR_CPU_CYCLES,
-	[PERF_COUNT_HW_INSTRUCTIONS]		= ARMV8_PMUV3_PERFCTR_INST_RETIRED,
-	[PERF_COUNT_HW_CACHE_REFERENCES]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
-	[PERF_COUNT_HW_CACHE_MISSES]		= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
-	[PERF_COUNT_HW_BRANCH_INSTRUCTIONS]	= ARMV8_PMUV3_PERFCTR_BR_RETIRED,
-	[PERF_COUNT_HW_BRANCH_MISSES]		= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-	[PERF_COUNT_HW_BUS_CYCLES]		= ARMV8_PMUV3_PERFCTR_BUS_CYCLES,
-	[PERF_COUNT_HW_STALLED_CYCLES_FRONTEND]	= ARMV8_PMUV3_PERFCTR_STALL_FRONTEND,
-	[PERF_COUNT_HW_STALLED_CYCLES_BACKEND]	= ARMV8_PMUV3_PERFCTR_STALL_BACKEND,
-};
-
-static const unsigned armv8_pmuv3_perf_cache_map[PERF_COUNT_HW_CACHE_MAX]
-						[PERF_COUNT_HW_CACHE_OP_MAX]
-						[PERF_COUNT_HW_CACHE_RESULT_MAX] = {
-	PERF_CACHE_MAP_ALL_UNSUPPORTED,
-
-	[C(L1D)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
-	[C(L1D)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
-	[C(L1D)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
-	[C(L1D)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
-
-	[C(L1I)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE,
-	[C(L1I)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL,
-
-	[C(DTLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1D_TLB_REFILL,
-	[C(DTLB)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1D_TLB,
-
-	[C(ITLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL,
-	[C(ITLB)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB,
-
-	[C(BPU)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
-	[C(BPU)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-	[C(BPU)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
-	[C(BPU)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-};
-
-static const unsigned armv8_a53_perf_cache_map[PERF_COUNT_HW_CACHE_MAX]
-					      [PERF_COUNT_HW_CACHE_OP_MAX]
-					      [PERF_COUNT_HW_CACHE_RESULT_MAX] = {
-	PERF_CACHE_MAP_ALL_UNSUPPORTED,
-
-	[C(L1D)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
-	[C(L1D)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
-	[C(L1D)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
-	[C(L1D)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
-	[C(L1D)][C(OP_PREFETCH)][C(RESULT_MISS)] = ARMV8_A53_PERFCTR_PREF_LINEFILL,
-
-	[C(L1I)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE,
-	[C(L1I)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL,
-
-	[C(ITLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL,
-
-	[C(BPU)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
-	[C(BPU)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-	[C(BPU)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
-	[C(BPU)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-};
-
-static const unsigned armv8_a57_perf_cache_map[PERF_COUNT_HW_CACHE_MAX]
-					      [PERF_COUNT_HW_CACHE_OP_MAX]
-					      [PERF_COUNT_HW_CACHE_RESULT_MAX] = {
-	PERF_CACHE_MAP_ALL_UNSUPPORTED,
-
-	[C(L1D)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_RD,
-	[C(L1D)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_RD,
-	[C(L1D)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WR,
-	[C(L1D)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_WR,
-
-	[C(L1I)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE,
-	[C(L1I)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL,
-
-	[C(DTLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_RD,
-	[C(DTLB)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_WR,
-
-	[C(ITLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL,
-
-	[C(BPU)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
-	[C(BPU)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-	[C(BPU)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
-	[C(BPU)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-};
-
-static const unsigned armv8_thunder_perf_cache_map[PERF_COUNT_HW_CACHE_MAX]
-						   [PERF_COUNT_HW_CACHE_OP_MAX]
-						   [PERF_COUNT_HW_CACHE_RESULT_MAX] = {
-	PERF_CACHE_MAP_ALL_UNSUPPORTED,
-
-	[C(L1D)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_RD,
-	[C(L1D)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_RD,
-	[C(L1D)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WR,
-	[C(L1D)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_THUNDER_PERFCTR_L1D_CACHE_MISS_ST,
-	[C(L1D)][C(OP_PREFETCH)][C(RESULT_ACCESS)] = ARMV8_THUNDER_PERFCTR_L1D_CACHE_PREF_ACCESS,
-	[C(L1D)][C(OP_PREFETCH)][C(RESULT_MISS)] = ARMV8_THUNDER_PERFCTR_L1D_CACHE_PREF_MISS,
-
-	[C(L1I)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE,
-	[C(L1I)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL,
-	[C(L1I)][C(OP_PREFETCH)][C(RESULT_ACCESS)] = ARMV8_THUNDER_PERFCTR_L1I_CACHE_PREF_ACCESS,
-	[C(L1I)][C(OP_PREFETCH)][C(RESULT_MISS)] = ARMV8_THUNDER_PERFCTR_L1I_CACHE_PREF_MISS,
-
-	[C(DTLB)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_RD,
-	[C(DTLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_RD,
-	[C(DTLB)][C(OP_WRITE)][C(RESULT_ACCESS)] = ARMV8_IMPDEF_PERFCTR_L1D_TLB_WR,
-	[C(DTLB)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_WR,
-
-	[C(ITLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL,
-
-	[C(BPU)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
-	[C(BPU)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-	[C(BPU)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
-	[C(BPU)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-};
-
-static const unsigned armv8_vulcan_perf_cache_map[PERF_COUNT_HW_CACHE_MAX]
-					      [PERF_COUNT_HW_CACHE_OP_MAX]
-					      [PERF_COUNT_HW_CACHE_RESULT_MAX] = {
-	PERF_CACHE_MAP_ALL_UNSUPPORTED,
-
-	[C(L1D)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_RD,
-	[C(L1D)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_RD,
-	[C(L1D)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WR,
-	[C(L1D)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_WR,
-
-	[C(L1I)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE,
-	[C(L1I)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL,
-
-	[C(ITLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL,
-	[C(ITLB)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB,
-
-	[C(DTLB)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_RD,
-	[C(DTLB)][C(OP_WRITE)][C(RESULT_ACCESS)] = ARMV8_IMPDEF_PERFCTR_L1D_TLB_WR,
-	[C(DTLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_RD,
-	[C(DTLB)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_WR,
-
-	[C(BPU)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
-	[C(BPU)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-	[C(BPU)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
-	[C(BPU)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
-
-	[C(NODE)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_RD,
-	[C(NODE)][C(OP_WRITE)][C(RESULT_ACCESS)] = ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_WR,
-};
-
-static ssize_t
-armv8pmu_events_sysfs_show(struct device *dev,
-			   struct device_attribute *attr, char *page)
-{
-	struct perf_pmu_events_attr *pmu_attr;
-
-	pmu_attr = container_of(attr, struct perf_pmu_events_attr, attr);
-
-	return sprintf(page, "event=0x%03llx\n", pmu_attr->id);
-}
-
-#define ARMV8_EVENT_ATTR_RESOLVE(m) #m
-#define ARMV8_EVENT_ATTR(name, config) \
-	PMU_EVENT_ATTR(name, armv8_event_attr_##name, \
-		       config, armv8pmu_events_sysfs_show)
-
-ARMV8_EVENT_ATTR(sw_incr, ARMV8_PMUV3_PERFCTR_SW_INCR);
-ARMV8_EVENT_ATTR(l1i_cache_refill, ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL);
-ARMV8_EVENT_ATTR(l1i_tlb_refill, ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL);
-ARMV8_EVENT_ATTR(l1d_cache_refill, ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL);
-ARMV8_EVENT_ATTR(l1d_cache, ARMV8_PMUV3_PERFCTR_L1D_CACHE);
-ARMV8_EVENT_ATTR(l1d_tlb_refill, ARMV8_PMUV3_PERFCTR_L1D_TLB_REFILL);
-ARMV8_EVENT_ATTR(ld_retired, ARMV8_PMUV3_PERFCTR_LD_RETIRED);
-ARMV8_EVENT_ATTR(st_retired, ARMV8_PMUV3_PERFCTR_ST_RETIRED);
-ARMV8_EVENT_ATTR(inst_retired, ARMV8_PMUV3_PERFCTR_INST_RETIRED);
-ARMV8_EVENT_ATTR(exc_taken, ARMV8_PMUV3_PERFCTR_EXC_TAKEN);
-ARMV8_EVENT_ATTR(exc_return, ARMV8_PMUV3_PERFCTR_EXC_RETURN);
-ARMV8_EVENT_ATTR(cid_write_retired, ARMV8_PMUV3_PERFCTR_CID_WRITE_RETIRED);
-ARMV8_EVENT_ATTR(pc_write_retired, ARMV8_PMUV3_PERFCTR_PC_WRITE_RETIRED);
-ARMV8_EVENT_ATTR(br_immed_retired, ARMV8_PMUV3_PERFCTR_BR_IMMED_RETIRED);
-ARMV8_EVENT_ATTR(br_return_retired, ARMV8_PMUV3_PERFCTR_BR_RETURN_RETIRED);
-ARMV8_EVENT_ATTR(unaligned_ldst_retired, ARMV8_PMUV3_PERFCTR_UNALIGNED_LDST_RETIRED);
-ARMV8_EVENT_ATTR(br_mis_pred, ARMV8_PMUV3_PERFCTR_BR_MIS_PRED);
-ARMV8_EVENT_ATTR(cpu_cycles, ARMV8_PMUV3_PERFCTR_CPU_CYCLES);
-ARMV8_EVENT_ATTR(br_pred, ARMV8_PMUV3_PERFCTR_BR_PRED);
-ARMV8_EVENT_ATTR(mem_access, ARMV8_PMUV3_PERFCTR_MEM_ACCESS);
-ARMV8_EVENT_ATTR(l1i_cache, ARMV8_PMUV3_PERFCTR_L1I_CACHE);
-ARMV8_EVENT_ATTR(l1d_cache_wb, ARMV8_PMUV3_PERFCTR_L1D_CACHE_WB);
-ARMV8_EVENT_ATTR(l2d_cache, ARMV8_PMUV3_PERFCTR_L2D_CACHE);
-ARMV8_EVENT_ATTR(l2d_cache_refill, ARMV8_PMUV3_PERFCTR_L2D_CACHE_REFILL);
-ARMV8_EVENT_ATTR(l2d_cache_wb, ARMV8_PMUV3_PERFCTR_L2D_CACHE_WB);
-ARMV8_EVENT_ATTR(bus_access, ARMV8_PMUV3_PERFCTR_BUS_ACCESS);
-ARMV8_EVENT_ATTR(memory_error, ARMV8_PMUV3_PERFCTR_MEMORY_ERROR);
-ARMV8_EVENT_ATTR(inst_spec, ARMV8_PMUV3_PERFCTR_INST_SPEC);
-ARMV8_EVENT_ATTR(ttbr_write_retired, ARMV8_PMUV3_PERFCTR_TTBR_WRITE_RETIRED);
-ARMV8_EVENT_ATTR(bus_cycles, ARMV8_PMUV3_PERFCTR_BUS_CYCLES);
-/* Don't expose the chain event in /sys, since it's useless in isolation */
-ARMV8_EVENT_ATTR(l1d_cache_allocate, ARMV8_PMUV3_PERFCTR_L1D_CACHE_ALLOCATE);
-ARMV8_EVENT_ATTR(l2d_cache_allocate, ARMV8_PMUV3_PERFCTR_L2D_CACHE_ALLOCATE);
-ARMV8_EVENT_ATTR(br_retired, ARMV8_PMUV3_PERFCTR_BR_RETIRED);
-ARMV8_EVENT_ATTR(br_mis_pred_retired, ARMV8_PMUV3_PERFCTR_BR_MIS_PRED_RETIRED);
-ARMV8_EVENT_ATTR(stall_frontend, ARMV8_PMUV3_PERFCTR_STALL_FRONTEND);
-ARMV8_EVENT_ATTR(stall_backend, ARMV8_PMUV3_PERFCTR_STALL_BACKEND);
-ARMV8_EVENT_ATTR(l1d_tlb, ARMV8_PMUV3_PERFCTR_L1D_TLB);
-ARMV8_EVENT_ATTR(l1i_tlb, ARMV8_PMUV3_PERFCTR_L1I_TLB);
-ARMV8_EVENT_ATTR(l2i_cache, ARMV8_PMUV3_PERFCTR_L2I_CACHE);
-ARMV8_EVENT_ATTR(l2i_cache_refill, ARMV8_PMUV3_PERFCTR_L2I_CACHE_REFILL);
-ARMV8_EVENT_ATTR(l3d_cache_allocate, ARMV8_PMUV3_PERFCTR_L3D_CACHE_ALLOCATE);
-ARMV8_EVENT_ATTR(l3d_cache_refill, ARMV8_PMUV3_PERFCTR_L3D_CACHE_REFILL);
-ARMV8_EVENT_ATTR(l3d_cache, ARMV8_PMUV3_PERFCTR_L3D_CACHE);
-ARMV8_EVENT_ATTR(l3d_cache_wb, ARMV8_PMUV3_PERFCTR_L3D_CACHE_WB);
-ARMV8_EVENT_ATTR(l2d_tlb_refill, ARMV8_PMUV3_PERFCTR_L2D_TLB_REFILL);
-ARMV8_EVENT_ATTR(l2i_tlb_refill, ARMV8_PMUV3_PERFCTR_L2I_TLB_REFILL);
-ARMV8_EVENT_ATTR(l2d_tlb, ARMV8_PMUV3_PERFCTR_L2D_TLB);
-ARMV8_EVENT_ATTR(l2i_tlb, ARMV8_PMUV3_PERFCTR_L2I_TLB);
-
-static struct attribute *armv8_pmuv3_event_attrs[] = {
-	&armv8_event_attr_sw_incr.attr.attr,
-	&armv8_event_attr_l1i_cache_refill.attr.attr,
-	&armv8_event_attr_l1i_tlb_refill.attr.attr,
-	&armv8_event_attr_l1d_cache_refill.attr.attr,
-	&armv8_event_attr_l1d_cache.attr.attr,
-	&armv8_event_attr_l1d_tlb_refill.attr.attr,
-	&armv8_event_attr_ld_retired.attr.attr,
-	&armv8_event_attr_st_retired.attr.attr,
-	&armv8_event_attr_inst_retired.attr.attr,
-	&armv8_event_attr_exc_taken.attr.attr,
-	&armv8_event_attr_exc_return.attr.attr,
-	&armv8_event_attr_cid_write_retired.attr.attr,
-	&armv8_event_attr_pc_write_retired.attr.attr,
-	&armv8_event_attr_br_immed_retired.attr.attr,
-	&armv8_event_attr_br_return_retired.attr.attr,
-	&armv8_event_attr_unaligned_ldst_retired.attr.attr,
-	&armv8_event_attr_br_mis_pred.attr.attr,
-	&armv8_event_attr_cpu_cycles.attr.attr,
-	&armv8_event_attr_br_pred.attr.attr,
-	&armv8_event_attr_mem_access.attr.attr,
-	&armv8_event_attr_l1i_cache.attr.attr,
-	&armv8_event_attr_l1d_cache_wb.attr.attr,
-	&armv8_event_attr_l2d_cache.attr.attr,
-	&armv8_event_attr_l2d_cache_refill.attr.attr,
-	&armv8_event_attr_l2d_cache_wb.attr.attr,
-	&armv8_event_attr_bus_access.attr.attr,
-	&armv8_event_attr_memory_error.attr.attr,
-	&armv8_event_attr_inst_spec.attr.attr,
-	&armv8_event_attr_ttbr_write_retired.attr.attr,
-	&armv8_event_attr_bus_cycles.attr.attr,
-	&armv8_event_attr_l1d_cache_allocate.attr.attr,
-	&armv8_event_attr_l2d_cache_allocate.attr.attr,
-	&armv8_event_attr_br_retired.attr.attr,
-	&armv8_event_attr_br_mis_pred_retired.attr.attr,
-	&armv8_event_attr_stall_frontend.attr.attr,
-	&armv8_event_attr_stall_backend.attr.attr,
-	&armv8_event_attr_l1d_tlb.attr.attr,
-	&armv8_event_attr_l1i_tlb.attr.attr,
-	&armv8_event_attr_l2i_cache.attr.attr,
-	&armv8_event_attr_l2i_cache_refill.attr.attr,
-	&armv8_event_attr_l3d_cache_allocate.attr.attr,
-	&armv8_event_attr_l3d_cache_refill.attr.attr,
-	&armv8_event_attr_l3d_cache.attr.attr,
-	&armv8_event_attr_l3d_cache_wb.attr.attr,
-	&armv8_event_attr_l2d_tlb_refill.attr.attr,
-	&armv8_event_attr_l2i_tlb_refill.attr.attr,
-	&armv8_event_attr_l2d_tlb.attr.attr,
-	&armv8_event_attr_l2i_tlb.attr.attr,
-	NULL,
-};
-
-static umode_t
-armv8pmu_event_attr_is_visible(struct kobject *kobj,
-			       struct attribute *attr, int unused)
-{
-	struct device *dev = kobj_to_dev(kobj);
-	struct pmu *pmu = dev_get_drvdata(dev);
-	struct arm_pmu *cpu_pmu = container_of(pmu, struct arm_pmu, pmu);
-	struct perf_pmu_events_attr *pmu_attr;
-
-	pmu_attr = container_of(attr, struct perf_pmu_events_attr, attr.attr);
-
-	if (test_bit(pmu_attr->id, cpu_pmu->pmceid_bitmap))
-		return attr->mode;
-
-	return 0;
-}
-
-static struct attribute_group armv8_pmuv3_events_attr_group = {
-	.name = "events",
-	.attrs = armv8_pmuv3_event_attrs,
-	.is_visible = armv8pmu_event_attr_is_visible,
-};
-
-PMU_FORMAT_ATTR(event, "config:0-9");
-
-static struct attribute *armv8_pmuv3_format_attrs[] = {
-	&format_attr_event.attr,
-	NULL,
-};
-
-static struct attribute_group armv8_pmuv3_format_attr_group = {
-	.name = "format",
-	.attrs = armv8_pmuv3_format_attrs,
-};
-
-/*
- * Perf Events' indices
- */
-#define	ARMV8_IDX_CYCLE_COUNTER	0
-#define	ARMV8_IDX_COUNTER0	1
-#define	ARMV8_IDX_COUNTER_LAST(cpu_pmu) \
-	(ARMV8_IDX_CYCLE_COUNTER + cpu_pmu->num_events - 1)
-
-/*
- * ARMv8 low level PMU access
- */
-
-/*
- * Perf Event to low level counters mapping
- */
-#define	ARMV8_IDX_TO_COUNTER(x)	\
-	(((x) - ARMV8_IDX_COUNTER0) & ARMV8_PMU_COUNTER_MASK)
-
-static inline u32 armv8pmu_pmcr_read(void)
-{
-	return read_sysreg(pmcr_el0);
-}
-
-static inline void armv8pmu_pmcr_write(u32 val)
-{
-	val &= ARMV8_PMU_PMCR_MASK;
-	isb();
-	write_sysreg(val, pmcr_el0);
-}
-
-static inline int armv8pmu_has_overflowed(u32 pmovsr)
-{
-	return pmovsr & ARMV8_PMU_OVERFLOWED_MASK;
-}
-
-static inline int armv8pmu_counter_valid(struct arm_pmu *cpu_pmu, int idx)
-{
-	return idx >= ARMV8_IDX_CYCLE_COUNTER &&
-		idx <= ARMV8_IDX_COUNTER_LAST(cpu_pmu);
-}
-
-static inline int armv8pmu_counter_has_overflowed(u32 pmnc, int idx)
-{
-	return pmnc & BIT(ARMV8_IDX_TO_COUNTER(idx));
-}
-
-static inline int armv8pmu_select_counter(int idx)
-{
-	u32 counter = ARMV8_IDX_TO_COUNTER(idx);
-	write_sysreg(counter, pmselr_el0);
-	isb();
-
-	return idx;
-}
-
-static inline u32 armv8pmu_read_counter(struct perf_event *event)
-{
-	struct arm_pmu *cpu_pmu = to_arm_pmu(event->pmu);
-	struct hw_perf_event *hwc = &event->hw;
-	int idx = hwc->idx;
-	u32 value = 0;
-
-	if (!armv8pmu_counter_valid(cpu_pmu, idx))
-		pr_err("CPU%u reading wrong counter %d\n",
-			smp_processor_id(), idx);
-	else if (idx == ARMV8_IDX_CYCLE_COUNTER)
-		value = read_sysreg(pmccntr_el0);
-	else if (armv8pmu_select_counter(idx) == idx)
-		value = read_sysreg(pmxevcntr_el0);
-
-	return value;
-}
-
-static inline void armv8pmu_write_counter(struct perf_event *event, u32 value)
-{
-	struct arm_pmu *cpu_pmu = to_arm_pmu(event->pmu);
-	struct hw_perf_event *hwc = &event->hw;
-	int idx = hwc->idx;
-
-	if (!armv8pmu_counter_valid(cpu_pmu, idx))
-		pr_err("CPU%u writing wrong counter %d\n",
-			smp_processor_id(), idx);
-	else if (idx == ARMV8_IDX_CYCLE_COUNTER) {
-		/*
-		 * Set the upper 32bits as this is a 64bit counter but we only
-		 * count using the lower 32bits and we want an interrupt when
-		 * it overflows.
-		 */
-		u64 value64 = 0xffffffff00000000ULL | value;
-
-		write_sysreg(value64, pmccntr_el0);
-	} else if (armv8pmu_select_counter(idx) == idx)
-		write_sysreg(value, pmxevcntr_el0);
-}
-
-static inline void armv8pmu_write_evtype(int idx, u32 val)
-{
-	if (armv8pmu_select_counter(idx) == idx) {
-		val &= ARMV8_PMU_EVTYPE_MASK;
-		write_sysreg(val, pmxevtyper_el0);
-	}
-}
-
-static inline int armv8pmu_enable_counter(int idx)
-{
-	u32 counter = ARMV8_IDX_TO_COUNTER(idx);
-	write_sysreg(BIT(counter), pmcntenset_el0);
-	return idx;
-}
-
-static inline int armv8pmu_disable_counter(int idx)
-{
-	u32 counter = ARMV8_IDX_TO_COUNTER(idx);
-	write_sysreg(BIT(counter), pmcntenclr_el0);
-	return idx;
-}
-
-static inline int armv8pmu_enable_intens(int idx)
-{
-	u32 counter = ARMV8_IDX_TO_COUNTER(idx);
-	write_sysreg(BIT(counter), pmintenset_el1);
-	return idx;
-}
-
-static inline int armv8pmu_disable_intens(int idx)
-{
-	u32 counter = ARMV8_IDX_TO_COUNTER(idx);
-	write_sysreg(BIT(counter), pmintenclr_el1);
-	isb();
-	/* Clear the overflow flag in case an interrupt is pending. */
-	write_sysreg(BIT(counter), pmovsclr_el0);
-	isb();
-
-	return idx;
-}
-
-static inline u32 armv8pmu_getreset_flags(void)
-{
-	u32 value;
-
-	/* Read */
-	value = read_sysreg(pmovsclr_el0);
-
-	/* Write to clear flags */
-	value &= ARMV8_PMU_OVSR_MASK;
-	write_sysreg(value, pmovsclr_el0);
-
-	return value;
-}
-
-static void armv8pmu_enable_event(struct perf_event *event)
-{
-	unsigned long flags;
-	struct hw_perf_event *hwc = &event->hw;
-	struct arm_pmu *cpu_pmu = to_arm_pmu(event->pmu);
-	struct pmu_hw_events *events = this_cpu_ptr(cpu_pmu->hw_events);
-	int idx = hwc->idx;
-
-	/*
-	 * Enable counter and interrupt, and set the counter to count
-	 * the event that we're interested in.
-	 */
-	raw_spin_lock_irqsave(&events->pmu_lock, flags);
-
-	/*
-	 * Disable counter
-	 */
-	armv8pmu_disable_counter(idx);
-
-	/*
-	 * Set event (if destined for PMNx counters).
-	 */
-	armv8pmu_write_evtype(idx, hwc->config_base);
-
-	/*
-	 * Enable interrupt for this counter
-	 */
-	armv8pmu_enable_intens(idx);
-
-	/*
-	 * Enable counter
-	 */
-	armv8pmu_enable_counter(idx);
-
-	raw_spin_unlock_irqrestore(&events->pmu_lock, flags);
-}
-
-static void armv8pmu_disable_event(struct perf_event *event)
-{
-	unsigned long flags;
-	struct hw_perf_event *hwc = &event->hw;
-	struct arm_pmu *cpu_pmu = to_arm_pmu(event->pmu);
-	struct pmu_hw_events *events = this_cpu_ptr(cpu_pmu->hw_events);
-	int idx = hwc->idx;
-
-	/*
-	 * Disable counter and interrupt
-	 */
-	raw_spin_lock_irqsave(&events->pmu_lock, flags);
-
-	/*
-	 * Disable counter
-	 */
-	armv8pmu_disable_counter(idx);
-
-	/*
-	 * Disable interrupt for this counter
-	 */
-	armv8pmu_disable_intens(idx);
-
-	raw_spin_unlock_irqrestore(&events->pmu_lock, flags);
-}
-
-static irqreturn_t armv8pmu_handle_irq(int irq_num, void *dev)
-{
-	u32 pmovsr;
-	struct perf_sample_data data;
-	struct arm_pmu *cpu_pmu = (struct arm_pmu *)dev;
-	struct pmu_hw_events *cpuc = this_cpu_ptr(cpu_pmu->hw_events);
-	struct pt_regs *regs;
-	int idx;
-
-	/*
-	 * Get and reset the IRQ flags
-	 */
-	pmovsr = armv8pmu_getreset_flags();
-
-	/*
-	 * Did an overflow occur?
-	 */
-	if (!armv8pmu_has_overflowed(pmovsr))
-		return IRQ_NONE;
-
-	/*
-	 * Handle the counter(s) overflow(s)
-	 */
-	regs = get_irq_regs();
-
-	for (idx = 0; idx < cpu_pmu->num_events; ++idx) {
-		struct perf_event *event = cpuc->events[idx];
-		struct hw_perf_event *hwc;
-
-		/* Ignore if we don't have an event. */
-		if (!event)
-			continue;
-
-		/*
-		 * We have a single interrupt for all counters. Check that
-		 * each counter has overflowed before we process it.
-		 */
-		if (!armv8pmu_counter_has_overflowed(pmovsr, idx))
-			continue;
-
-		hwc = &event->hw;
-		armpmu_event_update(event);
-		perf_sample_data_init(&data, 0, hwc->last_period);
-		if (!armpmu_event_set_period(event))
-			continue;
-
-		if (perf_event_overflow(event, &data, regs))
-			cpu_pmu->disable(event);
-	}
-
-	/*
-	 * Handle the pending perf events.
-	 *
-	 * Note: this call *must* be run with interrupts disabled. For
-	 * platforms that can have the PMU interrupts raised as an NMI, this
-	 * will not work.
-	 */
-	irq_work_run();
-
-	return IRQ_HANDLED;
-}
-
-static void armv8pmu_start(struct arm_pmu *cpu_pmu)
-{
-	unsigned long flags;
-	struct pmu_hw_events *events = this_cpu_ptr(cpu_pmu->hw_events);
-
-	raw_spin_lock_irqsave(&events->pmu_lock, flags);
-	/* Enable all counters */
-	armv8pmu_pmcr_write(armv8pmu_pmcr_read() | ARMV8_PMU_PMCR_E);
-	raw_spin_unlock_irqrestore(&events->pmu_lock, flags);
-}
-
-static void armv8pmu_stop(struct arm_pmu *cpu_pmu)
-{
-	unsigned long flags;
-	struct pmu_hw_events *events = this_cpu_ptr(cpu_pmu->hw_events);
-
-	raw_spin_lock_irqsave(&events->pmu_lock, flags);
-	/* Disable all counters */
-	armv8pmu_pmcr_write(armv8pmu_pmcr_read() & ~ARMV8_PMU_PMCR_E);
-	raw_spin_unlock_irqrestore(&events->pmu_lock, flags);
-}
-
-static int armv8pmu_get_event_idx(struct pmu_hw_events *cpuc,
-				  struct perf_event *event)
-{
-	int idx;
-	struct arm_pmu *cpu_pmu = to_arm_pmu(event->pmu);
-	struct hw_perf_event *hwc = &event->hw;
-	unsigned long evtype = hwc->config_base & ARMV8_PMU_EVTYPE_EVENT;
-
-	/* Always place a cycle counter into the cycle counter. */
-	if (evtype == ARMV8_PMUV3_PERFCTR_CPU_CYCLES) {
-		if (test_and_set_bit(ARMV8_IDX_CYCLE_COUNTER, cpuc->used_mask))
-			return -EAGAIN;
-
-		return ARMV8_IDX_CYCLE_COUNTER;
-	}
-
-	/*
-	 * For anything other than a cycle counter, try and use
-	 * the events counters
-	 */
-	for (idx = ARMV8_IDX_COUNTER0; idx < cpu_pmu->num_events; ++idx) {
-		if (!test_and_set_bit(idx, cpuc->used_mask))
-			return idx;
-	}
-
-	/* The counters are all in use. */
-	return -EAGAIN;
-}
-
-/*
- * Add an event filter to a given event. This will only work for PMUv2 PMUs.
- */
-static int armv8pmu_set_event_filter(struct hw_perf_event *event,
-				     struct perf_event_attr *attr)
-{
-	unsigned long config_base = 0;
-
-	if (attr->exclude_idle)
-		return -EPERM;
-
-	/*
-	 * If we're running in hyp mode, then we *are* the hypervisor.
-	 * Therefore we ignore exclude_hv in this configuration, since
-	 * there's no hypervisor to sample anyway. This is consistent
-	 * with other architectures (x86 and Power).
-	 */
-	if (is_kernel_in_hyp_mode()) {
-		if (!attr->exclude_kernel)
-			config_base |= ARMV8_PMU_INCLUDE_EL2;
-	} else {
-		if (attr->exclude_kernel)
-			config_base |= ARMV8_PMU_EXCLUDE_EL1;
-		if (!attr->exclude_hv)
-			config_base |= ARMV8_PMU_INCLUDE_EL2;
-	}
-	if (attr->exclude_user)
-		config_base |= ARMV8_PMU_EXCLUDE_EL0;
-
-	/*
-	 * Install the filter into config_base as this is used to
-	 * construct the event type.
-	 */
-	event->config_base = config_base;
-
-	return 0;
-}
-
-static void armv8pmu_reset(void *info)
-{
-	struct arm_pmu *cpu_pmu = (struct arm_pmu *)info;
-	u32 idx, nb_cnt = cpu_pmu->num_events;
-
-	/* The counter and interrupt enable registers are unknown at reset. */
-	for (idx = ARMV8_IDX_CYCLE_COUNTER; idx < nb_cnt; ++idx) {
-		armv8pmu_disable_counter(idx);
-		armv8pmu_disable_intens(idx);
-	}
-
-	/*
-	 * Initialize & Reset PMNC. Request overflow interrupt for
-	 * 64 bit cycle counter but cheat in armv8pmu_write_counter().
-	 */
-	armv8pmu_pmcr_write(ARMV8_PMU_PMCR_P | ARMV8_PMU_PMCR_C |
-			    ARMV8_PMU_PMCR_LC);
-}
-
-static int armv8_pmuv3_map_event(struct perf_event *event)
-{
-	int hw_event_id;
-	struct arm_pmu *armpmu = to_arm_pmu(event->pmu);
-
-	hw_event_id = armpmu_map_event(event, &armv8_pmuv3_perf_map,
-				       &armv8_pmuv3_perf_cache_map,
-				       ARMV8_PMU_EVTYPE_EVENT);
-	if (hw_event_id < 0)
-		return hw_event_id;
-
-	/* disable micro/arch events not supported by this PMU */
-	if ((hw_event_id < ARMV8_PMUV3_MAX_COMMON_EVENTS) &&
-		!test_bit(hw_event_id, armpmu->pmceid_bitmap)) {
-			return -EOPNOTSUPP;
-	}
-
-	return hw_event_id;
-}
-
-static int armv8_a53_map_event(struct perf_event *event)
-{
-	return armpmu_map_event(event, &armv8_a53_perf_map,
-				&armv8_a53_perf_cache_map,
-				ARMV8_PMU_EVTYPE_EVENT);
-}
-
-static int armv8_a57_map_event(struct perf_event *event)
-{
-	return armpmu_map_event(event, &armv8_a57_perf_map,
-				&armv8_a57_perf_cache_map,
-				ARMV8_PMU_EVTYPE_EVENT);
-}
-
-static int armv8_thunder_map_event(struct perf_event *event)
-{
-	return armpmu_map_event(event, &armv8_thunder_perf_map,
-				&armv8_thunder_perf_cache_map,
-				ARMV8_PMU_EVTYPE_EVENT);
-}
-
-static int armv8_vulcan_map_event(struct perf_event *event)
-{
-	return armpmu_map_event(event, &armv8_vulcan_perf_map,
-				&armv8_vulcan_perf_cache_map,
-				ARMV8_PMU_EVTYPE_EVENT);
-}
-
-static void __armv8pmu_probe_pmu(void *info)
-{
-	struct arm_pmu *cpu_pmu = info;
-	u32 pmceid[2];
-
-	/* Read the nb of CNTx counters supported from PMNC */
-	cpu_pmu->num_events = (armv8pmu_pmcr_read() >> ARMV8_PMU_PMCR_N_SHIFT)
-		& ARMV8_PMU_PMCR_N_MASK;
-
-	/* Add the CPU cycles counter */
-	cpu_pmu->num_events += 1;
-
-	pmceid[0] = read_sysreg(pmceid0_el0);
-	pmceid[1] = read_sysreg(pmceid1_el0);
-
-	bitmap_from_u32array(cpu_pmu->pmceid_bitmap,
-			     ARMV8_PMUV3_MAX_COMMON_EVENTS, pmceid,
-			     ARRAY_SIZE(pmceid));
-}
-
-static int armv8pmu_probe_pmu(struct arm_pmu *cpu_pmu)
-{
-	return smp_call_function_any(&cpu_pmu->supported_cpus,
-				    __armv8pmu_probe_pmu,
-				    cpu_pmu, 1);
-}
-
-static void armv8_pmu_init(struct arm_pmu *cpu_pmu)
-{
-	cpu_pmu->handle_irq		= armv8pmu_handle_irq,
-	cpu_pmu->enable			= armv8pmu_enable_event,
-	cpu_pmu->disable		= armv8pmu_disable_event,
-	cpu_pmu->read_counter		= armv8pmu_read_counter,
-	cpu_pmu->write_counter		= armv8pmu_write_counter,
-	cpu_pmu->get_event_idx		= armv8pmu_get_event_idx,
-	cpu_pmu->start			= armv8pmu_start,
-	cpu_pmu->stop			= armv8pmu_stop,
-	cpu_pmu->reset			= armv8pmu_reset,
-	cpu_pmu->max_period		= (1LLU << 32) - 1,
-	cpu_pmu->set_event_filter	= armv8pmu_set_event_filter;
-}
-
-static int armv8_pmuv3_init(struct arm_pmu *cpu_pmu)
-{
-	armv8_pmu_init(cpu_pmu);
-	cpu_pmu->name			= "armv8_pmuv3";
-	cpu_pmu->map_event		= armv8_pmuv3_map_event;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
-		&armv8_pmuv3_events_attr_group;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
-		&armv8_pmuv3_format_attr_group;
-	return armv8pmu_probe_pmu(cpu_pmu);
-}
-
-static int armv8_a53_pmu_init(struct arm_pmu *cpu_pmu)
-{
-	armv8_pmu_init(cpu_pmu);
-	cpu_pmu->name			= "armv8_cortex_a53";
-	cpu_pmu->map_event		= armv8_a53_map_event;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
-		&armv8_pmuv3_events_attr_group;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
-		&armv8_pmuv3_format_attr_group;
-	return armv8pmu_probe_pmu(cpu_pmu);
-}
-
-static int armv8_a57_pmu_init(struct arm_pmu *cpu_pmu)
-{
-	armv8_pmu_init(cpu_pmu);
-	cpu_pmu->name			= "armv8_cortex_a57";
-	cpu_pmu->map_event		= armv8_a57_map_event;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
-		&armv8_pmuv3_events_attr_group;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
-		&armv8_pmuv3_format_attr_group;
-	return armv8pmu_probe_pmu(cpu_pmu);
-}
-
-static int armv8_a72_pmu_init(struct arm_pmu *cpu_pmu)
-{
-	armv8_pmu_init(cpu_pmu);
-	cpu_pmu->name			= "armv8_cortex_a72";
-	cpu_pmu->map_event		= armv8_a57_map_event;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
-		&armv8_pmuv3_events_attr_group;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
-		&armv8_pmuv3_format_attr_group;
-	return armv8pmu_probe_pmu(cpu_pmu);
-}
-
-static int armv8_thunder_pmu_init(struct arm_pmu *cpu_pmu)
-{
-	armv8_pmu_init(cpu_pmu);
-	cpu_pmu->name			= "armv8_cavium_thunder";
-	cpu_pmu->map_event		= armv8_thunder_map_event;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
-		&armv8_pmuv3_events_attr_group;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
-		&armv8_pmuv3_format_attr_group;
-	return armv8pmu_probe_pmu(cpu_pmu);
-}
-
-static int armv8_vulcan_pmu_init(struct arm_pmu *cpu_pmu)
-{
-	armv8_pmu_init(cpu_pmu);
-	cpu_pmu->name			= "armv8_brcm_vulcan";
-	cpu_pmu->map_event		= armv8_vulcan_map_event;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
-		&armv8_pmuv3_events_attr_group;
-	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
-		&armv8_pmuv3_format_attr_group;
-	return armv8pmu_probe_pmu(cpu_pmu);
-}
-
-static const struct of_device_id armv8_pmu_of_device_ids[] = {
-	{.compatible = "arm,armv8-pmuv3",	.data = armv8_pmuv3_init},
-	{.compatible = "arm,cortex-a53-pmu",	.data = armv8_a53_pmu_init},
-	{.compatible = "arm,cortex-a57-pmu",	.data = armv8_a57_pmu_init},
-	{.compatible = "arm,cortex-a72-pmu",	.data = armv8_a72_pmu_init},
-	{.compatible = "cavium,thunder-pmu",	.data = armv8_thunder_pmu_init},
-	{.compatible = "brcm,vulcan-pmu",	.data = armv8_vulcan_pmu_init},
-	{},
-};
-
-/*
- * Non DT systems have their micro/arch events probed at run-time.
- * A fairly complete list of generic events are provided and ones that
- * aren't supported by the current PMU are disabled.
- */
-static const struct pmu_probe_info armv8_pmu_probe_table[] = {
-	PMU_PROBE(0, 0, armv8_pmuv3_init), /* enable all defined counters */
-	{ /* sentinel value */ }
-};
-
-static int armv8_pmu_device_probe(struct platform_device *pdev)
-{
-	if (acpi_disabled)
-		return arm_pmu_device_probe(pdev, armv8_pmu_of_device_ids,
-					    NULL);
-
-	return arm_pmu_device_probe(pdev, armv8_pmu_of_device_ids,
-				    armv8_pmu_probe_table);
-}
-
-static struct platform_driver armv8_pmu_driver = {
-	.driver		= {
-		.name	= ARMV8_PMU_PDEV_NAME,
-		.of_match_table = armv8_pmu_of_device_ids,
-	},
-	.probe		= armv8_pmu_device_probe,
-};
-
-builtin_platform_driver(armv8_pmu_driver);
diff --git a/arch/arm64/kernel/pre_gic_init.S b/arch/arm64/kernel/pre_gic_init.S
new file mode 100644
index 00000000..b6bd103
--- /dev/null
+++ b/arch/arm64/kernel/pre_gic_init.S
@@ -0,0 +1,141 @@
+#include <linux/linkage.h>
+#include <linux/init.h>
+#include <linux/irqchip/arm-gic-v3.h>
+
+#include <asm/assembler.h>
+#include <asm/boot.h>
+#include <asm/asm-offsets.h>
+#include <asm/cache.h>
+#include <asm/cputype.h>
+#include <asm/sysreg.h>
+#include <asm/virt.h>
+
+#ifdef CONFIG_ARCH_RTD16xx
+
+#define GICD_BASE 0xFF100000
+#define GICD_IROUTERn_BASE 0xFF106000
+#define CPUID 0
+#define GICR_RD_BASE 0xFF140000
+#define GICR_SGI_BASE 0xFF150000
+#define GICD_IROUTER_VALUE CPUID << 8
+#define OFFISE_84 0x84
+
+ENTRY(gicv3_pre_init)
+	ldr	x0, =GICD_BASE
+
+	/* Disable GICD_CTLR */
+	mov	w1, #0x0
+	str	w1, [x0]
+
+	/* Set ID0 to non scure (group1) GICD_IGROUPRn  0x084~0x08C */
+	ldr	w1, =0xFFFFFFFF
+	str	w1, [x0, 0x084]
+	str	w1, [x0, 0x088]
+	str	w1, [x0, 0x08C]
+
+	/* Enable ICDD_CTLR */
+	mov	w1, #0x37
+	str	w1, [x0]
+
+	/* Enable redistributor power on */
+	ldr	x0, =GICR_RD_BASE
+	mov	w1, #0x00
+	str	w1, [x0, 0x24]
+
+	/* Wake up redistributor: kick ProcessorSleep and wait for ChildrenAsleep to be 0 */
+	ldr	w1, [x0, 0x14]
+	mov w2, #0xFFFFFFFD
+	and	x1, x1, x2
+	str	w1, [x0, 0x14]
+	dsb	st
+	isb
+
+	/* Read the GICR_WAKER */
+1:
+	ldr	w1, [x0, 0x14]
+	mov	x4, #0x4
+
+	/* Read the ChildrenAsleep, bit [2] */
+	and	x1, x1, x4
+	cmp	x1, #0x0
+	bne	1b
+
+	/* Setup redistributor SGI base GICR_IGROUP0 */
+	ldr	x0, =GICR_SGI_BASE
+	mov w1, #0xFFFFFFFF
+	str	w1, [x0, 0x80]
+
+	/* Setup redistributor SGI base GICR_IGRPMOD0 */
+	mov w1, #0x0
+	str	w1, [x0, 0xD00]
+
+	/* Setup distributor GICR_IGROUP0 */
+	ldr	x0, =GICD_BASE
+	mov w1, #0xFFFFFFFF
+	str	w1, [x0, 0x80]
+
+	/* Setup distributor GICR_IGROUP0 */
+	mov w1, #0x0
+	str	w1, [x0, 0xD00]
+
+	/* Setup CPU system register ICC_SRE_EL3*/
+	mrs	x1, S3_6_C12_C12_5
+	mov	x2, #0x9 /* SRE bit0, Enable bit 3 */
+	orr x1,x1,x2
+	msr	S3_6_C12_C12_5, x1
+	isb
+
+	/* Setup CPU system register ICC_CTLR_EL3 */
+	mov	x2, #0x0
+	msr	S3_6_C12_C12_4, x2
+	isb
+
+	ret
+ENDPROC(gicv3_pre_init)
+#endif /* CONFIG_ARCH_RTD16xx */
+
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD139x)
+
+#define GICD_BASE 0xFF011000
+#define GICC_BASE 0xFF012000
+
+ENTRY(gic_init_secure)
+	mov	w9, #0x3		/* EnableGrp0 | EnableGrp1 */
+	str	w9, [x0, 0x000]	/* Secure GICD_CTLR */
+	ldr	w9, [x0, 0x004]
+	and	w10, w9, #0x1f	/* ITLinesNumber */
+	cbz	w10, 1f		/* No SPIs */
+	add	w10, w10, #0x1	/* Also add SGI/PPI to the counter */
+	add	x11, x0, (0x080)
+	mov	w9, #~0		/* Config SGI/PPI/SPIs as Grp1 */
+0:
+	str	w9, [x11], #0x4
+	sub	w10, w10, #0x1
+	cbnz	w10, 0b
+1:
+	ret
+ENDPROC(gic_init_secure)
+
+ENTRY(gic_init_secure_percpu)
+	mov	w9, #~0		/* Config SGIs and PPIs as Grp1 */
+	str	w9, [x0, 0x080]	/* GICD_IGROUPR0 */
+	mov	w9, #0x1		/* Enable SGI 0 */
+	str	w9, [x0, 0x100]
+					/* Initialize Cpu Interface */
+	mov	w9, #0x1e7		/* Disable IRQ/FIQ Bypass & */
+					/* Enable Ack Group1 Interrupt & */
+					/* EnableGrp0 & EnableGrp1 */
+	str	w9, [x1, 0x000]	/* Secure GICC_CTLR */
+	mov	w9, #0xf8		/* Non-Secure access to GICC_PMR */
+	str	w9, [x1, 0x004]
+	ret
+ENDPROC(gic_init_secure_percpu)
+
+ENTRY(gic_pre_init)
+	ldr	x0, =GICD_BASE
+	bl	gic_init_secure
+	ldr	x0, =GICD_BASE
+	ldr	x1, =GICC_BASE
+	bl	gic_init_secure_percpu
+ENDPROC(gic_pre_init)
+#endif /* defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD139x) */
diff --git a/arch/arm64/kernel/process.c b/arch/arm64/kernel/process.c
index e917d11..dd6fa0d 100644
--- a/arch/arm64/kernel/process.c
+++ b/arch/arm64/kernel/process.c
@@ -45,6 +45,7 @@
 #include <linux/personality.h>
 #include <linux/notifier.h>
 #include <trace/events/power.h>
+#include <linux/percpu.h>
 
 #include <asm/alternative.h>
 #include <asm/compat.h>
@@ -55,6 +56,10 @@
 #include <asm/processor.h>
 #include <asm/stacktrace.h>
 
+#ifdef CONFIG_RTK_TRACER
+#include <linux/rtk_trace.h>
+#endif
+
 #ifdef CONFIG_CC_STACKPROTECTOR
 #include <linux/stackprotector.h>
 unsigned long __stack_chk_guard __read_mostly;
@@ -166,6 +171,70 @@ void machine_restart(char *cmd)
 	while (1);
 }
 
+/*
+ * dump a block of kernel memory from around the given address
+ */
+static void show_data(unsigned long addr, int nbytes, const char *name)
+{
+	int	i, j;
+	int	nlines;
+	u32	*p;
+
+	/*
+	 * don't attempt to dump non-kernel addresses or
+	 * values that are probably just small negative numbers
+	 */
+	if (addr < PAGE_OFFSET || addr > -256UL)
+		return;
+
+	printk("\n%s: %#lx:\n", name, addr);
+
+	/*
+	 * round address down to a 32 bit boundary
+	 * and always dump a multiple of 32 bytes
+	 */
+	p = (u32 *)(addr & ~(sizeof(u32) - 1));
+	nbytes += (addr & (sizeof(u32) - 1));
+	nlines = (nbytes + 31) / 32;
+
+
+	for (i = 0; i < nlines; i++) {
+		/*
+		 * just display low 16 bits of address to keep
+		 * each line of the dump < 80 characters
+		 */
+		printk("%04lx ", (unsigned long)p & 0xffff);
+		for (j = 0; j < 8; j++) {
+			u32	data;
+			if (probe_kernel_address(p, data)) {
+				pr_cont(" ********");
+			} else {
+				pr_cont(" %08x", data);
+			}
+			++p;
+		}
+		pr_cont("\n");
+	}
+}
+
+static void show_extra_register_data(struct pt_regs *regs, int nbytes)
+{
+	mm_segment_t fs;
+	unsigned int i;
+
+	fs = get_fs();
+	set_fs(KERNEL_DS);
+	show_data(regs->pc - nbytes, nbytes * 2, "PC");
+	show_data(regs->regs[30] - nbytes, nbytes * 2, "LR");
+	show_data(regs->sp - nbytes, nbytes * 2, "SP");
+	for (i = 0; i < 30; i++) {
+		char name[4];
+		snprintf(name, sizeof(name), "X%u", i);
+		show_data(regs->regs[i] - nbytes, nbytes * 2, name);
+	}
+	set_fs(fs);
+}
+
 void __show_regs(struct pt_regs *regs)
 {
 	int i, top_reg;
@@ -201,6 +270,8 @@ void __show_regs(struct pt_regs *regs)
 
 		pr_cont("\n");
 	}
+	if (!user_mode(regs))
+		show_extra_register_data(regs, 128);
 	printk("\n");
 }
 
@@ -331,6 +402,20 @@ void uao_thread_switch(struct task_struct *next)
 }
 
 /*
+ * We store our current task in sp_el0, which is clobbered by userspace. Keep a
+ * shadow copy so that we can restore this upon entry from userspace.
+ *
+ * This is *only* for exception entry from EL0, and is not valid until we
+ * __switch_to() a user task.
+ */
+DEFINE_PER_CPU(struct task_struct *, __entry_task);
+
+static void entry_task_switch(struct task_struct *next)
+{
+	__this_cpu_write(__entry_task, next);
+}
+
+/*
  * Thread switching.
  */
 struct task_struct *__switch_to(struct task_struct *prev,
@@ -342,7 +427,11 @@ struct task_struct *__switch_to(struct task_struct *prev,
 	tls_thread_switch(next);
 	hw_breakpoint_thread_switch(next);
 	contextidr_thread_switch(next);
+	entry_task_switch(next);
 	uao_thread_switch(next);
+#ifdef CONFIG_RTK_TRACER
+	uncached_logk_pc(LOGK_CTXID, (void*)sched_clock(), (void*)(uint64_t)task_pid_nr(next));
+#endif
 
 	/*
 	 * Complete any pending TLB or cache maintenance on this CPU in case
@@ -359,27 +448,35 @@ struct task_struct *__switch_to(struct task_struct *prev,
 unsigned long get_wchan(struct task_struct *p)
 {
 	struct stackframe frame;
-	unsigned long stack_page;
+	unsigned long stack_page, ret = 0;
 	int count = 0;
 	if (!p || p == current || p->state == TASK_RUNNING)
 		return 0;
 
+	stack_page = (unsigned long)try_get_task_stack(p);
+	if (!stack_page)
+		return 0;
+
 	frame.fp = thread_saved_fp(p);
 	frame.sp = thread_saved_sp(p);
 	frame.pc = thread_saved_pc(p);
 #ifdef CONFIG_FUNCTION_GRAPH_TRACER
 	frame.graph = p->curr_ret_stack;
 #endif
-	stack_page = (unsigned long)task_stack_page(p);
 	do {
 		if (frame.sp < stack_page ||
 		    frame.sp >= stack_page + THREAD_SIZE ||
 		    unwind_frame(p, &frame))
-			return 0;
-		if (!in_sched_functions(frame.pc))
-			return frame.pc;
+			goto out;
+		if (!in_sched_functions(frame.pc)) {
+			ret = frame.pc;
+			goto out;
+		}
 	} while (count ++ < 16);
-	return 0;
+
+out:
+	put_task_stack(p);
+	return ret;
 }
 
 unsigned long arch_align_stack(unsigned long sp)
diff --git a/arch/arm64/kernel/psci.c b/arch/arm64/kernel/psci.c
index 42816be..e8edbf1 100644
--- a/arch/arm64/kernel/psci.c
+++ b/arch/arm64/kernel/psci.c
@@ -20,6 +20,7 @@
 #include <linux/smp.h>
 #include <linux/delay.h>
 #include <linux/psci.h>
+#include <linux/mm.h>
 
 #include <uapi/linux/psci.h>
 
@@ -45,7 +46,7 @@ static int __init cpu_psci_cpu_prepare(unsigned int cpu)
 
 static int cpu_psci_cpu_boot(unsigned int cpu)
 {
-	int err = psci_ops.cpu_on(cpu_logical_map(cpu), __pa(secondary_entry));
+	int err = psci_ops.cpu_on(cpu_logical_map(cpu), __pa_symbol(secondary_entry));
 	if (err)
 		pr_err("failed to boot CPU%d (%d)\n", cpu, err);
 
diff --git a/arch/arm64/kernel/ptrace.c b/arch/arm64/kernel/ptrace.c
index 8eedeef..a22161c 100644
--- a/arch/arm64/kernel/ptrace.c
+++ b/arch/arm64/kernel/ptrace.c
@@ -327,13 +327,13 @@ static int ptrace_hbp_fill_attr_ctrl(unsigned int note_type,
 				     struct arch_hw_breakpoint_ctrl ctrl,
 				     struct perf_event_attr *attr)
 {
-	int err, len, type, disabled = !ctrl.enabled;
+	int err, len, type, offset, disabled = !ctrl.enabled;
 
 	attr->disabled = disabled;
 	if (disabled)
 		return 0;
 
-	err = arch_bp_generic_fields(ctrl, &len, &type);
+	err = arch_bp_generic_fields(ctrl, &len, &type, &offset);
 	if (err)
 		return err;
 
@@ -352,6 +352,7 @@ static int ptrace_hbp_fill_attr_ctrl(unsigned int note_type,
 
 	attr->bp_len	= len;
 	attr->bp_type	= type;
+	attr->bp_addr	+= offset;
 
 	return 0;
 }
@@ -404,7 +405,7 @@ static int ptrace_hbp_get_addr(unsigned int note_type,
 	if (IS_ERR(bp))
 		return PTR_ERR(bp);
 
-	*addr = bp ? bp->attr.bp_addr : 0;
+	*addr = bp ? counter_arch_bp(bp)->address : 0;
 	return 0;
 }
 
diff --git a/arch/arm64/kernel/return_address.c b/arch/arm64/kernel/return_address.c
index 1718706..12a87f2 100644
--- a/arch/arm64/kernel/return_address.c
+++ b/arch/arm64/kernel/return_address.c
@@ -12,6 +12,7 @@
 #include <linux/export.h>
 #include <linux/ftrace.h>
 
+#include <asm/stack_pointer.h>
 #include <asm/stacktrace.h>
 
 struct return_address_data {
diff --git a/arch/arm64/kernel/setup.c b/arch/arm64/kernel/setup.c
index f534f49..b522209 100644
--- a/arch/arm64/kernel/setup.c
+++ b/arch/arm64/kernel/setup.c
@@ -42,6 +42,7 @@
 #include <linux/of_fdt.h>
 #include <linux/efi.h>
 #include <linux/psci.h>
+#include <linux/mm.h>
 
 #include <asm/acpi.h>
 #include <asm/fixmap.h>
@@ -199,10 +200,10 @@ static void __init request_standard_resources(void)
 	struct memblock_region *region;
 	struct resource *res;
 
-	kernel_code.start   = virt_to_phys(_text);
-	kernel_code.end     = virt_to_phys(__init_begin - 1);
-	kernel_data.start   = virt_to_phys(_sdata);
-	kernel_data.end     = virt_to_phys(_end - 1);
+	kernel_code.start   = __pa_symbol(_text);
+	kernel_code.end     = __pa_symbol(__init_begin - 1);
+	kernel_data.start   = __pa_symbol(_sdata);
+	kernel_data.end     = __pa_symbol(_end - 1);
 
 	for_each_memblock(memory, region) {
 		res = alloc_bootmem_low(sizeof(*res));
@@ -291,6 +292,15 @@ void __init setup_arch(char **cmdline_p)
 	smp_init_cpus();
 	smp_build_mpidr_hash();
 
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+	/*
+	 * Make sure init_thread_info.ttbr0 always generates translation
+	 * faults in case uaccess_enable() is inadvertently called by the init
+	 * thread.
+	 */
+	init_task.thread_info.ttbr0 = __pa_symbol(empty_zero_page);
+#endif
+
 #ifdef CONFIG_VT
 #if defined(CONFIG_VGA_CONSOLE)
 	conswitchp = &vga_con;
@@ -329,11 +339,11 @@ static int __init topology_init(void)
 static int dump_kernel_offset(struct notifier_block *self, unsigned long v,
 			      void *p)
 {
-	u64 const kaslr_offset = kimage_vaddr - KIMAGE_VADDR;
+	const unsigned long offset = kaslr_offset();
 
-	if (IS_ENABLED(CONFIG_RANDOMIZE_BASE) && kaslr_offset > 0) {
-		pr_emerg("Kernel Offset: 0x%llx from 0x%lx\n",
-			 kaslr_offset, KIMAGE_VADDR);
+	if (IS_ENABLED(CONFIG_RANDOMIZE_BASE) && offset > 0) {
+		pr_emerg("Kernel Offset: 0x%lx from 0x%lx\n",
+			 offset, KIMAGE_VADDR);
 	} else {
 		pr_emerg("Kernel Offset: disabled\n");
 	}
diff --git a/arch/arm64/kernel/sleep.S b/arch/arm64/kernel/sleep.S
old mode 100644
new mode 100755
index 0030d69..08f18cb
--- a/arch/arm64/kernel/sleep.S
+++ b/arch/arm64/kernel/sleep.S
@@ -3,6 +3,11 @@
 #include <asm/asm-offsets.h>
 #include <asm/assembler.h>
 
+#ifdef CONFIG_RTK_PLATFORM
+#define GICD_BASE 0xFF011000
+#define GICC_BASE 0xFF012000
+#endif /* CONFIG_RTK_PLATFORM */
+
 	.text
 /*
  * Implementation of MPIDR_EL1 hash algorithm through shifting
@@ -95,8 +100,51 @@ ENTRY(__cpu_suspend_enter)
 	ret
 ENDPROC(__cpu_suspend_enter)
 
+#ifdef CONFIG_RTK_PLATFORM
+ENTRY(gic_init_secure)
+	mov	w9, #0x3 /* EnableGrp0 | EnableGrp1 */
+	str	w9, [x0, 0x000] /* Secure GICD_CTLR */
+	ldr	w9, [x0, 0x004]
+	and	w10, w9, #0x1f /* ITLinesNumber */
+	cbz	w10, 1f /* No SPIs */
+	add	w10, w10, #0x1 /* Also add SGI/PPI to the counter */
+	add	x11, x0, (0x080)
+	mov	w9, #~0 /* Config SGI/PPI/SPIs as Grp1 */
+0:
+	str	w9, [x11], #0x4
+	sub	w10, w10, #0x1
+	cbnz	w10, 0b
+1:
+	ret
+ENDPROC(gic_init_secure)
+
+ENTRY(gic_init_secure_percpu)
+	mov	w9, #~0			/* Config SGIs and PPIs as Grp1 */
+	str	w9, [x0, 0x080]		/* GICD_IGROUPR0 */
+	mov	w9, #0x1		/* Enable SGI 0 */
+	str	w9, [x0, 0x100]
+					/* Initialize Cpu Interface */
+	mov	w9, #0x1e7		/* Disable IRQ/FIQ Bypass & */
+					/* Enable Ack Group1 Interrupt & */
+					/* EnableGrp0 & EnableGrp1 */
+	str	w9, [x1, 0x000]		/* Secure GICC_CTLR */
+	mov	w9, #0xf8		/* Non-Secure access to GICC_PMR */
+	str	w9, [x1, 0x004]
+	ret
+ENDPROC(gic_init_secure_percpu)
+#endif /* CONFIG_RTK_PLATFORM */
+
 	.pushsection ".idmap.text", "awx"
 ENTRY(cpu_resume)
+#ifdef CONFIG_ARCH_RTD129x
+	ldr	x0, =GICD_BASE
+	bl	gic_init_secure
+	ldr	x0, =GICD_BASE
+	ldr	x1, =GICC_BASE
+	bl	gic_init_secure_percpu
+	bl	armv8_switch_to_el2
+#endif /* CONFIG_ARCH_RTD129x */
+
 	bl	el2_setup		// if in EL2 drop to EL1 cleanly
 	bl	__cpu_setup
 	/* enable the MMU early - so we can access sleep_save_stash by va */
@@ -125,9 +173,6 @@ ENTRY(_cpu_resume)
 	/* load sp from context */
 	ldr	x2, [x0, #CPU_CTX_SP]
 	mov	sp, x2
-	/* save thread_info */
-	and	x2, x2, #~(THREAD_SIZE - 1)
-	msr	sp_el0, x2
 	/*
 	 * cpu_do_resume expects x0 to contain context address pointer
 	 */
diff --git a/arch/arm64/kernel/smp.c b/arch/arm64/kernel/smp.c
index a70f7d3..9870bad 100644
--- a/arch/arm64/kernel/smp.c
+++ b/arch/arm64/kernel/smp.c
@@ -58,6 +58,9 @@
 #define CREATE_TRACE_POINTS
 #include <trace/events/ipi.h>
 
+DEFINE_PER_CPU_READ_MOSTLY(int, cpu_number);
+EXPORT_PER_CPU_SYMBOL(cpu_number);
+
 /*
  * as from 2.5, kernels no longer have an init_tasks structure
  * so we need some other way of telling a new secondary core
@@ -146,6 +149,7 @@ int __cpu_up(unsigned int cpu, struct task_struct *idle)
 	 * We need to tell the secondary core where to find its stack and the
 	 * page tables.
 	 */
+	secondary_data.task = idle;
 	secondary_data.stack = task_stack_page(idle) + THREAD_START_SP;
 	update_cpu_boot_status(CPU_MMU_OFF);
 	__flush_dcache_area(&secondary_data, sizeof(secondary_data));
@@ -170,6 +174,7 @@ int __cpu_up(unsigned int cpu, struct task_struct *idle)
 		pr_err("CPU%u: failed to boot: %d\n", cpu, ret);
 	}
 
+	secondary_data.task = NULL;
 	secondary_data.stack = NULL;
 	status = READ_ONCE(secondary_data.status);
 	if (ret && status) {
@@ -208,7 +213,10 @@ int __cpu_up(unsigned int cpu, struct task_struct *idle)
 asmlinkage void secondary_start_kernel(void)
 {
 	struct mm_struct *mm = &init_mm;
-	unsigned int cpu = smp_processor_id();
+	unsigned int cpu;
+
+	cpu = task_cpu(current);
+	set_my_cpu_offset(per_cpu_offset(cpu));
 
 	/*
 	 * All kernel threads share the same mm context; grab a
@@ -217,8 +225,6 @@ asmlinkage void secondary_start_kernel(void)
 	atomic_inc(&mm->mm_count);
 	current->active_mm = mm;
 
-	set_my_cpu_offset(per_cpu_offset(smp_processor_id()));
-
 	/*
 	 * TTBR0 is only used for the identity mapping at this stage. Make it
 	 * point to zero page to avoid speculatively fetching new entries.
@@ -718,6 +724,8 @@ void __init smp_prepare_cpus(unsigned int max_cpus)
 	 */
 	for_each_possible_cpu(cpu) {
 
+		per_cpu(cpu_number, cpu) = cpu;
+
 		if (cpu == smp_processor_id())
 			continue;
 
diff --git a/arch/arm64/kernel/smp_spin_table.c b/arch/arm64/kernel/smp_spin_table.c
index 9a00eee..9303465 100644
--- a/arch/arm64/kernel/smp_spin_table.c
+++ b/arch/arm64/kernel/smp_spin_table.c
@@ -21,6 +21,7 @@
 #include <linux/of.h>
 #include <linux/smp.h>
 #include <linux/types.h>
+#include <linux/mm.h>
 
 #include <asm/cacheflush.h>
 #include <asm/cpu_ops.h>
@@ -98,7 +99,7 @@ static int smp_spin_table_cpu_prepare(unsigned int cpu)
 	 * boot-loader's endianess before jumping. This is mandated by
 	 * the boot protocol.
 	 */
-	writeq_relaxed(__pa(secondary_holding_pen), release_addr);
+	writeq_relaxed(__pa_symbol(secondary_holding_pen), release_addr);
 	__flush_dcache_area((__force void *)release_addr,
 			    sizeof(*release_addr));
 
diff --git a/arch/arm64/kernel/stacktrace.c b/arch/arm64/kernel/stacktrace.c
index 0cc01e0..db876b3 100644
--- a/arch/arm64/kernel/stacktrace.c
+++ b/arch/arm64/kernel/stacktrace.c
@@ -22,6 +22,7 @@
 #include <linux/stacktrace.h>
 
 #include <asm/irq.h>
+#include <asm/stack_pointer.h>
 #include <asm/stacktrace.h>
 
 /*
@@ -186,6 +187,9 @@ void save_stack_trace_tsk(struct task_struct *tsk, struct stack_trace *trace)
 	struct stack_trace_data data;
 	struct stackframe frame;
 
+	if (!try_get_task_stack(tsk))
+		return;
+
 	data.trace = trace;
 	data.skip = trace->skip;
 
@@ -207,6 +211,8 @@ void save_stack_trace_tsk(struct task_struct *tsk, struct stack_trace *trace)
 	walk_stackframe(tsk, &frame, save_trace, &data);
 	if (trace->nr_entries < trace->max_entries)
 		trace->entries[trace->nr_entries++] = ULONG_MAX;
+
+	put_task_stack(tsk);
 }
 
 void save_stack_trace(struct stack_trace *trace)
diff --git a/arch/arm64/kernel/suspend.c b/arch/arm64/kernel/suspend.c
index 1dbf609..e12f2d0 100644
--- a/arch/arm64/kernel/suspend.c
+++ b/arch/arm64/kernel/suspend.c
@@ -47,12 +47,6 @@ void notrace __cpu_suspend_exit(void)
 	cpu_uninstall_idmap();
 
 	/*
-	 * Restore per-cpu offset before any kernel
-	 * subsystem relying on it has a chance to run.
-	 */
-	set_my_cpu_offset(per_cpu_offset(cpu));
-
-	/*
 	 * PSTATE was not saved over suspend/resume, re-enable any detected
 	 * features that might not have been set correctly.
 	 */
diff --git a/arch/arm64/kernel/topology.c b/arch/arm64/kernel/topology.c
index 694f6de..ed73426 100644
--- a/arch/arm64/kernel/topology.c
+++ b/arch/arm64/kernel/topology.c
@@ -19,10 +19,24 @@
 #include <linux/nodemask.h>
 #include <linux/of.h>
 #include <linux/sched.h>
+#include <linux/sched.h>
+#include <linux/sched_energy.h>
 
 #include <asm/cputype.h>
 #include <asm/topology.h>
 
+static DEFINE_PER_CPU(unsigned long, cpu_scale) = SCHED_CAPACITY_SCALE;
+
+unsigned long scale_cpu_capacity(struct sched_domain *sd, int cpu)
+{
+	return per_cpu(cpu_scale, cpu);
+}
+
+static void set_capacity_scale(unsigned int cpu, unsigned long capacity)
+{
+	per_cpu(cpu_scale, cpu) = capacity;
+}
+
 static int __init get_cpu_for_node(struct device_node *node)
 {
 	struct device_node *cpu_node;
@@ -206,11 +220,72 @@ static int __init parse_dt_topology(void)
 struct cpu_topology cpu_topology[NR_CPUS];
 EXPORT_SYMBOL_GPL(cpu_topology);
 
+/* sd energy functions */
+static inline
+const struct sched_group_energy * const cpu_cluster_energy(int cpu)
+{
+	struct sched_group_energy *sge = sge_array[cpu][SD_LEVEL1];
+
+	if (!sge) {
+		pr_warn("Invalid sched_group_energy for Cluster%d\n", cpu);
+		return NULL;
+	}
+
+	return sge;
+}
+
+static inline
+const struct sched_group_energy * const cpu_core_energy(int cpu)
+{
+	struct sched_group_energy *sge = sge_array[cpu][SD_LEVEL0];
+
+	if (!sge) {
+		pr_warn("Invalid sched_group_energy for CPU%d\n", cpu);
+		return NULL;
+	}
+
+	return sge;
+}
+
 const struct cpumask *cpu_coregroup_mask(int cpu)
 {
 	return &cpu_topology[cpu].core_sibling;
 }
 
+static int cpu_cpu_flags(void)
+{
+	return SD_ASYM_CPUCAPACITY;
+}
+
+static inline int cpu_corepower_flags(void)
+{
+	return SD_SHARE_PKG_RESOURCES  | SD_SHARE_POWERDOMAIN | \
+	       SD_SHARE_CAP_STATES;
+}
+
+static struct sched_domain_topology_level arm64_topology[] = {
+#ifdef CONFIG_SCHED_MC
+	{ cpu_coregroup_mask, cpu_corepower_flags, cpu_core_energy, SD_INIT_NAME(MC) },
+#endif
+	{ cpu_cpu_mask, cpu_cpu_flags, cpu_cluster_energy, SD_INIT_NAME(DIE) },
+	{ NULL, },
+};
+
+static void update_cpu_capacity(unsigned int cpu)
+{
+	unsigned long capacity = SCHED_CAPACITY_SCALE;
+
+	if (cpu_core_energy(cpu)) {
+		int max_cap_idx = cpu_core_energy(cpu)->nr_cap_states - 1;
+		capacity = cpu_core_energy(cpu)->cap_states[max_cap_idx].cap;
+	}
+
+	set_capacity_scale(cpu, capacity);
+
+	pr_info("CPU%d: update cpu_capacity %lu\n",
+		cpu, arch_scale_cpu_capacity(NULL, cpu));
+}
+
 static void update_siblings_masks(unsigned int cpuid)
 {
 	struct cpu_topology *cpu_topo, *cpuid_topo = &cpu_topology[cpuid];
@@ -272,6 +347,7 @@ void store_cpu_topology(unsigned int cpuid)
 
 topology_populated:
 	update_siblings_masks(cpuid);
+	update_cpu_capacity(cpuid);
 }
 
 static void __init reset_cpu_topology(void)
@@ -302,4 +378,8 @@ void __init init_cpu_topology(void)
 	 */
 	if (of_have_populated_dt() && parse_dt_topology())
 		reset_cpu_topology();
+	else
+		set_sched_topology(arm64_topology);
+
+	init_sched_energy_costs();
 }
diff --git a/arch/arm64/kernel/traps.c b/arch/arm64/kernel/traps.c
index 5963be2..86a87ae 100644
--- a/arch/arm64/kernel/traps.c
+++ b/arch/arm64/kernel/traps.c
@@ -33,11 +33,13 @@
 #include <linux/syscalls.h>
 
 #include <asm/atomic.h>
+#include <asm/barrier.h>
 #include <asm/bug.h>
 #include <asm/debug-monitors.h>
 #include <asm/esr.h>
 #include <asm/insn.h>
 #include <asm/traps.h>
+#include <asm/stack_pointer.h>
 #include <asm/stacktrace.h>
 #include <asm/exception.h>
 #include <asm/system_misc.h>
@@ -147,6 +149,9 @@ static void dump_backtrace(struct pt_regs *regs, struct task_struct *tsk)
 	if (!tsk)
 		tsk = current;
 
+	if (!try_get_task_stack(tsk))
+		return;
+
 	/*
 	 * Switching between stacks is valid when tracing current and in
 	 * non-preemptible context.
@@ -212,6 +217,8 @@ static void dump_backtrace(struct pt_regs *regs, struct task_struct *tsk)
 				 stack + sizeof(struct pt_regs));
 		}
 	}
+
+	put_task_stack(tsk);
 }
 
 void show_stack(struct task_struct *tsk, unsigned long *sp)
@@ -227,10 +234,9 @@ void show_stack(struct task_struct *tsk, unsigned long *sp)
 #endif
 #define S_SMP " SMP"
 
-static int __die(const char *str, int err, struct thread_info *thread,
-		 struct pt_regs *regs)
+static int __die(const char *str, int err, struct pt_regs *regs)
 {
-	struct task_struct *tsk = thread->task;
+	struct task_struct *tsk = current;
 	static int die_counter;
 	int ret;
 
@@ -245,7 +251,8 @@ static int __die(const char *str, int err, struct thread_info *thread,
 	print_modules();
 	__show_regs(regs);
 	pr_emerg("Process %.*s (pid: %d, stack limit = 0x%p)\n",
-		 TASK_COMM_LEN, tsk->comm, task_pid_nr(tsk), thread + 1);
+		 TASK_COMM_LEN, tsk->comm, task_pid_nr(tsk),
+		 end_of_stack(tsk));
 
 	if (!user_mode(regs)) {
 		dump_mem(KERN_EMERG, "Stack: ", regs->sp,
@@ -264,7 +271,6 @@ static int __die(const char *str, int err, struct thread_info *thread,
  */
 void die(const char *str, struct pt_regs *regs, int err)
 {
-	struct thread_info *thread = current_thread_info();
 	int ret;
 
 	oops_enter();
@@ -272,9 +278,9 @@ void die(const char *str, struct pt_regs *regs, int err)
 	raw_spin_lock_irq(&die_lock);
 	console_verbose();
 	bust_spinlocks(1);
-	ret = __die(str, err, thread, regs);
+	ret = __die(str, err, regs);
 
-	if (regs && kexec_should_crash(thread->task))
+	if (regs && kexec_should_crash(current))
 		crash_kexec(regs);
 
 	bust_spinlocks(0);
@@ -435,9 +441,10 @@ int cpu_enable_cache_maint_trap(void *__unused)
 }
 
 #define __user_cache_maint(insn, address, res)			\
-	if (address >= user_addr_max())				\
+	if (address >= user_addr_max()) {			\
 		res = -EFAULT;					\
-	else							\
+	} else {						\
+		uaccess_ttbr0_enable();				\
 		asm volatile (					\
 			"1:	" insn ", %1\n"			\
 			"	mov	%w0, #0\n"		\
@@ -449,7 +456,9 @@ int cpu_enable_cache_maint_trap(void *__unused)
 			"	.popsection\n"			\
 			_ASM_EXTABLE(1b, 3b)			\
 			: "=r" (res)				\
-			: "r" (address), "i" (-EFAULT) )
+			: "r" (address), "i" (-EFAULT));	\
+		uaccess_ttbr0_disable();			\
+	}
 
 static void user_cache_maint_handler(unsigned int esr, struct pt_regs *regs)
 {
@@ -492,6 +501,25 @@ static void ctr_read_handler(unsigned int esr, struct pt_regs *regs)
 	regs->pc += 4;
 }
 
+static void cntvct_read_handler(unsigned int esr, struct pt_regs *regs)
+{
+	int rt = (esr & ESR_ELx_SYS64_ISS_RT_MASK) >> ESR_ELx_SYS64_ISS_RT_SHIFT;
+
+	isb();
+	if (rt != 31)
+		regs->regs[rt] = arch_counter_get_cntvct();
+	regs->pc += 4;
+}
+
+static void cntfrq_read_handler(unsigned int esr, struct pt_regs *regs)
+{
+	int rt = (esr & ESR_ELx_SYS64_ISS_RT_MASK) >> ESR_ELx_SYS64_ISS_RT_SHIFT;
+
+	if (rt != 31)
+		regs->regs[rt] = read_sysreg(cntfrq_el0);
+	regs->pc += 4;
+}
+
 struct sys64_hook {
 	unsigned int esr_mask;
 	unsigned int esr_val;
@@ -510,6 +538,18 @@ struct sys64_hook {
 		.esr_val = ESR_ELx_SYS64_ISS_SYS_CTR_READ,
 		.handler = ctr_read_handler,
 	},
+	{
+		/* Trap read access to CNTVCT_EL0 */
+		.esr_mask = ESR_ELx_SYS64_ISS_SYS_OP_MASK,
+		.esr_val = ESR_ELx_SYS64_ISS_SYS_CNTVCT,
+		.handler = cntvct_read_handler,
+	},
+	{
+		/* Trap read access to CNTFRQ_EL0 */
+		.esr_mask = ESR_ELx_SYS64_ISS_SYS_OP_MASK,
+		.esr_val = ESR_ELx_SYS64_ISS_SYS_CNTFRQ,
+		.handler = cntfrq_read_handler,
+	},
 	{},
 };
 
diff --git a/arch/arm64/kernel/vdso.c b/arch/arm64/kernel/vdso.c
index 4bcfe01..7492d90 100644
--- a/arch/arm64/kernel/vdso.c
+++ b/arch/arm64/kernel/vdso.c
@@ -123,6 +123,7 @@ static int __init vdso_init(void)
 {
 	int i;
 	struct page **vdso_pagelist;
+	unsigned long pfn;
 
 	if (memcmp(&vdso_start, "\177ELF", 4)) {
 		pr_err("vDSO is not a valid ELF object!\n");
@@ -140,11 +141,14 @@ static int __init vdso_init(void)
 		return -ENOMEM;
 
 	/* Grab the vDSO data page. */
-	vdso_pagelist[0] = pfn_to_page(PHYS_PFN(__pa(vdso_data)));
+	vdso_pagelist[0] = phys_to_page(__pa_symbol(vdso_data));
+
 
 	/* Grab the vDSO code pages. */
+	pfn = sym_to_pfn(&vdso_start);
+
 	for (i = 0; i < vdso_pages; i++)
-		vdso_pagelist[i + 1] = pfn_to_page(PHYS_PFN(__pa(&vdso_start)) + i);
+		vdso_pagelist[i + 1] = pfn_to_page(pfn + i);
 
 	vdso_spec[0].pages = &vdso_pagelist[0];
 	vdso_spec[1].pages = &vdso_pagelist[1];
@@ -216,10 +220,8 @@ void update_vsyscall(struct timekeeper *tk)
 	if (!use_syscall) {
 		/* tkr_mono.cycle_last == tkr_raw.cycle_last */
 		vdso_data->cs_cycle_last	= tk->tkr_mono.cycle_last;
-		vdso_data->raw_time_sec		= tk->raw_time.tv_sec;
-		vdso_data->raw_time_nsec	= (tk->raw_time.tv_nsec <<
-						   tk->tkr_raw.shift) +
-						  tk->tkr_raw.xtime_nsec;
+		vdso_data->raw_time_sec         = tk->raw_sec;
+		vdso_data->raw_time_nsec        = tk->tkr_raw.xtime_nsec;
 		vdso_data->xtime_clock_sec	= tk->xtime_sec;
 		vdso_data->xtime_clock_nsec	= tk->tkr_mono.xtime_nsec;
 		vdso_data->cs_mono_mult		= tk->tkr_mono.mult;
diff --git a/arch/arm64/kernel/vdso/Makefile b/arch/arm64/kernel/vdso/Makefile
index 62c84f7..88fef38 100644
--- a/arch/arm64/kernel/vdso/Makefile
+++ b/arch/arm64/kernel/vdso/Makefile
@@ -14,6 +14,7 @@ obj-vdso := $(addprefix $(obj)/, $(obj-vdso))
 ccflags-y := -shared -fno-common -fno-builtin
 ccflags-y += -nostdlib -Wl,-soname=linux-vdso.so.1 \
 		$(call cc-ldoption, -Wl$(comma)--hash-style=sysv)
+ccflags-y += $(DISABLE_LTO)
 
 # Disable gcov profiling for VDSO code
 GCOV_PROFILE := n
diff --git a/arch/arm64/kernel/vdso/gettimeofday.S b/arch/arm64/kernel/vdso/gettimeofday.S
index 76320e9..c39872a 100644
--- a/arch/arm64/kernel/vdso/gettimeofday.S
+++ b/arch/arm64/kernel/vdso/gettimeofday.S
@@ -309,7 +309,7 @@ ENTRY(__kernel_clock_getres)
 	b.ne	4f
 	ldr	x2, 6f
 2:
-	cbz	w1, 3f
+	cbz	x1, 3f
 	stp	xzr, x2, [x1]
 
 3:	/* res == NULL. */
diff --git a/arch/arm64/kernel/vmlinux.lds.S b/arch/arm64/kernel/vmlinux.lds.S
index 6a58455..402a621 100644
--- a/arch/arm64/kernel/vmlinux.lds.S
+++ b/arch/arm64/kernel/vmlinux.lds.S
@@ -60,7 +60,7 @@ jiffies = jiffies_64;
 #define TRAMP_TEXT					\
 	. = ALIGN(PAGE_SIZE);				\
 	VMLINUX_SYMBOL(__entry_tramp_text_start) = .;	\
-	*(.entry.tramp.text)				\
+	KEEP(*(.entry.tramp.text))			\
 	. = ALIGN(PAGE_SIZE);				\
 	VMLINUX_SYMBOL(__entry_tramp_text_end) = .;
 #else
@@ -179,11 +179,11 @@ SECTIONS
 	. = ALIGN(4);
 	.altinstructions : {
 		__alt_instructions = .;
-		*(.altinstructions)
+		KEEP(*(.altinstructions))
 		__alt_instructions_end = .;
 	}
 	.altinstr_replacement : {
-		*(.altinstr_replacement)
+		KEEP(*(.altinstr_replacement))
 	}
 	.rela : ALIGN(8) {
 		*(.rela .rela*)
@@ -228,6 +228,11 @@ SECTIONS
 	swapper_pg_dir = .;
 	. += SWAPPER_DIR_SIZE;
 
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+	reserved_ttbr0 = .;
+	. += RESERVED_TTBR0_SIZE;
+#endif
+
 #ifdef CONFIG_UNMAP_KERNEL_AT_EL0
 	tramp_pg_dir = .;
 	. += PAGE_SIZE;
diff --git a/arch/arm64/kvm/hyp/Makefile b/arch/arm64/kvm/hyp/Makefile
index 48b0354..c470a7c 100644
--- a/arch/arm64/kvm/hyp/Makefile
+++ b/arch/arm64/kvm/hyp/Makefile
@@ -4,6 +4,10 @@
 
 ccflags-y += -fno-stack-protector -DDISABLE_BRANCH_PROFILING
 
+ifeq ($(cc-name),clang)
+ccflags-y += -fno-jump-tables
+endif
+
 KVM=../../../../virt/kvm
 
 obj-$(CONFIG_KVM_ARM_HOST) += $(KVM)/arm/hyp/vgic-v2-sr.o
diff --git a/arch/arm64/lib/clear_user.S b/arch/arm64/lib/clear_user.S
index efbf610..b581e16 100644
--- a/arch/arm64/lib/clear_user.S
+++ b/arch/arm64/lib/clear_user.S
@@ -17,10 +17,7 @@
  */
 #include <linux/linkage.h>
 
-#include <asm/alternative.h>
-#include <asm/assembler.h>
-#include <asm/cpufeature.h>
-#include <asm/sysreg.h>
+#include <asm/uaccess.h>
 
 	.text
 
@@ -33,8 +30,7 @@
  * Alignment fixed up by hardware.
  */
 ENTRY(__arch_clear_user)
-ALTERNATIVE("nop", __stringify(SET_PSTATE_PAN(0)), ARM64_ALT_PAN_NOT_UAO, \
-	    CONFIG_ARM64_PAN)
+	uaccess_enable_not_uao x2, x3, x4
 	mov	x2, x1			// save the size for fixup return
 	subs	x1, x1, #8
 	b.mi	2f
@@ -54,8 +50,7 @@ uao_user_alternative 9f, strh, sttrh, wzr, x0, 2
 	b.mi	5f
 uao_user_alternative 9f, strb, sttrb, wzr, x0, 0
 5:	mov	x0, #0
-ALTERNATIVE("nop", __stringify(SET_PSTATE_PAN(1)), ARM64_ALT_PAN_NOT_UAO, \
-	    CONFIG_ARM64_PAN)
+	uaccess_disable_not_uao x2, x3
 	ret
 ENDPROC(__arch_clear_user)
 
diff --git a/arch/arm64/lib/copy_from_user.S b/arch/arm64/lib/copy_from_user.S
index 4fd67ea..c7a7d96 100644
--- a/arch/arm64/lib/copy_from_user.S
+++ b/arch/arm64/lib/copy_from_user.S
@@ -16,11 +16,8 @@
 
 #include <linux/linkage.h>
 
-#include <asm/alternative.h>
-#include <asm/assembler.h>
 #include <asm/cache.h>
-#include <asm/cpufeature.h>
-#include <asm/sysreg.h>
+#include <asm/uaccess.h>
 
 /*
  * Copy from user space to a kernel buffer (alignment handled by the hardware)
@@ -67,12 +64,10 @@
 
 end	.req	x5
 ENTRY(__arch_copy_from_user)
-ALTERNATIVE("nop", __stringify(SET_PSTATE_PAN(0)), ARM64_ALT_PAN_NOT_UAO, \
-	    CONFIG_ARM64_PAN)
+	uaccess_enable_not_uao x3, x4, x5
 	add	end, x0, x2
 #include "copy_template.S"
-ALTERNATIVE("nop", __stringify(SET_PSTATE_PAN(1)), ARM64_ALT_PAN_NOT_UAO, \
-	    CONFIG_ARM64_PAN)
+	uaccess_disable_not_uao x3, x4
 	mov	x0, #0				// Nothing to copy
 	ret
 ENDPROC(__arch_copy_from_user)
diff --git a/arch/arm64/lib/copy_in_user.S b/arch/arm64/lib/copy_in_user.S
index 841bf8f..800779e 100644
--- a/arch/arm64/lib/copy_in_user.S
+++ b/arch/arm64/lib/copy_in_user.S
@@ -18,11 +18,8 @@
 
 #include <linux/linkage.h>
 
-#include <asm/alternative.h>
-#include <asm/assembler.h>
 #include <asm/cache.h>
-#include <asm/cpufeature.h>
-#include <asm/sysreg.h>
+#include <asm/uaccess.h>
 
 /*
  * Copy from user space to user space (alignment handled by the hardware)
@@ -68,12 +65,10 @@
 
 end	.req	x5
 ENTRY(__arch_copy_in_user)
-ALTERNATIVE("nop", __stringify(SET_PSTATE_PAN(0)), ARM64_ALT_PAN_NOT_UAO, \
-	    CONFIG_ARM64_PAN)
+	uaccess_enable_not_uao x3, x4, x5
 	add	end, x0, x2
 #include "copy_template.S"
-ALTERNATIVE("nop", __stringify(SET_PSTATE_PAN(1)), ARM64_ALT_PAN_NOT_UAO, \
-	    CONFIG_ARM64_PAN)
+	uaccess_disable_not_uao x3, x4
 	mov	x0, #0
 	ret
 ENDPROC(__arch_copy_in_user)
diff --git a/arch/arm64/lib/copy_to_user.S b/arch/arm64/lib/copy_to_user.S
index 7a7efe2..f6cfcc0 100644
--- a/arch/arm64/lib/copy_to_user.S
+++ b/arch/arm64/lib/copy_to_user.S
@@ -16,11 +16,8 @@
 
 #include <linux/linkage.h>
 
-#include <asm/alternative.h>
-#include <asm/assembler.h>
 #include <asm/cache.h>
-#include <asm/cpufeature.h>
-#include <asm/sysreg.h>
+#include <asm/uaccess.h>
 
 /*
  * Copy to user space from a kernel buffer (alignment handled by the hardware)
@@ -66,12 +63,10 @@
 
 end	.req	x5
 ENTRY(__arch_copy_to_user)
-ALTERNATIVE("nop", __stringify(SET_PSTATE_PAN(0)), ARM64_ALT_PAN_NOT_UAO, \
-	    CONFIG_ARM64_PAN)
+	uaccess_enable_not_uao x3, x4, x5
 	add	end, x0, x2
 #include "copy_template.S"
-ALTERNATIVE("nop", __stringify(SET_PSTATE_PAN(1)), ARM64_ALT_PAN_NOT_UAO, \
-	    CONFIG_ARM64_PAN)
+	uaccess_disable_not_uao x3, x4
 	mov	x0, #0
 	ret
 ENDPROC(__arch_copy_to_user)
diff --git a/arch/arm64/mm/cache.S b/arch/arm64/mm/cache.S
index 58b5a90..631edbc 100644
--- a/arch/arm64/mm/cache.S
+++ b/arch/arm64/mm/cache.S
@@ -23,6 +23,83 @@
 #include <asm/assembler.h>
 #include <asm/cpufeature.h>
 #include <asm/alternative.h>
+#include <asm/uaccess.h>
+
+#ifdef CONFIG_RTK_PLATFORM
+
+/*
+ *  __flush_dcache_all()
+ *
+ *  Flush the whole D-cache.
+ *
+ *  Corrupted registers: x0-x7, x9-x11
+ */
+__flush_dcache_all:
+    dmb sy              // ensure ordering with previous memory accesses
+    mrs x0, clidr_el1           // read clidr
+    and x3, x0, #0x7000000      // extract loc from clidr
+    lsr x3, x3, #23         // left align loc bit field
+    cbz x3, finished            // if loc is 0, then no need to clean
+    mov x10, #0             // start clean at cache level 0
+loop1:
+    add x2, x10, x10, lsr #1        // work out 3x current cache level
+    lsr x1, x0, x2          // extract cache type bits from clidr
+    and x1, x1, #7          // mask of the bits for current cache only
+    cmp x1, #2              // see what cache we have at this level
+    b.lt    skip                // skip if no cache, or just i-cache
+    save_and_disable_irqs x9        // make CSSELR and CCSIDR access atomic
+    msr csselr_el1, x10         // select current cache level in csselr
+    isb                 // isb to sych the new cssr&csidr
+    mrs x1, ccsidr_el1          // read the new ccsidr
+    restore_irqs x9
+    and x2, x1, #7          // extract the length of the cache lines
+    add x2, x2, #4          // add 4 (line length offset)
+    mov x4, #0x3ff
+    and x4, x4, x1, lsr #3      // find maximum number on the way size
+    clz w5, w4              // find bit position of way size increment
+    mov x7, #0x7fff
+    and x7, x7, x1, lsr #13     // extract max number of the index size
+loop2:
+    mov x9, x4              // create working copy of max way size
+loop3:
+    lsl x6, x9, x5
+    orr x11, x10, x6            // factor way and cache number into x11
+    lsl x6, x7, x2
+    orr x11, x11, x6            // factor index number into x11
+    dc  cisw, x11           // clean & invalidate by set/way
+    subs    x9, x9, #1          // decrement the way
+    b.ge    loop3
+    subs    x7, x7, #1          // decrement the index
+    b.ge    loop2
+skip:
+    add x10, x10, #2            // increment cache number
+    cmp x3, x10
+    b.gt    loop1
+finished:
+    mov x10, #0             // swith back to cache level 0
+    msr csselr_el1, x10         // select current cache level in csselr
+    dsb sy
+    isb
+    ret
+ENDPROC(__flush_dcache_all)
+
+/*
+ *  flush_cache_all()
+ *
+ *  Flush the entire cache system.  The data cache flush is now achieved
+ *  using atomic clean / invalidates working outwards from L1 cache. This
+ *  is done using Set/Way based cache maintainance instructions.  The
+ *  instruction cache can still be invalidated back to the point of
+ *  unification in a single instruction.
+ */
+ENTRY(flush_cache_all)
+    mov x12, lr
+    bl  __flush_dcache_all
+    mov x0, #0
+    ic  ialluis             // I+BTB cache invalidate
+    ret x12
+ENDPROC(flush_cache_all)
+#endif /* CONFIG_RTK_PLATFORM */
 
 /*
  *	flush_icache_range(start,end)
@@ -48,6 +125,7 @@ ENTRY(flush_icache_range)
  *	- end     - virtual end address of region
  */
 ENTRY(__flush_cache_user_range)
+	uaccess_ttbr0_enable x2, x3, x4
 	dcache_line_size x2, x3
 	sub	x3, x2, #1
 	bic	x4, x0, x3
@@ -69,10 +147,12 @@ USER(9f, ic	ivau, x4	)		// invalidate I line PoU
 	dsb	ish
 	isb
 	mov	x0, #0
+1:
+	uaccess_ttbr0_disable x1, x2
 	ret
 9:
 	mov	x0, #-EFAULT
-	ret
+	b	1b
 ENDPROC(flush_icache_range)
 ENDPROC(__flush_cache_user_range)
 
diff --git a/arch/arm64/mm/context.c b/arch/arm64/mm/context.c
index 62d976e..c841cce 100644
--- a/arch/arm64/mm/context.c
+++ b/arch/arm64/mm/context.c
@@ -233,7 +233,12 @@ void check_and_switch_context(struct mm_struct *mm, unsigned int cpu)
 
 	arm64_apply_bp_hardening();
 
-	cpu_switch_mm(mm->pgd, mm);
+	/*
+	 * Defer TTBR0_EL1 setting for user threads to uaccess_enable() when
+	 * emulating PAN.
+	 */
+	if (!system_uses_ttbr0_pan())
+		cpu_switch_mm(mm->pgd, mm);
 }
 
 /* Errata workaround post TTBRx_EL1 update. */
diff --git a/arch/arm64/mm/dma-mapping.c b/arch/arm64/mm/dma-mapping.c
index cab3574..8c18cb6 100644
--- a/arch/arm64/mm/dma-mapping.c
+++ b/arch/arm64/mm/dma-mapping.c
@@ -174,7 +174,7 @@ static void *__dma_alloc(struct device *dev, size_t size,
 	/* create a coherent mapping */
 	page = virt_to_page(ptr);
 	coherent_ptr = dma_common_contiguous_remap(page, size, VM_USERMAP,
-						   prot, NULL);
+						   prot, __builtin_return_address(0));
 	if (!coherent_ptr)
 		goto no_map;
 
@@ -512,21 +512,40 @@ static int __dummy_dma_supported(struct device *hwdev, u64 mask)
 	return 0;
 }
 
+#ifdef CONFIG_RTK_PLATFORM
 struct dma_map_ops dummy_dma_ops = {
-	.alloc                  = __dummy_alloc,
-	.free                   = __dummy_free,
-	.mmap                   = __dummy_mmap,
-	.map_page               = __dummy_map_page,
-	.unmap_page             = __dummy_unmap_page,
-	.map_sg                 = __dummy_map_sg,
-	.unmap_sg               = __dummy_unmap_sg,
-	.sync_single_for_cpu    = __dummy_sync_single,
+	.alloc = __dma_alloc,
+	.free = __dma_free,
+	.mmap = __swiotlb_mmap,
+	.map_page = __swiotlb_map_page,
+	.unmap_page = __swiotlb_unmap_page,
+	.map_sg = __swiotlb_map_sg_attrs,
+	.unmap_sg = __swiotlb_unmap_sg_attrs,
+	.sync_single_for_cpu = __swiotlb_sync_single_for_cpu,
+	.sync_single_for_device = __swiotlb_sync_single_for_device,
+	.sync_sg_for_cpu = __swiotlb_sync_sg_for_cpu,
+	.sync_sg_for_device = __swiotlb_sync_sg_for_device,
+	.dma_supported = swiotlb_dma_supported,
+	.mapping_error = swiotlb_dma_mapping_error,
+};
+#else
+struct dma_map_ops dummy_dma_ops = {
+	.alloc = __dummy_alloc,
+	.free = __dummy_free,
+	.mmap = __dummy_mmap,
+	.map_page = __dummy_map_page,
+	.unmap_page = __dummy_unmap_page,
+	.map_sg = __dummy_map_sg,
+	.unmap_sg = __dummy_unmap_sg,
+	.sync_single_for_cpu = __dummy_sync_single,
 	.sync_single_for_device = __dummy_sync_single,
-	.sync_sg_for_cpu        = __dummy_sync_sg,
-	.sync_sg_for_device     = __dummy_sync_sg,
-	.mapping_error          = __dummy_mapping_error,
-	.dma_supported          = __dummy_dma_supported,
+	.sync_sg_for_cpu = __dummy_sync_sg,
+	.sync_sg_for_device = __dummy_sync_sg,
+	.mapping_error = __dummy_mapping_error,
+	.dma_supported = __dummy_dma_supported,
 };
+#endif /* CONFIG_RTK_PLATFORM */
+
 EXPORT_SYMBOL(dummy_dma_ops);
 
 static int __init arm64_dma_init(void)
diff --git a/arch/arm64/mm/fault.c b/arch/arm64/mm/fault.c
index ad49ae8..a9dc8ec 100644
--- a/arch/arm64/mm/fault.c
+++ b/arch/arm64/mm/fault.c
@@ -41,6 +41,10 @@
 #include <asm/pgtable.h>
 #include <asm/tlbflush.h>
 
+#ifdef CONFIG_RTK_TRACER
+#include <linux/rtk_trace.h>
+#endif
+
 struct fault_info {
 	int	(*fn)(unsigned long addr, unsigned int esr,
 		      struct pt_regs *regs);
@@ -186,6 +190,12 @@ static void __do_kernel_fault(struct mm_struct *mm, unsigned long addr,
 	if (!is_el1_instruction_abort(esr) && fixup_exception(regs))
 		return;
 
+#ifdef CONFIG_RTK_TRACER
+	uncached_logk(LOGK_DIE, (void *)regs->pc);
+	uncached_logk(LOGK_DIE, (void *)regs->regs[30]);
+	uncached_logk(LOGK_DIE, (void *)addr);
+	rtk_trace_disable();
+#endif
 	/*
 	 * No handler, we'll have to terminate things with extreme prejudice.
 	 */
@@ -286,13 +296,19 @@ static int __do_page_fault(struct mm_struct *mm, unsigned long addr,
 	return fault;
 }
 
-static inline bool is_permission_fault(unsigned int esr)
+static inline bool is_permission_fault(unsigned int esr, struct pt_regs *regs)
 {
 	unsigned int ec       = ESR_ELx_EC(esr);
 	unsigned int fsc_type = esr & ESR_ELx_FSC_TYPE;
 
-	return (ec == ESR_ELx_EC_DABT_CUR && fsc_type == ESR_ELx_FSC_PERM) ||
-	       (ec == ESR_ELx_EC_IABT_CUR && fsc_type == ESR_ELx_FSC_PERM);
+	if (ec != ESR_ELx_EC_DABT_CUR && ec != ESR_ELx_EC_IABT_CUR)
+		return false;
+
+	if (system_uses_ttbr0_pan())
+		return fsc_type == ESR_ELx_FSC_FAULT &&
+			(regs->pstate & PSR_PAN_BIT);
+	else
+		return fsc_type == ESR_ELx_FSC_PERM;
 }
 
 static bool is_el0_instruction_abort(unsigned int esr)
@@ -332,7 +348,7 @@ static int __kprobes do_page_fault(unsigned long addr, unsigned int esr,
 		mm_flags |= FAULT_FLAG_WRITE;
 	}
 
-	if (is_permission_fault(esr) && (addr < TASK_SIZE)) {
+	if (addr < TASK_SIZE && is_permission_fault(esr, regs)) {
 		/* regs->orig_addr_limit may be 0 if we entered from EL0 */
 		if (regs->orig_addr_limit == KERNEL_DS)
 			die("Accessing user space memory with fs=KERNEL_DS", regs, esr);
diff --git a/arch/arm64/mm/flush.c b/arch/arm64/mm/flush.c
index 8377329..a979f30 100644
--- a/arch/arm64/mm/flush.c
+++ b/arch/arm64/mm/flush.c
@@ -91,4 +91,7 @@ void flush_dcache_page(struct page *page)
 /*
  * Additional functions defined in assembly.
  */
+#ifdef CONFIG_RTK_PLATFORM
+EXPORT_SYMBOL(flush_cache_all);
+#endif /* CONFIG_RTK_PLATFORM */
 EXPORT_SYMBOL(flush_icache_range);
diff --git a/arch/arm64/mm/init.c b/arch/arm64/mm/init.c
index 9d07b42..31fe1cd 100644
--- a/arch/arm64/mm/init.c
+++ b/arch/arm64/mm/init.c
@@ -36,6 +36,7 @@
 #include <linux/efi.h>
 #include <linux/swiotlb.h>
 #include <linux/vmalloc.h>
+#include <linux/mm.h>
 
 #include <asm/boot.h>
 #include <asm/fixmap.h>
@@ -145,9 +146,11 @@ static void __init zone_sizes_init(unsigned long min, unsigned long max)
 #endif /* CONFIG_NUMA */
 
 #ifdef CONFIG_HAVE_ARCH_PFN_VALID
+#define PFN_MASK ((1UL << (64 - PAGE_SHIFT)) - 1)
+
 int pfn_valid(unsigned long pfn)
 {
-	return memblock_is_map_memory(pfn << PAGE_SHIFT);
+	return (pfn & PFN_MASK) == pfn && memblock_is_map_memory(pfn << PAGE_SHIFT);
 }
 EXPORT_SYMBOL(pfn_valid);
 #endif
@@ -209,8 +212,8 @@ void __init arm64_memblock_init(void)
 	 * linear mapping. Take care not to clip the kernel which may be
 	 * high in memory.
 	 */
-	memblock_remove(max_t(u64, memstart_addr + linear_region_size, __pa(_end)),
-			ULLONG_MAX);
+	memblock_remove(max_t(u64, memstart_addr + linear_region_size,
+			__pa_symbol(_end)), ULLONG_MAX);
 	if (memstart_addr + linear_region_size < memblock_end_of_DRAM()) {
 		/* ensure that memstart_addr remains sufficiently aligned */
 		memstart_addr = round_up(memblock_end_of_DRAM() - linear_region_size,
@@ -225,7 +228,7 @@ void __init arm64_memblock_init(void)
 	 */
 	if (memory_limit != (phys_addr_t)ULLONG_MAX) {
 		memblock_mem_limit_remove_map(memory_limit);
-		memblock_add(__pa(_text), (u64)(_end - _text));
+		memblock_add(__pa_symbol(_text), (u64)(_end - _text));
 	}
 
 	if (IS_ENABLED(CONFIG_BLK_DEV_INITRD) && initrd_start) {
@@ -278,7 +281,7 @@ void __init arm64_memblock_init(void)
 	 * Register the kernel text, kernel data, initrd, and initial
 	 * pagetables with memblock.
 	 */
-	memblock_reserve(__pa(_text), _end - _text);
+	memblock_reserve(__pa_symbol(_text), _end - _text);
 #ifdef CONFIG_BLK_DEV_INITRD
 	if (initrd_start) {
 		memblock_reserve(initrd_start, initrd_end - initrd_start);
@@ -488,7 +491,8 @@ void __init mem_init(void)
 
 void free_initmem(void)
 {
-	free_reserved_area(__va(__pa(__init_begin)), __va(__pa(__init_end)),
+	free_reserved_area(lm_alias(__init_begin),
+			   lm_alias(__init_end),
 			   0, "unused kernel");
 	/*
 	 * Unmap the __init region but leave the VM area in place. This
diff --git a/arch/arm64/mm/ioremap.c b/arch/arm64/mm/ioremap.c
index 01e88c8..fb6a4dc 100644
--- a/arch/arm64/mm/ioremap.c
+++ b/arch/arm64/mm/ioremap.c
@@ -28,6 +28,7 @@
 #include <asm/fixmap.h>
 #include <asm/tlbflush.h>
 #include <asm/pgalloc.h>
+#include <linux/rtk_trace.h>
 
 static void __iomem *__ioremap_caller(phys_addr_t phys_addr, size_t size,
 				      pgprot_t prot, void *caller)
@@ -55,8 +56,11 @@ static void __iomem *__ioremap_caller(phys_addr_t phys_addr, size_t size,
 	/*
 	 * Don't allow RAM to be mapped.
 	 */
-	if (WARN_ON(pfn_valid(__phys_to_pfn(phys_addr))))
-		return NULL;
+#ifdef CONFIG_RTK_MEM_REMAP	//Allow Realtek RTD129x to mapping RAM area
+#else
+if (WARN_ON(pfn_valid(__phys_to_pfn(phys_addr))))
+	return NULL;
+#endif
 
 	area = get_vm_area_caller(size, VM_IOREMAP, caller);
 	if (!area)
@@ -70,6 +74,10 @@ static void __iomem *__ioremap_caller(phys_addr_t phys_addr, size_t size,
 		return NULL;
 	}
 
+#ifdef CONFIG_RTK_TRACER
+	inject_vmap_info((void*)addr, size, phys_addr, 1);
+#endif
+
 	return (void __iomem *)(offset + addr);
 }
 
@@ -90,6 +98,9 @@ void __iounmap(volatile void __iomem *io_addr)
 	 */
 	if (VMALLOC_START <= addr && addr < VMALLOC_END)
 		vunmap((void *)addr);
+#ifdef CONFIG_RTK_TRACER
+	remove_vmap_info((void*)addr, 1);
+#endif
 }
 EXPORT_SYMBOL(__iounmap);
 
diff --git a/arch/arm64/mm/kasan_init.c b/arch/arm64/mm/kasan_init.c
index 757009d..201d918 100644
--- a/arch/arm64/mm/kasan_init.c
+++ b/arch/arm64/mm/kasan_init.c
@@ -15,6 +15,7 @@
 #include <linux/kernel.h>
 #include <linux/memblock.h>
 #include <linux/start_kernel.h>
+#include <linux/mm.h>
 
 #include <asm/mmu_context.h>
 #include <asm/kernel-pgtable.h>
@@ -26,6 +27,13 @@
 
 static pgd_t tmp_pg_dir[PTRS_PER_PGD] __initdata __aligned(PGD_SIZE);
 
+/*
+ * The p*d_populate functions call virt_to_phys implicitly so they can't be used
+ * directly on kernel symbols (bm_p*d). All the early functions are called too
+ * early to use lm_alias so __p*d_populate functions must be used to populate
+ * with the physical address from __pa_symbol.
+ */
+
 static void __init kasan_early_pte_populate(pmd_t *pmd, unsigned long addr,
 					unsigned long end)
 {
@@ -33,12 +41,12 @@ static void __init kasan_early_pte_populate(pmd_t *pmd, unsigned long addr,
 	unsigned long next;
 
 	if (pmd_none(*pmd))
-		pmd_populate_kernel(&init_mm, pmd, kasan_zero_pte);
+		__pmd_populate(pmd, __pa_symbol(kasan_zero_pte), PMD_TYPE_TABLE);
 
 	pte = pte_offset_kimg(pmd, addr);
 	do {
 		next = addr + PAGE_SIZE;
-		set_pte(pte, pfn_pte(virt_to_pfn(kasan_zero_page),
+		set_pte(pte, pfn_pte(sym_to_pfn(kasan_zero_page),
 					PAGE_KERNEL));
 	} while (pte++, addr = next, addr != end && pte_none(*pte));
 }
@@ -51,7 +59,7 @@ static void __init kasan_early_pmd_populate(pud_t *pud,
 	unsigned long next;
 
 	if (pud_none(*pud))
-		pud_populate(&init_mm, pud, kasan_zero_pmd);
+		__pud_populate(pud, __pa_symbol(kasan_zero_pmd), PMD_TYPE_TABLE);
 
 	pmd = pmd_offset_kimg(pud, addr);
 	do {
@@ -68,7 +76,7 @@ static void __init kasan_early_pud_populate(pgd_t *pgd,
 	unsigned long next;
 
 	if (pgd_none(*pgd))
-		pgd_populate(&init_mm, pgd, kasan_zero_pud);
+		__pgd_populate(pgd, __pa_symbol(kasan_zero_pud), PUD_TYPE_TABLE);
 
 	pud = pud_offset_kimg(pgd, addr);
 	do {
@@ -148,7 +156,7 @@ void __init kasan_init(void)
 	 */
 	memcpy(tmp_pg_dir, swapper_pg_dir, sizeof(tmp_pg_dir));
 	dsb(ishst);
-	cpu_replace_ttbr1(tmp_pg_dir);
+	cpu_replace_ttbr1(lm_alias(tmp_pg_dir));
 
 	clear_pgds(KASAN_SHADOW_START, KASAN_SHADOW_END);
 
@@ -199,10 +207,10 @@ void __init kasan_init(void)
 	 */
 	for (i = 0; i < PTRS_PER_PTE; i++)
 		set_pte(&kasan_zero_pte[i],
-			pfn_pte(virt_to_pfn(kasan_zero_page), PAGE_KERNEL_RO));
+			pfn_pte(sym_to_pfn(kasan_zero_page), PAGE_KERNEL_RO));
 
 	memset(kasan_zero_page, 0, PAGE_SIZE);
-	cpu_replace_ttbr1(swapper_pg_dir);
+	cpu_replace_ttbr1(lm_alias(swapper_pg_dir));
 
 	/* At this point kasan is fully initialized. Enable error messages */
 	init_task.kasan_depth = 0;
diff --git a/arch/arm64/mm/mmu.c b/arch/arm64/mm/mmu.c
index 4cd4862..c40d710 100644
--- a/arch/arm64/mm/mmu.c
+++ b/arch/arm64/mm/mmu.c
@@ -30,6 +30,7 @@
 #include <linux/io.h>
 #include <linux/slab.h>
 #include <linux/stop_machine.h>
+#include <linux/mm.h>
 
 #include <asm/barrier.h>
 #include <asm/cputype.h>
@@ -319,8 +320,8 @@ static void create_mapping_late(phys_addr_t phys, unsigned long virt,
 
 static void __init __map_memblock(pgd_t *pgd, phys_addr_t start, phys_addr_t end)
 {
-	unsigned long kernel_start = __pa(_text);
-	unsigned long kernel_end = __pa(__init_begin);
+	unsigned long kernel_start = __pa_symbol(_text);
+	unsigned long kernel_end = __pa_symbol(__init_begin);
 
 	/*
 	 * Take care not to create a writable alias for the
@@ -387,21 +388,21 @@ void mark_rodata_ro(void)
 	unsigned long section_size;
 
 	section_size = (unsigned long)_etext - (unsigned long)_text;
-	create_mapping_late(__pa(_text), (unsigned long)_text,
+	create_mapping_late(__pa_symbol(_text), (unsigned long)_text,
 			    section_size, PAGE_KERNEL_ROX);
 	/*
 	 * mark .rodata as read only. Use __init_begin rather than __end_rodata
 	 * to cover NOTES and EXCEPTION_TABLE.
 	 */
 	section_size = (unsigned long)__init_begin - (unsigned long)__start_rodata;
-	create_mapping_late(__pa(__start_rodata), (unsigned long)__start_rodata,
+	create_mapping_late(__pa_symbol(__start_rodata), (unsigned long)__start_rodata,
 			    section_size, PAGE_KERNEL_RO);
 }
 
 static void __init map_kernel_segment(pgd_t *pgd, void *va_start, void *va_end,
 				      pgprot_t prot, struct vm_struct *vma)
 {
-	phys_addr_t pa_start = __pa(va_start);
+	phys_addr_t pa_start = __pa_symbol(va_start);
 	unsigned long size = va_end - va_start;
 
 	BUG_ON(!PAGE_ALIGNED(pa_start));
@@ -480,7 +481,7 @@ static void __init map_kernel(pgd_t *pgd)
 		 */
 		BUG_ON(!IS_ENABLED(CONFIG_ARM64_16K_PAGES));
 		set_pud(pud_set_fixmap_offset(pgd, FIXADDR_START),
-			__pud(__pa(bm_pmd) | PUD_TYPE_TABLE));
+			__pud(__pa_symbol(bm_pmd) | PUD_TYPE_TABLE));
 		pud_clear_fixmap();
 	} else {
 		BUG();
@@ -511,7 +512,7 @@ void __init paging_init(void)
 	 */
 	cpu_replace_ttbr1(__va(pgd_phys));
 	memcpy(swapper_pg_dir, pgd, PGD_SIZE);
-	cpu_replace_ttbr1(swapper_pg_dir);
+	cpu_replace_ttbr1(lm_alias(swapper_pg_dir));
 
 	pgd_clear_fixmap();
 	memblock_free(pgd_phys, PAGE_SIZE);
@@ -520,10 +521,23 @@ void __init paging_init(void)
 	 * We only reuse the PGD from the swapper_pg_dir, not the pud + pmd
 	 * allocated with it.
 	 */
-	memblock_free(__pa(swapper_pg_dir) + PAGE_SIZE,
+	memblock_free(__pa_symbol(swapper_pg_dir) + PAGE_SIZE,
 		      SWAPPER_DIR_SIZE - PAGE_SIZE);
 }
 
+#ifdef CONFIG_RTK_PLATFORM
+/*
+ * Enable the identity mapping to allow the MMU disabling.
+ */
+void setup_mm_for_reboot(void)
+{
+       cpu_set_reserved_ttbr0();
+       flush_tlb_all();
+       cpu_set_idmap_tcr_t0sz();
+       cpu_switch_mm(idmap_pg_dir, &init_mm);
+}
+#endif /* CONFIG_RTK_PLATFORM */
+
 /*
  * Check whether a kernel address is valid (derived from arch/x86/).
  */
@@ -631,6 +645,12 @@ static inline pte_t * fixmap_pte(unsigned long addr)
 	return &bm_pte[pte_index(addr)];
 }
 
+/*
+ * The p*d_populate functions call virt_to_phys implicitly so they can't be used
+ * directly on kernel symbols (bm_p*d). This function is called too early to use
+ * lm_alias so __p*d_populate functions must be used to populate with the
+ * physical address from __pa_symbol.
+ */
 void __init early_fixmap_init(void)
 {
 	pgd_t *pgd;
@@ -640,7 +660,7 @@ void __init early_fixmap_init(void)
 
 	pgd = pgd_offset_k(addr);
 	if (CONFIG_PGTABLE_LEVELS > 3 &&
-	    !(pgd_none(*pgd) || pgd_page_paddr(*pgd) == __pa(bm_pud))) {
+	    !(pgd_none(*pgd) || pgd_page_paddr(*pgd) == __pa_symbol(bm_pud))) {
 		/*
 		 * We only end up here if the kernel mapping and the fixmap
 		 * share the top level pgd entry, which should only happen on
@@ -649,12 +669,14 @@ void __init early_fixmap_init(void)
 		BUG_ON(!IS_ENABLED(CONFIG_ARM64_16K_PAGES));
 		pud = pud_offset_kimg(pgd, addr);
 	} else {
-		pgd_populate(&init_mm, pgd, bm_pud);
+		if (pgd_none(*pgd))
+			__pgd_populate(pgd, __pa_symbol(bm_pud), PUD_TYPE_TABLE);
 		pud = fixmap_pud(addr);
 	}
-	pud_populate(&init_mm, pud, bm_pmd);
+	if (pud_none(*pud))
+		__pud_populate(pud, __pa_symbol(bm_pmd), PMD_TYPE_TABLE);
 	pmd = fixmap_pmd(addr);
-	pmd_populate_kernel(&init_mm, pmd, bm_pte);
+	__pmd_populate(pmd, __pa_symbol(bm_pte), PMD_TYPE_TABLE);
 
 	/*
 	 * The boot-ioremap range spans multiple pmds, for which
diff --git a/arch/arm64/mm/proc.S b/arch/arm64/mm/proc.S
index 18d96d3..b5f5e98 100644
--- a/arch/arm64/mm/proc.S
+++ b/arch/arm64/mm/proc.S
@@ -70,11 +70,14 @@ ENTRY(cpu_do_suspend)
 	mrs	x8, mdscr_el1
 	mrs	x9, oslsr_el1
 	mrs	x10, sctlr_el1
+	mrs	x11, tpidr_el1
+	mrs	x12, sp_el0
 	stp	x2, x3, [x0]
 	stp	x4, xzr, [x0, #16]
 	stp	x5, x6, [x0, #32]
 	stp	x7, x8, [x0, #48]
 	stp	x9, x10, [x0, #64]
+	stp	x11, x12, [x0, #80]
 	ret
 ENDPROC(cpu_do_suspend)
 
@@ -90,6 +93,7 @@ ENTRY(cpu_do_resume)
 	ldp	x6, x8, [x0, #32]
 	ldp	x9, x10, [x0, #48]
 	ldp	x11, x12, [x0, #64]
+	ldp	x13, x14, [x0, #80]
 	msr	tpidr_el0, x2
 	msr	tpidrro_el0, x3
 	msr	contextidr_el1, x4
@@ -112,6 +116,8 @@ ENTRY(cpu_do_resume)
 	msr	mdscr_el1, x10
 
 	msr	sctlr_el1, x12
+	msr	tpidr_el1, x13
+	msr	sp_el0, x14
 	/*
 	 * Restore oslsr_el1 by writing oslar_el1
 	 */
@@ -134,6 +140,9 @@ ENDPROC(cpu_do_resume)
 ENTRY(cpu_do_switch_mm)
 	mrs	x2, ttbr1_el1
 	mmid	x1, x1				// get mm->context.id
+#ifdef CONFIG_ARM64_SW_TTBR0_PAN
+	bfi	x0, x1, #48, #16		// set the ASID field in TTBR0
+#endif
 	bfi	x2, x1, #48, #16		// set the ASID
 	msr	ttbr1_el1, x2			// in TTBR1 (since TCR.A1 is set)
 	isb
diff --git a/arch/arm64/xen/hypercall.S b/arch/arm64/xen/hypercall.S
index 329c802..5c0b8e03 100644
--- a/arch/arm64/xen/hypercall.S
+++ b/arch/arm64/xen/hypercall.S
@@ -49,17 +49,58 @@
 
 #include <linux/linkage.h>
 #include <asm/assembler.h>
+#include <asm/uaccess.h>
 #include <xen/interface/xen.h>
 
+#ifdef CONFIG_RTK_TRACER
+#define LOGK_HVC	(13) /* sync with linux/rtk_trace.h */
+.extern uncached_logk
+
+.macro rtktrace_record
+	stp x29, x30, [sp,#-64]!
+	stp x19, x20, [sp,#16]
+	stp x21, x22, [sp,#32]
+	stp x23, x24, [sp,#48]
+	mov x19, x0
+	mov x20, x1
+	mov x21, x2
+	mov x22, x3
+	mov x23, x4
+	mov x24, x5
+	mov x1, x0
+	mov x0, #LOGK_HVC
+	bl uncached_logk
+	mov x0, x19
+	mov x1, x20
+	mov x2, x21
+	mov x3, x22
+	mov x4, x23
+	mov x5, x24
+	ldp x19, x20, [sp,#16]
+	ldp x21, x22, [sp,#32]
+	ldp x23, x24, [sp,#48]
+	ldp x29, x30, [sp], #64
+.endm
+#endif
 
 #define XEN_IMM 0xEA1
 
+#ifdef CONFIG_RTK_TRACER
+#define HYPERCALL_SIMPLE(hypercall)		\
+ENTRY(HYPERVISOR_##hypercall)			\
+	rtktrace_record;			\
+	mov x16, #__HYPERVISOR_##hypercall;	\
+	hvc XEN_IMM;				\
+	ret;					\
+ENDPROC(HYPERVISOR_##hypercall)
+#else /* !CONFIG_RTK_TRACER */
 #define HYPERCALL_SIMPLE(hypercall)		\
 ENTRY(HYPERVISOR_##hypercall)			\
 	mov x16, #__HYPERVISOR_##hypercall;	\
 	hvc XEN_IMM;				\
 	ret;					\
 ENDPROC(HYPERVISOR_##hypercall)
+#endif /* CONFIG_RTK_TRACER */
 
 #define HYPERCALL0 HYPERCALL_SIMPLE
 #define HYPERCALL1 HYPERCALL_SIMPLE
@@ -84,7 +125,13 @@ HYPERCALL1(platform_op_raw);
 HYPERCALL2(multicall);
 HYPERCALL2(vm_assist);
 
+#ifdef CONFIG_RTK_XEN_HYPERCALL
+HYPERCALL2(rtk_hypercall_op);
+#endif
+
+#ifdef CONFIG_RTK_TRACER
 ENTRY(privcmd_call)
+	rtktrace_record
 	mov x16, x0
 	mov x0, x1
 	mov x1, x2
@@ -94,3 +141,29 @@ ENTRY(privcmd_call)
 	hvc XEN_IMM
 	ret
 ENDPROC(privcmd_call);
+#else /* !CONFIG_RTK_TRACER */
+ENTRY(privcmd_call)
+	mov x16, x0
+	mov x0, x1
+	mov x1, x2
+	mov x2, x3
+	mov x3, x4
+	mov x4, x5
+	/*
+	 * Privcmd calls are issued by the userspace. The kernel needs to
+	 * enable access to TTBR0_EL1 as the hypervisor would issue stage 1
+	 * translations to user memory via AT instructions. Since AT
+	 * instructions are not affected by the PAN bit (ARMv8.1), we only
+	 * need the explicit uaccess_enable/disable if the TTBR0 PAN emulation
+	 * is enabled (it implies that hardware UAO and PAN disabled).
+	 */
+	uaccess_ttbr0_enable x6, x7, x8
+	hvc XEN_IMM
+
+	/*
+	 * Disable userspace access from kernel once the hyp call completed.
+	 */
+	uaccess_ttbr0_disable x6, x7
+	ret
+ENDPROC(privcmd_call);
+#endif /* CONFIG_RTK_TRACER */
diff --git a/arch/avr32/include/uapi/asm/socket.h b/arch/avr32/include/uapi/asm/socket.h
index 1fd147f..5f10f9b 100644
--- a/arch/avr32/include/uapi/asm/socket.h
+++ b/arch/avr32/include/uapi/asm/socket.h
@@ -90,4 +90,6 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif /* _UAPI__ASM_AVR32_SOCKET_H */
diff --git a/arch/frv/include/uapi/asm/socket.h b/arch/frv/include/uapi/asm/socket.h
index afbc98f0..ed960d3 100644
--- a/arch/frv/include/uapi/asm/socket.h
+++ b/arch/frv/include/uapi/asm/socket.h
@@ -90,5 +90,7 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif /* _ASM_SOCKET_H */
 
diff --git a/arch/ia64/include/uapi/asm/socket.h b/arch/ia64/include/uapi/asm/socket.h
index 0018fad..9790d13 100644
--- a/arch/ia64/include/uapi/asm/socket.h
+++ b/arch/ia64/include/uapi/asm/socket.h
@@ -99,4 +99,6 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif /* _ASM_IA64_SOCKET_H */
diff --git a/arch/ia64/kernel/Makefile b/arch/ia64/kernel/Makefile
index 3686d6a..9edda54 100644
--- a/arch/ia64/kernel/Makefile
+++ b/arch/ia64/kernel/Makefile
@@ -50,32 +50,10 @@ CFLAGS_traps.o  += -mfixed-range=f2-f5,f16-f31
 # The gate DSO image is built using a special linker script.
 include $(src)/Makefile.gate
 
-# Calculate NR_IRQ = max(IA64_NATIVE_NR_IRQS, XEN_NR_IRQS, ...) based on config
-define sed-y
-	"/^->/{s:^->\([^ ]*\) [\$$#]*\([^ ]*\) \(.*\):#define \1 \2 /* \3 */:; s:->::; p;}"
-endef
-quiet_cmd_nr_irqs = GEN     $@
-define cmd_nr_irqs
-	(set -e; \
-	 echo "#ifndef __ASM_NR_IRQS_H__"; \
-	 echo "#define __ASM_NR_IRQS_H__"; \
-	 echo "/*"; \
-	 echo " * DO NOT MODIFY."; \
-	 echo " *"; \
-	 echo " * This file was generated by Kbuild"; \
-	 echo " *"; \
-	 echo " */"; \
-	 echo ""; \
-	 sed -ne $(sed-y) $<; \
-	 echo ""; \
-	 echo "#endif" ) > $@
-endef
-
 # We use internal kbuild rules to avoid the "is up to date" message from make
 arch/$(SRCARCH)/kernel/nr-irqs.s: arch/$(SRCARCH)/kernel/nr-irqs.c
 	$(Q)mkdir -p $(dir $@)
 	$(call if_changed_dep,cc_s_c)
 
-include/generated/nr-irqs.h: arch/$(SRCARCH)/kernel/nr-irqs.s
-	$(Q)mkdir -p $(dir $@)
-	$(call cmd,nr_irqs)
+include/generated/nr-irqs.h: arch/$(SRCARCH)/kernel/nr-irqs.s FORCE
+	$(call filechk,offsets,__ASM_NR_IRQS_H__)
diff --git a/arch/m32r/include/uapi/asm/socket.h b/arch/m32r/include/uapi/asm/socket.h
index 5fe42fc..ad25676 100644
--- a/arch/m32r/include/uapi/asm/socket.h
+++ b/arch/m32r/include/uapi/asm/socket.h
@@ -90,4 +90,6 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif /* _ASM_M32R_SOCKET_H */
diff --git a/arch/mips/include/uapi/asm/socket.h b/arch/mips/include/uapi/asm/socket.h
index 2027240a..2f106d0 100644
--- a/arch/mips/include/uapi/asm/socket.h
+++ b/arch/mips/include/uapi/asm/socket.h
@@ -108,4 +108,6 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif /* _UAPI_ASM_SOCKET_H */
diff --git a/arch/mn10300/include/uapi/asm/socket.h b/arch/mn10300/include/uapi/asm/socket.h
index 5129f23..69f9618 100644
--- a/arch/mn10300/include/uapi/asm/socket.h
+++ b/arch/mn10300/include/uapi/asm/socket.h
@@ -90,4 +90,6 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif /* _ASM_SOCKET_H */
diff --git a/arch/parisc/include/uapi/asm/socket.h b/arch/parisc/include/uapi/asm/socket.h
index 9c935d7..b96a193 100644
--- a/arch/parisc/include/uapi/asm/socket.h
+++ b/arch/parisc/include/uapi/asm/socket.h
@@ -89,4 +89,6 @@
 
 #define SO_CNX_ADVICE		0x402E
 
+#define SO_COOKIE		0x4032
+
 #endif /* _UAPI_ASM_SOCKET_H */
diff --git a/arch/powerpc/include/uapi/asm/socket.h b/arch/powerpc/include/uapi/asm/socket.h
index 1672e33..e78550f 100644
--- a/arch/powerpc/include/uapi/asm/socket.h
+++ b/arch/powerpc/include/uapi/asm/socket.h
@@ -97,4 +97,6 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif	/* _ASM_POWERPC_SOCKET_H */
diff --git a/arch/powerpc/platforms/pseries/cmm.c b/arch/powerpc/platforms/pseries/cmm.c
index 66e7227..85018a1 100644
--- a/arch/powerpc/platforms/pseries/cmm.c
+++ b/arch/powerpc/platforms/pseries/cmm.c
@@ -708,7 +708,7 @@ static void cmm_exit(void)
  * Return value:
  * 	0 on success / other on failure
  **/
-static int cmm_set_disable(const char *val, struct kernel_param *kp)
+static int cmm_set_disable(const char *val, const struct kernel_param *kp)
 {
 	int disable = simple_strtoul(val, NULL, 10);
 
diff --git a/arch/s390/include/uapi/asm/socket.h b/arch/s390/include/uapi/asm/socket.h
index 41b51c2..04fe908 100644
--- a/arch/s390/include/uapi/asm/socket.h
+++ b/arch/s390/include/uapi/asm/socket.h
@@ -96,4 +96,6 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif /* _ASM_SOCKET_H */
diff --git a/arch/sh/boot/compressed/vmlinux.scr b/arch/sh/boot/compressed/vmlinux.scr
deleted file mode 100644
index 862d748..00000000
--- a/arch/sh/boot/compressed/vmlinux.scr
+++ /dev/null
@@ -1,10 +0,0 @@
-SECTIONS
-{
-  .rodata..compressed : {
-	input_len = .;
-	LONG(input_data_end - input_data) input_data = .;
-	*(.data)
-	output_len = . - 4;
-	input_data_end = .;
-	}
-}
diff --git a/arch/sh/boot/romimage/vmlinux.scr b/arch/sh/boot/romimage/vmlinux.scr
deleted file mode 100644
index 590394e..00000000
--- a/arch/sh/boot/romimage/vmlinux.scr
+++ /dev/null
@@ -1,8 +0,0 @@
-SECTIONS
-{
-  .text : {
-	zero_page_pos = .;
-	*(.data)
-	end_data = .;
-	}
-}
diff --git a/arch/sparc/include/uapi/asm/socket.h b/arch/sparc/include/uapi/asm/socket.h
index 31aede3..de15f0a 100644
--- a/arch/sparc/include/uapi/asm/socket.h
+++ b/arch/sparc/include/uapi/asm/socket.h
@@ -86,6 +86,8 @@
 
 #define SO_CNX_ADVICE		0x0037
 
+#define SO_COOKIE		0x003b
+
 /* Security levels - as per NRL IPv6 - don't actually do anything */
 #define SO_SECURITY_AUTHENTICATION		0x5001
 #define SO_SECURITY_ENCRYPTION_TRANSPORT	0x5002
diff --git a/arch/x86/Makefile b/arch/x86/Makefile
index f408bab..93b170e 100644
--- a/arch/x86/Makefile
+++ b/arch/x86/Makefile
@@ -11,6 +11,16 @@ else
         KBUILD_DEFCONFIG := $(ARCH)_defconfig
 endif
 
+# For gcc stack alignment is specified with -mpreferred-stack-boundary,
+# clang has the option -mstack-alignment for that purpose.
+ifneq ($(call cc-option, -mpreferred-stack-boundary=4),)
+      cc_stack_align4 := -mpreferred-stack-boundary=2
+      cc_stack_align8 := -mpreferred-stack-boundary=3
+else ifneq ($(call cc-option, -mstack-alignment=16),)
+      cc_stack_align4 := -mstack-alignment=4
+      cc_stack_align8 := -mstack-alignment=8
+endif
+
 # How to compile the 16-bit code.  Note we always compile for -march=i386;
 # that way we can complain to the user if the CPU is insufficient.
 #
@@ -24,10 +34,11 @@ REALMODE_CFLAGS	:= $(M16_CFLAGS) -g -Os -D__KERNEL__ \
 		   -DDISABLE_BRANCH_PROFILING \
 		   -Wall -Wstrict-prototypes -march=i386 -mregparm=3 \
 		   -fno-strict-aliasing -fomit-frame-pointer -fno-pic \
-		   -mno-mmx -mno-sse \
-		   $(call cc-option, -ffreestanding) \
-		   $(call cc-option, -fno-stack-protector) \
-		   $(call cc-option, -mpreferred-stack-boundary=2)
+		   -mno-mmx -mno-sse
+
+REALMODE_CFLAGS += $(call __cc-option, $(CC), $(REALMODE_CFLAGS), -ffreestanding)
+REALMODE_CFLAGS += $(call __cc-option, $(CC), $(REALMODE_CFLAGS), -fno-stack-protector)
+REALMODE_CFLAGS += $(call __cc-option, $(CC), $(REALMODE_CFLAGS), $(cc_stack_align4))
 export REALMODE_CFLAGS
 
 # BITS is used as extension for files which are available in a 32 bit
@@ -64,8 +75,10 @@ ifeq ($(CONFIG_X86_32),y)
         # with nonstandard options
         KBUILD_CFLAGS += -fno-pic
 
-        # prevent gcc from keeping the stack 16 byte aligned
-        KBUILD_CFLAGS += $(call cc-option,-mpreferred-stack-boundary=2)
+        # Align the stack to the register width instead of using the default
+        # alignment of 16 bytes. This reduces stack usage and the number of
+        # alignment instructions.
+        KBUILD_CFLAGS += $(call cc-option,$(cc_stack_align4))
 
         # Disable unit-at-a-time mode on pre-gcc-4.0 compilers, it makes gcc use
         # a lot more stack due to the lack of sharing of stacklots:
@@ -88,17 +101,25 @@ else
         KBUILD_CFLAGS += -m64
 
         # Align jump targets to 1 byte, not the default 16 bytes:
-        KBUILD_CFLAGS += -falign-jumps=1
+        KBUILD_CFLAGS += $(call cc-option,-falign-jumps=1)
 
         # Pack loops tightly as well:
-        KBUILD_CFLAGS += -falign-loops=1
+        KBUILD_CFLAGS += $(call cc-option,-falign-loops=1)
 
         # Don't autogenerate traditional x87 instructions
         KBUILD_CFLAGS += $(call cc-option,-mno-80387)
         KBUILD_CFLAGS += $(call cc-option,-mno-fp-ret-in-387)
 
-	# Use -mpreferred-stack-boundary=3 if supported.
-	KBUILD_CFLAGS += $(call cc-option,-mpreferred-stack-boundary=3)
+        KBUILD_CFLAGS += -fno-pic
+
+        # By default gcc and clang use a stack alignment of 16 bytes for x86.
+        # However the standard kernel entry on x86-64 leaves the stack on an
+        # 8-byte boundary. If the compiler isn't informed about the actual
+        # alignment it will generate extra alignment instructions for the
+        # default alignment which keep the stack *mis*aligned.
+        # Furthermore an alignment to the register width reduces stack usage
+        # and the number of alignment instructions.
+        KBUILD_CFLAGS += $(call cc-option,$(cc_stack_align8))
 
 	# Use -mskip-rax-setup if supported.
 	KBUILD_CFLAGS += $(call cc-option,-mskip-rax-setup)
diff --git a/arch/x86/boot/string.c b/arch/x86/boot/string.c
index 9e240fc..08dfce0 100644
--- a/arch/x86/boot/string.c
+++ b/arch/x86/boot/string.c
@@ -16,6 +16,15 @@
 #include "ctype.h"
 #include "string.h"
 
+/*
+ * Undef these macros so that the functions that we provide
+ * here will have the correct names regardless of how string.h
+ * may have chosen to #define them.
+ */
+#undef memcpy
+#undef memset
+#undef memcmp
+
 int memcmp(const void *s1, const void *s2, size_t len)
 {
 	bool diff;
diff --git a/arch/x86/configs/i386_ranchu_defconfig b/arch/x86/configs/i386_ranchu_defconfig
new file mode 100644
index 00000000..a1c83c4
--- /dev/null
+++ b/arch/x86/configs/i386_ranchu_defconfig
@@ -0,0 +1,424 @@
+# CONFIG_64BIT is not set
+# CONFIG_LOCALVERSION_AUTO is not set
+CONFIG_POSIX_MQUEUE=y
+CONFIG_AUDIT=y
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_BSD_PROCESS_ACCT=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_DEBUG=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_BLK_DEV_INITRD=y
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_SYSCTL_SYSCALL=y
+CONFIG_KALLSYMS_ALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_COMPAT_BRK is not set
+CONFIG_ARCH_MMAP_RND_BITS=16
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_OSF_PARTITION=y
+CONFIG_AMIGA_PARTITION=y
+CONFIG_MAC_PARTITION=y
+CONFIG_BSD_DISKLABEL=y
+CONFIG_MINIX_SUBPARTITION=y
+CONFIG_SOLARIS_X86_PARTITION=y
+CONFIG_UNIXWARE_DISKLABEL=y
+CONFIG_SGI_PARTITION=y
+CONFIG_SUN_PARTITION=y
+CONFIG_KARMA_PARTITION=y
+CONFIG_SMP=y
+CONFIG_X86_BIGSMP=y
+CONFIG_MCORE2=y
+CONFIG_X86_GENERIC=y
+CONFIG_HPET_TIMER=y
+CONFIG_NR_CPUS=512
+CONFIG_PREEMPT=y
+# CONFIG_X86_MCE is not set
+CONFIG_X86_REBOOTFIXUPS=y
+CONFIG_X86_MSR=y
+CONFIG_X86_CPUID=y
+CONFIG_KSM=y
+CONFIG_CMA=y
+# CONFIG_MTRR_SANITIZER is not set
+CONFIG_EFI=y
+CONFIG_EFI_STUB=y
+CONFIG_HZ_100=y
+CONFIG_PHYSICAL_START=0x100000
+CONFIG_PM_AUTOSLEEP=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_CPU_FREQ=y
+# CONFIG_CPU_FREQ_STAT is not set
+CONFIG_CPU_FREQ_DEFAULT_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_PCIEPORTBUS=y
+# CONFIG_PCIEASPM is not set
+CONFIG_PCCARD=y
+CONFIG_YENTA=y
+CONFIG_HOTPLUG_PCI=y
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_BINFMT_MISC=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_XFRM_USER=y
+CONFIG_NET_KEY=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_PIMSM_V1=y
+CONFIG_IP_PIMSM_V2=y
+CONFIG_SYN_COOKIES=y
+CONFIG_INET_ESP=y
+# CONFIG_INET_XFRM_MODE_BEET is not set
+# CONFIG_INET_LRO is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_IPV6_ROUTER_PREF=y
+CONFIG_IPV6_ROUTE_INFO=y
+CONFIG_IPV6_OPTIMISTIC_DAD=y
+CONFIG_INET6_AH=y
+CONFIG_INET6_ESP=y
+CONFIG_INET6_IPCOMP=y
+CONFIG_IPV6_MIP6=y
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_NETLABEL=y
+CONFIG_NETFILTER=y
+CONFIG_NF_CONNTRACK=y
+CONFIG_NF_CONNTRACK_SECMARK=y
+CONFIG_NF_CONNTRACK_EVENTS=y
+CONFIG_NF_CT_PROTO_DCCP=y
+CONFIG_NF_CT_PROTO_SCTP=y
+CONFIG_NF_CT_PROTO_UDPLITE=y
+CONFIG_NF_CONNTRACK_AMANDA=y
+CONFIG_NF_CONNTRACK_FTP=y
+CONFIG_NF_CONNTRACK_H323=y
+CONFIG_NF_CONNTRACK_IRC=y
+CONFIG_NF_CONNTRACK_NETBIOS_NS=y
+CONFIG_NF_CONNTRACK_PPTP=y
+CONFIG_NF_CONNTRACK_SANE=y
+CONFIG_NF_CONNTRACK_TFTP=y
+CONFIG_NF_CT_NETLINK=y
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=y
+CONFIG_NETFILTER_XT_TARGET_CONNMARK=y
+CONFIG_NETFILTER_XT_TARGET_CONNSECMARK=y
+CONFIG_NETFILTER_XT_TARGET_IDLETIMER=y
+CONFIG_NETFILTER_XT_TARGET_MARK=y
+CONFIG_NETFILTER_XT_TARGET_NFLOG=y
+CONFIG_NETFILTER_XT_TARGET_NFQUEUE=y
+CONFIG_NETFILTER_XT_TARGET_TPROXY=y
+CONFIG_NETFILTER_XT_TARGET_TRACE=y
+CONFIG_NETFILTER_XT_TARGET_SECMARK=y
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=y
+CONFIG_NETFILTER_XT_MATCH_COMMENT=y
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=y
+CONFIG_NETFILTER_XT_MATCH_CONNMARK=y
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=y
+CONFIG_NETFILTER_XT_MATCH_HASHLIMIT=y
+CONFIG_NETFILTER_XT_MATCH_HELPER=y
+CONFIG_NETFILTER_XT_MATCH_IPRANGE=y
+CONFIG_NETFILTER_XT_MATCH_LENGTH=y
+CONFIG_NETFILTER_XT_MATCH_LIMIT=y
+CONFIG_NETFILTER_XT_MATCH_MAC=y
+CONFIG_NETFILTER_XT_MATCH_MARK=y
+CONFIG_NETFILTER_XT_MATCH_POLICY=y
+CONFIG_NETFILTER_XT_MATCH_PKTTYPE=y
+CONFIG_NETFILTER_XT_MATCH_QTAGUID=y
+CONFIG_NETFILTER_XT_MATCH_QUOTA=y
+CONFIG_NETFILTER_XT_MATCH_QUOTA2=y
+CONFIG_NETFILTER_XT_MATCH_SOCKET=y
+CONFIG_NETFILTER_XT_MATCH_STATE=y
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=y
+CONFIG_NETFILTER_XT_MATCH_STRING=y
+CONFIG_NETFILTER_XT_MATCH_TIME=y
+CONFIG_NETFILTER_XT_MATCH_U32=y
+CONFIG_NF_CONNTRACK_IPV4=y
+CONFIG_IP_NF_IPTABLES=y
+CONFIG_IP_NF_MATCH_AH=y
+CONFIG_IP_NF_MATCH_ECN=y
+CONFIG_IP_NF_MATCH_TTL=y
+CONFIG_IP_NF_FILTER=y
+CONFIG_IP_NF_TARGET_REJECT=y
+CONFIG_IP_NF_MANGLE=y
+CONFIG_IP_NF_RAW=y
+CONFIG_IP_NF_SECURITY=y
+CONFIG_IP_NF_ARPTABLES=y
+CONFIG_IP_NF_ARPFILTER=y
+CONFIG_IP_NF_ARP_MANGLE=y
+CONFIG_NF_CONNTRACK_IPV6=y
+CONFIG_IP6_NF_IPTABLES=y
+CONFIG_IP6_NF_FILTER=y
+CONFIG_IP6_NF_TARGET_REJECT=y
+CONFIG_IP6_NF_MANGLE=y
+CONFIG_IP6_NF_RAW=y
+CONFIG_NET_SCHED=y
+CONFIG_NET_SCH_HTB=y
+CONFIG_NET_CLS_U32=y
+CONFIG_NET_EMATCH=y
+CONFIG_NET_EMATCH_U32=y
+CONFIG_NET_CLS_ACT=y
+CONFIG_CFG80211=y
+CONFIG_MAC80211=y
+CONFIG_MAC80211_LEDS=y
+CONFIG_UEVENT_HELPER_PATH="/sbin/hotplug"
+CONFIG_DMA_CMA=y
+CONFIG_CMA_SIZE_MBYTES=16
+CONFIG_CONNECTOR=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_RAM_SIZE=8192
+CONFIG_VIRTIO_BLK=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_BLK_DEV_SR=y
+CONFIG_BLK_DEV_SR_VENDOR=y
+CONFIG_CHR_DEV_SG=y
+CONFIG_SCSI_CONSTANTS=y
+CONFIG_SCSI_SPI_ATTRS=y
+CONFIG_SCSI_ISCSI_ATTRS=y
+# CONFIG_SCSI_LOWLEVEL is not set
+CONFIG_ATA=y
+CONFIG_SATA_AHCI=y
+CONFIG_ATA_PIIX=y
+CONFIG_PATA_AMD=y
+CONFIG_PATA_OLDPIIX=y
+CONFIG_PATA_SCH=y
+CONFIG_PATA_MPIIX=y
+CONFIG_ATA_GENERIC=y
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=y
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_DEBUG=y
+CONFIG_DM_CRYPT=y
+CONFIG_DM_MIRROR=y
+CONFIG_DM_ZERO=y
+CONFIG_DM_UEVENT=y
+CONFIG_DM_VERITY=y
+CONFIG_DM_VERITY_FEC=y
+CONFIG_NETDEVICES=y
+CONFIG_NETCONSOLE=y
+CONFIG_TUN=y
+CONFIG_VIRTIO_NET=y
+CONFIG_BNX2=y
+CONFIG_TIGON3=y
+CONFIG_NET_TULIP=y
+CONFIG_E100=y
+CONFIG_E1000=y
+CONFIG_E1000E=y
+CONFIG_SKY2=y
+CONFIG_NE2K_PCI=y
+CONFIG_FORCEDETH=y
+CONFIG_8139TOO=y
+# CONFIG_8139TOO_PIO is not set
+CONFIG_R8169=y
+CONFIG_FDDI=y
+CONFIG_PPP=y
+CONFIG_PPP_BSDCOMP=y
+CONFIG_PPP_DEFLATE=y
+CONFIG_PPP_MPPE=y
+CONFIG_PPPOLAC=y
+CONFIG_PPPOPNS=y
+CONFIG_USB_USBNET=y
+CONFIG_INPUT_POLLDEV=y
+# CONFIG_INPUT_MOUSEDEV_PSAUX is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_INPUT_KEYRESET=y
+# CONFIG_KEYBOARD_ATKBD is not set
+CONFIG_KEYBOARD_GOLDFISH_EVENTS=y
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_JOYSTICK=y
+CONFIG_JOYSTICK_XPAD=y
+CONFIG_JOYSTICK_XPAD_FF=y
+CONFIG_JOYSTICK_XPAD_LEDS=y
+CONFIG_INPUT_TABLET=y
+CONFIG_TABLET_USB_ACECAD=y
+CONFIG_TABLET_USB_AIPTEK=y
+CONFIG_TABLET_USB_GTCO=y
+CONFIG_TABLET_USB_HANWANG=y
+CONFIG_TABLET_USB_KBTAB=y
+CONFIG_INPUT_TOUCHSCREEN=y
+CONFIG_INPUT_MISC=y
+CONFIG_INPUT_KEYCHORD=y
+CONFIG_INPUT_UINPUT=y
+CONFIG_INPUT_GPIO=y
+# CONFIG_SERIO is not set
+# CONFIG_VT is not set
+# CONFIG_LEGACY_PTYS is not set
+CONFIG_SERIAL_NONSTANDARD=y
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_VIRTIO_CONSOLE=y
+CONFIG_NVRAM=y
+CONFIG_I2C_I801=y
+CONFIG_BATTERY_GOLDFISH=y
+CONFIG_WATCHDOG=y
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_AGP=y
+CONFIG_AGP_AMD64=y
+CONFIG_AGP_INTEL=y
+CONFIG_DRM=y
+CONFIG_FB_MODE_HELPERS=y
+CONFIG_FB_TILEBLITTING=y
+CONFIG_FB_EFI=y
+CONFIG_FB_GOLDFISH=y
+CONFIG_BACKLIGHT_LCD_SUPPORT=y
+# CONFIG_LCD_CLASS_DEVICE is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_HIDRAW=y
+CONFIG_UHID=y
+CONFIG_HID_A4TECH=y
+CONFIG_HID_ACRUX=y
+CONFIG_HID_ACRUX_FF=y
+CONFIG_HID_APPLE=y
+CONFIG_HID_BELKIN=y
+CONFIG_HID_CHERRY=y
+CONFIG_HID_CHICONY=y
+CONFIG_HID_PRODIKEYS=y
+CONFIG_HID_CYPRESS=y
+CONFIG_HID_DRAGONRISE=y
+CONFIG_DRAGONRISE_FF=y
+CONFIG_HID_EMS_FF=y
+CONFIG_HID_ELECOM=y
+CONFIG_HID_EZKEY=y
+CONFIG_HID_HOLTEK=y
+CONFIG_HID_KEYTOUCH=y
+CONFIG_HID_KYE=y
+CONFIG_HID_UCLOGIC=y
+CONFIG_HID_WALTOP=y
+CONFIG_HID_GYRATION=y
+CONFIG_HID_TWINHAN=y
+CONFIG_HID_KENSINGTON=y
+CONFIG_HID_LCPOWER=y
+CONFIG_HID_LOGITECH=y
+CONFIG_HID_LOGITECH_DJ=y
+CONFIG_LOGITECH_FF=y
+CONFIG_LOGIRUMBLEPAD2_FF=y
+CONFIG_LOGIG940_FF=y
+CONFIG_HID_MAGICMOUSE=y
+CONFIG_HID_MICROSOFT=y
+CONFIG_HID_MONTEREY=y
+CONFIG_HID_MULTITOUCH=y
+CONFIG_HID_NTRIG=y
+CONFIG_HID_ORTEK=y
+CONFIG_HID_PANTHERLORD=y
+CONFIG_PANTHERLORD_FF=y
+CONFIG_HID_PETALYNX=y
+CONFIG_HID_PICOLCD=y
+CONFIG_HID_PRIMAX=y
+CONFIG_HID_ROCCAT=y
+CONFIG_HID_SAITEK=y
+CONFIG_HID_SAMSUNG=y
+CONFIG_HID_SONY=y
+CONFIG_HID_SPEEDLINK=y
+CONFIG_HID_SUNPLUS=y
+CONFIG_HID_GREENASIA=y
+CONFIG_GREENASIA_FF=y
+CONFIG_HID_SMARTJOYPLUS=y
+CONFIG_SMARTJOYPLUS_FF=y
+CONFIG_HID_TIVO=y
+CONFIG_HID_TOPSEED=y
+CONFIG_HID_THRUSTMASTER=y
+CONFIG_HID_WACOM=y
+CONFIG_HID_WIIMOTE=y
+CONFIG_HID_ZEROPLUS=y
+CONFIG_HID_ZYDACRON=y
+CONFIG_HID_PID=y
+CONFIG_USB_HIDDEV=y
+CONFIG_USB_ANNOUNCE_NEW_DEVICES=y
+CONFIG_USB_MON=y
+CONFIG_USB_EHCI_HCD=y
+# CONFIG_USB_EHCI_TT_NEWSCHED is not set
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_UHCI_HCD=y
+CONFIG_USB_PRINTER=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_OTG_WAKELOCK=y
+CONFIG_EDAC=y
+CONFIG_RTC_CLASS=y
+# CONFIG_RTC_HCTOSYS is not set
+CONFIG_DMADEVICES=y
+CONFIG_VIRTIO_PCI=y
+CONFIG_STAGING=y
+CONFIG_ASHMEM=y
+CONFIG_ANDROID_LOW_MEMORY_KILLER=y
+CONFIG_SYNC=y
+CONFIG_SW_SYNC=y
+CONFIG_SYNC_FILE=y
+CONFIG_ION=y
+CONFIG_GOLDFISH_AUDIO=y
+CONFIG_SND_HDA_INTEL=y
+CONFIG_GOLDFISH=y
+CONFIG_GOLDFISH_PIPE=y
+CONFIG_GOLDFISH_SYNC=y
+CONFIG_ANDROID=y
+CONFIG_ANDROID_BINDER_IPC=y
+CONFIG_ISCSI_IBFT_FIND=y
+CONFIG_EXT4_FS=y
+CONFIG_EXT4_FS_SECURITY=y
+CONFIG_QUOTA=y
+CONFIG_QUOTA_NETLINK_INTERFACE=y
+# CONFIG_PRINT_QUOTA_WARNING is not set
+CONFIG_FUSE_FS=y
+CONFIG_ISO9660_FS=y
+CONFIG_JOLIET=y
+CONFIG_ZISOFS=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_KCORE=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_POSIX_ACL=y
+CONFIG_HUGETLBFS=y
+CONFIG_PSTORE=y
+CONFIG_PSTORE_CONSOLE=y
+CONFIG_PSTORE_RAM=y
+# CONFIG_NETWORK_FILESYSTEMS is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ASCII=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DEBUG_INFO=y
+# CONFIG_ENABLE_WARN_DEPRECATED is not set
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_FRAME_WARN=2048
+# CONFIG_UNUSED_SYMBOLS is not set
+CONFIG_MAGIC_SYSRQ=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_PANIC_TIMEOUT=5
+CONFIG_SCHEDSTATS=y
+CONFIG_TIMER_STATS=y
+CONFIG_SCHED_TRACER=y
+CONFIG_BLK_DEV_IO_TRACE=y
+CONFIG_PROVIDE_OHCI1394_DMA_INIT=y
+CONFIG_KEYS=y
+CONFIG_SECURITY=y
+CONFIG_SECURITY_NETWORK=y
+CONFIG_SECURITY_SELINUX=y
+CONFIG_CRYPTO_AES_586=y
+CONFIG_CRYPTO_TWOFISH=y
+CONFIG_ASYMMETRIC_KEY_TYPE=y
+CONFIG_ASYMMETRIC_PUBLIC_KEY_SUBTYPE=y
+CONFIG_X509_CERTIFICATE_PARSER=y
+CONFIG_PKCS7_MESSAGE_PARSER=y
+CONFIG_PKCS7_TEST_KEY=y
+# CONFIG_VIRTUALIZATION is not set
+CONFIG_CRC_T10DIF=y
diff --git a/arch/x86/configs/x86_64_cuttlefish_defconfig b/arch/x86/configs/x86_64_cuttlefish_defconfig
new file mode 100644
index 00000000..e985b3c
--- /dev/null
+++ b/arch/x86/configs/x86_64_cuttlefish_defconfig
@@ -0,0 +1,472 @@
+CONFIG_POSIX_MQUEUE=y
+# CONFIG_FHANDLE is not set
+# CONFIG_USELIB is not set
+CONFIG_AUDIT=y
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_BSD_PROCESS_ACCT=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_IKCONFIG=y
+CONFIG_IKCONFIG_PROC=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_DEBUG=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_MEMCG=y
+CONFIG_MEMCG_SWAP=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_CGROUP_BPF=y
+CONFIG_NAMESPACES=y
+CONFIG_BLK_DEV_INITRD=y
+# CONFIG_RD_LZ4 is not set
+CONFIG_KALLSYMS_ALL=y
+# CONFIG_PCSPKR_PLATFORM is not set
+CONFIG_BPF_SYSCALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_COMPAT_BRK is not set
+CONFIG_PROFILING=y
+CONFIG_OPROFILE=y
+CONFIG_KPROBES=y
+CONFIG_JUMP_LABEL=y
+CONFIG_CC_STACKPROTECTOR_STRONG=y
+CONFIG_MODULES=y
+CONFIG_MODULE_UNLOAD=y
+CONFIG_MODVERSIONS=y
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_SMP=y
+CONFIG_HYPERVISOR_GUEST=y
+CONFIG_PARAVIRT=y
+CONFIG_PARAVIRT_SPINLOCKS=y
+CONFIG_MCORE2=y
+CONFIG_PROCESSOR_SELECT=y
+# CONFIG_CPU_SUP_CENTAUR is not set
+CONFIG_NR_CPUS=8
+CONFIG_PREEMPT=y
+# CONFIG_MICROCODE is not set
+CONFIG_X86_MSR=y
+CONFIG_X86_CPUID=y
+CONFIG_KSM=y
+CONFIG_DEFAULT_MMAP_MIN_ADDR=65536
+CONFIG_TRANSPARENT_HUGEPAGE=y
+# CONFIG_MTRR is not set
+CONFIG_HZ_100=y
+CONFIG_KEXEC=y
+CONFIG_CRASH_DUMP=y
+CONFIG_PHYSICAL_START=0x200000
+CONFIG_RANDOMIZE_BASE=y
+CONFIG_PHYSICAL_ALIGN=0x1000000
+CONFIG_CMDLINE_BOOL=y
+CONFIG_CMDLINE="console=ttyS0 reboot=p nopti"
+CONFIG_PM_AUTOSLEEP=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_ACPI_PROCFS_POWER=y
+# CONFIG_ACPI_FAN is not set
+# CONFIG_ACPI_THERMAL is not set
+# CONFIG_X86_PM_TIMER is not set
+CONFIG_CPU_FREQ=y
+CONFIG_CPU_FREQ_GOV_ONDEMAND=y
+CONFIG_X86_ACPI_CPUFREQ=y
+# CONFIG_X86_ACPI_CPUFREQ_CPB is not set
+CONFIG_PCI_MMCONFIG=y
+CONFIG_PCI_MSI=y
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_BINFMT_MISC=y
+CONFIG_IA32_EMULATION=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_XFRM_USER=y
+CONFIG_NET_KEY=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_PIMSM_V1=y
+CONFIG_IP_PIMSM_V2=y
+CONFIG_SYN_COOKIES=y
+CONFIG_NET_IPVTI=y
+CONFIG_INET_ESP=y
+# CONFIG_INET_XFRM_MODE_BEET is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_TCP_CONG_ADVANCED=y
+# CONFIG_TCP_CONG_BIC is not set
+# CONFIG_TCP_CONG_WESTWOOD is not set
+# CONFIG_TCP_CONG_HTCP is not set
+CONFIG_TCP_MD5SIG=y
+CONFIG_IPV6_ROUTER_PREF=y
+CONFIG_IPV6_ROUTE_INFO=y
+CONFIG_IPV6_OPTIMISTIC_DAD=y
+CONFIG_INET6_AH=y
+CONFIG_INET6_ESP=y
+CONFIG_INET6_IPCOMP=y
+CONFIG_IPV6_MIP6=y
+CONFIG_IPV6_VTI=y
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_NETLABEL=y
+CONFIG_NETFILTER=y
+CONFIG_NF_CONNTRACK=y
+CONFIG_NF_CONNTRACK_SECMARK=y
+CONFIG_NF_CONNTRACK_EVENTS=y
+CONFIG_NF_CT_PROTO_DCCP=y
+CONFIG_NF_CT_PROTO_SCTP=y
+CONFIG_NF_CT_PROTO_UDPLITE=y
+CONFIG_NF_CONNTRACK_AMANDA=y
+CONFIG_NF_CONNTRACK_FTP=y
+CONFIG_NF_CONNTRACK_H323=y
+CONFIG_NF_CONNTRACK_IRC=y
+CONFIG_NF_CONNTRACK_NETBIOS_NS=y
+CONFIG_NF_CONNTRACK_PPTP=y
+CONFIG_NF_CONNTRACK_SANE=y
+CONFIG_NF_CONNTRACK_TFTP=y
+CONFIG_NF_CT_NETLINK=y
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=y
+CONFIG_NETFILTER_XT_TARGET_CONNMARK=y
+CONFIG_NETFILTER_XT_TARGET_CONNSECMARK=y
+CONFIG_NETFILTER_XT_TARGET_IDLETIMER=y
+CONFIG_NETFILTER_XT_TARGET_MARK=y
+CONFIG_NETFILTER_XT_TARGET_NFLOG=y
+CONFIG_NETFILTER_XT_TARGET_NFQUEUE=y
+CONFIG_NETFILTER_XT_TARGET_TPROXY=y
+CONFIG_NETFILTER_XT_TARGET_TRACE=y
+CONFIG_NETFILTER_XT_TARGET_SECMARK=y
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=y
+CONFIG_NETFILTER_XT_MATCH_BPF=y
+CONFIG_NETFILTER_XT_MATCH_COMMENT=y
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=y
+CONFIG_NETFILTER_XT_MATCH_CONNMARK=y
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=y
+CONFIG_NETFILTER_XT_MATCH_HASHLIMIT=y
+CONFIG_NETFILTER_XT_MATCH_HELPER=y
+CONFIG_NETFILTER_XT_MATCH_IPRANGE=y
+CONFIG_NETFILTER_XT_MATCH_LENGTH=y
+CONFIG_NETFILTER_XT_MATCH_LIMIT=y
+CONFIG_NETFILTER_XT_MATCH_MAC=y
+CONFIG_NETFILTER_XT_MATCH_MARK=y
+CONFIG_NETFILTER_XT_MATCH_POLICY=y
+CONFIG_NETFILTER_XT_MATCH_PKTTYPE=y
+CONFIG_NETFILTER_XT_MATCH_QTAGUID=y
+CONFIG_NETFILTER_XT_MATCH_QUOTA=y
+CONFIG_NETFILTER_XT_MATCH_QUOTA2=y
+CONFIG_NETFILTER_XT_MATCH_SOCKET=y
+CONFIG_NETFILTER_XT_MATCH_STATE=y
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=y
+CONFIG_NETFILTER_XT_MATCH_STRING=y
+CONFIG_NETFILTER_XT_MATCH_TIME=y
+CONFIG_NETFILTER_XT_MATCH_U32=y
+CONFIG_NF_CONNTRACK_IPV4=y
+CONFIG_IP_NF_IPTABLES=y
+CONFIG_IP_NF_MATCH_AH=y
+CONFIG_IP_NF_MATCH_ECN=y
+CONFIG_IP_NF_MATCH_TTL=y
+CONFIG_IP_NF_FILTER=y
+CONFIG_IP_NF_TARGET_REJECT=y
+CONFIG_IP_NF_NAT=y
+CONFIG_IP_NF_TARGET_MASQUERADE=y
+CONFIG_IP_NF_TARGET_NETMAP=y
+CONFIG_IP_NF_TARGET_REDIRECT=y
+CONFIG_IP_NF_MANGLE=y
+CONFIG_IP_NF_RAW=y
+CONFIG_IP_NF_SECURITY=y
+CONFIG_IP_NF_ARPTABLES=y
+CONFIG_IP_NF_ARPFILTER=y
+CONFIG_IP_NF_ARP_MANGLE=y
+CONFIG_NF_CONNTRACK_IPV6=y
+CONFIG_IP6_NF_IPTABLES=y
+CONFIG_IP6_NF_MATCH_IPV6HEADER=y
+CONFIG_IP6_NF_MATCH_RPFILTER=y
+CONFIG_IP6_NF_FILTER=y
+CONFIG_IP6_NF_TARGET_REJECT=y
+CONFIG_IP6_NF_MANGLE=y
+CONFIG_IP6_NF_RAW=y
+CONFIG_NET_SCHED=y
+CONFIG_NET_SCH_HTB=y
+CONFIG_NET_CLS_U32=y
+CONFIG_NET_EMATCH=y
+CONFIG_NET_EMATCH_U32=y
+CONFIG_NET_CLS_ACT=y
+CONFIG_CFG80211=y
+CONFIG_MAC80211=y
+CONFIG_RFKILL=y
+CONFIG_UEVENT_HELPER_PATH="/sbin/hotplug"
+CONFIG_DEVTMPFS=y
+CONFIG_DEBUG_DEVRES=y
+CONFIG_OF=y
+CONFIG_OF_UNITTEST=y
+# CONFIG_PNP_DEBUG_MESSAGES is not set
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_RAM_SIZE=8192
+CONFIG_VIRTIO_BLK=y
+CONFIG_UID_SYS_STATS=y
+CONFIG_MEMORY_STATE_TIME=y
+CONFIG_SCSI=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_BLK_DEV_SR=y
+CONFIG_BLK_DEV_SR_VENDOR=y
+CONFIG_CHR_DEV_SG=y
+CONFIG_SCSI_CONSTANTS=y
+CONFIG_SCSI_SPI_ATTRS=y
+CONFIG_SCSI_VIRTIO=y
+CONFIG_MD=y
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_CRYPT=y
+CONFIG_DM_MIRROR=y
+CONFIG_DM_ZERO=y
+CONFIG_DM_UEVENT=y
+CONFIG_DM_VERITY=y
+CONFIG_DM_VERITY_HASH_PREFETCH_MIN_SIZE=1
+CONFIG_DM_VERITY_FEC=y
+CONFIG_DM_ANDROID_VERITY=y
+CONFIG_NETDEVICES=y
+CONFIG_NETCONSOLE=y
+CONFIG_NETCONSOLE_DYNAMIC=y
+CONFIG_TUN=y
+CONFIG_VIRTIO_NET=y
+# CONFIG_ETHERNET is not set
+CONFIG_PPP=y
+CONFIG_PPP_BSDCOMP=y
+CONFIG_PPP_DEFLATE=y
+CONFIG_PPP_MPPE=y
+CONFIG_PPPOLAC=y
+CONFIG_PPPOPNS=y
+CONFIG_USB_USBNET=y
+# CONFIG_USB_NET_AX8817X is not set
+# CONFIG_USB_NET_AX88179_178A is not set
+# CONFIG_USB_NET_CDCETHER is not set
+# CONFIG_USB_NET_CDC_NCM is not set
+# CONFIG_USB_NET_NET1080 is not set
+# CONFIG_USB_NET_CDC_SUBSET is not set
+# CONFIG_USB_NET_ZAURUS is not set
+# CONFIG_WLAN_VENDOR_ADMTEK is not set
+# CONFIG_WLAN_VENDOR_ATH is not set
+# CONFIG_WLAN_VENDOR_ATMEL is not set
+# CONFIG_WLAN_VENDOR_BROADCOM is not set
+# CONFIG_WLAN_VENDOR_CISCO is not set
+# CONFIG_WLAN_VENDOR_INTEL is not set
+# CONFIG_WLAN_VENDOR_INTERSIL is not set
+# CONFIG_WLAN_VENDOR_MARVELL is not set
+# CONFIG_WLAN_VENDOR_MEDIATEK is not set
+# CONFIG_WLAN_VENDOR_RALINK is not set
+# CONFIG_WLAN_VENDOR_REALTEK is not set
+# CONFIG_WLAN_VENDOR_RSI is not set
+# CONFIG_WLAN_VENDOR_ST is not set
+# CONFIG_WLAN_VENDOR_TI is not set
+# CONFIG_WLAN_VENDOR_ZYDAS is not set
+CONFIG_MAC80211_HWSIM=y
+CONFIG_INPUT_EVDEV=y
+CONFIG_INPUT_KEYRESET=y
+# CONFIG_INPUT_KEYBOARD is not set
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_JOYSTICK=y
+CONFIG_JOYSTICK_XPAD=y
+CONFIG_JOYSTICK_XPAD_FF=y
+CONFIG_JOYSTICK_XPAD_LEDS=y
+CONFIG_INPUT_TABLET=y
+CONFIG_TABLET_USB_ACECAD=y
+CONFIG_TABLET_USB_AIPTEK=y
+CONFIG_TABLET_USB_GTCO=y
+CONFIG_TABLET_USB_HANWANG=y
+CONFIG_TABLET_USB_KBTAB=y
+CONFIG_INPUT_MISC=y
+CONFIG_INPUT_KEYCHORD=y
+CONFIG_INPUT_UINPUT=y
+CONFIG_INPUT_GPIO=y
+# CONFIG_SERIO_I8042 is not set
+# CONFIG_VT is not set
+# CONFIG_LEGACY_PTYS is not set
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+# CONFIG_SERIAL_8250_DEPRECATED_OPTIONS is not set
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_SERIAL_8250_NR_UARTS=48
+CONFIG_SERIAL_8250_EXTENDED=y
+CONFIG_SERIAL_8250_MANY_PORTS=y
+CONFIG_SERIAL_8250_SHARE_IRQ=y
+CONFIG_VIRTIO_CONSOLE=y
+CONFIG_HW_RANDOM=y
+# CONFIG_HW_RANDOM_INTEL is not set
+# CONFIG_HW_RANDOM_AMD is not set
+# CONFIG_HW_RANDOM_VIA is not set
+CONFIG_HW_RANDOM_VIRTIO=y
+CONFIG_HPET=y
+# CONFIG_HPET_MMAP_DEFAULT is not set
+# CONFIG_DEVPORT is not set
+# CONFIG_ACPI_I2C_OPREGION is not set
+# CONFIG_I2C_COMPAT is not set
+# CONFIG_I2C_HELPER_AUTO is not set
+CONFIG_PTP_1588_CLOCK=y
+# CONFIG_HWMON is not set
+# CONFIG_X86_PKG_TEMP_THERMAL is not set
+CONFIG_WATCHDOG=y
+CONFIG_SOFT_WATCHDOG=y
+CONFIG_MEDIA_SUPPORT=y
+# CONFIG_DVB_TUNER_DIB0070 is not set
+# CONFIG_DVB_TUNER_DIB0090 is not set
+# CONFIG_VGA_ARB is not set
+CONFIG_DRM=y
+# CONFIG_DRM_FBDEV_EMULATION is not set
+CONFIG_DRM_VIRTIO_GPU=y
+CONFIG_FB=y
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_HIDRAW=y
+CONFIG_UHID=y
+CONFIG_HID_A4TECH=y
+CONFIG_HID_ACRUX=y
+CONFIG_HID_ACRUX_FF=y
+CONFIG_HID_APPLE=y
+CONFIG_HID_BELKIN=y
+CONFIG_HID_CHERRY=y
+CONFIG_HID_CHICONY=y
+CONFIG_HID_PRODIKEYS=y
+CONFIG_HID_CYPRESS=y
+CONFIG_HID_DRAGONRISE=y
+CONFIG_DRAGONRISE_FF=y
+CONFIG_HID_EMS_FF=y
+CONFIG_HID_ELECOM=y
+CONFIG_HID_EZKEY=y
+CONFIG_HID_HOLTEK=y
+CONFIG_HID_KEYTOUCH=y
+CONFIG_HID_KYE=y
+CONFIG_HID_UCLOGIC=y
+CONFIG_HID_WALTOP=y
+CONFIG_HID_GYRATION=y
+CONFIG_HID_TWINHAN=y
+CONFIG_HID_KENSINGTON=y
+CONFIG_HID_LCPOWER=y
+CONFIG_HID_LOGITECH=y
+CONFIG_HID_LOGITECH_DJ=y
+CONFIG_LOGITECH_FF=y
+CONFIG_LOGIRUMBLEPAD2_FF=y
+CONFIG_LOGIG940_FF=y
+CONFIG_HID_MAGICMOUSE=y
+CONFIG_HID_MICROSOFT=y
+CONFIG_HID_MONTEREY=y
+CONFIG_HID_MULTITOUCH=y
+CONFIG_HID_NTRIG=y
+CONFIG_HID_ORTEK=y
+CONFIG_HID_PANTHERLORD=y
+CONFIG_PANTHERLORD_FF=y
+CONFIG_HID_PETALYNX=y
+CONFIG_HID_PICOLCD=y
+CONFIG_HID_PRIMAX=y
+CONFIG_HID_ROCCAT=y
+CONFIG_HID_SAITEK=y
+CONFIG_HID_SAMSUNG=y
+CONFIG_HID_SONY=y
+CONFIG_HID_SPEEDLINK=y
+CONFIG_HID_SUNPLUS=y
+CONFIG_HID_GREENASIA=y
+CONFIG_GREENASIA_FF=y
+CONFIG_HID_SMARTJOYPLUS=y
+CONFIG_SMARTJOYPLUS_FF=y
+CONFIG_HID_TIVO=y
+CONFIG_HID_TOPSEED=y
+CONFIG_HID_THRUSTMASTER=y
+CONFIG_HID_WACOM=y
+CONFIG_HID_WIIMOTE=y
+CONFIG_HID_ZEROPLUS=y
+CONFIG_HID_ZYDACRON=y
+CONFIG_USB_HIDDEV=y
+CONFIG_USB_ANNOUNCE_NEW_DEVICES=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_GADGET=y
+CONFIG_USB_DUMMY_HCD=y
+CONFIG_USB_CONFIGFS=y
+CONFIG_USB_CONFIGFS_F_FS=y
+CONFIG_USB_CONFIGFS_F_MTP=y
+CONFIG_USB_CONFIGFS_F_PTP=y
+CONFIG_USB_CONFIGFS_F_ACC=y
+CONFIG_USB_CONFIGFS_F_AUDIO_SRC=y
+CONFIG_USB_CONFIGFS_UEVENT=y
+CONFIG_USB_CONFIGFS_F_MIDI=y
+CONFIG_RTC_CLASS=y
+# CONFIG_RTC_HCTOSYS is not set
+CONFIG_SW_SYNC=y
+CONFIG_VIRTIO_PCI=y
+CONFIG_VIRTIO_BALLOON=y
+CONFIG_VIRTIO_MMIO=y
+CONFIG_VIRTIO_MMIO_CMDLINE_DEVICES=y
+CONFIG_STAGING=y
+CONFIG_ASHMEM=y
+CONFIG_ANDROID_VSOC=y
+CONFIG_ION=y
+# CONFIG_X86_PLATFORM_DEVICES is not set
+# CONFIG_IOMMU_SUPPORT is not set
+CONFIG_ANDROID=y
+CONFIG_ANDROID_BINDER_IPC=y
+# CONFIG_FIRMWARE_MEMMAP is not set
+CONFIG_EXT4_FS=y
+CONFIG_EXT4_FS_POSIX_ACL=y
+CONFIG_EXT4_FS_SECURITY=y
+CONFIG_EXT4_ENCRYPTION=y
+CONFIG_F2FS_FS=y
+CONFIG_F2FS_FS_SECURITY=y
+CONFIG_F2FS_FS_ENCRYPTION=y
+CONFIG_QUOTA=y
+CONFIG_QUOTA_NETLINK_INTERFACE=y
+# CONFIG_PRINT_QUOTA_WARNING is not set
+CONFIG_QFMT_V2=y
+CONFIG_AUTOFS4_FS=y
+CONFIG_FUSE_FS=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_KCORE=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_POSIX_ACL=y
+CONFIG_HUGETLBFS=y
+CONFIG_SDCARD_FS=y
+CONFIG_PSTORE=y
+CONFIG_PSTORE_CONSOLE=y
+CONFIG_PSTORE_RAM=y
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ASCII=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DEBUG_INFO=y
+# CONFIG_ENABLE_WARN_DEPRECATED is not set
+# CONFIG_ENABLE_MUST_CHECK is not set
+CONFIG_FRAME_WARN=1024
+# CONFIG_UNUSED_SYMBOLS is not set
+CONFIG_MAGIC_SYSRQ=y
+CONFIG_DEBUG_STACK_USAGE=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_DEBUG_STACKOVERFLOW=y
+CONFIG_LOCKUP_DETECTOR=y
+CONFIG_PANIC_TIMEOUT=5
+CONFIG_SCHEDSTATS=y
+CONFIG_TIMER_STATS=y
+CONFIG_RCU_CPU_STALL_TIMEOUT=60
+CONFIG_ENABLE_DEFAULT_TRACERS=y
+CONFIG_UPROBE_EVENT=y
+CONFIG_IO_DELAY_NONE=y
+CONFIG_DEBUG_BOOT_PARAMS=y
+CONFIG_OPTIMIZE_INLINING=y
+CONFIG_SECURITY_PERF_EVENTS_RESTRICT=y
+CONFIG_SECURITY=y
+CONFIG_SECURITY_NETWORK=y
+CONFIG_SECURITY_PATH=y
+CONFIG_HARDENED_USERCOPY=y
+CONFIG_SECURITY_SELINUX=y
+CONFIG_SECURITY_SELINUX_CHECKREQPROT_VALUE=1
+CONFIG_CRYPTO_RSA=y
+# CONFIG_CRYPTO_MANAGER_DISABLE_TESTS is not set
+CONFIG_CRYPTO_SHA512=y
+CONFIG_ASYMMETRIC_KEY_TYPE=y
+CONFIG_ASYMMETRIC_PUBLIC_KEY_SUBTYPE=y
+CONFIG_X509_CERTIFICATE_PARSER=y
+CONFIG_SYSTEM_TRUSTED_KEYRING=y
+CONFIG_SYSTEM_TRUSTED_KEYS="verity_dev_keys.x509"
diff --git a/arch/x86/configs/x86_64_ranchu_defconfig b/arch/x86/configs/x86_64_ranchu_defconfig
new file mode 100644
index 00000000..d50434f
--- /dev/null
+++ b/arch/x86/configs/x86_64_ranchu_defconfig
@@ -0,0 +1,419 @@
+# CONFIG_LOCALVERSION_AUTO is not set
+CONFIG_POSIX_MQUEUE=y
+CONFIG_AUDIT=y
+CONFIG_NO_HZ=y
+CONFIG_HIGH_RES_TIMERS=y
+CONFIG_BSD_PROCESS_ACCT=y
+CONFIG_TASKSTATS=y
+CONFIG_TASK_DELAY_ACCT=y
+CONFIG_TASK_XACCT=y
+CONFIG_TASK_IO_ACCOUNTING=y
+CONFIG_CGROUPS=y
+CONFIG_CGROUP_DEBUG=y
+CONFIG_CGROUP_FREEZER=y
+CONFIG_CGROUP_CPUACCT=y
+CONFIG_CGROUP_SCHED=y
+CONFIG_RT_GROUP_SCHED=y
+CONFIG_BLK_DEV_INITRD=y
+CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_SYSCTL_SYSCALL=y
+CONFIG_KALLSYMS_ALL=y
+CONFIG_EMBEDDED=y
+# CONFIG_COMPAT_BRK is not set
+CONFIG_ARCH_MMAP_RND_BITS=32
+CONFIG_ARCH_MMAP_RND_COMPAT_BITS=16
+CONFIG_PARTITION_ADVANCED=y
+CONFIG_OSF_PARTITION=y
+CONFIG_AMIGA_PARTITION=y
+CONFIG_MAC_PARTITION=y
+CONFIG_BSD_DISKLABEL=y
+CONFIG_MINIX_SUBPARTITION=y
+CONFIG_SOLARIS_X86_PARTITION=y
+CONFIG_UNIXWARE_DISKLABEL=y
+CONFIG_SGI_PARTITION=y
+CONFIG_SUN_PARTITION=y
+CONFIG_KARMA_PARTITION=y
+CONFIG_SMP=y
+CONFIG_MCORE2=y
+CONFIG_MAXSMP=y
+CONFIG_PREEMPT=y
+# CONFIG_X86_MCE is not set
+CONFIG_X86_MSR=y
+CONFIG_X86_CPUID=y
+CONFIG_KSM=y
+CONFIG_CMA=y
+# CONFIG_MTRR_SANITIZER is not set
+CONFIG_EFI=y
+CONFIG_EFI_STUB=y
+CONFIG_HZ_100=y
+CONFIG_PHYSICAL_START=0x100000
+CONFIG_PM_AUTOSLEEP=y
+CONFIG_PM_WAKELOCKS=y
+CONFIG_PM_WAKELOCKS_LIMIT=0
+# CONFIG_PM_WAKELOCKS_GC is not set
+CONFIG_PM_DEBUG=y
+CONFIG_CPU_FREQ=y
+# CONFIG_CPU_FREQ_STAT is not set
+CONFIG_CPU_FREQ_DEFAULT_GOV_ONDEMAND=y
+CONFIG_CPU_FREQ_GOV_USERSPACE=y
+CONFIG_PCI_MMCONFIG=y
+CONFIG_PCIEPORTBUS=y
+# CONFIG_PCIEASPM is not set
+CONFIG_PCCARD=y
+CONFIG_YENTA=y
+CONFIG_HOTPLUG_PCI=y
+# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
+CONFIG_BINFMT_MISC=y
+CONFIG_IA32_EMULATION=y
+CONFIG_NET=y
+CONFIG_PACKET=y
+CONFIG_UNIX=y
+CONFIG_XFRM_USER=y
+CONFIG_NET_KEY=y
+CONFIG_INET=y
+CONFIG_IP_MULTICAST=y
+CONFIG_IP_ADVANCED_ROUTER=y
+CONFIG_IP_MULTIPLE_TABLES=y
+CONFIG_IP_ROUTE_MULTIPATH=y
+CONFIG_IP_ROUTE_VERBOSE=y
+CONFIG_IP_PNP=y
+CONFIG_IP_PNP_DHCP=y
+CONFIG_IP_PNP_BOOTP=y
+CONFIG_IP_PNP_RARP=y
+CONFIG_IP_MROUTE=y
+CONFIG_IP_PIMSM_V1=y
+CONFIG_IP_PIMSM_V2=y
+CONFIG_SYN_COOKIES=y
+CONFIG_INET_ESP=y
+# CONFIG_INET_XFRM_MODE_BEET is not set
+# CONFIG_INET_LRO is not set
+CONFIG_INET_DIAG_DESTROY=y
+CONFIG_IPV6_ROUTER_PREF=y
+CONFIG_IPV6_ROUTE_INFO=y
+CONFIG_IPV6_OPTIMISTIC_DAD=y
+CONFIG_INET6_AH=y
+CONFIG_INET6_ESP=y
+CONFIG_INET6_IPCOMP=y
+CONFIG_IPV6_MIP6=y
+CONFIG_IPV6_MULTIPLE_TABLES=y
+CONFIG_NETLABEL=y
+CONFIG_NETFILTER=y
+CONFIG_NF_CONNTRACK=y
+CONFIG_NF_CONNTRACK_SECMARK=y
+CONFIG_NF_CONNTRACK_EVENTS=y
+CONFIG_NF_CT_PROTO_DCCP=y
+CONFIG_NF_CT_PROTO_SCTP=y
+CONFIG_NF_CT_PROTO_UDPLITE=y
+CONFIG_NF_CONNTRACK_AMANDA=y
+CONFIG_NF_CONNTRACK_FTP=y
+CONFIG_NF_CONNTRACK_H323=y
+CONFIG_NF_CONNTRACK_IRC=y
+CONFIG_NF_CONNTRACK_NETBIOS_NS=y
+CONFIG_NF_CONNTRACK_PPTP=y
+CONFIG_NF_CONNTRACK_SANE=y
+CONFIG_NF_CONNTRACK_TFTP=y
+CONFIG_NF_CT_NETLINK=y
+CONFIG_NETFILTER_XT_TARGET_CLASSIFY=y
+CONFIG_NETFILTER_XT_TARGET_CONNMARK=y
+CONFIG_NETFILTER_XT_TARGET_CONNSECMARK=y
+CONFIG_NETFILTER_XT_TARGET_IDLETIMER=y
+CONFIG_NETFILTER_XT_TARGET_MARK=y
+CONFIG_NETFILTER_XT_TARGET_NFLOG=y
+CONFIG_NETFILTER_XT_TARGET_NFQUEUE=y
+CONFIG_NETFILTER_XT_TARGET_TPROXY=y
+CONFIG_NETFILTER_XT_TARGET_TRACE=y
+CONFIG_NETFILTER_XT_TARGET_SECMARK=y
+CONFIG_NETFILTER_XT_TARGET_TCPMSS=y
+CONFIG_NETFILTER_XT_MATCH_COMMENT=y
+CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=y
+CONFIG_NETFILTER_XT_MATCH_CONNMARK=y
+CONFIG_NETFILTER_XT_MATCH_CONNTRACK=y
+CONFIG_NETFILTER_XT_MATCH_HASHLIMIT=y
+CONFIG_NETFILTER_XT_MATCH_HELPER=y
+CONFIG_NETFILTER_XT_MATCH_IPRANGE=y
+CONFIG_NETFILTER_XT_MATCH_LENGTH=y
+CONFIG_NETFILTER_XT_MATCH_LIMIT=y
+CONFIG_NETFILTER_XT_MATCH_MAC=y
+CONFIG_NETFILTER_XT_MATCH_MARK=y
+CONFIG_NETFILTER_XT_MATCH_POLICY=y
+CONFIG_NETFILTER_XT_MATCH_PKTTYPE=y
+CONFIG_NETFILTER_XT_MATCH_QTAGUID=y
+CONFIG_NETFILTER_XT_MATCH_QUOTA=y
+CONFIG_NETFILTER_XT_MATCH_QUOTA2=y
+CONFIG_NETFILTER_XT_MATCH_SOCKET=y
+CONFIG_NETFILTER_XT_MATCH_STATE=y
+CONFIG_NETFILTER_XT_MATCH_STATISTIC=y
+CONFIG_NETFILTER_XT_MATCH_STRING=y
+CONFIG_NETFILTER_XT_MATCH_TIME=y
+CONFIG_NETFILTER_XT_MATCH_U32=y
+CONFIG_NF_CONNTRACK_IPV4=y
+CONFIG_IP_NF_IPTABLES=y
+CONFIG_IP_NF_MATCH_AH=y
+CONFIG_IP_NF_MATCH_ECN=y
+CONFIG_IP_NF_MATCH_TTL=y
+CONFIG_IP_NF_FILTER=y
+CONFIG_IP_NF_TARGET_REJECT=y
+CONFIG_IP_NF_MANGLE=y
+CONFIG_IP_NF_RAW=y
+CONFIG_IP_NF_SECURITY=y
+CONFIG_IP_NF_ARPTABLES=y
+CONFIG_IP_NF_ARPFILTER=y
+CONFIG_IP_NF_ARP_MANGLE=y
+CONFIG_NF_CONNTRACK_IPV6=y
+CONFIG_IP6_NF_IPTABLES=y
+CONFIG_IP6_NF_FILTER=y
+CONFIG_IP6_NF_TARGET_REJECT=y
+CONFIG_IP6_NF_MANGLE=y
+CONFIG_IP6_NF_RAW=y
+CONFIG_NET_SCHED=y
+CONFIG_NET_SCH_HTB=y
+CONFIG_NET_CLS_U32=y
+CONFIG_NET_EMATCH=y
+CONFIG_NET_EMATCH_U32=y
+CONFIG_NET_CLS_ACT=y
+CONFIG_CFG80211=y
+CONFIG_MAC80211=y
+CONFIG_MAC80211_LEDS=y
+CONFIG_UEVENT_HELPER_PATH="/sbin/hotplug"
+CONFIG_DMA_CMA=y
+CONFIG_CONNECTOR=y
+CONFIG_BLK_DEV_LOOP=y
+CONFIG_BLK_DEV_RAM=y
+CONFIG_BLK_DEV_RAM_SIZE=8192
+CONFIG_VIRTIO_BLK=y
+CONFIG_BLK_DEV_SD=y
+CONFIG_BLK_DEV_SR=y
+CONFIG_BLK_DEV_SR_VENDOR=y
+CONFIG_CHR_DEV_SG=y
+CONFIG_SCSI_CONSTANTS=y
+CONFIG_SCSI_SPI_ATTRS=y
+CONFIG_SCSI_ISCSI_ATTRS=y
+# CONFIG_SCSI_LOWLEVEL is not set
+CONFIG_ATA=y
+CONFIG_SATA_AHCI=y
+CONFIG_ATA_PIIX=y
+CONFIG_PATA_AMD=y
+CONFIG_PATA_OLDPIIX=y
+CONFIG_PATA_SCH=y
+CONFIG_PATA_MPIIX=y
+CONFIG_ATA_GENERIC=y
+CONFIG_MD=y
+CONFIG_BLK_DEV_MD=y
+CONFIG_BLK_DEV_DM=y
+CONFIG_DM_DEBUG=y
+CONFIG_DM_CRYPT=y
+CONFIG_DM_MIRROR=y
+CONFIG_DM_ZERO=y
+CONFIG_DM_UEVENT=y
+CONFIG_DM_VERITY=y
+CONFIG_DM_VERITY_FEC=y
+CONFIG_NETDEVICES=y
+CONFIG_NETCONSOLE=y
+CONFIG_TUN=y
+CONFIG_VIRTIO_NET=y
+CONFIG_BNX2=y
+CONFIG_TIGON3=y
+CONFIG_NET_TULIP=y
+CONFIG_E100=y
+CONFIG_E1000=y
+CONFIG_E1000E=y
+CONFIG_SKY2=y
+CONFIG_NE2K_PCI=y
+CONFIG_FORCEDETH=y
+CONFIG_8139TOO=y
+# CONFIG_8139TOO_PIO is not set
+CONFIG_R8169=y
+CONFIG_FDDI=y
+CONFIG_PPP=y
+CONFIG_PPP_BSDCOMP=y
+CONFIG_PPP_DEFLATE=y
+CONFIG_PPP_MPPE=y
+CONFIG_PPPOLAC=y
+CONFIG_PPPOPNS=y
+CONFIG_USB_USBNET=y
+CONFIG_INPUT_POLLDEV=y
+# CONFIG_INPUT_MOUSEDEV_PSAUX is not set
+CONFIG_INPUT_EVDEV=y
+CONFIG_INPUT_KEYRESET=y
+# CONFIG_KEYBOARD_ATKBD is not set
+CONFIG_KEYBOARD_GOLDFISH_EVENTS=y
+# CONFIG_INPUT_MOUSE is not set
+CONFIG_INPUT_JOYSTICK=y
+CONFIG_JOYSTICK_XPAD=y
+CONFIG_JOYSTICK_XPAD_FF=y
+CONFIG_JOYSTICK_XPAD_LEDS=y
+CONFIG_INPUT_TABLET=y
+CONFIG_TABLET_USB_ACECAD=y
+CONFIG_TABLET_USB_AIPTEK=y
+CONFIG_TABLET_USB_GTCO=y
+CONFIG_TABLET_USB_HANWANG=y
+CONFIG_TABLET_USB_KBTAB=y
+CONFIG_INPUT_TOUCHSCREEN=y
+CONFIG_INPUT_MISC=y
+CONFIG_INPUT_KEYCHORD=y
+CONFIG_INPUT_UINPUT=y
+CONFIG_INPUT_GPIO=y
+# CONFIG_SERIO is not set
+# CONFIG_VT is not set
+# CONFIG_LEGACY_PTYS is not set
+CONFIG_SERIAL_NONSTANDARD=y
+# CONFIG_DEVMEM is not set
+# CONFIG_DEVKMEM is not set
+CONFIG_SERIAL_8250=y
+CONFIG_SERIAL_8250_CONSOLE=y
+CONFIG_VIRTIO_CONSOLE=y
+CONFIG_NVRAM=y
+CONFIG_I2C_I801=y
+CONFIG_BATTERY_GOLDFISH=y
+CONFIG_WATCHDOG=y
+CONFIG_MEDIA_SUPPORT=y
+CONFIG_AGP=y
+CONFIG_AGP_AMD64=y
+CONFIG_AGP_INTEL=y
+CONFIG_DRM=y
+CONFIG_FB_MODE_HELPERS=y
+CONFIG_FB_TILEBLITTING=y
+CONFIG_FB_EFI=y
+CONFIG_FB_GOLDFISH=y
+CONFIG_BACKLIGHT_LCD_SUPPORT=y
+# CONFIG_LCD_CLASS_DEVICE is not set
+CONFIG_SOUND=y
+CONFIG_SND=y
+CONFIG_HIDRAW=y
+CONFIG_UHID=y
+CONFIG_HID_A4TECH=y
+CONFIG_HID_ACRUX=y
+CONFIG_HID_ACRUX_FF=y
+CONFIG_HID_APPLE=y
+CONFIG_HID_BELKIN=y
+CONFIG_HID_CHERRY=y
+CONFIG_HID_CHICONY=y
+CONFIG_HID_PRODIKEYS=y
+CONFIG_HID_CYPRESS=y
+CONFIG_HID_DRAGONRISE=y
+CONFIG_DRAGONRISE_FF=y
+CONFIG_HID_EMS_FF=y
+CONFIG_HID_ELECOM=y
+CONFIG_HID_EZKEY=y
+CONFIG_HID_HOLTEK=y
+CONFIG_HID_KEYTOUCH=y
+CONFIG_HID_KYE=y
+CONFIG_HID_UCLOGIC=y
+CONFIG_HID_WALTOP=y
+CONFIG_HID_GYRATION=y
+CONFIG_HID_TWINHAN=y
+CONFIG_HID_KENSINGTON=y
+CONFIG_HID_LCPOWER=y
+CONFIG_HID_LOGITECH=y
+CONFIG_HID_LOGITECH_DJ=y
+CONFIG_LOGITECH_FF=y
+CONFIG_LOGIRUMBLEPAD2_FF=y
+CONFIG_LOGIG940_FF=y
+CONFIG_HID_MAGICMOUSE=y
+CONFIG_HID_MICROSOFT=y
+CONFIG_HID_MONTEREY=y
+CONFIG_HID_MULTITOUCH=y
+CONFIG_HID_NTRIG=y
+CONFIG_HID_ORTEK=y
+CONFIG_HID_PANTHERLORD=y
+CONFIG_PANTHERLORD_FF=y
+CONFIG_HID_PETALYNX=y
+CONFIG_HID_PICOLCD=y
+CONFIG_HID_PRIMAX=y
+CONFIG_HID_ROCCAT=y
+CONFIG_HID_SAITEK=y
+CONFIG_HID_SAMSUNG=y
+CONFIG_HID_SONY=y
+CONFIG_HID_SPEEDLINK=y
+CONFIG_HID_SUNPLUS=y
+CONFIG_HID_GREENASIA=y
+CONFIG_GREENASIA_FF=y
+CONFIG_HID_SMARTJOYPLUS=y
+CONFIG_SMARTJOYPLUS_FF=y
+CONFIG_HID_TIVO=y
+CONFIG_HID_TOPSEED=y
+CONFIG_HID_THRUSTMASTER=y
+CONFIG_HID_WACOM=y
+CONFIG_HID_WIIMOTE=y
+CONFIG_HID_ZEROPLUS=y
+CONFIG_HID_ZYDACRON=y
+CONFIG_HID_PID=y
+CONFIG_USB_HIDDEV=y
+CONFIG_USB_ANNOUNCE_NEW_DEVICES=y
+CONFIG_USB_MON=y
+CONFIG_USB_EHCI_HCD=y
+# CONFIG_USB_EHCI_TT_NEWSCHED is not set
+CONFIG_USB_OHCI_HCD=y
+CONFIG_USB_UHCI_HCD=y
+CONFIG_USB_PRINTER=y
+CONFIG_USB_STORAGE=y
+CONFIG_USB_OTG_WAKELOCK=y
+CONFIG_EDAC=y
+CONFIG_RTC_CLASS=y
+# CONFIG_RTC_HCTOSYS is not set
+CONFIG_DMADEVICES=y
+CONFIG_VIRTIO_PCI=y
+CONFIG_STAGING=y
+CONFIG_ASHMEM=y
+CONFIG_ANDROID_LOW_MEMORY_KILLER=y
+CONFIG_SYNC=y
+CONFIG_SW_SYNC=y
+CONFIG_SYNC_FILE=y
+CONFIG_ION=y
+CONFIG_GOLDFISH_AUDIO=y
+CONFIG_SND_HDA_INTEL=y
+CONFIG_GOLDFISH=y
+CONFIG_GOLDFISH_PIPE=y
+CONFIG_GOLDFISH_SYNC=y
+CONFIG_ANDROID=y
+CONFIG_ANDROID_BINDER_IPC=y
+CONFIG_ISCSI_IBFT_FIND=y
+CONFIG_EXT4_FS=y
+CONFIG_EXT4_FS_SECURITY=y
+CONFIG_QUOTA=y
+CONFIG_QUOTA_NETLINK_INTERFACE=y
+# CONFIG_PRINT_QUOTA_WARNING is not set
+CONFIG_FUSE_FS=y
+CONFIG_ISO9660_FS=y
+CONFIG_JOLIET=y
+CONFIG_ZISOFS=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_PROC_KCORE=y
+CONFIG_TMPFS=y
+CONFIG_TMPFS_POSIX_ACL=y
+CONFIG_HUGETLBFS=y
+CONFIG_PSTORE=y
+CONFIG_PSTORE_CONSOLE=y
+CONFIG_PSTORE_RAM=y
+# CONFIG_NETWORK_FILESYSTEMS is not set
+CONFIG_NLS_DEFAULT="utf8"
+CONFIG_NLS_CODEPAGE_437=y
+CONFIG_NLS_ASCII=y
+CONFIG_NLS_ISO8859_1=y
+CONFIG_NLS_UTF8=y
+CONFIG_PRINTK_TIME=y
+CONFIG_DEBUG_INFO=y
+# CONFIG_ENABLE_WARN_DEPRECATED is not set
+# CONFIG_ENABLE_MUST_CHECK is not set
+# CONFIG_UNUSED_SYMBOLS is not set
+CONFIG_MAGIC_SYSRQ=y
+CONFIG_DEBUG_MEMORY_INIT=y
+CONFIG_PANIC_TIMEOUT=5
+CONFIG_SCHEDSTATS=y
+CONFIG_TIMER_STATS=y
+CONFIG_SCHED_TRACER=y
+CONFIG_BLK_DEV_IO_TRACE=y
+CONFIG_PROVIDE_OHCI1394_DMA_INIT=y
+CONFIG_KEYS=y
+CONFIG_SECURITY=y
+CONFIG_SECURITY_NETWORK=y
+CONFIG_SECURITY_SELINUX=y
+CONFIG_CRYPTO_TWOFISH=y
+CONFIG_ASYMMETRIC_KEY_TYPE=y
+CONFIG_ASYMMETRIC_PUBLIC_KEY_SUBTYPE=y
+CONFIG_X509_CERTIFICATE_PARSER=y
+CONFIG_PKCS7_MESSAGE_PARSER=y
+CONFIG_PKCS7_TEST_KEY=y
+# CONFIG_VIRTUALIZATION is not set
+CONFIG_CRC_T10DIF=y
diff --git a/arch/x86/crypto/aes_ctrby8_avx-x86_64.S b/arch/x86/crypto/aes_ctrby8_avx-x86_64.S
index a916c4a..5f6a5af 100644
--- a/arch/x86/crypto/aes_ctrby8_avx-x86_64.S
+++ b/arch/x86/crypto/aes_ctrby8_avx-x86_64.S
@@ -65,7 +65,6 @@
 #include <linux/linkage.h>
 #include <asm/inst.h>
 
-#define CONCAT(a,b)	a##b
 #define VMOVDQ		vmovdqu
 
 #define xdata0		%xmm0
@@ -92,8 +91,6 @@
 #define num_bytes	%r8
 
 #define tmp		%r10
-#define	DDQ(i)		CONCAT(ddq_add_,i)
-#define	XMM(i)		CONCAT(%xmm, i)
 #define	DDQ_DATA	0
 #define	XDATA		1
 #define KEY_128		1
@@ -131,12 +128,12 @@ ddq_add_8:
 /* generate a unique variable for ddq_add_x */
 
 .macro setddq n
-	var_ddq_add = DDQ(\n)
+	var_ddq_add = ddq_add_\n
 .endm
 
 /* generate a unique variable for xmm register */
 .macro setxdata n
-	var_xdata = XMM(\n)
+	var_xdata = %xmm\n
 .endm
 
 /* club the numeric 'id' to the symbol 'name' */
diff --git a/arch/x86/entry/entry_64.S b/arch/x86/entry/entry_64.S
index d58d8dc..3a31fd4 100644
--- a/arch/x86/entry/entry_64.S
+++ b/arch/x86/entry/entry_64.S
@@ -626,13 +626,8 @@ apicinterrupt3 \num trace(\sym) smp_trace(\sym)
 #endif
 
 /* Make sure APIC interrupt handlers end up in the irqentry section: */
-#if defined(CONFIG_FUNCTION_GRAPH_TRACER) || defined(CONFIG_KASAN)
-# define PUSH_SECTION_IRQENTRY	.pushsection .irqentry.text, "ax"
-# define POP_SECTION_IRQENTRY	.popsection
-#else
-# define PUSH_SECTION_IRQENTRY
-# define POP_SECTION_IRQENTRY
-#endif
+#define PUSH_SECTION_IRQENTRY	.pushsection .irqentry.text, "ax"
+#define POP_SECTION_IRQENTRY	.popsection
 
 .macro apicinterrupt num sym do_sym
 PUSH_SECTION_IRQENTRY
diff --git a/arch/x86/entry/vdso/Makefile b/arch/x86/entry/vdso/Makefile
index d540966..51a858e 100644
--- a/arch/x86/entry/vdso/Makefile
+++ b/arch/x86/entry/vdso/Makefile
@@ -171,7 +171,8 @@ quiet_cmd_vdso = VDSO    $@
 		 sh $(srctree)/$(src)/checkundef.sh '$(NM)' '$@'
 
 VDSO_LDFLAGS = -fPIC -shared $(call cc-ldoption, -Wl$(comma)--hash-style=both) \
-	$(call cc-ldoption, -Wl$(comma)--build-id) -Wl,-Bsymbolic $(LTO_CFLAGS)
+	$(call cc-ldoption, -Wl$(comma)--build-id) -Wl,-Bsymbolic $(LTO_CFLAGS) \
+	$(filter --target=% --gcc-toolchain=%,$(KBUILD_CFLAGS))
 GCOV_PROFILE := n
 
 #
diff --git a/arch/x86/include/asm/alternative.h b/arch/x86/include/asm/alternative.h
index deca9b9..6665000 100644
--- a/arch/x86/include/asm/alternative.h
+++ b/arch/x86/include/asm/alternative.h
@@ -218,10 +218,9 @@ static inline int alternatives_text_reserved(void *start, void *end)
 #define alternative_call_2(oldfunc, newfunc1, feature1, newfunc2, feature2,   \
 			   output, input...)				      \
 {									      \
-	register void *__sp asm(_ASM_SP);				      \
 	asm volatile (ALTERNATIVE_2("call %P[old]", "call %P[new1]", feature1,\
 		"call %P[new2]", feature2)				      \
-		: output, "+r" (__sp)					      \
+		: output, ASM_CALL_CONSTRAINT				      \
 		: [old] "i" (oldfunc), [new1] "i" (newfunc1),		      \
 		  [new2] "i" (newfunc2), ## input);			      \
 }
diff --git a/arch/x86/include/asm/idle.h b/arch/x86/include/asm/idle.h
index c5d1785..02bab09 100644
--- a/arch/x86/include/asm/idle.h
+++ b/arch/x86/include/asm/idle.h
@@ -1,13 +1,6 @@
 #ifndef _ASM_X86_IDLE_H
 #define _ASM_X86_IDLE_H
 
-#define IDLE_START 1
-#define IDLE_END 2
-
-struct notifier_block;
-void idle_notifier_register(struct notifier_block *n);
-void idle_notifier_unregister(struct notifier_block *n);
-
 #ifdef CONFIG_X86_64
 void enter_idle(void);
 void exit_idle(void);
diff --git a/arch/x86/include/asm/paravirt_types.h b/arch/x86/include/asm/paravirt_types.h
index 04b7971..98dbad6 100644
--- a/arch/x86/include/asm/paravirt_types.h
+++ b/arch/x86/include/asm/paravirt_types.h
@@ -462,8 +462,8 @@ unsigned native_patch(u8 type, u16 clobbers, void *ibuf,
  */
 #ifdef CONFIG_X86_32
 #define PVOP_VCALL_ARGS							\
-	unsigned long __eax = __eax, __edx = __edx, __ecx = __ecx;	\
-	register void *__sp asm("esp")
+	unsigned long __eax = __eax, __edx = __edx, __ecx = __ecx;
+
 #define PVOP_CALL_ARGS			PVOP_VCALL_ARGS
 
 #define PVOP_CALL_ARG1(x)		"a" ((unsigned long)(x))
@@ -483,8 +483,8 @@ unsigned native_patch(u8 type, u16 clobbers, void *ibuf,
 /* [re]ax isn't an arg, but the return val */
 #define PVOP_VCALL_ARGS						\
 	unsigned long __edi = __edi, __esi = __esi,		\
-		__edx = __edx, __ecx = __ecx, __eax = __eax;	\
-	register void *__sp asm("rsp")
+		__edx = __edx, __ecx = __ecx, __eax = __eax;
+
 #define PVOP_CALL_ARGS		PVOP_VCALL_ARGS
 
 #define PVOP_CALL_ARG1(x)		"D" ((unsigned long)(x))
@@ -523,7 +523,7 @@ unsigned native_patch(u8 type, u16 clobbers, void *ibuf,
 			asm volatile(pre				\
 				     paravirt_alt(PARAVIRT_CALL)	\
 				     post				\
-				     : call_clbr, "+r" (__sp)		\
+				     : call_clbr, ASM_CALL_CONSTRAINT	\
 				     : paravirt_type(op),		\
 				       paravirt_clobber(clbr),		\
 				       ##__VA_ARGS__			\
@@ -533,7 +533,7 @@ unsigned native_patch(u8 type, u16 clobbers, void *ibuf,
 			asm volatile(pre				\
 				     paravirt_alt(PARAVIRT_CALL)	\
 				     post				\
-				     : call_clbr, "+r" (__sp)		\
+				     : call_clbr, ASM_CALL_CONSTRAINT	\
 				     : paravirt_type(op),		\
 				       paravirt_clobber(clbr),		\
 				       ##__VA_ARGS__			\
@@ -560,7 +560,7 @@ unsigned native_patch(u8 type, u16 clobbers, void *ibuf,
 		asm volatile(pre					\
 			     paravirt_alt(PARAVIRT_CALL)		\
 			     post					\
-			     : call_clbr, "+r" (__sp)			\
+			     : call_clbr, ASM_CALL_CONSTRAINT		\
 			     : paravirt_type(op),			\
 			       paravirt_clobber(clbr),			\
 			       ##__VA_ARGS__				\
diff --git a/arch/x86/include/asm/preempt.h b/arch/x86/include/asm/preempt.h
index 17f2186..4939f6e 100644
--- a/arch/x86/include/asm/preempt.h
+++ b/arch/x86/include/asm/preempt.h
@@ -94,19 +94,14 @@ static __always_inline bool should_resched(int preempt_offset)
 
 #ifdef CONFIG_PREEMPT
   extern asmlinkage void ___preempt_schedule(void);
-# define __preempt_schedule()					\
-({								\
-	register void *__sp asm(_ASM_SP);			\
-	asm volatile ("call ___preempt_schedule" : "+r"(__sp));	\
-})
+# define __preempt_schedule() \
+	asm volatile ("call ___preempt_schedule" : ASM_CALL_CONSTRAINT)
 
   extern asmlinkage void preempt_schedule(void);
   extern asmlinkage void ___preempt_schedule_notrace(void);
-# define __preempt_schedule_notrace()					\
-({									\
-	register void *__sp asm(_ASM_SP);				\
-	asm volatile ("call ___preempt_schedule_notrace" : "+r"(__sp));	\
-})
+# define __preempt_schedule_notrace() \
+	asm volatile ("call ___preempt_schedule_notrace" : ASM_CALL_CONSTRAINT)
+
   extern asmlinkage void preempt_schedule_notrace(void);
 #endif
 
diff --git a/arch/x86/include/asm/rwsem.h b/arch/x86/include/asm/rwsem.h
index a34e0d4..7116b79 100644
--- a/arch/x86/include/asm/rwsem.h
+++ b/arch/x86/include/asm/rwsem.h
@@ -103,7 +103,6 @@ static inline bool __down_read_trylock(struct rw_semaphore *sem)
 ({							\
 	long tmp;					\
 	struct rw_semaphore* ret;			\
-	register void *__sp asm(_ASM_SP);		\
 							\
 	asm volatile("# beginning down_write\n\t"	\
 		     LOCK_PREFIX "  xadd      %1,(%4)\n\t"	\
@@ -114,7 +113,8 @@ static inline bool __down_read_trylock(struct rw_semaphore *sem)
 		     "  call " slow_path "\n"		\
 		     "1:\n"				\
 		     "# ending down_write"		\
-		     : "+m" (sem->count), "=d" (tmp), "=a" (ret), "+r" (__sp) \
+		     : "+m" (sem->count), "=d" (tmp),	\
+		       "=a" (ret), ASM_CALL_CONSTRAINT	\
 		     : "a" (sem), "1" (RWSEM_ACTIVE_WRITE_BIAS) \
 		     : "memory", "cc");			\
 	ret;						\
diff --git a/arch/x86/include/asm/uaccess.h b/arch/x86/include/asm/uaccess.h
index a8d85a6..0c87840 100644
--- a/arch/x86/include/asm/uaccess.h
+++ b/arch/x86/include/asm/uaccess.h
@@ -171,11 +171,11 @@ static inline bool __chk_range_not_ok(unsigned long addr, unsigned long size, un
 ({									\
 	int __ret_gu;							\
 	register __inttype(*(ptr)) __val_gu asm("%"_ASM_DX);		\
-	register void *__sp asm(_ASM_SP);				\
 	__chk_user_ptr(ptr);						\
 	might_fault();							\
 	asm volatile("call __get_user_%P4"				\
-		     : "=a" (__ret_gu), "=r" (__val_gu), "+r" (__sp)	\
+		     : "=a" (__ret_gu), "=r" (__val_gu),		\
+			ASM_CALL_CONSTRAINT				\
 		     : "0" (ptr), "i" (sizeof(*(ptr))));		\
 	(x) = (__force __typeof__(*(ptr))) __val_gu;			\
 	__builtin_expect(__ret_gu, 0);					\
diff --git a/arch/x86/include/asm/xen/hypercall.h b/arch/x86/include/asm/xen/hypercall.h
index ccdc23d..1fdcb8c 100644
--- a/arch/x86/include/asm/xen/hypercall.h
+++ b/arch/x86/include/asm/xen/hypercall.h
@@ -112,10 +112,9 @@
 	register unsigned long __arg2 asm(__HYPERCALL_ARG2REG) = __arg2; \
 	register unsigned long __arg3 asm(__HYPERCALL_ARG3REG) = __arg3; \
 	register unsigned long __arg4 asm(__HYPERCALL_ARG4REG) = __arg4; \
-	register unsigned long __arg5 asm(__HYPERCALL_ARG5REG) = __arg5; \
-	register void *__sp asm(_ASM_SP);
+	register unsigned long __arg5 asm(__HYPERCALL_ARG5REG) = __arg5;
 
-#define __HYPERCALL_0PARAM	"=r" (__res), "+r" (__sp)
+#define __HYPERCALL_0PARAM	"=r" (__res), ASM_CALL_CONSTRAINT
 #define __HYPERCALL_1PARAM	__HYPERCALL_0PARAM, "+r" (__arg1)
 #define __HYPERCALL_2PARAM	__HYPERCALL_1PARAM, "+r" (__arg2)
 #define __HYPERCALL_3PARAM	__HYPERCALL_2PARAM, "+r" (__arg3)
diff --git a/arch/x86/kernel/process.c b/arch/x86/kernel/process.c
index 00a9047..e9195a1 100644
--- a/arch/x86/kernel/process.c
+++ b/arch/x86/kernel/process.c
@@ -68,19 +68,6 @@ __visible DEFINE_PER_CPU_SHARED_ALIGNED_USER_MAPPED(struct tss_struct, cpu_tss)
 
 #ifdef CONFIG_X86_64
 static DEFINE_PER_CPU(unsigned char, is_idle);
-static ATOMIC_NOTIFIER_HEAD(idle_notifier);
-
-void idle_notifier_register(struct notifier_block *n)
-{
-	atomic_notifier_chain_register(&idle_notifier, n);
-}
-EXPORT_SYMBOL_GPL(idle_notifier_register);
-
-void idle_notifier_unregister(struct notifier_block *n)
-{
-	atomic_notifier_chain_unregister(&idle_notifier, n);
-}
-EXPORT_SYMBOL_GPL(idle_notifier_unregister);
 #endif
 
 /*
@@ -397,14 +384,14 @@ static inline void play_dead(void)
 void enter_idle(void)
 {
 	this_cpu_write(is_idle, 1);
-	atomic_notifier_call_chain(&idle_notifier, IDLE_START, NULL);
+	idle_notifier_call_chain(IDLE_START);
 }
 
 static void __exit_idle(void)
 {
 	if (x86_test_and_clear_bit_percpu(0, is_idle) == 0)
 		return;
-	atomic_notifier_call_chain(&idle_notifier, IDLE_END, NULL);
+	idle_notifier_call_chain(IDLE_END);
 }
 
 /* Called from interrupts to signify idle end */
diff --git a/arch/x86/kvm/vmx.c b/arch/x86/kvm/vmx.c
index 30b74b4..995cd24 100644
--- a/arch/x86/kvm/vmx.c
+++ b/arch/x86/kvm/vmx.c
@@ -8656,7 +8656,6 @@ static void vmx_complete_atomic_exit(struct vcpu_vmx *vmx)
 static void vmx_handle_external_intr(struct kvm_vcpu *vcpu)
 {
 	u32 exit_intr_info = vmcs_read32(VM_EXIT_INTR_INFO);
-	register void *__sp asm(_ASM_SP);
 
 	/*
 	 * If external interrupt exists, IF bit is set in rflags/eflags on the
@@ -8690,7 +8689,7 @@ static void vmx_handle_external_intr(struct kvm_vcpu *vcpu)
 #ifdef CONFIG_X86_64
 			[sp]"=&r"(tmp),
 #endif
-			"+r"(__sp)
+			ASM_CALL_CONSTRAINT
 			:
 			THUNK_TARGET(entry),
 			[ss]"i"(__KERNEL_DS),
diff --git a/arch/x86/mm/fault.c b/arch/x86/mm/fault.c
index ae23c99..54efa85 100644
--- a/arch/x86/mm/fault.c
+++ b/arch/x86/mm/fault.c
@@ -759,7 +759,6 @@ static int is_f00f_bug(struct pt_regs *regs, unsigned long address)
 	if (is_vmalloc_addr((void *)address) &&
 	    (((unsigned long)tsk->stack - 1 - address < PAGE_SIZE) ||
 	     address - ((unsigned long)tsk->stack + THREAD_SIZE) < PAGE_SIZE)) {
-		register void *__sp asm("rsp");
 		unsigned long stack = this_cpu_read(orig_ist.ist[DOUBLEFAULT_STACK]) - sizeof(void *);
 		/*
 		 * We're likely to be running with very little stack space
@@ -774,7 +773,7 @@ static int is_f00f_bug(struct pt_regs *regs, unsigned long address)
 		asm volatile ("movq %[stack], %%rsp\n\t"
 			      "call handle_stack_overflow\n\t"
 			      "1: jmp 1b"
-			      : "+r" (__sp)
+			      : ASM_CALL_CONSTRAINT
 			      : "D" ("kernel stack overflow (page fault)"),
 				"S" (regs), "d" (address),
 				[stack] "rm" (stack));
diff --git a/arch/x86/oprofile/nmi_int.c b/arch/x86/oprofile/nmi_int.c
index 842ca3c..18f9dad 100644
--- a/arch/x86/oprofile/nmi_int.c
+++ b/arch/x86/oprofile/nmi_int.c
@@ -615,7 +615,7 @@ enum __force_cpu_type {
 
 static int force_cpu_type;
 
-static int set_cpu_type(const char *str, struct kernel_param *kp)
+static int set_cpu_type(const char *str, const struct kernel_param *kp)
 {
 	if (!strcmp(str, "timer")) {
 		force_cpu_type = timer;
diff --git a/arch/xtensa/include/uapi/asm/socket.h b/arch/xtensa/include/uapi/asm/socket.h
index 81435d9..fc7ca28 100644
--- a/arch/xtensa/include/uapi/asm/socket.h
+++ b/arch/xtensa/include/uapi/asm/socket.h
@@ -101,4 +101,6 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif	/* _XTENSA_SOCKET_H */
diff --git a/block/blk-core.c b/block/blk-core.c
index 77b99bf..c13af61 100644
--- a/block/blk-core.c
+++ b/block/blk-core.c
@@ -40,6 +40,8 @@
 #include "blk.h"
 #include "blk-mq.h"
 
+#include <linux/math64.h>
+
 EXPORT_TRACEPOINT_SYMBOL_GPL(block_bio_remap);
 EXPORT_TRACEPOINT_SYMBOL_GPL(block_rq_remap);
 EXPORT_TRACEPOINT_SYMBOL_GPL(block_bio_complete);
@@ -3569,3 +3571,52 @@ int __init blk_dev_init(void)
 
 	return 0;
 }
+
+/*
+ * Blk IO latency support. We want this to be as cheap as possible, so doing
+ * this lockless (and avoiding atomics), a few off by a few errors in this
+ * code is not harmful, and we don't want to do anything that is
+ * perf-impactful.
+ * TODO : If necessary, we can make the histograms per-cpu and aggregate
+ * them when printing them out.
+ */
+ssize_t
+blk_latency_hist_show(char* name, struct io_latency_state *s, char *buf,
+		int buf_size)
+{
+	int i;
+	int bytes_written = 0;
+	u_int64_t num_elem, elem;
+	int pct;
+	u_int64_t average;
+
+       num_elem = s->latency_elems;
+       if (num_elem > 0) {
+	       average = div64_u64(s->latency_sum, s->latency_elems);
+	       bytes_written += scnprintf(buf + bytes_written,
+			       buf_size - bytes_written,
+			       "IO svc_time %s Latency Histogram (n = %llu,"
+			       " average = %llu):\n", name, num_elem, average);
+	       for (i = 0;
+		    i < ARRAY_SIZE(latency_x_axis_us);
+		    i++) {
+		       elem = s->latency_y_axis[i];
+		       pct = div64_u64(elem * 100, num_elem);
+		       bytes_written += scnprintf(buf + bytes_written,
+				       PAGE_SIZE - bytes_written,
+				       "\t< %6lluus%15llu%15d%%\n",
+				       latency_x_axis_us[i],
+				       elem, pct);
+	       }
+	       /* Last element in y-axis table is overflow */
+	       elem = s->latency_y_axis[i];
+	       pct = div64_u64(elem * 100, num_elem);
+	       bytes_written += scnprintf(buf + bytes_written,
+			       PAGE_SIZE - bytes_written,
+			       "\t>=%6lluus%15llu%15d%%\n",
+			       latency_x_axis_us[i - 1], elem, pct);
+	}
+
+	return bytes_written;
+}
+EXPORT_SYMBOL(blk_latency_hist_show);
diff --git a/build.config.cuttlefish.x86_64 b/build.config.cuttlefish.x86_64
new file mode 100644
index 00000000..8d56143
--- /dev/null
+++ b/build.config.cuttlefish.x86_64
@@ -0,0 +1,16 @@
+ARCH=x86_64
+BRANCH=android-4.9
+CLANG_TRIPLE=x86_64-linux-gnu-
+CROSS_COMPILE=x86_64-linux-androidkernel-
+DEFCONFIG=x86_64_cuttlefish_defconfig
+EXTRA_CMDS=''
+KERNEL_DIR=common
+POST_DEFCONFIG_CMDS="check_defconfig"
+CLANG_PREBUILT_BIN=prebuilts-master/clang/host/linux-x86/clang-r328903/bin
+LINUX_GCC_CROSS_COMPILE_PREBUILTS_BIN=prebuilts/gcc/linux-x86/x86/x86_64-linux-android-4.9/bin
+FILES="
+arch/x86/boot/bzImage
+vmlinux
+System.map
+"
+STOP_SHIP_TRACEPRINTK=1
diff --git a/build.config.goldfish.arm b/build.config.goldfish.arm
new file mode 100644
index 00000000..ff5646a
--- /dev/null
+++ b/build.config.goldfish.arm
@@ -0,0 +1,13 @@
+ARCH=arm
+BRANCH=android-4.4
+CROSS_COMPILE=arm-linux-androidkernel-
+DEFCONFIG=ranchu_defconfig
+EXTRA_CMDS=''
+KERNEL_DIR=common
+LINUX_GCC_CROSS_COMPILE_PREBUILTS_BIN=prebuilts/gcc/linux-x86/arm/arm-linux-androideabi-4.9/bin
+FILES="
+arch/arm/boot/zImage
+vmlinux
+System.map
+"
+STOP_SHIP_TRACEPRINTK=1
diff --git a/build.config.goldfish.arm64 b/build.config.goldfish.arm64
new file mode 100644
index 00000000..4c896a6
--- /dev/null
+++ b/build.config.goldfish.arm64
@@ -0,0 +1,13 @@
+ARCH=arm64
+BRANCH=android-4.4
+CROSS_COMPILE=aarch64-linux-android-
+DEFCONFIG=ranchu64_defconfig
+EXTRA_CMDS=''
+KERNEL_DIR=common
+LINUX_GCC_CROSS_COMPILE_PREBUILTS_BIN=prebuilts/gcc/linux-x86/aarch64/aarch64-linux-android-4.9/bin
+FILES="
+arch/arm64/boot/Image
+vmlinux
+System.map
+"
+STOP_SHIP_TRACEPRINTK=1
diff --git a/build.config.goldfish.mips b/build.config.goldfish.mips
new file mode 100644
index 00000000..9a14a44
--- /dev/null
+++ b/build.config.goldfish.mips
@@ -0,0 +1,12 @@
+ARCH=mips
+BRANCH=android-4.4
+CROSS_COMPILE=mips64el-linux-android-
+DEFCONFIG=ranchu_defconfig
+EXTRA_CMDS=''
+KERNEL_DIR=common
+LINUX_GCC_CROSS_COMPILE_PREBUILTS_BIN=prebuilts/gcc/linux-x86/mips/mips64el-linux-android-4.9/bin
+FILES="
+vmlinux
+System.map
+"
+STOP_SHIP_TRACEPRINTK=1
diff --git a/build.config.goldfish.mips64 b/build.config.goldfish.mips64
new file mode 100644
index 00000000..6ad9759
--- /dev/null
+++ b/build.config.goldfish.mips64
@@ -0,0 +1,12 @@
+ARCH=mips
+BRANCH=android-4.4
+CROSS_COMPILE=mips64el-linux-android-
+DEFCONFIG=ranchu64_defconfig
+EXTRA_CMDS=''
+KERNEL_DIR=common
+LINUX_GCC_CROSS_COMPILE_PREBUILTS_BIN=prebuilts/gcc/linux-x86/mips/mips64el-linux-android-4.9/bin
+FILES="
+vmlinux
+System.map
+"
+STOP_SHIP_TRACEPRINTK=1
diff --git a/build.config.goldfish.x86 b/build.config.goldfish.x86
new file mode 100644
index 00000000..2266c62
--- /dev/null
+++ b/build.config.goldfish.x86
@@ -0,0 +1,13 @@
+ARCH=x86
+BRANCH=android-4.4
+CROSS_COMPILE=x86_64-linux-android-
+DEFCONFIG=i386_ranchu_defconfig
+EXTRA_CMDS=''
+KERNEL_DIR=common
+LINUX_GCC_CROSS_COMPILE_PREBUILTS_BIN=prebuilts/gcc/linux-x86/x86/x86_64-linux-android-4.9/bin
+FILES="
+arch/x86/boot/bzImage
+vmlinux
+System.map
+"
+STOP_SHIP_TRACEPRINTK=1
diff --git a/build.config.goldfish.x86_64 b/build.config.goldfish.x86_64
new file mode 100644
index 00000000..08c42c2
--- /dev/null
+++ b/build.config.goldfish.x86_64
@@ -0,0 +1,13 @@
+ARCH=x86_64
+BRANCH=android-4.4
+CROSS_COMPILE=x86_64-linux-android-
+DEFCONFIG=x86_64_ranchu_defconfig
+EXTRA_CMDS=''
+KERNEL_DIR=common
+LINUX_GCC_CROSS_COMPILE_PREBUILTS_BIN=prebuilts/gcc/linux-x86/x86/x86_64-linux-android-4.9/bin
+FILES="
+arch/x86/boot/bzImage
+vmlinux
+System.map
+"
+STOP_SHIP_TRACEPRINTK=1
diff --git a/certs/system_keyring.c b/certs/system_keyring.c
index 50979d6..4a34e41 100644
--- a/certs/system_keyring.c
+++ b/certs/system_keyring.c
@@ -240,5 +240,46 @@ int verify_pkcs7_signature(const void *data, size_t len,
 	return ret;
 }
 EXPORT_SYMBOL_GPL(verify_pkcs7_signature);
-
 #endif /* CONFIG_SYSTEM_DATA_VERIFICATION */
+
+/**
+ * verify_signature_one - Verify a signature with keys from given keyring
+ * @sig: The signature to be verified
+ * @trusted_keys: Trusted keys to use (NULL for builtin trusted keys only,
+ *					(void *)1UL for all trusted keys).
+ * @keyid: key description (not partial)
+ */
+int verify_signature_one(const struct public_key_signature *sig,
+			   struct key *trusted_keys, const char *keyid)
+{
+	key_ref_t ref;
+	struct key *key;
+	int ret;
+
+	if (!sig)
+		return -EBADMSG;
+	if (!trusted_keys) {
+		trusted_keys = builtin_trusted_keys;
+	} else if (trusted_keys == (void *)1UL) {
+#ifdef CONFIG_SECONDARY_TRUSTED_KEYRING
+		trusted_keys = secondary_trusted_keys;
+#else
+		trusted_keys = builtin_trusted_keys;
+#endif
+	}
+
+	ref = keyring_search(make_key_ref(trusted_keys, 1),
+				&key_type_asymmetric, keyid);
+	if (IS_ERR(ref)) {
+		pr_err("Asymmetric key (%s) not found in keyring(%s)\n",
+				keyid, trusted_keys->description);
+		return -ENOKEY;
+	}
+
+	key = key_ref_to_ptr(ref);
+	ret = verify_signature(key, sig);
+	key_put(key);
+	return ret;
+}
+EXPORT_SYMBOL_GPL(verify_signature_one);
+
diff --git a/crypto/Kconfig b/crypto/Kconfig
index ab0d93a..0f32afc 100644
--- a/crypto/Kconfig
+++ b/crypto/Kconfig
@@ -1444,6 +1444,20 @@ config CRYPTO_SERPENT_AVX2_X86_64
 	  See also:
 	  <http://www.cl.cam.ac.uk/~rja14/serpent.html>
 
+config CRYPTO_SPECK
+	tristate "Speck cipher algorithm"
+	select CRYPTO_ALGAPI
+	help
+	  Speck is a lightweight block cipher that is tuned for optimal
+	  performance in software (rather than hardware).
+
+	  Speck may not be as secure as AES, and should only be used on systems
+	  where AES is not fast enough.
+
+	  See also: <https://eprint.iacr.org/2013/404.pdf>
+
+	  If unsure, say N.
+
 config CRYPTO_TEA
 	tristate "TEA, XTEA and XETA cipher algorithms"
 	select CRYPTO_ALGAPI
diff --git a/crypto/Makefile b/crypto/Makefile
index 9e52b3c..5b08597 100644
--- a/crypto/Makefile
+++ b/crypto/Makefile
@@ -106,6 +106,7 @@ obj-$(CONFIG_CRYPTO_TEA) += tea.o
 obj-$(CONFIG_CRYPTO_KHAZAD) += khazad.o
 obj-$(CONFIG_CRYPTO_ANUBIS) += anubis.o
 obj-$(CONFIG_CRYPTO_SEED) += seed.o
+obj-$(CONFIG_CRYPTO_SPECK) += speck.o
 obj-$(CONFIG_CRYPTO_SALSA20) += salsa20_generic.o
 obj-$(CONFIG_CRYPTO_CHACHA20) += chacha20_generic.o
 obj-$(CONFIG_CRYPTO_POLY1305) += poly1305_generic.o
diff --git a/crypto/algboss.c b/crypto/algboss.c
index 6e39d9c..26704fb 100644
--- a/crypto/algboss.c
+++ b/crypto/algboss.c
@@ -25,6 +25,8 @@
 
 #include "internal.h"
 
+//#define CRYPTO_TEST_ALL
+
 struct cryptomgr_param {
 	struct rtattr *tb[CRYPTO_MAX_ATTRS + 2];
 
@@ -246,6 +248,8 @@ static int cryptomgr_schedule_test(struct crypto_alg *alg)
 	memcpy(param->driver, alg->cra_driver_name, sizeof(param->driver));
 	memcpy(param->alg, alg->cra_name, sizeof(param->alg));
 	type = alg->cra_flags;
+#ifndef CRYPTO_TEST_ALL
+
 
 	/* This piece of crap needs to disappear into per-type test hooks. */
 	if (!((type ^ CRYPTO_ALG_TYPE_BLKCIPHER) &
@@ -255,6 +259,8 @@ static int cryptomgr_schedule_test(struct crypto_alg *alg)
 					 alg->cra_ablkcipher.ivsize))
 		type |= CRYPTO_ALG_TESTED;
 
+
+#endif
 	param->type = type;
 
 	thread = kthread_run(cryptomgr_test, param, "cryptomgr_test");
diff --git a/crypto/api.c b/crypto/api.c
index bbc147c..e5c1abf 100644
--- a/crypto/api.c
+++ b/crypto/api.c
@@ -24,6 +24,7 @@
 #include <linux/sched.h>
 #include <linux/slab.h>
 #include <linux/string.h>
+#include <linux/completion.h>
 #include "internal.h"
 
 LIST_HEAD(crypto_alg_list);
@@ -611,5 +612,17 @@ int crypto_has_alg(const char *name, u32 type, u32 mask)
 }
 EXPORT_SYMBOL_GPL(crypto_has_alg);
 
+void crypto_req_done(struct crypto_async_request *req, int err)
+{
+	struct crypto_wait *wait = req->data;
+
+	if (err == -EINPROGRESS)
+		return;
+
+	wait->err = err;
+	complete(&wait->completion);
+}
+EXPORT_SYMBOL_GPL(crypto_req_done);
+
 MODULE_DESCRIPTION("Cryptographic core API");
 MODULE_LICENSE("GPL");
diff --git a/crypto/speck.c b/crypto/speck.c
new file mode 100644
index 00000000..58aa9f7
--- /dev/null
+++ b/crypto/speck.c
@@ -0,0 +1,307 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Speck: a lightweight block cipher
+ *
+ * Copyright (c) 2018 Google, Inc
+ *
+ * Speck has 10 variants, including 5 block sizes.  For now we only implement
+ * the variants Speck128/128, Speck128/192, Speck128/256, Speck64/96, and
+ * Speck64/128.   Speck${B}/${K} denotes the variant with a block size of B bits
+ * and a key size of K bits.  The Speck128 variants are believed to be the most
+ * secure variants, and they use the same block size and key sizes as AES.  The
+ * Speck64 variants are less secure, but on 32-bit processors are usually
+ * faster.  The remaining variants (Speck32, Speck48, and Speck96) are even less
+ * secure and/or not as well suited for implementation on either 32-bit or
+ * 64-bit processors, so are omitted.
+ *
+ * Reference: "The Simon and Speck Families of Lightweight Block Ciphers"
+ * https://eprint.iacr.org/2013/404.pdf
+ *
+ * In a correspondence, the Speck designers have also clarified that the words
+ * should be interpreted in little-endian format, and the words should be
+ * ordered such that the first word of each block is 'y' rather than 'x', and
+ * the first key word (rather than the last) becomes the first round key.
+ */
+
+#include <asm/unaligned.h>
+#include <crypto/speck.h>
+#include <linux/bitops.h>
+#include <linux/crypto.h>
+#include <linux/init.h>
+#include <linux/module.h>
+
+/* Speck128 */
+
+static __always_inline void speck128_round(u64 *x, u64 *y, u64 k)
+{
+	*x = ror64(*x, 8);
+	*x += *y;
+	*x ^= k;
+	*y = rol64(*y, 3);
+	*y ^= *x;
+}
+
+static __always_inline void speck128_unround(u64 *x, u64 *y, u64 k)
+{
+	*y ^= *x;
+	*y = ror64(*y, 3);
+	*x ^= k;
+	*x -= *y;
+	*x = rol64(*x, 8);
+}
+
+void crypto_speck128_encrypt(const struct speck128_tfm_ctx *ctx,
+			     u8 *out, const u8 *in)
+{
+	u64 y = get_unaligned_le64(in);
+	u64 x = get_unaligned_le64(in + 8);
+	int i;
+
+	for (i = 0; i < ctx->nrounds; i++)
+		speck128_round(&x, &y, ctx->round_keys[i]);
+
+	put_unaligned_le64(y, out);
+	put_unaligned_le64(x, out + 8);
+}
+EXPORT_SYMBOL_GPL(crypto_speck128_encrypt);
+
+static void speck128_encrypt(struct crypto_tfm *tfm, u8 *out, const u8 *in)
+{
+	crypto_speck128_encrypt(crypto_tfm_ctx(tfm), out, in);
+}
+
+void crypto_speck128_decrypt(const struct speck128_tfm_ctx *ctx,
+			     u8 *out, const u8 *in)
+{
+	u64 y = get_unaligned_le64(in);
+	u64 x = get_unaligned_le64(in + 8);
+	int i;
+
+	for (i = ctx->nrounds - 1; i >= 0; i--)
+		speck128_unround(&x, &y, ctx->round_keys[i]);
+
+	put_unaligned_le64(y, out);
+	put_unaligned_le64(x, out + 8);
+}
+EXPORT_SYMBOL_GPL(crypto_speck128_decrypt);
+
+static void speck128_decrypt(struct crypto_tfm *tfm, u8 *out, const u8 *in)
+{
+	crypto_speck128_decrypt(crypto_tfm_ctx(tfm), out, in);
+}
+
+int crypto_speck128_setkey(struct speck128_tfm_ctx *ctx, const u8 *key,
+			   unsigned int keylen)
+{
+	u64 l[3];
+	u64 k;
+	int i;
+
+	switch (keylen) {
+	case SPECK128_128_KEY_SIZE:
+		k = get_unaligned_le64(key);
+		l[0] = get_unaligned_le64(key + 8);
+		ctx->nrounds = SPECK128_128_NROUNDS;
+		for (i = 0; i < ctx->nrounds; i++) {
+			ctx->round_keys[i] = k;
+			speck128_round(&l[0], &k, i);
+		}
+		break;
+	case SPECK128_192_KEY_SIZE:
+		k = get_unaligned_le64(key);
+		l[0] = get_unaligned_le64(key + 8);
+		l[1] = get_unaligned_le64(key + 16);
+		ctx->nrounds = SPECK128_192_NROUNDS;
+		for (i = 0; i < ctx->nrounds; i++) {
+			ctx->round_keys[i] = k;
+			speck128_round(&l[i % 2], &k, i);
+		}
+		break;
+	case SPECK128_256_KEY_SIZE:
+		k = get_unaligned_le64(key);
+		l[0] = get_unaligned_le64(key + 8);
+		l[1] = get_unaligned_le64(key + 16);
+		l[2] = get_unaligned_le64(key + 24);
+		ctx->nrounds = SPECK128_256_NROUNDS;
+		for (i = 0; i < ctx->nrounds; i++) {
+			ctx->round_keys[i] = k;
+			speck128_round(&l[i % 3], &k, i);
+		}
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(crypto_speck128_setkey);
+
+static int speck128_setkey(struct crypto_tfm *tfm, const u8 *key,
+			   unsigned int keylen)
+{
+	return crypto_speck128_setkey(crypto_tfm_ctx(tfm), key, keylen);
+}
+
+/* Speck64 */
+
+static __always_inline void speck64_round(u32 *x, u32 *y, u32 k)
+{
+	*x = ror32(*x, 8);
+	*x += *y;
+	*x ^= k;
+	*y = rol32(*y, 3);
+	*y ^= *x;
+}
+
+static __always_inline void speck64_unround(u32 *x, u32 *y, u32 k)
+{
+	*y ^= *x;
+	*y = ror32(*y, 3);
+	*x ^= k;
+	*x -= *y;
+	*x = rol32(*x, 8);
+}
+
+void crypto_speck64_encrypt(const struct speck64_tfm_ctx *ctx,
+			    u8 *out, const u8 *in)
+{
+	u32 y = get_unaligned_le32(in);
+	u32 x = get_unaligned_le32(in + 4);
+	int i;
+
+	for (i = 0; i < ctx->nrounds; i++)
+		speck64_round(&x, &y, ctx->round_keys[i]);
+
+	put_unaligned_le32(y, out);
+	put_unaligned_le32(x, out + 4);
+}
+EXPORT_SYMBOL_GPL(crypto_speck64_encrypt);
+
+static void speck64_encrypt(struct crypto_tfm *tfm, u8 *out, const u8 *in)
+{
+	crypto_speck64_encrypt(crypto_tfm_ctx(tfm), out, in);
+}
+
+void crypto_speck64_decrypt(const struct speck64_tfm_ctx *ctx,
+			    u8 *out, const u8 *in)
+{
+	u32 y = get_unaligned_le32(in);
+	u32 x = get_unaligned_le32(in + 4);
+	int i;
+
+	for (i = ctx->nrounds - 1; i >= 0; i--)
+		speck64_unround(&x, &y, ctx->round_keys[i]);
+
+	put_unaligned_le32(y, out);
+	put_unaligned_le32(x, out + 4);
+}
+EXPORT_SYMBOL_GPL(crypto_speck64_decrypt);
+
+static void speck64_decrypt(struct crypto_tfm *tfm, u8 *out, const u8 *in)
+{
+	crypto_speck64_decrypt(crypto_tfm_ctx(tfm), out, in);
+}
+
+int crypto_speck64_setkey(struct speck64_tfm_ctx *ctx, const u8 *key,
+			  unsigned int keylen)
+{
+	u32 l[3];
+	u32 k;
+	int i;
+
+	switch (keylen) {
+	case SPECK64_96_KEY_SIZE:
+		k = get_unaligned_le32(key);
+		l[0] = get_unaligned_le32(key + 4);
+		l[1] = get_unaligned_le32(key + 8);
+		ctx->nrounds = SPECK64_96_NROUNDS;
+		for (i = 0; i < ctx->nrounds; i++) {
+			ctx->round_keys[i] = k;
+			speck64_round(&l[i % 2], &k, i);
+		}
+		break;
+	case SPECK64_128_KEY_SIZE:
+		k = get_unaligned_le32(key);
+		l[0] = get_unaligned_le32(key + 4);
+		l[1] = get_unaligned_le32(key + 8);
+		l[2] = get_unaligned_le32(key + 12);
+		ctx->nrounds = SPECK64_128_NROUNDS;
+		for (i = 0; i < ctx->nrounds; i++) {
+			ctx->round_keys[i] = k;
+			speck64_round(&l[i % 3], &k, i);
+		}
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(crypto_speck64_setkey);
+
+static int speck64_setkey(struct crypto_tfm *tfm, const u8 *key,
+			  unsigned int keylen)
+{
+	return crypto_speck64_setkey(crypto_tfm_ctx(tfm), key, keylen);
+}
+
+/* Algorithm definitions */
+
+static struct crypto_alg speck_algs[] = {
+	{
+		.cra_name		= "speck128",
+		.cra_driver_name	= "speck128-generic",
+		.cra_priority		= 100,
+		.cra_flags		= CRYPTO_ALG_TYPE_CIPHER,
+		.cra_blocksize		= SPECK128_BLOCK_SIZE,
+		.cra_ctxsize		= sizeof(struct speck128_tfm_ctx),
+		.cra_module		= THIS_MODULE,
+		.cra_u			= {
+			.cipher = {
+				.cia_min_keysize	= SPECK128_128_KEY_SIZE,
+				.cia_max_keysize	= SPECK128_256_KEY_SIZE,
+				.cia_setkey		= speck128_setkey,
+				.cia_encrypt		= speck128_encrypt,
+				.cia_decrypt		= speck128_decrypt
+			}
+		}
+	}, {
+		.cra_name		= "speck64",
+		.cra_driver_name	= "speck64-generic",
+		.cra_priority		= 100,
+		.cra_flags		= CRYPTO_ALG_TYPE_CIPHER,
+		.cra_blocksize		= SPECK64_BLOCK_SIZE,
+		.cra_ctxsize		= sizeof(struct speck64_tfm_ctx),
+		.cra_module		= THIS_MODULE,
+		.cra_u			= {
+			.cipher = {
+				.cia_min_keysize	= SPECK64_96_KEY_SIZE,
+				.cia_max_keysize	= SPECK64_128_KEY_SIZE,
+				.cia_setkey		= speck64_setkey,
+				.cia_encrypt		= speck64_encrypt,
+				.cia_decrypt		= speck64_decrypt
+			}
+		}
+	}
+};
+
+static int __init speck_module_init(void)
+{
+	return crypto_register_algs(speck_algs, ARRAY_SIZE(speck_algs));
+}
+
+static void __exit speck_module_exit(void)
+{
+	crypto_unregister_algs(speck_algs, ARRAY_SIZE(speck_algs));
+}
+
+module_init(speck_module_init);
+module_exit(speck_module_exit);
+
+MODULE_DESCRIPTION("Speck block cipher (generic)");
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Eric Biggers <ebiggers@google.com>");
+MODULE_ALIAS_CRYPTO("speck128");
+MODULE_ALIAS_CRYPTO("speck128-generic");
+MODULE_ALIAS_CRYPTO("speck64");
+MODULE_ALIAS_CRYPTO("speck64-generic");
diff --git a/crypto/testmgr.c b/crypto/testmgr.c
index 62dffa0..14f72c40 100644
--- a/crypto/testmgr.c
+++ b/crypto/testmgr.c
@@ -3238,6 +3238,36 @@ static int alg_test_null(const struct alg_test_desc *desc,
 			}
 		}
 	}, {
+		.alg = "ecb(speck128)",
+		.test = alg_test_skcipher,
+		.suite = {
+			.cipher = {
+				.enc = {
+					.vecs = speck128_enc_tv_template,
+					.count = ARRAY_SIZE(speck128_enc_tv_template)
+				},
+				.dec = {
+					.vecs = speck128_dec_tv_template,
+					.count = ARRAY_SIZE(speck128_dec_tv_template)
+				}
+			}
+		}
+	}, {
+		.alg = "ecb(speck64)",
+		.test = alg_test_skcipher,
+		.suite = {
+			.cipher = {
+				.enc = {
+					.vecs = speck64_enc_tv_template,
+					.count = ARRAY_SIZE(speck64_enc_tv_template)
+				},
+				.dec = {
+					.vecs = speck64_dec_tv_template,
+					.count = ARRAY_SIZE(speck64_dec_tv_template)
+				}
+			}
+		}
+	}, {
 		.alg = "ecb(tea)",
 		.test = alg_test_skcipher,
 		.suite = {
@@ -4058,6 +4088,36 @@ static int alg_test_null(const struct alg_test_desc *desc,
 			}
 		}
 	}, {
+		.alg = "xts(speck128)",
+		.test = alg_test_skcipher,
+		.suite = {
+			.cipher = {
+				.enc = {
+					.vecs = speck128_xts_enc_tv_template,
+					.count = ARRAY_SIZE(speck128_xts_enc_tv_template)
+				},
+				.dec = {
+					.vecs = speck128_xts_dec_tv_template,
+					.count = ARRAY_SIZE(speck128_xts_dec_tv_template)
+				}
+			}
+		}
+	}, {
+		.alg = "xts(speck64)",
+		.test = alg_test_skcipher,
+		.suite = {
+			.cipher = {
+				.enc = {
+					.vecs = speck64_xts_enc_tv_template,
+					.count = ARRAY_SIZE(speck64_xts_enc_tv_template)
+				},
+				.dec = {
+					.vecs = speck64_xts_dec_tv_template,
+					.count = ARRAY_SIZE(speck64_xts_dec_tv_template)
+				}
+			}
+		}
+	}, {
 		.alg = "xts(twofish)",
 		.test = alg_test_skcipher,
 		.suite = {
@@ -4134,7 +4194,9 @@ int alg_test(const char *driver, const char *alg, u32 type, u32 mask)
 	int i;
 	int j;
 	int rc;
-
+#ifdef CRYPTO_RTK_TEST
+	printk(KERN_ERR "alg: test for %s (%s)\n", alg, driver);
+#endif
 	if (!fips_enabled && notests) {
 		printk_once(KERN_INFO "alg: self-tests disabled\n");
 		return 0;
diff --git a/crypto/testmgr.h b/crypto/testmgr.h
index 9033088..38eabc0 100644
--- a/crypto/testmgr.h
+++ b/crypto/testmgr.h
@@ -32,6 +32,8 @@
 #define MAX_KEYLEN		160
 #define MAX_IVLEN		32
 
+//#define CRYPTO_RTK_TEST //not support chunk
+
 struct hash_testvec {
 	/* only used with keyed hash algorithms */
 	char *key;
@@ -1737,10 +1739,15 @@ struct kpp_testvec ecdh_tv_template[] = {
 /*
  * SHA256 test vectors from from NIST
  */
+#ifndef CRYPTO_RTK_TEST
 #define SHA256_TEST_VECTORS	5
+#else
+#define SHA256_TEST_VECTORS     4
+#endif
 
 static struct hash_testvec sha256_tv_template[] = {
 	{
+#ifndef CRYPTO_RTK_TEST
 		.plaintext = "",
 		.psize	= 0,
 		.digest	= "\xe3\xb0\xc4\x42\x98\xfc\x1c\x14"
@@ -1748,6 +1755,7 @@ struct kpp_testvec ecdh_tv_template[] = {
 			  "\x27\xae\x41\xe4\x64\x9b\x93\x4c"
 			  "\xa4\x95\x99\x1b\x78\x52\xb8\x55",
 	}, {
+#endif
 		.plaintext = "abc",
 		.psize	= 3,
 		.digest	= "\xba\x78\x16\xbf\x8f\x01\xcf\xea"
@@ -1761,8 +1769,10 @@ struct kpp_testvec ecdh_tv_template[] = {
 			  "\xe5\xc0\x26\x93\x0c\x3e\x60\x39"
 			  "\xa3\x3c\xe4\x59\x64\xff\x21\x67"
 			  "\xf6\xec\xed\xd4\x19\xdb\x06\xc1",
+#ifndef CRYPTO_RTK_TEST
 		.np	= 2,
 		.tap	= { 28, 28 }
+#endif
 	}, {
 		.plaintext = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-",
 		.psize	= 64,
@@ -13622,248 +13632,1734 @@ struct kpp_testvec ecdh_tv_template[] = {
 	},
 };
 
-/* Cast6 test vectors from RFC 2612 */
-#define CAST6_ENC_TEST_VECTORS		4
-#define CAST6_DEC_TEST_VECTORS		4
-#define CAST6_CBC_ENC_TEST_VECTORS	1
-#define CAST6_CBC_DEC_TEST_VECTORS	1
-#define CAST6_CTR_ENC_TEST_VECTORS	2
-#define CAST6_CTR_DEC_TEST_VECTORS	2
-#define CAST6_LRW_ENC_TEST_VECTORS	1
-#define CAST6_LRW_DEC_TEST_VECTORS	1
-#define CAST6_XTS_ENC_TEST_VECTORS	1
-#define CAST6_XTS_DEC_TEST_VECTORS	1
+/*
+ * Speck test vectors taken from the original paper:
+ * "The Simon and Speck Families of Lightweight Block Ciphers"
+ * https://eprint.iacr.org/2013/404.pdf
+ *
+ * Note that the paper does not make byte and word order clear.  But it was
+ * confirmed with the authors that the intended orders are little endian byte
+ * order and (y, x) word order.  Equivalently, the printed test vectors, when
+ * looking at only the bytes (ignoring the whitespace that divides them into
+ * words), are backwards: the left-most byte is actually the one with the
+ * highest memory address, while the right-most byte is actually the one with
+ * the lowest memory address.
+ */
 
-static struct cipher_testvec cast6_enc_tv_template[] = {
-	{
-		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
-			  "\x0a\xf7\x56\x47\xf2\x9f\x61\x5d",
+static struct cipher_testvec speck128_enc_tv_template[] = {
+	{ /* Speck128/128 */
+		.key	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f",
 		.klen	= 16,
-		.input	= zeroed_string,
+		.input	= "\x20\x6d\x61\x64\x65\x20\x69\x74"
+			  "\x20\x65\x71\x75\x69\x76\x61\x6c",
 		.ilen	= 16,
-		.result	= "\xc8\x42\xa0\x89\x72\xb4\x3d\x20"
-			  "\x83\x6c\x91\xd1\xb7\x53\x0f\x6b",
+		.result	= "\x18\x0d\x57\x5c\xdf\xfe\x60\x78"
+			  "\x65\x32\x78\x79\x51\x98\x5d\xa6",
 		.rlen	= 16,
-	}, {
-		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
-			  "\xbe\xd0\xac\x83\x94\x0a\xc2\x98"
-			  "\xba\xc7\x7a\x77\x17\x94\x28\x63",
+	}, { /* Speck128/192 */
+		.key	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17",
 		.klen	= 24,
-		.input	= zeroed_string,
+		.input	= "\x65\x6e\x74\x20\x74\x6f\x20\x43"
+			  "\x68\x69\x65\x66\x20\x48\x61\x72",
 		.ilen	= 16,
-		.result	= "\x1b\x38\x6c\x02\x10\xdc\xad\xcb"
-			  "\xdd\x0e\x41\xaa\x08\xa7\xa7\xe8",
+		.result	= "\x86\x18\x3c\xe0\x5d\x18\xbc\xf9"
+			  "\x66\x55\x13\x13\x3a\xcf\xe4\x1b",
 		.rlen	= 16,
-	}, {
-		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
-			  "\xbe\xd0\xac\x83\x94\x0a\xc2\x98"
-			  "\x8d\x7c\x47\xce\x26\x49\x08\x46"
-			  "\x1c\xc1\xb5\x13\x7a\xe6\xb6\x04",
+	}, { /* Speck128/256 */
+		.key	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f",
 		.klen	= 32,
-		.input	= zeroed_string,
+		.input	= "\x70\x6f\x6f\x6e\x65\x72\x2e\x20"
+			  "\x49\x6e\x20\x74\x68\x6f\x73\x65",
 		.ilen	= 16,
-		.result	= "\x4f\x6a\x20\x38\x28\x68\x97\xb9"
-			  "\xc9\x87\x01\x36\x55\x33\x17\xfa",
+		.result	= "\x43\x8f\x18\x9c\x8d\xb4\xee\x4e"
+			  "\x3e\xf5\xc0\x05\x04\x01\x09\x41",
 		.rlen	= 16,
-	}, { /* Generated from TF test vectors */
-		.key	= "\x85\x62\x3F\x1C\xF9\xD6\x1C\xF9"
-			  "\xD6\xB3\x90\x6D\x4A\x90\x6D\x4A"
-			  "\x27\x04\xE1\x27\x04\xE1\xBE\x9B"
-			  "\x78\xBE\x9B\x78\x55\x32\x0F\x55",
-		.klen	= 32,
-		.iv	= "\xE2\x24\x89\xEE\x53\xB8\x1D\x5F"
-			  "\xC4\x29\x8E\xF3\x35\x9A\xFF\x64",
-		.input	= "\x56\xED\x84\x1B\x8F\x26\xBD\x31"
-			  "\xC8\x5F\xF6\x6A\x01\x98\x0C\xA3"
-			  "\x3A\xD1\x45\xDC\x73\x0A\x7E\x15"
-			  "\xAC\x20\xB7\x4E\xE5\x59\xF0\x87"
-			  "\x1E\x92\x29\xC0\x34\xCB\x62\xF9"
-			  "\x6D\x04\x9B\x0F\xA6\x3D\xD4\x48"
-			  "\xDF\x76\x0D\x81\x18\xAF\x23\xBA"
-			  "\x51\xE8\x5C\xF3\x8A\x21\x95\x2C"
-			  "\xC3\x37\xCE\x65\xFC\x70\x07\x9E"
-			  "\x12\xA9\x40\xD7\x4B\xE2\x79\x10"
-			  "\x84\x1B\xB2\x26\xBD\x54\xEB\x5F"
-			  "\xF6\x8D\x01\x98\x2F\xC6\x3A\xD1"
-			  "\x68\xFF\x73\x0A\xA1\x15\xAC\x43"
-			  "\xDA\x4E\xE5\x7C\x13\x87\x1E\xB5"
-			  "\x29\xC0\x57\xEE\x62\xF9\x90\x04"
-			  "\x9B\x32\xC9\x3D\xD4\x6B\x02\x76"
-			  "\x0D\xA4\x18\xAF\x46\xDD\x51\xE8"
-			  "\x7F\x16\x8A\x21\xB8\x2C\xC3\x5A"
-			  "\xF1\x65\xFC\x93\x07\x9E\x35\xCC"
-			  "\x40\xD7\x6E\x05\x79\x10\xA7\x1B"
-			  "\xB2\x49\xE0\x54\xEB\x82\x19\x8D"
-			  "\x24\xBB\x2F\xC6\x5D\xF4\x68\xFF"
-			  "\x96\x0A\xA1\x38\xCF\x43\xDA\x71"
-			  "\x08\x7C\x13\xAA\x1E\xB5\x4C\xE3"
-			  "\x57\xEE\x85\x1C\x90\x27\xBE\x32"
-			  "\xC9\x60\xF7\x6B\x02\x99\x0D\xA4"
-			  "\x3B\xD2\x46\xDD\x74\x0B\x7F\x16"
-			  "\xAD\x21\xB8\x4F\xE6\x5A\xF1\x88"
-			  "\x1F\x93\x2A\xC1\x35\xCC\x63\xFA"
-			  "\x6E\x05\x9C\x10\xA7\x3E\xD5\x49"
-			  "\xE0\x77\x0E\x82\x19\xB0\x24\xBB"
-			  "\x52\xE9\x5D\xF4\x8B\x22\x96\x2D"
-			  "\xC4\x38\xCF\x66\xFD\x71\x08\x9F"
-			  "\x13\xAA\x41\xD8\x4C\xE3\x7A\x11"
-			  "\x85\x1C\xB3\x27\xBE\x55\xEC\x60"
-			  "\xF7\x8E\x02\x99\x30\xC7\x3B\xD2"
-			  "\x69\x00\x74\x0B\xA2\x16\xAD\x44"
-			  "\xDB\x4F\xE6\x7D\x14\x88\x1F\xB6"
-			  "\x2A\xC1\x58\xEF\x63\xFA\x91\x05"
-			  "\x9C\x33\xCA\x3E\xD5\x6C\x03\x77"
-			  "\x0E\xA5\x19\xB0\x47\xDE\x52\xE9"
-			  "\x80\x17\x8B\x22\xB9\x2D\xC4\x5B"
-			  "\xF2\x66\xFD\x94\x08\x9F\x36\xCD"
-			  "\x41\xD8\x6F\x06\x7A\x11\xA8\x1C"
-			  "\xB3\x4A\xE1\x55\xEC\x83\x1A\x8E"
-			  "\x25\xBC\x30\xC7\x5E\xF5\x69\x00"
-			  "\x97\x0B\xA2\x39\xD0\x44\xDB\x72"
-			  "\x09\x7D\x14\xAB\x1F\xB6\x4D\xE4"
-			  "\x58\xEF\x86\x1D\x91\x28\xBF\x33"
-			  "\xCA\x61\xF8\x6C\x03\x9A\x0E\xA5"
-			  "\x3C\xD3\x47\xDE\x75\x0C\x80\x17"
-			  "\xAE\x22\xB9\x50\xE7\x5B\xF2\x89"
-			  "\x20\x94\x2B\xC2\x36\xCD\x64\xFB"
-			  "\x6F\x06\x9D\x11\xA8\x3F\xD6\x4A"
-			  "\xE1\x78\x0F\x83\x1A\xB1\x25\xBC"
-			  "\x53\xEA\x5E\xF5\x8C\x00\x97\x2E"
-			  "\xC5\x39\xD0\x67\xFE\x72\x09\xA0"
-			  "\x14\xAB\x42\xD9\x4D\xE4\x7B\x12"
-			  "\x86\x1D\xB4\x28\xBF\x56\xED\x61"
-			  "\xF8\x8F\x03\x9A\x31\xC8\x3C\xD3"
-			  "\x6A\x01\x75\x0C\xA3\x17\xAE\x45"
-			  "\xDC\x50\xE7\x7E\x15\x89\x20\xB7",
-		.ilen	= 496,
-		.result	= "\xC3\x70\x22\x32\xF5\x80\xCB\x54"
-			  "\xFC\x30\xE0\xF6\xEB\x39\x57\xA6"
-			  "\xB6\xB9\xC5\xA4\x91\x55\x14\x97"
-			  "\xC1\x20\xFF\x6C\x5C\xF0\x67\xEA"
-			  "\x2F\xED\xD8\xC9\xFB\x38\x3F\xFE"
-			  "\x93\xBE\xDC\x00\xD3\x7F\xAD\x4C"
-			  "\x5A\x08\x92\xD1\x47\x0C\xFA\x6C"
-			  "\xD0\x6A\x99\x10\x72\xF8\x47\x62"
-			  "\x81\x42\xF8\xD8\xF5\xBB\x94\x08"
-			  "\xAA\x97\xA2\x8B\x69\xB3\xD2\x7E"
-			  "\xBC\xB5\x00\x0C\xE5\x44\x4B\x58"
-			  "\xE8\x63\xDC\xB3\xC4\xE5\x23\x12"
-			  "\x5A\x72\x85\x47\x8B\xEC\x9F\x26"
-			  "\x84\xB6\xED\x10\x33\x63\x9B\x5F"
-			  "\x4D\x53\xEE\x94\x45\x8B\x60\x58"
-			  "\x86\x20\xF9\x1E\x82\x08\x3E\x58"
-			  "\x60\x1B\x34\x19\x02\xBE\x4E\x09"
-			  "\xBB\x7C\x15\xCC\x60\x27\x55\x7A"
-			  "\x12\xB8\xD8\x08\x89\x3C\xA6\xF3"
-			  "\xF1\xDD\xA7\x07\xA3\x12\x85\x28"
-			  "\xE9\x57\xAC\x80\x0C\x5C\x0F\x3A"
-			  "\x5D\xC2\x91\xC7\x90\xE4\x8C\x43"
-			  "\x92\xE4\x7C\x26\x69\x4D\x83\x68"
-			  "\x14\x96\x42\x47\xBD\xA9\xE4\x8A"
-			  "\x33\x19\xEB\x54\x8E\x0D\x4B\x6E"
-			  "\x91\x51\xB5\x36\x08\xDE\x1C\x06"
-			  "\x03\xBD\xDE\x81\x26\xF7\x99\xC2"
-			  "\xBA\xF7\x6D\x87\x0D\xE4\xA6\xCF"
-			  "\xC1\xF5\x27\x05\xB8\x02\x57\x72"
-			  "\xE6\x42\x13\x0B\xC6\x47\x05\x74"
-			  "\x24\x15\xF7\x0D\xC2\x23\x9D\xB9"
-			  "\x3C\x77\x18\x93\xBA\xB4\xFC\x8C"
-			  "\x98\x82\x67\x67\xB4\xD7\xD3\x43"
-			  "\x23\x08\x02\xB7\x9B\x99\x05\xFB"
-			  "\xD3\xB5\x00\x0A\xA9\x9D\x66\xD6"
-			  "\x2E\x49\x58\xD0\xA8\x57\x29\x7F"
-			  "\x0A\x0E\x7D\xFC\x92\x83\xCC\x67"
-			  "\xA2\xB1\x70\x3A\x8F\x87\x4A\x8D"
-			  "\x17\xE2\x58\x2B\x88\x0D\x68\x62"
-			  "\xBF\x35\xD1\x6F\xC0\xF0\x18\x62"
-			  "\xB2\xC7\x2D\x58\xC7\x16\xDE\x08"
-			  "\xEB\x84\x1D\x25\xA7\x38\x94\x06"
-			  "\x93\x9D\xF8\xFE\x88\x71\xE7\x84"
-			  "\x2C\xA0\x38\xA3\x1D\x48\xCF\x29"
-			  "\x0B\xBC\xD8\x50\x99\x1A\x26\xFB"
-			  "\x8E\x75\x3D\x73\xEB\x6A\xED\x29"
-			  "\xE0\x8E\xED\xFC\xFE\x6F\xF6\xBA"
-			  "\x41\xE2\x10\x4C\x01\x8B\x69\x2B"
-			  "\x25\x3F\x4D\x70\x7B\x92\xD6\x3B"
-			  "\xAC\xF9\x77\x18\xD9\x6A\x30\xA6"
-			  "\x2E\xFA\x30\xFF\xC8\xD5\x1D\x06"
-			  "\x59\x28\x1D\x86\x43\x04\x5D\x3B"
-			  "\x99\x4C\x04\x5A\x21\x17\x8B\x76"
-			  "\x8F\x72\xCB\xA1\x9C\x29\x4C\xC3"
-			  "\x65\xA2\x58\x2A\xC5\x66\x24\xBF"
-			  "\xBA\xE6\x0C\xDD\x34\x24\x74\xC8"
-			  "\x84\x0A\x66\x2C\xBE\x8F\x32\xA9"
-			  "\xE7\xE4\xA1\xD7\xDA\xAB\x23\x1E"
-			  "\xEB\xEE\x6C\x94\x6F\x9C\x2E\xD1"
-			  "\x49\x2C\xF3\xD4\x90\xCC\x93\x4C"
-			  "\x84\x52\x6D\x68\xDE\xC6\x64\xB2"
-			  "\x11\x74\x93\x57\xB4\x7E\xC6\x00",
-		.rlen	= 496,
-		.also_non_np = 1,
-		.np	= 3,
-		.tap	= { 496 - 20, 4, 16 },
 	},
 };
 
-static struct cipher_testvec cast6_dec_tv_template[] = {
-	{
-		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
-			  "\x0a\xf7\x56\x47\xf2\x9f\x61\x5d",
+static struct cipher_testvec speck128_dec_tv_template[] = {
+	{ /* Speck128/128 */
+		.key	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f",
 		.klen	= 16,
-		.input	= "\xc8\x42\xa0\x89\x72\xb4\x3d\x20"
-			  "\x83\x6c\x91\xd1\xb7\x53\x0f\x6b",
+		.input	= "\x18\x0d\x57\x5c\xdf\xfe\x60\x78"
+			  "\x65\x32\x78\x79\x51\x98\x5d\xa6",
 		.ilen	= 16,
-		.result	= zeroed_string,
+		.result	= "\x20\x6d\x61\x64\x65\x20\x69\x74"
+			  "\x20\x65\x71\x75\x69\x76\x61\x6c",
 		.rlen	= 16,
-	}, {
-		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
-			  "\xbe\xd0\xac\x83\x94\x0a\xc2\x98"
-			  "\xba\xc7\x7a\x77\x17\x94\x28\x63",
+	}, { /* Speck128/192 */
+		.key	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17",
 		.klen	= 24,
-		.input	= "\x1b\x38\x6c\x02\x10\xdc\xad\xcb"
-			  "\xdd\x0e\x41\xaa\x08\xa7\xa7\xe8",
+		.input	= "\x86\x18\x3c\xe0\x5d\x18\xbc\xf9"
+			  "\x66\x55\x13\x13\x3a\xcf\xe4\x1b",
 		.ilen	= 16,
-		.result	= zeroed_string,
+		.result	= "\x65\x6e\x74\x20\x74\x6f\x20\x43"
+			  "\x68\x69\x65\x66\x20\x48\x61\x72",
 		.rlen	= 16,
-	}, {
-		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
-			  "\xbe\xd0\xac\x83\x94\x0a\xc2\x98"
-			  "\x8d\x7c\x47\xce\x26\x49\x08\x46"
-			  "\x1c\xc1\xb5\x13\x7a\xe6\xb6\x04",
+	}, { /* Speck128/256 */
+		.key	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f",
 		.klen	= 32,
-		.input	= "\x4f\x6a\x20\x38\x28\x68\x97\xb9"
-			  "\xc9\x87\x01\x36\x55\x33\x17\xfa",
+		.input	= "\x43\x8f\x18\x9c\x8d\xb4\xee\x4e"
+			  "\x3e\xf5\xc0\x05\x04\x01\x09\x41",
 		.ilen	= 16,
-		.result	= zeroed_string,
+		.result	= "\x70\x6f\x6f\x6e\x65\x72\x2e\x20"
+			  "\x49\x6e\x20\x74\x68\x6f\x73\x65",
 		.rlen	= 16,
-	}, { /* Generated from TF test vectors */
-		.key	= "\x85\x62\x3F\x1C\xF9\xD6\x1C\xF9"
-			  "\xD6\xB3\x90\x6D\x4A\x90\x6D\x4A"
-			  "\x27\x04\xE1\x27\x04\xE1\xBE\x9B"
-			  "\x78\xBE\x9B\x78\x55\x32\x0F\x55",
+	},
+};
+
+/*
+ * Speck128-XTS test vectors, taken from the AES-XTS test vectors with the
+ * result recomputed with Speck128 as the cipher
+ */
+
+static struct cipher_testvec speck128_xts_enc_tv_template[] = {
+	{
+		.key	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
 		.klen	= 32,
-		.iv	= "\xE2\x24\x89\xEE\x53\xB8\x1D\x5F"
-			  "\xC4\x29\x8E\xF3\x35\x9A\xFF\x64",
-		.input	= "\xC3\x70\x22\x32\xF5\x80\xCB\x54"
-			  "\xFC\x30\xE0\xF6\xEB\x39\x57\xA6"
-			  "\xB6\xB9\xC5\xA4\x91\x55\x14\x97"
-			  "\xC1\x20\xFF\x6C\x5C\xF0\x67\xEA"
-			  "\x2F\xED\xD8\xC9\xFB\x38\x3F\xFE"
-			  "\x93\xBE\xDC\x00\xD3\x7F\xAD\x4C"
-			  "\x5A\x08\x92\xD1\x47\x0C\xFA\x6C"
-			  "\xD0\x6A\x99\x10\x72\xF8\x47\x62"
-			  "\x81\x42\xF8\xD8\xF5\xBB\x94\x08"
-			  "\xAA\x97\xA2\x8B\x69\xB3\xD2\x7E"
-			  "\xBC\xB5\x00\x0C\xE5\x44\x4B\x58"
-			  "\xE8\x63\xDC\xB3\xC4\xE5\x23\x12"
-			  "\x5A\x72\x85\x47\x8B\xEC\x9F\x26"
-			  "\x84\xB6\xED\x10\x33\x63\x9B\x5F"
-			  "\x4D\x53\xEE\x94\x45\x8B\x60\x58"
-			  "\x86\x20\xF9\x1E\x82\x08\x3E\x58"
-			  "\x60\x1B\x34\x19\x02\xBE\x4E\x09"
-			  "\xBB\x7C\x15\xCC\x60\x27\x55\x7A"
-			  "\x12\xB8\xD8\x08\x89\x3C\xA6\xF3"
-			  "\xF1\xDD\xA7\x07\xA3\x12\x85\x28"
+		.iv	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.ilen	= 32,
+		.result	= "\xbe\xa0\xe7\x03\xd7\xfe\xab\x62"
+			  "\x3b\x99\x4a\x64\x74\x77\xac\xed"
+			  "\xd8\xf4\xa6\xcf\xae\xb9\x07\x42"
+			  "\x51\xd9\xb6\x1d\xe0\x5e\xbc\x54",
+		.rlen	= 32,
+	}, {
+		.key	= "\x11\x11\x11\x11\x11\x11\x11\x11"
+			  "\x11\x11\x11\x11\x11\x11\x11\x11"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22",
+		.klen	= 32,
+		.iv	= "\x33\x33\x33\x33\x33\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44",
+		.ilen	= 32,
+		.result	= "\xfb\x53\x81\x75\x6f\x9f\x34\xad"
+			  "\x7e\x01\xed\x7b\xcc\xda\x4e\x4a"
+			  "\xd4\x84\xa4\x53\xd5\x88\x73\x1b"
+			  "\xfd\xcb\xae\x0d\xf3\x04\xee\xe6",
+		.rlen	= 32,
+	}, {
+		.key	= "\xff\xfe\xfd\xfc\xfb\xfa\xf9\xf8"
+			  "\xf7\xf6\xf5\xf4\xf3\xf2\xf1\xf0"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22",
+		.klen	= 32,
+		.iv	= "\x33\x33\x33\x33\x33\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44",
+		.ilen	= 32,
+		.result	= "\x21\x52\x84\x15\xd1\xf7\x21\x55"
+			  "\xd9\x75\x4a\xd3\xc5\xdb\x9f\x7d"
+			  "\xda\x63\xb2\xf1\x82\xb0\x89\x59"
+			  "\x86\xd4\xaa\xaa\xdd\xff\x4f\x92",
+		.rlen	= 32,
+	}, {
+		.key	= "\x27\x18\x28\x18\x28\x45\x90\x45"
+			  "\x23\x53\x60\x28\x74\x71\x35\x26"
+			  "\x31\x41\x59\x26\x53\x58\x97\x93"
+			  "\x23\x84\x62\x64\x33\x83\x27\x95",
+		.klen	= 32,
+		.iv	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff"
+			  "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff",
+		.ilen	= 512,
+		.result	= "\x57\xb5\xf8\x71\x6e\x6d\xdd\x82"
+			  "\x53\xd0\xed\x2d\x30\xc1\x20\xef"
+			  "\x70\x67\x5e\xff\x09\x70\xbb\xc1"
+			  "\x3a\x7b\x48\x26\xd9\x0b\xf4\x48"
+			  "\xbe\xce\xb1\xc7\xb2\x67\xc4\xa7"
+			  "\x76\xf8\x36\x30\xb7\xb4\x9a\xd9"
+			  "\xf5\x9d\xd0\x7b\xc1\x06\x96\x44"
+			  "\x19\xc5\x58\x84\x63\xb9\x12\x68"
+			  "\x68\xc7\xaa\x18\x98\xf2\x1f\x5c"
+			  "\x39\xa6\xd8\x32\x2b\xc3\x51\xfd"
+			  "\x74\x79\x2e\xb4\x44\xd7\x69\xc4"
+			  "\xfc\x29\xe6\xed\x26\x1e\xa6\x9d"
+			  "\x1c\xbe\x00\x0e\x7f\x3a\xca\xfb"
+			  "\x6d\x13\x65\xa0\xf9\x31\x12\xe2"
+			  "\x26\xd1\xec\x2b\x0a\x8b\x59\x99"
+			  "\xa7\x49\xa0\x0e\x09\x33\x85\x50"
+			  "\xc3\x23\xca\x7a\xdd\x13\x45\x5f"
+			  "\xde\x4c\xa7\xcb\x00\x8a\x66\x6f"
+			  "\xa2\xb6\xb1\x2e\xe1\xa0\x18\xf6"
+			  "\xad\xf3\xbd\xeb\xc7\xef\x55\x4f"
+			  "\x79\x91\x8d\x36\x13\x7b\xd0\x4a"
+			  "\x6c\x39\xfb\x53\xb8\x6f\x02\x51"
+			  "\xa5\x20\xac\x24\x1c\x73\x59\x73"
+			  "\x58\x61\x3a\x87\x58\xb3\x20\x56"
+			  "\x39\x06\x2b\x4d\xd3\x20\x2b\x89"
+			  "\x3f\xa2\xf0\x96\xeb\x7f\xa4\xcd"
+			  "\x11\xae\xbd\xcb\x3a\xb4\xd9\x91"
+			  "\x09\x35\x71\x50\x65\xac\x92\xe3"
+			  "\x7b\x32\xc0\x7a\xdd\xd4\xc3\x92"
+			  "\x6f\xeb\x79\xde\x6f\xd3\x25\xc9"
+			  "\xcd\x63\xf5\x1e\x7a\x3b\x26\x9d"
+			  "\x77\x04\x80\xa9\xbf\x38\xb5\xbd"
+			  "\xb8\x05\x07\xbd\xfd\xab\x7b\xf8"
+			  "\x2a\x26\xcc\x49\x14\x6d\x55\x01"
+			  "\x06\x94\xd8\xb2\x2d\x53\x83\x1b"
+			  "\x8f\xd4\xdd\x57\x12\x7e\x18\xba"
+			  "\x8e\xe2\x4d\x80\xef\x7e\x6b\x9d"
+			  "\x24\xa9\x60\xa4\x97\x85\x86\x2a"
+			  "\x01\x00\x09\xf1\xcb\x4a\x24\x1c"
+			  "\xd8\xf6\xe6\x5b\xe7\x5d\xf2\xc4"
+			  "\x97\x1c\x10\xc6\x4d\x66\x4f\x98"
+			  "\x87\x30\xac\xd5\xea\x73\x49\x10"
+			  "\x80\xea\xe5\x5f\x4d\x5f\x03\x33"
+			  "\x66\x02\x35\x3d\x60\x06\x36\x4f"
+			  "\x14\x1c\xd8\x07\x1f\x78\xd0\xf8"
+			  "\x4f\x6c\x62\x7c\x15\xa5\x7c\x28"
+			  "\x7c\xcc\xeb\x1f\xd1\x07\x90\x93"
+			  "\x7e\xc2\xa8\x3a\x80\xc0\xf5\x30"
+			  "\xcc\x75\xcf\x16\x26\xa9\x26\x3b"
+			  "\xe7\x68\x2f\x15\x21\x5b\xe4\x00"
+			  "\xbd\x48\x50\xcd\x75\x70\xc4\x62"
+			  "\xbb\x41\xfb\x89\x4a\x88\x3b\x3b"
+			  "\x51\x66\x02\x69\x04\x97\x36\xd4"
+			  "\x75\xae\x0b\xa3\x42\xf8\xca\x79"
+			  "\x8f\x93\xe9\xcc\x38\xbd\xd6\xd2"
+			  "\xf9\x70\x4e\xc3\x6a\x8e\x25\xbd"
+			  "\xea\x15\x5a\xa0\x85\x7e\x81\x0d"
+			  "\x03\xe7\x05\x39\xf5\x05\x26\xee"
+			  "\xec\xaa\x1f\x3d\xc9\x98\x76\x01"
+			  "\x2c\xf4\xfc\xa3\x88\x77\x38\xc4"
+			  "\x50\x65\x50\x6d\x04\x1f\xdf\x5a"
+			  "\xaa\xf2\x01\xa9\xc1\x8d\xee\xca"
+			  "\x47\x26\xef\x39\xb8\xb4\xf2\xd1"
+			  "\xd6\xbb\x1b\x2a\xc1\x34\x14\xcf",
+		.rlen	= 512,
+	}, {
+		.key	= "\x27\x18\x28\x18\x28\x45\x90\x45"
+			  "\x23\x53\x60\x28\x74\x71\x35\x26"
+			  "\x62\x49\x77\x57\x24\x70\x93\x69"
+			  "\x99\x59\x57\x49\x66\x96\x76\x27"
+			  "\x31\x41\x59\x26\x53\x58\x97\x93"
+			  "\x23\x84\x62\x64\x33\x83\x27\x95"
+			  "\x02\x88\x41\x97\x16\x93\x99\x37"
+			  "\x51\x05\x82\x09\x74\x94\x45\x92",
+		.klen	= 64,
+		.iv	= "\xff\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff"
+			  "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff",
+		.ilen	= 512,
+		.result	= "\xc5\x85\x2a\x4b\x73\xe4\xf6\xf1"
+			  "\x7e\xf9\xf6\xe9\xa3\x73\x36\xcb"
+			  "\xaa\xb6\x22\xb0\x24\x6e\x3d\x73"
+			  "\x92\x99\xde\xd3\x76\xed\xcd\x63"
+			  "\x64\x3a\x22\x57\xc1\x43\x49\xd4"
+			  "\x79\x36\x31\x19\x62\xae\x10\x7e"
+			  "\x7d\xcf\x7a\xe2\x6b\xce\x27\xfa"
+			  "\xdc\x3d\xd9\x83\xd3\x42\x4c\xe0"
+			  "\x1b\xd6\x1d\x1a\x6f\xd2\x03\x00"
+			  "\xfc\x81\x99\x8a\x14\x62\xf5\x7e"
+			  "\x0d\xe7\x12\xe8\x17\x9d\x0b\xec"
+			  "\xe2\xf7\xc9\xa7\x63\xd1\x79\xb6"
+			  "\x62\x62\x37\xfe\x0a\x4c\x4a\x37"
+			  "\x70\xc7\x5e\x96\x5f\xbc\x8e\x9e"
+			  "\x85\x3c\x4f\x26\x64\x85\xbc\x68"
+			  "\xb0\xe0\x86\x5e\x26\x41\xce\x11"
+			  "\x50\xda\x97\x14\xe9\x9e\xc7\x6d"
+			  "\x3b\xdc\x43\xde\x2b\x27\x69\x7d"
+			  "\xfc\xb0\x28\xbd\x8f\xb1\xc6\x31"
+			  "\x14\x4d\xf0\x74\x37\xfd\x07\x25"
+			  "\x96\x55\xe5\xfc\x9e\x27\x2a\x74"
+			  "\x1b\x83\x4d\x15\x83\xac\x57\xa0"
+			  "\xac\xa5\xd0\x38\xef\x19\x56\x53"
+			  "\x25\x4b\xfc\xce\x04\x23\xe5\x6b"
+			  "\xf6\xc6\x6c\x32\x0b\xb3\x12\xc5"
+			  "\xed\x22\x34\x1c\x5d\xed\x17\x06"
+			  "\x36\xa3\xe6\x77\xb9\x97\x46\xb8"
+			  "\xe9\x3f\x7e\xc7\xbc\x13\x5c\xdc"
+			  "\x6e\x3f\x04\x5e\xd1\x59\xa5\x82"
+			  "\x35\x91\x3d\x1b\xe4\x97\x9f\x92"
+			  "\x1c\x5e\x5f\x6f\x41\xd4\x62\xa1"
+			  "\x8d\x39\xfc\x42\xfb\x38\x80\xb9"
+			  "\x0a\xe3\xcc\x6a\x93\xd9\x7a\xb1"
+			  "\xe9\x69\xaf\x0a\x6b\x75\x38\xa7"
+			  "\xa1\xbf\xf7\xda\x95\x93\x4b\x78"
+			  "\x19\xf5\x94\xf9\xd2\x00\x33\x37"
+			  "\xcf\xf5\x9e\x9c\xf3\xcc\xa6\xee"
+			  "\x42\xb2\x9e\x2c\x5f\x48\x23\x26"
+			  "\x15\x25\x17\x03\x3d\xfe\x2c\xfc"
+			  "\xeb\xba\xda\xe0\x00\x05\xb6\xa6"
+			  "\x07\xb3\xe8\x36\x5b\xec\x5b\xbf"
+			  "\xd6\x5b\x00\x74\xc6\x97\xf1\x6a"
+			  "\x49\xa1\xc3\xfa\x10\x52\xb9\x14"
+			  "\xad\xb7\x73\xf8\x78\x12\xc8\x59"
+			  "\x17\x80\x4c\x57\x39\xf1\x6d\x80"
+			  "\x25\x77\x0f\x5e\x7d\xf0\xaf\x21"
+			  "\xec\xce\xb7\xc8\x02\x8a\xed\x53"
+			  "\x2c\x25\x68\x2e\x1f\x85\x5e\x67"
+			  "\xd1\x07\x7a\x3a\x89\x08\xe0\x34"
+			  "\xdc\xdb\x26\xb4\x6b\x77\xfc\x40"
+			  "\x31\x15\x72\xa0\xf0\x73\xd9\x3b"
+			  "\xd5\xdb\xfe\xfc\x8f\xa9\x44\xa2"
+			  "\x09\x9f\xc6\x33\xe5\xe2\x88\xe8"
+			  "\xf3\xf0\x1a\xf4\xce\x12\x0f\xd6"
+			  "\xf7\x36\xe6\xa4\xf4\x7a\x10\x58"
+			  "\xcc\x1f\x48\x49\x65\x47\x75\xe9"
+			  "\x28\xe1\x65\x7b\xf2\xc4\xb5\x07"
+			  "\xf2\xec\x76\xd8\x8f\x09\xf3\x16"
+			  "\xa1\x51\x89\x3b\xeb\x96\x42\xac"
+			  "\x65\xe0\x67\x63\x29\xdc\xb4\x7d"
+			  "\xf2\x41\x51\x6a\xcb\xde\x3c\xfb"
+			  "\x66\x8d\x13\xca\xe0\x59\x2a\x00"
+			  "\xc9\x53\x4c\xe6\x9e\xe2\x73\xd5"
+			  "\x67\x19\xb2\xbd\x9a\x63\xd7\x5c",
+		.rlen	= 512,
+		.also_non_np = 1,
+		.np	= 3,
+		.tap	= { 512 - 20, 4, 16 },
+	}
+};
+
+static struct cipher_testvec speck128_xts_dec_tv_template[] = {
+	{
+		.key	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.klen	= 32,
+		.iv	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\xbe\xa0\xe7\x03\xd7\xfe\xab\x62"
+			  "\x3b\x99\x4a\x64\x74\x77\xac\xed"
+			  "\xd8\xf4\xa6\xcf\xae\xb9\x07\x42"
+			  "\x51\xd9\xb6\x1d\xe0\x5e\xbc\x54",
+		.ilen	= 32,
+		.result	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.rlen	= 32,
+	}, {
+		.key	= "\x11\x11\x11\x11\x11\x11\x11\x11"
+			  "\x11\x11\x11\x11\x11\x11\x11\x11"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22",
+		.klen	= 32,
+		.iv	= "\x33\x33\x33\x33\x33\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\xfb\x53\x81\x75\x6f\x9f\x34\xad"
+			  "\x7e\x01\xed\x7b\xcc\xda\x4e\x4a"
+			  "\xd4\x84\xa4\x53\xd5\x88\x73\x1b"
+			  "\xfd\xcb\xae\x0d\xf3\x04\xee\xe6",
+		.ilen	= 32,
+		.result	= "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44",
+		.rlen	= 32,
+	}, {
+		.key	= "\xff\xfe\xfd\xfc\xfb\xfa\xf9\xf8"
+			  "\xf7\xf6\xf5\xf4\xf3\xf2\xf1\xf0"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22",
+		.klen	= 32,
+		.iv	= "\x33\x33\x33\x33\x33\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x21\x52\x84\x15\xd1\xf7\x21\x55"
+			  "\xd9\x75\x4a\xd3\xc5\xdb\x9f\x7d"
+			  "\xda\x63\xb2\xf1\x82\xb0\x89\x59"
+			  "\x86\xd4\xaa\xaa\xdd\xff\x4f\x92",
+		.ilen	= 32,
+		.result	= "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44",
+		.rlen	= 32,
+	}, {
+		.key	= "\x27\x18\x28\x18\x28\x45\x90\x45"
+			  "\x23\x53\x60\x28\x74\x71\x35\x26"
+			  "\x31\x41\x59\x26\x53\x58\x97\x93"
+			  "\x23\x84\x62\x64\x33\x83\x27\x95",
+		.klen	= 32,
+		.iv	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x57\xb5\xf8\x71\x6e\x6d\xdd\x82"
+			  "\x53\xd0\xed\x2d\x30\xc1\x20\xef"
+			  "\x70\x67\x5e\xff\x09\x70\xbb\xc1"
+			  "\x3a\x7b\x48\x26\xd9\x0b\xf4\x48"
+			  "\xbe\xce\xb1\xc7\xb2\x67\xc4\xa7"
+			  "\x76\xf8\x36\x30\xb7\xb4\x9a\xd9"
+			  "\xf5\x9d\xd0\x7b\xc1\x06\x96\x44"
+			  "\x19\xc5\x58\x84\x63\xb9\x12\x68"
+			  "\x68\xc7\xaa\x18\x98\xf2\x1f\x5c"
+			  "\x39\xa6\xd8\x32\x2b\xc3\x51\xfd"
+			  "\x74\x79\x2e\xb4\x44\xd7\x69\xc4"
+			  "\xfc\x29\xe6\xed\x26\x1e\xa6\x9d"
+			  "\x1c\xbe\x00\x0e\x7f\x3a\xca\xfb"
+			  "\x6d\x13\x65\xa0\xf9\x31\x12\xe2"
+			  "\x26\xd1\xec\x2b\x0a\x8b\x59\x99"
+			  "\xa7\x49\xa0\x0e\x09\x33\x85\x50"
+			  "\xc3\x23\xca\x7a\xdd\x13\x45\x5f"
+			  "\xde\x4c\xa7\xcb\x00\x8a\x66\x6f"
+			  "\xa2\xb6\xb1\x2e\xe1\xa0\x18\xf6"
+			  "\xad\xf3\xbd\xeb\xc7\xef\x55\x4f"
+			  "\x79\x91\x8d\x36\x13\x7b\xd0\x4a"
+			  "\x6c\x39\xfb\x53\xb8\x6f\x02\x51"
+			  "\xa5\x20\xac\x24\x1c\x73\x59\x73"
+			  "\x58\x61\x3a\x87\x58\xb3\x20\x56"
+			  "\x39\x06\x2b\x4d\xd3\x20\x2b\x89"
+			  "\x3f\xa2\xf0\x96\xeb\x7f\xa4\xcd"
+			  "\x11\xae\xbd\xcb\x3a\xb4\xd9\x91"
+			  "\x09\x35\x71\x50\x65\xac\x92\xe3"
+			  "\x7b\x32\xc0\x7a\xdd\xd4\xc3\x92"
+			  "\x6f\xeb\x79\xde\x6f\xd3\x25\xc9"
+			  "\xcd\x63\xf5\x1e\x7a\x3b\x26\x9d"
+			  "\x77\x04\x80\xa9\xbf\x38\xb5\xbd"
+			  "\xb8\x05\x07\xbd\xfd\xab\x7b\xf8"
+			  "\x2a\x26\xcc\x49\x14\x6d\x55\x01"
+			  "\x06\x94\xd8\xb2\x2d\x53\x83\x1b"
+			  "\x8f\xd4\xdd\x57\x12\x7e\x18\xba"
+			  "\x8e\xe2\x4d\x80\xef\x7e\x6b\x9d"
+			  "\x24\xa9\x60\xa4\x97\x85\x86\x2a"
+			  "\x01\x00\x09\xf1\xcb\x4a\x24\x1c"
+			  "\xd8\xf6\xe6\x5b\xe7\x5d\xf2\xc4"
+			  "\x97\x1c\x10\xc6\x4d\x66\x4f\x98"
+			  "\x87\x30\xac\xd5\xea\x73\x49\x10"
+			  "\x80\xea\xe5\x5f\x4d\x5f\x03\x33"
+			  "\x66\x02\x35\x3d\x60\x06\x36\x4f"
+			  "\x14\x1c\xd8\x07\x1f\x78\xd0\xf8"
+			  "\x4f\x6c\x62\x7c\x15\xa5\x7c\x28"
+			  "\x7c\xcc\xeb\x1f\xd1\x07\x90\x93"
+			  "\x7e\xc2\xa8\x3a\x80\xc0\xf5\x30"
+			  "\xcc\x75\xcf\x16\x26\xa9\x26\x3b"
+			  "\xe7\x68\x2f\x15\x21\x5b\xe4\x00"
+			  "\xbd\x48\x50\xcd\x75\x70\xc4\x62"
+			  "\xbb\x41\xfb\x89\x4a\x88\x3b\x3b"
+			  "\x51\x66\x02\x69\x04\x97\x36\xd4"
+			  "\x75\xae\x0b\xa3\x42\xf8\xca\x79"
+			  "\x8f\x93\xe9\xcc\x38\xbd\xd6\xd2"
+			  "\xf9\x70\x4e\xc3\x6a\x8e\x25\xbd"
+			  "\xea\x15\x5a\xa0\x85\x7e\x81\x0d"
+			  "\x03\xe7\x05\x39\xf5\x05\x26\xee"
+			  "\xec\xaa\x1f\x3d\xc9\x98\x76\x01"
+			  "\x2c\xf4\xfc\xa3\x88\x77\x38\xc4"
+			  "\x50\x65\x50\x6d\x04\x1f\xdf\x5a"
+			  "\xaa\xf2\x01\xa9\xc1\x8d\xee\xca"
+			  "\x47\x26\xef\x39\xb8\xb4\xf2\xd1"
+			  "\xd6\xbb\x1b\x2a\xc1\x34\x14\xcf",
+		.ilen	= 512,
+		.result	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff"
+			  "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff",
+		.rlen	= 512,
+	}, {
+		.key	= "\x27\x18\x28\x18\x28\x45\x90\x45"
+			  "\x23\x53\x60\x28\x74\x71\x35\x26"
+			  "\x62\x49\x77\x57\x24\x70\x93\x69"
+			  "\x99\x59\x57\x49\x66\x96\x76\x27"
+			  "\x31\x41\x59\x26\x53\x58\x97\x93"
+			  "\x23\x84\x62\x64\x33\x83\x27\x95"
+			  "\x02\x88\x41\x97\x16\x93\x99\x37"
+			  "\x51\x05\x82\x09\x74\x94\x45\x92",
+		.klen	= 64,
+		.iv	= "\xff\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\xc5\x85\x2a\x4b\x73\xe4\xf6\xf1"
+			  "\x7e\xf9\xf6\xe9\xa3\x73\x36\xcb"
+			  "\xaa\xb6\x22\xb0\x24\x6e\x3d\x73"
+			  "\x92\x99\xde\xd3\x76\xed\xcd\x63"
+			  "\x64\x3a\x22\x57\xc1\x43\x49\xd4"
+			  "\x79\x36\x31\x19\x62\xae\x10\x7e"
+			  "\x7d\xcf\x7a\xe2\x6b\xce\x27\xfa"
+			  "\xdc\x3d\xd9\x83\xd3\x42\x4c\xe0"
+			  "\x1b\xd6\x1d\x1a\x6f\xd2\x03\x00"
+			  "\xfc\x81\x99\x8a\x14\x62\xf5\x7e"
+			  "\x0d\xe7\x12\xe8\x17\x9d\x0b\xec"
+			  "\xe2\xf7\xc9\xa7\x63\xd1\x79\xb6"
+			  "\x62\x62\x37\xfe\x0a\x4c\x4a\x37"
+			  "\x70\xc7\x5e\x96\x5f\xbc\x8e\x9e"
+			  "\x85\x3c\x4f\x26\x64\x85\xbc\x68"
+			  "\xb0\xe0\x86\x5e\x26\x41\xce\x11"
+			  "\x50\xda\x97\x14\xe9\x9e\xc7\x6d"
+			  "\x3b\xdc\x43\xde\x2b\x27\x69\x7d"
+			  "\xfc\xb0\x28\xbd\x8f\xb1\xc6\x31"
+			  "\x14\x4d\xf0\x74\x37\xfd\x07\x25"
+			  "\x96\x55\xe5\xfc\x9e\x27\x2a\x74"
+			  "\x1b\x83\x4d\x15\x83\xac\x57\xa0"
+			  "\xac\xa5\xd0\x38\xef\x19\x56\x53"
+			  "\x25\x4b\xfc\xce\x04\x23\xe5\x6b"
+			  "\xf6\xc6\x6c\x32\x0b\xb3\x12\xc5"
+			  "\xed\x22\x34\x1c\x5d\xed\x17\x06"
+			  "\x36\xa3\xe6\x77\xb9\x97\x46\xb8"
+			  "\xe9\x3f\x7e\xc7\xbc\x13\x5c\xdc"
+			  "\x6e\x3f\x04\x5e\xd1\x59\xa5\x82"
+			  "\x35\x91\x3d\x1b\xe4\x97\x9f\x92"
+			  "\x1c\x5e\x5f\x6f\x41\xd4\x62\xa1"
+			  "\x8d\x39\xfc\x42\xfb\x38\x80\xb9"
+			  "\x0a\xe3\xcc\x6a\x93\xd9\x7a\xb1"
+			  "\xe9\x69\xaf\x0a\x6b\x75\x38\xa7"
+			  "\xa1\xbf\xf7\xda\x95\x93\x4b\x78"
+			  "\x19\xf5\x94\xf9\xd2\x00\x33\x37"
+			  "\xcf\xf5\x9e\x9c\xf3\xcc\xa6\xee"
+			  "\x42\xb2\x9e\x2c\x5f\x48\x23\x26"
+			  "\x15\x25\x17\x03\x3d\xfe\x2c\xfc"
+			  "\xeb\xba\xda\xe0\x00\x05\xb6\xa6"
+			  "\x07\xb3\xe8\x36\x5b\xec\x5b\xbf"
+			  "\xd6\x5b\x00\x74\xc6\x97\xf1\x6a"
+			  "\x49\xa1\xc3\xfa\x10\x52\xb9\x14"
+			  "\xad\xb7\x73\xf8\x78\x12\xc8\x59"
+			  "\x17\x80\x4c\x57\x39\xf1\x6d\x80"
+			  "\x25\x77\x0f\x5e\x7d\xf0\xaf\x21"
+			  "\xec\xce\xb7\xc8\x02\x8a\xed\x53"
+			  "\x2c\x25\x68\x2e\x1f\x85\x5e\x67"
+			  "\xd1\x07\x7a\x3a\x89\x08\xe0\x34"
+			  "\xdc\xdb\x26\xb4\x6b\x77\xfc\x40"
+			  "\x31\x15\x72\xa0\xf0\x73\xd9\x3b"
+			  "\xd5\xdb\xfe\xfc\x8f\xa9\x44\xa2"
+			  "\x09\x9f\xc6\x33\xe5\xe2\x88\xe8"
+			  "\xf3\xf0\x1a\xf4\xce\x12\x0f\xd6"
+			  "\xf7\x36\xe6\xa4\xf4\x7a\x10\x58"
+			  "\xcc\x1f\x48\x49\x65\x47\x75\xe9"
+			  "\x28\xe1\x65\x7b\xf2\xc4\xb5\x07"
+			  "\xf2\xec\x76\xd8\x8f\x09\xf3\x16"
+			  "\xa1\x51\x89\x3b\xeb\x96\x42\xac"
+			  "\x65\xe0\x67\x63\x29\xdc\xb4\x7d"
+			  "\xf2\x41\x51\x6a\xcb\xde\x3c\xfb"
+			  "\x66\x8d\x13\xca\xe0\x59\x2a\x00"
+			  "\xc9\x53\x4c\xe6\x9e\xe2\x73\xd5"
+			  "\x67\x19\xb2\xbd\x9a\x63\xd7\x5c",
+		.ilen	= 512,
+		.result	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff"
+			  "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff",
+		.rlen	= 512,
+		.also_non_np = 1,
+		.np	= 3,
+		.tap	= { 512 - 20, 4, 16 },
+	}
+};
+
+static struct cipher_testvec speck64_enc_tv_template[] = {
+	{ /* Speck64/96 */
+		.key	= "\x00\x01\x02\x03\x08\x09\x0a\x0b"
+			  "\x10\x11\x12\x13",
+		.klen	= 12,
+		.input	= "\x65\x61\x6e\x73\x20\x46\x61\x74",
+		.ilen	= 8,
+		.result	= "\x6c\x94\x75\x41\xec\x52\x79\x9f",
+		.rlen	= 8,
+	}, { /* Speck64/128 */
+		.key	= "\x00\x01\x02\x03\x08\x09\x0a\x0b"
+			  "\x10\x11\x12\x13\x18\x19\x1a\x1b",
+		.klen	= 16,
+		.input	= "\x2d\x43\x75\x74\x74\x65\x72\x3b",
+		.ilen	= 8,
+		.result	= "\x8b\x02\x4e\x45\x48\xa5\x6f\x8c",
+		.rlen	= 8,
+	},
+};
+
+static struct cipher_testvec speck64_dec_tv_template[] = {
+	{ /* Speck64/96 */
+		.key	= "\x00\x01\x02\x03\x08\x09\x0a\x0b"
+			  "\x10\x11\x12\x13",
+		.klen	= 12,
+		.input	= "\x6c\x94\x75\x41\xec\x52\x79\x9f",
+		.ilen	= 8,
+		.result	= "\x65\x61\x6e\x73\x20\x46\x61\x74",
+		.rlen	= 8,
+	}, { /* Speck64/128 */
+		.key	= "\x00\x01\x02\x03\x08\x09\x0a\x0b"
+			  "\x10\x11\x12\x13\x18\x19\x1a\x1b",
+		.klen	= 16,
+		.input	= "\x8b\x02\x4e\x45\x48\xa5\x6f\x8c",
+		.ilen	= 8,
+		.result	= "\x2d\x43\x75\x74\x74\x65\x72\x3b",
+		.rlen	= 8,
+	},
+};
+
+/*
+ * Speck64-XTS test vectors, taken from the AES-XTS test vectors with the result
+ * recomputed with Speck64 as the cipher, and key lengths adjusted
+ */
+
+static struct cipher_testvec speck64_xts_enc_tv_template[] = {
+	{
+		.key	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.klen	= 24,
+		.iv	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.ilen	= 32,
+		.result	= "\x84\xaf\x54\x07\x19\xd4\x7c\xa6"
+			  "\xe4\xfe\xdf\xc4\x1f\x34\xc3\xc2"
+			  "\x80\xf5\x72\xe7\xcd\xf0\x99\x22"
+			  "\x35\xa7\x2f\x06\xef\xdc\x51\xaa",
+		.rlen	= 32,
+	}, {
+		.key	= "\x11\x11\x11\x11\x11\x11\x11\x11"
+			  "\x11\x11\x11\x11\x11\x11\x11\x11"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22",
+		.klen	= 24,
+		.iv	= "\x33\x33\x33\x33\x33\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44",
+		.ilen	= 32,
+		.result	= "\x12\x56\x73\xcd\x15\x87\xa8\x59"
+			  "\xcf\x84\xae\xd9\x1c\x66\xd6\x9f"
+			  "\xb3\x12\x69\x7e\x36\xeb\x52\xff"
+			  "\x62\xdd\xba\x90\xb3\xe1\xee\x99",
+		.rlen	= 32,
+	}, {
+		.key	= "\xff\xfe\xfd\xfc\xfb\xfa\xf9\xf8"
+			  "\xf7\xf6\xf5\xf4\xf3\xf2\xf1\xf0"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22",
+		.klen	= 24,
+		.iv	= "\x33\x33\x33\x33\x33\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44",
+		.ilen	= 32,
+		.result	= "\x15\x1b\xe4\x2c\xa2\x5a\x2d\x2c"
+			  "\x27\x36\xc0\xbf\x5d\xea\x36\x37"
+			  "\x2d\x1a\x88\xbc\x66\xb5\xd0\x0b"
+			  "\xa1\xbc\x19\xb2\x0f\x3b\x75\x34",
+		.rlen	= 32,
+	}, {
+		.key	= "\x27\x18\x28\x18\x28\x45\x90\x45"
+			  "\x23\x53\x60\x28\x74\x71\x35\x26"
+			  "\x31\x41\x59\x26\x53\x58\x97\x93",
+		.klen	= 24,
+		.iv	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff"
+			  "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff",
+		.ilen	= 512,
+		.result	= "\xaf\xa1\x81\xa6\x32\xbb\x15\x8e"
+			  "\xf8\x95\x2e\xd3\xe6\xee\x7e\x09"
+			  "\x0c\x1a\xf5\x02\x97\x8b\xe3\xb3"
+			  "\x11\xc7\x39\x96\xd0\x95\xf4\x56"
+			  "\xf4\xdd\x03\x38\x01\x44\x2c\xcf"
+			  "\x88\xae\x8e\x3c\xcd\xe7\xaa\x66"
+			  "\xfe\x3d\xc6\xfb\x01\x23\x51\x43"
+			  "\xd5\xd2\x13\x86\x94\x34\xe9\x62"
+			  "\xf9\x89\xe3\xd1\x7b\xbe\xf8\xef"
+			  "\x76\x35\x04\x3f\xdb\x23\x9d\x0b"
+			  "\x85\x42\xb9\x02\xd6\xcc\xdb\x96"
+			  "\xa7\x6b\x27\xb6\xd4\x45\x8f\x7d"
+			  "\xae\xd2\x04\xd5\xda\xc1\x7e\x24"
+			  "\x8c\x73\xbe\x48\x7e\xcf\x65\x28"
+			  "\x29\xe5\xbe\x54\x30\xcb\x46\x95"
+			  "\x4f\x2e\x8a\x36\xc8\x27\xc5\xbe"
+			  "\xd0\x1a\xaf\xab\x26\xcd\x9e\x69"
+			  "\xa1\x09\x95\x71\x26\xe9\xc4\xdf"
+			  "\xe6\x31\xc3\x46\xda\xaf\x0b\x41"
+			  "\x1f\xab\xb1\x8e\xd6\xfc\x0b\xb3"
+			  "\x82\xc0\x37\x27\xfc\x91\xa7\x05"
+			  "\xfb\xc5\xdc\x2b\x74\x96\x48\x43"
+			  "\x5d\x9c\x19\x0f\x60\x63\x3a\x1f"
+			  "\x6f\xf0\x03\xbe\x4d\xfd\xc8\x4a"
+			  "\xc6\xa4\x81\x6d\xc3\x12\x2a\x5c"
+			  "\x07\xff\xf3\x72\x74\x48\xb5\x40"
+			  "\x50\xb5\xdd\x90\x43\x31\x18\x15"
+			  "\x7b\xf2\xa6\xdb\x83\xc8\x4b\x4a"
+			  "\x29\x93\x90\x8b\xda\x07\xf0\x35"
+			  "\x6d\x90\x88\x09\x4e\x83\xf5\x5b"
+			  "\x94\x12\xbb\x33\x27\x1d\x3f\x23"
+			  "\x51\xa8\x7c\x07\xa2\xae\x77\xa6"
+			  "\x50\xfd\xcc\xc0\x4f\x80\x7a\x9f"
+			  "\x66\xdd\xcd\x75\x24\x8b\x33\xf7"
+			  "\x20\xdb\x83\x9b\x4f\x11\x63\x6e"
+			  "\xcf\x37\xef\xc9\x11\x01\x5c\x45"
+			  "\x32\x99\x7c\x3c\x9e\x42\x89\xe3"
+			  "\x70\x6d\x15\x9f\xb1\xe6\xb6\x05"
+			  "\xfe\x0c\xb9\x49\x2d\x90\x6d\xcc"
+			  "\x5d\x3f\xc1\xfe\x89\x0a\x2e\x2d"
+			  "\xa0\xa8\x89\x3b\x73\x39\xa5\x94"
+			  "\x4c\xa4\xa6\xbb\xa7\x14\x46\x89"
+			  "\x10\xff\xaf\xef\xca\xdd\x4f\x80"
+			  "\xb3\xdf\x3b\xab\xd4\xe5\x5a\xc7"
+			  "\x33\xca\x00\x8b\x8b\x3f\xea\xec"
+			  "\x68\x8a\xc2\x6d\xfd\xd4\x67\x0f"
+			  "\x22\x31\xe1\x0e\xfe\x5a\x04\xd5"
+			  "\x64\xa3\xf1\x1a\x76\x28\xcc\x35"
+			  "\x36\xa7\x0a\x74\xf7\x1c\x44\x9b"
+			  "\xc7\x1b\x53\x17\x02\xea\xd1\xad"
+			  "\x13\x51\x73\xc0\xa0\xb2\x05\x32"
+			  "\xa8\xa2\x37\x2e\xe1\x7a\x3a\x19"
+			  "\x26\xb4\x6c\x62\x5d\xb3\x1a\x1d"
+			  "\x59\xda\xee\x1a\x22\x18\xda\x0d"
+			  "\x88\x0f\x55\x8b\x72\x62\xfd\xc1"
+			  "\x69\x13\xcd\x0d\x5f\xc1\x09\x52"
+			  "\xee\xd6\xe3\x84\x4d\xee\xf6\x88"
+			  "\xaf\x83\xdc\x76\xf4\xc0\x93\x3f"
+			  "\x4a\x75\x2f\xb0\x0b\x3e\xc4\x54"
+			  "\x7d\x69\x8d\x00\x62\x77\x0d\x14"
+			  "\xbe\x7c\xa6\x7d\xc5\x24\x4f\xf3"
+			  "\x50\xf7\x5f\xf4\xc2\xca\x41\x97"
+			  "\x37\xbe\x75\x74\xcd\xf0\x75\x6e"
+			  "\x25\x23\x94\xbd\xda\x8d\xb0\xd4",
+		.rlen	= 512,
+	}, {
+		.key	= "\x27\x18\x28\x18\x28\x45\x90\x45"
+			  "\x23\x53\x60\x28\x74\x71\x35\x26"
+			  "\x62\x49\x77\x57\x24\x70\x93\x69"
+			  "\x99\x59\x57\x49\x66\x96\x76\x27",
+		.klen	= 32,
+		.iv	= "\xff\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff"
+			  "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff",
+		.ilen	= 512,
+		.result	= "\x55\xed\x71\xd3\x02\x8e\x15\x3b"
+			  "\xc6\x71\x29\x2d\x3e\x89\x9f\x59"
+			  "\x68\x6a\xcc\x8a\x56\x97\xf3\x95"
+			  "\x4e\x51\x08\xda\x2a\xf8\x6f\x3c"
+			  "\x78\x16\xea\x80\xdb\x33\x75\x94"
+			  "\xf9\x29\xc4\x2b\x76\x75\x97\xc7"
+			  "\xf2\x98\x2c\xf9\xff\xc8\xd5\x2b"
+			  "\x18\xf1\xaf\xcf\x7c\xc5\x0b\xee"
+			  "\xad\x3c\x76\x7c\xe6\x27\xa2\x2a"
+			  "\xe4\x66\xe1\xab\xa2\x39\xfc\x7c"
+			  "\xf5\xec\x32\x74\xa3\xb8\x03\x88"
+			  "\x52\xfc\x2e\x56\x3f\xa1\xf0\x9f"
+			  "\x84\x5e\x46\xed\x20\x89\xb6\x44"
+			  "\x8d\xd0\xed\x54\x47\x16\xbe\x95"
+			  "\x8a\xb3\x6b\x72\xc4\x32\x52\x13"
+			  "\x1b\xb0\x82\xbe\xac\xf9\x70\xa6"
+			  "\x44\x18\xdd\x8c\x6e\xca\x6e\x45"
+			  "\x8f\x1e\x10\x07\x57\x25\x98\x7b"
+			  "\x17\x8c\x78\xdd\x80\xa7\xd9\xd8"
+			  "\x63\xaf\xb9\x67\x57\xfd\xbc\xdb"
+			  "\x44\xe9\xc5\x65\xd1\xc7\x3b\xff"
+			  "\x20\xa0\x80\x1a\xc3\x9a\xad\x5e"
+			  "\x5d\x3b\xd3\x07\xd9\xf5\xfd\x3d"
+			  "\x4a\x8b\xa8\xd2\x6e\x7a\x51\x65"
+			  "\x6c\x8e\x95\xe0\x45\xc9\x5f\x4a"
+			  "\x09\x3c\x3d\x71\x7f\x0c\x84\x2a"
+			  "\xc8\x48\x52\x1a\xc2\xd5\xd6\x78"
+			  "\x92\x1e\xa0\x90\x2e\xea\xf0\xf3"
+			  "\xdc\x0f\xb1\xaf\x0d\x9b\x06\x2e"
+			  "\x35\x10\x30\x82\x0d\xe7\xc5\x9b"
+			  "\xde\x44\x18\xbd\x9f\xd1\x45\xa9"
+			  "\x7b\x7a\x4a\xad\x35\x65\x27\xca"
+			  "\xb2\xc3\xd4\x9b\x71\x86\x70\xee"
+			  "\xf1\x89\x3b\x85\x4b\x5b\xaa\xaf"
+			  "\xfc\x42\xc8\x31\x59\xbe\x16\x60"
+			  "\x4f\xf9\xfa\x12\xea\xd0\xa7\x14"
+			  "\xf0\x7a\xf3\xd5\x8d\xbd\x81\xef"
+			  "\x52\x7f\x29\x51\x94\x20\x67\x3c"
+			  "\xd1\xaf\x77\x9f\x22\x5a\x4e\x63"
+			  "\xe7\xff\x73\x25\xd1\xdd\x96\x8a"
+			  "\x98\x52\x6d\xf3\xac\x3e\xf2\x18"
+			  "\x6d\xf6\x0a\x29\xa6\x34\x3d\xed"
+			  "\xe3\x27\x0d\x9d\x0a\x02\x44\x7e"
+			  "\x5a\x7e\x67\x0f\x0a\x9e\xd6\xad"
+			  "\x91\xe6\x4d\x81\x8c\x5c\x59\xaa"
+			  "\xfb\xeb\x56\x53\xd2\x7d\x4c\x81"
+			  "\x65\x53\x0f\x41\x11\xbd\x98\x99"
+			  "\xf9\xc6\xfa\x51\x2e\xa3\xdd\x8d"
+			  "\x84\x98\xf9\x34\xed\x33\x2a\x1f"
+			  "\x82\xed\xc1\x73\x98\xd3\x02\xdc"
+			  "\xe6\xc2\x33\x1d\xa2\xb4\xca\x76"
+			  "\x63\x51\x34\x9d\x96\x12\xae\xce"
+			  "\x83\xc9\x76\x5e\xa4\x1b\x53\x37"
+			  "\x17\xd5\xc0\x80\x1d\x62\xf8\x3d"
+			  "\x54\x27\x74\xbb\x10\x86\x57\x46"
+			  "\x68\xe1\xed\x14\xe7\x9d\xfc\x84"
+			  "\x47\xbc\xc2\xf8\x19\x4b\x99\xcf"
+			  "\x7a\xe9\xc4\xb8\x8c\x82\x72\x4d"
+			  "\x7b\x4f\x38\x55\x36\x71\x64\xc1"
+			  "\xfc\x5c\x75\x52\x33\x02\x18\xf8"
+			  "\x17\xe1\x2b\xc2\x43\x39\xbd\x76"
+			  "\x9b\x63\x76\x32\x2f\x19\x72\x10"
+			  "\x9f\x21\x0c\xf1\x66\x50\x7f\xa5"
+			  "\x0d\x1f\x46\xe0\xba\xd3\x2f\x3c",
+		.rlen	= 512,
+		.also_non_np = 1,
+		.np	= 3,
+		.tap	= { 512 - 20, 4, 16 },
+	}
+};
+
+static struct cipher_testvec speck64_xts_dec_tv_template[] = {
+	{
+		.key	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.klen	= 24,
+		.iv	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x84\xaf\x54\x07\x19\xd4\x7c\xa6"
+			  "\xe4\xfe\xdf\xc4\x1f\x34\xc3\xc2"
+			  "\x80\xf5\x72\xe7\xcd\xf0\x99\x22"
+			  "\x35\xa7\x2f\x06\xef\xdc\x51\xaa",
+		.ilen	= 32,
+		.result	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.rlen	= 32,
+	}, {
+		.key	= "\x11\x11\x11\x11\x11\x11\x11\x11"
+			  "\x11\x11\x11\x11\x11\x11\x11\x11"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22",
+		.klen	= 24,
+		.iv	= "\x33\x33\x33\x33\x33\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x12\x56\x73\xcd\x15\x87\xa8\x59"
+			  "\xcf\x84\xae\xd9\x1c\x66\xd6\x9f"
+			  "\xb3\x12\x69\x7e\x36\xeb\x52\xff"
+			  "\x62\xdd\xba\x90\xb3\xe1\xee\x99",
+		.ilen	= 32,
+		.result	= "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44",
+		.rlen	= 32,
+	}, {
+		.key	= "\xff\xfe\xfd\xfc\xfb\xfa\xf9\xf8"
+			  "\xf7\xf6\xf5\xf4\xf3\xf2\xf1\xf0"
+			  "\x22\x22\x22\x22\x22\x22\x22\x22",
+		.klen	= 24,
+		.iv	= "\x33\x33\x33\x33\x33\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x15\x1b\xe4\x2c\xa2\x5a\x2d\x2c"
+			  "\x27\x36\xc0\xbf\x5d\xea\x36\x37"
+			  "\x2d\x1a\x88\xbc\x66\xb5\xd0\x0b"
+			  "\xa1\xbc\x19\xb2\x0f\x3b\x75\x34",
+		.ilen	= 32,
+		.result	= "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44"
+			  "\x44\x44\x44\x44\x44\x44\x44\x44",
+		.rlen	= 32,
+	}, {
+		.key	= "\x27\x18\x28\x18\x28\x45\x90\x45"
+			  "\x23\x53\x60\x28\x74\x71\x35\x26"
+			  "\x31\x41\x59\x26\x53\x58\x97\x93",
+		.klen	= 24,
+		.iv	= "\x00\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\xaf\xa1\x81\xa6\x32\xbb\x15\x8e"
+			  "\xf8\x95\x2e\xd3\xe6\xee\x7e\x09"
+			  "\x0c\x1a\xf5\x02\x97\x8b\xe3\xb3"
+			  "\x11\xc7\x39\x96\xd0\x95\xf4\x56"
+			  "\xf4\xdd\x03\x38\x01\x44\x2c\xcf"
+			  "\x88\xae\x8e\x3c\xcd\xe7\xaa\x66"
+			  "\xfe\x3d\xc6\xfb\x01\x23\x51\x43"
+			  "\xd5\xd2\x13\x86\x94\x34\xe9\x62"
+			  "\xf9\x89\xe3\xd1\x7b\xbe\xf8\xef"
+			  "\x76\x35\x04\x3f\xdb\x23\x9d\x0b"
+			  "\x85\x42\xb9\x02\xd6\xcc\xdb\x96"
+			  "\xa7\x6b\x27\xb6\xd4\x45\x8f\x7d"
+			  "\xae\xd2\x04\xd5\xda\xc1\x7e\x24"
+			  "\x8c\x73\xbe\x48\x7e\xcf\x65\x28"
+			  "\x29\xe5\xbe\x54\x30\xcb\x46\x95"
+			  "\x4f\x2e\x8a\x36\xc8\x27\xc5\xbe"
+			  "\xd0\x1a\xaf\xab\x26\xcd\x9e\x69"
+			  "\xa1\x09\x95\x71\x26\xe9\xc4\xdf"
+			  "\xe6\x31\xc3\x46\xda\xaf\x0b\x41"
+			  "\x1f\xab\xb1\x8e\xd6\xfc\x0b\xb3"
+			  "\x82\xc0\x37\x27\xfc\x91\xa7\x05"
+			  "\xfb\xc5\xdc\x2b\x74\x96\x48\x43"
+			  "\x5d\x9c\x19\x0f\x60\x63\x3a\x1f"
+			  "\x6f\xf0\x03\xbe\x4d\xfd\xc8\x4a"
+			  "\xc6\xa4\x81\x6d\xc3\x12\x2a\x5c"
+			  "\x07\xff\xf3\x72\x74\x48\xb5\x40"
+			  "\x50\xb5\xdd\x90\x43\x31\x18\x15"
+			  "\x7b\xf2\xa6\xdb\x83\xc8\x4b\x4a"
+			  "\x29\x93\x90\x8b\xda\x07\xf0\x35"
+			  "\x6d\x90\x88\x09\x4e\x83\xf5\x5b"
+			  "\x94\x12\xbb\x33\x27\x1d\x3f\x23"
+			  "\x51\xa8\x7c\x07\xa2\xae\x77\xa6"
+			  "\x50\xfd\xcc\xc0\x4f\x80\x7a\x9f"
+			  "\x66\xdd\xcd\x75\x24\x8b\x33\xf7"
+			  "\x20\xdb\x83\x9b\x4f\x11\x63\x6e"
+			  "\xcf\x37\xef\xc9\x11\x01\x5c\x45"
+			  "\x32\x99\x7c\x3c\x9e\x42\x89\xe3"
+			  "\x70\x6d\x15\x9f\xb1\xe6\xb6\x05"
+			  "\xfe\x0c\xb9\x49\x2d\x90\x6d\xcc"
+			  "\x5d\x3f\xc1\xfe\x89\x0a\x2e\x2d"
+			  "\xa0\xa8\x89\x3b\x73\x39\xa5\x94"
+			  "\x4c\xa4\xa6\xbb\xa7\x14\x46\x89"
+			  "\x10\xff\xaf\xef\xca\xdd\x4f\x80"
+			  "\xb3\xdf\x3b\xab\xd4\xe5\x5a\xc7"
+			  "\x33\xca\x00\x8b\x8b\x3f\xea\xec"
+			  "\x68\x8a\xc2\x6d\xfd\xd4\x67\x0f"
+			  "\x22\x31\xe1\x0e\xfe\x5a\x04\xd5"
+			  "\x64\xa3\xf1\x1a\x76\x28\xcc\x35"
+			  "\x36\xa7\x0a\x74\xf7\x1c\x44\x9b"
+			  "\xc7\x1b\x53\x17\x02\xea\xd1\xad"
+			  "\x13\x51\x73\xc0\xa0\xb2\x05\x32"
+			  "\xa8\xa2\x37\x2e\xe1\x7a\x3a\x19"
+			  "\x26\xb4\x6c\x62\x5d\xb3\x1a\x1d"
+			  "\x59\xda\xee\x1a\x22\x18\xda\x0d"
+			  "\x88\x0f\x55\x8b\x72\x62\xfd\xc1"
+			  "\x69\x13\xcd\x0d\x5f\xc1\x09\x52"
+			  "\xee\xd6\xe3\x84\x4d\xee\xf6\x88"
+			  "\xaf\x83\xdc\x76\xf4\xc0\x93\x3f"
+			  "\x4a\x75\x2f\xb0\x0b\x3e\xc4\x54"
+			  "\x7d\x69\x8d\x00\x62\x77\x0d\x14"
+			  "\xbe\x7c\xa6\x7d\xc5\x24\x4f\xf3"
+			  "\x50\xf7\x5f\xf4\xc2\xca\x41\x97"
+			  "\x37\xbe\x75\x74\xcd\xf0\x75\x6e"
+			  "\x25\x23\x94\xbd\xda\x8d\xb0\xd4",
+		.ilen	= 512,
+		.result	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff"
+			  "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff",
+		.rlen	= 512,
+	}, {
+		.key	= "\x27\x18\x28\x18\x28\x45\x90\x45"
+			  "\x23\x53\x60\x28\x74\x71\x35\x26"
+			  "\x62\x49\x77\x57\x24\x70\x93\x69"
+			  "\x99\x59\x57\x49\x66\x96\x76\x27",
+		.klen	= 32,
+		.iv	= "\xff\x00\x00\x00\x00\x00\x00\x00"
+			  "\x00\x00\x00\x00\x00\x00\x00\x00",
+		.input	= "\x55\xed\x71\xd3\x02\x8e\x15\x3b"
+			  "\xc6\x71\x29\x2d\x3e\x89\x9f\x59"
+			  "\x68\x6a\xcc\x8a\x56\x97\xf3\x95"
+			  "\x4e\x51\x08\xda\x2a\xf8\x6f\x3c"
+			  "\x78\x16\xea\x80\xdb\x33\x75\x94"
+			  "\xf9\x29\xc4\x2b\x76\x75\x97\xc7"
+			  "\xf2\x98\x2c\xf9\xff\xc8\xd5\x2b"
+			  "\x18\xf1\xaf\xcf\x7c\xc5\x0b\xee"
+			  "\xad\x3c\x76\x7c\xe6\x27\xa2\x2a"
+			  "\xe4\x66\xe1\xab\xa2\x39\xfc\x7c"
+			  "\xf5\xec\x32\x74\xa3\xb8\x03\x88"
+			  "\x52\xfc\x2e\x56\x3f\xa1\xf0\x9f"
+			  "\x84\x5e\x46\xed\x20\x89\xb6\x44"
+			  "\x8d\xd0\xed\x54\x47\x16\xbe\x95"
+			  "\x8a\xb3\x6b\x72\xc4\x32\x52\x13"
+			  "\x1b\xb0\x82\xbe\xac\xf9\x70\xa6"
+			  "\x44\x18\xdd\x8c\x6e\xca\x6e\x45"
+			  "\x8f\x1e\x10\x07\x57\x25\x98\x7b"
+			  "\x17\x8c\x78\xdd\x80\xa7\xd9\xd8"
+			  "\x63\xaf\xb9\x67\x57\xfd\xbc\xdb"
+			  "\x44\xe9\xc5\x65\xd1\xc7\x3b\xff"
+			  "\x20\xa0\x80\x1a\xc3\x9a\xad\x5e"
+			  "\x5d\x3b\xd3\x07\xd9\xf5\xfd\x3d"
+			  "\x4a\x8b\xa8\xd2\x6e\x7a\x51\x65"
+			  "\x6c\x8e\x95\xe0\x45\xc9\x5f\x4a"
+			  "\x09\x3c\x3d\x71\x7f\x0c\x84\x2a"
+			  "\xc8\x48\x52\x1a\xc2\xd5\xd6\x78"
+			  "\x92\x1e\xa0\x90\x2e\xea\xf0\xf3"
+			  "\xdc\x0f\xb1\xaf\x0d\x9b\x06\x2e"
+			  "\x35\x10\x30\x82\x0d\xe7\xc5\x9b"
+			  "\xde\x44\x18\xbd\x9f\xd1\x45\xa9"
+			  "\x7b\x7a\x4a\xad\x35\x65\x27\xca"
+			  "\xb2\xc3\xd4\x9b\x71\x86\x70\xee"
+			  "\xf1\x89\x3b\x85\x4b\x5b\xaa\xaf"
+			  "\xfc\x42\xc8\x31\x59\xbe\x16\x60"
+			  "\x4f\xf9\xfa\x12\xea\xd0\xa7\x14"
+			  "\xf0\x7a\xf3\xd5\x8d\xbd\x81\xef"
+			  "\x52\x7f\x29\x51\x94\x20\x67\x3c"
+			  "\xd1\xaf\x77\x9f\x22\x5a\x4e\x63"
+			  "\xe7\xff\x73\x25\xd1\xdd\x96\x8a"
+			  "\x98\x52\x6d\xf3\xac\x3e\xf2\x18"
+			  "\x6d\xf6\x0a\x29\xa6\x34\x3d\xed"
+			  "\xe3\x27\x0d\x9d\x0a\x02\x44\x7e"
+			  "\x5a\x7e\x67\x0f\x0a\x9e\xd6\xad"
+			  "\x91\xe6\x4d\x81\x8c\x5c\x59\xaa"
+			  "\xfb\xeb\x56\x53\xd2\x7d\x4c\x81"
+			  "\x65\x53\x0f\x41\x11\xbd\x98\x99"
+			  "\xf9\xc6\xfa\x51\x2e\xa3\xdd\x8d"
+			  "\x84\x98\xf9\x34\xed\x33\x2a\x1f"
+			  "\x82\xed\xc1\x73\x98\xd3\x02\xdc"
+			  "\xe6\xc2\x33\x1d\xa2\xb4\xca\x76"
+			  "\x63\x51\x34\x9d\x96\x12\xae\xce"
+			  "\x83\xc9\x76\x5e\xa4\x1b\x53\x37"
+			  "\x17\xd5\xc0\x80\x1d\x62\xf8\x3d"
+			  "\x54\x27\x74\xbb\x10\x86\x57\x46"
+			  "\x68\xe1\xed\x14\xe7\x9d\xfc\x84"
+			  "\x47\xbc\xc2\xf8\x19\x4b\x99\xcf"
+			  "\x7a\xe9\xc4\xb8\x8c\x82\x72\x4d"
+			  "\x7b\x4f\x38\x55\x36\x71\x64\xc1"
+			  "\xfc\x5c\x75\x52\x33\x02\x18\xf8"
+			  "\x17\xe1\x2b\xc2\x43\x39\xbd\x76"
+			  "\x9b\x63\x76\x32\x2f\x19\x72\x10"
+			  "\x9f\x21\x0c\xf1\x66\x50\x7f\xa5"
+			  "\x0d\x1f\x46\xe0\xba\xd3\x2f\x3c",
+		.ilen	= 512,
+		.result	= "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff"
+			  "\x00\x01\x02\x03\x04\x05\x06\x07"
+			  "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
+			  "\x10\x11\x12\x13\x14\x15\x16\x17"
+			  "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
+			  "\x20\x21\x22\x23\x24\x25\x26\x27"
+			  "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
+			  "\x30\x31\x32\x33\x34\x35\x36\x37"
+			  "\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f"
+			  "\x40\x41\x42\x43\x44\x45\x46\x47"
+			  "\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f"
+			  "\x50\x51\x52\x53\x54\x55\x56\x57"
+			  "\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f"
+			  "\x60\x61\x62\x63\x64\x65\x66\x67"
+			  "\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f"
+			  "\x70\x71\x72\x73\x74\x75\x76\x77"
+			  "\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f"
+			  "\x80\x81\x82\x83\x84\x85\x86\x87"
+			  "\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f"
+			  "\x90\x91\x92\x93\x94\x95\x96\x97"
+			  "\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f"
+			  "\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7"
+			  "\xa8\xa9\xaa\xab\xac\xad\xae\xaf"
+			  "\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7"
+			  "\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf"
+			  "\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7"
+			  "\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf"
+			  "\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7"
+			  "\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf"
+			  "\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7"
+			  "\xe8\xe9\xea\xeb\xec\xed\xee\xef"
+			  "\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7"
+			  "\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff",
+		.rlen	= 512,
+		.also_non_np = 1,
+		.np	= 3,
+		.tap	= { 512 - 20, 4, 16 },
+	}
+};
+
+/* Cast6 test vectors from RFC 2612 */
+#define CAST6_ENC_TEST_VECTORS		4
+#define CAST6_DEC_TEST_VECTORS		4
+#define CAST6_CBC_ENC_TEST_VECTORS	1
+#define CAST6_CBC_DEC_TEST_VECTORS	1
+#define CAST6_CTR_ENC_TEST_VECTORS	2
+#define CAST6_CTR_DEC_TEST_VECTORS	2
+#define CAST6_LRW_ENC_TEST_VECTORS	1
+#define CAST6_LRW_DEC_TEST_VECTORS	1
+#define CAST6_XTS_ENC_TEST_VECTORS	1
+#define CAST6_XTS_DEC_TEST_VECTORS	1
+
+static struct cipher_testvec cast6_enc_tv_template[] = {
+	{
+		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
+			  "\x0a\xf7\x56\x47\xf2\x9f\x61\x5d",
+		.klen	= 16,
+		.input	= zeroed_string,
+		.ilen	= 16,
+		.result	= "\xc8\x42\xa0\x89\x72\xb4\x3d\x20"
+			  "\x83\x6c\x91\xd1\xb7\x53\x0f\x6b",
+		.rlen	= 16,
+	}, {
+		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
+			  "\xbe\xd0\xac\x83\x94\x0a\xc2\x98"
+			  "\xba\xc7\x7a\x77\x17\x94\x28\x63",
+		.klen	= 24,
+		.input	= zeroed_string,
+		.ilen	= 16,
+		.result	= "\x1b\x38\x6c\x02\x10\xdc\xad\xcb"
+			  "\xdd\x0e\x41\xaa\x08\xa7\xa7\xe8",
+		.rlen	= 16,
+	}, {
+		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
+			  "\xbe\xd0\xac\x83\x94\x0a\xc2\x98"
+			  "\x8d\x7c\x47\xce\x26\x49\x08\x46"
+			  "\x1c\xc1\xb5\x13\x7a\xe6\xb6\x04",
+		.klen	= 32,
+		.input	= zeroed_string,
+		.ilen	= 16,
+		.result	= "\x4f\x6a\x20\x38\x28\x68\x97\xb9"
+			  "\xc9\x87\x01\x36\x55\x33\x17\xfa",
+		.rlen	= 16,
+	}, { /* Generated from TF test vectors */
+		.key	= "\x85\x62\x3F\x1C\xF9\xD6\x1C\xF9"
+			  "\xD6\xB3\x90\x6D\x4A\x90\x6D\x4A"
+			  "\x27\x04\xE1\x27\x04\xE1\xBE\x9B"
+			  "\x78\xBE\x9B\x78\x55\x32\x0F\x55",
+		.klen	= 32,
+		.iv	= "\xE2\x24\x89\xEE\x53\xB8\x1D\x5F"
+			  "\xC4\x29\x8E\xF3\x35\x9A\xFF\x64",
+		.input	= "\x56\xED\x84\x1B\x8F\x26\xBD\x31"
+			  "\xC8\x5F\xF6\x6A\x01\x98\x0C\xA3"
+			  "\x3A\xD1\x45\xDC\x73\x0A\x7E\x15"
+			  "\xAC\x20\xB7\x4E\xE5\x59\xF0\x87"
+			  "\x1E\x92\x29\xC0\x34\xCB\x62\xF9"
+			  "\x6D\x04\x9B\x0F\xA6\x3D\xD4\x48"
+			  "\xDF\x76\x0D\x81\x18\xAF\x23\xBA"
+			  "\x51\xE8\x5C\xF3\x8A\x21\x95\x2C"
+			  "\xC3\x37\xCE\x65\xFC\x70\x07\x9E"
+			  "\x12\xA9\x40\xD7\x4B\xE2\x79\x10"
+			  "\x84\x1B\xB2\x26\xBD\x54\xEB\x5F"
+			  "\xF6\x8D\x01\x98\x2F\xC6\x3A\xD1"
+			  "\x68\xFF\x73\x0A\xA1\x15\xAC\x43"
+			  "\xDA\x4E\xE5\x7C\x13\x87\x1E\xB5"
+			  "\x29\xC0\x57\xEE\x62\xF9\x90\x04"
+			  "\x9B\x32\xC9\x3D\xD4\x6B\x02\x76"
+			  "\x0D\xA4\x18\xAF\x46\xDD\x51\xE8"
+			  "\x7F\x16\x8A\x21\xB8\x2C\xC3\x5A"
+			  "\xF1\x65\xFC\x93\x07\x9E\x35\xCC"
+			  "\x40\xD7\x6E\x05\x79\x10\xA7\x1B"
+			  "\xB2\x49\xE0\x54\xEB\x82\x19\x8D"
+			  "\x24\xBB\x2F\xC6\x5D\xF4\x68\xFF"
+			  "\x96\x0A\xA1\x38\xCF\x43\xDA\x71"
+			  "\x08\x7C\x13\xAA\x1E\xB5\x4C\xE3"
+			  "\x57\xEE\x85\x1C\x90\x27\xBE\x32"
+			  "\xC9\x60\xF7\x6B\x02\x99\x0D\xA4"
+			  "\x3B\xD2\x46\xDD\x74\x0B\x7F\x16"
+			  "\xAD\x21\xB8\x4F\xE6\x5A\xF1\x88"
+			  "\x1F\x93\x2A\xC1\x35\xCC\x63\xFA"
+			  "\x6E\x05\x9C\x10\xA7\x3E\xD5\x49"
+			  "\xE0\x77\x0E\x82\x19\xB0\x24\xBB"
+			  "\x52\xE9\x5D\xF4\x8B\x22\x96\x2D"
+			  "\xC4\x38\xCF\x66\xFD\x71\x08\x9F"
+			  "\x13\xAA\x41\xD8\x4C\xE3\x7A\x11"
+			  "\x85\x1C\xB3\x27\xBE\x55\xEC\x60"
+			  "\xF7\x8E\x02\x99\x30\xC7\x3B\xD2"
+			  "\x69\x00\x74\x0B\xA2\x16\xAD\x44"
+			  "\xDB\x4F\xE6\x7D\x14\x88\x1F\xB6"
+			  "\x2A\xC1\x58\xEF\x63\xFA\x91\x05"
+			  "\x9C\x33\xCA\x3E\xD5\x6C\x03\x77"
+			  "\x0E\xA5\x19\xB0\x47\xDE\x52\xE9"
+			  "\x80\x17\x8B\x22\xB9\x2D\xC4\x5B"
+			  "\xF2\x66\xFD\x94\x08\x9F\x36\xCD"
+			  "\x41\xD8\x6F\x06\x7A\x11\xA8\x1C"
+			  "\xB3\x4A\xE1\x55\xEC\x83\x1A\x8E"
+			  "\x25\xBC\x30\xC7\x5E\xF5\x69\x00"
+			  "\x97\x0B\xA2\x39\xD0\x44\xDB\x72"
+			  "\x09\x7D\x14\xAB\x1F\xB6\x4D\xE4"
+			  "\x58\xEF\x86\x1D\x91\x28\xBF\x33"
+			  "\xCA\x61\xF8\x6C\x03\x9A\x0E\xA5"
+			  "\x3C\xD3\x47\xDE\x75\x0C\x80\x17"
+			  "\xAE\x22\xB9\x50\xE7\x5B\xF2\x89"
+			  "\x20\x94\x2B\xC2\x36\xCD\x64\xFB"
+			  "\x6F\x06\x9D\x11\xA8\x3F\xD6\x4A"
+			  "\xE1\x78\x0F\x83\x1A\xB1\x25\xBC"
+			  "\x53\xEA\x5E\xF5\x8C\x00\x97\x2E"
+			  "\xC5\x39\xD0\x67\xFE\x72\x09\xA0"
+			  "\x14\xAB\x42\xD9\x4D\xE4\x7B\x12"
+			  "\x86\x1D\xB4\x28\xBF\x56\xED\x61"
+			  "\xF8\x8F\x03\x9A\x31\xC8\x3C\xD3"
+			  "\x6A\x01\x75\x0C\xA3\x17\xAE\x45"
+			  "\xDC\x50\xE7\x7E\x15\x89\x20\xB7",
+		.ilen	= 496,
+		.result	= "\xC3\x70\x22\x32\xF5\x80\xCB\x54"
+			  "\xFC\x30\xE0\xF6\xEB\x39\x57\xA6"
+			  "\xB6\xB9\xC5\xA4\x91\x55\x14\x97"
+			  "\xC1\x20\xFF\x6C\x5C\xF0\x67\xEA"
+			  "\x2F\xED\xD8\xC9\xFB\x38\x3F\xFE"
+			  "\x93\xBE\xDC\x00\xD3\x7F\xAD\x4C"
+			  "\x5A\x08\x92\xD1\x47\x0C\xFA\x6C"
+			  "\xD0\x6A\x99\x10\x72\xF8\x47\x62"
+			  "\x81\x42\xF8\xD8\xF5\xBB\x94\x08"
+			  "\xAA\x97\xA2\x8B\x69\xB3\xD2\x7E"
+			  "\xBC\xB5\x00\x0C\xE5\x44\x4B\x58"
+			  "\xE8\x63\xDC\xB3\xC4\xE5\x23\x12"
+			  "\x5A\x72\x85\x47\x8B\xEC\x9F\x26"
+			  "\x84\xB6\xED\x10\x33\x63\x9B\x5F"
+			  "\x4D\x53\xEE\x94\x45\x8B\x60\x58"
+			  "\x86\x20\xF9\x1E\x82\x08\x3E\x58"
+			  "\x60\x1B\x34\x19\x02\xBE\x4E\x09"
+			  "\xBB\x7C\x15\xCC\x60\x27\x55\x7A"
+			  "\x12\xB8\xD8\x08\x89\x3C\xA6\xF3"
+			  "\xF1\xDD\xA7\x07\xA3\x12\x85\x28"
+			  "\xE9\x57\xAC\x80\x0C\x5C\x0F\x3A"
+			  "\x5D\xC2\x91\xC7\x90\xE4\x8C\x43"
+			  "\x92\xE4\x7C\x26\x69\x4D\x83\x68"
+			  "\x14\x96\x42\x47\xBD\xA9\xE4\x8A"
+			  "\x33\x19\xEB\x54\x8E\x0D\x4B\x6E"
+			  "\x91\x51\xB5\x36\x08\xDE\x1C\x06"
+			  "\x03\xBD\xDE\x81\x26\xF7\x99\xC2"
+			  "\xBA\xF7\x6D\x87\x0D\xE4\xA6\xCF"
+			  "\xC1\xF5\x27\x05\xB8\x02\x57\x72"
+			  "\xE6\x42\x13\x0B\xC6\x47\x05\x74"
+			  "\x24\x15\xF7\x0D\xC2\x23\x9D\xB9"
+			  "\x3C\x77\x18\x93\xBA\xB4\xFC\x8C"
+			  "\x98\x82\x67\x67\xB4\xD7\xD3\x43"
+			  "\x23\x08\x02\xB7\x9B\x99\x05\xFB"
+			  "\xD3\xB5\x00\x0A\xA9\x9D\x66\xD6"
+			  "\x2E\x49\x58\xD0\xA8\x57\x29\x7F"
+			  "\x0A\x0E\x7D\xFC\x92\x83\xCC\x67"
+			  "\xA2\xB1\x70\x3A\x8F\x87\x4A\x8D"
+			  "\x17\xE2\x58\x2B\x88\x0D\x68\x62"
+			  "\xBF\x35\xD1\x6F\xC0\xF0\x18\x62"
+			  "\xB2\xC7\x2D\x58\xC7\x16\xDE\x08"
+			  "\xEB\x84\x1D\x25\xA7\x38\x94\x06"
+			  "\x93\x9D\xF8\xFE\x88\x71\xE7\x84"
+			  "\x2C\xA0\x38\xA3\x1D\x48\xCF\x29"
+			  "\x0B\xBC\xD8\x50\x99\x1A\x26\xFB"
+			  "\x8E\x75\x3D\x73\xEB\x6A\xED\x29"
+			  "\xE0\x8E\xED\xFC\xFE\x6F\xF6\xBA"
+			  "\x41\xE2\x10\x4C\x01\x8B\x69\x2B"
+			  "\x25\x3F\x4D\x70\x7B\x92\xD6\x3B"
+			  "\xAC\xF9\x77\x18\xD9\x6A\x30\xA6"
+			  "\x2E\xFA\x30\xFF\xC8\xD5\x1D\x06"
+			  "\x59\x28\x1D\x86\x43\x04\x5D\x3B"
+			  "\x99\x4C\x04\x5A\x21\x17\x8B\x76"
+			  "\x8F\x72\xCB\xA1\x9C\x29\x4C\xC3"
+			  "\x65\xA2\x58\x2A\xC5\x66\x24\xBF"
+			  "\xBA\xE6\x0C\xDD\x34\x24\x74\xC8"
+			  "\x84\x0A\x66\x2C\xBE\x8F\x32\xA9"
+			  "\xE7\xE4\xA1\xD7\xDA\xAB\x23\x1E"
+			  "\xEB\xEE\x6C\x94\x6F\x9C\x2E\xD1"
+			  "\x49\x2C\xF3\xD4\x90\xCC\x93\x4C"
+			  "\x84\x52\x6D\x68\xDE\xC6\x64\xB2"
+			  "\x11\x74\x93\x57\xB4\x7E\xC6\x00",
+		.rlen	= 496,
+		.also_non_np = 1,
+		.np	= 3,
+		.tap	= { 496 - 20, 4, 16 },
+	},
+};
+
+static struct cipher_testvec cast6_dec_tv_template[] = {
+	{
+		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
+			  "\x0a\xf7\x56\x47\xf2\x9f\x61\x5d",
+		.klen	= 16,
+		.input	= "\xc8\x42\xa0\x89\x72\xb4\x3d\x20"
+			  "\x83\x6c\x91\xd1\xb7\x53\x0f\x6b",
+		.ilen	= 16,
+		.result	= zeroed_string,
+		.rlen	= 16,
+	}, {
+		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
+			  "\xbe\xd0\xac\x83\x94\x0a\xc2\x98"
+			  "\xba\xc7\x7a\x77\x17\x94\x28\x63",
+		.klen	= 24,
+		.input	= "\x1b\x38\x6c\x02\x10\xdc\xad\xcb"
+			  "\xdd\x0e\x41\xaa\x08\xa7\xa7\xe8",
+		.ilen	= 16,
+		.result	= zeroed_string,
+		.rlen	= 16,
+	}, {
+		.key	= "\x23\x42\xbb\x9e\xfa\x38\x54\x2c"
+			  "\xbe\xd0\xac\x83\x94\x0a\xc2\x98"
+			  "\x8d\x7c\x47\xce\x26\x49\x08\x46"
+			  "\x1c\xc1\xb5\x13\x7a\xe6\xb6\x04",
+		.klen	= 32,
+		.input	= "\x4f\x6a\x20\x38\x28\x68\x97\xb9"
+			  "\xc9\x87\x01\x36\x55\x33\x17\xfa",
+		.ilen	= 16,
+		.result	= zeroed_string,
+		.rlen	= 16,
+	}, { /* Generated from TF test vectors */
+		.key	= "\x85\x62\x3F\x1C\xF9\xD6\x1C\xF9"
+			  "\xD6\xB3\x90\x6D\x4A\x90\x6D\x4A"
+			  "\x27\x04\xE1\x27\x04\xE1\xBE\x9B"
+			  "\x78\xBE\x9B\x78\x55\x32\x0F\x55",
+		.klen	= 32,
+		.iv	= "\xE2\x24\x89\xEE\x53\xB8\x1D\x5F"
+			  "\xC4\x29\x8E\xF3\x35\x9A\xFF\x64",
+		.input	= "\xC3\x70\x22\x32\xF5\x80\xCB\x54"
+			  "\xFC\x30\xE0\xF6\xEB\x39\x57\xA6"
+			  "\xB6\xB9\xC5\xA4\x91\x55\x14\x97"
+			  "\xC1\x20\xFF\x6C\x5C\xF0\x67\xEA"
+			  "\x2F\xED\xD8\xC9\xFB\x38\x3F\xFE"
+			  "\x93\xBE\xDC\x00\xD3\x7F\xAD\x4C"
+			  "\x5A\x08\x92\xD1\x47\x0C\xFA\x6C"
+			  "\xD0\x6A\x99\x10\x72\xF8\x47\x62"
+			  "\x81\x42\xF8\xD8\xF5\xBB\x94\x08"
+			  "\xAA\x97\xA2\x8B\x69\xB3\xD2\x7E"
+			  "\xBC\xB5\x00\x0C\xE5\x44\x4B\x58"
+			  "\xE8\x63\xDC\xB3\xC4\xE5\x23\x12"
+			  "\x5A\x72\x85\x47\x8B\xEC\x9F\x26"
+			  "\x84\xB6\xED\x10\x33\x63\x9B\x5F"
+			  "\x4D\x53\xEE\x94\x45\x8B\x60\x58"
+			  "\x86\x20\xF9\x1E\x82\x08\x3E\x58"
+			  "\x60\x1B\x34\x19\x02\xBE\x4E\x09"
+			  "\xBB\x7C\x15\xCC\x60\x27\x55\x7A"
+			  "\x12\xB8\xD8\x08\x89\x3C\xA6\xF3"
+			  "\xF1\xDD\xA7\x07\xA3\x12\x85\x28"
 			  "\xE9\x57\xAC\x80\x0C\x5C\x0F\x3A"
 			  "\x5D\xC2\x91\xC7\x90\xE4\x8C\x43"
 			  "\x92\xE4\x7C\x26\x69\x4D\x83\x68"
@@ -15183,8 +16679,13 @@ struct kpp_testvec ecdh_tv_template[] = {
 #define AES_LRW_DEC_TEST_VECTORS 8
 #define AES_XTS_ENC_TEST_VECTORS 5
 #define AES_XTS_DEC_TEST_VECTORS 5
+#ifndef CRYPTO_RTK_TEST
 #define AES_CTR_ENC_TEST_VECTORS 5
 #define AES_CTR_DEC_TEST_VECTORS 5
+#else
+#define AES_CTR_ENC_TEST_VECTORS 4
+#define AES_CTR_DEC_TEST_VECTORS 4
+#endif
 #define AES_OFB_ENC_TEST_VECTORS 1
 #define AES_OFB_DEC_TEST_VECTORS 1
 #define AES_CTR_3686_ENC_TEST_VECTORS 7
@@ -15366,9 +16867,11 @@ struct kpp_testvec ecdh_tv_template[] = {
 			  "\x09\x79\xA0\x43\x5C\x0D\x08\x58"
 			  "\x17\xBB\xC0\x6B\x62\x3F\x56\xE9",
 		.rlen	= 496,
+#ifndef CRYPTO_RTK_TEST
 		.also_non_np = 1,
 		.np	= 3,
 		.tap	= { 496 - 20, 4, 16 },
+#endif
 	},
 };
 
@@ -15538,9 +17041,11 @@ struct kpp_testvec ecdh_tv_template[] = {
 			  "\x3C\xC8\x31\x9A\x03\x8F\xF8\x61"
 			  "\xED\x56\xBF\x28\xB4\x1D\x86\x12",
 		.rlen	= 496,
+#ifndef CRYPTO_RTK_TEST
 		.also_non_np = 1,
 		.np	= 3,
 		.tap	= { 496 - 20, 4, 16 },
+#endif
 	},
 };
 
@@ -15760,9 +17265,11 @@ struct kpp_testvec ecdh_tv_template[] = {
 			  "\xE0\x1F\x91\xF8\x82\x96\x2D\x65"
 			  "\xA3\xAA\x13\xCC\x50\xFF\x7B\x02",
 		.rlen	= 496,
+#ifndef CRYPTO_RTK_TEST
 		.also_non_np = 1,
 		.np	= 3,
 		.tap	= { 496 - 20, 4, 16 },
+#endif
 	},
 };
 
@@ -15982,9 +17489,11 @@ struct kpp_testvec ecdh_tv_template[] = {
 			  "\x3C\xC8\x31\x9A\x03\x8F\xF8\x61"
 			  "\xED\x56\xBF\x28\xB4\x1D\x86\x12",
 		.rlen	= 496,
+#ifndef CRYPTO_RTK_TEST
 		.also_non_np = 1,
 		.np	= 3,
 		.tap	= { 496 - 20, 4, 16 },
+#endif
 	},
 };
 
@@ -19115,6 +20624,7 @@ struct kpp_testvec ecdh_tv_template[] = {
 			  "\xFA\x3A\x05\x4C\xFA\xD1\xFF\xFE"
 			  "\xF1\x4C\xE5\xB2\x91\x64\x0C\x51",
 		.rlen	= 496,
+#ifndef CRYPTO_RTK_TEST
 		.also_non_np = 1,
 		.np	= 3,
 		.tap	= { 496 - 20, 4, 16 },
@@ -19257,6 +20767,7 @@ struct kpp_testvec ecdh_tv_template[] = {
 		.also_non_np = 1,
 		.np	= 2,
 		.tap	= { 499 - 16, 16 },
+#endif
 	},
 };
 
@@ -19470,6 +20981,7 @@ struct kpp_testvec ecdh_tv_template[] = {
 			  "\x3C\xC8\x31\x9A\x03\x8F\xF8\x61"
 			  "\xED\x56\xBF\x28\xB4\x1D\x86\x12",
 		.rlen	= 496,
+#ifndef CRYPTO_RTK_TEST
 		.also_non_np = 1,
 		.np	= 3,
 		.tap	= { 496 - 20, 4, 16 },
@@ -19612,6 +21124,7 @@ struct kpp_testvec ecdh_tv_template[] = {
 		.also_non_np = 1,
 		.np	= 2,
 		.tap	= { 499 - 16, 16 },
+#endif
 	},
 };
 
diff --git a/drivers/Kconfig b/drivers/Kconfig
index e1e2066..1097248 100644
--- a/drivers/Kconfig
+++ b/drivers/Kconfig
@@ -104,6 +104,8 @@ source "drivers/memstick/Kconfig"
 
 source "drivers/leds/Kconfig"
 
+source "drivers/switch/Kconfig"
+
 source "drivers/accessibility/Kconfig"
 
 source "drivers/infiniband/Kconfig"
@@ -202,4 +204,10 @@ source "drivers/hwtracing/intel_th/Kconfig"
 
 source "drivers/fpga/Kconfig"
 
+source "drivers/tee/Kconfig"
+
+source "drivers/smartcard/Kconfig"
+
+source "drivers/tsio/Kconfig"
+
 endmenu
diff --git a/drivers/Makefile b/drivers/Makefile
index 7c3d58d..0648179 100644
--- a/drivers/Makefile
+++ b/drivers/Makefile
@@ -127,6 +127,7 @@ obj-$(CONFIG_CPU_IDLE)		+= cpuidle/
 obj-y				+= mmc/
 obj-$(CONFIG_MEMSTICK)		+= memstick/
 obj-$(CONFIG_NEW_LEDS)		+= leds/
+obj-$(CONFIG_SWITCH)		+= switch/
 obj-$(CONFIG_INFINIBAND)	+= infiniband/
 obj-$(CONFIG_SGI_SN)		+= sn/
 obj-y				+= firmware/
@@ -175,3 +176,7 @@ obj-$(CONFIG_STM)		+= hwtracing/stm/
 obj-$(CONFIG_ANDROID)		+= android/
 obj-$(CONFIG_NVMEM)		+= nvmem/
 obj-$(CONFIG_FPGA)		+= fpga/
+obj-$(CONFIG_SMARTCARD) += smartcard/
+obj-$(CONFIG_TEE)               += tee/
+obj-$(CONFIG_TSIO)              += tsio/
+
diff --git a/drivers/acpi/button.c b/drivers/acpi/button.c
index e19f530..f7c4301 100644
--- a/drivers/acpi/button.c
+++ b/drivers/acpi/button.c
@@ -556,7 +556,8 @@ static int acpi_button_remove(struct acpi_device *device)
 	return 0;
 }
 
-static int param_set_lid_init_state(const char *val, struct kernel_param *kp)
+static int param_set_lid_init_state(const char *val,
+				    const struct kernel_param *kp)
 {
 	int result = 0;
 
@@ -574,7 +575,8 @@ static int param_set_lid_init_state(const char *val, struct kernel_param *kp)
 	return result;
 }
 
-static int param_get_lid_init_state(char *buffer, struct kernel_param *kp)
+static int param_get_lid_init_state(char *buffer,
+				    const struct kernel_param *kp)
 {
 	switch (lid_init_state) {
 	case ACPI_BUTTON_LID_INIT_OPEN:
diff --git a/drivers/acpi/ec.c b/drivers/acpi/ec.c
index 307b3e2..7b665aa 100644
--- a/drivers/acpi/ec.c
+++ b/drivers/acpi/ec.c
@@ -1891,7 +1891,8 @@ static int acpi_ec_resume(struct device *dev)
 	SET_SYSTEM_SLEEP_PM_OPS(acpi_ec_suspend, acpi_ec_resume)
 };
 
-static int param_set_event_clearing(const char *val, struct kernel_param *kp)
+static int param_set_event_clearing(const char *val,
+				    const struct kernel_param *kp)
 {
 	int result = 0;
 
@@ -1909,7 +1910,8 @@ static int param_set_event_clearing(const char *val, struct kernel_param *kp)
 	return result;
 }
 
-static int param_get_event_clearing(char *buffer, struct kernel_param *kp)
+static int param_get_event_clearing(char *buffer,
+				    const struct kernel_param *kp)
 {
 	switch (ec_event_clearing) {
 	case ACPI_EC_EVT_TIMING_STATUS:
diff --git a/drivers/acpi/sysfs.c b/drivers/acpi/sysfs.c
index cf05ae9..34328e1 100644
--- a/drivers/acpi/sysfs.c
+++ b/drivers/acpi/sysfs.c
@@ -227,7 +227,8 @@ static int param_get_trace_method_name(char *buffer, const struct kernel_param *
 module_param_cb(trace_debug_layer, &param_ops_trace_attrib, &acpi_gbl_trace_dbg_layer, 0644);
 module_param_cb(trace_debug_level, &param_ops_trace_attrib, &acpi_gbl_trace_dbg_level, 0644);
 
-static int param_set_trace_state(const char *val, struct kernel_param *kp)
+static int param_set_trace_state(const char *val,
+				 const struct kernel_param *kp)
 {
 	acpi_status status;
 	const char *method = trace_method_name;
@@ -263,7 +264,7 @@ static int param_set_trace_state(const char *val, struct kernel_param *kp)
 	return 0;
 }
 
-static int param_get_trace_state(char *buffer, struct kernel_param *kp)
+static int param_get_trace_state(char *buffer, const struct kernel_param *kp)
 {
 	if (!(acpi_gbl_trace_flags & ACPI_TRACE_ENABLED))
 		return sprintf(buffer, "disable");
@@ -292,7 +293,8 @@ static int param_get_trace_state(char *buffer, struct kernel_param *kp)
 		 "To enable/disable the ACPI Debug Object output.");
 
 /* /sys/module/acpi/parameters/acpica_version */
-static int param_get_acpica_version(char *buffer, struct kernel_param *kp)
+static int param_get_acpica_version(char *buffer,
+				    const struct kernel_param *kp)
 {
 	int result;
 
diff --git a/drivers/android/Kconfig b/drivers/android/Kconfig
index bdfc6c6..c7070a8 100644
--- a/drivers/android/Kconfig
+++ b/drivers/android/Kconfig
@@ -9,7 +9,7 @@ if ANDROID
 
 config ANDROID_BINDER_IPC
 	bool "Android Binder IPC Driver"
-	depends on MMU
+	depends on MMU && !M68K
 	default n
 	---help---
 	  Binder is used in Android for both communication between processes,
@@ -19,9 +19,22 @@ config ANDROID_BINDER_IPC
 	  Android process, using Binder to identify, invoke and pass arguments
 	  between said processes.
 
+config ANDROID_BINDER_DEVICES
+	string "Android Binder devices"
+	depends on ANDROID_BINDER_IPC
+	default "binder,hwbinder,vndbinder"
+	---help---
+	  Default value for the binder.devices parameter.
+
+	  The binder.devices parameter is a comma-separated list of strings
+	  that specifies the names of the binder device nodes that will be
+	  created. Each binder device has its own context manager, and is
+	  therefore logically separated from the other devices.
+
 config ANDROID_BINDER_IPC_32BIT
-	bool
-	depends on !64BIT && ANDROID_BINDER_IPC
+	bool "Android Binder IPC_32BIT Driver"
+	#depends on !64BIT && ANDROID_BINDER_IPC
+	depends on ANDROID_BINDER_IPC
 	default y
 	---help---
 	  The Binder API has been changed to support both 32 and 64bit
@@ -32,6 +45,22 @@ config ANDROID_BINDER_IPC_32BIT
 
 	  Note that enabling this will break newer Android user-space.
 
+config ANDROID_BINDER_IPC_SELFTEST
+	bool "Android Binder IPC Driver Selftest"
+	depends on ANDROID_BINDER_IPC
+	---help---
+	  This feature allows binder selftest to run.
+
+	  Binder selftest checks the allocation and free of binder buffers
+	  exhaustively with combinations of various buffer sizes and
+	  alignments.
+
+config ANDROID_KK
+	bool "Android KitKat support"
+	default n
+	---help---
+	Android KitKat support.
+
 endif # if ANDROID
 
 endmenu
diff --git a/drivers/android/Makefile b/drivers/android/Makefile
index 3b7e4b0..a01254c 100644
--- a/drivers/android/Makefile
+++ b/drivers/android/Makefile
@@ -1,3 +1,4 @@
 ccflags-y += -I$(src)			# needed for trace events
 
-obj-$(CONFIG_ANDROID_BINDER_IPC)	+= binder.o
+obj-$(CONFIG_ANDROID_BINDER_IPC)	+= binder.o binder_alloc.o
+obj-$(CONFIG_ANDROID_BINDER_IPC_SELFTEST) += binder_alloc_selftest.o
diff --git a/drivers/android/binder.c b/drivers/android/binder.c
index 49199bd..c6d909e1 100644
--- a/drivers/android/binder.c
+++ b/drivers/android/binder.c
@@ -15,6 +15,40 @@
  *
  */
 
+/*
+ * Locking overview
+ *
+ * There are 3 main spinlocks which must be acquired in the
+ * order shown:
+ *
+ * 1) proc->outer_lock : protects binder_ref
+ *    binder_proc_lock() and binder_proc_unlock() are
+ *    used to acq/rel.
+ * 2) node->lock : protects most fields of binder_node.
+ *    binder_node_lock() and binder_node_unlock() are
+ *    used to acq/rel
+ * 3) proc->inner_lock : protects the thread and node lists
+ *    (proc->threads, proc->waiting_threads, proc->nodes)
+ *    and all todo lists associated with the binder_proc
+ *    (proc->todo, thread->todo, proc->delivered_death and
+ *    node->async_todo), as well as thread->transaction_stack
+ *    binder_inner_proc_lock() and binder_inner_proc_unlock()
+ *    are used to acq/rel
+ *
+ * Any lock under procA must never be nested under any lock at the same
+ * level or below on procB.
+ *
+ * Functions that require a lock held on entry indicate which lock
+ * in the suffix of the function name:
+ *
+ * foo_olocked() : requires node->outer_lock
+ * foo_nlocked() : requires node->lock
+ * foo_ilocked() : requires proc->inner_lock
+ * foo_oilocked(): requires proc->outer_lock and proc->inner_lock
+ * foo_nilocked(): requires node->lock and proc->inner_lock
+ * ...
+ */
+
 #define pr_fmt(fmt) KBUILD_MODNAME ": " fmt
 
 #include <asm/cacheflush.h>
@@ -24,7 +58,6 @@
 #include <linux/fs.h>
 #include <linux/list.h>
 #include <linux/miscdevice.h>
-#include <linux/mm.h>
 #include <linux/module.h>
 #include <linux/mutex.h>
 #include <linux/nsproxy.h>
@@ -34,31 +67,31 @@
 #include <linux/sched.h>
 #include <linux/seq_file.h>
 #include <linux/uaccess.h>
-#include <linux/vmalloc.h>
-#include <linux/slab.h>
 #include <linux/pid_namespace.h>
 #include <linux/security.h>
+#include <linux/spinlock.h>
 
 #ifdef CONFIG_ANDROID_BINDER_IPC_32BIT
 #define BINDER_IPC_32BIT 1
 #endif
 
 #include <uapi/linux/android/binder.h>
+#include "binder_alloc.h"
 #include "binder_trace.h"
 
-static DEFINE_MUTEX(binder_main_lock);
+static HLIST_HEAD(binder_deferred_list);
 static DEFINE_MUTEX(binder_deferred_lock);
-static DEFINE_MUTEX(binder_mmap_lock);
 
+static HLIST_HEAD(binder_devices);
 static HLIST_HEAD(binder_procs);
-static HLIST_HEAD(binder_deferred_list);
+static DEFINE_MUTEX(binder_procs_lock);
+
 static HLIST_HEAD(binder_dead_nodes);
+static DEFINE_SPINLOCK(binder_dead_nodes_lock);
 
 static struct dentry *binder_debugfs_dir_entry_root;
 static struct dentry *binder_debugfs_dir_entry_proc;
-static struct binder_node *binder_context_mgr_node;
-static kuid_t binder_context_mgr_uid = INVALID_UID;
-static int binder_last_id;
+static atomic_t binder_last_id;
 
 #define BINDER_DEBUG_ENTRY(name) \
 static int binder_##name##_open(struct inode *inode, struct file *file) \
@@ -104,22 +137,21 @@ enum {
 	BINDER_DEBUG_TRANSACTION_COMPLETE   = 1U << 10,
 	BINDER_DEBUG_FREE_BUFFER            = 1U << 11,
 	BINDER_DEBUG_INTERNAL_REFS          = 1U << 12,
-	BINDER_DEBUG_BUFFER_ALLOC           = 1U << 13,
-	BINDER_DEBUG_PRIORITY_CAP           = 1U << 14,
-	BINDER_DEBUG_BUFFER_ALLOC_ASYNC     = 1U << 15,
+	BINDER_DEBUG_PRIORITY_CAP           = 1U << 13,
+	BINDER_DEBUG_SPINLOCKS              = 1U << 14,
 };
 static uint32_t binder_debug_mask = BINDER_DEBUG_USER_ERROR |
 	BINDER_DEBUG_FAILED_TRANSACTION | BINDER_DEBUG_DEAD_TRANSACTION;
-module_param_named(debug_mask, binder_debug_mask, uint, S_IWUSR | S_IRUGO);
+module_param_named(debug_mask, binder_debug_mask, uint, 0644);
 
-static bool binder_debug_no_lock;
-module_param_named(proc_no_lock, binder_debug_no_lock, bool, S_IWUSR | S_IRUGO);
+static char *binder_devices_param = CONFIG_ANDROID_BINDER_DEVICES;
+module_param_named(devices, binder_devices_param, charp, S_IRUGO);
 
 static DECLARE_WAIT_QUEUE_HEAD(binder_user_error_wait);
 static int binder_stop_on_user_error;
 
 static int binder_set_stop_on_user_error(const char *val,
-					 struct kernel_param *kp)
+					 const struct kernel_param *kp)
 {
 	int ret;
 
@@ -129,7 +161,7 @@ static int binder_set_stop_on_user_error(const char *val,
 	return ret;
 }
 module_param_call(stop_on_user_error, binder_set_stop_on_user_error,
-	param_get_int, &binder_stop_on_user_error, S_IWUSR | S_IRUGO);
+	param_get_int, &binder_stop_on_user_error, 0644);
 
 #define binder_debug(mask, x...) \
 	do { \
@@ -145,6 +177,17 @@ static int binder_set_stop_on_user_error(const char *val,
 			binder_stop_on_user_error = 2; \
 	} while (0)
 
+#define to_flat_binder_object(hdr) \
+	container_of(hdr, struct flat_binder_object, hdr)
+
+#define to_binder_fd_object(hdr) container_of(hdr, struct binder_fd_object, hdr)
+
+#define to_binder_buffer_object(hdr) \
+	container_of(hdr, struct binder_buffer_object, hdr)
+
+#define to_binder_fd_array_object(hdr) \
+	container_of(hdr, struct binder_fd_array_object, hdr)
+
 enum binder_stat_types {
 	BINDER_STAT_PROC,
 	BINDER_STAT_THREAD,
@@ -157,26 +200,27 @@ enum binder_stat_types {
 };
 
 struct binder_stats {
-	int br[_IOC_NR(BR_FAILED_REPLY) + 1];
-	int bc[_IOC_NR(BC_DEAD_BINDER_DONE) + 1];
-	int obj_created[BINDER_STAT_COUNT];
-	int obj_deleted[BINDER_STAT_COUNT];
+	atomic_t br[_IOC_NR(BR_FAILED_REPLY) + 1];
+	atomic_t bc[_IOC_NR(BC_REPLY_SG) + 1];
+	atomic_t obj_created[BINDER_STAT_COUNT];
+	atomic_t obj_deleted[BINDER_STAT_COUNT];
 };
 
 static struct binder_stats binder_stats;
 
 static inline void binder_stats_deleted(enum binder_stat_types type)
 {
-	binder_stats.obj_deleted[type]++;
+	atomic_inc(&binder_stats.obj_deleted[type]);
 }
 
 static inline void binder_stats_created(enum binder_stat_types type)
 {
-	binder_stats.obj_created[type]++;
+	atomic_inc(&binder_stats.obj_created[type]);
 }
 
 struct binder_transaction_log_entry {
 	int debug_id;
+	int debug_id_done;
 	int call_type;
 	int from_proc;
 	int from_thread;
@@ -186,10 +230,14 @@ struct binder_transaction_log_entry {
 	int to_node;
 	int data_size;
 	int offsets_size;
+	int return_error_line;
+	uint32_t return_error;
+	uint32_t return_error_param;
+	const char *context_name;
 };
 struct binder_transaction_log {
-	int next;
-	int full;
+	atomic_t cur;
+	bool full;
 	struct binder_transaction_log_entry entry[32];
 };
 static struct binder_transaction_log binder_transaction_log;
@@ -199,22 +247,50 @@ static struct binder_transaction_log_entry *binder_transaction_log_add(
 	struct binder_transaction_log *log)
 {
 	struct binder_transaction_log_entry *e;
-
-	e = &log->entry[log->next];
+	unsigned int cur = atomic_inc_return(&log->cur);
+
+	if (cur >= ARRAY_SIZE(log->entry))
+		log->full = true;
+	e = &log->entry[cur % ARRAY_SIZE(log->entry)];
+	WRITE_ONCE(e->debug_id_done, 0);
+	/*
+	 * write-barrier to synchronize access to e->debug_id_done.
+	 * We make sure the initialized 0 value is seen before
+	 * memset() other fields are zeroed by memset.
+	 */
+	smp_wmb();
 	memset(e, 0, sizeof(*e));
-	log->next++;
-	if (log->next == ARRAY_SIZE(log->entry)) {
-		log->next = 0;
-		log->full = 1;
-	}
 	return e;
 }
 
+struct binder_context {
+	struct binder_node *binder_context_mgr_node;
+	struct mutex context_mgr_node_lock;
+
+	kuid_t binder_context_mgr_uid;
+	const char *name;
+};
+
+struct binder_device {
+	struct hlist_node hlist;
+	struct miscdevice miscdev;
+	struct binder_context context;
+};
+
+/**
+ * struct binder_work - work enqueued on a worklist
+ * @entry:             node enqueued on list
+ * @type:              type of work to be performed
+ *
+ * There are separate work lists for proc, thread, and node (async).
+ */
 struct binder_work {
 	struct list_head entry;
+
 	enum {
 		BINDER_WORK_TRANSACTION = 1,
 		BINDER_WORK_TRANSACTION_COMPLETE,
+		BINDER_WORK_RETURN_ERROR,
 		BINDER_WORK_NODE,
 		BINDER_WORK_DEAD_BINDER,
 		BINDER_WORK_DEAD_BINDER_AND_CLEAR,
@@ -222,8 +298,76 @@ struct binder_work {
 	} type;
 };
 
+struct binder_error {
+	struct binder_work work;
+	uint32_t cmd;
+};
+
+/**
+ * struct binder_node - binder node bookkeeping
+ * @debug_id:             unique ID for debugging
+ *                        (invariant after initialized)
+ * @lock:                 lock for node fields
+ * @work:                 worklist element for node work
+ *                        (protected by @proc->inner_lock)
+ * @rb_node:              element for proc->nodes tree
+ *                        (protected by @proc->inner_lock)
+ * @dead_node:            element for binder_dead_nodes list
+ *                        (protected by binder_dead_nodes_lock)
+ * @proc:                 binder_proc that owns this node
+ *                        (invariant after initialized)
+ * @refs:                 list of references on this node
+ *                        (protected by @lock)
+ * @internal_strong_refs: used to take strong references when
+ *                        initiating a transaction
+ *                        (protected by @proc->inner_lock if @proc
+ *                        and by @lock)
+ * @local_weak_refs:      weak user refs from local process
+ *                        (protected by @proc->inner_lock if @proc
+ *                        and by @lock)
+ * @local_strong_refs:    strong user refs from local process
+ *                        (protected by @proc->inner_lock if @proc
+ *                        and by @lock)
+ * @tmp_refs:             temporary kernel refs
+ *                        (protected by @proc->inner_lock while @proc
+ *                        is valid, and by binder_dead_nodes_lock
+ *                        if @proc is NULL. During inc/dec and node release
+ *                        it is also protected by @lock to provide safety
+ *                        as the node dies and @proc becomes NULL)
+ * @ptr:                  userspace pointer for node
+ *                        (invariant, no lock needed)
+ * @cookie:               userspace cookie for node
+ *                        (invariant, no lock needed)
+ * @has_strong_ref:       userspace notified of strong ref
+ *                        (protected by @proc->inner_lock if @proc
+ *                        and by @lock)
+ * @pending_strong_ref:   userspace has acked notification of strong ref
+ *                        (protected by @proc->inner_lock if @proc
+ *                        and by @lock)
+ * @has_weak_ref:         userspace notified of weak ref
+ *                        (protected by @proc->inner_lock if @proc
+ *                        and by @lock)
+ * @pending_weak_ref:     userspace has acked notification of weak ref
+ *                        (protected by @proc->inner_lock if @proc
+ *                        and by @lock)
+ * @has_async_transaction: async transaction to node in progress
+ *                        (protected by @lock)
+ * @sched_policy:         minimum scheduling policy for node
+ *                        (invariant after initialized)
+ * @accept_fds:           file descriptor operations supported for node
+ *                        (invariant after initialized)
+ * @min_priority:         minimum scheduling priority
+ *                        (invariant after initialized)
+ * @inherit_rt:           inherit RT scheduling policy from caller
+ *                        (invariant after initialized)
+ * @async_todo:           list of async work items
+ *                        (protected by @proc->inner_lock)
+ *
+ * Bookkeeping structure for binder nodes.
+ */
 struct binder_node {
 	int debug_id;
+	spinlock_t lock;
 	struct binder_work work;
 	union {
 		struct rb_node rb_node;
@@ -234,97 +378,198 @@ struct binder_node {
 	int internal_strong_refs;
 	int local_weak_refs;
 	int local_strong_refs;
+	int tmp_refs;
 	binder_uintptr_t ptr;
 	binder_uintptr_t cookie;
-	unsigned has_strong_ref:1;
-	unsigned pending_strong_ref:1;
-	unsigned has_weak_ref:1;
-	unsigned pending_weak_ref:1;
-	unsigned has_async_transaction:1;
-	unsigned accept_fds:1;
-	unsigned min_priority:8;
+	struct {
+		/*
+		 * bitfield elements protected by
+		 * proc inner_lock
+		 */
+		u8 has_strong_ref:1;
+		u8 pending_strong_ref:1;
+		u8 has_weak_ref:1;
+		u8 pending_weak_ref:1;
+	};
+	struct {
+		/*
+		 * invariant after initialization
+		 */
+		u8 sched_policy:2;
+		u8 inherit_rt:1;
+		u8 accept_fds:1;
+		u8 min_priority;
+	};
+	bool has_async_transaction;
 	struct list_head async_todo;
 };
 
 struct binder_ref_death {
+	/**
+	 * @work: worklist element for death notifications
+	 *        (protected by inner_lock of the proc that
+	 *        this ref belongs to)
+	 */
 	struct binder_work work;
 	binder_uintptr_t cookie;
 };
 
+/**
+ * struct binder_ref_data - binder_ref counts and id
+ * @debug_id:        unique ID for the ref
+ * @desc:            unique userspace handle for ref
+ * @strong:          strong ref count (debugging only if not locked)
+ * @weak:            weak ref count (debugging only if not locked)
+ *
+ * Structure to hold ref count and ref id information. Since
+ * the actual ref can only be accessed with a lock, this structure
+ * is used to return information about the ref to callers of
+ * ref inc/dec functions.
+ */
+struct binder_ref_data {
+	int debug_id;
+	uint32_t desc;
+	int strong;
+	int weak;
+};
+
+/**
+ * struct binder_ref - struct to track references on nodes
+ * @data:        binder_ref_data containing id, handle, and current refcounts
+ * @rb_node_desc: node for lookup by @data.desc in proc's rb_tree
+ * @rb_node_node: node for lookup by @node in proc's rb_tree
+ * @node_entry:  list entry for node->refs list in target node
+ *               (protected by @node->lock)
+ * @proc:        binder_proc containing ref
+ * @node:        binder_node of target node. When cleaning up a
+ *               ref for deletion in binder_cleanup_ref, a non-NULL
+ *               @node indicates the node must be freed
+ * @death:       pointer to death notification (ref_death) if requested
+ *               (protected by @node->lock)
+ *
+ * Structure to track references from procA to target node (on procB). This
+ * structure is unsafe to access without holding @proc->outer_lock.
+ */
 struct binder_ref {
 	/* Lookups needed: */
 	/*   node + proc => ref (transaction) */
 	/*   desc + proc => ref (transaction, inc/dec ref) */
 	/*   node => refs + procs (proc exit) */
-	int debug_id;
+	struct binder_ref_data data;
 	struct rb_node rb_node_desc;
 	struct rb_node rb_node_node;
 	struct hlist_node node_entry;
 	struct binder_proc *proc;
 	struct binder_node *node;
-	uint32_t desc;
-	int strong;
-	int weak;
 	struct binder_ref_death *death;
 };
 
-struct binder_buffer {
-	struct list_head entry; /* free and allocated entries by address */
-	struct rb_node rb_node; /* free entry by size or allocated entry */
-				/* by address */
-	unsigned free:1;
-	unsigned allow_user_free:1;
-	unsigned async_transaction:1;
-	unsigned debug_id:29;
-
-	struct binder_transaction *transaction;
-
-	struct binder_node *target_node;
-	size_t data_size;
-	size_t offsets_size;
-	uint8_t data[0];
-};
-
 enum binder_deferred_state {
 	BINDER_DEFERRED_PUT_FILES    = 0x01,
 	BINDER_DEFERRED_FLUSH        = 0x02,
 	BINDER_DEFERRED_RELEASE      = 0x04,
 };
 
+/**
+ * struct binder_priority - scheduler policy and priority
+ * @sched_policy            scheduler policy
+ * @prio                    [100..139] for SCHED_NORMAL, [0..99] for FIFO/RT
+ *
+ * The binder driver supports inheriting the following scheduler policies:
+ * SCHED_NORMAL
+ * SCHED_BATCH
+ * SCHED_FIFO
+ * SCHED_RR
+ */
+struct binder_priority {
+	unsigned int sched_policy;
+	int prio;
+};
+
+/**
+ * struct binder_proc - binder process bookkeeping
+ * @proc_node:            element for binder_procs list
+ * @threads:              rbtree of binder_threads in this proc
+ *                        (protected by @inner_lock)
+ * @nodes:                rbtree of binder nodes associated with
+ *                        this proc ordered by node->ptr
+ *                        (protected by @inner_lock)
+ * @refs_by_desc:         rbtree of refs ordered by ref->desc
+ *                        (protected by @outer_lock)
+ * @refs_by_node:         rbtree of refs ordered by ref->node
+ *                        (protected by @outer_lock)
+ * @waiting_threads:      threads currently waiting for proc work
+ *                        (protected by @inner_lock)
+ * @pid                   PID of group_leader of process
+ *                        (invariant after initialized)
+ * @tsk                   task_struct for group_leader of process
+ *                        (invariant after initialized)
+ * @files                 files_struct for process
+ *                        (protected by @files_lock)
+ * @files_lock            mutex to protect @files
+ * @deferred_work_node:   element for binder_deferred_list
+ *                        (protected by binder_deferred_lock)
+ * @deferred_work:        bitmap of deferred work to perform
+ *                        (protected by binder_deferred_lock)
+ * @is_dead:              process is dead and awaiting free
+ *                        when outstanding transactions are cleaned up
+ *                        (protected by @inner_lock)
+ * @todo:                 list of work for this process
+ *                        (protected by @inner_lock)
+ * @stats:                per-process binder statistics
+ *                        (atomics, no lock needed)
+ * @delivered_death:      list of delivered death notification
+ *                        (protected by @inner_lock)
+ * @max_threads:          cap on number of binder threads
+ *                        (protected by @inner_lock)
+ * @requested_threads:    number of binder threads requested but not
+ *                        yet started. In current implementation, can
+ *                        only be 0 or 1.
+ *                        (protected by @inner_lock)
+ * @requested_threads_started: number binder threads started
+ *                        (protected by @inner_lock)
+ * @tmp_ref:              temporary reference to indicate proc is in use
+ *                        (protected by @inner_lock)
+ * @default_priority:     default scheduler priority
+ *                        (invariant after initialized)
+ * @debugfs_entry:        debugfs node
+ * @alloc:                binder allocator bookkeeping
+ * @context:              binder_context for this proc
+ *                        (invariant after initialized)
+ * @inner_lock:           can nest under outer_lock and/or node lock
+ * @outer_lock:           no nesting under innor or node lock
+ *                        Lock order: 1) outer, 2) node, 3) inner
+ *
+ * Bookkeeping structure for binder processes
+ */
 struct binder_proc {
 	struct hlist_node proc_node;
 	struct rb_root threads;
 	struct rb_root nodes;
 	struct rb_root refs_by_desc;
 	struct rb_root refs_by_node;
+	struct list_head waiting_threads;
 	int pid;
-	struct vm_area_struct *vma;
-	struct mm_struct *vma_vm_mm;
 	struct task_struct *tsk;
 	struct files_struct *files;
+	struct mutex files_lock;
 	struct hlist_node deferred_work_node;
 	int deferred_work;
-	void *buffer;
-	ptrdiff_t user_buffer_offset;
+	bool is_dead;
 
-	struct list_head buffers;
-	struct rb_root free_buffers;
-	struct rb_root allocated_buffers;
-	size_t free_async_space;
-
-	struct page **pages;
-	size_t buffer_size;
-	uint32_t buffer_free;
 	struct list_head todo;
-	wait_queue_head_t wait;
 	struct binder_stats stats;
 	struct list_head delivered_death;
 	int max_threads;
 	int requested_threads;
 	int requested_threads_started;
-	int ready_threads;
-	long default_priority;
+	int tmp_ref;
+	struct binder_priority default_priority;
 	struct dentry *debugfs_entry;
+	struct binder_alloc alloc;
+	struct binder_context *context;
+	spinlock_t inner_lock;
+	spinlock_t outer_lock;
 };
 
 enum {
@@ -333,22 +578,63 @@ enum {
 	BINDER_LOOPER_STATE_EXITED      = 0x04,
 	BINDER_LOOPER_STATE_INVALID     = 0x08,
 	BINDER_LOOPER_STATE_WAITING     = 0x10,
-	BINDER_LOOPER_STATE_NEED_RETURN = 0x20
+	BINDER_LOOPER_STATE_POLL        = 0x20,
 };
 
+/**
+ * struct binder_thread - binder thread bookkeeping
+ * @proc:                 binder process for this thread
+ *                        (invariant after initialization)
+ * @rb_node:              element for proc->threads rbtree
+ *                        (protected by @proc->inner_lock)
+ * @waiting_thread_node:  element for @proc->waiting_threads list
+ *                        (protected by @proc->inner_lock)
+ * @pid:                  PID for this thread
+ *                        (invariant after initialization)
+ * @looper:               bitmap of looping state
+ *                        (only accessed by this thread)
+ * @looper_needs_return:  looping thread needs to exit driver
+ *                        (no lock needed)
+ * @transaction_stack:    stack of in-progress transactions for this thread
+ *                        (protected by @proc->inner_lock)
+ * @todo:                 list of work to do for this thread
+ *                        (protected by @proc->inner_lock)
+ * @process_todo:         whether work in @todo should be processed
+ *                        (protected by @proc->inner_lock)
+ * @return_error:         transaction errors reported by this thread
+ *                        (only accessed by this thread)
+ * @reply_error:          transaction errors reported by target thread
+ *                        (protected by @proc->inner_lock)
+ * @wait:                 wait queue for thread work
+ * @stats:                per-thread statistics
+ *                        (atomics, no lock needed)
+ * @tmp_ref:              temporary reference to indicate thread is in use
+ *                        (atomic since @proc->inner_lock cannot
+ *                        always be acquired)
+ * @is_dead:              thread is dead and awaiting free
+ *                        when outstanding transactions are cleaned up
+ *                        (protected by @proc->inner_lock)
+ * @task:                 struct task_struct for this thread
+ *
+ * Bookkeeping structure for binder threads.
+ */
 struct binder_thread {
 	struct binder_proc *proc;
 	struct rb_node rb_node;
+	struct list_head waiting_thread_node;
 	int pid;
-	int looper;
+	int looper;              /* only modified by this thread */
+	bool looper_need_return; /* can be written by other thread */
 	struct binder_transaction *transaction_stack;
 	struct list_head todo;
-	uint32_t return_error; /* Write failed, return error code in read buf */
-	uint32_t return_error2; /* Write failed, return error code in read */
-		/* buffer. Used when sending a reply to a dead process that */
-		/* we are also waiting on */
+	bool process_todo;
+	struct binder_error return_error;
+	struct binder_error reply_error;
 	wait_queue_head_t wait;
 	struct binder_stats stats;
+	atomic_t tmp_ref;
+	bool is_dead;
+	struct task_struct *task;
 };
 
 struct binder_transaction {
@@ -365,30 +651,324 @@ struct binder_transaction {
 	struct binder_buffer *buffer;
 	unsigned int	code;
 	unsigned int	flags;
-	long	priority;
-	long	saved_priority;
+	struct binder_priority	priority;
+	struct binder_priority	saved_priority;
+	bool    set_priority_called;
 	kuid_t	sender_euid;
+	/**
+	 * @lock:  protects @from, @to_proc, and @to_thread
+	 *
+	 * @from, @to_proc, and @to_thread can be set to NULL
+	 * during thread teardown
+	 */
+	spinlock_t lock;
 };
 
+/**
+ * binder_proc_lock() - Acquire outer lock for given binder_proc
+ * @proc:         struct binder_proc to acquire
+ *
+ * Acquires proc->outer_lock. Used to protect binder_ref
+ * structures associated with the given proc.
+ */
+#define binder_proc_lock(proc) _binder_proc_lock(proc, __LINE__)
+static void
+_binder_proc_lock(struct binder_proc *proc, int line)
+{
+	binder_debug(BINDER_DEBUG_SPINLOCKS,
+		     "%s: line=%d\n", __func__, line);
+	spin_lock(&proc->outer_lock);
+}
+
+/**
+ * binder_proc_unlock() - Release spinlock for given binder_proc
+ * @proc:         struct binder_proc to acquire
+ *
+ * Release lock acquired via binder_proc_lock()
+ */
+#define binder_proc_unlock(_proc) _binder_proc_unlock(_proc, __LINE__)
+static void
+_binder_proc_unlock(struct binder_proc *proc, int line)
+{
+	binder_debug(BINDER_DEBUG_SPINLOCKS,
+		     "%s: line=%d\n", __func__, line);
+	spin_unlock(&proc->outer_lock);
+}
+
+/**
+ * binder_inner_proc_lock() - Acquire inner lock for given binder_proc
+ * @proc:         struct binder_proc to acquire
+ *
+ * Acquires proc->inner_lock. Used to protect todo lists
+ */
+#define binder_inner_proc_lock(proc) _binder_inner_proc_lock(proc, __LINE__)
+static void
+_binder_inner_proc_lock(struct binder_proc *proc, int line)
+{
+	binder_debug(BINDER_DEBUG_SPINLOCKS,
+		     "%s: line=%d\n", __func__, line);
+	spin_lock(&proc->inner_lock);
+}
+
+/**
+ * binder_inner_proc_unlock() - Release inner lock for given binder_proc
+ * @proc:         struct binder_proc to acquire
+ *
+ * Release lock acquired via binder_inner_proc_lock()
+ */
+#define binder_inner_proc_unlock(proc) _binder_inner_proc_unlock(proc, __LINE__)
+static void
+_binder_inner_proc_unlock(struct binder_proc *proc, int line)
+{
+	binder_debug(BINDER_DEBUG_SPINLOCKS,
+		     "%s: line=%d\n", __func__, line);
+	spin_unlock(&proc->inner_lock);
+}
+
+/**
+ * binder_node_lock() - Acquire spinlock for given binder_node
+ * @node:         struct binder_node to acquire
+ *
+ * Acquires node->lock. Used to protect binder_node fields
+ */
+#define binder_node_lock(node) _binder_node_lock(node, __LINE__)
+static void
+_binder_node_lock(struct binder_node *node, int line)
+{
+	binder_debug(BINDER_DEBUG_SPINLOCKS,
+		     "%s: line=%d\n", __func__, line);
+	spin_lock(&node->lock);
+}
+
+/**
+ * binder_node_unlock() - Release spinlock for given binder_proc
+ * @node:         struct binder_node to acquire
+ *
+ * Release lock acquired via binder_node_lock()
+ */
+#define binder_node_unlock(node) _binder_node_unlock(node, __LINE__)
+static void
+_binder_node_unlock(struct binder_node *node, int line)
+{
+	binder_debug(BINDER_DEBUG_SPINLOCKS,
+		     "%s: line=%d\n", __func__, line);
+	spin_unlock(&node->lock);
+}
+
+/**
+ * binder_node_inner_lock() - Acquire node and inner locks
+ * @node:         struct binder_node to acquire
+ *
+ * Acquires node->lock. If node->proc also acquires
+ * proc->inner_lock. Used to protect binder_node fields
+ */
+#define binder_node_inner_lock(node) _binder_node_inner_lock(node, __LINE__)
+static void
+_binder_node_inner_lock(struct binder_node *node, int line)
+{
+	binder_debug(BINDER_DEBUG_SPINLOCKS,
+		     "%s: line=%d\n", __func__, line);
+	spin_lock(&node->lock);
+	if (node->proc)
+		binder_inner_proc_lock(node->proc);
+}
+
+/**
+ * binder_node_unlock() - Release node and inner locks
+ * @node:         struct binder_node to acquire
+ *
+ * Release lock acquired via binder_node_lock()
+ */
+#define binder_node_inner_unlock(node) _binder_node_inner_unlock(node, __LINE__)
+static void
+_binder_node_inner_unlock(struct binder_node *node, int line)
+{
+	struct binder_proc *proc = node->proc;
+
+	binder_debug(BINDER_DEBUG_SPINLOCKS,
+		     "%s: line=%d\n", __func__, line);
+	if (proc)
+		binder_inner_proc_unlock(proc);
+	spin_unlock(&node->lock);
+}
+
+static bool binder_worklist_empty_ilocked(struct list_head *list)
+{
+	return list_empty(list);
+}
+
+/**
+ * binder_worklist_empty() - Check if no items on the work list
+ * @proc:       binder_proc associated with list
+ * @list:	list to check
+ *
+ * Return: true if there are no items on list, else false
+ */
+static bool binder_worklist_empty(struct binder_proc *proc,
+				  struct list_head *list)
+{
+	bool ret;
+
+	binder_inner_proc_lock(proc);
+	ret = binder_worklist_empty_ilocked(list);
+	binder_inner_proc_unlock(proc);
+	return ret;
+}
+
+/**
+ * binder_enqueue_work_ilocked() - Add an item to the work list
+ * @work:         struct binder_work to add to list
+ * @target_list:  list to add work to
+ *
+ * Adds the work to the specified list. Asserts that work
+ * is not already on a list.
+ *
+ * Requires the proc->inner_lock to be held.
+ */
+static void
+binder_enqueue_work_ilocked(struct binder_work *work,
+			   struct list_head *target_list)
+{
+	BUG_ON(target_list == NULL);
+	BUG_ON(work->entry.next && !list_empty(&work->entry));
+	list_add_tail(&work->entry, target_list);
+}
+
+/**
+ * binder_enqueue_deferred_thread_work_ilocked() - Add deferred thread work
+ * @thread:       thread to queue work to
+ * @work:         struct binder_work to add to list
+ *
+ * Adds the work to the todo list of the thread. Doesn't set the process_todo
+ * flag, which means that (if it wasn't already set) the thread will go to
+ * sleep without handling this work when it calls read.
+ *
+ * Requires the proc->inner_lock to be held.
+ */
+static void
+binder_enqueue_deferred_thread_work_ilocked(struct binder_thread *thread,
+					    struct binder_work *work)
+{
+	binder_enqueue_work_ilocked(work, &thread->todo);
+}
+
+/**
+ * binder_enqueue_thread_work_ilocked() - Add an item to the thread work list
+ * @thread:       thread to queue work to
+ * @work:         struct binder_work to add to list
+ *
+ * Adds the work to the todo list of the thread, and enables processing
+ * of the todo queue.
+ *
+ * Requires the proc->inner_lock to be held.
+ */
+static void
+binder_enqueue_thread_work_ilocked(struct binder_thread *thread,
+				   struct binder_work *work)
+{
+	binder_enqueue_work_ilocked(work, &thread->todo);
+	thread->process_todo = true;
+}
+
+/**
+ * binder_enqueue_thread_work() - Add an item to the thread work list
+ * @thread:       thread to queue work to
+ * @work:         struct binder_work to add to list
+ *
+ * Adds the work to the todo list of the thread, and enables processing
+ * of the todo queue.
+ */
+static void
+binder_enqueue_thread_work(struct binder_thread *thread,
+			   struct binder_work *work)
+{
+	binder_inner_proc_lock(thread->proc);
+	binder_enqueue_thread_work_ilocked(thread, work);
+	binder_inner_proc_unlock(thread->proc);
+}
+
+static void
+binder_dequeue_work_ilocked(struct binder_work *work)
+{
+	list_del_init(&work->entry);
+}
+
+/**
+ * binder_dequeue_work() - Removes an item from the work list
+ * @proc:         binder_proc associated with list
+ * @work:         struct binder_work to remove from list
+ *
+ * Removes the specified work item from whatever list it is on.
+ * Can safely be called if work is not on any list.
+ */
+static void
+binder_dequeue_work(struct binder_proc *proc, struct binder_work *work)
+{
+	binder_inner_proc_lock(proc);
+	binder_dequeue_work_ilocked(work);
+	binder_inner_proc_unlock(proc);
+}
+
+static struct binder_work *binder_dequeue_work_head_ilocked(
+					struct list_head *list)
+{
+	struct binder_work *w;
+
+	w = list_first_entry_or_null(list, struct binder_work, entry);
+	if (w)
+		list_del_init(&w->entry);
+	return w;
+}
+
+/**
+ * binder_dequeue_work_head() - Dequeues the item at head of list
+ * @proc:         binder_proc associated with list
+ * @list:         list to dequeue head
+ *
+ * Removes the head of the list if there are items on the list
+ *
+ * Return: pointer dequeued binder_work, NULL if list was empty
+ */
+static struct binder_work *binder_dequeue_work_head(
+					struct binder_proc *proc,
+					struct list_head *list)
+{
+	struct binder_work *w;
+
+	binder_inner_proc_lock(proc);
+	w = binder_dequeue_work_head_ilocked(list);
+	binder_inner_proc_unlock(proc);
+	return w;
+}
+
 static void
 binder_defer_work(struct binder_proc *proc, enum binder_deferred_state defer);
+static void binder_free_thread(struct binder_thread *thread);
+static void binder_free_proc(struct binder_proc *proc);
+static void binder_inc_node_tmpref_ilocked(struct binder_node *node);
 
 static int task_get_unused_fd_flags(struct binder_proc *proc, int flags)
 {
-	struct files_struct *files = proc->files;
 	unsigned long rlim_cur;
 	unsigned long irqs;
+	int ret;
 
-	if (files == NULL)
-		return -ESRCH;
-
-	if (!lock_task_sighand(proc->tsk, &irqs))
-		return -EMFILE;
-
+	mutex_lock(&proc->files_lock);
+	if (proc->files == NULL) {
+		ret = -ESRCH;
+		goto err;
+	}
+	if (!lock_task_sighand(proc->tsk, &irqs)) {
+		ret = -EMFILE;
+		goto err;
+	}
 	rlim_cur = task_rlimit(proc->tsk, RLIMIT_NOFILE);
 	unlock_task_sighand(proc->tsk, &irqs);
 
-	return __alloc_fd(files, 0, rlim_cur, flags);
+	ret = __alloc_fd(proc->files, 0, rlim_cur, flags);
+err:
+	mutex_unlock(&proc->files_lock);
+	return ret;
 }
 
 /*
@@ -397,8 +977,10 @@ static int task_get_unused_fd_flags(struct binder_proc *proc, int flags)
 static void task_fd_install(
 	struct binder_proc *proc, unsigned int fd, struct file *file)
 {
+	mutex_lock(&proc->files_lock);
 	if (proc->files)
 		__fd_install(proc->files, fd, file);
+	mutex_unlock(&proc->files_lock);
 }
 
 /*
@@ -408,9 +990,11 @@ static long task_close_fd(struct binder_proc *proc, unsigned int fd)
 {
 	int retval;
 
-	if (proc->files == NULL)
-		return -ESRCH;
-
+	mutex_lock(&proc->files_lock);
+	if (proc->files == NULL) {
+		retval = -ESRCH;
+		goto err;
+	}
 	retval = __close_fd(proc->files, fd);
 	/* can't restart close syscall because file table entry was cleared */
 	if (unlikely(retval == -ERESTARTSYS ||
@@ -418,457 +1002,287 @@ static long task_close_fd(struct binder_proc *proc, unsigned int fd)
 		     retval == -ERESTARTNOHAND ||
 		     retval == -ERESTART_RESTARTBLOCK))
 		retval = -EINTR;
-
+err:
+	mutex_unlock(&proc->files_lock);
 	return retval;
 }
 
-static inline void binder_lock(const char *tag)
+static bool binder_has_work_ilocked(struct binder_thread *thread,
+				    bool do_proc_work)
 {
-	trace_binder_lock(tag);
-	mutex_lock(&binder_main_lock);
-	trace_binder_locked(tag);
+	return thread->process_todo ||
+		thread->looper_need_return ||
+		(do_proc_work &&
+		 !binder_worklist_empty_ilocked(&thread->proc->todo));
 }
 
-static inline void binder_unlock(const char *tag)
+static bool binder_has_work(struct binder_thread *thread, bool do_proc_work)
 {
-	trace_binder_unlock(tag);
-	mutex_unlock(&binder_main_lock);
-}
+	bool has_work;
 
-static void binder_set_nice(long nice)
-{
-	long min_nice;
+	binder_inner_proc_lock(thread->proc);
+	has_work = binder_has_work_ilocked(thread, do_proc_work);
+	binder_inner_proc_unlock(thread->proc);
 
-	if (can_nice(current, nice)) {
-		set_user_nice(current, nice);
-		return;
-	}
-	min_nice = rlimit_to_nice(current->signal->rlim[RLIMIT_NICE].rlim_cur);
-	binder_debug(BINDER_DEBUG_PRIORITY_CAP,
-		     "%d: nice value %ld not allowed use %ld instead\n",
-		      current->pid, nice, min_nice);
-	set_user_nice(current, min_nice);
-	if (min_nice <= MAX_NICE)
-		return;
-	binder_user_error("%d RLIMIT_NICE not set\n", current->pid);
+	return has_work;
 }
 
-static size_t binder_buffer_size(struct binder_proc *proc,
-				 struct binder_buffer *buffer)
+static bool binder_available_for_proc_work_ilocked(struct binder_thread *thread)
 {
-	if (list_is_last(&buffer->entry, &proc->buffers))
-		return proc->buffer + proc->buffer_size - (void *)buffer->data;
-	return (size_t)list_entry(buffer->entry.next,
-			  struct binder_buffer, entry) - (size_t)buffer->data;
+	return !thread->transaction_stack &&
+		binder_worklist_empty_ilocked(&thread->todo) &&
+		(thread->looper & (BINDER_LOOPER_STATE_ENTERED |
+				   BINDER_LOOPER_STATE_REGISTERED));
 }
 
-static void binder_insert_free_buffer(struct binder_proc *proc,
-				      struct binder_buffer *new_buffer)
+static void binder_wakeup_poll_threads_ilocked(struct binder_proc *proc,
+					       bool sync)
 {
-	struct rb_node **p = &proc->free_buffers.rb_node;
-	struct rb_node *parent = NULL;
-	struct binder_buffer *buffer;
-	size_t buffer_size;
-	size_t new_buffer_size;
+	struct rb_node *n;
+	struct binder_thread *thread;
 
-	BUG_ON(!new_buffer->free);
+	for (n = rb_first(&proc->threads); n != NULL; n = rb_next(n)) {
+		thread = rb_entry(n, struct binder_thread, rb_node);
+		if (thread->looper & BINDER_LOOPER_STATE_POLL &&
+		    binder_available_for_proc_work_ilocked(thread)) {
+			if (sync)
+				wake_up_interruptible_sync(&thread->wait);
+			else
+				wake_up_interruptible(&thread->wait);
+		}
+	}
+}
 
-	new_buffer_size = binder_buffer_size(proc, new_buffer);
+/**
+ * binder_select_thread_ilocked() - selects a thread for doing proc work.
+ * @proc:	process to select a thread from
+ *
+ * Note that calling this function moves the thread off the waiting_threads
+ * list, so it can only be woken up by the caller of this function, or a
+ * signal. Therefore, callers *should* always wake up the thread this function
+ * returns.
+ *
+ * Return:	If there's a thread currently waiting for process work,
+ *		returns that thread. Otherwise returns NULL.
+ */
+static struct binder_thread *
+binder_select_thread_ilocked(struct binder_proc *proc)
+{
+	struct binder_thread *thread;
 
-	binder_debug(BINDER_DEBUG_BUFFER_ALLOC,
-		     "%d: add free buffer, size %zd, at %p\n",
-		      proc->pid, new_buffer_size, new_buffer);
+	assert_spin_locked(&proc->inner_lock);
+	thread = list_first_entry_or_null(&proc->waiting_threads,
+					  struct binder_thread,
+					  waiting_thread_node);
 
-	while (*p) {
-		parent = *p;
-		buffer = rb_entry(parent, struct binder_buffer, rb_node);
-		BUG_ON(!buffer->free);
+	if (thread)
+		list_del_init(&thread->waiting_thread_node);
 
-		buffer_size = binder_buffer_size(proc, buffer);
+	return thread;
+}
+
+/**
+ * binder_wakeup_thread_ilocked() - wakes up a thread for doing proc work.
+ * @proc:	process to wake up a thread in
+ * @thread:	specific thread to wake-up (may be NULL)
+ * @sync:	whether to do a synchronous wake-up
+ *
+ * This function wakes up a thread in the @proc process.
+ * The caller may provide a specific thread to wake-up in
+ * the @thread parameter. If @thread is NULL, this function
+ * will wake up threads that have called poll().
+ *
+ * Note that for this function to work as expected, callers
+ * should first call binder_select_thread() to find a thread
+ * to handle the work (if they don't have a thread already),
+ * and pass the result into the @thread parameter.
+ */
+static void binder_wakeup_thread_ilocked(struct binder_proc *proc,
+					 struct binder_thread *thread,
+					 bool sync)
+{
+	assert_spin_locked(&proc->inner_lock);
 
-		if (new_buffer_size < buffer_size)
-			p = &parent->rb_left;
+	if (thread) {
+		if (sync)
+			wake_up_interruptible_sync(&thread->wait);
 		else
-			p = &parent->rb_right;
+			wake_up_interruptible(&thread->wait);
+		return;
 	}
-	rb_link_node(&new_buffer->rb_node, parent, p);
-	rb_insert_color(&new_buffer->rb_node, &proc->free_buffers);
+
+	/* Didn't find a thread waiting for proc work; this can happen
+	 * in two scenarios:
+	 * 1. All threads are busy handling transactions
+	 *    In that case, one of those threads should call back into
+	 *    the kernel driver soon and pick up this work.
+	 * 2. Threads are using the (e)poll interface, in which case
+	 *    they may be blocked on the waitqueue without having been
+	 *    added to waiting_threads. For this case, we just iterate
+	 *    over all threads not handling transaction work, and
+	 *    wake them all up. We wake all because we don't know whether
+	 *    a thread that called into (e)poll is handling non-binder
+	 *    work currently.
+	 */
+	binder_wakeup_poll_threads_ilocked(proc, sync);
 }
 
-static void binder_insert_allocated_buffer(struct binder_proc *proc,
-					   struct binder_buffer *new_buffer)
+static void binder_wakeup_proc_ilocked(struct binder_proc *proc)
 {
-	struct rb_node **p = &proc->allocated_buffers.rb_node;
-	struct rb_node *parent = NULL;
-	struct binder_buffer *buffer;
+	struct binder_thread *thread = binder_select_thread_ilocked(proc);
 
-	BUG_ON(new_buffer->free);
-
-	while (*p) {
-		parent = *p;
-		buffer = rb_entry(parent, struct binder_buffer, rb_node);
-		BUG_ON(buffer->free);
+	binder_wakeup_thread_ilocked(proc, thread, /* sync = */false);
+}
 
-		if (new_buffer < buffer)
-			p = &parent->rb_left;
-		else if (new_buffer > buffer)
-			p = &parent->rb_right;
-		else
-			BUG();
-	}
-	rb_link_node(&new_buffer->rb_node, parent, p);
-	rb_insert_color(&new_buffer->rb_node, &proc->allocated_buffers);
+static bool is_rt_policy(int policy)
+{
+	return policy == SCHED_FIFO || policy == SCHED_RR;
 }
 
-static struct binder_buffer *binder_buffer_lookup(struct binder_proc *proc,
-						  uintptr_t user_ptr)
+static bool is_fair_policy(int policy)
 {
-	struct rb_node *n = proc->allocated_buffers.rb_node;
-	struct binder_buffer *buffer;
-	struct binder_buffer *kern_ptr;
+	return policy == SCHED_NORMAL || policy == SCHED_BATCH;
+}
 
-	kern_ptr = (struct binder_buffer *)(user_ptr - proc->user_buffer_offset
-		- offsetof(struct binder_buffer, data));
+static bool binder_supported_policy(int policy)
+{
+	return is_fair_policy(policy) || is_rt_policy(policy);
+}
 
-	while (n) {
-		buffer = rb_entry(n, struct binder_buffer, rb_node);
-		BUG_ON(buffer->free);
+static int to_userspace_prio(int policy, int kernel_priority)
+{
+	if (is_fair_policy(policy))
+		return PRIO_TO_NICE(kernel_priority);
+	else
+		return MAX_USER_RT_PRIO - 1 - kernel_priority;
+}
 
-		if (kern_ptr < buffer)
-			n = n->rb_left;
-		else if (kern_ptr > buffer)
-			n = n->rb_right;
-		else
-			return buffer;
-	}
-	return NULL;
+static int to_kernel_prio(int policy, int user_priority)
+{
+	if (is_fair_policy(policy))
+		return NICE_TO_PRIO(user_priority);
+	else
+		return MAX_USER_RT_PRIO - 1 - user_priority;
 }
 
-static int binder_update_page_range(struct binder_proc *proc, int allocate,
-				    void *start, void *end,
-				    struct vm_area_struct *vma)
+static void binder_do_set_priority(struct task_struct *task,
+				   struct binder_priority desired,
+				   bool verify)
 {
-	void *page_addr;
-	unsigned long user_page_addr;
-	struct page **page;
-	struct mm_struct *mm;
+	int priority; /* user-space prio value */
+	bool has_cap_nice;
+	unsigned int policy = desired.sched_policy;
 
-	binder_debug(BINDER_DEBUG_BUFFER_ALLOC,
-		     "%d: %s pages %p-%p\n", proc->pid,
-		     allocate ? "allocate" : "free", start, end);
+	if (task->policy == policy && task->normal_prio == desired.prio)
+		return;
 
-	if (end <= start)
-		return 0;
+	has_cap_nice = has_capability_noaudit(task, CAP_SYS_NICE);
 
-	trace_binder_update_page_range(proc, allocate, start, end);
+	priority = to_userspace_prio(policy, desired.prio);
 
-	if (vma)
-		mm = NULL;
-	else
-		mm = get_task_mm(proc->tsk);
+	if (verify && is_rt_policy(policy) && !has_cap_nice) {
+		long max_rtprio = task_rlimit(task, RLIMIT_RTPRIO);
 
-	if (mm) {
-		down_write(&mm->mmap_sem);
-		vma = proc->vma;
-		if (vma && mm != proc->vma_vm_mm) {
-			pr_err("%d: vma mm and task mm mismatch\n",
-				proc->pid);
-			vma = NULL;
+		if (max_rtprio == 0) {
+			policy = SCHED_NORMAL;
+			priority = MIN_NICE;
+		} else if (priority > max_rtprio) {
+			priority = max_rtprio;
 		}
 	}
 
-	if (allocate == 0)
-		goto free_range;
+	if (verify && is_fair_policy(policy) && !has_cap_nice) {
+		long min_nice = rlimit_to_nice(task_rlimit(task, RLIMIT_NICE));
 
-	if (vma == NULL) {
-		pr_err("%d: binder_alloc_buf failed to map pages in userspace, no vma\n",
-			proc->pid);
-		goto err_no_vma;
+		if (min_nice > MAX_NICE) {
+			binder_user_error("%d RLIMIT_NICE not set\n",
+					  task->pid);
+			return;
+		} else if (priority < min_nice) {
+			priority = min_nice;
+		}
 	}
 
-	for (page_addr = start; page_addr < end; page_addr += PAGE_SIZE) {
-		int ret;
+	if (policy != desired.sched_policy ||
+	    to_kernel_prio(policy, priority) != desired.prio)
+		binder_debug(BINDER_DEBUG_PRIORITY_CAP,
+			     "%d: priority %d not allowed, using %d instead\n",
+			      task->pid, desired.prio,
+			      to_kernel_prio(policy, priority));
 
-		page = &proc->pages[(page_addr - proc->buffer) / PAGE_SIZE];
-
-		BUG_ON(*page);
-		*page = alloc_page(GFP_KERNEL | __GFP_HIGHMEM | __GFP_ZERO);
-		if (*page == NULL) {
-			pr_err("%d: binder_alloc_buf failed for page at %p\n",
-				proc->pid, page_addr);
-			goto err_alloc_page_failed;
-		}
-		ret = map_kernel_range_noflush((unsigned long)page_addr,
-					PAGE_SIZE, PAGE_KERNEL, page);
-		flush_cache_vmap((unsigned long)page_addr,
-				(unsigned long)page_addr + PAGE_SIZE);
-		if (ret != 1) {
-			pr_err("%d: binder_alloc_buf failed to map page at %p in kernel\n",
-			       proc->pid, page_addr);
-			goto err_map_kernel_failed;
-		}
-		user_page_addr =
-			(uintptr_t)page_addr + proc->user_buffer_offset;
-		ret = vm_insert_page(vma, user_page_addr, page[0]);
-		if (ret) {
-			pr_err("%d: binder_alloc_buf failed to map page at %lx in userspace\n",
-			       proc->pid, user_page_addr);
-			goto err_vm_insert_page_failed;
-		}
-		/* vm_insert_page does not seem to increment the refcount */
-	}
-	if (mm) {
-		up_write(&mm->mmap_sem);
-		mmput(mm);
-	}
-	return 0;
+	trace_binder_set_priority(task->tgid, task->pid, task->normal_prio,
+				  to_kernel_prio(policy, priority),
+				  desired.prio);
 
-free_range:
-	for (page_addr = end - PAGE_SIZE; page_addr >= start;
-	     page_addr -= PAGE_SIZE) {
-		page = &proc->pages[(page_addr - proc->buffer) / PAGE_SIZE];
-		if (vma)
-			zap_page_range(vma, (uintptr_t)page_addr +
-				proc->user_buffer_offset, PAGE_SIZE, NULL);
-err_vm_insert_page_failed:
-		unmap_kernel_range((unsigned long)page_addr, PAGE_SIZE);
-err_map_kernel_failed:
-		__free_page(*page);
-		*page = NULL;
-err_alloc_page_failed:
-		;
-	}
-err_no_vma:
-	if (mm) {
-		up_write(&mm->mmap_sem);
-		mmput(mm);
-	}
-	return -ENOMEM;
-}
-
-static struct binder_buffer *binder_alloc_buf(struct binder_proc *proc,
-					      size_t data_size,
-					      size_t offsets_size, int is_async)
-{
-	struct rb_node *n = proc->free_buffers.rb_node;
-	struct binder_buffer *buffer;
-	size_t buffer_size;
-	struct rb_node *best_fit = NULL;
-	void *has_page_addr;
-	void *end_page_addr;
-	size_t size;
-
-	if (proc->vma == NULL) {
-		pr_err("%d: binder_alloc_buf, no vma\n",
-		       proc->pid);
-		return NULL;
-	}
+	/* Set the actual priority */
+	if (task->policy != policy || is_rt_policy(policy)) {
+		struct sched_param params;
 
-	size = ALIGN(data_size, sizeof(void *)) +
-		ALIGN(offsets_size, sizeof(void *));
+		params.sched_priority = is_rt_policy(policy) ? priority : 0;
 
-	if (size < data_size || size < offsets_size) {
-		binder_user_error("%d: got transaction with invalid size %zd-%zd\n",
-				proc->pid, data_size, offsets_size);
-		return NULL;
+		sched_setscheduler_nocheck(task,
+					   policy | SCHED_RESET_ON_FORK,
+					   &params);
 	}
+	if (is_fair_policy(policy))
+		set_user_nice(task, priority);
+}
 
-	if (is_async &&
-	    proc->free_async_space < size + sizeof(struct binder_buffer)) {
-		binder_debug(BINDER_DEBUG_BUFFER_ALLOC,
-			     "%d: binder_alloc_buf size %zd failed, no async space left\n",
-			      proc->pid, size);
-		return NULL;
-	}
-
-	while (n) {
-		buffer = rb_entry(n, struct binder_buffer, rb_node);
-		BUG_ON(!buffer->free);
-		buffer_size = binder_buffer_size(proc, buffer);
-
-		if (size < buffer_size) {
-			best_fit = n;
-			n = n->rb_left;
-		} else if (size > buffer_size)
-			n = n->rb_right;
-		else {
-			best_fit = n;
-			break;
-		}
-	}
-	if (best_fit == NULL) {
-		pr_err("%d: binder_alloc_buf size %zd failed, no address space\n",
-			proc->pid, size);
-		return NULL;
-	}
-	if (n == NULL) {
-		buffer = rb_entry(best_fit, struct binder_buffer, rb_node);
-		buffer_size = binder_buffer_size(proc, buffer);
-	}
-
-	binder_debug(BINDER_DEBUG_BUFFER_ALLOC,
-		     "%d: binder_alloc_buf size %zd got buffer %p size %zd\n",
-		      proc->pid, size, buffer, buffer_size);
-
-	has_page_addr =
-		(void *)(((uintptr_t)buffer->data + buffer_size) & PAGE_MASK);
-	if (n == NULL) {
-		if (size + sizeof(struct binder_buffer) + 4 >= buffer_size)
-			buffer_size = size; /* no room for other buffers */
-		else
-			buffer_size = size + sizeof(struct binder_buffer);
-	}
-	end_page_addr =
-		(void *)PAGE_ALIGN((uintptr_t)buffer->data + buffer_size);
-	if (end_page_addr > has_page_addr)
-		end_page_addr = has_page_addr;
-	if (binder_update_page_range(proc, 1,
-	    (void *)PAGE_ALIGN((uintptr_t)buffer->data), end_page_addr, NULL))
-		return NULL;
-
-	rb_erase(best_fit, &proc->free_buffers);
-	buffer->free = 0;
-	binder_insert_allocated_buffer(proc, buffer);
-	if (buffer_size != size) {
-		struct binder_buffer *new_buffer = (void *)buffer->data + size;
-
-		list_add(&new_buffer->entry, &buffer->entry);
-		new_buffer->free = 1;
-		binder_insert_free_buffer(proc, new_buffer);
-	}
-	binder_debug(BINDER_DEBUG_BUFFER_ALLOC,
-		     "%d: binder_alloc_buf size %zd got %p\n",
-		      proc->pid, size, buffer);
-	buffer->data_size = data_size;
-	buffer->offsets_size = offsets_size;
-	buffer->async_transaction = is_async;
-	if (is_async) {
-		proc->free_async_space -= size + sizeof(struct binder_buffer);
-		binder_debug(BINDER_DEBUG_BUFFER_ALLOC_ASYNC,
-			     "%d: binder_alloc_buf size %zd async free %zd\n",
-			      proc->pid, size, proc->free_async_space);
-	}
-
-	return buffer;
-}
-
-static void *buffer_start_page(struct binder_buffer *buffer)
-{
-	return (void *)((uintptr_t)buffer & PAGE_MASK);
-}
-
-static void *buffer_end_page(struct binder_buffer *buffer)
+static void binder_set_priority(struct task_struct *task,
+				struct binder_priority desired)
 {
-	return (void *)(((uintptr_t)(buffer + 1) - 1) & PAGE_MASK);
+	binder_do_set_priority(task, desired, /* verify = */ true);
 }
 
-static void binder_delete_free_buffer(struct binder_proc *proc,
-				      struct binder_buffer *buffer)
+static void binder_restore_priority(struct task_struct *task,
+				    struct binder_priority desired)
 {
-	struct binder_buffer *prev, *next = NULL;
-	int free_page_end = 1;
-	int free_page_start = 1;
-
-	BUG_ON(proc->buffers.next == &buffer->entry);
-	prev = list_entry(buffer->entry.prev, struct binder_buffer, entry);
-	BUG_ON(!prev->free);
-	if (buffer_end_page(prev) == buffer_start_page(buffer)) {
-		free_page_start = 0;
-		if (buffer_end_page(prev) == buffer_end_page(buffer))
-			free_page_end = 0;
-		binder_debug(BINDER_DEBUG_BUFFER_ALLOC,
-			     "%d: merge free, buffer %p share page with %p\n",
-			      proc->pid, buffer, prev);
-	}
-
-	if (!list_is_last(&buffer->entry, &proc->buffers)) {
-		next = list_entry(buffer->entry.next,
-				  struct binder_buffer, entry);
-		if (buffer_start_page(next) == buffer_end_page(buffer)) {
-			free_page_end = 0;
-			if (buffer_start_page(next) ==
-			    buffer_start_page(buffer))
-				free_page_start = 0;
-			binder_debug(BINDER_DEBUG_BUFFER_ALLOC,
-				     "%d: merge free, buffer %p share page with %p\n",
-				      proc->pid, buffer, prev);
-		}
-	}
-	list_del(&buffer->entry);
-	if (free_page_start || free_page_end) {
-		binder_debug(BINDER_DEBUG_BUFFER_ALLOC,
-			     "%d: merge free, buffer %p do not share page%s%s with %p or %p\n",
-			     proc->pid, buffer, free_page_start ? "" : " end",
-			     free_page_end ? "" : " start", prev, next);
-		binder_update_page_range(proc, 0, free_page_start ?
-			buffer_start_page(buffer) : buffer_end_page(buffer),
-			(free_page_end ? buffer_end_page(buffer) :
-			buffer_start_page(buffer)) + PAGE_SIZE, NULL);
-	}
+	binder_do_set_priority(task, desired, /* verify = */ false);
 }
 
-static void binder_free_buf(struct binder_proc *proc,
-			    struct binder_buffer *buffer)
+static void binder_transaction_priority(struct task_struct *task,
+					struct binder_transaction *t,
+					struct binder_priority node_prio,
+					bool inherit_rt)
 {
-	size_t size, buffer_size;
-
-	buffer_size = binder_buffer_size(proc, buffer);
+	struct binder_priority desired_prio = t->priority;
 
-	size = ALIGN(buffer->data_size, sizeof(void *)) +
-		ALIGN(buffer->offsets_size, sizeof(void *));
-
-	binder_debug(BINDER_DEBUG_BUFFER_ALLOC,
-		     "%d: binder_free_buf %p size %zd buffer_size %zd\n",
-		      proc->pid, buffer, size, buffer_size);
-
-	BUG_ON(buffer->free);
-	BUG_ON(size > buffer_size);
-	BUG_ON(buffer->transaction != NULL);
-	BUG_ON((void *)buffer < proc->buffer);
-	BUG_ON((void *)buffer > proc->buffer + proc->buffer_size);
+	if (t->set_priority_called)
+		return;
 
-	if (buffer->async_transaction) {
-		proc->free_async_space += size + sizeof(struct binder_buffer);
+	t->set_priority_called = true;
+	t->saved_priority.sched_policy = task->policy;
+	t->saved_priority.prio = task->normal_prio;
 
-		binder_debug(BINDER_DEBUG_BUFFER_ALLOC_ASYNC,
-			     "%d: binder_free_buf size %zd async free %zd\n",
-			      proc->pid, size, proc->free_async_space);
+	if (!inherit_rt && is_rt_policy(desired_prio.sched_policy)) {
+		desired_prio.prio = NICE_TO_PRIO(0);
+		desired_prio.sched_policy = SCHED_NORMAL;
 	}
 
-	binder_update_page_range(proc, 0,
-		(void *)PAGE_ALIGN((uintptr_t)buffer->data),
-		(void *)(((uintptr_t)buffer->data + buffer_size) & PAGE_MASK),
-		NULL);
-	rb_erase(&buffer->rb_node, &proc->allocated_buffers);
-	buffer->free = 1;
-	if (!list_is_last(&buffer->entry, &proc->buffers)) {
-		struct binder_buffer *next = list_entry(buffer->entry.next,
-						struct binder_buffer, entry);
-
-		if (next->free) {
-			rb_erase(&next->rb_node, &proc->free_buffers);
-			binder_delete_free_buffer(proc, next);
-		}
+	if (node_prio.prio < t->priority.prio ||
+	    (node_prio.prio == t->priority.prio &&
+	     node_prio.sched_policy == SCHED_FIFO)) {
+		/*
+		 * In case the minimum priority on the node is
+		 * higher (lower value), use that priority. If
+		 * the priority is the same, but the node uses
+		 * SCHED_FIFO, prefer SCHED_FIFO, since it can
+		 * run unbounded, unlike SCHED_RR.
+		 */
+		desired_prio = node_prio;
 	}
-	if (proc->buffers.next != &buffer->entry) {
-		struct binder_buffer *prev = list_entry(buffer->entry.prev,
-						struct binder_buffer, entry);
 
-		if (prev->free) {
-			binder_delete_free_buffer(proc, buffer);
-			rb_erase(&prev->rb_node, &proc->free_buffers);
-			buffer = prev;
-		}
-	}
-	binder_insert_free_buffer(proc, buffer);
+	binder_set_priority(task, desired_prio);
 }
 
-static struct binder_node *binder_get_node(struct binder_proc *proc,
-					   binder_uintptr_t ptr)
+static struct binder_node *binder_get_node_ilocked(struct binder_proc *proc,
+						   binder_uintptr_t ptr)
 {
 	struct rb_node *n = proc->nodes.rb_node;
 	struct binder_node *node;
 
+	assert_spin_locked(&proc->inner_lock);
+
 	while (n) {
 		node = rb_entry(n, struct binder_node, rb_node);
 
@@ -876,21 +1290,47 @@ static struct binder_node *binder_get_node(struct binder_proc *proc,
 			n = n->rb_left;
 		else if (ptr > node->ptr)
 			n = n->rb_right;
-		else
+		else {
+			/*
+			 * take an implicit weak reference
+			 * to ensure node stays alive until
+			 * call to binder_put_node()
+			 */
+			binder_inc_node_tmpref_ilocked(node);
 			return node;
+		}
 	}
 	return NULL;
 }
 
-static struct binder_node *binder_new_node(struct binder_proc *proc,
-					   binder_uintptr_t ptr,
-					   binder_uintptr_t cookie)
+static struct binder_node *binder_get_node(struct binder_proc *proc,
+					   binder_uintptr_t ptr)
+{
+	struct binder_node *node;
+
+	binder_inner_proc_lock(proc);
+	node = binder_get_node_ilocked(proc, ptr);
+	binder_inner_proc_unlock(proc);
+	return node;
+}
+
+static struct binder_node *binder_init_node_ilocked(
+						struct binder_proc *proc,
+						struct binder_node *new_node,
+						struct flat_binder_object *fp)
 {
 	struct rb_node **p = &proc->nodes.rb_node;
 	struct rb_node *parent = NULL;
 	struct binder_node *node;
+	binder_uintptr_t ptr = fp ? fp->binder : 0;
+	binder_uintptr_t cookie = fp ? fp->cookie : 0;
+	__u32 flags = fp ? fp->flags : 0;
+	s8 priority;
+
+	assert_spin_locked(&proc->inner_lock);
 
 	while (*p) {
+
 		parent = *p;
 		node = rb_entry(parent, struct binder_node, rb_node);
 
@@ -898,39 +1338,86 @@ static struct binder_node *binder_new_node(struct binder_proc *proc,
 			p = &(*p)->rb_left;
 		else if (ptr > node->ptr)
 			p = &(*p)->rb_right;
-		else
-			return NULL;
+		else {
+			/*
+			 * A matching node is already in
+			 * the rb tree. Abandon the init
+			 * and return it.
+			 */
+			binder_inc_node_tmpref_ilocked(node);
+			return node;
+		}
 	}
-
-	node = kzalloc(sizeof(*node), GFP_KERNEL);
-	if (node == NULL)
-		return NULL;
+	node = new_node;
 	binder_stats_created(BINDER_STAT_NODE);
+	node->tmp_refs++;
 	rb_link_node(&node->rb_node, parent, p);
 	rb_insert_color(&node->rb_node, &proc->nodes);
-	node->debug_id = ++binder_last_id;
+	node->debug_id = atomic_inc_return(&binder_last_id);
 	node->proc = proc;
 	node->ptr = ptr;
 	node->cookie = cookie;
 	node->work.type = BINDER_WORK_NODE;
+	priority = flags & FLAT_BINDER_FLAG_PRIORITY_MASK;
+	node->sched_policy = (flags & FLAT_BINDER_FLAG_SCHED_POLICY_MASK) >>
+		FLAT_BINDER_FLAG_SCHED_POLICY_SHIFT;
+	node->min_priority = to_kernel_prio(node->sched_policy, priority);
+	node->accept_fds = !!(flags & FLAT_BINDER_FLAG_ACCEPTS_FDS);
+	node->inherit_rt = !!(flags & FLAT_BINDER_FLAG_INHERIT_RT);
+	spin_lock_init(&node->lock);
 	INIT_LIST_HEAD(&node->work.entry);
 	INIT_LIST_HEAD(&node->async_todo);
 	binder_debug(BINDER_DEBUG_INTERNAL_REFS,
 		     "%d:%d node %d u%016llx c%016llx created\n",
 		     proc->pid, current->pid, node->debug_id,
 		     (u64)node->ptr, (u64)node->cookie);
+
 	return node;
 }
 
-static int binder_inc_node(struct binder_node *node, int strong, int internal,
-			   struct list_head *target_list)
+static struct binder_node *binder_new_node(struct binder_proc *proc,
+					   struct flat_binder_object *fp)
 {
+	struct binder_node *node;
+	struct binder_node *new_node = kzalloc(sizeof(*node), GFP_KERNEL);
+
+	if (!new_node)
+		return NULL;
+	binder_inner_proc_lock(proc);
+	node = binder_init_node_ilocked(proc, new_node, fp);
+	binder_inner_proc_unlock(proc);
+	if (node != new_node)
+		/*
+		 * The node was already added by another thread
+		 */
+		kfree(new_node);
+
+	return node;
+}
+
+static void binder_free_node(struct binder_node *node)
+{
+	kfree(node);
+	binder_stats_deleted(BINDER_STAT_NODE);
+}
+
+static int binder_inc_node_nilocked(struct binder_node *node, int strong,
+				    int internal,
+				    struct list_head *target_list)
+{
+	struct binder_proc *proc = node->proc;
+
+	assert_spin_locked(&node->lock);
+	if (proc)
+		assert_spin_locked(&proc->inner_lock);
 	if (strong) {
 		if (internal) {
 			if (target_list == NULL &&
 			    node->internal_strong_refs == 0 &&
-			    !(node == binder_context_mgr_node &&
-			    node->has_strong_ref)) {
+			    !(node->proc &&
+			      node == node->proc->context->
+				      binder_context_mgr_node &&
+			      node->has_strong_ref)) {
 				pr_err("invalid inc strong node for %d\n",
 					node->debug_id);
 				return -EINVAL;
@@ -939,8 +1426,19 @@ static int binder_inc_node(struct binder_node *node, int strong, int internal,
 		} else
 			node->local_strong_refs++;
 		if (!node->has_strong_ref && target_list) {
-			list_del_init(&node->work.entry);
-			list_add_tail(&node->work.entry, target_list);
+			binder_dequeue_work_ilocked(&node->work);
+			/*
+			 * Note: this function is the only place where we queue
+			 * directly to a thread->todo without using the
+			 * corresponding binder_enqueue_thread_work() helper
+			 * functions; in this case it's ok to not set the
+			 * process_todo flag, since we know this node work will
+			 * always be followed by other work that starts queue
+			 * processing: in case of synchronous transactions, a
+			 * BR_REPLY or BR_ERROR; in case of oneway
+			 * transactions, a BR_TRANSACTION_COMPLETE.
+			 */
+			binder_enqueue_work_ilocked(&node->work, target_list);
 		}
 	} else {
 		if (!internal)
@@ -951,58 +1449,172 @@ static int binder_inc_node(struct binder_node *node, int strong, int internal,
 					node->debug_id);
 				return -EINVAL;
 			}
-			list_add_tail(&node->work.entry, target_list);
+			/*
+			 * See comment above
+			 */
+			binder_enqueue_work_ilocked(&node->work, target_list);
 		}
 	}
 	return 0;
 }
 
-static int binder_dec_node(struct binder_node *node, int strong, int internal)
+static int binder_inc_node(struct binder_node *node, int strong, int internal,
+			   struct list_head *target_list)
+{
+	int ret;
+
+	binder_node_inner_lock(node);
+	ret = binder_inc_node_nilocked(node, strong, internal, target_list);
+	binder_node_inner_unlock(node);
+
+	return ret;
+}
+
+static bool binder_dec_node_nilocked(struct binder_node *node,
+				     int strong, int internal)
 {
+	struct binder_proc *proc = node->proc;
+
+	assert_spin_locked(&node->lock);
+	if (proc)
+		assert_spin_locked(&proc->inner_lock);
 	if (strong) {
 		if (internal)
 			node->internal_strong_refs--;
 		else
 			node->local_strong_refs--;
 		if (node->local_strong_refs || node->internal_strong_refs)
-			return 0;
+			return false;
 	} else {
 		if (!internal)
 			node->local_weak_refs--;
-		if (node->local_weak_refs || !hlist_empty(&node->refs))
-			return 0;
+		if (node->local_weak_refs || node->tmp_refs ||
+				!hlist_empty(&node->refs))
+			return false;
 	}
-	if (node->proc && (node->has_strong_ref || node->has_weak_ref)) {
+
+	if (proc && (node->has_strong_ref || node->has_weak_ref)) {
 		if (list_empty(&node->work.entry)) {
-			list_add_tail(&node->work.entry, &node->proc->todo);
-			wake_up_interruptible(&node->proc->wait);
+			binder_enqueue_work_ilocked(&node->work, &proc->todo);
+			binder_wakeup_proc_ilocked(proc);
 		}
 	} else {
 		if (hlist_empty(&node->refs) && !node->local_strong_refs &&
-		    !node->local_weak_refs) {
-			list_del_init(&node->work.entry);
-			if (node->proc) {
-				rb_erase(&node->rb_node, &node->proc->nodes);
+		    !node->local_weak_refs && !node->tmp_refs) {
+			if (proc) {
+				binder_dequeue_work_ilocked(&node->work);
+				rb_erase(&node->rb_node, &proc->nodes);
 				binder_debug(BINDER_DEBUG_INTERNAL_REFS,
 					     "refless node %d deleted\n",
 					     node->debug_id);
 			} else {
+				BUG_ON(!list_empty(&node->work.entry));
+				spin_lock(&binder_dead_nodes_lock);
+				/*
+				 * tmp_refs could have changed so
+				 * check it again
+				 */
+				if (node->tmp_refs) {
+					spin_unlock(&binder_dead_nodes_lock);
+					return false;
+				}
 				hlist_del(&node->dead_node);
+				spin_unlock(&binder_dead_nodes_lock);
 				binder_debug(BINDER_DEBUG_INTERNAL_REFS,
 					     "dead node %d deleted\n",
 					     node->debug_id);
 			}
-			kfree(node);
-			binder_stats_deleted(BINDER_STAT_NODE);
+			return true;
 		}
 	}
+	return false;
+}
 
-	return 0;
+static void binder_dec_node(struct binder_node *node, int strong, int internal)
+{
+	bool free_node;
+
+	binder_node_inner_lock(node);
+	free_node = binder_dec_node_nilocked(node, strong, internal);
+	binder_node_inner_unlock(node);
+	if (free_node)
+		binder_free_node(node);
 }
 
+static void binder_inc_node_tmpref_ilocked(struct binder_node *node)
+{
+	/*
+	 * No call to binder_inc_node() is needed since we
+	 * don't need to inform userspace of any changes to
+	 * tmp_refs
+	 */
+	node->tmp_refs++;
+}
+
+/**
+ * binder_inc_node_tmpref() - take a temporary reference on node
+ * @node:	node to reference
+ *
+ * Take reference on node to prevent the node from being freed
+ * while referenced only by a local variable. The inner lock is
+ * needed to serialize with the node work on the queue (which
+ * isn't needed after the node is dead). If the node is dead
+ * (node->proc is NULL), use binder_dead_nodes_lock to protect
+ * node->tmp_refs against dead-node-only cases where the node
+ * lock cannot be acquired (eg traversing the dead node list to
+ * print nodes)
+ */
+static void binder_inc_node_tmpref(struct binder_node *node)
+{
+	binder_node_lock(node);
+	if (node->proc)
+		binder_inner_proc_lock(node->proc);
+	else
+		spin_lock(&binder_dead_nodes_lock);
+	binder_inc_node_tmpref_ilocked(node);
+	if (node->proc)
+		binder_inner_proc_unlock(node->proc);
+	else
+		spin_unlock(&binder_dead_nodes_lock);
+	binder_node_unlock(node);
+}
+
+/**
+ * binder_dec_node_tmpref() - remove a temporary reference on node
+ * @node:	node to reference
+ *
+ * Release temporary reference on node taken via binder_inc_node_tmpref()
+ */
+static void binder_dec_node_tmpref(struct binder_node *node)
+{
+	bool free_node;
+
+	binder_node_inner_lock(node);
+	if (!node->proc)
+		spin_lock(&binder_dead_nodes_lock);
+	node->tmp_refs--;
+	BUG_ON(node->tmp_refs < 0);
+	if (!node->proc)
+		spin_unlock(&binder_dead_nodes_lock);
+	/*
+	 * Call binder_dec_node() to check if all refcounts are 0
+	 * and cleanup is needed. Calling with strong=0 and internal=1
+	 * causes no actual reference to be released in binder_dec_node().
+	 * If that changes, a change is needed here too.
+	 */
+	free_node = binder_dec_node_nilocked(node, 0, 1);
+	binder_node_inner_unlock(node);
+	if (free_node)
+		binder_free_node(node);
+}
 
-static struct binder_ref *binder_get_ref(struct binder_proc *proc,
-					 u32 desc, bool need_strong_ref)
+static void binder_put_node(struct binder_node *node)
+{
+	binder_dec_node_tmpref(node);
+}
+
+static struct binder_ref *binder_get_ref_olocked(struct binder_proc *proc,
+						 u32 desc, bool need_strong_ref)
 {
 	struct rb_node *n = proc->refs_by_desc.rb_node;
 	struct binder_ref *ref;
@@ -1010,11 +1622,11 @@ static struct binder_ref *binder_get_ref(struct binder_proc *proc,
 	while (n) {
 		ref = rb_entry(n, struct binder_ref, rb_node_desc);
 
-		if (desc < ref->desc) {
+		if (desc < ref->data.desc) {
 			n = n->rb_left;
-		} else if (desc > ref->desc) {
+		} else if (desc > ref->data.desc) {
 			n = n->rb_right;
-		} else if (need_strong_ref && !ref->strong) {
+		} else if (need_strong_ref && !ref->data.strong) {
 			binder_user_error("tried to use weak ref as strong ref\n");
 			return NULL;
 		} else {
@@ -1024,13 +1636,34 @@ static struct binder_ref *binder_get_ref(struct binder_proc *proc,
 	return NULL;
 }
 
-static struct binder_ref *binder_get_ref_for_node(struct binder_proc *proc,
-						  struct binder_node *node)
+/**
+ * binder_get_ref_for_node_olocked() - get the ref associated with given node
+ * @proc:	binder_proc that owns the ref
+ * @node:	binder_node of target
+ * @new_ref:	newly allocated binder_ref to be initialized or %NULL
+ *
+ * Look up the ref for the given node and return it if it exists
+ *
+ * If it doesn't exist and the caller provides a newly allocated
+ * ref, initialize the fields of the newly allocated ref and insert
+ * into the given proc rb_trees and node refs list.
+ *
+ * Return:	the ref for node. It is possible that another thread
+ *		allocated/initialized the ref first in which case the
+ *		returned ref would be different than the passed-in
+ *		new_ref. new_ref must be kfree'd by the caller in
+ *		this case.
+ */
+static struct binder_ref *binder_get_ref_for_node_olocked(
+					struct binder_proc *proc,
+					struct binder_node *node,
+					struct binder_ref *new_ref)
 {
-	struct rb_node *n;
+	struct binder_context *context = proc->context;
 	struct rb_node **p = &proc->refs_by_node.rb_node;
 	struct rb_node *parent = NULL;
-	struct binder_ref *ref, *new_ref;
+	struct binder_ref *ref;
+	struct rb_node *n;
 
 	while (*p) {
 		parent = *p;
@@ -1043,22 +1676,22 @@ static struct binder_ref *binder_get_ref_for_node(struct binder_proc *proc,
 		else
 			return ref;
 	}
-	new_ref = kzalloc(sizeof(*ref), GFP_KERNEL);
-	if (new_ref == NULL)
+	if (!new_ref)
 		return NULL;
+
 	binder_stats_created(BINDER_STAT_REF);
-	new_ref->debug_id = ++binder_last_id;
+	new_ref->data.debug_id = atomic_inc_return(&binder_last_id);
 	new_ref->proc = proc;
 	new_ref->node = node;
 	rb_link_node(&new_ref->rb_node_node, parent, p);
 	rb_insert_color(&new_ref->rb_node_node, &proc->refs_by_node);
 
-	new_ref->desc = (node == binder_context_mgr_node) ? 0 : 1;
+	new_ref->data.desc = (node == context->binder_context_mgr_node) ? 0 : 1;
 	for (n = rb_first(&proc->refs_by_desc); n != NULL; n = rb_next(n)) {
 		ref = rb_entry(n, struct binder_ref, rb_node_desc);
-		if (ref->desc > new_ref->desc)
+		if (ref->data.desc > new_ref->data.desc)
 			break;
-		new_ref->desc = ref->desc + 1;
+		new_ref->data.desc = ref->data.desc + 1;
 	}
 
 	p = &proc->refs_by_desc.rb_node;
@@ -1066,309 +1699,1254 @@ static struct binder_ref *binder_get_ref_for_node(struct binder_proc *proc,
 		parent = *p;
 		ref = rb_entry(parent, struct binder_ref, rb_node_desc);
 
-		if (new_ref->desc < ref->desc)
+		if (new_ref->data.desc < ref->data.desc)
 			p = &(*p)->rb_left;
-		else if (new_ref->desc > ref->desc)
+		else if (new_ref->data.desc > ref->data.desc)
 			p = &(*p)->rb_right;
 		else
 			BUG();
 	}
 	rb_link_node(&new_ref->rb_node_desc, parent, p);
 	rb_insert_color(&new_ref->rb_node_desc, &proc->refs_by_desc);
-	if (node) {
-		hlist_add_head(&new_ref->node_entry, &node->refs);
 
-		binder_debug(BINDER_DEBUG_INTERNAL_REFS,
-			     "%d new ref %d desc %d for node %d\n",
-			      proc->pid, new_ref->debug_id, new_ref->desc,
-			      node->debug_id);
-	} else {
-		binder_debug(BINDER_DEBUG_INTERNAL_REFS,
-			     "%d new ref %d desc %d for dead node\n",
-			      proc->pid, new_ref->debug_id, new_ref->desc);
-	}
+	binder_node_lock(node);
+	hlist_add_head(&new_ref->node_entry, &node->refs);
+
+	binder_debug(BINDER_DEBUG_INTERNAL_REFS,
+		     "%d new ref %d desc %d for node %d\n",
+		      proc->pid, new_ref->data.debug_id, new_ref->data.desc,
+		      node->debug_id);
+	binder_node_unlock(node);
 	return new_ref;
 }
 
-static void binder_delete_ref(struct binder_ref *ref)
+static void binder_cleanup_ref_olocked(struct binder_ref *ref)
 {
+	bool delete_node = false;
+
 	binder_debug(BINDER_DEBUG_INTERNAL_REFS,
 		     "%d delete ref %d desc %d for node %d\n",
-		      ref->proc->pid, ref->debug_id, ref->desc,
+		      ref->proc->pid, ref->data.debug_id, ref->data.desc,
 		      ref->node->debug_id);
 
 	rb_erase(&ref->rb_node_desc, &ref->proc->refs_by_desc);
 	rb_erase(&ref->rb_node_node, &ref->proc->refs_by_node);
-	if (ref->strong)
-		binder_dec_node(ref->node, 1, 1);
+
+	binder_node_inner_lock(ref->node);
+	if (ref->data.strong)
+		binder_dec_node_nilocked(ref->node, 1, 1);
+
 	hlist_del(&ref->node_entry);
-	binder_dec_node(ref->node, 0, 1);
+	delete_node = binder_dec_node_nilocked(ref->node, 0, 1);
+	binder_node_inner_unlock(ref->node);
+	/*
+	 * Clear ref->node unless we want the caller to free the node
+	 */
+	if (!delete_node) {
+		/*
+		 * The caller uses ref->node to determine
+		 * whether the node needs to be freed. Clear
+		 * it since the node is still alive.
+		 */
+		ref->node = NULL;
+	}
+
 	if (ref->death) {
 		binder_debug(BINDER_DEBUG_DEAD_BINDER,
 			     "%d delete ref %d desc %d has death notification\n",
-			      ref->proc->pid, ref->debug_id, ref->desc);
-		list_del(&ref->death->work.entry);
-		kfree(ref->death);
+			      ref->proc->pid, ref->data.debug_id,
+			      ref->data.desc);
+		binder_dequeue_work(ref->proc, &ref->death->work);
 		binder_stats_deleted(BINDER_STAT_DEATH);
 	}
-	kfree(ref);
 	binder_stats_deleted(BINDER_STAT_REF);
 }
 
-static int binder_inc_ref(struct binder_ref *ref, int strong,
-			  struct list_head *target_list)
+/**
+ * binder_inc_ref_olocked() - increment the ref for given handle
+ * @ref:         ref to be incremented
+ * @strong:      if true, strong increment, else weak
+ * @target_list: list to queue node work on
+ *
+ * Increment the ref. @ref->proc->outer_lock must be held on entry
+ *
+ * Return: 0, if successful, else errno
+ */
+static int binder_inc_ref_olocked(struct binder_ref *ref, int strong,
+				  struct list_head *target_list)
 {
 	int ret;
 
 	if (strong) {
-		if (ref->strong == 0) {
+		if (ref->data.strong == 0) {
 			ret = binder_inc_node(ref->node, 1, 1, target_list);
 			if (ret)
 				return ret;
 		}
-		ref->strong++;
+		ref->data.strong++;
 	} else {
-		if (ref->weak == 0) {
+		if (ref->data.weak == 0) {
 			ret = binder_inc_node(ref->node, 0, 1, target_list);
 			if (ret)
 				return ret;
 		}
-		ref->weak++;
+		ref->data.weak++;
 	}
 	return 0;
 }
 
-
-static int binder_dec_ref(struct binder_ref *ref, int strong)
+/**
+ * binder_dec_ref() - dec the ref for given handle
+ * @ref:	ref to be decremented
+ * @strong:	if true, strong decrement, else weak
+ *
+ * Decrement the ref.
+ *
+ * Return: true if ref is cleaned up and ready to be freed
+ */
+static bool binder_dec_ref_olocked(struct binder_ref *ref, int strong)
 {
 	if (strong) {
-		if (ref->strong == 0) {
+		if (ref->data.strong == 0) {
 			binder_user_error("%d invalid dec strong, ref %d desc %d s %d w %d\n",
-					  ref->proc->pid, ref->debug_id,
-					  ref->desc, ref->strong, ref->weak);
-			return -EINVAL;
+					  ref->proc->pid, ref->data.debug_id,
+					  ref->data.desc, ref->data.strong,
+					  ref->data.weak);
+			return false;
 		}
-		ref->strong--;
-		if (ref->strong == 0) {
-			int ret;
+		ref->data.strong--;
+		if (ref->data.strong == 0)
+			binder_dec_node(ref->node, strong, 1);
+	} else {
+		if (ref->data.weak == 0) {
+			binder_user_error("%d invalid dec weak, ref %d desc %d s %d w %d\n",
+					  ref->proc->pid, ref->data.debug_id,
+					  ref->data.desc, ref->data.strong,
+					  ref->data.weak);
+			return false;
+		}
+		ref->data.weak--;
+	}
+	if (ref->data.strong == 0 && ref->data.weak == 0) {
+		binder_cleanup_ref_olocked(ref);
+		return true;
+	}
+	return false;
+}
 
-			ret = binder_dec_node(ref->node, strong, 1);
-			if (ret)
-				return ret;
+/**
+ * binder_get_node_from_ref() - get the node from the given proc/desc
+ * @proc:	proc containing the ref
+ * @desc:	the handle associated with the ref
+ * @need_strong_ref: if true, only return node if ref is strong
+ * @rdata:	the id/refcount data for the ref
+ *
+ * Given a proc and ref handle, return the associated binder_node
+ *
+ * Return: a binder_node or NULL if not found or not strong when strong required
+ */
+static struct binder_node *binder_get_node_from_ref(
+		struct binder_proc *proc,
+		u32 desc, bool need_strong_ref,
+		struct binder_ref_data *rdata)
+{
+	struct binder_node *node;
+	struct binder_ref *ref;
+
+	binder_proc_lock(proc);
+	ref = binder_get_ref_olocked(proc, desc, need_strong_ref);
+	if (!ref)
+		goto err_no_ref;
+	node = ref->node;
+	/*
+	 * Take an implicit reference on the node to ensure
+	 * it stays alive until the call to binder_put_node()
+	 */
+	binder_inc_node_tmpref(node);
+	if (rdata)
+		*rdata = ref->data;
+	binder_proc_unlock(proc);
+
+	return node;
+
+err_no_ref:
+	binder_proc_unlock(proc);
+	return NULL;
+}
+
+/**
+ * binder_free_ref() - free the binder_ref
+ * @ref:	ref to free
+ *
+ * Free the binder_ref. Free the binder_node indicated by ref->node
+ * (if non-NULL) and the binder_ref_death indicated by ref->death.
+ */
+static void binder_free_ref(struct binder_ref *ref)
+{
+	if (ref->node)
+		binder_free_node(ref->node);
+	kfree(ref->death);
+	kfree(ref);
+}
+
+/**
+ * binder_update_ref_for_handle() - inc/dec the ref for given handle
+ * @proc:	proc containing the ref
+ * @desc:	the handle associated with the ref
+ * @increment:	true=inc reference, false=dec reference
+ * @strong:	true=strong reference, false=weak reference
+ * @rdata:	the id/refcount data for the ref
+ *
+ * Given a proc and ref handle, increment or decrement the ref
+ * according to "increment" arg.
+ *
+ * Return: 0 if successful, else errno
+ */
+static int binder_update_ref_for_handle(struct binder_proc *proc,
+		uint32_t desc, bool increment, bool strong,
+		struct binder_ref_data *rdata)
+{
+	int ret = 0;
+	struct binder_ref *ref;
+	bool delete_ref = false;
+
+	binder_proc_lock(proc);
+	ref = binder_get_ref_olocked(proc, desc, strong);
+	if (!ref) {
+		ret = -EINVAL;
+		goto err_no_ref;
+	}
+	if (increment)
+		ret = binder_inc_ref_olocked(ref, strong, NULL);
+	else
+		delete_ref = binder_dec_ref_olocked(ref, strong);
+
+	if (rdata)
+		*rdata = ref->data;
+	binder_proc_unlock(proc);
+
+	if (delete_ref)
+		binder_free_ref(ref);
+	return ret;
+
+err_no_ref:
+	binder_proc_unlock(proc);
+	return ret;
+}
+
+/**
+ * binder_dec_ref_for_handle() - dec the ref for given handle
+ * @proc:	proc containing the ref
+ * @desc:	the handle associated with the ref
+ * @strong:	true=strong reference, false=weak reference
+ * @rdata:	the id/refcount data for the ref
+ *
+ * Just calls binder_update_ref_for_handle() to decrement the ref.
+ *
+ * Return: 0 if successful, else errno
+ */
+static int binder_dec_ref_for_handle(struct binder_proc *proc,
+		uint32_t desc, bool strong, struct binder_ref_data *rdata)
+{
+	return binder_update_ref_for_handle(proc, desc, false, strong, rdata);
+}
+
+
+/**
+ * binder_inc_ref_for_node() - increment the ref for given proc/node
+ * @proc:	 proc containing the ref
+ * @node:	 target node
+ * @strong:	 true=strong reference, false=weak reference
+ * @target_list: worklist to use if node is incremented
+ * @rdata:	 the id/refcount data for the ref
+ *
+ * Given a proc and node, increment the ref. Create the ref if it
+ * doesn't already exist
+ *
+ * Return: 0 if successful, else errno
+ */
+static int binder_inc_ref_for_node(struct binder_proc *proc,
+			struct binder_node *node,
+			bool strong,
+			struct list_head *target_list,
+			struct binder_ref_data *rdata)
+{
+	struct binder_ref *ref;
+	struct binder_ref *new_ref = NULL;
+	int ret = 0;
+
+	binder_proc_lock(proc);
+	ref = binder_get_ref_for_node_olocked(proc, node, NULL);
+	if (!ref) {
+		binder_proc_unlock(proc);
+		new_ref = kzalloc(sizeof(*ref), GFP_KERNEL);
+		if (!new_ref)
+			return -ENOMEM;
+		binder_proc_lock(proc);
+		ref = binder_get_ref_for_node_olocked(proc, node, new_ref);
+	}
+	ret = binder_inc_ref_olocked(ref, strong, target_list);
+	*rdata = ref->data;
+	binder_proc_unlock(proc);
+	if (new_ref && ref != new_ref)
+		/*
+		 * Another thread created the ref first so
+		 * free the one we allocated
+		 */
+		kfree(new_ref);
+	return ret;
+}
+
+static void binder_pop_transaction_ilocked(struct binder_thread *target_thread,
+					   struct binder_transaction *t)
+{
+	BUG_ON(!target_thread);
+	assert_spin_locked(&target_thread->proc->inner_lock);
+	BUG_ON(target_thread->transaction_stack != t);
+	BUG_ON(target_thread->transaction_stack->from != target_thread);
+	target_thread->transaction_stack =
+		target_thread->transaction_stack->from_parent;
+	t->from = NULL;
+}
+
+/**
+ * binder_thread_dec_tmpref() - decrement thread->tmp_ref
+ * @thread:	thread to decrement
+ *
+ * A thread needs to be kept alive while being used to create or
+ * handle a transaction. binder_get_txn_from() is used to safely
+ * extract t->from from a binder_transaction and keep the thread
+ * indicated by t->from from being freed. When done with that
+ * binder_thread, this function is called to decrement the
+ * tmp_ref and free if appropriate (thread has been released
+ * and no transaction being processed by the driver)
+ */
+static void binder_thread_dec_tmpref(struct binder_thread *thread)
+{
+	/*
+	 * atomic is used to protect the counter value while
+	 * it cannot reach zero or thread->is_dead is false
+	 */
+	binder_inner_proc_lock(thread->proc);
+	atomic_dec(&thread->tmp_ref);
+	if (thread->is_dead && !atomic_read(&thread->tmp_ref)) {
+		binder_inner_proc_unlock(thread->proc);
+		binder_free_thread(thread);
+		return;
+	}
+	binder_inner_proc_unlock(thread->proc);
+}
+
+/**
+ * binder_proc_dec_tmpref() - decrement proc->tmp_ref
+ * @proc:	proc to decrement
+ *
+ * A binder_proc needs to be kept alive while being used to create or
+ * handle a transaction. proc->tmp_ref is incremented when
+ * creating a new transaction or the binder_proc is currently in-use
+ * by threads that are being released. When done with the binder_proc,
+ * this function is called to decrement the counter and free the
+ * proc if appropriate (proc has been released, all threads have
+ * been released and not currenly in-use to process a transaction).
+ */
+static void binder_proc_dec_tmpref(struct binder_proc *proc)
+{
+	binder_inner_proc_lock(proc);
+	proc->tmp_ref--;
+	if (proc->is_dead && RB_EMPTY_ROOT(&proc->threads) &&
+			!proc->tmp_ref) {
+		binder_inner_proc_unlock(proc);
+		binder_free_proc(proc);
+		return;
+	}
+	binder_inner_proc_unlock(proc);
+}
+
+/**
+ * binder_get_txn_from() - safely extract the "from" thread in transaction
+ * @t:	binder transaction for t->from
+ *
+ * Atomically return the "from" thread and increment the tmp_ref
+ * count for the thread to ensure it stays alive until
+ * binder_thread_dec_tmpref() is called.
+ *
+ * Return: the value of t->from
+ */
+static struct binder_thread *binder_get_txn_from(
+		struct binder_transaction *t)
+{
+	struct binder_thread *from;
+
+	spin_lock(&t->lock);
+	from = t->from;
+	if (from)
+		atomic_inc(&from->tmp_ref);
+	spin_unlock(&t->lock);
+	return from;
+}
+
+/**
+ * binder_get_txn_from_and_acq_inner() - get t->from and acquire inner lock
+ * @t:	binder transaction for t->from
+ *
+ * Same as binder_get_txn_from() except it also acquires the proc->inner_lock
+ * to guarantee that the thread cannot be released while operating on it.
+ * The caller must call binder_inner_proc_unlock() to release the inner lock
+ * as well as call binder_dec_thread_txn() to release the reference.
+ *
+ * Return: the value of t->from
+ */
+static struct binder_thread *binder_get_txn_from_and_acq_inner(
+		struct binder_transaction *t)
+{
+	struct binder_thread *from;
+
+	from = binder_get_txn_from(t);
+	if (!from)
+		return NULL;
+	binder_inner_proc_lock(from->proc);
+	if (t->from) {
+		BUG_ON(from != t->from);
+		return from;
+	}
+	binder_inner_proc_unlock(from->proc);
+	binder_thread_dec_tmpref(from);
+	return NULL;
+}
+
+static void binder_free_transaction(struct binder_transaction *t)
+{
+	if (t->buffer)
+		t->buffer->transaction = NULL;
+	kfree(t);
+	binder_stats_deleted(BINDER_STAT_TRANSACTION);
+}
+
+static void binder_send_failed_reply(struct binder_transaction *t,
+				     uint32_t error_code)
+{
+	struct binder_thread *target_thread;
+	struct binder_transaction *next;
+
+	BUG_ON(t->flags & TF_ONE_WAY);
+	while (1) {
+		target_thread = binder_get_txn_from_and_acq_inner(t);
+		if (target_thread) {
+			binder_debug(BINDER_DEBUG_FAILED_TRANSACTION,
+				     "send failed reply for transaction %d to %d:%d\n",
+				      t->debug_id,
+				      target_thread->proc->pid,
+				      target_thread->pid);
+
+			binder_pop_transaction_ilocked(target_thread, t);
+			if (target_thread->reply_error.cmd == BR_OK) {
+				target_thread->reply_error.cmd = error_code;
+				binder_enqueue_thread_work_ilocked(
+					target_thread,
+					&target_thread->reply_error.work);
+				wake_up_interruptible(&target_thread->wait);
+			} else {
+				/*
+				 * Cannot get here for normal operation, but
+				 * we can if multiple synchronous transactions
+				 * are sent without blocking for responses.
+				 * Just ignore the 2nd error in this case.
+				 */
+				pr_warn("Unexpected reply error: %u\n",
+					target_thread->reply_error.cmd);
+			}
+			binder_inner_proc_unlock(target_thread->proc);
+			binder_thread_dec_tmpref(target_thread);
+			binder_free_transaction(t);
+			return;
+		}
+		next = t->from_parent;
+
+		binder_debug(BINDER_DEBUG_FAILED_TRANSACTION,
+			     "send failed reply for transaction %d, target dead\n",
+			     t->debug_id);
+
+		binder_free_transaction(t);
+		if (next == NULL) {
+			binder_debug(BINDER_DEBUG_DEAD_BINDER,
+				     "reply failed, no target thread at root\n");
+			return;
 		}
+		t = next;
+		binder_debug(BINDER_DEBUG_DEAD_BINDER,
+			     "reply failed, no target thread -- retry %d\n",
+			      t->debug_id);
+	}
+}
+
+/**
+ * binder_cleanup_transaction() - cleans up undelivered transaction
+ * @t:		transaction that needs to be cleaned up
+ * @reason:	reason the transaction wasn't delivered
+ * @error_code:	error to return to caller (if synchronous call)
+ */
+static void binder_cleanup_transaction(struct binder_transaction *t,
+				       const char *reason,
+				       uint32_t error_code)
+{
+	if (t->buffer->target_node && !(t->flags & TF_ONE_WAY)) {
+		binder_send_failed_reply(t, error_code);
 	} else {
-		if (ref->weak == 0) {
-			binder_user_error("%d invalid dec weak, ref %d desc %d s %d w %d\n",
-					  ref->proc->pid, ref->debug_id,
-					  ref->desc, ref->strong, ref->weak);
-			return -EINVAL;
+		binder_debug(BINDER_DEBUG_DEAD_TRANSACTION,
+			"undelivered transaction %d, %s\n",
+			t->debug_id, reason);
+		binder_free_transaction(t);
+	}
+}
+
+/**
+ * binder_validate_object() - checks for a valid metadata object in a buffer.
+ * @buffer:	binder_buffer that we're parsing.
+ * @offset:	offset in the buffer at which to validate an object.
+ *
+ * Return:	If there's a valid metadata object at @offset in @buffer, the
+ *		size of that object. Otherwise, it returns zero.
+ */
+static size_t binder_validate_object(struct binder_buffer *buffer, u64 offset)
+{
+	/* Check if we can read a header first */
+	struct binder_object_header *hdr;
+	size_t object_size = 0;
+
+	if (buffer->data_size < sizeof(*hdr) ||
+	    offset > buffer->data_size - sizeof(*hdr) ||
+	    !IS_ALIGNED(offset, sizeof(u32)))
+		return 0;
+
+	/* Ok, now see if we can read a complete object. */
+	hdr = (struct binder_object_header *)(buffer->data + offset);
+	switch (hdr->type) {
+	case BINDER_TYPE_BINDER:
+	case BINDER_TYPE_WEAK_BINDER:
+	case BINDER_TYPE_HANDLE:
+	case BINDER_TYPE_WEAK_HANDLE:
+		object_size = sizeof(struct flat_binder_object);
+		break;
+	case BINDER_TYPE_FD:
+		object_size = sizeof(struct binder_fd_object);
+		break;
+	case BINDER_TYPE_PTR:
+		object_size = sizeof(struct binder_buffer_object);
+		break;
+	case BINDER_TYPE_FDA:
+		object_size = sizeof(struct binder_fd_array_object);
+		break;
+	default:
+		return 0;
+	}
+	if (offset <= buffer->data_size - object_size &&
+	    buffer->data_size >= object_size)
+		return object_size;
+	else
+		return 0;
+}
+
+/**
+ * binder_validate_ptr() - validates binder_buffer_object in a binder_buffer.
+ * @b:		binder_buffer containing the object
+ * @index:	index in offset array at which the binder_buffer_object is
+ *		located
+ * @start:	points to the start of the offset array
+ * @num_valid:	the number of valid offsets in the offset array
+ *
+ * Return:	If @index is within the valid range of the offset array
+ *		described by @start and @num_valid, and if there's a valid
+ *		binder_buffer_object at the offset found in index @index
+ *		of the offset array, that object is returned. Otherwise,
+ *		%NULL is returned.
+ *		Note that the offset found in index @index itself is not
+ *		verified; this function assumes that @num_valid elements
+ *		from @start were previously verified to have valid offsets.
+ */
+static struct binder_buffer_object *binder_validate_ptr(struct binder_buffer *b,
+							binder_size_t index,
+							binder_size_t *start,
+							binder_size_t num_valid)
+{
+	struct binder_buffer_object *buffer_obj;
+	binder_size_t *offp;
+
+	if (index >= num_valid)
+		return NULL;
+
+	offp = start + index;
+	buffer_obj = (struct binder_buffer_object *)(b->data + *offp);
+	if (buffer_obj->hdr.type != BINDER_TYPE_PTR)
+		return NULL;
+
+	return buffer_obj;
+}
+
+/**
+ * binder_validate_fixup() - validates pointer/fd fixups happen in order.
+ * @b:			transaction buffer
+ * @objects_start	start of objects buffer
+ * @buffer:		binder_buffer_object in which to fix up
+ * @offset:		start offset in @buffer to fix up
+ * @last_obj:		last binder_buffer_object that we fixed up in
+ * @last_min_offset:	minimum fixup offset in @last_obj
+ *
+ * Return:		%true if a fixup in buffer @buffer at offset @offset is
+ *			allowed.
+ *
+ * For safety reasons, we only allow fixups inside a buffer to happen
+ * at increasing offsets; additionally, we only allow fixup on the last
+ * buffer object that was verified, or one of its parents.
+ *
+ * Example of what is allowed:
+ *
+ * A
+ *   B (parent = A, offset = 0)
+ *   C (parent = A, offset = 16)
+ *     D (parent = C, offset = 0)
+ *   E (parent = A, offset = 32) // min_offset is 16 (C.parent_offset)
+ *
+ * Examples of what is not allowed:
+ *
+ * Decreasing offsets within the same parent:
+ * A
+ *   C (parent = A, offset = 16)
+ *   B (parent = A, offset = 0) // decreasing offset within A
+ *
+ * Referring to a parent that wasn't the last object or any of its parents:
+ * A
+ *   B (parent = A, offset = 0)
+ *   C (parent = A, offset = 0)
+ *   C (parent = A, offset = 16)
+ *     D (parent = B, offset = 0) // B is not A or any of A's parents
+ */
+static bool binder_validate_fixup(struct binder_buffer *b,
+				  binder_size_t *objects_start,
+				  struct binder_buffer_object *buffer,
+				  binder_size_t fixup_offset,
+				  struct binder_buffer_object *last_obj,
+				  binder_size_t last_min_offset)
+{
+	if (!last_obj) {
+		/* Nothing to fix up in */
+		return false;
+	}
+
+	while (last_obj != buffer) {
+		/*
+		 * Safe to retrieve the parent of last_obj, since it
+		 * was already previously verified by the driver.
+		 */
+		if ((last_obj->flags & BINDER_BUFFER_FLAG_HAS_PARENT) == 0)
+			return false;
+		last_min_offset = last_obj->parent_offset + sizeof(uintptr_t);
+		last_obj = (struct binder_buffer_object *)
+			(b->data + *(objects_start + last_obj->parent));
+	}
+	return (fixup_offset >= last_min_offset);
+}
+
+static void binder_transaction_buffer_release(struct binder_proc *proc,
+					      struct binder_buffer *buffer,
+					      binder_size_t *failed_at)
+{
+	binder_size_t *offp, *off_start, *off_end;
+	int debug_id = buffer->debug_id;
+
+	binder_debug(BINDER_DEBUG_TRANSACTION,
+		     "%d buffer release %d, size %zd-%zd, failed at %pK\n",
+		     proc->pid, buffer->debug_id,
+		     buffer->data_size, buffer->offsets_size, failed_at);
+
+	if (buffer->target_node)
+		binder_dec_node(buffer->target_node, 1, 0);
+
+	off_start = (binder_size_t *)(buffer->data +
+				      ALIGN(buffer->data_size, sizeof(void *)));
+	if (failed_at)
+		off_end = failed_at;
+	else
+		off_end = (void *)off_start + buffer->offsets_size;
+	for (offp = off_start; offp < off_end; offp++) {
+		struct binder_object_header *hdr;
+		size_t object_size = binder_validate_object(buffer, *offp);
+
+		if (object_size == 0) {
+			pr_err("transaction release %d bad object at offset %lld, size %zd\n",
+			       debug_id, (u64)*offp, buffer->data_size);
+			continue;
+		}
+		hdr = (struct binder_object_header *)(buffer->data + *offp);
+		switch (hdr->type) {
+		case BINDER_TYPE_BINDER:
+		case BINDER_TYPE_WEAK_BINDER: {
+			struct flat_binder_object *fp;
+			struct binder_node *node;
+
+			fp = to_flat_binder_object(hdr);
+			node = binder_get_node(proc, fp->binder);
+			if (node == NULL) {
+				pr_err("transaction release %d bad node %016llx\n",
+				       debug_id, (u64)fp->binder);
+				break;
+			}
+			binder_debug(BINDER_DEBUG_TRANSACTION,
+				     "        node %d u%016llx\n",
+				     node->debug_id, (u64)node->ptr);
+			binder_dec_node(node, hdr->type == BINDER_TYPE_BINDER,
+					0);
+			binder_put_node(node);
+		} break;
+		case BINDER_TYPE_HANDLE:
+		case BINDER_TYPE_WEAK_HANDLE: {
+			struct flat_binder_object *fp;
+			struct binder_ref_data rdata;
+			int ret;
+
+			fp = to_flat_binder_object(hdr);
+			ret = binder_dec_ref_for_handle(proc, fp->handle,
+				hdr->type == BINDER_TYPE_HANDLE, &rdata);
+
+			if (ret) {
+				pr_err("transaction release %d bad handle %d, ret = %d\n",
+				 debug_id, fp->handle, ret);
+				break;
+			}
+			binder_debug(BINDER_DEBUG_TRANSACTION,
+				     "        ref %d desc %d\n",
+				     rdata.debug_id, rdata.desc);
+		} break;
+
+		case BINDER_TYPE_FD: {
+			struct binder_fd_object *fp = to_binder_fd_object(hdr);
+
+			binder_debug(BINDER_DEBUG_TRANSACTION,
+				     "        fd %d\n", fp->fd);
+			if (failed_at)
+				task_close_fd(proc, fp->fd);
+		} break;
+		case BINDER_TYPE_PTR:
+			/*
+			 * Nothing to do here, this will get cleaned up when the
+			 * transaction buffer gets freed
+			 */
+			break;
+		case BINDER_TYPE_FDA: {
+			struct binder_fd_array_object *fda;
+			struct binder_buffer_object *parent;
+			uintptr_t parent_buffer;
+			u32 *fd_array;
+			size_t fd_index;
+			binder_size_t fd_buf_size;
+
+			fda = to_binder_fd_array_object(hdr);
+			parent = binder_validate_ptr(buffer, fda->parent,
+						     off_start,
+						     offp - off_start);
+			if (!parent) {
+				pr_err("transaction release %d bad parent offset",
+				       debug_id);
+				continue;
+			}
+			/*
+			 * Since the parent was already fixed up, convert it
+			 * back to kernel address space to access it
+			 */
+			parent_buffer = parent->buffer -
+				binder_alloc_get_user_buffer_offset(
+						&proc->alloc);
+
+			fd_buf_size = sizeof(u32) * fda->num_fds;
+			if (fda->num_fds >= SIZE_MAX / sizeof(u32)) {
+				pr_err("transaction release %d invalid number of fds (%lld)\n",
+				       debug_id, (u64)fda->num_fds);
+				continue;
+			}
+			if (fd_buf_size > parent->length ||
+			    fda->parent_offset > parent->length - fd_buf_size) {
+				/* No space for all file descriptors here. */
+				pr_err("transaction release %d not enough space for %lld fds in buffer\n",
+				       debug_id, (u64)fda->num_fds);
+				continue;
+			}
+			fd_array = (u32 *)(parent_buffer + (uintptr_t)fda->parent_offset);
+			for (fd_index = 0; fd_index < fda->num_fds; fd_index++)
+				task_close_fd(proc, fd_array[fd_index]);
+		} break;
+		default:
+			pr_err("transaction release %d bad object type %x\n",
+				debug_id, hdr->type);
+			break;
 		}
-		ref->weak--;
 	}
-	if (ref->strong == 0 && ref->weak == 0)
-		binder_delete_ref(ref);
-	return 0;
 }
 
-static void binder_pop_transaction(struct binder_thread *target_thread,
-				   struct binder_transaction *t)
+static int binder_translate_binder(struct flat_binder_object *fp,
+				   struct binder_transaction *t,
+				   struct binder_thread *thread)
+{
+	struct binder_node *node;
+	struct binder_proc *proc = thread->proc;
+	struct binder_proc *target_proc = t->to_proc;
+	struct binder_ref_data rdata;
+	int ret = 0;
+
+	node = binder_get_node(proc, fp->binder);
+	if (!node) {
+		node = binder_new_node(proc, fp);
+		if (!node)
+			return -ENOMEM;
+	}
+	if (fp->cookie != node->cookie) {
+		binder_user_error("%d:%d sending u%016llx node %d, cookie mismatch %016llx != %016llx\n",
+				  proc->pid, thread->pid, (u64)fp->binder,
+				  node->debug_id, (u64)fp->cookie,
+				  (u64)node->cookie);
+		ret = -EINVAL;
+		goto done;
+	}
+	if (security_binder_transfer_binder(proc->tsk, target_proc->tsk)) {
+		ret = -EPERM;
+		goto done;
+	}
+
+	ret = binder_inc_ref_for_node(target_proc, node,
+			fp->hdr.type == BINDER_TYPE_BINDER,
+			&thread->todo, &rdata);
+	if (ret)
+		goto done;
+
+	if (fp->hdr.type == BINDER_TYPE_BINDER)
+		fp->hdr.type = BINDER_TYPE_HANDLE;
+	else
+		fp->hdr.type = BINDER_TYPE_WEAK_HANDLE;
+	fp->binder = 0;
+	fp->handle = rdata.desc;
+	fp->cookie = 0;
+
+	trace_binder_transaction_node_to_ref(t, node, &rdata);
+	binder_debug(BINDER_DEBUG_TRANSACTION,
+		     "        node %d u%016llx -> ref %d desc %d\n",
+		     node->debug_id, (u64)node->ptr,
+		     rdata.debug_id, rdata.desc);
+done:
+	binder_put_node(node);
+	return ret;
+}
+
+static int binder_translate_handle(struct flat_binder_object *fp,
+				   struct binder_transaction *t,
+				   struct binder_thread *thread)
+{
+	struct binder_proc *proc = thread->proc;
+	struct binder_proc *target_proc = t->to_proc;
+	struct binder_node *node;
+	struct binder_ref_data src_rdata;
+	int ret = 0;
+
+	node = binder_get_node_from_ref(proc, fp->handle,
+			fp->hdr.type == BINDER_TYPE_HANDLE, &src_rdata);
+	if (!node) {
+		binder_user_error("%d:%d got transaction with invalid handle, %d\n",
+				  proc->pid, thread->pid, fp->handle);
+		return -EINVAL;
+	}
+	if (security_binder_transfer_binder(proc->tsk, target_proc->tsk)) {
+		ret = -EPERM;
+		goto done;
+	}
+
+	binder_node_lock(node);
+	if (node->proc == target_proc) {
+		if (fp->hdr.type == BINDER_TYPE_HANDLE)
+			fp->hdr.type = BINDER_TYPE_BINDER;
+		else
+			fp->hdr.type = BINDER_TYPE_WEAK_BINDER;
+		fp->binder = node->ptr;
+		fp->cookie = node->cookie;
+		if (node->proc)
+			binder_inner_proc_lock(node->proc);
+		binder_inc_node_nilocked(node,
+					 fp->hdr.type == BINDER_TYPE_BINDER,
+					 0, NULL);
+		if (node->proc)
+			binder_inner_proc_unlock(node->proc);
+		trace_binder_transaction_ref_to_node(t, node, &src_rdata);
+		binder_debug(BINDER_DEBUG_TRANSACTION,
+			     "        ref %d desc %d -> node %d u%016llx\n",
+			     src_rdata.debug_id, src_rdata.desc, node->debug_id,
+			     (u64)node->ptr);
+		binder_node_unlock(node);
+	} else {
+		struct binder_ref_data dest_rdata;
+
+		binder_node_unlock(node);
+		ret = binder_inc_ref_for_node(target_proc, node,
+				fp->hdr.type == BINDER_TYPE_HANDLE,
+				NULL, &dest_rdata);
+		if (ret)
+			goto done;
+
+		fp->binder = 0;
+		fp->handle = dest_rdata.desc;
+		fp->cookie = 0;
+		trace_binder_transaction_ref_to_ref(t, node, &src_rdata,
+						    &dest_rdata);
+		binder_debug(BINDER_DEBUG_TRANSACTION,
+			     "        ref %d desc %d -> ref %d desc %d (node %d)\n",
+			     src_rdata.debug_id, src_rdata.desc,
+			     dest_rdata.debug_id, dest_rdata.desc,
+			     node->debug_id);
+	}
+done:
+	binder_put_node(node);
+	return ret;
+}
+
+static int binder_translate_fd(int fd,
+			       struct binder_transaction *t,
+			       struct binder_thread *thread,
+			       struct binder_transaction *in_reply_to)
+{
+	struct binder_proc *proc = thread->proc;
+	struct binder_proc *target_proc = t->to_proc;
+	int target_fd;
+	struct file *file;
+	int ret;
+	bool target_allows_fd;
+
+	if (in_reply_to)
+		target_allows_fd = !!(in_reply_to->flags & TF_ACCEPT_FDS);
+	else
+		target_allows_fd = t->buffer->target_node->accept_fds;
+	if (!target_allows_fd) {
+		binder_user_error("%d:%d got %s with fd, %d, but target does not allow fds\n",
+				  proc->pid, thread->pid,
+				  in_reply_to ? "reply" : "transaction",
+				  fd);
+		ret = -EPERM;
+		goto err_fd_not_accepted;
+	}
+
+	file = fget(fd);
+	if (!file) {
+		binder_user_error("%d:%d got transaction with invalid fd, %d\n",
+				  proc->pid, thread->pid, fd);
+		ret = -EBADF;
+		goto err_fget;
+	}
+	ret = security_binder_transfer_file(proc->tsk, target_proc->tsk, file);
+	if (ret < 0) {
+		ret = -EPERM;
+		goto err_security;
+	}
+
+	target_fd = task_get_unused_fd_flags(target_proc, O_CLOEXEC);
+	if (target_fd < 0) {
+		ret = -ENOMEM;
+		goto err_get_unused_fd;
+	}
+	task_fd_install(target_proc, target_fd, file);
+	trace_binder_transaction_fd(t, fd, target_fd);
+	binder_debug(BINDER_DEBUG_TRANSACTION, "        fd %d -> %d\n",
+		     fd, target_fd);
+
+	return target_fd;
+
+err_get_unused_fd:
+err_security:
+	fput(file);
+err_fget:
+err_fd_not_accepted:
+	return ret;
+}
+
+static int binder_translate_fd_array(struct binder_fd_array_object *fda,
+				     struct binder_buffer_object *parent,
+				     struct binder_transaction *t,
+				     struct binder_thread *thread,
+				     struct binder_transaction *in_reply_to)
 {
-	if (target_thread) {
-		BUG_ON(target_thread->transaction_stack != t);
-		BUG_ON(target_thread->transaction_stack->from != target_thread);
-		target_thread->transaction_stack =
-			target_thread->transaction_stack->from_parent;
-		t->from = NULL;
+	binder_size_t fdi, fd_buf_size, num_installed_fds;
+	int target_fd;
+	uintptr_t parent_buffer;
+	u32 *fd_array;
+	struct binder_proc *proc = thread->proc;
+	struct binder_proc *target_proc = t->to_proc;
+
+	fd_buf_size = sizeof(u32) * fda->num_fds;
+	if (fda->num_fds >= SIZE_MAX / sizeof(u32)) {
+		binder_user_error("%d:%d got transaction with invalid number of fds (%lld)\n",
+				  proc->pid, thread->pid, (u64)fda->num_fds);
+		return -EINVAL;
 	}
-	t->need_reply = 0;
-	if (t->buffer)
-		t->buffer->transaction = NULL;
-	kfree(t);
-	binder_stats_deleted(BINDER_STAT_TRANSACTION);
+	if (fd_buf_size > parent->length ||
+	    fda->parent_offset > parent->length - fd_buf_size) {
+		/* No space for all file descriptors here. */
+		binder_user_error("%d:%d not enough space to store %lld fds in buffer\n",
+				  proc->pid, thread->pid, (u64)fda->num_fds);
+		return -EINVAL;
+	}
+	/*
+	 * Since the parent was already fixed up, convert it
+	 * back to the kernel address space to access it
+	 */
+	parent_buffer = parent->buffer -
+		binder_alloc_get_user_buffer_offset(&target_proc->alloc);
+	fd_array = (u32 *)(parent_buffer + (uintptr_t)fda->parent_offset);
+	if (!IS_ALIGNED((unsigned long)fd_array, sizeof(u32))) {
+		binder_user_error("%d:%d parent offset not aligned correctly.\n",
+				  proc->pid, thread->pid);
+		return -EINVAL;
+	}
+	for (fdi = 0; fdi < fda->num_fds; fdi++) {
+		target_fd = binder_translate_fd(fd_array[fdi], t, thread,
+						in_reply_to);
+		if (target_fd < 0)
+			goto err_translate_fd_failed;
+		fd_array[fdi] = target_fd;
+	}
+	return 0;
+
+err_translate_fd_failed:
+	/*
+	 * Failed to allocate fd or security error, free fds
+	 * installed so far.
+	 */
+	num_installed_fds = fdi;
+	for (fdi = 0; fdi < num_installed_fds; fdi++)
+		task_close_fd(target_proc, fd_array[fdi]);
+	return target_fd;
 }
 
-static void binder_send_failed_reply(struct binder_transaction *t,
-				     uint32_t error_code)
+static int binder_fixup_parent(struct binder_transaction *t,
+			       struct binder_thread *thread,
+			       struct binder_buffer_object *bp,
+			       binder_size_t *off_start,
+			       binder_size_t num_valid,
+			       struct binder_buffer_object *last_fixup_obj,
+			       binder_size_t last_fixup_min_off)
 {
-	struct binder_thread *target_thread;
-	struct binder_transaction *next;
+	struct binder_buffer_object *parent;
+	u8 *parent_buffer;
+	struct binder_buffer *b = t->buffer;
+	struct binder_proc *proc = thread->proc;
+	struct binder_proc *target_proc = t->to_proc;
 
-	BUG_ON(t->flags & TF_ONE_WAY);
-	while (1) {
-		target_thread = t->from;
-		if (target_thread) {
-			if (target_thread->return_error != BR_OK &&
-			   target_thread->return_error2 == BR_OK) {
-				target_thread->return_error2 =
-					target_thread->return_error;
-				target_thread->return_error = BR_OK;
-			}
-			if (target_thread->return_error == BR_OK) {
-				binder_debug(BINDER_DEBUG_FAILED_TRANSACTION,
-					     "send failed reply for transaction %d to %d:%d\n",
-					      t->debug_id,
-					      target_thread->proc->pid,
-					      target_thread->pid);
-
-				binder_pop_transaction(target_thread, t);
-				target_thread->return_error = error_code;
-				wake_up_interruptible(&target_thread->wait);
-			} else {
-				pr_err("reply failed, target thread, %d:%d, has error code %d already\n",
-					target_thread->proc->pid,
-					target_thread->pid,
-					target_thread->return_error);
-			}
-			return;
-		}
-		next = t->from_parent;
+	if (!(bp->flags & BINDER_BUFFER_FLAG_HAS_PARENT))
+		return 0;
 
-		binder_debug(BINDER_DEBUG_FAILED_TRANSACTION,
-			     "send failed reply for transaction %d, target dead\n",
-			     t->debug_id);
+	parent = binder_validate_ptr(b, bp->parent, off_start, num_valid);
+	if (!parent) {
+		binder_user_error("%d:%d got transaction with invalid parent offset or type\n",
+				  proc->pid, thread->pid);
+		return -EINVAL;
+	}
 
-		binder_pop_transaction(target_thread, t);
-		if (next == NULL) {
-			binder_debug(BINDER_DEBUG_DEAD_BINDER,
-				     "reply failed, no target thread at root\n");
-			return;
-		}
-		t = next;
-		binder_debug(BINDER_DEBUG_DEAD_BINDER,
-			     "reply failed, no target thread -- retry %d\n",
-			      t->debug_id);
+	if (!binder_validate_fixup(b, off_start,
+				   parent, bp->parent_offset,
+				   last_fixup_obj,
+				   last_fixup_min_off)) {
+		binder_user_error("%d:%d got transaction with out-of-order buffer fixup\n",
+				  proc->pid, thread->pid);
+		return -EINVAL;
+	}
+
+	if (parent->length < sizeof(binder_uintptr_t) ||
+	    bp->parent_offset > parent->length - sizeof(binder_uintptr_t)) {
+		/* No space for a pointer here! */
+		binder_user_error("%d:%d got transaction with invalid parent offset\n",
+				  proc->pid, thread->pid);
+		return -EINVAL;
 	}
+	parent_buffer = (u8 *)((uintptr_t)parent->buffer -
+			binder_alloc_get_user_buffer_offset(
+				&target_proc->alloc));
+	*(binder_uintptr_t *)(parent_buffer + bp->parent_offset) = bp->buffer;
+
+	return 0;
 }
 
-static void binder_transaction_buffer_release(struct binder_proc *proc,
-					      struct binder_buffer *buffer,
-					      binder_size_t *failed_at)
+/**
+ * binder_proc_transaction() - sends a transaction to a process and wakes it up
+ * @t:		transaction to send
+ * @proc:	process to send the transaction to
+ * @thread:	thread in @proc to send the transaction to (may be NULL)
+ *
+ * This function queues a transaction to the specified process. It will try
+ * to find a thread in the target process to handle the transaction and
+ * wake it up. If no thread is found, the work is queued to the proc
+ * waitqueue.
+ *
+ * If the @thread parameter is not NULL, the transaction is always queued
+ * to the waitlist of that specific thread.
+ *
+ * Return:	true if the transactions was successfully queued
+ *		false if the target process or thread is dead
+ */
+static bool binder_proc_transaction(struct binder_transaction *t,
+				    struct binder_proc *proc,
+				    struct binder_thread *thread)
 {
-	binder_size_t *offp, *off_end;
-	int debug_id = buffer->debug_id;
+	struct binder_node *node = t->buffer->target_node;
+	struct binder_priority node_prio;
+	bool oneway = !!(t->flags & TF_ONE_WAY);
+	bool pending_async = false;
+
+	BUG_ON(!node);
+	binder_node_lock(node);
+	node_prio.prio = node->min_priority;
+	node_prio.sched_policy = node->sched_policy;
+
+	if (oneway) {
+		BUG_ON(thread);
+		if (node->has_async_transaction) {
+			pending_async = true;
+		} else {
+			node->has_async_transaction = true;
+		}
+	}
 
-	binder_debug(BINDER_DEBUG_TRANSACTION,
-		     "%d buffer release %d, size %zd-%zd, failed at %p\n",
-		     proc->pid, buffer->debug_id,
-		     buffer->data_size, buffer->offsets_size, failed_at);
+	binder_inner_proc_lock(proc);
 
-	if (buffer->target_node)
-		binder_dec_node(buffer->target_node, 1, 0);
+	if (proc->is_dead || (thread && thread->is_dead)) {
+		binder_inner_proc_unlock(proc);
+		binder_node_unlock(node);
+		return false;
+	}
 
-	offp = (binder_size_t *)(buffer->data +
-				 ALIGN(buffer->data_size, sizeof(void *)));
-	if (failed_at)
-		off_end = failed_at;
-	else
-		off_end = (void *)offp + buffer->offsets_size;
-	for (; offp < off_end; offp++) {
-		struct flat_binder_object *fp;
+	if (!thread && !pending_async)
+		thread = binder_select_thread_ilocked(proc);
 
-		if (*offp > buffer->data_size - sizeof(*fp) ||
-		    buffer->data_size < sizeof(*fp) ||
-		    !IS_ALIGNED(*offp, sizeof(u32))) {
-			pr_err("transaction release %d bad offset %lld, size %zd\n",
-			       debug_id, (u64)*offp, buffer->data_size);
-			continue;
-		}
-		fp = (struct flat_binder_object *)(buffer->data + *offp);
-		switch (fp->type) {
-		case BINDER_TYPE_BINDER:
-		case BINDER_TYPE_WEAK_BINDER: {
-			struct binder_node *node = binder_get_node(proc, fp->binder);
+	if (thread) {
+		binder_transaction_priority(thread->task, t, node_prio,
+					    node->inherit_rt);
+		binder_enqueue_thread_work_ilocked(thread, &t->work);
+	} else if (!pending_async) {
+		binder_enqueue_work_ilocked(&t->work, &proc->todo);
+	} else {
+		binder_enqueue_work_ilocked(&t->work, &node->async_todo);
+	}
 
-			if (node == NULL) {
-				pr_err("transaction release %d bad node %016llx\n",
-				       debug_id, (u64)fp->binder);
-				break;
-			}
-			binder_debug(BINDER_DEBUG_TRANSACTION,
-				     "        node %d u%016llx\n",
-				     node->debug_id, (u64)node->ptr);
-			binder_dec_node(node, fp->type == BINDER_TYPE_BINDER, 0);
-		} break;
-		case BINDER_TYPE_HANDLE:
-		case BINDER_TYPE_WEAK_HANDLE: {
-			struct binder_ref *ref;
+	if (!pending_async)
+		binder_wakeup_thread_ilocked(proc, thread, !oneway /* sync */);
 
-			ref = binder_get_ref(proc, fp->handle,
-					     fp->type == BINDER_TYPE_HANDLE);
+	binder_inner_proc_unlock(proc);
+	binder_node_unlock(node);
 
-			if (ref == NULL) {
-				pr_err("transaction release %d bad handle %d\n",
-				 debug_id, fp->handle);
-				break;
-			}
-			binder_debug(BINDER_DEBUG_TRANSACTION,
-				     "        ref %d desc %d (node %d)\n",
-				     ref->debug_id, ref->desc, ref->node->debug_id);
-			binder_dec_ref(ref, fp->type == BINDER_TYPE_HANDLE);
-		} break;
+	return true;
+}
 
-		case BINDER_TYPE_FD:
-			binder_debug(BINDER_DEBUG_TRANSACTION,
-				     "        fd %d\n", fp->handle);
-			if (failed_at)
-				task_close_fd(proc, fp->handle);
-			break;
+/**
+ * binder_get_node_refs_for_txn() - Get required refs on node for txn
+ * @node:         struct binder_node for which to get refs
+ * @proc:         returns @node->proc if valid
+ * @error:        if no @proc then returns BR_DEAD_REPLY
+ *
+ * User-space normally keeps the node alive when creating a transaction
+ * since it has a reference to the target. The local strong ref keeps it
+ * alive if the sending process dies before the target process processes
+ * the transaction. If the source process is malicious or has a reference
+ * counting bug, relying on the local strong ref can fail.
+ *
+ * Since user-space can cause the local strong ref to go away, we also take
+ * a tmpref on the node to ensure it survives while we are constructing
+ * the transaction. We also need a tmpref on the proc while we are
+ * constructing the transaction, so we take that here as well.
+ *
+ * Return: The target_node with refs taken or NULL if no @node->proc is NULL.
+ * Also sets @proc if valid. If the @node->proc is NULL indicating that the
+ * target proc has died, @error is set to BR_DEAD_REPLY
+ */
+static struct binder_node *binder_get_node_refs_for_txn(
+		struct binder_node *node,
+		struct binder_proc **procp,
+		uint32_t *error)
+{
+	struct binder_node *target_node = NULL;
 
-		default:
-			pr_err("transaction release %d bad object type %x\n",
-				debug_id, fp->type);
-			break;
-		}
-	}
+	binder_node_inner_lock(node);
+	if (node->proc) {
+		target_node = node;
+		binder_inc_node_nilocked(node, 1, 0, NULL);
+		binder_inc_node_tmpref_ilocked(node);
+		node->proc->tmp_ref++;
+		*procp = node->proc;
+	} else
+		*error = BR_DEAD_REPLY;
+	binder_node_inner_unlock(node);
+
+	return target_node;
 }
 
 static void binder_transaction(struct binder_proc *proc,
 			       struct binder_thread *thread,
-			       struct binder_transaction_data *tr, int reply)
+			       struct binder_transaction_data *tr, int reply,
+			       binder_size_t extra_buffers_size)
 {
+	int ret;
 	struct binder_transaction *t;
 	struct binder_work *tcomplete;
-	binder_size_t *offp, *off_end;
+	binder_size_t *offp, *off_end, *off_start;
 	binder_size_t off_min;
-	struct binder_proc *target_proc;
+	u8 *sg_bufp, *sg_buf_end;
+	struct binder_proc *target_proc = NULL;
 	struct binder_thread *target_thread = NULL;
 	struct binder_node *target_node = NULL;
-	struct list_head *target_list;
-	wait_queue_head_t *target_wait;
 	struct binder_transaction *in_reply_to = NULL;
 	struct binder_transaction_log_entry *e;
-	uint32_t return_error;
+	uint32_t return_error = 0;
+	uint32_t return_error_param = 0;
+	uint32_t return_error_line = 0;
+	struct binder_buffer_object *last_fixup_obj = NULL;
+	binder_size_t last_fixup_min_off = 0;
+	struct binder_context *context = proc->context;
+	int t_debug_id = atomic_inc_return(&binder_last_id);
 
 	e = binder_transaction_log_add(&binder_transaction_log);
+	e->debug_id = t_debug_id;
 	e->call_type = reply ? 2 : !!(tr->flags & TF_ONE_WAY);
 	e->from_proc = proc->pid;
 	e->from_thread = thread->pid;
 	e->target_handle = tr->target.handle;
 	e->data_size = tr->data_size;
 	e->offsets_size = tr->offsets_size;
+	e->context_name = proc->context->name;
 
 	if (reply) {
+		binder_inner_proc_lock(proc);
 		in_reply_to = thread->transaction_stack;
 		if (in_reply_to == NULL) {
+			binder_inner_proc_unlock(proc);
 			binder_user_error("%d:%d got reply transaction with no transaction stack\n",
 					  proc->pid, thread->pid);
 			return_error = BR_FAILED_REPLY;
+			return_error_param = -EPROTO;
+			return_error_line = __LINE__;
 			goto err_empty_call_stack;
 		}
-		binder_set_nice(in_reply_to->saved_priority);
 		if (in_reply_to->to_thread != thread) {
+			spin_lock(&in_reply_to->lock);
 			binder_user_error("%d:%d got reply transaction with bad transaction stack, transaction %d has target %d:%d\n",
 				proc->pid, thread->pid, in_reply_to->debug_id,
 				in_reply_to->to_proc ?
 				in_reply_to->to_proc->pid : 0,
 				in_reply_to->to_thread ?
 				in_reply_to->to_thread->pid : 0);
+			spin_unlock(&in_reply_to->lock);
+			binder_inner_proc_unlock(proc);
 			return_error = BR_FAILED_REPLY;
+			return_error_param = -EPROTO;
+			return_error_line = __LINE__;
 			in_reply_to = NULL;
 			goto err_bad_call_stack;
 		}
 		thread->transaction_stack = in_reply_to->to_parent;
-		target_thread = in_reply_to->from;
+		binder_inner_proc_unlock(proc);
+		target_thread = binder_get_txn_from_and_acq_inner(in_reply_to);
 		if (target_thread == NULL) {
 			return_error = BR_DEAD_REPLY;
+			return_error_line = __LINE__;
 			goto err_dead_binder;
 		}
 		if (target_thread->transaction_stack != in_reply_to) {
@@ -1377,106 +2955,156 @@ static void binder_transaction(struct binder_proc *proc,
 				target_thread->transaction_stack ?
 				target_thread->transaction_stack->debug_id : 0,
 				in_reply_to->debug_id);
+			binder_inner_proc_unlock(target_thread->proc);
 			return_error = BR_FAILED_REPLY;
+			return_error_param = -EPROTO;
+			return_error_line = __LINE__;
 			in_reply_to = NULL;
 			target_thread = NULL;
 			goto err_dead_binder;
 		}
 		target_proc = target_thread->proc;
+		target_proc->tmp_ref++;
+		binder_inner_proc_unlock(target_thread->proc);
 	} else {
 		if (tr->target.handle) {
 			struct binder_ref *ref;
 
-			ref = binder_get_ref(proc, tr->target.handle, true);
-			if (ref == NULL) {
+			/*
+			 * There must already be a strong ref
+			 * on this node. If so, do a strong
+			 * increment on the node to ensure it
+			 * stays alive until the transaction is
+			 * done.
+			 */
+			binder_proc_lock(proc);
+			ref = binder_get_ref_olocked(proc, tr->target.handle,
+						     true);
+			if (ref) {
+				target_node = binder_get_node_refs_for_txn(
+						ref->node, &target_proc,
+						&return_error);
+			} else {
 				binder_user_error("%d:%d got transaction to invalid handle\n",
-					proc->pid, thread->pid);
+						  proc->pid, thread->pid);
 				return_error = BR_FAILED_REPLY;
-				goto err_invalid_target_handle;
 			}
-			target_node = ref->node;
+			binder_proc_unlock(proc);
 		} else {
-			target_node = binder_context_mgr_node;
-			if (target_node == NULL) {
+			mutex_lock(&context->context_mgr_node_lock);
+			target_node = context->binder_context_mgr_node;
+			if (target_node)
+				target_node = binder_get_node_refs_for_txn(
+						target_node, &target_proc,
+						&return_error);
+			else
 				return_error = BR_DEAD_REPLY;
-				goto err_no_context_mgr_node;
+			mutex_unlock(&context->context_mgr_node_lock);
+			if (target_node && target_proc == proc) {
+				binder_user_error("%d:%d got transaction to context manager from process owning it\n",
+						  proc->pid, thread->pid);
+				return_error = BR_FAILED_REPLY;
+				return_error_param = -EINVAL;
+				return_error_line = __LINE__;
+				goto err_invalid_target_handle;
 			}
 		}
-		e->to_node = target_node->debug_id;
-		target_proc = target_node->proc;
-		if (target_proc == NULL) {
-			return_error = BR_DEAD_REPLY;
+		if (!target_node) {
+			/*
+			 * return_error is set above
+			 */
+			return_error_param = -EINVAL;
+			return_error_line = __LINE__;
 			goto err_dead_binder;
 		}
+		e->to_node = target_node->debug_id;
 		if (security_binder_transaction(proc->tsk,
 						target_proc->tsk) < 0) {
 			return_error = BR_FAILED_REPLY;
+			return_error_param = -EPERM;
+			return_error_line = __LINE__;
 			goto err_invalid_target_handle;
 		}
+		binder_inner_proc_lock(proc);
 		if (!(tr->flags & TF_ONE_WAY) && thread->transaction_stack) {
 			struct binder_transaction *tmp;
 
 			tmp = thread->transaction_stack;
 			if (tmp->to_thread != thread) {
+				spin_lock(&tmp->lock);
 				binder_user_error("%d:%d got new transaction with bad transaction stack, transaction %d has target %d:%d\n",
 					proc->pid, thread->pid, tmp->debug_id,
 					tmp->to_proc ? tmp->to_proc->pid : 0,
 					tmp->to_thread ?
 					tmp->to_thread->pid : 0);
+				spin_unlock(&tmp->lock);
+				binder_inner_proc_unlock(proc);
 				return_error = BR_FAILED_REPLY;
+				return_error_param = -EPROTO;
+				return_error_line = __LINE__;
 				goto err_bad_call_stack;
 			}
 			while (tmp) {
-				if (tmp->from && tmp->from->proc == target_proc)
-					target_thread = tmp->from;
+				struct binder_thread *from;
+
+				spin_lock(&tmp->lock);
+				from = tmp->from;
+				if (from && from->proc == target_proc) {
+					atomic_inc(&from->tmp_ref);
+					target_thread = from;
+					spin_unlock(&tmp->lock);
+					break;
+				}
+				spin_unlock(&tmp->lock);
 				tmp = tmp->from_parent;
 			}
 		}
+		binder_inner_proc_unlock(proc);
 	}
-	if (target_thread) {
+	if (target_thread)
 		e->to_thread = target_thread->pid;
-		target_list = &target_thread->todo;
-		target_wait = &target_thread->wait;
-	} else {
-		target_list = &target_proc->todo;
-		target_wait = &target_proc->wait;
-	}
 	e->to_proc = target_proc->pid;
 
 	/* TODO: reuse incoming transaction for reply */
 	t = kzalloc(sizeof(*t), GFP_KERNEL);
 	if (t == NULL) {
 		return_error = BR_FAILED_REPLY;
+		return_error_param = -ENOMEM;
+		return_error_line = __LINE__;
 		goto err_alloc_t_failed;
 	}
 	binder_stats_created(BINDER_STAT_TRANSACTION);
+	spin_lock_init(&t->lock);
 
 	tcomplete = kzalloc(sizeof(*tcomplete), GFP_KERNEL);
 	if (tcomplete == NULL) {
 		return_error = BR_FAILED_REPLY;
+		return_error_param = -ENOMEM;
+		return_error_line = __LINE__;
 		goto err_alloc_tcomplete_failed;
 	}
 	binder_stats_created(BINDER_STAT_TRANSACTION_COMPLETE);
 
-	t->debug_id = ++binder_last_id;
-	e->debug_id = t->debug_id;
+	t->debug_id = t_debug_id;
 
 	if (reply)
 		binder_debug(BINDER_DEBUG_TRANSACTION,
-			     "%d:%d BC_REPLY %d -> %d:%d, data %016llx-%016llx size %lld-%lld\n",
+			     "%d:%d BC_REPLY %d -> %d:%d, data %016llx-%016llx size %lld-%lld-%lld\n",
 			     proc->pid, thread->pid, t->debug_id,
 			     target_proc->pid, target_thread->pid,
 			     (u64)tr->data.ptr.buffer,
 			     (u64)tr->data.ptr.offsets,
-			     (u64)tr->data_size, (u64)tr->offsets_size);
+			     (u64)tr->data_size, (u64)tr->offsets_size,
+			     (u64)extra_buffers_size);
 	else
 		binder_debug(BINDER_DEBUG_TRANSACTION,
-			     "%d:%d BC_TRANSACTION %d -> %d - node %d, data %016llx-%016llx size %lld-%lld\n",
+			     "%d:%d BC_TRANSACTION %d -> %d - node %d, data %016llx-%016llx size %lld-%lld-%lld\n",
 			     proc->pid, thread->pid, t->debug_id,
 			     target_proc->pid, target_node->debug_id,
 			     (u64)tr->data.ptr.buffer,
 			     (u64)tr->data.ptr.offsets,
-			     (u64)tr->data_size, (u64)tr->offsets_size);
+			     (u64)tr->data_size, (u64)tr->offsets_size,
+			     (u64)extra_buffers_size);
 
 	if (!reply && !(tr->flags & TF_ONE_WAY))
 		t->from = thread;
@@ -1487,14 +3115,30 @@ static void binder_transaction(struct binder_proc *proc,
 	t->to_thread = target_thread;
 	t->code = tr->code;
 	t->flags = tr->flags;
-	t->priority = task_nice(current);
+	if (!(t->flags & TF_ONE_WAY) &&
+	    binder_supported_policy(current->policy)) {
+		/* Inherit supported policies for synchronous transactions */
+		t->priority.sched_policy = current->policy;
+		t->priority.prio = current->normal_prio;
+	} else {
+		/* Otherwise, fall back to the default priority */
+		t->priority = target_proc->default_priority;
+	}
 
 	trace_binder_transaction(reply, t, target_node);
 
-	t->buffer = binder_alloc_buf(target_proc, tr->data_size,
-		tr->offsets_size, !reply && (t->flags & TF_ONE_WAY));
-	if (t->buffer == NULL) {
-		return_error = BR_FAILED_REPLY;
+	t->buffer = binder_alloc_new_buf(&target_proc->alloc, tr->data_size,
+		tr->offsets_size, extra_buffers_size,
+		!reply && (t->flags & TF_ONE_WAY));
+	if (IS_ERR(t->buffer)) {
+		/*
+		 * -ESRCH indicates VMA cleared. The target is dying.
+		 */
+		return_error_param = PTR_ERR(t->buffer);
+		return_error = return_error_param == -ESRCH ?
+			BR_DEAD_REPLY : BR_FAILED_REPLY;
+		return_error_line = __LINE__;
+		t->buffer = NULL;
 		goto err_binder_alloc_buf_failed;
 	}
 	t->buffer->allow_user_free = 0;
@@ -1502,17 +3146,17 @@ static void binder_transaction(struct binder_proc *proc,
 	t->buffer->transaction = t;
 	t->buffer->target_node = target_node;
 	trace_binder_transaction_alloc_buf(t->buffer);
-	if (target_node)
-		binder_inc_node(target_node, 1, 0, NULL);
-
-	offp = (binder_size_t *)(t->buffer->data +
-				 ALIGN(tr->data_size, sizeof(void *)));
+	off_start = (binder_size_t *)(t->buffer->data +
+				      ALIGN(tr->data_size, sizeof(void *)));
+	offp = off_start;
 
 	if (copy_from_user(t->buffer->data, (const void __user *)(uintptr_t)
 			   tr->data.ptr.buffer, tr->data_size)) {
 		binder_user_error("%d:%d got transaction with invalid data ptr\n",
 				proc->pid, thread->pid);
 		return_error = BR_FAILED_REPLY;
+		return_error_param = -EFAULT;
+		return_error_line = __LINE__;
 		goto err_copy_data_failed;
 	}
 	if (copy_from_user(offp, (const void __user *)(uintptr_t)
@@ -1520,231 +3164,253 @@ static void binder_transaction(struct binder_proc *proc,
 		binder_user_error("%d:%d got transaction with invalid offsets ptr\n",
 				proc->pid, thread->pid);
 		return_error = BR_FAILED_REPLY;
+		return_error_param = -EFAULT;
+		return_error_line = __LINE__;
 		goto err_copy_data_failed;
 	}
 	if (!IS_ALIGNED(tr->offsets_size, sizeof(binder_size_t))) {
 		binder_user_error("%d:%d got transaction with invalid offsets size, %lld\n",
 				proc->pid, thread->pid, (u64)tr->offsets_size);
 		return_error = BR_FAILED_REPLY;
+		return_error_param = -EINVAL;
+		return_error_line = __LINE__;
+		goto err_bad_offset;
+	}
+	if (!IS_ALIGNED(extra_buffers_size, sizeof(u64))) {
+		binder_user_error("%d:%d got transaction with unaligned buffers size, %lld\n",
+				  proc->pid, thread->pid,
+				  (u64)extra_buffers_size);
+		return_error = BR_FAILED_REPLY;
+		return_error_param = -EINVAL;
+		return_error_line = __LINE__;
 		goto err_bad_offset;
 	}
-	off_end = (void *)offp + tr->offsets_size;
+	off_end = (void *)off_start + tr->offsets_size;
+	sg_bufp = (u8 *)(PTR_ALIGN(off_end, sizeof(void *)));
+	sg_buf_end = sg_bufp + extra_buffers_size;
 	off_min = 0;
 	for (; offp < off_end; offp++) {
-		struct flat_binder_object *fp;
+		struct binder_object_header *hdr;
+		size_t object_size = binder_validate_object(t->buffer, *offp);
 
-		if (*offp > t->buffer->data_size - sizeof(*fp) ||
-		    *offp < off_min ||
-		    t->buffer->data_size < sizeof(*fp) ||
-		    !IS_ALIGNED(*offp, sizeof(u32))) {
-			binder_user_error("%d:%d got transaction with invalid offset, %lld (min %lld, max %lld)\n",
+		if (object_size == 0 || *offp < off_min) {
+			binder_user_error("%d:%d got transaction with invalid offset (%lld, min %lld max %lld) or object.\n",
 					  proc->pid, thread->pid, (u64)*offp,
 					  (u64)off_min,
-					  (u64)(t->buffer->data_size -
-					  sizeof(*fp)));
+					  (u64)t->buffer->data_size);
 			return_error = BR_FAILED_REPLY;
+			return_error_param = -EINVAL;
+			return_error_line = __LINE__;
 			goto err_bad_offset;
 		}
-		fp = (struct flat_binder_object *)(t->buffer->data + *offp);
-		off_min = *offp + sizeof(struct flat_binder_object);
-		switch (fp->type) {
+
+		hdr = (struct binder_object_header *)(t->buffer->data + *offp);
+		off_min = *offp + object_size;
+		switch (hdr->type) {
 		case BINDER_TYPE_BINDER:
 		case BINDER_TYPE_WEAK_BINDER: {
-			struct binder_ref *ref;
-			struct binder_node *node = binder_get_node(proc, fp->binder);
+			struct flat_binder_object *fp;
 
-			if (node == NULL) {
-				node = binder_new_node(proc, fp->binder, fp->cookie);
-				if (node == NULL) {
-					return_error = BR_FAILED_REPLY;
-					goto err_binder_new_node_failed;
-				}
-				node->min_priority = fp->flags & FLAT_BINDER_FLAG_PRIORITY_MASK;
-				node->accept_fds = !!(fp->flags & FLAT_BINDER_FLAG_ACCEPTS_FDS);
-			}
-			if (fp->cookie != node->cookie) {
-				binder_user_error("%d:%d sending u%016llx node %d, cookie mismatch %016llx != %016llx\n",
-					proc->pid, thread->pid,
-					(u64)fp->binder, node->debug_id,
-					(u64)fp->cookie, (u64)node->cookie);
+			fp = to_flat_binder_object(hdr);
+			ret = binder_translate_binder(fp, t, thread);
+			if (ret < 0) {
 				return_error = BR_FAILED_REPLY;
-				goto err_binder_get_ref_for_node_failed;
+				return_error_param = ret;
+				return_error_line = __LINE__;
+				goto err_translate_failed;
 			}
-			if (security_binder_transfer_binder(proc->tsk,
-							    target_proc->tsk)) {
-				return_error = BR_FAILED_REPLY;
-				goto err_binder_get_ref_for_node_failed;
-			}
-			ref = binder_get_ref_for_node(target_proc, node);
-			if (ref == NULL) {
-				return_error = BR_FAILED_REPLY;
-				goto err_binder_get_ref_for_node_failed;
-			}
-			if (fp->type == BINDER_TYPE_BINDER)
-				fp->type = BINDER_TYPE_HANDLE;
-			else
-				fp->type = BINDER_TYPE_WEAK_HANDLE;
-			fp->binder = 0;
-			fp->handle = ref->desc;
-			fp->cookie = 0;
-			binder_inc_ref(ref, fp->type == BINDER_TYPE_HANDLE,
-				       &thread->todo);
-
-			trace_binder_transaction_node_to_ref(t, node, ref);
-			binder_debug(BINDER_DEBUG_TRANSACTION,
-				     "        node %d u%016llx -> ref %d desc %d\n",
-				     node->debug_id, (u64)node->ptr,
-				     ref->debug_id, ref->desc);
 		} break;
 		case BINDER_TYPE_HANDLE:
 		case BINDER_TYPE_WEAK_HANDLE: {
-			struct binder_ref *ref;
+			struct flat_binder_object *fp;
 
-			ref = binder_get_ref(proc, fp->handle,
-					     fp->type == BINDER_TYPE_HANDLE);
+			fp = to_flat_binder_object(hdr);
+			ret = binder_translate_handle(fp, t, thread);
+			if (ret < 0) {
+				return_error = BR_FAILED_REPLY;
+				return_error_param = ret;
+				return_error_line = __LINE__;
+				goto err_translate_failed;
+			}
+		} break;
 
-			if (ref == NULL) {
-				binder_user_error("%d:%d got transaction with invalid handle, %d\n",
-						proc->pid,
-						thread->pid, fp->handle);
+		case BINDER_TYPE_FD: {
+			struct binder_fd_object *fp = to_binder_fd_object(hdr);
+			int target_fd = binder_translate_fd(fp->fd, t, thread,
+							    in_reply_to);
+
+			if (target_fd < 0) {
 				return_error = BR_FAILED_REPLY;
-				goto err_binder_get_ref_failed;
+				return_error_param = target_fd;
+				return_error_line = __LINE__;
+				goto err_translate_failed;
 			}
-			if (security_binder_transfer_binder(proc->tsk,
-							    target_proc->tsk)) {
+			fp->pad_binder = 0;
+			fp->fd = target_fd;
+		} break;
+		case BINDER_TYPE_FDA: {
+			struct binder_fd_array_object *fda =
+				to_binder_fd_array_object(hdr);
+			struct binder_buffer_object *parent =
+				binder_validate_ptr(t->buffer, fda->parent,
+						    off_start,
+						    offp - off_start);
+			if (!parent) {
+				binder_user_error("%d:%d got transaction with invalid parent offset or type\n",
+						  proc->pid, thread->pid);
 				return_error = BR_FAILED_REPLY;
-				goto err_binder_get_ref_failed;
+				return_error_param = -EINVAL;
+				return_error_line = __LINE__;
+				goto err_bad_parent;
 			}
-			if (ref->node->proc == target_proc) {
-				if (fp->type == BINDER_TYPE_HANDLE)
-					fp->type = BINDER_TYPE_BINDER;
-				else
-					fp->type = BINDER_TYPE_WEAK_BINDER;
-				fp->binder = ref->node->ptr;
-				fp->cookie = ref->node->cookie;
-				binder_inc_node(ref->node, fp->type == BINDER_TYPE_BINDER, 0, NULL);
-				trace_binder_transaction_ref_to_node(t, ref);
-				binder_debug(BINDER_DEBUG_TRANSACTION,
-					     "        ref %d desc %d -> node %d u%016llx\n",
-					     ref->debug_id, ref->desc, ref->node->debug_id,
-					     (u64)ref->node->ptr);
-			} else {
-				struct binder_ref *new_ref;
-
-				new_ref = binder_get_ref_for_node(target_proc, ref->node);
-				if (new_ref == NULL) {
-					return_error = BR_FAILED_REPLY;
-					goto err_binder_get_ref_for_node_failed;
-				}
-				fp->binder = 0;
-				fp->handle = new_ref->desc;
-				fp->cookie = 0;
-				binder_inc_ref(new_ref, fp->type == BINDER_TYPE_HANDLE, NULL);
-				trace_binder_transaction_ref_to_ref(t, ref,
-								    new_ref);
-				binder_debug(BINDER_DEBUG_TRANSACTION,
-					     "        ref %d desc %d -> ref %d desc %d (node %d)\n",
-					     ref->debug_id, ref->desc, new_ref->debug_id,
-					     new_ref->desc, ref->node->debug_id);
+			if (!binder_validate_fixup(t->buffer, off_start,
+						   parent, fda->parent_offset,
+						   last_fixup_obj,
+						   last_fixup_min_off)) {
+				binder_user_error("%d:%d got transaction with out-of-order buffer fixup\n",
+						  proc->pid, thread->pid);
+				return_error = BR_FAILED_REPLY;
+				return_error_param = -EINVAL;
+				return_error_line = __LINE__;
+				goto err_bad_parent;
 			}
-		} break;
-
-		case BINDER_TYPE_FD: {
-			int target_fd;
-			struct file *file;
-
-			if (reply) {
-				if (!(in_reply_to->flags & TF_ACCEPT_FDS)) {
-					binder_user_error("%d:%d got reply with fd, %d, but target does not allow fds\n",
-						proc->pid, thread->pid, fp->handle);
-					return_error = BR_FAILED_REPLY;
-					goto err_fd_not_allowed;
-				}
-			} else if (!target_node->accept_fds) {
-				binder_user_error("%d:%d got transaction with fd, %d, but target does not allow fds\n",
-					proc->pid, thread->pid, fp->handle);
+			ret = binder_translate_fd_array(fda, parent, t, thread,
+							in_reply_to);
+			if (ret < 0) {
 				return_error = BR_FAILED_REPLY;
-				goto err_fd_not_allowed;
+				return_error_param = ret;
+				return_error_line = __LINE__;
+				goto err_translate_failed;
 			}
-
-			file = fget(fp->handle);
-			if (file == NULL) {
-				binder_user_error("%d:%d got transaction with invalid fd, %d\n",
-					proc->pid, thread->pid, fp->handle);
+			last_fixup_obj = parent;
+			last_fixup_min_off =
+				fda->parent_offset + sizeof(u32) * fda->num_fds;
+		} break;
+		case BINDER_TYPE_PTR: {
+			struct binder_buffer_object *bp =
+				to_binder_buffer_object(hdr);
+			size_t buf_left = sg_buf_end - sg_bufp;
+
+			if (bp->length > buf_left) {
+				binder_user_error("%d:%d got transaction with too large buffer\n",
+						  proc->pid, thread->pid);
 				return_error = BR_FAILED_REPLY;
-				goto err_fget_failed;
+				return_error_param = -EINVAL;
+				return_error_line = __LINE__;
+				goto err_bad_offset;
 			}
-			if (security_binder_transfer_file(proc->tsk,
-							  target_proc->tsk,
-							  file) < 0) {
-				fput(file);
+			if (copy_from_user(sg_bufp,
+					   (const void __user *)(uintptr_t)
+					   bp->buffer, bp->length)) {
+				binder_user_error("%d:%d got transaction with invalid offsets ptr\n",
+						  proc->pid, thread->pid);
+				return_error_param = -EFAULT;
 				return_error = BR_FAILED_REPLY;
-				goto err_get_unused_fd_failed;
+				return_error_line = __LINE__;
+				goto err_copy_data_failed;
 			}
-			target_fd = task_get_unused_fd_flags(target_proc, O_CLOEXEC);
-			if (target_fd < 0) {
-				fput(file);
+			/* Fixup buffer pointer to target proc address space */
+			bp->buffer = (uintptr_t)sg_bufp +
+				binder_alloc_get_user_buffer_offset(
+						&target_proc->alloc);
+			sg_bufp += ALIGN(bp->length, sizeof(u64));
+
+			ret = binder_fixup_parent(t, thread, bp, off_start,
+						  offp - off_start,
+						  last_fixup_obj,
+						  last_fixup_min_off);
+			if (ret < 0) {
 				return_error = BR_FAILED_REPLY;
-				goto err_get_unused_fd_failed;
+				return_error_param = ret;
+				return_error_line = __LINE__;
+				goto err_translate_failed;
 			}
-			task_fd_install(target_proc, target_fd, file);
-			trace_binder_transaction_fd(t, fp->handle, target_fd);
-			binder_debug(BINDER_DEBUG_TRANSACTION,
-				     "        fd %d -> %d\n", fp->handle, target_fd);
-			/* TODO: fput? */
-			fp->binder = 0;
-			fp->handle = target_fd;
+			last_fixup_obj = bp;
+			last_fixup_min_off = 0;
 		} break;
-
 		default:
 			binder_user_error("%d:%d got transaction with invalid object type, %x\n",
-				proc->pid, thread->pid, fp->type);
+				proc->pid, thread->pid, hdr->type);
 			return_error = BR_FAILED_REPLY;
+			return_error_param = -EINVAL;
+			return_error_line = __LINE__;
 			goto err_bad_object_type;
 		}
 	}
+	tcomplete->type = BINDER_WORK_TRANSACTION_COMPLETE;
+	t->work.type = BINDER_WORK_TRANSACTION;
+
 	if (reply) {
+		binder_enqueue_thread_work(thread, tcomplete);
+		binder_inner_proc_lock(target_proc);
+		if (target_thread->is_dead) {
+			binder_inner_proc_unlock(target_proc);
+			goto err_dead_proc_or_thread;
+		}
 		BUG_ON(t->buffer->async_transaction != 0);
-		binder_pop_transaction(target_thread, in_reply_to);
+		binder_pop_transaction_ilocked(target_thread, in_reply_to);
+		binder_enqueue_thread_work_ilocked(target_thread, &t->work);
+		binder_inner_proc_unlock(target_proc);
+		wake_up_interruptible_sync(&target_thread->wait);
+		binder_restore_priority(current, in_reply_to->saved_priority);
+		binder_free_transaction(in_reply_to);
 	} else if (!(t->flags & TF_ONE_WAY)) {
 		BUG_ON(t->buffer->async_transaction != 0);
+		binder_inner_proc_lock(proc);
+		/*
+		 * Defer the TRANSACTION_COMPLETE, so we don't return to
+		 * userspace immediately; this allows the target process to
+		 * immediately start processing this transaction, reducing
+		 * latency. We will then return the TRANSACTION_COMPLETE when
+		 * the target replies (or there is an error).
+		 */
+		binder_enqueue_deferred_thread_work_ilocked(thread, tcomplete);
 		t->need_reply = 1;
 		t->from_parent = thread->transaction_stack;
 		thread->transaction_stack = t;
+		binder_inner_proc_unlock(proc);
+		if (!binder_proc_transaction(t, target_proc, target_thread)) {
+			binder_inner_proc_lock(proc);
+			binder_pop_transaction_ilocked(thread, t);
+			binder_inner_proc_unlock(proc);
+			goto err_dead_proc_or_thread;
+		}
 	} else {
 		BUG_ON(target_node == NULL);
 		BUG_ON(t->buffer->async_transaction != 1);
-		if (target_node->has_async_transaction) {
-			target_list = &target_node->async_todo;
-			target_wait = NULL;
-		} else
-			target_node->has_async_transaction = 1;
-	}
-	t->work.type = BINDER_WORK_TRANSACTION;
-	list_add_tail(&t->work.entry, target_list);
-	tcomplete->type = BINDER_WORK_TRANSACTION_COMPLETE;
-	list_add_tail(&tcomplete->entry, &thread->todo);
-	if (target_wait) {
-		if (reply || !(t->flags & TF_ONE_WAY))
-			wake_up_interruptible_sync(target_wait);
-		else
-			wake_up_interruptible(target_wait);
+		binder_enqueue_thread_work(thread, tcomplete);
+		if (!binder_proc_transaction(t, target_proc, NULL))
+			goto err_dead_proc_or_thread;
 	}
+	if (target_thread)
+		binder_thread_dec_tmpref(target_thread);
+	binder_proc_dec_tmpref(target_proc);
+	if (target_node)
+		binder_dec_node_tmpref(target_node);
+	/*
+	 * write barrier to synchronize with initialization
+	 * of log entry
+	 */
+	smp_wmb();
+	WRITE_ONCE(e->debug_id_done, t_debug_id);
 	return;
 
-err_get_unused_fd_failed:
-err_fget_failed:
-err_fd_not_allowed:
-err_binder_get_ref_for_node_failed:
-err_binder_get_ref_failed:
-err_binder_new_node_failed:
+err_dead_proc_or_thread:
+	return_error = BR_DEAD_REPLY;
+	return_error_line = __LINE__;
+	binder_dequeue_work(proc, tcomplete);
+err_translate_failed:
 err_bad_object_type:
 err_bad_offset:
+err_bad_parent:
 err_copy_data_failed:
 	trace_binder_transaction_failed_buffer_release(t->buffer);
 	binder_transaction_buffer_release(target_proc, t->buffer, offp);
+	if (target_node)
+		binder_dec_node_tmpref(target_node);
+	target_node = NULL;
 	t->buffer->transaction = NULL;
-	binder_free_buf(target_proc, t->buffer);
+	binder_alloc_free_buf(&target_proc->alloc, t->buffer);
 err_binder_alloc_buf_failed:
 	kfree(tcomplete);
 	binder_stats_deleted(BINDER_STAT_TRANSACTION_COMPLETE);
@@ -1756,25 +3422,48 @@ static void binder_transaction(struct binder_proc *proc,
 err_empty_call_stack:
 err_dead_binder:
 err_invalid_target_handle:
-err_no_context_mgr_node:
+	if (target_thread)
+		binder_thread_dec_tmpref(target_thread);
+	if (target_proc)
+		binder_proc_dec_tmpref(target_proc);
+	if (target_node) {
+		binder_dec_node(target_node, 1, 0);
+		binder_dec_node_tmpref(target_node);
+	}
+
 	binder_debug(BINDER_DEBUG_FAILED_TRANSACTION,
-		     "%d:%d transaction failed %d, size %lld-%lld\n",
-		     proc->pid, thread->pid, return_error,
-		     (u64)tr->data_size, (u64)tr->offsets_size);
+		     "%d:%d transaction failed %d/%d, size %lld-%lld line %d\n",
+		     proc->pid, thread->pid, return_error, return_error_param,
+		     (u64)tr->data_size, (u64)tr->offsets_size,
+		     return_error_line);
 
 	{
 		struct binder_transaction_log_entry *fe;
 
+		e->return_error = return_error;
+		e->return_error_param = return_error_param;
+		e->return_error_line = return_error_line;
 		fe = binder_transaction_log_add(&binder_transaction_log_failed);
 		*fe = *e;
+		/*
+		 * write barrier to synchronize with initialization
+		 * of log entry
+		 */
+		smp_wmb();
+		WRITE_ONCE(e->debug_id_done, t_debug_id);
+		WRITE_ONCE(fe->debug_id_done, t_debug_id);
 	}
 
-	BUG_ON(thread->return_error != BR_OK);
+	BUG_ON(thread->return_error.cmd != BR_OK);
 	if (in_reply_to) {
-		thread->return_error = BR_TRANSACTION_COMPLETE;
+		binder_restore_priority(current, in_reply_to->saved_priority);
+		thread->return_error.cmd = BR_TRANSACTION_COMPLETE;
+		binder_enqueue_thread_work(thread, &thread->return_error.work);
 		binder_send_failed_reply(in_reply_to, return_error);
-	} else
-		thread->return_error = return_error;
+	} else {
+		thread->return_error.cmd = return_error;
+		binder_enqueue_thread_work(thread, &thread->return_error.work);
+	}
 }
 
 static int binder_thread_write(struct binder_proc *proc,
@@ -1783,19 +3472,22 @@ static int binder_thread_write(struct binder_proc *proc,
 			binder_size_t *consumed)
 {
 	uint32_t cmd;
+	struct binder_context *context = proc->context;
 	void __user *buffer = (void __user *)(uintptr_t)binder_buffer;
 	void __user *ptr = buffer + *consumed;
 	void __user *end = buffer + size;
 
-	while (ptr < end && thread->return_error == BR_OK) {
+	while (ptr < end && thread->return_error.cmd == BR_OK) {
+		int ret;
+
 		if (get_user(cmd, (uint32_t __user *)ptr))
 			return -EFAULT;
 		ptr += sizeof(uint32_t);
 		trace_binder_command(cmd);
 		if (_IOC_NR(cmd) < ARRAY_SIZE(binder_stats.bc)) {
-			binder_stats.bc[_IOC_NR(cmd)]++;
-			proc->stats.bc[_IOC_NR(cmd)]++;
-			thread->stats.bc[_IOC_NR(cmd)]++;
+			atomic_inc(&binder_stats.bc[_IOC_NR(cmd)]);
+			atomic_inc(&proc->stats.bc[_IOC_NR(cmd)]);
+			atomic_inc(&thread->stats.bc[_IOC_NR(cmd)]);
 		}
 		switch (cmd) {
 		case BC_INCREFS:
@@ -1803,53 +3495,61 @@ static int binder_thread_write(struct binder_proc *proc,
 		case BC_RELEASE:
 		case BC_DECREFS: {
 			uint32_t target;
-			struct binder_ref *ref;
 			const char *debug_string;
+			bool strong = cmd == BC_ACQUIRE || cmd == BC_RELEASE;
+			bool increment = cmd == BC_INCREFS || cmd == BC_ACQUIRE;
+			struct binder_ref_data rdata;
 
 			if (get_user(target, (uint32_t __user *)ptr))
 				return -EFAULT;
+
 			ptr += sizeof(uint32_t);
-			if (target == 0 && binder_context_mgr_node &&
-			    (cmd == BC_INCREFS || cmd == BC_ACQUIRE)) {
-				ref = binder_get_ref_for_node(proc,
-					       binder_context_mgr_node);
-				if (ref->desc != target) {
-					binder_user_error("%d:%d tried to acquire reference to desc 0, got %d instead\n",
-						proc->pid, thread->pid,
-						ref->desc);
-				}
-			} else
-				ref = binder_get_ref(proc, target,
-						     cmd == BC_ACQUIRE ||
-						     cmd == BC_RELEASE);
-			if (ref == NULL) {
-				binder_user_error("%d:%d refcount change on invalid ref %d\n",
-					proc->pid, thread->pid, target);
-				break;
+			ret = -1;
+			if (increment && !target) {
+				struct binder_node *ctx_mgr_node;
+				mutex_lock(&context->context_mgr_node_lock);
+				ctx_mgr_node = context->binder_context_mgr_node;
+				if (ctx_mgr_node)
+					ret = binder_inc_ref_for_node(
+							proc, ctx_mgr_node,
+							strong, NULL, &rdata);
+				mutex_unlock(&context->context_mgr_node_lock);
+			}
+			if (ret)
+				ret = binder_update_ref_for_handle(
+						proc, target, increment, strong,
+						&rdata);
+			if (!ret && rdata.desc != target) {
+				binder_user_error("%d:%d tried to acquire reference to desc %d, got %d instead\n",
+					proc->pid, thread->pid,
+					target, rdata.desc);
 			}
 			switch (cmd) {
 			case BC_INCREFS:
 				debug_string = "IncRefs";
-				binder_inc_ref(ref, 0, NULL);
 				break;
 			case BC_ACQUIRE:
 				debug_string = "Acquire";
-				binder_inc_ref(ref, 1, NULL);
 				break;
 			case BC_RELEASE:
 				debug_string = "Release";
-				binder_dec_ref(ref, 1);
 				break;
 			case BC_DECREFS:
 			default:
 				debug_string = "DecRefs";
-				binder_dec_ref(ref, 0);
+				break;
+			}
+			if (ret) {
+				binder_user_error("%d:%d %s %d refcount change on invalid ref %d ret %d\n",
+					proc->pid, thread->pid, debug_string,
+					strong, target, ret);
 				break;
 			}
 			binder_debug(BINDER_DEBUG_USER_REFS,
-				     "%d:%d %s ref %d desc %d s %d w %d for node %d\n",
-				     proc->pid, thread->pid, debug_string, ref->debug_id,
-				     ref->desc, ref->strong, ref->weak, ref->node->debug_id);
+				     "%d:%d %s ref %d desc %d s %d w %d\n",
+				     proc->pid, thread->pid, debug_string,
+				     rdata.debug_id, rdata.desc, rdata.strong,
+				     rdata.weak);
 			break;
 		}
 		case BC_INCREFS_DONE:
@@ -1857,6 +3557,7 @@ static int binder_thread_write(struct binder_proc *proc,
 			binder_uintptr_t node_ptr;
 			binder_uintptr_t cookie;
 			struct binder_node *node;
+			bool free_node;
 
 			if (get_user(node_ptr, (binder_uintptr_t __user *)ptr))
 				return -EFAULT;
@@ -1881,13 +3582,17 @@ static int binder_thread_write(struct binder_proc *proc,
 					"BC_INCREFS_DONE" : "BC_ACQUIRE_DONE",
 					(u64)node_ptr, node->debug_id,
 					(u64)cookie, (u64)node->cookie);
+				binder_put_node(node);
 				break;
 			}
+			binder_node_inner_lock(node);
 			if (cmd == BC_ACQUIRE_DONE) {
 				if (node->pending_strong_ref == 0) {
 					binder_user_error("%d:%d BC_ACQUIRE_DONE node %d has no pending acquire request\n",
 						proc->pid, thread->pid,
 						node->debug_id);
+					binder_node_inner_unlock(node);
+					binder_put_node(node);
 					break;
 				}
 				node->pending_strong_ref = 0;
@@ -1896,16 +3601,23 @@ static int binder_thread_write(struct binder_proc *proc,
 					binder_user_error("%d:%d BC_INCREFS_DONE node %d has no pending increfs request\n",
 						proc->pid, thread->pid,
 						node->debug_id);
+					binder_node_inner_unlock(node);
+					binder_put_node(node);
 					break;
 				}
 				node->pending_weak_ref = 0;
 			}
-			binder_dec_node(node, cmd == BC_ACQUIRE_DONE, 0);
+			free_node = binder_dec_node_nilocked(node,
+					cmd == BC_ACQUIRE_DONE, 0);
+			WARN_ON(free_node);
 			binder_debug(BINDER_DEBUG_USER_REFS,
-				     "%d:%d %s node %d ls %d lw %d\n",
+				     "%d:%d %s node %d ls %d lw %d tr %d\n",
 				     proc->pid, thread->pid,
 				     cmd == BC_INCREFS_DONE ? "BC_INCREFS_DONE" : "BC_ACQUIRE_DONE",
-				     node->debug_id, node->local_strong_refs, node->local_weak_refs);
+				     node->debug_id, node->local_strong_refs,
+				     node->local_weak_refs, node->tmp_refs);
+			binder_node_inner_unlock(node);
+			binder_put_node(node);
 			break;
 		}
 		case BC_ATTEMPT_ACQUIRE:
@@ -1923,7 +3635,8 @@ static int binder_thread_write(struct binder_proc *proc,
 				return -EFAULT;
 			ptr += sizeof(binder_uintptr_t);
 
-			buffer = binder_buffer_lookup(proc, data_ptr);
+			buffer = binder_alloc_prepare_to_free(&proc->alloc,
+							      data_ptr);
 			if (buffer == NULL) {
 				binder_user_error("%d:%d BC_FREE_BUFFER u%016llx no match\n",
 					proc->pid, thread->pid, (u64)data_ptr);
@@ -1945,18 +3658,41 @@ static int binder_thread_write(struct binder_proc *proc,
 				buffer->transaction = NULL;
 			}
 			if (buffer->async_transaction && buffer->target_node) {
-				BUG_ON(!buffer->target_node->has_async_transaction);
-				if (list_empty(&buffer->target_node->async_todo))
-					buffer->target_node->has_async_transaction = 0;
-				else
-					list_move_tail(buffer->target_node->async_todo.next, &thread->todo);
+				struct binder_node *buf_node;
+				struct binder_work *w;
+
+				buf_node = buffer->target_node;
+				binder_node_inner_lock(buf_node);
+				BUG_ON(!buf_node->has_async_transaction);
+				BUG_ON(buf_node->proc != proc);
+				w = binder_dequeue_work_head_ilocked(
+						&buf_node->async_todo);
+				if (!w) {
+					buf_node->has_async_transaction = false;
+				} else {
+					binder_enqueue_work_ilocked(
+							w, &proc->todo);
+					binder_wakeup_proc_ilocked(proc);
+				}
+				binder_node_inner_unlock(buf_node);
 			}
 			trace_binder_transaction_buffer_release(buffer);
 			binder_transaction_buffer_release(proc, buffer, NULL);
-			binder_free_buf(proc, buffer);
+			binder_alloc_free_buf(&proc->alloc, buffer);
 			break;
 		}
 
+		case BC_TRANSACTION_SG:
+		case BC_REPLY_SG: {
+			struct binder_transaction_data_sg tr;
+
+			if (copy_from_user(&tr, ptr, sizeof(tr)))
+				return -EFAULT;
+			ptr += sizeof(tr);
+			binder_transaction(proc, thread, &tr.transaction_data,
+					   cmd == BC_REPLY_SG, tr.buffers_size);
+			break;
+		}
 		case BC_TRANSACTION:
 		case BC_REPLY: {
 			struct binder_transaction_data tr;
@@ -1964,7 +3700,8 @@ static int binder_thread_write(struct binder_proc *proc,
 			if (copy_from_user(&tr, ptr, sizeof(tr)))
 				return -EFAULT;
 			ptr += sizeof(tr);
-			binder_transaction(proc, thread, &tr, cmd == BC_REPLY);
+			binder_transaction(proc, thread, &tr,
+					   cmd == BC_REPLY, 0);
 			break;
 		}
 
@@ -1972,6 +3709,7 @@ static int binder_thread_write(struct binder_proc *proc,
 			binder_debug(BINDER_DEBUG_THREADS,
 				     "%d:%d BC_REGISTER_LOOPER\n",
 				     proc->pid, thread->pid);
+			binder_inner_proc_lock(proc);
 			if (thread->looper & BINDER_LOOPER_STATE_ENTERED) {
 				thread->looper |= BINDER_LOOPER_STATE_INVALID;
 				binder_user_error("%d:%d ERROR: BC_REGISTER_LOOPER called after BC_ENTER_LOOPER\n",
@@ -1985,6 +3723,7 @@ static int binder_thread_write(struct binder_proc *proc,
 				proc->requested_threads_started++;
 			}
 			thread->looper |= BINDER_LOOPER_STATE_REGISTERED;
+			binder_inner_proc_unlock(proc);
 			break;
 		case BC_ENTER_LOOPER:
 			binder_debug(BINDER_DEBUG_THREADS,
@@ -2009,7 +3748,7 @@ static int binder_thread_write(struct binder_proc *proc,
 			uint32_t target;
 			binder_uintptr_t cookie;
 			struct binder_ref *ref;
-			struct binder_ref_death *death;
+			struct binder_ref_death *death = NULL;
 
 			if (get_user(target, (uint32_t __user *)ptr))
 				return -EFAULT;
@@ -2017,7 +3756,28 @@ static int binder_thread_write(struct binder_proc *proc,
 			if (get_user(cookie, (binder_uintptr_t __user *)ptr))
 				return -EFAULT;
 			ptr += sizeof(binder_uintptr_t);
-			ref = binder_get_ref(proc, target, false);
+			if (cmd == BC_REQUEST_DEATH_NOTIFICATION) {
+				/*
+				 * Allocate memory for death notification
+				 * before taking lock
+				 */
+				death = kzalloc(sizeof(*death), GFP_KERNEL);
+				if (death == NULL) {
+					WARN_ON(thread->return_error.cmd !=
+						BR_OK);
+					thread->return_error.cmd = BR_ERROR;
+					binder_enqueue_thread_work(
+						thread,
+						&thread->return_error.work);
+					binder_debug(
+						BINDER_DEBUG_FAILED_TRANSACTION,
+						"%d:%d BC_REQUEST_DEATH_NOTIFICATION failed\n",
+						proc->pid, thread->pid);
+					break;
+				}
+			}
+			binder_proc_lock(proc);
+			ref = binder_get_ref_olocked(proc, target, false);
 			if (ref == NULL) {
 				binder_user_error("%d:%d %s invalid ref %d\n",
 					proc->pid, thread->pid,
@@ -2025,6 +3785,8 @@ static int binder_thread_write(struct binder_proc *proc,
 					"BC_REQUEST_DEATH_NOTIFICATION" :
 					"BC_CLEAR_DEATH_NOTIFICATION",
 					target);
+				binder_proc_unlock(proc);
+				kfree(death);
 				break;
 			}
 
@@ -2034,21 +3796,18 @@ static int binder_thread_write(struct binder_proc *proc,
 				     cmd == BC_REQUEST_DEATH_NOTIFICATION ?
 				     "BC_REQUEST_DEATH_NOTIFICATION" :
 				     "BC_CLEAR_DEATH_NOTIFICATION",
-				     (u64)cookie, ref->debug_id, ref->desc,
-				     ref->strong, ref->weak, ref->node->debug_id);
+				     (u64)cookie, ref->data.debug_id,
+				     ref->data.desc, ref->data.strong,
+				     ref->data.weak, ref->node->debug_id);
 
+			binder_node_lock(ref->node);
 			if (cmd == BC_REQUEST_DEATH_NOTIFICATION) {
 				if (ref->death) {
 					binder_user_error("%d:%d BC_REQUEST_DEATH_NOTIFICATION death notification already set\n",
 						proc->pid, thread->pid);
-					break;
-				}
-				death = kzalloc(sizeof(*death), GFP_KERNEL);
-				if (death == NULL) {
-					thread->return_error = BR_ERROR;
-					binder_debug(BINDER_DEBUG_FAILED_TRANSACTION,
-						     "%d:%d BC_REQUEST_DEATH_NOTIFICATION failed\n",
-						     proc->pid, thread->pid);
+					binder_node_unlock(ref->node);
+					binder_proc_unlock(proc);
+					kfree(death);
 					break;
 				}
 				binder_stats_created(BINDER_STAT_DEATH);
@@ -2057,17 +3816,19 @@ static int binder_thread_write(struct binder_proc *proc,
 				ref->death = death;
 				if (ref->node->proc == NULL) {
 					ref->death->work.type = BINDER_WORK_DEAD_BINDER;
-					if (thread->looper & (BINDER_LOOPER_STATE_REGISTERED | BINDER_LOOPER_STATE_ENTERED)) {
-						list_add_tail(&ref->death->work.entry, &thread->todo);
-					} else {
-						list_add_tail(&ref->death->work.entry, &proc->todo);
-						wake_up_interruptible(&proc->wait);
-					}
+
+					binder_inner_proc_lock(proc);
+					binder_enqueue_work_ilocked(
+						&ref->death->work, &proc->todo);
+					binder_wakeup_proc_ilocked(proc);
+					binder_inner_proc_unlock(proc);
 				}
 			} else {
 				if (ref->death == NULL) {
 					binder_user_error("%d:%d BC_CLEAR_DEATH_NOTIFICATION death notification not active\n",
 						proc->pid, thread->pid);
+					binder_node_unlock(ref->node);
+					binder_proc_unlock(proc);
 					break;
 				}
 				death = ref->death;
@@ -2076,22 +3837,35 @@ static int binder_thread_write(struct binder_proc *proc,
 						proc->pid, thread->pid,
 						(u64)death->cookie,
 						(u64)cookie);
+					binder_node_unlock(ref->node);
+					binder_proc_unlock(proc);
 					break;
 				}
 				ref->death = NULL;
+				binder_inner_proc_lock(proc);
 				if (list_empty(&death->work.entry)) {
 					death->work.type = BINDER_WORK_CLEAR_DEATH_NOTIFICATION;
-					if (thread->looper & (BINDER_LOOPER_STATE_REGISTERED | BINDER_LOOPER_STATE_ENTERED)) {
-						list_add_tail(&death->work.entry, &thread->todo);
-					} else {
-						list_add_tail(&death->work.entry, &proc->todo);
-						wake_up_interruptible(&proc->wait);
+					if (thread->looper &
+					    (BINDER_LOOPER_STATE_REGISTERED |
+					     BINDER_LOOPER_STATE_ENTERED))
+						binder_enqueue_thread_work_ilocked(
+								thread,
+								&death->work);
+					else {
+						binder_enqueue_work_ilocked(
+								&death->work,
+								&proc->todo);
+						binder_wakeup_proc_ilocked(
+								proc);
 					}
 				} else {
 					BUG_ON(death->work.type != BINDER_WORK_DEAD_BINDER);
 					death->work.type = BINDER_WORK_DEAD_BINDER_AND_CLEAR;
 				}
+				binder_inner_proc_unlock(proc);
 			}
+			binder_node_unlock(ref->node);
+			binder_proc_unlock(proc);
 		} break;
 		case BC_DEAD_BINDER_DONE: {
 			struct binder_work *w;
@@ -2102,8 +3876,13 @@ static int binder_thread_write(struct binder_proc *proc,
 				return -EFAULT;
 
 			ptr += sizeof(cookie);
-			list_for_each_entry(w, &proc->delivered_death, entry) {
-				struct binder_ref_death *tmp_death = container_of(w, struct binder_ref_death, work);
+			binder_inner_proc_lock(proc);
+			list_for_each_entry(w, &proc->delivered_death,
+					    entry) {
+				struct binder_ref_death *tmp_death =
+					container_of(w,
+						     struct binder_ref_death,
+						     work);
 
 				if (tmp_death->cookie == cookie) {
 					death = tmp_death;
@@ -2111,25 +3890,31 @@ static int binder_thread_write(struct binder_proc *proc,
 				}
 			}
 			binder_debug(BINDER_DEBUG_DEAD_BINDER,
-				     "%d:%d BC_DEAD_BINDER_DONE %016llx found %p\n",
+				     "%d:%d BC_DEAD_BINDER_DONE %016llx found %pK\n",
 				     proc->pid, thread->pid, (u64)cookie,
 				     death);
 			if (death == NULL) {
 				binder_user_error("%d:%d BC_DEAD_BINDER_DONE %016llx not found\n",
 					proc->pid, thread->pid, (u64)cookie);
+				binder_inner_proc_unlock(proc);
 				break;
 			}
-
-			list_del_init(&death->work.entry);
+			binder_dequeue_work_ilocked(&death->work);
 			if (death->work.type == BINDER_WORK_DEAD_BINDER_AND_CLEAR) {
 				death->work.type = BINDER_WORK_CLEAR_DEATH_NOTIFICATION;
-				if (thread->looper & (BINDER_LOOPER_STATE_REGISTERED | BINDER_LOOPER_STATE_ENTERED)) {
-					list_add_tail(&death->work.entry, &thread->todo);
-				} else {
-					list_add_tail(&death->work.entry, &proc->todo);
-					wake_up_interruptible(&proc->wait);
+				if (thread->looper &
+					(BINDER_LOOPER_STATE_REGISTERED |
+					 BINDER_LOOPER_STATE_ENTERED))
+					binder_enqueue_thread_work_ilocked(
+						thread, &death->work);
+				else {
+					binder_enqueue_work_ilocked(
+							&death->work,
+							&proc->todo);
+					binder_wakeup_proc_ilocked(proc);
 				}
 			}
+			binder_inner_proc_unlock(proc);
 		} break;
 
 		default:
@@ -2147,23 +3932,73 @@ static void binder_stat_br(struct binder_proc *proc,
 {
 	trace_binder_return(cmd);
 	if (_IOC_NR(cmd) < ARRAY_SIZE(binder_stats.br)) {
-		binder_stats.br[_IOC_NR(cmd)]++;
-		proc->stats.br[_IOC_NR(cmd)]++;
-		thread->stats.br[_IOC_NR(cmd)]++;
+		atomic_inc(&binder_stats.br[_IOC_NR(cmd)]);
+		atomic_inc(&proc->stats.br[_IOC_NR(cmd)]);
+		atomic_inc(&thread->stats.br[_IOC_NR(cmd)]);
 	}
 }
 
-static int binder_has_proc_work(struct binder_proc *proc,
-				struct binder_thread *thread)
+static int binder_put_node_cmd(struct binder_proc *proc,
+			       struct binder_thread *thread,
+			       void __user **ptrp,
+			       binder_uintptr_t node_ptr,
+			       binder_uintptr_t node_cookie,
+			       int node_debug_id,
+			       uint32_t cmd, const char *cmd_name)
 {
-	return !list_empty(&proc->todo) ||
-		(thread->looper & BINDER_LOOPER_STATE_NEED_RETURN);
+	void __user *ptr = *ptrp;
+
+	if (put_user(cmd, (uint32_t __user *)ptr))
+		return -EFAULT;
+	ptr += sizeof(uint32_t);
+
+	if (put_user(node_ptr, (binder_uintptr_t __user *)ptr))
+		return -EFAULT;
+	ptr += sizeof(binder_uintptr_t);
+
+	if (put_user(node_cookie, (binder_uintptr_t __user *)ptr))
+		return -EFAULT;
+	ptr += sizeof(binder_uintptr_t);
+
+	binder_stat_br(proc, thread, cmd);
+	binder_debug(BINDER_DEBUG_USER_REFS, "%d:%d %s %d u%016llx c%016llx\n",
+		     proc->pid, thread->pid, cmd_name, node_debug_id,
+		     (u64)node_ptr, (u64)node_cookie);
+
+	*ptrp = ptr;
+	return 0;
 }
 
-static int binder_has_thread_work(struct binder_thread *thread)
+static int binder_wait_for_work(struct binder_thread *thread,
+				bool do_proc_work)
 {
-	return !list_empty(&thread->todo) || thread->return_error != BR_OK ||
-		(thread->looper & BINDER_LOOPER_STATE_NEED_RETURN);
+	DEFINE_WAIT(wait);
+	struct binder_proc *proc = thread->proc;
+	int ret = 0;
+
+	freezer_do_not_count();
+	binder_inner_proc_lock(proc);
+	for (;;) {
+		prepare_to_wait(&thread->wait, &wait, TASK_INTERRUPTIBLE);
+		if (binder_has_work_ilocked(thread, do_proc_work))
+			break;
+		if (do_proc_work)
+			list_add(&thread->waiting_thread_node,
+				 &proc->waiting_threads);
+		binder_inner_proc_unlock(proc);
+		schedule();
+		binder_inner_proc_lock(proc);
+		list_del_init(&thread->waiting_thread_node);
+		if (signal_pending(current)) {
+			ret = -ERESTARTSYS;
+			break;
+		}
+	}
+	finish_wait(&thread->wait, &wait);
+	binder_inner_proc_unlock(proc);
+	freezer_count();
+
+	return ret;
 }
 
 static int binder_thread_read(struct binder_proc *proc,
@@ -2185,37 +4020,15 @@ static int binder_thread_read(struct binder_proc *proc,
 	}
 
 retry:
-	wait_for_proc_work = thread->transaction_stack == NULL &&
-				list_empty(&thread->todo);
-
-	if (thread->return_error != BR_OK && ptr < end) {
-		if (thread->return_error2 != BR_OK) {
-			if (put_user(thread->return_error2, (uint32_t __user *)ptr))
-				return -EFAULT;
-			ptr += sizeof(uint32_t);
-			binder_stat_br(proc, thread, thread->return_error2);
-			if (ptr == end)
-				goto done;
-			thread->return_error2 = BR_OK;
-		}
-		if (put_user(thread->return_error, (uint32_t __user *)ptr))
-			return -EFAULT;
-		ptr += sizeof(uint32_t);
-		binder_stat_br(proc, thread, thread->return_error);
-		thread->return_error = BR_OK;
-		goto done;
-	}
-
+	binder_inner_proc_lock(proc);
+	wait_for_proc_work = binder_available_for_proc_work_ilocked(thread);
+	binder_inner_proc_unlock(proc);
 
 	thread->looper |= BINDER_LOOPER_STATE_WAITING;
-	if (wait_for_proc_work)
-		proc->ready_threads++;
-
-	binder_unlock(__func__);
 
 	trace_binder_wait_for_work(wait_for_proc_work,
 				   !!thread->transaction_stack,
-				   !list_empty(&thread->todo));
+				   !binder_worklist_empty(proc, &thread->todo));
 	if (wait_for_proc_work) {
 		if (!(thread->looper & (BINDER_LOOPER_STATE_REGISTERED |
 					BINDER_LOOPER_STATE_ENTERED))) {
@@ -2224,24 +4037,16 @@ static int binder_thread_read(struct binder_proc *proc,
 			wait_event_interruptible(binder_user_error_wait,
 						 binder_stop_on_user_error < 2);
 		}
-		binder_set_nice(proc->default_priority);
-		if (non_block) {
-			if (!binder_has_proc_work(proc, thread))
-				ret = -EAGAIN;
-		} else
-			ret = wait_event_freezable_exclusive(proc->wait, binder_has_proc_work(proc, thread));
-	} else {
-		if (non_block) {
-			if (!binder_has_thread_work(thread))
-				ret = -EAGAIN;
-		} else
-			ret = wait_event_freezable(thread->wait, binder_has_thread_work(thread));
+		binder_restore_priority(current, proc->default_priority);
 	}
 
-	binder_lock(__func__);
+	if (non_block) {
+		if (!binder_has_work(thread, wait_for_proc_work))
+			ret = -EAGAIN;
+	} else {
+		ret = binder_wait_for_work(thread, wait_for_proc_work);
+	}
 
-	if (wait_for_proc_work)
-		proc->ready_threads--;
 	thread->looper &= ~BINDER_LOOPER_STATE_WAITING;
 
 	if (ret)
@@ -2250,31 +4055,55 @@ static int binder_thread_read(struct binder_proc *proc,
 	while (1) {
 		uint32_t cmd;
 		struct binder_transaction_data tr;
-		struct binder_work *w;
+		struct binder_work *w = NULL;
+		struct list_head *list = NULL;
 		struct binder_transaction *t = NULL;
+		struct binder_thread *t_from;
+
+		binder_inner_proc_lock(proc);
+		if (!binder_worklist_empty_ilocked(&thread->todo))
+			list = &thread->todo;
+		else if (!binder_worklist_empty_ilocked(&proc->todo) &&
+			   wait_for_proc_work)
+			list = &proc->todo;
+		else {
+			binder_inner_proc_unlock(proc);
 
-		if (!list_empty(&thread->todo)) {
-			w = list_first_entry(&thread->todo, struct binder_work,
-					     entry);
-		} else if (!list_empty(&proc->todo) && wait_for_proc_work) {
-			w = list_first_entry(&proc->todo, struct binder_work,
-					     entry);
-		} else {
 			/* no data added */
-			if (ptr - buffer == 4 &&
-			    !(thread->looper & BINDER_LOOPER_STATE_NEED_RETURN))
+			if (ptr - buffer == 4 && !thread->looper_need_return)
 				goto retry;
 			break;
 		}
 
-		if (end - ptr < sizeof(tr) + 4)
+		if (end - ptr < sizeof(tr) + 4) {
+			binder_inner_proc_unlock(proc);
 			break;
+		}
+		w = binder_dequeue_work_head_ilocked(list);
+		if (binder_worklist_empty_ilocked(&thread->todo))
+			thread->process_todo = false;
 
 		switch (w->type) {
 		case BINDER_WORK_TRANSACTION: {
+			binder_inner_proc_unlock(proc);
 			t = container_of(w, struct binder_transaction, work);
 		} break;
+		case BINDER_WORK_RETURN_ERROR: {
+			struct binder_error *e = container_of(
+					w, struct binder_error, work);
+
+			WARN_ON(e->cmd == BR_OK);
+			binder_inner_proc_unlock(proc);
+			if (put_user(e->cmd, (uint32_t __user *)ptr))
+				return -EFAULT;
+			cmd = e->cmd;
+			e->cmd = BR_OK;
+			ptr += sizeof(uint32_t);
+
+			binder_stat_br(proc, thread, cmd);
+		} break;
 		case BINDER_WORK_TRANSACTION_COMPLETE: {
+			binder_inner_proc_unlock(proc);
 			cmd = BR_TRANSACTION_COMPLETE;
 			if (put_user(cmd, (uint32_t __user *)ptr))
 				return -EFAULT;
@@ -2284,113 +4113,134 @@ static int binder_thread_read(struct binder_proc *proc,
 			binder_debug(BINDER_DEBUG_TRANSACTION_COMPLETE,
 				     "%d:%d BR_TRANSACTION_COMPLETE\n",
 				     proc->pid, thread->pid);
-
-			list_del(&w->entry);
 			kfree(w);
 			binder_stats_deleted(BINDER_STAT_TRANSACTION_COMPLETE);
 		} break;
 		case BINDER_WORK_NODE: {
 			struct binder_node *node = container_of(w, struct binder_node, work);
-			uint32_t cmd = BR_NOOP;
-			const char *cmd_name;
-			int strong = node->internal_strong_refs || node->local_strong_refs;
-			int weak = !hlist_empty(&node->refs) || node->local_weak_refs || strong;
-
-			if (weak && !node->has_weak_ref) {
-				cmd = BR_INCREFS;
-				cmd_name = "BR_INCREFS";
+			int strong, weak;
+			binder_uintptr_t node_ptr = node->ptr;
+			binder_uintptr_t node_cookie = node->cookie;
+			int node_debug_id = node->debug_id;
+			int has_weak_ref;
+			int has_strong_ref;
+			void __user *orig_ptr = ptr;
+
+			BUG_ON(proc != node->proc);
+			strong = node->internal_strong_refs ||
+					node->local_strong_refs;
+			weak = !hlist_empty(&node->refs) ||
+					node->local_weak_refs ||
+					node->tmp_refs || strong;
+			has_strong_ref = node->has_strong_ref;
+			has_weak_ref = node->has_weak_ref;
+
+			if (weak && !has_weak_ref) {
 				node->has_weak_ref = 1;
 				node->pending_weak_ref = 1;
 				node->local_weak_refs++;
-			} else if (strong && !node->has_strong_ref) {
-				cmd = BR_ACQUIRE;
-				cmd_name = "BR_ACQUIRE";
+			}
+			if (strong && !has_strong_ref) {
 				node->has_strong_ref = 1;
 				node->pending_strong_ref = 1;
 				node->local_strong_refs++;
-			} else if (!strong && node->has_strong_ref) {
-				cmd = BR_RELEASE;
-				cmd_name = "BR_RELEASE";
+			}
+			if (!strong && has_strong_ref)
 				node->has_strong_ref = 0;
-			} else if (!weak && node->has_weak_ref) {
-				cmd = BR_DECREFS;
-				cmd_name = "BR_DECREFS";
+			if (!weak && has_weak_ref)
 				node->has_weak_ref = 0;
-			}
-			if (cmd != BR_NOOP) {
-				if (put_user(cmd, (uint32_t __user *)ptr))
-					return -EFAULT;
-				ptr += sizeof(uint32_t);
-				if (put_user(node->ptr,
-					     (binder_uintptr_t __user *)ptr))
-					return -EFAULT;
-				ptr += sizeof(binder_uintptr_t);
-				if (put_user(node->cookie,
-					     (binder_uintptr_t __user *)ptr))
-					return -EFAULT;
-				ptr += sizeof(binder_uintptr_t);
-
-				binder_stat_br(proc, thread, cmd);
-				binder_debug(BINDER_DEBUG_USER_REFS,
-					     "%d:%d %s %d u%016llx c%016llx\n",
-					     proc->pid, thread->pid, cmd_name,
-					     node->debug_id,
-					     (u64)node->ptr, (u64)node->cookie);
-			} else {
-				list_del_init(&w->entry);
-				if (!weak && !strong) {
-					binder_debug(BINDER_DEBUG_INTERNAL_REFS,
-						     "%d:%d node %d u%016llx c%016llx deleted\n",
-						     proc->pid, thread->pid,
-						     node->debug_id,
-						     (u64)node->ptr,
-						     (u64)node->cookie);
-					rb_erase(&node->rb_node, &proc->nodes);
-					kfree(node);
-					binder_stats_deleted(BINDER_STAT_NODE);
-				} else {
-					binder_debug(BINDER_DEBUG_INTERNAL_REFS,
-						     "%d:%d node %d u%016llx c%016llx state unchanged\n",
-						     proc->pid, thread->pid,
-						     node->debug_id,
-						     (u64)node->ptr,
-						     (u64)node->cookie);
-				}
-			}
+			if (!weak && !strong) {
+				binder_debug(BINDER_DEBUG_INTERNAL_REFS,
+					     "%d:%d node %d u%016llx c%016llx deleted\n",
+					     proc->pid, thread->pid,
+					     node_debug_id,
+					     (u64)node_ptr,
+					     (u64)node_cookie);
+				rb_erase(&node->rb_node, &proc->nodes);
+				binder_inner_proc_unlock(proc);
+				binder_node_lock(node);
+				/*
+				 * Acquire the node lock before freeing the
+				 * node to serialize with other threads that
+				 * may have been holding the node lock while
+				 * decrementing this node (avoids race where
+				 * this thread frees while the other thread
+				 * is unlocking the node after the final
+				 * decrement)
+				 */
+				binder_node_unlock(node);
+				binder_free_node(node);
+			} else
+				binder_inner_proc_unlock(proc);
+
+			if (weak && !has_weak_ref)
+				ret = binder_put_node_cmd(
+						proc, thread, &ptr, node_ptr,
+						node_cookie, node_debug_id,
+						BR_INCREFS, "BR_INCREFS");
+			if (!ret && strong && !has_strong_ref)
+				ret = binder_put_node_cmd(
+						proc, thread, &ptr, node_ptr,
+						node_cookie, node_debug_id,
+						BR_ACQUIRE, "BR_ACQUIRE");
+			if (!ret && !strong && has_strong_ref)
+				ret = binder_put_node_cmd(
+						proc, thread, &ptr, node_ptr,
+						node_cookie, node_debug_id,
+						BR_RELEASE, "BR_RELEASE");
+			if (!ret && !weak && has_weak_ref)
+				ret = binder_put_node_cmd(
+						proc, thread, &ptr, node_ptr,
+						node_cookie, node_debug_id,
+						BR_DECREFS, "BR_DECREFS");
+			if (orig_ptr == ptr)
+				binder_debug(BINDER_DEBUG_INTERNAL_REFS,
+					     "%d:%d node %d u%016llx c%016llx state unchanged\n",
+					     proc->pid, thread->pid,
+					     node_debug_id,
+					     (u64)node_ptr,
+					     (u64)node_cookie);
+			if (ret)
+				return ret;
 		} break;
 		case BINDER_WORK_DEAD_BINDER:
 		case BINDER_WORK_DEAD_BINDER_AND_CLEAR:
 		case BINDER_WORK_CLEAR_DEATH_NOTIFICATION: {
 			struct binder_ref_death *death;
 			uint32_t cmd;
+			binder_uintptr_t cookie;
 
 			death = container_of(w, struct binder_ref_death, work);
 			if (w->type == BINDER_WORK_CLEAR_DEATH_NOTIFICATION)
 				cmd = BR_CLEAR_DEATH_NOTIFICATION_DONE;
 			else
 				cmd = BR_DEAD_BINDER;
-			if (put_user(cmd, (uint32_t __user *)ptr))
-				return -EFAULT;
-			ptr += sizeof(uint32_t);
-			if (put_user(death->cookie,
-				     (binder_uintptr_t __user *)ptr))
-				return -EFAULT;
-			ptr += sizeof(binder_uintptr_t);
-			binder_stat_br(proc, thread, cmd);
+			cookie = death->cookie;
+
 			binder_debug(BINDER_DEBUG_DEATH_NOTIFICATION,
 				     "%d:%d %s %016llx\n",
 				      proc->pid, thread->pid,
 				      cmd == BR_DEAD_BINDER ?
 				      "BR_DEAD_BINDER" :
 				      "BR_CLEAR_DEATH_NOTIFICATION_DONE",
-				      (u64)death->cookie);
-
+				      (u64)cookie);
 			if (w->type == BINDER_WORK_CLEAR_DEATH_NOTIFICATION) {
-				list_del(&w->entry);
+				binder_inner_proc_unlock(proc);
 				kfree(death);
 				binder_stats_deleted(BINDER_STAT_DEATH);
-			} else
-				list_move(&w->entry, &proc->delivered_death);
+			} else {
+				binder_enqueue_work_ilocked(
+						w, &proc->delivered_death);
+				binder_inner_proc_unlock(proc);
+			}
+			if (put_user(cmd, (uint32_t __user *)ptr))
+				return -EFAULT;
+			ptr += sizeof(uint32_t);
+			if (put_user(cookie,
+				     (binder_uintptr_t __user *)ptr))
+				return -EFAULT;
+			ptr += sizeof(binder_uintptr_t);
+			binder_stat_br(proc, thread, cmd);
 			if (cmd == BR_DEAD_BINDER)
 				goto done; /* DEAD_BINDER notifications can cause transactions */
 		} break;
@@ -2402,16 +4252,14 @@ static int binder_thread_read(struct binder_proc *proc,
 		BUG_ON(t->buffer == NULL);
 		if (t->buffer->target_node) {
 			struct binder_node *target_node = t->buffer->target_node;
+			struct binder_priority node_prio;
 
 			tr.target.ptr = target_node->ptr;
 			tr.cookie =  target_node->cookie;
-			t->saved_priority = task_nice(current);
-			if (t->priority < target_node->min_priority &&
-			    !(t->flags & TF_ONE_WAY))
-				binder_set_nice(t->priority);
-			else if (!(t->flags & TF_ONE_WAY) ||
-				 t->saved_priority > target_node->min_priority)
-				binder_set_nice(target_node->min_priority);
+			node_prio.sched_policy = target_node->sched_policy;
+			node_prio.prio = target_node->min_priority;
+			binder_transaction_priority(current, t, node_prio,
+						    target_node->inherit_rt);
 			cmd = BR_TRANSACTION;
 		} else {
 			tr.target.ptr = 0;
@@ -2422,8 +4270,9 @@ static int binder_thread_read(struct binder_proc *proc,
 		tr.flags = t->flags;
 		tr.sender_euid = from_kuid(current_user_ns(), t->sender_euid);
 
-		if (t->from) {
-			struct task_struct *sender = t->from->proc->tsk;
+		t_from = binder_get_txn_from(t);
+		if (t_from) {
+			struct task_struct *sender = t_from->proc->tsk;
 
 			tr.sender_pid = task_tgid_nr_ns(sender,
 							task_active_pid_ns(current));
@@ -2433,18 +4282,32 @@ static int binder_thread_read(struct binder_proc *proc,
 
 		tr.data_size = t->buffer->data_size;
 		tr.offsets_size = t->buffer->offsets_size;
-		tr.data.ptr.buffer = (binder_uintptr_t)(
-					(uintptr_t)t->buffer->data +
-					proc->user_buffer_offset);
+		tr.data.ptr.buffer = (binder_uintptr_t)
+			((uintptr_t)t->buffer->data +
+			binder_alloc_get_user_buffer_offset(&proc->alloc));
 		tr.data.ptr.offsets = tr.data.ptr.buffer +
 					ALIGN(t->buffer->data_size,
 					    sizeof(void *));
 
-		if (put_user(cmd, (uint32_t __user *)ptr))
+		if (put_user(cmd, (uint32_t __user *)ptr)) {
+			if (t_from)
+				binder_thread_dec_tmpref(t_from);
+
+			binder_cleanup_transaction(t, "put_user failed",
+						   BR_FAILED_REPLY);
+
 			return -EFAULT;
+		}
 		ptr += sizeof(uint32_t);
-		if (copy_to_user(ptr, &tr, sizeof(tr)))
+		if (copy_to_user(ptr, &tr, sizeof(tr))) {
+			if (t_from)
+				binder_thread_dec_tmpref(t_from);
+
+			binder_cleanup_transaction(t, "copy_to_user failed",
+						   BR_FAILED_REPLY);
+
 			return -EFAULT;
+		}
 		ptr += sizeof(tr);
 
 		trace_binder_transaction_received(t);
@@ -2454,21 +4317,22 @@ static int binder_thread_read(struct binder_proc *proc,
 			     proc->pid, thread->pid,
 			     (cmd == BR_TRANSACTION) ? "BR_TRANSACTION" :
 			     "BR_REPLY",
-			     t->debug_id, t->from ? t->from->proc->pid : 0,
-			     t->from ? t->from->pid : 0, cmd,
+			     t->debug_id, t_from ? t_from->proc->pid : 0,
+			     t_from ? t_from->pid : 0, cmd,
 			     t->buffer->data_size, t->buffer->offsets_size,
 			     (u64)tr.data.ptr.buffer, (u64)tr.data.ptr.offsets);
 
-		list_del(&t->work.entry);
+		if (t_from)
+			binder_thread_dec_tmpref(t_from);
 		t->buffer->allow_user_free = 1;
 		if (cmd == BR_TRANSACTION && !(t->flags & TF_ONE_WAY)) {
+			binder_inner_proc_lock(thread->proc);
 			t->to_parent = thread->transaction_stack;
 			t->to_thread = thread;
 			thread->transaction_stack = t;
+			binder_inner_proc_unlock(thread->proc);
 		} else {
-			t->buffer->transaction = NULL;
-			kfree(t);
-			binder_stats_deleted(BINDER_STAT_TRANSACTION);
+			binder_free_transaction(t);
 		}
 		break;
 	}
@@ -2476,45 +4340,52 @@ static int binder_thread_read(struct binder_proc *proc,
 done:
 
 	*consumed = ptr - buffer;
-	if (proc->requested_threads + proc->ready_threads == 0 &&
+	binder_inner_proc_lock(proc);
+	if (proc->requested_threads == 0 &&
+	    list_empty(&thread->proc->waiting_threads) &&
 	    proc->requested_threads_started < proc->max_threads &&
 	    (thread->looper & (BINDER_LOOPER_STATE_REGISTERED |
 	     BINDER_LOOPER_STATE_ENTERED)) /* the user-space code fails to */
 	     /*spawn a new thread if we leave this out */) {
 		proc->requested_threads++;
+		binder_inner_proc_unlock(proc);
 		binder_debug(BINDER_DEBUG_THREADS,
 			     "%d:%d BR_SPAWN_LOOPER\n",
 			     proc->pid, thread->pid);
 		if (put_user(BR_SPAWN_LOOPER, (uint32_t __user *)buffer))
 			return -EFAULT;
 		binder_stat_br(proc, thread, BR_SPAWN_LOOPER);
-	}
+	} else
+		binder_inner_proc_unlock(proc);
 	return 0;
 }
 
-static void binder_release_work(struct list_head *list)
+static void binder_release_work(struct binder_proc *proc,
+				struct list_head *list)
 {
 	struct binder_work *w;
 
-	while (!list_empty(list)) {
-		w = list_first_entry(list, struct binder_work, entry);
-		list_del_init(&w->entry);
+	while (1) {
+		w = binder_dequeue_work_head(proc, list);
+		if (!w)
+			return;
+
 		switch (w->type) {
 		case BINDER_WORK_TRANSACTION: {
 			struct binder_transaction *t;
 
 			t = container_of(w, struct binder_transaction, work);
-			if (t->buffer->target_node &&
-			    !(t->flags & TF_ONE_WAY)) {
-				binder_send_failed_reply(t, BR_DEAD_REPLY);
-			} else {
-				binder_debug(BINDER_DEBUG_DEAD_TRANSACTION,
-					"undelivered transaction %d\n",
-					t->debug_id);
-				t->buffer->transaction = NULL;
-				kfree(t);
-				binder_stats_deleted(BINDER_STAT_TRANSACTION);
-			}
+
+			binder_cleanup_transaction(t, "process died.",
+						   BR_DEAD_REPLY);
+		} break;
+		case BINDER_WORK_RETURN_ERROR: {
+			struct binder_error *e = container_of(
+					w, struct binder_error, work);
+
+			binder_debug(BINDER_DEBUG_DEAD_TRANSACTION,
+				"undelivered TRANSACTION_ERROR: %u\n",
+				e->cmd);
 		} break;
 		case BINDER_WORK_TRANSACTION_COMPLETE: {
 			binder_debug(BINDER_DEBUG_DEAD_TRANSACTION,
@@ -2542,7 +4413,8 @@ static void binder_release_work(struct list_head *list)
 
 }
 
-static struct binder_thread *binder_get_thread(struct binder_proc *proc)
+static struct binder_thread *binder_get_thread_ilocked(
+		struct binder_proc *proc, struct binder_thread *new_thread)
 {
 	struct binder_thread *thread = NULL;
 	struct rb_node *parent = NULL;
@@ -2557,38 +4429,102 @@ static struct binder_thread *binder_get_thread(struct binder_proc *proc)
 		else if (current->pid > thread->pid)
 			p = &(*p)->rb_right;
 		else
-			break;
+			return thread;
 	}
-	if (*p == NULL) {
-		thread = kzalloc(sizeof(*thread), GFP_KERNEL);
-		if (thread == NULL)
+	if (!new_thread)
+		return NULL;
+	thread = new_thread;
+	binder_stats_created(BINDER_STAT_THREAD);
+	thread->proc = proc;
+	thread->pid = current->pid;
+	get_task_struct(current);
+	thread->task = current;
+	atomic_set(&thread->tmp_ref, 0);
+	init_waitqueue_head(&thread->wait);
+	INIT_LIST_HEAD(&thread->todo);
+	rb_link_node(&thread->rb_node, parent, p);
+	rb_insert_color(&thread->rb_node, &proc->threads);
+	thread->looper_need_return = true;
+	thread->return_error.work.type = BINDER_WORK_RETURN_ERROR;
+	thread->return_error.cmd = BR_OK;
+	thread->reply_error.work.type = BINDER_WORK_RETURN_ERROR;
+	thread->reply_error.cmd = BR_OK;
+	INIT_LIST_HEAD(&new_thread->waiting_thread_node);
+	return thread;
+}
+
+static struct binder_thread *binder_get_thread(struct binder_proc *proc)
+{
+	struct binder_thread *thread;
+	struct binder_thread *new_thread;
+
+	binder_inner_proc_lock(proc);
+	thread = binder_get_thread_ilocked(proc, NULL);
+	binder_inner_proc_unlock(proc);
+	if (!thread) {
+		new_thread = kzalloc(sizeof(*thread), GFP_KERNEL);
+		if (new_thread == NULL)
 			return NULL;
-		binder_stats_created(BINDER_STAT_THREAD);
-		thread->proc = proc;
-		thread->pid = current->pid;
-		init_waitqueue_head(&thread->wait);
-		INIT_LIST_HEAD(&thread->todo);
-		rb_link_node(&thread->rb_node, parent, p);
-		rb_insert_color(&thread->rb_node, &proc->threads);
-		thread->looper |= BINDER_LOOPER_STATE_NEED_RETURN;
-		thread->return_error = BR_OK;
-		thread->return_error2 = BR_OK;
+		binder_inner_proc_lock(proc);
+		thread = binder_get_thread_ilocked(proc, new_thread);
+		binder_inner_proc_unlock(proc);
+		if (thread != new_thread)
+			kfree(new_thread);
 	}
 	return thread;
 }
 
-static int binder_free_thread(struct binder_proc *proc,
-			      struct binder_thread *thread)
+static void binder_free_proc(struct binder_proc *proc)
+{
+	BUG_ON(!list_empty(&proc->todo));
+	BUG_ON(!list_empty(&proc->delivered_death));
+	binder_alloc_deferred_release(&proc->alloc);
+	put_task_struct(proc->tsk);
+	binder_stats_deleted(BINDER_STAT_PROC);
+	kfree(proc);
+}
+
+static void binder_free_thread(struct binder_thread *thread)
+{
+	BUG_ON(!list_empty(&thread->todo));
+	binder_stats_deleted(BINDER_STAT_THREAD);
+	binder_proc_dec_tmpref(thread->proc);
+	put_task_struct(thread->task);
+	kfree(thread);
+}
+
+static int binder_thread_release(struct binder_proc *proc,
+				 struct binder_thread *thread)
 {
 	struct binder_transaction *t;
 	struct binder_transaction *send_reply = NULL;
 	int active_transactions = 0;
-
+	struct binder_transaction *last_t = NULL;
+
+	binder_inner_proc_lock(thread->proc);
+	/*
+	 * take a ref on the proc so it survives
+	 * after we remove this thread from proc->threads.
+	 * The corresponding dec is when we actually
+	 * free the thread in binder_free_thread()
+	 */
+	proc->tmp_ref++;
+	/*
+	 * take a ref on this thread to ensure it
+	 * survives while we are releasing it
+	 */
+	atomic_inc(&thread->tmp_ref);
 	rb_erase(&thread->rb_node, &proc->threads);
 	t = thread->transaction_stack;
-	if (t && t->to_thread == thread)
-		send_reply = t;
+	if (t) {
+		spin_lock(&t->lock);
+		if (t->to_thread == thread)
+			send_reply = t;
+	}
+	thread->is_dead = true;
+
 	while (t) {
+		last_t = t;
 		active_transactions++;
 		binder_debug(BINDER_DEBUG_DEAD_TRANSACTION,
 			     "release %d:%d transaction %d %s, still active\n",
@@ -2609,12 +4545,37 @@ static int binder_free_thread(struct binder_proc *proc,
 			t = t->from_parent;
 		} else
 			BUG();
+		spin_unlock(&last_t->lock);
+		if (t)
+			spin_lock(&t->lock);
+	}
+
+	/*
+	 * If this thread used poll, make sure we remove the waitqueue
+	 * from any epoll data structures holding it with POLLFREE.
+	 * waitqueue_active() is safe to use here because we're holding
+	 * the inner lock.
+	 */
+	if ((thread->looper & BINDER_LOOPER_STATE_POLL) &&
+	    waitqueue_active(&thread->wait)) {
+		wake_up_poll(&thread->wait, POLLHUP | POLLFREE);
 	}
+
+	binder_inner_proc_unlock(thread->proc);
+
+	/*
+	 * This is needed to avoid races between wake_up_poll() above and
+	 * and ep_remove_waitqueue() called for other reasons (eg the epoll file
+	 * descriptor being closed); ep_remove_waitqueue() holds an RCU read
+	 * lock, so we can be sure it's done after calling synchronize_rcu().
+	 */
+	if (thread->looper & BINDER_LOOPER_STATE_POLL)
+		synchronize_rcu();
+
 	if (send_reply)
 		binder_send_failed_reply(send_reply, BR_DEAD_REPLY);
-	binder_release_work(&thread->todo);
-	kfree(thread);
-	binder_stats_deleted(BINDER_STAT_THREAD);
+	binder_release_work(proc, &thread->todo);
+	binder_thread_dec_tmpref(thread);
 	return active_transactions;
 }
 
@@ -2623,34 +4584,23 @@ static unsigned int binder_poll(struct file *filp,
 {
 	struct binder_proc *proc = filp->private_data;
 	struct binder_thread *thread = NULL;
-	int wait_for_proc_work;
-
-	binder_lock(__func__);
+	bool wait_for_proc_work;
 
 	thread = binder_get_thread(proc);
-	if (!thread) {
-		binder_unlock(__func__);
+	if (!thread)
 		return POLLERR;
-	}
 
-	wait_for_proc_work = thread->transaction_stack == NULL &&
-		list_empty(&thread->todo) && thread->return_error == BR_OK;
+	binder_inner_proc_lock(thread->proc);
+	thread->looper |= BINDER_LOOPER_STATE_POLL;
+	wait_for_proc_work = binder_available_for_proc_work_ilocked(thread);
 
-	binder_unlock(__func__);
+	binder_inner_proc_unlock(thread->proc);
+
+	poll_wait(filp, &thread->wait, wait);
+
+	if (binder_has_work(thread, wait_for_proc_work))
+		return POLLIN;
 
-	if (wait_for_proc_work) {
-		if (binder_has_proc_work(proc, thread))
-			return POLLIN;
-		poll_wait(filp, &proc->wait, wait);
-		if (binder_has_proc_work(proc, thread))
-			return POLLIN;
-	} else {
-		if (binder_has_thread_work(thread))
-			return POLLIN;
-		poll_wait(filp, &thread->wait, wait);
-		if (binder_has_thread_work(thread))
-			return POLLIN;
-	}
 	return 0;
 }
 
@@ -2697,8 +4647,10 @@ static int binder_ioctl_write_read(struct file *filp,
 					 &bwr.read_consumed,
 					 filp->f_flags & O_NONBLOCK);
 		trace_binder_read_done(ret);
-		if (!list_empty(&proc->todo))
-			wake_up_interruptible(&proc->wait);
+		binder_inner_proc_lock(proc);
+		if (!binder_worklist_empty_ilocked(&proc->todo))
+			binder_wakeup_proc_ilocked(proc);
+		binder_inner_proc_unlock(proc);
 		if (ret < 0) {
 			if (copy_to_user(ubuf, &bwr, sizeof(bwr)))
 				ret = -EFAULT;
@@ -2722,9 +4674,12 @@ static int binder_ioctl_set_ctx_mgr(struct file *filp)
 {
 	int ret = 0;
 	struct binder_proc *proc = filp->private_data;
+	struct binder_context *context = proc->context;
+	struct binder_node *new_node;
 	kuid_t curr_euid = current_euid();
 
-	if (binder_context_mgr_node != NULL) {
+	mutex_lock(&context->context_mgr_node_lock);
+	if (context->binder_context_mgr_node) {
 		pr_err("BINDER_SET_CONTEXT_MGR already set\n");
 		ret = -EBUSY;
 		goto out;
@@ -2732,31 +4687,60 @@ static int binder_ioctl_set_ctx_mgr(struct file *filp)
 	ret = security_binder_set_context_mgr(proc->tsk);
 	if (ret < 0)
 		goto out;
-	if (uid_valid(binder_context_mgr_uid)) {
-		if (!uid_eq(binder_context_mgr_uid, curr_euid)) {
+	if (uid_valid(context->binder_context_mgr_uid)) {
+		if (!uid_eq(context->binder_context_mgr_uid, curr_euid)) {
 			pr_err("BINDER_SET_CONTEXT_MGR bad uid %d != %d\n",
 			       from_kuid(&init_user_ns, curr_euid),
 			       from_kuid(&init_user_ns,
-					binder_context_mgr_uid));
+					 context->binder_context_mgr_uid));
 			ret = -EPERM;
 			goto out;
 		}
 	} else {
-		binder_context_mgr_uid = curr_euid;
+		context->binder_context_mgr_uid = curr_euid;
 	}
-	binder_context_mgr_node = binder_new_node(proc, 0, 0);
-	if (binder_context_mgr_node == NULL) {
+	new_node = binder_new_node(proc, NULL);
+	if (!new_node) {
 		ret = -ENOMEM;
 		goto out;
 	}
-	binder_context_mgr_node->local_weak_refs++;
-	binder_context_mgr_node->local_strong_refs++;
-	binder_context_mgr_node->has_strong_ref = 1;
-	binder_context_mgr_node->has_weak_ref = 1;
+	binder_node_lock(new_node);
+	new_node->local_weak_refs++;
+	new_node->local_strong_refs++;
+	new_node->has_strong_ref = 1;
+	new_node->has_weak_ref = 1;
+	context->binder_context_mgr_node = new_node;
+	binder_node_unlock(new_node);
+	binder_put_node(new_node);
 out:
+	mutex_unlock(&context->context_mgr_node_lock);
 	return ret;
 }
 
+static int binder_ioctl_get_node_debug_info(struct binder_proc *proc,
+				struct binder_node_debug_info *info) {
+	struct rb_node *n;
+	binder_uintptr_t ptr = info->ptr;
+
+	memset(info, 0, sizeof(*info));
+
+	binder_inner_proc_lock(proc);
+	for (n = rb_first(&proc->nodes); n != NULL; n = rb_next(n)) {
+		struct binder_node *node = rb_entry(n, struct binder_node,
+						    rb_node);
+		if (node->ptr > ptr) {
+			info->ptr = node->ptr;
+			info->cookie = node->cookie;
+			info->has_strong_ref = node->has_strong_ref;
+			info->has_weak_ref = node->has_weak_ref;
+			break;
+		}
+	}
+	binder_inner_proc_unlock(proc);
+
+	return 0;
+}
+
 static long binder_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 {
 	int ret;
@@ -2768,13 +4752,14 @@ static long binder_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 	/*pr_info("binder_ioctl: %d:%d %x %lx\n",
 			proc->pid, current->pid, cmd, arg);*/
 
+	binder_selftest_alloc(&proc->alloc);
+
 	trace_binder_ioctl(cmd, arg);
 
 	ret = wait_event_interruptible(binder_user_error_wait, binder_stop_on_user_error < 2);
 	if (ret)
 		goto err_unlocked;
 
-	binder_lock(__func__);
 	thread = binder_get_thread(proc);
 	if (thread == NULL) {
 		ret = -ENOMEM;
@@ -2787,12 +4772,19 @@ static long binder_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 		if (ret)
 			goto err;
 		break;
-	case BINDER_SET_MAX_THREADS:
-		if (copy_from_user(&proc->max_threads, ubuf, sizeof(proc->max_threads))) {
+	case BINDER_SET_MAX_THREADS: {
+		int max_threads;
+
+		if (copy_from_user(&max_threads, ubuf,
+				   sizeof(max_threads))) {
 			ret = -EINVAL;
 			goto err;
 		}
+		binder_inner_proc_lock(proc);
+		proc->max_threads = max_threads;
+		binder_inner_proc_unlock(proc);
 		break;
+	}
 	case BINDER_SET_CONTEXT_MGR:
 		ret = binder_ioctl_set_ctx_mgr(filp);
 		if (ret)
@@ -2801,7 +4793,7 @@ static long binder_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 	case BINDER_THREAD_EXIT:
 		binder_debug(BINDER_DEBUG_THREADS, "%d:%d exit\n",
 			     proc->pid, thread->pid);
-		binder_free_thread(proc, thread);
+		binder_thread_release(proc, thread);
 		thread = NULL;
 		break;
 	case BINDER_VERSION: {
@@ -2818,6 +4810,24 @@ static long binder_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 		}
 		break;
 	}
+	case BINDER_GET_NODE_DEBUG_INFO: {
+		struct binder_node_debug_info info;
+
+		if (copy_from_user(&info, ubuf, sizeof(info))) {
+			ret = -EFAULT;
+			goto err;
+		}
+
+		ret = binder_ioctl_get_node_debug_info(proc, &info);
+		if (ret < 0)
+			goto err;
+
+		if (copy_to_user(ubuf, &info, sizeof(info))) {
+			ret = -EFAULT;
+			goto err;
+		}
+		break;
+	}
 	default:
 		ret = -EINVAL;
 		goto err;
@@ -2825,8 +4835,7 @@ static long binder_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 	ret = 0;
 err:
 	if (thread)
-		thread->looper &= ~BINDER_LOOPER_STATE_NEED_RETURN;
-	binder_unlock(__func__);
+		thread->looper_need_return = false;
 	wait_event_interruptible(binder_user_error_wait, binder_stop_on_user_error < 2);
 	if (ret && ret != -ERESTARTSYS)
 		pr_info("%d:%d ioctl %x %lx returned %d\n", proc->pid, current->pid, cmd, arg, ret);
@@ -2855,8 +4864,7 @@ static void binder_vma_close(struct vm_area_struct *vma)
 		     proc->pid, vma->vm_start, vma->vm_end,
 		     (vma->vm_end - vma->vm_start) / SZ_1K, vma->vm_flags,
 		     (unsigned long)pgprot_val(vma->vm_page_prot));
-	proc->vma = NULL;
-	proc->vma_vm_mm = NULL;
+	binder_alloc_vma_close(&proc->alloc);
 	binder_defer_work(proc, BINDER_DEFERRED_PUT_FILES);
 }
 
@@ -2874,10 +4882,8 @@ static int binder_vm_fault(struct vm_area_struct *vma, struct vm_fault *vmf)
 static int binder_mmap(struct file *filp, struct vm_area_struct *vma)
 {
 	int ret;
-	struct vm_struct *area;
 	struct binder_proc *proc = filp->private_data;
 	const char *failure_string;
-	struct binder_buffer *buffer;
 
 	if (proc->tsk != current->group_leader)
 		return -EINVAL;
@@ -2886,8 +4892,8 @@ static int binder_mmap(struct file *filp, struct vm_area_struct *vma)
 		vma->vm_end = vma->vm_start + SZ_4M;
 
 	binder_debug(BINDER_DEBUG_OPEN_CLOSE,
-		     "binder_mmap: %d %lx-%lx (%ld K) vma %lx pagep %lx\n",
-		     proc->pid, vma->vm_start, vma->vm_end,
+		     "%s: %d %lx-%lx (%ld K) vma %lx pagep %lx\n",
+		     __func__, proc->pid, vma->vm_start, vma->vm_end,
 		     (vma->vm_end - vma->vm_start) / SZ_1K, vma->vm_flags,
 		     (unsigned long)pgprot_val(vma->vm_page_prot));
 
@@ -2896,76 +4902,22 @@ static int binder_mmap(struct file *filp, struct vm_area_struct *vma)
 		failure_string = "bad vm_flags";
 		goto err_bad_arg;
 	}
-	vma->vm_flags = (vma->vm_flags | VM_DONTCOPY) & ~VM_MAYWRITE;
-
-	mutex_lock(&binder_mmap_lock);
-	if (proc->buffer) {
-		ret = -EBUSY;
-		failure_string = "already mapped";
-		goto err_already_mapped;
-	}
-
-	area = get_vm_area(vma->vm_end - vma->vm_start, VM_IOREMAP);
-	if (area == NULL) {
-		ret = -ENOMEM;
-		failure_string = "get_vm_area";
-		goto err_get_vm_area_failed;
-	}
-	proc->buffer = area->addr;
-	proc->user_buffer_offset = vma->vm_start - (uintptr_t)proc->buffer;
-	mutex_unlock(&binder_mmap_lock);
-
-#ifdef CONFIG_CPU_CACHE_VIPT
-	if (cache_is_vipt_aliasing()) {
-		while (CACHE_COLOUR((vma->vm_start ^ (uint32_t)proc->buffer))) {
-			pr_info("binder_mmap: %d %lx-%lx maps %p bad alignment\n", proc->pid, vma->vm_start, vma->vm_end, proc->buffer);
-			vma->vm_start += PAGE_SIZE;
-		}
-	}
-#endif
-	proc->pages = kzalloc(sizeof(proc->pages[0]) * ((vma->vm_end - vma->vm_start) / PAGE_SIZE), GFP_KERNEL);
-	if (proc->pages == NULL) {
-		ret = -ENOMEM;
-		failure_string = "alloc page array";
-		goto err_alloc_pages_failed;
-	}
-	proc->buffer_size = vma->vm_end - vma->vm_start;
+	vma->vm_flags |= VM_DONTCOPY | VM_MIXEDMAP;
+	vma->vm_flags &= ~VM_MAYWRITE;
 
 	vma->vm_ops = &binder_vm_ops;
 	vma->vm_private_data = proc;
 
-	if (binder_update_page_range(proc, 1, proc->buffer, proc->buffer + PAGE_SIZE, vma)) {
-		ret = -ENOMEM;
-		failure_string = "alloc small buf";
-		goto err_alloc_small_buf_failed;
-	}
-	buffer = proc->buffer;
-	INIT_LIST_HEAD(&proc->buffers);
-	list_add(&buffer->entry, &proc->buffers);
-	buffer->free = 1;
-	binder_insert_free_buffer(proc, buffer);
-	proc->free_async_space = proc->buffer_size / 2;
-	barrier();
+	ret = binder_alloc_mmap_handler(&proc->alloc, vma);
+	if (ret)
+		return ret;
+	mutex_lock(&proc->files_lock);
 	proc->files = get_files_struct(current);
-	proc->vma = vma;
-	proc->vma_vm_mm = vma->vm_mm;
-
-	/*pr_info("binder_mmap: %d %lx-%lx maps %p\n",
-		 proc->pid, vma->vm_start, vma->vm_end, proc->buffer);*/
+	mutex_unlock(&proc->files_lock);
 	return 0;
 
-err_alloc_small_buf_failed:
-	kfree(proc->pages);
-	proc->pages = NULL;
-err_alloc_pages_failed:
-	mutex_lock(&binder_mmap_lock);
-	vfree(proc->buffer);
-	proc->buffer = NULL;
-err_get_vm_area_failed:
-err_already_mapped:
-	mutex_unlock(&binder_mmap_lock);
 err_bad_arg:
-	pr_err("binder_mmap: %d %lx-%lx %s failed %d\n",
+	pr_err("%s: %d %lx-%lx %s failed %d\n", __func__,
 	       proc->pid, vma->vm_start, vma->vm_end, failure_string, ret);
 	return ret;
 }
@@ -2973,35 +4925,58 @@ static int binder_mmap(struct file *filp, struct vm_area_struct *vma)
 static int binder_open(struct inode *nodp, struct file *filp)
 {
 	struct binder_proc *proc;
+	struct binder_device *binder_dev;
 
-	binder_debug(BINDER_DEBUG_OPEN_CLOSE, "binder_open: %d:%d\n",
+	binder_debug(BINDER_DEBUG_OPEN_CLOSE, "%s: %d:%d\n", __func__,
 		     current->group_leader->pid, current->pid);
 
 	proc = kzalloc(sizeof(*proc), GFP_KERNEL);
 	if (proc == NULL)
 		return -ENOMEM;
+	spin_lock_init(&proc->inner_lock);
+	spin_lock_init(&proc->outer_lock);
 	get_task_struct(current->group_leader);
 	proc->tsk = current->group_leader;
+	mutex_init(&proc->files_lock);
 	INIT_LIST_HEAD(&proc->todo);
-	init_waitqueue_head(&proc->wait);
-	proc->default_priority = task_nice(current);
+	if (binder_supported_policy(current->policy)) {
+		proc->default_priority.sched_policy = current->policy;
+		proc->default_priority.prio = current->normal_prio;
+	} else {
+		proc->default_priority.sched_policy = SCHED_NORMAL;
+		proc->default_priority.prio = NICE_TO_PRIO(0);
+	}
 
-	binder_lock(__func__);
+	binder_dev = container_of(filp->private_data, struct binder_device,
+				  miscdev);
+	proc->context = &binder_dev->context;
+	binder_alloc_init(&proc->alloc);
 
 	binder_stats_created(BINDER_STAT_PROC);
-	hlist_add_head(&proc->proc_node, &binder_procs);
 	proc->pid = current->group_leader->pid;
 	INIT_LIST_HEAD(&proc->delivered_death);
+	INIT_LIST_HEAD(&proc->waiting_threads);
 	filp->private_data = proc;
 
-	binder_unlock(__func__);
+	mutex_lock(&binder_procs_lock);
+	hlist_add_head(&proc->proc_node, &binder_procs);
+	mutex_unlock(&binder_procs_lock);
 
 	if (binder_debugfs_dir_entry_proc) {
 		char strbuf[11];
 
 		snprintf(strbuf, sizeof(strbuf), "%u", proc->pid);
-		proc->debugfs_entry = debugfs_create_file(strbuf, S_IRUGO,
-			binder_debugfs_dir_entry_proc, proc, &binder_proc_fops);
+		/*
+		 * proc debug entries are shared between contexts, so
+		 * this will fail if the process tries to open the driver
+		 * again with a different context. The priting code will
+		 * anyway print all contexts that a given PID has, so this
+		 * is not a problem.
+		 */
+		proc->debugfs_entry = debugfs_create_file(strbuf, 0444,
+			binder_debugfs_dir_entry_proc,
+			(void *)(unsigned long)proc->pid,
+			&binder_proc_fops);
 	}
 
 	return 0;
@@ -3021,16 +4996,17 @@ static void binder_deferred_flush(struct binder_proc *proc)
 	struct rb_node *n;
 	int wake_count = 0;
 
+	binder_inner_proc_lock(proc);
 	for (n = rb_first(&proc->threads); n != NULL; n = rb_next(n)) {
 		struct binder_thread *thread = rb_entry(n, struct binder_thread, rb_node);
 
-		thread->looper |= BINDER_LOOPER_STATE_NEED_RETURN;
+		thread->looper_need_return = true;
 		if (thread->looper & BINDER_LOOPER_STATE_WAITING) {
 			wake_up_interruptible(&thread->wait);
 			wake_count++;
 		}
 	}
-	wake_up_interruptible_all(&proc->wait);
+	binder_inner_proc_unlock(proc);
 
 	binder_debug(BINDER_DEBUG_OPEN_CLOSE,
 		     "binder_flush: %d woke %d threads\n", proc->pid,
@@ -3051,13 +5027,21 @@ static int binder_node_release(struct binder_node *node, int refs)
 {
 	struct binder_ref *ref;
 	int death = 0;
-
-	list_del_init(&node->work.entry);
-	binder_release_work(&node->async_todo);
-
-	if (hlist_empty(&node->refs)) {
-		kfree(node);
-		binder_stats_deleted(BINDER_STAT_NODE);
+	struct binder_proc *proc = node->proc;
+
+	binder_release_work(proc, &node->async_todo);
+
+	binder_node_lock(node);
+	binder_inner_proc_lock(proc);
+	binder_dequeue_work_ilocked(&node->work);
+	/*
+	 * The caller must have taken a temporary ref on the node,
+	 */
+	BUG_ON(!node->tmp_refs);
+	if (hlist_empty(&node->refs) && node->tmp_refs == 1) {
+		binder_inner_proc_unlock(proc);
+		binder_node_unlock(node);
+		binder_free_node(node);
 
 		return refs;
 	}
@@ -3065,59 +5049,84 @@ static int binder_node_release(struct binder_node *node, int refs)
 	node->proc = NULL;
 	node->local_strong_refs = 0;
 	node->local_weak_refs = 0;
+	binder_inner_proc_unlock(proc);
+
+	spin_lock(&binder_dead_nodes_lock);
 	hlist_add_head(&node->dead_node, &binder_dead_nodes);
+	spin_unlock(&binder_dead_nodes_lock);
 
 	hlist_for_each_entry(ref, &node->refs, node_entry) {
 		refs++;
-
-		if (!ref->death)
+		/*
+		 * Need the node lock to synchronize
+		 * with new notification requests and the
+		 * inner lock to synchronize with queued
+		 * death notifications.
+		 */
+		binder_inner_proc_lock(ref->proc);
+		if (!ref->death) {
+			binder_inner_proc_unlock(ref->proc);
 			continue;
+		}
 
 		death++;
 
-		if (list_empty(&ref->death->work.entry)) {
-			ref->death->work.type = BINDER_WORK_DEAD_BINDER;
-			list_add_tail(&ref->death->work.entry,
-				      &ref->proc->todo);
-			wake_up_interruptible(&ref->proc->wait);
-		} else
-			BUG();
+		BUG_ON(!list_empty(&ref->death->work.entry));
+		ref->death->work.type = BINDER_WORK_DEAD_BINDER;
+		binder_enqueue_work_ilocked(&ref->death->work,
+					    &ref->proc->todo);
+		binder_wakeup_proc_ilocked(ref->proc);
+		binder_inner_proc_unlock(ref->proc);
 	}
 
 	binder_debug(BINDER_DEBUG_DEAD_BINDER,
 		     "node %d now dead, refs %d, death %d\n",
 		     node->debug_id, refs, death);
+	binder_node_unlock(node);
+	binder_put_node(node);
 
 	return refs;
 }
 
 static void binder_deferred_release(struct binder_proc *proc)
 {
-	struct binder_transaction *t;
+	struct binder_context *context = proc->context;
 	struct rb_node *n;
-	int threads, nodes, incoming_refs, outgoing_refs, buffers,
-		active_transactions, page_count;
+	int threads, nodes, incoming_refs, outgoing_refs, active_transactions;
 
-	BUG_ON(proc->vma);
 	BUG_ON(proc->files);
 
+	mutex_lock(&binder_procs_lock);
 	hlist_del(&proc->proc_node);
+	mutex_unlock(&binder_procs_lock);
 
-	if (binder_context_mgr_node && binder_context_mgr_node->proc == proc) {
+	mutex_lock(&context->context_mgr_node_lock);
+	if (context->binder_context_mgr_node &&
+	    context->binder_context_mgr_node->proc == proc) {
 		binder_debug(BINDER_DEBUG_DEAD_BINDER,
 			     "%s: %d context_mgr_node gone\n",
 			     __func__, proc->pid);
-		binder_context_mgr_node = NULL;
+		context->binder_context_mgr_node = NULL;
 	}
-
+	mutex_unlock(&context->context_mgr_node_lock);
+	binder_inner_proc_lock(proc);
+	/*
+	 * Make sure proc stays alive after we
+	 * remove all the threads
+	 */
+	proc->tmp_ref++;
+
+	proc->is_dead = true;
 	threads = 0;
 	active_transactions = 0;
 	while ((n = rb_first(&proc->threads))) {
 		struct binder_thread *thread;
 
 		thread = rb_entry(n, struct binder_thread, rb_node);
+		binder_inner_proc_unlock(proc);
 		threads++;
-		active_transactions += binder_free_thread(proc, thread);
+		active_transactions += binder_thread_release(proc, thread);
+		binder_inner_proc_lock(proc);
 	}
 
 	nodes = 0;
@@ -3127,73 +5136,42 @@ static void binder_deferred_release(struct binder_proc *proc)
 
 		node = rb_entry(n, struct binder_node, rb_node);
 		nodes++;
+		/*
+		 * take a temporary ref on the node before
+		 * calling binder_node_release() which will either
+		 * kfree() the node or call binder_put_node()
+		 */
+		binder_inc_node_tmpref_ilocked(node);
 		rb_erase(&node->rb_node, &proc->nodes);
+		binder_inner_proc_unlock(proc);
 		incoming_refs = binder_node_release(node, incoming_refs);
+		binder_inner_proc_lock(proc);
 	}
+	binder_inner_proc_unlock(proc);
 
 	outgoing_refs = 0;
+	binder_proc_lock(proc);
 	while ((n = rb_first(&proc->refs_by_desc))) {
 		struct binder_ref *ref;
 
 		ref = rb_entry(n, struct binder_ref, rb_node_desc);
 		outgoing_refs++;
-		binder_delete_ref(ref);
-	}
-
-	binder_release_work(&proc->todo);
-	binder_release_work(&proc->delivered_death);
-
-	buffers = 0;
-	while ((n = rb_first(&proc->allocated_buffers))) {
-		struct binder_buffer *buffer;
-
-		buffer = rb_entry(n, struct binder_buffer, rb_node);
-
-		t = buffer->transaction;
-		if (t) {
-			t->buffer = NULL;
-			buffer->transaction = NULL;
-			pr_err("release proc %d, transaction %d, not freed\n",
-			       proc->pid, t->debug_id);
-			/*BUG();*/
-		}
-
-		binder_free_buf(proc, buffer);
-		buffers++;
-	}
-
-	binder_stats_deleted(BINDER_STAT_PROC);
-
-	page_count = 0;
-	if (proc->pages) {
-		int i;
-
-		for (i = 0; i < proc->buffer_size / PAGE_SIZE; i++) {
-			void *page_addr;
-
-			if (!proc->pages[i])
-				continue;
-
-			page_addr = proc->buffer + i * PAGE_SIZE;
-			binder_debug(BINDER_DEBUG_BUFFER_ALLOC,
-				     "%s: %d: page %d at %p not freed\n",
-				     __func__, proc->pid, i, page_addr);
-			unmap_kernel_range((unsigned long)page_addr, PAGE_SIZE);
-			__free_page(proc->pages[i]);
-			page_count++;
-		}
-		kfree(proc->pages);
-		vfree(proc->buffer);
+		binder_cleanup_ref_olocked(ref);
+		binder_proc_unlock(proc);
+		binder_free_ref(ref);
+		binder_proc_lock(proc);
 	}
+	binder_proc_unlock(proc);
 
-	put_task_struct(proc->tsk);
+	binder_release_work(proc, &proc->todo);
+	binder_release_work(proc, &proc->delivered_death);
 
 	binder_debug(BINDER_DEBUG_OPEN_CLOSE,
-		     "%s: %d threads %d, nodes %d (ref %d), refs %d, active transactions %d, buffers %d, pages %d\n",
+		     "%s: %d threads %d, nodes %d (ref %d), refs %d, active transactions %d\n",
 		     __func__, proc->pid, threads, nodes, incoming_refs,
-		     outgoing_refs, active_transactions, buffers, page_count);
+		     outgoing_refs, active_transactions);
 
-	kfree(proc);
+	binder_proc_dec_tmpref(proc);
 }
 
 static void binder_deferred_func(struct work_struct *work)
@@ -3204,7 +5182,6 @@ static void binder_deferred_func(struct work_struct *work)
 	int defer;
 
 	do {
-		binder_lock(__func__);
 		mutex_lock(&binder_deferred_lock);
 		if (!hlist_empty(&binder_deferred_list)) {
 			proc = hlist_entry(binder_deferred_list.first,
@@ -3220,9 +5197,11 @@ static void binder_deferred_func(struct work_struct *work)
 
 		files = NULL;
 		if (defer & BINDER_DEFERRED_PUT_FILES) {
+			mutex_lock(&proc->files_lock);
 			files = proc->files;
 			if (files)
 				proc->files = NULL;
+			mutex_unlock(&proc->files_lock);
 		}
 
 		if (defer & BINDER_DEFERRED_FLUSH)
@@ -3231,7 +5210,6 @@ static void binder_deferred_func(struct work_struct *work)
 		if (defer & BINDER_DEFERRED_RELEASE)
 			binder_deferred_release(proc); /* frees proc */
 
-		binder_unlock(__func__);
 		if (files)
 			put_files_struct(files);
 	} while (proc);
@@ -3251,41 +5229,52 @@ static void binder_deferred_func(struct work_struct *work)
 	mutex_unlock(&binder_deferred_lock);
 }
 
-static void print_binder_transaction(struct seq_file *m, const char *prefix,
-				     struct binder_transaction *t)
+static void print_binder_transaction_ilocked(struct seq_file *m,
+					     struct binder_proc *proc,
+					     const char *prefix,
+					     struct binder_transaction *t)
 {
+	struct binder_proc *to_proc;
+	struct binder_buffer *buffer = t->buffer;
+
+	spin_lock(&t->lock);
+	to_proc = t->to_proc;
 	seq_printf(m,
-		   "%s %d: %p from %d:%d to %d:%d code %x flags %x pri %ld r%d",
+		   "%s %d: %pK from %d:%d to %d:%d code %x flags %x pri %d:%d r%d",
 		   prefix, t->debug_id, t,
 		   t->from ? t->from->proc->pid : 0,
 		   t->from ? t->from->pid : 0,
-		   t->to_proc ? t->to_proc->pid : 0,
+		   to_proc ? to_proc->pid : 0,
 		   t->to_thread ? t->to_thread->pid : 0,
-		   t->code, t->flags, t->priority, t->need_reply);
-	if (t->buffer == NULL) {
-		seq_puts(m, " buffer free\n");
+		   t->code, t->flags, t->priority.sched_policy,
+		   t->priority.prio, t->need_reply);
+	spin_unlock(&t->lock);
+
+	if (proc != to_proc) {
+		/*
+		 * Can only safely deref buffer if we are holding the
+		 * correct proc inner lock for this node
+		 */
+		seq_puts(m, "\n");
 		return;
 	}
-	if (t->buffer->target_node)
-		seq_printf(m, " node %d",
-			   t->buffer->target_node->debug_id);
-	seq_printf(m, " size %zd:%zd data %p\n",
-		   t->buffer->data_size, t->buffer->offsets_size,
-		   t->buffer->data);
-}
 
-static void print_binder_buffer(struct seq_file *m, const char *prefix,
-				struct binder_buffer *buffer)
-{
-	seq_printf(m, "%s %d: %p size %zd:%zd %s\n",
-		   prefix, buffer->debug_id, buffer->data,
+	if (buffer == NULL) {
+		seq_puts(m, " buffer free\n");
+		return;
+	}
+	if (buffer->target_node)
+		seq_printf(m, " node %d", buffer->target_node->debug_id);
+	seq_printf(m, " size %zd:%zd data %pK\n",
 		   buffer->data_size, buffer->offsets_size,
-		   buffer->transaction ? "active" : "delivered");
+		   buffer->data);
 }
 
-static void print_binder_work(struct seq_file *m, const char *prefix,
-			      const char *transaction_prefix,
-			      struct binder_work *w)
+static void print_binder_work_ilocked(struct seq_file *m,
+				     struct binder_proc *proc,
+				     const char *prefix,
+				     const char *transaction_prefix,
+				     struct binder_work *w)
 {
 	struct binder_node *node;
 	struct binder_transaction *t;
@@ -3293,8 +5282,16 @@ static void print_binder_work(struct seq_file *m, const char *prefix,
 	switch (w->type) {
 	case BINDER_WORK_TRANSACTION:
 		t = container_of(w, struct binder_transaction, work);
-		print_binder_transaction(m, transaction_prefix, t);
+		print_binder_transaction_ilocked(
+				m, proc, transaction_prefix, t);
 		break;
+	case BINDER_WORK_RETURN_ERROR: {
+		struct binder_error *e = container_of(
+				w, struct binder_error, work);
+
+		seq_printf(m, "%stransaction error: %u\n",
+			   prefix, e->cmd);
+	} break;
 	case BINDER_WORK_TRANSACTION_COMPLETE:
 		seq_printf(m, "%stransaction complete\n", prefix);
 		break;
@@ -3319,40 +5316,46 @@ static void print_binder_work(struct seq_file *m, const char *prefix,
 	}
 }
 
-static void print_binder_thread(struct seq_file *m,
-				struct binder_thread *thread,
-				int print_always)
+static void print_binder_thread_ilocked(struct seq_file *m,
+					struct binder_thread *thread,
+					int print_always)
 {
 	struct binder_transaction *t;
 	struct binder_work *w;
 	size_t start_pos = m->count;
 	size_t header_pos;
 
-	seq_printf(m, "  thread %d: l %02x\n", thread->pid, thread->looper);
+	seq_printf(m, "  thread %d: l %02x need_return %d tr %d\n",
+			thread->pid, thread->looper,
+			thread->looper_need_return,
+			atomic_read(&thread->tmp_ref));
 	header_pos = m->count;
 	t = thread->transaction_stack;
 	while (t) {
 		if (t->from == thread) {
-			print_binder_transaction(m,
-						 "    outgoing transaction", t);
+			print_binder_transaction_ilocked(m, thread->proc,
+					"    outgoing transaction", t);
 			t = t->from_parent;
 		} else if (t->to_thread == thread) {
-			print_binder_transaction(m,
+			print_binder_transaction_ilocked(m, thread->proc,
 						 "    incoming transaction", t);
 			t = t->to_parent;
 		} else {
-			print_binder_transaction(m, "    bad transaction", t);
+			print_binder_transaction_ilocked(m, thread->proc,
+					"    bad transaction", t);
 			t = NULL;
 		}
 	}
 	list_for_each_entry(w, &thread->todo, entry) {
-		print_binder_work(m, "    ", "    pending transaction", w);
+		print_binder_work_ilocked(m, thread->proc, "    ",
+					  "    pending transaction", w);
 	}
 	if (!print_always && m->count == header_pos)
 		m->count = start_pos;
 }
 
-static void print_binder_node(struct seq_file *m, struct binder_node *node)
+static void print_binder_node_nilocked(struct seq_file *m,
+				       struct binder_node *node)
 {
 	struct binder_ref *ref;
 	struct binder_work *w;
@@ -3362,27 +5365,35 @@ static void print_binder_node(struct seq_file *m, struct binder_node *node)
 	hlist_for_each_entry(ref, &node->refs, node_entry)
 		count++;
 
-	seq_printf(m, "  node %d: u%016llx c%016llx hs %d hw %d ls %d lw %d is %d iw %d",
+	seq_printf(m, "  node %d: u%016llx c%016llx pri %d:%d hs %d hw %d ls %d lw %d is %d iw %d tr %d",
 		   node->debug_id, (u64)node->ptr, (u64)node->cookie,
+		   node->sched_policy, node->min_priority,
 		   node->has_strong_ref, node->has_weak_ref,
 		   node->local_strong_refs, node->local_weak_refs,
-		   node->internal_strong_refs, count);
+		   node->internal_strong_refs, count, node->tmp_refs);
 	if (count) {
 		seq_puts(m, " proc");
 		hlist_for_each_entry(ref, &node->refs, node_entry)
 			seq_printf(m, " %d", ref->proc->pid);
 	}
 	seq_puts(m, "\n");
-	list_for_each_entry(w, &node->async_todo, entry)
-		print_binder_work(m, "    ",
-				  "    pending async transaction", w);
+	if (node->proc) {
+		list_for_each_entry(w, &node->async_todo, entry)
+			print_binder_work_ilocked(m, node->proc, "    ",
+					  "    pending async transaction", w);
+	}
 }
 
-static void print_binder_ref(struct seq_file *m, struct binder_ref *ref)
+static void print_binder_ref_olocked(struct seq_file *m,
+				     struct binder_ref *ref)
 {
-	seq_printf(m, "  ref %d: desc %d %snode %d s %d w %d d %p\n",
-		   ref->debug_id, ref->desc, ref->node->proc ? "" : "dead ",
-		   ref->node->debug_id, ref->strong, ref->weak, ref->death);
+	binder_node_lock(ref->node);
+	seq_printf(m, "  ref %d: desc %d %snode %d s %d w %d d %pK\n",
+		   ref->data.debug_id, ref->data.desc,
+		   ref->node->proc ? "" : "dead ",
+		   ref->node->debug_id, ref->data.strong,
+		   ref->data.weak, ref->death);
+	binder_node_unlock(ref->node);
 }
 
 static void print_binder_proc(struct seq_file *m,
@@ -3392,35 +5403,60 @@ static void print_binder_proc(struct seq_file *m,
 	struct rb_node *n;
 	size_t start_pos = m->count;
 	size_t header_pos;
+	struct binder_node *last_node = NULL;
 
 	seq_printf(m, "proc %d\n", proc->pid);
+	seq_printf(m, "context %s\n", proc->context->name);
 	header_pos = m->count;
 
+	binder_inner_proc_lock(proc);
 	for (n = rb_first(&proc->threads); n != NULL; n = rb_next(n))
-		print_binder_thread(m, rb_entry(n, struct binder_thread,
+		print_binder_thread_ilocked(m, rb_entry(n, struct binder_thread,
 						rb_node), print_all);
+
 	for (n = rb_first(&proc->nodes); n != NULL; n = rb_next(n)) {
 		struct binder_node *node = rb_entry(n, struct binder_node,
 						    rb_node);
-		if (print_all || node->has_async_transaction)
-			print_binder_node(m, node);
+		/*
+		 * take a temporary reference on the node so it
+		 * survives and isn't removed from the tree
+		 * while we print it.
+		 */
+		binder_inc_node_tmpref_ilocked(node);
+		/* Need to drop inner lock to take node lock */
+		binder_inner_proc_unlock(proc);
+		if (last_node)
+			binder_put_node(last_node);
+		binder_node_inner_lock(node);
+		print_binder_node_nilocked(m, node);
+		binder_node_inner_unlock(node);
+		last_node = node;
+		binder_inner_proc_lock(proc);
 	}
+	binder_inner_proc_unlock(proc);
+	if (last_node)
+		binder_put_node(last_node);
+
 	if (print_all) {
+		binder_proc_lock(proc);
 		for (n = rb_first(&proc->refs_by_desc);
 		     n != NULL;
 		     n = rb_next(n))
-			print_binder_ref(m, rb_entry(n, struct binder_ref,
-						     rb_node_desc));
+			print_binder_ref_olocked(m, rb_entry(n,
+							    struct binder_ref,
+							    rb_node_desc));
+		binder_proc_unlock(proc);
 	}
-	for (n = rb_first(&proc->allocated_buffers); n != NULL; n = rb_next(n))
-		print_binder_buffer(m, "  buffer",
-				    rb_entry(n, struct binder_buffer, rb_node));
+	binder_alloc_print_allocated(m, &proc->alloc);
+	binder_inner_proc_lock(proc);
 	list_for_each_entry(w, &proc->todo, entry)
-		print_binder_work(m, "  ", "  pending transaction", w);
+		print_binder_work_ilocked(m, proc, "  ",
+					  "  pending transaction", w);
 	list_for_each_entry(w, &proc->delivered_death, entry) {
 		seq_puts(m, "  has delivered dead binder\n");
 		break;
 	}
+	binder_inner_proc_unlock(proc);
 	if (!print_all && m->count == header_pos)
 		m->count = start_pos;
 }
@@ -3463,7 +5499,9 @@ static void print_binder_proc(struct seq_file *m,
 	"BC_EXIT_LOOPER",
 	"BC_REQUEST_DEATH_NOTIFICATION",
 	"BC_CLEAR_DEATH_NOTIFICATION",
-	"BC_DEAD_BINDER_DONE"
+	"BC_DEAD_BINDER_DONE",
+	"BC_TRANSACTION_SG",
+	"BC_REPLY_SG",
 };
 
 static const char * const binder_objstat_strings[] = {
@@ -3484,17 +5522,21 @@ static void print_binder_stats(struct seq_file *m, const char *prefix,
 	BUILD_BUG_ON(ARRAY_SIZE(stats->bc) !=
 		     ARRAY_SIZE(binder_command_strings));
 	for (i = 0; i < ARRAY_SIZE(stats->bc); i++) {
-		if (stats->bc[i])
+		int temp = atomic_read(&stats->bc[i]);
+
+		if (temp)
 			seq_printf(m, "%s%s: %d\n", prefix,
-				   binder_command_strings[i], stats->bc[i]);
+				   binder_command_strings[i], temp);
 	}
 
 	BUILD_BUG_ON(ARRAY_SIZE(stats->br) !=
 		     ARRAY_SIZE(binder_return_strings));
 	for (i = 0; i < ARRAY_SIZE(stats->br); i++) {
-		if (stats->br[i])
+		int temp = atomic_read(&stats->br[i]);
+
+		if (temp)
 			seq_printf(m, "%s%s: %d\n", prefix,
-				   binder_return_strings[i], stats->br[i]);
+				   binder_return_strings[i], temp);
 	}
 
 	BUILD_BUG_ON(ARRAY_SIZE(stats->obj_created) !=
@@ -3502,11 +5544,15 @@ static void print_binder_stats(struct seq_file *m, const char *prefix,
 	BUILD_BUG_ON(ARRAY_SIZE(stats->obj_created) !=
 		     ARRAY_SIZE(stats->obj_deleted));
 	for (i = 0; i < ARRAY_SIZE(stats->obj_created); i++) {
-		if (stats->obj_created[i] || stats->obj_deleted[i])
-			seq_printf(m, "%s%s: active %d total %d\n", prefix,
+		int created = atomic_read(&stats->obj_created[i]);
+		int deleted = atomic_read(&stats->obj_deleted[i]);
+
+		if (created || deleted)
+			seq_printf(m, "%s%s: active %d total %d\n",
+				prefix,
 				binder_objstat_strings[i],
-				stats->obj_created[i] - stats->obj_deleted[i],
-				stats->obj_created[i]);
+				created - deleted,
+				created);
 	}
 }
 
@@ -3514,50 +5560,61 @@ static void print_binder_proc_stats(struct seq_file *m,
 				    struct binder_proc *proc)
 {
 	struct binder_work *w;
+	struct binder_thread *thread;
 	struct rb_node *n;
-	int count, strong, weak;
+	int count, strong, weak, ready_threads;
+	size_t free_async_space =
+		binder_alloc_get_free_async_space(&proc->alloc);
 
 	seq_printf(m, "proc %d\n", proc->pid);
+	seq_printf(m, "context %s\n", proc->context->name);
 	count = 0;
+	ready_threads = 0;
+	binder_inner_proc_lock(proc);
 	for (n = rb_first(&proc->threads); n != NULL; n = rb_next(n))
 		count++;
+
+	list_for_each_entry(thread, &proc->waiting_threads, waiting_thread_node)
+		ready_threads++;
+
 	seq_printf(m, "  threads: %d\n", count);
 	seq_printf(m, "  requested threads: %d+%d/%d\n"
 			"  ready threads %d\n"
 			"  free async space %zd\n", proc->requested_threads,
 			proc->requested_threads_started, proc->max_threads,
-			proc->ready_threads, proc->free_async_space);
+			ready_threads,
+			free_async_space);
 	count = 0;
 	for (n = rb_first(&proc->nodes); n != NULL; n = rb_next(n))
 		count++;
+	binder_inner_proc_unlock(proc);
 	seq_printf(m, "  nodes: %d\n", count);
 	count = 0;
 	strong = 0;
 	weak = 0;
+	binder_proc_lock(proc);
 	for (n = rb_first(&proc->refs_by_desc); n != NULL; n = rb_next(n)) {
 		struct binder_ref *ref = rb_entry(n, struct binder_ref,
 						  rb_node_desc);
 		count++;
-		strong += ref->strong;
-		weak += ref->weak;
+		strong += ref->data.strong;
+		weak += ref->data.weak;
 	}
+	binder_proc_unlock(proc);
 	seq_printf(m, "  refs: %d s %d w %d\n", count, strong, weak);
 
-	count = 0;
-	for (n = rb_first(&proc->allocated_buffers); n != NULL; n = rb_next(n))
-		count++;
+	count = binder_alloc_get_allocated_count(&proc->alloc);
 	seq_printf(m, "  buffers: %d\n", count);
 
+	binder_alloc_print_pages(m, &proc->alloc);
+
 	count = 0;
+	binder_inner_proc_lock(proc);
 	list_for_each_entry(w, &proc->todo, entry) {
-		switch (w->type) {
-		case BINDER_WORK_TRANSACTION:
+		if (w->type == BINDER_WORK_TRANSACTION)
 			count++;
-			break;
-		default:
-			break;
-		}
 	}
+	binder_inner_proc_unlock(proc);
 	seq_printf(m, "  pending transactions: %d\n", count);
 
 	print_binder_stats(m, "  ", &proc->stats);
@@ -3568,107 +5625,131 @@ static int binder_state_show(struct seq_file *m, void *unused)
 {
 	struct binder_proc *proc;
 	struct binder_node *node;
-	int do_lock = !binder_debug_no_lock;
-
-	if (do_lock)
-		binder_lock(__func__);
+	struct binder_node *last_node = NULL;
 
 	seq_puts(m, "binder state:\n");
 
+	spin_lock(&binder_dead_nodes_lock);
 	if (!hlist_empty(&binder_dead_nodes))
 		seq_puts(m, "dead nodes:\n");
-	hlist_for_each_entry(node, &binder_dead_nodes, dead_node)
-		print_binder_node(m, node);
+	hlist_for_each_entry(node, &binder_dead_nodes, dead_node) {
+		/*
+		 * take a temporary reference on the node so it
+		 * survives and isn't removed from the list
+		 * while we print it.
+		 */
+		node->tmp_refs++;
+		spin_unlock(&binder_dead_nodes_lock);
+		if (last_node)
+			binder_put_node(last_node);
+		binder_node_lock(node);
+		print_binder_node_nilocked(m, node);
+		binder_node_unlock(node);
+		last_node = node;
+		spin_lock(&binder_dead_nodes_lock);
+	}
+	spin_unlock(&binder_dead_nodes_lock);
+	if (last_node)
+		binder_put_node(last_node);
 
+	mutex_lock(&binder_procs_lock);
 	hlist_for_each_entry(proc, &binder_procs, proc_node)
 		print_binder_proc(m, proc, 1);
-	if (do_lock)
-		binder_unlock(__func__);
+	mutex_unlock(&binder_procs_lock);
+
 	return 0;
 }
 
 static int binder_stats_show(struct seq_file *m, void *unused)
 {
 	struct binder_proc *proc;
-	int do_lock = !binder_debug_no_lock;
-
-	if (do_lock)
-		binder_lock(__func__);
 
 	seq_puts(m, "binder stats:\n");
 
 	print_binder_stats(m, "", &binder_stats);
 
+	mutex_lock(&binder_procs_lock);
 	hlist_for_each_entry(proc, &binder_procs, proc_node)
 		print_binder_proc_stats(m, proc);
-	if (do_lock)
-		binder_unlock(__func__);
+	mutex_unlock(&binder_procs_lock);
+
 	return 0;
 }
 
 static int binder_transactions_show(struct seq_file *m, void *unused)
 {
 	struct binder_proc *proc;
-	int do_lock = !binder_debug_no_lock;
-
-	if (do_lock)
-		binder_lock(__func__);
 
 	seq_puts(m, "binder transactions:\n");
+	mutex_lock(&binder_procs_lock);
 	hlist_for_each_entry(proc, &binder_procs, proc_node)
 		print_binder_proc(m, proc, 0);
-	if (do_lock)
-		binder_unlock(__func__);
+	mutex_unlock(&binder_procs_lock);
+
 	return 0;
 }
 
 static int binder_proc_show(struct seq_file *m, void *unused)
 {
 	struct binder_proc *itr;
-	struct binder_proc *proc = m->private;
-	int do_lock = !binder_debug_no_lock;
-	bool valid_proc = false;
-
-	if (do_lock)
-		binder_lock(__func__);
+	int pid = (unsigned long)m->private;
 
+	mutex_lock(&binder_procs_lock);
 	hlist_for_each_entry(itr, &binder_procs, proc_node) {
-		if (itr == proc) {
-			valid_proc = true;
-			break;
+		if (itr->pid == pid) {
+			seq_puts(m, "binder proc state:\n");
+			print_binder_proc(m, itr, 1);
 		}
 	}
-	if (valid_proc) {
-		seq_puts(m, "binder proc state:\n");
-		print_binder_proc(m, proc, 1);
-	}
-	if (do_lock)
-		binder_unlock(__func__);
+	mutex_unlock(&binder_procs_lock);
+
 	return 0;
 }
 
 static void print_binder_transaction_log_entry(struct seq_file *m,
 					struct binder_transaction_log_entry *e)
 {
+	int debug_id = READ_ONCE(e->debug_id_done);
+	/*
+	 * read barrier to guarantee debug_id_done read before
+	 * we print the log values
+	 */
+	smp_rmb();
 	seq_printf(m,
-		   "%d: %s from %d:%d to %d:%d node %d handle %d size %d:%d\n",
+		   "%d: %s from %d:%d to %d:%d context %s node %d handle %d size %d:%d ret %d/%d l=%d",
 		   e->debug_id, (e->call_type == 2) ? "reply" :
 		   ((e->call_type == 1) ? "async" : "call "), e->from_proc,
-		   e->from_thread, e->to_proc, e->to_thread, e->to_node,
-		   e->target_handle, e->data_size, e->offsets_size);
+		   e->from_thread, e->to_proc, e->to_thread, e->context_name,
+		   e->to_node, e->target_handle, e->data_size, e->offsets_size,
+		   e->return_error, e->return_error_param,
+		   e->return_error_line);
+	/*
+	 * read-barrier to guarantee read of debug_id_done after
+	 * done printing the fields of the entry
+	 */
+	smp_rmb();
+	seq_printf(m, debug_id && debug_id == READ_ONCE(e->debug_id_done) ?
+			"\n" : " (incomplete)\n");
 }
 
 static int binder_transaction_log_show(struct seq_file *m, void *unused)
 {
 	struct binder_transaction_log *log = m->private;
+	unsigned int log_cur = atomic_read(&log->cur);
+	unsigned int count;
+	unsigned int cur;
 	int i;
 
-	if (log->full) {
-		for (i = log->next; i < ARRAY_SIZE(log->entry); i++)
-			print_binder_transaction_log_entry(m, &log->entry[i]);
+	count = log_cur + 1;
+	cur = count < ARRAY_SIZE(log->entry) && !log->full ?
+		0 : count % ARRAY_SIZE(log->entry);
+	if (count > ARRAY_SIZE(log->entry) || log->full)
+		count = ARRAY_SIZE(log->entry);
+	for (i = 0; i < count; i++) {
+		unsigned int index = cur++ % ARRAY_SIZE(log->entry);
+
+		print_binder_transaction_log_entry(m, &log->entry[index]);
 	}
-	for (i = 0; i < log->next; i++)
-		print_binder_transaction_log_entry(m, &log->entry[i]);
 	return 0;
 }
 
@@ -3683,53 +5764,118 @@ static int binder_transaction_log_show(struct seq_file *m, void *unused)
 	.release = binder_release,
 };
 
-static struct miscdevice binder_miscdev = {
-	.minor = MISC_DYNAMIC_MINOR,
-	.name = "binder",
-	.fops = &binder_fops
-};
-
 BINDER_DEBUG_ENTRY(state);
 BINDER_DEBUG_ENTRY(stats);
 BINDER_DEBUG_ENTRY(transactions);
 BINDER_DEBUG_ENTRY(transaction_log);
 
+static int __init init_binder_device(const char *name)
+{
+	int ret;
+	struct binder_device *binder_device;
+
+	binder_device = kzalloc(sizeof(*binder_device), GFP_KERNEL);
+	if (!binder_device)
+		return -ENOMEM;
+
+	binder_device->miscdev.fops = &binder_fops;
+	binder_device->miscdev.minor = MISC_DYNAMIC_MINOR;
+	binder_device->miscdev.name = name;
+
+	binder_device->context.binder_context_mgr_uid = INVALID_UID;
+	binder_device->context.name = name;
+	mutex_init(&binder_device->context.context_mgr_node_lock);
+
+	ret = misc_register(&binder_device->miscdev);
+	if (ret < 0) {
+		kfree(binder_device);
+		return ret;
+	}
+
+	hlist_add_head(&binder_device->hlist, &binder_devices);
+
+	return ret;
+}
+
 static int __init binder_init(void)
 {
 	int ret;
+	char *device_name, *device_names, *device_tmp;
+	struct binder_device *device;
+	struct hlist_node *tmp;
+
+	ret = binder_alloc_shrinker_init();
+	if (ret)
+		return ret;
+
+	atomic_set(&binder_transaction_log.cur, ~0U);
+	atomic_set(&binder_transaction_log_failed.cur, ~0U);
 
 	binder_debugfs_dir_entry_root = debugfs_create_dir("binder", NULL);
 	if (binder_debugfs_dir_entry_root)
 		binder_debugfs_dir_entry_proc = debugfs_create_dir("proc",
 						 binder_debugfs_dir_entry_root);
-	ret = misc_register(&binder_miscdev);
+
 	if (binder_debugfs_dir_entry_root) {
 		debugfs_create_file("state",
-				    S_IRUGO,
+				    0444,
 				    binder_debugfs_dir_entry_root,
 				    NULL,
 				    &binder_state_fops);
 		debugfs_create_file("stats",
-				    S_IRUGO,
+				    0444,
 				    binder_debugfs_dir_entry_root,
 				    NULL,
 				    &binder_stats_fops);
 		debugfs_create_file("transactions",
-				    S_IRUGO,
+				    0444,
 				    binder_debugfs_dir_entry_root,
 				    NULL,
 				    &binder_transactions_fops);
 		debugfs_create_file("transaction_log",
-				    S_IRUGO,
+				    0444,
 				    binder_debugfs_dir_entry_root,
 				    &binder_transaction_log,
 				    &binder_transaction_log_fops);
 		debugfs_create_file("failed_transaction_log",
-				    S_IRUGO,
+				    0444,
 				    binder_debugfs_dir_entry_root,
 				    &binder_transaction_log_failed,
 				    &binder_transaction_log_fops);
 	}
+
+	/*
+	 * Copy the module_parameter string, because we don't want to
+	 * tokenize it in-place.
+	 */
+	device_names = kzalloc(strlen(binder_devices_param) + 1, GFP_KERNEL);
+	if (!device_names) {
+		ret = -ENOMEM;
+		goto err_alloc_device_names_failed;
+	}
+	strcpy(device_names, binder_devices_param);
+
+	device_tmp = device_names;
+	while ((device_name = strsep(&device_tmp, ","))) {
+		ret = init_binder_device(device_name);
+		if (ret)
+			goto err_init_binder_device_failed;
+	}
+
+	return ret;
+
+err_init_binder_device_failed:
+	hlist_for_each_entry_safe(device, tmp, &binder_devices, hlist) {
+		misc_deregister(&device->miscdev);
+		hlist_del(&device->hlist);
+		kfree(device);
+	}
+
+	kfree(device_names);
+
+err_alloc_device_names_failed:
+	debugfs_remove_recursive(binder_debugfs_dir_entry_root);
+
 	return ret;
 }
 
diff --git a/drivers/android/binder_alloc.c b/drivers/android/binder_alloc.c
new file mode 100644
index 00000000..c85aa07
--- /dev/null
+++ b/drivers/android/binder_alloc.c
@@ -0,0 +1,1039 @@
+/* binder_alloc.c
+ *
+ * Android IPC Subsystem
+ *
+ * Copyright (C) 2007-2017 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#define pr_fmt(fmt) KBUILD_MODNAME ": " fmt
+
+#include <asm/cacheflush.h>
+#include <linux/list.h>
+#include <linux/mm.h>
+#include <linux/module.h>
+#include <linux/rtmutex.h>
+#include <linux/rbtree.h>
+#include <linux/seq_file.h>
+#include <linux/vmalloc.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/list_lru.h>
+#include "binder_alloc.h"
+#include "binder_trace.h"
+
+struct list_lru binder_alloc_lru;
+static DEFINE_MUTEX(binder_alloc_lru_lock);
+
+static DEFINE_MUTEX(binder_alloc_mmap_lock);
+
+enum {
+	BINDER_DEBUG_OPEN_CLOSE             = 1U << 1,
+	BINDER_DEBUG_BUFFER_ALLOC           = 1U << 2,
+	BINDER_DEBUG_BUFFER_ALLOC_ASYNC     = 1U << 3,
+};
+static uint32_t binder_alloc_debug_mask;
+
+module_param_named(debug_mask, binder_alloc_debug_mask,
+		   uint, 0644);
+
+#define binder_alloc_debug(mask, x...) \
+	do { \
+		if (binder_alloc_debug_mask & mask) \
+			pr_info(x); \
+	} while (0)
+
+static struct binder_buffer *binder_buffer_next(struct binder_buffer *buffer)
+{
+	return list_entry(buffer->entry.next, struct binder_buffer, entry);
+}
+
+static struct binder_buffer *binder_buffer_prev(struct binder_buffer *buffer)
+{
+	return list_entry(buffer->entry.prev, struct binder_buffer, entry);
+}
+
+static size_t binder_alloc_buffer_size(struct binder_alloc *alloc,
+				       struct binder_buffer *buffer)
+{
+	if (list_is_last(&buffer->entry, &alloc->buffers))
+		return (u8 *)alloc->buffer +
+			alloc->buffer_size - (u8 *)buffer->data;
+	return (u8 *)binder_buffer_next(buffer)->data - (u8 *)buffer->data;
+}
+
+static void binder_insert_free_buffer(struct binder_alloc *alloc,
+				      struct binder_buffer *new_buffer)
+{
+	struct rb_node **p = &alloc->free_buffers.rb_node;
+	struct rb_node *parent = NULL;
+	struct binder_buffer *buffer;
+	size_t buffer_size;
+	size_t new_buffer_size;
+
+	BUG_ON(!new_buffer->free);
+
+	new_buffer_size = binder_alloc_buffer_size(alloc, new_buffer);
+
+	binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+		     "%d: add free buffer, size %zd, at %pK\n",
+		      alloc->pid, new_buffer_size, new_buffer);
+
+	while (*p) {
+		parent = *p;
+		buffer = rb_entry(parent, struct binder_buffer, rb_node);
+		BUG_ON(!buffer->free);
+
+		buffer_size = binder_alloc_buffer_size(alloc, buffer);
+
+		if (new_buffer_size < buffer_size)
+			p = &parent->rb_left;
+		else
+			p = &parent->rb_right;
+	}
+	rb_link_node(&new_buffer->rb_node, parent, p);
+	rb_insert_color(&new_buffer->rb_node, &alloc->free_buffers);
+}
+
+static void binder_insert_allocated_buffer_locked(
+		struct binder_alloc *alloc, struct binder_buffer *new_buffer)
+{
+	struct rb_node **p = &alloc->allocated_buffers.rb_node;
+	struct rb_node *parent = NULL;
+	struct binder_buffer *buffer;
+
+	BUG_ON(new_buffer->free);
+
+	while (*p) {
+		parent = *p;
+		buffer = rb_entry(parent, struct binder_buffer, rb_node);
+		BUG_ON(buffer->free);
+
+		if (new_buffer->data < buffer->data)
+			p = &parent->rb_left;
+		else if (new_buffer->data > buffer->data)
+			p = &parent->rb_right;
+		else
+			BUG();
+	}
+	rb_link_node(&new_buffer->rb_node, parent, p);
+	rb_insert_color(&new_buffer->rb_node, &alloc->allocated_buffers);
+}
+
+static struct binder_buffer *binder_alloc_prepare_to_free_locked(
+		struct binder_alloc *alloc,
+		uintptr_t user_ptr)
+{
+	struct rb_node *n = alloc->allocated_buffers.rb_node;
+	struct binder_buffer *buffer;
+	void *kern_ptr;
+
+	kern_ptr = (void *)(user_ptr - alloc->user_buffer_offset);
+
+	while (n) {
+		buffer = rb_entry(n, struct binder_buffer, rb_node);
+		BUG_ON(buffer->free);
+
+		if (kern_ptr < buffer->data)
+			n = n->rb_left;
+		else if (kern_ptr > buffer->data)
+			n = n->rb_right;
+		else {
+			/*
+			 * Guard against user threads attempting to
+			 * free the buffer twice
+			 */
+			if (buffer->free_in_progress) {
+				pr_err("%d:%d FREE_BUFFER u%016llx user freed buffer twice\n",
+				       alloc->pid, current->pid, (u64)user_ptr);
+				return NULL;
+			}
+			buffer->free_in_progress = 1;
+			return buffer;
+		}
+	}
+	return NULL;
+}
+
+/**
+ * binder_alloc_buffer_lookup() - get buffer given user ptr
+ * @alloc:	binder_alloc for this proc
+ * @user_ptr:	User pointer to buffer data
+ *
+ * Validate userspace pointer to buffer data and return buffer corresponding to
+ * that user pointer. Search the rb tree for buffer that matches user data
+ * pointer.
+ *
+ * Return:	Pointer to buffer or NULL
+ */
+struct binder_buffer *binder_alloc_prepare_to_free(struct binder_alloc *alloc,
+						   uintptr_t user_ptr)
+{
+	struct binder_buffer *buffer;
+
+	mutex_lock(&alloc->mutex);
+	buffer = binder_alloc_prepare_to_free_locked(alloc, user_ptr);
+	mutex_unlock(&alloc->mutex);
+	return buffer;
+}
+
+static int binder_update_page_range(struct binder_alloc *alloc, int allocate,
+				    void *start, void *end)
+{
+	void *page_addr;
+	unsigned long user_page_addr;
+	struct binder_lru_page *page;
+	struct vm_area_struct *vma = NULL;
+	struct mm_struct *mm = NULL;
+	bool need_mm = false;
+
+	binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+		     "%d: %s pages %pK-%pK\n", alloc->pid,
+		     allocate ? "allocate" : "free", start, end);
+
+	if (end <= start)
+		return 0;
+
+	trace_binder_update_page_range(alloc, allocate, start, end);
+
+	if (allocate == 0)
+		goto free_range;
+
+	for (page_addr = start; page_addr < end; page_addr += PAGE_SIZE) {
+		page = &alloc->pages[(page_addr - alloc->buffer) / PAGE_SIZE];
+		if (!page->page_ptr) {
+			need_mm = true;
+			break;
+		}
+	}
+
+	if (need_mm && mmget_not_zero(alloc->vma_vm_mm))
+		mm = alloc->vma_vm_mm;
+
+	if (mm) {
+		down_read(&mm->mmap_sem);
+		vma = alloc->vma;
+	}
+
+	if (!vma && need_mm) {
+		pr_err("%d: binder_alloc_buf failed to map pages in userspace, no vma\n",
+			alloc->pid);
+		goto err_no_vma;
+	}
+
+	for (page_addr = start; page_addr < end; page_addr += PAGE_SIZE) {
+		int ret;
+		bool on_lru;
+		size_t index;
+
+		index = (page_addr - alloc->buffer) / PAGE_SIZE;
+		page = &alloc->pages[index];
+
+		if (page->page_ptr) {
+			mutex_lock(&binder_alloc_lru_lock);
+			trace_binder_alloc_lru_start(alloc, index);
+
+			on_lru = list_lru_del(&binder_alloc_lru, &page->lru);
+			WARN_ON(!on_lru);
+
+			trace_binder_alloc_lru_end(alloc, index);
+			mutex_unlock(&binder_alloc_lru_lock);
+			continue;
+		}
+
+		if (WARN_ON(!vma))
+			goto err_page_ptr_cleared;
+
+		trace_binder_alloc_page_start(alloc, index);
+		page->page_ptr = alloc_page(GFP_KERNEL |
+					    __GFP_HIGHMEM |
+					    __GFP_ZERO);
+		if (!page->page_ptr) {
+			pr_err("%d: binder_alloc_buf failed for page at %pK\n",
+				alloc->pid, page_addr);
+			goto err_alloc_page_failed;
+		}
+		page->alloc = alloc;
+		INIT_LIST_HEAD(&page->lru);
+
+		ret = map_kernel_range_noflush((unsigned long)page_addr,
+					       PAGE_SIZE, PAGE_KERNEL,
+					       &page->page_ptr);
+		flush_cache_vmap((unsigned long)page_addr,
+				(unsigned long)page_addr + PAGE_SIZE);
+		if (ret != 1) {
+			pr_err("%d: binder_alloc_buf failed to map page at %pK in kernel\n",
+			       alloc->pid, page_addr);
+			goto err_map_kernel_failed;
+		}
+		user_page_addr =
+			(uintptr_t)page_addr + alloc->user_buffer_offset;
+		ret = vm_insert_page(vma, user_page_addr, page[0].page_ptr);
+		if (ret) {
+			pr_err("%d: binder_alloc_buf failed to map page at %lx in userspace\n",
+			       alloc->pid, user_page_addr);
+			goto err_vm_insert_page_failed;
+		}
+
+		if (index + 1 > alloc->pages_high)
+			alloc->pages_high = index + 1;
+
+		trace_binder_alloc_page_end(alloc, index);
+		/* vm_insert_page does not seem to increment the refcount */
+	}
+	if (mm) {
+		up_read(&mm->mmap_sem);
+		mmput(mm);
+	}
+	return 0;
+
+free_range:
+	for (page_addr = end - PAGE_SIZE; page_addr >= start;
+	     page_addr -= PAGE_SIZE) {
+		bool ret;
+		size_t index;
+
+		index = (page_addr - alloc->buffer) / PAGE_SIZE;
+		page = &alloc->pages[index];
+
+		trace_binder_free_lru_start(alloc, index);
+
+		mutex_lock(&binder_alloc_lru_lock);
+		ret = list_lru_add(&binder_alloc_lru, &page->lru);
+		mutex_unlock(&binder_alloc_lru_lock);
+		WARN_ON(!ret);
+
+		trace_binder_free_lru_end(alloc, index);
+		continue;
+
+err_vm_insert_page_failed:
+		unmap_kernel_range((unsigned long)page_addr, PAGE_SIZE);
+err_map_kernel_failed:
+		__free_page(page->page_ptr);
+		page->page_ptr = NULL;
+err_alloc_page_failed:
+err_page_ptr_cleared:
+		;
+	}
+err_no_vma:
+	if (mm) {
+		up_read(&mm->mmap_sem);
+		mmput(mm);
+	}
+	return vma ? -ENOMEM : -ESRCH;
+}
+
+static struct binder_buffer *binder_alloc_new_buf_locked(
+				struct binder_alloc *alloc,
+				size_t data_size,
+				size_t offsets_size,
+				size_t extra_buffers_size,
+				int is_async)
+{
+	struct rb_node *n = alloc->free_buffers.rb_node;
+	struct binder_buffer *buffer;
+	size_t buffer_size;
+	struct rb_node *best_fit = NULL;
+	void *has_page_addr;
+	void *end_page_addr;
+	size_t size, data_offsets_size;
+	int ret;
+
+	if (alloc->vma == NULL) {
+		pr_err("%d: binder_alloc_buf, no vma\n",
+		       alloc->pid);
+		return ERR_PTR(-ESRCH);
+	}
+
+	data_offsets_size = ALIGN(data_size, sizeof(void *)) +
+		ALIGN(offsets_size, sizeof(void *));
+
+	if (data_offsets_size < data_size || data_offsets_size < offsets_size) {
+		binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+				"%d: got transaction with invalid size %zd-%zd\n",
+				alloc->pid, data_size, offsets_size);
+		return ERR_PTR(-EINVAL);
+	}
+	size = data_offsets_size + ALIGN(extra_buffers_size, sizeof(void *));
+	if (size < data_offsets_size || size < extra_buffers_size) {
+		binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+				"%d: got transaction with invalid extra_buffers_size %zd\n",
+				alloc->pid, extra_buffers_size);
+		return ERR_PTR(-EINVAL);
+	}
+	if (is_async &&
+	    alloc->free_async_space < size + sizeof(struct binder_buffer)) {
+		binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+			     "%d: binder_alloc_buf size %zd failed, no async space left\n",
+			      alloc->pid, size);
+		return ERR_PTR(-ENOSPC);
+	}
+
+	/* Pad 0-size buffers so they get assigned unique addresses */
+	size = max(size, sizeof(void *));
+
+	while (n) {
+		buffer = rb_entry(n, struct binder_buffer, rb_node);
+		BUG_ON(!buffer->free);
+		buffer_size = binder_alloc_buffer_size(alloc, buffer);
+
+		if (size < buffer_size) {
+			best_fit = n;
+			n = n->rb_left;
+		} else if (size > buffer_size)
+			n = n->rb_right;
+		else {
+			best_fit = n;
+			break;
+		}
+	}
+	if (best_fit == NULL) {
+		size_t allocated_buffers = 0;
+		size_t largest_alloc_size = 0;
+		size_t total_alloc_size = 0;
+		size_t free_buffers = 0;
+		size_t largest_free_size = 0;
+		size_t total_free_size = 0;
+
+		for (n = rb_first(&alloc->allocated_buffers); n != NULL;
+		     n = rb_next(n)) {
+			buffer = rb_entry(n, struct binder_buffer, rb_node);
+			buffer_size = binder_alloc_buffer_size(alloc, buffer);
+			allocated_buffers++;
+			total_alloc_size += buffer_size;
+			if (buffer_size > largest_alloc_size)
+				largest_alloc_size = buffer_size;
+		}
+		for (n = rb_first(&alloc->free_buffers); n != NULL;
+		     n = rb_next(n)) {
+			buffer = rb_entry(n, struct binder_buffer, rb_node);
+			buffer_size = binder_alloc_buffer_size(alloc, buffer);
+			free_buffers++;
+			total_free_size += buffer_size;
+			if (buffer_size > largest_free_size)
+				largest_free_size = buffer_size;
+		}
+		pr_err("%d: binder_alloc_buf size %zd failed, no address space\n",
+			alloc->pid, size);
+		pr_err("allocated: %zd (num: %zd largest: %zd), free: %zd (num: %zd largest: %zd)\n",
+		       total_alloc_size, allocated_buffers, largest_alloc_size,
+		       total_free_size, free_buffers, largest_free_size);
+		return ERR_PTR(-ENOSPC);
+	}
+	if (n == NULL) {
+		buffer = rb_entry(best_fit, struct binder_buffer, rb_node);
+		buffer_size = binder_alloc_buffer_size(alloc, buffer);
+	}
+
+	binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+		     "%d: binder_alloc_buf size %zd got buffer %pK size %zd\n",
+		      alloc->pid, size, buffer, buffer_size);
+
+	has_page_addr =
+		(void *)(((uintptr_t)buffer->data + buffer_size) & PAGE_MASK);
+	WARN_ON(n && buffer_size != size);
+	end_page_addr =
+		(void *)PAGE_ALIGN((uintptr_t)buffer->data + size);
+	if (end_page_addr > has_page_addr)
+		end_page_addr = has_page_addr;
+	ret = binder_update_page_range(alloc, 1,
+	    (void *)PAGE_ALIGN((uintptr_t)buffer->data), end_page_addr);
+	if (ret)
+		return ERR_PTR(ret);
+
+	if (buffer_size != size) {
+		struct binder_buffer *new_buffer;
+
+		new_buffer = kzalloc(sizeof(*buffer), GFP_KERNEL);
+		if (!new_buffer) {
+			pr_err("%s: %d failed to alloc new buffer struct\n",
+			       __func__, alloc->pid);
+			goto err_alloc_buf_struct_failed;
+		}
+		new_buffer->data = (u8 *)buffer->data + size;
+		list_add(&new_buffer->entry, &buffer->entry);
+		new_buffer->free = 1;
+		binder_insert_free_buffer(alloc, new_buffer);
+	}
+
+	rb_erase(best_fit, &alloc->free_buffers);
+	buffer->free = 0;
+	buffer->free_in_progress = 0;
+	binder_insert_allocated_buffer_locked(alloc, buffer);
+	binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+		     "%d: binder_alloc_buf size %zd got %pK\n",
+		      alloc->pid, size, buffer);
+	buffer->data_size = data_size;
+	buffer->offsets_size = offsets_size;
+	buffer->async_transaction = is_async;
+	buffer->extra_buffers_size = extra_buffers_size;
+	if (is_async) {
+		alloc->free_async_space -= size + sizeof(struct binder_buffer);
+		binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC_ASYNC,
+			     "%d: binder_alloc_buf size %zd async free %zd\n",
+			      alloc->pid, size, alloc->free_async_space);
+	}
+	return buffer;
+
+err_alloc_buf_struct_failed:
+	binder_update_page_range(alloc, 0,
+				 (void *)PAGE_ALIGN((uintptr_t)buffer->data),
+				 end_page_addr);
+	return ERR_PTR(-ENOMEM);
+}
+
+/**
+ * binder_alloc_new_buf() - Allocate a new binder buffer
+ * @alloc:              binder_alloc for this proc
+ * @data_size:          size of user data buffer
+ * @offsets_size:       user specified buffer offset
+ * @extra_buffers_size: size of extra space for meta-data (eg, security context)
+ * @is_async:           buffer for async transaction
+ *
+ * Allocate a new buffer given the requested sizes. Returns
+ * the kernel version of the buffer pointer. The size allocated
+ * is the sum of the three given sizes (each rounded up to
+ * pointer-sized boundary)
+ *
+ * Return:	The allocated buffer or %NULL if error
+ */
+struct binder_buffer *binder_alloc_new_buf(struct binder_alloc *alloc,
+					   size_t data_size,
+					   size_t offsets_size,
+					   size_t extra_buffers_size,
+					   int is_async)
+{
+	struct binder_buffer *buffer;
+
+	mutex_lock(&alloc->mutex);
+	buffer = binder_alloc_new_buf_locked(alloc, data_size, offsets_size,
+					     extra_buffers_size, is_async);
+	mutex_unlock(&alloc->mutex);
+	return buffer;
+}
+
+static void *buffer_start_page(struct binder_buffer *buffer)
+{
+	return (void *)((uintptr_t)buffer->data & PAGE_MASK);
+}
+
+static void *prev_buffer_end_page(struct binder_buffer *buffer)
+{
+	return (void *)(((uintptr_t)(buffer->data) - 1) & PAGE_MASK);
+}
+
+static void binder_delete_free_buffer(struct binder_alloc *alloc,
+				      struct binder_buffer *buffer)
+{
+	struct binder_buffer *prev, *next = NULL;
+	bool to_free = true;
+	BUG_ON(alloc->buffers.next == &buffer->entry);
+	prev = binder_buffer_prev(buffer);
+	BUG_ON(!prev->free);
+	if (prev_buffer_end_page(prev) == buffer_start_page(buffer)) {
+		to_free = false;
+		binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+				   "%d: merge free, buffer %pK share page with %pK\n",
+				   alloc->pid, buffer->data, prev->data);
+	}
+
+	if (!list_is_last(&buffer->entry, &alloc->buffers)) {
+		next = binder_buffer_next(buffer);
+		if (buffer_start_page(next) == buffer_start_page(buffer)) {
+			to_free = false;
+			binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+					   "%d: merge free, buffer %pK share page with %pK\n",
+					   alloc->pid,
+					   buffer->data,
+					   next->data);
+		}
+	}
+
+	if (PAGE_ALIGNED(buffer->data)) {
+		binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+				   "%d: merge free, buffer start %pK is page aligned\n",
+				   alloc->pid, buffer->data);
+		to_free = false;
+	}
+
+	if (to_free) {
+		binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+				   "%d: merge free, buffer %pK do not share page with %pK or %pK\n",
+				   alloc->pid, buffer->data,
+				   prev->data, next ? next->data : NULL);
+		binder_update_page_range(alloc, 0, buffer_start_page(buffer),
+					 buffer_start_page(buffer) + PAGE_SIZE);
+	}
+	list_del(&buffer->entry);
+	kfree(buffer);
+}
+
+static void binder_free_buf_locked(struct binder_alloc *alloc,
+				   struct binder_buffer *buffer)
+{
+	size_t size, buffer_size;
+
+	buffer_size = binder_alloc_buffer_size(alloc, buffer);
+
+	size = ALIGN(buffer->data_size, sizeof(void *)) +
+		ALIGN(buffer->offsets_size, sizeof(void *)) +
+		ALIGN(buffer->extra_buffers_size, sizeof(void *));
+
+	binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+		     "%d: binder_free_buf %pK size %zd buffer_size %zd\n",
+		      alloc->pid, buffer, size, buffer_size);
+
+	BUG_ON(buffer->free);
+	BUG_ON(size > buffer_size);
+	BUG_ON(buffer->transaction != NULL);
+	BUG_ON(buffer->data < alloc->buffer);
+	BUG_ON(buffer->data > alloc->buffer + alloc->buffer_size);
+
+	if (buffer->async_transaction) {
+		alloc->free_async_space += size + sizeof(struct binder_buffer);
+
+		binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC_ASYNC,
+			     "%d: binder_free_buf size %zd async free %zd\n",
+			      alloc->pid, size, alloc->free_async_space);
+	}
+
+	binder_update_page_range(alloc, 0,
+		(void *)PAGE_ALIGN((uintptr_t)buffer->data),
+		(void *)(((uintptr_t)buffer->data + buffer_size) & PAGE_MASK));
+
+	rb_erase(&buffer->rb_node, &alloc->allocated_buffers);
+	buffer->free = 1;
+	if (!list_is_last(&buffer->entry, &alloc->buffers)) {
+		struct binder_buffer *next = binder_buffer_next(buffer);
+
+		if (next->free) {
+			rb_erase(&next->rb_node, &alloc->free_buffers);
+			binder_delete_free_buffer(alloc, next);
+		}
+	}
+	if (alloc->buffers.next != &buffer->entry) {
+		struct binder_buffer *prev = binder_buffer_prev(buffer);
+
+		if (prev->free) {
+			binder_delete_free_buffer(alloc, buffer);
+			rb_erase(&prev->rb_node, &alloc->free_buffers);
+			buffer = prev;
+		}
+	}
+	binder_insert_free_buffer(alloc, buffer);
+}
+
+/**
+ * binder_alloc_free_buf() - free a binder buffer
+ * @alloc:	binder_alloc for this proc
+ * @buffer:	kernel pointer to buffer
+ *
+ * Free the buffer allocated via binder_alloc_new_buffer()
+ */
+void binder_alloc_free_buf(struct binder_alloc *alloc,
+			    struct binder_buffer *buffer)
+{
+	mutex_lock(&alloc->mutex);
+	binder_free_buf_locked(alloc, buffer);
+	mutex_unlock(&alloc->mutex);
+}
+
+/**
+ * binder_alloc_mmap_handler() - map virtual address space for proc
+ * @alloc:	alloc structure for this proc
+ * @vma:	vma passed to mmap()
+ *
+ * Called by binder_mmap() to initialize the space specified in
+ * vma for allocating binder buffers
+ *
+ * Return:
+ *      0 = success
+ *      -EBUSY = address space already mapped
+ *      -ENOMEM = failed to map memory to given address space
+ */
+int binder_alloc_mmap_handler(struct binder_alloc *alloc,
+			      struct vm_area_struct *vma)
+{
+	int ret;
+	struct vm_struct *area;
+	const char *failure_string;
+	struct binder_buffer *buffer;
+
+	mutex_lock(&binder_alloc_mmap_lock);
+	if (alloc->buffer) {
+		ret = -EBUSY;
+		failure_string = "already mapped";
+		goto err_already_mapped;
+	}
+
+	area = get_vm_area(vma->vm_end - vma->vm_start, VM_ALLOC);
+	if (area == NULL) {
+		ret = -ENOMEM;
+		failure_string = "get_vm_area";
+		goto err_get_vm_area_failed;
+	}
+	alloc->buffer = area->addr;
+	alloc->user_buffer_offset =
+		vma->vm_start - (uintptr_t)alloc->buffer;
+	mutex_unlock(&binder_alloc_mmap_lock);
+
+#ifdef CONFIG_CPU_CACHE_VIPT
+	if (cache_is_vipt_aliasing()) {
+		while (CACHE_COLOUR(
+				(vma->vm_start ^ (uint32_t)alloc->buffer))) {
+			pr_info("%s: %d %lx-%lx maps %pK bad alignment\n",
+				__func__, alloc->pid, vma->vm_start,
+				vma->vm_end, alloc->buffer);
+			vma->vm_start += PAGE_SIZE;
+		}
+	}
+#endif
+	alloc->pages = kzalloc(sizeof(alloc->pages[0]) *
+				   ((vma->vm_end - vma->vm_start) / PAGE_SIZE),
+			       GFP_KERNEL);
+	if (alloc->pages == NULL) {
+		ret = -ENOMEM;
+		failure_string = "alloc page array";
+		goto err_alloc_pages_failed;
+	}
+	alloc->buffer_size = vma->vm_end - vma->vm_start;
+
+	buffer = kzalloc(sizeof(*buffer), GFP_KERNEL);
+	if (!buffer) {
+		ret = -ENOMEM;
+		failure_string = "alloc buffer struct";
+		goto err_alloc_buf_struct_failed;
+	}
+
+	buffer->data = alloc->buffer;
+	list_add(&buffer->entry, &alloc->buffers);
+	buffer->free = 1;
+	binder_insert_free_buffer(alloc, buffer);
+	alloc->free_async_space = alloc->buffer_size / 2;
+	barrier();
+	alloc->vma = vma;
+	alloc->vma_vm_mm = vma->vm_mm;
+	/* Same as mmgrab() in later kernel versions */
+	atomic_inc(&alloc->vma_vm_mm->mm_count);
+
+	return 0;
+
+err_alloc_buf_struct_failed:
+	kfree(alloc->pages);
+	alloc->pages = NULL;
+err_alloc_pages_failed:
+	mutex_lock(&binder_alloc_mmap_lock);
+	vfree(alloc->buffer);
+	alloc->buffer = NULL;
+err_get_vm_area_failed:
+err_already_mapped:
+	mutex_unlock(&binder_alloc_mmap_lock);
+	pr_err("%s: %d %lx-%lx %s failed %d\n", __func__,
+	       alloc->pid, vma->vm_start, vma->vm_end, failure_string, ret);
+	return ret;
+}
+
+
+void binder_alloc_deferred_release(struct binder_alloc *alloc)
+{
+	struct rb_node *n;
+	int buffers, page_count;
+	struct binder_buffer *buffer;
+
+	BUG_ON(alloc->vma);
+
+	buffers = 0;
+	mutex_lock(&alloc->mutex);
+	while ((n = rb_first(&alloc->allocated_buffers))) {
+		buffer = rb_entry(n, struct binder_buffer, rb_node);
+
+		/* Transaction should already have been freed */
+		BUG_ON(buffer->transaction);
+
+		binder_free_buf_locked(alloc, buffer);
+		buffers++;
+	}
+
+	while (!list_empty(&alloc->buffers)) {
+		buffer = list_first_entry(&alloc->buffers,
+					  struct binder_buffer, entry);
+		WARN_ON(!buffer->free);
+
+		list_del(&buffer->entry);
+		WARN_ON_ONCE(!list_empty(&alloc->buffers));
+		kfree(buffer);
+	}
+
+	page_count = 0;
+	if (alloc->pages) {
+		int i;
+
+		for (i = 0; i < alloc->buffer_size / PAGE_SIZE; i++) {
+			void *page_addr;
+			bool on_lru;
+
+			if (!alloc->pages[i].page_ptr)
+				continue;
+
+			mutex_lock(&binder_alloc_lru_lock);
+			on_lru = list_lru_del(&binder_alloc_lru,
+					      &alloc->pages[i].lru);
+			mutex_unlock(&binder_alloc_lru_lock);
+			page_addr = alloc->buffer + i * PAGE_SIZE;
+			binder_alloc_debug(BINDER_DEBUG_BUFFER_ALLOC,
+				     "%s: %d: page %d at %pK %s\n",
+				     __func__, alloc->pid, i, page_addr,
+				     on_lru ? "on lru" : "active");
+			unmap_kernel_range((unsigned long)page_addr, PAGE_SIZE);
+			__free_page(alloc->pages[i].page_ptr);
+			page_count++;
+		}
+		kfree(alloc->pages);
+		vfree(alloc->buffer);
+	}
+	mutex_unlock(&alloc->mutex);
+	if (alloc->vma_vm_mm)
+		mmdrop(alloc->vma_vm_mm);
+
+	binder_alloc_debug(BINDER_DEBUG_OPEN_CLOSE,
+		     "%s: %d buffers %d, pages %d\n",
+		     __func__, alloc->pid, buffers, page_count);
+}
+
+static void print_binder_buffer(struct seq_file *m, const char *prefix,
+				struct binder_buffer *buffer)
+{
+	seq_printf(m, "%s %d: %pK size %zd:%zd:%zd %s\n",
+		   prefix, buffer->debug_id, buffer->data,
+		   buffer->data_size, buffer->offsets_size,
+		   buffer->extra_buffers_size,
+		   buffer->transaction ? "active" : "delivered");
+}
+
+/**
+ * binder_alloc_print_allocated() - print buffer info
+ * @m:     seq_file for output via seq_printf()
+ * @alloc: binder_alloc for this proc
+ *
+ * Prints information about every buffer associated with
+ * the binder_alloc state to the given seq_file
+ */
+void binder_alloc_print_allocated(struct seq_file *m,
+				  struct binder_alloc *alloc)
+{
+	struct rb_node *n;
+
+	mutex_lock(&alloc->mutex);
+	for (n = rb_first(&alloc->allocated_buffers); n != NULL; n = rb_next(n))
+		print_binder_buffer(m, "  buffer",
+				    rb_entry(n, struct binder_buffer, rb_node));
+	mutex_unlock(&alloc->mutex);
+}
+
+/**
+ * binder_alloc_print_pages() - print page usage
+ * @m:     seq_file for output via seq_printf()
+ * @alloc: binder_alloc for this proc
+ */
+void binder_alloc_print_pages(struct seq_file *m,
+			      struct binder_alloc *alloc)
+{
+	struct binder_lru_page *page;
+	int i;
+	int active = 0;
+	int lru = 0;
+	int free = 0;
+
+	mutex_lock(&alloc->mutex);
+	for (i = 0; i < alloc->buffer_size / PAGE_SIZE; i++) {
+		page = &alloc->pages[i];
+		if (!page->page_ptr)
+			free++;
+		else if (list_empty(&page->lru))
+			active++;
+		else
+			lru++;
+	}
+	mutex_unlock(&alloc->mutex);
+	seq_printf(m, "  pages: %d:%d:%d\n", active, lru, free);
+	seq_printf(m, "  pages high watermark: %zu\n", alloc->pages_high);
+}
+
+/**
+ * binder_alloc_get_allocated_count() - return count of buffers
+ * @alloc: binder_alloc for this proc
+ *
+ * Return: count of allocated buffers
+ */
+int binder_alloc_get_allocated_count(struct binder_alloc *alloc)
+{
+	struct rb_node *n;
+	int count = 0;
+
+	mutex_lock(&alloc->mutex);
+	for (n = rb_first(&alloc->allocated_buffers); n != NULL; n = rb_next(n))
+		count++;
+	mutex_unlock(&alloc->mutex);
+	return count;
+}
+
+
+/**
+ * binder_alloc_vma_close() - invalidate address space
+ * @alloc: binder_alloc for this proc
+ *
+ * Called from binder_vma_close() when releasing address space.
+ * Clears alloc->vma to prevent new incoming transactions from
+ * allocating more buffers.
+ */
+void binder_alloc_vma_close(struct binder_alloc *alloc)
+{
+	WRITE_ONCE(alloc->vma, NULL);
+}
+
+/**
+ * binder_alloc_free_page() - shrinker callback to free pages
+ * @item:   item to free
+ * @lock:   lock protecting the item
+ * @cb_arg: callback argument
+ *
+ * Called from list_lru_walk() in binder_shrink_scan() to free
+ * up pages when the system is under memory pressure.
+ */
+enum lru_status binder_alloc_free_page(struct list_head *item,
+				       struct list_lru_one *lru,
+				       spinlock_t *lock,
+				       void *cb_arg)
+{
+	struct mm_struct *mm = NULL;
+	struct binder_lru_page *page = container_of(item,
+						    struct binder_lru_page,
+						    lru);
+	struct binder_alloc *alloc;
+	uintptr_t page_addr;
+	size_t index;
+	struct vm_area_struct *vma;
+
+	alloc = page->alloc;
+	if (!mutex_trylock(&alloc->mutex))
+		goto err_get_alloc_mutex_failed;
+
+	if (!page->page_ptr)
+		goto err_page_already_freed;
+
+	index = page - alloc->pages;
+	page_addr = (uintptr_t)alloc->buffer + index * PAGE_SIZE;
+	vma = alloc->vma;
+	if (vma) {
+		if (!mmget_not_zero(alloc->vma_vm_mm))
+			goto err_mmget;
+		mm = alloc->vma_vm_mm;
+		if (!down_write_trylock(&mm->mmap_sem))
+			goto err_down_write_mmap_sem_failed;
+	}
+
+	list_lru_isolate(lru, item);
+	spin_unlock(lock);
+
+	if (vma) {
+		trace_binder_unmap_user_start(alloc, index);
+
+		zap_page_range(vma,
+			       page_addr +
+			       alloc->user_buffer_offset,
+			       PAGE_SIZE, NULL);
+
+		trace_binder_unmap_user_end(alloc, index);
+
+		up_write(&mm->mmap_sem);
+		mmput(mm);
+	}
+
+	trace_binder_unmap_kernel_start(alloc, index);
+
+	unmap_kernel_range(page_addr, PAGE_SIZE);
+	__free_page(page->page_ptr);
+	page->page_ptr = NULL;
+
+	trace_binder_unmap_kernel_end(alloc, index);
+
+	spin_lock(lock);
+	mutex_unlock(&alloc->mutex);
+	return LRU_REMOVED_RETRY;
+
+err_down_write_mmap_sem_failed:
+	mmput_async(mm);
+err_mmget:
+err_page_already_freed:
+	mutex_unlock(&alloc->mutex);
+err_get_alloc_mutex_failed:
+	return LRU_SKIP;
+}
+
+static unsigned long
+binder_shrink_count(struct shrinker *shrink, struct shrink_control *sc)
+{
+#if 0
+	unsigned long ret = list_lru_count(&binder_alloc_lru);
+#else
+	unsigned long ret;
+	mutex_lock(&binder_alloc_lru_lock);
+	ret = list_lru_count(&binder_alloc_lru);
+	mutex_unlock(&binder_alloc_lru_lock);
+#endif
+	return ret;
+}
+
+static unsigned long
+binder_shrink_scan(struct shrinker *shrink, struct shrink_control *sc)
+{
+	unsigned long ret;
+
+	mutex_lock(&binder_alloc_lru_lock);
+	ret = list_lru_walk(&binder_alloc_lru, binder_alloc_free_page,
+			    NULL, sc->nr_to_scan);
+	mutex_unlock(&binder_alloc_lru_lock);
+	return ret;
+}
+
+static struct shrinker binder_shrinker = {
+	.count_objects = binder_shrink_count,
+	.scan_objects = binder_shrink_scan,
+	.seeks = DEFAULT_SEEKS,
+};
+
+/**
+ * binder_alloc_init() - called by binder_open() for per-proc initialization
+ * @alloc: binder_alloc for this proc
+ *
+ * Called from binder_open() to initialize binder_alloc fields for
+ * new binder proc
+ */
+void binder_alloc_init(struct binder_alloc *alloc)
+{
+	alloc->pid = current->group_leader->pid;
+	mutex_init(&alloc->mutex);
+	INIT_LIST_HEAD(&alloc->buffers);
+}
+
+int binder_alloc_shrinker_init(void)
+{
+	int ret = list_lru_init(&binder_alloc_lru);
+	mutex_init(&binder_alloc_lru_lock);
+
+	if (ret == 0) {
+		ret = register_shrinker(&binder_shrinker);
+		if (ret)
+			list_lru_destroy(&binder_alloc_lru);
+	}
+	return ret;
+}
diff --git a/drivers/android/binder_alloc.h b/drivers/android/binder_alloc.h
new file mode 100644
index 00000000..9ef64e5
--- /dev/null
+++ b/drivers/android/binder_alloc.h
@@ -0,0 +1,188 @@
+/*
+ * Copyright (C) 2017 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_BINDER_ALLOC_H
+#define _LINUX_BINDER_ALLOC_H
+
+#include <linux/rbtree.h>
+#include <linux/list.h>
+#include <linux/mm.h>
+#include <linux/rtmutex.h>
+#include <linux/vmalloc.h>
+#include <linux/slab.h>
+#include <linux/list_lru.h>
+
+extern struct list_lru binder_alloc_lru;
+struct binder_transaction;
+
+/**
+ * struct binder_buffer - buffer used for binder transactions
+ * @entry:              entry alloc->buffers
+ * @rb_node:            node for allocated_buffers/free_buffers rb trees
+ * @free:               true if buffer is free
+ * @allow_user_free:    describe the second member of struct blah,
+ * @async_transaction:  describe the second member of struct blah,
+ * @debug_id:           describe the second member of struct blah,
+ * @transaction:        describe the second member of struct blah,
+ * @target_node:        describe the second member of struct blah,
+ * @data_size:          describe the second member of struct blah,
+ * @offsets_size:       describe the second member of struct blah,
+ * @extra_buffers_size: describe the second member of struct blah,
+ * @data:i              describe the second member of struct blah,
+ *
+ * Bookkeeping structure for binder transaction buffers
+ */
+struct binder_buffer {
+	struct list_head entry; /* free and allocated entries by address */
+	struct rb_node rb_node; /* free entry by size or allocated entry */
+				/* by address */
+	unsigned free:1;
+	unsigned allow_user_free:1;
+	unsigned async_transaction:1;
+	unsigned free_in_progress:1;
+	unsigned debug_id:28;
+
+	struct binder_transaction *transaction;
+
+	struct binder_node *target_node;
+	size_t data_size;
+	size_t offsets_size;
+	size_t extra_buffers_size;
+	void *data;
+};
+
+/**
+ * struct binder_lru_page - page object used for binder shrinker
+ * @page_ptr: pointer to physical page in mmap'd space
+ * @lru:      entry in binder_alloc_lru
+ * @alloc:    binder_alloc for a proc
+ */
+struct binder_lru_page {
+	struct list_head lru;
+	struct page *page_ptr;
+	struct binder_alloc *alloc;
+};
+
+/**
+ * struct binder_alloc - per-binder proc state for binder allocator
+ * @vma:                vm_area_struct passed to mmap_handler
+ *                      (invarient after mmap)
+ * @tsk:                tid for task that called init for this proc
+ *                      (invariant after init)
+ * @vma_vm_mm:          copy of vma->vm_mm (invarient after mmap)
+ * @buffer:             base of per-proc address space mapped via mmap
+ * @user_buffer_offset: offset between user and kernel VAs for buffer
+ * @buffers:            list of all buffers for this proc
+ * @free_buffers:       rb tree of buffers available for allocation
+ *                      sorted by size
+ * @allocated_buffers:  rb tree of allocated buffers sorted by address
+ * @free_async_space:   VA space available for async buffers. This is
+ *                      initialized at mmap time to 1/2 the full VA space
+ * @pages:              array of binder_lru_page
+ * @buffer_size:        size of address space specified via mmap
+ * @pid:                pid for associated binder_proc (invariant after init)
+ * @pages_high:         high watermark of offset in @pages
+ *
+ * Bookkeeping structure for per-proc address space management for binder
+ * buffers. It is normally initialized during binder_init() and binder_mmap()
+ * calls. The address space is used for both user-visible buffers and for
+ * struct binder_buffer objects used to track the user buffers
+ */
+struct binder_alloc {
+	struct mutex mutex;
+	struct vm_area_struct *vma;
+	struct mm_struct *vma_vm_mm;
+	void *buffer;
+	ptrdiff_t user_buffer_offset;
+	struct list_head buffers;
+	struct rb_root free_buffers;
+	struct rb_root allocated_buffers;
+	size_t free_async_space;
+	struct binder_lru_page *pages;
+	size_t buffer_size;
+	uint32_t buffer_free;
+	int pid;
+	size_t pages_high;
+};
+
+#ifdef CONFIG_ANDROID_BINDER_IPC_SELFTEST
+void binder_selftest_alloc(struct binder_alloc *alloc);
+#else
+static inline void binder_selftest_alloc(struct binder_alloc *alloc) {}
+#endif
+enum lru_status binder_alloc_free_page(struct list_head *item,
+				       struct list_lru_one *lru,
+				       spinlock_t *lock, void *cb_arg);
+extern struct binder_buffer *binder_alloc_new_buf(struct binder_alloc *alloc,
+						  size_t data_size,
+						  size_t offsets_size,
+						  size_t extra_buffers_size,
+						  int is_async);
+extern void binder_alloc_init(struct binder_alloc *alloc);
+extern int binder_alloc_shrinker_init(void);
+extern void binder_alloc_vma_close(struct binder_alloc *alloc);
+extern struct binder_buffer *
+binder_alloc_prepare_to_free(struct binder_alloc *alloc,
+			     uintptr_t user_ptr);
+extern void binder_alloc_free_buf(struct binder_alloc *alloc,
+				  struct binder_buffer *buffer);
+extern int binder_alloc_mmap_handler(struct binder_alloc *alloc,
+				     struct vm_area_struct *vma);
+extern void binder_alloc_deferred_release(struct binder_alloc *alloc);
+extern int binder_alloc_get_allocated_count(struct binder_alloc *alloc);
+extern void binder_alloc_print_allocated(struct seq_file *m,
+					 struct binder_alloc *alloc);
+void binder_alloc_print_pages(struct seq_file *m,
+			      struct binder_alloc *alloc);
+
+/**
+ * binder_alloc_get_free_async_space() - get free space available for async
+ * @alloc:	binder_alloc for this proc
+ *
+ * Return:	the bytes remaining in the address-space for async transactions
+ */
+static inline size_t
+binder_alloc_get_free_async_space(struct binder_alloc *alloc)
+{
+	size_t free_async_space;
+
+	mutex_lock(&alloc->mutex);
+	free_async_space = alloc->free_async_space;
+	mutex_unlock(&alloc->mutex);
+	return free_async_space;
+}
+
+/**
+ * binder_alloc_get_user_buffer_offset() - get offset between kernel/user addrs
+ * @alloc:	binder_alloc for this proc
+ *
+ * Return:	the offset between kernel and user-space addresses to use for
+ * virtual address conversion
+ */
+static inline ptrdiff_t
+binder_alloc_get_user_buffer_offset(struct binder_alloc *alloc)
+{
+	/*
+	 * user_buffer_offset is constant if vma is set and
+	 * undefined if vma is not set. It is possible to
+	 * get here with !alloc->vma if the target process
+	 * is dying while a transaction is being initiated.
+	 * Returning the old value is ok in this case and
+	 * the transaction will fail.
+	 */
+	return alloc->user_buffer_offset;
+}
+
+#endif /* _LINUX_BINDER_ALLOC_H */
+
diff --git a/drivers/android/binder_alloc_selftest.c b/drivers/android/binder_alloc_selftest.c
new file mode 100644
index 00000000..8bd7bce
--- /dev/null
+++ b/drivers/android/binder_alloc_selftest.c
@@ -0,0 +1,310 @@
+/* binder_alloc_selftest.c
+ *
+ * Android IPC Subsystem
+ *
+ * Copyright (C) 2017 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#define pr_fmt(fmt) KBUILD_MODNAME ": " fmt
+
+#include <linux/mm_types.h>
+#include <linux/err.h>
+#include "binder_alloc.h"
+
+#define BUFFER_NUM 5
+#define BUFFER_MIN_SIZE (PAGE_SIZE / 8)
+
+static bool binder_selftest_run = true;
+static int binder_selftest_failures;
+static DEFINE_MUTEX(binder_selftest_lock);
+
+/**
+ * enum buf_end_align_type - Page alignment of a buffer
+ * end with regard to the end of the previous buffer.
+ *
+ * In the pictures below, buf2 refers to the buffer we
+ * are aligning. buf1 refers to previous buffer by addr.
+ * Symbol [ means the start of a buffer, ] means the end
+ * of a buffer, and | means page boundaries.
+ */
+enum buf_end_align_type {
+	/**
+	 * @SAME_PAGE_UNALIGNED: The end of this buffer is on
+	 * the same page as the end of the previous buffer and
+	 * is not page aligned. Examples:
+	 * buf1 ][ buf2 ][ ...
+	 * buf1 ]|[ buf2 ][ ...
+	 */
+	SAME_PAGE_UNALIGNED = 0,
+	/**
+	 * @SAME_PAGE_ALIGNED: When the end of the previous buffer
+	 * is not page aligned, the end of this buffer is on the
+	 * same page as the end of the previous buffer and is page
+	 * aligned. When the previous buffer is page aligned, the
+	 * end of this buffer is aligned to the next page boundary.
+	 * Examples:
+	 * buf1 ][ buf2 ]| ...
+	 * buf1 ]|[ buf2 ]| ...
+	 */
+	SAME_PAGE_ALIGNED,
+	/**
+	 * @NEXT_PAGE_UNALIGNED: The end of this buffer is on
+	 * the page next to the end of the previous buffer and
+	 * is not page aligned. Examples:
+	 * buf1 ][ buf2 | buf2 ][ ...
+	 * buf1 ]|[ buf2 | buf2 ][ ...
+	 */
+	NEXT_PAGE_UNALIGNED,
+	/**
+	 * @NEXT_PAGE_ALIGNED: The end of this buffer is on
+	 * the page next to the end of the previous buffer and
+	 * is page aligned. Examples:
+	 * buf1 ][ buf2 | buf2 ]| ...
+	 * buf1 ]|[ buf2 | buf2 ]| ...
+	 */
+	NEXT_PAGE_ALIGNED,
+	/**
+	 * @NEXT_NEXT_UNALIGNED: The end of this buffer is on
+	 * the page that follows the page after the end of the
+	 * previous buffer and is not page aligned. Examples:
+	 * buf1 ][ buf2 | buf2 | buf2 ][ ...
+	 * buf1 ]|[ buf2 | buf2 | buf2 ][ ...
+	 */
+	NEXT_NEXT_UNALIGNED,
+	LOOP_END,
+};
+
+static void pr_err_size_seq(size_t *sizes, int *seq)
+{
+	int i;
+
+	pr_err("alloc sizes: ");
+	for (i = 0; i < BUFFER_NUM; i++)
+		pr_cont("[%zu]", sizes[i]);
+	pr_cont("\n");
+	pr_err("free seq: ");
+	for (i = 0; i < BUFFER_NUM; i++)
+		pr_cont("[%d]", seq[i]);
+	pr_cont("\n");
+}
+
+static bool check_buffer_pages_allocated(struct binder_alloc *alloc,
+					 struct binder_buffer *buffer,
+					 size_t size)
+{
+	void *page_addr, *end;
+	int page_index;
+
+	end = (void *)PAGE_ALIGN((uintptr_t)buffer->data + size);
+	page_addr = buffer->data;
+	for (; page_addr < end; page_addr += PAGE_SIZE) {
+		page_index = (page_addr - alloc->buffer) / PAGE_SIZE;
+		if (!alloc->pages[page_index].page_ptr ||
+		    !list_empty(&alloc->pages[page_index].lru)) {
+			pr_err("expect alloc but is %s at page index %d\n",
+			       alloc->pages[page_index].page_ptr ?
+			       "lru" : "free", page_index);
+			return false;
+		}
+	}
+	return true;
+}
+
+static void binder_selftest_alloc_buf(struct binder_alloc *alloc,
+				      struct binder_buffer *buffers[],
+				      size_t *sizes, int *seq)
+{
+	int i;
+
+	for (i = 0; i < BUFFER_NUM; i++) {
+		buffers[i] = binder_alloc_new_buf(alloc, sizes[i], 0, 0, 0);
+		if (IS_ERR(buffers[i]) ||
+		    !check_buffer_pages_allocated(alloc, buffers[i],
+						  sizes[i])) {
+			pr_err_size_seq(sizes, seq);
+			binder_selftest_failures++;
+		}
+	}
+}
+
+static void binder_selftest_free_buf(struct binder_alloc *alloc,
+				     struct binder_buffer *buffers[],
+				     size_t *sizes, int *seq, size_t end)
+{
+	int i;
+
+	for (i = 0; i < BUFFER_NUM; i++)
+		binder_alloc_free_buf(alloc, buffers[seq[i]]);
+
+	for (i = 0; i < end / PAGE_SIZE; i++) {
+		/**
+		 * Error message on a free page can be false positive
+		 * if binder shrinker ran during binder_alloc_free_buf
+		 * calls above.
+		 */
+		if (list_empty(&alloc->pages[i].lru)) {
+			pr_err_size_seq(sizes, seq);
+			pr_err("expect lru but is %s at page index %d\n",
+			       alloc->pages[i].page_ptr ? "alloc" : "free", i);
+			binder_selftest_failures++;
+		}
+	}
+}
+
+static void binder_selftest_free_page(struct binder_alloc *alloc)
+{
+	int i;
+	unsigned long count;
+
+	while ((count = list_lru_count(&binder_alloc_lru))) {
+		list_lru_walk(&binder_alloc_lru, binder_alloc_free_page,
+			      NULL, count);
+	}
+
+	for (i = 0; i < (alloc->buffer_size / PAGE_SIZE); i++) {
+		if (alloc->pages[i].page_ptr) {
+			pr_err("expect free but is %s at page index %d\n",
+			       list_empty(&alloc->pages[i].lru) ?
+			       "alloc" : "lru", i);
+			binder_selftest_failures++;
+		}
+	}
+}
+
+static void binder_selftest_alloc_free(struct binder_alloc *alloc,
+				       size_t *sizes, int *seq, size_t end)
+{
+	struct binder_buffer *buffers[BUFFER_NUM];
+
+	binder_selftest_alloc_buf(alloc, buffers, sizes, seq);
+	binder_selftest_free_buf(alloc, buffers, sizes, seq, end);
+
+	/* Allocate from lru. */
+	binder_selftest_alloc_buf(alloc, buffers, sizes, seq);
+	if (list_lru_count(&binder_alloc_lru))
+		pr_err("lru list should be empty but is not\n");
+
+	binder_selftest_free_buf(alloc, buffers, sizes, seq, end);
+	binder_selftest_free_page(alloc);
+}
+
+static bool is_dup(int *seq, int index, int val)
+{
+	int i;
+
+	for (i = 0; i < index; i++) {
+		if (seq[i] == val)
+			return true;
+	}
+	return false;
+}
+
+/* Generate BUFFER_NUM factorial free orders. */
+static void binder_selftest_free_seq(struct binder_alloc *alloc,
+				     size_t *sizes, int *seq,
+				     int index, size_t end)
+{
+	int i;
+
+	if (index == BUFFER_NUM) {
+		binder_selftest_alloc_free(alloc, sizes, seq, end);
+		return;
+	}
+	for (i = 0; i < BUFFER_NUM; i++) {
+		if (is_dup(seq, index, i))
+			continue;
+		seq[index] = i;
+		binder_selftest_free_seq(alloc, sizes, seq, index + 1, end);
+	}
+}
+
+static void binder_selftest_alloc_size(struct binder_alloc *alloc,
+				       size_t *end_offset)
+{
+	int i;
+	int seq[BUFFER_NUM] = {0};
+	size_t front_sizes[BUFFER_NUM];
+	size_t back_sizes[BUFFER_NUM];
+	size_t last_offset, offset = 0;
+
+	for (i = 0; i < BUFFER_NUM; i++) {
+		last_offset = offset;
+		offset = end_offset[i];
+		front_sizes[i] = offset - last_offset;
+		back_sizes[BUFFER_NUM - i - 1] = front_sizes[i];
+	}
+	/*
+	 * Buffers share the first or last few pages.
+	 * Only BUFFER_NUM - 1 buffer sizes are adjustable since
+	 * we need one giant buffer before getting to the last page.
+	 */
+	back_sizes[0] += alloc->buffer_size - end_offset[BUFFER_NUM - 1];
+	binder_selftest_free_seq(alloc, front_sizes, seq, 0,
+				 end_offset[BUFFER_NUM - 1]);
+	binder_selftest_free_seq(alloc, back_sizes, seq, 0, alloc->buffer_size);
+}
+
+static void binder_selftest_alloc_offset(struct binder_alloc *alloc,
+					 size_t *end_offset, int index)
+{
+	int align;
+	size_t end, prev;
+
+	if (index == BUFFER_NUM) {
+		binder_selftest_alloc_size(alloc, end_offset);
+		return;
+	}
+	prev = index == 0 ? 0 : end_offset[index - 1];
+	end = prev;
+
+	BUILD_BUG_ON(BUFFER_MIN_SIZE * BUFFER_NUM >= PAGE_SIZE);
+
+	for (align = SAME_PAGE_UNALIGNED; align < LOOP_END; align++) {
+		if (align % 2)
+			end = ALIGN(end, PAGE_SIZE);
+		else
+			end += BUFFER_MIN_SIZE;
+		end_offset[index] = end;
+		binder_selftest_alloc_offset(alloc, end_offset, index + 1);
+	}
+}
+
+/**
+ * binder_selftest_alloc() - Test alloc and free of buffer pages.
+ * @alloc: Pointer to alloc struct.
+ *
+ * Allocate BUFFER_NUM buffers to cover all page alignment cases,
+ * then free them in all orders possible. Check that pages are
+ * correctly allocated, put onto lru when buffers are freed, and
+ * are freed when binder_alloc_free_page is called.
+ */
+void binder_selftest_alloc(struct binder_alloc *alloc)
+{
+	size_t end_offset[BUFFER_NUM];
+
+	if (!binder_selftest_run)
+		return;
+	mutex_lock(&binder_selftest_lock);
+	if (!binder_selftest_run || !alloc->vma)
+		goto done;
+	pr_info("STARTED\n");
+	binder_selftest_alloc_offset(alloc, end_offset, 0);
+	binder_selftest_run = false;
+	if (binder_selftest_failures > 0)
+		pr_info("%d tests FAILED\n", binder_selftest_failures);
+	else
+		pr_info("PASSED\n");
+
+done:
+	mutex_unlock(&binder_selftest_lock);
+}
diff --git a/drivers/android/binder_trace.h b/drivers/android/binder_trace.h
index 7f20f3d..b11dffc5 100644
--- a/drivers/android/binder_trace.h
+++ b/drivers/android/binder_trace.h
@@ -23,7 +23,8 @@
 struct binder_buffer;
 struct binder_node;
 struct binder_proc;
-struct binder_ref;
+struct binder_alloc;
+struct binder_ref_data;
 struct binder_thread;
 struct binder_transaction;
 
@@ -84,6 +85,30 @@
 DEFINE_BINDER_FUNCTION_RETURN_EVENT(binder_write_done);
 DEFINE_BINDER_FUNCTION_RETURN_EVENT(binder_read_done);
 
+TRACE_EVENT(binder_set_priority,
+	TP_PROTO(int proc, int thread, unsigned int old_prio,
+		 unsigned int desired_prio, unsigned int new_prio),
+	TP_ARGS(proc, thread, old_prio, new_prio, desired_prio),
+
+	TP_STRUCT__entry(
+		__field(int, proc)
+		__field(int, thread)
+		__field(unsigned int, old_prio)
+		__field(unsigned int, new_prio)
+		__field(unsigned int, desired_prio)
+	),
+	TP_fast_assign(
+		__entry->proc = proc;
+		__entry->thread = thread;
+		__entry->old_prio = old_prio;
+		__entry->new_prio = new_prio;
+		__entry->desired_prio = desired_prio;
+	),
+	TP_printk("proc=%d thread=%d old=%d => new=%d desired=%d",
+		  __entry->proc, __entry->thread, __entry->old_prio,
+		  __entry->new_prio, __entry->desired_prio)
+);
+
 TRACE_EVENT(binder_wait_for_work,
 	TP_PROTO(bool proc_work, bool transaction_stack, bool thread_todo),
 	TP_ARGS(proc_work, transaction_stack, thread_todo),
@@ -146,8 +171,8 @@
 
 TRACE_EVENT(binder_transaction_node_to_ref,
 	TP_PROTO(struct binder_transaction *t, struct binder_node *node,
-		 struct binder_ref *ref),
-	TP_ARGS(t, node, ref),
+		 struct binder_ref_data *rdata),
+	TP_ARGS(t, node, rdata),
 
 	TP_STRUCT__entry(
 		__field(int, debug_id)
@@ -160,8 +185,8 @@
 		__entry->debug_id = t->debug_id;
 		__entry->node_debug_id = node->debug_id;
 		__entry->node_ptr = node->ptr;
-		__entry->ref_debug_id = ref->debug_id;
-		__entry->ref_desc = ref->desc;
+		__entry->ref_debug_id = rdata->debug_id;
+		__entry->ref_desc = rdata->desc;
 	),
 	TP_printk("transaction=%d node=%d src_ptr=0x%016llx ==> dest_ref=%d dest_desc=%d",
 		  __entry->debug_id, __entry->node_debug_id,
@@ -170,8 +195,9 @@
 );
 
 TRACE_EVENT(binder_transaction_ref_to_node,
-	TP_PROTO(struct binder_transaction *t, struct binder_ref *ref),
-	TP_ARGS(t, ref),
+	TP_PROTO(struct binder_transaction *t, struct binder_node *node,
+		 struct binder_ref_data *rdata),
+	TP_ARGS(t, node, rdata),
 
 	TP_STRUCT__entry(
 		__field(int, debug_id)
@@ -182,10 +208,10 @@
 	),
 	TP_fast_assign(
 		__entry->debug_id = t->debug_id;
-		__entry->ref_debug_id = ref->debug_id;
-		__entry->ref_desc = ref->desc;
-		__entry->node_debug_id = ref->node->debug_id;
-		__entry->node_ptr = ref->node->ptr;
+		__entry->ref_debug_id = rdata->debug_id;
+		__entry->ref_desc = rdata->desc;
+		__entry->node_debug_id = node->debug_id;
+		__entry->node_ptr = node->ptr;
 	),
 	TP_printk("transaction=%d node=%d src_ref=%d src_desc=%d ==> dest_ptr=0x%016llx",
 		  __entry->debug_id, __entry->node_debug_id,
@@ -194,9 +220,10 @@
 );
 
 TRACE_EVENT(binder_transaction_ref_to_ref,
-	TP_PROTO(struct binder_transaction *t, struct binder_ref *src_ref,
-		 struct binder_ref *dest_ref),
-	TP_ARGS(t, src_ref, dest_ref),
+	TP_PROTO(struct binder_transaction *t, struct binder_node *node,
+		 struct binder_ref_data *src_ref,
+		 struct binder_ref_data *dest_ref),
+	TP_ARGS(t, node, src_ref, dest_ref),
 
 	TP_STRUCT__entry(
 		__field(int, debug_id)
@@ -208,7 +235,7 @@
 	),
 	TP_fast_assign(
 		__entry->debug_id = t->debug_id;
-		__entry->node_debug_id = src_ref->node->debug_id;
+		__entry->node_debug_id = node->debug_id;
 		__entry->src_ref_debug_id = src_ref->debug_id;
 		__entry->src_ref_desc = src_ref->desc;
 		__entry->dest_ref_debug_id = dest_ref->debug_id;
@@ -268,9 +295,9 @@
 	TP_ARGS(buffer));
 
 TRACE_EVENT(binder_update_page_range,
-	TP_PROTO(struct binder_proc *proc, bool allocate,
+	TP_PROTO(struct binder_alloc *alloc, bool allocate,
 		 void *start, void *end),
-	TP_ARGS(proc, allocate, start, end),
+	TP_ARGS(alloc, allocate, start, end),
 	TP_STRUCT__entry(
 		__field(int, proc)
 		__field(bool, allocate)
@@ -278,9 +305,9 @@
 		__field(size_t, size)
 	),
 	TP_fast_assign(
-		__entry->proc = proc->pid;
+		__entry->proc = alloc->pid;
 		__entry->allocate = allocate;
-		__entry->offset = start - proc->buffer;
+		__entry->offset = start - alloc->buffer;
 		__entry->size = end - start;
 	),
 	TP_printk("proc=%d allocate=%d offset=%zu size=%zu",
@@ -288,6 +315,61 @@
 		  __entry->offset, __entry->size)
 );
 
+DECLARE_EVENT_CLASS(binder_lru_page_class,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index),
+	TP_STRUCT__entry(
+		__field(int, proc)
+		__field(size_t, page_index)
+	),
+	TP_fast_assign(
+		__entry->proc = alloc->pid;
+		__entry->page_index = page_index;
+	),
+	TP_printk("proc=%d page_index=%zu",
+		  __entry->proc, __entry->page_index)
+);
+
+DEFINE_EVENT(binder_lru_page_class, binder_alloc_lru_start,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index));
+
+DEFINE_EVENT(binder_lru_page_class, binder_alloc_lru_end,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index));
+
+DEFINE_EVENT(binder_lru_page_class, binder_free_lru_start,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index));
+
+DEFINE_EVENT(binder_lru_page_class, binder_free_lru_end,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index));
+
+DEFINE_EVENT(binder_lru_page_class, binder_alloc_page_start,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index));
+
+DEFINE_EVENT(binder_lru_page_class, binder_alloc_page_end,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index));
+
+DEFINE_EVENT(binder_lru_page_class, binder_unmap_user_start,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index));
+
+DEFINE_EVENT(binder_lru_page_class, binder_unmap_user_end,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index));
+
+DEFINE_EVENT(binder_lru_page_class, binder_unmap_kernel_start,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index));
+
+DEFINE_EVENT(binder_lru_page_class, binder_unmap_kernel_end,
+	TP_PROTO(const struct binder_alloc *alloc, size_t page_index),
+	TP_ARGS(alloc, page_index));
+
 TRACE_EVENT(binder_command,
 	TP_PROTO(uint32_t cmd),
 	TP_ARGS(cmd),
diff --git a/drivers/ata/Kconfig b/drivers/ata/Kconfig
index 5d16fc4..0ca0009 100644
--- a/drivers/ata/Kconfig
+++ b/drivers/ata/Kconfig
@@ -193,6 +193,14 @@ config AHCI_QORIQ
 
 	  If unsure, say N.
 
+config AHCI_RTK
+    tristate "Realtek AHCI SATA support"
+    help
+      This option enables support for Realtek AHCI Serial ATA
+      controllers.
+
+      If unsure, say N.
+
 config SATA_FSL
 	tristate "Freescale 3.0Gbps SATA support"
 	depends on FSL_SOC
diff --git a/drivers/ata/Makefile b/drivers/ata/Makefile
index a46e6b7..86fac9b 100644
--- a/drivers/ata/Makefile
+++ b/drivers/ata/Makefile
@@ -22,6 +22,7 @@ obj-$(CONFIG_AHCI_ST)		+= ahci_st.o libahci.o libahci_platform.o
 obj-$(CONFIG_AHCI_TEGRA)	+= ahci_tegra.o libahci.o libahci_platform.o
 obj-$(CONFIG_AHCI_XGENE)	+= ahci_xgene.o libahci.o libahci_platform.o
 obj-$(CONFIG_AHCI_QORIQ)	+= ahci_qoriq.o libahci.o libahci_platform.o
+obj-$(CONFIG_AHCI_RTK)		+= ahci_rtk.o libahci.o libahci_platform.o
 
 # SFF w/ custom DMA
 obj-$(CONFIG_PDC_ADMA)		+= pdc_adma.o
diff --git a/drivers/ata/ahci.c b/drivers/ata/ahci.c
index faa91f8..d33a296 100644
--- a/drivers/ata/ahci.c
+++ b/drivers/ata/ahci.c
@@ -1633,7 +1633,16 @@ static int ahci_init_one(struct pci_dev *pdev, const struct pci_device_id *ent)
 	if (ahci_sb600_enable_64bit(pdev))
 		hpriv->flags &= ~AHCI_HFLAG_32BIT_ONLY;
 
+#ifdef CONFIG_ARCH_RTD129x
+	// Realtek platform
+	hpriv->flags |= AHCI_HFLAG_NO_MSI;
+	if (pdev->bus->number == 0)
+		hpriv->mmio = ioremap(0x9804f000, 1024);
+	else
+		hpriv->mmio = ioremap(0x9803C000, 1024);
+#else
 	hpriv->mmio = pcim_iomap_table(pdev)[ahci_pci_bar];
+#endif
 
 	/* must set flag prior to save config in order to take effect */
 	if (ahci_broken_devslp(pdev))
diff --git a/drivers/ata/ahci_rtk.c b/drivers/ata/ahci_rtk.c
new file mode 100644
index 00000000..134b617
--- /dev/null
+++ b/drivers/ata/ahci_rtk.c
@@ -0,0 +1,688 @@
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/kthread.h>
+#include <linux/platform_device.h>
+#include <linux/ahci_platform.h>
+#include <linux/libata.h>
+#include <linux/reset.h>
+#include <linux/io.h>
+#include <linux/delay.h>
+#include <linux/of_address.h>
+#include <linux/of_gpio.h>
+#include <linux/suspend.h>
+
+#include "ahci.h"
+#include "libata.h"
+#include <scsi/scsi_device.h>
+
+#include <soc/realtek/rtk_chip.h>
+
+#define DRV_NAME_RTK	"ahci_rtk"
+#define POWER_SAVEING	1
+#define MAC_MAX_CLK	5
+#define MAC_MAX_RST	5
+#define MAX_GPIO_CTL	10
+
+struct task_struct *rtk_sata_dev_task;
+int RTK_SATA_DEV_FLAG;
+struct ahci_host_priv *g_hpriv;
+
+enum {
+	SUSPEND = 0,
+	RESUME,
+	RESUME_OK,
+	RUNNING
+};
+
+/*
+int rtk_enter_loopback_mode(struct ata_port *ap)
+{
+	return 0;
+}*/
+
+static const struct ata_port_info ahci_port_info = {
+	.flags		= AHCI_FLAG_COMMON,
+	.pio_mask	= ATA_PIO4,
+	.udma_mask	= ATA_UDMA6,
+	.port_ops	= &ahci_platform_ops,
+};
+
+static struct scsi_host_template ahci_platform_sht = {
+	AHCI_SHT(DRV_NAME_RTK),
+};
+
+struct ahci_port_desc {
+	unsigned int index;
+	unsigned int power_io;
+	unsigned int power_save;
+	struct reset_control *rsts[MAC_MAX_RST];
+};
+
+struct ahci_rtk_dev {
+	struct ahci_port_desc **ports;
+	struct device *dev;
+	struct ahci_host_priv *hpriv;
+	struct delayed_work work;
+	struct work_struct gpio;
+	struct reset_control *rsts[MAC_MAX_RST];
+
+	enum rtd_chip_id chip_id;
+	enum rtd_chip_revision chip_revision;
+	unsigned int state;
+	unsigned int hostinit;
+};
+
+void rtk_sata_phy_poweron(struct ata_link *link)
+{
+	struct ahci_rtk_dev *ahci_dev;
+	struct ata_host *host;
+	void __iomem *mmio = g_hpriv->mmio;
+	unsigned val;
+	int port;
+
+	if (!g_hpriv) {
+		pr_err("sata host not ready\n");
+		return;
+	}
+	ahci_dev = g_hpriv->plat_data;
+	if (!ahci_dev) {
+		pr_err("sata host not ready\n");
+		return;
+	}
+	host = dev_get_drvdata(ahci_dev->dev);
+	if (host != link->ap->host) {
+		pr_err("host not match\n");
+		return;
+	}
+
+	port = link->ap->port_no;
+	if (port >= g_hpriv->nports || g_hpriv->phys[port] == NULL)
+		return;
+	if (g_hpriv->phys[port]->power_count == 0)
+		phy_power_on(g_hpriv->phys[port]);
+
+	if (ahci_dev->chip_id == CHIP_ID_RTD1619 ||
+		ahci_dev->chip_id == CHIP_ID_RTD1319) {
+		val = readl(mmio + 0xf18);
+		val = val | (0x7 << 3*port);
+		writel(val, mmio + 0xf18);
+	}
+}
+EXPORT_SYMBOL_GPL(rtk_sata_phy_poweron);
+
+static void rtk_sata_init(struct ahci_host_priv *hpriv)
+{
+	struct ahci_rtk_dev *ahci_dev = hpriv->plat_data;
+	void __iomem *mmio = hpriv->mmio;
+	unsigned int val;
+
+	if (ahci_dev->chip_id == CHIP_ID_RTD1619 ||
+		ahci_dev->chip_id == CHIP_ID_RTD1319) {
+		writel(readl(mmio + 0xf18) | (1<<6), mmio + 0xf18);
+		if (ahci_dev->chip_id == CHIP_ID_RTD1619)
+			writel(0xc0c300, mmio + 0xf20);
+		else if (ahci_dev->chip_id == CHIP_ID_RTD1319)
+			writel(0xc00300, mmio + 0xf20);
+		// COMINIT waveform adjustment
+		writel(0x0506373e, mmio + 0xf28);
+		writel(0x0506373e, mmio + 0xf2c);
+		// COMINIT detect enable
+		writel(0x42004200, mmio + 0xf04);
+		// COMWAKE detect enable
+		writel(0x02000200, mmio + 0xf08);
+	}
+	if (ahci_dev->chip_id == CHIP_ID_RTD1319)
+		writel(0x5, mmio + 0xff0);
+
+	val = readl(mmio + 0xC);
+	writel((val | 0x3), mmio + 0xC);
+}
+
+static int rtk_sata_dev_fun(void *data)
+{
+	struct ahci_rtk_dev *ahci_dev = (struct ahci_rtk_dev *)data;
+	struct ata_host *host;
+	struct ahci_host_priv *hpriv;
+	struct ata_port *ap;
+	struct scsi_device *sdev;
+	int i;
+
+	set_current_state(TASK_INTERRUPTIBLE);
+	while (!kthread_should_stop()) {
+		schedule();
+		host = dev_get_drvdata(ahci_dev->dev);
+		if (!host) {
+			set_current_state(TASK_INTERRUPTIBLE);
+			continue;
+		}
+
+		hpriv = host->private_data;
+		for (i = 0; i < hpriv->nports; i++) {
+			ap = host->ports[i];
+			sdev = ap->link.device[0].sdev;
+			if (!sdev)
+				continue;
+//			if (ap->scsi_host->shost_state == SHOST_RUNNING)
+//				scsi_remove_device(sdev);
+		}
+		set_current_state(TASK_INTERRUPTIBLE);
+	}
+
+	return 0;
+}
+/*
+static int rtk_sata_remove_scsi(struct ahci_rtk_dev *ahci_dev)
+{
+	struct ata_host *host;
+	struct ahci_host_priv *hpriv;
+	struct ata_port *ap;
+	struct scsi_device *sdev;
+	int i;
+
+	host = dev_get_drvdata(ahci_dev->dev);
+	if (!host)
+		return 0;
+
+	hpriv = host->private_data;
+	for (i = 0; i < hpriv->nports; i++) {
+		ap = host->ports[i];
+		sdev = ap->link.device[0].sdev;
+		if (!sdev)
+			continue;
+		if (ap->scsi_host->shost_state == SHOST_RUNNING)
+			scsi_remove_device(sdev);
+	}
+
+	return 0;
+}
+*/
+static void rtk_sata_host_resume(struct ahci_rtk_dev *ahci_dev)
+{
+	struct ata_host *host = dev_get_drvdata(ahci_dev->dev);
+	struct ahci_host_priv *hpriv = host->private_data;
+	struct ata_port *ap;
+	int i;
+	int resume_ok = 0;
+
+	for (i = 0; i < hpriv->nports; i++) {
+		ap = host->ports[i];
+		if (ap->link.sata_spd &&
+			ap->scsi_host->shost_state == SHOST_RUNNING)
+			resume_ok++;
+		else if (!ap->link.sata_spd)
+			resume_ok++;
+	}
+	if (resume_ok != hpriv->nports)
+		return;
+
+	if (ahci_dev->state == RESUME) {
+		ahci_dev->state = RESUME_OK;
+		schedule_delayed_work(&ahci_dev->work, 500);
+		return;
+	}
+	for (i = 0; i < hpriv->nports; i++) {
+		ap = host->ports[i];
+		if (ap->link.sata_spd) {
+			dev_info(ahci_dev->dev, "ata scsi user scan\n");
+			ata_scsi_user_scan(ap->scsi_host, 0, 0, 0);
+		}
+	}
+	ahci_dev->state = RUNNING;
+}
+
+static void rtk_sata_power_ctrl(struct ahci_rtk_dev *ahci_dev)
+{
+	struct ata_host *host = dev_get_drvdata(ahci_dev->dev);
+	struct ahci_host_priv *hpriv = host->private_data;
+	struct device *dev = ahci_dev->dev;
+	struct ata_port *ap;
+	void __iomem *mmio = hpriv->mmio;
+	unsigned int val;
+	int i;
+
+	if(!IS_ENABLED(POWER_SAVEING))
+		return;
+
+	for (i = 0; i < hpriv->nports; i++) {
+		ap = host->ports[i];
+		if (hpriv->phys[i] == NULL)
+			continue;
+
+		if (ahci_dev->ports[i]->power_save == 1 &&
+			(ahci_dev->chip_id & 0xFFF0) == CHIP_ID_RTD129X) {
+			phy_set_mode(hpriv->phys[i], 0);
+			ahci_dev->ports[i]->power_save = 0;
+			msleep(20);
+		}
+		if (ahci_dev->ports[i]->power_save == 1 &&
+			(ahci_dev->chip_id == CHIP_ID_RTD1619 ||
+				ahci_dev->chip_id == CHIP_ID_RTD1319)) {
+			val = readl(mmio + 0xf04);
+			if (!(val & (0x1000 << i*16)))
+				continue;
+
+			dev_info(dev, "sata%d plugin detect\n", i);
+			writel((readl(mmio + 0xf04) & ~(0xffff << i*16)) | (0x6600 << i*16), mmio + 0xf04);
+			writel((readl(mmio + 0xf08) & ~(0xffff << i*16)) | (0x0600 << i*16), mmio + 0xf08);
+
+			phy_set_mode(hpriv->phys[i], 0);
+			ahci_dev->ports[i]->power_save = 0;
+
+			writel(readl(mmio + 0xf0c) & ~(0x3 << (i*4)), mmio + 0xf0c);
+			writel((readl(mmio + 0xf04) & ~(0xffff << i*16)) | (0x4200 << i*16), mmio + 0xf04);
+			writel((readl(mmio + 0xf08) & ~(0xffff << i*16)) | (0x0200 << i*16), mmio + 0xf08);
+			writel(readl(mmio + 0xf18) | (0x7 << 3*i), mmio + 0xf18);
+
+			msleep(20);
+			continue;
+		}
+		if (!ap->hotplug_flag && !ap->link.sata_spd && ahci_dev->ports[i]->power_save == 0) {
+			if (ap->pflags & ATA_PFLAG_EH_IN_PROGRESS)
+				continue;
+
+			dev_dbg(dev, "sata%d enter power down mode\n", i);
+
+			if (ahci_dev->chip_id == CHIP_ID_RTD1619 ||
+				ahci_dev->chip_id == CHIP_ID_RTD1319)
+				writel(readl(mmio + 0xf18) & ~(0x7 << 3*i), mmio + 0xf18);
+
+			phy_set_mode(hpriv->phys[i], 1);
+			ahci_dev->ports[i]->power_save = 1;
+
+			if (ahci_dev->chip_id == CHIP_ID_RTD1619 ||
+				ahci_dev->chip_id == CHIP_ID_RTD1319) {
+				writel(readl(mmio + 0xf0c) | (0x3 << (i*4)), mmio + 0xf0c);
+				writel((readl(mmio + 0xf04) & ~(0xffff << i*16)) | (0x6600 << i*16), mmio + 0xf04);
+				writel((readl(mmio + 0xf04) & ~(0xffff << i*16)) | (0x4200 << i*16), mmio + 0xf04);
+				writel((readl(mmio + 0xf08) & ~(0xffff << i*16)) | (0x0600 << i*16), mmio + 0xf08);
+				writel((readl(mmio + 0xf08) & ~(0xffff << i*16)) | (0x0200 << i*16), mmio + 0xf08);
+			}
+		}
+	}
+}
+
+static void rtk_sata_host_ctrl(struct work_struct *work)
+{
+	struct ahci_rtk_dev *ahci_dev =
+			container_of(work, struct ahci_rtk_dev, work.work);
+	struct device *dev = ahci_dev->dev;
+	struct platform_device *pdev =
+			container_of(dev, struct platform_device, dev);
+	struct ata_host *host = dev_get_drvdata(ahci_dev->dev);
+
+	if (!host) {
+		ahci_platform_init_host(pdev,
+			ahci_dev->hpriv, &ahci_port_info, &ahci_platform_sht);
+		if (IS_ENABLED(POWER_SAVEING))
+			schedule_delayed_work(&ahci_dev->work, 2000);
+		return;
+	}
+
+	switch (ahci_dev->state) {
+	case RUNNING:
+		if (IS_ENABLED(POWER_SAVEING)) {
+			rtk_sata_power_ctrl(ahci_dev);
+			schedule_delayed_work(&ahci_dev->work, 200);
+		}
+		break;
+	case RESUME_OK:
+	case RESUME:
+		rtk_sata_host_resume(ahci_dev);
+		schedule_delayed_work(&ahci_dev->work, 20);
+		break;
+	case SUSPEND:
+	default:
+		dev_err(ahci_dev->dev, "state error, do nothing\n");
+		break;
+	}
+}
+
+static void rtk_sata_power_io_ctrl(struct work_struct *work)
+{
+	struct ahci_rtk_dev *ahci_dev =
+			container_of(work, struct ahci_rtk_dev, gpio);
+	struct device *dev = ahci_dev->dev;
+	struct device_node *node = dev->of_node;
+	int power_io;
+	static int cnt = 0;
+
+	power_io = of_get_gpio(node, cnt);
+	if (power_io >= 0) {
+		gpio_request(power_io, node->name);
+		gpio_set_value(power_io, 1);
+		gpio_free(power_io);
+		cnt++;
+		msleep(3000);
+		schedule_work(&ahci_dev->gpio);
+	}
+}
+
+static int ahci_rtk_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct ahci_rtk_dev *ahci_dev;
+	struct ahci_host_priv *hpriv;
+	struct device_node *child;
+	struct ahci_port_desc *desc;
+	struct reset_control *rst;
+	int power_io;
+	int id;
+	int i;
+
+	ahci_dev = devm_kzalloc(dev, sizeof(struct ahci_rtk_dev), GFP_KERNEL);
+	if (!ahci_dev)
+		goto memalloc_fail;
+
+	ahci_dev->chip_id = get_rtd_chip_id();
+	ahci_dev->chip_revision = get_rtd_chip_revision();
+	ahci_dev->dev = dev;
+
+	hpriv = ahci_platform_get_resources(pdev);
+	if (IS_ERR(hpriv))
+		return PTR_ERR(hpriv);
+	g_hpriv = hpriv;
+
+	ahci_dev->ports = devm_kcalloc(dev, hpriv->nports,
+				sizeof(*ahci_dev->ports), GFP_KERNEL);
+	if (!ahci_dev->ports)
+		goto memalloc_fail;
+
+	for (i=0; i<MAC_MAX_RST; i++) {
+		rst = of_reset_control_get_by_index(dev->of_node, i);
+		if (IS_ERR(rst))
+			break;
+		ahci_dev->rsts[i] = rst;
+		reset_control_deassert(rst);
+	}
+
+	of_property_read_u32(dev->of_node, "hostinit-mode", &ahci_dev->hostinit);
+
+	power_io = of_get_gpio(dev->of_node, 0);
+	if (power_io >= 0) {
+		INIT_WORK(&ahci_dev->gpio, rtk_sata_power_io_ctrl);
+		schedule_work(&ahci_dev->gpio);
+	}
+
+	for_each_available_child_of_node(dev->of_node, child) {
+		desc = devm_kzalloc(dev, sizeof(*desc), GFP_KERNEL);
+		if (!desc)
+			goto memalloc_fail;
+
+		if (of_property_read_u32(child, "reg", &id))
+			goto dtb_fail;
+
+		if (id >= hpriv->nports)
+			goto dtb_fail;
+
+		power_io = of_get_gpio(child, 0);
+		if (power_io >= 0) {
+			gpio_request(power_io, child->name);
+			gpio_set_value(power_io, 1);
+			gpio_free(power_io);
+			desc->power_io = power_io;
+		}
+		for (i=0; i<MAC_MAX_RST; i++) {
+			rst = of_reset_control_get_by_index(child, i);
+			if (IS_ERR(rst))
+				break;
+			desc->rsts[i] = rst;
+			reset_control_deassert(rst);
+		}
+		desc->index = id;
+		ahci_dev->ports[id] = desc;
+	}
+
+	ahci_platform_enable_clks(hpriv);
+	for (i = 0; i < hpriv->nports; i++) {
+		phy_init(hpriv->phys[i]);
+		ahci_dev->ports[i]->power_save = 0;
+	}
+
+	hpriv->plat_data = ahci_dev;
+	ahci_dev->hpriv = hpriv;
+
+	hpriv->flags |= AHCI_HFLAG_YES_FBS;
+
+	rtk_sata_init(hpriv);
+	ahci_dev->state = RUNNING;
+
+	INIT_DELAYED_WORK(&ahci_dev->work, rtk_sata_host_ctrl);
+	if (ahci_dev->hostinit) {
+		ahci_platform_init_host(pdev,
+			ahci_dev->hpriv, &ahci_port_info,
+			&ahci_platform_sht);
+		if (IS_ENABLED(POWER_SAVEING))
+			schedule_delayed_work(&ahci_dev->work, 2000);
+	} else
+		schedule_delayed_work(&ahci_dev->work, 800);
+
+	rtk_sata_dev_task = kthread_run(rtk_sata_dev_fun,
+				ahci_dev, "rtk sata dev handle");
+
+	return 0;
+
+dtb_fail:
+	dev_err(dev, "[SATA] get resource from dtb fail\n");
+	return -EINVAL;
+
+memalloc_fail:
+	dev_err(dev, "[SATA] memalloc fail\n");
+	return -ENOMEM;
+}
+
+static int ahci_rtk_prepare(struct device *dev)
+{
+	struct device_node *child;
+	int power_io;
+	int i;
+
+	dev_info(dev, "enter %s\n", __func__);
+//	rtk_sata_remove_scsi(ahci_dev);
+//	wake_up_process(rtk_sata_dev_task);
+//	msleep(1600);
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY)
+		goto exit;
+
+	for (i=0; i<MAX_GPIO_CTL; i++) {
+		power_io = of_get_gpio(dev->of_node, i);
+		if (power_io >= 0) {
+			gpio_request(power_io, NULL);
+			gpio_set_value(power_io, 0);
+			gpio_free(power_io);
+		} else {
+			break;
+		}
+	}
+
+	for_each_available_child_of_node(dev->of_node, child) {
+		power_io = of_get_gpio(child, 0);
+		if (power_io >= 0) {
+			gpio_request(power_io, NULL);
+			gpio_set_value(power_io, 0);
+			gpio_free(power_io);
+		}
+	}
+
+exit:
+	dev_info(dev, "exit %s\n", __func__);
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+static int ahci_rtk_suspend(struct device *dev)
+{
+	struct ata_host *host = dev_get_drvdata(dev);
+	struct ahci_host_priv *hpriv = host->private_data;
+	struct ahci_rtk_dev *ahci_dev = hpriv->plat_data;
+	void __iomem *mmio = hpriv->mmio;
+#ifdef DISABLE_CLKRST
+	struct reset_control *rst;
+	int i, j;
+#endif
+	int rc;
+
+	dev_info(dev, "enter %s\n", __func__);
+
+	cancel_delayed_work(&ahci_dev->work);
+	rc = ahci_platform_suspend_host(dev);
+	if (rc)
+		return rc;
+
+	if (ahci_dev->chip_id == CHIP_ID_RTD1619)
+		writel(0x40, mmio + 0xf18);
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		ahci_platform_disable_clks(hpriv);
+	} else {
+#ifdef DISABLE_CLKRST
+		ahci_platform_disable_resources(hpriv);
+		for (i = 0; i < hpriv->nports; i++) {
+			for (j = 0; j < MAC_MAX_RST; j++) {
+				rst = ahci_dev->ports[i]->rsts[j];
+				if (rst != NULL)
+					reset_control_assert(rst);
+				else
+					break;
+			}
+		}
+		for (j = 0; j < MAC_MAX_RST; j++) {
+			rst = ahci_dev->rsts[j];
+			if (rst != NULL)
+				reset_control_assert(rst);
+			else
+				break;
+		}
+#endif
+	}
+
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static void ahci_rtk_shutdown(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+
+	dev_info(dev, "enter %s\n", __func__);
+	ahci_rtk_suspend(dev);
+	dev_info(dev, "exit %s\n", __func__);
+}
+
+static int ahci_rtk_resume(struct device *dev)
+{
+	struct ata_host *host = dev_get_drvdata(dev);
+	struct ahci_host_priv *hpriv = host->private_data;
+	struct ahci_rtk_dev *ahci_dev = hpriv->plat_data;
+	struct device_node *child;
+	struct reset_control *rst;
+	int rc, i = 0, j;
+	int power_io;
+
+	dev_info(dev, "enter %s\n", __func__);
+
+	power_io = of_get_gpio(dev->of_node, 0);
+	if (power_io >= 0)
+		schedule_work(&ahci_dev->gpio);
+
+	for_each_available_child_of_node(dev->of_node, child) {
+		power_io = of_get_gpio(child, 0);
+		if (power_io >= 0) {
+			ahci_dev->ports[i++]->power_io = power_io;
+			gpio_request(power_io, NULL);
+			gpio_set_value(power_io, 1);
+			gpio_free(power_io);
+		}
+	}
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		ahci_platform_enable_clks(hpriv);
+		ahci_dev->state = RUNNING;
+	} else {
+		ahci_platform_disable_resources(hpriv);
+
+		for (j = 0; j < MAC_MAX_RST; j++) {
+			rst = ahci_dev->rsts[j];
+			if (rst != NULL) {
+				reset_control_assert(rst);
+				reset_control_deassert(rst);
+			} else
+				break;
+		}
+		for (i = 0; i < hpriv->nports; i++) {
+			for (j = 0; j < MAC_MAX_RST; j++) {
+				rst = ahci_dev->ports[i]->rsts[j];
+				if (rst != NULL) {
+					reset_control_assert(rst);
+					reset_control_deassert(rst);
+				} else
+					break;
+			}
+		}
+		ahci_platform_enable_clks(hpriv);
+		for (i = 0; i < hpriv->nports; i++) {
+			phy_init(hpriv->phys[i]);
+			ahci_dev->ports[i]->power_save = 0;
+		}
+
+		ahci_dev->state = RESUME;
+		rtk_sata_init(hpriv);
+	}
+	rc = ahci_platform_resume_host(dev);
+	if (rc)
+		goto disable_resources;
+
+	/* We resumed so update PM runtime state */
+	pm_runtime_disable(dev);
+	pm_runtime_set_active(dev);
+	pm_runtime_enable(dev);
+
+	schedule_delayed_work(&ahci_dev->work, 200);
+
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+
+disable_resources:
+	ahci_platform_disable_resources(hpriv);
+	return rc;
+}
+
+/*static SIMPLE_DEV_PM_OPS(ahci_rtk_pm_ops, ahci_rtk_suspend, ahci_rtk_resume);*/
+
+static const struct dev_pm_ops ahci_rtk_pm_ops = {
+	.prepare = ahci_rtk_prepare,
+	.suspend = ahci_rtk_suspend,
+	.resume = ahci_rtk_resume,
+};
+#else
+static const struct dev_pm_ops ahci_rtk_pm_ops = {};
+#endif
+
+static const struct of_device_id ahci_rtk_of_match[] = {
+	{ .compatible = "Realtek,ahci-sata", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, ahci_rtk_of_match);
+
+static struct platform_driver ahci_rtk_driver = {
+	.probe = ahci_rtk_probe,
+	.remove = ata_platform_remove_one,
+#ifdef CONFIG_PM
+	.shutdown = ahci_rtk_shutdown,
+#endif /* CONFIG_PM */
+	.driver = {
+		.name = DRV_NAME_RTK,
+		.of_match_table = ahci_rtk_of_match,
+#ifdef CONFIG_PM
+		.pm = &ahci_rtk_pm_ops,
+#endif
+	},
+};
+module_platform_driver(ahci_rtk_driver);
+
+MODULE_DESCRIPTION("RTK AHCI SATA platform driver");
+MODULE_AUTHOR("Simon Hsu <simon_hsu@realtek.com>");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:ahci");
diff --git a/drivers/ata/libahci.c b/drivers/ata/libahci.c
index 0d028ea..02a7183 100644
--- a/drivers/ata/libahci.c
+++ b/drivers/ata/libahci.c
@@ -1761,6 +1761,12 @@ static void ahci_error_intr(struct ata_port *ap, u32 irq_stat)
 	}
 
 	if (irq_stat & (PORT_IRQ_CONNECT | PORT_IRQ_PHYRDY)) {
+#ifdef CONFIG_AHCI_RTK
+		if(irq_stat & PORT_IRQ_CONNECT)
+			ap->hotplug_flag = 1;
+		else
+			ap->hotplug_flag = 0;
+#endif
 		ata_ehi_hotplugged(host_ehi);
 		ata_ehi_push_desc(host_ehi, "%s",
 			irq_stat & PORT_IRQ_CONNECT ?
diff --git a/drivers/ata/libata-core.c b/drivers/ata/libata-core.c
index 73d636d..f871716 100644
--- a/drivers/ata/libata-core.c
+++ b/drivers/ata/libata-core.c
@@ -79,6 +79,10 @@
 #include "libata.h"
 #include "libata-transport.h"
 
+#ifdef CONFIG_AHCI_RTK
+extern void rtk_sata_phy_poweron(struct ata_link *link);
+#endif
+
 /* debounce timing parameters in msecs { interval, duration, timeout } */
 const unsigned long sata_deb_timing_normal[]		= {   5,  100, 2000 };
 const unsigned long sata_deb_timing_hotplug[]		= {  25,  500, 2000 };
@@ -3784,7 +3788,9 @@ int sata_link_resume(struct ata_link *link, const unsigned long *params,
 		if ((rc = sata_scr_read(link, SCR_CONTROL, &scontrol)))
 			return rc;
 	} while ((scontrol & 0xf0f) != 0x300 && --tries);
-
+#if defined(CONFIG_AHCI_RTK)
+	rtk_sata_phy_poweron(link);
+#endif
 	if ((scontrol & 0xf0f) != 0x300) {
 		ata_link_warn(link, "failed to resume link (SControl %X)\n",
 			     scontrol);
@@ -5753,6 +5759,9 @@ void ata_dev_init(struct ata_device *dev)
 	link->sata_spd_limit = link->hw_sata_spd_limit;
 	link->sata_spd = 0;
 
+#if defined(CONFIG_AHCI_RTK)
+	sata_set_spd(link);
+#endif
 	/* High bits of dev->flags are used to record warm plug
 	 * requests which occur asynchronously.  Synchronize using
 	 * host lock.
diff --git a/drivers/base/cpu.c b/drivers/base/cpu.c
index cbb1cc6b..3bca4ee 100644
--- a/drivers/base/cpu.c
+++ b/drivers/base/cpu.c
@@ -21,6 +21,10 @@
 #include "base.h"
 
 static DEFINE_PER_CPU(struct device *, cpu_sys_devices);
+#ifdef CONFIG_RTK_PLATFORM
+extern void rtk_cpu_power_down(int cpu);
+extern void rtk_cpu_power_up(int cpu);
+#endif /* CONFIG_RTK_PLATFORM */
 
 static int cpu_subsys_match(struct device *dev, struct device_driver *drv)
 {
@@ -52,6 +56,10 @@ static int cpu_subsys_online(struct device *dev)
 	if (from_nid == NUMA_NO_NODE)
 		return -ENODEV;
 
+#if defined(CONFIG_RTK_PLATFORM) && !defined(CONFIG_RTK_PSCI_BOOT)
+	rtk_cpu_power_up(cpuid);
+#endif /* CONFIG_RTK_PLATFORM */
+
 	ret = cpu_up(cpuid);
 	/*
 	 * When hot adding memory to memoryless node and enabling a cpu
@@ -66,7 +74,14 @@ static int cpu_subsys_online(struct device *dev)
 
 static int cpu_subsys_offline(struct device *dev)
 {
+#if defined(CONFIG_RTK_PLATFORM) && !defined(CONFIG_RTK_PSCI_BOOT)
+	int ret = 0;
+	ret = cpu_down(dev->id);
+	rtk_cpu_power_down(dev->id);
+	return ret;
+#else
 	return cpu_down(dev->id);
+#endif /* CONFIG_RTK_PLATFORM */
 }
 
 void unregister_cpu(struct cpu *cpu)
diff --git a/drivers/base/dma-contiguous.c b/drivers/base/dma-contiguous.c
old mode 100644
new mode 100755
index e167a1e1..f379ee5
--- a/drivers/base/dma-contiguous.c
+++ b/drivers/base/dma-contiguous.c
@@ -36,6 +36,12 @@
 
 struct cma *dma_contiguous_default_area;
 
+#if defined(CONFIG_CMA_AREAS)
+#if defined(CONFIG_RTD119X) || defined(CONFIG_RTD129x) || defined(CONFIG_RTD139x) || defined(CONFIG_RTD16xx)
+of_cma_info_t of_cma_info;
+#endif // defined(CONFIG_RTD129x) || defined(CONFIG_RTD139x) || defined(CONFIG_RTD16xx)
+#endif // defined(CONFIG_CMA_AREAS)
+
 /*
  * Default global CMA area size can be defined in kernel's .config.
  * This is useful mainly for distro maintainers to create a kernel
@@ -110,9 +116,33 @@ void __init dma_contiguous_reserve(phys_addr_t limit)
 	phys_addr_t selected_base = 0;
 	phys_addr_t selected_limit = limit;
 	bool fixed = false;
+	int i = 0;
 
 	pr_debug("%s(limit %08lx)\n", __func__, (unsigned long)limit);
 
+#if defined(CONFIG_CMA_AREAS)
+#if defined(CONFIG_RTD119X) || defined(CONFIG_RTD129x) || defined(CONFIG_RTD139x)
+	if( of_cma_info.region_enable && of_cma_info.region_cnt ) {
+		for( i=0; i<of_cma_info.region_cnt; i++) {
+			selected_size  = of_cma_info.region[i].size;
+			selected_base  = of_cma_info.region[i].base;
+			selected_limit = selected_size+selected_base;
+			pr_info("fdt region %d\n", i);
+			pr_debug("%s: reserving %ld MiB for global area\n", __func__,
+				(unsigned long)selected_size / SZ_1M);
+
+			dma_contiguous_reserve_area(
+				selected_size,
+				selected_base,
+				selected_limit,
+				&dma_contiguous_default_area,
+				1/*alwasy fixed base*/);
+		}
+		return;
+	}
+#endif // defined(CONFIG_RTD129x) || defined(CONFIG_RTD139x)
+#endif // defined(CONFIG_CMA_AREAS)
+
 	if (size_cmdline != -1) {
 		selected_size = size_cmdline;
 		selected_base = base_cmdline;
diff --git a/drivers/base/power/main.c b/drivers/base/power/main.c
index dfffba3..dc259d2 100644
--- a/drivers/base/power/main.c
+++ b/drivers/base/power/main.c
@@ -33,6 +33,7 @@
 #include <linux/cpufreq.h>
 #include <linux/cpuidle.h>
 #include <linux/timer.h>
+#include <linux/wakeup_reason.h>
 
 #include "../base.h"
 #include "power.h"
@@ -1353,6 +1354,7 @@ static int __device_suspend(struct device *dev, pm_message_t state, bool async)
 	pm_callback_t callback = NULL;
 	char *info = NULL;
 	int error = 0;
+	char suspend_abort[MAX_SUSPEND_ABORT_LEN];
 	DECLARE_DPM_WATCHDOG_ON_STACK(wd);
 
 	TRACE_DEVICE(dev);
@@ -1373,6 +1375,9 @@ static int __device_suspend(struct device *dev, pm_message_t state, bool async)
 		pm_wakeup_event(dev, 0);
 
 	if (pm_wakeup_pending()) {
+		pm_get_active_wakeup_sources(suspend_abort,
+			MAX_SUSPEND_ABORT_LEN);
+		log_suspend_abort_reason(suspend_abort);
 		async_error = -EBUSY;
 		goto Complete;
 	}
diff --git a/drivers/base/power/opp/core.c b/drivers/base/power/opp/core.c
index 23ee46a..e494a93 100644
--- a/drivers/base/power/opp/core.c
+++ b/drivers/base/power/opp/core.c
@@ -708,7 +708,7 @@ static void _remove_opp_dev(struct opp_device *opp_dev,
 			    struct opp_table *opp_table)
 {
 	opp_debug_unregister(opp_dev, opp_table);
-	list_del(&opp_dev->node);
+	list_del_rcu(&opp_dev->node);
 	call_srcu(&opp_table->srcu_head.srcu, &opp_dev->rcu_head,
 		  _kfree_opp_dev_rcu);
 }
diff --git a/drivers/base/power/wakeup.c b/drivers/base/power/wakeup.c
index f98121f1..90c16d8 100644
--- a/drivers/base/power/wakeup.c
+++ b/drivers/base/power/wakeup.c
@@ -15,6 +15,7 @@
 #include <linux/seq_file.h>
 #include <linux/debugfs.h>
 #include <linux/pm_wakeirq.h>
+#include <linux/types.h>
 #include <trace/events/power.h>
 
 #include "power.h"
@@ -804,6 +805,37 @@ void pm_wakeup_event(struct device *dev, unsigned int msec)
 }
 EXPORT_SYMBOL_GPL(pm_wakeup_event);
 
+void pm_get_active_wakeup_sources(char *pending_wakeup_source, size_t max)
+{
+	struct wakeup_source *ws, *last_active_ws = NULL;
+	int len = 0;
+	bool active = false;
+
+	rcu_read_lock();
+	list_for_each_entry_rcu(ws, &wakeup_sources, entry) {
+		if (ws->active && len < max) {
+			if (!active)
+				len += scnprintf(pending_wakeup_source, max,
+						"Pending Wakeup Sources: ");
+			len += scnprintf(pending_wakeup_source + len, max - len,
+				"%s ", ws->name);
+			active = true;
+		} else if (!active &&
+			   (!last_active_ws ||
+			    ktime_to_ns(ws->last_time) >
+			    ktime_to_ns(last_active_ws->last_time))) {
+			last_active_ws = ws;
+		}
+	}
+	if (!active && last_active_ws) {
+		scnprintf(pending_wakeup_source, max,
+				"Last active Wakeup Source: %s",
+				last_active_ws->name);
+	}
+	rcu_read_unlock();
+}
+EXPORT_SYMBOL_GPL(pm_get_active_wakeup_sources);
+
 void pm_print_active_wakeup_sources(void)
 {
 	struct wakeup_source *ws;
@@ -1011,7 +1043,7 @@ static int print_wakeup_source_stats(struct seq_file *m,
 		active_time = ktime_set(0, 0);
 	}
 
-	seq_printf(m, "%-12s\t%lu\t\t%lu\t\t%lu\t\t%lu\t\t%lld\t\t%lld\t\t%lld\t\t%lld\t\t%lld\n",
+	seq_printf(m, "%-32s\t%lu\t\t%lu\t\t%lu\t\t%lu\t\t%lld\t\t%lld\t\t%lld\t\t%lld\t\t%lld\n",
 		   ws->name, active_count, ws->event_count,
 		   ws->wakeup_count, ws->expire_count,
 		   ktime_to_ms(active_time), ktime_to_ms(total_time),
@@ -1032,7 +1064,7 @@ static int wakeup_sources_stats_show(struct seq_file *m, void *unused)
 	struct wakeup_source *ws;
 	int srcuidx;
 
-	seq_puts(m, "name\t\tactive_count\tevent_count\twakeup_count\t"
+	seq_puts(m, "name\t\t\t\t\tactive_count\tevent_count\twakeup_count\t"
 		"expire_count\tactive_since\ttotal_time\tmax_time\t"
 		"last_change\tprevent_suspend_time\n");
 
diff --git a/drivers/base/syscore.c b/drivers/base/syscore.c
index 8d98a32..96c34a9 100644
--- a/drivers/base/syscore.c
+++ b/drivers/base/syscore.c
@@ -11,6 +11,7 @@
 #include <linux/module.h>
 #include <linux/suspend.h>
 #include <trace/events/power.h>
+#include <linux/wakeup_reason.h>
 
 static LIST_HEAD(syscore_ops_list);
 static DEFINE_MUTEX(syscore_ops_lock);
@@ -75,6 +76,8 @@ int syscore_suspend(void)
 	return 0;
 
  err_out:
+	log_suspend_abort_reason("System core suspend callback %pF failed",
+		ops->suspend);
 	pr_err("PM: System core suspend callback %pF failed.\n", ops->suspend);
 
 	list_for_each_entry_continue(ops, &syscore_ops_list, node)
diff --git a/drivers/block/xen-blkfront.c b/drivers/block/xen-blkfront.c
index f11d62d..e270308 100644
--- a/drivers/block/xen-blkfront.c
+++ b/drivers/block/xen-blkfront.c
@@ -221,7 +221,7 @@ struct blkfront_info
 
 #define GRANT_INVALID_REF	0
 
-#define PARTS_PER_DISK		16
+#define PARTS_PER_DISK		32
 #define PARTS_PER_EXT_DISK      256
 
 #define BLKIF_MAJOR(dev) ((dev)>>8)
diff --git a/drivers/bluetooth/Kconfig b/drivers/bluetooth/Kconfig
index 3cc9bff..14bdcac 100644
--- a/drivers/bluetooth/Kconfig
+++ b/drivers/bluetooth/Kconfig
@@ -30,6 +30,12 @@ config BT_HCIBTUSB
 	  Say Y here to compile support for Bluetooth USB devices into the
 	  kernel or say M to compile it as module (btusb).
 
+config BT_RTKBTRFKILL
+        tristate "Realtek Bluetooth RFKILL driver"
+        default n
+        help
+          Realtek Bluetooth rfkill driver
+
 config BT_HCIBTUSB_BCM
 	bool "Broadcom protocol support"
 	depends on BT_HCIBTUSB
diff --git a/drivers/bluetooth/Makefile b/drivers/bluetooth/Makefile
index b1fc29a..f4195b4 100644
--- a/drivers/bluetooth/Makefile
+++ b/drivers/bluetooth/Makefile
@@ -13,6 +13,7 @@ obj-$(CONFIG_BT_HCIBLUECARD)	+= bluecard_cs.o
 obj-$(CONFIG_BT_HCIBTUART)	+= btuart_cs.o
 
 obj-$(CONFIG_BT_HCIBTUSB)	+= btusb.o
+obj-$(CONFIG_BT_RTKBTRFKILL)    += rtk_rfkill.o
 obj-$(CONFIG_BT_HCIBTSDIO)	+= btsdio.o
 
 obj-$(CONFIG_BT_INTEL)		+= btintel.o
@@ -28,7 +29,7 @@ obj-$(CONFIG_BT_QCA)		+= btqca.o
 btmrvl-y			:= btmrvl_main.o
 btmrvl-$(CONFIG_DEBUG_FS)	+= btmrvl_debugfs.o
 
-hci_uart-y				:= hci_ldisc.o
+hci_uart-y				:= hci_ldisc.o hci_rtk_h5.o rtk_coex.o
 hci_uart-$(CONFIG_BT_HCIUART_H4)	+= hci_h4.o
 hci_uart-$(CONFIG_BT_HCIUART_BCSP)	+= hci_bcsp.o
 hci_uart-$(CONFIG_BT_HCIUART_LL)	+= hci_ll.o
diff --git a/drivers/bluetooth/hci_rtk_h5.c b/drivers/bluetooth/hci_rtk_h5.c
new file mode 100644
index 00000000..3e746f0
--- /dev/null
+++ b/drivers/bluetooth/hci_rtk_h5.c
@@ -0,0 +1,896 @@
+/*
+ *
+ *  Bluetooth HCI UART driver
+ *
+ *  Copyright (C) 2011-2014  wifi_fae<wifi_fae@realtek.com.tw>
+ *
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/types.h>
+#include <linux/fcntl.h>
+#include <linux/interrupt.h>
+#include <linux/ptrace.h>
+#include <linux/poll.h>
+#include <linux/slab.h>
+#include <linux/tty.h>
+#include <linux/errno.h>
+#include <linux/string.h>
+#include <linux/signal.h>
+#include <linux/ioctl.h>
+#include <linux/skbuff.h>
+#include <linux/bitrev.h>
+#include <asm/unaligned.h>
+#include <net/bluetooth/bluetooth.h>
+#include <net/bluetooth/hci_core.h>
+#include <linux/version.h>
+
+#include "hci_uart.h"
+
+#ifdef BTCOEX
+#include "rtk_coex.h"
+#endif
+
+//#define VERSION "1.0"
+
+static int txcrc = 1;
+//static int hciextn = 1;
+
+#define H5_TXWINSIZE	4
+#define H5_ACK_PKT	0x00
+#define H5_LE_PKT	    0x0F
+#define H5_VDRSPEC_PKT	0x0E
+
+struct h5_struct {
+	struct sk_buff_head unack;	/* Unack'ed packets queue */
+	struct sk_buff_head rel;	/* Reliable packets queue */
+	struct sk_buff_head unrel;	/* Unreliable packets queue */
+
+	unsigned long rx_count;
+	struct sk_buff *rx_skb;
+	u8 rxseq_txack;	/* rxseq == txack. */
+	u8 rxack;	/* Last packet sent by us that the peer ack'ed */
+	struct timer_list th5;
+
+	enum {
+		H5_W4_PKT_DELIMITER,
+		H5_W4_PKT_START,
+		H5_W4_HDR,
+		H5_W4_DATA,
+		H5_W4_CRC
+	} rx_state;
+
+	enum {
+		H5_ESCSTATE_NOESC,
+		H5_ESCSTATE_ESC
+	} rx_esc_state;
+
+	u8 use_crc;
+	u16 message_crc;
+	u8 txack_req;		/* Do we need to send ack's to the peer? */
+
+	/* Reliable packet sequence number -
+	 *used to assign seq to each rel pkt.
+	 */
+	u8 msgq_txseq;
+};
+
+/* ---- H5 CRC calculation ---- */
+
+/* Table for calculating CRC for polynomial 0x1021, LSB processed first,
+ *initial value 0xffff, bits shifted in reverse order.
+ */
+
+static const u16 crc_table[] = {
+	0x0000, 0x1081, 0x2102, 0x3183,
+	0x4204, 0x5285, 0x6306, 0x7387,
+	0x8408, 0x9489, 0xa50a, 0xb58b,
+	0xc60c, 0xd68d, 0xe70e, 0xf78f
+};
+
+/* Initialise the crc calculator */
+#define H5_CRC_INIT(x) (x = 0xffff)
+
+/*
+ *  Update crc with next data byte
+ *
+ *  Implementation note
+ *       The data byte is treated as two nibbles.  The crc is generated
+ *       in reverse, i.e., bits are fed into the register from the top.
+ */
+static void h5_crc_update(u16 *crc, u8 d)
+{
+	u16 reg = *crc;
+
+	reg = (reg >> 4) ^ crc_table[(reg ^ d) & 0x000f];
+	reg = (reg >> 4) ^ crc_table[(reg ^ (d >> 4)) & 0x000f];
+
+	*crc = reg;
+}
+
+/* ---- H5 core ---- */
+
+static void h5_slip_msgdelim(struct sk_buff *skb)
+{
+	const char pkt_delim = 0xc0;
+
+	memcpy(skb_put(skb, 1), &pkt_delim, 1);
+}
+
+static void h5_slip_one_byte(struct sk_buff *skb, u8 c)
+{
+	const char esc_c0[2] = { 0xdb, 0xdc };
+	const char esc_db[2] = { 0xdb, 0xdd };
+	const char esc_11[2] = { 0xdb, 0xde };
+	const char esc_13[2] = { 0xdb, 0xdf };
+
+	switch (c) {
+	case 0xc0:
+		memcpy(skb_put(skb, 2), &esc_c0, 2);
+		break;
+	case 0xdb:
+		memcpy(skb_put(skb, 2), &esc_db, 2);
+		break;
+	case 0x11:
+		memcpy(skb_put(skb, 2), &esc_11, 2);
+		break;
+	case 0x13:
+		memcpy(skb_put(skb, 2), &esc_13, 2);
+		break;
+	default:
+		memcpy(skb_put(skb, 1), &c, 1);
+	}
+}
+
+static int h5_enqueue(struct hci_uart *hu, struct sk_buff *skb)
+{
+	struct h5_struct *h5 = hu->priv;
+
+	if (skb->len > 0xFFF) {	//Pkt length must be less than 4095 bytes
+		BT_ERR("Packet too long");
+		kfree_skb(skb);
+		return 0;
+	}
+
+	switch (bt_cb(skb)->pkt_type) {
+	case HCI_ACLDATA_PKT:
+	case HCI_COMMAND_PKT:
+		skb_queue_tail(&h5->rel, skb);
+		break;
+
+	case HCI_SCODATA_PKT:
+		skb_queue_tail(&h5->unrel, skb);
+		break;
+	case H5_LE_PKT:
+	case H5_ACK_PKT:
+	case H5_VDRSPEC_PKT:
+		skb_queue_tail(&h5->unrel, skb);/* 3-wire LinkEstablishment */
+		break;
+
+	default:
+		BT_ERR("Unknown packet type");
+		kfree_skb(skb);
+		break;
+	}
+
+	return 0;
+}
+
+static struct sk_buff *h5_prepare_pkt(struct h5_struct *h5, u8 *data,
+				      int len, int pkt_type)
+{
+	struct sk_buff *nskb;
+	u8 hdr[4], chan;
+	u16 h5_txmsg_crc;
+	int rel, i;
+
+	H5_CRC_INIT(h5_txmsg_crc);
+	switch (pkt_type) {
+	case HCI_ACLDATA_PKT:
+		chan = 2;	/* 3-wire ACL channel */
+		rel = 1;	/* reliable channel */
+		break;
+	case HCI_COMMAND_PKT:
+		chan = 1;	/* 3-wire cmd channel */
+		rel = 1;	/* reliable channel */
+		break;
+	case HCI_EVENT_PKT:
+		chan = 4;	/* 3-wire cmd channel */
+		rel = 1;	/* reliable channel */
+		break;
+	case HCI_SCODATA_PKT:
+		chan = 3;	/* 3-wire SCO channel */
+		rel = 0;	/* unreliable channel */
+		break;
+	case H5_LE_PKT:
+		chan = 15;	/* 3-wire LinkEstablishment channel */
+		rel = 0;	/* unreliable channel */
+		break;
+	case H5_ACK_PKT:
+		chan = 0;	/* 3-wire ACK channel */
+		rel = 0;	/* unreliable channel */
+		break;
+	case H5_VDRSPEC_PKT:
+		chan = 14;	/* 3-wire Vendor Specific channel */
+		rel = 0;	/* unreliable channel */
+		break;
+	default:
+		BT_ERR("Unknown packet type");
+		return NULL;
+	}
+
+	/* Max len of packet: (original len +4(h5 hdr) +2(crc))*2
+	 * (because bytes 0xc0 and 0xdb are escaped, worst case is
+	 * when the packet is all made of 0xc0 and 0xdb :) )
+	 * + 2 (0xc0 delimiters at start and end).
+	 */
+
+	nskb = alloc_skb((len + 6) * 2 + 2, GFP_ATOMIC);
+	if (!nskb)
+		return NULL;
+
+	bt_cb(nskb)->pkt_type = pkt_type;
+
+	h5_slip_msgdelim(nskb);
+
+	hdr[0] = h5->rxseq_txack << 3;
+	h5->txack_req = 0;
+	BT_DBG("We request packet no %u to card", h5->rxseq_txack);
+
+	if (rel) {
+		hdr[0] |= 0x80 + h5->msgq_txseq;
+		BT_DBG("Sending packet with seqno %u", h5->msgq_txseq);
+		h5->msgq_txseq = (h5->msgq_txseq + 1) & 0x07;
+	}
+
+	if (h5->use_crc)
+		hdr[0] |= 0x40;
+
+	hdr[1] = ((len << 4) & 0xff) | chan;
+	hdr[2] = len >> 4;
+	hdr[3] = ~(hdr[0] + hdr[1] + hdr[2]);
+
+	/* Put H5 header */
+	for (i = 0; i < 4; i++) {
+		h5_slip_one_byte(nskb, hdr[i]);
+
+		if (h5->use_crc)
+			h5_crc_update(&h5_txmsg_crc, hdr[i]);
+	}
+
+	/* Put payload */
+	for (i = 0; i < len; i++) {
+		h5_slip_one_byte(nskb, data[i]);
+
+		if (h5->use_crc)
+			h5_crc_update(&h5_txmsg_crc, data[i]);
+	}
+
+	/* Put CRC */
+	if (h5->use_crc) {
+		h5_txmsg_crc = bitrev16(h5_txmsg_crc);
+		h5_slip_one_byte(nskb, (u8) ((h5_txmsg_crc >> 8) & 0x00ff));
+		h5_slip_one_byte(nskb, (u8) (h5_txmsg_crc & 0x00ff));
+	}
+
+	h5_slip_msgdelim(nskb);
+	return nskb;
+}
+
+/* This is a rewrite of pkt_avail in AH5 */
+static struct sk_buff *h5_dequeue(struct hci_uart *hu)
+{
+	struct h5_struct *h5 = hu->priv;
+	unsigned long flags;
+	struct sk_buff *skb;
+
+	/* First of all, check for unreliable messages in the queue,
+	 * since they have priority
+	 */
+	skb = skb_dequeue(&h5->unrel);
+	if (skb != NULL) {
+		struct sk_buff *nskb =
+		    h5_prepare_pkt(h5, skb->data, skb->len,
+				   bt_cb(skb)->pkt_type);
+		if (nskb) {
+			kfree_skb(skb);
+			return nskb;
+		} else {
+			skb_queue_head(&h5->unrel, skb);
+			BT_ERR
+			    ("Could not dequeue pkt because alloc_skb failed");
+		}
+	}
+
+	/* Now, try to send a reliable pkt. We can only send a
+	 * reliable packet if the number of packets sent but not yet ack'ed
+	 * is < than the winsize
+	 */
+
+	spin_lock_irqsave_nested(&h5->unack.lock, flags, SINGLE_DEPTH_NESTING);
+
+	if (h5->unack.qlen < H5_TXWINSIZE) {
+		skb = skb_dequeue(&h5->rel);
+		if (skb != NULL) {
+			struct sk_buff *nskb =
+				h5_prepare_pkt(h5, skb->data, skb->len,
+						bt_cb(skb)->pkt_type);
+			if (nskb) {
+				__skb_queue_tail(&h5->unack, skb);
+				mod_timer(&h5->th5, jiffies + HZ / 4);
+				spin_unlock_irqrestore(&h5->unack.lock, flags);
+				return nskb;
+			} else {
+				skb_queue_head(&h5->rel, skb);
+				BT_ERR("Could not dequeue pkt ");
+				BT_ERR("because alloc_skb failed");
+			}
+		}
+	}
+
+	spin_unlock_irqrestore(&h5->unack.lock, flags);
+
+	/* We could not send a reliable packet, either because there are
+	 * none or because there are too many unack'ed pkts. Did we receive
+	 * any packets we have not acknowledged yet ?
+	 */
+
+	if (h5->txack_req) {
+		/* if so, craft an empty ACK pkt and send it on H5 unreliable
+		 * channel 0
+		 */
+		struct sk_buff *nskb = h5_prepare_pkt(h5, NULL, 0, H5_ACK_PKT);
+		return nskb;
+	}
+
+	/* We have nothing to send */
+	return NULL;
+}
+
+static int h5_flush(struct hci_uart *hu)
+{
+	BT_DBG("hu %p", hu);
+	return 0;
+}
+
+/* Remove ack'ed packets */
+static void h5_pkt_cull(struct h5_struct *h5)
+{
+	struct sk_buff *skb, *tmp;
+	unsigned long flags;
+	int i, pkts_to_be_removed;
+	u8 seqno;
+
+	spin_lock_irqsave(&h5->unack.lock, flags);
+
+	pkts_to_be_removed = skb_queue_len(&h5->unack);
+	seqno = h5->msgq_txseq;
+
+	while (pkts_to_be_removed) {
+		if (h5->rxack == seqno)
+			break;
+		pkts_to_be_removed--;
+		seqno = (seqno - 1) & 0x07;
+	}
+
+	if (h5->rxack != seqno)
+		BT_ERR("Peer acked invalid packet");
+
+	BT_DBG("Removing %u pkts out of %u, up to seqno %u",
+	       pkts_to_be_removed, skb_queue_len(&h5->unack),
+	       (seqno - 1) & 0x07);
+
+	i = 0;
+	skb_queue_walk_safe(&h5->unack, skb, tmp) {
+		if (i >= pkts_to_be_removed)
+			break;
+		i++;
+
+		__skb_unlink(skb, &h5->unack);
+		kfree_skb(skb);
+	}
+
+	if (skb_queue_empty(&h5->unack))
+		del_timer(&h5->th5);
+
+	spin_unlock_irqrestore(&h5->unack.lock, flags);
+
+	if (i != pkts_to_be_removed)
+		BT_ERR("Removed only %u out of %u pkts", i, pkts_to_be_removed);
+}
+
+/* Handle H5 link-establishment packets. When we
+ * detect a "sync" packet, symptom that the BT module has reset,
+ * we do nothing :) (yet)
+ */
+#if 0
+static void h5_handle_le_pkt(struct hci_uart *hu)
+{
+	struct h5_struct *h5 = hu->priv;
+	u8 conf_pkt[2] = { 0x03, 0xfc };
+	u8 conf_rsp_pkt[3] = { 0x04, 0x7b, 0x00 };
+	u8 sync_pkt[2] = { 0x01, 0x7e };
+	u8 sync_rsp_pkt[2] = { 0x02, 0x7d };
+
+	u8 wakeup_pkt[2] = { 0x05, 0xfa };
+	u8 woken_pkt[2] = { 0x06, 0xf9 };
+	u8 sleep_pkt[2] = { 0x07, 0x78 };
+
+	/* spot "conf" pkts and reply with a "conf rsp" pkt */
+	if (h5->rx_skb->data[1] >> 4 == 2 && h5->rx_skb->data[2] == 0 &&
+	    !memcmp(&h5->rx_skb->data[4], conf_pkt, 2)) {
+		struct sk_buff *nskb = alloc_skb(3, GFP_ATOMIC);
+
+		BT_DBG("Found a LE conf pkt");
+		if (!nskb)
+			return;
+
+		/*crc check enable, version no = 0. needed to be as avariable.*/
+		conf_rsp_pkt[2] |= txcrc << 0x4;
+		memcpy(skb_put(nskb, 3), conf_rsp_pkt, 3);
+		bt_cb(nskb)->pkt_type = H5_LE_PKT;
+
+		skb_queue_head(&h5->unrel, nskb);
+		hci_uart_tx_wakeup(hu);
+	}
+	/* spot "conf resp" pkts */
+	else if (h5->rx_skb->data[1] >> 4 == 2 && h5->rx_skb->data[2] == 0 &&
+		 !memcmp(&h5->rx_skb->data[4], conf_rsp_pkt, 2)) {
+		BT_DBG("Found a LE conf resp pkt, device go into active state");
+		txcrc = (h5->rx_skb->data[6] >> 0x4) & 0x1;
+	}
+
+	/* Spot "sync" pkts. If we find one...disaster! */
+	else if (h5->rx_skb->data[1] >> 4 == 2 && h5->rx_skb->data[2] == 0 &&
+		 !memcmp(&h5->rx_skb->data[4], sync_pkt, 2)) {
+		BT_ERR("Found a LE sync pkt, card has reset");
+		//DO Something here
+	}
+	/* Spot "sync resp" pkts. If we find one...disaster! */
+	else if (h5->rx_skb->data[1] >> 4 == 2 && h5->rx_skb->data[2] == 0 &&
+		 !memcmp(&h5->rx_skb->data[4], sync_rsp_pkt, 2)) {
+		BT_ERR("Found a LE sync resp pkt, ");
+		BT_ERR("device go into initialized state");
+		//      DO Something here
+	}
+	/* Spot "wakeup" pkts. reply woken message when in active mode */
+	else if (h5->rx_skb->data[1] >> 4 == 2 && h5->rx_skb->data[2] == 0 &&
+		 !memcmp(&h5->rx_skb->data[4], wakeup_pkt, 2)) {
+		struct sk_buff *nskb = alloc_skb(2, GFP_ATOMIC);
+
+		BT_ERR("Found a LE Wakeup pkt, and reply woken message");
+		//      DO Something here
+
+		memcpy(skb_put(nskb, 2), woken_pkt, 2);
+		bt_cb(nskb)->pkt_type = H5_LE_PKT;
+
+		skb_queue_head(&h5->unrel, nskb);
+		hci_uart_tx_wakeup(hu);
+	}
+	/* Spot "woken" pkts. receive woken message from device */
+	else if (h5->rx_skb->data[1] >> 4 == 2 && h5->rx_skb->data[2] == 0 &&
+		 !memcmp(&h5->rx_skb->data[4], woken_pkt, 2)) {
+		BT_ERR("Found a LE woken pkt from device");
+		//      DO Something here
+	}
+	/* Spot "Sleep" pkts */
+	else if (h5->rx_skb->data[1] >> 4 == 2 && h5->rx_skb->data[2] == 0 &&
+		 !memcmp(&h5->rx_indent : Standard input:620 : Error : Unmatched 'else'
+skb->data[4], sleep_pkt, 2)) {
+		BT_ERR("Found a LE Sleep pkt");
+		//      DO Something here
+	}
+}
+#endif
+
+static inline void h5_unslip_one_byte(struct h5_struct *h5, unsigned char byte)
+{
+	const u8 c0 = 0xc0, db = 0xdb;
+	const u8 oof1 = 0x11, oof2 = 0x13;
+
+	switch (h5->rx_esc_state) {
+	case H5_ESCSTATE_NOESC:
+		switch (byte) {
+		case 0xdb:
+			h5->rx_esc_state = H5_ESCSTATE_ESC;
+			break;
+		default:
+			memcpy(skb_put(h5->rx_skb, 1), &byte, 1);
+			if ((h5->rx_skb->data[0] & 0x40) != 0 &&
+			    h5->rx_state != H5_W4_CRC)
+				h5_crc_update(&h5->message_crc, byte);
+			h5->rx_count--;
+		}
+		break;
+
+	case H5_ESCSTATE_ESC:
+		switch (byte) {
+		case 0xdc:
+			memcpy(skb_put(h5->rx_skb, 1), &c0, 1);
+			if ((h5->rx_skb->data[0] & 0x40) != 0 &&
+			    h5->rx_state != H5_W4_CRC)
+				h5_crc_update(&h5->message_crc, 0xc0);
+			h5->rx_esc_state = H5_ESCSTATE_NOESC;
+			h5->rx_count--;
+			break;
+
+		case 0xdd:
+			memcpy(skb_put(h5->rx_skb, 1), &db, 1);
+			if ((h5->rx_skb->data[0] & 0x40) != 0 &&
+			    h5->rx_state != H5_W4_CRC)
+				h5_crc_update(&h5->message_crc, 0xdb);
+			h5->rx_esc_state = H5_ESCSTATE_NOESC;
+			h5->rx_count--;
+			break;
+
+		case 0xde:
+			memcpy(skb_put(h5->rx_skb, 1), &oof1, 1);
+			if ((h5->rx_skb->data[0] & 0x40) != 0
+			    && h5->rx_state != H5_W4_CRC)
+				h5_crc_update(&h5->message_crc, oof1);
+			h5->rx_esc_state = H5_ESCSTATE_NOESC;
+			h5->rx_count--;
+			break;
+
+		case 0xdf:
+			memcpy(skb_put(h5->rx_skb, 1), &oof2, 1);
+			if ((h5->rx_skb->data[0] & 0x40) != 0
+			    && h5->rx_state != H5_W4_CRC)
+				h5_crc_update(&h5->message_crc, oof2);
+			h5->rx_esc_state = H5_ESCSTATE_NOESC;
+			h5->rx_count--;
+			break;
+
+		default:
+			BT_ERR("Invalid byte %02x after esc byte", byte);
+			kfree_skb(h5->rx_skb);
+			h5->rx_skb = NULL;
+			h5->rx_state = H5_W4_PKT_DELIMITER;
+			h5->rx_count = 0;
+		}
+	}
+}
+
+static void h5_complete_rx_pkt(struct hci_uart *hu)
+{
+	struct h5_struct *h5 = hu->priv;
+	int pass_up;
+
+	if (h5->rx_skb->data[0] & 0x80) {	/* reliable pkt */
+		BT_DBG("Received seqno %u from card", h5->rxseq_txack);
+		h5->rxseq_txack++;
+		h5->rxseq_txack %= 0x8;
+		h5->txack_req = 1;
+
+		/* If needed, transmit an ack pkt */
+		hci_uart_tx_wakeup(hu);
+	}
+
+	h5->rxack = (h5->rx_skb->data[0] >> 3) & 0x07;
+	BT_DBG("Request for pkt %u from card", h5->rxack);
+
+	h5_pkt_cull(h5);
+
+	if ((h5->rx_skb->data[1] & 0x0f) == 2 && h5->rx_skb->data[0] & 0x80) {
+		bt_cb(h5->rx_skb)->pkt_type = HCI_ACLDATA_PKT;
+		pass_up = 1;
+	} else if ((h5->rx_skb->data[1] & 0x0f) == 4 &&
+		   h5->rx_skb->data[0] & 0x80) {
+		bt_cb(h5->rx_skb)->pkt_type = HCI_EVENT_PKT;
+		pass_up = 1;
+	} else if ((h5->rx_skb->data[1] & 0x0f) == 3) {
+		bt_cb(h5->rx_skb)->pkt_type = HCI_SCODATA_PKT;
+		pass_up = 1;
+	} else if ((h5->rx_skb->data[1] & 0x0f) == 15 &&
+		   !(h5->rx_skb->data[0] & 0x80)) {
+		//h5_handle_le_pkt(hu);//Link Establishment Pkt
+		pass_up = 0;
+	} else if ((h5->rx_skb->data[1] & 0x0f) == 1 &&
+		   h5->rx_skb->data[0] & 0x80) {
+		bt_cb(h5->rx_skb)->pkt_type = HCI_COMMAND_PKT;
+		pass_up = 1;
+	} else if ((h5->rx_skb->data[1] & 0x0f) == 14) {
+		bt_cb(h5->rx_skb)->pkt_type = H5_VDRSPEC_PKT;
+		pass_up = 1;
+	} else
+		pass_up = 0;
+
+	if (!pass_up) {
+		/* struct hci_event_hdr hdr; */
+		u8 desc = (h5->rx_skb->data[1] & 0x0f);
+
+		if (desc != H5_ACK_PKT && desc != H5_LE_PKT) {
+			/* if (hciextn) {
+			 *	desc |= 0xc0;
+			 *	skb_pull(h5->rx_skb, 4);
+			 *	memcpy(skb_push(h5->rx_skb, 1), &desc, 1);
+
+			 *	hdr.evt = 0xff;
+			 *	hdr.plen = h5->rx_skb->len;
+			 *	memcpy(skb_push(h5->rx_skb, HCI_EVENT_HDR_SIZE),
+			 *	       &hdr, HCI_EVENT_HDR_SIZE);
+			 *	bt_cb(h5->rx_skb)->pkt_type = HCI_EVENT_PKT;
+
+			 *	hci_recv_frame(h5->rx_skb);
+			 * } else {
+			 */
+			BT_ERR("Packet for unknown channel (%u %s)",
+				       h5->rx_skb->data[1] & 0x0f,
+				       h5->rx_skb->data[0] & 0x80 ?
+				       "reliable" : "unreliable");
+			kfree_skb(h5->rx_skb);
+			/* } */
+		} else
+			kfree_skb(h5->rx_skb);
+	} else {
+			/* Pull out H5 hdr */
+		skb_pull(h5->rx_skb, 4);
+
+#ifdef BTCOEX
+		if (bt_cb(h5->rx_skb)->pkt_type == HCI_EVENT_PKT)
+			rtk_btcoex_parse_event(h5->rx_skb->data,
+					       h5->rx_skb->len);
+
+		if (bt_cb(h5->rx_skb)->pkt_type == HCI_ACLDATA_PKT)
+			rtk_btcoex_parse_l2cap_data_rx(h5->rx_skb->data,
+						       h5->rx_skb->len);
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3, 13, 0)
+		hci_recv_frame(h5->rx_skb);
+#else
+		hci_recv_frame(hu->hdev, h5->rx_skb);
+#endif
+	}
+
+	h5->rx_state = H5_W4_PKT_DELIMITER;
+	h5->rx_skb = NULL;
+}
+
+static u16 bscp_get_crc(struct h5_struct *h5)
+{
+	return get_unaligned_be16(&h5->rx_skb->
+			data[h5->rx_skb->len - 2]);
+}
+
+/* Recv data */
+static int h5_recv(struct hci_uart *hu, const void *data, int count)
+{
+	struct h5_struct *h5 = hu->priv;
+
+	register unsigned char *ptr;
+
+	BT_DBG("hu %p count %d rx_state %d rx_count %ld",
+	       hu, count, h5->rx_state, h5->rx_count);
+
+	ptr = data;
+	while (count) {
+		if (h5->rx_count) {
+			if (*ptr == 0xc0) {
+				BT_ERR("Short H5 packet");
+				kfree_skb(h5->rx_skb);
+				h5->rx_state = H5_W4_PKT_START;
+				h5->rx_count = 0;
+			} else
+				h5_unslip_one_byte(h5, *ptr);
+
+			ptr++;
+			count--;
+			continue;
+		}
+
+		switch (h5->rx_state) {
+		case H5_W4_HDR:
+			if ((0xff & (u8) ~
+			     (h5->rx_skb->data[0] +
+			      h5->rx_skb->data[1] +
+			      h5->rx_skb->data[2])) != h5->rx_skb->data[3]) {
+				BT_ERR("Error in H5 hdr checksum");
+				kfree_skb(h5->rx_skb);
+				h5->rx_state = H5_W4_PKT_DELIMITER;
+				h5->rx_count = 0;
+				continue;
+			}
+			if (h5->rx_skb->data[0] & 0x80	/* reliable pkt */
+			    && (h5->rx_skb->data[0] & 0x07) !=
+							h5->rxseq_txack) {
+				BT_ERR
+				    ("Out-of-order packet arrived, ");
+				BT_ERR("got %u expected %u",
+				     h5->rx_skb->data[0] & 0x07,
+				     h5->rxseq_txack);
+
+				h5->txack_req = 1;
+				hci_uart_tx_wakeup(hu);
+				kfree_skb(h5->rx_skb);
+				h5->rx_state = H5_W4_PKT_DELIMITER;
+				h5->rx_count = 0;
+				continue;
+			}
+			h5->rx_state = H5_W4_DATA;
+			h5->rx_count = (h5->rx_skb->data[1] >> 4) +
+				(h5->rx_skb->data[2] << 4); /* May be 0 */
+			continue;
+
+		case H5_W4_DATA:
+			if (h5->rx_skb->data[0] & 0x40) {/* pkt with crc */
+				h5->rx_state = H5_W4_CRC;
+				h5->rx_count = 2;
+			} else
+				h5_complete_rx_pkt(hu);
+			continue;
+
+		case H5_W4_CRC:
+			if (bitrev16(h5->message_crc) != bscp_get_crc(h5)) {
+				BT_ERR("Checksum failed: ");
+				BT_ERR("computed %04x received %04x",
+				     bitrev16(h5->message_crc),
+				     bscp_get_crc(h5));
+
+				kfree_skb(h5->rx_skb);
+				h5->rx_state = H5_W4_PKT_DELIMITER;
+				h5->rx_count = 0;
+				continue;
+			}
+			skb_trim(h5->rx_skb, h5->rx_skb->len - 2);
+			h5_complete_rx_pkt(hu);
+			continue;
+
+		case H5_W4_PKT_DELIMITER:
+			switch (*ptr) {
+			case 0xc0:
+				h5->rx_state = H5_W4_PKT_START;
+				break;
+			default:
+				/*BT_ERR("Ignoring byte %02x", *ptr); */
+				break;
+			}
+			ptr++;
+			count--;
+			break;
+
+		case H5_W4_PKT_START:
+			switch (*ptr) {
+			case 0xc0:
+				ptr++;
+				count--;
+				break;
+
+			default:
+				h5->rx_state = H5_W4_HDR;
+				h5->rx_count = 4;
+				h5->rx_esc_state = H5_ESCSTATE_NOESC;
+				H5_CRC_INIT(h5->message_crc);
+
+				/* Do not increment ptr or decrement count
+				 * Allocate packet. Max len of a H5 pkt=
+				 * 0xFFF (payload) +4 (header) +2 (crc)
+				 */
+
+				h5->rx_skb = bt_skb_alloc(0x1005, GFP_ATOMIC);
+				if (!h5->rx_skb) {
+					BT_ERR("Can't allocate mem for ");
+					BT_ERR("new packet");
+					h5->rx_state = H5_W4_PKT_DELIMITER;
+					h5->rx_count = 0;
+					return 0;
+				}
+				h5->rx_skb->dev = (void *)hu->hdev;
+				break;
+			}
+			break;
+		}
+	}
+	return count;
+}
+
+/* Arrange to retransmit all messages in the relq. */
+static void h5_timed_event(unsigned long arg)
+{
+	struct hci_uart *hu = (struct hci_uart *)arg;
+	struct h5_struct *h5 = hu->priv;
+	struct sk_buff *skb;
+	unsigned long flags;
+
+	BT_DBG("hu %p retransmitting %u pkts", hu, h5->unack.qlen);
+
+	spin_lock_irqsave_nested(&h5->unack.lock, flags, SINGLE_DEPTH_NESTING);
+
+	while ((skb = __skb_dequeue_tail(&h5->unack)) != NULL) {
+		h5->msgq_txseq = (h5->msgq_txseq - 1) & 0x07;
+		skb_queue_head(&h5->rel, skb);
+	}
+
+	spin_unlock_irqrestore(&h5->unack.lock, flags);
+
+	hci_uart_tx_wakeup(hu);
+}
+
+static int h5_open(struct hci_uart *hu)
+{
+	struct h5_struct *h5;
+
+	BT_DBG("hu %p", hu);
+
+	BT_INFO("h5_open");
+	h5 = kzalloc(sizeof(*h5), GFP_ATOMIC);
+	if (!h5)
+		return -ENOMEM;
+
+	hu->priv = h5;
+	skb_queue_head_init(&h5->unack);
+	skb_queue_head_init(&h5->rel);
+	skb_queue_head_init(&h5->unrel);
+
+	init_timer(&h5->th5);
+	h5->th5.function = h5_timed_event;
+	h5->th5.data = (u_long) hu;
+
+	h5->rx_state = H5_W4_PKT_DELIMITER;
+
+	if (txcrc)
+		h5->use_crc = 1;
+
+	return 0;
+}
+
+static int h5_close(struct hci_uart *hu)
+{
+	struct h5_struct *h5 = hu->priv;
+
+	hu->priv = NULL;
+
+	BT_DBG("hu %p", hu);
+	BT_INFO("h5_close");
+	skb_queue_purge(&h5->unack);
+	skb_queue_purge(&h5->rel);
+	skb_queue_purge(&h5->unrel);
+	del_timer(&h5->th5);
+
+	kfree(h5);
+	return 0;
+}
+
+static struct hci_uart_proto h5 = {
+	.id = HCI_UART_3WIRE,
+	.open = h5_open,
+	.close = h5_close,
+	.enqueue = h5_enqueue,
+	.dequeue = h5_dequeue,
+	.recv = h5_recv,
+	.flush = h5_flush
+};
+
+int h5_init(void)
+{
+	int err = hci_uart_register_proto(&h5);
+
+	if (!err)
+		BT_INFO("HCI Realtek H5 protocol initialized");
+	else
+		BT_ERR("HCI Realtek H5 protocol registration failed");
+
+	return err;
+}
+
+int h5_deinit(void)
+{
+	return hci_uart_unregister_proto(&h5);
+}
diff --git a/drivers/bluetooth/rtk_coex.c b/drivers/bluetooth/rtk_coex.c
new file mode 100644
index 00000000..10eef43
--- /dev/null
+++ b/drivers/bluetooth/rtk_coex.c
@@ -0,0 +1,2588 @@
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/slab.h>
+#include <linux/types.h>
+#include <linux/sched.h>
+#include <linux/errno.h>
+#include <linux/skbuff.h>
+#include <linux/dcache.h>
+#include <linux/version.h>
+#include <net/sock.h>
+#include <net/bluetooth/bluetooth.h>
+#include <net/bluetooth/hci_core.h>
+#include <net/bluetooth/l2cap.h>
+
+#include "rtk_coex.h"
+
+#if BTRTL_HCI_IF == BTRTL_HCIUSB
+#include <linux/usb.h>
+#include "rtk_bt.h"
+#undef RTKBT_DBG
+#undef RTKBT_INFO
+#undef RTKBT_WARN
+#undef RTKBT_ERR
+
+#elif BTRTL_HCI_IF == BTRTL_HCIUART
+/* #define HCI_VERSION_CODE KERNEL_VERSION(3, 14, 41) */
+#define HCI_VERSION_CODE LINUX_VERSION_CODE
+
+#else
+#error "Please set type of HCI interface"
+#endif
+
+#define RTK_VERSION "1.2"
+
+#define RTKBT_DBG(fmt, arg...) pr_info("rtk_btcoex: " fmt "\n", ## arg)
+#define RTKBT_INFO(fmt, arg...) pr_info("rtk_btcoex: " fmt "\n", ## arg)
+#define RTKBT_WARN(fmt, arg...) pr_warn("rtk_btcoex: " fmt "\n", ## arg)
+#define RTKBT_ERR(fmt, arg...) pr_warn("rtk_btcoex: " fmt "\n", ## arg)
+
+static struct rtl_coex_struct btrtl_coex;
+
+#define is_profile_connected(profile)\
+	((btrtl_coex.profile_bitmap & BIT(profile)) > 0)
+#define is_profile_busy(profile)\
+	((btrtl_coex.profile_status & BIT(profile)) > 0)
+
+static void rtk_handle_event_from_wifi(uint8_t *msg);
+static void count_a2dp_packet_timeout(unsigned long data);
+static void count_pan_packet_timeout(unsigned long data);
+static void count_hogp_packet_timeout(unsigned long data);
+
+static int rtl_alloc_buff(struct rtl_coex_struct *coex)
+{
+	struct rtl_hci_ev *ev;
+	struct rtl_l2_buff *l2;
+	int i;
+	int order;
+	unsigned long addr;
+	unsigned long addr2;
+	int ev_size;
+	int l2_size;
+	int n;
+
+	spin_lock_init(&coex->buff_lock);
+
+	INIT_LIST_HEAD(&coex->ev_used_list);
+	INIT_LIST_HEAD(&coex->ev_free_list);
+
+	INIT_LIST_HEAD(&coex->l2_used_list);
+	INIT_LIST_HEAD(&coex->l2_free_list);
+
+	n = NUM_RTL_HCI_EV * sizeof(struct rtl_hci_ev);
+	ev_size = ALIGN(n, sizeof(unsigned long));
+
+	n = L2_MAX_PKTS * sizeof(struct rtl_l2_buff);
+	l2_size = ALIGN(n, sizeof(unsigned long));
+
+	RTKBT_DBG("alloc buffers %d, %d for ev and l2", ev_size, l2_size);
+
+	order = get_order(ev_size + l2_size);
+	addr = __get_free_pages(GFP_KERNEL, order);
+	if (!addr) {
+		RTKBT_ERR("failed to alloc buffers for ev and l2.");
+		return -ENOMEM;
+	}
+	memset((void *)addr, 0, ev_size + l2_size);
+
+	coex->pages_addr = addr;
+	coex->buff_size = ev_size + l2_size;
+
+	ev = (struct rtl_hci_ev *)addr;
+	for (i = 0; i < NUM_RTL_HCI_EV; i++) {
+		list_add_tail(&ev->list, &coex->ev_free_list);
+		ev++;
+	}
+
+	addr2 = addr + ev_size;
+	l2 = (struct rtl_l2_buff *)addr2;
+	for (i = 0; i < L2_MAX_PKTS; i++) {
+		list_add_tail(&l2->list, &coex->l2_free_list);
+		l2++;
+	}
+
+	return 0;
+}
+
+static void rtl_free_buff(struct rtl_coex_struct *coex)
+{
+	struct rtl_hci_ev *ev;
+	struct rtl_l2_buff *l2;
+	unsigned long flags;
+
+	spin_lock_irqsave(&coex->buff_lock, flags);
+
+	while (!list_empty(&coex->ev_used_list)) {
+		ev = list_entry(coex->ev_used_list.next, struct rtl_hci_ev,
+				list);
+		list_del(&ev->list);
+	}
+
+	while (!list_empty(&coex->ev_free_list)) {
+		ev = list_entry(coex->ev_free_list.next, struct rtl_hci_ev,
+				list);
+		list_del(&ev->list);
+	}
+
+	while (!list_empty(&coex->l2_used_list)) {
+		l2 = list_entry(coex->l2_used_list.next, struct rtl_l2_buff,
+				list);
+		list_del(&l2->list);
+	}
+
+	while (!list_empty(&coex->l2_free_list)) {
+		l2 = list_entry(coex->l2_free_list.next, struct rtl_l2_buff,
+				list);
+		list_del(&l2->list);
+	}
+
+	spin_unlock_irqrestore(&coex->buff_lock, flags);
+
+	if (coex->buff_size > 0) {
+		free_pages(coex->pages_addr, get_order(coex->buff_size));
+		coex->pages_addr = 0;
+		coex->buff_size = 0;
+	}
+}
+
+static struct rtl_hci_ev *rtl_ev_node_get(struct rtl_coex_struct *coex)
+{
+	struct rtl_hci_ev *ev;
+	unsigned long flags;
+
+	if (!coex->buff_size)
+		return NULL;
+
+	spin_lock_irqsave(&coex->buff_lock, flags);
+	if (!list_empty(&coex->ev_free_list)) {
+		ev = list_entry(coex->ev_free_list.next, struct rtl_hci_ev,
+				list);
+		list_del(&ev->list);
+	} else
+		ev = NULL;
+	spin_unlock_irqrestore(&coex->buff_lock, flags);
+	return ev;
+}
+
+static int rtl_ev_node_to_used(struct rtl_coex_struct *coex,
+		struct rtl_hci_ev *ev)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&coex->buff_lock, flags);
+	list_add_tail(&ev->list, &coex->ev_used_list);
+	spin_unlock_irqrestore(&coex->buff_lock, flags);
+
+	return 0;
+}
+
+static struct rtl_l2_buff *rtl_l2_node_get(struct rtl_coex_struct *coex)
+{
+	struct rtl_l2_buff *l2;
+	unsigned long flags;
+
+	if (!coex->buff_size)
+		return NULL;
+
+	spin_lock_irqsave(&coex->buff_lock, flags);
+
+	if (!list_empty(&coex->l2_free_list)) {
+		l2 = list_entry(coex->l2_free_list.next, struct rtl_l2_buff,
+				list);
+		list_del(&l2->list);
+	} else
+		l2 = NULL;
+
+	spin_unlock_irqrestore(&coex->buff_lock, flags);
+	return l2;
+}
+
+static int rtl_l2_node_to_used(struct rtl_coex_struct *coex,
+		struct rtl_l2_buff *l2)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&coex->buff_lock, flags);
+	list_add_tail(&l2->list, &coex->l2_used_list);
+	spin_unlock_irqrestore(&coex->buff_lock, flags);
+
+	return 0;
+}
+
+static int8_t psm_to_profile_index(uint16_t psm)
+{
+	switch (psm) {
+	case PSM_AVCTP:
+	case PSM_SDP:
+		return -1;	//ignore
+
+	case PSM_HID:
+	case PSM_HID_INT:
+		return profile_hid;
+
+	case PSM_AVDTP:
+		return profile_a2dp;
+
+	case PSM_PAN:
+	case PSM_OPP:
+	case PSM_FTP:
+	case PSM_BIP:
+	case PSM_RFCOMM:
+		return profile_pan;
+
+	default:
+		return profile_pan;
+	}
+}
+
+static rtk_conn_prof *find_connection_by_handle(struct rtl_coex_struct *coex,
+						uint16_t handle)
+{
+	struct list_head *head = &coex->conn_hash;
+	struct list_head *iter = NULL, *temp = NULL;
+	rtk_conn_prof *desc = NULL;
+
+	list_for_each_safe(iter, temp, head) {
+		desc = list_entry(iter, rtk_conn_prof, list);
+		if ((handle & 0xEFF) == desc->handle)
+			return desc;
+	}
+	return NULL;
+}
+
+static rtk_conn_prof *allocate_connection_by_handle(uint16_t handle)
+{
+	rtk_conn_prof *phci_conn = NULL;
+
+	phci_conn = kmalloc(sizeof(rtk_conn_prof), GFP_ATOMIC);
+	if (phci_conn)
+		phci_conn->handle = handle;
+
+	return phci_conn;
+}
+
+static void init_connection_hash(struct rtl_coex_struct *coex)
+{
+	struct list_head *head = &coex->conn_hash;
+
+	INIT_LIST_HEAD(head);
+}
+
+static void add_connection_to_hash(struct rtl_coex_struct *coex,
+				   rtk_conn_prof *desc)
+{
+	struct list_head *head = &coex->conn_hash;
+
+	list_add_tail(&desc->list, head);
+}
+
+static void delete_connection_from_hash(rtk_conn_prof *desc)
+{
+	if (desc) {
+		list_del(&desc->list);
+		kfree(desc);
+	}
+}
+
+static void flush_connection_hash(struct rtl_coex_struct *coex)
+{
+	struct list_head *head = &coex->conn_hash;
+	struct list_head *iter = NULL, *temp = NULL;
+	rtk_conn_prof *desc = NULL;
+
+	list_for_each_safe(iter, temp, head) {
+		desc = list_entry(iter, rtk_conn_prof, list);
+		if (desc) {
+			list_del(&desc->list);
+			kfree(desc);
+		}
+	}
+	//INIT_LIST_HEAD(head);
+}
+
+static void init_profile_hash(struct rtl_coex_struct *coex)
+{
+	struct list_head *head = &coex->profile_list;
+
+	INIT_LIST_HEAD(head);
+}
+
+static uint8_t list_allocate_add(uint16_t handle, uint16_t psm,
+				 int8_t profile_index, uint16_t dcid,
+				 uint16_t scid)
+{
+	rtk_prof_info *pprof_info = NULL;
+
+	if (profile_index < 0) {
+		RTKBT_ERR("PSM(0x%x) do not need parse", psm);
+		return FALSE;
+	}
+
+	pprof_info = kmalloc(sizeof(rtk_prof_info), GFP_ATOMIC);
+
+	if (pprof_info == NULL) {
+		RTKBT_ERR("list_allocate_add: allocate error");
+		return FALSE;
+	}
+
+	pprof_info->handle = handle;
+	pprof_info->psm = psm;
+	pprof_info->scid = scid;
+	pprof_info->dcid = dcid;
+	pprof_info->profile_index = profile_index;
+	list_add_tail(&(pprof_info->list), &(btrtl_coex.profile_list));
+
+	return TRUE;
+}
+
+static void delete_profile_from_hash(rtk_prof_info *desc)
+{
+	RTKBT_DBG("Delete profile: hndl 0x%04x, psm 0x%04x, ",
+			desc->handle, desc->psm);
+	RTKBT_DBG("dcid 0x%04x, scid 0x%04x", desc->dcid, desc->scid);
+	if (desc) {
+		list_del(&desc->list);
+		kfree(desc);
+		desc = NULL;
+	}
+}
+
+static void flush_profile_hash(struct rtl_coex_struct *coex)
+{
+	struct list_head *head = &coex->profile_list;
+	struct list_head *iter = NULL, *temp = NULL;
+	rtk_prof_info *desc = NULL;
+
+	spin_lock(&btrtl_coex.spin_lock_profile);
+	list_for_each_safe(iter, temp, head) {
+		desc = list_entry(iter, rtk_prof_info, list);
+		delete_profile_from_hash(desc);
+	}
+	//INIT_LIST_HEAD(head);
+	spin_unlock(&btrtl_coex.spin_lock_profile);
+}
+
+static rtk_prof_info *find_profile_by_handle_scid(
+	struct rtl_coex_struct *coex, uint16_t handle,
+	uint16_t scid)
+{
+	struct list_head *head = &coex->profile_list;
+	struct list_head *iter = NULL, *temp = NULL;
+	rtk_prof_info *desc = NULL;
+
+	list_for_each_safe(iter, temp, head) {
+		desc = list_entry(iter, rtk_prof_info, list);
+		if (((handle & 0xFFF) == desc->handle) &&
+					(scid == desc->scid))
+			return desc;
+	}
+	return NULL;
+}
+
+static rtk_prof_info *find_profile_by_handle_dcid(struct rtl_coex_struct *
+						  coex, uint16_t handle,
+						  uint16_t dcid)
+{
+	struct list_head *head = &coex->profile_list;
+	struct list_head *iter = NULL, *temp = NULL;
+	rtk_prof_info *desc = NULL;
+
+	list_for_each_safe(iter, temp, head) {
+		desc = list_entry(iter, rtk_prof_info, list);
+		if (((handle & 0xFFF) == desc->handle) &&
+					(dcid == desc->dcid))
+			return desc;
+	}
+	return NULL;
+}
+
+static rtk_prof_info *find_profile_by_handle_dcid_scid(struct rtl_coex_struct
+						       *coex, uint16_t handle,
+						       uint16_t dcid,
+						       uint16_t scid)
+{
+	struct list_head *head = &coex->profile_list;
+	struct list_head *iter = NULL, *temp = NULL;
+	rtk_prof_info *desc = NULL;
+
+	list_for_each_safe(iter, temp, head) {
+		desc = list_entry(iter, rtk_prof_info, list);
+		if (((handle & 0xFFF) == desc->handle) && (dcid == desc->dcid)
+		    && (scid == desc->scid)) {
+			return desc;
+		}
+	}
+	return NULL;
+}
+
+static void rtk_vendor_cmd_to_fw(uint16_t opcode, uint8_t parameter_len,
+				 uint8_t *parameter)
+{
+	int len = HCI_CMD_PREAMBLE_SIZE + parameter_len;
+	uint8_t *p;
+	struct sk_buff *skb;
+	struct hci_dev *hdev = btrtl_coex.hdev;
+
+	skb = bt_skb_alloc(len, GFP_ATOMIC);
+	if (!skb) {
+		RTKBT_DBG("there is no room for cmd 0x%x", opcode);
+		return;
+	}
+
+	p = (uint8_t *) skb_put(skb, HCI_CMD_PREAMBLE_SIZE);
+	UINT16_TO_STREAM(p, opcode);
+	*p++ = parameter_len;
+
+	if (parameter_len)
+		memcpy(skb_put(skb, parameter_len), parameter, parameter_len);
+
+	bt_cb(skb)->pkt_type = HCI_COMMAND_PKT;
+
+#if HCI_VERSION_CODE >= KERNEL_VERSION(3, 18, 0)
+#if HCI_VERSION_CODE < KERNEL_VERSION(4, 4, 0)
+	bt_cb(skb)->opcode = opcode;
+#else
+	bt_cb(skb)->hci.opcode = opcode;
+#endif
+#endif
+
+	/* Stand-alone HCI commands must be flagged as
+	 * single-command requests.
+	 */
+#if HCI_VERSION_CODE >= KERNEL_VERSION(3, 10, 0)
+#if HCI_VERSION_CODE < KERNEL_VERSION(4, 4, 0)
+	bt_cb(skb)->req.start = true;
+#else
+#if HCI_VERSION_CODE < KERNEL_VERSION(4, 9, 0)
+	bt_cb(skb)->hci.req_start = true;
+#else
+	bt_cb(skb)->hci.req_flags |= HCI_REQ_START;
+#endif
+#endif
+#endif
+	RTKBT_DBG("%s: opcode 0x%x", __func__, opcode);
+
+	/* It is harmless if set skb->dev twice. The dev will be used in
+	 * btusb_send_frame() after or equal to kernel/hci 3.13.0,
+	 * the hdev will not come from skb->dev.
+	 */
+#if HCI_VERSION_CODE < KERNEL_VERSION(3, 13, 0)
+	skb->dev = (void *)btrtl_coex.hdev;
+#endif
+	/* Put the skb to the global hdev->cmd_q */
+	skb_queue_tail(&hdev->cmd_q, skb);
+
+#if HCI_VERSION_CODE < KERNEL_VERSION(3, 3, 0)
+	tasklet_schedule(&hdev->cmd_task);
+#else
+	queue_work(hdev->workqueue, &hdev->cmd_work);
+#endif
+}
+
+static void rtk_notify_profileinfo_to_fw(void)
+{
+	struct list_head *head = NULL;
+	struct list_head *iter = NULL;
+	struct list_head *temp = NULL;
+	rtk_conn_prof *hci_conn = NULL;
+	uint8_t handle_number = 0;
+	uint32_t buffer_size = 0;
+	uint8_t *p_buf = NULL;
+	uint8_t *p = NULL;
+
+	head = &btrtl_coex.conn_hash;
+	list_for_each_safe(iter, temp, head) {
+		hci_conn = list_entry(iter, rtk_conn_prof, list);
+		if (hci_conn && hci_conn->profile_bitmap)
+			handle_number++;
+	}
+
+	buffer_size = 1 + handle_number * 3 + 1;
+
+	p_buf = kmalloc(buffer_size, GFP_ATOMIC);
+
+	if (p_buf == NULL) {
+		RTKBT_ERR("%s: alloc error", __func__);
+		return;
+	}
+	p = p_buf;
+
+	RTKBT_DBG("%s: BufferSize %u", __func__, buffer_size);
+	*p++ = handle_number;
+	RTKBT_DBG("%s: NumberOfHandles %u", __func__, handle_number);
+	head = &btrtl_coex.conn_hash;
+	list_for_each(iter, head) {
+		hci_conn = list_entry(iter, rtk_conn_prof, list);
+		if (hci_conn && hci_conn->profile_bitmap) {
+			UINT16_TO_STREAM(p, hci_conn->handle);
+			RTKBT_DBG("%s: handle 0x%04x", __func__,
+					hci_conn->handle);
+			*p++ = hci_conn->profile_bitmap;
+			RTKBT_DBG("%s: profile_bitmap 0x%02x", __func__,
+					hci_conn->profile_bitmap);
+			handle_number--;
+		}
+		if (handle_number == 0)
+			break;
+	}
+
+	*p++ = btrtl_coex.profile_status;
+	RTKBT_DBG("%s: profile_status 0x%02x", __func__,
+			btrtl_coex.profile_status);
+
+	rtk_vendor_cmd_to_fw(HCI_VENDOR_SET_PROFILE_REPORT_COMMAND, buffer_size,
+			     p_buf);
+
+	kfree(p_buf);
+}
+
+static void rtk_check_setup_timer(int8_t profile_index)
+{
+	if (profile_index == profile_a2dp) {
+		btrtl_coex.a2dp_packet_count = 0;
+		setup_timer(&(btrtl_coex.a2dp_count_timer),
+			    count_a2dp_packet_timeout, 0);
+		btrtl_coex.a2dp_count_timer.expires =
+		    jiffies + msecs_to_jiffies(1000);
+		add_timer(&(btrtl_coex.a2dp_count_timer));
+	}
+
+	if (profile_index == profile_pan) {
+		btrtl_coex.pan_packet_count = 0;
+		setup_timer(&(btrtl_coex.pan_count_timer),
+			    count_pan_packet_timeout, 0);
+		btrtl_coex.pan_count_timer.expires =
+		    jiffies + msecs_to_jiffies(1000);
+		add_timer(&(btrtl_coex.pan_count_timer));
+	}
+
+	/* hogp & voice share one timer now */
+	if ((profile_index == profile_hogp) ||
+		(profile_index == profile_voice)) {
+		if ((btrtl_coex.profile_refcount[profile_hogp] == 0)
+		    && (btrtl_coex.profile_refcount[profile_voice] == 0)) {
+			btrtl_coex.hogp_packet_count = 0;
+			btrtl_coex.voice_packet_count = 0;
+			setup_timer(&(btrtl_coex.hogp_count_timer),
+				    count_hogp_packet_timeout, 0);
+			btrtl_coex.hogp_count_timer.expires =
+			    jiffies + msecs_to_jiffies(1000);
+			add_timer(&(btrtl_coex.hogp_count_timer));
+		}
+	}
+}
+
+static void rtk_check_del_timer(int8_t profile_index)
+{
+	if (profile_a2dp == profile_index) {
+		btrtl_coex.a2dp_packet_count = 0;
+		del_timer(&(btrtl_coex.a2dp_count_timer));
+	}
+	if (profile_pan == profile_index) {
+		btrtl_coex.pan_packet_count = 0;
+		del_timer(&(btrtl_coex.pan_count_timer));
+	}
+	if (profile_hogp == profile_index) {
+		btrtl_coex.hogp_packet_count = 0;
+		if (btrtl_coex.profile_refcount[profile_voice] == 0)
+			del_timer(&(btrtl_coex.hogp_count_timer));
+	}
+	if (profile_voice == profile_index) {
+		btrtl_coex.voice_packet_count = 0;
+		if (btrtl_coex.profile_refcount[profile_hogp] == 0)
+			del_timer(&(btrtl_coex.hogp_count_timer));
+	}
+}
+
+static void update_profile_state(uint8_t profile_index, uint8_t is_busy)
+{
+	uint8_t need_update = FALSE;
+
+	if ((btrtl_coex.profile_bitmap & BIT(profile_index)) == 0) {
+		RTKBT_ERR("%s: : ERROR!!! profile(Index: %x) does not exist",
+				__func__, profile_index);
+		return;
+	}
+
+	if (is_busy) {
+		if ((btrtl_coex.profile_status & BIT(profile_index)) == 0) {
+			need_update = TRUE;
+			btrtl_coex.profile_status |= BIT(profile_index);
+		}
+	} else {
+		if ((btrtl_coex.profile_status & BIT(profile_index)) > 0) {
+			need_update = TRUE;
+			btrtl_coex.profile_status &= ~(BIT(profile_index));
+		}
+	}
+
+	if (need_update) {
+		RTKBT_DBG("%s: btrtl_coex.profie_bitmap = %x",
+				__func__, btrtl_coex.profile_bitmap);
+		RTKBT_DBG("%s: btrtl_coex.profile_status = %x",
+				__func__, btrtl_coex.profile_status);
+		rtk_notify_profileinfo_to_fw();
+	}
+}
+
+static void update_profile_connection(rtk_conn_prof *phci_conn,
+				      int8_t profile_index, uint8_t is_add)
+{
+	uint8_t need_update = FALSE;
+	uint8_t kk;
+
+	RTKBT_DBG("%s: is_add %d, profile_index %x", __func__,
+			is_add, profile_index);
+	if (profile_index < 0)
+		return;
+
+	if (is_add) {
+		if (btrtl_coex.profile_refcount[profile_index] == 0) {
+			need_update = TRUE;
+			btrtl_coex.profile_bitmap |= BIT(profile_index);
+
+			/* SCO is always busy */
+			if (profile_index == profile_sco)
+				btrtl_coex.profile_status |=
+				    BIT(profile_index);
+
+			rtk_check_setup_timer(profile_index);
+		}
+		btrtl_coex.profile_refcount[profile_index]++;
+
+		if (phci_conn->profile_refcount[profile_index] == 0) {
+			need_update = TRUE;
+			phci_conn->profile_bitmap |= BIT(profile_index);
+		}
+		phci_conn->profile_refcount[profile_index]++;
+	} else {
+		btrtl_coex.profile_refcount[profile_index]--;
+		RTKBT_DBG("%s: btrtl_coex.profile_refcount[%x] = %x",
+				__func__, profile_index,
+				btrtl_coex.profile_refcount[profile_index]);
+		if (btrtl_coex.profile_refcount[profile_index] == 0) {
+			need_update = TRUE;
+			btrtl_coex.profile_bitmap &= ~(BIT(profile_index));
+
+			/* if profile does not exist, status is meaningless */
+			btrtl_coex.profile_status &= ~(BIT(profile_index));
+			rtk_check_del_timer(profile_index);
+		}
+
+		phci_conn->profile_refcount[profile_index]--;
+		if (phci_conn->profile_refcount[profile_index] == 0) {
+			need_update = TRUE;
+			phci_conn->profile_bitmap &= ~(BIT(profile_index));
+
+			/* clear profile_hid_interval if need */
+			if ((profile_hid == profile_index)
+			    && (phci_conn->
+				profile_bitmap & (BIT(profile_hid_interval)))) {
+				phci_conn->profile_bitmap &=
+				    ~(BIT(profile_hid_interval));
+				btrtl_coex.
+				    profile_refcount[profile_hid_interval]--;
+			}
+		}
+	}
+
+	RTKBT_DBG("%s: btrtl_coex.profile_bitmap 0x%02x", __func__,
+			btrtl_coex.profile_bitmap);
+	for (kk = 0; kk < 8; kk++)
+		RTKBT_DBG("%s: btrtl_coex.profile_refcount[%d] = %d",
+				__func__, kk,
+				btrtl_coex.profile_refcount[kk]);
+
+	if (need_update)
+		rtk_notify_profileinfo_to_fw();
+}
+
+static void update_hid_active_state(uint16_t handle, uint16_t interval)
+{
+	uint8_t need_update = 0;
+	rtk_conn_prof *phci_conn =
+	    find_connection_by_handle(&btrtl_coex, handle);
+
+	if (phci_conn == NULL)
+		return;
+
+	RTKBT_DBG("%s: handle 0x%04x, interval %u", __func__, handle, interval);
+	if (((phci_conn->profile_bitmap) & (BIT(profile_hid))) == 0) {
+		RTKBT_DBG("HID not connected, nothing to be down");
+		return;
+	}
+
+	if (interval < 60) {
+		if ((phci_conn->profile_bitmap & (BIT(profile_hid_interval))) ==
+		    0) {
+			need_update = 1;
+			phci_conn->profile_bitmap |= BIT(profile_hid_interval);
+
+			btrtl_coex.profile_refcount[profile_hid_interval]++;
+			if (btrtl_coex.
+			    profile_refcount[profile_hid_interval] == 1)
+				btrtl_coex.profile_status |=
+				    BIT(profile_hid);
+		}
+	} else {
+		if ((phci_conn->profile_bitmap & (BIT(profile_hid_interval)))) {
+			need_update = 1;
+			phci_conn->profile_bitmap &=
+			    ~(BIT(profile_hid_interval));
+
+			btrtl_coex.profile_refcount[profile_hid_interval]--;
+			if (btrtl_coex.
+			    profile_refcount[profile_hid_interval] == 0)
+				btrtl_coex.profile_status &=
+				    ~(BIT(profile_hid));
+		}
+	}
+
+	if (need_update)
+		rtk_notify_profileinfo_to_fw();
+}
+
+static uint8_t handle_l2cap_con_req(uint16_t handle, uint16_t psm,
+				    uint16_t scid, uint8_t direction)
+{
+	uint8_t status = FALSE;
+	rtk_prof_info *prof_info = NULL;
+	int8_t profile_index = psm_to_profile_index(psm);
+
+	if (profile_index < 0) {
+		RTKBT_DBG("PSM(0x%04x) do not need parse", psm);
+		return status;
+	}
+
+	spin_lock(&btrtl_coex.spin_lock_profile);
+	if (direction)		//1: out
+		prof_info =
+		    find_profile_by_handle_scid(&btrtl_coex, handle, scid);
+	else			// 0:in
+		prof_info =
+		    find_profile_by_handle_dcid(&btrtl_coex, handle, scid);
+
+	if (prof_info) {
+		RTKBT_DBG("%s: this profile is already exist!", __func__);
+		spin_unlock(&btrtl_coex.spin_lock_profile);
+		return status;
+	}
+
+	if (direction)		//1: out
+		status = list_allocate_add(handle, psm, profile_index, 0, scid);
+	else			// 0:in
+		status = list_allocate_add(handle, psm, profile_index, scid, 0);
+
+	spin_unlock(&btrtl_coex.spin_lock_profile);
+
+	if (!status)
+		RTKBT_ERR("%s: list_allocate_add failed!", __func__);
+
+	return status;
+}
+
+static uint8_t handle_l2cap_con_rsp(uint16_t handle, uint16_t dcid,
+				    uint16_t scid, uint8_t direction,
+				    uint8_t result)
+{
+	rtk_prof_info *prof_info = NULL;
+	rtk_conn_prof *phci_conn = NULL;
+
+	spin_lock(&btrtl_coex.spin_lock_profile);
+	if (!direction)		//0, in
+		prof_info =
+		    find_profile_by_handle_scid(&btrtl_coex, handle, scid);
+	else			//1, out
+		prof_info =
+		    find_profile_by_handle_dcid(&btrtl_coex, handle, scid);
+
+	if (!prof_info) {
+		//RTKBT_DBG("handle_l2cap_con_rsp: prof_info Not Find!!");
+		spin_unlock(&btrtl_coex.spin_lock_profile);
+		return FALSE;
+	}
+
+	if (!result) {		//success
+		RTKBT_DBG("l2cap connection success, update connection");
+		if (!direction)	//0, in
+			prof_info->dcid = dcid;
+		else		//1, out
+			prof_info->scid = dcid;
+
+		phci_conn = find_connection_by_handle(&btrtl_coex, handle);
+		if (phci_conn)
+			update_profile_connection(phci_conn,
+						  prof_info->profile_index,
+						  TRUE);
+	}
+
+	spin_unlock(&btrtl_coex.spin_lock_profile);
+	return TRUE;
+}
+
+static uint8_t handle_l2cap_discon_req(uint16_t handle, uint16_t dcid,
+				       uint16_t scid, uint8_t direction)
+{
+	rtk_prof_info *prof_info = NULL;
+	rtk_conn_prof *phci_conn = NULL;
+
+	RTKBT_DBG("%s: handle 0x%04x, dcid 0x%04x, scid 0x%04x, dir %u",
+			__func__, handle, dcid, scid, direction);
+
+	spin_lock(&btrtl_coex.spin_lock_profile);
+	if (!direction)		//0: in
+		prof_info =
+		    find_profile_by_handle_dcid_scid(&btrtl_coex, handle,
+						     scid, dcid);
+	else			//1: out
+		prof_info =
+		    find_profile_by_handle_dcid_scid(&btrtl_coex, handle,
+						     dcid, scid);
+
+	if (!prof_info) {
+		//LogMsg("handle_l2cap_discon_req: prof_info Not Find!");
+		spin_unlock(&btrtl_coex.spin_lock_profile);
+		return 0;
+	}
+
+	phci_conn = find_connection_by_handle(&btrtl_coex, handle);
+	if (!phci_conn) {
+		spin_unlock(&btrtl_coex.spin_lock_profile);
+		return 0;
+	}
+
+	update_profile_connection(phci_conn, prof_info->profile_index, FALSE);
+	delete_profile_from_hash(prof_info);
+	spin_unlock(&btrtl_coex.spin_lock_profile);
+
+	return 1;
+}
+
+static void packets_count(uint16_t handle, uint16_t scid, uint16_t length,
+			  uint8_t direction, u8 *user_data)
+{
+	rtk_prof_info *prof_info = NULL;
+
+	rtk_conn_prof *hci_conn =
+	    find_connection_by_handle(&btrtl_coex, handle);
+	if (hci_conn == NULL)
+		return;
+
+	if (hci_conn->type == 0) {
+		if (!direction)	//0: in
+			prof_info =
+			    find_profile_by_handle_scid(&btrtl_coex, handle,
+							scid);
+		else		//1: out
+			prof_info =
+			    find_profile_by_handle_dcid(&btrtl_coex, handle,
+							scid);
+
+		if (!prof_info) {
+			//RTKBT_DBG("packets_count: prof_info Not Find!");
+			return;
+		}
+		/*avdtp media data*/
+		if ((prof_info->profile_index == profile_a2dp) &&
+							(length > 100)) {
+			if (!is_profile_busy(profile_a2dp)) {
+				struct sbc_frame_hdr *sbc_header;
+				struct rtp_header *rtph;
+				u8 bitpool;
+
+				update_profile_state(profile_a2dp, TRUE);
+				rtph = (struct rtp_header *)user_data;
+
+				RTKBT_DBG("cc %u", rtph->cc);
+				/* move forward */
+				user_data += sizeof(struct rtp_header) +
+					rtph->cc * 4 + 1;
+
+				/* point to the sbc frame header */
+				sbc_header = (struct sbc_frame_hdr *)user_data;
+				bitpool = sbc_header->bitpool;
+
+				RTKBT_DBG("bitpool %u", bitpool);
+
+				rtk_vendor_cmd_to_fw(HCI_VENDOR_SET_BITPOOL,
+						1, &bitpool);
+			}
+			btrtl_coex.a2dp_packet_count++;
+		}
+
+		if (prof_info->profile_index == profile_pan)
+			btrtl_coex.pan_packet_count++;
+	}
+}
+
+static void count_a2dp_packet_timeout(unsigned long data)
+{
+	RTKBT_DBG("%s: a2dp_packet_count %d", __func__,
+			btrtl_coex.a2dp_packet_count);
+	if (btrtl_coex.a2dp_packet_count == 0) {
+		if (is_profile_busy(profile_a2dp)) {
+			RTKBT_DBG("%s: a2dp busy->idle!", __func__);
+			update_profile_state(profile_a2dp, FALSE);
+		}
+	}
+	btrtl_coex.a2dp_packet_count = 0;
+	mod_timer(&(btrtl_coex.a2dp_count_timer),
+		  jiffies + msecs_to_jiffies(1000));
+}
+
+static void count_pan_packet_timeout(unsigned long data)
+{
+	RTKBT_DBG("%s: pan_packet_count %d", __func__,
+			btrtl_coex.pan_packet_count);
+	if (btrtl_coex.pan_packet_count < PAN_PACKET_COUNT) {
+		if (is_profile_busy(profile_pan)) {
+			RTKBT_DBG("%s: pan busy->idle!", __func__);
+			update_profile_state(profile_pan, FALSE);
+		}
+	} else {
+		if (!is_profile_busy(profile_pan)) {
+			RTKBT_DBG("timeout_handler: pan idle->busy!");
+			update_profile_state(profile_pan, TRUE);
+		}
+	}
+	btrtl_coex.pan_packet_count = 0;
+	mod_timer(&(btrtl_coex.pan_count_timer),
+		  jiffies + msecs_to_jiffies(1000));
+}
+
+static void count_hogp_packet_timeout(unsigned long data)
+{
+	RTKBT_DBG("%s: hogp_packet_count %d", __func__,
+			btrtl_coex.hogp_packet_count);
+	if (btrtl_coex.hogp_packet_count == 0) {
+		if (is_profile_busy(profile_hogp)) {
+			RTKBT_DBG("%s: hogp busy->idle!", __func__);
+			update_profile_state(profile_hogp, FALSE);
+		}
+	}
+	btrtl_coex.hogp_packet_count = 0;
+
+	RTKBT_DBG("%s: voice_packet_count %d", __func__,
+			btrtl_coex.voice_packet_count);
+	if (btrtl_coex.voice_packet_count == 0) {
+		if (is_profile_busy(profile_voice)) {
+			RTKBT_DBG("%s: voice busy->idle!", __func__);
+			update_profile_state(profile_voice, FALSE);
+		}
+	}
+	btrtl_coex.voice_packet_count = 0;
+	mod_timer(&(btrtl_coex.hogp_count_timer),
+		  jiffies + msecs_to_jiffies(1000));
+}
+
+static int udpsocket_send(char *tx_msg, int msg_size)
+{
+	u8 error = 0;
+	struct msghdr udpmsg;
+	mm_segment_t oldfs;
+	struct iovec iov;
+
+	RTKBT_DBG("send msg %s with len:%d", tx_msg, msg_size);
+
+	if (btrtl_coex.sock_open) {
+		iov.iov_base = (void *)tx_msg;
+		iov.iov_len = msg_size;
+		udpmsg.msg_name = &btrtl_coex.wifi_addr;
+		udpmsg.msg_namelen = sizeof(struct sockaddr_in);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3, 19, 0)
+		udpmsg.msg_iov = &iov;
+		udpmsg.msg_iovlen = 1;
+#else
+		iov_iter_init(&udpmsg.msg_iter, WRITE, &iov, 1, msg_size);
+#endif
+		udpmsg.msg_control = NULL;
+		udpmsg.msg_controllen = 0;
+		udpmsg.msg_flags = MSG_DONTWAIT | MSG_NOSIGNAL;
+		oldfs = get_fs();
+		set_fs(KERNEL_DS);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 1, 0)
+		error = sock_sendmsg(btrtl_coex.udpsock, &udpmsg, msg_size);
+#else
+		error = sock_sendmsg(btrtl_coex.udpsock, &udpmsg);
+#endif
+		set_fs(oldfs);
+
+		if (error < 0)
+			RTKBT_DBG("Error when sendimg msg, error:%d", error);
+	}
+
+	return error;
+}
+
+static void udpsocket_recv_data(void)
+{
+	u8 recv_data[512];
+	u32 len = 0;
+	u16 recv_length;
+	struct sk_buff *skb;
+
+	RTKBT_DBG("-");
+
+	spin_lock(&btrtl_coex.spin_lock_sock);
+	len = skb_queue_len(&btrtl_coex.sk->sk_receive_queue);
+
+	while (len > 0) {
+		skb = skb_dequeue(&btrtl_coex.sk->sk_receive_queue);
+
+		/* important: cut the udp header from skb->data!
+		 * header length is 8 byte
+		 */
+		recv_length = skb->len - 8;
+		memset(recv_data, 0, sizeof(recv_data));
+		memcpy(recv_data, skb->data + 8, recv_length);
+		//RTKBT_DBG("received data: %s :with len %u",
+		//			recv_data, recv_length);
+
+		rtk_handle_event_from_wifi(recv_data);
+
+		len--;
+		kfree_skb(skb);
+	}
+
+	spin_unlock(&btrtl_coex.spin_lock_sock);
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3, 15, 0)
+static void udpsocket_recv(struct sock *sk, int bytes)
+#else
+static void udpsocket_recv(struct sock *sk)
+#endif
+{
+	spin_lock(&btrtl_coex.spin_lock_sock);
+	btrtl_coex.sk = sk;
+	spin_unlock(&btrtl_coex.spin_lock_sock);
+	queue_delayed_work(btrtl_coex.sock_wq, &btrtl_coex.sock_work, 0);
+}
+
+static void create_udpsocket(void)
+{
+	int err;
+
+	RTKBT_DBG("%s: connect_port: %d", __func__, CONNECT_PORT);
+
+	btrtl_coex.sock_open = 0;
+
+	err = sock_create(AF_INET, SOCK_DGRAM, IPPROTO_UDP,
+			&btrtl_coex.udpsock);
+	if (err < 0) {
+		RTKBT_ERR("%s: sock create error, err = %d", __func__, err);
+		return;
+	}
+
+	memset(&btrtl_coex.addr, 0, sizeof(struct sockaddr_in));
+	btrtl_coex.addr.sin_family = AF_INET;
+	btrtl_coex.addr.sin_addr.s_addr = htonl(INADDR_LOOPBACK);
+	btrtl_coex.addr.sin_port = htons(CONNECT_PORT);
+
+	memset(&btrtl_coex.wifi_addr, 0, sizeof(struct sockaddr_in));
+	btrtl_coex.wifi_addr.sin_family = AF_INET;
+	btrtl_coex.wifi_addr.sin_addr.s_addr = htonl(INADDR_LOOPBACK);
+	btrtl_coex.wifi_addr.sin_port = htons(CONNECT_PORT_WIFI);
+
+	err =
+	    btrtl_coex.udpsock->ops->bind(btrtl_coex.udpsock,
+					     (struct sockaddr *)&btrtl_coex.
+					     addr, sizeof(struct sockaddr));
+	if (err < 0) {
+		sock_release(btrtl_coex.udpsock);
+		RTKBT_ERR("%s: sock bind error, err = %d", __func__,  err);
+		return;
+	}
+
+	btrtl_coex.sock_open = 1;
+	btrtl_coex.udpsock->sk->sk_data_ready = udpsocket_recv;
+}
+
+static void rtk_notify_extension_version_to_wifi(void)
+{
+	uint8_t para_length = 2;
+	char p_buf[para_length + HCI_CMD_PREAMBLE_SIZE];
+	char *p = p_buf;
+
+	if (!btrtl_coex.wifi_on)
+		return;
+
+	UINT16_TO_STREAM(p, HCI_OP_HCI_EXTENSION_VERSION_NOTIFY);
+	*p++ = para_length;
+	UINT16_TO_STREAM(p, HCI_EXTENSION_VERSION);
+	RTKBT_DBG("extension version is 0x%x", HCI_EXTENSION_VERSION);
+	if (udpsocket_send(p_buf, para_length + HCI_CMD_PREAMBLE_SIZE) < 0)
+		RTKBT_ERR("%s: sock send error", __func__);
+}
+
+static void rtk_notify_btpatch_version_to_wifi(void)
+{
+	uint8_t para_length = 4;
+	char p_buf[para_length + HCI_CMD_PREAMBLE_SIZE];
+	char *p = p_buf;
+
+	if (!btrtl_coex.wifi_on)
+		return;
+
+	UINT16_TO_STREAM(p, HCI_OP_HCI_BT_PATCH_VER_NOTIFY);
+	*p++ = para_length;
+	UINT16_TO_STREAM(p, btrtl_coex.hci_reversion);
+	UINT16_TO_STREAM(p, btrtl_coex.lmp_subversion);
+	RTKBT_DBG("btpatch ver: len %u, hci_rev 0x%04x, lmp_subver 0x%04x",
+			para_length, btrtl_coex.hci_reversion,
+			btrtl_coex.lmp_subversion);
+
+	if (udpsocket_send(p_buf, para_length + HCI_CMD_PREAMBLE_SIZE) < 0)
+		RTKBT_ERR("%s: sock send error", __func__);
+}
+
+static void rtk_notify_afhmap_to_wifi(void)
+{
+	uint8_t para_length = 13;
+	char p_buf[para_length + HCI_CMD_PREAMBLE_SIZE];
+	char *p = p_buf;
+	uint8_t kk = 0;
+
+	if (!btrtl_coex.wifi_on)
+		return;
+
+	UINT16_TO_STREAM(p, HCI_OP_HCI_BT_AFH_MAP_NOTIFY);
+	*p++ = para_length;
+	*p++ = btrtl_coex.piconet_id;
+	*p++ = btrtl_coex.mode;
+	*p++ = 10;
+	memcpy(p, btrtl_coex.afh_map, 10);
+
+	RTKBT_DBG("afhmap, piconet_id is 0x%x, map type is 0x%x",
+		  btrtl_coex.piconet_id, btrtl_coex.mode);
+	for (kk = 0; kk < 10; kk++)
+		RTKBT_DBG("afhmap data[%d] is 0x%x", kk,
+			  btrtl_coex.afh_map[kk]);
+
+	if (udpsocket_send(p_buf, para_length + HCI_CMD_PREAMBLE_SIZE) < 0)
+		RTKBT_ERR("%s: sock send error", __func__);
+}
+
+static void rtk_notify_btcoex_to_wifi(uint8_t opcode, uint8_t status)
+{
+	uint8_t para_length = 2;
+	char p_buf[para_length + HCI_CMD_PREAMBLE_SIZE];
+	char *p = p_buf;
+
+	if (!btrtl_coex.wifi_on)
+		return;
+
+	UINT16_TO_STREAM(p, HCI_OP_HCI_BT_COEX_NOTIFY);
+	*p++ = para_length;
+	*p++ = opcode;
+	if (!status)
+		*p++ = 0;
+	else
+		*p++ = 1;
+
+	RTKBT_DBG("btcoex, opcode is 0x%x, status is 0x%x", opcode, status);
+
+	if (udpsocket_send(p_buf, para_length + HCI_CMD_PREAMBLE_SIZE) < 0)
+		RTKBT_ERR("%s: sock send error", __func__);
+}
+
+static void rtk_notify_btoperation_to_wifi(uint8_t operation,
+					   uint8_t append_data_length,
+					   uint8_t *append_data)
+{
+	uint8_t para_length = 3 + append_data_length;
+	char p_buf[para_length + HCI_CMD_PREAMBLE_SIZE];
+	char *p = p_buf;
+	uint8_t kk = 0;
+
+	if (!btrtl_coex.wifi_on)
+		return;
+
+	UINT16_TO_STREAM(p, HCI_OP_BT_OPERATION_NOTIFY);
+	*p++ = para_length;
+	*p++ = operation;
+	*p++ = append_data_length;
+	if (append_data_length)
+		memcpy(p, append_data, append_data_length);
+
+	RTKBT_DBG("btoperation: op 0x%02x, append_data_length %u",
+		  operation, append_data_length);
+	if (append_data_length) {
+		for (kk = 0; kk < append_data_length; kk++)
+			RTKBT_DBG("append data is 0x%x", *(append_data + kk));
+	}
+
+	if (udpsocket_send(p_buf, para_length + HCI_CMD_PREAMBLE_SIZE) < 0)
+		RTKBT_ERR("%s: sock send error", __func__);
+}
+
+static void rtk_notify_info_to_wifi(uint8_t reason, uint8_t length,
+				    uint8_t *report_info)
+{
+	uint8_t para_length = 4 + length;
+	char buf[para_length + HCI_CMD_PREAMBLE_SIZE];
+	char *p = buf;
+	struct rtl_btinfo *report = (struct rtl_btinfo *)report_info;
+
+	if (length) {
+		RTKBT_DBG("bt info: cmd %2.2X", report->cmd);
+		RTKBT_DBG("bt info: len %2.2X", report->len);
+		RTKBT_DBG("bt info: data %2.2X %2.2X %2.2X %2.2X %2.2X %2.2X",
+			  report->data[0], report->data[1], report->data[2],
+			  report->data[3], report->data[4], report->data[5]);
+	}
+	RTKBT_DBG("bt info: reason 0x%2x, length 0x%2x", reason, length);
+
+	if (!btrtl_coex.wifi_on)
+		return;
+
+	UINT16_TO_STREAM(p, HCI_OP_HCI_BT_INFO_NOTIFY);
+	*p++ = para_length;
+	*p++ = btrtl_coex.polling_enable;
+	*p++ = btrtl_coex.polling_interval;
+	*p++ = reason;
+	*p++ = length;
+
+	if (length)
+		memcpy(p, report_info, length);
+
+	RTKBT_DBG("para length %2x, polling_enable %u, poiiling_interval %u",
+	     para_length, btrtl_coex.polling_enable,
+	     btrtl_coex.polling_interval);
+	/* send BT INFO to Wi-Fi driver */
+	if (udpsocket_send(buf, para_length + HCI_CMD_PREAMBLE_SIZE) < 0)
+		RTKBT_ERR("%s: sock send error", __func__);
+}
+
+static void rtk_notify_regester_to_wifi(uint8_t *reg_value)
+{
+	uint8_t para_length = 9;
+	char p_buf[para_length + HCI_CMD_PREAMBLE_SIZE];
+	char *p = p_buf;
+	hci_mailbox_register *reg = (hci_mailbox_register *) reg_value;
+
+	if (!btrtl_coex.wifi_on)
+		return;
+
+	UINT16_TO_STREAM(p, HCI_OP_HCI_BT_REGISTER_VALUE_NOTIFY);
+	*p++ = para_length;
+	memcpy(p, reg_value, para_length);
+
+	RTKBT_DBG("bt register, register type is %x", reg->type);
+	RTKBT_DBG("bt register, register offset is %x", reg->offset);
+	RTKBT_DBG("bt register, register value is %x", reg->value);
+
+	if (udpsocket_send(p_buf, para_length + HCI_CMD_PREAMBLE_SIZE) < 0)
+		RTKBT_ERR("%s: sock send error", __func__);
+}
+
+void rtk_btcoex_parse_cmd(uint8_t *buffer, int count)
+{
+	u16 opcode = (buffer[0]) + (buffer[1] << 8);
+
+	if ((opcode == HCI_OP_INQUIRY) || (opcode == HCI_OP_PERIODIC_INQ)) {
+		if (!btrtl_coex.isinquirying) {
+			btrtl_coex.isinquirying = 1;
+			RTKBT_DBG("hci (periodic)inq, ");
+			RTKBT_DBG("notify wifi inquiry start");
+			rtk_notify_btoperation_to_wifi(BT_OPCODE_INQUIRY_START,
+						       0, NULL);
+		}
+	}
+
+	if ((opcode == HCI_OP_INQUIRY_CANCEL)
+	    || (opcode == HCI_OP_EXIT_PERIODIC_INQ)) {
+		if (btrtl_coex.isinquirying) {
+			btrtl_coex.isinquirying = 0;
+			RTKBT_DBG("hci (periodic)inq cancel/exit, ");
+			RTKBT_DBG("notify wifi inquiry stop");
+			rtk_notify_btoperation_to_wifi(BT_OPCODE_INQUIRY_END, 0,
+						       NULL);
+		}
+	}
+
+	if (opcode == HCI_OP_ACCEPT_CONN_REQ) {
+		if (!btrtl_coex.ispaging) {
+			btrtl_coex.ispaging = 1;
+			RTKBT_DBG("hci accept connreq, notify wifi page start");
+			rtk_notify_btoperation_to_wifi(BT_OPCODE_PAGE_START, 0,
+						       NULL);
+		}
+	}
+}
+
+static void rtk_handle_inquiry_complete(void)
+{
+	if (btrtl_coex.isinquirying) {
+		btrtl_coex.isinquirying = 0;
+		RTKBT_DBG("inq complete, notify wifi inquiry end");
+		rtk_notify_btoperation_to_wifi(BT_OPCODE_INQUIRY_END, 0, NULL);
+	}
+}
+
+static void rtk_handle_pin_code_req(void)
+{
+	if (!btrtl_coex.ispairing) {
+		btrtl_coex.ispairing = 1;
+		RTKBT_DBG("pin code req, notify wifi pair start");
+		rtk_notify_btoperation_to_wifi(BT_OPCODE_PAIR_START, 0, NULL);
+	}
+}
+
+static void rtk_handle_io_capa_req(void)
+{
+	if (!btrtl_coex.ispairing) {
+		btrtl_coex.ispairing = 1;
+		RTKBT_DBG("io cap req, notify wifi pair start");
+		rtk_notify_btoperation_to_wifi(BT_OPCODE_PAIR_START, 0, NULL);
+	}
+}
+
+static void rtk_handle_auth_request(void)
+{
+	if (btrtl_coex.ispairing) {
+		btrtl_coex.ispairing = 0;
+		RTKBT_DBG("auth req, notify wifi pair end");
+		rtk_notify_btoperation_to_wifi(BT_OPCODE_PAIR_END, 0, NULL);
+	}
+}
+
+static void rtk_handle_link_key_notify(void)
+{
+	if (btrtl_coex.ispairing) {
+		btrtl_coex.ispairing = 0;
+		RTKBT_DBG("link key notify, notify wifi pair end");
+		rtk_notify_btoperation_to_wifi(BT_OPCODE_PAIR_END, 0, NULL);
+	}
+}
+
+static void rtk_handle_mode_change_evt(u8 *p)
+{
+	u16 mode_change_handle, mode_interval;
+
+	p++;
+	STREAM_TO_UINT16(mode_change_handle, p);
+	p++;
+	STREAM_TO_UINT16(mode_interval, p);
+	update_hid_active_state(mode_change_handle, mode_interval);
+}
+
+static void rtk_parse_vendor_mailbox_cmd_evt(u8 *p, u8 total_len)
+{
+	u8 status, subcmd;
+	u8 temp_cmd[10];
+
+	status = *p++;
+	if (total_len <= 4) {
+		RTKBT_DBG("receive mailbox cmd from fw, total length <= 4");
+		return;
+	}
+	subcmd = *p++;
+	RTKBT_DBG("receive mailbox cmd from fw, subcmd is 0x%x, status is 0x%x",
+		  subcmd, status);
+
+	switch (subcmd) {
+	case HCI_VENDOR_SUB_CMD_BT_REPORT_CONN_SCO_INQ_INFO:
+		if (status == 0)	//success
+			rtk_notify_info_to_wifi(POLLING_RESPONSE,
+					RTL_BTINFO_LEN, (uint8_t *)p);
+		break;
+
+	case HCI_VENDOR_SUB_CMD_WIFI_CHANNEL_AND_BANDWIDTH_CMD:
+		rtk_notify_btcoex_to_wifi(WIFI_BW_CHNL_NOTIFY, status);
+		break;
+
+	case HCI_VENDOR_SUB_CMD_WIFI_FORCE_TX_POWER_CMD:
+		rtk_notify_btcoex_to_wifi(BT_POWER_DECREASE_CONTROL, status);
+		break;
+
+	case HCI_VENDOR_SUB_CMD_BT_ENABLE_IGNORE_WLAN_ACT_CMD:
+		rtk_notify_btcoex_to_wifi(IGNORE_WLAN_ACTIVE_CONTROL, status);
+		break;
+
+	case HCI_VENDOR_SUB_CMD_SET_BT_PSD_MODE:
+		rtk_notify_btcoex_to_wifi(BT_PSD_MODE_CONTROL, status);
+		break;
+
+	case HCI_VENDOR_SUB_CMD_SET_BT_LNA_CONSTRAINT:
+		rtk_notify_btcoex_to_wifi(LNA_CONSTRAIN_CONTROL, status);
+		break;
+
+	case HCI_VENDOR_SUB_CMD_BT_AUTO_REPORT_ENABLE:
+		break;
+
+	case HCI_VENDOR_SUB_CMD_BT_SET_TXRETRY_REPORT_PARAM:
+		break;
+
+	case HCI_VENDOR_SUB_CMD_BT_SET_PTATABLE:
+		break;
+
+	case HCI_VENDOR_SUB_CMD_GET_AFH_MAP_L:
+		if (status == 0) {
+			/* cmd_idx, length, piconet_id, mode */
+			memcpy(btrtl_coex.afh_map, p + 4, 4);
+			temp_cmd[0] = HCI_VENDOR_SUB_CMD_GET_AFH_MAP_M;
+			temp_cmd[1] = 2;
+			temp_cmd[2] = btrtl_coex.piconet_id;
+			temp_cmd[3] = btrtl_coex.mode;
+			rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 4,
+					     temp_cmd);
+		} else {
+			memset(btrtl_coex.afh_map, 0, 10);
+			rtk_notify_afhmap_to_wifi();
+		}
+		break;
+
+	case HCI_VENDOR_SUB_CMD_GET_AFH_MAP_M:
+		if (status == 0) {
+			memcpy(btrtl_coex.afh_map + 4, p + 4, 4);
+			temp_cmd[0] = HCI_VENDOR_SUB_CMD_GET_AFH_MAP_H;
+			temp_cmd[1] = 2;
+			temp_cmd[2] = btrtl_coex.piconet_id;
+			temp_cmd[3] = btrtl_coex.mode;
+			rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 4,
+					     temp_cmd);
+		} else {
+			memset(btrtl_coex.afh_map, 0, 10);
+			rtk_notify_afhmap_to_wifi();
+		}
+		break;
+
+	case HCI_VENDOR_SUB_CMD_GET_AFH_MAP_H:
+		if (status == 0)
+			memcpy(btrtl_coex.afh_map + 8, p + 4, 2);
+		else
+			memset(btrtl_coex.afh_map, 0, 10);
+
+		rtk_notify_afhmap_to_wifi();
+		break;
+
+	case HCI_VENDOR_SUB_CMD_RD_REG_REQ:
+		if (status == 0)
+			/* cmd_idx,length,regist type */
+			rtk_notify_regester_to_wifi(p + 3);
+		break;
+
+	case HCI_VENDOR_SUB_CMD_WR_REG_REQ:
+		rtk_notify_btcoex_to_wifi(BT_REGISTER_ACCESS, status);
+		break;
+
+	default:
+		break;
+	}
+}
+
+static void rtk_handle_cmd_complete_evt(u8 total_len, u8 *p)
+{
+	u16 opcode;
+
+	p++;
+	STREAM_TO_UINT16(opcode, p);
+	//RTKBT_DBG("cmd_complete, opcode is 0x%x", opcode);
+
+	if (opcode == HCI_OP_PERIODIC_INQ) {
+		if (*p++ && btrtl_coex.isinquirying) {
+			btrtl_coex.isinquirying = 0;
+			RTKBT_DBG("hci period inq, start error, ");
+			RTKBT_DBG("notify wifi inquiry stop");
+			rtk_notify_btoperation_to_wifi(BT_OPCODE_INQUIRY_END, 0,
+						       NULL);
+		}
+	}
+
+	if (opcode == HCI_OP_READ_LOCAL_VERSION) {
+		if (!(*p++)) {
+			p++;
+			STREAM_TO_UINT16(btrtl_coex.hci_reversion, p);
+			p += 3;
+			STREAM_TO_UINT16(btrtl_coex.lmp_subversion, p);
+			RTKBT_DBG("BTCOEX hci_rev 0x%04x",
+				  btrtl_coex.hci_reversion);
+			RTKBT_DBG("BTCOEX lmp_subver 0x%04x",
+				  btrtl_coex.lmp_subversion);
+		}
+	}
+
+	if (opcode == HCI_VENDOR_MAILBOX_CMD)
+		rtk_parse_vendor_mailbox_cmd_evt(p, total_len);
+}
+
+static void rtk_handle_cmd_status_evt(u8 *p)
+{
+	u16 opcode;
+	u8 status;
+
+	status = *p++;
+	p++;
+	STREAM_TO_UINT16(opcode, p);
+	//RTKBT_DBG("cmd_status, opcode is 0x%x", opcode);
+	if ((opcode == HCI_OP_INQUIRY) && (status)) {
+		if (btrtl_coex.isinquirying) {
+			btrtl_coex.isinquirying = 0;
+			RTKBT_DBG("hci inq, start error, notify wifi inq stop");
+			rtk_notify_btoperation_to_wifi(BT_OPCODE_INQUIRY_END, 0,
+						       NULL);
+		}
+	}
+
+	if (opcode == HCI_OP_CREATE_CONN) {
+		if (!status && !btrtl_coex.ispaging) {
+			btrtl_coex.ispaging = 1;
+			RTKBT_DBG("hci create conn, notify wifi start page");
+			rtk_notify_btoperation_to_wifi(BT_OPCODE_PAGE_START, 0,
+						       NULL);
+		}
+	}
+}
+
+static void rtk_handle_connection_complete_evt(u8 *p)
+{
+	u16 handle;
+	u8 status, link_type;
+	rtk_conn_prof *hci_conn = NULL;
+
+	status = *p++;
+	STREAM_TO_UINT16(handle, p);
+	p += 6;
+	link_type = *p++;
+
+	if (status == 0) {
+		if (btrtl_coex.ispaging) {
+			btrtl_coex.ispaging = 0;
+			RTKBT_DBG("notify wifi page success end");
+			rtk_notify_btoperation_to_wifi
+			    (BT_OPCODE_PAGE_SUCCESS_END, 0, NULL);
+		}
+
+		hci_conn = find_connection_by_handle(&btrtl_coex, handle);
+		if (hci_conn == NULL) {
+			hci_conn = allocate_connection_by_handle(handle);
+			if (hci_conn) {
+				add_connection_to_hash(&btrtl_coex,
+						       hci_conn);
+				hci_conn->profile_bitmap = 0;
+				memset(hci_conn->profile_refcount, 0, 8);
+				/*sco or esco*/
+				if ((link_type == 0) || (link_type == 2)) {
+					hci_conn->type = 1;
+					update_profile_connection(hci_conn,
+								  profile_sco,
+								  TRUE);
+				} else
+					hci_conn->type = 0;
+			} else {
+				RTKBT_ERR("hci connection allocate fail");
+			}
+		} else {
+			RTKBT_DBG("hci conn handle 0x%04x already existed!",
+				  handle);
+			hci_conn->profile_bitmap = 0;
+			memset(hci_conn->profile_refcount, 0, 8);
+			/*sco or esco*/
+			if ((link_type == 0) || (link_type == 2)) {
+				hci_conn->type = 1;
+				update_profile_connection(hci_conn, profile_sco,
+							  TRUE);
+			} else
+				hci_conn->type = 0;
+		}
+	} else if (btrtl_coex.ispaging) {
+		btrtl_coex.ispaging = 0;
+		RTKBT_DBG("notify wifi page unsuccess end");
+		rtk_notify_btoperation_to_wifi(BT_OPCODE_PAGE_UNSUCCESS_END, 0,
+					       NULL);
+	}
+}
+
+static void rtk_handle_le_connection_complete_evt(u8 *p)
+{
+	u16 handle, interval;
+	u8 status;
+	rtk_conn_prof *hci_conn = NULL;
+
+	status = *p++;
+	STREAM_TO_UINT16(handle, p);
+	p += 8;			//role, address type, address
+	STREAM_TO_UINT16(interval, p);
+
+	if (status == 0) {
+		if (btrtl_coex.ispaging) {
+			btrtl_coex.ispaging = 0;
+			RTKBT_DBG("notify wifi page success end");
+			rtk_notify_btoperation_to_wifi
+			    (BT_OPCODE_PAGE_SUCCESS_END, 0, NULL);
+		}
+
+		hci_conn = find_connection_by_handle(&btrtl_coex, handle);
+		if (hci_conn == NULL) {
+			hci_conn = allocate_connection_by_handle(handle);
+			if (hci_conn) {
+				add_connection_to_hash(&btrtl_coex,
+						       hci_conn);
+				hci_conn->profile_bitmap = 0;
+				memset(hci_conn->profile_refcount, 0, 8);
+				hci_conn->type = 2;
+				/*for coex, le is the same as hid*/
+				update_profile_connection(hci_conn,
+							profile_hid, TRUE);
+				update_hid_active_state(handle, interval);
+			} else {
+				RTKBT_ERR("hci connection allocate fail");
+			}
+		} else {
+			RTKBT_DBG("hci conn handle 0x%04x already existed!",
+				  handle);
+			hci_conn->profile_bitmap = 0;
+			memset(hci_conn->profile_refcount, 0, 8);
+			hci_conn->type = 2;
+			update_profile_connection(hci_conn, profile_hid, TRUE);
+			update_hid_active_state(handle, interval);
+		}
+	} else if (btrtl_coex.ispaging) {
+		btrtl_coex.ispaging = 0;
+		RTKBT_DBG("notify wifi page unsuccess end");
+		rtk_notify_btoperation_to_wifi(BT_OPCODE_PAGE_UNSUCCESS_END, 0,
+					       NULL);
+	}
+}
+
+static void rtk_handle_le_connection_update_complete_evt(u8 *p)
+{
+	u16 handle, interval;
+	/* u8 status; */
+
+	/* status = *p++; */
+	p++;
+
+	STREAM_TO_UINT16(handle, p);
+	STREAM_TO_UINT16(interval, p);
+	update_hid_active_state(handle, interval);
+}
+
+static void rtk_handle_le_meta_evt(u8 *p)
+{
+	u8 sub_event = *p++;
+
+	switch (sub_event) {
+	case HCI_EV_LE_CONN_COMPLETE:
+		rtk_handle_le_connection_complete_evt(p);
+		break;
+
+	case HCI_EV_LE_CONN_UPDATE_COMPLETE:
+		rtk_handle_le_connection_update_complete_evt(p);
+		break;
+
+	default:
+		break;
+	}
+}
+
+static void disconn_acl(u16 handle, struct rtl_hci_conn *conn)
+{
+	struct rtl_coex_struct *coex = &btrtl_coex;
+	rtk_prof_info *prof_info = NULL;
+	struct list_head *iter = NULL, *temp = NULL;
+
+	spin_lock(&coex->spin_lock_profile);
+
+	list_for_each_safe(iter, temp, &coex->profile_list) {
+		prof_info = list_entry(iter, rtk_prof_info, list);
+		if (handle == prof_info->handle && prof_info->scid
+		    && prof_info->dcid) {
+			RTKBT_DBG("hci disconn, hndl %x, psm %x, ",
+				prof_info->handle, prof_info->psm);
+			RTKBT_DBG("dcid %x, scid %x",
+				prof_info->dcid, prof_info->scid);
+			//If both scid and dcid > 0, L2cap connection is exist.
+			update_profile_connection(conn,
+					prof_info->profile_index, FALSE);
+			delete_profile_from_hash(prof_info);
+		}
+	}
+	spin_unlock(&coex->spin_lock_profile);
+}
+
+static void rtk_handle_disconnect_complete_evt(u8 *p)
+{
+	u16 handle;
+	u8 status;
+	/* u8 reason; */
+	rtk_conn_prof *hci_conn = NULL;
+
+	/*for slave: connection will be disconnected if authentication fail*/
+	if (btrtl_coex.ispairing) {
+		btrtl_coex.ispairing = 0;
+		RTKBT_DBG("hci disc complete, notify wifi pair end");
+		rtk_notify_btoperation_to_wifi(BT_OPCODE_PAIR_END, 0, NULL);
+	}
+
+	status = *p++;
+	STREAM_TO_UINT16(handle, p);
+
+	/* reason = *p; */
+
+	if (status == 0) {
+		RTKBT_DBG("process disconn complete event.");
+		hci_conn = find_connection_by_handle(&btrtl_coex, handle);
+		if (hci_conn) {
+			switch (hci_conn->type) {
+			case 0:
+				/* FIXME: If this is interrupted by l2cap rx,
+				 * there may be deadlock on spin_lock_profile
+				 */
+				disconn_acl(handle, hci_conn);
+				break;
+
+			case 1:
+				update_profile_connection(hci_conn, profile_sco,
+							  FALSE);
+				break;
+
+			case 2:
+				update_profile_connection(hci_conn, profile_hid,
+							  FALSE);
+				break;
+
+			default:
+				break;
+			}
+			delete_connection_from_hash(hci_conn);
+		} else
+			RTKBT_ERR("hci conn handle 0x%04x not found", handle);
+	}
+}
+
+static void rtk_handle_specific_evt(u8 *p)
+{
+	u16 subcode;
+
+	STREAM_TO_UINT16(subcode, p);
+	if (subcode == HCI_VENDOR_PTA_AUTO_REPORT_EVENT) {
+		RTKBT_DBG("notify wifi driver with autoreport data");
+		rtk_notify_info_to_wifi(AUTO_REPORT, RTL_BTINFO_LEN,
+			(uint8_t *)p);
+	}
+}
+
+static void rtk_parse_event_data(struct rtl_coex_struct *coex,
+		u8 *data, u16 len)
+{
+	u8 *p = data;
+	u8 event_code = *p++;
+	u8 total_len = *p++;
+
+	(void)coex;
+	(void)&len;
+
+	switch (event_code) {
+	case HCI_EV_INQUIRY_COMPLETE:
+		rtk_handle_inquiry_complete();
+		break;
+
+	case HCI_EV_PIN_CODE_REQ:
+		rtk_handle_pin_code_req();
+		break;
+
+	case HCI_EV_IO_CAPA_REQUEST:
+		rtk_handle_io_capa_req();
+		break;
+
+	case HCI_EV_AUTH_COMPLETE:
+		rtk_handle_auth_request();
+		break;
+
+	case HCI_EV_LINK_KEY_NOTIFY:
+		rtk_handle_link_key_notify();
+		break;
+
+	case HCI_EV_MODE_CHANGE:
+		rtk_handle_mode_change_evt(p);
+		break;
+
+	case HCI_EV_CMD_COMPLETE:
+		rtk_handle_cmd_complete_evt(total_len, p);
+		break;
+
+	case HCI_EV_CMD_STATUS:
+		rtk_handle_cmd_status_evt(p);
+		break;
+
+	case HCI_EV_CONN_COMPLETE:
+	case HCI_EV_SYNC_CONN_COMPLETE:
+		rtk_handle_connection_complete_evt(p);
+		break;
+
+	case HCI_EV_DISCONN_COMPLETE:
+		rtk_handle_disconnect_complete_evt(p);
+		break;
+
+	case HCI_EV_LE_META:
+		rtk_handle_le_meta_evt(p);
+		break;
+
+	case HCI_EV_VENDOR_SPECIFIC:
+		rtk_handle_specific_evt(p);
+		break;
+
+	default:
+		break;
+	}
+}
+
+const char l2_dir_str[][4] = {
+	"RX", "TX",
+};
+
+void rtl_process_l2_sig(struct rtl_l2_buff *l2)
+{
+	/* u8 flag; */
+	u8 code;
+	/* u8 identifier; */
+	u16 handle;
+	/* u16 total_len; */
+	/* u16 pdu_len, channel_id; */
+	/* u16 command_len; */
+	u16 psm, scid, dcid, result;
+	/* u16 status; */
+	u8 *pp = l2->data;
+
+	STREAM_TO_UINT16(handle, pp);
+	/* flag = handle >> 12; */
+	handle = handle & 0x0FFF;
+	/* STREAM_TO_UINT16(total_len, pp); */
+	pp += 2; /* data total length */
+
+	/* STREAM_TO_UINT16(pdu_len, pp);
+	 * STREAM_TO_UINT16(channel_id, pp);
+	 */
+	pp += 4; /* l2 len and channel id */
+
+	code = *pp++;
+	switch (code) {
+	case L2CAP_CONN_REQ:
+		/* identifier = *pp++; */
+		pp++;
+		/* STREAM_TO_UINT16(command_len, pp); */
+		pp += 2;
+		STREAM_TO_UINT16(psm, pp);
+		STREAM_TO_UINT16(scid, pp);
+		RTKBT_DBG("%s l2cap conn req, hndl 0x%04x, ",
+				l2_dir_str[l2->out], handle);
+		RTKBT_DBG("PSM 0x%04x, scid 0x%04x", psm, scid);
+		handle_l2cap_con_req(handle, psm, scid, l2->out);
+		break;
+
+	case L2CAP_CONN_RSP:
+		/* identifier = *pp++; */
+		pp++;
+		/* STREAM_TO_UINT16(command_len, pp); */
+		pp += 2;
+		STREAM_TO_UINT16(dcid, pp);
+		STREAM_TO_UINT16(scid, pp);
+		STREAM_TO_UINT16(result, pp);
+		/* STREAM_TO_UINT16(status, pp); */
+		pp += 2;
+		RTKBT_DBG("%s l2cap conn rsp, ", l2_dir_str[l2->out]);
+		RTKBT_DBG("hndl 0x%04x, dcid 0x%04x, ", handle, dcid);
+		RTKBT_DBG("scid 0x%04x, result 0x%04x", scid, result);
+		handle_l2cap_con_rsp(handle, dcid, scid, l2->out, result);
+		break;
+
+	case L2CAP_DISCONN_REQ:
+		/* identifier = *pp++; */
+		pp++;
+		/* STREAM_TO_UINT16(command_len, pp); */
+		pp += 2;
+		STREAM_TO_UINT16(dcid, pp);
+		STREAM_TO_UINT16(scid, pp);
+		RTKBT_DBG("%s l2cap disconn req, ", l2_dir_str[l2->out]);
+		RTKBT_DBG("hndl 0x%04x, dcid 0x%04x, scid 0x%04x",
+			handle, dcid, scid);
+		handle_l2cap_discon_req(handle, dcid, scid, l2->out);
+		break;
+	default:
+		RTKBT_DBG("undesired l2 command %u", code);
+		break;
+	}
+}
+
+static void rtl_l2_data_process(u8 *pp, u16 len, int dir)
+{
+	u8 code;
+	u8 flag;
+	u16 handle, pdu_len, channel_id;
+	/* u16 total_len; */
+	struct rtl_l2_buff *l2 = NULL;
+	u8 *hd = pp;
+
+	/* RTKBT_DBG("l2 sig data %p, len %u, dir %d", pp, len, dir); */
+
+	STREAM_TO_UINT16(handle, pp);
+	flag = handle >> 12;
+	handle = handle & 0x0FFF;
+	/* STREAM_TO_UINT16(total_len, pp); */
+	pp += 2; /* data total length */
+
+	STREAM_TO_UINT16(pdu_len, pp);
+	STREAM_TO_UINT16(channel_id, pp);
+
+	if (channel_id == 0x0001) {
+		code = *pp++;
+		switch (code) {
+		case L2CAP_CONN_REQ:
+		case L2CAP_CONN_RSP:
+		case L2CAP_DISCONN_REQ:
+			RTKBT_DBG("l2cap op %u, len %u, out %d", code, len,
+				  dir);
+			l2 = rtl_l2_node_get(&btrtl_coex);
+			if (l2) {
+				u16 n;
+
+				n = min_t(uint, len, L2_MAX_SUBSEC_LEN);
+				memcpy(l2->data, hd, n);
+				l2->out = dir;
+				rtl_l2_node_to_used(&btrtl_coex, l2);
+				queue_delayed_work(btrtl_coex.fw_wq,
+						&btrtl_coex.l2_work, 0);
+			} else
+				RTKBT_ERR("%s: failed to get l2 node",
+					  __func__);
+			break;
+		case L2CAP_DISCONN_RSP:
+			break;
+		default:
+			break;
+		}
+	} else {
+		if ((flag != 0x01) && (is_profile_connected(profile_a2dp) ||
+				       is_profile_connected(profile_pan)))
+			/* Do not count the continuous packets */
+			packets_count(handle, channel_id, pdu_len, dir, pp);
+	}
+}
+
+
+static void rtl_l2_work(struct work_struct *work)
+{
+	struct rtl_coex_struct *coex;
+	struct rtl_l2_buff *l2;
+	unsigned long flags;
+
+	coex = container_of(work, struct rtl_coex_struct, l2_work.work);
+
+	spin_lock_irqsave(&coex->buff_lock, flags);
+	while (!list_empty(&coex->l2_used_list)) {
+		l2 = list_entry(coex->l2_used_list.next, struct rtl_l2_buff,
+				list);
+		list_del(&l2->list);
+
+		spin_unlock_irqrestore(&coex->buff_lock, flags);
+
+		rtl_process_l2_sig(l2);
+
+		spin_lock_irqsave(&coex->buff_lock, flags);
+
+		list_add_tail(&l2->list, &coex->l2_free_list);
+	}
+	spin_unlock_irqrestore(&coex->buff_lock, flags);
+}
+
+static void rtl_ev_work(struct work_struct *work)
+{
+	struct rtl_coex_struct *coex;
+	struct rtl_hci_ev *ev;
+	unsigned long flags;
+
+	coex = container_of(work, struct rtl_coex_struct, fw_work.work);
+
+	spin_lock_irqsave(&coex->buff_lock, flags);
+	while (!list_empty(&coex->ev_used_list)) {
+		ev = list_entry(coex->ev_used_list.next, struct rtl_hci_ev,
+				list);
+		list_del(&ev->list);
+		spin_unlock_irqrestore(&coex->buff_lock, flags);
+
+		rtk_parse_event_data(coex, ev->data, ev->len);
+
+		spin_lock_irqsave(&coex->buff_lock, flags);
+		list_add_tail(&ev->list, &coex->ev_free_list);
+	}
+	spin_unlock_irqrestore(&coex->buff_lock, flags);
+}
+
+int ev_filter_out(u8 ev_code)
+{
+	switch (ev_code) {
+	case HCI_EV_INQUIRY_COMPLETE:
+	case HCI_EV_PIN_CODE_REQ:
+	case HCI_EV_IO_CAPA_REQUEST:
+	case HCI_EV_AUTH_COMPLETE:
+	case HCI_EV_LINK_KEY_NOTIFY:
+	case HCI_EV_MODE_CHANGE:
+	case HCI_EV_CMD_COMPLETE:
+	case HCI_EV_CMD_STATUS:
+	case HCI_EV_CONN_COMPLETE:
+	case HCI_EV_SYNC_CONN_COMPLETE:
+	case HCI_EV_DISCONN_COMPLETE:
+	case HCI_EV_LE_META:
+	case HCI_EV_VENDOR_SPECIFIC:
+		return 0;
+	default:
+		return 1;
+	}
+}
+
+/* Context: in_interrupt() */
+void rtk_btcoex_parse_event(uint8_t *buffer, int count)
+{
+	struct rtl_coex_struct *coex = &btrtl_coex;
+	struct rtl_hci_ev *ev;
+	u8 *s;
+	struct sk_buff *skb;
+	struct sk_buff *ev_sk = NULL;
+
+	/* RTKBT_DBG("%s: parse ev.", __func__); */
+
+	spin_lock(&coex->rxlock);
+	skb = coex->evt_skb;
+
+	while (count) {
+		int len;
+
+		if (!skb) {
+			skb = bt_skb_alloc(HCI_MAX_EVENT_SIZE, GFP_ATOMIC);
+			if (!skb) {
+				RTKBT_ERR("failed to alloc skb");
+				break;
+			}
+
+			coex->pkt_type = HCI_EVENT_PKT;
+			coex->expect = HCI_EVENT_HDR_SIZE;
+		}
+
+		len = min_t(uint, coex->expect, count);
+		memcpy(skb_put(skb, len), buffer, len);
+
+		count -= len;
+		buffer += len;
+		coex->expect -= len;
+
+		if (skb->len == HCI_EVENT_HDR_SIZE) {
+			/* Complete event header */
+			coex->expect = hci_event_hdr(skb)->plen;
+
+			if (skb_tailroom(skb) < coex->expect) {
+				kfree_skb(skb);
+				skb = NULL;
+
+				RTKBT_ERR("skb room is not enough");
+				break;
+			}
+		}
+
+		if (coex->expect == 0) {
+			/* Complete frame */
+			ev_sk = skb;
+			skb = NULL;
+		}
+	}
+
+	/* evt_skb would be NULL only there is a complete frame found. */
+	coex->evt_skb = skb;
+	spin_unlock(&coex->rxlock);
+
+	/* no complete frame */
+	if (!ev_sk)
+		return;
+
+	s = (u8 *)ev_sk->data;
+
+	if (ev_filter_out(s[0]))
+		return;
+
+	ev = rtl_ev_node_get(&btrtl_coex);
+	if (!ev) {
+		RTKBT_ERR("%s: no free ev node.", __func__);
+		return;
+	}
+
+	if (ev_sk->len > MAX_LEN_OF_HCI_EV) {
+		memcpy(ev->data, ev_sk->data, MAX_LEN_OF_HCI_EV);
+		ev->len = MAX_LEN_OF_HCI_EV;
+	} else {
+		memcpy(ev->data, ev_sk->data, ev_sk->len);
+		ev->len = ev_sk->len;
+	}
+
+	rtl_ev_node_to_used(&btrtl_coex, ev);
+
+	queue_delayed_work(btrtl_coex.fw_wq, &btrtl_coex.fw_work, 0);
+
+	/* free complete frame here */
+	kfree_skb(ev_sk);
+}
+
+
+void rtk_btcoex_parse_l2cap_data_tx(uint8_t *buffer, int count)
+{
+	rtl_l2_data_process(buffer, count, 1);
+	//u16 handle, total_len, pdu_len, channel_ID, command_len, psm, scid,
+	//    dcid, result, status;
+	//u8 flag, code, identifier;
+	//u8 *pp = (u8 *) (skb->data);
+	//STREAM_TO_UINT16(handle, pp);
+	//flag = handle >> 12;
+	//handle = handle & 0x0FFF;
+	//STREAM_TO_UINT16(total_len, pp);
+	//STREAM_TO_UINT16(pdu_len, pp);
+	//STREAM_TO_UINT16(channel_ID, pp);
+
+	//if (channel_ID == 0x0001) {
+	//	code = *pp++;
+	//	switch (code) {
+	//	case L2CAP_CONN_REQ:
+	//		identifier = *pp++;
+	//		STREAM_TO_UINT16(command_len, pp);
+	//		STREAM_TO_UINT16(psm, pp);
+	//		STREAM_TO_UINT16(scid, pp);
+	//		RTKBT_DBG("TX l2cap conn req, hndl %x, PSM %x, scid=%x",
+	//			  handle, psm, scid);
+	//		handle_l2cap_con_req(handle, psm, scid, 1);
+	//		break;
+
+	//	case L2CAP_CONN_RSP:
+	//		identifier = *pp++;
+	//		STREAM_TO_UINT16(command_len, pp);
+	//		STREAM_TO_UINT16(dcid, pp);
+	//		STREAM_TO_UINT16(scid, pp);
+	//		STREAM_TO_UINT16(result, pp);
+	//		STREAM_TO_UINT16(status, pp);
+	//		RTKBT_DBG("TX l2cap conn rsp, hndl %x, dcid %x, "
+	//			  "scid %x, result %x",
+	//			  handle, dcid, scid, result);
+	//		handle_l2cap_con_rsp(handle, dcid, scid, 1, result);
+	//		break;
+
+	//	case L2CAP_DISCONN_REQ:
+	//		identifier = *pp++;
+	//		STREAM_TO_UINT16(command_len, pp);
+	//		STREAM_TO_UINT16(dcid, pp);
+	//		STREAM_TO_UINT16(scid, pp);
+	//		RTKBT_DBG("TX l2cap disconn req, hndl %x, dcid %x, "
+	//			  "scid %x", handle, dcid, scid);
+	//		handle_l2cap_discon_req(handle, dcid, scid, 1);
+	//		break;
+
+	//	case L2CAP_DISCONN_RSP:
+	//		break;
+
+	//	default:
+	//		break;
+	//	}
+	//} else {
+	//	/*Do not count the continuous packets*/
+	//	if ((flag != 0x01) && (is_profile_connected(profile_a2dp) ||
+	//		is_profile_connected(profile_pan)))
+	//		packets_count(handle, channel_ID, pdu_len, 1, pp);
+	//}
+}
+
+void rtk_btcoex_parse_l2cap_data_rx(uint8_t *buffer, int count)
+{
+	rtl_l2_data_process(buffer, count, 0);
+	//u16 handle, total_len, pdu_len, channel_ID, command_len, psm, scid,
+	//    dcid, result, status;
+	//u8 flag, code, identifier;
+	//u8 *pp = urb->transfer_buffer;
+	//STREAM_TO_UINT16(handle, pp);
+	//flag = handle >> 12;
+	//handle = handle & 0x0FFF;
+	//STREAM_TO_UINT16(total_len, pp);
+	//STREAM_TO_UINT16(pdu_len, pp);
+	//STREAM_TO_UINT16(channel_ID, pp);
+
+	//if (channel_ID == 0x0001) {
+	//	code = *pp++;
+	//	switch (code) {
+	//	case L2CAP_CONN_REQ:
+	//		identifier = *pp++;
+	//		STREAM_TO_UINT16(command_len, pp);
+	//		STREAM_TO_UINT16(psm, pp);
+	//		STREAM_TO_UINT16(scid, pp);
+	//		RTKBT_DBG("RX l2cap conn req, hndl %x, PSM %x, scid %x",
+	//			  handle, psm, scid);
+	//		handle_l2cap_con_req(handle, psm, scid, 0);
+	//		break;
+
+	//	case L2CAP_CONN_RSP:
+	//		identifier = *pp++;
+	//		STREAM_TO_UINT16(command_len, pp);
+	//		STREAM_TO_UINT16(dcid, pp);
+	//		STREAM_TO_UINT16(scid, pp);
+	//		STREAM_TO_UINT16(result, pp);
+	//		STREAM_TO_UINT16(status, pp);
+	//		RTKBT_DBG("RX l2cap conn rsp, hndl %x, dcid %x, "
+	//			  "scid %x, result %x",
+	//			  handle, dcid, scid, result);
+	//		handle_l2cap_con_rsp(handle, dcid, scid, 0, result);
+	//		break;
+
+	//	case L2CAP_DISCONN_REQ:
+	//		identifier = *pp++;
+	//		STREAM_TO_UINT16(command_len, pp);
+	//		STREAM_TO_UINT16(dcid, pp);
+	//		STREAM_TO_UINT16(scid, pp);
+	//		RTKBT_DBG("RX l2cap disconn req, hndl %x, dcid %x, "
+	//			  "scid %x", handle, dcid, scid);
+	//		handle_l2cap_discon_req(handle, dcid, scid, 0);
+	//		break;
+
+	//	case L2CAP_DISCONN_RSP:
+	//		break;
+
+	//	default:
+	//		break;
+	//	}
+	//} else {
+	//      /*Do not count the continuous packets*/
+	//	if ((flag != 0x01) && (is_profile_connected(profile_a2dp)
+	//			|| is_profile_connected(profile_pan)))
+	//		packets_count(handle, channel_ID, pdu_len, 0, pp);
+	//}
+}
+
+static void polling_bt_info(unsigned long data)
+{
+	uint8_t temp_cmd[1];
+
+	RTKBT_DBG("polling timer");
+	if (btrtl_coex.polling_enable) {
+		//temp_cmd[0] = HCI_VENDOR_SUB_CMD_BT_REPORT_CONN_SCO_INQ_INFO;
+		temp_cmd[0] = HCI_VENDOR_SUB_CMD_BT_AUTO_REPORT_STATUS_INFO;
+		rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 1, temp_cmd);
+	}
+	mod_timer(&(btrtl_coex.polling_timer),
+		  jiffies +
+		  msecs_to_jiffies(1000 * btrtl_coex.polling_interval));
+}
+
+static void rtk_handle_bt_info_control(uint8_t *p)
+{
+	uint8_t temp_cmd[20];
+	struct rtl_btinfo_ctl *ctl = (struct rtl_btinfo_ctl *)p;
+
+	RTKBT_DBG("Received polling_enable %u, ", ctl->polling_enable);
+	RTKBT_DBG("polling_time %u, ", ctl->polling_time);
+	RTKBT_DBG("autoreport_enable %u", ctl->autoreport_enable);
+	RTKBT_DBG("coex: original polling_enable %u",
+		  btrtl_coex.polling_enable);
+
+	if (ctl->polling_enable && !btrtl_coex.polling_enable) {
+		/* setup polling timer for getting bt info from firmware */
+		setup_timer(&(btrtl_coex.polling_timer), polling_bt_info, 0);
+		btrtl_coex.polling_timer.expires =
+		    jiffies + msecs_to_jiffies(ctl->polling_time * 1000);
+		add_timer(&(btrtl_coex.polling_timer));
+	}
+
+	/* Close bt info polling timer */
+	if (!ctl->polling_enable && btrtl_coex.polling_enable)
+		del_timer(&(btrtl_coex.polling_timer));
+
+	if (btrtl_coex.autoreport != ctl->autoreport_enable) {
+		temp_cmd[0] = HCI_VENDOR_SUB_CMD_BT_AUTO_REPORT_ENABLE;
+		temp_cmd[1] = 1;
+		temp_cmd[2] = ctl->autoreport_enable;
+		rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 3, temp_cmd);
+	}
+
+	btrtl_coex.polling_enable = ctl->polling_enable;
+	btrtl_coex.polling_interval = ctl->polling_time;
+	btrtl_coex.autoreport = ctl->autoreport_enable;
+
+	rtk_notify_info_to_wifi(HOST_RESPONSE, 0, NULL);
+}
+
+static void rtk_handle_bt_coex_control(uint8_t *p)
+{
+	uint8_t temp_cmd[20];
+	uint8_t opcode, opcode_len, value, power_decrease, psd_mode,
+	    access_type;
+
+	opcode = *p++;
+	RTKBT_DBG("receive bt coex control event from wifi, op 0x%02x", opcode);
+
+	switch (opcode) {
+	case BT_PATCH_VERSION_QUERY:
+		rtk_notify_btpatch_version_to_wifi();
+		break;
+
+	case IGNORE_WLAN_ACTIVE_CONTROL:
+		opcode_len = *p++;
+		value = *p++;
+		temp_cmd[0] = HCI_VENDOR_SUB_CMD_BT_ENABLE_IGNORE_WLAN_ACT_CMD;
+		temp_cmd[1] = 1;
+		temp_cmd[2] = value;
+		rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 3, temp_cmd);
+		break;
+
+	case LNA_CONSTRAIN_CONTROL:
+		opcode_len = *p++;
+		value = *p++;
+		temp_cmd[0] = HCI_VENDOR_SUB_CMD_SET_BT_LNA_CONSTRAINT;
+		temp_cmd[1] = 1;
+		temp_cmd[2] = value;
+		rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 3, temp_cmd);
+		break;
+
+	case BT_POWER_DECREASE_CONTROL:
+		opcode_len = *p++;
+		power_decrease = *p++;
+		temp_cmd[0] = HCI_VENDOR_SUB_CMD_WIFI_FORCE_TX_POWER_CMD;
+		temp_cmd[1] = 1;
+		temp_cmd[2] = power_decrease;
+		rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 3, temp_cmd);
+		break;
+
+	case BT_PSD_MODE_CONTROL:
+		opcode_len = *p++;
+		psd_mode = *p++;
+		temp_cmd[0] = HCI_VENDOR_SUB_CMD_SET_BT_PSD_MODE;
+		temp_cmd[1] = 1;
+		temp_cmd[2] = psd_mode;
+		rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 3, temp_cmd);
+		break;
+
+	case WIFI_BW_CHNL_NOTIFY:
+		opcode_len = *p++;
+		temp_cmd[0] = HCI_VENDOR_SUB_CMD_WIFI_CHANNEL_AND_BANDWIDTH_CMD;
+		temp_cmd[1] = 3;
+		/*wifi_state, wifi_centralchannel, chnnels_btnotuse*/
+		memcpy(temp_cmd + 2, p, 3);
+		rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 5, temp_cmd);
+		break;
+
+	case QUERY_BT_AFH_MAP:
+		opcode_len = *p++;
+		btrtl_coex.piconet_id = *p++;
+		btrtl_coex.mode = *p++;
+		temp_cmd[0] = HCI_VENDOR_SUB_CMD_GET_AFH_MAP_L;
+		temp_cmd[1] = 2;
+		temp_cmd[2] = btrtl_coex.piconet_id;
+		temp_cmd[3] = btrtl_coex.mode;
+		rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 4, temp_cmd);
+		break;
+
+	case BT_REGISTER_ACCESS:
+		opcode_len = *p++;
+		access_type = *p++;
+		if (access_type == 0) {	//read
+			temp_cmd[0] = HCI_VENDOR_SUB_CMD_RD_REG_REQ;
+			temp_cmd[1] = 5;
+			temp_cmd[2] = *p++;
+			memcpy(temp_cmd + 3, p, 4);
+			rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 7,
+					     temp_cmd);
+		} else {	//write
+			temp_cmd[0] = HCI_VENDOR_SUB_CMD_RD_REG_REQ;
+			temp_cmd[1] = 5;
+			temp_cmd[2] = *p++;
+			memcpy(temp_cmd + 3, p, 8);
+			rtk_vendor_cmd_to_fw(HCI_VENDOR_MAILBOX_CMD, 11,
+					     temp_cmd);
+		}
+		break;
+
+	default:
+		break;
+	}
+}
+
+static void rtk_handle_event_from_wifi(uint8_t *msg)
+{
+	uint8_t *p = msg;
+	uint8_t event_code = *p++;
+	uint8_t total_length;
+	uint8_t extension_event;
+	uint8_t operation;
+	uint16_t wifi_opcode;
+	uint8_t op_status;
+
+	if (memcmp(msg, invite_rsp, sizeof(invite_rsp)) == 0) {
+		RTKBT_DBG("receive invite rsp from wifi, wifi is already on");
+		btrtl_coex.wifi_on = 1;
+		rtk_notify_extension_version_to_wifi();
+	}
+
+	if (memcmp(msg, attend_req, sizeof(attend_req)) == 0) {
+		RTKBT_DBG("receive attend req from wifi, wifi turn on");
+		btrtl_coex.wifi_on = 1;
+		udpsocket_send(attend_ack, sizeof(attend_ack));
+		rtk_notify_extension_version_to_wifi();
+	}
+
+	if (memcmp(msg, wifi_leave, sizeof(wifi_leave)) == 0) {
+		RTKBT_DBG("receive wifi leave from wifi, wifi turn off");
+		btrtl_coex.wifi_on = 0;
+		udpsocket_send(leave_ack, sizeof(leave_ack));
+		if (btrtl_coex.polling_enable) {
+			btrtl_coex.polling_enable = 0;
+			del_timer(&(btrtl_coex.polling_timer));
+		}
+	}
+
+	if (memcmp(msg, leave_ack, sizeof(leave_ack)) == 0)
+		RTKBT_DBG("receive leave ack from wifi");
+
+	if (event_code == 0xFE) {
+		total_length = *p++;
+		extension_event = *p++;
+		switch (extension_event) {
+		case RTK_HS_EXTENSION_EVENT_WIFI_SCAN:
+			operation = *p;
+			RTKBT_DBG("Recv WiFi scan notify event from");
+			RTKBT_DBG(" WiFi, op 0x%02x", operation);
+			break;
+
+		case RTK_HS_EXTENSION_EVENT_HCI_BT_INFO_CONTROL:
+			rtk_handle_bt_info_control(p);
+			break;
+
+		case RTK_HS_EXTENSION_EVENT_HCI_BT_COEX_CONTROL:
+			rtk_handle_bt_coex_control(p);
+			break;
+
+		default:
+			break;
+		}
+	}
+
+	if (event_code == 0x0E) {
+		p += 2;		//length, number of complete packets
+		STREAM_TO_UINT16(wifi_opcode, p);
+		op_status = *p;
+		RTKBT_DBG("Recv cmd complete event from WiFi, ");
+		RTKBT_DBG("op 0x%02x, status 0x%02x",
+			wifi_opcode, op_status);
+	}
+}
+
+static inline void rtl_free_frags(struct rtl_coex_struct *coex)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&coex->rxlock, flags);
+
+	kfree_skb(coex->evt_skb);
+	coex->evt_skb = NULL;
+
+	spin_unlock_irqrestore(&coex->rxlock, flags);
+}
+
+void rtk_btcoex_open(struct hci_dev *hdev)
+{
+	if (test_and_set_bit(RTL_COEX_RUNNING, &btrtl_coex.flags)) {
+		RTKBT_WARN("RTL COEX is already running.");
+		return;
+	}
+
+	RTKBT_INFO("Open BTCOEX");
+
+	/* Just for test */
+	//struct rtl_btinfo_ctl ctl;
+
+	INIT_DELAYED_WORK(&btrtl_coex.fw_work, (void *)rtl_ev_work);
+	INIT_DELAYED_WORK(&btrtl_coex.sock_work,
+			  (void *)udpsocket_recv_data);
+	INIT_DELAYED_WORK(&btrtl_coex.l2_work, (void *)rtl_l2_work);
+
+	btrtl_coex.hdev = hdev;
+	btrtl_coex.wifi_on = 0;
+
+	init_profile_hash(&btrtl_coex);
+	init_connection_hash(&btrtl_coex);
+
+	btrtl_coex.pkt_type = 0;
+	btrtl_coex.expect = 0;
+	btrtl_coex.evt_skb = NULL;
+
+	create_udpsocket();
+	udpsocket_send(invite_req, sizeof(invite_req));
+
+	/* Just for test */
+	//ctl.polling_enable = 1;
+	//ctl.polling_time = 1;
+	//ctl.autoreport_enable = 1;
+	//rtk_handle_bt_info_control((u8 *)&ctl);
+}
+
+void rtk_btcoex_close(void)
+{
+	int kk = 0;
+
+	if (!test_and_clear_bit(RTL_COEX_RUNNING, &btrtl_coex.flags)) {
+		RTKBT_WARN("RTL COEX is already closed.");
+		return;
+	}
+
+	RTKBT_INFO("Close BTCOEX");
+
+	if (btrtl_coex.wifi_on)
+		udpsocket_send(bt_leave, sizeof(bt_leave));
+
+	if (btrtl_coex.polling_enable) {
+		btrtl_coex.polling_enable = 0;
+		del_timer(&(btrtl_coex.polling_timer));
+	}
+
+	del_timer(&(btrtl_coex.a2dp_count_timer));
+	del_timer(&(btrtl_coex.pan_count_timer));
+
+	cancel_delayed_work(&btrtl_coex.sock_work);
+	cancel_delayed_work(&btrtl_coex.fw_work);
+	cancel_delayed_work(&btrtl_coex.l2_work);
+
+	if (btrtl_coex.sock_open) {
+		btrtl_coex.sock_open = 0;
+		RTKBT_DBG("release udp socket");
+		sock_release(btrtl_coex.udpsock);
+	}
+
+	flush_connection_hash(&btrtl_coex);
+	flush_profile_hash(&btrtl_coex);
+	btrtl_coex.profile_bitmap = 0;
+	btrtl_coex.profile_status = 0;
+	for (kk = 0; kk < 8; kk++)
+		btrtl_coex.profile_refcount[kk] = 0;
+
+	rtl_free_frags(&btrtl_coex);
+	RTKBT_DBG("-x");
+}
+
+void rtk_btcoex_probe(struct hci_dev *hdev)
+{
+	btrtl_coex.hdev = hdev;
+	spin_lock_init(&btrtl_coex.spin_lock_sock);
+	spin_lock_init(&btrtl_coex.spin_lock_profile);
+}
+
+void rtk_btcoex_init(void)
+{
+	RTKBT_DBG("%s: version: %s", __func__, RTK_VERSION);
+	RTKBT_DBG("create workqueue");
+	btrtl_coex.sock_wq = create_workqueue("btudpwork");
+	btrtl_coex.fw_wq = create_workqueue("btfwwork");
+	rtl_alloc_buff(&btrtl_coex);
+	spin_lock_init(&btrtl_coex.rxlock);
+}
+
+void rtk_btcoex_exit(void)
+{
+	RTKBT_DBG("%s: destroy workqueue", __func__);
+	flush_workqueue(btrtl_coex.sock_wq);
+	destroy_workqueue(btrtl_coex.sock_wq);
+	flush_workqueue(btrtl_coex.fw_wq);
+	destroy_workqueue(btrtl_coex.fw_wq);
+	rtl_free_buff(&btrtl_coex);
+}
diff --git a/drivers/bluetooth/rtk_coex.h b/drivers/bluetooth/rtk_coex.h
new file mode 100644
index 00000000..085a505
--- /dev/null
+++ b/drivers/bluetooth/rtk_coex.h
@@ -0,0 +1,342 @@
+#include <net/bluetooth/hci_core.h>
+#include <linux/list.h>
+
+/*
+ * Realtek - For coexistence
+ */
+#define BTRTL_HCIUSB    0
+#define BTRTL_HCIUART   1
+
+#define BTRTL_HCI_IF    BTRTL_HCIUART
+
+#define TRUE                1
+#define FALSE               0
+
+#define CONNECT_PORT        30001
+#define CONNECT_PORT_WIFI   30000
+
+#define invite_req          "INVITE_REQ"
+#define invite_rsp          "INVITE_RSP"
+#define attend_req          "ATTEND_REQ"
+#define attend_ack          "ATTEND_ACK"
+#define wifi_leave          "WIFI_LEAVE"
+#define leave_ack           "LEAVE_ACK"
+#define bt_leave            "BT_LEAVE"
+
+#define HCI_OP_PERIODIC_INQ		0x0403
+#define HCI_EV_LE_META			                        0x3e
+#define HCI_EV_LE_CONN_COMPLETE		                    0x01
+#define HCI_EV_LE_CONN_UPDATE_COMPLETE	                0x03
+
+//vendor cmd to fw
+#define HCI_VENDOR_ENABLE_PROFILE_REPORT_COMMAND        0xfc18
+#define HCI_VENDOR_SET_PROFILE_REPORT_COMMAND           0xfc19
+#define HCI_VENDOR_MAILBOX_CMD                          0xfc8f
+#define HCI_VENDOR_SET_BITPOOL				0xfc51
+
+//subcmd to fw
+#define HCI_VENDOR_SUB_CMD_WIFI_CHANNEL_AND_BANDWIDTH_CMD   0x11
+#define HCI_VENDOR_SUB_CMD_WIFI_FORCE_TX_POWER_CMD          0x17
+#define HCI_VENDOR_SUB_CMD_BT_ENABLE_IGNORE_WLAN_ACT_CMD    0x1B
+#define HCI_VENDOR_SUB_CMD_BT_REPORT_CONN_SCO_INQ_INFO      0x23
+#define HCI_VENDOR_SUB_CMD_BT_AUTO_REPORT_STATUS_INFO       0x27
+#define HCI_VENDOR_SUB_CMD_BT_AUTO_REPORT_ENABLE            0x28
+#define HCI_VENDOR_SUB_CMD_BT_SET_TXRETRY_REPORT_PARAM      0x29
+#define HCI_VENDOR_SUB_CMD_BT_SET_PTATABLE                  0x2A
+#define HCI_VENDOR_SUB_CMD_SET_BT_PSD_MODE                  0x31
+#define HCI_VENDOR_SUB_CMD_SET_BT_LNA_CONSTRAINT            0x32
+#define HCI_VENDOR_SUB_CMD_GET_AFH_MAP_L                    0x40
+#define HCI_VENDOR_SUB_CMD_GET_AFH_MAP_M                    0x41
+#define HCI_VENDOR_SUB_CMD_GET_AFH_MAP_H                    0x42
+#define HCI_VENDOR_SUB_CMD_RD_REG_REQ                       0x43
+#define HCI_VENDOR_SUB_CMD_WR_REG_REQ                       0x44
+
+#define HCI_EV_VENDOR_SPECIFIC      0xff
+
+//sub event from fw start
+#define HCI_VENDOR_PTA_REPORT_EVENT         0x24
+#define HCI_VENDOR_PTA_AUTO_REPORT_EVENT    0x25
+
+//vendor cmd to wifi driver
+#define HCI_GRP_VENDOR_SPECIFIC             (0x3f << 10)
+#define HCI_OP_HCI_EXTENSION_VERSION_NOTIFY (0x0100 | HCI_GRP_VENDOR_SPECIFIC)
+#define HCI_OP_BT_OPERATION_NOTIFY          (0x0102 | HCI_GRP_VENDOR_SPECIFIC)
+#define HCI_OP_HCI_BT_INFO_NOTIFY           (0x0106 | HCI_GRP_VENDOR_SPECIFIC)
+#define HCI_OP_HCI_BT_COEX_NOTIFY           (0x0107 | HCI_GRP_VENDOR_SPECIFIC)
+#define HCI_OP_HCI_BT_PATCH_VER_NOTIFY      (0x0108 | HCI_GRP_VENDOR_SPECIFIC)
+#define HCI_OP_HCI_BT_AFH_MAP_NOTIFY        (0x0109 | HCI_GRP_VENDOR_SPECIFIC)
+#define HCI_OP_HCI_BT_REGISTER_VALUE_NOTIFY (0x010a | HCI_GRP_VENDOR_SPECIFIC)
+
+//bt info reason to wifi
+/*Host response when receive the BT Info Control Event*/
+#define HOST_RESPONSE                   0
+/*The BT Info response for polling by BT firmware.*/
+#define POLLING_RESPONSE                1
+/*BT auto report by BT firmware.*/
+#define AUTO_REPORT                     2
+/*Stack report when BT firmware is under power save state(ex:D2)*/
+#define STACK_REPORT_WHILE_DEVICE_D2    3
+
+// vendor event from wifi
+#define RTK_HS_EXTENSION_EVENT_WIFI_SCAN            0x01
+#define RTK_HS_EXTENSION_EVENT_RADIO_STATUS_NOTIFY  0x02
+#define RTK_HS_EXTENSION_EVENT_HCI_BT_INFO_CONTROL  0x03
+#define RTK_HS_EXTENSION_EVENT_HCI_BT_COEX_CONTROL  0x04
+
+//op code from wifi
+#define BT_PATCH_VERSION_QUERY      0x00
+#define IGNORE_WLAN_ACTIVE_CONTROL  0x01
+#define LNA_CONSTRAIN_CONTROL       0x02
+#define BT_POWER_DECREASE_CONTROL   0x03
+#define BT_PSD_MODE_CONTROL         0x04
+#define WIFI_BW_CHNL_NOTIFY         0x05
+#define QUERY_BT_AFH_MAP            0x06
+#define BT_REGISTER_ACCESS          0x07
+
+//bt operation to notify
+#define BT_OPCODE_NONE                  0
+#define BT_OPCODE_INQUIRY_START         1
+#define BT_OPCODE_INQUIRY_END           2
+#define BT_OPCODE_PAGE_START            3
+#define BT_OPCODE_PAGE_SUCCESS_END      4
+#define BT_OPCODE_PAGE_UNSUCCESS_END    5
+#define BT_OPCODE_PAIR_START            6
+#define BT_OPCODE_PAIR_END              7
+#define BT_OPCODE_ENABLE_BT             8
+#define BT_OPCODE_DISABLE_BT            9
+
+#define HCI_EXTENSION_VERSION           0x0004
+#define HCI_CMD_PREAMBLE_SIZE           3
+#define PAN_PACKET_COUNT                5
+
+#define STREAM_TO_UINT16(u16, p)\
+	{u16 = ((uint16_t)(*(p)) + (((uint16_t)(*((p) + 1))) << 8)); (p) += 2; }
+#define UINT16_TO_STREAM(p, u16)\
+	{*(p)++ = (uint8_t)(u16); *(p)++ = (uint8_t)((u16) >> 8); }
+
+#define PSM_SDP     0x0001
+#define PSM_RFCOMM  0x0003
+#define PSM_PAN     0x000F
+#define PSM_HID     0x0011
+#define PSM_HID_INT 0x0013
+#define PSM_AVCTP   0x0017
+#define PSM_AVDTP   0x0019
+#define PSM_FTP     0x1001
+#define PSM_BIP     0x1003
+#define PSM_OPP     0x1015
+//--add more if needed--//
+
+enum {
+	profile_sco = 0,
+	profile_hid = 1,
+	profile_a2dp = 2,
+	profile_pan = 3,
+	profile_hid_interval = 4,
+	profile_hogp = 5,
+	profile_voice = 6,
+	profile_max = 7
+};
+
+//profile info data
+typedef struct {
+	struct list_head list;
+	uint16_t handle;
+	uint16_t psm;
+	uint16_t dcid;
+	uint16_t scid;
+	uint8_t profile_index;
+} rtk_prof_info, *prtk_prof_info;
+
+//profile info for each connection
+typedef struct rtl_hci_conn {
+	struct list_head list;
+	uint16_t handle;
+	uint8_t type;		// 0:l2cap, 1:sco/esco, 2:le
+	uint8_t profile_bitmap;
+	int8_t profile_refcount[8];
+} rtk_conn_prof, *prtk_conn_prof;
+
+struct rtl_btinfo {
+	u8 cmd;
+	u8 len;
+	u8 data[6];
+};
+#define RTL_BTINFO_LEN	(sizeof(struct rtl_btinfo))
+/* typedef struct {
+ *	uint8_t cmd_index;
+ *	uint8_t cmd_length;
+ *	uint8_t link_status;
+ *	uint8_t retry_cnt;
+ *	uint8_t rssi;
+ *	uint8_t mailbox_info;
+ *	uint16_t acl_throughput;
+ * } hci_linkstatus_report;
+ */
+
+typedef struct {
+	uint8_t type;
+	uint32_t offset;
+	uint32_t value;
+} hci_mailbox_register;
+
+struct rtl_btinfo_ctl {
+	uint8_t polling_enable;
+	uint8_t polling_time;
+	uint8_t autoreport_enable;
+};
+
+#define MAX_LEN_OF_HCI_EV	32
+#define NUM_RTL_HCI_EV		32
+struct rtl_hci_ev {
+	__u8 data[MAX_LEN_OF_HCI_EV];
+	__u16 len;
+	struct list_head list;
+};
+
+#define L2_MAX_SUBSEC_LEN	128
+#define L2_MAX_PKTS	16
+struct rtl_l2_buff {
+	__u8 data[L2_MAX_SUBSEC_LEN];
+	__u16 len;
+	__u16 out;
+	struct list_head list;
+};
+
+struct rtl_coex_struct {
+	struct list_head conn_hash;	//hash for connections
+	struct list_head profile_list;	//hash for profile info
+	struct hci_dev *hdev;
+	struct socket *udpsock;
+	struct sockaddr_in addr;
+	struct sockaddr_in wifi_addr;
+	struct timer_list polling_timer;
+	struct timer_list a2dp_count_timer;
+	struct timer_list pan_count_timer;
+	struct timer_list hogp_count_timer;
+	struct workqueue_struct *sock_wq;
+	struct workqueue_struct *fw_wq;
+	struct delayed_work sock_work;
+	struct delayed_work fw_work;
+	struct delayed_work l2_work;
+	struct sock *sk;
+	struct urb *urb;
+	spinlock_t spin_lock_sock;
+	spinlock_t spin_lock_profile;
+	uint32_t a2dp_packet_count;
+	uint32_t pan_packet_count;
+	uint32_t hogp_packet_count;
+	uint32_t voice_packet_count;
+	uint8_t profile_bitmap;
+	uint8_t profile_status;
+	int8_t profile_refcount[8];
+	uint8_t ispairing;
+	uint8_t isinquirying;
+	uint8_t ispaging;
+	uint8_t wifi_state;
+	uint8_t autoreport;
+	uint8_t polling_enable;
+	uint8_t polling_interval;
+	uint8_t piconet_id;
+	uint8_t mode;
+	uint8_t afh_map[10];
+	uint16_t hci_reversion;
+	uint16_t lmp_subversion;
+	uint8_t wifi_on;
+	uint8_t sock_open;
+	unsigned long cmd_last_tx;
+
+	/* hci ev buff */
+	struct list_head ev_used_list;
+	struct list_head ev_free_list;
+
+	spinlock_t rxlock;
+	__u8 pkt_type;
+	__u16 expect;
+	struct sk_buff *evt_skb;
+
+	/* l2cap rx buff */
+	struct list_head l2_used_list;
+	struct list_head l2_free_list;
+
+	/* buff addr and size */
+	spinlock_t buff_lock;
+	unsigned long pages_addr;
+	unsigned long buff_size;
+
+#define RTL_COEX_RUNNING	(1 << 0)
+	unsigned long flags;
+
+};
+
+/* #if __BYTE_ORDER == __LITTLE_ENDIAN */
+/* Little endian */
+struct sbc_frame_hdr {
+	uint8_t syncword:8;		/* Sync word */
+	uint8_t subbands:1;		/* Subbands */
+	uint8_t allocation_method:1;	/* Allocation method */
+	uint8_t channel_mode:2;		/* Channel mode */
+	uint8_t blocks:2;		/* Blocks */
+	uint8_t sampling_frequency:2;	/* Sampling frequency */
+	uint8_t bitpool:8;		/* Bitpool */
+	uint8_t crc_check:8;		/* CRC check */
+} __attribute__ ((packed));
+
+/* NOTE: The code is copied from pa.
+ * only the bit field in 8-bit is affected by endian, not the 16-bit or 32-bit.
+ * why?
+ */
+struct rtp_header {
+	unsigned cc:4;
+	unsigned x:1;
+	unsigned p:1;
+	unsigned v:2;
+
+	unsigned pt:7;
+	unsigned m:1;
+
+	uint16_t sequence_number;
+	uint32_t timestamp;
+	uint32_t ssrc;
+	uint32_t csrc[0];
+} __attribute__ ((packed));
+
+/* #elif __BYTE_ORDER == __BIG_ENDIAN
+ * struct sbc_frame_hdr {
+ *	uint8_t syncword;
+ *	uint8_t sampling_frequency:2;
+ *	uint8_t blocks:2;
+ *	uint8_t channel_mode:2;
+ *	uint8_t allocation_method:1;
+ *	uint8_t subbands:1;
+ *	uint8_t bitpool:8;
+ *	uint8_t crc_check:8;
+ * } __attribute__ ((packed));
+ *
+ * struct rtp_header {
+ *	unsigned v:2;
+ *	unsigned p:1;
+ *	unsigned x:1;
+ *	unsigned cc:4;
+ *
+ *	unsigned m:1;
+ *	unsigned pt:7;
+ *
+ *	uint16_t sequence_number;
+ *	uint32_t timestamp;
+ *	uint32_t ssrc;
+ *	uint32_t csrc[0];
+ * } __attribute__ ((packed));
+ *
+ * #endif
+ */
+
+void rtk_btcoex_parse_event(uint8_t *buffer, int count);
+void rtk_btcoex_parse_cmd(uint8_t *buffer, int count);
+void rtk_btcoex_parse_l2cap_data_tx(uint8_t *buffer, int count);
+void rtk_btcoex_parse_l2cap_data_rx(uint8_t *buffer, int count);
+
+void rtk_btcoex_open(struct hci_dev *hdev);
+void rtk_btcoex_close(void);
+void rtk_btcoex_probe(struct hci_dev *hdev);
+void rtk_btcoex_init(void);
+void rtk_btcoex_exit(void);
diff --git a/drivers/bluetooth/rtk_rfkill.c b/drivers/bluetooth/rtk_rfkill.c
new file mode 100755
index 00000000..ceacecc
--- /dev/null
+++ b/drivers/bluetooth/rtk_rfkill.c
@@ -0,0 +1,146 @@
+/*
+ * Copyright (C) 2011 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/delay.h>
+#include <linux/device.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/rfkill.h>
+#include <linux/gpio.h>
+#include <linux/ioport.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+
+
+static struct rfkill *bt_rfk;
+static const char bt_name[] = "bluetooth";
+static  int bt_reset;
+
+static int bluetooth_set_power(void *data, bool blocked)
+{
+	pr_info("%s: block=%d\n", __func__, blocked);
+
+	if (!blocked)
+		gpio_direction_output(bt_reset, 1);
+	else
+		gpio_direction_output(bt_reset, 0);
+
+	return 0;
+}
+
+static struct rfkill_ops rfkill_bluetooth_ops = {
+	.set_block = bluetooth_set_power,
+};
+
+static void rfkill_gpio_init(struct device_node *rtk119x_bt_node)
+{
+	/*initial gpios*/
+	/* get gpio number from device tree*/
+	bt_reset = of_get_gpio_flags(rtk119x_bt_node, 0, NULL);
+
+	if (bt_reset < 0)
+		pr_err("[%s ] could not get gpio from of\n", __func__);
+
+	if (!gpio_is_valid(bt_reset))	/*check whether gpio number is valid*/
+		pr_err("[%s ] gpio %d is not valid\n", __func__, bt_reset);
+
+	if (gpio_request(bt_reset, rtk119x_bt_node->name)) /*request gpio*/
+		pr_err("[%s ] could not request gpio, %d\n",
+					__func__, bt_reset);
+}
+
+static void rfkill_gpio_deinit(void)
+{
+	gpio_free(bt_reset);
+}
+static int rfkill_bluetooth_probe(struct platform_device *pdev)
+{
+
+	int rc = 0;
+	bool default_state = true;
+	struct device_node *rtk119x_bt_node;
+
+	rtk119x_bt_node = pdev->dev.of_node;
+
+	pr_info("-->%s\n", __func__);
+
+	bt_rfk = rfkill_alloc(bt_name, &pdev->dev, RFKILL_TYPE_BLUETOOTH,
+	   &rfkill_bluetooth_ops, NULL);
+	if (!bt_rfk) {
+		rc = -ENOMEM;
+		goto err_rfkill_alloc;
+	}
+	rfkill_gpio_init(rtk119x_bt_node);
+	/* userspace cannot take exclusive control */
+	rfkill_init_sw_state(bt_rfk, false);
+	rc = rfkill_register(bt_rfk);
+	if (rc)
+		goto err_rfkill_reg;
+
+	rfkill_set_sw_state(bt_rfk, true);
+	bluetooth_set_power(NULL, default_state);
+
+	pr_info("<--%s\n", __func__);
+	return 0;
+
+err_rfkill_reg:
+	rfkill_destroy(bt_rfk);
+err_rfkill_alloc:
+	return rc;
+}
+
+static int rfkill_bluetooth_remove(struct platform_device *dev)
+{
+	pr_info("-->%s\n", __func__);
+	rfkill_gpio_deinit();
+	rfkill_unregister(bt_rfk);
+	rfkill_destroy(bt_rfk);
+	pr_info("<--%s\n", __func__);
+	return 0;
+}
+static const struct of_device_id rtk119x_bt_ids[] = {
+	{ .compatible = "realtek,rfkill" },
+	{ /* Sentinel */ },
+};
+static struct platform_driver rfkill_bluetooth_driver = {
+	.probe  = rfkill_bluetooth_probe,
+	.remove = rfkill_bluetooth_remove,
+	.driver = {
+		.name = "rfkill",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk119x_bt_ids,
+	},
+};
+
+static int __init rfkill_bluetooth_init(void)
+{
+	pr_info("-->%s\n", __func__);
+	return platform_driver_register(&rfkill_bluetooth_driver);
+}
+
+static void __exit rfkill_bluetooth_exit(void)
+{
+	pr_info("-->%s\n", __func__);
+	platform_driver_unregister(&rfkill_bluetooth_driver);
+}
+
+late_initcall(rfkill_bluetooth_init);
+module_exit(rfkill_bluetooth_exit);
+MODULE_DESCRIPTION("bluetooth rfkill");
+MODULE_AUTHOR("rs <wn@realsil.com.cn>");
+MODULE_LICENSE("GPL");
+
diff --git a/drivers/char/hw_random/Kconfig b/drivers/char/hw_random/Kconfig
index 200dab5..c1c52c4 100644
--- a/drivers/char/hw_random/Kconfig
+++ b/drivers/char/hw_random/Kconfig
@@ -423,6 +423,14 @@ config HW_RANDOM_CAVIUM
 
          If unsure, say Y.
 
+
+config HW_RANDOM_REALTEK
+        tristate "Realtek Random Number Generator support"
+        depends on HW_RANDOM 
+        ---help---
+          Say Y, if you want to enable hw rng feature on Realtek platform.
+
+
 endif # HW_RANDOM
 
 config UML_RANDOM
diff --git a/drivers/char/hw_random/Makefile b/drivers/char/hw_random/Makefile
index 5f52b1e..1373aca 100644
--- a/drivers/char/hw_random/Makefile
+++ b/drivers/char/hw_random/Makefile
@@ -36,3 +36,4 @@ obj-$(CONFIG_HW_RANDOM_STM32) += stm32-rng.o
 obj-$(CONFIG_HW_RANDOM_PIC32) += pic32-rng.o
 obj-$(CONFIG_HW_RANDOM_MESON) += meson-rng.o
 obj-$(CONFIG_HW_RANDOM_CAVIUM) += cavium-rng.o cavium-rng-vf.o
+obj-$(CONFIG_HW_RANDOM_REALTEK) += rtd-rng.o
diff --git a/drivers/char/hw_random/rtd-rng.c b/drivers/char/hw_random/rtd-rng.c
new file mode 100644
index 00000000..e67aaf9
--- /dev/null
+++ b/drivers/char/hw_random/rtd-rng.c
@@ -0,0 +1,225 @@
+/**
+ * Copyright (c) 2015-2016 Realtek. All rights reserved.
+ *
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License ("GPL")
+ * version 2, as published by the Free Software Foundation.
+ */
+
+#include <linux/hw_random.h>
+#include <linux/io.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/platform_device.h>
+#include <linux/delay.h>
+
+#define MAX_1MS_TO_CNT          1000
+
+#define TRNG_REG_BASE           0
+
+#if defined(CONFIG_ARCH_RTD129x)
+
+#define RNG_CALI_CHK            (TRNG_REG_BASE + 0x18)
+#define RNG_ANA                 (TRNG_REG_BASE + 0x14)
+#define RNG_CALI_RETURN         (TRNG_REG_BASE + 0x20)
+#define RNG_LOCK_CHK            (TRNG_REG_BASE + 0x24)
+#define RNG_RETURN3             (TRNG_REG_BASE + 0x2c)
+#define RNG_RETURN4             (TRNG_REG_BASE + 0x30)
+#define RNG_RESULTR             (TRNG_REG_BASE + 0x38)
+#define RNG_DUMMY               (TRNG_REG_BASE + 0x44)
+
+#define RNG_OUT_READY		RNG_RETURN3      
+
+#elif defined(CONFIG_ARCH_RTD139x)
+
+#define RNG_CTRL		(TRNG_REG_BASE + 0x00)
+#define RNG_CALI_CHK            (TRNG_REG_BASE + 0x08)
+#define RNG_ANA                 (TRNG_REG_BASE + 0x04)
+#define RNG_CALI_RETURN         (TRNG_REG_BASE + 0x10)
+#define RNG_LOCK_CHK            (TRNG_REG_BASE + 0x14)
+#define RNG_RETURN3             (TRNG_REG_BASE + 0x1c)
+#define RNG_RETURN4             (TRNG_REG_BASE + 0x20)
+#define RNG_RESULTR             (TRNG_REG_BASE + 0x28)
+#define RNG_DUMMY               (TRNG_REG_BASE + 0x34)
+#define RNG_ST              	(TRNG_REG_BASE + 0x3c)
+
+#define RNG_OUT_READY		RNG_RETURN3      
+
+#elif defined(CONFIG_ARCH_RTD16xx)
+
+#define RNG_CTRL		(TRNG_REG_BASE + 0x00)
+#define RNG_CALI_CHK            (TRNG_REG_BASE + 0x08)
+#define RNG_ANALOG              (TRNG_REG_BASE + 0x04)
+#define RNG_CALI_CTRL           (TRNG_REG_BASE + 0x0c)
+#define RNG_CALI_RETURN0        (TRNG_REG_BASE + 0x10)
+#define RNG_LOCK_CHK            (TRNG_REG_BASE + 0x14)
+#define RNG_RETURN0             (TRNG_REG_BASE + 0x1c)
+#define RNG_RETURN1             (TRNG_REG_BASE + 0x20)
+#define RNG_RETURN2             (TRNG_REG_BASE + 0x24)
+#define RNG_RESULTR             (TRNG_REG_BASE + 0x28)
+#define RNG_DUMMY               (TRNG_REG_BASE + 0x34)
+#define RNG_ST              	(TRNG_REG_BASE + 0x3c)
+
+#define RNG_OUT_READY		RNG_RETURN0           
+
+#elif defined(CONFIG_ARCH_RTD13xx)
+
+#define RNG_CTRL		(TRNG_REG_BASE + 0x00)
+#define RNG_CALI_CHK            (TRNG_REG_BASE + 0x08)
+#define RNG_ANALOG              (TRNG_REG_BASE + 0x04)
+#define RNG_CALI_CTRL           (TRNG_REG_BASE + 0x0c)
+#define RNG_CALI_RETURN0        (TRNG_REG_BASE + 0x10)
+#define RNG_LOCK_CHK            (TRNG_REG_BASE + 0x14)
+#define RNG_RETURN6             (TRNG_REG_BASE + 0xc00)
+#define RNG_RETURN7             (TRNG_REG_BASE + 0xc04)
+#define RNG_RETURN8             (TRNG_REG_BASE + 0xc08)
+#define RNG_RESULTR             (TRNG_REG_BASE + 0xc0c)
+#define RNG_DUMMY               (TRNG_REG_BASE + 0x34)
+#define RNG_ST              	(TRNG_REG_BASE + 0x3c)
+
+#define RNG_OUT_READY		RNG_RETURN6           
+
+#endif 
+
+static int rtd_rng_read(struct hwrng *rng, void *buf, size_t max,
+                               bool wait)
+{
+        void __iomem *rng_base = (void __iomem *)rng->priv;
+        unsigned int tocnt=0;
+
+        while (!(__raw_readl(rng_base + RNG_OUT_READY) & 0x1)) {
+                if (!wait || tocnt++ > MAX_1MS_TO_CNT){
+			pr_err("**************************%s timeout******************** \n", __func__);
+                        return 0;
+		}
+                cpu_relax();
+        }
+        *(u32 *)buf = __raw_readl(rng_base + RNG_RESULTR);
+        return sizeof(u32);
+}
+
+static int rtd_rng_init(struct hwrng *rng)
+{
+        void __iomem *rng_base = (void __iomem *)rng->priv;
+        pr_info("%s %d\n", __func__, __LINE__);
+
+#if defined(CONFIG_ARCH_RTD129x)
+        __raw_writel(0xd8000220, rng_base + RNG_CALI_CHK);
+        __raw_writel(0xd8000220, rng_base + RNG_LOCK_CHK);
+        __raw_writel(0x00008891, rng_base + RNG_ANA);
+#elif defined(CONFIG_ARCH_RTD139x)
+	__raw_writel(0x00001000, rng_base + RNG_CTRL);
+	__raw_writel(0x24a524a4, rng_base + RNG_CALI_CHK);
+        __raw_writel(0x300021c0, rng_base + RNG_LOCK_CHK);
+        __raw_writel(0x00008b91, rng_base + RNG_ANA);
+	__raw_writel(0x00014062, rng_base + RNG_ST);
+#elif defined(CONFIG_ARCH_RTD16xx)
+	__raw_writel(0x00008000, rng_base + RNG_CTRL);
+	__raw_writel(0x010c1041, rng_base + RNG_CALI_CTRL);
+	__raw_writel(0x24a524a4, rng_base + RNG_CALI_CHK);
+        __raw_writel(0x300021c0, rng_base + RNG_LOCK_CHK);
+        __raw_writel(0x00008b91, rng_base + RNG_ANALOG); 
+#elif defined(CONFIG_ARCH_RTD13xx)
+	__raw_writel(0x00008000, rng_base + RNG_CTRL);
+	__raw_writel(0x010c1041, rng_base + RNG_CALI_CTRL);
+	__raw_writel(0x24a524a4, rng_base + RNG_CALI_CHK);
+        __raw_writel(0x300021c0, rng_base + RNG_LOCK_CHK);
+        __raw_writel(0x00008a91, rng_base + RNG_ANALOG); 
+
+#endif
+	msleep(2);
+        return 0;
+}
+
+static struct hwrng rtd_rng_ops = {
+        .name   = "rtd",
+        .init   = rtd_rng_init,
+        .read   = rtd_rng_read,
+	.quality = 1000,
+};
+
+static int rtd_rng_probe(struct platform_device *pdev)
+{
+        struct device *dev = &pdev->dev;
+        struct device_node *np = dev->of_node;
+        void __iomem *rng_base;
+        int err;
+
+        /* map peripheral */
+        rng_base = of_iomap(np, 0);
+        if (!rng_base) {
+                dev_err(dev, "failed to remap rng regs");
+                return -ENODEV;
+        }
+        rtd_rng_ops.priv = (unsigned long)rng_base;
+
+
+
+        /* register driver */
+	err = hwrng_register(&rtd_rng_ops);
+        if (err) {
+                dev_err(dev, "hwrng registration failed\n");
+                iounmap(rng_base);
+                rtd_rng_ops.priv = (unsigned long)0;
+        } else
+                dev_info(dev, "hwrng registered\n");
+
+        return err;
+}
+
+static int rtd_rng_remove(struct platform_device *pdev)
+{
+        void __iomem *rng_base = (void __iomem *)rtd_rng_ops.priv;
+
+
+        /* unregister driver */
+        hwrng_unregister(&rtd_rng_ops);
+        iounmap(rng_base);
+
+        return 0;
+}
+#ifdef CONFIG_PM
+static int rtd_rng_suspend(struct device *dev)
+{
+        return 0;
+}
+
+static int rtd_rng_resume(struct device *dev)
+{
+        if (rtd_rng_ops.priv)
+                rtd_rng_init(&rtd_rng_ops);
+        return 0;
+}
+
+static const struct dev_pm_ops rtd_rng_pm_ops = {
+        .suspend        = rtd_rng_suspend,
+        .resume         = rtd_rng_resume,
+};
+#endif /* CONFIG_PM */
+
+static const struct of_device_id rtd_rng_of_match[] = {
+        { .compatible = "Realtek,rtk-rng", },
+        {},
+};
+MODULE_DEVICE_TABLE(of, rtd_rng_of_match);
+
+static struct platform_driver rtd_rng_driver = {
+        .driver         = {
+                .name = "rtd-rng",
+                .of_match_table = rtd_rng_of_match,
+#ifdef CONFIG_PM
+                .pm             = &rtd_rng_pm_ops,
+#endif /* CONFIG_PM */
+        },
+        .probe          = rtd_rng_probe,
+        .remove         = rtd_rng_remove,
+};
+module_platform_driver(rtd_rng_driver);
+
+MODULE_AUTHOR("Cy Huang");
+MODULE_DESCRIPTION("RTD129x/139x/16xx/13xx Random Number Generator (RNG) driver");
+MODULE_LICENSE("GPL v2");
+
diff --git a/drivers/char/ipmi/ipmi_poweroff.c b/drivers/char/ipmi/ipmi_poweroff.c
index 9f2e3be..676c910 100644
--- a/drivers/char/ipmi/ipmi_poweroff.c
+++ b/drivers/char/ipmi/ipmi_poweroff.c
@@ -66,7 +66,7 @@
 /* Holds the old poweroff function so we can restore it on removal. */
 static void (*old_poweroff_func)(void);
 
-static int set_param_ifnum(const char *val, struct kernel_param *kp)
+static int set_param_ifnum(const char *val, const struct kernel_param *kp)
 {
 	int rv = param_set_int(val, kp);
 	if (rv)
diff --git a/drivers/char/ipmi/ipmi_si_intf.c b/drivers/char/ipmi/ipmi_si_intf.c
index e0a5315..89adeb4 100644
--- a/drivers/char/ipmi/ipmi_si_intf.c
+++ b/drivers/char/ipmi/ipmi_si_intf.c
@@ -1344,7 +1344,7 @@ static void set_maintenance_mode(void *send_info, bool enable)
 #define IPMI_MEM_ADDR_SPACE 1
 static const char * const addr_space_to_str[] = { "i/o", "mem" };
 
-static int hotmod_handler(const char *val, struct kernel_param *kp);
+static int hotmod_handler(const char *val, const struct kernel_param *kp);
 
 module_param_call(hotmod, hotmod_handler, NULL, NULL, 0200);
 MODULE_PARM_DESC(hotmod, "Add and remove interfaces.  See"
@@ -1814,7 +1814,7 @@ static struct smi_info *smi_info_alloc(void)
 	return info;
 }
 
-static int hotmod_handler(const char *val, struct kernel_param *kp)
+static int hotmod_handler(const char *val, const struct kernel_param *kp)
 {
 	char *str = kstrdup(val, GFP_KERNEL);
 	int  rv;
diff --git a/drivers/clk/Kconfig b/drivers/clk/Kconfig
index 6a8ac04..2afc6ff 100644
--- a/drivers/clk/Kconfig
+++ b/drivers/clk/Kconfig
@@ -210,5 +210,6 @@ source "drivers/clk/sunxi-ng/Kconfig"
 source "drivers/clk/tegra/Kconfig"
 source "drivers/clk/ti/Kconfig"
 source "drivers/clk/uniphier/Kconfig"
+source "drivers/clk/realtek/Kconfig"
 
 endmenu
diff --git a/drivers/clk/Makefile b/drivers/clk/Makefile
index 42042c0..26960f0 100644
--- a/drivers/clk/Makefile
+++ b/drivers/clk/Makefile
@@ -92,3 +92,4 @@ obj-$(CONFIG_X86)			+= x86/
 endif
 obj-$(CONFIG_ARCH_ZX)			+= zte/
 obj-$(CONFIG_ARCH_ZYNQ)			+= zynq/
+obj-$(CONFIG_COMMON_CLK_REALTEK)	+= realtek/
diff --git a/drivers/clk/realtek/Kconfig b/drivers/clk/realtek/Kconfig
new file mode 100644
index 00000000..d2d980f
--- /dev/null
+++ b/drivers/clk/realtek/Kconfig
@@ -0,0 +1,58 @@
+config COMMON_CLK_REALTEK
+	bool "Clock driver for realtek"
+	select RTK_MMIO
+	select RESET_CONTROLLER
+
+config CLK_PLL_PSAUD
+	bool
+
+config CLK_PLL_DIF
+	bool
+
+config RESET_PLATFORM
+	bool
+
+config COMMON_CLK_RTD119X
+	bool "Clock driver for RTD119x"
+	depends on ARCH_RTD119X
+	select COMMON_CLK_REALTEK
+	default y
+
+config COMMON_CLK_RTD129X
+	bool "Clock driver for RTD129x"
+	depends on ARCH_RTD129x
+	select COMMON_CLK_REALTEK
+	default y
+
+config COMMON_CLK_RTD139X
+	bool "Clock driver for RTD139x"
+	depends on ARCH_RTD139x
+	select COMMON_CLK_REALTEK
+	default y
+
+config COMMON_CLK_RTD16XX
+	bool "Clock driver for RTD16xx"
+	depends on ARCH_RTD16xx
+	select COMMON_CLK_REALTEK
+	select CLK_PLL_PSAUD
+	select CLK_PLL_DIF
+	select RESET_PLATFORM
+	select RTK_MMIO_SECURE_RTD16XX_GENERIC_CRT
+	default y
+
+config COMMON_CLK_RTD13XX
+	bool "Clock driver for RTD13xx"
+	depends on ARCH_RTD13xx
+	select COMMON_CLK_REALTEK
+	select CLK_PLL_PSAUD
+	select CLK_PLL_DIF
+	select RESET_PLATFORM
+	select RTK_MMIO_SECURE_RTD13XX_GENERIC_CRT
+	default y
+
+config COMMON_CLK_REALTEK_TEE
+	bool "Clock Driver to Control PLL SCPU over TEE"
+	depends on TEE
+	default n
+	help
+	  PLL BUS/DCSB would be fixed when enable this.
diff --git a/drivers/clk/realtek/Makefile b/drivers/clk/realtek/Makefile
new file mode 100644
index 00000000..ac5225c
--- /dev/null
+++ b/drivers/clk/realtek/Makefile
@@ -0,0 +1,34 @@
+ccflags-y += -I$(src)/include
+ccflags-$(CONFIG_COMMON_CLK_RTD119X) += -I$(src)/include/rtd119x/
+ccflags-$(CONFIG_COMMON_CLK_RTD129X) += -I$(src)/include/rtd129x/
+ccflags-$(CONFIG_COMMON_CLK_RTD139X) += -I$(src)/include/rtd139x/
+ccflags-$(CONFIG_COMMON_CLK_RTD16XX) += -I$(src)/include/rtd16xx/
+ccflags-$(CONFIG_COMMON_CLK_RTD13XX) += -I$(src)/include/rtd13xx/
+
+obj-$(CONFIG_COMMON_CLK_REALTEK) += clk-rtk.o
+
+clk-rtk-y += common.o
+clk-rtk-y += clk-notify.o
+clk-rtk-y += clk-mmio-mux.o
+clk-rtk-y += clk-mmio-gate.o
+clk-rtk-y += cgc.o
+clk-rtk-y += clk-pll.o
+clk-rtk-y += cc-platform.o
+clk-rtk-$(CONFIG_CLK_PLL_PSAUD) += clk-pll-psaud.o
+clk-rtk-$(CONFIG_CLK_PLL_DIF) += clk-pll-dif.o
+clk-rtk-y += reset.o
+clk-rtk-$(CONFIG_RESET_PLATFORM) += reset-platform.o
+
+clk-rtk-$(CONFIG_COMMON_CLK_RTD119X) += cc-rtd119x.o
+
+clk-rtk-$(CONFIG_COMMON_CLK_RTD129X) += cc-rtd129x.o
+
+clk-rtk-$(CONFIG_COMMON_CLK_RTD139X) += cc-rtd139x.o
+
+clk-rtk-$(CONFIG_COMMON_CLK_RTD16XX) += cc-rtd16xx.o
+clk-rtk-$(CONFIG_COMMON_CLK_RTD16XX) += reset-rtd16xx.o
+
+clk-rtk-$(CONFIG_COMMON_CLK_RTD13XX) += cc-rtd13xx.o
+clk-rtk-$(CONFIG_COMMON_CLK_RTD13XX) += reset-rtd13xx.o
+
+clk-rtk-$(CONFIG_COMMON_CLK_REALTEK_TEE) += cc-tee.o
diff --git a/drivers/clk/realtek/cc-platform.c b/drivers/clk/realtek/cc-platform.c
new file mode 100644
index 00000000..032a406
--- /dev/null
+++ b/drivers/clk/realtek/cc-platform.c
@@ -0,0 +1,124 @@
+/*
+ * cc-platform.c - clock controller platform code
+ *
+ * Copyright (C) 2018-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/slab.h>
+#include <linux/platform_device.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/clk.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/bitops.h>
+#include <linux/pm.h>
+#include <soc/realtek/rtk_mmio.h>
+#include "common.h"
+
+static int cc_suspend(struct device *dev)
+{
+	int i;
+	struct cc_platform_data *ccd = dev_get_drvdata(dev);
+
+	dev_info(dev, "enter %s\n", __func__);
+
+	for (i = 0; i < ccd->clk_num; i++)
+		clk_pm_data_save(&ccd->pm_data[i]);
+
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static int cc_resume(struct device *dev)
+{
+	int i;
+	struct cc_platform_data *ccd = dev_get_drvdata(dev);
+
+	dev_info(dev, "enter %s\n", __func__);
+
+	for (i = ccd->clk_num - 1; i >= 0; i--)
+		clk_pm_data_restore(&ccd->pm_data[i]);
+
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+const struct dev_pm_ops cc_pm_ops = {
+	.suspend_noirq = cc_suspend,
+	.resume_noirq  = cc_resume,
+};
+
+struct cc_platform_data *devm_cc_alloc_platform_data(struct device *dev,
+						     int max_clk)
+{
+	struct cc_platform_data *ccd;
+
+	ccd = devm_kzalloc(dev, sizeof(*ccd), GFP_KERNEL);
+	if (!ccd)
+		return NULL;
+	ccd->clk_num = max_clk;
+	ccd->data.clk_num = max_clk;
+	ccd->data.clks = devm_kcalloc(dev, max_clk,
+		sizeof(*ccd->data.clks), GFP_KERNEL);
+	if (!ccd->data.clks)
+		return NULL;
+#ifdef CONFIG_PM
+	ccd->pm_data = devm_kcalloc(dev, max_clk,
+		sizeof(*ccd->pm_data), GFP_KERNEL);
+	if (!ccd->pm_data)
+		return NULL;
+#endif
+	return ccd;
+}
+
+int cc_probe_platform(struct platform_device *pdev,
+		      struct cc_platform_data *ccd,
+		      int (*init_cb)(struct device *dev))
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	void __iomem *reg;
+	struct regmap *regmap;
+	int offset = 0;
+	int ret;
+
+	if (!init_cb || !ccd)
+		return -EINVAL;
+
+	/* register access */
+	reg = of_iomap(np, 0);
+	regmap = of_get_rtk_mmio_regmap_with_offset(np, 0, &offset);
+	if (!reg && IS_ERR_OR_NULL(regmap))
+		return -EINVAL;
+	if (IS_ERR(regmap))
+		regmap = NULL;
+
+	ccd->init_data.reg = reg;
+	if (regmap) {
+		dev_info(dev, "use mmio regmap\n");
+		ccd->init_data.offset = offset;
+		ccd->init_data.regmap = regmap;
+	}
+
+	platform_set_drvdata(pdev, ccd);
+
+	ret = init_cb(dev);
+	if (ret)
+		dev_err(dev, "failed in %pF: %d\n", init_cb, ret);
+
+	ret = of_clk_add_provider(np, of_clk_src_onecell_get, &ccd->data);
+	if (ret)
+		dev_err(dev, "failed to add clk provider: %d\n", ret);
+
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
diff --git a/drivers/clk/realtek/cc-rtd119x.c b/drivers/clk/realtek/cc-rtd119x.c
new file mode 100644
index 00000000..9f47edb
--- /dev/null
+++ b/drivers/clk/realtek/cc-rtd119x.c
@@ -0,0 +1,399 @@
+/*
+ * cc-rtd119x.c - RTD119x clock controller
+ *
+ * Copyright (C) 2018-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/bitops.h>
+#include <linux/platform_device.h>
+#include "common.h"
+#include "clk-pll.h"
+#include "clk-mmio-gate.h"
+#include "clk-mmio-mux.h"
+#include "clk_regmap.h"
+#include <dt-bindings/clock/rtk,clock-rtd119x.h>
+
+#define DEFAULT_PARENT_OSC27M    (const char *[]){ "osc27M" }
+static DEFINE_SPINLOCK(clk_div_lock);
+
+#define NF_MASK    0x1FFFFC00
+#define MNO_MASK   0x030FF800
+#define MN_MASK    0x07FC0000
+
+#define CLK_PLL_TYPE_NF       \
+	(CLK_PLL_CONF_FREQ_LOC_CTL2)
+#define CLK_PLL_TYPE_MNO      \
+	(CLK_PLL_CONF_FREQ_LOC_CTL1 | CLK_PLL_CONF_POW_LOC_CTL2)
+#define CLK_PLL_TYPE_MN       \
+	(CLK_PLL_CONF_FREQ_LOC_CTL1 | CLK_PLL_CONF_POW_LOC_CTL3)
+
+#define _D(_rate, _div, _val) \
+{ \
+	.rate = _rate, \
+	.div = _div, \
+	.val = _val, \
+}
+
+#define _NF(_rate, _n, _f) \
+{ \
+	.rate = _rate, \
+	.mask = NF_MASK, \
+	.val = ((_n) << 21) | ((_f) << 10), \
+}
+
+#define _MNO(_rate, _m, _n, _o) \
+{ \
+	.rate = _rate, \
+	.mask = MNO_MASK, \
+	.val = ((_m) << 11) | ((_n) << 18) | ((_o) << 24), \
+}
+
+#define _MN(_rate, _m, _n) \
+{ \
+	.rate = _rate, .mask = MN_MASK, \
+	.val = ((_m) << 18) | ((_n) << 25), \
+}
+
+static const struct div_table scpu_div_tbl[] = {
+	_D(600000000, 1, SCPU_FREQ_DIV1),
+	_D(290000000, 2, SCPU_FREQ_DIV2),
+	_D(1,         4, SCPU_FREQ_DIV4),
+	DIV_TABLE_END
+};
+
+static const struct div_table scpu_div_tbl_rev2[] = {
+	_D(700000000, 1, SCPU_FREQ_DIV1),
+	_D(350000000, 2, SCPU_FREQ_DIV2),
+	_D(290000000, 4, SCPU_FREQ_DIV4),
+	DIV_TABLE_END
+};
+
+static const struct freq_table scpu_tbl[] = {
+	_NF(720000000,  25, 1364),
+	_NF(780000000,  27, 1820),
+	_NF(800000000,  28, 1290),
+	_NF(1000000000, 36,   75),
+	_NF(1160000000, 41, 1159),
+	_NF(1200000000, 43,  910),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_scpu = {
+	.div_offset = PLL_DIV,
+	.div_shift  = SCPU_FREQ_SEL_SHIFT,
+	.div_width  = SCPU_FREQ_SEL_WIDTH,
+	.div_tbl    = scpu_div_tbl_rev2,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_NF,
+		.pll_offset   = PLL_SCPU1,
+		.freq_tbl     = scpu_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_scpu",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+static const struct div_table bus_div_tbl[] = {
+	_D(250000000, 2, BUS_FREQ_DIV1),
+	_D(1,         4, BUS_FREQ_DIV2),
+	DIV_TABLE_END
+};
+
+static const struct freq_table bus_tbl[] = {
+	_MN(459000000, 15, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_bus = {
+	.div_offset = PLL_DIV,
+	.div_shift  = BUS_FREQ_SEL_SHIFT,
+	.div_width  = BUS_FREQ_SEL_WIDTH,
+	.div_tbl    = bus_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_MN,
+		.pll_offset   = PLL_BUS1,
+		.freq_tbl     = bus_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_bus",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+static struct clk_fixed_factor clk_sys = {
+	.div     = 1,
+	.mult    = 1,
+	.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sys",
+		.ops          = &clk_fixed_factor_ops,
+		.parent_names = (const char *[]){ "pll_bus" },
+		.num_parents  = 1,
+		.flags        = 0,
+	},
+};
+
+static const struct freq_table dcsb_tbl[] = {
+	_MN(351000000, 11, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_dcsb = {
+	.pll_offset   = PLL_DCSB1,
+	.freq_tbl     = dcsb_tbl,
+	.conf         = CLK_PLL_TYPE_MN,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_dcsb",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_IGNORE_UNUSED | CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_fixed_factor clk_sysh = {
+	.div     = 1,
+	.mult    = 1,
+	.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sysh",
+		.ops          = &clk_fixed_factor_ops,
+		.parent_names = (const char *[]){ "pll_dscb" },
+		.num_parents  = 1,
+		.flags        = CLK_SET_RATE_PARENT,
+	},
+};
+
+static const struct freq_table gpu_tbl[] = {
+	_MNO(378000000, 12, 0, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_gpu = {
+	.conf         = CLK_PLL_TYPE_MNO,
+	.pll_offset   = PLL_GPU1,
+	.freq_tbl     = gpu_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_gpu",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_composite_init_data clk_gpu_init = {
+	.mux_offset   = CLK_OFFSET_INVALID,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_GPU,
+	.parent_names =  (const char *[]){ "pll_gpu", },
+	.num_parents  = 1,
+	.name         = "clk_gpu",
+	.flags = CLK_SET_RATE_PARENT,
+
+};
+
+static const struct freq_table vcpu_tbl[] = {
+	_MNO(243000000,  7, 0, 0),
+	_MNO(324000000, 10, 0, 0),
+	_MNO(405000000, 13, 0, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_vcpu = {
+	.conf         = CLK_PLL_TYPE_MNO,
+	.pll_offset   = PLL_VPU1,
+	.freq_tbl     = vcpu_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_vcpu",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_composite_init_data clk_ve_init = {
+	.mux_offset   = CLK_OFFSET_INVALID,
+	.gate_offset  = CLOCK_ENABLE2,
+	.gate_shift   = CLK_EN_VCPU,
+	.parent_names = (const char *[]){ "pll_vcpu", },
+	.num_parents  = 1,
+	.name         = "clk_ve",
+	.flags        = CLK_IGNORE_UNUSED | CLK_SET_RATE_PARENT |
+			CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve1_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE1_SEL_WIDTH,
+	.mux_shift    = CLK_VE1_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE_H264,
+	.parent_names =  (const char *[]){
+		"clk_sys",
+		"clk_sysh",
+		"clk_ve",
+		"clk_ve",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve1",
+	.flags        = CLK_IGNORE_UNUSED | CLK_SET_RATE_PARENT |
+			CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve2_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE2_SEL_WIDTH,
+	.mux_shift    = CLK_VE2_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE_H265,
+	.parent_names =  (const char *[]){
+		"clk_sys",
+		"clk_sysh",
+		"clk_ve",
+		"clk_ve",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve2",
+	.flags        = CLK_IGNORE_UNUSED | CLK_SET_RATE_PARENT |
+			CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve2_bpu_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE2_BPU_SEL_WIDTH,
+	.mux_shift    = CLK_VE2_BPU_SEL_SHIFT,
+	.gate_offset  = CLK_OFFSET_INVALID,
+	.parent_names =  (const char *[]){
+		"clk_sys",
+		"clk_sysh",
+		"clk_gpu",
+		"clk_gpu",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve2_bpu",
+	.flags        = CLK_IGNORE_UNUSED | CLK_SET_RATE_PARENT |
+			CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_hw *clk_reg_list[] = {
+	[CC_PLL_SCPU]   = &__clk_pll_div_hw(&pll_scpu),
+	[CC_PLL_BUS]    = &__clk_pll_div_hw(&pll_bus),
+	[CC_PLL_DCSB]   = &__clk_pll_hw(&pll_dcsb),
+	[CC_PLL_GPU]    = &__clk_pll_hw(&pll_gpu),
+	[CC_PLL_VCPU]   = &__clk_pll_hw(&pll_vcpu),
+	[CC_CLK_SYS]    = &clk_sys.hw,
+	[CC_CLK_SYSH]   = &clk_sysh.hw,
+};
+
+static struct clk_composite_init_data *composite_clks[] = {
+	[CC_CLK_GPU]     = &clk_gpu_init,
+	[CC_CLK_VE]      = &clk_ve_init,
+	[CC_CLK_VE1]     = &clk_ve1_init,
+	[CC_CLK_VE2]     = &clk_ve2_init,
+	[CC_CLK_VE2_BPU] = &clk_ve2_bpu_init,
+};
+
+static int rtd119x_cc_init_clocks(struct device *dev)
+{
+	struct cc_platform_data *ccd = dev_get_drvdata(dev);
+	int i;
+	int ret;
+
+	// TODO: check chip rev and (re)set scpu pll div table
+
+	for (i = 0; i < ARRAY_SIZE(clk_reg_list); i++) {
+		struct clk_hw *hw = clk_reg_list[i];
+		const char *name;
+
+		if (!hw)
+			continue;
+
+		name = hw->init->name;
+		ret = cc_init_hw(dev, ccd, i, hw);
+		if (ret) {
+			dev_err(dev, "%s: failed in cc_init_hw: %d\n",
+				name, ret);
+			continue;
+		}
+	}
+
+	for (i = 0; i < ARRAY_SIZE(composite_clks); i++) {
+		struct clk_composite_init_data *data = composite_clks[i];
+		const char *name;
+
+		if (!data)
+			continue;
+
+		name = data->name;
+		ret = cc_init_composite_clk(dev, ccd, i, data);
+		if (ret) {
+			dev_err(dev, "%s: failed in cc_init_composite_clk: %d\n",
+				name, ret);
+			continue;
+		}
+	}
+
+	return 0;
+}
+
+static int rtd119x_cc_probe(struct platform_device *pdev)
+{
+	struct cc_platform_data *ccd;
+
+	ccd = devm_cc_alloc_platform_data(&pdev->dev, CC_CLK_MAX);
+	if (!ccd)
+		return -ENOMEM;
+
+	platform_set_drvdata(pdev, ccd);
+	return cc_probe_platform(pdev, ccd, rtd119x_cc_init_clocks);
+}
+
+static const struct of_device_id rtd119x_cc_match[] = {
+	{ .compatible = "realtek,clock-controller", },
+	{}
+};
+
+static struct platform_driver rtd119x_cc_driver = {
+	.probe = rtd119x_cc_probe,
+	.driver = {
+		.name = "rtk-rtd119x-cc",
+		.of_match_table = rtd119x_cc_match,
+		.pm = &cc_pm_ops,
+	},
+};
+
+static int __init rtd119x_cc_init(void)
+{
+	return platform_driver_register(&rtd119x_cc_driver);
+}
+core_initcall(rtd119x_cc_init);
diff --git a/drivers/clk/realtek/cc-rtd129x.c b/drivers/clk/realtek/cc-rtd129x.c
new file mode 100644
index 00000000..9d037f5
--- /dev/null
+++ b/drivers/clk/realtek/cc-rtd129x.c
@@ -0,0 +1,509 @@
+/*
+ * cc-rtd129x.c - RTD129x clock controller
+ *
+ * Copyright (C) 2017,2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/bitops.h>
+#include <linux/platform_device.h>
+#include "common.h"
+#include "clk-pll.h"
+#include "clk-mmio-gate.h"
+#include "clk-mmio-mux.h"
+#include "clk_regmap.h"
+#include <dt-bindings/clock/rtk,clock-rtd129x.h>
+
+#define DEFAULT_PARENT_OSC27M    (const char *[]){ "osc27M" }
+static DEFINE_SPINLOCK(clk_div_lock);
+
+#define _D(_rate, _div, _val) \
+{ \
+	.rate = _rate, \
+	.div = _div, \
+	.val = _val, \
+}
+
+#define _NF(_rate, _n, _f) \
+{ \
+	.rate = _rate, \
+	.mask = 0x7FFFF, \
+	.val = ((_n) << 11) | (_f), \
+}
+
+#define _MNO(_rate, _m, _n, _o) \
+{ \
+	.rate = _rate, \
+	.mask = 0x63FF0, \
+	.val = ((_m) << 4) | ((_n) << 12) | ((_o) << 17), \
+}
+
+#define CLK_PLL_TYPE_SSC                \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1)
+#define CLK_PLL_TYPE_SSC_POW0           \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1 | CLK_PLL_CONF_POW_LOC_CTL2)
+#define CLK_PLL_TYPE_SSC_POW1           \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1 | CLK_PLL_CONF_POW_LOC_CTL3)
+#define CLK_PLL_TYPE_POW                \
+	(CLK_PLL_CONF_FREQ_LOC_CTL1 | CLK_PLL_CONF_POW_LOC_CTL2)
+
+static const struct div_table scpu_div_tbl[] = {
+	_D(1000000000, 1, SCPU_FREQ_DIV1),
+	_D(500000000,  2, SCPU_FREQ_DIV2),
+	_D(250000000,  4, SCPU_FREQ_DIV4),
+	DIV_TABLE_END
+};
+
+static const struct freq_table scpu_tbl[] = {
+	_NF(1000000000, 34,   75),
+	_NF(1100000000, 37, 1517),
+	_NF(1200000000, 41,  910),
+	_NF(1300000000, 45,  303),
+	_NF(1400000000, 48, 1745),
+	_NF(1500000000, 52, 1137),
+	_NF(1600000000, 56,  531),
+	_NF(1800000000, 63, 1365),
+	/* special cases */
+	_NF(1200000000, 41, 1024),
+	_NF(1300000000, 45, 1024),
+	_NF(1503000000, 48, 1744),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_scpu = {
+	.div_offset = PLL_DIV,
+	.div_shift  = SCPU_FREQ_SEL_SHIFT,
+	.div_width  = SCPU_FREQ_SEL_WIDTH,
+	.div_tbl    = scpu_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.flags        = CLK_PLL_DIV_WORKAROUND,
+		.ssc_offset   = PLL_SSC_DIG_SCPU0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = scpu_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_scpu",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+static const struct freq_table bus_tbl[] = {
+	_NF(200000000,  4,  835),
+	_NF(243000000,  6,    0),
+	_NF(256000000,  6, 1024),
+	_NF(256000000,  6,  986),
+	_NF(257000000,  6, 1061),
+	_NF(459000000, 14,    0),
+	_NF(486000000, 15,    0),
+	_NF(482000000, 14, 1744),
+	_NF(513000000, 16,    0),
+	_NF(540000000, 17,    0),
+	FREQ_TABLE_END
+};
+
+static const struct div_table bus_div_tbl[] = {
+	_D(256000000,  1, BUS_FREQ_DIV1),
+	_D(1,          2, BUS_FREQ_DIV2),
+	DIV_TABLE_END
+};
+
+static struct clk_pll_div pll_bus = {
+	.div_offset = PLL_DIV,
+	.div_shift  = BUS_FREQ_SEL_SHIFT,
+	.div_width  = BUS_FREQ_SEL_WIDTH,
+	.div_tbl    = bus_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.ssc_offset   = PLL_SSC_DIG_BUS0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = bus_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_bus",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+				CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+static struct clk_fixed_factor clk_sys = {
+	.div     = 1,
+	.mult    = 1,
+	.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sys",
+		.ops          = &clk_fixed_factor_ops,
+		.parent_names = (const char *[]){ "pll_bus" },
+		.num_parents  = 1,
+		.flags        = CLK_SET_RATE_PARENT,
+	},
+};
+
+
+static struct clk_mmio_mux clk_sys_sb2 = {
+	.mux_offset   = GROUP1_CK_SEL,
+	.mask         = BIT(1) - 1,
+	.shift        = 0,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sys_sb2",
+		.ops          = &clk_mmio_mux_ops,
+		.parent_names = (const char *[]){ "clk_sys", "osc27M", },
+		.num_parents  = 2,
+		.flags        = 0,
+	},
+};
+
+static int clk_sys_sb2_notifier(struct notifier_block *nb, unsigned long action,
+	void *data)
+{
+	struct clk_hw *hw = &clk_sys_sb2.base.hw, *phw = NULL;
+
+	switch (action) {
+	case PRE_RATE_CHANGE:
+		phw = clk_hw_get_parent_by_index(hw, 1);
+		break;
+
+	case POST_RATE_CHANGE:
+	case ABORT_RATE_CHANGE:
+		phw = clk_hw_get_parent_by_index(hw, 0);
+		break;
+	}
+
+	if (phw)
+		clk_set_parent(hw->clk, phw->clk);
+	return NOTIFY_OK;
+}
+
+static struct notifier_block clk_sys_sb2_nb = {
+	.notifier_call = clk_sys_sb2_notifier,
+};
+
+static struct clk_pll pll_bus_h = {
+	.conf         = CLK_PLL_TYPE_SSC,
+	.ssc_offset   = PLL_SSC_DIG_BUSH0,
+	.pll_offset   = CLK_OFFSET_INVALID,
+	.freq_tbl     = bus_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_bus_h",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_IGNORE_UNUSED | CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_fixed_factor clk_sysh = {
+	.div     = 1,
+	.mult    = 1,
+	.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sysh",
+		.ops          = &clk_fixed_factor_ops,
+		.parent_names = (const char *[]){ "pll_bus_h" },
+		.num_parents  = 1,
+		.flags        = CLK_SET_RATE_PARENT,
+	},
+};
+
+static const struct freq_table ddsx_tbl[] = {
+	_NF(432000000, 13, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_ddsa = {
+	.conf         = CLK_PLL_TYPE_SSC_POW1,
+	.ssc_offset   = PLL_SSC_DIG_DDSA0,
+	.pll_offset   = PLL_DDSA1,
+	.freq_tbl     = ddsx_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ddsa",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_IGNORE_UNUSED | CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_pll pll_ddsb = {
+	.conf         = CLK_PLL_TYPE_SSC_POW0,
+	.ssc_offset   = PLL_SSC_DIG_DDSB0,
+	.pll_offset   = PLL_DDSB1,
+	.freq_tbl     = ddsx_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ddsb",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static const struct freq_table gpu_tbl[] = {
+	_NF(300000000,  8,  227),
+	_NF(320000000,  8, 1744),
+	_NF(340000000,  9, 1213),
+	_NF(360000000, 10,  682),
+	_NF(380000000, 11,  151),
+	_NF(400000000, 11, 1668),
+	_NF(420000000, 12, 1137),
+	_NF(440000000, 13,  606),
+	_NF(460000000, 14,   75),
+	_NF(480000000, 14, 1592),
+	_NF(500000000, 15, 1061),
+	_NF(520000000, 16,  530),
+	_NF(540000000, 17,    0),
+	_NF(560000000, 17, 1517),
+	_NF(580000000, 18,  986),
+	_NF(600000000, 19,  455),
+	_NF(620000000, 19, 1972),
+	_NF(640000000, 20, 1441),
+	_NF(660000000, 21,  910),
+	_NF(680000000, 22,  379),
+	_NF(460000000, 13, 1365),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_gpu = {
+	.conf         = CLK_PLL_TYPE_SSC_POW0,
+	.ssc_offset   = PLL_SSC_DIG_GPU0,
+	.pll_offset   = PLL_GPU1,
+	.freq_tbl     = gpu_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_gpu",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_composite_init_data clk_gpu_init = {
+	.mux_offset   = CLK_OFFSET_INVALID,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_GPU,
+	.parent_names = (const char *[]){ "pll_gpu" },
+	.num_parents  = 1,
+	.name         = "clk_gpu",
+	.flags        = CLK_SET_RATE_PARENT,
+};
+
+static struct freq_table ve_tbl[] = {
+	_MNO(189000000,  5, 0, 0),
+	_MNO(270000000,  8, 0, 0),
+	_MNO(405000000, 13, 0, 0),
+	_MNO(432000000, 14, 0, 0),
+	_MNO(459000000, 15, 0, 0),
+	_MNO(486000000, 16, 0, 0),
+	_MNO(513000000, 17, 0, 0),
+	_MNO(540000000, 18, 0, 0),
+	_MNO(567000000, 19, 0, 0),
+	_MNO(594000000, 20, 0, 0),
+	_MNO(648000000, 22, 0, 0),
+	_MNO(675000000, 23, 0, 0),
+	_MNO(702000000, 24, 0, 0),
+	_MNO(715000000, 51, 1, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_ve1 = {
+	.conf         = CLK_PLL_TYPE_POW,
+	.ssc_offset   = CLK_OFFSET_INVALID,
+	.pll_offset   = PLL_VE1_1,
+	.freq_tbl     = ve_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ve1",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_pll pll_ve2 = {
+	.conf         = CLK_PLL_TYPE_POW,
+	.ssc_offset   = CLK_OFFSET_INVALID,
+	.pll_offset   = PLL_VE2_1,
+	.freq_tbl     = ve_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ve2",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_composite_init_data clk_ve1_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE1_SEL_WIDTH,
+	.mux_shift    = CLK_VE1_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE1,
+	.parent_names = (const char *[]){
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve1",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve2_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE2_SEL_WIDTH,
+	.mux_shift    = CLK_VE2_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE2,
+	.parent_names = (const char *[]){
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve2",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve3_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE3_SEL_WIDTH,
+	.mux_shift    = CLK_VE3_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE3,
+	.parent_names =  (const char *[]){
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve3",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_hw *clk_reg_list[] = {
+	[CC_PLL_SCPU]    = &__clk_pll_div_hw(&pll_scpu),
+	[CC_PLL_BUS]     = &__clk_pll_div_hw(&pll_bus),
+	[CC_PLL_BUS_H]   = &__clk_pll_hw(&pll_bus_h),
+	[CC_PLL_DDSA]    = &__clk_pll_hw(&pll_ddsa),
+	[CC_PLL_DDSB]    = &__clk_pll_hw(&pll_ddsb),
+	[CC_PLL_GPU]     = &__clk_pll_hw(&pll_gpu),
+	[CC_PLL_VE1]     = &__clk_pll_hw(&pll_ve1),
+	[CC_PLL_VE2]     = &__clk_pll_hw(&pll_ve2),
+	[CC_CLK_SYS_SB2] = &__clk_mmio_mux_hw(&clk_sys_sb2),
+	[CC_CLK_SYS]     = &clk_sys.hw,
+	[CC_CLK_SYSH]    = &clk_sysh.hw,
+};
+
+static  struct clk_composite_init_data *composite_clks[] = {
+	[CC_CLK_GPU]     = &clk_gpu_init,
+	[CC_CLK_VE1]     = &clk_ve1_init,
+	[CC_CLK_VE2]     = &clk_ve2_init,
+	[CC_CLK_VE3]     = &clk_ve3_init,
+};
+
+static int rtd129x_cc_init_clocks(struct device *dev)
+{
+	struct cc_platform_data *ccd = dev_get_drvdata(dev);
+	int i;
+	int ret;
+
+	for (i = 0; i < ARRAY_SIZE(clk_reg_list); i++) {
+		struct clk_hw *hw = clk_reg_list[i];
+		const char *name;
+
+		if (!hw)
+			continue;
+
+		name = hw->init->name;
+		ret = cc_init_hw(dev, ccd, i, hw);
+		if (ret) {
+			dev_err(dev, "%s: failed in cc_init_hw: %d\n",
+				name, ret);
+			continue;
+		}
+	}
+
+	for (i = 0; i < ARRAY_SIZE(composite_clks); i++) {
+		struct clk_composite_init_data *data = composite_clks[i];
+		const char *name;
+
+		if (!data)
+			continue;
+
+		name = data->name;
+		ret = cc_init_composite_clk(dev, ccd, i, data);
+		if (ret) {
+			dev_err(dev, "%s: failed in cc_init_composite_clk: %d\n",
+				name, ret);
+			continue;
+		}
+	}
+
+	if (clk_sys.hw.clk && clk_sys_sb2.base.hw.clk)
+		clk_notifier_register(clk_sys.hw.clk, &clk_sys_sb2_nb);
+	/* set alias */
+	clk_add_alias("jpeg", NULL, "clk_en_jpeg", NULL);
+
+	return 0;
+}
+
+static int rtd129x_cc_probe(struct platform_device *pdev)
+{
+	struct cc_platform_data *ccd;
+
+	ccd = devm_cc_alloc_platform_data(&pdev->dev, CC_CLK_MAX);
+	if (!ccd)
+		return -ENOMEM;
+
+	platform_set_drvdata(pdev, ccd);
+	return cc_probe_platform(pdev, ccd, rtd129x_cc_init_clocks);
+}
+
+static const struct of_device_id rtd129x_cc_match[] = {
+	{ .compatible = "realtek,clock-controller", },
+	{}
+};
+
+static struct platform_driver rtd129x_cc_driver = {
+	.probe = rtd129x_cc_probe,
+	.driver = {
+		.name = "rtk-rtd129x-cc",
+		.of_match_table = rtd129x_cc_match,
+		.pm = &cc_pm_ops,
+	},
+};
+
+static int __init rtd129x_cc_init(void)
+{
+	return platform_driver_register(&rtd129x_cc_driver);
+}
+core_initcall(rtd129x_cc_init);
diff --git a/drivers/clk/realtek/cc-rtd139x.c b/drivers/clk/realtek/cc-rtd139x.c
new file mode 100644
index 00000000..b241091
--- /dev/null
+++ b/drivers/clk/realtek/cc-rtd139x.c
@@ -0,0 +1,515 @@
+/*
+ * cc-rtd139x.c - RTD139x clock controller
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/bitops.h>
+#include <linux/platform_device.h>
+#include "common.h"
+#include "clk-pll.h"
+#include "clk-mmio-gate.h"
+#include "clk-mmio-mux.h"
+#include "clk_regmap.h"
+#include <dt-bindings/clock/rtk,clock-rtd139x.h>
+
+#define DEFAULT_PARENT_OSC27M    (const char *[]){ "osc27M" }
+static DEFINE_SPINLOCK(clk_div_lock);
+
+#define _D(_rate, _div, _val) \
+{ \
+	.rate = _rate, \
+	.div = _div, \
+	.val = _val, \
+}
+
+#define _NF(_rate, _n, _f) \
+{ \
+	.rate = _rate, \
+	.mask = 0x7FFFF, \
+	.val = ((_n) << 11) | (_f), \
+}
+
+#define _MNO(_rate, _m, _n, _o) \
+{ \
+	.rate = _rate, \
+	.mask = 0x63FF0, \
+	.val = ((_m) << 4) | ((_n) << 12) | ((_o) << 17), \
+}
+
+#define CLK_PLL_TYPE_SSC                \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1)
+#define CLK_PLL_TYPE_SSC_POW0           \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1 | CLK_PLL_CONF_POW_LOC_CTL2)
+#define CLK_PLL_TYPE_SSC_POW1           \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1 | CLK_PLL_CONF_POW_LOC_CTL3)
+#define CLK_PLL_TYPE_POW                \
+	(CLK_PLL_CONF_FREQ_LOC_CTL1 | CLK_PLL_CONF_POW_LOC_CTL2)
+
+static const struct div_table scpu_div_tbl[] = {
+	_D(1000000000,  1, SCPU_FREQ_DIV1),
+	_D(500000000,   2, SCPU_FREQ_DIV2),
+	_D(250000000,   4, SCPU_FREQ_DIV4),
+	_D(200000000,   8, SCPU_FREQ_DIV8),
+	_D(100000000,  10, SCPU_FREQ_DIV10),
+	DIV_TABLE_END
+};
+
+static const struct freq_table scpu_tbl[] = {
+	_NF(1000000000, 34,   75),
+	_NF(1100000000, 37, 1517),
+	_NF(1200000000, 41,  910),
+	_NF(1300000000, 45,  303),
+	_NF(1400000000, 48, 1745),
+	_NF(1500000000, 52, 1137),
+	_NF(1600000000, 56,  530),
+	_NF(1800000000, 63, 1365),
+	/* special cases */
+	_NF(1000000000, 35,    0),
+	_NF(1800000000, 65,    0),
+	_NF(1800000000, 64,    0),
+	_NF(1400000001, 45,  301),
+	_NF(1500000001, 45,  302),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_scpu = {
+	.div_offset = PLL_DIV,
+	.div_shift  = SCPU_FREQ_SEL_SHIFT,
+	.div_width  = SCPU_FREQ_SEL_WIDTH,
+	.div_tbl    = scpu_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.ssc_offset   = PLL_SSC_DIG_SCPU0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = scpu_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_scpu",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+static const struct div_table bus_div_tbl[] = {
+	_D(257000000,  1, BUS_FREQ_DIV1),
+	_D(129000000,  2, BUS_FREQ_DIV2),
+	_D(65000000,   4, BUS_FREQ_DIV4),
+	DIV_TABLE_END
+};
+
+/* NOTE: PDIV = 1 */
+static const struct freq_table bus_tbl[] = {
+	_NF(513000000, 35,    0),
+	_NF(400000000, 26, 1289),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_bus = {
+	.div_offset = PLL_DIV,
+	.div_shift  = BUS_FREQ_SEL_SHIFT,
+	.div_width  = BUS_FREQ_SEL_WIDTH,
+	.div_tbl    = bus_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.ssc_offset   = PLL_SSC_DIG_BUS0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = bus_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_bus",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+				CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+static struct clk_fixed_factor clk_sys = {
+	.div     = 1,
+	.mult    = 1,
+	.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sys",
+		.ops          = &clk_fixed_factor_ops,
+		.parent_names = (const char *[]){ "pll_bus" },
+		.num_parents  = 1,
+		.flags        = CLK_SET_RATE_PARENT,
+	},
+};
+
+static struct clk_mmio_mux clk_sys_sb2 = {
+	.mux_offset   = GROUP1_CK_SEL,
+	.mask         = BIT(1) - 1,
+	.shift        = 0,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sys_sb2",
+		.ops          = &clk_mmio_mux_ops,
+		.parent_names = (const char *[]){ "clk_sys", "osc27M", },
+		.num_parents  = 2,
+		.flags        = 0,
+	},
+};
+
+static int clk_sys_sb2_notifier(struct notifier_block *nb, unsigned long action,
+	void *data)
+{
+	struct clk_hw *hw = &clk_sys_sb2.base.hw, *phw = NULL;
+
+	switch (action) {
+	case PRE_RATE_CHANGE:
+		phw = clk_hw_get_parent_by_index(hw, 1);
+		break;
+
+	case POST_RATE_CHANGE:
+	case ABORT_RATE_CHANGE:
+		phw = clk_hw_get_parent_by_index(hw, 0);
+		break;
+	}
+
+	if (phw)
+		clk_set_parent(hw->clk, phw->clk);
+	return NOTIFY_OK;
+}
+
+static struct notifier_block clk_sys_sb2_nb = {
+	.notifier_call = clk_sys_sb2_notifier,
+};
+
+static const struct div_table dcsb_div_tbl[] = {
+	_D(250000000,  1, DCSB_FREQ_DIV1),
+	_D(125000000,  2, DCSB_FREQ_DIV2),
+	_D(62500000,   4, DCSB_FREQ_DIV4),
+	DIV_TABLE_END
+};
+
+/* NOTE: PDIV = 1 */
+static const struct freq_table dcsb_tbl[] = {
+	_NF(500000000, 34,    0),
+	_NF(450000000, 30,  682),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_dcsb = {
+	.div_offset = PLL_DIV,
+	.div_shift  = DCSB_FREQ_SEL_SHIFT,
+	.div_width  = DCSB_FREQ_SEL_WIDTH,
+	.div_tbl    = dcsb_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.ssc_offset   = PLL_SSC_DIG_DCSB0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = dcsb_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_dcsb",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+static struct clk_fixed_factor clk_sysh = {
+	.div     = 1,
+	.mult    = 1,
+	.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sysh",
+		.ops          = &clk_fixed_factor_ops,
+		.parent_names = (const char *[]){ "pll_dcsb" },
+		.num_parents  = 1,
+		.flags        = CLK_SET_RATE_PARENT,
+	},
+};
+
+static const struct freq_table ddsx_tbl[] = {
+	_NF(432000000, 13, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_ddsa = {
+	.conf         = CLK_PLL_TYPE_SSC_POW1,
+	.ssc_offset   = PLL_SSC_DIG_DDSA0,
+	.pll_offset   = PLL_DDSA1,
+	.freq_tbl     = ddsx_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ddsa",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_IGNORE_UNUSED | CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_pll pll_ddsb = {
+	.conf         = CLK_PLL_TYPE_SSC_POW0,
+	.ssc_offset   = PLL_SSC_DIG_DDSB0,
+	.pll_offset   = PLL_DDSB1,
+	.freq_tbl     = ddsx_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ddsb",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static const struct freq_table gpu_tbl[] = {
+	_NF(300000000, 19,  455),
+	_NF(400000000, 26, 1289),
+	_NF(500000000, 34,   75),
+	_NF(600000000, 41,  910),
+	_NF(700000000, 48, 1745),
+	_NF(750000000, 52, 1137),
+	_NF(800000000, 56,  530),
+	_NF(850000000, 59, 1971),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_gpu = {
+	.conf         = CLK_PLL_TYPE_SSC_POW0,
+	.ssc_offset   = PLL_SSC_DIG_GPU0,
+	.pll_offset   = PLL_GPU1,
+	.freq_tbl     = gpu_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_gpu",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_composite_init_data clk_gpu_init = {
+	.mux_offset   = CLK_OFFSET_INVALID,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_GPU,
+	.parent_names = (const char *[]){ "pll_gpu" },
+	.num_parents  = 1,
+	.name         = "clk_gpu",
+	.flags        = CLK_SET_RATE_PARENT,
+};
+
+static struct freq_table ve_tbl[] = {
+	_MNO(189000000, 12, 0, 1),
+	_MNO(270000000, 18, 0, 1),
+	_MNO(405000000, 13, 0, 0),
+	_MNO(432000000, 14, 0, 0),
+	_MNO(459000000, 15, 0, 0),
+	_MNO(486000000, 16, 0, 0),
+	_MNO(513000000, 17, 0, 0),
+	_MNO(540000000, 18, 0, 0),
+	_MNO(550000000, 59, 2, 0),
+	_MNO(567000000, 19, 0, 0),
+	_MNO(594000000, 20, 0, 0),
+	_MNO(648000000, 22, 0, 0),
+	_MNO(675000000, 23, 0, 0),
+	_MNO(702000000, 24, 0, 0),
+	_MNO(715000000, 51, 1, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_ve1 = {
+	.conf         = CLK_PLL_TYPE_POW,
+	.ssc_offset   = CLK_OFFSET_INVALID,
+	.pll_offset   = PLL_VE1_1,
+	.freq_tbl     = ve_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ve1",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_pll pll_ve2 = {
+	.conf         = CLK_PLL_TYPE_POW,
+	.ssc_offset   = CLK_OFFSET_INVALID,
+	.pll_offset   = PLL_VE2_1,
+	.freq_tbl     = ve_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ve2",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_composite_init_data clk_ve1_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE1_SEL_WIDTH,
+	.mux_shift    = CLK_VE1_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE1,
+	.parent_names = (const char *[]){
+		"pll_ve1",
+		"pll_ve2",
+		"clk_sysh",
+		"clk_sysh",
+		"pll_ddsa",
+	},
+	.num_parents  = 5,
+	.name         = "clk_ve1",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve2_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE2_SEL_WIDTH,
+	.mux_shift    = CLK_VE2_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE2,
+	.parent_names = (const char *[]){
+		"pll_ve1",
+		"pll_ve2",
+		"clk_sysh",
+		"clk_sysh",
+		"pll_ddsa",
+	},
+	.num_parents  = 5,
+	.name         = "clk_ve2",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve2_bpu_init = {
+	.mux_offset  = VE_CKSEL,
+	.mux_width   = CLK_VE2_BPU_SEL_WIDTH,
+	.mux_shift   = CLK_VE2_BPU_SEL_SHIFT,
+	.gate_offset = CLK_OFFSET_INVALID,
+	.parent_names = (const char *[]){
+		"pll_ve1",
+		"pll_ve2",
+		"clk_sysh",
+		"clk_sysh",
+		"pll_ddsa",
+	},
+	.num_parents  = 5,
+	.name         = "clk_ve2_bpu",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_hw *clk_reg_list[] = {
+	[CC_PLL_SCPU]    = &__clk_pll_div_hw(&pll_scpu),
+	[CC_PLL_BUS]     = &__clk_pll_div_hw(&pll_bus),
+	[CC_PLL_BUS_H]   = &__clk_pll_div_hw(&pll_dcsb),
+	[CC_PLL_DDSA]    = &__clk_pll_hw(&pll_ddsa),
+	[CC_PLL_DDSB]    = &__clk_pll_hw(&pll_ddsb),
+	[CC_PLL_GPU]     = &__clk_pll_hw(&pll_gpu),
+	[CC_PLL_VE1]     = &__clk_pll_hw(&pll_ve1),
+	[CC_PLL_VE2]     = &__clk_pll_hw(&pll_ve2),
+	[CC_CLK_SYS_SB2] = &__clk_mmio_mux_hw(&clk_sys_sb2),
+	[CC_CLK_SYS]     = &clk_sys.hw,
+	[CC_CLK_SYSH]    = &clk_sysh.hw,
+};
+
+static  struct clk_composite_init_data *composite_clks[] = {
+	[CC_CLK_GPU]     = &clk_gpu_init,
+	[CC_CLK_VE1]     = &clk_ve1_init,
+	[CC_CLK_VE2]     = &clk_ve2_init,
+	[CC_CLK_VE2_BPU] = &clk_ve2_bpu_init,
+};
+
+int rtd139x_cc_init_clocks(struct device *dev)
+{
+	struct cc_platform_data *ccd = dev_get_drvdata(dev);
+	int i;
+	int ret;
+
+	for (i = 0; i < ARRAY_SIZE(clk_reg_list); i++) {
+		struct clk_hw *hw = clk_reg_list[i];
+		const char *name;
+
+		if (!hw)
+			continue;
+
+		name = hw->init->name;
+		ret = cc_init_hw(dev, ccd, i, hw);
+		if (ret) {
+			dev_err(dev, "%s: failed in cc_init_hw: %d\n",
+				name, ret);
+			continue;
+		}
+	}
+
+	for (i = 0; i < ARRAY_SIZE(composite_clks); i++) {
+		struct clk_composite_init_data *data = composite_clks[i];
+		const char *name;
+
+		if (!data)
+			continue;
+
+		name = data->name;
+		ret = cc_init_composite_clk(dev, ccd, i, data);
+		if (ret) {
+			dev_err(dev, "%s: failed in cc_init_composite_clk: %d\n",
+				name, ret);
+			continue;
+		}
+	}
+
+	if (clk_sys.hw.clk && clk_sys_sb2.base.hw.clk)
+		clk_notifier_register(clk_sys.hw.clk, &clk_sys_sb2_nb);
+
+	return 0;
+}
+
+static int rtd139x_cc_probe(struct platform_device *pdev)
+{
+	struct cc_platform_data *ccd;
+
+	ccd = devm_cc_alloc_platform_data(&pdev->dev, CC_CLK_MAX);
+	if (!ccd)
+		return -ENOMEM;
+
+	platform_set_drvdata(pdev, ccd);
+	return cc_probe_platform(pdev, ccd, rtd139x_cc_init_clocks);
+}
+
+static const struct of_device_id rtd139x_cc_match[] = {
+	{ .compatible = "realtek,clock-controller", },
+	{}
+};
+
+static struct platform_driver rtd139x_cc_driver = {
+	.probe = rtd139x_cc_probe,
+	.driver = {
+		.name = "rtk-rtd139x-cc",
+		.of_match_table = rtd139x_cc_match,
+		.pm = &cc_pm_ops,
+	},
+};
+
+static int __init rtd139x_cc_init(void)
+{
+	return platform_driver_register(&rtd139x_cc_driver);
+}
+core_initcall(rtd139x_cc_init);
diff --git a/drivers/clk/realtek/cc-rtd13xx.c b/drivers/clk/realtek/cc-rtd13xx.c
new file mode 100644
index 00000000..d4a2fed
--- /dev/null
+++ b/drivers/clk/realtek/cc-rtd13xx.c
@@ -0,0 +1,566 @@
+/*
+ * cc-rtd13xx.c - RTD13xx clock controller
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/bitops.h>
+#include <linux/platform_device.h>
+#include "common.h"
+#include "clk-pll.h"
+#include "clk-mmio-gate.h"
+#include "clk-mmio-mux.h"
+#include "clk_regmap.h"
+#include <dt-bindings/clock/rtk,clock-rtd13xx.h>
+
+#define DEFAULT_PARENT_OSC27M    (const char *[]){ "osc27M" }
+static DEFINE_SPINLOCK(clk_div_lock);
+
+#define _D(_rate, _div, _val) \
+{ \
+	.rate = _rate, \
+	.div = _div, \
+	.val = _val, \
+}
+
+#define _NF(_rate, _n, _f) \
+{ \
+	.rate = _rate, \
+	.mask = 0x7FFFF, \
+	.val = ((_n) << 11) | (_f), \
+}
+
+#define _MNO(_rate, _m, _n, _o) \
+{ \
+	.rate = _rate, \
+	.mask = 0x63FF0, \
+	.val = ((_m) << 4) | ((_n) << 12) | ((_o) << 17), \
+}
+
+#define CLK_PLL_TYPE_SSC                \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1)
+#define CLK_PLL_TYPE_SSC_POW0           \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1 | CLK_PLL_CONF_POW_LOC_CTL2)
+#define CLK_PLL_TYPE_SSC_POW1           \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1 | CLK_PLL_CONF_POW_LOC_CTL3)
+#define CLK_PLL_TYPE_POW                \
+	(CLK_PLL_CONF_FREQ_LOC_CTL1 | CLK_PLL_CONF_POW_LOC_CTL2)
+
+static const struct div_table scpu_div_tbl[] = {
+	_D(1000000000,  1, SCPU_FREQ_DIV1),
+	_D(500000000,   2, SCPU_FREQ_DIV2),
+	_D(250000000,   4, SCPU_FREQ_DIV4),
+	_D(200000000,   8, SCPU_FREQ_DIV8),
+	_D(100000000,  10, SCPU_FREQ_DIV10),
+	DIV_TABLE_END
+};
+
+static const struct freq_table scpu_tbl[] = {
+	_NF(1000000000, 34,   75),
+	_NF(1100000000, 37, 1517),
+	_NF(1200000000, 41,  910),
+	_NF(1300000000, 45,  303),
+	_NF(1400000000, 48, 1745),
+	_NF(1500000000, 52, 1137),
+	_NF(1600000000, 56,  530),
+	_NF(1700000000, 59, 1972),
+	_NF(1800000000, 63, 1365),
+	_NF(1900000000, 67,  758),
+	_NF(2000000000, 71,  151),
+	/* init-value mapping */
+	_NF(1000000000, 35,    0),
+	_NF(1200000000, 41,    0),
+	_NF(1800000000, 65,    0),
+	_NF(1800000000, 64,    0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_scpu = {
+	.div_offset = PLL_DIV,
+	.div_shift  = SCPU_FREQ_SEL_SHIFT,
+	.div_width  = SCPU_FREQ_SEL_WIDTH,
+	.div_tbl    = scpu_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.ssc_offset   = PLL_SSC_DIG_SCPU0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = scpu_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_scpu",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+static const struct div_table bus_div_tbl[] = {
+	_D(257000000,  1, BUS_FREQ_DIV1),
+	_D(129000000,  2, BUS_FREQ_DIV2),
+	_D(65000000,   4, BUS_FREQ_DIV4),
+	DIV_TABLE_END
+};
+
+/* NOTE: PDIV = 1 */
+static const struct freq_table bus_tbl[] = {
+	_NF(500000000, 34,    0),
+	_NF(513000000, 35,    0),
+	_NF(400000000, 26, 1289),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_bus = {
+	.div_offset = PLL_DIV,
+	.div_shift  = BUS_FREQ_SEL_SHIFT,
+	.div_width  = BUS_FREQ_SEL_WIDTH,
+	.div_tbl    = bus_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.ssc_offset   = PLL_SSC_DIG_BUS0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = bus_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_bus",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+static struct clk_fixed_factor clk_sys = {
+	.div     = 1,
+	.mult    = 1,
+	.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sys",
+		.ops          = &clk_fixed_factor_ops,
+		.parent_names = (const char *[]){ "pll_bus" },
+		.num_parents  = 1,
+		.flags        = CLK_SET_RATE_PARENT,
+	},
+};
+
+static struct clk_mmio_mux clk_sys_sb2 = {
+	.mux_offset   = GROUP1_CK_SEL,
+	.mask         = BIT(1) - 1,
+	.shift        = 0,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sys_sb2",
+		.ops          = &clk_mmio_mux_ops,
+		.parent_names = (const char *[]){ "clk_sys", "osc27M", },
+		.num_parents  = 2,
+		.flags        = 0,
+	},
+};
+
+static int clk_sys_sb2_notifier(struct notifier_block *nb, unsigned long action,
+	void *data)
+{
+	struct clk_hw *hw = &clk_sys_sb2.base.hw, *phw = NULL;
+
+	switch (action) {
+	case PRE_RATE_CHANGE:
+		phw = clk_hw_get_parent_by_index(hw, 1);
+		break;
+
+	case POST_RATE_CHANGE:
+	case ABORT_RATE_CHANGE:
+		phw = clk_hw_get_parent_by_index(hw, 0);
+		break;
+	}
+
+	if (phw)
+		clk_set_parent(hw->clk, phw->clk);
+	return NOTIFY_OK;
+}
+
+static struct notifier_block clk_sys_sb2_nb = {
+	.notifier_call = clk_sys_sb2_notifier,
+};
+
+static const struct div_table dcsb_div_tbl[] = {
+	_D(400000000, 1, DCSB_FREQ_DIV1),
+	_D(275000000, 2, DCSB_FREQ_DIV2),
+	_D(1,         4, DCSB_FREQ_DIV4),
+	DIV_TABLE_END
+};
+
+/* NOTE: PDIV = 1 */
+static const struct freq_table dcsb_tbl[] = {
+	_NF(472000000, 32, 0),
+	_NF(550000000, 38, 0),
+	_NF(550000000, 37, 1517),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_dcsb = {
+	.div_offset = PLL_DIV,
+	.div_shift  = DCSB_FREQ_SEL_SHIFT,
+	.div_width  = DCSB_FREQ_SEL_WIDTH,
+	.div_tbl    = dcsb_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.ssc_offset   = PLL_SSC_DIG_DCSB0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = dcsb_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_dcsb",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+static struct clk_fixed_factor clk_sysh = {
+	.div     = 1,
+	.mult    = 1,
+	.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sysh",
+		.ops          = &clk_fixed_factor_ops,
+		.parent_names = (const char *[]){ "pll_dcsb" },
+		.num_parents  = 1,
+		.flags        = CLK_SET_RATE_PARENT,
+	},
+};
+
+static const struct freq_table ddsx_tbl[] = {
+	_NF(432000000, 13, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_ddsa = {
+	.conf         = CLK_PLL_TYPE_SSC_POW1,
+	.ssc_offset   = PLL_SSC_DIG_DDSA0,
+	.pll_offset   = PLL_DDSA1,
+	.freq_tbl     = ddsx_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ddsa",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_IGNORE_UNUSED | CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static const struct freq_table gpu_tbl[] = {
+	_NF(300000000, 19,  455),
+	_NF(400000000, 26, 1289),
+	_NF(500000000, 34,   75),
+	_NF(600000000, 41,  910),
+	_NF(650000000, 45,  303),
+	_NF(700000000, 48, 1745),
+	_NF(720000000, 50,  682),
+	_NF(750000000, 52, 1137),
+	_NF(800000000, 56,  530),
+	_NF(850000000, 59, 1971),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_gpu = {
+	.conf         = CLK_PLL_TYPE_SSC_POW0,
+	.ssc_offset   = PLL_SSC_DIG_GPU0,
+	.pll_offset   = PLL_GPU1,
+	.freq_tbl     = gpu_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_gpu",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_composite_init_data clk_gpu_init = {
+	.mux_offset   = CLK_OFFSET_INVALID,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_GPU,
+	.gate_flags   = CLK_MMIO_GATE_HAS_WRITE_EN,
+	.parent_names = (const char *[]){ "pll_gpu" },
+	.num_parents  = 1,
+	.name         = "clk_gpu",
+	.flags        = CLK_SET_RATE_PARENT,
+};
+
+static struct freq_table ve_tbl[] = {
+	_MNO(189000000, 12, 0, 1),
+	_MNO(270000000, 18, 0, 1),
+	_MNO(405000000, 13, 0, 0),
+	_MNO(432000000, 14, 0, 0),
+	_MNO(459000000, 15, 0, 0),
+	_MNO(486000000, 16, 0, 0),
+	_MNO(513000000, 17, 0, 0),
+	_MNO(540000000, 18, 0, 0),
+	_MNO(550000000, 59, 2, 0),
+	_MNO(567000000, 19, 0, 0),
+	_MNO(594000000, 20, 0, 0),
+	_MNO(621000000, 21, 0, 0),
+	_MNO(648000000, 22, 0, 0),
+	_MNO(675000000, 23, 0, 0),
+	_MNO(702000000, 24, 0, 0),
+	_MNO(715000000, 51, 1, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_ve1 = {
+	.conf         = CLK_PLL_TYPE_POW,
+	.ssc_offset   = CLK_OFFSET_INVALID,
+	.pll_offset   = PLL_VE1_1,
+	.freq_tbl     = ve_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ve1",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_pll pll_ve2 = {
+	.conf         = CLK_PLL_TYPE_POW,
+	.ssc_offset   = CLK_OFFSET_INVALID,
+	.pll_offset   = PLL_VE2_1,
+	.freq_tbl     = ve_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ve2",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE | CLK_IGNORE_UNUSED,
+	},
+};
+
+static struct clk_composite_init_data clk_ve1_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE1_SEL_WIDTH,
+	.mux_shift    = CLK_VE1_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE1,
+	.gate_flags   = CLK_MMIO_GATE_HAS_WRITE_EN,
+	.parent_names = (const char *[]){
+		"pll_gpu",
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve1",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve2_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE2_SEL_WIDTH,
+	.mux_shift    = CLK_VE2_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE2,
+	.gate_flags   = CLK_MMIO_GATE_HAS_WRITE_EN,
+	.parent_names = (const char *[]){
+		"pll_gpu",
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve2",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT |
+			CLK_IGNORE_UNUSED,
+};
+
+static struct clk_composite_init_data clk_ve3_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE3_SEL_WIDTH,
+	.mux_shift    = CLK_VE3_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE4,
+	.gate_shift   = CLK_EN_VE3,
+	.gate_flags   = CLK_MMIO_GATE_HAS_WRITE_EN,
+	.parent_names = (const char *[]){
+		"pll_gpu",
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve3",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve3_bpu_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE3_BPU_SEL_WIDTH,
+	.mux_shift    = CLK_VE3_BPU_SEL_SHIFT,
+	.gate_offset  = CLK_OFFSET_INVALID,
+	.parent_names = (const char *[]){
+		"pll_gpu",
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve3_bpu",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_pll_dif pll_dif = {
+	.ssc_offset   = PLL_SSC_DIG_PLLDIF0,
+	.pll_offset   = PLL_DIF1,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_dif",
+		.ops          = &clk_pll_dif_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_pll_psaud pll_psaud1a = {
+	.reg = PLL_PSAUDA1,
+	.id  = CLK_PLL_PSAUD1A,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_psaud1a",
+		.ops          = &clk_pll_psaud_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_IGNORE_UNUSED | CLK_SET_RATE_UNGATE,
+	},
+};
+
+static struct clk_pll_psaud pll_psaud2a = {
+	.reg = PLL_PSAUDA1,
+	.id  = CLK_PLL_PSAUD2A,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_psaud2a",
+		.ops          = &clk_pll_psaud_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_IGNORE_UNUSED | CLK_SET_RATE_UNGATE,
+	},
+};
+
+static struct clk_hw *clk_reg_list[] = {
+	[CC_PLL_SCPU]    = &__clk_pll_div_hw(&pll_scpu),
+	[CC_PLL_BUS]     = &__clk_pll_div_hw(&pll_bus),
+	[CC_PLL_DCSB]    = &__clk_pll_div_hw(&pll_dcsb),
+	[CC_PLL_DDSA]    = &__clk_pll_hw(&pll_ddsa),
+	[CC_PLL_GPU]     = &__clk_pll_hw(&pll_gpu),
+	[CC_PLL_VE1]     = &__clk_pll_hw(&pll_ve1),
+	[CC_PLL_VE2]     = &__clk_pll_hw(&pll_ve2),
+	[CC_PLL_DIF]     = &__clk_pll_dif_hw(&pll_dif),
+	[CC_CLK_SYS_SB2] = &__clk_mmio_mux_hw(&clk_sys_sb2),
+	[CC_CLK_SYS]     = &clk_sys.hw,
+	[CC_CLK_SYSH]    = &clk_sysh.hw,
+	[CC_PLL_PSAUD1A] = &__clk_pll_psaud_hw(&pll_psaud1a),
+	[CC_PLL_PSAUD2A] = &__clk_pll_psaud_hw(&pll_psaud2a),
+};
+
+static  struct clk_composite_init_data *composite_clks[] = {
+	[CC_CLK_GPU] = &clk_gpu_init,
+	[CC_CLK_VE1] = &clk_ve1_init,
+	[CC_CLK_VE2] = &clk_ve2_init,
+	[CC_CLK_VE3] = &clk_ve3_init,
+	[CC_CLK_VE3_BPU] = &clk_ve3_bpu_init,
+};
+
+static int rtd13xx_cc_init_clocks(struct device *dev)
+{
+	struct cc_platform_data *ccd = dev_get_drvdata(dev);
+	int i;
+	int ret;
+
+	for (i = 0; i < ARRAY_SIZE(clk_reg_list); i++) {
+		struct clk_hw *hw = clk_reg_list[i];
+		const char *name;
+
+		if (!hw)
+			continue;
+
+		name = hw->init->name;
+		ret = cc_init_hw(dev, ccd, i, hw);
+		if (ret) {
+			dev_err(dev, "%s: failed in cc_init_hw: %d\n",
+				name, ret);
+			continue;
+		}
+	}
+
+	for (i = 0; i < ARRAY_SIZE(composite_clks); i++) {
+		struct clk_composite_init_data *data = composite_clks[i];
+		const char *name;
+
+		if (!data)
+			continue;
+
+		name = data->name;
+		ret = cc_init_composite_clk(dev, ccd, i, data);
+		if (ret) {
+			dev_err(dev, "%s: failed in cc_init_composite_clk: %d\n",
+				name, ret);
+			continue;
+		}
+	}
+
+	if (clk_sys.hw.clk && clk_sys_sb2.base.hw.clk)
+		clk_notifier_register(clk_sys.hw.clk, &clk_sys_sb2_nb);
+
+	return 0;
+}
+
+static int rtd13xx_cc_probe(struct platform_device *pdev)
+{
+	struct cc_platform_data *ccd;
+
+	ccd = devm_cc_alloc_platform_data(&pdev->dev, CC_CLK_MAX);
+	if (!ccd)
+		return -ENOMEM;
+
+	platform_set_drvdata(pdev, ccd);
+	return cc_probe_platform(pdev, ccd, rtd13xx_cc_init_clocks);
+}
+
+static const struct of_device_id rtd13xx_cc_match[] = {
+	{ .compatible = "realtek,clock-controller", },
+	{}
+};
+
+static struct platform_driver rtd13xx_cc_driver = {
+	.probe = rtd13xx_cc_probe,
+	.driver = {
+		.name = "rtk-rtd13xx-cc",
+		.of_match_table = rtd13xx_cc_match,
+		.pm = &cc_pm_ops,
+	},
+};
+
+static int __init rtd13xx_cc_init(void)
+{
+	return platform_driver_register(&rtd13xx_cc_driver);
+}
+core_initcall(rtd13xx_cc_init);
diff --git a/drivers/clk/realtek/cc-rtd16xx.c b/drivers/clk/realtek/cc-rtd16xx.c
new file mode 100644
index 00000000..05ddfa0
--- /dev/null
+++ b/drivers/clk/realtek/cc-rtd16xx.c
@@ -0,0 +1,599 @@
+/*
+ * cc-rtd16xx.c - RTD16xx clock controller
+ *
+ * Copyright (C) 2018-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/bitops.h>
+#include <linux/platform_device.h>
+#include "common.h"
+#include "clk-pll.h"
+#include "clk-mmio-gate.h"
+#include "clk-mmio-mux.h"
+#include "clk_regmap.h"
+#include <dt-bindings/clock/rtk,clock-rtd16xx.h>
+
+#define DEFAULT_PARENT_OSC27M    (const char *[]){ "osc27M" }
+static __maybe_unused DEFINE_SPINLOCK(clk_div_lock);
+
+#define _D(_rate, _div, _val) \
+{ \
+	.rate = _rate, \
+	.div = _div, \
+	.val = _val, \
+}
+
+#define _NF(_rate, _n, _f) \
+{ \
+	.rate = _rate, \
+	.mask = 0x7FFFF, \
+	.val = ((_n) << 11) | (_f), \
+}
+
+#define _MNO(_rate, _m, _n, _o) \
+{ \
+	.rate = _rate, \
+	.mask = 0x63FF0, \
+	.val = ((_m) << 4) | ((_n) << 12) | ((_o) << 17), \
+}
+
+#define CLK_PLL_TYPE_SSC                \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1)
+#define CLK_PLL_TYPE_SSC_POW0           \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1 | CLK_PLL_CONF_POW_LOC_CTL2)
+#define CLK_PLL_TYPE_SSC_POW1           \
+	(CLK_PLL_CONF_FREQ_LOC_SSC1 | CLK_PLL_CONF_POW_LOC_CTL3)
+#define CLK_PLL_TYPE_POW                \
+	(CLK_PLL_CONF_FREQ_LOC_CTL1 | CLK_PLL_CONF_POW_LOC_CTL2)
+
+#ifndef CONFIG_COMMON_CLK_REALTEK_TEE
+
+static const struct div_table scpu_div_tbl[] = {
+	_D(1000000000,  1, SCPU_FREQ_DIV1),
+	_D(500000000,   2, SCPU_FREQ_DIV2),
+	_D(350000000,   3, SCPU_FREQ_DIV3),
+	_D(250000000,   4, SCPU_FREQ_DIV4),
+	_D(200000000,   8, SCPU_FREQ_DIV8),
+	_D(100000000,  10, SCPU_FREQ_DIV10),
+	DIV_TABLE_END
+};
+
+static const struct freq_table scpu_tbl[] = {
+	_NF(1000000000, 34,   75),
+	_NF(1100000000, 37, 1517),
+	_NF(1200000000, 41,  910),
+	_NF(1300000000, 45,  303),
+	_NF(1400000000, 48, 1745),
+	_NF(1500000000, 52, 1137),
+	_NF(1600000000, 56,  530),
+	_NF(1700000000, 59, 1972),
+	_NF(1800000000, 63, 1365),
+	_NF(1900000000, 67,  758),
+	_NF(2000000000, 71,  151),
+	/* init-value mapping */
+	_NF(1000000000, 35,    0),
+	_NF(1200000000, 41,    0),
+	_NF(1800000000, 65,    0),
+	_NF(1800000000, 64,    0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_scpu = {
+	.div_offset = PLL_DIV,
+	.div_shift  = SCPU_FREQ_SEL_SHIFT,
+	.div_width  = SCPU_FREQ_SEL_WIDTH,
+	.div_tbl    = scpu_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.ssc_offset   = PLL_SSC_DIG_SCPU0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = scpu_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_scpu",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+
+static const struct div_table bus_div_tbl[] = {
+	_D(257000000,  1, BUS_FREQ_DIV1),
+	_D(129000000,  2, BUS_FREQ_DIV2),
+	_D(65000000,   4, BUS_FREQ_DIV4),
+	DIV_TABLE_END
+};
+
+/* NOTE: PDIV = 1 */
+static const struct freq_table bus_tbl[] = {
+	_NF(513000000, 35,    0),
+	_NF(400000000, 26, 1289),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_bus = {
+	.div_offset = PLL_DIV,
+	.div_shift  = BUS_FREQ_SEL_SHIFT,
+	.div_width  = BUS_FREQ_SEL_WIDTH,
+	.div_tbl    = bus_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.ssc_offset   = PLL_SSC_DIG_BUS0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = bus_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_bus",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+#else /* CONFIG_COMMON_CLK_REALTEK_TEE */
+
+static struct clk_fixed_rate pll_bus = {
+	.fixed_rate = 256500000,
+	.hw.init = &(struct clk_init_data) {
+		.name = "pll_bus",
+		.ops  = &clk_fixed_rate_ops,
+	},
+};
+
+#endif /* CONFIG_COMMON_CLK_REALTEK_TEE */
+
+static struct clk_fixed_factor clk_sys = {
+	.div     = 1,
+	.mult    = 1,
+	.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sys",
+		.ops          = &clk_fixed_factor_ops,
+		.parent_names = (const char *[]){ "pll_bus" },
+		.num_parents  = 1,
+		.flags        = CLK_SET_RATE_PARENT,
+	},
+};
+
+static struct clk_mmio_mux clk_sys_sb2 = {
+	.mux_offset   = GROUP1_CK_SEL,
+	.mask         = BIT(1) - 1,
+	.shift        = 0,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sys_sb2",
+		.ops          = &clk_mmio_mux_ops,
+		.parent_names = (const char *[]){ "clk_sys", "osc27M", },
+		.num_parents  = 2,
+		.flags        = 0,
+	},
+};
+
+static int clk_sys_sb2_notifier(struct notifier_block *nb, unsigned long action,
+	void *data)
+{
+	struct clk_hw *hw = &clk_sys_sb2.base.hw, *phw = NULL;
+
+	switch (action) {
+	case PRE_RATE_CHANGE:
+		phw = clk_hw_get_parent_by_index(hw, 1);
+		break;
+
+	case POST_RATE_CHANGE:
+	case ABORT_RATE_CHANGE:
+		phw = clk_hw_get_parent_by_index(hw, 0);
+		break;
+	}
+
+	if (phw)
+		clk_set_parent(hw->clk, phw->clk);
+	return NOTIFY_OK;
+}
+
+static struct notifier_block clk_sys_sb2_nb = {
+	.notifier_call = clk_sys_sb2_notifier,
+};
+
+static const struct div_table dcsb_div_tbl[] = {
+	_D(550000000, 1, DCSB_FREQ_DIV1),
+	_D(275000000, 2, DCSB_FREQ_DIV2),
+	_D(1,         4, DCSB_FREQ_DIV4),
+	DIV_TABLE_END
+};
+
+#ifndef CONFIG_COMMON_CLK_REALTEK_TEE
+
+/* NOTE: PDIV = 1 */
+static const struct freq_table dcsb_tbl[] = {
+	_NF(550000000, 38, 0),
+	_NF(550000000, 37, 1517),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll_div pll_dcsb = {
+	.div_offset = PLL_DIV,
+	.div_shift  = DCSB_FREQ_SEL_SHIFT,
+	.div_width  = DCSB_FREQ_SEL_WIDTH,
+	.div_tbl    = dcsb_div_tbl,
+	.lock       = &clk_div_lock,
+	.clkp       = {
+		.conf         = CLK_PLL_TYPE_SSC,
+		.ssc_offset   = PLL_SSC_DIG_DCSB0,
+		.pll_offset   = CLK_OFFSET_INVALID,
+		.freq_tbl     = dcsb_tbl,
+		.base.hw.init = &(struct clk_init_data) {
+			.name         = "pll_dcsb",
+			.ops          = &clk_pll_div_ops,
+			.parent_names = DEFAULT_PARENT_OSC27M,
+			.num_parents  = 1,
+			.flags        = CLK_IGNORE_UNUSED |
+					CLK_GET_RATE_NOCACHE,
+		},
+	},
+};
+
+#else /* CONFIG_COMMON_CLK_REALTEK_TEE */
+
+static struct clk_fixed_rate pll_dcsb = {
+	.fixed_rate = 550000000,
+	.hw.init = &(struct clk_init_data) {
+		.name = "pll_dcsb",
+		.ops  = &clk_fixed_rate_ops,
+	},
+};
+
+#endif /* CONFIG_COMMON_CLK_REALTEK_TEE */
+
+static struct clk_fixed_factor clk_sysh = {
+	.div     = 1,
+	.mult    = 1,
+	.hw.init = &(struct clk_init_data) {
+		.name         = "clk_sysh",
+		.ops          = &clk_fixed_factor_ops,
+		.parent_names = (const char *[]){ "pll_dcsb" },
+		.num_parents  = 1,
+		.flags        = CLK_SET_RATE_PARENT,
+	},
+};
+
+static const struct freq_table ddsx_tbl[] = {
+	_NF(432000000, 13, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_ddsa = {
+	.conf         = CLK_PLL_TYPE_SSC_POW1,
+	.ssc_offset   = PLL_SSC_DIG_DDSA0,
+	.pll_offset   = PLL_DDSA1,
+	.freq_tbl     = ddsx_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ddsa",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_IGNORE_UNUSED | CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static const struct freq_table gpu_tbl[] = {
+	_NF(300000000, 19,  455),
+	_NF(400000000, 26, 1289),
+	_NF(500000000, 34,   75),
+	_NF(600000000, 41,  910),
+	_NF(650000000, 45,  303),
+	_NF(700000000, 48, 1745),
+	_NF(750000000, 52, 1137),
+	_NF(800000000, 56,  530),
+	_NF(850000000, 59, 1971),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_gpu = {
+	.conf         = CLK_PLL_TYPE_SSC_POW0,
+	.ssc_offset   = PLL_SSC_DIG_GPU0,
+	.pll_offset   = PLL_GPU1,
+	.freq_tbl     = gpu_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_gpu",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_composite_init_data clk_gpu_init = {
+	.mux_offset   = CLK_OFFSET_INVALID,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_GPU,
+	.gate_flags   = CLK_MMIO_GATE_HAS_WRITE_EN,
+	.parent_names = (const char *[]){ "pll_gpu" },
+	.num_parents  = 1,
+	.name         = "clk_gpu",
+	.flags        = CLK_SET_RATE_PARENT,
+};
+
+static struct freq_table ve_tbl[] = {
+	_MNO(189000000, 12, 0, 1),
+	_MNO(270000000, 18, 0, 1),
+	_MNO(405000000, 13, 0, 0),
+	_MNO(432000000, 14, 0, 0),
+	_MNO(459000000, 15, 0, 0),
+	_MNO(486000000, 16, 0, 0),
+	_MNO(513000000, 17, 0, 0),
+	_MNO(540000000, 18, 0, 0),
+	_MNO(550000000, 59, 2, 0),
+	_MNO(567000000, 19, 0, 0),
+	_MNO(594000000, 20, 0, 0),
+	_MNO(648000000, 22, 0, 0),
+	_MNO(675000000, 23, 0, 0),
+	_MNO(702000000, 24, 0, 0),
+	_MNO(715000000, 51, 1, 0),
+	FREQ_TABLE_END
+};
+
+static struct clk_pll pll_ve1 = {
+	.conf         = CLK_PLL_TYPE_POW,
+	.ssc_offset   = CLK_OFFSET_INVALID,
+	.pll_offset   = PLL_VE1_1,
+	.freq_tbl     = ve_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ve1",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_pll pll_ve2 = {
+	.conf         = CLK_PLL_TYPE_POW,
+	.ssc_offset   = CLK_OFFSET_INVALID,
+	.pll_offset   = PLL_VE2_1,
+	.freq_tbl     = ve_tbl,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_ve2",
+		.ops          = &clk_pll_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_composite_init_data clk_ve1_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE1_SEL_WIDTH,
+	.mux_shift    = CLK_VE1_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE1,
+	.gate_flags   = CLK_MMIO_GATE_HAS_WRITE_EN,
+	.parent_names = (const char *[]){
+		"clk_sys",
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve1",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve2_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE2_SEL_WIDTH,
+	.mux_shift    = CLK_VE2_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE1,
+	.gate_shift   = CLK_EN_VE2,
+	.gate_flags   = CLK_MMIO_GATE_HAS_WRITE_EN,
+	.parent_names = (const char *[]){
+		"clk_sys",
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve2",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve3_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE3_SEL_WIDTH,
+	.mux_shift    = CLK_VE3_SEL_SHIFT,
+	.gate_offset  = CLOCK_ENABLE4,
+	.gate_shift   = CLK_EN_VE3,
+	.gate_flags   = CLK_MMIO_GATE_HAS_WRITE_EN,
+	.parent_names = (const char *[]){
+		"clk_sys",
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve3",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_composite_init_data clk_ve2_bpu_init = {
+	.mux_offset   = VE_CKSEL,
+	.mux_width    = CLK_VE2_BPU_SEL_WIDTH,
+	.mux_shift    = CLK_VE2_BPU_SEL_SHIFT,
+	.gate_offset  = CLK_OFFSET_INVALID,
+	.parent_names = (const char *[]){
+		"clk_sys",
+		"clk_sysh",
+		"pll_ve1",
+		"pll_ve2",
+	},
+	.num_parents  = 4,
+	.name         = "clk_ve2_bpu",
+	.flags        = CLK_SET_RATE_PARENT | CLK_SET_RATE_NO_REPARENT,
+};
+
+static struct clk_pll_dif pll_dif = {
+	.ssc_offset   = PLL_SSC_DIG_PLLDIF0,
+	.pll_offset   = PLL_DIF1,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_dif",
+		.ops          = &clk_pll_dif_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_GET_RATE_NOCACHE,
+	},
+};
+
+static struct clk_pll_psaud pll_psaud1a = {
+	.reg = PLL_PSAUDA1,
+	.id  = CLK_PLL_PSAUD1A,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_psaud1a",
+		.ops          = &clk_pll_psaud_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_IGNORE_UNUSED | CLK_SET_RATE_UNGATE,
+	},
+};
+
+static struct clk_pll_psaud pll_psaud2a = {
+	.reg = PLL_PSAUDA1,
+	.id  = CLK_PLL_PSAUD2A,
+	.base.hw.init = &(struct clk_init_data) {
+		.name         = "pll_psaud2a",
+		.ops          = &clk_pll_psaud_ops,
+		.parent_names = DEFAULT_PARENT_OSC27M,
+		.num_parents  = 1,
+		.flags        = CLK_IGNORE_UNUSED | CLK_SET_RATE_UNGATE,
+	},
+};
+
+static struct clk_hw *clk_reg_list[] = {
+#ifndef CONFIG_COMMON_CLK_REALTEK_TEE
+	[CC_PLL_SCPU]    = &__clk_pll_div_hw(&pll_scpu),
+	[CC_PLL_BUS]     = &__clk_pll_div_hw(&pll_bus),
+	[CC_PLL_DCSB]    = &__clk_pll_div_hw(&pll_dcsb),
+#else
+	[CC_PLL_SCPU]    = (struct clk_hw *)-ENODEV,
+	[CC_PLL_BUS]     = &pll_bus.hw,
+	[CC_PLL_DCSB]    = &pll_dcsb.hw,
+#endif /* CONFIG_COMMON_CLK_REALTEK_TEE */
+	[CC_PLL_DDSA]    = &__clk_pll_hw(&pll_ddsa),
+	[CC_PLL_GPU]     = &__clk_pll_hw(&pll_gpu),
+	[CC_PLL_VE1]     = &__clk_pll_hw(&pll_ve1),
+	[CC_PLL_VE2]     = &__clk_pll_hw(&pll_ve2),
+	[CC_PLL_DIF]     = &__clk_pll_dif_hw(&pll_dif),
+	[CC_CLK_SYS_SB2] = &__clk_mmio_mux_hw(&clk_sys_sb2),
+	[CC_CLK_SYS]     = &clk_sys.hw,
+	[CC_CLK_SYSH]    = &clk_sysh.hw,
+	[CC_PLL_PSAUD1A] = &__clk_pll_psaud_hw(&pll_psaud1a),
+	[CC_PLL_PSAUD2A] = &__clk_pll_psaud_hw(&pll_psaud2a),
+};
+
+static  struct clk_composite_init_data *composite_clks[] = {
+	[CC_CLK_GPU] = &clk_gpu_init,
+	[CC_CLK_VE1] = &clk_ve1_init,
+	[CC_CLK_VE2] = &clk_ve2_init,
+	[CC_CLK_VE3] = &clk_ve3_init,
+	[CC_CLK_VE2_BPU] = &clk_ve2_bpu_init,
+};
+
+static int rtd16xx_cc_init_clocks(struct device *dev)
+{
+	struct cc_platform_data *ccd = dev_get_drvdata(dev);
+	int i;
+	int ret;
+
+	for (i = 0; i < ARRAY_SIZE(clk_reg_list); i++) {
+		struct clk_hw *hw = clk_reg_list[i];
+		const char *name;
+
+		if (IS_ERR(hw))
+			ccd->data.clks[i] = ERR_CAST(hw);
+		if (IS_ERR_OR_NULL(hw))
+			continue;
+
+		name = hw->init->name;
+		ret = cc_init_hw(dev, ccd, i, hw);
+		if (ret) {
+			dev_err(dev, "%s: failed in cc_init_hw: %d\n",
+				name, ret);
+			continue;
+		}
+	}
+
+	for (i = 0; i < ARRAY_SIZE(composite_clks); i++) {
+		struct clk_composite_init_data *data = composite_clks[i];
+		const char *name;
+
+		if (!data)
+			continue;
+
+		name = data->name;
+		ret = cc_init_composite_clk(dev, ccd, i, data);
+		if (ret) {
+			dev_err(dev, "%s: failed in cc_init_composite_clk: %d\n",
+				name, ret);
+			continue;
+		}
+	}
+
+	if (clk_sys.hw.clk && clk_sys_sb2.base.hw.clk)
+		clk_notifier_register(clk_sys.hw.clk, &clk_sys_sb2_nb);
+
+	return 0;
+}
+
+static int rtd16xx_cc_probe(struct platform_device *pdev)
+{
+	struct cc_platform_data *ccd;
+
+	ccd = devm_cc_alloc_platform_data(&pdev->dev, CC_CLK_MAX);
+	if (!ccd)
+		return -ENOMEM;
+
+	platform_set_drvdata(pdev, ccd);
+	return cc_probe_platform(pdev, ccd, rtd16xx_cc_init_clocks);
+}
+
+static const struct of_device_id rtd16xx_cc_match[] = {
+	{ .compatible = "realtek,clock-controller", },
+	{}
+};
+
+static struct platform_driver rtd16xx_cc_driver = {
+	.probe = rtd16xx_cc_probe,
+	.driver = {
+		.name = "rtk-rtd16xx-cc",
+		.of_match_table = rtd16xx_cc_match,
+		.pm = &cc_pm_ops,
+	},
+};
+
+static int __init rtd16xx_cc_init(void)
+{
+	return platform_driver_register(&rtd16xx_cc_driver);
+}
+core_initcall(rtd16xx_cc_init);
diff --git a/drivers/clk/realtek/cc-tee.c b/drivers/clk/realtek/cc-tee.c
new file mode 100644
index 00000000..fc173e9
--- /dev/null
+++ b/drivers/clk/realtek/cc-tee.c
@@ -0,0 +1,221 @@
+/*
+ * cc-tee.c - TEE clock controller
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include <soc/realtek/rtk_event.h>
+
+#define HZ_PER_MHZ            1000000
+#define TA_CMD_SCPU_PLL       5
+
+struct ta_clk_data {
+	struct clk_hw hw;
+	struct device *dev;
+	unsigned long freq_mhz;
+	struct tee_context *ctx;
+	struct tee_ioctl_open_session_arg arg;
+};
+
+static const u8 uuid[TEE_IOCTL_UUID_LEN] = {
+	0x65, 0x0b, 0x79, 0xa1, 0xa7, 0x9a, 0x43, 0xea,
+	0x91, 0x85, 0xf6, 0x67, 0x55, 0x65, 0x64, 0xa7,
+};
+
+static int ta_clk_optee_match(struct tee_ioctl_version_data *vers,
+			      const void *data)
+{
+	if (vers->impl_id == TEE_IMPL_ID_OPTEE)
+		return 1;
+	return 0;
+}
+
+static int ta_clk_init_client(struct ta_clk_data *tcd)
+{
+	struct tee_ioctl_version_data vers = {
+		.impl_id   = TEE_IMPL_ID_OPTEE,
+		.impl_caps = TEE_OPTEE_CAP_TZ,
+		.gen_caps  = TEE_GEN_CAP_GP,
+	};
+	int ret;
+
+	tcd->ctx = tee_client_open_context(NULL, ta_clk_optee_match, NULL,
+					   &vers);
+	if (IS_ERR(tcd->ctx)) {
+		ret = PTR_ERR(tcd->ctx);
+		dev_err(tcd->dev, "failed to open context: %d\n", ret);
+		return ret;
+	}
+
+	memcpy(tcd->arg.uuid, uuid, TEE_IOCTL_UUID_LEN);
+	tcd->arg.clnt_login = TEE_IOCTL_LOGIN_PUBLIC;
+	tcd->arg.num_params = 0;
+
+	ret = tee_client_open_session(tcd->ctx, &tcd->arg, NULL);
+	if (ret)
+		dev_err(tcd->dev, "failed to open session: %d\n", ret);
+	return ret;
+}
+
+static int ta_clk_set_pll_scpu_freq(struct ta_clk_data *tcd, unsigned int freq)
+{
+	struct tee_ioctl_invoke_arg inv_arg;
+	struct tee_param param[4];
+	int ret;
+
+	memset(&inv_arg, 0, sizeof(inv_arg));
+	memset(&param, 0, sizeof(param));
+
+	inv_arg.func = TA_CMD_SCPU_PLL;
+	inv_arg.session = tcd->arg.session;
+	inv_arg.num_params = 4;
+
+	param[0].u.value.a = freq;
+	param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	ret = tee_client_invoke_func(tcd->ctx, &inv_arg, param);
+	if ((ret < 0) || (inv_arg.ret != 0)) {
+		dev_err(tcd->dev, "failed to invoke func: %d, %x\n", ret,
+			inv_arg.ret);
+		return -EINVAL;
+	}
+
+	if (param[0].u.value.b) {
+		dev_err(tcd->dev, "failed to set freq: %lld\n",
+			param[0].u.value.b);
+		return -EINVAL;
+	}
+
+	return 0;
+}
+
+
+static long ta_clk_round_rate(struct clk_hw *hw, unsigned long rate,
+			      unsigned long *parent_rate)
+{
+	rate /= HZ_PER_MHZ;
+	rate = rate > 1400 ? 1400 : rate;
+	rate = rate < 300 ? 300 : rate;
+	return rate * HZ_PER_MHZ;
+}
+
+static unsigned long ta_clk_recalc_rate(struct clk_hw *hw,
+					unsigned long parent_rate)
+{
+	struct ta_clk_data *tcd = container_of(hw, struct ta_clk_data, hw);
+
+	return tcd->freq_mhz * HZ_PER_MHZ;
+}
+
+static int ta_clk_set_rate(struct clk_hw *hw, unsigned long rate,
+			   unsigned long parent_rate)
+{
+	struct ta_clk_data *tcd = container_of(hw, struct ta_clk_data, hw);
+	unsigned long freq_mhz = rate / HZ_PER_MHZ;
+	int ret;
+	ktime_t start;
+	s64 delta_us;
+
+	dev_dbg(tcd->dev, "enter %s (freq=%lu)\n", __func__, freq_mhz);
+
+	start = ktime_get();
+	ret = ta_clk_set_pll_scpu_freq(tcd, freq_mhz);
+	if (ret)
+		goto done;
+	tcd->freq_mhz = freq_mhz;
+done:
+	delta_us = ktime_to_us(ktime_sub(ktime_get(), start));
+	dev_dbg(tcd->dev, "exit %s (freq=%lu, time=%lld, ret=%d)\n", __func__,
+		freq_mhz, delta_us,  ret);
+	return ret;
+}
+
+static const struct clk_ops ta_clk_ops = {
+	 .round_rate       = ta_clk_round_rate,
+	 .recalc_rate      = ta_clk_recalc_rate,
+	 .set_rate         = ta_clk_set_rate,
+};
+
+static struct ta_clk_data pll_scpu = {
+	.freq_mhz = 1100,
+	.hw.init = &(struct clk_init_data) {
+		.name = "pll_scpu",
+		.ops  = &ta_clk_ops,
+	},
+};
+
+static int rtd16xx_tcc_probe(struct platform_device *pdev)
+{
+	int ret;
+	struct device *dev = &pdev->dev;
+	struct clk *clk;
+	struct ta_clk_data *tcd = &pll_scpu;
+
+	tcd->dev = dev;
+
+	ret = ta_clk_init_client(tcd);
+	if (ret)
+		return -EPROBE_DEFER;
+
+	ret = ta_clk_set_pll_scpu_freq(tcd, tcd->freq_mhz);
+	if (ret)
+		return ret;
+
+	clk = clk_register(NULL, &pll_scpu.hw);
+	if (IS_ERR(clk)) {
+		ret = PTR_ERR(clk);
+		dev_err(dev, "failed to register clk: %d\n", ret);
+		return ret;
+	}
+	platform_set_drvdata(pdev, clk);
+
+	of_clk_add_provider(dev->of_node, of_clk_src_simple_get, clk);
+	clk_register_clkdev(clk, __clk_get_name(clk), NULL);
+
+	rtk_clk_notify(clk, CLK_EVENT_REGISTERED);
+	dev_err(dev, "initialized\n");
+	return 0;
+}
+
+static const struct of_device_id rtd16xx_tcc_match[] = {
+	{ .compatible = "realtek,tee-clock-controller", },
+	{}
+};
+
+static struct platform_driver rtd16xx_tcc_driver = {
+	.probe = rtd16xx_tcc_probe,
+	.driver = {
+		.name = "rtk-tee-cc",
+		.of_match_table = rtd16xx_tcc_match,
+	},
+};
+
+static int __init rtd16xx_tcc_init(void)
+{
+	return platform_driver_register(&rtd16xx_tcc_driver);
+}
+late_initcall(rtd16xx_tcc_init);
diff --git a/drivers/clk/realtek/cgc.c b/drivers/clk/realtek/cgc.c
new file mode 100644
index 00000000..197eb17
--- /dev/null
+++ b/drivers/clk/realtek/cgc.c
@@ -0,0 +1,300 @@
+/*
+ * cgc.c - clock-gate controller
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/slab.h>
+#include <linux/platform_device.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/clk.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/bitops.h>
+#include <linux/pm.h>
+#include <soc/realtek/rtk_mmio.h>
+#include "common.h"
+#include "clk-mmio-gate.h"
+
+#define MAX_CLOCK_GATES  32
+
+struct cgc_desc {
+	const char *names[MAX_CLOCK_GATES];
+	int num_names;
+	unsigned int flags;
+	unsigned int pm_mask;
+	unsigned int ignore_unsed_mask;
+};
+
+/* flags */
+#define CGC_FLAGS_HAS_WEB  0x1
+
+struct cgc_data {
+	struct device *dev;
+	struct cgc_desc desc;
+	struct clk_reg_init_data init_data;
+	struct clk_onecell_data clk_data;
+	unsigned int pm_data;
+};
+
+
+static inline int cgc_has_web(struct cgc_data *cgcd)
+{
+	return !!(cgcd->desc.flags & CGC_FLAGS_HAS_WEB);
+}
+
+static int init_clk_gates(struct cgc_data *cgcd)
+{
+	int i;
+	struct cgc_desc *desc = &cgcd->desc;
+	struct clk_onecell_data *data = &cgcd->clk_data;
+	struct device *dev = cgcd->dev;
+	struct device_node *np = dev->of_node;
+	unsigned int flags = 0;
+	unsigned int num_clks = desc->num_names;
+	const char *name = NULL;
+	int ret = 0;
+
+	if (cgc_has_web(cgcd)) {
+		flags |= CLK_MMIO_GATE_HAS_WRITE_EN;
+		num_clks *= 2;
+	}
+
+	data->clks = kcalloc(num_clks, sizeof(struct clk *), GFP_KERNEL);
+	if (!data->clks)
+		return -ENOMEM;
+	data->clk_num = num_clks;
+
+	for (i = 0; i < desc->num_names; i++) {
+		struct clk_mmio_gate *gate;
+		struct clk_init_data init = { 0 };
+		struct clk *clk;
+		int idx = cgc_has_web(cgcd) ? i * 2 : i;
+
+		name = desc->names[i];
+		if (!name || !name[0] || !strncmp(name, "unused", 6))
+			continue;
+
+		/* setup clk init data */
+		init.name = name;
+		init.ops = &clk_mmio_gate_ops;
+		init.flags = CLK_IS_BASIC;
+		if (desc->ignore_unsed_mask & BIT(i))
+			init.flags |= CLK_IGNORE_UNUSED;
+
+		gate = kzalloc(sizeof(*gate), GFP_KERNEL);
+		if  (!gate) {
+			ret = -ENOMEM;
+			break;
+		}
+
+		/* setup init data for specific clk type */
+		gate->bit_idx = idx;
+		gate->base.hw.init = &init;
+		gate->flags = flags;
+		clk_reg_init(&gate->base, &cgcd->init_data);
+
+		/* register clk */
+		clk = clk_register(NULL, &gate->base.hw);
+		if (IS_ERR(clk)) {
+			dev_err(dev, "%s: failed to register: %ld\n",
+				name, PTR_ERR(clk));
+			ret = PTR_ERR(clk);
+			break;
+		}
+		data->clks[idx] = clk;
+
+		dev_dbg(dev, "name-index=%d, clk-index=%d, clk-name=%s\n",
+			i, idx, name);
+
+		/* register clkdev */
+		clk_register_clkdev(clk, name, NULL);
+	}
+
+	if (ret)
+		dev_err(dev, "failed to init %s(%d): %d\n", name, i, ret);
+
+	return of_clk_add_provider(np, of_clk_src_onecell_get, data);
+}
+
+static int rtk_cgc_suspend(struct device *dev)
+{
+	struct cgc_data *cgcd = dev_get_drvdata(dev);
+	struct clk_reg clk_reg;
+
+	dev_info(dev, "enter %s\n", __func__);
+
+	/* create a clk_reg for read/write reg */
+	clk_reg_init(&clk_reg, &cgcd->init_data);
+	cgcd->pm_data = clk_reg_read(&clk_reg, 0);
+	dev_dbg(dev, "save pm_data=%08x\n", cgcd->pm_data);
+
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_cgc_resume(struct device *dev)
+{
+	struct cgc_data *cgcd = dev_get_drvdata(dev);
+	struct clk_reg clk_reg;
+	int mask;
+	int val;
+
+	dev_info(dev, "enter %s\n", __func__);
+
+	clk_reg_init(&clk_reg, &cgcd->init_data);
+	mask = cgcd->desc.pm_mask;
+	val  = cgcd->pm_data;
+
+	if (cgc_has_web(cgcd)) {
+		mask |= cgcd->desc.pm_mask << 1;
+		val  |= cgcd->desc.pm_mask << 1;
+	}
+
+	dev_dbg(dev, "restore mask=%08x, val=%08x, pm_data=%08x\n",
+		mask, val, cgcd->pm_data);
+	clk_reg_update(&clk_reg, 0, mask, val);
+
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_cgc_pm_ops = {
+	.suspend_noirq = rtk_cgc_suspend,
+	.resume_noirq = rtk_cgc_resume,
+};
+
+static int of_get_cgc_desc(struct device_node *np, struct cgc_desc *desc)
+{
+	struct property *prop;
+	const char *s;
+	int ret;
+	int i;
+
+	if (of_property_read_bool(np, "has-write-en") ||
+	    of_property_read_bool(np, "realtek,has-web"))
+		desc->flags |= CGC_FLAGS_HAS_WEB;
+
+	ret = of_property_count_strings(np, "clock-output-names");
+	if (ret < 0)
+		return ret;
+	desc->num_names = ret;
+
+	ret = of_property_read_string_array(np, "clock-output-names",
+					    desc->names, desc->num_names);
+	if (ret != desc->num_names)
+		return -EINVAL;
+	if (ret < 0)
+		return ret;
+
+	desc->ignore_unsed_mask = 0;
+	of_property_for_each_string(np, "ignore-unused-clocks", prop, s) {
+		ret = of_property_match_string(np, "clock-output-names", s);
+		if (ret < 0)
+			continue;
+		desc->ignore_unsed_mask |= BIT(ret);
+	}
+
+	desc->pm_mask = 0;
+	i = 0;
+	of_property_for_each_string(np, "clock-output-names", prop, s) {
+		if (s && s[0] && strncmp(s, "unused", 6) &&
+		    !of_clk_is_ignore_pm(np, s))
+			desc->pm_mask |= BIT(i);
+		i += (desc->flags & CGC_FLAGS_HAS_WEB) ? 2 : 1;
+	}
+	return 0;
+}
+
+static int devm_of_get_clk_reg_init_data(struct device *dev,
+					 int index,
+					 struct clk_reg_init_data *idata)
+{
+	struct device_node *np = dev->of_node;
+	struct regmap *regmap;
+	int offset = 0;
+	struct resource r;
+	int ret;
+
+	regmap = of_get_rtk_mmio_regmap_with_offset(np, index, &offset);
+	if (!IS_ERR_OR_NULL(regmap)) {
+		idata->regmap = regmap;
+		idata->offset = offset;
+		return 0;
+	}
+
+	ret = of_address_to_resource(np, index, &r);
+	if (ret)
+		return ret;
+	idata->reg = devm_ioremap(dev, r.start, resource_size(&r));
+	return idata->reg ? 0 : -ENOMEM;
+}
+
+
+static int rtk_cgc_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	struct cgc_data *cgcd;
+	int ret;
+
+	cgcd = devm_kzalloc(dev, sizeof(*cgcd), GFP_KERNEL);
+	if (!cgcd)
+		return -ENOMEM;
+
+	cgcd->dev = dev;
+
+	ret = of_get_cgc_desc(np, &cgcd->desc);
+	if (ret) {
+		dev_err(dev, "failed to get cgc_desc: %d\n", ret);
+		return ret;
+	}
+
+	ret = devm_of_get_clk_reg_init_data(dev, 0, &cgcd->init_data);
+	if (ret) {
+		dev_err(dev, "failed to get clk_reg_init_data: %d", ret);
+		return ret;
+	}
+
+	platform_set_drvdata(pdev, cgcd);
+	init_clk_gates(cgcd);
+	dev_info(dev, "initialized");
+	return 0;
+}
+
+static const struct of_device_id rtk_cgc_match[] = {
+	{.compatible = "realtek,clock-gate-controller"},
+	{}
+};
+
+static struct platform_driver rtk_cgc_driver = {
+	.probe = rtk_cgc_probe,
+	.driver = {
+		.name = "rtk-cgc",
+		.of_match_table = rtk_cgc_match,
+		.pm = &rtk_cgc_pm_ops,
+	},
+};
+
+static int __init rtk_cgc_init(void)
+{
+	return platform_driver_register(&rtk_cgc_driver);
+}
+core_initcall(rtk_cgc_init);
diff --git a/drivers/clk/realtek/clk-mmio-gate.c b/drivers/clk/realtek/clk-mmio-gate.c
new file mode 100644
index 00000000..c9d3b8b
--- /dev/null
+++ b/drivers/clk/realtek/clk-mmio-gate.c
@@ -0,0 +1,103 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/slab.h>
+#include <linux/clk-provider.h>
+#include "clk-mmio-gate.h"
+
+static int clk_mmio_gate_enable(struct clk_hw *hw)
+{
+	struct clk_mmio_gate *g = to_clk_mmio_gate(hw);
+	unsigned long flags = 0;
+	unsigned int mask;
+	unsigned int val;
+
+	if (g->lock)
+		spin_lock_irqsave(g->lock, flags);
+
+	mask = BIT(g->bit_idx);
+	val  = BIT(g->bit_idx);
+
+	if (g->flags & CLK_MMIO_GATE_HAS_WRITE_EN) {
+		mask |= BIT(g->bit_idx + 1);
+		val  |= BIT(g->bit_idx + 1);
+	}
+
+	clk_reg_update(&g->base, g->gate_offset, mask, val);
+
+	if (g->lock)
+		spin_unlock_irqrestore(g->lock, flags);
+
+	return 0;
+}
+
+static void clk_mmio_gate_disable(struct clk_hw *hw)
+{
+	struct clk_mmio_gate *g = to_clk_mmio_gate(hw);
+	unsigned long flags = 0;
+	unsigned int mask;
+	unsigned int val;
+
+	if (g->lock)
+		spin_lock_irqsave(g->lock, flags);
+
+	mask = BIT(g->bit_idx);
+	val  = 0;
+
+	if (g->flags & CLK_MMIO_GATE_HAS_WRITE_EN) {
+		mask |= BIT(g->bit_idx + 1);
+		val  |= BIT(g->bit_idx + 1);
+	}
+
+	clk_reg_update(&g->base, g->gate_offset, mask, val);
+
+	if (g->lock)
+		spin_unlock_irqrestore(g->lock, flags);
+}
+
+static void clk_mmio_gate_disable_unused(struct clk_hw *hw)
+{
+	pr_info("%s: %s\n", __func__, __clk_get_name(hw->clk));
+	clk_mmio_gate_disable(hw);
+}
+
+static int clk_mmio_gate_is_enabled(struct clk_hw *hw)
+{
+	struct clk_mmio_gate *g = to_clk_mmio_gate(hw);
+	int ret;
+	unsigned long flags = 0;
+
+	if (g->lock)
+		spin_lock_irqsave(g->lock, flags);
+
+	ret = !!(clk_reg_read(&g->base, g->gate_offset) & BIT(g->bit_idx));
+
+	if (g->lock)
+		spin_unlock_irqrestore(g->lock, flags);
+
+	return ret;
+}
+
+const struct clk_ops clk_mmio_gate_ops = {
+	.enable = clk_mmio_gate_enable,
+	.disable = clk_mmio_gate_disable,
+	.disable_unused = clk_mmio_gate_disable_unused,
+	.is_enabled = clk_mmio_gate_is_enabled,
+};
diff --git a/drivers/clk/realtek/clk-mmio-mux.c b/drivers/clk/realtek/clk-mmio-mux.c
new file mode 100644
index 00000000..7509360
--- /dev/null
+++ b/drivers/clk/realtek/clk-mmio-mux.c
@@ -0,0 +1,79 @@
+/*
+ * clk-mmio-mux.c - this file is based on clk-mux.c
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/err.h>
+#include "clk-mmio-mux.h"
+
+static u8 clk_mmio_mux_get_parent(struct clk_hw *hw)
+{
+	struct clk_mmio_mux *mux = to_clk_mmio_mux(hw);
+	int num_parents = clk_hw_get_num_parents(hw);
+	u32 val;
+	unsigned long flags = 0;
+
+	if (mux->lock)
+		spin_lock_irqsave(mux->lock, flags);
+
+	val = clk_reg_read(&mux->base, mux->mux_offset) >> mux->shift;
+	if (mux->lock)
+		spin_unlock_irqrestore(mux->lock, flags);
+
+	val &= mux->mask;
+	if (val >= num_parents)
+		return -EINVAL;
+
+	return val;
+}
+
+static int clk_mmio_mux_set_parent(struct clk_hw *hw, u8 index)
+{
+	struct clk_mmio_mux *mux = to_clk_mmio_mux(hw);
+	unsigned long flags = 0;
+
+	if (mux->lock)
+		spin_lock_irqsave(mux->lock, flags);
+
+	clk_reg_update(&mux->base, mux->mux_offset, mux->mask << mux->shift,
+		index << mux->shift);
+
+	if (mux->lock)
+		spin_unlock_irqrestore(mux->lock, flags);
+	return 0;
+}
+
+const struct clk_ops clk_mmio_mux_ops = {
+	.get_parent = clk_mmio_mux_get_parent,
+	.set_parent = clk_mmio_mux_set_parent,
+	.determine_rate = __clk_mux_determine_rate,
+};
+EXPORT_SYMBOL_GPL(clk_mmio_mux_ops);
+
+const struct clk_ops clk_mmio_mux_ro_ops = {
+	.get_parent = clk_mmio_mux_get_parent,
+};
+EXPORT_SYMBOL_GPL(clk_mmio_mux_ro_ops);
+
diff --git a/drivers/clk/realtek/clk-notify.c b/drivers/clk/realtek/clk-notify.c
new file mode 100644
index 00000000..6da59ec
--- /dev/null
+++ b/drivers/clk/realtek/clk-notify.c
@@ -0,0 +1,44 @@
+/*
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/notifier.h>
+#include <linux/clk-provider.h>
+#include <linux/module.h>
+MODULE_LICENSE("GPL");
+
+static ATOMIC_NOTIFIER_HEAD(rtk_clk_notifier);
+
+void rtk_clk_notify(struct clk *clk, unsigned int long event)
+{
+	atomic_notifier_call_chain(&rtk_clk_notifier, event, clk);
+}
+
+int rtk_clk_notifier_register(struct notifier_block *nb)
+{
+	return atomic_notifier_chain_register(&rtk_clk_notifier, nb);
+}
+EXPORT_SYMBOL_GPL(rtk_clk_notifier_register);
+
+int rtk_clk_notifier_unregister(struct notifier_block *nb)
+{
+        return atomic_notifier_chain_unregister(&rtk_clk_notifier, nb);
+}
+EXPORT_SYMBOL_GPL(rtk_clk_notifier_unregister);
+
diff --git a/drivers/clk/realtek/clk-pll-dif.c b/drivers/clk/realtek/clk-pll-dif.c
new file mode 100644
index 00000000..5fb46c4
--- /dev/null
+++ b/drivers/clk/realtek/clk-pll-dif.c
@@ -0,0 +1,98 @@
+/*
+ * clk-pll-dif.c - PLL_DIF
+ *
+ * Copyright (c) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *       Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk-provider.h>
+#include <linux/clk.h>
+#include <linux/spinlock.h>
+#include <linux/delay.h>
+#include "common.h"
+#include "clk-pll.h"
+
+static int clk_pll_dif_enable(struct clk_hw *hw)
+{
+	struct clk_pll_dif *pll = to_clk_pll_dif(hw);
+
+	pr_debug("%pC: %s\n", hw->clk, __func__);
+
+	clk_reg_write(&pll->base, pll->pll_offset + 0x0C, 0x00000048);
+	clk_reg_write(&pll->base, pll->pll_offset + 0x08, 0x00020c00);
+	clk_reg_write(&pll->base, pll->pll_offset + 0x04, 0x204004ca);
+	clk_reg_write(&pll->base, pll->pll_offset + 0x00, 0x8000a000);
+	udelay(100);
+
+	clk_reg_write(&pll->base, pll->pll_offset + 0x08, 0x00420c00);
+	udelay(50);
+
+	clk_reg_write(&pll->base, pll->pll_offset + 0x08, 0x00420c03);
+	udelay(200);
+
+	clk_reg_write(&pll->base, pll->pll_offset + 0x0C, 0x00000078);
+	udelay(100);
+
+	clk_reg_write(&pll->base, pll->pll_offset + 0x04, 0x204084ca);
+
+	/* ssc control */
+	clk_reg_write(&pll->base, pll->ssc_offset + 0x00, 0x00000004);
+	clk_reg_write(&pll->base, pll->ssc_offset + 0x04, 0x00006800);
+	clk_reg_write(&pll->base, pll->ssc_offset + 0x0C, 0x00000000);
+	clk_reg_write(&pll->base, pll->ssc_offset + 0x10, 0x00000000);
+	clk_reg_write(&pll->base, pll->ssc_offset + 0x08, 0x001e1f98);
+	clk_reg_write(&pll->base, pll->ssc_offset + 0x00, 0x00000005);
+	pll->status &= ~CLK_PLL_DISABLED;
+
+	return 0;
+}
+
+static void clk_pll_dif_disable(struct clk_hw *hw)
+{
+	struct clk_pll_dif *pll = to_clk_pll_dif(hw);
+
+	pr_debug("%pC: %s\n", hw->clk, __func__);
+	clk_reg_update(&pll->base, pll->pll_offset + 0x04, 0x00080000, 0x0);
+	clk_reg_update(&pll->base, pll->pll_offset + 0x08, 0x00400C03, 0x0);
+	clk_reg_update(&pll->base, pll->pll_offset + 0x0C, 0x00000038, 0x0);
+
+	clk_reg_write(&pll->base, pll->ssc_offset + 0x00, 0x00000004);
+	pll->status |= CLK_PLL_DISABLED;
+}
+
+static int clk_pll_dif_is_enabled(struct clk_hw *hw)
+{
+	struct clk_pll_dif *pll = to_clk_pll_dif(hw);
+
+	pr_debug("%pC: %s\n", hw->clk, __func__);
+	return !(pll->status & CLK_PLL_DISABLED);
+}
+
+static void clk_pll_dif_disable_unused(struct clk_hw *hw)
+{
+	pr_info("%pC: %s\n", hw->clk, __func__);
+	clk_pll_dif_disable(hw);
+}
+
+const struct clk_ops clk_pll_dif_ops = {
+	.enable           = clk_pll_dif_enable,
+	.disable          = clk_pll_dif_disable,
+	.disable_unused   = clk_pll_dif_disable_unused,
+	.is_enabled       = clk_pll_dif_is_enabled,
+};
+
diff --git a/drivers/clk/realtek/clk-pll-psaud.c b/drivers/clk/realtek/clk-pll-psaud.c
new file mode 100644
index 00000000..209ed13
--- /dev/null
+++ b/drivers/clk/realtek/clk-pll-psaud.c
@@ -0,0 +1,142 @@
+/*
+ * clk-pll-psaud.c - PLL_PSAUDXA
+ *
+ * Copyright (c) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *       Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk-provider.h>
+#include "common.h"
+#include "clk-pll.h"
+
+static int clk_pll_psaud_enable(struct clk_hw *hw)
+{
+	struct clk_pll_psaud *pll = to_clk_pll_psaud(hw);
+	u32 mask = 0, val = 0;
+
+	if (pll->id == CLK_PLL_PSAUD1A) {
+		mask = 0x3;
+		val = 0x1;
+	} else {
+		mask = 0xc;
+		val = 0x4;
+	}
+	clk_reg_update(&pll->base, pll->reg + 4, mask, val);
+	return 0;
+}
+
+static void clk_pll_psaud_disable(struct clk_hw *hw)
+{
+	struct clk_pll_psaud *pll = to_clk_pll_psaud(hw);
+	u32 mask = 0, val = 0;
+
+	if (pll->id == CLK_PLL_PSAUD1A) {
+		mask = 0x3;
+		val = 0x3;
+	} else {
+		mask = 0xc;
+		val = 0xc;
+	}
+	clk_reg_update(&pll->base, pll->reg + 4, mask, val);
+}
+
+static void clk_pll_psaud_disable_unused(struct clk_hw *hw)
+{
+	pr_info("%pC: %s\n", hw->clk, __func__);
+	clk_pll_psaud_disable(hw);
+}
+
+static int clk_pll_psaud_is_enabled(struct clk_hw *hw)
+{
+	struct clk_pll_psaud *pll = to_clk_pll_psaud(hw);
+	u32 val;
+
+	val = clk_reg_read(&pll->base, pll->reg + 4);
+	if (pll->id == CLK_PLL_PSAUD1A)
+		val &= 0x3;
+	else
+		val >>= 2;
+	return val == 0x1;
+}
+
+static long clk_pll_psaud_round_rate(struct clk_hw *hw,
+				     unsigned long rate,
+				     unsigned long *parent_rate)
+{
+	if (WARN_ON_ONCE(*parent_rate != default_osc_rate))
+		return -EINVAL;
+	return 49192000;
+}
+
+static int clk_pll_psaud_set_rate(struct clk_hw *hw,
+				  unsigned long rate,
+				  unsigned long parent_rate)
+{
+	struct clk_pll_psaud *pll = to_clk_pll_psaud(hw);
+	u32 rsel = 0;
+	u32 mask = 0, val = 0;
+
+	if (WARN_ON_ONCE(parent_rate != default_osc_rate))
+		return -EINVAL;
+
+	if (WARN_ON_ONCE(rate != 45158400 && rate != 49192000))
+		return -EINVAL;
+
+	if (rate == 45158400)
+		rsel = 1;
+	if (pll->id == CLK_PLL_PSAUD1A) {
+		val  = 0x6a0 | (rsel << 8);
+		mask = 0x7e0;
+	} else {
+		val  = 0x19 | (rsel << 2);
+		mask = 0x1f;
+	}
+	clk_reg_update(&pll->base, pll->reg, mask, val);
+	return 0;
+}
+
+static unsigned long clk_pll_psaud_recalc_rate(struct clk_hw *hw,
+					       unsigned long parent_rate)
+{
+	struct clk_pll_psaud *pll = to_clk_pll_psaud(hw);
+	u32 val;
+	u32 rsel = 0;
+
+	if (WARN_ON_ONCE(parent_rate != default_osc_rate))
+		return 0;
+
+	val = clk_reg_read(&pll->base, pll->reg);
+
+	if (pll->id == CLK_PLL_PSAUD1A)
+		rsel = !!(val & BIT(8));
+	else
+		rsel = !!(val & BIT(2));
+
+	return rsel ? 45158400 : 49192000;
+}
+
+const struct clk_ops clk_pll_psaud_ops = {
+	.enable         = clk_pll_psaud_enable,
+	.disable        = clk_pll_psaud_disable,
+	.disable_unused = clk_pll_psaud_disable_unused,
+	.is_enabled     = clk_pll_psaud_is_enabled,
+	.set_rate       = clk_pll_psaud_set_rate,
+	.round_rate     = clk_pll_psaud_round_rate,
+	.recalc_rate    = clk_pll_psaud_recalc_rate,
+};
+
diff --git a/drivers/clk/realtek/clk-pll.c b/drivers/clk/realtek/clk-pll.c
new file mode 100644
index 00000000..1ffd3ad
--- /dev/null
+++ b/drivers/clk/realtek/clk-pll.c
@@ -0,0 +1,511 @@
+/*
+ * clk-pll.c - Realtek clk-pll & clk-pll-div implementation
+ *
+ * Copyright (C) 2017-2018 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/io.h>
+#include <linux/slab.h>
+#include <linux/clk-provider.h>
+#include <linux/clk.h>
+#include <linux/spinlock.h>
+#include <linux/delay.h>
+#include <linux/debugfs.h>
+#include "common.h"
+#include "clk-pll.h"
+
+#define ck_dbg(clk, fmt, ...) \
+	pr_debug("%pC: %s:" fmt, clk, __func__, ##__VA_ARGS__)
+
+#define DEFUALT_OSC_RATE                (27000000)
+#define DEFAULT_MAX_OC_DONE_RETRY       (20000)
+
+/*
+ * Since table lookup is used for freq selection, default osc rate is required
+ * for validation.
+ */
+unsigned long default_osc_rate = DEFUALT_OSC_RATE;
+
+static int clk_pll_debugfs_u64_set(void *data, u64 val)
+{
+	struct clk_hw *hw = data;
+
+	clk_set_rate(hw->clk, (unsigned long)(val));
+	return 0;
+}
+
+static int clk_pll_debugfs_u64_get(void *data, u64 *val)
+{
+	struct clk_hw *hw = data;
+
+	*val = (u64)clk_get_rate(hw->clk);
+	return 0;
+}
+
+DEFINE_SIMPLE_ATTRIBUTE(clk_pll_rate_op,
+			clk_pll_debugfs_u64_get,
+			clk_pll_debugfs_u64_set,
+			"%llu\n");
+
+
+static int clk_pll_conf_show(struct seq_file *s, void *data)
+{
+	struct clk_hw *hw = s->private;
+	struct clk_pll *pll = to_clk_pll(hw);
+	const struct freq_table *ftbl = pll->freq_tbl;
+
+	seq_printf(s, "%pC\n", hw->clk);
+	seq_printf(s, "raw_conf: 0x%08x\n", pll->conf);
+
+	if (pll->ops == &clk_pll_ops || pll->ops == &clk_pll_div_ops) {
+		seq_printf(s, "freq-tbl-entries:\n");
+		for ( ; !IS_FREQ_TABLE_END(ftbl); ftbl++)
+			seq_printf(s, "   %10lu : %08x\n", ftbl->rate, ftbl->val);
+	}
+
+	if (pll->ops == &clk_pll_div_ops) {
+		struct clk_pll_div *plld = to_clk_pll_div(hw);
+		const struct div_table *dtbl = plld->div_tbl;
+
+		seq_printf(s, "div-tbl-entries:\n");
+		for ( ; !IS_DIV_TABLE_END(dtbl); dtbl++)
+			seq_printf(s, "  %10lu : %2d(0x%02x)\n", dtbl->rate, dtbl->div, dtbl->val);
+	}
+
+	return 0;
+}
+
+static int clk_pll_conf_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, clk_pll_conf_show, inode->i_private);
+}
+
+static const struct file_operations clk_pll_conf_fops = {
+	.open           = clk_pll_conf_open,
+	.read           = seq_read,
+	.llseek         = seq_lseek,
+	.release        = single_release,
+};
+
+static int clk_pll_debug_init(struct clk_hw *hw, struct dentry *d)
+{
+	debugfs_create_file("rtk_clk_rate", 0644, d, hw, &clk_pll_rate_op);
+	debugfs_create_file("clk_pll_conf", S_IRUGO, d, hw, &clk_pll_conf_fops);
+	return 0;
+}
+
+static const struct freq_table *ftbl_find_by_rate(const struct freq_table *ftbl,
+						  unsigned long rate)
+{
+	unsigned long best_rate = 0;
+	const struct freq_table *best = NULL;
+
+	for ( ; !IS_FREQ_TABLE_END(ftbl); ftbl++) {
+		if (ftbl->rate == rate)
+			return ftbl;
+
+		if (ftbl->rate > rate)
+			continue;
+
+		if ((rate - best_rate) > (rate - ftbl->rate)) {
+			best_rate = ftbl->rate;
+			best = ftbl;
+		}
+	}
+
+	if (best)
+		pr_debug("%s: closest rate for %lu is %lu\n", __func__,
+			rate, best->rate);
+
+	return best;
+}
+
+static const struct freq_table *ftbl_find_by_val(const struct freq_table *ftbl,
+						 unsigned long value)
+{
+	while (!IS_FREQ_TABLE_END(ftbl)) {
+		if (ftbl->val == (value & ftbl->mask))
+			return ftbl;
+		ftbl++;
+	}
+	return NULL;
+};
+
+static const struct div_table *dtbl_find_by_rate(const struct div_table *dtbl,
+						 unsigned long rate)
+{
+	while (!IS_DIV_TABLE_END(dtbl)) {
+		if (rate >= dtbl->rate)
+			return dtbl;
+		dtbl++;
+	}
+	return NULL;
+}
+
+static const struct div_table *dtbl_find_by_val(const struct div_table *dtbl,
+						unsigned int val)
+{
+	while (!IS_DIV_TABLE_END(dtbl)) {
+		if (val == dtbl->val)
+			return dtbl;
+		dtbl++;
+	}
+	return NULL;
+}
+
+static void __clk_pll_set_pow_reg(struct clk_pll *pll, int on)
+{
+	unsigned int pow = (pll->conf & CLK_PLL_CONF_POW_LOC_CTL3) ? 0x8 : 0x4;
+
+	if (on) {
+		clk_reg_update(&pll->base, pll->pll_offset + pow, 0x7, 0x3);
+		if (pll->conf & CLK_PLL_CONF_FREQ_LOC_SSC1) {
+			u32 val = clk_reg_read(&pll->base, pll->ssc_offset + 0x0);
+
+			/*
+			 * For those PLL with SCC used only the default
+			 * freq, the oc_en would nerver to be set.
+			 * Help to set it here.
+			 */
+			if ((val & 0x7) != 0x5)
+				clk_reg_update(&pll->base, pll->ssc_offset + 0x0, 0x7, 0x5);
+		}
+		udelay(200);
+	} else {
+		clk_reg_update(&pll->base, pll->pll_offset + pow, 0x7, 0x4);
+	}
+}
+
+static int clk_pll_enable(struct clk_hw *hw)
+{
+	struct clk_pll *pll = to_clk_pll(hw);
+
+	if (clk_pll_has_pow(pll))
+		__clk_pll_set_pow_reg(pll, 1);
+	pll->status &= ~CLK_PLL_DISABLED;
+	return 0;
+}
+
+static void clk_pll_disable(struct clk_hw *hw)
+{
+	struct clk_pll *pll = to_clk_pll(hw);
+
+	if (clk_pll_has_pow(pll))
+		__clk_pll_set_pow_reg(pll, 0);
+	pll->status |= CLK_PLL_DISABLED;
+}
+
+static void clk_pll_disable_unused(struct clk_hw *hw)
+{
+	pr_info("%pC: %s\n", hw->clk, __func__);
+	clk_pll_disable(hw);
+}
+
+static int clk_pll_is_enabled(struct clk_hw *hw)
+{
+	struct clk_pll *pll = to_clk_pll(hw);
+	unsigned int pow = (pll->conf & CLK_PLL_CONF_POW_LOC_CTL3) ? 0x8 : 0x4;
+	int val;
+
+	if (clk_pll_has_pow(pll))
+		val = clk_reg_read(&pll->base, pll->pll_offset + pow);
+	else
+		val = !(pll->status & CLK_PLL_DISABLED);
+	return !!(val & 0x1);
+}
+
+static long clk_pll_round_rate(struct clk_hw *hw,
+			       unsigned long rate,
+			       unsigned long *parent_rate)
+{
+	struct clk_pll *pll = to_clk_pll(hw);
+	const struct freq_table *ftblv = NULL;
+
+	if (WARN_ON_ONCE(*parent_rate != default_osc_rate))
+		return 0;
+
+	// TODO: return closest rate
+	ftblv = ftbl_find_by_rate(pll->freq_tbl, rate);
+	if (!ftblv)
+		return 0;
+
+	return ftblv->rate;
+}
+
+static unsigned int __clk_pll_get_rate_reg(struct clk_pll *pll)
+{
+	unsigned int val;
+
+	if (pll->conf & CLK_PLL_CONF_FREQ_LOC_CTL2)
+		val = clk_reg_read(&pll->base, pll->pll_offset + 0x4);
+	else if (pll->conf & CLK_PLL_CONF_FREQ_LOC_SSC1)
+		val = clk_reg_read(&pll->base, pll->ssc_offset + 0x4);
+	else
+		val = clk_reg_read(&pll->base, pll->pll_offset + 0x0);
+	return val;
+}
+
+static unsigned long clk_pll_recalc_rate(struct clk_hw *hw,
+					 unsigned long parent_rate)
+{
+	struct clk_pll *pll = to_clk_pll(hw);
+	unsigned long flags = 0;
+	const struct freq_table *fv;
+	unsigned int val;
+
+	if (WARN_ON_ONCE(parent_rate != default_osc_rate))
+		return 0;
+
+	flags = clk_pll_lock(pll);
+	val = __clk_pll_get_rate_reg(pll);
+	clk_pll_unlock(pll, flags);
+
+	fv = ftbl_find_by_val(pll->freq_tbl, val);
+	WARN(!fv, "%pC: invalid f-tbl entry for %08x\n", hw->clk, val);
+	return fv ? fv->rate : 0;
+}
+
+static inline int __clk_pll_set_rate_reg(struct clk_pll *pll, u32 mask, u32 val)
+{
+	struct clk_hw *hw = &pll->base.hw;
+	int ret = 0;
+
+	if (pll->conf & CLK_PLL_CONF_FREQ_LOC_CTL2) {
+		clk_reg_update(&pll->base, pll->pll_offset + 0x4, mask, val);
+		clk_reg_update(&pll->base, pll->pll_offset + 0x8, 0x1, 0x0);
+		clk_reg_update(&pll->base, pll->pll_offset + 0x8, 0x1, 0x1);
+	} else if (pll->conf & CLK_PLL_CONF_FREQ_LOC_SSC1) {
+		int retry = DEFAULT_MAX_OC_DONE_RETRY;
+
+		clk_reg_update(&pll->base, pll->ssc_offset + 0x0, 0x7, 0x4);
+		clk_reg_update(&pll->base, pll->ssc_offset + 0x4, mask, val);
+		clk_reg_update(&pll->base, pll->ssc_offset + 0x0, 0x7, 0x5);
+
+		if (clk_pll_has_pow(pll) && !clk_pll_is_enabled(hw))
+			return 0;
+
+		ret = -ETIME;
+		while (--retry > 0) {
+			udelay(1);
+			if (clk_reg_read_notrace(&pll->base, pll->ssc_offset + 0x1c) & BIT(20)) {
+				ret = 0;
+				break;
+			}
+		}
+		pr_debug("%pC: %s: retry left=%d\n", hw->clk, __func__, retry);
+	} else {
+		clk_reg_update(&pll->base, pll->pll_offset, mask, val);
+	}
+	return ret;
+}
+
+static int clk_pll_set_rate(struct clk_hw *hw,
+			    unsigned long rate,
+			    unsigned long parent_rate)
+{
+	struct clk_pll *pll = to_clk_pll(hw);
+	unsigned long flags = 0;
+	const struct freq_table *fv;
+	int ret = 0;
+
+	if (WARN_ON_ONCE(parent_rate != default_osc_rate))
+		return 0;
+
+	fv = ftbl_find_by_rate(pll->freq_tbl, rate);
+	if (WARN(!fv, "%pC: invalid f-tbl entry for %lu\n", hw->clk, rate))
+		return -EINVAL;
+
+	pr_debug("%pC: %s: target rate=%ld, val=0x%08x, mask=0x%08x\n",
+		hw->clk, __func__, fv->rate, fv->val, fv->mask);
+
+	flags = clk_pll_lock(pll);
+	ret = __clk_pll_set_rate_reg(pll, fv->mask, fv->val);
+	clk_pll_unlock(pll, flags);
+	if (ret == -ETIME)
+		pr_warn("%pC %s: wait pll ready timeout\n", hw->clk, __func__);
+	return 0;
+}
+
+static void __clk_pll_div_set_div_reg(struct clk_pll_div *plld, unsigned int val)
+{
+	unsigned int m = (BIT(plld->div_width) - 1) << plld->div_shift;
+	unsigned int s = plld->div_shift;
+
+	clk_reg_update(&plld->clkp.base, plld->div_offset, m, val << s);
+}
+
+static unsigned int __clk_pll_div_get_div_reg(struct clk_pll_div *plld)
+{
+	unsigned int m = (BIT(plld->div_width) - 1) << plld->div_shift;
+	unsigned int s = plld->div_shift;
+
+	return (clk_reg_read(&plld->clkp.base, plld->div_offset) & m) >> s;
+}
+
+
+static long clk_pll_div_round_rate(struct clk_hw *hw,
+				   unsigned long rate,
+				   unsigned long *parent_rate)
+{
+	struct clk_pll_div *plld = to_clk_pll_div(hw);
+	const struct div_table *dv;
+
+	if (WARN_ON_ONCE(*parent_rate != default_osc_rate))
+		return 0;
+
+	/* lookup div in dtbl */
+	dv = dtbl_find_by_rate(plld->div_tbl, rate);
+	if (WARN(!dv, "%pC: invalid d-tbl entry for %lu", hw->clk, rate))
+		return 0;
+
+	rate *= dv->div;
+	rate = clk_pll_round_rate(hw, rate, parent_rate);
+	return rate / dv->div;
+}
+
+static unsigned long clk_pll_div_recalc_rate(struct clk_hw *hw,
+						 unsigned long parent_rate)
+{
+	struct clk_pll_div *plld = to_clk_pll_div(hw);
+	unsigned long rate;
+	const struct div_table *dv;
+	unsigned int val;
+
+	if (WARN_ON_ONCE(parent_rate != default_osc_rate))
+		return 0;
+
+	rate = clk_pll_recalc_rate(hw, parent_rate);
+
+	val = __clk_pll_div_get_div_reg(plld);
+	dv = dtbl_find_by_val(plld->div_tbl, val);
+	if (WARN(!dv, "%pC: invalid d-tbl entry for %lu", hw->clk, rate))
+		return 0;
+
+	rate /= dv->div;
+	pr_debug("%pC: %s: current rate=%lu, div=%d, reg_val=0x%x\n",
+		hw->clk, __func__, rate, dv->div, val);
+
+	return rate;
+}
+
+static int clk_pll_div_set_rate(struct clk_hw *hw,
+				unsigned long rate,
+				unsigned long parent_rate)
+{
+	struct clk *clk = hw->clk;
+	struct clk_pll_div *plld = to_clk_pll_div(hw);
+	unsigned long flags;
+	const struct div_table *ndv, *cdv;
+	unsigned long target;
+	unsigned int cur_d;
+
+	if (WARN_ON_ONCE(parent_rate != default_osc_rate))
+		return -EINVAL;
+
+	/* find next in the dtbl */
+	ndv = dtbl_find_by_rate(plld->div_tbl, rate);
+	if (WARN(!ndv, "%pC: invalid d-tbl entry for %lu", hw->clk, rate))
+		return -EINVAL;
+
+	target = rate * ndv->div;
+
+	/* find current in the dtbl */
+	cur_d = __clk_pll_div_get_div_reg(plld);
+	cdv = dtbl_find_by_val(plld->div_tbl, cur_d);
+	if (WARN(!ndv, "%pC: invalid d-tbl entry for %u", hw->clk, cur_d))
+		return -EINVAL;
+
+	ck_dbg(clk, "target rate=%lu\n", rate);
+	ck_dbg(clk, "c div=(%d, 0x%x)\n", cdv->div, cdv->val);
+	ck_dbg(clk, "n div=(%d, 0x%x)\n", ndv->div, ndv->val);
+
+	flags = clk_pll_div_lock(plld);
+
+	/* workaround to prevent glitch */
+	if (IS_ENABLED(CONFIG_COMMON_CLK_RTD129X)) {
+		struct clk_pll *pll = &plld->clkp;
+
+		if ((pll->flags & CLK_PLL_DIV_WORKAROUND) &&
+			ndv->val != cdv->val &&
+			(ndv->val == 1 || cdv->val == 1)) {
+
+			ck_dbg(clk, "apply rate=%u\n", 1000000000);
+			clk_pll_set_rate(hw, 1000000000, parent_rate);
+
+			ck_dbg(clk, "apply div=%d, reg_val=0x%x\n", ndv->div, ndv->val);
+			__clk_pll_div_set_div_reg(plld, ndv->val);
+			cdv = ndv;
+		}
+	}
+
+	if (ndv->div > cdv->div)
+		__clk_pll_div_set_div_reg(plld, ndv->val);
+	clk_pll_set_rate(hw, target, parent_rate);
+	if (ndv->div < cdv->div)
+		__clk_pll_div_set_div_reg(plld, ndv->val);
+
+	clk_pll_div_unlock(plld, flags);
+
+	return 0;
+}
+
+const struct clk_ops clk_pll_ops = {
+	.debug_init       = clk_pll_debug_init,
+	.round_rate       = clk_pll_round_rate,
+	.recalc_rate      = clk_pll_recalc_rate,
+	.set_rate         = clk_pll_set_rate,
+	.enable           = clk_pll_enable,
+	.disable          = clk_pll_disable,
+	.disable_unused   = clk_pll_disable_unused,
+	.is_enabled       = clk_pll_is_enabled,
+};
+
+const struct clk_ops clk_pll_div_ops = {
+	.debug_init       = clk_pll_debug_init,
+	.round_rate       = clk_pll_div_round_rate,
+	.recalc_rate      = clk_pll_div_recalc_rate,
+	.set_rate         = clk_pll_div_set_rate,
+	.enable           = clk_pll_enable,
+	.disable          = clk_pll_disable,
+	.disable_unused   = clk_pll_disable_unused,
+	.is_enabled       = clk_pll_is_enabled,
+};
+
+bool clk_hw_is_pll(struct clk_hw *hw)
+{
+	const struct clk_init_data *init = hw->init;
+
+	if (init->ops == &clk_pll_ops ||
+	    init->ops == &clk_pll_div_ops)
+		return true;
+
+	return false;
+}
+
+int clk_pll_init(struct clk_hw *hw)
+{
+	struct clk_pll *pll = to_clk_pll(hw);
+
+	if (!clk_hw_is_pll(hw))
+		return -EINVAL;
+	pll->ops = hw->init->ops;
+
+	return 0;
+}
+
diff --git a/drivers/clk/realtek/common.c b/drivers/clk/realtek/common.c
new file mode 100644
index 00000000..b3dfec0
--- /dev/null
+++ b/drivers/clk/realtek/common.c
@@ -0,0 +1,299 @@
+/*
+ * common.c - Realtek Clock common
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/device.h>
+#include <linux/init.h>
+#include <linux/pm.h>
+#include <linux/slab.h>
+#include "common.h"
+#include "clk-pll.h"
+#include "clk-mmio-gate.h"
+#include "clk-mmio-mux.h"
+#include <soc/realtek/rtk_event.h>
+
+#ifdef CONFIG_PM
+int clk_pm_init(struct clk *clk, struct clk_pm_data *pm_data,
+		unsigned int pm_flags)
+{
+	if (!clk)
+		return -ENOENT;
+
+	WARN(!pm_data, "no pm_data for pm");
+	if (!pm_data)
+		return -EINVAL;
+
+	pm_data->clk = clk;
+	pm_data->flags = pm_flags;
+	return 0;
+}
+
+
+int clk_pm_data_save(struct clk_pm_data *pm_data)
+{
+	struct clk *clk = pm_data->clk;
+
+	if (!clk)
+		return 0;
+
+	if (pm_data->flags & CLK_PM_SUSPEND_PARENT)
+		pm_data->parent = clk_get_parent(clk);
+
+	if (pm_data->flags & CLK_PM_SUSPEND_RATE)
+		pm_data->rate = clk_get_rate(clk);
+
+	if (pm_data->flags & CLK_PM_SUSPEND_ENABLE) {
+		pm_data->enable_cnt = __clk_get_enable_count(clk);
+
+		while (__clk_get_enable_count(clk) > 0)
+			clk_disable_unprepare(clk);
+	}
+
+	pr_debug("%s: data[f = 0x%x, p = %s, r = %lu, en_cnt = %d]\n",
+		__clk_get_name(clk), pm_data->flags,
+		__clk_get_name(pm_data->parent), pm_data->rate,
+		pm_data->enable_cnt);
+
+	return 0;
+}
+
+int clk_pm_data_restore(struct clk_pm_data *pm_data)
+{
+	struct clk *clk = pm_data->clk;
+
+	if (!clk)
+		return 0;
+
+	if (pm_data->flags & CLK_PM_SUSPEND_ENABLE) {
+		while (pm_data->enable_cnt > 0) {
+			clk_prepare_enable(clk);
+			pm_data->enable_cnt--;
+		}
+	}
+
+	if (pm_data->parent) {
+		/* clear the old parent */
+		clk_set_parent(clk, NULL);
+
+		/* restore parent */
+		clk_set_parent(clk, pm_data->parent);
+	}
+
+	if (pm_data->rate) {
+		long old;
+
+		old = clk_get_rate(clk);
+		clk_set_rate(clk, pm_data->rate);
+
+		pr_debug("%s: %ld -> %ld\n", __clk_get_name(clk),
+			old, clk_get_rate(clk));
+	}
+
+	return 0;
+}
+#endif /* CONFIG_PM */
+
+#define CC_CLK_TYPE_OTHERS     0
+#define CC_CLK_TYPE_CLK_REG    1
+#define CC_CLK_TYPE_CLK_PLL    3
+#define CC_CLK_TYPE_CLK_MUX    5
+#define CC_CLK_TYPE_CLK_GATE   7
+
+static inline int __hw_to_cc_type(struct clk_hw *hw)
+{
+	const struct clk_ops *ops = hw->init->ops;
+
+	if (clk_hw_is_pll(hw))
+		return CC_CLK_TYPE_CLK_PLL;
+	if (ops == &clk_mmio_mux_ops)
+		return CC_CLK_TYPE_CLK_MUX;
+	if (ops == &clk_mmio_gate_ops)
+		return CC_CLK_TYPE_CLK_GATE;
+#ifdef CONFIG_CLK_PLL_DIF
+	/*
+	 * clk_pll_dif is not based struct clk_pll, so
+	 * return as CC_CLK_TYPE_CLK_REG to setup internal
+	 * clk_reg
+	 */
+	if (ops == &clk_pll_dif_ops)
+		return CC_CLK_TYPE_CLK_REG;
+#endif
+#ifdef CONFIG_CLK_PLL_PSAUD
+	/*
+	 * clk_pll_psaud is not based struct clk_pll, so
+	 * return as CC_CLK_TYPE_CLK_REG to setup internal
+	 * clk_reg
+	 */
+	if (ops == &clk_pll_psaud_ops)
+		return CC_CLK_TYPE_CLK_REG;
+#endif
+
+	return CC_CLK_TYPE_OTHERS;
+}
+
+static inline int cc_set_clk_cell(struct cc_platform_data *ccd, int i,
+				  struct clk *clk)
+{
+	if (ccd->data.clks[i]) {
+		pr_warn("%s: failed to fill %s to cell %d, used by %s\n",
+			__func__,
+			__clk_get_name(clk), i,
+			__clk_get_name(ccd->data.clks[i]));
+		return -EINVAL;
+	}
+	ccd->data.clks[i] = clk;
+	return 0;
+}
+
+int cc_init_hw(struct device *dev, struct cc_platform_data *ccd, int cc_index,
+	       struct clk_hw *hw)
+{
+	struct clk *clk;
+	struct clk_reg *reg = to_clk_reg(hw);
+	const char *name = hw->init->name;
+	int clk_type;
+	unsigned int pm_flags = 0;
+
+#ifdef CONFIG_XEN
+	if (of_clk_is_invalid(dev->of_node, name)) {
+		dev_notice(dev, "%s not in current domain\n", name);
+		return 0;
+	}
+#endif
+
+	dev_dbg(dev, "%s: start initialize %s\n", __func__, name);
+
+	clk_type = __hw_to_cc_type(hw);
+	switch (clk_type) {
+	case CC_CLK_TYPE_CLK_PLL:
+		clk_reg_init(reg, &ccd->init_data);
+		clk_pll_init(hw);
+		pm_flags = CLK_PM_SUSPEND_RATE;
+		break;
+
+	case CC_CLK_TYPE_CLK_MUX:
+		clk_reg_init(reg, &ccd->init_data);
+		pm_flags = CLK_PM_SUSPEND_PARENT;
+		break;
+
+	case CC_CLK_TYPE_CLK_GATE:
+		clk_reg_init(reg, &ccd->init_data);
+		pm_flags = CLK_PM_SUSPEND_ENABLE;
+		break;
+
+	case CC_CLK_TYPE_CLK_REG:
+		clk_reg_init(reg, &ccd->init_data);
+		break;
+
+	default:
+		break;
+	}
+
+	clk = clk_register(dev, hw);
+	if (IS_ERR(clk))
+		return PTR_ERR(clk);
+	rtk_clk_notify(clk, CLK_EVENT_REGISTERED);
+	clk_register_clkdev(clk, name, NULL);
+	cc_set_clk_cell(ccd, cc_index, hw->clk);
+	if (pm_flags)
+		clk_pm_init(clk, &ccd->pm_data[cc_index], pm_flags);
+	return 0;
+}
+
+static
+struct clk *clk_reg_create_composite_clk(struct device *dev,
+					 struct clk_reg_init_data *reg,
+					 struct clk_composite_init_data *init)
+{
+	struct clk_mmio_gate *gate = NULL;
+	const struct clk_ops *gate_op = NULL;
+	struct clk_mmio_mux *mux = NULL;
+	const struct clk_ops *mux_op = NULL;
+	struct clk *clk;
+
+	if (init->mux_offset != CLK_OFFSET_INVALID) {
+		mux = kzalloc(sizeof(*mux), GFP_KERNEL);
+		mux->mux_offset = init->mux_offset;
+		mux->mask = BIT(init->mux_width) - 1;
+		mux->shift = init->mux_shift;
+
+		clk_reg_init(&mux->base, reg);
+		mux_op = &clk_mmio_mux_ops;
+	}
+
+	if (init->gate_offset != CLK_OFFSET_INVALID) {
+		gate = kzalloc(sizeof(*gate), GFP_KERNEL);
+		gate->gate_offset = init->gate_offset;
+		gate->bit_idx = init->gate_shift;
+		gate->flags = init->gate_flags;
+
+		clk_reg_init(&gate->base, reg);
+		gate_op = &clk_mmio_gate_ops;
+	}
+
+	clk = clk_register_composite(NULL, init->name, init->parent_names,
+		init->num_parents,
+		mux ? &__clk_mmio_mux_hw(mux) : NULL, mux_op,
+		NULL, NULL,
+		gate ? &__clk_mmio_gate_hw(gate) : NULL, gate_op,
+		init->flags);
+	if (IS_ERR(clk)) {
+		kfree(mux);
+		kfree(gate);
+	}
+	return clk;
+}
+
+int cc_init_composite_clk(struct device *dev, struct cc_platform_data *ccd,
+			  int cc_index, struct clk_composite_init_data *init)
+{
+	struct clk *clk;
+	const char *name = init->name;
+	unsigned int pm_flags = 0;
+
+#ifdef CONFIG_XEN
+	if (of_clk_is_invalid(dev->of_node, name)) {
+		dev_notice(dev, "%s not in current domain\n", name);
+		return 0;
+	}
+#endif
+
+	dev_dbg(dev, "%s: start initialize %s\n", __func__, name);
+
+	clk = clk_reg_create_composite_clk(dev, &ccd->init_data, init);
+	if (IS_ERR(clk))
+		return PTR_ERR(clk);
+	init->clk = clk;
+
+	clk_register_clkdev(clk, init->name, NULL);
+	cc_set_clk_cell(ccd, cc_index, clk);
+	/* init clk pm */
+	if (CLK_OFFSET_IS_VALID(init->mux_offset))
+		pm_flags |= CLK_PM_SUSPEND_PARENT;
+	if (CLK_OFFSET_IS_VALID(init->gate_offset))
+		pm_flags |=  CLK_PM_SUSPEND_ENABLE;
+	clk_pm_init(clk, &ccd->pm_data[cc_index], pm_flags);
+	return 0;
+}
+
diff --git a/drivers/clk/realtek/include/clk-mmio-gate.h b/drivers/clk/realtek/include/clk-mmio-gate.h
new file mode 100644
index 00000000..64ad502
--- /dev/null
+++ b/drivers/clk/realtek/include/clk-mmio-gate.h
@@ -0,0 +1,59 @@
+/*
+ * clk-mmio-gate.h - gating clock with regmap
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __CLK_REALTEK_CLK_MMIO_GATE_H
+#define __CLK_REALTEK_CLK_MMIO_GATE_H
+
+#include "common.h"
+
+/**
+ * struct clk_mmio_gate - gating clock with regmap
+ *
+ * @base:        handle for common, hw and register access interfaces
+ * @gate_offset: offset from base register
+ * @bit_idx:     bit index of gating bit field
+ * @shift:       shift to gating bit field
+ * @lock:        register lock
+ * @flags:       clk_mmio_gate flags
+ * @ref:         debug reference
+ *
+ * Flags:
+ * CLK_MMIO_GATE_HAS_WRITE_EN - set write_en bit in (bit_idx+1)
+ */
+struct clk_mmio_gate {
+	struct clk_reg base;
+	int gate_offset;
+	u8 bit_idx;
+	spinlock_t *lock;
+	unsigned int flags;
+};
+
+#define to_clk_mmio_gate(_hw) \
+	container_of(to_clk_reg(_hw), struct clk_mmio_gate, base)
+#define __clk_mmio_gate_hw(_ptr) __clk_reg_hw(&(_ptr)->base)
+
+/* clk_mmio_gate flags */
+#define CLK_MMIO_GATE_HAS_WRITE_EN 0x1
+
+extern const struct clk_ops clk_mmio_gate_ops;
+
+#endif
diff --git a/drivers/clk/realtek/include/clk-mmio-mux.h b/drivers/clk/realtek/include/clk-mmio-mux.h
new file mode 100644
index 00000000..34bd866
--- /dev/null
+++ b/drivers/clk/realtek/include/clk-mmio-mux.h
@@ -0,0 +1,51 @@
+/*
+ * clk-mmio-mux.h - multiplexer clock with regmap
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __CLK_REALTEK_CLK_MMIO_MUX_H
+#define __CLK_REALTEK_CLK_MMIO_MUX_H
+
+#include "common.h"
+
+/**
+ * struct clk_mmio_mux - multiplexer clock with regmap
+ *
+ * @base:       handle for common, hw and register access interfaces
+ * @mux_offset: offset from base register
+ * @mask:       mask of multiplexer bit field
+ * @shift:      shift to multiplexer bit field
+ * @lock:       register lock
+ */
+struct clk_mmio_mux {
+	struct clk_reg base;
+	int mux_offset;
+	unsigned int mask;
+	unsigned int shift;
+	spinlock_t *lock;
+};
+
+#define to_clk_mmio_mux(_hw) \
+	container_of(to_clk_reg(_hw), struct clk_mmio_mux, base)
+#define __clk_mmio_mux_hw(_ptr) __clk_reg_hw(&(_ptr)->base)
+
+extern const struct clk_ops clk_mmio_mux_ops;
+
+#endif
diff --git a/drivers/clk/realtek/include/clk-pll.h b/drivers/clk/realtek/include/clk-pll.h
new file mode 100644
index 00000000..f342a4f
--- /dev/null
+++ b/drivers/clk/realtek/include/clk-pll.h
@@ -0,0 +1,222 @@
+/*
+ * clk-pll.h - pll clock with regmap
+ *
+ * Copyright (C) 2017-2018 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __CLK_REALTEK_CLK_PLL_H
+#define __CLK_REALTEK_CLK_PLL_H
+
+#include "common.h"
+
+/**
+ * struct freq_table - clock frequency table
+ *
+ * @val:  register valute
+ * @mask: mask to apply value to register
+ * @rate: frequency
+ */
+struct freq_table {
+	unsigned int val;
+	unsigned int mask;
+	unsigned long rate;
+};
+
+#define FREQ_TABLE_END                  { .rate = 0 }
+#define IS_FREQ_TABLE_END(_f)           ((_f)->rate == 0)
+
+/**
+ * struct div_table - clock divisor table
+ *
+ * @rate: rate for divisor selection. When target rate is greater-equal than
+ *     the rate, using the divisor.
+ * @div:  divisor
+ * @val:  register value
+ */
+struct div_table {
+	unsigned long rate;
+	unsigned int div;
+	unsigned int val;
+};
+
+#define DIV_TABLE_END                   { .rate = 0 }
+#define IS_DIV_TABLE_END(_d)            ((_d)->rate == 0)
+
+/**
+ * struct clk_pll - pll clock with regmap. Using a frequency table to lookup
+ * for frequency.
+ *
+ * @base:       handle for common, hw and register access interface
+ * @pll_offset: offset of register to set pll rate
+ * @freq_table: frequency table
+ * @ssc_offset: offset of ssc register
+ * @lock:       register lock
+ * @flags:      clk_pll flags
+ * @status:     clk_pll status
+ * @conf        clk_pll hw configure
+ *
+ * Flags:
+ * CLK_PLL_DIV_WORKAROUND - (kylin) workaround for clk_pll_div
+ *
+ * Status:
+ * CLK_PLL_ENABLED - indicate the pll is enabled
+ */
+struct clk_pll {
+	struct clk_reg base;
+
+	const struct freq_table *freq_tbl;
+	int pll_offset;
+	int ssc_offset;
+	spinlock_t *lock;
+
+	unsigned int flags;
+	unsigned int status;
+	unsigned int conf;
+
+	const struct clk_ops *ops;
+};
+
+#define to_clk_pll(_hw) container_of(to_clk_reg(_hw), struct clk_pll, base)
+#define __clk_pll_hw(_ptr)  __clk_reg_hw(&(_ptr)->base)
+
+/* clk_pll flags */
+#define CLK_PLL_DIV_WORKAROUND          BIT(2)
+
+/* clk_pll status */
+#define CLK_PLL_DISABLED                BIT(0)
+
+/* clk_pll conf & functions */
+#define CLK_PLL_CONF_POW_MASK           (0xf)
+#define CLK_PLL_CONF_POW_LOC_CTL2       BIT(0)
+#define CLK_PLL_CONF_POW_LOC_CTL3       BIT(1)
+#define CLK_PLL_CONF_FREQ_MASK          (0xf0)
+#define CLK_PLL_CONF_FREQ_LOC_CTL1      BIT(4)
+#define CLK_PLL_CONF_FREQ_LOC_CTL2      BIT(5)
+#define CLK_PLL_CONF_FREQ_LOC_SSC1      BIT(6)
+
+static inline bool clk_pll_has_pow(struct clk_pll *pll)
+{
+	if (pll->conf & CLK_PLL_CONF_POW_MASK)
+		return true;
+	return false;
+}
+
+/* clk_pll helper macros & functions */
+#define SSC_VALID(_pll)                 CLK_OFFSET_IS_VALID((_pll)->ssc_offset)
+
+static inline unsigned long clk_pll_lock(struct clk_pll *pll)
+{
+	unsigned long flags = 0;
+
+	if (pll->lock)
+		spin_lock_irqsave(pll->lock, flags);
+	return flags;
+}
+
+static inline void clk_pll_unlock(struct clk_pll *pll, unsigned long flags)
+{
+	if (pll->lock)
+		spin_unlock_irqrestore(pll->lock, flags);
+}
+
+/**
+ * struct clk_pll_div - pll clock externion with divisor
+ *
+ * @clkp:       pll clock
+ * @div_offset: offset of divsor register
+ * @div_shift:  shift of divsor bit field
+ * @div_width:  width of divsor bit field
+ * @div_tbl:    divsor table
+ * @lock        divsor register lock
+ */
+struct clk_pll_div {
+	struct clk_pll clkp;
+	int div_offset;
+	int div_shift;
+	int div_width;
+	const struct div_table *div_tbl;
+	spinlock_t *lock;
+};
+
+#define to_clk_pll_div(_hw) \
+	container_of(to_clk_pll(_hw), struct clk_pll_div, clkp)
+#define __clk_pll_div_hw(_ptr) __clk_pll_hw(&(_ptr)->clkp)
+
+/* clk_pll_div helper functions */
+static inline unsigned long clk_pll_div_lock(struct clk_pll_div *plld)
+{
+	unsigned long flags = 0;
+
+	if (plld->lock)
+		spin_lock_irqsave(plld->lock, flags);
+	return flags;
+}
+
+static inline void clk_pll_div_unlock(struct clk_pll_div *plld,
+	unsigned long flags)
+{
+	if (plld->lock)
+		spin_unlock_irqrestore(plld->lock, flags);
+}
+
+extern const struct clk_ops clk_pll_ops;
+extern const struct clk_ops clk_pll_div_ops;
+
+bool clk_hw_is_pll(struct clk_hw *hw);
+int clk_pll_init(struct clk_hw *hw);
+
+extern unsigned long default_osc_rate;
+
+#ifdef CONFIG_CLK_PLL_PSAUD
+
+struct clk_pll_psaud {
+     struct clk_reg base;
+     int id;
+     int reg;
+     spinlock_t *lock;
+};
+
+#define to_clk_pll_psaud(_hw) \
+    container_of(to_clk_reg(_hw), struct clk_pll_psaud, base)
+#define __clk_pll_psaud_hw(_ptr)  __clk_reg_hw(&(_ptr)->base)
+extern const struct clk_ops clk_pll_psaud_ops;
+
+#define CLK_PLL_PSAUD1A       (0x1)
+#define CLK_PLL_PSAUD2A       (0x2)
+
+#endif /* CONFIG_CLK_PLL_PSAUD */
+
+#ifdef CONFIG_CLK_PLL_DIF
+
+struct clk_pll_dif {
+    struct clk_reg base;
+    int pll_offset;
+    int ssc_offset;
+    unsigned int status;
+    spinlock_t *lock;
+};
+#define to_clk_pll_dif(_hw) \
+    container_of(to_clk_reg(_hw), struct clk_pll_dif, base)
+#define __clk_pll_dif_hw(_ptr)  __clk_reg_hw(&(_ptr)->base)
+
+extern const struct clk_ops clk_pll_dif_ops;
+#endif /* CONFIG_CLK_PLL_DIF */
+
+
+#endif /* __CLK_REALTEK_CLK_PLL_H */
diff --git a/drivers/clk/realtek/include/common.h b/drivers/clk/realtek/include/common.h
new file mode 100644
index 00000000..687b659
--- /dev/null
+++ b/drivers/clk/realtek/include/common.h
@@ -0,0 +1,276 @@
+/*
+ * common.h - Realtek Clock Common
+ *
+ * Copyright (C) 2016-2018 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __CLK_REALTEK_COMMON_H
+#define __CLK_REALTEK_COMMON_H
+
+#include <linux/bitops.h>
+#include <linux/clk-provider.h>
+#include <linux/device.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/regmap.h>
+
+struct device;
+struct platform_device;
+
+/**
+ * struct clk_reg - a clk core with hardware register access, which is provided
+ * ether a direct regsiter or a regmap register access. The regmap provides a
+ * safe register aceess, when the registers are shared by modules or firmwares.
+ *
+ * @hw:             handle between common and hardware-specific interfaces
+ * @flags:          clk_reg flags
+ * @reg:            a pointor for direct register access
+ * @regmap:         a remap for register access, which provides safe register
+ *                  aceess
+ * @offset:         the offset between @regmap and @reg
+ */
+struct clk_reg {
+	struct clk_hw hw;
+	unsigned long flags;
+	void __iomem *reg;
+	struct regmap *regmap;
+	int offset;
+};
+
+#define to_clk_reg(_hw) container_of(_hw, struct clk_reg, hw)
+#define __clk_reg_hw(_ptr)  ((_ptr)->hw)
+
+#define CLK_REG_INIT()  {{}, 0, 0, 0, 0, 0 }
+
+static inline bool of_clk_is_ignore_unused(struct device_node *np,
+					   const char *name)
+{
+	return of_property_match_string(np, "ignore-unused-clocks", name) >= 0;
+}
+
+static inline bool of_clk_is_ignore_pm(struct device_node *np,
+				       const char *name)
+{
+	return of_property_match_string(np, "ignore-pm-clocks", name) >= 0;
+}
+
+static inline bool of_clk_is_invalid(struct device_node *np,
+				     const char *name)
+{
+	return of_property_match_string(np, "invalid-clocks", name) >= 0;
+}
+
+/**
+ * struct clk_reg_init_data - init data of clk_reg
+ */
+struct clk_reg_init_data {
+	unsigned long flags;
+	void __iomem *reg;
+	struct regmap *regmap;
+	int offset;
+};
+
+static inline void clk_reg_init(struct clk_reg *b, struct clk_reg_init_data *i)
+{
+	b->flags = i->flags;
+	b->regmap = i->regmap;
+	b->reg = i->reg;
+	b->offset = i->offset;
+}
+
+static inline void clk_reg_write(struct clk_reg *b, unsigned int offset,
+	unsigned int val)
+{
+	pr_debug("%s: off=%03x, val=%08x\n", __func__, offset, val);
+	if (b->regmap)
+		regmap_write(b->regmap, b->offset + offset, val);
+	else if (b->reg)
+		writel(val, b->reg + offset);
+	else
+		WARN_ON(1);
+}
+
+static inline unsigned int clk_reg_read(struct clk_reg *b, unsigned int offset)
+{
+	unsigned int val = 0;
+
+	if (b->regmap)
+		regmap_read(b->regmap, b->offset + offset, &val);
+	else if (b->reg)
+		val = readl(b->reg + offset);
+	else
+		WARN_ON(1);
+	pr_debug("%s: off=%03x, val=%08x\n", __func__, offset, val);
+	return val;
+}
+
+static inline unsigned int clk_reg_read_notrace(struct clk_reg *b,
+						unsigned int offset)
+{
+	unsigned int val = 0;
+
+	if (b->regmap)
+		regmap_read(b->regmap, b->offset + offset, &val);
+	else if (b->reg)
+		val = readl(b->reg + offset);
+	else
+		WARN_ON(1);
+	return val;
+}
+
+static inline void clk_reg_update(struct clk_reg *b, unsigned int offset,
+				  unsigned int mask, unsigned int val)
+{
+	pr_debug("%s: off=%03x, mask=%08x, val=%08x\n", __func__, offset,
+		mask, val);
+	if (b->regmap) {
+		regmap_update_bits(b->regmap, b->offset + offset, mask, val);
+	} else if (b->reg) {
+		unsigned int rval;
+
+		rval = readl(b->reg + offset);
+		rval = (rval & ~mask) | (val & mask);
+		writel(rval, b->reg + offset);
+	} else {
+		WARN_ON(1);
+	}
+}
+
+/* offset check */
+#define CLK_OFFSET_INVALID  -1
+#define CLK_OFFSET_IS_VALID(_off)    ((_off) != CLK_OFFSET_INVALID)
+
+/**
+ * struct clk_composite_init_data - init data of clk_reg type composite clock.
+ *
+ * init data for registering an internal clk_mmio_gate
+ * @gate_offset
+ * @gate_shift
+ * @gate_flags
+ *
+ * init data for registering an internal clk_mmio_mux
+ * @mux_offset
+ * @mux_width
+ * @mux_width
+ * @parent_names
+ * @num_parents
+ *
+ * - common
+ * @flags:  clk flags
+ * @name:   name of a clk
+ * @clk:    the registered clk
+ */
+struct clk_composite_init_data {
+	int gate_offset;
+	int gate_shift;
+	unsigned int gate_flags;
+	int mux_offset;
+	int mux_width;
+	int mux_shift;
+	const char **parent_names;
+	int num_parents;
+	unsigned long flags;
+	const char *name;
+	struct clk *clk;
+};
+
+/**
+ * struct clk_pm_data - for saving clk pm state
+ *
+ * @clk         pointer to the struct clk
+ * @flags:      indicates the field(s) to save
+ * @parent:     saved parent for clk_mux
+ * @rate:       saved rate for clk_rate
+ * @enable_cnt: saved enable count for clk_gate
+ *
+ * Flags:
+ * CLK_PM_SUSPEND_RATE   - save clk_rate when suspending
+ * CLK_PM_SUSPEND_PARENT - save clk_parent when suspending
+ * CLK_PM_SUSPEND_ENABLE - save clk_enable_cnt when suspending
+ */
+struct clk_pm_data {
+	struct clk *clk;
+	unsigned int flags;
+	struct clk *parent;
+	unsigned long rate;
+	int enable_cnt;
+};
+
+#define CLK_PM_SUSPEND_RATE     BIT(0)
+#define CLK_PM_SUSPEND_PARENT   BIT(1)
+#define CLK_PM_SUSPEND_ENABLE   BIT(2)
+
+#ifdef CONFIG_PM
+int clk_pm_init(struct clk *clk, struct clk_pm_data *pm_data,
+		unsigned int pm_flags);
+int clk_pm_data_save(struct clk_pm_data *pm_data);
+int clk_pm_data_restore(struct clk_pm_data *pm_data);
+
+#else /* CONFIG_PM */
+
+static inline
+int clk_pm_init(struct clk *clk, struct clk_pm_data *pm_data,
+		unsigned int pm_flags)
+{
+	return 0;
+}
+
+static inline
+int clk_pm_data_save(struct clk_pm_data *pm_data)
+{
+	return 0;
+}
+
+static inline
+int clk_pm_data_restore(struct clk_pm_data *pm_data)
+{
+	return 0;
+}
+
+#endif /* CONFIG_PM */
+
+/**
+ * struct cc_platform_data - description of clock controller
+ *
+ * @init_data      init data of clk_reg
+ * @data           onecell data of clock provider
+ * @pm_data        data of clk_pm
+ */
+struct cc_platform_data {
+	struct clk_reg_init_data init_data;
+	int clk_num;
+	struct clk_onecell_data data;
+#ifdef CONFIG_PM
+	struct clk_pm_data *pm_data;
+#endif
+};
+
+struct cc_platform_data *devm_cc_alloc_platform_data(struct device *dev,
+						     int max_clk);
+int cc_probe_platform(struct platform_device *pdev,
+		      struct cc_platform_data *ccd,
+		      int (*init_cb)(struct device *dev));
+int cc_init_hw(struct device *dev, struct cc_platform_data *ccd,
+	       int cc_index, struct clk_hw *hw);
+int cc_init_composite_clk(struct device *dev, struct cc_platform_data *ccd,
+			  int cc_index, struct clk_composite_init_data *init);
+extern const struct dev_pm_ops cc_pm_ops;
+
+#endif /* __CLK_REALTEK_COMMON_H */
+
diff --git a/drivers/clk/realtek/include/reset.h b/drivers/clk/realtek/include/reset.h
new file mode 100644
index 00000000..18fde3e
--- /dev/null
+++ b/drivers/clk/realtek/include/reset.h
@@ -0,0 +1,65 @@
+/*
+ * reset.h
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __CLK_REALTEK_RESET_H
+#define __CLK_REALTEK_RESET_H
+
+#include <linux/reset-controller.h>
+
+#define RC_DESC_ID(_id)           ((_id >> 8) - 1)
+#define RC_RESET_ID(_id)          ((_id) & 0xff)
+#define RC_RESET_BIT_MASK(_id)    BIT((_id) & 0xff)
+#define RC_INVALID_OFFSET         (0xffffffff)
+
+struct rc_reg_desc {
+	u32 offset;
+	u32 pm_ignore_bits;
+	u32 pm_data;
+	u32 write_en:1;
+};
+
+struct rc_platform_data {
+	struct device *dev;
+	struct reset_controller_dev rcdev;
+	struct rc_reg_desc *desc;
+	u32 num_desc;
+	u32 chip_rev;
+	unsigned long (*id_xlate)(struct rc_platform_data *data,
+				  unsigned long id);
+	/* register */
+	void *reg;
+
+	/* mmio regmap of reg */
+	struct regmap *regmap;
+	int offset;
+};
+#define to_rc_platform_data(_p) container_of((_p), struct rc_platform_data, rcdev)
+
+extern const struct dev_pm_ops rc_pm_ops;
+int rc_probe_platform(struct platform_device *pdev,
+		      struct rc_platform_data *data);
+static inline bool rc_is_invalid(struct rc_reg_desc *desc)
+{
+	return desc->offset == RC_INVALID_OFFSET;
+}
+
+#endif /* __CLK_REALTEK_RESET_H */
diff --git a/drivers/clk/realtek/include/rtd119x/clk_regmap.h b/drivers/clk/realtek/include/rtd119x/clk_regmap.h
new file mode 100644
index 00000000..86e6efd
--- /dev/null
+++ b/drivers/clk/realtek/include/rtd119x/clk_regmap.h
@@ -0,0 +1,43 @@
+#ifndef __CLK_REALTEK_REGMAP_RTD119X_H
+#define __CLK_REALTEK_REGMAP_RTD119X_H
+
+#define CLOCK_ENABLE1                   (0x00C)
+#define CLOCK_ENABLE2                   (0x010)
+#define GROUP1_CK_SEL                   (0x018)
+#define PLL_DIV                         (0x030)
+#define VE_CKSEL                        (0x04C)
+#define PLL_SCPU1                       (0x100)
+#define PLL_SCPU2                       (0x104)
+#define PLL_SCPU3                       (0x108)
+#define PLL_VPU1                        (0x114)
+#define PLL_VPU2                        (0x118)
+#define PLL_BUS1                        (0x164)
+#define PLL_BUS2                        (0x168)
+#define PLL_BUS3                        (0x16C)
+#define PLL_DCSB1                       (0x1B4)
+#define PLL_DCSB2                       (0x1B8)
+#define PLL_DCSB3                       (0x1BC)
+#define PLL_GPU1                        (0x1C0)
+#define PLL_GPU2                        (0x1C4)
+
+/* PLL_DIV */
+#define SCPU_FREQ_SEL_SHIFT             (7)
+#define SCPU_FREQ_SEL_WIDTH             (2)
+#define SCPU_FREQ_DIV1                  (0)
+#define SCPU_FREQ_DIV2                  (2)
+#define SCPU_FREQ_DIV4                  (3)
+
+#define BUS_FREQ_SEL_SHIFT              (0)
+#define BUS_FREQ_SEL_WIDTH              (1)
+#define BUS_FREQ_DIV1                   (0)
+#define BUS_FREQ_DIV2                   (1)
+
+/* VE_CKSEL */
+#define CLK_VE2_BPU_SEL_SHIFT           (6)
+#define CLK_VE2_BPU_SEL_WIDTH           (2)
+#define CLK_VE2_SEL_SHIFT               (2)
+#define CLK_VE2_SEL_WIDTH               (2)
+#define CLK_VE1_SEL_SHIFT               (0)
+#define CLK_VE1_SEL_WIDTH               (2)
+
+#endif
diff --git a/drivers/clk/realtek/include/rtd129x/clk_regmap.h b/drivers/clk/realtek/include/rtd129x/clk_regmap.h
new file mode 100644
index 00000000..07beb59
--- /dev/null
+++ b/drivers/clk/realtek/include/rtd129x/clk_regmap.h
@@ -0,0 +1,90 @@
+#ifndef __CLK_REALTEK_REGMAP_RTD129X_H
+#define __CLK_REALTEK_REGMAP_RTD129X_H
+
+#define CLOCK_ENABLE1                   (0x00C)
+#define CLOCK_ENABLE2                   (0x010)
+#define GROUP1_CK_SEL                   (0x018)
+#define PLL_DIV                         (0x030)
+#define VE_CKSEL                        (0x04C)
+#define PLL_VE1_1                       (0x114)
+#define PLL_VE1_2                       (0x118)
+#define PLL_DDSA1                       (0x120)
+#define PLL_DDSA2                       (0x128)
+#define PLL_DDSB1                       (0x174)
+#define PLL_DDSB2                       (0x178)
+#define PLL_GPU1                        (0x1C0)
+#define PLL_GPU2                        (0x1C4)
+#define PLL_VE2_1                       (0x1D0)
+#define PLL_VE2_2                       (0x1D4)
+#define PLL_SSC_DIG_SCPU0               (0x500)
+#define PLL_SSC_DIG_SCPU1               (0x504)
+#define PLL_SSC_DIG_SCPU2               (0x508)
+#define PLL_SSC_DIG_SCPU3               (0x50C)
+#define PLL_SSC_DIG_SCPU4               (0x510)
+#define PLL_SSC_DIG_SCPU5               (0x514)
+#define PLL_SSC_DIG_SCPU_DBG1           (0x518)
+#define PLL_SSC_DIG_SCPU_DBG2           (0x51C)
+#define PLL_SSC_DIG_BUS0                (0x520)
+#define PLL_SSC_DIG_BUS1                (0x524)
+#define PLL_SSC_DIG_BUS2                (0x528)
+#define PLL_SSC_DIG_BUS3                (0x52C)
+#define PLL_SSC_DIG_BUS4                (0x530)
+#define PLL_SSC_DIG_BUS5                (0x534)
+#define PLL_SSC_DIG_BUS_DBG1            (0x538)
+#define PLL_SSC_DIG_BUS_DBG2            (0x53C)
+#define PLL_SSC_DIG_BUSH0               (0x540)
+#define PLL_SSC_DIG_BUSH1               (0x544)
+#define PLL_SSC_DIG_BUSH2               (0x548)
+#define PLL_SSC_DIG_BUSH3               (0x54C)
+#define PLL_SSC_DIG_BUSH4               (0x550)
+#define PLL_SSC_DIG_BUSH5               (0x554)
+#define PLL_SSC_DIG_BUSH_DBG1           (0x558)
+#define PLL_SSC_DIG_BUSH_DBG2           (0x55C)
+#define PLL_SSC_DIG_DDSA0               (0x560)
+#define PLL_SSC_DIG_DDSA1               (0x564)
+#define PLL_SSC_DIG_DDSA2               (0x568)
+#define PLL_SSC_DIG_DDSA3               (0x56C)
+#define PLL_SSC_DIG_DDSA4               (0x570)
+#define PLL_SSC_DIG_DDSA5               (0x574)
+#define PLL_SSC_DIG_DDSA_DBG1           (0x578)
+#define PLL_SSC_DIG_DDSA_DBG2           (0x57C)
+#define PLL_SSC_DIG_DDSB0               (0x580)
+#define PLL_SSC_DIG_DDSB1               (0x584)
+#define PLL_SSC_DIG_DDSB2               (0x588)
+#define PLL_SSC_DIG_DDSB3               (0x58C)
+#define PLL_SSC_DIG_DDSB4               (0x590)
+#define PLL_SSC_DIG_DDSB5               (0x594)
+#define PLL_SSC_DIG_DDSB_DBG1           (0x598)
+#define PLL_SSC_DIG_DDSB_DBG2           (0x59C)
+#define PLL_SSC_DIG_GPU0                (0x5A0)
+#define PLL_SSC_DIG_GPU1                (0x5A4)
+#define PLL_SSC_DIG_GPU2                (0x5A8)
+#define PLL_SSC_DIG_GPU3                (0x5AC)
+#define PLL_SSC_DIG_GPU4                (0x5B0)
+#define PLL_SSC_DIG_GPU5                (0x5B4)
+#define PLL_SSC_DIG_GPU_DBG1            (0x5B8)
+#define PLL_SSC_DIG_GPU_DBG2            (0x5BC)
+
+/* PLL_DIV */
+#define SCPU_FREQ_SEL_SHIFT             (7)
+#define SCPU_FREQ_SEL_WIDTH             (2)
+#define SCPU_FREQ_DIV1                  (0)
+#define SCPU_FREQ_DIV2                  (2)
+#define SCPU_FREQ_DIV4                  (3)
+
+#define BUS_FREQ_SEL_SHIFT              (0)
+#define BUS_FREQ_SEL_WIDTH              (1)
+#define BUS_FREQ_DIV1                   (0)
+#define BUS_FREQ_DIV2                   (1)
+
+/* VE_CKSEL */
+#define CLK_VE2_BPU_SEL_SHIFT           (8)
+#define CLK_VE2_BPU_SEL_WIDTH           (2)
+#define CLK_VE3_SEL_SHIFT               (4)
+#define CLK_VE3_SEL_WIDTH               (2)
+#define CLK_VE2_SEL_SHIFT               (2)
+#define CLK_VE2_SEL_WIDTH               (2)
+#define CLK_VE1_SEL_SHIFT               (0)
+#define CLK_VE1_SEL_WIDTH               (2)
+
+#endif
diff --git a/drivers/clk/realtek/include/rtd139x/clk_regmap.h b/drivers/clk/realtek/include/rtd139x/clk_regmap.h
new file mode 100644
index 00000000..ba3e0a6
--- /dev/null
+++ b/drivers/clk/realtek/include/rtd139x/clk_regmap.h
@@ -0,0 +1,104 @@
+#ifndef __CLK_REALTEK_REGMAP_RTD139X_H
+#define __CLK_REALTEK_REGMAP_RTD139X_H
+
+#define CLOCK_ENABLE1                   (0x00C)
+#define CLOCK_ENABLE2                   (0x010)
+#define GROUP1_CK_SEL                   (0x018)
+#define PLL_DIV                         (0x030)
+#define VE_CKSEL                        (0x04C)
+#define PLL_VE1_1                       (0x114)
+#define PLL_VE1_2                       (0x118)
+#define PLL_DDSA1                       (0x120)
+#define PLL_DDSA2                       (0x128)
+#define PLL_DDSB1                       (0x174)
+#define PLL_DDSB2                       (0x178)
+#define PLL_GPU1                        (0x1C0)
+#define PLL_GPU2                        (0x1C4)
+#define PLL_VE2_1                       (0x1D0)
+#define PLL_VE2_2                       (0x1D4)
+#define PLL_SSC_DIG_SCPU0               (0x500)
+#define PLL_SSC_DIG_SCPU1               (0x504)
+#define PLL_SSC_DIG_SCPU2               (0x508)
+#define PLL_SSC_DIG_SCPU3               (0x50C)
+#define PLL_SSC_DIG_SCPU4               (0x510)
+#define PLL_SSC_DIG_SCPU5               (0x514)
+#define PLL_SSC_DIG_SCPU_DBG1           (0x518)
+#define PLL_SSC_DIG_SCPU_DBG2           (0x51C)
+#define PLL_SSC_DIG_BUS0                (0x520)
+#define PLL_SSC_DIG_BUS1                (0x524)
+#define PLL_SSC_DIG_BUS2                (0x528)
+#define PLL_SSC_DIG_BUS3                (0x52C)
+#define PLL_SSC_DIG_BUS4                (0x530)
+#define PLL_SSC_DIG_BUS5                (0x534)
+#define PLL_SSC_DIG_BUS_DBG1            (0x538)
+#define PLL_SSC_DIG_BUS_DBG2            (0x53C)
+#define PLL_SSC_DIG_DCSB0               (0x540)
+#define PLL_SSC_DIG_DCSB1               (0x544)
+#define PLL_SSC_DIG_DCSB2               (0x548)
+#define PLL_SSC_DIG_DCSB3               (0x54C)
+#define PLL_SSC_DIG_DCSB4               (0x550)
+#define PLL_SSC_DIG_DCSB5               (0x554)
+#define PLL_SSC_DIG_DCSB_DBG1           (0x558)
+#define PLL_SSC_DIG_DCSB_DBG2           (0x55C)
+#define PLL_SSC_DIG_DDSA0               (0x560)
+#define PLL_SSC_DIG_DDSA1               (0x564)
+#define PLL_SSC_DIG_DDSA2               (0x568)
+#define PLL_SSC_DIG_DDSA3               (0x56C)
+#define PLL_SSC_DIG_DDSA4               (0x570)
+#define PLL_SSC_DIG_DDSA5               (0x574)
+#define PLL_SSC_DIG_DDSA_DBG1           (0x578)
+#define PLL_SSC_DIG_DDSA_DBG2           (0x57C)
+#define PLL_SSC_DIG_DDSB0               (0x580)
+#define PLL_SSC_DIG_DDSB1               (0x584)
+#define PLL_SSC_DIG_DDSB2               (0x588)
+#define PLL_SSC_DIG_DDSB3               (0x58C)
+#define PLL_SSC_DIG_DDSB4               (0x590)
+#define PLL_SSC_DIG_DDSB5               (0x594)
+#define PLL_SSC_DIG_DDSB_DBG1           (0x598)
+#define PLL_SSC_DIG_DDSB_DBG2           (0x59C)
+#define PLL_SSC_DIG_GPU0                (0x5A0)
+#define PLL_SSC_DIG_GPU1                (0x5A4)
+#define PLL_SSC_DIG_GPU2                (0x5A8)
+#define PLL_SSC_DIG_GPU3                (0x5AC)
+#define PLL_SSC_DIG_GPU4                (0x5B0)
+#define PLL_SSC_DIG_GPU5                (0x5B4)
+#define PLL_SSC_DIG_GPU_DBG1            (0x5B8)
+#define PLL_SSC_DIG_GPU_DBG2            (0x5BC)
+
+/* PLL_DIV */
+#define SCPU_FREQ_SEL_SHIFT             (6)
+#define SCPU_FREQ_SEL_WIDTH             (8)
+#define SCPU_FREQ_SEL1                  (0x02)
+#define SCPU_FREQ_SEL7                  (0x80)
+#define SCPU_FREQ_DIV1                  (0)
+#define SCPU_FREQ_DIV2                  (0 | SCPU_FREQ_SEL1)
+#define SCPU_FREQ_DIV4                  (1 | SCPU_FREQ_SEL1)
+#define SCPU_FREQ_DIV3                  ((3 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV5                  ((5 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV6                  ((6 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV7                  ((7 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV8                  ((8 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV10                 ((10 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV13                 ((13 << 2) | SCPU_FREQ_SEL7)
+
+#define BUS_FREQ_SEL_SHIFT              (0)
+#define BUS_FREQ_SEL_WIDTH              (2)
+#define BUS_FREQ_DIV1                   (0)
+#define BUS_FREQ_DIV2                   (2)
+#define BUS_FREQ_DIV4                   (3)
+
+#define DCSB_FREQ_SEL_SHIFT             (2)
+#define DCSB_FREQ_SEL_WIDTH             (2)
+#define DCSB_FREQ_DIV1                  (0)
+#define DCSB_FREQ_DIV2                  (2)
+#define DCSB_FREQ_DIV4                  (3)
+
+/* VE_CKSEL */
+#define CLK_VE2_BPU_SEL_SHIFT           (9)
+#define CLK_VE2_BPU_SEL_WIDTH           (3)
+#define CLK_VE2_SEL_SHIFT               (3)
+#define CLK_VE2_SEL_WIDTH               (3)
+#define CLK_VE1_SEL_SHIFT               (0)
+#define CLK_VE1_SEL_WIDTH               (3)
+
+#endif
diff --git a/drivers/clk/realtek/include/rtd13xx/clk_regmap.h b/drivers/clk/realtek/include/rtd13xx/clk_regmap.h
new file mode 100644
index 00000000..28c49c3
--- /dev/null
+++ b/drivers/clk/realtek/include/rtd13xx/clk_regmap.h
@@ -0,0 +1,113 @@
+#ifndef __CLK_REALTEK_REGMAP_RTDRTD13XX_H
+#define __CLK_REALTEK_REGMAP_RTDRTD13XX_H
+
+#define GROUP1_CK_SEL                   (0x018)
+#define PLL_DIV                         (0x030)
+#define VE_CKSEL                        (0x04C)
+#define CLOCK_ENABLE1                   (0x050)
+#define CLOCK_ENABLE2                   (0x054)
+#define CLOCK_ENABLE3                   (0x058)
+#define CLOCK_ENABLE4                   (0x05C)
+#define PLL_VE1_1                       (0x114)
+#define PLL_VE1_2                       (0x118)
+#define PLL_DDSA1                       (0x120)
+#define PLL_DDSA2                       (0x128)
+#define PLL_PSAUDA1                     (0x130)
+#define PLL_PSAUDA2                     (0x134)
+#define PLL_GPU1                        (0x1C0)
+#define PLL_GPU2                        (0x1C4)
+#define PLL_VE2_1                       (0x1D0)
+#define PLL_VE2_2                       (0x1D4)
+#define PLL_SSC_DIG_SCPU0               (0x500)
+#define PLL_SSC_DIG_SCPU1               (0x504)
+#define PLL_SSC_DIG_SCPU2               (0x508)
+#define PLL_SSC_DIG_SCPU3               (0x50C)
+#define PLL_SSC_DIG_SCPU4               (0x510)
+#define PLL_SSC_DIG_SCPU5               (0x514)
+#define PLL_SSC_DIG_SCPU_DBG1           (0x518)
+#define PLL_SSC_DIG_SCPU_DBG2           (0x51C)
+#define PLL_SSC_DIG_BUS0                (0x520)
+#define PLL_SSC_DIG_BUS1                (0x524)
+#define PLL_SSC_DIG_BUS2                (0x528)
+#define PLL_SSC_DIG_BUS3                (0x52C)
+#define PLL_SSC_DIG_BUS4                (0x530)
+#define PLL_SSC_DIG_BUS5                (0x534)
+#define PLL_SSC_DIG_BUS_DBG1            (0x538)
+#define PLL_SSC_DIG_BUS_DBG2            (0x53C)
+#define PLL_SSC_DIG_DCSB0               (0x540)
+#define PLL_SSC_DIG_DCSB1               (0x544)
+#define PLL_SSC_DIG_DCSB2               (0x548)
+#define PLL_SSC_DIG_DCSB3               (0x54C)
+#define PLL_SSC_DIG_DCSB4               (0x550)
+#define PLL_SSC_DIG_DCSB5               (0x554)
+#define PLL_SSC_DIG_DCSB_DBG1           (0x558)
+#define PLL_SSC_DIG_DCSB_DBG2           (0x55C)
+#define PLL_SSC_DIG_DDSA0               (0x560)
+#define PLL_SSC_DIG_DDSA1               (0x564)
+#define PLL_SSC_DIG_DDSA2               (0x568)
+#define PLL_SSC_DIG_DDSA3               (0x56C)
+#define PLL_SSC_DIG_DDSA4               (0x570)
+#define PLL_SSC_DIG_DDSA5               (0x574)
+#define PLL_SSC_DIG_DDSA_DBG1           (0x578)
+#define PLL_SSC_DIG_DDSA_DBG2           (0x57C)
+#define PLL_SSC_DIG_GPU0                (0x5A0)
+#define PLL_SSC_DIG_GPU1                (0x5A4)
+#define PLL_SSC_DIG_GPU2                (0x5A8)
+#define PLL_SSC_DIG_GPU3                (0x5AC)
+#define PLL_SSC_DIG_GPU4                (0x5B0)
+#define PLL_SSC_DIG_GPU5                (0x5B4)
+#define PLL_SSC_DIG_GPU_DBG1            (0x5B8)
+#define PLL_SSC_DIG_GPU_DBG2            (0x5BC)
+#define PLL_DIF1                        (0x624)
+#define PLL_DIF2                        (0x628)
+#define PLL_DIF3                        (0x62C)
+#define PLL_DIF4                        (0x630)
+#define PLL_SSC_DIG_PLLDIF0             (0x634)
+#define PLL_SSC_DIG_PLLDIF1             (0x638)
+#define PLL_SSC_DIG_PLLDIF2             (0x63C)
+#define PLL_SSC_DIG_PLLDIF3             (0x640)
+#define PLL_SSC_DIG_PLLDIF4             (0x644)
+#define PLL_SSC_DIG_PLLDIF5             (0x648)
+#define PLL_SSC_DIG_PLLDIF_DBG1         (0x64C)
+#define PLL_SSC_DIG_PLLDIF_DBG2         (0x650)
+
+/* PLL_DIV */
+#define SCPU_FREQ_SEL_SHIFT             (6)
+#define SCPU_FREQ_SEL_WIDTH             (8)
+#define SCPU_FREQ_SEL1                  (0x00)
+#define SCPU_FREQ_SEL7                  (0x80)
+#define SCPU_FREQ_DIV1                  (0)
+#define SCPU_FREQ_DIV2                  ((2 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV4                  ((4 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV3                  ((3 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV5                  ((5 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV6                  ((6 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV7                  ((7 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV8                  ((8 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV10                 ((10 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV13                 ((13 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV32                 ((32 << 2) | SCPU_FREQ_SEL7)
+
+#define BUS_FREQ_SEL_SHIFT              (0)
+#define BUS_FREQ_SEL_WIDTH              (2)
+#define BUS_FREQ_DIV1                   (0)
+#define BUS_FREQ_DIV2                   (2)
+#define BUS_FREQ_DIV4                   (3)
+
+#define DCSB_FREQ_SEL_SHIFT             (2)
+#define DCSB_FREQ_SEL_WIDTH             (2)
+#define DCSB_FREQ_DIV1                  (0)
+#define DCSB_FREQ_DIV2                  (2)
+#define DCSB_FREQ_DIV4                  (3)
+
+/* VE_CKSEL */
+#define CLK_VE3_BPU_SEL_SHIFT           (9)
+#define CLK_VE3_BPU_SEL_WIDTH           (3)
+#define CLK_VE3_SEL_SHIFT               (6)
+#define CLK_VE3_SEL_WIDTH               (3)
+#define CLK_VE2_SEL_SHIFT               (3)
+#define CLK_VE2_SEL_WIDTH               (3)
+#define CLK_VE1_SEL_SHIFT               (0)
+#define CLK_VE1_SEL_WIDTH               (3)
+
+#endif
diff --git a/drivers/clk/realtek/include/rtd16xx/clk_regmap.h b/drivers/clk/realtek/include/rtd16xx/clk_regmap.h
new file mode 100644
index 00000000..1f17a4df
--- /dev/null
+++ b/drivers/clk/realtek/include/rtd16xx/clk_regmap.h
@@ -0,0 +1,112 @@
+#ifndef __CLK_REALTEK_REGMAP_RTD16XX_H
+#define __CLK_REALTEK_REGMAP_RTD16XX_H
+
+#define GROUP1_CK_SEL                   (0x018)
+#define PLL_DIV                         (0x030)
+#define VE_CKSEL                        (0x04C)
+#define CLOCK_ENABLE1                   (0x050)
+#define CLOCK_ENABLE2                   (0x054)
+#define CLOCK_ENABLE3                   (0x058)
+#define CLOCK_ENABLE4                   (0x05C)
+#define PLL_VE1_1                       (0x114)
+#define PLL_VE1_2                       (0x118)
+#define PLL_DDSA1                       (0x120)
+#define PLL_DDSA2                       (0x128)
+#define PLL_PSAUDA1                     (0x130)
+#define PLL_PSAUDA2                     (0x134)
+#define PLL_GPU1                        (0x1C0)
+#define PLL_GPU2                        (0x1C4)
+#define PLL_VE2_1                       (0x1D0)
+#define PLL_VE2_2                       (0x1D4)
+#define PLL_SSC_DIG_SCPU0               (0x500)
+#define PLL_SSC_DIG_SCPU1               (0x504)
+#define PLL_SSC_DIG_SCPU2               (0x508)
+#define PLL_SSC_DIG_SCPU3               (0x50C)
+#define PLL_SSC_DIG_SCPU4               (0x510)
+#define PLL_SSC_DIG_SCPU5               (0x514)
+#define PLL_SSC_DIG_SCPU_DBG1           (0x518)
+#define PLL_SSC_DIG_SCPU_DBG2           (0x51C)
+#define PLL_SSC_DIG_BUS0                (0x520)
+#define PLL_SSC_DIG_BUS1                (0x524)
+#define PLL_SSC_DIG_BUS2                (0x528)
+#define PLL_SSC_DIG_BUS3                (0x52C)
+#define PLL_SSC_DIG_BUS4                (0x530)
+#define PLL_SSC_DIG_BUS5                (0x534)
+#define PLL_SSC_DIG_BUS_DBG1            (0x538)
+#define PLL_SSC_DIG_BUS_DBG2            (0x53C)
+#define PLL_SSC_DIG_DCSB0               (0x540)
+#define PLL_SSC_DIG_DCSB1               (0x544)
+#define PLL_SSC_DIG_DCSB2               (0x548)
+#define PLL_SSC_DIG_DCSB3               (0x54C)
+#define PLL_SSC_DIG_DCSB4               (0x550)
+#define PLL_SSC_DIG_DCSB5               (0x554)
+#define PLL_SSC_DIG_DCSB_DBG1           (0x558)
+#define PLL_SSC_DIG_DCSB_DBG2           (0x55C)
+#define PLL_SSC_DIG_DDSA0               (0x560)
+#define PLL_SSC_DIG_DDSA1               (0x564)
+#define PLL_SSC_DIG_DDSA2               (0x568)
+#define PLL_SSC_DIG_DDSA3               (0x56C)
+#define PLL_SSC_DIG_DDSA4               (0x570)
+#define PLL_SSC_DIG_DDSA5               (0x574)
+#define PLL_SSC_DIG_DDSA_DBG1           (0x578)
+#define PLL_SSC_DIG_DDSA_DBG2           (0x57C)
+#define PLL_SSC_DIG_GPU0                (0x5A0)
+#define PLL_SSC_DIG_GPU1                (0x5A4)
+#define PLL_SSC_DIG_GPU2                (0x5A8)
+#define PLL_SSC_DIG_GPU3                (0x5AC)
+#define PLL_SSC_DIG_GPU4                (0x5B0)
+#define PLL_SSC_DIG_GPU5                (0x5B4)
+#define PLL_SSC_DIG_GPU_DBG1            (0x5B8)
+#define PLL_SSC_DIG_GPU_DBG2            (0x5BC)
+#define PLL_DIF1                        (0x624)
+#define PLL_DIF2                        (0x628)
+#define PLL_DIF3                        (0x62C)
+#define PLL_DIF4                        (0x630)
+#define PLL_SSC_DIG_PLLDIF0             (0x634)
+#define PLL_SSC_DIG_PLLDIF1             (0x638)
+#define PLL_SSC_DIG_PLLDIF2             (0x63C)
+#define PLL_SSC_DIG_PLLDIF3             (0x640)
+#define PLL_SSC_DIG_PLLDIF4             (0x644)
+#define PLL_SSC_DIG_PLLDIF5             (0x648)
+#define PLL_SSC_DIG_PLLDIF_DBG1         (0x64C)
+#define PLL_SSC_DIG_PLLDIF_DBG2         (0x650)
+
+/* PLL_DIV */
+#define SCPU_FREQ_SEL_SHIFT             (6)
+#define SCPU_FREQ_SEL_WIDTH             (8)
+#define SCPU_FREQ_SEL1                  (0x00)
+#define SCPU_FREQ_SEL7                  (0x80)
+#define SCPU_FREQ_DIV1                  (0)
+#define SCPU_FREQ_DIV2                  ((2 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV4                  ((4 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV3                  ((3 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV5                  ((5 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV6                  ((6 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV7                  ((7 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV8                  ((8 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV10                 ((10 << 2) | SCPU_FREQ_SEL7)
+#define SCPU_FREQ_DIV13                 ((13 << 2) | SCPU_FREQ_SEL7)
+
+#define BUS_FREQ_SEL_SHIFT              (0)
+#define BUS_FREQ_SEL_WIDTH              (2)
+#define BUS_FREQ_DIV1                   (0)
+#define BUS_FREQ_DIV2                   (2)
+#define BUS_FREQ_DIV4                   (3)
+
+#define DCSB_FREQ_SEL_SHIFT             (2)
+#define DCSB_FREQ_SEL_WIDTH             (2)
+#define DCSB_FREQ_DIV1                  (0)
+#define DCSB_FREQ_DIV2                  (2)
+#define DCSB_FREQ_DIV4                  (3)
+
+/* VE_CKSEL */
+#define CLK_VE2_BPU_SEL_SHIFT           (9)
+#define CLK_VE2_BPU_SEL_WIDTH           (3)
+#define CLK_VE3_SEL_SHIFT               (6)
+#define CLK_VE3_SEL_WIDTH               (3)
+#define CLK_VE2_SEL_SHIFT               (3)
+#define CLK_VE2_SEL_WIDTH               (3)
+#define CLK_VE1_SEL_SHIFT               (0)
+#define CLK_VE1_SEL_WIDTH               (3)
+
+#endif
diff --git a/drivers/clk/realtek/reset-platform.c b/drivers/clk/realtek/reset-platform.c
new file mode 100644
index 00000000..2facd2f
--- /dev/null
+++ b/drivers/clk/realtek/reset-platform.c
@@ -0,0 +1,277 @@
+/*
+ * reset-platform.c - Realtek Reset Controller platform code
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/pm.h>
+#include <linux/regmap.h>
+#include <linux/reset.h>
+#include <linux/reset-controller.h>
+#include <linux/slab.h>
+#include <linux/suspend.h>
+#include <soc/realtek/rtk_mmio.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <soc/realtek/rtk_chip.h>
+#include "common.h"
+#include "reset.h"
+
+static inline u32 bits_to_set(struct rc_reg_desc *reg, u32 bits_to_set)
+{
+	return bits_to_set * (reg->write_en ? 3 : 1);
+}
+
+static inline u32 bits_to_clear(struct rc_reg_desc *reg, u32 bits_to_clear)
+{
+	return reg->write_en ? (bits_to_clear << 1) : 0;
+}
+
+static inline u32 bits_to_mask(struct rc_reg_desc *reg, u32 bits)
+{
+	return bits_to_set(reg, bits);
+}
+
+static inline u32 rc_reg_read(struct rc_platform_data *data,
+			      struct rc_reg_desc *reg)
+{
+	u32 val = 0;
+
+	if (data->regmap)
+		regmap_read(data->regmap, data->offset + reg->offset, &val);
+	else if (data->reg)
+		val = readl(data->reg + reg->offset);
+	else
+		WARN_ON_ONCE(1);
+	return val;
+}
+
+static inline void rc_reg_update_bits(struct rc_platform_data *data,
+				      struct rc_reg_desc *reg,
+				      u32 mask,
+				      u32 val)
+{
+	dev_dbg(data->dev, "%s: offset=%03x: flags=%c, mask=%08x, val=%08x\n",
+		__func__, reg->offset, reg->write_en ? 'w' : '-', mask, val);
+	if (data->regmap) {
+		regmap_update_bits(data->regmap, data->offset + reg->offset,
+				   mask, val);
+	} else if (data->reg) {
+		unsigned int rval;
+
+		rval = readl(data->reg + reg->offset);
+		rval = (rval & ~mask) | (val & mask);
+		writel(rval, data->reg + reg->offset);
+	} else
+		WARN_ON_ONCE(1);
+}
+
+static int rc_reset_assert(struct reset_controller_dev *rcdev,
+			   unsigned long id)
+{
+	struct rc_platform_data *data = to_rc_platform_data(rcdev);
+	struct rc_reg_desc *reg = &data->desc[RC_DESC_ID(id)];
+	u32 val, mask;
+
+	mask = bits_to_mask(reg, RC_RESET_BIT_MASK(id));
+	val  = bits_to_clear(reg, RC_RESET_BIT_MASK(id));
+	rc_reg_update_bits(data, reg, mask, val);
+	return 0;
+}
+
+static int rc_reset_deassert(struct reset_controller_dev *rcdev,
+			     unsigned long id)
+{
+	struct rc_platform_data *data = to_rc_platform_data(rcdev);
+	struct rc_reg_desc *reg = &data->desc[RC_DESC_ID(id)];
+	u32 val, mask;
+
+	mask = bits_to_mask(reg, RC_RESET_BIT_MASK(id));
+	val = bits_to_set(reg, RC_RESET_BIT_MASK(id));
+	rc_reg_update_bits(data, reg, mask, val);
+	return 0;
+}
+
+static int rc_reset_reset(struct reset_controller_dev *rcdev,
+			  unsigned long id)
+{
+	int ret;
+
+	ret = rc_reset_assert(rcdev, id);
+	if (ret)
+		return ret;
+	return rc_reset_deassert(rcdev, id);
+}
+
+static int rc_reset_status(struct reset_controller_dev *rcdev,
+			   unsigned long id)
+{
+	struct rc_platform_data *data = to_rc_platform_data(rcdev);
+	struct rc_reg_desc *reg = &data->desc[RC_DESC_ID(id)];
+	u32 val = 0;
+
+	val = rc_reg_read(data, reg);
+	return !(val & RC_RESET_BIT_MASK(id));
+}
+
+static struct reset_control_ops rc_ops = {
+	.assert   = rc_reset_assert,
+	.deassert = rc_reset_deassert,
+	.reset    = rc_reset_reset,
+	.status   = rc_reset_status,
+};
+
+static int rc_suspend(struct device *dev)
+{
+	struct rc_platform_data *data = dev_get_drvdata(dev);
+	struct rc_reg_desc *desc;
+	int i;
+
+	dev_info(dev, "enter %s\n", __func__);
+	for (i = 0; i < data->num_desc; i++) {
+		desc = &data->desc[i];
+
+		if (rc_is_invalid(desc))
+			continue;
+
+		desc->pm_data = rc_reg_read(data, desc);
+		dev_info(dev, "%03x: suspend_val=%08x\n", desc->offset,
+			desc->pm_data);
+	}
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static void rc_resume_desc(struct device *dev,
+			   struct rc_platform_data *data,
+			   struct rc_reg_desc *desc)
+{
+	u32 mask, val;
+
+	if (rc_is_invalid(desc))
+		return;
+
+	dev_info(dev, "%03x: current=%08x, suspend=%08x\n", desc->offset,
+		 rc_reg_read(data, desc), desc->pm_data);
+
+	val = desc->pm_data | (desc->write_en ? 0xaaaaaaaa : 0);
+	mask = ~bits_to_mask(desc, desc->pm_ignore_bits);
+	dev_info(dev, "%03x: write mask=%08x, val=%08x\n", desc->offset, mask, val);
+
+	/* apply reg-val */
+	rc_reg_update_bits(data, desc, mask, val);
+
+	dev_info(dev, "%03x: current=%08x\n", desc->offset,
+		rc_reg_read(data, desc));
+}
+
+static int rc_resume(struct device *dev)
+{
+	struct rc_platform_data *data = dev_get_drvdata(dev);
+	int i;
+
+	dev_info(dev, "enter %s\n", __func__);
+	for (i = 0; i < data->num_desc; i++)
+		rc_resume_desc(dev, data, &data->desc[i]);
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+const struct dev_pm_ops rc_pm_ops = {
+	.suspend_noirq = rc_suspend,
+	.resume_noirq  = rc_resume,
+};
+
+static int rc_of_reset_xlate(struct reset_controller_dev *rcdev,
+				  const struct of_phandle_args *reset_spec)
+{
+	struct rc_platform_data *data = to_rc_platform_data(rcdev);
+	int val;
+
+	val = reset_spec->args[0];
+	if (val >= rcdev->nr_resets)
+		return -EINVAL;
+
+	if (data->id_xlate)
+		return data->id_xlate(data, val);
+	return val;
+}
+
+static int rc_of_config_io_mem(struct device *dev,
+			       struct rc_platform_data *data)
+{
+	struct device_node *np = dev->of_node;
+	struct regmap *regmap;
+	int offset = 0;
+	struct resource r;
+	int ret;
+
+
+	regmap = of_get_rtk_mmio_regmap_with_offset(np, 0, &offset);
+	if (regmap) {
+		data->regmap = regmap;
+		data->offset = offset;
+		return 0;
+	}
+
+	ret = of_address_to_resource(np, 0, &r);
+	if (ret)
+		return ret;
+	data->reg = devm_ioremap(dev, r.start, resource_size(&r));
+	return data->reg ? 0 : -ENOMEM;
+}
+
+
+int rc_probe_platform(struct platform_device *pdev,
+		      struct rc_platform_data *data)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	int ret;
+
+	ret = rc_of_config_io_mem(dev, data);
+	if (ret) {
+		dev_err(dev, "failed to get io mem: %d\n", ret);
+		return ret;
+	}
+
+	dev_info(dev, "io mem type is %s\n",
+			data->regmap ? "regmap" : "direct");
+	data->dev = dev;
+	data->chip_rev = get_rtd_chip_revision();
+
+	data->rcdev.owner = THIS_MODULE;
+	data->rcdev.ops = &rc_ops;
+	data->rcdev.of_node = np;
+	data->rcdev.nr_resets = 0xffff;
+	data->rcdev.of_reset_n_cells = 1;
+	data->rcdev.of_xlate = rc_of_reset_xlate;
+	ret = reset_controller_register(&data->rcdev);
+	if (ret) {
+		dev_err(dev, "failed to register controller: %d\n", ret);
+		return ret;
+	}
+
+	platform_set_drvdata(pdev, data);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
diff --git a/drivers/clk/realtek/reset-rtd13xx.c b/drivers/clk/realtek/reset-rtd13xx.c
new file mode 100644
index 00000000..76444a9
--- /dev/null
+++ b/drivers/clk/realtek/reset-rtd13xx.c
@@ -0,0 +1,78 @@
+/*
+ * reset-rtd13xx.c - Realtek RTD-13xx Reset Controller
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/platform_device.h>
+#include <linux/pm.h>
+#include <soc/realtek/rtk_chip.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <dt-bindings/reset/rtk,reset-rtd13xx.h>
+#include "common.h"
+#include "reset.h"
+
+static struct rc_reg_desc rtd13xx_rc_desc[] = {
+	{ .offset = 0x00, .write_en = 1, },
+	{ .offset = 0x04, .write_en = 1, },
+	{ .offset = 0x08, .write_en = 1, .pm_ignore_bits = 0x50150000, },
+	{ .offset = 0x0c, .write_en = 1, .pm_ignore_bits = 0x40000000, },
+	{ .offset = RC_INVALID_OFFSET, },
+	{ .offset = 0x14, .write_en = 1, .pm_ignore_bits = 0x00140014, },
+	{ .offset = 0x68, .write_en = 1, },
+	{ .offset = 0x88, .write_en = 1, },
+	{ .offset = 0x90, .write_en = 1, },
+	{ .offset = 0x94, .write_en = 1, },
+	{ .offset = 0x454, },
+	{ .offset = 0x458, },
+	{ .offset = RC_INVALID_OFFSET, },
+	{ .offset = RC_INVALID_OFFSET, },
+	{ .offset = 0x464, },
+};
+
+static struct rc_platform_data rtd13xx_rc_platform_data = {
+	.desc     = rtd13xx_rc_desc,
+	.num_desc = ARRAY_SIZE(rtd13xx_rc_desc),
+};
+
+static int rtd13xx_rc_probe(struct platform_device *pdev)
+{
+	return rc_probe_platform(pdev, &rtd13xx_rc_platform_data);
+}
+
+static const struct of_device_id rtd13xx_rc_match[] = {
+	{ .compatible = "realtek,rtd13xx-reset-controller", },
+	{}
+};
+
+static struct platform_driver rtd13xx_rc_driver = {
+	.probe = rtd13xx_rc_probe,
+	.driver = {
+		.name   = "rtk-rtd13xx-reset",
+		.of_match_table = rtd13xx_rc_match,
+		.pm = &rc_pm_ops,
+	},
+};
+
+static int __init rtd13xx_rc_init(void)
+{
+	return platform_driver_register(&rtd13xx_rc_driver);
+}
+core_initcall(rtd13xx_rc_init);
+
diff --git a/drivers/clk/realtek/reset-rtd16xx.c b/drivers/clk/realtek/reset-rtd16xx.c
new file mode 100644
index 00000000..c9e5de9
--- /dev/null
+++ b/drivers/clk/realtek/reset-rtd16xx.c
@@ -0,0 +1,109 @@
+/*
+ * reset-rtd16xx.c - Realtek RTD-16xx Reset Controller
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/platform_device.h>
+#include <linux/pm.h>
+#include <soc/realtek/rtk_chip.h>
+#include <dt-bindings/reset/rtk,reset.h>
+#include <dt-bindings/reset/rtk,reset-rtd16xx.h>
+#include "common.h"
+#include "reset.h"
+
+static struct rc_reg_desc rtd16xx_rc_desc[] = {
+	{ .offset = 0x00, .write_en = 1, },
+	{ .offset = 0x04, .write_en = 1, },
+	{ .offset = 0x08, .write_en = 1, .pm_ignore_bits = 0x50150000, },
+	{ .offset = 0x0c, .write_en = 1, .pm_ignore_bits = 0x40000000, },
+	{ .offset = RC_INVALID_OFFSET, },
+	{ .offset = 0x14, .write_en = 1, .pm_ignore_bits = 0x00140014, },
+	{ .offset = 0x68, .write_en = 1, },
+};
+
+static unsigned long rtd16xx_rc_id_xlate(struct rc_platform_data *data,
+					 unsigned long id)
+{
+	unsigned long ret = id;
+
+	if (data->chip_rev != RTD_CHIP_A00) {
+		switch (id) {
+		case RSTN_HSE:
+			ret =  RSTN_HSE_2;
+			break;
+		case RSTN_R2RDSC:
+			ret =  RSTN_R2RDSC_2;
+			break;
+		case RSTN_EMMC:
+			ret =  RSTN_EMMC_2;
+			break;
+		case RSTN_NF:
+			ret =  RSTN_NF_2;
+			break;
+		case RSTN_MD:
+			ret =  RSTN_MD_2;
+			break;
+		case RSTN_TPB:
+			ret =  RSTN_TPB_2;
+			break;
+		case RSTN_TP:
+			ret =  RSTN_TP_2;
+			break;
+		case RSTN_MIPI:
+			ret =  RSTN_MIPI_2;
+			break;
+		}
+	}
+	if (ret != id)
+		pr_debug("%s: id: %lx -> %lx\n", __func__, id, ret);
+	return ret;
+}
+
+static struct rc_platform_data rtd16xx_rc_platform_data = {
+	.desc     = rtd16xx_rc_desc,
+	.num_desc = ARRAY_SIZE(rtd16xx_rc_desc),
+	.id_xlate = rtd16xx_rc_id_xlate,
+};
+
+static int rtd16xx_rc_probe(struct platform_device *pdev)
+{
+	return rc_probe_platform(pdev, &rtd16xx_rc_platform_data);
+}
+
+static const struct of_device_id rtd16xx_rc_match[] = {
+	{ .compatible = "realtek,rtd16xx-reset-controller", },
+	{}
+};
+
+static struct platform_driver rtd16xx_rc_driver = {
+	.probe = rtd16xx_rc_probe,
+	.driver = {
+		.name   = "rtk-rtd16xx-reset",
+		.of_match_table = rtd16xx_rc_match,
+		.pm = &rc_pm_ops,
+	},
+};
+
+static int __init rtd16xx_rc_init(void)
+{
+	return platform_driver_register(&rtd16xx_rc_driver);
+}
+core_initcall(rtd16xx_rc_init);
+
diff --git a/drivers/clk/realtek/reset.c b/drivers/clk/realtek/reset.c
new file mode 100644
index 00000000..fb14288
--- /dev/null
+++ b/drivers/clk/realtek/reset.c
@@ -0,0 +1,377 @@
+/*
+ * reset.c - Realtek Generic Reset Controller
+ *
+ * Copyright (C) 2016-2017,2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/list.h>
+#include <linux/mutex.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/pm.h>
+#include <linux/regmap.h>
+#include <linux/reset.h>
+#include <linux/reset-controller.h>
+#include <linux/slab.h>
+#include <soc/realtek/rtk_mmio.h>
+#include <dt-bindings/reset/rtk,reset.h>
+
+#include "common.h"
+
+static DEFINE_SPINLOCK(rtk_reset_async_lock);
+static LIST_HEAD(rtk_reset_async_list);
+
+#define RESET_ASYNC         BIT(0)
+#define RESET_NO_PM         BIT(1)
+#define RESET_HAS_WRITE_EN  BIT(2)
+
+struct reset_priv {
+	struct device *dev;
+	struct reset_controller_dev rcdev;
+	unsigned int flags;
+
+	/* register */
+	void *reg;
+
+	/* mmio regmap of reg */
+	struct regmap *regmap;
+	int offset;
+
+	/* async reset control */
+	unsigned int async_data;
+	unsigned int async_group;
+	struct list_head async_list;
+
+	/* pm */
+	unsigned int pm_data;
+	unsigned int pm_ignore_bits;
+
+	/* boot clear bits */
+	unsigned int boot_clear_bits;
+
+};
+
+#define to_reset_priv(_p) container_of((_p), struct reset_priv, rcdev)
+
+static inline int contain_write_en(struct reset_priv *priv)
+{
+	return !!(priv->flags & RESET_HAS_WRITE_EN);
+}
+
+static inline u32 bits_to_set(struct reset_priv *priv, u32 bits_to_set)
+{
+	return bits_to_set * (contain_write_en(priv) ? 3 : 1);
+}
+
+static inline u32 bits_to_clear(struct reset_priv *priv, u32 bits_to_clear)
+{
+	return contain_write_en(priv) ? (bits_to_clear << 1) : 0;
+}
+
+static inline u32 bits_to_mask(struct reset_priv *priv, u32 bits)
+{
+	return bits_to_set(priv, bits);
+}
+
+static inline void rtk_reset_write(struct reset_priv *priv, unsigned int val)
+{
+	WARN_ON_ONCE(1);
+}
+
+static inline void rtk_reset_read(struct reset_priv *priv, unsigned int *val)
+{
+	if (priv->regmap)
+		regmap_read(priv->regmap, priv->offset, val);
+	else if (priv->reg)
+		*val = readl(priv->reg);
+	else
+		WARN_ON_ONCE(1);
+}
+
+static inline void rtk_reset_update_bits(struct reset_priv *priv,
+	unsigned int mask, unsigned int val)
+{
+	dev_dbg(priv->dev, "%s: flags:%c mask=%08x, val=%08x\n",
+		__func__, contain_write_en(priv) ? 'w' : '-', mask, val);
+	if (priv->regmap) {
+		regmap_update_bits(priv->regmap, priv->offset, mask, val);
+	} else if (priv->reg) {
+		unsigned int rval;
+
+		rval = readl(priv->reg);
+		rval = (rval & ~mask) | (val & mask);
+		writel(rval, priv->reg);
+	} else
+		WARN_ON_ONCE(1);
+}
+
+static int rtk_reset_assert(struct reset_controller_dev *rcdev,
+		unsigned long id)
+{
+	struct reset_priv *priv = to_reset_priv(rcdev);
+	u32 val, mask;
+
+	if (priv->flags & RESET_ASYNC) {
+		if (id == RTK_RSTN_DO_SYNC)
+			return -EINVAL;
+	}
+
+	mask = bits_to_mask(priv, BIT(id));
+	val = bits_to_clear(priv, BIT(id));
+	rtk_reset_update_bits(priv, mask, val);
+
+	return 0;
+}
+
+static void rtk_reset_deassert_sync(unsigned int group)
+{
+	struct reset_priv *p;
+	u32 val, mask;
+
+	list_for_each_entry(p, &rtk_reset_async_list, async_list) {
+		if (p->async_group != group)
+			continue;
+
+		if (!p->async_data)
+			continue;
+
+		mask = bits_to_mask(p, p->async_data);
+		val = bits_to_set(p, p->async_data);
+		rtk_reset_update_bits(p, mask, val);
+
+		p->async_data = 0;
+	}
+}
+
+static int rtk_reset_deassert(struct reset_controller_dev *rcdev,
+		unsigned long id)
+{
+	struct reset_priv *priv = to_reset_priv(rcdev);
+	u32 val, mask;
+	unsigned long flags;
+
+	if (priv->flags & RESET_ASYNC) {
+		spin_lock_irqsave(&rtk_reset_async_lock, flags);
+		if (id == RTK_RSTN_DO_SYNC)
+			rtk_reset_deassert_sync(priv->async_group);
+		else
+			priv->async_data |= BIT(id);
+		spin_unlock_irqrestore(&rtk_reset_async_lock, flags);
+
+		return 0;
+	}
+
+	mask = bits_to_mask(priv, BIT(id));
+	val = bits_to_set(priv, BIT(id));
+	rtk_reset_update_bits(priv, mask, val);
+
+	return 0;
+}
+
+static int rtk_reset_reset(struct reset_controller_dev *rcdev,
+		unsigned long id)
+{
+	int ret;
+
+	ret = rtk_reset_assert(rcdev, id);
+	if (ret)
+		return ret;
+
+	return rtk_reset_deassert(rcdev, id);
+}
+
+static int rtk_reset_status(struct reset_controller_dev *rcdev,
+		unsigned long id)
+{
+	struct reset_priv *priv = to_reset_priv(rcdev);
+	unsigned int val = 0;
+
+	rtk_reset_read(priv, &val);
+	return !(val & BIT(id));
+}
+
+static struct reset_control_ops rtk_reset_ops = {
+	.assert   = rtk_reset_assert,
+	.deassert = rtk_reset_deassert,
+	.reset    = rtk_reset_reset,
+	.status   = rtk_reset_status,
+};
+
+static int rtk_reset_of_xlate(struct reset_controller_dev *rcdev,
+		const struct of_phandle_args *reset_spec)
+{
+	struct reset_priv __maybe_unused *priv = to_reset_priv(rcdev);
+	int id;
+
+	if (reset_spec->args_count != 1)
+		return -EINVAL;
+
+	id = (int)reset_spec->args[0];
+	return id;
+}
+
+static int rtk_reset_parse_dt(struct device_node *np, struct reset_priv *priv)
+{
+	u32 val;
+
+	if (of_find_property(np, "has-write-en", NULL))
+		priv->flags |= RESET_HAS_WRITE_EN;
+
+	if (!of_property_read_u32(np, "async-group", &val)) {
+		priv->flags |= RESET_ASYNC | RESET_NO_PM;
+		priv->async_group = val;
+		list_add(&priv->async_list, &rtk_reset_async_list);
+	}
+
+	if (of_find_property(np, "no-pm", NULL))
+		priv->flags |= RESET_NO_PM;
+
+	of_property_read_u32(np, "pm-ignore-bits", &priv->pm_ignore_bits);
+
+	priv->boot_clear_bits = 0;
+	of_property_read_u32(np, "boot-clear-bits", &priv->boot_clear_bits);
+
+	return 0;
+}
+
+static int rtk_reset_suspend(struct device *dev)
+{
+	struct reset_priv *priv = dev_get_drvdata(dev);
+
+	if (priv->flags & RESET_NO_PM)
+		return 0;
+
+	dev_info(dev, "Enter %s\n", __func__);
+
+	rtk_reset_read(priv, &priv->pm_data);
+	dev_dbg(dev, "%s: save val=%08x\n", __func__, priv->pm_data);
+
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_reset_resume(struct device *dev)
+{
+	struct reset_priv *priv = dev_get_drvdata(dev);
+	unsigned int mask;
+	unsigned int val;
+
+	if (priv->flags & RESET_NO_PM)
+		return 0;
+
+	dev_info(dev, "Enter %s\n", __func__);
+
+	dev_dbg(dev, "saved val=%08x\n", priv->pm_data);
+
+	val  = bits_to_set(priv, priv->pm_data);
+	mask = ~bits_to_mask(priv, priv->pm_ignore_bits);
+	dev_info(dev, "%s: restore mask=%08x, val=%08x\n", __func__, mask, val);
+	rtk_reset_update_bits(priv, mask, val);
+
+	rtk_reset_read(priv, &val);
+	dev_dbg(dev, "register val=%08x\n", val);
+
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_reset_pm_ops = {
+	.suspend_noirq = rtk_reset_suspend,
+	.resume_noirq = rtk_reset_resume,
+};
+
+static int rtk_reset_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	struct reset_priv *priv;
+	struct regmap *regmap;
+	void *reg;
+	int offset = 0;
+	int ret;
+
+
+	priv = devm_kzalloc(&pdev->dev, sizeof(struct reset_priv), GFP_KERNEL);
+	if (!priv)
+		return -ENOMEM;
+
+	reg = of_iomap(np, 0);
+	regmap = of_get_rtk_mmio_regmap_with_offset(np, 0, &offset);
+	if (IS_ERR(regmap))
+		regmap = NULL;
+	if (!reg && IS_ERR_OR_NULL(regmap))
+		return -EINVAL;
+
+	priv->dev = dev;
+	priv->reg = reg;
+	if (regmap) {
+		priv->regmap = regmap;
+		priv->offset = offset;
+		dev_info(dev, "use mmio regmap\n");
+	}
+
+	priv->rcdev.owner = THIS_MODULE;
+	priv->rcdev.ops = &rtk_reset_ops;
+	priv->rcdev.of_node = np;
+	priv->rcdev.of_reset_n_cells = 1;
+	priv->rcdev.of_xlate = rtk_reset_of_xlate;
+	rtk_reset_parse_dt(np, priv);
+
+	if (priv->boot_clear_bits) {
+		u32 mask = bits_to_mask(priv, priv->boot_clear_bits);
+		u32 val = bits_to_clear(priv, priv->boot_clear_bits);
+
+		dev_info(dev, "boot_clear_bits: mask=%08x, val=%08x\n",
+			mask, val);
+		rtk_reset_update_bits(priv, mask, val);
+	}
+	ret = reset_controller_register(&priv->rcdev);
+	if (ret)
+		return ret;
+
+	platform_set_drvdata(pdev, priv);
+	dev_info(dev, "initialized\n");
+
+	return ret;
+}
+
+static const struct of_device_id rtk_reset_match[] = {
+	{.compatible = "realtek,reset-controller"},
+	{}
+};
+
+static struct platform_driver rtk_reset_driver = {
+	.probe = rtk_reset_probe,
+	.driver = {
+		.name   = "rtk-reset",
+		.of_match_table = rtk_reset_match,
+		.pm = &rtk_reset_pm_ops,
+	},
+};
+
+static int __init rtk_reset_init(void)
+{
+	return platform_driver_register(&rtk_reset_driver);
+}
+core_initcall(rtk_reset_init);
+
diff --git a/drivers/clocksource/Kconfig b/drivers/clocksource/Kconfig
index e2c6e43..529dd23 100644
--- a/drivers/clocksource/Kconfig
+++ b/drivers/clocksource/Kconfig
@@ -133,6 +133,14 @@ config ASM9260_TIMER
 	help
 	  Enables support for the ASM9260 timer.
 
+config RTK_TIMER
+	bool "Realtek System Timer"
+	depends on RTK_PLATFORM
+	select CLKSRC_MMIO
+	default n
+	help
+	  Realtek System Timer.
+
 config CLKSRC_NOMADIK_MTU
 	bool "Nomakdik clocksource driver" if COMPILE_TEST
 	depends on ARM
@@ -305,6 +313,14 @@ config ARM_ARCH_TIMER_EVTSTREAM
 	  This must be disabled for hardware validation purposes to detect any
 	  hardware anomalies of missing events.
 
+config ARM_ARCH_TIMER_VCT_ACCESS
+	bool "Support for ARM architected timer virtual counter access in userspace"
+	default !ARM64
+	depends on ARM_ARCH_TIMER
+	help
+	  This option enables support for reading the ARM architected timer's
+	  virtual counter in userspace.
+
 config FSL_ERRATUM_A008585
 	bool "Workaround for Freescale/NXP Erratum A-008585"
 	default y
diff --git a/drivers/clocksource/Makefile b/drivers/clocksource/Makefile
index cf87f40..300d682 100644
--- a/drivers/clocksource/Makefile
+++ b/drivers/clocksource/Makefile
@@ -50,6 +50,7 @@ obj-$(CONFIG_CLKSRC_PISTACHIO)	+= time-pistachio.o
 obj-$(CONFIG_CLKSRC_TI_32K)	+= timer-ti-32k.o
 obj-$(CONFIG_CLKSRC_NPS)	+= timer-nps.o
 obj-$(CONFIG_OXNAS_RPS_TIMER)	+= timer-oxnas-rps.o
+obj-$(CONFIG_RTK_TIMER)		+= rtk_timer.o
 
 obj-$(CONFIG_ARM_ARCH_TIMER)		+= arm_arch_timer.o
 obj-$(CONFIG_ARM_GLOBAL_TIMER)		+= arm_global_timer.o
diff --git a/drivers/clocksource/arm_arch_timer.c b/drivers/clocksource/arm_arch_timer.c
index a2503db..99208ab 100644
--- a/drivers/clocksource/arm_arch_timer.c
+++ b/drivers/clocksource/arm_arch_timer.c
@@ -140,20 +140,20 @@ void arch_timer_reg_write(int access, enum arch_timer_reg reg, u32 val,
 		struct arch_timer *timer = to_arch_timer(clk);
 		switch (reg) {
 		case ARCH_TIMER_REG_CTRL:
-			writel_relaxed(val, timer->base + CNTP_CTL);
+			writel_relaxed_no_log(val, timer->base + CNTP_CTL);
 			break;
 		case ARCH_TIMER_REG_TVAL:
-			writel_relaxed(val, timer->base + CNTP_TVAL);
+			writel_relaxed_no_log(val, timer->base + CNTP_TVAL);
 			break;
 		}
 	} else if (access == ARCH_TIMER_MEM_VIRT_ACCESS) {
 		struct arch_timer *timer = to_arch_timer(clk);
 		switch (reg) {
 		case ARCH_TIMER_REG_CTRL:
-			writel_relaxed(val, timer->base + CNTV_CTL);
+			writel_relaxed_no_log(val, timer->base + CNTV_CTL);
 			break;
 		case ARCH_TIMER_REG_TVAL:
-			writel_relaxed(val, timer->base + CNTV_TVAL);
+			writel_relaxed_no_log(val, timer->base + CNTV_TVAL);
 			break;
 		}
 	} else {
@@ -171,20 +171,20 @@ u32 arch_timer_reg_read(int access, enum arch_timer_reg reg,
 		struct arch_timer *timer = to_arch_timer(clk);
 		switch (reg) {
 		case ARCH_TIMER_REG_CTRL:
-			val = readl_relaxed(timer->base + CNTP_CTL);
+			val = readl_relaxed_no_log(timer->base + CNTP_CTL);
 			break;
 		case ARCH_TIMER_REG_TVAL:
-			val = readl_relaxed(timer->base + CNTP_TVAL);
+			val = readl_relaxed_no_log(timer->base + CNTP_TVAL);
 			break;
 		}
 	} else if (access == ARCH_TIMER_MEM_VIRT_ACCESS) {
 		struct arch_timer *timer = to_arch_timer(clk);
 		switch (reg) {
 		case ARCH_TIMER_REG_CTRL:
-			val = readl_relaxed(timer->base + CNTV_CTL);
+			val = readl_relaxed_no_log(timer->base + CNTV_CTL);
 			break;
 		case ARCH_TIMER_REG_TVAL:
-			val = readl_relaxed(timer->base + CNTV_TVAL);
+			val = readl_relaxed_no_log(timer->base + CNTV_TVAL);
 			break;
 		}
 	} else {
@@ -449,7 +449,10 @@ static void arch_counter_set_user_access(void)
 			| ARCH_TIMER_USR_PCT_ACCESS_EN);
 
 	/* Enable user access to the virtual counter */
-	cntkctl |= ARCH_TIMER_USR_VCT_ACCESS_EN;
+	if (IS_ENABLED(CONFIG_ARM_ARCH_TIMER_VCT_ACCESS))
+		cntkctl |= ARCH_TIMER_USR_VCT_ACCESS_EN;
+	else
+		cntkctl &= ~ARCH_TIMER_USR_VCT_ACCESS_EN;
 
 	arch_timer_set_cntkctl(cntkctl);
 }
@@ -509,7 +512,7 @@ static int arch_timer_starting_cpu(unsigned int cpu)
 	if (!acpi_disabled ||
 	    of_property_read_u32(np, "clock-frequency", &arch_timer_rate)) {
 		if (cntbase)
-			arch_timer_rate = readl_relaxed(cntbase + CNTFRQ);
+			arch_timer_rate = readl_relaxed_no_log(cntbase + CNTFRQ);
 		else
 			arch_timer_rate = arch_timer_get_cntfrq();
 	}
@@ -546,9 +549,9 @@ static u64 arch_counter_get_cntvct_mem(void)
 	u32 vct_lo, vct_hi, tmp_hi;
 
 	do {
-		vct_hi = readl_relaxed(arch_counter_base + CNTVCT_HI);
-		vct_lo = readl_relaxed(arch_counter_base + CNTVCT_LO);
-		tmp_hi = readl_relaxed(arch_counter_base + CNTVCT_HI);
+		vct_hi = readl_relaxed_no_log(arch_counter_base + CNTVCT_HI);
+		vct_lo = readl_relaxed_no_log(arch_counter_base + CNTVCT_LO);
+		tmp_hi = readl_relaxed_no_log(arch_counter_base + CNTVCT_HI);
 	} while (vct_hi != tmp_hi);
 
 	return ((u64) vct_hi << 32) | vct_lo;
@@ -933,7 +936,7 @@ static int __init arch_timer_mem_init(struct device_node *np)
 		return -ENXIO;
 	}
 
-	cnttidr = readl_relaxed(cntctlbase + CNTTIDR);
+	cnttidr = readl_relaxed_no_log(cntctlbase + CNTTIDR);
 
 	/*
 	 * Try to find a virtual capable frame. Otherwise fall back to a
@@ -952,8 +955,8 @@ static int __init arch_timer_mem_init(struct device_node *np)
 		/* Try enabling everything, and see what sticks */
 		cntacr = CNTACR_RFRQ | CNTACR_RWPT | CNTACR_RPCT |
 			 CNTACR_RWVT | CNTACR_RVOFF | CNTACR_RVCT;
-		writel_relaxed(cntacr, cntctlbase + CNTACR(n));
-		cntacr = readl_relaxed(cntctlbase + CNTACR(n));
+		writel_relaxed_no_log(cntacr, cntctlbase + CNTACR(n));
+		cntacr = readl_relaxed_no_log(cntctlbase + CNTACR(n));
 
 		if ((cnttidr & CNTTIDR_VIRT(n)) &&
 		    !(~cntacr & (CNTACR_RWVT | CNTACR_RVCT))) {
diff --git a/drivers/clocksource/rtk_timer.c b/drivers/clocksource/rtk_timer.c
new file mode 100644
index 00000000..2168d51
--- /dev/null
+++ b/drivers/clocksource/rtk_timer.c
@@ -0,0 +1,568 @@
+#include <linux/clockchips.h>
+#include <linux/clocksource.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/io.h>
+
+#define TIMER0 0
+#define TIMER1 1
+#define TIMER2 2
+#define TIMER_MAX (TIMER2 + 1)
+
+#define SYSTEM_TIMER TIMER0
+
+#define COUNTER 0
+#define TIMER 1
+
+#define TR_EN (1 << 31)
+#define TR_MODE (1 << 30)
+#define TR_PAUSE (1 << 29)
+#define TR_INT_EN (1 << 31)
+
+#define MISC_OFFSET 0x0001B000
+#define UMSK_ISR_OFFSET 0x00000008
+#define ISR_OFFSET 0x0000000C
+#define UMSK_ISR_SWC 0x00000010
+#define ISR_SWC 0x00000014
+#define SETTING_SWC 0x00000018
+#define FAST_INT_EN_0 0x0000001C
+#define FAST_INT_EN_1 0x00000020
+#define FAST_ISR 0x00000024
+#define MISC_DBG 0x0000002C
+#define MISC_DUMMY 0x00000030
+
+#define TCTVR_OFFSET 0x00000500
+#define TCCVR_OFFSET 0x0000050C
+#define TCCR_OFFSET 0x00000518
+#define TCICR_OFFSET 0x00000524
+
+#define RTK_TIMER_HZ CONFIG_HZ
+
+/* HW timer command enum description */
+enum hwtimer_commands {
+	HWT_START = 0x80, /* Start a timer/counter */
+	HWT_STOP, /* Stop a timer/counter */
+	HWT_PAUSE, /* Pause a timer/counter */
+	HWT_RESUME, /* Restart a timer/counter */
+	HWT_INT_ENABLE, /* Enable timer/counter interrupt */
+	HWT_INT_DISABLE, /* Disable timer/counter interrupt */
+	HWT_INT_CLEAR, /* Clear timer/counter interrupt pending bit */
+};
+
+int TC_SHIFT[2] = {
+	(1 << 6),
+	(1 << 7),
+};
+
+struct _suspend_data {
+	unsigned int value;
+	unsigned char mode;
+};
+
+struct rtk_clock_event_device {
+	int index;
+	struct clock_event_device *evt;
+	struct irqaction *irq_action;
+};
+
+static struct _suspend_data sTimerSuspendData[TIMER_MAX];
+
+static void __iomem *timer_base;
+unsigned long clk_freq;
+int oneshot_mode;
+
+#define MISC_BASE(pa) (timer_base + pa)
+#define rtk_setbits(offset, Mask) \
+	__raw_writel(((__raw_readl(offset) | Mask)), offset)
+#define rtk_clearbits(offset, Mask) \
+	__raw_writel(((__raw_readl(offset) & ~Mask)), offset)
+
+unsigned char rtk_timer_get_mode(unsigned char id)
+{
+	unsigned int reg = __raw_readl(MISC_BASE(TCCR_OFFSET + (id << 2)));
+
+	return (reg & TR_MODE) ? TIMER : COUNTER;
+}
+
+int rtk_timer_control(unsigned char id, unsigned int cmd)
+{
+	switch (cmd) {
+	case HWT_INT_CLEAR:
+		rtk_setbits(MISC_BASE(UMSK_ISR_OFFSET), TC_SHIFT[id] | 0x1);
+		break;
+	case HWT_START:
+		rtk_setbits(MISC_BASE(TCCR_OFFSET + (id << 2)), TR_EN);
+		break;
+	case HWT_STOP:
+		rtk_clearbits(MISC_BASE(TCCR_OFFSET + (id << 2)), TR_EN);
+		break;
+	case HWT_PAUSE:
+		rtk_setbits(MISC_BASE(TCCR_OFFSET + (id << 2)), TR_PAUSE);
+		break;
+	case HWT_RESUME:
+		rtk_clearbits(MISC_BASE(TCCR_OFFSET + (id << 2)), TR_PAUSE);
+		break;
+	case HWT_INT_ENABLE:
+		rtk_setbits(MISC_BASE(TCICR_OFFSET + (id << 2)), TR_INT_EN);
+		break;
+	case HWT_INT_DISABLE:
+		rtk_clearbits(MISC_BASE(TCICR_OFFSET + (id << 2)), TR_INT_EN);
+		break;
+	default:
+		return 1;
+	}
+	return 0;
+}
+
+int rtk_timer_get_value(unsigned char id)
+{
+	/* get the current timer's value */
+	return __raw_readl(MISC_BASE(TCCVR_OFFSET + (id << 2)));
+}
+
+int rtk_timer_set_value(unsigned char id, unsigned int value)
+{
+	/* set the timer's initial value */
+	__raw_writel(value, MISC_BASE(TCCVR_OFFSET + (id << 2)));
+	return 0;
+}
+
+int rtk_timer_set_target(unsigned char id, unsigned int value)
+{
+	/* set the timer's initial value */
+	__raw_writel(value, MISC_BASE(TCTVR_OFFSET + (id << 2)));
+	return 0;
+}
+
+static int rtk_timer_set_mode(unsigned char id, unsigned char mode)
+{
+	switch (mode) {
+	case COUNTER:
+		rtk_clearbits((MISC_BASE(TCCR_OFFSET + (id << 2))), TR_MODE);
+		break;
+	case TIMER:
+		rtk_setbits((MISC_BASE(TCCR_OFFSET + (id << 2))), TR_MODE);
+		break;
+	default:
+		return 1;
+	}
+
+	return 0;
+}
+
+static irqreturn_t rtk_clock_event_isr(int irq, void *dev_id)
+{
+	struct rtk_clock_event_device *clkevt;
+	struct clock_event_device *evt;
+	int nr = 0;
+
+	clkevt = (struct rtk_clock_event_device *) dev_id;
+	evt = clkevt->evt;
+	nr = clkevt->index;
+
+	rtk_setbits(MISC_BASE(ISR_OFFSET), TC_SHIFT[nr]);
+
+	if (oneshot_mode)
+		rtk_timer_control(nr, HWT_INT_DISABLE);
+
+	evt->event_handler(evt);
+
+	return IRQ_HANDLED;
+}
+
+static int rtk_clkevt_set_next(int nr, unsigned long cycles,
+	struct clock_event_device *evt)
+{
+	int ret = 0;
+
+	rtk_timer_control(nr, HWT_STOP);
+
+	rtk_timer_set_target(nr, cycles);
+
+	rtk_timer_control(nr, HWT_START);
+	rtk_timer_control(nr, HWT_INT_ENABLE);
+
+	return ret;
+}
+
+static void rtk_clocksource0_suspend(struct clocksource *cs)
+{
+	int nr = TIMER1;
+
+	pr_info("[RTK-TIMER0] Enter %s\n", __func__);
+
+	for (nr = 0 ; nr < TIMER_MAX ; nr++)
+		sTimerSuspendData[nr].value = rtk_timer_get_value(nr);
+
+	pr_info("[RTK-TIMER0] Exit %s\n", __func__);
+}
+
+static void rtk_clocksource0_resume(struct clocksource *cs)
+{
+	int nr = TIMER1;
+
+	pr_info("[RTK-TIMER0] Enter %s\n", __func__);
+
+	for (nr = 0 ; nr < TIMER_MAX ; nr++)
+		rtk_timer_set_value(nr, sTimerSuspendData[nr].value);
+
+	pr_info("[RTK-TIMER0] Exit %s\n", __func__);
+
+}
+
+static void rtk_clocksource1_suspend(struct clocksource *cs)
+{
+	int nr = TIMER1;
+
+	pr_info("[RTK-TIMER1] Enter %s\n", __func__);
+
+	for (nr = 0 ; nr < TIMER_MAX ; nr++)
+		sTimerSuspendData[nr].value = rtk_timer_get_value(nr);
+
+	pr_info("[RTK-TIMER1] Exit %s\n", __func__);
+}
+
+static void rtk_clocksource1_resume(struct clocksource *cs)
+{
+	int nr = TIMER1;
+
+	pr_info("[RTK-TIMER1] Enter %s\n", __func__);
+
+	for (nr = 0 ; nr < TIMER_MAX ; nr++)
+		rtk_timer_set_value(nr, sTimerSuspendData[nr].value);
+
+	pr_info("[RTK-TIMER1] Exit %s\n", __func__);
+}
+
+static int rtk_timer0_set_next(unsigned long cycles,
+	struct clock_event_device *evt)
+{
+	return rtk_clkevt_set_next(TIMER0, cycles, evt);
+}
+
+static cycle_t rtk_read_sched_clock0(struct clocksource *cs)
+{
+	return (cycle_t)rtk_timer_get_value(TIMER0);
+}
+
+static int rtk_tm0_set_state_periodic(struct clock_event_device *cev)
+{
+	int nr = 0;
+
+	oneshot_mode = 0;
+	pr_info("[RTK-TIMER%d] set mode: periodic\n", nr);
+	rtk_timer_control(nr, HWT_INT_DISABLE);
+	rtk_timer_control(nr, HWT_STOP);
+	rtk_timer_set_value(nr, sTimerSuspendData[nr].value);
+	rtk_timer_set_target(nr, DIV_ROUND_UP(clk_freq, HZ));
+	rtk_timer_set_mode(nr, TIMER);
+	rtk_timer_control(nr, HWT_START);
+	rtk_timer_control(nr, HWT_INT_ENABLE);
+
+	return 0;
+}
+
+static int rtk_tm0_set_state_oneshot(struct clock_event_device *cev)
+{
+	int nr = 0;
+
+	oneshot_mode = 1;
+	/* period set, and timer enabled in 'next event' hook */
+	pr_info("[RTK-TIMER%d] set mode: oneshot\n", nr);
+	rtk_timer_control(nr, HWT_STOP);
+	rtk_timer_set_mode(nr, COUNTER);
+	rtk_timer_control(nr, HWT_START);
+
+	return 0;
+}
+
+static int rtk_tm0_set_state_oneshot_stopped(struct clock_event_device *cev)
+{
+	int nr = 0;
+
+	pr_info("[RTK-TIMER%d] set mode: stopped\n", nr);
+	rtk_timer_control(nr, HWT_STOP);
+
+	return 0;
+}
+
+static int rtk_tm0_set_state_shutdown(struct clock_event_device *cev)
+{
+	int nr = 0;
+
+	pr_info("[RTK-TIMER%d] set mode: shutdown\n", nr);
+	sTimerSuspendData[nr].value = rtk_timer_get_value(nr);
+	sTimerSuspendData[nr].mode = rtk_timer_get_mode(nr);
+	rtk_timer_control(nr, HWT_INT_DISABLE);
+	rtk_timer_control(nr, HWT_STOP);
+
+	return 0;
+}
+
+static int rtk_tm0_tick_resume(struct clock_event_device *cev)
+{
+	int nr = 0;
+
+	pr_info("[RTK-TIMER%d] set mode: CLOCK_EVT_MODE_RESUME\n", nr);
+	rtk_timer_set_value(nr, sTimerSuspendData[nr].value);
+	rtk_timer_set_target(nr, DIV_ROUND_UP(clk_freq, HZ));
+	rtk_timer_set_mode(nr, sTimerSuspendData[nr].mode);
+	rtk_timer_control(nr, HWT_RESUME);
+	rtk_timer_control(nr, HWT_INT_ENABLE);
+
+	return 0;
+}
+
+static struct clocksource rtk_cs0 = {
+	.name = "rtk_timer0_counter",
+	.rating = 400,
+	.read = rtk_read_sched_clock0,
+	.mask = CLOCKSOURCE_MASK(32),
+	.flags = CLOCK_SOURCE_IS_CONTINUOUS,
+	.suspend = rtk_clocksource0_suspend,
+	.resume = rtk_clocksource0_resume,
+};
+
+static struct clock_event_device timer0_clockevent = {
+	.rating = 400,
+	.shift = 32,
+	.features = CLOCK_EVT_FEAT_PERIODIC | CLOCK_EVT_FEAT_ONESHOT,
+	.set_next_event = rtk_timer0_set_next,
+	.set_state_periodic = rtk_tm0_set_state_periodic,
+	.set_state_oneshot = rtk_tm0_set_state_oneshot,
+	.set_state_oneshot_stopped = rtk_tm0_set_state_oneshot_stopped,
+	.set_state_shutdown = rtk_tm0_set_state_shutdown,
+	.tick_resume = rtk_tm0_tick_resume,
+
+};
+
+static struct irqaction timer0_irq = {
+	.flags = IRQF_TIMER | IRQF_IRQPOLL,
+	.handler = rtk_clock_event_isr,
+	.dev_id = &timer0_clockevent,
+};
+
+static int rtk_timer1_set_next(unsigned long cycles,
+	struct clock_event_device *evt)
+{
+	return rtk_clkevt_set_next(TIMER1, cycles, evt);
+}
+
+static cycle_t rtk_read_sched_clock1(struct clocksource *cs)
+{
+	return (cycle_t)rtk_timer_get_value(TIMER1);
+}
+
+static int rtk_tm1_set_state_periodic(struct clock_event_device *cev)
+{
+	int nr = 1;
+
+	pr_info("[RTK-TIMER%d] set mode: periodic\n", nr);
+	rtk_timer_control(nr, HWT_INT_DISABLE);
+	rtk_timer_control(nr, HWT_STOP);
+	rtk_timer_set_value(nr, sTimerSuspendData[nr].value);
+	rtk_timer_set_target(nr, DIV_ROUND_UP(clk_freq, HZ));
+	rtk_timer_set_mode(nr, TIMER);
+	rtk_timer_control(nr, HWT_START);
+	rtk_timer_control(nr, HWT_INT_ENABLE);
+
+	return 0;
+}
+
+static int rtk_tm1_set_state_oneshot(struct clock_event_device *cev)
+{
+	int nr = 1;
+
+	/* period set, and timer enabled in 'next event' hook */
+	pr_info("[RTK-TIMER%d] set mode: oneshot\n", nr);
+	rtk_timer_control(nr, HWT_INT_DISABLE);
+	rtk_timer_control(nr, HWT_STOP);
+	rtk_timer_set_value(nr, sTimerSuspendData[nr].value);
+	rtk_timer_set_target(nr, DIV_ROUND_UP(clk_freq, HZ));
+	rtk_timer_set_mode(nr, COUNTER);
+	rtk_timer_control(nr, HWT_START);
+	rtk_timer_control(nr, HWT_INT_ENABLE);
+
+	return 0;
+}
+
+static int rtk_tm1_set_state_oneshot_stopped(struct clock_event_device *cev)
+{
+	int nr = 1;
+
+	pr_info("[RTK-TIMER%d] set mode: stopped\n", nr);
+	rtk_timer_control(nr, HWT_INT_DISABLE);
+	rtk_timer_control(nr, HWT_STOP);
+
+	return 0;
+}
+
+static int rtk_tm1_set_state_shutdown(struct clock_event_device *cev)
+{
+	int nr = 1;
+
+	pr_info("[RTK-TIMER%d] set mode: shutdown\n", nr);
+	sTimerSuspendData[nr].value = rtk_timer_get_value(nr);
+	sTimerSuspendData[nr].mode = rtk_timer_get_mode(nr);
+	rtk_timer_control(nr, HWT_INT_DISABLE);
+	rtk_timer_control(nr, HWT_STOP);
+
+	return 0;
+}
+
+static int rtk_tm1_tick_resume(struct clock_event_device *cev)
+{
+	int nr = 1;
+
+	pr_info("[RTK-TIMER%d] set mode: CLOCK_EVT_MODE_RESUME\n", nr);
+	rtk_timer_set_value(nr, sTimerSuspendData[nr].value);
+	rtk_timer_set_target(nr, DIV_ROUND_UP(clk_freq, HZ));
+	rtk_timer_set_mode(nr, sTimerSuspendData[nr].mode);
+	rtk_timer_control(nr, HWT_RESUME);
+	rtk_timer_control(nr, HWT_INT_ENABLE);
+
+	return 0;
+}
+
+static struct clocksource rtk_cs1 = {
+	.name = "rtk_timer1_counter",
+	.rating = 400,
+	.read = rtk_read_sched_clock1,
+	.mask = CLOCKSOURCE_MASK(32),
+	.flags = CLOCK_SOURCE_IS_CONTINUOUS,
+	.suspend = rtk_clocksource1_suspend,
+	.resume = rtk_clocksource1_resume,
+};
+
+static struct clock_event_device timer1_clockevent = {
+	.rating = 400,
+	.shift = 32,
+	.features = CLOCK_EVT_FEAT_PERIODIC | CLOCK_EVT_FEAT_ONESHOT,
+	.set_next_event = rtk_timer1_set_next,
+	.set_state_periodic = rtk_tm1_set_state_periodic,
+	.set_state_oneshot = rtk_tm1_set_state_oneshot,
+	.set_state_oneshot_stopped = rtk_tm1_set_state_oneshot_stopped,
+	.set_state_shutdown = rtk_tm1_set_state_shutdown,
+	.tick_resume = rtk_tm1_tick_resume,
+};
+
+static struct irqaction timer1_irq = {
+	.flags = IRQF_TIMER,
+	.handler = rtk_clock_event_isr,
+	.dev_id = &timer1_clockevent,
+};
+
+static struct rtk_clock_event_device rtk_evt[] = {
+	{ 0, &timer0_clockevent, &timer0_irq },
+	{ 1, &timer1_clockevent, &timer1_irq },
+};
+
+void rtk_clockevent_init(int index, const char *name, void __iomem *base,
+	int irq, unsigned long freq)
+{
+	struct rtk_clock_event_device *clkevt = &rtk_evt[index];
+	struct clock_event_device *evt = clkevt->evt;
+
+	timer_base = base;
+	clk_freq = freq;
+	evt->irq = irq;
+	evt->name = name;
+	evt->cpumask = cpumask_of(smp_processor_id());
+
+	memset(sTimerSuspendData, 0, sizeof(sTimerSuspendData[0]) * TIMER_MAX);
+
+	clkevt->irq_action->name = name;
+	clkevt->irq_action->irq = irq;
+	clkevt->irq_action->dev_id = clkevt;
+
+	setup_irq(irq, clkevt->irq_action);
+
+	clockevents_config_and_register(evt, clk_freq, 0xF, UINT_MAX);
+}
+
+void rtk_clocksource_init(int index)
+{
+	struct clocksource *cs = &rtk_cs0;
+	struct clocksource *cs1 = &rtk_cs1;
+
+	pr_info("[RTK-TIMER%d] clocksource %d register HZ\n", index, index);
+
+	if (index == 0) {
+		if (clocksource_register_hz(cs, clk_freq))
+			pr_err("[RTK-TIMER%d] timer%d can't register clocksource\n",
+				index, index);
+	} else {
+		if (clocksource_register_hz(cs1, clk_freq))
+			pr_err("[RTK-TIMER%d] timer%d can't register clocksource\n",
+				index, index);
+	}
+}
+
+static int __init rtk_timer0_init(struct device_node *np)
+{
+	int ret = 0;
+	void __iomem *iobase;
+	int irq = 0;
+	int rate = 0;
+
+	iobase = of_iomap(np, 0);
+	if (!iobase) {
+		pr_err("[RTK-TIMER0] failed to get base address\n");
+		return 1;
+	}
+
+	irq = irq_of_parse_and_map(np, 0);
+	if (irq <= 0) {
+		pr_err("[RTK-TIMER0] can't parse IRQ\n");
+		return 1;
+	}
+
+	ret = of_property_read_u32(np, "clock-frequency", &rate);
+	if (ret) {
+		pr_err("[RTK-TIMER0] can't get clock-frequency\n");
+		return 1;
+	}
+
+	rtk_clockevent_init(TIMER0, np->name, iobase, irq, rate);
+	rtk_clocksource_init(TIMER0);
+
+	return ret;
+}
+
+static int __init rtk_timer1_init(struct device_node *np)
+{
+	int ret = 0;
+	void __iomem *iobase;
+	int irq = 0;
+	int rate = 0;
+
+	iobase = of_iomap(np, 0);
+	if (!iobase) {
+		pr_err("[RTK-TIMER1] failed to get base address\n");
+		return 1;
+	}
+
+	irq = irq_of_parse_and_map(np, 0);
+	if (irq <= 0) {
+		pr_err("[RTK-TIMER1] can't parse IRQ\n");
+		return 1;
+	}
+
+	ret = of_property_read_u32(np, "clock-frequency", &rate);
+	if (ret) {
+		pr_err("[RTK-TIMER1] can't get clock-frequency\n");
+		return 1;
+	}
+
+	rtk_clockevent_init(TIMER1, np->name, iobase, irq, rate);
+	rtk_clocksource_init(TIMER1);
+
+	return ret;
+}
+
+CLOCKSOURCE_OF_DECLARE(realtek_timer0, "realtek,rtk-timer0", rtk_timer0_init);
+CLOCKSOURCE_OF_DECLARE(realtek_timer1, "realtek,rtk-timer1", rtk_timer1_init);
diff --git a/drivers/cpufreq/Kconfig b/drivers/cpufreq/Kconfig
index cac26fb..c70ed51 100644
--- a/drivers/cpufreq/Kconfig
+++ b/drivers/cpufreq/Kconfig
@@ -45,6 +45,15 @@ config CPU_FREQ_STAT_DETAILS
 
 	  If in doubt, say N.
 
+config CPU_FREQ_TIMES
+       bool "CPU frequency time-in-state statistics"
+       default y
+       help
+         This driver exports CPU time-in-state information through procfs file
+         system.
+
+         If in doubt, say N.
+
 choice
 	prompt "Default CPUFreq governor"
 	default CPU_FREQ_DEFAULT_GOV_USERSPACE if ARM_SA1100_CPUFREQ || ARM_SA1110_CPUFREQ
@@ -102,6 +111,16 @@ config CPU_FREQ_DEFAULT_GOV_CONSERVATIVE
 	  governor. If unsure have a look at the help section of the
 	  driver. Fallback governor will be the performance governor.
 
+config CPU_FREQ_DEFAULT_GOV_INTERACTIVE
+	bool "interactive"
+	select CPU_FREQ_GOV_INTERACTIVE
+	select CPU_FREQ_GOV_PERFORMANCE
+	help
+	  Use the CPUFreq governor 'interactive' as default. This allows
+	  you to get a full dynamic cpu frequency capable system by simply
+	  loading your cpufreq low-level hardware driver, using the
+	  'interactive' governor for latency-sensitive workloads.
+
 config CPU_FREQ_DEFAULT_GOV_SCHEDUTIL
 	bool "schedutil"
 	depends on SMP
@@ -193,6 +212,26 @@ config CPU_FREQ_GOV_CONSERVATIVE
 
 	  If in doubt, say N.
 
+config CPU_FREQ_GOV_INTERACTIVE
+	tristate "'interactive' cpufreq policy governor"
+	depends on CPU_FREQ
+	select CPU_FREQ_GOV_ATTR_SET
+	select IRQ_WORK
+	help
+	  'interactive' - This driver adds a dynamic cpufreq policy governor
+	  designed for latency-sensitive workloads.
+
+	  This governor attempts to reduce the latency of clock
+	  increases so that the system is more responsive to
+	  interactive workloads.
+
+	  To compile this driver as a module, choose M here: the
+	  module will be called cpufreq_interactive.
+
+	  For details, take a look at linux/Documentation/cpu-freq.
+
+	  If in doubt, say N.
+
 config CPU_FREQ_GOV_SCHEDUTIL
 	bool "'schedutil' cpufreq policy governor"
 	depends on CPU_FREQ && SMP
diff --git a/drivers/cpufreq/Kconfig.arm b/drivers/cpufreq/Kconfig.arm
index bc3917d..157ac13 100644
--- a/drivers/cpufreq/Kconfig.arm
+++ b/drivers/cpufreq/Kconfig.arm
@@ -258,3 +258,21 @@ config ACPI_CPPC_CPUFREQ
 	  support for its operation.
 
 	  If in doubt, say N.
+
+menu "Realtek CPUFreq on Xen"
+
+config ARM_REALTEK_CPUFREQ_XEN
+	bool "Enable CPUFreq in Xen"
+	depends on RTK_XEN_SUPPORT
+
+config ARM_REALTEK_XEN_CPULOAD
+	bool "Get CPU load from Xen"
+	depends on ARM_REALTEK_CPUFREQ && RTK_XEN_HYPERCALL
+	select ARM_REALTEK_CPUFREQ_XEN
+	default n
+	help
+	  This replaces the load calculation with xen version.
+
+	  if in doubt, say N
+
+endmenu
diff --git a/drivers/cpufreq/Makefile b/drivers/cpufreq/Makefile
index 0a9b6a09..f10a18d 100644
--- a/drivers/cpufreq/Makefile
+++ b/drivers/cpufreq/Makefile
@@ -4,12 +4,16 @@ obj-$(CONFIG_CPU_FREQ)			+= cpufreq.o freq_table.o
 # CPUfreq stats
 obj-$(CONFIG_CPU_FREQ_STAT)             += cpufreq_stats.o
 
-# CPUfreq governors 
+# CPUfreq times
+obj-$(CONFIG_CPU_FREQ_TIMES)		+= cpufreq_times.o
+
+# CPUfreq governors
 obj-$(CONFIG_CPU_FREQ_GOV_PERFORMANCE)	+= cpufreq_performance.o
 obj-$(CONFIG_CPU_FREQ_GOV_POWERSAVE)	+= cpufreq_powersave.o
 obj-$(CONFIG_CPU_FREQ_GOV_USERSPACE)	+= cpufreq_userspace.o
 obj-$(CONFIG_CPU_FREQ_GOV_ONDEMAND)	+= cpufreq_ondemand.o
 obj-$(CONFIG_CPU_FREQ_GOV_CONSERVATIVE)	+= cpufreq_conservative.o
+obj-$(CONFIG_CPU_FREQ_GOV_INTERACTIVE)	+= cpufreq_interactive.o
 obj-$(CONFIG_CPU_FREQ_GOV_COMMON)		+= cpufreq_governor.o
 obj-$(CONFIG_CPU_FREQ_GOV_ATTR_SET)	+= cpufreq_governor_attr_set.o
 
diff --git a/drivers/cpufreq/cpufreq-dt-platdev.c b/drivers/cpufreq/cpufreq-dt-platdev.c
index 7126762..5ab1759 100644
--- a/drivers/cpufreq/cpufreq-dt-platdev.c
+++ b/drivers/cpufreq/cpufreq-dt-platdev.c
@@ -81,6 +81,13 @@
 
 	{ .compatible = "xlnx,zynq-7000", },
 
+	{ .compatible = "realtek,rtd1294", },
+	{ .compatible = "realtek,rtd1295", },
+	{ .compatible = "realtek,rtd1296", },
+	{ .compatible = "realtek,rtd1395", },
+	{ .compatible = "realtek,rtd1619", },
+	{ .compatible = "realtek,rtd1319", },
+
 	{ }
 };
 
diff --git a/drivers/cpufreq/cpufreq-dt.c b/drivers/cpufreq/cpufreq-dt.c
index 4d3ec92..e4cbfe5 100644
--- a/drivers/cpufreq/cpufreq-dt.c
+++ b/drivers/cpufreq/cpufreq-dt.c
@@ -280,6 +280,13 @@ static int cpufreq_init(struct cpufreq_policy *policy)
 
 	policy->cpuinfo.transition_latency = transition_latency;
 
+        /*
+         * Android: set default parameters for parity between schedutil and
+         * schedfreq
+         */
+	policy->up_transition_delay_us = transition_latency / NSEC_PER_USEC;
+	policy->down_transition_delay_us = 50000; /* 50ms */
+
 	return 0;
 
 out_free_cpufreq_table:
diff --git a/drivers/cpufreq/cpufreq.c b/drivers/cpufreq/cpufreq.c
index af5eff6..a63581b 100644
--- a/drivers/cpufreq/cpufreq.c
+++ b/drivers/cpufreq/cpufreq.c
@@ -19,6 +19,7 @@
 
 #include <linux/cpu.h>
 #include <linux/cpufreq.h>
+#include <linux/cpufreq_times.h>
 #include <linux/delay.h>
 #include <linux/device.h>
 #include <linux/init.h>
@@ -29,6 +30,9 @@
 #include <linux/suspend.h>
 #include <linux/syscore_ops.h>
 #include <linux/tick.h>
+#ifdef CONFIG_SMP
+#include <linux/sched.h>
+#endif
 #include <trace/events/power.h>
 
 static LIST_HEAD(cpufreq_policy_list);
@@ -117,6 +121,12 @@ bool have_governor_per_policy(void)
 }
 EXPORT_SYMBOL_GPL(have_governor_per_policy);
 
+bool cpufreq_driver_is_slow(void)
+{
+	return !(cpufreq_driver->flags & CPUFREQ_DRIVER_FAST);
+}
+EXPORT_SYMBOL_GPL(cpufreq_driver_is_slow);
+
 struct kobject *get_governor_parent_kobj(struct cpufreq_policy *policy)
 {
 	if (have_governor_per_policy())
@@ -301,6 +311,92 @@ static void adjust_jiffies(unsigned long val, struct cpufreq_freqs *ci)
 #endif
 }
 
+/*********************************************************************
+ *               FREQUENCY INVARIANT CPU CAPACITY                    *
+ *********************************************************************/
+
+static DEFINE_PER_CPU(unsigned long, freq_scale) = SCHED_CAPACITY_SCALE;
+static DEFINE_PER_CPU(unsigned long, max_freq_cpu);
+static DEFINE_PER_CPU(unsigned long, max_freq_scale) = SCHED_CAPACITY_SCALE;
+static DEFINE_PER_CPU(unsigned long, min_freq_scale);
+
+static void
+scale_freq_capacity(const cpumask_t *cpus, unsigned long cur_freq,
+		    unsigned long max_freq)
+{
+	unsigned long scale = (cur_freq << SCHED_CAPACITY_SHIFT) / max_freq;
+	int cpu;
+
+	for_each_cpu(cpu, cpus) {
+		per_cpu(freq_scale, cpu) = scale;
+		per_cpu(max_freq_cpu, cpu) = max_freq;
+	}
+
+	pr_debug("cpus %*pbl cur freq/max freq %lu/%lu kHz freq scale %lu\n",
+		 cpumask_pr_args(cpus), cur_freq, max_freq, scale);
+}
+
+unsigned long cpufreq_scale_freq_capacity(struct sched_domain *sd, int cpu)
+{
+	return per_cpu(freq_scale, cpu);
+}
+
+static void
+scale_max_freq_capacity(const cpumask_t *cpus, unsigned long policy_max_freq)
+{
+	unsigned long scale, max_freq;
+	int cpu = cpumask_first(cpus);
+
+	if (cpu >= nr_cpu_ids)
+		return;
+
+	max_freq = per_cpu(max_freq_cpu, cpu);
+
+	if (!max_freq)
+		return;
+
+	scale = (policy_max_freq << SCHED_CAPACITY_SHIFT) / max_freq;
+
+	for_each_cpu(cpu, cpus)
+		per_cpu(max_freq_scale, cpu) = scale;
+
+	pr_debug("cpus %*pbl policy max freq/max freq %lu/%lu kHz max freq scale %lu\n",
+		 cpumask_pr_args(cpus), policy_max_freq, max_freq, scale);
+}
+
+unsigned long cpufreq_scale_max_freq_capacity(struct sched_domain *sd, int cpu)
+{
+	return per_cpu(max_freq_scale, cpu);
+}
+
+static void
+scale_min_freq_capacity(const cpumask_t *cpus, unsigned long policy_min_freq)
+{
+	unsigned long scale, max_freq;
+	int cpu = cpumask_first(cpus);
+
+	if (cpu >= nr_cpu_ids)
+		return;
+
+	max_freq = per_cpu(max_freq_cpu, cpu);
+
+	if (!max_freq)
+		return;
+
+	scale = (policy_min_freq << SCHED_CAPACITY_SHIFT) / max_freq;
+
+	for_each_cpu(cpu, cpus)
+		per_cpu(min_freq_scale, cpu) = scale;
+
+	pr_debug("cpus %*pbl policy min freq/max freq %lu/%lu kHz min freq scale %lu\n",
+		 cpumask_pr_args(cpus), policy_min_freq, max_freq, scale);
+}
+
+unsigned long cpufreq_scale_min_freq_capacity(struct sched_domain *sd, int cpu)
+{
+	return per_cpu(min_freq_scale, cpu);
+}
+
 static void __cpufreq_notify_transition(struct cpufreq_policy *policy,
 		struct cpufreq_freqs *freqs, unsigned int state)
 {
@@ -339,6 +435,7 @@ static void __cpufreq_notify_transition(struct cpufreq_policy *policy,
 			 (unsigned long)freqs->new, (unsigned long)freqs->cpu);
 		trace_cpu_frequency(freqs->new, freqs->cpu);
 		cpufreq_stats_record_transition(policy, freqs->new);
+		cpufreq_times_record_transition(freqs);
 		srcu_notifier_call_chain(&cpufreq_transition_notifier_list,
 				CPUFREQ_POSTCHANGE, freqs);
 		if (likely(policy) && likely(policy->cpu == freqs->cpu))
@@ -378,6 +475,9 @@ static void cpufreq_notify_post_transition(struct cpufreq_policy *policy,
 void cpufreq_freq_transition_begin(struct cpufreq_policy *policy,
 		struct cpufreq_freqs *freqs)
 {
+#ifdef CONFIG_SMP
+	int cpu;
+#endif
 
 	/*
 	 * Catch double invocations of _begin() which lead to self-deadlock.
@@ -405,6 +505,12 @@ void cpufreq_freq_transition_begin(struct cpufreq_policy *policy,
 
 	spin_unlock(&policy->transition_lock);
 
+	scale_freq_capacity(policy->cpus, freqs->new, policy->cpuinfo.max_freq);
+#ifdef CONFIG_SMP
+	for_each_cpu(cpu, policy->cpus)
+		trace_cpu_capacity(capacity_curr_of(cpu), cpu);
+#endif
+
 	cpufreq_notify_transition(policy, freqs, CPUFREQ_PRECHANGE);
 }
 EXPORT_SYMBOL_GPL(cpufreq_freq_transition_begin);
@@ -1257,6 +1363,7 @@ static int cpufreq_online(unsigned int cpu)
 			goto out_exit_policy;
 
 		cpufreq_stats_create_table(policy);
+		cpufreq_times_create_policy(policy);
 		blocking_notifier_call_chain(&cpufreq_policy_notifier_list,
 				CPUFREQ_CREATE_POLICY, policy);
 
@@ -2201,8 +2308,12 @@ static int cpufreq_set_policy(struct cpufreq_policy *policy,
 	blocking_notifier_call_chain(&cpufreq_policy_notifier_list,
 			CPUFREQ_NOTIFY, new_policy);
 
+	scale_max_freq_capacity(policy->cpus, policy->max);
+	scale_min_freq_capacity(policy->cpus, policy->min);
+
 	policy->min = new_policy->min;
 	policy->max = new_policy->max;
+	trace_cpu_frequency_limits(policy->max, policy->min, policy->cpu);
 
 	policy->cached_target_freq = UINT_MAX;
 
diff --git a/drivers/cpufreq/cpufreq_conservative.c b/drivers/cpufreq/cpufreq_conservative.c
index 00a7435..0fe2518 100644
--- a/drivers/cpufreq/cpufreq_conservative.c
+++ b/drivers/cpufreq/cpufreq_conservative.c
@@ -302,7 +302,10 @@ static void cs_start(struct cpufreq_policy *policy)
 	dbs_info->requested_freq = policy->cur;
 }
 
-static struct dbs_governor cs_governor = {
+#ifndef CONFIG_CPU_FREQ_DEFAULT_GOV_CONSERVATIVE
+static
+#endif
+struct dbs_governor cs_governor = {
 	.gov = CPUFREQ_DBS_GOVERNOR_INITIALIZER("conservative"),
 	.kobj_type = { .default_attrs = cs_attributes },
 	.gov_dbs_timer = cs_dbs_timer,
diff --git a/drivers/cpufreq/cpufreq_governor.c b/drivers/cpufreq/cpufreq_governor.c
index 642dd0f..a72eba5 100644
--- a/drivers/cpufreq/cpufreq_governor.c
+++ b/drivers/cpufreq/cpufreq_governor.c
@@ -23,6 +23,13 @@
 
 #include "cpufreq_governor.h"
 
+#ifdef CONFIG_ARM_REALTEK_XEN_CPULOAD
+#include <xen/xen.h>
+#include <xen/interface/rtk-hypercall.h>
+#include <asm/xen/hypercall.h>
+#include <asm/xen/interface.h>
+#endif /* CONFIG_ARM_REALTEK_XEN_CPULOAD */
+
 static DEFINE_PER_CPU(struct cpu_dbs_info, cpu_dbs);
 
 static DEFINE_MUTEX(gov_dbs_data_mutex);
@@ -95,6 +102,9 @@ ssize_t store_sampling_rate(struct gov_attr_set *attr_set, const char *buf,
  */
 void gov_update_cpu_data(struct dbs_data *dbs_data)
 {
+#ifdef CONFIG_ARM_REALTEK_XEN_CPULOAD
+	WARN_ON_ONCE(1);
+#else
 	struct policy_dbs_info *policy_dbs;
 
 	list_for_each_entry(policy_dbs, &dbs_data->attr_set.policy_list, list) {
@@ -109,11 +119,20 @@ void gov_update_cpu_data(struct dbs_data *dbs_data)
 				j_cdbs->prev_cpu_nice = kcpustat_cpu(j).cpustat[CPUTIME_NICE];
 		}
 	}
+#endif /* CONFIG_ARM_REALTEK_XEN_CPULOAD */
 }
 EXPORT_SYMBOL_GPL(gov_update_cpu_data);
 
 unsigned int dbs_update(struct cpufreq_policy *policy)
 {
+#ifdef CONFIG_ARM_REALTEK_XEN_CPULOAD
+	unsigned int max_load = 0;
+	struct xen_rtk_cpu_load xen_load;
+
+	HYPERVISOR_rtk_hypercall_op(XENRTK_cpu_load, &xen_load);
+	max_load = xen_load.max_load;
+
+#else /* CONFIG_ARM_REALTEK_XEN_CPULOAD */
 	struct policy_dbs_info *policy_dbs = policy->governor_data;
 	struct dbs_data *dbs_data = policy_dbs->dbs_data;
 	unsigned int ignore_nice = dbs_data->ignore_nice_load;
@@ -218,6 +237,7 @@ unsigned int dbs_update(struct cpufreq_policy *policy)
 		if (load > max_load)
 			max_load = load;
 	}
+#endif /* CONFIG_ARM_REALTEK_XEN_CPULOAD */
 	return max_load;
 }
 EXPORT_SYMBOL_GPL(dbs_update);
diff --git a/drivers/cpufreq/cpufreq_interactive.c b/drivers/cpufreq/cpufreq_interactive.c
new file mode 100644
index 00000000..54f9042
--- /dev/null
+++ b/drivers/cpufreq/cpufreq_interactive.c
@@ -0,0 +1,1412 @@
+/*
+ * drivers/cpufreq/cpufreq_interactive.c
+ *
+ * Copyright (C) 2010-2016 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * Author: Mike Chan (mike@android.com)
+ */
+
+#define pr_fmt(fmt) KBUILD_MODNAME ": " fmt
+
+#include <linux/cpu.h>
+#include <linux/cpumask.h>
+#include <linux/cpufreq.h>
+#include <linux/irq_work.h>
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/rwsem.h>
+#include <linux/sched.h>
+#include <linux/sched/rt.h>
+#include <linux/tick.h>
+#include <linux/time.h>
+#include <linux/timer.h>
+#include <linux/kthread.h>
+#include <linux/slab.h>
+
+#define CREATE_TRACE_POINTS
+#include <trace/events/cpufreq_interactive.h>
+
+#define gov_attr_ro(_name)						\
+static struct governor_attr _name =					\
+__ATTR(_name, 0444, show_##_name, NULL)
+
+#define gov_attr_wo(_name)						\
+static struct governor_attr _name =					\
+__ATTR(_name, 0200, NULL, store_##_name)
+
+#define gov_attr_rw(_name)						\
+static struct governor_attr _name =					\
+__ATTR(_name, 0644, show_##_name, store_##_name)
+
+/* Separate instance required for each 'interactive' directory in sysfs */
+struct interactive_tunables {
+	struct gov_attr_set attr_set;
+
+	/* Hi speed to bump to from lo speed when load burst (default max) */
+	unsigned int hispeed_freq;
+
+	/* Go to hi speed when CPU load at or above this value. */
+#define DEFAULT_GO_HISPEED_LOAD 99
+	unsigned long go_hispeed_load;
+
+	/* Target load. Lower values result in higher CPU speeds. */
+	spinlock_t target_loads_lock;
+	unsigned int *target_loads;
+	int ntarget_loads;
+
+	/*
+	 * The minimum amount of time to spend at a frequency before we can ramp
+	 * down.
+	 */
+#define DEFAULT_MIN_SAMPLE_TIME (80 * USEC_PER_MSEC)
+	unsigned long min_sample_time;
+
+	/* The sample rate of the timer used to increase frequency */
+	unsigned long sampling_rate;
+
+	/*
+	 * Wait this long before raising speed above hispeed, by default a
+	 * single timer interval.
+	 */
+	spinlock_t above_hispeed_delay_lock;
+	unsigned int *above_hispeed_delay;
+	int nabove_hispeed_delay;
+
+	/* Non-zero means indefinite speed boost active */
+	int boost;
+	/* Duration of a boot pulse in usecs */
+	int boostpulse_duration;
+	/* End time of boost pulse in ktime converted to usecs */
+	u64 boostpulse_endtime;
+	bool boosted;
+
+	/*
+	 * Max additional time to wait in idle, beyond sampling_rate, at speeds
+	 * above minimum before wakeup to reduce speed, or -1 if unnecessary.
+	 */
+#define DEFAULT_TIMER_SLACK (4 * DEFAULT_SAMPLING_RATE)
+	unsigned long timer_slack_delay;
+	unsigned long timer_slack;
+	bool io_is_busy;
+};
+
+/* Separate instance required for each 'struct cpufreq_policy' */
+struct interactive_policy {
+	struct cpufreq_policy *policy;
+	struct interactive_tunables *tunables;
+	struct list_head tunables_hook;
+};
+
+/* Separate instance required for each CPU */
+struct interactive_cpu {
+	struct update_util_data update_util;
+	struct interactive_policy *ipolicy;
+
+	struct irq_work irq_work;
+	u64 last_sample_time;
+	unsigned long next_sample_jiffies;
+	bool work_in_progress;
+
+	struct rw_semaphore enable_sem;
+	struct timer_list slack_timer;
+
+	spinlock_t load_lock; /* protects the next 4 fields */
+	u64 time_in_idle;
+	u64 time_in_idle_timestamp;
+	u64 cputime_speedadj;
+	u64 cputime_speedadj_timestamp;
+
+	spinlock_t target_freq_lock; /*protects target freq */
+	unsigned int target_freq;
+
+	unsigned int floor_freq;
+	u64 pol_floor_val_time; /* policy floor_validate_time */
+	u64 loc_floor_val_time; /* per-cpu floor_validate_time */
+	u64 pol_hispeed_val_time; /* policy hispeed_validate_time */
+	u64 loc_hispeed_val_time; /* per-cpu hispeed_validate_time */
+};
+
+static DEFINE_PER_CPU(struct interactive_cpu, interactive_cpu);
+
+/* Realtime thread handles frequency scaling */
+static struct task_struct *speedchange_task;
+static cpumask_t speedchange_cpumask;
+static spinlock_t speedchange_cpumask_lock;
+
+/* Target load. Lower values result in higher CPU speeds. */
+#define DEFAULT_TARGET_LOAD 90
+static unsigned int default_target_loads[] = {DEFAULT_TARGET_LOAD};
+
+#define DEFAULT_SAMPLING_RATE (20 * USEC_PER_MSEC)
+#define DEFAULT_ABOVE_HISPEED_DELAY DEFAULT_SAMPLING_RATE
+static unsigned int default_above_hispeed_delay[] = {
+	DEFAULT_ABOVE_HISPEED_DELAY
+};
+
+/* Iterate over interactive policies for tunables */
+#define for_each_ipolicy(__ip)	\
+	list_for_each_entry(__ip, &tunables->attr_set.policy_list, tunables_hook)
+
+static struct interactive_tunables *global_tunables;
+static DEFINE_MUTEX(global_tunables_lock);
+
+static inline void update_slack_delay(struct interactive_tunables *tunables)
+{
+	tunables->timer_slack_delay = usecs_to_jiffies(tunables->timer_slack +
+						       tunables->sampling_rate);
+}
+
+static bool timer_slack_required(struct interactive_cpu *icpu)
+{
+	struct interactive_policy *ipolicy = icpu->ipolicy;
+	struct interactive_tunables *tunables = ipolicy->tunables;
+
+	if (tunables->timer_slack < 0)
+		return false;
+
+	if (icpu->target_freq > ipolicy->policy->min)
+		return true;
+
+	return false;
+}
+
+static void gov_slack_timer_start(struct interactive_cpu *icpu, int cpu)
+{
+	struct interactive_tunables *tunables = icpu->ipolicy->tunables;
+
+	icpu->slack_timer.expires = jiffies + tunables->timer_slack_delay;
+	add_timer_on(&icpu->slack_timer, cpu);
+}
+
+static void gov_slack_timer_modify(struct interactive_cpu *icpu)
+{
+	struct interactive_tunables *tunables = icpu->ipolicy->tunables;
+
+	mod_timer(&icpu->slack_timer, jiffies + tunables->timer_slack_delay);
+}
+
+static void slack_timer_resched(struct interactive_cpu *icpu, int cpu,
+				bool modify)
+{
+	struct interactive_tunables *tunables = icpu->ipolicy->tunables;
+	unsigned long flags;
+
+	spin_lock_irqsave(&icpu->load_lock, flags);
+
+	icpu->time_in_idle = get_cpu_idle_time(cpu,
+					       &icpu->time_in_idle_timestamp,
+					       tunables->io_is_busy);
+	icpu->cputime_speedadj = 0;
+	icpu->cputime_speedadj_timestamp = icpu->time_in_idle_timestamp;
+
+	if (timer_slack_required(icpu)) {
+		if (modify)
+			gov_slack_timer_modify(icpu);
+		else
+			gov_slack_timer_start(icpu, cpu);
+	}
+
+	spin_unlock_irqrestore(&icpu->load_lock, flags);
+}
+
+static unsigned int
+freq_to_above_hispeed_delay(struct interactive_tunables *tunables,
+			    unsigned int freq)
+{
+	unsigned long flags;
+	unsigned int ret;
+	int i;
+
+	spin_lock_irqsave(&tunables->above_hispeed_delay_lock, flags);
+
+	for (i = 0; i < tunables->nabove_hispeed_delay - 1 &&
+	     freq >= tunables->above_hispeed_delay[i + 1]; i += 2)
+		;
+
+	ret = tunables->above_hispeed_delay[i];
+	spin_unlock_irqrestore(&tunables->above_hispeed_delay_lock, flags);
+
+	return ret;
+}
+
+static unsigned int freq_to_targetload(struct interactive_tunables *tunables,
+				       unsigned int freq)
+{
+	unsigned long flags;
+	unsigned int ret;
+	int i;
+
+	spin_lock_irqsave(&tunables->target_loads_lock, flags);
+
+	for (i = 0; i < tunables->ntarget_loads - 1 &&
+	     freq >= tunables->target_loads[i + 1]; i += 2)
+		;
+
+	ret = tunables->target_loads[i];
+	spin_unlock_irqrestore(&tunables->target_loads_lock, flags);
+	return ret;
+}
+
+/*
+ * If increasing frequencies never map to a lower target load then
+ * choose_freq() will find the minimum frequency that does not exceed its
+ * target load given the current load.
+ */
+static unsigned int choose_freq(struct interactive_cpu *icpu,
+				unsigned int loadadjfreq)
+{
+	struct cpufreq_policy *policy = icpu->ipolicy->policy;
+	struct cpufreq_frequency_table *freq_table = policy->freq_table;
+	unsigned int prevfreq, freqmin = 0, freqmax = UINT_MAX, tl;
+	unsigned int freq = policy->cur;
+	int index;
+
+	do {
+		prevfreq = freq;
+		tl = freq_to_targetload(icpu->ipolicy->tunables, freq);
+
+		/*
+		 * Find the lowest frequency where the computed load is less
+		 * than or equal to the target load.
+		 */
+
+		index = cpufreq_frequency_table_target(policy, loadadjfreq / tl,
+						       CPUFREQ_RELATION_L);
+
+		freq = freq_table[index].frequency;
+
+		if (freq > prevfreq) {
+			/* The previous frequency is too low */
+			freqmin = prevfreq;
+
+			if (freq < freqmax)
+				continue;
+
+			/* Find highest frequency that is less than freqmax */
+			index = cpufreq_frequency_table_target(policy,
+					freqmax - 1, CPUFREQ_RELATION_H);
+
+			freq = freq_table[index].frequency;
+
+			if (freq == freqmin) {
+				/*
+				 * The first frequency below freqmax has already
+				 * been found to be too low. freqmax is the
+				 * lowest speed we found that is fast enough.
+				 */
+				freq = freqmax;
+				break;
+			}
+		} else if (freq < prevfreq) {
+			/* The previous frequency is high enough. */
+			freqmax = prevfreq;
+
+			if (freq > freqmin)
+				continue;
+
+			/* Find lowest frequency that is higher than freqmin */
+			index = cpufreq_frequency_table_target(policy,
+					freqmin + 1, CPUFREQ_RELATION_L);
+
+			freq = freq_table[index].frequency;
+
+			/*
+			 * If freqmax is the first frequency above
+			 * freqmin then we have already found that
+			 * this speed is fast enough.
+			 */
+			if (freq == freqmax)
+				break;
+		}
+
+		/* If same frequency chosen as previous then done. */
+	} while (freq != prevfreq);
+
+	return freq;
+}
+
+static u64 update_load(struct interactive_cpu *icpu, int cpu)
+{
+	struct interactive_tunables *tunables = icpu->ipolicy->tunables;
+	u64 now_idle, now, active_time, delta_idle, delta_time;
+
+	now_idle = get_cpu_idle_time(cpu, &now, tunables->io_is_busy);
+	delta_idle = (now_idle - icpu->time_in_idle);
+	delta_time = (now - icpu->time_in_idle_timestamp);
+
+	if (delta_time <= delta_idle)
+		active_time = 0;
+	else
+		active_time = delta_time - delta_idle;
+
+	icpu->cputime_speedadj += active_time * icpu->ipolicy->policy->cur;
+
+	icpu->time_in_idle = now_idle;
+	icpu->time_in_idle_timestamp = now;
+
+	return now;
+}
+
+/* Re-evaluate load to see if a frequency change is required or not */
+static void eval_target_freq(struct interactive_cpu *icpu)
+{
+	struct interactive_tunables *tunables = icpu->ipolicy->tunables;
+	struct cpufreq_policy *policy = icpu->ipolicy->policy;
+	struct cpufreq_frequency_table *freq_table = policy->freq_table;
+	u64 cputime_speedadj, now, max_fvtime;
+	unsigned int new_freq, loadadjfreq, index, delta_time;
+	unsigned long flags;
+	int cpu_load;
+	int cpu = smp_processor_id();
+
+	spin_lock_irqsave(&icpu->load_lock, flags);
+	now = update_load(icpu, smp_processor_id());
+	delta_time = (unsigned int)(now - icpu->cputime_speedadj_timestamp);
+	cputime_speedadj = icpu->cputime_speedadj;
+	spin_unlock_irqrestore(&icpu->load_lock, flags);
+
+	if (WARN_ON_ONCE(!delta_time))
+		return;
+
+	spin_lock_irqsave(&icpu->target_freq_lock, flags);
+	do_div(cputime_speedadj, delta_time);
+	loadadjfreq = (unsigned int)cputime_speedadj * 100;
+	cpu_load = loadadjfreq / policy->cur;
+	tunables->boosted = tunables->boost ||
+			    now < tunables->boostpulse_endtime;
+
+	if (cpu_load >= tunables->go_hispeed_load || tunables->boosted) {
+		if (policy->cur < tunables->hispeed_freq) {
+			new_freq = tunables->hispeed_freq;
+		} else {
+			new_freq = choose_freq(icpu, loadadjfreq);
+
+			if (new_freq < tunables->hispeed_freq)
+				new_freq = tunables->hispeed_freq;
+		}
+	} else {
+		new_freq = choose_freq(icpu, loadadjfreq);
+		if (new_freq > tunables->hispeed_freq &&
+		    policy->cur < tunables->hispeed_freq)
+			new_freq = tunables->hispeed_freq;
+	}
+
+	if (policy->cur >= tunables->hispeed_freq &&
+	    new_freq > policy->cur &&
+	    now - icpu->pol_hispeed_val_time < freq_to_above_hispeed_delay(tunables, policy->cur)) {
+		trace_cpufreq_interactive_notyet(cpu, cpu_load,
+				icpu->target_freq, policy->cur, new_freq);
+		goto exit;
+	}
+
+	icpu->loc_hispeed_val_time = now;
+
+	index = cpufreq_frequency_table_target(policy, new_freq,
+					       CPUFREQ_RELATION_L);
+	new_freq = freq_table[index].frequency;
+
+	/*
+	 * Do not scale below floor_freq unless we have been at or above the
+	 * floor frequency for the minimum sample time since last validated.
+	 */
+	max_fvtime = max(icpu->pol_floor_val_time, icpu->loc_floor_val_time);
+	if (new_freq < icpu->floor_freq && icpu->target_freq >= policy->cur) {
+		if (now - max_fvtime < tunables->min_sample_time) {
+			trace_cpufreq_interactive_notyet(cpu, cpu_load,
+				icpu->target_freq, policy->cur, new_freq);
+			goto exit;
+		}
+	}
+
+	/*
+	 * Update the timestamp for checking whether speed has been held at
+	 * or above the selected frequency for a minimum of min_sample_time,
+	 * if not boosted to hispeed_freq.  If boosted to hispeed_freq then we
+	 * allow the speed to drop as soon as the boostpulse duration expires
+	 * (or the indefinite boost is turned off).
+	 */
+
+	if (!tunables->boosted || new_freq > tunables->hispeed_freq) {
+		icpu->floor_freq = new_freq;
+		if (icpu->target_freq >= policy->cur || new_freq >= policy->cur)
+			icpu->loc_floor_val_time = now;
+	}
+
+	if (icpu->target_freq == new_freq &&
+	    icpu->target_freq <= policy->cur) {
+		trace_cpufreq_interactive_already(cpu, cpu_load,
+			icpu->target_freq, policy->cur, new_freq);
+		goto exit;
+	}
+
+	trace_cpufreq_interactive_target(cpu, cpu_load, icpu->target_freq,
+					 policy->cur, new_freq);
+
+	icpu->target_freq = new_freq;
+	spin_unlock_irqrestore(&icpu->target_freq_lock, flags);
+
+	spin_lock_irqsave(&speedchange_cpumask_lock, flags);
+	cpumask_set_cpu(cpu, &speedchange_cpumask);
+	spin_unlock_irqrestore(&speedchange_cpumask_lock, flags);
+
+	wake_up_process(speedchange_task);
+	return;
+
+exit:
+	spin_unlock_irqrestore(&icpu->target_freq_lock, flags);
+}
+
+static void cpufreq_interactive_update(struct interactive_cpu *icpu)
+{
+	eval_target_freq(icpu);
+	slack_timer_resched(icpu, smp_processor_id(), true);
+}
+
+static void cpufreq_interactive_idle_end(void)
+{
+	struct interactive_cpu *icpu = &per_cpu(interactive_cpu,
+						smp_processor_id());
+
+	if (!down_read_trylock(&icpu->enable_sem))
+		return;
+
+	if (icpu->ipolicy) {
+		/*
+		 * We haven't sampled load for more than sampling_rate time, do
+		 * it right now.
+		 */
+		if (time_after_eq(jiffies, icpu->next_sample_jiffies))
+			cpufreq_interactive_update(icpu);
+	}
+
+	up_read(&icpu->enable_sem);
+}
+
+static void cpufreq_interactive_get_policy_info(struct cpufreq_policy *policy,
+						unsigned int *pmax_freq,
+						u64 *phvt, u64 *pfvt)
+{
+	struct interactive_cpu *icpu;
+	u64 hvt = ~0ULL, fvt = 0;
+	unsigned int max_freq = 0, i;
+
+	for_each_cpu(i, policy->cpus) {
+		icpu = &per_cpu(interactive_cpu, i);
+
+		fvt = max(fvt, icpu->loc_floor_val_time);
+		if (icpu->target_freq > max_freq) {
+			max_freq = icpu->target_freq;
+			hvt = icpu->loc_hispeed_val_time;
+		} else if (icpu->target_freq == max_freq) {
+			hvt = min(hvt, icpu->loc_hispeed_val_time);
+		}
+	}
+
+	*pmax_freq = max_freq;
+	*phvt = hvt;
+	*pfvt = fvt;
+}
+
+static void cpufreq_interactive_adjust_cpu(unsigned int cpu,
+					   struct cpufreq_policy *policy)
+{
+	struct interactive_cpu *icpu;
+	u64 hvt, fvt;
+	unsigned int max_freq;
+	int i;
+
+	cpufreq_interactive_get_policy_info(policy, &max_freq, &hvt, &fvt);
+
+	for_each_cpu(i, policy->cpus) {
+		icpu = &per_cpu(interactive_cpu, i);
+		icpu->pol_floor_val_time = fvt;
+	}
+
+	if (max_freq != policy->cur) {
+		__cpufreq_driver_target(policy, max_freq, CPUFREQ_RELATION_H);
+		for_each_cpu(i, policy->cpus) {
+			icpu = &per_cpu(interactive_cpu, i);
+			icpu->pol_hispeed_val_time = hvt;
+		}
+	}
+
+	trace_cpufreq_interactive_setspeed(cpu, max_freq, policy->cur);
+}
+
+static int cpufreq_interactive_speedchange_task(void *data)
+{
+	unsigned int cpu;
+	cpumask_t tmp_mask;
+	unsigned long flags;
+
+again:
+	set_current_state(TASK_INTERRUPTIBLE);
+	spin_lock_irqsave(&speedchange_cpumask_lock, flags);
+
+	if (cpumask_empty(&speedchange_cpumask)) {
+		spin_unlock_irqrestore(&speedchange_cpumask_lock, flags);
+		schedule();
+
+		if (kthread_should_stop())
+			return 0;
+
+		spin_lock_irqsave(&speedchange_cpumask_lock, flags);
+	}
+
+	set_current_state(TASK_RUNNING);
+	tmp_mask = speedchange_cpumask;
+	cpumask_clear(&speedchange_cpumask);
+	spin_unlock_irqrestore(&speedchange_cpumask_lock, flags);
+
+	for_each_cpu(cpu, &tmp_mask) {
+		struct interactive_cpu *icpu = &per_cpu(interactive_cpu, cpu);
+		struct cpufreq_policy *policy;
+
+		if (unlikely(!down_read_trylock(&icpu->enable_sem)))
+			continue;
+
+		if (likely(icpu->ipolicy)) {
+			policy = icpu->ipolicy->policy;
+			cpufreq_interactive_adjust_cpu(cpu, policy);
+		}
+
+		up_read(&icpu->enable_sem);
+	}
+
+	goto again;
+}
+
+static void cpufreq_interactive_boost(struct interactive_tunables *tunables)
+{
+	struct interactive_policy *ipolicy;
+	struct cpufreq_policy *policy;
+	struct interactive_cpu *icpu;
+	unsigned long flags[2];
+	bool wakeup = false;
+	int i;
+
+	tunables->boosted = true;
+
+	spin_lock_irqsave(&speedchange_cpumask_lock, flags[0]);
+
+	for_each_ipolicy(ipolicy) {
+		policy = ipolicy->policy;
+
+		for_each_cpu(i, policy->cpus) {
+			icpu = &per_cpu(interactive_cpu, i);
+
+			if (!down_read_trylock(&icpu->enable_sem))
+				continue;
+
+			if (!icpu->ipolicy) {
+				up_read(&icpu->enable_sem);
+				continue;
+			}
+
+			spin_lock_irqsave(&icpu->target_freq_lock, flags[1]);
+			if (icpu->target_freq < tunables->hispeed_freq) {
+				icpu->target_freq = tunables->hispeed_freq;
+				cpumask_set_cpu(i, &speedchange_cpumask);
+				icpu->pol_hispeed_val_time = ktime_to_us(ktime_get());
+				wakeup = true;
+			}
+			spin_unlock_irqrestore(&icpu->target_freq_lock, flags[1]);
+
+			up_read(&icpu->enable_sem);
+		}
+	}
+
+	spin_unlock_irqrestore(&speedchange_cpumask_lock, flags[0]);
+
+	if (wakeup)
+		wake_up_process(speedchange_task);
+}
+
+static int cpufreq_interactive_notifier(struct notifier_block *nb,
+					unsigned long val, void *data)
+{
+	struct cpufreq_freqs *freq = data;
+	struct interactive_cpu *icpu = &per_cpu(interactive_cpu, freq->cpu);
+	unsigned long flags;
+
+	if (val != CPUFREQ_POSTCHANGE)
+		return 0;
+
+	if (!down_read_trylock(&icpu->enable_sem))
+		return 0;
+
+	if (!icpu->ipolicy) {
+		up_read(&icpu->enable_sem);
+		return 0;
+	}
+
+	spin_lock_irqsave(&icpu->load_lock, flags);
+	update_load(icpu, freq->cpu);
+	spin_unlock_irqrestore(&icpu->load_lock, flags);
+
+	up_read(&icpu->enable_sem);
+
+	return 0;
+}
+
+static struct notifier_block cpufreq_notifier_block = {
+	.notifier_call = cpufreq_interactive_notifier,
+};
+
+static unsigned int *get_tokenized_data(const char *buf, int *num_tokens)
+{
+	const char *cp = buf;
+	int ntokens = 1, i = 0;
+	unsigned int *tokenized_data;
+	int err = -EINVAL;
+
+	while ((cp = strpbrk(cp + 1, " :")))
+		ntokens++;
+
+	if (!(ntokens & 0x1))
+		goto err;
+
+	tokenized_data = kcalloc(ntokens, sizeof(*tokenized_data), GFP_KERNEL);
+	if (!tokenized_data) {
+		err = -ENOMEM;
+		goto err;
+	}
+
+	cp = buf;
+	while (i < ntokens) {
+		if (kstrtouint(cp, 0, &tokenized_data[i++]) < 0)
+			goto err_kfree;
+
+		cp = strpbrk(cp, " :");
+		if (!cp)
+			break;
+		cp++;
+	}
+
+	if (i != ntokens)
+		goto err_kfree;
+
+	*num_tokens = ntokens;
+	return tokenized_data;
+
+err_kfree:
+	kfree(tokenized_data);
+err:
+	return ERR_PTR(err);
+}
+
+/* Interactive governor sysfs interface */
+static struct interactive_tunables *to_tunables(struct gov_attr_set *attr_set)
+{
+	return container_of(attr_set, struct interactive_tunables, attr_set);
+}
+
+#define show_one(file_name, type)					\
+static ssize_t show_##file_name(struct gov_attr_set *attr_set, char *buf) \
+{									\
+	struct interactive_tunables *tunables = to_tunables(attr_set);	\
+	return sprintf(buf, type "\n", tunables->file_name);		\
+}
+
+static ssize_t show_target_loads(struct gov_attr_set *attr_set, char *buf)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long flags;
+	ssize_t ret = 0;
+	int i;
+
+	spin_lock_irqsave(&tunables->target_loads_lock, flags);
+
+	for (i = 0; i < tunables->ntarget_loads; i++)
+		ret += sprintf(buf + ret, "%u%s", tunables->target_loads[i],
+			       i & 0x1 ? ":" : " ");
+
+	sprintf(buf + ret - 1, "\n");
+	spin_unlock_irqrestore(&tunables->target_loads_lock, flags);
+
+	return ret;
+}
+
+static ssize_t store_target_loads(struct gov_attr_set *attr_set,
+				  const char *buf, size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned int *new_target_loads;
+	unsigned long flags;
+	int ntokens;
+
+	new_target_loads = get_tokenized_data(buf, &ntokens);
+	if (IS_ERR(new_target_loads))
+		return PTR_ERR(new_target_loads);
+
+	spin_lock_irqsave(&tunables->target_loads_lock, flags);
+	if (tunables->target_loads != default_target_loads)
+		kfree(tunables->target_loads);
+	tunables->target_loads = new_target_loads;
+	tunables->ntarget_loads = ntokens;
+	spin_unlock_irqrestore(&tunables->target_loads_lock, flags);
+
+	return count;
+}
+
+static ssize_t show_above_hispeed_delay(struct gov_attr_set *attr_set,
+					char *buf)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long flags;
+	ssize_t ret = 0;
+	int i;
+
+	spin_lock_irqsave(&tunables->above_hispeed_delay_lock, flags);
+
+	for (i = 0; i < tunables->nabove_hispeed_delay; i++)
+		ret += sprintf(buf + ret, "%u%s",
+			       tunables->above_hispeed_delay[i],
+			       i & 0x1 ? ":" : " ");
+
+	sprintf(buf + ret - 1, "\n");
+	spin_unlock_irqrestore(&tunables->above_hispeed_delay_lock, flags);
+
+	return ret;
+}
+
+static ssize_t store_above_hispeed_delay(struct gov_attr_set *attr_set,
+					 const char *buf, size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned int *new_above_hispeed_delay = NULL;
+	unsigned long flags;
+	int ntokens;
+
+	new_above_hispeed_delay = get_tokenized_data(buf, &ntokens);
+	if (IS_ERR(new_above_hispeed_delay))
+		return PTR_ERR(new_above_hispeed_delay);
+
+	spin_lock_irqsave(&tunables->above_hispeed_delay_lock, flags);
+	if (tunables->above_hispeed_delay != default_above_hispeed_delay)
+		kfree(tunables->above_hispeed_delay);
+	tunables->above_hispeed_delay = new_above_hispeed_delay;
+	tunables->nabove_hispeed_delay = ntokens;
+	spin_unlock_irqrestore(&tunables->above_hispeed_delay_lock, flags);
+
+	return count;
+}
+
+static ssize_t store_hispeed_freq(struct gov_attr_set *attr_set,
+				  const char *buf, size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long int val;
+	int ret;
+
+	ret = kstrtoul(buf, 0, &val);
+	if (ret < 0)
+		return ret;
+
+	tunables->hispeed_freq = val;
+
+	return count;
+}
+
+static ssize_t store_go_hispeed_load(struct gov_attr_set *attr_set,
+				     const char *buf, size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long val;
+	int ret;
+
+	ret = kstrtoul(buf, 0, &val);
+	if (ret < 0)
+		return ret;
+
+	tunables->go_hispeed_load = val;
+
+	return count;
+}
+
+static ssize_t store_min_sample_time(struct gov_attr_set *attr_set,
+				     const char *buf, size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long val;
+	int ret;
+
+	ret = kstrtoul(buf, 0, &val);
+	if (ret < 0)
+		return ret;
+
+	tunables->min_sample_time = val;
+
+	return count;
+}
+
+static ssize_t show_timer_rate(struct gov_attr_set *attr_set, char *buf)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+
+	return sprintf(buf, "%lu\n", tunables->sampling_rate);
+}
+
+static ssize_t store_timer_rate(struct gov_attr_set *attr_set, const char *buf,
+				size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long val, val_round;
+	int ret;
+
+	ret = kstrtoul(buf, 0, &val);
+	if (ret < 0)
+		return ret;
+
+	val_round = jiffies_to_usecs(usecs_to_jiffies(val));
+	if (val != val_round)
+		pr_warn("timer_rate not aligned to jiffy. Rounded up to %lu\n",
+			val_round);
+
+	tunables->sampling_rate = val_round;
+
+	return count;
+}
+
+static ssize_t store_timer_slack(struct gov_attr_set *attr_set, const char *buf,
+				 size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long val;
+	int ret;
+
+	ret = kstrtol(buf, 10, &val);
+	if (ret < 0)
+		return ret;
+
+	tunables->timer_slack = val;
+	update_slack_delay(tunables);
+
+	return count;
+}
+
+static ssize_t store_boost(struct gov_attr_set *attr_set, const char *buf,
+			   size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long val;
+	int ret;
+
+	ret = kstrtoul(buf, 0, &val);
+	if (ret < 0)
+		return ret;
+
+	tunables->boost = val;
+
+	if (tunables->boost) {
+		trace_cpufreq_interactive_boost("on");
+		if (!tunables->boosted)
+			cpufreq_interactive_boost(tunables);
+	} else {
+		tunables->boostpulse_endtime = ktime_to_us(ktime_get());
+		trace_cpufreq_interactive_unboost("off");
+	}
+
+	return count;
+}
+
+static ssize_t store_boostpulse(struct gov_attr_set *attr_set, const char *buf,
+				size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long val;
+	int ret;
+
+	ret = kstrtoul(buf, 0, &val);
+	if (ret < 0)
+		return ret;
+
+	tunables->boostpulse_endtime = ktime_to_us(ktime_get()) +
+					tunables->boostpulse_duration;
+	trace_cpufreq_interactive_boost("pulse");
+	if (!tunables->boosted)
+		cpufreq_interactive_boost(tunables);
+
+	return count;
+}
+
+static ssize_t store_boostpulse_duration(struct gov_attr_set *attr_set,
+					 const char *buf, size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long val;
+	int ret;
+
+	ret = kstrtoul(buf, 0, &val);
+	if (ret < 0)
+		return ret;
+
+	tunables->boostpulse_duration = val;
+
+	return count;
+}
+
+static ssize_t store_io_is_busy(struct gov_attr_set *attr_set, const char *buf,
+				size_t count)
+{
+	struct interactive_tunables *tunables = to_tunables(attr_set);
+	unsigned long val;
+	int ret;
+
+	ret = kstrtoul(buf, 0, &val);
+	if (ret < 0)
+		return ret;
+
+	tunables->io_is_busy = val;
+
+	return count;
+}
+
+show_one(hispeed_freq, "%u");
+show_one(go_hispeed_load, "%lu");
+show_one(min_sample_time, "%lu");
+show_one(timer_slack, "%lu");
+show_one(boost, "%u");
+show_one(boostpulse_duration, "%u");
+show_one(io_is_busy, "%u");
+
+gov_attr_rw(target_loads);
+gov_attr_rw(above_hispeed_delay);
+gov_attr_rw(hispeed_freq);
+gov_attr_rw(go_hispeed_load);
+gov_attr_rw(min_sample_time);
+gov_attr_rw(timer_rate);
+gov_attr_rw(timer_slack);
+gov_attr_rw(boost);
+gov_attr_wo(boostpulse);
+gov_attr_rw(boostpulse_duration);
+gov_attr_rw(io_is_busy);
+
+static struct attribute *interactive_attributes[] = {
+	&target_loads.attr,
+	&above_hispeed_delay.attr,
+	&hispeed_freq.attr,
+	&go_hispeed_load.attr,
+	&min_sample_time.attr,
+	&timer_rate.attr,
+	&timer_slack.attr,
+	&boost.attr,
+	&boostpulse.attr,
+	&boostpulse_duration.attr,
+	&io_is_busy.attr,
+	NULL
+};
+
+static struct kobj_type interactive_tunables_ktype = {
+	.default_attrs = interactive_attributes,
+	.sysfs_ops = &governor_sysfs_ops,
+};
+
+static int cpufreq_interactive_idle_notifier(struct notifier_block *nb,
+					     unsigned long val, void *data)
+{
+	if (val == IDLE_END)
+		cpufreq_interactive_idle_end();
+
+	return 0;
+}
+
+static struct notifier_block cpufreq_interactive_idle_nb = {
+	.notifier_call = cpufreq_interactive_idle_notifier,
+};
+
+/* Interactive Governor callbacks */
+struct interactive_governor {
+	struct cpufreq_governor gov;
+	unsigned int usage_count;
+};
+
+static struct interactive_governor interactive_gov;
+
+#define CPU_FREQ_GOV_INTERACTIVE	(&interactive_gov.gov)
+
+static void irq_work(struct irq_work *irq_work)
+{
+	struct interactive_cpu *icpu = container_of(irq_work, struct
+						    interactive_cpu, irq_work);
+
+	cpufreq_interactive_update(icpu);
+	icpu->work_in_progress = false;
+}
+
+static void update_util_handler(struct update_util_data *data, u64 time,
+				unsigned int flags)
+{
+	struct interactive_cpu *icpu = container_of(data,
+					struct interactive_cpu, update_util);
+	struct interactive_policy *ipolicy = icpu->ipolicy;
+	struct interactive_tunables *tunables = ipolicy->tunables;
+	u64 delta_ns;
+
+	/*
+	 * The irq-work may not be allowed to be queued up right now.
+	 * Possible reasons:
+	 * - Work has already been queued up or is in progress.
+	 * - It is too early (too little time from the previous sample).
+	 */
+	if (icpu->work_in_progress)
+		return;
+
+	delta_ns = time - icpu->last_sample_time;
+	if ((s64)delta_ns < tunables->sampling_rate * NSEC_PER_USEC)
+		return;
+
+	icpu->last_sample_time = time;
+	icpu->next_sample_jiffies = usecs_to_jiffies(tunables->sampling_rate) +
+				    jiffies;
+
+	icpu->work_in_progress = true;
+	irq_work_queue(&icpu->irq_work);
+}
+
+static void gov_set_update_util(struct interactive_policy *ipolicy)
+{
+	struct cpufreq_policy *policy = ipolicy->policy;
+	struct interactive_cpu *icpu;
+	int cpu;
+
+	for_each_cpu(cpu, policy->cpus) {
+		icpu = &per_cpu(interactive_cpu, cpu);
+
+		icpu->last_sample_time = 0;
+		icpu->next_sample_jiffies = 0;
+		cpufreq_add_update_util_hook(cpu, &icpu->update_util,
+					     update_util_handler);
+	}
+}
+
+static inline void gov_clear_update_util(struct cpufreq_policy *policy)
+{
+	int i;
+
+	for_each_cpu(i, policy->cpus)
+		cpufreq_remove_update_util_hook(i);
+
+	synchronize_sched();
+}
+
+static void icpu_cancel_work(struct interactive_cpu *icpu)
+{
+	irq_work_sync(&icpu->irq_work);
+	icpu->work_in_progress = false;
+	del_timer_sync(&icpu->slack_timer);
+}
+
+static struct interactive_policy *
+interactive_policy_alloc(struct cpufreq_policy *policy)
+{
+	struct interactive_policy *ipolicy;
+
+	ipolicy = kzalloc(sizeof(*ipolicy), GFP_KERNEL);
+	if (!ipolicy)
+		return NULL;
+
+	ipolicy->policy = policy;
+
+	return ipolicy;
+}
+
+static void interactive_policy_free(struct interactive_policy *ipolicy)
+{
+	kfree(ipolicy);
+}
+
+static struct interactive_tunables *
+interactive_tunables_alloc(struct interactive_policy *ipolicy)
+{
+	struct interactive_tunables *tunables;
+
+	tunables = kzalloc(sizeof(*tunables), GFP_KERNEL);
+	if (!tunables)
+		return NULL;
+
+	gov_attr_set_init(&tunables->attr_set, &ipolicy->tunables_hook);
+	if (!have_governor_per_policy())
+		global_tunables = tunables;
+
+	ipolicy->tunables = tunables;
+
+	return tunables;
+}
+
+static void interactive_tunables_free(struct interactive_tunables *tunables)
+{
+	if (!have_governor_per_policy())
+		global_tunables = NULL;
+
+	kfree(tunables);
+}
+
+int cpufreq_interactive_init(struct cpufreq_policy *policy)
+{
+	struct interactive_policy *ipolicy;
+	struct interactive_tunables *tunables;
+	int ret;
+
+	/* State should be equivalent to EXIT */
+	if (policy->governor_data)
+		return -EBUSY;
+
+	ipolicy = interactive_policy_alloc(policy);
+	if (!ipolicy)
+		return -ENOMEM;
+
+	mutex_lock(&global_tunables_lock);
+
+	if (global_tunables) {
+		if (WARN_ON(have_governor_per_policy())) {
+			ret = -EINVAL;
+			goto free_int_policy;
+		}
+
+		policy->governor_data = ipolicy;
+		ipolicy->tunables = global_tunables;
+
+		gov_attr_set_get(&global_tunables->attr_set,
+				 &ipolicy->tunables_hook);
+		goto out;
+	}
+
+	tunables = interactive_tunables_alloc(ipolicy);
+	if (!tunables) {
+		ret = -ENOMEM;
+		goto free_int_policy;
+	}
+
+	tunables->hispeed_freq = policy->max;
+	tunables->above_hispeed_delay = default_above_hispeed_delay;
+	tunables->nabove_hispeed_delay =
+		ARRAY_SIZE(default_above_hispeed_delay);
+	tunables->go_hispeed_load = DEFAULT_GO_HISPEED_LOAD;
+	tunables->target_loads = default_target_loads;
+	tunables->ntarget_loads = ARRAY_SIZE(default_target_loads);
+	tunables->min_sample_time = DEFAULT_MIN_SAMPLE_TIME;
+	tunables->boostpulse_duration = DEFAULT_MIN_SAMPLE_TIME;
+	tunables->sampling_rate = DEFAULT_SAMPLING_RATE;
+	tunables->timer_slack = DEFAULT_TIMER_SLACK;
+	tunables->io_is_busy = 1;
+	update_slack_delay(tunables);
+
+	spin_lock_init(&tunables->target_loads_lock);
+	spin_lock_init(&tunables->above_hispeed_delay_lock);
+
+	policy->governor_data = ipolicy;
+
+	ret = kobject_init_and_add(&tunables->attr_set.kobj,
+				   &interactive_tunables_ktype,
+				   get_governor_parent_kobj(policy), "%s",
+				   interactive_gov.gov.name);
+	if (ret)
+		goto fail;
+
+	/* One time initialization for governor */
+	if (!interactive_gov.usage_count++) {
+		idle_notifier_register(&cpufreq_interactive_idle_nb);
+		cpufreq_register_notifier(&cpufreq_notifier_block,
+					  CPUFREQ_TRANSITION_NOTIFIER);
+	}
+
+ out:
+	mutex_unlock(&global_tunables_lock);
+	return 0;
+
+ fail:
+	policy->governor_data = NULL;
+	interactive_tunables_free(tunables);
+
+ free_int_policy:
+	mutex_unlock(&global_tunables_lock);
+
+	interactive_policy_free(ipolicy);
+	pr_err("governor initialization failed (%d)\n", ret);
+
+	return ret;
+}
+
+void cpufreq_interactive_exit(struct cpufreq_policy *policy)
+{
+	struct interactive_policy *ipolicy = policy->governor_data;
+	struct interactive_tunables *tunables = ipolicy->tunables;
+	unsigned int count;
+
+	mutex_lock(&global_tunables_lock);
+
+	/* Last policy using the governor ? */
+	if (!--interactive_gov.usage_count) {
+		cpufreq_unregister_notifier(&cpufreq_notifier_block,
+					    CPUFREQ_TRANSITION_NOTIFIER);
+		idle_notifier_unregister(&cpufreq_interactive_idle_nb);
+	}
+
+	count = gov_attr_set_put(&tunables->attr_set, &ipolicy->tunables_hook);
+	policy->governor_data = NULL;
+	if (!count)
+		interactive_tunables_free(tunables);
+
+	mutex_unlock(&global_tunables_lock);
+
+	interactive_policy_free(ipolicy);
+}
+
+int cpufreq_interactive_start(struct cpufreq_policy *policy)
+{
+	struct interactive_policy *ipolicy = policy->governor_data;
+	struct interactive_cpu *icpu;
+	unsigned int cpu;
+
+	for_each_cpu(cpu, policy->cpus) {
+		icpu = &per_cpu(interactive_cpu, cpu);
+
+		icpu->target_freq = policy->cur;
+		icpu->floor_freq = icpu->target_freq;
+		icpu->pol_floor_val_time = ktime_to_us(ktime_get());
+		icpu->loc_floor_val_time = icpu->pol_floor_val_time;
+		icpu->pol_hispeed_val_time = icpu->pol_floor_val_time;
+		icpu->loc_hispeed_val_time = icpu->pol_floor_val_time;
+
+		down_write(&icpu->enable_sem);
+		icpu->ipolicy = ipolicy;
+		up_write(&icpu->enable_sem);
+
+		slack_timer_resched(icpu, cpu, false);
+	}
+
+	gov_set_update_util(ipolicy);
+	return 0;
+}
+
+void cpufreq_interactive_stop(struct cpufreq_policy *policy)
+{
+	struct interactive_policy *ipolicy = policy->governor_data;
+	struct interactive_cpu *icpu;
+	unsigned int cpu;
+
+	gov_clear_update_util(ipolicy->policy);
+
+	for_each_cpu(cpu, policy->cpus) {
+		icpu = &per_cpu(interactive_cpu, cpu);
+
+		icpu_cancel_work(icpu);
+
+		down_write(&icpu->enable_sem);
+		icpu->ipolicy = NULL;
+		up_write(&icpu->enable_sem);
+	}
+}
+
+void cpufreq_interactive_limits(struct cpufreq_policy *policy)
+{
+	struct interactive_cpu *icpu;
+	unsigned int cpu;
+	unsigned long flags;
+
+	cpufreq_policy_apply_limits(policy);
+
+	for_each_cpu(cpu, policy->cpus) {
+		icpu = &per_cpu(interactive_cpu, cpu);
+
+		spin_lock_irqsave(&icpu->target_freq_lock, flags);
+
+		if (policy->max < icpu->target_freq)
+			icpu->target_freq = policy->max;
+		else if (policy->min > icpu->target_freq)
+			icpu->target_freq = policy->min;
+
+		spin_unlock_irqrestore(&icpu->target_freq_lock, flags);
+	}
+}
+
+static struct interactive_governor interactive_gov = {
+	.gov = {
+		.name			= "interactive",
+		.max_transition_latency	= TRANSITION_LATENCY_LIMIT,
+		.owner			= THIS_MODULE,
+		.init			= cpufreq_interactive_init,
+		.exit			= cpufreq_interactive_exit,
+		.start			= cpufreq_interactive_start,
+		.stop			= cpufreq_interactive_stop,
+		.limits			= cpufreq_interactive_limits,
+	}
+};
+
+static void cpufreq_interactive_nop_timer(unsigned long data)
+{
+	/*
+	 * The purpose of slack-timer is to wake up the CPU from IDLE, in order
+	 * to decrease its frequency if it is not set to minimum already.
+	 *
+	 * This is important for platforms where CPU with higher frequencies
+	 * consume higher power even at IDLE.
+	 */
+}
+
+static int __init cpufreq_interactive_gov_init(void)
+{
+	struct sched_param param = { .sched_priority = MAX_RT_PRIO - 1 };
+	struct interactive_cpu *icpu;
+	unsigned int cpu;
+
+	for_each_possible_cpu(cpu) {
+		icpu = &per_cpu(interactive_cpu, cpu);
+
+		init_irq_work(&icpu->irq_work, irq_work);
+		spin_lock_init(&icpu->load_lock);
+		spin_lock_init(&icpu->target_freq_lock);
+		init_rwsem(&icpu->enable_sem);
+
+		/* Initialize per-cpu slack-timer */
+		init_timer_pinned(&icpu->slack_timer);
+		icpu->slack_timer.function = cpufreq_interactive_nop_timer;
+	}
+
+	spin_lock_init(&speedchange_cpumask_lock);
+	speedchange_task = kthread_create(cpufreq_interactive_speedchange_task,
+					  NULL, "cfinteractive");
+	if (IS_ERR(speedchange_task))
+		return PTR_ERR(speedchange_task);
+
+	sched_setscheduler_nocheck(speedchange_task, SCHED_FIFO, &param);
+	get_task_struct(speedchange_task);
+
+	/* wake up so the thread does not look hung to the freezer */
+	wake_up_process(speedchange_task);
+
+	return cpufreq_register_governor(CPU_FREQ_GOV_INTERACTIVE);
+}
+
+#ifdef CONFIG_CPU_FREQ_DEFAULT_GOV_INTERACTIVE
+struct cpufreq_governor *cpufreq_default_governor(void)
+{
+	return CPU_FREQ_GOV_INTERACTIVE;
+}
+
+fs_initcall(cpufreq_interactive_gov_init);
+#else
+module_init(cpufreq_interactive_gov_init);
+#endif
+
+static void __exit cpufreq_interactive_gov_exit(void)
+{
+	cpufreq_unregister_governor(CPU_FREQ_GOV_INTERACTIVE);
+	kthread_stop(speedchange_task);
+	put_task_struct(speedchange_task);
+}
+module_exit(cpufreq_interactive_gov_exit);
+
+MODULE_AUTHOR("Mike Chan <mike@android.com>");
+MODULE_DESCRIPTION("'cpufreq_interactive' - A dynamic cpufreq governor for Latency sensitive workloads");
+MODULE_LICENSE("GPL");
diff --git a/drivers/cpufreq/cpufreq_performance.c b/drivers/cpufreq/cpufreq_performance.c
index dafb679..399428e 100644
--- a/drivers/cpufreq/cpufreq_performance.c
+++ b/drivers/cpufreq/cpufreq_performance.c
@@ -22,7 +22,10 @@ static void cpufreq_gov_performance_limits(struct cpufreq_policy *policy)
 	__cpufreq_driver_target(policy, policy->max, CPUFREQ_RELATION_H);
 }
 
-static struct cpufreq_governor cpufreq_gov_performance = {
+#ifdef CONFIG_CPU_FREQ_GOV_PERFORMANCE_MODULE
+static
+#endif
+struct cpufreq_governor cpufreq_gov_performance = {
 	.name		= "performance",
 	.owner		= THIS_MODULE,
 	.limits		= cpufreq_gov_performance_limits,
diff --git a/drivers/cpufreq/cpufreq_powersave.c b/drivers/cpufreq/cpufreq_powersave.c
index 78a6510..5daa500 100644
--- a/drivers/cpufreq/cpufreq_powersave.c
+++ b/drivers/cpufreq/cpufreq_powersave.c
@@ -22,7 +22,10 @@ static void cpufreq_gov_powersave_limits(struct cpufreq_policy *policy)
 	__cpufreq_driver_target(policy, policy->min, CPUFREQ_RELATION_L);
 }
 
-static struct cpufreq_governor cpufreq_gov_powersave = {
+#ifndef CONFIG_CPU_FREQ_DEFAULT_GOV_POWERSAVE
+static
+#endif
+struct cpufreq_governor cpufreq_gov_powersave = {
 	.name		= "powersave",
 	.limits		= cpufreq_gov_powersave_limits,
 	.owner		= THIS_MODULE,
diff --git a/drivers/cpufreq/cpufreq_times.c b/drivers/cpufreq/cpufreq_times.c
new file mode 100644
index 00000000..0e8754b6
--- /dev/null
+++ b/drivers/cpufreq/cpufreq_times.c
@@ -0,0 +1,464 @@
+/* drivers/cpufreq/cpufreq_times.c
+ *
+ * Copyright (C) 2018 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/cpufreq.h>
+#include <linux/cpufreq_times.h>
+#include <linux/cputime.h>
+#include <linux/hashtable.h>
+#include <linux/init.h>
+#include <linux/proc_fs.h>
+#include <linux/sched.h>
+#include <linux/seq_file.h>
+#include <linux/slab.h>
+#include <linux/spinlock.h>
+#include <linux/threads.h>
+
+#define UID_HASH_BITS 10
+
+static DECLARE_HASHTABLE(uid_hash_table, UID_HASH_BITS);
+
+static DEFINE_SPINLOCK(task_time_in_state_lock); /* task->time_in_state */
+static DEFINE_SPINLOCK(uid_lock); /* uid_hash_table */
+
+struct uid_entry {
+	uid_t uid;
+	unsigned int max_state;
+	struct hlist_node hash;
+	struct rcu_head rcu;
+	u64 time_in_state[0];
+};
+
+/**
+ * struct cpu_freqs - per-cpu frequency information
+ * @offset: start of these freqs' stats in task time_in_state array
+ * @max_state: number of entries in freq_table
+ * @last_index: index in freq_table of last frequency switched to
+ * @freq_table: list of available frequencies
+ */
+struct cpu_freqs {
+	unsigned int offset;
+	unsigned int max_state;
+	unsigned int last_index;
+	unsigned int freq_table[0];
+};
+
+static struct cpu_freqs *all_freqs[NR_CPUS];
+
+static unsigned int next_offset;
+
+
+/* Caller must hold rcu_read_lock() */
+static struct uid_entry *find_uid_entry_rcu(uid_t uid)
+{
+	struct uid_entry *uid_entry;
+
+	hash_for_each_possible_rcu(uid_hash_table, uid_entry, hash, uid) {
+		if (uid_entry->uid == uid)
+			return uid_entry;
+	}
+	return NULL;
+}
+
+/* Caller must hold uid lock */
+static struct uid_entry *find_uid_entry_locked(uid_t uid)
+{
+	struct uid_entry *uid_entry;
+
+	hash_for_each_possible(uid_hash_table, uid_entry, hash, uid) {
+		if (uid_entry->uid == uid)
+			return uid_entry;
+	}
+	return NULL;
+}
+
+/* Caller must hold uid lock */
+static struct uid_entry *find_or_register_uid_locked(uid_t uid)
+{
+	struct uid_entry *uid_entry, *temp;
+	unsigned int max_state = READ_ONCE(next_offset);
+	size_t alloc_size = sizeof(*uid_entry) + max_state *
+		sizeof(uid_entry->time_in_state[0]);
+
+	uid_entry = find_uid_entry_locked(uid);
+	if (uid_entry) {
+		if (uid_entry->max_state == max_state)
+			return uid_entry;
+		/* uid_entry->time_in_state is too small to track all freqs, so
+		 * expand it.
+		 */
+		temp = __krealloc(uid_entry, alloc_size, GFP_ATOMIC);
+		if (!temp)
+			return uid_entry;
+		temp->max_state = max_state;
+		memset(temp->time_in_state + uid_entry->max_state, 0,
+		       (max_state - uid_entry->max_state) *
+		       sizeof(uid_entry->time_in_state[0]));
+		if (temp != uid_entry) {
+			hlist_replace_rcu(&uid_entry->hash, &temp->hash);
+			kfree_rcu(uid_entry, rcu);
+		}
+		return temp;
+	}
+
+	uid_entry = kzalloc(alloc_size, GFP_ATOMIC);
+	if (!uid_entry)
+		return NULL;
+
+	uid_entry->uid = uid;
+	uid_entry->max_state = max_state;
+
+	hash_add_rcu(uid_hash_table, &uid_entry->hash, uid);
+
+	return uid_entry;
+}
+
+static bool freq_index_invalid(unsigned int index)
+{
+	unsigned int cpu;
+	struct cpu_freqs *freqs;
+
+	for_each_possible_cpu(cpu) {
+		freqs = all_freqs[cpu];
+		if (!freqs || index < freqs->offset ||
+		    freqs->offset + freqs->max_state <= index)
+			continue;
+		return freqs->freq_table[index - freqs->offset] ==
+			CPUFREQ_ENTRY_INVALID;
+	}
+	return true;
+}
+
+static int single_uid_time_in_state_show(struct seq_file *m, void *ptr)
+{
+	struct uid_entry *uid_entry;
+	unsigned int i;
+	u64 time;
+	uid_t uid = from_kuid_munged(current_user_ns(), *(kuid_t *)m->private);
+
+	if (uid == overflowuid)
+		return -EINVAL;
+
+	rcu_read_lock();
+
+	uid_entry = find_uid_entry_rcu(uid);
+	if (!uid_entry) {
+		rcu_read_unlock();
+		return 0;
+	}
+
+	for (i = 0; i < uid_entry->max_state; ++i) {
+		if (freq_index_invalid(i))
+			continue;
+		time = cputime_to_clock_t(uid_entry->time_in_state[i]);
+		seq_write(m, &time, sizeof(time));
+	}
+
+	rcu_read_unlock();
+
+	return 0;
+}
+
+static void *uid_seq_start(struct seq_file *seq, loff_t *pos)
+{
+	if (*pos >= HASH_SIZE(uid_hash_table))
+		return NULL;
+
+	return &uid_hash_table[*pos];
+}
+
+static void *uid_seq_next(struct seq_file *seq, void *v, loff_t *pos)
+{
+	(*pos)++;
+
+	if (*pos >= HASH_SIZE(uid_hash_table))
+		return NULL;
+
+	return &uid_hash_table[*pos];
+}
+
+static void uid_seq_stop(struct seq_file *seq, void *v) { }
+
+static int uid_time_in_state_seq_show(struct seq_file *m, void *v)
+{
+	struct uid_entry *uid_entry;
+	struct cpu_freqs *freqs, *last_freqs = NULL;
+	int i, cpu;
+
+	if (v == uid_hash_table) {
+		seq_puts(m, "uid:");
+		for_each_possible_cpu(cpu) {
+			freqs = all_freqs[cpu];
+			if (!freqs || freqs == last_freqs)
+				continue;
+			last_freqs = freqs;
+			for (i = 0; i < freqs->max_state; i++) {
+				if (freqs->freq_table[i] ==
+				    CPUFREQ_ENTRY_INVALID)
+					continue;
+				seq_printf(m, " %d", freqs->freq_table[i]);
+			}
+		}
+		seq_putc(m, '\n');
+	}
+
+	rcu_read_lock();
+
+	hlist_for_each_entry_rcu(uid_entry, (struct hlist_head *)v, hash) {
+		if (uid_entry->max_state)
+			seq_printf(m, "%d:", uid_entry->uid);
+		for (i = 0; i < uid_entry->max_state; ++i) {
+			if (freq_index_invalid(i))
+				continue;
+			seq_printf(m, " %lu", (unsigned long)cputime_to_clock_t(
+					   uid_entry->time_in_state[i]));
+		}
+		if (uid_entry->max_state)
+			seq_putc(m, '\n');
+	}
+
+	rcu_read_unlock();
+	return 0;
+}
+
+void cpufreq_task_times_init(struct task_struct *p)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&task_time_in_state_lock, flags);
+	p->time_in_state = NULL;
+	spin_unlock_irqrestore(&task_time_in_state_lock, flags);
+	p->max_state = 0;
+}
+
+void cpufreq_task_times_alloc(struct task_struct *p)
+{
+	void *temp;
+	unsigned long flags;
+	unsigned int max_state = READ_ONCE(next_offset);
+
+	/* We use one array to avoid multiple allocs per task */
+	temp = kcalloc(max_state, sizeof(p->time_in_state[0]), GFP_ATOMIC);
+	if (!temp)
+		return;
+
+	spin_lock_irqsave(&task_time_in_state_lock, flags);
+	p->time_in_state = temp;
+	spin_unlock_irqrestore(&task_time_in_state_lock, flags);
+	p->max_state = max_state;
+}
+
+/* Caller must hold task_time_in_state_lock */
+static int cpufreq_task_times_realloc_locked(struct task_struct *p)
+{
+	void *temp;
+	unsigned int max_state = READ_ONCE(next_offset);
+
+	temp = krealloc(p->time_in_state, max_state * sizeof(u64), GFP_ATOMIC);
+	if (!temp)
+		return -ENOMEM;
+	p->time_in_state = temp;
+	memset(p->time_in_state + p->max_state, 0,
+	       (max_state - p->max_state) * sizeof(u64));
+	p->max_state = max_state;
+	return 0;
+}
+
+void cpufreq_task_times_exit(struct task_struct *p)
+{
+	unsigned long flags;
+	void *temp;
+
+	if (!p->time_in_state)
+		return;
+
+	spin_lock_irqsave(&task_time_in_state_lock, flags);
+	temp = p->time_in_state;
+	p->time_in_state = NULL;
+	spin_unlock_irqrestore(&task_time_in_state_lock, flags);
+	kfree(temp);
+}
+
+int proc_time_in_state_show(struct seq_file *m, struct pid_namespace *ns,
+	struct pid *pid, struct task_struct *p)
+{
+	unsigned int cpu, i;
+	cputime_t cputime;
+	unsigned long flags;
+	struct cpu_freqs *freqs;
+	struct cpu_freqs *last_freqs = NULL;
+
+	spin_lock_irqsave(&task_time_in_state_lock, flags);
+	for_each_possible_cpu(cpu) {
+		freqs = all_freqs[cpu];
+		if (!freqs || freqs == last_freqs)
+			continue;
+		last_freqs = freqs;
+
+		seq_printf(m, "cpu%u\n", cpu);
+		for (i = 0; i < freqs->max_state; i++) {
+			if (freqs->freq_table[i] == CPUFREQ_ENTRY_INVALID)
+				continue;
+			cputime = 0;
+			if (freqs->offset + i < p->max_state &&
+			    p->time_in_state)
+				cputime = p->time_in_state[freqs->offset + i];
+			seq_printf(m, "%u %lu\n", freqs->freq_table[i],
+				   (unsigned long)cputime_to_clock_t(cputime));
+		}
+	}
+	spin_unlock_irqrestore(&task_time_in_state_lock, flags);
+	return 0;
+}
+
+void cpufreq_acct_update_power(struct task_struct *p, cputime_t cputime)
+{
+	unsigned long flags;
+	unsigned int state;
+	struct uid_entry *uid_entry;
+	struct cpu_freqs *freqs = all_freqs[task_cpu(p)];
+	uid_t uid = from_kuid_munged(current_user_ns(), task_uid(p));
+
+	if (!freqs || p->flags & PF_EXITING)
+		return;
+
+	state = freqs->offset + READ_ONCE(freqs->last_index);
+
+	spin_lock_irqsave(&task_time_in_state_lock, flags);
+	if ((state < p->max_state || !cpufreq_task_times_realloc_locked(p)) &&
+	    p->time_in_state)
+		p->time_in_state[state] += cputime;
+	spin_unlock_irqrestore(&task_time_in_state_lock, flags);
+
+	spin_lock_irqsave(&uid_lock, flags);
+	uid_entry = find_or_register_uid_locked(uid);
+	if (uid_entry && state < uid_entry->max_state)
+		uid_entry->time_in_state[state] += cputime;
+	spin_unlock_irqrestore(&uid_lock, flags);
+}
+
+void cpufreq_times_create_policy(struct cpufreq_policy *policy)
+{
+	int cpu, index;
+	unsigned int count = 0;
+	struct cpufreq_frequency_table *pos, *table;
+	struct cpu_freqs *freqs;
+	void *tmp;
+
+	if (all_freqs[policy->cpu])
+		return;
+
+	table = policy->freq_table;
+	if (!table)
+		return;
+
+	cpufreq_for_each_entry(pos, table)
+		count++;
+
+	tmp =  kzalloc(sizeof(*freqs) + sizeof(freqs->freq_table[0]) * count,
+		       GFP_KERNEL);
+	if (!tmp)
+		return;
+
+	freqs = tmp;
+	freqs->max_state = count;
+
+	index = cpufreq_frequency_table_get_index(policy, policy->cur);
+	if (index >= 0)
+		WRITE_ONCE(freqs->last_index, index);
+
+	cpufreq_for_each_entry(pos, table)
+		freqs->freq_table[pos - table] = pos->frequency;
+
+	freqs->offset = next_offset;
+	WRITE_ONCE(next_offset, freqs->offset + count);
+	for_each_cpu(cpu, policy->related_cpus)
+		all_freqs[cpu] = freqs;
+}
+
+void cpufreq_task_times_remove_uids(uid_t uid_start, uid_t uid_end)
+{
+	struct uid_entry *uid_entry;
+	struct hlist_node *tmp;
+	unsigned long flags;
+
+	spin_lock_irqsave(&uid_lock, flags);
+
+	for (; uid_start <= uid_end; uid_start++) {
+		hash_for_each_possible_safe(uid_hash_table, uid_entry, tmp,
+			hash, uid_start) {
+			if (uid_start == uid_entry->uid) {
+				hash_del_rcu(&uid_entry->hash);
+				kfree_rcu(uid_entry, rcu);
+			}
+		}
+	}
+
+	spin_unlock_irqrestore(&uid_lock, flags);
+}
+
+void cpufreq_times_record_transition(struct cpufreq_freqs *freq)
+{
+	int index;
+	struct cpu_freqs *freqs = all_freqs[freq->cpu];
+	struct cpufreq_policy *policy;
+
+	if (!freqs)
+		return;
+
+	policy = cpufreq_cpu_get(freq->cpu);
+	if (!policy)
+		return;
+
+	index = cpufreq_frequency_table_get_index(policy, freq->new);
+	if (index >= 0)
+		WRITE_ONCE(freqs->last_index, index);
+
+	cpufreq_cpu_put(policy);
+}
+
+static const struct seq_operations uid_time_in_state_seq_ops = {
+	.start = uid_seq_start,
+	.next = uid_seq_next,
+	.stop = uid_seq_stop,
+	.show = uid_time_in_state_seq_show,
+};
+
+static int uid_time_in_state_open(struct inode *inode, struct file *file)
+{
+	return seq_open(file, &uid_time_in_state_seq_ops);
+}
+
+int single_uid_time_in_state_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, single_uid_time_in_state_show,
+			&(inode->i_uid));
+}
+
+static const struct file_operations uid_time_in_state_fops = {
+	.open		= uid_time_in_state_open,
+	.read		= seq_read,
+	.llseek		= seq_lseek,
+	.release	= seq_release,
+};
+
+static int __init cpufreq_times_init(void)
+{
+	proc_create_data("uid_time_in_state", 0444, NULL,
+			 &uid_time_in_state_fops, NULL);
+
+	return 0;
+}
+
+early_initcall(cpufreq_times_init);
diff --git a/drivers/cpufreq/cpufreq_userspace.c b/drivers/cpufreq/cpufreq_userspace.c
index bd897e3..765166d 100644
--- a/drivers/cpufreq/cpufreq_userspace.c
+++ b/drivers/cpufreq/cpufreq_userspace.c
@@ -118,7 +118,10 @@ static void cpufreq_userspace_policy_limits(struct cpufreq_policy *policy)
 	mutex_unlock(&userspace_mutex);
 }
 
-static struct cpufreq_governor cpufreq_gov_userspace = {
+#ifndef CONFIG_CPU_FREQ_DEFAULT_GOV_USERSPACE
+static
+#endif
+struct cpufreq_governor cpufreq_gov_userspace = {
 	.name		= "userspace",
 	.init		= cpufreq_userspace_policy_init,
 	.exit		= cpufreq_userspace_policy_exit,
diff --git a/drivers/cpuidle/Kconfig.arm b/drivers/cpuidle/Kconfig.arm
index 21340e0..f521448 100644
--- a/drivers/cpuidle/Kconfig.arm
+++ b/drivers/cpuidle/Kconfig.arm
@@ -4,6 +4,7 @@
 config ARM_CPUIDLE
         bool "Generic ARM/ARM64 CPU idle Driver"
         select DT_IDLE_STATES
+	select CPU_IDLE_MULTIPLE_DRIVERS
         help
           Select this to enable generic cpuidle driver for ARM.
           It provides a generic idle driver whose idle states are configured
diff --git a/drivers/cpuidle/cpuidle-arm.c b/drivers/cpuidle/cpuidle-arm.c
index f440d38..f47c545 100644
--- a/drivers/cpuidle/cpuidle-arm.c
+++ b/drivers/cpuidle/cpuidle-arm.c
@@ -18,6 +18,7 @@
 #include <linux/module.h>
 #include <linux/of.h>
 #include <linux/slab.h>
+#include <linux/topology.h>
 
 #include <asm/cpuidle.h>
 
@@ -44,7 +45,7 @@ static int arm_enter_idle_state(struct cpuidle_device *dev,
 	return CPU_PM_CPU_IDLE_ENTER(arm_cpuidle_suspend, idx);
 }
 
-static struct cpuidle_driver arm_idle_driver = {
+static struct cpuidle_driver arm_idle_driver __initdata = {
 	.name = "arm_idle",
 	.owner = THIS_MODULE,
 	/*
@@ -80,30 +81,42 @@ static int arm_enter_idle_state(struct cpuidle_device *dev,
 static int __init arm_idle_init(void)
 {
 	int cpu, ret;
-	struct cpuidle_driver *drv = &arm_idle_driver;
+	struct cpuidle_driver *drv;
 	struct cpuidle_device *dev;
 
-	/*
-	 * Initialize idle states data, starting at index 1.
-	 * This driver is DT only, if no DT idle states are detected (ret == 0)
-	 * let the driver initialization fail accordingly since there is no
-	 * reason to initialize the idle driver if only wfi is supported.
-	 */
-	ret = dt_init_idle_driver(drv, arm_idle_state_match, 1);
-	if (ret <= 0)
-		return ret ? : -ENODEV;
-
-	ret = cpuidle_register_driver(drv);
-	if (ret) {
-		pr_err("Failed to register cpuidle driver\n");
-		return ret;
-	}
-
-	/*
-	 * Call arch CPU operations in order to initialize
-	 * idle states suspend back-end specific data
-	 */
 	for_each_possible_cpu(cpu) {
+
+		drv = kmemdup(&arm_idle_driver, sizeof(*drv), GFP_KERNEL);
+		if (!drv) {
+			ret = -ENOMEM;
+			goto out_fail;
+		}
+
+		drv->cpumask = (struct cpumask *)cpumask_of(cpu);
+
+		/*
+		 * Initialize idle states data, starting at index 1.  This
+		 * driver is DT only, if no DT idle states are detected (ret
+		 * == 0) let the driver initialization fail accordingly since
+		 * there is no reason to initialize the idle driver if only
+		 * wfi is supported.
+		 */
+		ret = dt_init_idle_driver(drv, arm_idle_state_match, 1);
+		if (ret <= 0) {
+			ret = ret ? : -ENODEV;
+			goto out_kfree_drv;
+		}
+
+		ret = cpuidle_register_driver(drv);
+		if (ret) {
+			pr_err("Failed to register cpuidle driver\n");
+			goto out_kfree_drv;
+		}
+
+		/*
+		 * Call arch CPU operations in order to initialize
+		 * idle states suspend back-end specific data
+		 */
 		ret = arm_cpuidle_init(cpu);
 
 		/*
@@ -115,14 +128,14 @@ static int __init arm_idle_init(void)
 
 		if (ret) {
 			pr_err("CPU %d failed to init idle CPU ops\n", cpu);
-			goto out_fail;
+			goto out_unregister_drv;
 		}
 
 		dev = kzalloc(sizeof(*dev), GFP_KERNEL);
 		if (!dev) {
 			pr_err("Failed to allocate cpuidle device\n");
 			ret = -ENOMEM;
-			goto out_fail;
+			goto out_unregister_drv;
 		}
 		dev->cpu = cpu;
 
@@ -130,21 +143,28 @@ static int __init arm_idle_init(void)
 		if (ret) {
 			pr_err("Failed to register cpuidle device for CPU %d\n",
 			       cpu);
-			kfree(dev);
-			goto out_fail;
+			goto out_kfree_dev;
 		}
 	}
 
 	return 0;
+
+out_kfree_dev:
+	kfree(dev);
+out_unregister_drv:
+	cpuidle_unregister_driver(drv);
+out_kfree_drv:
+	kfree(drv);
 out_fail:
 	while (--cpu >= 0) {
 		dev = per_cpu(cpuidle_devices, cpu);
+		drv = cpuidle_get_cpu_driver(dev);
 		cpuidle_unregister_device(dev);
+		cpuidle_unregister_driver(drv);
 		kfree(dev);
+		kfree(drv);
 	}
 
-	cpuidle_unregister_driver(drv);
-
 	return ret;
 }
 device_initcall(arm_idle_init);
diff --git a/drivers/cpuidle/cpuidle.c b/drivers/cpuidle/cpuidle.c
index 35237c8..439f460 100644
--- a/drivers/cpuidle/cpuidle.c
+++ b/drivers/cpuidle/cpuidle.c
@@ -193,7 +193,7 @@ int cpuidle_enter_state(struct cpuidle_device *dev, struct cpuidle_driver *drv,
 	}
 
 	/* Take note of the planned idle state. */
-	sched_idle_set_state(target_state);
+	sched_idle_set_state(target_state, index);
 
 	trace_cpu_idle_rcuidle(index, dev->cpu);
 	time_start = ns_to_ktime(local_clock());
@@ -206,7 +206,7 @@ int cpuidle_enter_state(struct cpuidle_device *dev, struct cpuidle_driver *drv,
 	trace_cpu_idle_rcuidle(PWR_EVENT_EXIT, dev->cpu);
 
 	/* The cpu is no longer idle or about to enter idle. */
-	sched_idle_set_state(NULL);
+	sched_idle_set_state(NULL, -1);
 
 	if (broadcast) {
 		if (WARN_ON_ONCE(!irqs_disabled()))
diff --git a/drivers/cpuidle/governors/menu.c b/drivers/cpuidle/governors/menu.c
index 03d38c2..65bb6fd 100644
--- a/drivers/cpuidle/governors/menu.c
+++ b/drivers/cpuidle/governors/menu.c
@@ -178,7 +178,12 @@ static inline int performance_multiplier(unsigned long nr_iowaiters, unsigned lo
 
 	/* for higher loadavg, we are more reluctant */
 
-	mult += 2 * get_loadavg(load);
+	/*
+	 * this doesn't work as intended - it is almost always 0, but can
+	 * sometimes, depending on workload, spike very high into the hundreds
+	 * even when the average cpu load is under 10%.
+	 */
+	/* mult += 2 * get_loadavg(); */
 
 	/* for IO wait tasks (per cpu!) we add 5x each */
 	mult += 10 * nr_iowaiters;
diff --git a/drivers/crypto/Makefile b/drivers/crypto/Makefile
index ad7250f..22e4caa 100644
--- a/drivers/crypto/Makefile
+++ b/drivers/crypto/Makefile
@@ -32,3 +32,4 @@ obj-$(CONFIG_CRYPTO_DEV_VMX) += vmx/
 obj-$(CONFIG_CRYPTO_DEV_SUN4I_SS) += sunxi-ss/
 obj-$(CONFIG_CRYPTO_DEV_ROCKCHIP) += rockchip/
 obj-$(CONFIG_CRYPTO_DEV_CHELSIO) += chelsio/
+obj-$(CONFIG_CRYPTO_DEV_RTK) += rtk/
diff --git a/drivers/crypto/rtk/Makefile b/drivers/crypto/rtk/Makefile
new file mode 100644
index 00000000..d11cd8c
--- /dev/null
+++ b/drivers/crypto/rtk/Makefile
@@ -0,0 +1 @@
+obj-$(CONFIG_CRYPTO_DEV_RTK) += rtk_crypto.o
diff --git a/drivers/crypto/rtk/rtk_crypto.c b/drivers/crypto/rtk/rtk_crypto.c
new file mode 100644
index 00000000..644fea1
--- /dev/null
+++ b/drivers/crypto/rtk/rtk_crypto.c
@@ -0,0 +1,1619 @@
+/*
+ * rtk_crypto.c - MCP driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+#include <linux/cpufeature.h>
+#include <linux/crypto.h>
+#include <linux/module.h>
+
+#include <linux/moduleparam.h>
+#include <linux/init.h>
+#include <linux/platform_device.h>
+#include <linux/fs.h>
+#include <linux/cdev.h>
+#include <linux/dma-mapping.h>
+#include <linux/device.h>
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/uaccess.h>
+#include <linux/compat.h>
+#include <linux/io.h>
+#include <asm/mutex.h>
+
+#include "asm/cacheflush.h"
+
+#include <crypto/ablk_helper.h>
+#include <crypto/algapi.h>
+
+#include <crypto/sha.h>
+#include <crypto/sha256_base.h>
+
+#include "rtk_crypto.h"
+
+static void __iomem *RTK_MCP_BASE;
+static void __iomem *RTK_CRT_BASE;
+
+static DEFINE_SPINLOCK(mcp_buffer_lock);
+static DEFINE_MUTEX(mcp_mutex);
+
+static struct platform_device* local_pdev;
+
+MODULE_DESCRIPTION("rtk rtd1xxx Crypto Extensions");
+MODULE_AUTHOR("Aaron Lin<aaron.lin@realtek.com>");
+MODULE_LICENSE("GPL v2");
+
+#define DEVNAME "rtk_crypto_mcp"
+
+#define DYN_ALLOC 1
+
+extern void aes_cipher_encrypt(struct crypto_tfm *tfm, u8 dst[], u8 const src[]);
+extern void aes_cipher_decrypt(struct crypto_tfm *tfm, u8 dst[], u8 const src[]);
+
+static unsigned long sha256_data_dma_vaddr;
+static dma_addr_t sha256_data_dma_phyaddr;
+
+static dma_addr_t sha256_padding_dma_phyaddr;
+
+static unsigned int update_count=0;
+static unsigned long last_len;
+
+/*------------------------------------------------------------------
+ * Func : _mcp_phy_init
+ * Desc : init mcp engine
+ * Parm : N/A
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+static int crypto__mcp_phy_init(void)
+{
+#ifdef CONFIG_ARCH_RTD139x
+	unsigned int cur_value;
+#endif
+
+
+	//_mcp_load_otp();
+	SET_MCP_CTRL(MCP_GO, RTK_MCP_BASE); // dessert go bit
+	SET_MCP_EN(0xFE, RTK_MCP_BASE); // disable all interrupts
+	SET_MCP_STATUS(0xFE, RTK_MCP_BASE); // clear interrupts status
+	SET_MCP_BASE (0, RTK_MCP_BASE);
+	SET_MCP_LIMIT(0, RTK_MCP_BASE);
+	SET_MCP_RDPTR(0, RTK_MCP_BASE);
+	SET_MCP_WRPTR(0, RTK_MCP_BASE);
+
+#ifdef CONFIG_ARCH_RTD139x
+	/* auto power management */
+	cur_value = GET_PWM_CTRL(RTK_MCP_BASE);
+	cur_value |= (1 << 22) | (1 << 23) | (1 << 24) | (1 << 25) | (1 << 27) | (1 << 28);
+	SET_PWM_CTRL(cur_value, RTK_MCP_BASE);
+#endif
+
+	return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mcp_init
+ * Desc : init mcp engine
+ * Parm : N/A
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+static int crypto_mcp_init(void)
+{
+	if (crypto__mcp_phy_init()<0)
+		return -1;
+
+#if 0//def MCP_INTERRUPT_ENABLE
+	if (request_irq(MCP_IRQ, mcp_isr, SA_INTERRUPT | SA_SHIRQ, "MCP", &mcp_wait_queue) < 0){
+		mcp_warning("Request irq %d failed\n", MCP_IRQ);
+		return -ENODEV;
+	}
+#endif
+
+	return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mcp_uninit
+ * Desc : uninit mcp engine
+ * Parm : N/A
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+static void crypto_mcp_uninit(void)
+{
+	SET_MCP_CTRL(MCP_GO, RTK_MCP_BASE); // dessert go bit
+	SET_MCP_EN(0xFE, RTK_MCP_BASE); // disable all interrupts
+	msleep_interruptible(10); // wait for hw stop
+	SET_MCP_BASE (0, RTK_MCP_BASE);
+	SET_MCP_LIMIT(0, RTK_MCP_BASE);
+	SET_MCP_RDPTR(0, RTK_MCP_BASE);
+	SET_MCP_WRPTR(0, RTK_MCP_BASE);
+#if 0 //def MCP_INTERRUPT_ENABLE
+	free_irq(MCP_IRQ, &mcp_wait_queue);
+#endif
+}
+
+/*---------------------------------------------------------------------- 
+ * Func : mcp_dump_mem 
+ * Desc : dump data in memory
+ * Parm : data : start address of data
+ * len : length of data
+ * Retn : N/A
+ *----------------------------------------------------------------------*/ 
+void crypto_mcp_dump_mem(unsigned char* data, unsigned int len)
+{
+	int i;
+	for (i = 0 ; i < len ; i++){
+		if ((i & 0xF)==0)
+			mcp_info("\n %04x | ", i);
+		mcp_info("%02x ", data[i]);
+	}
+	mcp_info("\n");
+}
+
+/*---------------------------------------------------------------------- 
+ * Func : mcp_dump_all_registers 
+ * Desc : dump mcp registers
+ * Parm : N/A
+ * Retn : N/A
+ *----------------------------------------------------------------------*/ 
+void crypto_mcp_dump_all_registers(void)
+{
+	mcp_info("****** MCP Registers ******\n");
+	mcp_info("MCP_CTRL addr:0x%x, value:0x%x\n", MCP_CTRL, GET_MCP_CTRL(RTK_MCP_BASE));
+	mcp_info("MCP_STATUS addr:0x%x, value:0x%x\n", MCP_STATUS, GET_MCP_STATUS(RTK_MCP_BASE));
+	mcp_info("MCP_EN addr:0x%x, value:0x%x\n", MCP_EN, GET_MCP_EN(RTK_MCP_BASE));
+	mcp_info("MCP_BASE addr:0x%p, value:0x%x\n", RTK_MCP_BASE, GET_MCP_BASE(RTK_MCP_BASE));
+	mcp_info("MCP_LIMIT addr:0x%x, value:0x%x\n", MCP_LIMIT, GET_MCP_LIMIT(RTK_MCP_BASE));
+	mcp_info("MCP_RDPTR addr:0x%x, value:0x%x\n", MCP_RDPTR, GET_MCP_RDPTR(RTK_MCP_BASE));
+	mcp_info("MCP_WRPTR addr:0x%x, value:0x%x\n", MCP_WRPTR, GET_MCP_WRPTR(RTK_MCP_BASE));
+	mcp_info("MCP_DES_COUNT addr:0x%x, value:0x%x\n", MCP_DES_COUNT, GET_MCP_DES_COUNT(RTK_MCP_BASE));
+	mcp_info("MCP_DES_COMPARE addr:0x%x, value:0x%x\n", MCP_DES_COMPARE, GET_MCP_DES_COMPARE(RTK_MCP_BASE));
+}
+
+/*---------------------------------------------------------------------- 
+ * Func : mcp_dump_descriptor 
+ * Desc : dump mcp descriptor
+ * Parm : p_desc: pointer  to descriptor
+ * Retn : N/A
+ *----------------------------------------------------------------------*/ 
+void crypto_mcp_dump_descriptor(mcp_desc *p_desc)
+{
+	int i = 0;
+
+	mcp_info("****** MCP Descriptor ******\n");
+	mcp_info("p_desc->flags:0x%0x\n", p_desc->flags);
+
+	for(i = 0 ; i < sizeof(p_desc->key)/sizeof(p_desc->key[0]) ; i++){
+		mcp_info("p_desc->key[%d]:0x%0x\n", i, p_desc->key[i]);
+	}
+
+	for(i = 0 ; i < sizeof(p_desc->iv)/sizeof(p_desc->iv[0]) ; i++){
+		mcp_info("p_desc->iv[%d]:0x%0x\n", i, p_desc->iv[i]);
+	}
+
+	mcp_info("p_desc->data_in:0x%0x\n", p_desc->data_in);
+	mcp_info("p_desc->data_out:0x%0x\n", p_desc->data_out);
+	mcp_info("p_desc->length:0x%0x\n", p_desc->length);
+}
+
+/*------------------------------------------------------------------ 
+ * Func : _mcp_set_desc_buffer
+ * Desc : set descriptors buffer
+ * Parm : base  : base address of descriptor buffer
+ * limit : limit address of descriptor buffer
+ * rp : read pointer of descriptor buffer
+ * wp : write pointer of descriptor buffer
+ * Retn : 0
+ *------------------------------------------------------------------*/
+int crypto__mcp_set_desc_buffer(unsigned long	 base, unsigned long limit, unsigned long rp, unsigned long wp)
+{
+	unsigned long event;
+
+	spin_lock_irqsave(&mcp_buffer_lock, event);
+	SET_MCP_BASE (base, RTK_MCP_BASE);
+	SET_MCP_LIMIT(limit, RTK_MCP_BASE);
+	SET_MCP_RDPTR(rp, RTK_MCP_BASE);
+	SET_MCP_WRPTR(wp, RTK_MCP_BASE);
+	spin_unlock_irqrestore(&mcp_buffer_lock, event);
+
+	return 0;
+}
+
+/*------------------------------------------------------------------ 
+ * Func : _mcp_start_xfer
+ * Desc : Start Xfer
+ * Parm : N/A
+ * Retn : S_OK /  S_FALSE 
+ *------------------------------------------------------------------*/
+int crypto__mcp_start_xfer(void)
+{
+	int ret = -1;
+	int WaitTime = 0x3FF << 2;
+	int wiat_clear_timeout = 0;
+
+	SET_MCP_DES_COUNT(0x0, RTK_MCP_BASE);   // descriptor in ddr
+	SET_MCP_CTRL(MCP_CLEAR | MCP_WRITE_DATA, RTK_MCP_BASE);	// issue clear
+
+	while ((GET_MCP_CTRL(RTK_MCP_BASE) & MCP_CLEAR) && wiat_clear_timeout++ < 30);
+
+	if (GET_MCP_CTRL(RTK_MCP_BASE) & MCP_CLEAR){
+		mcp_warning("wait clear bit deassert timeout,  force unset clear bit, (CTRL=%08x, STATUS=%08x)\n", GET_MCP_CTRL(RTK_MCP_BASE), GET_MCP_STATUS(RTK_MCP_BASE));
+		SET_MCP_CTRL(MCP_CLEAR, RTK_MCP_BASE);	// issue clear
+		mcp_warning("CTRL=%08x, STATUS=%08x)\n",GET_MCP_CTRL(RTK_MCP_BASE), GET_MCP_STATUS(RTK_MCP_BASE));
+	}
+
+	SET_MCP_EN(0xFE, RTK_MCP_BASE);
+	SET_MCP_STATUS(0xFE, RTK_MCP_BASE);	// clear status
+
+	mcp_info("before go:\n");
+	crypto_mcp_dump_all_registers();
+
+	SET_MCP_CTRL(MCP_GO | MCP_WRITE_DATA, RTK_MCP_BASE);
+
+	while (WaitTime--){
+		mcp_debug("STATUS=%08x, CTRL=%08x\n",GET_MCP_STATUS(RTK_MCP_BASE), GET_MCP_CTRL(RTK_MCP_BASE));
+		if (!(GET_MCP_CTRL(RTK_MCP_BASE) & MCP_GO)) {
+			mcp_info("ctrl break\n");
+			break;
+		}
+
+		if (GET_MCP_STATUS(RTK_MCP_BASE)&0x6) {
+			mcp_info("status break\n");
+			break;
+		}
+
+		//msleep_interruptible(1);
+		//msleep(1);
+	}
+#ifdef CONFIG_ARCH_RTD16xx
+	ret = ((GET_MCP_STATUS(RTK_MCP_BASE) & ~(MCP_RING_EMPTY | MCP_COMPARE|MCP_KL_DONE|MCP_K_KL_DONE))) ? -1 : 0;
+#else
+	ret = ((GET_MCP_STATUS(RTK_MCP_BASE) & ~(MCP_RING_EMPTY | MCP_COMPARE))) ? -1 : 0;
+#endif
+	mcp_info("after go:\n");
+	crypto_mcp_dump_all_registers();
+
+	if (ret <0)
+		mcp_warning("do mcp command failed, (MCP_Status %08x)\n", GET_MCP_STATUS(RTK_MCP_BASE));
+
+	SET_MCP_CTRL(MCP_GO, RTK_MCP_BASE); // clear go bit
+	SET_MCP_STATUS(0xFE, RTK_MCP_BASE); // clear ring empty
+
+	return ret;
+}
+
+/*------------------------------------------------------------------ 
+ * Func : mcp_do_command 
+ * Desc : Do Command
+ * Parm : p_desc : number of Descriptor to be Execute
+ * n_desc : number of Descriptor to be Execute
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+int crypto_mcp_do_command(mcp_desc* p_desc, int n_desc)
+{
+	int	 ret = 0;
+	int	 len = sizeof(mcp_desc) * n_desc;
+
+	int	 i, j;
+	unsigned long desc_dma_vaddr;
+          unsigned long data_out_vaddr;
+	dma_addr_t desc_dma;
+	mcp_desc *p_desc_vaddr;
+
+	if(n_desc){
+		mutex_lock(&mcp_mutex);
+
+		desc_dma_vaddr = (unsigned long)dma_alloc_coherent(&local_pdev->dev, n_desc * sizeof(mcp_desc) + sizeof(mcp_desc), &desc_dma, GFP_ATOMIC|GFP_DMA);
+		//desc_dma_vaddr = kmalloc(n_desc * sizeof(mcp_desc) + sizeof(mcp_desc), GFP_KERNEL);
+		if (desc_dma_vaddr){
+
+			p_desc_vaddr = (mcp_desc *)desc_dma_vaddr;
+
+			for (i = 0; i < n_desc ; i++){
+				p_desc_vaddr->flags = p_desc->flags;
+
+				for (j = 0 ; j < sizeof(p_desc->key) / sizeof(p_desc->key[0]) ; j++) {
+					p_desc_vaddr->key[j] = p_desc->key[j];
+				}
+
+				for (j = 0 ; j < sizeof(p_desc->iv) / sizeof(p_desc->iv[0]) ; j++) {
+					p_desc_vaddr->iv[j] = p_desc->iv[j];
+				}
+
+				//p_desc_vaddr->data_in = virt_to_phys(p_desc->data_in);
+				//p_desc_vaddr->data_out = virt_to_phys(p_desc->data_out);
+				p_desc_vaddr->data_in = p_desc->data_in;
+				p_desc_vaddr->data_out = p_desc->data_out;
+				p_desc_vaddr->length = p_desc->length;
+#if 1//def MCP_DEBUG_EN
+				__flush_dcache_area(p_desc_vaddr, sizeof(mcp_desc)*2);
+				crypto_mcp_dump_descriptor(p_desc_vaddr);
+#else
+				mcp_info("Do command, flags:0x%0x\n", p_desc->flags);
+#endif
+				p_desc_vaddr++;
+				p_desc++;
+			}
+
+			p_desc_vaddr = p_desc_vaddr - n_desc;
+			p_desc = p_desc - n_desc;
+
+			crypto__mcp_set_desc_buffer(desc_dma, desc_dma + len + sizeof(mcp_desc), desc_dma, desc_dma + len);
+			ret = crypto__mcp_start_xfer();
+		}else{
+			mcp_warning("no dma buffer for descriptor!\n");
+			ret = -1;   // error, no dma buffer for descriptor
+		}
+                    //crypto_mcp_dump_mem((unsigned char *)p_desc->data_out, 16);
+                    //__flush_dcache_area(p_desc_vaddr->data_out, p_desc_vaddr->length);
+		dma_free_coherent(&local_pdev->dev, n_desc * sizeof(mcp_desc), (void *)desc_dma_vaddr, desc_dma);
+
+		mutex_unlock(&mcp_mutex);
+	}
+
+	return ret;
+}
+
+/********************************************************************************
+ AES
+ ********************************************************************************/
+/*------------------------------------------------------------------
+ * Func : MCP_AES_DESC_INIT
+ * Desc : Init AES Descriptor
+ * Parm : pDesc : Descriptor to be Load
+ * EnDe : Encryption/Descryption
+ * 0 for Decryption / 1 for Encryption
+ * Mode : Operation Mode
+ * Key : Key Value
+ * IV : Initial Vector
+ * Retn : S_OK /  S_FALSE 
+ *------------------------------------------------------------------*/
+int crypto_MCP_AES_DESC_INIT(mcp_desc*	 pDesc, unsigned char EnDe, unsigned char Mode, unsigned char Key[32], unsigned char IV[16], unsigned int key_len)
+{
+	memset(pDesc, 0, sizeof(mcp_desc));
+
+	switch (Mode){
+	case MCP_BCM_ECB:
+	case MCP_BCM_CBC:
+	case MCP_BCM_CTR:
+		pDesc->flags = MARS_MCP_MODE(MCP_ALGO_AES) | MARS_MCP_BCM(Mode) | MARS_MCP_ENC(EnDe);
+
+		if(Key){
+
+                              if(key_len<32){
+			pDesc->key[0]  = (Key[ 0]<<24) + (Key[ 1]<<16) + (Key[ 2]<<8) + Key[ 3];
+			pDesc->key[1]  = (Key[ 4]<<24) + (Key[ 5]<<16) + (Key[ 6]<<8) + Key[ 7];
+			pDesc->key[2]  = (Key[ 8]<<24) + (Key[ 9]<<16) + (Key[10]<<8) + Key[11];
+			pDesc->key[3]  = (Key[12]<<24) + (Key[13]<<16) + (Key[14]<<8) + Key[15];
+                                }
+
+                              if(key_len == 24){
+                                        //printk(KERN_ERR "*************alg: crypto_MCP_AES_DESC_INIT, len: %d\n", key_len);
+                                        pDesc->flags |= 0x18;
+            			pDesc->key[4]  = (Key[ 16]<<24) + (Key[ 17]<<16) + (Key[ 18]<<8) + Key[ 19];
+            			pDesc->key[5]  = (Key[ 20]<<24) + (Key[ 21]<<16) + (Key[ 22]<<8) + Key[ 23];
+                              }else if(key_len == 32){
+
+                                        //printk(KERN_ERR "*************alg: crypto_MCP_AES_DESC_INIT, len: %d\n", key_len);
+                                        pDesc->flags |= 0x3010;
+                                        pDesc->key[0]  = (unsigned int)Key;
+                              }
+		}else
+			pDesc->flags |= MARS_MCP_KEY_SEL(MCP_KEY_SEL_OTP);
+
+		if(IV){
+			pDesc->iv[0]   = (IV[ 0]<<24) + (IV[ 1]<<16) + (IV[ 2]<<8) + IV[ 3];
+			pDesc->iv[1]   = (IV[ 4]<<24) + (IV[ 5]<<16) + (IV[ 6]<<8) + IV[ 7];
+			pDesc->iv[2]   = (IV[ 8]<<24) + (IV[ 9]<<16) + (IV[10]<<8) + IV[11];
+			pDesc->iv[3]   = (IV[12]<<24) + (IV[13]<<16) + (IV[14]<<8) + IV[15];
+		}
+		return 0;
+	default:
+		mcp_warning("Init AES descriptor failed - invalid mode (%d)\n", Mode);
+		return -1;
+	}
+}
+
+/*------------------------------------------------------------------
+ * Func : MCP_AES_Decryption
+ * Desc : Do AES Decryption
+ * Parm : mode : Operation Mode
+ * key : Key Value
+ * iv : Initial Vector
+ * p_in : Data In
+ * p_out : Data Out
+ * len : Data Length
+ * Retn : 0 for success, others failed
+ *------------------------------------------------------------------*/
+int crypto_MCP_AES_Decryption(unsigned char mode, unsigned char key[16], unsigned char iv[16], unsigned char* p_in, unsigned char* p_out, unsigned long len, unsigned int key_len)
+{
+	mcp_desc desc;
+	int ret;
+
+	unsigned long data_dma_vaddr=NULL;
+	dma_addr_t data_dma_phyaddr;
+	unsigned char *pData = NULL;
+	int i = 0;
+
+	unsigned long key_dma_vaddr=NULL;
+	dma_addr_t key_dma_phyaddr;
+	unsigned char *pKey = NULL;
+          unsigned char tmp_iv[16];
+	//int i = 0;
+
+	data_dma_vaddr = (unsigned long)dma_alloc_coherent(&local_pdev->dev, len, &data_dma_phyaddr, GFP_ATOMIC|GFP_DMA);
+
+	if (data_dma_vaddr) {
+		pData = (unsigned char *)data_dma_vaddr;
+
+		for (i = 0; i < len; i++) {
+			pData[i] = p_in[i];
+		}
+
+                if(iv && mode==MCP_BCM_CBC){ //update for next iv
+		for (i = 0; i < 16; i++) {
+			 tmp_iv[i]=pData[len-16+i];
+		}
+                }
+		//mcp_dump_data_with_text(pData, 16, "decrypted value : ");
+	}else{
+		mcp_warning("test dma alloc fail");
+	}
+
+
+         if(key_len==32){
+            	key_dma_vaddr = (unsigned long)dma_alloc_coherent(&local_pdev->dev, key_len, &key_dma_phyaddr, GFP_ATOMIC|GFP_DMA);
+
+            	if (key_dma_vaddr) {
+            		pKey = (unsigned char *)key_dma_vaddr;
+
+            		for (i = 0; i < key_len; i++) {
+            			pKey[i] = key[i];
+            		}
+            		//mcp_dump_data_with_text(pKey, key_len, "decrypted key : ");
+            	}else{
+            		mcp_warning("test key dma alloc fail");
+            	}
+
+                    crypto_MCP_AES_DESC_INIT(&desc, 0, mode, (unsigned char *)key_dma_phyaddr, iv, key_len);
+         }else{
+	            crypto_MCP_AES_DESC_INIT(&desc, 0, mode, key, iv, key_len);
+         }
+
+	desc.data_in = data_dma_phyaddr;
+	desc.data_out = data_dma_phyaddr;
+	//desc.length = len & ~0xF;
+	desc.length = len;
+
+	ret = crypto_mcp_do_command(&desc, 1);
+	//printk(KERN_ERR "*************alg: crypto_MCP_AES_Decryption, ret: %d\n",ret);
+		for (i = 0; i < len; i++) {
+			 p_out[i]=pData[i];
+		}
+
+                if(iv && mode==MCP_BCM_CBC){ //update for next iv
+		for (i = 0; i < 16; i++) {
+			 iv[i]=tmp_iv[i];
+		}
+                }
+
+            dma_free_coherent(&local_pdev->dev, len, (void *)data_dma_vaddr, data_dma_phyaddr);
+
+            if(key_dma_vaddr){
+                        mcp_warning("free key dma alloc");
+                        dma_free_coherent(&local_pdev->dev, key_len, (void *)key_dma_vaddr, key_dma_phyaddr);
+            }
+	return ret;
+}
+
+/*------------------------------------------------------------------
+ * Func : MCP_AES_Encryption
+ * Desc : Do AES Encryption
+ * Parm : mode : Operation Mode
+ * key : Key Value
+ * iv : Initial Vector
+ * p_in : Data In
+ * p_out : Data Out
+ * len : Data Length
+ * Retn : 0 for success, others failed
+ *------------------------------------------------------------------*/
+int crypto_MCP_AES_Encryption(unsigned char mode, unsigned char key[16], unsigned char iv[16], unsigned char* p_in, unsigned char* p_out, unsigned long len, unsigned int key_len)
+{
+	mcp_desc desc;
+	int ret;
+
+	unsigned long data_dma_vaddr=NULL;
+	dma_addr_t data_dma_phyaddr;
+	unsigned char *pData = NULL;
+	int i = 0;
+
+	unsigned long key_dma_vaddr=NULL;
+	dma_addr_t key_dma_phyaddr;
+	unsigned char *pKey = NULL;
+	//int i = 0;
+
+	data_dma_vaddr = (unsigned long)dma_alloc_coherent(&local_pdev->dev, len, &data_dma_phyaddr, GFP_ATOMIC|GFP_DMA);
+
+	if (data_dma_vaddr) {
+		pData = (unsigned char *)data_dma_vaddr;
+
+		for (i = 0; i < len; i++) {
+			pData[i] = p_in[i];
+		}
+		//mcp_dump_data_with_text(pData, 16, "decrypted value : ");
+	}else{
+		mcp_warning("test dma alloc fail");
+	}
+
+
+         if(key_len==32){ //for aes 256
+            	key_dma_vaddr = (unsigned long)dma_alloc_coherent(&local_pdev->dev, key_len, &key_dma_phyaddr, GFP_ATOMIC|GFP_DMA);
+
+            	if (key_dma_vaddr) {
+            		pKey = (unsigned char *)key_dma_vaddr;
+
+            		for (i = 0; i < key_len; i++) {
+            			pKey[i] = key[i];
+            		}
+            		//mcp_dump_data_with_text(pKey, key_len, "decrypted key : ");
+            	}else{
+            		mcp_warning("test key dma alloc fail");
+            	}
+
+                    crypto_MCP_AES_DESC_INIT(&desc, 1, mode, (unsigned char *)key_dma_phyaddr, iv, key_len);
+         }else{
+                    crypto_MCP_AES_DESC_INIT(&desc, 1, mode, key, iv, key_len);
+         }
+
+	desc.data_in = data_dma_phyaddr;
+	desc.data_out = data_dma_phyaddr;
+	//desc.length = len & ~0xF;
+	desc.length = len;
+
+	ret = crypto_mcp_do_command(&desc, 1);
+	//printk(KERN_ERR "*************alg: crypto_MCP_AES_Encryption, ret: %d\n",ret);
+		for (i = 0; i < len; i++) {
+			 p_out[i]=pData[i];
+		}
+
+        if(iv && mode==MCP_BCM_CBC){ //update for next iv
+		for (i = 0; i < 16; i++) {
+			 iv[i]=pData[len-16+i];
+		}
+        }
+
+            dma_free_coherent(&local_pdev->dev, len, (void *)data_dma_vaddr, data_dma_phyaddr);
+
+            if(key_dma_vaddr){
+                        mcp_warning("free key dma alloc");
+                        dma_free_coherent(&local_pdev->dev, key_len, (void *)key_dma_vaddr, key_dma_phyaddr);
+            }
+	return ret;
+}
+
+/*------------------------------------------------------------------ 
+ * Func : MCP_AES_128_ECB_DataEncryptTest
+ * Desc : Test AES 128 ECB
+ * Parm : N/A
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void crypto_MCP_AES_128_ECB_DataEncryptTest(void)
+{
+	unsigned char Data[16]={0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88,
+										 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff, 0x00};
+	unsigned char Key[16];
+
+	unsigned long data_dma_vaddr;
+	dma_addr_t data_dma_phyaddr;
+	unsigned char *pData = NULL;
+	int i = 0;
+
+	data_dma_vaddr = (unsigned long)dma_alloc_coherent(&local_pdev->dev, sizeof(Data), &data_dma_phyaddr, GFP_ATOMIC|GFP_DMA);
+
+	if (data_dma_vaddr) {
+		memset(Key, 'b', sizeof(Key));
+
+		pData = (unsigned char *)data_dma_vaddr;
+
+		for (i = 0; i < sizeof(Data); i++) {
+			pData[i] = Data[i];
+		}
+
+		crypto_MCP_AES_Encryption(MCP_BCM_ECB, Key,NULL, (unsigned char *)data_dma_phyaddr, (unsigned char *)data_dma_phyaddr, 16, 16);
+
+		mcp_dump_data_with_text(pData, 16, "encrypted value : ");
+
+		crypto_MCP_AES_Decryption(MCP_BCM_ECB, Key,NULL, (unsigned char *)data_dma_phyaddr, (unsigned char *)data_dma_phyaddr, 16, 16);
+
+		mcp_dump_data_with_text(pData, 16, "decrypted value : ");
+	}else{
+		mcp_warning("test dma alloc fail");
+	}
+
+	dma_free_coherent(&local_pdev->dev, sizeof(Data), (void *)data_dma_vaddr, data_dma_phyaddr);
+}
+
+static int rtk_mcp_aes_ecb_cipher_encrypt(struct blkcipher_desc *desc, struct scatterlist *dst,
+		       struct scatterlist *src, unsigned int nbytes)
+{
+	struct crypto_aes_ctx *ctx = crypto_blkcipher_ctx(desc->tfm);
+	int err, first, rounds = 6 + ctx->key_length / 4;
+	struct blkcipher_walk walk;
+	unsigned int blocks;
+	//printk(KERN_ERR "*************alg: ecb_encrypt, nbytes:%d\n", nbytes);
+	desc->flags &= ~CRYPTO_TFM_REQ_MAY_SLEEP;
+	blkcipher_walk_init(&walk, dst, src, nbytes);
+	err = blkcipher_walk_virt(desc, &walk);
+
+	for (first = 1; (blocks = (walk.nbytes / AES_BLOCK_SIZE)); first = 0) {
+		crypto_MCP_AES_Encryption(MCP_BCM_ECB, (unsigned char*)ctx->key_enc, NULL, walk.src.virt.addr, walk.dst.virt.addr, AES_BLOCK_SIZE*blocks, ctx->key_length);
+		err = blkcipher_walk_done(desc, &walk, walk.nbytes % AES_BLOCK_SIZE);
+	}
+	return err;
+}
+
+static int rtk_mcp_aes_ecb_cipher_decrypt(struct blkcipher_desc *desc, struct scatterlist *dst,
+		       struct scatterlist *src, unsigned int nbytes)
+{
+	struct crypto_aes_ctx *ctx = crypto_blkcipher_ctx(desc->tfm);
+	int err, first, rounds = 6 + ctx->key_length / 4;
+	struct blkcipher_walk walk;
+	unsigned int blocks;
+	//printk(KERN_ERR "*************alg: ecb_decrypt\n");
+	desc->flags &= ~CRYPTO_TFM_REQ_MAY_SLEEP;
+	blkcipher_walk_init(&walk, dst, src, nbytes);
+	err = blkcipher_walk_virt(desc, &walk);
+
+	for (first = 1; (blocks = (walk.nbytes / AES_BLOCK_SIZE)); first = 0) {
+		crypto_MCP_AES_Decryption(MCP_BCM_ECB, (unsigned char*)ctx->key_enc, NULL, walk.src.virt.addr, walk.dst.virt.addr, AES_BLOCK_SIZE*blocks, ctx->key_length);
+		err = blkcipher_walk_done(desc, &walk, walk.nbytes % AES_BLOCK_SIZE);
+	}
+	return err;
+}
+
+static int rtk_mcp_aes_cbc_cipher_encrypt(struct blkcipher_desc *desc, struct scatterlist *dst,
+		       struct scatterlist *src, unsigned int nbytes)
+{
+	struct crypto_aes_ctx *ctx = crypto_blkcipher_ctx(desc->tfm);
+	int err, first, rounds = 6 + ctx->key_length / 4;
+	struct blkcipher_walk walk;
+	unsigned int blocks;
+	//printk(KERN_ERR "*************alg: cbc_encrypt, nbytes:%d\n", nbytes);
+	desc->flags &= ~CRYPTO_TFM_REQ_MAY_SLEEP;
+	blkcipher_walk_init(&walk, dst, src, nbytes);
+	err = blkcipher_walk_virt(desc, &walk);
+	unsigned char IV[16];
+memcpy(IV, walk.iv, 16);
+	for (first = 1; (blocks = (walk.nbytes / AES_BLOCK_SIZE)); first = 0) {
+		crypto_MCP_AES_Encryption(MCP_BCM_CBC, (unsigned char*)ctx->key_enc, IV, walk.src.virt.addr, walk.dst.virt.addr, AES_BLOCK_SIZE*blocks, ctx->key_length);
+		err = blkcipher_walk_done(desc, &walk, walk.nbytes % AES_BLOCK_SIZE);
+	}
+	return err;
+}
+
+static int rtk_mcp_aes_cbc_cipher_decrypt(struct blkcipher_desc *desc, struct scatterlist *dst,
+		       struct scatterlist *src, unsigned int nbytes)
+{
+	struct crypto_aes_ctx *ctx = crypto_blkcipher_ctx(desc->tfm);
+	int err, first, rounds = 6 + ctx->key_length / 4;
+	struct blkcipher_walk walk;
+	unsigned int blocks;
+	//printk(KERN_ERR "*************alg: cbc_decrypt\n");
+	desc->flags &= ~CRYPTO_TFM_REQ_MAY_SLEEP;
+	blkcipher_walk_init(&walk, dst, src, nbytes);
+	err = blkcipher_walk_virt(desc, &walk);
+	unsigned char IV[16];
+memcpy(IV, walk.iv, 16);
+
+	for (first = 1; (blocks = (walk.nbytes / AES_BLOCK_SIZE)); first = 0) {
+		crypto_MCP_AES_Decryption(MCP_BCM_CBC, (unsigned char*)ctx->key_enc, IV, walk.src.virt.addr, walk.dst.virt.addr, AES_BLOCK_SIZE*blocks, ctx->key_length);
+		err = blkcipher_walk_done(desc, &walk, walk.nbytes % AES_BLOCK_SIZE);
+	}
+
+	return err;
+}
+
+static int rtk_mcp_aes_ctr_cipher_encrypt(struct blkcipher_desc *desc, struct scatterlist *dst,
+		       struct scatterlist *src, unsigned int nbytes)
+{
+	struct crypto_aes_ctx *ctx = crypto_blkcipher_ctx(desc->tfm);
+	int err, first, rounds = 6 + ctx->key_length / 4;
+	struct blkcipher_walk walk;
+	unsigned int blocks;
+
+	unsigned long q_cnt = 0;
+	unsigned long r_cnt = 0;
+	unsigned char IV[16];
+	unsigned char ecnt[16];
+	int i;
+	unsigned int n=0;
+	unsigned int total_bytes=0;
+	unsigned long DataLen_count=0;
+
+	desc->flags &= ~CRYPTO_TFM_REQ_MAY_SLEEP;
+	blkcipher_walk_init(&walk, dst, src, nbytes);
+	err = blkcipher_walk_virt_block(desc, &walk, AES_BLOCK_SIZE);
+
+            memcpy(IV, walk.iv, 16);
+            total_bytes=nbytes;
+
+	while ((blocks = (walk.nbytes / AES_BLOCK_SIZE))) {
+		crypto_MCP_AES_Encryption(MCP_BCM_CTR, (unsigned char*)ctx->key_enc, walk.iv, walk.src.virt.addr, walk.dst.virt.addr, blocks*AES_BLOCK_SIZE, ctx->key_length);
+		first = 0;
+		nbytes -= blocks * AES_BLOCK_SIZE;
+		/* Add count value to IV */
+		q_cnt = walk.nbytes/ 16; // block num
+
+		while(q_cnt--) {
+			i = 15;
+			do {
+				IV[i]++;
+			} while (!IV[i] && i-- >= 0);
+		}
+                    memcpy(walk.iv, IV, 16); //for next iv
+		if (nbytes && nbytes == walk.nbytes% AES_BLOCK_SIZE)
+			break;
+		err = blkcipher_walk_done(desc, &walk,
+					  walk.nbytes % AES_BLOCK_SIZE);
+	}
+
+	if (walk.nbytes % AES_BLOCK_SIZE) {
+		u8 *tdst = walk.dst.virt.addr + blocks * AES_BLOCK_SIZE;
+		u8 *tsrc = walk.src.virt.addr + blocks * AES_BLOCK_SIZE;
+
+		DataLen_count=total_bytes % AES_BLOCK_SIZE;
+		while (DataLen_count--) {
+		if (n == 0){
+                            crypto_MCP_AES_Encryption(MCP_BCM_ECB, (unsigned char*)ctx->key_enc, NULL, IV, ecnt, AES_BLOCK_SIZE, ctx->key_length);
+		}
+
+		*(tdst++) = *(tsrc++) ^ ecnt[n];
+		n = (n+1) % 16;
+
+		if (n == 0) {
+			i = 15;
+			do {
+				IV[i]++;
+			} while (!IV[i] && i-- >= 0);
+		}
+	}
+
+		err = blkcipher_walk_done(desc, &walk, 0);
+	}
+
+	return err;
+}
+
+static int rtk_mcp_aes_ctr_cipher_decrypt(struct blkcipher_desc *desc, struct scatterlist *dst,
+		       struct scatterlist *src, unsigned int nbytes)
+{
+	struct crypto_aes_ctx *ctx = crypto_blkcipher_ctx(desc->tfm);
+	int err, first, rounds = 6 + ctx->key_length / 4;
+	struct blkcipher_walk walk;
+	unsigned int blocks;
+
+	unsigned long q_cnt = 0;
+	unsigned long r_cnt = 0;
+	unsigned char IV[16];
+	unsigned char ecnt[16];
+	int i;
+	unsigned int n=0;
+	unsigned int total_bytes=0;
+	unsigned long DataLen_count=0;
+
+	desc->flags &= ~CRYPTO_TFM_REQ_MAY_SLEEP;
+	blkcipher_walk_init(&walk, dst, src, nbytes);
+	err = blkcipher_walk_virt_block(desc, &walk, AES_BLOCK_SIZE);
+
+            memcpy(IV, walk.iv, 16);
+            total_bytes=nbytes;
+
+	while ((blocks = (walk.nbytes / AES_BLOCK_SIZE))) {
+		crypto_MCP_AES_Decryption(MCP_BCM_CTR, (unsigned char*)ctx->key_enc, walk.iv, walk.src.virt.addr, walk.dst.virt.addr, blocks*AES_BLOCK_SIZE, ctx->key_length);
+		first = 0;
+		nbytes -= blocks * AES_BLOCK_SIZE;
+		/* Add count value to IV */
+		q_cnt = walk.nbytes/ 16; // block num
+
+		while(q_cnt--) {
+			i = 15;
+			do {
+				IV[i]++;
+			} while (!IV[i] && i-- >= 0);
+		}
+                    memcpy(walk.iv, IV, 16); //for next iv
+		if (nbytes && nbytes == walk.nbytes% AES_BLOCK_SIZE)
+			break;
+		err = blkcipher_walk_done(desc, &walk,
+					  walk.nbytes % AES_BLOCK_SIZE);
+	}
+
+	if (walk.nbytes % AES_BLOCK_SIZE) {
+		u8 *tdst = walk.dst.virt.addr + blocks * AES_BLOCK_SIZE;
+		u8 *tsrc = walk.src.virt.addr + blocks * AES_BLOCK_SIZE;
+
+		DataLen_count=total_bytes % AES_BLOCK_SIZE;
+		while (DataLen_count--) {
+		if (n == 0){
+                            crypto_MCP_AES_Encryption(MCP_BCM_ECB, (unsigned char*)ctx->key_enc, NULL, IV, ecnt, AES_BLOCK_SIZE, ctx->key_length);
+		}
+
+		*(tdst++) = *(tsrc++) ^ ecnt[n];
+		n = (n+1) % 16;
+
+		if (n == 0) {
+			i = 15;
+			do {
+				IV[i]++;
+			} while (!IV[i] && i-- >= 0);
+		}
+	}
+
+		err = blkcipher_walk_done(desc, &walk, 0);
+	}
+
+	return err;
+}
+
+int crypto_rtk_aes_key(struct crypto_aes_ctx *ctx, const u8 *in_key,
+		unsigned int key_len)
+{
+#if 1
+	const __le32 *key = (const __le32 *)in_key;
+
+	if (key_len != AES_KEYSIZE_128 && key_len != AES_KEYSIZE_192 &&
+			key_len != AES_KEYSIZE_256)
+		return -EINVAL;
+
+	ctx->key_length = key_len;
+
+	ctx->key_enc[0] = le32_to_cpu(key[0]);
+	ctx->key_enc[1] = le32_to_cpu(key[1]);
+	ctx->key_enc[2] = le32_to_cpu(key[2]);
+	ctx->key_enc[3] = le32_to_cpu(key[3]);
+
+	switch (key_len) {
+	case AES_KEYSIZE_128:
+		break;
+
+	case AES_KEYSIZE_192:
+		ctx->key_enc[4] = le32_to_cpu(key[4]);
+		ctx->key_enc[5] = le32_to_cpu(key[5]);
+		break;
+
+	case AES_KEYSIZE_256:
+		ctx->key_enc[4] = le32_to_cpu(key[4]);
+		ctx->key_enc[5] = le32_to_cpu(key[5]);
+		ctx->key_enc[6] = le32_to_cpu(key[6]);
+		ctx->key_enc[7] = le32_to_cpu(key[7]);
+		break;
+	}
+    #endif
+	return 0;
+}
+
+int rtk_mcp_aes_setkey(struct crypto_tfm *tfm, const u8 *in_key,
+		  unsigned int key_len)
+{
+	struct crypto_aes_ctx *ctx = crypto_tfm_ctx(tfm);
+	int ret;
+	//mcp_dump_data_with_text(in_key, key_len, "in_key : ");
+	//ret = crypto_rtk_aes_expand_key(ctx, in_key, key_len);
+	ret = crypto_rtk_aes_key(ctx, in_key, key_len);
+    
+	//mcp_dump_data_with_text((unsigned char *)ctx->key_enc, key_len, "extend ctx->key_enc : ");
+	//mcp_dump_data_with_text((unsigned char *)ctx->key_dec, key_len, "extend ctx->key_dec : ");
+	if (!ret)
+		return 0;
+
+	tfm->crt_flags |= CRYPTO_TFM_RES_BAD_KEY_LEN;
+	return -EINVAL;
+}
+EXPORT_SYMBOL(rtk_mcp_aes_setkey);
+
+static int append_padding(unsigned int length, unsigned char *dst)
+{
+    unsigned int num_of_bits;
+    int i, j, tmp;
+    int pad_len;
+
+    if ((length == 0) || (dst == NULL)) {
+        return -1;
+    }
+
+    // calculate padding length
+    pad_len = 1;
+    while ((length + pad_len) % 64 != 56)
+        pad_len++;
+    pad_len += 8;
+
+    // fill padding pattern
+    memset(dst, 0, pad_len);
+    dst[0] = 1 << 7;
+
+    num_of_bits = length * 8;
+    for (i = pad_len - 8, j = 32; j >= 0; j -= 32) {
+        tmp = (int) ((long long)num_of_bits >> j);
+        dst[i++] = (tmp >> 24) & 0xff;
+        dst[i++] = (tmp >> 16) & 0xff;
+        dst[i++] = (tmp >> 8) & 0xff;
+        dst[i++] =  tmp & 0xff;
+        //printf("%ld >> %d = %d\n", num_of_bits, j, tmp);
+    }
+
+    return pad_len;
+}
+
+int crypto_MCP_SHA256_update(unsigned char* p_in, unsigned long len)
+{
+	mcp_desc desc;
+	int ret;
+
+	unsigned char *pData = NULL;
+	int i = 0;
+
+	sha256_data_dma_vaddr = (unsigned long)dma_alloc_coherent(&local_pdev->dev, len, &sha256_data_dma_phyaddr, GFP_ATOMIC|GFP_DMA);
+
+	if (sha256_data_dma_vaddr) {
+		pData = (unsigned char *)sha256_data_dma_vaddr;
+
+		for (i = 0; i < len; i++) {
+			pData[i] = p_in[i];
+		}
+		//mcp_dump_data_with_text(pData, 16, "decrypted value : ");
+		ret = 0;
+	}else{
+		mcp_warning("crypto_MCP_SHA256_update dma alloc fail");
+                    ret = -1;
+	}
+
+	return ret;
+}
+
+int crypto_MCP_SHA256_final(unsigned char* p_out, unsigned long len, unsigned int iv[8], unsigned int is_final)
+{
+	mcp_desc desc;
+	int ret;
+
+	unsigned char *pData = NULL;
+    	unsigned char *pPaddingData = NULL;
+	int i = 0;
+	pData = (unsigned char *)sha256_data_dma_vaddr;
+          unsigned long padding_tmp_vaddr;
+          unsigned int padding_len;
+
+          pPaddingData = (unsigned char *)padding_tmp_vaddr;
+          if(update_count>1 && is_final){
+                padding_len=((last_len/64)+2)*64;
+                //printk(KERN_ERR "*************alg: software padding, padding len: %d\n", padding_len);    
+                padding_tmp_vaddr = (unsigned long)dma_alloc_coherent(&local_pdev->dev, padding_len, &sha256_padding_dma_phyaddr, GFP_ATOMIC|GFP_DMA);
+                memset(padding_tmp_vaddr, 0x0, sizeof(padding_tmp_vaddr));
+                memcpy(padding_tmp_vaddr, pData, last_len);
+                append_padding(len,padding_tmp_vaddr + last_len);
+          }
+
+	desc.flags= 0xb;
+
+	desc.key[0] = iv[0];
+	desc.key[1] = iv[1];
+	desc.key[2] = iv[2];
+	desc.key[3] = iv[3];
+	desc.key[4] = iv[4];
+	desc.key[5] = iv[5];
+	desc.iv[0] = iv[6];
+	desc.iv[1] = iv[7];
+
+//for (i = 0; i < 8; i++) {
+//printk(KERN_ERR "*************alg: crypto_MCP_SHA256_final, p_out: %x\n",iv[i]);
+//}
+
+          if(update_count>1 && is_final){
+            	desc.data_in = sha256_padding_dma_phyaddr;
+            	desc.data_out = sha256_padding_dma_phyaddr;
+
+                      //if(len%16)
+                      //len+=0x10;
+                
+            	//desc.length = len & ~0xF;
+            	//desc.length = len;
+                      if((last_len%64)<56)
+                        desc.length = padding_len-64;
+                     else{
+                        desc.length = padding_len;
+                     }
+
+                      SET_MCP_CTRL1(GET_MCP_CTRL1(RTK_MCP_BASE) | 0x800, RTK_MCP_BASE); //disable auto padding
+          }else{
+
+                      desc.data_in = sha256_data_dma_phyaddr;
+                      desc.data_out = sha256_data_dma_phyaddr;
+
+                      //desc.length = len & ~0xF;
+                      desc.length = len;
+
+                      if(is_final){
+                              //printk(KERN_ERR "*************alg: hw padding.\n");
+                              SET_MCP_CTRL1(GET_MCP_CTRL1(RTK_MCP_BASE) & ~0x800, RTK_MCP_BASE); //auto padding
+                      }else{
+                              //printk(KERN_ERR "*************alg: hw padding off.\n");
+                              SET_MCP_CTRL1(GET_MCP_CTRL1(RTK_MCP_BASE) | 0x800, RTK_MCP_BASE); //disable auto padding
+                      }
+
+          }
+
+	ret = crypto_mcp_do_command(&desc, 1);
+	//printk(KERN_ERR "*************alg: crypto_MCP_SHA256_final, ret: %d\n",ret);
+
+	if(update_count>1 && is_final){
+
+            	if(sha256_data_dma_vaddr && padding_tmp_vaddr){
+            		for (i = 0; i < 32; i++) {
+            			 p_out[i]=pPaddingData[i];
+            			 //printk(KERN_ERR "*************alg: crypto_MCP_SHA256_final, p_out: %x\n",p_out[i]);
+            		}
+
+            		dma_free_coherent(&local_pdev->dev, len, (void *)sha256_data_dma_vaddr, sha256_data_dma_phyaddr);
+            		dma_free_coherent(&local_pdev->dev, padding_len, (void *)padding_tmp_vaddr, sha256_padding_dma_phyaddr);
+            	}
+
+	}else{
+
+                    	if(sha256_data_dma_vaddr){
+                    		for (i = 0; i < 32; i++) {
+                    			 p_out[i]=pData[i];
+                    			 //printk(KERN_ERR "*************alg: crypto_MCP_SHA256_final, p_out: %x\n",p_out[i]);
+                    		}
+
+                    		dma_free_coherent(&local_pdev->dev, len, (void *)sha256_data_dma_vaddr, sha256_data_dma_phyaddr);
+                    	}
+	}
+    
+	return ret;
+}
+#if 0
+static inline int rtk_sha256_base_init(struct shash_desc *desc)
+{
+	struct sha256_state *sctx = shash_desc_ctx(desc);
+	sctx->state[0] = SHA256_H0;
+	sctx->state[1] = SHA256_H1;
+	sctx->state[2] = SHA256_H2;
+	sctx->state[3] = SHA256_H3;
+	sctx->state[4] = SHA256_H4;
+	sctx->state[5] = SHA256_H5;
+	sctx->state[6] = SHA256_H6;
+	sctx->state[7] = SHA256_H7;
+	sctx->count = 0;
+
+	update_count=0;
+	return 0;
+}
+#endif
+int swap_endian(unsigned int input)
+{
+        unsigned int output;
+
+        output = (input & 0xff000000)>>24|
+                         (input & 0x00ff0000)>>8|
+                         (input & 0x0000ff00)<<8|
+                         (input & 0x000000ff)<<24;
+        return output;
+}
+#if 0
+int rtk_crypto_sha256_update(struct shash_desc *desc, const u8 *data,
+			  unsigned int len)
+{
+        	struct sha256_state *sctx = shash_desc_ctx(desc);
+            unsigned int iv[8];
+            unsigned int i=0;
+	//unsigned int partial = sctx->count % SHA256_BLOCK_SIZE;
+	//printk(KERN_ERR "*************alg: sha256_base_do_update, len:%d\n", len);
+	//sctx->count += len;
+
+	if(update_count){
+              crypto_MCP_SHA256_final((unsigned char*)iv, sctx->count, sctx->state, 0);
+              for(i = 0 ; i < 8 ; i++) {
+                    iv[i] = swap_endian(iv[i]);
+                }
+              sctx->state[0] = iv[0];
+              sctx->state[1] = iv[1];
+              sctx->state[2] = iv[2];
+              sctx->state[3] = iv[3];
+              sctx->state[4] = iv[4];
+              sctx->state[5] = iv[5];
+              sctx->state[6] = iv[6];
+              sctx->state[7] = iv[7];
+
+              //print_hex_dump(KERN_ERR, "", DUMP_PREFIX_OFFSET,
+			//16, 1,
+			//(unsigned char *)sctx->state, 32, false);
+             
+            crypto_MCP_SHA256_update(data, len);
+              last_len = len;
+        }else
+            crypto_MCP_SHA256_update(data, len);
+
+        sctx->count += len;
+	//return sha256_base_do_update(desc, data, len, sha256_generic_block_fn);
+	update_count++;
+	return 0;
+}
+EXPORT_SYMBOL(rtk_crypto_sha256_update);
+
+static int rtk_sha256_final(struct shash_desc *desc, u8 *out)
+{
+        	struct sha256_state *sctx = shash_desc_ctx(desc);
+          //printk(KERN_ERR "*************alg: rtk_sha256_final, sctx->count:%d\n", sctx->count);
+          return crypto_MCP_SHA256_final(out, sctx->count, sctx->state, 1);
+}
+
+int rtk_crypto_sha256_finup(struct shash_desc *desc, const u8 *data,
+			unsigned int len, u8 *hash)
+{
+	//printk(KERN_ERR "*************alg: rtk_crypto_sha256_finup\n");
+	rtk_crypto_sha256_update(desc, data, len);
+	return rtk_sha256_final(desc, hash);
+}
+EXPORT_SYMBOL(rtk_crypto_sha256_finup);
+#endif
+//==================================================================================
+
+static inline int rtk_sha256_base_init(struct shash_desc *desc)
+{
+	struct sha256_state *sctx = shash_desc_ctx(desc);
+
+	sctx->state[0] = CRYPTO_SHA256_H0;
+	sctx->state[1] = CRYPTO_SHA256_H1;
+	sctx->state[2] = CRYPTO_SHA256_H2;
+	sctx->state[3] = CRYPTO_SHA256_H3;
+	sctx->state[4] = CRYPTO_SHA256_H4;
+	sctx->state[5] = CRYPTO_SHA256_H5;
+	sctx->state[6] = CRYPTO_SHA256_H6;
+	sctx->state[7] = CRYPTO_SHA256_H7;
+	sctx->count = 0;
+
+	return 0;
+}
+
+static inline int rtk_sha256_base_do_update(struct shash_desc *desc,
+					const u8 *data,
+					unsigned int len,
+					sha256_block_fn *block_fn)
+{
+	struct sha256_state *sctx = shash_desc_ctx(desc);
+	unsigned int partial = sctx->count % SHA256_BLOCK_SIZE;
+
+	sctx->count += len;
+//printk(KERN_ERR "*************alg: sha256_base_do_update, len:%d, sctx->count:%d\n", len, sctx->count);
+	if (unlikely((partial + len) >= SHA256_BLOCK_SIZE)) {
+		int blocks;
+
+		if (partial) {
+			int p = SHA256_BLOCK_SIZE - partial;
+
+			memcpy(sctx->buf + partial, data, p);
+			data += p;
+			len -= p;
+			//printk(KERN_ERR "*************alg: sha256_base_do_update partial, len:%d, sctx->count:%d\n", len, sctx->count);
+			block_fn(sctx, sctx->buf, 1*SHA256_BLOCK_SIZE);
+		}
+
+		blocks = len / SHA256_BLOCK_SIZE;
+		len %= SHA256_BLOCK_SIZE;
+
+		if (blocks) {
+                                //printk(KERN_ERR "*************alg: sha256_base_do_update blocks, len:%d, sctx->count:%d, blocks:%d\n", len, sctx->count, blocks);
+			block_fn(sctx, data, blocks*SHA256_BLOCK_SIZE);
+			data += blocks * SHA256_BLOCK_SIZE;
+		}
+		partial = 0;
+	}
+	if (len)
+		memcpy(sctx->buf + partial, data, len);
+
+	return 0;
+}
+
+static inline int rtk_sha256_base_do_finalize(struct shash_desc *desc,
+					  sha256_block_fn *block_fn)
+{
+	const int bit_offset = SHA256_BLOCK_SIZE - sizeof(__be64);
+	struct sha256_state *sctx = shash_desc_ctx(desc);
+	__be64 *bits = (__be64 *)(sctx->buf + bit_offset);
+	unsigned int partial = sctx->count % SHA256_BLOCK_SIZE;
+
+	sctx->buf[partial++] = 0x80;
+	if (partial > bit_offset) {
+		memset(sctx->buf + partial, 0x0, SHA256_BLOCK_SIZE - partial);
+		partial = 0;
+		//printk(KERN_ERR "*************alg: sha256_base_do_finalize blocks, sctx->count:%d, partial:%d\n", sctx->count, partial);
+		block_fn(sctx, sctx->buf, 1*SHA256_BLOCK_SIZE);
+	}
+
+	memset(sctx->buf + partial, 0x0, bit_offset - partial);
+	*bits = cpu_to_be64(sctx->count << 3);
+	block_fn(sctx, sctx->buf, 1*SHA256_BLOCK_SIZE);
+
+	return 0;
+}
+
+static inline int rtk_sha256_base_finish(struct shash_desc *desc, u8 *out)
+{
+	unsigned int digest_size = crypto_shash_digestsize(desc->tfm);
+	struct sha256_state *sctx = shash_desc_ctx(desc);
+	__be32 *digest = (__be32 *)out;
+	int i;
+//printk(KERN_ERR "*************alg: sha256_base_finish,  sctx->count:%d\n", sctx->count);
+	for (i = 0; digest_size > 0; i++, digest_size -= sizeof(__be32))
+		put_unaligned_be32(sctx->state[i], digest++);
+
+	*sctx = (struct sha256_state){};
+	return 0;
+}
+
+
+static void rtk_sha256_generic_block_fn(struct sha256_state *sctx, u8 const *data,
+				    int len)
+{
+            unsigned int iv[8];
+            unsigned int i=0;
+	//unsigned int partial = sctx->count % SHA256_BLOCK_SIZE;
+	//printk(KERN_ERR "*************alg: sha256_base_do_update, len:%d\n", len);
+	//sctx->count += len;
+
+            crypto_MCP_SHA256_update(data, len);
+            crypto_MCP_SHA256_final((unsigned char*)iv, len, sctx->state, 0);
+
+              for(i = 0 ; i < 8 ; i++) {
+                    iv[i] = swap_endian(iv[i]);
+                }
+              sctx->state[0] = iv[0];
+              sctx->state[1] = iv[1];
+              sctx->state[2] = iv[2];
+              sctx->state[3] = iv[3];
+              sctx->state[4] = iv[4];
+              sctx->state[5] = iv[5];
+              sctx->state[6] = iv[6];
+              sctx->state[7] = iv[7];
+
+	return 0;
+}
+
+int rtk_crypto_sha256_update(struct shash_desc *desc, const u8 *data,
+			  unsigned int len)
+{
+//printk(KERN_ERR "*************alg: crypto_sha256_update, len:%d\n", len);
+	return rtk_sha256_base_do_update(desc, data, len, rtk_sha256_generic_block_fn);
+}
+EXPORT_SYMBOL(rtk_crypto_sha256_update);
+
+static int rtk_sha256_final(struct shash_desc *desc, u8 *out)
+{
+//printk(KERN_ERR "*************alg: sha256_final\n");
+	rtk_sha256_base_do_finalize(desc, rtk_sha256_generic_block_fn);
+	return rtk_sha256_base_finish(desc, out);
+}
+
+int rtk_crypto_sha256_finup(struct shash_desc *desc, const u8 *data,
+			unsigned int len, u8 *hash)
+{
+	rtk_sha256_base_do_update(desc, data, len, rtk_sha256_generic_block_fn);
+	return rtk_sha256_final(desc, hash);
+}
+EXPORT_SYMBOL(rtk_crypto_sha256_finup);
+
+static struct crypto_alg rtk_aes_ecb_alg = {
+
+	.cra_name		= "ecb(aes)",
+	.cra_driver_name	= "__driver-ecb-aes-rtk",
+	.cra_priority		= 0,
+	.cra_flags		= CRYPTO_ALG_TYPE_BLKCIPHER |
+				  CRYPTO_ALG_INTERNAL,
+	.cra_blocksize		= AES_BLOCK_SIZE,
+	.cra_ctxsize		= sizeof(struct crypto_aes_ctx),
+	.cra_alignmask		= 0xf,
+	.cra_type		= &crypto_blkcipher_type,
+	.cra_module		= THIS_MODULE,
+	.cra_blkcipher = {
+		.min_keysize	= AES_MIN_KEY_SIZE,
+		.max_keysize	= AES_MAX_KEY_SIZE,
+		.ivsize		= AES_BLOCK_SIZE,
+		.setkey		= rtk_mcp_aes_setkey,
+		.encrypt	= rtk_mcp_aes_ecb_cipher_encrypt,
+		.decrypt	= rtk_mcp_aes_ecb_cipher_decrypt,
+	}
+};
+
+static struct crypto_alg rtk_aes_cbc_alg = {
+
+	.cra_name		= "cbc(aes)",
+	.cra_driver_name	= "__driver-cbc-aes-rtk",
+	.cra_priority		= 0,
+	.cra_flags		= CRYPTO_ALG_TYPE_BLKCIPHER |
+				  CRYPTO_ALG_INTERNAL,
+	.cra_blocksize		= AES_BLOCK_SIZE,
+	.cra_ctxsize		= sizeof(struct crypto_aes_ctx),
+	.cra_alignmask		= 0xf,
+	.cra_type		= &crypto_blkcipher_type,
+	.cra_module		= THIS_MODULE,
+	.cra_blkcipher = {
+		.min_keysize	= AES_MIN_KEY_SIZE,
+		.max_keysize	= AES_MAX_KEY_SIZE,
+		.ivsize		= AES_BLOCK_SIZE,
+		.setkey		= rtk_mcp_aes_setkey,
+		.encrypt	= rtk_mcp_aes_cbc_cipher_encrypt,
+		.decrypt	= rtk_mcp_aes_cbc_cipher_decrypt,
+	}
+};
+
+static struct crypto_alg rtk_aes_ctr_alg = {
+
+	.cra_name		= "ctr(aes)",
+	.cra_driver_name	= "__driver-ctr-aes-rtk",
+	.cra_priority		= 0,
+	.cra_flags		= CRYPTO_ALG_TYPE_BLKCIPHER |
+				  CRYPTO_ALG_INTERNAL,
+	.cra_blocksize		= 1,//for chunk
+	.cra_ctxsize		= sizeof(struct crypto_aes_ctx),
+	.cra_alignmask		= 0xf,
+	.cra_type		= &crypto_blkcipher_type,
+	.cra_module		= THIS_MODULE,
+	.cra_blkcipher = {
+		.min_keysize	= AES_MIN_KEY_SIZE,
+		.max_keysize	= AES_MAX_KEY_SIZE,
+		.ivsize		= AES_BLOCK_SIZE,
+		.setkey		= rtk_mcp_aes_setkey,
+		.encrypt	= rtk_mcp_aes_ctr_cipher_encrypt,
+		.decrypt	= rtk_mcp_aes_ctr_cipher_decrypt,
+	}
+};
+
+static struct shash_alg rtk_sha256_alg = { 
+	.digestsize	=	SHA256_DIGEST_SIZE,
+	.init		=	rtk_sha256_base_init,
+	.update		=	rtk_crypto_sha256_update,
+	.final		=	rtk_sha256_final,
+	.finup		=	rtk_crypto_sha256_finup,
+	.descsize	=	sizeof(struct sha256_state),
+	.base		=	{
+		.cra_name	=	"sha256",
+		.cra_driver_name=	"sha256-rtk",
+		.cra_flags	=	CRYPTO_ALG_TYPE_SHASH,
+		.cra_blocksize	=	SHA256_BLOCK_SIZE,
+		.cra_module	=	THIS_MODULE,
+	}
+};
+
+#if 0
+static int __init rtk_mcp_aes_mod_init(void)
+{
+printk(KERN_ERR "*************alg: rtk_mcp_aes_mod_init\n");
+	return crypto_register_alg(&rtk_aes_alg);
+}
+
+static void __exit rtk_mcp_aes_mod_exit(void)
+{
+	crypto_unregister_alg(&rtk_aes_alg);
+}
+
+//module_cpu_feature_match(AES, rtk_mcp_aes_mod_init);
+//module_exit(rtk_mcp_aes_mod_exit);
+
+module_init(rtk_mcp_aes_mod_init);
+module_exit(rtk_mcp_aes_mod_exit);
+#endif
+#if 0
+static int rtk_crypto_mcp_probe(struct platform_device *pdev)
+{
+	//local_pdev = pdev;
+
+	//printk(KERN_ERR "[RTK MCP] MCP driver initial begin.\n");
+printk(KERN_ERR "*************alg: rtk_crypto_mcp_probe\n");
+
+    	//RTK_MCP_BASE = ioremap(0x98015000, 0x1000);
+	//RTK_CRT_BASE = ioremap(0x98000000, 0x100);
+
+#if 0
+	RTK_MCP_BASE = of_iomap(pdev->dev.of_node, 0);
+	if (!MCP_BASE) {
+		dev_err(&pdev->dev, "no mcp address\n");
+		return -EINVAL;
+	}
+
+	RTK_TP_BASE = of_iomap(pdev->dev.of_node, 1);
+	if (!RTK_TP_BASE) {
+		dev_err(&pdev->dev, "no tp address\n");
+		return -EINVAL;
+	}
+
+	printk(KERN_INFO "[RTK MCP] MCP Base: 0x%p\n", RTK_MCP_BASE);
+	printk(KERN_INFO "[RTK MCP] TP Base: 0x%p\n", RTK_TP_BASE);
+
+	 if (mcp_init()<0)
+		 return -ENODEV;
+
+	 cdev_init(&mcp_dev, &mcp_ops);
+
+	if (alloc_chrdev_region(&devno, 0, 1, MCP_DEVICE_NAME) != 0){
+		cdev_del(&mcp_dev);
+		printk("%s %s %d",__FILE__, __func__,__LINE__);
+		return -EFAULT;
+	}
+
+	if (cdev_add(&mcp_dev, devno, 1) < 0)
+		return -EFAULT;
+
+	mcp_dev_class = class_create(THIS_MODULE, MCP_DEVICE_NAME); // create a new class for mcp
+
+	mcp_device = device_create(mcp_dev_class, NULL, devno, NULL, "mcp_core");
+#endif
+	printk(KERN_ERR "[RTK MCP] MCP driver initial done.\n");
+
+	return crypto_register_alg(&rtk_aes_alg);
+}
+
+static int rtk_crypto_mcp_remove(struct platform_device *dev)
+{
+	printk(KERN_ERR "[RTK MCP] MCP driver remove begin.\n");
+#if 0
+	device_destroy(mcp_dev_class, mcp_device->devt);
+
+	cdev_del(&mcp_dev);
+
+	unregister_chrdev_region(devno, 1);
+
+	mcp_uninit();
+#endif
+	printk(KERN_ERR "[RTK MCP] MCP driver remove done.\n");
+
+	return 0;
+}
+
+static struct of_device_id rtk_crypto_mcp_ids[] = {
+	{ .compatible = "Realtek,rtk-mcp" },
+	{ /* Sentinel */ },
+};
+
+static struct platform_driver rtk_crypto_mcp_driver = {
+	.probe = rtk_crypto_mcp_probe,
+	.remove = rtk_crypto_mcp_remove,
+	.driver = {
+		.name = "RTK_CRYPTO_MCP",
+		.of_match_table = of_match_ptr(rtk_crypto_mcp_ids),
+	},
+};
+
+module_platform_driver(rtk_crypto_mcp_driver);
+#endif
+
+static struct platform_device *rtk_crypto_mcp_device;
+
+static int rtk_crypto_mcp_probe(struct platform_device *pdev)
+{
+	int ret=0;
+	//printk(KERN_ERR "[RTK_CRYPTO]rtk_crypto_mcp_probe\n");
+	local_pdev = pdev;
+    
+	RTK_MCP_BASE = ioremap(0x98015000, 0x1000);
+	RTK_CRT_BASE = ioremap(0x98000000, 0x100);
+	//SET_CRT_MCP_RESET((GET_CRT_MCP_RESET(RTK_CRT_BASE)|0x30000), RTK_CRT_BASE);
+	//SET_CRT_MCP_CLK((GET_CRT_MCP_CLK(RTK_CRT_BASE)|0xc), RTK_CRT_BASE);
+
+	mcp_debug("STATUS=%08x, CTRL=%08x\n",GET_MCP_STATUS(RTK_MCP_BASE), GET_MCP_CTRL(RTK_MCP_BASE));
+	//mcp_debug("GET_CRT_MCP_RESET=%08x\n",GET_CRT_MCP_RESET(RTK_CRT_BASE));
+	//mcp_debug("GET_CRT_MCP_CLK=%08x\n",GET_CRT_MCP_CLK(RTK_CRT_BASE));
+	crypto_mcp_init();
+
+
+   //crypto_register_alg(&rtk_aes_alg);
+   ret = crypto_register_alg(&rtk_aes_ecb_alg);
+   if(ret){
+	printk(KERN_ERR "[RTK_CRYPTO]rtk_aes_ecb_alg register fail\n");
+   }
+   ret = crypto_register_alg(&rtk_aes_cbc_alg);
+   if(ret){
+	printk(KERN_ERR "[RTK_CRYPTO]rtk_aes_cbc_alg register fail\n");
+   }
+   ret = crypto_register_alg(&rtk_aes_ctr_alg);
+    if(ret){
+	printk(KERN_ERR "[RTK_CRYPTO]rtk_aes_ctr_alg register fail\n");
+   }
+   ret = crypto_register_shash(&rtk_sha256_alg);
+    if(ret){
+	printk(KERN_ERR "[RTK_CRYPTO]rtk_sha256_alg register fail\n");
+   }
+   return ret;
+}
+
+static int rtk_crypto_mcp_remove(struct platform_device *pdev)
+{
+    int ret;
+    pr_err("%s(#%d)\n", __func__, __LINE__);
+   ret = crypto_unregister_alg(&rtk_aes_ecb_alg);
+   if(ret){
+	printk(KERN_ERR "[RTK_CRYPTO]rtk_aes_ecb_alg unregister fail\n");
+   }
+   ret = crypto_unregister_alg(&rtk_aes_cbc_alg);
+   if(ret){
+	printk(KERN_ERR "[RTK_CRYPTO]rtk_aes_cbc_alg unregister fail\n");
+   }
+   ret = crypto_unregister_alg(&rtk_aes_ctr_alg);
+    if(ret){
+	printk(KERN_ERR "[RTK_CRYPTO]rtk_aes_ctr_alg unregister fail\n");
+   }
+   ret = crypto_unregister_shash(&rtk_sha256_alg);
+    if(ret){
+	printk(KERN_ERR "[RTK_CRYPTO]rtk_sha256_alg unregister fail\n");
+   }
+    return ret;
+}
+
+static struct platform_driver rtk_crypto_mcp_driver = {
+    .driver = {
+        .name  = DEVNAME,
+        .owner = THIS_MODULE,
+    },
+    .probe  = rtk_crypto_mcp_probe,
+    .remove = rtk_crypto_mcp_remove,
+};
+
+static int __init rtk_crypto_mcp_init(void)
+{
+    int err;
+    //printk(KERN_ERR "*************alg: rtk_crypto_mcp_init\n");
+    pr_err("%s(#%d)\n", __func__, __LINE__);
+
+    /* using platform_device_alloc() + platform_device_add() 
+     * instead of platform_device_register() to avoid the OOPS, 
+     *     "Device 'brook.0' does not have a release() function,
+     *      it is broken and must be fixed."
+     */
+    rtk_crypto_mcp_device = platform_device_alloc(DEVNAME, 0);
+    if (!rtk_crypto_mcp_device) {
+        pr_err("%s(#%d): platform_device_alloc fail\n",
+               __func__, __LINE__);
+        return -ENOMEM;
+    }
+
+    err = platform_device_add(rtk_crypto_mcp_device);
+    if (err) {
+        pr_err("%s(#%d): platform_device_add failed\n",
+               __func__, __LINE__);
+        goto dev_add_failed;
+    }
+
+    err = platform_driver_register(&rtk_crypto_mcp_driver);
+    if (err) {
+        dev_err(&(rtk_crypto_mcp_device->dev), "%s(#%d): platform_driver_register fail(%d)\n",
+                __func__, __LINE__, err);
+        goto dev_reg_failed;
+    }
+    return err;
+
+dev_add_failed:
+    platform_device_put(rtk_crypto_mcp_device);
+dev_reg_failed:
+    platform_device_unregister(rtk_crypto_mcp_device);
+
+    return err;
+}
+module_init(rtk_crypto_mcp_init);
+
+static void __exit rtk_crypto_mcp_exit(void)
+{
+    dev_info(&(rtk_crypto_mcp_device->dev), "%s(#%d)\n", __func__, __LINE__);
+    platform_device_unregister(rtk_crypto_mcp_device);
+    platform_driver_unregister(&rtk_crypto_mcp_driver);
+}
+module_exit(rtk_crypto_mcp_exit);
+
diff --git a/drivers/crypto/rtk/rtk_crypto.h b/drivers/crypto/rtk/rtk_crypto.h
new file mode 100644
index 00000000..bd700e8
--- /dev/null
+++ b/drivers/crypto/rtk/rtk_crypto.h
@@ -0,0 +1,210 @@
+/*
+ * rtk_crypto_mcp.h - MCP driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/types.h>
+#include <linux/crypto.h>
+
+#define CP_REG_BASE 0x0
+#define TP_REG_BASE 0x0
+#define CP_OTP_LOAD (CP_REG_BASE + 0x19c)
+
+/* for SCPU */
+/* MCP General Registers */
+#define MCP_CTRL (CP_REG_BASE + 0x100)
+#define MCP_STATUS (CP_REG_BASE + 0x104)
+#define MCP_EN (CP_REG_BASE + 0x108)
+#define MCP_CTRL1 (CP_REG_BASE + 0x198)
+
+/* MCP Ring-Buffer Registers */
+#define MCP_BASE (CP_REG_BASE + 0x10c)
+#define MCP_LIMIT (CP_REG_BASE + 0x110)
+#define MCP_RDPTR (CP_REG_BASE + 0x114)
+#define MCP_WRPTR (CP_REG_BASE + 0x118)
+#define MCP_DES_COUNT (CP_REG_BASE + 0x134)
+#define MCP_DES_COMPARE (CP_REG_BASE + 0x138)
+
+/* MCP Ini_Key Registers */
+#define MCP_DES_INI_KEY (CP_REG_BASE + 0x11C)
+#define MCP_AES_INI_KEY (CP_REG_BASE + 0x124)
+
+/* CP Power Management */
+#define PWM_CTRL (CP_REG_BASE + 0x1e0)
+
+/* TP registers */
+#define TP_KEY_INFO_0 (TP_REG_BASE + 0x58)
+#define TP_KEY_INFO_1 (TP_REG_BASE + 0x5c)
+#define TP_KEY_CTRL (TP_REG_BASE + 0x60)
+
+#if 1
+
+#define SET_TP_KEY_CTRL(x,y) writel((x), (volatile unsigned int*) (TP_KEY_CTRL+y))
+#define SET_TP_KEYINFO_0(x,y) writel((x), (volatile unsigned int*) (TP_KEY_INFO_0+y))
+#define SET_TP_KEYINFO_1(x,y) writel((x), (volatile unsigned int*) (TP_KEY_INFO_1+y))
+
+#define SET_MCP_CTRL(x,y) writel((x), (volatile unsigned int*) (MCP_CTRL+y))
+#define SET_MCP_STATUS(x,y) writel((x), (volatile unsigned int*) (MCP_STATUS+y))
+#define SET_MCP_EN(x,y) writel((x), (volatile unsigned int*) (MCP_EN+y))
+#define SET_MCP_BASE(x,y) writel((x), (volatile unsigned int*) (MCP_BASE+y))
+#define SET_MCP_LIMIT(x,y) writel((x), (volatile unsigned int*) (MCP_LIMIT+y))
+#define SET_MCP_RDPTR(x,y) writel((x), (volatile unsigned int*) (MCP_RDPTR+y))
+#define SET_MCP_WRPTR(x,y) writel((x), (volatile unsigned int*) (MCP_WRPTR+y))
+#define SET_MCP_OTP_LOAD(x,y) writel((x), (volatile unsigned int*) (CP_OTP_LOAD+y)) /* for Jupiter only */
+#define SET_MCP_DES_COUNT(x,y) writel((x), (volatile unsigned int*) (MCP_DES_COUNT+y))
+#define SET_MCP_DES_COMPARE(x,y) writel((x), (volatile unsigned int*) (MCP_DES_COMPARE+y))
+
+#define SET_MCP_CTRL1(x,y) writel((x), (volatile unsigned int*) (MCP_CTRL1+y))
+
+#define SET_PWM_CTRL(x,y) writel((x), (volatile unsigned int*) (PWM_CTRL+y))
+
+#define GET_MCP_CTRL(y) readl((volatile unsigned int*) (MCP_CTRL+y))
+#define GET_MCP_STATUS(y) readl((volatile unsigned int*) (MCP_STATUS+y))
+#define GET_MCP_EN(y) readl((volatile unsigned int*) (MCP_EN+y))
+#define GET_MCP_BASE(y) readl((volatile unsigned int*) (MCP_BASE+y))
+#define GET_MCP_LIMIT(y) readl((volatile unsigned int*) (MCP_LIMIT+y))
+#define GET_MCP_RDPTR(y) readl((volatile unsigned int*) (MCP_RDPTR+y))
+#define GET_MCP_WRPTR(y) readl((volatile unsigned int*) (MCP_WRPTR+y))
+#define GET_MCP_OTP_LOAD(y) readl((volatile unsigned int*) (CP_OTP_LOAD+y)) /* for Jupiter only */
+#define GET_MCP_DES_COUNT(y) readl((volatile unsigned int*) (MCP_DES_COUNT+y))
+#define GET_MCP_DES_COMPARE(y) readl((volatile unsigned int*) (MCP_DES_COMPARE+y))
+
+#define GET_PWM_CTRL(y) readl((volatile unsigned int*) (PWM_CTRL+y))
+
+#define GET_MCP_CTRL1(y) readl((volatile unsigned int*) (MCP_CTRL1+y))
+
+#endif
+
+//for IOCTL
+#define MCP_DESC_ENTRY_COUNT 64
+#define MCP_IOCTL_DO_COMMAND 0x70000001
+#define MCP_IOCTL_TEST_AES_H 0x71000001
+
+#define MCP_BCM_ECB 0x0
+#define MCP_BCM_CBC 0x1
+#define MCP_BCM_CTR 0x2
+
+#define MCP_WRITE_DATA (0x01)
+#define MCP_RING_EMPTY (0x01 <<1)
+#define MCP_ERROR (0x01 <<2)
+#define MCP_COMPARE (0x01 <<3)
+#ifdef CONFIG_ARCH_RTD16xx
+#define MCP_KL_DONE (0x01 <<20)
+#define MCP_K_KL_DONE (0x01 <<13)
+#endif
+
+#define MCP_GO (0x01<<1)
+#define MCP_IDEL (0x01<<2)
+#define MCP_SWAP (0x01<<3)
+#define MCP_CLEAR (0x01<<4)
+
+// Descriptor Definition
+#define MARS_MCP_MODE(x) (x & 0x1F)
+
+#define MCP_ALGO_DES 0x00
+#define MCP_ALGO_3DES 0x01
+#define MCP_ALGO_RC4 0x02
+#define MCP_ALGO_MD5 0x03
+#define MCP_ALGO_SHA_1 0x04
+#define MCP_ALGO_AES 0x05
+#define MCP_ALGO_AES_G 0x06
+#define MCP_ALGO_AES_H 0x07
+#define MCP_ALGO_CMAC 0x08
+#define MCP_ALGO_SHA256 0x0b
+
+#define MARS_MCP_BCM(x) ((x & 0x3) << 6)
+#define MCP_BCM_ECB 0x0
+#define MCP_BCM_CBC 0x1
+#define MCP_BCM_CTR 0x2
+
+#define MARS_MCP_ENC(x) ((x & 0x1) << 5)
+
+#define MARS_MCP_KEY_SEL(x) ((x & 0x1) << 12)
+#define MCP_KEY_SEL_OTP 0x1
+#define MCP_KEY_SEL_DESC 0x0
+
+#define MARS_MCP_IV_SEL(x) ((x & 0x1) << 11)
+#define MCP_IV_SEL_REG 0x1
+#define MCP_IV_SEL_DESC 0x0
+
+#define MCP_AES_ECB_Decryption(key, p_in, p_out, len) MCP_AES_Decryption(MCP_BCM_ECB, key, NULL, p_in, p_out, len)
+#define MCP_AES_ECB_Encryption(key, p_in, p_out, len) MCP_AES_Encryption(MCP_BCM_ECB, key, NULL, p_in, p_out, len)
+
+#define mcp_dump_data_with_text(data, len ,fmt, args...)  do {\
+								pr_err(fmt, ## args);\
+								crypto_mcp_dump_mem(data, len);\
+								}while(0)
+
+/* Debug */
+//#define MCP_DEBUG_EN
+#ifdef MCP_DEBUG_EN
+#define mcp_debug(fmt, args...) pr_err("[MCP] Debug, " fmt, ## args)
+#else
+#define mcp_debug(fmt, args...)
+#endif
+
+#ifdef MCP_DEBUG_EN
+#define mcp_info(fmt, args...) pr_err("[MCP] " fmt, ## args)
+#define mcp_warning(fmt, args...) pr_err("[MCP] Warning, " fmt, ## args)
+#else
+#define mcp_info(fmt, args...)
+#define mcp_warning(fmt, args...)
+#endif
+
+
+typedef struct {
+	uint32_t flags;
+	uint32_t key[6];
+	uint32_t iv[4];
+	uint32_t data_in; /* data in : physical address */
+	uint32_t data_out; /* data out : physical address */
+	uint32_t length; /* data length */
+}mcp_desc;
+
+typedef struct {
+	union {
+		mcp_desc __user *p_desc;
+		uint64_t padding_p_desc;
+	};
+
+	uint32_t n_desc;
+	int32_t reserved;
+}mcp_desc_set;
+
+/* 256 bit SHA256 initial vector */
+#define CRYPTO_SHA256_H0		0x6A09E667
+#define CRYPTO_SHA256_H1		0xBB67AE85
+#define CRYPTO_SHA256_H2		0x3C6EF372
+#define CRYPTO_SHA256_H3		0xA54FF53A
+#define CRYPTO_SHA256_H4		0x510E527F
+#define CRYPTO_SHA256_H5		0x9B05688C
+#define CRYPTO_SHA256_H6		0x1F83D9AB
+#define CRYPTO_SHA256_H7		0x5BE0CD19
+
+/*kernel crypto relate*/
+#define AES_MIN_KEY_SIZE	16
+#define AES_MAX_KEY_SIZE	32
+#define AES_KEYSIZE_128		16
+#define AES_KEYSIZE_192		24
+#define AES_KEYSIZE_256		32
+#define AES_BLOCK_SIZE		16
+#define AES_MAX_KEYLENGTH	(15 * 16)
+#define AES_MAX_KEYLENGTH_U32	(AES_MAX_KEYLENGTH / sizeof(u32))
+
+/*
+ * Please ensure that the first two fields are 16-byte aligned
+ * relative to the start of the structure, i.e., don't move them!
+ */
+struct crypto_aes_ctx {
+	u32 key_enc[AES_MAX_KEYLENGTH_U32];
+	u32 key_dec[AES_MAX_KEYLENGTH_U32];
+	u32 key_length;
+};
+
+
diff --git a/drivers/devfreq/Kconfig b/drivers/devfreq/Kconfig
index 41254e7..9f095f5 100644
--- a/drivers/devfreq/Kconfig
+++ b/drivers/devfreq/Kconfig
@@ -113,5 +113,6 @@ config ARM_RK3399_DMC_DEVFREQ
           from hardware.
 
 source "drivers/devfreq/event/Kconfig"
+source "drivers/devfreq/realtek/Kconfig"
 
 endif # PM_DEVFREQ
diff --git a/drivers/devfreq/Makefile b/drivers/devfreq/Makefile
index fbff40a..66d68ef 100644
--- a/drivers/devfreq/Makefile
+++ b/drivers/devfreq/Makefile
@@ -10,6 +10,7 @@ obj-$(CONFIG_DEVFREQ_GOV_PASSIVE)	+= governor_passive.o
 obj-$(CONFIG_ARM_EXYNOS_BUS_DEVFREQ)	+= exynos-bus.o
 obj-$(CONFIG_ARM_RK3399_DMC_DEVFREQ)	+= rk3399_dmc.o
 obj-$(CONFIG_ARM_TEGRA_DEVFREQ)		+= tegra-devfreq.o
+obj-y += realtek/
 
 # DEVFREQ Event Drivers
 obj-$(CONFIG_PM_DEVFREQ_EVENT)		+= event/
diff --git a/drivers/devfreq/realtek/Kconfig b/drivers/devfreq/realtek/Kconfig
new file mode 100644
index 00000000..25ca8aa
--- /dev/null
+++ b/drivers/devfreq/realtek/Kconfig
@@ -0,0 +1,23 @@
+if PM_DEVFREQ
+
+config DEVFREQ_GOV_RTK_LTL
+	tristate "Realtek Long-Term Load"
+	help
+	  LTL governor for Realtek Devfreq Drvier
+
+config RTK_BUS_DEVFREQ
+	tristate "Realtek Bus DEVFREQ Driver"
+	select DEVFREQ_GOV_SIMPLE_ONDEMAND
+	select DEVFREQ_GOV_PASSIVE
+	select DEVFREQ_GOV_RTK_LTL
+	select PM_DEVFREQ_EVENT
+	select PM_OPP
+	help
+	  This adds the DEVFREQ driver for Realtek Bus
+
+config DEVFREQ_EVENT_RTK_BANDWIDTH
+	tristate "Realtek Bandwidth event Driver"
+	help
+	  Realtek Bandwidth event Driver
+
+endif # PM_DEVFREQ
diff --git a/drivers/devfreq/realtek/Makefile b/drivers/devfreq/realtek/Makefile
new file mode 100644
index 00000000..4c6c480
--- /dev/null
+++ b/drivers/devfreq/realtek/Makefile
@@ -0,0 +1,4 @@
+
+obj-$(CONFIG_RTK_BUS_DEVFREQ) += rtk-busfreq.o
+obj-$(CONFIG_DEVFREQ_EVENT_RTK_BANDWIDTH) += event-bandwidth.o
+obj-$(CONFIG_DEVFREQ_GOV_RTK_LTL) += governor_rtk_ltl.o
diff --git a/drivers/devfreq/realtek/event-bandwidth.c b/drivers/devfreq/realtek/event-bandwidth.c
new file mode 100644
index 00000000..88933f9
--- /dev/null
+++ b/drivers/devfreq/realtek/event-bandwidth.c
@@ -0,0 +1,327 @@
+/*
+ * Realtek DDR Bandwidth Event
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2017-2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/devfreq-event.h>
+#include <linux/of.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/atomic.h>
+#include <soc/realtek/perfcnt.h>
+#include <soc/realtek/dcsys.h>
+#include <soc/realtek/dmc.h>
+
+struct bw_event;
+
+struct bw_perfcnt_ops {
+	int (*set_conf)(struct bw_event *);
+	int (*get_load)(struct bw_event *, unsigned long *, unsigned long *, u32);
+};
+
+struct bw_event {
+	struct device *dev;
+	struct perfcnt *pc;
+	const struct bw_perfcnt_ops *ops;
+	u32 has_dc1;
+	struct devfreq_event_dev *edev;
+	atomic_t start_cnt;
+	struct notifier_block nb;
+};
+
+#define BYTE_PER_REQ   16
+#define SEL_VO         0x00
+
+static u32 bw_to_kbyte(u32 byte, u32 interval_ms)
+{
+	u64 val = byte;
+
+	if (interval_ms) {
+		val *= 1000;
+		val /= interval_ms;
+	}
+	return (u32)val / 1024;
+}
+
+static int bw_dcsys_set_conf(struct bw_event *data)
+{
+	perfcnt_set_conf(data->pc, DCSYS_PERFCNT_ID_SYSH_0, SEL_VO | DCSYS_PROG_DCSEL_DC0);
+	perfcnt_set_conf(data->pc, DCSYS_PERFCNT_ID_SYSH_1, SEL_VO | DCSYS_PROG_DCSEL_DC1);
+	return 0;
+}
+
+static int bw_dcsys_get_load(struct bw_event *data,
+			     unsigned long *load,
+			     unsigned long *total,
+			     u32 interval)
+
+{
+
+	struct perfcnt_data dc0;
+	struct perfcnt_data dc0_vo;
+	struct perfcnt_data dc1;
+	struct perfcnt_data dc1_vo;
+	int ret;
+
+	*load = *total = 0;
+
+	ret = perfcnt_get_data(data->pc, DCSYS_PERFCNT_ID_TOTAL_0, &dc0);
+	if (!ret)
+		*total += bw_to_kbyte(dc0.data[1] * BYTE_PER_REQ, interval);
+	ret = perfcnt_get_data(data->pc, DCSYS_PERFCNT_ID_SYSH_0, &dc0_vo);
+	if (!ret)
+		*load += bw_to_kbyte(dc0_vo.data[3] * BYTE_PER_REQ, interval);
+
+	if (!data->has_dc1)
+		return 0;
+
+	ret = perfcnt_get_data(data->pc, DCSYS_PERFCNT_ID_TOTAL_1, &dc1);
+	if (!ret)
+		*total += bw_to_kbyte(dc1.data[1] * BYTE_PER_REQ, interval);
+	ret = perfcnt_get_data(data->pc, DCSYS_PERFCNT_ID_SYSH_1, &dc1_vo);
+	if (!ret)
+		*load += bw_to_kbyte(dc1_vo.data[3] * BYTE_PER_REQ, interval);
+	return 0;
+}
+
+static const struct bw_perfcnt_ops bw_dcsys_ops = {
+	.set_conf = bw_dcsys_set_conf,
+	.get_load = bw_dcsys_get_load,
+};
+
+static int bw_dmc_get_load(struct bw_event *data,
+			   unsigned long *load,
+			   unsigned long *total,
+			   u32 interval)
+{
+	struct perfcnt_data dmc_cpu;
+	struct perfcnt_data dmc_gpu;
+	int ret;
+
+	*load = *total = 0;
+
+	ret = perfcnt_get_data(data->pc, DMC_PERFCNT_ID_CPU, &dmc_cpu);
+	if (!ret)
+		*total += bw_to_kbyte(dmc_cpu.data[0] * BYTE_PER_REQ, interval);
+	ret = perfcnt_get_data(data->pc, DMC_PERFCNT_ID_GPU, &dmc_gpu);
+	if (!ret)
+		*total += bw_to_kbyte(dmc_gpu.data[0] * BYTE_PER_REQ, interval);
+	return 0;
+}
+
+static const struct bw_perfcnt_ops bw_dmc_ops = {
+	.get_load = bw_dmc_get_load,
+};
+
+static int bw_event_start(struct bw_event *data)
+{
+	int ret = 0;
+
+	if (atomic_inc_return(&data->start_cnt) != 1)
+		return -EBUSY;
+
+	if (data->ops->set_conf)
+		data->ops->set_conf(data);
+
+	ret = perfcnt_start(data->pc);
+	if (ret)
+		pr_warn("perfcnt_start() returns %d\n", ret);
+	return 0;
+}
+
+static int bw_event_stop(struct bw_event *data)
+{
+	int ret;
+
+	if (atomic_dec_return(&data->start_cnt) != 0)
+		return -EBUSY;
+
+	ret = perfcnt_stop(data->pc);
+	if (ret)
+		pr_warn("perfcnt_stop() returns %d\n", ret);
+	return 0;
+}
+
+static int bw_evnet_perfcnt_notifier(struct notifier_block *nb,
+				     unsigned long action,
+				     void *d)
+{
+	struct bw_event *data = container_of(nb, struct bw_event, nb);
+	struct perfcnt_change_data *pccd = d;
+
+	switch (action) {
+	case PERFCNT_EVENT_PRE_CHANGE:
+		if (pccd->old_pc != data->pc)
+			break;
+		dev_info(data->dev, "perfcnt suspend\n");
+		bw_event_stop(data);
+		break;
+	case PERFCNT_EVENT_POST_CHANGE:
+		if (pccd->new_pc != data->pc)
+			break;
+		dev_info(data->dev, "perfcnt resume\n");
+		bw_event_start(data);
+		break;
+	}
+	return NOTIFY_OK;
+}
+
+static int bw_event_get_event(struct devfreq_event_dev *edev,
+			      struct devfreq_event_data *edata)
+{
+	struct bw_event *data = edev->desc->driver_data;
+	int ret;
+	u32 interval_ms;
+
+	edata->load_count  = 0;
+	edata->total_count = 0;
+
+	ret = bw_event_stop(data);
+	if (ret)
+		return ret == -EBUSY ? 0 : ret;
+
+	perfcnt_last_duration(data->pc, &interval_ms);
+	data->ops->get_load(data, &edata->load_count, &edata->total_count,
+		interval_ms);
+	return 0;
+}
+
+static int bw_event_set_event(struct devfreq_event_dev *edev)
+{
+	struct bw_event *data = edev->desc->driver_data;
+	int ret;
+
+	ret = bw_event_start(data);
+	if (ret == -EBUSY)
+		return 0;
+	return ret;
+}
+
+static int bw_event_enable(struct devfreq_event_dev *edev)
+{
+	struct bw_event *data = edev->desc->driver_data;
+	int ret = 0;
+
+	perfcnt_request(data->pc);
+
+	//ret = bw_event_start(data);
+	//if (ret == -EBUSY)
+	//	return 0;
+	return ret;
+}
+
+static int bw_event_disable(struct devfreq_event_dev *edev)
+{
+	struct bw_event *data = edev->desc->driver_data;
+	int ret = 0;
+
+	perfcnt_release(data->pc);
+
+	//ret = bw_event_stop(data);
+	//if (ret == -EBUSY)
+	//	return 0;
+	return ret;
+}
+
+static int bw_event_reset(struct devfreq_event_dev *edev)
+{
+	struct bw_event *data = edev->desc->driver_data;
+
+	atomic_set(&data->start_cnt, 0);
+	return 0;
+}
+
+static const struct devfreq_event_ops bw_event_ops = {
+	.enable    = bw_event_enable,
+	.disable   = bw_event_disable,
+	.set_event = bw_event_set_event,
+	.get_event = bw_event_get_event,
+	.reset     = bw_event_reset,
+};
+
+static const struct of_device_id bw_event_ids[];
+
+static int bw_event_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	const struct of_device_id *id;
+	const struct bw_perfcnt_ops *ops;
+	struct devfreq_event_desc *desc;
+
+	struct bw_event *data;
+	int ret;
+
+	dev_info(dev, "%s\n", __func__);
+	if (!of_device_is_compatible(np, "devfreq-event"))
+		return -EINVAL;
+
+	id = of_match_node(bw_event_ids, np);
+	if (id)
+		ops = id->data;
+	if (!id || !ops)
+		return -EINVAL;
+
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	desc = devm_kzalloc(dev, sizeof(*desc),GFP_KERNEL);
+	if (!desc)
+		return -ENOMEM;
+
+	desc->name = np->name;
+	desc->ops = &bw_event_ops;
+	desc->driver_data = data;
+
+	atomic_set(&data->start_cnt, 0);
+	data->dev = dev;
+	data->ops = ops;
+	data->pc = perfcnt_get(dev, NULL);
+	if (IS_ERR(data->pc)) {
+		ret = PTR_ERR(data->pc);
+		dev_err(dev, "perfcnt_get() returns %d\n", ret);
+		return ret;
+	}
+
+	data->nb.notifier_call = bw_evnet_perfcnt_notifier;
+	perfcnt_register_notifier(data->pc, &data->nb);
+
+	data->edev = devfreq_event_add_edev(&pdev->dev, desc);
+	if (IS_ERR(data->edev)) {
+		ret = PTR_ERR(data->edev);
+		goto error;
+	}
+	return 0;
+
+error:
+	perfcnt_put(data->pc);
+	return ret;
+}
+
+static const struct of_device_id bw_event_ids[] = {
+	{ .compatible = "realtek,bw-event-dcsys", .data = &bw_dcsys_ops, },
+	{ .compatible = "realtek,bw-event-dmc", .data = &bw_dmc_ops, },
+	{}
+};
+
+static struct platform_driver bw_event_driver = {
+	.driver = {
+		.name  = "rtk-bw-event",
+		.of_match_table = bw_event_ids,
+	},
+	.probe = bw_event_probe,
+};
+
+static int __init bw_event_init(void)
+{
+	return platform_driver_register(&bw_event_driver);
+}
+device_initcall(bw_event_init);
+
diff --git a/drivers/devfreq/realtek/governor_rtk_ltl.c b/drivers/devfreq/realtek/governor_rtk_ltl.c
new file mode 100644
index 00000000..4cc1e20
--- /dev/null
+++ b/drivers/devfreq/realtek/governor_rtk_ltl.c
@@ -0,0 +1,173 @@
+/*
+ * LTL Governor
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/errno.h>
+#include <linux/module.h>
+#include <linux/devfreq.h>
+#include <linux/math64.h>
+#include "../governor.h"
+#include <soc/realtek/devfreq_gov_data.h>
+
+#define DEFAULT_CAP_LONG      (200)
+#define DEFAULT_TH_CAP        (60)
+#define DEFAULT_TH_CAP_SHORT  (45)
+#define DEFAULT_TH_CAP_LONG   (30)
+
+#define weight(_v0, _w0, _v1, _w1)  \
+	(((_v0) * (_w0) + (_v1) * (_w1)) / ((_w0) + (_w1)))
+
+static int devfreq_ltl_func(struct devfreq *df,
+			    unsigned long *freq)
+{
+	struct devfreq_dev_status *stat;
+	struct devfreq_ltl_data *d = df->data;
+	int th_cap = DEFAULT_TH_CAP;
+	int th_cap_short = DEFAULT_TH_CAP_SHORT;
+	int th_cap_long = DEFAULT_TH_CAP_LONG;
+	int cap;
+	int err;
+
+	err = devfreq_update_stats(df);
+	if (err)
+		return err;
+
+	stat = &df->last_status;
+	*freq = UINT_MAX;
+
+	if (!d)
+		goto check;
+	if (d->th_cap)
+		th_cap = d->th_cap;
+	if (d->th_cap_short)
+		th_cap_short = d->th_cap_short;
+	if (d->th_cap_long)
+		th_cap_long = d->th_cap_long;
+
+	cap = (stat->total_time - stat->busy_time) / 1000;
+	if (!cap)
+		goto check;
+
+	d->weighted_cap_long = weight(cap, 5, d->weighted_cap_long, 95);
+	d->weighted_cap_short = weight(cap, 50, d->weighted_cap_short, 50);
+	pr_debug("%s: cap=%d, cap_s=%d, cap_l=%d\n",
+		__func__, cap, d->weighted_cap_short, d->weighted_cap_long);
+	d->prev_cap = cap;
+
+	if (cap < th_cap
+	    && d->weighted_cap_short < th_cap_short
+	    && d->weighted_cap_long < th_cap_long)
+		*freq = 0;
+check:
+	if (df->min_freq && *freq < df->min_freq)
+		*freq = df->min_freq;
+	if (df->max_freq && *freq > df->max_freq)
+		*freq = df->max_freq;
+
+	return 0;
+}
+
+static void devfreq_ltl_data_reset(struct devfreq_ltl_data *ltl_data)
+{
+	ltl_data->weighted_cap_long = ltl_data->th_cap_long * 2;
+	if (!ltl_data->weighted_cap_long)
+		ltl_data->weighted_cap_long = DEFAULT_CAP_LONG;
+}
+
+static int devfreq_ltl_notifier_call(struct notifier_block *nb,
+				     unsigned long event,
+				     void *ptr)
+{
+	struct devfreq_freqs *freqs = (struct devfreq_freqs *)ptr;
+	struct devfreq_ltl_data *ltl_data = container_of(nb, struct devfreq_ltl_data, nb);
+
+	switch (event) {
+	case DEVFREQ_POSTCHANGE:
+		if (freqs->old < freqs->new) {
+			devfreq_ltl_data_reset(ltl_data);
+			pr_debug("%s: reset weighted_cap_long=%d\n", __func__, ltl_data->weighted_cap_long);
+		}
+		break;
+
+	}
+	return NOTIFY_DONE;
+}
+
+static int devfreq_ltl_handler(struct devfreq *devfreq,
+			       unsigned int event,
+			       void *data)
+{
+	struct devfreq_ltl_data *ltl_data = devfreq->data;
+	struct device *dev = devfreq->dev.parent;
+	int ret;
+
+	switch (event) {
+	case DEVFREQ_GOV_START:
+		ltl_data->nb.notifier_call = devfreq_ltl_notifier_call;
+		ret = devm_devfreq_register_notifier(dev, devfreq, &ltl_data->nb,
+			DEVFREQ_TRANSITION_NOTIFIER);
+		if (ret)
+			return ret;
+		devfreq_ltl_data_reset(ltl_data);
+
+		devfreq_monitor_start(devfreq);
+		break;
+
+	case DEVFREQ_GOV_STOP:
+		devfreq_monitor_stop(devfreq);
+		devm_devfreq_unregister_notifier(dev, devfreq, &ltl_data->nb,
+			DEVFREQ_TRANSITION_NOTIFIER);
+		break;
+
+	case DEVFREQ_GOV_INTERVAL:
+		devfreq_interval_update(devfreq, (unsigned int *)data);
+		break;
+
+	case DEVFREQ_GOV_SUSPEND:
+		devfreq_monitor_suspend(devfreq);
+		break;
+
+	case DEVFREQ_GOV_RESUME:
+		devfreq_ltl_data_reset(ltl_data);
+		devfreq_monitor_resume(devfreq);
+		break;
+
+	default:
+		break;
+	}
+
+	return 0;
+}
+
+static struct devfreq_governor devfreq_ltl = {
+	.name = "ltl",
+	.immutable = 1,
+	.get_target_freq = devfreq_ltl_func,
+	.event_handler = devfreq_ltl_handler,
+};
+
+static int __init devfreq_ltl_init(void)
+{
+	return devfreq_add_governor(&devfreq_ltl);
+}
+subsys_initcall(devfreq_ltl_init);
+
+static void __exit devfreq_ltl_exit(void)
+{
+	int ret;
+
+	ret = devfreq_remove_governor(&devfreq_ltl);
+	if (ret)
+		pr_err("%s: failed remove governor %d\n", __func__, ret);
+
+	return;
+}
+module_exit(devfreq_ltl_exit);
+MODULE_LICENSE("GPL");
diff --git a/drivers/devfreq/realtek/rtk-busfreq.c b/drivers/devfreq/realtek/rtk-busfreq.c
new file mode 100644
index 00000000..b8a46ba
--- /dev/null
+++ b/drivers/devfreq/realtek/rtk-busfreq.c
@@ -0,0 +1,455 @@
+/*
+ * rtk-busfreq.c - Realtek Generic Bus DFS Driver
+ *
+ * Copyright (C) 2017,2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2017,2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#define pr_fmt(fmt) "busfreq: " fmt
+
+#include <linux/clk.h>
+#include <linux/devfreq.h>
+#include <linux/devfreq-event.h>
+#include <linux/io.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/platform_device.h>
+#include <linux/pm_opp.h>
+#include <linux/pm_runtime.h>
+#include <linux/slab.h>
+#include <linux/suspend.h>
+#include <linux/sysfs.h>
+#include <soc/realtek/devfreq_gov_data.h>
+
+enum {
+	BUSFREQ_GOV_PASSIVE,
+	BUSFREQ_GOV_LTL,
+	BUSFREQ_GOV_OTHER,
+};
+
+struct busfreq_data {
+	struct device *dev;
+	struct devfreq *devfreq;
+	struct clk *clk;
+
+	struct devfreq_dev_profile *profile;
+	int gov_id;
+	const char *gov_name;
+	void *gov_data;
+
+	struct devfreq_event_dev **edev;
+	int edev_count;
+
+	unsigned long cur_freq;
+	unsigned long min_freq;
+	unsigned long max_freq;
+	unsigned long suspend_freq;
+};
+
+
+static inline void busfreq_enable_edev(struct busfreq_data *priv)
+{
+	int i;
+	int ret;
+
+	for (i = 0; i < priv->edev_count; i++) {
+		ret = devfreq_event_enable_edev(priv->edev[i]);
+		if (ret)
+			dev_warn(priv->dev, "edev%d: devfreq_event_enable_edev() returns %d\n",
+				i, ret);
+	}
+}
+
+static inline void busfreq_disable_edev(struct busfreq_data *priv)
+{
+	int i;
+	int ret;
+
+	for (i = 0; i < priv->edev_count; i++) {
+		ret = devfreq_event_disable_edev(priv->edev[i]);
+		if (ret)
+			dev_warn(priv->dev, "edev%d: devfreq_event_disable_edev() returns %d\n",
+				i, ret);
+	}
+}
+
+static inline void busfreq_restart_edev(struct busfreq_data *priv)
+{
+	int i;
+	int ret;
+
+	for (i = 0; i < priv->edev_count; i++) {
+		ret = devfreq_event_set_event(priv->edev[i]);
+		if (ret)
+			dev_warn(priv->dev, "edev%d: devfreq_event_set_event() returns %d\n",
+				i, ret);
+	}
+}
+
+static int busfreq_get_dev_status(struct device *dev,
+				  struct devfreq_dev_status *stat)
+{
+	struct busfreq_data *priv = dev_get_drvdata(dev);
+	int i;
+	int ret;
+	int no_data = 0;
+
+	stat->current_frequency = priv->cur_freq;
+	stat->busy_time = stat->total_time = 0;
+
+	for (i = 0; i < priv->edev_count; i++) {
+		struct devfreq_event_data evdata;
+
+		if (!priv->edev[i])
+			continue;
+
+		ret = devfreq_event_get_event(priv->edev[i], &evdata);
+		if (ret) {
+			dev_warn(dev, "edev%d: devfreq_event_get_event() returns %d\n",
+				i, ret);
+			continue;
+		}
+
+		dev_dbg(dev, "%s: edev%d: %ld / %ld\n", __func__,
+			i, evdata.load_count, evdata.total_count);
+
+		if (evdata.total_count == 0)
+			no_data |= 1;
+		stat->busy_time += evdata.load_count;
+		stat->total_time += evdata.total_count;
+	}
+	if (no_data)
+		stat->busy_time = stat->total_time = 0;
+	busfreq_restart_edev(priv);
+
+	return 0;
+}
+
+static int busfreq_get_cur_freq(struct device *dev, unsigned long *freq)
+{
+	struct busfreq_data *priv = dev_get_drvdata(dev);
+
+	*freq = priv->cur_freq;
+	return 0;
+}
+
+static int busfreq_set_clk_freq(struct busfreq_data *priv,
+	   unsigned long new_freq)
+{
+	struct device *dev = priv->dev;
+	int ret;
+
+	if (priv->cur_freq == new_freq)
+		return 0;
+
+	dev_dbg(dev, "%s: set freq to %lu\n", __func__, new_freq);
+	ret = clk_set_rate(priv->clk, new_freq);
+	if (ret) {
+		dev_err(dev, "clk_set_rate() returns %d\n", ret);
+		return ret;
+	}
+	priv->cur_freq = new_freq;
+	return 0;
+}
+
+
+static int busfreq_target(struct device *dev,
+			  unsigned long *freq,
+			  u32 flags)
+{
+	struct busfreq_data *priv = dev_get_drvdata(dev);
+	struct dev_pm_opp *new_opp;
+	unsigned long new_freq;
+
+	rcu_read_lock();
+	new_opp = devfreq_recommended_opp(dev, freq, flags);
+	if (IS_ERR(new_opp)) {
+		rcu_read_unlock();
+		dev_err(dev, "Failed to find opp for %lu KHz\n", *freq);
+		return PTR_ERR(new_opp);
+	}
+
+	new_freq = dev_pm_opp_get_freq(new_opp);
+	rcu_read_unlock();
+
+	return busfreq_set_clk_freq(priv, new_freq);
+}
+
+static int busfreq_suspend(struct device *dev)
+{
+	struct busfreq_data *priv = dev_get_drvdata(dev);
+	unsigned long target = priv->suspend_freq;
+
+	dev_info(dev, "%s enter\n", __func__);
+
+	busfreq_disable_edev(priv);
+	devfreq_suspend_device(priv->devfreq);
+
+#ifdef CONFIG_SUSPEND
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY)
+		target = priv->min_freq;
+#endif
+	busfreq_set_clk_freq(priv, target);
+	dev_info(dev, "%s exit\n", __func__);
+	return 0;
+}
+
+static int busfreq_resume(struct device *dev)
+{
+	struct busfreq_data *priv = dev_get_drvdata(dev);
+
+	dev_info(dev, "%s enter\n", __func__);
+	busfreq_set_clk_freq(priv, priv->max_freq);
+	busfreq_enable_edev(priv);
+	devfreq_resume_device(priv->devfreq);
+	dev_info(dev, "%s exit\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops busfreq_pm_ops = {
+	SET_LATE_SYSTEM_SLEEP_PM_OPS(busfreq_suspend, busfreq_resume)
+};
+
+static int busfreq_add_edevs(struct busfreq_data *priv)
+{
+	struct device *dev = priv->dev;
+	int i;
+
+	priv->edev_count = devfreq_event_get_edev_count(dev);
+	if (priv->edev_count < 0)
+		priv->edev_count = 0;
+
+	priv->edev = devm_kcalloc(dev, priv->edev_count, sizeof(*priv->edev),
+		GFP_KERNEL);
+	if (!priv->edev)
+		return -ENOMEM;
+
+	for (i = 0; i < priv->edev_count; i++) {
+		priv->edev[i] = devfreq_event_get_edev_by_phandle(dev, i);
+		if (IS_ERR(priv->edev[i]))
+			return -EPROBE_DEFER;
+	}
+	return 0;
+}
+
+static int busfreq_setup_ltl(struct busfreq_data *priv)
+{
+	struct device *dev = priv->dev;
+	struct devfreq_ltl_data *ltl_data;
+	struct devfreq_dev_profile *profile = priv->profile;
+	int ret;
+	u32 data[3];
+
+	ltl_data = devm_kzalloc(dev, sizeof(*ltl_data), GFP_KERNEL);
+	if (!ltl_data)
+		return -ENOMEM;
+
+	ret = of_property_read_u32_array(dev->of_node, "ltl-data", data, 3);
+	if (!ret) {
+		ltl_data->th_cap       = data[0];
+		ltl_data->th_cap_short = data[1];
+		ltl_data->th_cap_long  = data[2];
+	}
+	priv->gov_data = ltl_data;
+
+	profile->target         = busfreq_target;
+	profile->get_dev_status = busfreq_get_dev_status;
+	profile->get_cur_freq   = busfreq_get_cur_freq;
+	profile->polling_ms     = 1000;
+	profile->initial_freq   = priv->cur_freq;
+	return 0;
+}
+
+static int busfreq_setup_passive(struct busfreq_data *priv)
+{
+	struct device *dev = priv->dev;
+	struct devfreq_dev_profile *profile = priv->profile;
+	struct devfreq_passive_data *passive_data;
+	int ret;
+
+	passive_data = devm_kzalloc(dev, sizeof(*passive_data), GFP_KERNEL);
+	if (!passive_data)
+		return -ENOMEM;
+	passive_data->parent = devfreq_get_devfreq_by_phandle(dev, 0);
+	if (IS_ERR(passive_data->parent)) {
+		ret = PTR_ERR(passive_data->parent);
+		dev_err(dev, "devfreq_get_devfreq_by_phandle() returns %d\n", ret);
+		return ret;
+	}
+
+	priv->gov_data = passive_data;
+
+	profile->target         = busfreq_target;
+	profile->get_cur_freq   = busfreq_get_cur_freq;
+	profile->polling_ms     = 1000;
+	profile->initial_freq   = priv->cur_freq;
+	return 0;
+}
+
+static int busfreq_setup_devfreq(struct busfreq_data *priv)
+{
+	struct device *dev = priv->dev;
+	struct device_node *np = dev->of_node;
+	struct devfreq_dev_profile *profile;
+	int ret;
+
+	priv->profile = devm_kzalloc(dev, sizeof(*profile), GFP_KERNEL);
+	if (!priv->profile)
+		return -ENOMEM;
+	profile = priv->profile;
+
+	ret = of_property_read_string(np, "method", &priv->gov_name);
+	if (ret) {
+		dev_err(dev, "invalid governor\n");
+		return ret;
+	}
+
+	if (!strncmp("ltl", priv->gov_name, 3)) {
+		priv->gov_id = BUSFREQ_GOV_LTL;
+		ret = busfreq_setup_ltl(priv);
+		if (ret) {
+			dev_err(dev, "busfreq_setup_ltl() returns %d\n", ret);
+			return ret;
+		}
+	} else if (!strncmp("passive", priv->gov_name, 7)) {
+		priv->gov_id = BUSFREQ_GOV_PASSIVE;
+		ret = busfreq_setup_passive(priv);
+		if (ret) {
+			dev_err(dev, "busfreq_setup_passive() returns %d\n", ret);
+			return ret;
+		}
+	} else {
+		dev_err(dev, "invalid governor name: %s\n", priv->gov_name);
+		return -EINVAL;
+	}
+	return 0;
+}
+
+static int busfreq_setup_freq(struct busfreq_data *priv)
+{
+	struct device *dev = priv->dev;
+	struct dev_pm_opp *opp;
+	int ret = 0;
+	unsigned long target_freq;
+
+	priv->cur_freq = clk_get_rate(priv->clk);
+
+	rcu_read_lock();
+
+	target_freq = 0;
+	opp = dev_pm_opp_find_freq_ceil(dev, &target_freq);
+	if (IS_ERR(opp)) {
+		ret = PTR_ERR(opp);
+		dev_err(dev, "failed to get min_freq\n");
+		goto error;
+	}
+	priv->min_freq = target_freq;
+
+	target_freq = ULONG_MAX;
+	opp = dev_pm_opp_find_freq_floor(dev, &target_freq);
+	if (IS_ERR(opp)) {
+		ret = PTR_ERR(opp);
+		dev_err(dev, "failed to get max_freq\n");
+		goto error;
+	}
+	priv->max_freq = target_freq;
+
+	opp = dev_pm_opp_get_suspend_opp(dev);
+	if (IS_ERR(opp)) {
+		dev_warn(dev, "invalid suspend_freq, use max_freq\n");
+		priv->suspend_freq = priv->max_freq;
+	} else
+		priv->suspend_freq = dev_pm_opp_get_freq(opp);
+error:
+	rcu_read_unlock();
+
+	dev_info(dev, "cur_freq = %lu\n", priv->cur_freq);
+	dev_info(dev, "max_freq = %lu Hz\n", priv->max_freq);
+	dev_info(dev, "min_freq = %lu Hz\n", priv->min_freq);
+	dev_info(dev, "suspend_freq = %lu Hz\n", priv->suspend_freq);
+
+	return ret;
+
+}
+
+static int busfreq_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct busfreq_data *priv;
+	int ret;
+
+	dev_info(dev, "%s\n", __func__);
+
+	priv = devm_kzalloc(dev, sizeof(*priv), GFP_KERNEL);
+	if (!priv)
+		return -ENOMEM;
+	priv->dev = dev;
+
+	ret = busfreq_add_edevs(priv);
+	if (ret)
+		return ret;
+
+	priv->clk = devm_clk_get(dev, NULL);
+	if (IS_ERR(priv->clk)) {
+		ret = PTR_ERR(priv->clk);
+		dev_err(dev, "clk_get() returns %d\n", ret);
+		return ret;
+	}
+
+	ret = dev_pm_opp_of_add_table(dev);
+	if (ret) {
+		dev_err(dev, "dev_pm_opp_of_add_table() returns %d\n", ret);
+		return ret;
+	}
+
+	ret = busfreq_setup_freq(priv);
+	if (ret)
+		goto remove_table;
+
+	ret = busfreq_setup_devfreq(priv);
+	if (ret)
+		goto remove_table;
+
+	priv->devfreq = devm_devfreq_add_device(dev,
+					        priv->profile,
+						priv->gov_name,
+						priv->gov_data);
+	if (IS_ERR(priv->devfreq)) {
+		ret = PTR_ERR(priv->devfreq);
+		dev_err(dev, "devfreq_add_device() returns %d\n", ret);
+		goto remove_table;
+	}
+
+	platform_set_drvdata(pdev, priv);
+	busfreq_enable_edev(priv);
+	return 0;
+
+remove_table:
+	dev_pm_opp_of_remove_table(dev);
+	return ret;
+}
+
+static const struct of_device_id busfreq_ids[] = {
+	{ .compatible = "realtek,busfreq", },
+	{}
+};
+
+static struct platform_driver busfreq_driver = {
+	.driver = {
+		.owner = THIS_MODULE,
+		.name  = "rtk-busfreq",
+		.pm = &busfreq_pm_ops,
+		.of_match_table = busfreq_ids,
+	},
+	.probe = busfreq_probe,
+};
+
+static int __init busfreq_init(void)
+{
+	return platform_driver_register(&busfreq_driver);
+}
+late_initcall(busfreq_init);
+
diff --git a/drivers/dma-buf/fence.c b/drivers/dma-buf/fence.c
index 04bf298..883b3be 100644
--- a/drivers/dma-buf/fence.c
+++ b/drivers/dma-buf/fence.c
@@ -68,6 +68,8 @@ int fence_signal_locked(struct fence *fence)
 	struct fence_cb *cur, *tmp;
 	int ret = 0;
 
+	lockdep_assert_held(fence->lock);
+
 	if (WARN_ON(!fence))
 		return -EINVAL;
 
@@ -159,9 +161,6 @@ int fence_signal(struct fence *fence)
 	if (WARN_ON(timeout < 0))
 		return -EINVAL;
 
-	if (timeout == 0)
-		return fence_is_signaled(fence);
-
 	trace_fence_wait_start(fence);
 	ret = fence->ops->wait(fence, intr, timeout);
 	trace_fence_wait_end(fence);
@@ -329,8 +328,12 @@ int fence_get_status(struct fence *fence)
 	spin_lock_irqsave(fence->lock, flags);
 
 	ret = !list_empty(&cb->node);
-	if (ret)
+	if (ret) {
 		list_del_init(&cb->node);
+		if (list_empty(&fence->cb_list))
+			if (fence->ops->disable_signaling)
+				fence->ops->disable_signaling(fence);
+	}
 
 	spin_unlock_irqrestore(fence->lock, flags);
 
diff --git a/drivers/dma-buf/reservation.c b/drivers/dma-buf/reservation.c
index 723d8af..82f35a4 100644
--- a/drivers/dma-buf/reservation.c
+++ b/drivers/dma-buf/reservation.c
@@ -280,18 +280,24 @@ int reservation_object_get_fences_rcu(struct reservation_object *obj,
 				      unsigned *pshared_count,
 				      struct fence ***pshared)
 {
-	unsigned shared_count = 0;
-	unsigned retry = 1;
-	struct fence **shared = NULL, *fence_excl = NULL;
-	int ret = 0;
+	struct fence **shared = NULL;
+	struct fence *fence_excl;
+	unsigned int shared_count;
+	int ret = 1;
 
-	while (retry) {
+	do {
 		struct reservation_object_list *fobj;
 		unsigned seq;
+		unsigned int i;
 
-		seq = read_seqcount_begin(&obj->seq);
+		shared_count = i = 0;
 
 		rcu_read_lock();
+		seq = read_seqcount_begin(&obj->seq);
+
+		fence_excl = rcu_dereference(obj->fence_excl);
+		if (fence_excl && !fence_get_rcu(fence_excl))
+			goto unlock;
 
 		fobj = rcu_dereference(obj->fence);
 		if (fobj) {
@@ -309,52 +315,37 @@ int reservation_object_get_fences_rcu(struct reservation_object *obj,
 				}
 
 				ret = -ENOMEM;
-				shared_count = 0;
 				break;
 			}
 			shared = nshared;
-			memcpy(shared, fobj->shared, sz);
 			shared_count = fobj->shared_count;
-		} else
-			shared_count = 0;
-		fence_excl = rcu_dereference(obj->fence_excl);
-
-		retry = read_seqcount_retry(&obj->seq, seq);
-		if (retry)
-			goto unlock;
-
-		if (!fence_excl || fence_get_rcu(fence_excl)) {
-			unsigned i;
 
 			for (i = 0; i < shared_count; ++i) {
-				if (fence_get_rcu(shared[i]))
-					continue;
-
-				/* uh oh, refcount failed, abort and retry */
-				while (i--)
-					fence_put(shared[i]);
-
-				if (fence_excl) {
-					fence_put(fence_excl);
-					fence_excl = NULL;
-				}
-
-				retry = 1;
-				break;
+				shared[i] = rcu_dereference(fobj->shared[i]);
+				if (!fence_get_rcu(shared[i]))
+					break;
 			}
-		} else
-			retry = 1;
+		}
 
+		if (i != shared_count || read_seqcount_retry(&obj->seq, seq)) {
+			while (i--)
+				fence_put(shared[i]);
+			fence_put(fence_excl);
+			goto unlock;
+		}
+
+		ret = 0;
 unlock:
 		rcu_read_unlock();
-	}
-	*pshared_count = shared_count;
-	if (shared_count)
-		*pshared = shared;
-	else {
-		*pshared = NULL;
+	} while (ret);
+
+	if (!shared_count) {
 		kfree(shared);
+		shared = NULL;
 	}
+
+	*pshared_count = shared_count;
+	*pshared = shared;
 	*pfence_excl = fence_excl;
 
 	return ret;
@@ -379,10 +370,7 @@ long reservation_object_wait_timeout_rcu(struct reservation_object *obj,
 {
 	struct fence *fence;
 	unsigned seq, shared_count, i = 0;
-	long ret = timeout;
-
-	if (!timeout)
-		return reservation_object_test_signaled_rcu(obj, wait_all);
+	long ret = timeout ? timeout : 1;
 
 retry:
 	fence = NULL;
@@ -397,9 +385,6 @@ long reservation_object_wait_timeout_rcu(struct reservation_object *obj,
 		if (fobj)
 			shared_count = fobj->shared_count;
 
-		if (read_seqcount_retry(&obj->seq, seq))
-			goto unlock_retry;
-
 		for (i = 0; i < shared_count; ++i) {
 			struct fence *lfence = rcu_dereference(fobj->shared[i]);
 
@@ -422,9 +407,6 @@ long reservation_object_wait_timeout_rcu(struct reservation_object *obj,
 	if (!shared_count) {
 		struct fence *fence_excl = rcu_dereference(obj->fence_excl);
 
-		if (read_seqcount_retry(&obj->seq, seq))
-			goto unlock_retry;
-
 		if (fence_excl &&
 		    !test_bit(FENCE_FLAG_SIGNALED_BIT, &fence_excl->flags)) {
 			if (!fence_get_rcu(fence_excl))
@@ -439,6 +421,11 @@ long reservation_object_wait_timeout_rcu(struct reservation_object *obj,
 
 	rcu_read_unlock();
 	if (fence) {
+		if (read_seqcount_retry(&obj->seq, seq)) {
+			fence_put(fence);
+			goto retry;
+		}
+
 		ret = fence_wait_timeout(fence, intr, ret);
 		fence_put(fence);
 		if (ret > 0 && wait_all && (i + 1 < shared_count))
@@ -484,12 +471,13 @@ bool reservation_object_test_signaled_rcu(struct reservation_object *obj,
 					  bool test_all)
 {
 	unsigned seq, shared_count;
-	int ret = true;
+	int ret;
 
+	rcu_read_lock();
 retry:
+	ret = true;
 	shared_count = 0;
 	seq = read_seqcount_begin(&obj->seq);
-	rcu_read_lock();
 
 	if (test_all) {
 		unsigned i;
@@ -500,46 +488,35 @@ bool reservation_object_test_signaled_rcu(struct reservation_object *obj,
 		if (fobj)
 			shared_count = fobj->shared_count;
 
-		if (read_seqcount_retry(&obj->seq, seq))
-			goto unlock_retry;
-
 		for (i = 0; i < shared_count; ++i) {
 			struct fence *fence = rcu_dereference(fobj->shared[i]);
 
 			ret = reservation_object_test_signaled_single(fence);
 			if (ret < 0)
-				goto unlock_retry;
+				goto retry;
 			else if (!ret)
 				break;
 		}
 
-		/*
-		 * There could be a read_seqcount_retry here, but nothing cares
-		 * about whether it's the old or newer fence pointers that are
-		 * signaled. That race could still have happened after checking
-		 * read_seqcount_retry. If you care, use ww_mutex_lock.
-		 */
+		if (read_seqcount_retry(&obj->seq, seq))
+			goto retry;
 	}
 
 	if (!shared_count) {
 		struct fence *fence_excl = rcu_dereference(obj->fence_excl);
 
-		if (read_seqcount_retry(&obj->seq, seq))
-			goto unlock_retry;
-
 		if (fence_excl) {
 			ret = reservation_object_test_signaled_single(
 								fence_excl);
 			if (ret < 0)
-				goto unlock_retry;
+				goto retry;
+
+			if (read_seqcount_retry(&obj->seq, seq))
+				goto retry;
 		}
 	}
 
 	rcu_read_unlock();
 	return ret;
-
-unlock_retry:
-	rcu_read_unlock();
-	goto retry;
 }
 EXPORT_SYMBOL_GPL(reservation_object_test_signaled_rcu);
diff --git a/drivers/dma-buf/sw_sync.c b/drivers/dma-buf/sw_sync.c
index 4f35114..ca166fe 100644
--- a/drivers/dma-buf/sw_sync.c
+++ b/drivers/dma-buf/sw_sync.c
@@ -19,7 +19,11 @@
 #include <linux/uaccess.h>
 #include <linux/slab.h>
 #include <linux/sync_file.h>
-
+#ifdef CONFIG_RTK_PLATFORM
+#include <linux/miscdevice.h>
+#include <linux/init.h>
+#include <linux/module.h>
+#endif /* CONFIG_RTK_PLATFORM */
 #include "sync_debug.h"
 
 #define CREATE_TRACE_POINTS
@@ -104,6 +108,7 @@ struct sync_timeline *sync_timeline_create(const char *name)
 
 	return obj;
 }
+EXPORT_SYMBOL(sync_timeline_create);
 
 static void sync_timeline_free(struct kref *kref)
 {
@@ -120,10 +125,18 @@ static void sync_timeline_get(struct sync_timeline *obj)
 	kref_get(&obj->kref);
 }
 
+#ifdef CONFIG_RTK_PLATFORM
+void sync_timeline_put(struct sync_timeline *obj)
+{
+	kref_put(&obj->kref, sync_timeline_free);
+}
+#else
 static void sync_timeline_put(struct sync_timeline *obj)
 {
 	kref_put(&obj->kref, sync_timeline_free);
 }
+EXPORT_SYMBOL(sync_timeline_put);
+#endif /* CONFIG_RTK_PLATFORM */
 
 static const char *timeline_fence_get_driver_name(struct fence *fence)
 {
@@ -169,6 +182,13 @@ static bool timeline_fence_enable_signaling(struct fence *fence)
 	return true;
 }
 
+static void timeline_fence_disable_signaling(struct fence *fence)
+{
+	struct sync_pt *pt = container_of(fence, struct sync_pt, base);
+
+	list_del_init(&pt->link);
+}
+
 static void timeline_fence_value_str(struct fence *fence,
 				    char *str, int size)
 {
@@ -187,6 +207,7 @@ static void timeline_fence_timeline_value_str(struct fence *fence,
 	.get_driver_name = timeline_fence_get_driver_name,
 	.get_timeline_name = timeline_fence_get_timeline_name,
 	.enable_signaling = timeline_fence_enable_signaling,
+	.disable_signaling = timeline_fence_disable_signaling,
 	.signaled = timeline_fence_signaled,
 	.wait = fence_default_wait,
 	.release = timeline_fence_release,
@@ -194,6 +215,110 @@ static void timeline_fence_timeline_value_str(struct fence *fence,
 	.timeline_value_str = timeline_fence_timeline_value_str,
 };
 
+#ifdef CONFIG_RTK_PLATFORM
+/**
+ * sync_timeline_signal() - signal a status change on a sync_timeline
+ * @obj:	sync_timeline to signal
+ * @inc:	num to increment on timeline->value
+ *
+ * A sync implementation should call this any time one of it's fences
+ * has signaled or has an error condition.
+ */
+void sync_timeline_signal(struct sync_timeline *obj, unsigned int inc)
+{
+	struct sync_pt *pt, *next;
+
+	trace_sync_timeline(obj);
+
+	spin_lock_irq(&obj->lock);
+
+	obj->value += inc;
+
+	list_for_each_entry_safe(pt, next, &obj->pt_list, link) {
+		if (!timeline_fence_signaled(&pt->base))
+			break;
+
+		list_del_init(&pt->link);
+		rb_erase(&pt->node, &obj->pt_tree);
+
+		/*
+		 * A signal callback may release the last reference to this
+		 * fence, causing it to be freed. That operation has to be
+		 * last to avoid a use after free inside this loop, and must
+		 * be after we remove the fence from the timeline in order to
+		 * prevent deadlocking on timeline->lock inside
+		 * timeline_fence_release().
+		 */
+		fence_signal_locked(&pt->base);
+	}
+
+	spin_unlock_irq(&obj->lock);
+}
+EXPORT_SYMBOL(sync_timeline_signal);
+
+/**
+ * sync_pt_create() - creates a sync pt
+ * @parent:	fence's parent sync_timeline
+ * @inc:	value of the fence
+ *
+ * Creates a new sync_pt as a child of @parent.  @size bytes will be
+ * allocated allowing for implementation specific data to be kept after
+ * the generic sync_timeline struct. Returns the sync_pt object or
+ * NULL in case of error.
+ */
+struct sync_pt *sync_pt_create(struct sync_timeline *obj,
+				      unsigned int value)
+{
+	struct sync_pt *pt;
+
+	pt = kzalloc(sizeof(*pt), GFP_KERNEL);
+	if (!pt)
+		return NULL;
+
+	sync_timeline_get(obj);
+	fence_init(&pt->base, &timeline_fence_ops, &obj->lock,
+		   obj->context, value);
+	INIT_LIST_HEAD(&pt->link);
+
+	spin_lock_irq(&obj->lock);
+	if (!fence_is_signaled_locked(&pt->base)) {
+		struct rb_node **p = &obj->pt_tree.rb_node;
+		struct rb_node *parent = NULL;
+
+		while (*p) {
+			struct sync_pt *other;
+			int cmp;
+
+			parent = *p;
+			other = rb_entry(parent, typeof(*pt), node);
+			cmp = value - other->base.seqno;
+			if (cmp > 0) {
+				p = &parent->rb_right;
+			} else if (cmp < 0) {
+				p = &parent->rb_left;
+			} else {
+				if (fence_get_rcu(&other->base)) {
+					fence_put(&pt->base);
+					pt = other;
+					goto unlock;
+				}
+				p = &parent->rb_left;
+			}
+		}
+		rb_link_node(&pt->node, parent, p);
+		rb_insert_color(&pt->node, &obj->pt_tree);
+
+		parent = rb_next(&pt->node);
+		list_add_tail(&pt->link,
+			      parent ? &rb_entry(parent, typeof(*pt), node)->link : &obj->pt_list);
+	}
+unlock:
+	spin_unlock_irq(&obj->lock);
+
+	return pt;
+}
+EXPORT_SYMBOL(sync_pt_create);
+#else
 /**
  * sync_timeline_signal() - signal a status change on a sync_timeline
  * @obj:	sync_timeline to signal
@@ -294,6 +419,7 @@ static struct sync_pt *sync_pt_create(struct sync_timeline *obj,
 
 	return pt;
 }
+#endif /* #ifdef CONFIG_RTK_PLATFORM */
 
 /*
  * *WARNING*
@@ -360,8 +486,8 @@ static long sw_sync_ioctl_create_fence(struct sync_timeline *obj,
 	}
 
 	sync_file = sync_file_create(&pt->base);
+	fence_put(&pt->base);
 	if (!sync_file) {
-		fence_put(&pt->base);
 		err = -ENOMEM;
 		goto err;
 	}
@@ -422,3 +548,24 @@ static long sw_sync_ioctl(struct file *file, unsigned int cmd,
 	.unlocked_ioctl = sw_sync_ioctl,
 	.compat_ioctl	= sw_sync_ioctl,
 };
+
+#ifdef CONFIG_RTK_PLATFORM
+static struct miscdevice sw_sync_dev = {
+    .minor  = MISC_DYNAMIC_MINOR,
+    .name   = "sw_sync",
+    .fops   = &sw_sync_debugfs_fops,
+};
+
+static int __init sw_sync_device_init(void)
+{
+    return misc_register(&sw_sync_dev);
+}
+
+static void __exit sw_sync_device_remove(void)
+{
+    misc_deregister(&sw_sync_dev);
+}
+
+module_init(sw_sync_device_init);
+module_exit(sw_sync_device_remove);
+#endif /* CONFIG_RTK_PLATFORM */
diff --git a/drivers/dma-buf/sync_debug.c b/drivers/dma-buf/sync_debug.c
index 858263d..8270b066 100644
--- a/drivers/dma-buf/sync_debug.c
+++ b/drivers/dma-buf/sync_debug.c
@@ -205,29 +205,3 @@ static __init int sync_debugfs_init(void)
 	return 0;
 }
 late_initcall(sync_debugfs_init);
-
-#define DUMP_CHUNK 256
-static char sync_dump_buf[64 * 1024];
-void sync_dump(void)
-{
-	struct seq_file s = {
-		.buf = sync_dump_buf,
-		.size = sizeof(sync_dump_buf) - 1,
-	};
-	int i;
-
-	sync_debugfs_show(&s, NULL);
-
-	for (i = 0; i < s.count; i += DUMP_CHUNK) {
-		if ((s.count - i) > DUMP_CHUNK) {
-			char c = s.buf[i + DUMP_CHUNK];
-
-			s.buf[i + DUMP_CHUNK] = 0;
-			pr_cont("%s", s.buf + i);
-			s.buf[i + DUMP_CHUNK] = c;
-		} else {
-			s.buf[s.count] = 0;
-			pr_cont("%s", s.buf + i);
-		}
-	}
-}
diff --git a/drivers/dma-buf/sync_debug.h b/drivers/dma-buf/sync_debug.h
index 9615dc0..0d55191 100644
--- a/drivers/dma-buf/sync_debug.h
+++ b/drivers/dma-buf/sync_debug.h
@@ -70,14 +70,19 @@ struct sync_pt {
 void sync_timeline_debug_remove(struct sync_timeline *obj);
 void sync_file_debug_add(struct sync_file *fence);
 void sync_file_debug_remove(struct sync_file *fence);
-void sync_dump(void);
 
 #else
 # define sync_timeline_debug_add(obj)
 # define sync_timeline_debug_remove(obj)
 # define sync_file_debug_add(fence)
 # define sync_file_debug_remove(fence)
-# define sync_dump()
 #endif
 
+#ifdef CONFIG_RTK_PLATFORM
+struct sync_timeline *sync_timeline_create(const char *name);
+struct sync_pt *sync_pt_create(struct sync_timeline *obj, unsigned int value);
+void sync_timeline_signal(struct sync_timeline *obj, unsigned int inc);
+void sync_timeline_put(struct sync_timeline *obj);
+#endif /* CONFIG_RTK_PLATFORM */
+
 #endif /* _LINUX_SYNC_H */
diff --git a/drivers/dma-buf/sync_file.c b/drivers/dma-buf/sync_file.c
index f0c374d..9c9c7fb 100644
--- a/drivers/dma-buf/sync_file.c
+++ b/drivers/dma-buf/sync_file.c
@@ -91,6 +91,31 @@ struct sync_file *sync_file_create(struct fence *fence)
 }
 EXPORT_SYMBOL(sync_file_create);
 
+/**
+ * sync_file_fdget() - get a sync_file from an fd
+ * @fd:		fd referencing a fence
+ *
+ * Ensures @fd references a valid sync_file, increments the refcount of the
+ * backing file. Returns the sync_file or NULL in case of error.
+ */
+#ifdef CONFIG_RTK_PLATFORM
+struct sync_file *sync_file_fdget(int fd)
+{
+	struct file *file = fget(fd);
+
+	if (!file)
+		return NULL;
+
+	if (file->f_op != &sync_file_fops)
+		goto err;
+
+	return file->private_data;
+
+err:
+	fput(file);
+	return NULL;
+}
+#else
 static struct sync_file *sync_file_fdget(int fd)
 {
 	struct file *file = fget(fd);
@@ -107,6 +132,8 @@ static struct sync_file *sync_file_fdget(int fd)
 	fput(file);
 	return NULL;
 }
+#endif /* CONFIG_RTK_PLATFORM */
+EXPORT_SYMBOL(sync_file_fdget);
 
 /**
  * sync_file_get_fence - get the fence related to the sync_file fd
@@ -279,7 +306,7 @@ static void sync_file_free(struct kref *kref)
 	struct sync_file *sync_file = container_of(kref, struct sync_file,
 						     kref);
 
-	if (test_bit(POLL_ENABLED, &sync_file->fence->flags))
+	if (test_bit(POLL_ENABLED, &sync_file->flags))
 		fence_remove_callback(sync_file->fence, &sync_file->cb);
 	fence_put(sync_file->fence);
 	kfree(sync_file);
@@ -299,10 +326,10 @@ static unsigned int sync_file_poll(struct file *file, poll_table *wait)
 
 	poll_wait(file, &sync_file->wq, wait);
 
-	if (!poll_does_not_wait(wait) &&
-	    !test_and_set_bit(POLL_ENABLED, &sync_file->fence->flags)) {
+	if (list_empty(&sync_file->cb.node) &&
+	    !test_and_set_bit(POLL_ENABLED, &sync_file->flags)) {
 		if (fence_add_callback(sync_file->fence, &sync_file->cb,
-				       fence_check_cb_func) < 0)
+					   fence_check_cb_func) < 0)
 			wake_up_all(&sync_file->wq);
 	}
 
diff --git a/drivers/edac/edac_mc_sysfs.c b/drivers/edac/edac_mc_sysfs.c
index 4e0f8e7..bea71fb 100644
--- a/drivers/edac/edac_mc_sysfs.c
+++ b/drivers/edac/edac_mc_sysfs.c
@@ -50,7 +50,7 @@ int edac_mc_get_poll_msec(void)
 	return edac_mc_poll_msec;
 }
 
-static int edac_set_poll_msec(const char *val, struct kernel_param *kp)
+static int edac_set_poll_msec(const char *val, const struct kernel_param *kp)
 {
 	unsigned long l;
 	int ret;
diff --git a/drivers/edac/edac_module.c b/drivers/edac/edac_module.c
index 5f8543b..b0d3284 100644
--- a/drivers/edac/edac_module.c
+++ b/drivers/edac/edac_module.c
@@ -19,7 +19,8 @@
 
 #ifdef CONFIG_EDAC_DEBUG
 
-static int edac_set_debug_level(const char *buf, struct kernel_param *kp)
+static int edac_set_debug_level(const char *buf,
+				const struct kernel_param *kp)
 {
 	unsigned long val;
 	int ret;
diff --git a/drivers/firmware/Makefile b/drivers/firmware/Makefile
index 898ac41..ecc0aa3 100644
--- a/drivers/firmware/Makefile
+++ b/drivers/firmware/Makefile
@@ -1,7 +1,9 @@
 #
 # Makefile for the linux kernel.
 #
+ifndef CONFIG_RTK_PLATFORM_PSCI
 obj-$(CONFIG_ARM_PSCI_FW)	+= psci.o
+endif
 obj-$(CONFIG_ARM_SCPI_PROTOCOL)	+= arm_scpi.o
 obj-$(CONFIG_ARM_SCPI_POWER_DOMAIN) += scpi_pm_domain.o
 obj-$(CONFIG_DMI)		+= dmi_scan.o
diff --git a/drivers/firmware/efi/libstub/Makefile b/drivers/firmware/efi/libstub/Makefile
index 5e23e2d..0e3ca82 100644
--- a/drivers/firmware/efi/libstub/Makefile
+++ b/drivers/firmware/efi/libstub/Makefile
@@ -10,7 +10,7 @@ cflags-$(CONFIG_X86)		+= -m$(BITS) -D__KERNEL__ $(LINUX_INCLUDE) -O2 \
 				   -fPIC -fno-strict-aliasing -mno-red-zone \
 				   -mno-mmx -mno-sse
 
-cflags-$(CONFIG_ARM64)		:= $(subst -pg,,$(KBUILD_CFLAGS))
+cflags-$(CONFIG_ARM64)		:= $(subst -pg,,$(KBUILD_CFLAGS)) -fpie
 cflags-$(CONFIG_ARM)		:= $(subst -pg,,$(KBUILD_CFLAGS)) -g0 \
 				   -fno-builtin -fpic -mno-single-pic-base
 
@@ -18,7 +18,8 @@ cflags-$(CONFIG_EFI_ARMSTUB)	+= -I$(srctree)/scripts/dtc/libfdt
 
 KBUILD_CFLAGS			:= $(cflags-y) -DDISABLE_BRANCH_PROFILING \
 				   $(call cc-option,-ffreestanding) \
-				   $(call cc-option,-fno-stack-protector)
+				   $(call cc-option,-fno-stack-protector) \
+				   $(DISABLE_LTO)
 
 GCOV_PROFILE			:= n
 KASAN_SANITIZE			:= n
diff --git a/drivers/firmware/efi/libstub/arm-stub.c b/drivers/firmware/efi/libstub/arm-stub.c
index 993aa56..7ec09ea 100644
--- a/drivers/firmware/efi/libstub/arm-stub.c
+++ b/drivers/firmware/efi/libstub/arm-stub.c
@@ -18,8 +18,6 @@
 
 #include "efistub.h"
 
-bool __nokaslr;
-
 static int efi_get_secureboot(efi_system_table_t *sys_table_arg)
 {
 	static efi_char16_t const sb_var_name[] = {
@@ -268,18 +266,6 @@ unsigned long efi_entry(void *handle, efi_system_table_t *sys_table,
 		goto fail;
 	}
 
-	/* check whether 'nokaslr' was passed on the command line */
-	if (IS_ENABLED(CONFIG_RANDOMIZE_BASE)) {
-		static const u8 default_cmdline[] = CONFIG_CMDLINE;
-		const u8 *str, *cmdline = cmdline_ptr;
-
-		if (IS_ENABLED(CONFIG_CMDLINE_FORCE))
-			cmdline = default_cmdline;
-		str = strstr(cmdline, "nokaslr");
-		if (str == cmdline || (str > cmdline && *(str - 1) == ' '))
-			__nokaslr = true;
-	}
-
 	si = setup_graphics(sys_table);
 
 	status = handle_kernel_image(sys_table, image_addr, &image_size,
@@ -291,9 +277,13 @@ unsigned long efi_entry(void *handle, efi_system_table_t *sys_table,
 		goto fail_free_cmdline;
 	}
 
-	status = efi_parse_options(cmdline_ptr);
-	if (status != EFI_SUCCESS)
-		pr_efi_err(sys_table, "Failed to parse EFI cmdline options\n");
+	if (IS_ENABLED(CONFIG_CMDLINE_EXTEND) ||
+	    IS_ENABLED(CONFIG_CMDLINE_FORCE) ||
+	    cmdline_size == 0)
+		efi_parse_options(CONFIG_CMDLINE);
+
+	if (!IS_ENABLED(CONFIG_CMDLINE_FORCE) && cmdline_size > 0)
+		efi_parse_options(cmdline_ptr);
 
 	secure_boot = efi_get_secureboot(sys_table);
 	if (secure_boot > 0)
diff --git a/drivers/firmware/efi/libstub/arm64-stub.c b/drivers/firmware/efi/libstub/arm64-stub.c
index eae693e..f7a6970 100644
--- a/drivers/firmware/efi/libstub/arm64-stub.c
+++ b/drivers/firmware/efi/libstub/arm64-stub.c
@@ -9,15 +9,21 @@
  * published by the Free Software Foundation.
  *
  */
+
+/*
+ * To prevent the compiler from emitting GOT-indirected (and thus absolute)
+ * references to the section markers, override their visibility as 'hidden'
+ */
+#pragma GCC visibility push(hidden)
+#include <asm/sections.h>
+#pragma GCC visibility pop
+
 #include <linux/efi.h>
 #include <asm/efi.h>
-#include <asm/sections.h>
 #include <asm/sysreg.h>
 
 #include "efistub.h"
 
-extern bool __nokaslr;
-
 efi_status_t check_platform_features(efi_system_table_t *sys_table_arg)
 {
 	u64 tg;
@@ -52,7 +58,7 @@ efi_status_t handle_kernel_image(efi_system_table_t *sys_table_arg,
 	u64 phys_seed = 0;
 
 	if (IS_ENABLED(CONFIG_RANDOMIZE_BASE)) {
-		if (!__nokaslr) {
+		if (!nokaslr()) {
 			status = efi_get_random_bytes(sys_table_arg,
 						      sizeof(phys_seed),
 						      (u8 *)&phys_seed);
diff --git a/drivers/firmware/efi/libstub/efi-stub-helper.c b/drivers/firmware/efi/libstub/efi-stub-helper.c
index aded106..2db141c 100644
--- a/drivers/firmware/efi/libstub/efi-stub-helper.c
+++ b/drivers/firmware/efi/libstub/efi-stub-helper.c
@@ -41,6 +41,13 @@
 #define EFI_ALLOC_ALIGN		EFI_PAGE_SIZE
 #endif
 
+static int __section(.data) __nokaslr;
+
+int __pure nokaslr(void)
+{
+	return __nokaslr;
+}
+
 #define EFI_MMAP_NR_SLACK_SLOTS	8
 
 struct file_info {
@@ -351,10 +358,14 @@ void efi_free(efi_system_table_t *sys_table_arg, unsigned long size,
  * environments, first in the early boot environment of the EFI boot
  * stub, and subsequently during the kernel boot.
  */
-efi_status_t efi_parse_options(char *cmdline)
+efi_status_t efi_parse_options(char const *cmdline)
 {
 	char *str;
 
+	str = strstr(cmdline, "nokaslr");
+	if (str == cmdline || (str && str > cmdline && *(str - 1) == ' '))
+		__nokaslr = 1;
+
 	/*
 	 * If no EFI parameters were specified on the cmdline we've got
 	 * nothing to do.
diff --git a/drivers/firmware/efi/libstub/efistub.h b/drivers/firmware/efi/libstub/efistub.h
index fac6799..d0e5aca 100644
--- a/drivers/firmware/efi/libstub/efistub.h
+++ b/drivers/firmware/efi/libstub/efistub.h
@@ -15,6 +15,8 @@
  */
 #undef __init
 
+extern int __pure nokaslr(void);
+
 void efi_char16_printk(efi_system_table_t *, efi_char16_t *);
 
 efi_status_t efi_open_volume(efi_system_table_t *sys_table_arg, void *__image,
diff --git a/drivers/gpio/Kconfig b/drivers/gpio/Kconfig
index 12d417a..167ecea 100644
--- a/drivers/gpio/Kconfig
+++ b/drivers/gpio/Kconfig
@@ -531,6 +531,37 @@ config GPIO_LOONGSON1
 	help
 	  Say Y or M here to support GPIO on Loongson1 SoCs.
 
+config GPIO_RTD129x
+    bool "Realtek RTD129x GPIO support"
+    depends on ARCH_RTD129x
+    default y
+    select GPIOLIB_IRQCHIP
+    help
+      Realtek RTD129x GPIO support.
+
+config GPIO_RTD139x
+    bool "Realtek RTD139x GPIO support"
+    depends on ARCH_RTD139x
+    default y
+    select GPIOLIB_IRQCHIP
+    help
+      Realtek RTD139x GPIO support.
+
+config GPIO_RTD16xx
+    bool "Realtek RTD16xx GPIO support"
+    depends on ARCH_RTD16xx
+    default y
+    select GPIOLIB_IRQCHIP
+    help
+      Realtek RTD16xx GPIO support.
+
+config GPIO_RTD13xx
+    bool "Realtek RTD13xx GPIO support"
+    depends on ARCH_RTD13xx
+    default y
+    select GPIOLIB_IRQCHIP
+    help
+      Realtek RTD13xx GPIO support.
 endmenu
 
 menu "Port-mapped I/O GPIO drivers"
diff --git a/drivers/gpio/Makefile b/drivers/gpio/Makefile
index d074c22..ee2fe56 100644
--- a/drivers/gpio/Makefile
+++ b/drivers/gpio/Makefile
@@ -141,3 +141,8 @@ obj-$(CONFIG_GPIO_ZEVIO)	+= gpio-zevio.o
 obj-$(CONFIG_GPIO_ZYNQ)		+= gpio-zynq.o
 obj-$(CONFIG_GPIO_ZX)		+= gpio-zx.o
 obj-$(CONFIG_GPIO_LOONGSON1)	+= gpio-loongson1.o
+obj-$(CONFIG_ARCH_RTD119X)      += gpio-rtd119x.o
+obj-$(CONFIG_GPIO_RTD129x)	+= gpio-rtd129x.o
+obj-$(CONFIG_GPIO_RTD139x)	+= gpio-rtd139x.o
+obj-$(CONFIG_GPIO_RTD16xx)	+= gpio-rtd16xx.o gpio-rtd16xx-suspend.o
+obj-$(CONFIG_GPIO_RTD13xx)	+= gpio-rtd13xx.o gpio-rtd13xx-suspend.o
diff --git a/drivers/gpio/gpio-rtd119x.c b/drivers/gpio/gpio-rtd119x.c
new file mode 100644
index 00000000..42ef19e
--- /dev/null
+++ b/drivers/gpio/gpio-rtd119x.c
@@ -0,0 +1,805 @@
+//#include <asm/mach/irq.h>
+
+#include <linux/gpio.h>
+#include <linux/errno.h>
+#include <linux/kernel.h>
+#include <linux/clk.h>
+#include <linux/err.h>
+#include <linux/io.h>
+
+//#include <asm/mach/irq.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+
+//#include <linux/irqdomain.h>
+#include <linux/irqchip/chained_irq.h>
+#include <linux/slab.h>
+#include <linux/interrupt.h>
+
+#include <linux/pinctrl/consumer.h>
+
+#include <linux/of_device.h>
+#include <linux/platform_device.h>
+
+//#include <linux/of.h>
+#include <linux/of_gpio.h>
+
+#include "gpio-rtd119x.h"
+
+#define GPIO_REG_OFST(id)       ((id >> 5)<<2)
+#define GPIO_REG_BIT(id)        (id & 0x1F)	// reg bit = id % 32
+#define GPIO_INT_REG_OFST(id)   ((id/31)<<2)
+#define GPIO_INT_REG_BIT(id)    ((id%31)+1)
+
+/*TODO :
+ intc mux tempary define the first irq number in this mux is 160, end in 160+63
+ misc gpio int mux tempary define the first irq number in this mux is 160+64 , end in 160+64+59
+ iso gpio int mux tempary define the first irq number in this mux is 160+64+60 , end in 160+64+60+19*/
+static const struct rtk119x_gpio_groups rtk_gpio_grps_array[] = {
+	{
+		.group_name = "rtk_misc_gpio",
+		.linux_irq_base = 224,//160(predefine base)+64(intc_mux)
+		.gpio_isr_deassert_offset = 0x00100000,	//Bit20
+		.gpio_isr_assert_offset = 0x00080000,	//Bit19
+		.reg_isr_off = 0xc,						//MIS_ISR
+		.reg_umsk_isr_gpa_off = 0x40,			//MIS_UMSK_ISR_GP0A
+		.reg_umsk_isr_gpda_off = 0x54,			//MIS_UMSK_ISR_GP0DA
+		.reg_dir_off = 0x0,		//MIS_GP0DIR
+		.reg_dato_off = 0x10,	//MIS_GP0DATO
+		.reg_dati_off = 0x20,	//MIS_GP0DATI
+		.reg_ie_off = 0x30,		//MIS_GP0IE
+		.reg_dp_off = 0x40,		//MIS_GP0DP
+		.reg_deb_off = 0x50,	//MIS_GPDEB
+	},
+	{
+		.group_name = "rtk_iso_gpio",
+#ifndef CONFIG_MACH_RTK1192
+		.linux_irq_base = 284,//160(predefine base)+64(intc_mux)+60(misc_gpio)
+#else
+		.linux_irq_base = 327,//160(predefine base)+64(intc_mux)+103(misc_gpio)
+#endif
+		.gpio_isr_deassert_offset = 0x00100000,	//Bit20
+		.gpio_isr_assert_offset = 0x00080000,	//Bit19
+		.reg_isr_off = 0x0,						//ISO_ISR
+		.reg_umsk_isr_gpa_off = 0x8,			//ISO_UMSK_ISR_GPA
+		.reg_umsk_isr_gpda_off = 0xc,			//ISO_UMSK_ISR_GPDA
+		.reg_dir_off = 0x0,		//ISO_GPDIR
+		.reg_dato_off = 0x4,	//ISO_GPDATO
+		.reg_dati_off = 0x8,	//ISO_GPDATI
+		.reg_ie_off = 0xc,		//ISO_GPIE
+		.reg_dp_off = 0x10,		//ISO_GPDP
+		.reg_deb_off = 0x14,	//ISO_GPDEB
+	 }
+};
+
+static const struct rtk119x_gpio_desc rtk_gpio_desc = {
+	.groups = rtk_gpio_grps_array,
+	.ngroups = ARRAY_SIZE(rtk_gpio_grps_array)
+};
+
+static void __inline iowrite_reg_bit(volatile void *reg, unsigned char bit, unsigned char val)
+{
+	if (val)
+		iowrite32(ioread32(reg) | (0x1 << bit), reg);
+	else
+		iowrite32(ioread32(reg) & ~(0x1 << bit), reg);
+}
+
+#define ioread_reg_bit(reg, bits)    ((ioread32(reg) >> (bits)) & 0x1)
+#define chip2controller(chip)	container_of(chip, struct rtk119x_gpio_controller, chip)
+
+int gpio_chk_irq_enable(struct rtk119x_gpio_controller *p_rtk_gpio_ctl, unsigned int irq)
+{
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	return ioread_reg_bit(((volatile void *)(p_rtk_gpio_ctl->reg_ie) + GPIO_REG_OFST(irq)), GPIO_REG_BIT(irq));
+}
+
+static void gpio_irq_disable(struct irq_data *d)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl = (struct rtk119x_gpio_controller *)(d->chip_data);
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	iowrite_reg_bit(((volatile void *)p_rtk_gpio_ctl->reg_ie + GPIO_REG_OFST(d->hwirq)), GPIO_REG_BIT(d->hwirq), 0);
+}
+
+static void gpio_irq_enable(struct irq_data *d)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl = (struct rtk119x_gpio_controller *)(d->chip_data);
+    unsigned long irq_flag;
+    unsigned int gpio_int_flag;
+    RTK_debug("[%s]  %s  line: %d  irq=%d ,hwirq=%ld  ,of_node->name=%s \n", __FILE__, __FUNCTION__, __LINE__, d->irq, d->hwirq,
+            d->domain->of_node->name);
+
+    spin_lock_irqsave(&p_rtk_gpio_ctl->lock, irq_flag);
+    //Clear assert/de-assert interrupt flag
+    gpio_int_flag = 0x1 << GPIO_INT_REG_BIT(d->hwirq);
+    if(ioread32(p_rtk_gpio_ctl->regs_umsk_isr_gpa+GPIO_INT_REG_OFST(d->hwirq))&gpio_int_flag)
+    {
+        RTK_debug("[%s]  %s  line: %d, Wrte Reg(0x%08x) Val(0x%08x)\n",__FILE__, __FUNCTION__, __LINE__,p_rtk_gpio_ctl->regs_umsk_isr_gpa+GPIO_INT_REG_OFST(d->hwirq),gpio_int_flag);
+        iowrite32(gpio_int_flag,p_rtk_gpio_ctl->regs_umsk_isr_gpa+GPIO_INT_REG_OFST(d->hwirq));
+    }
+    if(ioread32(p_rtk_gpio_ctl->regs_umsk_isr_gpda+GPIO_INT_REG_OFST(d->hwirq))&gpio_int_flag)
+    {
+        RTK_debug("[%s]  %s  line: %d, Wrte Reg(0x%08x) Val(0x%08x)\n",__FILE__, __FUNCTION__, __LINE__,p_rtk_gpio_ctl->regs_umsk_isr_gpda+GPIO_INT_REG_OFST(d->hwirq),gpio_int_flag);
+        iowrite32(gpio_int_flag,p_rtk_gpio_ctl->regs_umsk_isr_gpda+GPIO_INT_REG_OFST(d->hwirq));
+    }
+
+    //Enable interrupt
+    iowrite_reg_bit(((volatile void *)p_rtk_gpio_ctl->reg_ie + GPIO_REG_OFST(d->hwirq)), GPIO_REG_BIT(d->hwirq), 1);
+    spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, irq_flag);
+
+	RTK_debug("[%s]  %s  line: %d  reg_ie[%x]= %x \n", __FILE__, __FUNCTION__, __LINE__,
+			  (unsigned int)(p_rtk_gpio_ctl->reg_ie + GPIO_REG_OFST(d->hwirq)),
+			  ioread32(p_rtk_gpio_ctl->reg_ie + GPIO_REG_OFST(d->hwirq)));
+}
+
+static int gpio_irq_type(struct irq_data *d, unsigned trigger)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl = (struct rtk119x_gpio_controller *)(d->chip_data);
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+	switch(trigger)
+	{
+		case IRQ_TYPE_EDGE_RISING://	1
+		RTK_debug("[%s]%sline: %d \n",__FILE__,__FUNCTION__,__LINE__);
+		iowrite_reg_bit(((volatile void *)p_rtk_gpio_ctl->reg_dp + GPIO_REG_OFST(d->hwirq)), GPIO_REG_BIT(d->hwirq), 1); 
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag + GPIO_REG_OFST(d->hwirq));
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag + GPIO_REG_OFST(d->hwirq));
+		break;
+
+		case IRQ_TYPE_EDGE_FALLING://	2
+		RTK_debug("[%s]%sline: %d \n",__FILE__,__FUNCTION__,__LINE__);
+		iowrite_reg_bit(((volatile void *)p_rtk_gpio_ctl->reg_dp + GPIO_REG_OFST(d->hwirq)), GPIO_REG_BIT(d->hwirq), 1); 
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag + GPIO_REG_OFST(d->hwirq));
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag + GPIO_REG_OFST(d->hwirq));
+		break;
+
+		case IRQ_TYPE_LEVEL_HIGH://	4
+		RTK_debug("[%s]%sline: %d \n",__FILE__,__FUNCTION__,__LINE__);
+		iowrite_reg_bit(((volatile void *)p_rtk_gpio_ctl->reg_dp + GPIO_REG_OFST(d->hwirq)), GPIO_REG_BIT(d->hwirq), 1); 
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag + GPIO_REG_OFST(d->hwirq));
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag + GPIO_REG_OFST(d->hwirq));
+		break;
+
+		case IRQ_TYPE_LEVEL_LOW://	8
+		RTK_debug("[%s]%sline: %d \n",__FILE__,__FUNCTION__,__LINE__);
+		iowrite_reg_bit(((volatile void *)p_rtk_gpio_ctl->reg_dp + GPIO_REG_OFST(d->hwirq)), GPIO_REG_BIT(d->hwirq), 0); 
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag + GPIO_REG_OFST(d->hwirq));
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag + GPIO_REG_OFST(d->hwirq));
+		break;
+
+		case IRQ_TYPE_EDGE_BOTH://	(IRQ_TYPE_EDGE_FALLING | IRQ_TYPE_EDGE_RISING)
+		case IRQ_TYPE_NONE:	//		0
+		default:
+		RTK_debug("[%s]%sline: %d \n",__FILE__,__FUNCTION__,__LINE__);
+		iowrite_reg_bit(((volatile void *)p_rtk_gpio_ctl->reg_dp + GPIO_REG_OFST(d->hwirq)), GPIO_REG_BIT(d->hwirq), 1); 
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag + GPIO_REG_OFST(d->hwirq));
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag + GPIO_REG_OFST(d->hwirq));
+		break;
+
+	}
+
+	return 0;
+
+}
+
+static void gpio_irq_handler(struct irq_desc *desc)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl;
+
+//  struct irq_chip *chip = irq_get_chip(irq);
+	unsigned int gpioNr, reg_ofst, i;
+	unsigned int event;
+	unsigned int status;
+//  unsigned int mux_irq;
+	unsigned int hw_irq=12345678, linux_irq;
+	unsigned int irq_had_fired = 0 ;
+
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+#if 0
+//gpio test start
+	mux_irq = 60 + 15;
+	generic_handle_irq(irq_find_mapping(irq_mux_domain, mux_irq));
+	return;
+//gpio test end
+#endif
+
+	p_rtk_gpio_ctl = (struct rtk119x_gpio_controller *)irq_desc_get_handler_data(desc);	//rtk119x_gpio_controller for MISC or ISO
+//  chained_irq_enter(chip, desc);
+
+	/*get interrupt status */
+	event = ioread32(p_rtk_gpio_ctl->reg_isr) & (p_rtk_gpio_ctl->gpio_isr_deassert_offset | p_rtk_gpio_ctl->gpio_isr_assert_offset);
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+	if (event == 0)
+		return;
+
+	/*handle gpio deassert */
+	if (event & (p_rtk_gpio_ctl->gpio_isr_deassert_offset))
+	{
+		gpioNr = 0;
+		reg_ofst = 0;
+		RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+		while (gpioNr < (p_rtk_gpio_ctl->chip.ngpio))	//less than MISC gpio number(60) or ISO gpio number(20)
+		{
+			status = ioread32(p_rtk_gpio_ctl->regs_umsk_isr_gpda + reg_ofst) >> 1;	//get regs_umsk_isr_gpda0 or regs_umsk_isr_gpda1
+			iowrite32(status << 1, p_rtk_gpio_ctl->regs_umsk_isr_gpda + reg_ofst);
+
+			i = gpioNr;
+			while (status && i < (p_rtk_gpio_ctl->chip.ngpio))	//    i<MISC gpio number(60) or ISO gpio number(20)
+			{
+				//printk("status = %08x\n", status);
+				if ((status & 0x1) && gpio_chk_irq_enable(p_rtk_gpio_ctl, i))
+				{
+					/*
+					   mux_irq = p_rtk_gpio_ctl->chip.base + i;                         //d->chip.base = 0 for MISC,  d->chip.base = 60 for ISO
+					   generic_handle_irq(irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, mux_irq));
+					 */
+					hw_irq = i;
+					linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, hw_irq);
+					if (linux_irq)
+					{
+						RTK_debug("[%s]%s  line: %d \n",__FILE__,__FUNCTION__,__LINE__);
+						RTK_debug("hw_irq = %d,  deassertflg[%x] = %x \n",hw_irq,((unsigned int)((p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag) + GPIO_REG_OFST(hw_irq))), (*((p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag) + GPIO_REG_OFST(hw_irq))));
+						if ( (1<<GPIO_REG_BIT(hw_irq)) & (*((p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag) + GPIO_REG_OFST(hw_irq)))  )
+						{
+							generic_handle_irq(linux_irq);
+							irq_had_fired++;
+						}
+					}
+					else
+					{
+						printk(KERN_ERR "%s can not specified linux irq number for hwirq=%d .", __func__, hw_irq);
+					}
+				}
+				i++;
+				status >>= 1;
+				RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+			}
+
+			gpioNr += 31;
+			reg_ofst += 4;
+			RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+		}
+	}
+
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+	/*handle gpio assert */
+	if (event & (p_rtk_gpio_ctl->gpio_isr_assert_offset))
+	{
+		gpioNr = 0;
+		reg_ofst = 0;
+		RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+		while (gpioNr < (p_rtk_gpio_ctl->chip.ngpio))
+		{
+			status = ioread32(p_rtk_gpio_ctl->regs_umsk_isr_gpa + reg_ofst) >> 1;
+			iowrite32(status << 1, p_rtk_gpio_ctl->regs_umsk_isr_gpa + reg_ofst);
+
+			i = gpioNr;
+			//printk("GPIO DEASSERT : %p = %08x\n", UMSK_ISR_GPDA + reg_ofst, status);
+
+			while (status && i < (p_rtk_gpio_ctl->chip.ngpio))
+			{
+				if ((status & 0x1) && gpio_chk_irq_enable(p_rtk_gpio_ctl, i))
+				{
+					/*
+					   mux_irq = p_rtk_gpio_ctl->chip.base + i;
+					   generic_handle_irq(irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, mux_irq));
+					 */
+					hw_irq = i;
+					linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, hw_irq);
+					if (linux_irq)
+					{
+						RTK_debug("[%s]%s  line: %d \n",__FILE__,__FUNCTION__,__LINE__);
+						RTK_debug("hw_irq = %d,  assertflg[%x] = %x \n",hw_irq,((unsigned int)((p_rtk_gpio_ctl->gpio_isr_assert_enable_flag) + GPIO_REG_OFST(hw_irq))), (*((p_rtk_gpio_ctl->gpio_isr_assert_enable_flag) + GPIO_REG_OFST(hw_irq))));
+						if ( (1<<GPIO_REG_BIT(hw_irq)) & (*((p_rtk_gpio_ctl->gpio_isr_assert_enable_flag) + GPIO_REG_OFST(hw_irq)))  )
+						{
+							RTK_debug("[%s]%s  line: %d \n",__FILE__,__FUNCTION__,__LINE__);
+							generic_handle_irq(linux_irq);
+							irq_had_fired++;
+						}
+					}
+					else
+					{
+						printk(KERN_ERR "%s can not specified linux irq number for hwirq=%d .", __func__, hw_irq);
+					}
+				}
+				i++;
+				status >>= 1;
+				RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+			}
+			gpioNr += 31;
+			reg_ofst += 4;
+			RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+		}
+	}
+
+
+	RTK_debug("[%s]%s  line: %d  irq_had_fired = %d\n",__FILE__,__FUNCTION__,__LINE__,irq_had_fired);
+	iowrite32(event, p_rtk_gpio_ctl->reg_isr);
+	if(!irq_had_fired)
+		RTK_debug("%s gpio irq (hwirq=%d) has triggered but no dispatch to user handler (12345678 mean something Wrong) .\n", __func__, hw_irq);
+	return ;
+
+}
+
+__maybe_unused static int mux_irq_domain_xlate(struct irq_domain *d,
+											   struct device_node *controller,
+											   const u32 * intspec, unsigned int intsize,
+											   unsigned long *out_hwirq, unsigned int *out_type)
+{
+	RTK_debug("[%s]  %s  line: %d device_node.name = %s \n", __FILE__, __FUNCTION__, __LINE__, controller->name);
+
+	if (/*d->of_node*/to_of_node(d->fwnode) != controller)
+		return -EINVAL;
+
+	if (intsize < 1)
+		return -EINVAL;
+
+	*out_hwirq = intspec[0];
+	*out_type = 0;
+	RTK_debug("[%s]  %s  line: %d out_hwirq = %ld \n", __FILE__, __FUNCTION__, __LINE__, *out_hwirq);
+	return 0;
+}
+
+static int mux_irq_domain_map(struct irq_domain *d, unsigned int irq, irq_hw_number_t hw)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl = d->host_data;
+	RTK_debug("[%s]  %s  line: %d   irq=%d , irq_hw_number=%d\n", __FILE__, __FUNCTION__, __LINE__, irq, (unsigned int)hw);
+
+	if (!p_rtk_gpio_ctl)
+	{
+		RTK_debug("[%s]  %s  line: %d  p_rtk_gpio_ctl is NULL\n", __FILE__, __FUNCTION__, __LINE__);
+		return -EINVAL;
+	}
+	RTK_debug("[%s]  %s  line: %d  p_rtk_gpio_ctl =%x bank_assert_irq =%d ,reg_ie= %x \n", __FILE__, __FUNCTION__, __LINE__,
+			  (unsigned int)p_rtk_gpio_ctl, (unsigned int)p_rtk_gpio_ctl->bank_assert_irq, (unsigned int)p_rtk_gpio_ctl->reg_ie);
+
+	irq_set_chip(irq, &p_rtk_gpio_ctl->gp_irq_chip);
+	irq_set_chip_data(irq, (__force void *)p_rtk_gpio_ctl);
+	irq_set_handler_data(irq, p_rtk_gpio_ctl);
+	irq_set_handler(irq, handle_simple_irq);
+	//set_irq_flags(irq, IRQF_VALID);
+
+	return 0;
+}
+
+static struct irq_domain_ops mux_irq_domain_ops = {
+	.xlate = mux_irq_domain_xlate,
+	.map = mux_irq_domain_map,
+};
+
+int rtk119x_gpio_irq_setup(struct device_node *node, struct rtk119x_gpio_controller *p_rtk_gpio_ctl,
+						   const struct rtk119x_gpio_groups *p_rtk_gpio_grp)
+{
+	int bank_deassert_irq, bank_assert_irq;
+
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	p_rtk_gpio_ctl->gp_irq_chip.name = node->name;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_enable = gpio_irq_enable;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_disable = gpio_irq_disable;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_set_type = gpio_irq_type;
+	p_rtk_gpio_ctl->gp_irq_chip.flags = IRQCHIP_SET_TYPE_MASKED;
+
+	bank_assert_irq = irq_of_parse_and_map(node, 0);
+	if (!bank_assert_irq)
+	{
+		printk(KERN_ALERT "Venus IR: fail to parse of irq.\n");
+		return -ENXIO;
+	}
+
+	bank_deassert_irq = irq_of_parse_and_map(node, 1);
+	if (!bank_deassert_irq)
+	{
+		printk(KERN_ALERT "Venus IR: fail to parse of irq.\n");
+		return -ENXIO;
+	}
+
+	p_rtk_gpio_ctl->bank_assert_irq = bank_assert_irq;
+	p_rtk_gpio_ctl->bank_deassert_irq = bank_deassert_irq;
+	RTK_debug("[%s] %s  %d bank_assert_irq=%d \n", __FILE__, __FUNCTION__, __LINE__, p_rtk_gpio_ctl->bank_assert_irq);
+	RTK_debug("[%s] %s  %d bank_deassert_irq=%d \n", __FILE__, __FUNCTION__, __LINE__, p_rtk_gpio_ctl->bank_deassert_irq);
+
+	p_rtk_gpio_ctl->irq_mux_domain = irq_domain_add_simple(node, p_rtk_gpio_ctl->chip.ngpio,
+														   p_rtk_gpio_ctl->linux_irq_base, &mux_irq_domain_ops, p_rtk_gpio_ctl);
+
+	WARN(!p_rtk_gpio_ctl->irq_mux_domain, "IRQ domain init failed\n");
+
+	irq_set_chained_handler(p_rtk_gpio_ctl->bank_deassert_irq,(irq_flow_handler_t)gpio_irq_handler);
+	irq_set_handler_data(p_rtk_gpio_ctl->bank_deassert_irq, p_rtk_gpio_ctl);
+
+	irq_set_chained_handler(p_rtk_gpio_ctl->bank_assert_irq, (irq_flow_handler_t)gpio_irq_handler);
+	irq_set_handler_data(p_rtk_gpio_ctl->bank_assert_irq, p_rtk_gpio_ctl);
+	return 0;
+}
+
+static inline int __rtk119x_direction(struct gpio_chip *chip, unsigned offset, bool out)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned int gpio_reg_offset = (offset / 32) * 4;
+
+	unsigned long flags;
+	u32 temp;
+	u32 mask = 1 << (offset % 32);
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	temp = __raw_readl((p_rtk_gpio_ctl->reg_dir) + gpio_reg_offset);
+	if (out)
+	{
+		temp |= mask;
+	}
+	else
+	{
+		temp &= ~mask;
+	}
+	__raw_writel(temp, (p_rtk_gpio_ctl->reg_dir) + gpio_reg_offset);
+	RTK_debug("[%s]  %s  line: %d  offset = %d  addr = 0x%08x  temp = 0x%08x \n", __FILE__, __FUNCTION__, __LINE__, offset,
+			  (unsigned int)((p_rtk_gpio_ctl->reg_dir) + gpio_reg_offset), temp);
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+
+	return 0;
+}
+
+static int rtk119x_gpio_get(struct gpio_chip *chip, unsigned offset)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	return ioread_reg_bit(((volatile void *)p_rtk_gpio_ctl->reg_dati + GPIO_REG_OFST(offset)), GPIO_REG_BIT(offset));
+
+}
+
+static void rtk119x_gpio_set(struct gpio_chip *chip, unsigned offset, int value)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+
+	RTK_debug("[%s]  %s  line: %d  offset = %d  addr = %x  value = %d \n", __FILE__, __FUNCTION__, __LINE__, offset,
+			  (unsigned int)((volatile void *)p_rtk_gpio_ctl->reg_dato + GPIO_REG_OFST(offset)), value);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+
+	if (value)
+		iowrite_reg_bit(((volatile void *)p_rtk_gpio_ctl->reg_dato + GPIO_REG_OFST(offset)), GPIO_REG_BIT(offset), 1);
+	else
+		iowrite_reg_bit(((volatile void *)p_rtk_gpio_ctl->reg_dato + GPIO_REG_OFST(offset)), GPIO_REG_BIT(offset), 0);
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+}
+
+static int rtk119x_direction_in(struct gpio_chip *chip, unsigned offset)
+{
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	return __rtk119x_direction(chip, offset, GP_DIRIN);
+}
+
+static int rtk119x_direction_out(struct gpio_chip *chip, unsigned offset, int value)
+{
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	rtk119x_gpio_set(chip, offset, value);
+	return __rtk119x_direction(chip, offset, GP_DIROUT);
+}
+
+static int rtk119x_gpio_setdeb(struct gpio_chip *chip, unsigned offset, unsigned debounce/*microsecond(us)*/)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	RTK_debug("[%s]  %s  line: %d debounce = %d \n", __FILE__, __FUNCTION__, __LINE__, debounce);
+
+	if(debounce>=30*1000){//30ms
+		debounce = RTK119X_GPIO_DEBOUNCE_30ms;
+	}else if(debounce>=20*1000){//20ms
+		debounce = RTK119X_GPIO_DEBOUNCE_20ms;
+	}else if(debounce>=10*1000){//10ms
+		debounce = RTK119X_GPIO_DEBOUNCE_10ms;
+	}else if(debounce>=1000){// 1ms
+		debounce = RTK119X_GPIO_DEBOUNCE_1ms;
+	}else if(debounce>=100){// 100us
+		debounce = RTK119X_GPIO_DEBOUNCE_100us;
+	}else{
+		debounce = RTK119X_GPIO_DEBOUNCE_10us;
+	}
+
+	if (strcmp("rtk_misc_gpio", chip->label) == 0)
+	{
+		RTK_debug("[%s]  %s  line: %d debounce = %d  for rtk_misc_gpio \n", __FILE__, __FUNCTION__, __LINE__, debounce);
+		iowrite32((0x8 | debounce) << ((offset >> 4) * 4), ((volatile void *)p_rtk_gpio_ctl->reg_deb));
+		return 0;
+	}
+	else if (strcmp("rtk_iso_gpio", chip->label) == 0)
+	{
+		RTK_debug("[%s]  %s  line: %d debounce = %d  for rtk_iso_gpio \n", __FILE__, __FUNCTION__, __LINE__, debounce);
+		iowrite32((0x8 | debounce), ((volatile void *)p_rtk_gpio_ctl->reg_deb));
+		return 0;
+	}
+
+	return -EINVAL;
+}
+
+static int rtk119x_gpio_request(struct gpio_chip *chip, unsigned offset)
+{
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	return pinctrl_request_gpio(chip->base + offset);
+}
+
+static void rtk119x_gpio_free(struct gpio_chip *chip, unsigned offset)
+{
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	pinctrl_free_gpio(chip->base + offset);
+}
+
+static int rtk119x_gpio_to_irq(struct gpio_chip *chip, unsigned offset)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned int linux_irq = 0;
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	linux_irq = irq_create_mapping(p_rtk_gpio_ctl->irq_mux_domain, offset);
+	RTK_debug("[%s]  %s  line: %d linux_irq = %d \n", __FILE__, __FUNCTION__, __LINE__, linux_irq);
+//  linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, offset);
+	if (!linux_irq)
+	{
+		printk(KERN_ERR "%s can not specified linux irq number for hwirq=%d .\n", __func__, offset);
+		return -EINVAL;
+	}
+	return linux_irq;
+}
+
+static int rtk119x_gpio_xlate(struct gpio_chip *gc, const struct of_phandle_args *gpiospec, u32 * flags)
+{
+	unsigned int pin;
+	RTK_debug("[%s]  %s  line: %d base = %d \n", __FILE__, __FUNCTION__, __LINE__, gc->base);
+
+//  RTK_debug("[%s]  %s  line: %d args[0]=%d  args[1]=%d   args[2]=%d\n",__FILE__,__FUNCTION__,__LINE__,gpiospec->args[0],gpiospec->args[1],gpiospec->args[2]);
+	RTK_debug("[%s]  %s  line: %d args[0]=%d  \n", __FILE__, __FUNCTION__, __LINE__, gpiospec->args[0]);
+
+	if (WARN_ON(gc->of_gpio_n_cells < 1))
+		return -EINVAL;
+
+	if (WARN_ON(gpiospec->args_count < gc->of_gpio_n_cells))
+		return -EINVAL;
+
+	if (gpiospec->args[0] > gc->ngpio)
+		return -EINVAL;
+
+	pin = gpiospec->args[0];
+
+	if (gpiospec->args[1] == GP_DIRIN)	//gpio direction input
+	{
+		if (rtk119x_direction_in(gc, pin))
+			printk(KERN_ERR "gpio_xlate: failed to set pin direction in\n");
+	}
+	else
+	{
+		if (gpiospec->args[2] == GP_LOW)	//gpio direction output low
+		{
+			if (rtk119x_direction_out(gc, pin, GP_LOW))
+				printk(KERN_ERR "gpio_xlate: failed to set pin direction out \n");
+		}
+		else if (gpiospec->args[2] == GP_HIGH)
+		{
+			if (rtk119x_direction_out(gc, pin, GP_HIGH))	//gpio direction output high
+				printk(KERN_ERR "gpio_xlate: failed to set pin direction out \n");
+		}
+		else
+		{
+			printk(KERN_ERR "gpio_xlate: failed to set pin direction out \n");
+		}
+	}
+
+//  if (rtk119x_gpio_setdeb(gc, pin,gpiospec->args[2]))
+//      printk(KERN_ERR"gpio_xlate: failed to set pin deb\n");
+
+	return gpiospec->args[0];
+}
+
+void set_default_gpio(struct device_node *node)
+{
+    int num_gpios, n;
+
+    num_gpios = of_gpio_count(node);
+    if (num_gpios > 0)
+    {
+        for (n = 0; n < num_gpios; n++)
+        {
+            int gpio = of_get_gpio_flags(node, n, NULL);
+            RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+            if (gpio >= 0)
+            {
+                if (!gpio_is_valid(gpio))
+                    pr_err("[GPIO] %s: gpio %d is not valid\n",  __FUNCTION__, gpio);
+
+                if (gpio_request(gpio, node->name))
+                    pr_err("[GPIO] %s: gpio %d is in use\n",  __FUNCTION__, gpio);
+
+                gpio_free(gpio);
+            }
+            else
+                pr_err("[GPIO] %s: Could not get gpio from of \n", __FUNCTION__);
+        }
+    }
+
+}
+
+static const struct of_device_id rtk119x_gpio_of_match[] = {
+	{.compatible = "Realtek,rtk-misc-gpio-irq-mux",},
+	{.compatible = "Realtek,rtk-iso-gpio-irq-mux",},
+	{ /* Sentinel */ },
+};
+
+static int rtk119x_gpio_probe(struct platform_device *pdev)
+{
+	int i;
+	void __iomem *irq_regs_base;
+	void __iomem *gpio_regs_base;
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl;
+	const struct rtk119x_gpio_groups *p_rtk_gpio_grp = NULL;
+	unsigned int gpio_numbers;
+	unsigned int gpio_base;
+	struct device_node *node = NULL;
+	unsigned int num_gpios, n;
+
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+	node = pdev->dev.of_node;
+	if (!node)
+	{
+		printk(KERN_ERR "rtk gpio: failed to allocate device structure.\n");
+		return -ENODEV;
+	}
+
+	RTK_debug("[%s]  %s  line: %d   node name = [%s] \n", __FILE__, __FUNCTION__, __LINE__, node->name);
+
+	p_rtk_gpio_ctl = kzalloc(sizeof(struct rtk119x_gpio_controller), GFP_KERNEL);
+	if (!p_rtk_gpio_ctl)
+	{
+		printk(KERN_ERR "rtk gpio: failed to allocate device structure.\n");
+		return -ENOMEM;
+	}
+	memset(p_rtk_gpio_ctl, 0, sizeof(struct rtk119x_gpio_groups));
+
+	if (of_property_read_u32_array(node, "Realtek,gpio_numbers", &gpio_numbers, 1))
+	{
+		printk(KERN_ERR "Don't know gpio group number.\n");
+		return -EINVAL;
+	}
+
+	if (of_property_read_u32_index(node, "Realtek,gpio_base", 0, &gpio_base))
+	{
+		printk(KERN_ERR "Don't know gpio group number.\n");
+		return -EINVAL;
+	}
+
+	for (i = 0; i < rtk_gpio_desc.ngroups; i++)
+	{
+		if (strcmp(rtk_gpio_grps_array[i].group_name, node->name) == 0)
+			p_rtk_gpio_grp = &rtk_gpio_grps_array[i];
+	}
+
+	if (!p_rtk_gpio_grp)
+	{
+		printk(KERN_ERR "Don't know gpio group name.\n");
+		return -EINVAL;
+	}
+
+	RTK_debug("[%s]  %s  line: %d   node name = [%s] \n", __FILE__, __FUNCTION__, __LINE__, node->name);
+	p_rtk_gpio_ctl->chip.label = node->name;
+	p_rtk_gpio_ctl->chip.request = rtk119x_gpio_request;
+	p_rtk_gpio_ctl->chip.free = rtk119x_gpio_free;
+	p_rtk_gpio_ctl->chip.direction_input = rtk119x_direction_in;
+	p_rtk_gpio_ctl->chip.get = rtk119x_gpio_get;
+	p_rtk_gpio_ctl->chip.direction_output = rtk119x_direction_out;
+	p_rtk_gpio_ctl->chip.set = rtk119x_gpio_set;
+	p_rtk_gpio_ctl->chip.set_debounce = rtk119x_gpio_setdeb;
+	p_rtk_gpio_ctl->chip.to_irq = rtk119x_gpio_to_irq;
+	p_rtk_gpio_ctl->chip.base = gpio_base;
+	p_rtk_gpio_ctl->chip.ngpio = gpio_numbers;
+	p_rtk_gpio_ctl->chip.of_gpio_n_cells = 3;	//must be the same with     #gpio-cells = <> in dtb
+	p_rtk_gpio_ctl->chip.of_xlate = rtk119x_gpio_xlate;
+	p_rtk_gpio_ctl->chip.of_node = node;
+
+	spin_lock_init(&p_rtk_gpio_ctl->lock);
+
+	irq_regs_base = of_iomap(node, 0);
+	if (!irq_regs_base)
+	{
+		printk(KERN_ERR "unable to map irq_regs_base registers\n");
+		return -EINVAL;
+	}
+
+	gpio_regs_base = of_iomap(node, 1);
+	if (!gpio_regs_base)
+	{
+		printk(KERN_ERR "unable to map gpio_regs_base registers\n");
+		return -EINVAL;
+	}
+
+	p_rtk_gpio_ctl->gpio_isr_deassert_offset = p_rtk_gpio_grp->gpio_isr_deassert_offset;
+	p_rtk_gpio_ctl->gpio_isr_assert_offset = p_rtk_gpio_grp->gpio_isr_assert_offset;
+	p_rtk_gpio_ctl->linux_irq_base = p_rtk_gpio_grp->linux_irq_base;
+	p_rtk_gpio_ctl->reg_isr = (void __iomem *)((unsigned int)irq_regs_base + p_rtk_gpio_grp->reg_isr_off);
+	p_rtk_gpio_ctl->regs_umsk_isr_gpa = (void __iomem *)((unsigned int)irq_regs_base + p_rtk_gpio_grp->reg_umsk_isr_gpa_off);
+	p_rtk_gpio_ctl->regs_umsk_isr_gpda = (void __iomem *)((unsigned int)irq_regs_base + p_rtk_gpio_grp->reg_umsk_isr_gpda_off);
+	p_rtk_gpio_ctl->reg_dir = (void __iomem *)((unsigned int)gpio_regs_base + p_rtk_gpio_grp->reg_dir_off);
+	p_rtk_gpio_ctl->reg_dato = (void __iomem *)((unsigned int)gpio_regs_base + p_rtk_gpio_grp->reg_dato_off);
+	p_rtk_gpio_ctl->reg_dati = (void __iomem *)((unsigned int)gpio_regs_base + p_rtk_gpio_grp->reg_dati_off);
+	p_rtk_gpio_ctl->reg_ie = (void __iomem *)((unsigned int)gpio_regs_base + p_rtk_gpio_grp->reg_ie_off);
+	p_rtk_gpio_ctl->reg_dp = (void __iomem *)((unsigned int)gpio_regs_base + p_rtk_gpio_grp->reg_dp_off);
+	p_rtk_gpio_ctl->reg_deb = (void __iomem *)((unsigned int)gpio_regs_base + p_rtk_gpio_grp->reg_deb_off);
+
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+	if (gpiochip_add(&p_rtk_gpio_ctl->chip))
+	{
+		printk("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+
+	}
+	RTK_debug("[%s]  %s  line: %d \n", __FILE__, __FUNCTION__, __LINE__);
+	rtk119x_gpio_irq_setup(node, p_rtk_gpio_ctl, p_rtk_gpio_grp);
+
+	platform_set_drvdata(pdev,p_rtk_gpio_ctl);
+
+	/*TODO : need to implement gpio device tree */
+	//  of_irq_init(rtk119x_gpio_mux_irq_match);
+
+	/* Initial default gpios */
+	set_default_gpio(node);
+
+	return 0;
+}
+
+static int rtk119x_gpio_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl;
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+
+	pr_info("[GPIO] Enter %s, label(%s)\n",__FUNCTION__,p_rtk_gpio_ctl->chip.label);
+
+	disable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	disable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n",__FUNCTION__);
+
+	return 0;
+}
+
+static int rtk119x_gpio_resume(struct platform_device *pdev)
+{
+	struct rtk119x_gpio_controller *p_rtk_gpio_ctl;
+    struct device_node *node ;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+    node = p_rtk_gpio_ctl->chip.of_node;
+
+	pr_info("[GPIO] Enter %s, label(%s)\n",__FUNCTION__,p_rtk_gpio_ctl->chip.label);
+
+    /* Initial default gpios */
+    set_default_gpio(node);
+
+	enable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	enable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n",__FUNCTION__);
+
+	return 0;
+}
+
+static struct platform_driver rtk119x_gpio_driver = {
+	.driver = {
+			   .name = "rtk119x-gpio",
+			   .owner = THIS_MODULE,
+			   .of_match_table = rtk119x_gpio_of_match,
+			   },
+	.probe = rtk119x_gpio_probe,
+	.suspend = rtk119x_gpio_suspend,
+	.resume = rtk119x_gpio_resume,
+};
+
+static int rtk119x_gpio_init(void)
+{
+	return platform_driver_register(&rtk119x_gpio_driver);
+}
+
+postcore_initcall(rtk119x_gpio_init);
diff --git a/drivers/gpio/gpio-rtd119x.h b/drivers/gpio/gpio-rtd119x.h
new file mode 100644
index 00000000..d18c91f
--- /dev/null
+++ b/drivers/gpio/gpio-rtd119x.h
@@ -0,0 +1,159 @@
+/*
+ * TI DaVinci GPIO Support
+ *
+ * Copyright (c) 2006 David Brownell
+ * Copyright (c) 2007, MontaVista Software, Inc. <source@mvista.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+//#ifndef	__RTK119X_RTK119X_GPIO_H
+//#define	__RTK119X_RTK119X_GPIO_H
+
+#include <linux/io.h>
+#include <linux/spinlock.h>
+#include <asm-generic/gpio.h>
+//#include <mach/irqs.h>
+
+
+//#define RTK_DEBUG
+#ifdef RTK_DEBUG
+#define RTK_debug(fmt, ...) printk(fmt, ##__VA_ARGS__)
+#else
+#define RTK_debug(fmt, ...)
+#endif
+
+#define GP_HIGH		1
+#define GP_LOW		0
+#define GP_DIROUT	1
+#define GP_DIRIN	0
+
+typedef enum {
+    RTK119X_GPIO_DEBOUNCE_37ns = 0,
+    RTK119X_GPIO_DEBOUNCE_1us,
+    RTK119X_GPIO_DEBOUNCE_10us,
+    RTK119X_GPIO_DEBOUNCE_100us,
+    RTK119X_GPIO_DEBOUNCE_1ms,
+    RTK119X_GPIO_DEBOUNCE_10ms,
+    RTK119X_GPIO_DEBOUNCE_20ms,
+    RTK119X_GPIO_DEBOUNCE_30ms,
+}RTK119X_GPIO_DEBOUNCE;
+
+
+
+struct rtk119x_gpio_groups {
+	const char		*group_name;
+	unsigned int		linux_irq_base;
+	void __iomem		*irq_membase;
+	unsigned int 		gpio_isr_deassert_offset;
+	unsigned int 		gpio_isr_assert_offset;
+	unsigned int 		reg_isr_off;
+	unsigned int 		reg_umsk_isr_gpa_off;
+	unsigned int 		reg_umsk_isr_gpda_off;
+	void __iomem		*gpio_membase;
+	unsigned int		mem_size;
+	unsigned int 		reg_dir_off;
+	unsigned int 		reg_dato_off;
+	unsigned int 		reg_dati_off;
+	unsigned int 		reg_ie_off;
+	unsigned int 		reg_dp_off;
+	unsigned int 		reg_deb_off;
+//	int				bank_irq;
+};
+
+struct rtk119x_gpio_desc {
+	const struct rtk119x_gpio_groups	*groups;
+	int								ngroups;
+};
+
+
+/*
+ * basic gpio routines
+ *
+ * board-specific init should be done by arch/.../.../board-XXX.c (maybe
+ * initializing banks together) rather than boot loaders; kexec() won't
+ * go through boot loaders.
+ *
+ * the gpio clock will be turned on when gpios are used, and you may also
+ * need to pay attention to PINMUX registers to be sure those pins are
+ * used as gpios, not with other peripherals.
+ *
+ * On-chip GPIOs are numbered 0..(RTK119X_N_GPIO-1).  For documentation,
+ * and maybe for later updates, code may write GPIO(N).  These may be
+ * all 1.8V signals, all 3.3V ones, or a mix of the two.  A given chip
+ * may not support all the GPIOs in that range.
+ *
+ * GPIOs can also be on external chips, numbered after the ones built-in
+ * to the DaVinci chip.  For now, they won't be usable as IRQ sources.
+ */
+//#define	GPIO(X)		(X)		/* 0 <= X <= (RTK119X_N_GPIO - 1) */
+
+/* Convert GPIO signal to GPIO pin number */
+//#define GPIO_TO_PIN(bank, gpio)	(16 * (bank) + (gpio))
+
+struct rtk119x_gpio_controller {
+	struct gpio_chip	chip;
+	struct irq_chip	gp_irq_chip;
+	int				bank_deassert_irq;
+	int				bank_assert_irq;
+	struct irq_domain *irq_mux_domain;
+	spinlock_t		lock;
+	unsigned int		gpio_isr_deassert_offset;
+	unsigned int		gpio_isr_assert_offset;
+	unsigned int		gpio_isr_deassert_enable_flag[10];
+	unsigned int		gpio_isr_assert_enable_flag[10];
+	unsigned int		linux_irq_base;
+	void __iomem		*reg_isr;
+	void __iomem		*regs_umsk_isr_gpa;
+	void __iomem		*regs_umsk_isr_gpda;
+	void __iomem 	*reg_dir;
+	void __iomem 	*reg_dato;
+	void __iomem		*reg_dati;
+	void __iomem 	*reg_ie;
+	void __iomem 	*reg_dp;
+	void __iomem 	*reg_deb;
+
+};
+
+
+/* The __gpio_to_controller() and __gpio_mask() functions inline to constants
+ * with constant parameters; or in outlined code they execute at runtime.
+ *
+ * You'd access the controller directly when reading or writing more than
+ * one gpio value at a time, and to support wired logic where the value
+ * being driven by the cpu need not match the value read back.
+ *
+ * These are NOT part of the cross-platform GPIO interface
+ */
+/*
+static inline struct rtk119x_gpio_controller *
+__gpio_to_controller(unsigned gpio)
+{
+	struct rtk119x_gpio_controller *ctlrs = rtk119x_soc_info.gpio_ctlrs;
+	int index = gpio / 32;
+
+	if (!ctlrs || index >= rtk119x_soc_info.gpio_ctlrs_num)
+		return NULL;
+
+	return ctlrs + index;
+}
+
+static inline u32 __gpio_mask(unsigned gpio)
+{
+	return 1 << (gpio % 32);
+}
+*/
+
+
+
+
+
+
+
+
+
+
+//#endif	/* __RTK119X_RTK119X_GPIO_H */
diff --git a/drivers/gpio/gpio-rtd129x.c b/drivers/gpio/gpio-rtd129x.c
new file mode 100644
index 00000000..62b5297
--- /dev/null
+++ b/drivers/gpio/gpio-rtd129x.c
@@ -0,0 +1,932 @@
+/*
+ * Realtek GPIO driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/gpio.h>
+#include <linux/errno.h>
+#include <linux/kernel.h>
+#include <linux/clk.h>
+#include <linux/err.h>
+#include <linux/io.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/platform_device.h>
+#include <linux/irqdomain.h>
+#include <linux/irqchip/chained_irq.h>
+#include <linux/slab.h>
+#include <linux/interrupt.h>
+#include <linux/pinctrl/consumer.h>
+#include <linux/irqchip.h>
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+#include "gpio-rtd129x.h"
+
+#define GPIO_REG_OFST(id)       (id >> 5) // (id/32)
+#define GPIO_REG_BIT(id)        (id & 0x1F)	// id % 32
+#define GPIO_INT_REG_OFST(id)   (id/31)
+#define GPIO_INT_REG_BIT(id)    ((id%31)+1)
+
+/* intc mux tempary define the first irq number in this mux is 160 */
+static const struct rtk_gpio_groups rtk_gpio_grps_array[] = {
+	{
+		.group_name = "rtk_misc_gpio",
+		.group_index = 0,
+		/*160(predefine base)+64(intc_mux)*/
+		.linux_irq_base = 224,
+		/*Bit20, de-assert interrupt flag*/
+		.gpio_isr_deassert_int = 0x00100000,
+		/*Bit19, assert interrupt flag*/
+		.gpio_isr_assert_int = 0x00080000,
+		/*MIS_ISR*/
+		.reg_isr_off = 0xc,
+		/* MIS_UMSK_ISR_GP0A, UMSK_ISR_GP1A, UMSK_ISR_GP2A, UMSK_ISR_GP3A */
+		.reg_umsk_isr_gpa_off = {0x40, 0x44, 0xa4, 0xb8},
+		/* MIS_UMSK_ISR_GP0DA, UMSK_ISR_GP1DA, UMSK_ISR_GP2DA, UMSK_ISR_GP3DA*/
+		.reg_umsk_isr_gpda_off = {0x54, 0x58, 0xa8, 0xbc},
+		/* MIS_GP0DIR, GP1DIR, GP2DIR, GP3DIR */
+		.reg_dir_off = {0x00, 0x04, 0x08, 0x0c},
+		/* MIS_GP0DATO, GP1DATO, GP2DATO, GP3DATO */
+		.reg_dato_off = {0x10, 0x14, 0x18, 0x1c},
+		/* MIS_GP0DATI, GP1DATI, GP2DATI, GP3DATI */
+		.reg_dati_off = {0x20, 0x24, 0x28, 0x2c},
+		/* MIS_GP0IE, GP1IE, GP2IE, GP3IE */
+		.reg_ie_off = {0x30, 0x34, 0x38, 0x3c},
+		/* MIS_GP0DP, GP1DP, GP2DP, GP3DP */
+		.reg_dp_off = {0x40, 0x44, 0x48, 0x4c},
+		/*MIS_GPDEB*/
+		.reg_deb_off = 0x50,
+	},
+	{
+		.group_name = "rtk_iso_gpio",
+		.group_index = 1,
+		/*160(predefine base)+64(intc_mux)+101(misc_gpio)*/
+		.linux_irq_base = 325,
+		/*Bit20, de-assert interrupt flag*/
+		.gpio_isr_deassert_int = 0x00100000,
+		/*Bit19, assert interrupt flag*/
+		.gpio_isr_assert_int = 0x00080000,
+		/*ISO_ISR*/
+		.reg_isr_off = 0x0,
+		/* ISO_UMSK_ISR_GPA0, UMSK_ISR_GPA1 */
+		.reg_umsk_isr_gpa_off = {0x08, 0xe0},
+		/* ISO_UMSK_ISR_GPDA0, UMSK_ISR_GPDA1 */
+		.reg_umsk_isr_gpda_off = {0x0c, 0xe4},
+		/* ISO_GPDIR, GPDIR_1 */
+		.reg_dir_off = {0x00, 0x18},
+		/* ISO_GPDATO, GPDATO_1 */
+		.reg_dato_off = {0x04, 0x1c},
+		/* ISO_GPDATI, GPDATI_1 */
+		.reg_dati_off = {0x08, 0x20},
+		/* ISO_GPIE, GPIE_1 */
+		.reg_ie_off = {0x0c, 0x24},
+		/* ISO_GPDP, GPDP_1 */
+		.reg_dp_off = {0x10, 0x28},
+		/*ISO_GPDEB*/
+		.reg_deb_off = 0x14,
+	}
+};
+
+static const u32 rtk_gpio_ngroups = ARRAY_SIZE(rtk_gpio_grps_array);
+
+static u32 gpio_get_reg_offset(u32 group_index, u32 reg_type, u32 pin)
+{
+	u32 reg_index, reg_offset = UNKNOW_OFFSET;
+	const struct rtk_gpio_groups *p_rtk_gpio_grp = NULL;
+
+	if ((reg_type == GP_REG_UMSK_ISR_GPA) ||
+		(reg_type == GP_REG_UMSK_ISR_GPDA))
+		reg_index = GPIO_INT_REG_OFST(pin);
+	else
+		reg_index = GPIO_REG_OFST(pin);
+
+	if (reg_index >= GPIO_REG_ARRAY_SIZE)
+		return reg_offset;
+
+	if (group_index < rtk_gpio_ngroups)
+		p_rtk_gpio_grp = &rtk_gpio_grps_array[group_index];
+
+	if (!p_rtk_gpio_grp)
+		return reg_offset;
+
+	switch (reg_type) {
+	case GP_REG_UMSK_ISR_GPA:
+		reg_offset = p_rtk_gpio_grp->reg_umsk_isr_gpa_off[reg_index];
+		break;
+	case GP_REG_UMSK_ISR_GPDA:
+		reg_offset = p_rtk_gpio_grp->reg_umsk_isr_gpda_off[reg_index];
+		break;
+	case GP_REG_DIR:
+		reg_offset = p_rtk_gpio_grp->reg_dir_off[reg_index];
+		break;
+	case GP_REG_DATO:
+		reg_offset = p_rtk_gpio_grp->reg_dato_off[reg_index];
+		break;
+	case GP_REG_DATI:
+		reg_offset = p_rtk_gpio_grp->reg_dati_off[reg_index];
+		break;
+	case GP_REG_IE:
+		reg_offset = p_rtk_gpio_grp->reg_ie_off[reg_index];
+		break;
+	case GP_REG_DP:
+		reg_offset = p_rtk_gpio_grp->reg_dp_off[reg_index];
+		break;
+	default:
+		RTK_GPIO_DBG("[%s] Unknow type", __func__);
+	}
+
+	return reg_offset;
+}
+
+static inline void iowrite_reg_bit(void *reg,
+				unsigned char bit, unsigned char val)
+{
+	if (val)
+		writel(readl(reg) | (0x1 << bit), reg);
+	else
+		writel(readl(reg) & ~(0x1 << bit), reg);
+}
+
+#define ioread_reg_bit(reg, bits)    ((readl(reg) >> (bits)) & 0x1)
+#define chip2controller(chip)	\
+	container_of(chip, struct rtk_gpio_controller, chip)
+
+int gpio_chk_irq_enable(struct rtk_gpio_controller *p_rtk_gpio_ctl, u32 irq)
+{
+	u32 ie_offset;
+
+	RTK_GPIO_DBG("[%s] irq(%u)", __func__, irq);
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, irq);
+
+	return ioread_reg_bit(((void *)(p_rtk_gpio_ctl->gpio_regs_base)
+					+ ie_offset), GPIO_REG_BIT(irq));
+}
+
+static void gpio_irq_disable(struct irq_data *d)
+{
+	u32 ie_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+			(struct rtk_gpio_controller *)(d->chip_data);
+
+	RTK_GPIO_DBG("[%s] d->hwirq(%lu)", __func__, d->hwirq);
+
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, d->hwirq);
+
+	iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base +
+					ie_offset), GPIO_REG_BIT(d->hwirq), 0);
+}
+
+static void gpio_irq_enable(struct irq_data *d)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+				(struct rtk_gpio_controller *)(d->chip_data);
+	unsigned long irq_flag;
+	u32 gpa_offset, gpada_offset, ie_offset, gpio_int_flag;
+
+	RTK_GPIO_DBG("[%s] irq number(%u), hwirq(%lu), group(%s)",
+			__func__, d->irq, d->hwirq, d->domain->name);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, irq_flag);
+	gpio_int_flag = 0x1 << GPIO_INT_REG_BIT(d->hwirq);
+
+	gpa_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_UMSK_ISR_GPA, d->hwirq);
+	gpada_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_UMSK_ISR_GPDA, d->hwirq);
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, d->hwirq);
+
+	if ((gpa_offset != UNKNOW_OFFSET) && (gpada_offset != UNKNOW_OFFSET)
+		&& (ie_offset != UNKNOW_OFFSET)) {
+		/*Clear assert interrupt flag*/
+		if (readl(p_rtk_gpio_ctl->irq_regs_base+gpa_offset)
+			& gpio_int_flag) {
+			RTK_GPIO_DBG("[%s] Wrte Reg(0x%08llx) Val(0x%08x)",
+				__func__,
+				(u64)(p_rtk_gpio_ctl->irq_regs_base+gpa_offset),
+				gpio_int_flag);
+			writel(gpio_int_flag,
+				p_rtk_gpio_ctl->irq_regs_base + gpa_offset);
+		}
+
+		/*Clear de-assert interrupt flag*/
+		if (readl(p_rtk_gpio_ctl->irq_regs_base+gpada_offset)
+			& gpio_int_flag) {
+			RTK_GPIO_DBG("[%s] Wrte Reg(0x%08llx) Val(0x%08x)",
+				__func__,
+				(u64)(p_rtk_gpio_ctl->irq_regs_base+gpada_offset),
+				gpio_int_flag);
+			writel(gpio_int_flag,
+				p_rtk_gpio_ctl->irq_regs_base + gpada_offset);
+		}
+
+		/*Enable interrupt*/
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ie_offset), GPIO_REG_BIT(d->hwirq), 1);
+		RTK_GPIO_DBG("[%s] Reg_ie[0x%08llx]= 0x%08x", __func__,
+			  (u64)(p_rtk_gpio_ctl->gpio_regs_base+ie_offset),
+			  readl(p_rtk_gpio_ctl->gpio_regs_base+ie_offset));
+	}
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, irq_flag);
+
+}
+
+static int gpio_irq_type(struct irq_data *d, unsigned int trigger)
+{
+	u32 dp_offset;
+
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+		(struct rtk_gpio_controller *)(d->chip_data);
+
+	dp_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DP, d->hwirq);
+
+	switch (trigger) {
+	case IRQ_TYPE_EDGE_RISING:
+	case IRQ_TYPE_LEVEL_HIGH:
+		RTK_GPIO_DBG("[%s] Pin(%lu) IRQ_TYPE_EDGE_RISING",
+				__func__, d->hwirq);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ dp_offset), GPIO_REG_BIT(d->hwirq), 1);
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	case IRQ_TYPE_EDGE_FALLING:
+	case IRQ_TYPE_LEVEL_LOW:
+		RTK_GPIO_DBG("[%s] Pin(%lu) IRQ_TYPE_EDGE_FALLING", __func__, d->hwirq);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dp_offset), GPIO_REG_BIT(d->hwirq), 0);
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	case IRQ_TYPE_EDGE_BOTH:
+	case IRQ_TYPE_NONE:
+	default:
+		RTK_GPIO_DBG("[%s] Pin(%lu) trigger(%u)", __func__, d->hwirq, trigger);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dp_offset), GPIO_REG_BIT(d->hwirq), 1);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq),
+			(unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	}
+
+	return 0;
+
+}
+
+static void gpio_irq_handler(struct irq_desc *desc)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	u32 gpada_offset, gpa_offset;
+	u32 gpioNr, i;
+	u32 event, status;
+	u32 hw_irq = 12345678, linux_irq;
+	u32 irq_had_fired = 0;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+
+	p_rtk_gpio_ctl = (struct rtk_gpio_controller *)irq_desc_get_handler_data(desc);	/*rtk_gpio_controller for MISC or ISO*/
+
+	/* Get interrupt status */
+	event = readl(p_rtk_gpio_ctl->reg_isr) & (p_rtk_gpio_ctl->gpio_isr_deassert_int | p_rtk_gpio_ctl->gpio_isr_assert_int);
+	RTK_GPIO_DBG("[%s] event(0x%08x)", __func__, event);
+	if (event == 0)
+		return;
+
+	/* Handle gpio deassert */
+	if (event & (p_rtk_gpio_ctl->gpio_isr_deassert_int)) {
+		gpioNr = 0;
+		RTK_GPIO_DBG("[%s] de-assert interrupt", __func__);
+		while (gpioNr < (p_rtk_gpio_ctl->chip.ngpio)) {
+			gpada_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_UMSK_ISR_GPDA, gpioNr);
+
+			status = readl(p_rtk_gpio_ctl->irq_regs_base + gpada_offset) >> 1;	/*get regs_umsk_isr_gpda0 or regs_umsk_isr_gpda1*/
+			writel(status << 1, p_rtk_gpio_ctl->irq_regs_base + gpada_offset);
+
+			i = gpioNr;
+			while (status && i < (p_rtk_gpio_ctl->chip.ngpio)) {	/*i<MISC gpio number(60) or ISO gpio number(20)*/
+				/*printk("status = %08x\n", status);*/
+				if ((status & 0x1) && gpio_chk_irq_enable(p_rtk_gpio_ctl, i)) {
+					hw_irq = i;
+					linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, hw_irq);
+					if (linux_irq) {
+						RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+						RTK_GPIO_DBG("hw_irq = %d,  deassertflg[0x%08llx] = %x", hw_irq, (u64)(&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)]), p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)]);
+						if ((1<<GPIO_REG_BIT(hw_irq)) & (p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)])) {
+							generic_handle_irq(linux_irq);
+							irq_had_fired++;
+						}
+					} else {
+						pr_err("%s can not specified linux irq number for hwirq=%d .", __func__, hw_irq);
+					}
+				}
+				i++;
+				status >>= 1;
+				RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+			}
+
+			gpioNr += 31;
+			RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+		}
+
+	}
+
+	RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+
+	/* Handle gpio assert */
+	if (event & (p_rtk_gpio_ctl->gpio_isr_assert_int)) {
+		gpioNr = 0;
+		RTK_GPIO_DBG("[%s] assert interrupt", __func__);
+		while (gpioNr < (p_rtk_gpio_ctl->chip.ngpio)) {
+			gpa_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_UMSK_ISR_GPA, gpioNr);
+
+			status = readl(p_rtk_gpio_ctl->irq_regs_base + gpa_offset) >> 1;
+			writel(status << 1, p_rtk_gpio_ctl->irq_regs_base + gpa_offset);
+
+			i = gpioNr;
+			while (status && i < (p_rtk_gpio_ctl->chip.ngpio)) {
+				if ((status & 0x1) && gpio_chk_irq_enable(p_rtk_gpio_ctl, i)) {
+					hw_irq = i;
+					linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, hw_irq);
+					if (linux_irq) {
+						RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+						RTK_GPIO_DBG("hw_irq = %d,  assertflg[0x%08llx] = %x", hw_irq, (u64)(&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)]), p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)]);
+						if ((1<<GPIO_REG_BIT(hw_irq)) & (p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)])) {
+							RTK_GPIO_DBG("[%s]%s  line: %d", __FILE__, __func__, __LINE__);
+							generic_handle_irq(linux_irq);
+							irq_had_fired++;
+						}
+					} else {
+						pr_err("%s can not specified linux irq number for hwirq=%d .", __func__, hw_irq);
+					}
+				}
+				i++;
+				status >>= 1;
+				RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+			}
+			gpioNr += 31;
+			RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+		}
+	}
+
+
+	RTK_GPIO_DBG("[%s] irq_had_fired = %d", __func__, irq_had_fired);
+	writel(event, p_rtk_gpio_ctl->reg_isr);
+	if (!irq_had_fired)
+		RTK_GPIO_DBG("%s gpio irq(hwirq=%d) has triggered but no dispatch",
+				__func__, hw_irq);
+		RTK_GPIO_DBG("to user handler (12345678 mean something Wrong)");
+	return;
+
+}
+
+static __maybe_unused int
+	mux_irq_domain_xlate(struct irq_domain *d,
+		struct device_node *controller, const u32 *intspec, u32 intsize,
+		unsigned long *out_hwirq, u32 *out_type)
+{
+	RTK_GPIO_DBG("[%s] device_node.name = %s", __func__, controller->name);
+
+	if (/*d->of_node*/to_of_node(d->fwnode) != controller)
+		return -EINVAL;
+
+	if (intsize < 1)
+		return -EINVAL;
+
+	*out_hwirq = intspec[0];
+	*out_type = 0;
+	RTK_GPIO_DBG("[%s] out_hwirq = %ld", __func__, *out_hwirq);
+	return 0;
+}
+
+
+static int mux_irq_domain_map(struct irq_domain *d, u32 irq, irq_hw_number_t hw)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = d->host_data;
+
+	RTK_GPIO_DBG("[%s] irq=%d , irq_hw_number=%d", __func__, irq, (u32)hw);
+
+	if (!p_rtk_gpio_ctl) {
+		RTK_GPIO_DBG("[%s] p_rtk_gpio_ctl is NULL", __func__);
+		return -EINVAL;
+	}
+
+	irq_set_chip(irq, &p_rtk_gpio_ctl->gp_irq_chip);
+	irq_set_chip_data(irq, (__force void *)p_rtk_gpio_ctl);
+	irq_set_handler_data(irq, p_rtk_gpio_ctl);
+	irq_set_handler(irq, handle_simple_irq);
+	//set_irq_flags(irq, IRQF_VALID);
+
+	return 0;
+}
+
+static const struct irq_domain_ops mux_irq_domain_ops = {
+	.xlate = mux_irq_domain_xlate,
+	.map = mux_irq_domain_map,
+};
+
+int rtk_gpio_irq_setup(struct device_node *node,
+	struct rtk_gpio_controller *p_rtk_gpio_ctl,
+	const struct rtk_gpio_groups *p_rtk_gpio_grp)
+{
+	unsigned int bank_deassert_irq, bank_assert_irq;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+
+	p_rtk_gpio_ctl->gp_irq_chip.name = node->name;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_enable = gpio_irq_enable;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_disable = gpio_irq_disable;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_set_type = gpio_irq_type;
+	p_rtk_gpio_ctl->gp_irq_chip.flags = IRQCHIP_SET_TYPE_MASKED;
+
+	bank_assert_irq = irq_of_parse_and_map(node, 0);
+	if (!bank_assert_irq) {
+		pr_alert("[GPIO] Fail to parse of irq.\n");
+		return -ENXIO;
+	}
+
+	bank_deassert_irq = irq_of_parse_and_map(node, 1);
+	if (!bank_deassert_irq) {
+		pr_alert("[GPIO] Fail to parse of irq.\n");
+		return -ENXIO;
+	}
+
+	p_rtk_gpio_ctl->bank_assert_irq = bank_assert_irq;
+	p_rtk_gpio_ctl->bank_deassert_irq = bank_deassert_irq;
+	RTK_GPIO_DBG("[%s] bank_assert_irq=%d", __func__,
+			p_rtk_gpio_ctl->bank_assert_irq);
+	RTK_GPIO_DBG("[%s] bank_deassert_irq=%d", __func__,
+			p_rtk_gpio_ctl->bank_deassert_irq);
+
+	p_rtk_gpio_ctl->irq_mux_domain = irq_domain_add_simple(node,
+			p_rtk_gpio_ctl->chip.ngpio,
+			p_rtk_gpio_ctl->linux_irq_base,
+			&mux_irq_domain_ops, p_rtk_gpio_ctl);
+
+	WARN(!p_rtk_gpio_ctl->irq_mux_domain, "IRQ domain init failed\n");
+
+	irq_set_chained_handler(p_rtk_gpio_ctl->bank_deassert_irq,
+				(irq_flow_handler_t)gpio_irq_handler);
+	irq_set_handler_data(p_rtk_gpio_ctl->bank_deassert_irq, p_rtk_gpio_ctl);
+
+	irq_set_chained_handler(p_rtk_gpio_ctl->bank_assert_irq,
+				(irq_flow_handler_t)gpio_irq_handler);
+	irq_set_handler_data(p_rtk_gpio_ctl->bank_assert_irq, p_rtk_gpio_ctl);
+	return 0;
+}
+
+static inline int __rtk_gpio_direction(struct gpio_chip *chip,
+	unsigned int offset, bool out)
+{
+	u32 dir_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+	u32 temp;
+	u32 mask = 1 << (offset % 32);
+
+	RTK_GPIO_DBG("[%s] offset(%u) out(%u)", __func__, offset, out);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DIR, offset);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	if (out)
+		temp |= mask;
+	else
+		temp &= ~mask;
+
+	__raw_writel(temp, (p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	RTK_GPIO_DBG("[%s] offset(%u)  addr(0x%08llx)  temp(0x%08x)",
+			__func__, offset,
+			(u64)((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset),
+			temp);
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+
+	return 0;
+}
+
+static int rtk_gpio_get(struct gpio_chip *chip, unsigned int offset)
+{
+	u32 dati_offset, dato_offset, dir_offset;
+	u32 temp, value;
+	u32 mask = 1 << (offset % 32);
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DIR, offset);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	if (temp & mask) {  /*direction out*/
+		dato_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+						GP_REG_DATO, offset);
+		value = ioread_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base +
+					dato_offset), GPIO_REG_BIT(offset));
+	} else {  /*direction in*/
+		dati_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+						GP_REG_DATI, offset);
+		value = ioread_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base +
+					dati_offset), GPIO_REG_BIT(offset));
+	}
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+
+	return value;
+}
+
+static void rtk_gpio_set(struct gpio_chip *chip, unsigned int offset, int value)
+{
+	u32 dato_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+
+	RTK_GPIO_DBG("[%s] offset(%u) value(%d)", __func__, offset, value);
+
+	dato_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DATO, offset);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	if (value)
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dato_offset),
+				GPIO_REG_BIT(offset), 1);
+	else
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dato_offset),
+				GPIO_REG_BIT(offset), 0);
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+}
+
+static int rtk_gpio_direction_in(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	return __rtk_gpio_direction(chip, offset, GP_DIRIN);
+}
+
+static int rtk_gpio_direction_out(struct gpio_chip *chip,
+			unsigned int offset, int value)
+{
+	RTK_GPIO_DBG("[%s] offset(%u) value(%d)",
+			__func__, offset, value);
+
+	rtk_gpio_set(chip, offset, value);
+	return __rtk_gpio_direction(chip, offset, GP_DIROUT);
+}
+
+static int rtk_gpio_get_direction(struct gpio_chip *chip, unsigned int offset)
+{
+	u32 dir_offset;
+	u32 temp, dir;
+	u32 mask = 1 << (offset % 32);
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+
+	RTK_GPIO_DBG("[%s] offset(%u)\n", __func__, offset);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DIR, offset);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	dir = (temp & mask) ? 0 : 1;
+
+	return dir;
+}
+
+
+static int rtk_gpio_setdeb(struct gpio_chip *chip,
+	unsigned int offset, unsigned int debounce/*microsecond(us)*/)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+
+	RTK_GPIO_DBG("[%s] offset(%u) debounce(%d)",
+			__func__, offset, debounce);
+
+	if (debounce >= 30*1000) {//30ms
+		debounce = RTK_GPIO_DEBOUNCE_30ms;
+	} else if (debounce >= 20*1000) {//20ms
+		debounce = RTK_GPIO_DEBOUNCE_20ms;
+	} else if (debounce >= 10*1000) {//10ms
+		debounce = RTK_GPIO_DEBOUNCE_10ms;
+	} else if (debounce >= 1000) {// 1ms
+		debounce = RTK_GPIO_DEBOUNCE_1ms;
+	} else if (debounce >= 100) {// 100us
+		debounce = RTK_GPIO_DEBOUNCE_100us;
+	} else {
+		debounce = RTK_GPIO_DEBOUNCE_10us;
+	}
+
+	if (strcmp("rtk_misc_gpio", chip->label) == 0) {
+		writel((0x8 | debounce) << ((offset >> 4) * 4),
+			((void *)p_rtk_gpio_ctl->reg_deb));
+		return 0;
+	} else if (strcmp("rtk_iso_gpio", chip->label) == 0) {
+		writel((0x8 | debounce),
+			((void *)p_rtk_gpio_ctl->reg_deb));
+		return 0;
+	}
+	RTK_GPIO_DBG("[%s] Fail", __func__);
+	return -EINVAL;
+}
+
+static int rtk_gpio_request(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	return pinctrl_request_gpio(chip->base + offset);
+}
+
+static void rtk_gpio_free(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	pinctrl_free_gpio(chip->base + offset);
+}
+
+static int rtk_gpio_to_irq(struct gpio_chip *chip, unsigned int offset)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	u32 linux_irq = 0;
+
+	linux_irq = irq_create_mapping(p_rtk_gpio_ctl->irq_mux_domain, offset);
+	RTK_GPIO_DBG("[%s] offset(%u) linux_irq(%u)",
+			__func__, offset, linux_irq);
+
+	if (!linux_irq) {
+		pr_err("%s can not specified linux irq number for hwirq=%d .\n",
+			__func__, offset);
+		return -EINVAL;
+	}
+	return linux_irq;
+}
+
+static int rtk_gpio_xlate(struct gpio_chip *gc,
+	const struct of_phandle_args *gpiospec, u32 *flags)
+{
+	u32 pin;
+
+	RTK_GPIO_DBG("[%s] base(%d), args[0]=%d",
+			__func__, gc->base, gpiospec->args[0]);
+
+	if (WARN_ON(gc->of_gpio_n_cells < 1))
+		return -EINVAL;
+
+	if (WARN_ON(gpiospec->args_count < gc->of_gpio_n_cells))
+		return -EINVAL;
+
+	if (gpiospec->args[0] > gc->ngpio)
+		return -EINVAL;
+
+	pin = gpiospec->args[0];
+
+	if (gpiospec->args[1] == GP_DIRIN) {	//gpio direction input
+		if (rtk_gpio_direction_in(gc, pin))
+			pr_err("gpio_xlate: failed to set pin direction in\n");
+
+		if (flags)//low active flag
+			*flags = gpiospec->args[2];
+	} else {
+		if (gpiospec->args[2] == GP_LOW) {
+			/*gpio direction output low*/
+			if (rtk_gpio_direction_out(gc, pin, GP_LOW))
+				pr_err("gpio_xlate: failed to set pin direction out\n");
+		} else if (gpiospec->args[2] == GP_HIGH) {
+			/*gpio direction output high*/
+			if (rtk_gpio_direction_out(gc, pin, GP_HIGH))
+				pr_err("gpio_xlate: failed to set pin direction out\n");
+		} else {
+			pr_err("gpio_xlate: failed to set pin direction out\n");
+		}
+	}
+
+	return gpiospec->args[0];
+}
+
+void set_default_gpio(struct device_node *node)
+{
+	int num_gpios, n;
+
+	num_gpios = of_gpio_count(node);
+	if (num_gpios > 0) {
+		for (n = 0; n < num_gpios; n++) {
+			int gpio = of_get_gpio_flags(node, n, NULL);
+
+			RTK_GPIO_DBG("[%s]  %s  line: %d",
+					__FILE__, __func__, __LINE__);
+			if (gpio >= 0) {
+				if (!gpio_is_valid(gpio))
+					pr_err("[GPIO] %s: gpio %d is not valid\n",
+						__func__, gpio);
+
+				if (gpio_request(gpio, node->name))
+					pr_err("[GPIO] %s: gpio %d is in use\n",
+						__func__, gpio);
+
+				gpio_free(gpio);
+			} else {
+				pr_err("[GPIO] %s: Could not get gpio from of\n",
+					__func__);
+			}
+		}
+	} else {
+		RTK_GPIO_INF("No default gpio need to set");
+	}
+}
+
+static const struct of_device_id rtk_gpio_of_match[] = {
+	{.compatible = "realtek,rtk-misc-gpio-irq-mux",},
+	{.compatible = "realtek,rtk-iso-gpio-irq-mux",},
+	{ /* Sentinel */ },
+};
+
+static int rtk_gpio_probe(struct platform_device *pdev)
+{
+	int i;
+	void __iomem *irq_regs_base;
+	void __iomem *gpio_regs_base;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	const struct rtk_gpio_groups *p_rtk_gpio_grp = NULL;
+	u32 gpio_numbers;
+	u32 gpio_base;
+	struct device_node *node = NULL;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+	node = pdev->dev.of_node;
+	if (!node) {
+		pr_err("rtk gpio: failed to allocate device structure.\n");
+		return -ENODEV;
+	}
+
+	RTK_GPIO_DBG("[%s] node name = [%s]", __func__, node->name);
+
+	p_rtk_gpio_ctl =
+		kzalloc(sizeof(struct rtk_gpio_controller), GFP_KERNEL);
+	if (!p_rtk_gpio_ctl) {
+		pr_err("rtk gpio: failed to allocate device structure.\n");
+		return -ENOMEM;
+	}
+	memset(p_rtk_gpio_ctl, 0, sizeof(struct rtk_gpio_groups));
+
+	if (of_property_read_u32_array(node, "Realtek,gpio_numbers",
+		&gpio_numbers, 1)) {
+		pr_err("Don't know gpio group number.\n");
+		return -EINVAL;
+	}
+
+	if (of_property_read_u32_index(node, "Realtek,gpio_base",
+		0, &gpio_base)) {
+		pr_err("Don't know gpio group number.\n");
+		return -EINVAL;
+	}
+
+	for (i = 0; i < rtk_gpio_ngroups; i++) {
+		if (strcmp(rtk_gpio_grps_array[i].group_name, node->name) == 0)
+			p_rtk_gpio_grp = &rtk_gpio_grps_array[i];
+	}
+
+	if (!p_rtk_gpio_grp) {
+		pr_err("Don't know gpio group name.\n");
+		return -EINVAL;
+	}
+
+	p_rtk_gpio_ctl->chip.label = node->name;
+	p_rtk_gpio_ctl->chip.request = rtk_gpio_request;
+	p_rtk_gpio_ctl->chip.free = rtk_gpio_free;
+	p_rtk_gpio_ctl->chip.direction_input = rtk_gpio_direction_in;
+	p_rtk_gpio_ctl->chip.get = rtk_gpio_get;
+	p_rtk_gpio_ctl->chip.get_direction= rtk_gpio_get_direction;
+	p_rtk_gpio_ctl->chip.direction_output = rtk_gpio_direction_out;
+	p_rtk_gpio_ctl->chip.set = rtk_gpio_set;
+	p_rtk_gpio_ctl->chip.set_debounce = rtk_gpio_setdeb;
+	p_rtk_gpio_ctl->chip.to_irq = rtk_gpio_to_irq;
+	p_rtk_gpio_ctl->chip.base = gpio_base;
+	p_rtk_gpio_ctl->chip.ngpio = gpio_numbers;
+	/*must be the same with     #gpio-cells = <> in dtb*/
+	p_rtk_gpio_ctl->chip.of_gpio_n_cells = 3;
+	p_rtk_gpio_ctl->chip.of_xlate = rtk_gpio_xlate;
+	p_rtk_gpio_ctl->chip.of_node = node;
+
+	spin_lock_init(&p_rtk_gpio_ctl->lock);
+
+	irq_regs_base = of_iomap(node, 0);
+	if (!irq_regs_base) {
+		pr_err("unable to map irq_regs_base registers\n");
+		return -EINVAL;
+	}
+
+	gpio_regs_base = of_iomap(node, 1);
+	if (!gpio_regs_base) {
+		pr_err("unable to map gpio_regs_base registers\n");
+		return -EINVAL;
+	}
+
+	p_rtk_gpio_ctl->gpio_isr_deassert_int =
+				p_rtk_gpio_grp->gpio_isr_deassert_int;
+	p_rtk_gpio_ctl->gpio_isr_assert_int =
+				p_rtk_gpio_grp->gpio_isr_assert_int;
+	p_rtk_gpio_ctl->linux_irq_base = p_rtk_gpio_grp->linux_irq_base;
+
+	p_rtk_gpio_ctl->group_index = p_rtk_gpio_grp->group_index;
+	p_rtk_gpio_ctl->irq_regs_base = (void __iomem *)irq_regs_base;
+	p_rtk_gpio_ctl->gpio_regs_base = (void __iomem *)gpio_regs_base;
+	p_rtk_gpio_ctl->reg_isr = (void __iomem *)irq_regs_base +
+					p_rtk_gpio_grp->reg_isr_off;
+	p_rtk_gpio_ctl->reg_deb = (void __iomem *)gpio_regs_base +
+					p_rtk_gpio_grp->reg_deb_off;
+
+	if (gpiochip_add(&p_rtk_gpio_ctl->chip))
+		pr_info("[%s]  %s  line: %d\n", __FILE__, __func__, __LINE__);
+
+
+	rtk_gpio_irq_setup(node, p_rtk_gpio_ctl, p_rtk_gpio_grp);
+
+	platform_set_drvdata(pdev, p_rtk_gpio_ctl);
+
+	/* Initial default gpios */
+	set_default_gpio(node);
+
+	return 0;
+}
+
+static int rtk_gpio_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return 0;
+	}
+#endif
+
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+
+	disable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	disable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static int rtk_gpio_resume(struct platform_device *pdev)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	struct device_node *node;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+	node = p_rtk_gpio_ctl->chip.of_node;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return 0;
+	}
+#endif
+
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+
+	/* Initial default gpios */
+	set_default_gpio(node);
+
+	enable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	enable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static struct platform_driver rtk_gpio_driver = {
+	.driver = {
+			   .name = "rtk_gpio",
+			   .owner = THIS_MODULE,
+			   .of_match_table = rtk_gpio_of_match,
+			   },
+	.probe = rtk_gpio_probe,
+	.suspend = rtk_gpio_suspend,
+	.resume = rtk_gpio_resume,
+};
+
+static int rtk_gpio_drv_reg(void)
+{
+	return platform_driver_register(&rtk_gpio_driver);
+}
+
+postcore_initcall(rtk_gpio_drv_reg);
diff --git a/drivers/gpio/gpio-rtd129x.h b/drivers/gpio/gpio-rtd129x.h
new file mode 100644
index 00000000..47e6e2d
--- /dev/null
+++ b/drivers/gpio/gpio-rtd129x.h
@@ -0,0 +1,104 @@
+/*
+ * Realtek GPIO driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+
+#ifndef _RTK_GPIO_H_
+#define _RTK_GPIO_H_
+
+#include <linux/io.h>
+#include <linux/spinlock.h>
+#include <asm-generic/gpio.h>
+
+
+//#define RTK_GPIO_DEBUG
+#ifdef RTK_GPIO_DEBUG
+#define RTK_GPIO_DBG(fmt, ...) pr_info("[GPIO DBG] " fmt "\n", ## __VA_ARGS__)
+#else
+#define RTK_GPIO_DBG(fmt, ...)
+#endif
+
+#define RTK_GPIO_INF(fmt, ...) pr_info("[GPIO] " fmt "\n", ## __VA_ARGS__)
+#define RTK_GPIO_ERR(fmt, ...) pr_err("[GPIO Error] " fmt "\n", ## __VA_ARGS__)
+
+#define GP_HIGH		1
+#define GP_LOW		0
+#define GP_DIROUT	1
+#define GP_DIRIN	0
+
+/*RTK_GPIO_DEBOUNCE*/
+enum {
+	RTK_GPIO_DEBOUNCE_37ns = 0,
+	RTK_GPIO_DEBOUNCE_1us,
+	RTK_GPIO_DEBOUNCE_10us,
+	RTK_GPIO_DEBOUNCE_100us,
+	RTK_GPIO_DEBOUNCE_1ms,
+	RTK_GPIO_DEBOUNCE_10ms,
+	RTK_GPIO_DEBOUNCE_20ms,
+	RTK_GPIO_DEBOUNCE_30ms,
+};
+
+#define GPIO_REG_ARRAY_SIZE	 4
+
+#define UNKNOW_OFFSET	0xFFFF
+
+/*GP_REG_TYPE*/
+enum {
+	GP_REG_UMSK_ISR_GPA = 0,
+	GP_REG_UMSK_ISR_GPDA,
+	GP_REG_DIR,
+	GP_REG_DATO,
+	GP_REG_DATI,
+	GP_REG_IE,
+	GP_REG_DP
+};
+
+
+struct rtk_gpio_groups {
+	const char	*group_name;
+	u32	group_index;
+	u32	linux_irq_base;
+	void __iomem	*irq_membase;
+	u32	gpio_isr_deassert_int;
+	u32	gpio_isr_assert_int;
+	u32	reg_isr_off;
+	u32	reg_umsk_isr_gpa_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_umsk_isr_gpda_off[GPIO_REG_ARRAY_SIZE];
+	void __iomem	*gpio_membase;
+	u32	mem_size;
+	u32	reg_dir_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dato_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dati_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_ie_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dp_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_deb_off;
+};
+
+
+struct rtk_gpio_controller {
+	struct gpio_chip	chip;
+	struct irq_chip	gp_irq_chip;
+	unsigned int	bank_deassert_irq;
+	unsigned int	bank_assert_irq;
+	struct irq_domain *irq_mux_domain;
+	spinlock_t		lock;
+	u32		gpio_isr_deassert_int;
+	u32		gpio_isr_assert_int;
+	u64		gpio_isr_deassert_enable_flag[GPIO_REG_ARRAY_SIZE];
+	u64		gpio_isr_assert_enable_flag[GPIO_REG_ARRAY_SIZE];
+	u32		linux_irq_base;
+	u32 group_index;
+	void __iomem	*reg_isr;
+	void __iomem	*irq_regs_base;
+	void __iomem	*gpio_regs_base;
+	void __iomem	*reg_deb;
+};
+
+#endif //_RTK_GPIO_H_
diff --git a/drivers/gpio/gpio-rtd139x.c b/drivers/gpio/gpio-rtd139x.c
new file mode 100644
index 00000000..ccd2186
--- /dev/null
+++ b/drivers/gpio/gpio-rtd139x.c
@@ -0,0 +1,925 @@
+/*
+ * Realtek GPIO driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/gpio.h>
+#include <linux/errno.h>
+#include <linux/kernel.h>
+#include <linux/clk.h>
+#include <linux/err.h>
+#include <linux/io.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/platform_device.h>
+#include <linux/irqdomain.h>
+#include <linux/irqchip/chained_irq.h>
+#include <linux/slab.h>
+#include <linux/interrupt.h>
+#include <linux/pinctrl/consumer.h>
+#include <linux/irqchip.h>
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+#include "../pinctrl/realtek/pinctrl-rtd139x.h"
+#include "gpio-rtd139x.h"
+
+#define GPIO_REG_OFST(id)       (id >> 5) /* (id/32)*/
+#define GPIO_REG_BIT(id)        (id & 0x1F)	/* id % 32*/
+#define GPIO_DEB_OFST(id)       (id >> 3) /* (id/8)*/
+#define GPIO_DEB_BIT(id)        (id & 0x7)	/* id % 8*/
+#define GPIO_INT_REG_OFST(id)   (id/31)
+#define GPIO_INT_REG_BIT(id)    ((id%31)+1)
+
+/* intc mux tempary define the first irq number in this mux is 160 */
+static const struct rtk_gpio_groups rtk_gpio_grps_array[] = {
+	{
+		.group_name = "rtk_iso_gpio",
+		.group_index = 0,
+		/*160(predefine base)+64(intc_mux)*/
+		.linux_irq_base = 224,
+		/*Bit20, de-assert interrupt flag*/
+		.gpio_isr_deassert_int = 0x00100000,
+		/*Bit19, assert interrupt flag*/
+		.gpio_isr_assert_int = 0x00080000,
+		/*ISO_ISR*/
+		.reg_isr_off = 0x0,
+		 /* ISO_UMSK_ISR_GPA0, UMSK_ISR_GPA1 */
+		.reg_umsk_isr_gpa_off = {0x08, 0xe0},
+		/* ISO_UMSK_ISR_GPDA0, UMSK_ISR_GPDA1 */
+		.reg_umsk_isr_gpda_off = {0x0c, 0xe4},
+		/* ISO_GPDIR, GPDIR_1 */
+		.reg_dir_off = {0x00, 0x18},
+		/* ISO_GPDATO, GPDATO_1 */
+		.reg_dato_off = {0x04, 0x1c},
+		/* ISO_GPDATI, GPDATI_1 */
+		.reg_dati_off = {0x08, 0x20},
+		/* ISO_GPIE, GPIE_1 */
+		.reg_ie_off = {0x0c, 0x24},
+		/* ISO_GPDP, GPDP_1 */
+		.reg_dp_off = {0x10, 0x28},
+		/*ISO_GPDEB*/
+		.reg_deb_off = {0x30, 0x34, 0x38, 0x3c, 0x40, 0x44, 0x48, 0x4c},
+	}
+};
+
+static const u32 rtk_gpio_ngroups = ARRAY_SIZE(rtk_gpio_grps_array);
+
+static u32 gpio_get_reg_offset(u32 group_index, u32 reg_type, u32 pin)
+{
+	u32 reg_index, reg_offset = UNKNOW_OFFSET;
+	const struct rtk_gpio_groups *p_rtk_gpio_grp = NULL;
+
+	if ((reg_type == GP_REG_UMSK_ISR_GPA) ||
+			(reg_type == GP_REG_UMSK_ISR_GPDA))
+		reg_index = GPIO_INT_REG_OFST(pin);
+	else
+		reg_index = GPIO_REG_OFST(pin);
+
+	if (reg_index >= GPIO_REG_ARRAY_SIZE)
+		return reg_offset;
+
+	if (group_index < rtk_gpio_ngroups)
+		p_rtk_gpio_grp = &rtk_gpio_grps_array[group_index];
+
+	if (!p_rtk_gpio_grp)
+		return reg_offset;
+
+	switch (reg_type) {
+	case GP_REG_UMSK_ISR_GPA:
+		reg_offset = p_rtk_gpio_grp->reg_umsk_isr_gpa_off[reg_index];
+		break;
+	case GP_REG_UMSK_ISR_GPDA:
+		reg_offset = p_rtk_gpio_grp->reg_umsk_isr_gpda_off[reg_index];
+		break;
+	case GP_REG_DIR:
+		reg_offset = p_rtk_gpio_grp->reg_dir_off[reg_index];
+		break;
+	case GP_REG_DATO:
+		reg_offset = p_rtk_gpio_grp->reg_dato_off[reg_index];
+		break;
+	case GP_REG_DATI:
+		reg_offset = p_rtk_gpio_grp->reg_dati_off[reg_index];
+		break;
+	case GP_REG_IE:
+		reg_offset = p_rtk_gpio_grp->reg_ie_off[reg_index];
+		break;
+	case GP_REG_DP:
+		reg_offset = p_rtk_gpio_grp->reg_dp_off[reg_index];
+		break;
+	default:
+		RTK_GPIO_DBG("[%s] Unknow type", __func__);
+	}
+
+	return reg_offset;
+}
+
+static inline void iowrite_reg_bit(void *reg,
+				unsigned char bit, unsigned char val)
+{
+	if (val)
+		writel(readl(reg) | (0x1 << bit), reg);
+	else
+		writel(readl(reg) & ~(0x1 << bit), reg);
+}
+
+#define ioread_reg_bit(reg, bits)    ((readl(reg) >> (bits)) & 0x1)
+#define chip2controller(chip)	\
+	container_of(chip, struct rtk_gpio_controller, chip)
+
+int gpio_chk_irq_enable(struct rtk_gpio_controller *p_rtk_gpio_ctl, u32 irq)
+{
+	u32 ie_offset;
+
+	RTK_GPIO_DBG("[%s] irq(%u)", __func__, irq);
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, irq);
+
+	return ioread_reg_bit(((void *)(p_rtk_gpio_ctl->gpio_regs_base)
+					+ ie_offset), GPIO_REG_BIT(irq));
+}
+
+static void gpio_irq_disable(struct irq_data *d)
+{
+	u32 ie_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+			(struct rtk_gpio_controller *)(d->chip_data);
+
+	RTK_GPIO_DBG("[%s] d->hwirq(%lu)", __func__, d->hwirq);
+
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, d->hwirq);
+
+	iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base +
+					ie_offset), GPIO_REG_BIT(d->hwirq), 0);
+}
+
+static void gpio_irq_enable(struct irq_data *d)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+				(struct rtk_gpio_controller *)(d->chip_data);
+	unsigned long irq_flag;
+	u32 gpa_offset, gpada_offset, ie_offset, gpio_int_flag;
+
+	RTK_GPIO_DBG("[%s] irq number(%u), hwirq(%lu), group(%s)",
+			__func__, d->irq, d->hwirq, d->domain->name);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, irq_flag);
+	gpio_int_flag = 0x1 << GPIO_INT_REG_BIT(d->hwirq);
+
+	gpa_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_UMSK_ISR_GPA, d->hwirq);
+	gpada_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_UMSK_ISR_GPDA, d->hwirq);
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, d->hwirq);
+
+	if ((gpa_offset != UNKNOW_OFFSET) && (gpada_offset != UNKNOW_OFFSET)
+		&& (ie_offset != UNKNOW_OFFSET)) {
+		/*Clear assert interrupt flag*/
+		if (readl(p_rtk_gpio_ctl->irq_regs_base+gpa_offset)
+			& gpio_int_flag) {
+			RTK_GPIO_DBG("[%s] Wrte Reg(0x%08llx) Val(0x%08x)",
+				__func__,
+				(u64)(p_rtk_gpio_ctl->irq_regs_base+gpa_offset),
+				gpio_int_flag);
+			writel(gpio_int_flag,
+				p_rtk_gpio_ctl->irq_regs_base + gpa_offset);
+		}
+
+		/*Clear de-assert interrupt flag*/
+		if (readl(p_rtk_gpio_ctl->irq_regs_base+gpada_offset)
+			& gpio_int_flag) {
+			RTK_GPIO_DBG("[%s] Wrte Reg(0x%08llx) Val(0x%08x)",
+				__func__,
+				(u64)(p_rtk_gpio_ctl->irq_regs_base+gpada_offset),
+				gpio_int_flag);
+			writel(gpio_int_flag,
+				p_rtk_gpio_ctl->irq_regs_base + gpada_offset);
+		}
+
+		/*Enable interrupt*/
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ie_offset), GPIO_REG_BIT(d->hwirq), 1);
+		RTK_GPIO_DBG("[%s] Reg_ie[0x%08llx]= 0x%08x", __func__,
+			  (u64)(p_rtk_gpio_ctl->gpio_regs_base+ie_offset),
+			  readl(p_rtk_gpio_ctl->gpio_regs_base+ie_offset));
+	}
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, irq_flag);
+
+}
+
+static int gpio_irq_type(struct irq_data *d, unsigned int trigger)
+{
+	u32 dp_offset;
+
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+		(struct rtk_gpio_controller *)(d->chip_data);
+
+	dp_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DP, d->hwirq);
+
+	switch (trigger) {
+	case IRQ_TYPE_EDGE_RISING:
+	case IRQ_TYPE_LEVEL_HIGH:
+		RTK_GPIO_DBG("[%s] Pin(%lu) IRQ_TYPE_EDGE_RISING",
+				__func__, d->hwirq);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ dp_offset), GPIO_REG_BIT(d->hwirq), 1);
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	case IRQ_TYPE_EDGE_FALLING:
+	case IRQ_TYPE_LEVEL_LOW:
+		RTK_GPIO_DBG("[%s] Pin(%lu) IRQ_TYPE_EDGE_FALLING", __func__, d->hwirq);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dp_offset), GPIO_REG_BIT(d->hwirq), 0);
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	case IRQ_TYPE_EDGE_BOTH:
+	case IRQ_TYPE_NONE:
+	default:
+		RTK_GPIO_DBG("[%s] Pin(%lu) trigger(%u)", __func__, d->hwirq, trigger);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dp_offset), GPIO_REG_BIT(d->hwirq), 1);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq),
+			(unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	}
+
+	return 0;
+
+}
+
+static void gpio_irq_handler(struct irq_desc *desc)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	u32 gpada_offset, gpa_offset;
+	u32 gpioNr, i;
+	u32 event, status;
+	u32 hw_irq = 12345678, linux_irq;
+	u32 irq_had_fired = 0;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+
+	p_rtk_gpio_ctl = (struct rtk_gpio_controller *)irq_desc_get_handler_data(desc);	/*rtk_gpio_controller for MISC or ISO*/
+
+	/* Get interrupt status */
+	event = readl(p_rtk_gpio_ctl->reg_isr) & (p_rtk_gpio_ctl->gpio_isr_deassert_int | p_rtk_gpio_ctl->gpio_isr_assert_int);
+	RTK_GPIO_DBG("[%s] event(0x%08x)", __func__, event);
+	if (event == 0)
+		return;
+
+	/* Handle gpio deassert */
+	if (event & (p_rtk_gpio_ctl->gpio_isr_deassert_int)) {
+		gpioNr = 0;
+		RTK_GPIO_DBG("[%s] de-assert interrupt", __func__);
+		while (gpioNr < (p_rtk_gpio_ctl->chip.ngpio)) {
+			gpada_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_UMSK_ISR_GPDA, gpioNr);
+
+			status = readl(p_rtk_gpio_ctl->irq_regs_base + gpada_offset) >> 1;	/*get regs_umsk_isr_gpda0 or regs_umsk_isr_gpda1*/
+			writel(status << 1, p_rtk_gpio_ctl->irq_regs_base + gpada_offset);
+
+			i = gpioNr;
+			while (status && i < (p_rtk_gpio_ctl->chip.ngpio)) {	/*i<MISC gpio number(60) or ISO gpio number(20)*/
+				/*printk("status = %08x\n", status);*/
+				if ((status & 0x1) && gpio_chk_irq_enable(p_rtk_gpio_ctl, i)) {
+					hw_irq = i;
+					linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, hw_irq);
+					if (linux_irq) {
+						RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+						RTK_GPIO_DBG("hw_irq = %d,  deassertflg[0x%08llx] = %x", hw_irq, (u64)(&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)]), p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)]);
+						if ((1<<GPIO_REG_BIT(hw_irq)) & (p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)])) {
+							generic_handle_irq(linux_irq);
+							irq_had_fired++;
+						}
+					} else {
+						pr_err("%s can not specified linux irq number for hwirq=%d .", __func__, hw_irq);
+					}
+				}
+				i++;
+				status >>= 1;
+				RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+			}
+
+			gpioNr += 31;
+			RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+		}
+
+	}
+
+	RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+
+	/* Handle gpio assert */
+	if (event & (p_rtk_gpio_ctl->gpio_isr_assert_int)) {
+		gpioNr = 0;
+		RTK_GPIO_DBG("[%s] assert interrupt", __func__);
+		while (gpioNr < (p_rtk_gpio_ctl->chip.ngpio)) {
+			gpa_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_UMSK_ISR_GPA, gpioNr);
+
+			status = readl(p_rtk_gpio_ctl->irq_regs_base + gpa_offset) >> 1;
+			writel(status << 1, p_rtk_gpio_ctl->irq_regs_base + gpa_offset);
+
+			i = gpioNr;
+			while (status && i < (p_rtk_gpio_ctl->chip.ngpio)) {
+				if ((status & 0x1) && gpio_chk_irq_enable(p_rtk_gpio_ctl, i)) {
+					hw_irq = i;
+					linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, hw_irq);
+					if (linux_irq) {
+						RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+						RTK_GPIO_DBG("hw_irq = %d,  assertflg[0x%08llx] = %x", hw_irq, (u64)(&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)]), p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)]);
+						if ((1<<GPIO_REG_BIT(hw_irq)) & (p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)])) {
+							RTK_GPIO_DBG("[%s]%s  line: %d", __FILE__, __func__, __LINE__);
+							generic_handle_irq(linux_irq);
+							irq_had_fired++;
+						}
+					} else {
+						pr_err("%s can not specified linux irq number for hwirq=%d .", __func__, hw_irq);
+					}
+				}
+				i++;
+				status >>= 1;
+				RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+			}
+			gpioNr += 31;
+			RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+		}
+	}
+
+
+	RTK_GPIO_DBG("[%s] irq_had_fired = %d", __func__, irq_had_fired);
+	writel(event, p_rtk_gpio_ctl->reg_isr);
+	if (!irq_had_fired)
+		RTK_GPIO_DBG("%s gpio irq(hwirq=%d) has triggered but no dispatch",
+				__func__, hw_irq);
+		RTK_GPIO_DBG("to user handler (12345678 mean something Wrong)");
+	return;
+
+}
+
+static __maybe_unused int
+	mux_irq_domain_xlate(struct irq_domain *d,
+		struct device_node *controller, const u32 *intspec, u32 intsize,
+		unsigned long *out_hwirq, u32 *out_type)
+{
+	RTK_GPIO_DBG("[%s] device_node.name = %s", __func__, controller->name);
+
+	if (/*d->of_node*/to_of_node(d->fwnode) != controller)
+		return -EINVAL;
+
+	if (intsize < 1)
+		return -EINVAL;
+
+	*out_hwirq = intspec[0];
+	*out_type = 0;
+	RTK_GPIO_DBG("[%s] out_hwirq = %ld", __func__, *out_hwirq);
+	return 0;
+}
+
+static int mux_irq_domain_map(struct irq_domain *d, u32 irq, irq_hw_number_t hw)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = d->host_data;
+
+	RTK_GPIO_DBG("[%s] irq=%d , irq_hw_number=%d", __func__, irq, (u32)hw);
+
+	if (!p_rtk_gpio_ctl) {
+		RTK_GPIO_DBG("[%s] p_rtk_gpio_ctl is NULL", __func__);
+		return -EINVAL;
+	}
+
+	irq_set_chip(irq, &p_rtk_gpio_ctl->gp_irq_chip);
+	irq_set_chip_data(irq, (__force void *)p_rtk_gpio_ctl);
+	irq_set_handler_data(irq, p_rtk_gpio_ctl);
+	irq_set_handler(irq, handle_simple_irq);
+	/*set_irq_flags(irq, IRQF_VALID);*/
+
+	return 0;
+}
+
+static const struct irq_domain_ops mux_irq_domain_ops = {
+	.xlate = mux_irq_domain_xlate,
+	.map = mux_irq_domain_map,
+};
+
+int rtk_gpio_irq_setup(struct device_node *node,
+	struct rtk_gpio_controller *p_rtk_gpio_ctl,
+	const struct rtk_gpio_groups *p_rtk_gpio_grp)
+{
+	unsigned int bank_deassert_irq, bank_assert_irq;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+
+	p_rtk_gpio_ctl->gp_irq_chip.name = node->name;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_enable = gpio_irq_enable;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_disable = gpio_irq_disable;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_set_type = gpio_irq_type;
+	p_rtk_gpio_ctl->gp_irq_chip.flags = IRQCHIP_SET_TYPE_MASKED;
+
+	bank_assert_irq = irq_of_parse_and_map(node, 0);
+	if (!bank_assert_irq) {
+		pr_alert("[GPIO] Fail to parse of irq.\n");
+		return -ENXIO;
+	}
+
+	bank_deassert_irq = irq_of_parse_and_map(node, 1);
+	if (!bank_deassert_irq) {
+		pr_alert("[GPIO] Fail to parse of irq.\n");
+		return -ENXIO;
+	}
+
+	p_rtk_gpio_ctl->bank_assert_irq = bank_assert_irq;
+	p_rtk_gpio_ctl->bank_deassert_irq = bank_deassert_irq;
+	RTK_GPIO_DBG("[%s] bank_assert_irq=%d", __func__,
+			p_rtk_gpio_ctl->bank_assert_irq);
+	RTK_GPIO_DBG("[%s] bank_deassert_irq=%d", __func__,
+			p_rtk_gpio_ctl->bank_deassert_irq);
+
+	p_rtk_gpio_ctl->irq_mux_domain = irq_domain_add_simple(node,
+			p_rtk_gpio_ctl->chip.ngpio,
+			p_rtk_gpio_ctl->linux_irq_base,
+			&mux_irq_domain_ops, p_rtk_gpio_ctl);
+
+	WARN(!p_rtk_gpio_ctl->irq_mux_domain, "IRQ domain init failed\n");
+
+	irq_set_chained_handler(p_rtk_gpio_ctl->bank_deassert_irq,
+				(irq_flow_handler_t)gpio_irq_handler);
+	irq_set_handler_data(p_rtk_gpio_ctl->bank_deassert_irq, p_rtk_gpio_ctl);
+
+	irq_set_chained_handler(p_rtk_gpio_ctl->bank_assert_irq,
+				(irq_flow_handler_t)gpio_irq_handler);
+	irq_set_handler_data(p_rtk_gpio_ctl->bank_assert_irq, p_rtk_gpio_ctl);
+	return 0;
+}
+
+static inline int __rtk_gpio_direction(struct gpio_chip *chip,
+	unsigned int offset, bool out)
+{
+	u32 dir_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+	u32 temp;
+	u32 mask = 1 << (offset % 32);
+
+	RTK_GPIO_DBG("[%s] offset(%u) out(%u)", __func__, offset, out);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DIR, offset);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	if (out)
+		temp |= mask;
+	else
+		temp &= ~mask;
+
+	__raw_writel(temp, (p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	RTK_GPIO_DBG("[%s] offset(%u)  addr(0x%08llx)  temp(0x%08x)",
+			__func__, offset,
+			(u64)((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset),
+			temp);
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+
+	return 0;
+}
+
+static int rtk_gpio_get(struct gpio_chip *chip, unsigned int offset)
+{
+	u32 dati_offset, dato_offset, dir_offset;
+	u32 temp, value;
+	u32 mask = 1 << (offset % 32);
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DIR, offset);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	if (temp & mask) {  /*direction out*/
+		dato_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DATO, offset);
+		value = ioread_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dato_offset), GPIO_REG_BIT(offset));
+	} else {  /*direction in*/
+		dati_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DATI, offset);
+		value = ioread_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dati_offset), GPIO_REG_BIT(offset));
+	}
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+	return value;
+}
+
+static void rtk_gpio_set(struct gpio_chip *chip, unsigned int offset, int value)
+{
+	u32 dato_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+
+	RTK_GPIO_DBG("[%s] offset(%u) value(%d)", __func__, offset, value);
+
+	dato_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DATO, offset);
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	if (value)
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ dato_offset), GPIO_REG_BIT(offset), 1);
+	else
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ dato_offset), GPIO_REG_BIT(offset), 0);
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+}
+
+static int rtk_gpio_direction_in(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	return __rtk_gpio_direction(chip, offset, GP_DIRIN);
+}
+
+static int rtk_gpio_direction_out(struct gpio_chip *chip,
+	unsigned int offset, int value)
+{
+	RTK_GPIO_DBG("[%s] offset(%u) value(%d)", __func__, offset, value);
+
+	rtk_gpio_set(chip, offset, value);
+	return __rtk_gpio_direction(chip, offset, GP_DIROUT);
+}
+
+static int rtk_gpio_get_direction(struct gpio_chip *chip, unsigned int offset)
+{
+	u32 dir_offset;
+	u32 temp, dir;
+	u32 mask = 1 << (offset % 32);
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+
+	RTK_GPIO_DBG("[%s] offset(%u)\n", __func__, offset);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DIR, offset);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	dir = (temp & mask) ? 0 : 1;
+
+	return dir;
+}
+
+
+static int rtk_gpio_setdeb(struct gpio_chip *chip,
+	unsigned int offset, unsigned int debounce/*microsecond(us)*/)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	void __iomem *gpio_deb_addr;
+
+	RTK_GPIO_DBG("[%s] offset(%u) debounce(%d)",
+			__func__, offset, debounce);
+
+	if (debounce >= 50*1000) {/*50ms*/
+		debounce = RTK_GPIO_DEBOUNCE_50ms;
+	} else if (debounce >= 30*1000) {/*30ms*/
+		debounce = RTK_GPIO_DEBOUNCE_30ms;
+	} else if (debounce >= 20*1000) {/*20ms*/
+		debounce = RTK_GPIO_DEBOUNCE_20ms;
+	} else if (debounce >= 10*1000) {/* 10ms*/
+		debounce = RTK_GPIO_DEBOUNCE_10ms;
+	} else if (debounce >= 1000) {/* 1ms*/
+		debounce = RTK_GPIO_DEBOUNCE_1ms;
+	} else if (debounce >= 100) {/* 100us*/
+		debounce = RTK_GPIO_DEBOUNCE_100us;
+	} else if (debounce >= 10) {/* 10us*/
+		debounce = RTK_GPIO_DEBOUNCE_10us;
+	} else {   /*1us*/
+		debounce = RTK_GPIO_DEBOUNCE_1us;
+	}
+
+	if (strcmp("rtk_iso_gpio", chip->label) == 0) {
+		gpio_deb_addr = p_rtk_gpio_ctl->reg_deb[GPIO_DEB_OFST(offset)];
+		writel((0x8 | debounce) << (GPIO_DEB_BIT(offset)*4),
+				(void *)gpio_deb_addr);
+		return 0;
+	}
+
+	RTK_GPIO_DBG("[%s] Fail", __func__);
+	return -EINVAL;
+}
+
+static int rtk_gpio_request(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	return pinctrl_request_gpio(chip->base + offset);
+}
+
+static void rtk_gpio_free(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	pinctrl_free_gpio(chip->base + offset);
+}
+
+static int rtk_gpio_to_irq(struct gpio_chip *chip, unsigned int offset)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	u32 linux_irq = 0;
+
+	linux_irq = irq_create_mapping(p_rtk_gpio_ctl->irq_mux_domain, offset);
+	RTK_GPIO_DBG("[%s] offset(%u) linux_irq(%u)", __func__,
+			offset, linux_irq);
+
+	if (!linux_irq) {
+		pr_err("%s can not specified linux irq number for hwirq=%d .\n",
+			__func__, offset);
+		return -EINVAL;
+	}
+	return linux_irq;
+}
+
+static int rtk_gpio_xlate(struct gpio_chip *gc,
+	const struct of_phandle_args *gpiospec, u32 *flags)
+{
+	u32 pin;
+
+	RTK_GPIO_DBG("[%s] base(%d), args[0]=%d", __func__,
+		gc->base, gpiospec->args[0]);
+
+	if (WARN_ON(gc->of_gpio_n_cells < 1))
+		return -EINVAL;
+
+	if (WARN_ON(gpiospec->args_count < gc->of_gpio_n_cells))
+		return -EINVAL;
+
+	if (gpiospec->args[0] > gc->ngpio)
+		return -EINVAL;
+
+	pin = gpiospec->args[0];
+
+	gpio_pinctrl_control(gc, gpiospec->args[0],
+			gpiospec->args[1], gpiospec->args[2]);
+
+	if (gpiospec->args[1] == GP_DIRIN) {/*gpio direction input*/
+		if (rtk_gpio_direction_in(gc, pin))
+			pr_err("gpio_xlate: failed to set pin direction in\n");
+
+		if (flags) /*low active flag*/
+			*flags = gpiospec->args[2];
+	} else {
+		/*gpio direction output low*/
+		if (gpiospec->args[2] == 0 || gpiospec->args[2] == 2 || gpiospec->args[2] == 4) {
+			if (rtk_gpio_direction_out(gc, pin, GP_LOW))
+				pr_err("gpio_xlate: failed to set pin direction out\n");
+		} else if (gpiospec->args[2] == 1 || gpiospec->args[2] == 3 || gpiospec->args[2] == 5) {
+			/*gpio direction output high*/
+			if (rtk_gpio_direction_out(gc, pin, GP_HIGH))
+				pr_err("gpio_xlate: failed to set pin direction out\n");
+		} else {
+			pr_err("gpio_xlate: failed to set pin direction out\n");
+		}
+	}
+
+	return gpiospec->args[0];
+}
+
+void set_default_gpio(struct device_node *node)
+{
+	int num_gpios, n;
+
+	num_gpios = of_gpio_count(node);
+	if (num_gpios > 0) {
+		for (n = 0; n < num_gpios; n++) {
+			int gpio = of_get_gpio_flags(node, n, NULL);
+
+			RTK_GPIO_DBG("[%s]  %s  line: %d",
+					__FILE__, __func__, __LINE__);
+			if (gpio >= 0) {
+				if (!gpio_is_valid(gpio))
+					pr_err("[GPIO] %s: gpio %d is not valid\n",
+						__func__, gpio);
+
+				if (gpio_request(gpio, node->name))
+					pr_err("[GPIO] %s: gpio %d is in use\n",
+						__func__, gpio);
+
+				gpio_free(gpio);
+			} else {
+				pr_err("[GPIO] %s: Could not get gpio from of\n",
+					__func__);
+			}
+		}
+	} else {
+		RTK_GPIO_INF("No default gpio need to set");
+	}
+}
+
+static const struct of_device_id rtk_gpio_of_match[] = {
+	{.compatible = "realtek,rtk139x-iso-gpio-irq-mux",},
+	{ /* Sentinel */ },
+};
+
+static int rtk_gpio_probe(struct platform_device *pdev)
+{
+	int i;
+	void __iomem *irq_regs_base;
+	void __iomem *gpio_regs_base;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	const struct rtk_gpio_groups *p_rtk_gpio_grp = NULL;
+	u32 gpio_numbers;
+	u32 gpio_base;
+	struct device_node *node = NULL;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+	node = pdev->dev.of_node;
+	if (!node) {
+		pr_err("rtk gpio: failed to allocate device structure.\n");
+		return -ENODEV;
+	}
+
+	RTK_GPIO_DBG("[%s] node name = [%s]", __func__, node->name);
+
+	p_rtk_gpio_ctl =
+		kzalloc(sizeof(struct rtk_gpio_controller), GFP_KERNEL);
+	if (!p_rtk_gpio_ctl) {
+		pr_err("rtk gpio: failed to allocate device structure.\n");
+		return -ENOMEM;
+	}
+	memset(p_rtk_gpio_ctl, 0, sizeof(struct rtk_gpio_groups));
+
+	if (of_property_read_u32_array(node, "Realtek,gpio_numbers",
+		&gpio_numbers, 1)) {
+		pr_err("Don't know gpio group number.\n");
+		return -EINVAL;
+	}
+
+	if (of_property_read_u32_index(node, "Realtek,gpio_base",
+		0, &gpio_base)) {
+		pr_err("Don't know gpio group number.\n");
+		return -EINVAL;
+	}
+
+	for (i = 0; i < rtk_gpio_ngroups; i++) {
+		if (strcmp(rtk_gpio_grps_array[i].group_name, node->name) == 0)
+			p_rtk_gpio_grp = &rtk_gpio_grps_array[i];
+	}
+
+	if (!p_rtk_gpio_grp) {
+		pr_err("Don't know gpio group name.\n");
+		return -EINVAL;
+	}
+
+	p_rtk_gpio_ctl->chip.label = node->name;
+	p_rtk_gpio_ctl->chip.request = rtk_gpio_request;
+	p_rtk_gpio_ctl->chip.free = rtk_gpio_free;
+	p_rtk_gpio_ctl->chip.direction_input = rtk_gpio_direction_in;
+	p_rtk_gpio_ctl->chip.get = rtk_gpio_get;
+	p_rtk_gpio_ctl->chip.get_direction= rtk_gpio_get_direction;
+	p_rtk_gpio_ctl->chip.direction_output = rtk_gpio_direction_out;
+	p_rtk_gpio_ctl->chip.set = rtk_gpio_set;
+	p_rtk_gpio_ctl->chip.set_debounce = rtk_gpio_setdeb;
+	p_rtk_gpio_ctl->chip.to_irq = rtk_gpio_to_irq;
+	p_rtk_gpio_ctl->chip.base = gpio_base;
+	p_rtk_gpio_ctl->chip.ngpio = gpio_numbers;
+	/*must be the same with     #gpio-cells = <> in dtb*/
+	p_rtk_gpio_ctl->chip.of_gpio_n_cells = 3;
+	p_rtk_gpio_ctl->chip.of_xlate = rtk_gpio_xlate;
+	p_rtk_gpio_ctl->chip.of_node = node;
+
+	spin_lock_init(&p_rtk_gpio_ctl->lock);
+
+	irq_regs_base = of_iomap(node, 0);
+	if (!irq_regs_base) {
+		pr_err("unable to map irq_regs_base registers\n");
+		return -EINVAL;
+	}
+
+	gpio_regs_base = of_iomap(node, 1);
+	if (!gpio_regs_base) {
+		pr_err("unable to map gpio_regs_base registers\n");
+		return -EINVAL;
+	}
+
+	p_rtk_gpio_ctl->gpio_isr_deassert_int =
+			p_rtk_gpio_grp->gpio_isr_deassert_int;
+	p_rtk_gpio_ctl->gpio_isr_assert_int =
+			p_rtk_gpio_grp->gpio_isr_assert_int;
+	p_rtk_gpio_ctl->linux_irq_base = p_rtk_gpio_grp->linux_irq_base;
+
+	p_rtk_gpio_ctl->group_index = p_rtk_gpio_grp->group_index;
+	p_rtk_gpio_ctl->irq_regs_base = (void __iomem *)irq_regs_base;
+	p_rtk_gpio_ctl->gpio_regs_base = (void __iomem *)gpio_regs_base;
+	p_rtk_gpio_ctl->reg_isr = (void __iomem *)irq_regs_base
+				+ p_rtk_gpio_grp->reg_isr_off;
+	for (i = 0; i < ARRAY_SIZE(p_rtk_gpio_grp->reg_deb_off); i++) {
+		p_rtk_gpio_ctl->reg_deb[i] = (void __iomem *)gpio_regs_base
+					+ p_rtk_gpio_grp->reg_deb_off[i];
+	}
+
+	if (gpiochip_add(&p_rtk_gpio_ctl->chip))
+		pr_info("[%s]  %s  line: %d\n", __FILE__, __func__, __LINE__);
+
+	rtk_gpio_irq_setup(node, p_rtk_gpio_ctl, p_rtk_gpio_grp);
+
+	platform_set_drvdata(pdev, p_rtk_gpio_ctl);
+
+	/* Initial default gpios */
+	set_default_gpio(node);
+
+	return 0;
+}
+
+static int rtk_gpio_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return 0;
+	}
+#endif
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+
+	disable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	disable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static int rtk_gpio_resume(struct platform_device *pdev)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	struct device_node *node;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+	node = p_rtk_gpio_ctl->chip.of_node;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return 0;
+	}
+#endif
+
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+
+	/* Initial default gpios */
+	set_default_gpio(node);
+
+	enable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	enable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static void rtk_gpio_shutdown(struct platform_device *pdev)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return;
+	}
+#endif
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+
+	disable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	disable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n", __func__);
+}
+
+
+static struct platform_driver rtk_gpio_driver = {
+	.driver = {
+			   .name = "rtk_gpio",
+			   .owner = THIS_MODULE,
+			   .of_match_table = rtk_gpio_of_match,
+			   },
+	.probe = rtk_gpio_probe,
+	.suspend = rtk_gpio_suspend,
+	.resume = rtk_gpio_resume,
+	.shutdown = rtk_gpio_shutdown,
+};
+
+static int rtk_gpio_drv_reg(void)
+{
+	return platform_driver_register(&rtk_gpio_driver);
+}
+
+postcore_initcall(rtk_gpio_drv_reg);
diff --git a/drivers/gpio/gpio-rtd139x.h b/drivers/gpio/gpio-rtd139x.h
new file mode 100644
index 00000000..0fc9974
--- /dev/null
+++ b/drivers/gpio/gpio-rtd139x.h
@@ -0,0 +1,104 @@
+/*
+ * Realtek GPIO driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+
+#ifndef _RTK_GPIO_H_
+#define _RTK_GPIO_H_
+
+#include <linux/io.h>
+#include <linux/spinlock.h>
+#include <asm-generic/gpio.h>
+
+
+/*#define RTK_GPIO_DEBUG*/
+#ifdef RTK_GPIO_DEBUG
+#define RTK_GPIO_DBG(fmt, ...) pr_info("[GPIO DBG] " fmt "\n", ## __VA_ARGS__)
+#else
+#define RTK_GPIO_DBG(fmt, ...)
+#endif
+
+#define RTK_GPIO_INF(fmt, ...) pr_info("[GPIO] " fmt "\n", ## __VA_ARGS__)
+#define RTK_GPIO_ERR(fmt, ...) pr_err("[GPIO Error] " fmt "\n", ## __VA_ARGS__)
+
+#define GP_HIGH		1
+#define GP_LOW		0
+#define GP_DIROUT	1
+#define GP_DIRIN	0
+
+/*RTK_GPIO_DEBOUNCE*/
+enum {
+	RTK_GPIO_DEBOUNCE_1us = 0,
+	RTK_GPIO_DEBOUNCE_10us,
+	RTK_GPIO_DEBOUNCE_100us,
+	RTK_GPIO_DEBOUNCE_1ms,
+	RTK_GPIO_DEBOUNCE_10ms,
+	RTK_GPIO_DEBOUNCE_20ms,
+	RTK_GPIO_DEBOUNCE_30ms,
+	RTK_GPIO_DEBOUNCE_50ms,
+};
+
+#define GPIO_REG_ARRAY_SIZE	 4
+#define GPIO_DEB_ARRAY_SIZE	 8
+
+#define UNKNOW_OFFSET	0xFFFF
+/*GP_REG_TYPE*/
+enum {
+	GP_REG_UMSK_ISR_GPA = 0,
+	GP_REG_UMSK_ISR_GPDA,
+	GP_REG_DIR,
+	GP_REG_DATO,
+	GP_REG_DATI,
+	GP_REG_IE,
+	GP_REG_DP
+};
+
+
+struct rtk_gpio_groups {
+	const char	*group_name;
+	u32		group_index;
+	u32		linux_irq_base;
+	void __iomem		*irq_membase;
+	u32	gpio_isr_deassert_int;
+	u32	gpio_isr_assert_int;
+	u32	reg_isr_off;
+	u32	reg_umsk_isr_gpa_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_umsk_isr_gpda_off[GPIO_REG_ARRAY_SIZE];
+	void __iomem		*gpio_membase;
+	u32		mem_size;
+	u32	reg_dir_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dato_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dati_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_ie_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dp_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_deb_off[GPIO_DEB_ARRAY_SIZE];
+};
+
+
+struct rtk_gpio_controller {
+	struct gpio_chip	chip;
+	struct irq_chip	gp_irq_chip;
+	unsigned int	bank_deassert_irq;
+	unsigned int	bank_assert_irq;
+	struct irq_domain *irq_mux_domain;
+	spinlock_t		lock;
+	u32		gpio_isr_deassert_int;
+	u32		gpio_isr_assert_int;
+	u64		gpio_isr_deassert_enable_flag[GPIO_REG_ARRAY_SIZE];
+	u64		gpio_isr_assert_enable_flag[GPIO_REG_ARRAY_SIZE];
+	u32		linux_irq_base;
+	u32 group_index;
+	void __iomem	*reg_isr;
+	void __iomem	*irq_regs_base;
+	void __iomem	*gpio_regs_base;
+	void __iomem	*reg_deb[GPIO_DEB_ARRAY_SIZE];
+};
+
+#endif /*_RTK_GPIO_H_*/
diff --git a/drivers/gpio/gpio-rtd13xx-suspend.c b/drivers/gpio/gpio-rtd13xx-suspend.c
new file mode 100644
index 00000000..d1ac547
--- /dev/null
+++ b/drivers/gpio/gpio-rtd13xx-suspend.c
@@ -0,0 +1,465 @@
+/*
+ * rtd16xx_suspend.c - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/pm.h>
+#include <linux/suspend.h>
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/cpu.h>
+#include <linux/delay.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/reboot.h>
+#include <linux/clocksource.h>
+#include <linux/clockchips.h>
+#include <linux/cpu_pm.h>
+#include <linux/vmalloc.h>
+#include <linux/tick.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/irqchip/arm-gic.h>
+#include <asm/system_misc.h>
+#include <asm/cacheflush.h>
+#include <asm/suspend.h>
+#include <soc/realtek/memory.h>
+
+#include "gpio-rtd13xx-suspend.h"
+
+#define DEV_NAME "RTD13xx_gpio-suspend"
+
+
+char wu_en[SUSPEND_ISO_GPIO_SIZE];
+char wu_act[SUSPEND_ISO_GPIO_SIZE];
+
+char out_en[SUSPEND_ISO_GPIO_SIZE];
+char out_act[SUSPEND_ISO_GPIO_SIZE];
+
+EXPORT_SYMBOL(wu_en);
+EXPORT_SYMBOL(wu_act);
+
+void rtk_suspend_gpio_output_change_suspend(void)
+{
+	int i = 0;
+	int tmp;
+
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (!out_en[i])
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			out_act[i] ? "HIGH" : "LOW");
+		tmp = out_act[i] ? 1 : 0;
+		gpio_direction_output(i + SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+}
+
+void rtk_suspend_gpio_output_change_resume(void)
+{
+	int i = 0;
+	int tmp;
+
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (!out_en[i])
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			out_act[i] ? "LOW" : "HIGH");
+		tmp = out_act[i] ? 0 : 1;
+		gpio_direction_output(i + SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+}
+
+
+
+static void rtk_gpio_init_wu(struct device_node *nd)
+{
+	const u32 *prop_en;
+	const u32 *prop_act;
+	int wu_gpio_en = 0;
+	int wu_gpio_act = 0;
+	int wu_gpio_list = 0;
+	int en;
+	int act;
+	int wu_gpio;
+	int gpio_iso_num;
+	int tmp;
+	int i = 0;
+
+	wu_gpio_list = of_gpio_named_count(nd, "wakeup-gpio-list");
+	prop_en = of_get_property(nd, "wakeup-gpio-enable", &wu_gpio_en);
+	prop_act = of_get_property(nd, "wakeup-gpio-activity", &wu_gpio_act);
+	wu_gpio_en  /= sizeof(u32);
+	wu_gpio_act /= sizeof(u32);
+
+	pr_info("[%s] wakeup-gpio Cnt: en(%d) act(%d) list(%d)\n",
+		DEV_NAME, wu_gpio_en, wu_gpio_act, wu_gpio_list);
+
+	if (wu_gpio_en != 0 && (wu_gpio_en == wu_gpio_act)
+		&& (wu_gpio_act == wu_gpio_list)) {
+
+		for (i = 0 ; i < wu_gpio_list ; i++) {
+			en  = of_read_number(prop_en, 1 + i);
+			act = of_read_number(prop_act, 1 + i);
+			wu_gpio = of_get_named_gpio(nd, "wakeup-gpio-list", i);
+			gpio_iso_num = wu_gpio - SUSPEND_ISO_GPIO_BASE;
+
+			if (!en) {
+				pr_err("[%s] wakeup-gpio[%d] States is disable! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, wu_gpio);
+				continue;
+			}
+
+			tmp = gpio_iso_num < 0 || gpio_iso_num;
+			if (tmp >= SUSPEND_ISO_GPIO_SIZE) {
+				pr_err("[%s] wakeup-gpio[%d] Out of iso range! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, wu_gpio);
+				continue;
+			}
+
+			if (gpio_request(wu_gpio, nd->name)) {
+				pr_err("[%s] wakeup-gpio[%d] Request failed! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, wu_gpio);
+			} else {
+				//gpio_free(wu_gpio);
+			}
+
+			gpio_direction_input(wu_gpio);
+
+			pr_info("[%s] wakeup-gpio[%d] Successful registration! (en:%d act:%d gpio:%d)\n",
+				DEV_NAME, i, en, act, wu_gpio);
+
+			wu_en[gpio_iso_num] = en ? 1 : 0;
+			wu_act[gpio_iso_num] = act ? 1 : 0;
+		}
+	}
+}
+
+static void rtk_gpio_init_out(struct device_node *nd)
+{
+	const u32 *prop_en;
+	const u32 *prop_act;
+	int out_gpio_en = 0;
+	int out_gpio_act = 0;
+	int out_gpio_list = 0;
+	int en;
+	int act;
+	int gpio_iso_num;
+	int output_change_gpio;
+	int i = 0;
+
+	out_gpio_list = of_gpio_named_count(nd, "gpio-output-change-list");
+	prop_en = of_get_property(nd, "gpio-output-change-enable",
+		&out_gpio_en);
+	prop_act = of_get_property(nd, "gpio-output-change-activity",
+		&out_gpio_act);
+	out_gpio_en /= sizeof(u32);
+	out_gpio_act /= sizeof(u32);
+
+	pr_info("[%s] gpio-output-change Cnt: en(%d) act(%d) list(%d)\n",
+			DEV_NAME, out_gpio_en, out_gpio_act, out_gpio_list);
+
+	if (out_gpio_en != 0 && (out_gpio_en == out_gpio_act)
+		&& (out_gpio_act == out_gpio_list)) {
+
+		for (i = 0 ; i < out_gpio_list ; i++) {
+			en  = of_read_number(prop_en, 1 + i);
+			act = of_read_number(prop_act, 1 + i);
+			output_change_gpio = of_get_named_gpio(nd,
+				"gpio-output-change-list", i);
+			gpio_iso_num = output_change_gpio -
+				SUSPEND_ISO_GPIO_BASE;
+
+			if (!en) {
+				pr_err("[%s] gpio-output-change[%d] States is disable! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, output_change_gpio);
+				continue;
+			}
+
+			if (gpio_iso_num < 0 ||
+				gpio_iso_num >= SUSPEND_ISO_GPIO_SIZE) {
+				pr_err("[%s] gpio-output-change[%d] Out of iso range! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, output_change_gpio);
+				continue;
+			}
+
+			if (gpio_request(output_change_gpio, nd->name)) {
+				pr_err("[%s] gpio-output-change[%d] Request failed! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, output_change_gpio);
+			} else {
+				gpio_free(output_change_gpio);
+			}
+
+			pr_info("[%s] gpio-output-change[%d] Successful registration! (en:%d act:%d gpio:%d)\n",
+				DEV_NAME, i, en, act, output_change_gpio);
+
+			out_en[gpio_iso_num] = en ? 1:0;
+			out_act[gpio_iso_num] = act ? 1:0;
+		}
+	}
+}
+
+static void rtk_gpio_init(struct device_node *nd)
+{
+	rtk_gpio_init_wu(nd);
+	rtk_gpio_init_out(nd);
+}
+
+void rtk_gpio_suspend_init(struct device_node *node)
+{
+
+	memset(wu_en, 0, sizeof(wu_en));
+	memset(wu_act, 0, sizeof(wu_act));
+	memset(out_en, 0, sizeof(out_en));
+	memset(out_act, 0, sizeof(out_act));
+	rtk_gpio_init(node);
+}
+
+//subsys_initcall(rtk_suspend_init);
+
+#ifdef CONFIG_SYSFS
+#define RTK_SUSPEND_ATTR(_name) \
+{ \
+	.attr = {.name = #_name, .mode = 0644}, \
+	.show =  rtk_suspend_##_name##_show, \
+	.store = rtk_suspend_##_name##_store, \
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_en_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+
+
+	n += sprintf(buf + n, " En | GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (wu_en[i])
+			n += sprintf(buf + n, "  * | %d\n", i);
+		else
+			n += sprintf(buf + n, "	| %d\n", i);
+	}
+	n += sprintf(buf + n, "\n");
+	return n;
+
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_en_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#else
+
+	if (val < GPIO_WAKEUP_EN_BITS)
+		rtk_suspend_gpio_wakeup_en_set(
+			rtk_suspend_gpio_wakeup_en_get() ^ (0x1U << val));
+	else if ((val >= GPIO_WAKEUP_EN_BITS) && (val < GPIO_WAKEUP_EN_BITS + GPIO_WAKEUP_EN2_BITS))
+		rtk_suspend_gpio_wakeup_en2_set(
+			rtk_suspend_gpio_wakeup_en2_get() ^ (0x1U <<
+			(val-GPIO_WAKEUP_EN_BITS)));
+	return count;
+#endif
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_act_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+
+	n += sprintf(buf + n, " Act| GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (!wu_en[i])
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (wu_act[i])
+			n += sprintf(buf + n, "  H | %d\n", i);
+		else
+			n += sprintf(buf + n, "  L | %d\n", i);
+	}
+	n += sprintf(buf + n, "\n");
+
+	return n;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_act_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#else
+
+	if (val < GPIO_WAKEUP_ACT_BITS) {
+		tmp = (0x1U << val);
+		if (rtk_suspend_gpio_wakeup_en_get() & tmp)
+			rtk_suspend_gpio_wakeup_act_set(
+				rtk_suspend_gpio_wakeup_act_get() ^ tmp);
+	} else {
+		tmp = (0x1U << (val - GPIO_WAKEUP_ACT_BITS));
+		if (rtk_suspend_gpio_wakeup_en2_get() & tmp) {
+			rtk_suspend_gpio_wakeup_act2_set(
+				rtk_suspend_gpio_wakeup_act2_get() ^
+				(0x1U << (val-GPIO_WAKEUP_ACT_BITS)));
+		}
+	}
+
+	return count;
+#endif
+
+}
+
+static ssize_t rtk_suspend_gpio_out_en_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+
+	n += sprintf(buf + n, " En | GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (out_en[i])
+			n += sprintf(buf + n, "  * | %d\n", i);
+		else
+			n += sprintf(buf + n, "	| %d\n", i);
+	}
+
+	n += sprintf(buf + n, "\n");
+	return n;
+
+}
+
+static ssize_t rtk_suspend_gpio_out_en_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#else
+
+	if (val < GPIO_OUTPUT_CHANGE_EN_BITS)
+		rtk_suspend_gpio_out_en_set(
+			rtk_suspend_gpio_out_en_get() ^ (0x1U << val));
+	else
+		rtk_suspend_gpio_out_en2_set(rtk_suspend_gpio_out_en2_get() ^
+			(0x1U << (val-GPIO_OUTPUT_CHANGE_EN_BITS)));
+
+	return count;
+#endif
+}
+
+static ssize_t rtk_suspend_gpio_out_act_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+
+	n += sprintf(buf + n, " Act| GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (!out_en[i])
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (out_act[i])
+			n += sprintf(buf + n, "  H | %d\n", i);
+		else
+			n += sprintf(buf + n, "  L | %d\n", i);
+	}
+
+	n += sprintf(buf + n, "\n");
+
+	return n;
+}
+
+static ssize_t rtk_suspend_gpio_out_act_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#else
+
+	if (val < GPIO_OUTPUT_CHANGE_ACT_BITS) {
+		if (rtk_suspend_gpio_out_en_get() &  (0x1U << val)) {
+			tmp = (0x1U << val);
+			rtk_suspend_gpio_out_act_set(
+				rtk_suspend_gpio_out_act_get() ^ tmp);
+		}
+	} else {
+		if (rtk_suspend_gpio_out_en2_get() &
+			(0x1U << (val-GPIO_OUTPUT_CHANGE_ACT_BITS))) {
+			tmp = (0x1U << (val-GPIO_OUTPUT_CHANGE_ACT_BITS));
+			rtk_suspend_gpio_out_act2_set(
+				rtk_suspend_gpio_out_act2_get() ^ tmp);
+		}
+	}
+
+	return count;
+#endif
+
+}
+
+struct kobj_attribute rtk_suspend_gpio_wakeup_en_attr =
+	RTK_SUSPEND_ATTR(gpio_wakeup_en);
+struct kobj_attribute rtk_suspend_gpio_wakeup_act_attr =
+	RTK_SUSPEND_ATTR(gpio_wakeup_act);
+struct kobj_attribute rtk_suspend_gpio_out_en_attr =
+	RTK_SUSPEND_ATTR(gpio_out_en);
+struct kobj_attribute rtk_suspend_gpio_out_act_attr =
+	RTK_SUSPEND_ATTR(gpio_out_act);
+
+EXPORT_SYMBOL(rtk_suspend_gpio_wakeup_en_attr);
+EXPORT_SYMBOL(rtk_suspend_gpio_wakeup_act_attr);
+EXPORT_SYMBOL(rtk_suspend_gpio_out_en_attr);
+EXPORT_SYMBOL(rtk_suspend_gpio_out_act_attr);
+
+#endif
+
+
diff --git a/drivers/gpio/gpio-rtd13xx-suspend.h b/drivers/gpio/gpio-rtd13xx-suspend.h
new file mode 100644
index 00000000..e97940c
--- /dev/null
+++ b/drivers/gpio/gpio-rtd13xx-suspend.h
@@ -0,0 +1,88 @@
+/*
+ * rtd16xx_gpio_suspend.h - gpio suspend driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef RTD16XX_GPIO_SUSPEND_H_
+#define RTD16XX_GPIO_SUSPEND_H_
+
+#include <soc/realtek/rtk_pm.h>
+
+#define SETMASK(bits, pos) (((-1U) >> (32-bits)) << (pos))
+#define CLRMASK(bits, pos) (~(SETMASK(bits, pos)))
+#define SET_VAL(val,bits,pos) ((val << pos) & SETMASK(bits, pos))
+#define GET_VAL(reg,bits,pos) ((reg & SETMASK(bits, pos)) >> pos)
+
+#define GPIO_WAKEUP_EN_SHIFFT 0
+#define GPIO_WAKEUP_EN_BITS	 32
+#define GPIO_WAKEUP_EN_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+#define GPIO_WAKEUP_EN_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+
+#define GPIO_WAKEUP_ACT_SHIFFT 0
+#define GPIO_WAKEUP_ACT_BITS 32
+#define GPIO_WAKEUP_ACT_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+#define GPIO_WAKEUP_ACT_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_EN_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_EN_BITS 32
+#define GPIO_OUTPUT_CHANGE_EN_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_ACT_BITS 32
+#define GPIO_OUTPUT_CHANGE_ACT_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+
+#define GPIO_WAKEUP_EN2_SHIFFT 0
+#define GPIO_WAKEUP_EN2_BITS 32
+#define GPIO_WAKEUP_EN2_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN2_BITS, GPIO_WAKEUP_EN2_SHIFFT)
+#define GPIO_WAKEUP_EN2_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN2_BITS, GPIO_WAKEUP_EN2_SHIFFT)
+
+#define GPIO_WAKEUP_ACT2_SHIFFT 0
+#define GPIO_WAKEUP_ACT2_BITS 32
+#define GPIO_WAKEUP_ACT2_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT2_BITS, GPIO_WAKEUP_ACT2_SHIFFT)
+#define GPIO_WAKEUP_ACT2_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT2_BITS, GPIO_WAKEUP_ACT2_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_EN2_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_EN2_BITS 32
+#define GPIO_OUTPUT_CHANGE_EN2_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_EN2_BITS, GPIO_OUTPUT_CHANGE_EN2_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN2_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN2_BITS, GPIO_OUTPUT_CHANGE_EN2_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT2_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_ACT2_BITS 32
+#define GPIO_OUTPUT_CHANGE_ACT2_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT2_BITS, GPIO_OUTPUT_CHANGE_ACT2_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT2_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT2_BITS, GPIO_OUTPUT_CHANGE_ACT2_SHIFFT)
+
+#define GPIO_WAKEUP_EN3_SHIFFT 0
+#define GPIO_WAKEUP_EN3_BITS 22
+#define GPIO_WAKEUP_EN3_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN3_BITS, GPIO_WAKEUP_EN3_SHIFFT)
+#define GPIO_WAKEUP_EN3_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN3_BITS, GPIO_WAKEUP_EN3_SHIFFT)
+
+#define GPIO_WAKEUP_ACT3_SHIFFT 0
+#define GPIO_WAKEUP_ACT3_BITS 22
+#define GPIO_WAKEUP_ACT3_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT3_BITS, GPIO_WAKEUP_ACT3_SHIFFT)
+#define GPIO_WAKEUP_ACT3_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT3_BITS, GPIO_WAKEUP_ACT3_SHIFFT)
+
+
+#define GPIO_OUTPUT_CHANGE_EN3_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_EN3_BITS 22
+#define GPIO_OUTPUT_CHANGE_EN3_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN3_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT3_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_ACT3_BITS 22
+#define GPIO_OUTPUT_CHANGE_ACT3_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT3_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+
+void rtk_suspend_gpio_output_change_suspend(void);
+void rtk_suspend_gpio_output_change_resume(void);
+void rtk_gpio_suspend_init(struct device_node *node);
+
+
+#endif /* RTD16XX_GPIO_SUSPEND_H_ */
+
diff --git a/drivers/gpio/gpio-rtd13xx.c b/drivers/gpio/gpio-rtd13xx.c
new file mode 100644
index 00000000..8448a83
--- /dev/null
+++ b/drivers/gpio/gpio-rtd13xx.c
@@ -0,0 +1,971 @@
+/*
+ * Realtek GPIO driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/gpio.h>
+#include <linux/errno.h>
+#include <linux/kernel.h>
+#include <linux/clk.h>
+#include <linux/err.h>
+#include <linux/io.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/platform_device.h>
+#include <linux/irqdomain.h>
+#include <linux/irqchip/chained_irq.h>
+#include <linux/slab.h>
+#include <linux/interrupt.h>
+#include <linux/pinctrl/consumer.h>
+#include <linux/irqchip.h>
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+#include "../pinctrl/realtek/pinctrl-rtd13xx.h"
+#include "gpio-rtd13xx.h"
+#include "gpio-rtd13xx-suspend.h"
+
+
+#define GPIO_REG_OFST(id)       (id >> 5) /* (id/32)*/
+#define GPIO_REG_BIT(id)        (id & 0x1F)	/* id % 32*/
+#define GPIO_DEB_OFST(id)       (id >> 3) /* (id/8)*/
+#define GPIO_DEB_BIT(id)        (id & 0x7)	/* id % 8*/
+#define GPIO_INT_REG_OFST(id)   (id/31)
+#define GPIO_INT_REG_BIT(id)    ((id%31)+1)
+
+static int gpios_unused[3];
+/* intc mux tempary define the first irq number in this mux is 160 */
+static const struct rtk_gpio_groups rtk_gpio_grps_array[] = {
+	{
+		.group_name = "rtk_iso_gpio",
+		.group_index = 0,
+		/*160(predefine base)+64(intc_mux)*/
+		.linux_irq_base = 224,
+		/*Bit20, de-assert interrupt flag*/
+		.gpio_isr_deassert_int = 0x00100000,
+		/*Bit19, assert interrupt flag*/
+		.gpio_isr_assert_int = 0x00080000,
+		/*ISO_ISR*/
+		.reg_isr_off = 0x0,
+		 /* ISO_UMSK_ISR_GPA0, UMSK_ISR_GPA1 */
+		.reg_umsk_isr_gpa_off = {0x08, 0xe0, 0x90},
+		/* ISO_UMSK_ISR_GPDA0, UMSK_ISR_GPDA1 */
+		.reg_umsk_isr_gpda_off = {0x0c, 0xe4, 0x94},
+		/* ISO_GPDIR, GPDIR_1 */
+		.reg_dir_off = {0x00, 0x18, 0x2C},
+		/* ISO_GPDATO, GPDATO_1 */
+		.reg_dato_off = {0x04, 0x1c, 0x30},
+		/* ISO_GPDATI, GPDATI_1 */
+		.reg_dati_off = {0x08, 0x20, 0x34},
+		/* ISO_GPIE, GPIE_1 */
+		.reg_ie_off = {0x0c, 0x24, 0x38},
+		/* ISO_GPDP, GPDP_1 */
+		.reg_dp_off = {0x10, 0x28, 0x3C},
+		/*ISO_GPDEB*/
+		.reg_deb_off = {0x44, 0x48, 0x4C, 0x50, 0x54, 0x58, 0x5C, 0x60, 0x64, 0x68, 0x6C},
+	}
+};
+
+static const u32 rtk_gpio_ngroups = ARRAY_SIZE(rtk_gpio_grps_array);
+
+static u32 gpio_get_reg_offset(u32 group_index, u32 reg_type, u32 pin)
+{
+	u32 reg_index, reg_offset = UNKNOW_OFFSET;
+	const struct rtk_gpio_groups *p_rtk_gpio_grp = NULL;
+
+	if ((reg_type == GP_REG_UMSK_ISR_GPA) ||
+			(reg_type == GP_REG_UMSK_ISR_GPDA))
+		reg_index = GPIO_INT_REG_OFST(pin);
+	else
+		reg_index = GPIO_REG_OFST(pin);
+
+	if (reg_index >= GPIO_REG_ARRAY_SIZE)
+		return reg_offset;
+
+	if (group_index < rtk_gpio_ngroups)
+		p_rtk_gpio_grp = &rtk_gpio_grps_array[group_index];
+
+	if (!p_rtk_gpio_grp)
+		return reg_offset;
+
+	switch (reg_type) {
+	case GP_REG_UMSK_ISR_GPA:
+		reg_offset = p_rtk_gpio_grp->reg_umsk_isr_gpa_off[reg_index];
+		break;
+	case GP_REG_UMSK_ISR_GPDA:
+		reg_offset = p_rtk_gpio_grp->reg_umsk_isr_gpda_off[reg_index];
+		break;
+	case GP_REG_DIR:
+		reg_offset = p_rtk_gpio_grp->reg_dir_off[reg_index];
+		break;
+	case GP_REG_DATO:
+		reg_offset = p_rtk_gpio_grp->reg_dato_off[reg_index];
+		break;
+	case GP_REG_DATI:
+		reg_offset = p_rtk_gpio_grp->reg_dati_off[reg_index];
+		break;
+	case GP_REG_IE:
+		reg_offset = p_rtk_gpio_grp->reg_ie_off[reg_index];
+		break;
+	case GP_REG_DP:
+		reg_offset = p_rtk_gpio_grp->reg_dp_off[reg_index];
+		break;
+	default:
+		RTK_GPIO_DBG("[%s] Unknow type", __func__);
+	}
+
+	return reg_offset;
+}
+
+static inline void iowrite_reg_bit(void *reg,
+				unsigned char bit, unsigned char val)
+{
+	if (val)
+		writel(readl(reg) | (0x1 << bit), reg);
+	else
+		writel(readl(reg) & ~(0x1 << bit), reg);
+}
+
+#define ioread_reg_bit(reg, bits)    ((readl(reg) >> (bits)) & 0x1)
+#define chip2controller(chip)	\
+	container_of(chip, struct rtk_gpio_controller, chip)
+
+int gpio_chk_irq_enable(struct rtk_gpio_controller *p_rtk_gpio_ctl, u32 irq)
+{
+	u32 ie_offset;
+
+	RTK_GPIO_DBG("[%s] irq(%u)", __func__, irq);
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, irq);
+
+	return ioread_reg_bit(((void *)(p_rtk_gpio_ctl->gpio_regs_base)
+					+ ie_offset), GPIO_REG_BIT(irq));
+}
+
+static void gpio_irq_disable(struct irq_data *d)
+{
+	u32 ie_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+			(struct rtk_gpio_controller *)(d->chip_data);
+
+	RTK_GPIO_DBG("[%s] d->hwirq(%lu)", __func__, d->hwirq);
+
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, d->hwirq);
+
+	iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base +
+					ie_offset), GPIO_REG_BIT(d->hwirq), 0);
+}
+
+static void gpio_irq_enable(struct irq_data *d)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+				(struct rtk_gpio_controller *)(d->chip_data);
+	unsigned long irq_flag;
+	u32 gpa_offset, gpada_offset, ie_offset, gpio_int_flag;
+
+	RTK_GPIO_DBG("[%s] irq number(%u), hwirq(%lu), group(%s)",
+			__func__, d->irq, d->hwirq, d->domain->name);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, irq_flag);
+	gpio_int_flag = 0x1 << GPIO_INT_REG_BIT(d->hwirq);
+
+	gpa_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_UMSK_ISR_GPA, d->hwirq);
+	gpada_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_UMSK_ISR_GPDA, d->hwirq);
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, d->hwirq);
+
+	if ((gpa_offset != UNKNOW_OFFSET) && (gpada_offset != UNKNOW_OFFSET)
+		&& (ie_offset != UNKNOW_OFFSET)) {
+		/*Clear assert interrupt flag*/
+		if (readl(p_rtk_gpio_ctl->irq_regs_base+gpa_offset)
+			& gpio_int_flag) {
+			RTK_GPIO_DBG("[%s] Wrte Reg(0x%08llx) Val(0x%08x)",
+				__func__,
+				(u64)(p_rtk_gpio_ctl->irq_regs_base+gpa_offset),
+				gpio_int_flag);
+			writel(gpio_int_flag,
+				p_rtk_gpio_ctl->irq_regs_base + gpa_offset);
+		}
+
+		/*Clear de-assert interrupt flag*/
+		if (readl(p_rtk_gpio_ctl->irq_regs_base+gpada_offset)
+			& gpio_int_flag) {
+			RTK_GPIO_DBG("[%s] Wrte Reg(0x%08llx) Val(0x%08x)",
+				__func__,
+				(u64)(p_rtk_gpio_ctl->irq_regs_base+gpada_offset),
+				gpio_int_flag);
+			writel(gpio_int_flag,
+				p_rtk_gpio_ctl->irq_regs_base + gpada_offset);
+		}
+
+		/*Enable interrupt*/
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ie_offset), GPIO_REG_BIT(d->hwirq), 1);
+		RTK_GPIO_DBG("[%s] Reg_ie[0x%08llx]= 0x%08x", __func__,
+			  (u64)(p_rtk_gpio_ctl->gpio_regs_base+ie_offset),
+			  readl(p_rtk_gpio_ctl->gpio_regs_base+ie_offset));
+	}
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, irq_flag);
+
+}
+
+static int gpio_irq_type(struct irq_data *d, unsigned int trigger)
+{
+	u32 dp_offset;
+
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+		(struct rtk_gpio_controller *)(d->chip_data);
+
+	dp_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DP, d->hwirq);
+
+	switch (trigger) {
+	case IRQ_TYPE_EDGE_RISING:
+	case IRQ_TYPE_LEVEL_HIGH:
+		RTK_GPIO_DBG("[%s] Pin(%lu) IRQ_TYPE_EDGE_RISING",
+				__func__, d->hwirq);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ dp_offset), GPIO_REG_BIT(d->hwirq), 1);
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	case IRQ_TYPE_EDGE_FALLING:
+	case IRQ_TYPE_LEVEL_LOW:
+		RTK_GPIO_DBG("[%s] Pin(%lu) IRQ_TYPE_EDGE_FALLING", __func__, d->hwirq);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dp_offset), GPIO_REG_BIT(d->hwirq), 0);
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	case IRQ_TYPE_EDGE_BOTH:
+	case IRQ_TYPE_NONE:
+	default:
+		RTK_GPIO_DBG("[%s] Pin(%lu) trigger(%u)", __func__, d->hwirq, trigger);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dp_offset), GPIO_REG_BIT(d->hwirq), 1);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq),
+			(unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	}
+
+	return 0;
+
+}
+
+static void gpio_irq_handler(struct irq_desc *desc)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	u32 gpada_offset, gpa_offset;
+	u32 gpioNr, i;
+	u32 event, status;
+	u32 hw_irq = 12345678, linux_irq;
+	u32 irq_had_fired = 0;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+
+	p_rtk_gpio_ctl = (struct rtk_gpio_controller *)irq_desc_get_handler_data(desc);	/*rtk_gpio_controller for MISC or ISO*/
+
+	/* Get interrupt status */
+	event = readl(p_rtk_gpio_ctl->reg_isr) & (p_rtk_gpio_ctl->gpio_isr_deassert_int | p_rtk_gpio_ctl->gpio_isr_assert_int);
+	RTK_GPIO_DBG("[%s] event(0x%08x)", __func__, event);
+	if (event == 0)
+		return;
+
+	/* Handle gpio deassert */
+	if (event & (p_rtk_gpio_ctl->gpio_isr_deassert_int)) {
+		gpioNr = 0;
+		RTK_GPIO_DBG("[%s] de-assert interrupt", __func__);
+		while (gpioNr < (p_rtk_gpio_ctl->chip.ngpio)) {
+			gpada_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_UMSK_ISR_GPDA, gpioNr);
+
+			status = readl(p_rtk_gpio_ctl->irq_regs_base + gpada_offset) >> 1;	/*get regs_umsk_isr_gpda0 or regs_umsk_isr_gpda1*/
+			writel(status << 1, p_rtk_gpio_ctl->irq_regs_base + gpada_offset);
+
+			i = gpioNr;
+			while (status && i < (p_rtk_gpio_ctl->chip.ngpio)) {	/*i<MISC gpio number(60) or ISO gpio number(20)*/
+				/*printk("status = %08x\n", status);*/
+				if ((status & 0x1) && gpio_chk_irq_enable(p_rtk_gpio_ctl, i)) {
+					hw_irq = i;
+					linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, hw_irq);
+					if (linux_irq) {
+						RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+						RTK_GPIO_DBG("hw_irq = %d,  deassertflg[0x%08llx] = %x", hw_irq, (u64)(&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)]), p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)]);
+						if ((1<<GPIO_REG_BIT(hw_irq)) & (p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)])) {
+							generic_handle_irq(linux_irq);
+							irq_had_fired++;
+						}
+					} else {
+						pr_err("%s can not specified linux irq number for hwirq=%d .", __func__, hw_irq);
+					}
+				}
+				i++;
+				status >>= 1;
+				RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+			}
+
+			gpioNr += 31;
+			RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+		}
+
+	}
+
+	RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+
+	/* Handle gpio assert */
+	if (event & (p_rtk_gpio_ctl->gpio_isr_assert_int)) {
+		gpioNr = 0;
+		RTK_GPIO_DBG("[%s] assert interrupt", __func__);
+		while (gpioNr < (p_rtk_gpio_ctl->chip.ngpio)) {
+			gpa_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_UMSK_ISR_GPA, gpioNr);
+
+			status = readl(p_rtk_gpio_ctl->irq_regs_base + gpa_offset) >> 1;
+			writel(status << 1, p_rtk_gpio_ctl->irq_regs_base + gpa_offset);
+
+			i = gpioNr;
+			while (status && i < (p_rtk_gpio_ctl->chip.ngpio)) {
+				if ((status & 0x1) && gpio_chk_irq_enable(p_rtk_gpio_ctl, i)) {
+					hw_irq = i;
+					linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, hw_irq);
+					if (linux_irq) {
+						RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+						RTK_GPIO_DBG("hw_irq = %d,  assertflg[0x%08llx] = %x", hw_irq, (u64)(&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)]), p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)]);
+						if ((1<<GPIO_REG_BIT(hw_irq)) & (p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)])) {
+							RTK_GPIO_DBG("[%s]%s  line: %d", __FILE__, __func__, __LINE__);
+							generic_handle_irq(linux_irq);
+							irq_had_fired++;
+						}
+					} else {
+						pr_err("%s can not specified linux irq number for hwirq=%d .", __func__, hw_irq);
+					}
+				}
+				i++;
+				status >>= 1;
+				RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+			}
+			gpioNr += 31;
+			RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+		}
+	}
+
+
+	RTK_GPIO_DBG("[%s] irq_had_fired = %d", __func__, irq_had_fired);
+	writel(event, p_rtk_gpio_ctl->reg_isr);
+	if (!irq_had_fired)
+		RTK_GPIO_DBG("%s gpio irq(hwirq=%d) has triggered but no dispatch",
+				__func__, hw_irq);
+		RTK_GPIO_DBG("to user handler (12345678 mean something Wrong)");
+	return;
+
+}
+
+static __maybe_unused int
+	mux_irq_domain_xlate(struct irq_domain *d,
+		struct device_node *controller, const u32 *intspec, u32 intsize,
+		unsigned long *out_hwirq, u32 *out_type)
+{
+	RTK_GPIO_DBG("[%s] device_node.name = %s", __func__, controller->name);
+
+	if (/*d->of_node*/to_of_node(d->fwnode) != controller)
+		return -EINVAL;
+
+	if (intsize < 1)
+		return -EINVAL;
+
+	*out_hwirq = intspec[0];
+	*out_type = 0;
+	RTK_GPIO_DBG("[%s] out_hwirq = %ld", __func__, *out_hwirq);
+	return 0;
+}
+
+static int mux_irq_domain_map(struct irq_domain *d, u32 irq, irq_hw_number_t hw)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = d->host_data;
+
+	RTK_GPIO_DBG("[%s] irq=%d , irq_hw_number=%d", __func__, irq, (u32)hw);
+
+	if (!p_rtk_gpio_ctl) {
+		RTK_GPIO_DBG("[%s] p_rtk_gpio_ctl is NULL", __func__);
+		return -EINVAL;
+	}
+
+	irq_set_chip(irq, &p_rtk_gpio_ctl->gp_irq_chip);
+	irq_set_chip_data(irq, (__force void *)p_rtk_gpio_ctl);
+	irq_set_handler_data(irq, p_rtk_gpio_ctl);
+	irq_set_handler(irq, handle_simple_irq);
+	/*set_irq_flags(irq, IRQF_VALID);*/
+
+	return 0;
+}
+
+static const struct irq_domain_ops mux_irq_domain_ops = {
+	.xlate = mux_irq_domain_xlate,
+	.map = mux_irq_domain_map,
+};
+
+int rtk_gpio_irq_setup(struct device_node *node,
+	struct rtk_gpio_controller *p_rtk_gpio_ctl,
+	const struct rtk_gpio_groups *p_rtk_gpio_grp)
+{
+	unsigned int bank_deassert_irq, bank_assert_irq;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+
+	p_rtk_gpio_ctl->gp_irq_chip.name = node->name;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_enable = gpio_irq_enable;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_disable = gpio_irq_disable;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_set_type = gpio_irq_type;
+	p_rtk_gpio_ctl->gp_irq_chip.flags = IRQCHIP_SET_TYPE_MASKED;
+
+	bank_assert_irq = irq_of_parse_and_map(node, 0);
+	if (!bank_assert_irq) {
+		pr_alert("[GPIO] Fail to parse of irq.\n");
+		return -ENXIO;
+	}
+
+	bank_deassert_irq = irq_of_parse_and_map(node, 1);
+	if (!bank_deassert_irq) {
+		pr_alert("[GPIO] Fail to parse of irq.\n");
+		return -ENXIO;
+	}
+
+	p_rtk_gpio_ctl->bank_assert_irq = bank_assert_irq;
+	p_rtk_gpio_ctl->bank_deassert_irq = bank_deassert_irq;
+	RTK_GPIO_DBG("[%s] bank_assert_irq=%d", __func__,
+			p_rtk_gpio_ctl->bank_assert_irq);
+	RTK_GPIO_DBG("[%s] bank_deassert_irq=%d", __func__,
+			p_rtk_gpio_ctl->bank_deassert_irq);
+
+	p_rtk_gpio_ctl->irq_mux_domain = irq_domain_add_simple(node,
+			p_rtk_gpio_ctl->chip.ngpio,
+			p_rtk_gpio_ctl->linux_irq_base,
+			&mux_irq_domain_ops, p_rtk_gpio_ctl);
+
+	WARN(!p_rtk_gpio_ctl->irq_mux_domain, "IRQ domain init failed\n");
+
+	irq_set_chained_handler(p_rtk_gpio_ctl->bank_deassert_irq,
+				(irq_flow_handler_t)gpio_irq_handler);
+	irq_set_handler_data(p_rtk_gpio_ctl->bank_deassert_irq, p_rtk_gpio_ctl);
+
+	irq_set_chained_handler(p_rtk_gpio_ctl->bank_assert_irq,
+				(irq_flow_handler_t)gpio_irq_handler);
+	irq_set_handler_data(p_rtk_gpio_ctl->bank_assert_irq, p_rtk_gpio_ctl);
+	return 0;
+}
+
+static inline int __rtk_gpio_direction(struct gpio_chip *chip,
+	unsigned int offset, bool out)
+{
+	u32 dir_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+	u32 temp;
+	u32 mask = 1 << (offset % 32);
+
+	RTK_GPIO_DBG("[%s] offset(%u) out(%u)", __func__, offset, out);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DIR, offset);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	if (out)
+		temp |= mask;
+	else
+		temp &= ~mask;
+
+	__raw_writel(temp, (p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	RTK_GPIO_DBG("[%s] offset(%u)  addr(0x%08llx)  temp(0x%08x)",
+			__func__, offset,
+			(u64)((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset),
+			temp);
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+
+	return 0;
+}
+
+static int rtk_gpio_get(struct gpio_chip *chip, unsigned int offset)
+{
+	u32 dati_offset, dato_offset, dir_offset;
+	u32 temp, value;
+	u32 mask = 1 << (offset % 32);
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DIR, offset);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	if (temp & mask) {  /*direction out*/
+		dato_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DATO, offset);
+		value = ioread_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dato_offset), GPIO_REG_BIT(offset));
+	} else {  /*direction in*/
+		dati_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DATI, offset);
+		value = ioread_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dati_offset), GPIO_REG_BIT(offset));
+	}
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+
+	return value;
+}
+
+static void rtk_gpio_set(struct gpio_chip *chip, unsigned int offset, int value)
+{
+	u32 dato_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+
+	RTK_GPIO_DBG("[%s] offset(%u) value(%d)", __func__, offset, value);
+
+	dato_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DATO, offset);
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	if (value)
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ dato_offset), GPIO_REG_BIT(offset), 1);
+	else
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ dato_offset), GPIO_REG_BIT(offset), 0);
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+}
+
+static int rtk_gpio_direction_in(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	return __rtk_gpio_direction(chip, offset, GP_DIRIN);
+}
+
+static int rtk_gpio_direction_out(struct gpio_chip *chip,
+	unsigned int offset, int value)
+{
+	RTK_GPIO_DBG("[%s] offset(%u) value(%d)", __func__, offset, value);
+
+	rtk_gpio_set(chip, offset, value);
+	return __rtk_gpio_direction(chip, offset, GP_DIROUT);
+}
+
+
+static int rtk_gpio_get_direction(struct gpio_chip *chip, unsigned int offset)
+{
+	u32 dir_offset;
+	u32 temp, dir;
+	u32 mask = 1 << (offset % 32);
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+
+	RTK_GPIO_DBG("[%s] offset(%u)\n", __func__, offset);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DIR, offset);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	dir = (temp & mask) ? 0 : 1;
+
+	return dir;
+}
+
+static int rtk_gpio_setdeb(struct gpio_chip *chip,
+	unsigned int offset, unsigned int debounce/*microsecond(us)*/)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	void __iomem *gpio_deb_addr;
+
+	RTK_GPIO_DBG("[%s] offset(%u) debounce(%d)",
+			__func__, offset, debounce);
+
+	if (debounce >= 50*1000) {/*50ms*/
+		debounce = RTK_GPIO_DEBOUNCE_50ms;
+	} else if (debounce >= 30*1000) {/*30ms*/
+		debounce = RTK_GPIO_DEBOUNCE_30ms;
+	} else if (debounce >= 20*1000) {/*20ms*/
+		debounce = RTK_GPIO_DEBOUNCE_20ms;
+	} else if (debounce >= 10*1000) {/* 10ms*/
+		debounce = RTK_GPIO_DEBOUNCE_10ms;
+	} else if (debounce >= 1000) {/* 1ms*/
+		debounce = RTK_GPIO_DEBOUNCE_1ms;
+	} else if (debounce >= 100) {/* 100us*/
+		debounce = RTK_GPIO_DEBOUNCE_100us;
+	} else if (debounce >= 10) {/* 10us*/
+		debounce = RTK_GPIO_DEBOUNCE_10us;
+	} else {   /*1us*/
+		debounce = RTK_GPIO_DEBOUNCE_1us;
+	}
+
+	if (strcmp("rtk_iso_gpio", chip->label) == 0) {
+		gpio_deb_addr = p_rtk_gpio_ctl->reg_deb[GPIO_DEB_OFST(offset)];
+		writel((0x8 | debounce) << (GPIO_DEB_BIT(offset)*4),
+				(void *)gpio_deb_addr);
+		return 0;
+	}
+
+	RTK_GPIO_DBG("[%s] Fail", __func__);
+	return -EINVAL;
+}
+
+static void rtk_add_gpio_unused(unsigned int gpio)
+{
+	int div, offset;
+
+	div = gpio/31;
+	offset = gpio%31;
+	gpios_unused[div] |= (1 << offset);
+
+}
+
+
+static int is_rtk_gpio_unused(unsigned int gpio)
+{
+	int div, offset;
+
+	div = gpio/31;
+	offset = gpio%31;
+
+	return ((1 << offset) & gpios_unused[div]);
+}
+
+static int rtk_gpio_request(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+	if (is_rtk_gpio_unused(chip->base + offset)) {
+		pr_err("[%s] invalid gpio :%d\n", __func__, chip->base + offset);
+		return -EINVAL;
+	}
+
+	return pinctrl_request_gpio(chip->base + offset);
+}
+
+static void rtk_gpio_free(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	pinctrl_free_gpio(chip->base + offset);
+}
+
+static int rtk_gpio_to_irq(struct gpio_chip *chip, unsigned int offset)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	u32 linux_irq = 0;
+
+	linux_irq = irq_create_mapping(p_rtk_gpio_ctl->irq_mux_domain, offset);
+	RTK_GPIO_DBG("[%s] offset(%u) linux_irq(%u)", __func__,
+			offset, linux_irq);
+
+	if (!linux_irq) {
+		pr_err("%s can not specified linux irq number for hwirq=%d .\n",
+			__func__, offset);
+		return -EINVAL;
+	}
+	return linux_irq;
+}
+
+static int rtk_gpio_xlate(struct gpio_chip *gc,
+	const struct of_phandle_args *gpiospec, u32 *flags)
+{
+	u32 pin;
+
+	RTK_GPIO_DBG("[%s] base(%d), args[0]=%d", __func__,
+		gc->base, gpiospec->args[0]);
+
+	if (WARN_ON(gc->of_gpio_n_cells < 1))
+		return -EINVAL;
+
+	if (WARN_ON(gpiospec->args_count < gc->of_gpio_n_cells))
+		return -EINVAL;
+
+	if (gpiospec->args[0] > gc->ngpio)
+		return -EINVAL;
+
+	pin = gpiospec->args[0];
+
+	if (is_rtk_gpio_unused(gpiospec->args[0])) {
+		pr_err("[%s] invalid gpio :%d\n", __func__, gpiospec->args[0]);
+		return -EINVAL;
+	}
+
+	gpio_pinctrl_control(gc, gpiospec->args[0],
+			gpiospec->args[1], gpiospec->args[2]);
+
+	if (gpiospec->args[1] == GP_DIRIN) {/*gpio direction input*/
+		if (rtk_gpio_direction_in(gc, pin))
+			pr_err("gpio_xlate: failed to set pin direction in\n");
+
+		if (flags) /*low active flag*/
+			*flags = gpiospec->args[2];
+	} else {
+		/*gpio direction output low*/
+		if (gpiospec->args[2] == 0 || gpiospec->args[2] == 2 || gpiospec->args[2] == 4) {
+			if (rtk_gpio_direction_out(gc, pin, GP_LOW))
+				pr_err("gpio_xlate: failed to set pin direction out\n");
+		} else if (gpiospec->args[2] == 1 || gpiospec->args[2] == 3 || gpiospec->args[2] == 5) {
+			/*gpio direction output high*/
+			if (rtk_gpio_direction_out(gc, pin, GP_HIGH))
+				pr_err("gpio_xlate: failed to set pin direction out\n");
+		} else {
+			pr_err("gpio_xlate: failed to set pin direction out\n");
+		}
+	}
+
+	return gpiospec->args[0];
+}
+
+void set_default_gpio(struct device_node *node)
+{
+	int num_gpios, n;
+
+	num_gpios = of_gpio_count(node);
+	if (num_gpios > 0) {
+		for (n = 0; n < num_gpios; n++) {
+			int gpio = of_get_gpio_flags(node, n, NULL);
+
+			RTK_GPIO_DBG("[%s]  %s  line: %d",
+					__FILE__, __func__, __LINE__);
+			if (gpio >= 0) {
+				if (!gpio_is_valid(gpio))
+					pr_err("[GPIO] %s: gpio %d is not valid\n",
+						__func__, gpio);
+
+				if (gpio_request(gpio, node->name))
+					pr_err("[GPIO] %s: gpio %d is in use\n",
+						__func__, gpio);
+
+				gpio_free(gpio);
+			} else {
+				pr_err("[GPIO] %s: Could not get gpio from of\n",
+					__func__);
+			}
+		}
+	} else {
+		RTK_GPIO_INF("No default gpio need to set");
+	}
+}
+
+static const struct of_device_id rtk_gpio_of_match[] = {
+	{.compatible = "realtek,rtk13xx-iso-gpio-irq-mux",},
+	{ /* Sentinel */ },
+};
+
+static int rtk_gpio_probe(struct platform_device *pdev)
+{
+	int i;
+	void __iomem *irq_regs_base;
+	void __iomem *gpio_regs_base;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	const struct rtk_gpio_groups *p_rtk_gpio_grp = NULL;
+	u32 gpio_numbers;
+	u32 gpio_base;
+	struct device_node *node = NULL;
+	u32 size;
+	u32 *gpio_unused;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+	node = pdev->dev.of_node;
+	if (!node) {
+		pr_err("rtk gpio: failed to allocate device structure.\n");
+		return -ENODEV;
+	}
+
+	RTK_GPIO_DBG("[%s] node name = [%s]", __func__, node->name);
+
+	p_rtk_gpio_ctl =
+		kzalloc(sizeof(struct rtk_gpio_controller), GFP_KERNEL);
+	if (!p_rtk_gpio_ctl) {
+		pr_err("rtk gpio: failed to allocate device structure.\n");
+		return -ENOMEM;
+	}
+	memset(p_rtk_gpio_ctl, 0, sizeof(struct rtk_gpio_groups));
+
+	if (of_property_read_u32_array(node, "Realtek,gpio_numbers",
+		&gpio_numbers, 1)) {
+		pr_err("Don't know gpio group number.\n");
+		return -EINVAL;
+	}
+
+	if (of_property_read_u32_index(node, "Realtek,gpio_base",
+		0, &gpio_base)) {
+		pr_err("Don't know gpio group number.\n");
+		return -EINVAL;
+	}
+
+	memset(gpios_unused, 0, sizeof(gpios_unused));
+	size = of_property_count_u32_elems(node, "gpio-unused");
+	if (size < 0) {
+		gpio_unused = kmalloc(size * sizeof(u32), GFP_KERNEL);
+		of_property_read_u32_array(node, "gpio-unused", gpio_unused, size);
+		for (i = 0; i < size; i++) {
+			rtk_add_gpio_unused(gpio_unused[i]);
+		}
+	}
+	for (i = 0; i < rtk_gpio_ngroups; i++) {
+		if (strcmp(rtk_gpio_grps_array[i].group_name, node->name) == 0)
+			p_rtk_gpio_grp = &rtk_gpio_grps_array[i];
+	}
+
+	if (!p_rtk_gpio_grp) {
+		pr_err("Don't know gpio group name.\n");
+		return -EINVAL;
+	}
+	p_rtk_gpio_ctl->chip.label = node->name;
+	p_rtk_gpio_ctl->chip.request = rtk_gpio_request;
+	p_rtk_gpio_ctl->chip.free = rtk_gpio_free;
+	p_rtk_gpio_ctl->chip.direction_input = rtk_gpio_direction_in;
+	p_rtk_gpio_ctl->chip.get = rtk_gpio_get;
+	p_rtk_gpio_ctl->chip.get_direction= rtk_gpio_get_direction;
+	p_rtk_gpio_ctl->chip.direction_output = rtk_gpio_direction_out;
+	p_rtk_gpio_ctl->chip.set = rtk_gpio_set;
+	p_rtk_gpio_ctl->chip.set_debounce = rtk_gpio_setdeb;
+	p_rtk_gpio_ctl->chip.to_irq = rtk_gpio_to_irq;
+	p_rtk_gpio_ctl->chip.base = gpio_base;
+	p_rtk_gpio_ctl->chip.ngpio = gpio_numbers;
+	/*must be the same with     #gpio-cells = <> in dtb*/
+	p_rtk_gpio_ctl->chip.of_gpio_n_cells = 3;
+	p_rtk_gpio_ctl->chip.of_xlate = rtk_gpio_xlate;
+	p_rtk_gpio_ctl->chip.of_node = node;
+
+	spin_lock_init(&p_rtk_gpio_ctl->lock);
+
+	irq_regs_base = of_iomap(node, 0);
+	if (!irq_regs_base) {
+		pr_err("unable to map irq_regs_base registers\n");
+		return -EINVAL;
+	}
+
+	gpio_regs_base = of_iomap(node, 1);
+	if (!gpio_regs_base) {
+		pr_err("unable to map gpio_regs_base registers\n");
+		return -EINVAL;
+	}
+
+	p_rtk_gpio_ctl->gpio_isr_deassert_int =
+			p_rtk_gpio_grp->gpio_isr_deassert_int;
+	p_rtk_gpio_ctl->gpio_isr_assert_int =
+			p_rtk_gpio_grp->gpio_isr_assert_int;
+	p_rtk_gpio_ctl->linux_irq_base = p_rtk_gpio_grp->linux_irq_base;
+
+	p_rtk_gpio_ctl->group_index = p_rtk_gpio_grp->group_index;
+	p_rtk_gpio_ctl->irq_regs_base = (void __iomem *)irq_regs_base;
+	p_rtk_gpio_ctl->gpio_regs_base = (void __iomem *)gpio_regs_base;
+	p_rtk_gpio_ctl->reg_isr = (void __iomem *)irq_regs_base
+				+ p_rtk_gpio_grp->reg_isr_off;
+	for (i = 0; i < ARRAY_SIZE(p_rtk_gpio_grp->reg_deb_off); i++) {
+		p_rtk_gpio_ctl->reg_deb[i] = (void __iomem *)gpio_regs_base
+					+ p_rtk_gpio_grp->reg_deb_off[i];
+	}
+
+	if (gpiochip_add(&p_rtk_gpio_ctl->chip))
+		pr_info("[%s]  %s  line: %d\n", __FILE__, __func__, __LINE__);
+
+	rtk_gpio_irq_setup(node, p_rtk_gpio_ctl, p_rtk_gpio_grp);
+
+	platform_set_drvdata(pdev, p_rtk_gpio_ctl);
+
+	/* Initial default gpios */
+	set_default_gpio(node);
+
+	rtk_gpio_suspend_init(node);
+
+	return 0;
+}
+
+static int rtk_gpio_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return 0;
+	}
+#endif
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+	rtk_suspend_gpio_output_change_suspend();
+	disable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	disable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static int rtk_gpio_resume(struct platform_device *pdev)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	struct device_node *node;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+	node = p_rtk_gpio_ctl->chip.of_node;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return 0;
+	}
+#endif
+
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+
+	/* Initial default gpios */
+	set_default_gpio(node);
+
+	enable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	enable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+	rtk_suspend_gpio_output_change_resume();
+	pr_info("[GPIO] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static void rtk_gpio_shutdown(struct platform_device *pdev)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return;
+	}
+#endif
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+
+	disable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	disable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n", __func__);
+}
+
+
+static struct platform_driver rtk_gpio_driver = {
+	.driver = {
+		.name = "rtk_gpio",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_gpio_of_match,
+	},
+	.probe = rtk_gpio_probe,
+	.suspend = rtk_gpio_suspend,
+	.resume = rtk_gpio_resume,
+	.shutdown = rtk_gpio_shutdown,
+};
+
+static int rtk_gpio_drv_reg(void)
+{
+	return platform_driver_register(&rtk_gpio_driver);
+}
+
+postcore_initcall(rtk_gpio_drv_reg);
diff --git a/drivers/gpio/gpio-rtd13xx.h b/drivers/gpio/gpio-rtd13xx.h
new file mode 100644
index 00000000..2bcfb39
--- /dev/null
+++ b/drivers/gpio/gpio-rtd13xx.h
@@ -0,0 +1,104 @@
+/*
+ * Realtek GPIO driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+
+#ifndef _RTK_GPIO_H_
+#define _RTK_GPIO_H_
+
+#include <linux/io.h>
+#include <linux/spinlock.h>
+#include <asm-generic/gpio.h>
+
+
+/*#define RTK_GPIO_DEBUG*/
+#ifdef RTK_GPIO_DEBUG
+#define RTK_GPIO_DBG(fmt, ...) pr_info("[GPIO DBG] " fmt "\n", ## __VA_ARGS__)
+#else
+#define RTK_GPIO_DBG(fmt, ...)
+#endif
+
+#define RTK_GPIO_INF(fmt, ...) pr_info("[GPIO] " fmt "\n", ## __VA_ARGS__)
+#define RTK_GPIO_ERR(fmt, ...) pr_err("[GPIO Error] " fmt "\n", ## __VA_ARGS__)
+
+#define GP_HIGH		1
+#define GP_LOW		0
+#define GP_DIROUT	1
+#define GP_DIRIN	0
+
+/*RTK_GPIO_DEBOUNCE*/
+enum {
+	RTK_GPIO_DEBOUNCE_1us = 0,
+	RTK_GPIO_DEBOUNCE_10us,
+	RTK_GPIO_DEBOUNCE_100us,
+	RTK_GPIO_DEBOUNCE_1ms,
+	RTK_GPIO_DEBOUNCE_10ms,
+	RTK_GPIO_DEBOUNCE_20ms,
+	RTK_GPIO_DEBOUNCE_30ms,
+	RTK_GPIO_DEBOUNCE_50ms,
+};
+
+#define GPIO_REG_ARRAY_SIZE	 4
+#define GPIO_DEB_ARRAY_SIZE	 12
+
+#define UNKNOW_OFFSET	0xFFFF
+/*GP_REG_TYPE*/
+enum {
+	GP_REG_UMSK_ISR_GPA = 0,
+	GP_REG_UMSK_ISR_GPDA,
+	GP_REG_DIR,
+	GP_REG_DATO,
+	GP_REG_DATI,
+	GP_REG_IE,
+	GP_REG_DP
+};
+
+
+struct rtk_gpio_groups {
+	const char	*group_name;
+	u32		group_index;
+	u32		linux_irq_base;
+	void __iomem		*irq_membase;
+	u32	gpio_isr_deassert_int;
+	u32	gpio_isr_assert_int;
+	u32	reg_isr_off;
+	u32	reg_umsk_isr_gpa_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_umsk_isr_gpda_off[GPIO_REG_ARRAY_SIZE];
+	void __iomem		*gpio_membase;
+	u32		mem_size;
+	u32	reg_dir_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dato_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dati_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_ie_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dp_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_deb_off[GPIO_DEB_ARRAY_SIZE];
+};
+
+
+struct rtk_gpio_controller {
+	struct gpio_chip	chip;
+	struct irq_chip	gp_irq_chip;
+	unsigned int	bank_deassert_irq;
+	unsigned int	bank_assert_irq;
+	struct irq_domain *irq_mux_domain;
+	spinlock_t		lock;
+	u32		gpio_isr_deassert_int;
+	u32		gpio_isr_assert_int;
+	u64		gpio_isr_deassert_enable_flag[GPIO_REG_ARRAY_SIZE];
+	u64		gpio_isr_assert_enable_flag[GPIO_REG_ARRAY_SIZE];
+	u32		linux_irq_base;
+	u32 group_index;
+	void __iomem	*reg_isr;
+	void __iomem	*irq_regs_base;
+	void __iomem	*gpio_regs_base;
+	void __iomem	*reg_deb[GPIO_DEB_ARRAY_SIZE];
+};
+
+#endif /*_RTK_GPIO_H_*/
diff --git a/drivers/gpio/gpio-rtd16xx-suspend.c b/drivers/gpio/gpio-rtd16xx-suspend.c
new file mode 100644
index 00000000..549c143
--- /dev/null
+++ b/drivers/gpio/gpio-rtd16xx-suspend.c
@@ -0,0 +1,584 @@
+/*
+ * rtd16xx_suspend.c - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/pm.h>
+#include <linux/suspend.h>
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/cpu.h>
+#include <linux/delay.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/reboot.h>
+#include <linux/clocksource.h>
+#include <linux/clockchips.h>
+#include <linux/cpu_pm.h>
+#include <linux/vmalloc.h>
+#include <linux/tick.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/irqchip/arm-gic.h>
+#include <linux/gpio_keys.h>
+#include <linux/platform_device.h>
+#include <linux/input-event-codes.h>
+#include <asm/system_misc.h>
+#include <asm/cacheflush.h>
+#include <asm/suspend.h>
+#include <soc/realtek/memory.h>
+
+#include "gpio-rtd16xx-suspend.h"
+
+#define DEV_NAME "RTD16xx_gpio-suspend"
+
+
+char wu_en[SUSPEND_ISO_GPIO_SIZE];
+char wu_act[SUSPEND_ISO_GPIO_SIZE];
+
+char out_en[SUSPEND_ISO_GPIO_SIZE];
+char out_act[SUSPEND_ISO_GPIO_SIZE];
+
+EXPORT_SYMBOL(wu_en);
+EXPORT_SYMBOL(wu_act);
+
+void rtk_suspend_gpio_output_change_suspend(void)
+{
+	int i = 0;
+	int tmp;
+
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (!out_en[i])
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			out_act[i] ? "HIGH" : "LOW");
+		tmp = out_act[i] ? 1 : 0;
+		gpio_direction_output(i + SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+}
+
+void rtk_suspend_gpio_output_change_resume(void)
+{
+	int i = 0;
+	int tmp;
+
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (!out_en[i])
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			out_act[i] ? "LOW" : "HIGH");
+		tmp = out_act[i] ? 0 : 1;
+		gpio_direction_output(i + SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+}
+
+
+
+static void rtk_gpio_init_wu(struct device_node *nd)
+{
+	const u32 *prop_en;
+	const u32 *prop_act;
+	int wu_gpio_en = 0;
+	int wu_gpio_act = 0;
+	int wu_gpio_list = 0;
+	int en;
+	int act;
+	int wu_gpio;
+	int gpio_iso_num;
+	int tmp;
+	int i = 0;
+
+	wu_gpio_list = of_gpio_named_count(nd, "wakeup-gpio-list");
+	prop_en = of_get_property(nd, "wakeup-gpio-enable", &wu_gpio_en);
+	prop_act = of_get_property(nd, "wakeup-gpio-activity", &wu_gpio_act);
+	wu_gpio_en  /= sizeof(u32);
+	wu_gpio_act /= sizeof(u32);
+
+	pr_info("[%s] wakeup-gpio Cnt: en(%d) act(%d) list(%d)\n",
+		DEV_NAME, wu_gpio_en, wu_gpio_act, wu_gpio_list);
+
+	if (wu_gpio_en != 0 && (wu_gpio_en == wu_gpio_act)
+		&& (wu_gpio_act == wu_gpio_list)) {
+
+		for (i = 0 ; i < wu_gpio_list ; i++) {
+			en  = of_read_number(prop_en, 1 + i);
+			act = of_read_number(prop_act, 1 + i);
+			wu_gpio = of_get_named_gpio(nd, "wakeup-gpio-list", i);
+			gpio_iso_num = wu_gpio - SUSPEND_ISO_GPIO_BASE;
+
+			if (!en) {
+				pr_err("[%s] wakeup-gpio[%d] States is disable! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, wu_gpio);
+				continue;
+			}
+
+			tmp = gpio_iso_num < 0 || gpio_iso_num;
+			if (tmp >= SUSPEND_ISO_GPIO_SIZE) {
+				pr_err("[%s] wakeup-gpio[%d] Out of iso range! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, wu_gpio);
+				continue;
+			}
+
+			if (gpio_request(wu_gpio, nd->name)) {
+				pr_err("[%s] wakeup-gpio[%d] Request failed! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, wu_gpio);
+			} else {
+				//gpio_free(wu_gpio);
+			}
+
+			gpio_direction_input(wu_gpio);
+
+			pr_info("[%s] wakeup-gpio[%d] Successful registration! (en:%d act:%d gpio:%d)\n",
+				DEV_NAME, i, en, act, wu_gpio);
+
+			wu_en[gpio_iso_num] = en ? 1 : 0;
+			wu_act[gpio_iso_num] = act ? 1 : 0;
+		}
+	}
+}
+
+static void rtk_gpio_init_out(struct device_node *nd)
+{
+	const u32 *prop_en;
+	const u32 *prop_act;
+	int out_gpio_en = 0;
+	int out_gpio_act = 0;
+	int out_gpio_list = 0;
+	int en;
+	int act;
+	int gpio_iso_num;
+	int output_change_gpio;
+	int i = 0;
+
+	out_gpio_list = of_gpio_named_count(nd, "gpio-output-change-list");
+	prop_en = of_get_property(nd, "gpio-output-change-enable",
+		&out_gpio_en);
+	prop_act = of_get_property(nd, "gpio-output-change-activity",
+		&out_gpio_act);
+	out_gpio_en /= sizeof(u32);
+	out_gpio_act /= sizeof(u32);
+
+	pr_info("[%s] gpio-output-change Cnt: en(%d) act(%d) list(%d)\n",
+			DEV_NAME, out_gpio_en, out_gpio_act, out_gpio_list);
+
+	if (out_gpio_en != 0 && (out_gpio_en == out_gpio_act)
+		&& (out_gpio_act == out_gpio_list)) {
+
+		for (i = 0 ; i < out_gpio_list ; i++) {
+			en  = of_read_number(prop_en, 1 + i);
+			act = of_read_number(prop_act, 1 + i);
+			output_change_gpio = of_get_named_gpio(nd,
+				"gpio-output-change-list", i);
+			gpio_iso_num = output_change_gpio -
+				SUSPEND_ISO_GPIO_BASE;
+
+			if (!en) {
+				pr_err("[%s] gpio-output-change[%d] States is disable! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, output_change_gpio);
+				continue;
+			}
+
+			if (gpio_iso_num < 0 ||
+				gpio_iso_num >= SUSPEND_ISO_GPIO_SIZE) {
+				pr_err("[%s] gpio-output-change[%d] Out of iso range! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, output_change_gpio);
+				continue;
+			}
+
+			if (gpio_request(output_change_gpio, nd->name)) {
+				pr_err("[%s] gpio-output-change[%d] Request failed! (en:%d act:%d gpio:%d)\n",
+					DEV_NAME, i, en, act, output_change_gpio);
+			} else {
+				gpio_free(output_change_gpio);
+			}
+
+			pr_info("[%s] gpio-output-change[%d] Successful registration! (en:%d act:%d gpio:%d)\n",
+				DEV_NAME, i, en, act, output_change_gpio);
+
+			out_en[gpio_iso_num] = en ? 1:0;
+			out_act[gpio_iso_num] = act ? 1:0;
+		}
+	}
+}
+
+#ifdef CONFIG_KEYBOARD_GPIO
+
+static int rtk_gpio_keys_init_button(struct device_node *pp,
+				     struct gpio_keys_button *button)
+{
+	enum of_gpio_flags flags;
+	u32 idx;
+
+	button->gpio = of_get_gpio_flags(pp, 0, &flags);
+	if (button->gpio < 0) {
+		pr_err("failed to get gpio flags: %d\n", button->gpio);
+		return button->gpio;
+	} else {
+		button->active_low = (flags & OF_GPIO_ACTIVE_LOW) ? 1 : 0;
+	}
+
+	pr_info("%s: get gpio%d, flags=%x\n", __func__, button->gpio, flags);
+	idx = button->gpio - SUSPEND_ISO_GPIO_BASE;
+
+	if (of_property_read_u32(pp, "linux,code", &button->code))
+		return -EINVAL;
+
+	button->desc = of_get_property(pp, "label", NULL);
+
+	if (of_property_read_u32(pp, "linux,input-type", &button->type))
+		button->type = EV_KEY;
+
+	if (of_property_read_bool(pp, "wakeup-source")) {
+		pr_err("%s: gpio%d is wakeup-source\n", __func__, button->gpio);
+
+		wu_en[idx] = 1;
+		wu_act[idx] = (flags & OF_GPIO_ACTIVE_LOW) ? 0 : 1;
+	}
+
+	button->can_disable = !!of_get_property(pp, "linux,can-disable", NULL);
+
+	if (of_property_read_u32(pp, "debounce-interval",
+				 &button->debounce_interval))
+		button->debounce_interval = 5;
+
+	return 0;
+}
+
+static struct platform_device *gpio_keys_pdev;
+
+static void rtk_gpio_keys_init(struct device_node *np)
+{
+	struct platform_device *pdev;
+	struct gpio_keys_platform_data *pdata;
+	struct device_node *pp;
+	int nbuttons;
+	int i;
+	int ret = -ENOMEM;
+
+	pdev = kzalloc(sizeof(*pdev), GFP_KERNEL);
+	if (!pdev) {
+		pr_err("%s: failed to alloc platform_device\n",
+			__func__);
+		return;
+	}
+	pdev->name = "gpio-keys";
+	pdev->id   = -1;
+
+	pdata = kzalloc(sizeof(*pdata), GFP_KERNEL);
+	if (!pdata) {
+		pr_err("%s: failed to alloc gpio_keys_platform_data\n",
+			__func__);
+		goto free_pdev;
+	}
+
+	nbuttons = of_get_available_child_count(np);
+	pdata->buttons = kcalloc(nbuttons, sizeof(*pdata->buttons), GFP_KERNEL);
+	if (!pdata->buttons) {
+		pr_err("%s: failed to alloc gpio_keys_button\n", __func__);
+		goto free_pdata;
+	}
+	pdata->nbuttons = nbuttons;
+
+	pdata->rep = !!of_get_property(np, "autorepeat", NULL);
+	of_property_read_string(np, "label", &pdata->name);
+	i = 0;
+	for_each_available_child_of_node(np, pp) {
+		ret = rtk_gpio_keys_init_button(pp, pdata->buttons + i);
+		if (ret) {
+			pr_err("%s: failed to init button%d from dt: %d\n",
+				__func__, i, ret);
+			goto free_buttons;
+		}
+		i++;
+	}
+
+	pdev->dev.platform_data = pdata;
+	ret = platform_device_register(pdev);
+	if (ret) {
+		pr_err("%s: failed to register platform_device: %d\n",
+			__func__, ret);
+		goto free_buttons;
+	}
+	gpio_keys_pdev = pdev;
+	pr_info("%s: ready\n", __func__);
+	return;
+free_buttons:
+	kfree(pdata->buttons);
+free_pdata:
+	kfree(pdata);
+free_pdev:
+	kfree(pdev);
+}
+#else
+
+static inline void rtk_gpio_keys_init(struct device_node *np)
+{}
+
+#endif /* CONFIG_KEYBOARD_GPIO */
+
+static void rtk_gpio_init(struct device_node *nd)
+{
+	rtk_gpio_init_wu(nd);
+	rtk_gpio_init_out(nd);
+	rtk_gpio_keys_init(nd);
+}
+
+void rtk_gpio_suspend_init(struct device_node *node)
+{
+
+	memset(wu_en, 0, sizeof(wu_en));
+	memset(wu_act, 0, sizeof(wu_act));
+	memset(out_en, 0, sizeof(out_en));
+	memset(out_act, 0, sizeof(out_act));
+	rtk_gpio_init(node);
+}
+
+//subsys_initcall(rtk_suspend_init);
+
+#ifdef CONFIG_SYSFS
+#define RTK_SUSPEND_ATTR(_name) \
+{ \
+	.attr = {.name = #_name, .mode = 0644}, \
+	.show =  rtk_suspend_##_name##_show, \
+	.store = rtk_suspend_##_name##_store, \
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_en_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+
+
+	n += sprintf(buf + n, " En | GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (wu_en[i])
+			n += sprintf(buf + n, "  * | %d\n", i);
+		else
+			n += sprintf(buf + n, "	| %d\n", i);
+	}
+	n += sprintf(buf + n, "\n");
+	return n;
+
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_en_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#else
+
+	if (val < GPIO_WAKEUP_EN_BITS)
+		rtk_suspend_gpio_wakeup_en_set(
+			rtk_suspend_gpio_wakeup_en_get() ^ (0x1U << val));
+	else if ((val >= GPIO_WAKEUP_EN_BITS) && (val < GPIO_WAKEUP_EN_BITS + GPIO_WAKEUP_EN2_BITS))
+		rtk_suspend_gpio_wakeup_en2_set(
+			rtk_suspend_gpio_wakeup_en2_get() ^ (0x1U <<
+			(val-GPIO_WAKEUP_EN_BITS)));
+	return count;
+#endif
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_act_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+
+	n += sprintf(buf + n, " Act| GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (!wu_en[i])
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (wu_act[i])
+			n += sprintf(buf + n, "  H | %d\n", i);
+		else
+			n += sprintf(buf + n, "  L | %d\n", i);
+	}
+	n += sprintf(buf + n, "\n");
+
+	return n;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_act_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#else
+
+	if (val < GPIO_WAKEUP_ACT_BITS) {
+		tmp = (0x1U << val);
+		if (rtk_suspend_gpio_wakeup_en_get() & tmp)
+			rtk_suspend_gpio_wakeup_act_set(
+				rtk_suspend_gpio_wakeup_act_get() ^ tmp);
+	} else {
+		tmp = (0x1U << (val - GPIO_WAKEUP_ACT_BITS));
+		if (rtk_suspend_gpio_wakeup_en2_get() & tmp) {
+			rtk_suspend_gpio_wakeup_act2_set(
+				rtk_suspend_gpio_wakeup_act2_get() ^
+				(0x1U << (val-GPIO_WAKEUP_ACT_BITS)));
+		}
+	}
+
+	return count;
+#endif
+
+}
+
+static ssize_t rtk_suspend_gpio_out_en_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+
+	n += sprintf(buf + n, " En | GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (out_en[i])
+			n += sprintf(buf + n, "  * | %d\n", i);
+		else
+			n += sprintf(buf + n, "	| %d\n", i);
+	}
+
+	n += sprintf(buf + n, "\n");
+	return n;
+
+}
+
+static ssize_t rtk_suspend_gpio_out_en_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#else
+
+	if (val < GPIO_OUTPUT_CHANGE_EN_BITS)
+		rtk_suspend_gpio_out_en_set(
+			rtk_suspend_gpio_out_en_get() ^ (0x1U << val));
+	else
+		rtk_suspend_gpio_out_en2_set(rtk_suspend_gpio_out_en2_get() ^
+			(0x1U << (val-GPIO_OUTPUT_CHANGE_EN_BITS)));
+
+	return count;
+#endif
+}
+
+static ssize_t rtk_suspend_gpio_out_act_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+
+	n += sprintf(buf + n, " Act| GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		if (!out_en[i])
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (out_act[i])
+			n += sprintf(buf + n, "  H | %d\n", i);
+		else
+			n += sprintf(buf + n, "  L | %d\n", i);
+	}
+
+	n += sprintf(buf + n, "\n");
+
+	return n;
+}
+
+static ssize_t rtk_suspend_gpio_out_act_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#else
+
+	if (val < GPIO_OUTPUT_CHANGE_ACT_BITS) {
+		if (rtk_suspend_gpio_out_en_get() &  (0x1U << val)) {
+			tmp = (0x1U << val);
+			rtk_suspend_gpio_out_act_set(
+				rtk_suspend_gpio_out_act_get() ^ tmp);
+		}
+	} else {
+		if (rtk_suspend_gpio_out_en2_get() &
+			(0x1U << (val-GPIO_OUTPUT_CHANGE_ACT_BITS))) {
+			tmp = (0x1U << (val-GPIO_OUTPUT_CHANGE_ACT_BITS));
+			rtk_suspend_gpio_out_act2_set(
+				rtk_suspend_gpio_out_act2_get() ^ tmp);
+		}
+	}
+
+	return count;
+#endif
+
+}
+
+struct kobj_attribute rtk_suspend_gpio_wakeup_en_attr =
+	RTK_SUSPEND_ATTR(gpio_wakeup_en);
+struct kobj_attribute rtk_suspend_gpio_wakeup_act_attr =
+	RTK_SUSPEND_ATTR(gpio_wakeup_act);
+struct kobj_attribute rtk_suspend_gpio_out_en_attr =
+	RTK_SUSPEND_ATTR(gpio_out_en);
+struct kobj_attribute rtk_suspend_gpio_out_act_attr =
+	RTK_SUSPEND_ATTR(gpio_out_act);
+
+EXPORT_SYMBOL(rtk_suspend_gpio_wakeup_en_attr);
+EXPORT_SYMBOL(rtk_suspend_gpio_wakeup_act_attr);
+EXPORT_SYMBOL(rtk_suspend_gpio_out_en_attr);
+EXPORT_SYMBOL(rtk_suspend_gpio_out_act_attr);
+
+#endif
+
+
diff --git a/drivers/gpio/gpio-rtd16xx-suspend.h b/drivers/gpio/gpio-rtd16xx-suspend.h
new file mode 100644
index 00000000..e97940c
--- /dev/null
+++ b/drivers/gpio/gpio-rtd16xx-suspend.h
@@ -0,0 +1,88 @@
+/*
+ * rtd16xx_gpio_suspend.h - gpio suspend driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef RTD16XX_GPIO_SUSPEND_H_
+#define RTD16XX_GPIO_SUSPEND_H_
+
+#include <soc/realtek/rtk_pm.h>
+
+#define SETMASK(bits, pos) (((-1U) >> (32-bits)) << (pos))
+#define CLRMASK(bits, pos) (~(SETMASK(bits, pos)))
+#define SET_VAL(val,bits,pos) ((val << pos) & SETMASK(bits, pos))
+#define GET_VAL(reg,bits,pos) ((reg & SETMASK(bits, pos)) >> pos)
+
+#define GPIO_WAKEUP_EN_SHIFFT 0
+#define GPIO_WAKEUP_EN_BITS	 32
+#define GPIO_WAKEUP_EN_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+#define GPIO_WAKEUP_EN_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+
+#define GPIO_WAKEUP_ACT_SHIFFT 0
+#define GPIO_WAKEUP_ACT_BITS 32
+#define GPIO_WAKEUP_ACT_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+#define GPIO_WAKEUP_ACT_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_EN_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_EN_BITS 32
+#define GPIO_OUTPUT_CHANGE_EN_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_ACT_BITS 32
+#define GPIO_OUTPUT_CHANGE_ACT_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+
+#define GPIO_WAKEUP_EN2_SHIFFT 0
+#define GPIO_WAKEUP_EN2_BITS 32
+#define GPIO_WAKEUP_EN2_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN2_BITS, GPIO_WAKEUP_EN2_SHIFFT)
+#define GPIO_WAKEUP_EN2_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN2_BITS, GPIO_WAKEUP_EN2_SHIFFT)
+
+#define GPIO_WAKEUP_ACT2_SHIFFT 0
+#define GPIO_WAKEUP_ACT2_BITS 32
+#define GPIO_WAKEUP_ACT2_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT2_BITS, GPIO_WAKEUP_ACT2_SHIFFT)
+#define GPIO_WAKEUP_ACT2_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT2_BITS, GPIO_WAKEUP_ACT2_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_EN2_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_EN2_BITS 32
+#define GPIO_OUTPUT_CHANGE_EN2_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_EN2_BITS, GPIO_OUTPUT_CHANGE_EN2_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN2_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN2_BITS, GPIO_OUTPUT_CHANGE_EN2_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT2_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_ACT2_BITS 32
+#define GPIO_OUTPUT_CHANGE_ACT2_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT2_BITS, GPIO_OUTPUT_CHANGE_ACT2_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT2_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT2_BITS, GPIO_OUTPUT_CHANGE_ACT2_SHIFFT)
+
+#define GPIO_WAKEUP_EN3_SHIFFT 0
+#define GPIO_WAKEUP_EN3_BITS 22
+#define GPIO_WAKEUP_EN3_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN3_BITS, GPIO_WAKEUP_EN3_SHIFFT)
+#define GPIO_WAKEUP_EN3_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN3_BITS, GPIO_WAKEUP_EN3_SHIFFT)
+
+#define GPIO_WAKEUP_ACT3_SHIFFT 0
+#define GPIO_WAKEUP_ACT3_BITS 22
+#define GPIO_WAKEUP_ACT3_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT3_BITS, GPIO_WAKEUP_ACT3_SHIFFT)
+#define GPIO_WAKEUP_ACT3_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT3_BITS, GPIO_WAKEUP_ACT3_SHIFFT)
+
+
+#define GPIO_OUTPUT_CHANGE_EN3_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_EN3_BITS 22
+#define GPIO_OUTPUT_CHANGE_EN3_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN3_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT3_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_ACT3_BITS 22
+#define GPIO_OUTPUT_CHANGE_ACT3_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT3_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+
+void rtk_suspend_gpio_output_change_suspend(void);
+void rtk_suspend_gpio_output_change_resume(void);
+void rtk_gpio_suspend_init(struct device_node *node);
+
+
+#endif /* RTD16XX_GPIO_SUSPEND_H_ */
+
diff --git a/drivers/gpio/gpio-rtd16xx.c b/drivers/gpio/gpio-rtd16xx.c
new file mode 100644
index 00000000..078b664
--- /dev/null
+++ b/drivers/gpio/gpio-rtd16xx.c
@@ -0,0 +1,930 @@
+/*
+ * Realtek GPIO driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/gpio.h>
+#include <linux/errno.h>
+#include <linux/kernel.h>
+#include <linux/clk.h>
+#include <linux/err.h>
+#include <linux/io.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/platform_device.h>
+#include <linux/irqdomain.h>
+#include <linux/irqchip/chained_irq.h>
+#include <linux/slab.h>
+#include <linux/interrupt.h>
+#include <linux/pinctrl/consumer.h>
+#include <linux/irqchip.h>
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+#include "../pinctrl/realtek/pinctrl-rtd16xx.h"
+#include "gpio-rtd16xx.h"
+#include "gpio-rtd16xx-suspend.h"
+
+
+#define GPIO_REG_OFST(id)       (id >> 5) /* (id/32)*/
+#define GPIO_REG_BIT(id)        (id & 0x1F)	/* id % 32*/
+#define GPIO_DEB_OFST(id)       (id >> 3) /* (id/8)*/
+#define GPIO_DEB_BIT(id)        (id & 0x7)	/* id % 8*/
+#define GPIO_INT_REG_OFST(id)   (id/31)
+#define GPIO_INT_REG_BIT(id)    ((id%31)+1)
+
+/* intc mux tempary define the first irq number in this mux is 160 */
+static const struct rtk_gpio_groups rtk_gpio_grps_array[] = {
+	{
+		.group_name = "rtk_iso_gpio",
+		.group_index = 0,
+		/*160(predefine base)+64(intc_mux)*/
+		.linux_irq_base = 224,
+		/*Bit20, de-assert interrupt flag*/
+		.gpio_isr_deassert_int = 0x00100000,
+		/*Bit19, assert interrupt flag*/
+		.gpio_isr_assert_int = 0x00080000,
+		/*ISO_ISR*/
+		.reg_isr_off = 0x0,
+		 /* ISO_UMSK_ISR_GPA0, UMSK_ISR_GPA1 */
+		.reg_umsk_isr_gpa_off = {0x08, 0xe0, 0x90},
+		/* ISO_UMSK_ISR_GPDA0, UMSK_ISR_GPDA1 */
+		.reg_umsk_isr_gpda_off = {0x0c, 0xe4, 0x94},
+		/* ISO_GPDIR, GPDIR_1 */
+		.reg_dir_off = {0x00, 0x18, 0x2C},
+		/* ISO_GPDATO, GPDATO_1 */
+		.reg_dato_off = {0x04, 0x1c, 0x30},
+		/* ISO_GPDATI, GPDATI_1 */
+		.reg_dati_off = {0x08, 0x20, 0x34},
+		/* ISO_GPIE, GPIE_1 */
+		.reg_ie_off = {0x0c, 0x24, 0x38},
+		/* ISO_GPDP, GPDP_1 */
+		.reg_dp_off = {0x10, 0x28, 0x3C},
+		/*ISO_GPDEB*/
+		.reg_deb_off = {0x44, 0x48, 0x4C, 0x50, 0x54, 0x58, 0x5C, 0x60, 0x64, 0x68, 0x6C},
+	}
+};
+
+static const u32 rtk_gpio_ngroups = ARRAY_SIZE(rtk_gpio_grps_array);
+
+static u32 gpio_get_reg_offset(u32 group_index, u32 reg_type, u32 pin)
+{
+	u32 reg_index, reg_offset = UNKNOW_OFFSET;
+	const struct rtk_gpio_groups *p_rtk_gpio_grp = NULL;
+
+	if ((reg_type == GP_REG_UMSK_ISR_GPA) ||
+			(reg_type == GP_REG_UMSK_ISR_GPDA))
+		reg_index = GPIO_INT_REG_OFST(pin);
+	else
+		reg_index = GPIO_REG_OFST(pin);
+
+	if (reg_index >= GPIO_REG_ARRAY_SIZE)
+		return reg_offset;
+
+	if (group_index < rtk_gpio_ngroups)
+		p_rtk_gpio_grp = &rtk_gpio_grps_array[group_index];
+
+	if (!p_rtk_gpio_grp)
+		return reg_offset;
+
+	switch (reg_type) {
+	case GP_REG_UMSK_ISR_GPA:
+		reg_offset = p_rtk_gpio_grp->reg_umsk_isr_gpa_off[reg_index];
+		break;
+	case GP_REG_UMSK_ISR_GPDA:
+		reg_offset = p_rtk_gpio_grp->reg_umsk_isr_gpda_off[reg_index];
+		break;
+	case GP_REG_DIR:
+		reg_offset = p_rtk_gpio_grp->reg_dir_off[reg_index];
+		break;
+	case GP_REG_DATO:
+		reg_offset = p_rtk_gpio_grp->reg_dato_off[reg_index];
+		break;
+	case GP_REG_DATI:
+		reg_offset = p_rtk_gpio_grp->reg_dati_off[reg_index];
+		break;
+	case GP_REG_IE:
+		reg_offset = p_rtk_gpio_grp->reg_ie_off[reg_index];
+		break;
+	case GP_REG_DP:
+		reg_offset = p_rtk_gpio_grp->reg_dp_off[reg_index];
+		break;
+	default:
+		RTK_GPIO_DBG("[%s] Unknow type", __func__);
+	}
+
+	return reg_offset;
+}
+
+static inline void iowrite_reg_bit(void *reg,
+				unsigned char bit, unsigned char val)
+{
+	if (val)
+		writel(readl(reg) | (0x1 << bit), reg);
+	else
+		writel(readl(reg) & ~(0x1 << bit), reg);
+}
+
+#define ioread_reg_bit(reg, bits)    ((readl(reg) >> (bits)) & 0x1)
+#define chip2controller(chip)	\
+	container_of(chip, struct rtk_gpio_controller, chip)
+
+int gpio_chk_irq_enable(struct rtk_gpio_controller *p_rtk_gpio_ctl, u32 irq)
+{
+	u32 ie_offset;
+
+	RTK_GPIO_DBG("[%s] irq(%u)", __func__, irq);
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, irq);
+
+	return ioread_reg_bit(((void *)(p_rtk_gpio_ctl->gpio_regs_base)
+					+ ie_offset), GPIO_REG_BIT(irq));
+}
+
+static void gpio_irq_disable(struct irq_data *d)
+{
+	u32 ie_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+			(struct rtk_gpio_controller *)(d->chip_data);
+
+	RTK_GPIO_DBG("[%s] d->hwirq(%lu)", __func__, d->hwirq);
+
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, d->hwirq);
+
+	iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base +
+					ie_offset), GPIO_REG_BIT(d->hwirq), 0);
+}
+
+static void gpio_irq_enable(struct irq_data *d)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+				(struct rtk_gpio_controller *)(d->chip_data);
+	unsigned long irq_flag;
+	u32 gpa_offset, gpada_offset, ie_offset, gpio_int_flag;
+
+	RTK_GPIO_DBG("[%s] irq number(%u), hwirq(%lu), group(%s)",
+			__func__, d->irq, d->hwirq, d->domain->name);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, irq_flag);
+	gpio_int_flag = 0x1 << GPIO_INT_REG_BIT(d->hwirq);
+
+	gpa_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_UMSK_ISR_GPA, d->hwirq);
+	gpada_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_UMSK_ISR_GPDA, d->hwirq);
+	ie_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_IE, d->hwirq);
+
+	if ((gpa_offset != UNKNOW_OFFSET) && (gpada_offset != UNKNOW_OFFSET)
+		&& (ie_offset != UNKNOW_OFFSET)) {
+		/*Clear assert interrupt flag*/
+		if (readl(p_rtk_gpio_ctl->irq_regs_base+gpa_offset)
+			& gpio_int_flag) {
+			RTK_GPIO_DBG("[%s] Wrte Reg(0x%08llx) Val(0x%08x)",
+				__func__,
+				(u64)(p_rtk_gpio_ctl->irq_regs_base+gpa_offset),
+				gpio_int_flag);
+			writel(gpio_int_flag,
+				p_rtk_gpio_ctl->irq_regs_base + gpa_offset);
+		}
+
+		/*Clear de-assert interrupt flag*/
+		if (readl(p_rtk_gpio_ctl->irq_regs_base+gpada_offset)
+			& gpio_int_flag) {
+			RTK_GPIO_DBG("[%s] Wrte Reg(0x%08llx) Val(0x%08x)",
+				__func__,
+				(u64)(p_rtk_gpio_ctl->irq_regs_base+gpada_offset),
+				gpio_int_flag);
+			writel(gpio_int_flag,
+				p_rtk_gpio_ctl->irq_regs_base + gpada_offset);
+		}
+
+		/*Enable interrupt*/
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ie_offset), GPIO_REG_BIT(d->hwirq), 1);
+		RTK_GPIO_DBG("[%s] Reg_ie[0x%08llx]= 0x%08x", __func__,
+			  (u64)(p_rtk_gpio_ctl->gpio_regs_base+ie_offset),
+			  readl(p_rtk_gpio_ctl->gpio_regs_base+ie_offset));
+	}
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, irq_flag);
+
+}
+
+static int gpio_irq_type(struct irq_data *d, unsigned int trigger)
+{
+	u32 dp_offset;
+
+	struct rtk_gpio_controller *p_rtk_gpio_ctl =
+		(struct rtk_gpio_controller *)(d->chip_data);
+
+	dp_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DP, d->hwirq);
+
+	switch (trigger) {
+	case IRQ_TYPE_EDGE_RISING:
+	case IRQ_TYPE_LEVEL_HIGH:
+		RTK_GPIO_DBG("[%s] Pin(%lu) IRQ_TYPE_EDGE_RISING",
+				__func__, d->hwirq);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ dp_offset), GPIO_REG_BIT(d->hwirq), 1);
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	case IRQ_TYPE_EDGE_FALLING:
+	case IRQ_TYPE_LEVEL_LOW:
+		RTK_GPIO_DBG("[%s] Pin(%lu) IRQ_TYPE_EDGE_FALLING", __func__, d->hwirq);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dp_offset), GPIO_REG_BIT(d->hwirq), 0);
+		clear_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	case IRQ_TYPE_EDGE_BOTH:
+	case IRQ_TYPE_NONE:
+	default:
+		RTK_GPIO_DBG("[%s] Pin(%lu) trigger(%u)", __func__, d->hwirq, trigger);
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dp_offset), GPIO_REG_BIT(d->hwirq), 1);
+		set_bit(GPIO_REG_BIT(d->hwirq), (unsigned long *)&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		set_bit(GPIO_REG_BIT(d->hwirq),
+			(unsigned long *)&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(d->hwirq)]);
+		break;
+
+	}
+
+	return 0;
+
+}
+
+static void gpio_irq_handler(struct irq_desc *desc)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	u32 gpada_offset, gpa_offset;
+	u32 gpioNr, i;
+	u32 event, status;
+	u32 hw_irq = 12345678, linux_irq;
+	u32 irq_had_fired = 0;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+
+	p_rtk_gpio_ctl = (struct rtk_gpio_controller *)irq_desc_get_handler_data(desc);	/*rtk_gpio_controller for MISC or ISO*/
+
+	/* Get interrupt status */
+	event = readl(p_rtk_gpio_ctl->reg_isr) & (p_rtk_gpio_ctl->gpio_isr_deassert_int | p_rtk_gpio_ctl->gpio_isr_assert_int);
+	RTK_GPIO_DBG("[%s] event(0x%08x)", __func__, event);
+	if (event == 0)
+		return;
+
+	/* Handle gpio deassert */
+	if (event & (p_rtk_gpio_ctl->gpio_isr_deassert_int)) {
+		gpioNr = 0;
+		RTK_GPIO_DBG("[%s] de-assert interrupt", __func__);
+		while (gpioNr < (p_rtk_gpio_ctl->chip.ngpio)) {
+			gpada_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_UMSK_ISR_GPDA, gpioNr);
+
+			status = readl(p_rtk_gpio_ctl->irq_regs_base + gpada_offset) >> 1;	/*get regs_umsk_isr_gpda0 or regs_umsk_isr_gpda1*/
+			writel(status << 1, p_rtk_gpio_ctl->irq_regs_base + gpada_offset);
+
+			i = gpioNr;
+			while (status && i < (p_rtk_gpio_ctl->chip.ngpio)) {	/*i<MISC gpio number(60) or ISO gpio number(20)*/
+				/*printk("status = %08x\n", status);*/
+				if ((status & 0x1) && gpio_chk_irq_enable(p_rtk_gpio_ctl, i)) {
+					hw_irq = i;
+					linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, hw_irq);
+					if (linux_irq) {
+						RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+						RTK_GPIO_DBG("hw_irq = %d,  deassertflg[0x%08llx] = %x", hw_irq, (u64)(&p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)]), p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)]);
+						if ((1<<GPIO_REG_BIT(hw_irq)) & (p_rtk_gpio_ctl->gpio_isr_deassert_enable_flag[GPIO_REG_OFST(hw_irq)])) {
+							generic_handle_irq(linux_irq);
+							irq_had_fired++;
+						}
+					} else {
+						pr_err("%s can not specified linux irq number for hwirq=%d .", __func__, hw_irq);
+					}
+				}
+				i++;
+				status >>= 1;
+				RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+			}
+
+			gpioNr += 31;
+			RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+		}
+
+	}
+
+	RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+
+	/* Handle gpio assert */
+	if (event & (p_rtk_gpio_ctl->gpio_isr_assert_int)) {
+		gpioNr = 0;
+		RTK_GPIO_DBG("[%s] assert interrupt", __func__);
+		while (gpioNr < (p_rtk_gpio_ctl->chip.ngpio)) {
+			gpa_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_UMSK_ISR_GPA, gpioNr);
+
+			status = readl(p_rtk_gpio_ctl->irq_regs_base + gpa_offset) >> 1;
+			writel(status << 1, p_rtk_gpio_ctl->irq_regs_base + gpa_offset);
+
+			i = gpioNr;
+			while (status && i < (p_rtk_gpio_ctl->chip.ngpio)) {
+				if ((status & 0x1) && gpio_chk_irq_enable(p_rtk_gpio_ctl, i)) {
+					hw_irq = i;
+					linux_irq = irq_find_mapping(p_rtk_gpio_ctl->irq_mux_domain, hw_irq);
+					if (linux_irq) {
+						RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+						RTK_GPIO_DBG("hw_irq = %d,  assertflg[0x%08llx] = %x", hw_irq, (u64)(&p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)]), p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)]);
+						if ((1<<GPIO_REG_BIT(hw_irq)) & (p_rtk_gpio_ctl->gpio_isr_assert_enable_flag[GPIO_REG_OFST(hw_irq)])) {
+							RTK_GPIO_DBG("[%s]%s  line: %d", __FILE__, __func__, __LINE__);
+							generic_handle_irq(linux_irq);
+							irq_had_fired++;
+						}
+					} else {
+						pr_err("%s can not specified linux irq number for hwirq=%d .", __func__, hw_irq);
+					}
+				}
+				i++;
+				status >>= 1;
+				RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+			}
+			gpioNr += 31;
+			RTK_GPIO_DBG("[%s] line: %d", __func__, __LINE__);
+		}
+	}
+
+
+	RTK_GPIO_DBG("[%s] irq_had_fired = %d", __func__, irq_had_fired);
+	writel(event, p_rtk_gpio_ctl->reg_isr);
+	if (!irq_had_fired)
+		RTK_GPIO_DBG("%s gpio irq(hwirq=%d) has triggered but no dispatch",
+				__func__, hw_irq);
+		RTK_GPIO_DBG("to user handler (12345678 mean something Wrong)");
+	return;
+
+}
+
+static __maybe_unused int
+	mux_irq_domain_xlate(struct irq_domain *d,
+		struct device_node *controller, const u32 *intspec, u32 intsize,
+		unsigned long *out_hwirq, u32 *out_type)
+{
+	RTK_GPIO_DBG("[%s] device_node.name = %s", __func__, controller->name);
+
+	if (/*d->of_node*/to_of_node(d->fwnode) != controller)
+		return -EINVAL;
+
+	if (intsize < 1)
+		return -EINVAL;
+
+	*out_hwirq = intspec[0];
+	*out_type = 0;
+	RTK_GPIO_DBG("[%s] out_hwirq = %ld", __func__, *out_hwirq);
+	return 0;
+}
+
+static int mux_irq_domain_map(struct irq_domain *d, u32 irq, irq_hw_number_t hw)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = d->host_data;
+
+	RTK_GPIO_DBG("[%s] irq=%d , irq_hw_number=%d", __func__, irq, (u32)hw);
+
+	if (!p_rtk_gpio_ctl) {
+		RTK_GPIO_DBG("[%s] p_rtk_gpio_ctl is NULL", __func__);
+		return -EINVAL;
+	}
+
+	irq_set_chip(irq, &p_rtk_gpio_ctl->gp_irq_chip);
+	irq_set_chip_data(irq, (__force void *)p_rtk_gpio_ctl);
+	irq_set_handler_data(irq, p_rtk_gpio_ctl);
+	irq_set_handler(irq, handle_simple_irq);
+	/*set_irq_flags(irq, IRQF_VALID);*/
+
+	return 0;
+}
+
+static const struct irq_domain_ops mux_irq_domain_ops = {
+	.xlate = mux_irq_domain_xlate,
+	.map = mux_irq_domain_map,
+};
+
+int rtk_gpio_irq_setup(struct device_node *node,
+	struct rtk_gpio_controller *p_rtk_gpio_ctl,
+	const struct rtk_gpio_groups *p_rtk_gpio_grp)
+{
+	unsigned int bank_deassert_irq, bank_assert_irq;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+
+	p_rtk_gpio_ctl->gp_irq_chip.name = node->name;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_enable = gpio_irq_enable;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_disable = gpio_irq_disable;
+	p_rtk_gpio_ctl->gp_irq_chip.irq_set_type = gpio_irq_type;
+	p_rtk_gpio_ctl->gp_irq_chip.flags = IRQCHIP_SET_TYPE_MASKED;
+
+	bank_assert_irq = irq_of_parse_and_map(node, 0);
+	if (!bank_assert_irq) {
+		pr_alert("[GPIO] Fail to parse of irq.\n");
+		return -ENXIO;
+	}
+
+	bank_deassert_irq = irq_of_parse_and_map(node, 1);
+	if (!bank_deassert_irq) {
+		pr_alert("[GPIO] Fail to parse of irq.\n");
+		return -ENXIO;
+	}
+
+	p_rtk_gpio_ctl->bank_assert_irq = bank_assert_irq;
+	p_rtk_gpio_ctl->bank_deassert_irq = bank_deassert_irq;
+	RTK_GPIO_DBG("[%s] bank_assert_irq=%d", __func__,
+			p_rtk_gpio_ctl->bank_assert_irq);
+	RTK_GPIO_DBG("[%s] bank_deassert_irq=%d", __func__,
+			p_rtk_gpio_ctl->bank_deassert_irq);
+
+	p_rtk_gpio_ctl->irq_mux_domain = irq_domain_add_simple(node,
+			p_rtk_gpio_ctl->chip.ngpio,
+			p_rtk_gpio_ctl->linux_irq_base,
+			&mux_irq_domain_ops, p_rtk_gpio_ctl);
+
+	WARN(!p_rtk_gpio_ctl->irq_mux_domain, "IRQ domain init failed\n");
+
+	irq_set_chained_handler(p_rtk_gpio_ctl->bank_deassert_irq,
+				(irq_flow_handler_t)gpio_irq_handler);
+	irq_set_handler_data(p_rtk_gpio_ctl->bank_deassert_irq, p_rtk_gpio_ctl);
+
+	irq_set_chained_handler(p_rtk_gpio_ctl->bank_assert_irq,
+				(irq_flow_handler_t)gpio_irq_handler);
+	irq_set_handler_data(p_rtk_gpio_ctl->bank_assert_irq, p_rtk_gpio_ctl);
+	return 0;
+}
+
+static inline int __rtk_gpio_direction(struct gpio_chip *chip,
+	unsigned int offset, bool out)
+{
+	u32 dir_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+	u32 temp;
+	u32 mask = 1 << (offset % 32);
+
+	RTK_GPIO_DBG("[%s] offset(%u) out(%u)", __func__, offset, out);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DIR, offset);
+
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	if (out)
+		temp |= mask;
+	else
+		temp &= ~mask;
+
+	__raw_writel(temp, (p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	RTK_GPIO_DBG("[%s] offset(%u)  addr(0x%08llx)  temp(0x%08x)",
+			__func__, offset,
+			(u64)((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset),
+			temp);
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+
+	return 0;
+}
+
+static int rtk_gpio_get(struct gpio_chip *chip, unsigned int offset)
+{
+	u32 dati_offset, dato_offset, dir_offset;
+	u32 temp, value;
+	u32 mask = 1 << (offset % 32);
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DIR, offset);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	if (temp & mask) {  /*direction out*/
+		dato_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DATO, offset);
+		value = ioread_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dato_offset), GPIO_REG_BIT(offset));
+	} else {  /*direction in*/
+		dati_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DATI, offset);
+		value = ioread_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base + dati_offset), GPIO_REG_BIT(offset));
+	}
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+
+	return value;
+}
+
+static void rtk_gpio_set(struct gpio_chip *chip, unsigned int offset, int value)
+{
+	u32 dato_offset;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	unsigned long flags;
+
+	RTK_GPIO_DBG("[%s] offset(%u) value(%d)", __func__, offset, value);
+
+	dato_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index,
+					GP_REG_DATO, offset);
+	spin_lock_irqsave(&p_rtk_gpio_ctl->lock, flags);
+	if (value)
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ dato_offset), GPIO_REG_BIT(offset), 1);
+	else
+		iowrite_reg_bit(((void *)p_rtk_gpio_ctl->gpio_regs_base
+				+ dato_offset), GPIO_REG_BIT(offset), 0);
+	spin_unlock_irqrestore(&p_rtk_gpio_ctl->lock, flags);
+}
+
+static int rtk_gpio_direction_in(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	return __rtk_gpio_direction(chip, offset, GP_DIRIN);
+}
+
+static int rtk_gpio_direction_out(struct gpio_chip *chip,
+	unsigned int offset, int value)
+{
+	RTK_GPIO_DBG("[%s] offset(%u) value(%d)", __func__, offset, value);
+
+	rtk_gpio_set(chip, offset, value);
+	return __rtk_gpio_direction(chip, offset, GP_DIROUT);
+}
+
+
+static int rtk_gpio_get_direction(struct gpio_chip *chip, unsigned int offset)
+{
+	u32 dir_offset;
+	u32 temp, dir;
+	u32 mask = 1 << (offset % 32);
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+
+	RTK_GPIO_DBG("[%s] offset(%u)\n", __func__, offset);
+
+	dir_offset = gpio_get_reg_offset(p_rtk_gpio_ctl->group_index, GP_REG_DIR, offset);
+	temp = __raw_readl((p_rtk_gpio_ctl->gpio_regs_base) + dir_offset);
+	dir = (temp & mask) ? 0 : 1;
+
+	return dir;
+}
+
+static int rtk_gpio_setdeb(struct gpio_chip *chip,
+	unsigned int offset, unsigned int debounce/*microsecond(us)*/)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	void __iomem *gpio_deb_addr;
+
+	RTK_GPIO_DBG("[%s] offset(%u) debounce(%d)",
+			__func__, offset, debounce);
+
+	if (debounce >= 50*1000) {/*50ms*/
+		debounce = RTK_GPIO_DEBOUNCE_50ms;
+	} else if (debounce >= 30*1000) {/*30ms*/
+		debounce = RTK_GPIO_DEBOUNCE_30ms;
+	} else if (debounce >= 20*1000) {/*20ms*/
+		debounce = RTK_GPIO_DEBOUNCE_20ms;
+	} else if (debounce >= 10*1000) {/* 10ms*/
+		debounce = RTK_GPIO_DEBOUNCE_10ms;
+	} else if (debounce >= 1000) {/* 1ms*/
+		debounce = RTK_GPIO_DEBOUNCE_1ms;
+	} else if (debounce >= 100) {/* 100us*/
+		debounce = RTK_GPIO_DEBOUNCE_100us;
+	} else if (debounce >= 10) {/* 10us*/
+		debounce = RTK_GPIO_DEBOUNCE_10us;
+	} else {   /*1us*/
+		debounce = RTK_GPIO_DEBOUNCE_1us;
+	}
+
+	if (strcmp("rtk_iso_gpio", chip->label) == 0) {
+		gpio_deb_addr = p_rtk_gpio_ctl->reg_deb[GPIO_DEB_OFST(offset)];
+		writel((0x8 | debounce) << (GPIO_DEB_BIT(offset)*4),
+				(void *)gpio_deb_addr);
+		return 0;
+	}
+
+	RTK_GPIO_DBG("[%s] Fail", __func__);
+	return -EINVAL;
+}
+
+static int rtk_gpio_request(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	return pinctrl_request_gpio(chip->base + offset);
+}
+
+static void rtk_gpio_free(struct gpio_chip *chip, unsigned int offset)
+{
+	RTK_GPIO_DBG("[%s] offset(%u)", __func__, offset);
+
+	pinctrl_free_gpio(chip->base + offset);
+}
+
+static int rtk_gpio_to_irq(struct gpio_chip *chip, unsigned int offset)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl = chip2controller(chip);
+	u32 linux_irq = 0;
+
+	linux_irq = irq_create_mapping(p_rtk_gpio_ctl->irq_mux_domain, offset);
+	RTK_GPIO_DBG("[%s] offset(%u) linux_irq(%u)", __func__,
+			offset, linux_irq);
+
+	if (!linux_irq) {
+		pr_err("%s can not specified linux irq number for hwirq=%d .\n",
+			__func__, offset);
+		return -EINVAL;
+	}
+	return linux_irq;
+}
+
+static int rtk_gpio_xlate(struct gpio_chip *gc,
+	const struct of_phandle_args *gpiospec, u32 *flags)
+{
+	u32 pin;
+
+	RTK_GPIO_DBG("[%s] base(%d), args[0]=%d", __func__,
+		gc->base, gpiospec->args[0]);
+
+	if (WARN_ON(gc->of_gpio_n_cells < 1))
+		return -EINVAL;
+
+	if (WARN_ON(gpiospec->args_count < gc->of_gpio_n_cells))
+		return -EINVAL;
+
+	if (gpiospec->args[0] > gc->ngpio)
+		return -EINVAL;
+
+	pin = gpiospec->args[0];
+
+	gpio_pinctrl_control(gc, gpiospec->args[0],
+			gpiospec->args[1], gpiospec->args[2]);
+
+	if (gpiospec->args[1] == GP_DIRIN) {/*gpio direction input*/
+		if (rtk_gpio_direction_in(gc, pin))
+			pr_err("gpio_xlate: failed to set pin direction in\n");
+
+		if (flags) /*low active flag*/
+			*flags = gpiospec->args[2];
+	} else {
+		/*gpio direction output low*/
+		if (gpiospec->args[2] == 0 || gpiospec->args[2] == 2 || gpiospec->args[2] == 4) {
+			if (rtk_gpio_direction_out(gc, pin, GP_LOW))
+				pr_err("gpio_xlate: failed to set pin direction out\n");
+		} else if (gpiospec->args[2] == 1 || gpiospec->args[2] == 3 || gpiospec->args[2] == 5) {
+			/*gpio direction output high*/
+			if (rtk_gpio_direction_out(gc, pin, GP_HIGH))
+				pr_err("gpio_xlate: failed to set pin direction out\n");
+		} else {
+			pr_err("gpio_xlate: failed to set pin direction out\n");
+		}
+	}
+
+	return gpiospec->args[0];
+}
+
+void set_default_gpio(struct device_node *node)
+{
+	int num_gpios, n;
+
+	num_gpios = of_gpio_count(node);
+	if (num_gpios > 0) {
+		for (n = 0; n < num_gpios; n++) {
+			int gpio = of_get_gpio_flags(node, n, NULL);
+
+			RTK_GPIO_DBG("[%s]  %s  line: %d",
+					__FILE__, __func__, __LINE__);
+			if (gpio >= 0) {
+				if (!gpio_is_valid(gpio))
+					pr_err("[GPIO] %s: gpio %d is not valid\n",
+						__func__, gpio);
+
+				if (gpio_request(gpio, node->name))
+					pr_err("[GPIO] %s: gpio %d is in use\n",
+						__func__, gpio);
+
+				gpio_free(gpio);
+			} else {
+				pr_err("[GPIO] %s: Could not get gpio from of\n",
+					__func__);
+			}
+		}
+	} else {
+		RTK_GPIO_INF("No default gpio need to set");
+	}
+}
+
+static const struct of_device_id rtk_gpio_of_match[] = {
+	{.compatible = "realtek,rtk16xx-iso-gpio-irq-mux",},
+	{ /* Sentinel */ },
+};
+
+static int rtk_gpio_probe(struct platform_device *pdev)
+{
+	int i;
+	void __iomem *irq_regs_base;
+	void __iomem *gpio_regs_base;
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	const struct rtk_gpio_groups *p_rtk_gpio_grp = NULL;
+	u32 gpio_numbers;
+	u32 gpio_base;
+	struct device_node *node = NULL;
+
+	RTK_GPIO_DBG("[%s]", __func__);
+	node = pdev->dev.of_node;
+	if (!node) {
+		pr_err("rtk gpio: failed to allocate device structure.\n");
+		return -ENODEV;
+	}
+
+	RTK_GPIO_DBG("[%s] node name = [%s]", __func__, node->name);
+
+	p_rtk_gpio_ctl =
+		kzalloc(sizeof(struct rtk_gpio_controller), GFP_KERNEL);
+	if (!p_rtk_gpio_ctl) {
+		pr_err("rtk gpio: failed to allocate device structure.\n");
+		return -ENOMEM;
+	}
+	memset(p_rtk_gpio_ctl, 0, sizeof(struct rtk_gpio_groups));
+
+	if (of_property_read_u32_array(node, "Realtek,gpio_numbers",
+		&gpio_numbers, 1)) {
+		pr_err("Don't know gpio group number.\n");
+		return -EINVAL;
+	}
+
+	if (of_property_read_u32_index(node, "Realtek,gpio_base",
+		0, &gpio_base)) {
+		pr_err("Don't know gpio group number.\n");
+		return -EINVAL;
+	}
+
+	for (i = 0; i < rtk_gpio_ngroups; i++) {
+		if (strcmp(rtk_gpio_grps_array[i].group_name, node->name) == 0)
+			p_rtk_gpio_grp = &rtk_gpio_grps_array[i];
+	}
+
+	if (!p_rtk_gpio_grp) {
+		pr_err("Don't know gpio group name.\n");
+		return -EINVAL;
+	}
+
+	p_rtk_gpio_ctl->chip.label = node->name;
+	p_rtk_gpio_ctl->chip.request = rtk_gpio_request;
+	p_rtk_gpio_ctl->chip.free = rtk_gpio_free;
+	p_rtk_gpio_ctl->chip.direction_input = rtk_gpio_direction_in;
+	p_rtk_gpio_ctl->chip.get = rtk_gpio_get;
+	p_rtk_gpio_ctl->chip.get_direction= rtk_gpio_get_direction;
+	p_rtk_gpio_ctl->chip.direction_output = rtk_gpio_direction_out;
+	p_rtk_gpio_ctl->chip.set = rtk_gpio_set;
+	p_rtk_gpio_ctl->chip.set_debounce = rtk_gpio_setdeb;
+	p_rtk_gpio_ctl->chip.to_irq = rtk_gpio_to_irq;
+	p_rtk_gpio_ctl->chip.base = gpio_base;
+	p_rtk_gpio_ctl->chip.ngpio = gpio_numbers;
+	/*must be the same with     #gpio-cells = <> in dtb*/
+	p_rtk_gpio_ctl->chip.of_gpio_n_cells = 3;
+	p_rtk_gpio_ctl->chip.of_xlate = rtk_gpio_xlate;
+	p_rtk_gpio_ctl->chip.of_node = node;
+
+	spin_lock_init(&p_rtk_gpio_ctl->lock);
+
+	irq_regs_base = of_iomap(node, 0);
+	if (!irq_regs_base) {
+		pr_err("unable to map irq_regs_base registers\n");
+		return -EINVAL;
+	}
+
+	gpio_regs_base = of_iomap(node, 1);
+	if (!gpio_regs_base) {
+		pr_err("unable to map gpio_regs_base registers\n");
+		return -EINVAL;
+	}
+
+	p_rtk_gpio_ctl->gpio_isr_deassert_int =
+			p_rtk_gpio_grp->gpio_isr_deassert_int;
+	p_rtk_gpio_ctl->gpio_isr_assert_int =
+			p_rtk_gpio_grp->gpio_isr_assert_int;
+	p_rtk_gpio_ctl->linux_irq_base = p_rtk_gpio_grp->linux_irq_base;
+
+	p_rtk_gpio_ctl->group_index = p_rtk_gpio_grp->group_index;
+	p_rtk_gpio_ctl->irq_regs_base = (void __iomem *)irq_regs_base;
+	p_rtk_gpio_ctl->gpio_regs_base = (void __iomem *)gpio_regs_base;
+	p_rtk_gpio_ctl->reg_isr = (void __iomem *)irq_regs_base
+				+ p_rtk_gpio_grp->reg_isr_off;
+	for (i = 0; i < ARRAY_SIZE(p_rtk_gpio_grp->reg_deb_off); i++) {
+		p_rtk_gpio_ctl->reg_deb[i] = (void __iomem *)gpio_regs_base
+					+ p_rtk_gpio_grp->reg_deb_off[i];
+	}
+
+	if (gpiochip_add(&p_rtk_gpio_ctl->chip))
+		pr_info("[%s]  %s  line: %d\n", __FILE__, __func__, __LINE__);
+
+	rtk_gpio_irq_setup(node, p_rtk_gpio_ctl, p_rtk_gpio_grp);
+
+	platform_set_drvdata(pdev, p_rtk_gpio_ctl);
+
+	/* Initial default gpios */
+	set_default_gpio(node);
+
+	rtk_gpio_suspend_init(node);
+
+	return 0;
+}
+
+static int rtk_gpio_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return 0;
+	}
+#endif
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+	rtk_suspend_gpio_output_change_suspend();
+	disable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	disable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static int rtk_gpio_resume(struct platform_device *pdev)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+	struct device_node *node;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+	node = p_rtk_gpio_ctl->chip.of_node;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return 0;
+	}
+#endif
+
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+
+	/* Initial default gpios */
+	set_default_gpio(node);
+
+	enable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	enable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+	rtk_suspend_gpio_output_change_resume();
+	pr_info("[GPIO] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static void rtk_gpio_shutdown(struct platform_device *pdev)
+{
+	struct rtk_gpio_controller *p_rtk_gpio_ctl;
+
+	p_rtk_gpio_ctl = platform_get_drvdata(pdev);
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[GPIO] skip %s in DomU, label(%s)\n", __func__, p_rtk_gpio_ctl->chip.label);
+		return;
+	}
+#endif
+	pr_info("[GPIO] Enter %s, label(%s)\n",
+		__func__, p_rtk_gpio_ctl->chip.label);
+
+	disable_irq(p_rtk_gpio_ctl->bank_assert_irq);
+	disable_irq(p_rtk_gpio_ctl->bank_deassert_irq);
+
+	pr_info("[GPIO] Exit %s\n", __func__);
+}
+
+
+static struct platform_driver rtk_gpio_driver = {
+	.driver = {
+		.name = "rtk_gpio",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_gpio_of_match,
+	},
+	.probe = rtk_gpio_probe,
+	.suspend = rtk_gpio_suspend,
+	.resume = rtk_gpio_resume,
+	.shutdown = rtk_gpio_shutdown,
+};
+
+static int rtk_gpio_drv_reg(void)
+{
+	return platform_driver_register(&rtk_gpio_driver);
+}
+
+postcore_initcall(rtk_gpio_drv_reg);
diff --git a/drivers/gpio/gpio-rtd16xx.h b/drivers/gpio/gpio-rtd16xx.h
new file mode 100644
index 00000000..2bcfb39
--- /dev/null
+++ b/drivers/gpio/gpio-rtd16xx.h
@@ -0,0 +1,104 @@
+/*
+ * Realtek GPIO driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+
+#ifndef _RTK_GPIO_H_
+#define _RTK_GPIO_H_
+
+#include <linux/io.h>
+#include <linux/spinlock.h>
+#include <asm-generic/gpio.h>
+
+
+/*#define RTK_GPIO_DEBUG*/
+#ifdef RTK_GPIO_DEBUG
+#define RTK_GPIO_DBG(fmt, ...) pr_info("[GPIO DBG] " fmt "\n", ## __VA_ARGS__)
+#else
+#define RTK_GPIO_DBG(fmt, ...)
+#endif
+
+#define RTK_GPIO_INF(fmt, ...) pr_info("[GPIO] " fmt "\n", ## __VA_ARGS__)
+#define RTK_GPIO_ERR(fmt, ...) pr_err("[GPIO Error] " fmt "\n", ## __VA_ARGS__)
+
+#define GP_HIGH		1
+#define GP_LOW		0
+#define GP_DIROUT	1
+#define GP_DIRIN	0
+
+/*RTK_GPIO_DEBOUNCE*/
+enum {
+	RTK_GPIO_DEBOUNCE_1us = 0,
+	RTK_GPIO_DEBOUNCE_10us,
+	RTK_GPIO_DEBOUNCE_100us,
+	RTK_GPIO_DEBOUNCE_1ms,
+	RTK_GPIO_DEBOUNCE_10ms,
+	RTK_GPIO_DEBOUNCE_20ms,
+	RTK_GPIO_DEBOUNCE_30ms,
+	RTK_GPIO_DEBOUNCE_50ms,
+};
+
+#define GPIO_REG_ARRAY_SIZE	 4
+#define GPIO_DEB_ARRAY_SIZE	 12
+
+#define UNKNOW_OFFSET	0xFFFF
+/*GP_REG_TYPE*/
+enum {
+	GP_REG_UMSK_ISR_GPA = 0,
+	GP_REG_UMSK_ISR_GPDA,
+	GP_REG_DIR,
+	GP_REG_DATO,
+	GP_REG_DATI,
+	GP_REG_IE,
+	GP_REG_DP
+};
+
+
+struct rtk_gpio_groups {
+	const char	*group_name;
+	u32		group_index;
+	u32		linux_irq_base;
+	void __iomem		*irq_membase;
+	u32	gpio_isr_deassert_int;
+	u32	gpio_isr_assert_int;
+	u32	reg_isr_off;
+	u32	reg_umsk_isr_gpa_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_umsk_isr_gpda_off[GPIO_REG_ARRAY_SIZE];
+	void __iomem		*gpio_membase;
+	u32		mem_size;
+	u32	reg_dir_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dato_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dati_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_ie_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_dp_off[GPIO_REG_ARRAY_SIZE];
+	u32	reg_deb_off[GPIO_DEB_ARRAY_SIZE];
+};
+
+
+struct rtk_gpio_controller {
+	struct gpio_chip	chip;
+	struct irq_chip	gp_irq_chip;
+	unsigned int	bank_deassert_irq;
+	unsigned int	bank_assert_irq;
+	struct irq_domain *irq_mux_domain;
+	spinlock_t		lock;
+	u32		gpio_isr_deassert_int;
+	u32		gpio_isr_assert_int;
+	u64		gpio_isr_deassert_enable_flag[GPIO_REG_ARRAY_SIZE];
+	u64		gpio_isr_assert_enable_flag[GPIO_REG_ARRAY_SIZE];
+	u32		linux_irq_base;
+	u32 group_index;
+	void __iomem	*reg_isr;
+	void __iomem	*irq_regs_base;
+	void __iomem	*gpio_regs_base;
+	void __iomem	*reg_deb[GPIO_DEB_ARRAY_SIZE];
+};
+
+#endif /*_RTK_GPIO_H_*/
diff --git a/drivers/gpu/drm/Kconfig b/drivers/gpu/drm/Kconfig
index 483059a..958cb8a 100644
--- a/drivers/gpu/drm/Kconfig
+++ b/drivers/gpu/drm/Kconfig
@@ -12,6 +12,7 @@ menuconfig DRM
 	select I2C
 	select I2C_ALGOBIT
 	select DMA_SHARED_BUFFER
+	select SYNC_FILE
 	help
 	  Kernel-level support for the Direct Rendering Infrastructure (DRI)
 	  introduced in XFree86 4.0. If you say Y here, you need to select
@@ -223,6 +224,8 @@ source "drivers/gpu/drm/hisilicon/Kconfig"
 
 source "drivers/gpu/drm/mediatek/Kconfig"
 
+source "drivers/gpu/drm/rtk/Kconfig"
+
 # Keep legacy drivers last
 
 menuconfig DRM_LEGACY
diff --git a/drivers/gpu/drm/Makefile b/drivers/gpu/drm/Makefile
index 25c7204..820e11e 100644
--- a/drivers/gpu/drm/Makefile
+++ b/drivers/gpu/drm/Makefile
@@ -79,6 +79,7 @@ obj-$(CONFIG_DRM_TEGRA) += tegra/
 obj-$(CONFIG_DRM_STI) += sti/
 obj-$(CONFIG_DRM_IMX) += imx/
 obj-$(CONFIG_DRM_MEDIATEK) += mediatek/
+obj-$(CONFIG_DRM_RTK) += rtk/
 obj-y			+= i2c/
 obj-y			+= panel/
 obj-y			+= bridge/
diff --git a/drivers/gpu/drm/drm_atomic.c b/drivers/gpu/drm/drm_atomic.c
index dd6fff1..4e4043f 100644
--- a/drivers/gpu/drm/drm_atomic.c
+++ b/drivers/gpu/drm/drm_atomic.c
@@ -30,6 +30,7 @@
 #include <drm/drm_atomic.h>
 #include <drm/drm_mode.h>
 #include <drm/drm_plane_helper.h>
+#include <linux/sync_file.h>
 
 #include "drm_crtc_internal.h"
 
@@ -292,6 +293,23 @@ struct drm_crtc_state *
 }
 EXPORT_SYMBOL(drm_atomic_get_crtc_state);
 
+static void set_out_fence_for_crtc(struct drm_atomic_state *state,
+				   struct drm_crtc *crtc, s32 __user *fence_ptr)
+{
+	state->crtcs[drm_crtc_index(crtc)].out_fence_ptr = fence_ptr;
+}
+
+static s32 __user *get_out_fence_for_crtc(struct drm_atomic_state *state,
+					  struct drm_crtc *crtc)
+{
+	s32 __user *fence_ptr;
+
+	fence_ptr = state->crtcs[drm_crtc_index(crtc)].out_fence_ptr;
+	state->crtcs[drm_crtc_index(crtc)].out_fence_ptr = NULL;
+
+	return fence_ptr;
+}
+
 /**
  * drm_atomic_set_mode_for_crtc - set mode for CRTC
  * @state: the CRTC whose incoming state to update
@@ -496,6 +514,16 @@ int drm_atomic_crtc_set_property(struct drm_crtc *crtc,
 					&replaced);
 		state->color_mgmt_changed |= replaced;
 		return ret;
+	} else if (property == config->prop_out_fence_ptr) {
+		s32 __user *fence_ptr = u64_to_user_ptr(val);
+
+		if (!fence_ptr)
+			return 0;
+
+		if (put_user(-1, fence_ptr))
+			return -EFAULT;
+
+		set_out_fence_for_crtc(state->state, crtc, fence_ptr);
 	} else if (crtc->funcs->atomic_set_property)
 		return crtc->funcs->atomic_set_property(crtc, state, property, val);
 	else
@@ -538,6 +566,8 @@ int drm_atomic_crtc_set_property(struct drm_crtc *crtc,
 		*val = (state->ctm) ? state->ctm->base.id : 0;
 	else if (property == config->gamma_lut_property)
 		*val = (state->gamma_lut) ? state->gamma_lut->base.id : 0;
+	else if (property == config->prop_out_fence_ptr)
+		*val = 0;
 	else if (crtc->funcs->atomic_get_property)
 		return crtc->funcs->atomic_get_property(crtc, state, property, val);
 	else
@@ -693,6 +723,17 @@ int drm_atomic_plane_set_property(struct drm_plane *plane,
 		drm_atomic_set_fb_for_plane(state, fb);
 		if (fb)
 			drm_framebuffer_unreference(fb);
+	} else if (property == config->prop_in_fence_fd) {
+		if (state->fence)
+			return -EINVAL;
+
+		if (U642I64(val) == -1)
+			return 0;
+
+		state->fence = sync_file_get_fence(val);
+		if (!state->fence)
+			return -EINVAL;
+
 	} else if (property == config->prop_crtc_id) {
 		struct drm_crtc *crtc = drm_crtc_find(dev, val);
 		return drm_atomic_set_crtc_for_plane(state, crtc);
@@ -752,6 +793,8 @@ int drm_atomic_plane_set_property(struct drm_plane *plane,
 
 	if (property == config->prop_fb_id) {
 		*val = (state->fb) ? state->fb->base.id : 0;
+	} else if (property == config->prop_in_fence_fd) {
+		*val = -1;
 	} else if (property == config->prop_crtc_id) {
 		*val = (state->crtc) ? state->crtc->base.id : 0;
 	} else if (property == config->prop_crtc_x) {
@@ -1154,6 +1197,36 @@ int drm_atomic_get_property(struct drm_mode_object *obj,
 EXPORT_SYMBOL(drm_atomic_set_fb_for_plane);
 
 /**
+ * drm_atomic_set_fence_for_plane - set fence for plane
+ * @plane_state: atomic state object for the plane
+ * @fence: fence to use for the plane
+ *
+ * Helper to setup the plane_state fence in case it is not set yet.
+ * By using this drivers doesn't need to worry if the user choose
+ * implicit or explicit fencing.
+ *
+ * This function will not set the fence to the state if it was set
+ * via explicit fencing interfaces on the atomic ioctl. It will
+ * all drope the reference to the fence as we not storing it
+ * anywhere.
+ *
+ * Otherwise, if plane_state->fence is not set this function we
+ * just set it with the received implict fence.
+ */
+void
+drm_atomic_set_fence_for_plane(struct drm_plane_state *plane_state,
+			       struct fence *fence)
+{
+	if (plane_state->fence) {
+		fence_put(fence);
+		return;
+	}
+
+	plane_state->fence = fence;
+}
+EXPORT_SYMBOL(drm_atomic_set_fence_for_plane);
+
+/**
  * drm_atomic_set_crtc_for_connector - set crtc for connector
  * @conn_state: atomic state object for the connector
  * @crtc: crtc to use for the connector
@@ -1472,11 +1545,9 @@ int drm_atomic_nonblocking_commit(struct drm_atomic_state *state)
  */
 
 static struct drm_pending_vblank_event *create_vblank_event(
-		struct drm_device *dev, struct drm_file *file_priv,
-		struct fence *fence, uint64_t user_data)
+		struct drm_device *dev, uint64_t user_data)
 {
 	struct drm_pending_vblank_event *e = NULL;
-	int ret;
 
 	e = kzalloc(sizeof *e, GFP_KERNEL);
 	if (!e)
@@ -1486,17 +1557,6 @@ static struct drm_pending_vblank_event *create_vblank_event(
 	e->event.base.length = sizeof(e->event);
 	e->event.user_data = user_data;
 
-	if (file_priv) {
-		ret = drm_event_reserve_init(dev, file_priv, &e->base,
-					     &e->event.base);
-		if (ret) {
-			kfree(e);
-			return NULL;
-		}
-	}
-
-	e->base.fence = fence;
-
 	return e;
 }
 
@@ -1601,6 +1661,206 @@ void drm_atomic_clean_old_fb(struct drm_device *dev,
 }
 EXPORT_SYMBOL(drm_atomic_clean_old_fb);
 
+/**
+ * DOC: explicit fencing properties
+ *
+ * Explicit fencing allows userspace to control the buffer synchronization
+ * between devices. A Fence or a group of fences are transfered to/from
+ * userspace using Sync File fds and there are two DRM properties for that.
+ * IN_FENCE_FD on each DRM Plane to send fences to the kernel and
+ * OUT_FENCE_PTR on each DRM CRTC to receive fences from the kernel.
+ *
+ * As a contrast, with implicit fencing the kernel keeps track of any
+ * ongoing rendering, and automatically ensures that the atomic update waits
+ * for any pending rendering to complete. For shared buffers represented with
+ * a struct &dma_buf this is tracked in &reservation_object structures.
+ * Implicit syncing is how Linux traditionally worked (e.g. DRI2/3 on X.org),
+ * whereas explicit fencing is what Android wants.
+ *
+ * "IN_FENCE_FD”:
+ *	Use this property to pass a fence that DRM should wait on before
+ *	proceeding with the Atomic Commit request and show the framebuffer for
+ *	the plane on the screen. The fence can be either a normal fence or a
+ *	merged one, the sync_file framework will handle both cases and use a
+ *	fence_array if a merged fence is received. Passing -1 here means no
+ *	fences to wait on.
+ *
+ *	If the Atomic Commit request has the DRM_MODE_ATOMIC_TEST_ONLY flag
+ *	it will only check if the Sync File is a valid one.
+ *
+ *	On the driver side the fence is stored on the @fence parameter of
+ *	struct &drm_plane_state. Drivers which also support implicit fencing
+ *	should set the implicit fence using drm_atomic_set_fence_for_plane(),
+ *	to make sure there's consistent behaviour between drivers in precedence
+ *	of implicit vs. explicit fencing.
+ *
+ * "OUT_FENCE_PTR”:
+ *	Use this property to pass a file descriptor pointer to DRM. Once the
+ *	Atomic Commit request call returns OUT_FENCE_PTR will be filled with
+ *	the file descriptor number of a Sync File. This Sync File contains the
+ *	CRTC fence that will be signaled when all framebuffers present on the
+ *	Atomic Commit * request for that given CRTC are scanned out on the
+ *	screen.
+ *
+ *	The Atomic Commit request fails if a invalid pointer is passed. If the
+ *	Atomic Commit request fails for any other reason the out fence fd
+ *	returned will be -1. On a Atomic Commit with the
+ *	DRM_MODE_ATOMIC_TEST_ONLY flag the out fence will also be set to -1.
+ *
+ *	Note that out-fences don't have a special interface to drivers and are
+ *	internally represented by a struct &drm_pending_vblank_event in struct
+ *	&drm_crtc_state, which is also used by the nonblocking atomic commit
+ *	helpers and for the DRM event handling for existing userspace.
+ */
+
+struct drm_out_fence_state {
+	s32 __user *out_fence_ptr;
+	struct sync_file *sync_file;
+	int fd;
+};
+
+static int setup_out_fence(struct drm_out_fence_state *fence_state,
+			   struct fence *fence)
+{
+	fence_state->fd = get_unused_fd_flags(O_CLOEXEC);
+	if (fence_state->fd < 0)
+		return fence_state->fd;
+
+	if (put_user(fence_state->fd, fence_state->out_fence_ptr))
+		return -EFAULT;
+
+	fence_state->sync_file = sync_file_create(fence);
+	if (!fence_state->sync_file)
+		return -ENOMEM;
+
+	return 0;
+}
+
+static int prepare_crtc_signaling(struct drm_device *dev,
+				  struct drm_atomic_state *state,
+				  struct drm_mode_atomic *arg,
+				  struct drm_file *file_priv,
+				  struct drm_out_fence_state **fence_state,
+				  unsigned int *num_fences)
+{
+	struct drm_crtc *crtc;
+	struct drm_crtc_state *crtc_state;
+	int i, ret;
+
+	if (arg->flags & DRM_MODE_ATOMIC_TEST_ONLY)
+		return 0;
+
+	for_each_crtc_in_state(state, crtc, crtc_state, i) {
+		s32 __user *fence_ptr;
+
+		fence_ptr = get_out_fence_for_crtc(crtc_state->state, crtc);
+
+		if (arg->flags & DRM_MODE_PAGE_FLIP_EVENT || fence_ptr) {
+			struct drm_pending_vblank_event *e;
+
+			e = create_vblank_event(dev, arg->user_data);
+			if (!e)
+				return -ENOMEM;
+
+			crtc_state->event = e;
+		}
+
+		if (arg->flags & DRM_MODE_PAGE_FLIP_EVENT) {
+			struct drm_pending_vblank_event *e = crtc_state->event;
+
+			if (!file_priv)
+				continue;
+
+			ret = drm_event_reserve_init(dev, file_priv, &e->base,
+						     &e->event.base);
+			if (ret) {
+				kfree(e);
+				crtc_state->event = NULL;
+				return ret;
+			}
+		}
+
+		if (fence_ptr) {
+			struct fence *fence;
+			struct drm_out_fence_state *f;
+
+			f = krealloc(*fence_state, sizeof(**fence_state) *
+				     (*num_fences + 1), GFP_KERNEL);
+			if (!f)
+				return -ENOMEM;
+
+			memset(&f[*num_fences], 0, sizeof(*f));
+
+			f[*num_fences].out_fence_ptr = fence_ptr;
+			*fence_state = f;
+
+			fence = drm_crtc_create_fence(crtc);
+			if (!fence)
+				return -ENOMEM;
+
+			ret = setup_out_fence(&f[(*num_fences)++], fence);
+			if (ret) {
+				fence_put(fence);
+				return ret;
+			}
+
+			crtc_state->event->base.fence = fence;
+		}
+	}
+
+	return 0;
+}
+
+static void complete_crtc_signaling(struct drm_device *dev,
+				    struct drm_atomic_state *state,
+				    struct drm_out_fence_state *fence_state,
+				    unsigned int num_fences,
+				    bool install_fds)
+{
+	struct drm_crtc *crtc;
+	struct drm_crtc_state *crtc_state;
+	int i;
+
+	if (install_fds) {
+		for (i = 0; i < num_fences; i++)
+			fd_install(fence_state[i].fd,
+				   fence_state[i].sync_file->file);
+
+		kfree(fence_state);
+		return;
+	}
+
+	for_each_crtc_in_state(state, crtc, crtc_state, i) {
+		struct drm_pending_vblank_event *event = crtc_state->event;
+		/*
+		 * Free the allocated event. drm_atomic_helper_setup_commit
+		 * can allocate an event too, so only free it if it's ours
+		 * to prevent a double free in drm_atomic_state_clear.
+		 */
+		if (event && (event->base.fence || event->base.file_priv)) {
+			drm_event_cancel_free(dev, &event->base);
+			crtc_state->event = NULL;
+		}
+	}
+
+	if (!fence_state)
+		return;
+
+	for (i = 0; i < num_fences; i++) {
+		if (fence_state[i].sync_file)
+			fput(fence_state[i].sync_file->file);
+		if (fence_state[i].fd >= 0)
+			put_unused_fd(fence_state[i].fd);
+
+		/* If this fails log error to the user */
+		if (fence_state[i].out_fence_ptr &&
+		    put_user(-1, fence_state[i].out_fence_ptr))
+			DRM_DEBUG_ATOMIC("Couldn't clear out_fence_ptr\n");
+	}
+
+	kfree(fence_state);
+}
+
 int drm_mode_atomic_ioctl(struct drm_device *dev,
 			  void *data, struct drm_file *file_priv)
 {
@@ -1613,11 +1873,10 @@ int drm_mode_atomic_ioctl(struct drm_device *dev,
 	struct drm_atomic_state *state;
 	struct drm_modeset_acquire_ctx ctx;
 	struct drm_plane *plane;
-	struct drm_crtc *crtc;
-	struct drm_crtc_state *crtc_state;
+	struct drm_out_fence_state *fence_state;
 	unsigned plane_mask;
 	int ret = 0;
-	unsigned int i, j;
+	unsigned int i, j, num_fences;
 
 	/* disallow for drivers not supporting atomic: */
 	if (!drm_core_check_feature(dev, DRIVER_ATOMIC))
@@ -1658,6 +1917,8 @@ int drm_mode_atomic_ioctl(struct drm_device *dev,
 	plane_mask = 0;
 	copied_objs = 0;
 	copied_props = 0;
+	fence_state = NULL;
+	num_fences = 0;
 
 	for (i = 0; i < arg->count_objs; i++) {
 		uint32_t obj_id, count_props;
@@ -1732,20 +1993,10 @@ int drm_mode_atomic_ioctl(struct drm_device *dev,
 		drm_mode_object_unreference(obj);
 	}
 
-	if (arg->flags & DRM_MODE_PAGE_FLIP_EVENT) {
-		for_each_crtc_in_state(state, crtc, crtc_state, i) {
-			struct drm_pending_vblank_event *e;
-
-			e = create_vblank_event(dev, file_priv, NULL,
-						arg->user_data);
-			if (!e) {
-				ret = -ENOMEM;
-				goto out;
-			}
-
-			crtc_state->event = e;
-		}
-	}
+	ret = prepare_crtc_signaling(dev, state, arg, file_priv, &fence_state,
+				     &num_fences);
+	if (ret)
+		goto out;
 
 	if (arg->flags & DRM_MODE_ATOMIC_TEST_ONLY) {
 		/*
@@ -1762,20 +2013,7 @@ int drm_mode_atomic_ioctl(struct drm_device *dev,
 out:
 	drm_atomic_clean_old_fb(dev, plane_mask, ret);
 
-	if (ret && arg->flags & DRM_MODE_PAGE_FLIP_EVENT) {
-		/*
-		 * Free the allocated event. drm_atomic_helper_setup_commit
-		 * can allocate an event too, so only free it if it's ours
-		 * to prevent a double free in drm_atomic_state_clear.
-		 */
-		for_each_crtc_in_state(state, crtc, crtc_state, i) {
-			struct drm_pending_vblank_event *event = crtc_state->event;
-			if (event && (event->base.fence || event->base.file_priv)) {
-				drm_event_cancel_free(dev, &event->base);
-				crtc_state->event = NULL;
-			}
-		}
-	}
+	complete_crtc_signaling(dev, state, fence_state, num_fences, !ret);
 
 	if (ret == -EDEADLK) {
 		drm_atomic_state_clear(state);
diff --git a/drivers/gpu/drm/drm_atomic_helper.c b/drivers/gpu/drm/drm_atomic_helper.c
index 50acd79..f34b4e8 100644
--- a/drivers/gpu/drm/drm_atomic_helper.c
+++ b/drivers/gpu/drm/drm_atomic_helper.c
@@ -3166,6 +3166,9 @@ void __drm_atomic_helper_plane_destroy_state(struct drm_plane_state *state)
 {
 	if (state->fb)
 		drm_framebuffer_unreference(state->fb);
+
+	if (state->fence)
+		fence_put(state->fence);
 }
 EXPORT_SYMBOL(__drm_atomic_helper_plane_destroy_state);
 
diff --git a/drivers/gpu/drm/drm_crtc.c b/drivers/gpu/drm/drm_crtc.c
index 2d7bedf..79b3d52 100644
--- a/drivers/gpu/drm/drm_crtc.c
+++ b/drivers/gpu/drm/drm_crtc.c
@@ -33,6 +33,7 @@
 #include <linux/list.h>
 #include <linux/slab.h>
 #include <linux/export.h>
+#include <linux/fence.h>
 #include <drm/drmP.h>
 #include <drm/drm_crtc.h>
 #include <drm/drm_edid.h>
@@ -141,6 +142,54 @@ static void drm_crtc_unregister_all(struct drm_device *dev)
 	}
 }
 
+static const struct fence_ops drm_crtc_fence_ops;
+
+static struct drm_crtc *fence_to_crtc(struct fence *fence)
+{
+	BUG_ON(fence->ops != &drm_crtc_fence_ops);
+	return container_of(fence->lock, struct drm_crtc, fence_lock);
+}
+
+static const char *drm_crtc_fence_get_driver_name(struct fence *fence)
+{
+	struct drm_crtc *crtc = fence_to_crtc(fence);
+
+	return crtc->dev->driver->name;
+}
+
+static const char *drm_crtc_fence_get_timeline_name(struct fence *fence)
+{
+	struct drm_crtc *crtc = fence_to_crtc(fence);
+
+	return crtc->timeline_name;
+}
+
+static bool drm_crtc_fence_enable_signaling(struct fence *fence)
+{
+	return true;
+}
+
+static const struct fence_ops drm_crtc_fence_ops = {
+	.get_driver_name = drm_crtc_fence_get_driver_name,
+	.get_timeline_name = drm_crtc_fence_get_timeline_name,
+	.enable_signaling = drm_crtc_fence_enable_signaling,
+	.wait = fence_default_wait,
+};
+
+struct fence *drm_crtc_create_fence(struct drm_crtc *crtc)
+{
+	struct fence *fence;
+
+	fence = kzalloc(sizeof(*fence), GFP_KERNEL);
+	if (!fence)
+		return NULL;
+
+	fence_init(fence, &drm_crtc_fence_ops, &crtc->fence_lock,
+		       crtc->fence_context, ++crtc->fence_seqno);
+
+	return fence;
+}
+
 /**
  * drm_crtc_init_with_planes - Initialise a new CRTC object with
  *    specified primary and cursor planes.
@@ -198,6 +247,11 @@ int drm_crtc_init_with_planes(struct drm_device *dev, struct drm_crtc *crtc,
 		return -ENOMEM;
 	}
 
+	crtc->fence_context = fence_context_alloc(1);
+	spin_lock_init(&crtc->fence_lock);
+	snprintf(crtc->timeline_name, sizeof(crtc->timeline_name),
+		 "CRTC:%d-%s", crtc->base.id, crtc->name);
+
 	crtc->base.properties = &crtc->properties;
 
 	list_add_tail(&crtc->head, &config->crtc_list);
@@ -213,6 +267,8 @@ int drm_crtc_init_with_planes(struct drm_device *dev, struct drm_crtc *crtc,
 	if (drm_core_check_feature(dev, DRIVER_ATOMIC)) {
 		drm_object_attach_property(&crtc->base, config->prop_active, 0);
 		drm_object_attach_property(&crtc->base, config->prop_mode_id, 0);
+		drm_object_attach_property(&crtc->base,
+					   config->prop_out_fence_ptr, 0);
 	}
 
 	return 0;
@@ -365,6 +421,18 @@ static int drm_mode_create_standard_properties(struct drm_device *dev)
 		return -ENOMEM;
 	dev->mode_config.prop_fb_id = prop;
 
+	prop = drm_property_create_signed_range(dev, DRM_MODE_PROP_ATOMIC,
+			"IN_FENCE_FD", -1, INT_MAX);
+	if (!prop)
+		return -ENOMEM;
+	dev->mode_config.prop_in_fence_fd = prop;
+
+	prop = drm_property_create_range(dev, DRM_MODE_PROP_ATOMIC,
+			"OUT_FENCE_PTR", 0, U64_MAX);
+	if (!prop)
+		return -ENOMEM;
+	dev->mode_config.prop_out_fence_ptr = prop;
+
 	prop = drm_property_create_object(dev, DRM_MODE_PROP_ATOMIC,
 			"CRTC_ID", DRM_MODE_OBJECT_CRTC);
 	if (!prop)
diff --git a/drivers/gpu/drm/drm_crtc_internal.h b/drivers/gpu/drm/drm_crtc_internal.h
index c48ba02..df2b51a 100644
--- a/drivers/gpu/drm/drm_crtc_internal.h
+++ b/drivers/gpu/drm/drm_crtc_internal.h
@@ -41,6 +41,8 @@ int drm_crtc_check_viewport(const struct drm_crtc *crtc,
 			    const struct drm_display_mode *mode,
 			    const struct drm_framebuffer *fb);
 
+struct fence *drm_crtc_create_fence(struct drm_crtc *crtc);
+
 void drm_fb_release(struct drm_file *file_priv);
 
 /* dumb buffer support IOCTLs */
diff --git a/drivers/gpu/drm/drm_fb_cma_helper.c b/drivers/gpu/drm/drm_fb_cma_helper.c
index 1fd6eac..52629b6 100644
--- a/drivers/gpu/drm/drm_fb_cma_helper.c
+++ b/drivers/gpu/drm/drm_fb_cma_helper.c
@@ -18,13 +18,16 @@
  */
 
 #include <drm/drmP.h>
+#include <drm/drm_atomic.h>
 #include <drm/drm_crtc.h>
 #include <drm/drm_fb_helper.h>
 #include <drm/drm_crtc_helper.h>
 #include <drm/drm_gem_cma_helper.h>
 #include <drm/drm_fb_cma_helper.h>
+#include <linux/dma-buf.h>
 #include <linux/dma-mapping.h>
 #include <linux/module.h>
+#include <linux/reservation.h>
 
 #define DEFAULT_FBDEFIO_DELAY_MS 50
 
@@ -265,6 +268,38 @@ struct drm_gem_cma_object *drm_fb_cma_get_gem_obj(struct drm_framebuffer *fb,
 }
 EXPORT_SYMBOL_GPL(drm_fb_cma_get_gem_obj);
 
+/**
+ * drm_fb_cma_prepare_fb() - Prepare CMA framebuffer
+ * @plane: Which plane
+ * @state: Plane state attach fence to
+ *
+ * This should be put into prepare_fb hook of struct &drm_plane_helper_funcs .
+ *
+ * This function checks if the plane FB has an dma-buf attached, extracts
+ * the exclusive fence and attaches it to plane state for the atomic helper
+ * to wait on.
+ *
+ * There is no need for cleanup_fb for CMA based framebuffer drivers.
+ */
+int drm_fb_cma_prepare_fb(struct drm_plane *plane,
+			  struct drm_plane_state *state)
+{
+	struct dma_buf *dma_buf;
+	struct fence *fence;
+
+	if ((plane->state->fb == state->fb) || !state->fb)
+		return 0;
+
+	dma_buf = drm_fb_cma_get_gem_obj(state->fb, 0)->base.dma_buf;
+	if (dma_buf) {
+		fence = reservation_object_get_excl_rcu(dma_buf->resv);
+		drm_atomic_set_fence_for_plane(state, fence);
+	}
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(drm_fb_cma_prepare_fb);
+
 #ifdef CONFIG_DEBUG_FS
 static void drm_fb_cma_describe(struct drm_framebuffer *fb, struct seq_file *m)
 {
diff --git a/drivers/gpu/drm/drm_fops.c b/drivers/gpu/drm/drm_fops.c
index c37b7b5..129b80b 100644
--- a/drivers/gpu/drm/drm_fops.c
+++ b/drivers/gpu/drm/drm_fops.c
@@ -664,6 +664,10 @@ void drm_event_cancel_free(struct drm_device *dev,
 		list_del(&p->pending_link);
 	}
 	spin_unlock_irqrestore(&dev->event_lock, flags);
+
+	if (p->fence)
+		fence_put(p->fence);
+
 	kfree(p);
 }
 EXPORT_SYMBOL(drm_event_cancel_free);
diff --git a/drivers/gpu/drm/drm_plane.c b/drivers/gpu/drm/drm_plane.c
index 249c0ae..3957ef8 100644
--- a/drivers/gpu/drm/drm_plane.c
+++ b/drivers/gpu/drm/drm_plane.c
@@ -137,6 +137,7 @@ int drm_universal_plane_init(struct drm_device *dev, struct drm_plane *plane,
 
 	if (drm_core_check_feature(dev, DRIVER_ATOMIC)) {
 		drm_object_attach_property(&plane->base, config->prop_fb_id, 0);
+		drm_object_attach_property(&plane->base, config->prop_in_fence_fd, -1);
 		drm_object_attach_property(&plane->base, config->prop_crtc_id, 0);
 		drm_object_attach_property(&plane->base, config->prop_crtc_x, 0);
 		drm_object_attach_property(&plane->base, config->prop_crtc_y, 0);
diff --git a/drivers/gpu/drm/msm/mdp/mdp5/mdp5_plane.c b/drivers/gpu/drm/msm/mdp/mdp5/mdp5_plane.c
index 83bf997..5e67e8b 100644
--- a/drivers/gpu/drm/msm/mdp/mdp5/mdp5_plane.c
+++ b/drivers/gpu/drm/msm/mdp/mdp5/mdp5_plane.c
@@ -218,9 +218,10 @@ static void mdp5_plane_reset(struct drm_plane *plane)
 
 	mdp5_state = kmemdup(to_mdp5_plane_state(plane->state),
 			sizeof(*mdp5_state), GFP_KERNEL);
+	if (!mdp5_state)
+		return NULL;
 
-	if (mdp5_state && mdp5_state->base.fb)
-		drm_framebuffer_reference(mdp5_state->base.fb);
+	__drm_atomic_helper_plane_duplicate_state(plane, &mdp5_state->base);
 
 	mdp5_state->mode_changed = false;
 	mdp5_state->pending = false;
diff --git a/drivers/gpu/drm/rtk/Kconfig b/drivers/gpu/drm/rtk/Kconfig
new file mode 100644
index 00000000..090f3cb
--- /dev/null
+++ b/drivers/gpu/drm/rtk/Kconfig
@@ -0,0 +1,10 @@
+config DRM_RTK
+	tristate "DRM Support for RTK display"
+	depends on DRM
+	select DRM_KMS_HELPER
+    select DRM_KMS_FB_HELPER
+    select DRM_KMS_CMA_HELPER
+    select FB_RTK
+	help
+	  Choose this option for DRM support for the RTK display.
+	  If M is selected the module will be called rtk_drm.
diff --git a/drivers/gpu/drm/rtk/Makefile b/drivers/gpu/drm/rtk/Makefile
new file mode 100644
index 00000000..4a2dae7
--- /dev/null
+++ b/drivers/gpu/drm/rtk/Makefile
@@ -0,0 +1,14 @@
+ccflags-y := -Iinclude/drm -Werror
+
+rtk_drm-y := rtk_drm_connector.o \
+    rtk_drm_crtc.o \
+	rtk_drm_device.o \
+	rtk_drm_encoder.o \
+	rtk_drm_drv.o \
+	rtk_drm_platform.o \
+	rtk_drm_suspend.o \
+	rtk_gem_ion.o \
+	rtk_drm_fb_ion.o \
+	rtk_drm_plane.o
+
+obj-$(CONFIG_DRM_RTK) += rtk_drm.o
diff --git a/drivers/gpu/drm/rtk/rtk_drm.h b/drivers/gpu/drm/rtk/rtk_drm.h
new file mode 100644
index 00000000..bf6b2d2
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm.h
@@ -0,0 +1,131 @@
+/*
+ *
+ * (C) COPYRIGHT 2012-2013 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+#ifndef _RTK_DRM_H_
+#define _RTK_DRM_H_
+
+#include <drm/drm_gem.h>
+#include <drm/drm_plane_helper.h>
+#include <drm/drm_fb_helper.h>
+#include <linux/kthread.h>
+
+#include "rtk_drm_fb_ion.h"
+#include "../../../video/fbdev/rtk/rtk_fb.h"
+
+#include "../../../staging/android/ion/ion.h"
+#include "../../../staging/android/uapi/ion_rtk.h"
+extern struct ion_device *rtk_phoenix_ion_device;
+
+#define DRIVER_AUTHOR    "Realtek"
+#define DRIVER_NAME      "rtk_drm"
+#define DRIVER_DESC      "DRM module for RTK"
+#define DRIVER_LICENCE   "GPL"
+#define DRIVER_ALIAS     "platform:rtk_drm"
+#define DRIVER_DATE      "20170207"
+#define DRIVER_VERSION   "1.0"
+#define DRIVER_MAJOR      1
+#define DRIVER_MINOR      5
+#define DRIVER_PATCHLEVEL 0
+
+/*
+ * Number of flips allowed in flight at any one time. Any more flips requested
+ * beyond this value will cause the caller to block until earlier flips have
+ * completed.
+ *
+ * For performance reasons, this must be greater than the number of buffers
+ * used in the rendering pipeline. Note that the rendering pipeline can contain
+ * different types of buffer, e.g.:
+ * - 2 final framebuffers
+ * - >2 geometry buffers for GPU use-cases
+ * - >2 vertex buffers for GPU use-cases
+ *
+ * For example, a system using 5 geometry buffers could have 5 flips in flight,
+ * and so NR_FLIPS_IN_FLIGHT_THRESHOLD must be 5 or greater.
+ *
+ * Whilst there may be more intermediate buffers (such as vertex/geometry) than
+ * final framebuffers, KDS is used to ensure that GPU rendering waits for the
+ * next off-screen buffer, so it doesn't overwrite an on-screen buffer and
+ * produce tearing.
+ */
+
+/*
+ * Here, we choose a conservative value. A lower value is most likely
+ * suitable for GPU use-cases.
+ */
+//#define NR_FLIPS_IN_FLIGHT_THRESHOLD 16
+
+#define CLCD_IRQ_NEXTBASE_UPDATE (1u<<2)
+
+// Parameters for different buffer objects and type:
+
+//#define RTK_USE_FBHELPER
+
+#define PAGE_FLIP_ALING_WITH_VBLANK
+
+struct rtk_drm_plane {
+    struct drm_plane base;
+};
+
+struct rtk_drm_plane_state {
+    struct drm_plane_state base;
+};
+
+struct rtk_drm_planes {
+    struct rtk_drm_plane *primary;
+};
+
+struct rtk_drm_crtc {
+    struct drm_crtc base;
+    int crtc_index;
+    struct drm_display_mode *new_mode;
+    struct drm_display_mode *current_mode;
+    bool vblank_en;
+    struct drm_pending_vblank_event *event;
+
+    struct list_head      swap_list;
+    struct mutex          swap_lock;
+    struct task_struct *  swap_thread;
+    struct kthread_work   swap_work;
+    struct kthread_worker swap_worker;
+};
+
+struct rtk_drm_connector {
+    struct drm_connector base;
+};
+
+struct rtk_drm_encoder {
+    struct drm_encoder base;
+};
+
+struct rtk_drm_private {
+    struct rtk_drm_crtc *      rtk_crtc;
+    struct drm_gem_object *    fbdev_bo;
+    struct rtk_drm_planes *    planes;
+    struct rtk_drm_connector * connector;
+    struct rtk_drm_encoder *   encoder;
+#ifdef RTK_USE_FBHELPER
+    struct drm_fbdev_ion *     fbhelper;
+#endif
+    struct task_struct *       vblank_task;
+};
+
+#define RTK_CRTC_FROM_CRTC(x)               (container_of(x, struct rtk_drm_crtc, base))
+#define RTK_ENCODER_FROM_ENCODER(x)         (container_of(x, struct rtk_drm_encoder, base))
+#define RTK_CONNECTOR_FROM_CONNECTOR(x)     (container_of(x, struct rtk_drm_connector, base))
+#define RTK_PLANE_FROM_PLANE(x)             (container_of(x, struct rtk_drm_plane, base))
+
+#include "rtk_drm_funcs.h"
+
+#endif /* _RTK_DRM_H_ */
diff --git a/drivers/gpu/drm/rtk/rtk_drm_connector.c b/drivers/gpu/drm/rtk/rtk_drm_connector.c
new file mode 100644
index 00000000..5ff9fff
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_connector.c
@@ -0,0 +1,245 @@
+/*
+ *
+ * (C) COPYRIGHT 2012-2013 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+/**
+ * rtk_drm_connector.c
+ * Implementation of the connector functions for RTK DRM
+ */
+#include <linux/version.h>
+#include <linux/shmem_fs.h>
+#include <linux/dma-buf.h>
+#include <linux/module.h>
+
+#include <drm/drmP.h>
+#include <drm/drm_atomic.h>
+#include <drm/drm_crtc_helper.h>
+#include <drm/drm_atomic_helper.h>
+#include <drm/drm_edid.h>
+#include "../drm_internal.h"
+#include "rtk_drm.h"
+#include "../../../media/platform/rtk_hdmitx/hdmitx_dev.h"
+
+void rtk_connector_destroy(struct drm_connector *connector)
+{
+    struct rtk_drm_connector *rtk_connector =
+        RTK_CONNECTOR_FROM_CONNECTOR(connector);
+
+    DRM_DEBUG_KMS("DRM %s on connector=%p\n", __func__, connector);
+
+    drm_connector_unreference(connector);
+    drm_connector_unregister(connector);
+    drm_connector_cleanup(connector);
+    kfree(rtk_connector);
+}
+
+enum drm_connector_status rtk_connector_detect(struct drm_connector
+        *connector, bool force)
+{
+    enum drm_connector_status status;
+
+    DRM_DEBUG_KMS("DRM %s on connector=%p\n", __func__, connector);
+
+#if 1
+    status = connector_status_connected;
+    drm_connector_reference(connector);
+#else
+    if (hdmitx_switch_get_state())
+        status = connector_status_connected;
+    else
+        status = connector_status_disconnected;
+#endif
+
+    return status;
+}
+
+void rtk_connector_dpms(struct drm_connector *connector, int mode)
+{
+    DRM_DEBUG_KMS("DRM %s on connector=%p\n", __func__, connector);
+}
+
+struct drm_encoder *
+rtk_connector_helper_best_encoder(struct drm_connector *connector)
+{
+    DRM_DEBUG_KMS("DRM %s on connector=%p\n", __func__, connector);
+
+    if (connector->encoder != NULL) {
+        return connector->encoder; /* Return attached encoder */
+    } else {
+        /*
+         * If there is no attached encoder we choose the best candidate
+         * from the list.
+         * For RTK there is only one encoder so we return the first
+         * one we find.
+         * Other h/w would require a suitable criterion below.
+         */
+        struct drm_encoder *encoder = NULL;
+        struct drm_device *dev = connector->dev;
+
+        list_for_each_entry(encoder, &dev->mode_config.encoder_list,
+                head) {
+            if (1) { /* criterion ? */
+                break;
+            }
+        }
+        return encoder; /* return best candidate encoder */
+    }
+}
+
+static struct {
+       int w, h, type;
+} rtk_drm_modes[] = {
+       {1920, 1080,  DRM_MODE_TYPE_PREFERRED},
+       {  -1,  -1, -1}
+};
+
+
+int rtk_connector_helper_get_modes(struct drm_connector *connector)
+{
+    int count = 0;
+    struct drm_connector_state *state = connector->state;
+
+#if 0
+    struct i2c_adapter *p_adap = NULL;
+    unsigned char bus_id= 1;
+    struct edid *edid;
+
+    if ((p_adap = i2c_get_adapter(bus_id)) != NULL) {
+        edid = drm_get_edid(connector, p_adap);
+        if (edid) {
+            count = drm_add_edid_modes(connector, edid);
+            drm_mode_connector_update_edid_property(connector, edid);
+            kfree(edid);
+        }
+    }
+#else
+    unsigned char* hdmitx_edid;
+
+    hdmitx_edid = kmalloc(2 * EDID_LENGTH, GFP_KERNEL);
+    if (hdmitx_edid != NULL) {
+        if (!hdmitx_get_raw_edid(hdmitx_edid)) {
+            DRM_DEBUG_KMS("hdmitx_get_raw_edid success\n");
+            count = drm_add_edid_modes(connector, (struct edid *)hdmitx_edid);
+            drm_mode_connector_update_edid_property(connector, (struct edid *)hdmitx_edid);
+        } else {
+            pr_err("hdmitx_get_raw_edid failed\n");
+        }
+        kfree(hdmitx_edid);
+    } else {
+        pr_err("alloc hdmitx_edid block failed\n");
+    }
+#endif
+
+    if (state != NULL) {
+        if (connector->encoder != NULL) {
+            //DRM_DEBUG_KMS("[DRM] %s %d set drm_connector_state encoder %p\n", __FUNCTION__, __LINE__, connector->encoder);
+            state->best_encoder = connector->encoder;
+            if (connector->encoder->crtc != NULL) {
+                //DRM_DEBUG_KMS("[DRM] %s %d drm_connector_state crtc %p\n", __FUNCTION__, __LINE__, connector->encoder->crtc);
+                state->crtc = connector->encoder->crtc;
+            }
+        }
+    }
+
+    if (count == 0) {
+        /* default */
+        int i = 0;
+        while (rtk_drm_modes[i].w != -1) {
+            struct drm_display_mode *mode =
+                drm_mode_find_dmt(connector->dev,
+                        rtk_drm_modes[i].w,
+                        rtk_drm_modes[i].h,
+                        60 , false);
+
+            if (mode != NULL) {
+                mode->type |= rtk_drm_modes[i].type;
+                drm_mode_probed_add(connector, mode);
+                count++;
+            }
+
+            i++;
+        }
+       DRM_DEBUG_KMS("found %d modes\n", count);
+
+    }
+    return count;
+}
+
+int rtk_connector_helper_mode_valid(struct drm_connector *connector,
+        struct drm_display_mode *mode)
+{
+    DRM_DEBUG_KMS("DRM %s on connector=%p\n", __func__, connector);
+    return MODE_OK;
+}
+
+const struct drm_connector_funcs connector_funcs = {
+    //.dpms                   = rtk_connector_dpms,
+    .dpms                   = drm_atomic_helper_connector_dpms,
+    .detect                 = rtk_connector_detect,
+    .fill_modes             = drm_helper_probe_single_connector_modes,
+    .destroy                = rtk_connector_destroy,
+    .reset                  = drm_atomic_helper_connector_reset,
+    .atomic_duplicate_state = drm_atomic_helper_connector_duplicate_state,
+    .atomic_destroy_state   = drm_atomic_helper_connector_destroy_state,
+};
+
+const struct drm_connector_helper_funcs connector_helper_funcs = {
+    .get_modes              = rtk_connector_helper_get_modes,
+    .mode_valid             = rtk_connector_helper_mode_valid,
+    .best_encoder           = rtk_connector_helper_best_encoder,
+};
+
+struct rtk_drm_connector *rtk_connector_create(struct drm_device *dev)
+{
+    struct rtk_drm_connector *rtk_connector;
+    struct drm_connector *connector;
+    int ret = 0;
+    rtk_connector = kzalloc(sizeof(struct rtk_drm_connector), GFP_KERNEL);
+
+    if (rtk_connector == NULL) {
+        pr_err("Failed to allocated rtk_drm_connector\n");
+        return NULL;
+    }
+
+    pr_info("DRM %s %d\n", __func__, __LINE__);
+    connector = &rtk_connector->base;
+
+    connector->display_info.width_mm    = 1920;
+    connector->display_info.height_mm   = 1080;
+    connector->interlace_allowed        = true;
+    connector->doublescan_allowed       = false;
+    connector->stereo_allowed           = false; //3D mode flags
+    connector->polled                   = DRM_CONNECTOR_POLL_HPD;
+
+    ret = drm_connector_init(dev, connector, &connector_funcs, DRM_MODE_CONNECTOR_HDMIA);
+    if (ret < 0) {
+        DRM_DEBUG_KMS("DRM connector_init failed\n");
+        kfree(rtk_connector);
+        return NULL;
+    }
+
+    drm_connector_helper_add(connector, &connector_helper_funcs);
+    ret = drm_connector_register(connector);
+    if (ret < 0) {
+        DRM_DEBUG_KMS("DRM connector_init failed\n");
+        kfree(rtk_connector);
+        return NULL;
+    }
+
+    connector->dpms = DRM_MODE_DPMS_OFF;
+
+    return rtk_connector;
+}
diff --git a/drivers/gpu/drm/rtk/rtk_drm_crtc.c b/drivers/gpu/drm/rtk/rtk_drm_crtc.c
new file mode 100644
index 00000000..6543bce
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_crtc.c
@@ -0,0 +1,369 @@
+/*
+ *
+ * (C) COPYRIGHT 2012-2014 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+/**
+ * rtk_drm_crtc.c
+ * Implementation of the CRTC functions for RTK DRM
+ */
+#include <linux/version.h>
+#include <linux/shmem_fs.h>
+#include <linux/dma-buf.h>
+#include <linux/module.h>
+
+#include <drm/drmP.h>
+#include <drm/drm_crtc_helper.h>
+#include <drm/drm_atomic_helper.h>
+
+#include "rtk_drm.h"
+
+#include "../../../drivers/dma-buf/sync_debug.h"
+#include "../../../video/fbdev/rtk/dc2vo/dc2vo.h"
+
+#include "rtk_gem_ion.h"
+#include "rtk_drm_fb_ion.h"
+
+#define RTK_CRTC_SWAP_SHORT_FENCE_TIMEOUT_MS    (60)
+#define RTK_CRTC_SWAP_LONG_FENCE_TIMEOUT_MS     (-1)
+
+struct rtk_crtc_swap_post {
+    struct list_head        head;
+    struct sync_file *     fence;
+    struct drm_framebuffer *fb;
+    struct rtk_drm_crtc *   rtk_crtc;
+    struct drm_pending_vblank_event *event;
+};
+
+static void rtk_crtc_swap_post_cleanup(struct rtk_crtc_swap_post * cfg)
+{
+    if (cfg == NULL)
+        return;
+    if (cfg->fence)
+        fput(cfg->fence->file);
+    kfree(cfg);
+}
+
+static void rtk_crtc_swap_post_release(struct rtk_crtc_swap_post * cfg)
+{
+    if (cfg == NULL)
+        return;
+
+    if (cfg->fence) {
+        int err = fence_wait_timeout(cfg->fence->fence, 1, RTK_CRTC_SWAP_SHORT_FENCE_TIMEOUT_MS);
+        if (err == -ETIME) {
+            DRM_ERROR("DRM %s:%d fence %p\n", __FUNCTION__, __LINE__, cfg->fence);
+            err = fence_wait_timeout(cfg->fence->fence, 1, RTK_CRTC_SWAP_SHORT_FENCE_TIMEOUT_MS);
+        }
+        if (err < 0)
+            DRM_ERROR("DRM %s:%d fence %p\n", __FUNCTION__, __LINE__, cfg->fence);
+    }
+
+    if (cfg->event) {
+        struct rtk_drm_crtc * rtk_crtc = cfg->rtk_crtc;
+        struct drm_device *     dev         = rtk_crtc->base.dev;
+        unsigned long flags;
+
+        spin_lock_irqsave(&dev->event_lock, flags);
+        drm_crtc_vblank_get(&rtk_crtc->base);
+        drm_crtc_send_vblank_event(&rtk_crtc->base, cfg->event);
+        drm_crtc_vblank_put(&rtk_crtc->base);
+        spin_unlock_irqrestore(&dev->event_lock, flags);
+        cfg->event = NULL;
+    }
+
+    if (cfg->fb) {
+        struct rtk_gem_ion_object * ion_obj = drm_fb_ion_get_gem_obj(cfg->fb,0);
+        drm_framebuffer_unreference(cfg->fb);
+        if (ion_obj)
+            drm_gem_object_unreference_unlocked(&ion_obj->base);
+    }
+#if 0
+    {
+        struct rtk_drm_crtc * rtk_crtc = cfg->rtk_crtc;
+        if (rtk_crtc->vblank_en) {
+            rtk_crtc->event = cfg->event;
+        }
+    }
+#endif
+    return rtk_crtc_swap_post_cleanup(cfg);
+}
+
+struct rtk_crtc_swap_post * rtk_crtc_swap_post_create(
+        struct drm_framebuffer *fb, struct sync_file * fence, struct rtk_drm_crtc *rtk_crtc,
+        struct drm_pending_vblank_event *event)
+{
+    struct rtk_crtc_swap_post * cfg = kzalloc(sizeof(*cfg), GFP_KERNEL);
+    INIT_LIST_HEAD(&cfg->head);
+    cfg->fence  = fence;
+    cfg->fb     = fb;
+    cfg->rtk_crtc = rtk_crtc;
+    cfg->event = event;
+    return cfg;
+}
+
+static int rtk_crtc_swap_post_to_worker(struct drm_crtc *crtc, struct drm_framebuffer *fb,
+        struct drm_pending_vblank_event *event)
+{
+    struct rtk_drm_crtc *rtk_crtc = RTK_CRTC_FROM_CRTC(crtc);
+    struct rtk_crtc_swap_post * cfg = NULL;
+    struct sync_file * fence = NULL;
+
+    {
+        struct rtk_gem_ion_object * ion_obj = drm_fb_ion_get_gem_obj(fb,0);
+        struct dc_buffer buf;
+        memset(&buf, 0, sizeof(buf));
+        buf.id                          = eUserBuffer;
+        buf.overlay_engine              = eEngine_VO;
+        buf.phyAddr                     = ion_obj->paddr;
+        //buf.format                      = xxxxxxxxxx;
+        buf.width                       = fb->width;
+        buf.height                      = fb->height;
+        buf.stride                      = ((fb->width * fb->bits_per_pixel) + 7)/8;
+        buf.acquire.fence               = (struct sync_file *) 0;
+        if (fb->pixel_format == DRM_FORMAT_XRGB8888) {
+            buf.flags |= eBuffer_USE_GLOBAL_ALPHA;
+            buf.alpha = 0xff;
+        }
+
+        fence = DC_QueueBuffer(&buf);
+    }
+
+    //DRM_DEBUG_KMS("[%s:%d] [%d x %d] bits_per_pixel = %d\n", __func__, __LINE__, fb->width, fb->height, fb->bits_per_pixel);
+
+    if (fence == NULL)
+        return -1;
+    cfg = rtk_crtc_swap_post_create(fb, fence, rtk_crtc, event);
+
+    if (cfg == NULL) {
+        fput(fence->file);
+        return -1;
+    }
+
+    if (fb) {
+        struct rtk_gem_ion_object * ion_obj = drm_fb_ion_get_gem_obj(fb,0);
+        if (ion_obj)
+            drm_gem_object_reference(&ion_obj->base);
+        drm_framebuffer_reference(fb);
+    }
+
+    mutex_lock(&rtk_crtc->swap_lock);
+    list_add_tail(&cfg->head, &rtk_crtc->swap_list);
+    kthread_queue_work(&rtk_crtc->swap_worker, &rtk_crtc->swap_work);
+    mutex_unlock(&rtk_crtc->swap_lock);
+
+    return 0;
+}
+
+static int show_framebuffer_on_crtc(struct drm_crtc *crtc,
+        struct drm_framebuffer *fb,
+        struct drm_pending_vblank_event *event)
+{
+    crtc->primary->fb = fb;
+    if (rtk_crtc_swap_post_to_worker(crtc, fb, event) != 0) {
+        pr_err("DRM %s:%d rtk_crtc_swap_post_to_worker return error!", __FUNCTION__, __LINE__);
+        drm_framebuffer_reference(fb);
+        return -1;
+    }
+    DRM_DEBUG_KMS("DRM %s %d", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+static int rtk_crtc_page_flip(struct drm_crtc *crtc, struct drm_framebuffer *fb,
+        struct drm_pending_vblank_event *event,
+        uint32_t flags)
+{
+    DRM_DEBUG_KMS("DRM %s: crtc=%p, fb=%p, event=%p\n", __func__, crtc, fb, event);
+    //return drm_atomic_helper_page_flip(crtc, fb, event, flags);
+    return show_framebuffer_on_crtc(crtc, fb, event);
+}
+
+void rtk_crtc_finish_page_flip(struct rtk_drm_crtc *rtk_crtc)
+{
+    struct drm_device *dev = rtk_crtc->base.dev;
+    unsigned long flags;
+
+    spin_lock_irqsave(&dev->event_lock, flags);
+
+    if (rtk_crtc->event) {
+        //drm_vblank_get(dev, rtk_crtc->crtc_index);
+        //drm_send_vblank_event(dev, rtk_crtc->crtc_index, rtk_crtc->event);
+        //drm_vblank_put(dev, rtk_crtc->crtc_index);
+
+        drm_crtc_vblank_get(&rtk_crtc->base);
+        drm_crtc_send_vblank_event(&rtk_crtc->base, rtk_crtc->event);
+        drm_crtc_vblank_put(&rtk_crtc->base);
+        rtk_crtc->event = NULL;
+    }
+    spin_unlock_irqrestore(&dev->event_lock, flags);
+}
+
+#if 1
+static void rtk_crtc_atomic_begin(struct drm_crtc *crtc, struct drm_crtc_state *old_crtc_state)
+{
+    struct rtk_drm_crtc *rtk_crtc = RTK_CRTC_FROM_CRTC(crtc);
+
+    if (crtc->state->event) {
+         crtc->state->event->pipe = drm_crtc_index(crtc);
+         WARN_ON(drm_crtc_vblank_get(crtc) != 0);
+         rtk_crtc->event = crtc->state->event;
+         crtc->state->event = NULL;
+    }
+}
+
+static void rtk_crtc_atomic_flush(struct drm_crtc *crtc, struct drm_crtc_state *old_crtc_state)
+{
+/* TODO: write common plane control register if available */
+}
+#endif
+
+__maybe_unused static int rtk_crtc_helper_mode_set(struct drm_crtc *crtc,
+        struct drm_display_mode *mode,
+        struct drm_display_mode *adjusted_mode,
+        int x, int y, struct drm_framebuffer *old_fb)
+{
+    pr_info("DRM %s %d", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+static void rtk_crtc_helper_prepare(struct drm_crtc *crtc)
+{
+    DRM_DEBUG_KMS("DRM %s on crtc=%p\n", __func__, crtc);
+}
+
+static void rtk_crtc_helper_commit(struct drm_crtc *crtc)
+{
+    struct rtk_drm_crtc *rtk_crtc = RTK_CRTC_FROM_CRTC(crtc);
+    DRM_DEBUG_KMS("DRM %s on crtc=%p\n", __func__, crtc);
+    rtk_crtc->vblank_en = true;
+    drm_crtc_vblank_on(crtc);
+}
+
+void rtk_crtc_pending_vblank(struct drm_crtc *crtc, struct drm_file *file_priv)
+{
+    struct rtk_drm_crtc *rtk_crtc = RTK_CRTC_FROM_CRTC(crtc);
+    if (rtk_crtc->swap_thread) {
+        kthread_flush_worker(&rtk_crtc->swap_worker);
+    }
+}
+
+static bool rtk_crtc_helper_mode_fixup(struct drm_crtc *crtc,
+        const struct drm_display_mode *mode,
+        struct drm_display_mode *adjusted_mode)
+{
+    struct rtk_drm_crtc *rtk_crtc = RTK_CRTC_FROM_CRTC(crtc);
+    DRM_DEBUG_KMS("DRM %s on crtc=%p\n", __func__, crtc);
+    if (rtk_crtc->swap_thread) {
+        kthread_flush_worker(&rtk_crtc->swap_worker);
+    }
+    rtk_crtc->vblank_en = false;
+    //drm_crtc_vblank_off(crtc);
+    return true;
+}
+
+static void rtk_crtc_helper_disable(struct drm_crtc *crtc)
+{
+    DRM_DEBUG_KMS("DRM %s on crtc=%p\n", __func__, crtc);
+    //clcd_disable(crtc);
+}
+
+static void rtk_crtc_destroy(struct drm_crtc *crtc)
+{
+    struct rtk_drm_crtc *rtk_crtc = RTK_CRTC_FROM_CRTC(crtc);
+
+    DRM_DEBUG_KMS("DRM %s on crtc=%p\n", __func__, crtc);
+
+
+    if (rtk_crtc->swap_thread) {
+        kthread_flush_worker(&rtk_crtc->swap_worker);
+        kthread_stop(rtk_crtc->swap_thread);
+    }
+    drm_crtc_cleanup(crtc);
+    kfree(rtk_crtc);
+}
+
+static void rtk_crtc_mode_set_nofb(struct drm_crtc *crtc)
+{
+    DRM_DEBUG_KMS("DRM %s on crtc=%p\n", __func__, crtc);
+}
+
+const struct drm_crtc_funcs rtk_crtc_funcs = {
+    .cursor_set             = NULL,
+    .cursor_move            = NULL,
+    .set_config             = drm_atomic_helper_set_config,
+    .page_flip              = rtk_crtc_page_flip,
+    .destroy                = rtk_crtc_destroy,
+    .reset                  = drm_atomic_helper_crtc_reset,
+    .atomic_duplicate_state = drm_atomic_helper_crtc_duplicate_state,
+    .atomic_destroy_state   = drm_atomic_helper_crtc_destroy_state,
+};
+
+const struct drm_crtc_helper_funcs crtc_helper_funcs = {
+    .mode_set           = drm_helper_crtc_mode_set, //rtk_crtc_helper_mode_set
+    .prepare            = rtk_crtc_helper_prepare,
+    .commit             = rtk_crtc_helper_commit,
+    .mode_fixup         = rtk_crtc_helper_mode_fixup,
+    .disable            = rtk_crtc_helper_disable,
+    .mode_set_nofb      = rtk_crtc_mode_set_nofb,
+    .mode_set_base      = drm_helper_crtc_mode_set_base,
+    .atomic_begin       = rtk_crtc_atomic_begin,
+    .atomic_flush       = rtk_crtc_atomic_flush,
+};
+
+static void rtk_crtc_swap_work_func(struct kthread_work *work)
+{
+    struct rtk_drm_crtc *rtk_crtc = container_of(work, struct rtk_drm_crtc, swap_work);
+    struct rtk_crtc_swap_post *post, *next;
+    struct list_head saved_list;
+
+    mutex_lock(&rtk_crtc->swap_lock);
+    memcpy(&saved_list, &rtk_crtc->swap_list, sizeof(saved_list));
+    list_replace_init(&rtk_crtc->swap_list, &saved_list);
+    mutex_unlock(&rtk_crtc->swap_lock);
+    list_for_each_entry_safe(post, next, &saved_list, head) {
+        list_del(&post->head);
+        rtk_crtc_swap_post_release(post);
+    }
+}
+
+struct rtk_drm_crtc *rtk_crtc_create(struct drm_device *dev)
+{
+    struct rtk_drm_private *priv = dev->dev_private;
+    struct rtk_drm_crtc *rtk_crtc;
+    pr_info("DRM %s %d", __FUNCTION__, __LINE__);
+
+    rtk_crtc = kzalloc(sizeof(struct rtk_drm_crtc), GFP_KERNEL);
+
+    if (rtk_crtc == NULL) {
+        pr_err("Failed to allocated rtk_drm_crtc\n");
+        return NULL;
+    }
+
+    rtk_crtc->vblank_en = false;
+
+    drm_crtc_init_with_planes(dev, &rtk_crtc->base, &priv->planes->primary->base, NULL, &rtk_crtc_funcs, NULL);
+    drm_crtc_helper_add(&rtk_crtc->base, &crtc_helper_funcs);
+    rtk_crtc->base.enabled = 0;
+    rtk_crtc->crtc_index = drm_crtc_index(&rtk_crtc->base);
+
+    drm_mode_crtc_set_gamma_size(&rtk_crtc->base, 256);
+
+    INIT_LIST_HEAD(&rtk_crtc->swap_list);
+    mutex_init(&rtk_crtc->swap_lock);
+    kthread_init_worker(&rtk_crtc->swap_worker);
+    kthread_init_work(&rtk_crtc->swap_work, rtk_crtc_swap_work_func);
+    rtk_crtc->swap_thread = kthread_run(kthread_worker_fn, &rtk_crtc->swap_worker, "rtk_crtc swap_worker");
+    return rtk_crtc;
+}
diff --git a/drivers/gpu/drm/rtk/rtk_drm_device.c b/drivers/gpu/drm/rtk/rtk_drm_device.c
new file mode 100644
index 00000000..8dddafb
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_device.c
@@ -0,0 +1,359 @@
+/*
+ *
+ * (C) COPYRIGHT 2012-2015 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+/**
+ * rtk_drm_device.c
+ * Implementation of the Linux device driver entrypoints for RTK DRM
+ */
+#include <linux/version.h>
+#include <linux/shmem_fs.h>
+#include <linux/dma-buf.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+
+#include <drm/drmP.h>
+#include <drm/drm_crtc_helper.h>
+#include <drm/drm_atomic_helper.h>
+#include "rtk_gem_ion.h"
+#include "rtk_drm.h"
+
+#include "../../../video/fbdev/rtk/dc2vo/dc2vo.h"
+
+void rtk_drm_preclose(struct drm_device *dev, struct drm_file *file_priv)
+{
+    struct rtk_drm_private *priv = dev->dev_private;
+    DRM_DEBUG_KMS("DRM %s on dev=%p\n", __func__, dev);
+    if (priv != NULL && priv->rtk_crtc != NULL)
+        rtk_crtc_pending_vblank(&priv->rtk_crtc->base, file_priv);
+}
+
+/*
+ * rtk does not have a proper HW counter for vblank IRQs so enable_vblank
+ * and disable_vblank are just no op callbacks.
+ */
+static int rtk_enable_vblank(struct drm_device *dev, unsigned int pipe)
+{
+    DRM_DEBUG_KMS("%s: dev=%p, crtc=%d", __func__, dev, pipe);
+    return 0;
+}
+
+static void rtk_disable_vblank(struct drm_device *dev, unsigned int pipe)
+{
+    DRM_DEBUG_KMS("%s: dev=%p, crtc=%d", __func__, dev, pipe);
+}
+
+static int vblank_thread(void *data)
+{
+    struct drm_device *dev = (struct drm_device *)data;
+    unsigned long long nsecs = 0;
+#ifdef PAGE_FLIP_ALING_WITH_VBLANK
+    struct rtk_drm_private *priv = dev->dev_private;
+#endif
+    do {
+        drm_handle_vblank(dev, 0);
+#ifdef PAGE_FLIP_ALING_WITH_VBLANK
+        rtk_crtc_finish_page_flip(priv->rtk_crtc);
+#endif
+        DC_VsyncWait(&nsecs);
+    } while(!kthread_should_stop());
+
+    return 0;
+}
+
+static void rtk_drm_driver_lastclose(struct drm_device *dev)
+{
+#ifdef RTK_USE_FBHELPER
+    struct rtk_drm_private *priv = dev->dev_private;
+    if (priv->fbhelper)
+        drm_fbdev_ion_restore_mode(priv->fbhelper);
+#endif
+}
+
+static void rtk_drm_output_poll_changed(struct drm_device *dev)
+{
+#ifdef RTK_USE_FBHELPER
+    struct rtk_drm_private *priv = dev->dev_private;
+    if (priv->fbhelper)
+        drm_fbdev_ion_hotplug_event(priv->fbhelper);
+#endif
+}
+
+struct drm_mode_config_funcs mode_config_funcs = {
+    .fb_create           = drm_fb_ion_create,
+    .output_poll_changed = rtk_drm_output_poll_changed,
+    .atomic_check        = drm_atomic_helper_check,
+    .atomic_commit       = drm_atomic_helper_commit,
+};
+
+void rtk_drm_mode_config_init(struct drm_device *dev)
+{
+    drm_mode_config_init(dev);
+    dev->mode_config.min_width       = 0;
+    dev->mode_config.min_height      = 0;
+    dev->mode_config.max_width       = 1920; //3840
+    dev->mode_config.max_height      = 1080; //2160
+    //dev->mode_config.async_page_flip = true;
+    dev->mode_config.funcs           = &mode_config_funcs;
+}
+
+static int rtk_modeset_init(struct drm_device *dev)
+{
+    struct rtk_drm_private *priv = dev->dev_private;
+    int ret = 0;
+
+    if (priv == NULL)
+        return -EINVAL;
+
+    rtk_drm_mode_config_init(dev);
+
+    priv->planes = rtk_plans_create(dev);
+    if (priv->planes == NULL) {
+        pr_err("Failed to create rtk_drm_planes\n");
+        ret = -ENOMEM;
+        goto out_config;
+    }
+
+    priv->rtk_crtc = rtk_crtc_create(dev);
+    if (priv->rtk_crtc == NULL) {
+        pr_err("Failed to create rtk_drm_crtc\n");
+        ret = -ENOMEM;
+        goto out_config;
+    }
+
+    priv->connector = rtk_connector_create(dev);
+    if (priv->connector == NULL) {
+        pr_err("Failed to create rtk_drm_connector\n");
+        ret = -ENOMEM;
+        goto out_config;
+    }
+
+    priv->encoder = rtk_encoder_create(dev, 1);
+    if (priv->encoder == NULL) {
+        pr_err("Failed to create rtk_drm_encoder\n");
+        ret = -ENOMEM;
+        goto out_config;
+    }
+
+    ret = drm_mode_connector_attach_encoder(&priv->connector->base, &priv->encoder->base);
+    if (ret != 0) {
+        DRM_ERROR("Failed to attach encoder\n");
+        goto out_config;
+    }
+
+    priv->connector->base.encoder = &priv->encoder->base;
+
+    priv->encoder->base.crtc = &priv->rtk_crtc->base;
+
+#ifdef RTK_USE_FBHELPER
+    priv->fbhelper = drm_fbdev_ion_init(dev, 32,
+            dev->mode_config.num_crtc,
+            dev->mode_config.num_connector);
+#endif
+
+    goto finish;
+
+out_config:
+    drm_mode_config_cleanup(dev);
+finish:
+    DRM_DEBUG("%s returned %d\n", __func__, ret);
+    return ret;
+}
+
+static void rtk_modeset_fini(struct drm_device *dev)
+{
+    drm_mode_config_cleanup(dev);
+}
+
+static int rtk_drm_load(struct drm_device *dev, unsigned long flags)
+{
+    int ret = 0;
+    struct rtk_drm_private *priv;
+    pr_info("DRM %s %d\n", __func__, __LINE__);
+
+    //drm_atomic = 1;
+    //drm_debug=1;
+
+    priv = kzalloc(sizeof(struct rtk_drm_private), GFP_KERNEL);
+    if (!priv)
+        return -ENOMEM;
+
+    dev->dev_private = priv;
+
+    ret = rtk_gem_ion_device_init(dev);
+    if (ret != 0) {
+        DRM_ERROR("[%s:%d] Failed to init rtk_gem_ion\n", __func__, __LINE__);
+        kfree(priv);
+        return -ENOMEM;
+    }
+
+    ret = rtk_modeset_init(dev);
+    if (ret != 0) {
+        pr_err("Failed to init modeset\n");
+        goto out_slab;
+    }
+
+    ret = rtk_device_init(dev);
+    if (ret != 0) {
+        DRM_ERROR("Failed to init MMIO and IRQ\n");
+        goto out_modeset;
+    }
+
+    drm_mode_config_reset(dev);
+
+    /* syncpoints are used for full 32-bit hardware VBLANK counters */
+    dev->max_vblank_count = 0xffffffff;
+
+    ret = drm_vblank_init(dev, 1);
+    if (ret != 0) {
+        DRM_ERROR("Failed to init vblank\n");
+        goto out_vblank;
+    }
+
+    /*
+     * enable drm irq mode.
+     * - with irq_enabled = true, we can use the vblank feature.
+     *
+     * P.S. note that we wouldn't use drm irq handler but
+     *      just specific driver own one instead because
+     *      drm framework supports only one irq handler and
+     *      drivers can well take care of their interrupts
+     */
+    dev->irq_enabled = true;
+
+    platform_set_drvdata(dev->platformdev, dev);
+
+    //drm_kms_helper_poll_init(dev);
+
+    priv->vblank_task = kthread_create(vblank_thread, dev, "vblank thread");
+    if (IS_ERR(priv->vblank_task)) {
+        DRM_ERROR("create vblank thread failed\n");
+    } else {
+        pr_info("create vblank thread success\n");
+        wake_up_process(priv->vblank_task);
+    }
+
+    pr_info("DRM %s %d\n", __func__, __LINE__);
+    goto finish;
+
+out_vblank:
+    rtk_device_fini(dev);
+out_modeset:
+    rtk_modeset_fini(dev);
+out_slab:
+finish:
+    DRM_DEBUG_KMS("rtk_drm_load returned %d\n", ret);
+    return ret;
+}
+
+static int rtk_drm_unload(struct drm_device *dev)
+{
+    struct rtk_drm_private *priv = dev->dev_private;
+    pr_info("DRM %s\n", __func__);
+
+    //drm_kms_helper_poll_fini(dev);
+
+    if (!IS_ERR(priv->vblank_task)){
+        int ret = kthread_stop(priv->vblank_task);
+        pr_info("thread function has run %d\n", ret);
+    }
+
+#ifdef RTK_USE_FBHELPER
+    if (priv->fbhelper)
+        drm_fbdev_ion_fini(priv->fbhelper);
+#endif
+    rtk_modeset_fini(dev);
+    drm_vblank_cleanup(dev);
+    rtk_device_fini(dev);
+    rtk_gem_ion_device_deinit(dev);
+
+    if (priv != NULL) {
+        kfree(dev->dev_private);
+        dev->dev_private = NULL;
+    }
+    return 0;
+}
+
+static const struct file_operations drm_fops = {
+    .owner          = THIS_MODULE,
+    .open           = drm_open,
+    .release        = drm_release,
+    .unlocked_ioctl = drm_ioctl,
+#ifdef CONFIG_COMPAT
+    .compat_ioctl   = drm_compat_ioctl,
+#endif
+    .mmap           = rtk_gem_ion_mmap,
+    .poll           = drm_poll,
+    .read           = drm_read,
+};
+
+static struct drm_ioctl_desc rtk_ioctls[] = {
+    //DRM_IOCTL_DEF_DRV(RTK_GEM_CREATE, rtk_drm_gem_create_ioctl, DRM_UNLOCKED),
+    //DRM_IOCTL_DEF_DRV(RTK_GEM_MAP, rtk_gem_mmap, DRM_UNLOCKED),
+};
+
+static struct drm_driver driver = {
+    .driver_features = DRIVER_MODESET | DRIVER_GEM | DRIVER_PRIME | DRIVER_ATOMIC /*| DRIVER_HAVE_IRQ*/ | DRIVER_RENDER,
+    .load                       = rtk_drm_load,
+    .unload                     = rtk_drm_unload,
+    //.set_busid                  = drm_platform_set_busid,
+    .preclose                   = rtk_drm_preclose,
+    .get_vblank_counter         = drm_vblank_count,
+    .enable_vblank              = rtk_enable_vblank,
+    .disable_vblank             = rtk_disable_vblank,
+    //.suspend                    = rtk_drm_suspend,
+    //.resume                     = rtk_drm_resume,
+    .gem_free_object            = rtk_gem_ion_free_object,
+    .gem_vm_ops                 = &rtk_gem_ion_vm_ops,
+    .gem_prime_get_sg_table     = rtk_gem_ion_prime_get_sg_table,
+    .gem_prime_import_sg_table  = rtk_gem_ion_prime_import_sg_table,
+    .gem_prime_vmap             = rtk_gem_ion_prime_vmap,
+    .gem_prime_vunmap           = rtk_gem_ion_prime_vunmap,
+    .gem_prime_mmap             = rtk_gem_ion_prime_mmap,
+    .dumb_create                = rtk_gem_ion_dumb_create,
+    .dumb_map_offset            = rtk_gem_ion_dumb_map_offset,
+    .dumb_destroy               = drm_gem_dumb_destroy,
+    .gem_prime_export           = drm_gem_prime_export,
+    .gem_prime_import           = drm_gem_prime_import,
+    .prime_handle_to_fd         = drm_gem_prime_handle_to_fd,
+    .prime_fd_to_handle         = drm_gem_prime_fd_to_handle,
+    .ioctls                     = rtk_ioctls,
+    .num_ioctls                 = ARRAY_SIZE(rtk_ioctls),
+    .fops                       = &drm_fops,
+    .name                       = DRIVER_NAME,
+    .desc                       = DRIVER_DESC,
+    .date                       = DRIVER_DATE,
+    .major                      = DRIVER_MAJOR,
+    .minor                      = DRIVER_MINOR,
+    .patchlevel                 = DRIVER_PATCHLEVEL,
+    .lastclose                  = rtk_drm_driver_lastclose,
+};
+
+int rtk_drm_init(struct platform_device *dev)
+{
+    int ret;
+    pr_info("DRM %s\n", __func__);
+    pr_info("RTK DRM initialize, driver name: %s, version %d.%d\n",
+            DRIVER_NAME, DRIVER_MAJOR, DRIVER_MINOR);
+    ret = 0;
+    return drm_platform_init(&driver, dev);
+}
+
+void rtk_drm_exit(struct platform_device *dev)
+{
+    pr_info("DRM %s\n", __func__);
+    drm_put_dev(platform_get_drvdata(dev));
+}
diff --git a/drivers/gpu/drm/rtk/rtk_drm_drv.c b/drivers/gpu/drm/rtk/rtk_drm_drv.c
new file mode 100644
index 00000000..123584b
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_drv.c
@@ -0,0 +1,53 @@
+/*
+ *
+ * (C) COPYRIGHT 2012-2014 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+/**
+ * rtk_drm_drv.c
+ * RTK specific functions for RTK DRM
+ */
+#include <linux/version.h>
+#include <linux/shmem_fs.h>
+#include <linux/dma-buf.h>
+#include <linux/module.h>
+#include <drm/drmP.h>
+#include <drm/drm_crtc_helper.h>
+
+#include "rtk_drm.h"
+
+int rtk_device_init(struct drm_device *dev)
+{
+	struct rtk_drm_private *priv = dev->dev_private;
+	int ret;
+
+	if (priv == NULL) {
+		pr_err("%s no private data\n", __func__);
+		return -EINVAL;
+	}
+
+    ret = 0;
+
+	goto finish;
+
+finish:
+	DRM_DEBUG_KMS("rtk_device_init returned %d\n", ret);
+	return ret;
+}
+
+void rtk_device_fini(struct drm_device *dev)
+{
+
+}
diff --git a/drivers/gpu/drm/rtk/rtk_drm_encoder.c b/drivers/gpu/drm/rtk/rtk_drm_encoder.c
new file mode 100644
index 00000000..063b9af
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_encoder.c
@@ -0,0 +1,106 @@
+/*
+ *
+ * (C) COPYRIGHT 2012-2013 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+/**
+ * rtk_drm_encoder.c
+ * Implementation of the encoder functions for RTK DRM
+ */
+#include <linux/version.h>
+#include <linux/shmem_fs.h>
+#include <linux/dma-buf.h>
+#include <linux/module.h>
+
+#include <drm/drmP.h>
+#include <drm/drm_crtc_helper.h>
+
+#include "rtk_drm.h"
+
+bool rtk_encoder_helper_mode_fixup(struct drm_encoder *encoder,
+					const struct drm_display_mode *mode,
+					struct drm_display_mode *adjusted_mode)
+{
+	DRM_DEBUG_KMS("DRM %s on encoder=%p\n", __func__, encoder);
+	return true;
+}
+
+void rtk_encoder_helper_prepare(struct drm_encoder *encoder)
+{
+	DRM_DEBUG_KMS("DRM %s on encoder=%p\n", __func__, encoder);
+}
+
+void rtk_encoder_helper_commit(struct drm_encoder *encoder)
+{
+	DRM_DEBUG_KMS("DRM %s on encoder=%p\n", __func__, encoder);
+}
+
+void rtk_encoder_helper_mode_set(struct drm_encoder *encoder,
+				struct drm_display_mode *mode,
+				struct drm_display_mode *adjusted_mode)
+{
+	DRM_DEBUG_KMS("DRM %s on encoder=%p\n", __func__, encoder);
+}
+
+void rtk_encoder_helper_disable(struct drm_encoder *encoder)
+{
+	DRM_DEBUG_KMS("DRM %s on encoder=%p\n", __func__, encoder);
+}
+
+void rtk_encoder_destroy(struct drm_encoder *encoder)
+{
+	struct rtk_drm_encoder *rtk_encoder =
+					RTK_ENCODER_FROM_ENCODER(encoder);
+
+	DRM_DEBUG_KMS("DRM %s on encoder=%p\n", __func__, encoder);
+
+	drm_encoder_cleanup(encoder);
+	kfree(rtk_encoder);
+}
+
+const struct drm_encoder_funcs encoder_funcs = {
+	.destroy        = rtk_encoder_destroy,
+};
+
+const struct drm_encoder_helper_funcs encoder_helper_funcs = {
+    //todo
+	.mode_fixup     = rtk_encoder_helper_mode_fixup,
+	.prepare        = rtk_encoder_helper_prepare,
+	.commit         = rtk_encoder_helper_commit,
+	.mode_set       = rtk_encoder_helper_mode_set,
+	.disable        = rtk_encoder_helper_disable,
+};
+
+struct rtk_drm_encoder *rtk_encoder_create(struct drm_device *dev,
+						int possible_crtcs)
+{
+	struct rtk_drm_encoder *rtk_encoder;
+
+	rtk_encoder = kzalloc(sizeof(struct rtk_drm_encoder), GFP_KERNEL);
+	if (rtk_encoder == NULL) {
+		pr_err("Failed to allocated rtk_drm_encoder\n");
+		return NULL;
+	}
+
+	//drm_encoder_init(dev, &rtk_encoder->encoder, &encoder_funcs, DRM_MODE_ENCODER_DAC);
+	drm_encoder_init(dev, &rtk_encoder->base, &encoder_funcs, DRM_MODE_ENCODER_TMDS, NULL);
+
+	drm_encoder_helper_add(&rtk_encoder->base, &encoder_helper_funcs);
+
+	rtk_encoder->base.possible_crtcs = possible_crtcs;
+
+	return rtk_encoder;
+}
+
diff --git a/drivers/gpu/drm/rtk/rtk_drm_fb_ion.c b/drivers/gpu/drm/rtk/rtk_drm_fb_ion.c
new file mode 100644
index 00000000..a060a61
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_fb_ion.c
@@ -0,0 +1,357 @@
+#include <drm/drmP.h>
+#include <drm/drm_crtc.h>
+#include <drm/drm_fb_helper.h>
+#include <drm/drm_crtc_helper.h>
+#include <linux/module.h>
+
+#include "rtk_gem_ion.h"
+#include "rtk_drm_fb_ion.h"
+
+struct drm_fb_ion {
+    struct drm_framebuffer		fb;
+    struct rtk_gem_ion_object	*obj[4];
+};
+
+struct drm_fbdev_ion {
+    struct drm_fb_helper	fb_helper;
+    struct drm_fb_ion	*   fb;
+};
+
+static inline struct drm_fbdev_ion *to_fbdev_ion(struct drm_fb_helper *helper)
+{
+    return container_of(helper, struct drm_fbdev_ion, fb_helper);
+}
+
+static inline struct drm_fb_ion *to_fb_ion(struct drm_framebuffer *fb)
+{
+    return container_of(fb, struct drm_fb_ion, fb);
+}
+
+static void drm_fb_ion_destroy(struct drm_framebuffer *fb)
+{
+    struct drm_fb_ion *fb_ion = to_fb_ion(fb);
+    int i;
+
+    drm_framebuffer_cleanup(fb);
+
+    for (i = 0; i < 4; i++) {
+        if (fb_ion->obj[i])
+            drm_gem_object_unreference_unlocked(&fb_ion->obj[i]->base);
+    }
+
+    kfree(fb_ion);
+}
+
+static int drm_fb_ion_create_handle(struct drm_framebuffer *fb,
+        struct drm_file *file_priv, unsigned int *handle)
+{
+    struct drm_fb_ion *fb_ion = to_fb_ion(fb);
+
+    return drm_gem_handle_create(file_priv,
+            &fb_ion->obj[0]->base, handle);
+}
+
+static int drm_fb_ion_framebuffer_dirty(struct drm_framebuffer *fb,
+        struct drm_file *file_priv, unsigned flags, unsigned color,
+        struct drm_clip_rect *clips, unsigned num_clips)
+{
+    //TODO
+    DRM_DEBUG_KMS("[%s:%d] fb = %p, flags = 0x%x, color = 0x%x, num_clips = %d\n",
+            __func__, __LINE__, fb, flags, color, num_clips);
+    return 0;
+}
+
+static struct drm_framebuffer_funcs drm_fb_ion_funcs = {
+    .destroy	    = drm_fb_ion_destroy,
+    .create_handle	= drm_fb_ion_create_handle,
+    .dirty          = drm_fb_ion_framebuffer_dirty,
+};
+
+static struct drm_fb_ion *drm_fb_ion_alloc(struct drm_device *dev,
+        const struct drm_mode_fb_cmd2 *mode_cmd, struct rtk_gem_ion_object **obj,
+        unsigned int num_planes)
+{
+    struct drm_fb_ion *fb_ion;
+    int ret;
+    int i;
+
+    fb_ion = kzalloc(sizeof(*fb_ion), GFP_KERNEL);
+    if (!fb_ion)
+        return ERR_PTR(-ENOMEM);
+
+    drm_helper_mode_fill_fb_struct(&fb_ion->fb, mode_cmd);
+
+    for (i = 0; i < num_planes; i++)
+        fb_ion->obj[i] = obj[i];
+
+    ret = drm_framebuffer_init(dev, &fb_ion->fb, &drm_fb_ion_funcs);
+    if (ret) {
+        dev_err(dev->dev, "Failed to initialize framebuffer: %d\n", ret);
+        kfree(fb_ion);
+        return ERR_PTR(ret);
+    }
+
+    return fb_ion;
+}
+
+struct drm_framebuffer *drm_fb_ion_create(struct drm_device *dev,
+        struct drm_file *file_priv, const struct drm_mode_fb_cmd2 *mode_cmd)
+{
+    struct drm_fb_ion *fb_ion;
+    struct rtk_gem_ion_object *objs[4];
+    struct drm_gem_object *obj;
+    unsigned int hsub;
+    unsigned int vsub;
+    int ret;
+    int i;
+
+    hsub = drm_format_horz_chroma_subsampling(mode_cmd->pixel_format);
+    vsub = drm_format_vert_chroma_subsampling(mode_cmd->pixel_format);
+
+    for (i = 0; i < drm_format_num_planes(mode_cmd->pixel_format); i++) {
+        unsigned int width = mode_cmd->width / (i ? hsub : 1);
+        unsigned int height = mode_cmd->height / (i ? vsub : 1);
+        unsigned int min_size;
+
+        obj = drm_gem_object_lookup(file_priv, mode_cmd->handles[i]);
+        if (!obj) {
+            dev_err(dev->dev, "Failed to lookup GEM object\n");
+            ret = -ENXIO;
+            goto err_gem_object_unreference;
+        }
+
+        min_size = (height - 1) * mode_cmd->pitches[i]
+            + width * drm_format_plane_cpp(mode_cmd->pixel_format, i)
+            + mode_cmd->offsets[i];
+
+        if (obj->size < min_size) {
+            drm_gem_object_unreference_unlocked(obj);
+            ret = -EINVAL;
+            DRM_ERROR("[%s:%d] obj->size = %zu, min_size = %d\n", __func__, __LINE__,
+                    obj->size, min_size);
+            goto err_gem_object_unreference;
+        }
+        objs[i] = to_rtk_gem_ion_obj(obj);
+    }
+
+    fb_ion = drm_fb_ion_alloc(dev, mode_cmd, objs, i);
+    if (IS_ERR(fb_ion)) {
+        ret = PTR_ERR(fb_ion);
+        goto err_gem_object_unreference;
+    }
+
+    DRM_DEBUG_KMS("[%s:%d] fb = %p\n", __func__, __LINE__,
+            &fb_ion->fb);
+    return &fb_ion->fb;
+
+err_gem_object_unreference:
+    for (i--; i >= 0; i--)
+        drm_gem_object_unreference_unlocked(&objs[i]->base);
+    DRM_ERROR("[%s:%d]\n", __func__, __LINE__);
+    return ERR_PTR(ret);
+}
+
+struct rtk_gem_ion_object *drm_fb_ion_get_gem_obj(struct drm_framebuffer *fb,
+        unsigned int plane)
+{
+    struct drm_fb_ion *fb_ion = to_fb_ion(fb);
+
+    if (plane >= 4)
+        return NULL;
+
+    return fb_ion->obj[plane];
+}
+
+static struct fb_ops drm_fbdev_ion_ops = {
+    .owner		= THIS_MODULE,
+    .fb_fillrect	= sys_fillrect,
+    .fb_copyarea	= sys_copyarea,
+    .fb_imageblit	= sys_imageblit,
+    .fb_check_var	= drm_fb_helper_check_var,
+    .fb_set_par	= drm_fb_helper_set_par,
+    .fb_blank	= drm_fb_helper_blank,
+    .fb_pan_display	= drm_fb_helper_pan_display,
+    .fb_setcmap	= drm_fb_helper_setcmap,
+};
+
+static int drm_fbdev_ion_create(struct drm_fb_helper *helper,
+        struct drm_fb_helper_surface_size *sizes)
+{
+    struct drm_fbdev_ion *fbdev_ion = to_fbdev_ion(helper);
+    struct drm_mode_fb_cmd2 mode_cmd = { 0 };
+    struct drm_device *dev = helper->dev;
+    struct rtk_gem_ion_object *obj;
+    struct drm_framebuffer *fb;
+    unsigned int bytes_per_pixel;
+    unsigned long offset;
+    struct fb_info *fbi;
+    size_t size;
+    int flags = 0;
+    int ret;
+
+    DRM_DEBUG_KMS("surface width(%d), height(%d) and bpp(%d)\n",
+            sizes->surface_width, sizes->surface_height,
+            sizes->surface_bpp);
+
+    bytes_per_pixel = DIV_ROUND_UP(sizes->surface_bpp, 8);
+
+    mode_cmd.width = sizes->surface_width;
+    mode_cmd.height = sizes->surface_height;
+    mode_cmd.pitches[0] = sizes->surface_width * bytes_per_pixel;
+    mode_cmd.pixel_format = drm_mode_legacy_fb_format(sizes->surface_bpp,
+            sizes->surface_depth);
+    mode_cmd.flags = DRM_MODE_FB_MODIFIERS;
+
+    size = mode_cmd.pitches[0] * mode_cmd.height;
+
+    flags |= RTK_BOT_BUFFER_SCPUACC;
+    flags |= RTK_BOT_BUFFER_HWIPACC;
+    flags |= RTK_BOT_BUFFER_HEAP_MEDIA;
+
+    obj = rtk_gem_ion_create(dev, size, flags);
+    if (IS_ERR(obj))
+        return -ENOMEM;
+
+    fbi = framebuffer_alloc(0, dev->dev);
+    if (!fbi) {
+        dev_err(dev->dev, "Failed to allocate framebuffer info.\n");
+        ret = -ENOMEM;
+        goto err_rtk_gem_ion_free_object;
+    }
+
+    fbdev_ion->fb = drm_fb_ion_alloc(dev, &mode_cmd, &obj, 1);
+    if (IS_ERR(fbdev_ion->fb)) {
+        dev_err(dev->dev, "Failed to allocate DRM framebuffer.\n");
+        ret = PTR_ERR(fbdev_ion->fb);
+        goto err_framebuffer_release;
+    }
+
+    fb = &fbdev_ion->fb->fb;
+    helper->fb = fb;
+    helper->fbdev = fbi;
+
+    fbi->par = helper;
+    fbi->flags = FBINFO_FLAG_DEFAULT;
+    fbi->fbops = &drm_fbdev_ion_ops;
+
+    ret = fb_alloc_cmap(&fbi->cmap, 256, 0);
+    if (ret) {
+        dev_err(dev->dev, "Failed to allocate color map.\n");
+        goto err_drm_fb_ion_destroy;
+    }
+
+    drm_fb_helper_fill_fix(fbi, fb->pitches[0], fb->depth);
+    drm_fb_helper_fill_var(fbi, helper, sizes->fb_width, sizes->fb_height);
+
+    offset = fbi->var.xoffset * bytes_per_pixel;
+    offset += fbi->var.yoffset * fb->pitches[0];
+
+    dev->mode_config.fb_base = (resource_size_t)obj->paddr;
+    fbi->screen_base = obj->vaddr + offset;
+    fbi->fix.smem_start = (unsigned long)(obj->paddr + offset);
+    fbi->screen_size = size;
+    fbi->fix.smem_len = size;
+
+    return 0;
+
+err_drm_fb_ion_destroy:
+    drm_framebuffer_unregister_private(fb);
+    drm_fb_ion_destroy(fb);
+err_framebuffer_release:
+    framebuffer_release(fbi);
+err_rtk_gem_ion_free_object:
+    rtk_gem_ion_free_object(&obj->base);
+    return ret;
+}
+
+static const struct drm_fb_helper_funcs drm_fb_ion_helper_funcs = {
+    .fb_probe = drm_fbdev_ion_create,
+};
+
+struct drm_fbdev_ion *drm_fbdev_ion_init(struct drm_device *dev,
+        unsigned int preferred_bpp, unsigned int num_crtc,
+        unsigned int max_conn_count)
+{
+    struct drm_fbdev_ion *fbdev_ion;
+    struct drm_fb_helper *helper;
+    int ret;
+
+    fbdev_ion = kzalloc(sizeof(*fbdev_ion), GFP_KERNEL);
+    if (!fbdev_ion) {
+        dev_err(dev->dev, "Failed to allocate drm fbdev.\n");
+        return ERR_PTR(-ENOMEM);
+    }
+
+    helper = &fbdev_ion->fb_helper;
+
+    drm_fb_helper_prepare(dev, helper, &drm_fb_ion_helper_funcs);
+
+    ret = drm_fb_helper_init(dev, helper, num_crtc, max_conn_count);
+    if (ret < 0) {
+        dev_err(dev->dev, "Failed to initialize drm fb helper.\n");
+        goto err_free;
+    }
+
+    ret = drm_fb_helper_single_add_all_connectors(helper);
+    if (ret < 0) {
+        dev_err(dev->dev, "Failed to add connectors.\n");
+        goto err_drm_fb_helper_fini;
+
+    }
+
+    /* disable all the possible outputs/crtcs before entering KMS mode */
+    drm_helper_disable_unused_functions(dev);
+
+    ret = drm_fb_helper_initial_config(helper, preferred_bpp);
+    if (ret < 0) {
+        dev_err(dev->dev, "Failed to set initial hw configuration.\n");
+        goto err_drm_fb_helper_fini;
+    }
+
+    return fbdev_ion;
+
+err_drm_fb_helper_fini:
+    drm_fb_helper_fini(helper);
+err_free:
+    kfree(fbdev_ion);
+
+    return ERR_PTR(ret);
+}
+
+void drm_fbdev_ion_fini(struct drm_fbdev_ion *fbdev_ion)
+{
+    if (fbdev_ion->fb_helper.fbdev) {
+        struct fb_info *info;
+        int ret;
+
+        info = fbdev_ion->fb_helper.fbdev;
+        ret = unregister_framebuffer(info);
+        if (ret < 0)
+            DRM_DEBUG_KMS("failed unregister_framebuffer()\n");
+
+        if (info->cmap.len)
+            fb_dealloc_cmap(&info->cmap);
+
+        framebuffer_release(info);
+    }
+
+    if (fbdev_ion->fb) {
+        drm_framebuffer_unregister_private(&fbdev_ion->fb->fb);
+        drm_fb_ion_destroy(&fbdev_ion->fb->fb);
+    }
+
+    drm_fb_helper_fini(&fbdev_ion->fb_helper);
+    kfree(fbdev_ion);
+}
+
+void drm_fbdev_ion_restore_mode(struct drm_fbdev_ion *fbdev_ion)
+{
+    if (fbdev_ion)
+        drm_fb_helper_restore_fbdev_mode_unlocked(&fbdev_ion->fb_helper);
+}
+
+void drm_fbdev_ion_hotplug_event(struct drm_fbdev_ion *fbdev_ion)
+{
+    if (fbdev_ion)
+        drm_fb_helper_hotplug_event(&fbdev_ion->fb_helper);
+}
diff --git a/drivers/gpu/drm/rtk/rtk_drm_fb_ion.h b/drivers/gpu/drm/rtk/rtk_drm_fb_ion.h
new file mode 100644
index 00000000..021f48e
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_fb_ion.h
@@ -0,0 +1,29 @@
+#ifndef __RTK_DRM_FB_ION_H__
+#define __RTK_DRM_FB_ION_H__
+
+struct drm_fbdev_ion;
+struct rtk_gem_ion_object;
+
+struct drm_framebuffer;
+struct drm_device;
+struct drm_file;
+struct drm_mode_fb_cmd2;
+
+struct drm_fbdev_ion *drm_fbdev_ion_init(struct drm_device *dev,
+	unsigned int preferred_bpp, unsigned int num_crtc,
+	unsigned int max_conn_count);
+
+void drm_fbdev_ion_fini(struct drm_fbdev_ion *fbdev_ion);
+
+void drm_fbdev_ion_restore_mode(struct drm_fbdev_ion *fbdev_ion);
+
+void drm_fbdev_ion_hotplug_event(struct drm_fbdev_ion *fbdev_ion);
+
+struct drm_framebuffer *drm_fb_ion_create(struct drm_device *dev,
+	struct drm_file *file_priv, const struct drm_mode_fb_cmd2 *mode_cmd);
+
+struct rtk_gem_ion_object *drm_fb_ion_get_gem_obj(struct drm_framebuffer *fb,
+	unsigned int plane);
+
+#endif
+
diff --git a/drivers/gpu/drm/rtk/rtk_drm_funcs.h b/drivers/gpu/drm/rtk/rtk_drm_funcs.h
new file mode 100644
index 00000000..4702621
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_funcs.h
@@ -0,0 +1,55 @@
+/*
+ *
+ * (C) COPYRIGHT 2012-2013 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+/**
+ * rtk_drm_funcs.h
+ * Function prototypes for RTK DRM
+ */
+
+#ifndef RTK_DRM_FUNCS_H_
+#define RTK_DRM_FUNCS_H_
+
+/* Platform Initialisation */
+int rtk_drm_init(struct platform_device *dev);
+void rtk_drm_exit(struct platform_device *dev);
+
+/* Plane Functions */
+struct rtk_drm_planes * rtk_plans_create(struct drm_device *dev);
+
+
+/* CRTC Functions */
+struct rtk_drm_crtc * rtk_crtc_create(struct drm_device *dev);
+void rtk_crtc_finish_page_flip(struct rtk_drm_crtc *rtk_crtc);
+
+/* Connector Functions */
+struct rtk_drm_connector * rtk_connector_create(struct drm_device *dev);
+
+/* Encoder Functions */
+struct rtk_drm_encoder * rtk_encoder_create(struct drm_device *dev, int possible_crtcs);
+
+/* Frame Buffer Functions */
+void rtk_drm_mode_config_init(struct drm_device *dev);
+
+/* Suspend Functions */
+int rtk_drm_resume(struct drm_device *dev);
+int rtk_drm_suspend(struct drm_device *dev, pm_message_t state);
+
+void rtk_crtc_pending_vblank(struct drm_crtc *crtc, struct drm_file *file_priv);
+
+int rtk_device_init(struct drm_device *dev);
+void rtk_device_fini(struct drm_device *dev);
+#endif /* RTK_DRM_FUNCS_H_ */
diff --git a/drivers/gpu/drm/rtk/rtk_drm_plane.c b/drivers/gpu/drm/rtk/rtk_drm_plane.c
new file mode 100644
index 00000000..7864679
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_plane.c
@@ -0,0 +1,158 @@
+#include <linux/version.h>
+#include <linux/shmem_fs.h>
+#include <linux/dma-buf.h>
+#include <linux/module.h>
+
+#include <drm/drmP.h>
+#include <drm/drm_crtc_helper.h>
+#include <drm/drm_atomic_helper.h>
+
+#include "rtk_drm.h"
+
+struct rtk_drm_plane_state * rtk_drm_create_plane_state(struct drm_plane *plane)
+{   
+    struct rtk_drm_plane_state *state;
+    DRM_DEBUG_KMS("[%s:%d]\n", __FUNCTION__, __LINE__);
+
+    state = kzalloc(sizeof(*state), GFP_KERNEL);
+    if (!state)
+        return NULL;
+    state->base.plane       = plane;
+    state->base.rotation    = DRM_ROTATE_0;
+    state->base.crtc_x      = 0;
+    state->base.crtc_y      = 0;
+    state->base.crtc_h      = 1080;
+    state->base.crtc_w      = 1920;
+    state->base.src_x       = 0;
+    state->base.src_y       = 0;
+    state->base.src_h       = 1080;
+    state->base.src_w       = 1920;
+    return state;
+}
+
+void rtk_drm_plane_destroy_state(struct drm_plane *plane,
+        struct drm_plane_state *state)
+{
+    DRM_DEBUG_KMS("[%s:%d]\n", __FUNCTION__, __LINE__);
+    drm_atomic_helper_plane_destroy_state(plane, state);
+}
+
+static const uint32_t rtk_primary_formats[] = {
+    DRM_FORMAT_XRGB8888,
+    DRM_FORMAT_ARGB8888,
+};
+
+static int rtk_update_plane(struct drm_plane *plane, struct drm_crtc *crtc,
+        struct drm_framebuffer *fb, int crtc_x, int crtc_y,
+        unsigned int crtc_w, unsigned int crtc_h,
+        uint32_t src_x, uint32_t src_y, uint32_t src_w,
+        uint32_t src_h)
+{
+    DRM_DEBUG_KMS("[%s:%d]\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+void rtk_plane_destroy(struct drm_plane *plane)
+{   
+    struct rtk_drm_plane *rtk_plane = RTK_PLANE_FROM_PLANE(plane);
+    drm_plane_cleanup(plane);
+    kfree(rtk_plane);
+} 
+
+static int rtk_disable_plane(struct drm_plane *plane)
+{
+    DRM_DEBUG_KMS("[%s:%d]\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+static const struct drm_plane_funcs rtk_plane_funcs = {
+    .update_plane       = rtk_update_plane,
+    .disable_plane      = rtk_disable_plane,
+    .destroy            = rtk_plane_destroy,
+    .atomic_duplicate_state = drm_atomic_helper_plane_duplicate_state,
+    .atomic_destroy_state = drm_atomic_helper_plane_destroy_state,
+};
+
+int rtk_prepare_plane_fb(struct drm_plane *plane,
+        struct drm_plane_state *new_state)
+{
+    DRM_DEBUG_KMS("[%s:%d]\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+void rtk_cleanup_plane_fb(struct drm_plane *plane,
+        struct drm_plane_state *old_state)
+{
+    DRM_DEBUG_KMS("[%s:%d]\n", __FUNCTION__, __LINE__);
+}
+
+int rtk_plane_atomic_check(struct drm_plane *plane,
+        struct drm_plane_state *state)
+{
+    DRM_DEBUG_KMS("[%s:%d]\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+void rtk_plane_atomic_update(struct drm_plane *plane,
+        struct drm_plane_state *old_state)
+{
+    DRM_DEBUG_KMS("[%s:%d]\n", __FUNCTION__, __LINE__);
+}
+
+const struct drm_plane_helper_funcs rtk_plane_helper_funcs = {
+    .prepare_fb     = rtk_prepare_plane_fb,
+    .cleanup_fb     = rtk_cleanup_plane_fb,
+    .atomic_check   = rtk_plane_atomic_check,
+    .atomic_update  = rtk_plane_atomic_update,
+};
+
+
+struct rtk_drm_plane * rtk_drm_primary_create(struct drm_device *dev) {
+    struct rtk_drm_plane *          plane = NULL;
+    struct rtk_drm_plane_state *    state = NULL;
+
+    DRM_DEBUG_KMS("[%s:%d]\n", __FUNCTION__, __LINE__);
+
+    plane =  kzalloc(sizeof(*plane), GFP_KERNEL);
+    if (plane == NULL)
+        return NULL;
+
+    state = rtk_drm_create_plane_state(&plane->base);
+    if (state == NULL)
+        goto err;
+
+    plane->base.state = &state->base;
+
+    drm_universal_plane_init(dev, &plane->base, 0,
+            &rtk_plane_funcs,
+            rtk_primary_formats, 2,
+            DRM_PLANE_TYPE_PRIMARY, NULL);
+
+    drm_plane_helper_add(&plane->base, &rtk_plane_helper_funcs);
+
+    return plane;
+err:
+    if (state)
+        rtk_drm_plane_destroy_state(&plane->base, &state->base);
+    if (plane)
+        kfree(plane);
+    return NULL;
+}
+
+
+
+struct rtk_drm_planes * rtk_plans_create(struct drm_device *dev) {
+    struct rtk_drm_planes *     planes = NULL;
+    DRM_DEBUG_KMS("[%s:%d]\n", __FUNCTION__, __LINE__);
+	planes = kzalloc(sizeof(*planes), GFP_KERNEL);
+    if (planes == NULL)
+        return NULL;
+
+    planes->primary = rtk_drm_primary_create(dev);
+
+    if (planes->primary == NULL) {
+        kfree(planes);
+        return NULL;
+    }
+    return planes;
+}
diff --git a/drivers/gpu/drm/rtk/rtk_drm_platform.c b/drivers/gpu/drm/rtk/rtk_drm_platform.c
new file mode 100644
index 00000000..2154659
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_platform.c
@@ -0,0 +1,124 @@
+/*
+ *
+ * (C) COPYRIGHT 2012-2013 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+/**
+ * rtk_drm_platform.c
+ * Implementation of the Linux platform device entrypoints for RTK DRM
+ */
+#include <linux/version.h>
+#include <linux/shmem_fs.h>
+#include <linux/dma-buf.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/platform_device.h>
+#include <drm/drmP.h>
+#include <drm/drm_crtc_helper.h>
+#include "rtk_drm.h"
+
+static int rtk_platform_drm_suspend(struct platform_device *dev,
+					pm_message_t state)
+{
+	pr_info("DRM %s\n", __func__);
+	return 0;
+}
+
+static int rtk_platform_drm_resume(struct platform_device *dev)
+{
+	pr_info("DRM %s\n", __func__);
+	return 0;
+}
+
+int rtk_platform_drm_probe(struct platform_device *dev)
+{
+	if (IS_ERR_OR_NULL(rtk_phoenix_ion_device))
+		return -ENODEV;
+	pr_info("DRM %s\n", __func__);
+	return rtk_drm_init(dev);
+}
+
+static int rtk_platform_drm_remove(struct platform_device *dev)
+{
+	pr_info("DRM %s\n", __func__);
+	rtk_drm_exit(dev);
+	return 0;
+}
+
+static struct platform_driver platform_drm_driver = {
+	.probe = rtk_platform_drm_probe,
+	.remove = rtk_platform_drm_remove,
+	.suspend = rtk_platform_drm_suspend,
+	.resume = rtk_platform_drm_resume,
+	.driver = {
+			.owner = THIS_MODULE,
+			.name = DRIVER_NAME,
+		},
+};
+
+static const struct platform_device_info rtk_drm_pdevinfo = {
+	.name = DRIVER_NAME,
+	.id = -1,
+	.dma_mask = ~0UL
+};
+
+static struct platform_device *rtk_drm_device;
+
+static int __init rtk_platform_drm_init(void)
+{
+	int ret;
+
+	printk(KERN_ALERT "DRM %s\n", __func__);
+
+	rtk_drm_device = platform_device_register_full(&rtk_drm_pdevinfo);
+	if (rtk_drm_device == NULL) {
+		pr_err("DRM platform_device_register_full() failed\n");
+		return -ENOMEM;
+	}
+
+    ret = platform_driver_register(&platform_drm_driver);
+	if (ret != 0) {
+		pr_err("DRM platform_driver_register() failed %d\n", ret);
+		goto err_pdrv_reg;
+	}
+
+	return 0;
+
+err_pdrv_reg:
+	platform_device_unregister(rtk_drm_device);
+
+	return ret;
+}
+
+static void __exit rtk_platform_drm_exit(void)
+{
+	pr_info("DRM %s\n", __func__);
+
+	platform_device_unregister(rtk_drm_device);
+	platform_driver_unregister(&platform_drm_driver);
+}
+
+#ifdef MODULE
+module_init(rtk_platform_drm_init);
+#else
+late_initcall(rtk_platform_drm_init);
+#endif
+module_exit(rtk_platform_drm_exit);
+
+MODULE_DESCRIPTION(DRIVER_DESC);
+MODULE_VERSION(DRIVER_VERSION);
+MODULE_AUTHOR(DRIVER_AUTHOR);
+MODULE_LICENSE(DRIVER_LICENCE);
+MODULE_ALIAS(DRIVER_ALIAS);
diff --git a/drivers/gpu/drm/rtk/rtk_drm_suspend.c b/drivers/gpu/drm/rtk/rtk_drm_suspend.c
new file mode 100755
index 00000000..470cf62
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_drm_suspend.c
@@ -0,0 +1,41 @@
+/*
+ *
+ * (C) COPYRIGHT 2012-2013 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+/**
+ * rtk_drm_suspend.c
+ * Implementation of the suspend/resume functions for RTK DRM
+ */
+
+#include <linux/version.h>
+#include <linux/shmem_fs.h>
+#include <linux/dma-buf.h>
+#include <linux/module.h>
+#include <drm/drmP.h>
+#include <drm/drm_crtc_helper.h>
+#include "rtk_drm.h"
+
+int rtk_drm_suspend(struct drm_device *dev, pm_message_t state)
+{
+	pr_info("DRM %s\n", __func__);
+	return 0;
+}
+
+int rtk_drm_resume(struct drm_device *dev)
+{
+	pr_info("DRM %s\n", __func__);
+	return 0;
+}
diff --git a/drivers/gpu/drm/rtk/rtk_gem_ion.c b/drivers/gpu/drm/rtk/rtk_gem_ion.c
new file mode 100644
index 00000000..79aaaef
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_gem_ion.c
@@ -0,0 +1,373 @@
+#include <linux/mm.h>
+#include <linux/slab.h>
+#include <linux/mutex.h>
+#include <linux/export.h>
+#include <linux/dma-buf.h>
+#include <linux/dma-mapping.h>
+
+#include <drm/drmP.h>
+#include <drm/drm.h>
+#include "rtk_gem_ion.h"
+#include <drm/drm_vma_manager.h>
+
+extern struct ion_device *rtk_phoenix_ion_device;
+
+static struct ion_client * rtk_gem_ion_client = NULL;
+
+static struct ion_client * rtk_gem_ion_get_client(void)
+{
+    if (rtk_gem_ion_client == NULL)
+        rtk_gem_ion_client = ion_client_create(rtk_phoenix_ion_device, "rtk_gem_ion");
+    return rtk_gem_ion_client;
+}
+
+int rtk_gem_ion_device_init(struct drm_device *drm)
+{
+    if (IS_ERR(rtk_gem_ion_get_client()))
+        return (-ENOMEM);
+    return 0;
+}
+
+void rtk_gem_ion_device_deinit(struct drm_device *drm)
+{
+    if (rtk_gem_ion_client != NULL) {
+        ion_client_destroy(rtk_gem_ion_client);
+        rtk_gem_ion_client = NULL;
+    }
+}
+
+static inline unsigned int rtk_ion_flags(unsigned int dumb_flags)
+{
+    unsigned int ret = 0;
+    if (dumb_flags & RTK_BOT_BUFFER_NONCACHED     ) ret |= ION_FLAG_NONCACHED;
+    if (dumb_flags & RTK_BOT_BUFFER_SCPUACC       ) ret |= ION_FLAG_SCPUACC;
+    if (dumb_flags & RTK_BOT_BUFFER_ACPUACC       ) ret |= ION_FLAG_ACPUACC;
+    if (dumb_flags & RTK_BOT_BUFFER_HWIPACC       ) ret |= ION_FLAG_HWIPACC;
+    if (dumb_flags & RTK_BOT_BUFFER_VE_SPEC       ) ret |= ION_FLAG_VE_SPEC;
+    if (dumb_flags & RTK_BOT_BUFFER_ALGO_LAST_FIT ) ret |= ION_USAGE_ALGO_LAST_FIT;
+    if (dumb_flags & RTK_BOT_BUFFER_PROTECTED     ) ret |= ION_USAGE_PROTECTED;
+    if (dumb_flags & RTK_BOT_BUFFER_SECURE_AUDIO  ) ret |= ION_FLAG_SECURE_AUDIO;
+
+    if (ret == 0)
+        ret |= ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_HWIPACC;
+    return ret;
+}
+
+static inline unsigned int rtk_ion_heaps(unsigned int dumb_flags)
+{
+    unsigned int ret = 0;
+    if (dumb_flags & RTK_BOT_BUFFER_HEAP_MEDIA    ) ret |= RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+    if (dumb_flags & RTK_BOT_BUFFER_HEAP_AUDIO    ) ret |= RTK_PHOENIX_ION_HEAP_AUDIO_MASK;
+    if (dumb_flags & RTK_BOT_BUFFER_HEAP_SYSTEM   ) ret |= ION_HEAP_SYSTEM_MASK;
+    if (dumb_flags & RTK_BOT_BUFFER_HEAP_DMA      ) ret |= ION_HEAP_TYPE_DMA_MASK;
+    if (dumb_flags & RTK_BOT_BUFFER_HEAP_SECURE   ) ret |= RTK_PHOENIX_ION_HEAP_SECURE_MASK;
+
+    if (ret == 0)
+        ret |= RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+    return ret;
+}
+
+
+
+static struct rtk_gem_ion_object * __rtk_gem_ion_create(struct drm_device *drm, size_t size)
+{
+    struct rtk_gem_ion_object *ion_obj;
+    struct drm_gem_object *gem_obj;
+    int ret;
+
+    ion_obj = kzalloc(sizeof(*ion_obj), GFP_KERNEL);
+    if (!ion_obj)
+        return ERR_PTR(-ENOMEM);
+
+    gem_obj = &ion_obj->base;
+
+    ret = drm_gem_object_init(drm, gem_obj, size);
+    if (ret)
+        goto error;
+
+    ret = drm_gem_create_mmap_offset(gem_obj);
+    if (ret) {
+        drm_gem_object_release(gem_obj);
+        goto error;
+    }
+
+    return ion_obj;
+
+error:
+    kfree(ion_obj);
+    return ERR_PTR(ret);
+}
+
+struct rtk_gem_ion_object *rtk_gem_ion_create(struct drm_device *drm, size_t size, unsigned int flags)
+{
+    struct rtk_gem_ion_object *ion_obj;
+
+    size = round_up(size, PAGE_SIZE);
+
+    DRM_DEBUG_KMS("[%s:%d] size = %zu, flags = 0x%x\n", __func__, __LINE__,
+            size, flags);
+
+    ion_obj = __rtk_gem_ion_create(drm, size);
+    if (IS_ERR(ion_obj))
+        return ion_obj;
+
+
+    ion_obj->handle = ion_alloc(rtk_gem_ion_get_client(), size, 0, rtk_ion_heaps(flags), rtk_ion_flags(flags));
+
+    if (IS_ERR(ion_obj->handle))
+        goto error;
+
+    ion_obj->vaddr = ion_map_kernel(rtk_gem_ion_get_client(), ion_obj->handle);
+    {
+        ion_phys_addr_t addr;
+        size_t len;
+        if (ion_phys(rtk_gem_ion_get_client(), ion_obj->handle, &addr, &len) == 0)
+            ion_obj->paddr = addr;
+    }
+
+    return ion_obj;
+
+error:
+    rtk_gem_ion_free_object(&ion_obj->base);
+    return ERR_PTR(-ENOMEM);
+}
+
+static struct rtk_gem_ion_object * rtk_gem_ion_create_with_handle(struct drm_file *file_priv,
+        struct drm_device *drm, size_t size, unsigned int flags,
+        uint32_t *handle)
+{
+    struct rtk_gem_ion_object *ion_obj;
+    struct drm_gem_object *gem_obj;
+    int ret;
+
+    ion_obj = rtk_gem_ion_create(drm, size, flags);
+    if (IS_ERR(ion_obj))
+        return ion_obj;
+
+    gem_obj = &ion_obj->base;
+
+    ret = drm_gem_handle_create(file_priv, gem_obj, handle);
+    if (ret)
+        goto err_handle_create;
+
+    /* drop reference from allocate - handle holds it now. */
+    drm_gem_object_unreference_unlocked(gem_obj);
+
+    return ion_obj;
+
+err_handle_create:
+    rtk_gem_ion_free_object(gem_obj);
+
+    return ERR_PTR(ret);
+}
+
+void rtk_gem_ion_free_object(struct drm_gem_object *gem_obj)
+{
+    struct rtk_gem_ion_object *ion_obj;
+
+    ion_obj = to_rtk_gem_ion_obj(gem_obj);
+
+    if (ion_obj->handle) {
+        ion_free(rtk_gem_ion_get_client(), ion_obj->handle);
+    } else if (gem_obj->import_attach) {
+        drm_prime_gem_destroy(gem_obj, ion_obj->sgt);
+    }
+
+    drm_gem_object_release(gem_obj);
+
+    kfree(ion_obj);
+}
+
+int rtk_gem_ion_dumb_create_internal(struct drm_file *file_priv,
+        struct drm_device *drm,
+        struct drm_mode_create_dumb *args)
+{
+    unsigned int min_pitch = DIV_ROUND_UP(args->width * args->bpp, 8);
+    struct rtk_gem_ion_object *ion_obj;
+
+    //if (args->pitch < min_pitch)
+    args->pitch = min_pitch;
+
+    if (args->size < args->pitch * args->height)
+        args->size = args->pitch * args->height;
+
+    ion_obj = rtk_gem_ion_create_with_handle(file_priv, drm, args->size, args->flags,
+            &args->handle);
+    return PTR_ERR_OR_ZERO(ion_obj);
+}
+
+int rtk_gem_ion_dumb_create(struct drm_file *file_priv,
+        struct drm_device *drm,
+        struct drm_mode_create_dumb *args)
+{
+    struct rtk_gem_ion_object *ion_obj;
+
+    args->pitch = DIV_ROUND_UP(args->width * args->bpp, 8);
+    args->size = args->pitch * args->height;
+
+    DRM_DEBUG_KMS("DRM %s on [ %d x %d, bpp=%d, flags=0x%x]\n", __func__,
+            args->width, args->height, args->bpp, args->flags);
+
+    ion_obj = rtk_gem_ion_create_with_handle(file_priv, drm, args->size, args->flags,
+            &args->handle);
+    return PTR_ERR_OR_ZERO(ion_obj);
+}
+
+int rtk_gem_ion_dumb_map_offset(struct drm_file *file_priv,
+        struct drm_device *drm, u32 handle,
+        u64 *offset)
+{
+    struct drm_gem_object *gem_obj;
+
+    mutex_lock(&drm->struct_mutex);
+
+    gem_obj = drm_gem_object_lookup(file_priv, handle);
+    if (!gem_obj) {
+        dev_err(drm->dev, "failed to lookup GEM object\n");
+        mutex_unlock(&drm->struct_mutex);
+        return -EINVAL;
+    }
+
+    *offset = drm_vma_node_offset_addr(&gem_obj->vma_node);
+
+    drm_gem_object_unreference(gem_obj);
+
+    mutex_unlock(&drm->struct_mutex);
+
+    return 0;
+}
+
+const struct vm_operations_struct rtk_gem_ion_vm_ops = {
+    .open = drm_gem_vm_open,
+    .close = drm_gem_vm_close,
+};
+
+static int rtk_gem_ion_mmap_obj(struct rtk_gem_ion_object *ion_obj,
+        struct vm_area_struct *vma)
+{
+    /*
+     * Clear the VM_PFNMAP flag that was set by drm_gem_mmap(), and set the
+     * vm_pgoff (used as a fake buffer offset by DRM) to 0 as we want to map
+     * the whole buffer.
+     */
+    vma->vm_flags &= ~VM_PFNMAP;
+    vma->vm_pgoff = 0;
+    return ion_mmap_by_handle(ion_obj->handle, vma);
+}
+
+int rtk_gem_ion_mmap(struct file *filp, struct vm_area_struct *vma)
+{
+    struct rtk_gem_ion_object *ion_obj;
+    struct drm_gem_object *gem_obj;
+    int ret;
+
+    ret = drm_gem_mmap(filp, vma);
+    if (ret)
+        return ret;
+
+    gem_obj = vma->vm_private_data;
+    ion_obj = to_rtk_gem_ion_obj(gem_obj);
+
+    return rtk_gem_ion_mmap_obj(ion_obj, vma);
+}
+
+struct sg_table *rtk_gem_ion_prime_get_sg_table(struct drm_gem_object *obj)
+{
+    struct rtk_gem_ion_object *ion_obj = to_rtk_gem_ion_obj(obj);
+    struct sg_table *ion_sgt = NULL;
+    struct sg_table *sgt = NULL;
+
+    DRM_DEBUG_PRIME("[%s:%d]\n", __func__, __LINE__);
+
+    ion_sgt = ion_sg_table(rtk_gem_ion_get_client(), ion_obj->handle);
+    if (!ion_sgt) {
+        DRM_ERROR("[%s:%d] ion_sg_table %p \n", __func__, __LINE__, ion_sgt);
+        return NULL;
+    }
+
+    sgt = kzalloc(sizeof(*sgt), GFP_KERNEL);
+    if (!sgt)
+        return NULL;
+
+    if (sg_alloc_table(sgt, ion_sgt->nents, GFP_KERNEL) != 0) {
+        DRM_ERROR("[%s:%d] sg_alloc_table %p \n", __func__, __LINE__, sgt);
+        kfree(sgt);
+        goto out;
+    }
+
+    {
+        struct scatterlist *rd, *wr;
+        unsigned int i;
+        rd = ion_sgt->sgl;
+        wr = sgt->sgl;
+        for (i = 0; i<ion_sgt->nents; i++) {
+            sg_set_page(wr, sg_page(rd), rd->length, rd->offset);
+            sg_dma_address(wr) = sg_phys(rd);
+            sg_dma_len(wr) = rd->length;
+            rd = sg_next(rd);
+            wr = sg_next(wr);
+        }
+    }
+
+    return sgt;
+
+out:
+    kfree(sgt);
+    return NULL;
+}
+
+struct drm_gem_object * rtk_gem_ion_prime_import_sg_table(struct drm_device *dev,
+        struct dma_buf_attachment *attach,
+        struct sg_table *sgt)
+{
+    struct rtk_gem_ion_object *ion_obj;
+
+    if (sgt->nents != 1)
+        return ERR_PTR(-EINVAL);
+
+    /* Create a CMA GEM buffer. */
+    ion_obj = __rtk_gem_ion_create(dev, attach->dmabuf->size);
+    if (IS_ERR(ion_obj))
+        return ERR_CAST(ion_obj);
+
+    ion_obj->paddr = sg_dma_address(sgt->sgl);
+    ion_obj->sgt = sgt;
+
+    DRM_DEBUG_PRIME("dma_addr = %pad, size = %zu\n", &ion_obj->paddr, attach->dmabuf->size);
+
+    return &ion_obj->base;
+}
+
+int rtk_gem_ion_prime_mmap(struct drm_gem_object *obj,
+        struct vm_area_struct *vma)
+{
+    struct rtk_gem_ion_object *ion_obj;
+    struct drm_device *dev = obj->dev;
+    int ret;
+
+    mutex_lock(&dev->struct_mutex);
+    ret = drm_gem_mmap_obj(obj, obj->size, vma);
+    mutex_unlock(&dev->struct_mutex);
+    if (ret < 0)
+        return ret;
+
+    ion_obj = to_rtk_gem_ion_obj(obj);
+    return rtk_gem_ion_mmap_obj(ion_obj, vma);
+}
+
+void *rtk_gem_ion_prime_vmap(struct drm_gem_object *obj)
+{
+    struct rtk_gem_ion_object *ion_obj = to_rtk_gem_ion_obj(obj);
+
+    return ion_obj->vaddr;
+}
+
+void rtk_gem_ion_prime_vunmap(struct drm_gem_object *obj, void *vaddr)
+{
+    /* Nothing to do */
+}
+
+int rtk_gem_create_ioctl(struct drm_device *drm, void *data, struct drm_file *file_priv) {
+    DRM_DEBUG_PRIME("[%s]\n", __func__);
+    return rtk_gem_ion_dumb_create_internal(file_priv, drm, (struct drm_mode_create_dumb *)data);
+}
diff --git a/drivers/gpu/drm/rtk/rtk_gem_ion.h b/drivers/gpu/drm/rtk/rtk_gem_ion.h
new file mode 100644
index 00000000..e7d2483
--- /dev/null
+++ b/drivers/gpu/drm/rtk/rtk_gem_ion.h
@@ -0,0 +1,94 @@
+#ifndef __RTK_GEM_ION_HELPER_H__
+#define __RTK_GEM_ION_HELPER_H__
+
+#include <drm/drmP.h>
+#include <drm/drm_gem.h>
+
+#include "rtk_drm.h"
+#include "../../../staging/android/ion/ion.h"
+#include "../../../staging/android/uapi/ion_rtk.h"
+
+enum {
+    eRTK_BOT_BUFFER_NONCACHED,
+    eRTK_BOT_BUFFER_SCPUACC,
+    eRTK_BOT_BUFFER_ACPUACC,
+    eRTK_BOT_BUFFER_HWIPACC,
+    eRTK_BOT_BUFFER_VE_SPEC,
+    eRTK_BOT_BUFFER_ALGO_LAST_FIT,
+    eRTK_BOT_BUFFER_PROTECTED,
+    eRTK_BOT_BUFFER_SECURE_AUDIO,
+    eRTK_BOT_BUFFER_HEAP_MEDIA,
+    eRTK_BOT_BUFFER_HEAP_AUDIO,
+    eRTK_BOT_BUFFER_HEAP_SYSTEM,
+    eRTK_BOT_BUFFER_HEAP_DMA,
+    eRTK_BOT_BUFFER_HEAP_SECURE,
+    eRTK_BOT_MAX_DEFINED,
+};
+
+#define RTK_BOT_BUFFER_NONCACHED            (0x1 << eRTK_BOT_BUFFER_NONCACHED           )
+#define RTK_BOT_BUFFER_SCPUACC              (0x1 << eRTK_BOT_BUFFER_SCPUACC             )
+#define RTK_BOT_BUFFER_ACPUACC              (0x1 << eRTK_BOT_BUFFER_ACPUACC             )
+#define RTK_BOT_BUFFER_HWIPACC              (0x1 << eRTK_BOT_BUFFER_HWIPACC             )
+#define RTK_BOT_BUFFER_VE_SPEC              (0x1 << eRTK_BOT_BUFFER_VE_SPEC             )
+#define RTK_BOT_BUFFER_ALGO_LAST_FIT        (0x1 << eRTK_BOT_BUFFER_ALGO_LAST_FIT       )
+#define RTK_BOT_BUFFER_PROTECTED            (0x1 << eRTK_BOT_BUFFER_PROTECTED           )
+#define RTK_BOT_BUFFER_SECURE_AUDIO         (0x1 << eRTK_BOT_BUFFER_SECURE_AUDIO        )
+#define RTK_BOT_BUFFER_HEAP_MEDIA           (0x1 << eRTK_BOT_BUFFER_HEAP_MEDIA          )
+#define RTK_BOT_BUFFER_HEAP_AUDIO           (0x1 << eRTK_BOT_BUFFER_HEAP_AUDIO          )
+#define RTK_BOT_BUFFER_HEAP_SYSTEM          (0x1 << eRTK_BOT_BUFFER_HEAP_SYSTEM         )
+#define RTK_BOT_BUFFER_HEAP_DMA             (0x1 << eRTK_BOT_BUFFER_HEAP_DMA            )
+#define RTK_BOT_BUFFER_HEAP_SECURE          (0x1 << eRTK_BOT_BUFFER_HEAP_SECURE         )
+#define RTK_BOT_MASK                        ((0x1 << eRTK_BOT_MAX_DEFINED) -1           )
+
+struct rtk_gem_ion_object {
+    struct drm_gem_object   base;
+    struct ion_handle *     handle;
+    dma_addr_t              paddr;
+    struct sg_table *       sgt;
+    void *                  vaddr;
+};
+
+static inline struct rtk_gem_ion_object * to_rtk_gem_ion_obj(struct drm_gem_object *gem_obj)
+{
+    return container_of(gem_obj, struct rtk_gem_ion_object, base);
+}
+
+void rtk_gem_ion_free_object(struct drm_gem_object *gem_obj);
+
+int rtk_gem_ion_dumb_create_internal(struct drm_file *file_priv,
+        struct drm_device *drm,
+        struct drm_mode_create_dumb *args);
+
+int rtk_gem_ion_dumb_create(struct drm_file *file_priv,
+        struct drm_device *drm,
+        struct drm_mode_create_dumb *args);
+
+int rtk_gem_ion_dumb_map_offset(struct drm_file *file_priv,
+        struct drm_device *drm, u32 handle,
+        u64 *offset);
+
+int rtk_gem_ion_mmap(struct file *filp, struct vm_area_struct *vma);
+
+struct rtk_gem_ion_object *rtk_gem_ion_create(struct drm_device *drm, size_t size, unsigned int flags);
+
+extern const struct vm_operations_struct rtk_gem_ion_vm_ops;
+
+struct sg_table *rtk_gem_ion_prime_get_sg_table(struct drm_gem_object *obj);
+
+struct drm_gem_object * rtk_gem_ion_prime_import_sg_table(struct drm_device *dev,
+        struct dma_buf_attachment *attach,
+        struct sg_table *sgt);
+
+int rtk_gem_ion_prime_mmap(struct drm_gem_object *obj,
+        struct vm_area_struct *vma);
+
+void *rtk_gem_ion_prime_vmap(struct drm_gem_object *obj);
+
+void rtk_gem_ion_prime_vunmap(struct drm_gem_object *obj, void *vaddr);
+
+int rtk_gem_ion_device_init(struct drm_device *drm);
+
+void rtk_gem_ion_device_deinit(struct drm_device *drm);
+
+int rtk_gem_create_ioctl(struct drm_device *dev, void *data, struct drm_file *file_priv);
+#endif /* __RTK_GEM_ION_HELPER_H__ */
diff --git a/drivers/gpu/drm/ttm/ttm_bo.c b/drivers/gpu/drm/ttm/ttm_bo.c
index 52a2a1a..5a18408 100644
--- a/drivers/gpu/drm/ttm/ttm_bo.c
+++ b/drivers/gpu/drm/ttm/ttm_bo.c
@@ -1606,7 +1606,14 @@ void ttm_bo_unmap_virtual(struct ttm_buffer_object *bo)
 int ttm_bo_wait(struct ttm_buffer_object *bo,
 		bool interruptible, bool no_wait)
 {
-	long timeout = no_wait ? 0 : 15 * HZ;
+	long timeout = 15 * HZ;
+
+	if (no_wait) {
+		if (reservation_object_test_signaled_rcu(bo->resv, true))
+			return 0;
+		else
+			return -EBUSY;
+	}
 
 	timeout = reservation_object_wait_timeout_rcu(bo->resv, true,
 						      interruptible, timeout);
diff --git a/drivers/hid/hid-magicmouse.c b/drivers/hid/hid-magicmouse.c
index 20b40ad..42ed887 100644
--- a/drivers/hid/hid-magicmouse.c
+++ b/drivers/hid/hid-magicmouse.c
@@ -34,7 +34,8 @@
 MODULE_PARM_DESC(emulate_scroll_wheel, "Emulate a scroll wheel");
 
 static unsigned int scroll_speed = 32;
-static int param_set_scroll_speed(const char *val, struct kernel_param *kp) {
+static int param_set_scroll_speed(const char *val,
+				  const struct kernel_param *kp) {
 	unsigned long speed;
 	if (!val || kstrtoul(val, 0, &speed) || speed > 63)
 		return -EINVAL;
diff --git a/drivers/hid/uhid.c b/drivers/hid/uhid.c
index 7f8ff39..e46f656 100644
--- a/drivers/hid/uhid.c
+++ b/drivers/hid/uhid.c
@@ -28,6 +28,8 @@
 #define UHID_NAME	"uhid"
 #define UHID_BUFSIZE	32
 
+static DEFINE_MUTEX(uhid_open_mutex);
+
 struct uhid_device {
 	struct mutex devlock;
 	bool running;
@@ -142,15 +144,26 @@ static void uhid_hid_stop(struct hid_device *hid)
 static int uhid_hid_open(struct hid_device *hid)
 {
 	struct uhid_device *uhid = hid->driver_data;
+	int retval = 0;
 
-	return uhid_queue_event(uhid, UHID_OPEN);
+	mutex_lock(&uhid_open_mutex);
+	if (!hid->open++) {
+		retval = uhid_queue_event(uhid, UHID_OPEN);
+		if (retval)
+			hid->open--;
+	}
+	mutex_unlock(&uhid_open_mutex);
+	return retval;
 }
 
 static void uhid_hid_close(struct hid_device *hid)
 {
 	struct uhid_device *uhid = hid->driver_data;
 
-	uhid_queue_event(uhid, UHID_CLOSE);
+	mutex_lock(&uhid_open_mutex);
+	if (!--hid->open)
+		uhid_queue_event(uhid, UHID_CLOSE);
+	mutex_unlock(&uhid_open_mutex);
 }
 
 static int uhid_hid_parse(struct hid_device *hid)
diff --git a/drivers/hwtracing/coresight/coresight-etm-perf.c b/drivers/hwtracing/coresight/coresight-etm-perf.c
index 2cd7c71..df633153 100644
--- a/drivers/hwtracing/coresight/coresight-etm-perf.c
+++ b/drivers/hwtracing/coresight/coresight-etm-perf.c
@@ -201,9 +201,23 @@ static void *etm_setup_aux(int event_cpu, void **pages,
 	event_data = alloc_event_data(event_cpu);
 	if (!event_data)
 		return NULL;
-
 	INIT_WORK(&event_data->work, free_event_data);
 
+	/*
+	 * In theory nothing prevent tracers in a trace session from being
+	 * associated with different sinks, nor having a sink per tracer.  But
+	 * until we have HW with this kind of topology we need to assume tracers
+	 * in a trace session are using the same sink.  Therefore go through
+	 * the coresight bus and pick the first enabled sink.
+	 *
+	 * When operated from sysFS users are responsible to enable the sink
+	 * while from perf, the perf tools will do it based on the choice made
+	 * on the cmd line.  As such the "enable_sink" flag in sysFS is reset.
+	 */
+	sink = coresight_get_enabled_sink(true);
+	if (!sink)
+		goto err;
+
 	mask = &event_data->mask;
 
 	/* Setup the path for each CPU in a trace session */
@@ -219,28 +233,15 @@ static void *etm_setup_aux(int event_cpu, void **pages,
 		 * list of devices from source to sink that can be
 		 * referenced later when the path is actually needed.
 		 */
-		event_data->path[cpu] = coresight_build_path(csdev);
+		event_data->path[cpu] = coresight_build_path(csdev, sink);
 		if (IS_ERR(event_data->path[cpu]))
 			goto err;
 	}
 
-	/*
-	 * In theory nothing prevent tracers in a trace session from being
-	 * associated with different sinks, nor having a sink per tracer.  But
-	 * until we have HW with this kind of topology and a way to convey
-	 * sink assignement from the perf cmd line we need to assume tracers
-	 * in a trace session are using the same sink.  Therefore pick the sink
-	 * found at the end of the first available path.
-	 */
-	cpu = cpumask_first(mask);
-	/* Grab the sink at the end of the path */
-	sink = coresight_get_sink(event_data->path[cpu]);
-	if (!sink)
-		goto err;
-
 	if (!sink_ops(sink)->alloc_buffer)
 		goto err;
 
+	cpu = cpumask_first(mask);
 	/* Get the AUX specific data from the sink buffer */
 	event_data->snk_config =
 			sink_ops(sink)->alloc_buffer(sink, cpu, pages,
diff --git a/drivers/hwtracing/coresight/coresight-etm4x.c b/drivers/hwtracing/coresight/coresight-etm4x.c
index 4db8d6a..83358eb 100644
--- a/drivers/hwtracing/coresight/coresight-etm4x.c
+++ b/drivers/hwtracing/coresight/coresight-etm4x.c
@@ -1026,7 +1026,8 @@ static int etm4_probe(struct amba_device *adev, const struct amba_id *id)
 	}
 
 	pm_runtime_put(&adev->dev);
-	dev_info(dev, "%s initialized\n", (char *)id->data);
+	dev_info(dev, "CPU%d: %s initialized\n",
+			drvdata->cpu, (char *)id->data);
 
 	if (boot_enable) {
 		coresight_enable(drvdata->csdev);
@@ -1045,20 +1046,25 @@ static int etm4_probe(struct amba_device *adev, const struct amba_id *id)
 }
 
 static struct amba_id etm4_ids[] = {
-	{       /* ETM 4.0 - Cortex-A53  */
+	{
 		.id	= 0x000bb95d,
 		.mask	= 0x000fffff,
-		.data	= "ETM 4.0",
+		.data	= "Cortex-A53 ETM v4.0",
 	},
-	{       /* ETM 4.0 - Cortex-A57 */
+	{
 		.id	= 0x000bb95e,
 		.mask	= 0x000fffff,
-		.data	= "ETM 4.0",
+		.data	= "Cortex-A57 ETM v4.0",
 	},
-	{       /* ETM 4.0 - A72, Maia, HiSilicon */
+	{
 		.id = 0x000bb95a,
 		.mask = 0x000fffff,
-		.data = "ETM 4.0",
+		.data	= "Cortex-A72 ETM v4.0",
+	},
+	{
+		.id = 0x000bb959,
+		.mask = 0x000fffff,
+		.data	= "Cortex-A73 ETM v4.0",
 	},
 	{ 0, 0},
 };
diff --git a/drivers/hwtracing/coresight/coresight-priv.h b/drivers/hwtracing/coresight/coresight-priv.h
index 196a14b..ef9d8e9 100644
--- a/drivers/hwtracing/coresight/coresight-priv.h
+++ b/drivers/hwtracing/coresight/coresight-priv.h
@@ -111,7 +111,9 @@ static inline void CS_UNLOCK(void __iomem *addr)
 void coresight_disable_path(struct list_head *path);
 int coresight_enable_path(struct list_head *path, u32 mode);
 struct coresight_device *coresight_get_sink(struct list_head *path);
-struct list_head *coresight_build_path(struct coresight_device *csdev);
+struct coresight_device *coresight_get_enabled_sink(bool reset);
+struct list_head *coresight_build_path(struct coresight_device *csdev,
+				       struct coresight_device *sink);
 void coresight_release_path(struct list_head *path);
 
 #ifdef CONFIG_CORESIGHT_SOURCE_ETM3X
diff --git a/drivers/hwtracing/coresight/coresight-tmc-etf.c b/drivers/hwtracing/coresight/coresight-tmc-etf.c
index d6941ea..1549436 100644
--- a/drivers/hwtracing/coresight/coresight-tmc-etf.c
+++ b/drivers/hwtracing/coresight/coresight-tmc-etf.c
@@ -70,7 +70,7 @@ static void tmc_etb_disable_hw(struct tmc_drvdata *drvdata)
 	 * When operating in sysFS mode the content of the buffer needs to be
 	 * read before the TMC is disabled.
 	 */
-	if (local_read(&drvdata->mode) == CS_MODE_SYSFS)
+	if (drvdata->mode == CS_MODE_SYSFS)
 		tmc_etb_dump_hw(drvdata);
 	tmc_disable_hw(drvdata);
 
@@ -103,19 +103,14 @@ static void tmc_etf_disable_hw(struct tmc_drvdata *drvdata)
 	CS_LOCK(drvdata->base);
 }
 
-static int tmc_enable_etf_sink_sysfs(struct coresight_device *csdev, u32 mode)
+static int tmc_enable_etf_sink_sysfs(struct coresight_device *csdev)
 {
 	int ret = 0;
 	bool used = false;
 	char *buf = NULL;
-	long val;
 	unsigned long flags;
 	struct tmc_drvdata *drvdata = dev_get_drvdata(csdev->dev.parent);
 
-	 /* This shouldn't be happening */
-	if (WARN_ON(mode != CS_MODE_SYSFS))
-		return -EINVAL;
-
 	/*
 	 * If we don't have a buffer release the lock and allocate memory.
 	 * Otherwise keep the lock and move along.
@@ -138,13 +133,12 @@ static int tmc_enable_etf_sink_sysfs(struct coresight_device *csdev, u32 mode)
 		goto out;
 	}
 
-	val = local_xchg(&drvdata->mode, mode);
 	/*
 	 * In sysFS mode we can have multiple writers per sink.  Since this
 	 * sink is already enabled no memory is needed and the HW need not be
 	 * touched.
 	 */
-	if (val == CS_MODE_SYSFS)
+	if (drvdata->mode == CS_MODE_SYSFS)
 		goto out;
 
 	/*
@@ -163,6 +157,7 @@ static int tmc_enable_etf_sink_sysfs(struct coresight_device *csdev, u32 mode)
 		drvdata->buf = buf;
 	}
 
+	drvdata->mode = CS_MODE_SYSFS;
 	tmc_etb_enable_hw(drvdata);
 out:
 	spin_unlock_irqrestore(&drvdata->spinlock, flags);
@@ -177,34 +172,29 @@ static int tmc_enable_etf_sink_sysfs(struct coresight_device *csdev, u32 mode)
 	return ret;
 }
 
-static int tmc_enable_etf_sink_perf(struct coresight_device *csdev, u32 mode)
+static int tmc_enable_etf_sink_perf(struct coresight_device *csdev)
 {
 	int ret = 0;
-	long val;
 	unsigned long flags;
 	struct tmc_drvdata *drvdata = dev_get_drvdata(csdev->dev.parent);
 
-	 /* This shouldn't be happening */
-	if (WARN_ON(mode != CS_MODE_PERF))
-		return -EINVAL;
-
 	spin_lock_irqsave(&drvdata->spinlock, flags);
 	if (drvdata->reading) {
 		ret = -EINVAL;
 		goto out;
 	}
 
-	val = local_xchg(&drvdata->mode, mode);
 	/*
 	 * In Perf mode there can be only one writer per sink.  There
 	 * is also no need to continue if the ETB/ETR is already operated
 	 * from sysFS.
 	 */
-	if (val != CS_MODE_DISABLED) {
+	if (drvdata->mode != CS_MODE_DISABLED) {
 		ret = -EINVAL;
 		goto out;
 	}
 
+	drvdata->mode = CS_MODE_PERF;
 	tmc_etb_enable_hw(drvdata);
 out:
 	spin_unlock_irqrestore(&drvdata->spinlock, flags);
@@ -216,9 +206,9 @@ static int tmc_enable_etf_sink(struct coresight_device *csdev, u32 mode)
 {
 	switch (mode) {
 	case CS_MODE_SYSFS:
-		return tmc_enable_etf_sink_sysfs(csdev, mode);
+		return tmc_enable_etf_sink_sysfs(csdev);
 	case CS_MODE_PERF:
-		return tmc_enable_etf_sink_perf(csdev, mode);
+		return tmc_enable_etf_sink_perf(csdev);
 	}
 
 	/* We shouldn't be here */
@@ -227,7 +217,6 @@ static int tmc_enable_etf_sink(struct coresight_device *csdev, u32 mode)
 
 static void tmc_disable_etf_sink(struct coresight_device *csdev)
 {
-	long val;
 	unsigned long flags;
 	struct tmc_drvdata *drvdata = dev_get_drvdata(csdev->dev.parent);
 
@@ -237,10 +226,11 @@ static void tmc_disable_etf_sink(struct coresight_device *csdev)
 		return;
 	}
 
-	val = local_xchg(&drvdata->mode, CS_MODE_DISABLED);
 	/* Disable the TMC only if it needs to */
-	if (val != CS_MODE_DISABLED)
+	if (drvdata->mode != CS_MODE_DISABLED) {
 		tmc_etb_disable_hw(drvdata);
+		drvdata->mode = CS_MODE_DISABLED;
+	}
 
 	spin_unlock_irqrestore(&drvdata->spinlock, flags);
 
@@ -260,7 +250,7 @@ static int tmc_enable_etf_link(struct coresight_device *csdev,
 	}
 
 	tmc_etf_enable_hw(drvdata);
-	local_set(&drvdata->mode, CS_MODE_SYSFS);
+	drvdata->mode = CS_MODE_SYSFS;
 	spin_unlock_irqrestore(&drvdata->spinlock, flags);
 
 	dev_info(drvdata->dev, "TMC-ETF enabled\n");
@@ -280,7 +270,7 @@ static void tmc_disable_etf_link(struct coresight_device *csdev,
 	}
 
 	tmc_etf_disable_hw(drvdata);
-	local_set(&drvdata->mode, CS_MODE_DISABLED);
+	drvdata->mode = CS_MODE_DISABLED;
 	spin_unlock_irqrestore(&drvdata->spinlock, flags);
 
 	dev_info(drvdata->dev, "TMC disabled\n");
@@ -383,7 +373,7 @@ static void tmc_update_etf_buffer(struct coresight_device *csdev,
 		return;
 
 	/* This shouldn't happen */
-	if (WARN_ON_ONCE(local_read(&drvdata->mode) != CS_MODE_PERF))
+	if (WARN_ON_ONCE(drvdata->mode != CS_MODE_PERF))
 		return;
 
 	CS_UNLOCK(drvdata->base);
@@ -504,7 +494,6 @@ static void tmc_update_etf_buffer(struct coresight_device *csdev,
 
 int tmc_read_prepare_etb(struct tmc_drvdata *drvdata)
 {
-	long val;
 	enum tmc_mode mode;
 	int ret = 0;
 	unsigned long flags;
@@ -528,9 +517,8 @@ int tmc_read_prepare_etb(struct tmc_drvdata *drvdata)
 		goto out;
 	}
 
-	val = local_read(&drvdata->mode);
 	/* Don't interfere if operated from Perf */
-	if (val == CS_MODE_PERF) {
+	if (drvdata->mode == CS_MODE_PERF) {
 		ret = -EINVAL;
 		goto out;
 	}
@@ -542,7 +530,7 @@ int tmc_read_prepare_etb(struct tmc_drvdata *drvdata)
 	}
 
 	/* Disable the TMC if need be */
-	if (val == CS_MODE_SYSFS)
+	if (drvdata->mode == CS_MODE_SYSFS)
 		tmc_etb_disable_hw(drvdata);
 
 	drvdata->reading = true;
@@ -573,7 +561,7 @@ int tmc_read_unprepare_etb(struct tmc_drvdata *drvdata)
 	}
 
 	/* Re-enable the TMC if need be */
-	if (local_read(&drvdata->mode) == CS_MODE_SYSFS) {
+	if (drvdata->mode == CS_MODE_SYSFS) {
 		/*
 		 * The trace run will continue with the same allocated trace
 		 * buffer. As such zero-out the buffer so that we don't end
diff --git a/drivers/hwtracing/coresight/coresight-tmc-etr.c b/drivers/hwtracing/coresight/coresight-tmc-etr.c
index 886ea83..2db4857 100644
--- a/drivers/hwtracing/coresight/coresight-tmc-etr.c
+++ b/drivers/hwtracing/coresight/coresight-tmc-etr.c
@@ -15,11 +15,30 @@
  * this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 
+#include <linux/circ_buf.h>
 #include <linux/coresight.h>
 #include <linux/dma-mapping.h>
+#include <linux/slab.h>
+
 #include "coresight-priv.h"
 #include "coresight-tmc.h"
 
+/**
+ * struct cs_etr_buffer - keep track of a recording session' specifics
+ * @tmc:	generic portion of the TMC buffers
+ * @paddr:	the physical address of a DMA'able contiguous memory area
+ * @vaddr:	the virtual address associated to @paddr
+ * @size:	how much memory we have, starting at @paddr
+ * @dev:	the device @vaddr has been tied to
+ */
+struct cs_etr_buffers {
+	struct cs_buffers	tmc;
+	dma_addr_t		paddr;
+	void __iomem		*vaddr;
+	u32			size;
+	struct device		*dev;
+};
+
 static void tmc_etr_enable_hw(struct tmc_drvdata *drvdata)
 {
 	u32 axictl;
@@ -86,26 +105,22 @@ static void tmc_etr_disable_hw(struct tmc_drvdata *drvdata)
 	 * When operating in sysFS mode the content of the buffer needs to be
 	 * read before the TMC is disabled.
 	 */
-	if (local_read(&drvdata->mode) == CS_MODE_SYSFS)
+	if (drvdata->mode == CS_MODE_SYSFS)
 		tmc_etr_dump_hw(drvdata);
 	tmc_disable_hw(drvdata);
 
 	CS_LOCK(drvdata->base);
 }
 
-static int tmc_enable_etr_sink_sysfs(struct coresight_device *csdev, u32 mode)
+static int tmc_enable_etr_sink_sysfs(struct coresight_device *csdev)
 {
 	int ret = 0;
 	bool used = false;
-	long val;
 	unsigned long flags;
 	void __iomem *vaddr = NULL;
 	dma_addr_t paddr;
 	struct tmc_drvdata *drvdata = dev_get_drvdata(csdev->dev.parent);
 
-	 /* This shouldn't be happening */
-	if (WARN_ON(mode != CS_MODE_SYSFS))
-		return -EINVAL;
 
 	/*
 	 * If we don't have a buffer release the lock and allocate memory.
@@ -134,13 +149,12 @@ static int tmc_enable_etr_sink_sysfs(struct coresight_device *csdev, u32 mode)
 		goto out;
 	}
 
-	val = local_xchg(&drvdata->mode, mode);
 	/*
 	 * In sysFS mode we can have multiple writers per sink.  Since this
 	 * sink is already enabled no memory is needed and the HW need not be
 	 * touched.
 	 */
-	if (val == CS_MODE_SYSFS)
+	if (drvdata->mode == CS_MODE_SYSFS)
 		goto out;
 
 	/*
@@ -155,8 +169,7 @@ static int tmc_enable_etr_sink_sysfs(struct coresight_device *csdev, u32 mode)
 		drvdata->buf = drvdata->vaddr;
 	}
 
-	memset(drvdata->vaddr, 0, drvdata->size);
-
+	drvdata->mode = CS_MODE_SYSFS;
 	tmc_etr_enable_hw(drvdata);
 out:
 	spin_unlock_irqrestore(&drvdata->spinlock, flags);
@@ -171,34 +184,29 @@ static int tmc_enable_etr_sink_sysfs(struct coresight_device *csdev, u32 mode)
 	return ret;
 }
 
-static int tmc_enable_etr_sink_perf(struct coresight_device *csdev, u32 mode)
+static int tmc_enable_etr_sink_perf(struct coresight_device *csdev)
 {
 	int ret = 0;
-	long val;
 	unsigned long flags;
 	struct tmc_drvdata *drvdata = dev_get_drvdata(csdev->dev.parent);
 
-	 /* This shouldn't be happening */
-	if (WARN_ON(mode != CS_MODE_PERF))
-		return -EINVAL;
-
 	spin_lock_irqsave(&drvdata->spinlock, flags);
 	if (drvdata->reading) {
 		ret = -EINVAL;
 		goto out;
 	}
 
-	val = local_xchg(&drvdata->mode, mode);
 	/*
 	 * In Perf mode there can be only one writer per sink.  There
 	 * is also no need to continue if the ETR is already operated
 	 * from sysFS.
 	 */
-	if (val != CS_MODE_DISABLED) {
+	if (drvdata->mode != CS_MODE_DISABLED) {
 		ret = -EINVAL;
 		goto out;
 	}
 
+	drvdata->mode = CS_MODE_PERF;
 	tmc_etr_enable_hw(drvdata);
 out:
 	spin_unlock_irqrestore(&drvdata->spinlock, flags);
@@ -210,9 +218,9 @@ static int tmc_enable_etr_sink(struct coresight_device *csdev, u32 mode)
 {
 	switch (mode) {
 	case CS_MODE_SYSFS:
-		return tmc_enable_etr_sink_sysfs(csdev, mode);
+		return tmc_enable_etr_sink_sysfs(csdev);
 	case CS_MODE_PERF:
-		return tmc_enable_etr_sink_perf(csdev, mode);
+		return tmc_enable_etr_sink_perf(csdev);
 	}
 
 	/* We shouldn't be here */
@@ -221,7 +229,6 @@ static int tmc_enable_etr_sink(struct coresight_device *csdev, u32 mode)
 
 static void tmc_disable_etr_sink(struct coresight_device *csdev)
 {
-	long val;
 	unsigned long flags;
 	struct tmc_drvdata *drvdata = dev_get_drvdata(csdev->dev.parent);
 
@@ -231,19 +238,244 @@ static void tmc_disable_etr_sink(struct coresight_device *csdev)
 		return;
 	}
 
-	val = local_xchg(&drvdata->mode, CS_MODE_DISABLED);
 	/* Disable the TMC only if it needs to */
-	if (val != CS_MODE_DISABLED)
+	if (drvdata->mode != CS_MODE_DISABLED) {
 		tmc_etr_disable_hw(drvdata);
+		drvdata->mode = CS_MODE_DISABLED;
+	}
 
 	spin_unlock_irqrestore(&drvdata->spinlock, flags);
 
 	dev_info(drvdata->dev, "TMC-ETR disabled\n");
 }
 
+static void *tmc_alloc_etr_buffer(struct coresight_device *csdev, int cpu,
+				  void **pages, int nr_pages, bool overwrite)
+{
+	int node;
+	struct cs_etr_buffers *buf;
+	struct tmc_drvdata *drvdata = dev_get_drvdata(csdev->dev.parent);
+
+	if (cpu == -1)
+		cpu = smp_processor_id();
+	node = cpu_to_node(cpu);
+
+	/* Allocate memory structure for interaction with Perf */
+	buf = kzalloc_node(sizeof(struct cs_etr_buffers), GFP_KERNEL, node);
+	if (!buf)
+		return NULL;
+
+	buf->dev = drvdata->dev;
+	buf->size = drvdata->size;
+	buf->vaddr = dma_alloc_coherent(buf->dev, buf->size,
+					&buf->paddr, GFP_KERNEL);
+	if (!buf->vaddr) {
+		kfree(buf);
+		return NULL;
+	}
+
+	buf->tmc.snapshot = overwrite;
+	buf->tmc.nr_pages = nr_pages;
+	buf->tmc.data_pages = pages;
+
+	return buf;
+}
+
+static void tmc_free_etr_buffer(void *config)
+{
+	struct cs_etr_buffers *buf = config;
+
+	dma_free_coherent(buf->dev, buf->size, buf->vaddr, buf->paddr);
+	kfree(buf);
+}
+
+static int tmc_set_etr_buffer(struct coresight_device *csdev,
+			      struct perf_output_handle *handle,
+			      void *sink_config)
+{
+	int ret = 0;
+	unsigned long head;
+	struct cs_etr_buffers *buf = sink_config;
+	struct tmc_drvdata *drvdata = dev_get_drvdata(csdev->dev.parent);
+
+	/* wrap head around to the amount of space we have */
+	head = handle->head & ((buf->tmc.nr_pages << PAGE_SHIFT) - 1);
+
+	/* find the page to write to */
+	buf->tmc.cur = head / PAGE_SIZE;
+
+	/* and offset within that page */
+	buf->tmc.offset = head % PAGE_SIZE;
+
+	local_set(&buf->tmc.data_size, 0);
+
+	/* Tell the HW where to put the trace data */
+	drvdata->vaddr = buf->vaddr;
+	drvdata->paddr = buf->paddr;
+	memset(drvdata->vaddr, 0, drvdata->size);
+
+	return ret;
+}
+
+static unsigned long tmc_reset_etr_buffer(struct coresight_device *csdev,
+					  struct perf_output_handle *handle,
+					  void *sink_config, bool *lost)
+{
+	long size = 0;
+	struct cs_etr_buffers *buf = sink_config;
+	struct tmc_drvdata *drvdata = dev_get_drvdata(csdev->dev.parent);
+
+	if (buf) {
+		/*
+		 * In snapshot mode ->data_size holds the new address of the
+		 * ring buffer's head.  The size itself is the whole address
+		 * range since we want the latest information.
+		 */
+		if (buf->tmc.snapshot) {
+			size = buf->tmc.nr_pages << PAGE_SHIFT;
+			handle->head = local_xchg(&buf->tmc.data_size, size);
+		}
+
+		/*
+		 * Tell the tracer PMU how much we got in this run and if
+		 * something went wrong along the way.  Nobody else can use
+		 * this cs_etr_buffers instance until we are done.  As such
+		 * resetting parameters here and squaring off with the ring
+		 * buffer API in the tracer PMU is fine.
+		 */
+		*lost = !!local_xchg(&buf->tmc.lost, 0);
+		size = local_xchg(&buf->tmc.data_size, 0);
+	}
+
+	/* Get ready for another run */
+	drvdata->vaddr = NULL;
+	drvdata->paddr = 0;
+
+	return size;
+}
+
+static void tmc_update_etr_buffer(struct coresight_device *csdev,
+				  struct perf_output_handle *handle,
+				  void *sink_config)
+{
+	int i, cur;
+	u32 *buf_ptr;
+	u32 read_ptr, write_ptr;
+	u32 status, to_read;
+	unsigned long offset;
+	struct cs_buffers *buf = sink_config;
+	struct tmc_drvdata *drvdata = dev_get_drvdata(csdev->dev.parent);
+
+	if (!buf)
+		return;
+
+	/* This shouldn't happen */
+	if (WARN_ON_ONCE(drvdata->mode != CS_MODE_PERF))
+		return;
+
+	CS_UNLOCK(drvdata->base);
+
+	tmc_flush_and_stop(drvdata);
+
+	read_ptr = readl_relaxed(drvdata->base + TMC_RRP);
+	write_ptr = readl_relaxed(drvdata->base + TMC_RWP);
+
+	/*
+	 * Get a hold of the status register and see if a wrap around
+	 * has occurred.  If so adjust things accordingly.
+	 */
+	status = readl_relaxed(drvdata->base + TMC_STS);
+	if (status & TMC_STS_FULL) {
+		local_inc(&buf->lost);
+		to_read = drvdata->size;
+	} else {
+		to_read = CIRC_CNT(write_ptr, read_ptr, drvdata->size);
+	}
+
+	/*
+	 * The TMC RAM buffer may be bigger than the space available in the
+	 * perf ring buffer (handle->size).  If so advance the RRP so that we
+	 * get the latest trace data.
+	 */
+	if (to_read > handle->size) {
+		u32 buffer_start, mask = 0;
+
+		/* Read buffer start address in system memory */
+		buffer_start = readl_relaxed(drvdata->base + TMC_DBALO);
+
+		/*
+		 * The value written to RRP must be byte-address aligned to
+		 * the width of the trace memory databus _and_ to a frame
+		 * boundary (16 byte), whichever is the biggest. For example,
+		 * for 32-bit, 64-bit and 128-bit wide trace memory, the four
+		 * LSBs must be 0s. For 256-bit wide trace memory, the five
+		 * LSBs must be 0s.
+		 */
+		switch (drvdata->memwidth) {
+		case TMC_MEM_INTF_WIDTH_32BITS:
+		case TMC_MEM_INTF_WIDTH_64BITS:
+		case TMC_MEM_INTF_WIDTH_128BITS:
+			mask = GENMASK(31, 5);
+			break;
+		case TMC_MEM_INTF_WIDTH_256BITS:
+			mask = GENMASK(31, 6);
+			break;
+		}
+
+		/*
+		 * Make sure the new size is aligned in accordance with the
+		 * requirement explained above.
+		 */
+		to_read = handle->size & mask;
+		/* Move the RAM read pointer up */
+		read_ptr = (write_ptr + drvdata->size) - to_read;
+		/* Make sure we are still within our limits */
+		if (read_ptr > (buffer_start + (drvdata->size - 1)))
+			read_ptr -= drvdata->size;
+		/* Tell the HW */
+		writel_relaxed(read_ptr, drvdata->base + TMC_RRP);
+		local_inc(&buf->lost);
+	}
+
+	cur = buf->cur;
+	offset = buf->offset;
+
+	/* for every byte to read */
+	for (i = 0; i < to_read; i += 4) {
+		buf_ptr = buf->data_pages[cur] + offset;
+		*buf_ptr = readl_relaxed(drvdata->base + TMC_RRD);
+
+		offset += 4;
+		if (offset >= PAGE_SIZE) {
+			offset = 0;
+			cur++;
+			/* wrap around at the end of the buffer */
+			cur &= buf->nr_pages - 1;
+		}
+	}
+
+	/*
+	 * In snapshot mode all we have to do is communicate to
+	 * perf_aux_output_end() the address of the current head.  In full
+	 * trace mode the same function expects a size to move rb->aux_head
+	 * forward.
+	 */
+	if (buf->snapshot)
+		local_set(&buf->data_size, (cur * PAGE_SIZE) + offset);
+	else
+		local_add(to_read, &buf->data_size);
+
+	CS_LOCK(drvdata->base);
+}
+
 static const struct coresight_ops_sink tmc_etr_sink_ops = {
 	.enable		= tmc_enable_etr_sink,
 	.disable	= tmc_disable_etr_sink,
+	.alloc_buffer	= tmc_alloc_etr_buffer,
+	.free_buffer	= tmc_free_etr_buffer,
+	.set_buffer	= tmc_set_etr_buffer,
+	.reset_buffer	= tmc_reset_etr_buffer,
+	.update_buffer	= tmc_update_etr_buffer,
 };
 
 const struct coresight_ops tmc_etr_cs_ops = {
@@ -253,7 +485,6 @@ static void tmc_disable_etr_sink(struct coresight_device *csdev)
 int tmc_read_prepare_etr(struct tmc_drvdata *drvdata)
 {
 	int ret = 0;
-	long val;
 	unsigned long flags;
 
 	/* config types are set a boot time and never change */
@@ -266,9 +497,8 @@ int tmc_read_prepare_etr(struct tmc_drvdata *drvdata)
 		goto out;
 	}
 
-	val = local_read(&drvdata->mode);
 	/* Don't interfere if operated from Perf */
-	if (val == CS_MODE_PERF) {
+	if (drvdata->mode == CS_MODE_PERF) {
 		ret = -EINVAL;
 		goto out;
 	}
@@ -280,7 +510,7 @@ int tmc_read_prepare_etr(struct tmc_drvdata *drvdata)
 	}
 
 	/* Disable the TMC if need be */
-	if (val == CS_MODE_SYSFS)
+	if (drvdata->mode == CS_MODE_SYSFS)
 		tmc_etr_disable_hw(drvdata);
 
 	drvdata->reading = true;
@@ -303,7 +533,7 @@ int tmc_read_unprepare_etr(struct tmc_drvdata *drvdata)
 	spin_lock_irqsave(&drvdata->spinlock, flags);
 
 	/* RE-enable the TMC if need be */
-	if (local_read(&drvdata->mode) == CS_MODE_SYSFS) {
+	if (drvdata->mode == CS_MODE_SYSFS) {
 		/*
 		 * The trace run will continue with the same allocated trace
 		 * buffer. The trace buffer is cleared in tmc_etr_enable_hw(),
diff --git a/drivers/hwtracing/coresight/coresight-tmc.h b/drivers/hwtracing/coresight/coresight-tmc.h
index 44b3ae3..51c0185 100644
--- a/drivers/hwtracing/coresight/coresight-tmc.h
+++ b/drivers/hwtracing/coresight/coresight-tmc.h
@@ -117,7 +117,7 @@ struct tmc_drvdata {
 	void __iomem		*vaddr;
 	u32			size;
 	u32			len;
-	local_t			mode;
+	u32			mode;
 	enum tmc_config_type	config_type;
 	enum tmc_mem_intf_width	memwidth;
 	u32			trigger_cntr;
diff --git a/drivers/hwtracing/coresight/coresight.c b/drivers/hwtracing/coresight/coresight.c
index 4383324..62faa58 100644
--- a/drivers/hwtracing/coresight/coresight.c
+++ b/drivers/hwtracing/coresight/coresight.c
@@ -368,6 +368,52 @@ struct coresight_device *coresight_get_sink(struct list_head *path)
 	return csdev;
 }
 
+static int coresight_enabled_sink(struct device *dev, void *data)
+{
+	bool *reset = data;
+	struct coresight_device *csdev = to_coresight_device(dev);
+
+	if ((csdev->type == CORESIGHT_DEV_TYPE_SINK ||
+	     csdev->type == CORESIGHT_DEV_TYPE_LINKSINK) &&
+	     csdev->activated) {
+		/*
+		 * Now that we have a handle on the sink for this session,
+		 * disable the sysFS "enable_sink" flag so that possible
+		 * concurrent perf session that wish to use another sink don't
+		 * trip on it.  Doing so has no ramification for the current
+		 * session.
+		 */
+		if (*reset)
+			csdev->activated = false;
+
+		return 1;
+	}
+
+	return 0;
+}
+
+/**
+ * coresight_get_enabled_sink - returns the first enabled sink found on the bus
+ * @deactivate:	Whether the 'enable_sink' flag should be reset
+ *
+ * When operated from perf the deactivate parameter should be set to 'true'.
+ * That way the "enabled_sink" flag of the sink that was selected can be reset,
+ * allowing for other concurrent perf sessions to choose a different sink.
+ *
+ * When operated from sysFS users have full control and as such the deactivate
+ * parameter should be set to 'false', hence mandating users to explicitly
+ * clear the flag.
+ */
+struct coresight_device *coresight_get_enabled_sink(bool deactivate)
+{
+	struct device *dev = NULL;
+
+	dev = bus_find_device(&coresight_bustype, NULL, &deactivate,
+			      coresight_enabled_sink);
+
+	return dev ? to_coresight_device(dev) : NULL;
+}
+
 /**
  * _coresight_build_path - recursively build a path from a @csdev to a sink.
  * @csdev:	The device to start from.
@@ -380,6 +426,7 @@ struct coresight_device *coresight_get_sink(struct list_head *path)
  * last one.
  */
 static int _coresight_build_path(struct coresight_device *csdev,
+				 struct coresight_device *sink,
 				 struct list_head *path)
 {
 	int i;
@@ -387,15 +434,15 @@ static int _coresight_build_path(struct coresight_device *csdev,
 	struct coresight_node *node;
 
 	/* An activated sink has been found.  Enqueue the element */
-	if ((csdev->type == CORESIGHT_DEV_TYPE_SINK ||
-	     csdev->type == CORESIGHT_DEV_TYPE_LINKSINK) && csdev->activated)
+	if (csdev == sink)
 		goto out;
 
 	/* Not a sink - recursively explore each port found on this element */
 	for (i = 0; i < csdev->nr_outport; i++) {
 		struct coresight_device *child_dev = csdev->conns[i].child_dev;
 
-		if (child_dev && _coresight_build_path(child_dev, path) == 0) {
+		if (child_dev &&
+		    _coresight_build_path(child_dev, sink, path) == 0) {
 			found = true;
 			break;
 		}
@@ -422,18 +469,22 @@ static int _coresight_build_path(struct coresight_device *csdev,
 	return 0;
 }
 
-struct list_head *coresight_build_path(struct coresight_device *csdev)
+struct list_head *coresight_build_path(struct coresight_device *source,
+				       struct coresight_device *sink)
 {
 	struct list_head *path;
 	int rc;
 
+	if (!sink)
+		return ERR_PTR(-EINVAL);
+
 	path = kzalloc(sizeof(struct list_head), GFP_KERNEL);
 	if (!path)
 		return ERR_PTR(-ENOMEM);
 
 	INIT_LIST_HEAD(path);
 
-	rc = _coresight_build_path(csdev, path);
+	rc = _coresight_build_path(source, sink, path);
 	if (rc) {
 		kfree(path);
 		return ERR_PTR(rc);
@@ -497,6 +548,7 @@ static int coresight_validate_source(struct coresight_device *csdev,
 int coresight_enable(struct coresight_device *csdev)
 {
 	int cpu, ret = 0;
+	struct coresight_device *sink;
 	struct list_head *path;
 	enum coresight_dev_subtype_source subtype;
 
@@ -519,7 +571,17 @@ int coresight_enable(struct coresight_device *csdev)
 		goto out;
 	}
 
-	path = coresight_build_path(csdev);
+	/*
+	 * Search for a valid sink for this session but don't reset the
+	 * "enable_sink" flag in sysFS.  Users get to do that explicitly.
+	 */
+	sink = coresight_get_enabled_sink(false);
+	if (!sink) {
+		ret = -EINVAL;
+		goto out;
+	}
+
+	path = coresight_build_path(csdev, sink);
 	if (IS_ERR(path)) {
 		pr_err("building path(s) failed\n");
 		ret = PTR_ERR(path);
diff --git a/drivers/i2c/algos/Kconfig b/drivers/i2c/algos/Kconfig
index f1cfe7e..cd531e3 100644
--- a/drivers/i2c/algos/Kconfig
+++ b/drivers/i2c/algos/Kconfig
@@ -14,4 +14,10 @@ config I2C_ALGOPCF
 config I2C_ALGOPCA
 	tristate "I2C PCA 9564 interfaces"
 
+config I2C_ALGO_PHOENIX
+	tristate "I2C Realtek Phoenix interface"
+	depends on I2C
+	help
+	  Supports the Realtek Phoenix I2C
+
 endmenu
diff --git a/drivers/i2c/algos/Makefile b/drivers/i2c/algos/Makefile
index 215303f..d9b6b1b 100644
--- a/drivers/i2c/algos/Makefile
+++ b/drivers/i2c/algos/Makefile
@@ -5,5 +5,6 @@
 obj-$(CONFIG_I2C_ALGOBIT)	+= i2c-algo-bit.o
 obj-$(CONFIG_I2C_ALGOPCF)	+= i2c-algo-pcf.o
 obj-$(CONFIG_I2C_ALGOPCA)	+= i2c-algo-pca.o
+obj-$(CONFIG_I2C_PHOENIX)	+= i2c-algo-phoenix.o
 
 ccflags-$(CONFIG_I2C_DEBUG_ALGO) := -DDEBUG
diff --git a/drivers/i2c/algos/i2c-algo-phoenix.c b/drivers/i2c/algos/i2c-algo-phoenix.c
new file mode 100644
index 00000000..97f6f79
--- /dev/null
+++ b/drivers/i2c/algos/i2c-algo-phoenix.c
@@ -0,0 +1,107 @@
+/*
+ * i2c-algo-venus.c: i2c driver algorithms for Realtek Venus DVR
+ * 
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License version 2 as published by the Free Software Foundation.
+ *
+ * Copyright (C) 2005 Chih-pin Wu <wucp@realtek.com.tw>
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/errno.h>
+#include <linux/delay.h>
+
+#include <linux/i2c-dev.h>
+#include <linux/proc_fs.h>
+#include "i2c-algo-phoenix.h"
+
+
+/*------------------------------------------------------------------
+ * Func : venus_xfer
+ *
+ * Desc : 
+ *
+ * Parm : adapter : i2c adapter
+ *
+ * Retn : 
+ *------------------------------------------------------------------*/ 
+static 
+int venus_xfer(
+    struct i2c_adapter*     i2c_adap,
+    struct i2c_msg*         msgs,
+    int                     num
+    )
+{
+    i2c_venus_algo* p_alog = (i2c_venus_algo*) i2c_adap->algo_data;
+    
+    return p_alog->masterXfer(p_alog->dev_id, msgs, num);	
+}
+
+
+/*------------------------------------------------------------------
+ * Func : venus_func
+ *
+ * Desc : 
+ *
+ * Parm : adapter : i2c adapter
+ *
+ * Retn : 
+ *------------------------------------------------------------------*/ 
+static 
+u32 venus_func(
+    struct i2c_adapter*     adap
+    )
+{
+	return I2C_FUNC_SMBUS_EMUL;
+}	
+
+
+static 
+struct i2c_algorithm venus_algo = {		
+	.master_xfer	= venus_xfer,	
+	.functionality	= venus_func,
+};
+
+ 
+ 
+/*------------------------------------------------------------------
+ * Func : i2c_venus_add_bus
+ *
+ * Desc : add an venus i2c adapter onto i2c bus
+ *
+ * Parm : adapter : i2c adapter 
+ *
+ * Retn : 
+ *------------------------------------------------------------------*/  
+int i2c_venus_add_bus(struct i2c_adapter *adap)
+{        	
+	adap->algo = &venus_algo;   	
+	return i2c_add_adapter(adap);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : i2c_venus_add_bus
+ *
+ * Desc : delete an venus i2c adapter from i2c bus
+ *
+ * Parm : adapter : i2c adapter 
+ *
+ * Retn : 
+ *------------------------------------------------------------------*/
+int i2c_venus_del_bus(struct i2c_adapter *adap)
+{    
+	i2c_del_adapter(adap);
+	return ;
+}
+
+
+EXPORT_SYMBOL(i2c_venus_add_bus);
+EXPORT_SYMBOL(i2c_venus_del_bus);
+
+MODULE_AUTHOR("Kevin Wang <kevin_wang@realtek.com>");
+MODULE_DESCRIPTION("I2C-Bus Venus algorithm");
+MODULE_LICENSE("GPL");
diff --git a/drivers/i2c/algos/i2c-algo-phoenix.h b/drivers/i2c/algos/i2c-algo-phoenix.h
new file mode 100644
index 00000000..5eb2792
--- /dev/null
+++ b/drivers/i2c/algos/i2c-algo-phoenix.h
@@ -0,0 +1,49 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License version 2 as published by the Free Software Foundation.
+ *
+ * Copyright (C) 2005 Chih-pin Wu <wucp@realtek.com.tw>
+ */
+
+#ifndef I2C_ALGO_VENUS_H
+#define I2C_ALGO_VENUS_H
+
+#include <linux/i2c.h>
+
+
+#define MAX_NAME_LENGTH     32
+
+typedef struct  
+{	
+    unsigned char   addr;
+    char            name[MAX_NAME_LENGTH];
+}venus_i2c_name_param;
+
+typedef struct {
+    unsigned int        tx_count;
+    unsigned int        tx_err;
+    unsigned int        rx_count;    
+    unsigned int        rx_err;
+	char                name[MAX_NAME_LENGTH];	
+}target_info;
+
+typedef struct 
+{    
+	void* dev_id;
+	int (*masterXfer)(void* dev_id, struct i2c_msg *msgs, int num);
+	int (*set_speed) (void* dev_id, int KHz);
+	
+}i2c_venus_algo;
+
+
+
+int i2c_venus_add_bus(struct i2c_adapter *);
+int i2c_venus_del_bus(struct i2c_adapter *);
+int venus_set_target_name(
+    struct i2c_adapter*     adapter,     
+    unsigned char           addr,
+    const char*             name, 
+    unsigned char           length 
+    );
+
+#endif /* I2C_ALGO_VENUS_H */
diff --git a/drivers/i2c/busses/Kconfig b/drivers/i2c/busses/Kconfig
index d252276..ae6b157 100644
--- a/drivers/i2c/busses/Kconfig
+++ b/drivers/i2c/busses/Kconfig
@@ -1214,4 +1214,14 @@ config I2C_OPAL
 	  This driver can also be built as a module. If so, the module will be
 	  called as i2c-opal.
 
+config I2C_RTK
+	tristate "Realtek I2C"
+	depends on I2C
+	help
+	  This driver supports I2C Controller on Realtek SoC
+
+config I2C_RTK_SECURE_ACCESS
+	bool
+	depends on HAVE_ARM_SMCCC
+
 endmenu
diff --git a/drivers/i2c/busses/Makefile b/drivers/i2c/busses/Makefile
index 29764cc..03eecc6 100644
--- a/drivers/i2c/busses/Makefile
+++ b/drivers/i2c/busses/Makefile
@@ -121,5 +121,6 @@ obj-$(CONFIG_I2C_PCA_ISA)	+= i2c-pca-isa.o
 obj-$(CONFIG_I2C_SIBYTE)	+= i2c-sibyte.o
 obj-$(CONFIG_I2C_XGENE_SLIMPRO) += i2c-xgene-slimpro.o
 obj-$(CONFIG_SCx200_ACB)	+= scx200_acb.o
+obj-$(CONFIG_I2C_RTK)		+= i2c-rtk.o i2c-rtk-priv.o
 
 ccflags-$(CONFIG_I2C_DEBUG_BUS) := -DDEBUG
diff --git a/drivers/i2c/busses/i2c-rtk-priv.c b/drivers/i2c/busses/i2c-rtk-priv.c
new file mode 100644
index 00000000..f48bcaa
--- /dev/null
+++ b/drivers/i2c/busses/i2c-rtk-priv.c
@@ -0,0 +1,1394 @@
+/*
+ * Realtek I2C driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+
+#include <linux/kernel.h>
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <linux/i2c.h>
+#include <linux/io.h>
+#include <linux/delay.h>
+#include <linux/arm-smccc.h>
+#include <asm/irq.h>
+
+#include "i2c-rtk-priv.h"
+
+#ifdef CONFIG_I2C_RTK_SECURE_ACCESS
+extern bool secure_dvfs_is_disabled(void);
+
+static void swc_write(unsigned int address, unsigned int value)
+{
+	struct arm_smccc_res res;
+
+	arm_smccc_smc(0x8400ff0a, value, 0, 0, 0, 0, 0, 0, &res);
+//	ta_hdcp_lib_set_i2c_enable(value);
+}
+
+void SET_IC_ENABLE(struct rtk_i2c_handler *handler, int value)
+{
+	if (handler->id == 0 && !secure_dvfs_is_disabled())
+		smc_write(handler->reg_map.IC_ENABLE, value);
+	else
+		wr_reg(handler->reg_map.IC_ENABLE, value);
+}
+#endif
+/*
+ * Func : rtk_i2c_init
+ * Desc : init rtk i2c
+ * Parm : handler : handle of rtk i2c
+ * Retn : 0
+ */
+int rtk_i2c_handler_init(struct rtk_i2c_handler *handler)
+{
+	RTK_DEBUG("%s\n", __func__);
+
+#if defined(CONFIG_I2C_RTK_SECURE_ACCESS)
+//	if (handler->id == 0)
+//		ta_i2c_init();
+#endif
+#if 0
+	if (handler->flags & RTK_I2C_IRQ_RDY)
+		return 0;
+
+	if (rtk_i2c_probe(handler) < 0)
+		return -ENODEV;
+
+	ret = request_irq(handler->irq, rtk_i2c_isr, SA_SHIRQ, "i2c",
+		(void *) handler);
+	if (ret < 0) {
+		pr_err("FATAL: Request irq %d failed(ret=%d)\n",
+			handler->irq, ret);
+		return -ENODEV;
+	}
+#endif
+
+	handler->flags = RTK_I2C_IRQ_RDY;
+	handler->rx_fifo_depth =
+		((GET_IC_COMP_PARAM_1(handler) >>  8) & 0xFF) + 1;
+	handler->tx_fifo_depth =
+		((GET_IC_COMP_PARAM_1(handler) >> 16) & 0xFF) + 1;
+	init_waitqueue_head(&handler->wq);
+
+	spin_lock_init(&handler->lock);
+
+	return rtk_i2c_phy_init(handler);
+}
+
+/*
+ * Func : rtk_i2c_uninit
+ * Desc : uninit rtk i2c
+ * Parm : handler : handle of rtk i2c
+ * Retn : 0
+ */
+int rtk_i2c_handler_uninit(struct rtk_i2c_handler *handler)
+{
+	RTK_DEBUG("%s\n", __func__);
+
+	SET_IC_ENABLE(handler, 0);
+	SET_IC_INTR_MASK(handler, 0);
+
+	if ((handler->flags & RTK_I2C_IRQ_RDY)) {
+		free_irq(handler->irq, handler);
+		handler->flags = 0;
+	}
+
+	return 0;
+}
+
+/*
+ * Func : rtk_i2c_phy_init
+ * Desc : init rtk i2c phy
+ * Parm : handler : handle of rtk i2c
+ * Retn : 0
+ */
+int rtk_i2c_phy_init(struct rtk_i2c_handler *handler)
+{
+	RTK_DEBUG("%s\n", __func__);
+
+	SET_IC_ENABLE(handler, 0);
+	SET_IC_INTR_MASK(handler, 0); /* disable all interrupt*/
+	SET_IC_CON(handler,
+		IC_SLAVE_DISABLE | IC_RESTART_EN | SPEED_SS | IC_MASTER_MODE);
+	SET_IC_TX_TL(handler, FIFO_THRESHOLD);
+	SET_IC_RX_TL(handler, handler->rx_fifo_depth - FIFO_THRESHOLD);
+	handler->set_spd(handler, handler->spd);
+
+#ifdef DEV_DEBUG
+	rtk_i2c_dump(handler);
+#endif
+	return 0;
+}
+
+/*
+ * Func : rtk_i2c_set_spd
+ * Desc : set speed of rtk i2c
+ * Parm : handler:handle of rtk i2c
+ *	KHz:operation speed of i2c
+ * Retn : 0
+ */
+int rtk_i2c_set_spd(struct rtk_i2c_handler *handler, int KHz)
+{
+	unsigned int scl_time;
+	unsigned int div_h;
+	unsigned int div_l;
+	unsigned long sda_del;
+	unsigned int clk_time;
+
+	RTK_DEBUG("%s\n", __func__);
+
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	if (handler->id == 0) {
+		if (KHz < 10 || KHz > 3400) {
+			pr_err("[I2C%d] warning, speed %d out of range,",
+				handler->id, KHz);
+			pr_err("speed should between 10 ~ 3400KHz\n");
+			return -1;
+		}
+	} else {
+		if (KHz < 10 || KHz > 800) {
+			pr_err("[I2C%d] warning, speed %d out of range,",
+				handler->id, KHz);
+			pr_err("speed should between 10 ~ 800KHz\n");
+			return -1;
+		}
+	}
+#else
+	if (KHz < 10 || KHz > 800) {
+		pr_err("[I2C%d] warning, speed %d out of range,",
+			handler->id, KHz);
+		pr_err("speed should between 10 ~ 800KHz\n");
+		return -1;
+	}
+#endif
+
+	clk_time = 37; /*27MHZ*/
+
+	scl_time = (1000000 / KHz) / 2; /* the time ns need for SCL high/low */
+	if (scl_time % clk_time) {
+		if ((scl_time % clk_time) > clk_time / 2)
+			scl_time += (clk_time - (scl_time % clk_time));
+		else
+			scl_time -= (scl_time % clk_time);
+	}
+
+	/*
+	 * 27MHz crystal generate one clock 37ns,
+	 * 108MHz crystal generate one clock 9ns,
+	 * for synopsys design ware ip v1.14a, SCL_LCNT need -1,
+	 * SCL_HCNT need -8, 400KHz SCL Low required min 1.3 us
+	 */
+
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+
+	if (handler->id == 0) {
+		if (KHz == 100){
+			div_h = 524;
+			div_l = 532;
+		} else if (KHz == 400){
+			div_h = 106;
+			div_l = 146;
+		} else if (KHz == 3400) {
+			div_h = 6;
+			div_l = 11;
+		}
+	} else {
+		if (KHz < 400) {
+			div_h = (scl_time / clk_time) - 8;
+			/*div_l + 1 to meet SPEC*/
+			div_l = (scl_time / clk_time) - 1 + 1;
+		} else {
+			div_h = 21;
+			div_l = 35;
+		}
+	}
+
+#else
+	if (KHz < 400) {
+		div_h = (scl_time / clk_time) - 8;
+		div_l = (scl_time / clk_time) - 1;
+	} else {
+		div_h = 24;
+		div_l = 34;
+	}
+
+	if (div_h >= 0xFFFF || div_h == 0 || div_l >= 0xFFFF || div_l == 0) {
+		pr_err("[I2C%d] fatal, set speed failed : ", handler->id);
+		pr_err("divider divider out of range.");
+		pr_err("div_h = %d, div_l = %d\n", div_h, div_l);
+		return -1;
+	}
+
+#endif
+
+	RTK_DEBUG("[I2C%d] KHz = %d, div_h = %d, div_l = %d\n",
+		handler->id, KHz, div_h, div_l);
+
+
+	SET_IC_ENABLE(handler, 0);
+
+	if (KHz <= 100) {
+		SET_IC_CON(handler, (GET_IC_CON(handler) &
+			(~IC_SPEED)) | SPEED_SS);
+		SET_IC_SS_SCL_HCNT(handler, div_h);
+		SET_IC_SS_SCL_LCNT(handler, div_l);
+	} else if(KHz >= 400 && KHz < 3400) {
+		SET_IC_CON(handler, (GET_IC_CON(handler) &
+			(~IC_SPEED)) | SPEED_FS);
+		SET_IC_FS_SCL_HCNT(handler, div_h);
+		SET_IC_FS_SCL_LCNT(handler, div_l);
+	} else if (KHz == 3400) {
+		SET_IC_CON(handler, (GET_IC_CON(handler) &
+			(~IC_SPEED)) | SPEED_HS);
+		SET_IC_HS_SCL_HCNT(handler, div_h);
+		SET_IC_HS_SCL_LCNT(handler, div_l);
+	}
+
+	handler->spd = KHz;
+	/*Todo: Fix tick for 3.4MHz*/
+	handler->tick = 1000 / KHz;
+
+	/*Set SDA delay time */
+	if (KHz == 3400) { /*disabled sda_del*/
+		sda_del = 0x0;
+	} else {
+		if (handler->id == 0) {
+			sda_del = GET_IC_SDA_DEL(handler) & ~I2C_SDA_DEL_MASK;
+			sda_del |= I2C_SDA_DEL_EN | I2C_SDA_DEL_SEL(I2C0_SDA_DEL_520NS);
+		} else {
+			sda_del = GET_IC_SDA_DEL(handler) & ~I2C_SDA_DEL_MASK;
+			sda_del |= I2C_SDA_DEL_EN | I2C_SDA_DEL_SEL(SDA_DEL_518NS);
+		}
+	}
+	SET_IC_SDA_DEL(handler, sda_del);
+
+	return 0;
+}
+
+/**
+ * Func : rtk_i2c_set_tar
+ * Desc : set tar of rtk i2c
+ * Parm : handler : handle of rtk i2c
+ *	addr : address of sar
+ *	mode : mode of sar
+ * Retn : 0
+ */
+int rtk_i2c_set_tar(struct rtk_i2c_handler *handler, unsigned short addr,
+	enum ADDR_MODE mode)
+{
+	RTK_DEBUG("%s\n", __func__);
+
+	if (mode == ADDR_MODE_10BITS) {
+		if (addr > ADDR_10BITS_MASK)
+			return -EADDROVERRANGE;
+
+		SET_IC_ENABLE(handler, 0);
+		SET_IC_TAR(handler, addr & ADDR_10BITS_MASK);
+		SET_IC_CON(handler, (GET_IC_CON(handler) &
+			(~IC_10BITADDR_MASTER)) | IC_10BITADDR_MASTER);
+	} else {
+		if (addr > ADDR_7BITS_MASK)
+			return -EADDROVERRANGE;
+
+		SET_IC_ENABLE(handler, 0);
+		SET_IC_TAR(handler, addr & ADDR_7BITS_MASK);
+		SET_IC_CON(handler, GET_IC_CON(handler) &
+			(~IC_10BITADDR_MASTER));
+	}
+
+	handler->tar = addr;
+	handler->tar_mode = mode;
+
+	return 0;
+}
+
+/*
+ * Func : rtk_i2c_set_guard_interval
+ * Desc : set guard_interval of rtk i2c
+ * Parm : handler : handle of rtk i2c
+ *		us : operation speed of i2c
+ * Retn : 0
+ */
+int rtk_i2c_set_guard_interval(struct rtk_i2c_handler *handler,
+	unsigned long us)
+{
+	RTK_DEBUG("%s\n", __func__);
+	handler->guard_interval = us;
+	return 0;
+}
+
+/*
+ * Func : rtk_i2c_read
+ * Desc : read data from sar
+ * Parm : handler : handle of rtk i2c
+ * Retn : 0 for success, others is failed
+ */
+int rtk_i2c_read(struct rtk_i2c_handler *handler,
+	unsigned char *tx_buf, unsigned short tx_buf_len,
+	unsigned char *rx_buf, unsigned short rx_buf_len)
+{
+	int retry = 2;
+	unsigned int ret = 0;
+
+	RTK_DEBUG("%s\n", __func__);
+
+	while (retry > 0) {
+		rtk_i2c_load_message(handler,
+			tx_buf_len ? I2C_MASTER_RANDOM_READ : I2C_MASTER_READ,
+			tx_buf, tx_buf_len,
+			rx_buf, rx_buf_len, 0);
+
+		ret = rtk_i2c_start_xfer(handler);
+		if (ret != -ETIMEOUT)
+			break;
+
+		/*JAM_DEBUG("[I2C] read timeout detected, do retry\n");*/
+		retry--;
+	}
+
+	return ret;
+}
+
+/*
+ * Func : rtk_i2c_write
+ * Desc : write data to sar
+ * Parm : handler : handle of rtk i2c
+ *	tx_buf : data to write
+ *	tx_buf_len : number of bytes to write
+ *	wait_stop  : wait for stop of not (extension)
+ * Retn : 0 for success, others is failed
+ */
+int rtk_i2c_write(struct rtk_i2c_handler *handler, unsigned char *tx_buf,
+	unsigned short tx_buf_len, unsigned char wait_stop)
+{
+	int retry = 2;
+	unsigned int ret = 0;
+
+	RTK_DEBUG("%s\n", __func__);
+
+	while (retry > 0) {
+		rtk_i2c_load_message(handler, I2C_MASTER_WRITE, tx_buf,
+			tx_buf_len, NULL, 0, (wait_stop) ? 0 : I2C_NO_STOP);
+
+		ret = rtk_i2c_start_xfer(handler);
+
+		if (ret != -ETIMEOUT)
+			break;
+
+		retry--;
+	}
+
+	return ret;
+}
+
+/*
+ * Func : rtk_i2c_load_message
+ * Desc : load a i2c message (just add this message to the queue)
+ * Parm : handler : handle of rtk i2c
+ * Retn : 0 for success, others is failed
+ */
+int rtk_i2c_load_message(struct rtk_i2c_handler *handler,
+		unsigned char mode, unsigned char *tx_buf,
+		unsigned short tx_buf_len, unsigned char *rx_buf,
+		unsigned short rx_buf_len, unsigned char xfer_flags)
+{
+	unsigned long flags;
+
+	RTK_DEBUG("%s\n", __func__);
+
+	LOCK_RTK_I2C(&handler->lock, flags);
+
+	memset(&handler->xfer, 0, sizeof(handler->xfer));
+
+	handler->xfer.mode = mode;
+	handler->xfer.flags = xfer_flags;
+	handler->xfer.tx_buff = tx_buf;
+	handler->xfer.tx_buff_len = tx_buf_len;
+	handler->xfer.tx_len = 0;
+	handler->xfer.rx_buff = rx_buf;
+	handler->xfer.rx_buff_len = rx_buf_len;
+	handler->xfer.rx_len = 0;
+	handler->xfer.except_time =
+		((tx_buf_len + rx_buf_len + 2) * 9 * handler->tick);
+
+	if (rx_buf && rx_buf_len)
+		memset(rx_buf, 0, rx_buf_len);
+
+	//handler->xfer.gpio_xfer_state = G2C_ST_START;
+	//handler->xfer.gpio_xfer_sub_state = 0;
+
+	UNLOCK_RTK_I2C(&handler->lock, flags);
+
+#ifdef DEV_DEBUG
+	{
+		int i;
+
+		pr_info("%s xfer.mode = %x\n",
+			__func__, handler->xfer.mode);
+		pr_info("%s xfer.flags= 0x%x\n",
+			__func__, handler->xfer.flags);
+
+		if (handler->xfer.tx_buff_len) {
+			for (i = 0; i < handler->xfer.tx_buff_len; i++) {
+				pr_info("%s xfer.tx_buff= 0x%x\n",
+					__func__, *handler->xfer.tx_buff);
+				pr_info("%s xfer.tx_buff= 0x%x\n",
+					__func__, handler->xfer.tx_buff[i]);
+			}
+		}
+
+		pr_info("%s xfer.tx_buff_len= 0x%x\n",
+			__func__, handler->xfer.tx_buff_len);
+		pr_info("%s xfer.tx_len= 0x%x\n",
+			__func__, handler->xfer.tx_len);
+
+		if (handler->xfer.rx_buff_len) {
+			for (i = 0; i < handler->xfer.rx_buff_len; i++) {
+				pr_info("%s xfer.rx_buff= 0x%x\n",
+					__func__, *handler->xfer.rx_buff);
+				pr_info("%s xfer.rx_buff= 0x%x\n",
+					__func__, handler->xfer.rx_buff[i]);
+			}
+		}
+
+		pr_info("%s xfer.rx_buff_len= 0x%x\n",
+			__func__, handler->xfer.rx_buff_len);
+		pr_info("%s xfer.rx_len= 0x%x\n",
+			__func__, handler->xfer.rx_len);
+		pr_info("%s xfer.except_time= 0x%lx\n",
+			__func__, handler->xfer.except_time);
+	}
+#endif
+
+	return 0;
+}
+
+/*
+ * Func : rtk_i2c_start_xfer
+ * Desc : start xfer message
+ * Parm : handler : handle of rtk i2c
+ * Retn : 0 for success, others is failed
+ */
+int rtk_i2c_start_xfer(struct rtk_i2c_handler *handler)
+{
+	unsigned long flags;
+	unsigned int ret;
+	int mode = handler->xfer.mode;
+
+	RTK_DEBUG("%s\n", __func__);
+
+	LOG_EVENT(EVENT_START_XFER);
+
+	LOCK_RTK_I2C(&handler->lock, flags);
+
+	if ((GET_IC_CON(handler) & IC_SLAVE_DISABLE) == 0) {
+		SET_IC_ENABLE(handler, 0);
+		SET_IC_CON(handler, GET_IC_CON(handler) | IC_SLAVE_DISABLE);
+	}
+
+	switch (handler->xfer.mode) {
+	case I2C_MASTER_WRITE:
+		SET_IC_INTR_MASK(handler,
+			TX_EMPTY_BIT | TX_ABRT_BIT | STOP_DET_BIT);
+		break;
+	case I2C_MASTER_READ:
+	case I2C_MASTER_RANDOM_READ:
+		if (GET_IC_RXFLR(handler)) {
+			pr_info("WARNING, RX FIFO NOT EMPRY\n");
+
+			while (GET_IC_RXFLR(handler))
+				GET_IC_DATA_CMD(handler);
+		}
+		SET_IC_INTR_MASK(handler,
+			RX_FULL_BIT | TX_EMPTY_BIT | TX_ABRT_BIT |
+			STOP_DET_BIT);
+		break;
+	default:
+		UNLOCK_RTK_I2C(&handler->lock, flags);
+		LOG_EVENT(EVENT_STOP_XFER);
+		return -EILLEGALMSG;
+	}
+
+	if (handler->reg_map.I2C_ISR_EN)
+		wr_reg(handler->reg_map.I2C_ISR_EN,
+			rd_reg(handler->reg_map.I2C_ISR_EN) |
+			handler->reg_map.I2C_ISR_EN_MASK);
+
+#ifdef MINIMUM_DELAY_EN
+	UNLOCK_RTK_I2C(&handler->lock, flags);
+
+	/* cfyeh found that delay 1/2 tick will cause long
+	 * system booting time, so we revert the delay setting
+	 * temporarily until we findout the root cause
+	 */
+	if (time_after(jiffies, handler->time_stamp)) {
+		// udelay(handler->tick/2); /* wait 1/2 ticks */
+		udelay(handler->guard_interval);
+	}
+
+	LOCK_RTK_I2C(&handler->lock, flags);
+#endif
+
+	SET_IC_ENABLE(handler, 1); /* Start Xfer */
+	UNLOCK_RTK_I2C(&handler->lock, flags);
+
+	/* less than 1 ms */
+	if (handler->xfer.except_time < 1000) {
+		/* extra 20 us for extra guard interval */
+		udelay(handler->xfer.except_time + 20);
+	}
+
+	if (handler->xfer.mode != I2C_IDLE)
+		wait_event_timeout(handler->wq,
+			handler->xfer.mode == I2C_IDLE, 1 * HZ);
+
+	LOCK_RTK_I2C(&handler->lock, flags);
+
+	SET_IC_INTR_MASK(handler, 0);
+	SET_IC_ENABLE(handler, 0);
+
+	if (handler->xfer.mode != I2C_IDLE) {
+		handler->xfer.ret  = -ETIMEOUT;
+
+	} else if (handler->xfer.ret == -ECMDSPLIT) {
+		pr_warn("WARNING,");
+		switch (mode) {
+		case I2C_MASTER_WRITE:
+			pr_warn("Write Cmd Split, tx : %d/%d\n",
+				handler->xfer.tx_len,
+				handler->xfer.tx_buff_len);
+			break;
+		case I2C_MASTER_READ:
+			pr_warn("Read Cmd Split, tx : %d/%d rx : %d/%d\n",
+				handler->xfer.tx_len,
+				handler->xfer.tx_buff_len,
+				handler->xfer.rx_len,
+				handler->xfer.rx_buff_len);
+			break;
+		case I2C_MASTER_RANDOM_READ:
+			ret = handler->xfer.tx_buff_len +
+				handler->xfer.rx_buff_len;
+			pr_warn("Read Cmd Split, tx : %d/%d rx : %d/%d\n",
+				handler->xfer.tx_len,
+				ret,
+				handler->xfer.rx_len,
+				handler->xfer.rx_buff_len);
+			break;
+		default:
+			break;
+		}
+	}
+
+#ifdef MINIMUM_DELAY_EN
+	handler->time_stamp = (unsigned long) jiffies;
+#endif
+
+	ret = handler->xfer.ret;
+
+	UNLOCK_RTK_I2C(&handler->lock, flags);
+
+#ifndef MINIMUM_DELAY_EN
+	udelay(handler->guard_interval);
+#endif
+
+	LOG_EVENT(EVENT_STOP_XFER);
+
+	if (handler->flags & RTK_I2C_SLAVE_ENABLE)
+		handler->slave_mode_enable(handler, 1);
+
+	return ret;
+}
+
+/*
+ * Func : rtk_i2c_get_tx_abort_reason
+ * Desc : get reason of tx abort, this register will be clear when new
+ *	message is loaded
+ * Parm : handler : handle of rtk i2c
+ * Retn : tx about source
+ */
+unsigned int rtk_i2c_get_tx_abort_reason(struct rtk_i2c_handler *handler)
+{
+	RTK_DEBUG("%s\n", __func__);
+	return handler->xfer.tx_abort_source;
+}
+
+
+/*
+ * Func : rtk_i2c_master_write
+ * Desc : master write handler for rtk i2c
+ * Parm : handler : handle of rtk i2c
+ *		event  : INT event of rtk i2c
+ * Retn : N/A
+ */
+void rtk_i2c_master_write(struct rtk_i2c_handler *handler, unsigned int event,
+	unsigned int tx_abort_source)
+{
+#define TxComplete() (handler->xfer.tx_len >= handler->xfer.tx_buff_len)
+
+	RTK_DEBUG("%s\n", __func__);
+
+	while (!TxComplete() && NOT_TXFULL(handler)) {
+		if (handler->xfer.tx_len == handler->xfer.tx_buff_len - 1) {
+			SET_IC_DATA_CMD(handler,
+				handler->xfer.tx_buff[handler->xfer.tx_len++] |
+				(0x1 << 9));
+		} else {
+			SET_IC_DATA_CMD(handler,
+				handler->xfer.tx_buff[handler->xfer.tx_len++]);
+		}
+	}
+
+	if (TxComplete())
+		SET_IC_INTR_MASK(handler,
+			GET_IC_INTR_MASK(handler) & ~TX_EMPTY_BIT);
+
+	if (event & TX_ABRT_BIT) {
+		handler->tx_abort_flag = 1;
+		handler->xfer.tx_abort_source = tx_abort_source;
+	} else if (event & STOP_DET_BIT) {
+		if (handler->tx_abort_flag != 1) {
+			handler->xfer.ret =
+				TxComplete() ? handler->xfer.tx_len : -ECMDSPLIT;
+		} else {
+			handler->tx_abort_flag = 0;
+			handler->xfer.ret = -ETXABORT;
+		}
+	}
+
+	if (handler->xfer.ret) {
+		SET_IC_INTR_MASK(handler, 0);
+#if defined(CONFIG_I2C_RTK_SECURE_ACCESS)
+#else
+		SET_IC_ENABLE(handler, 0);
+#endif
+		handler->xfer.mode = I2C_IDLE; /* change to idle state */
+		wake_up(&handler->wq);
+	}
+
+#undef TxComplete
+}
+
+/*
+ * Func : rtk_i2c_master_read
+ * Desc : master read handler for rtk i2c
+ * Parm : handler : handle of rtk i2c
+ * Retn : N/A
+ */
+void rtk_i2c_master_read(struct rtk_i2c_handler *handler, unsigned int event,
+	unsigned int tx_abort_source)
+{
+#define TxComplete() (handler->xfer.tx_len >= handler->xfer.rx_buff_len)
+#define RxComplete() (handler->xfer.rx_len >= handler->xfer.rx_buff_len)
+
+	RTK_DEBUG("%s\n", __func__);
+
+	/* TX Thread */
+	while (!TxComplete() && NOT_TXFULL(handler)) {
+		if (handler->xfer.tx_len ==
+			((handler->xfer.rx_buff_len +
+			handler->xfer.tx_buff_len) - 1)) {
+			/* send stop command to rx fifo */
+			SET_IC_DATA_CMD(handler, (READ_CMD | (0x1 << 9)));
+		} else {
+			/* send read command to rx fifo*/
+			SET_IC_DATA_CMD(handler, READ_CMD);
+		}
+
+		handler->xfer.tx_len++;
+		while (!RxComplete() && NOT_RXEMPTY(handler))
+			handler->xfer.rx_buff[handler->xfer.rx_len++] =
+				(unsigned char)(GET_IC_DATA_CMD(handler) &
+				0xFF);
+	}
+
+	/* RX Thread */
+	while (!RxComplete() && NOT_RXEMPTY(handler))
+		handler->xfer.rx_buff[handler->xfer.rx_len++] =
+			(unsigned char)(GET_IC_DATA_CMD(handler) & 0xFF);
+
+	if (TxComplete())
+		SET_IC_INTR_MASK(handler,
+			GET_IC_INTR_MASK(handler) & ~TX_EMPTY_BIT);
+
+	if (event & TX_ABRT_BIT) {
+		handler->tx_abort_flag =1;
+		handler->xfer.tx_abort_source = tx_abort_source;
+	} else if ((event & STOP_DET_BIT) || RxComplete()) {
+		SET_IC_INTR_MASK(handler,
+			GET_IC_INTR_MASK(handler) & ~RX_FULL_BIT);
+		if (handler->tx_abort_flag != 1) {
+			handler->xfer.ret =
+				RxComplete() ? handler->xfer.rx_len : -ECMDSPLIT;
+		} else {
+			handler->tx_abort_flag = 0;
+			handler->xfer.ret = -ETXABORT;
+		}
+	}
+
+	if (handler->xfer.ret  && (handler->xfer.ret!=-ETXABORT)) {
+		SET_IC_INTR_MASK(handler, 0);
+#if defined(CONFIG_I2C_RTK_SECURE_ACCESS)
+#else
+		SET_IC_ENABLE(handler, 0);
+#endif
+		handler->xfer.mode = I2C_IDLE; /* change to idle state */
+		wake_up(&handler->wq);
+	}
+
+#undef TxComplete
+#undef RxComplete
+}
+
+/*
+ * Func : rtk_i2c_master_random_read
+ * Desc : master random read handler for rtk i2c
+ * Parm : handler : handle of rtk i2c
+ * Retn : N/A
+ */
+void rtk_i2c_master_random_read(struct rtk_i2c_handler *handler,
+	unsigned int event, unsigned int tx_abort_source)
+{
+/* it should add the same number of read command to tx fifo */
+#define TxComplete() \
+(handler->xfer.tx_len >= \
+(handler->xfer.rx_buff_len + handler->xfer.tx_buff_len))
+#define RxComplete() (handler->xfer.rx_len >=  handler->xfer.rx_buff_len)
+
+	RTK_DEBUG("%s\n", __func__);
+
+	/* TX Thread  */
+	while (!TxComplete() && NOT_TXFULL(handler)) {
+		if (handler->xfer.tx_len < handler->xfer.tx_buff_len) {
+			SET_IC_DATA_CMD(handler,
+				handler->xfer.tx_buff[handler->xfer.tx_len]);
+		} else {
+			if ((handler->xfer.tx_len == handler->xfer.tx_buff_len)
+				&& (handler->xfer.tx_len ==
+				((handler->xfer.rx_buff_len +
+				handler->xfer.tx_buff_len) - 1))) {
+				/* send Restart command and STOP to rx fifo :
+				 * first also last read cmd
+				 */
+				SET_IC_DATA_CMD(handler,
+					(READ_CMD | (0x3 << 9)));
+			} else if ((handler->xfer.tx_len ==
+					(handler->xfer.tx_buff_len)) &&
+					(!(handler->xfer.tx_len ==
+					((handler->xfer.rx_buff_len +
+					handler->xfer.tx_buff_len) - 1)))) {
+				/* send restart command to rx fifo :
+				 * first but not last read cmd
+				 */
+				SET_IC_DATA_CMD(handler,
+					(READ_CMD | (0x1 << 10)));
+			} else if ((!(handler->xfer.tx_len ==
+					(handler->xfer.tx_buff_len))) &&
+					(handler->xfer.tx_len ==
+					((handler->xfer.rx_buff_len +
+					handler->xfer.tx_buff_len) - 1))) {
+				/* send stop command to rx fifo :
+				 * not first but last read cmd
+				 */
+				SET_IC_DATA_CMD(handler,
+					(READ_CMD | (0x1 << 9)));
+			} else {
+				/* send read command to rx fifo :
+				 * not first also not last read cmd
+				 */
+				SET_IC_DATA_CMD(handler, READ_CMD);
+			}
+		}
+
+		handler->xfer.tx_len++;
+
+		/* RX Thread,
+		 * incase rxfifo overflow and the datas are droped
+		 */
+		while (!RxComplete() && NOT_RXEMPTY(handler)) {
+			RTK_DEBUG("%s handler->xfer.rx_len =%d\n",
+				__func__, handler->xfer.rx_len);
+			handler->xfer.rx_buff[handler->xfer.rx_len++] =
+				(unsigned char)(GET_IC_DATA_CMD(handler) &
+				0xFF);
+		}
+	}
+
+	/* RX Thread */
+	while (!RxComplete() && NOT_RXEMPTY(handler))
+		handler->xfer.rx_buff[handler->xfer.rx_len++] =
+			(unsigned char)(GET_IC_DATA_CMD(handler) & 0xFF);
+
+	if (TxComplete())
+		SET_IC_INTR_MASK(handler,
+			GET_IC_INTR_MASK(handler) & ~TX_EMPTY_BIT);
+
+	if (event & TX_ABRT_BIT) {
+		handler->tx_abort_flag =1;
+		handler->xfer.tx_abort_source = tx_abort_source;
+	} else if ((event & STOP_DET_BIT) || RxComplete()) {
+		SET_IC_INTR_MASK(handler,
+			GET_IC_INTR_MASK(handler) & ~RX_FULL_BIT);
+		if (handler->tx_abort_flag != 1) {
+			handler->xfer.ret =
+				RxComplete() ? handler->xfer.rx_len : -ECMDSPLIT;
+		} else {
+			handler->tx_abort_flag = 0;
+			handler->xfer.ret = -ETXABORT;
+		}
+	}
+
+	if (handler->xfer.ret) {
+		SET_IC_INTR_MASK(handler, 0);
+#if defined(CONFIG_I2C_RTK_SECURE_ACCESS)
+#else
+		SET_IC_ENABLE(handler, 0);
+#endif
+		handler->xfer.mode = I2C_IDLE; /* change to idle state */
+		wake_up(&handler->wq);
+	}
+
+#undef TxComplete
+#undef RxComplete
+}
+
+#ifdef EDID_4BLOCK_SUPPORT
+
+/*
+ * Func : rtk_i2c_read_edid_seg
+ * Desc : read edid seg
+ * Parm : Block 0~1: Seg 0
+ *	Block 2: Seg 1, Offset 0
+ *	Block 3: Seg 1, Offset 128
+ * Retn : 0 for success, others is failed
+ */
+int rtk_i2c_read_edid_seg(struct rtk_i2c_handler *handler,
+	unsigned char seg, /* Segment Pointer */
+	unsigned char offset, /* Word Offset */
+	unsigned char *rx_buff, unsigned short rx_buf_len)
+{
+#define RxComplete() (rx_len >= rx_buf_len)
+#define TxComplete() (tx_len >= rx_buf_len)
+
+	int rx_len = 0;
+	int tx_len = 0;
+	int cnt = 0;
+
+	RTK_DEBUG("%s seg=0x%x offset=0x%02x len(%u)\n",
+		__func__, seg, offset, rx_buf_len);
+
+	rtk_i2c_set_tar(handler, 0x30, ADDR_MODE_7BITS);
+	CLR_IC_INTR(handler);
+	SET_IC_ENABLE(handler, 1);
+
+	while (GET_IC_STATUS(handler) & (ST_ACTIVITY_BIT == 0)) {
+		if (cnt++ < 5)
+			udelay(50);
+		else
+			return -ETIMEOUT;
+
+		RTK_DEBUG("%s IC_STATUS = 0x%x\n",
+			__func__, GET_IC_STATUS(handler));
+	}
+
+	SET_IC_DATA_CMD(handler, seg); /* Segment Pointer */
+	udelay(50);
+	CLR_IC_INTR(handler);
+	SET_IC_ENABLE(handler, 0);
+
+	rtk_i2c_set_tar(handler, 0x50, ADDR_MODE_7BITS);
+	CLR_IC_INTR(handler);
+	SET_IC_ENABLE(handler, 1);
+	cnt = 0;
+
+	while (GET_IC_STATUS(handler) & (ST_ACTIVITY_BIT == 0)) {
+		if (cnt++ < 5)
+			udelay(50);
+		else
+			return -ETIMEOUT;
+	}
+
+	SET_IC_DATA_CMD(handler, offset|(0x1<<10)); /* Restart, Word Offset */
+	udelay(100);
+
+	RTK_DEBUG("%s IC_STATUS= 0x%x\n", __func__, GET_IC_STATUS(handler));
+
+	while (!TxComplete() && NOT_TXFULL(handler)) {
+
+		if (tx_len == rx_buf_len - 1)
+			/* Read, Stop */
+			SET_IC_DATA_CMD(handler, (0x1 << 8) | (0x1 << 9));
+		else
+			/* Read */
+			SET_IC_DATA_CMD(handler, (0x1 << 8));
+
+		tx_len++;
+		udelay(100);
+		while (NOT_RXEMPTY(handler)) {
+			rx_buff[rx_len] =
+				(unsigned char)(GET_IC_DATA_CMD(handler) &
+				0xFF);
+			udelay(50);
+			rx_len++;
+		}
+	}
+
+	while (!RxComplete() && NOT_RXEMPTY(handler)) {
+		rx_buff[rx_len] =
+			(unsigned char)(GET_IC_DATA_CMD(handler) & 0xFF);
+		rx_len++;
+		udelay(50);
+	}
+
+	CLR_IC_INTR(handler);
+	SET_IC_ENABLE(handler, 0);
+
+	return 0;
+}
+#endif
+
+/*
+ * Func : rtk_i2c_isr
+ * Desc : isr of rtk i2c
+ * Parm : handler : handle of rtk i2c
+ * Retn : 0
+ */
+irqreturn_t rtk_i2c_isr(int this_irq, void *dev_id)
+{
+	struct rtk_i2c_handler *handler = (struct rtk_i2c_handler *) dev_id;
+	unsigned long flags;
+	unsigned int event = 0;
+	unsigned int tx_abrt_source = 0;
+	unsigned int tmp;
+
+	RTK_DEBUG("%s\n", __func__);
+
+#if defined(CONFIG_I2C_RTK_SECURE_ACCESS)
+#else
+	LOCK_RTK_I2C(&handler->lock, flags);
+#endif
+
+	/* interrupt belongs to I2C */
+	if (!(GET_I2C_ISR(handler) & handler->reg_map.I2C_INT)) {
+#if defined(CONFIG_I2C_RTK_SECURE_ACCESS)
+#else
+		UNLOCK_RTK_I2C(&handler->lock, flags);
+#endif
+		return IRQ_NONE;
+	}
+
+	LOG_EVENT(EVENT_ENTER_ISR);
+
+	event = GET_IC_INTR_STAT(handler);
+	tx_abrt_source = GET_IC_TX_ABRT_SOURCE(handler);
+
+	CLR_IC_INTR(handler); /* clear interrupts of i2c_x */
+
+	if ((GET_IC_CON(handler) & IC_SLAVE_DISABLE) == 0) {
+		while (NOT_RXEMPTY(handler) &&
+			(handler->slave_rx_len <
+			sizeof(handler->slave_rx_buffer))) {
+			handler->slave_rx_buffer[handler->slave_rx_len++] =
+				(unsigned char)(GET_IC_DATA_CMD(handler) &
+				0xFF);
+		}
+
+		if ((event & STOP_DET_BIT) && handler->slave_rx_len) {
+			if (handler->slave_ops.handle_command)
+				handler->slave_ops.handle_command(
+						handler->slave_id,
+						handler->slave_rx_buffer,
+						handler->slave_rx_len);
+
+			handler->slave_rx_len = 0; /* flush buffer */
+		}
+
+		if (event & RD_REQ_BIT) {
+			if (handler->slave_ops.read_data) {
+				tmp = handler->slave_id;
+				SET_IC_DATA_CMD(handler,
+					handler->slave_ops.read_data(tmp));
+			} else
+				SET_IC_DATA_CMD(handler, 0xFF);
+		}
+	} else {
+		switch (handler->xfer.mode) {
+		case I2C_MASTER_WRITE:
+			rtk_i2c_master_write(handler, event, tx_abrt_source);
+			break;
+
+		case I2C_MASTER_READ:
+			rtk_i2c_master_read(handler, event, tx_abrt_source);
+			break;
+
+		case I2C_MASTER_RANDOM_READ:
+			rtk_i2c_master_random_read(handler, event,
+						tx_abrt_source);
+			break;
+
+		default:
+			pr_info("Unexcepted Interrupt\n");
+#if defined(CONFIG_I2C_RTK_SECURE_ACCESS)
+#else
+			SET_IC_ENABLE(handler, 0);
+#endif
+		}
+	}
+
+	/* clear I2C Interrupt Flag */
+	SET_I2C_ISR(handler, handler->reg_map.I2C_INT);
+#if defined(CONFIG_I2C_RTK_SECURE_ACCESS)
+#else
+	UNLOCK_RTK_I2C(&handler->lock, flags);
+#endif
+	return IRQ_HANDLED;
+}
+
+/*
+ * Func : rtk_i2c_set_sar
+ * Desc : set sar of rtk i2c
+ * Parm : handler : handle of rtk i2c
+ *	addr : address of sar
+ *	mode : mode of sar
+ * Retn : 0
+ */
+int rtk_i2c_set_sar(struct rtk_i2c_handler *handler,
+	unsigned short addr, enum ADDR_MODE mode)
+{
+	RTK_DEBUG("%s\n", __func__);
+
+	if (mode == ADDR_MODE_10BITS) {
+		SET_IC_ENABLE(handler, 0);
+		SET_IC_SAR(handler, handler->sar & ADDR_10BITS_MASK);
+		SET_IC_CON(handler, GET_IC_CON(handler) | IC_10BITADDR_SLAVE);
+	} else {
+		SET_IC_ENABLE(handler, 0);
+		SET_IC_SAR(handler, handler->sar & ADDR_7BITS_MASK);
+		SET_IC_CON(handler, GET_IC_CON(handler) &
+			(~IC_10BITADDR_SLAVE));
+	}
+
+	handler->sar = addr;
+	handler->sar_mode = mode;
+
+	return 0;
+}
+
+/*
+ * Func : rtk_i2c_slave_mode_enable
+ * Desc : enable/disable i2c slave mode
+ * Parm : handler : handle of rtk i2c
+ *	on : enable /disable
+ * Retn : 0
+ */
+int rtk_i2c_slave_mode_enable(struct rtk_i2c_handler *handler,
+	unsigned char on)
+{
+	unsigned long flags;
+
+	RTK_DEBUG("%s\n", __func__);
+
+	LOCK_RTK_I2C(&handler->lock, flags);
+
+	if (on) {
+		pr_info("[I2C%d] i2c slave enabled, sar=%x\n",
+				handler->id, GET_IC_SAR(handler));
+		SET_IC_ENABLE(handler, 0);
+		handler->set_sar(handler, handler->sar, handler->sar_mode);
+		SET_IC_CON(handler, GET_IC_CON(handler) & ~(IC_SLAVE_DISABLE));
+		SET_IC_INTR_MASK(handler, START_DET_BIT |
+				STOP_DET_BIT | RD_REQ_BIT | RX_FULL_BIT);
+		if (handler->reg_map.I2C_ISR_EN)
+			wr_reg(handler->reg_map.I2C_ISR_EN,
+				rd_reg(handler->reg_map.I2C_ISR_EN) |
+				handler->reg_map.I2C_ISR_EN_MASK);
+		SET_IC_ENABLE(handler, 1);
+		handler->flags |= RTK_I2C_SLAVE_ENABLE;
+	} else {
+		pr_info("[I2C%d] i2c slave disabled\n", handler->id);
+		SET_IC_ENABLE(handler, 0);
+		SET_IC_CON(handler, GET_IC_CON(handler) | IC_SLAVE_DISABLE);
+		SET_IC_INTR_MASK(handler, 0);
+		handler->flags &= ~RTK_I2C_SLAVE_ENABLE;
+	}
+
+	UNLOCK_RTK_I2C(&handler->lock, flags);
+
+	return 0;
+}
+
+/*
+ * Func : rtk_i2c_register_slave_ops
+ * Desc : register slave mode ops
+ * Parm : handler : handle of rtk i2c
+ *		ops : slave mode ops
+ * Retn : 0
+ */
+int rtk_i2c_register_slave_ops(struct rtk_i2c_handler *handler,
+	struct rtk_i2c_slave_ops *ops, unsigned long id)
+{
+	unsigned long flags;
+
+	RTK_DEBUG("%s\n", __func__);
+
+	LOCK_RTK_I2C(&handler->lock, flags);
+
+	if (ops == NULL) {
+		handler->slave_ops.handle_command = NULL;
+		handler->slave_ops.read_data = NULL;
+		handler->slave_id = 0;
+		rtk_i2c_slave_mode_enable(handler, 0);
+	} else {
+		handler->slave_ops.handle_command = ops->handle_command;
+		handler->slave_ops.read_data = ops->read_data;
+		handler->slave_id = id;
+	}
+
+	UNLOCK_RTK_I2C(&handler->lock, flags);
+	return 0;
+}
+
+/*
+ * Func : rtk_i2c_dump
+ * Desc : dump staus of rtk i2c
+ * Parm : handler : handle of rtk i2c
+ * Retn : 0 for success
+ */
+int rtk_i2c_dump(struct rtk_i2c_handler *handler)
+{
+	RTK_DEBUG("%s\n", __func__);
+	pr_info("=========================\n");
+	pr_info("= VER : %s\n", VERSION);
+	pr_info("=========================\n");
+	pr_info("= PHY : %d\n", handler->id);
+	//pr_info("= PORT: %ld\n", current_port_id(handler));
+	pr_info("= MODEL: %s\n", handler->model_name);
+	pr_info("= SPD : %d\n", handler->spd);
+	pr_info("= SAR : 0x%03x (%d bits)\n",
+			handler->sar, handler->sar_mode);
+	pr_info("= TX FIFO DEPTH : %d\n", handler->tx_fifo_depth);
+	pr_info("= RX FIFO DEPTH : %d\n", handler->rx_fifo_depth);
+	pr_info("= FIFO THRESHOLD: %d\n", FIFO_THRESHOLD);
+	pr_info("=========================\n");
+	return 0;
+}
+
+/*
+ * Func : rtk_i2c_setup_reg_base
+ * Desc : setup register of rtk i2c
+ * Parm : N/A
+ * Retn : reg_map of rtk i2c
+ */
+struct rtk_i2c_reg_map rtk_i2c_setup_reg_base(unsigned int id,
+	unsigned long base)
+{
+	struct rtk_i2c_reg_map reg_map;
+
+	switch (id) {
+	case 0:
+		reg_map.I2C_ISR = (base & ~0xFFF);
+		reg_map.I2C_INT = ISO_ISR_I2C0;
+		reg_map.IC_SDA_DEL = (base & ~0xFFF) | ISO_I2C0_SDA_DEL;
+		break;
+	case 1:
+#ifdef CONFIG_ARCH_RTD119X
+		reg_map.I2C_ISR = (base & ~0xFFF) | 0x000C;
+		reg_map.I2C_INT = MISC_ISR_I2C1;
+		reg_map.IC_SDA_DEL = (base & ~0xFFF) | MISC_I2C1_SDA_DEL;
+#else
+		reg_map.I2C_ISR = (base & ~0xFFF);
+		reg_map.I2C_INT = ISO_ISR_I2C1;
+		reg_map.IC_SDA_DEL = (base & ~0xFFF) | ISO_I2C1_SDA_DEL;
+#endif
+		break;
+	case 2:
+		reg_map.I2C_ISR = (base & ~0xFFF) | 0x000C;
+		reg_map.I2C_INT = MIS_ISR_I2C2;
+		reg_map.IC_SDA_DEL = (base & ~0xFFF) | MIS_I2C2_SDA_DEL;
+		break;
+	case 3:
+		reg_map.I2C_ISR = (base & ~0xFFF) | 0x000C;
+		reg_map.I2C_INT = MIS_ISR_I2C3;
+		reg_map.IC_SDA_DEL = (base & ~0xFFF) | MIS_I2C3_SDA_DEL;
+		break;
+	case 4:
+		reg_map.I2C_ISR = (base & ~0xFFF) | 0x000C;
+		reg_map.I2C_INT = MIS_ISR_I2C4;
+		reg_map.IC_SDA_DEL = (base & ~0xFFF) | MIS_I2C4_SDA_DEL;
+		break;
+	case 5:
+		reg_map.I2C_ISR = (base & ~0xFFF) | 0x000C;
+		reg_map.I2C_INT = MIS_ISR_I2C5;
+		reg_map.IC_SDA_DEL = (base & ~0xFFF) | MIS_I2C5_SDA_DEL;
+		break;
+	case 6:
+		reg_map.I2C_ISR = (base & ~0xFFF);
+		reg_map.I2C_INT = ISO_ISR_I2C6;
+		reg_map.IC_SDA_DEL = (base & ~0xFFF) | ISO_I2C6_SDA_DEL;
+		break;
+	default:
+		break;
+	}
+
+	reg_map.I2C_ISR_EN = 0;
+	reg_map.I2C_ISR_EN_MASK = 0;
+	reg_map.IC_CON = base | I2C_CON;
+	reg_map.IC_TAR = base | I2C_TAR;
+	reg_map.IC_SAR = base | I2C_SAR;
+	reg_map.IC_HS_MADDR = base | I2C_HS_MADDR;
+	reg_map.IC_DATA_CMD = base | I2C_DATA_CMD;
+
+	reg_map.IC_FS_SCL_HCNT = base | I2C_FS_SCL_HCNT;
+	reg_map.IC_FS_SCL_LCNT = base | I2C_FS_SCL_LCNT;
+	reg_map.IC_SS_SCL_HCNT = base | I2C_SS_SCL_HCNT;
+	reg_map.IC_SS_SCL_LCNT = base | I2C_SS_SCL_LCNT;
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	if (id == 0) {
+		reg_map.IC_HS_SCL_HCNT = base | I2C_HS_SCL_HCNT;
+		reg_map.IC_HS_SCL_LCNT = base | I2C_HS_SCL_LCNT;
+	}
+#endif
+	reg_map.IC_INTR_STAT = base | I2C_INTR_STAT;
+	reg_map.IC_INTR_MASK = base | I2C_INTR_MASK;
+	reg_map.IC_RAW_INTR_STAT = base | I2C_RAW_INTR_STAT;
+	reg_map.IC_RX_TL = base | I2C_RX_TL;
+	reg_map.IC_TX_TL = base | I2C_TX_TL;
+
+	reg_map.IC_CLR_INTR = base | I2C_CLR_INTR;
+	reg_map.IC_CLR_RX_UNDER = base | I2C_CLR_RX_UNDER;
+	reg_map.IC_CLR_RX_OVER = base | I2C_CLR_RX_OVER;
+	reg_map.IC_CLR_TX_OVER = base | I2C_CLR_TX_OVER;
+	reg_map.IC_CLR_RD_REQ = base | I2C_CLR_RD_REQ;
+	reg_map.IC_CLR_TX_ABRT = base | I2C_CLR_TX_ABRT;
+	reg_map.IC_CLR_RX_DONE = base | I2C_CLR_RX_DONE;
+	reg_map.IC_CLR_ACTIVITY = base | I2C_CLR_ACTIVITY;
+	reg_map.IC_CLR_STOP_DET = base | I2C_CLR_STOP_DET;
+	reg_map.IC_CLR_START_DET = base | I2C_CLR_START_DET;
+	reg_map.IC_CLR_GEN_CALL = base | I2C_CLR_GEN_CALL;
+
+	reg_map.IC_ENABLE = base | I2C_ENABLE;
+	reg_map.IC_STATUS = base | I2C_STATUS;
+	reg_map.IC_TXFLR = base | I2C_TXFLR;
+	reg_map.IC_RXFLR = base | I2C_RXFLR;
+	reg_map.IC_SDA_HOLD = base | I2C_SDA_HOLD;
+	reg_map.IC_TX_ABRT_SOURCE = base | I2C_TX_ABRT_SOURCE;
+	reg_map.IC_SLV_DATA_NACK_ONLY = base | I2C_SLV_DATA_NACK_ONLY;
+	reg_map.IC_DMA_CR = base | I2C_DMA_CR;
+	reg_map.IC_DMA_TDLR = base | I2C_DMA_TDLR;
+	reg_map.IC_DMA_RDLR = base | I2C_DMA_RDLR;
+	reg_map.IC_SDA_SETUP = base | I2C_SDA_SETUP;
+	reg_map.IC_ACK_GENERAL_CALL = base | I2C_ACK_GENERAL_CALL;
+	reg_map.IC_ENABLE_STATUS = base | I2C_ENABLE_STATUS;
+	reg_map.IC_COMP_PARAM_1 = base | I2C_COMP_PARAM_1;
+	reg_map.IC_COMP_VERSION = base | I2C_COMP_VERSION;
+	reg_map.IC_COMP_TYPE = base | I2C_COMP_TYPE;
+	return reg_map;
+}
+
+static unsigned char rtk_i2c_flags;
+static struct rtk_i2c_handler *rtk_i2c_phy_handle[I2C_PHY_CNT] = {NULL};
+
+/*
+ * Func : create_rtk_i2c_handle
+ * Desc : create handle of rtk i2c
+ * Parm : N/A
+ * Retn : handle of rtk i2c
+ */
+struct rtk_i2c_handler *create_rtk_i2c_handle(
+	unsigned int id,
+	unsigned short sar,
+	enum ADDR_MODE sar_mode,
+	unsigned int spd,
+	unsigned int irq,
+	unsigned long base)
+{
+	struct rtk_i2c_handler *hHandle;
+
+	RTK_DEBUG("%s\n", __func__);
+
+	if (!(BIT(id) & I2C_ID_MASK))
+		return NULL;
+
+	if (((rtk_i2c_flags>>id) & 0x01))
+		return rtk_i2c_phy_handle[id];
+
+	hHandle = kmalloc(sizeof(struct rtk_i2c_handler), GFP_KERNEL);
+
+	if (hHandle != NULL) {
+		memset(hHandle, 0, sizeof(struct rtk_i2c_handler));
+		hHandle->flags = 0;
+		hHandle->id = id;
+		hHandle->irq = irq;
+		hHandle->sar = sar;
+		hHandle->sar_mode = sar_mode;
+		hHandle->spd = spd;
+		hHandle->guard_interval = 1000;
+		hHandle->tx_abort_flag = 0;
+		hHandle->init = rtk_i2c_handler_init;
+		hHandle->uninit = rtk_i2c_handler_uninit;
+		hHandle->set_spd = rtk_i2c_set_spd;
+		hHandle->set_guard_interval = rtk_i2c_set_guard_interval;
+		hHandle->set_tar = rtk_i2c_set_tar;
+		hHandle->reg_map = rtk_i2c_setup_reg_base(id, base);
+		hHandle->read = rtk_i2c_read;
+		hHandle->write = rtk_i2c_write;
+		hHandle->get_tx_abort_reason = rtk_i2c_get_tx_abort_reason;
+		hHandle->dump = rtk_i2c_dump;
+		hHandle->set_sar = rtk_i2c_set_sar;
+		hHandle->slave_mode_enable = rtk_i2c_slave_mode_enable;
+		hHandle->register_slave_ops = rtk_i2c_register_slave_ops;
+		/* GPIO */
+		//hHandle->set_port = rtk_i2c_set_port;
+		//hHandle->gpio_read = rtk_g2c_read;
+		//hHandle->gpio_write = rtk_g2c_write;
+#ifdef EDID_4BLOCK_SUPPORT
+		hHandle->read_edid_seg = rtk_i2c_read_edid_seg;
+#endif
+		atomic_set(&hHandle->ref_cnt, 1);
+		memset(&hHandle->xfer, 0, sizeof(struct rtk_i2c_xfer));
+		rtk_i2c_phy_handle[id] = hHandle;
+		rtk_i2c_flags |= (0x01 << id);
+	}
+
+	return hHandle;
+}
+EXPORT_SYMBOL(create_rtk_i2c_handle);
+
+/*
+ * Func : destroy_rtk_i2c_handle
+ * Desc : destroy handle of rtk i2c
+ * Parm : N/A
+ * Retn : N/A
+ */
+void destroy_rtk_i2c_handle(struct rtk_i2c_handler *hHandle)
+{
+	RTK_DEBUG("%s\n", __func__);
+
+	if (hHandle == NULL)
+		return;
+
+	if (atomic_dec_return(&hHandle->ref_cnt) > 0) {
+		pr_info("[I2C] destroy I2C%d successed, reference cnt=%d\n",
+			hHandle->id, atomic_read(&hHandle->ref_cnt));
+		return;
+	}
+
+	pr_info("[I2C] destroy rtk i2c%d handle\n", hHandle->id);
+	hHandle->uninit(hHandle);
+	rtk_i2c_flags &= ~(0x01 << hHandle->id);
+	rtk_i2c_phy_handle[hHandle->id] = NULL;
+	kfree(hHandle);
+}
+EXPORT_SYMBOL(destroy_rtk_i2c_handle);
diff --git a/drivers/i2c/busses/i2c-rtk-priv.h b/drivers/i2c/busses/i2c-rtk-priv.h
new file mode 100644
index 00000000..0d7df13
--- /dev/null
+++ b/drivers/i2c/busses/i2c-rtk-priv.h
@@ -0,0 +1,323 @@
+/*
+ * Realtek I2C driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/i2c.h>
+#include <linux/spinlock.h>
+#include <linux/wait.h>
+#include <linux/atomic.h>
+
+#include "i2c-rtk.h"
+#if defined(CONFIG_I2C_RTK_SECURE_ACCESS)
+extern int ta_i2c_init(void);
+extern void ta_hdcp_lib_set_i2c_enable(unsigned int  i2c_enable_value);
+#endif
+
+#define FIFO_THRESHOLD 4
+#define ADDR_10BITS_MASK 0x3FF
+#define ADDR_7BITS_MASK 0x7F
+
+#ifdef CONFIG_ARCH_RTD119X
+#define I2C_ID_MASK 0x7F
+
+#elif defined(CONFIG_ARCH_RTD129x)
+#define I2C_ID_MASK 0x3F
+
+#elif defined(CONFIG_ARCH_RTD139x)
+
+#define I2C_ID_MASK 0x23
+
+#elif defined(CONFIG_ARCH_RTD16xx)
+
+#define I2C_ID_MASK 0x3B
+
+#elif defined(CONFIG_ARCH_RTD13xx)
+
+#define I2C_ID_MASK 0x2B
+
+#endif
+
+
+/* DEFINE FLAG ENABLE */
+#define MINIMUM_DELAY_EN
+#define SPIN_LOCK_PROTECT_EN
+#define EDID_4BLOCK_SUPPORT /* For HDMI TX CTS 7-1 */
+
+/* DEBUG */
+#ifdef DEV_DEBUG
+#define RTK_DEBUG(fmt, ...) pr_info(fmt, ##__VA_ARGS__)
+#else
+#define RTK_DEBUG(fmt, ...)
+#endif /* DEV_DEBUG */
+
+/* LOG EVENT */
+#ifdef I2C_PROFILEING_EN
+#define LOG_EVENT(x) log_event(x)
+#else
+#define LOG_EVENT(x)
+#endif /* LOG EVENT */
+
+#define EVENT_START_XFER 4
+#define EVENT_STOP_XFER 5
+#define EVENT_ENTER_ISR 6
+#define EVENT_EXIT_ISR 7
+#define EVENT_EXIT_TIMEOUT 8
+
+/* SPINLOCK */
+#ifdef SPIN_LOCK_PROTECT_EN
+#if defined(CONFIG_I2C_RTK_SECURE_ACCESS)
+#define LOCK_RTK_I2C(a, b) spin_lock(a)
+#define UNLOCK_RTK_I2C(a, b) spin_unlock(a)
+#else
+#define LOCK_RTK_I2C(a, b) spin_lock_irqsave(a, b)
+#define UNLOCK_RTK_I2C(a, b) spin_unlock_irqrestore(a, b)
+#endif
+#else
+#define LOCK_RTK_I2C(a, b) do {} while (0)
+#define UNLOCK_RTK_I2C(a, b) do {} while (0)
+#endif /* SPIN_LOCK_PROTECT_EN */
+
+/* RTK I2C API */
+#define wr_reg(x, y) writel(y, (unsigned int *)x)
+#define rd_reg(x) readl((unsigned int *)x)
+#define SET_I2C_ISR(adp, x) wr_reg(adp->reg_map.I2C_ISR, x)
+#define GET_I2C_ISR(adp) rd_reg(adp->reg_map.I2C_ISR)
+#ifndef CONFIG_I2C_RTK_SECURE_ACCESS
+#define SET_IC_ENABLE(adp, x) wr_reg(adp->reg_map.IC_ENABLE, x)
+#endif
+#define GET_IC_ENABLE(adp) rd_reg(adp->reg_map.IC_ENABLE)
+#define SET_IC_CON(adp, x) wr_reg(adp->reg_map.IC_CON, x)
+#define GET_IC_CON(adp) rd_reg(adp->reg_map.IC_CON)
+#define SET_IC_SAR(adp, x) wr_reg(adp->reg_map.IC_SAR, x)
+#define GET_IC_SAR(adp) rd_reg(adp->reg_map.IC_SAR)
+#define SET_IC_TAR(adp, x) wr_reg(adp->reg_map.IC_TAR, x)
+#define GET_IC_TAR(adp) rd_reg(adp->reg_map.IC_TAR)
+#define SET_IC_DATA_CMD(adp, x) wr_reg(adp->reg_map.IC_DATA_CMD, x)
+#define GET_IC_DATA_CMD(adp) rd_reg(adp->reg_map.IC_DATA_CMD)
+#define SET_IC_SS_SCL_HCNT(adp, x) wr_reg(adp->reg_map.IC_SS_SCL_HCNT, x)
+#define SET_IC_SS_SCL_LCNT(adp, x) wr_reg(adp->reg_map.IC_SS_SCL_LCNT, x)
+#define SET_IC_FS_SCL_HCNT(adp, x) wr_reg(adp->reg_map.IC_FS_SCL_HCNT, x)
+#define SET_IC_FS_SCL_LCNT(adp, x) wr_reg(adp->reg_map.IC_FS_SCL_LCNT, x)
+#define SET_IC_HS_SCL_HCNT(adp, x) wr_reg(adp->reg_map.IC_HS_SCL_HCNT, x)
+#define SET_IC_HS_SCL_LCNT(adp, x) wr_reg(adp->reg_map.IC_HS_SCL_LCNT, x)
+#define GET_IC_STATUS(adp) rd_reg(adp->reg_map.IC_STATUS)
+#define SET_IC_INTR_MASK(adp, x) wr_reg(adp->reg_map.IC_INTR_MASK, x)
+#define GET_IC_INTR_MASK(adp) rd_reg(adp->reg_map.IC_INTR_MASK)
+#define GET_IC_INTR_STAT(adp) rd_reg(adp->reg_map.IC_INTR_STAT)
+#define GET_IC_RAW_INTR_STAT(adp) rd_reg(adp->reg_map.IC_RAW_INTR_STAT)
+#define CLR_IC_INTR(adp) rd_reg(adp->reg_map.IC_CLR_INTR)
+#define CLR_IC_RX_UNDER(adp) rd_reg(adp->reg_map.IC_CLR_RX_UNDER)
+#define CLR_IC_TX_OVER(adp) rd_reg(adp->reg_map.IC_CLR_TX_OVER)
+#define CLR_IC_RD_REQ(adp) rd_reg(adp->reg_map.IC_CLR_RD_REQ)
+#define CLR_IC_RX_DONE(adp) rd_reg(adp->reg_map.IC_CLR_RX_DONE)
+#define CLR_IC_ACTIVITY(adp) rd_reg(adp->reg_map.IC_CLR_ACTIVITY)
+#define CLR_IC_GEN_CALL(adp) rd_reg(adp->reg_map.IC_CLR_GEN_CALL)
+#define CLR_IC_TX_ABRT(adp) rd_reg(adp->reg_map.IC_CLR_TX_ABRT)
+#define CLR_IC_STOP_DET(adp) rd_reg(adp->reg_map.IC_CLR_STOP_DET)
+#define GET_IC_COMP_PARAM_1(adp) rd_reg(adp->reg_map.IC_COMP_PARAM_1)
+#define GET_IC_TXFLR(adp) rd_reg(adp->reg_map.IC_TXFLR)
+#define GET_IC_RXFLR(adp) rd_reg(adp->reg_map.IC_RXFLR)
+#define GET_IC_RX_TL(adp) rd_reg(adp->reg_map.IC_RX_TL)
+#define GET_IC_TX_TL(adp) rd_reg(adp->reg_map.IC_TX_TL)
+#define GET_IC_SDA_DEL(adp) rd_reg(adp->reg_map.IC_SDA_DEL)
+#define SET_IC_RX_TL(adp, x) wr_reg(adp->reg_map.IC_RX_TL, x)
+#define SET_IC_TX_TL(adp, x) wr_reg(adp->reg_map.IC_TX_TL, x)
+#define SET_IC_SDA_DEL(adp, x) wr_reg(adp->reg_map.IC_SDA_DEL, x)
+#define GET_IC_TX_ABRT_SOURCE(adp) rd_reg(adp->reg_map.IC_TX_ABRT_SOURCE)
+#define NOT_TXFULL(adp) (GET_IC_STATUS(adp) & ST_TFNF_BIT)
+#define NOT_RXEMPTY(adp) (GET_IC_STATUS(adp) & ST_RFNE_BIT)
+
+/* TRUCT DEFINE */
+enum SPD_MODE {
+	SPD_MODE_LS = 33,
+	SPD_MODE_SS = 100,
+	SPD_MODE_FS = 400,
+	SPD_MODE_HS = 1000
+};
+
+enum ADDR_MODE {
+	ADDR_MODE_7BITS   = 7,
+	ADDR_MODE_10BITS  = 10
+};
+
+enum {
+	ECMDSPLIT = 40, /* stop detected during transfer*/
+	ETXABORT = 41,
+	ETIMEOUT = 42,
+	EILLEGALMSG = 43, /* illegal message*/
+	EADDROVERRANGE = 44, /* invalid Address*/
+};
+
+enum {
+	NON_STOP = 0, /* stop detected during transfer */
+	WAIT_STOP = 1,
+};
+
+struct rtk_i2c_xfer {
+	unsigned char mode;
+	#define I2C_IDLE 0
+	#define I2C_MASTER_READ 1
+	#define I2C_MASTER_WRITE 2
+	#define I2C_MASTER_RANDOM_READ 3
+
+	/* don't issue stop command, (for gpio xfer only) */
+	#define I2C_NO_STOP 0x01
+
+	unsigned char flags;
+	unsigned char *tx_buff;
+	unsigned short tx_buff_len;
+	unsigned short tx_len;
+	unsigned char *rx_buff;
+	unsigned short rx_buff_len;
+	unsigned short rx_len;
+	unsigned long except_time;
+	unsigned long timeout;
+	int ret; /* 0 : on going, > 0 : success, < 0 : err */
+	unsigned int tx_abort_source; /* for gpio mode */
+};
+
+struct rtk_i2c_slave_ops {
+	int (*handle_command)(int id, unsigned char *cmd, unsigned char len);
+	unsigned char (*read_data)(int id); /* read data form i2c slave */
+};
+
+struct rtk_i2c_reg_map {
+	unsigned long I2C_ISR_EN;
+	unsigned long I2C_ISR_EN_MASK;
+	unsigned long I2C_ISR;
+	unsigned long I2C_INT;
+	unsigned long IC_CON;
+	unsigned long IC_TAR;
+	unsigned long IC_SAR;
+	unsigned long IC_HS_MADDR;
+	unsigned long IC_DATA_CMD;
+	unsigned long IC_SS_SCL_HCNT;
+	unsigned long IC_SS_SCL_LCNT;
+	unsigned long IC_FS_SCL_HCNT;
+	unsigned long IC_FS_SCL_LCNT;
+	unsigned long IC_HS_SCL_HCNT;
+	unsigned long IC_HS_SCL_LCNT;
+	unsigned long IC_INTR_STAT;
+	unsigned long IC_INTR_MASK;
+	unsigned long IC_RAW_INTR_STAT;
+	unsigned long IC_RX_TL;
+	unsigned long IC_TX_TL;
+	unsigned long IC_CLR_INTR;
+	unsigned long IC_CLR_RX_UNDER;
+	unsigned long IC_CLR_RX_OVER;
+	unsigned long IC_CLR_TX_OVER;
+	unsigned long IC_CLR_RD_REQ;
+	unsigned long IC_CLR_TX_ABRT;
+	unsigned long IC_CLR_RX_DONE;
+	unsigned long IC_CLR_ACTIVITY;
+	unsigned long IC_CLR_STOP_DET;
+	unsigned long IC_CLR_START_DET;
+	unsigned long IC_CLR_GEN_CALL;
+	unsigned long IC_ENABLE;
+	unsigned long IC_STATUS;
+	unsigned long IC_TXFLR;
+	unsigned long IC_RXFLR;
+	unsigned long IC_SDA_HOLD;
+	unsigned long IC_TX_ABRT_SOURCE;
+	unsigned long IC_SLV_DATA_NACK_ONLY;
+	unsigned long IC_DMA_CR;
+	unsigned long IC_DMA_TDLR;
+	unsigned long IC_DMA_RDLR;
+	unsigned long IC_SDA_SETUP;
+	unsigned long IC_ACK_GENERAL_CALL;
+	unsigned long IC_ENABLE_STATUS;
+	unsigned long IC_COMP_PARAM_1;
+	unsigned long IC_COMP_VERSION;
+	unsigned long IC_COMP_TYPE;
+	unsigned long IC_SDA_DEL;
+};
+
+struct rtk_i2c_handler {
+#define RTK_I2C_IRQ_RDY 0x01
+#define RTK_I2C_SLAVE_ENABLE 0x80
+	unsigned int flags;
+	atomic_t ref_cnt;
+	char *model_name;
+	unsigned int irq;
+	unsigned char id;
+	unsigned int spd;
+	unsigned int tick;
+	unsigned int guard_interval;
+	unsigned short sar;
+	unsigned short tar;
+	unsigned char rx_fifo_depth;
+	unsigned char tx_fifo_depth;
+	unsigned long time_stamp;
+	unsigned char slave_rx_buffer[64];
+	unsigned int slave_rx_len;
+	unsigned long slave_id;
+	unsigned int tx_abort_flag;
+	enum ADDR_MODE tar_mode;
+	enum ADDR_MODE sar_mode;
+	struct rtk_i2c_reg_map reg_map;
+	struct rtk_i2c_xfer xfer;
+	struct rtk_i2c_slave_ops slave_ops;
+	wait_queue_head_t wq;
+	spinlock_t lock;
+	int (*init)(struct rtk_i2c_handler *handler);
+	int (*uninit)(struct rtk_i2c_handler *handler);
+	int (*set_spd)(struct rtk_i2c_handler *handler, int KHz);
+	int (*set_guard_interval)(struct rtk_i2c_handler *handler,
+		unsigned long us);
+	int (*set_tar)(struct rtk_i2c_handler *handler, unsigned short addr,
+		enum ADDR_MODE mode);
+	int (*read)(struct rtk_i2c_handler *handler, unsigned char *tx_buf,
+		unsigned short tx_buf_len, unsigned char *rx_buff,
+		unsigned short rx_buf_len);
+	int (*write)(struct rtk_i2c_handler *handler, unsigned char *tx_buf,
+		unsigned short tx_buf_len, unsigned char wait_stop);
+#if 0
+	int (*gpio_read)(struct rtk_i2c_handler *handler,
+		unsigned char *tx_buf, unsigned short tx_buf_len,
+		unsigned char *rx_buff, unsigned short rx_buf_len);
+	int (*gpio_write)(struct rtk_i2c_handler *handler,
+		unsigned char *tx_buf, unsigned short tx_buf_len,
+		unsigned char wait_stop);
+#endif
+	int (*dump)(struct rtk_i2c_handler *handler); /* for debug*/
+#if 0
+	int (*suspend)(struct rtk_i2c_handler *handler);
+	int (*resume)(struct rtk_i2c_handler *handler);
+#endif
+	unsigned int (*get_tx_abort_reason)(struct rtk_i2c_handler *handler);
+	int (*set_sar)(struct rtk_i2c_handler *handler,
+		unsigned short, enum ADDR_MODE mode);
+	int (*register_slave_ops)(struct rtk_i2c_handler *handler,
+		struct rtk_i2c_slave_ops *ops, unsigned long id);
+	int (*slave_mode_enable)(struct rtk_i2c_handler *handler,
+		unsigned char on);
+#ifdef EDID_4BLOCK_SUPPORT
+	int (*read_edid_seg)(struct rtk_i2c_handler *handler,
+		unsigned char seg, unsigned char offset,
+		unsigned char *rx_buff, unsigned short rx_buf_len);
+#endif /* EDID_4BLOCK_SUPPORT */
+
+};
+
+/* FUNCTION PROTOTYPE */
+struct rtk_i2c_handler  *create_rtk_i2c_handle(unsigned int id,
+	unsigned short sar, enum ADDR_MODE sar_mode, enum SPD_MODE spd,
+	unsigned int irq, unsigned long base);
+
+int rtk_i2c_phy_init(struct rtk_i2c_handler *handler);
+
+int rtk_i2c_load_message(struct rtk_i2c_handler *handler, unsigned char mode,
+	unsigned char *tx_buf, unsigned short tx_buf_len,
+	unsigned char *rx_buf, unsigned short rx_buf_len,
+	unsigned char xfer_flags);
+
+int rtk_i2c_start_xfer(struct rtk_i2c_handler *handler);
+unsigned int rtk_i2c_get_tx_abort_reason(struct rtk_i2c_handler *handler);
+irqreturn_t rtk_i2c_isr(int this_irq, void *dev_id);
diff --git a/drivers/i2c/busses/i2c-rtk.c b/drivers/i2c/busses/i2c-rtk.c
new file mode 100644
index 00000000..4bf177b
--- /dev/null
+++ b/drivers/i2c/busses/i2c-rtk.c
@@ -0,0 +1,416 @@
+/*
+ * Realtek I2C driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/delay.h>
+#include <linux/i2c.h>
+#include <linux/err.h>
+#include <linux/interrupt.h>
+#include <linux/completion.h>
+#include <linux/platform_device.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_platform.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/slab.h>
+#include <linux/pm_runtime.h>
+#include <linux/pinctrl/consumer.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+#include "i2c-rtk-priv.h"
+
+#include <linux/pinctrl/consumer.h>
+
+
+#define RTK_MASTER_7BIT_ADDR  0x24
+#define IsReadMsg(x) (x.flags & I2C_M_RD)
+#define IsSameTarget(x, y) \
+((x.addr == y.addr) && !((x.flags ^ y.flags) & (~I2C_M_RD)))
+
+struct rtk_i2c_dev {
+	struct device *dev;
+	struct i2c_adapter adapter;
+	struct clk *div_clk;
+	void __iomem *base;
+	unsigned int id;
+	bool is_suspended;
+	u32 bus_clk_rate;
+	int cont_id;
+	int irq;
+	int is_dvc;
+	struct pinctrl *pctrl;
+	struct rtk_i2c_reg_map reg_map;
+	struct rtk_i2c_handler *handler;
+};
+
+void i2c_rtk_dump_msg(const struct i2c_msg *p_msg)
+{
+	RTK_DEBUG("%s\n", __func__);
+	pr_info("msg->addr  = %02x\n", p_msg->addr);
+	pr_info("msg->flags = %04x\n", p_msg->flags);
+	pr_info("msg->len   = %d\n", p_msg->len);
+	pr_info("msg->buf   = %p\n", p_msg->buf);
+}
+
+static u32 rtk_i2c_func(struct i2c_adapter *adap)
+{
+	u32 ret = I2C_FUNC_I2C | I2C_FUNC_SMBUS_EMUL |
+		I2C_FUNC_10BIT_ADDR | I2C_FUNC_PROTOCOL_MANGLING;
+
+	return ret;
+}
+
+static int  i2c_rtk_xfer(struct i2c_adapter *adap,
+	struct i2c_msg msgs[], int num)
+{
+	struct rtk_i2c_dev *i2c_dev = i2c_get_adapdata(adap);
+	struct rtk_i2c_handler *handler = i2c_dev->handler;
+	int i = 0;
+	int ret = 0;
+	struct pinctrl_state *pctrl_state;
+
+	RTK_DEBUG("%s\n", __func__);
+
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	if (handler->id == 0) {
+		pctrl_state = pinctrl_lookup_state(i2c_dev->pctrl, "default");
+		pinctrl_select_state(i2c_dev->pctrl, pctrl_state);
+	}
+#endif
+
+#ifdef EDID_4BLOCK_SUPPORT
+	if (handler->id == 1 && num == 3) {
+		if (msgs[0].addr == 0x30 && msgs[1].addr == 0x50) {
+			ret = handler->read_edid_seg(handler, msgs[0].buf[0],
+				msgs[1].buf[0], msgs[2].buf, msgs[2].len);
+
+			if (ret < 0)
+				goto err_occur;
+			else
+				return 3;
+		}
+	}
+#endif
+
+	for (i = 0; i < num; i++) {
+		ret = handler->set_tar(handler, msgs[i].addr, ADDR_MODE_7BITS);
+		if (ret < 0)
+			goto err_occur;
+
+		switch (msgs[i].flags & I2C_M_SPEED_MASK) {
+		case I2C_M_FAST_SPEED:
+			handler->set_spd(handler, 400);
+			break;
+		case I2C_M_HIGH_SPEED:
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+			if (handler->id == 0) {
+				pctrl_state = pinctrl_lookup_state(i2c_dev->pctrl, "high_speed");
+				pinctrl_select_state(i2c_dev->pctrl, pctrl_state);
+				handler->set_spd(handler, 3400);
+			}
+#else
+			handler->set_spd(handler, 800);
+#endif
+			break;
+		case I2C_M_LOW_SPEED:
+			handler->set_spd(handler, 50);
+			break;
+		case I2C_M_LOW_SPEED_80:
+			handler->set_spd(handler, 80);
+			break;
+		case I2C_M_LOW_SPEED_66:
+			handler->set_spd(handler, 66);
+			break;
+		case I2C_M_LOW_SPEED_33:
+			handler->set_spd(handler, 33);
+			break;
+		case I2C_M_LOW_SPEED_10:
+			handler->set_spd(handler, 10);
+			break;
+		default:
+		case I2C_M_NORMAL_SPEED:
+			handler->set_spd(handler, 100);
+			break;
+		}
+
+		handler->set_guard_interval(handler,
+			(msgs[i].flags & I2C_M_NO_GUARD_TIME) ? 0 : 1000);
+
+		if (IsReadMsg(msgs[i])) {
+			ret = handler->read(handler, NULL, 0, msgs[i].buf,
+				msgs[i].len);
+		} else {
+			if ((i < (num-1)) && IsReadMsg(msgs[i+1]) &&
+				IsSameTarget(msgs[i], msgs[i+1])) {
+				/* Random Read = Write + Read (same addr) */
+				ret = handler->read(handler,
+					msgs[i].buf, msgs[i].len,
+					msgs[i+1].buf, msgs[i+1].len);
+				i++;
+			} else {
+				/* Single Write */
+				ret = handler->write(handler,
+					msgs[i].buf, msgs[i].len,
+					(i == (num-1)) ? WAIT_STOP : NON_STOP);
+			}
+		}
+
+		if (ret < 0)
+			goto err_occur;
+	}
+
+	return i;
+
+err_occur:
+
+	switch (ret) {
+	case -ECMDSPLIT:
+		pr_info("[I2C%d] Xfer fail - MSG SPLIT (%d/%d)\n",
+			handler->id, i, num);
+		break;
+	case -ETXABORT:
+		pr_info("[I2C%d] Xfer fail - TXABORT (%d/%d), Reason=%04x\n",
+			handler->id, i, num,
+			handler->get_tx_abort_reason(handler));
+		break;
+	case -ETIMEOUT:
+		pr_info("[I2C%d] Xfer fail - TIMEOUT (%d/%d)\n",
+			handler->id, i, num);
+		break;
+	case -EILLEGALMSG:
+		pr_info("[I2C%d] Xfer fail - ILLEGAL MSG (%d/%d)\n",
+			handler->id, i, num);
+		break;
+	case -EADDROVERRANGE:
+		pr_info("[I2C%d] Xfer fail - ADDRESS OUT OF RANGE (%d/%d)\n",
+			handler->id, i, num);
+		break;
+	default:
+		pr_info("[I2C%d] Xfer fail - Unkonwn Return Value (%d/%d)\n",
+			handler->id, i, num);
+		break;
+	}
+
+	i2c_rtk_dump_msg(&msgs[i]);
+
+	ret = -EACCES;
+	return ret;
+}
+
+static const struct i2c_algorithm rtk_i2c_algo = {
+	.master_xfer = i2c_rtk_xfer,
+	.functionality = rtk_i2c_func,
+};
+
+static int  rtk_i2c_init(struct rtk_i2c_dev *i2c_dev)
+{
+	i2c_dev->handler = create_rtk_i2c_handle(
+		i2c_dev->id, RTK_MASTER_7BIT_ADDR,
+		ADDR_MODE_7BITS, SPD_MODE_SS, i2c_dev->irq,
+		(unsigned long)i2c_dev->base);
+
+	i2c_dev->pctrl = devm_pinctrl_get(i2c_dev->dev);
+
+	if (i2c_dev->handler == NULL)
+		pr_info("[I2C%d] handler is NULL, FAIL!!!!\n", i2c_dev->id);
+
+	return i2c_dev->handler->init(i2c_dev->handler);
+}
+
+/* Match table for of_platform binding */
+static const struct of_device_id rtk_i2c_of_match[] = {
+	{ .compatible = "realtek,rtk-i2c", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_i2c_of_match);
+
+static int rtk_i2c_probe(struct platform_device *pdev)
+{
+	struct rtk_i2c_dev *i2c_dev;
+	struct clk *div_clk = NULL;
+	void __iomem *base;
+	int irq;
+	u32 i2c_id;
+	int ret = 0;
+
+	base = of_iomap(pdev->dev.of_node, 0);
+	if (!base) {
+		pr_err("i2c no mmio space\n");
+		return -EINVAL;
+	}
+
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (irq < 0) {
+		pr_err("i2c no irq\n");
+		return -EINVAL;
+	}
+
+	if (of_property_read_u32(pdev->dev.of_node, "i2c-num", &i2c_id)) {
+		pr_err("Get I2C ID fail\n");
+		return -EINVAL;
+	}
+
+	div_clk = of_clk_get(pdev->dev.of_node, 0);
+	if (IS_ERR_OR_NULL(div_clk)) {
+		pr_warn("Failed to get clk from DT: %ld\n", PTR_ERR(div_clk));
+		div_clk = NULL;
+	}
+	clk_prepare_enable(div_clk);
+	ret = device_reset(&pdev->dev);
+	if (ret)
+		pr_warn("Failed to device reset: %d\n", ret);
+
+	i2c_dev = devm_kzalloc(&pdev->dev, sizeof(*i2c_dev), GFP_KERNEL);
+	i2c_dev->base = base;
+	i2c_dev->div_clk = div_clk;
+	i2c_dev->adapter.algo = &rtk_i2c_algo;
+	i2c_dev->irq = irq;
+	i2c_dev->cont_id = pdev->id;
+	i2c_dev->id = i2c_id;
+	i2c_dev->dev = &pdev->dev;
+
+	ret = of_property_read_u32(i2c_dev->dev->of_node, "clock-frequency",
+		&i2c_dev->bus_clk_rate);
+	if (ret)
+		i2c_dev->bus_clk_rate = 100000; /* default clock rate */
+
+	if (pdev->dev.of_node) {
+		const struct of_device_id *match;
+
+		match = of_match_device(rtk_i2c_of_match, &pdev->dev);
+	}
+
+	platform_set_drvdata(pdev, i2c_dev);
+
+	ret = rtk_i2c_init(i2c_dev);
+
+	if (ret) {
+		dev_err(&pdev->dev, "Failed to initialize i2c controller");
+		return ret;
+	}
+
+	ret = devm_request_irq(&pdev->dev, i2c_dev->irq, rtk_i2c_isr,
+		IRQF_SHARED, dev_name(&pdev->dev),
+		(void *)i2c_dev->handler);
+
+	i2c_set_adapdata(&i2c_dev->adapter, i2c_dev);
+	i2c_dev->adapter.owner = THIS_MODULE;
+	i2c_dev->adapter.class = I2C_CLASS_HWMON;
+	strlcpy(i2c_dev->adapter.name, "Realtek I2C adapter",
+		sizeof(i2c_dev->adapter.name));
+	i2c_dev->adapter.dev.parent = &pdev->dev;
+	i2c_dev->adapter.nr = pdev->id;
+	i2c_dev->adapter.dev.of_node = pdev->dev.of_node;
+
+	ret = i2c_add_numbered_adapter(&i2c_dev->adapter);
+
+	if (ret) {
+		dev_err(&pdev->dev, "Failed to add I2C adapter\n");
+		return ret;
+	}
+	return 0;
+}
+
+static int rtk_i2c_remove(struct platform_device *pdev)
+{
+	struct rtk_i2c_dev *i2c_dev = platform_get_drvdata(pdev);
+
+	i2c_del_adapter(&i2c_dev->adapter);
+	return 0;
+}
+
+#ifdef CONFIG_PM_SLEEP
+static int rtk_i2c_suspend(struct device *dev)
+{
+	struct rtk_i2c_dev *i2c_dev = dev_get_drvdata(dev);
+
+	pr_info("[I2C] Enter %s\n", __func__);
+
+	i2c_lock_adapter(&i2c_dev->adapter);
+	devm_pinctrl_put(i2c_dev->pctrl);
+	i2c_dev->is_suspended = true;
+	clk_disable_unprepare(i2c_dev->div_clk);
+	i2c_unlock_adapter(&i2c_dev->adapter);
+
+	pr_info("[I2C] Exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_i2c_resume(struct device *dev)
+{
+	struct rtk_i2c_dev *i2c_dev = dev_get_drvdata(dev);
+	int ret;
+
+	pr_info("[I2C] Enter %s\n", __func__);
+
+	i2c_lock_adapter(&i2c_dev->adapter);
+
+	clk_prepare_enable(i2c_dev->div_clk);
+
+	ret = rtk_i2c_init(i2c_dev);
+
+	if (ret) {
+		i2c_unlock_adapter(&i2c_dev->adapter);
+		return ret;
+	}
+
+	i2c_dev->is_suspended = false;
+
+	i2c_unlock_adapter(&i2c_dev->adapter);
+
+	pr_info("[I2C] Exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_i2c_pm_ops = {
+	.suspend_noirq = rtk_i2c_suspend,
+	.resume_noirq = rtk_i2c_resume,
+};
+
+#define RTK_I2C_PM_OPS (&rtk_i2c_pm_ops)
+#else
+#define RTK_I2C_PM_OPS NULL
+#endif /* CONFIG_PM_SLEEP */
+
+static struct platform_driver rtk_i2c_driver = {
+	.probe = rtk_i2c_probe,
+	.remove = rtk_i2c_remove,
+	.driver = {
+		.name = "rtk_i2c",
+		.owner = THIS_MODULE,
+		.pm = RTK_I2C_PM_OPS,
+		.of_match_table = of_match_ptr(rtk_i2c_of_match),
+	},
+};
+
+/* I2C may be needed to bring up other drivers */
+static int __init rtk_i2c_init_driver(void)
+{
+	return platform_driver_register(&rtk_i2c_driver);
+}
+//subsys_initcall(rtk_i2c_init_driver);
+rootfs_initcall(rtk_i2c_init_driver);
+
+static void __exit rtk_i2c_exit_driver(void)
+{
+	platform_driver_unregister(&rtk_i2c_driver);
+}
+module_exit(rtk_i2c_exit_driver);
+
+MODULE_AUTHOR("James Tai <james.tai@realtek.com>");
+MODULE_DESCRIPTION("Realtek I2C bus adapter");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtk_i2c");
diff --git a/drivers/i2c/busses/i2c-rtk.h b/drivers/i2c/busses/i2c-rtk.h
new file mode 100644
index 00000000..04e9084
--- /dev/null
+++ b/drivers/i2c/busses/i2c-rtk.h
@@ -0,0 +1,156 @@
+/*
+ * Realtek I2C driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#ifndef __I2C_RTK_H__
+#define __I2C_RTK_H__
+
+#include "platform.h"
+#include "../algos/i2c-algo-phoenix.h"
+
+#define MODLE_NAME        "rtk_i2c"
+#define I2C_PHY_CNT       7
+#define VERSION                "2.2"
+
+
+#define SET_I2C_CFG(phy_id, port_id)          ((0x80000000) | ((phy_id)<<8) \
+						 | (port_id))
+#define SET_G2C_CFG(sda, scl)                 ((0xC0000000) | ((sda)<<8) \
+						 | (scl))
+#define IS_I2C_CFG(cfg)                       ((cfg & 0xFFFF0000) == 0x80000000)
+#define IS_G2C_CFG(cfg)                       ((cfg & 0xFFFF0000) == 0xC0000000)
+#define IS_VALID_CFG(cfg)                     (IS_G2C_MODE(cfg) || \
+						IS_I2C_MODE(cfg))
+#define GET_I2C_PHY(cfg)                      ((cfg>>8) & 0xFF)
+#define GET_I2C_PORT(cfg)                     (cfg & 0xFF)
+#define GET_G2C_SDA(cfg)                      ((cfg>>8) & 0xFF)
+#define GET_G2C_SCL(cfg)                      (cfg & 0xFF)
+
+
+#define I2C_CON                 0x0000
+#define I2C_TAR                 0x0004
+#define I2C_SAR                 0x0008
+#define I2C_HS_MADDR            0x000c
+#define I2C_DATA_CMD            0x0010
+#define I2C_SS_SCL_HCNT         0x0014
+#define I2C_SS_SCL_LCNT         0x0018
+#define I2C_FS_SCL_HCNT         0x001c
+#define I2C_FS_SCL_LCNT         0x0020
+#define I2C_HS_SCL_HCNT         0x0024
+#define I2C_HS_SCL_LCNT         0x0028
+#define I2C_INTR_STAT           0x002c
+#define I2C_INTR_MASK           0x0030
+#define I2C_RAW_INTR_STAT       0x0034
+#define I2C_RX_TL               0x0038
+#define I2C_TX_TL               0x003c
+#define I2C_CLR_INTR            0x0040
+#define I2C_CLR_RX_UNDER        0x0044
+#define I2C_CLR_RX_OVER         0x0048
+#define I2C_CLR_TX_OVER         0x004c
+#define I2C_CLR_RD_REQ          0x0050
+#define I2C_CLR_TX_ABRT         0x0054
+#define I2C_CLR_RX_DONE         0x0058
+#define I2C_CLR_ACTIVITY        0x005c
+#define I2C_CLR_STOP_DET        0x0060
+#define I2C_CLR_START_DET       0x0064
+#define I2C_CLR_GEN_CALL        0x0068
+#define I2C_ENABLE              0x006c
+#define I2C_STATUS              0x0070
+#define I2C_TXFLR               0x0074
+#define I2C_RXFLR               0x0078
+#define I2C_SDA_HOLD            0x007c
+#define I2C_TX_ABRT_SOURCE      0x0080
+#define I2C_SLV_DATA_NACK_ONLY  0x0084
+#define I2C_DMA_CR              0x0088
+#define I2C_DMA_TDLR            0x008c
+#define I2C_DMA_RDLR            0x0090
+#define I2C_SDA_SETUP		0x0094
+#define I2C_ACK_GENERAL_CALL	0x0098
+#define I2C_ENABLE_STATUS		0x009c
+#define I2C_COMP_PARAM_1        0x00f4
+#define I2C_COMP_VERSION        0x00f8
+#define I2C_COMP_TYPE           0x00fc
+
+
+#ifdef CONFIG_ARCH_RTD119X
+#define MISC_ISR_I2C1    (0x00000001 << 4)
+#define MISC_I2C1_SDA_DEL	0x0088
+#else
+#define ISO_ISR_I2C1    (0x00000001 << 11)
+#define ISO_I2C1_SDA_DEL	0x0080
+#endif
+
+#define ISO_ISR_I2C0	(0x00000001 << 8)
+#define ISO_ISR_I2C6	(0x00000001 << 10)
+
+#define MIS_ISR_I2C2	(0x00000001 << 26)
+#define MIS_ISR_I2C3	(0x00000001 << 23)
+#define MIS_ISR_I2C4	(0x00000001 << 15)
+#define MIS_ISR_I2C5	(0x00000001 << 14)
+
+#define MIS_I2C2_SDA_DEL	0x008C
+#define MIS_I2C3_SDA_DEL	0x0090
+#define MIS_I2C4_SDA_DEL	0x0094
+#define MIS_I2C5_SDA_DEL	0x0098
+
+#define ISO_I2C0_SDA_DEL	0x0084
+#define ISO_I2C6_SDA_DEL	0x00c0
+
+
+
+/*IC_CON*/
+#define IC_SLAVE_DISABLE    0x0040
+#define IC_RESTART_EN       0x0020
+#define IC_10BITADDR_MASTER 0x0010
+#define IC_10BITADDR_SLAVE  0x0008
+#define IC_MASTER_MODE      0x0001
+
+#define IC_SPEED            0x0006
+#define SPEED_SS            0x0002
+#define SPEED_FS            0x0004
+#define SPEED_HS            0x0006
+
+/*ID_DATA*/
+#define READ_CMD            0x0100
+
+/*INT*/
+#define GEN_CALL_BIT        0x800
+#define START_DET_BIT       0x400
+#define STOP_DET_BIT        0x200
+#define ACTIVITY_BIT        0x100
+#define RX_DONE_BIT         0x080
+#define TX_ABRT_BIT         0x040
+#define RD_REQ_BIT          0x020
+#define TX_EMPTY_BIT        0x010
+#define TX_OVER_BIT         0x008
+#define RX_FULL_BIT         0x004
+#define RX_OVER_BIT         0x002
+#define RX_UNDER_BIT        0x001
+
+/*STATUS*/
+#define ST_RFF_BIT          0x10
+#define ST_RFNE_BIT         0x08
+#define ST_TFE_BIT          0x04
+#define ST_TFNF_BIT         0x02
+#define ST_ACTIVITY_BIT     0x01
+
+/*DELAY*/
+#define I2C_SDA_DEL_MASK	(0x1FF)
+#define I2C_SDA_DEL_EN		(0x00000001<<8)
+#define I2C_SDA_DEL_SEL(x)	((x & 0x1F)) /* Delay time: (unit 518ns)*/
+#define SDA_DEL_518NS		1
+#define SDA_DEL_1036NS		2
+#define SDA_DEL_1554NS		3
+#define SDA_DEL_2072NS		4
+#define SDA_DEL_2590NS		5
+#define I2C0_SDA_DEL_520NS    4
+
+
+#endif /*__I2C_RTK_H__*/
diff --git a/drivers/i2c/busses/i2c-venus-config-saturn.h b/drivers/i2c/busses/i2c-venus-config-saturn.h
new file mode 100644
index 00000000..f3028df
--- /dev/null
+++ b/drivers/i2c/busses/i2c-venus-config-saturn.h
@@ -0,0 +1,516 @@
+#ifndef __I2C_VENUS_CONFIG_SATURN_H__
+#define __I2C_VENUS_CONFIG_SATURN_H__
+
+#include "platform.h"
+
+#define MODLE_NAME        "Saturn"
+#define I2C_PHY_CNT       7
+
+#ifdef CONFIG_I2C_RTK
+#include "mars.h"
+#include "saturn.h"
+#endif
+
+//////////////////////////////////////////////////////////////////////////////////////////
+// I2C 0
+//////////////////////////////////////////////////////////////////////////////////////////
+
+static const venus_i2c_reg_map saturn_i2c0_reg = 
+{       
+    .I2C_ISR           		= ISO_IO_PORT_BASE + MARS_ISO_ISR,
+    .I2C_INT           		= MARS_ISO_ISR_I2C0,
+    .IC_CON            		= ISO_IO_PORT_BASE + MARS_ISO_IC0_CON,
+    .IC_TAR            		= ISO_IO_PORT_BASE + MARS_ISO_IC0_TAR,
+    .IC_SAR            		= ISO_IO_PORT_BASE + MARS_ISO_IC0_SAR,
+    .IC_HS_MADDR       		= ISO_IO_PORT_BASE + MARS_ISO_IC0_HS_MADDR,
+    .IC_DATA_CMD       		= ISO_IO_PORT_BASE + MARS_ISO_IC0_DATA_CMD,
+    .IC_SS_SCL_HCNT    	= ISO_IO_PORT_BASE + MARS_ISO_IC0_SS_SCL_HCNT,
+    .IC_SS_SCL_LCNT    	= ISO_IO_PORT_BASE + MARS_ISO_IC0_SS_SCL_LCNT,
+    .IC_FS_SCL_HCNT    	= ISO_IO_PORT_BASE + MARS_ISO_IC0_FS_SCL_HCNT,
+    .IC_FS_SCL_LCNT    		= ISO_IO_PORT_BASE + MARS_ISO_IC0_FS_SCL_LCNT,
+    .IC_INTR_STAT      		= ISO_IO_PORT_BASE + MARS_ISO_IC0_INTR_STAT,
+    .IC_INTR_MASK      		= ISO_IO_PORT_BASE + MARS_ISO_IC0_INTR_MASK,
+    .IC_RAW_INTR_STAT  	= ISO_IO_PORT_BASE + MARS_ISO_IC0_RAW_INTR_STAT,
+    .IC_RX_TL          		= ISO_IO_PORT_BASE + MARS_ISO_IC0_RX_TL,
+    .IC_TX_TL          		= ISO_IO_PORT_BASE + MARS_ISO_IC0_TX_TL,
+    .IC_CLR_INTR       		= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_INTR,
+    .IC_CLR_RX_UNDER   	= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_RX_UNDER,
+    .IC_CLR_RX_OVER    	= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_RX_OVER,
+    .IC_CLR_TX_OVER    	= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_TX_OVER,
+    .IC_CLR_RD_REQ     		= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_RD_REQ,
+    .IC_CLR_TX_ABRT    	= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_TX_ABRT,
+    .IC_CLR_RX_DONE    	= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_RX_DONE,
+    .IC_CLR_ACTIVITY   		= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_ACTIVITY,
+    .IC_CLR_STOP_DET   	= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_STOP_DET,
+    .IC_CLR_START_DET  	= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_START_DET,
+    .IC_CLR_GEN_CALL   	= ISO_IO_PORT_BASE + MARS_ISO_IC0_CLR_GEN_CALL,
+    .IC_ENABLE         		= ISO_IO_PORT_BASE + MARS_ISO_IC0_ENABLE,
+    .IC_STATUS         		= ISO_IO_PORT_BASE + MARS_ISO_IC0_STATUS,
+    .IC_TXFLR          		= ISO_IO_PORT_BASE + MARS_ISO_IC0_TXFLR,
+    .IC_RXFLR          		= ISO_IO_PORT_BASE + MARS_ISO_IC0_RXFLR,
+    .IC_SDA_HOLD          	= ISO_IO_PORT_BASE + 	MARS_ISO_IC0_SDA_HOLD,
+    .IC_TX_ABRT_SOURCE 	= ISO_IO_PORT_BASE + MARS_ISO_IC0_TX_ABRT_SOURCE,
+    .IC_SLV_DATA_NACK_ONLY= ISO_IO_PORT_BASE + MARS_ISO_IC0_SLV_DATA_NACK_ONLY,
+    .IC_DMA_CR         		= ISO_IO_PORT_BASE + MARS_ISO_IC0_DMA_CR,
+    .IC_DMA_TDLR       		= ISO_IO_PORT_BASE + MARS_ISO_IC0_DMA_TDLR,
+    .IC_DMA_RDLR       		= ISO_IO_PORT_BASE + MARS_ISO_IC0_DMA_RDLR,
+    .IC_SDA_SETUP          	= ISO_IO_PORT_BASE + MARS_ISO_IC0_SDA_SETUP,
+    .IC_ACK_GENERAL_CALL 	= ISO_IO_PORT_BASE + MARS_ISO_IC0_ACK_GENERAL_CALL,
+    .IC_ENABLE_STATUS       	= ISO_IO_PORT_BASE + MARS_ISO_IC0_ENABLE_STATUS,
+    .IC_COMP_PARAM_1  	= ISO_IO_PORT_BASE + MARS_ISO_IC0_COMP_PARAM_1,
+    .IC_COMP_VERSION   	= ISO_IO_PORT_BASE + MARS_ISO_IC0_COMP_VERSION,
+    .IC_COMP_TYPE      		= ISO_IO_PORT_BASE + MARS_ISO_IC0_COMP_TYPE,
+    .IC_SDA_DEL        		= ISO_IO_PORT_BASE + SATURN_ISO_I2C0_SDA_DEL,          // for Saturn Only
+};
+
+static const venus_i2c_port saturn_i2c0_port[] = 
+{
+    {
+        // PHY1 SRC-0
+        .gpio_mapped   = 0, 
+        .g2c_scl       = venus_gpio_id(MIS_GPIO, 61),
+        .g2c_sda       = venus_gpio_id(MIS_GPIO, 62),
+        .input_mux[0]  = {0},   
+        .input_mux[1]  = {0},                   
+        .pin_mux[0]    = {0xFE007310, 0xF<<24, 0x5<<24, 0},
+        .pin_mux[1]    = {0},                
+    },    
+};
+    
+
+
+
+//////////////////////////////////////////////////////////////////////////////////////////
+// I2C 1
+//////////////////////////////////////////////////////////////////////////////////////////
+
+static const venus_i2c_reg_map saturn_i2c1_reg = 
+{       
+    .I2C_ISR           		= MISC_IO_PORT_BASE + MARS_MIS_ISR,
+    .I2C_INT           		= MARS_MIS_ISR_I2C1,
+    .IC_CON            		= MISC_IO_PORT_BASE + MARS_MIS_IC1_CON,
+    .IC_TAR            		= MISC_IO_PORT_BASE + MARS_MIS_IC1_TAR,
+    .IC_SAR            		= MISC_IO_PORT_BASE + MARS_MIS_IC1_SAR,
+    .IC_HS_MADDR       		= MISC_IO_PORT_BASE + MARS_MIS_IC1_HS_MADDR,
+    .IC_DATA_CMD       		= MISC_IO_PORT_BASE + MARS_MIS_IC1_DATA_CMD,
+    .IC_SS_SCL_HCNT    	= MISC_IO_PORT_BASE + MARS_MIS_IC1_SS_SCL_HCNT,
+    .IC_SS_SCL_LCNT    	= MISC_IO_PORT_BASE + MARS_MIS_IC1_SS_SCL_LCNT,
+    .IC_FS_SCL_HCNT    	= MISC_IO_PORT_BASE + MARS_MIS_IC1_FS_SCL_HCNT,
+    .IC_FS_SCL_LCNT    		= MISC_IO_PORT_BASE + MARS_MIS_IC1_FS_SCL_LCNT,
+    .IC_INTR_STAT      		= MISC_IO_PORT_BASE + MARS_MIS_IC1_INTR_STAT,
+    .IC_INTR_MASK      		= MISC_IO_PORT_BASE + MARS_MIS_IC1_INTR_MASK,
+    .IC_RAW_INTR_STAT  	= MISC_IO_PORT_BASE + MARS_MIS_IC1_RAW_INTR_STAT,
+    .IC_RX_TL          		= MISC_IO_PORT_BASE + MARS_MIS_IC1_RX_TL,
+    .IC_TX_TL          		= MISC_IO_PORT_BASE + MARS_MIS_IC1_TX_TL,
+    .IC_CLR_INTR       		= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_INTR,
+    .IC_CLR_RX_UNDER   	= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_RX_UNDER,
+    .IC_CLR_RX_OVER    	= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_RX_OVER,
+    .IC_CLR_TX_OVER    	= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_TX_OVER,
+    .IC_CLR_RD_REQ     		= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_RD_REQ,
+    .IC_CLR_TX_ABRT    	= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_TX_ABRT,
+    .IC_CLR_RX_DONE    	= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_RX_DONE,
+    .IC_CLR_ACTIVITY   		= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_ACTIVITY,
+    .IC_CLR_STOP_DET   	= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_STOP_DET,
+    .IC_CLR_START_DET  	= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_START_DET,
+    .IC_CLR_GEN_CALL   	= MISC_IO_PORT_BASE + MARS_MIS_IC1_CLR_GEN_CALL,
+    .IC_ENABLE         		= MISC_IO_PORT_BASE + MARS_MIS_IC1_ENABLE,
+    .IC_STATUS         		= MISC_IO_PORT_BASE + MARS_MIS_IC1_STATUS,
+    .IC_TXFLR          		= MISC_IO_PORT_BASE + MARS_MIS_IC1_TXFLR,
+    .IC_RXFLR          		= MISC_IO_PORT_BASE + MARS_MIS_IC1_RXFLR,
+    .IC_SDA_HOLD          	= MISC_IO_PORT_BASE + 	MARS_MIS_IC1_SDA_HOLD,
+    .IC_TX_ABRT_SOURCE 	= MISC_IO_PORT_BASE + MARS_MIS_IC1_TX_ABRT_SOURCE,
+    .IC_SLV_DATA_NACK_ONLY= MISC_IO_PORT_BASE + MARS_MIS_IC1_SLV_DATA_NACK_ONLY,
+    .IC_DMA_CR         		= MISC_IO_PORT_BASE + MARS_MIS_IC1_DMA_CR,
+    .IC_DMA_TDLR       		= MISC_IO_PORT_BASE + MARS_MIS_IC1_DMA_TDLR,
+    .IC_DMA_RDLR       		= MISC_IO_PORT_BASE + MARS_MIS_IC1_DMA_RDLR,
+    .IC_SDA_SETUP          	= MISC_IO_PORT_BASE + MARS_MIS_IC1_SDA_SETUP,
+    .IC_ACK_GENERAL_CALL 	= MISC_IO_PORT_BASE + MARS_MIS_IC1_ACK_GENERAL_CALL,
+    .IC_ENABLE_STATUS       	= MISC_IO_PORT_BASE + MARS_MIS_IC1_ENABLE_STATUS,
+    .IC_COMP_PARAM_1  	= MISC_IO_PORT_BASE + MARS_MIS_IC1_COMP_PARAM_1,
+    .IC_COMP_VERSION   	= MISC_IO_PORT_BASE + MARS_MIS_IC1_COMP_VERSION,
+    .IC_COMP_TYPE      		= MISC_IO_PORT_BASE + MARS_MIS_IC1_COMP_TYPE,
+    .IC_SDA_DEL        		= MISC_IO_PORT_BASE + SATURN_MIS_I2C1_SDA_DEL,          // for Saturn Only
+};
+
+static const venus_i2c_port saturn_i2c1_port[] = 
+{
+    {
+        // PHY1 SRC-0
+        .gpio_mapped   = 0, 
+        .g2c_scl       = 51,//venus_gpio_id(MIS_GPIO, 61),
+        .g2c_sda       = 52,//venus_gpio_id(MIS_GPIO, 62),
+        .input_mux[0]  = {0},   
+        .input_mux[1]  = {0},                   
+#ifdef CONFIG_MACH_RTK1192
+        .pin_mux[0]    = {0xFE01A90C, 0xF<<0, 0x5<<0, 0},
+#else
+        .pin_mux[0]    = {0xFE00036c, 0xF<<0, 0x5<<0, 0},
+#endif
+        .pin_mux[1]    = {0},                
+    },    
+};
+    
+    
+//////////////////////////////////////////////////////////////////////////////////////////
+// I2C 2
+//////////////////////////////////////////////////////////////////////////////////////////    
+static const venus_i2c_reg_map saturn_i2c2_reg = 
+{    
+    .I2C_ISR           = MISC_IO_PORT_BASE + MARS_MIS_ISR,
+    .I2C_INT           = MARS_MIS_ISR_I2C2,
+    .IC_CON            = MISC_IO_PORT_BASE + MARS_MIS_IC2_CON,
+    .IC_TAR            = MISC_IO_PORT_BASE + MARS_MIS_IC2_TAR,
+    .IC_SAR            = MISC_IO_PORT_BASE + MARS_MIS_IC2_SAR,
+    .IC_HS_MADDR       = MISC_IO_PORT_BASE + MARS_MIS_IC2_HS_MADDR,
+    .IC_DATA_CMD       = MISC_IO_PORT_BASE + MARS_MIS_IC2_DATA_CMD,
+    .IC_SS_SCL_HCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC2_SS_SCL_HCNT,
+    .IC_SS_SCL_LCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC2_SS_SCL_LCNT,
+    .IC_FS_SCL_HCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC2_FS_SCL_HCNT,
+    .IC_FS_SCL_LCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC2_FS_SCL_LCNT,
+    .IC_INTR_STAT      = MISC_IO_PORT_BASE + MARS_MIS_IC2_INTR_STAT,
+    .IC_INTR_MASK      = MISC_IO_PORT_BASE + MARS_MIS_IC2_INTR_MASK,
+    .IC_RAW_INTR_STAT  = MISC_IO_PORT_BASE + MARS_MIS_IC2_RAW_INTR_STAT,
+    .IC_RX_TL          = MISC_IO_PORT_BASE + MARS_MIS_IC2_RX_TL,
+    .IC_TX_TL          = MISC_IO_PORT_BASE + MARS_MIS_IC2_TX_TL,
+    .IC_CLR_INTR       = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_INTR,
+    .IC_CLR_RX_UNDER   = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_RX_UNDER,
+    .IC_CLR_RX_OVER    = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_RX_OVER,
+    .IC_CLR_TX_OVER    = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_TX_OVER,
+    .IC_CLR_RD_REQ     = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_RD_REQ,
+    .IC_CLR_TX_ABRT    = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_TX_ABRT,
+    .IC_CLR_RX_DONE    = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_RX_DONE,
+    .IC_CLR_ACTIVITY   = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_ACTIVITY,
+    .IC_CLR_STOP_DET   = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_STOP_DET,
+    .IC_CLR_START_DET  = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_START_DET,
+    .IC_CLR_GEN_CALL   = MISC_IO_PORT_BASE + MARS_MIS_IC2_CLR_GEN_CALL,
+    .IC_ENABLE         = MISC_IO_PORT_BASE + MARS_MIS_IC2_ENABLE,
+    .IC_STATUS         = MISC_IO_PORT_BASE + MARS_MIS_IC2_STATUS,
+    .IC_TXFLR          = MISC_IO_PORT_BASE + MARS_MIS_IC2_TXFLR,
+    .IC_RXFLR          = MISC_IO_PORT_BASE + MARS_MIS_IC2_RXFLR,
+    .IC_SDA_HOLD          = MISC_IO_PORT_BASE + 	MARS_MIS_IC2_SDA_HOLD,
+    .IC_TX_ABRT_SOURCE = MISC_IO_PORT_BASE + MARS_MIS_IC2_TX_ABRT_SOURCE,
+    .IC_SLV_DATA_NACK_ONLY          = MISC_IO_PORT_BASE + MARS_MIS_IC2_SLV_DATA_NACK_ONLY,
+    .IC_DMA_CR         = MISC_IO_PORT_BASE + MARS_MIS_IC2_DMA_CR,
+    .IC_DMA_TDLR       = MISC_IO_PORT_BASE + MARS_MIS_IC2_DMA_TDLR,
+    .IC_DMA_RDLR       = MISC_IO_PORT_BASE + MARS_MIS_IC2_DMA_RDLR,
+    .IC_SDA_SETUP          = MISC_IO_PORT_BASE + MARS_MIS_IC2_SDA_SETUP,
+    .IC_ACK_GENERAL_CALL          = MISC_IO_PORT_BASE + MARS_MIS_IC2_ACK_GENERAL_CALL,
+    .IC_ENABLE_STATUS          = MISC_IO_PORT_BASE + MARS_MIS_IC2_ENABLE_STATUS,
+    .IC_COMP_PARAM_1   = MISC_IO_PORT_BASE + MARS_MIS_IC2_COMP_PARAM_1,
+    .IC_COMP_VERSION   = MISC_IO_PORT_BASE + MARS_MIS_IC2_COMP_VERSION,
+    .IC_COMP_TYPE      = MISC_IO_PORT_BASE + MARS_MIS_IC2_COMP_TYPE,
+    .IC_SDA_DEL        = MISC_IO_PORT_BASE + SATURN_MIS_I2C2_SDA_DEL,          // for Saturn Only
+};  
+              
+static const venus_i2c_port saturn_i2c2_port[] = 
+{
+    {
+        // PHY2 SRC-0
+        .gpio_mapped   = 0, 
+        .g2c_scl       = venus_gpio_id(MIS_GPIO, 63),
+        .g2c_sda       = venus_gpio_id(MIS_GPIO, 64),
+        .input_mux[0]  = {0},   
+        .input_mux[1]  = {0},                   
+#ifdef CONFIG_MACH_RTK1192
+        .pin_mux[0]    = {0xFE01A908, 0x33<<18, 0x33<<18, 0x22<<18},
+#else
+        .pin_mux[0]    = {0xFE000368, 0x33<<18, 0x33<<18, 0x22<<18},
+#endif
+        .pin_mux[1]    = {0},                
+    },    
+};                                    
+
+ 
+//////////////////////////////////////////////////////////////////////////////////////////
+// I2C 3
+//////////////////////////////////////////////////////////////////////////////////////////    
+static const venus_i2c_reg_map saturn_i2c3_reg = 
+{    
+    .I2C_ISR           = MISC_IO_PORT_BASE + MARS_MIS_ISR,
+    .I2C_INT           = MARS_MIS_ISR_I2C3,
+    .IC_CON            = MISC_IO_PORT_BASE + MARS_MIS_IC3_CON,
+    .IC_TAR            = MISC_IO_PORT_BASE + MARS_MIS_IC3_TAR,
+    .IC_SAR            = MISC_IO_PORT_BASE + MARS_MIS_IC3_SAR,
+    .IC_HS_MADDR       = MISC_IO_PORT_BASE + MARS_MIS_IC3_HS_MADDR,
+    .IC_DATA_CMD       = MISC_IO_PORT_BASE + MARS_MIS_IC3_DATA_CMD,
+    .IC_SS_SCL_HCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC3_SS_SCL_HCNT,
+    .IC_SS_SCL_LCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC3_SS_SCL_LCNT,
+    .IC_FS_SCL_HCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC3_FS_SCL_HCNT,
+    .IC_FS_SCL_LCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC3_FS_SCL_LCNT,
+    .IC_INTR_STAT      = MISC_IO_PORT_BASE + MARS_MIS_IC3_INTR_STAT,
+    .IC_INTR_MASK      = MISC_IO_PORT_BASE + MARS_MIS_IC3_INTR_MASK,
+    .IC_RAW_INTR_STAT  = MISC_IO_PORT_BASE + MARS_MIS_IC3_RAW_INTR_STAT,
+    .IC_RX_TL          = MISC_IO_PORT_BASE + MARS_MIS_IC3_RX_TL,
+    .IC_TX_TL          = MISC_IO_PORT_BASE + MARS_MIS_IC3_TX_TL,
+    .IC_CLR_INTR       = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_INTR,
+    .IC_CLR_RX_UNDER   = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_RX_UNDER,
+    .IC_CLR_RX_OVER    = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_RX_OVER,
+    .IC_CLR_TX_OVER    = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_TX_OVER,
+    .IC_CLR_RD_REQ     = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_RD_REQ,
+    .IC_CLR_TX_ABRT    = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_TX_ABRT,
+    .IC_CLR_RX_DONE    = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_RX_DONE,
+    .IC_CLR_ACTIVITY   = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_ACTIVITY,
+    .IC_CLR_STOP_DET   = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_STOP_DET,
+    .IC_CLR_START_DET  = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_START_DET,
+    .IC_CLR_GEN_CALL   = MISC_IO_PORT_BASE + MARS_MIS_IC3_CLR_GEN_CALL,
+    .IC_ENABLE         = MISC_IO_PORT_BASE + MARS_MIS_IC3_ENABLE,
+    .IC_STATUS         = MISC_IO_PORT_BASE + MARS_MIS_IC3_STATUS,
+    .IC_TXFLR          = MISC_IO_PORT_BASE + MARS_MIS_IC3_TXFLR,
+    .IC_RXFLR          = MISC_IO_PORT_BASE + MARS_MIS_IC3_RXFLR,
+    .IC_SDA_HOLD          = MISC_IO_PORT_BASE + 	MARS_MIS_IC3_SDA_HOLD,
+    .IC_TX_ABRT_SOURCE = MISC_IO_PORT_BASE + MARS_MIS_IC3_TX_ABRT_SOURCE,
+    .IC_SLV_DATA_NACK_ONLY          = MISC_IO_PORT_BASE + MARS_MIS_IC3_SLV_DATA_NACK_ONLY,
+    .IC_DMA_CR         = MISC_IO_PORT_BASE + MARS_MIS_IC3_DMA_CR,
+    .IC_DMA_TDLR       = MISC_IO_PORT_BASE + MARS_MIS_IC3_DMA_TDLR,
+    .IC_DMA_RDLR       = MISC_IO_PORT_BASE + MARS_MIS_IC3_DMA_RDLR,
+    .IC_SDA_SETUP          = MISC_IO_PORT_BASE + MARS_MIS_IC3_SDA_SETUP,
+    .IC_ACK_GENERAL_CALL          = MISC_IO_PORT_BASE + MARS_MIS_IC3_ACK_GENERAL_CALL,
+    .IC_ENABLE_STATUS          = MISC_IO_PORT_BASE + MARS_MIS_IC3_ENABLE_STATUS,
+    .IC_COMP_PARAM_1   = MISC_IO_PORT_BASE + MARS_MIS_IC3_COMP_PARAM_1,
+    .IC_COMP_VERSION   = MISC_IO_PORT_BASE + MARS_MIS_IC3_COMP_VERSION,
+    .IC_COMP_TYPE      = MISC_IO_PORT_BASE + MARS_MIS_IC3_COMP_TYPE,
+    .IC_SDA_DEL        = MISC_IO_PORT_BASE + SATURN_MIS_I2C3_SDA_DEL,          // for Saturn Only
+};  
+              
+static const venus_i2c_port saturn_i2c3_port[] = 
+{
+    {
+        // PHY3 SRC-0
+        .gpio_mapped   = 1, //0, 
+        .g2c_scl       = 42, //venus_gpio_id(MIS_GPIO, 63),
+        .g2c_sda       = 40, //venus_gpio_id(MIS_GPIO, 64),
+        .input_mux[0]  = {0},   
+        .input_mux[1]  = {0},                   
+#ifdef CONFIG_MACH_RTK1192
+        .pin_mux[0]    = {0xFE01A908, 0x33<<16, 0x33<<16, 0x22<<16},
+#else
+        .pin_mux[0]    = {0xFE000368, 0x33<<16, 0x33<<16, 0x22<<16},
+#endif
+        .pin_mux[1]    = {0},                
+    },    
+};                                    
+
+ 
+//////////////////////////////////////////////////////////////////////////////////////////
+// I2C 4
+//////////////////////////////////////////////////////////////////////////////////////////    
+static const venus_i2c_reg_map saturn_i2c4_reg = 
+{    
+    .I2C_ISR           = MISC_IO_PORT_BASE + MARS_MIS_ISR,
+    .I2C_INT           = MARS_MIS_ISR_I2C4,
+    .IC_CON            = MISC_IO_PORT_BASE + MARS_MIS_IC4_CON,
+    .IC_TAR            = MISC_IO_PORT_BASE + MARS_MIS_IC4_TAR,
+    .IC_SAR            = MISC_IO_PORT_BASE + MARS_MIS_IC4_SAR,
+    .IC_HS_MADDR       = MISC_IO_PORT_BASE + MARS_MIS_IC4_HS_MADDR,
+    .IC_DATA_CMD       = MISC_IO_PORT_BASE + MARS_MIS_IC4_DATA_CMD,
+    .IC_SS_SCL_HCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC4_SS_SCL_HCNT,
+    .IC_SS_SCL_LCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC4_SS_SCL_LCNT,
+    .IC_FS_SCL_HCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC4_FS_SCL_HCNT,
+    .IC_FS_SCL_LCNT    = MISC_IO_PORT_BASE + MARS_MIS_IC4_FS_SCL_LCNT,
+    .IC_INTR_STAT      = MISC_IO_PORT_BASE + MARS_MIS_IC4_INTR_STAT,
+    .IC_INTR_MASK      = MISC_IO_PORT_BASE + MARS_MIS_IC4_INTR_MASK,
+    .IC_RAW_INTR_STAT  = MISC_IO_PORT_BASE + MARS_MIS_IC4_RAW_INTR_STAT,
+    .IC_RX_TL          = MISC_IO_PORT_BASE + MARS_MIS_IC4_RX_TL,
+    .IC_TX_TL          = MISC_IO_PORT_BASE + MARS_MIS_IC4_TX_TL,
+    .IC_CLR_INTR       = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_INTR,
+    .IC_CLR_RX_UNDER   = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_RX_UNDER,
+    .IC_CLR_RX_OVER    = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_RX_OVER,
+    .IC_CLR_TX_OVER    = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_TX_OVER,
+    .IC_CLR_RD_REQ     = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_RD_REQ,
+    .IC_CLR_TX_ABRT    = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_TX_ABRT,
+    .IC_CLR_RX_DONE    = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_RX_DONE,
+    .IC_CLR_ACTIVITY   = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_ACTIVITY,
+    .IC_CLR_STOP_DET   = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_STOP_DET,
+    .IC_CLR_START_DET  = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_START_DET,
+    .IC_CLR_GEN_CALL   = MISC_IO_PORT_BASE + MARS_MIS_IC4_CLR_GEN_CALL,
+    .IC_ENABLE         = MISC_IO_PORT_BASE + MARS_MIS_IC4_ENABLE,
+    .IC_STATUS         = MISC_IO_PORT_BASE + MARS_MIS_IC4_STATUS,
+    .IC_TXFLR          = MISC_IO_PORT_BASE + MARS_MIS_IC4_TXFLR,
+    .IC_RXFLR          = MISC_IO_PORT_BASE + MARS_MIS_IC4_RXFLR,
+    .IC_SDA_HOLD          = MISC_IO_PORT_BASE + 	MARS_MIS_IC4_SDA_HOLD,
+    .IC_TX_ABRT_SOURCE = MISC_IO_PORT_BASE + MARS_MIS_IC4_TX_ABRT_SOURCE,
+    .IC_SLV_DATA_NACK_ONLY          = MISC_IO_PORT_BASE + MARS_MIS_IC4_SLV_DATA_NACK_ONLY,
+    .IC_DMA_CR         = MISC_IO_PORT_BASE + MARS_MIS_IC4_DMA_CR,
+    .IC_DMA_TDLR       = MISC_IO_PORT_BASE + MARS_MIS_IC4_DMA_TDLR,
+    .IC_DMA_RDLR       = MISC_IO_PORT_BASE + MARS_MIS_IC4_DMA_RDLR,
+    .IC_SDA_SETUP          = MISC_IO_PORT_BASE + MARS_MIS_IC4_SDA_SETUP,
+    .IC_ACK_GENERAL_CALL          = MISC_IO_PORT_BASE + MARS_MIS_IC4_ACK_GENERAL_CALL,
+    .IC_ENABLE_STATUS          = MISC_IO_PORT_BASE + MARS_MIS_IC4_ENABLE_STATUS,
+    .IC_COMP_PARAM_1   = MISC_IO_PORT_BASE + MARS_MIS_IC4_COMP_PARAM_1,
+    .IC_COMP_VERSION   = MISC_IO_PORT_BASE + MARS_MIS_IC4_COMP_VERSION,
+    .IC_COMP_TYPE      = MISC_IO_PORT_BASE + MARS_MIS_IC4_COMP_TYPE,
+    .IC_SDA_DEL        = MISC_IO_PORT_BASE + SATURN_MIS_I2C4_SDA_DEL,          // for Saturn Only
+};  
+              
+static const venus_i2c_port saturn_i2c4_port[] = 
+{
+    {
+        // PHY4 SRC-0
+        .gpio_mapped   = 0, 
+        .g2c_scl       = venus_gpio_id(MIS_GPIO, 63),
+        .g2c_sda       = venus_gpio_id(MIS_GPIO, 64),
+        .input_mux[0]  = {0},   
+        .input_mux[1]  = {0},                   
+#ifdef CONFIG_MACH_RTK1192
+        .pin_mux[0]    = {0xFE01A90C, 0xF<<4, 0x5<<4, 0},
+#else
+        .pin_mux[0]    = {0xFE00036c, 0xF<<4, 0x5<<4, 0},
+#endif
+        .pin_mux[1]    = {0},                
+    },    
+};                                    
+
+ 
+//////////////////////////////////////////////////////////////////////////////////////////
+// I2C 5
+//////////////////////////////////////////////////////////////////////////////////////////    
+static const venus_i2c_reg_map saturn_i2c5_reg = 
+{    
+    .I2C_ISR          		 		= MISC_IO_PORT_BASE + MARS_MIS_ISR,
+    .I2C_INT           			= MARS_MIS_ISR_I2C5,
+    .IC_CON            			= MISC_IO_PORT_BASE + MARS_MIS_IC5_CON,
+    .IC_TAR            			= MISC_IO_PORT_BASE + MARS_MIS_IC5_TAR,
+    .IC_SAR            			= MISC_IO_PORT_BASE + MARS_MIS_IC5_SAR,
+    .IC_HS_MADDR       			= MISC_IO_PORT_BASE + MARS_MIS_IC5_HS_MADDR,
+    .IC_DATA_CMD       			= MISC_IO_PORT_BASE + MARS_MIS_IC5_DATA_CMD,
+    .IC_SS_SCL_HCNT    		= MISC_IO_PORT_BASE + MARS_MIS_IC5_SS_SCL_HCNT,
+    .IC_SS_SCL_LCNT    		= MISC_IO_PORT_BASE + MARS_MIS_IC5_SS_SCL_LCNT,
+    .IC_FS_SCL_HCNT   	 		= MISC_IO_PORT_BASE + MARS_MIS_IC5_FS_SCL_HCNT,
+    .IC_FS_SCL_LCNT    			= MISC_IO_PORT_BASE + MARS_MIS_IC5_FS_SCL_LCNT,
+    .IC_INTR_STAT      			= MISC_IO_PORT_BASE + MARS_MIS_IC5_INTR_STAT,
+    .IC_INTR_MASK      			= MISC_IO_PORT_BASE + MARS_MIS_IC5_INTR_MASK,
+    .IC_RAW_INTR_STAT  		= MISC_IO_PORT_BASE + MARS_MIS_IC5_RAW_INTR_STAT,
+    .IC_RX_TL          			= MISC_IO_PORT_BASE + MARS_MIS_IC5_RX_TL,
+    .IC_TX_TL          			= MISC_IO_PORT_BASE + MARS_MIS_IC5_TX_TL,
+    .IC_CLR_INTR       			= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_INTR,
+    .IC_CLR_RX_UNDER   		= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_RX_UNDER,
+    .IC_CLR_RX_OVER    		= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_RX_OVER,
+    .IC_CLR_TX_OVER    		= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_TX_OVER,
+    .IC_CLR_RD_REQ     			= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_RD_REQ,
+    .IC_CLR_TX_ABRT    		= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_TX_ABRT,
+    .IC_CLR_RX_DONE    		= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_RX_DONE,
+    .IC_CLR_ACTIVITY   			= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_ACTIVITY,
+    .IC_CLR_STOP_DET   		= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_STOP_DET,
+    .IC_CLR_START_DET  		= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_START_DET,
+    .IC_CLR_GEN_CALL   		= MISC_IO_PORT_BASE + MARS_MIS_IC5_CLR_GEN_CALL,
+    .IC_ENABLE         			= MISC_IO_PORT_BASE + MARS_MIS_IC5_ENABLE,
+    .IC_STATUS         			= MISC_IO_PORT_BASE + MARS_MIS_IC5_STATUS,
+    .IC_TXFLR          			= MISC_IO_PORT_BASE + MARS_MIS_IC5_TXFLR,
+    .IC_RXFLR          			= MISC_IO_PORT_BASE + MARS_MIS_IC5_RXFLR,
+    .IC_SDA_HOLD          		= MISC_IO_PORT_BASE + MARS_MIS_IC5_SDA_HOLD,
+    .IC_TX_ABRT_SOURCE 		= MISC_IO_PORT_BASE + MARS_MIS_IC5_TX_ABRT_SOURCE,
+    .IC_SLV_DATA_NACK_ONLY   	= MISC_IO_PORT_BASE + MARS_MIS_IC5_SLV_DATA_NACK_ONLY,
+    .IC_DMA_CR         			= MISC_IO_PORT_BASE + MARS_MIS_IC5_DMA_CR,
+    .IC_DMA_TDLR       			= MISC_IO_PORT_BASE + MARS_MIS_IC5_DMA_TDLR,
+    .IC_DMA_RDLR       			= MISC_IO_PORT_BASE + MARS_MIS_IC5_DMA_RDLR,
+    .IC_SDA_SETUP          		= MISC_IO_PORT_BASE + MARS_MIS_IC5_SDA_SETUP,
+    .IC_ACK_GENERAL_CALL		= MISC_IO_PORT_BASE + MARS_MIS_IC5_ACK_GENERAL_CALL,
+    .IC_ENABLE_STATUS 		= MISC_IO_PORT_BASE + MARS_MIS_IC5_ENABLE_STATUS,
+    .IC_COMP_PARAM_1   		= MISC_IO_PORT_BASE + MARS_MIS_IC5_COMP_PARAM_1,
+    .IC_COMP_VERSION   		= MISC_IO_PORT_BASE + MARS_MIS_IC5_COMP_VERSION,
+    .IC_COMP_TYPE      			= MISC_IO_PORT_BASE + MARS_MIS_IC5_COMP_TYPE,
+    .IC_SDA_DEL        			= MISC_IO_PORT_BASE + SATURN_MIS_I2C5_SDA_DEL,          // for Saturn Only
+};  
+              
+static const venus_i2c_port saturn_i2c5_port[] = 
+{
+    {
+        // PHY5 SRC-0
+        .gpio_mapped   = 0, 
+        .g2c_scl       = venus_gpio_id(MIS_GPIO, 63),
+        .g2c_sda       = venus_gpio_id(MIS_GPIO, 64),
+        .input_mux[0]  = {0},   
+        .input_mux[1]  = {0},                   
+#ifdef CONFIG_MACH_RTK1192
+		.pin_mux[0]    = {0xFE01A90C, 0xF<<8, 0x5<<8, 0},
+#else
+        .pin_mux[0]    = {0xFE00036c, 0xF<<8, 0x5<<8, 0},
+#endif
+        .pin_mux[1]    = {0},                
+    },    
+};                                    
+
+
+
+ 
+//////////////////////////////////////////////////////////////////////////////////////////
+// I2C 6
+//////////////////////////////////////////////////////////////////////////////////////////    
+static const venus_i2c_reg_map saturn_i2c6_reg = 
+{    
+    .I2C_ISR           = ISO_IO_PORT_BASE + MARS_ISO_ISR,
+    .I2C_INT           = MARS_ISO_ISR_I2C6,
+    .IC_CON            = ISO_IO_PORT_BASE + MARS_ISO_IC6_CON,
+    .IC_TAR            = ISO_IO_PORT_BASE + MARS_ISO_IC6_TAR,
+    .IC_SAR            = ISO_IO_PORT_BASE + MARS_ISO_IC6_SAR,
+    .IC_HS_MADDR       = ISO_IO_PORT_BASE + MARS_ISO_IC6_HS_MADDR,
+    .IC_DATA_CMD       = ISO_IO_PORT_BASE + MARS_ISO_IC6_DATA_CMD,
+    .IC_SS_SCL_HCNT    = ISO_IO_PORT_BASE + MARS_ISO_IC6_SS_SCL_HCNT,
+    .IC_SS_SCL_LCNT    = ISO_IO_PORT_BASE + MARS_ISO_IC6_SS_SCL_LCNT,
+    .IC_FS_SCL_HCNT    = ISO_IO_PORT_BASE + MARS_ISO_IC6_FS_SCL_HCNT,
+    .IC_FS_SCL_LCNT    = ISO_IO_PORT_BASE + MARS_ISO_IC6_FS_SCL_LCNT,
+    .IC_INTR_STAT      = ISO_IO_PORT_BASE + MARS_ISO_IC6_INTR_STAT,
+    .IC_INTR_MASK      = ISO_IO_PORT_BASE + MARS_ISO_IC6_INTR_MASK,
+    .IC_RAW_INTR_STAT  = ISO_IO_PORT_BASE + MARS_ISO_IC6_RAW_INTR_STAT,
+    .IC_RX_TL          = ISO_IO_PORT_BASE + MARS_ISO_IC6_RX_TL,
+    .IC_TX_TL          = ISO_IO_PORT_BASE + MARS_ISO_IC6_TX_TL,
+    .IC_CLR_INTR       = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_INTR,
+    .IC_CLR_RX_UNDER   = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_RX_UNDER,
+    .IC_CLR_RX_OVER    = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_RX_OVER,
+    .IC_CLR_TX_OVER    = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_TX_OVER,
+    .IC_CLR_RD_REQ     = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_RD_REQ,
+    .IC_CLR_TX_ABRT    = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_TX_ABRT,
+    .IC_CLR_RX_DONE    = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_RX_DONE,
+    .IC_CLR_ACTIVITY   = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_ACTIVITY,
+    .IC_CLR_STOP_DET   = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_STOP_DET,
+    .IC_CLR_START_DET  = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_START_DET,
+    .IC_CLR_GEN_CALL   = ISO_IO_PORT_BASE + MARS_ISO_IC6_CLR_GEN_CALL,
+    .IC_ENABLE         = ISO_IO_PORT_BASE + MARS_ISO_IC6_ENABLE,
+    .IC_STATUS         = ISO_IO_PORT_BASE + MARS_ISO_IC6_STATUS,
+    .IC_TXFLR          = ISO_IO_PORT_BASE + MARS_ISO_IC6_TXFLR,
+    .IC_RXFLR          = ISO_IO_PORT_BASE + MARS_ISO_IC6_RXFLR,
+    .IC_SDA_HOLD          = ISO_IO_PORT_BASE + 	MARS_ISO_IC6_SDA_HOLD,
+    .IC_TX_ABRT_SOURCE = ISO_IO_PORT_BASE + MARS_ISO_IC6_TX_ABRT_SOURCE,
+    .IC_SLV_DATA_NACK_ONLY          = ISO_IO_PORT_BASE + MARS_ISO_IC6_SLV_DATA_NACK_ONLY,
+    .IC_DMA_CR         = ISO_IO_PORT_BASE + MARS_ISO_IC6_DMA_CR,
+    .IC_DMA_TDLR       = ISO_IO_PORT_BASE + MARS_ISO_IC6_DMA_TDLR,
+    .IC_DMA_RDLR       = ISO_IO_PORT_BASE + MARS_ISO_IC6_DMA_RDLR,
+    .IC_SDA_SETUP          = ISO_IO_PORT_BASE + MARS_ISO_IC6_SDA_SETUP,
+    .IC_ACK_GENERAL_CALL          = ISO_IO_PORT_BASE + MARS_ISO_IC6_ACK_GENERAL_CALL,
+    .IC_ENABLE_STATUS          = ISO_IO_PORT_BASE + MARS_ISO_IC6_ENABLE_STATUS,
+    .IC_COMP_PARAM_1   = ISO_IO_PORT_BASE + MARS_ISO_IC6_COMP_PARAM_1,
+    .IC_COMP_VERSION   = ISO_IO_PORT_BASE + MARS_ISO_IC6_COMP_VERSION,
+    .IC_COMP_TYPE      = ISO_IO_PORT_BASE + MARS_ISO_IC6_COMP_TYPE,
+    .IC_SDA_DEL        = ISO_IO_PORT_BASE + SATURN_ISO_I2C6_SDA_DEL,          // for Saturn Only
+};  
+              
+static const venus_i2c_port saturn_i2c6_port[] = 
+{
+    {
+        // PHY5 SRC-0
+        .gpio_mapped   = 0, 
+        .g2c_scl       = venus_gpio_id(MIS_GPIO, 63),
+        .g2c_sda       = venus_gpio_id(MIS_GPIO, 64),
+        .input_mux[0]  = {0},   
+        .input_mux[1]  = {0},                   
+        .pin_mux[0]    = {0xFE007314, 0xF<<0, 0x5<<0, 0},
+        .pin_mux[1]    = {0},                
+    },    
+};                                    
+
+
+
+
+static venus_i2c_phy i2c_phy[] = 
+{    
+    { &saturn_i2c0_reg, sizeof(saturn_i2c0_port)/sizeof(venus_i2c_port), saturn_i2c0_port},
+    { &saturn_i2c1_reg, sizeof(saturn_i2c1_port)/sizeof(venus_i2c_port), saturn_i2c1_port},
+    { &saturn_i2c2_reg, sizeof(saturn_i2c2_port)/sizeof(venus_i2c_port), saturn_i2c2_port},
+    { &saturn_i2c3_reg, sizeof(saturn_i2c3_port)/sizeof(venus_i2c_port), saturn_i2c3_port},
+    { &saturn_i2c4_reg, sizeof(saturn_i2c4_port)/sizeof(venus_i2c_port), saturn_i2c4_port},
+    { &saturn_i2c5_reg, sizeof(saturn_i2c5_port)/sizeof(venus_i2c_port), saturn_i2c5_port},
+    { &saturn_i2c6_reg, sizeof(saturn_i2c6_port)/sizeof(venus_i2c_port), saturn_i2c6_port},
+};
+               
+
+#endif //__I2C_VENUS_CONFIG_SATURN_H__
diff --git a/drivers/i2c/busses/mars.h b/drivers/i2c/busses/mars.h
new file mode 100644
index 00000000..4f6bd13
--- /dev/null
+++ b/drivers/i2c/busses/mars.h
@@ -0,0 +1,674 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License.  See the file "COPYING" in the main directory of this archive
+ * for more details.
+ *
+ * Defines of the Mars cpu's specific address-MAP, registers, etc. Mars cpu
+ * inherits most of the defines of Venus cpu.
+ *
+ * Copyright (C) 2010 by Chien-An Lin <colin@realtek.com.tw>
+ */
+
+#ifndef _MACH_MARS_H
+#define _MACH_MARS_H
+
+//#include <asm/addrspace.h>
+#include "venus.h"
+
+#define ISO_IO_PORT_BASE		VENUS_ISO_IO_PORT_BASE  
+#define MISC_IO_PORT_BASE		VENUS_MISC_IO_PORT_BASE  
+
+/*-------------------------------------------------------------
+ * Mars CP
+ *-------------------------------------------------------------*/
+
+#define MARS_MCP_CTRL             0xb8015100
+    #define MCP_GO                (0x01<<1)
+    #define MCP_IDEL              (0x01<<2)
+    #define MCP_SWAP              (0x01<<3)
+    #define MCP_CLEAR             (0x01<<4)
+    #define MCP_CHK_SYS_HDR       (0x01<<5)     /* this bit has been removed from jupiter cpu */        
+    #define MCP_ARB_MODE(x)       ((x & 0x01)<<6)     /* for Jupiter only */        
+    #define MCP_OFB_1(x)          ((x & 0x01)<<7)     /* for Jupiter only */
+    #define MCP_OFB_2(x)          ((x & 0x01)<<8)     /* for Jupiter only */
+
+#define MARS_MCP_STATUS           0xb8015104          
+
+    #define MCP_WRITE_DATA        (0x01)
+    #define MCP_RING_EMPTY        (0x01 <<1)
+    #define MCP_ERROR             (0x01 <<2)
+    #define MCP_COMPARE           (0x01 <<3)
+    #define MCP_HDR_OTHER_PCAK    (0x01 <<4)    /* this bit has been removed from jupiter cpu */        
+    #define MCP_HDP_OTHER_PCAK    (0x01 <<5)    /* this bit has been removed from jupiter cpu */        
+    #define MCP_ACP_ERR           (0x01 <<6)    
+    #define MCP_SYS_HDR_ERR       (0x01 <<7)    /* this bit has been removed from jupiter cpu */                    
+    
+#define MARS_MCP_EN               0xb8015108
+#define MARS_MCP_BASE             0xb801510C
+#define MARS_MCP_LIMIT            0xb8015110
+#define MARS_MCP_RDPTR            0xb8015114
+#define MARS_MCP_WRPTR            0xb8015118
+#define MARS_MCP_AES_INI_KEY0     0xb8015124
+#define MARS_MCP_AES_INI_KEY1     0xb8015128
+#define MARS_MCP_AES_INI_KEY2     0xb801512C
+#define MARS_MCP_AES_INI_KEY3     0xb8015130
+#define MARS_MCP_DES_COUNT        0xb8015148
+#define MARS_MCP_DES_COMPARE      0xb8015138
+#define JUPITER_MCP_CTRL1         0xb8015198    /* for Jupiter only */
+    #define MCP_AES_PAD_OFF(x)    ((x & 0x1)<<10)
+    #define MCP_CSA_ENTROPY(x)    ((x & 0x3)<<8)
+        #define ORIGIONAL_MODE    0x0
+        #define CSA_MODE_1        0x1
+        #define CSA_MODE_2        0x2
+    #define MCP_ROUND_NO(x)       ((x & 0xFF))
+
+// Descriptor Definition
+#define MARS_MCP_MODE(x)     (x & 0x1F)   
+
+#define MCP_ALGO_DES         0x00
+#define MCP_ALGO_3DES        0x01
+#define MCP_ALGO_RC4         0x02
+#define MCP_ALGO_MD5         0x03
+#define MCP_ALGO_SHA_1       0x04
+#define MCP_ALGO_AES         0x05
+#define MCP_ALGO_AES_G       0x06
+#define MCP_ALGO_AES_H       0x07
+#define MCP_ALGO_CMAC        0x08
+
+#define MARS_MCP_BCM(x)     ((x & 0x3) << 6)  
+#define MCP_BCM_ECB          0x0
+#define MCP_BCM_CBC          0x1
+#define MCP_BCM_CTR          0x2
+
+#define MARS_MCP_ENC(x)     ((x & 0x1) << 5)  
+
+#define MARS_MCP_KEY_SEL(x) ((x & 0x1) << 12)  
+#define MCP_KEY_SEL_OTP      0x1
+#define MCP_KEY_SEL_DESC     0x0
+
+#define MARS_MCP_IV_SEL(x)  ((x & 0x1) << 11)  
+#define MCP_IV_SEL_REG      0x1
+#define MCP_IV_SEL_DESC     0x0
+
+/*-------------------------------------------------------------
+ * Mars CRT
+ *-------------------------------------------------------------*/
+#define MARS_CRT_BASE			0xB8000000
+#define MARS_CRT_PCICK_SEL		0x0338
+
+
+/*-------------------------------------------------------------
+ * Mars MISC 
+ *-------------------------------------------------------------*/
+
+#define MARS_MIS_BASE			0xB8010000
+
+#define MARS_MIS_ISR			VENUS_MIS_ISR
+#define MARS_PCMCIA_INT			(0x00000001 <<21)
+#define MARS_MIS_ISR_CEC_TX    	(0x00000001 <<22)
+#define MARS_MIS_ISR_CEC_RX   	(0x00000001 <<23)
+#define MARS_MIS_ISR_I2C1     	(0x00000001 <<4)
+#define MARS_MIS_ISR_I2C2     	(0x00000001 <<26)
+#define MARS_MIS_ISR_I2C3     	(0x00000001 <<23)
+#define MARS_MIS_ISR_I2C4     	(0x00000001 <<15)
+#define MARS_MIS_ISR_I2C5     	(0x00000001 <<14)
+
+
+
+#define MARS_ISO_ISR			VENUS_ISO_ISR
+#define MARS_ISO_ISR_I2C0     	(0x00000001 <<8)
+#define MARS_ISO_ISR_I2C6     	(0x00000001 <<10)
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+#define MARS_0_SYS_MUXPAD0		0xB8000350
+
+  #define I2C0_LOC_MASK              (0x00000003 << 18)
+  #define I2C0_LOC_QFPA_BGA          (0x00000000)
+  #define I2C0_LOC_QFPB              (0x00000001 << 18)    
+  #define I2C1_LOC_MASK              (0x00000003 << 20)
+  #define I2C1_LOC_MUX_PCI           (0x00000000)
+  #define I2C1_LOC_MUX_UR0           (0x00000001 << 18)  
+  
+#define MARS_0_SYS_MUXPAD1		0xB8000354
+#define MARS_0_SYS_MUXPAD2		0xB8000358
+#define MARS_0_SYS_MUXPAD3		0xB800035C
+  
+  #define I2C0_MASK                  (0x00000003 << 4)
+  #define I2C0_SDA_SCL               (0x00000000)
+  #define I2C0_GP4_GP5               (0x00000001 << 4)    
+  #define I2C1_MASK                  (0x00000003)
+  #define I2C1_SDA_SCL               (0x00000002)
+  #define I2C1_GP0_GP1               (0x00000001)  
+  #define I2C1_UART1                 (0x00000000)  
+  
+#define MARS_0_SYS_MUXPAD4		0xB8000360
+#define MARS_0_SYS_MUXPAD5		0xB8000364
+
+  #define PCI_MUX1_MASK              (0x00000003<<2)
+  #define PCI_MUX1_PCI               (0x00000000<<2)
+  #define PCI_MUX1_GPIO              (0x00000001<<2)
+  #define PCI_MUX1_I2C1              (0x00000002<<2)
+  
+#define MARS_0_SYS_MUXPAD6		0xB8000368
+#define MARS_0_SYS_MUXPAD7		0xB800036C
+
+  
+
+/*
+ * Mars GPIO registers.
+ */
+#define MARS_MIS_GP0DIR			0x1B100
+#define MARS_MIS_GP1DIR			0x1B104
+#define MARS_MIS_GP2DIR			0x1B108
+#define MARS_MIS_GP3DIR			0x1B10C
+#define MARS_MIS_GP0DATO		0x1B110
+#define MARS_MIS_GP1DATO		0x1B114
+#define MARS_MIS_GP2DATO		0x1B118
+#define MARS_MIS_GP3DATO		0x1B11C
+#define MARS_MIS_GP0DATI		0x1B120
+#define MARS_MIS_GP1DATI		0x1B124
+#define MARS_MIS_GP2DATI		0x1B128
+#define MARS_MIS_GP3DATI		0x1B12C
+#define MARS_MIS_GP0IE			0x1B130
+#define MARS_MIS_GP1IE			0x1B134
+#define MARS_MIS_GP2IE			0x1B138
+#define MARS_MIS_GP3IE			0x1B13C
+#define MARS_MIS_GP0DP			0x1B140
+#define MARS_MIS_GP1DP			0x1B144
+#define MARS_MIS_GP2DP			0x1B148
+#define MARS_MIS_GP3DP			0x1B14C
+#define MARS_MIS_GPDEB			0x1B150
+
+/*-------------------------------------------------------------
+ * Mars MISC UART register
+ *-------------------------------------------------------------*/
+#define MARS_MIS_U0RBR_THR_DLL		0x1B200
+
+/*-------------------------------------------------------------
+ * Mars MISC CEC register
+ *-------------------------------------------------------------*/                                                              
+#define MARS_MIS_CEC_CR0        0x1B900                       
+#define MARS_MIS_CEC_CR1        0x1B904                       
+#define MARS_MIS_CEC_CR2        0x1B908                       
+#define MARS_MIS_CEC_CR3        0x1B90C                       
+#define MARS_MIS_CEC_RT0        0x1B910                       
+#define MARS_MIS_CEC_RT1        0x1B914                       
+#define MARS_MIS_CEC_RX0        0x1B918                       
+#define MARS_MIS_CEC_RX1        0x1B91C                       
+#define MARS_MIS_CEC_TX0        0x1B920                       
+#define MARS_MIS_CEC_TX1        0x1B924                       
+#define MARS_MIS_CEC_TX_FIFO    0x1B928                       
+#define MARS_MIS_CEC_RX_FIFO    0x1B92C                       
+#define MARS_MIS_CEC_RX_START0  0x1B930                       
+#define MARS_MIS_CEC_RX_START1  0x1B934                       
+#define MARS_MIS_CEC_RX_DATA0   0x1B938                       
+#define MARS_MIS_CEC_RX_DATA1   0x1B93C                       
+#define MARS_MIS_CEC_TX_START0  0x1B940                       
+#define MARS_MIS_CEC_TX_START1  0x1B944                       
+#define MARS_MIS_CEC_TX_DATA0   0x1B948                       
+#define MARS_MIS_CEC_TX_DATA1   0x1B94C                       
+#define MARS_MIS_CEC_TX_DATA2   0x1B950                       
+ 
+ 
+/*-------------------------------------------------------------
+ * Mars MISC I2C register
+ *-------------------------------------------------------------*/  
+ 
+// I2C
+#define MARS_ISO_IC0_CON                 0x7d00
+#define MARS_ISO_IC0_TAR                 0x7d04
+#define MARS_ISO_IC0_SAR                 0x7d08
+#define MARS_ISO_IC0_HS_MADDR            0x7d0c
+#define MARS_ISO_IC0_DATA_CMD            0x7d10
+#define MARS_ISO_IC0_SS_SCL_HCNT         0x7d14
+#define MARS_ISO_IC0_SS_SCL_LCNT         0x7d18
+#define MARS_ISO_IC0_FS_SCL_HCNT         0x7d1c
+#define MARS_ISO_IC0_FS_SCL_LCNT         0x7d20
+#define MARS_ISO_IC0_INTR_STAT           0x7d2c
+#define MARS_ISO_IC0_INTR_MASK           0x7d30
+#define MARS_ISO_IC0_RAW_INTR_STAT       0x7d34
+#define MARS_ISO_IC0_RX_TL               0x7d38
+#define MARS_ISO_IC0_TX_TL               0x7d3c
+#define MARS_ISO_IC0_CLR_INTR            0x7d40
+#define MARS_ISO_IC0_CLR_RX_UNDER        0x7d44
+#define MARS_ISO_IC0_CLR_RX_OVER         0x7d48
+#define MARS_ISO_IC0_CLR_TX_OVER         0x7d4c
+#define MARS_ISO_IC0_CLR_RD_REQ          0x7d50
+#define MARS_ISO_IC0_CLR_TX_ABRT         0x7d54
+#define MARS_ISO_IC0_CLR_RX_DONE         0x7d58
+#define MARS_ISO_IC0_CLR_ACTIVITY        0x7d5c
+#define MARS_ISO_IC0_CLR_STOP_DET        0x7d60
+#define MARS_ISO_IC0_CLR_START_DET       0x7d64
+#define MARS_ISO_IC0_CLR_GEN_CALL        0x7d68
+#define MARS_ISO_IC0_ENABLE              0x7d6c
+#define MARS_ISO_IC0_STATUS              0x7d70
+#define MARS_ISO_IC0_TXFLR               0x7d74
+#define MARS_ISO_IC0_RXFLR               0x7d78
+#define MARS_ISO_IC0_SDA_HOLD               0x7d7c
+#define MARS_ISO_IC0_TX_ABRT_SOURCE      0x7d80
+#define MARS_ISO_IC0_SLV_DATA_NACK_ONLY     0x7d84
+#define MARS_ISO_IC0_DMA_CR              0x7d88
+#define MARS_ISO_IC0_DMA_TDLR            0x7d8c
+#define MARS_ISO_IC0_DMA_RDLR            0x7d90
+#define MARS_ISO_IC0_SDA_SETUP            0x7d94
+#define MARS_ISO_IC0_ACK_GENERAL_CALL            0x7d98
+#define MARS_ISO_IC0_ENABLE_STATUS            0x7d9c
+#define MARS_ISO_IC0_COMP_PARAM_1        0x7df4
+#define MARS_ISO_IC0_COMP_VERSION        0x7df8
+#define MARS_ISO_IC0_COMP_TYPE           0x7dfc
+
+
+#define MARS_MIS_IC1_CON                 0x1b300
+#define MARS_MIS_IC1_TAR                 0x1b304
+#define MARS_MIS_IC1_SAR                 0x1b308
+#define MARS_MIS_IC1_HS_MADDR            0x1b30c
+#define MARS_MIS_IC1_DATA_CMD            0x1b310
+#define MARS_MIS_IC1_SS_SCL_HCNT         0x1b314
+#define MARS_MIS_IC1_SS_SCL_LCNT         0x1b318
+#define MARS_MIS_IC1_FS_SCL_HCNT         0x1b31c
+#define MARS_MIS_IC1_FS_SCL_LCNT         0x1b320
+#define MARS_MIS_IC1_INTR_STAT           0x1b32c
+#define MARS_MIS_IC1_INTR_MASK           0x1b330
+#define MARS_MIS_IC1_RAW_INTR_STAT       0x1b334
+#define MARS_MIS_IC1_RX_TL               0x1b338
+#define MARS_MIS_IC1_TX_TL               0x1b33c
+#define MARS_MIS_IC1_CLR_INTR            0x1b340
+#define MARS_MIS_IC1_CLR_RX_UNDER        0x1b344
+#define MARS_MIS_IC1_CLR_RX_OVER         0x1b348
+#define MARS_MIS_IC1_CLR_TX_OVER         0x1b34c
+#define MARS_MIS_IC1_CLR_RD_REQ          0x1b350
+#define MARS_MIS_IC1_CLR_TX_ABRT         0x1b354
+#define MARS_MIS_IC1_CLR_RX_DONE         0x1b358
+#define MARS_MIS_IC1_CLR_ACTIVITY        0x1b35c
+#define MARS_MIS_IC1_CLR_STOP_DET        0x1b360
+#define MARS_MIS_IC1_CLR_START_DET       0x1b364
+#define MARS_MIS_IC1_CLR_GEN_CALL        0x1b368
+#define MARS_MIS_IC1_ENABLE              0x1b36c
+#define MARS_MIS_IC1_STATUS              0x1b370
+#define MARS_MIS_IC1_TXFLR               0x1b374
+#define MARS_MIS_IC1_RXFLR               0x1b378
+#define MARS_MIS_IC1_SDA_HOLD               0x1b37c
+#define MARS_MIS_IC1_TX_ABRT_SOURCE      0x1b380
+#define MARS_MIS_IC1_SLV_DATA_NACK_ONLY     0x1b384
+#define MARS_MIS_IC1_DMA_CR              0x1b388
+#define MARS_MIS_IC1_DMA_TDLR            0x1b38c
+#define MARS_MIS_IC1_DMA_RDLR            0x1b390
+#define MARS_MIS_IC1_SDA_SETUP            0x1b394
+#define MARS_MIS_IC1_ACK_GENERAL_CALL            0x1b398
+#define MARS_MIS_IC1_ENABLE_STATUS            0x1b39c
+#define MARS_MIS_IC1_COMP_PARAM_1        0x1b3f4
+#define MARS_MIS_IC1_COMP_VERSION        0x1b3f8
+#define MARS_MIS_IC1_COMP_TYPE           0x1b3fc
+
+#define MARS_MIS_IC2_CON                 0x1b700
+#define MARS_MIS_IC2_TAR                 0x1b704
+#define MARS_MIS_IC2_SAR                 0x1b708
+#define MARS_MIS_IC2_HS_MADDR            0x1b70c
+#define MARS_MIS_IC2_DATA_CMD            0x1b710
+#define MARS_MIS_IC2_SS_SCL_HCNT         0x1b714
+#define MARS_MIS_IC2_SS_SCL_LCNT         0x1b718
+#define MARS_MIS_IC2_FS_SCL_HCNT         0x1b71c
+#define MARS_MIS_IC2_FS_SCL_LCNT         0x1b720
+#define MARS_MIS_IC2_INTR_STAT           0x1b72c
+#define MARS_MIS_IC2_INTR_MASK           0x1b730
+#define MARS_MIS_IC2_RAW_INTR_STAT       0x1b734
+#define MARS_MIS_IC2_RX_TL               0x1b738
+#define MARS_MIS_IC2_TX_TL               0x1b73c
+#define MARS_MIS_IC2_CLR_INTR            0x1b740
+#define MARS_MIS_IC2_CLR_RX_UNDER        0x1b744
+#define MARS_MIS_IC2_CLR_RX_OVER         0x1b748
+#define MARS_MIS_IC2_CLR_TX_OVER         0x1b74c
+#define MARS_MIS_IC2_CLR_RD_REQ          0x1b750
+#define MARS_MIS_IC2_CLR_TX_ABRT         0x1b754
+#define MARS_MIS_IC2_CLR_RX_DONE         0x1b758
+#define MARS_MIS_IC2_CLR_ACTIVITY        0x1b75c
+#define MARS_MIS_IC2_CLR_STOP_DET        0x1b760
+#define MARS_MIS_IC2_CLR_START_DET       0x1b764
+#define MARS_MIS_IC2_CLR_GEN_CALL        0x1b768
+#define MARS_MIS_IC2_ENABLE              0x1b76c
+#define MARS_MIS_IC2_STATUS              0x1b770
+#define MARS_MIS_IC2_TXFLR               0x1b774
+#define MARS_MIS_IC2_RXFLR               0x1b778
+#define MARS_MIS_IC2_SDA_HOLD               0x1b77c
+#define MARS_MIS_IC2_TX_ABRT_SOURCE      0x1b780
+#define MARS_MIS_IC2_SLV_DATA_NACK_ONLY     0x1b784
+#define MARS_MIS_IC2_DMA_CR              0x1b788
+#define MARS_MIS_IC2_DMA_TDLR            0x1b78c
+#define MARS_MIS_IC2_DMA_RDLR            0x1b790
+#define MARS_MIS_IC2_SDA_SETUP            0x1b794
+#define MARS_MIS_IC2_ACK_GENERAL_CALL            0x1b798
+#define MARS_MIS_IC2_ENABLE_STATUS            0x1b79c
+#define MARS_MIS_IC2_COMP_PARAM_1        0x1b7f4
+#define MARS_MIS_IC2_COMP_VERSION        0x1b7f8
+#define MARS_MIS_IC2_COMP_TYPE           0x1b7fc
+
+#define MARS_MIS_IC3_CON                 0x1b900
+#define MARS_MIS_IC3_TAR                 0x1b904
+#define MARS_MIS_IC3_SAR                 0x1b908
+#define MARS_MIS_IC3_HS_MADDR            0x1b90c
+#define MARS_MIS_IC3_DATA_CMD            0x1b910
+#define MARS_MIS_IC3_SS_SCL_HCNT         0x1b914
+#define MARS_MIS_IC3_SS_SCL_LCNT         0x1b918
+#define MARS_MIS_IC3_FS_SCL_HCNT         0x1b91c
+#define MARS_MIS_IC3_FS_SCL_LCNT         0x1b920
+#define MARS_MIS_IC3_INTR_STAT           0x1b92c
+#define MARS_MIS_IC3_INTR_MASK           0x1b930
+#define MARS_MIS_IC3_RAW_INTR_STAT       0x1b934
+#define MARS_MIS_IC3_RX_TL               0x1b938
+#define MARS_MIS_IC3_TX_TL               0x1b93c
+#define MARS_MIS_IC3_CLR_INTR            0x1b940
+#define MARS_MIS_IC3_CLR_RX_UNDER        0x1b944
+#define MARS_MIS_IC3_CLR_RX_OVER         0x1b948
+#define MARS_MIS_IC3_CLR_TX_OVER         0x1b94c
+#define MARS_MIS_IC3_CLR_RD_REQ          0x1b950
+#define MARS_MIS_IC3_CLR_TX_ABRT         0x1b954
+#define MARS_MIS_IC3_CLR_RX_DONE         0x1b958
+#define MARS_MIS_IC3_CLR_ACTIVITY        0x1b95c
+#define MARS_MIS_IC3_CLR_STOP_DET        0x1b960
+#define MARS_MIS_IC3_CLR_START_DET       0x1b964
+#define MARS_MIS_IC3_CLR_GEN_CALL        0x1b968
+#define MARS_MIS_IC3_ENABLE              0x1b96c
+#define MARS_MIS_IC3_STATUS              0x1b970
+#define MARS_MIS_IC3_TXFLR               0x1b974
+#define MARS_MIS_IC3_RXFLR               0x1b978
+#define MARS_MIS_IC3_SDA_HOLD               0x1b97c
+#define MARS_MIS_IC3_TX_ABRT_SOURCE      0x1b980
+#define MARS_MIS_IC3_SLV_DATA_NACK_ONLY     0x1b984
+#define MARS_MIS_IC3_DMA_CR              0x1b988
+#define MARS_MIS_IC3_DMA_TDLR            0x1b98c
+#define MARS_MIS_IC3_DMA_RDLR            0x1b990
+#define MARS_MIS_IC3_SDA_SETUP            0x1b994
+#define MARS_MIS_IC3_ACK_GENERAL_CALL            0x1b998
+#define MARS_MIS_IC3_ENABLE_STATUS            0x1b99c
+#define MARS_MIS_IC3_COMP_PARAM_1        0x1b9f4
+#define MARS_MIS_IC3_COMP_VERSION        0x1b9f8
+#define MARS_MIS_IC3_COMP_TYPE           0x1b9fc
+
+#define MARS_MIS_IC4_CON                 0x1ba00
+#define MARS_MIS_IC4_TAR                 0x1ba04
+#define MARS_MIS_IC4_SAR                 0x1ba08
+#define MARS_MIS_IC4_HS_MADDR            0x1ba0c
+#define MARS_MIS_IC4_DATA_CMD            0x1ba10
+#define MARS_MIS_IC4_SS_SCL_HCNT         0x1ba14
+#define MARS_MIS_IC4_SS_SCL_LCNT         0x1ba18
+#define MARS_MIS_IC4_FS_SCL_HCNT         0x1ba1c
+#define MARS_MIS_IC4_FS_SCL_LCNT         0x1ba20
+#define MARS_MIS_IC4_INTR_STAT           0x1ba2c
+#define MARS_MIS_IC4_INTR_MASK           0x1ba30
+#define MARS_MIS_IC4_RAW_INTR_STAT       0x1ba34
+#define MARS_MIS_IC4_RX_TL               0x1ba38
+#define MARS_MIS_IC4_TX_TL               0x1ba3c
+#define MARS_MIS_IC4_CLR_INTR            0x1ba40
+#define MARS_MIS_IC4_CLR_RX_UNDER        0x1ba44
+#define MARS_MIS_IC4_CLR_RX_OVER         0x1ba48
+#define MARS_MIS_IC4_CLR_TX_OVER         0x1ba4c
+#define MARS_MIS_IC4_CLR_RD_REQ          0x1ba50
+#define MARS_MIS_IC4_CLR_TX_ABRT         0x1ba54
+#define MARS_MIS_IC4_CLR_RX_DONE         0x1ba58
+#define MARS_MIS_IC4_CLR_ACTIVITY        0x1ba5c
+#define MARS_MIS_IC4_CLR_STOP_DET        0x1ba60
+#define MARS_MIS_IC4_CLR_START_DET       0x1ba64
+#define MARS_MIS_IC4_CLR_GEN_CALL        0x1ba68
+#define MARS_MIS_IC4_ENABLE              0x1ba6c
+#define MARS_MIS_IC4_STATUS              0x1ba70
+#define MARS_MIS_IC4_TXFLR               0x1ba74
+#define MARS_MIS_IC4_RXFLR               0x1ba78
+#define MARS_MIS_IC4_SDA_HOLD               0x1ba7c
+#define MARS_MIS_IC4_TX_ABRT_SOURCE      0x1ba80
+#define MARS_MIS_IC4_SLV_DATA_NACK_ONLY     0x1ba84
+#define MARS_MIS_IC4_DMA_CR              0x1ba88
+#define MARS_MIS_IC4_DMA_TDLR            0x1ba8c
+#define MARS_MIS_IC4_DMA_RDLR            0x1ba90
+#define MARS_MIS_IC4_SDA_SETUP            0x1ba94
+#define MARS_MIS_IC4_ACK_GENERAL_CALL            0x1ba98
+#define MARS_MIS_IC4_ENABLE_STATUS            0x1ba9c
+#define MARS_MIS_IC4_COMP_PARAM_1        0x1baf4
+#define MARS_MIS_IC4_COMP_VERSION        0x1baf8
+#define MARS_MIS_IC4_COMP_TYPE           0x1bafc
+
+#define MARS_MIS_IC5_CON                0x1bb00
+#define MARS_MIS_IC5_TAR                0x1bb04
+#define MARS_MIS_IC5_SAR                0x1bb08
+#define MARS_MIS_IC5_HS_MADDR           0x1bb0c
+#define MARS_MIS_IC5_DATA_CMD           0x1bb10
+#define MARS_MIS_IC5_SS_SCL_HCNT        0x1bb14
+#define MARS_MIS_IC5_SS_SCL_LCNT        0x1bb18
+#define MARS_MIS_IC5_FS_SCL_HCNT        0x1bb1c
+#define MARS_MIS_IC5_FS_SCL_LCNT        0x1bb20
+#define MARS_MIS_IC5_INTR_STAT          0x1bb2c
+#define MARS_MIS_IC5_INTR_MASK          0x1bb30
+#define MARS_MIS_IC5_RAW_INTR_STAT      0x1bb34
+#define MARS_MIS_IC5_RX_TL              0x1bb38
+#define MARS_MIS_IC5_TX_TL              0x1bb3c
+#define MARS_MIS_IC5_CLR_INTR           0x1bb40
+#define MARS_MIS_IC5_CLR_RX_UNDER       0x1bb44
+#define MARS_MIS_IC5_CLR_RX_OVER        0x1bb48
+#define MARS_MIS_IC5_CLR_TX_OVER        0x1bb4c
+#define MARS_MIS_IC5_CLR_RD_REQ         0x1bb50
+#define MARS_MIS_IC5_CLR_TX_ABRT        0x1bb54
+#define MARS_MIS_IC5_CLR_RX_DONE        0x1bb58
+#define MARS_MIS_IC5_CLR_ACTIVITY       0x1bb5c
+#define MARS_MIS_IC5_CLR_STOP_DET       0x1bb60
+#define MARS_MIS_IC5_CLR_START_DET      0x1bb64
+#define MARS_MIS_IC5_CLR_GEN_CALL       0x1bb68
+#define MARS_MIS_IC5_ENABLE             0x1bb6c
+#define MARS_MIS_IC5_STATUS             0x1bb70
+#define MARS_MIS_IC5_TXFLR              0x1bb74
+#define MARS_MIS_IC5_RXFLR              0x1bb78
+#define MARS_MIS_IC5_SDA_HOLD               0x1bb7c
+#define MARS_MIS_IC5_TX_ABRT_SOURCE     0x1bb80
+#define MARS_MIS_IC5_SLV_DATA_NACK_ONLY     0x1bb84
+#define MARS_MIS_IC5_DMA_CR             0x1bb88
+#define MARS_MIS_IC5_DMA_TDLR           0x1bb8c
+#define MARS_MIS_IC5_DMA_RDLR           0x1bb90
+#define MARS_MIS_IC5_SDA_SETUP            0x1bb94
+#define MARS_MIS_IC5_ACK_GENERAL_CALL            0x1bb98
+#define MARS_MIS_IC5_ENABLE_STATUS            0x1bb9c
+#define MARS_MIS_IC5_COMP_PARAM_1       0x1bbf4
+#define MARS_MIS_IC5_COMP_VERSION       0x1bbf8
+#define MARS_MIS_IC5_COMP_TYPE          0x1bbfc
+ 
+#define MARS_ISO_IC6_CON                			0x7e00
+#define MARS_ISO_IC6_TAR                			0x7e04
+#define MARS_ISO_IC6_SAR               			0x7e08
+#define MARS_ISO_IC6_HS_MADDR           		0x7e0c
+#define MARS_ISO_IC6_DATA_CMD           		0x7e10
+#define MARS_ISO_IC6_SS_SCL_HCNT        		0x7e14
+#define MARS_ISO_IC6_SS_SCL_LCNT        		0x7e18
+#define MARS_ISO_IC6_FS_SCL_HCNT        		0x7e1c
+#define MARS_ISO_IC6_FS_SCL_LCNT        		0x7e20
+#define MARS_ISO_IC6_INTR_STAT          		0x7e2c
+#define MARS_ISO_IC6_INTR_MASK          		0x7e30
+#define MARS_ISO_IC6_RAW_INTR_STAT   		0x7e34
+#define MARS_ISO_IC6_RX_TL              			0x7e38
+#define MARS_ISO_IC6_TX_TL              			0x7e3c
+#define MARS_ISO_IC6_CLR_INTR           		0x7e40
+#define MARS_ISO_IC6_CLR_RX_UNDER       		0x7e44
+#define MARS_ISO_IC6_CLR_RX_OVER        		0x7e48
+#define MARS_ISO_IC6_CLR_TX_OVER        		0x7e4c
+#define MARS_ISO_IC6_CLR_RD_REQ         		0x7e50
+#define MARS_ISO_IC6_CLR_TX_ABRT        		0x7e54
+#define MARS_ISO_IC6_CLR_RX_DONE        		0x7e58
+#define MARS_ISO_IC6_CLR_ACTIVITY       		0x7e5c
+#define MARS_ISO_IC6_CLR_STOP_DET       		0x7e60
+#define MARS_ISO_IC6_CLR_START_DET   		0x7e64
+#define MARS_ISO_IC6_CLR_GEN_CALL       		0x7e68
+#define MARS_ISO_IC6_ENABLE             		0x7e6c
+#define MARS_ISO_IC6_STATUS             		0x7e70
+#define MARS_ISO_IC6_TXFLR              			0x7e74
+#define MARS_ISO_IC6_RXFLR             	 		0x7e78
+#define MARS_ISO_IC6_SDA_HOLD           		0x7e7c
+#define MARS_ISO_IC6_TX_ABRT_SOURCE  		0x7e80
+#define MARS_ISO_IC6_SLV_DATA_NACK_ONLY	0x7e84
+#define MARS_ISO_IC6_DMA_CR             		0x7e88
+#define MARS_ISO_IC6_DMA_TDLR           		0x7e8c
+#define MARS_ISO_IC6_DMA_RDLR           		0x7e90
+#define MARS_ISO_IC6_SDA_SETUP            		0x7e94
+#define MARS_ISO_IC6_ACK_GENERAL_CALL    	0x7e98
+#define MARS_ISO_IC6_ENABLE_STATUS   		0x7e9c
+#define MARS_ISO_IC6_COMP_PARAM_1      	0x7ef4
+#define MARS_ISO_IC6_COMP_VERSION       	0x7ef8
+#define MARS_ISO_IC6_COMP_TYPE          		0x7efc
+ 
+ 
+ 
+//IC_CON
+#define IC_SLAVE_DISABLE    0x0040
+#define IC_RESTART_EN       0x0020                  
+#define IC_10BITADDR_MASTER 0x0010                  
+#define IC_10BITADDR_SLAVE  0x0008                  
+#define IC_MASTER_MODE      0x0001                  
+                  
+#define IC_SPEED            0x0006
+#define SPEED_SS            0x0002
+#define SPEED_FS            0x0004
+#define SPEED_HS            0x0006
+
+//ID_DATA
+#define READ_CMD            0x0100
+
+// INT
+#define GEN_CALL_BIT        0x800
+#define START_DET_BIT       0x400
+#define STOP_DET_BIT        0x200
+#define ACTIVITY_BIT        0x100
+#define RX_DONE_BIT         0x080
+#define TX_ABRT_BIT         0x040
+#define RD_REQ_BIT          0x020
+#define TX_EMPTY_BIT        0x010
+#define TX_OVER_BIT         0x008
+#define RX_FULL_BIT         0x004
+#define RX_OVER_BIT         0x002
+#define RX_UNDER_BIT        0x001
+
+// STATUS
+#define ST_RFF_BIT          0x10
+#define ST_RFNE_BIT         0x08
+#define ST_TFE_BIT          0x04
+#define ST_TFNF_BIT         0x02
+#define ST_ACTIVITY_BIT     0x01     
+
+
+// IC_TX_ABRT_SOURCE
+#define ABRT_SLVRD_INTX             0x8000
+#define ABRT_SLV_ARB_LOST           0x4000
+#define ABRT_SLV_FLUSH_TX_FIFO      0x2000
+#define ABRT_ARB_LOST               0x1000
+#define ABR_MASTER_DIS              0x0800   
+#define ABRT_10B_RD_NORSTRT         0x0400
+#define ABRT_SBYTE_NORSTRT          0x0200
+#define ABRT_HS_NORSTRT             0x0100
+#define ABRT_SBYTE_ACKDET           0x0080
+#define ABRT_HS_ACKDET              0x0040
+#define ABRT_GCALL_READ             0x0020
+#define ABRT_GCALL_NOACK            0x0010
+#define ABRT_TXDATA_NOACK           0x0008
+#define ABRT_10ADDR2_NOACK          0x0004
+#define ABRT_10ADDR1_NOACK          0x0002
+#define ABRT_7ADDR_NOACK            0x0001
+ 
+/*-------------------------------------------------------------
+ * Mars MISC PCMCIA register
+ *-------------------------------------------------------------*/
+#define MARS_PCMCIA_CMDFF		0x1B800
+#define MARS_PCMCIA_CTRL		0x1B804
+#define MARS_PCMCIA_STS			0x1B808
+#define MARS_PCMCIA_AMTC		0x1B80C
+#define MARS_PCMCIA_IOMTC		0x1B810
+#define MARS_PCMCIA_MATC		0x1B814
+#define MARS_PCMCIA_ACTRL		0x1B818
+
+
+//-- MARS_PCMCIA_CMDFF
+#define PC_CT(x)			(((x) & 0x01)<< 24)
+#define PC_CT_READ			PC_CT(0)
+#define PC_CT_WRITE			PC_CT(1)
+#define PC_AT(x)			(((x) & 0x01)<< 23)
+#define PC_AT_IO			PC_AT(0)
+#define PC_AT_ATTRMEM			PC_AT(1)
+#define PC_PA(x)			(((x) & 0x7FFF) << 8)
+#define PC_DF(x)			(((x) & 0xFF))
+
+//-- MARS_PCMCIA_CTRL
+#define PC_PSR				(0x00000001 << 31)
+#define PC_CE1_CARD1			(0x00000001 << 30)
+#define PC_CE1_CARD2			(0x00000001 << 29)
+#define PC_CE2_CARD1			(0x00000001 << 28)
+#define PC_CE2_CARD2			(0x00000001 << 27)
+#define PC_PCR1				(0x00000001 << 26)
+#define PC_PCR2				(0x00000001 << 25)
+#define PC_PCR1_OE			(0x00000001 << 24)
+#define PC_PCR2_OE			(0x00000001 << 23)
+#define PC_PIIE1			(0x00000001 << 7)
+#define PC_PCIIE1			(0x00000001 << 6)
+#define PC_PCRIE1			(0x00000001 << 5)
+#define PC_PIIE2			(0x00000001 << 4)
+#define PC_PCIIE2			(0x00000001 << 3)
+#define PC_PCRIE2			(0x00000001 << 2)
+#define PC_AFIE				(0x00000001 << 1)
+#define PC_APFIE			(0x00000001)
+
+//-- MARS_PCMCIA_STS
+#define PC_PRES1			(0x00000001 << 9)
+#define PC_PRES2			(0x00000001 << 8)
+#define PC_PII1				(0x00000001 << 7)
+#define PC_PCII1			(0x00000001 << 6)
+#define PC_PCRI1			(0x00000001 << 5)
+#define PC_PII2				(0x00000001 << 4)
+#define PC_PCII2			(0x00000001 << 3)
+#define PC_PCRI2			(0x00000001 << 2)
+#define PC_AFI				(0x00000001 << 1)
+#define PC_APFI				(0x00000001)
+
+//-- MARS_PCMCIA_AMTC
+#define PC_TWE(x)			(((x) & 0x3F) << 26)
+#define PC_THD(x)			(((x) & 0x0F) << 22)
+#define PC_TAOE(x)			(((x) & 0x1F) << 17)
+#define PC_THCE(x)			(((x) & 0x1F) << 8)
+#define PC_TSU(x)			(((x) & 0x1F))
+
+//-- MARS_PCMCIA_IOMTC
+#define PC_TDIORD(x)			(((x) & 0x1F) << 16)
+#define PC_TSUIO(x)			(((x) & 0x0F) << 8)
+#define PC_TDINPACK(x)			(((x) & 0x0F) << 4)
+#define PC_TDWT(x)			(((x) & 0x0F))
+
+//-- MARS_PCMCIA_MATC
+#define PC_TC(x)			(((x) & 0xFF) << 24)
+#define PC_THDIO(x)			(((x) & 0x0F) << 20)
+#define PC_TCIO(x)			(((x) & 0xFF) << 8)
+#define PC_TWIOWR(x)			(((x) & 0x3F))
+
+//-- MARS_PCMCIA_MATC
+#define PC_OE(x)			(((x) & 0x7FFF))
+
+
+// USB Host Registers
+//#define VENUS_USB_HOST_BASE			(VENUS_USB_BASE+0x800)
+#define MARS_USB_HOST_VERSION			(VENUS_USB_HOST_BASE+0x14)
+#define MARS_USB_HOST_WRAPP_2PORT		(VENUS_USB_HOST_BASE+0x20)
+#define MARS_USB_HOST_VSTATUS_2PORT		(VENUS_USB_HOST_BASE+0x24)
+#define MARS_USB_HOST_USBIPINPUT_2PORT		(VENUS_USB_HOST_BASE+0x28)
+#define MARS_USB_HOST_RESET_UTMI_2PORT		(VENUS_USB_HOST_BASE+0x2C)
+#define MARS_USB_HOST_SELF_LOOP_BACK_2PORT	(VENUS_USB_HOST_BASE+0x30)
+#define MARS_USB_HOST_IPNEWINPUT_2PORT		(VENUS_USB_HOST_BASE+0x34)
+#define MARS_USB_HOST_USBPHY_SLB0		(VENUS_USB_HOST_BASE+0x38)
+#define MARS_USB_HOST_USBPHY_SLB1		(VENUS_USB_HOST_BASE+0x3C)
+#define MARS_USB_HOST_OTG			(VENUS_USB_HOST_BASE+0x40)
+#define MARS_USB_HOST_OTGMUX			(VENUS_USB_HOST_BASE+0x44)
+
+#endif /* !(_MACH_MARS_H) */
+
diff --git a/drivers/i2c/busses/platform.h b/drivers/i2c/busses/platform.h
new file mode 100644
index 00000000..0849bff
--- /dev/null
+++ b/drivers/i2c/busses/platform.h
@@ -0,0 +1,318 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License.  See the file "COPYING" in the main directory of this archive
+ * for more details.
+ *
+ * This file contains platform-related defines for Realtek boards.
+ *
+ * Copyright (C) 2010 by Chien-An Lin <colin@realtek.com.tw>
+ */
+
+
+#ifndef _MACH_PLATFORM_H
+#define _MACH_PLATFORM_H
+
+#define AES_CCMP_LEN		571
+#define SYSTEM_PARAMETERS_LEN	960 // 1~6
+#define MODEL_CONFIG_LEN	64	// Originally this value is 20 for libra 10bytes config and now we support 32byes for customer extra use
+#define SIGNATURE_LEN		129
+#define AES_IMG_KEY_LEN		16
+#define RSA_KEY_MODULUS_LEN	128
+#define _PRIV_LEN		1024
+#define _CUSTOM_PARAM_LEN	4096
+#if defined(CONFIG_REALTEK_PCBMGR)
+#define panel_parameter_LEN     129
+#define pcb_enum_parameter_LEN  4096
+#endif
+
+typedef struct {
+	int mode;		// 0: NTSC, 1: PAL
+	int size;
+	int color[4];
+} logo_info_struct;
+
+/* The format of "bootrev" is like "00.00.26c". The second byte of it stands for board id, and the upper half byte of board id stands for CPU id */
+/* The new format of "bootrev" is extended to be "xxxx.xxxx.xx". We support both "xx.xx.xx" and "xxxx.xxxx.xx".  */
+typedef enum {
+	realtek_qa_board		=0x0,
+	realtek_mk_board		=0x1,
+	realtek_1261_demo_board		=0x2,		/* first demo board */
+	realtek_1281_demo_board		=0x4,		/* little blue */
+	realtek_mk2_board		=0x5,		/* little white */
+	realtek_photoviewer_board	=0x7,
+	realtek_avhdd_demo_board	=0x8,		/* little yellow */
+	realtek_pvr_demo_board		=0x9,
+	realtek_pvrbox_demo_board	=0xA,
+	realtek_avhdd2_demo_board	=0xB,		/* little yellow 2 */
+	realtek_pvrbox_pc_demo_board	=0xC,		/* little yellow 2 with PC install */
+	realtek_1071_avhdd_mk_demo_board	=0xD,	/* 1071 AVHDD MK Demo Board */
+	realtek_1261_avhdd_hdd25_demo_board	=0xE,	/* 1261 2.5" AVHDD Demo Board */
+	realtek_neptune_qa_board	=0x0101,
+	realtek_neptuneB_qa_board	=0x1101,
+	realtek_neptune_demo_board	=0x0102,
+	realtek_neptuneB_demo_board	=0x1102,
+	realtek_1282_neptuneB_qa_board	=0x1103, /* 1282 Neptune B, QA Board. */
+	realtek_1282_neptuneB_demo_board	=0x1104, /* 1282 Neptune B, DEMO board. */
+	realtek_1262_neptuneB_pc_install_demo_board	=0x1105, /* 1262 Neptune B, DEMO board with PC install. */
+	realtek_1262_neptuneB_mk_board	=0x1106, /* 1262 Neptune B, MK board. */
+	realtek_1262_neptuneB_avhdd_ewha10_mk_board	=0x1107, /* 1262 Neptune B, AVHDD Ewha 1.0 MK board. */
+	realtek_1283_mars_qa_board	=0x0200, /* 1283 Mars, QA board. */
+	C01_avhdd_board			=0x10001,
+	C01_1262_avhdd_board		=0x11101, /* 1262 Neptune AVHDD Board. */
+	C01_photoviewer_board		=0x10007,
+	C02_avhdd_board			=0x20008,
+	C02_1262_Neptune_avhdd_board	=0x21101,
+	C03_pvr_8m_board		=0x30001,
+	C03_pvr_board			=0x30009,
+	C03_pvr2_board			=0x3000B,
+	C04_pvr_board			=0x40009,
+	C04_pvr2_board			=0x4000B,
+	C05_pvrbox_board		=0x5000A,
+	C05_pvrbox2_board		=0x50001,
+	C06_pvr_board			=0x60009,
+	C07_avhdd_board			=0x70001, //AVHDD with J-Micron SATA.
+	C07_pvrbox_board		=0x7000a, //PVR-BOX with PC Install.
+	C07_pvrbox2_board		=0x7000b, //PVR-BOX without PC Install.
+	C08_pvr_board			=0x80009,
+	C09_pvrbox_board		=0x90001,
+	C09_pvrbox2_board		=0x90002,
+	C0A_pvr_board			=0xa0001, //2MB NOR and 128MB+ NAND.Behavior is the same with C0003.B000b
+	C0B_dvr_board			=0xb1101, //Neptune 1282 DVR Demo Board.
+	C0C_avhdd_board			=0xc0001,
+	C0D_pvr_board			=0xd0001,	//8 MB PVR Module.
+	C0E_dvr_board			=0xe0001,	//1281 2MB DVR (little blue).
+	C0F_1061_avhdd_hdd35_board	=0xf0001,	//1061 AVHDD with 3.5" HDD.
+	C0F_1061_avhdd_board		=0xf0002,	//1061 AVHDD without HDD.
+	C0F_1262_avhdd_hdd35_board	=0xf1101,	//1262 AVHDD with 3.5" HDD.
+	C0F_1262_avhdd_hdd25_board	=0xf1102,	//1262 AVHDD with 2.5" HDD.
+	C10_1071_avhdd_board		=0x100001,	//1071 AVHDD
+} board_id_t;
+
+/* The format of "bootrev" is like "00.00.26c". The first byte of it stands for company id */
+typedef enum {
+	company_realtek		=0x0,
+	company_alpha		=0x1,
+	company_C02		=0x2,
+	company_C03		=0x3,
+	company_C04		=0x4,
+	company_C05		=0x5,
+	company_C06		=0x6,
+	company_C07		=0x7,
+	company_C08		=0x8,
+	company_C09		=0x9,
+	company_C0A		=0xa,
+	company_C0B		=0xb,
+	company_C0C		=0xc,
+	company_C0D		=0xd,
+	company_C0E		=0xe,
+	company_C0F		=0xf,
+	company_C10		=0x10,
+} company_id_t;
+
+/* Defines of CPU ID */
+typedef enum {
+	realtek_venus_cpu	=0x00,
+	realtek_venus2_cpu	=0x10,
+	realtek_venus3_cpu	=0x20,
+	realtek_neptune_cpu	=0x01,
+	realtek_neptuneB_cpu	=0x11,
+	realtek_mars_cpu	=0x02,
+	realtek_marsB_cpu	=0x12,
+	realtek_marsC_cpu	=0x22,
+	realtek_marsD_cpu	=0x32,
+	realtek_jupiter_cpu	=0x03,
+	realtek_jupiterB_cpu    =0x13,
+	realtek_jupiterC_cpu    =0x23,
+	realtek_jupiterD_cpu    =0x33,
+	realtek_saturn_cpu	=0x04,
+	realtek_saturnB_cpu	=0x14,
+	realtek_darwin_cpu	=0x05,
+	realtek_macarthur_cpu	=0x06,
+	realtek_nike_cpu	=0x07,
+} cpu_id_t;
+
+typedef enum {
+	PAL,
+	NTSC,
+} tv_encoding_system_t;
+
+typedef struct {
+	board_id_t		board_id;
+	company_id_t		company_id;
+	cpu_id_t		cpu_id;
+	char			kernel_source_code_info[64];
+	char			bootloader_version[32];
+	char			ethaddr[20];			/* Ethernet Mac address */
+	int			ethtype;			/* Ethernet type. 0 for 100M; 1 for 1G */
+	char			usb_param[20];			/* USB parameter */
+	char			usb1_param[20];			/* USB parameter */
+	char			usb2_param[20];			/* USB parameter */
+	unsigned char		AES_CCMP[AES_CCMP_LEN];		/* maximum size 113. The last one may be '\0' */
+	int			AES_CCMP_len;			/* The stored length of the binary data in AES_CCMP[] */
+#if defined(CONFIG_REALTEK_PCBMGR)
+	unsigned char		panel_parameter[panel_parameter_LEN];		/* maximum size 113. The last one may be '\0' */
+	int			panel_parameter_len;			/* The stored length of the binary data in AES_CCMP[] */
+	char           pcb_enum_parameter[pcb_enum_parameter_LEN];
+	int 		   pcb_enum_parameter_len;
+#endif
+	int			update_mode;
+	char			system_parameters[SYSTEM_PARAMETERS_LEN];
+	tv_encoding_system_t	tv_encoding_system;
+	char			signature[SIGNATURE_LEN];
+	unsigned char 		modelconfig[MODEL_CONFIG_LEN];
+	int			modelconfig_len;
+	int			secure_boot;
+	char			AES_IMG_KEY[AES_IMG_KEY_LEN];
+	char			RSA_KEY_MODULUS[RSA_KEY_MODULUS_LEN];
+	char			_priv_[_PRIV_LEN];
+	char			_custom_param_[_CUSTOM_PARAM_LEN];
+	unsigned		short rtc_base_date_year;	/* The base year of RTC passed from bootloader. The default is 2005 */
+} platform_info_t;
+
+extern platform_info_t platform_info;
+
+static inline int is_venus_cpu(void) {
+/*
+	int cpu_id = platform_info.cpu_id;
+
+	#ifdef CONFIG_REALTEK_FORCE_CPUID_AS_CHIP
+		#ifdef CONFIG_REALTEK_VENUS
+		       return 1;
+		#else
+			return 0;
+		#endif
+	#endif
+
+	if((cpu_id&0xf) == realtek_venus_cpu)
+		return 1;
+	else
+*/		return 0;
+
+}
+
+static inline int is_neptune_cpu(void) {
+/*	int cpu_id = platform_info.cpu_id;
+
+
+	#ifdef CONFIG_REALTEK_FORCE_CPUID_AS_CHIP
+		#ifdef CONFIG_REALTEK_NEPTUNE
+		       return 1;
+		#else
+			return 0;
+		#endif
+	#endif
+
+	if((cpu_id&0xf) == realtek_neptune_cpu)
+		return 1;
+	else
+*/		return 0;
+}
+
+static inline int is_mars_cpu(void) {
+/*	int cpu_id = platform_info.cpu_id;
+
+	#ifdef CONFIG_REALTEK_FORCE_CPUID_AS_CHIP
+		#ifdef CONFIG_REALTEK_MARS
+		       return 1;
+		#else
+			return 0;
+		#endif
+	#endif
+
+	if((cpu_id&0xf) == realtek_mars_cpu)
+		return 1;
+	else
+*/		return 0;
+}
+
+static inline int is_jupiter_cpu(void) {
+/*	int cpu_id = platform_info.cpu_id;
+
+	#ifdef CONFIG_REALTEK_FORCE_CPUID_AS_CHIP
+		#ifdef CONFIG_REALTEK_JUPITER
+		       return 1;
+		#else
+			return 0;
+		#endif
+	#endif
+
+	if((cpu_id&0xf) == realtek_jupiter_cpu)
+		return 1;
+	else
+*/		return 0;
+}
+
+static inline int is_saturn_cpu(void) {
+/*        int cpu_id = platform_info.cpu_id;
+
+	#ifdef CONFIG_REALTEK_FORCE_CPUID_AS_CHIP
+		#ifdef CONFIG_REALTEK_SATURN
+		       return 1;
+		#else
+			return 0;
+		#endif
+	#endif
+
+        if((cpu_id&0xf) == realtek_saturn_cpu)
+                return 1;
+        else
+*/                return 0;
+}
+static inline int is_nike_cpu(void) {
+/*        int cpu_id = platform_info.cpu_id;
+
+	#ifdef CONFIG_REALTEK_FORCE_CPUID_AS_CHIP
+		#ifdef CONFIG_REALTEK_NIKE
+		       return 1;
+		#else
+			return 0;
+		#endif
+	#endif
+
+        if((cpu_id&0xf) == realtek_nike_cpu)
+                return 1;
+        else
+*/                return 0;
+}
+static inline int is_darwin_cpu(void) {
+/*        int cpu_id = platform_info.cpu_id;
+	#ifdef CONFIG_REALTEK_FORCE_CPUID_AS_CHIP
+		#ifdef CONFIG_REALTEK_DARWIN
+		       return 1;
+		#else
+			return 0;
+		#endif
+	#endif
+
+        if((cpu_id&0xf) == realtek_darwin_cpu)
+                return 1;
+        else
+*/                return 0;
+}
+
+static inline int is_macarthur_cpu(void) {
+/*
+        int cpu_id = platform_info.cpu_id;
+
+	#ifdef CONFIG_REALTEK_FORCE_CPUID_AS_CHIP
+		#ifdef CONFIG_REALTEK_MACARTHUR
+		       return 1;
+		#else
+			return 0;
+		#endif
+	#endif
+        if((cpu_id&0xf) == realtek_macarthur_cpu)
+                return 1;
+        else
+*/                return 0;
+
+}
+// Return the revision number of Venus/Neptune/Mars/Jupiter... CPUs
+static inline int cpu_rev_num(void) {
+/*	return (platform_info.cpu_id&0xf0)>>4;
+*/                return 0;
+}
+
+#endif /* !(_MACH_PLATFORM_H) */
+
+
diff --git a/drivers/i2c/busses/saturn.h b/drivers/i2c/busses/saturn.h
new file mode 100644
index 00000000..e4857f2
--- /dev/null
+++ b/drivers/i2c/busses/saturn.h
@@ -0,0 +1,153 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License.  See the file "COPYING" in the main directory of this archive
+ * for more details.
+ *
+ * Defines of the Mars cpu's specific address-MAP, registers, etc. Mars cpu
+ * inherits most of the defines of Venus cpu.
+ *
+ * Copyright (C) 2010 by Chien-An Lin <colin@realtek.com.tw>
+ */
+
+#ifndef _MACH_SATURN_H
+#define _MACH_SATURN_H
+
+//#include <asm/addrspace.h>
+//#include <jupiter.h>
+
+#define SATURN_IO_PORT_BASE                     JUPITER_IO_PORT_BASE     
+
+/*-------------------------------------------------------------
+ * Saturn DC SYS register
+ *-------------------------------------------------------------*/  
+#define SATURN_DC_EC_CTRL               0x8300
+#define SATURN_DC_EC_ADDCMD_HI          0x8304
+#define SATURN_DC_EC_ADDCMD_LO          0x8308
+
+#define SATURN_DC_MT_ENTRY_COUNT           8
+#define SATURN_DC_MT_SADDR                 0x08200
+#define SATURN_DC_MT_EADDR                 0x08220
+#define SATURN_DC_MT_MODE                  0x08240
+#define SATURN_DC_MT_TABLE                 0x08260
+#define SATURN_DC_MT_ADDCMD_HI             0x08280
+#define SATURN_DC_MT_ADDCMD_LO             0x082A0
+
+
+/*-------------------------------------------------------------
+ * Saturn MISC I2C register
+ *-------------------------------------------------------------*/  
+#define SATURN_MIS_I2C1_SDA_DEL                 0x1b088
+#define SATURN_MIS_I2C2_SDA_DEL                 0x1b08C
+#define SATURN_MIS_I2C3_SDA_DEL                 0x1b090
+#define SATURN_MIS_I2C4_SDA_DEL                 0x1b094
+#define SATURN_MIS_I2C5_SDA_DEL                 0x1b098
+
+  #define I2C_SDA_DEL_MASK                        (0x1FF)
+  #define I2C_SDA_DEL_EN(x)                       (0x00000001<<8)
+  #define I2C_SDA_DEL_SEL(x)                      ((x & 0x1F))          // Delay time: (unit 518ns)
+        
+#define SATURN_MIS_PWM_OCD                      0x1b400
+#define SATURN_MIS_PWM_CD                       0x1b404
+#define SATURN_MIS_PWM_CSD                      0x1b408
+
+  #define PWM_OUTPUT_DIV(i, val)      ((val & 0xFF) << (i<<3))
+  #define PWM_OUTPUT_DIV_MASK(i)      ((0xFF) << (i<<3))
+  #define PWM_CLK_DUTY(i, val)        ((val & 0xFF) << (i<<3))
+  #define PWM_CLK_DUTY_MASK(i)        ((0xFF) << (i<<3))
+  #define PWM_SCLK_DIV(i, val)        ((val & 0xF) << (i<<2))
+  #define PWM_SCLK_DIV_MASK(i)        ((0xF) << (i<<2))
+
+
+/*-------------------------------------------------------------
+ * Saturn ISO system register
+ *-------------------------------------------------------------*/
+#define Saturn_ISO_ISR             0x7000
+#define SATURN_ISO_ISR             Saturn_ISO_ISR
+#define SATURN_ISO_ISR_CEC_TX     (0x00000001<<22)
+#define SATURN_ISO_ISR_CEC_RX     (0x00000001<<23)
+
+
+#define SATURN_ISO_I2C0_SDA_DEL                 0x7084
+#define SATURN_ISO_I2C6_SDA_DEL                 0x70c0
+
+
+#define SATURN_ISO_UMSK_ISR                     0x7004
+#define SATURN_ISO_UMSK_ISR_GP                  0x7008
+#define SATURN_ISO_UMSK_ISR_KPADAH              0x700C
+#define SATURN_ISO_UMSK_ISR_KPADAL              0x7010
+#define SATURN_ISO_UMSK_ISR_KPADDAH             0x7014
+#define SATURN_ISO_UMSK_ISR_KPADDAL             0x7018
+#define SATURN_ISO_UMSK_ISR_SW                  0x701C
+#define SATURN_ISO_DBG                          0x7020
+#define SATURN_ISO_DUMMY1                       0x7024
+#define SATURN_ISO_CHIP_INFO1                   0x7028
+#define SATURN_ISO_CHIP_INFO2                   0x702C
+#define SATURN_ISO_CHIP_CTRL                    0x7030
+#define SATURN_ISO_RTC                          0x7034
+#define SATURN_ISO_CELL                         0x7038
+#define SATURN_ISO_POWER                        0x703C
+#define SATURN_ISO_SCPU_INT_EN                  0x7040
+#define SATURN_ISO_KCPU_INT_EN                  0x7044
+#define SATURN_ISO_CPU_ST1                      0x7048
+#define SATURN_ISO_CPU_ST1V                     0x704C
+#define SATURN_ISO_DUMMY2                       0x7050
+
+/*-------------------------------------------------------------
+ * SATURN ISO GPIO register
+ *-------------------------------------------------------------*/
+#define SATURN_ISO_GPDIR                        0x7100
+#define SATURN_ISO_GPDATO                       0x7104
+#define SATURN_ISO_GPDATI                       0x7108
+#define SATURN_ISO_GPIE                         0x710C
+#define SATURN_ISO_GPDP                         0x7110
+#define SATURN_ISO_GPDEB                        0x7114
+
+/*-------------------------------------------------------------
+ * SATURN ISO IrDA register
+ *-------------------------------------------------------------*/
+#define SATURN_ISO_IR_PSR                       0x7400
+#define SATURN_ISO_IR_PRE                       0x7404
+#define SATURN_ISO_IR_SF                        0x7408
+#define SATURN_ISO_IR_DPIR                      0x740C
+#define SATURN_ISO_IR_CR                        0x7410
+#define SATURN_ISO_IR_RP                        0x7414
+#define SATURN_ISO_IR_SR                        0x7418
+#define SATURN_ISO_IR_RAW_CTRL                  0x741C
+#define SATURN_ISO_IR_RAW_FF                    0x7420
+#define SATURN_ISO_IR_RAW_SAMPLE_TIME           0x7424
+#define SATURN_ISO_IR_WL                        0x7428
+#define SATURN_ISO_IR_RAW_DEB                   0x742C
+#define SATURN_ISO_IR_PSR_UP                    0x7430
+#define SATURN_ISO_IR_PER_UP                    0x7434
+#define SATURN_ISO_IR_CTRL_RC6                  0x7438
+
+/*-------------------------------------------------------------
+ * SATURN ISO CEC register
+ *-------------------------------------------------------------*/                                                                                                                             
+#define SATURN_ISO_CEC_CR0         0x7500
+#define SATURN_ISO_CEC_CR1         0x7504
+#define SATURN_ISO_CEC_CR2         0x7508
+#define SATURN_ISO_CEC_CR3         0x750C        
+#define SATURN_ISO_CEC_RT0         0x7510                       
+#define SATURN_ISO_CEC_RT1         0x7514                       
+#define SATURN_ISO_CEC_RX0         0x7518                       
+#define SATURN_ISO_CEC_RX1         0x751C                       
+#define SATURN_ISO_CEC_TX0         0x7520                       
+#define SATURN_ISO_CEC_TX1         0x7524                       
+#define SATURN_ISO_CEC_TX_FIFO     0x7528                       
+#define SATURN_ISO_CEC_RX_FIFO     0x752C                       
+#define SATURN_ISO_CEC_RX_START0   0x7530                       
+#define SATURN_ISO_CEC_RX_START1   0x7534                       
+#define SATURN_ISO_CEC_RX_DATA0    0x7538                       
+#define SATURN_ISO_CEC_RX_DATA1    0x753C                       
+#define SATURN_ISO_CEC_TX_START0   0x7540                       
+#define SATURN_ISO_CEC_TX_START1   0x7544                       
+#define SATURN_ISO_CEC_TX_DATA0    0x7548                       
+#define SATURN_ISO_CEC_TX_DATA1    0x754C                       
+#define SATURN_ISO_CEC_TX_DATA2    0x7550   
+
+#define SATURN_MIS_SCPU_INT_EN		0x1B080
+#define SATURN_MIS_KCPU_INT_EN		0x1B084
+
+#endif /* !(_MACH_SATURN_H) */
+
diff --git a/drivers/i2c/busses/venus.h b/drivers/i2c/busses/venus.h
new file mode 100644
index 00000000..a6fa515
--- /dev/null
+++ b/drivers/i2c/busses/venus.h
@@ -0,0 +1,596 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License.  See the file "COPYING" in the main directory of this archive
+ * for more details.
+ *
+ * Defines of the Venus cpu's specific address-MAP, registers, etc.
+ *
+ * Copyright (C) 2010 by Chien-An Lin <colin@realtek.com.tw>
+ */
+#ifndef _MACH_VENUS_H
+#define _MACH_VENUS_H
+
+//#include <asm/addrspace.h>
+
+
+/*
+ * Yamon Prom print address.
+ */
+#define YAMON_PROM_PRINT_ADDR		0x1fc00504
+
+//#define VENUS_RESET_ADDR		0xbfc00000
+
+//#define VENUS_IO_PORT_BASE		0xb8000000
+#define VENUS_ISO_IO_PORT_BASE		0xFE000000
+#define VENUS_MISC_IO_PORT_BASE		0xFE000000
+//#define VENUS_0_SYS_DEBUG		0xB80000AC
+
+
+/*
+ * Venus USB registers.
+ */
+#define VENUS_USB_BASE			0x13000
+//Ehci Capability Registers
+#define VENUS_USB_EHCI_USBBASE		VENUS_USB_BASE
+#define VENUS_USB_EHCI_HCCAPBASE	(VENUS_USB_EHCI_USBBASE+0x00)
+#define VENUS_USB_EHCI_HCSPARAMS	(VENUS_USB_EHCI_USBBASE+0x04)
+#define VENUS_USB_EHCI_HCCPARAMS	(VENUS_USB_EHCI_USBBASE+0x08)
+//Ehci Operational Registers
+#define VENUS_USB_EHCI_USBOPBASE	(VENUS_USB_EHCI_USBBASE+0x10)
+#define VENUS_USB_EHCI_USBCMD		(VENUS_USB_EHCI_USBOPBASE+0x00)
+#define VENUS_USB_EHCI_USBSTS		(VENUS_USB_EHCI_USBOPBASE+0x04)
+#define VENUS_USB_EHCI_USBINTR		(VENUS_USB_EHCI_USBOPBASE+0x08)
+#define VENUS_USB_EHCI_FRINDEX		(VENUS_USB_EHCI_USBOPBASE+0x0c)
+#define VENUS_USB_EHCI_CTRLDSSEGMENT	(VENUS_USB_EHCI_USBOPBASE+0x10)
+#define VENUS_USB_EHCI_PERIODICLISTBASE	(VENUS_USB_EHCI_USBOPBASE+0x14)
+#define VENUS_USB_EHCI_ASYNCLISTADDR	(VENUS_USB_EHCI_USBOPBASE+0x18)
+#define VENUS_USB_EHCI_CONFIGFLAG	(VENUS_USB_EHCI_USBOPBASE+0x40)
+#define VENUS_USB_EHCI_PORTSC_0		(VENUS_USB_EHCI_USBOPBASE+0x44)
+//Synopsys-Specific Registers
+#define VENUS_USB_EHCI_INSNREG00	(VENUS_USB_EHCI_USBOPBASE+0x80)
+#define VENUS_USB_EHCI_INSNREG01	(VENUS_USB_EHCI_USBOPBASE+0x84)
+#define VENUS_USB_EHCI_INSNREG02	(VENUS_USB_EHCI_USBOPBASE+0x88)
+#define VENUS_USB_EHCI_INSNREG03	(VENUS_USB_EHCI_USBOPBASE+0x8c)
+#define VENUS_USB_EHCI_INSNREG04	(VENUS_USB_EHCI_USBOPBASE+0x90)
+#define VENUS_USB_EHCI_INSNREG05	(VENUS_USB_EHCI_USBOPBASE+0x94)
+//Ohci Registers
+#define VENUS_USB_OHCI_USBBASE		(VENUS_USB_BASE+0x400)
+#define VENUS_USB_OHCI_REVISION		(VENUS_USB_OHCI_USBBASE+0x00)
+#define VENUS_USB_OHCI_CONTROL		(VENUS_USB_OHCI_USBBASE+0x04)
+#define VENUS_USB_OHCI_COMMAND_STATUS	(VENUS_USB_OHCI_USBBASE+0x08)
+#define VENUS_USB_OHCI_INTERRUPT_STATUS	(VENUS_USB_OHCI_USBBASE+0x0c)
+#define VENUS_USB_OHCI_INTERRUPT_ENABLE	(VENUS_USB_OHCI_USBBASE+0x10)
+#define VENUS_USB_OHCI_INTERRUPT_DISABLE	(VENUS_USB_OHCI_USBBASE+0x14)
+#define VENUS_USB_OHCI_HCCA		(VENUS_USB_OHCI_USBBASE+0x18)
+#define VENUS_USB_OHCI_PERIOD_CURRENTED	(VENUS_USB_OHCI_USBBASE+0x1c)
+#define VENUS_USB_OHCI_CONTROL_HEADED	(VENUS_USB_OHCI_USBBASE+0x20)
+#define VENUS_USB_OHCI_CONTROL_CURRENTED	(VENUS_USB_OHCI_USBBASE+0x24)
+#define VENUS_USB_OHCI_BULK_HEADED	(VENUS_USB_OHCI_USBBASE+0x28)
+#define VENUS_USB_OHCI_BULK_CURRENTED	(VENUS_USB_OHCI_USBBASE+0x2c)
+#define VENUS_USB_OHCI_DONE_HEAD	(VENUS_USB_OHCI_USBBASE+0x30)
+#define VENUS_USB_OHCI_FM_INTERVAL	(VENUS_USB_OHCI_USBBASE+0x34)
+#define VENUS_USB_OHCI_FM_REMAINING	(VENUS_USB_OHCI_USBBASE+0x38)
+#define VENUS_USB_OHCI_FM_NUMBER	(VENUS_USB_OHCI_USBBASE+0x3c)
+#define VENUS_USB_OHCI_PERIODIC_START	(VENUS_USB_OHCI_USBBASE+0x40)
+#define VENUS_USB_OHCI_LS_THRESHOLD	(VENUS_USB_OHCI_USBBASE+0x44)
+#define VENUS_USB_OHCI_RH_DESC_A	(VENUS_USB_OHCI_USBBASE+0x48)
+#define VENUS_USB_OHCI_RH_DESC_B	(VENUS_USB_OHCI_USBBASE+0x4c)
+#define VENUS_USB_OHCI_RH_STATUS	(VENUS_USB_OHCI_USBBASE+0x50)
+#define VENUS_USB_OHCI_PORT_STATUS_1	(VENUS_USB_OHCI_USBBASE+0x54)
+
+
+// USB Host Registers
+#define VENUS_USB_HOST_BASE		(VENUS_USB_BASE+0x800)
+#define VENUS_USB_HOST_WRAPPER		(VENUS_USB_HOST_BASE+0x00)
+#define VENUS_USB_HOST_VSTATUS		(VENUS_USB_HOST_BASE+0x04)
+#define VENUS_USB_HOST_USBIP_INPUT	(VENUS_USB_HOST_BASE+0x08)
+#define VENUS_USB_HOST_RESET_UTMI	(VENUS_USB_HOST_BASE+0x0c)
+#define VENUS_USB_HOST_SELF_LOOP_BACK	(VENUS_USB_HOST_BASE+0x10)
+
+
+/* Define for Venus Ethernet MAC. */
+#define VENUS_ETH_BASE			0xb8016000
+#define VENUS_ETH_CR			((volatile unsigned char *)(VENUS_ETH_BASE + 0x3B))
+#define VENUS_ETH_IMR			((volatile unsigned short *)(VENUS_ETH_BASE + 0x3C))
+#define VENUS_ETH_RCR			((volatile unsigned int *)(VENUS_ETH_BASE + 0x44))
+#define VENUS_ETH_MIIAR			((volatile unsigned int *)(VENUS_ETH_BASE + 0x5C))
+/*
+ * Venus Ethernet Phy registers.
+ */
+#define VENUS_ETN_MII_AR		0x1605C
+
+
+/*
+ * Venus TV encoder registers.
+ */
+#define VENUS_TVE_VIDEO_DAC_CTRL0	0x180D0
+#define VENUS_TVE_VIDEO_DAC_CTRL1	0x180D4
+
+
+/*
+ * Venus TV decoder registers.
+ */
+#define VENUS_TVD_VIDEO_ADC_DIGITAL_CTRL0	0x190FC
+
+
+/*
+ * Venus SB2 registers.
+ */
+#define VENUS_SB2_HD_SEM		0x1A000
+#define VENUS_SB2_INV_INTEN		0x1A004
+#define VENUS_SB2_INV_INTSTAT		0x1A008
+#define VENUS_SB2_INV_ADDR		0x1A00C
+
+#define VENUS_SB2_CHIP_ID		0x1A200
+#define VENUS_SB2_CHIP_INFO		0x1A204
+
+
+/*
+ * Software Debug registers
+ */
+#define SB2_DGB_START_REG0		0x1A458
+#define SB2_DGB_START_REG1		0x1A45c
+#define SB2_DGB_START_REG2		0x1A460
+#define SB2_DGB_START_REG3		0x1A464
+#define SB2_DGB_START_REG4		0x1A468
+#define SB2_DGB_START_REG5		0x1A46c
+#define SB2_DGB_START_REG6		0x1A470
+#define SB2_DGB_START_REG7		0x1A474
+
+#define SB2_DGB_END_REG0		0x1A478
+#define SB2_DGB_END_REG1		0x1A47c
+#define SB2_DGB_END_REG2		0x1A480
+#define SB2_DGB_END_REG3		0x1A484
+#define SB2_DGB_END_REG4		0x1A488
+#define SB2_DGB_END_REG5		0x1A48c
+#define SB2_DGB_END_REG6		0x1A490
+#define SB2_DGB_END_REG7		0x1A494
+
+#define SB2_DGB_CTRL_REG0		0x1A498
+#define SB2_DGB_CTRL_REG1		0x1A49c
+#define SB2_DGB_CTRL_REG2		0x1A4a0
+#define SB2_DGB_CTRL_REG3		0x1A4a4
+#define SB2_DGB_CTRL_REG4		0x1A4a8
+#define SB2_DGB_CTRL_REG5		0x1A4ac
+#define SB2_DGB_CTRL_REG6		0x1A4b0
+#define SB2_DGB_CTRL_REG7		0x1A4b4
+
+#define SB2_DGB_ADDR_ADUIO		0x1A4b8
+#define SB2_DGB_ADDR_VIDEO		0x1A4bc
+#define SB2_DGB_ADDR_SYSTEM		0x1A4c0
+
+#define SB2_DGB_INT			0x1A4e0
+
+
+/*
+ * Venus MISC registers.
+ */
+
+#define VENUS_ISO_ISR			0x7000
+
+
+#define VENUS_MIS_PSELH			0x1B000
+#define VENUS_MIS_PSELL			0x1B004
+#define VENUS_MIS_UMSK_ISR		0x1B008
+#define VENUS_MIS_ISR			0x1B00C
+#define VENUS_MIS_UMSK_ISR_GP0A		0x1B010
+#define VENUS_MIS_UMSK_ISR_GP0DA	0x1B014
+#define VENUS_MIS_UMSK_ISR_KPADAH	0x1B018
+#define VENUS_MIS_UMSK_ISR_KPADAL	0x1B01C
+#define VENUS_MIS_UMSK_ISR_KPADDAH	0x1B020
+#define VENUS_MIS_UMSK_ISR_KPADDAL	0x1B024
+#define VENUS_MIS_UMSK_ISR_SW		0x1B028
+#define VENUS_MIS_DBG			0x1B02C
+#define VENUS_MIS_DUMMY			0x1B030
+#define VENUS_MIS_PSEL2			0x1B034
+#define VENUS_MIS_UMSK_ISR_GP1A		0x1B038
+#define VENUS_MIS_UMSK_ISR_GP1DA	0x1B03C
+
+
+/*
+ * Venus GPIO registers.
+ */
+#define VENUS_MIS_GP0DIR		0x1B100
+#define VENUS_MIS_GP1DIR		0x1B104
+#define VENUS_MIS_GP0DATO		0x1B108
+#define VENUS_MIS_GP1DATO		0x1B10C
+#define VENUS_MIS_GP0DATI		0x1B110
+#define VENUS_MIS_GP1DATI		0x1B114
+#define VENUS_MIS_GP0IE			0x1B118
+#define VENUS_MIS_GP1IE			0x1B11C
+#define VENUS_MIS_GP0DP			0x1B120
+#define VENUS_MIS_GP1DP			0x1B124
+#define VENUS_MIS_GPDEB			0x1B128
+
+
+
+/*
+ * Venus UART registers. jjdarwin
+ */
+
+#if  defined(CONFIG_REALTEK_MACARTHUR)
+ 
+#define VENUS_MIS_U1RBR_THR_DLL         0x1B100
+#define VENUS_MIS_U1IER_DLH             0x1B104
+#define VENUS_MIS_U1IIR_FCR             0x1B108
+#define VENUS_MIS_U1LCR                 0x1B10C
+#define VENUS_MIS_U1MCR                 0x1B110
+#define VENUS_MIS_U1LSR                 0x1B114
+#define VENUS_MIS_U1MSR                 0x1B118
+#define VENUS_MIS_U1SCR                 0x1B11C
+ 
+#define VENUS_MIS_U0RBR_THR_DLL         0x61300
+#define VENUS_MIS_U0IER_DLH                 0x61304
+#define VENUS_MIS_U0IIR_FCR                  0x61308
+#define VENUS_MIS_U0LCR                         0x6130C
+#define VENUS_MIS_U0MCR                        0x61310
+#define VENUS_MIS_U0LSR                         0x61314
+#define VENUS_MIS_U0MSR                        0x61318
+#define VENUS_MIS_U0SCR                         0x6131C
+
+#define VENUS_MIS_U3RBR_THR_DLL         0x1B300
+#define VENUS_MIS_U3IER_DLH             0x1B304
+#define VENUS_MIS_U3IIR_FCR             0x1B308
+#define VENUS_MIS_U3LCR                 0x1B30C
+#define VENUS_MIS_U3MCR                 0x1B310
+#define VENUS_MIS_U3LSR                 0x1B314
+#define VENUS_MIS_U3MSR                 0x1B318
+#define VENUS_MIS_U3SCR                 0x1B31C
+#define VENUS_MIS_U3SRBR                0x1B330
+#define VENUS_MIS_U3FAR                 0x1B370
+#define VENUS_MIS_U3TFR                 0x1B374
+#define VENUS_MIS_U3RFW                 0x1B378
+#define VENUS_MIS_U3USR                 0x1B37C
+#define VENUS_MIS_U3TFL                 0x1B380
+#define VENUS_MIS_U3RFL                 0x1B384
+#define VENUS_MIS_U3SRR                 0x1B388
+#define VENUS_MIS_U3SBCR                0x1B390
+#define VENUS_MIS_U3SDMAM               0x1B394
+#define VENUS_MIS_U3SFE                 0x1B398
+#define VENUS_MIS_U3SRT                 0x1B39C
+#define VENUS_MIS_U3STET                0x1B3A0
+#define VENUS_MIS_U3HTX                 0x1B3A4
+#define VENUS_MIS_U3DMASA               0x1B3A8
+#define VENUS_MIS_U3CPR                 0x1B3F4
+#define VENUS_MIS_U3UCV                 0x1B3F8
+#define VENUS_MIS_U3CTR                 0x1B3FC
+
+#endif
+
+#if  defined(CONFIG_REALTEK_DARWIN) 
+ 
+#define VENUS_MIS_U0RBR_THR_DLL         0x1B100
+#define VENUS_MIS_U0IER_DLH             0x1B104
+#define VENUS_MIS_U0IIR_FCR             0x1B108
+#define VENUS_MIS_U0LCR                 0x1B10C
+#define VENUS_MIS_U0MCR                 0x1B110
+#define VENUS_MIS_U0LSR                 0x1B114
+#define VENUS_MIS_U0MSR                 0x1B118
+#define VENUS_MIS_U0SCR                 0x1B11C
+ 
+#define VENUS_MIS_U1RBR_THR_DLL         0x61300
+#define VENUS_MIS_U1IER_DLH                 0x61304
+#define VENUS_MIS_U1IIR_FCR                  0x61308
+#define VENUS_MIS_U1LCR                         0x6130C
+#define VENUS_MIS_U1MCR                        0x61310
+#define VENUS_MIS_U1LSR                         0x61314
+#define VENUS_MIS_U1MSR                        0x61318
+#define VENUS_MIS_U1SCR                         0x6131C
+ 
+#endif
+
+#if  defined(CONFIG_REALTEK_SATURN)
+
+#define VENUS_MIS_U0RBR_THR_DLL		0x7800
+#define VENUS_MIS_U0IER_DLH		0x7804
+#define VENUS_MIS_U0IIR_FCR		0x7808
+#define VENUS_MIS_U0LCR			0x780C
+#define VENUS_MIS_U0MCR			0x7810
+#define VENUS_MIS_U0LSR			0x7814
+#define VENUS_MIS_U0MSR			0x7818
+#define VENUS_MIS_U0SCR			0x781C
+
+#define VENUS_MIS_U1RBR_THR_DLL		0x1BC00
+#define VENUS_MIS_U1IER_DLH		0x1BC04
+#define VENUS_MIS_U1IIR_FCR		0x1BC08
+#define VENUS_MIS_U1LCR			0x1BC0C
+#define VENUS_MIS_U1MCR			0x1BC10
+#define VENUS_MIS_U1LSR			0x1BC14
+#define VENUS_MIS_U1MSR			0x1BC18
+#define VENUS_MIS_U1SCR			0x1BC1C
+
+#endif
+
+#if  defined(CONFIG_REALTEK_NIKE)
+
+#define VENUS_MIS_U0RBR_THR_DLL		0x7800
+#define VENUS_MIS_U0IER_DLH		0x7804
+#define VENUS_MIS_U0IIR_FCR		0x7808
+#define VENUS_MIS_U0LCR			0x780C
+#define VENUS_MIS_U0MCR			0x7810
+#define VENUS_MIS_U0LSR			0x7814
+#define VENUS_MIS_U0MSR			0x7818
+#define VENUS_MIS_U0SCR			0x781C
+
+#define VENUS_MIS_U1RBR_THR_DLL		0x7900
+#define VENUS_MIS_U1IER_DLH		0x7904
+#define VENUS_MIS_U1IIR_FCR		0x7908
+#define VENUS_MIS_U1LCR			0x790C
+#define VENUS_MIS_U1MCR			0x7910
+#define VENUS_MIS_U1LSR			0x7914
+#define VENUS_MIS_U1MSR			0x7918
+#define VENUS_MIS_U1SCR			0x791C
+
+#endif
+
+// for Chip before Saturn
+#ifndef VENUS_MIS_U0RBR_THR_DLL
+#define VENUS_MIS_U0RBR_THR_DLL         0x1B200
+#define VENUS_MIS_U0IER_DLH             0x1B204
+#define VENUS_MIS_U0IIR_FCR             0x1B208
+#define VENUS_MIS_U0LCR                 0x1B20C
+#define VENUS_MIS_U0MCR                 0x1B210
+#define VENUS_MIS_U0LSR                 0x1B214
+#define VENUS_MIS_U0MSR                 0x1B218
+#define VENUS_MIS_U0SCR                 0x1B21C
+ 
+#define VENUS_MIS_U1RBR_THR_DLL         0x1B220
+#define VENUS_MIS_U1IER_DLH             0x1B224
+#define VENUS_MIS_U1IIR_FCR             0x1B228
+#define VENUS_MIS_U1LCR                 0x1B22C
+#define VENUS_MIS_U1MCR                 0x1B230
+#define VENUS_MIS_U1LSR                 0x1B234
+#define VENUS_MIS_U1MSR                 0x1B238
+#define VENUS_MIS_U1SCR                 0x1B23C
+
+#endif
+
+
+#define VENUS_UART0_CLK			27000000
+#define VENUS_UART1_CLK			432000000
+
+/*
+ * Venus IrDA registers.
+ */
+#define VENUS_MIS_IR_PSR		0x1B400
+#define VENUS_MIS_IR_PRE		0x1B404
+#define VENUS_MIS_IR_SF			0x1B408
+#define VENUS_MIS_IR_DPIR		0x1B40C
+#define VENUS_MIS_IR_CR			0x1B410
+#define VENUS_MIS_IR_RP			0x1B414
+#define VENUS_MIS_IR_SR			0x1B418
+
+
+/*
+ * Venus external timer registers.jjdarwin
+ */
+#if  defined(CONFIG_REALTEK_DARWIN) || defined(CONFIG_REALTEK_MACARTHUR)
+#define VENUS_MIS_TC0TVR		0x1B600
+#define VENUS_MIS_TC1TVR		0x1B604
+#define VENUS_MIS_TC2TVR		0x1B608//0x1B618//0x1B608 use TC6
+#define VENUS_MIS_TC6TVR		0x1B618
+#define VENUS_MIS_TC0CVR		0x1B620
+#define VENUS_MIS_TC1CVR		0x1B624
+#define VENUS_MIS_TC2CVR		0x1B628//0x1B638//0x1B628 use TC6
+#define VENUS_MIS_TC6CVR		0x1B638
+#define VENUS_MIS_TC0CR			0x1B640
+#define VENUS_MIS_TC1CR			0x1B644
+#define VENUS_MIS_TC2CR			0x1B648//0x1B658//0x1B648 use TC6
+#define VENUS_MIS_TC6CR			0x1B658
+#define VENUS_MIS_TC0ICR		0x1B660
+#define VENUS_MIS_TC1ICR		0x1B664
+#define VENUS_MIS_TC2ICR		0x1B668//0x1B678//0x1B668 use TC6
+#define VENUS_MIS_TC6ICR		0x1B678
+#define VENUS_MIS_TCWCR			0x1BB00
+#define VENUS_MIS_TCWTR			0x1BB04
+#define VENUS_MIS_TCWOV			0x1BB0C
+#define VENUS_MIS_CLK27M_CLK90K_CNT	0x1B688
+#define VENUS_MIS_CLK90K_TM_LO		0x1B690
+#define VENUS_MIS_CLK90K_TM_HI		0x1B694
+
+#else
+
+#define VENUS_MIS_TC0TVR                0x1B500
+#define VENUS_MIS_TC1TVR                0x1B504
+#define VENUS_MIS_TC2TVR                0x1B508
+#define VENUS_MIS_TC0CVR                0x1B50C
+#define VENUS_MIS_TC1CVR                0x1B510
+#define VENUS_MIS_TC2CVR                0x1B514
+#define VENUS_MIS_TC0CR                 0x1B518
+#define VENUS_MIS_TC1CR                 0x1B51C
+#define VENUS_MIS_TC2CR                 0x1B520
+#define VENUS_MIS_TC0ICR                0x1B524
+#define VENUS_MIS_TC1ICR                0x1B528
+#define VENUS_MIS_TC2ICR                0x1B52C
+#if  defined(CONFIG_REALTEK_SATURN) || defined(CONFIG_REALTEK_NIKE)
+#define VENUS_MIS_TCWCR                 0x1B5B0
+#define VENUS_MIS_TCWTR                 0x1B5B4
+#define VENUS_MIS_TCWOV                 0x1B5BC
+#else
+#define VENUS_MIS_TCWCR                 0x1B530
+#define VENUS_MIS_TCWTR                 0x1B534
+#endif
+#define VENUS_MIS_CLK27M_CLK90K_CNT     0x1B538
+#define VENUS_MIS_CLK90K_TM_LO          0x1B53C
+#define VENUS_MIS_CLK90K_TM_HI          0x1B540
+
+#endif
+
+
+
+/*
+ * Venus RTC registers.
+ */
+#define VENUS_MIS_RTCSEC		0x1B600
+#define VENUS_MIS_RTCMIN		0x1B604
+#define VENUS_MIS_RTCHR			0x1B608
+#define VENUS_MIS_RTCDATE1		0x1B60C
+#define VENUS_MIS_RTCDATE2		0x1B610
+#define VENUS_MIS_ALMMIN		0x1B614
+#define VENUS_MIS_ALMHR			0x1B618
+#define VENUS_MIS_ALMDATE1		0x1B61C
+#define VENUS_MIS_ALMDATE2		0x1B620
+#define VENUS_MIS_RTCSTOP		0x1B624
+#define VENUS_MIS_RTCACR		0x1B628
+#define VENUS_MIS_RTCEN			0x1B62C
+#define VENUS_MIS_RTCCR			0x1B630
+
+
+/*
+ * Venus VFD registers.
+ */
+#define VENUS_MIS_VFD_CTL		0x1B700
+#define VENUS_MIS_VFD_WRCTL		0x1B704
+#define VENUS_MIS_VFDO			0x1B708
+#define VENUS_MIS_VFD_ARDCTL 		0x1B70C
+#define VENUS_MIS_VFD_KPADLIE		0x1B710
+#define VENUS_MIS_VFD_KPADHIE		0x1B714
+#define VENUS_MIS_VFD_SWIE		0x1B718
+#define VENUS_MIS_VFD_ARDKPADL		0x1B71C
+#define VENUS_MIS_VFD_ARDKPADH		0x1B720
+#define VENUS_MIS_VFD_ARDSW		0x1B724
+
+
+/*
+ * Defines for the Venus interrupt controller.
+ */
+#define VENUS_INT_BASE			2
+#define VENUS_INT_USB			(VENUS_INT_BASE+0)
+#define VENUS_INT_ETH			(VENUS_INT_BASE+0)
+
+#define VENUS_INT_CP			(VENUS_INT_BASE+1)
+
+#define VENUS_INT_1394			(VENUS_INT_BASE+2)
+#define VENUS_INT_ATA			(VENUS_INT_BASE+2)
+#define VENUS_INT_NAND			(VENUS_INT_BASE+2)
+
+#define VENUS_INT_AUDIO_RISC		(VENUS_INT_BASE+3)
+#define VENUS_INT_VIDEO_RISC		(VENUS_INT_BASE+3)
+#define VENUS_INT_SB2			(VENUS_INT_BASE+3)
+#define VENUS_INT_SE			(VENUS_INT_BASE+3)
+#define VENUS_INT_PERFORMANCE_COUNTER	(VENUS_INT_BASE+3)	// 24K has this; 4KEC doesn't
+
+#define VENUS_INT_EXTERNAL_TIMER	(VENUS_INT_BASE+4)//1)//4) //jjdarwin
+
+#define VENUS_INT_TIMER			(VENUS_INT_BASE+5)
+#define VENUS_INT_RTC			(VENUS_INT_BASE+5)
+
+
+#define REG_CLOCK_ENABLE1				(0xb800000c)
+#define REG_MUXPAD7							(0xb800036c)
+#define REG_NF_CKSEL						(0xb8000034)
+#define REG_DDR_BASE_ADDR				(0x80000000)
+#define REG_NF_BASE_ADDR				(0xb8010000)
+#define REG_ND_PA0							( REG_NF_BASE_ADDR + 0 ) 		//Page address 0 [7:0]
+#define	REG_ND_PA1							( REG_NF_BASE_ADDR + 0x4 )		//Page address 1 [15:8]
+#define	REG_ND_PA2							( REG_NF_BASE_ADDR + 0x8 )		//Page address 2 [20:16]
+#define	REG_ND_CA0				  		( REG_NF_BASE_ADDR + 0xc )		//Column address 0 [7:0]
+#define	REG_ND_CMD							( REG_NF_BASE_ADDR + 0x10 )		//Command [7:0]
+#define	REG_ND_DAT							( REG_NF_BASE_ADDR + 0x14 )		//NAND Data[7:0](Status_0)
+#define	REG_ND_CTL							( REG_NF_BASE_ADDR + 0x18 )		//NAND control register
+#define	REG_CMD3								( REG_NF_BASE_ADDR + 0x28 )		//CMD3 is the third command that would be transfer out by auto mode case 0/1/2
+#define	REG_ND_PA3							( REG_NF_BASE_ADDR + 0x2c )		//Page address 3 [23:21]
+#define REG_POLL_FSTS						( REG_NF_BASE_ADDR + 0x30 )		//Polling nand flash status
+#define REG_BLANK_CHK						( REG_NF_BASE_ADDR + 0x34 )		//Enable blank check function
+#define REG_ND_ECC							( REG_NF_BASE_ADDR + 0x38 )		//Indicate ECC status
+#define	REG_ND_CA1							( REG_NF_BASE_ADDR + 0x3c )		//Column address [15:8]
+#define	REG_DATA_TL0						( REG_NF_BASE_ADDR + 0x100 )	//Data transfer count [7:0]...
+#define	REG_DATA_TL1						( REG_NF_BASE_ADDR + 0x104 )	//Data transfer count [13:8]...
+#define REG_DMA1_CTL						( REG_NF_BASE_ADDR + 0x10c )	//DMA1 control register
+#define REG_PP_CTL0							( REG_NF_BASE_ADDR + 0x110 )	//Ping-Pong buffer control register
+#define REG_ECC_SEL							( REG_NF_BASE_ADDR + 0x128 )
+#define REG_PP_CTL1							( REG_NF_BASE_ADDR + 0x12c )	//PP starting address [7:0], this filedspecifies the starting address of the Ping-Pong buffer to put the data
+#define	REG_PD									( REG_NF_BASE_ADDR + 0x130 )	//PDx. Flash Chip Enable Output
+#define REG_DUMMY_NF1						( REG_NF_BASE_ADDR + 0x158 )	//NF clock dummy bit
+#define REG_DUMMY_NF2						( REG_NF_BASE_ADDR + 0x15c )	//NF clock dummy bit
+#define REG_DUMMY_NF3						( REG_NF_BASE_ADDR + 0x160 )	//NF clock dummy bit
+#define REG_DUMMY_NF4						( REG_NF_BASE_ADDR + 0x164 )	//NF clock dummy bit
+#define REG_AUTO_TRIG						( REG_NF_BASE_ADDR + 0x200 )	//Auto trigger register control
+#define REG_RSECC_NUM						( REG_NF_BASE_ADDR + 0x204 )	//ECC_NUM RS ECC error symbol count.
+#define REG_READ_BY_PP					( REG_NF_BASE_ADDR + 0x228 )	//Setting data read to DRAM from NAND through by PP or not
+#define REG_MAX_ECC_NUM					( REG_NF_BASE_ADDR + 0x22c )	//Auto mode(Mode 000) read status 
+#define REG_TIME_PARA3					( REG_NF_BASE_ADDR + 0x234 )	//NAND flash AC timming setting
+#define REG_TIME_PARA2					( REG_NF_BASE_ADDR + 0x238 )	//NAND flash AC timming setting
+#define REG_TIME_PARA1					( REG_NF_BASE_ADDR + 0x23c )	//NAND flash AC timming setting
+#define REG_PIN_MUX_STOP				( REG_NF_BASE_ADDR + 0x25c )	//Enable Pin_Mux_Stop function
+#define REG_DELAY_CTL						( REG_NF_BASE_ADDR + 0x260 )    //Flash timing delay clock number control
+#define	REG_ECC_STOP						( REG_NF_BASE_ADDR + 0x264 )	//Data read from NAND to SRAM don't stop transfer when ECC error occurs 
+#define	REG_ECC_PAGE						( REG_NF_BASE_ADDR + 0x268 )	//Used in data reading from NAND flash to TBRAM, and ECC_N_STOP was set.
+#define	REG_PAGE_CNT						( REG_NF_BASE_ADDR + 0x26c )	//Data page count that had been transferred.
+#define	REG_PAGE_LEN						( REG_NF_BASE_ADDR + 0x270 )	//Set the data length would be transferred by auto mode.
+#define	REG_CMD2								( REG_NF_BASE_ADDR + 0x274 )	//This is the secone command that would be transfer out by auto mode case 0/1/2.
+#define	REG_MULTI_CHNL_MODE			( REG_NF_BASE_ADDR + 0x27c )	//Multi-channel control register
+#define REG_SRAM_CTL						( REG_NF_BASE_ADDR + 0x300 )	//SRAM control register
+#define	REG_DMA_CTL1						( REG_NF_BASE_ADDR + 0x304 )	//DRAM start address for DMA transfer.
+#define	REG_DMA_CTL2						( REG_NF_BASE_ADDR + 0x308 )    //Transfer length for DMA transfer between DMA buffer and DDR.(512B Unit)
+#define	REG_DMA_CTL3						( REG_NF_BASE_ADDR + 0x30c )	//Set to control data transfer between DRAM and DMA buffer.
+#define	REG_NAND_ISR						( REG_NF_BASE_ADDR + 0x324 )	//NAND ISR status register
+#define	REG_NAND_ISREN					( REG_NF_BASE_ADDR + 0x328 )	//NAND ISR enable register
+#define	REG_DUMMY_SYS						( REG_NF_BASE_ADDR + 0x32c )	//Dummy
+#define	REG_DBG									( REG_NF_BASE_ADDR + 0x344 )	
+#define	REG_SPR_DDR_CTL					( REG_NF_BASE_ADDR + 0x348 )	
+#define	REG_CP_LEN							( REG_NF_BASE_ADDR + 0x34C )	
+
+
+
+/*
+ * Defines for the CP.
+ */
+#define REG_CP_BASE_ADDR				(0xb8015000)
+#define REG_MCP_CTRL					(REG_CP_BASE_ADDR+0x100)
+#define REG_MCP_STATUS					(REG_CP_BASE_ADDR+0x104)
+#define REG_MCP_EN						(REG_CP_BASE_ADDR+0x108)
+#define REG_MCP_CTRL1					(REG_CP_BASE_ADDR+0x198)
+#define REG_MCP_BASE					(REG_CP_BASE_ADDR+0x10C)
+#define REG_MCP_LIMIT					(REG_CP_BASE_ADDR+0x110)
+#define REG_MCP_RDPTR					(REG_CP_BASE_ADDR+0x114)
+#define REG_MCP_WRPTR					(REG_CP_BASE_ADDR+0x118)
+#define REG_MCP_DES_COUNT				(REG_CP_BASE_ADDR+0x134)
+#define REG_MCP_DES_COMPARE				(REG_CP_BASE_ADDR+0x138)
+#define REG_MCP_DES_INI_KEY				(REG_CP_BASE_ADDR+0x11C)
+#define REG_MCP_AES_INI_KEY				(REG_CP_BASE_ADDR+0x124)
+#define REG_MCP_MULTI2_SYS_KEY			(REG_CP_BASE_ADDR+0x178)
+#define REG_OTP_LOAD					(REG_CP_BASE_ADDR+0x19C)
+#define REG_K_MCP_CTRL					(REG_CP_BASE_ADDR+0x900)
+#define REG_K_MCP_STATUS				(REG_CP_BASE_ADDR+0x904)
+#define REG_K_MCP_EN					(REG_CP_BASE_ADDR+0x908)
+#define REG_K_MCP_CTRL1					(REG_CP_BASE_ADDR+0x998)
+#define REG_K_MCP_BASE					(REG_CP_BASE_ADDR+0x90C)
+#define REG_K_MCP_LIMIT					(REG_CP_BASE_ADDR+0x910)
+#define REG_K_MCP_RDPTR					(REG_CP_BASE_ADDR+0x914)
+#define REG_K_MCP_WRPTR					(REG_CP_BASE_ADDR+0x918)
+#define REG_K_MCP_DES_COUNT				(REG_CP_BASE_ADDR+0x934)
+#define REG_K_MCP_DES_COMPARE			(REG_CP_BASE_ADDR+0x938)
+#define REG_K_MCP_DES_INI_KEY			(REG_CP_BASE_ADDR+0x91C)
+#define REG_K_MCP_AES_INI_KEY			(REG_CP_BASE_ADDR+0x924)
+#define REG_K_MCP_MULTI2_SYS_KEY		(REG_CP_BASE_ADDR+0x978)
+#define REG_CP_REG_KEY					(REG_CP_BASE_ADDR+0x034)
+#define REG_CP_REG_DATAIN				(REG_CP_BASE_ADDR+0x044)	
+#define REG_CP_REG_DATAOUT				(REG_CP_BASE_ADDR+0x054)
+#define REG_CP_REG_IV					(REG_CP_BASE_ADDR+0x064)
+#define REG_CP_REG_SET					(REG_CP_BASE_ADDR+0x074)
+#define REG_CP_REG_SET1					(REG_CP_BASE_ADDR+0x078)
+#define REG_CP_REG_SET2					(REG_CP_BASE_ADDR+0x07C)
+#define REG_TP_KEY_INFO					(0xB8014058)
+#define REG_TP_KEY_CTRL					(0xB8014060)
+#define REG_CP_SCTCH					(REG_CP_BASE_ADDR+0x080)
+#define REG_CP_NF_KEY					(REG_CP_BASE_ADDR+0x084)
+#define REG_CP_NF_INI_KEY				(REG_CP_BASE_ADDR+0x094)
+#define REG_CP_NF_SET					(REG_CP_BASE_ADDR+0x0A4)
+#define REG_CP_MD_KEY					(REG_CP_BASE_ADDR+0x0A8)
+#define REG_CP_MD_INI_KEY				(REG_CP_BASE_ADDR+0x0B8)
+#define REG_CP_MD_SET					(REG_CP_BASE_ADDR+0x0C8)
+#define REG_K_CP_REG_KEY				(REG_CP_BASE_ADDR+0x834)
+#define REG_K_CP_REG_DATAIN				(REG_CP_BASE_ADDR+0x844)
+#define REG_K_CP_REG_DATAOUT			(REG_CP_BASE_ADDR+0x854)
+#define REG_K_CP_REG_IV					(REG_CP_BASE_ADDR+0x864)
+#define REG_K_CP_REG_SET				(REG_CP_BASE_ADDR+0x874)
+#define REG_K_CP_REG_SET1				(REG_CP_BASE_ADDR+0x878)
+#define REG_K_CP_REG_SET2				(REG_CP_BASE_ADDR+0x87C)
+#define REG_CP_DBG						(REG_CP_BASE_ADDR+0x0CC)
+#define REG_MCP_ST						(REG_CP_BASE_ADDR+0x1A0)
+
+#define __sleep __attribute__ ((__section__ (".sleep.text")))
+#define __sleepdata __attribute__ ((__section__ (".sleep.data")))
+
+#endif /* !(_MACH_VENUS_H) */
diff --git a/drivers/ide/ide.c b/drivers/ide/ide.c
index d127ace..6ee866f 100644
--- a/drivers/ide/ide.c
+++ b/drivers/ide/ide.c
@@ -244,7 +244,7 @@ struct chs_geom {
 static unsigned int ide_disks;
 static struct chs_geom ide_disks_chs[MAX_HWIFS * MAX_DRIVES];
 
-static int ide_set_disk_chs(const char *str, struct kernel_param *kp)
+static int ide_set_disk_chs(const char *str, const struct kernel_param *kp)
 {
 	unsigned int a, b, c = 0, h = 0, s = 0, i, j = 1;
 
@@ -328,7 +328,7 @@ static void ide_dev_apply_params(ide_drive_t *drive, u8 unit)
 
 static unsigned int ide_ignore_cable;
 
-static int ide_set_ignore_cable(const char *s, struct kernel_param *kp)
+static int ide_set_ignore_cable(const char *s, const struct kernel_param *kp)
 {
 	int i, j = 1;
 
diff --git a/drivers/iio/adc/Kconfig b/drivers/iio/adc/Kconfig
index 99c0514..2292c82 100644
--- a/drivers/iio/adc/Kconfig
+++ b/drivers/iio/adc/Kconfig
@@ -434,6 +434,20 @@ config STX104
 	  The base port addresses for the devices may be configured via the base
 	  array module parameter.
 
+config RTK_LSADC
+	tristate "Realtek LSADC support"
+	depends on ARCH_RTD129x || ARCH_RTD139x || ARCH_RTD16xx
+	default n
+	help
+          Say Y, if you want to enable LSADC feature on Realtek platform.
+
+config RTK_LSADC_RTD13xx
+	tristate "Realtek LSADC support"
+	depends on ARCH_RTD13xx
+	default n
+	help
+          Say Y, if you want to enable LSADC feature on Realtek platform.
+
 config TI_ADC081C
 	tristate "Texas Instruments ADC081C/ADC101C/ADC121C family"
 	depends on I2C
diff --git a/drivers/iio/adc/Makefile b/drivers/iio/adc/Makefile
index 7a40c04..d9ce1d6 100644
--- a/drivers/iio/adc/Makefile
+++ b/drivers/iio/adc/Makefile
@@ -41,6 +41,8 @@ obj-$(CONFIG_QCOM_SPMI_IADC) += qcom-spmi-iadc.o
 obj-$(CONFIG_QCOM_SPMI_VADC) += qcom-spmi-vadc.o
 obj-$(CONFIG_ROCKCHIP_SARADC) += rockchip_saradc.o
 obj-$(CONFIG_STX104) += stx104.o
+obj-$(CONFIG_RTK_LSADC) += rtk_lsadc.o
+obj-$(CONFIG_RTK_LSADC_RTD13xx) += rtk_lsadc_rtd13xx.o
 obj-$(CONFIG_TI_ADC081C) += ti-adc081c.o
 obj-$(CONFIG_TI_ADC0832) += ti-adc0832.o
 obj-$(CONFIG_TI_ADC12138) += ti-adc12138.o
diff --git a/drivers/iio/adc/rtk_lsadc.c b/drivers/iio/adc/rtk_lsadc.c
new file mode 100644
index 00000000..ceb2979
--- /dev/null
+++ b/drivers/iio/adc/rtk_lsadc.c
@@ -0,0 +1,1230 @@
+/*
+ * Realtek Low Speed ADC driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+///////////////////////////////////////////////////////////////////////////////////////////////////////////
+#include <linux/platform_device.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/hwmon.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/err.h>
+#include <linux/of.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/interrupt.h>
+#include <linux/delay.h>
+#if defined(CONFIG_ARCH_RTD129x)
+#include <soc/realtek/rtk_chip.h>
+#endif /* CONFIG_ARCH_RTD129x */
+
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+#include <linux/reset.h>
+
+#include "rtk_lsadc.h"
+
+/*
+#define rtd_inb(offset)			(*(volatile unsigned char *)(offset))
+#define rtd_inw(offset)			(*(volatile unsigned short *)(offset))
+#define rtd_inl(offset)			(*(volatile unsigned long *)(offset))
+
+#define rtd_outb(offset,val)	(*(volatile unsigned char *)(offset) = val)
+#define rtd_outw(offset,val)	(*(volatile unsigned short *)(offset) = val)
+#define rtd_outl(offset,val)	(*(volatile unsigned long *)(offset) = val)
+*/
+#define LSADC_IRQ_DEFINED 	(1)
+#define SA_SHIRQ		IRQF_SHARED
+#define LSADC_READL(reg)        readl((void __iomem *)(reg + (uintptr_t)(pc->lsadc_addr)))
+#define LSADC_WRITEL(val, reg)  writel(val, (void __iomem *)(reg + (uintptr_t)(pc->lsadc_addr)))
+
+struct rtk_lsadc_pad_info {
+	uint			activate;
+	uint			ctrl_mode;
+	uint			pad_sw;
+	uint			threshold;
+	uint			vref_sel;
+};
+
+struct rtk_lsadc_info {
+	struct rtk_lsadc_pad_info	padInfoSet[2];
+	uint				pad0_adc_val;
+	uint				pad1_adc_val;
+	uint				irq;
+	uint				clk_gating_en;
+};
+
+struct rtk_lsadc_device {
+	struct device			*dev;
+	struct rtk_lsadc_info		lsadc[2];
+	uint				crt_lsadc_pg_val;
+	void __iomem			*crt_lsadc_pg_addr;
+	void __iomem			*isr_addr;
+	void __iomem			*lsadc_addr;
+};
+
+#ifdef LSADC_IRQ_DEFINED
+static irqreturn_t lsadc0_interrupt_pad(int irq, void *dev)
+{
+	struct rtk_lsadc_device *pc = dev;
+	uint status_reg;
+	uint pad0_reg, pad1_reg;
+	uint pad0_int, pad1_int;
+	uint new_adc_val=0;
+	int interrupt_flag=0;
+
+	interrupt_flag = ISR_MASK_LSADC0_INT & readl(pc->isr_addr);
+
+	{
+		status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+
+		pad0_int = LSADC_STATUS_MASK_PAD0_STATUS & status_reg;
+		pad1_int = LSADC_STATUS_MASK_PAD1_STATUS & status_reg;
+
+		pad0_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+		pad1_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+		pr_err("--- lsadc0_interrupt_pad :  pad0_adc=0x%0x, pad1_adc=0x%0x \n",pc->lsadc[0].pad0_adc_val,pc->lsadc[0].pad1_adc_val);
+
+		if(pad0_int) {
+			new_adc_val = pad0_reg & LSADC0_PAD_MASK_ADC_VAL;
+			pr_err(" lsadc0_interrupt_pad : pad0 interrupt! status_reg=0x%x , adc_val=> from [%d] to [%d] \n",
+			status_reg, pc->lsadc[0].pad0_adc_val,new_adc_val);
+			if( pc->lsadc[0].pad0_adc_val > new_adc_val ) {
+				pr_err(" lsadc0_interrupt_pad : pad0 adc became smaller! \n\n");
+			}
+			else {
+				pr_err(" lsadc0_interrupt_pad : pad0 adc became bigger! \n\n");
+			}
+			pc->lsadc[0].pad0_adc_val=new_adc_val;
+		}
+
+		if(pad1_int) {
+			new_adc_val = pad1_reg & LSADC0_PAD_MASK_ADC_VAL;
+			pr_err(" lsadc0_interrupt_pad : pad1 interrupt! status_reg=0x%x , adc_val=> from [%d] to [%d] \n",
+			status_reg, pc->lsadc[0].pad1_adc_val,new_adc_val);
+			if( pc->lsadc[0].pad1_adc_val > new_adc_val ) {
+				pr_err(" lsadc0_interrupt_pad : pad1 adc became smaller! \n\n");
+			}
+			else {
+				pr_err(" lsadc0_interrupt_pad : pad1 adc became bigger! \n\n");
+			}
+			pc->lsadc[0].pad1_adc_val=new_adc_val;
+		}
+
+		status_reg = status_reg | ( LSADC_STATUS_MASK_PAD0_STATUS | LSADC_STATUS_MASK_PAD1_STATUS);  // reset INT flag
+		LSADC_WRITEL(status_reg, LSADC0_STATUS_ADDR);
+
+		return IRQ_HANDLED;
+	}
+}
+
+static irqreturn_t lsadc1_interrupt_pad(int irq, void *dev)
+{
+	struct rtk_lsadc_device *pc = dev;
+	uint status_reg;
+	uint pad0_reg, pad1_reg;
+	uint pad0_int, pad1_int;
+	uint new_adc_val=0;
+	int interrupt_flag=0;
+
+	interrupt_flag = ISR_MASK_LSADC1_INT & readl(pc->isr_addr);
+
+	{
+		status_reg = LSADC_READL(LSADC1_STATUS_ADDR);
+
+		pad0_int = LSADC_STATUS_MASK_PAD0_STATUS & status_reg;
+		pad1_int = LSADC_STATUS_MASK_PAD1_STATUS & status_reg;
+
+		pad0_reg = LSADC_READL(LSADC1_PAD0_ADDR);
+		pad1_reg = LSADC_READL(LSADC1_PAD1_ADDR);
+		pr_err("--- lsadc1_interrupt_pad :  pad0_adc=0x%0x, pad1_adc=0x%0x \n",pc->lsadc[1].pad0_adc_val,pc->lsadc[1].pad1_adc_val);
+
+		if(pad0_int) {
+			new_adc_val = pad0_reg & LSADC1_PAD_MASK_ADC_VAL;
+			pr_err(" lsadc1_interrupt_pad : pad0 interrupt! status_reg=0x%x , adc_val=> from [%d] to [%d] \n",
+			status_reg, pc->lsadc[1].pad0_adc_val,new_adc_val);
+			if( pc->lsadc[1].pad0_adc_val > new_adc_val ) {
+				pr_err(" lsadc1_interrupt_pad : pad0 adc became smaller! \n\n");
+			}
+			else {
+				pr_err(" lsadc1_interrupt_pad : pad0 adc became bigger! \n\n");
+			}
+			pc->lsadc[1].pad0_adc_val=new_adc_val;
+		}
+
+		if(pad1_int) {
+			new_adc_val = pad1_reg & LSADC1_PAD_MASK_ADC_VAL;
+			pr_err(" lsadc1_interrupt_pad : pad1 interrupt! status_reg=0x%x , adc_val=> from [%d] to [%d] \n",
+			status_reg, pc->lsadc[1].pad1_adc_val,new_adc_val);
+			if( pc->lsadc[1].pad1_adc_val > new_adc_val ) {
+				pr_err(" lsadc1_interrupt_pad : pad1 adc became smaller! \n\n");
+			}
+			else {
+				pr_err(" lsadc1_interrupt_pad : pad1 adc became bigger! \n\n");
+			}
+			pc->lsadc[1].pad1_adc_val=new_adc_val;
+		}
+
+		status_reg = status_reg | ( LSADC_STATUS_MASK_PAD0_STATUS | LSADC_STATUS_MASK_PAD1_STATUS);  // reset INT flag
+		LSADC_WRITEL(status_reg, LSADC1_STATUS_ADDR);
+
+		return IRQ_HANDLED;
+	}
+}
+#endif
+
+static ssize_t rtk_lsadc0_show_info(struct device *dev, struct device_attribute
+			      *devattr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint analog_ctrl_reg;
+	uint pad0_reg, pad1_reg;
+	uint lsadc_status_reg;
+	uint pad0_set[5], pad1_set[5];
+	char padBuffer[512], tmpBuf[64];
+	int isr_value=0;
+	int i=0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+	analog_ctrl_reg = LSADC_READL(LSADC0_ANALOG_CTRL_ADDR);
+
+	if( (ctrl_reg & LSADC_CTRL_MASK_ENABLE) == 0 ) {
+		ctrl_reg = ctrl_reg | LSADC_CTRL_MASK_ENABLE ;
+		LSADC_WRITEL(ctrl_reg, LSADC0_CTRL_ADDR);
+		pr_info("--- rtk_lsadc0_show_info  :    write ctrl_enable	ctrl_reg=0x%x  ---  \n",ctrl_reg);
+	}
+
+	pad0_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+	pad1_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+
+	pc->lsadc[0].pad0_adc_val = pad0_reg & LSADC0_PAD_MASK_ADC_VAL;
+	pc->lsadc[0].pad1_adc_val = pad1_reg & LSADC0_PAD_MASK_ADC_VAL;
+
+	strcpy(padBuffer, "info:\n");
+	for(i=0; i<5; i++) {
+		pad0_set[i] = LSADC_READL(LSADC0_PAD0_LEVEL_SET0_ADDR+(i*4));
+		pad1_set[i] = LSADC_READL(LSADC0_PAD1_LEVEL_SET0_ADDR+(i*4));
+		sprintf(tmpBuf, "set_idx=%d:pad0_set=0x%0x pad1_set=0x%0x\n",i, pad0_set[i],pad1_set[i]);
+		strcat(padBuffer, tmpBuf);
+	}
+
+	return sprintf(buf, "rtk_lsadc0_show_info--\n isr_value=0x%x \n ctrl_reg=0x%x \n lsadc_status_reg=0x%x\n analog_ctrl_reg=0x%x\n pad0_reg=0x%x\n pad1_reg=0x%x \n pad0_adc=0x%x\n pad1_adc=0x%x  \n %s" ,
+		isr_value, ctrl_reg ,lsadc_status_reg,analog_ctrl_reg ,pad0_reg,pad1_reg,pc->lsadc[0].pad0_adc_val ,pc->lsadc[0].pad1_adc_val ,padBuffer);
+}
+
+static ssize_t rtk_lsadc1_show_info(struct device *dev, struct device_attribute
+			      *devattr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint analog_ctrl_reg;
+	uint pad0_reg, pad1_reg;
+	uint lsadc_status_reg;
+	uint pad0_set[5], pad1_set[5];
+	char padBuffer[512], tmpBuf[64];
+	int isr_value=0;
+	int i=0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC1_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC1_STATUS_ADDR);
+	analog_ctrl_reg = LSADC_READL(LSADC1_ANALOG_CTRL_ADDR);
+
+	if( (ctrl_reg & LSADC_CTRL_MASK_ENABLE) == 0 ) {
+		ctrl_reg = ctrl_reg | LSADC_CTRL_MASK_ENABLE ;
+		LSADC_WRITEL(ctrl_reg, LSADC1_CTRL_ADDR);
+		pr_info("--- rtk_lsadc1_show_info  :    write ctrl_enable	ctrl_reg=0x%x  ---  \n",ctrl_reg);
+	}
+
+	pad0_reg = LSADC_READL(LSADC1_PAD0_ADDR);
+	pad1_reg = LSADC_READL(LSADC1_PAD1_ADDR);
+
+	pc->lsadc[1].pad0_adc_val = pad0_reg & LSADC1_PAD_MASK_ADC_VAL;
+	pc->lsadc[1].pad1_adc_val = pad1_reg & LSADC1_PAD_MASK_ADC_VAL;
+
+	strcpy(padBuffer, "info:\n");
+	for(i=0; i<5; i++) {
+		pad0_set[i] = LSADC_READL(LSADC1_PAD0_LEVEL_SET0_ADDR+(i*4));
+		pad1_set[i] = LSADC_READL(LSADC1_PAD1_LEVEL_SET0_ADDR+(i*4));
+		sprintf(tmpBuf, "set_idx=%d:pad0_set=0x%0x pad1_set=0x%0x\n",i, pad0_set[i],pad1_set[i]);
+		strcat(padBuffer, tmpBuf);
+	}
+
+	return sprintf(buf, "rtk_lsadc1_show_info--\n isr_value=0x%x \n ctrl_reg=0x%x \n lsadc_status_reg=0x%x\n analog_ctrl_reg=0x%x\n pad0_reg=0x%x\n pad1_reg=0x%x \n pad0_adc=0x%x\n pad1_adc=0x%x  \n %s" ,
+		isr_value, ctrl_reg ,lsadc_status_reg,analog_ctrl_reg ,pad0_reg,pad1_reg,pc->lsadc[1].pad0_adc_val ,pc->lsadc[1].pad1_adc_val ,padBuffer);
+}
+
+ssize_t rtk_lsadc0_show_debounce(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint lsadc_status_reg;
+	int isr_value = 0 ;
+	int debounce_cnt = 0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+
+	debounce_cnt = (ctrl_reg & LSADC0_CTRL_DEBOUNCE_MASK) >> 20;
+
+	pr_info("--- debug : rtk_lsadc0_show_debounce : ctrl_reg=0x%x, isr_value=0x%x, lsadc_status_reg=0x%x \n    debounce_cnt=%d (0~15) ---- \n",
+		ctrl_reg, isr_value, lsadc_status_reg, debounce_cnt);
+
+	return sprintf(buf, "%d\n", debounce_cnt);
+}
+
+ssize_t rtk_lsadc0_store_debounce(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint lsadc_status_reg;
+	int isr_value = 0 ;
+	int debounce_cnt = 0;
+	int value=0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+
+	debounce_cnt = ( ctrl_reg & LSADC0_CTRL_DEBOUNCE_MASK ) >> 20;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : rtk_lsadc0_store_debounce	====  buffer is null, return \n");
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : rtk_lsadc0_store_debounce : get value=%d \n", value);
+
+	if(debounce_cnt == value) {
+		pr_err("--- debug : rtk_lsadc0_store_debounce	====  the same, do nothing (value=%d) \n", value);
+		return count;
+	}
+	if(value > 15 || value < 0) {
+		pr_err("--- debug : rtk_lsadc0_store_debounce	====  value (%d) out of range, (valid data => 0-15) \n", value);
+		return count;
+	}
+
+	debounce_cnt = value;
+
+	ctrl_reg =(ctrl_reg & (~LSADC0_CTRL_DEBOUNCE_MASK))|(debounce_cnt << 20);
+	LSADC_WRITEL(ctrl_reg, LSADC0_CTRL_ADDR);
+	pr_err("--- debug : rtk_lsadc0_store0_debounce : write ctrl_reg=0x%x debounce_cnt=%d \n", ctrl_reg, debounce_cnt);
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+
+	pr_info("--- debug : rtk_lsadc0_store_debounce : ctrl_reg=0x%x, isr_value=0x%x, lsadc_status_reg=0x%x \n    debounce_cnt=%d ---- \n",
+		ctrl_reg, isr_value, lsadc_status_reg, debounce_cnt);
+
+	return count;
+}
+
+ssize_t rtk_lsadc1_show_debounce(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint lsadc_status_reg;
+	int isr_value = 0 ;
+	int debounce_cnt = 0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC1_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC1_STATUS_ADDR);
+
+	debounce_cnt = (ctrl_reg & LSADC1_CTRL_DEBOUNCE_MASK) >> 16;
+
+	pr_info("--- debug : rtk_lsadc1_show_debounce : ctrl_reg=0x%x, isr_value=0x%x, lsadc_status_reg=0x%x \n    debounce_cnt=%d (0~255) ---- \n",
+		ctrl_reg, isr_value, lsadc_status_reg, debounce_cnt);
+
+	return sprintf(buf, "%d\n", debounce_cnt);
+}
+
+ssize_t rtk_lsadc1_store_debounce(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint lsadc_status_reg;
+	int isr_value = 0 ;
+	int debounce_cnt = 0;
+	int value=0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC1_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC1_STATUS_ADDR);
+
+	debounce_cnt = (ctrl_reg & LSADC1_CTRL_DEBOUNCE_MASK) >> 16;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : rtk_lsadc1_store_debounce	====  buffer is null, return \n");
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : rtk_lsadc1_store_debounce : get value=%d \n", value);
+
+	if(debounce_cnt == value) {
+		pr_err("--- debug : rtk_lsadc1_store_debounce	====  the same, do nothing (value=%d) \n", value);
+		return count;
+	}
+	if(value > 255 || value < 0) {
+		pr_err("--- debug : rtk_lsadc1_store_debounce	====  value (%d) out of range, (valid data => 0-255) \n", value);
+		return count;
+	}
+
+	debounce_cnt = value;
+
+	ctrl_reg =(ctrl_reg & (~LSADC1_CTRL_DEBOUNCE_MASK))|(debounce_cnt << 16);
+	LSADC_WRITEL(ctrl_reg, LSADC1_CTRL_ADDR);
+	pr_err("--- debug : rtk_lsadc1_store0_debounce : write ctrl_reg=0x%x debounce_cnt=%d \n", ctrl_reg, debounce_cnt);
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC1_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC1_STATUS_ADDR);
+
+	pr_info("--- debug : rtk_lsadc1_store_debounce : ctrl_reg=0x%x, isr_value=0x%x, lsadc_status_reg=0x%x \n    debounce_cnt=%d ---- \n",
+		ctrl_reg, isr_value, lsadc_status_reg, debounce_cnt);
+
+	return count;
+}
+
+ssize_t rtk_lsadc0_show_threshold0(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+	uint pad_reg;
+	uint threshold;
+
+	pad_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+	threshold = (pad_reg & LSADC_PAD_MASK_THRESHOLD) >> 16;
+
+	pr_info("--- debug : %s : pad_reg = 0x%x\n    threshold = %d (0~63) ---- \n",
+		__func__, pad_reg, threshold);
+
+	return sprintf(buf, "%d\n", threshold);
+}
+
+ssize_t rtk_lsadc0_store_threshold0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+	uint pad_reg;
+	uint threshold;
+	int value = 0;
+
+	pad_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+
+	threshold = (pad_reg & LSADC_PAD_MASK_THRESHOLD) >> 16;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : %s ====  buffer is null, return \n", __func__);
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : %s : get value = %d \n", __func__, value);
+
+	if(threshold == value) {
+		pr_err("--- debug : %s ====  the same, do nothing (value = %d) \n", __func__, value);
+		return count;
+	}
+	if(value > 63 || value < 0) {
+		pr_err("--- debug : %s ====  value (%d) out of range, (valid data => 0-63) \n", __func__, value);
+		return count;
+	}
+
+	threshold = value;
+
+	pad_reg = (pad_reg & ~LSADC_PAD_MASK_THRESHOLD) | (threshold << 16);
+	LSADC_WRITEL(pad_reg, LSADC0_PAD0_ADDR);
+	pr_err("--- debug : %s : write pad_reg = 0x%x threshold = %d \n", __func__, pad_reg, threshold);
+
+	return count;
+}
+
+ssize_t rtk_lsadc0_show_threshold1(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+	uint pad_reg;
+	uint threshold;
+
+	pad_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+	threshold = (pad_reg & LSADC_PAD_MASK_THRESHOLD) >> 16;
+
+	pr_info("--- debug : %s : pad_reg = 0x%x\n    threshold = %d (0~63) ---- \n",
+		__func__, pad_reg, threshold);
+
+	return sprintf(buf, "%d\n", threshold);
+}
+
+ssize_t rtk_lsadc0_store_threshold1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+	uint pad_reg;
+	uint threshold;
+	int value = 0;
+
+	pad_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+
+	threshold = (pad_reg & LSADC_PAD_MASK_THRESHOLD) >> 16;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : %s ====  buffer is null, return \n", __func__);
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : %s : get value = %d \n", __func__, value);
+
+	if(threshold == value) {
+		pr_err("--- debug : %s ====  the same, do nothing (value = %d) \n", __func__, value);
+		return count;
+	}
+	if(value > 63 || value < 0) {
+		pr_err("--- debug : %s ====  value (%d) out of range, (valid data => 0-63) \n", __func__, value);
+		return count;
+	}
+
+	threshold = value;
+
+	pad_reg = (pad_reg & ~LSADC_PAD_MASK_THRESHOLD) | (threshold << 16);
+	LSADC_WRITEL(pad_reg, LSADC0_PAD1_ADDR);
+	pr_err("--- debug : %s : write pad_reg = 0x%x threshold = %d \n", __func__, pad_reg, threshold);
+
+	return count;
+}
+
+ssize_t rtk_lsadc1_show_vdd_gnd_sel(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint lsadc_status_reg;
+	int isr_value = 0 ;
+	int vdd_gnd_mode = 0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC1_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC1_STATUS_ADDR);
+
+	vdd_gnd_mode = (ctrl_reg & LSADC1_CTRL_VDD_GND_SEL_MASK) >> 4;
+
+	pr_info("--- debug : rtk_lsadc1_show_vdd_gnd_sel : ctrl_reg=0x%x, isr_value=0x%x, lsadc_status_reg=0x%x \n    vdd_gnd_mode=%d (0:disabled; 1:GND1/GND2; 2:disabled; 3:VDD1/VDD2) ---- \n",
+		ctrl_reg, isr_value, lsadc_status_reg, vdd_gnd_mode);
+
+	return sprintf(buf, "%d\n", vdd_gnd_mode);
+}
+
+ssize_t rtk_lsadc1_store_vdd_gnd_sel(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint lsadc_status_reg;
+	int isr_value = 0 ;
+	int vdd_gnd_mode = 0;
+	int value=0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC1_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC1_STATUS_ADDR);
+
+	vdd_gnd_mode = (ctrl_reg & LSADC1_CTRL_VDD_GND_SEL_MASK) >> 4;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : rtk_lsadc1_store_vdd_gnd_sel	====  buffer is null, return \n");
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : rtk_lsadc1_store_vdd_gnd_sel : get value=%d \n", value);
+
+	if(vdd_gnd_mode == value) {
+		pr_err("--- debug : rtk_lsadc1_store_vdd_gnd_sel	====  the same, do nothing (value=%d) \n", value);
+		return count;
+	}
+	if(value > 3 || value < 0) {
+		pr_err("--- debug : rtk_lsadc1_store_vdd_gnd_sel	====  value (%d) out of range, (valid data => 0-3) \n", value);
+		return count;
+	}
+
+	vdd_gnd_mode = value;
+
+	ctrl_reg =(ctrl_reg & (~LSADC1_CTRL_VDD_GND_SEL_MASK))|(vdd_gnd_mode << 4);
+	LSADC_WRITEL(ctrl_reg, LSADC1_CTRL_ADDR);
+	pr_err("--- debug : rtk_lsadc1_store_vdd_gnd_sel : write ctrl_reg=0x%x vdd_gnd_mode=%d \n", ctrl_reg, vdd_gnd_mode);
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC1_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC1_STATUS_ADDR);
+
+	pr_info("--- debug : rtk_lsadc1_store_vdd_gnd_sel : ctrl_reg=0x%x, isr_value=0x%x, lsadc_status_reg=0x%x \n    vdd_gnd_mode=%d ---- \n",
+		ctrl_reg, isr_value, lsadc_status_reg, vdd_gnd_mode);
+
+	return count;
+}
+
+ssize_t rtk_lsadc_show_vdd_mux_sel(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux_sel = 0;
+
+	vdd_mux_sel = (readl(pc->crt_lsadc_pg_addr) & CRT_LSADC_VDDMUX_SEL_MASK) >> CRT_LSADC_VDDMUX_SEL_OFFSET;
+
+	pr_info("--- debug : rtk_lsadc_show_vdd_mux_sel : vdd_mux_sel=%d (0:VDD1; 1:VDD2) ---- \n", vdd_mux_sel);
+
+	return sprintf(buf, "%d\n", vdd_mux_sel);
+}
+
+ssize_t rtk_lsadc_store_vdd_mux_sel(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux_sel = 0;
+	int value=0;
+	uint crt_lsadc_pg_val;
+
+	crt_lsadc_pg_val = readl(pc->crt_lsadc_pg_addr);
+	vdd_mux_sel = (crt_lsadc_pg_val & CRT_LSADC_VDDMUX_SEL_MASK) >> CRT_LSADC_VDDMUX_SEL_OFFSET;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux_sel	====  buffer is null, return \n");
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux_sel : get value=%d \n", value);
+
+	if(vdd_mux_sel == value) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux_sel	====  the same, do nothing (value=%d) \n", value);
+		return count;
+	}
+	if(value > 1 || value < 0) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux_sel	====  value (%d) out of range, (valid data => 0-1) \n", value);
+		return count;
+	}
+
+	vdd_mux_sel = value;
+
+	crt_lsadc_pg_val = (crt_lsadc_pg_val & (~CRT_LSADC_VDDMUX_SEL_MASK)) | (vdd_mux_sel << CRT_LSADC_VDDMUX_SEL_OFFSET);
+	pc->crt_lsadc_pg_val = crt_lsadc_pg_val;
+	writel(pc->crt_lsadc_pg_val, pc->crt_lsadc_pg_addr);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux_sel : write crt_lsadc_pg_val=0x%x vdd_mux_sel=%d \n", crt_lsadc_pg_val, vdd_mux_sel);
+
+	return count;
+}
+
+ssize_t rtk_lsadc_show_vdd_mux1(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux1 = 0;
+
+	vdd_mux1 = (readl(pc->crt_lsadc_pg_addr) & CRT_LSADC_VDD_MUX1_MASK) >> CRT_LSADC_VDD_MUX1_OFFSET;
+
+	pr_info("--- debug : rtk_lsadc_show_vdd_mux1 : vdd_mux1=%d (VDD1 input MUX select) ---- \n", vdd_mux1);
+
+	return sprintf(buf, "%d\n", vdd_mux1);
+}
+
+ssize_t rtk_lsadc_store_vdd_mux1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux1 = 0;
+	int value=0;
+	uint crt_lsadc_pg_val;
+
+	crt_lsadc_pg_val = readl(pc->crt_lsadc_pg_addr);
+	vdd_mux1 = (crt_lsadc_pg_val & CRT_LSADC_VDD_MUX1_MASK) >> CRT_LSADC_VDD_MUX1_OFFSET;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux1	====  buffer is null, return \n");
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux1 : get value=%d \n", value);
+
+	if(vdd_mux1 == value) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux1	====  the same, do nothing (value=%d) \n", value);
+		return count;
+	}
+	if(value > 15 || value < 0) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux1	====  value (%d) out of range, (valid data => 0-15) \n", value);
+		return count;
+	}
+
+	vdd_mux1 = value;
+
+	crt_lsadc_pg_val = (crt_lsadc_pg_val & (~CRT_LSADC_VDD_MUX1_MASK)) | (vdd_mux1 << CRT_LSADC_VDD_MUX1_OFFSET);
+	pc->crt_lsadc_pg_val = crt_lsadc_pg_val;
+	writel(pc->crt_lsadc_pg_val, pc->crt_lsadc_pg_addr);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux1 : write crt_lsadc_pg_val=0x%x vdd_mux1=%d \n", crt_lsadc_pg_val, vdd_mux1);
+
+	return count;
+}
+
+ssize_t rtk_lsadc_show_vdd_mux2(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux2 = 0;
+
+	vdd_mux2 = (readl(pc->crt_lsadc_pg_addr) & CRT_LSADC_VDD_MUX2_MASK) >> CRT_LSADC_VDD_MUX2_OFFSET;
+
+	pr_info("--- debug : rtk_lsadc_show_vdd_mux2 : vdd_mux2=%d (VDD2 input MUX select) ---- \n", vdd_mux2);
+
+	return sprintf(buf, "%d\n", vdd_mux2);
+}
+
+ssize_t rtk_lsadc_store_vdd_mux2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux2 = 0;
+	int value=0;
+	uint crt_lsadc_pg_val;
+
+	crt_lsadc_pg_val = readl(pc->crt_lsadc_pg_addr);
+	vdd_mux2 = (crt_lsadc_pg_val & CRT_LSADC_VDD_MUX2_MASK) >> CRT_LSADC_VDD_MUX2_OFFSET;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux2	====  buffer is null, return \n");
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux2 : get value=%d \n", value);
+
+	if(vdd_mux2 == value) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux2	====  the same, do nothing (value=%d) \n", value);
+		return count;
+	}
+	if(value > 15 || value < 0) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux2	====  value (%d) out of range, (valid data => 0-15) \n", value);
+		return count;
+	}
+
+	vdd_mux2 = value;
+
+	crt_lsadc_pg_val = (crt_lsadc_pg_val & (~CRT_LSADC_VDD_MUX2_MASK)) | (vdd_mux2 << CRT_LSADC_VDD_MUX2_OFFSET);
+	pc->crt_lsadc_pg_val = crt_lsadc_pg_val;
+	writel(pc->crt_lsadc_pg_val, pc->crt_lsadc_pg_addr);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux2 : write crt_lsadc_pg_val=0x%x vdd_mux2=%d \n", crt_lsadc_pg_val, vdd_mux2);
+
+	return count;
+}
+
+static DEVICE_ATTR(debounce0, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc0_show_debounce, rtk_lsadc0_store_debounce);
+static DEVICE_ATTR(debounce1, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc1_show_debounce, rtk_lsadc1_store_debounce);
+static DEVICE_ATTR(threshold00, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc0_show_threshold0, rtk_lsadc0_store_threshold0);
+static DEVICE_ATTR(threshold01, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc0_show_threshold1, rtk_lsadc0_store_threshold1);
+static DEVICE_ATTR(vdd_gnd_mode1, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc1_show_vdd_gnd_sel, rtk_lsadc1_store_vdd_gnd_sel);
+static DEVICE_ATTR(vdd_mux_sel, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc_show_vdd_mux_sel, rtk_lsadc_store_vdd_mux_sel);
+static DEVICE_ATTR(vdd_mux1, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc_show_vdd_mux1, rtk_lsadc_store_vdd_mux1);
+static DEVICE_ATTR(vdd_mux2, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc_show_vdd_mux2, rtk_lsadc_store_vdd_mux2);
+static DEVICE_ATTR(info0, S_IRUGO, rtk_lsadc0_show_info, NULL);
+static DEVICE_ATTR(info1, S_IRUGO, rtk_lsadc1_show_info, NULL);
+
+static struct attribute *rtk_attr_base[] = {
+	&dev_attr_info0.attr,
+	&dev_attr_info1.attr,
+	&dev_attr_debounce0.attr,
+	&dev_attr_debounce1.attr,
+	&dev_attr_threshold00.attr,
+	&dev_attr_threshold01.attr,
+	&dev_attr_vdd_gnd_mode1.attr,
+	&dev_attr_vdd_mux_sel.attr,
+	&dev_attr_vdd_mux1.attr,
+	&dev_attr_vdd_mux2.attr,
+	NULL
+};
+
+static const struct attribute_group rtk_group_base = {
+	.attrs = rtk_attr_base,
+};
+
+static int __init rtk_lsadc_probe(struct platform_device *pdev)
+{
+	struct rtk_lsadc_device *priv, *pc;
+	struct device_node *lsadc0_pad0_node, *lsadc0_pad1_node;
+	struct device_node *lsadc1_pad0_node, *lsadc1_pad1_node;
+	int ret = -EINVAL, val;
+	uint ctrl_reg;
+	uint analog_ctrl_reg;
+	uint pad0_reg, pad1_reg;
+	uint lsadc_status_reg;
+	uint irq_num0, irq_num1;
+	uint clk_gating_en[2], lsadc_power_reg;
+	uint vdd_mux_sel, vdd_mux1, vdd_mux2, vdd_mux_en;
+	#if defined(CONFIG_ARCH_RTD129x)
+	void __iomem *lsadc_clk_addr;
+	#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	struct clk *clk;
+	struct reset_control *rstc;
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+
+	pr_info("--- debug : rtk_lsadc_probe \n");
+
+	lsadc0_pad0_node = of_get_child_by_name(pdev->dev.of_node, "rtk-lsadc0-pad0");
+	if (!lsadc0_pad0_node) {
+		dev_err(&pdev->dev, "could not find [rtk-lsadc0-pad0] sub-node\n");
+		return -EINVAL;
+	}
+	lsadc0_pad1_node = of_get_child_by_name(pdev->dev.of_node, "rtk-lsadc0-pad1");
+	if (!lsadc0_pad1_node) {
+		dev_err(&pdev->dev, "could not find [rtk-lsadc0-pad1] sub-node\n");
+		return -EINVAL;
+	}
+
+	lsadc1_pad0_node = of_get_child_by_name(pdev->dev.of_node, "rtk-lsadc1-pad0");
+	if (!lsadc1_pad0_node) {
+		dev_err(&pdev->dev, "could not find [rtk-lsadc1-pad0] sub-node\n");
+		return -EINVAL;
+	}
+	lsadc1_pad1_node = of_get_child_by_name(pdev->dev.of_node, "rtk-lsadc1-pad1");
+	if (!lsadc1_pad1_node) {
+		dev_err(&pdev->dev, "could not find [rtk-lsadc1-pad1] sub-node\n");
+		return -EINVAL;
+	}
+
+	/* Request IRQ */
+	irq_num0 = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	irq_num1 = irq_of_parse_and_map(pdev->dev.of_node, 1);
+
+	pc = priv = devm_kzalloc(&pdev->dev, sizeof(*priv), GFP_KERNEL);
+	if (!priv) {
+		dev_err(&pdev->dev, "failed to allocate memory\n");
+		return -ENOMEM;
+	}
+
+	priv->dev = &pdev->dev;
+	priv->lsadc[0].irq = irq_num0;
+	priv->lsadc[1].irq = irq_num1;
+	priv->isr_addr = of_iomap(pdev->dev.of_node, 0);
+	priv->lsadc_addr = of_iomap(pdev->dev.of_node, 1);
+	priv->crt_lsadc_pg_addr = of_iomap(pdev->dev.of_node, 2);
+
+	platform_set_drvdata(pdev, priv);
+
+	if (!of_property_read_u32_array(pdev->dev.of_node, "clk_gating_en", clk_gating_en, 2)) {
+		priv->lsadc[0].clk_gating_en = clk_gating_en[0];
+		priv->lsadc[1].clk_gating_en = clk_gating_en[1];
+	}
+
+	// set CRT LSADC_PG from device tree
+	if (!of_property_read_u32(pdev->dev.of_node, "vdd_mux_sel", &vdd_mux_sel) &&
+			!of_property_read_u32(pdev->dev.of_node, "vdd_mux1", &vdd_mux1) &&
+			!of_property_read_u32(pdev->dev.of_node, "vdd_mux2", &vdd_mux2) &&
+			!of_property_read_u32(pdev->dev.of_node, "vdd_mux_en", &vdd_mux_en)) {
+		priv->crt_lsadc_pg_val = ((vdd_mux_sel << CRT_LSADC_VDDMUX_SEL_OFFSET) & CRT_LSADC_VDDMUX_SEL_MASK) |
+								 ((vdd_mux1 << CRT_LSADC_VDD_MUX1_OFFSET) & CRT_LSADC_VDD_MUX1_MASK) |
+								 ((vdd_mux2 << CRT_LSADC_VDD_MUX2_OFFSET) & CRT_LSADC_VDD_MUX2_MASK) |
+								 ((vdd_mux_en << CRT_LSADC_VDDMUX_EN_OFFSET) & CRT_LSADC_VDDMUX_EN_MASK);
+	} else {
+		priv->crt_lsadc_pg_val = CRT_LSADC_PG_VALUE;
+	}
+
+
+	// set LSADC0 pad0 from device tree : [pad_idx0]
+	if (!of_property_read_u32(lsadc0_pad0_node, "activate", &val))
+		priv->lsadc[0].padInfoSet[0].activate=val;
+
+	if (!of_property_read_u32(lsadc0_pad0_node, "ctrl_mode", &val))
+		priv->lsadc[0].padInfoSet[0].ctrl_mode=val;
+
+	if (!of_property_read_u32(lsadc0_pad0_node, "sw_idx", &val)){
+		if(val == 1)
+			priv->lsadc[0].padInfoSet[0].pad_sw=val;
+		else
+			priv->lsadc[0].padInfoSet[0].pad_sw=0;
+	}
+
+	if (!of_property_read_u32(lsadc0_pad0_node, "voltage_threshold", &val))
+		priv->lsadc[0].padInfoSet[0].threshold=val;
+
+	// set LSADC0 pad1 from device tree : [pad_idx1]
+	if (!of_property_read_u32(lsadc0_pad1_node, "activate", &val))
+		priv->lsadc[0].padInfoSet[1].activate=val;
+	else
+		priv->lsadc[0].padInfoSet[1].activate=0;
+
+	if (!of_property_read_u32(lsadc0_pad1_node, "ctrl_mode", &val))
+		priv->lsadc[0].padInfoSet[1].ctrl_mode=val;
+
+	if (!of_property_read_u32(lsadc0_pad1_node, "sw_idx", &val)){
+		if(val == 1)
+			priv->lsadc[0].padInfoSet[1].pad_sw=val;
+		else
+			priv->lsadc[0].padInfoSet[1].pad_sw=0;
+	}
+
+	if (!of_property_read_u32(lsadc0_pad1_node, "voltage_threshold", &val))
+		priv->lsadc[0].padInfoSet[1].threshold=val;
+
+
+	// set LSADC1 pad0 from device tree : [pad_idx0]
+	if (!of_property_read_u32(lsadc1_pad0_node, "activate", &val))
+		priv->lsadc[1].padInfoSet[0].activate=val;
+
+	if (!of_property_read_u32(lsadc1_pad0_node, "ctrl_mode", &val))
+		priv->lsadc[1].padInfoSet[0].ctrl_mode=val;
+
+	if (!of_property_read_u32(lsadc1_pad0_node, "sw_idx", &val)){
+		if(val == 1)
+			priv->lsadc[1].padInfoSet[0].pad_sw=val;
+		else
+			priv->lsadc[1].padInfoSet[0].pad_sw=0;
+	}
+
+	if (!of_property_read_u32(lsadc1_pad0_node, "voltage_threshold", &val))
+		priv->lsadc[1].padInfoSet[0].threshold=val;
+
+	if (!of_property_read_u32(lsadc1_pad0_node, "detect_range_ctrl", &val))
+		priv->lsadc[1].padInfoSet[0].vref_sel=val;
+
+	// set LSADC0 pad1 from device tree : [pad_idx1]
+	if (!of_property_read_u32(lsadc1_pad1_node, "activate", &val))
+		priv->lsadc[1].padInfoSet[1].activate=val;
+	else
+		priv->lsadc[1].padInfoSet[1].activate=0;
+
+	if (!of_property_read_u32(lsadc1_pad1_node, "ctrl_mode", &val))
+		priv->lsadc[1].padInfoSet[1].ctrl_mode=val;
+
+	if (!of_property_read_u32(lsadc1_pad1_node, "sw_idx", &val)){
+		if(val == 1)
+			priv->lsadc[1].padInfoSet[1].pad_sw=val;
+		else
+			priv->lsadc[1].padInfoSet[1].pad_sw=0;
+	}
+
+	if (!of_property_read_u32(lsadc1_pad1_node, "voltage_threshold", &val))
+		priv->lsadc[1].padInfoSet[1].threshold=val;
+
+	if (!of_property_read_u32(lsadc1_pad1_node, "detect_range_ctrl", &val))
+		priv->lsadc[1].padInfoSet[1].vref_sel=val;
+
+	#if defined(CONFIG_ARCH_RTD129x)
+	if (get_rtd_chip_revision() >= RTD_CHIP_B00) {
+		// Enable LSADC clock
+		lsadc_clk_addr = ioremap(CRT_LSADC_CLK_ADDR, 0x4);
+		val = readl(lsadc_clk_addr) | CRT_LSADC_CLK_EN_VALUE;
+		writel(val, lsadc_clk_addr);
+		__iounmap(lsadc_clk_addr);
+	}
+	#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	clk = clk_get(&pdev->dev, NULL);
+	if (IS_ERR(clk)) {
+		clk = NULL;
+		pr_err("can't get LSADC clock\n");
+	} else {
+		clk_prepare_enable(clk);
+	}
+
+
+	rstc = reset_control_get(&pdev->dev, NULL);
+	if (IS_ERR(rstc)) {
+		pr_err("can't get LSADC reset\n");
+	} else {
+		reset_control_deassert(rstc);
+		reset_control_put(rstc);
+	}
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+
+	lsadc_power_reg = LSADC_READL(LSADC0_POWER_ADDR) & ~(LSADC0_CLK_GATING_EN | LSADC1_CLK_GATING_EN);
+	if(priv->lsadc[0].clk_gating_en == 1)
+		lsadc_power_reg |= LSADC0_CLK_GATING_EN;
+	if(priv->lsadc[1].clk_gating_en == 1)
+		lsadc_power_reg |= LSADC1_CLK_GATING_EN;
+
+	LSADC_WRITEL(lsadc_power_reg, LSADC0_POWER_ADDR);
+	pr_info("--- debug :    write lsadc0_power_reg=0x%x  --  \n\n",lsadc_power_reg);
+
+	// Initial Ananlog_ctrl value to 0x00011101
+	LSADC_WRITEL(LSADC_ANALOG_CTRL_VALUE, LSADC0_ANALOG_CTRL_ADDR);
+	LSADC_WRITEL(LSADC_ANALOG_CTRL_VALUE, LSADC1_ANALOG_CTRL_ADDR);
+	mdelay(100);
+
+	//LSADC0
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	analog_ctrl_reg = LSADC_READL(LSADC0_ANALOG_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+	pad0_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+	pad1_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+
+	pr_err("--- debug :   from device tree: pad0=[activate=%d, ctrl_mode=%d, pad_sw=%d, threshold=%d]---  \n",
+			priv->lsadc[0].padInfoSet[0].activate, priv->lsadc[0].padInfoSet[0].ctrl_mode, priv->lsadc[0].padInfoSet[0].pad_sw, priv->lsadc[0].padInfoSet[0].threshold);
+	pr_err("--- debug :   from device tree: pad1=[activate=%d, ctrl_mode=%d, pad_sw=%d, threshold=%d]---  \n\n",
+			priv->lsadc[0].padInfoSet[1].activate, priv->lsadc[0].padInfoSet[1].ctrl_mode, priv->lsadc[0].padInfoSet[1].pad_sw, priv->lsadc[0].padInfoSet[1].threshold);
+
+	pr_err("--- debug :  current value =   ctrl_reg=0x%x, lsadc_status_reg=0x%x, pad0_reg=0x%x, pad1_reg=0x%x ---- \n",
+		ctrl_reg, lsadc_status_reg,pad0_reg,pad1_reg );
+
+	if( priv->lsadc[0].padInfoSet[0].activate==1) {
+		pad0_reg = pad0_reg | LSADC_PAD_MASK_ACTIVE ;
+		if( priv->lsadc[0].padInfoSet[0].ctrl_mode == 1 )
+			pad0_reg = pad0_reg | LSADC_PAD_MASK_CTRL;
+		else
+			pad0_reg = pad0_reg & ~(LSADC_PAD_MASK_CTRL);
+
+		if( priv->lsadc[0].padInfoSet[0].pad_sw == 1 )
+			pad0_reg = pad0_reg | LSADC_PAD_MASK_SW;
+		else
+			pad0_reg = pad0_reg & ~(LSADC_PAD_MASK_SW);
+
+		if(priv->lsadc[0].padInfoSet[0].threshold <=0xFF && priv->lsadc[0].padInfoSet[0].threshold >=0 )
+			pad0_reg = pad0_reg | (LSADC_PAD_MASK_THRESHOLD & (priv->lsadc[0].padInfoSet[0].threshold << 16 ));
+
+		LSADC_WRITEL(pad0_reg, LSADC0_PAD0_ADDR);
+		pr_info("--- debug :    write pad0_reg=0x%x ---  \n",pad0_reg);
+	}
+	if( priv->lsadc[0].padInfoSet[1].activate==1) {
+		pad1_reg = pad1_reg | LSADC_PAD_MASK_ACTIVE ;
+		if( priv->lsadc[0].padInfoSet[1].ctrl_mode == 1 )
+			pad1_reg = pad1_reg | LSADC_PAD_MASK_CTRL;
+		else
+			pad1_reg = pad1_reg & ~(LSADC_PAD_MASK_CTRL);
+
+		if( priv->lsadc[0].padInfoSet[1].pad_sw == 1 )
+			pad1_reg = pad1_reg | LSADC_PAD_MASK_SW;
+		else
+			pad1_reg = pad1_reg & ~(LSADC_PAD_MASK_SW);
+
+		if(priv->lsadc[0].padInfoSet[1].threshold <=0xFF && priv->lsadc[0].padInfoSet[1].threshold >=0 )
+			pad1_reg = pad1_reg | (LSADC_PAD_MASK_THRESHOLD & (priv->lsadc[0].padInfoSet[1].threshold << 16 ));
+
+		LSADC_WRITEL(pad1_reg, LSADC0_PAD1_ADDR);
+		pr_info("--- debug :    write pad1_reg=0x%x  ---  \n",pad1_reg);
+	}
+
+	ctrl_reg = ctrl_reg | LSADC_CTRL_MASK_ENABLE | LSADC0_CTRL_DEBOUNCE_CNT | LSADC_CTRL_MASK_SEL_WAIT ;
+	LSADC_WRITEL(ctrl_reg, LSADC0_CTRL_ADDR);
+	pr_err("--- debug :    rtk_lsadc0_probe	ctrl_reg=0x%x  irq_num=%d---  \n",ctrl_reg, irq_num0);
+
+	if( (lsadc_status_reg & LSADC_STATUS_MASK_IRQ_EN) != LSADC_STATUS_MASK_IRQ_EN ) {
+		lsadc_status_reg = lsadc_status_reg | LSADC_STATUS_MASK_IRQ_EN ;
+		LSADC_WRITEL(lsadc_status_reg, LSADC0_STATUS_ADDR);
+		pr_info("--- debug :    write lsadc_status_reg=0x%x  --  \n\n",lsadc_status_reg);
+	}
+
+#ifdef LSADC_IRQ_DEFINED
+
+	if (request_irq(priv->lsadc[0].irq, lsadc0_interrupt_pad, IRQF_SHARED, "lsadc0", priv)< 0)
+	{
+		pr_err("--- debug : unable to request LSADC0 irq#%d\n", priv->lsadc[0].irq);
+		goto err;
+	}
+	// Enable IRQ for pad0/pad1, set LSADC0_STATUS to 0x0300000
+	LSADC_WRITEL(LSADC_STATUS_ENABLE_IRQ, LSADC0_STATUS_ADDR);
+
+#endif // LSADC_IRQ_DEFINED
+
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+	analog_ctrl_reg = LSADC_READL(LSADC0_ANALOG_CTRL_ADDR);
+	pad0_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+	pad1_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+
+	priv->lsadc[0].pad0_adc_val = pad0_reg & LSADC0_PAD_MASK_ADC_VAL;
+	priv->lsadc[0].pad1_adc_val = pad1_reg & LSADC0_PAD_MASK_ADC_VAL;
+
+	pr_err("--- debug :  set value =   ctrl_reg=0x%x, lsadc_status_reg=0x%x, pad0_reg=0x%x, pad1_reg=0x%x ---- \n\n\n",
+		ctrl_reg, lsadc_status_reg, pad0_reg, pad1_reg);
+
+	//LSADC1
+	ctrl_reg = LSADC_READL(LSADC1_CTRL_ADDR);
+	analog_ctrl_reg = LSADC_READL(LSADC1_ANALOG_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC1_STATUS_ADDR);
+	pad0_reg = LSADC_READL(LSADC1_PAD0_ADDR);
+	pad1_reg = LSADC_READL(LSADC1_PAD1_ADDR);
+
+	pr_err("--- debug :   from device tree: pad0=[activate=%d, ctrl_mode=%d, pad_sw=%d, threshold=%d, vref_sel=%d]---  \n",
+			priv->lsadc[1].padInfoSet[0].activate, priv->lsadc[1].padInfoSet[0].ctrl_mode, priv->lsadc[1].padInfoSet[0].pad_sw, priv->lsadc[1].padInfoSet[0].threshold, priv->lsadc[1].padInfoSet[0].vref_sel);
+	pr_err("--- debug :   from device tree: pad1=[activate=%d, ctrl_mode=%d, pad_sw=%d, threshold=%d, vref_sel=%d]---  \n\n",
+			priv->lsadc[1].padInfoSet[1].activate, priv->lsadc[1].padInfoSet[1].ctrl_mode, priv->lsadc[1].padInfoSet[1].pad_sw, priv->lsadc[1].padInfoSet[1].threshold, priv->lsadc[1].padInfoSet[1].vref_sel);
+
+	pr_err("--- debug :  current value =   ctrl_reg=0x%x, lsadc_status_reg=0x%x, pad0_reg=0x%x, pad1_reg=0x%x ---- \n",
+		ctrl_reg, lsadc_status_reg,pad0_reg,pad1_reg );
+
+	if( priv->lsadc[1].padInfoSet[0].activate==1) {
+		pad0_reg = pad0_reg | LSADC_PAD_MASK_ACTIVE ;
+		if( priv->lsadc[1].padInfoSet[0].ctrl_mode == 1 )
+			pad0_reg = pad0_reg | LSADC_PAD_MASK_CTRL;
+		else
+			pad0_reg = pad0_reg & ~(LSADC_PAD_MASK_CTRL);
+
+		if( priv->lsadc[1].padInfoSet[0].pad_sw == 1 )
+			pad0_reg = pad0_reg | LSADC_PAD_MASK_SW;
+		else
+			pad0_reg = pad0_reg & ~(LSADC_PAD_MASK_SW);
+
+		if(priv->lsadc[1].padInfoSet[0].threshold <=0xFF && priv->lsadc[1].padInfoSet[0].threshold >=0 )
+			pad0_reg = pad0_reg | (LSADC_PAD_MASK_THRESHOLD & (priv->lsadc[1].padInfoSet[0].threshold << 16 ));
+
+		if( priv->lsadc[1].padInfoSet[0].vref_sel == 1 )
+			pad0_reg = pad0_reg | LSADC_PAD_MASK_VREF_SEL;
+		else
+			pad0_reg = pad0_reg & ~(LSADC_PAD_MASK_VREF_SEL);
+
+		LSADC_WRITEL(pad0_reg, LSADC1_PAD0_ADDR);
+		pr_info("--- debug :    write pad0_reg=0x%x ---  \n",pad0_reg);
+	}
+	if( priv->lsadc[1].padInfoSet[1].activate==1) {
+		pad1_reg = pad1_reg | LSADC_PAD_MASK_ACTIVE ;
+		if( priv->lsadc[1].padInfoSet[1].ctrl_mode == 1 )
+			pad1_reg = pad1_reg | LSADC_PAD_MASK_CTRL;
+		else
+			pad1_reg = pad1_reg & ~(LSADC_PAD_MASK_CTRL);
+
+		if( priv->lsadc[1].padInfoSet[1].pad_sw == 1 )
+			pad1_reg = pad1_reg | LSADC_PAD_MASK_SW;
+		else
+			pad1_reg = pad1_reg & ~(LSADC_PAD_MASK_SW);
+
+		if(priv->lsadc[1].padInfoSet[1].threshold <=0xFF && priv->lsadc[1].padInfoSet[1].threshold >=0 )
+			pad1_reg = pad1_reg | (LSADC_PAD_MASK_THRESHOLD & (priv->lsadc[1].padInfoSet[1].threshold << 16 ));
+
+		if( priv->lsadc[1].padInfoSet[1].vref_sel == 1 )
+			pad0_reg = pad1_reg | LSADC_PAD_MASK_VREF_SEL;
+		else
+			pad0_reg = pad1_reg & ~(LSADC_PAD_MASK_VREF_SEL);
+
+		LSADC_WRITEL(pad1_reg, LSADC1_PAD1_ADDR);
+		pr_info("--- debug :    write pad1_reg=0x%x  ---  \n",pad1_reg);
+	}
+
+	ctrl_reg = ctrl_reg | LSADC_CTRL_MASK_ENABLE | LSADC1_CTRL_DEBOUNCE_CNT | LSADC_CTRL_MASK_SEL_WAIT ;
+	LSADC_WRITEL(ctrl_reg, LSADC1_CTRL_ADDR);
+	pr_err("--- debug :    rtk_lsadc1_probe	ctrl_reg=0x%x  irq_num=%d---  \n",ctrl_reg, irq_num1);
+
+	if( (lsadc_status_reg & LSADC_STATUS_MASK_IRQ_EN) != LSADC_STATUS_MASK_IRQ_EN ) {
+		lsadc_status_reg = lsadc_status_reg | LSADC_STATUS_MASK_IRQ_EN ;
+		LSADC_WRITEL(lsadc_status_reg, LSADC1_STATUS_ADDR);
+		pr_info("--- debug :    write lsadc_status_reg=0x%x  --  \n\n",lsadc_status_reg);
+	}
+
+#ifdef LSADC_IRQ_DEFINED
+
+	if (request_irq(priv->lsadc[1].irq, lsadc1_interrupt_pad, IRQF_SHARED, "lsadc1", priv)< 0)
+	{
+		pr_err("--- debug : unable to request LSADC1 irq#%d\n", priv->lsadc[1].irq);
+		goto err;
+	}
+	// Enable IRQ for pad0/pad1, set LSADC1_STATUS to 0x0300000
+	LSADC_WRITEL(LSADC_STATUS_ENABLE_IRQ, LSADC1_STATUS_ADDR);
+
+#endif // LSADC_IRQ_DEFINED
+
+	ctrl_reg = LSADC_READL(LSADC1_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC1_STATUS_ADDR);
+	analog_ctrl_reg = LSADC_READL(LSADC1_ANALOG_CTRL_ADDR);
+	pad0_reg = LSADC_READL(LSADC1_PAD0_ADDR);
+	pad1_reg = LSADC_READL(LSADC1_PAD1_ADDR);
+
+	priv->lsadc[1].pad0_adc_val = pad0_reg & LSADC1_PAD_MASK_ADC_VAL;
+	priv->lsadc[1].pad1_adc_val = pad1_reg & LSADC1_PAD_MASK_ADC_VAL;
+
+	pr_err("--- debug :  set value =   ctrl_reg=0x%x, lsadc_status_reg=0x%x, pad0_reg=0x%x, pad1_reg=0x%x ---- \n",
+		ctrl_reg, lsadc_status_reg, pad0_reg, pad1_reg);
+
+	// Init CRT LSADC PG
+	writel(priv->crt_lsadc_pg_val, priv->crt_lsadc_pg_addr);
+	pr_err("--- debug :    write crt_lsadc_pg_val=0x%x  --  \n",priv->crt_lsadc_pg_val);
+
+	/* Register sysfs hooks */
+	ret = sysfs_create_group(&pdev->dev.kobj, &rtk_group_base);
+	if (ret)
+		goto out_err_register;
+
+	return 0;
+
+out_err_register:
+	pr_err("--- debug :    sysfs_create_group() failed, ret = %d\n", ret);
+	sysfs_remove_group(&pdev->dev.kobj, &rtk_group_base);
+err:
+	return ret;
+}
+
+static int rtk_lsadc_remove(struct platform_device *pdev)
+{
+	struct rtk_lsadc_device *priv = platform_get_drvdata(pdev);
+	sysfs_remove_group(&pdev->dev.kobj, &rtk_group_base);
+#ifdef LSADC_IRQ_DEFINED
+	free_irq(priv->lsadc[0].irq, priv);
+	free_irq(priv->lsadc[1].irq, priv);
+#endif
+	return 0;
+}
+
+static const struct of_device_id rtk_lsadc_of_match[] = {
+	{ .compatible = "realtek,rtk-lsadc" },
+	{ }
+};
+MODULE_DEVICE_TABLE(of, rtk_lsadc_of_match);
+
+
+static struct platform_driver rtk_lsadc_platform_driver = {
+	.driver		= {
+		.owner	= THIS_MODULE,
+		.name	= "rtk-lsadc",
+		.of_match_table = rtk_lsadc_of_match,
+	},
+	.probe 		= rtk_lsadc_probe,
+	.remove 	= rtk_lsadc_remove,
+};
+module_platform_driver(rtk_lsadc_platform_driver);
+
+MODULE_DESCRIPTION("RTK LSADC driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtk-lsadc");
+
+
diff --git a/drivers/iio/adc/rtk_lsadc.h b/drivers/iio/adc/rtk_lsadc.h
new file mode 100644
index 00000000..6936833
--- /dev/null
+++ b/drivers/iio/adc/rtk_lsadc.h
@@ -0,0 +1,289 @@
+/*
+ *
+ * Realtek Low Speed ADC driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ */
+
+#ifndef  __RTD1295_LSADC_H_
+#define  __RTD1295_LSADC_H_
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#if defined(CONFIG_ARCH_RTD129x)
+#define CRT_LSADC_CLK_ADDR                   (0x98000450)
+#define CRT_LSADC_CLK_EN_VALUE               (4)
+#endif /* CONFIG_ARCH_RTD129x */
+
+#define CRT_LSADC_PG_VALUE                   (0x00000002)
+#define CRT_LSADC_VDDMUX_EN_MASK             (0x00000002)
+#define CRT_LSADC_VDDMUX_EN_OFFSET           (1)
+#define CRT_LSADC_VDD_MUX2_MASK              (0x0000003C)
+#define CRT_LSADC_VDD_MUX2_OFFSET            (2)
+#define CRT_LSADC_VDD_MUX1_MASK              (0x000003C0)
+#define CRT_LSADC_VDD_MUX1_OFFSET            (6)
+#define CRT_LSADC_VDDMUX_SEL_MASK            (0x00000400)
+#define CRT_LSADC_VDDMUX_SEL_OFFSET          (10)
+
+#if defined(CONFIG_ARCH_RTD129x)
+#define ISR_MASK_LSADC0_INT              (0x00200000)
+#define ISR_MASK_LSADC1_INT              (0x00400000)
+#elif defined(CONFIG_ARCH_RTD139x)
+#define ISR_MASK_LSADC0_INT              (0x00010000)
+#define ISR_MASK_LSADC1_INT              (0x00020000)
+#elif defined(CONFIG_ARCH_RTD16xx)
+#define ISR_MASK_LSADC0_INT              (0x00000008)
+#define ISR_MASK_LSADC1_INT              (0x00000010)
+#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+
+
+//#define LSADC_ANALOG_CTRL_VALUE              (0x00011101)
+#define LSADC_ANALOG_CTRL_VALUE              (0x00000001)
+#define LSADC_STATUS_ENABLE_IRQ              (0x03000000)
+#define LSADC_CTRL_MASK_ENABLE               (0x00000001)
+#define LSADC_CTRL_MASK_SEL_WAIT             (0x80000000)
+#define LSADC0_CTRL_DEBOUNCE_CNT             (0x00800000)
+#define LSADC0_CTRL_DEBOUNCE_MASK            (0x00F00000)
+#define LSADC1_CTRL_DEBOUNCE_CNT             (0x00800000)
+#define LSADC1_CTRL_DEBOUNCE_MASK            (0x00FF0000)
+#define LSADC1_CTRL_VDD_GND_SEL_MASK         (0x00000030)
+
+#define LSADC1_CTRL_MASK_VDD_GND_EN          (0x00000010)
+#define LSADC1_CTRL_MASK_VDD_GND_SEL         (0x00000020)
+
+#define LSADC0_PAD0_ADDR                     (0x00000000)
+#define LSADC0_PAD1_ADDR                     (0x00000004)
+
+#define LSADC0_CTRL_ADDR                     (0x00000020)
+#define LSADC0_STATUS_ADDR                   (0x00000024)
+#define LSADC0_ANALOG_CTRL_ADDR              (0x00000028)
+//#define LSADC0_PERI_TOP_DEBUG_ADDR           (0x0000002c)
+
+#define LSADC0_PAD0_LEVEL_SET0_ADDR          (0x00000030)
+#define LSADC0_PAD0_LEVEL_SET1_ADDR          (0x00000034)
+#define LSADC0_PAD0_LEVEL_SET2_ADDR          (0x00000038)
+#define LSADC0_PAD0_LEVEL_SET3_ADDR          (0x0000003c)
+#define LSADC0_PAD0_LEVEL_SET4_ADDR          (0x00000040)
+#define LSADC0_PAD0_LEVEL_SET5_ADDR          (0x00000044)
+
+#define LSADC0_PAD1_LEVEL_SET0_ADDR          (0x00000048)
+#define LSADC0_PAD1_LEVEL_SET1_ADDR          (0x0000004c)
+#define LSADC0_PAD1_LEVEL_SET2_ADDR          (0x00000050)
+#define LSADC0_PAD1_LEVEL_SET3_ADDR          (0x00000054)
+#define LSADC0_PAD1_LEVEL_SET4_ADDR          (0x00000058)
+#define LSADC0_PAD1_LEVEL_SET5_ADDR          (0x0000005c)
+
+//#define LSADC0_INT_PAD0_ADDR                 (0x00000078)
+//#define LSADC0_INT_PAD1_ADDR                 (0x0000007c)
+#define LSADC0_POWER_ADDR                    (0x00000080)
+#define LSADC0_CLK_GATING_EN                 (0x00000001)
+#define LSADC1_CLK_GATING_EN                 (0x00000002)
+
+#define LSADC0_PAD_MASK_ACTIVE               (0x80000000)
+#define LSADC0_PAD_MASK_THRESHOLD            (0x00FF0000)
+#define LSADC0_PAD_MASK_SW                   (0x00001000)
+#define LSADC0_PAD_MASK_CTRL                 (0x00000100)
+#define LSADC0_PAD_MASK_ADC_VAL              (0x0000003F)
+#define LSADC1_PAD_MASK_ADC_VAL              (0x0000007F)
+
+
+#define LSADC1_PAD0_ADDR                     (0x00000100)
+#define LSADC1_PAD1_ADDR                     (0x00000104)
+
+#define LSADC1_CTRL_ADDR                     (0x00000120)
+#define LSADC1_STATUS_ADDR                   (0x00000124)
+#define LSADC1_ANALOG_CTRL_ADDR              (0x00000128)
+//#define LSADC1_PERI_TOP_DEBUG_ADDR           (0x0000012c)
+
+#define LSADC1_PAD0_LEVEL_SET0_ADDR          (0x00000130)
+#define LSADC1_PAD0_LEVEL_SET1_ADDR          (0x00000134)
+#define LSADC1_PAD0_LEVEL_SET2_ADDR          (0x00000138)
+#define LSADC1_PAD0_LEVEL_SET3_ADDR          (0x0000013c)
+#define LSADC1_PAD0_LEVEL_SET4_ADDR          (0x00000140)
+#define LSADC1_PAD0_LEVEL_SET5_ADDR          (0x00000144)
+
+#define LSADC1_PAD1_LEVEL_SET0_ADDR          (0x00000148)
+#define LSADC1_PAD1_LEVEL_SET1_ADDR          (0x0000014c)
+#define LSADC1_PAD1_LEVEL_SET2_ADDR          (0x00000150)
+#define LSADC1_PAD1_LEVEL_SET3_ADDR          (0x00000154)
+#define LSADC1_PAD1_LEVEL_SET4_ADDR          (0x00000158)
+#define LSADC1_PAD1_LEVEL_SET5_ADDR          (0x0000015c)
+
+//#define LSADC1_INT_PAD0_ADDR                 (0x00000178)
+//#define LSADC1_INT_PAD1_ADDR                 (0x0000017c)
+#define LSADC1_POWER_ADDR                    (0x00000180)
+
+// define LSADC0_STATUS and LSADC1_STATUS MASK
+#define LSADC_STATUS_MASK_PAD0_STATUS       (0x00000001)
+#define LSADC_STATUS_MASK_PAD1_STATUS       (0x00000002)
+#define LSADC_STATUS_MASK_PAD_CTRL_0        (0x00001000)
+#define LSADC_STATUS_MASK_PAD_CTRL_4        (0x00010000)
+#define LSADC_STATUS_MASK_ADC_BUSY          (0x00080000)
+#define LSADC_STATUS_MASK_PAD_CNT           (0x00F00000)
+#define LSADC_STATUS_MASK_IRQ_EN            (0x03000000)
+
+// define LSADC0_PAD0/LSADC0_PAD1/LSADC1_PAD0/LSADC1_PAD1 MASK
+#define LSADC_PAD_MASK_ACTIVE               (0x80000000)
+#define LSADC_PAD_MASK_VREF_SEL             (0x01000000)
+#define LSADC_PAD_MASK_THRESHOLD            (0x00FF0000)
+#define LSADC_PAD_MASK_SW                   (0x00001000)
+#define LSADC_PAD_MASK_CTRL                 (0x00000100)
+
+#ifndef LITTLE_ENDIAN	// apply BIG_ENDIAN
+typedef union
+{
+	unsigned int     regValue;
+	struct
+	{
+		unsigned int     sel_wait:4;
+		unsigned int     sel_adc_ck:4;
+		unsigned int     debounce_cnt:4;
+		unsigned int     reserved_0:4;
+		unsigned int     dout_test_in:8;
+		unsigned int     reserved_1:6;
+		unsigned int     test_en:1;
+		unsigned int     enable:1;
+	};
+} ST_LSADC0_ctrl;
+
+typedef union
+{
+	unsigned int     regValue;
+	struct
+	{
+		unsigned int     reserved_0:14;
+		unsigned int     jd_sbias:2;
+		unsigned int     reserved_1:2;
+		unsigned int     jd_adsbias:2;
+		unsigned int     jd_dummy:2;
+		unsigned int     reserved_2:1;
+		unsigned int     jd_svr:1;
+		unsigned int     reserved_3:3;
+		unsigned int     jd_adcksel:1;
+		unsigned int     reserved_4:3;
+		unsigned int     jd_power:1;
+	};
+} ST_LSADC0_analog_ctrl;
+
+typedef union
+{
+	unsigned int		regValue;
+	struct
+	{
+		unsigned int     pad_active:1;
+		unsigned int     reserved_0:7;
+		unsigned int     pad_thred:8;
+		unsigned int     pad_sw:4;
+		unsigned int     reserved_1:3;
+		unsigned int     pad_ctrl:1;
+		unsigned int     reserved_2:2;
+		unsigned int     adc_val:6;
+	};
+} ST_LSADC0_pad;
+
+typedef union
+{
+	unsigned int		regValue;
+	struct
+	{
+		unsigned int     irq_en:8;
+		unsigned int     pad_cnt:4;
+		unsigned int     adc_busy:1;
+		unsigned int     reserved_0:2;
+		unsigned int     pad_ctrl:5;
+		unsigned int     reserved_1:10;
+		unsigned int     pad1_status:1;
+		unsigned int     pad0_status:1;
+	};
+} ST_LSADC0_status;
+
+
+#else	// apply LITTLE_ENDIAN
+
+typedef union
+{
+	unsigned int     regValue;
+	struct
+	{
+		unsigned int     enable:1;
+		unsigned int     test_en:1;
+		unsigned int     reserved_1:6;
+		unsigned int     dout_test_in:8;
+		unsigned int     reserved_0:4;
+		unsigned int     debounce_cnt:4;
+		unsigned int     sel_adc_ck:4;
+		unsigned int     sel_wait:4;
+	};
+} ST_LSADC0_ctrl;
+
+typedef union
+{
+	unsigned int     regValue;
+	struct
+	{
+		unsigned int     jd_power:1;
+		unsigned int     reserved_4:3;
+		unsigned int     jd_adcksel:1;
+		unsigned int     reserved_3:3;
+		unsigned int     jd_svr:1;
+		unsigned int     reserved_2:1;
+		unsigned int     jd_dummy:2;
+		unsigned int     jd_adsbias:2;
+		unsigned int     reserved_1:2;
+		unsigned int     jd_sbias:2;
+		unsigned int     reserved_0:14;
+	};
+} ST_LSADC0_analog_ctrl;
+
+typedef union
+{
+	unsigned int     regValue;
+	struct
+	{
+		unsigned int     adc_val:6;
+		unsigned int     reserved_2:2;
+		unsigned int     pad_ctrl:1;
+		unsigned int     reserved_1:3;
+		unsigned int     pad_sw:4;
+		unsigned int     pad_thred:8;
+		unsigned int     reserved_0:7;
+		unsigned int     pad_active:1;
+	};
+} ST_LSADC0_pad;
+
+typedef union
+{
+	unsigned int		regValue;
+	struct
+	{
+		unsigned int     pad0_status:1;
+		unsigned int     pad1_status:1;
+		unsigned int     reserved_1:10;
+		unsigned int     pad_ctrl:5;
+		unsigned int     reserved_0:2;
+		unsigned int     adc_busy:1;
+		unsigned int     pad_cnt:4;
+		unsigned int     irq_en:8;
+	};
+} ST_LSADC0_status;
+
+
+
+#endif
+
+extern int lsadc_init(int index, int voltage_mode);
+extern int lsdac_get(int index);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif//__RTD1295_LSADC_H_
+
diff --git a/drivers/iio/adc/rtk_lsadc_rtd13xx.c b/drivers/iio/adc/rtk_lsadc_rtd13xx.c
new file mode 100644
index 00000000..f89db5d
--- /dev/null
+++ b/drivers/iio/adc/rtk_lsadc_rtd13xx.c
@@ -0,0 +1,806 @@
+/*
+ * Realtek Low Speed ADC driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+///////////////////////////////////////////////////////////////////////////////////////////////////////////
+#include <linux/platform_device.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/hwmon.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/err.h>
+#include <linux/of.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/interrupt.h>
+#include <linux/delay.h>
+
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+#include <linux/reset.h>
+
+#include "rtk_lsadc_rtd13xx.h"
+
+/*
+#define rtd_inb(offset)			(*(volatile unsigned char *)(offset))
+#define rtd_inw(offset)			(*(volatile unsigned short *)(offset))
+#define rtd_inl(offset)			(*(volatile unsigned long *)(offset))
+
+#define rtd_outb(offset,val)	(*(volatile unsigned char *)(offset) = val)
+#define rtd_outw(offset,val)	(*(volatile unsigned short *)(offset) = val)
+#define rtd_outl(offset,val)	(*(volatile unsigned long *)(offset) = val)
+*/
+#define LSADC_IRQ_DEFINED 	(1)
+#define SA_SHIRQ		IRQF_SHARED
+#define LSADC_READL(reg)        readl((void __iomem *)(reg + (uintptr_t)(pc->lsadc_addr)))
+#define LSADC_WRITEL(val, reg)  writel(val, (void __iomem *)(reg + (uintptr_t)(pc->lsadc_addr)))
+
+struct rtk_lsadc_pad_info {
+	uint			activate;
+	uint			ctrl_mode;
+	uint			pad_sw;
+	uint			threshold;
+	uint			vref_sel;
+};
+
+struct rtk_lsadc_info {
+	struct rtk_lsadc_pad_info	padInfoSet[2];
+	uint				pad0_adc_val;
+	uint				pad1_adc_val;
+	uint				irq;
+	uint				clk_gating_en;
+};
+
+struct rtk_lsadc_device {
+	struct device			*dev;
+	struct rtk_lsadc_info		lsadc[1];
+	uint				crt_lsadc_pg_val;
+	void __iomem			*crt_lsadc_pg_addr;
+	void __iomem			*isr_addr;
+	void __iomem			*lsadc_addr;
+};
+
+#ifdef LSADC_IRQ_DEFINED
+static irqreturn_t lsadc0_interrupt_pad(int irq, void *dev)
+{
+	struct rtk_lsadc_device *pc = dev;
+	uint status_reg;
+	uint pad0_reg, pad1_reg;
+	uint pad0_int, pad1_int;
+	uint new_adc_val=0;
+	int interrupt_flag=0;
+
+	interrupt_flag = ISR_MASK_LSADC0_INT & readl(pc->isr_addr);
+
+	{
+		status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+
+		pad0_int = LSADC_STATUS_MASK_PAD0_STATUS & status_reg;
+		pad1_int = LSADC_STATUS_MASK_PAD1_STATUS & status_reg;
+
+		pad0_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+		pad1_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+		pr_err("--- lsadc0_interrupt_pad :  pad0_adc=0x%0x, pad1_adc=0x%0x \n",pc->lsadc[0].pad0_adc_val,pc->lsadc[0].pad1_adc_val);
+
+		if(pad0_int) {
+			new_adc_val = pad0_reg & LSADC0_PAD_MASK_ADC_VAL;
+			pr_err(" lsadc0_interrupt_pad : pad0 interrupt! status_reg=0x%x , adc_val=> from [%d] to [%d] \n",
+			status_reg, pc->lsadc[0].pad0_adc_val,new_adc_val);
+			if( pc->lsadc[0].pad0_adc_val > new_adc_val ) {
+				pr_err(" lsadc0_interrupt_pad : pad0 adc became smaller! \n\n");
+			}
+			else {
+				pr_err(" lsadc0_interrupt_pad : pad0 adc became bigger! \n\n");
+			}
+			pc->lsadc[0].pad0_adc_val=new_adc_val;
+		}
+
+		if(pad1_int) {
+			new_adc_val = pad1_reg & LSADC0_PAD_MASK_ADC_VAL;
+			pr_err(" lsadc0_interrupt_pad : pad1 interrupt! status_reg=0x%x , adc_val=> from [%d] to [%d] \n",
+			status_reg, pc->lsadc[0].pad1_adc_val,new_adc_val);
+			if( pc->lsadc[0].pad1_adc_val > new_adc_val ) {
+				pr_err(" lsadc0_interrupt_pad : pad1 adc became smaller! \n\n");
+			}
+			else {
+				pr_err(" lsadc0_interrupt_pad : pad1 adc became bigger! \n\n");
+			}
+			pc->lsadc[0].pad1_adc_val=new_adc_val;
+		}
+
+		status_reg = status_reg | ( LSADC_STATUS_MASK_PAD0_STATUS | LSADC_STATUS_MASK_PAD1_STATUS);  // reset INT flag
+		LSADC_WRITEL(status_reg, LSADC0_STATUS_ADDR);
+
+		return IRQ_HANDLED;
+	}
+}
+#endif
+
+static ssize_t rtk_lsadc0_show_info(struct device *dev, struct device_attribute
+			      *devattr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint analog_ctrl_reg;
+	uint pad0_reg, pad1_reg;
+	uint lsadc_status_reg;
+	uint pad0_set[5], pad1_set[5];
+	char padBuffer[512], tmpBuf[64];
+	int isr_value=0;
+	int i=0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+	analog_ctrl_reg = LSADC_READL(LSADC0_ANALOG_CTRL_ADDR);
+
+	if( (ctrl_reg & LSADC_CTRL_MASK_ENABLE) == 0 ) {
+		ctrl_reg = ctrl_reg | LSADC_CTRL_MASK_ENABLE ;
+		LSADC_WRITEL(ctrl_reg, LSADC0_CTRL_ADDR);
+		pr_info("--- rtk_lsadc0_show_info  :    write ctrl_enable	ctrl_reg=0x%x  ---  \n",ctrl_reg);
+	}
+
+	pad0_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+	pad1_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+
+	pc->lsadc[0].pad0_adc_val = pad0_reg & LSADC0_PAD_MASK_ADC_VAL;
+	pc->lsadc[0].pad1_adc_val = pad1_reg & LSADC0_PAD_MASK_ADC_VAL;
+
+	strcpy(padBuffer, "info:\n");
+	for(i=0; i<5; i++) {
+		pad0_set[i] = LSADC_READL(LSADC0_PAD0_LEVEL_SET0_ADDR+(i*4));
+		pad1_set[i] = LSADC_READL(LSADC0_PAD1_LEVEL_SET0_ADDR+(i*4));
+		sprintf(tmpBuf, "set_idx=%d:pad0_set=0x%0x pad1_set=0x%0x\n",i, pad0_set[i],pad1_set[i]);
+		strcat(padBuffer, tmpBuf);
+	}
+
+	return sprintf(buf, "rtk_lsadc0_show_info--\n isr_value=0x%x \n ctrl_reg=0x%x \n lsadc_status_reg=0x%x\n analog_ctrl_reg=0x%x\n pad0_reg=0x%x\n pad1_reg=0x%x \n pad0_adc=0x%x\n pad1_adc=0x%x  \n %s" ,
+		isr_value, ctrl_reg ,lsadc_status_reg,analog_ctrl_reg ,pad0_reg,pad1_reg,pc->lsadc[0].pad0_adc_val ,pc->lsadc[0].pad1_adc_val ,padBuffer);
+}
+
+ssize_t rtk_lsadc0_show_debounce(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint lsadc_status_reg;
+	int isr_value = 0 ;
+	int debounce_cnt = 0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+
+	debounce_cnt = (ctrl_reg & LSADC0_CTRL_DEBOUNCE_MASK) >> 20;
+
+	pr_info("--- debug : rtk_lsadc0_show_debounce : ctrl_reg=0x%x, isr_value=0x%x, lsadc_status_reg=0x%x \n    debounce_cnt=%d (0~15) ---- \n",
+		ctrl_reg, isr_value, lsadc_status_reg, debounce_cnt);
+
+	return sprintf(buf, "%d\n", debounce_cnt);
+}
+
+ssize_t rtk_lsadc0_store_debounce(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	uint ctrl_reg;
+	uint lsadc_status_reg;
+	int isr_value = 0 ;
+	int debounce_cnt = 0;
+	int value = 0;
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+
+	debounce_cnt = ( ctrl_reg & LSADC0_CTRL_DEBOUNCE_MASK ) >> 20;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : rtk_lsadc0_store_debounce	====  buffer is null, return \n");
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : rtk_lsadc0_store_debounce : get value=%d \n", value);
+
+	if(debounce_cnt == value) {
+		pr_err("--- debug : rtk_lsadc0_store_debounce	====  the same, do nothing (value=%d) \n", value);
+		return count;
+	}
+	if(value > 15 || value < 0) {
+		pr_err("--- debug : rtk_lsadc0_store_debounce	====  value (%d) out of range, (valid data => 0-15) \n", value);
+		return count;
+	}
+
+	debounce_cnt = value;
+
+	ctrl_reg =(ctrl_reg & (~LSADC0_CTRL_DEBOUNCE_MASK))|(debounce_cnt << 20);
+	LSADC_WRITEL(ctrl_reg, LSADC0_CTRL_ADDR);
+	pr_err("--- debug : rtk_lsadc0_store0_debounce : write ctrl_reg=0x%x debounce_cnt=%d \n", ctrl_reg, debounce_cnt);
+
+	isr_value = readl(pc->isr_addr);
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+
+	pr_info("--- debug : rtk_lsadc0_store_debounce : ctrl_reg=0x%x, isr_value=0x%x, lsadc_status_reg=0x%x \n    debounce_cnt=%d ---- \n",
+		ctrl_reg, isr_value, lsadc_status_reg, debounce_cnt);
+
+	return count;
+}
+
+ssize_t rtk_lsadc0_show_threshold0(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+	uint pad_reg;
+	uint threshold;
+
+	pad_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+	threshold = (pad_reg & LSADC_PAD_MASK_THRESHOLD) >> 16;
+
+	pr_info("--- debug : %s : pad_reg = 0x%x\n    threshold = %d (0~63) ---- \n",
+		__func__, pad_reg, threshold);
+
+	return sprintf(buf, "%d\n", threshold);
+}
+
+ssize_t rtk_lsadc0_store_threshold0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+	uint pad_reg;
+	uint threshold;
+	int value = 0;
+
+	pad_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+
+	threshold = (pad_reg & LSADC_PAD_MASK_THRESHOLD) >> 16;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : %s ====  buffer is null, return \n", __func__);
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : %s : get value = %d \n", __func__, value);
+
+	if(threshold == value) {
+		pr_err("--- debug : %s ====  the same, do nothing (value = %d) \n", __func__, value);
+		return count;
+	}
+	if(value > 63 || value < 0) {
+		pr_err("--- debug : %s ====  value (%d) out of range, (valid data => 0-63) \n", __func__, value);
+		return count;
+	}
+
+	threshold = value;
+
+	pad_reg = (pad_reg & ~LSADC_PAD_MASK_THRESHOLD) | (threshold << 16);
+	LSADC_WRITEL(pad_reg, LSADC0_PAD0_ADDR);
+	pr_err("--- debug : %s : write pad_reg = 0x%x threshold = %d \n", __func__, pad_reg, threshold);
+
+	return count;
+}
+
+ssize_t rtk_lsadc0_show_threshold1(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+	uint pad_reg;
+	uint threshold;
+
+	pad_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+	threshold = (pad_reg & LSADC_PAD_MASK_THRESHOLD) >> 16;
+
+	pr_info("--- debug : %s : pad_reg = 0x%x\n    threshold = %d (0~63) ---- \n",
+		__func__, pad_reg, threshold);
+
+	return sprintf(buf, "%d\n", threshold);
+}
+
+ssize_t rtk_lsadc0_store_threshold1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+	uint pad_reg;
+	uint threshold;
+	int value = 0;
+
+	pad_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+
+	threshold = (pad_reg & LSADC_PAD_MASK_THRESHOLD) >> 16;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : %s ====  buffer is null, return \n", __func__);
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : %s : get value = %d \n", __func__, value);
+
+	if(threshold == value) {
+		pr_err("--- debug : %s ====  the same, do nothing (value = %d) \n", __func__, value);
+		return count;
+	}
+	if(value > 63 || value < 0) {
+		pr_err("--- debug : %s ====  value (%d) out of range, (valid data => 0-63) \n", __func__, value);
+		return count;
+	}
+
+	threshold = value;
+
+	pad_reg = (pad_reg & ~LSADC_PAD_MASK_THRESHOLD) | (threshold << 16);
+	LSADC_WRITEL(pad_reg, LSADC0_PAD1_ADDR);
+	pr_err("--- debug : %s : write pad_reg = 0x%x threshold = %d \n", __func__, pad_reg, threshold);
+
+	return count;
+}
+
+ssize_t rtk_lsadc_show_vdd_mux_sel(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux_sel = 0;
+
+	vdd_mux_sel = (readl(pc->crt_lsadc_pg_addr) & CRT_LSADC_VDDMUX_SEL_MASK) >> CRT_LSADC_VDDMUX_SEL_OFFSET;
+
+	pr_info("--- debug : rtk_lsadc_show_vdd_mux_sel : vdd_mux_sel=%d (0:VDD1; 1:VDD2) ---- \n", vdd_mux_sel);
+
+	return sprintf(buf, "%d\n", vdd_mux_sel);
+}
+
+ssize_t rtk_lsadc_store_vdd_mux_sel(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux_sel = 0;
+	int value=0;
+	uint crt_lsadc_pg_val;
+
+	crt_lsadc_pg_val = readl(pc->crt_lsadc_pg_addr);
+	vdd_mux_sel = (crt_lsadc_pg_val & CRT_LSADC_VDDMUX_SEL_MASK) >> CRT_LSADC_VDDMUX_SEL_OFFSET;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux_sel	====  buffer is null, return \n");
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux_sel : get value=%d \n", value);
+
+	if(vdd_mux_sel == value) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux_sel	====  the same, do nothing (value=%d) \n", value);
+		return count;
+	}
+	if(value > 1 || value < 0) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux_sel	====  value (%d) out of range, (valid data => 0-1) \n", value);
+		return count;
+	}
+
+	vdd_mux_sel = value;
+
+	crt_lsadc_pg_val = (crt_lsadc_pg_val & (~CRT_LSADC_VDDMUX_SEL_MASK)) | (vdd_mux_sel << CRT_LSADC_VDDMUX_SEL_OFFSET);
+	pc->crt_lsadc_pg_val = crt_lsadc_pg_val;
+	writel(pc->crt_lsadc_pg_val, pc->crt_lsadc_pg_addr);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux_sel : write crt_lsadc_pg_val=0x%x vdd_mux_sel=%d \n", crt_lsadc_pg_val, vdd_mux_sel);
+
+	return count;
+}
+
+ssize_t rtk_lsadc_show_vdd_mux1(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux1 = 0;
+
+	vdd_mux1 = (readl(pc->crt_lsadc_pg_addr) & CRT_LSADC_VDD_MUX1_MASK) >> CRT_LSADC_VDD_MUX1_OFFSET;
+
+	pr_info("--- debug : rtk_lsadc_show_vdd_mux1 : vdd_mux1=%d (VDD1 input MUX select) ---- \n", vdd_mux1);
+
+	return sprintf(buf, "%d\n", vdd_mux1);
+}
+
+ssize_t rtk_lsadc_store_vdd_mux1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux1 = 0;
+	int value=0;
+	uint crt_lsadc_pg_val;
+
+	crt_lsadc_pg_val = readl(pc->crt_lsadc_pg_addr);
+	vdd_mux1 = (crt_lsadc_pg_val & CRT_LSADC_VDD_MUX1_MASK) >> CRT_LSADC_VDD_MUX1_OFFSET;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux1	====  buffer is null, return \n");
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux1 : get value=%d \n", value);
+
+	if(vdd_mux1 == value) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux1	====  the same, do nothing (value=%d) \n", value);
+		return count;
+	}
+	if(value > 15 || value < 0) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux1	====  value (%d) out of range, (valid data => 0-15) \n", value);
+		return count;
+	}
+
+	vdd_mux1 = value;
+
+	crt_lsadc_pg_val = (crt_lsadc_pg_val & (~CRT_LSADC_VDD_MUX1_MASK)) | (vdd_mux1 << CRT_LSADC_VDD_MUX1_OFFSET);
+	pc->crt_lsadc_pg_val = crt_lsadc_pg_val;
+	writel(pc->crt_lsadc_pg_val, pc->crt_lsadc_pg_addr);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux1 : write crt_lsadc_pg_val=0x%x vdd_mux1=%d \n", crt_lsadc_pg_val, vdd_mux1);
+
+	return count;
+}
+
+ssize_t rtk_lsadc_show_vdd_mux2(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux2 = 0;
+
+	vdd_mux2 = (readl(pc->crt_lsadc_pg_addr) & CRT_LSADC_VDD_MUX2_MASK) >> CRT_LSADC_VDD_MUX2_OFFSET;
+
+	pr_info("--- debug : rtk_lsadc_show_vdd_mux2 : vdd_mux2=%d (VDD2 input MUX select) ---- \n", vdd_mux2);
+
+	return sprintf(buf, "%d\n", vdd_mux2);
+}
+
+ssize_t rtk_lsadc_store_vdd_mux2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_lsadc_device *pc = platform_get_drvdata(pdev);
+
+	int vdd_mux2 = 0;
+	int value=0;
+	uint crt_lsadc_pg_val;
+
+	crt_lsadc_pg_val = readl(pc->crt_lsadc_pg_addr);
+	vdd_mux2 = (crt_lsadc_pg_val & CRT_LSADC_VDD_MUX2_MASK) >> CRT_LSADC_VDD_MUX2_OFFSET;
+
+	if(buf ==NULL) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux2	====  buffer is null, return \n");
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux2 : get value=%d \n", value);
+
+	if(vdd_mux2 == value) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux2	====  the same, do nothing (value=%d) \n", value);
+		return count;
+	}
+	if(value > 15 || value < 0) {
+		pr_err("--- debug : rtk_lsadc_store_vdd_mux2	====  value (%d) out of range, (valid data => 0-15) \n", value);
+		return count;
+	}
+
+	vdd_mux2 = value;
+
+	crt_lsadc_pg_val = (crt_lsadc_pg_val & (~CRT_LSADC_VDD_MUX2_MASK)) | (vdd_mux2 << CRT_LSADC_VDD_MUX2_OFFSET);
+	pc->crt_lsadc_pg_val = crt_lsadc_pg_val;
+	writel(pc->crt_lsadc_pg_val, pc->crt_lsadc_pg_addr);
+
+	pr_err("--- debug : rtk_lsadc_store_vdd_mux2 : write crt_lsadc_pg_val=0x%x vdd_mux2=%d \n", crt_lsadc_pg_val, vdd_mux2);
+
+	return count;
+}
+
+static DEVICE_ATTR(debounce0, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc0_show_debounce, rtk_lsadc0_store_debounce);
+static DEVICE_ATTR(threshold00, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc0_show_threshold0, rtk_lsadc0_store_threshold0);
+static DEVICE_ATTR(threshold01, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc0_show_threshold1, rtk_lsadc0_store_threshold1);
+static DEVICE_ATTR(vdd_mux_sel, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc_show_vdd_mux_sel, rtk_lsadc_store_vdd_mux_sel);
+static DEVICE_ATTR(vdd_mux1, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc_show_vdd_mux1, rtk_lsadc_store_vdd_mux1);
+static DEVICE_ATTR(vdd_mux2, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), rtk_lsadc_show_vdd_mux2, rtk_lsadc_store_vdd_mux2);
+static DEVICE_ATTR(info0, S_IRUGO, rtk_lsadc0_show_info, NULL);
+
+static struct attribute *rtk_attr_base[] = {
+	&dev_attr_info0.attr,
+	&dev_attr_debounce0.attr,
+	&dev_attr_threshold00.attr,
+	&dev_attr_threshold01.attr,
+	&dev_attr_vdd_mux_sel.attr,
+	&dev_attr_vdd_mux1.attr,
+	&dev_attr_vdd_mux2.attr,
+	NULL
+};
+
+static const struct attribute_group rtk_group_base = {
+	.attrs = rtk_attr_base,
+};
+
+static int __init rtk_lsadc_probe(struct platform_device *pdev)
+{
+	struct rtk_lsadc_device *priv, *pc;
+	struct device_node *lsadc0_pad0_node, *lsadc0_pad1_node;
+	int ret = -EINVAL, val;
+	uint ctrl_reg;
+	uint analog_ctrl_reg;
+	uint pad0_reg, pad1_reg;
+	uint lsadc_status_reg;
+	uint irq_num;
+	uint clk_gating_en, lsadc_power_reg;
+	uint vdd_mux_sel, vdd_mux1, vdd_mux2, vdd_mux_en;
+	struct clk *clk;
+	struct reset_control *rstc;
+
+	pr_info("--- debug : rtk_lsadc_probe \n");
+
+	lsadc0_pad0_node = of_get_child_by_name(pdev->dev.of_node, "rtk-lsadc0-pad0");
+	if (!lsadc0_pad0_node) {
+		dev_err(&pdev->dev, "could not find [rtk-lsadc0-pad0] sub-node\n");
+		return -EINVAL;
+	}
+	lsadc0_pad1_node = of_get_child_by_name(pdev->dev.of_node, "rtk-lsadc0-pad1");
+	if (!lsadc0_pad1_node) {
+		dev_err(&pdev->dev, "could not find [rtk-lsadc0-pad1] sub-node\n");
+		return -EINVAL;
+	}
+
+	/* Request IRQ */
+	irq_num = irq_of_parse_and_map(pdev->dev.of_node, 0);
+
+	pc = priv = devm_kzalloc(&pdev->dev, sizeof(*priv), GFP_KERNEL);
+	if (!priv) {
+		dev_err(&pdev->dev, "failed to allocate memory\n");
+		return -ENOMEM;
+	}
+
+	priv->dev = &pdev->dev;
+	priv->lsadc[0].irq = irq_num;
+	priv->isr_addr = of_iomap(pdev->dev.of_node, 0);
+	priv->lsadc_addr = of_iomap(pdev->dev.of_node, 1);
+	priv->crt_lsadc_pg_addr = of_iomap(pdev->dev.of_node, 2);
+
+	platform_set_drvdata(pdev, priv);
+
+	if (!of_property_read_u32(pdev->dev.of_node, "clk_gating_en", &clk_gating_en)) {
+		priv->lsadc[0].clk_gating_en = clk_gating_en;
+	}
+
+	// set CRT LSADC_PG from device tree
+	if (!of_property_read_u32(pdev->dev.of_node, "vdd_mux_sel", &vdd_mux_sel) &&
+			!of_property_read_u32(pdev->dev.of_node, "vdd_mux1", &vdd_mux1) &&
+			!of_property_read_u32(pdev->dev.of_node, "vdd_mux2", &vdd_mux2) &&
+			!of_property_read_u32(pdev->dev.of_node, "vdd_mux_en", &vdd_mux_en)) {
+		priv->crt_lsadc_pg_val = ((vdd_mux_sel << CRT_LSADC_VDDMUX_SEL_OFFSET) & CRT_LSADC_VDDMUX_SEL_MASK) |
+								 ((vdd_mux1 << CRT_LSADC_VDD_MUX1_OFFSET) & CRT_LSADC_VDD_MUX1_MASK) |
+								 ((vdd_mux2 << CRT_LSADC_VDD_MUX2_OFFSET) & CRT_LSADC_VDD_MUX2_MASK) |
+								 ((vdd_mux_en << CRT_LSADC_VDDMUX_EN_OFFSET) & CRT_LSADC_VDDMUX_EN_MASK);
+	} else {
+		priv->crt_lsadc_pg_val = CRT_LSADC_PG_VALUE;
+	}
+
+
+	// set LSADC0 pad0 from device tree : [pad_idx0]
+	if (!of_property_read_u32(lsadc0_pad0_node, "activate", &val))
+		priv->lsadc[0].padInfoSet[0].activate=val;
+
+	if (!of_property_read_u32(lsadc0_pad0_node, "ctrl_mode", &val))
+		priv->lsadc[0].padInfoSet[0].ctrl_mode=val;
+
+	if (!of_property_read_u32(lsadc0_pad0_node, "sw_idx", &val)){
+		if(val == 1)
+			priv->lsadc[0].padInfoSet[0].pad_sw=val;
+		else
+			priv->lsadc[0].padInfoSet[0].pad_sw=0;
+	}
+
+	if (!of_property_read_u32(lsadc0_pad0_node, "voltage_threshold", &val))
+		priv->lsadc[0].padInfoSet[0].threshold=val;
+
+	// set LSADC0 pad1 from device tree : [pad_idx1]
+	if (!of_property_read_u32(lsadc0_pad1_node, "activate", &val))
+		priv->lsadc[0].padInfoSet[1].activate=val;
+	else
+		priv->lsadc[0].padInfoSet[1].activate=0;
+
+	if (!of_property_read_u32(lsadc0_pad1_node, "ctrl_mode", &val))
+		priv->lsadc[0].padInfoSet[1].ctrl_mode=val;
+
+	if (!of_property_read_u32(lsadc0_pad1_node, "sw_idx", &val)){
+		if(val == 1)
+			priv->lsadc[0].padInfoSet[1].pad_sw=val;
+		else
+			priv->lsadc[0].padInfoSet[1].pad_sw=0;
+	}
+
+	if (!of_property_read_u32(lsadc0_pad1_node, "voltage_threshold", &val))
+		priv->lsadc[0].padInfoSet[1].threshold=val;
+
+
+	clk = clk_get(&pdev->dev, NULL);
+	if (IS_ERR(clk)) {
+		clk = NULL;
+		pr_err("can't get LSADC clock\n");
+	} else {
+		clk_prepare_enable(clk);
+	}
+
+
+	rstc = reset_control_get(&pdev->dev, NULL);
+	if (IS_ERR(rstc)) {
+		pr_err("can't get LSADC reset\n");
+	} else {
+		reset_control_deassert(rstc);
+		reset_control_put(rstc);
+	}
+
+	lsadc_power_reg = LSADC_READL(LSADC0_POWER_ADDR) & ~(LSADC0_CLK_GATING_EN);
+	if(priv->lsadc[0].clk_gating_en == 1)
+		lsadc_power_reg |= LSADC0_CLK_GATING_EN;
+
+	LSADC_WRITEL(lsadc_power_reg, LSADC0_POWER_ADDR);
+	pr_info("--- debug :    write lsadc0_power_reg=0x%x  --  \n\n",lsadc_power_reg);
+
+	// Initial Ananlog_ctrl value to 0x00011101
+	LSADC_WRITEL(LSADC_ANALOG_CTRL_VALUE, LSADC0_ANALOG_CTRL_ADDR);
+	mdelay(100);
+
+	//LSADC0
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	analog_ctrl_reg = LSADC_READL(LSADC0_ANALOG_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+	pad0_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+	pad1_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+
+	pr_err("--- debug :   from device tree: pad0=[activate=%d, ctrl_mode=%d, pad_sw=%d, threshold=%d]---  \n",
+			priv->lsadc[0].padInfoSet[0].activate, priv->lsadc[0].padInfoSet[0].ctrl_mode, priv->lsadc[0].padInfoSet[0].pad_sw, priv->lsadc[0].padInfoSet[0].threshold);
+	pr_err("--- debug :   from device tree: pad1=[activate=%d, ctrl_mode=%d, pad_sw=%d, threshold=%d]---  \n\n",
+			priv->lsadc[0].padInfoSet[1].activate, priv->lsadc[0].padInfoSet[1].ctrl_mode, priv->lsadc[0].padInfoSet[1].pad_sw, priv->lsadc[0].padInfoSet[1].threshold);
+
+	pr_err("--- debug :  current value =   ctrl_reg=0x%x, lsadc_status_reg=0x%x, pad0_reg=0x%x, pad1_reg=0x%x ---- \n",
+		ctrl_reg, lsadc_status_reg,pad0_reg,pad1_reg );
+
+	if( priv->lsadc[0].padInfoSet[0].activate==1) {
+		pad0_reg = pad0_reg | LSADC_PAD_MASK_ACTIVE ;
+		if( priv->lsadc[0].padInfoSet[0].ctrl_mode == 1 )
+			pad0_reg = pad0_reg | LSADC_PAD_MASK_CTRL;
+		else
+			pad0_reg = pad0_reg & ~(LSADC_PAD_MASK_CTRL);
+
+		if( priv->lsadc[0].padInfoSet[0].pad_sw == 1 )
+			pad0_reg = pad0_reg | LSADC_PAD_MASK_SW;
+		else
+			pad0_reg = pad0_reg & ~(LSADC_PAD_MASK_SW);
+
+		if(priv->lsadc[0].padInfoSet[0].threshold <=0xFF && priv->lsadc[0].padInfoSet[0].threshold >=0 )
+			pad0_reg = pad0_reg | (LSADC_PAD_MASK_THRESHOLD & (priv->lsadc[0].padInfoSet[0].threshold << 16 ));
+
+		LSADC_WRITEL(pad0_reg, LSADC0_PAD0_ADDR);
+		pr_info("--- debug :    write pad0_reg=0x%x ---  \n",pad0_reg);
+	}
+	if( priv->lsadc[0].padInfoSet[1].activate==1) {
+		pad1_reg = pad1_reg | LSADC_PAD_MASK_ACTIVE ;
+		if( priv->lsadc[0].padInfoSet[1].ctrl_mode == 1 )
+			pad1_reg = pad1_reg | LSADC_PAD_MASK_CTRL;
+		else
+			pad1_reg = pad1_reg & ~(LSADC_PAD_MASK_CTRL);
+
+		if( priv->lsadc[0].padInfoSet[1].pad_sw == 1 )
+			pad1_reg = pad1_reg | LSADC_PAD_MASK_SW;
+		else
+			pad1_reg = pad1_reg & ~(LSADC_PAD_MASK_SW);
+
+		if(priv->lsadc[0].padInfoSet[1].threshold <=0xFF && priv->lsadc[0].padInfoSet[1].threshold >=0 )
+			pad1_reg = pad1_reg | (LSADC_PAD_MASK_THRESHOLD & (priv->lsadc[0].padInfoSet[1].threshold << 16 ));
+
+		LSADC_WRITEL(pad1_reg, LSADC0_PAD1_ADDR);
+		pr_info("--- debug :    write pad1_reg=0x%x  ---  \n",pad1_reg);
+	}
+
+	ctrl_reg = ctrl_reg | LSADC_CTRL_MASK_ENABLE | LSADC0_CTRL_DEBOUNCE_CNT | LSADC_CTRL_MASK_SEL_WAIT ;
+	LSADC_WRITEL(ctrl_reg, LSADC0_CTRL_ADDR);
+	pr_err("--- debug :    rtk_lsadc0_probe	ctrl_reg=0x%x  irq_num=%d---  \n",ctrl_reg, irq_num);
+
+	if( (lsadc_status_reg & LSADC_STATUS_MASK_IRQ_EN) != LSADC_STATUS_MASK_IRQ_EN ) {
+		lsadc_status_reg = lsadc_status_reg | LSADC_STATUS_MASK_IRQ_EN ;
+		LSADC_WRITEL(lsadc_status_reg, LSADC0_STATUS_ADDR);
+		pr_info("--- debug :    write lsadc_status_reg=0x%x  --  \n\n",lsadc_status_reg);
+	}
+
+#ifdef LSADC_IRQ_DEFINED
+
+	if (request_irq(priv->lsadc[0].irq, lsadc0_interrupt_pad, IRQF_SHARED, "lsadc0", priv)< 0)
+	{
+		pr_err("--- debug : unable to request LSADC0 irq#%d\n", priv->lsadc[0].irq);
+		goto err;
+	}
+	// Enable IRQ for pad0/pad1, set LSADC0_STATUS to 0x0300000
+	LSADC_WRITEL(LSADC_STATUS_ENABLE_IRQ, LSADC0_STATUS_ADDR);
+
+#endif // LSADC_IRQ_DEFINED
+
+	ctrl_reg = LSADC_READL(LSADC0_CTRL_ADDR);
+	lsadc_status_reg = LSADC_READL(LSADC0_STATUS_ADDR);
+	analog_ctrl_reg = LSADC_READL(LSADC0_ANALOG_CTRL_ADDR);
+	pad0_reg = LSADC_READL(LSADC0_PAD0_ADDR);
+	pad1_reg = LSADC_READL(LSADC0_PAD1_ADDR);
+
+	priv->lsadc[0].pad0_adc_val = pad0_reg & LSADC0_PAD_MASK_ADC_VAL;
+	priv->lsadc[0].pad1_adc_val = pad1_reg & LSADC0_PAD_MASK_ADC_VAL;
+
+	pr_err("--- debug :  set value =   ctrl_reg=0x%x, lsadc_status_reg=0x%x, pad0_reg=0x%x, pad1_reg=0x%x ---- \n\n\n",
+		ctrl_reg, lsadc_status_reg, pad0_reg, pad1_reg);
+
+	// Init CRT LSADC PG
+	writel(priv->crt_lsadc_pg_val, priv->crt_lsadc_pg_addr);
+	pr_err("--- debug :    write crt_lsadc_pg_val=0x%x  --  \n",priv->crt_lsadc_pg_val);
+
+	/* Register sysfs hooks */
+	ret = sysfs_create_group(&pdev->dev.kobj, &rtk_group_base);
+	if (ret)
+		goto out_err_register;
+
+	return 0;
+
+out_err_register:
+	pr_err("--- debug :    sysfs_create_group() failed, ret = %d\n", ret);
+	sysfs_remove_group(&pdev->dev.kobj, &rtk_group_base);
+err:
+	return ret;
+}
+
+static int rtk_lsadc_remove(struct platform_device *pdev)
+{
+	struct rtk_lsadc_device *priv = platform_get_drvdata(pdev);
+	sysfs_remove_group(&pdev->dev.kobj, &rtk_group_base);
+#ifdef LSADC_IRQ_DEFINED
+	free_irq(priv->lsadc[0].irq, priv);
+#endif
+	return 0;
+}
+
+static const struct of_device_id rtk_lsadc_of_match[] = {
+	{ .compatible = "realtek,rtk-lsadc" },
+	{ }
+};
+MODULE_DEVICE_TABLE(of, rtk_lsadc_of_match);
+
+
+static struct platform_driver rtk_lsadc_platform_driver = {
+	.driver		= {
+		.owner	= THIS_MODULE,
+		.name	= "rtk-lsadc",
+		.of_match_table = rtk_lsadc_of_match,
+	},
+	.probe 		= rtk_lsadc_probe,
+	.remove 	= rtk_lsadc_remove,
+};
+module_platform_driver(rtk_lsadc_platform_driver);
+
+MODULE_DESCRIPTION("RTK LSADC driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtk-lsadc");
+
+
diff --git a/drivers/iio/adc/rtk_lsadc_rtd13xx.h b/drivers/iio/adc/rtk_lsadc_rtd13xx.h
new file mode 100644
index 00000000..e8fe3a8
--- /dev/null
+++ b/drivers/iio/adc/rtk_lsadc_rtd13xx.h
@@ -0,0 +1,240 @@
+/*
+ *
+ * Realtek Low Speed ADC driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ */
+
+#ifndef  __RTD13xx_LSADC_H_
+#define  __RTD13xx_LSADC_H_
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define CRT_LSADC_PG_VALUE                   (0x00000002)
+#define CRT_LSADC_VDDMUX_EN_MASK             (0x00000002)
+#define CRT_LSADC_VDDMUX_EN_OFFSET           (1)
+#define CRT_LSADC_VDD_MUX2_MASK              (0x0000003C)
+#define CRT_LSADC_VDD_MUX2_OFFSET            (2)
+#define CRT_LSADC_VDD_MUX1_MASK              (0x000003C0)
+#define CRT_LSADC_VDD_MUX1_OFFSET            (6)
+#define CRT_LSADC_VDDMUX_SEL_MASK            (0x00000400)
+#define CRT_LSADC_VDDMUX_SEL_OFFSET          (10)
+
+#define ISR_MASK_LSADC0_INT              (0x00000008)
+
+
+#define LSADC_ANALOG_CTRL_VALUE              (0x00000001)
+#define LSADC_STATUS_ENABLE_IRQ              (0x03000000)
+#define LSADC_CTRL_MASK_ENABLE               (0x00000001)
+#define LSADC_CTRL_MASK_SEL_WAIT             (0x80000000)
+#define LSADC0_CTRL_DEBOUNCE_CNT             (0x00800000)
+#define LSADC0_CTRL_DEBOUNCE_MASK            (0x00F00000)
+
+#define LSADC0_PAD0_ADDR                     (0x00000000)
+#define LSADC0_PAD1_ADDR                     (0x00000004)
+
+#define LSADC0_CTRL_ADDR                     (0x00000020)
+#define LSADC0_STATUS_ADDR                   (0x00000024)
+#define LSADC0_ANALOG_CTRL_ADDR              (0x00000028)
+//#define LSADC0_PERI_TOP_DEBUG_ADDR           (0x0000002c)
+
+#define LSADC0_PAD0_LEVEL_SET0_ADDR          (0x00000030)
+#define LSADC0_PAD0_LEVEL_SET1_ADDR          (0x00000034)
+#define LSADC0_PAD0_LEVEL_SET2_ADDR          (0x00000038)
+#define LSADC0_PAD0_LEVEL_SET3_ADDR          (0x0000003c)
+#define LSADC0_PAD0_LEVEL_SET4_ADDR          (0x00000040)
+#define LSADC0_PAD0_LEVEL_SET5_ADDR          (0x00000044)
+
+#define LSADC0_PAD1_LEVEL_SET0_ADDR          (0x00000048)
+#define LSADC0_PAD1_LEVEL_SET1_ADDR          (0x0000004c)
+#define LSADC0_PAD1_LEVEL_SET2_ADDR          (0x00000050)
+#define LSADC0_PAD1_LEVEL_SET3_ADDR          (0x00000054)
+#define LSADC0_PAD1_LEVEL_SET4_ADDR          (0x00000058)
+#define LSADC0_PAD1_LEVEL_SET5_ADDR          (0x0000005c)
+
+//#define LSADC0_INT_PAD0_ADDR                 (0x00000078)
+//#define LSADC0_INT_PAD1_ADDR                 (0x0000007c)
+#define LSADC0_POWER_ADDR                    (0x00000080)
+#define LSADC0_CLK_GATING_EN                 (0x00000001)
+
+#define LSADC0_PAD_MASK_ACTIVE               (0x80000000)
+#define LSADC0_PAD_MASK_THRESHOLD            (0x003F0000)
+#define LSADC0_PAD_MASK_SW                   (0x00001000)
+#define LSADC0_PAD_MASK_CTRL                 (0x00000100)
+#define LSADC0_PAD_MASK_ADC_VAL              (0x0000003F)
+
+
+// define LSADC0_STATUS STATUS MASK
+#define LSADC_STATUS_MASK_PAD0_STATUS       (0x00000001)
+#define LSADC_STATUS_MASK_PAD1_STATUS       (0x00000002)
+#define LSADC_STATUS_MASK_PAD_CTRL_0        (0x00001000)
+#define LSADC_STATUS_MASK_PAD_CTRL_4        (0x00010000)
+#define LSADC_STATUS_MASK_ADC_BUSY          (0x00080000)
+#define LSADC_STATUS_MASK_PAD_CNT           (0x00F00000)
+#define LSADC_STATUS_MASK_IRQ_EN            (0x03000000)
+
+// define LSADC0_PAD0/LSADC0_PAD1A MASK
+#define LSADC_PAD_MASK_ACTIVE               (0x80000000)
+#define LSADC_PAD_MASK_VREF_SEL             (0x01000000)
+#define LSADC_PAD_MASK_THRESHOLD            (0x00FF0000)
+#define LSADC_PAD_MASK_SW                   (0x00001000)
+#define LSADC_PAD_MASK_CTRL                 (0x00000100)
+
+#ifndef LITTLE_ENDIAN	// apply BIG_ENDIAN
+typedef union
+{
+	unsigned int     regValue;
+	struct
+	{
+		unsigned int     sel_wait:4;
+		unsigned int     sel_adc_ck:4;
+		unsigned int     debounce_cnt:4;
+		unsigned int     reserved_0:4;
+		unsigned int     dout_test_in:8;
+		unsigned int     reserved_1:6;
+		unsigned int     test_en:1;
+		unsigned int     enable:1;
+	};
+} ST_LSADC0_ctrl;
+
+typedef union
+{
+	unsigned int     regValue;
+	struct
+	{
+		unsigned int     reserved_0:14;
+		unsigned int     jd_sbias:2;
+		unsigned int     reserved_1:2;
+		unsigned int     jd_adsbias:2;
+		unsigned int     jd_dummy:2;
+		unsigned int     reserved_2:1;
+		unsigned int     jd_svr:1;
+		unsigned int     reserved_3:3;
+		unsigned int     jd_adcksel:1;
+		unsigned int     reserved_4:3;
+		unsigned int     jd_power:1;
+	};
+} ST_LSADC0_analog_ctrl;
+
+typedef union
+{
+	unsigned int		regValue;
+	struct
+	{
+		unsigned int     pad_active:1;
+		unsigned int     reserved_0:7;
+		unsigned int     pad_thred:8;
+		unsigned int     pad_sw:4;
+		unsigned int     reserved_1:3;
+		unsigned int     pad_ctrl:1;
+		unsigned int     reserved_2:2;
+		unsigned int     adc_val:6;
+	};
+} ST_LSADC0_pad;
+
+typedef union
+{
+	unsigned int		regValue;
+	struct
+	{
+		unsigned int     irq_en:8;
+		unsigned int     pad_cnt:4;
+		unsigned int     adc_busy:1;
+		unsigned int     reserved_0:2;
+		unsigned int     pad_ctrl:5;
+		unsigned int     reserved_1:10;
+		unsigned int     pad1_status:1;
+		unsigned int     pad0_status:1;
+	};
+} ST_LSADC0_status;
+
+
+#else	// apply LITTLE_ENDIAN
+
+typedef union
+{
+	unsigned int     regValue;
+	struct
+	{
+		unsigned int     enable:1;
+		unsigned int     test_en:1;
+		unsigned int     reserved_1:6;
+		unsigned int     dout_test_in:8;
+		unsigned int     reserved_0:4;
+		unsigned int     debounce_cnt:4;
+		unsigned int     sel_adc_ck:4;
+		unsigned int     sel_wait:4;
+	};
+} ST_LSADC0_ctrl;
+
+typedef union
+{
+	unsigned int     regValue;
+	struct
+	{
+		unsigned int     jd_power:1;
+		unsigned int     reserved_4:3;
+		unsigned int     jd_adcksel:1;
+		unsigned int     reserved_3:3;
+		unsigned int     jd_svr:1;
+		unsigned int     reserved_2:1;
+		unsigned int     jd_dummy:2;
+		unsigned int     jd_adsbias:2;
+		unsigned int     reserved_1:2;
+		unsigned int     jd_sbias:2;
+		unsigned int     reserved_0:14;
+	};
+} ST_LSADC0_analog_ctrl;
+
+typedef union
+{
+	unsigned int     regValue;
+	struct
+	{
+		unsigned int     adc_val:6;
+		unsigned int     reserved_2:2;
+		unsigned int     pad_ctrl:1;
+		unsigned int     reserved_1:3;
+		unsigned int     pad_sw:4;
+		unsigned int     pad_thred:8;
+		unsigned int     reserved_0:7;
+		unsigned int     pad_active:1;
+	};
+} ST_LSADC0_pad;
+
+typedef union
+{
+	unsigned int		regValue;
+	struct
+	{
+		unsigned int     pad0_status:1;
+		unsigned int     pad1_status:1;
+		unsigned int     reserved_1:10;
+		unsigned int     pad_ctrl:5;
+		unsigned int     reserved_0:2;
+		unsigned int     adc_busy:1;
+		unsigned int     pad_cnt:4;
+		unsigned int     irq_en:8;
+	};
+} ST_LSADC0_status;
+
+
+
+#endif
+
+extern int lsadc_init(int index, int voltage_mode);
+extern int lsdac_get(int index);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif//__RTD13xx_LSADC_H_
+
diff --git a/drivers/infiniband/hw/qib/qib_iba7322.c b/drivers/infiniband/hw/qib/qib_iba7322.c
index cedb447..228cb4c 100644
--- a/drivers/infiniband/hw/qib/qib_iba7322.c
+++ b/drivers/infiniband/hw/qib/qib_iba7322.c
@@ -150,7 +150,7 @@ static void qib_set_ib_7322_lstate(struct qib_pportdata *ppd, u16 linkcmd,
 	.string = txselect_list,
 	.maxlen = MAX_ATTEN_LEN
 };
-static int  setup_txselect(const char *, struct kernel_param *);
+static int  setup_txselect(const char *, const struct kernel_param *);
 module_param_call(txselect, setup_txselect, param_get_string,
 		  &kp_txselect, S_IWUSR | S_IRUGO);
 MODULE_PARM_DESC(txselect,
@@ -6177,7 +6177,7 @@ static void set_no_qsfp_atten(struct qib_devdata *dd, int change)
 }
 
 /* handle the txselect parameter changing */
-static int setup_txselect(const char *str, struct kernel_param *kp)
+static int setup_txselect(const char *str, const struct kernel_param *kp)
 {
 	struct qib_devdata *dd;
 	unsigned long val;
diff --git a/drivers/infiniband/ulp/srpt/ib_srpt.c b/drivers/infiniband/ulp/srpt/ib_srpt.c
index 876f438..9888c9b 100644
--- a/drivers/infiniband/ulp/srpt/ib_srpt.c
+++ b/drivers/infiniband/ulp/srpt/ib_srpt.c
@@ -80,7 +80,7 @@
 MODULE_PARM_DESC(srpt_srq_size,
 		 "Shared receive queue (SRQ) size.");
 
-static int srpt_get_u64_x(char *buffer, struct kernel_param *kp)
+static int srpt_get_u64_x(char *buffer, const struct kernel_param *kp)
 {
 	return sprintf(buffer, "0x%016llx", *(u64 *)kp->arg);
 }
diff --git a/drivers/input/Kconfig b/drivers/input/Kconfig
index 6261874..34ffa02 100644
--- a/drivers/input/Kconfig
+++ b/drivers/input/Kconfig
@@ -187,6 +187,19 @@ config INPUT_APMPOWER
 	  To compile this driver as a module, choose M here: the
 	  module will be called apm-power.
 
+config INPUT_KEYRESET
+	bool "Reset key"
+	depends on INPUT
+	select INPUT_KEYCOMBO
+	---help---
+	  Say Y here if you want to reboot when some keys are pressed;
+
+config INPUT_KEYCOMBO
+	bool "Key combo"
+	depends on INPUT
+	---help---
+	  Say Y here if you want to take action when some keys are pressed;
+
 comment "Input Device Drivers"
 
 source "drivers/input/keyboard/Kconfig"
diff --git a/drivers/input/Makefile b/drivers/input/Makefile
index 595820b..6a3281c 100644
--- a/drivers/input/Makefile
+++ b/drivers/input/Makefile
@@ -26,5 +26,7 @@ obj-$(CONFIG_INPUT_TOUCHSCREEN)	+= touchscreen/
 obj-$(CONFIG_INPUT_MISC)	+= misc/
 
 obj-$(CONFIG_INPUT_APMPOWER)	+= apm-power.o
+obj-$(CONFIG_INPUT_KEYRESET)	+= keyreset.o
+obj-$(CONFIG_INPUT_KEYCOMBO)	+= keycombo.o
 
 obj-$(CONFIG_RMI4_CORE)		+= rmi4/
diff --git a/drivers/input/keyboard/Kconfig b/drivers/input/keyboard/Kconfig
index cbd75cf..55d0159a 100644
--- a/drivers/input/keyboard/Kconfig
+++ b/drivers/input/keyboard/Kconfig
@@ -733,5 +733,20 @@ config KEYBOARD_BCM
 
 	  To compile this driver as a module, choose M here: the
 	  module will be called bcm-keypad.
+	  
+config KEYBOARD_GPIO_CMD
+	tristate "GPIO Commands"
+	depends on GPIOLIB
+	help
+	  This driver implements support for commanding device connected
+	  to GPIO pins of various CPUs (and some other chips).
+
+	  Say Y here if your device has outside commanding device connected
+	  directly to such GPIO pins.  Your board-specific
+	  setup logic must also provide a platform device,
+	  with configuration data saying which GPIOs are used.
+
+	  To compile this driver as a module, choose M here: the
+	  module will be called gpio_keys.
 
 endif
diff --git a/drivers/input/keyboard/Makefile b/drivers/input/keyboard/Makefile
index d9f4cfc..21e7888 100644
--- a/drivers/input/keyboard/Makefile
+++ b/drivers/input/keyboard/Makefile
@@ -64,3 +64,4 @@ obj-$(CONFIG_KEYBOARD_TEGRA)		+= tegra-kbc.o
 obj-$(CONFIG_KEYBOARD_TWL4030)		+= twl4030_keypad.o
 obj-$(CONFIG_KEYBOARD_XTKBD)		+= xtkbd.o
 obj-$(CONFIG_KEYBOARD_W90P910)		+= w90p910_keypad.o
+obj-$(CONFIG_KEYBOARD_GPIO_CMD)		+= gpio_cmds.o
diff --git a/drivers/input/keyboard/goldfish_events.c b/drivers/input/keyboard/goldfish_events.c
index f6e643b..c877e56 100644
--- a/drivers/input/keyboard/goldfish_events.c
+++ b/drivers/input/keyboard/goldfish_events.c
@@ -17,6 +17,7 @@
 #include <linux/interrupt.h>
 #include <linux/types.h>
 #include <linux/input.h>
+#include <linux/input/mt.h>
 #include <linux/kernel.h>
 #include <linux/platform_device.h>
 #include <linux/slab.h>
@@ -24,6 +25,8 @@
 #include <linux/io.h>
 #include <linux/acpi.h>
 
+#define GOLDFISH_MAX_FINGERS 5
+
 enum {
 	REG_READ        = 0x00,
 	REG_SET_PAGE    = 0x00,
@@ -52,7 +55,21 @@ static irqreturn_t events_interrupt(int irq, void *dev_id)
 	value = __raw_readl(edev->addr + REG_READ);
 
 	input_event(edev->input, type, code, value);
-	input_sync(edev->input);
+	// Send an extra (EV_SYN, SYN_REPORT, 0x0) event
+	// if a key was pressed. Some keyboard device
+        // drivers may only send the EV_KEY event and
+        // not EV_SYN.
+        // Note that sending an extra SYN_REPORT is not
+        // necessary nor correct protocol with other
+        // devices such as touchscreens, which will send
+        // their own SYN_REPORT's when sufficient event
+        // information has been collected (e.g., for
+        // touchscreens, when pressure and X/Y coordinates
+	// have been received). Hence, we will only send
+	// this extra SYN_REPORT if type == EV_KEY.
+	if (type == EV_KEY) {
+		input_sync(edev->input);
+	}
 	return IRQ_HANDLED;
 }
 
@@ -154,6 +171,15 @@ static int events_probe(struct platform_device *pdev)
 
 	input_dev->name = edev->name;
 	input_dev->id.bustype = BUS_HOST;
+	// Set the Goldfish Device to be multi-touch.
+	// In the Ranchu kernel, there is multi-touch-specific
+	// code for handling ABS_MT_SLOT events.
+	// See drivers/input/input.c:input_handle_abs_event.
+	// If we do not issue input_mt_init_slots,
+        // the kernel will filter out needed ABS_MT_SLOT
+        // events when we touch the screen in more than one place,
+        // preventing multi-touch with more than one finger from working.
+	input_mt_init_slots(input_dev, GOLDFISH_MAX_FINGERS, 0);
 
 	events_import_bits(edev, input_dev->evbit, EV_SYN, EV_MAX);
 	events_import_bits(edev, input_dev->keybit, EV_KEY, KEY_MAX);
diff --git a/drivers/input/keyboard/gpio_cmds.c b/drivers/input/keyboard/gpio_cmds.c
new file mode 100644
index 00000000..0bfa399
--- /dev/null
+++ b/drivers/input/keyboard/gpio_cmds.c
@@ -0,0 +1,761 @@
+/*
+ * Driver for keys on GPIO lines capable of generating interrupts.
+ *
+ * Copyright 2005 Phil Blundell
+ * Copyright 2010, 2011 David Jander <david@protonic.nl>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+
+#include <linux/init.h>
+#include <linux/fs.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/sched.h>
+#include <linux/pm.h>
+#include <linux/slab.h>
+#include <linux/sysctl.h>
+#include <linux/proc_fs.h>
+#include <linux/delay.h>
+#include <linux/platform_device.h>
+#include <linux/input.h>
+#include <linux/gpio_keys.h>
+#include <linux/workqueue.h>
+#include <linux/gpio.h>
+#include <linux/of.h>
+#include <linux/of_platform.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+#include <linux/spinlock.h>
+
+struct gpio_button_data {
+	const struct gpio_keys_button *button;
+	struct input_dev *input;
+
+	struct timer_list release_timer;
+	unsigned int release_delay;	/* in msecs, for IRQ-only buttons */
+
+	struct delayed_work work;
+	unsigned int software_debounce;	/* in msecs, for GPIO-driven buttons */
+
+	unsigned int irq;
+	spinlock_t lock;
+	bool disabled;
+	bool key_pressed;
+#if LEGACY_CMD
+	unsigned int cmd_gpio[4]; 
+#endif
+};
+
+struct gpio_keys_drvdata {
+	const struct gpio_keys_platform_data *pdata;
+	struct input_dev *input;
+	struct mutex disable_lock;
+	struct gpio_button_data data[0];
+};
+
+struct cmd_key {
+        const u32 scancode;
+        const u32 keycode;
+	u32 rx;
+	u32 repeat;
+};
+
+static struct cmd_key rtk_cmd_keys[] = {
+#if LEGACY_CMD
+        {0x00, KEY_VOICECOMMAND, 0, 0},                     
+        {0x08, KEY_HOME, 0, 0},                     
+        {0x09, KEY_VOLUMEUP, 0, 1},       
+        {0x0A, KEY_VOLUMEDOWN, 0, 1},          
+	{0x05, KEY_ESC, 0, 0},                   
+        {0x0D, KEY_OK, 0, 0},                     
+        {0x0E, KEY_PLAY, 0, 0},                                                        
+        {0x0F, KEY_PAUSE, 0, 0},   
+	{0x07, KEY_STOP, 0, 0}, 
+	{0x0B, KEY_UP, 0, 0},                         
+        {0x0C, KEY_DOWN, 0, 0},                     
+        {0x03, KEY_RIGHT, 0, 0},                                                        
+        {0x04, KEY_LEFT, 0, 0},   
+	{0x06, KEY_ALEXA, 0, 0}, 
+#else
+        {0x00, KEY_SEARCH, 0, 0},
+#endif
+};
+
+static int rtk_cmd_keys_count = ARRAY_SIZE(rtk_cmd_keys);
+static u32 trigger_cmd = 0;
+
+
+static ssize_t gpio_cmds_show_cmds(struct device *dev,                
+                                     struct device_attribute *attr,     
+                                     char *buf)                         
+{                                                                       
+                                                                        
+        return sprintf(buf, "%d\n", trigger_cmd);              
+                                            
+}
+
+
+static ssize_t gpio_cmds_store_cmds(struct device *dev,               
+                                      struct device_attribute *attr,    
+                                      const char *buf,                 
+                                      size_t count)                    
+{                                                                       
+                           
+	trigger_cmd = simple_strtol(buf, 0, 16);                                                                                  
+       	return count;                                                   
+}
+
+
+static DEVICE_ATTR(cmds, 0644,
+                   gpio_cmds_show_cmds,
+                   gpio_cmds_store_cmds);
+
+static struct attribute *gpio_cmds_attrs[] = {
+        &dev_attr_cmds.attr,
+        NULL,
+};
+
+static struct attribute_group gpio_cmds_attr_group = {
+        .attrs = gpio_cmds_attrs,
+};
+
+static void gpio_keys_gpio_report_event(struct gpio_button_data *bdata)
+{
+	const struct gpio_keys_button *button = bdata->button;
+	struct input_dev *input = bdata->input;
+	unsigned int type = button->type ?: EV_KEY;
+	int state = (gpio_get_value_cansleep(button->gpio) ? 1 : 0) ^ button->active_low;
+	u32 map_data = 0;
+	int i, j;
+
+#if LEGACY_CMD
+	for (i =0 ; i < 4; i++) {
+
+		if(gpio_request(bdata->cmd_gpio[i], "cmd"))  {       //request gpio
+        		pr_err("%s ERROR Request cmd_gpio[%d] fail\n",__func__, i);
+			return;
+		}
+        	else if (bdata->cmd_gpio[i]!= -1) {
+			gpio_direction_input(bdata->cmd_gpio[i]);
+			pr_debug("gpio_direction_input(bdata->cmd_gpio[%d]) = %d \n", i, gpio_get_value(bdata->cmd_gpio[i]));
+
+			map_data |= (gpio_get_value(bdata->cmd_gpio[i]) << i);	
+			
+			gpio_free(bdata->cmd_gpio[i]);
+		}
+	}
+	for (i = 0; i < rtk_cmd_keys_count; i++) {
+
+                if (map_data == rtk_cmd_keys[i].scancode) {
+
+			pr_err("[getscancode] found! keycode=%d scancode=0x%x !\n", rtk_cmd_keys[i].keycode, rtk_cmd_keys[i].scancode);
+
+			if ( i == 0) {
+				trigger_cmd = 1;
+				return ;					
+			}
+			trigger_cmd = 0;
+	
+			rtk_cmd_keys[i].rx++;
+
+			j = rtk_cmd_keys[i].repeat + 1;
+			while ( j--) {
+				input_report_key(input, rtk_cmd_keys[i].keycode, 1);
+             			input_event(input, EV_SYN, SYN_REPORT, rtk_cmd_keys[i].rx);
+				
+				input_report_key(input, rtk_cmd_keys[i].keycode, 0);
+				input_event(input, EV_SYN, SYN_REPORT, rtk_cmd_keys[i].rx);
+				if (j)
+					msleep(500);
+			}
+                        return ;
+                }
+        }
+#else
+        i = 0;
+        pr_err("[getscancode] found! keycode=%d scancode=0x%x !\n", rtk_cmd_keys[i].keycode, rtk_cmd_keys[i].scancode);
+        input_report_key(input, rtk_cmd_keys[i].keycode, 1);
+        input_event(input, EV_SYN, SYN_REPORT, rtk_cmd_keys[i].rx);
+
+        input_report_key(input, rtk_cmd_keys[i].keycode, 0);
+        input_event(input, EV_SYN, SYN_REPORT, rtk_cmd_keys[i].rx);
+        trigger_cmd = 1;
+#endif
+
+}
+
+static void gpio_keys_gpio_work_func(struct work_struct *work)
+{
+	struct gpio_button_data *bdata =
+		container_of(work, struct gpio_button_data, work.work);
+
+	gpio_keys_gpio_report_event(bdata);
+
+	if (bdata->button->wakeup)
+		pm_relax(bdata->input->dev.parent);
+}
+
+static irqreturn_t gpio_keys_gpio_isr(int irq, void *dev_id)
+{
+	struct gpio_button_data *bdata = dev_id;
+
+	BUG_ON(irq != bdata->irq);
+
+	if (bdata->button->wakeup)
+		pm_stay_awake(bdata->input->dev.parent);
+
+	mod_delayed_work(system_wq,
+			 &bdata->work,
+			 msecs_to_jiffies(bdata->software_debounce));
+
+	return IRQ_HANDLED;
+}
+
+static void gpio_keys_irq_timer(unsigned long _data)
+{
+	struct gpio_button_data *bdata = (struct gpio_button_data *)_data;
+	struct input_dev *input = bdata->input;
+	unsigned long flags;
+
+	spin_lock_irqsave(&bdata->lock, flags);
+	if (bdata->key_pressed) {
+		input_event(input, EV_KEY, bdata->button->code, 0);
+		input_sync(input);
+		bdata->key_pressed = false;
+	}
+	spin_unlock_irqrestore(&bdata->lock, flags);
+}
+
+static irqreturn_t gpio_keys_irq_isr(int irq, void *dev_id)
+{
+	struct gpio_button_data *bdata = dev_id;
+	const struct gpio_keys_button *button = bdata->button;
+	struct input_dev *input = bdata->input;
+	unsigned long flags;
+
+	BUG_ON(irq != bdata->irq);
+
+	spin_lock_irqsave(&bdata->lock, flags);
+
+	if (!bdata->key_pressed) {
+		if (bdata->button->wakeup)
+			pm_wakeup_event(bdata->input->dev.parent, 0);
+
+		input_event(input, EV_KEY, button->code, 1);
+		input_sync(input);
+
+		if (!bdata->release_delay) {
+			input_event(input, EV_KEY, button->code, 0);
+			input_sync(input);
+			goto out;
+		}
+
+		bdata->key_pressed = true;
+	}
+
+	if (bdata->release_delay)
+		mod_timer(&bdata->release_timer,
+			jiffies + msecs_to_jiffies(bdata->release_delay));
+out:
+	spin_unlock_irqrestore(&bdata->lock, flags);
+	return IRQ_HANDLED;
+}
+
+static void gpio_keys_quiesce_key(void *data)
+{
+	struct gpio_button_data *bdata = data;
+
+	if (gpio_is_valid(bdata->button->gpio))
+		cancel_delayed_work_sync(&bdata->work);
+	else
+		del_timer_sync(&bdata->release_timer);
+}
+
+static int gpio_keys_setup_key(struct platform_device *pdev,
+				struct input_dev *input,
+				struct gpio_button_data *bdata,
+				const struct gpio_keys_button *button)
+{
+	const char *desc = button->desc ? button->desc : "gpio_cmds";
+	struct device *dev = &pdev->dev;
+	irq_handler_t isr;
+	unsigned long irqflags;
+	int irq;
+	int error;
+	struct device_node *node;
+	unsigned int ldo_gpio;
+	int i;
+
+	node = dev->of_node;
+	if (!node)
+		return -ENODEV;
+
+	bdata->input = input;
+	bdata->button = button;
+	spin_lock_init(&bdata->lock);
+
+	if (gpio_is_valid(button->gpio)) {
+		//if(gpio_request(button->gpio, "gpio_cmds")) {        //request gpio
+                //	dev_err(dev, "%s ERROR Request ldo gpio fail\n",__func__);
+		//	return -EINVAL;
+		//}
+		//gpio_direction_input(button->gpio);
+
+
+		error = devm_gpio_request_one(&pdev->dev, button->gpio,
+					      GPIOF_IN, desc);
+		if (error < 0) {
+			dev_err(dev, "Failed to request GPIO %d, error %d\n",
+				button->gpio, error);
+			return error;
+		}
+
+		if (button->debounce_interval) {
+			error = gpio_set_debounce(button->gpio,
+					button->debounce_interval * 1000);
+			/* use timer if gpiolib doesn't provide debounce */
+			if (error < 0)
+				bdata->software_debounce =
+						button->debounce_interval;
+		}
+
+		if (button->irq) {
+			bdata->irq = button->irq;
+			dev_err(dev, "[irq] = %d \n", bdata->irq);
+
+		} else {
+			irq = gpio_to_irq(button->gpio);
+			if (irq < 0) {
+				error = irq;
+				dev_err(dev,
+					"Unable to get irq number for GPIO %d, error %d\n",
+					button->gpio, error);
+				return error;
+			}
+			bdata->irq = irq;
+			dev_err(dev, "(irq) = %d \n", bdata->irq);
+		}
+
+		
+#if LEGACY_CMD	
+		bdata->cmd_gpio[0] = of_get_named_gpio(node, "5679_gpio2", 0);
+                if (!gpio_is_valid(bdata->cmd_gpio[0])) {
+			dev_err(dev, "Found cmd without 5679_gpio2 \n");
+                        return -EINVAL;
+			
+		}
+	
+		bdata->cmd_gpio[1] = of_get_named_gpio(node, "5679_gpio3", 0);
+                if (!gpio_is_valid(bdata->cmd_gpio[1])) {
+			dev_err(dev, "Found cmd without 5679_gpio3 \n");
+                        return -EINVAL;
+			
+		}
+
+		bdata->cmd_gpio[2] = of_get_named_gpio(node, "5679_gpio12", 0);
+                if (!gpio_is_valid(bdata->cmd_gpio[2])) {
+			dev_err(dev, "Found cmd without 5679_gpio12 \n");
+                        return -EINVAL;
+			
+		}
+	
+		bdata->cmd_gpio[3] = of_get_named_gpio(node, "5679_gpio13", 0);
+                if (!gpio_is_valid(bdata->cmd_gpio[3])) {
+			dev_err(dev, "Found cmd without 5679_gpio13 \n");
+                        return -EINVAL;
+			
+		}
+
+		ldo_gpio = of_get_named_gpio(node, "5679_ldo", 0);
+                if (gpio_is_valid(ldo_gpio)) {
+
+			if(gpio_request(ldo_gpio, "ldo"))         //request gpio
+                        	dev_err(dev, "%s ERROR Request ldo gpio fail\n",__func__);
+                        else if (ldo_gpio != -1) {
+                        	if (gpio_direction_output(ldo_gpio, 0))
+                                	dev_err(dev, "%s ERROR ldo gpio ouput 0 fail \n", __func__);;
+				mdelay(100);                     // may be too long ?
+				if (gpio_direction_output(ldo_gpio, 1))
+                                	dev_err(dev, "%s ERROR ldo gpio ouput 0 fail \n", __func__);;
+
+                                gpio_free(ldo_gpio);
+
+                        }
+
+                }
+#endif
+				
+		INIT_DELAYED_WORK(&bdata->work, gpio_keys_gpio_work_func);
+
+		isr = gpio_keys_gpio_isr;
+		irqflags = IRQF_TRIGGER_RISING /*| IRQF_TRIGGER_FALLING*/;
+
+	} else {
+		if (!button->irq) {
+			dev_err(dev, "No IRQ specified\n");
+			return -EINVAL;
+		}
+		bdata->irq = button->irq;
+
+		if (button->type && button->type != EV_KEY) {
+			dev_err(dev, "Only EV_KEY allowed for IRQ buttons.\n");
+			return -EINVAL;
+		}
+
+		bdata->release_delay = button->debounce_interval;
+		setup_timer(&bdata->release_timer,
+			    gpio_keys_irq_timer, (unsigned long)bdata);
+
+		isr = gpio_keys_irq_isr;
+		irqflags = 0;
+	}
+
+	for (i = 0; i < rtk_cmd_keys_count; i++) 
+		input_set_capability(input, EV_KEY, rtk_cmd_keys[i].keycode);
+
+	/*
+	 * Install custom action to cancel release timer and
+	 * workqueue item.
+	 */
+	error = devm_add_action(&pdev->dev, gpio_keys_quiesce_key, bdata);
+	if (error) {
+		dev_err(&pdev->dev,
+			"failed to register quiesce action, error: %d\n",
+			error);
+		return error;
+	}
+
+	/*
+	 * If platform has specified that the button can be disabled,
+	 * we don't want it to share the interrupt line.
+	 */
+	if (!button->can_disable)
+		irqflags |= IRQF_SHARED;
+
+	error = devm_request_any_context_irq(&pdev->dev, bdata->irq,
+					     isr, irqflags, desc, bdata);
+	if (error < 0) {
+		dev_err(dev, "Unable to claim irq %d; error %d\n",
+			bdata->irq, error);
+		return error;
+	}
+
+	return 0;
+}
+
+static void gpio_keys_report_state(struct gpio_keys_drvdata *ddata)
+{
+	struct input_dev *input = ddata->input;
+	int i;
+
+	for (i = 0; i < ddata->pdata->nbuttons; i++) {
+		struct gpio_button_data *bdata = &ddata->data[i];
+		if (gpio_is_valid(bdata->button->gpio))
+			gpio_keys_gpio_report_event(bdata);
+	}
+	input_sync(input);
+}
+
+static int gpio_keys_open(struct input_dev *input)
+{
+	struct gpio_keys_drvdata *ddata = input_get_drvdata(input);
+	const struct gpio_keys_platform_data *pdata = ddata->pdata;
+	int error;
+
+	if (pdata->enable) {
+		error = pdata->enable(input->dev.parent);
+		if (error)
+			return error;
+	}
+
+	/* Report current state of buttons that are connected to GPIOs */
+	//gpio_keys_report_state(ddata);
+
+	return 0;
+}
+
+static void gpio_keys_close(struct input_dev *input)
+{
+	struct gpio_keys_drvdata *ddata = input_get_drvdata(input);
+	const struct gpio_keys_platform_data *pdata = ddata->pdata;
+
+	if (pdata->disable)
+		pdata->disable(input->dev.parent);
+}
+
+/*
+ * Handlers for alternative sources of platform_data
+ */
+
+#ifdef CONFIG_OF
+/*
+ * Translate OpenFirmware node properties into platform_data
+ */
+static struct gpio_keys_platform_data *
+gpio_keys_get_devtree_pdata(struct device *dev)
+{
+	struct device_node *node, *pp;
+	struct gpio_keys_platform_data *pdata;
+	struct gpio_keys_button *button;
+	int error;
+	int nbuttons;
+	int i;
+
+	node = dev->of_node;
+	if (!node)
+		return ERR_PTR(-ENODEV);
+
+	nbuttons = of_get_child_count(node);
+	if (nbuttons == 0)
+		return ERR_PTR(-ENODEV);
+
+	pdata = devm_kzalloc(dev,
+			     sizeof(*pdata) + nbuttons * sizeof(*button),
+			     GFP_KERNEL);
+	if (!pdata)
+		return ERR_PTR(-ENOMEM);
+
+	pdata->buttons = (struct gpio_keys_button *)(pdata + 1);
+	pdata->nbuttons = nbuttons;
+
+	pdata->rep = !!of_get_property(node, "autorepeat", NULL);
+
+	i = 0;
+	for_each_child_of_node(node, pp) {
+		enum of_gpio_flags flags;
+
+		button = &pdata->buttons[i++];
+
+		button->gpio = of_get_gpio_flags(pp, 0, &flags);
+		if (button->gpio < 0) {
+			error = button->gpio;
+			if (error != -ENOENT) {
+				if (error != -EPROBE_DEFER)
+					dev_err(dev,
+						"Failed to get gpio flags, error: %d\n",
+						error);
+				return ERR_PTR(error);
+			}
+		} else {
+			button->active_low = flags & OF_GPIO_ACTIVE_LOW;
+		}
+
+		button->irq = irq_of_parse_and_map(pp, 0);
+
+		if (!gpio_is_valid(button->gpio) && !button->irq) {
+			dev_err(dev, "Found button without gpios or irqs\n");
+			return ERR_PTR(-EINVAL);
+		}
+
+
+		button->wakeup = !!of_get_property(pp, "gpio-key,wakeup", NULL);
+
+		button->can_disable = !!of_get_property(pp, "linux,can-disable", NULL);
+
+		if (of_property_read_u32(pp, "debounce-interval",
+					 &button->debounce_interval))
+			button->debounce_interval = 5;
+	}
+
+	if (pdata->nbuttons == 0)
+		return ERR_PTR(-EINVAL);
+
+
+	return pdata;
+}
+
+static const struct of_device_id gpio_cmds_of_match[] = {
+	{ .compatible = "gpio-cmds", },
+	{ },
+};
+MODULE_DEVICE_TABLE(of, gpio_cmds_of_match);
+
+#else
+
+static inline struct gpio_keys_platform_data *
+gpio_keys_get_devtree_pdata(struct device *dev)
+{
+	return ERR_PTR(-ENODEV);
+}
+
+#endif
+
+static int gpio_cmds_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	const struct gpio_keys_platform_data *pdata = dev_get_platdata(dev);
+	struct gpio_keys_drvdata *ddata;
+	struct input_dev *input;
+	size_t size;
+	int i, error;
+	int wakeup = 0;
+
+	if (!pdata) {
+		pdata = gpio_keys_get_devtree_pdata(dev);
+		if (IS_ERR(pdata))
+			return PTR_ERR(pdata);
+	}
+
+	size = sizeof(struct gpio_keys_drvdata) +
+			pdata->nbuttons * sizeof(struct gpio_button_data);
+	ddata = devm_kzalloc(dev, size, GFP_KERNEL);
+	if (!ddata) {
+		dev_err(dev, "failed to allocate state\n");
+		return -ENOMEM;
+	}
+
+	input = devm_input_allocate_device(dev);
+	if (!input) {
+		dev_err(dev, "failed to allocate input device\n");
+		return -ENOMEM;
+	}
+
+	ddata->pdata = pdata;
+	ddata->input = input;
+	mutex_init(&ddata->disable_lock);
+
+	platform_set_drvdata(pdev, ddata);
+	input_set_drvdata(input, ddata);
+
+	input->name = pdata->name ? : pdev->name;
+	input->phys = "gpio-cmds/input0";
+	input->dev.parent = &pdev->dev;
+	input->open = gpio_keys_open;
+	input->close = gpio_keys_close;
+
+	input->id.bustype = BUS_HOST;
+	input->id.vendor = 0x0001;
+	input->id.product = 0x0001;
+	input->id.version = 0x0100;
+
+	/* Enable auto repeat feature of Linux input subsystem */
+	if (pdata->rep)
+		__set_bit(EV_REP, input->evbit);
+
+	for (i = 0; i < pdata->nbuttons; i++) {
+		const struct gpio_keys_button *button = &pdata->buttons[i];
+		struct gpio_button_data *bdata = &ddata->data[i];
+
+		error = gpio_keys_setup_key(pdev, input, bdata, button);
+		if (error)
+			return error;
+
+		if (button->wakeup)
+			wakeup = 1;
+	}
+
+	error = sysfs_create_group(&pdev->dev.kobj, &gpio_cmds_attr_group);
+        if (error) {
+                dev_err(dev, "Unable to export cmds, error: %d\n",
+                        error);
+                return error;
+        }
+
+
+	error = input_register_device(input);
+	if (error) {
+		dev_err(dev, "Unable to register input device, error: %d\n",
+			error);
+		goto err_remove_group;
+	}
+
+	device_init_wakeup(&pdev->dev, wakeup);
+
+	return 0;
+
+err_remove_group:
+	return error;
+}
+
+static int gpio_cmds_remove(struct platform_device *pdev)
+{
+
+	device_init_wakeup(&pdev->dev, 0);
+
+	return 0;
+}
+
+#ifdef CONFIG_PM_SLEEP
+static int gpio_cmds_suspend(struct device *dev)
+{
+	struct gpio_keys_drvdata *ddata = dev_get_drvdata(dev);
+	struct input_dev *input = ddata->input;
+	int i;
+
+	if (device_may_wakeup(dev)) {
+		for (i = 0; i < ddata->pdata->nbuttons; i++) {
+			struct gpio_button_data *bdata = &ddata->data[i];
+			if (bdata->button->wakeup)
+				enable_irq_wake(bdata->irq);
+		}
+	} else {
+		mutex_lock(&input->mutex);
+		if (input->users)
+			gpio_keys_close(input);
+		mutex_unlock(&input->mutex);
+	}
+
+	return 0;
+}
+
+static int gpio_cmds_resume(struct device *dev)
+{
+	struct gpio_keys_drvdata *ddata = dev_get_drvdata(dev);
+	struct input_dev *input = ddata->input;
+	int error = 0;
+	int i;
+
+	if (device_may_wakeup(dev)) {
+		for (i = 0; i < ddata->pdata->nbuttons; i++) {
+			struct gpio_button_data *bdata = &ddata->data[i];
+			if (bdata->button->wakeup)
+				disable_irq_wake(bdata->irq);
+		}
+	} else {
+		mutex_lock(&input->mutex);
+		if (input->users)
+			error = gpio_keys_open(input);
+		mutex_unlock(&input->mutex);
+	}
+
+	if (error)
+		return error;
+
+	//gpio_keys_report_state(ddata);
+	return 0;
+}
+#endif
+
+static SIMPLE_DEV_PM_OPS(gpio_cmds_pm_ops, gpio_cmds_suspend, gpio_cmds_resume);
+
+static struct platform_driver gpio_cmds_device_driver = {
+	.probe		= gpio_cmds_probe,
+	.remove		= gpio_cmds_remove,
+	.driver		= {
+		.name	= "gpio-cmds",
+		.pm	= &gpio_cmds_pm_ops,
+		.of_match_table = of_match_ptr(gpio_cmds_of_match),
+	}
+};
+
+static int __init gpio_cmds_init(void)
+{
+	return platform_driver_register(&gpio_cmds_device_driver);
+}
+
+static void __exit gpio_cmds_exit(void)
+{
+	platform_driver_unregister(&gpio_cmds_device_driver);
+}
+
+late_initcall(gpio_cmds_init);
+module_exit(gpio_cmds_exit);
+
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Command driver for GPIOs");
+MODULE_ALIAS("platform:gpio-cmds");
diff --git a/drivers/input/keycombo.c b/drivers/input/keycombo.c
new file mode 100644
index 00000000..2fba451
--- /dev/null
+++ b/drivers/input/keycombo.c
@@ -0,0 +1,261 @@
+/* drivers/input/keycombo.c
+ *
+ * Copyright (C) 2014 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/input.h>
+#include <linux/keycombo.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/reboot.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+
+struct keycombo_state {
+	struct input_handler input_handler;
+	unsigned long keybit[BITS_TO_LONGS(KEY_CNT)];
+	unsigned long upbit[BITS_TO_LONGS(KEY_CNT)];
+	unsigned long key[BITS_TO_LONGS(KEY_CNT)];
+	spinlock_t lock;
+	struct  workqueue_struct *wq;
+	int key_down_target;
+	int key_down;
+	int key_up;
+	struct delayed_work key_down_work;
+	int delay;
+	struct work_struct key_up_work;
+	void (*key_up_fn)(void *);
+	void (*key_down_fn)(void *);
+	void *priv;
+	int key_is_down;
+	struct wakeup_source combo_held_wake_source;
+	struct wakeup_source combo_up_wake_source;
+};
+
+static void do_key_down(struct work_struct *work)
+{
+	struct delayed_work *dwork = container_of(work, struct delayed_work,
+									work);
+	struct keycombo_state *state = container_of(dwork,
+					struct keycombo_state, key_down_work);
+	if (state->key_down_fn)
+		state->key_down_fn(state->priv);
+}
+
+static void do_key_up(struct work_struct *work)
+{
+	struct keycombo_state *state = container_of(work, struct keycombo_state,
+								key_up_work);
+	if (state->key_up_fn)
+		state->key_up_fn(state->priv);
+	__pm_relax(&state->combo_up_wake_source);
+}
+
+static void keycombo_event(struct input_handle *handle, unsigned int type,
+		unsigned int code, int value)
+{
+	unsigned long flags;
+	struct keycombo_state *state = handle->private;
+
+	if (type != EV_KEY)
+		return;
+
+	if (code >= KEY_MAX)
+		return;
+
+	if (!test_bit(code, state->keybit))
+		return;
+
+	spin_lock_irqsave(&state->lock, flags);
+	if (!test_bit(code, state->key) == !value)
+		goto done;
+	__change_bit(code, state->key);
+	if (test_bit(code, state->upbit)) {
+		if (value)
+			state->key_up++;
+		else
+			state->key_up--;
+	} else {
+		if (value)
+			state->key_down++;
+		else
+			state->key_down--;
+	}
+	if (state->key_down == state->key_down_target && state->key_up == 0) {
+		__pm_stay_awake(&state->combo_held_wake_source);
+		state->key_is_down = 1;
+		if (queue_delayed_work(state->wq, &state->key_down_work,
+								state->delay))
+			pr_debug("Key down work already queued!");
+	} else if (state->key_is_down) {
+		if (!cancel_delayed_work(&state->key_down_work)) {
+			__pm_stay_awake(&state->combo_up_wake_source);
+			queue_work(state->wq, &state->key_up_work);
+		}
+		__pm_relax(&state->combo_held_wake_source);
+		state->key_is_down = 0;
+	}
+done:
+	spin_unlock_irqrestore(&state->lock, flags);
+}
+
+static int keycombo_connect(struct input_handler *handler,
+		struct input_dev *dev,
+		const struct input_device_id *id)
+{
+	int i;
+	int ret;
+	struct input_handle *handle;
+	struct keycombo_state *state =
+		container_of(handler, struct keycombo_state, input_handler);
+	for (i = 0; i < KEY_MAX; i++) {
+		if (test_bit(i, state->keybit) && test_bit(i, dev->keybit))
+			break;
+	}
+	if (i == KEY_MAX)
+		return -ENODEV;
+
+	handle = kzalloc(sizeof(*handle), GFP_KERNEL);
+	if (!handle)
+		return -ENOMEM;
+
+	handle->dev = dev;
+	handle->handler = handler;
+	handle->name = KEYCOMBO_NAME;
+	handle->private = state;
+
+	ret = input_register_handle(handle);
+	if (ret)
+		goto err_input_register_handle;
+
+	ret = input_open_device(handle);
+	if (ret)
+		goto err_input_open_device;
+
+	return 0;
+
+err_input_open_device:
+	input_unregister_handle(handle);
+err_input_register_handle:
+	kfree(handle);
+	return ret;
+}
+
+static void keycombo_disconnect(struct input_handle *handle)
+{
+	input_close_device(handle);
+	input_unregister_handle(handle);
+	kfree(handle);
+}
+
+static const struct input_device_id keycombo_ids[] = {
+		{
+				.flags = INPUT_DEVICE_ID_MATCH_EVBIT,
+				.evbit = { BIT_MASK(EV_KEY) },
+		},
+		{ },
+};
+MODULE_DEVICE_TABLE(input, keycombo_ids);
+
+static int keycombo_probe(struct platform_device *pdev)
+{
+	int ret;
+	int key, *keyp;
+	struct keycombo_state *state;
+	struct keycombo_platform_data *pdata = pdev->dev.platform_data;
+
+	if (!pdata)
+		return -EINVAL;
+
+	state = kzalloc(sizeof(*state), GFP_KERNEL);
+	if (!state)
+		return -ENOMEM;
+
+	spin_lock_init(&state->lock);
+	keyp = pdata->keys_down;
+	while ((key = *keyp++)) {
+		if (key >= KEY_MAX)
+			continue;
+		state->key_down_target++;
+		__set_bit(key, state->keybit);
+	}
+	if (pdata->keys_up) {
+		keyp = pdata->keys_up;
+		while ((key = *keyp++)) {
+			if (key >= KEY_MAX)
+				continue;
+			__set_bit(key, state->keybit);
+			__set_bit(key, state->upbit);
+		}
+	}
+
+	state->wq = alloc_ordered_workqueue("keycombo", 0);
+	if (!state->wq)
+		return -ENOMEM;
+
+	state->priv = pdata->priv;
+
+	if (pdata->key_down_fn)
+		state->key_down_fn = pdata->key_down_fn;
+	INIT_DELAYED_WORK(&state->key_down_work, do_key_down);
+
+	if (pdata->key_up_fn)
+		state->key_up_fn = pdata->key_up_fn;
+	INIT_WORK(&state->key_up_work, do_key_up);
+
+	wakeup_source_init(&state->combo_held_wake_source, "key combo");
+	wakeup_source_init(&state->combo_up_wake_source, "key combo up");
+	state->delay = msecs_to_jiffies(pdata->key_down_delay);
+
+	state->input_handler.event = keycombo_event;
+	state->input_handler.connect = keycombo_connect;
+	state->input_handler.disconnect = keycombo_disconnect;
+	state->input_handler.name = KEYCOMBO_NAME;
+	state->input_handler.id_table = keycombo_ids;
+	ret = input_register_handler(&state->input_handler);
+	if (ret) {
+		kfree(state);
+		return ret;
+	}
+	platform_set_drvdata(pdev, state);
+	return 0;
+}
+
+int keycombo_remove(struct platform_device *pdev)
+{
+	struct keycombo_state *state = platform_get_drvdata(pdev);
+	input_unregister_handler(&state->input_handler);
+	destroy_workqueue(state->wq);
+	kfree(state);
+	return 0;
+}
+
+
+struct platform_driver keycombo_driver = {
+		.driver.name = KEYCOMBO_NAME,
+		.probe = keycombo_probe,
+		.remove = keycombo_remove,
+};
+
+static int __init keycombo_init(void)
+{
+	return platform_driver_register(&keycombo_driver);
+}
+
+static void __exit keycombo_exit(void)
+{
+	return platform_driver_unregister(&keycombo_driver);
+}
+
+module_init(keycombo_init);
+module_exit(keycombo_exit);
diff --git a/drivers/input/keyreset.c b/drivers/input/keyreset.c
new file mode 100644
index 00000000..7e5222a
--- /dev/null
+++ b/drivers/input/keyreset.c
@@ -0,0 +1,144 @@
+/* drivers/input/keyreset.c
+ *
+ * Copyright (C) 2014 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/input.h>
+#include <linux/keyreset.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/reboot.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/syscalls.h>
+#include <linux/keycombo.h>
+
+struct keyreset_state {
+	int restart_requested;
+	int (*reset_fn)(void);
+	struct platform_device *pdev_child;
+	struct work_struct restart_work;
+};
+
+static void do_restart(struct work_struct *unused)
+{
+	orderly_reboot();
+}
+
+static void do_reset_fn(void *priv)
+{
+	struct keyreset_state *state = priv;
+	if (state->restart_requested)
+		panic("keyboard reset failed, %d", state->restart_requested);
+	if (state->reset_fn) {
+		state->restart_requested = state->reset_fn();
+	} else {
+		pr_info("keyboard reset\n");
+		schedule_work(&state->restart_work);
+		state->restart_requested = 1;
+	}
+}
+
+static int keyreset_probe(struct platform_device *pdev)
+{
+	int ret = -ENOMEM;
+	struct keycombo_platform_data *pdata_child;
+	struct keyreset_platform_data *pdata = pdev->dev.platform_data;
+	int up_size = 0, down_size = 0, size;
+	int key, *keyp;
+	struct keyreset_state *state;
+
+	if (!pdata)
+		return -EINVAL;
+	state = devm_kzalloc(&pdev->dev, sizeof(*state), GFP_KERNEL);
+	if (!state)
+		return -ENOMEM;
+
+	state->pdev_child = platform_device_alloc(KEYCOMBO_NAME,
+							PLATFORM_DEVID_AUTO);
+	if (!state->pdev_child)
+		return -ENOMEM;
+	state->pdev_child->dev.parent = &pdev->dev;
+	INIT_WORK(&state->restart_work, do_restart);
+
+	keyp = pdata->keys_down;
+	while ((key = *keyp++)) {
+		if (key >= KEY_MAX)
+			continue;
+		down_size++;
+	}
+	if (pdata->keys_up) {
+		keyp = pdata->keys_up;
+		while ((key = *keyp++)) {
+			if (key >= KEY_MAX)
+				continue;
+			up_size++;
+		}
+	}
+	size = sizeof(struct keycombo_platform_data)
+			+ sizeof(int) * (down_size + 1);
+	pdata_child = devm_kzalloc(&pdev->dev, size, GFP_KERNEL);
+	if (!pdata_child)
+		goto error;
+	memcpy(pdata_child->keys_down, pdata->keys_down,
+						sizeof(int) * down_size);
+	if (up_size > 0) {
+		pdata_child->keys_up = devm_kzalloc(&pdev->dev, up_size + 1,
+								GFP_KERNEL);
+		if (!pdata_child->keys_up)
+			goto error;
+		memcpy(pdata_child->keys_up, pdata->keys_up,
+							sizeof(int) * up_size);
+		if (!pdata_child->keys_up)
+			goto error;
+	}
+	state->reset_fn = pdata->reset_fn;
+	pdata_child->key_down_fn = do_reset_fn;
+	pdata_child->priv = state;
+	pdata_child->key_down_delay = pdata->key_down_delay;
+	ret = platform_device_add_data(state->pdev_child, pdata_child, size);
+	if (ret)
+		goto error;
+	platform_set_drvdata(pdev, state);
+	return platform_device_add(state->pdev_child);
+error:
+	platform_device_put(state->pdev_child);
+	return ret;
+}
+
+int keyreset_remove(struct platform_device *pdev)
+{
+	struct keyreset_state *state = platform_get_drvdata(pdev);
+	platform_device_put(state->pdev_child);
+	return 0;
+}
+
+
+struct platform_driver keyreset_driver = {
+	.driver.name = KEYRESET_NAME,
+	.probe = keyreset_probe,
+	.remove = keyreset_remove,
+};
+
+static int __init keyreset_init(void)
+{
+	return platform_driver_register(&keyreset_driver);
+}
+
+static void __exit keyreset_exit(void)
+{
+	return platform_driver_unregister(&keyreset_driver);
+}
+
+module_init(keyreset_init);
+module_exit(keyreset_exit);
diff --git a/drivers/input/misc/Kconfig b/drivers/input/misc/Kconfig
index 7ffb614..6d650f0 100644
--- a/drivers/input/misc/Kconfig
+++ b/drivers/input/misc/Kconfig
@@ -367,6 +367,17 @@ config INPUT_ATI_REMOTE2
 	  To compile this driver as a module, choose M here: the module will be
 	  called ati_remote2.
 
+config INPUT_KEYCHORD
+	tristate "Key chord input driver support"
+	help
+	  Say Y here if you want to enable the key chord driver
+	  accessible at /dev/keychord.  This driver can be used
+	  for receiving notifications when client specified key
+	  combinations are pressed.
+
+	  To compile this driver as a module, choose M here: the
+	  module will be called keychord.
+
 config INPUT_KEYSPAN_REMOTE
 	tristate "Keyspan DMR USB remote control"
 	depends on USB_ARCH_HAS_HCD
@@ -535,6 +546,11 @@ config INPUT_SGI_BTNS
 	  To compile this driver as a module, choose M here: the
 	  module will be called sgi_btns.
 
+config INPUT_GPIO
+	tristate "GPIO driver support"
+	help
+	  Say Y here if you want to support gpio based keys, wheels etc...
+
 config HP_SDC_RTC
 	tristate "HP SDC Real Time Clock"
 	depends on (GSC || HP300) && SERIO
@@ -831,4 +847,11 @@ config INPUT_HISI_POWERKEY
 	  To compile this driver as a module, choose M here: the
 	  module will be called hisi_powerkey.
 
+config INPUT_G22XX_POWERKEY
+	tristate "G22XX PMIC Power Key support"
+	depends on MFD_G22XX
+	select INPUT_POLLDEV
+	help
+	  This driver supports GMT G22xx PMICs as an input device.
+
 endif
diff --git a/drivers/input/misc/Makefile b/drivers/input/misc/Makefile
index 0b6d025..c6fff1b 100644
--- a/drivers/input/misc/Makefile
+++ b/drivers/input/misc/Makefile
@@ -36,10 +36,12 @@ obj-$(CONFIG_INPUT_GP2A)		+= gp2ap002a00f.o
 obj-$(CONFIG_INPUT_GPIO_BEEPER)		+= gpio-beeper.o
 obj-$(CONFIG_INPUT_GPIO_TILT_POLLED)	+= gpio_tilt_polled.o
 obj-$(CONFIG_INPUT_GPIO_DECODER)	+= gpio_decoder.o
+obj-$(CONFIG_INPUT_GPIO)		+= gpio_event.o gpio_matrix.o gpio_input.o gpio_output.o gpio_axis.o
 obj-$(CONFIG_INPUT_HISI_POWERKEY)	+= hisi_powerkey.o
 obj-$(CONFIG_HP_SDC_RTC)		+= hp_sdc_rtc.o
 obj-$(CONFIG_INPUT_IMS_PCU)		+= ims-pcu.o
 obj-$(CONFIG_INPUT_IXP4XX_BEEPER)	+= ixp4xx-beeper.o
+obj-$(CONFIG_INPUT_KEYCHORD)		+= keychord.o
 obj-$(CONFIG_INPUT_KEYSPAN_REMOTE)	+= keyspan_remote.o
 obj-$(CONFIG_INPUT_KXTJ9)		+= kxtj9.o
 obj-$(CONFIG_INPUT_M68K_BEEP)		+= m68kspkr.o
@@ -78,3 +80,4 @@ obj-$(CONFIG_INPUT_WM831X_ON)		+= wm831x-on.o
 obj-$(CONFIG_INPUT_XEN_KBDDEV_FRONTEND)	+= xen-kbdfront.o
 obj-$(CONFIG_INPUT_YEALINK)		+= yealink.o
 obj-$(CONFIG_INPUT_IDEAPAD_SLIDEBAR)	+= ideapad_slidebar.o
+obj-$(CONFIG_INPUT_G22XX_POWERKEY) += g22xx-powerkey.o
diff --git a/drivers/input/misc/g22xx-powerkey.c b/drivers/input/misc/g22xx-powerkey.c
new file mode 100644
index 00000000..cde6ffb
--- /dev/null
+++ b/drivers/input/misc/g22xx-powerkey.c
@@ -0,0 +1,458 @@
+/*
+ * GMT-G22XX series PMIC Powerkey Driver
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/debugfs.h>
+#include <linux/input.h>
+#include <linux/input-polldev.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/regmap.h>
+#include <linux/slab.h>
+#include <linux/input-polldev.h>
+#include <linux/of.h>
+#include <linux/mfd/g22xx.h>
+#include <linux/mfd/g2227.h>
+#include <linux/ktime.h>
+#include <linux/pm.h>
+
+#define DEFAULT_POLLING_MS    (250)
+
+enum {
+	G22XX_LPOFF_TO_DO,
+	G22XX_ENLPOFF,
+	G22XX_TIME_IT,
+	G22XX_TIME_LP,
+	G22XX_TIME_LPOFF,
+	G22XX_MASK_PWRKEY,
+	G22XX_MASK_LP,
+	G22XX_MASK_IT,
+	G22XX_MAX,
+};
+
+struct g22xx_powerkey_data {
+	struct device *dev;
+	struct g22xx_device *gdev;
+	struct dentry *d;
+	struct input_polled_dev *ipdev;
+
+	struct regmap_field *regs[G22XX_MAX];
+
+	u32 state;
+	u32 lp_emu_left;
+	ktime_t it_timestamp;
+
+	/* config */
+	u32 lp_hw_en:1;
+	u32 lp_sw_en:1;
+	u32 it_sw_en:1;
+	u32 lpoff_sel:2;
+	u32 lpoff_act:1;
+	u32 lp_sel:2;
+	u32 it_sel:2;
+	u32 lp_time;
+	u32 lp_timeout;
+};
+
+static struct reg_field g22xx_powerkey_fields[] = {
+	[G22XX_LPOFF_TO_DO] =  REG_FIELD(G2227_REG_PWRKEY, 7, 7),
+	[G22XX_ENLPOFF]     =  REG_FIELD(G2227_REG_PWRKEY, 6, 6),
+	[G22XX_TIME_IT]     =  REG_FIELD(G2227_REG_PWRKEY, 4, 5),
+	[G22XX_TIME_LP]     =  REG_FIELD(G2227_REG_PWRKEY, 2, 3),
+	[G22XX_TIME_LPOFF]  =  REG_FIELD(G2227_REG_PWRKEY, 0, 1),
+	[G22XX_MASK_PWRKEY] =  REG_FIELD(G2227_REG_INTR_MASK, 5, 5),
+	[G22XX_MASK_LP]     =  REG_FIELD(G2227_REG_INTR_MASK, 4, 4),
+	[G22XX_MASK_IT]     =  REG_FIELD(G2227_REG_INTR_MASK, 3, 3),
+};
+
+static void g22xx_powerkey_set_config(struct g22xx_powerkey_data *pdata,
+				      u32 id,
+				      u32 val)
+{
+	regmap_field_write(pdata->regs[id], val);
+}
+
+static int g22xx_powerkey_show(struct seq_file *s, void *data)
+{
+	struct g22xx_powerkey_data *pdata = s->private;
+	struct regmap *r = pdata->gdev->regmap;
+	u32 val;
+	int ret;
+
+	ret = regmap_read(r, G2227_REG_PWRKEY, &val);
+	if (ret) {
+		seq_puts(s, "faield to read REG_PWRKEY");
+		return 0;
+	}
+
+	seq_printf(s, "TIME_LPOFF=%x\n", val & 0x3);
+	val >>= 2;
+	seq_printf(s, "TIME_LP=%x\n", val & 0x3);
+	val >>= 2;
+	seq_printf(s, "TIME_IT=%x\n", val & 0x3);
+	val >>= 2;
+	seq_printf(s, "ENLPOFF=%x\n", val & 0x1);
+	val >>= 1;
+	seq_printf(s, "LPOFF_TO_DO=%x\n", val & 0x1);
+
+	ret = regmap_read(r, G2227_REG_INTR_MASK, &val);
+	if (ret) {
+		seq_puts(s, "faield to read REG_INTR_MASK");
+		return 0;
+	}
+	val >>= 3;
+	seq_printf(s, "MASK_IT=%x\n", val & 1);
+	val >>= 1;
+	seq_printf(s, "MASK_LP=%x\n", val & 1);
+	val >>= 1;
+	seq_printf(s, "MASK_PWRKEY=%x\n", val & 1);
+
+	return 0;
+}
+
+static int g22xx_powerkey_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, g22xx_powerkey_show, inode->i_private);
+}
+
+static const struct file_operations g22xx_powerkey_fops = {
+	.owner   = THIS_MODULE,
+	.open    = g22xx_powerkey_open,
+	.read    = seq_read,
+	.release = single_release,
+};
+
+enum {
+	G22XX_STATE_DEFAULT,
+	G22XX_STATE_IT_PRESSED,
+};
+
+enum {
+	G22XX_ACT_NONE,
+	G22XX_ACT_KEY_POWEY,
+	G22XX_ACT_KEY_POWEY_LP,
+};
+
+static void g22xx_powerkey_poll(struct input_polled_dev *ipdev)
+{
+	struct g22xx_powerkey_data *pdata = ipdev->private;
+	struct regmap *r = pdata->gdev->regmap;
+	struct input_dev *idev = pdata->ipdev->input;
+	struct device *dev = pdata->dev;
+	ktime_t cur = ktime_get();
+	u32 val, val_c;
+	int ret;
+	u32 next_state;
+	u32 action;
+
+	u32 pwrkey_it;
+	u32 pwrkey_lp;
+	u32 pwrkey;
+	u32 ints;
+
+	if (pdata->lp_emu_left > 0) {
+		if (pdata->lp_emu_left-- == 1) {
+			input_report_key(idev, KEY_POWER, 0);
+			input_sync(idev);
+			dev_dbg(dev, "pwrkey longpress stop\n");
+
+			/* clear ints */
+			regmap_read(r, 0x00, &val);
+		}
+		return;
+	}
+
+	ret = regmap_read(r, 0x00, &val);
+	if (ret) {
+		dev_warn(dev, "failed to read from regmap: %d\n", ret);
+		return;
+	}
+
+	val_c = val;
+	val >>= 3;
+	pwrkey_it = val & 0x1;
+	val >>= 1;
+	pwrkey_lp = val & 0x1;
+	val >>= 1;
+	pwrkey = val & 0x1;
+	val >>= 2;
+	ints = val & 0x1;
+	val = val_c;
+
+	if (val != 0)
+		dev_dbg(pdata->dev, "read=%02x, pwrkey_it=%d, pwrkey_lp=%d, pwrkey=%d, ints=%d\n",
+			val, pwrkey_it, pwrkey_lp, pwrkey, ints);
+
+	action = G22XX_ACT_NONE;
+	next_state = pdata->state;
+	switch (pdata->state) {
+	case G22XX_STATE_DEFAULT:
+		if (pwrkey_it == 1) {
+			/* unnecessary to check when no sw lp */
+			if (pdata->lp_sw_en == 0) {
+				action = G22XX_ACT_KEY_POWEY;
+			} else {
+				next_state = G22XX_STATE_IT_PRESSED;
+				pdata->it_timestamp = cur;
+			}
+		} else if (pwrkey_lp == 1) {
+			action = G22XX_ACT_KEY_POWEY_LP;
+		}
+		break;
+
+	case G22XX_STATE_IT_PRESSED:
+		next_state = G22XX_STATE_DEFAULT;
+		if (pwrkey == 1) {
+			dev_dbg(dev, "state_it: pwrkey press\n");
+			action = G22XX_ACT_KEY_POWEY;
+		} else if (pwrkey_lp == 1) {
+			dev_dbg(dev, "state_it: pwrkey long press\n");
+			action = G22XX_ACT_KEY_POWEY_LP;
+		} else if (ktime_ms_delta(cur, pdata->it_timestamp) >=
+			   pdata->lp_timeout) {
+			dev_dbg(dev, "state_it: pwrkey long press timeout\n");
+			action = G22XX_ACT_KEY_POWEY;
+		} else
+			next_state = G22XX_STATE_IT_PRESSED;
+		break;
+	default:
+		break;
+	}
+	pdata->state = next_state;
+
+	switch (action) {
+	case G22XX_ACT_KEY_POWEY_LP:
+		dev_dbg(dev, "pwrkey longpress start\n");
+		pdata->lp_emu_left = DIV_ROUND_UP(pdata->lp_time,
+						  pdata->ipdev->poll_interval);
+		input_report_key(idev, KEY_POWER, 1);
+		input_sync(idev);
+		break;
+	case G22XX_ACT_KEY_POWEY:
+		dev_dbg(dev, "pwrkey press\n");
+		input_report_key(idev, KEY_POWER, 1);
+		input_sync(idev);
+		input_report_key(idev, KEY_POWER, 0);
+		input_sync(idev);
+		break;
+	default:
+		break;
+	}
+}
+
+static int g22xx_powerkey_parse_dt(struct device_node *np,
+				   struct g22xx_powerkey_data *pdata)
+{
+	const char *str;
+	u32 val[3];
+
+	pdata->lp_hw_en = pdata->lp_sw_en = 0;
+	if (!of_property_read_string(np, "lp-handler", &str)) {
+		if (!strncmp("hw", str, 2))
+			pdata->lp_hw_en = 1;
+		else if (!strncmp("sw", str, 2))
+			pdata->lp_sw_en = 1;
+	}
+
+	pdata->it_sw_en = 0;
+	if (!of_property_read_string(np, "it-handler", &str)) {
+		if (!strncmp("sw", str, 2))
+			pdata->it_sw_en = 1;
+	}
+
+	pdata->it_sel = 0;
+	pdata->lp_sel = 1;
+	pdata->lpoff_sel = 3;
+	if (!of_property_read_u32_array(np, "time-sel", val, 3)) {
+		pdata->it_sel = val[0];
+		pdata->lp_sel = val[1];
+		pdata->lpoff_sel = val[2];
+	}
+
+	pdata->lp_time = (pdata->lp_sel + 1) * 1000;
+	pdata->lp_timeout = pdata->lp_time + DEFAULT_POLLING_MS + 1;
+
+	pdata->lpoff_act = 1;
+	if (!of_property_read_u32(np, "lpoff-act", val))
+		pdata->lpoff_act = *val;
+
+	dev_info(pdata->dev, "lp=%s, it=%s, sel=[%d,%d,%d]\n",
+		pdata->lp_hw_en ? "hw" : (pdata->lp_sw_en ? "sw" : "none"),
+		pdata->it_sw_en ? "sw" : "none",
+		pdata->it_sel, pdata->lp_sel, pdata->lpoff_sel);
+
+	return 0;
+}
+
+static int g22xx_powerkey_apply_config(struct g22xx_powerkey_data *pdata)
+{
+	if (pdata->lp_hw_en == 1) {
+		g22xx_powerkey_set_config(pdata, G22XX_ENLPOFF, 1);
+		g22xx_powerkey_set_config(pdata, G22XX_TIME_LPOFF,
+					  pdata->lpoff_sel);
+		g22xx_powerkey_set_config(pdata, G22XX_MASK_LP, 1);
+		g22xx_powerkey_set_config(pdata, G22XX_LPOFF_TO_DO,
+					  pdata->lpoff_act);
+	} else if (pdata->lp_sw_en == 1) {
+		g22xx_powerkey_set_config(pdata, G22XX_ENLPOFF, 0);
+		g22xx_powerkey_set_config(pdata, G22XX_TIME_LP, pdata->lp_sel);
+		g22xx_powerkey_set_config(pdata, G22XX_MASK_LP, 0);
+	} else {
+		g22xx_powerkey_set_config(pdata, G22XX_ENLPOFF, 0);
+		g22xx_powerkey_set_config(pdata, G22XX_MASK_LP, 1);
+	}
+
+	if (pdata->it_sw_en == 1) {
+		g22xx_powerkey_set_config(pdata, G22XX_TIME_IT, pdata->it_sel);
+		g22xx_powerkey_set_config(pdata, G22XX_MASK_IT, 0);
+	} else {
+		g22xx_powerkey_set_config(pdata, G22XX_MASK_IT, 1);
+	}
+
+	return 0;
+}
+
+static int g22xx_powerkey_suspend(struct device *dev)
+{
+	struct g22xx_powerkey_data *pdata = dev_get_drvdata(dev);
+
+	dev_info(dev, "enter %s\n", __func__);
+	g22xx_powerkey_set_config(pdata, G22XX_ENLPOFF, 1);
+	g22xx_powerkey_set_config(pdata, G22XX_LPOFF_TO_DO, pdata->lpoff_act);
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static int g22xx_powerkey_resume(struct device *dev)
+{
+	struct g22xx_powerkey_data *pdata = dev_get_drvdata(dev);
+
+	dev_info(dev, "enter %s\n", __func__);
+	g22xx_powerkey_apply_config(pdata);
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops g22xx_powerkey_pm_ops = {
+	.suspend = g22xx_powerkey_suspend,
+	.resume  = g22xx_powerkey_resume,
+};
+
+static int g22xx_powerkey_probe(struct platform_device *pdev)
+{
+	struct g22xx_powerkey_data *pdata;
+	struct device *dev = &pdev->dev;
+	struct g22xx_device *gdev = dev_get_drvdata(dev->parent);
+	struct input_dev *idev;
+	int ret;
+	int i;
+
+	if (!dev->of_node || !of_device_is_available(dev->of_node))
+		return -ENODEV;
+
+	if (!gdev) {
+		dev_err(dev, "no parent device\n");
+		return -EINVAL;
+	}
+
+	pdata = devm_kzalloc(dev, sizeof(*pdata), GFP_KERNEL);
+	if (!pdata)
+		return -ENOMEM;
+
+
+	pdata->ipdev = devm_input_allocate_polled_device(dev);
+	if (!pdata->ipdev)
+		return -ENOMEM;
+
+	for (i = 0; i < G22XX_MAX; i++) {
+		pdata->regs[i] = devm_regmap_field_alloc(dev, gdev->regmap,
+						g22xx_powerkey_fields[i]);
+		if (IS_ERR(pdata->regs[i])) {
+			ret = PTR_ERR(pdata->regs[i]);
+			dev_err(dev, "failed to alloc regmap field %d: %d\n", i,
+				ret);
+			return ret;
+		}
+	}
+
+	pdata->dev = dev;
+	pdata->gdev = gdev;
+	g22xx_powerkey_parse_dt(dev->of_node, pdata);
+	g22xx_powerkey_apply_config(pdata);
+
+	if (!pdata->lp_sw_en && !pdata->it_sw_en)
+		goto no_input_polldev;
+
+	pdata->ipdev->poll = g22xx_powerkey_poll;
+	pdata->ipdev->poll_interval = DEFAULT_POLLING_MS;
+	pdata->ipdev->private = pdata;
+
+	idev = pdata->ipdev->input;
+	idev->name = "g22xx-powerkey";
+	idev->phys = "g22xx-powerkey/input0";
+	idev->id.bustype = BUS_HOST;
+	idev->dev.parent = dev;
+	input_set_capability(idev, EV_KEY, KEY_POWER);
+
+	ret = input_register_polled_device(pdata->ipdev);
+	if (ret) {
+		dev_err(dev, "failed to register input polled device\n");
+		return ret;
+	}
+no_input_polldev:
+	pdata->d = debugfs_create_file("g22xx_powerkey_info", 0444, NULL, pdata,
+				       &g22xx_powerkey_fops);
+	if (!pdata->d)
+		dev_warn(dev, "debugfs_create_file() failed\n");
+	platform_set_drvdata(pdev, pdata);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static int g22xx_powerkey_remove(struct platform_device *pdev)
+{
+	struct g22xx_powerkey_data *pdata = platform_get_drvdata(pdev);
+	struct device *dev = &pdev->dev;
+
+	platform_set_drvdata(pdev, NULL);
+	debugfs_remove(pdata->d);
+	if (pdata->lp_sw_en || pdata->it_sw_en)
+		input_unregister_polled_device(pdata->ipdev);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+static const struct of_device_id g22xx_powerkey_ids[] = {
+	{ .compatible = "gmt,g22xx-powerkey", },
+	{}
+};
+
+static struct platform_driver g22xx_powerkey_driver = {
+	.probe = g22xx_powerkey_probe,
+	.remove = g22xx_powerkey_remove,
+	.driver = {
+		.name = "g22xx-powerkey",
+		.of_match_table = g22xx_powerkey_ids,
+		.pm = &g22xx_powerkey_pm_ops,
+	},
+};
+module_platform_driver(g22xx_powerkey_driver);
+
diff --git a/drivers/input/misc/gpio_axis.c b/drivers/input/misc/gpio_axis.c
new file mode 100644
index 00000000..0acf4a5
--- /dev/null
+++ b/drivers/input/misc/gpio_axis.c
@@ -0,0 +1,192 @@
+/* drivers/input/misc/gpio_axis.c
+ *
+ * Copyright (C) 2007 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/gpio.h>
+#include <linux/gpio_event.h>
+#include <linux/interrupt.h>
+#include <linux/slab.h>
+
+struct gpio_axis_state {
+	struct gpio_event_input_devs *input_devs;
+	struct gpio_event_axis_info *info;
+	uint32_t pos;
+};
+
+uint16_t gpio_axis_4bit_gray_map_table[] = {
+	[0x0] = 0x0, [0x1] = 0x1, /* 0000 0001 */
+	[0x3] = 0x2, [0x2] = 0x3, /* 0011 0010 */
+	[0x6] = 0x4, [0x7] = 0x5, /* 0110 0111 */
+	[0x5] = 0x6, [0x4] = 0x7, /* 0101 0100 */
+	[0xc] = 0x8, [0xd] = 0x9, /* 1100 1101 */
+	[0xf] = 0xa, [0xe] = 0xb, /* 1111 1110 */
+	[0xa] = 0xc, [0xb] = 0xd, /* 1010 1011 */
+	[0x9] = 0xe, [0x8] = 0xf, /* 1001 1000 */
+};
+uint16_t gpio_axis_4bit_gray_map(struct gpio_event_axis_info *info, uint16_t in)
+{
+	return gpio_axis_4bit_gray_map_table[in];
+}
+
+uint16_t gpio_axis_5bit_singletrack_map_table[] = {
+	[0x10] = 0x00, [0x14] = 0x01, [0x1c] = 0x02, /*     10000 10100 11100 */
+	[0x1e] = 0x03, [0x1a] = 0x04, [0x18] = 0x05, /*     11110 11010 11000 */
+	[0x08] = 0x06, [0x0a] = 0x07, [0x0e] = 0x08, /*    01000 01010 01110  */
+	[0x0f] = 0x09, [0x0d] = 0x0a, [0x0c] = 0x0b, /*    01111 01101 01100  */
+	[0x04] = 0x0c, [0x05] = 0x0d, [0x07] = 0x0e, /*   00100 00101 00111   */
+	[0x17] = 0x0f, [0x16] = 0x10, [0x06] = 0x11, /*   10111 10110 00110   */
+	[0x02] = 0x12, [0x12] = 0x13, [0x13] = 0x14, /*  00010 10010 10011    */
+	[0x1b] = 0x15, [0x0b] = 0x16, [0x03] = 0x17, /*  11011 01011 00011    */
+	[0x01] = 0x18, [0x09] = 0x19, [0x19] = 0x1a, /* 00001 01001 11001     */
+	[0x1d] = 0x1b, [0x15] = 0x1c, [0x11] = 0x1d, /* 11101 10101 10001     */
+};
+uint16_t gpio_axis_5bit_singletrack_map(
+	struct gpio_event_axis_info *info, uint16_t in)
+{
+	return gpio_axis_5bit_singletrack_map_table[in];
+}
+
+static void gpio_event_update_axis(struct gpio_axis_state *as, int report)
+{
+	struct gpio_event_axis_info *ai = as->info;
+	int i;
+	int change;
+	uint16_t state = 0;
+	uint16_t pos;
+	uint16_t old_pos = as->pos;
+	for (i = ai->count - 1; i >= 0; i--)
+		state = (state << 1) | gpio_get_value(ai->gpio[i]);
+	pos = ai->map(ai, state);
+	if (ai->flags & GPIOEAF_PRINT_RAW)
+		pr_info("axis %d-%d raw %x, pos %d -> %d\n",
+			ai->type, ai->code, state, old_pos, pos);
+	if (report && pos != old_pos) {
+		if (ai->type == EV_REL) {
+			change = (ai->decoded_size + pos - old_pos) %
+				  ai->decoded_size;
+			if (change > ai->decoded_size / 2)
+				change -= ai->decoded_size;
+			if (change == ai->decoded_size / 2) {
+				if (ai->flags & GPIOEAF_PRINT_EVENT)
+					pr_info("axis %d-%d unknown direction, "
+						"pos %d -> %d\n", ai->type,
+						ai->code, old_pos, pos);
+				change = 0; /* no closest direction */
+			}
+			if (ai->flags & GPIOEAF_PRINT_EVENT)
+				pr_info("axis %d-%d change %d\n",
+					ai->type, ai->code, change);
+			input_report_rel(as->input_devs->dev[ai->dev],
+						ai->code, change);
+		} else {
+			if (ai->flags & GPIOEAF_PRINT_EVENT)
+				pr_info("axis %d-%d now %d\n",
+					ai->type, ai->code, pos);
+			input_event(as->input_devs->dev[ai->dev],
+					ai->type, ai->code, pos);
+		}
+		input_sync(as->input_devs->dev[ai->dev]);
+	}
+	as->pos = pos;
+}
+
+static irqreturn_t gpio_axis_irq_handler(int irq, void *dev_id)
+{
+	struct gpio_axis_state *as = dev_id;
+	gpio_event_update_axis(as, 1);
+	return IRQ_HANDLED;
+}
+
+int gpio_event_axis_func(struct gpio_event_input_devs *input_devs,
+			 struct gpio_event_info *info, void **data, int func)
+{
+	int ret;
+	int i;
+	int irq;
+	struct gpio_event_axis_info *ai;
+	struct gpio_axis_state *as;
+
+	ai = container_of(info, struct gpio_event_axis_info, info);
+	if (func == GPIO_EVENT_FUNC_SUSPEND) {
+		for (i = 0; i < ai->count; i++)
+			disable_irq(gpio_to_irq(ai->gpio[i]));
+		return 0;
+	}
+	if (func == GPIO_EVENT_FUNC_RESUME) {
+		for (i = 0; i < ai->count; i++)
+			enable_irq(gpio_to_irq(ai->gpio[i]));
+		return 0;
+	}
+
+	if (func == GPIO_EVENT_FUNC_INIT) {
+		*data = as = kmalloc(sizeof(*as), GFP_KERNEL);
+		if (as == NULL) {
+			ret = -ENOMEM;
+			goto err_alloc_axis_state_failed;
+		}
+		as->input_devs = input_devs;
+		as->info = ai;
+		if (ai->dev >= input_devs->count) {
+			pr_err("gpio_event_axis: bad device index %d >= %d "
+				"for %d:%d\n", ai->dev, input_devs->count,
+				ai->type, ai->code);
+			ret = -EINVAL;
+			goto err_bad_device_index;
+		}
+
+		input_set_capability(input_devs->dev[ai->dev],
+				     ai->type, ai->code);
+		if (ai->type == EV_ABS) {
+			input_set_abs_params(input_devs->dev[ai->dev], ai->code,
+					     0, ai->decoded_size - 1, 0, 0);
+		}
+		for (i = 0; i < ai->count; i++) {
+			ret = gpio_request(ai->gpio[i], "gpio_event_axis");
+			if (ret < 0)
+				goto err_request_gpio_failed;
+			ret = gpio_direction_input(ai->gpio[i]);
+			if (ret < 0)
+				goto err_gpio_direction_input_failed;
+			ret = irq = gpio_to_irq(ai->gpio[i]);
+			if (ret < 0)
+				goto err_get_irq_num_failed;
+			ret = request_irq(irq, gpio_axis_irq_handler,
+					  IRQF_TRIGGER_RISING |
+					  IRQF_TRIGGER_FALLING,
+					  "gpio_event_axis", as);
+			if (ret < 0)
+				goto err_request_irq_failed;
+		}
+		gpio_event_update_axis(as, 0);
+		return 0;
+	}
+
+	ret = 0;
+	as = *data;
+	for (i = ai->count - 1; i >= 0; i--) {
+		free_irq(gpio_to_irq(ai->gpio[i]), as);
+err_request_irq_failed:
+err_get_irq_num_failed:
+err_gpio_direction_input_failed:
+		gpio_free(ai->gpio[i]);
+err_request_gpio_failed:
+		;
+	}
+err_bad_device_index:
+	kfree(as);
+	*data = NULL;
+err_alloc_axis_state_failed:
+	return ret;
+}
diff --git a/drivers/input/misc/gpio_event.c b/drivers/input/misc/gpio_event.c
new file mode 100644
index 00000000..90f07eb
--- /dev/null
+++ b/drivers/input/misc/gpio_event.c
@@ -0,0 +1,228 @@
+/* drivers/input/misc/gpio_event.c
+ *
+ * Copyright (C) 2007 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/module.h>
+#include <linux/input.h>
+#include <linux/gpio_event.h>
+#include <linux/hrtimer.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+
+struct gpio_event {
+	struct gpio_event_input_devs *input_devs;
+	const struct gpio_event_platform_data *info;
+	void *state[0];
+};
+
+static int gpio_input_event(
+	struct input_dev *dev, unsigned int type, unsigned int code, int value)
+{
+	int i;
+	int devnr;
+	int ret = 0;
+	int tmp_ret;
+	struct gpio_event_info **ii;
+	struct gpio_event *ip = input_get_drvdata(dev);
+
+	for (devnr = 0; devnr < ip->input_devs->count; devnr++)
+		if (ip->input_devs->dev[devnr] == dev)
+			break;
+	if (devnr == ip->input_devs->count) {
+		pr_err("gpio_input_event: unknown device %p\n", dev);
+		return -EIO;
+	}
+
+	for (i = 0, ii = ip->info->info; i < ip->info->info_count; i++, ii++) {
+		if ((*ii)->event) {
+			tmp_ret = (*ii)->event(ip->input_devs, *ii,
+						&ip->state[i],
+						devnr, type, code, value);
+			if (tmp_ret)
+				ret = tmp_ret;
+		}
+	}
+	return ret;
+}
+
+static int gpio_event_call_all_func(struct gpio_event *ip, int func)
+{
+	int i;
+	int ret;
+	struct gpio_event_info **ii;
+
+	if (func == GPIO_EVENT_FUNC_INIT || func == GPIO_EVENT_FUNC_RESUME) {
+		ii = ip->info->info;
+		for (i = 0; i < ip->info->info_count; i++, ii++) {
+			if ((*ii)->func == NULL) {
+				ret = -ENODEV;
+				pr_err("gpio_event_probe: Incomplete pdata, "
+					"no function\n");
+				goto err_no_func;
+			}
+			if (func == GPIO_EVENT_FUNC_RESUME && (*ii)->no_suspend)
+				continue;
+			ret = (*ii)->func(ip->input_devs, *ii, &ip->state[i],
+					  func);
+			if (ret) {
+				pr_err("gpio_event_probe: function failed\n");
+				goto err_func_failed;
+			}
+		}
+		return 0;
+	}
+
+	ret = 0;
+	i = ip->info->info_count;
+	ii = ip->info->info + i;
+	while (i > 0) {
+		i--;
+		ii--;
+		if ((func & ~1) == GPIO_EVENT_FUNC_SUSPEND && (*ii)->no_suspend)
+			continue;
+		(*ii)->func(ip->input_devs, *ii, &ip->state[i], func & ~1);
+err_func_failed:
+err_no_func:
+		;
+	}
+	return ret;
+}
+
+static void __maybe_unused gpio_event_suspend(struct gpio_event *ip)
+{
+	gpio_event_call_all_func(ip, GPIO_EVENT_FUNC_SUSPEND);
+	if (ip->info->power)
+		ip->info->power(ip->info, 0);
+}
+
+static void __maybe_unused gpio_event_resume(struct gpio_event *ip)
+{
+	if (ip->info->power)
+		ip->info->power(ip->info, 1);
+	gpio_event_call_all_func(ip, GPIO_EVENT_FUNC_RESUME);
+}
+
+static int gpio_event_probe(struct platform_device *pdev)
+{
+	int err;
+	struct gpio_event *ip;
+	struct gpio_event_platform_data *event_info;
+	int dev_count = 1;
+	int i;
+	int registered = 0;
+
+	event_info = pdev->dev.platform_data;
+	if (event_info == NULL) {
+		pr_err("gpio_event_probe: No pdata\n");
+		return -ENODEV;
+	}
+	if ((!event_info->name && !event_info->names[0]) ||
+	    !event_info->info || !event_info->info_count) {
+		pr_err("gpio_event_probe: Incomplete pdata\n");
+		return -ENODEV;
+	}
+	if (!event_info->name)
+		while (event_info->names[dev_count])
+			dev_count++;
+	ip = kzalloc(sizeof(*ip) +
+		     sizeof(ip->state[0]) * event_info->info_count +
+		     sizeof(*ip->input_devs) +
+		     sizeof(ip->input_devs->dev[0]) * dev_count, GFP_KERNEL);
+	if (ip == NULL) {
+		err = -ENOMEM;
+		pr_err("gpio_event_probe: Failed to allocate private data\n");
+		goto err_kp_alloc_failed;
+	}
+	ip->input_devs = (void*)&ip->state[event_info->info_count];
+	platform_set_drvdata(pdev, ip);
+
+	for (i = 0; i < dev_count; i++) {
+		struct input_dev *input_dev = input_allocate_device();
+		if (input_dev == NULL) {
+			err = -ENOMEM;
+			pr_err("gpio_event_probe: "
+				"Failed to allocate input device\n");
+			goto err_input_dev_alloc_failed;
+		}
+		input_set_drvdata(input_dev, ip);
+		input_dev->name = event_info->name ?
+					event_info->name : event_info->names[i];
+		input_dev->event = gpio_input_event;
+		ip->input_devs->dev[i] = input_dev;
+	}
+	ip->input_devs->count = dev_count;
+	ip->info = event_info;
+	if (event_info->power)
+		ip->info->power(ip->info, 1);
+
+	err = gpio_event_call_all_func(ip, GPIO_EVENT_FUNC_INIT);
+	if (err)
+		goto err_call_all_func_failed;
+
+	for (i = 0; i < dev_count; i++) {
+		err = input_register_device(ip->input_devs->dev[i]);
+		if (err) {
+			pr_err("gpio_event_probe: Unable to register %s "
+				"input device\n", ip->input_devs->dev[i]->name);
+			goto err_input_register_device_failed;
+		}
+		registered++;
+	}
+
+	return 0;
+
+err_input_register_device_failed:
+	gpio_event_call_all_func(ip, GPIO_EVENT_FUNC_UNINIT);
+err_call_all_func_failed:
+	if (event_info->power)
+		ip->info->power(ip->info, 0);
+	for (i = 0; i < registered; i++)
+		input_unregister_device(ip->input_devs->dev[i]);
+	for (i = dev_count - 1; i >= registered; i--) {
+		input_free_device(ip->input_devs->dev[i]);
+err_input_dev_alloc_failed:
+		;
+	}
+	kfree(ip);
+err_kp_alloc_failed:
+	return err;
+}
+
+static int gpio_event_remove(struct platform_device *pdev)
+{
+	struct gpio_event *ip = platform_get_drvdata(pdev);
+	int i;
+
+	gpio_event_call_all_func(ip, GPIO_EVENT_FUNC_UNINIT);
+	if (ip->info->power)
+		ip->info->power(ip->info, 0);
+	for (i = 0; i < ip->input_devs->count; i++)
+		input_unregister_device(ip->input_devs->dev[i]);
+	kfree(ip);
+	return 0;
+}
+
+static struct platform_driver gpio_event_driver = {
+	.probe		= gpio_event_probe,
+	.remove		= gpio_event_remove,
+	.driver		= {
+		.name	= GPIO_EVENT_DEV_NAME,
+	},
+};
+
+module_platform_driver(gpio_event_driver);
+
+MODULE_DESCRIPTION("GPIO Event Driver");
+MODULE_LICENSE("GPL");
+
diff --git a/drivers/input/misc/gpio_input.c b/drivers/input/misc/gpio_input.c
new file mode 100644
index 00000000..eefd027
--- /dev/null
+++ b/drivers/input/misc/gpio_input.c
@@ -0,0 +1,390 @@
+/* drivers/input/misc/gpio_input.c
+ *
+ * Copyright (C) 2007 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/gpio.h>
+#include <linux/gpio_event.h>
+#include <linux/hrtimer.h>
+#include <linux/input.h>
+#include <linux/interrupt.h>
+#include <linux/slab.h>
+#include <linux/pm_wakeup.h>
+
+enum {
+	DEBOUNCE_UNSTABLE     = BIT(0),	/* Got irq, while debouncing */
+	DEBOUNCE_PRESSED      = BIT(1),
+	DEBOUNCE_NOTPRESSED   = BIT(2),
+	DEBOUNCE_WAIT_IRQ     = BIT(3),	/* Stable irq state */
+	DEBOUNCE_POLL         = BIT(4),	/* Stable polling state */
+
+	DEBOUNCE_UNKNOWN =
+		DEBOUNCE_PRESSED | DEBOUNCE_NOTPRESSED,
+};
+
+struct gpio_key_state {
+	struct gpio_input_state *ds;
+	uint8_t debounce;
+};
+
+struct gpio_input_state {
+	struct gpio_event_input_devs *input_devs;
+	const struct gpio_event_input_info *info;
+	struct hrtimer timer;
+	int use_irq;
+	int debounce_count;
+	spinlock_t irq_lock;
+	struct wakeup_source *ws;
+	struct gpio_key_state key_state[0];
+};
+
+static enum hrtimer_restart gpio_event_input_timer_func(struct hrtimer *timer)
+{
+	int i;
+	int pressed;
+	struct gpio_input_state *ds =
+		container_of(timer, struct gpio_input_state, timer);
+	unsigned gpio_flags = ds->info->flags;
+	unsigned npolarity;
+	int nkeys = ds->info->keymap_size;
+	const struct gpio_event_direct_entry *key_entry;
+	struct gpio_key_state *key_state;
+	unsigned long irqflags;
+	uint8_t debounce;
+	bool sync_needed;
+
+#if 0
+	key_entry = kp->keys_info->keymap;
+	key_state = kp->key_state;
+	for (i = 0; i < nkeys; i++, key_entry++, key_state++)
+		pr_info("gpio_read_detect_status %d %d\n", key_entry->gpio,
+			gpio_read_detect_status(key_entry->gpio));
+#endif
+	key_entry = ds->info->keymap;
+	key_state = ds->key_state;
+	sync_needed = false;
+	spin_lock_irqsave(&ds->irq_lock, irqflags);
+	for (i = 0; i < nkeys; i++, key_entry++, key_state++) {
+		debounce = key_state->debounce;
+		if (debounce & DEBOUNCE_WAIT_IRQ)
+			continue;
+		if (key_state->debounce & DEBOUNCE_UNSTABLE) {
+			debounce = key_state->debounce = DEBOUNCE_UNKNOWN;
+			enable_irq(gpio_to_irq(key_entry->gpio));
+			if (gpio_flags & GPIOEDF_PRINT_KEY_UNSTABLE)
+				pr_info("gpio_keys_scan_keys: key %x-%x, %d "
+					"(%d) continue debounce\n",
+					ds->info->type, key_entry->code,
+					i, key_entry->gpio);
+		}
+		npolarity = !(gpio_flags & GPIOEDF_ACTIVE_HIGH);
+		pressed = gpio_get_value(key_entry->gpio) ^ npolarity;
+		if (debounce & DEBOUNCE_POLL) {
+			if (pressed == !(debounce & DEBOUNCE_PRESSED)) {
+				ds->debounce_count++;
+				key_state->debounce = DEBOUNCE_UNKNOWN;
+				if (gpio_flags & GPIOEDF_PRINT_KEY_DEBOUNCE)
+					pr_info("gpio_keys_scan_keys: key %x-"
+						"%x, %d (%d) start debounce\n",
+						ds->info->type, key_entry->code,
+						i, key_entry->gpio);
+			}
+			continue;
+		}
+		if (pressed && (debounce & DEBOUNCE_NOTPRESSED)) {
+			if (gpio_flags & GPIOEDF_PRINT_KEY_DEBOUNCE)
+				pr_info("gpio_keys_scan_keys: key %x-%x, %d "
+					"(%d) debounce pressed 1\n",
+					ds->info->type, key_entry->code,
+					i, key_entry->gpio);
+			key_state->debounce = DEBOUNCE_PRESSED;
+			continue;
+		}
+		if (!pressed && (debounce & DEBOUNCE_PRESSED)) {
+			if (gpio_flags & GPIOEDF_PRINT_KEY_DEBOUNCE)
+				pr_info("gpio_keys_scan_keys: key %x-%x, %d "
+					"(%d) debounce pressed 0\n",
+					ds->info->type, key_entry->code,
+					i, key_entry->gpio);
+			key_state->debounce = DEBOUNCE_NOTPRESSED;
+			continue;
+		}
+		/* key is stable */
+		ds->debounce_count--;
+		if (ds->use_irq)
+			key_state->debounce |= DEBOUNCE_WAIT_IRQ;
+		else
+			key_state->debounce |= DEBOUNCE_POLL;
+		if (gpio_flags & GPIOEDF_PRINT_KEYS)
+			pr_info("gpio_keys_scan_keys: key %x-%x, %d (%d) "
+				"changed to %d\n", ds->info->type,
+				key_entry->code, i, key_entry->gpio, pressed);
+		input_event(ds->input_devs->dev[key_entry->dev], ds->info->type,
+			    key_entry->code, pressed);
+		sync_needed = true;
+	}
+	if (sync_needed) {
+		for (i = 0; i < ds->input_devs->count; i++)
+			input_sync(ds->input_devs->dev[i]);
+	}
+
+#if 0
+	key_entry = kp->keys_info->keymap;
+	key_state = kp->key_state;
+	for (i = 0; i < nkeys; i++, key_entry++, key_state++) {
+		pr_info("gpio_read_detect_status %d %d\n", key_entry->gpio,
+			gpio_read_detect_status(key_entry->gpio));
+	}
+#endif
+
+	if (ds->debounce_count)
+		hrtimer_start(timer, ds->info->debounce_time, HRTIMER_MODE_REL);
+	else if (!ds->use_irq)
+		hrtimer_start(timer, ds->info->poll_time, HRTIMER_MODE_REL);
+	else
+		__pm_relax(ds->ws);
+
+	spin_unlock_irqrestore(&ds->irq_lock, irqflags);
+
+	return HRTIMER_NORESTART;
+}
+
+static irqreturn_t gpio_event_input_irq_handler(int irq, void *dev_id)
+{
+	struct gpio_key_state *ks = dev_id;
+	struct gpio_input_state *ds = ks->ds;
+	int keymap_index = ks - ds->key_state;
+	const struct gpio_event_direct_entry *key_entry;
+	unsigned long irqflags;
+	int pressed;
+
+	if (!ds->use_irq)
+		return IRQ_HANDLED;
+
+	key_entry = &ds->info->keymap[keymap_index];
+
+	if (ds->info->debounce_time.tv64) {
+		spin_lock_irqsave(&ds->irq_lock, irqflags);
+		if (ks->debounce & DEBOUNCE_WAIT_IRQ) {
+			ks->debounce = DEBOUNCE_UNKNOWN;
+			if (ds->debounce_count++ == 0) {
+				__pm_stay_awake(ds->ws);
+				hrtimer_start(
+					&ds->timer, ds->info->debounce_time,
+					HRTIMER_MODE_REL);
+			}
+			if (ds->info->flags & GPIOEDF_PRINT_KEY_DEBOUNCE)
+				pr_info("gpio_event_input_irq_handler: "
+					"key %x-%x, %d (%d) start debounce\n",
+					ds->info->type, key_entry->code,
+					keymap_index, key_entry->gpio);
+		} else {
+			disable_irq_nosync(irq);
+			ks->debounce = DEBOUNCE_UNSTABLE;
+		}
+		spin_unlock_irqrestore(&ds->irq_lock, irqflags);
+	} else {
+		pressed = gpio_get_value(key_entry->gpio) ^
+			!(ds->info->flags & GPIOEDF_ACTIVE_HIGH);
+		if (ds->info->flags & GPIOEDF_PRINT_KEYS)
+			pr_info("gpio_event_input_irq_handler: key %x-%x, %d "
+				"(%d) changed to %d\n",
+				ds->info->type, key_entry->code, keymap_index,
+				key_entry->gpio, pressed);
+		input_event(ds->input_devs->dev[key_entry->dev], ds->info->type,
+			    key_entry->code, pressed);
+		input_sync(ds->input_devs->dev[key_entry->dev]);
+	}
+	return IRQ_HANDLED;
+}
+
+static int gpio_event_input_request_irqs(struct gpio_input_state *ds)
+{
+	int i;
+	int err;
+	unsigned int irq;
+	unsigned long req_flags = IRQF_TRIGGER_RISING | IRQF_TRIGGER_FALLING;
+
+	for (i = 0; i < ds->info->keymap_size; i++) {
+		err = irq = gpio_to_irq(ds->info->keymap[i].gpio);
+		if (err < 0)
+			goto err_gpio_get_irq_num_failed;
+		err = request_irq(irq, gpio_event_input_irq_handler,
+				  req_flags, "gpio_keys", &ds->key_state[i]);
+		if (err) {
+			pr_err("gpio_event_input_request_irqs: request_irq "
+				"failed for input %d, irq %d\n",
+				ds->info->keymap[i].gpio, irq);
+			goto err_request_irq_failed;
+		}
+		if (ds->info->info.no_suspend) {
+			err = enable_irq_wake(irq);
+			if (err) {
+				pr_err("gpio_event_input_request_irqs: "
+					"enable_irq_wake failed for input %d, "
+					"irq %d\n",
+					ds->info->keymap[i].gpio, irq);
+				goto err_enable_irq_wake_failed;
+			}
+		}
+	}
+	return 0;
+
+	for (i = ds->info->keymap_size - 1; i >= 0; i--) {
+		irq = gpio_to_irq(ds->info->keymap[i].gpio);
+		if (ds->info->info.no_suspend)
+			disable_irq_wake(irq);
+err_enable_irq_wake_failed:
+		free_irq(irq, &ds->key_state[i]);
+err_request_irq_failed:
+err_gpio_get_irq_num_failed:
+		;
+	}
+	return err;
+}
+
+int gpio_event_input_func(struct gpio_event_input_devs *input_devs,
+			struct gpio_event_info *info, void **data, int func)
+{
+	int ret;
+	int i;
+	unsigned long irqflags;
+	struct gpio_event_input_info *di;
+	struct gpio_input_state *ds = *data;
+	char *wlname;
+
+	di = container_of(info, struct gpio_event_input_info, info);
+
+	if (func == GPIO_EVENT_FUNC_SUSPEND) {
+		if (ds->use_irq)
+			for (i = 0; i < di->keymap_size; i++)
+				disable_irq(gpio_to_irq(di->keymap[i].gpio));
+		hrtimer_cancel(&ds->timer);
+		return 0;
+	}
+	if (func == GPIO_EVENT_FUNC_RESUME) {
+		spin_lock_irqsave(&ds->irq_lock, irqflags);
+		if (ds->use_irq)
+			for (i = 0; i < di->keymap_size; i++)
+				enable_irq(gpio_to_irq(di->keymap[i].gpio));
+		hrtimer_start(&ds->timer, ktime_set(0, 0), HRTIMER_MODE_REL);
+		spin_unlock_irqrestore(&ds->irq_lock, irqflags);
+		return 0;
+	}
+
+	if (func == GPIO_EVENT_FUNC_INIT) {
+		if (ktime_to_ns(di->poll_time) <= 0)
+			di->poll_time = ktime_set(0, 20 * NSEC_PER_MSEC);
+
+		*data = ds = kzalloc(sizeof(*ds) + sizeof(ds->key_state[0]) *
+					di->keymap_size, GFP_KERNEL);
+		if (ds == NULL) {
+			ret = -ENOMEM;
+			pr_err("gpio_event_input_func: "
+				"Failed to allocate private data\n");
+			goto err_ds_alloc_failed;
+		}
+		ds->debounce_count = di->keymap_size;
+		ds->input_devs = input_devs;
+		ds->info = di;
+		wlname = kasprintf(GFP_KERNEL, "gpio_input:%s%s",
+				   input_devs->dev[0]->name,
+				   (input_devs->count > 1) ? "..." : "");
+
+		ds->ws = wakeup_source_register(wlname);
+		kfree(wlname);
+		if (!ds->ws) {
+			ret = -ENOMEM;
+			pr_err("gpio_event_input_func: "
+				"Failed to allocate wakeup source\n");
+			goto err_ws_failed;
+		}
+
+		spin_lock_init(&ds->irq_lock);
+
+		for (i = 0; i < di->keymap_size; i++) {
+			int dev = di->keymap[i].dev;
+			if (dev >= input_devs->count) {
+				pr_err("gpio_event_input_func: bad device "
+					"index %d >= %d for key code %d\n",
+					dev, input_devs->count,
+					di->keymap[i].code);
+				ret = -EINVAL;
+				goto err_bad_keymap;
+			}
+			input_set_capability(input_devs->dev[dev], di->type,
+					     di->keymap[i].code);
+			ds->key_state[i].ds = ds;
+			ds->key_state[i].debounce = DEBOUNCE_UNKNOWN;
+		}
+
+		for (i = 0; i < di->keymap_size; i++) {
+			ret = gpio_request(di->keymap[i].gpio, "gpio_kp_in");
+			if (ret) {
+				pr_err("gpio_event_input_func: gpio_request "
+					"failed for %d\n", di->keymap[i].gpio);
+				goto err_gpio_request_failed;
+			}
+			ret = gpio_direction_input(di->keymap[i].gpio);
+			if (ret) {
+				pr_err("gpio_event_input_func: "
+					"gpio_direction_input failed for %d\n",
+					di->keymap[i].gpio);
+				goto err_gpio_configure_failed;
+			}
+		}
+
+		ret = gpio_event_input_request_irqs(ds);
+
+		spin_lock_irqsave(&ds->irq_lock, irqflags);
+		ds->use_irq = ret == 0;
+
+		pr_info("GPIO Input Driver: Start gpio inputs for %s%s in %s "
+			"mode\n", input_devs->dev[0]->name,
+			(input_devs->count > 1) ? "..." : "",
+			ret == 0 ? "interrupt" : "polling");
+
+		hrtimer_init(&ds->timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+		ds->timer.function = gpio_event_input_timer_func;
+		hrtimer_start(&ds->timer, ktime_set(0, 0), HRTIMER_MODE_REL);
+		spin_unlock_irqrestore(&ds->irq_lock, irqflags);
+		return 0;
+	}
+
+	ret = 0;
+	spin_lock_irqsave(&ds->irq_lock, irqflags);
+	hrtimer_cancel(&ds->timer);
+	if (ds->use_irq) {
+		for (i = di->keymap_size - 1; i >= 0; i--) {
+			int irq = gpio_to_irq(di->keymap[i].gpio);
+			if (ds->info->info.no_suspend)
+				disable_irq_wake(irq);
+			free_irq(irq, &ds->key_state[i]);
+		}
+	}
+	spin_unlock_irqrestore(&ds->irq_lock, irqflags);
+
+	for (i = di->keymap_size - 1; i >= 0; i--) {
+err_gpio_configure_failed:
+		gpio_free(di->keymap[i].gpio);
+err_gpio_request_failed:
+		;
+	}
+err_bad_keymap:
+	wakeup_source_unregister(ds->ws);
+err_ws_failed:
+	kfree(ds);
+err_ds_alloc_failed:
+	return ret;
+}
diff --git a/drivers/input/misc/gpio_matrix.c b/drivers/input/misc/gpio_matrix.c
new file mode 100644
index 00000000..08769dd
--- /dev/null
+++ b/drivers/input/misc/gpio_matrix.c
@@ -0,0 +1,440 @@
+/* drivers/input/misc/gpio_matrix.c
+ *
+ * Copyright (C) 2007 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/gpio.h>
+#include <linux/gpio_event.h>
+#include <linux/hrtimer.h>
+#include <linux/interrupt.h>
+#include <linux/slab.h>
+
+struct gpio_kp {
+	struct gpio_event_input_devs *input_devs;
+	struct gpio_event_matrix_info *keypad_info;
+	struct hrtimer timer;
+	struct wakeup_source wake_src;
+	int current_output;
+	unsigned int use_irq:1;
+	unsigned int key_state_changed:1;
+	unsigned int last_key_state_changed:1;
+	unsigned int some_keys_pressed:2;
+	unsigned int disabled_irq:1;
+	unsigned long keys_pressed[0];
+};
+
+static void clear_phantom_key(struct gpio_kp *kp, int out, int in)
+{
+	struct gpio_event_matrix_info *mi = kp->keypad_info;
+	int key_index = out * mi->ninputs + in;
+	unsigned short keyentry = mi->keymap[key_index];
+	unsigned short keycode = keyentry & MATRIX_KEY_MASK;
+	unsigned short dev = keyentry >> MATRIX_CODE_BITS;
+
+	if (!test_bit(keycode, kp->input_devs->dev[dev]->key)) {
+		if (mi->flags & GPIOKPF_PRINT_PHANTOM_KEYS)
+			pr_info("gpiomatrix: phantom key %x, %d-%d (%d-%d) "
+				"cleared\n", keycode, out, in,
+				mi->output_gpios[out], mi->input_gpios[in]);
+		__clear_bit(key_index, kp->keys_pressed);
+	} else {
+		if (mi->flags & GPIOKPF_PRINT_PHANTOM_KEYS)
+			pr_info("gpiomatrix: phantom key %x, %d-%d (%d-%d) "
+				"not cleared\n", keycode, out, in,
+				mi->output_gpios[out], mi->input_gpios[in]);
+	}
+}
+
+static int restore_keys_for_input(struct gpio_kp *kp, int out, int in)
+{
+	int rv = 0;
+	int key_index;
+
+	key_index = out * kp->keypad_info->ninputs + in;
+	while (out < kp->keypad_info->noutputs) {
+		if (test_bit(key_index, kp->keys_pressed)) {
+			rv = 1;
+			clear_phantom_key(kp, out, in);
+		}
+		key_index += kp->keypad_info->ninputs;
+		out++;
+	}
+	return rv;
+}
+
+static void remove_phantom_keys(struct gpio_kp *kp)
+{
+	int out, in, inp;
+	int key_index;
+
+	if (kp->some_keys_pressed < 3)
+		return;
+
+	for (out = 0; out < kp->keypad_info->noutputs; out++) {
+		inp = -1;
+		key_index = out * kp->keypad_info->ninputs;
+		for (in = 0; in < kp->keypad_info->ninputs; in++, key_index++) {
+			if (test_bit(key_index, kp->keys_pressed)) {
+				if (inp == -1) {
+					inp = in;
+					continue;
+				}
+				if (inp >= 0) {
+					if (!restore_keys_for_input(kp, out + 1,
+									inp))
+						break;
+					clear_phantom_key(kp, out, inp);
+					inp = -2;
+				}
+				restore_keys_for_input(kp, out, in);
+			}
+		}
+	}
+}
+
+static void report_key(struct gpio_kp *kp, int key_index, int out, int in)
+{
+	struct gpio_event_matrix_info *mi = kp->keypad_info;
+	int pressed = test_bit(key_index, kp->keys_pressed);
+	unsigned short keyentry = mi->keymap[key_index];
+	unsigned short keycode = keyentry & MATRIX_KEY_MASK;
+	unsigned short dev = keyentry >> MATRIX_CODE_BITS;
+
+	if (pressed != test_bit(keycode, kp->input_devs->dev[dev]->key)) {
+		if (keycode == KEY_RESERVED) {
+			if (mi->flags & GPIOKPF_PRINT_UNMAPPED_KEYS)
+				pr_info("gpiomatrix: unmapped key, %d-%d "
+					"(%d-%d) changed to %d\n",
+					out, in, mi->output_gpios[out],
+					mi->input_gpios[in], pressed);
+		} else {
+			if (mi->flags & GPIOKPF_PRINT_MAPPED_KEYS)
+				pr_info("gpiomatrix: key %x, %d-%d (%d-%d) "
+					"changed to %d\n", keycode,
+					out, in, mi->output_gpios[out],
+					mi->input_gpios[in], pressed);
+			input_report_key(kp->input_devs->dev[dev], keycode, pressed);
+		}
+	}
+}
+
+static void report_sync(struct gpio_kp *kp)
+{
+	int i;
+
+	for (i = 0; i < kp->input_devs->count; i++)
+		input_sync(kp->input_devs->dev[i]);
+}
+
+static enum hrtimer_restart gpio_keypad_timer_func(struct hrtimer *timer)
+{
+	int out, in;
+	int key_index;
+	int gpio;
+	struct gpio_kp *kp = container_of(timer, struct gpio_kp, timer);
+	struct gpio_event_matrix_info *mi = kp->keypad_info;
+	unsigned gpio_keypad_flags = mi->flags;
+	unsigned polarity = !!(gpio_keypad_flags & GPIOKPF_ACTIVE_HIGH);
+
+	out = kp->current_output;
+	if (out == mi->noutputs) {
+		out = 0;
+		kp->last_key_state_changed = kp->key_state_changed;
+		kp->key_state_changed = 0;
+		kp->some_keys_pressed = 0;
+	} else {
+		key_index = out * mi->ninputs;
+		for (in = 0; in < mi->ninputs; in++, key_index++) {
+			gpio = mi->input_gpios[in];
+			if (gpio_get_value(gpio) ^ !polarity) {
+				if (kp->some_keys_pressed < 3)
+					kp->some_keys_pressed++;
+				kp->key_state_changed |= !__test_and_set_bit(
+						key_index, kp->keys_pressed);
+			} else
+				kp->key_state_changed |= __test_and_clear_bit(
+						key_index, kp->keys_pressed);
+		}
+		gpio = mi->output_gpios[out];
+		if (gpio_keypad_flags & GPIOKPF_DRIVE_INACTIVE)
+			gpio_set_value(gpio, !polarity);
+		else
+			gpio_direction_input(gpio);
+		out++;
+	}
+	kp->current_output = out;
+	if (out < mi->noutputs) {
+		gpio = mi->output_gpios[out];
+		if (gpio_keypad_flags & GPIOKPF_DRIVE_INACTIVE)
+			gpio_set_value(gpio, polarity);
+		else
+			gpio_direction_output(gpio, polarity);
+		hrtimer_start(timer, mi->settle_time, HRTIMER_MODE_REL);
+		return HRTIMER_NORESTART;
+	}
+	if (gpio_keypad_flags & GPIOKPF_DEBOUNCE) {
+		if (kp->key_state_changed) {
+			hrtimer_start(&kp->timer, mi->debounce_delay,
+				      HRTIMER_MODE_REL);
+			return HRTIMER_NORESTART;
+		}
+		kp->key_state_changed = kp->last_key_state_changed;
+	}
+	if (kp->key_state_changed) {
+		if (gpio_keypad_flags & GPIOKPF_REMOVE_SOME_PHANTOM_KEYS)
+			remove_phantom_keys(kp);
+		key_index = 0;
+		for (out = 0; out < mi->noutputs; out++)
+			for (in = 0; in < mi->ninputs; in++, key_index++)
+				report_key(kp, key_index, out, in);
+		report_sync(kp);
+	}
+	if (!kp->use_irq || kp->some_keys_pressed) {
+		hrtimer_start(timer, mi->poll_time, HRTIMER_MODE_REL);
+		return HRTIMER_NORESTART;
+	}
+
+	/* No keys are pressed, reenable interrupt */
+	for (out = 0; out < mi->noutputs; out++) {
+		if (gpio_keypad_flags & GPIOKPF_DRIVE_INACTIVE)
+			gpio_set_value(mi->output_gpios[out], polarity);
+		else
+			gpio_direction_output(mi->output_gpios[out], polarity);
+	}
+	for (in = 0; in < mi->ninputs; in++)
+		enable_irq(gpio_to_irq(mi->input_gpios[in]));
+	__pm_relax(&kp->wake_src);
+	return HRTIMER_NORESTART;
+}
+
+static irqreturn_t gpio_keypad_irq_handler(int irq_in, void *dev_id)
+{
+	int i;
+	struct gpio_kp *kp = dev_id;
+	struct gpio_event_matrix_info *mi = kp->keypad_info;
+	unsigned gpio_keypad_flags = mi->flags;
+
+	if (!kp->use_irq) {
+		/* ignore interrupt while registering the handler */
+		kp->disabled_irq = 1;
+		disable_irq_nosync(irq_in);
+		return IRQ_HANDLED;
+	}
+
+	for (i = 0; i < mi->ninputs; i++)
+		disable_irq_nosync(gpio_to_irq(mi->input_gpios[i]));
+	for (i = 0; i < mi->noutputs; i++) {
+		if (gpio_keypad_flags & GPIOKPF_DRIVE_INACTIVE)
+			gpio_set_value(mi->output_gpios[i],
+				!(gpio_keypad_flags & GPIOKPF_ACTIVE_HIGH));
+		else
+			gpio_direction_input(mi->output_gpios[i]);
+	}
+	__pm_stay_awake(&kp->wake_src);
+	hrtimer_start(&kp->timer, ktime_set(0, 0), HRTIMER_MODE_REL);
+	return IRQ_HANDLED;
+}
+
+static int gpio_keypad_request_irqs(struct gpio_kp *kp)
+{
+	int i;
+	int err;
+	unsigned int irq;
+	unsigned long request_flags;
+	struct gpio_event_matrix_info *mi = kp->keypad_info;
+
+	switch (mi->flags & (GPIOKPF_ACTIVE_HIGH|GPIOKPF_LEVEL_TRIGGERED_IRQ)) {
+	default:
+		request_flags = IRQF_TRIGGER_FALLING;
+		break;
+	case GPIOKPF_ACTIVE_HIGH:
+		request_flags = IRQF_TRIGGER_RISING;
+		break;
+	case GPIOKPF_LEVEL_TRIGGERED_IRQ:
+		request_flags = IRQF_TRIGGER_LOW;
+		break;
+	case GPIOKPF_LEVEL_TRIGGERED_IRQ | GPIOKPF_ACTIVE_HIGH:
+		request_flags = IRQF_TRIGGER_HIGH;
+		break;
+	}
+
+	for (i = 0; i < mi->ninputs; i++) {
+		err = irq = gpio_to_irq(mi->input_gpios[i]);
+		if (err < 0)
+			goto err_gpio_get_irq_num_failed;
+		err = request_irq(irq, gpio_keypad_irq_handler, request_flags,
+				  "gpio_kp", kp);
+		if (err) {
+			pr_err("gpiomatrix: request_irq failed for input %d, "
+				"irq %d\n", mi->input_gpios[i], irq);
+			goto err_request_irq_failed;
+		}
+		err = enable_irq_wake(irq);
+		if (err) {
+			pr_err("gpiomatrix: set_irq_wake failed for input %d, "
+				"irq %d\n", mi->input_gpios[i], irq);
+		}
+		disable_irq(irq);
+		if (kp->disabled_irq) {
+			kp->disabled_irq = 0;
+			enable_irq(irq);
+		}
+	}
+	return 0;
+
+	for (i = mi->noutputs - 1; i >= 0; i--) {
+		free_irq(gpio_to_irq(mi->input_gpios[i]), kp);
+err_request_irq_failed:
+err_gpio_get_irq_num_failed:
+		;
+	}
+	return err;
+}
+
+int gpio_event_matrix_func(struct gpio_event_input_devs *input_devs,
+	struct gpio_event_info *info, void **data, int func)
+{
+	int i;
+	int err;
+	int key_count;
+	struct gpio_kp *kp;
+	struct gpio_event_matrix_info *mi;
+
+	mi = container_of(info, struct gpio_event_matrix_info, info);
+	if (func == GPIO_EVENT_FUNC_SUSPEND || func == GPIO_EVENT_FUNC_RESUME) {
+		/* TODO: disable scanning */
+		return 0;
+	}
+
+	if (func == GPIO_EVENT_FUNC_INIT) {
+		if (mi->keymap == NULL ||
+		   mi->input_gpios == NULL ||
+		   mi->output_gpios == NULL) {
+			err = -ENODEV;
+			pr_err("gpiomatrix: Incomplete pdata\n");
+			goto err_invalid_platform_data;
+		}
+		key_count = mi->ninputs * mi->noutputs;
+
+		*data = kp = kzalloc(sizeof(*kp) + sizeof(kp->keys_pressed[0]) *
+				     BITS_TO_LONGS(key_count), GFP_KERNEL);
+		if (kp == NULL) {
+			err = -ENOMEM;
+			pr_err("gpiomatrix: Failed to allocate private data\n");
+			goto err_kp_alloc_failed;
+		}
+		kp->input_devs = input_devs;
+		kp->keypad_info = mi;
+		for (i = 0; i < key_count; i++) {
+			unsigned short keyentry = mi->keymap[i];
+			unsigned short keycode = keyentry & MATRIX_KEY_MASK;
+			unsigned short dev = keyentry >> MATRIX_CODE_BITS;
+			if (dev >= input_devs->count) {
+				pr_err("gpiomatrix: bad device index %d >= "
+					"%d for key code %d\n",
+					dev, input_devs->count, keycode);
+				err = -EINVAL;
+				goto err_bad_keymap;
+			}
+			if (keycode && keycode <= KEY_MAX)
+				input_set_capability(input_devs->dev[dev],
+							EV_KEY, keycode);
+		}
+
+		for (i = 0; i < mi->noutputs; i++) {
+			err = gpio_request(mi->output_gpios[i], "gpio_kp_out");
+			if (err) {
+				pr_err("gpiomatrix: gpio_request failed for "
+					"output %d\n", mi->output_gpios[i]);
+				goto err_request_output_gpio_failed;
+			}
+			if (gpio_cansleep(mi->output_gpios[i])) {
+				pr_err("gpiomatrix: unsupported output gpio %d,"
+					" can sleep\n", mi->output_gpios[i]);
+				err = -EINVAL;
+				goto err_output_gpio_configure_failed;
+			}
+			if (mi->flags & GPIOKPF_DRIVE_INACTIVE)
+				err = gpio_direction_output(mi->output_gpios[i],
+					!(mi->flags & GPIOKPF_ACTIVE_HIGH));
+			else
+				err = gpio_direction_input(mi->output_gpios[i]);
+			if (err) {
+				pr_err("gpiomatrix: gpio_configure failed for "
+					"output %d\n", mi->output_gpios[i]);
+				goto err_output_gpio_configure_failed;
+			}
+		}
+		for (i = 0; i < mi->ninputs; i++) {
+			err = gpio_request(mi->input_gpios[i], "gpio_kp_in");
+			if (err) {
+				pr_err("gpiomatrix: gpio_request failed for "
+					"input %d\n", mi->input_gpios[i]);
+				goto err_request_input_gpio_failed;
+			}
+			err = gpio_direction_input(mi->input_gpios[i]);
+			if (err) {
+				pr_err("gpiomatrix: gpio_direction_input failed"
+					" for input %d\n", mi->input_gpios[i]);
+				goto err_gpio_direction_input_failed;
+			}
+		}
+		kp->current_output = mi->noutputs;
+		kp->key_state_changed = 1;
+
+		hrtimer_init(&kp->timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+		kp->timer.function = gpio_keypad_timer_func;
+		wakeup_source_init(&kp->wake_src, "gpio_kp");
+		err = gpio_keypad_request_irqs(kp);
+		kp->use_irq = err == 0;
+
+		pr_info("GPIO Matrix Keypad Driver: Start keypad matrix for "
+			"%s%s in %s mode\n", input_devs->dev[0]->name,
+			(input_devs->count > 1) ? "..." : "",
+			kp->use_irq ? "interrupt" : "polling");
+
+		if (kp->use_irq)
+			__pm_stay_awake(&kp->wake_src);
+		hrtimer_start(&kp->timer, ktime_set(0, 0), HRTIMER_MODE_REL);
+
+		return 0;
+	}
+
+	err = 0;
+	kp = *data;
+
+	if (kp->use_irq)
+		for (i = mi->noutputs - 1; i >= 0; i--)
+			free_irq(gpio_to_irq(mi->input_gpios[i]), kp);
+
+	hrtimer_cancel(&kp->timer);
+	wakeup_source_trash(&kp->wake_src);
+	for (i = mi->noutputs - 1; i >= 0; i--) {
+err_gpio_direction_input_failed:
+		gpio_free(mi->input_gpios[i]);
+err_request_input_gpio_failed:
+		;
+	}
+	for (i = mi->noutputs - 1; i >= 0; i--) {
+err_output_gpio_configure_failed:
+		gpio_free(mi->output_gpios[i]);
+err_request_output_gpio_failed:
+		;
+	}
+err_bad_keymap:
+	kfree(kp);
+err_kp_alloc_failed:
+err_invalid_platform_data:
+	return err;
+}
diff --git a/drivers/input/misc/gpio_output.c b/drivers/input/misc/gpio_output.c
new file mode 100644
index 00000000..2aac2fa
--- /dev/null
+++ b/drivers/input/misc/gpio_output.c
@@ -0,0 +1,97 @@
+/* drivers/input/misc/gpio_output.c
+ *
+ * Copyright (C) 2007 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/gpio.h>
+#include <linux/gpio_event.h>
+
+int gpio_event_output_event(
+	struct gpio_event_input_devs *input_devs, struct gpio_event_info *info,
+	void **data, unsigned int dev, unsigned int type,
+	unsigned int code, int value)
+{
+	int i;
+	struct gpio_event_output_info *oi;
+	oi = container_of(info, struct gpio_event_output_info, info);
+	if (type != oi->type)
+		return 0;
+	if (!(oi->flags & GPIOEDF_ACTIVE_HIGH))
+		value = !value;
+	for (i = 0; i < oi->keymap_size; i++)
+		if (dev == oi->keymap[i].dev && code == oi->keymap[i].code)
+			gpio_set_value(oi->keymap[i].gpio, value);
+	return 0;
+}
+
+int gpio_event_output_func(
+	struct gpio_event_input_devs *input_devs, struct gpio_event_info *info,
+	void **data, int func)
+{
+	int ret;
+	int i;
+	struct gpio_event_output_info *oi;
+	oi = container_of(info, struct gpio_event_output_info, info);
+
+	if (func == GPIO_EVENT_FUNC_SUSPEND || func == GPIO_EVENT_FUNC_RESUME)
+		return 0;
+
+	if (func == GPIO_EVENT_FUNC_INIT) {
+		int output_level = !(oi->flags & GPIOEDF_ACTIVE_HIGH);
+
+		for (i = 0; i < oi->keymap_size; i++) {
+			int dev = oi->keymap[i].dev;
+			if (dev >= input_devs->count) {
+				pr_err("gpio_event_output_func: bad device "
+					"index %d >= %d for key code %d\n",
+					dev, input_devs->count,
+					oi->keymap[i].code);
+				ret = -EINVAL;
+				goto err_bad_keymap;
+			}
+			input_set_capability(input_devs->dev[dev], oi->type,
+					     oi->keymap[i].code);
+		}
+
+		for (i = 0; i < oi->keymap_size; i++) {
+			ret = gpio_request(oi->keymap[i].gpio,
+					   "gpio_event_output");
+			if (ret) {
+				pr_err("gpio_event_output_func: gpio_request "
+					"failed for %d\n", oi->keymap[i].gpio);
+				goto err_gpio_request_failed;
+			}
+			ret = gpio_direction_output(oi->keymap[i].gpio,
+						    output_level);
+			if (ret) {
+				pr_err("gpio_event_output_func: "
+					"gpio_direction_output failed for %d\n",
+					oi->keymap[i].gpio);
+				goto err_gpio_direction_output_failed;
+			}
+		}
+		return 0;
+	}
+
+	ret = 0;
+	for (i = oi->keymap_size - 1; i >= 0; i--) {
+err_gpio_direction_output_failed:
+		gpio_free(oi->keymap[i].gpio);
+err_gpio_request_failed:
+		;
+	}
+err_bad_keymap:
+	return ret;
+}
+
diff --git a/drivers/input/misc/keychord.c b/drivers/input/misc/keychord.c
new file mode 100644
index 00000000..82fefdf
--- /dev/null
+++ b/drivers/input/misc/keychord.c
@@ -0,0 +1,467 @@
+/*
+ *  drivers/input/misc/keychord.c
+ *
+ * Copyright (C) 2008 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+*/
+
+#include <linux/poll.h>
+#include <linux/slab.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/spinlock.h>
+#include <linux/fs.h>
+#include <linux/miscdevice.h>
+#include <linux/keychord.h>
+#include <linux/sched.h>
+
+#define KEYCHORD_NAME		"keychord"
+#define BUFFER_SIZE			16
+
+MODULE_AUTHOR("Mike Lockwood <lockwood@android.com>");
+MODULE_DESCRIPTION("Key chord input driver");
+MODULE_SUPPORTED_DEVICE("keychord");
+MODULE_LICENSE("GPL");
+
+#define NEXT_KEYCHORD(kc) ((struct input_keychord *) \
+		((char *)kc + sizeof(struct input_keychord) + \
+		kc->count * sizeof(kc->keycodes[0])))
+
+struct keychord_device {
+	struct input_handler	input_handler;
+	int			registered;
+
+	/* list of keychords to monitor */
+	struct input_keychord	*keychords;
+	int			keychord_count;
+
+	/* bitmask of keys contained in our keychords */
+	unsigned long keybit[BITS_TO_LONGS(KEY_CNT)];
+	/* current state of the keys */
+	unsigned long keystate[BITS_TO_LONGS(KEY_CNT)];
+	/* number of keys that are currently pressed */
+	int key_down;
+
+	/* second input_device_id is needed for null termination */
+	struct input_device_id  device_ids[2];
+
+	spinlock_t		lock;
+	wait_queue_head_t	waitq;
+	unsigned char		head;
+	unsigned char		tail;
+	__u16			buff[BUFFER_SIZE];
+	/* Bit to serialize writes to this device */
+#define KEYCHORD_BUSY			0x01
+	unsigned long		flags;
+	wait_queue_head_t	write_waitq;
+};
+
+static int check_keychord(struct keychord_device *kdev,
+		struct input_keychord *keychord)
+{
+	int i;
+
+	if (keychord->count != kdev->key_down)
+		return 0;
+
+	for (i = 0; i < keychord->count; i++) {
+		if (!test_bit(keychord->keycodes[i], kdev->keystate))
+			return 0;
+	}
+
+	/* we have a match */
+	return 1;
+}
+
+static void keychord_event(struct input_handle *handle, unsigned int type,
+			   unsigned int code, int value)
+{
+	struct keychord_device *kdev = handle->private;
+	struct input_keychord *keychord;
+	unsigned long flags;
+	int i, got_chord = 0;
+
+	if (type != EV_KEY || code >= KEY_MAX)
+		return;
+
+	spin_lock_irqsave(&kdev->lock, flags);
+	/* do nothing if key state did not change */
+	if (!test_bit(code, kdev->keystate) == !value)
+		goto done;
+	__change_bit(code, kdev->keystate);
+	if (value)
+		kdev->key_down++;
+	else
+		kdev->key_down--;
+
+	/* don't notify on key up */
+	if (!value)
+		goto done;
+	/* ignore this event if it is not one of the keys we are monitoring */
+	if (!test_bit(code, kdev->keybit))
+		goto done;
+
+	keychord = kdev->keychords;
+	if (!keychord)
+		goto done;
+
+	/* check to see if the keyboard state matches any keychords */
+	for (i = 0; i < kdev->keychord_count; i++) {
+		if (check_keychord(kdev, keychord)) {
+			kdev->buff[kdev->head] = keychord->id;
+			kdev->head = (kdev->head + 1) % BUFFER_SIZE;
+			got_chord = 1;
+			break;
+		}
+		/* skip to next keychord */
+		keychord = NEXT_KEYCHORD(keychord);
+	}
+
+done:
+	spin_unlock_irqrestore(&kdev->lock, flags);
+
+	if (got_chord) {
+		pr_info("keychord: got keychord id %d. Any tasks: %d\n",
+			keychord->id,
+			!list_empty_careful(&kdev->waitq.task_list));
+		wake_up_interruptible(&kdev->waitq);
+	}
+}
+
+static int keychord_connect(struct input_handler *handler,
+					  struct input_dev *dev,
+					  const struct input_device_id *id)
+{
+	int i, ret;
+	struct input_handle *handle;
+	struct keychord_device *kdev =
+		container_of(handler, struct keychord_device, input_handler);
+
+	/*
+	 * ignore this input device if it does not contain any keycodes
+	 * that we are monitoring
+	 */
+	for (i = 0; i < KEY_MAX; i++) {
+		if (test_bit(i, kdev->keybit) && test_bit(i, dev->keybit))
+			break;
+	}
+	if (i == KEY_MAX)
+		return -ENODEV;
+
+	handle = kzalloc(sizeof(*handle), GFP_KERNEL);
+	if (!handle)
+		return -ENOMEM;
+
+	handle->dev = dev;
+	handle->handler = handler;
+	handle->name = KEYCHORD_NAME;
+	handle->private = kdev;
+
+	ret = input_register_handle(handle);
+	if (ret)
+		goto err_input_register_handle;
+
+	ret = input_open_device(handle);
+	if (ret)
+		goto err_input_open_device;
+
+	pr_info("keychord: using input dev %s for fevent\n", dev->name);
+	return 0;
+
+err_input_open_device:
+	input_unregister_handle(handle);
+err_input_register_handle:
+	kfree(handle);
+	return ret;
+}
+
+static void keychord_disconnect(struct input_handle *handle)
+{
+	input_close_device(handle);
+	input_unregister_handle(handle);
+	kfree(handle);
+}
+
+/*
+ * keychord_read is used to read keychord events from the driver
+ */
+static ssize_t keychord_read(struct file *file, char __user *buffer,
+		size_t count, loff_t *ppos)
+{
+	struct keychord_device *kdev = file->private_data;
+	__u16   id;
+	int retval;
+	unsigned long flags;
+
+	if (count < sizeof(id))
+		return -EINVAL;
+	count = sizeof(id);
+
+	if (kdev->head == kdev->tail && (file->f_flags & O_NONBLOCK))
+		return -EAGAIN;
+
+	retval = wait_event_interruptible(kdev->waitq,
+			kdev->head != kdev->tail);
+	if (retval)
+		return retval;
+
+	spin_lock_irqsave(&kdev->lock, flags);
+	/* pop a keychord ID off the queue */
+	id = kdev->buff[kdev->tail];
+	kdev->tail = (kdev->tail + 1) % BUFFER_SIZE;
+	spin_unlock_irqrestore(&kdev->lock, flags);
+
+	if (copy_to_user(buffer, &id, count))
+		return -EFAULT;
+
+	return count;
+}
+
+/*
+ * serializes writes on a device. can use mutex_lock_interruptible()
+ * for this particular use case as well - a matter of preference.
+ */
+static int
+keychord_write_lock(struct keychord_device *kdev)
+{
+	int ret;
+	unsigned long flags;
+
+	spin_lock_irqsave(&kdev->lock, flags);
+	while (kdev->flags & KEYCHORD_BUSY) {
+		spin_unlock_irqrestore(&kdev->lock, flags);
+		ret = wait_event_interruptible(kdev->write_waitq,
+			       ((kdev->flags & KEYCHORD_BUSY) == 0));
+		if (ret)
+			return ret;
+		spin_lock_irqsave(&kdev->lock, flags);
+	}
+	kdev->flags |= KEYCHORD_BUSY;
+	spin_unlock_irqrestore(&kdev->lock, flags);
+	return 0;
+}
+
+static void
+keychord_write_unlock(struct keychord_device *kdev)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&kdev->lock, flags);
+	kdev->flags &= ~KEYCHORD_BUSY;
+	spin_unlock_irqrestore(&kdev->lock, flags);
+	wake_up_interruptible(&kdev->write_waitq);
+}
+
+/*
+ * keychord_write is used to configure the driver
+ */
+static ssize_t keychord_write(struct file *file, const char __user *buffer,
+		size_t count, loff_t *ppos)
+{
+	struct keychord_device *kdev = file->private_data;
+	struct input_keychord *keychords = 0;
+	struct input_keychord *keychord;
+	int ret, i, key;
+	unsigned long flags;
+	size_t resid = count;
+	size_t key_bytes;
+
+	if (count < sizeof(struct input_keychord) || count > PAGE_SIZE)
+		return -EINVAL;
+	keychords = kzalloc(count, GFP_KERNEL);
+	if (!keychords)
+		return -ENOMEM;
+
+	/* read list of keychords from userspace */
+	if (copy_from_user(keychords, buffer, count)) {
+		kfree(keychords);
+		return -EFAULT;
+	}
+
+	/*
+	 * Serialize writes to this device to prevent various races.
+	 * 1) writers racing here could do duplicate input_unregister_handler()
+	 *    calls, resulting in attempting to unlink a node from a list that
+	 *    does not exist.
+	 * 2) writers racing here could do duplicate input_register_handler() calls
+	 *    below, resulting in a duplicate insertion of a node into the list.
+	 * 3) a double kfree of keychords can occur (in the event that
+	 *    input_register_handler() fails below.
+	 */
+	ret = keychord_write_lock(kdev);
+	if (ret) {
+		kfree(keychords);
+		return ret;
+	}
+
+	/* unregister handler before changing configuration */
+	if (kdev->registered) {
+		input_unregister_handler(&kdev->input_handler);
+		kdev->registered = 0;
+	}
+
+	spin_lock_irqsave(&kdev->lock, flags);
+	/* clear any existing configuration */
+	kfree(kdev->keychords);
+	kdev->keychords = 0;
+	kdev->keychord_count = 0;
+	kdev->key_down = 0;
+	memset(kdev->keybit, 0, sizeof(kdev->keybit));
+	memset(kdev->keystate, 0, sizeof(kdev->keystate));
+	kdev->head = kdev->tail = 0;
+
+	keychord = keychords;
+
+	while (resid > 0) {
+		/* Is the entire keychord entry header present ? */
+		if (resid < sizeof(struct input_keychord)) {
+			pr_err("keychord: Insufficient bytes present for header %zu\n",
+			       resid);
+			goto err_unlock_return;
+		}
+		resid -= sizeof(struct input_keychord);
+		if (keychord->count <= 0) {
+			pr_err("keychord: invalid keycode count %d\n",
+				keychord->count);
+			goto err_unlock_return;
+		}
+		key_bytes = keychord->count * sizeof(keychord->keycodes[0]);
+		/* Do we have all the expected keycodes ? */
+		if (resid < key_bytes) {
+			pr_err("keychord: Insufficient bytes present for keycount %zu\n",
+			       resid);
+			goto err_unlock_return;
+		}
+		resid -= key_bytes;
+
+		if (keychord->version != KEYCHORD_VERSION) {
+			pr_err("keychord: unsupported version %d\n",
+				keychord->version);
+			goto err_unlock_return;
+		}
+
+		/* keep track of the keys we are monitoring in keybit */
+		for (i = 0; i < keychord->count; i++) {
+			key = keychord->keycodes[i];
+			if (key < 0 || key >= KEY_CNT) {
+				pr_err("keychord: keycode %d out of range\n",
+					key);
+				goto err_unlock_return;
+			}
+			__set_bit(key, kdev->keybit);
+		}
+
+		kdev->keychord_count++;
+		keychord = NEXT_KEYCHORD(keychord);
+	}
+
+	kdev->keychords = keychords;
+	spin_unlock_irqrestore(&kdev->lock, flags);
+
+	ret = input_register_handler(&kdev->input_handler);
+	if (ret) {
+		kfree(keychords);
+		kdev->keychords = 0;
+		keychord_write_unlock(kdev);
+		return ret;
+	}
+	kdev->registered = 1;
+
+	keychord_write_unlock(kdev);
+
+	return count;
+
+err_unlock_return:
+	spin_unlock_irqrestore(&kdev->lock, flags);
+	kfree(keychords);
+	keychord_write_unlock(kdev);
+	return -EINVAL;
+}
+
+static unsigned int keychord_poll(struct file *file, poll_table *wait)
+{
+	struct keychord_device *kdev = file->private_data;
+
+	poll_wait(file, &kdev->waitq, wait);
+
+	if (kdev->head != kdev->tail)
+		return POLLIN | POLLRDNORM;
+
+	return 0;
+}
+
+static int keychord_open(struct inode *inode, struct file *file)
+{
+	struct keychord_device *kdev;
+
+	kdev = kzalloc(sizeof(struct keychord_device), GFP_KERNEL);
+	if (!kdev)
+		return -ENOMEM;
+
+	spin_lock_init(&kdev->lock);
+	init_waitqueue_head(&kdev->waitq);
+	init_waitqueue_head(&kdev->write_waitq);
+
+	kdev->input_handler.event = keychord_event;
+	kdev->input_handler.connect = keychord_connect;
+	kdev->input_handler.disconnect = keychord_disconnect;
+	kdev->input_handler.name = KEYCHORD_NAME;
+	kdev->input_handler.id_table = kdev->device_ids;
+
+	kdev->device_ids[0].flags = INPUT_DEVICE_ID_MATCH_EVBIT;
+	__set_bit(EV_KEY, kdev->device_ids[0].evbit);
+
+	file->private_data = kdev;
+
+	return 0;
+}
+
+static int keychord_release(struct inode *inode, struct file *file)
+{
+	struct keychord_device *kdev = file->private_data;
+
+	if (kdev->registered)
+		input_unregister_handler(&kdev->input_handler);
+	kfree(kdev->keychords);
+	kfree(kdev);
+
+	return 0;
+}
+
+static const struct file_operations keychord_fops = {
+	.owner		= THIS_MODULE,
+	.open		= keychord_open,
+	.release	= keychord_release,
+	.read		= keychord_read,
+	.write		= keychord_write,
+	.poll		= keychord_poll,
+};
+
+static struct miscdevice keychord_misc = {
+	.fops		= &keychord_fops,
+	.name		= KEYCHORD_NAME,
+	.minor		= MISC_DYNAMIC_MINOR,
+};
+
+static int __init keychord_init(void)
+{
+	return misc_register(&keychord_misc);
+}
+
+static void __exit keychord_exit(void)
+{
+	misc_deregister(&keychord_misc);
+}
+
+module_init(keychord_init);
+module_exit(keychord_exit);
diff --git a/drivers/irqchip/Kconfig b/drivers/irqchip/Kconfig
index 910cb5e..61b285e 100644
--- a/drivers/irqchip/Kconfig
+++ b/drivers/irqchip/Kconfig
@@ -41,6 +41,12 @@ config ARM_GIC_V3_ITS
 	depends on PCI_MSI
 	select ACPI_IORT if ACPI
 
+config ARM_GIC_V3_DEBUGFS
+	bool
+	depends on DEBUG_FS
+	depends on RTK_PLATFORM
+	depends on HAVE_ARM_SMCCC
+
 config ARM_NVIC
 	bool
 	select IRQ_DOMAIN
diff --git a/drivers/irqchip/Makefile b/drivers/irqchip/Makefile
index e4dbfc8..87460ff 100644
--- a/drivers/irqchip/Makefile
+++ b/drivers/irqchip/Makefile
@@ -74,3 +74,9 @@ obj-$(CONFIG_LS_SCFG_MSI)		+= irq-ls-scfg-msi.o
 obj-$(CONFIG_EZNPS_GIC)			+= irq-eznps.o
 obj-$(CONFIG_ARCH_ASPEED)		+= irq-aspeed-vic.o
 obj-$(CONFIG_STM32_EXTI) 		+= irq-stm32-exti.o
+obj-$(CONFIG_ARCH_RTD119X)		+= irq-rtd119x.o
+obj-$(CONFIG_ARCH_RTD129x) 		+= irq-rtd129x.o
+obj-$(CONFIG_ARCH_RTD139x) 		+= irq-rtd139x.o
+obj-$(CONFIG_ARCH_RTD16xx)		+= irq-rtd16xx.o
+obj-$(CONFIG_ARCH_RTD13xx)		+= irq-rtd13xx.o
+
diff --git a/drivers/irqchip/irq-gic-v3.c b/drivers/irqchip/irq-gic-v3.c
old mode 100644
new mode 100755
index f7b8681..09d935e
--- a/drivers/irqchip/irq-gic-v3.c
+++ b/drivers/irqchip/irq-gic-v3.c
@@ -64,6 +64,13 @@ struct gic_chip_data {
 
 static struct gic_kvm_info gic_v3_kvm_info;
 
+static unsigned int GICR_ISENABLER0_REG = 0;
+static unsigned int GIC_ISENABLER0_REG = 0;
+static unsigned int GIC_ISENABLER1_REG = 0;
+static unsigned int GIC_ISENABLER2_REG = 0;
+static unsigned int GIC_ISENABLER3_REG = 0;
+
+
 #define gic_data_rdist()		(this_cpu_ptr(gic_data.rdists.rdist))
 #define gic_data_rdist_rd_base()	(gic_data_rdist()->rd_base)
 #define gic_data_rdist_sgi_base()	(gic_data_rdist_rd_base() + SZ_64K)
@@ -139,11 +146,18 @@ static void gic_enable_redist(bool enable)
 	rbase = gic_data_rdist_rd_base();
 
 	val = readl_relaxed(rbase + GICR_WAKER);
-	if (enable)
+	if (enable) {
+
+#ifdef CONFIG_RTK_PLATFORM
+		if (readl_relaxed(rbase) & 0x02000000)
+		       writel_relaxed(readl_relaxed(rbase) & 0xFDFFFFFF, rbase);
+#endif /* CONFIG_RTK_PLATFORM */
+
 		/* Wake up this CPU redistributor */
 		val &= ~GICR_WAKER_ProcessorSleep;
-	else
+	} else
 		val |= GICR_WAKER_ProcessorSleep;
+
 	writel_relaxed(val, rbase + GICR_WAKER);
 
 	if (!enable) {		/* Check that GICR_WAKER is writeable */
@@ -409,14 +423,31 @@ static void __init gic_dist_init(void)
 	gic_dist_config(base, gic_data.irq_nr, gic_dist_wait_for_rwp);
 
 	/* Enable distributor with ARE, Group1 */
+#ifdef CONFIG_RTK_PLATFORM
+#define GICD_CTLR_E1NWF (1 << 7)
+	writel_relaxed(GICD_CTLR_E1NWF | GICD_CTLR_ARE_NS | GICD_CTLR_ENABLE_G1A | GICD_CTLR_ENABLE_G1,
+		       base + GICD_CTLR);
+#else
 	writel_relaxed(GICD_CTLR_ARE_NS | GICD_CTLR_ENABLE_G1A | GICD_CTLR_ENABLE_G1,
 		       base + GICD_CTLR);
+#endif
 
 	/*
 	 * Set all global interrupts to the boot CPU only. ARE must be
 	 * enabled.
 	 */
 	affinity = gic_mpidr_to_affinity(cpu_logical_map(smp_processor_id()));
+
+#ifdef CONFIG_RTK_PLATFORM
+	/*
+	 * The GIC selects the appropriate core for a SPI.
+	 * GICD_IROUTER<n>.Interrupt_Routing_Mode = 1
+	 */
+
+	affinity |= 0x80000000;
+
+#endif /* CONFIG_RTK_PLATFORM */
+
 	for (i = 32; i < gic_data.irq_nr; i++)
 		gic_write_irouter(affinity, base + GICD_IROUTER + i * 8);
 }
@@ -552,6 +583,19 @@ static int gic_starting_cpu(unsigned int cpu)
 	return 0;
 }
 
+#ifdef CONFIG_RTK_PLATFORM
+static int gic_off_cpu(unsigned int cpu)
+{
+
+	void __iomem *rbase;
+
+	rbase = gic_data_rdist_rd_base();
+	writel_relaxed(readl_relaxed(rbase) | 0x2000000, rbase);
+
+	return 0;
+}
+#endif /* CONFIG_RTK_PLATFORM */
+
 static u16 gic_compute_target_list(int *base_cpu, const struct cpumask *mask,
 				   unsigned long cluster_id)
 {
@@ -632,9 +676,16 @@ static void gic_raise_softirq(const struct cpumask *mask, unsigned int irq)
 static void gic_smp_init(void)
 {
 	set_smp_cross_call(gic_raise_softirq);
+
+#ifdef CONFIG_RTK_PLATFORM
+	cpuhp_setup_state_nocalls(CPUHP_AP_IRQ_GICV3_STARTING,
+				  "AP_IRQ_GICV3_STARTING", gic_starting_cpu,
+				  gic_off_cpu);
+#else
 	cpuhp_setup_state_nocalls(CPUHP_AP_IRQ_GICV3_STARTING,
 				  "AP_IRQ_GICV3_STARTING", gic_starting_cpu,
 				  NULL);
+#endif /* CONFIG_RTK_PLATFORM */
 }
 
 static int gic_set_affinity(struct irq_data *d, const struct cpumask *mask_val,
@@ -659,6 +710,10 @@ static int gic_set_affinity(struct irq_data *d, const struct cpumask *mask_val,
 	reg = gic_dist_base(d) + GICD_IROUTER + (gic_irq(d) * 8);
 	val = gic_mpidr_to_affinity(cpu_logical_map(cpu));
 
+#ifdef CONFIG_RTK_PLATFORM
+	if (cpumask_subset(cpu_online_mask, mask_val))
+		val |= 0x80000000;
+#endif
 	gic_write_irouter(val, reg);
 
 	/*
@@ -687,6 +742,36 @@ static bool gic_dist_security_disabled(void)
 static int gic_cpu_pm_notifier(struct notifier_block *self,
 			       unsigned long cmd, void *v)
 {
+#ifdef CONFIG_RTK_PLATFORM
+	void __iomem *rbase;
+
+	rbase = gic_data_rdist_sgi_base();
+	if (cmd == CPU_PM_EXIT) {
+		pr_err("GICR_ISENABLER0 = %x\n", GICR_ISENABLER0_REG);
+		pr_err("GIC_ISENABLER0 = %x\n", GIC_ISENABLER0_REG);
+		pr_err("GIC_ISENABLER1 = %x\n", GIC_ISENABLER1_REG);
+		pr_err("GIC_ISENABLER2 = %x\n", GIC_ISENABLER2_REG);
+		pr_err("GIC_ISENABLER3 = %x\n", GIC_ISENABLER3_REG);
+		writel_relaxed(GICR_ISENABLER0_REG, rbase + GICR_ISENABLER0);
+		writel_relaxed(GIC_ISENABLER0_REG, gic_data.dist_base + 0x100);
+		writel_relaxed(GIC_ISENABLER1_REG, gic_data.dist_base + 0x104);
+		writel_relaxed(GIC_ISENABLER2_REG, gic_data.dist_base + 0x108);
+		writel_relaxed(GIC_ISENABLER3_REG, gic_data.dist_base + 0x10C);
+
+	} else if (cmd == CPU_PM_ENTER) {
+		GICR_ISENABLER0_REG = readl_relaxed(rbase + GICR_ISENABLER0);
+		GIC_ISENABLER0_REG = readl_relaxed(gic_data.dist_base + 0x100);
+		GIC_ISENABLER1_REG = readl_relaxed(gic_data.dist_base + 0x104);
+		GIC_ISENABLER2_REG = readl_relaxed(gic_data.dist_base + 0x108);
+		GIC_ISENABLER3_REG = readl_relaxed(gic_data.dist_base + 0x10C);
+		pr_err("GICR_ISENABLER0 = %x\n", GICR_ISENABLER0_REG);
+		pr_err("GIC_ISENABLER0 = %x\n", GIC_ISENABLER0_REG);
+		pr_err("GIC_ISENABLER1 = %x\n", GIC_ISENABLER1_REG);
+		pr_err("GIC_ISENABLER2 = %x\n", GIC_ISENABLER2_REG);
+		pr_err("GIC_ISENABLER3 = %x\n", GIC_ISENABLER3_REG);
+	}
+#endif /* CONFIG_RTK_PLATFORM */
+
 	if (cmd == CPU_PM_EXIT) {
 		if (gic_dist_security_disabled())
 			gic_enable_redist(true);
@@ -1497,3 +1582,107 @@ static void __init gic_acpi_setup_kvm_info(void)
 		     acpi_validate_gic_table, ACPI_MADT_GIC_VERSION_NONE,
 		     gic_acpi_init);
 #endif
+
+#ifdef CONFIG_ARM_GIC_V3_DEBUGFS
+
+#include <linux/debugfs.h>
+#include <linux/arm-smccc.h>
+
+
+#define SB2_SWCIO_RCMD                  0x8400fffe
+#define SB2_SWCIO_WCMD                  0x8400ffff
+static struct dentry *gic_root;
+
+static int gic_gicr_class_set(void *data, u64 val)
+{
+	long i = (long)data;
+	u32 phys = per_cpu_ptr(gic_data.rdists.rdist, i)->phys_base + GICR_CLASS;
+	struct arm_smccc_res res;
+
+	if (val != 0 && val != 1)
+		return -EINVAL;
+
+	arm_smccc_smc(SB2_SWCIO_WCMD, phys, (unsigned long)val, 0, 0, 0, 0, 0, &res);
+	return 0;
+}
+static int gic_gicr_class_get(void *data, u64 *val)
+{
+	long i = (long)data;
+	u32 phys = per_cpu_ptr(gic_data.rdists.rdist, i)->phys_base + GICR_CLASS;
+	struct arm_smccc_res res;
+
+	arm_smccc_smc(SB2_SWCIO_RCMD, phys, 0, 0, 0, 0, 0, 0, &res);
+	*val = res.a0;
+	return 0;
+}
+
+DEFINE_SIMPLE_ATTRIBUTE(gic_gicr_class_ops,
+			gic_gicr_class_get,
+			gic_gicr_class_set,
+			"%llx\n");
+
+static int gic_gicd_iclar_set(void *data, u64 val)
+{
+	long i = (long)data;
+	u32 reg, sft, rval;
+	void __iomem *base = gic_data.dist_base;
+
+	if (val & ~0x3)
+		return -EINVAL;
+
+	reg = i / 16;
+	sft = (i % 16) * 2;
+
+	rval = readl(base + GICD_ICLAR + reg * 4);
+	rval &= ~(0x3 << sft);
+	rval |= val << sft;
+	writel(rval, base + GICD_ICLAR + reg * 4);
+	return 0;
+}
+
+static int gic_gicd_iclar_get(void *data, u64 *val)
+{
+	long i = (long)data;
+	u32 reg, sft, rval;
+	void __iomem *base = gic_data.dist_base;
+
+	reg = i / 16;
+	sft = (i % 16) * 2;
+
+	rval = readl(base + GICD_ICLAR + reg * 4);
+	*val = (rval >> sft) & 0x3;
+	return 0;
+}
+DEFINE_SIMPLE_ATTRIBUTE(gic_gicd_iclar_ops,
+			gic_gicd_iclar_get,
+			gic_gicd_iclar_set,
+			"%llx\n");
+
+static int __init gic_create_debugfs(void)
+{
+	long i;
+	char name[16];
+	struct dentry *d;
+
+	gic_root = debugfs_create_dir("gic", NULL);
+	if (!gic_root) {
+		pr_warn("couldn't not create debugfs\n");
+		return -EINVAL;
+	}
+
+	d = debugfs_create_dir("irq_class_disable", gic_root);
+	for (i = 33; i <= 121; i++) {
+		sprintf(name, "irq%ld", i);
+		debugfs_create_file(name, 0644, d, (void *)i, &gic_gicd_iclar_ops);
+	}
+
+	for_each_cpu(i, cpu_online_mask) {
+		sprintf(name, "cpu%ld", i);
+		d = debugfs_create_dir(name, gic_root);
+		debugfs_create_file("class", 0644, d, (void *)i, &gic_gicr_class_ops);
+	}
+	return 0;
+}
+late_initcall(gic_create_debugfs);
+
+#endif /* CONFIG_ARM_GIC_V3_DEBUGFS */
diff --git a/drivers/irqchip/irq-gic.c b/drivers/irqchip/irq-gic.c
index d6c404b..d4952f6 100644
--- a/drivers/irqchip/irq-gic.c
+++ b/drivers/irqchip/irq-gic.c
@@ -50,6 +50,10 @@
 
 #include "irq-gic-common.h"
 
+#if defined(CONFIG_CPU_V7)
+#include <linux/rtk_trace.h>
+#endif /* CONFIG_CPU_V7 */
+
 #ifdef CONFIG_ARM64
 #include <asm/cpufeature.h>
 
@@ -193,13 +197,13 @@ static inline bool cascading_gic_irq(struct irq_data *d)
 static void gic_poke_irq(struct irq_data *d, u32 offset)
 {
 	u32 mask = 1 << (gic_irq(d) % 32);
-	writel_relaxed(mask, gic_dist_base(d) + offset + (gic_irq(d) / 32) * 4);
+	writel_relaxed_no_log(mask, gic_dist_base(d) + offset + (gic_irq(d) / 32) * 4);
 }
 
 static int gic_peek_irq(struct irq_data *d, u32 offset)
 {
 	u32 mask = 1 << (gic_irq(d) % 32);
-	return !!(readl_relaxed(gic_dist_base(d) + offset + (gic_irq(d) / 32) * 4) & mask);
+	return !!(readl_relaxed_no_log(gic_dist_base(d) + offset + (gic_irq(d) / 32) * 4) & mask);
 }
 
 static void gic_mask_irq(struct irq_data *d)
@@ -229,7 +233,7 @@ static void gic_unmask_irq(struct irq_data *d)
 
 static void gic_eoi_irq(struct irq_data *d)
 {
-	writel_relaxed(gic_irq(d), gic_cpu_base(d) + GIC_CPU_EOI);
+	writel_relaxed_no_log(gic_irq(d), gic_cpu_base(d) + GIC_CPU_EOI);
 }
 
 static void gic_eoimode1_eoi_irq(struct irq_data *d)
@@ -238,7 +242,7 @@ static void gic_eoimode1_eoi_irq(struct irq_data *d)
 	if (irqd_is_forwarded_to_vcpu(d))
 		return;
 
-	writel_relaxed(gic_irq(d), gic_cpu_base(d) + GIC_CPU_DEACTIVATE);
+	writel_relaxed_no_log(gic_irq(d), gic_cpu_base(d) + GIC_CPU_DEACTIVATE);
 }
 
 static int gic_irq_set_irqchip_state(struct irq_data *d,
@@ -339,9 +343,15 @@ static int gic_set_affinity(struct irq_data *d, const struct cpumask *mask_val,
 
 	gic_lock_irqsave(flags);
 	mask = 0xff << shift;
+
+#ifdef CONFIG_RTK_PLATFORM
+	bit = *cpumask_bits(mask_val) << shift;
+#else
 	bit = gic_cpu_map[cpu] << shift;
-	val = readl_relaxed(reg) & ~mask;
-	writel_relaxed(val | bit, reg);
+#endif /* CONFIG_RTK_PLATFORM */
+
+	val = readl_relaxed_no_log(reg) & ~mask;
+	writel_relaxed_no_log(val | bit, reg);
 	gic_unlock_irqrestore(flags);
 
 	return IRQ_SET_MASK_OK_DONE;
@@ -355,19 +365,22 @@ static void __exception_irq_entry gic_handle_irq(struct pt_regs *regs)
 	void __iomem *cpu_base = gic_data_cpu_base(gic);
 
 	do {
-		irqstat = readl_relaxed(cpu_base + GIC_CPU_INTACK);
+		irqstat = readl_relaxed_no_log(cpu_base + GIC_CPU_INTACK);
 		irqnr = irqstat & GICC_IAR_INT_ID_MASK;
 
+		/* Record IRQ status */
+		uncached_logk(LOGK_IRQ, (void *)(uintptr_t)irqnr);
+
 		if (likely(irqnr > 15 && irqnr < 1020)) {
 			if (static_key_true(&supports_deactivate))
-				writel_relaxed(irqstat, cpu_base + GIC_CPU_EOI);
+				writel_relaxed_no_log(irqstat, cpu_base + GIC_CPU_EOI);
 			handle_domain_irq(gic->domain, irqnr, regs);
 			continue;
 		}
 		if (irqnr < 16) {
-			writel_relaxed(irqstat, cpu_base + GIC_CPU_EOI);
+			writel_relaxed_no_log(irqstat, cpu_base + GIC_CPU_EOI);
 			if (static_key_true(&supports_deactivate))
-				writel_relaxed(irqstat, cpu_base + GIC_CPU_DEACTIVATE);
+				writel_relaxed_no_log(irqstat, cpu_base + GIC_CPU_DEACTIVATE);
 #ifdef CONFIG_SMP
 			/*
 			 * Ensure any shared data written by the CPU sending
@@ -394,7 +407,7 @@ static void gic_handle_cascade_irq(struct irq_desc *desc)
 
 	chained_irq_enter(chip, desc);
 
-	status = readl_relaxed(gic_data_cpu_base(chip_data) + GIC_CPU_INTACK);
+	status = readl_relaxed_no_log(gic_data_cpu_base(chip_data) + GIC_CPU_INTACK);
 
 	gic_irq = (status & GICC_IAR_INT_ID_MASK);
 	if (gic_irq == GICC_INT_SPURIOUS)
@@ -435,7 +448,7 @@ static u8 gic_get_cpumask(struct gic_chip_data *gic)
 	u32 mask, i;
 
 	for (i = mask = 0; i < 32; i += 4) {
-		mask = readl_relaxed(base + GIC_DIST_TARGET + i);
+		mask = readl_relaxed_no_log(base + GIC_DIST_TARGET + i);
 		mask |= mask >> 16;
 		mask |= mask >> 8;
 		if (mask)
@@ -463,7 +476,7 @@ static void gic_cpu_if_up(struct gic_chip_data *gic)
 	bypass = readl(cpu_base + GIC_CPU_CTRL);
 	bypass &= GICC_DIS_BYPASS_MASK;
 
-	writel_relaxed(bypass | mode | GICC_ENABLE, cpu_base + GIC_CPU_CTRL);
+	writel_relaxed_no_log(bypass | mode | GICC_ENABLE, cpu_base + GIC_CPU_CTRL);
 }
 
 
@@ -474,7 +487,7 @@ static void gic_dist_init(struct gic_chip_data *gic)
 	unsigned int gic_irqs = gic->gic_irqs;
 	void __iomem *base = gic_data_dist_base(gic);
 
-	writel_relaxed(GICD_DISABLE, base + GIC_DIST_CTRL);
+	writel_relaxed_no_log(GICD_DISABLE, base + GIC_DIST_CTRL);
 
 	/*
 	 * Set all global interrupts to this CPU only.
@@ -482,12 +495,23 @@ static void gic_dist_init(struct gic_chip_data *gic)
 	cpumask = gic_get_cpumask(gic);
 	cpumask |= cpumask << 8;
 	cpumask |= cpumask << 16;
+
+#ifdef CONFIG_RTK_PLATFORM
+#ifdef CONFIG_ARCH_RTD119X
+	for (i = 32; i < gic_irqs; i += 4)
+                writel_relaxed_no_log(0x03030303, base + GIC_DIST_TARGET + i * 4 / 4);
+#else
+	for (i = 32; i < gic_irqs; i += 4)
+		writel_relaxed_no_log(0x0F0F0F0F, base + GIC_DIST_TARGET + i * 4 / 4);
+#endif
+#else
 	for (i = 32; i < gic_irqs; i += 4)
-		writel_relaxed(cpumask, base + GIC_DIST_TARGET + i * 4 / 4);
+		writel_relaxed_no_log(cpumask, base + GIC_DIST_TARGET + i * 4 / 4);
+#endif /* CONFIG_RTK_PLATFORM */
 
 	gic_dist_config(base, gic_irqs, NULL);
 
-	writel_relaxed(GICD_ENABLE, base + GIC_DIST_CTRL);
+	writel_relaxed_no_log(GICD_ENABLE, base + GIC_DIST_CTRL);
 }
 
 static int gic_cpu_init(struct gic_chip_data *gic)
@@ -524,7 +548,7 @@ static int gic_cpu_init(struct gic_chip_data *gic)
 
 	gic_cpu_config(dist_base, NULL);
 
-	writel_relaxed(GICC_INT_PRI_THRESHOLD, base + GIC_CPU_PRIMASK);
+	writel_relaxed_no_log(GICC_INT_PRI_THRESHOLD, base + GIC_CPU_PRIMASK);
 	gic_cpu_if_up(gic);
 
 	return 0;
@@ -541,7 +565,7 @@ int gic_cpu_if_down(unsigned int gic_nr)
 	cpu_base = gic_data_cpu_base(&gic_data[gic_nr]);
 	val = readl(cpu_base + GIC_CPU_CTRL);
 	val &= ~GICC_ENABLE;
-	writel_relaxed(val, cpu_base + GIC_CPU_CTRL);
+	writel_relaxed_no_log(val, cpu_base + GIC_CPU_CTRL);
 
 	return 0;
 }
@@ -570,19 +594,19 @@ void gic_dist_save(struct gic_chip_data *gic)
 
 	for (i = 0; i < DIV_ROUND_UP(gic_irqs, 16); i++)
 		gic->saved_spi_conf[i] =
-			readl_relaxed(dist_base + GIC_DIST_CONFIG + i * 4);
+			readl_relaxed_no_log(dist_base + GIC_DIST_CONFIG + i * 4);
 
 	for (i = 0; i < DIV_ROUND_UP(gic_irqs, 4); i++)
 		gic->saved_spi_target[i] =
-			readl_relaxed(dist_base + GIC_DIST_TARGET + i * 4);
+			readl_relaxed_no_log(dist_base + GIC_DIST_TARGET + i * 4);
 
 	for (i = 0; i < DIV_ROUND_UP(gic_irqs, 32); i++)
 		gic->saved_spi_enable[i] =
-			readl_relaxed(dist_base + GIC_DIST_ENABLE_SET + i * 4);
+			readl_relaxed_no_log(dist_base + GIC_DIST_ENABLE_SET + i * 4);
 
 	for (i = 0; i < DIV_ROUND_UP(gic_irqs, 32); i++)
 		gic->saved_spi_active[i] =
-			readl_relaxed(dist_base + GIC_DIST_ACTIVE_SET + i * 4);
+			readl_relaxed_no_log(dist_base + GIC_DIST_ACTIVE_SET + i * 4);
 }
 
 /*
@@ -607,35 +631,35 @@ void gic_dist_restore(struct gic_chip_data *gic)
 	if (!dist_base)
 		return;
 
-	writel_relaxed(GICD_DISABLE, dist_base + GIC_DIST_CTRL);
+	writel_relaxed_no_log(GICD_DISABLE, dist_base + GIC_DIST_CTRL);
 
 	for (i = 0; i < DIV_ROUND_UP(gic_irqs, 16); i++)
-		writel_relaxed(gic->saved_spi_conf[i],
+		writel_relaxed_no_log(gic->saved_spi_conf[i],
 			dist_base + GIC_DIST_CONFIG + i * 4);
 
 	for (i = 0; i < DIV_ROUND_UP(gic_irqs, 4); i++)
-		writel_relaxed(GICD_INT_DEF_PRI_X4,
+		writel_relaxed_no_log(GICD_INT_DEF_PRI_X4,
 			dist_base + GIC_DIST_PRI + i * 4);
 
 	for (i = 0; i < DIV_ROUND_UP(gic_irqs, 4); i++)
-		writel_relaxed(gic->saved_spi_target[i],
+		writel_relaxed_no_log(gic->saved_spi_target[i],
 			dist_base + GIC_DIST_TARGET + i * 4);
 
 	for (i = 0; i < DIV_ROUND_UP(gic_irqs, 32); i++) {
-		writel_relaxed(GICD_INT_EN_CLR_X32,
+		writel_relaxed_no_log(GICD_INT_EN_CLR_X32,
 			dist_base + GIC_DIST_ENABLE_CLEAR + i * 4);
-		writel_relaxed(gic->saved_spi_enable[i],
+		writel_relaxed_no_log(gic->saved_spi_enable[i],
 			dist_base + GIC_DIST_ENABLE_SET + i * 4);
 	}
 
 	for (i = 0; i < DIV_ROUND_UP(gic_irqs, 32); i++) {
-		writel_relaxed(GICD_INT_EN_CLR_X32,
+		writel_relaxed_no_log(GICD_INT_EN_CLR_X32,
 			dist_base + GIC_DIST_ACTIVE_CLEAR + i * 4);
-		writel_relaxed(gic->saved_spi_active[i],
+		writel_relaxed_no_log(gic->saved_spi_active[i],
 			dist_base + GIC_DIST_ACTIVE_SET + i * 4);
 	}
 
-	writel_relaxed(GICD_ENABLE, dist_base + GIC_DIST_CTRL);
+	writel_relaxed_no_log(GICD_ENABLE, dist_base + GIC_DIST_CTRL);
 }
 
 void gic_cpu_save(struct gic_chip_data *gic)
@@ -656,15 +680,15 @@ void gic_cpu_save(struct gic_chip_data *gic)
 
 	ptr = raw_cpu_ptr(gic->saved_ppi_enable);
 	for (i = 0; i < DIV_ROUND_UP(32, 32); i++)
-		ptr[i] = readl_relaxed(dist_base + GIC_DIST_ENABLE_SET + i * 4);
+		ptr[i] = readl_relaxed_no_log(dist_base + GIC_DIST_ENABLE_SET + i * 4);
 
 	ptr = raw_cpu_ptr(gic->saved_ppi_active);
 	for (i = 0; i < DIV_ROUND_UP(32, 32); i++)
-		ptr[i] = readl_relaxed(dist_base + GIC_DIST_ACTIVE_SET + i * 4);
+		ptr[i] = readl_relaxed_no_log(dist_base + GIC_DIST_ACTIVE_SET + i * 4);
 
 	ptr = raw_cpu_ptr(gic->saved_ppi_conf);
 	for (i = 0; i < DIV_ROUND_UP(32, 16); i++)
-		ptr[i] = readl_relaxed(dist_base + GIC_DIST_CONFIG + i * 4);
+		ptr[i] = readl_relaxed_no_log(dist_base + GIC_DIST_CONFIG + i * 4);
 
 }
 
@@ -686,27 +710,27 @@ void gic_cpu_restore(struct gic_chip_data *gic)
 
 	ptr = raw_cpu_ptr(gic->saved_ppi_enable);
 	for (i = 0; i < DIV_ROUND_UP(32, 32); i++) {
-		writel_relaxed(GICD_INT_EN_CLR_X32,
+		writel_relaxed_no_log(GICD_INT_EN_CLR_X32,
 			       dist_base + GIC_DIST_ENABLE_CLEAR + i * 4);
-		writel_relaxed(ptr[i], dist_base + GIC_DIST_ENABLE_SET + i * 4);
+		writel_relaxed_no_log(ptr[i], dist_base + GIC_DIST_ENABLE_SET + i * 4);
 	}
 
 	ptr = raw_cpu_ptr(gic->saved_ppi_active);
 	for (i = 0; i < DIV_ROUND_UP(32, 32); i++) {
-		writel_relaxed(GICD_INT_EN_CLR_X32,
+		writel_relaxed_no_log(GICD_INT_EN_CLR_X32,
 			       dist_base + GIC_DIST_ACTIVE_CLEAR + i * 4);
-		writel_relaxed(ptr[i], dist_base + GIC_DIST_ACTIVE_SET + i * 4);
+		writel_relaxed_no_log(ptr[i], dist_base + GIC_DIST_ACTIVE_SET + i * 4);
 	}
 
 	ptr = raw_cpu_ptr(gic->saved_ppi_conf);
 	for (i = 0; i < DIV_ROUND_UP(32, 16); i++)
-		writel_relaxed(ptr[i], dist_base + GIC_DIST_CONFIG + i * 4);
+		writel_relaxed_no_log(ptr[i], dist_base + GIC_DIST_CONFIG + i * 4);
 
 	for (i = 0; i < DIV_ROUND_UP(32, 4); i++)
-		writel_relaxed(GICD_INT_DEF_PRI_X4,
+		writel_relaxed_no_log(GICD_INT_DEF_PRI_X4,
 					dist_base + GIC_DIST_PRI + i * 4);
 
-	writel_relaxed(GICC_INT_PRI_THRESHOLD, cpu_base + GIC_CPU_PRIMASK);
+	writel_relaxed_no_log(GICC_INT_PRI_THRESHOLD, cpu_base + GIC_CPU_PRIMASK);
 	gic_cpu_if_up(gic);
 }
 
@@ -714,6 +738,13 @@ static int gic_notifier(struct notifier_block *self, unsigned long cmd,	void *v)
 {
 	int i;
 
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		pr_info("%s, skip under domu\n", __func__);
+		return NOTIFY_OK;
+	}
+#endif
+
 	for (i = 0; i < CONFIG_ARM_GIC_MAX_NR; i++) {
 #ifdef CONFIG_GIC_NON_BANKED
 		/* Skip over unused GICs */
@@ -789,7 +820,7 @@ static void gic_raise_softirq(const struct cpumask *mask, unsigned int irq)
 
 	if (unlikely(nr_cpu_ids == 1)) {
 		/* Only one CPU? let's do a self-IPI... */
-		writel_relaxed(2 << 24 | irq,
+		writel_relaxed_no_log(2 << 24 | irq,
 			       gic_data_dist_base(&gic_data[0]) + GIC_DIST_SOFTINT);
 		return;
 	}
@@ -807,7 +838,7 @@ static void gic_raise_softirq(const struct cpumask *mask, unsigned int irq)
 	dmb(ishst);
 
 	/* this always happens on GIC0 */
-	writel_relaxed(map << 16 | irq, gic_data_dist_base(&gic_data[0]) + GIC_DIST_SOFTINT);
+	writel_relaxed_no_log(map << 16 | irq, gic_data_dist_base(&gic_data[0]) + GIC_DIST_SOFTINT);
 
 	gic_unlock_irqrestore(flags);
 }
@@ -825,7 +856,7 @@ void gic_send_sgi(unsigned int cpu_id, unsigned int irq)
 	BUG_ON(cpu_id >= NR_GIC_CPU_IF);
 	cpu_id = 1 << cpu_id;
 	/* this always happens on GIC0 */
-	writel_relaxed((cpu_id << 16) | irq, gic_data_dist_base(&gic_data[0]) + GIC_DIST_SOFTINT);
+	writel_relaxed_no_log((cpu_id << 16) | irq, gic_data_dist_base(&gic_data[0]) + GIC_DIST_SOFTINT);
 }
 
 /*
@@ -888,12 +919,12 @@ void gic_migrate_target(unsigned int new_cpu_id)
 	 * We skip DIST_TARGET 0 to 7 as they are read-only.
 	 */
 	for (i = 8; i < DIV_ROUND_UP(gic_irqs, 4); i++) {
-		val = readl_relaxed(dist_base + GIC_DIST_TARGET + i * 4);
+		val = readl_relaxed_no_log(dist_base + GIC_DIST_TARGET + i * 4);
 		active_mask = val & cur_target_mask;
 		if (active_mask) {
 			val &= ~active_mask;
 			val |= ror32(active_mask, ror_val);
-			writel_relaxed(val, dist_base + GIC_DIST_TARGET + i*4);
+			writel_relaxed_no_log(val, dist_base + GIC_DIST_TARGET + i*4);
 		}
 	}
 
@@ -911,13 +942,13 @@ void gic_migrate_target(unsigned int new_cpu_id)
 	 */
 	for (i = 0; i < 16; i += 4) {
 		int j;
-		val = readl_relaxed(dist_base + GIC_DIST_SGI_PENDING_SET + i);
+		val = readl_relaxed_no_log(dist_base + GIC_DIST_SGI_PENDING_SET + i);
 		if (!val)
 			continue;
-		writel_relaxed(val, dist_base + GIC_DIST_SGI_PENDING_CLEAR + i);
+		writel_relaxed_no_log(val, dist_base + GIC_DIST_SGI_PENDING_CLEAR + i);
 		for (j = i; j < i + 4; j++) {
 			if (val & 0xff)
-				writel_relaxed((1 << (new_cpu_id + 16)) | j,
+				writel_relaxed_no_log((1 << (new_cpu_id + 16)) | j,
 						dist_base + GIC_DIST_SOFTINT);
 			val >>= 8;
 		}
@@ -1107,7 +1138,7 @@ static int gic_init_bases(struct gic_chip_data *gic, int irq_start,
 	 * Find out how many interrupts are supported.
 	 * The GIC only supports up to 1020 interrupt sources.
 	 */
-	gic_irqs = readl_relaxed(gic_data_dist_base(gic) + GIC_DIST_CTR) & 0x1f;
+	gic_irqs = readl_relaxed_no_log(gic_data_dist_base(gic) + GIC_DIST_CTR) & 0x1f;
 	gic_irqs = (gic_irqs + 1) * 32;
 	if (gic_irqs > 1020)
 		gic_irqs = 1020;
@@ -1266,8 +1297,8 @@ static bool gic_check_eoimode(struct device_node *node, void __iomem **base)
 		 * aliased over the first 64kB by checking the
 		 * GICC_IIDR register on both ends.
 		 */
-		val_low = readl_relaxed(*base + GIC_CPU_IDENT);
-		val_high = readl_relaxed(*base + GIC_CPU_IDENT + 0xf000);
+		val_low = readl_relaxed_no_log(*base + GIC_CPU_IDENT);
+		val_high = readl_relaxed_no_log(*base + GIC_CPU_IDENT + 0xf000);
 		if ((val_low & 0xffff0fff) != 0x0202043B ||
 		    val_low != val_high)
 			return false;
diff --git a/drivers/irqchip/irq-rtd119x.c b/drivers/irqchip/irq-rtd119x.c
new file mode 100644
index 00000000..bb8243f
--- /dev/null
+++ b/drivers/irqchip/irq-rtd119x.c
@@ -0,0 +1,343 @@
+/*
+ * irq-rtd119x.c - RTK irq mux driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/err.h>
+#include <linux/export.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/syscore_ops.h>
+#include <linux/slab.h>
+#include <linux/irqdomain.h>
+#include <linux/irqchip/chained_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/irqchip.h>
+#include <asm/hardirq.h>
+#include <asm/exception.h>
+#include <asm/irq.h>
+
+#include "irq-rtd119x.h"
+
+#define DEV_NAME "RTK_IRQ_MUX"
+
+static DEFINE_SPINLOCK(irq_mux_lock);
+
+struct irq_mux_data {
+	void __iomem *base;
+	unsigned char index;
+	unsigned int irq;
+	unsigned int irq_offset;
+	u32 intr_status;
+	u32 intr_en;
+};
+
+static struct irq_domain *rtk_domain;
+
+static void mux_mask_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_st;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_st = mux_data->intr_status;
+
+	__raw_writel(BIT(data->hwirq % IRQ_INMUX), base + reg_st);
+}
+
+static void mux_unmask_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_en;
+	u8 en_offset;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_en = mux_data->intr_en;
+
+	en_offset = irq_map_tab[mux_data->index][data->hwirq % IRQ_INMUX];
+
+	if ((en_offset != MISC_INT_RVD) && (en_offset != MISC_INT_FAIL)) {
+
+		__raw_writel((__raw_readl(base + reg_en) |
+			BIT(en_offset)), base + reg_en);
+
+	} else if (en_offset == MISC_INT_FAIL) {
+		pr_err("[%s] Enable irq(%lu) fail\n", DEV_NAME, data->hwirq);
+	}
+}
+
+static void mux_disable_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_en;
+	u8 en_offset;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_en = mux_data->intr_en;
+
+	en_offset = irq_map_tab[mux_data->index][data->hwirq % IRQ_INMUX];
+
+	if ((en_offset != MISC_INT_RVD) && (en_offset != MISC_INT_FAIL)) {
+
+		__raw_writel((__raw_readl(base + reg_en) &
+				~BIT(en_offset)), base + reg_en);
+
+	} else if (en_offset == MISC_INT_FAIL) {
+		pr_err("[%s] Disable irq(%lu) fail\n", DEV_NAME, data->hwirq);
+	}
+}
+
+#ifdef CONFIG_SMP
+static int __maybe_unused mux_set_affinity(struct irq_data *d,
+	const struct cpumask *mask_val,
+	bool force)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(d);
+	struct irq_chip *chip = irq_get_chip(mux_data->irq);
+	struct irq_data *data = irq_get_irq_data(mux_data->irq);
+
+	if (chip && chip->irq_set_affinity)
+		return chip->irq_set_affinity(data, mask_val, force);
+	else
+		return -EINVAL;
+
+}
+#endif
+
+static struct irq_chip mux_chip = {
+	.name = DEV_NAME,
+	.irq_mask = mux_mask_irq,
+	.irq_unmask = mux_unmask_irq,
+	.irq_disable = mux_disable_irq,
+#ifdef CONFIG_SMP
+	.irq_set_affinity = mux_set_affinity,
+#endif
+};
+
+static void mux_irq_handle(struct irq_desc *desc)
+{
+	struct irq_mux_data *mux_data = irq_desc_get_handler_data(desc);
+	struct irq_chip *chip = irq_desc_get_chip(desc);
+	unsigned int irq = irq_desc_get_irq(desc);
+	unsigned int tmp;
+	int ret;
+	unsigned int mux_irq;
+	static u32 count;
+	u8 en_offset;
+	int i;
+	unsigned int status, check_status;
+	unsigned int enable;
+
+	u32 reg_st = mux_data->intr_status;
+	u32 reg_en = mux_data->intr_en;
+
+	chained_irq_enter(chip, desc);
+
+	spin_lock(&irq_mux_lock);
+	enable = __raw_readl(mux_data->base + reg_en);
+	status = __raw_readl(mux_data->base + reg_st);
+	spin_unlock(&irq_mux_lock);
+
+	for (i = 0 ; i < IRQ_INMUX ; i++) {
+		if (status & BIT(i)) {
+			en_offset = irq_map_tab[mux_data->index][i];
+			mux_irq = mux_data->irq_offset + i;
+
+			if ((en_offset < IRQ_INMUX) &&
+				(enable & BIT(en_offset))) {
+
+				tmp = irq_find_mapping(rtk_domain, mux_irq);
+				ret = generic_handle_irq(tmp);
+
+				if (ret != 0) {
+					pr_err("[%s] irq(%u) desc is not found"
+						"(st:0x%08x en:0x%08x)\n",
+						DEV_NAME,
+						mux_irq,
+						status,
+						enable);
+				}
+			} else if (en_offset == MISC_INT_RVD) {
+
+				tmp = irq_find_mapping(rtk_domain, mux_irq);
+				ret = generic_handle_irq(tmp);
+
+				if (ret != 0) {
+					pr_err("[%s] irq(%u) desc is not found"
+						"(st:0x%08x en:0x%08x)\n",
+						DEV_NAME,
+						mux_irq,
+						status,
+						enable);
+				}
+			} else {
+				pr_err("[%s] irq(%u) should not happen"
+					"(st:0x%08x en:0x%08x)\n",
+					DEV_NAME,
+					mux_irq,
+					status,
+					enable);
+			}
+		}
+	}
+
+	/* as a transmission interface, SPI wont do too much here */
+	if (irq == 1 && status | 0x08000000) 
+		goto out; 	
+	
+
+	spin_lock(&irq_mux_lock);
+	check_status = __raw_readl(mux_data->base + reg_st);
+	spin_unlock(&irq_mux_lock);
+
+	if (check_status == status) {
+		if (count > 1) {
+			pr_err("[%s] (%u) %s irq status is not change"
+				"clear it! (st:0x%08x en:0x%08x)\n",
+				DEV_NAME,
+				irq,
+				mux_data->index ? "ISO" : "MISC",
+				status,
+				enable);
+		} else {
+			count++;
+		}
+
+		spin_lock(&irq_mux_lock);
+		__raw_writel(BIT(__ffs(status)), mux_data->base + reg_st);
+		spin_unlock(&irq_mux_lock);
+
+	} else {
+		count = 0;
+	}
+out:
+	chained_irq_exit(chip, desc);
+}
+
+static int mux_irq_domain_xlate(struct irq_domain *d,
+	struct device_node *controller,
+	const u32 *intspec,
+	unsigned int intsize,
+	unsigned long *out_hwirq,
+	unsigned int *out_type)
+{
+	if (controller != irq_domain_get_of_node(d))
+		return -EINVAL;
+
+	if (intsize < 2)
+		return -EINVAL;
+
+	*out_hwirq = intspec[0] * IRQ_INMUX + intspec[1];
+	*out_type = 0;
+
+	return 0;
+}
+
+static int mux_irq_domain_map(struct irq_domain *d,
+						unsigned int irq,
+						irq_hw_number_t hw)
+{
+	struct irq_mux_data *data = d->host_data;
+
+	irq_set_chip_and_handler(irq, &mux_chip, handle_level_irq);
+	irq_set_chip_data(irq, data);
+	irq_set_probe(irq);
+
+	return 0;
+}
+
+static const struct irq_domain_ops mux_irq_domain_ops = {
+	.xlate = mux_irq_domain_xlate,
+	.map = mux_irq_domain_map,
+};
+
+static void __init mux_init_each(struct irq_mux_data *mux_data,
+	void __iomem *base,
+	u32 irq, u32 status,
+	u32 enable, int nr)
+{
+	mux_data->base = base;
+	mux_data->index = nr;
+	mux_data->irq = irq;
+	mux_data->irq_offset = nr * IRQ_INMUX;
+	mux_data->intr_status = status;
+	mux_data->intr_en = enable;
+
+	__raw_writel((__raw_readl(base + enable) & ~BIT(2)), base + enable);
+	__raw_writel(BIT(2), base + status);
+
+	irq_set_chained_handler_and_data(irq, mux_irq_handle, mux_data);
+
+}
+
+#ifdef CONFIG_OF
+static int __init mux_of_init(struct device_node *np,
+	struct device_node *parent)
+{
+	int i;
+	u32 nr_irq = 1;
+	struct irq_mux_data *mux_data;
+	void __iomem *base;
+	u32 irq;
+	u32 status, enable;
+
+	if (WARN_ON(!np))
+		return -ENODEV;
+
+	if (of_property_read_u32(np, "Realtek,mux-nr", &nr_irq))
+		pr_err("[%s] can not specified mux number", DEV_NAME);
+
+	mux_data = kcalloc(nr_irq, sizeof(*mux_data), GFP_KERNEL);
+
+	/*
+	 * TODO : tempary define the first irq number
+	 * in this mux is 160, end in 160+64
+	 */
+	rtk_domain = irq_domain_add_simple(np,
+		(nr_irq * IRQ_INMUX),
+		160,
+		&mux_irq_domain_ops,
+		mux_data);
+
+	if (!rtk_domain)
+		pr_warn("[%s] IRQ domain init failed\n", DEV_NAME);
+
+	for (i = 0; i < nr_irq; i++) {
+		base = of_iomap(np, i);
+
+		if (!base)
+			pr_warn("[%s] unable to map IRQ base registers\n",
+				DEV_NAME);
+
+
+		irq = irq_of_parse_and_map(np, i);
+
+		if (!irq)
+			pr_warn("[%s] can not map IRQ\n", DEV_NAME);
+
+		of_property_read_u32_index(np, "intr-status", i, &status);
+		of_property_read_u32_index(np, "intr-en", i, &enable);
+
+		mux_init_each(mux_data, base, irq, status, enable, i);
+
+		mux_data++;
+	}
+
+	return 0;
+}
+
+IRQCHIP_DECLARE(rtk_irq_mux, "Realtek,rtk-irq-mux", mux_of_init);
+#endif
diff --git a/drivers/irqchip/irq-rtd119x.h b/drivers/irqchip/irq-rtd119x.h
new file mode 100644
index 00000000..c814efa
--- /dev/null
+++ b/drivers/irqchip/irq-rtd119x.h
@@ -0,0 +1,121 @@
+/*
+ * irq-rtd119x.h - RTK irq mux driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef IRQ_RTD119x_H_
+#define IRQ_RTD119x_H_
+
+#define IRQ_INMUX 32
+
+enum misc_int_en {
+	MISC_INT_FAIL = 0xFF,
+	MISC_INT_RVD = 0xFE,
+	MISC_INT_EN_GSPI = 27,
+	MISC_INT_EN_I2C2 = 26,
+	MISC_INT_EN_I2C3 = 23,
+	MISC_INT_EN_LSADC = 21,
+	MISC_INT_EN_GPIODA = 20,
+	MISC_INT_EN_GPIOA = 19,
+	MISC_INT_EN_I2C4 = 15,
+	MISC_INT_EN_I2C5 = 14,
+	MISC_INT_EN_RTC_DATE = 12,
+	MISC_INT_EN_RTC_HOUR = 11,
+	MISC_INT_EN_RTC_MIN = 10,
+	MISC_INT_EN_UR1_TO = 5,
+	MISC_INT_EN_I2C1 = 4,
+	MISC_INT_EN_UR1 = 3,
+};
+
+enum iso_int_en {
+	ISO_INT_FAIL = 0xFF,
+	ISO_INT_RVD = 0xFE,
+	ISO_INT_EN_CEC = 22,
+	ISO_INT_EN_GPIODA = 20,
+	ISO_INT_EN_GPIOA = 19,
+	ISO_INT_EN_RTC_ALARM = 13,
+	ISO_INT_EN_RTC_HSEC = 12,
+	ISO_INT_EN_I2C6 = 10,
+	ISO_INT_EN_I2C0 = 8,
+	ISO_INT_EN_IRDA = 5,
+	ISO_INT_EN_UR0 = 2,
+};
+
+unsigned char irq_map_tab[2][IRQ_INMUX] = {
+	{
+		MISC_INT_FAIL,          /* Bit0 */
+		MISC_INT_FAIL,          /* Bit1 */
+		MISC_INT_RVD,           /* Bit2 */
+		MISC_INT_EN_UR1,        /* Bit3 */
+		MISC_INT_EN_I2C1,       /* Bit4 */
+		MISC_INT_EN_UR1_TO,     /* Bit5 */
+		MISC_INT_RVD,           /* Bit6 */
+		MISC_INT_RVD,           /* Bit7 */
+		MISC_INT_FAIL,          /* Bit8 */
+		MISC_INT_RVD,           /* Bit9 */
+		MISC_INT_EN_RTC_MIN,    /* Bit10 */
+		MISC_INT_EN_RTC_HOUR,   /* Bit11 */
+		MISC_INT_EN_RTC_DATE,   /* Bit12 */
+		MISC_INT_FAIL,          /* Bit13 */
+		MISC_INT_EN_I2C5,       /* Bit14 */
+		MISC_INT_EN_I2C4,       /* Bit15 */
+		MISC_INT_FAIL,          /* Bit16 */
+		MISC_INT_FAIL,          /* Bit17 */
+		MISC_INT_FAIL,          /* Bit18 */
+		MISC_INT_EN_GPIOA,      /* Bit19 */
+		MISC_INT_EN_GPIODA,     /* Bit20 */
+		MISC_INT_EN_LSADC,      /* Bit21 */
+		MISC_INT_FAIL,          /* Bit22 */
+		MISC_INT_EN_I2C3,       /* Bit23 */
+		MISC_INT_FAIL,          /* Bit24 */
+		MISC_INT_FAIL,          /* Bit25 */
+		MISC_INT_EN_I2C2,       /* Bit26 */
+		MISC_INT_EN_GSPI,       /* Bit27 */
+		MISC_INT_FAIL,          /* Bit28 */
+		MISC_INT_FAIL,          /* Bit29 */
+		MISC_INT_FAIL,          /* Bit30 */
+		MISC_INT_FAIL,          /* Bit31 */
+	},
+	{
+                ISO_INT_FAIL,           /* Bit0 */
+                ISO_INT_RVD,            /* Bit1 */
+                ISO_INT_EN_UR0,         /* Bit2 */
+                ISO_INT_FAIL,           /* Bit3 */
+                ISO_INT_FAIL,           /* Bit4 */
+                ISO_INT_EN_IRDA,        /* Bit5 */
+                ISO_INT_FAIL,           /* Bit6 */
+                ISO_INT_RVD,            /* Bit7 */
+                ISO_INT_EN_I2C0,        /* Bit8 */
+                ISO_INT_RVD,            /* Bit9 */
+                ISO_INT_EN_I2C6,        /* Bit10 */
+                ISO_INT_FAIL,           /* Bit11 */
+                ISO_INT_EN_RTC_HSEC,    /* Bit12 */
+                ISO_INT_EN_RTC_ALARM,   /* Bit13 */
+                ISO_INT_RVD,            /* Bit14 */
+                ISO_INT_RVD,            /* Bit15 */
+                ISO_INT_RVD,            /* Bit16 */
+                ISO_INT_RVD,            /* Bit17 */
+                ISO_INT_RVD,            /* Bit18 */
+                ISO_INT_EN_GPIOA,       /* Bit19 */
+                ISO_INT_EN_GPIODA,      /* Bit20 */
+                ISO_INT_FAIL,           /* Bit21 */
+                ISO_INT_EN_CEC,         /* Bit22 */
+                ISO_INT_FAIL,           /* Bit23 */
+                ISO_INT_FAIL,           /* Bit24 */
+                ISO_INT_FAIL,           /* Bit25 */
+                ISO_INT_FAIL,           /* Bit26 */
+                ISO_INT_FAIL,           /* Bit27 */
+                ISO_INT_FAIL,           /* Bit28 */
+                ISO_INT_FAIL,           /* Bit29 */
+                ISO_INT_FAIL,           /* Bit30 */
+                ISO_INT_FAIL,           /* Bit31 */
+        }
+};
+
+#endif /* IRQ_RTD119x_H_ */
diff --git a/drivers/irqchip/irq-rtd129x.c b/drivers/irqchip/irq-rtd129x.c
new file mode 100644
index 00000000..193572b
--- /dev/null
+++ b/drivers/irqchip/irq-rtd129x.c
@@ -0,0 +1,356 @@
+/*
+ * irq-rtd129x.c - RTK irq mux driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/err.h>
+#include <linux/export.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/syscore_ops.h>
+#include <linux/slab.h>
+#include <linux/irqdomain.h>
+#include <linux/irqchip/chained_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/irqchip.h>
+#include <asm/hardirq.h>
+#include <asm/exception.h>
+#include <asm/irq.h>
+
+#include "irq-rtd129x.h"
+
+#define DEV_NAME "RTK_IRQ_MUX"
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#define IRDA_HW_IRQ     37
+#endif
+
+static DEFINE_SPINLOCK(irq_mux_lock);
+
+struct irq_mux_data {
+	void __iomem *base;
+	unsigned char index;
+	unsigned int irq;
+	unsigned int irq_offset;
+	u32 intr_status;
+	u32 intr_en;
+};
+
+static struct irq_domain *rtk_domain;
+
+static void mux_mask_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_st;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_st = mux_data->intr_status;
+
+	__raw_writel(BIT(data->hwirq % IRQ_INMUX), base + reg_st);
+}
+
+static void mux_unmask_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_en;
+	u8 en_offset;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_en = mux_data->intr_en;
+
+	en_offset = irq_map_tab[mux_data->index][data->hwirq % IRQ_INMUX];
+
+	if ((en_offset != MISC_INT_RVD) && (en_offset != MISC_INT_FAIL)) {
+
+		__raw_writel((__raw_readl(base + reg_en) |
+			BIT(en_offset)), base + reg_en);
+
+	} else if (en_offset == MISC_INT_FAIL) {
+		pr_err("[%s] Enable irq(%lu) fail\n", DEV_NAME, data->hwirq);
+	}
+}
+
+static void mux_disable_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_en;
+	u8 en_offset;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (data->hwirq == IRDA_HW_IRQ && !xen_initial_domain()) {
+		pr_info("%s:Skip IRDA on Guest Domain\n", __func__);
+		return;
+	}
+#endif
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_en = mux_data->intr_en;
+
+	en_offset = irq_map_tab[mux_data->index][data->hwirq % IRQ_INMUX];
+
+	if ((en_offset != MISC_INT_RVD) && (en_offset != MISC_INT_FAIL)) {
+
+		__raw_writel((__raw_readl(base + reg_en) &
+				~BIT(en_offset)), base + reg_en);
+
+	} else if (en_offset == MISC_INT_FAIL) {
+		pr_err("[%s] Disable irq(%lu) fail\n", DEV_NAME, data->hwirq);
+	}
+}
+
+#ifdef CONFIG_SMP
+static int __maybe_unused mux_set_affinity(struct irq_data *d,
+	const struct cpumask *mask_val,
+	bool force)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(d);
+	struct irq_chip *chip = irq_get_chip(mux_data->irq);
+	struct irq_data *data = irq_get_irq_data(mux_data->irq);
+
+	if (chip && chip->irq_set_affinity)
+		return chip->irq_set_affinity(data, mask_val, force);
+	else
+		return -EINVAL;
+
+}
+#endif
+
+static struct irq_chip mux_chip = {
+	.name = DEV_NAME,
+	.irq_mask = mux_mask_irq,
+	.irq_unmask = mux_unmask_irq,
+	.irq_disable = mux_disable_irq,
+#ifdef CONFIG_SMP
+	.irq_set_affinity = mux_set_affinity,
+#endif
+};
+
+static void mux_irq_handle(struct irq_desc *desc)
+{
+	struct irq_mux_data *mux_data = irq_desc_get_handler_data(desc);
+	struct irq_chip *chip = irq_desc_get_chip(desc);
+	unsigned int irq = irq_desc_get_irq(desc);
+	unsigned int tmp;
+	int ret;
+	unsigned int mux_irq;
+	static u32 count;
+	u8 en_offset;
+	int i;
+	unsigned int status, check_status;
+	unsigned int enable;
+
+	u32 reg_st = mux_data->intr_status;
+	u32 reg_en = mux_data->intr_en;
+
+	chained_irq_enter(chip, desc);
+
+	spin_lock(&irq_mux_lock);
+	enable = __raw_readl(mux_data->base + reg_en);
+	status = __raw_readl(mux_data->base + reg_st);
+	spin_unlock(&irq_mux_lock);
+
+	for (i = 0 ; i < IRQ_INMUX ; i++) {
+		if (status & BIT(i)) {
+			en_offset = irq_map_tab[mux_data->index][i];
+			mux_irq = mux_data->irq_offset + i;
+
+			if ((en_offset < IRQ_INMUX) &&
+				(enable & BIT(en_offset))) {
+
+				tmp = irq_find_mapping(rtk_domain, mux_irq);
+				ret = generic_handle_irq(tmp);
+
+				if (ret != 0) {
+					pr_err("[%s] irq(%u) desc is not found"
+						"(st:0x%08x en:0x%08x)\n",
+						DEV_NAME,
+						mux_irq,
+						status,
+						enable);
+				}
+			} else if (en_offset == MISC_INT_RVD) {
+
+				tmp = irq_find_mapping(rtk_domain, mux_irq);
+				ret = generic_handle_irq(tmp);
+
+				if (ret != 0) {
+					pr_err("[%s] irq(%u) desc is not found"
+						"(st:0x%08x en:0x%08x)\n",
+						DEV_NAME,
+						mux_irq,
+						status,
+						enable);
+				}
+			} else {
+				pr_err("[%s] irq(%u) should not happen"
+					"(st:0x%08x en:0x%08x)\n",
+					DEV_NAME,
+					mux_irq,
+					status,
+					enable);
+			}
+		}
+	}
+
+	/* as a transmission interface, SPI wont do too much here */
+	if (irq == 1 && status | 0x08000000) 
+		goto out; 	
+	
+
+	spin_lock(&irq_mux_lock);
+	check_status = __raw_readl(mux_data->base + reg_st);
+	spin_unlock(&irq_mux_lock);
+
+	if (check_status == status) {
+		if (count > 1) {
+			pr_err("[%s] (%u) %s irq status is not change"
+				"clear it! (st:0x%08x en:0x%08x)\n",
+				DEV_NAME,
+				irq,
+				mux_data->index ? "ISO" : "MISC",
+				status,
+				enable);
+		} else {
+			count++;
+		}
+
+		spin_lock(&irq_mux_lock);
+		__raw_writel(BIT(__ffs(status)), mux_data->base + reg_st);
+		spin_unlock(&irq_mux_lock);
+
+	} else {
+		count = 0;
+	}
+out:
+	chained_irq_exit(chip, desc);
+}
+
+static int mux_irq_domain_xlate(struct irq_domain *d,
+	struct device_node *controller,
+	const u32 *intspec,
+	unsigned int intsize,
+	unsigned long *out_hwirq,
+	unsigned int *out_type)
+{
+	if (controller != irq_domain_get_of_node(d))
+		return -EINVAL;
+
+	if (intsize < 2)
+		return -EINVAL;
+
+	*out_hwirq = intspec[0] * IRQ_INMUX + intspec[1];
+	*out_type = 0;
+
+	return 0;
+}
+
+static int mux_irq_domain_map(struct irq_domain *d,
+						unsigned int irq,
+						irq_hw_number_t hw)
+{
+	struct irq_mux_data *data = d->host_data;
+
+	irq_set_chip_and_handler(irq, &mux_chip, handle_level_irq);
+	irq_set_chip_data(irq, data);
+	irq_set_probe(irq);
+
+	return 0;
+}
+
+static const struct irq_domain_ops mux_irq_domain_ops = {
+	.xlate = mux_irq_domain_xlate,
+	.map = mux_irq_domain_map,
+};
+
+static void __init mux_init_each(struct irq_mux_data *mux_data,
+	void __iomem *base,
+	u32 irq, u32 status,
+	u32 enable, int nr)
+{
+	mux_data->base = base;
+	mux_data->index = nr;
+	mux_data->irq = irq;
+	mux_data->irq_offset = nr * IRQ_INMUX;
+	mux_data->intr_status = status;
+	mux_data->intr_en = enable;
+
+#ifndef CONFIG_RTK_XEN_SUPPORT  // UART is handled at hypervisor, clear bit will cause console stop
+	__raw_writel((__raw_readl(base + enable) & ~BIT(2)), base + enable);
+	__raw_writel(BIT(2), base + status);
+#endif
+
+	irq_set_chained_handler_and_data(irq, mux_irq_handle, mux_data);
+
+}
+
+#ifdef CONFIG_OF
+static int __init mux_of_init(struct device_node *np,
+	struct device_node *parent)
+{
+	int i;
+	u32 nr_irq = 1;
+	struct irq_mux_data *mux_data;
+	void __iomem *base;
+	u32 irq;
+	u32 status, enable;
+
+	if (WARN_ON(!np))
+		return -ENODEV;
+
+	if (of_property_read_u32(np, "Realtek,mux-nr", &nr_irq))
+		pr_err("[%s] can not specified mux number", DEV_NAME);
+
+	mux_data = kcalloc(nr_irq, sizeof(*mux_data), GFP_KERNEL);
+
+	/*
+	 * TODO : tempary define the first irq number
+	 * in this mux is 160, end in 160+64
+	 */
+	rtk_domain = irq_domain_add_simple(np,
+		(nr_irq * IRQ_INMUX),
+		160,
+		&mux_irq_domain_ops,
+		mux_data);
+
+	if (!rtk_domain)
+		pr_warn("[%s] IRQ domain init failed\n", DEV_NAME);
+
+	for (i = 0; i < nr_irq; i++) {
+		base = of_iomap(np, i);
+
+		if (!base)
+			pr_warn("[%s] unable to map IRQ base registers\n",
+				DEV_NAME);
+
+
+		irq = irq_of_parse_and_map(np, i);
+
+		if (!irq)
+			pr_warn("[%s] can not map IRQ\n", DEV_NAME);
+
+		of_property_read_u32_index(np, "intr-status", i, &status);
+		of_property_read_u32_index(np, "intr-en", i, &enable);
+
+		mux_init_each(mux_data, base, irq, status, enable, i);
+
+		mux_data++;
+	}
+
+	return 0;
+}
+
+IRQCHIP_DECLARE(rtk_irq_mux, "Realtek,rtk-irq-mux", mux_of_init);
+#endif
diff --git a/drivers/irqchip/irq-rtd129x.h b/drivers/irqchip/irq-rtd129x.h
new file mode 100644
index 00000000..b00e180
--- /dev/null
+++ b/drivers/irqchip/irq-rtd129x.h
@@ -0,0 +1,127 @@
+/*
+ * irq-rtd129x.h - RTK irq mux driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef IRQ_RTD129x_H_
+#define IRQ_RTD129x_H_
+
+#define IRQ_INMUX 32
+
+enum misc_int_en {
+	MISC_INT_FAIL = 0xFF,
+	MISC_INT_RVD = 0xFE,
+	MISC_INT_EN_FAN = 29,
+	MISC_INT_EN_I2C3 = 28,
+	MISC_INT_EN_GSPI = 27,
+	MISC_INT_EN_I2C2 = 26,
+	MISC_INT_EN_SC0 = 24,
+	MISC_INT_EN_LSADC1 = 22,
+	MISC_INT_EN_LSADC0 = 21,
+	MISC_INT_EN_GPIODA = 20,
+	MISC_INT_EN_GPIOA = 19,
+	MISC_INT_EN_I2C4 = 15,
+	MISC_INT_EN_I2C5 = 14,
+	MISC_INT_EN_RTC_DATA = 12,
+	MISC_INT_EN_RTC_HOUR = 11,
+	MISC_INT_EN_RTC_MIN = 10,
+	MISC_INT_EN_UR2 = 7,
+	MISC_INT_EN_UR2_TO = 6,
+	MISC_INT_EN_UR1_TO = 5,
+	MISC_INT_EN_UR1 = 3,
+};
+
+enum iso_int_en {
+	ISO_INT_FAIL = 0xFF,
+	ISO_INT_RVD = 0xFE,
+	ISO_INT_EN_I2C1_REQ = 31,
+	ISO_INT_EN_GPHY_AV = 30,
+	ISO_INT_EN_GPHY_DV = 29,
+	ISO_INT_EN_GPIODA = 20,
+	ISO_INT_EN_GPIOA = 19,
+	ISO_INT_EN_RTC_ALARM = 13,
+	ISO_INT_EN_RTC_HSEC = 12,
+	ISO_INT_EN_I2C1 = 11,
+	ISO_INT_EN_I2C0 = 8,
+	ISO_INT_EN_IRDA = 5,
+	ISO_INT_EN_UR0 = 2,
+};
+
+unsigned char irq_map_tab[2][IRQ_INMUX] = {
+	{
+	MISC_INT_FAIL, /* Bit0 */
+	MISC_INT_FAIL, /* Bit1 */
+	MISC_INT_RVD, /* Bit2 */
+	MISC_INT_EN_UR1, /* Bit3 */
+	MISC_INT_FAIL, /* Bit4 */
+	MISC_INT_EN_UR1_TO, /* Bit5 */
+	MISC_INT_RVD, /* Bit6 */
+	MISC_INT_RVD, /* Bit7 */
+	MISC_INT_EN_UR2, /* Bit8 */
+	MISC_INT_RVD, /* Bit9 */
+	MISC_INT_EN_RTC_MIN, /* Bit10 */
+	MISC_INT_EN_RTC_HOUR, /* Bit11 */
+	MISC_INT_EN_RTC_DATA, /* Bit12 */
+	MISC_INT_EN_UR2_TO, /* Bit13 */
+	MISC_INT_EN_I2C5, /* Bit14 */
+	MISC_INT_EN_I2C4, /* Bit15 */
+	MISC_INT_FAIL, /* Bit16 */
+	MISC_INT_FAIL, /* Bit17 */
+	MISC_INT_FAIL, /* Bit18 */
+	MISC_INT_EN_GPIOA, /* Bit19 */
+	MISC_INT_EN_GPIODA, /* Bit20 */
+	MISC_INT_EN_LSADC0, /* Bit21 */
+	MISC_INT_EN_LSADC1, /* Bit22 */
+	MISC_INT_EN_I2C3, /* Bit23 */
+	MISC_INT_EN_SC0, /* Bit24 */
+	MISC_INT_FAIL, /* Bit25 */
+	MISC_INT_EN_I2C2, /* Bit26 */
+	MISC_INT_EN_GSPI, /* Bit27 */
+	MISC_INT_FAIL, /* Bit28 */
+	MISC_INT_EN_FAN, /* Bit29 */
+	MISC_INT_FAIL, /* Bit30 */
+	MISC_INT_FAIL, /* Bit31 */
+	},
+	{
+	ISO_INT_FAIL, /* Bit0 */
+	ISO_INT_RVD, /* Bit1 */
+	ISO_INT_EN_UR0,	/* Bit2 */
+	ISO_INT_FAIL, /* Bit3 */
+	ISO_INT_FAIL, /* Bit4 */
+	ISO_INT_EN_IRDA, /* Bit5 */
+	ISO_INT_FAIL, /* Bit6 */
+	ISO_INT_RVD, /* Bit7 */
+	ISO_INT_EN_I2C0, /* Bit8 */
+	ISO_INT_RVD, /* Bit9 */
+	ISO_INT_FAIL, /* Bit10 */
+	ISO_INT_EN_I2C1, /* Bit11 */
+	ISO_INT_EN_RTC_HSEC, /* Bit12 */
+	ISO_INT_EN_RTC_ALARM, /* Bit13 */
+	ISO_INT_FAIL, /* Bit14 */
+	ISO_INT_FAIL, /* Bit15 */
+	ISO_INT_FAIL, /* Bit16 */
+	ISO_INT_FAIL, /* Bit17 */
+	ISO_INT_FAIL, /* Bit18 */
+	ISO_INT_EN_GPIOA, /* Bit19 */
+	ISO_INT_EN_GPIODA, /* Bit20 */
+	ISO_INT_RVD, /* Bit21 */
+	ISO_INT_RVD, /* Bit22 */
+	ISO_INT_RVD, /* Bit23 */
+	ISO_INT_RVD, /* Bit24 */
+	ISO_INT_FAIL, /* Bit25 */
+	ISO_INT_FAIL, /* Bit26 */
+	ISO_INT_FAIL, /* Bit27 */
+	ISO_INT_FAIL, /* Bit28 */
+	ISO_INT_EN_GPHY_DV, /* Bit29 */
+	ISO_INT_EN_GPHY_AV, /* Bit30 */
+	ISO_INT_EN_I2C1_REQ, /* Bit31 */
+	}
+};
+
+#endif /* IRQ_RTD129x_H_ */
diff --git a/drivers/irqchip/irq-rtd139x.c b/drivers/irqchip/irq-rtd139x.c
new file mode 100644
index 00000000..8e9b29d
--- /dev/null
+++ b/drivers/irqchip/irq-rtd139x.c
@@ -0,0 +1,357 @@
+/*
+ * irq-rtd139x.c - RTK irq mux driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/err.h>
+#include <linux/export.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/syscore_ops.h>
+#include <linux/slab.h>
+#include <linux/irqdomain.h>
+#include <linux/irqchip/chained_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/irqchip.h>
+#include <asm/hardirq.h>
+#include <asm/exception.h>
+#include <asm/irq.h>
+
+#include "irq-rtd139x.h"
+
+#define DEV_NAME "RTK_IRQ_MUX"
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#define IRDA_HW_IRQ     37
+#endif
+
+static DEFINE_SPINLOCK(irq_mux_lock);
+
+struct irq_mux_data {
+	void __iomem *base;
+	unsigned char index;
+	unsigned int irq;
+	unsigned int irq_offset;
+	u32 intr_status;
+	u32 intr_en;
+};
+
+static struct irq_domain *rtk_domain;
+
+static void mux_mask_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_st;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_st = mux_data->intr_status;
+
+	__raw_writel(BIT(data->hwirq % IRQ_INMUX), base + reg_st);
+}
+
+static void mux_unmask_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_en;
+	u8 en_offset;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_en = mux_data->intr_en;
+
+	en_offset = irq_map_tab[mux_data->index][data->hwirq % IRQ_INMUX];
+
+	if ((en_offset != MISC_INT_RVD) && (en_offset != MISC_INT_FAIL)) {
+
+		__raw_writel((__raw_readl(base + reg_en) |
+			BIT(en_offset)), base + reg_en);
+
+	} else if (en_offset == MISC_INT_FAIL) {
+		pr_err("[%s] Enable irq(%lu) fail\n", DEV_NAME, data->hwirq);
+	}
+
+}
+
+static void mux_disable_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_en;
+	u8 en_offset;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (data->hwirq == IRDA_HW_IRQ && !xen_initial_domain()) {
+		pr_info("%s:Skip IRDA on Guest Domain\n", __func__);
+		return;
+	}
+#endif
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_en = mux_data->intr_en;
+
+	en_offset = irq_map_tab[mux_data->index][data->hwirq % IRQ_INMUX];
+
+	if ((en_offset != MISC_INT_RVD) && (en_offset != MISC_INT_FAIL)) {
+
+		__raw_writel((__raw_readl(base + reg_en) &
+				~BIT(en_offset)), base + reg_en);
+
+	} else if (en_offset == MISC_INT_FAIL) {
+		pr_err("[%s] Disable irq(%lu) fail\n", DEV_NAME, data->hwirq);
+	}
+
+}
+
+#ifdef CONFIG_SMP
+static int __maybe_unused mux_set_affinity(struct irq_data *d,
+	const struct cpumask *mask_val,
+	bool force)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(d);
+	struct irq_chip *chip = irq_get_chip(mux_data->irq);
+	struct irq_data *data = irq_get_irq_data(mux_data->irq);
+
+	if (chip && chip->irq_set_affinity)
+		return chip->irq_set_affinity(data, mask_val, force);
+	else
+		return -EINVAL;
+
+}
+#endif
+
+static struct irq_chip mux_chip = {
+	.name = DEV_NAME,
+	.irq_mask = mux_mask_irq,
+	.irq_unmask = mux_unmask_irq,
+	.irq_disable = mux_disable_irq,
+#ifdef CONFIG_SMP
+	.irq_set_affinity = mux_set_affinity,
+#endif
+};
+
+static void mux_irq_handle(struct irq_desc *desc)
+{
+	struct irq_mux_data *mux_data = irq_desc_get_handler_data(desc);
+	struct irq_chip *chip = irq_desc_get_chip(desc);
+	unsigned int irq = irq_desc_get_irq(desc);
+	unsigned int tmp;
+	int ret;
+	unsigned int mux_irq;
+	static u32 count;
+	u8 en_offset;
+	int i;
+	unsigned int status, check_status;
+	unsigned int enable;
+
+	u32 reg_st = mux_data->intr_status;
+	u32 reg_en = mux_data->intr_en;
+
+	chained_irq_enter(chip, desc);
+
+	spin_lock(&irq_mux_lock);
+	enable = __raw_readl(mux_data->base + reg_en);
+	status = __raw_readl(mux_data->base + reg_st);
+	spin_unlock(&irq_mux_lock);
+
+	for (i = 0 ; i < IRQ_INMUX ; i++) {
+		if (status & BIT(i)) {
+			en_offset = irq_map_tab[mux_data->index][i];
+			mux_irq = mux_data->irq_offset + i;
+
+			if ((en_offset < IRQ_INMUX) &&
+				(enable & BIT(en_offset))) {
+
+				tmp = irq_find_mapping(rtk_domain, mux_irq);
+				ret = generic_handle_irq(tmp);
+
+				if (ret != 0) {
+					pr_err("[%s] irq(%u) desc is not found"
+						"(st:0x%08x en:0x%08x)\n",
+						DEV_NAME,
+						mux_irq,
+						status,
+						enable);
+				}
+			} else if (en_offset == MISC_INT_RVD) {
+
+				tmp = irq_find_mapping(rtk_domain, mux_irq);
+				ret = generic_handle_irq(tmp);
+
+				if (ret != 0) {
+					pr_err("[%s] irq(%u) desc is not found"
+						"(st:0x%08x en:0x%08x)\n",
+						DEV_NAME,
+						mux_irq,
+						status,
+						enable);
+				}
+			} else {
+				pr_err("[%s] irq(%u) should not happen"
+					"(st:0x%08x en:0x%08x)\n",
+					DEV_NAME,
+					mux_irq,
+					status,
+					enable);
+			}
+		}
+	}
+
+	/* as a transmission interface, SPI wont do too much here */
+	if (irq == 1 && status | 0x08000000)
+		goto out;
+
+	spin_lock(&irq_mux_lock);
+	check_status = __raw_readl(mux_data->base + reg_st);
+	spin_unlock(&irq_mux_lock);
+
+	if (check_status == status) {
+		if (count > 1) {
+			pr_err("[%s] (%u) %s irq status is not change"
+				"clear it! (st:0x%08x en:0x%08x)\n",
+				DEV_NAME,
+				irq,
+				mux_data->index ? "ISO" : "MISC",
+				status,
+				enable);
+		} else {
+			count++;
+		}
+
+		spin_lock(&irq_mux_lock);
+		__raw_writel(BIT(__ffs(status)), mux_data->base + reg_st);
+		spin_unlock(&irq_mux_lock);
+
+	} else {
+		count = 0;
+	}
+out:
+	chained_irq_exit(chip, desc);
+}
+
+static int mux_irq_domain_xlate(struct irq_domain *d,
+	struct device_node *controller,
+	const u32 *intspec,
+	unsigned int intsize,
+	unsigned long *out_hwirq,
+	unsigned int *out_type)
+{
+	if (controller != irq_domain_get_of_node(d))
+		return -EINVAL;
+
+	if (intsize < 2)
+		return -EINVAL;
+
+	*out_hwirq = intspec[0] * IRQ_INMUX + intspec[1];
+	*out_type = 0;
+
+	return 0;
+}
+
+static int mux_irq_domain_map(struct irq_domain *d,
+						unsigned int irq,
+						irq_hw_number_t hw)
+{
+	struct irq_mux_data *data = d->host_data;
+
+	irq_set_chip_and_handler(irq, &mux_chip, handle_level_irq);
+	irq_set_chip_data(irq, data);
+	irq_set_probe(irq);
+
+	return 0;
+}
+
+static const struct irq_domain_ops mux_irq_domain_ops = {
+	.xlate = mux_irq_domain_xlate,
+	.map = mux_irq_domain_map,
+};
+
+static void __init mux_init_each(struct irq_mux_data *mux_data,
+	void __iomem *base,
+	u32 irq, u32 status,
+	u32 enable, int nr)
+{
+	mux_data->base = base;
+	mux_data->index = nr;
+	mux_data->irq = irq;
+	mux_data->irq_offset = nr * IRQ_INMUX;
+	mux_data->intr_status = status;
+	mux_data->intr_en = enable;
+
+#ifndef CONFIG_RTK_XEN_SUPPORT  // UART is handled at hypervisor, clear bit will cause console stop
+	__raw_writel((__raw_readl(base + enable) & ~BIT(2)), base + enable);
+	__raw_writel(BIT(2), base + status);
+#endif
+
+	irq_set_chained_handler_and_data(irq, mux_irq_handle, mux_data);
+
+}
+
+#ifdef CONFIG_OF
+static int __init mux_of_init(struct device_node *np,
+	struct device_node *parent)
+{
+	int i;
+	u32 nr_irq = 1;
+	struct irq_mux_data *mux_data;
+	void __iomem *base;
+	u32 irq;
+	u32 status, enable;
+
+	if (WARN_ON(!np))
+		return -ENODEV;
+
+	if (of_property_read_u32(np, "Realtek,mux-nr", &nr_irq))
+		pr_err("[%s] can not specified mux number", DEV_NAME);
+
+	mux_data = kcalloc(nr_irq, sizeof(*mux_data), GFP_KERNEL);
+
+	/*
+	 * TODO : tempary define the first irq number
+	 * in this mux is 160, end in 160+64
+	 */
+	rtk_domain = irq_domain_add_simple(np,
+		(nr_irq * IRQ_INMUX),
+		160,
+		&mux_irq_domain_ops,
+		mux_data);
+
+	if (!rtk_domain)
+		pr_warn("[%s] IRQ domain init failed\n", DEV_NAME);
+
+	for (i = 0; i < nr_irq; i++) {
+		base = of_iomap(np, i);
+
+		if (!base)
+			pr_warn("[%s] unable to map IRQ base registers\n",
+				DEV_NAME);
+
+
+		irq = irq_of_parse_and_map(np, i);
+
+		if (!irq)
+			pr_warn("[%s] can not map IRQ\n", DEV_NAME);
+
+		of_property_read_u32_index(np, "intr-status", i, &status);
+		of_property_read_u32_index(np, "intr-en", i, &enable);
+
+		mux_init_each(mux_data, base, irq, status, enable, i);
+
+		mux_data++;
+	}
+
+	return 0;
+}
+
+IRQCHIP_DECLARE(rtk_irq_mux, "Realtek,rtk-irq-mux", mux_of_init);
+#endif
diff --git a/drivers/irqchip/irq-rtd139x.h b/drivers/irqchip/irq-rtd139x.h
new file mode 100644
index 00000000..ce95c0e
--- /dev/null
+++ b/drivers/irqchip/irq-rtd139x.h
@@ -0,0 +1,121 @@
+/*
+ * irq-rtd139x.h - RTK irq mux driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef IRQ_RTD139x_H_
+#define IRQ_RTD139x_H_
+
+#define IRQ_INMUX 32
+
+enum misc_int_en {
+	MISC_INT_FAIL = 0xFF,
+	MISC_INT_RVD = 0xFE,
+	MISC_INT_EN_FAN = 29,
+	MISC_INT_EN_SPI = 27,
+	MISC_INT_EN_SC0 = 24,
+	MISC_INT_EN_I2C5 = 14,
+	MISC_INT_EN_UR2 = 7,
+	MISC_INT_EN_UR2_TO = 6,
+	MISC_INT_EN_UR1_TO = 5,
+	MISC_INT_EN_UR1 = 3,
+};
+
+enum iso_int_en {
+	ISO_INT_FAIL = 0xFF,
+	ISO_INT_RVD = 0xFE,
+	ISO_INT_EN_I2C1_REQ = 31,
+	ISO_INT_EN_GPHY_AV = 30,
+	ISO_INT_EN_GPHY_DV = 29,
+	ISO_INT_EN_GPHY_HV = 28,
+	ISO_INT_EN_GPIODA = 20,
+	ISO_INT_EN_GPIOA = 19,
+	ISO_INT_EN_LSADC1 = 17,
+	ISO_INT_EN_LSADC0 = 16,
+	ISO_INT_EN_RTC_ALARM = 13,
+	ISO_INT_EN_RTC_HSEC = 12,
+	ISO_INT_EN_I2C1 = 11,
+	ISO_INT_EN_I2C0 = 8,
+	ISO_INT_EN_IRDA = 5,
+	ISO_INT_EN_UR0 = 2,
+};
+
+const unsigned char irq_map_tab[2][IRQ_INMUX] = {
+	{
+	MISC_INT_FAIL, /* Bit0 */
+	MISC_INT_FAIL, /* Bit1 */
+	MISC_INT_RVD, /* Bit2 */
+	MISC_INT_EN_UR1, /* Bit3 */
+	MISC_INT_FAIL, /* Bit4 */
+	MISC_INT_EN_UR1_TO, /* Bit5 */
+	MISC_INT_RVD, /* Bit6 */
+	MISC_INT_RVD, /* Bit7 */
+	MISC_INT_EN_UR2, /* Bit8 */
+	MISC_INT_FAIL, /* Bit9 */
+	MISC_INT_FAIL, /* Bit10 */
+	MISC_INT_FAIL, /* Bit11 */
+	MISC_INT_FAIL, /* Bit12 */
+	MISC_INT_EN_UR2_TO, /* Bit13 */
+	MISC_INT_EN_I2C5, /* Bit14 */
+	MISC_INT_FAIL, /* Bit15 */
+	MISC_INT_FAIL, /* Bit16 */
+	MISC_INT_FAIL, /* Bit17 */
+	MISC_INT_FAIL, /* Bit18 */
+	MISC_INT_FAIL, /* Bit19 */
+	MISC_INT_FAIL, /* Bit20 */
+	MISC_INT_FAIL, /* Bit21 */
+	MISC_INT_FAIL, /* Bit22 */
+	MISC_INT_FAIL, /* Bit23 */
+	MISC_INT_EN_SC0, /* Bit24 */
+	MISC_INT_FAIL, /* Bit25 */
+	MISC_INT_FAIL, /* Bit26 */
+	MISC_INT_EN_SPI, /* Bit27 */
+	MISC_INT_FAIL, /* Bit28 */
+	MISC_INT_EN_FAN, /* Bit29 */
+	MISC_INT_FAIL, /* Bit30 */
+	MISC_INT_FAIL, /* Bit31 */
+	},
+	{
+	ISO_INT_FAIL, /* Bit0 */
+	ISO_INT_RVD, /* Bit1 */
+	ISO_INT_EN_UR0,	/* Bit2 */
+	ISO_INT_FAIL, /* Bit3 */
+	ISO_INT_FAIL, /* Bit4 */
+	ISO_INT_EN_IRDA, /* Bit5 */
+	ISO_INT_FAIL, /* Bit6 */
+	ISO_INT_RVD, /* Bit7 */
+	ISO_INT_EN_I2C0, /* Bit8 */
+	ISO_INT_RVD, /* Bit9 */
+	ISO_INT_FAIL, /* Bit10 */
+	ISO_INT_EN_I2C1, /* Bit11 */
+	ISO_INT_EN_RTC_HSEC, /* Bit12 */
+	ISO_INT_EN_RTC_ALARM, /* Bit13 */
+	ISO_INT_FAIL, /* Bit14 */
+	ISO_INT_FAIL, /* Bit15 */
+	ISO_INT_EN_LSADC0, /* Bit16 */
+	ISO_INT_EN_LSADC1, /* Bit17 */
+	ISO_INT_FAIL, /* Bit18 */
+	ISO_INT_EN_GPIOA, /* Bit19 */
+	ISO_INT_EN_GPIODA, /* Bit20 */
+	ISO_INT_RVD, /* Bit21 */
+	ISO_INT_RVD, /* Bit22 */
+	ISO_INT_RVD, /* Bit23 */
+	ISO_INT_RVD, /* Bit24 */
+	ISO_INT_FAIL, /* Bit25 */
+	ISO_INT_FAIL, /* Bit26 */
+	ISO_INT_FAIL, /* Bit27 */
+	ISO_INT_EN_GPHY_HV, /* Bit28 */
+	ISO_INT_EN_GPHY_DV, /* Bit29 */
+	ISO_INT_EN_GPHY_AV, /* Bit30 */
+	ISO_INT_EN_I2C1_REQ, /* Bit31 */
+	}
+};
+
+
+#endif /* IRQ_RTD139x_H_ */
diff --git a/drivers/irqchip/irq-rtd13xx.c b/drivers/irqchip/irq-rtd13xx.c
new file mode 100644
index 00000000..4551a64
--- /dev/null
+++ b/drivers/irqchip/irq-rtd13xx.c
@@ -0,0 +1,368 @@
+/*
+ * irq-rtd13xx.c - RTK irq mux driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/err.h>
+#include <linux/export.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/syscore_ops.h>
+#include <linux/slab.h>
+#include <linux/irqdomain.h>
+#include <linux/irqchip/chained_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/irqchip.h>
+#include <asm/hardirq.h>
+#include <asm/exception.h>
+#include <asm/irq.h>
+
+#include "irq-rtd13xx.h"
+
+#define DEV_NAME "RTK_IRQ_MUX"
+
+static DEFINE_SPINLOCK(irq_mux_lock);
+
+struct irq_mux_data {
+	void __iomem *base;
+	unsigned char index;
+	unsigned int irq;
+	unsigned int irq_offset;
+	u32 intr_status;
+	u32 intr_en;
+};
+
+static struct irq_domain *rtk_domain;
+
+static void mux_mask_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_st;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_st = mux_data->intr_status;
+
+	__raw_writel(BIT(data->hwirq % IRQ_INMUX), base + reg_st);
+}
+
+static void mux_unmask_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_en;
+	u8 en_offset;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_en = mux_data->intr_en;
+
+	en_offset = irq_map_tab[mux_data->index][data->hwirq % IRQ_INMUX];
+
+	if ((en_offset != MISC_INT_RVD) && (en_offset != MISC_INT_FAIL)) {
+
+		__raw_writel((__raw_readl(base + reg_en) |
+			BIT(en_offset)), base + reg_en);
+
+	} else if (en_offset == MISC_INT_FAIL) {
+		pr_err("[%s] Enable irq(%lu) fail\n", DEV_NAME, data->hwirq);
+	}
+
+}
+
+static void mux_disable_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_en;
+	u8 en_offset;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_en = mux_data->intr_en;
+
+	en_offset = irq_map_tab[mux_data->index][data->hwirq % IRQ_INMUX];
+
+	if ((en_offset != MISC_INT_RVD) && (en_offset != MISC_INT_FAIL)) {
+
+		__raw_writel((__raw_readl(base + reg_en) &
+				~BIT(en_offset)), base + reg_en);
+
+	} else if (en_offset == MISC_INT_FAIL) {
+		pr_err("[%s] Disable irq(%lu) fail\n", DEV_NAME, data->hwirq);
+	}
+
+}
+
+static int mux_set_type(struct irq_data *d, unsigned int type)
+{
+	/*
+	 * TODO: configure ISO/MSIC interrupt type
+	*/
+	return 0;
+}
+
+#ifdef CONFIG_SMP
+static int __maybe_unused mux_set_affinity(struct irq_data *d,
+	const struct cpumask *mask_val,
+	bool force)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(d);
+	struct irq_chip *chip = irq_get_chip(mux_data->irq);
+	struct irq_data *data = irq_get_irq_data(mux_data->irq);
+
+	if (chip && chip->irq_set_affinity)
+		return chip->irq_set_affinity(data, mask_val, force);
+	else
+		return -EINVAL;
+
+}
+#endif
+
+static struct irq_chip mux_chip = {
+	.name = DEV_NAME,
+	.irq_mask = mux_mask_irq,
+	.irq_unmask = mux_unmask_irq,
+	.irq_disable = mux_disable_irq,
+	.irq_set_type = mux_set_type,
+#ifdef CONFIG_SMP
+	.irq_set_affinity = mux_set_affinity,
+#endif
+};
+
+static void mux_irq_handle(struct irq_desc *desc)
+{
+	struct irq_mux_data *mux_data = irq_desc_get_handler_data(desc);
+	struct irq_chip *chip = irq_desc_get_chip(desc);
+	unsigned int irq = irq_desc_get_irq(desc);
+	unsigned int tmp;
+	int ret;
+	unsigned int mux_irq;
+	static u32 count;
+	u8 en_offset;
+	int i;
+	unsigned int status, check_status;
+	unsigned int enable;
+
+	u32 reg_st = mux_data->intr_status;
+	u32 reg_en = mux_data->intr_en;
+
+	chained_irq_enter(chip, desc);
+
+	spin_lock(&irq_mux_lock);
+	enable = __raw_readl(mux_data->base + reg_en);
+	status = __raw_readl(mux_data->base + reg_st);
+	spin_unlock(&irq_mux_lock);
+
+	for (i = 0 ; i < IRQ_INMUX ; i++) {
+		if (status & BIT(i)) {
+			en_offset = irq_map_tab[mux_data->index][i];
+			mux_irq = mux_data->irq_offset + i;
+
+			if ((en_offset < IRQ_INMUX) &&
+				(enable & BIT(en_offset))) {
+
+				tmp = irq_find_mapping(rtk_domain, mux_irq);
+				ret = generic_handle_irq(tmp);
+
+				if (ret != 0) {
+					pr_err("[%s] irq(%u) desc is not found"
+						"(st:0x%08x en:0x%08x)\n",
+						DEV_NAME,
+						mux_irq,
+						status,
+						enable);
+				}
+			} else if (en_offset == MISC_INT_RVD) {
+
+				tmp = irq_find_mapping(rtk_domain, mux_irq);
+				ret = generic_handle_irq(tmp);
+
+				if (ret != 0) {
+					pr_err("[%s] irq(%u) desc is not found"
+						"(st:0x%08x en:0x%08x)\n",
+						DEV_NAME,
+						mux_irq,
+						status,
+						enable);
+				}
+			} else {
+				pr_err("[%s] irq(%u) should not happen"
+					"(st:0x%08x en:0x%08x)\n",
+					DEV_NAME,
+					mux_irq,
+					status,
+					enable);
+			}
+		}
+	}
+
+	/* as a transmission interface, SPI wont do too much here */
+	if ((irq == 17 && (status & 0x08000000)) ||
+		(irq == 18 && (status & 0x00000040)))
+		goto out;
+
+	spin_lock(&irq_mux_lock);
+	check_status = __raw_readl(mux_data->base + reg_st);
+	spin_unlock(&irq_mux_lock);
+
+	if (check_status == status) {
+		if (count > 1) {
+			pr_err("[%s] (%u) %s irq status is not change. "
+				"clear it! (st:0x%08x en:0x%08x)\n",
+				DEV_NAME,
+				irq,
+				mux_data->index ? "ISO" : "MISC",
+				status,
+				enable);
+		} else {
+			count++;
+		}
+
+		spin_lock(&irq_mux_lock);
+		__raw_writel(BIT(__ffs(status)), mux_data->base + reg_st);
+		spin_unlock(&irq_mux_lock);
+
+	} else {
+		count = 0;
+	}
+out:
+	chained_irq_exit(chip, desc);
+}
+
+static int mux_irq_domain_xlate(struct irq_domain *d,
+	struct device_node *controller,
+	const u32 *intspec,
+	unsigned int intsize,
+	unsigned long *out_hwirq,
+	unsigned int *out_type)
+{
+
+	if (controller != irq_domain_get_of_node(d))
+		return -EINVAL;
+
+	if (intsize < 2)
+		return -EINVAL;
+
+	*out_hwirq = intspec[0];
+	*out_type = intspec[1];
+
+	return 0;
+}
+
+static int mux_irq_domain_translate(struct irq_domain *d,
+	struct irq_fwspec *fwspec,
+	unsigned long *hwirq,
+	unsigned int *type)
+{
+	unsigned int virq;
+
+	*hwirq = fwspec->param[0];
+	*type = fwspec->param[1];
+
+	virq = irq_find_mapping(d, fwspec->param[0]);
+	irq_set_irq_type(virq, fwspec->param[1]);
+
+	return 0;
+}
+
+static int mux_irq_domain_map(struct irq_domain *d,
+	unsigned int irq,
+	irq_hw_number_t hw)
+{
+	struct irq_mux_data *data = d->host_data;
+
+	irq_set_chip_and_handler(irq, &mux_chip, handle_level_irq);
+	irq_set_chip_data(irq, data);
+	irq_set_probe(irq);
+
+	return 0;
+}
+
+static const struct irq_domain_ops mux_irq_domain_ops = {
+	.translate = mux_irq_domain_translate,
+	.xlate = mux_irq_domain_xlate,
+	.map = mux_irq_domain_map,
+};
+
+static void __init mux_init_each(struct irq_mux_data *mux_data,
+	void __iomem *base,
+	u32 irq, u32 status,
+	u32 enable, int nr)
+{
+	mux_data->base = base;
+	mux_data->index = nr;
+	mux_data->irq = irq;
+	mux_data->irq_offset = nr * IRQ_INMUX;
+	mux_data->intr_status = status;
+	mux_data->intr_en = enable;
+
+	irq_set_chained_handler_and_data(irq, mux_irq_handle, mux_data);
+}
+
+#ifdef CONFIG_OF
+static int __init mux_of_init(struct device_node *np,
+	struct device_node *parent)
+{
+	int i;
+	u32 nr_irq = 1;
+	struct irq_mux_data *mux_data;
+	void __iomem *base;
+	u32 irq;
+	u32 status, enable;
+
+	if (WARN_ON(!np))
+		return -ENODEV;
+
+	if (of_property_read_u32(np, "Realtek,mux-nr", &nr_irq))
+		pr_err("[%s] can not specified mux number", DEV_NAME);
+
+	mux_data = kcalloc(nr_irq, sizeof(*mux_data), GFP_KERNEL);
+
+	/*
+	 * TODO : tempary define the first irq number
+	 * in this mux is 160, end in 160+64
+	 */
+	rtk_domain = irq_domain_add_simple(np,
+		(nr_irq * IRQ_INMUX),
+		160,
+		&mux_irq_domain_ops,
+		mux_data);
+
+	if (!rtk_domain)
+		pr_warn("[%s] IRQ domain init failed\n", DEV_NAME);
+
+	for (i = 0; i < nr_irq; i++) {
+		base = of_iomap(np, i);
+
+		if (!base)
+			pr_warn("[%s] unable to map IRQ base registers\n",
+				DEV_NAME);
+
+
+		irq = irq_of_parse_and_map(np, i);
+
+		if (!irq)
+			pr_warn("[%s] can not map IRQ\n", DEV_NAME);
+
+		of_property_read_u32_index(np, "intr-status", i, &status);
+		of_property_read_u32_index(np, "intr-en", i, &enable);
+
+		mux_init_each(mux_data, base, irq, status, enable, i);
+
+		mux_data++;
+	}
+
+	return 0;
+}
+
+IRQCHIP_DECLARE(rtk_irq_mux, "Realtek,rtk-irq-mux", mux_of_init);
+#endif
diff --git a/drivers/irqchip/irq-rtd13xx.h b/drivers/irqchip/irq-rtd13xx.h
new file mode 100644
index 00000000..2f94ba5
--- /dev/null
+++ b/drivers/irqchip/irq-rtd13xx.h
@@ -0,0 +1,126 @@
+/*
+ * irq-rtd13xx.h - RTK irq mux driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef IRQ_RTD13xx_H_
+#define IRQ_RTD13xx_H_
+
+#define IRQ_INMUX 32
+
+enum misc_int_en {
+	MISC_INT_FAIL = 0xFF,
+	MISC_INT_RVD = 0xFE,
+	MISC_INT_EN_FAN = 29,
+	MISC_INT_EN_I2C3 = 28,
+	MISC_INT_EN_SPI = 27,
+	MISC_INT_EN_SC1 = 25,
+	MISC_INT_EN_SC0 = 24,
+	MISC_INT_EN_I2C5 = 14,
+	MISC_INT_EN_RTC_DATE = 12,
+	MISC_INT_EN_RTC_HOUR = 11,
+	MISC_INT_EN_RTC_MIN = 10,
+	MISC_INT_EN_UR2 = 7,
+	MISC_INT_EN_UR2_TO = 6,
+	MISC_INT_EN_UR1_TO = 5,
+	MISC_INT_EN_UR1 = 3,
+	MISC_INT_EN_WDOG_NMI = 2,
+};
+
+enum iso_int_en {
+	ISO_INT_FAIL = 0xFF,
+	ISO_INT_RVD = 0xFE,
+	ISO_INT_EN_I2C1_REQ = 31,
+	ISO_INT_EN_GPHY_AV = 30,
+	ISO_INT_EN_GPHY_DV = 29,
+	ISO_INT_EN_GPHY_HV = 28,
+	ISO_INT_EN_GPIODA = 20,
+	ISO_INT_EN_GPIOA = 19,
+	ISO_INT_EN_RTC_ALARM = 13,
+	ISO_INT_EN_RTC_HSEC = 12,
+	ISO_INT_EN_I2C1 = 11,
+	ISO_INT_EN_I2C0 = 8,
+	ISO_INT_EN_IRDA = 5,
+	ISO_INT_EN_LSADC0 = 3,
+	ISO_INT_EN_UR0 = 2,
+	ISO_INT_EN_SPI1 = 1,
+};
+
+const unsigned char irq_map_tab[2][IRQ_INMUX] = {
+	{
+	MISC_INT_RVD, /* Bit0 */
+	MISC_INT_RVD, /* Bit1 */
+	MISC_INT_EN_WDOG_NMI, /* Bit2 */
+	MISC_INT_EN_UR1, /* Bit3 */
+	MISC_INT_RVD, /* Bit4 */
+	MISC_INT_EN_UR1_TO, /* Bit5 */
+	MISC_INT_EN_UR2_TO, /* Bit6 */
+	MISC_INT_EN_UR2, /* Bit7 */
+	MISC_INT_RVD, /* Bit8 */
+	MISC_INT_RVD, /* Bit9 */
+	MISC_INT_EN_RTC_MIN, /* Bit10 */
+	MISC_INT_EN_RTC_HOUR, /* Bit11 */
+	MISC_INT_EN_RTC_DATE, /* Bit12 */
+	MISC_INT_RVD, /* Bit13 */
+	MISC_INT_EN_I2C5, /* Bit14 */
+	MISC_INT_RVD, /* Bit15 */
+	MISC_INT_RVD, /* Bit16 */
+	MISC_INT_RVD, /* Bit17 */
+	MISC_INT_RVD, /* Bit18 */
+	MISC_INT_RVD, /* Bit19 */
+	MISC_INT_RVD, /* Bit20 */
+	MISC_INT_RVD, /* Bit21 */
+	MISC_INT_RVD, /* Bit22 */
+	MISC_INT_EN_I2C3, /* Bit23 */
+	MISC_INT_EN_SC0, /* Bit24 */
+	MISC_INT_EN_SC1, /* Bit25 */
+	MISC_INT_RVD, /* Bit26 */
+	MISC_INT_EN_SPI, /* Bit27 */
+	MISC_INT_RVD, /* Bit28 */
+	MISC_INT_EN_FAN, /* Bit29 */
+	MISC_INT_RVD, /* Bit30 */
+	MISC_INT_RVD, /* Bit31 */
+	},
+	{
+	ISO_INT_RVD, /* Bit0 */
+	ISO_INT_EN_SPI1, /* Bit1 */
+	ISO_INT_EN_UR0,	/* Bit2 */
+	ISO_INT_EN_LSADC0, /* Bit3 */
+	ISO_INT_RVD, /* Bit4 */
+	ISO_INT_EN_IRDA, /* Bit5 */
+	ISO_INT_RVD, /* Bit6 */
+	ISO_INT_RVD, /* Bit7 */
+	ISO_INT_EN_I2C0, /* Bit8 */
+	ISO_INT_RVD, /* Bit9 */
+	ISO_INT_RVD, /* Bit10 */
+	ISO_INT_EN_I2C1, /* Bit11 */
+	ISO_INT_EN_RTC_HSEC, /* Bit12 */
+	ISO_INT_EN_RTC_ALARM, /* Bit13 */
+	ISO_INT_RVD, /* Bit14 */
+	ISO_INT_RVD, /* Bit15 */
+	ISO_INT_RVD, /* Bit16 */
+	ISO_INT_RVD, /* Bit17 */
+	ISO_INT_RVD, /* Bit18 */
+	ISO_INT_EN_GPIOA, /* Bit19 */
+	ISO_INT_EN_GPIODA, /* Bit20 */
+	ISO_INT_RVD, /* Bit21 */
+	ISO_INT_RVD, /* Bit22 */
+	ISO_INT_RVD, /* Bit23 */
+	ISO_INT_RVD, /* Bit24 */
+	ISO_INT_RVD, /* Bit25 */
+	ISO_INT_RVD, /* Bit26 */
+	ISO_INT_RVD, /* Bit27 */
+	ISO_INT_EN_GPHY_HV, /* Bit28 */
+	ISO_INT_EN_GPHY_DV, /* Bit29 */
+	ISO_INT_EN_GPHY_AV, /* Bit30 */
+	ISO_INT_EN_I2C1_REQ, /* Bit31 */
+	}
+};
+
+#endif /* IRQ_RTD13xx_H_ */
diff --git a/drivers/irqchip/irq-rtd16xx.c b/drivers/irqchip/irq-rtd16xx.c
new file mode 100644
index 00000000..88236de
--- /dev/null
+++ b/drivers/irqchip/irq-rtd16xx.c
@@ -0,0 +1,367 @@
+/*
+ * irq-rtd16xx.c - RTK irq mux driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/err.h>
+#include <linux/export.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/syscore_ops.h>
+#include <linux/slab.h>
+#include <linux/irqdomain.h>
+#include <linux/irqchip/chained_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/irqchip.h>
+#include <asm/hardirq.h>
+#include <asm/exception.h>
+#include <asm/irq.h>
+
+#include "irq-rtd16xx.h"
+
+#define DEV_NAME "RTK_IRQ_MUX"
+
+static DEFINE_SPINLOCK(irq_mux_lock);
+
+struct irq_mux_data {
+	void __iomem *base;
+	unsigned char index;
+	unsigned int irq;
+	unsigned int irq_offset;
+	u32 intr_status;
+	u32 intr_en;
+};
+
+static struct irq_domain *rtk_domain;
+
+static void mux_mask_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_st;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_st = mux_data->intr_status;
+
+	__raw_writel(BIT(data->hwirq % IRQ_INMUX), base + reg_st);
+}
+
+static void mux_unmask_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_en;
+	u8 en_offset;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_en = mux_data->intr_en;
+
+	en_offset = irq_map_tab[mux_data->index][data->hwirq % IRQ_INMUX];
+
+	if ((en_offset != MISC_INT_RVD) && (en_offset != MISC_INT_FAIL)) {
+
+		__raw_writel((__raw_readl(base + reg_en) |
+			BIT(en_offset)), base + reg_en);
+
+	} else if (en_offset == MISC_INT_FAIL) {
+		pr_err("[%s] Enable irq(%lu) fail\n", DEV_NAME, data->hwirq);
+	}
+
+}
+
+static void mux_disable_irq(struct irq_data *data)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(data);
+	void __iomem *base;
+	u32 reg_en;
+	u8 en_offset;
+
+	mux_data += (data->hwirq / IRQ_INMUX);
+	base = mux_data->base;
+	reg_en = mux_data->intr_en;
+
+	en_offset = irq_map_tab[mux_data->index][data->hwirq % IRQ_INMUX];
+
+	if ((en_offset != MISC_INT_RVD) && (en_offset != MISC_INT_FAIL)) {
+
+		__raw_writel((__raw_readl(base + reg_en) &
+				~BIT(en_offset)), base + reg_en);
+
+	} else if (en_offset == MISC_INT_FAIL) {
+		pr_err("[%s] Disable irq(%lu) fail\n", DEV_NAME, data->hwirq);
+	}
+
+}
+
+static int mux_set_type(struct irq_data *d, unsigned int type)
+{
+	/*
+	 * TODO: configure ISO/MSIC interrupt type
+	*/
+	return 0;
+}
+
+#ifdef CONFIG_SMP
+static int __maybe_unused mux_set_affinity(struct irq_data *d,
+	const struct cpumask *mask_val,
+	bool force)
+{
+	struct irq_mux_data *mux_data = irq_data_get_irq_chip_data(d);
+	struct irq_chip *chip = irq_get_chip(mux_data->irq);
+	struct irq_data *data = irq_get_irq_data(mux_data->irq);
+
+	if (chip && chip->irq_set_affinity)
+		return chip->irq_set_affinity(data, mask_val, force);
+	else
+		return -EINVAL;
+
+}
+#endif
+
+static struct irq_chip mux_chip = {
+	.name = DEV_NAME,
+	.irq_mask = mux_mask_irq,
+	.irq_unmask = mux_unmask_irq,
+	.irq_disable = mux_disable_irq,
+	.irq_set_type = mux_set_type,
+#ifdef CONFIG_SMP
+	.irq_set_affinity = mux_set_affinity,
+#endif
+};
+
+static void mux_irq_handle(struct irq_desc *desc)
+{
+	struct irq_mux_data *mux_data = irq_desc_get_handler_data(desc);
+	struct irq_chip *chip = irq_desc_get_chip(desc);
+	unsigned int irq = irq_desc_get_irq(desc);
+	unsigned int tmp;
+	int ret;
+	unsigned int mux_irq;
+	static u32 count;
+	u8 en_offset;
+	int i;
+	unsigned int status, check_status;
+	unsigned int enable;
+
+	u32 reg_st = mux_data->intr_status;
+	u32 reg_en = mux_data->intr_en;
+
+	chained_irq_enter(chip, desc);
+
+	spin_lock(&irq_mux_lock);
+	enable = __raw_readl(mux_data->base + reg_en);
+	status = __raw_readl(mux_data->base + reg_st);
+	spin_unlock(&irq_mux_lock);
+
+	for (i = 0 ; i < IRQ_INMUX ; i++) {
+		if (status & BIT(i)) {
+			en_offset = irq_map_tab[mux_data->index][i];
+			mux_irq = mux_data->irq_offset + i;
+
+			if ((en_offset < IRQ_INMUX) &&
+				(enable & BIT(en_offset))) {
+
+				tmp = irq_find_mapping(rtk_domain, mux_irq);
+				ret = generic_handle_irq(tmp);
+
+				if (ret != 0) {
+					pr_err("[%s] irq(%u) desc is not found"
+						"(st:0x%08x en:0x%08x)\n",
+						DEV_NAME,
+						mux_irq,
+						status,
+						enable);
+				}
+			} else if (en_offset == MISC_INT_RVD) {
+
+				tmp = irq_find_mapping(rtk_domain, mux_irq);
+				ret = generic_handle_irq(tmp);
+
+				if (ret != 0) {
+					pr_err("[%s] irq(%u) desc is not found"
+						"(st:0x%08x en:0x%08x)\n",
+						DEV_NAME,
+						mux_irq,
+						status,
+						enable);
+				}
+			} else {
+				pr_err("[%s] irq(%u) should not happen"
+					"(st:0x%08x en:0x%08x)\n",
+					DEV_NAME,
+					mux_irq,
+					status,
+					enable);
+			}
+		}
+	}
+
+	/* as a transmission interface, SPI wont do too much here */
+	if (irq == 1 && status | 0x08000000)
+		goto out;
+
+	spin_lock(&irq_mux_lock);
+	check_status = __raw_readl(mux_data->base + reg_st);
+	spin_unlock(&irq_mux_lock);
+
+	if (check_status == status) {
+		if (count > 1) {
+			pr_err("[%s] (%u) %s irq status is not change"
+				"clear it! (st:0x%08x en:0x%08x)\n",
+				DEV_NAME,
+				irq,
+				mux_data->index ? "ISO" : "MISC",
+				status,
+				enable);
+		} else {
+			count++;
+		}
+
+		spin_lock(&irq_mux_lock);
+		__raw_writel(BIT(__ffs(status)), mux_data->base + reg_st);
+		spin_unlock(&irq_mux_lock);
+
+	} else {
+		count = 0;
+	}
+out:
+	chained_irq_exit(chip, desc);
+}
+
+static int mux_irq_domain_xlate(struct irq_domain *d,
+	struct device_node *controller,
+	const u32 *intspec,
+	unsigned int intsize,
+	unsigned long *out_hwirq,
+	unsigned int *out_type)
+{
+
+	if (controller != irq_domain_get_of_node(d))
+		return -EINVAL;
+
+	if (intsize < 2)
+		return -EINVAL;
+
+	*out_hwirq = intspec[0];
+	*out_type = intspec[1];
+
+	return 0;
+}
+
+static int mux_irq_domain_translate(struct irq_domain *d,
+	struct irq_fwspec *fwspec,
+	unsigned long *hwirq,
+	unsigned int *type)
+{
+	unsigned int virq;
+
+	*hwirq = fwspec->param[0];
+	*type = fwspec->param[1];
+
+	virq = irq_find_mapping(d, fwspec->param[0]);
+	irq_set_irq_type(virq, fwspec->param[1]);
+
+	return 0;
+}
+
+static int mux_irq_domain_map(struct irq_domain *d,
+	unsigned int irq,
+	irq_hw_number_t hw)
+{
+	struct irq_mux_data *data = d->host_data;
+
+	irq_set_chip_and_handler(irq, &mux_chip, handle_level_irq);
+	irq_set_chip_data(irq, data);
+	irq_set_probe(irq);
+
+	return 0;
+}
+
+static const struct irq_domain_ops mux_irq_domain_ops = {
+	.translate = mux_irq_domain_translate,
+	.xlate = mux_irq_domain_xlate,
+	.map = mux_irq_domain_map,
+};
+
+static void __init mux_init_each(struct irq_mux_data *mux_data,
+	void __iomem *base,
+	u32 irq, u32 status,
+	u32 enable, int nr)
+{
+	mux_data->base = base;
+	mux_data->index = nr;
+	mux_data->irq = irq;
+	mux_data->irq_offset = nr * IRQ_INMUX;
+	mux_data->intr_status = status;
+	mux_data->intr_en = enable;
+
+	irq_set_chained_handler_and_data(irq, mux_irq_handle, mux_data);
+}
+
+#ifdef CONFIG_OF
+static int __init mux_of_init(struct device_node *np,
+	struct device_node *parent)
+{
+	int i;
+	u32 nr_irq = 1;
+	struct irq_mux_data *mux_data;
+	void __iomem *base;
+	u32 irq;
+	u32 status, enable;
+
+	if (WARN_ON(!np))
+		return -ENODEV;
+
+	if (of_property_read_u32(np, "Realtek,mux-nr", &nr_irq))
+		pr_err("[%s] can not specified mux number", DEV_NAME);
+
+	mux_data = kcalloc(nr_irq, sizeof(*mux_data), GFP_KERNEL);
+
+	/*
+	 * TODO : tempary define the first irq number
+	 * in this mux is 160, end in 160+64
+	 */
+	rtk_domain = irq_domain_add_simple(np,
+		(nr_irq * IRQ_INMUX),
+		160,
+		&mux_irq_domain_ops,
+		mux_data);
+
+	if (!rtk_domain)
+		pr_warn("[%s] IRQ domain init failed\n", DEV_NAME);
+
+	for (i = 0; i < nr_irq; i++) {
+		base = of_iomap(np, i);
+
+		if (!base)
+			pr_warn("[%s] unable to map IRQ base registers\n",
+				DEV_NAME);
+
+
+		irq = irq_of_parse_and_map(np, i);
+
+		if (!irq)
+			pr_warn("[%s] can not map IRQ\n", DEV_NAME);
+
+		of_property_read_u32_index(np, "intr-status", i, &status);
+		of_property_read_u32_index(np, "intr-en", i, &enable);
+
+		mux_init_each(mux_data, base, irq, status, enable, i);
+
+		mux_data++;
+	}
+
+	return 0;
+}
+
+IRQCHIP_DECLARE(rtk_irq_mux, "Realtek,rtk-irq-mux", mux_of_init);
+#endif
diff --git a/drivers/irqchip/irq-rtd16xx.h b/drivers/irqchip/irq-rtd16xx.h
new file mode 100644
index 00000000..0c0534a
--- /dev/null
+++ b/drivers/irqchip/irq-rtd16xx.h
@@ -0,0 +1,131 @@
+/*
+ * irq-rtd16xx.h - RTK irq mux driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef IRQ_RTD16xx_H_
+#define IRQ_RTD16xx_H_
+
+#define IRQ_INMUX 32
+
+enum misc_int_en {
+	MISC_INT_FAIL = 0xFF,
+	MISC_INT_RVD = 0xFE,
+	MISC_INT_EN_FAN = 29,
+	MISC_INT_EN_SPI = 27,
+	MISC_INT_EN_SC1 = 25,
+	MISC_INT_EN_SC0 = 24,
+	MISC_INT_EN_I2C3 = 28,
+	MISC_INT_EN_I2C4 = 15,
+	MISC_INT_EN_I2C5 = 14,
+	MISC_INT_EN_RTC_DATE = 12,
+	MISC_INT_EN_RTC_HOUR = 11,
+	MISC_INT_EN_RTC_MIN = 10,
+	MISC_INT_EN_UR2 = 7,
+	MISC_INT_EN_UR2_TO = 6,
+	MISC_INT_EN_UR1_TO = 5,
+	MISC_INT_EN_UR1 = 3,
+};
+
+enum iso_int_en {
+	ISO_INT_FAIL = 0xFF,
+	ISO_INT_RVD = 0xFE,
+	ISO_INT_EN_I2C1_REQ = 31,
+	ISO_INT_EN_GPHY_AV = 30,
+	ISO_INT_EN_GPHY_DV = 29,
+	ISO_INT_EN_GPHY_HV = 28,
+	ISO_INT_EN_GPIODA = 20,
+	ISO_INT_EN_GPIOA = 19,
+	ISO_INT_EN_VFD_ARDSWDA = 18,
+	ISO_INT_EN_VFD_ARDSWA = 17,
+	ISO_INT_EN_VFD_ARDKPADDA = 16,
+	ISO_INT_EN_VFD_ARDKPADA = 15,
+	ISO_INT_EN_VFD_WDONE = 14,
+	ISO_INT_EN_RTC_ALARM = 13,
+	ISO_INT_EN_RTC_HSEC = 12,
+	ISO_INT_EN_I2C1 = 11,
+	ISO_INT_EN_I2C0 = 8,
+	ISO_INT_EN_IRDA = 5,
+	ISO_INT_EN_LSADC1 = 4,
+	ISO_INT_EN_LSADC0 = 3,
+	ISO_INT_EN_UR0 = 2,
+};
+
+const unsigned char irq_map_tab[2][IRQ_INMUX] = {
+	{
+	MISC_INT_FAIL, /* Bit0 */
+	MISC_INT_FAIL, /* Bit1 */
+	MISC_INT_RVD, /* Bit2 */
+	MISC_INT_EN_UR1, /* Bit3 */
+	MISC_INT_FAIL, /* Bit4 */
+	MISC_INT_EN_UR1_TO, /* Bit5 */
+	MISC_INT_EN_UR2_TO, /* Bit6 */
+	MISC_INT_EN_UR2, /* Bit7 */
+	MISC_INT_FAIL, /* Bit8 */
+	MISC_INT_FAIL, /* Bit9 */
+	MISC_INT_EN_RTC_MIN, /* Bit10 */
+	MISC_INT_EN_RTC_HOUR, /* Bit11 */
+	MISC_INT_EN_RTC_DATE, /* Bit12 */
+	MISC_INT_FAIL, /* Bit13 */
+	MISC_INT_EN_I2C5, /* Bit14 */
+	MISC_INT_EN_I2C4, /* Bit15 */
+	MISC_INT_FAIL, /* Bit16 */
+	MISC_INT_FAIL, /* Bit17 */
+	MISC_INT_FAIL, /* Bit18 */
+	MISC_INT_FAIL, /* Bit19 */
+	MISC_INT_FAIL, /* Bit20 */
+	MISC_INT_FAIL, /* Bit21 */
+	MISC_INT_FAIL, /* Bit22 */
+	MISC_INT_EN_I2C3, /* Bit23 */
+	MISC_INT_EN_SC0, /* Bit24 */
+	MISC_INT_EN_SC1, /* Bit25 */
+	MISC_INT_FAIL, /* Bit26 */
+	MISC_INT_EN_SPI, /* Bit27 */
+	MISC_INT_FAIL, /* Bit28 */
+	MISC_INT_EN_FAN, /* Bit29 */
+	MISC_INT_FAIL, /* Bit30 */
+	MISC_INT_FAIL, /* Bit31 */
+	},
+	{
+	ISO_INT_FAIL, /* Bit0 */
+	ISO_INT_RVD, /* Bit1 */
+	ISO_INT_EN_UR0,	/* Bit2 */
+	ISO_INT_EN_LSADC0, /* Bit3 */
+	ISO_INT_EN_LSADC1, /* Bit4 */
+	ISO_INT_EN_IRDA, /* Bit5 */
+	ISO_INT_FAIL, /* Bit6 */
+	ISO_INT_RVD, /* Bit7 */
+	ISO_INT_EN_I2C0, /* Bit8 */
+	ISO_INT_RVD, /* Bit9 */
+	ISO_INT_FAIL, /* Bit10 */
+	ISO_INT_EN_I2C1, /* Bit11 */
+	ISO_INT_EN_RTC_HSEC, /* Bit12 */
+	ISO_INT_EN_RTC_ALARM, /* Bit13 */
+	ISO_INT_EN_VFD_WDONE, /* Bit14 */
+	ISO_INT_EN_VFD_ARDKPADA, /* Bit15 */
+	ISO_INT_EN_VFD_ARDKPADDA, /* Bit16 */
+	ISO_INT_EN_VFD_ARDSWA, /* Bit17 */
+	ISO_INT_EN_VFD_ARDSWDA, /* Bit18 */
+	ISO_INT_EN_GPIOA, /* Bit19 */
+	ISO_INT_EN_GPIODA, /* Bit20 */
+	ISO_INT_RVD, /* Bit21 */
+	ISO_INT_RVD, /* Bit22 */
+	ISO_INT_RVD, /* Bit23 */
+	ISO_INT_RVD, /* Bit24 */
+	ISO_INT_FAIL, /* Bit25 */
+	ISO_INT_FAIL, /* Bit26 */
+	ISO_INT_FAIL, /* Bit27 */
+	ISO_INT_EN_GPHY_HV, /* Bit28 */
+	ISO_INT_EN_GPHY_DV, /* Bit29 */
+	ISO_INT_EN_GPHY_AV, /* Bit30 */
+	ISO_INT_EN_I2C1_REQ, /* Bit31 */
+	}
+};
+
+#endif /* IRQ_RTD16xx_H_ */
diff --git a/drivers/isdn/hardware/mISDN/avmfritz.c b/drivers/isdn/hardware/mISDN/avmfritz.c
index e3fa1cd..a57b04f 100644
--- a/drivers/isdn/hardware/mISDN/avmfritz.c
+++ b/drivers/isdn/hardware/mISDN/avmfritz.c
@@ -156,7 +156,7 @@ struct fritzcard {
 }
 
 static int
-set_debug(const char *val, struct kernel_param *kp)
+set_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret;
 	struct fritzcard *card;
diff --git a/drivers/isdn/hardware/mISDN/mISDNinfineon.c b/drivers/isdn/hardware/mISDN/mISDNinfineon.c
index d5bdbaf..1fc2906 100644
--- a/drivers/isdn/hardware/mISDN/mISDNinfineon.c
+++ b/drivers/isdn/hardware/mISDN/mISDNinfineon.c
@@ -244,7 +244,7 @@ struct inf_hw {
 }
 
 static int
-set_debug(const char *val, struct kernel_param *kp)
+set_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret;
 	struct inf_hw *card;
diff --git a/drivers/isdn/hardware/mISDN/netjet.c b/drivers/isdn/hardware/mISDN/netjet.c
index afde4ed..e9fcae4 100644
--- a/drivers/isdn/hardware/mISDN/netjet.c
+++ b/drivers/isdn/hardware/mISDN/netjet.c
@@ -111,7 +111,7 @@ struct tiger_hw {
 }
 
 static int
-set_debug(const char *val, struct kernel_param *kp)
+set_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret;
 	struct tiger_hw *card;
diff --git a/drivers/isdn/hardware/mISDN/speedfax.c b/drivers/isdn/hardware/mISDN/speedfax.c
index 9815bb4..1f1446e 100644
--- a/drivers/isdn/hardware/mISDN/speedfax.c
+++ b/drivers/isdn/hardware/mISDN/speedfax.c
@@ -94,7 +94,7 @@ struct sfax_hw {
 }
 
 static int
-set_debug(const char *val, struct kernel_param *kp)
+set_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret;
 	struct sfax_hw *card;
diff --git a/drivers/isdn/hardware/mISDN/w6692.c b/drivers/isdn/hardware/mISDN/w6692.c
index 3b067ea..0db6783 100644
--- a/drivers/isdn/hardware/mISDN/w6692.c
+++ b/drivers/isdn/hardware/mISDN/w6692.c
@@ -101,7 +101,7 @@ struct w6692_hw {
 }
 
 static int
-set_debug(const char *val, struct kernel_param *kp)
+set_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret;
 	struct w6692_hw *card;
diff --git a/drivers/md/Kconfig b/drivers/md/Kconfig
index 197e29d..c786f6b 100644
--- a/drivers/md/Kconfig
+++ b/drivers/md/Kconfig
@@ -459,6 +459,21 @@ config DM_VERITY
 
 	  If unsure, say N.
 
+config DM_VERITY_HASH_PREFETCH_MIN_SIZE_128
+	bool "Prefetch size 128"
+
+config DM_VERITY_HASH_PREFETCH_MIN_SIZE
+	int "Verity hash prefetch minimum size"
+	depends on DM_VERITY
+	range 1 4096
+	default 128 if DM_VERITY_HASH_PREFETCH_MIN_SIZE_128
+	default 1
+	---help---
+	  This sets minimum number of hash blocks to prefetch for dm-verity.
+	  For devices like eMMC, having larger prefetch size like 128 can improve
+	  performance with increased memory consumption for keeping more hashes
+	  in RAM.
+
 config DM_VERITY_FEC
 	bool "Verity forward error correction support"
 	depends on DM_VERITY
@@ -501,4 +516,42 @@ config DM_LOG_WRITES
 
 	  If unsure, say N.
 
+config DM_ANDROID_VERITY
+	bool "Android verity target support"
+	depends on BLK_DEV_DM=y
+	depends on DM_VERITY=y
+	depends on X509_CERTIFICATE_PARSER
+	depends on SYSTEM_TRUSTED_KEYRING
+	depends on CRYPTO_RSA
+	depends on KEYS
+	depends on ASYMMETRIC_KEY_TYPE
+	depends on ASYMMETRIC_PUBLIC_KEY_SUBTYPE
+	select DM_VERITY_HASH_PREFETCH_MIN_SIZE_128
+	---help---
+	  This device-mapper target is virtually a VERITY target. This
+	  target is setup by reading the metadata contents piggybacked
+	  to the actual data blocks in the block device. The signature
+	  of the metadata contents are verified against the key included
+	  in the system keyring. Upon success, the underlying verity
+	  target is setup.
+
+config DM_ANDROID_VERITY_AT_MOST_ONCE_DEFAULT_ENABLED
+	bool "Verity will validate blocks at most once"
+	depends on DM_VERITY
+	---help---
+	  Default enables at_most_once option for dm-verity
+
+	  Verify data blocks only the first time they are read from the
+	  data device, rather than every time.  This reduces the overhead
+	  of dm-verity so that it can be used on systems that are memory
+	  and/or CPU constrained.  However, it provides a reduced level
+	  of security because only offline tampering of the data device's
+	  content will be detected, not online tampering.
+
+	  Hash blocks are still verified each time they are read from the
+	  hash device, since verification of hash blocks is less performance
+	  critical than data blocks, and a hash block will not be verified
+	  any more after all the data blocks it covers have been verified anyway.
+
+	  If unsure, say N.
 endif # MD
diff --git a/drivers/md/Makefile b/drivers/md/Makefile
index 3cbda1a..f26ce41 100644
--- a/drivers/md/Makefile
+++ b/drivers/md/Makefile
@@ -59,6 +59,7 @@ obj-$(CONFIG_DM_CACHE_SMQ)	+= dm-cache-smq.o
 obj-$(CONFIG_DM_CACHE_CLEANER)	+= dm-cache-cleaner.o
 obj-$(CONFIG_DM_ERA)		+= dm-era.o
 obj-$(CONFIG_DM_LOG_WRITES)	+= dm-log-writes.o
+obj-$(CONFIG_DM_ANDROID_VERITY) += dm-android-verity.o
 
 ifeq ($(CONFIG_DM_UEVENT),y)
 dm-mod-objs			+= dm-uevent.o
diff --git a/drivers/md/dm-android-verity.c b/drivers/md/dm-android-verity.c
new file mode 100644
index 00000000..f9491de
--- /dev/null
+++ b/drivers/md/dm-android-verity.c
@@ -0,0 +1,923 @@
+/*
+ * Copyright (C) 2015 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/buffer_head.h>
+#include <linux/debugfs.h>
+#include <linux/delay.h>
+#include <linux/device.h>
+#include <linux/device-mapper.h>
+#include <linux/errno.h>
+#include <linux/fs.h>
+#include <linux/fcntl.h>
+#include <linux/init.h>
+#include <linux/kernel.h>
+#include <linux/key.h>
+#include <linux/module.h>
+#include <linux/mount.h>
+#include <linux/namei.h>
+#include <linux/of.h>
+#include <linux/reboot.h>
+#include <linux/string.h>
+#include <linux/vmalloc.h>
+
+#include <asm/setup.h>
+#include <crypto/hash.h>
+#include <crypto/hash_info.h>
+#include <crypto/public_key.h>
+#include <crypto/sha.h>
+#include <keys/asymmetric-type.h>
+#include <keys/system_keyring.h>
+
+#include "dm-verity.h"
+#include "dm-android-verity.h"
+
+static char verifiedbootstate[VERITY_COMMANDLINE_PARAM_LENGTH];
+static char veritymode[VERITY_COMMANDLINE_PARAM_LENGTH];
+static char veritykeyid[VERITY_DEFAULT_KEY_ID_LENGTH];
+static char buildvariant[BUILD_VARIANT];
+
+static bool target_added;
+static bool verity_enabled = true;
+struct dentry *debug_dir;
+static int android_verity_ctr(struct dm_target *ti, unsigned argc, char **argv);
+
+static struct target_type android_verity_target = {
+	.name                   = "android-verity",
+	.version                = {1, 0, 0},
+	.module                 = THIS_MODULE,
+	.ctr                    = android_verity_ctr,
+	.dtr                    = verity_dtr,
+	.map                    = verity_map,
+	.status                 = verity_status,
+	.prepare_ioctl          = verity_prepare_ioctl,
+	.iterate_devices        = verity_iterate_devices,
+	.io_hints               = verity_io_hints,
+};
+
+static int __init verified_boot_state_param(char *line)
+{
+	strlcpy(verifiedbootstate, line, sizeof(verifiedbootstate));
+	return 1;
+}
+
+__setup("androidboot.verifiedbootstate=", verified_boot_state_param);
+
+static int __init verity_mode_param(char *line)
+{
+	strlcpy(veritymode, line, sizeof(veritymode));
+	return 1;
+}
+
+__setup("androidboot.veritymode=", verity_mode_param);
+
+static int __init verity_keyid_param(char *line)
+{
+	strlcpy(veritykeyid, line, sizeof(veritykeyid));
+	return 1;
+}
+
+__setup("veritykeyid=", verity_keyid_param);
+
+static int __init verity_buildvariant(char *line)
+{
+	strlcpy(buildvariant, line, sizeof(buildvariant));
+	return 1;
+}
+
+__setup("buildvariant=", verity_buildvariant);
+
+static inline bool default_verity_key_id(void)
+{
+	return veritykeyid[0] != '\0';
+}
+
+static inline bool is_eng(void)
+{
+	static const char typeeng[]  = "eng";
+
+	return !strncmp(buildvariant, typeeng, sizeof(typeeng));
+}
+
+static inline bool is_userdebug(void)
+{
+	static const char typeuserdebug[]  = "userdebug";
+
+	return !strncmp(buildvariant, typeuserdebug, sizeof(typeuserdebug));
+}
+
+static inline bool is_unlocked(void)
+{
+	static const char unlocked[] = "orange";
+
+	return !strncmp(verifiedbootstate, unlocked, sizeof(unlocked));
+}
+
+static int read_block_dev(struct bio_read *payload, struct block_device *bdev,
+		sector_t offset, int length)
+{
+	struct bio *bio;
+	int err = 0, i;
+
+	payload->number_of_pages = DIV_ROUND_UP(length, PAGE_SIZE);
+
+	bio = bio_alloc(GFP_KERNEL, payload->number_of_pages);
+	if (!bio) {
+		DMERR("Error while allocating bio");
+		return -ENOMEM;
+	}
+
+	bio->bi_bdev = bdev;
+	bio->bi_iter.bi_sector = offset;
+	bio_set_op_attrs(bio, REQ_OP_READ, READ_SYNC);
+
+	payload->page_io = kzalloc(sizeof(struct page *) *
+		payload->number_of_pages, GFP_KERNEL);
+	if (!payload->page_io) {
+		DMERR("page_io array alloc failed");
+		err = -ENOMEM;
+		goto free_bio;
+	}
+
+	for (i = 0; i < payload->number_of_pages; i++) {
+		payload->page_io[i] = alloc_page(GFP_KERNEL);
+		if (!payload->page_io[i]) {
+			DMERR("alloc_page failed");
+			err = -ENOMEM;
+			goto free_pages;
+		}
+		if (!bio_add_page(bio, payload->page_io[i], PAGE_SIZE, 0)) {
+			DMERR("bio_add_page error");
+			err = -EIO;
+			goto free_pages;
+		}
+	}
+
+	if (!submit_bio_wait(bio))
+		/* success */
+		goto free_bio;
+	DMERR("bio read failed");
+	err = -EIO;
+
+free_pages:
+	for (i = 0; i < payload->number_of_pages; i++)
+		if (payload->page_io[i])
+			__free_page(payload->page_io[i]);
+	kfree(payload->page_io);
+free_bio:
+	bio_put(bio);
+	return err;
+}
+
+static inline u64 fec_div_round_up(u64 x, u64 y)
+{
+	u64 remainder;
+
+	return div64_u64_rem(x, y, &remainder) +
+		(remainder > 0 ? 1 : 0);
+}
+
+static inline void populate_fec_metadata(struct fec_header *header,
+				struct fec_ecc_metadata *ecc)
+{
+	ecc->blocks = fec_div_round_up(le64_to_cpu(header->inp_size),
+			FEC_BLOCK_SIZE);
+	ecc->roots = le32_to_cpu(header->roots);
+	ecc->start = le64_to_cpu(header->inp_size);
+}
+
+static inline int validate_fec_header(struct fec_header *header, u64 offset)
+{
+	/* move offset to make the sanity check work for backup header
+	 * as well. */
+	offset -= offset % FEC_BLOCK_SIZE;
+	if (le32_to_cpu(header->magic) != FEC_MAGIC ||
+		le32_to_cpu(header->version) != FEC_VERSION ||
+		le32_to_cpu(header->size) != sizeof(struct fec_header) ||
+		le32_to_cpu(header->roots) == 0 ||
+		le32_to_cpu(header->roots) >= FEC_RSM)
+		return -EINVAL;
+
+	return 0;
+}
+
+static int extract_fec_header(dev_t dev, struct fec_header *fec,
+				struct fec_ecc_metadata *ecc)
+{
+	u64 device_size;
+	struct bio_read payload;
+	int i, err = 0;
+	struct block_device *bdev;
+
+	bdev = blkdev_get_by_dev(dev, FMODE_READ, NULL);
+
+	if (IS_ERR_OR_NULL(bdev)) {
+		DMERR("bdev get error");
+		return PTR_ERR(bdev);
+	}
+
+	device_size = i_size_read(bdev->bd_inode);
+
+	/* fec metadata size is a power of 2 and PAGE_SIZE
+	 * is a power of 2 as well.
+	 */
+	BUG_ON(FEC_BLOCK_SIZE > PAGE_SIZE);
+	/* 512 byte sector alignment */
+	BUG_ON(((device_size - FEC_BLOCK_SIZE) % (1 << SECTOR_SHIFT)) != 0);
+
+	err = read_block_dev(&payload, bdev, (device_size -
+		FEC_BLOCK_SIZE) / (1 << SECTOR_SHIFT), FEC_BLOCK_SIZE);
+	if (err) {
+		DMERR("Error while reading verity metadata");
+		goto error;
+	}
+
+	BUG_ON(sizeof(struct fec_header) > PAGE_SIZE);
+	memcpy(fec, page_address(payload.page_io[0]),
+			sizeof(*fec));
+
+	ecc->valid = true;
+	if (validate_fec_header(fec, device_size - FEC_BLOCK_SIZE)) {
+		/* Try the backup header */
+		memcpy(fec, page_address(payload.page_io[0]) + FEC_BLOCK_SIZE
+			- sizeof(*fec) ,
+			sizeof(*fec));
+		if (validate_fec_header(fec, device_size -
+			sizeof(struct fec_header)))
+			ecc->valid = false;
+	}
+
+	if (ecc->valid)
+		populate_fec_metadata(fec, ecc);
+
+	for (i = 0; i < payload.number_of_pages; i++)
+		__free_page(payload.page_io[i]);
+	kfree(payload.page_io);
+
+error:
+	blkdev_put(bdev, FMODE_READ);
+	return err;
+}
+static void find_metadata_offset(struct fec_header *fec,
+		struct block_device *bdev, u64 *metadata_offset)
+{
+	u64 device_size;
+
+	device_size = i_size_read(bdev->bd_inode);
+
+	if (le32_to_cpu(fec->magic) == FEC_MAGIC)
+		*metadata_offset = le64_to_cpu(fec->inp_size) -
+					VERITY_METADATA_SIZE;
+	else
+		*metadata_offset = device_size - VERITY_METADATA_SIZE;
+}
+
+static int find_size(dev_t dev, u64 *device_size)
+{
+	struct block_device *bdev;
+
+	bdev = blkdev_get_by_dev(dev, FMODE_READ, NULL);
+	if (IS_ERR_OR_NULL(bdev)) {
+		DMERR("blkdev_get_by_dev failed");
+		return PTR_ERR(bdev);
+	}
+
+	*device_size = i_size_read(bdev->bd_inode);
+	*device_size >>= SECTOR_SHIFT;
+
+	DMINFO("blkdev size in sectors: %llu", *device_size);
+	blkdev_put(bdev, FMODE_READ);
+	return 0;
+}
+
+static int verify_header(struct android_metadata_header *header)
+{
+	int retval = -EINVAL;
+
+	if (is_userdebug() && le32_to_cpu(header->magic_number) ==
+			VERITY_METADATA_MAGIC_DISABLE)
+		return VERITY_STATE_DISABLE;
+
+	if (!(le32_to_cpu(header->magic_number) ==
+			VERITY_METADATA_MAGIC_NUMBER) ||
+			(le32_to_cpu(header->magic_number) ==
+			VERITY_METADATA_MAGIC_DISABLE)) {
+		DMERR("Incorrect magic number");
+		return retval;
+	}
+
+	if (le32_to_cpu(header->protocol_version) !=
+			VERITY_METADATA_VERSION) {
+		DMERR("Unsupported version %u",
+			le32_to_cpu(header->protocol_version));
+		return retval;
+	}
+
+	return 0;
+}
+
+static int extract_metadata(dev_t dev, struct fec_header *fec,
+				struct android_metadata **metadata,
+				bool *verity_enabled)
+{
+	struct block_device *bdev;
+	struct android_metadata_header *header;
+	int i;
+	u32 table_length, copy_length, offset;
+	u64 metadata_offset;
+	struct bio_read payload;
+	int err = 0;
+
+	bdev = blkdev_get_by_dev(dev, FMODE_READ, NULL);
+
+	if (IS_ERR_OR_NULL(bdev)) {
+		DMERR("blkdev_get_by_dev failed");
+		return -ENODEV;
+	}
+
+	find_metadata_offset(fec, bdev, &metadata_offset);
+
+	/* Verity metadata size is a power of 2 and PAGE_SIZE
+	 * is a power of 2 as well.
+	 * PAGE_SIZE is also a multiple of 512 bytes.
+	*/
+	if (VERITY_METADATA_SIZE > PAGE_SIZE)
+		BUG_ON(VERITY_METADATA_SIZE % PAGE_SIZE != 0);
+	/* 512 byte sector alignment */
+	BUG_ON(metadata_offset % (1 << SECTOR_SHIFT) != 0);
+
+	err = read_block_dev(&payload, bdev, metadata_offset /
+		(1 << SECTOR_SHIFT), VERITY_METADATA_SIZE);
+	if (err) {
+		DMERR("Error while reading verity metadata");
+		goto blkdev_release;
+	}
+
+	header = kzalloc(sizeof(*header), GFP_KERNEL);
+	if (!header) {
+		DMERR("kzalloc failed for header");
+		err = -ENOMEM;
+		goto free_payload;
+	}
+
+	memcpy(header, page_address(payload.page_io[0]),
+		sizeof(*header));
+
+	DMINFO("bio magic_number:%u protocol_version:%d table_length:%u",
+		le32_to_cpu(header->magic_number),
+		le32_to_cpu(header->protocol_version),
+		le32_to_cpu(header->table_length));
+
+	err = verify_header(header);
+
+	if (err == VERITY_STATE_DISABLE) {
+		DMERR("Mounting root with verity disabled");
+		*verity_enabled = false;
+		/* we would still have to read the metadata to figure out
+		 * the data blocks size. Or may be could map the entire
+		 * partition similar to mounting the device.
+		 *
+		 * Reset error as well as the verity_enabled flag is changed.
+		 */
+		err = 0;
+	} else if (err)
+		goto free_header;
+
+	*metadata = kzalloc(sizeof(**metadata), GFP_KERNEL);
+	if (!*metadata) {
+		DMERR("kzalloc for metadata failed");
+		err = -ENOMEM;
+		goto free_header;
+	}
+
+	(*metadata)->header = header;
+	table_length = le32_to_cpu(header->table_length);
+
+	if (table_length == 0 ||
+		table_length > (VERITY_METADATA_SIZE -
+			sizeof(struct android_metadata_header))) {
+		DMERR("table_length too long");
+		err = -EINVAL;
+		goto free_metadata;
+	}
+
+	(*metadata)->verity_table = kzalloc(table_length + 1, GFP_KERNEL);
+
+	if (!(*metadata)->verity_table) {
+		DMERR("kzalloc verity_table failed");
+		err = -ENOMEM;
+		goto free_metadata;
+	}
+
+	if (sizeof(struct android_metadata_header) +
+			table_length <= PAGE_SIZE) {
+		memcpy((*metadata)->verity_table,
+			page_address(payload.page_io[0])
+			+ sizeof(struct android_metadata_header),
+			table_length);
+	} else {
+		copy_length = PAGE_SIZE -
+			sizeof(struct android_metadata_header);
+		memcpy((*metadata)->verity_table,
+			page_address(payload.page_io[0])
+			+ sizeof(struct android_metadata_header),
+			copy_length);
+		table_length -= copy_length;
+		offset = copy_length;
+		i = 1;
+		while (table_length != 0) {
+			if (table_length > PAGE_SIZE) {
+				memcpy((*metadata)->verity_table + offset,
+					page_address(payload.page_io[i]),
+					PAGE_SIZE);
+				offset += PAGE_SIZE;
+				table_length -= PAGE_SIZE;
+			} else {
+				memcpy((*metadata)->verity_table + offset,
+					page_address(payload.page_io[i]),
+					table_length);
+				table_length = 0;
+			}
+			i++;
+		}
+	}
+	(*metadata)->verity_table[table_length] = '\0';
+
+	DMINFO("verity_table: %s", (*metadata)->verity_table);
+	goto free_payload;
+
+free_metadata:
+	kfree(*metadata);
+free_header:
+	kfree(header);
+free_payload:
+	for (i = 0; i < payload.number_of_pages; i++)
+		if (payload.page_io[i])
+			__free_page(payload.page_io[i]);
+	kfree(payload.page_io);
+blkdev_release:
+	blkdev_put(bdev, FMODE_READ);
+	return err;
+}
+
+/* helper functions to extract properties from dts */
+const char *find_dt_value(const char *name)
+{
+	struct device_node *firmware;
+	const char *value;
+
+	firmware = of_find_node_by_path("/firmware/android");
+	if (!firmware)
+		return NULL;
+	value = of_get_property(firmware, name, NULL);
+	of_node_put(firmware);
+
+	return value;
+}
+
+static int verity_mode(void)
+{
+	static const char enforcing[] = "enforcing";
+	static const char verified_mode_prop[] = "veritymode";
+	const char *value;
+
+	value = find_dt_value(verified_mode_prop);
+	if (!value)
+		value = veritymode;
+	if (!strncmp(value, enforcing, sizeof(enforcing) - 1))
+		return DM_VERITY_MODE_RESTART;
+
+	return DM_VERITY_MODE_EIO;
+}
+
+static void handle_error(void)
+{
+	int mode = verity_mode();
+	if (mode == DM_VERITY_MODE_RESTART) {
+		DMERR("triggering restart");
+		kernel_restart("dm-verity device corrupted");
+	} else {
+		DMERR("Mounting verity root failed");
+	}
+}
+
+static struct public_key_signature *table_make_digest(
+						enum hash_algo hash,
+						const void *table,
+						unsigned long table_len)
+{
+	struct public_key_signature *pks = NULL;
+	struct crypto_shash *tfm;
+	struct shash_desc *desc;
+	size_t digest_size, desc_size;
+	int ret;
+
+	/* Allocate the hashing algorithm we're going to need and find out how
+	 * big the hash operational data will be.
+	 */
+	tfm = crypto_alloc_shash(hash_algo_name[hash], 0, 0);
+	if (IS_ERR(tfm))
+		return ERR_CAST(tfm);
+
+	desc_size = crypto_shash_descsize(tfm) + sizeof(*desc);
+	digest_size = crypto_shash_digestsize(tfm);
+
+	/* We allocate the hash operational data storage on the end of out
+	 * context data and the digest output buffer on the end of that.
+	 */
+	ret = -ENOMEM;
+	pks = kzalloc(digest_size + sizeof(*pks) + desc_size, GFP_KERNEL);
+	if (!pks)
+		goto error;
+
+	pks->pkey_algo = "rsa";
+	pks->hash_algo = hash_algo_name[hash];
+	pks->digest = (u8 *)pks + sizeof(*pks) + desc_size;
+	pks->digest_size = digest_size;
+
+	desc = (struct shash_desc *)(pks + 1);
+	desc->tfm = tfm;
+	desc->flags = CRYPTO_TFM_REQ_MAY_SLEEP;
+
+	ret = crypto_shash_init(desc);
+	if (ret < 0)
+		goto error;
+
+	ret = crypto_shash_finup(desc, table, table_len, pks->digest);
+	if (ret < 0)
+		goto error;
+
+	crypto_free_shash(tfm);
+	return pks;
+
+error:
+	kfree(pks);
+	crypto_free_shash(tfm);
+	return ERR_PTR(ret);
+}
+
+
+static int verify_verity_signature(char *key_id,
+		struct android_metadata *metadata)
+{
+	struct public_key_signature *pks = NULL;
+	int retval = -EINVAL;
+
+	if (!key_id)
+		goto error;
+
+	pks = table_make_digest(HASH_ALGO_SHA256,
+			(const void *)metadata->verity_table,
+			le32_to_cpu(metadata->header->table_length));
+	if (IS_ERR(pks)) {
+		DMERR("hashing failed");
+		retval = PTR_ERR(pks);
+		pks = NULL;
+		goto error;
+	}
+
+	pks->s = kmemdup(&metadata->header->signature[0], RSANUMBYTES, GFP_KERNEL);
+	if (!pks->s) {
+		DMERR("Error allocating memory for signature");
+		goto error;
+	}
+	pks->s_size = RSANUMBYTES;
+
+	retval = verify_signature_one(pks, NULL, key_id);
+	kfree(pks->s);
+error:
+	kfree(pks);
+	return retval;
+}
+
+static inline bool test_mult_overflow(sector_t a, u32 b)
+{
+	sector_t r = (sector_t)~0ULL;
+
+	sector_div(r, b);
+	return a > r;
+}
+
+static int add_as_linear_device(struct dm_target *ti, char *dev)
+{
+	/*Move to linear mapping defines*/
+	char *linear_table_args[DM_LINEAR_ARGS] = {dev,
+					DM_LINEAR_TARGET_OFFSET};
+	int err = 0;
+
+	android_verity_target.dtr = dm_linear_dtr,
+	android_verity_target.map = dm_linear_map,
+	android_verity_target.status = dm_linear_status,
+	android_verity_target.prepare_ioctl = dm_linear_prepare_ioctl,
+	android_verity_target.iterate_devices = dm_linear_iterate_devices,
+        android_verity_target.direct_access = dm_linear_direct_access,
+	android_verity_target.io_hints = NULL;
+
+	set_disk_ro(dm_disk(dm_table_get_md(ti->table)), 0);
+
+	err = dm_linear_ctr(ti, DM_LINEAR_ARGS, linear_table_args);
+
+	if (!err) {
+		DMINFO("Added android-verity as a linear target");
+		target_added = true;
+	} else
+		DMERR("Failed to add android-verity as linear target");
+
+	return err;
+}
+
+static int create_linear_device(struct dm_target *ti, dev_t dev,
+				char *target_device)
+{
+	u64 device_size = 0;
+	int err = find_size(dev, &device_size);
+
+	if (err) {
+		DMERR("error finding bdev size");
+		handle_error();
+		return err;
+	}
+
+	ti->len = device_size;
+	err = add_as_linear_device(ti, target_device);
+	if (err) {
+		handle_error();
+		return err;
+	}
+	verity_enabled = false;
+	return 0;
+}
+
+/*
+ * Target parameters:
+ *	<key id>	Key id of the public key in the system keyring.
+ *			Verity metadata's signature would be verified against
+ *			this. If the key id contains spaces, replace them
+ *			with '#'.
+ *	<block device>	The block device for which dm-verity is being setup.
+ */
+static int android_verity_ctr(struct dm_target *ti, unsigned argc, char **argv)
+{
+	dev_t uninitialized_var(dev);
+	struct android_metadata *metadata = NULL;
+	int err = 0, i, mode;
+	char *key_id = NULL, *table_ptr, dummy, *target_device;
+	char *verity_table_args[VERITY_TABLE_ARGS + 2 + VERITY_TABLE_OPT_FEC_ARGS];
+	/* One for specifying number of opt args and one for mode */
+	sector_t data_sectors;
+	u32 data_block_size;
+	unsigned int no_of_args = VERITY_TABLE_ARGS + 2 + VERITY_TABLE_OPT_FEC_ARGS;
+	struct fec_header uninitialized_var(fec);
+	struct fec_ecc_metadata uninitialized_var(ecc);
+	char buf[FEC_ARG_LENGTH], *buf_ptr;
+	unsigned long long tmpll;
+
+	if (argc == 1) {
+		/* Use the default keyid */
+		if (default_verity_key_id())
+			key_id = veritykeyid;
+		else if (!is_eng()) {
+			DMERR("veritykeyid= is not set");
+			handle_error();
+			return -EINVAL;
+		}
+		target_device = argv[0];
+	} else if (argc == 2) {
+		key_id = argv[0];
+		target_device = argv[1];
+	} else {
+		DMERR("Incorrect number of arguments");
+		handle_error();
+		return -EINVAL;
+	}
+
+	dev = name_to_dev_t(target_device);
+	if (!dev) {
+		DMERR("no dev found for %s", target_device);
+		handle_error();
+		return -EINVAL;
+	}
+
+	if (is_eng())
+		return create_linear_device(ti, dev, target_device);
+
+	strreplace(key_id, '#', ' ');
+
+	DMINFO("key:%s dev:%s", key_id, target_device);
+
+	if (extract_fec_header(dev, &fec, &ecc)) {
+		DMERR("Error while extracting fec header");
+		handle_error();
+		return -EINVAL;
+	}
+
+	err = extract_metadata(dev, &fec, &metadata, &verity_enabled);
+
+	if (err) {
+		/* Allow invalid metadata when the device is unlocked */
+		if (is_unlocked()) {
+			DMWARN("Allow invalid metadata when unlocked");
+			return create_linear_device(ti, dev, target_device);
+		}
+		DMERR("Error while extracting metadata");
+		handle_error();
+		goto free_metadata;
+	}
+
+	if (verity_enabled) {
+		err = verify_verity_signature(key_id, metadata);
+
+		if (err) {
+			DMERR("Signature verification failed");
+			handle_error();
+			goto free_metadata;
+		} else
+			DMINFO("Signature verification success");
+	}
+
+	table_ptr = metadata->verity_table;
+
+	for (i = 0; i < VERITY_TABLE_ARGS; i++) {
+		verity_table_args[i] = strsep(&table_ptr, " ");
+		if (verity_table_args[i] == NULL)
+			break;
+	}
+
+	if (i != VERITY_TABLE_ARGS) {
+		DMERR("Verity table not in the expected format");
+		err = -EINVAL;
+		handle_error();
+		goto free_metadata;
+	}
+
+	if (sscanf(verity_table_args[5], "%llu%c", &tmpll, &dummy)
+							!= 1) {
+		DMERR("Verity table not in the expected format");
+		handle_error();
+		err = -EINVAL;
+		goto free_metadata;
+	}
+
+	if (tmpll > ULONG_MAX) {
+		DMERR("<num_data_blocks> too large. Forgot to turn on CONFIG_LBDAF?");
+		handle_error();
+		err = -EINVAL;
+		goto free_metadata;
+	}
+
+	data_sectors = tmpll;
+
+	if (sscanf(verity_table_args[3], "%u%c", &data_block_size, &dummy)
+								!= 1) {
+		DMERR("Verity table not in the expected format");
+		handle_error();
+		err = -EINVAL;
+		goto free_metadata;
+	}
+
+	if (test_mult_overflow(data_sectors, data_block_size >>
+							SECTOR_SHIFT)) {
+		DMERR("data_sectors too large");
+		handle_error();
+		err = -EOVERFLOW;
+		goto free_metadata;
+	}
+
+	data_sectors *= data_block_size >> SECTOR_SHIFT;
+	DMINFO("Data sectors %llu", (unsigned long long)data_sectors);
+
+	/* update target length */
+	ti->len = data_sectors;
+
+	/* Setup linear target and free */
+	if (!verity_enabled) {
+		err = add_as_linear_device(ti, target_device);
+		goto free_metadata;
+	}
+
+	/*substitute data_dev and hash_dev*/
+	verity_table_args[1] = target_device;
+	verity_table_args[2] = target_device;
+
+	mode = verity_mode();
+
+	if (ecc.valid && IS_BUILTIN(CONFIG_DM_VERITY_FEC)) {
+		if (mode) {
+			err = snprintf(buf, FEC_ARG_LENGTH,
+				"%u %s " VERITY_TABLE_OPT_FEC_FORMAT,
+				1 + VERITY_TABLE_OPT_FEC_ARGS,
+				mode == DM_VERITY_MODE_RESTART ?
+					VERITY_TABLE_OPT_RESTART :
+					VERITY_TABLE_OPT_LOGGING,
+				target_device,
+				ecc.start / FEC_BLOCK_SIZE, ecc.blocks,
+				ecc.roots);
+		} else {
+			err = snprintf(buf, FEC_ARG_LENGTH,
+				"%u " VERITY_TABLE_OPT_FEC_FORMAT,
+				VERITY_TABLE_OPT_FEC_ARGS, target_device,
+				ecc.start / FEC_BLOCK_SIZE, ecc.blocks,
+				ecc.roots);
+		}
+	} else if (mode) {
+		err = snprintf(buf, FEC_ARG_LENGTH,
+			"2 " VERITY_TABLE_OPT_IGNZERO " %s",
+			mode == DM_VERITY_MODE_RESTART ?
+			VERITY_TABLE_OPT_RESTART : VERITY_TABLE_OPT_LOGGING);
+	} else {
+		err = snprintf(buf, FEC_ARG_LENGTH, "1 %s",
+				 "ignore_zero_blocks");
+	}
+
+	if (err < 0 || err >= FEC_ARG_LENGTH)
+		goto free_metadata;
+
+	buf_ptr = buf;
+
+	for (i = VERITY_TABLE_ARGS; i < (VERITY_TABLE_ARGS +
+		VERITY_TABLE_OPT_FEC_ARGS + 2); i++) {
+		verity_table_args[i] = strsep(&buf_ptr, " ");
+		if (verity_table_args[i] == NULL) {
+			no_of_args = i;
+			break;
+		}
+	}
+
+	err = verity_ctr(ti, no_of_args, verity_table_args);
+	if (err) {
+		DMERR("android-verity failed to create a verity target");
+	} else {
+		target_added = true;
+		DMINFO("android-verity created as verity target");
+	}
+
+free_metadata:
+	if (metadata) {
+		kfree(metadata->header);
+		kfree(metadata->verity_table);
+	}
+	kfree(metadata);
+	return err;
+}
+
+static int __init dm_android_verity_init(void)
+{
+	int r;
+	struct dentry *file;
+
+	r = dm_register_target(&android_verity_target);
+	if (r < 0)
+		DMERR("register failed %d", r);
+
+	/* Tracks the status of the last added target */
+	debug_dir = debugfs_create_dir("android_verity", NULL);
+
+	if (IS_ERR_OR_NULL(debug_dir)) {
+		DMERR("Cannot create android_verity debugfs directory: %ld",
+			PTR_ERR(debug_dir));
+		goto end;
+	}
+
+	file = debugfs_create_bool("target_added", S_IRUGO, debug_dir,
+				&target_added);
+
+	if (IS_ERR_OR_NULL(file)) {
+		DMERR("Cannot create android_verity debugfs directory: %ld",
+			PTR_ERR(debug_dir));
+		debugfs_remove_recursive(debug_dir);
+		goto end;
+	}
+
+	file = debugfs_create_bool("verity_enabled", S_IRUGO, debug_dir,
+				&verity_enabled);
+
+	if (IS_ERR_OR_NULL(file)) {
+		DMERR("Cannot create android_verity debugfs directory: %ld",
+			PTR_ERR(debug_dir));
+		debugfs_remove_recursive(debug_dir);
+	}
+
+end:
+	return r;
+}
+
+static void __exit dm_android_verity_exit(void)
+{
+	if (!IS_ERR_OR_NULL(debug_dir))
+		debugfs_remove_recursive(debug_dir);
+
+	dm_unregister_target(&android_verity_target);
+}
+
+module_init(dm_android_verity_init);
+module_exit(dm_android_verity_exit);
diff --git a/drivers/md/dm-android-verity.h b/drivers/md/dm-android-verity.h
new file mode 100644
index 00000000..c8d7ab64
--- /dev/null
+++ b/drivers/md/dm-android-verity.h
@@ -0,0 +1,123 @@
+/*
+ * Copyright (C) 2015 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef DM_ANDROID_VERITY_H
+#define DM_ANDROID_VERITY_H
+
+#include <crypto/sha.h>
+
+#define RSANUMBYTES 256
+#define VERITY_METADATA_MAGIC_NUMBER 0xb001b001
+#define VERITY_METADATA_MAGIC_DISABLE 0x46464f56
+#define VERITY_METADATA_VERSION 0
+#define VERITY_STATE_DISABLE 1
+#define DATA_BLOCK_SIZE (4 * 1024)
+#define VERITY_METADATA_SIZE (8 * DATA_BLOCK_SIZE)
+#define VERITY_TABLE_ARGS 10
+#define VERITY_COMMANDLINE_PARAM_LENGTH 20
+#define BUILD_VARIANT 20
+
+/*
+ * <subject>:<sha1-id> is the format for the identifier.
+ * subject can either be the Common Name(CN) + Organization Name(O) or
+ * just the CN if the it is prefixed with O
+ * From https://tools.ietf.org/html/rfc5280#appendix-A
+ * ub-organization-name-length INTEGER ::= 64
+ * ub-common-name-length INTEGER ::= 64
+ *
+ * http://lxr.free-electrons.com/source/crypto/asymmetric_keys/x509_cert_parser.c?v=3.9#L278
+ * ctx->o_size + 2 + ctx->cn_size + 1
+ * + 41 characters for ":" and sha1 id
+ * 64 + 2 + 64 + 1 + 1 + 40 (172)
+ * setting VERITY_DEFAULT_KEY_ID_LENGTH to 200 characters.
+ */
+#define VERITY_DEFAULT_KEY_ID_LENGTH 200
+
+#define FEC_MAGIC 0xFECFECFE
+#define FEC_BLOCK_SIZE (4 * 1024)
+#define FEC_VERSION 0
+#define FEC_RSM 255
+#define FEC_ARG_LENGTH 300
+
+#define VERITY_TABLE_OPT_RESTART "restart_on_corruption"
+#define VERITY_TABLE_OPT_LOGGING "ignore_corruption"
+#define VERITY_TABLE_OPT_IGNZERO "ignore_zero_blocks"
+
+#define VERITY_TABLE_OPT_FEC_FORMAT \
+	"use_fec_from_device %s fec_start %llu fec_blocks %llu fec_roots %u ignore_zero_blocks"
+#define VERITY_TABLE_OPT_FEC_ARGS 9
+
+#define VERITY_DEBUG 0
+
+#define DM_MSG_PREFIX                   "android-verity"
+
+#define DM_LINEAR_ARGS 2
+#define DM_LINEAR_TARGET_OFFSET "0"
+
+/*
+ * There can be two formats.
+ * if fec is present
+ * <data_blocks> <verity_tree> <verity_metdata_32K><fec_data><fec_data_4K>
+ * if fec is not present
+ * <data_blocks> <verity_tree> <verity_metdata_32K>
+ */
+struct fec_header {
+	__le32 magic;
+	__le32 version;
+	__le32 size;
+	__le32 roots;
+	__le32 fec_size;
+	__le64 inp_size;
+	u8 hash[SHA256_DIGEST_SIZE];
+} __attribute__((packed));
+
+struct android_metadata_header {
+	__le32 magic_number;
+	__le32 protocol_version;
+	char signature[RSANUMBYTES];
+	__le32 table_length;
+};
+
+struct android_metadata {
+	struct android_metadata_header *header;
+	char *verity_table;
+};
+
+struct fec_ecc_metadata {
+	bool valid;
+	u32 roots;
+	u64 blocks;
+	u64 rounds;
+	u64 start;
+};
+
+struct bio_read {
+	struct page **page_io;
+	int number_of_pages;
+};
+
+extern struct target_type linear_target;
+
+extern void dm_linear_dtr(struct dm_target *ti);
+extern int dm_linear_map(struct dm_target *ti, struct bio *bio);
+extern void dm_linear_status(struct dm_target *ti, status_type_t type,
+			unsigned status_flags, char *result, unsigned maxlen);
+extern int dm_linear_prepare_ioctl(struct dm_target *ti,
+                struct block_device **bdev, fmode_t *mode);
+extern int dm_linear_iterate_devices(struct dm_target *ti,
+			iterate_devices_callout_fn fn, void *data);
+extern int dm_linear_ctr(struct dm_target *ti, unsigned int argc, char **argv);
+extern long dm_linear_direct_access(struct dm_target *ti, sector_t sector,
+                                 void **kaddr, pfn_t *pfn, long size);
+#endif /* DM_ANDROID_VERITY_H */
diff --git a/drivers/md/dm-crypt.c b/drivers/md/dm-crypt.c
index 0aedd0e..7a5b75f 100644
--- a/drivers/md/dm-crypt.c
+++ b/drivers/md/dm-crypt.c
@@ -1866,16 +1866,24 @@ static int crypt_ctr(struct dm_target *ti, unsigned int argc, char **argv)
 	}
 
 	ret = -ENOMEM;
-	cc->io_queue = alloc_workqueue("kcryptd_io", WQ_MEM_RECLAIM, 1);
+	cc->io_queue = alloc_workqueue("kcryptd_io",
+				       WQ_HIGHPRI |
+				       WQ_MEM_RECLAIM,
+				       1);
 	if (!cc->io_queue) {
 		ti->error = "Couldn't create kcryptd io queue";
 		goto bad;
 	}
 
 	if (test_bit(DM_CRYPT_SAME_CPU, &cc->flags))
-		cc->crypt_queue = alloc_workqueue("kcryptd", WQ_CPU_INTENSIVE | WQ_MEM_RECLAIM, 1);
+		cc->crypt_queue = alloc_workqueue("kcryptd",
+						  WQ_HIGHPRI |
+						  WQ_MEM_RECLAIM, 1);
 	else
-		cc->crypt_queue = alloc_workqueue("kcryptd", WQ_CPU_INTENSIVE | WQ_MEM_RECLAIM | WQ_UNBOUND,
+		cc->crypt_queue = alloc_workqueue("kcryptd",
+						  WQ_HIGHPRI |
+						  WQ_MEM_RECLAIM |
+						  WQ_UNBOUND,
 						  num_online_cpus());
 	if (!cc->crypt_queue) {
 		ti->error = "Couldn't create kcryptd queue";
diff --git a/drivers/md/dm-ioctl.c b/drivers/md/dm-ioctl.c
index b67414b..9f398ad 100644
--- a/drivers/md/dm-ioctl.c
+++ b/drivers/md/dm-ioctl.c
@@ -19,9 +19,15 @@
 
 #include <asm/uaccess.h>
 
+#include <linux/clk.h>
+#include <linux/delay.h>
+
 #define DM_MSG_PREFIX "ioctl"
 #define DM_DRIVER_EMAIL "dm-devel@redhat.com"
 
+#define VERITY_MATCH (0x8f)
+#define HWRSANUMBYTES (520)
+
 /*-----------------------------------------------------------------
  * The ioctl interface needs to be able to look up devices by
  * name or uuid.
@@ -51,6 +57,11 @@ struct vers_iter {
     uint32_t flags;
 };
 
+struct verity_signature_data {
+	uint8_t signature[HWRSANUMBYTES];
+	uint8_t ecc_signature[HWRSANUMBYTES];
+	uint8_t hash[32];
+};
 
 #define NUM_BUCKETS 64
 #define MASK_BUCKETS (NUM_BUCKETS - 1)
@@ -965,6 +976,76 @@ static int dev_set_geometry(struct dm_ioctl *param, size_t param_size)
 	return r;
 }
 
+static int dev_verify_signature(struct dm_ioctl *param, size_t param_size)
+{
+#if !defined(CONFIG_CPU_V7)
+	int ret = -1;
+	char *buffer = (char*) param;
+	struct verity_signature_data *v_data = (struct verity_signature_data *) &buffer[sizeof(struct dm_ioctl)];
+	uint32_t target_signature;
+	uint32_t target_hash;
+	struct clk *rsa_clk;
+
+	rsa_clk = clk_get(NULL, "clk_en_rsa");
+	if (IS_ERR(rsa_clk)) {
+		pr_err("%s: clk_get() returns %ld\n", __func__, PTR_ERR(rsa_clk));
+		rsa_clk = NULL;
+		goto OUT;
+	}
+	clk_prepare_enable(rsa_clk);
+
+	__flush_dcache_area(buffer, param_size);
+
+	target_signature = (uint32_t)__pa(v_data->signature);
+	target_hash = (uint32_t)__pa(v_data->hash);
+
+	__flush_dcache_area(&target_signature, sizeof(target_signature));
+	__flush_dcache_area(&target_hash, sizeof(target_hash));
+
+	asm volatile("mov x1, %0" : :"r" (target_signature) : "cc");
+	asm volatile("mov x2, %0" : :"r" (target_hash) : "cc");
+	asm volatile("ldr x0, =0x8400ff10" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("mov %0, x0" : "=r"(ret): : "cc");
+
+	if (ret != VERITY_MATCH) {
+		pr_err("Verify system fail \n");
+		goto OUT;
+	}
+
+	target_signature = (uint32_t)__pa(v_data->ecc_signature);
+	target_hash = (uint32_t)__pa(v_data->hash);
+
+	__flush_dcache_area(&target_signature, sizeof(target_signature));
+	__flush_dcache_area(&target_hash, sizeof(target_hash));
+
+	asm volatile("mov x1, %0" : :"r" (target_signature) : "cc");
+	asm volatile("mov x2, %0" : :"r" (target_hash) : "cc");
+	asm volatile("ldr x0, =0x8400ff10" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("mov %0, x0" : "=r"(ret): : "cc");
+
+	if (ret != VERITY_MATCH) {
+		pr_err("Verify system fail \n");
+		goto OUT;
+	}
+
+	ret = 0;
+
+OUT:
+	if (rsa_clk != NULL)
+		clk_prepare_enable(rsa_clk);
+
+	return ret;
+#else
+	return -1;
+#endif
+}
+
 static int do_suspend(struct dm_ioctl *param)
 {
 	int r = 0;
@@ -1635,7 +1716,8 @@ static ioctl_fn lookup_ioctl(unsigned int cmd, int *ioctl_flags)
 		{DM_LIST_VERSIONS_CMD, 0, list_versions},
 
 		{DM_TARGET_MSG_CMD, 0, target_message},
-		{DM_DEV_SET_GEOMETRY_CMD, 0, dev_set_geometry}
+		{DM_DEV_SET_GEOMETRY_CMD, 0, dev_set_geometry},
+		{DM_VERIFY_SIGNATURE_CMD, 0, dev_verify_signature}
 	};
 
 	if (unlikely(cmd >= ARRAY_SIZE(_ioctls)))
@@ -1927,6 +2009,45 @@ void dm_interface_exit(void)
 	dm_hash_exit();
 }
 
+
+/**
+ * dm_ioctl_export - Permanently export a mapped device via the ioctl interface
+ * @md: Pointer to mapped_device
+ * @name: Buffer (size DM_NAME_LEN) for name
+ * @uuid: Buffer (size DM_UUID_LEN) for uuid or NULL if not desired
+ */
+int dm_ioctl_export(struct mapped_device *md, const char *name,
+		    const char *uuid)
+{
+	int r = 0;
+	struct hash_cell *hc;
+
+	if (!md) {
+		r = -ENXIO;
+		goto out;
+	}
+
+	/* The name and uuid can only be set once. */
+	mutex_lock(&dm_hash_cells_mutex);
+	hc = dm_get_mdptr(md);
+	mutex_unlock(&dm_hash_cells_mutex);
+	if (hc) {
+		DMERR("%s: already exported", dm_device_name(md));
+		r = -ENXIO;
+		goto out;
+	}
+
+	r = dm_hash_insert(name, uuid, md);
+	if (r) {
+		DMERR("%s: could not bind to '%s'", dm_device_name(md), name);
+		goto out;
+	}
+
+	/* Let udev know we've changed. */
+	dm_kobject_uevent(md, KOBJ_CHANGE, dm_get_event_nr(md));
+out:
+	return r;
+}
 /**
  * dm_copy_name_and_uuid - Copy mapped device name & uuid into supplied buffers
  * @md: Pointer to mapped_device
diff --git a/drivers/md/dm-linear.c b/drivers/md/dm-linear.c
index 4788b0b..4ad62d6 100644
--- a/drivers/md/dm-linear.c
+++ b/drivers/md/dm-linear.c
@@ -25,7 +25,7 @@ struct linear_c {
 /*
  * Construct a linear mapping: <dev_path> <offset>
  */
-static int linear_ctr(struct dm_target *ti, unsigned int argc, char **argv)
+int dm_linear_ctr(struct dm_target *ti, unsigned int argc, char **argv)
 {
 	struct linear_c *lc;
 	unsigned long long tmp;
@@ -66,14 +66,16 @@ static int linear_ctr(struct dm_target *ti, unsigned int argc, char **argv)
 	kfree(lc);
 	return ret;
 }
+EXPORT_SYMBOL_GPL(dm_linear_ctr);
 
-static void linear_dtr(struct dm_target *ti)
+void dm_linear_dtr(struct dm_target *ti)
 {
 	struct linear_c *lc = (struct linear_c *) ti->private;
 
 	dm_put_device(ti, lc->dev);
 	kfree(lc);
 }
+EXPORT_SYMBOL_GPL(dm_linear_dtr);
 
 static sector_t linear_map_sector(struct dm_target *ti, sector_t bi_sector)
 {
@@ -92,14 +94,15 @@ static void linear_map_bio(struct dm_target *ti, struct bio *bio)
 			linear_map_sector(ti, bio->bi_iter.bi_sector);
 }
 
-static int linear_map(struct dm_target *ti, struct bio *bio)
+int dm_linear_map(struct dm_target *ti, struct bio *bio)
 {
 	linear_map_bio(ti, bio);
 
 	return DM_MAPIO_REMAPPED;
 }
+EXPORT_SYMBOL_GPL(dm_linear_map);
 
-static void linear_status(struct dm_target *ti, status_type_t type,
+void dm_linear_status(struct dm_target *ti, status_type_t type,
 			  unsigned status_flags, char *result, unsigned maxlen)
 {
 	struct linear_c *lc = (struct linear_c *) ti->private;
@@ -115,8 +118,9 @@ static void linear_status(struct dm_target *ti, status_type_t type,
 		break;
 	}
 }
+EXPORT_SYMBOL_GPL(dm_linear_status);
 
-static int linear_prepare_ioctl(struct dm_target *ti,
+int dm_linear_prepare_ioctl(struct dm_target *ti,
 		struct block_device **bdev, fmode_t *mode)
 {
 	struct linear_c *lc = (struct linear_c *) ti->private;
@@ -132,16 +136,18 @@ static int linear_prepare_ioctl(struct dm_target *ti,
 		return 1;
 	return 0;
 }
+EXPORT_SYMBOL_GPL(dm_linear_prepare_ioctl);
 
-static int linear_iterate_devices(struct dm_target *ti,
+int dm_linear_iterate_devices(struct dm_target *ti,
 				  iterate_devices_callout_fn fn, void *data)
 {
 	struct linear_c *lc = ti->private;
 
 	return fn(ti, lc->dev, lc->start, ti->len, data);
 }
+EXPORT_SYMBOL_GPL(dm_linear_iterate_devices);
 
-static long linear_direct_access(struct dm_target *ti, sector_t sector,
+long dm_linear_direct_access(struct dm_target *ti, sector_t sector,
 				 void **kaddr, pfn_t *pfn, long size)
 {
 	struct linear_c *lc = ti->private;
@@ -158,18 +164,19 @@ static long linear_direct_access(struct dm_target *ti, sector_t sector,
 
 	return ret;
 }
+EXPORT_SYMBOL_GPL(dm_linear_direct_access);
 
 static struct target_type linear_target = {
 	.name   = "linear",
 	.version = {1, 3, 0},
 	.module = THIS_MODULE,
-	.ctr    = linear_ctr,
-	.dtr    = linear_dtr,
-	.map    = linear_map,
-	.status = linear_status,
-	.prepare_ioctl = linear_prepare_ioctl,
-	.iterate_devices = linear_iterate_devices,
-	.direct_access = linear_direct_access,
+	.ctr    = dm_linear_ctr,
+	.dtr    = dm_linear_dtr,
+	.map    = dm_linear_map,
+	.status = dm_linear_status,
+	.prepare_ioctl = dm_linear_prepare_ioctl,
+	.iterate_devices = dm_linear_iterate_devices,
+	.direct_access = dm_linear_direct_access,
 };
 
 int __init dm_linear_init(void)
diff --git a/drivers/md/dm-table.c b/drivers/md/dm-table.c
index 5ac239d..0e79a43 100644
--- a/drivers/md/dm-table.c
+++ b/drivers/md/dm-table.c
@@ -11,6 +11,7 @@
 #include <linux/vmalloc.h>
 #include <linux/blkdev.h>
 #include <linux/namei.h>
+#include <linux/mount.h>
 #include <linux/ctype.h>
 #include <linux/string.h>
 #include <linux/slab.h>
@@ -510,14 +511,14 @@ static int adjoin(struct dm_table *table, struct dm_target *ti)
  * On the other hand, dm-switch needs to process bulk data using messages and
  * excessive use of GFP_NOIO could cause trouble.
  */
-static char **realloc_argv(unsigned *array_size, char **old_argv)
+static char **realloc_argv(unsigned *size, char **old_argv)
 {
 	char **argv;
 	unsigned new_size;
 	gfp_t gfp;
 
-	if (*array_size) {
-		new_size = *array_size * 2;
+	if (*size) {
+		new_size = *size * 2;
 		gfp = GFP_KERNEL;
 	} else {
 		new_size = 8;
@@ -525,8 +526,8 @@ static char **realloc_argv(unsigned *array_size, char **old_argv)
 	}
 	argv = kmalloc(new_size * sizeof(*argv), gfp);
 	if (argv) {
-		memcpy(argv, old_argv, *array_size * sizeof(*argv));
-		*array_size = new_size;
+		memcpy(argv, old_argv, *size * sizeof(*argv));
+		*size = new_size;
 	}
 
 	kfree(old_argv);
diff --git a/drivers/md/dm-verity-fec.c b/drivers/md/dm-verity-fec.c
index 78f3601..3b62315 100644
--- a/drivers/md/dm-verity-fec.c
+++ b/drivers/md/dm-verity-fec.c
@@ -11,6 +11,7 @@
 
 #include "dm-verity-fec.h"
 #include <linux/math64.h>
+#include <linux/sysfs.h>
 
 #define DM_MSG_PREFIX	"verity-fec"
 
@@ -175,9 +176,11 @@ static int fec_decode_bufs(struct dm_verity *v, struct dm_verity_fec_io *fio,
 	if (r < 0 && neras)
 		DMERR_LIMIT("%s: FEC %llu: failed to correct: %d",
 			    v->data_dev->name, (unsigned long long)rsb, r);
-	else if (r > 0)
+	else if (r > 0) {
 		DMWARN_LIMIT("%s: FEC %llu: corrected %d errors",
 			     v->data_dev->name, (unsigned long long)rsb, r);
+		atomic_add_unless(&v->fec->corrected, 1, INT_MAX);
+	}
 
 	return r;
 }
@@ -556,6 +559,7 @@ unsigned verity_fec_status_table(struct dm_verity *v, unsigned sz,
 void verity_fec_dtr(struct dm_verity *v)
 {
 	struct dm_verity_fec *f = v->fec;
+	struct kobject *kobj = &f->kobj_holder.kobj;
 
 	if (!verity_fec_is_enabled(v))
 		goto out;
@@ -572,6 +576,12 @@ void verity_fec_dtr(struct dm_verity *v)
 
 	if (f->dev)
 		dm_put_device(v->ti, f->dev);
+
+	if (kobj->state_initialized) {
+		kobject_put(kobj);
+		wait_for_completion(dm_get_completion_from_kobject(kobj));
+	}
+
 out:
 	kfree(f);
 	v->fec = NULL;
@@ -660,6 +670,28 @@ int verity_fec_parse_opt_args(struct dm_arg_set *as, struct dm_verity *v,
 	return 0;
 }
 
+static ssize_t corrected_show(struct kobject *kobj, struct kobj_attribute *attr,
+			      char *buf)
+{
+	struct dm_verity_fec *f = container_of(kobj, struct dm_verity_fec,
+					       kobj_holder.kobj);
+
+	return sprintf(buf, "%d\n", atomic_read(&f->corrected));
+}
+
+static struct kobj_attribute attr_corrected = __ATTR_RO(corrected);
+
+static struct attribute *fec_attrs[] = {
+	&attr_corrected.attr,
+	NULL
+};
+
+static struct kobj_type fec_ktype = {
+	.sysfs_ops = &kobj_sysfs_ops,
+	.default_attrs = fec_attrs,
+	.release = dm_kobject_release
+};
+
 /*
  * Allocate dm_verity_fec for v->fec. Must be called before verity_fec_ctr.
  */
@@ -683,8 +715,10 @@ int verity_fec_ctr_alloc(struct dm_verity *v)
  */
 int verity_fec_ctr(struct dm_verity *v)
 {
+	int r;
 	struct dm_verity_fec *f = v->fec;
 	struct dm_target *ti = v->ti;
+	struct mapped_device *md = dm_table_get_md(ti->table);
 	u64 hash_blocks;
 
 	if (!verity_fec_is_enabled(v)) {
@@ -692,6 +726,16 @@ int verity_fec_ctr(struct dm_verity *v)
 		return 0;
 	}
 
+	/* Create a kobject and sysfs attributes */
+	init_completion(&f->kobj_holder.completion);
+
+	r = kobject_init_and_add(&f->kobj_holder.kobj, &fec_ktype,
+				 &disk_to_dev(dm_disk(md))->kobj, "%s", "fec");
+	if (r) {
+		ti->error = "Cannot create kobject";
+		return r;
+	}
+
 	/*
 	 * FEC is computed over data blocks, possible metadata, and
 	 * hash blocks. In other words, FEC covers total of fec_blocks
diff --git a/drivers/md/dm-verity-fec.h b/drivers/md/dm-verity-fec.h
index bb31ce8..4db0cae 100644
--- a/drivers/md/dm-verity-fec.h
+++ b/drivers/md/dm-verity-fec.h
@@ -12,6 +12,8 @@
 #ifndef DM_VERITY_FEC_H
 #define DM_VERITY_FEC_H
 
+#include "dm.h"
+#include "dm-core.h"
 #include "dm-verity.h"
 #include <linux/rslib.h>
 
@@ -51,6 +53,8 @@ struct dm_verity_fec {
 	mempool_t *extra_pool;	/* mempool for extra buffers */
 	mempool_t *output_pool;	/* mempool for output */
 	struct kmem_cache *cache;	/* cache for buffers */
+	atomic_t corrected;		/* corrected errors */
+	struct dm_kobject_holder kobj_holder;	/* for sysfs attributes */
 };
 
 /* per-bio data */
diff --git a/drivers/md/dm-verity-target.c b/drivers/md/dm-verity-target.c
index 0aba34a..0a7a828 100644
--- a/drivers/md/dm-verity-target.c
+++ b/drivers/md/dm-verity-target.c
@@ -19,6 +19,7 @@
 
 #include <linux/module.h>
 #include <linux/reboot.h>
+#include <linux/vmalloc.h>
 
 #define DM_MSG_PREFIX			"verity"
 
@@ -32,6 +33,7 @@
 #define DM_VERITY_OPT_LOGGING		"ignore_corruption"
 #define DM_VERITY_OPT_RESTART		"restart_on_corruption"
 #define DM_VERITY_OPT_IGN_ZEROES	"ignore_zero_blocks"
+#define DM_VERITY_OPT_AT_MOST_ONCE	"check_at_most_once"
 
 #define DM_VERITY_OPTS_MAX		(2 + DM_VERITY_OPTS_FEC)
 
@@ -395,6 +397,18 @@ static int verity_bv_zero(struct dm_verity *v, struct dm_verity_io *io,
 }
 
 /*
+ * Moves the bio iter one data block forward.
+ */
+static inline void verity_bv_skip_block(struct dm_verity *v,
+					struct dm_verity_io *io,
+					struct bvec_iter *iter)
+{
+	struct bio *bio = dm_bio_from_per_bio_data(io, v->ti->per_io_data_size);
+
+	bio_advance_iter(bio, iter, 1 << v->data_dev_block_bits);
+}
+
+/*
  * Verify one "dm_verity_io" structure.
  */
 static int verity_verify_io(struct dm_verity_io *io)
@@ -406,9 +420,16 @@ static int verity_verify_io(struct dm_verity_io *io)
 
 	for (b = 0; b < io->n_blocks; b++) {
 		int r;
+		sector_t cur_block = io->block + b;
 		struct shash_desc *desc = verity_io_hash_desc(v, io);
 
-		r = verity_hash_for_block(v, io, io->block + b,
+		if (v->validated_blocks &&
+		    likely(test_bit(cur_block, v->validated_blocks))) {
+			verity_bv_skip_block(v, io, &io->iter);
+			continue;
+		}
+
+		r = verity_hash_for_block(v, io, cur_block,
 					  verity_io_want_digest(v, io),
 					  &is_zero);
 		if (unlikely(r < 0))
@@ -441,13 +462,16 @@ static int verity_verify_io(struct dm_verity_io *io)
 			return r;
 
 		if (likely(memcmp(verity_io_real_digest(v, io),
-				  verity_io_want_digest(v, io), v->digest_size) == 0))
+				  verity_io_want_digest(v, io), v->digest_size) == 0)) {
+			if (v->validated_blocks)
+				set_bit(cur_block, v->validated_blocks);
 			continue;
+		}
 		else if (verity_fec_decode(v, io, DM_VERITY_BLOCK_TYPE_DATA,
-					   io->block + b, NULL, &start) == 0)
+					   cur_block, NULL, &start) == 0)
 			continue;
 		else if (verity_handle_err(v, DM_VERITY_BLOCK_TYPE_DATA,
-					   io->block + b))
+					   cur_block))
 			return -EIO;
 	}
 
@@ -501,6 +525,7 @@ static void verity_prefetch_io(struct work_struct *work)
 		container_of(work, struct dm_verity_prefetch_work, work);
 	struct dm_verity *v = pw->v;
 	int i;
+	sector_t prefetch_size;
 
 	for (i = v->levels - 2; i >= 0; i--) {
 		sector_t hash_block_start;
@@ -523,8 +548,14 @@ static void verity_prefetch_io(struct work_struct *work)
 				hash_block_end = v->hash_blocks - 1;
 		}
 no_prefetch_cluster:
+		// for emmc, it is more efficient to send bigger read
+		prefetch_size = max((sector_t)CONFIG_DM_VERITY_HASH_PREFETCH_MIN_SIZE,
+			hash_block_end - hash_block_start + 1);
+		if ((hash_block_start + prefetch_size) >= (v->hash_start + v->hash_blocks)) {
+			prefetch_size = hash_block_end - hash_block_start + 1;
+		}
 		dm_bufio_prefetch(v->bufio, hash_block_start,
-				  hash_block_end - hash_block_start + 1);
+				  prefetch_size);
 	}
 
 	kfree(pw);
@@ -551,7 +582,7 @@ static void verity_submit_prefetch(struct dm_verity *v, struct dm_verity_io *io)
  * Bio map function. It allocates dm_verity_io structure and bio vector and
  * fills them. Then it issues prefetches and the I/O.
  */
-static int verity_map(struct dm_target *ti, struct bio *bio)
+int verity_map(struct dm_target *ti, struct bio *bio)
 {
 	struct dm_verity *v = ti->private;
 	struct dm_verity_io *io;
@@ -592,11 +623,12 @@ static int verity_map(struct dm_target *ti, struct bio *bio)
 
 	return DM_MAPIO_SUBMITTED;
 }
+EXPORT_SYMBOL_GPL(verity_map);
 
 /*
  * Status: V (valid) or C (corruption found)
  */
-static void verity_status(struct dm_target *ti, status_type_t type,
+void verity_status(struct dm_target *ti, status_type_t type,
 			  unsigned status_flags, char *result, unsigned maxlen)
 {
 	struct dm_verity *v = ti->private;
@@ -633,6 +665,8 @@ static void verity_status(struct dm_target *ti, status_type_t type,
 			args += DM_VERITY_OPTS_FEC;
 		if (v->zero_digest)
 			args++;
+		if (v->validated_blocks)
+			args++;
 		if (!args)
 			return;
 		DMEMIT(" %u", args);
@@ -651,12 +685,15 @@ static void verity_status(struct dm_target *ti, status_type_t type,
 		}
 		if (v->zero_digest)
 			DMEMIT(" " DM_VERITY_OPT_IGN_ZEROES);
+		if (v->validated_blocks)
+			DMEMIT(" " DM_VERITY_OPT_AT_MOST_ONCE);
 		sz = verity_fec_status_table(v, sz, result, maxlen);
 		break;
 	}
 }
+EXPORT_SYMBOL_GPL(verity_status);
 
-static int verity_prepare_ioctl(struct dm_target *ti,
+int verity_prepare_ioctl(struct dm_target *ti,
 		struct block_device **bdev, fmode_t *mode)
 {
 	struct dm_verity *v = ti->private;
@@ -668,16 +705,18 @@ static int verity_prepare_ioctl(struct dm_target *ti,
 		return 1;
 	return 0;
 }
+EXPORT_SYMBOL_GPL(verity_prepare_ioctl);
 
-static int verity_iterate_devices(struct dm_target *ti,
+int verity_iterate_devices(struct dm_target *ti,
 				  iterate_devices_callout_fn fn, void *data)
 {
 	struct dm_verity *v = ti->private;
 
 	return fn(ti, v->data_dev, v->data_start, ti->len, data);
 }
+EXPORT_SYMBOL_GPL(verity_iterate_devices);
 
-static void verity_io_hints(struct dm_target *ti, struct queue_limits *limits)
+void verity_io_hints(struct dm_target *ti, struct queue_limits *limits)
 {
 	struct dm_verity *v = ti->private;
 
@@ -689,8 +728,9 @@ static void verity_io_hints(struct dm_target *ti, struct queue_limits *limits)
 
 	blk_limits_io_min(limits, limits->logical_block_size);
 }
+EXPORT_SYMBOL_GPL(verity_io_hints);
 
-static void verity_dtr(struct dm_target *ti)
+void verity_dtr(struct dm_target *ti)
 {
 	struct dm_verity *v = ti->private;
 
@@ -700,6 +740,7 @@ static void verity_dtr(struct dm_target *ti)
 	if (v->bufio)
 		dm_bufio_client_destroy(v->bufio);
 
+	vfree(v->validated_blocks);
 	kfree(v->salt);
 	kfree(v->root_digest);
 	kfree(v->zero_digest);
@@ -719,6 +760,27 @@ static void verity_dtr(struct dm_target *ti)
 
 	kfree(v);
 }
+EXPORT_SYMBOL_GPL(verity_dtr);
+
+static int verity_alloc_most_once(struct dm_verity *v)
+{
+	struct dm_target *ti = v->ti;
+
+	/* the bitset can only handle INT_MAX blocks */
+	if (v->data_blocks > INT_MAX) {
+		ti->error = "device too large to use check_at_most_once";
+		return -E2BIG;
+	}
+
+	v->validated_blocks = vzalloc(BITS_TO_LONGS(v->data_blocks) *
+				       sizeof(unsigned long));
+	if (!v->validated_blocks) {
+		ti->error = "failed to allocate bitset for check_at_most_once";
+		return -ENOMEM;
+	}
+
+	return 0;
+}
 
 static int verity_alloc_zero_digest(struct dm_verity *v)
 {
@@ -789,6 +851,12 @@ static int verity_parse_opt_args(struct dm_arg_set *as, struct dm_verity *v)
 			}
 			continue;
 
+		} else if (!strcasecmp(arg_name, DM_VERITY_OPT_AT_MOST_ONCE)) {
+			r = verity_alloc_most_once(v);
+			if (r)
+				return r;
+			continue;
+
 		} else if (verity_is_fec_opt_arg(arg_name)) {
 			r = verity_fec_parse_opt_args(as, v, &argc, arg_name);
 			if (r)
@@ -817,7 +885,7 @@ static int verity_parse_opt_args(struct dm_arg_set *as, struct dm_verity *v)
  *	<digest>
  *	<salt>		Hex string or "-" if no salt.
  */
-static int verity_ctr(struct dm_target *ti, unsigned argc, char **argv)
+int verity_ctr(struct dm_target *ti, unsigned argc, char **argv)
 {
 	struct dm_verity *v;
 	struct dm_arg_set as;
@@ -981,6 +1049,14 @@ static int verity_ctr(struct dm_target *ti, unsigned argc, char **argv)
 			goto bad;
 	}
 
+#ifdef CONFIG_DM_ANDROID_VERITY_AT_MOST_ONCE_DEFAULT_ENABLED
+	if (!v->validated_blocks) {
+		r = verity_alloc_most_once(v);
+		if (r)
+			goto bad;
+	}
+#endif
+
 	v->hash_per_block_bits =
 		__fls((1 << v->hash_dev_block_bits) / v->digest_size);
 
@@ -1053,10 +1129,11 @@ static int verity_ctr(struct dm_target *ti, unsigned argc, char **argv)
 
 	return r;
 }
+EXPORT_SYMBOL_GPL(verity_ctr);
 
 static struct target_type verity_target = {
 	.name		= "verity",
-	.version	= {1, 3, 0},
+	.version	= {1, 4, 0},
 	.module		= THIS_MODULE,
 	.ctr		= verity_ctr,
 	.dtr		= verity_dtr,
diff --git a/drivers/md/dm-verity.h b/drivers/md/dm-verity.h
index fb419f4..6d6d8df 100644
--- a/drivers/md/dm-verity.h
+++ b/drivers/md/dm-verity.h
@@ -63,6 +63,7 @@ struct dm_verity {
 	sector_t hash_level_block[DM_VERITY_MAX_LEVELS];
 
 	struct dm_verity_fec *fec;	/* forward error correction */
+	unsigned long *validated_blocks; /* bitset blocks validated */
 };
 
 struct dm_verity_io {
@@ -126,4 +127,14 @@ extern int verity_hash(struct dm_verity *v, struct shash_desc *desc,
 extern int verity_hash_for_block(struct dm_verity *v, struct dm_verity_io *io,
 				 sector_t block, u8 *digest, bool *is_zero);
 
+extern void verity_status(struct dm_target *ti, status_type_t type,
+			unsigned status_flags, char *result, unsigned maxlen);
+extern int verity_prepare_ioctl(struct dm_target *ti,
+                struct block_device **bdev, fmode_t *mode);
+extern int verity_iterate_devices(struct dm_target *ti,
+				iterate_devices_callout_fn fn, void *data);
+extern void verity_io_hints(struct dm_target *ti, struct queue_limits *limits);
+extern void verity_dtr(struct dm_target *ti);
+extern int verity_ctr(struct dm_target *ti, unsigned argc, char **argv);
+extern int verity_map(struct dm_target *ti, struct bio *bio);
 #endif /* DM_VERITY_H */
diff --git a/drivers/md/dm.h b/drivers/md/dm.h
index f0aad08..ed25f30 100644
--- a/drivers/md/dm.h
+++ b/drivers/md/dm.h
@@ -80,8 +80,6 @@ void dm_table_set_restrictions(struct dm_table *t, struct request_queue *q,
 unsigned dm_get_md_type(struct mapped_device *md);
 struct target_type *dm_get_immutable_target_type(struct mapped_device *md);
 
-int dm_setup_md_queue(struct mapped_device *md, struct dm_table *t);
-
 /*
  * To check the return value from dm_table_find_target().
  */
diff --git a/drivers/md/md.c b/drivers/md/md.c
index a7a0e3a..ff53829 100644
--- a/drivers/md/md.c
+++ b/drivers/md/md.c
@@ -5098,7 +5098,7 @@ static struct kobject *md_probe(dev_t dev, int *part, void *data)
 	return NULL;
 }
 
-static int add_named_array(const char *val, struct kernel_param *kp)
+static int add_named_array(const char *val, const struct kernel_param *kp)
 {
 	/* val must be "md_*" where * is not all digits.
 	 * We allocate an array with a large free minor number, and
@@ -8989,11 +8989,11 @@ static __exit void md_exit(void)
 subsys_initcall(md_init);
 module_exit(md_exit)
 
-static int get_ro(char *buffer, struct kernel_param *kp)
+static int get_ro(char *buffer, const struct kernel_param *kp)
 {
 	return sprintf(buffer, "%d", start_readonly);
 }
-static int set_ro(const char *val, struct kernel_param *kp)
+static int set_ro(const char *val, const struct kernel_param *kp)
 {
 	return kstrtouint(val, 10, (unsigned int *)&start_readonly);
 }
diff --git a/drivers/media/Kconfig b/drivers/media/Kconfig
index 7b85402..18eefb5 100644
--- a/drivers/media/Kconfig
+++ b/drivers/media/Kconfig
@@ -221,3 +221,5 @@ source "drivers/media/tuners/Kconfig"
 source "drivers/media/dvb-frontends/Kconfig"
 
 endif # MEDIA_SUPPORT
+
+source "drivers/media/platform/rtk_cec/Kconfig"
diff --git a/drivers/media/pci/tw686x/tw686x-core.c b/drivers/media/pci/tw686x/tw686x-core.c
index 71a0453..279d447 100644
--- a/drivers/media/pci/tw686x/tw686x-core.c
+++ b/drivers/media/pci/tw686x/tw686x-core.c
@@ -72,12 +72,12 @@ static const char *dma_mode_name(unsigned int mode)
 	}
 }
 
-static int tw686x_dma_mode_get(char *buffer, struct kernel_param *kp)
+static int tw686x_dma_mode_get(char *buffer, const struct kernel_param *kp)
 {
 	return sprintf(buffer, dma_mode_name(dma_mode));
 }
 
-static int tw686x_dma_mode_set(const char *val, struct kernel_param *kp)
+static int tw686x_dma_mode_set(const char *val, const struct kernel_param *kp)
 {
 	if (!strcasecmp(val, dma_mode_name(TW686X_DMA_MODE_MEMCPY)))
 		dma_mode = TW686X_DMA_MODE_MEMCPY;
diff --git a/drivers/media/platform/Kconfig b/drivers/media/platform/Kconfig
index 5ff803e..2e51585 100644
--- a/drivers/media/platform/Kconfig
+++ b/drivers/media/platform/Kconfig
@@ -376,3 +376,9 @@ menuconfig DVB_PLATFORM_DRIVERS
 if DVB_PLATFORM_DRIVERS
 source "drivers/media/platform/sti/c8sectpfe/Kconfig"
 endif #DVB_PLATFORM_DRIVERS
+
+source "drivers/media/platform/rtk_hdmitx/Kconfig"
+source "drivers/media/platform/rtk_hdcptx/Kconfig"
+source "drivers/media/platform/rtk_hdmirx/Kconfig"
+source "drivers/media/platform/rtk_cvbsdetect/Kconfig"
+source "drivers/media/platform/rtk_dptx/Kconfig"
diff --git a/drivers/media/platform/Makefile b/drivers/media/platform/Makefile
index 40b18d1..c005d5a 100644
--- a/drivers/media/platform/Makefile
+++ b/drivers/media/platform/Makefile
@@ -66,3 +66,18 @@ ccflags-y += -I$(srctree)/drivers/media/i2c
 obj-$(CONFIG_VIDEO_MEDIATEK_VPU)	+= mtk-vpu/
 
 obj-$(CONFIG_VIDEO_MEDIATEK_VCODEC)	+= mtk-vcodec/
+
+obj-$(CONFIG_RTK_HDMITX)        += rtk_hdmitx/
+obj-$(CONFIG_RTK_HDCP_1x)	+= rtk_hdcptx/
+ifeq ($(CONFIG_ARCH_RTD129x),y)
+obj-$(CONFIG_RTK_HDMIRX)	+= rtk_hdmirx/rtd129x/
+endif
+ifeq ($(CONFIG_ARCH_RTD16xx),y)
+obj-$(CONFIG_RTK_HDMIRX)	+= rtk_hdmirx/rtd161x/
+endif
+obj-$(CONFIG_CEC)     += rtk_cec/
+obj-$(CONFIG_XEN_CECDEV_FRONTEND)     += rtk_cec/
+obj-$(CONFIG_RTK_CVBS_SWITCH)     += rtk_cvbsdetect/
+obj-$(CONFIG_RTK_DPTX)    += rtk_dptx/
+
+ccflags-y += -I$(srctree)/drivers/media/i2c
diff --git a/drivers/media/platform/rtk_cec/Kconfig b/drivers/media/platform/rtk_cec/Kconfig
new file mode 100644
index 00000000..420019a
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/Kconfig
@@ -0,0 +1,39 @@
+#Copyright (C) 2007-2013 Realtek Semiconductor Corporation.
+# drivers/Kconfig
+
+menu "CEC Support"
+
+config XEN_CECDEV_FRONTEND
+    bool "CEC Xen frontend driver support"
+    depends on XEN
+    select XEN_XENBUS_FRONTEND
+    default n
+    help
+        This driver implements the front-end of the Xen virtual cec device driver.
+        It communicates with a back-end driver in another domain which drives the actual
+        cec device.
+
+config CEC
+	bool "CEC Support"
+
+config XEN_CECDEV_BACKEND
+    bool "CEC Xen backend driver support"
+    depends on XEN
+	default n
+    help
+        The regulator-device backend driver allows the kernel to export its
+        regulator devices to other guests via a high-performance shared-memory
+        interface.
+
+menu "CEC Adapters"
+	depends on CEC
+
+config RTK_CEC
+	tristate "CEC Controller for Realtek platform"
+	depends on CEC
+	default n
+	help
+	  Say Y, if you want to enable CEC feature on Realtek platform.
+
+endmenu
+endmenu
diff --git a/drivers/media/platform/rtk_cec/Makefile b/drivers/media/platform/rtk_cec/Makefile
new file mode 100644
index 00000000..9f34450
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/Makefile
@@ -0,0 +1,9 @@
+#
+# Makefile for CEC linux kernel module.
+#
+
+obj-$(CONFIG_CEC)  += cec_core.o cm_buff.o cec_dev.o
+
+obj-$(CONFIG_CEC) += adapter/
+obj-$(CONFIG_XEN_CECDEV_BACKEND) += xen/cecback.o
+obj-$(CONFIG_XEN_CECDEV_FRONTEND) += xen/cecfront.o xen/cecdev.o
diff --git a/drivers/media/platform/rtk_cec/adapter/Makefile b/drivers/media/platform/rtk_cec/adapter/Makefile
new file mode 100644
index 00000000..4176501
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/adapter/Makefile
@@ -0,0 +1,15 @@
+#
+# Makefile for CEC linux kernel module.
+#
+
+ccflags-y += -I$(srctree)/drivers/video/fbdev/rtk
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_mhltx
+ccflags-y += -I$(srctree)/drivers/staging/android
+
+EXTRA_CFLAGS += -I ../
+
+ifndef CONFIG_XEN
+ccflags-y += -D USE_ION_AUDIO_HEAP
+endif
+
+obj-$(CONFIG_RTK_CEC) += rtk_cec.o
diff --git a/drivers/media/platform/rtk_cec/adapter/cec_rpc.h b/drivers/media/platform/rtk_cec/adapter/cec_rpc.h
new file mode 100644
index 00000000..beb89ad
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/adapter/cec_rpc.h
@@ -0,0 +1,91 @@
+/*
+ *  Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifndef __CEC_RPC_H__
+#define __CEC_RPC_H__
+
+#include <soc/realtek/kernel-rpc.h>
+
+#include "uapi/ion.h"
+#include "ion/ion.h"
+#include "uapi/ion_rtk.h"
+
+typedef enum {
+	ENUM_KERNEL_RPC_CREATE_AGENT,
+	ENUM_KERNEL_RPC_INIT_RINGBUF,
+	ENUM_KERNEL_RPC_PRIVATEINFO,
+	ENUM_KERNEL_RPC_RUN,
+	ENUM_KERNEL_RPC_PAUSE,
+	ENUM_KERNEL_RPC_SWITCH_FOCUS,
+	ENUM_KERNEL_RPC_MALLOC_ADDR,
+	ENUM_KERNEL_RPC_VOLUME_CONTROL,
+	ENUM_KERNEL_RPC_FLUSH,
+	ENUM_KERNEL_RPC_CONNECT,
+	ENUM_KERNEL_RPC_SETREFCLOCK,
+	ENUM_KERNEL_RPC_DAC_I2S_CONFIG,
+	ENUM_KERNEL_RPC_DAC_SPDIF_CONFIG,
+	ENUM_KERNEL_RPC_HDMI_OUT_EDID,
+	ENUM_KERNEL_RPC_HDMI_OUT_EDID2,
+	ENUM_KERNEL_RPC_HDMI_SET,
+	ENUM_KERNEL_RPC_HDMI_MUTE,
+	ENUM_KERNEL_RPC_ASK_DBG_MEM_ADDR,
+	ENUM_KERNEL_RPC_DESTROY,
+	ENUM_KERNEL_RPC_STOP,
+	ENUM_KERNEL_RPC_CHECK_READY,
+	ENUM_KERNEL_RPC_GET_MUTE_N_VOLUME,
+	ENUM_KERNEL_RPC_EOS,
+	ENUM_KERNEL_RPC_ADC0_CONFIG,
+	ENUM_KERNEL_RPC_ADC1_CONFIG,
+	ENUM_KERNEL_RPC_ADC2_CONFIG,
+#if defined(AUDIO_TV_PLATFORM)
+	ENUM_KERNEL_RPC_BBADC_CONFIG,
+	ENUM_KERNEL_RPC_I2SI_CONFIG,
+	ENUM_KERNEL_RPC_SPDIFI_CONFIG,
+#endif
+	ENUM_KERNEL_RPC_HDMI_OUT_VSDB,
+	ENUM_VIDEO_KERNEL_RPC_CONFIG_TV_SYSTEM,
+	ENUM_VIDEO_KERNEL_RPC_CONFIG_HDMI_INFO_FRAME,
+} ENUM_AUDIO_KERNEL_RPC_CMD;
+
+
+enum AUDIO_ENUM_PRIVAETINFO {
+	ENUM_PRIVATEINFO_AUDIO_FORMAT_PARSER_CAPABILITY,
+	ENUM_PRIVATEINFO_AUDIO_DECODER_CAPABILITY,
+	ENUM_PRIVATEINFO_AUDIO_CONFIG_CMD_BS_INFO,
+	ENUM_PRIVATEINFO_AUDIO_CHECK_LPCM_ENDIANESS,
+	ENUM_PRIVATEINFO_AUDIO_CONFIG_CMD_AO_DELAY_INFO,
+	ENUM_PRIVATEINFO_AUDIO_AO_CHANNEL_VOLUME_LEVEL,
+	ENUM_PRIVATEINFO_AUDIO_GET_FLASH_PIN,
+	ENUM_PRIVATEINFO_AUDIO_RELEASE_FLASH_PIN,
+	ENUM_PRIVATEINFO_AUDIO_GET_MUTE_N_VOLUME,
+	ENUM_PRIVATEINFO_AUDIO_AO_MONITOR_FULLNESS,
+	ENUM_PRIVATEINFO_AUDIO_CONTROL_FLASH_VOLUME,
+	ENUM_PRIVATEINFO_AUDIO_CONTROL_DAC_SWITCH,
+	ENUM_PRIVATEINFO_AUDIO_PREPROCESS_CONFIG,
+	ENUM_PRIVATEINFO_AUDIO_CHECK_SECURITY_ID,
+	ENUM_PRIVATEINFO_AUDIO_LOW_DELAY_PARAMETERS,
+	ENUM_PRIVATEINFO_AUDIO_SET_NETWORK_JITTER,
+	ENUM_PRIVATEINFO_AUDIO_GET_QUEUE_DATA_SIZE,
+	ENUM_PRIVATEINFO_AUDIO_GET_SHARE_MEMORY_FROM_ALSA,
+	ENUM_PRIVATEINFO_AUDIO_AI_CONNECT_ALSA,
+	ENUM_PRIVATEINFO_AUDIO_SET_PCM_FORMAT,
+	ENUM_PRIVATEINFO_AUDIO_DO_SELF_DESTROY_FLOW,
+	ENUM_PRIVATEINFO_AUDIO_GET_SAMPLING_RATE,
+	ENUM_PRIVATEINFO_AUDIO_SLAVE_TIMEOUT_THRESHOLD,
+	ENUM_PRIVATEINFO_AUDIO_GET_GLOBAL_AO_INSTANCEID,
+	ENUM_PRIVATEINFO_AUDIO_SET_CEC_PARAMETERS
+};
+
+struct AUDIO_RPC_PRIVATEINFO_PARAMETERS
+{
+	int instanceID;
+	enum    AUDIO_ENUM_PRIVAETINFO type;
+	int privateInfo[16];
+};
+
+#endif  /* __CEC_RPC_H__ */
+
diff --git a/drivers/media/platform/rtk_cec/adapter/rtk_cec.c b/drivers/media/platform/rtk_cec/adapter/rtk_cec.c
new file mode 100644
index 00000000..343abf7
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/adapter/rtk_cec.c
@@ -0,0 +1,1271 @@
+/*
+ *  Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/interrupt.h>
+#include <linux/slab.h>
+
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <soc/realtek/rtk_chip.h>
+
+#include <linux/of.h>
+#include "../cec.h"
+#include "rtk_cec.h"
+#include "cec_rpc.h"
+
+#if defined(CONFIG_ARCH_RTD129x)||defined(CONFIG_ARCH_RTD119X)
+#define CONVERT_FOR_AVCPU(x)	((unsigned int)(x) | 0xA0000000)
+#else
+#define CONVERT_FOR_AVCPU(x)	(x)
+#endif
+
+#define CBUS_WRAPPER		(0)
+
+#define CEC_INT_SCPU_EN		(0x1<<17)
+#define CEC_INT_ACPU_EN		(0x1<<16)
+#define CEC_PAD_EN		(0x1<<17)
+#define CEC_PAD_EN_MODE		(0x1<<16)
+
+//#define SELF_TEST		1
+
+#define CEC_RSEL(x)				(x & 0x1F)
+#define CEC_RPU_EN				(1<<5)
+#define IRQ_BY_CEC_RECEIVE_SPECIAL_CMD(x)	((x&0x1)<<8)
+
+#define AUDIO_ION_FLAG (ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC)
+
+static const struct of_device_id cec_ids[] __initconst = {
+	{ .compatible = "Realtek,rtk-cec0", },
+	{},
+	{ .compatible = "Realtek,rtk-cec1", },
+	{/*Sentinel*/},
+};
+
+static cec_device rtk_cec_controller[] = {
+	{ .id = 0, .name = "cec0", },
+	{ .id = 1, .name = "cec1", },
+};
+
+static const int cec_divider_table[] = {
+	256000000, 255, 25,
+	128000000, 200, 16,
+};
+
+#ifdef USE_ION_AUDIO_HEAP
+extern struct ion_device *rtk_phoenix_ion_device;
+
+struct ion_client *get_ion_client(const char *name)
+{
+	return ion_client_create(rtk_phoenix_ion_device, name);
+}
+#endif
+static int clk_nb_func(struct notifier_block *nb,
+			unsigned long action, void *data)
+{
+	struct rtk_cec *p_this = container_of(nb, struct rtk_cec, clk_nb);
+	unsigned int i, reg, table_num;
+	struct clk_notifier_data *d = data;
+
+	if (action == 2)
+		return 0;
+
+	reg = read_reg32(p_this->reg_base + CEC_CR0);
+	table_num = sizeof(cec_divider_table) / sizeof(int) / 3;
+	for (i = 0; i < table_num; i++) {
+		if (d->new_rate == cec_divider_table[i*3]) {
+			reg &= ~0x00FFFF00;
+			reg |= cec_divider_table[i*3+1] << 16
+				| cec_divider_table[i*3+2]<<8;
+		}
+	}
+	write_reg32(p_this->reg_base + CEC_CR0, reg);
+
+	return 0;
+}
+
+int _read_cec_rx_fifo(void __iomem *reg, cm_buff *cmb)
+{
+	unsigned long rx_fifo_data[4];
+	int len = read_reg32(reg + CEC_RXCR0) & 0x1F;
+	int i;
+
+	if (cmb_tailroom(cmb) >= len) {
+		while (len) {
+			unsigned char rx_len = len;
+
+			if (rx_len > 16)
+				rx_len = 16;
+
+			for (i = 0; i < rx_len; i += 4)
+				rx_fifo_data[i>>2] = __cpu_to_be32(
+						read_reg32(reg + CEC_RXDR1 + i));
+
+			memcpy(cmb->tail, (unsigned char *)rx_fifo_data, rx_len);
+			cmb_put(cmb, rx_len);
+
+			write_reg32(reg + CEC_TXDR0,
+				RX_SUB_CNT | FIFO_CNT(rx_len));
+
+			len -= rx_len;
+		}
+		return cmb->len;
+	} else {
+		pr_err("[cec] no more space to read data\n");
+		return -ENOMEM;
+	}
+}
+
+int _write_cec_tx_fifo(void __iomem *reg, cm_buff *cmb)
+{
+	int remain = 0x1F - (read_reg32(reg + CEC_TXCR0) & 0x1F);
+	int i;
+	int len = cmb->len;
+	unsigned int tx_fifo_data[4];
+
+	if (len > remain)
+		len = remain;
+
+	while (len) {
+		unsigned char tx_len = len;
+
+		if (tx_len > 16)
+			tx_len = 16;
+
+		memcpy(tx_fifo_data, cmb->data, tx_len);
+		cmb_pull(cmb, tx_len);
+
+		for (i = 0; i < tx_len; i += 4)
+			write_reg32(reg + CEC_TXDR1 + i,
+					__cpu_to_be32(tx_fifo_data[i>>2]));
+
+		write_reg32(reg + CEC_TXDR0, TX_ADD_CNT | FIFO_CNT(tx_len));
+		len -= tx_len;
+	}
+
+	return len;
+}
+
+static void rtk_cec_rx_reset(struct rtk_cec *p_this)
+{
+	write_reg32(p_this->reg_base + CEC_RXCR0, 0x4040);
+	write_reg32(p_this->reg_base + CEC_RXCR0, 0x0);
+	p_this->rcv.state = IDEL;
+}
+static void rtk_cec_tx_reset(struct rtk_cec *p_this)
+{
+	write_reg32(p_this->reg_base + CEC_TXCR0, 0x4040);
+	write_reg32(p_this->reg_base + CEC_TXCR0, 0x0);
+	p_this->xmit.state = IDEL;
+}
+
+void _cmb_cec_tx_complete(cm_buff *cmb)
+{
+	if (cmb == NULL) {
+		pr_err("[cec] cmb free, wake fail\n");
+		return;
+	}
+
+	if (cmb->flags & NONBLOCK) {
+		kfree_cmb(cmb);
+	} else {
+		if (cmb->status == WAIT_XMIT)
+			cmb->status = XMIT_ABORT;
+		wake_up(&cmb->wq);
+	}
+}
+
+void rtk_cec_tx_work(struct work_struct *work)
+{
+	struct rtk_cec *p_this =
+		container_of(work, struct rtk_cec, xmit.work.work);
+	struct rtk_cec_xmit *p_xmit = &p_this->xmit;
+	void __iomem *reg = p_this->reg_base;
+	unsigned char dest;
+	unsigned long flags;
+
+	spin_lock_irqsave(&p_this->lock, flags);
+
+	if (p_xmit->state == XMIT) {
+		if (!(read_reg32(reg + CEC_TXCR0) & TX_EN)) {
+			if ((read_reg32(reg + CEC_TXCR0) & TX_EOM) == 0)
+				p_xmit->cmb->status = XMIT_FAIL;
+			else
+				p_xmit->cmb->status = XMIT_OK;
+			write_reg32(reg + CEC_TXCR0,
+				read_reg32(reg + CEC_TXCR0));
+			goto exit_xmit_state;
+		}
+		if (read_reg32(reg + CEC_TXCR0) & TX_INT) {
+			if (p_xmit->cmb->len)
+				_write_cec_tx_fifo(reg, p_xmit->cmb);
+			if (p_xmit->cmb->len == 0)
+				write_reg32(reg + CEC_TXCR0,
+					read_reg32(reg + CEC_TXCR0) &
+					~TX_CONTINUOUS);
+			else
+				write_reg32(reg + CEC_TXCR0,
+					read_reg32(reg + CEC_TXCR0));
+		}
+		if (time_after(jiffies, p_xmit->timeout)) {
+			write_reg32(reg + CEC_TXCR0, 0);
+			p_xmit->cmb->status = XMIT_TIMEOUT;
+			goto exit_xmit_state;
+		} else {
+			goto exit_workque;
+		}
+	} else if (p_xmit->state == IDEL) {
+		goto cmdque_check;
+	} else {
+		goto exit_workque;
+	}
+exit_xmit_state:
+	cancel_delayed_work(&p_xmit->work);
+	_cmb_cec_tx_complete(p_xmit->cmb);
+	p_xmit->cmb   = NULL;
+	p_xmit->state = IDEL;
+
+cmdque_check:
+	if (p_xmit->enable) {
+		p_xmit->cmb = cmb_dequeue(&p_this->tx_queue);
+		if (!p_xmit->cmb)
+			goto exit_workque;
+
+		dest = (p_xmit->cmb->data[0] & 0xf);
+		cmb_pull(p_xmit->cmb, 1);
+		p_xmit->timeout = jiffies + TX_TIMEOUT;
+
+		rtk_cec_tx_reset(p_this);
+		_write_cec_tx_fifo(reg, p_xmit->cmb);
+
+		if (p_xmit->cmb->len == 0)
+			write_reg32(reg + CEC_TXCR0, TX_ADDR_EN |
+					TX_ADDR(p_this->standby_logical_addr) |
+					DEST_ADDR(dest) | TX_EN | TX_INT_EN);
+		else
+			write_reg32(reg + CEC_TXCR0,
+					TX_ADDR(p_this->standby_logical_addr) |
+					DEST_ADDR(dest) | TX_EN | TX_INT_EN |
+					TX_CONTINUOUS);
+		p_xmit->state = XMIT;
+		schedule_delayed_work(&p_xmit->work, TX_TIMEOUT+1);
+	}
+
+exit_workque:
+	spin_unlock_irqrestore(&p_this->lock, flags);
+}
+
+static void rtk_cec_tx_start(struct rtk_cec *p_this)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&p_this->lock, flags);
+
+	if (!p_this->xmit.enable) {
+		p_this->xmit.enable = 1;
+		p_this->xmit.state  = IDEL;
+		p_this->xmit.cmb    = NULL;
+
+		INIT_DELAYED_WORK(&p_this->xmit.work, rtk_cec_tx_work);
+		cmb_queue_head_init(&p_this->tx_queue);
+	}
+
+	spin_unlock_irqrestore(&p_this->lock, flags);
+}
+
+static void rtk_cec_tx_stop(struct rtk_cec *p_this)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&p_this->lock, flags);
+
+	if (p_this->xmit.enable) {
+		cancel_delayed_work(&p_this->xmit.work);
+		rtk_cec_tx_reset(p_this);
+
+		if (p_this->xmit.cmb)
+			_cmb_cec_tx_complete(p_this->xmit.cmb);
+
+/*		while((cmb = cmb_dequeue(&p_this->tx_queue)))
+			_cmb_cec_tx_complete(cmb);*/
+
+		p_this->xmit.enable = 0;
+		p_this->xmit.state  = IDEL;
+		p_this->xmit.cmb    = NULL;
+	}
+
+	spin_unlock_irqrestore(&p_this->lock, flags);
+}
+
+int rtk_cec_xmit_message(struct rtk_cec *p_this, cm_buff *cmb, unsigned long flags)
+{
+	struct device *dev = p_this->dev;
+	int ret = 0;
+	unsigned long flag;
+
+	if (!p_this->xmit.enable)
+		return -1;
+
+	cmb->flags  = flags;
+	cmb->status = WAIT_XMIT;
+
+	cmb_queue_tail(&p_this->tx_queue, cmb);
+
+	schedule_delayed_work(&p_this->xmit.work, 0);
+
+	if (!(cmb->flags & NONBLOCK)) {
+		wait_event_timeout(cmb->wq, cmb->status != WAIT_XMIT,
+							TX_TIMEOUT + 50);
+
+		switch (cmb->status) {
+		case XMIT_OK:
+			dev_info(dev, "xmit message success\n");
+			break;
+		case XMIT_ABORT:
+			dev_info(dev, "xmit message abort\n");
+			break;
+		case XMIT_FAIL:
+			dev_info(dev, "xmit message abort\n");
+			break;
+		default:
+		case XMIT_TIMEOUT:
+		case WAIT_XMIT:
+			dev_info(dev, "xmit message timeout\n");
+			break;
+		}
+
+		spin_lock_irqsave(&p_this->lock, flag);
+		ret = (cmb->status == XMIT_OK) ? 0 : -1;
+		kfree_cmb(cmb);
+		spin_unlock_irqrestore(&p_this->lock, flag);
+	}
+	return ret;
+}
+
+void rtk_cec_standby_message_handler(struct rtk_cec *p_this,
+				unsigned char init,
+				unsigned char dest,
+				unsigned char opcode,
+				unsigned char *param,
+				unsigned char len)
+{
+	cm_buff *cmb = NULL;
+	unsigned char dev_type_map[15] = {
+		CEC_DEVICE_TV,
+		CEC_DEVICE_RECORDING_DEVICE,
+		CEC_DEVICE_RECORDING_DEVICE,
+		CEC_DEVICE_TUNER,
+		CEC_DEVICE_PLAYBACK_DEVICE,
+		CEC_DEVICE_AUDIO_SYSTEM,
+		CEC_DEVICE_TUNER,
+		CEC_DEVICE_TUNER,
+		CEC_DEVICE_PLAYBACK_DEVICE,
+		CEC_DEVICE_RECORDING_DEVICE,
+		CEC_DEVICE_TUNER,
+		CEC_DEVICE_PLAYBACK_DEVICE,
+		CEC_DEVICE_RESERVED,
+		CEC_DEVICE_RESERVED,
+		CEC_DEVICE_TV
+	};
+
+	switch (opcode) {
+	case CEC_MSG_GIVE_DEVICE_POWER_STATUS:
+		if ((p_this->standby_config & STANBY_RESPONSE_GIVE_POWER_STATUS)
+			&& len == 0 && init != 0xF) {
+#ifdef CEC_OPCODE_COMPARE_ENABLE
+			if (PWR_STS_COMP_EN())
+				break;
+#endif
+			cmb = alloc_cmb(3);
+			if (cmb) {
+				cmb->data[0] = (dest<<4) | init;
+				cmb->data[1] = CEC_MSG_REPORT_POWER_STATUS;
+				cmb->data[2] = CEC_POWER_STATUS_STANDBY;
+				cmb_put(cmb, 3);
+			}
+		}
+		break;
+	case CEC_MSG_GIVE_PHYSICAL_ADDRESS:
+		if ((p_this->standby_config & STANBY_WAKEUP_BY_SET_STREAM_PATH)
+			&& len == 0 && dest != 0xF) {
+
+#ifdef CEC_OPCODE_COMPARE_ENABLE
+			if (PHY_ADDR_COMP_EN())
+				break;
+#endif
+			cmb = alloc_cmb(5);
+			if (cmb) {
+				cmb->data[0] = (dest<<4) | 0xF;
+				cmb->data[1] = CEC_MSG_REPORT_PHYSICAL_ADDRESS;
+				cmb->data[2] = (p_this->standby_physical_addr >> 8) & 0xFF;
+				cmb->data[3] = (p_this->standby_physical_addr) & 0xFF;
+				cmb->data[4] = dev_type_map[dest];
+				cmb_put(cmb, 5);
+			}
+		}
+		break;
+	case CEC_MSG_STANDBY:
+		break;
+
+	default:
+		if (init != 0xF && dest != 0xF) {
+			cmb = alloc_cmb(4);
+			if (cmb) {
+				cmb->data[0] = (dest<<4) | init;
+				cmb->data[1] = CEC_MSG_FEATURE_ABORT;
+				cmb->data[2] = opcode;
+				cmb->data[3] = CEC_ABORT_NOT_IN_CORECT_MODE;
+				cmb_put(cmb, 4);
+			}
+		}
+	}
+	if (cmb)
+		rtk_cec_xmit_message(p_this, cmb, NONBLOCK);
+}
+
+void rtk_cec_rx_work(struct work_struct *work)
+{
+	struct rtk_cec *p_this =
+			container_of(work, struct rtk_cec, rcv.work.work);
+	struct rtk_cec_rcv *p_rcv = &p_this->rcv;
+	struct device *dev = p_this->dev;
+	void __iomem *reg = p_this->reg_base;
+	unsigned long flags;
+	unsigned long rx_event = read_reg32(p_this->reg_base + CEC_RXCR0);
+
+	spin_lock_irqsave(&p_this->lock, flags);
+
+	if (!p_rcv->enable) {
+		if (p_rcv->state == RCV) {
+			dev_info(dev, "%s force stop\n", __func__);
+			write_reg32(p_this->reg_base + CEC_RXCR0, 0);
+			kfree_cmb(p_rcv->cmb);
+			p_rcv->cmb   = NULL;
+			p_rcv->state = IDEL;
+		}
+		rtk_cec_rx_reset(p_this);
+		goto exit_workque;
+	}
+
+	if (p_rcv->state != RCV)
+		goto exit_rcv_state;
+
+#ifdef CEC_OPCODE_COMPARE_ENABLE
+	if ((rx_event & RX_EN) && (!IS_OPCODE_COMP_EN())) {
+#else
+	if (rx_event & RX_EN) {
+#endif
+		if (rx_event & RX_INT) {
+			if (_read_cec_rx_fifo(reg, p_rcv->cmb) < 0) {
+				write_reg32(reg + CEC_RXCR0, 0);
+				p_rcv->state = IDEL;
+			}
+			write_reg32(reg + CEC_RXCR0, RX_INT);
+		}
+		goto exit_rcv_state;
+	}
+
+	if ((rx_event & RX_EOM) && _read_cec_rx_fifo(reg, p_rcv->cmb)) {
+		if (rx_event & BROADCAST_ADDR)
+			*cmb_push(p_rcv->cmb, 1) =
+			((rx_event & INIT_ADDR_MASK)>>INIT_ADDR_SHIFT)<<4 |
+			0xF;
+		else
+			*cmb_push(p_rcv->cmb, 1) =
+			((rx_event & INIT_ADDR_MASK)>>INIT_ADDR_SHIFT)<<4 |
+			(read_reg32(reg + CEC_CR0) & LOGICAL_ADDR_MASK)>>LOGICAL_ADDR_SHIFT;
+	}
+	if (p_this->status.standby_mode) {
+		rtk_cec_standby_message_handler(
+					p_this,
+					p_rcv->cmb->data[0] >> 4,
+					p_rcv->cmb->data[0] & 0xF,
+					p_rcv->cmb->data[1],
+					&p_rcv->cmb->data[2],
+					p_rcv->cmb->len - 2);
+	} else {
+		cmb_queue_tail(&p_this->rx_queue, p_rcv->cmb);
+		p_rcv->cmb = NULL;
+		wake_up_interruptible(&p_this->rcv.wq);
+	}
+	p_rcv->state = IDEL;
+
+exit_rcv_state:
+	if (p_rcv->state != IDEL)
+		goto exit_workque;
+
+	if (!p_rcv->cmb) {
+		if (cmb_queue_len(&p_this->rx_free_queue))
+			p_rcv->cmb = cmb_dequeue(&p_this->rx_free_queue);
+		else
+			p_rcv->cmb = cmb_dequeue(&p_this->rx_queue);
+
+		if (p_rcv->cmb == NULL)
+			goto exit_workque;
+	}
+	cmb_purge(p_rcv->cmb);
+	cmb_reserve(p_rcv->cmb, 1);
+
+	rtk_cec_rx_reset(p_this);
+	write_reg32(reg + CEC_RXCR0, RX_EN | RX_INT_EN);
+	p_rcv->state = RCV;
+
+exit_workque:
+	spin_unlock_irqrestore(&p_this->lock, flags);
+}
+
+static void rtk_cec_rx_start(struct rtk_cec *p_this)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&p_this->lock, flags);
+
+	if (!p_this->rcv.enable) {
+		p_this->rcv.enable = 1;
+		p_this->rcv.state  = IDEL;
+		p_this->rcv.cmb    = NULL;
+
+		INIT_DELAYED_WORK(&p_this->rcv.work, rtk_cec_rx_work);
+
+		schedule_delayed_work(&p_this->rcv.work, 0);
+	}
+
+	spin_unlock_irqrestore(&p_this->lock, flags);
+}
+
+static void rtk_cec_rx_stop(struct rtk_cec *p_this)
+{
+	cm_buff *cmb;
+	unsigned long flags;
+
+	spin_lock_irqsave(&p_this->lock, flags);
+
+	if (p_this->rcv.enable) {
+		rtk_cec_rx_reset(p_this);
+
+		if (p_this->rcv.cmb) {
+			cmb_purge(p_this->rcv.cmb);
+			cmb_reserve(p_this->rcv.cmb, 1);
+			cmb_queue_tail(&p_this->rx_free_queue, p_this->rcv.cmb);
+		}
+
+		while ((cmb = cmb_dequeue(&p_this->rx_queue))) {
+			cmb_purge(cmb);
+			cmb_reserve(cmb, 1);
+			cmb_queue_tail(&p_this->rx_free_queue, cmb);
+		}
+		p_this->rcv.enable = 0;
+		p_this->rcv.state  = IDEL;
+		p_this->rcv.cmb    = NULL;
+
+		wake_up_interruptible(&p_this->rcv.wq);
+	}
+	spin_unlock_irqrestore(&p_this->lock, flags);
+}
+
+static irqreturn_t rtk_cec_isr(int this_irq, void *dev_id)
+{
+	struct rtk_cec *p_this;
+	int i, dev_num;
+	irqreturn_t ret = IRQ_NONE;
+
+	dev_num = ARRAY_SIZE(rtk_cec_controller);
+	for (i = 0; i < dev_num; i++) {
+		if (cec_device_pthis[i] != 0) {
+			p_this = (struct rtk_cec *)cec_device_pthis[i];
+
+			if (read_reg32(p_this->reg_base + CEC_TXCR0) & TX_INT) {
+				rtk_cec_tx_work(&p_this->xmit.work.work);
+				ret = IRQ_HANDLED;
+			}
+
+			if (read_reg32(p_this->reg_base + CEC_RXCR0) & RX_INT) {
+				rtk_cec_rx_work(&p_this->rcv.work.work);
+				ret = IRQ_HANDLED;
+			}
+		}
+	}
+	return ret;
+}
+
+int rtk_cec_init(struct rtk_cec *p_this)
+{
+	cm_buff *cmb = NULL;
+	void __iomem *reg = p_this->reg_base;
+	void __iomem *wrapper = p_this->wrapper_reg;
+	int i;
+
+	if (p_this->status.init)
+		return 0;
+	rtk_cec_rx_reset(p_this);
+	rtk_cec_tx_reset(p_this);
+
+	write_reg32(reg + CEC_TXTCR1, TX_DATA_LOW(0x1A) |
+					TX_DATA_01(0x23) |
+					TX_DATA_HIGH(0x22));
+	write_reg32(reg + CEC_TXTCR0, TX_START_LOW(0x93) | TX_START_HIGH(0x20));
+	write_reg32(reg + CEC_RXTCR0, RX_START_LOW(0x8C) |
+					RX_START_PERIOD(0xC1) |
+					RX_DATA_SAMPLE(0x2A) |
+					RX_DATA_PERIOD(0x52));
+	if(p_this->chip_id == CHIP_ID_RTD1295 ||
+		p_this->chip_id == CHIP_ID_RTD1296) {
+		write_reg32(reg + CEC_CR0, CEC_MODE(1) |
+					LOGICAL_ADDR(0x4) |
+					TIMER_DIV(25) |
+					PRE_DIV(255) |
+					UNREG_ACK_EN);
+	} else {
+		write_reg32(reg + CEC_CR0, CEC_MODE(1) |
+					LOGICAL_ADDR(0x4) |
+					TIMER_DIV(20) |
+					PRE_DIV(33) |
+					UNREG_ACK_EN);
+	}
+	write_reg32(reg + CEC_RTCR0, CEC_PAD_EN | CEC_PAD_EN_MODE | RETRY_NO(2));
+	write_reg32(reg + CEC_RXCR0, RX_EN | RX_INT_EN);
+#ifdef CEC_OPCODE_COMPARE_ENABLE
+	write_reg32(reg + GDI_CEC_OPCODE_ENABLE, 0);
+#endif
+	spin_lock_init(&p_this->lock);
+
+	p_this->xmit.state      = IDEL;
+	p_this->xmit.cmb        = NULL;
+	p_this->xmit.timeout    = 0;
+
+	p_this->rcv.state       = IDEL;
+	p_this->rcv.cmb         = NULL;
+	init_waitqueue_head(&p_this->rcv.wq);
+
+	cmb_queue_head_init(&p_this->tx_queue);
+	cmb_queue_head_init(&p_this->rx_queue);
+	cmb_queue_head_init(&p_this->rx_free_queue);
+
+	for (i = 0; i < RX_RING_LENGTH; i++) {
+		cmb = alloc_cmb(RX_BUFFER_SIZE);
+		if (cmb)
+			cmb_queue_tail(&p_this->rx_free_queue, cmb);
+	}
+
+	if (request_irq(p_this->irq_num, rtk_cec_isr,
+			IRQF_SHARED, "RTK CEC", p_this) < 0) {
+		return -EIO;
+	}
+	if (wrapper != NULL)
+		write_reg32(wrapper + CBUS_WRAPPER,
+				read_reg32(wrapper + CBUS_WRAPPER) |
+				CEC_INT_SCPU_EN |
+				CEC_INT_ACPU_EN);
+	write_reg32(reg + GDI_POWER_SAVING_MODE,
+			IRQ_BY_CEC_RECEIVE_SPECIAL_CMD(1) |
+			CEC_RPU_EN | CEC_RSEL(0x17));
+	p_this->status.init = 1;
+
+	return 0;
+}
+
+int rtk_cec_RPC_TOAGENT_PrivateInfo(struct rtk_cec *p_this, char *str,
+							unsigned long para)
+{
+#ifdef USE_ION_AUDIO_HEAP
+	struct AUDIO_RPC_PRIVATEINFO_PARAMETERS *rpc = NULL;
+	struct device *dev = p_this->dev;
+	struct ion_handle *handle = NULL;
+	struct ion_client *client = p_this->rpc_ion_client;
+	unsigned int RPC_ret;
+	ion_phys_addr_t dat = {0};
+	size_t len;
+	int ret = -1;
+	unsigned long offset;
+
+	if (p_this->chip_id == CHIP_ID_RTD1619)
+		return 0;
+
+	handle = ion_alloc(client, 4096, 1024,
+				RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+				AUDIO_ION_FLAG);
+	if (IS_ERR(handle)) {
+		dev_err(dev, "%s ion_alloc fail\n", __func__);
+		goto exit;
+	}
+	if (ion_phys(client, handle, &dat, &len) != 0) {
+		dev_err(dev, "%s ion_phys fail\n", __func__);
+		goto exit;
+	}
+	rpc = ion_map_kernel(client, handle);
+	if (!rpc)
+		goto exit;
+
+	offset = get_rpc_alignment_offset(sizeof(*rpc));
+	memset(rpc, 0, sizeof(*rpc));
+
+	rpc->type = htonl(ENUM_PRIVATEINFO_AUDIO_SET_CEC_PARAMETERS);
+	rpc->privateInfo[0] = htonl(p_this->standby_config);
+	rpc->privateInfo[1] = htonl(p_this->standby_logical_addr);
+	rpc->privateInfo[2] = htonl(p_this->standby_physical_addr);
+	rpc->privateInfo[3] = htonl(p_this->standby_cec_version);
+	rpc->privateInfo[4] = htonl(p_this->standby_vendor_id);
+	rpc->privateInfo[5] = htonl(p_this->standby_rx_mask);
+	rpc->privateInfo[6] = htonl(p_this->standby_cec_wakeup_off);
+
+	if (send_rpc_command(RPC_AUDIO,
+		ENUM_KERNEL_RPC_PRIVATEINFO,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + offset),
+		&RPC_ret)) {
+		dev_err(dev, "%s RPC fail\n", __func__);
+		goto exit;
+	}
+	ret = 0;
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(client, handle);
+		ion_free(client, handle);
+	}
+	return ret;
+#endif
+	return 0;
+}
+
+int rtk_cec_set_mode(struct rtk_cec *p_this, unsigned char mode)
+{
+	struct device *dev = p_this->dev;
+	void __iomem *reg = p_this->reg_base;
+
+	switch (mode) {
+	case CEC_MODE_OFF:
+		dev_info(dev, "mode : OFF\n");
+		write_reg32(reg + CEC_CR0,
+				(read_reg32(reg + CEC_CR0) &
+				~CTRL_MASK1) |
+				CEC_MODE(0) |
+				LOGICAL_ADDR(0xF));
+		p_this->status.enable = 0;
+		p_this->status.standby_mode = 0;
+		rtk_cec_rx_stop(p_this);
+		rtk_cec_tx_stop(p_this);
+		break;
+
+	case CEC_MODE_ON:
+		dev_info(dev, "mode : ON\n");
+		write_reg32(reg + CEC_CR0,
+				(read_reg32(reg + CEC_CR0) & ~CTRL_MASK1) |
+				CEC_MODE(1));
+		write_reg32(reg + CEC_RXCR0, RX_EN | RX_INT_EN);
+#ifdef CEC_OPCODE_COMPARE_ENABLE
+		write_reg32(reg + GDI_CEC_OPCODE_ENABLE, 0);
+#endif
+		rtk_cec_rx_start(p_this);
+		rtk_cec_tx_start(p_this);
+		p_this->status.enable = 1;
+		p_this->status.standby_mode = 0;
+		break;
+
+	case CEC_MODE_STANDBY:
+		dev_info(dev, "mode : standby (la=%x)\n",
+				p_this->standby_logical_addr);
+		write_reg32(reg + CEC_CR0,
+				(read_reg32(reg + CEC_CR0) & ~CTRL_MASK1) |
+				CEC_MODE(1) |
+				LOGICAL_ADDR(p_this->standby_logical_addr));
+		rtk_cec_rx_start(p_this);
+		rtk_cec_tx_start(p_this);
+		p_this->status.enable = 1;
+		p_this->status.standby_mode = 1;
+		break;
+	}
+	return 0;
+}
+
+int rtk_cec_enable(struct rtk_cec *p_this, unsigned char on_off)
+{
+	if (on_off) {
+		rtk_cec_set_mode(p_this, CEC_MODE_ON);
+	} else {
+		if (p_this->standby_config == 0 ||
+				p_this->standby_logical_addr >= 0xF ||
+				p_this->standby_physical_addr == 0xFFFF)
+			rtk_cec_set_mode(p_this, CEC_MODE_OFF);
+		else
+			rtk_cec_set_mode(p_this, CEC_MODE_STANDBY);
+	}
+	return 0;
+}
+
+int rtk_cec_set_rx_mask(struct rtk_cec *p_this, unsigned short rx_mask)
+{
+	struct device *dev = p_this->dev;
+	void __iomem *reg = p_this->reg_base;
+	unsigned char log_addr = 0xf;
+	int i;
+
+	for (i = 0; i < 16; i++) {
+		if (TEST_BIT(rx_mask, i)) {
+			log_addr = i;
+			break;
+		}
+	}
+
+	if (rx_mask & ~(BIT_MASK(15) | BIT_MASK(log_addr))) {
+		dev_info(dev,
+			"multi addr specified %04x, only address %x are valid\n"
+			, rx_mask, log_addr);
+	}
+
+	write_reg32(reg + CEC_CR0, (read_reg32(reg + CEC_CR0) &
+			~LOGICAL_ADDR_MASK) | LOGICAL_ADDR(log_addr));
+
+	if (log_addr != 0xF) {
+		p_this->standby_logical_addr = log_addr;
+		rtk_cec_RPC_TOAGENT_PrivateInfo(p_this, "logical address",
+						p_this->standby_logical_addr);
+	}
+	return 0;
+}
+
+int rtk_cec_set_physical_addr(struct rtk_cec *p_this, unsigned short phy_addr)
+{
+	dev_info(p_this->dev, "physcial address = %04x\n", phy_addr);
+
+	if (phy_addr != 0xffff)
+		p_this->standby_physical_addr = phy_addr;
+
+	rtk_cec_RPC_TOAGENT_PrivateInfo(p_this, "physical addr",
+					(unsigned long)phy_addr);
+	return 0;
+}
+
+int rtk_cec_get_physical_addr(struct rtk_cec *p_this)
+{
+	return p_this->standby_physical_addr;
+}
+
+int rtk_cec_set_cec_version(struct rtk_cec *p_this, unsigned char version)
+{
+	p_this->standby_cec_version = version;
+	rtk_cec_RPC_TOAGENT_PrivateInfo(p_this, "cec version",
+					(unsigned long)version);
+	return 0;
+}
+
+int rtk_cec_set_device_vendor_id(struct rtk_cec *p_this, unsigned long vendor_id)
+{
+	p_this->standby_vendor_id = vendor_id;
+	rtk_cec_RPC_TOAGENT_PrivateInfo(p_this, "vendor id", vendor_id);
+	return 0;
+}
+
+int rtk_cec_set_stanby_mode(struct rtk_cec *p_this, unsigned long mode)
+{
+	p_this->standby_config = mode;
+	rtk_cec_RPC_TOAGENT_PrivateInfo(p_this, "standy mode", mode);
+	return 0;
+}
+
+int rtk_cec_set_retry_num(struct rtk_cec *p_this, unsigned long	num)
+{
+	void __iomem *reg = p_this->reg_base;
+
+	write_reg32(reg + CEC_RTCR0, ((read_reg32(reg + CEC_RTCR0) &
+					~RETRY_NO_MASK) | RETRY_NO(num)));
+	return 0;
+}
+
+static cm_buff *rtk_cec_read_message(struct rtk_cec *p_this, unsigned char flags)
+{
+	p_this->status.exit = 0;
+	if (!(flags & NONBLOCK) && p_this->status.enable &&
+				!cmb_queue_len(&p_this->rx_queue)) {
+		if (wait_event_interruptible(p_this->rcv.wq, !p_this->status.enable || p_this->status.exit
+					|| cmb_queue_len(&p_this->rx_queue)))
+			return NULL;
+	}
+	if (p_this->status.exit == 1) {
+		p_this->status.exit = 0;
+		return NULL;
+	}
+	if (p_this->status.enable) {
+		cm_buff *cmb = cmb_dequeue(&p_this->rx_queue);
+
+		if (cmb) {
+			cm_buff *cmb1 = alloc_cmb(RX_BUFFER_SIZE);
+			if (cmb1)
+				cmb_queue_tail(&p_this->rx_free_queue, cmb1);
+			else
+				dev_err(p_this->dev, "alloc_cmb fail\n");
+			dev_info(p_this->dev, "got msg %p\n", cmb);
+			return cmb;
+		}
+	}
+
+	return NULL;
+}
+
+void rtk_cec_uninit(struct rtk_cec *p_this)
+{
+	struct device *dev = p_this->dev;
+	void __iomem *reg = p_this->reg_base;
+
+	dev_info(dev, "%s\n", __func__);
+
+	free_irq(p_this->irq_num, p_this);
+	write_reg32(reg + CEC_CR0, read_reg32(reg + CEC_CR0) & ~CEC_MODE_MASK);
+	write_reg32(reg + CEC_RXCR0, 0);
+	write_reg32(reg + CEC_TXCR0, 0);
+	rtk_cec_enable(p_this, 0);
+	p_this->status.init = 0;
+}
+
+int rtk_cec_suspend(struct rtk_cec *p_this)
+{
+	struct device *dev = p_this->dev;
+	void __iomem *reg = p_this->reg_base;
+	void __iomem *wrapper = p_this->wrapper_reg;
+
+	if (!p_this->status.enable) {
+		dev_info(dev, "function is disable\n");
+		p_this->standby_cec_wakeup_off = 1;
+		rtk_cec_RPC_TOAGENT_PrivateInfo(p_this, "wakeup off",
+					p_this->standby_cec_wakeup_off);
+		return 0;
+	}
+
+	p_this->standby_cec_wakeup_off = 0;
+	rtk_cec_RPC_TOAGENT_PrivateInfo(p_this, "wakeup off",
+					p_this->standby_cec_wakeup_off);
+
+	dev_info(dev, "rtk cec suspended (la=%x, pa=%04x, standby_mode=%ld)",
+			p_this->standby_logical_addr,
+			p_this->standby_physical_addr,
+			p_this->standby_config);
+
+	rtk_cec_set_mode(p_this, CEC_MODE_OFF);
+
+	disable_irq(p_this->irq_num);
+
+	if (p_this->standby_config && p_this->standby_logical_addr < 0xF &&
+				p_this->standby_physical_addr != 0xFFFF) {
+		p_this->status.enable = 1;
+		p_this->status.standby_mode = 1;
+
+		write_reg32(reg + CEC_CR0,
+			(read_reg32(reg + CEC_CR0) & ~(LOGICAL_ADDR(0xF))) |
+			CEC_MODE(1) |
+			LOGICAL_ADDR(p_this->standby_logical_addr));
+		write_reg32(reg + CEC_RXCR0,  RX_RST);
+		write_reg32(reg + CEC_RXCR0,  0);
+		write_reg32(reg + CEC_TXCR0,  TX_RST);
+		write_reg32(reg + CEC_TXCR0,  0);
+
+		write_reg32(reg + CEC_RXCR0,  RX_EN | RX_INT_EN | RX_INT);
+		write_reg32(reg + GDI_POWER_SAVING_MODE,
+				IRQ_BY_CEC_RECEIVE_SPECIAL_CMD(1) |
+				CEC_RPU_EN | CEC_RSEL(0x17));
+		if (wrapper != NULL)
+			write_reg32(wrapper + CBUS_WRAPPER,
+				(read_reg32(wrapper + CBUS_WRAPPER) & ~CEC_INT_SCPU_EN));
+		dev_info(dev, "standby enabled");
+	}
+	return 0;
+}
+
+int rtk_cec_resume(struct rtk_cec *p_this)
+{
+	void __iomem *reg = p_this->reg_base;
+	void __iomem *wrapper = p_this->wrapper_reg;
+	unsigned int val;
+
+	/* clear tx interrupt */
+	val = read_reg32(reg + CEC_TXCR0);
+	if (val & TX_INT)
+		write_reg32(reg + CEC_TXCR0, val);
+
+	write_reg32(reg + CEC_TXTCR1, TX_DATA_LOW(0x1A) |
+					TX_DATA_01(0x23) |
+					TX_DATA_HIGH(0x22));
+	write_reg32(reg + CEC_TXTCR0, TX_START_LOW(0x93) | TX_START_HIGH(0x20));
+	write_reg32(reg + CEC_RXTCR0, RX_START_LOW(0x8C) |
+					RX_START_PERIOD(0xC1) |
+					RX_DATA_SAMPLE(0x2A) |
+					RX_DATA_PERIOD(0x52));
+	if(p_this->chip_id == CHIP_ID_RTD1295 ||
+		p_this->chip_id == CHIP_ID_RTD1296) {
+		write_reg32(reg + CEC_CR0, CEC_MODE(1) |
+					LOGICAL_ADDR(p_this->standby_logical_addr) |
+					TIMER_DIV(25) |
+					PRE_DIV(255) |
+					UNREG_ACK_EN);
+	} else {
+		write_reg32(reg + CEC_CR0, CEC_MODE(1) |
+					LOGICAL_ADDR(p_this->standby_logical_addr) |
+					TIMER_DIV(20) |
+					PRE_DIV(33) |
+					UNREG_ACK_EN);
+	}
+	val = read_reg32(reg + CEC_CR0);
+	pr_info("resume cec control register = 0x%x, logical addr = %d\n", val, p_this->standby_logical_addr);
+	write_reg32(reg + CEC_RTCR0, CEC_PAD_EN | CEC_PAD_EN_MODE | RETRY_NO(2));
+	write_reg32(reg + CEC_RXCR0, RX_EN | RX_INT_EN);
+
+	rtk_cec_rx_reset(p_this);
+	rtk_cec_tx_reset(p_this);
+
+	if (p_this->standby_config && p_this->standby_logical_addr < 0xF &&
+					p_this->standby_physical_addr != 0xFFFF)
+		rtk_cec_set_mode(p_this, CEC_MODE_ON);
+	else
+		rtk_cec_set_mode(p_this, CEC_MODE_OFF);
+
+	if (p_this->status.enable)
+		enable_irq(p_this->irq_num);
+	if (wrapper != NULL)
+		write_reg32(wrapper + CBUS_WRAPPER,
+				read_reg32(wrapper + CBUS_WRAPPER) |
+				CEC_INT_SCPU_EN |
+				CEC_INT_ACPU_EN);
+	return 0;
+}
+
+static int ops_probe(cec_device *dev)
+{
+	struct device_node __maybe_unused *cec_node;
+	struct rtk_cec *m_cec;
+	struct clk *clk;
+	struct reset_control *rstc;
+
+	m_cec = kzalloc(sizeof(*m_cec), GFP_KERNEL);
+	cec_node = of_find_matching_node(NULL, &cec_ids[dev->id*2]);
+	if (!cec_node)
+		goto cec_probe_fail;
+	if (!of_device_is_available(cec_node))
+		goto cec_probe_fail;
+
+	m_cec->dev = &dev->dev;
+	cec_device_en[dev->id] = 1;
+	cec_device_pthis[dev->id] = 0;
+
+#ifdef USE_ION_AUDIO_HEAP
+	m_cec->rpc_ion_client = ion_client_create(
+					rtk_phoenix_ion_device, "CECDriver");
+#else
+	m_cec->rpc_ion_client = NULL;
+#endif
+	m_cec->reg_base = of_iomap(cec_node, 0);
+	m_cec->iso_base = of_iomap(cec_node, 1);
+	m_cec->wrapper_reg = of_iomap(cec_node, 2);
+
+	m_cec->chip_id = get_rtd_chip_id();
+	if (m_cec->chip_id == CHIP_ID_RTD1295 ||
+		m_cec->chip_id == CHIP_ID_RTD1296) {
+		clk = of_clk_get_by_name(cec_node, "sys");
+		m_cec->clk_nb.notifier_call = clk_nb_func;
+		clk_notifier_register(clk, &m_cec->clk_nb);
+	}
+
+	if (m_cec->wrapper_reg == NULL && m_cec->chip_id != CHIP_ID_RTD1195)
+		goto cec_probe_fail;
+
+	clk = of_clk_get_by_name(cec_node, "cbus_osc");
+	if (!IS_ERR(clk))
+		clk_prepare_enable(clk);
+	clk = of_clk_get_by_name(cec_node, "cbus_sys");
+	if (!IS_ERR(clk))
+		clk_prepare_enable(clk);
+
+	rstc = __of_reset_control_get(cec_node, "cbus", 0, 1);
+	if (!IS_ERR(rstc))
+		reset_control_deassert(rstc);
+
+	if (dev->id == 0) {
+		m_cec->clk = of_clk_get_by_name(cec_node, "cbustx_sys");
+		m_cec->rstc = __of_reset_control_get(cec_node, "cbustx", 0, 1);
+	} else {
+		m_cec->clk = of_clk_get_by_name(cec_node, "cbusrx_sys");
+		m_cec->rstc = __of_reset_control_get(cec_node, "cbusrx", 0, 1);
+	}
+	if (!IS_ERR(m_cec->rstc))
+		reset_control_deassert(m_cec->rstc);
+	if (!IS_ERR(m_cec->clk))
+		clk_prepare_enable(m_cec->clk);
+
+	m_cec->irq_num = irq_of_parse_and_map(cec_node, 0);
+	if (!m_cec->irq_num)
+		goto cec_probe_fail;
+
+	if (rtk_cec_init(m_cec) == 0) {
+		cec_set_drvdata(dev, m_cec);
+		cec_device_pthis[dev->id] = (int *)m_cec;
+	}
+#if defined(SELF_TEST) && SELF_TEST
+	pr_info("%s self test start\n", __func__);
+	rtk_cec_enable(m_cec, 1);
+	rtk_cec_set_rx_mask(m_cec, 0x8010);
+#endif
+	dev_info(&dev->dev, "probe success\n");
+	return 0;
+
+cec_probe_fail:
+	dev_err(&dev->dev, "probe fail\n");
+	kfree(m_cec);
+	return -1;
+}
+
+static void ops_remove(cec_device *dev)
+{
+	rtk_cec_uninit((struct rtk_cec *)cec_get_drvdata(dev));
+}
+
+static int ops_enable(cec_device *dev, unsigned char on_off)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	dev_info(p_this->dev, "%s : %02x\n", __func__, on_off);
+	if ((on_off & 0xf0) == 0) {
+		if (on_off & 0x0f) {
+			p_this->standby_config = STANBY_RESPONSE_GIVE_POWER_STATUS
+					| STANBY_RESPONSE_GET_CEC_VERISON;
+			p_this->standby_logical_addr	= 0x0;
+			p_this->standby_physical_addr	= 0x0000;
+		} else {
+			p_this->standby_config		= 0;
+			p_this->standby_logical_addr	= 0xF;
+			p_this->standby_physical_addr	= 0xFFFF;
+		}
+	}
+	return rtk_cec_enable(p_this, (on_off & 0x0f));
+}
+
+static int ops_set_rx_mask(cec_device *dev, unsigned short rx_mask)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_set_rx_mask(p_this, rx_mask);
+}
+
+static int ops_set_physical_addr(cec_device *dev, unsigned short phy_addr)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_set_physical_addr(p_this, phy_addr);
+}
+
+static int ops_get_physical_addr(cec_device *dev)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_get_physical_addr(p_this);
+}
+
+static int ops_set_cev_version(cec_device *dev, unsigned char version)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_set_cec_version(p_this, version);
+}
+
+static int ops_set_device_vendor_id(cec_device *dev, unsigned long vendor_id)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_set_device_vendor_id(p_this, vendor_id);
+}
+
+static int ops_xmit(cec_device *dev, cm_buff *cmb, unsigned long flags)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_xmit_message(p_this, cmb, flags);
+}
+
+static cm_buff *ops_read(cec_device *dev, unsigned long flags)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_read_message(p_this, flags);
+}
+
+static int ops_set_stanby_mode(cec_device *dev, unsigned long flags)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_set_stanby_mode(p_this, flags);
+}
+
+static int ops_set_retry_num(cec_device *dev, unsigned long num)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_set_retry_num(p_this, num);
+}
+
+static int ops_suspend(cec_device *dev)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_suspend(p_this);
+}
+
+static int ops_resume(cec_device *dev)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	return rtk_cec_resume(p_this);
+}
+
+static int ops_read_exit(cec_device *dev)
+{
+	struct rtk_cec *p_this = cec_get_drvdata(dev);
+
+	p_this->status.exit = 1;
+	wake_up_interruptible(&p_this->rcv.wq);
+
+	return 0;
+}
+
+static cec_driver rtk_cec_driver = {
+	.name			= "cec",
+	.probe			= ops_probe,
+	.remove			= ops_remove,
+	.suspend		= ops_suspend,
+	.resume			= ops_resume,
+	.enable			= ops_enable,
+	.xmit			= ops_xmit,
+	.read			= ops_read,
+	.set_rx_mask		= ops_set_rx_mask,
+	.set_physical_addr	= ops_set_physical_addr,
+	.set_cec_version	= ops_set_cev_version,
+	.set_device_vendor_id	= ops_set_device_vendor_id,
+	.set_stanby_mode	= ops_set_stanby_mode,
+	.set_retry_num		= ops_set_retry_num,
+	.get_physical_addr	= ops_get_physical_addr,
+	.read_exit		= ops_read_exit,
+};
+
+static int __init rtk_cec_module_init(void)
+{
+	int i, dev_num;
+
+	if (register_cec_driver(&rtk_cec_driver) != 0)
+		return -EFAULT;
+
+	dev_num = ARRAY_SIZE(rtk_cec_controller);
+	if (dev_num > 0) {
+		for (i = 0; i < dev_num; i++)
+			register_cec_device(&rtk_cec_controller[i]);
+	}
+	return 0;
+}
+
+static void __exit rtk_cec_module_exit(void)
+{
+	unregister_cec_driver(&rtk_cec_driver);
+}
+
+module_init(rtk_cec_module_init);
+module_exit(rtk_cec_module_exit);
diff --git a/drivers/media/platform/rtk_cec/adapter/rtk_cec.h b/drivers/media/platform/rtk_cec/adapter/rtk_cec.h
new file mode 100644
index 00000000..df63e83
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/adapter/rtk_cec.h
@@ -0,0 +1,288 @@
+/*
+ *  Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __RTK_CEC_H__
+#define __RTK_CEC_H__
+
+#include <linux/wait.h>
+#include <linux/timer.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+#include "../cm_buff.h"
+
+struct rtk_cec_xmit {
+	unsigned char enable : 1;
+	unsigned char state : 7;
+	cm_buff *cmb;
+	unsigned long timeout;
+	struct delayed_work work;
+};
+
+struct rtk_cec_rcv {
+	unsigned char enable : 1;
+	unsigned char state : 7;
+	cm_buff *cmb;
+	wait_queue_head_t wq;
+	struct delayed_work work;
+};
+
+struct rtk_cec {
+	struct device *dev;
+	struct {
+		unsigned char init : 1;
+		unsigned char enable : 1;
+		unsigned char standby_mode : 1;
+		unsigned char exit;
+	} status;
+
+	void __iomem *reg_base;
+	void __iomem *iso_base;
+	void __iomem *wrapper_reg;
+	unsigned int irq_num;
+
+	unsigned long  standby_config;
+	unsigned char  standby_logical_addr;
+	unsigned short standby_physical_addr;
+	unsigned char  standby_cec_version;
+	unsigned long  standby_vendor_id;
+	unsigned short standby_rx_mask;
+	unsigned char  standby_cec_wakeup_off;
+
+	struct rtk_cec_xmit xmit;
+	struct rtk_cec_rcv rcv;
+	cm_buff_head tx_queue;
+	cm_buff_head rx_queue;
+	cm_buff_head rx_free_queue;
+	spinlock_t lock;
+	struct clk *clk;
+	struct notifier_block clk_nb;
+	struct reset_control *rstc;
+	struct ion_client *rpc_ion_client;
+	int chip_id;
+};
+
+#define RX_RING_LENGTH		16
+#define TX_RING_LENGTH		16
+#define TX_TIMEOUT		(HZ<<2)
+#define SA_INTERRUPT		0
+#define SA_SHIRQ		IRQF_SHARED
+
+
+#define write_reg32(addr, val)	writel(val, (volatile unsigned int*)(addr))
+#define read_reg32(addr)	readl((volatile unsigned int*)(addr))
+
+#define FLD_GET(val, start, end)	(((val) & FLD_MASK(start, end)) >> (end))
+#define FLD_MASK(start, end)		(((1 << (start - end + 1)) - 1) << (end))
+#define SETBITS(base, offset, Mask)	write_reg32((base+offset), (read_reg32(base+offset) | Mask))
+#define READBITS(value, Mask)		((value >> (Mask)) & 0x1)
+#define CLEARBITS(base, offset, Mask)	write_reg32((base+offset), (read_reg32(base+offset) & ~(Mask)))
+#define MASK_REG_32(base, offset, andMask, orMask)	write_reg32((base+offset), ((read_reg32(base+offset) & (andMask)) | (orMask)))
+
+enum {
+	IDEL,
+	XMIT,
+	RCV
+};
+
+enum {
+	RCV_OK,
+	RCV_FAIL,
+};
+
+#define CEC_MODE_OFF        0
+#define CEC_MODE_ON         1
+#define CEC_MODE_STANDBY    2
+
+/* register define */
+#define RTK_CEC_CR0				(0x00)
+#define RTK_CEC_RTCR0				(0x04)
+#define RTK_CEC_RXCR0				(0x08)
+#define RTK_CEC_TXCR0				(0x0C)
+#define RTK_CEC_TXDR0				(0x10)
+#define RTK_CEC_TXDR1				(0x14)
+#define RTK_CEC_TXDR2				(0x18)
+#define RTK_CEC_TXDR3				(0x1C)
+#define RTK_CEC_TXDR4				(0x20)
+#define RTK_CEC_RXDR1				(0x24)
+#define RTK_CEC_RXDR2				(0x28)
+#define RTK_CEC_RXDR3				(0x2C)
+#define RTK_CEC_RXDR4				(0x30)
+#define RTK_CEC_RXTCR0				(0x34)
+#define RTK_CEC_TXTCR0				(0x38)
+#define RTK_CEC_TXTCR1				(0x3C)
+
+#define RTK_GDI_CEC_COMPARE_OPCODE_01		(0x40)
+#define RTK_GDI_CEC_SEND_OPCODE_01		(0x44)
+#define RTK_GDI_CEC_SEND_OPERAND_NUMBER_01	(0x48)
+#define RTK_GDI_CEC_OPERAND_01			(0x4C)
+#define RTK_GDI_CEC_OPERAND_02			(0x50)
+#define RTK_GDI_CEC_OPERAND_03			(0x54)
+#define RTK_GDI_CEC_COMPARE_OPCODE_02		(0x58)
+#define RTK_GDI_CEC_SEND_OPCODE_02		(0x5C)
+#define RTK_GDI_CEC_SEND_OPERAND_NUMBER_02	(0x60)
+#define RTK_GDI_CEC_OPERAND_04			(0x64)
+#define RTK_GDI_CEC_OPERAND_05			(0x68)
+#define RTK_GDI_CEC_OPERAND_06			(0x6C)
+#define RTK_GDI_CEC_COMPARE_OPCODE_03		(0x70)
+#define RTK_GDI_CEC_SEND_OPCODE_03		(0x74)
+#define RTK_GDI_CEC_SEND_OPERAND_NUMBER_03	(0x78)
+#define RTK_GDI_CEC_OPERAND_07			(0x7C)
+#define RTK_GDI_CEC_OPERAND_08			(0x80)
+#define RTK_GDI_CEC_OPERAND_09			(0x84)
+#define RTK_GDI_CEC_COMPARE_OPCODE_04		(0x88)
+#define RTK_GDI_CEC_SEND_OPCODE_04		(0x8C)
+#define RTK_GDI_CEC_SEND_OPERAND_NUMBER_04	(0x90)
+#define RTK_GDI_CEC_OPERAND_10			(0x94)
+#define RTK_GDI_CEC_OPERAND_11			(0x98)
+#define RTK_GDI_CEC_OPERAND_12			(0x9C)
+#define RTK_GDI_CEC_COMPARE_OPCODE_05		(0xA0)
+#define RTK_GDI_CEC_COMPARE_OPCODE_06		(0xA4)
+#define RTK_GDI_CEC_COMPARE_OPCODE_07		(0xA8)
+#define RTK_GDI_CEC_COMPARE_OPCODE_08		(0xAC)
+#define RTK_GDI_CEC_COMPARE_OPCODE_09		(0xB0)
+#define RTK_GDI_CEC_COMPARE_OPCODE_10		(0xB4)
+#define RTK_GDI_CEC_COMPARE_OPCODE_11		(0xB8)
+#define RTK_GDI_CEC_COMPARE_OPCODE_12		(0xBC)
+#define RTK_GDI_CEC_COMPARE_OPCODE_13		(0xC0)
+#define RTK_GDI_CEC_COMPARE_OPCODE_14		(0xC4)
+#define RTK_GDI_CEC_COMPARE_OPCODE_15		(0xC8)
+#define RTK_GDI_CEC_OPCODE_ENABLE		(0xCC)
+#define RTK_GDI_POWER_SAVING_MODE		(0xD0)
+
+#define RTK_CEC_SOFT_RESET			(0x88)
+#define RTK_CEC_CLOCK_ENABLE			(0x8C)
+
+#define CEC_CR0					RTK_CEC_CR0
+#define CEC_RTCR0				RTK_CEC_RTCR0
+#define CEC_RXCR0				RTK_CEC_RXCR0
+#define CEC_TXCR0				RTK_CEC_TXCR0
+#define CEC_TXDR0				RTK_CEC_TXDR0
+#define CEC_TXDR1				RTK_CEC_TXDR1
+#define CEC_TXDR2				RTK_CEC_TXDR2
+#define CEC_TXDR3				RTK_CEC_TXDR3
+#define CEC_TXDR4				RTK_CEC_TXDR4
+#define CEC_RXDR1				RTK_CEC_RXDR1
+#define CEC_RXDR2				RTK_CEC_RXDR2
+#define CEC_RXDR3				RTK_CEC_RXDR3
+#define CEC_RXDR4				RTK_CEC_RXDR4
+#define CEC_RXTCR0				RTK_CEC_RXTCR0
+#define CEC_TXTCR0				RTK_CEC_TXTCR0
+#define CEC_TXTCR1				RTK_CEC_TXTCR1
+
+#define GDI_CEC_COMPARE_OPCODE_01		RTK_GDI_CEC_COMPARE_OPCODE_01
+#define GDI_CEC_SEND_OPCODE_01			RTK_GDI_CEC_SEND_OPCODE_01
+#define GDI_CEC_SEND_OPERAND_NUMBER_01		RTK_GDI_CEC_SEND_OPERAND_NUMBER_01
+#define GDI_CEC_OPERAND_01			RTK_GDI_CEC_OPERAND_01
+#define GDI_CEC_OPERAND_02			RTK_GDI_CEC_OPERAND_02
+#define GDI_CEC_OPERAND_03			RTK_GDI_CEC_OPERAND_03
+#define GDI_CEC_COMPARE_OPCODE_02		RTK_GDI_CEC_COMPARE_OPCODE_02
+#define GDI_CEC_SEND_OPCODE_02			RTK_GDI_CEC_SEND_OPCODE_02
+#define GDI_CEC_SEND_OPERAND_NUMBER_02		RTK_GDI_CEC_SEND_OPERAND_NUMBER_02
+#define GDI_CEC_OPERAND_04			RTK_GDI_CEC_OPERAND_04
+#define GDI_CEC_OPERAND_05			RTK_GDI_CEC_OPERAND_05
+#define GDI_CEC_OPERAND_06			RTK_GDI_CEC_OPERAND_06
+#define GDI_CEC_COMPARE_OPCODE_03		RTK_GDI_CEC_COMPARE_OPCODE_03
+#define GDI_CEC_SEND_OPCODE_03			RTK_GDI_CEC_SEND_OPCODE_03
+#define GDI_CEC_SEND_OPERAND_NUMBER_03		RTK_GDI_CEC_SEND_OPERAND_NUMBER_03
+#define GDI_CEC_OPERAND_07			RTK_GDI_CEC_OPERAND_07
+#define GDI_CEC_OPERAND_08			RTK_GDI_CEC_OPERAND_08
+#define GDI_CEC_OPERAND_09			RTK_GDI_CEC_OPERAND_09
+#define GDI_CEC_COMPARE_OPCODE_04		RTK_GDI_CEC_COMPARE_OPCODE_04
+#define GDI_CEC_SEND_OPCODE_04			RTK_GDI_CEC_SEND_OPCODE_04
+#define GDI_CEC_SEND_OPERAND_NUMBER_04		RTK_GDI_CEC_SEND_OPERAND_NUMBER_04
+#define GDI_CEC_OPERAND_10			RTK_GDI_CEC_OPERAND_10
+#define GDI_CEC_OPERAND_11			RTK_GDI_CEC_OPERAND_11
+#define GDI_CEC_OPERAND_12			RTK_GDI_CEC_OPERAND_12
+#define GDI_CEC_COMPARE_OPCODE_05		RTK_GDI_CEC_COMPARE_OPCODE_05
+#define GDI_CEC_COMPARE_OPCODE_06		RTK_GDI_CEC_COMPARE_OPCODE_06
+#define GDI_CEC_COMPARE_OPCODE_07		RTK_GDI_CEC_COMPARE_OPCODE_07
+#define GDI_CEC_COMPARE_OPCODE_08		RTK_GDI_CEC_COMPARE_OPCODE_08
+#define GDI_CEC_COMPARE_OPCODE_09		RTK_GDI_CEC_COMPARE_OPCODE_09
+#define GDI_CEC_COMPARE_OPCODE_10		RTK_GDI_CEC_COMPARE_OPCODE_10
+#define GDI_CEC_COMPARE_OPCODE_11		RTK_GDI_CEC_COMPARE_OPCODE_11
+#define GDI_CEC_COMPARE_OPCODE_12		RTK_GDI_CEC_COMPARE_OPCODE_12
+#define GDI_CEC_COMPARE_OPCODE_13		RTK_GDI_CEC_COMPARE_OPCODE_13
+#define GDI_CEC_COMPARE_OPCODE_14		RTK_GDI_CEC_COMPARE_OPCODE_14
+#define GDI_CEC_COMPARE_OPCODE_15		RTK_GDI_CEC_COMPARE_OPCODE_15
+#define GDI_CEC_OPCODE_ENABLE			RTK_GDI_CEC_OPCODE_ENABLE
+#define GDI_POWER_SAVING_MODE			RTK_GDI_POWER_SAVING_MODE
+
+/* CR0 */
+#define LOGICAL_ADDR_SHIFT		24
+#define CEC_MODE(x)			((x & 0x3)<<30)
+#define TEST_MODE_PAD_EN		(0x1<<28)
+#define LOGICAL_ADDR(x)			((x & 0xF)<<LOGICAL_ADDR_SHIFT)
+#define TIMER_DIV(x)			((x & 0xFF)<<16)
+#define PRE_DIV(x)			((x & 0xFF)<<8)
+#define UNREG_ACK_EN			(1<<7)
+#define CDC_ARBITRATION_EN		(0x1<<5)
+#define TEST_MODE_DATA(x)		(x & 0x1F)
+
+#define CEC_MODE_MASK			(CEC_MODE(3))
+#define LOGICAL_ADDR_MASK		(LOGICAL_ADDR(0xF))
+#define CTRL_MASK1			(CEC_MODE_MASK | LOGICAL_ADDR_MASK)
+
+/* RTCR0 */
+#define CEC_PAD_IN			(0x1<<31)
+#define CLEAR_CEC_INT			(0x1<<11)
+#define WT_CNT(x)			((x & 0x3F)<<5)
+#define LATTEST				(0x1<<4)
+#define RETRY_NO_MASK			(0x0F)
+#define RETRY_NO(x)			(x & 0xF)
+
+/* RXCR0 */
+#define INIT_ADDR_SHIFT			(8)
+#define BROADCAST_ADDR			(0x1<<31)
+#define STB_ADDR_SEL			(0x1<<20)
+#define STB_INIT_ADDR(x)		((x & 0xF)<<16)
+#define RX_EN				(0x1<<15)
+#define RX_RST				(0x1<<14)
+#define RX_CONTINUOUS			(0x1<<13)
+#define RX_INT_EN			(0x1<<12)
+#define INIT_ADDR(x)			((x & 0xF)<<INIT_ADDR_SHIFT)
+#define RX_EOM				(0x1<<7)
+#define RX_INT				(0x1<<6)
+#define RX_FIFO_OV			(0x1<<5)
+#define RX_FIFO_CNT(x)			(x & 0x1F)
+
+#define INIT_ADDR_MASK			INIT_ADDR(0xF)
+
+/* TXCR0 */
+#define TX_ADDR_EN			(0x1<<20)
+#define TX_ADDR(x)			((x & 0xF)<<16)
+#define TX_EN				(0x1<<15)
+#define TX_RST				(0x1<<14)
+#define TX_CONTINUOUS			(0x1<<13)
+#define TX_INT_EN			(0x1<<12)
+#define DEST_ADDR(x)			((x & 0xF)<<8)
+#define TX_EOM				(0x1<<7)
+#define TX_INT				(0x1<<6)
+#define TX_FIFO_UD			(0x1<<5)
+#define TX_FIFO_CNT(x)			(x & 0x1F)
+
+/* TXDR0 */
+#define TX_ADD_CNT			(0x1<<6)
+#define RX_SUB_CNT			(0x1<<5)
+#define FIFO_CNT(x)			(x & 0x1F)
+
+/* RXTCR0 */
+#define RX_START_LOW(x)			((x & 0xFF)<<24)
+#define RX_START_PERIOD(x)		((x & 0xFF)<<16)
+#define RX_DATA_SAMPLE(x)		((x & 0xFF)<<8)
+#define RX_DATA_PERIOD(x)		(x & 0xFF)
+
+/* TXCR0 */
+#define TX_START_LOW(x)			((x & 0xFF)<<8)
+#define TX_START_HIGH(x)		((x & 0xFF))
+
+#define TX_DATA_LOW(x)			((x & 0xFF)<<16)
+#define TX_DATA_01(x)			((x & 0xFF)<<8)
+#define TX_DATA_HIGH(x)			((x & 0xFF))
+
+#endif /*__RTK_CEC_H_ */
diff --git a/drivers/media/platform/rtk_cec/cec.h b/drivers/media/platform/rtk_cec/cec.h
new file mode 100644
index 00000000..98cd2ed
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/cec.h
@@ -0,0 +1,137 @@
+/*
+ *  Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifndef __CEC_H__
+#define __CEC_H__
+
+#include <linux/device.h>
+#include "cm_buff.h"
+
+typedef struct {
+	unsigned long id;
+	char *name;
+	struct device dev;
+} cec_device;
+
+extern int cec_device_en[2];
+extern int *cec_device_pthis[2];
+
+#define to_cec_device(x)  container_of(x, cec_device, dev)
+
+static inline void *cec_get_drvdata(cec_device *device)
+{
+	return dev_get_drvdata(&device->dev);
+}
+
+static inline void cec_set_drvdata(cec_device *device, void *data)
+{
+	struct device *dev = &device->dev;
+
+	dev_set_drvdata(dev, data);
+}
+
+typedef struct {
+	char *name;
+	struct device_driver drv;
+
+	int (*probe)(cec_device *dev);
+	void (*remove)(cec_device *dev);
+	int (*xmit)(cec_device *dev, cm_buff *cmg, unsigned long flags);
+	cm_buff *(*read)(cec_device *dev, unsigned long flags);
+	int (*enable)(cec_device *dev, unsigned char on_off);
+	int (*set_rx_mask)(cec_device *dev, unsigned short addr);
+	int (*set_physical_addr)(cec_device *dev, unsigned short phy_addr);
+	int (*set_cec_version)(cec_device *dev, unsigned char version);
+	int (*set_device_vendor_id)(cec_device *dev, unsigned long vendor_id);
+	int (*set_stanby_mode)(cec_device *dev, unsigned long mode);
+	int (*set_retry_num)(cec_device *dev, unsigned long num);
+	int (*suspend)(cec_device *dev);
+	int (*resume)(cec_device *dev);
+	int (*get_physical_addr)(cec_device *dev);
+	int (*read_exit)(cec_device *dev);
+} cec_driver;
+
+extern int register_cec_device(cec_device *device);
+extern void unregister_cec_device(cec_device *device);
+
+#define _BIT(x)         (1UL << x)
+#define TEST_BIT(x, i) (x & (1<<i))
+#define STANBY_RESPONSE_GIVE_POWER_STATUS       _BIT(0)
+#define STANBY_RESPONSE_POOL                    _BIT(1)
+#define STANBY_RESPONSE_GIVE_PHYSICAL_ADDR      _BIT(2)
+#define STANBY_RESPONSE_GET_CEC_VERISON         _BIT(3)
+#define STANBY_RESPONSE_GIVE_DEVICE_VENDOR_ID   _BIT(4)
+#define STANBY_WAKEUP_BY_ROUTING_INFO           _BIT(26)
+#define STANBY_WAKEUP_BY_ROUTING_CHANGE         _BIT(27)
+#define STANBY_WAKEUP_BY_REQUEST_AUDIO_SYSTEM   _BIT(28)
+#define STANBY_WAKEUP_BY_USER_CONTROL           _BIT(29)
+#define STANBY_WAKEUP_BY_IMAGE_VIEW_ON          _BIT(30)
+#define STANBY_WAKEUP_BY_SET_STREAM_PATH        _BIT(31)
+
+#define to_cec_driver(x)  container_of(x, cec_driver, drv)
+
+extern int register_cec_driver(cec_driver *driver);
+extern void unregister_cec_driver(cec_driver *driver);
+
+typedef enum {
+	CEC_VERSION_1_1                         = 0x00,
+	CEC_VERSION_1_2                         = 0x01,
+	CEC_VERSION_1_2A                        = 0x02,
+	CEC_VERSION_1_3                         = 0x03,
+	CEC_VERSION_1_3A                        = 0x04,
+	CEC_VERSION_1_4                         = 0x05,
+	CEC_VERSION_UNKNOWN                     = 0xFF,
+} CEC_VERSION;
+
+#define CEC_WAKEUP_BY_SET_STREAM_PATH       0x01
+#define CEC_WAKEUP_BY_PLAY_CMD              0x02
+#define CEC_WAKEUP_BY_IMAGE_VIEW_ON         0x04
+#define CEC_MSG_GET_CEC_VERSION             0x9F
+#define CEC_MSG_CEC_VERSION                 0x9E
+#define CEC_MSG_REPORT_POWER_STATUS         0x90
+#define CEC_MSG_GIVE_DEVICE_POWER_STATUS    0x8F
+#define CEC_MSG_GIVE_DEVICE_VENDOR_ID       0x8C
+#define CEC_MSG_DEVICE_VENDOR_ID            0x87
+#define CEC_MSG_SET_STREAM_PATH             0x86
+#define CEC_MSG_REPORT_PHYSICAL_ADDRESS     0x84
+#define CEC_MSG_GIVE_PHYSICAL_ADDRESS       0x83
+#define CEC_MSG_ROUTING_INFO                0x81
+#define CEC_MSG_ROUTING_CHANGE              0x80
+#define CEC_MSG_REQUEST_SYSTEM_AUDIO        0x70
+#define CEC_MSG_USER_CONTROL_PRESSED        0x44
+#define CEC_MSG_PLAY                        0x41
+#define CEC_MSG_STANDBY                     0x36
+#define CEC_MSG_TEXT_VIEW_ON                0x0D
+#define CEC_MSG_IMAGE_VIEW_ON               0x04
+#define CEC_MSG_FEATURE_ABORT               0x00
+
+#define CEC_DEVICE_TV                       0x00
+#define CEC_DEVICE_RECORDING_DEVICE         0x01
+#define CEC_DEVICE_RESERVED                 0x02
+#define CEC_DEVICE_TUNER                    0x03
+#define CEC_DEVICE_PLAYBACK_DEVICE          0x04
+#define CEC_DEVICE_AUDIO_SYSTEM             0x05
+#define CEC_DEVICE_PURE_CEC_SWITCH          0x06
+#define CEC_DEVICE_VIDEO_PROCESSOR          0x07
+
+#define CEC_POWER_STATUS_ON                 0x00
+#define CEC_POWER_STATUS_STANDBY            0x01
+#define CEC_POWER_STATUS_STANDBY_TO_ON      0x02
+#define CEC_POWER_STATUS_ON_TO_STANDBY      0x03
+
+#define CEC_ABORT_UNKNOWN_OPCODE            0x00
+#define CEC_ABORT_NOT_IN_CORECT_MODE        0x01
+#define CEC_ABORT_CAN_NOT_PROVIDE_SOURCE    0x02
+#define CEC_ABORT_INVALID_OPERAND           0x03
+#define CEC_ABORT_REFUSED                   0x04
+
+#define CEC_USER_CONTROL_POWER_TOGGLE       0x6B
+#define CEC_USER_CONTROL_POWER_ON           0x6D
+#define CEC_USER_CONTROL_POWER              0x40
+
+#endif
+
diff --git a/drivers/media/platform/rtk_cec/cec_core.c b/drivers/media/platform/rtk_cec/cec_core.c
new file mode 100644
index 00000000..6f3c00f
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/cec_core.c
@@ -0,0 +1,199 @@
+/*
+ *  Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/device.h>
+#include "cec.h"
+#include "cec_dev.h"
+
+int cec_device_en[2];
+int *cec_device_pthis[2];
+
+int cec_bus_match(struct device *dev, struct device_driver *drv)
+{
+	dev_info(dev, "bus match name = %s, drv_name = %s\n",
+					dev_name(dev), drv->name);
+	if (0 == strncmp(dev_name(dev), drv->name, 3))
+		return 1;
+	return 0;
+}
+
+#ifdef CONFIG_PM
+int cec_check_device(struct device *dev)
+{
+	int device_en = 0;
+	char device0[] = "cec0";
+	char device1[] = "cec1";
+
+	dev_info(dev, "check_device %s\n", dev_name(dev));
+	if (0 == strncmp(dev_name(dev), device0, strlen(dev_name(dev))))
+		device_en = cec_device_en[0];
+	else if (0 == strncmp(dev_name(dev), device1, strlen(dev_name(dev))))
+		device_en = cec_device_en[1];
+	return device_en;
+}
+
+int cec_drv_suspend(struct device *dev)
+{
+	int device_en = cec_check_device(dev);
+
+	dev_info(dev, "%s\n", __func__);
+	if (device_en) {
+		cec_device *p_dev = to_cec_device(dev);
+		cec_driver *p_drv = to_cec_driver(dev->driver);
+
+		return (p_drv->suspend) ? p_drv->suspend(p_dev) : 0;
+	} else {
+		dev_err(dev, "%s not implement yet !!\n", dev_name(dev));
+		return 0;
+	}
+}
+
+void cec_bus_shutdown(struct device *dev)
+{
+	cec_drv_suspend(dev);
+}
+
+int cec_drv_resume(struct device *dev)
+{
+	int device_en = cec_check_device(dev);
+
+	dev_info(dev, "%s\n", __func__);
+	if (device_en) {
+		cec_device *p_dev = to_cec_device(dev);
+		cec_driver *p_drv = to_cec_driver(dev->driver);
+
+		return (p_drv->resume) ? p_drv->resume(p_dev) : 0;
+	} else {
+		dev_err(dev, "%s not implement yet !!\n", dev_name(dev));
+		return 0;
+	}
+}
+
+static const struct dev_pm_ops cec_bus_pm_ops = {
+	.suspend = cec_drv_suspend,
+	.resume = cec_drv_resume,
+};
+#endif
+
+struct bus_type cec_bus_type = {
+	.name    = "cec",
+	.match   = cec_bus_match,
+#ifdef CONFIG_PM
+	.pm      = &cec_bus_pm_ops,
+	.shutdown = cec_bus_shutdown,
+#endif
+};
+
+/* cec device */
+
+void cec_device_release(struct device *dev)
+{
+	cec_device *p_dev = to_cec_device(dev);
+
+	dev_info(dev, "dev %s released\n", p_dev->name);
+}
+
+int register_cec_device(cec_device *device)
+{
+	struct device *dev = &device->dev;
+
+	dev_set_name(dev, device->name);
+	dev->bus = &cec_bus_type;
+	dev->release  = cec_device_release;
+
+	return device_register(dev);
+}
+EXPORT_SYMBOL(register_cec_device);
+
+void unregister_cec_device(cec_device *device)
+{
+	device_unregister(&device->dev);
+}
+EXPORT_SYMBOL(unregister_cec_device);
+
+/* cec driver */
+int cec_drv_probe(struct device *dev)
+{
+	cec_device *p_dev = to_cec_device(dev);
+	cec_driver *p_drv = to_cec_driver(dev->driver);
+
+	dev_info(dev, "probe dev %s\n", p_dev->name);
+
+	if (!p_drv->probe)
+		return -ENODEV;
+
+	if (p_drv->probe(p_dev) == 0) {
+		create_cec_dev_node(p_dev);
+		return 0;
+	}
+	return -ENODEV;
+}
+
+int cec_drv_remove(struct device *dev)
+{
+	cec_device *p_dev = to_cec_device(dev);
+	cec_driver *p_drv = to_cec_driver(dev->driver);
+
+	dev_info(dev, "remove dev %s\n", p_dev->name);
+
+	if (p_drv->remove)
+		p_drv->remove(p_dev);
+
+	create_cec_dev_node(p_dev);
+	return 0;
+}
+
+void cec_drv_shutdown(struct device *dev)
+{
+	cec_device *p_dev = to_cec_device(dev);
+	cec_driver *p_drv = to_cec_driver(dev->driver);
+
+	dev_info(dev, "shotdown dev %s\n", p_dev->name);
+
+	if (p_drv->enable)
+		p_drv->enable(p_dev, 0);
+}
+
+int register_cec_driver(cec_driver *driver)
+{
+	struct device_driver *drv = &driver->drv;
+
+	drv->name     = driver->name;
+	drv->bus      = &cec_bus_type;
+	drv->probe    = cec_drv_probe;
+	drv->remove   = cec_drv_remove;
+
+	pr_info("register cec driver %s (%p)\n", drv->name, drv);
+
+	return driver_register(drv);
+}
+EXPORT_SYMBOL(register_cec_driver);
+
+void unregister_cec_driver(cec_driver *driver)
+{
+	struct device_driver *drv = &driver->drv;
+
+	pr_info("unregister cec driver %s (%p)\n", drv->name, &driver->drv);
+	driver_unregister(&driver->drv);
+}
+EXPORT_SYMBOL(unregister_cec_driver);
+
+static int __init cec_core_init(void)
+{
+	return bus_register(&cec_bus_type);
+}
+
+static void __exit cec_core_exit(void)
+{
+	bus_unregister(&cec_bus_type);
+}
+
+module_init(cec_core_init);
+module_exit(cec_core_exit);
diff --git a/drivers/media/platform/rtk_cec/cec_debug.h b/drivers/media/platform/rtk_cec/cec_debug.h
new file mode 100644
index 00000000..73b00b7
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/cec_debug.h
@@ -0,0 +1,41 @@
+//Copyright (C) 2007-2013 Realtek Semiconductor Corporation.
+#ifndef __CEC_DEBUG_H__
+#define __CEC_DEBUG_H__
+
+
+//-- cec debug messages
+//#define CONFIG_CEC_DBG
+//#define CEC_TX_DBG
+//#define CEC_RX_DBG
+
+#ifdef CONFIG_CEC_DBG
+#define cec_dbg(format, ...) printk("[CEC_DBG] " format, ## __VA_ARGS__)
+#else
+#define cec_dbg(args...)	
+#endif
+
+
+#ifdef CEC_TX_DBG
+#define cec_tx_dbg(format, ...) printk("[CEC_TX] " format, ## __VA_ARGS__)
+#else
+#define cec_tx_dbg(args...)	
+#endif
+
+
+
+#ifdef CEC_RX_DBG
+#define cec_rx_dbg(format, ...) printk("[CEC_RX] " format, ## __VA_ARGS__)
+#else
+#define cec_rx_dbg(args...)	
+#endif
+
+
+
+#define cec_info(format, ...) printk("[CEC_INFO] " format, ## __VA_ARGS__)
+
+#define cec_warning(format, ...) printk("[CEC_WARN] " format, ## __VA_ARGS__)	
+
+#endif  //__CEC_DEBUG_H__
+
+
+
diff --git a/drivers/media/platform/rtk_cec/cec_dev.c b/drivers/media/platform/rtk_cec/cec_dev.c
new file mode 100644
index 00000000..91c789a
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/cec_dev.c
@@ -0,0 +1,341 @@
+/*
+ *  Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+#include "cec.h"
+#include "cec_dev.h"
+
+#define MAX_CEC_CNT	4
+static cec_dev node_list[MAX_CEC_CNT];
+static dev_t devno_base;
+static struct class *cec_dev_class;
+
+void *get_cecdev_from_node(struct inode *inode)
+{
+	unsigned int i = iminor(inode);
+	void *dev = NULL;
+
+	if (!node_list[i].device)
+		return NULL;
+
+	dev = dev_get_drvdata(node_list[i].device);
+
+	return dev;
+}
+
+int create_cec_dev_node(cec_device *device)
+{
+	int i;
+
+	for (i = 0; i < MAX_CEC_CNT; i++) {
+		if (node_list[i].device != NULL)
+			continue;
+		if (cdev_add(&node_list[i].cdev, devno_base + i, 1) < 0) {
+			pr_err("cec err : register character dev failed\n");
+			return -1;
+		}
+		node_list[i].device = device_create(
+				cec_dev_class,
+				NULL,
+				devno_base + i,
+				device,
+				"cec-%d",
+				i);
+		return 0;
+	}
+	return -1;
+}
+
+void remove_cec_dev_node(cec_device *device)
+{
+	int i = 0;
+
+	for (i = 0; i < MAX_CEC_CNT; i++) {
+		if (node_list[i].device &&
+			dev_get_drvdata(node_list[i].device) == (void *)device) {
+			device_destroy(cec_dev_class, devno_base + i);
+			cdev_del(&node_list[i].cdev);
+			node_list[i].device = NULL;
+		}
+	}
+}
+
+static int cec_dev_open(struct inode *inode, struct file *file)
+{
+	unsigned int i = iminor(inode);
+	cec_device *dev;
+
+	if (!node_list[i].device)
+		return -ENODEV;
+
+	dev = (cec_device *)dev_get_drvdata(node_list[i].device);
+
+	if (dev) {
+		file->private_data = dev;
+		return 0;
+	}
+	return -ENODEV;
+}
+
+static int cec_dev_release(struct inode *inode, struct file *file)
+{
+	unsigned int i = iminor(inode);
+	cec_device *dev;
+	cec_driver *drv;
+
+	if (node_list[i].device) {
+		dev = (cec_device *)dev_get_drvdata(node_list[i].device);
+		drv = (cec_driver *)to_cec_driver(dev->dev.driver);
+		drv->enable(dev, 0xf0);
+	}
+	return 0;
+}
+
+static long cec_dev_ioctl(struct file *file, unsigned int cmd,
+						unsigned long arg)
+{
+	cec_device *dev = (cec_device *) file->private_data;
+	cec_driver *drv;
+	cec_msg  msg;
+	cm_buff *cmb = NULL;
+	int len;
+	unsigned short rx_mask;
+	unsigned int result;
+
+	if (!dev)
+		return -ENODEV;
+
+	drv = (cec_driver *)to_cec_driver(dev->dev.driver);
+
+	switch (cmd) {
+	case CEC_ENABLE:
+		dev_info(&dev->dev, "ioctl - ENABLE\n");
+		return drv->enable(dev, (arg) ? 1 : 0);
+
+	case CEC_SET_RX_MASK:
+		dev_info(&dev->dev, "ioctl - SET_RX_MASK\n");
+		return drv->set_rx_mask(dev, (unsigned short) arg | 0x8000);
+
+	case CEC_SET_LOGICAL_ADDRESS:
+		dev_info(&dev->dev, "ioctl - SET_LOGICAL_ADDRESS\n");
+
+		rx_mask = (unsigned char) arg;
+		if (rx_mask > 0xF) {
+			dev_err(&dev->dev,
+				"invalid logical address %d\n", rx_mask);
+			return -EFAULT;
+		}
+		rx_mask = (1 << rx_mask);
+		return drv->set_rx_mask(dev, rx_mask | 0x8000);
+
+	case CEC_SET_PHYSICAL_ADDRESS:
+		dev_info(&dev->dev, "ioctl - SET_PHYSICAL_ADDRESS\n");
+		return drv->set_physical_addr(dev, (unsigned short) arg);
+
+	case CEC_GET_PHYSICAL_ADDRESS:
+		dev_info(&dev->dev, "ioctl - GET_PHYSICAL_ADDRESS\n");
+		return drv->get_physical_addr(dev);
+
+	case CEC_SEND_MESSAGE:
+		dev_info(&dev->dev, "ioctl - SEND_MESSAGE\n");
+		if (copy_from_user(&msg, (cec_msg __user *)arg, sizeof(msg)))
+			return -EFAULT;
+
+		cmb = alloc_cmb(msg.len);
+		if (cmb == NULL)
+			return -ENOMEM;
+		if (copy_from_user(cmb_put(cmb, msg.len),
+			(unsigned char __user *)msg.buf, msg.len))
+			return -EFAULT;
+
+		return drv->xmit(dev, cmb, 0);
+
+	case CEC_RCV_MESSAGE:
+		if (copy_from_user(&msg, (cec_msg __user *)arg, sizeof(msg)))
+			return -EFAULT;
+		cmb = drv->read(dev, (file->f_flags & O_NONBLOCK) ? NONBLOCK : 0);
+		if (!cmb)
+			return -EFAULT;
+
+		if (cmb->len > msg.len) {
+			dev_err(&dev->dev,
+				"rcv failed, msg size %d, buffer size %d\n",
+				cmb->len, msg.len);
+			kfree_cmb(cmb);
+			return -ENOMEM;
+		}
+		len = cmb->len;
+		result = copy_to_user((unsigned char __user *)msg.buf,
+					cmb->data, cmb->len) ? -EFAULT : 0;
+	/*	if (result < 0) {
+			dev_err(&dev->dev, "copy msg to user failed\n");
+			kfree_cmb(cmb);
+			return result;
+		}*/
+		kfree_cmb(cmb);
+		return len;
+
+	case CEC_RCV_EXIT:
+		return drv->read_exit(dev);
+
+	case CEC_SET_STANDBY_MODE:
+		return drv->set_stanby_mode(dev, (unsigned long) arg);
+
+	case CEC_SET_CEC_VERSION:
+		return drv->set_cec_version(dev, (unsigned char) arg);
+
+	case CEC_SET_DEVICE_VENDOR_ID:
+		return drv->set_device_vendor_id(dev, (unsigned long) arg);
+
+	case CEC_SET_RETRY_NUM:
+		return drv->set_retry_num(dev, (unsigned long) arg);
+	default:
+		dev_err(&dev->dev, "unknown ioctl cmd %08x\n", cmd);
+		return -EFAULT;
+	}
+}
+#ifdef CONFIG_64BIT
+long cec_dev_compat_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	long (*ioctl)(struct file*, unsigned int, unsigned long);
+	cec_device *dev = (cec_device *)file->private_data;
+	cec_driver *drv;
+	cec_msg  msg;
+	cm_buff *cmb = NULL;
+	unsigned int temp[4];
+	int len;
+	unsigned int result;
+
+	if (!dev)
+		return -ENODEV;
+
+	drv = (cec_driver *)to_cec_driver(dev->dev.driver);
+
+	if (!file->f_op->unlocked_ioctl)
+		return -ENOTTY;
+	ioctl = file->f_op->unlocked_ioctl;
+
+	switch (cmd) {
+	case CEC_ENABLE:
+	case CEC_SET_RX_MASK:
+	case CEC_SET_LOGICAL_ADDRESS:
+	case CEC_SET_PHYSICAL_ADDRESS:
+		return ioctl(file, cmd, (unsigned long)compat_ptr(arg));
+
+	case CEC_SEND_MESSAGE:
+		if (copy_from_user(&temp, (void __user *)arg, sizeof(msg)))
+			return -EFAULT;
+		msg.buf = (unsigned char *)(unsigned long)temp[0];
+		msg.len = (unsigned char)temp[1];
+
+		cmb = alloc_cmb(msg.len);
+		if (cmb == NULL)
+			return -ENOMEM;
+
+		if (copy_from_user(cmb_put(cmb, msg.len),
+			(unsigned char __user *)compat_ptr((unsigned long)msg.buf),
+			msg.len))
+			return -EFAULT;
+		return drv->xmit(dev, cmb, 0);
+
+	case CEC_RCV_MESSAGE:
+		if (copy_from_user(&temp, (cec_msg __user *)compat_ptr(arg),
+					sizeof(msg)))
+			return -EFAULT;
+		msg.buf = (unsigned char *)(unsigned long)temp[0];
+		msg.len = (unsigned char)temp[1];
+
+		cmb = drv->read(dev, (file->f_flags & O_NONBLOCK) ? NONBLOCK : 0);
+		if (!cmb)
+			return -EFAULT;
+		if (cmb->len > msg.len) {
+			dev_err(&dev->dev,
+				"rcv failed, msg size %d, buffer size %d\n",
+				cmb->len, msg.len);
+			kfree_cmb(cmb);
+			return -ENOMEM;
+		}
+		len = cmb->len;
+		result = copy_to_user((unsigned char __user *) msg.buf,
+					cmb->data, cmb->len) ? -EFAULT : 0;
+/*		if (result < 0) {
+			dev_err(&dev->dev, "copy msg to user failed\n");
+			kfree_cmb(cmb);
+			return result;
+		}*/
+		kfree_cmb(cmb);
+		return len;
+
+	case CEC_SET_STANDBY_MODE:
+	case CEC_SET_CEC_VERSION:
+	case CEC_SET_DEVICE_VENDOR_ID:
+	case CEC_SET_RETRY_NUM:
+	case CEC_RCV_EXIT:
+		return ioctl(file, cmd, (unsigned long)compat_ptr(arg));
+
+	default:
+		return -EFAULT;
+	}
+}
+#endif
+static const struct file_operations cec_dev_fops = {
+	.owner = THIS_MODULE,
+	.unlocked_ioctl	= cec_dev_ioctl,
+	.open = cec_dev_open,
+	.release = cec_dev_release,
+#ifdef CONFIG_64BIT
+	.compat_ioctl = cec_dev_compat_ioctl,
+#endif
+};
+
+static int __init cec_dev_module_init(void)
+{
+	int i;
+	unsigned int result = 0;
+
+	if (alloc_chrdev_region(&devno_base, 0, MAX_CEC_CNT, "cec") != 0)
+		return -EFAULT;
+
+	for (i = 0; i < MAX_CEC_CNT; i++) {
+		cdev_init(&node_list[i].cdev, &cec_dev_fops);
+		node_list[i].device = NULL;
+	}
+
+	cec_dev_class = class_create(THIS_MODULE, "cec-dev");
+
+	if (IS_ERR(cec_dev_class)) {
+		result = PTR_ERR(cec_dev_class);
+		goto err_create_class_failed;
+	}
+	return 0;
+
+err_create_class_failed:
+	unregister_chrdev_region(devno_base, MAX_CEC_CNT);
+	return result;
+}
+
+static void __exit cec_dev_module_exit(void)
+{
+	int i = 0;
+	cec_device *dev;
+
+	for (i = 0; i < MAX_CEC_CNT; i++) {
+		if (!node_list[i].device)
+			continue;
+		dev = dev_get_drvdata(node_list[i].device);
+		remove_cec_dev_node(dev);
+	}
+
+	unregister_chrdev_region(devno_base, MAX_CEC_CNT);
+	class_destroy(cec_dev_class);
+}
+
+module_init(cec_dev_module_init);
+module_exit(cec_dev_module_exit);
diff --git a/drivers/media/platform/rtk_cec/cec_dev.h b/drivers/media/platform/rtk_cec/cec_dev.h
new file mode 100644
index 00000000..54976b5
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/cec_dev.h
@@ -0,0 +1,48 @@
+/*
+ *  Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifndef __CEC_DEV_H__
+#define __CEC_DEV_H__
+
+#include <linux/cdev.h>
+#include "cm_buff.h"
+#include "cec.h"
+
+enum {
+	CEC_ENABLE,
+	CEC_SET_LOGICAL_ADDRESS,
+	CEC_SET_POWER_STATUS,
+	CEC_SEND_MESSAGE,
+	CEC_RCV_MESSAGE,
+	CEC_SET_PHYSICAL_ADDRESS,
+	CEC_SET_STANDBY_MODE,
+	CEC_SET_RX_MASK,
+	CEC_SET_CEC_VERSION,
+	CEC_SET_DEVICE_VENDOR_ID,
+	CEC_SET_RETRY_NUM,
+	CEC_GET_PHYSICAL_ADDRESS,
+	CEC_RCV_EXIT,
+};
+
+typedef struct {
+	unsigned char      *buf;
+	unsigned char       len;
+} cec_msg;
+
+
+typedef struct{
+	struct cdev     cdev;
+	struct device *device;
+} cec_dev;
+
+extern int  create_cec_dev_node(cec_device *dev);
+extern void remove_cec_dev_node(cec_device *dev);
+extern int cec_tx_device_check(void);
+extern int cec_rx_device_check(void);
+
+#endif  /* __CEC_DEV_H__ */
+
diff --git a/drivers/media/platform/rtk_cec/cm_buff.c b/drivers/media/platform/rtk_cec/cm_buff.c
new file mode 100644
index 00000000..040abbb
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/cm_buff.c
@@ -0,0 +1,189 @@
+/*
+ *  Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/slab.h>
+#include "cm_buff.h"
+
+#define CHECK_BOUNDRARY(cmb)	\
+	do {\
+		if (cmb->tail > cmb->end)\
+			pr_err("cmb over panic:  cmb=%p cmb->tail (%p) > cmb->end (%p)\n", cmb, cmb->tail, cmb->end);\
+		if (cmb->data < cmb->head)\
+			pr_err("cmb under panic: cmb=%p cmb->data (%p) < cmb->head (%p)\n", cmb, cmb->data, cmb->head);\
+	} while (0)
+
+void cmb_queue_head_init(cm_buff_head *head)
+{
+	spin_lock_init(&head->lock);
+	INIT_LIST_HEAD(&head->list);
+	head->qlen = 0;
+}
+EXPORT_SYMBOL(cmb_queue_head_init);
+
+void cmb_queue_head(cm_buff_head *head, cm_buff *cmb)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&head->lock, flags);
+
+	list_add(&cmb->list, &head->list);
+	head->qlen++;
+
+	spin_unlock_irqrestore(&head->lock, flags);
+}
+EXPORT_SYMBOL(cmb_queue_head);
+
+void cmb_queue_tail(cm_buff_head *head, cm_buff *cmb)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&head->lock, flags);
+
+	list_add_tail(&cmb->list, &head->list);
+	head->qlen++;
+
+	spin_unlock_irqrestore(&head->lock, flags);
+}
+EXPORT_SYMBOL(cmb_queue_tail);
+
+cm_buff *cmb_dequeue(cm_buff_head *head)
+{
+	cm_buff *cmb = NULL;
+	unsigned long flags;
+
+	spin_lock_irqsave(&head->lock, flags);
+
+	if (!list_empty(&head->list)) {
+		cmb = list_entry(head->list.next, cm_buff, list);
+		list_del_init(&cmb->list);
+		head->qlen--;
+	}
+
+	spin_unlock_irqrestore(&head->lock, flags);
+
+	return cmb;
+}
+EXPORT_SYMBOL(cmb_dequeue);
+
+cm_buff *cmb_dequeue_tail(cm_buff_head *head)
+{
+	cm_buff *cmb = NULL;
+	unsigned long flags;
+
+	spin_lock_irqsave(&head->lock, flags);
+
+	if (!list_empty(&head->list)) {
+		cmb = list_entry(head->list.prev, cm_buff, list);
+		list_del_init(&cmb->list);
+		head->qlen--;
+	}
+
+	spin_unlock_irqrestore(&head->lock, flags);
+
+	return cmb;
+}
+EXPORT_SYMBOL(cmb_dequeue_tail);
+
+unsigned int cmb_queue_len(const cm_buff_head *head)
+{
+	return head->qlen;
+}
+EXPORT_SYMBOL(cmb_queue_len);
+
+void cmb_queue_purge(cm_buff_head *head)
+{
+	cm_buff *cmb;
+	unsigned long flags;
+
+	spin_lock_irqsave(&head->lock, flags);
+
+	while ((cmb = cmb_dequeue(head)) != NULL)
+		kfree_cmb(cmb);
+
+	spin_unlock_irqrestore(&head->lock, flags);
+}
+EXPORT_SYMBOL(cmb_queue_purge);
+
+cm_buff *alloc_cmb(size_t size)
+{
+	cm_buff *cmb = kmalloc(sizeof(cm_buff) + size, GFP_KERNEL);
+
+	if (cmb) {
+		INIT_LIST_HEAD(&cmb->list);
+		init_waitqueue_head(&cmb->wq);
+		cmb->status = 0;
+		cmb->flags  = 0;
+		cmb->head   = ((unsigned char *) cmb) + sizeof(cm_buff);
+		cmb->data   = cmb->head;
+		cmb->tail   = cmb->head;
+		cmb->end    = cmb->head + size;
+		cmb->len    = 0;
+	}
+	return cmb;
+}
+EXPORT_SYMBOL(alloc_cmb);
+
+void kfree_cmb(cm_buff *cmb)
+{
+	if (cmb)
+		kfree(cmb);
+}
+EXPORT_SYMBOL(kfree_cmb);
+
+int cmb_tailroom(const cm_buff *cmb)
+{
+	return cmb->end - cmb->tail;
+}
+EXPORT_SYMBOL(cmb_tailroom);
+
+void cmb_reserve(cm_buff *cmb, unsigned int len)
+{
+	cmb->data += len;
+	cmb->tail += len;
+	CHECK_BOUNDRARY(cmb);
+}
+EXPORT_SYMBOL(cmb_reserve);
+
+unsigned char *cmb_put(cm_buff *cmb, unsigned int len)
+{
+	unsigned char *ptr = cmb->tail;
+
+	cmb->tail += len;
+	cmb->len  += len;
+	CHECK_BOUNDRARY(cmb);
+	return ptr;
+}
+EXPORT_SYMBOL(cmb_put);
+
+unsigned char *cmb_push(cm_buff *cmb, unsigned int len)
+{
+	cmb->data -= len;
+	cmb->len  += len;
+	CHECK_BOUNDRARY(cmb);
+	return cmb->data;
+}
+EXPORT_SYMBOL(cmb_push);
+
+unsigned char *cmb_pull(cm_buff *cmb, unsigned int len)
+{
+	if (len <= cmb->len) {
+		cmb->data += len;
+		cmb->len  -= len;
+		return cmb->data;
+	}
+	return NULL;
+}
+EXPORT_SYMBOL(cmb_pull);
+
+void cmb_purge(cm_buff *cmb)
+{
+	cmb->data = cmb->head;
+	cmb->tail = cmb->head;
+	cmb->len  = 0;
+}
+EXPORT_SYMBOL(cmb_purge);
diff --git a/drivers/media/platform/rtk_cec/cm_buff.h b/drivers/media/platform/rtk_cec/cm_buff.h
new file mode 100644
index 00000000..1036c36
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/cm_buff.h
@@ -0,0 +1,62 @@
+/*
+ *  Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifndef __CEC_MSG_H__
+#define __CEC_MSG_H__
+
+#include <linux/list.h>
+#include <linux/spinlock.h>
+#include <linux/completion.h>
+#include <linux/wait.h>
+
+#define RX_BUFFER_SIZE      64
+
+typedef struct {
+	struct list_head    list;
+	unsigned char       status;
+
+#define WAIT_XMIT       0xff
+#define XMIT_OK         0x00
+#define XMIT_FAIL       0x01
+#define XMIT_TIMEOUT    0x02
+#define XMIT_ABORT      0x03
+
+	unsigned char       flags;
+#define NONBLOCK        0x80
+	wait_queue_head_t   wq;
+	unsigned char       *head;
+	unsigned char       *data;
+	unsigned char       *tail;
+	unsigned char       *end;
+	unsigned char       len;
+} cm_buff;
+
+typedef struct {
+	spinlock_t          lock;
+	struct list_head    list;
+	unsigned int        qlen;
+} cm_buff_head;
+
+void     cmb_queue_head_init(cm_buff_head *head);
+void     cmb_queue_head(cm_buff_head *head, cm_buff *cmb);
+void     cmb_queue_tail(cm_buff_head *head, cm_buff *cmb);
+cm_buff *cmb_dequeue(cm_buff_head *head);
+cm_buff *cmb_dequeue_tail(cm_buff_head *head);
+void     cmb_queue_purge(cm_buff_head *head);
+unsigned int cmb_queue_len(const cm_buff_head *head);
+
+cm_buff *alloc_cmb(size_t size);
+void     kfree_cmb(cm_buff *cmb);
+
+void            cmb_reserve(cm_buff *cmb, unsigned int len);
+unsigned char   *cmb_put(cm_buff *cmb, unsigned int len);
+unsigned char   *cmb_push(cm_buff *cmb, unsigned int len);
+unsigned char   *cmb_pull(cm_buff *cmb, unsigned int len);
+void            cmb_purge(cm_buff *cmb);
+int             cmb_tailroom(const cm_buff *cmb);
+
+#endif  /* __CEC_H__ */
diff --git a/drivers/media/platform/rtk_cec/xen/cecback.c b/drivers/media/platform/rtk_cec/xen/cecback.c
new file mode 100644
index 00000000..f2e8171
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/xen/cecback.c
@@ -0,0 +1,383 @@
+/*
+ * regback.c - xen regulator backend driver
+ *
+ * Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/list.h>
+#include <linux/kthread.h>
+#include <linux/namei.h>
+#include <linux/fs.h>
+#include <xen/xen.h>
+#include <xen/events.h>
+#include <xen/xenbus.h>
+
+#include "xencec.h"
+
+struct cec_back_info {
+	struct xenbus_device *dev;
+	
+	struct task_struct *task;
+	wait_queue_head_t wq;
+
+	struct cec_back_ring ring;
+	void *ringp;
+	unsigned int irq;
+	int ring_connected;
+
+	int rsp_id;
+};
+
+extern void *get_cecdev_from_node(struct inode *inode);
+
+static inline void ring_send_rsp(struct cec_back_info *info,
+			int req_id, int ret, int err, void *ptr, char *data)
+{
+	struct cec_response *rsp;
+	int notify;
+
+	rsp = RING_GET_RESPONSE(&info->ring, info->ring.rsp_prod_pvt++);
+	rsp->rsp_id = info->rsp_id++;
+	rsp->req_id = req_id;
+	rsp->retval = ret;
+	rsp->errval = err;
+	rsp->ptr = ptr;
+	if(ret > 0)
+		memcpy(&rsp->data, data, ret);
+
+	RING_PUSH_RESPONSES_AND_CHECK_NOTIFY(&info->ring, notify);
+	if (notify)
+		notify_remote_via_irq(info->irq);
+}
+
+static int cec_work_to_do(struct cec_back_info *info)
+{
+	if (!info->ring_connected)
+		return 0;
+
+	if (likely(RING_HAS_UNCONSUMED_REQUESTS(&info->ring)))
+		return 1;
+
+	return 0;
+}
+
+static int cec_back_enable(cec_device *dev, unsigned long arg)
+{
+	cec_driver* drv = to_cec_driver(dev->dev.driver);
+	return drv->enable(dev, (arg) ? 1 : 0);
+}
+
+static int cec_back_set_rxmask(cec_device *dev, unsigned long arg)
+{
+	cec_driver* drv = to_cec_driver(dev->dev.driver);
+	return drv->set_rx_mask(dev, (unsigned short)arg | 0x8000);
+}
+
+static int cec_back_set_logical(cec_device *dev, unsigned long arg)
+{
+	unsigned short rx_mask;
+	cec_driver* drv = to_cec_driver(dev->dev.driver);
+
+	rx_mask = (unsigned char)arg;
+	if (rx_mask > 0xF) {
+		pr_err("%s: invalid logical addr %d\n", __func__, rx_mask);
+		return -EFAULT;
+	}
+	rx_mask = (1 << rx_mask);
+	return drv->set_rx_mask(dev, rx_mask | 0x8000);
+}
+
+static int cec_back_set_physical(cec_device *dev, unsigned long arg)
+{
+	cec_driver* drv = to_cec_driver(dev->dev.driver);
+	return drv->set_physical_addr(dev, (unsigned short) arg);
+}
+
+static int cec_back_send_msg(cec_device *dev, char *data, int len)
+{
+	cec_driver* drv = to_cec_driver(dev->dev.driver);
+	cm_buff *cmb;
+
+	if ((cmb = alloc_cmb(len)) == NULL)
+		return -ENOMEM;
+	memcpy(cmb_put(cmb, len), data, len);
+
+	return drv->xmit(dev, cmb, 0);
+}
+
+static int cec_back_rcv_msg(cec_device *dev, char *data, int len)
+{
+	cec_driver* drv = to_cec_driver(dev->dev.driver);
+	cm_buff *cmb = NULL;
+
+	cmb = drv->read(dev, NONBLOCK);
+	if (cmb) {
+		if (cmb->len > len) {
+			pr_err("%s: msg size more than buffer\n", __func__);
+			kfree_cmb(cmb);
+			return -ENOMEM;
+		}
+		len = cmb->len;
+		memcpy(data, cmb->data, cmb->len);
+		kfree_cmb(cmb);
+		return len;
+	}
+	return -EFAULT;
+}
+
+static void *cec_back_open(char *name)
+{
+	struct path path;
+	struct inode *inode;
+	void *dev = NULL;
+	int ret;
+
+	ret = kern_path(name, LOOKUP_FOLLOW, &path);
+	if(ret) {
+		pr_err("%s: can't find file path %s\n", __func__, name);
+		return NULL;
+	}
+	inode = path.dentry->d_inode;
+	if(inode)
+		dev = get_cecdev_from_node(inode);
+
+	return dev;
+}
+
+static int cec_kthread(void *arg)
+{
+	struct cec_back_info *info = arg;
+	int ret = 0;
+	int err = 0;
+	void *ptr = NULL;
+	char data[CEC_CMB_LENGTH];
+
+	pr_info("%s\n", __func__);
+
+	while (!kthread_should_stop()) {
+		wait_event_interruptible(info->wq, 
+			cec_work_to_do(info) || kthread_should_stop()); 
+		while (cec_work_to_do(info)) {
+			int rp = info->ring.sring->req_prod;
+			int rc = info->ring.req_cons;
+			struct cec_request *req;
+
+			if (rc == rp)
+				break;
+			while (rc != rp) {
+				req = RING_GET_REQUEST(&info->ring, rc);
+				rc ++;
+				switch(req->op) {
+				case CEC_OP_OPEN:
+					ptr = cec_back_open(req->cec_name);
+					break;
+				case CEC_OP_ENABLE:
+					ret = cec_back_enable(req->dev, req->arg);
+					break;
+				case CEC_OP_SET_RXMASK:
+					ret = cec_back_set_rxmask(req->dev, req->arg);
+					break;
+				case CEC_OP_SET_LOGICAL:
+					ret = cec_back_set_logical(req->dev, req->arg);
+					break;
+				case CEC_OP_SET_PHYSICAL:
+					ret = cec_back_set_physical(req->dev, req->arg);
+					break;
+				case CEC_OP_SEND_MSG:
+					ret = cec_back_send_msg(req->dev, req->data, req->len);
+					break;
+				case CEC_OP_RCV_MSG:
+					ret = cec_back_rcv_msg(req->dev, data, req->len);
+					break;
+				case CEC_OP_STANDBY:
+					break;
+				case CEC_OP_CEC_VER:
+					break;
+				case CEC_OP_VENDER_ID:
+					break;
+				}
+                		ring_send_rsp(info, req->req_id, ret, err, ptr, data);
+			}
+			info->ring.req_cons = rc;
+			info->ring.sring->req_event = rc + 1;
+		}
+	}
+	info->task = NULL;
+	return 0;
+}
+
+static irqreturn_t cec_back_interrupt(int irq, void *dev_id)
+{
+	struct cec_back_info *info = dev_id;
+
+	wake_up(&info->wq);
+	return IRQ_HANDLED;
+}
+
+static int connect_ring(struct cec_back_info *info)
+{
+	unsigned int evtchn;
+	unsigned int ring_ref;
+	grant_ref_t gref;
+	struct cec_sring *sring;
+	int ret;
+	const char * msg;
+
+	msg = "xenbus_scanf::event-channel";
+	ret = xenbus_scanf(XBT_NIL, info->dev->otherend,
+				"event-channel", "%u", &evtchn);
+	if (ret < 0)
+		goto error;
+
+	msg = "xenbus_scanf::ring-ref";
+	ret = xenbus_scanf(XBT_NIL, info->dev->otherend,
+				"ring-ref", "%u", &ring_ref);
+	if (ret < 0)
+		goto error;
+
+	msg = "xenbus_map_ring_valloc";
+	gref = ring_ref;
+	ret = xenbus_map_ring_valloc(info->dev, &gref, 1, &info->ringp);
+	if (ret)
+		goto error;
+	sring = (struct cec_sring *)info->ringp;
+	BACK_RING_INIT(&info->ring, sring, PAGE_SIZE);
+    
+	msg = "bind_interdomain_evtchn_to_irqhandler";
+	ret = bind_interdomain_evtchn_to_irqhandler(info->dev->otherend_id,
+			evtchn, cec_back_interrupt, 0, "cec-backend", info);
+	if (ret < 0)
+		goto unmap;
+	info->irq = ret;
+
+	info->ring_connected = 1;   
+	return 0;    
+unmap:
+	xenbus_unmap_ring_vfree(info->dev, info->ringp);
+error:
+	pr_err("Failed at %s: %d\n", msg, ret);
+	return ret;
+}
+
+static void disconnect_ring(struct cec_back_info *info)
+{
+	info->ring_connected = 0;
+
+	if (info->irq) {
+		unbind_from_irqhandler(info->irq, info);
+		info->irq = 0;
+	}
+
+	if (info->ringp) {
+		xenbus_unmap_ring_vfree(info->dev, info->ringp);
+		info->ringp = NULL;
+	}
+}
+
+static void frontend_changed(struct xenbus_device *dev,
+		enum xenbus_state frontend_state)
+{
+	struct cec_back_info *info = dev_get_drvdata(&dev->dev);
+    
+	pr_info("cec %s: FE %s BE %s\n", __func__,
+		xenbus_strstate(frontend_state), xenbus_strstate(dev->state));
+	switch (frontend_state) {
+	case XenbusStateInitialising:
+		if (dev->state == XenbusStateClosed)
+			xenbus_switch_state(dev, XenbusStateInitWait);
+		break;
+
+	case XenbusStateInitialised:
+	case XenbusStateConnected:
+		if (dev->state == XenbusStateConnected)
+			break;
+		if (connect_ring(info))
+			break;
+		info->task = kthread_run(cec_kthread, info, "%s", "cec-back");
+		xenbus_switch_state(dev, XenbusStateConnected);
+		break;
+	case XenbusStateClosing:
+		xenbus_switch_state(dev, XenbusStateClosing);
+		break;
+	case XenbusStateClosed:
+		kthread_stop(info->task);
+		disconnect_ring(info);
+		xenbus_switch_state(dev, XenbusStateClosed);
+		if (xenbus_dev_is_online(dev))
+			break;
+	case XenbusStateUnknown:
+		device_unregister(&dev->dev);
+		break;
+	default:
+		pr_err("cec %s: not support\n", __func__);
+		break;
+	}
+	return;
+}
+
+static int cec_back_probe(struct xenbus_device *dev,
+		const struct xenbus_device_id *id)
+{
+	struct cec_back_info *info;
+	int ret;
+
+	pr_info("%s start\n", __func__);
+	info = kzalloc(sizeof(*info), GFP_KERNEL);
+	if (!info)
+		return -ENOMEM;
+
+	info->dev = dev;
+	dev_set_drvdata(&dev->dev, info);
+	
+	init_waitqueue_head(&info->wq);
+//	info->task = kthread_run(cec_kthread, info, "%s", "cec-back");
+
+	ret = xenbus_switch_state(dev, XenbusStateInitWait);
+	if (ret)
+		pr_err("Failed to xenbus_switch_state: %d\n", ret);
+	return 0;
+}
+
+static int cec_back_remove(struct xenbus_device *dev)
+{
+	struct cec_back_info *info = dev_get_drvdata(&dev->dev);
+
+	pr_info("%s\n", __func__);
+	if (info->task != NULL)
+		kthread_stop(info->task);
+	disconnect_ring(info);
+	kfree(info);
+	dev_set_drvdata(&dev->dev, NULL);
+	return 0;
+}
+
+static const struct xenbus_device_id cec_back_ids[] = {
+	{ "cec" },
+	{ "" }
+};
+
+static struct xenbus_driver cec_back_driver = {
+	.ids = cec_back_ids,
+	.probe = cec_back_probe,
+	.remove = cec_back_remove,
+	.otherend_changed = frontend_changed,
+};
+
+static int __init xen_cec_back_init(void)
+{
+	if (!xen_domain())
+		return -ENODEV;
+
+	/* only exists in dom0 */
+	if (!xen_initial_domain())
+		return -ENODEV;
+
+	printk(KERN_ERR "%s start\n", __func__);
+	return xenbus_register_backend(&cec_back_driver);
+}
+late_initcall(xen_cec_back_init);
diff --git a/drivers/media/platform/rtk_cec/xen/cecdev.c b/drivers/media/platform/rtk_cec/xen/cecdev.c
new file mode 100644
index 00000000..9fe90b8
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/xen/cecdev.c
@@ -0,0 +1,188 @@
+#include <linux/module.h>
+#include <linux/uaccess.h>
+#include <linux/kernel.h>
+#include <linux/platform_device.h>
+#include <linux/miscdevice.h>
+#include <linux/types.h>
+#include <linux/of.h>
+#include <linux/fs.h>
+#include <linux/slab.h>
+#include <linux/string.h>
+
+#include "xencec.h"
+
+static struct cec_front_info *front_info = NULL;
+
+static long xen_cec_ioctl( struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	struct miscdevice *mdev = filp->private_data;
+	struct cec_front_info *info = front_info;
+	void *dev = dev_get_drvdata(mdev->this_device);;
+
+	if (!dev)
+		return -ENODEV;
+	
+	switch (cmd) {
+	case CEC_ENABLE:
+	case CEC_SET_RX_MASK:
+	case CEC_SET_LOGICAL_ADDRESS:
+	case CEC_SET_PHYSICAL_ADDRESS:
+	case CEC_SET_STANDBY_MODE:
+	case CEC_SET_CEC_VERSION:
+	case CEC_SET_DEVICE_VENDOR_ID:
+	case CEC_SET_RETRY_NUM:
+		return cec_front_set_param(info, dev, cmd, arg);
+	default:
+		return -1;
+	}
+}
+
+long xen_cec_compat_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	struct miscdevice *mdev = filp->private_data;
+	struct cec_front_info *info = front_info;
+	void *dev = dev_get_drvdata(mdev->this_device);
+	cec_msg  msg;
+	char data[CEC_CMB_LENGTH];
+	unsigned int temp[4];
+	int ret=0;
+
+	if (!dev)
+		return -ENODEV;
+	if (!filp->f_op->unlocked_ioctl)
+		return -ENOTTY;
+
+	switch(cmd) {
+	case CEC_ENABLE:
+	case CEC_SET_RX_MASK:
+	case CEC_SET_LOGICAL_ADDRESS:
+	case CEC_SET_PHYSICAL_ADDRESS:
+	case CEC_SET_STANDBY_MODE:
+	case CEC_SET_CEC_VERSION:
+	case CEC_SET_DEVICE_VENDOR_ID:
+	case CEC_SET_RETRY_NUM:
+		ret = filp->f_op->unlocked_ioctl(filp, cmd,
+				(unsigned long)compat_ptr(arg));
+		break;
+	case CEC_SEND_MESSAGE:
+		if (copy_from_user(&temp, (void __user *)arg, sizeof(cec_msg)))
+			return -EFAULT;
+		msg.buf = (unsigned char *)(unsigned long)temp[0];
+		msg.len = (unsigned char)temp[1];
+		if(msg.len >= CEC_CMB_LENGTH) {
+			pr_err("%s: length overflow\n", __func__);
+			return -EFAULT;
+		}
+		if (copy_from_user(data, (unsigned char __user *)compat_ptr((unsigned long)msg.buf), msg.len))
+			return -EFAULT;
+		ret = cec_front_send_message(info, dev, data, msg.len);
+		break;
+	case CEC_RCV_MESSAGE:
+		if (copy_from_user(&temp, (void __user *)arg, sizeof(cec_msg)))
+			return -EFAULT;
+		msg.buf = (unsigned char *)(unsigned long)temp[0];
+		msg.len = (unsigned char)temp[1];
+		ret = cec_front_rcv_message(info, dev, data, msg.len);
+		if (ret<0)
+			return -EFAULT;
+		if (copy_to_user((unsigned char __user *)msg.buf, data, ret))
+			return -EFAULT;
+		break;
+	default:
+		return -EFAULT;
+	}
+	return ret;
+}
+
+int xen_cec_open(struct inode *inode, struct file *filp)
+{
+	struct miscdevice *dev = filp->private_data;
+	struct cec_front_info *info = front_info;
+	const char *msg;
+	char path[CEC_NAME_LENGTH];
+	void *devptr = NULL;
+
+	msg = "nonseekable open";
+	if (nonseekable_open(inode, filp))
+		goto fail;
+
+	msg = "cec_front_open";
+	sprintf(path, "/dev/%s", dev->name);
+//	sprintf(path, "/dev/cec-0");
+	devptr = cec_front_open(info, path);
+	if(!devptr)
+		goto fail;
+	dev_set_drvdata(dev->this_device, devptr);
+
+	return 0;
+fail:
+	pr_err("%s: fail at %s\n", __func__, msg);
+	return -1;
+}
+
+const struct file_operations xen_cec_fops = {
+	.owner		= THIS_MODULE,
+	.open		= xen_cec_open,
+	.unlocked_ioctl	= xen_cec_ioctl,
+	.compat_ioctl	= xen_cec_compat_ioctl,
+	.poll		= NULL,
+};
+
+struct miscdevice cecdev = {
+	.minor = MISC_DYNAMIC_MINOR,
+	.name = "cec-0",
+	.fops = &xen_cec_fops,
+};
+
+static int xen_cec_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	const char *msg;
+
+	msg = "register misc dev";
+	if (misc_register(&cecdev))
+		goto fail;
+	
+	return 0;
+fail:
+	dev_err(dev, "%s: fail at %s\n", __func__, msg);
+	return -1; 
+}
+
+static const struct of_device_id xen_cec_ids[] = {
+	{ .compatible = "xen,cec", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, xen_cec_ids);
+
+static struct platform_driver xen_cec_driver = {
+	.probe = xen_cec_probe,
+	.driver = {
+		.name = "xen_cec",
+		.owner = THIS_MODULE,
+		.of_match_table = of_match_ptr(xen_cec_ids),
+	},
+};
+
+int xen_cec_register(struct cec_front_info *info)
+{
+	const char *msg;
+
+	msg = "platform_driver_register";
+	if (platform_driver_register(&xen_cec_driver))
+		goto fail;
+
+	front_info = info;
+	return 0;
+fail:
+	pr_err("%s: fail at %s\n", __func__, msg);
+	return -1;
+}
+
+void xen_cec_unregister(void)
+{
+	if(front_info != NULL)
+		platform_driver_unregister(&xen_cec_driver);
+	front_info = NULL;
+}
+
diff --git a/drivers/media/platform/rtk_cec/xen/cecfront.c b/drivers/media/platform/rtk_cec/xen/cecfront.c
new file mode 100644
index 00000000..7443fb9
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/xen/cecfront.c
@@ -0,0 +1,386 @@
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/delay.h>
+#include <linux/string.h>
+#include <xen/xen.h>
+#include <xen/events.h>
+#include <xen/xenbus.h>
+#include <xen/grant_table.h>
+#include "xencec.h"
+
+static inline struct cec_request *ring_new_req(struct cec_front_info *info)
+{
+	struct cec_request *req;
+
+	req = RING_GET_REQUEST(&info->ring, info->ring.req_prod_pvt);
+	info->ring.req_prod_pvt++;
+	req->req_id = info->req_id++;
+	return req;
+}
+
+static inline void ring_push_req(struct cec_front_info *info)
+{
+	int notify;
+	info->wait_done = 0;
+
+	RING_PUSH_REQUESTS_AND_CHECK_NOTIFY(&info->ring, notify);
+	if (notify)
+		notify_remote_via_irq(info->irq);
+}
+
+static inline int ring_wait_rsp(struct cec_front_info *info)
+{
+#define RETRY_CONUNT 2000
+	int i;
+	for (i = 0; i < RETRY_CONUNT; i++) {
+		if (info->wait_done)
+			return i;
+		udelay(100);
+	}
+	pr_info("%s timeout\n", __func__);
+	return -EINVAL;
+}
+
+static inline struct cec_response * ring_get_rsp(struct cec_front_info *info)
+{
+	struct cec_response *rsp;
+	int more_to_do;
+
+	rsp = RING_GET_RESPONSE(&info->ring, info->ring.rsp_cons++);
+again:
+	RING_FINAL_CHECK_FOR_RESPONSES(&info->ring, more_to_do);
+	if (more_to_do) {
+		struct cec_response *rsp_1 =
+			RING_GET_RESPONSE(&info->ring, info->ring.rsp_cons++);
+		pr_info("multiple response\n");
+		pr_info("rsp_id  = %d\n", rsp_1->rsp_id);
+		pr_info("req_id  = %d\n", rsp_1->req_id);
+//		pr_info("op      = %s\n", regif_op_string(rsp_1->op));
+		pr_info("rdev_id = %d\n", rsp_1->rdev_id);
+		pr_info("retval  = %d\n", rsp_1->retval);
+		pr_info("errval  = %d\n", rsp_1->errval);
+
+		goto again;
+	}
+	return rsp;
+}
+
+static struct cec_response *ring_send_req_ang_get_rsp(struct cec_front_info *info)
+{
+	ring_push_req(info);
+	if (ring_wait_rsp(info) < 0)
+		return NULL;
+	return ring_get_rsp(info);
+}
+
+int cec_front_set_param(struct cec_front_info *info, void *dev,
+				unsigned int cmd, unsigned long arg)
+{
+	struct cec_request *req;
+	struct cec_response *rsp;
+	
+	mutex_lock(&info->lock);
+	req = ring_new_req(info);
+	switch (cmd) {
+	case CEC_ENABLE:
+		req->op = CEC_OP_ENABLE;
+		break;
+	case CEC_SET_RX_MASK:
+		req->op = CEC_OP_SET_RXMASK;
+		break;
+	case CEC_SET_LOGICAL_ADDRESS:
+		req->op = CEC_OP_SET_LOGICAL;
+		break;
+	case CEC_SET_PHYSICAL_ADDRESS:
+		req->op = CEC_OP_SET_PHYSICAL;
+		break;
+	case CEC_SET_STANDBY_MODE:
+		req->op = CEC_OP_STANDBY;
+		break;
+	case CEC_SET_CEC_VERSION:
+		req->op = CEC_OP_CEC_VER;
+		break;
+	case CEC_SET_DEVICE_VENDOR_ID:
+		req->op = CEC_OP_VENDER_ID;
+		break;
+	case CEC_SET_RETRY_NUM:
+		req->op = CEC_OP_RETRY_NUM;
+		break;
+	}
+	req->arg = arg;
+	req->dev = dev;
+	rsp = ring_send_req_ang_get_rsp(info);
+	mutex_unlock(&info->lock);
+	if (!rsp)
+		return -1;
+	return 0;
+}
+
+int cec_front_send_message(struct cec_front_info *info, void *dev, char *data, int len)
+{
+	struct cec_request *req;
+	struct cec_response *rsp;
+
+	mutex_lock(&info->lock);
+
+	req = ring_new_req(info);
+	req->op = CEC_OP_SEND_MSG;
+	memcpy(req->data, data, len);
+	req->len = len;
+	req->dev = dev;
+	rsp = ring_send_req_ang_get_rsp(info);
+
+	mutex_unlock(&info->lock);
+
+	if (!rsp)
+		return -1;
+	return rsp->retval;
+}
+
+int cec_front_rcv_message(struct cec_front_info *info, void *dev, char *data, int len)
+{
+	struct cec_request *req;
+	struct cec_response *rsp;
+
+	mutex_lock(&info->lock);
+
+	req = ring_new_req(info);
+	req->op = CEC_OP_RCV_MSG;
+	req->len = len;
+	req->dev = dev;
+	rsp = ring_send_req_ang_get_rsp(info);
+
+	mutex_unlock(&info->lock);
+	if (!rsp)
+		return -1;
+	if (rsp->retval<0)
+		return rsp->retval;
+	
+	memcpy(data, rsp->data, rsp->retval);
+	return rsp->retval;
+}
+
+void *cec_front_open(struct cec_front_info *info, char *path)
+{
+	const char *msg;
+	struct cec_request *req;
+	struct cec_response *rsp;
+
+	msg = "get::open";
+	req = ring_new_req(info);
+	req->op = CEC_OP_OPEN;
+	strcpy(req->cec_name, path);
+	rsp = ring_send_req_ang_get_rsp(info);
+	if (!rsp)
+		goto fail;
+
+	return rsp->ptr;
+fail:
+	pr_err("%s: fail at %s\n", __func__, msg);
+	return NULL;
+}
+
+static irqreturn_t cec_front_interrupt(int irq, void *dev_id)
+{
+	struct cec_front_info *info = dev_id;
+
+	info->wait_done = 1;
+	return IRQ_HANDLED;
+}
+
+static void free_ring(struct xenbus_device *dev)
+{
+	struct cec_front_info *info = dev_get_drvdata(&dev->dev);
+
+	if (info->irq) {
+		unbind_from_irqhandler(info->irq, info);
+		info->irq = 0;
+	}
+
+	if (info->evtchn) {
+		xenbus_free_evtchn(dev, info->evtchn);
+		info->evtchn = 0;
+	}
+
+	if (info->ring_ref != 0) {
+		gnttab_end_foreign_access(info->ring_ref, 0, 
+				(unsigned long)info->ring.sring);
+		info->ring_ref = 0;
+	}
+	info->connected = 0;
+}
+
+static int setup_ring(struct xenbus_device *dev)
+{
+	struct cec_front_info *info = dev_get_drvdata(&dev->dev);
+	struct cec_sring *sring;
+	unsigned long ring_size = PAGE_SIZE;
+	int err;
+	grant_ref_t gref;
+	const char *msg;
+
+	sring = (struct cec_sring *)__get_free_pages
+			(GFP_NOIO | __GFP_HIGH, get_order(ring_size));
+	if (!sring)
+		return -ENOMEM;
+	
+	SHARED_RING_INIT(sring);
+	FRONT_RING_INIT(&info->ring, sring, ring_size);
+
+	msg = "xenbus_grant_ring";
+	err = xenbus_grant_ring(dev, info->ring.sring, 1, &gref);
+	if (err)
+		goto fail;
+	info->ring_ref = gref;
+
+	msg = "xenbus_alloc_evtchn";
+	err = xenbus_alloc_evtchn(dev, &info->evtchn);
+	if (err)
+		goto fail;
+
+	msg = "bind_evtchn_to_irqhandler";
+	err = bind_evtchn_to_irqhandler(info->evtchn, 
+			cec_front_interrupt, 0, "cec-frontend", info);
+	if (err <= 0)
+		goto fail;
+	info->irq = err;
+	return 0;
+fail:
+	xenbus_dev_fatal(dev, err, "%s\n", msg );
+	free_ring(dev);
+	return err;
+}
+
+static int talk_to_backend(struct xenbus_device *dev)
+{
+	struct cec_front_info *info = dev_get_drvdata(&dev->dev);
+	struct xenbus_transaction xbt;
+	int err;
+	const char *msg;
+	
+	msg = "setup_ring";
+	err = setup_ring(dev);
+	if (err)
+		goto destroy_ring;
+again:
+	msg = "xenbus_transaction_start";
+	err = xenbus_transaction_start(&xbt);
+	if (err)
+		goto destroy_ring;
+
+	msg = "xenbus_printf::event-channel";
+	err = xenbus_printf(xbt, dev->nodename, "event-channel"
+						, "%u", info->evtchn);
+	if (err)
+		goto abort_transaction;
+
+	msg = "xenbus_printf::ring-ref";
+	err = xenbus_printf(xbt, dev->nodename, "ring-ref", "%u", info->ring_ref);
+	if (err)
+		goto abort_transaction;
+
+	msg = "xenbus_transaction_end";
+	err = xenbus_transaction_end(xbt, 0);
+	if (err == -EAGAIN)
+		goto again;
+	if (err)
+		goto destroy_ring;
+
+	xenbus_switch_state(dev, XenbusStateInitialised);
+
+	info->connected = 1;
+	return 0;
+
+abort_transaction:
+	xenbus_transaction_end(xbt, 1);
+	xenbus_dev_fatal(dev, err, "%s", msg);
+destroy_ring:
+	free_ring(dev);
+	return err;
+}
+
+static void backend_changed(struct xenbus_device *dev,
+		enum xenbus_state backend_state)
+{
+	struct cec_front_info __maybe_unused *info = dev_get_drvdata(&dev->dev);
+
+	pr_info("cec %s: BE %s FE %s\n", __func__,
+		xenbus_strstate(backend_state), xenbus_strstate(dev->state));
+	switch (backend_state) {
+	case XenbusStateInitWait:
+		if (dev->state != XenbusStateInitialising)
+			break;
+		if (talk_to_backend(dev))
+			break;
+		break;
+	case XenbusStateConnected:
+		if (dev->state == XenbusStateConnected)
+			break;
+		xen_cec_register(info);
+		xenbus_switch_state(dev, XenbusStateConnected);
+		break;
+	case XenbusStateClosed:
+		if (dev->state == XenbusStateClosed)
+			break;
+	case XenbusStateClosing:
+		free_ring(dev);
+		xenbus_frontend_closed(dev);
+		break;
+	default:
+		pr_err("cec %s: not support\n", __func__);
+		break;
+	}
+}
+
+static int cec_front_probe(struct xenbus_device *dev,
+			const struct xenbus_device_id *id)
+{
+	struct cec_front_info *info;
+    
+	info  = devm_kzalloc(&dev->dev, sizeof(*info), GFP_KERNEL);
+	if (!info)
+		return -ENOMEM;
+
+	info->dev = dev;
+	mutex_init(&info->lock);
+	dev_set_drvdata(&dev->dev, info);
+	return 0;
+}
+
+static int cec_front_remove(struct xenbus_device *dev)
+{
+	struct cec_front_info *info = dev_get_drvdata(&dev->dev);
+
+	free_ring(dev);
+	kfree(info);
+	dev_set_drvdata(&dev->dev, NULL);
+	return 0;
+}
+
+static const struct xenbus_device_id cec_front_ids[] = {
+	{ "cec" },
+	{ "" }
+};
+
+static struct xenbus_driver cec_front_driver = {
+	.ids    = cec_front_ids,
+	.probe  = cec_front_probe,
+	.remove = cec_front_remove,
+	.otherend_changed = backend_changed,
+};
+
+static int __init cec_front_init(void)
+{
+	if (!xen_domain())
+		return -ENODEV;
+
+	return xenbus_register_frontend(&cec_front_driver);
+}
+module_init(cec_front_init);
+
+static void __exit cec_front_exit(void)
+{
+	xenbus_unregister_driver(&cec_front_driver);
+}
+module_exit(cec_front_exit);
+
diff --git a/drivers/media/platform/rtk_cec/xen/xencec.h b/drivers/media/platform/rtk_cec/xen/xencec.h
new file mode 100644
index 00000000..1d41b36
--- /dev/null
+++ b/drivers/media/platform/rtk_cec/xen/xencec.h
@@ -0,0 +1,70 @@
+
+#ifndef __XEN_PUBLIC_CEC_H__
+#define __XEN_PUBLIC_CEC_H__
+
+#include <xen/interface/io/ring.h>
+#include "../cec.h"
+#include "../cec_dev.h"
+
+#define CEC_OP_OPEN		0
+#define CEC_OP_ENABLE		1
+#define CEC_OP_SET_RXMASK	2
+#define CEC_OP_SET_LOGICAL	3
+#define CEC_OP_SET_PHYSICAL	4
+#define CEC_OP_SEND_MSG		5
+#define CEC_OP_RCV_MSG		6
+#define CEC_OP_STANDBY		7
+#define CEC_OP_CEC_VER		8
+#define CEC_OP_VENDER_ID	9
+#define CEC_OP_RETRY_NUM	10
+#define CEC_NAME_LENGTH		20
+#define CEC_CMB_LENGTH		128
+
+struct cec_request {
+	int req_id;
+
+	int op;
+	int rdev_id;
+	void *dev;
+	union {
+		char cec_name[CEC_NAME_LENGTH];
+		char data[CEC_CMB_LENGTH];
+		unsigned long arg;
+	};
+	int len;
+};
+
+struct cec_response {
+	int rsp_id;
+	int req_id;
+    
+	int op;
+	int rdev_id;
+	int retval;
+	int errval;
+	void *ptr;
+	char data[CEC_CMB_LENGTH];
+};
+
+DEFINE_RING_TYPES(cec, struct cec_request, struct cec_response);
+
+struct cec_front_info {
+	struct xenbus_device *dev;
+	struct cec_front_ring ring;
+	struct mutex lock;
+
+	int ring_ref;
+	unsigned int evtchn;
+	unsigned int irq;
+
+	int connected;
+	volatile int wait_done;
+	int req_id;
+};
+
+extern void *cec_front_open(struct cec_front_info *info, char *path);
+extern int cec_front_set_param(struct cec_front_info *info, void *dev, unsigned int cmd, unsigned long arg);
+extern int cec_front_send_message(struct cec_front_info *info, void *dev, char *data, int len);
+extern int cec_front_rcv_message(struct cec_front_info *info, void *dev, char *data, int len);
+extern int xen_cec_register(struct cec_front_info *info);
+#endif
diff --git a/drivers/media/platform/rtk_cvbsdetect/Kconfig b/drivers/media/platform/rtk_cvbsdetect/Kconfig
new file mode 100644
index 00000000..25ca6f8
--- /dev/null
+++ b/drivers/media/platform/rtk_cvbsdetect/Kconfig
@@ -0,0 +1,10 @@
+#Copyright (C) 2017 Realtek Semiconductor Corporation
+
+config RTK_CVBS_SWITCH
+	tristate "Realtek RTD1395 cvbs switch"
+	select SWITCH
+    select RTK_RPC
+	help
+	  enable CVBS detect feature on Realtek RTD1395 platform.
+
+
diff --git a/drivers/media/platform/rtk_cvbsdetect/Makefile b/drivers/media/platform/rtk_cvbsdetect/Makefile
new file mode 100644
index 00000000..0aa0f55
--- /dev/null
+++ b/drivers/media/platform/rtk_cvbsdetect/Makefile
@@ -0,0 +1,8 @@
+#
+# Makefile for cvbs switch module.
+#
+
+
+ccflags-y += -I$(srctree)/drivers/staging/android
+
+obj-$(CONFIG_RTK_CVBS_SWITCH)  += cvbs_switch.o
diff --git a/drivers/media/platform/rtk_cvbsdetect/cvbs_rpc.h b/drivers/media/platform/rtk_cvbsdetect/cvbs_rpc.h
new file mode 100644
index 00000000..c9e436f
--- /dev/null
+++ b/drivers/media/platform/rtk_cvbsdetect/cvbs_rpc.h
@@ -0,0 +1,74 @@
+#include <soc/realtek/kernel-rpc.h>
+
+#include "uapi/ion.h"
+#include "ion/ion.h"
+#include "uapi/ion_rtk.h"
+
+
+/* From FW amw_kernel_rpc.h */
+typedef enum {
+	ENUM_KERNEL_RPC_CREATE_AGENT,
+	ENUM_KERNEL_RPC_INIT_RINGBUF,
+	ENUM_KERNEL_RPC_PRIVATEINFO,
+	ENUM_KERNEL_RPC_RUN,
+	ENUM_KERNEL_RPC_PAUSE,
+	ENUM_KERNEL_RPC_SWITCH_FOCUS,
+	ENUM_KERNEL_RPC_MALLOC_ADDR,
+	ENUM_KERNEL_RPC_VOLUME_CONTROL,
+	ENUM_KERNEL_RPC_FLUSH,
+	ENUM_KERNEL_RPC_CONNECT,
+	ENUM_KERNEL_RPC_SETREFCLOCK,
+	ENUM_KERNEL_RPC_DAC_I2S_CONFIG,
+	ENUM_KERNEL_RPC_DAC_SPDIF_CONFIG,
+	ENUM_KERNEL_RPC_HDMI_OUT_EDID,
+	ENUM_KERNEL_RPC_HDMI_OUT_EDID2,
+	ENUM_KERNEL_RPC_HDMI_SET,
+	ENUM_KERNEL_RPC_HDMI_MUTE,
+	ENUM_KERNEL_RPC_ASK_DBG_MEM_ADDR,
+	ENUM_KERNEL_RPC_DESTROY,
+	ENUM_KERNEL_RPC_STOP,
+	ENUM_KERNEL_RPC_CHECK_READY,   // check if Audio get memory pool from AP
+	ENUM_KERNEL_RPC_GET_MUTE_N_VOLUME,	 // get mute and volume level
+	ENUM_KERNEL_RPC_EOS,
+	ENUM_KERNEL_RPC_ADC0_CONFIG,
+	ENUM_KERNEL_RPC_ADC1_CONFIG,
+	ENUM_KERNEL_RPC_ADC2_CONFIG,
+#if defined(AUDIO_TV_PLATFORM)
+	ENUM_KERNEL_RPC_BBADC_CONFIG,
+	ENUM_KERNEL_RPC_I2SI_CONFIG,
+	ENUM_KERNEL_RPC_SPDIFI_CONFIG,
+#endif // AUDIO_TV_PLATFORM
+	ENUM_KERNEL_RPC_HDMI_OUT_VSDB,
+	ENUM_VIDEO_KERNEL_RPC_CONFIG_TV_SYSTEM,
+	ENUM_VIDEO_KERNEL_RPC_CONFIG_HDMI_INFO_FRAME,
+	ENUM_VIDEO_KERNEL_RPC_QUERY_DISPLAY_WIN,
+	ENUM_VIDEO_KERNEL_RPC_PP_INIT_PIN,
+	ENUM_KERNEL_RPC_INIT_RINGBUF_AO,
+	ENUM_VIDEO_KERNEL_RPC_VOUT_EDID_DATA,
+	ENUM_KERNEL_RPC_AUDIO_POWER_SET,
+	ENUM_VIDEO_KERNEL_RPC_VOUT_VDAC_SET,
+	ENUM_VIDEO_KERNEL_RPC_QUERY_CONFIG_TV_SYSTEM
+} ENUM_AUDIO_KERNEL_RPC_CMD;
+
+
+enum VIDEO_ENUM_PRIVATEINFO {
+	ENUM_PRIVATEINFO_VIDEO_CHECK_SECURITY_ID = 0,
+	ENUM_PRIVATEINFO_VIDEO_DISPLAY_RATIO = 1,
+	ENUM_PRIVATEINFO_VIDEO_DISPLAY_X_Y_W_H = 2,
+	ENUM_PRIVATEINFO_VIDEO_CVBS_POWER_OFF = 3,
+	ENUM_PRIVATEINFO_VIDEO_VO_CAPTURE = 4,
+	ENUM_PRIVATEINFO_VIDEO_VDAC_POWER_OFF = 5,
+	ENUM_PRIVATEINFO_HDMI_RANGE_SETTING = 6,
+	ENUM_PRIVATEINFO_VO_DISPLAY_RATIO_TYPE = 7,
+	ENUM_PRIVATEINFO_MIXDD_DISPLAY_RATIO = 8,
+	ENUM_PRIVATEINFO_MIX1_DISPLAY_RATIO = 9,
+	ENUM_PRIVATEINFO_MIX2_DISPLAY_RATIO = 10,
+};
+
+struct VIDEO_RPC_PRIVATEINFO_PARAMETERS {
+	unsigned int instanceID;
+	enum VIDEO_ENUM_PRIVATEINFO type;
+	unsigned int privateInfo[16];
+};
+
+
diff --git a/drivers/media/platform/rtk_cvbsdetect/cvbs_switch.c b/drivers/media/platform/rtk_cvbsdetect/cvbs_switch.c
new file mode 100644
index 00000000..d3b8cc8
--- /dev/null
+++ b/drivers/media/platform/rtk_cvbsdetect/cvbs_switch.c
@@ -0,0 +1,245 @@
+/*
+ * cvbs_switch.c - RTK cvbs switch driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+#include "cvbs_switch.h"
+
+int cvbs_rpc(unsigned int detected)
+{
+	struct VIDEO_RPC_PRIVATEINFO_PARAMETERS *rpc = NULL;
+	struct ion_handle *handle = NULL;
+	unsigned int RPC_ret;
+	ion_phys_addr_t dat;
+	size_t len;
+	int ret = -1;
+	unsigned long offset;
+
+	handle = ion_alloc(cvbs_rpc_ion_client, 4096, 1024,
+			RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+			ION_FLAG_NONCACHED | ION_FLAG_SCPUACC
+			| ION_FLAG_ACPUACC);
+	if (IS_ERR(handle)) {
+		cvbs_error("%s ion_alloc fail\n", __func__);
+		goto exit;
+	}
+	if (ion_phys(cvbs_rpc_ion_client, handle, &dat, &len) != 0) {
+		cvbs_error(KERN_ERR "%s ion_phys fail\n", __func__);
+		goto exit;
+	}
+	rpc = ion_map_kernel(cvbs_rpc_ion_client, handle);
+
+	offset = get_rpc_alignment_offset(
+			sizeof(struct VIDEO_RPC_PRIVATEINFO_PARAMETERS));
+	memset(rpc, 0, sizeof(struct VIDEO_RPC_PRIVATEINFO_PARAMETERS));
+
+	rpc->type = htonl(ENUM_PRIVATEINFO_VIDEO_CVBS_POWER_OFF);
+	rpc->privateInfo[0] = htonl(detected);
+
+	if (send_rpc_command(RPC_AUDIO,
+		ENUM_VIDEO_KERNEL_RPC_VOUT_VDAC_SET,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + offset),
+		&RPC_ret)) {
+		cvbs_error("[%s %d RPC fail]\n", __func__, __LINE__);
+		goto exit;
+	}
+	ret = 0;
+
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(cvbs_rpc_ion_client, handle);
+		ion_free(cvbs_rpc_ion_client, handle);
+	}
+	return ret;
+}
+
+ssize_t cvbs_switch_print_state(struct switch_dev *sdev, char *buf)
+{
+	cvbs_debug("cvbs_switch_print_state");
+	return sprintf(buf, "%d", cvbs_det.state);
+}
+
+static void cvbs_switch_work_func(struct work_struct *work)
+{
+	int ret = 0;
+
+	if (gpio_activity)
+		cvbs_det.state = gpio_get_value(cvbs_det.gpio);
+	else
+		cvbs_det.state = !gpio_get_value(cvbs_det.gpio);
+
+	if (cvbs_det.state == 0) { /*cvbs off*/
+		switch_set_state(&cvbs_det.sdev, cvbs_det.state);
+		ret = cvbs_rpc(1);
+		gpio_set_value(cvbs_det.gpio_mute, 0);/*mute*/
+		cvbs_info("cvbs unplugged");
+	} else if (cvbs_det.state == 1) { /*cvbs on*/
+		switch_set_state(&cvbs_det.sdev, cvbs_det.state);
+		ret = cvbs_rpc(0);
+		gpio_set_value(cvbs_det.gpio_mute, 1);/*unmute*/
+		cvbs_info("cvbs plugged");
+	}
+
+	if (ret)
+		cvbs_error("rpc failed\n");
+}
+
+static irqreturn_t cvbs_switch_isr(int irq, void *data)
+{
+	schedule_work(&cvbs_det.work);
+	return IRQ_HANDLED;
+}
+
+static int rtk_cvbs_switch_probe(struct platform_device *pdev)
+{
+	int ret = 0, mode;
+
+	if (get_rtd_chip_revision() == RTD_CHIP_A01) {
+		return -1;
+	}
+	cvbs_det.sdev.name = CVBS_SWITCH_NAME;
+	cvbs_det.sdev.print_state = cvbs_switch_print_state;
+	cvbs_det.dev = &pdev->dev;
+	cvbs_rpc_ion_client = ion_client_create(rtk_phoenix_ion_device,
+						"CVBS_SWITCH");
+
+	ret = switch_dev_register(&cvbs_det.sdev);
+	if (ret < 0)
+		cvbs_error("err_register_switch");
+
+
+	if (of_property_read_u32(pdev->dev.of_node, "detect-mode", &mode)) {
+		cvbs_error("Get detect-mode failed\n");
+		cvbs_error("cvbs use GPIO21 to detect\n");
+	}
+
+	if (mode)
+		if (of_property_read_u32(pdev->dev.of_node,
+				"gpio-activity", &gpio_activity))
+			cvbs_error("Get gpio-activity failed\n");
+
+	cvbs_det.gpio = of_get_gpio_flags(pdev->dev.of_node, 0, NULL);
+	ret = gpio_request(cvbs_det.gpio, "cvbs_gpio");
+	if (ret < 0)
+		cvbs_error("%s: can't request gpio %d\n",
+				__func__, cvbs_det.gpio);
+
+	gpio_set_debounce(cvbs_det.gpio, 30*1000);
+
+	cvbs_det.gpio_mute = of_get_named_gpio(pdev->dev.of_node, "gpio_mute", 0);
+	ret = gpio_request(cvbs_det.gpio_mute, "cvbs_gpio_mute");
+	if (ret < 0)
+		cvbs_error("%s: can't request gpio %d\n",
+				__func__, cvbs_det.gpio_mute);
+
+	INIT_WORK(&cvbs_det.work, cvbs_switch_work_func);
+	schedule_work(&cvbs_det.work);
+
+	cvbs_det.irq = gpio_to_irq(cvbs_det.gpio);
+
+	if (!cvbs_det.irq)
+		cvbs_error("Fail to get cvbs irq");
+	else
+		cvbs_debug("irq_num(%u)\n", cvbs_det.irq);
+
+	irq_set_irq_type(cvbs_det.irq, IRQ_TYPE_EDGE_BOTH);
+	ret = request_irq(cvbs_det.irq, cvbs_switch_isr,
+		IRQF_SHARED, "cvbs_switch", cvbs_det.dev);
+	if (ret)
+		cvbs_error("Cannot register IRQ %d", cvbs_det.irq);
+
+	return ret;
+}
+
+
+static int rtk_cvbs_switch_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	disable_irq(cvbs_det.irq);
+	free_irq(cvbs_det.irq, cvbs_det.dev);
+	/* Cancel work and wait for it to finish */
+	cancel_work_sync(&cvbs_det.work);
+
+	return 0;
+}
+
+static int rtk_cvbs_switch_resume(struct platform_device *pdev)
+{
+	int ret;
+
+	schedule_work(&cvbs_det.work);
+	gpio_set_debounce(cvbs_det.gpio, 30*1000);
+	irq_set_irq_type(cvbs_det.irq, IRQ_TYPE_EDGE_BOTH);
+	ret = request_irq(cvbs_det.irq, cvbs_switch_isr,
+		IRQF_SHARED, "cvbs_switch", cvbs_det.dev);
+	if (ret)
+		cvbs_error("Cannot register IRQ %d", cvbs_det.irq);
+
+	return 0;
+}
+
+
+static int rtk_cvbs_switch_remove(struct platform_device *pdev)
+{
+
+	disable_irq(cvbs_det.irq);
+	free_irq(cvbs_det.irq, cvbs_det.dev);
+	gpio_free(cvbs_det.gpio);
+	gpio_free(cvbs_det.gpio_mute);
+	/* Cancel work and wait for it to finish */
+	cancel_work_sync(&cvbs_det.work);
+	switch_dev_unregister(&cvbs_det.sdev);
+
+	return 0;
+}
+
+
+static const struct of_device_id rtk_cvbs_match_table[] = {
+	{.compatible = "realtek,rtd1395-cvbs-switch",},
+	{},
+};
+
+
+static struct platform_driver rtk_cvbs_switch_driver = {
+	.probe		= rtk_cvbs_switch_probe,
+	.driver		= {
+		.name	= "switch-cvbs",
+		.of_match_table = of_match_ptr(rtk_cvbs_match_table),
+		.owner	= THIS_MODULE,
+	},
+	.suspend	= rtk_cvbs_switch_suspend,
+	.resume		= rtk_cvbs_switch_resume,
+	.remove		= rtk_cvbs_switch_remove,
+};
+
+static int __init rtk_cvbs_switch_init(void)
+{
+	int ret = 0;
+
+	ret = platform_driver_register(&rtk_cvbs_switch_driver);
+	if (ret != 0)
+		goto err_register;
+
+	return 0;
+err_register:
+	platform_driver_unregister(&rtk_cvbs_switch_driver);
+
+	return -EFAULT;
+}
+
+static void __exit rtk_cvbs_switch_exit(void)
+{
+	platform_driver_unregister(&rtk_cvbs_switch_driver);
+
+}
+
+module_init(rtk_cvbs_switch_init);
+module_exit(rtk_cvbs_switch_exit);
+MODULE_DESCRIPTION("Realtek CVBS Switch driver");
+MODULE_LICENSE("GPL v2");
+
diff --git a/drivers/media/platform/rtk_cvbsdetect/cvbs_switch.h b/drivers/media/platform/rtk_cvbsdetect/cvbs_switch.h
new file mode 100644
index 00000000..8d5dbc6
--- /dev/null
+++ b/drivers/media/platform/rtk_cvbsdetect/cvbs_switch.h
@@ -0,0 +1,52 @@
+#include <linux/platform_device.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/device.h>
+#include <linux/kernel.h>
+#include <linux/types.h>
+#include <linux/switch.h>
+#include <linux/of.h>
+
+#include <linux/gpio.h>
+#include <linux/of_gpio.h>
+#include <linux/interrupt.h>
+#include <linux/workqueue.h>
+#include <soc/realtek/rtk_chip.h>
+
+#include "cvbs_rpc.h"
+
+
+//#define CVBS_DEBUG
+
+#define CVBS_SWITCH_NAME "cvbs_switch"
+#define cvbs_error(format, ...)  \
+	pr_err("[CVBS_SWITCH_ERR] " format "\n", ## __VA_ARGS__)
+#define cvbs_info(format, ...)  \
+	pr_info("[CVBS_SWITCH] " format "\n", ## __VA_ARGS__)
+#ifdef CVBS_DEBUG
+#define cvbs_debug(format, ...)  \
+	pr_info("[CVBS_SWITCH_DEBUG] " format "\n", ## __VA_ARGS__)
+#else
+#define cvbs_debug(format, ...)
+#endif
+
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+#define CONVERT_FOR_AVCPU(x)        ((unsigned int)(x) | 0xA0000000)
+#else
+#define CONVERT_FOR_AVCPU(x)        (x)
+#endif
+
+struct CVBS_DET {
+	struct switch_dev sdev;
+	struct device *dev;
+	int gpio;
+	int gpio_mute;
+	unsigned int irq;
+	int state;
+	struct work_struct work;
+} cvbs_det;
+
+int gpio_activity;
+struct ion_client *cvbs_rpc_ion_client;
+
+extern struct ion_device *rtk_phoenix_ion_device;
diff --git a/drivers/media/platform/rtk_dptx/Kconfig b/drivers/media/platform/rtk_dptx/Kconfig
new file mode 100644
index 00000000..fd730f8
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/Kconfig
@@ -0,0 +1,5 @@
+#Copyright (C) 2007-2013 Realtek Semiconductor Corporation.
+# drivers/Kconfig
+
+config RTK_DPTX
+	bool "RTK Display Port Support"
diff --git a/drivers/media/platform/rtk_dptx/Makefile b/drivers/media/platform/rtk_dptx/Makefile
new file mode 100644
index 00000000..b31ea01
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/Makefile
@@ -0,0 +1,9 @@
+#
+# Makefile for CEC linux kernel module.
+#
+
+ccflags-y += -I$(srctree)/drivers/video/fbdev/rtk
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_mhltx
+ccflags-y += -I$(srctree)/drivers/staging/android
+
+obj-$(CONFIG_RTK_DPTX)  += dptx_core.o dptx_switch.o dptx_hwapi.o dptx_aux_channel.o dptx_rpc.o dptx_edid.o dptx_hdcp.o
diff --git a/drivers/media/platform/rtk_dptx/dptx_aux_channel.c b/drivers/media/platform/rtk_dptx/dptx_aux_channel.c
new file mode 100644
index 00000000..45ff35f
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_aux_channel.c
@@ -0,0 +1,206 @@
+/*
+ *  dptx_aux_channel.c - RTK display port aux channel driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+#include "dptx_aux_channel.h"
+
+static void dptx_aux_reset(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+
+	SetReg(base, PBB_A1_DP_RESET_CTRL, 0x20);
+	SetReg(base, PBB_A1_DP_RESET_CTRL, 0x0);
+}
+
+static bool dptx_aux_write(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned int ucAddr,
+			unsigned char ucLength,
+			unsigned char *pucWriteArray)
+{
+	void __iomem *base = hwinfo->reg_base;
+	int i;
+	unsigned char ucAddrH, ucAddrM, ucAddrL;
+
+	ucAddrH = (ucAddr>>16) & 0xFF;
+	ucAddrM = (ucAddr>>8) & 0xFF;
+	ucAddrL = ucAddr & 0xFF;
+	//Clear fifo & interrupt
+	SetBit(base, PBD_AB_AUX_FIFO_CTRL, ~(_BIT1 | _BIT0), (_BIT1 | _BIT0));
+	SetReg(base, PBD_B1_AUX_IRQ_EVENT, 0x3F);
+	//Command request
+	SetReg(base, PBD_A4_AUXTX_REQ_CMD, ucAddrH);
+	SetReg(base, PBD_A5_AUXTX_REQ_ADDR_M, ucAddrM);
+	SetReg(base, PBD_A6_AUXTX_REQ_ADDR_L, ucAddrL);
+	SetReg(base, PBD_A7_AUXTX_REQ_LEN, ((ucLength > 0) ? (ucLength - 1) : 0));
+
+	for(i = 0; i < ucLength; i++)
+		SetReg(base, PBD_A8_AUXTX_REQ_DATA, pucWriteArray[i]);
+	//Start transfer
+	SetBit(base, PBD_A3_AUXTX_TRAN_CTRL, ~_BIT0, _BIT0);
+	
+	if(down_timeout(&hwinfo->sem, 100))
+		goto write_fail;
+
+	if(hwinfo->aux_status)
+		return true;
+write_fail:
+	pr_err("%s fail\n", __func__);
+	return false;
+}
+
+static bool dptx_aux_read(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned int ucAddr,
+			unsigned char ucLength,
+			unsigned char *pucReadArray)
+{
+	void __iomem *base = hwinfo->reg_base;
+	int i;
+
+	unsigned char ucAddrH, ucAddrM, ucAddrL;
+
+	ucAddrH = (ucAddr>>16) & 0xFF;
+	ucAddrM = (ucAddr>>8) & 0xFF;
+	ucAddrL = ucAddr & 0xFF;
+	
+	SetReg(base, PBD_B1_AUX_IRQ_EVENT, 0x3F);
+	SetBit(base, PBD_AB_AUX_FIFO_CTRL, ~(_BIT1 | _BIT0), (_BIT1 | _BIT0));
+	SetReg(base, PBD_A4_AUXTX_REQ_CMD, ucAddrH);
+	SetReg(base, PBD_A5_AUXTX_REQ_ADDR_M, ucAddrM);
+	SetReg(base, PBD_A6_AUXTX_REQ_ADDR_L, ucAddrL);
+	
+	SetReg(base, PBD_A7_AUXTX_REQ_LEN, ((ucLength > 0) ? (ucLength - 1) : 0));
+	SetBit(base, PBD_A3_AUXTX_TRAN_CTRL, ~_BIT0, _BIT0);
+
+	if(down_timeout(&hwinfo->sem, 100))
+		goto read_fail;
+
+	if(hwinfo->aux_status) {
+		for(i=0; i<ucLength; i++) {
+			*pucReadArray = GetReg(base, PBD_AA_AUX_REPLY_DATA);
+			pucReadArray++;
+		}
+		return true;
+	}
+read_fail:
+	pr_err("%s fail\n", __func__);
+	return false;
+}
+
+bool dptx_aux_native_write(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned int ucAddr,
+			unsigned char ucLength,
+			unsigned char *pucWriteArray)
+{
+	ucAddr = ucAddr | (0x80 << 16);
+	return dptx_aux_write(hwinfo, ucAddr, ucLength, pucWriteArray);
+}
+
+bool dptx_aux_native_read(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned int ucAddr,
+			unsigned char ucLength,
+			unsigned char *pucReadArray)
+{
+	ucAddr = ucAddr | (0x90 << 16);	
+	return dptx_aux_read(hwinfo, ucAddr, ucLength, pucReadArray);
+}
+
+bool dptx_aux_i2c_write(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned char ucSlaveAddress,
+			unsigned char ucLength,
+			unsigned char *pucReadArray,
+			unsigned char bMOT)
+{
+	unsigned int ucAddr;
+
+	ucAddr = ((0x00 | bMOT<<6) << 16) | 0x00 << 8 | ucSlaveAddress;
+
+	if(!dptx_aux_write(hwinfo, ucAddr, ucLength, pucReadArray)) {
+		if(!dptx_aux_write(hwinfo, ucAddr, ucLength, pucReadArray)) {
+			return false;
+		}
+	}
+	return true;
+}
+
+bool dptx_aux_i2c_read(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned char ucSlaveAddress,
+			unsigned char ucLength,
+			unsigned char *pucReadArray,
+			unsigned char bMOT)
+{
+	unsigned int ucAddr;
+
+	ucAddr = ((0x10 | bMOT<<6) << 16) | 0x00 << 8 | ucSlaveAddress;
+
+	if(!dptx_aux_read(hwinfo, ucAddr, ucLength, pucReadArray)) {
+		if(!dptx_aux_read(hwinfo, ucAddr, ucLength, pucReadArray)) {
+			return false;
+		}
+	}
+	return true;
+}
+
+void dptx_aux_irq_handle(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	unsigned int reg;
+
+	reg = GetReg(base, PBD_B1_AUX_IRQ_EVENT);
+
+	if((reg & _BIT5)==_BIT5) {
+		hwinfo->aux_status = 1;
+		up(&hwinfo->sem);
+	} else {
+		pr_err("not expect interrupt 0x%x\n", reg);
+		hwinfo->aux_status = 0;
+		dptx_aux_reset(hwinfo);
+		up(&hwinfo->sem);
+	}
+	
+	SetReg(base, PBD_B1_AUX_IRQ_EVENT, 0x3F);
+	SetBit(base, PBD_AB_AUX_FIFO_CTRL, ~(_BIT1 | _BIT0), (_BIT1 | _BIT0));
+}
+
+static void __maybe_unused dptx_aux_physet(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	
+	SetBit(base, PBD_61_AUX_1, ~(_BIT7 | _BIT6 | _BIT5), _BIT7);
+	SetBit(base, PBD_61_AUX_1, ~(_BIT3 | _BIT2 | _BIT1 | _BIT0),
+				(_BIT3 | _BIT2 | _BIT1 | _BIT0));
+	SetBit(base, PBD_62_AUX_2, ~(_BIT5 | _BIT0), _BIT5 |_BIT0);
+	SetBit(base, PBD_66_AUX_6, ~(_BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0),
+				(_BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0));
+	SetReg(base, PBD_67_DIG_TX_03, 0xFF);
+}
+
+void dptx_aux_initial(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+
+//	dptx_aux_physet(hwinfo);
+
+	// Sync end Pattern Error Handle Disable
+	SetBit(base, PBD_F6_AUX_DIG_PHY8, ~_BIT1, _BIT1);
+//	SetReg(base, PBD_64_AUX_4, 0xCA);
+	// Set Aux Timeout
+//	SetReg(base, PBD_A1_AUX_TIMEOUT, 0x95);
+	// Power On Aux CH
+	SetBit(base, PBD_A0_AUX_TX_CTRL, ~_BIT0, _BIT0);
+
+//	SetBit(base, PBD_65_AUX_5, ~_BIT7, 0);
+	SetBit(base, PBD_B2_AUX_IRQ_EN, 0,
+		_BIT0 | _BIT1 | _BIT2 | _BIT3 | _BIT4 | _BIT5 | _BIT6 | _BIT7);
+
+//	SetReg(base, PBD_AF_AUX_RETRY_1, 0x2);
+//	SetBit(base, PBD_B0_AUX_RETRY_2,
+//		~(_BIT7 | _BIT6 | _BIT5 | _BIT4 | _BIT3), _BIT5);
+//		~(_BIT7 | _BIT6 | _BIT5 | _BIT4 | _BIT3), _BIT7 | _BIT5);
+}
+
diff --git a/drivers/media/platform/rtk_dptx/dptx_aux_channel.h b/drivers/media/platform/rtk_dptx/dptx_aux_channel.h
new file mode 100644
index 00000000..c83f8e8
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_aux_channel.h
@@ -0,0 +1,41 @@
+/*
+ *  dptx_aux_channel.h - RTK display port driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __DPTX_AUX_CHANNEL_H__
+#define __DPTX_AUX_CHANNEL_H__
+
+#include "dptx_hwapi.h"
+
+bool dptx_aux_native_write(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned int ucAddr,
+			unsigned char ucLength,
+			unsigned char *pucWriteArray);
+
+bool dptx_aux_native_read(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned int ucAddr,
+			unsigned char ucLength,
+			unsigned char *pucReadArray);
+
+bool dptx_aux_i2c_write(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned char ucSlaveAddress,
+			unsigned char ucLength,
+			unsigned char *pucReadArray,
+			unsigned char bMOT);
+
+bool dptx_aux_i2c_read(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned char ucSlaveAddress,
+			unsigned char ucLength,
+			unsigned char *pucReadArray,
+			unsigned char bMOT);
+
+void dptx_aux_initial(struct rtk_dptx_hwinfo *hwinfo);
+void dptx_aux_irq_handle(struct rtk_dptx_hwinfo *hwinfo);
+#endif  //__DPTX_AUX_CHANNEL_H__
diff --git a/drivers/media/platform/rtk_dptx/dptx_core.c b/drivers/media/platform/rtk_dptx/dptx_core.c
new file mode 100644
index 00000000..76889dc
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_core.c
@@ -0,0 +1,689 @@
+/*
+ *  dptx_core.c - RTK display port driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/interrupt.h>
+#include <linux/of.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+#include <linux/reset.h>
+#include <linux/uaccess.h>
+#include <linux/delay.h>
+
+#include "dptx_core.h"
+#include "dptx_aux_channel.h"
+
+#define DPTX_RES_MAX 0xFF
+#define EDID_SIZE 256
+static int dptxHpdDetect = 0;
+extern struct ion_device *rtk_phoenix_ion_device;
+
+const char dptx_kylin_support_vic[] = {
+	VIC_1280X720P60,
+	VIC_1920X1080P60,
+	VIC_3840X2160P30,
+	VIC_3840X2160P60,
+};
+
+const char dptx_thor_support_vic[] = {
+	VIC_1280X720P60,
+	VIC_1920X1080P60,
+	VIC_3840X2160P30,
+	VIC_1024X768P60,
+	VIC_1440X768P60,
+	VIC_1440X900P60,
+	VIC_1280X800P60,
+	VIC_960X544P60,
+};
+
+static void rtk_hdmi_power_on(void)
+{
+	void __iomem *chk_reg;
+	unsigned int i;
+
+	chk_reg = ioremap(0x98000190, 0x1);
+	writel(0x11a, chk_reg);
+	for(i = 0; i < 4096 ; i++);
+	writel(0x1be, chk_reg);
+	for(i = 0; i < 4096 ; i++);
+	writel(0xbf, chk_reg);
+	for(i = 0; i < 4096 ; i++);
+	iounmap(chk_reg);
+}
+
+static int rtk_tveint_en(struct rtk_dptx_device *dptx_dev, int en)
+{
+	struct device *dev = dptx_dev->dev;
+	void  __iomem *tve_reg;
+	void  __iomem *vdac_reg;
+	unsigned int reg, reg1;
+	bool clken;
+	int ret = -1;
+
+	/* check tve clock enable or not */
+	clken = __clk_is_enabled(dptx_dev->tve_clk);
+	if(!clken) {
+		dev_info(dev, "tve clock is disable, ignore\n");
+		return ret;
+	}
+
+	tve_reg = ioremap(0x9801801c, 0x1);
+	vdac_reg = ioremap(0x980183a0, 0x1);
+	reg = readl(tve_reg);
+
+	if((reg & 0x4) && !en) {
+		reg1 = readl(vdac_reg);
+		reg1 = reg1 & ~0x40000000;
+		writel(reg1, vdac_reg);
+		writel(0x4, tve_reg);
+		ret = 0;
+	} else if(!(reg & 0x4) && en) {
+		writel(0x5, tve_reg);
+		ret = 0;
+	}
+	iounmap(tve_reg);
+	iounmap(vdac_reg);
+	if(ret < 0)
+		dev_info(dev, "tve interrupt = 0x%x, ignore\n", reg);
+	return ret;
+}
+
+static void rtk_dptx_disable(struct rtk_dptx_device *dptx_dev)
+{
+	int ret;
+
+	dptx_dev->dptx_en = 0;
+	ret = reset_control_status(dptx_dev->lvds_rst);
+	if (ret)
+		return;
+	rtk_tveint_en(dptx_dev, 0);
+	dptx_lvdsint_en(&dptx_dev->hwinfo, 0);
+	msleep(20);
+
+	dptx_close_phy(&dptx_dev->hwinfo);
+	reset_control_assert(dptx_dev->lvds_rst);
+	dptx_close_pll(&dptx_dev->hwinfo);
+}
+
+static void rtk_dptx_enable(struct rtk_dptx_device *dptx_dev)
+{
+	int ret = 0;
+	int status;
+
+	status = reset_control_status(dptx_dev->lvds_rst);
+	if (!status) {
+		ret = rtk_tveint_en(dptx_dev, 0);
+		dptx_lvdsint_en(&dptx_dev->hwinfo, 0);
+		msleep(20);
+
+		dptx_close_phy(&dptx_dev->hwinfo);
+		reset_control_assert(dptx_dev->lvds_rst);
+		dptx_close_pll(&dptx_dev->hwinfo);
+	}
+
+	dptx_pixelpll_setting(&dptx_dev->hwinfo);
+	reset_control_deassert(dptx_dev->lvds_rst);
+
+	dptx_dppll_setting(&dptx_dev->hwinfo);
+	dptx_initial(&dptx_dev->hwinfo);
+
+	if(!status && ret == 0)
+		rtk_tveint_en(dptx_dev, 1);
+
+	dptx_dev->dptx_en = 1;
+}
+
+static unsigned int vic_to_vo_standard(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned char vic)
+{
+	unsigned int standard;
+
+	switch(vic) {
+	case VIC_1280X720P60:
+		hwinfo->out_type = DP_FORMAT_720P_60;
+		standard = VO_STANDARD_DP_FORMAT_1280_720P_60;
+		break;
+	case VIC_1920X1080P60:
+		hwinfo->out_type = DP_FORMAT_1080P_60;
+		standard = VO_STANDARD_DP_FORMAT_1920_1080P_60;
+		break;
+	case VIC_3840X2160P30:
+		hwinfo->out_type = DP_FORMAT_2160P_30;
+		standard = VO_STANDARD_DP_FORMAT_2160P_30;
+		break;
+	case VIC_3840X2160P60:
+		hwinfo->out_type = DP_FORMAT_2160P_60;
+		standard = VO_STANDARD_DP_FORMAT_3840_2160P_60;
+		break;
+	case VIC_1024X768P60:
+		hwinfo->out_type = DP_FORMAT_1024_768;
+		standard = VO_STANDARD_DP_FORMAT_1024_768P_60;
+		break;
+	case VIC_1440X768P60:
+		hwinfo->out_type = DP_FORMAT_1440_768;
+		standard = VO_STANDARD_DP_FORMAT_1440_768P_60;
+		break;
+	case VIC_1440X900P60:
+		hwinfo->out_type = DP_FORMAT_1440_900;
+		standard = VO_STANDARD_DP_FORMAT_1440_900P_60;
+		break;
+	case VIC_1280X800P60:
+		hwinfo->out_type = DP_FORMAT_1280_800;
+		standard = VO_STANDARD_DP_FORMAT_1280_800P_60;
+		break;
+	case VIC_960X544P60:
+		hwinfo->out_type = DP_FORMAT_960_544;
+		standard = VO_STANDARD_DP_FORMAT_960_544P_60;
+		break;
+	default:
+		hwinfo->out_type = DP_FORMAT_1024_768;
+		standard = VO_STANDARD_DP_FORMAT_1024_768P_60;
+		break;
+	}
+	return standard;
+}
+
+static unsigned char vo_standard_to_vic(unsigned int vo)
+{
+	switch(vo) {
+	case VO_STANDARD_DP_FORMAT_1280_720P_60:
+		return VIC_1280X720P60;
+	case VO_STANDARD_DP_FORMAT_1920_1080P_60:
+		return VIC_1920X1080P60;
+	case VO_STANDARD_DP_FORMAT_2160P_30:
+		return VIC_3840X2160P30;
+	case VO_STANDARD_DP_FORMAT_3840_2160P_60:
+		return VIC_3840X2160P60;
+	case VO_STANDARD_DP_FORMAT_1024_768P_60:
+		return VIC_1024X768P60;
+	case VO_STANDARD_DP_FORMAT_1440_768P_60:
+		return VIC_1440X768P60;
+	case VO_STANDARD_DP_FORMAT_1440_900P_60:
+		return VIC_1440X900P60;
+	case VO_STANDARD_DP_FORMAT_1280_800P_60:
+		return VIC_1280X800P60;
+	case VO_STANDARD_DP_FORMAT_960_544P_60:
+		return VIC_960X544P60;
+	default:
+		return VIC_1280X720P60;
+	}
+}
+
+void gen_dptx_format_support(struct rtk_dptx_device *dptx_dev,
+				struct sink_capabilities_t *sink_cap)
+{
+	struct dptx_support_list *list = &dptx_dev->list;
+	struct dptx_format_support *support = list->tx_support;
+	struct device *dev = dptx_dev->dev;
+	int i;
+	unsigned long long vic;
+	unsigned char extended_vic;
+	unsigned long long vic2;
+	unsigned long long vic2_420;
+	int offset;
+	int size;
+	const char *support_vic;
+
+	vic = sink_cap->vic;
+	extended_vic = sink_cap->extended_vic;
+	vic2 = sink_cap->vic2;
+	vic2_420 = sink_cap->vic2_420;
+
+	memset(support, 0, sizeof(struct dptx_support_list));
+	/* SD 16:9->4:3 */
+	if (vic & BIT(2))
+		vic |= BIT(1);
+	if (vic & BIT(6))
+		vic |= BIT(5);
+	if (vic & BIT(17))
+		vic |= BIT(16);
+	if (vic & BIT(21))
+		vic |= BIT(20);
+
+	/* Merge extended_vic to vic2 */
+	if (extended_vic & BIT(1))
+		vic2 |= BIT(30);
+	if (extended_vic & BIT(2))
+		vic2 |= BIT(29);
+	if (extended_vic & BIT(3))
+		vic2 |= BIT(28);
+	if (extended_vic & BIT(4))
+		vic2 |= BIT(33);
+
+	if (dptx_dev->hwinfo.chip_id == CHIP_ID_RTD1619) {
+		size = sizeof(dptx_thor_support_vic);
+		support_vic = dptx_thor_support_vic;
+	} else {
+		size = sizeof(dptx_kylin_support_vic);
+		support_vic = dptx_kylin_support_vic;
+	}
+	offset = 0;
+	for (i=0; i<size; i++) {
+		if (support_vic[i] <= 64) {
+			if (vic & BIT(support_vic[i]-1)) {
+				dev_info(dev, "support vic = %d\n", support_vic[i]);
+				support[offset].vic = support_vic[i];
+				offset++;
+			}
+		} else {
+			if (vic2 & BIT(support_vic[i]-64)) {
+				dev_info(dev, "dptx support vic = %d\n", support_vic[i]);
+				support[offset].vic = support_vic[i];
+				offset++;
+			} else if (vic2_420 & BIT(support_vic[i]-65)) {
+				dev_info(dev, "dptx support vic = %d\n", support_vic[i]);
+				support[offset].vic = support_vic[i];
+				offset++;
+			}
+		}
+	}
+	list->tx_support_size = offset;
+}
+
+static long rtk_dptx_ioctl(struct file* filp, 
+			unsigned int cmd, unsigned long arg)
+{
+	struct rtk_dptx_device *dptx_dev = filp->private_data;
+	struct rtk_dptx_hwinfo *hwinfo = &dptx_dev->hwinfo;
+	struct device *dev = dptx_dev->dev;
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM rpc;
+	struct dptx_format_setting *format = &dptx_dev->format;
+	struct dptx_support_list *list = &dptx_dev->list;
+	struct edid *edid;
+	asoc_dptx_t* cap = &dptx_dev->cap;
+	int mode;
+	int value;
+	int ret;
+
+	switch(cmd) {
+	case DPTX_CONFIG_TV_SYSTEM:
+		if (copy_from_user(&rpc, (void __user *)arg, sizeof(rpc))) {
+			dev_err(dev, "[%s] failed to copy from user !\n", __func__);
+			return -EFAULT;
+		}
+		mode = rpc.videoInfo.pedType;
+		switch(mode) {
+		case VO_STANDARD_DP_FORMAT_1920_1080P_60:
+			hwinfo->out_type = DP_FORMAT_1080P_60;
+			break;
+		case VO_STANDARD_DP_FORMAT_2160P_30:
+			hwinfo->out_type = DP_FORMAT_2160P_30;
+			break;
+		case VO_STANDARD_DP_FORMAT_3840_2160P_60:
+			hwinfo->out_type = DP_FORMAT_2160P_60;
+			break;
+		case VO_STANDARD_DP_FORMAT_1280_720P_60:
+			hwinfo->out_type = DP_FORMAT_720P_60;
+			break;
+		case VO_STANDARD_DP_FORMAT_1024_768P_60:
+			hwinfo->out_type = DP_FORMAT_1024_768;
+			break;
+		}
+		rtk_dptx_enable(dptx_dev);
+		if(dptx_config_tv_system(&dptx_dev->hwinfo) == true)
+			RPC_TOAGENT_DPTX_Config_TV_System(dptx_dev->rpc_ion_client, &rpc);
+		break;
+
+	case DPTX_GET_SINK_CAPABILITY:
+	case DPTX_GET_RAW_EDID:
+	case DPTX_GET_EDID_SUPPORT_LIST:
+		if (!dptx_dev->dptx_en)
+			rtk_dptx_enable(dptx_dev);
+		if (dptx_dev->ignore_edid)
+			return -EFAULT;
+		if (!dptx_dev->ignore_edid && !(cap->sink_cap_available)) {
+			ret = dptx_read_edid(&dptx_dev->hwinfo, cap->edid_ptr, EDID_SIZE);
+			if (ret < 0) {
+				dev_err(dev, "Read EDID fail\n");
+				return -EFAULT;
+			}
+			edid = (struct edid *)cap->edid_ptr;
+			memset(&cap->sink_cap, 0, sizeof(struct sink_capabilities_t));
+			dptx_add_edid_modes(edid, &cap->sink_cap);
+			cap->sink_cap_available = true;
+		}
+
+		if(cmd == DPTX_GET_SINK_CAPABILITY) {
+			if(copy_to_user((void __user *)arg, &cap->sink_cap, sizeof(cap->sink_cap))) {
+				dev_err(dev, "[%s] failed to copy to user !\n", __func__);
+				return -EFAULT;
+			}
+		} else if (cmd == DPTX_GET_RAW_EDID) {
+			if(copy_to_user((void __user *)arg, &cap->edid_ptr, EDID_SIZE)) {
+				dev_err(dev, "[%s] failed to copy to user !\n", __func__);
+				return -EFAULT;
+			}
+		} else {
+			gen_dptx_format_support(dptx_dev, &dptx_dev->cap.sink_cap);
+			if (copy_to_user((void __user *)arg, list, sizeof(struct dptx_support_list))) {
+				dev_err(dev, "[%s] failed to copy to user !\n", __func__);
+				return -EFAULT;
+			}
+		}
+		break;
+	case DPTX_GET_OUTPUT_FORMAT:
+		RPC_TOAGENT_DPTX_QUERY_TV_System(dptx_dev->rpc_ion_client, &rpc);
+		format->vic = vo_standard_to_vic(rpc.videoInfo.pedType);
+		format->display_mode = rpc.interfaceType;
+		dev_info(dev, "dptx format vic = %d, display_mode = %d\n", format->vic, format->display_mode);
+
+		if (copy_to_user((void __user *)arg, format, sizeof(struct dptx_format_setting))) {
+			dev_err(dev, "[%s] failed to copy to user !\n", __func__);
+			return -EFAULT;
+		}
+		break;
+	case DPTX_SET_OUTPUT_FORMAT:
+		if (copy_from_user(format, (void __user *)arg, sizeof(format))) {
+			dev_err(dev, "[%s] copy from user fail\n", __func__);
+			break;
+		}
+		RPC_TOAGENT_DPTX_QUERY_TV_System(dptx_dev->rpc_ion_client, &rpc);
+
+		rpc.videoInfo.pedType = vic_to_vo_standard(hwinfo, format->vic);
+		rpc.interfaceType = format->display_mode;
+		dev_info(dev, "dptx set format vo = %d, display_mode = %d\n", rpc.videoInfo.pedType, rpc.interfaceType);
+		if (rpc.interfaceType < VO_DISPLAY_PORT_ONLY ||
+			rpc.interfaceType > VO_HDMI_AND_DP_DIFF_SOURCE_WITH_CVBS)
+		{
+			rtk_dptx_disable(dptx_dev);
+			RPC_TOAGENT_DPTX_Config_TV_System(dptx_dev->rpc_ion_client, &rpc);
+			return 0;
+		}
+		rtk_dptx_enable(dptx_dev);
+		if(dptx_config_tv_system(&dptx_dev->hwinfo) == true)
+			RPC_TOAGENT_DPTX_Config_TV_System(dptx_dev->rpc_ion_client, &rpc);
+		break;
+	case DPTX_HOTPLUG_DETECTION:
+		if (copy_from_user(&value, (void __user *)arg, sizeof(value))) {
+			DPTX_ERR("%s:failed to copy from user !", __func__);
+			return -EFAULT;
+		}
+
+		dptxHpdDetect = value;
+		if(value == 0)
+		{
+			dptx_dev->isr_signal = true;
+			wake_up_interruptible(&dptx_dev->hpd_wait);
+		}
+		return ret;
+	case DPTX_WAIT_HOTPLUG:
+		value = dptx_switch_get_state(&dptx_dev->swdev);
+		wait_event_interruptible(dptx_dev->hpd_wait, (((dptx_dev->isr_signal == true)&&(value!=switch_get_state(&dptx_dev->swdev.sw))) || (!dptxHpdDetect)));
+		dptx_dev->isr_signal = false;
+		value = dptx_switch_get_state(&dptx_dev->swdev);
+		if (copy_to_user((void __user *)arg,&value,sizeof(value))) {
+			DPTX_ERR("%s:failed to copy to user ! ", __func__);
+			return -EFAULT;
+		}
+
+		return ret;
+	default:
+		dev_err(dev, "[%s] unknown ioctl cmd %08x\n", __func__, cmd);
+		return -EFAULT;
+	}
+	return 0;
+}
+
+#ifdef CONFIG_64BIT
+static long rtk_dptx_compat_ioctl(struct file* filp,
+			unsigned int cmd, unsigned long arg)
+{
+	long (*ioctl)(struct file*, unsigned int, unsigned long);
+
+	if (!filp->f_op->unlocked_ioctl)
+		return -ENOTTY;
+
+	ioctl = filp->f_op->unlocked_ioctl;
+
+	switch(cmd) {
+	case DPTX_GET_SINK_CAPABILITY:
+	case DPTX_GET_RAW_EDID:
+	case DPTX_CONFIG_TV_SYSTEM:
+	case DPTX_GET_EDID_SUPPORT_LIST:
+	case DPTX_GET_OUTPUT_FORMAT:
+	case DPTX_SET_OUTPUT_FORMAT:
+		return ioctl(filp, cmd, (unsigned long)compat_ptr(arg));
+	default:
+		break;
+	}
+	return 0;
+}
+#endif /* end of CONFIG_64BIT */
+
+static ssize_t rtk_dptx_write(struct file *filp, const char __user *buf,
+        size_t count, loff_t *pos)
+{
+	struct rtk_dptx_device *dptx_dev = filp->private_data;
+	struct device *dev = dptx_dev->dev;
+	char resolution;
+
+	if (!dptx_dev->selftest)
+		return count;
+	if (copy_from_user(&resolution, (void __user *)buf, sizeof(char))) {
+		dev_err(dev, "[%s] failed to copy from user !\n", __func__);
+		return -EFAULT;
+	}
+
+	if (resolution == '0') {
+		dptx_dev->hwinfo.out_type = DP_FORMAT_720P_60;
+	} else if (resolution == '1') {
+		dptx_dev->hwinfo.out_type = DP_FORMAT_1080P_60;
+	} else if (resolution == '2') {
+		dptx_dev->hwinfo.out_type = DP_FORMAT_1024_768;
+	} else if (resolution == '3') {
+		dptx_dev->hwinfo.out_type = DP_FORMAT_1280_800;
+	} else if (resolution == '4') {
+		dptx_dev->hwinfo.out_type = DP_FORMAT_1440_768;
+	} else if (resolution == '5') {
+		dptx_dev->hwinfo.out_type = DP_FORMAT_1440_900;
+	} else if (resolution == '6') {
+		dptx_dev->hwinfo.out_type = DP_FORMAT_960_544;
+	} else if (resolution == '7') {
+		dptx_dev->hwinfo.out_type = DP_FORMAT_2160P_30;
+	} else {
+		dev_err(dev, "'0' = DP_FORMAT_720P_60\n");
+		dev_err(dev, "'1' = DP_FORMAT_1080P_60\n");
+		dev_err(dev, "'2' = DP_FORMAT_1024_768\n");
+		dev_err(dev, "'3' = DP_FORMAT_1280_800\n");
+		dev_err(dev, "'4' = DP_FORMAT_1440_768\n");
+		dev_err(dev, "'5' = DP_FORMAT_1440_900\n");
+		dev_err(dev, "'6' = DP_FORMAT_960_544\n");
+		dev_err(dev, "'7' = DP_FORMAT_2160P_30\n");
+		return count;
+	}
+
+	rtk_dptx_enable(dptx_dev);
+	dptx_config_tv_system(&dptx_dev->hwinfo);
+
+	return count;
+}
+
+int rtk_dptx_open(struct inode *inode, struct file *filp)
+{
+	struct miscdevice *misc = filp->private_data;
+	struct rtk_dptx_device *dptx_dev =
+			container_of(misc, struct rtk_dptx_device, miscdev);
+
+	if (nonseekable_open(inode, filp))
+		return -ENODEV;
+
+	filp->private_data = dptx_dev;
+	
+	return 0;
+}
+
+static struct file_operations dptx_fops = {
+	.owner = THIS_MODULE,
+	.open = rtk_dptx_open,
+	.write = rtk_dptx_write,
+	.unlocked_ioctl = rtk_dptx_ioctl,
+#ifdef CONFIG_64BIT
+	.compat_ioctl = rtk_dptx_compat_ioctl,
+#endif /* end of CONFIG_64BIT */
+};
+
+static irqreturn_t rtk_dptx_isr(int irq, void *dev_id)
+{
+	struct rtk_dptx_device *dptx_dev = (struct rtk_dptx_device *)dev_id;
+
+	dptx_aux_irq_handle(&dptx_dev->hwinfo);
+
+	return IRQ_HANDLED;
+}
+
+static int rtk_dptx_probe(struct platform_device *pdev)
+{
+	struct rtk_dptx_device *dptx_dev;
+	struct device *dev = &pdev->dev;
+	struct device_node *node = dev->of_node;
+	struct reset_control *rstc;
+	struct clk *clk;
+	int i, idx;
+	unsigned char *edid_ptr;
+	unsigned int irq;
+
+	dev_info(dev, "[%s] start\n", __func__);
+
+	dptx_dev = devm_kzalloc(dev, sizeof(struct rtk_dptx_device), GFP_KERNEL);
+	if (IS_ERR(dptx_dev))
+		return PTR_ERR(dptx_dev);
+
+	edid_ptr = devm_kzalloc(dev, sizeof(unsigned char)*EDID_SIZE, GFP_KERNEL);
+	if (IS_ERR(edid_ptr))
+		return PTR_ERR(edid_ptr);
+
+	dev->platform_data = dptx_dev;
+	dptx_dev->dev = dev;
+	dptx_dev->cap.edid_ptr = edid_ptr;
+
+	dptx_dev->rpc_ion_client = ion_client_create(
+			rtk_phoenix_ion_device, "dptx_driver");
+
+	dptx_dev->hwinfo.chip_id = get_rtd_chip_id();
+	dptx_dev->hwinfo.chip_revision = get_rtd_chip_revision();
+
+	of_property_read_u32(node, "self-test", &dptx_dev->selftest);
+	if (dptx_dev->selftest) {
+		rtk_hdmi_power_on();
+		dptx_dev->hwinfo.vo_en = 1;
+	}
+
+	/* get clock & reset resource from devic tree */
+	idx = of_property_match_string(node, "clock-names", "clk_en_tve");
+	dptx_dev->tve_clk = clk_get(dev, "clk_en_tve");
+	clk_prepare_enable(dptx_dev->tve_clk);
+	for (i=0; i<DPTX_RES_MAX; i++) {
+		if (i==idx)
+			continue;
+		clk = of_clk_get(node, i);
+		if (!IS_ERR(clk)) {
+			clk_prepare_enable(clk);
+			clk_put(clk);
+		} else {
+			break;
+		}
+	}
+	if (dptx_dev->hwinfo.chip_id == CHIP_ID_RTD1619) {
+		clk = clk_get(dev, "clk_en_tsio_trx");
+		clk_disable_unprepare(clk);
+		clk_put(clk);
+	}
+
+	if (dptx_dev->hwinfo.chip_id == CHIP_ID_RTD1619)
+		idx = of_property_match_string(node, "reset-names", "edp");
+	else
+		idx = of_property_match_string(node, "reset-names", "lvds");
+
+	dptx_dev->lvds_rst = of_reset_control_get_by_index(node, idx);
+	for (i=0; i<DPTX_RES_MAX; i++) {
+		if (i==idx)
+			continue;
+		rstc = of_reset_control_get_by_index(node, i);
+		if (!IS_ERR(rstc))
+			reset_control_deassert(rstc);	
+		else
+			break;
+	}
+
+	sema_init(&dptx_dev->hwinfo.sem, 0);
+	dptx_dev->hwinfo.reg_base = of_iomap(dev->of_node, 0);
+	dptx_dev->hwinfo.pll_base = of_iomap(dev->of_node, 1);
+	dptx_dev->hwinfo.lvds_base = of_iomap(dev->of_node, 2);
+	dptx_dev->hwinfo.vo_base = of_iomap(dev->of_node, 3);
+
+	/* get other resource from device tree */
+	of_property_read_u32(node, "ignore-edid", &dptx_dev->ignore_edid);
+
+	irq = irq_of_parse_and_map(node, 0);
+	if (request_irq(irq, rtk_dptx_isr, IRQF_SHARED, "DP_TX", dptx_dev)) {
+		dev_err(dev, "[%s] request irq fail\n", __func__);
+		return -ENODEV;
+	}
+	dptx_dev->dptx_irq = irq;
+
+	/* register misc device */
+	dptx_dev->miscdev.minor = MISC_DYNAMIC_MINOR;
+	dptx_dev->miscdev.name = "dptx";
+	dptx_dev->miscdev.mode = 0666;
+	dptx_dev->miscdev.fops = &dptx_fops;
+	if(misc_register(&dptx_dev->miscdev)) {
+		dev_err(dev, "[%s] misc register fail\n", __func__);
+		return -ENODEV;
+	}
+	
+	dptx_dev->hwinfo.out_type = DP_FORMAT_1080P_60;
+
+	if (dptx_dev->selftest)
+		rtk_dptx_enable(dptx_dev);
+
+	register_dptx_switch(dptx_dev);
+
+	dev_info(dev, "[%s] finished\n", __func__);
+	dptx_dev->isr_signal = false;
+	init_waitqueue_head(&dptx_dev->hpd_wait);
+	return 0;
+}
+
+static const struct of_device_id rtk_dptx_dt_ids[] = {
+	{ .compatible = "Realtek,rtk-dptx", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_dptx_dt_ids);
+
+static struct platform_driver rtk_dptx_driver = {
+	.probe = rtk_dptx_probe,
+	.driver = {
+		.name = "rtk_dptx",
+		.owner = THIS_MODULE, 
+		.of_match_table = of_match_ptr(rtk_dptx_dt_ids),
+	},
+};
+
+static int __init rtk_dptx_init(void)
+{
+	if (platform_driver_register(&rtk_dptx_driver)) {
+		return -EFAULT;
+	}
+	return 0;
+}
+
+static void __exit rtk_dptx_exit(void)
+{
+
+}
+
+module_init(rtk_dptx_init);
+module_exit(rtk_dptx_exit);
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Realtek Display Port kernel module");
diff --git a/drivers/media/platform/rtk_dptx/dptx_core.h b/drivers/media/platform/rtk_dptx/dptx_core.h
new file mode 100644
index 00000000..70af526
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_core.h
@@ -0,0 +1,134 @@
+/*
+ *  dptx_core.h - RTK display port driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __DPTX_CORE_H__
+#define __DPTX_CORE_H__
+
+#include <linux/miscdevice.h>
+#include <linux/switch.h>
+#include <linux/semaphore.h>
+
+#include "dptx_hwapi.h"
+#include "dptx_edid.h"
+#include "dptx_rpc.h"
+
+#define TX_SUPPORT_MAX 25
+
+#define DPTX_DEBUG(format, ...)
+#define DPTX_ERR(format, ...) printk(KERN_ERR "[DPTX_ERR] " format, ## __VA_ARGS__)
+
+enum {
+	DPTX_GET_SINK_CAPABILITY,
+	DPTX_GET_RAW_EDID,
+	DPTX_GET_LINK_STATUS,
+	DPTX_GET_VIDEO_CONFIG,
+	DPTX_SEND_AVMUTE,
+	DPTX_CONFIG_TV_SYSTEM,
+	DPTX_CONFIG_AVI_INFO,
+	DPTX_SET_FREQUNCY,
+	DPTX_SEND_AUDIO_MUTE,
+	DPTX_SEND_AUDIO_VSDB_DATA,
+	DPTX_SEND_AUDIO_EDID2,
+	DPTX_CHECK_TMDS_SRC,
+	// new added ioctl from kernel 4.9
+	DPTX_GET_EDID_SUPPORT_LIST,
+	DPTX_GET_OUTPUT_FORMAT,
+	DPTX_SET_OUTPUT_FORMAT,
+#if 1//def __LINUX_MEDIA_NAS__
+	DPTX_HOTPLUG_DETECTION = 50,
+	DPTX_WAIT_HOTPLUG = 51,
+#endif
+};
+
+enum DPTX_VIDEO_ID_CODE {
+	VIC_720X480P60 = 2,
+	VIC_1280X720P60 = 4,
+	VIC_1920X1080I60 = 5,
+	VIC_720X480I60 = 6,
+	VIC_1920X1080P60 = 16,
+	VIC_720X576P50 = 17,
+	VIC_1280X720P50 = 19,
+	VIC_1920X1080I50 = 20,
+	VIC_720X576I50 = 21,
+	VIC_1920X1080P50 = 31,
+	VIC_1920X1080P24 = 32,
+	VIC_1920X1080P25 = 33,
+	VIC_1920X1080P30 = 34,
+	VIC_3840X2160P24 = 93,
+	VIC_3840X2160P25 = 94,
+	VIC_3840X2160P30 = 95,
+	VIC_3840X2160P50 = 96,
+	VIC_3840X2160P60 = 97,
+	VIC_4096X2160P24 = 98,
+	VIC_4096X2160P25 = 99,
+	VIC_4096X2160P30 = 100,
+	VIC_4096X2160P50 = 101,
+	VIC_4096X2160P60 = 102,
+	VIC_1024X768P60 = 231,
+	VIC_1440X768P60 = 232,
+	VIC_1440X900P60 = 233,
+	VIC_1280X800P60 = 234,
+	VIC_960X544P60 = 235,
+};
+
+struct dptx_format_setting {
+	unsigned char mode;
+	unsigned char vic;
+	unsigned char display_mode; // same source, different source..
+	unsigned char reserved1;
+};
+
+struct dptx_format_support {
+	unsigned char vic;
+	unsigned char reserved1;
+	unsigned char reserved2;
+	unsigned char reserved3;
+};
+
+struct dptx_support_list {
+	struct dptx_format_support tx_support[TX_SUPPORT_MAX];
+	unsigned int tx_support_size;
+};
+
+struct rtk_dptx_switch {
+	struct switch_dev sw;
+	struct delayed_work work;
+
+	int hpd_irq;
+	int hpd_gpio;
+	unsigned int state;
+};
+
+struct rtk_dptx_device {
+	struct device *dev;
+	struct miscdevice miscdev;
+	struct rtk_dptx_switch swdev;
+	struct rtk_dptx_hwinfo hwinfo;
+	struct dptx_format_setting format;
+	struct dptx_support_list list;
+	struct ion_client *rpc_ion_client;
+
+	struct clk *tve_clk;
+	struct reset_control *lvds_rst;
+	asoc_dptx_t cap;
+	
+	unsigned int ignore_edid;
+	unsigned int dptx_irq;
+
+	unsigned int dptx_en;
+	unsigned int selftest;
+	unsigned int isr_signal;
+	wait_queue_head_t hpd_wait;
+};
+
+int dptx_switch_get_state(struct rtk_dptx_switch *swdev);
+int register_dptx_switch(struct rtk_dptx_device *dptx_dev);
+#endif  //__DPTX_CORE_H__
diff --git a/drivers/media/platform/rtk_dptx/dptx_edid.c b/drivers/media/platform/rtk_dptx/dptx_edid.c
new file mode 100644
index 00000000..f38366d
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_edid.c
@@ -0,0 +1,1796 @@
+/*
+ *  dptx_edid.c - RTK display port driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/kernel.h>
+#include <sound/pcm.h>
+
+#include "dptx_edid.h"
+
+#define DPTX_EDID_DEBUG 1
+
+#if DPTX_EDID_DEBUG
+#define DPTX_EDID_DBG(format, ...) pr_info("[DPTX_EDID_DBG] " format, ## __VA_ARGS__)
+#else
+#define DPTX_EDID_DBG(format, ...)
+#endif
+
+#define DPTX_EDID_ERR(format, ...) pr_err("[DPTX_EDID_ERR] " format, ## __VA_ARGS__)
+
+#define EDID_EST_TIMINGS 16
+#define EDID_DETAILED_TIMINGS 4
+#define EDID_STANDARD_TIMINGS 8
+
+//Tag Code
+#define AUDIO_BLOCK	0x01
+#define VIDEO_BLOCK     0x02
+#define VENDOR_BLOCK    0x03
+#define SPEAKER_BLOCK	0x04
+#define VESA_DISPLAY_TRANSFER_BLOCK	0x05
+#define USE_EXTENDED_TAG	0x07
+
+//Extended Tag Codes
+#define VIDEO_CAPABILITY_DATA_BLOCK			0x00
+#define VENDOR_SPECIFIC_VIDEO_DATA_BLOCK	0x01
+#define VESA_DISPLAY_DEVICE_DATA_BLOCK		0x02
+#define VESA_VIDEO_TIMING_BLOCK_EXTENSION	0x03
+#define COLORIMETRY_DATA_BLOCK				0x05
+#define HDR_STATIC_METADATA_DATA_BLOCK		0x06
+#define YCBCR420_VIDEO_DATA_BLOCK			0x0E
+#define YCBCR420_CAPABILITY_MAP_DATA_BLOCK	0x0F
+#define VENDOR_SPECIFIC_AUDIO_DATA_BLOCK	0x11
+#define INFOFRAME_DATA_BLOCK				0x20
+
+#define EDID_BASIC_AUDIO	(1 << 6)
+#define EDID_CEA_YCRCB444	(1 << 5)
+#define EDID_CEA_YCRCB422	(1 << 4)
+#define EDID_CEA_VCDB_QS	(1 << 6)
+
+struct edid_info dptx_edid_info;
+
+static const u8 edid_header[] = {
+	0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00
+};
+
+static u8 vdb[16] = {0x00};
+
+struct detailed_mode_closure {
+	struct sink_capabilities_t *cap;
+	struct edid *edid;
+	bool preferred;
+	u32 quirks;
+	int modes;
+};
+
+typedef void detailed_cb(struct detailed_timing *timing, void *closure);
+
+/*
+ * Probably taken from CEA-861 spec.
+ * This table is converted from xorg's hw/xfree86/modes/xf86EdidModes.c.
+ */
+static const struct drm_display_mode edid_cea_modes[] = {
+	/* 1 - 640x480@60Hz */
+	{ DRM_MODE("640x480", DRM_MODE_TYPE_DRIVER, 25175, 640, 656,
+		   752, 800, 0, 480, 490, 492, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 2 - 720x480@60Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 27000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 3 - 720x480@60Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 27000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 4 - 1280x720@60Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 1390,
+		   1430, 1650, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 60, },
+	/* 5 - 1920x1080i@60Hz */
+	{ DRM_MODE("1920x1080i", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 60, },
+	/* 6 - 1440x480i@60Hz */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 60, },
+	/* 7 - 1440x480i@60Hz */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 60, },
+	/* 8 - 1440x240@60Hz */
+	{ DRM_MODE("1440x240", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1478,
+		   1602, 1716, 0, 240, 244, 247, 262, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 60, },
+	/* 9 - 1440x240@60Hz */
+	{ DRM_MODE("1440x240", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1478,
+		   1602, 1716, 0, 240, 244, 247, 262, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 60, },
+	/* 10 - 2880x480i@60Hz */
+	{ DRM_MODE("2880x480i", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2956,
+		   3204, 3432, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 60, },
+	/* 11 - 2880x480i@60Hz */
+	{ DRM_MODE("2880x480i", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2956,
+		   3204, 3432, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 60, },
+	/* 12 - 2880x240@60Hz */
+	{ DRM_MODE("2880x240", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2956,
+		   3204, 3432, 0, 240, 244, 247, 262, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 13 - 2880x240@60Hz */
+	{ DRM_MODE("2880x240", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2956,
+		   3204, 3432, 0, 240, 244, 247, 262, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 14 - 1440x480@60Hz */
+	{ DRM_MODE("1440x480", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1472,
+		   1596, 1716, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 15 - 1440x480@60Hz */
+	{ DRM_MODE("1440x480", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1472,
+		   1596, 1716, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 16 - 1920x1080@60Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 60, },
+	/* 17 - 720x576@50Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 27000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 18 - 720x576@50Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 27000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 19 - 1280x720@50Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 1720,
+		   1760, 1980, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 50, },
+	/* 20 - 1920x1080i@50Hz */
+	{ DRM_MODE("1920x1080i", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 50, },
+	/* 21 - 1440x576i@50Hz */
+	{ DRM_MODE("1440x576i", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 50, },
+	/* 22 - 1440x576i@50Hz */
+	{ DRM_MODE("1440x576i", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 50, },
+	/* 23 - 1440x288@50Hz */
+	{ DRM_MODE("1440x288", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1464,
+		   1590, 1728, 0, 288, 290, 293, 312, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 50, },
+	/* 24 - 1440x288@50Hz */
+	{ DRM_MODE("1440x288", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1464,
+		   1590, 1728, 0, 288, 290, 293, 312, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 50, },
+	/* 25 - 2880x576i@50Hz */
+	{ DRM_MODE("2880x576i", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2928,
+		   3180, 3456, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 50, },
+	/* 26 - 2880x576i@50Hz */
+	{ DRM_MODE("2880x576i", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2928,
+		   3180, 3456, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 50, },
+	/* 27 - 2880x288@50Hz */
+	{ DRM_MODE("2880x288", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2928,
+		   3180, 3456, 0, 288, 290, 293, 312, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 28 - 2880x288@50Hz */
+	{ DRM_MODE("2880x288", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2928,
+		   3180, 3456, 0, 288, 290, 293, 312, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 29 - 1440x576@50Hz */
+	{ DRM_MODE("1440x576", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1464,
+		   1592, 1728, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 30 - 1440x576@50Hz */
+	{ DRM_MODE("1440x576", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1464,
+		   1592, 1728, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 31 - 1920x1080@50Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 50, },
+	/* 32 - 1920x1080@24Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2558,
+		   2602, 2750, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 24, },
+	/* 33 - 1920x1080@25Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 25, },
+	/* 34 - 1920x1080@30Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 30, },
+	/* 35 - 2880x480@60Hz */
+	{ DRM_MODE("2880x480", DRM_MODE_TYPE_DRIVER, 108000, 2880, 2944,
+		   3192, 3432, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 36 - 2880x480@60Hz */
+	{ DRM_MODE("2880x480", DRM_MODE_TYPE_DRIVER, 108000, 2880, 2944,
+		   3192, 3432, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 37 - 2880x576@50Hz */
+	{ DRM_MODE("2880x576", DRM_MODE_TYPE_DRIVER, 108000, 2880, 2928,
+		   3184, 3456, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 38 - 2880x576@50Hz */
+	{ DRM_MODE("2880x576", DRM_MODE_TYPE_DRIVER, 108000, 2880, 2928,
+		   3184, 3456, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 39 - 1920x1080i@50Hz */
+	{ DRM_MODE("1920x1080i", DRM_MODE_TYPE_DRIVER, 72000, 1920, 1952,
+		   2120, 2304, 0, 1080, 1126, 1136, 1250, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 50, },
+	/* 40 - 1920x1080i@100Hz */
+	{ DRM_MODE("1920x1080i", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 100, },
+	/* 41 - 1280x720@100Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 148500, 1280, 1720,
+		   1760, 1980, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 100, },
+	/* 42 - 720x576@100Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 54000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 100, },
+	/* 43 - 720x576@100Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 54000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 100, },
+	/* 44 - 1440x576i@100Hz */
+	{ DRM_MODE("1440x576", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 100, },
+	/* 45 - 1440x576i@100Hz */
+	{ DRM_MODE("1440x576", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 100, },
+	/* 46 - 1920x1080i@120Hz */
+	{ DRM_MODE("1920x1080i", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 120, },
+	/* 47 - 1280x720@120Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 148500, 1280, 1390,
+		   1430, 1650, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 120, },
+	/* 48 - 720x480@120Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 54000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 120, },
+	/* 49 - 720x480@120Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 54000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 120, },
+	/* 50 - 1440x480i@120Hz */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 120, },
+	/* 51 - 1440x480i@120Hz */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 120, },
+	/* 52 - 720x576@200Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 108000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 200, },
+	/* 53 - 720x576@200Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 108000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 200, },
+	/* 54 - 1440x576i@200Hz */
+	{ DRM_MODE("1440x576i", DRM_MODE_TYPE_DRIVER, 108000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 200, },
+	/* 55 - 1440x576i@200Hz */
+	{ DRM_MODE("1440x576i", DRM_MODE_TYPE_DRIVER, 108000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 200, },
+	/* 56 - 720x480@240Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 108000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 240, },
+	/* 57 - 720x480@240Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 108000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 240, },
+	/* 58 - 1440x480i@240 */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 108000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 240, },
+	/* 59 - 1440x480i@240 */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 108000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 240, },
+	/* 60 - 1280x720@24Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 59400, 1280, 3040,
+		   3080, 3300, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 24, },
+	/* 61 - 1280x720@25Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 3700,
+		   3740, 3960, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 25, },
+	/* 62 - 1280x720@30Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 3040,
+		   3080, 3300, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 30, },
+	/* 63 - 1920x1080@120Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 297000, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 120, },
+	/* 64 - 1920x1080@100Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 297000, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 100, },
+	/* 65 - 1280x720@24Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 59400, 1280, 3040,
+			3080, 3300, 0, 720, 725, 730, 750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 66 - 1280x720@25Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 3700,
+			3740, 3960, 0, 720, 725, 730, 750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 67 - 1280x720@30Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 3040,
+			3080, 3300, 0, 720, 725, 730, 750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 68 - 1280x720@50Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 1720,
+		   1760, 1980, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 50, },
+	/* 69 - 1280x720@60Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 1390,
+		   1430, 1650, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 60, },
+	/* 70 - 1280x720@100Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 148500, 1280, 1720,
+		   1760, 1980, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 100, },
+	/* 71 - 1280x720@120Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 148500, 1280, 1390,
+			1430, 1650, 0, 720, 725, 730, 750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 120, },
+	/* 72 - 1920x1080@24Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2558,
+		   2602, 2750, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 24, },
+	/* 73 - 1920x1080@25Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 25, },
+	/* 74 - 1920x1080@30Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 30, },
+	/* 75 - 1920x1080@50Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 50, },
+	/* 76 - 1920x1080@60Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 60, },
+	/* 77 - 1920x1080@100Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 297000, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 100, },
+	/* 78 - 1920x1080@120Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 297000, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 120, },
+	/* 79 - 1680x720@24Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 59400,
+			1680, 0, 0, 3300, 0,
+			 720, 0, 0,  750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 80 - 1680x720@25Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 59400,
+			1680, 0, 0, 3168, 0,
+			 720, 0, 0,  750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 81 - 1680x720@30Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 59400,
+			1680, 0, 0, 2640, 0,
+			 720, 0, 0,  750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 82 - 1680x720@50Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 82500,
+			1680, 0, 0, 2200, 0,
+			 720, 0, 0,  750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 50, },
+	/* 83 - 1680x720@60Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 99000,
+			1680, 0, 0, 2200, 0,
+			 720, 0, 0,  750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 60, },
+	/* 84 - 1680x720@100Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 165000,
+			1680, 0, 0, 2000, 0,
+			 720, 0, 0,  825, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 100, },
+	/* 85 - 1680x720@120Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 198000,
+			1680, 0, 0, 2000, 0,
+			 720, 0, 0,  825, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 120, },
+	/* 86 - 2560x1080@24Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 99000,
+			2560, 0, 0, 3750, 0,
+			1080, 0, 0, 1100, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 87 - 2560x1080@25Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 90000,
+			2560, 0, 0, 3200, 0,
+			1080, 0, 0, 1125, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 88 - 2560x1080@30Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 118800,
+			2560, 0, 0, 3520, 0,
+			1080, 0, 0, 1125, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 89 - 2560x1080@50Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 185625,
+			2560, 0, 0, 3300, 0,
+			1080, 0, 0, 1125, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 50, },
+	/* 90 - 2560x1080@60Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 198000,
+			2560, 0, 0, 3000, 0,
+			1080, 0, 0, 1100, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 60, },
+	/* 91 - 2560x1080@100Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 371250,
+			2560, 0, 0, 2970, 0,
+			1080, 0, 0, 1250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 100, },
+	/* 92 - 2560x1080@120Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 495000,
+			2560, 0, 0, 3300, 0,
+			1080, 0, 0, 1250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 120, },
+	/* 93 - 3840x2160@24Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 5116, 5204, 5500, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 94 - 3840x2160@25Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 4896, 4984, 5280, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 95 - 3840x2160@30Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 4016, 4104, 4400, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 96 - 3840x2160@50Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			3840, 0, 0, 5280, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 50, },
+	/* 97 - 3840x2160@60Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			3840, 0, 0, 4400, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 60, },
+	/* 98 - 4096x2160@24Hz */
+	{ DRM_MODE("4096x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			4096, 0, 0, 5500, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 99 - 4096x2160@25Hz */
+	{ DRM_MODE("4096x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			4096, 0, 0, 5280, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 100 - 4096x2160@30Hz */
+	{ DRM_MODE("4096x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			4096, 0, 0, 4400, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 101 - 4096x2160@50Hz */
+	{ DRM_MODE("4096x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			4096, 0, 0, 5280, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 50, },
+	/* 102 - 4096x2160@60Hz */
+	{ DRM_MODE("4096x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			4096, 0, 0, 4400, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 60, },
+	/* 103 - 3840x2160@24Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 5116, 5204, 5500, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 104 - 3840x2160@25Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 4896, 4984, 5280, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 105 - 3840x2160@30Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 4016, 4104, 4400, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 106 - 3840x2160@50Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			3840, 0, 0, 5280, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 50, },
+	/* 107 - 3840x2160@60Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			3840, 0, 0, 4400, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 60, },
+};
+
+static int rtk_edid_header_is_valid(const u8 *raw_edid)
+{
+	int i, score = 0;
+
+	for (i = 0; i < sizeof(edid_header); i++)
+		if (raw_edid[i] == edid_header[i])
+			score++;
+
+	return score;
+}
+
+static bool rtk_edid_block_valid(u8 *raw_edid, int block)
+{
+	int i;
+	u8 csum = 0;
+	struct edid *edid = (struct edid *)raw_edid;
+
+	if (block == 0) {
+		int score = rtk_edid_header_is_valid(raw_edid);
+		if (score != 8)
+			goto bad;		
+	}
+
+	for (i = 0; i < EDID_LENGTH; i++)
+		csum += raw_edid[i];
+	if (csum) {
+		DPTX_EDID_ERR("EDID checksum is invalid, remainder is %d\n", csum);		
+
+		/* allow CEA to slide through, switches mangle this */
+		if (raw_edid[0] != 0x02)
+			goto bad;
+	}
+
+	/* per-block-type checks */
+	switch (raw_edid[0]) {
+	case 0: /* base */
+		if (edid->version != 1) {
+			DPTX_EDID_DBG("EDID has major version %d, instead of 1\n", edid->version);
+			goto bad;
+		}
+
+		if (edid->revision > 4)
+			DPTX_EDID_DBG("EDID minor > 4, assuming backward compatibility\n");
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+
+bad:
+	if (raw_edid) {
+		DPTX_EDID_DBG("Raw EDID:\n");
+		print_hex_dump(KERN_ERR, " \t", DUMP_PREFIX_NONE, 16, 1,raw_edid, EDID_LENGTH, false);
+	}
+	return 0;
+}
+
+static bool rtk_edid_is_valid(struct edid *edid)
+{
+	int i;
+	u8 *raw = (u8 *)edid;
+
+	if (!edid)
+		return false;
+
+	for (i = 0; i <= edid->extensions; i++)
+		if (!rtk_edid_block_valid(raw + i * EDID_LENGTH, i))
+			return false;
+
+	return true;
+}
+
+/**
+ * Search EDID for CEA extension block.
+ */
+static u8 *rtk_find_cea_extension(struct edid *edid)
+{
+	u8 *edid_ext = NULL;
+	int i;
+
+	/* No EDID or EDID extensions */
+	if (edid == NULL || edid->extensions == 0)
+		return NULL;
+
+	/* Find CEA extension */
+	for (i = 0; i < edid->extensions; i++) {
+		edid_ext = (u8 *)edid + EDID_LENGTH * (i + 1);
+		if (edid_ext[0] == CEA_EXT)		
+			break;
+	}
+
+	if (i == edid->extensions)
+		return NULL;
+
+	return edid_ext;
+}
+
+static void rtk_add_display_info(struct edid *edid,struct drm_display_info *info)
+{
+	u8 *edid_ext;
+
+	info->width_mm = edid->width_cm * 10;
+	info->height_mm = edid->height_cm * 10;
+
+	/* driver figures it out in this case */
+	info->bpc = 0;
+	info->color_formats = 0;
+
+	if (edid->revision < 3)
+		return;
+
+	if (!(edid->input & DRM_EDID_INPUT_DIGITAL))
+		return;
+
+	/* Get data from CEA blocks if present */
+	edid_ext = rtk_find_cea_extension(edid);
+	if (edid_ext) {
+		info->cea_rev = edid_ext[1];
+
+		/* The existence of a CEA block should imply RGB support */
+		info->color_formats = DRM_COLOR_FORMAT_RGB444;
+		if (edid_ext[3] & EDID_CEA_YCRCB444)
+			info->color_formats |= DRM_COLOR_FORMAT_YCRCB444;
+		if (edid_ext[3] & EDID_CEA_YCRCB422)
+			info->color_formats |= DRM_COLOR_FORMAT_YCRCB422;
+			
+	}
+
+	/* Only defined for 1.4 with digital displays */
+	if (edid->revision < 4)
+		return;
+		
+	switch (edid->input & DRM_EDID_DIGITAL_DEPTH_MASK) {
+	case DRM_EDID_DIGITAL_DEPTH_6:
+		//info->bpc |= RTK_EDID_DIGITAL_DEPTH_6;
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_8:
+		info->bpc |= RTK_EDID_DIGITAL_DEPTH_8;
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_10:
+		info->bpc |= RTK_EDID_DIGITAL_DEPTH_10;
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_12:
+		info->bpc |= RTK_EDID_DIGITAL_DEPTH_12;
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_14:
+		//info->bpc |= RTK_EDID_DIGITAL_DEPTH_14;
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_16:
+		//info->bpc |= RTK_EDID_DIGITAL_DEPTH_16;
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_UNDEF:
+	default:
+		info->bpc = 0;
+		break;
+	}
+
+	info->color_formats |= DRM_COLOR_FORMAT_RGB444;
+	if (edid->features & DRM_EDID_FEATURE_RGB_YCRCB444)
+		info->color_formats |= DRM_COLOR_FORMAT_YCRCB444;
+	if (edid->features & DRM_EDID_FEATURE_RGB_YCRCB422)
+		info->color_formats |= DRM_COLOR_FORMAT_YCRCB422;
+			
+}
+
+static void cea_for_each_detailed_block(u8 *ext, detailed_cb *cb, void *closure)
+{
+	int i, n = 0;
+	u8 d = ext[0x02];
+	u8 *det_base = ext + d;
+
+	n = (127 - d) / 18;
+	for (i = 0; i < n; i++)
+		cb((struct detailed_timing *)(det_base + 18 * i), closure);
+}
+
+static void vtb_for_each_detailed_block(u8 *ext, detailed_cb *cb, void *closure)
+{
+	unsigned int i, n = min((int)ext[0x02], 6);
+	u8 *det_base = ext + 5;
+
+	if (ext[0x01] != 1)
+		return; /* unknown version */
+
+	for (i = 0; i < n; i++)
+		cb((struct detailed_timing *)(det_base + 18 * i), closure);
+}
+
+static void rtk_for_each_detailed_block(u8 *raw_edid, detailed_cb *cb, void *closure)
+{
+	int i;
+	struct edid *edid = (struct edid *)raw_edid;
+
+	if (edid == NULL)
+		return;
+	
+	//parsing No.1-4 Detailed Timing Descriptor of basic edid, start from 0x36.
+	for (i = 0; i < EDID_DETAILED_TIMINGS; i++) 
+		cb(&(edid->detailed_timings[i]), closure);
+
+	//parsing Detailed Timing Descriptor of extension blk.		
+	for (i = 1; i <= raw_edid[0x7e]; i++) {
+		u8 *ext = raw_edid + (i * EDID_LENGTH);
+		switch (*ext) {
+		case CEA_EXT:
+			cea_for_each_detailed_block(ext, cb, closure);
+			break;
+		case VTB_EXT:
+			vtb_for_each_detailed_block(ext, cb, closure);
+			break;
+		default:
+			break;
+		}
+	}
+}
+
+/*
+ * EDID is delightfully ambiguous about how interlaced modes are to be
+ * encoded.  Our internal representation is of frame height, but some
+ * HDTV detailed timings are encoded as field height.
+ *
+ * The format list here is from CEA, in frame size.  Technically we
+ * should be checking refresh rate too.  Whatever.
+ */
+static void drm_mode_do_interlace_quirk(struct drm_display_mode *mode,struct detailed_pixel_timing *pt)
+{
+        int i;
+        static const struct {
+                int w, h;
+        } cea_interlaced[] = {
+                { 1920, 1080 },
+                {  720,  480 },
+                { 1440,  480 },
+                { 2880,  480 },
+                {  720,  576 },
+                { 1440,  576 },
+                { 2880,  576 },
+        };
+ 
+        if (!(pt->misc & DRM_EDID_PT_INTERLACED))
+                return;
+ 
+        for (i = 0; i < ARRAY_SIZE(cea_interlaced); i++) {
+                if ((mode->hdisplay == cea_interlaced[i].w) &&
+                    (mode->vdisplay == cea_interlaced[i].h / 2)) {
+                        mode->vdisplay *= 2;
+                        mode->vsync_start *= 2;
+                        mode->vsync_end *= 2;
+                        mode->vtotal *= 2;
+                        mode->vtotal |= 1;
+                }
+        }
+ 
+        mode->flags |= DRM_MODE_FLAG_INTERLACE;
+}
+
+static int rtk_drm_mode_vrefresh(const struct drm_display_mode *mode)
+{
+        int refresh = 0;
+        unsigned int calc_val;
+
+        if (mode->vrefresh > 0)
+                refresh = mode->vrefresh;
+        else if (mode->htotal > 0 && mode->vtotal > 0) {
+                int vtotal;
+                vtotal = mode->vtotal;
+                /* work out vrefresh the value will be x1000 */
+                calc_val = (mode->clock * 1000);
+                calc_val /= mode->htotal;
+                refresh = (calc_val + vtotal / 2) / vtotal;
+
+                if (mode->flags & DRM_MODE_FLAG_INTERLACE)
+                        refresh *= 2;
+                if (mode->flags & DRM_MODE_FLAG_DBLSCAN)
+                        refresh /= 2;
+                if (mode->vscan > 1)
+                        refresh /= mode->vscan;
+        }
+        return refresh;
+}
+
+/**
+ * drm_mode_detailed - create a new mode from an EDID detailed timing section
+ * @edid: EDID block
+ * @timing: EDID detailed timing info
+ * @quirks: quirks to apply
+ *
+ * An EDID detailed timing block contains enough info for us to create and
+ * return a new struct drm_display_mode.
+ */
+static struct drm_display_mode *rtk_drm_mode_detailed(struct edid *edid,struct detailed_timing *timing,u32 quirks)
+{
+	struct drm_display_mode *mode;
+		
+	struct detailed_pixel_timing *pt = &timing->data.pixel_data;
+	unsigned hactive = (pt->hactive_hblank_hi & 0xf0) << 4 | pt->hactive_lo;
+	unsigned vactive = (pt->vactive_vblank_hi & 0xf0) << 4 | pt->vactive_lo;
+	unsigned hblank = (pt->hactive_hblank_hi & 0xf) << 8 | pt->hblank_lo;
+	unsigned vblank = (pt->vactive_vblank_hi & 0xf) << 8 | pt->vblank_lo;
+	unsigned hsync_offset = (pt->hsync_vsync_offset_pulse_width_hi & 0xc0) << 2 | pt->hsync_offset_lo;
+	unsigned hsync_pulse_width = (pt->hsync_vsync_offset_pulse_width_hi & 0x30) << 4 | pt->hsync_pulse_width_lo;
+	unsigned vsync_offset = (pt->hsync_vsync_offset_pulse_width_hi & 0xc) << 2 | pt->vsync_offset_pulse_width_lo >> 4;
+	unsigned vsync_pulse_width = (pt->hsync_vsync_offset_pulse_width_hi & 0x3) << 4 | (pt->vsync_offset_pulse_width_lo & 0xf);
+		
+	/* ignore tiny modes */
+	if (hactive < 64 || vactive < 64)
+		return NULL;
+		
+	mode = kzalloc(sizeof(struct drm_display_mode), GFP_KERNEL);
+    if (!mode)
+        return NULL;	
+
+//	if (pt->misc & DRM_EDID_PT_STEREO) {
+//		HDMI_ERROR("stereo mode not supported");
+//		return NULL;
+//	}
+//	if (!(pt->misc & DRM_EDID_PT_SEPARATE_SYNC)) {
+//		HDMI_ERROR("composite sync not supported");
+//		return NULL;
+//	}
+//
+//	/* it is incorrect if hsync/vsync width is zero */
+//	if (!hsync_pulse_width || !vsync_pulse_width) {
+//		HDMI_ERROR("Incorrect Detailed timing.Wrong Hsync/Vsync pulse width");
+//		return NULL;
+//	}
+	
+	mode->clock = le16_to_cpu(timing->pixel_clock) * 10;
+ 
+	mode->hdisplay = hactive;
+	mode->hsync_start = mode->hdisplay + hsync_offset;
+	mode->hsync_end = mode->hsync_start + hsync_pulse_width;
+	mode->htotal = mode->hdisplay + hblank;
+        
+	mode->vdisplay = vactive;
+	mode->vsync_start = mode->vdisplay + vsync_offset;
+	mode->vsync_end = mode->vsync_start + vsync_pulse_width;
+	mode->vtotal = mode->vdisplay + vblank;
+	
+	/* Some EDIDs have bogus h/vtotal values */
+	if (mode->hsync_end > mode->htotal)
+		mode->htotal = mode->hsync_end + 1;
+	if (mode->vsync_end > mode->vtotal)
+		mode->vtotal = mode->vsync_end + 1;
+		
+
+	drm_mode_do_interlace_quirk(mode, pt);
+
+	
+//	if (quirks & EDID_QUIRK_DETAILED_SYNC_PP) {
+//		pt->misc |= DRM_EDID_PT_HSYNC_POSITIVE | DRM_EDID_PT_VSYNC_POSITIVE;
+//	}
+
+//	mode->flags |= (pt->misc & DRM_EDID_PT_HSYNC_POSITIVE) ? DRM_MODE_FLAG_PHSYNC : DRM_MODE_FLAG_NHSYNC;
+//	mode->flags |= (pt->misc & DRM_EDID_PT_VSYNC_POSITIVE) ? DRM_MODE_FLAG_PVSYNC : DRM_MODE_FLAG_NVSYNC;
+
+//set_size:
+//	mode->width_mm = pt->width_mm_lo | (pt->width_height_mm_hi & 0xf0) << 4;
+//	mode->height_mm = pt->height_mm_lo | (pt->width_height_mm_hi & 0xf) << 8;
+//
+//	if (quirks & EDID_QUIRK_DETAILED_IN_CM) {
+//		mode->width_mm *= 10;
+//		mode->height_mm *= 10;
+//	}
+		
+	mode->vscan = (mode->flags & DRM_MODE_FLAG_DBLSCAN) ? 2 : 1;
+	
+	mode->vrefresh = rtk_drm_mode_vrefresh(mode);
+
+//	mode->type = DRM_MODE_TYPE_DRIVER;
+
+	return mode;
+	
+}
+
+static void rtk_do_detailed_mode(struct detailed_timing *timing, void *c)
+{
+	struct detailed_mode_closure *closure = c;
+    struct drm_display_mode *newmode;
+	int j;
+	
+	if (timing->pixel_clock) {	
+		
+		newmode=rtk_drm_mode_detailed(closure->edid,timing,closure->quirks);
+		
+		if (!newmode)
+			return;
+		else
+		{
+			DPTX_EDID_DBG("[%s] Detailied Timing: Hdisplay(%u), Vdisplay(%u), Clock(%u), vrefresh(%u), flags(0x%x)\n",__FUNCTION__,
+							newmode->hdisplay,newmode->vdisplay,newmode->clock,newmode->vrefresh,newmode->flags);
+
+			for (j=0; j< ARRAY_SIZE(edid_cea_modes); j++) 
+			{
+				if( newmode->hdisplay == edid_cea_modes[j].hdisplay &&
+					newmode->vdisplay == edid_cea_modes[j].vdisplay &&
+					newmode->clock == edid_cea_modes[j].clock &&
+					newmode->vrefresh == edid_cea_modes[j].vrefresh &&
+				  ((newmode->flags & DRM_MODE_FLAG_INTERLACE) == (edid_cea_modes[j].flags & DRM_MODE_FLAG_INTERLACE)))
+				{	
+					DPTX_EDID_DBG("clk = %d, refresh = %d\n", newmode->clock, newmode->vrefresh);
+					DPTX_EDID_DBG("[%s] vic=%d\n",__FUNCTION__,j+1);
+					if(j<64)
+						closure->cap->vic |= 1ULL << j;
+					else if(j<128)
+						closure->cap->vic2 |= 1ULL << (j-64);
+
+					closure->modes++;					
+				}		
+			}
+		}
+		
+		kfree(newmode);
+	}		
+}
+
+static int rtk_add_standard_mode(struct sink_capabilities_t *sink_cap, struct edid *edid)
+{
+	struct drm_display_mode newmode;
+	int i, j;
+	int ratio;
+	int cnt=0;
+
+	for(i=0; i<EDID_STANDARD_TIMINGS; i++) {
+		if(edid->standard_timings[i].hsize == 0x1 &&
+			edid->standard_timings[i].vfreq_aspect == 0x1)
+			continue;
+		newmode.hdisplay = edid->standard_timings[i].hsize * 8 + 248;
+		ratio = (edid->standard_timings[i].vfreq_aspect & 0xC0) >> 6;
+		if(ratio==0x0)
+			newmode.vdisplay = newmode.hdisplay * 10 / 16;
+		else if(ratio==0x1)
+			newmode.vdisplay = newmode.hdisplay * 3 / 4;
+		else if(ratio==0x2)
+			newmode.vdisplay = newmode.hdisplay * 4 / 5;
+		else if(ratio==0x3)
+			newmode.vdisplay = newmode.hdisplay * 9 / 16;
+		else
+			newmode.vdisplay = 0;
+
+		newmode.vrefresh = (edid->standard_timings[i].vfreq_aspect & 0x3F) + 60;
+
+		DPTX_EDID_DBG("[%s] Standard Timing: Hdisplay(%u), Vdisplay(%u), vrefresh(%u), 0x%x\n",__FUNCTION__,
+				newmode.hdisplay, newmode.vdisplay, newmode.vrefresh, edid->standard_timings[i].vfreq_aspect);
+
+		for (j=0; j< ARRAY_SIZE(edid_cea_modes); j++) {
+			if( newmode.hdisplay == edid_cea_modes[j].hdisplay &&
+				newmode.vdisplay == edid_cea_modes[j].vdisplay &&
+				newmode.vrefresh == edid_cea_modes[j].vrefresh) {
+
+				DPTX_EDID_DBG("[%s] vic=%d\n",__FUNCTION__,j+1);
+				if(j<64)
+					sink_cap->vic |= 1ULL << j;
+				else if(j<128)
+					sink_cap->vic2 |= 1ULL << (j-64);
+				cnt++;
+			}
+		}
+	}
+	return cnt;
+}
+
+static int rtk_add_detailed_modes(struct sink_capabilities_t *sink_cap, struct edid *edid,u32 quirks)
+{
+	
+	struct detailed_mode_closure closure = {
+		sink_cap,
+		edid,
+		1,
+		quirks,
+		0
+	};
+
+	//if (closure.preferred && !version_greater(edid, 1, 3))
+	//	closure.preferred =(edid->features & DRM_EDID_FEATURE_PREFERRED_TIMING);
+
+	rtk_for_each_detailed_block((u8 *)edid, rtk_do_detailed_mode, &closure);
+
+	return closure.modes;
+	
+}
+
+static int add_established_modes(struct edid *edid, u32 *est_format)
+{	
+	unsigned long est_bits = edid->established_timings.t1 |
+		(edid->established_timings.t2 << 8) |
+		((edid->established_timings.mfg_rsvd & 0x80) << 9);
+	int i, modes = 0;
+
+	for (i = 0; i <= EDID_EST_TIMINGS; i++) {
+		if (est_bits & (1<<i)) {
+			modes++;
+			}
+		}	
+		*est_format=est_bits;
+	
+		return modes;
+}
+
+static int do_cea_modes (u8 *db, u8 len, u64 *cea_format, u64 *cea_format2)
+{
+	u8 * mode; 
+	u64 cea_mode=0;
+	int modes = 0;
+	
+	for (mode = db; mode < db + len; mode++)
+	{
+		cea_mode = (*mode & 127) - 1; /* CEA modes are numbered 1..127 */				
+		if (cea_mode < ARRAY_SIZE(edid_cea_modes))
+		{
+			if(cea_mode<=63)
+				*cea_format|= 1ULL<<cea_mode;
+			else if(cea_mode<=127)
+			{
+				*cea_format2|= 1ULL<<(cea_mode-64);
+
+//				if((dptx_edid_info.hdmi_id != HDMI_2P0_IDENTIFIER)&&(cea_mode>=93))//HDMI 1.4 not support 4K VIC
+//					dptx_edid_info.hdmi_id = HDMI_2P0_IDENTIFIER;
+			}
+            if( (mode-db) < 16)
+				vdb[mode-db]= *mode;
+						
+			modes++;			
+		}
+	}
+	
+	return modes;
+}
+
+static void do_cea_420modes (u8 *db, u8 len, u64 *cea_420format)
+{
+	u8 * mode;
+	u64 cea_mode=0;
+
+	for (mode = db; mode < db + len; mode++)
+	{
+		cea_mode = (*mode & 127) - 1; /* CEA modes are numbered 1..127 */
+		if (cea_mode < ARRAY_SIZE(edid_cea_modes))
+		{
+			if(cea_mode>=64)
+				*cea_420format|= 1ULL<<(cea_mode-64);
+
+		}
+	}
+}
+
+static int cea_db_payload_len(const u8 *db)
+{
+	return db[0] & 0x1f;
+}
+
+static int cea_db_tag(const u8 *db)
+{
+	return db[0] >> 5;
+}
+
+static int cea_revision(const u8 *cea)
+{
+	return cea[1];
+}
+
+static int cea_db_offsets(const u8 *cea, int *start, int *end)
+{
+	/* Data block offset in CEA extension block */
+	*start = 4;
+	*end = cea[2];
+	if (*end == 0)
+		*end = 127;
+	if (*end < 4 || *end > 127)
+		return -ERANGE;
+	return 0;
+}
+
+#define for_each_cea_db(cea, i, start, end) \
+	for ((i) = (start); (i) < (end) && (i) + cea_db_payload_len(&(cea)[(i)]) < (end); (i) += cea_db_payload_len(&(cea)[(i)]) + 1)
+
+static int add_cea_modes(struct edid *edid, u64 *video_format, u64 *video_format2)
+{
+	u8 * cea = rtk_find_cea_extension(edid);
+	u8 * db, dbl;
+	int modes = 0;
+
+	if (cea && cea_revision(cea) >= 3) {
+		int i, start, end;
+
+		if (cea_db_offsets(cea, &start, &end))
+			return 0;
+
+		for_each_cea_db(cea, i, start, end) {
+			db = &cea[i];
+			dbl = cea_db_payload_len(db);
+
+			if (cea_db_tag(db) == VIDEO_BLOCK)
+				modes += do_cea_modes (db+1, dbl,video_format,video_format2);
+				
+		}
+	}
+
+	return modes;
+}
+
+static bool cea_db_is_hdmi_vsdb(const u8 *db)
+{
+	int hdmi_id;
+
+	if (cea_db_tag(db) != VENDOR_BLOCK)
+		return false;
+
+	if (cea_db_payload_len(db) < 5)
+		return false;
+
+	hdmi_id = db[1] | (db[2] << 8) | (db[3] << 16);
+
+	if(dptx_edid_info.hdmi_id!=HDMI_2P0_IDENTIFIER)//Prevent overwrite 2.0 ID
+		dptx_edid_info.hdmi_id = hdmi_id;
+
+	return hdmi_id == HDMI_1PX_IDENTIFIER;
+}
+
+static bool cea_db_is_hdmi_forum_vsdb(const u8 *db)
+{
+	int hdmi_id;
+
+	if (cea_db_tag(db) != VENDOR_BLOCK)
+		return false;
+
+	if (cea_db_payload_len(db) < 7)
+		return false;
+
+	hdmi_id = db[1] | (db[2] << 8) | (db[3] << 16);
+
+	dptx_edid_info.hdmi_id = hdmi_id;
+
+	return hdmi_id == HDMI_2P0_IDENTIFIER;
+}
+
+static void print_cea_modes(u64 cea_format, u64 cea_format2, u64 cea_format2_420)
+{
+	int i,freq;
+	
+	if(cea_format==0){
+		DPTX_EDID_ERR("no matching video format found\n");
+		return;
+	}
+		
+	DPTX_EDID_DBG(" VIDEO DATA: \n");
+	
+	for (i = 0; i < ARRAY_SIZE(edid_cea_modes); i++)
+	{
+		if(i<64)
+		{
+			if ((cea_format >> i) & 1ULL)
+			{
+				if(edid_cea_modes[i].flags & DRM_MODE_FLAG_INTERLACE)
+					freq=((edid_cea_modes[i].clock*1000)/((edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal)/2));
+				else
+					freq=((edid_cea_modes[i].clock*1000)/(edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal));
+				DPTX_EDID_DBG("[%02d]%-10s @%d Hz\n",i+1,edid_cea_modes[i].name,freq);
+			}
+		}
+		else if(i<128)
+		{
+			if ((cea_format2 >> (i-64)) & 1ULL)
+			{
+				if(edid_cea_modes[i].flags & DRM_MODE_FLAG_INTERLACE)
+					freq=((edid_cea_modes[i].clock*1000)/((edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal)/2));
+				else
+					freq=((edid_cea_modes[i].clock*1000)/(edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal));
+				DPTX_EDID_DBG("[%02d]%-10s @%d Hz\n",i+1,edid_cea_modes[i].name,freq);
+			}
+		}
+	}
+
+	for (i = 64; i < ARRAY_SIZE(edid_cea_modes); i++)
+	{
+		if(i<128)
+		{
+			if ((cea_format2_420 >> (i-64)) & 1ULL)
+			{
+				if(edid_cea_modes[i].flags & DRM_MODE_FLAG_INTERLACE)
+					freq=((edid_cea_modes[i].clock*1000)/((edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal)/2));
+				else
+					freq=((edid_cea_modes[i].clock*1000)/(edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal));
+				DPTX_EDID_DBG("[%02d]%-10s @%d Hz(YCbCr420)\n",i+1,edid_cea_modes[i].name,freq);
+			}
+		}
+	}
+
+}
+
+static void monitor_name(struct detailed_timing *t, void *data)
+{
+	if (t->data.other_data.type == EDID_DETAIL_MONITOR_NAME)
+		*(u8 **)data = t->data.other_data.data.str.str;
+}
+
+/*
+bit		7			6			5			4			3			2			1			0
+	BT2020_RGB/BT2020_YCC/BT2020_cYCC/AdobeRGB/AdobeYCC601/sYCC601/xvYCC709/xvYCC601/
+*/
+static void parse_hdmi_colorimetry_db(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	sink_cap->color_space = db[2];
+//	sink_cap->vout_edid_data.color_space = db[2];
+	DPTX_EDID_DBG("[%s] color_space(0x%02x)\n", __FUNCTION__, sink_cap->color_space);
+
+}
+
+static void parse_hdmi_hdr_db(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+/*	sink_cap->vout_edid_data.et = db[2];
+	sink_cap->vout_edid_data.sm = db[3];
+	sink_cap->vout_edid_data.max_luminace = db[4];
+	sink_cap->vout_edid_data.max_frame_avg = db[5];
+	sink_cap->vout_edid_data.min_luminace = db[6];
+	HDMI_DEBUG("[%s] et(0x%02x) db(0x%02x) max_lum(0x%02x) max_frame_avg(0x%02x), min_lum(0x%02x)",__FUNCTION__,
+						sink_cap->vout_edid_data.et,
+						sink_cap->vout_edid_data.sm,
+						sink_cap->vout_edid_data.max_luminace,
+						sink_cap->vout_edid_data.max_frame_avg,
+						sink_cap->vout_edid_data.min_luminace);
+*/
+}
+
+static void parse_hdmi_ycbcr420_video_db(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	int dbl;
+
+	dbl = cea_db_payload_len(db);
+	do_cea_420modes((u8 *)(db+2), dbl-1, &sink_cap->vic2_420);
+	DPTX_EDID_DBG("[%s] vic2_420(0x%llx)\n", __FUNCTION__, sink_cap->vic2_420);
+}
+static bool parse_hdmi_extdb(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	int dbl;
+	
+	if (cea_db_tag(db) != USE_EXTENDED_TAG)
+		return false;
+	
+	dbl = cea_db_payload_len(db);
+	
+	switch (*(db+1)) {
+			case VIDEO_CAPABILITY_DATA_BLOCK:
+				DPTX_EDID_DBG("[%s] VIDEO_CAPABILITY_DATA_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				break;
+			case VENDOR_SPECIFIC_VIDEO_DATA_BLOCK:
+				DPTX_EDID_DBG("[%s] VENDOR_SPECIFIC_VIDEO_DATA_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				break;
+			case VESA_DISPLAY_DEVICE_DATA_BLOCK:
+				DPTX_EDID_DBG("[%s] VESA_DISPLAY_DEVICE_DATA_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				break;
+			case VESA_VIDEO_TIMING_BLOCK_EXTENSION:
+				DPTX_EDID_DBG("[%s] VESA_VIDEO_TIMING_BLOCK_EXTENSION (%u bytes)\n",__FUNCTION__,dbl);
+				break;
+			case COLORIMETRY_DATA_BLOCK:
+				DPTX_EDID_DBG("[%s] COLORIMETRY_DATA_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				parse_hdmi_colorimetry_db(sink_cap,db);
+				break;
+			case HDR_STATIC_METADATA_DATA_BLOCK:
+				DPTX_EDID_DBG("[%s] HDR_STATIC_METADATA_DATA_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				parse_hdmi_hdr_db(sink_cap, db);
+				break;
+			case YCBCR420_VIDEO_DATA_BLOCK:
+				DPTX_EDID_DBG("[%s] YCBCR420_VIDEO_DATA_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				parse_hdmi_ycbcr420_video_db(sink_cap, db);
+				break;
+			case YCBCR420_CAPABILITY_MAP_DATA_BLOCK:
+				DPTX_EDID_DBG("[%s] YCBCR420_CAPABILITY_MAP_DATA_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				break;
+			case VENDOR_SPECIFIC_AUDIO_DATA_BLOCK:
+				DPTX_EDID_DBG("[%s] VENDOR_SPECIFIC_AUDIO_DATA_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				break;
+			case INFOFRAME_DATA_BLOCK:
+				DPTX_EDID_DBG("[%s] INFOFRAME_DATA_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				break;
+			default:
+				DPTX_EDID_DBG("[%s] Unknow Extend Tag(%u) (%u bytes)\n",__FUNCTION__,*(db+1),dbl);
+				break;
+			}
+		
+		return true;	
+			
+}
+
+static void parse_hdmi_vsdb(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	u8 len = cea_db_payload_len(db);
+	u8 HDMI_Video_present=0;
+	int offset = 0;
+
+	//int _3D_present=0;
+	int multi_present = 0;
+	int i;
+	u8 vic_len=0, hdmi_3d_len = 0;
+	u16 mask=0;
+	
+	if (len >= 4) {
+		sink_cap->cec_phy_addr[0] = db[4];
+		sink_cap->cec_phy_addr[1] = db[5];
+	}
+	
+	if (len >= 6) {
+		sink_cap->eld[5] |= (db[6] >> 7) & 1;  /* Supports_AI */
+		sink_cap->DC_Y444 = (db[6] >> 3) & 1;  /* Supports 4:4:4 in deep color modes */
+		if((db[6] >> 4) & 1)
+			sink_cap-> display_info.bpc |= RTK_EDID_DIGITAL_DEPTH_10;
+		if((db[6] >> 5) & 1)
+			sink_cap-> display_info.bpc |= RTK_EDID_DIGITAL_DEPTH_12;
+		sink_cap->dvi_dual = db[6] & 1;
+	}
+	if (len >= 7)
+		sink_cap->max_tmds_clock = db[7] * 5;
+	if (len >= 8) {
+		sink_cap->latency_present[0] = db[8] >> 7; /* Latency_Fields_Present */
+		sink_cap->latency_present[1] = (db[8] >> 6) & 1; /* I_Latency_Fields_Present */
+		HDMI_Video_present			 = (db[8] >> 5) & 1; /* HDMI_Video_Present */
+	}
+	
+	if (db[8] & (1 << 7)){
+		offset += 2;
+		if (len >= 9)
+			sink_cap->video_latency[0] = db[9];
+		if (len >= 10)
+			sink_cap->audio_latency[0] = db[10];
+	}
+
+	/* I_Latency_Fields_Present */
+	if (db[8] & (1 << 6)){	
+		offset += 2;
+		if (len >= 11)
+			sink_cap->video_latency[1] = db[11];
+		if (len >= 12)
+			sink_cap->audio_latency[1] = db[12];	
+	}
+	
+	if(HDMI_Video_present)
+	{
+		offset++;
+		if (len >= 8+offset){
+			//H_3D_present = db[8+offset] & (1 << 7);	
+			sink_cap-> _3D_present = (db[8+offset] >> 7) & 1;	
+			multi_present= (db[8+offset] & 0x60) >> 5;
+			//printk("present offset=%d db[8+offset]=0x%x\n",offset,db[8+offset]);
+		}
+		
+		offset++;
+		if (len >= 8+offset){
+			vic_len = db[8+offset] >> 5;
+			hdmi_3d_len = db[8+offset] & 0x1f;					
+		}
+		
+		for(i = 1; i <= vic_len; i++)
+		{					
+			sink_cap-> extended_vic |= (1 << db[8+offset+i]);
+			DPTX_EDID_DBG("sink_cap-> extended_vic = %x db[8+%d+%d]=%x\n", sink_cap-> extended_vic,offset,i,db[8+offset+i]);
+		}
+			
+		for (i = 0; i < vic_len && len >= (9 + offset + i); i++) {
+			u8 vic;
+			vic = db[9 + offset + i];
+		}
+		offset += 1 + vic_len;
+	
+		/* 3D_Structure_ALL */
+		if(multi_present == 1 || multi_present == 2)
+			sink_cap->structure_all = (db[8 + offset] << 8) | db[9 + offset];
+								
+		/* check if 3D_MASK is present */
+		if (multi_present == 2){
+			mask = (db[10 + offset] << 8) | db[11 + offset];				
+	
+			for (i = 0; i < 16 ; i++){
+				if((mask>>i) & 1){
+				sink_cap->_3D_vic[i]= vdb[i];
+				DPTX_EDID_DBG("sink_cap->_3D_vic[%d]=%d\n",i,sink_cap->_3D_vic[i]);
+				}
+			}
+			
+		}				
+		else
+			mask = 0xffff;
+	}	
+	
+	DPTX_EDID_DBG("cec addr:0x%x 0x%x\n",sink_cap->cec_phy_addr[0],sink_cap->cec_phy_addr[1]);	
+	DPTX_EDID_DBG("HDMI: DVI dual %d, "
+		    "max TMDS clock %d, "
+		    "latency present %d %d, "
+		    "video latency %d %d, "
+		    "audio latency %d %d\n",
+		    sink_cap->dvi_dual,
+		    sink_cap->max_tmds_clock,
+	      (int) sink_cap->latency_present[0],
+	      (int) sink_cap->latency_present[1],
+		    sink_cap->video_latency[0],
+		    sink_cap->video_latency[1],
+		    sink_cap->audio_latency[0],
+		    sink_cap->audio_latency[1]);
+			
+	DPTX_EDID_DBG("HDMI 3D: HDMI_Video_present 0x%x _3D_present 0x%x ,multi_present 0x%x\n",HDMI_Video_present,sink_cap-> _3D_present,multi_present);
+	DPTX_EDID_DBG("vic_len %d,hdmi_3d_len %d\n",vic_len,hdmi_3d_len);
+	DPTX_EDID_DBG("structure_all 0x%x,mask 0x%x\n",sink_cap->structure_all,mask);
+				
+}
+
+static void parse_hdmi_forum_vsdb(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	dptx_edid_info.max_tmds_char_rate = db[5]*5;
+	dptx_edid_info.dc_420 = db[7]&0x7;
+}
+
+static unsigned rates_mask[] = {
+	SNDRV_PCM_RATE_32000,
+	SNDRV_PCM_RATE_44100,
+	SNDRV_PCM_RATE_48000,
+	SNDRV_PCM_RATE_88200,
+	SNDRV_PCM_RATE_96000,
+	SNDRV_PCM_RATE_176400,
+	SNDRV_PCM_RATE_192000,
+};
+
+static void rtk_parse_eld(uint8_t *eld,struct sink_capabilities_t *sink_cap)
+{
+	uint8_t *sad;
+	unsigned char eld_ver,mnl, sad_count, rates, rate_mask;
+	unsigned max_channels;
+	int i=0;
+
+	eld_ver = eld[0] >> 3;
+	if (eld_ver != 2 && eld_ver != 31)
+		return;
+
+	mnl = eld[4] & 0x1f;
+	if (mnl > 16)
+		return;
+
+	sad_count = eld[5] >> 4;
+	sad = eld + 20 + mnl;
+
+    sink_cap-> audio_data.ADB_length = sad_count*3 ;
+	/* Start from the basic audio settings */
+	max_channels = 2;
+	rates = 7;
+	while (sad_count > 0) {
+
+        sink_cap-> audio_data.ADB[i].coding_type = ((sad[0] & 0x78)>>3);
+		sink_cap-> audio_data.ADB[i].channel_count = max((unsigned)sink_cap->audio_data.ADB[i].channel_count,((sad[0]&7)+1u));		
+		sink_cap-> audio_data.ADB[i].sample_freq_all |= sad[1];
+		
+		if(sink_cap-> audio_data.ADB[i].coding_type == 0x01) /* PCM */
+			sink_cap-> audio_data.ADB[i].sample_size_all = sad[2];	
+		else
+			sink_cap-> audio_data.ADB[i].max_bit_rate_divided_by_8KHz = sad[2]; 
+	
+		switch (sad[0] & 0x78) {
+		case 0x08: /* PCM */
+			max_channels = max(max_channels,((sad[0]&7)+1u));
+			rates |= sad[1];
+			break;
+		}
+		sad += 3;
+		sad_count -= 1;
+        i++;
+	}
+
+	for (rate_mask = i = 0; i < ARRAY_SIZE(rates_mask); i++)
+		if (rates & 1 << i)
+			rate_mask |= rates_mask[i];
+
+	//sink_cap->sampling_rate_cap = rate_mask;
+	//sink_cap->max_channel_cap = max_channels;
+	
+}
+
+void dptx_edid_to_eld(struct edid *edid, struct sink_capabilities_t *sink_cap)
+{
+	unsigned char *eld = sink_cap->eld;
+	u8 *cea;
+	u8 *name;
+	u8 *db;
+	int sad_count = 0;
+	int mnl;
+	int dbl;
+
+	memset(eld, 0, sizeof(sink_cap->eld));
+
+	cea = rtk_find_cea_extension(edid);
+	if (!cea) {
+		DPTX_EDID_ERR("ELD: no CEA Extension found\n");
+		return;
+	}
+
+	name = NULL;
+	rtk_for_each_detailed_block((u8 *)edid, monitor_name, &name);
+	for (mnl = 0; name && mnl < 13; mnl++) {
+		if (name[mnl] == 0x0a)
+			break;
+		eld[20 + mnl] = name[mnl];
+	}
+	eld[4] = (cea[1] << 5) | mnl;
+	DPTX_EDID_DBG("ELD monitor %s\n", eld + 20);
+
+	eld[0] = 2 << 3;		/* ELD version: 2 */
+
+	eld[16] = edid->mfg_id[0];
+	eld[17] = edid->mfg_id[1];
+	eld[18] = edid->prod_code[0];
+	eld[19] = edid->prod_code[1];
+
+	/* Color characteristics */
+/*	sink_cap->vout_edid_data.red_green_lo = edid->red_green_lo;
+	sink_cap->vout_edid_data.black_white_lo = edid->black_white_lo;
+	sink_cap->vout_edid_data.red_x = edid->red_x;
+	sink_cap->vout_edid_data.red_y = edid->red_y;
+	sink_cap->vout_edid_data.green_x = edid->green_x;
+	sink_cap->vout_edid_data.green_y = edid->green_y;
+	sink_cap->vout_edid_data.blue_x = edid->blue_x;
+	sink_cap->vout_edid_data.blue_y = edid->blue_y;
+	sink_cap->vout_edid_data.white_x = edid->white_x;
+	sink_cap->vout_edid_data.white_y = edid->white_y;*/
+
+	if (cea_revision(cea) >= 3) {
+		int i, start, end;
+
+		if (cea_db_offsets(cea, &start, &end)) {
+			start = 0;
+			end = 0;
+		}
+
+		for_each_cea_db(cea, i, start, end) {
+			db = &cea[i];
+			dbl = cea_db_payload_len(db);
+
+			switch (cea_db_tag(db)) {
+			case AUDIO_BLOCK:
+				/* Audio Data Block, contains SADs */
+				DPTX_EDID_DBG("[%s] AUDIO_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				sad_count = dbl / 3;
+				if (dbl >= 1)
+					memcpy(eld + 20 + mnl, &db[1], dbl);
+				break;
+			case VIDEO_BLOCK:
+				DPTX_EDID_DBG("[%s] VIDEO_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				break;
+			case SPEAKER_BLOCK:
+				/* Speaker Allocation Data Block */
+				DPTX_EDID_DBG("[%s] SPEAKER_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				if (dbl >= 1){
+					eld[7] = db[1];					
+					sink_cap-> audio_data.SADB_length= dbl;
+					memcpy(sink_cap-> audio_data.SADB ,&db[1],sizeof(sink_cap->audio_data.SADB));
+				}
+				break;
+			case VENDOR_BLOCK:
+				/* HDMI Vendor-Specific Data Block */
+				DPTX_EDID_DBG("[%s] VENDOR_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				if (cea_db_is_hdmi_vsdb(db))
+					parse_hdmi_vsdb(sink_cap, db);
+
+				if(cea_db_is_hdmi_forum_vsdb(db))//HDMI 2.0
+					parse_hdmi_forum_vsdb(sink_cap, db);
+				break;
+			case VESA_DISPLAY_TRANSFER_BLOCK:
+				DPTX_EDID_DBG("[%s] VESA_DISPLAY_TRANSFER_BLOCK (%u bytes)\n",__FUNCTION__,dbl);
+				break;
+			case USE_EXTENDED_TAG:
+				/* HDMI USE_EXTENDED_TAG Block */
+				parse_hdmi_extdb(sink_cap, db);
+				break;	
+			default:
+				DPTX_EDID_ERR("[%s] Unknow tag(0x%x)\n", __FUNCTION__, cea_db_tag(db));
+				break;
+			}
+		}
+	}
+	eld[5] |= sad_count << 4;
+	eld[2] = (20 + mnl + sad_count * 3 + 3) / 4;
+
+	DPTX_EDID_DBG("ELD size %d, SAD count %d\n", (int)eld[2], sad_count);
+
+	rtk_parse_eld(eld,sink_cap);
+}
+
+int dptx_add_edid_modes(struct edid *edid, struct sink_capabilities_t *sink_cap)
+{
+	int num_modes = 0;
+	u32 quirks=0;
+
+	if (edid == NULL) 
+		return 0;
+	
+	if (!rtk_edid_is_valid(edid)) 
+		return 0;
+	
+	/*
+	 * EDID spec says modes should be preferred in this order:
+	 * - preferred detailed mode
+	 * - other detailed modes from base block
+	 * - detailed modes from extension blocks
+	 * - CVT 3-byte code modes
+	 * - standard timing codes
+	 * - established timing codes
+	 * - modes inferred from GTF or CVT range information
+	 *
+	 * We get this pretty much right.
+	 *
+	 * XXX order for additional mode types in extension blocks?
+	 */
+	
+	num_modes +=rtk_add_standard_mode(sink_cap, edid);
+	num_modes +=rtk_add_detailed_modes(sink_cap,edid,quirks);
+	DPTX_EDID_DBG("Detailed Timing Descriptor\n");
+	print_cea_modes(sink_cap->vic, sink_cap->vic2, sink_cap->vic2_420);
+	
+	//num_modes += add_cvt_modes(connector, edid);
+	//num_modes += add_standard_modes(connector, edid);
+	num_modes += add_established_modes(edid,&sink_cap->est_modes);
+	//if (edid->features & DRM_EDID_FEATURE_DEFAULT_GTF)
+		//num_modes += add_inferred_modes(connector, edid);
+	
+	num_modes += add_cea_modes(edid,&sink_cap->vic,&sink_cap->vic2);
+	rtk_add_display_info(edid,&sink_cap->display_info);
+	
+	return num_modes;
+}
+
diff --git a/drivers/media/platform/rtk_dptx/dptx_edid.h b/drivers/media/platform/rtk_dptx/dptx_edid.h
new file mode 100644
index 00000000..607cd7c
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_edid.h
@@ -0,0 +1,145 @@
+/*
+ *  dptx_edid.h - RTK display port driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _DPTX_EDID_H_
+#define _DPTX_EDID_H_
+
+#include <drm/drm_edid.h>
+#include <drm/drm_crtc.h>
+#include <linux/types.h>
+
+#define RTK_EDID_DIGITAL_DEPTH_6       (1 << 0)
+#define RTK_EDID_DIGITAL_DEPTH_8       (1 << 1)
+#define RTK_EDID_DIGITAL_DEPTH_10      (1 << 2)
+#define RTK_EDID_DIGITAL_DEPTH_12      (1 << 3)
+#define RTK_EDID_DIGITAL_DEPTH_14      (1 << 4)
+#define RTK_EDID_DIGITAL_DEPTH_16      (1 << 5)
+
+#define HDMI_1PX_IDENTIFIER 0x000C03
+#define HDMI_2P0_IDENTIFIER 0xC45DD8
+
+struct edid_info {
+	// ----- Base Block 128 Bytes Begin -----
+	u8 header[8];
+	/* Vendor & product info */
+	u8 mfg_id[2];
+	u8 prod_code[2];
+	u32 serial; /* FIXME: byte order */
+	u8 mfg_week;
+	u8 mfg_year;
+	/* EDID version */
+	u8 version;
+	u8 revision;
+	/* Display info: */
+	u8 input;
+	u8 width_cm;
+	u8 height_cm;
+	u8 gamma;
+	u8 features;
+	/* Color characteristics */
+	u8 red_green_lo;
+	u8 black_white_lo;
+	u8 red_x;
+	u8 red_y;
+	u8 green_x;
+	u8 green_y;
+	u8 blue_x;
+	u8 blue_y;
+	u8 white_x;
+	u8 white_y;
+	/* Est. timings and mfg rsvd timings*/
+	struct est_timings established_timings;
+	/* Standard timings 1-8*/
+	struct std_timing standard_timings[8];
+	/* Detailing timings 1-4 */
+	struct detailed_timing detailed_timings[4];
+	/* Number of 128 byte ext. blocks */
+	u8 extensions;
+	/* Checksum */
+	u8 checksum;
+	// ----- Base Block 128 Bytes End ----
+
+	u32 hdmi_id;
+	u32 max_tmds_char_rate;
+	u8 dc_420;//Deep Color420, [Bit2]DC_48bit_420;[Bit1]DC_36bit_420;[Bit0]:DC_30bit_420
+} __attribute__((packed));
+
+struct Audio_desc
+{
+	unsigned char	coding_type;
+	unsigned char	channel_count;
+	unsigned char	sample_freq_all;
+	unsigned char	sample_size_all;
+	unsigned char	max_bit_rate_divided_by_8KHz;
+};
+
+struct Audio_Data
+{
+	char ADB_length;	// Audio Data Block
+	struct Audio_desc ADB[10];
+	char SADB_length;	// Speaker Allocation Data Block
+	unsigned char SADB[3];	
+};
+
+struct sink_capabilities_t {
+	
+	unsigned int hdmi_mode;
+	//basic
+	unsigned int est_modes;
+	
+	//audio
+	//unsigned int max_channel_cap;
+	//unsigned int sampling_rate_cap;	
+	unsigned char eld[MAX_ELD_BYTES];
+	struct Audio_Data audio_data;
+	
+	//Vendor-Specific Data Block(VSDB)
+	unsigned char cec_phy_addr[2];
+	bool support_AI;  // needs info from ACP or ISRC packets
+	bool DC_Y444;	// 4:4:4 in deep color modes
+	unsigned char color_space;  
+	bool dvi_dual;	//DVI Dual Link Operation
+	int max_tmds_clock;	/* in MHz */
+	bool latency_present[2];
+	unsigned char video_latency[2];	/* [0]: progressive, [1]: interlaced */
+	unsigned char audio_latency[2];
+	
+	bool _3D_present;
+	__u16 structure_all;
+	unsigned char _3D_vic[16];
+		
+	//video
+	struct drm_display_info display_info;
+	__u64 vic;//VIC 1~64, BIT0=VIC1
+	unsigned char extended_vic;
+	__u64 vic2;//VIC 65~128, BIT0=VIC65
+	__u64 vic2_420;//YCbCr420 format, VIC 65~128, BIT0=VIC65
+//	struct VIDEO_RPC_VOUT_EDID_DATA vout_edid_data;
+};
+
+typedef struct{
+	struct sink_capabilities_t sink_cap;
+	bool sink_cap_available;
+	unsigned char *edid_ptr;	
+}asoc_dptx_t;
+
+int dptx_add_edid_modes(struct edid *edid, struct sink_capabilities_t *sink_cap);
+
+void dptx_edid_to_eld(struct edid *edid, struct sink_capabilities_t *sink_cap);
+
+//extern void rtk_edid_to_eld(struct edid *edid, struct sink_capabilities_t *sink_cap);
+
+//extern bool rtk_edid_block_valid(u8 *raw_edid, int block);
+
+//extern void hdmi_print_raw_edid(unsigned char *edid);
+
+#endif /* _DPTX_EDID_H_ */
+
diff --git a/drivers/media/platform/rtk_dptx/dptx_hdcp.c b/drivers/media/platform/rtk_dptx/dptx_hdcp.c
new file mode 100644
index 00000000..664c63f
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_hdcp.c
@@ -0,0 +1,296 @@
+/*
+ *  dptx_hdcp.c - RTK display port hdcp driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/random.h>
+#include <linux/delay.h>
+#include "dptx_hdcp.h"
+#include "dptx_aux_channel.h"
+
+unsigned char ksv[5] = {0x0};
+unsigned char private[320] = {0x0};
+
+void dptx_hdcp_change_state(struct rtk_dptx_hwinfo *hwinfo, int state)
+{
+	struct DPTxHDCPAuthInfo *hdcp = &hwinfo->HDCPInfo;
+
+	hdcp->AuthState = state;
+	hdcp->AuthStateChange = true;
+}
+
+static void dptx_hdcp_encrypt_en(struct rtk_dptx_hwinfo *hwinfo, int en)
+{
+	void __iomem *base = hwinfo->reg_base;
+
+	if (en)
+		SetBit(base, PBB_30_DPTX_HDCP_CTRL1, ~_BIT1, _BIT1);
+	else
+        	SetBit(base, PBB_30_DPTX_HDCP_CTRL1, ~_BIT1, 0x00);
+}
+
+void dptx_hdcp_set_privatekey(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	int i;
+
+	SetBit(base, PBB_30_DPTX_HDCP_CTRL1, ~_BIT3, _BIT3);
+	for (i=0; i<320; i++)
+		SetReg(base, PBB_32_DP_HDCP_KEY_DL_PORT, private[i]);
+	SetBit(base, PBB_30_DPTX_HDCP_CTRL1, ~_BIT3, 0);
+}
+
+void dptx_hdcp_check_capability(struct rtk_dptx_hwinfo *hwinfo)
+{
+	struct DPTxHDCPAuthInfo *hdcp = &hwinfo->HDCPInfo;
+	unsigned char data[20];
+
+	hdcp->IsHDCPSupported = false;
+	hdcp->IsDownstreamRepeater = false;
+
+	if (dptx_aux_native_read(hwinfo, 0x68028, 1, data)) {
+		if (data[0] & (unsigned char)_BIT0)
+			hdcp->IsHDCPSupported = true;
+		if (data[0] & (unsigned char)_BIT1)
+			hdcp->IsDownstreamRepeater = true;
+	}
+	pr_info("dptx - HDCP = %d, Repeater = %d\n", hdcp->IsHDCPSupported, hdcp->IsDownstreamRepeater);
+}
+
+static bool dptx_hdcp_check_bksv(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	unsigned char data[20];
+	bool ret = false;
+
+	dptx_aux_native_read(hwinfo, 0x68000, 5, data);
+
+	SetReg(base, PBB_4F_BKSV_0, data[0]);
+	SetReg(base, PBB_50_BKSV_1, data[1]);
+	SetReg(base, PBB_51_BKSV_2, data[2]);
+	SetReg(base, PBB_52_BKSV_3, data[3]);
+	SetReg(base, PBB_53_BKSV_4, data[4]);
+	
+	// Turn on circuit that check BKSV
+	SetBit(base, PBB_56_DP_HDCP_TX, ~_BIT2, _BIT2);
+
+	msleep(10);
+
+	pr_err("bksv reg = 0x%x\n", GetReg(base, PBB_56_DP_HDCP_TX));
+	if ((GetReg(base, PBB_56_DP_HDCP_TX) & _BIT1) == _BIT1) {
+		if ((GetReg(base, PBB_56_DP_HDCP_TX) & _BIT0) == 0)
+			ret = true;
+	}
+	SetBit(base, PBB_56_DP_HDCP_TX, ~_BIT2, 0x00);
+	
+	return ret;
+}
+
+static void dptx_hdcp_auth1_gen_an(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	unsigned char data[20];
+	int i;
+	unsigned int rand;
+
+	// Write an_gen_start = 1 , and An gen start to run
+	SetBit(base, PBB_31_DPTX_HDCP_CTRL2, ~_BIT3, _BIT3);
+
+	// Write reg_freerun_init an initial value
+	rand = get_random_int();
+	pr_err("dptx gen random = 0x%x\n", rand);
+	SetReg(base, PBB_58_DP_HDCP_AN_SEED, rand);
+
+	// Write reg_freerun_init_en 0 to 1 to load init value
+	SetBit(base, PBB_56_DP_HDCP_TX, ~_BIT3, _BIT3);
+
+	msleep(10);
+
+	// Write an_gen_start = 0 , An gen stop
+	SetBit(base, PBB_31_DPTX_HDCP_CTRL2, ~_BIT3, 0x00);
+
+	// Disable load init value
+	SetBit(base, PBB_56_DP_HDCP_TX, ~_BIT3, 0x00);
+
+	for (i=0; i<8; i++)
+		data[i] = GetReg(base, PBB_3B_AN_BYTE_0 - i*4);
+	
+	dptx_aux_native_write(hwinfo, 0x6800c, 8, data);
+
+	for (i=0; i<5; i++)
+		data[i] = ksv[i];
+	dptx_aux_native_write(hwinfo, 0x68007, 5, data);
+}
+
+static bool dptx_hdcp_auth1_gen_km(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	bool ret = false;
+
+	// Turn on computation
+	SetBit(base, PBB_31_DPTX_HDCP_CTRL2, ~_BIT1, _BIT1);
+
+	msleep(10);
+	if (GetReg(base, PBB_31_DPTX_HDCP_CTRL2) & _BIT0)
+		ret = true;
+
+	SetBit(base, PBB_31_DPTX_HDCP_CTRL2, ~_BIT1, 0x00);
+
+	return ret;
+}
+
+static bool dptx_hdcp_auth1_compare_r0(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	unsigned char cnt = 0;
+	unsigned char data[20];
+
+	pr_err("enter %s\n", __func__);
+	do {
+		dptx_aux_native_read(hwinfo, 0x68005, 2, data);
+		if (GetReg(base, PBB_4C_R0_BYTE_LSB) == data[0] &&
+			GetReg(base, PBB_4B_R0_BYTE_MSB) == data[1])
+			return true;
+		msleep(10);
+		cnt ++;
+	} while (cnt < 3);
+	pr_err("exit %s fail\n", __func__);
+
+	return false;
+}
+
+static bool dptx_hdcp_auth1_proc(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	struct DPTxHDCPAuthInfo *hdcp = &hwinfo->HDCPInfo;
+	bool ret;
+
+	pr_err("enter %s\n", __func__);
+	// Enable DP Tx HDCP Tx function .
+	SetBit(base, PBB_30_DPTX_HDCP_CTRL1, ~_BIT0, _BIT0);
+
+	// Step1: Read Bcap from DPCD
+	dptx_hdcp_check_capability(hwinfo);
+
+	if (!hdcp->IsHDCPSupported)
+		return false;
+
+	if (!dptx_hdcp_check_bksv(hwinfo)) {
+		pr_err("check bksv error\n");
+		hdcp->AuthStart = false;
+		return false;
+	}
+	// Step3: Generate An
+	dptx_hdcp_auth1_gen_an(hwinfo);
+
+	ret = dptx_hdcp_auth1_gen_km(hwinfo);
+	pr_err("exit %s %d\n", __func__, ret);
+
+	return ret;
+}
+
+void dptx_hdcp_initial(struct rtk_dptx_hwinfo *hwinfo)
+{
+	struct DPTxHDCPAuthInfo *hdcp = &hwinfo->HDCPInfo;
+	void __iomem *base = hwinfo->reg_base;
+	int i;
+
+	dptx_hdcp_change_state(hwinfo, _DP_HDCP_STATE_IDLE);
+	// Set ECF by FW mode
+	SetBit(base, PBB_64_HDCP_ECF_BYTE0, ~_BIT7, 0x00);
+
+	// Set HPD 1ms Timer to  2ms
+	SetBit(base, PBB_73_HPD_TIMER1, ~(_BIT3 | _BIT2 | _BIT1 | _BIT0), (_BIT3 | _BIT2 | _BIT0));
+	SetReg(base, PBB_75_HPD_TIMER3, 0x2C);
+	// Set HPD 10ms Timer to  2ms
+	SetReg(base, PBB_78_HPD_TIMER6, 0x0D);
+	SetReg(base, PBB_79_HPD_TIMER7, 0x2C);
+	// Enable HPD Detection
+	SetBit(base, PBB_70_HPD_CTRL, ~_BIT7, 0x00);
+	SetBit(base, PBB_70_HPD_CTRL, ~_BIT7, _BIT7);
+	// Clear HPD IRQ Flag
+	SetReg(base, PBB_71_HPD_IRQ, 0xFE);
+	// Enable Short IRQ and Disable Long IRQ
+	SetBit(base, PBB_72_HPD_IRQ_EN, ~(_BIT6 | _BIT5), _BIT6 | _BIT7 | _BIT5);
+
+	// Clear HDCP Flag
+	hdcp->AuthStart = false;
+	hdcp->AuthHold = false;
+	
+	// Set private key
+	SetBit(base, PBB_30_DPTX_HDCP_CTRL1, ~_BIT3, _BIT3);
+	for (i=0; i<320; i++)
+		SetReg(base, PBB_32_DP_HDCP_KEY_DL_PORT, private[i]);
+	SetBit(base, PBB_30_DPTX_HDCP_CTRL1, ~_BIT3, 0);
+}
+
+void dptx_hdcp_handler(struct rtk_dptx_hwinfo *hwinfo)
+{
+	struct DPTxHDCPAuthInfo *hdcp = &hwinfo->HDCPInfo;
+//	bool ret;
+
+	hdcp->AuthDownstreamEvent = _DP_HDCP_AUTH_EVENT_NONE;
+	
+	switch (hdcp->AuthState) {
+	case _DP_HDCP_STATE_IDLE:
+		pr_err("enter state _DP_HDCP_STATE_IDLE)\n");
+		if (hdcp->AuthStateChange == true) {
+			hdcp->AuthStateChange = false;
+			hdcp->R0Timeout = false;
+			hdcp->VReadyTimeout = false;
+			hdcp->PollingVReady = false;
+			hdcp->VReadyBit = false;
+			hdcp->AuthHold = false;
+			hdcp->BInfoDevice = 0;
+			hdcp->BInfoDepth = 0;
+			dptx_hdcp_encrypt_en(hwinfo, 0);
+			dptx_hdcp_check_capability(hwinfo);
+			dptx_hdcp_set_privatekey(hwinfo);
+
+			memset(hwinfo->ksvfifo, 0, sizeof(hwinfo->ksvfifo));
+		}
+		if (hdcp->IsHDCPSupported && hwinfo->LTInfo.LTResult == _DP_TX_TRAINING_PASS) {
+			hdcp->AuthStart = false;
+			dptx_hdcp_change_state(hwinfo, _DP_HDCP_STATE_AUTH_1);
+		}
+		break;
+	case _DP_HDCP_STATE_AUTH_1:
+		pr_err("enter state _DP_HDCP_STATE_AUTH_1\n");
+		if (hdcp->AuthStateChange) {
+			hdcp->AuthStateChange = false;
+			hdcp->AuthHold = true;
+
+			if (dptx_hdcp_auth1_proc(hwinfo) == true)
+				dptx_hdcp_change_state(hwinfo, _DP_HDCP_STATE_AUTH_1_COMPARE_R0);
+			else
+				dptx_hdcp_change_state(hwinfo, _DP_HDCP_STATE_IDLE);
+		}
+		break;
+	case _DP_HDCP_STATE_AUTH_1_COMPARE_R0:
+		pr_err("enter state _DP_HDCP_STATE_AUTH_1_COMPARE_R0\n");
+		if (hdcp->AuthStateChange) {
+			hdcp->AuthStateChange = false;
+			msleep(100);
+			if (dptx_hdcp_auth1_compare_r0(hwinfo))
+				dptx_hdcp_change_state(hwinfo, _DP_HDCP_STATE_AUTH_PASS);
+			else
+				dptx_hdcp_change_state(hwinfo, _DP_HDCP_STATE_IDLE);
+		}
+		break;
+	case _DP_HDCP_STATE_AUTH_PASS:
+		if (hdcp->AuthStateChange) {
+			hdcp->AuthStateChange = false;
+			pr_err("AUTH_PASS enable encryption\n");
+			dptx_hdcp_encrypt_en(hwinfo, 1);
+		}
+		break;
+	default:
+		break;
+	}
+}
diff --git a/drivers/media/platform/rtk_dptx/dptx_hdcp.h b/drivers/media/platform/rtk_dptx/dptx_hdcp.h
new file mode 100644
index 00000000..26b646f
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_hdcp.h
@@ -0,0 +1,22 @@
+/*
+ *  dptx_hdcp.h - RTK display port driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __DPTX_HDCP_H__
+#define __DPTX_HDCP_H__
+
+#include "dptx_hwapi.h"
+
+void dptx_hdcp_check_capability(struct rtk_dptx_hwinfo *hwinfo);
+void dptx_hdcp_initial(struct rtk_dptx_hwinfo *hwinfo);
+void dptx_hdcp_handler(struct rtk_dptx_hwinfo *hwinfo);
+void dptx_hdcp_change_state(struct rtk_dptx_hwinfo *hwinfo, int state);
+
+#endif  //__DPTX_HDCP_H__
diff --git a/drivers/media/platform/rtk_dptx/dptx_hwapi.c b/drivers/media/platform/rtk_dptx/dptx_hwapi.c
new file mode 100644
index 00000000..f43129e
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_hwapi.c
@@ -0,0 +1,1484 @@
+/*
+ *  dptx_hwapi.c - RTK display port driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/delay.h>
+
+#include "dptx_hwapi.h"
+#include "dptx_aux_channel.h"
+
+#define RTK_VO_SET 0
+#define AUDIO_ON 1 
+
+unsigned char tDPTX_DRV_TABLE[48] =
+{
+// Pre-emphasis->    0                    1                    2                    3
+// VoltageSwing
+/* 0 */      0x00, 0x00, 0x03,    0x00, 0x07, 0x05,    0x00, 0x0C, 0x05,    0x01, 0x09, 0x06,
+/* 1 */      0x00, 0x00, 0x05,    0x00, 0x07, 0x05,    0x00, 0x0C, 0x05,    0x00, 0x0C, 0x05,
+/* 2 */      0x00, 0x00, 0x09,    0x00, 0x0C, 0x09,    0x00, 0x0C, 0x09,    0x00, 0x0C, 0x09,
+/* 3 */      0x00, 0x00, 0x0E,    0x00, 0x00, 0x0E,    0x00, 0x00, 0x0E,    0x00, 0x00, 0x0E,
+};
+
+#define GET_BIT0(x) (x & 0x1)
+#define GET_BIT1(x) ((x & (0x1<<1))>>1)
+#define GET_BIT2(x) ((x & (0x1<<2))>>2)
+#define GET_BIT3(x) ((x & (0x1<<3))>>3)
+#define GET_BIT4(x) ((x & (0x1<<4))>>4)
+#define GET_BIT5(x) ((x & (0x1<<5))>>5)
+#define GET_BIT6(x) ((x & (0x1<<6))>>6)
+#define GET_BIT7(x) ((x & (0x1<<7))>>7)
+
+#define GET_LANE_VOL_SWING(x,y) (x->LTInfo.LaneAdj[y] & 0x03)
+#define SET_LANE_VOL_SWING(x,y,z) (x->LTInfo.LaneAdj[y] = ((x->LTInfo.LaneAdj[y] & 0xFC) | (z)))
+#define SET_LANE_VOL_SWING_MAX(x,y) (x->LTInfo.LaneAdj[y] |= _BIT2)
+#define CLR_LANE_VOL_SWING_MAX(x,y) (x->LTInfo.LaneAdj[y] &= ~_BIT2)
+
+#define GET_LANE_PRE_EMPHASIS(x,y) ((x->LTInfo.LaneAdj[y] & (_BIT4 | _BIT3)) >> 3)
+#define SET_LANE_PRE_EMPHASIS(x,y,z) (x->LTInfo.LaneAdj[y] = ((x->LTInfo.LaneAdj[y] & ~(_BIT4 | _BIT3)) | ((z) << 3)))
+#define SET_LANE_PRE_EMPHASIS_MAX(x,y) (x->LTInfo.LaneAdj[y] |= _BIT5)
+#define CLR_LANE_PRE_EMPHASIS_MAX(x,y) (x->LTInfo.LaneAdj[y] &= ~_BIT5)
+
+#define GET_LANE0_CR_DONE(x) ((x->LTInfo.Lane01LTStatus & _BIT0) == _BIT0)
+#define GET_LANE1_CR_DONE(x) ((x->LTInfo.Lane01LTStatus & _BIT4) == _BIT4)
+#define GET_LANE2_CR_DONE(x) ((x->LTInfo.Lane23LTStatus & _BIT0) == _BIT0)
+#define GET_LANE3_CR_DONE(x) ((x->LTInfo.Lane23LTStatus & _BIT4) == _BIT4)
+
+#define GET_LANE0_EQ_DONE(x) ((x->LTInfo.Lane01LTStatus & (_BIT1 | _BIT2)) == (_BIT1 | _BIT2))
+#define GET_LANE1_EQ_DONE(x) ((x->LTInfo.Lane01LTStatus & (_BIT5 | _BIT6)) == (_BIT5 | _BIT6))
+#define GET_LANE2_EQ_DONE(x) ((x->LTInfo.Lane23LTStatus & (_BIT1 | _BIT2)) == (_BIT1 | _BIT2))
+#define GET_LANE3_EQ_DONE(x) ((x->LTInfo.Lane23LTStatus & (_BIT5 | _BIT6)) == (_BIT5 | _BIT6))
+
+#define GET_LANE0_ADJ_VOL_SWING(x) (x->LTInfo.AdjReqLane01 & (_BIT1 | _BIT0))
+#define SET_LANE0_ADJ_VOL_SWING(x,y) (x->LTInfo.AdjReqLane01 = ((x->LTInfo.AdjReqLane01 & ~(_BIT1 | _BIT0)) | (y)))
+
+#define GET_LANE1_ADJ_VOL_SWING(x) ((x->LTInfo.AdjReqLane01 & (_BIT5 | _BIT4)) >> 4)
+#define SET_LANE1_ADJ_VOL_SWING(x,y) (x->LTInfo.AdjReqLane01 = ((x->LTInfo.AdjReqLane01 & ~(_BIT5 | _BIT4)) | ((y) << 4)))
+
+#define GET_LANE2_ADJ_VOL_SWING(x) (x->LTInfo.AdjReqLane23 & (_BIT1 | _BIT0))
+#define SET_LANE2_ADJ_VOL_SWING(x,y) (x->LTInfo.AdjReqLane23 = ((x->LTInfo.AdjReqLane23 & ~(_BIT1 | _BIT0)) | (y)))
+
+#define GET_LANE3_ADJ_VOL_SWING(x) ((x->LTInfo.AdjReqLane23 & (_BIT5 | _BIT4)) >> 4)
+#define SET_LANE3_ADJ_VOL_SWING(x,y) (x->LTInfo.AdjReqLane23 = ((x->LTInfo.AdjReqLane23 & ~(_BIT5 | _BIT4)) | ((y) << 4)))
+
+#define GET_LANE0_ADJ_PRE_EMPHASIS(x) ((x->LTInfo.AdjReqLane01 & (_BIT3 | _BIT2)) >> 2)
+#define SET_LANE0_ADJ_PRE_EMPHASIS(x,y) (x->LTInfo.AdjReqLane01 = ((x->LTInfo.AdjReqLane01 & ~(_BIT3 | _BIT2)) | ((y) << 2)))
+
+#define GET_LANE1_ADJ_PRE_EMPHASIS(x) ((x->LTInfo.AdjReqLane01 & (_BIT7 | _BIT6)) >> 6)
+#define SET_LANE1_ADJ_PRE_EMPHASIS(x,y) (x->LTInfo.AdjReqLane01 = ((x->LTInfo.AdjReqLane01 & ~(_BIT7 | _BIT6)) | ((y) << 6)))
+
+#define GET_LANE2_ADJ_PRE_EMPHASIS(x) ((x->LTInfo.AdjReqLane23 & (_BIT3 | _BIT2)) >> 2)
+#define SET_LANE2_ADJ_PRE_EMPHASIS(x,y) (x->LTInfo.AdjReqLane23 = ((x->LTInfo.AdjReqLane23 & ~(_BIT3 | _BIT2)) | ((y) << 2)))
+
+#define GET_LANE3_ADJ_PRE_EMPHASIS(x) ((x->LTInfo.AdjReqLane23 & (_BIT7 | _BIT6)) >> 6)
+#define SET_LANE3_ADJ_PRE_EMPHASIS(x,y) (x->LTInfo.AdjReqLane23 = ((x->LTInfo.AdjReqLane23 & ~(_BIT7 | _BIT6)) | ((y) << 6)))
+
+static void SetBitTD(void __iomem *base, unsigned int offset,
+		unsigned int mask, unsigned int value)
+{
+	SetBit(base, offset, mask, value);
+	mdelay(1);
+}
+
+void SetRegTD(void __iomem *base, unsigned int offset, unsigned int value)
+{
+	SetReg(base, offset, value);
+	mdelay(1);
+}
+
+int dptx_read_edid(struct rtk_dptx_hwinfo *hwinfo,
+			unsigned char *ptr, int length)
+{
+	int i, ret;
+
+	for(i=0; i<length; i++)
+		*(ptr+i) = 0;
+	
+	ret = dptx_aux_i2c_write(hwinfo, 0x50, 1, ptr, 0);
+	if(ret==false)
+		return -1;
+	dptx_aux_i2c_write(hwinfo, 0x50, 1, ptr, 1);
+	for(i=0; i<length/16; i++)
+		dptx_aux_i2c_read(hwinfo, 0x50, 16, (ptr+i*16), 1);
+	return 0;
+}
+
+void dptx_phy_set_signal_lv(struct rtk_dptx_hwinfo *hwinfo,
+				unsigned char enumLaneX,
+				unsigned char ucVoltageSwing,
+				unsigned char ucPreEmphasis)
+{
+	void __iomem *lvds_base = hwinfo->lvds_base;
+	unsigned int val;
+	unsigned char *tbl, idx;
+	
+	tbl = tDPTX_DRV_TABLE;
+
+	if(ucVoltageSwing + ucPreEmphasis > 3) {
+		if(ucVoltageSwing < 4)
+			ucPreEmphasis = 3 - ucVoltageSwing;
+		else {
+			ucVoltageSwing = 3;
+			ucPreEmphasis = 0;
+		}
+	}
+	idx = (ucVoltageSwing * 4 + ucPreEmphasis) * 3;
+	val = readl(lvds_base+0x44);
+	val = val & ~((0x1 << (16+enumLaneX)) | 0xF<<(enumLaneX*4));
+	val = val | tbl[idx]<<(16+enumLaneX) | tbl[idx+1]<<(enumLaneX*4) | 0x00f00000;
+	writel(val, lvds_base+0x44);
+	
+	val = readl(lvds_base+0x48);
+	val = val & ~(0xF<<(enumLaneX*4)) & ~0xFF000000;
+	val = val | tbl[idx+2]<<(enumLaneX*4) | 0x1F000000;
+	writel(val, lvds_base+0x48);
+
+	return;
+}
+
+void dptx_mlphy_set(struct rtk_dptx_hwinfo *hwinfo)
+{
+	int i;
+	unsigned char swing, emphasis;
+
+	for (i=0; i<hwinfo->DownStreamInfo.LaneNum; i++) {
+		swing = GET_LANE_VOL_SWING(hwinfo, i);
+		emphasis = GET_LANE_PRE_EMPHASIS(hwinfo, i);
+		dptx_phy_set_signal_lv(hwinfo, i, swing, emphasis);
+	}
+}
+
+void dptx_signal_reset(struct rtk_dptx_hwinfo *hwinfo)
+{
+	int i;
+
+	for (i=0; i<4; i++) {
+		hwinfo->LTInfo.TP1LaneSameVolCnt[i] = 0;
+
+		SET_LANE_VOL_SWING(hwinfo, i, _DP_TX_LEVEL_0);
+		CLR_LANE_VOL_SWING_MAX(hwinfo, i);
+		SET_LANE_PRE_EMPHASIS(hwinfo, i, _DP_TX_LEVEL_0);
+		CLR_LANE_PRE_EMPHASIS_MAX(hwinfo, i);
+	}
+	dptx_mlphy_set(hwinfo);
+}
+
+void dptx_signal_init_set(struct rtk_dptx_hwinfo *hwinfo)
+{
+	dptx_signal_reset(hwinfo);
+
+/*	switch(GET_DP_TX_DOWNSTREAM_LANE_NUM(hwinfo))
+	{
+		case _DP_ONE_LANE:
+
+			break;
+	}*/
+}
+
+void dptx_tp_init_set(struct rtk_dptx_hwinfo *hwinfo)
+{
+	unsigned char link_rate, link_count;
+
+	hwinfo->LTInfo.LTResult = _DP_TX_TRAINING_NO_RESULT;
+	hwinfo->LTInfo.LTState = _DP_TX_TP1;
+
+	link_rate = hwinfo->DownStreamInfo.MaxLinkRate;
+	hwinfo->DownStreamInfo.LinkRate = link_rate;
+
+	dptx_signal_init_set(hwinfo);
+
+	//Set Link Rate
+	dptx_aux_native_write(hwinfo, 0x100, 1, &link_rate);
+
+	link_count = hwinfo->DownStreamInfo.EnhanceFraming << 7 |
+			hwinfo->DownStreamInfo.LaneNum;
+
+	dptx_aux_native_write(hwinfo, 0x101, 1, &link_count);
+}
+
+static bool dptx_link_config(struct rtk_dptx_hwinfo *hwinfo)
+{
+	unsigned char data[16];
+
+	memset(data, 0, sizeof(data));
+	data[0] = 0x4C;
+	data[1] = 0xE0;
+	data[2] = 0x00;
+
+	if (dptx_aux_native_write(hwinfo, 0x300, 3, data) == false)
+		return false;
+	if (dptx_aux_native_read(hwinfo, 0x0, 16, data)==false)
+		return false;
+	
+	// Step1 : Get DownStream infromation
+	if((data[0] != 0x10) && (data[0] != 0x11) && (data[0] != 0x12))
+		data[0] = 0x11;
+
+	hwinfo->DownStreamInfo.DPCDRev = data[0];
+
+	if ((data[1] == 0x06) || (data[1] == 0x0A) ||
+		((data[0] == 0x12) && (data[1] == 0x14))) {
+		if (data[1] > 0xA)
+			data[1] = 0xA;
+		hwinfo->DownStreamInfo.MaxLinkRate = data[1];
+	} else {
+		hwinfo->DownStreamInfo.MaxLinkRate = 0x6;
+	}
+	
+	if(hwinfo->out_type == DP_FORMAT_1080P_60 || hwinfo->out_type == DP_FORMAT_1440_768
+		|| hwinfo->out_type == DP_FORMAT_1280_800 || hwinfo->out_type == DP_FORMAT_1440_900
+		|| hwinfo->out_type == DP_FORMAT_2160P_30)
+		hwinfo->DownStreamInfo.LaneNum = _DP_TWO_LANE;
+	else if(hwinfo->out_type == DP_FORMAT_720P_60 ||
+			hwinfo->out_type == DP_FORMAT_1024_768 ||
+			hwinfo->out_type == DP_FORMAT_960_544)
+		hwinfo->DownStreamInfo.LaneNum = _DP_ONE_LANE;
+
+	hwinfo->DownStreamInfo.EnhanceFraming = (data[2] & _BIT7) >> 7;
+
+	return true;
+}
+
+void dptx_tp2_lane_adjust(struct rtk_dptx_hwinfo *hwinfo, int lane)
+{
+	unsigned char swing, emphasis;
+	unsigned char adj_swing, adj_emphasis;
+
+	if (lane == _DP_TX_LANE_0) {
+		adj_swing = GET_LANE0_ADJ_VOL_SWING(hwinfo);
+		adj_emphasis = GET_LANE0_ADJ_PRE_EMPHASIS(hwinfo);
+	} else if (lane == _DP_TX_LANE_1) {
+		adj_swing = GET_LANE1_ADJ_VOL_SWING(hwinfo);
+		adj_emphasis = GET_LANE1_ADJ_PRE_EMPHASIS(hwinfo);
+	} else if (lane == _DP_TX_LANE_2) {
+		adj_swing = GET_LANE2_ADJ_VOL_SWING(hwinfo);
+		adj_emphasis = GET_LANE2_ADJ_PRE_EMPHASIS(hwinfo);
+	} else if (lane == _DP_TX_LANE_3) {
+		adj_swing = GET_LANE3_ADJ_VOL_SWING(hwinfo);
+		adj_emphasis = GET_LANE3_ADJ_PRE_EMPHASIS(hwinfo);
+	} else {
+		return;
+	}
+	swing = GET_LANE_VOL_SWING(hwinfo, lane);
+	emphasis = GET_LANE_PRE_EMPHASIS(hwinfo, lane);
+
+	if ((swing + adj_emphasis) > _DP_TX_LEVEL_3) {
+		adj_emphasis = _DP_TX_LEVEL_3 - swing;
+		if (lane == _DP_TX_LANE_0)
+			SET_LANE0_ADJ_PRE_EMPHASIS(hwinfo, adj_emphasis);
+		if (lane == _DP_TX_LANE_1)
+			SET_LANE1_ADJ_PRE_EMPHASIS(hwinfo, adj_emphasis);
+		if (lane == _DP_TX_LANE_2)
+			SET_LANE2_ADJ_PRE_EMPHASIS(hwinfo, adj_emphasis);
+		if (lane == _DP_TX_LANE_3)
+			SET_LANE3_ADJ_PRE_EMPHASIS(hwinfo, adj_emphasis);
+	}
+	SET_LANE_PRE_EMPHASIS(hwinfo, lane, adj_emphasis);
+	SET_LANE_VOL_SWING(hwinfo, lane, adj_swing);
+
+	if (adj_swing == _DP_TX_LEVEL_3)
+		SET_LANE_VOL_SWING_MAX(hwinfo, lane);
+	else
+		CLR_LANE_VOL_SWING_MAX(hwinfo, lane);
+	if (adj_emphasis == _DP_TX_LEVEL_3)
+		SET_LANE_PRE_EMPHASIS_MAX(hwinfo, lane);
+	else
+		CLR_LANE_PRE_EMPHASIS_MAX(hwinfo, lane);
+}
+
+bool dptx_tp1_lane_adjust(struct rtk_dptx_hwinfo *hwinfo, int lane)
+{
+	unsigned char swing, emphasis;
+	unsigned char adj_swing, adj_emphasis;
+	int cnt;
+	
+	if (lane == _DP_TX_LANE_0) {
+		adj_swing = GET_LANE0_ADJ_VOL_SWING(hwinfo);
+		adj_emphasis = GET_LANE0_ADJ_PRE_EMPHASIS(hwinfo);
+	} else if (lane == _DP_TX_LANE_1) {
+		adj_swing = GET_LANE1_ADJ_VOL_SWING(hwinfo);
+		adj_emphasis = GET_LANE1_ADJ_PRE_EMPHASIS(hwinfo);
+	} else if (lane == _DP_TX_LANE_2) {
+		adj_swing = GET_LANE2_ADJ_VOL_SWING(hwinfo);
+		adj_emphasis = GET_LANE2_ADJ_PRE_EMPHASIS(hwinfo);
+	} else if (lane == _DP_TX_LANE_3) {
+		adj_swing = GET_LANE3_ADJ_VOL_SWING(hwinfo);
+		adj_emphasis = GET_LANE3_ADJ_PRE_EMPHASIS(hwinfo);
+	} else {
+		return false;
+	}
+
+	swing = GET_LANE_VOL_SWING(hwinfo, lane);
+	emphasis = GET_LANE_PRE_EMPHASIS(hwinfo, lane);
+
+	if ((adj_swing + emphasis) > _DP_TX_LEVEL_3) {
+		adj_swing = _DP_TX_LEVEL_3 - emphasis;
+		if (lane == _DP_TX_LANE_0)
+			SET_LANE0_ADJ_VOL_SWING(hwinfo, adj_swing);
+		else if (lane == _DP_TX_LANE_1)
+			SET_LANE1_ADJ_VOL_SWING(hwinfo, adj_swing);
+		else if (lane == _DP_TX_LANE_2)
+			SET_LANE2_ADJ_VOL_SWING(hwinfo, adj_swing);
+		else if (lane == _DP_TX_LANE_3)
+			SET_LANE3_ADJ_VOL_SWING(hwinfo, adj_swing);
+	}
+	if (swing == adj_swing) {
+		cnt = hwinfo->LTInfo.TP1LaneSameVolCnt[lane]++;
+		if(cnt==5 || (cnt==1 && adj_swing == _DP_TX_LEVEL_3)) {
+			hwinfo->LTInfo.TP1LaneSameVolCnt[lane] = 0;
+			return false;
+		}
+	} else
+		hwinfo->LTInfo.TP1LaneSameVolCnt[lane] = 0;
+	
+	SET_LANE_VOL_SWING(hwinfo, lane, adj_swing);
+	SET_LANE_PRE_EMPHASIS(hwinfo, lane, adj_emphasis);
+	if (adj_swing == _DP_TX_LEVEL_3)
+		SET_LANE_VOL_SWING_MAX(hwinfo, lane);
+	else
+		CLR_LANE_VOL_SWING_MAX(hwinfo, lane);
+	if (adj_emphasis == _DP_TX_LEVEL_3)
+		SET_LANE_PRE_EMPHASIS_MAX(hwinfo, lane);
+	else
+		CLR_LANE_PRE_EMPHASIS_MAX(hwinfo, lane);
+
+	return true;
+}
+
+static unsigned char dptx_train_pattern1(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	unsigned char data[20];
+	int i;
+
+	memset(data, 0, sizeof(data));
+
+	if(hwinfo->LTInfo.LTResult == _DP_TX_TRAINING_NO_RESULT) {
+		SetReg(base, PBB_01_DPTX_ML_PAT_SEL, 0x10);
+		SetReg(base, PBB_01_DPTX_ML_PAT_SEL, 0x11);
+		data[0] = _DP_TP_1 | _DP_SCRAMBLING_DISABLE;
+		for (i=0; i<4; i++)
+			data[i+1] = hwinfo->LTInfo.LaneAdj[i];
+		dptx_aux_native_write(hwinfo, 0x102, 5, data);
+	} else {
+		dptx_mlphy_set(hwinfo);
+		for (i=0; i<4; i++)
+			data[i] = hwinfo->LTInfo.LaneAdj[i];
+		dptx_aux_native_write(hwinfo, 0x103, 4, data);
+	}
+
+	mdelay(5);
+
+	dptx_aux_native_read(hwinfo, 0x202, 6, data);
+	pr_info("dptx - TP1 : 0x%x, 0x%x, 0x%x, 0x%x, 0x%x\n",
+			data[0], data[1], data[2], data[4], data[5]);
+
+	hwinfo->LTInfo.Lane01LTStatus = data[0];
+	hwinfo->LTInfo.Lane23LTStatus = data[1];
+	hwinfo->LTInfo.AdjReqLane01 = data[4];
+	hwinfo->LTInfo.AdjReqLane23 = data[5];
+
+	switch(hwinfo->DownStreamInfo.LaneNum) {
+	case _DP_FOUR_LANE:
+		if((GET_LANE3_CR_DONE(hwinfo) &
+			GET_LANE2_CR_DONE(hwinfo)) != true)
+			break;
+	case _DP_TWO_LANE:
+		if((GET_LANE1_CR_DONE(hwinfo)) != true)
+			break;
+	case _DP_ONE_LANE:
+	default:
+		if(GET_LANE0_CR_DONE(hwinfo) != true) {
+			break;
+		} else {
+			hwinfo->LTInfo.TP1Cnt = 0;
+			return _DP_TX_TP1_PASS;
+		}
+	}
+
+	if(hwinfo->LTInfo.TP1Cnt >= 5) {
+		hwinfo->LTInfo.TP1Cnt = 0;
+		return _DP_TX_TP1_ADJUST_FAIL;
+	} else
+		hwinfo->LTInfo.TP1Cnt++;
+
+	switch(hwinfo->DownStreamInfo.LaneNum) {
+	case _DP_FOUR_LANE:
+		if(dptx_tp1_lane_adjust(hwinfo, 3) == false)
+			return _DP_TX_TP1_ADJUST_FAIL;
+		if(dptx_tp1_lane_adjust(hwinfo, 2) == false)
+			return _DP_TX_TP1_ADJUST_FAIL;
+	case _DP_TWO_LANE:
+		if(dptx_tp1_lane_adjust(hwinfo, 1) == false)
+			return _DP_TX_TP1_ADJUST_FAIL;
+	case _DP_ONE_LANE:
+	default:
+		if(dptx_tp1_lane_adjust(hwinfo, 0) == false)
+			return _DP_TX_TP1_ADJUST_FAIL;
+		break;
+	}
+
+	return _DP_TX_TP1_FAIL;
+}
+
+static unsigned char dptx_train_pattern2(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	unsigned char data[20];
+	int i;
+
+	if(hwinfo->LTInfo.LTResult == _DP_TX_TP1_PASS) {
+		SetReg(base, PBB_01_DPTX_ML_PAT_SEL, 0x20);
+		SetReg(base, PBB_01_DPTX_ML_PAT_SEL, 0x21);
+		data[0] = _DP_TP_2 | _DP_SCRAMBLING_DISABLE;
+		for (i=0; i<4; i++)
+			data[i+1] = hwinfo->LTInfo.LaneAdj[i];
+		dptx_aux_native_write(hwinfo, 0x102, 5, data);
+	} else {
+		dptx_mlphy_set(hwinfo);
+		for (i=0; i<4; i++)
+			data[i] = hwinfo->LTInfo.LaneAdj[i];
+		dptx_aux_native_write(hwinfo, 0x103, 4, data);
+	}
+
+	mdelay(5);
+
+	dptx_aux_native_read(hwinfo, 0x202, 6, data);
+	hwinfo->LTInfo.Lane01LTStatus = data[0];
+	hwinfo->LTInfo.Lane23LTStatus = data[1];
+	hwinfo->LTInfo.LaneAlignStatus = data[2];
+	hwinfo->LTInfo.AdjReqLane01 = data[4];
+	hwinfo->LTInfo.AdjReqLane23 = data[5];
+	pr_info("dptx - TP2 : 0x%x, 0x%x, 0x%x, 0x%x, 0x%x\n",
+			data[0], data[1], data[2], data[4], data[5]);
+
+	switch(hwinfo->DownStreamInfo.LaneNum) {
+	case _DP_FOUR_LANE:
+		if((GET_LANE3_CR_DONE(hwinfo) &
+			GET_LANE2_CR_DONE(hwinfo)) != true) {
+			hwinfo->LTInfo.TP2Cnt = 0;
+			return _DP_TX_TP2_ADJUST_FAIL;
+		}
+		if((GET_LANE3_EQ_DONE(hwinfo) &
+			GET_LANE2_EQ_DONE(hwinfo)) != true)
+			break;
+	case _DP_TWO_LANE:
+		if((GET_LANE1_CR_DONE(hwinfo)) != true) {
+			hwinfo->LTInfo.TP2Cnt = 0;
+			return _DP_TX_TP2_ADJUST_FAIL;
+		}
+		if((GET_LANE1_EQ_DONE(hwinfo)) != true)
+			break;
+	case _DP_ONE_LANE:
+	default:
+		if(GET_LANE0_CR_DONE(hwinfo) != true) {
+			hwinfo->LTInfo.TP2Cnt = 0;
+			return _DP_TX_TP2_ADJUST_FAIL;
+		}
+		if(GET_LANE0_EQ_DONE(hwinfo) != true) {
+			break;
+		} else {
+			hwinfo->LTInfo.TP2Cnt = 0;
+			return _DP_TX_TP2_PASS;
+		}
+		break;
+	}
+	if(hwinfo->LTInfo.TP2Cnt >= 5) {
+		hwinfo->LTInfo.TP2Cnt = 0;
+		return _DP_TX_TP2_ADJUST_FAIL;
+	} else
+		hwinfo->LTInfo.TP2Cnt++;
+
+	switch(hwinfo->DownStreamInfo.LaneNum) {
+		case _DP_FOUR_LANE:
+			dptx_tp2_lane_adjust(hwinfo, 3);
+			dptx_tp2_lane_adjust(hwinfo, 2);
+		case _DP_TWO_LANE:
+			dptx_tp2_lane_adjust(hwinfo, 1);
+		case _DP_ONE_LANE:
+		default:
+			dptx_tp2_lane_adjust(hwinfo, 0);
+			break;
+	}
+
+	return _DP_TX_TP2_FAIL;
+}
+
+void dptx_train_pattern_end(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	unsigned char data[20];
+
+	data[0] = _DP_TP_NONE;
+	dptx_aux_native_write(hwinfo, 0x102, 1, data);
+
+	if(hwinfo->LTInfo.LTResult == _DP_TX_TRAINING_PASS && hwinfo->vo_en) {
+		SetReg(base, PBB_01_DPTX_ML_PAT_SEL, 0x40);
+		SetReg(base, PBB_01_DPTX_ML_PAT_SEL, 0x41);
+	}
+}
+
+bool dptx_link_training(struct rtk_dptx_hwinfo *hwinfo)
+{
+	unsigned char data[20];
+	unsigned char ret;
+
+	if (dptx_link_config(hwinfo) == false)
+		return false;
+	
+	data[0] = 0x1;
+	dptx_aux_native_write(hwinfo, 0x600, 1, data);
+
+	dptx_tp_init_set(hwinfo);
+
+START_TRAIN:
+	switch (hwinfo->LTInfo.LTState) {
+	case _DP_TX_TP1:
+		ret = dptx_train_pattern1(hwinfo);
+		hwinfo->LTInfo.LTResult = ret;
+		if (ret == _DP_TX_TP1_PASS) {
+			pr_info("dptx - TP1 training success\n");
+			hwinfo->LTInfo.LTState = _DP_TX_TP2;
+		} else if (ret == _DP_TX_TP1_ADJUST_FAIL) {
+			pr_err("DPTX - TP1 training fail\n");
+			hwinfo->LTInfo.LTResult =
+						_DP_TX_TRAINING_FAIL;
+			return false;
+		}
+		break;
+	case _DP_TX_TP2:
+		ret = dptx_train_pattern2(hwinfo);
+		hwinfo->LTInfo.LTResult = ret;
+		if (ret == _DP_TX_TP2_PASS) {
+			pr_info("dptx - TP2 training success\n");
+			hwinfo->LTInfo.LTState = _DP_TX_TP_END;
+		} else if(ret == _DP_TX_TP2_ADJUST_FAIL) {
+			pr_err("DPTX - TP2 training fail\n");
+			dptx_train_pattern_end(hwinfo);
+			return false;
+		}
+		break;
+	case _DP_TX_TP_END:
+		hwinfo->LTInfo.LTResult = _DP_TX_TRAINING_PASS;
+		dptx_train_pattern_end(hwinfo);
+		break;
+	}
+
+	if(hwinfo->LTInfo.LTResult != _DP_TX_TRAINING_PASS &&
+		hwinfo->LTInfo.LTResult != _DP_TX_TRAINING_FAIL)
+		goto START_TRAIN;
+
+	return true;
+}
+
+void dptx_pixelpll_setting(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->pll_base;
+
+	SetBitTD(base, PLL_HDMI, ~_BIT3, _BIT3);
+	SetBitTD(base, PLL_HDMI_LDO1, ~_BIT6, 0);
+
+	if (hwinfo->out_type == DP_FORMAT_1024_768) {
+		SetRegTD(base, PLL_PIXEL1, 0x934701a2);
+		SetRegTD(base, PLL_PIXEL1, 0x934741a2);
+		SetRegTD(base, PLL_SSC_DIG_PIXEL1, 0xcf1c);
+	} else if (hwinfo->out_type == DP_FORMAT_1080P_60) {
+		SetRegTD(base, PLL_PIXEL1, 0x93470192);
+		SetRegTD(base, PLL_PIXEL1, 0x93474192);
+		SetRegTD(base, PLL_SSC_DIG_PIXEL1, 0xf000);
+	} else if (hwinfo->out_type == DP_FORMAT_2160P_60) {
+		SetRegTD(base, PLL_PIXEL1, 0x93470182);
+		SetRegTD(base, PLL_PIXEL1, 0x93474182);
+		SetRegTD(base, PLL_SSC_DIG_PIXEL1, 0x1b815);
+	} else if (hwinfo->out_type == DP_FORMAT_2160P_30) {
+		SetRegTD(base, PLL_PIXEL1, 0x93470182);
+		SetRegTD(base, PLL_PIXEL1, 0x93474182);
+		SetRegTD(base, PLL_SSC_DIG_PIXEL1, 0xccce);
+	} else if (hwinfo->out_type == DP_FORMAT_1440_768) {
+		SetRegTD(base, PLL_PIXEL1, 0x934701a2);
+		SetRegTD(base, PLL_PIXEL1, 0x934741a2);
+		SetRegTD(base, PLL_SSC_DIG_PIXEL1, 0xe800);
+	} else if (hwinfo->out_type == DP_FORMAT_1440_900) {
+		SetRegTD(base, PLL_PIXEL1, 0x934701a2);
+		SetRegTD(base, PLL_PIXEL1, 0x934741a2);
+		SetRegTD(base, PLL_SSC_DIG_PIXEL1, 0x11800);
+	} else if (hwinfo->out_type == DP_FORMAT_1280_800) {
+		SetRegTD(base, PLL_PIXEL1, 0x934701a2);
+		SetRegTD(base, PLL_PIXEL1, 0x934741a2);
+		SetRegTD(base, PLL_SSC_DIG_PIXEL1, 0xdaab);
+	} else if (hwinfo->out_type == DP_FORMAT_960_544) {
+		SetRegTD(base, PLL_PIXEL1, 0x934701b2);
+		SetRegTD(base, PLL_PIXEL1, 0x934741b2);
+		SetRegTD(base, PLL_SSC_DIG_PIXEL1, 0xD800);
+	} else {
+		SetRegTD(base, PLL_PIXEL1, 0x934701a2);
+		SetRegTD(base, PLL_PIXEL1, 0x934741a2);
+		SetRegTD(base, PLL_SSC_DIG_PIXEL1, 0xF000);
+	}
+
+	SetRegTD(base, PLL_PIXEL2, 0x1e01);
+	SetRegTD(base, PLL_SSC_DIG_PIXEL2, 0x501008);
+	SetRegTD(base, PLL_SSC_DIG_PIXEL0, 0xd);
+}
+
+void dptx_dppll_setting(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *pll_base = hwinfo->pll_base;
+	void __iomem *lvds_base = hwinfo->lvds_base;
+
+	/* Disable iso control */
+	if (hwinfo->chip_id != CHIP_ID_RTD1619) {
+		SetRegTD(pll_base, DISP_PLL_DIV2, 0x440000);
+		SetRegTD(lvds_base, AIF_MISC, 0x1003301);
+		SetRegTD(pll_base, DISP_PLL_DIV2, 0x420000);
+	}
+
+	/* DP PLL setting */
+	SetRegTD(pll_base, PLL_EDP1, 0x9A356007);
+	SetRegTD(pll_base, PLL_EDP2, 0x3);
+	SetRegTD(pll_base, PLL_SSC_DIG_EDP0, 0xc);
+	SetRegTD(pll_base, PLL_SSC_DIG_EDP1, 0x30800);
+	SetRegTD(pll_base, PLL_SSC_DIG_EDP3, 0x30480);
+	SetRegTD(pll_base, PLL_SSC_DIG_EDP4, 0x1100);
+	SetRegTD(pll_base, PLL_SSC_DIG_EDP2, 0x501068);
+	SetRegTD(pll_base, PLL_SSC_DIG_EDP0, 0xd);
+}
+
+void dptx_initial(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+
+	SetBit(base, PBB_72_HPD_IRQ_EN, ~(_BIT6 | _BIT5), _BIT6);
+	// Set DP TX CLK divider
+	SetReg(base, PBB_A3_DPTX_IRQ_CTRL, 0x80);
+
+	SetBit(base, PBB_C9_ARBITER_CTRL, ~_BIT0, _BIT0);
+
+//	SetReg(base, PBB_E0_DPTX_CLK_GEN, 0x21);
+
+	SetBit(base, PBB_C7_VBID, ~_BIT1, _BIT1);
+	dptx_aux_initial(hwinfo);
+}
+
+void dptx_close_phy(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	void __iomem *lvds_base = hwinfo->lvds_base;
+
+	SetReg(base, PBB_00_DP_PHY_CTRL, 0x1);
+	if (hwinfo->chip_id != CHIP_ID_RTD1619)
+		SetReg(lvds_base, AIF_EDP1, 0);
+}
+
+void dptx_close_pll(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->pll_base;
+
+	SetRegTD(base, PLL_EDP2, 0);
+	SetBitTD(base, PLL_EDP1, ~_BIT31, 0);
+
+	SetRegTD(base, PLL_SSC_DIG_PIXEL0, 0x8);
+	SetBitTD(base, PLL_PIXEL2, ~_BIT0, 0);
+	SetBitTD(base, PLL_PIXEL1, ~_BIT31, 0);
+}
+
+static unsigned char dptx_audio_get_parity(unsigned char ucHeader)
+{
+	unsigned char ucParity = 0;
+
+	ucParity |= ((unsigned char)(GET_BIT1(ucHeader) ^ GET_BIT2(ucHeader) ^ GET_BIT6(ucHeader))) << 7;
+	ucParity |= ((unsigned char)(GET_BIT0(ucHeader) ^ GET_BIT1(ucHeader) ^ GET_BIT3(ucHeader) ^ GET_BIT5(ucHeader))) << 6;
+	ucParity |= ((unsigned char)(GET_BIT0(ucHeader) ^ GET_BIT2(ucHeader) ^ GET_BIT4(ucHeader) ^ GET_BIT7(ucHeader))) << 5;
+	ucParity |= ((unsigned char)(GET_BIT2(ucHeader) ^ GET_BIT3(ucHeader) ^ GET_BIT7(ucHeader))) << 4;
+	ucParity |= ((unsigned char)(GET_BIT1(ucHeader) ^ GET_BIT2(ucHeader) ^ GET_BIT3(ucHeader) ^ GET_BIT6(ucHeader) ^ GET_BIT7(ucHeader))) << 3;
+	ucParity |= ((unsigned char)(GET_BIT0(ucHeader) ^ GET_BIT1(ucHeader) ^ GET_BIT2(ucHeader) ^ GET_BIT3(ucHeader) ^ GET_BIT5(ucHeader) ^ GET_BIT6(ucHeader))) << 2;
+	ucParity |= ((unsigned char)(GET_BIT0(ucHeader) ^ GET_BIT1(ucHeader) ^ GET_BIT2(ucHeader) ^ GET_BIT4(ucHeader) ^ GET_BIT5(ucHeader) ^ GET_BIT7(ucHeader))) << 1;
+	ucParity |= (GET_BIT0(ucHeader) ^ GET_BIT2(ucHeader) ^ GET_BIT3(ucHeader) ^ GET_BIT4(ucHeader) ^ GET_BIT7(ucHeader));
+
+	return ucParity;
+}
+
+static void dptx_set_sec_header(struct rtk_dptx_hwinfo *hwinfo,
+			int enumPackettype)
+{
+	void __iomem *base = hwinfo->reg_base;
+	unsigned char pucData[4];
+
+	memset(pucData, 0, sizeof(pucData));
+	pucData[0] = 0x00;
+	pucData[1] = enumPackettype;
+	SetBit(base, PBC_7B_SEC_PH_PACKET_TYPE, ~(_BIT3 | _BIT2 | _BIT1 | _BIT0), pucData[1]);
+	switch(enumPackettype)
+	{
+		case _SEC_PACKET_TYPE_AUDIO_TIMESTAMP:
+			pucData[2] = 0x17;
+			pucData[3] = 0x44; //(_DP_VERSION_1_1 << 2);
+			break;
+		case _SEC_PACKET_TYPE_VSC:
+			pucData[2] = 0x01;
+			pucData[3] = 0x01;
+			break;
+		case _SEC_PACKET_TYPE_INFOFRAME_AVI:
+		case _SEC_PACKET_TYPE_INFOFRAME_AUDIO:
+		case _SEC_PACKET_TYPE_INFOFRAME_MPEG:
+			pucData[1] = 0x84;
+			pucData[2] = 0x1B;
+			pucData[3] = 0x44;
+
+			SetReg(base, PBC_26_SEC_INFO_AUD_DB0, 0x11);
+			SetReg(base, PBC_27_SEC_INFO_AUD_DB1, 0x0F);
+			break;
+		case _SEC_PACKET_TYPE_AUDIO_STREAM:
+			pucData[2] = 0x00;
+			pucData[3] = 0x01;
+			break;
+		case _SEC_PACKET_TYPE_INFOFRAME_RSV:
+			pucData[1] = 0x83;
+			pucData[2] = 0x01;
+			pucData[3] = 0x08;
+			break;
+		default:
+			break;
+	}
+	// Set Header Byte
+	SetReg(base, PBC_73_SEC_PH_HB0, pucData[0]);
+	SetReg(base, PBC_74_SEC_PH_HB1, pucData[1]);
+	SetReg(base, PBC_75_SEC_PH_HB2, pucData[2]);
+	SetReg(base, PBC_76_SEC_PH_HB3, pucData[3]);
+	// Set Parity Byte
+	SetReg(base, PBC_77_SEC_PH_PB0, dptx_audio_get_parity(pucData[0]));
+	SetReg(base, PBC_78_SEC_PH_PB1, dptx_audio_get_parity(pucData[1]));
+	SetReg(base, PBC_79_SEC_PH_PB2, dptx_audio_get_parity(pucData[2]));
+	SetReg(base, PBC_7A_SEC_PH_PB3, dptx_audio_get_parity(pucData[3]));
+	// Set Double Buffer
+	SetBit(base, PBC_02_SEC_DBUF_CTRL, ~(_BIT1 | _BIT0), (_BIT1 | _BIT0));
+}
+
+static void dptx_audio_setting(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	unsigned char pucData[6];
+
+	// Set 2 channel layout and audio source from I2S
+	SetBit(base, PBC_18_AUD_FUNCTION_CTRL1, ~(_BIT7 | _BIT6), 0x00);
+	pucData[0] = 20;
+
+//	((WORD *)pucData)[0] = 2 + ((8 + pucData[0]) / hwinfo->DownStreamInfo.LaneNum;
+//	((WORD *)pucData)[1] = (DWORD)(((WORD *)pucData)[1] - hwinfo->TxInputInfo.HorizontalDataEnablePeriod * 7 / 10;
+//	if(((WORD *)pucData)[1] > ((WORD *)pucData)[0])
+//		((WORD *)pucData)[2] = ((WORD *)pucData)[1] - ((WORD *)pucData)[0];
+//	else
+//		((WORD *)pucData)[2] = 0;
+	
+//	SetReg(base, PBB_D4_ARBITER_SEC_END_CNT_HB, pucData[4]);
+//	SetReg(base, PBB_D5_ARBITER_SEC_END_CNT_LB, pucData[5]);
+	SetReg(base, PBB_D4_ARBITER_SEC_END_CNT_HB, 0x00);
+	SetReg(base, PBB_D5_ARBITER_SEC_END_CNT_LB, 0x10);
+
+}
+
+void dptx_sst_audioplay_setting(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+
+	SetBit(base, PBC_00_SEC_FUNCTION_CTRL, ~_BIT0, 0x00);
+	SetReg(base, PBC_47_AUD_FUNCTION_CTRL2, 0x4F);
+	SetReg(base, PBC_48_AUD_FUNCTION_CTRL3, 0x04);
+	SetReg(base, PBC_19_AUD_PAYLOAD_B3, 0x80);
+
+	dptx_audio_setting(hwinfo);
+	// Set Maud	
+	SetReg(base, PBC_20_AUD_TS_MAUD_H, 0x0);
+	SetReg(base, PBC_21_AUD_TS_MAUD_M, 0x2);
+	SetReg(base, PBC_22_AUD_TS_MAUD_L, 0x0);
+	// Sed Naud
+	SetReg(base, PBC_23_AUD_TS_NAUD_H, 0x0);
+	SetReg(base, PBC_24_AUD_TS_NAUD_M, 0x15);
+	SetReg(base, PBC_25_AUD_TS_NAUD_L, 0xf9);
+	
+	// Set Header for Audio Timestamp
+	dptx_set_sec_header(hwinfo, _SEC_PACKET_TYPE_AUDIO_TIMESTAMP);
+	// Set Header for Audio Info-frame
+	dptx_set_sec_header(hwinfo, _SEC_PACKET_TYPE_INFOFRAME_AUDIO);
+	// Set Header for Audio Stream
+	dptx_set_sec_header(hwinfo, _SEC_PACKET_TYPE_AUDIO_STREAM);
+
+	SetBit(base, PBC_00_SEC_FUNCTION_CTRL, ~(_BIT3 | _BIT1 | _BIT0), (_BIT3 | _BIT1 | _BIT0));
+	SetBit(base, PBC_8F_DPTX_I2S_CTRL, ~(_BIT7 | _BIT6 | _BIT5 | _BIT4 | _BIT1 | _BIT0), (_BIT7 | _BIT1 | _BIT0));
+
+	SetReg(base, PBC_85_CH_STATUS_0, 0x04);
+	SetReg(base, PBC_86_CH_STATUS_1, 0x00);
+	SetReg(base, PBC_87_CH_STATUS_2, 0x00);
+	SetReg(base, PBC_88_CH_STATUS_3, 0x02);
+	SetReg(base, PBC_89_CH_STATUS_4, 0x0b);
+
+	SetBit(base, PBB_C7_VBID, ~_BIT2, 0x00);
+}
+
+void dptx_sst_displayformat_setting(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	// Disable HW Auto Calculate H Delay
+	SetBit(base, PBB_D3_LFIFO_WL_SET, ~_BIT7, 0x00);
+
+	SetBit(base, PBB_A1_DP_RESET_CTRL, ~_BIT7, _BIT7);
+	SetBit(base, PBB_A1_DP_RESET_CTRL, ~_BIT7, 0x00);
+	switch (hwinfo->out_type) {
+	case DP_FORMAT_1024_768:
+		SetReg(base, PBB_CD_TU_DATA_SIZE0, 0x2e);
+		SetReg(base, PBB_CE_TU_DATA_SIZE1, 0x01);
+		SetReg(base, PBB_CA_V_DATA_PER_LINE0, 0xc);
+		SetReg(base, PBB_CB_V_DATA_PER_LINE1, 0x00);
+		break;
+	case DP_FORMAT_720P_60:
+		SetReg(base, PBB_CD_TU_DATA_SIZE0, 0x35);
+		SetReg(base, PBB_CE_TU_DATA_SIZE1, 0x0);
+		SetReg(base, PBB_CA_V_DATA_PER_LINE0, 0xf);
+		SetReg(base, PBB_CB_V_DATA_PER_LINE1, 0x00);
+		break;
+	case DP_FORMAT_1440_768:
+		SetReg(base, PBB_CD_TU_DATA_SIZE0, 0x19);
+		SetReg(base, PBB_CE_TU_DATA_SIZE1, 0x6);
+		SetReg(base, PBB_CA_V_DATA_PER_LINE0, 0x8);
+		SetReg(base, PBB_CB_V_DATA_PER_LINE1, 0x70);
+		break;
+	case DP_FORMAT_1440_900:
+		SetReg(base, PBB_CD_TU_DATA_SIZE0, 0x1e);
+		SetReg(base, PBB_CE_TU_DATA_SIZE1, 0x0);
+		SetReg(base, PBB_CA_V_DATA_PER_LINE0, 0x8);
+		SetReg(base, PBB_CB_V_DATA_PER_LINE1, 0x70);
+		break;
+	case DP_FORMAT_1280_800:
+		SetReg(base, PBB_CD_TU_DATA_SIZE0, 0x17);
+		SetReg(base, PBB_CE_TU_DATA_SIZE1, 0x8);
+		SetReg(base, PBB_CA_V_DATA_PER_LINE0, 0x7);
+		SetReg(base, PBB_CB_V_DATA_PER_LINE1, 0x80);
+		break;
+	case DP_FORMAT_960_544:
+		SetReg(base, PBB_CD_TU_DATA_SIZE0, 0x18);
+		SetReg(base, PBB_CE_TU_DATA_SIZE1, 0x8);
+		SetReg(base, PBB_CA_V_DATA_PER_LINE0, 0xb);
+		SetReg(base, PBB_CB_V_DATA_PER_LINE1, 0x40);
+		break;
+	case DP_FORMAT_1080P_60:
+		SetReg(base, PBB_CD_TU_DATA_SIZE0, 0x35);
+		SetReg(base, PBB_CE_TU_DATA_SIZE1, 0x0);
+		SetReg(base, PBB_CA_V_DATA_PER_LINE0, 0xb);
+		SetReg(base, PBB_CB_V_DATA_PER_LINE1, 0x40);
+		break;
+	case DP_FORMAT_2160P_30:
+		SetReg(base, PBB_CD_TU_DATA_SIZE0, 0x3d);
+		SetReg(base, PBB_CE_TU_DATA_SIZE1, 0x01);
+		SetReg(base, PBB_CA_V_DATA_PER_LINE0, 0xf);
+		SetReg(base, PBB_CB_V_DATA_PER_LINE1, 0x00);
+		break;
+	case DP_FORMAT_2160P_60:
+		SetReg(base, PBB_CD_TU_DATA_SIZE0, 0x3e);
+		SetReg(base, PBB_CE_TU_DATA_SIZE1, 0x0);
+		SetReg(base, PBB_CA_V_DATA_PER_LINE0, 0x7);
+		SetReg(base, PBB_CB_V_DATA_PER_LINE1, 0x80);
+		break;
+	default:
+		break;
+	}
+	SetReg(base, PBB_D3_LFIFO_WL_SET, 0xC0);
+}
+
+static void dptx_sstmsa_setting(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+
+	SetBit(base, PBB_A1_DP_RESET_CTRL, ~_BIT6, _BIT6);
+	SetBit(base, PBB_A1_DP_RESET_CTRL, ~_BIT6, 0x00);
+	
+	switch (hwinfo->out_type) {
+	case DP_FORMAT_1024_768:
+		SetReg(base, PBB_B7_MN_STRM_ATTR_HTT_M, 0x5);
+		SetReg(base, PBB_B8_MN_STRM_ATTR_HTT_L, 0x40);
+		SetReg(base, PBB_B9_MN_STRM_ATTR_HST_M, 0x1);
+		SetReg(base, PBB_BA_MN_STRM_ATTR_HST_L, 0x29);
+		SetReg(base, PBB_BB_MN_STRM_ATTR_HWD_M, 0x4);
+		SetReg(base, PBB_BC_MN_STRM_ATTR_HWD_L, 0x00);
+		SetReg(base, PBB_BD_MN_STRM_ATTR_HSW_M, 0x80);
+		SetReg(base, PBB_BE_MN_STRM_ATTR_HSW_L, 0x88);
+		SetReg(base, PBB_BF_MN_STRM_ATTR_VTTE_M, 0x3);
+		SetReg(base, PBB_C0_MN_STRM_ATTR_VTTE_L, 0x26);
+		SetReg(base, PBB_C2_MN_STRM_ATTR_VST_L, 0x24);
+		SetReg(base, PBB_C3_MN_STRM_ATTR_VHT_M, 0x3);
+		SetReg(base, PBB_C4_MN_STRM_ATTR_VHT_L, 0x00);
+		SetReg(base, PBB_C5_MN_STRM_ATTR_VSW_M, 0x80);
+		SetReg(base, PBB_C6_MN_STRM_ATTR_VSW_L, 0x6);
+		SetReg(base, PBB_B5_MSA_MISC0, 0x20);
+		break;
+	case DP_FORMAT_720P_60:
+		SetReg(base, PBB_B7_MN_STRM_ATTR_HTT_M, 0x6);
+		SetReg(base, PBB_B8_MN_STRM_ATTR_HTT_L, 0x72);
+		SetReg(base, PBB_B9_MN_STRM_ATTR_HST_M, 0x01);
+		SetReg(base, PBB_BA_MN_STRM_ATTR_HST_L, 0x33);
+		SetReg(base, PBB_BB_MN_STRM_ATTR_HWD_M, 0x5);
+		SetReg(base, PBB_BC_MN_STRM_ATTR_HWD_L, 0x00);
+		SetReg(base, PBB_BD_MN_STRM_ATTR_HSW_M, 0x0);
+		SetReg(base, PBB_BE_MN_STRM_ATTR_HSW_L, 0x28);
+		SetReg(base, PBB_BF_MN_STRM_ATTR_VTTE_M, 0x2);
+		SetReg(base, PBB_C0_MN_STRM_ATTR_VTTE_L, 0xee);
+		SetReg(base, PBB_C2_MN_STRM_ATTR_VST_L, 0x1a);
+		SetReg(base, PBB_C3_MN_STRM_ATTR_VHT_M, 0x2);
+		SetReg(base, PBB_C4_MN_STRM_ATTR_VHT_L, 0xd0);
+		SetReg(base, PBB_C5_MN_STRM_ATTR_VSW_M, 0x0);
+		SetReg(base, PBB_C6_MN_STRM_ATTR_VSW_L, 0x5);
+		SetReg(base, PBB_B5_MSA_MISC0, 0x20);
+		break;
+	case DP_FORMAT_1440_768:
+		SetReg(base, PBB_B7_MN_STRM_ATTR_HTT_M, 0x5);
+		SetReg(base, PBB_B8_MN_STRM_ATTR_HTT_L, 0xf0);
+		SetReg(base, PBB_B9_MN_STRM_ATTR_HST_M, 0x0);
+		SetReg(base, PBB_BA_MN_STRM_ATTR_HST_L, 0x49);
+		SetReg(base, PBB_BB_MN_STRM_ATTR_HWD_M, 0x5);
+		SetReg(base, PBB_BC_MN_STRM_ATTR_HWD_L, 0xa0);
+		SetReg(base, PBB_BD_MN_STRM_ATTR_HSW_M, 0x0);
+		SetReg(base, PBB_BE_MN_STRM_ATTR_HSW_L, 0x20);
+		SetReg(base, PBB_BF_MN_STRM_ATTR_VTTE_M, 0x3);
+		SetReg(base, PBB_C0_MN_STRM_ATTR_VTTE_L, 0x16);
+		SetReg(base, PBB_C2_MN_STRM_ATTR_VST_L, 0xf);
+		SetReg(base, PBB_C3_MN_STRM_ATTR_VHT_M, 0x3);
+		SetReg(base, PBB_C4_MN_STRM_ATTR_VHT_L, 0x00);
+		SetReg(base, PBB_C5_MN_STRM_ATTR_VSW_M, 0x00);
+		SetReg(base, PBB_C6_MN_STRM_ATTR_VSW_L, 0x8);
+		SetReg(base, PBB_B5_MSA_MISC0, 0x20);
+		break;
+	case DP_FORMAT_1440_900:
+		SetReg(base, PBB_B7_MN_STRM_ATTR_HTT_M, 0x5);
+		SetReg(base, PBB_B8_MN_STRM_ATTR_HTT_L, 0xf0);
+		SetReg(base, PBB_B9_MN_STRM_ATTR_HST_M, 0x0);
+		SetReg(base, PBB_BA_MN_STRM_ATTR_HST_L, 0x49);
+		SetReg(base, PBB_BB_MN_STRM_ATTR_HWD_M, 0x5);
+		SetReg(base, PBB_BC_MN_STRM_ATTR_HWD_L, 0xa0);
+		SetReg(base, PBB_BD_MN_STRM_ATTR_HSW_M, 0x0);
+		SetReg(base, PBB_BE_MN_STRM_ATTR_HSW_L, 0x20);
+		SetReg(base, PBB_BF_MN_STRM_ATTR_VTTE_M, 0x3);
+		SetReg(base, PBB_C0_MN_STRM_ATTR_VTTE_L, 0x9e);
+		SetReg(base, PBB_C2_MN_STRM_ATTR_VST_L, 0xf);
+		SetReg(base, PBB_C3_MN_STRM_ATTR_VHT_M, 0x3);
+		SetReg(base, PBB_C4_MN_STRM_ATTR_VHT_L, 0x84);
+		SetReg(base, PBB_C5_MN_STRM_ATTR_VSW_M, 0x0);
+		SetReg(base, PBB_C6_MN_STRM_ATTR_VSW_L, 0x8);
+		SetReg(base, PBB_B5_MSA_MISC0, 0x20);
+		break;
+	case DP_FORMAT_1280_800:
+		SetReg(base, PBB_B7_MN_STRM_ATTR_HTT_M, 0x5);
+		SetReg(base, PBB_B8_MN_STRM_ATTR_HTT_L, 0x50);
+		SetReg(base, PBB_B9_MN_STRM_ATTR_HST_M, 0x0);
+		SetReg(base, PBB_BA_MN_STRM_ATTR_HST_L, 0x49);
+		SetReg(base, PBB_BB_MN_STRM_ATTR_HWD_M, 0x5);
+		SetReg(base, PBB_BC_MN_STRM_ATTR_HWD_L, 0x00);
+		SetReg(base, PBB_BD_MN_STRM_ATTR_HSW_M, 0x0);
+		SetReg(base, PBB_BE_MN_STRM_ATTR_HSW_L, 0x20);
+		SetReg(base, PBB_BF_MN_STRM_ATTR_VTTE_M, 0x3);
+		SetReg(base, PBB_C0_MN_STRM_ATTR_VTTE_L, 0x37);
+		SetReg(base, PBB_C2_MN_STRM_ATTR_VST_L, 0xf);
+		SetReg(base, PBB_C3_MN_STRM_ATTR_VHT_M, 0x3);
+		SetReg(base, PBB_C4_MN_STRM_ATTR_VHT_L, 0x20);
+		SetReg(base, PBB_C5_MN_STRM_ATTR_VSW_M, 0x0);
+		SetReg(base, PBB_C6_MN_STRM_ATTR_VSW_L, 0x8);
+		SetReg(base, PBB_B5_MSA_MISC0, 0x20);
+		break;
+	case DP_FORMAT_960_544:
+		SetReg(base, PBB_B7_MN_STRM_ATTR_HTT_M, 0x4);
+		SetReg(base, PBB_B8_MN_STRM_ATTR_HTT_L, 0x10);
+		SetReg(base, PBB_B9_MN_STRM_ATTR_HST_M, 0x0);
+		SetReg(base, PBB_BA_MN_STRM_ATTR_HST_L, 0x49);
+		SetReg(base, PBB_BB_MN_STRM_ATTR_HWD_M, 0x3);
+		SetReg(base, PBB_BC_MN_STRM_ATTR_HWD_L, 0xc0);
+		SetReg(base, PBB_BD_MN_STRM_ATTR_HSW_M, 0x0);
+		SetReg(base, PBB_BE_MN_STRM_ATTR_HSW_L, 0x20);
+		SetReg(base, PBB_BF_MN_STRM_ATTR_VTTE_M, 0x2);
+		SetReg(base, PBB_C0_MN_STRM_ATTR_VTTE_L, 0x30);
+		SetReg(base, PBB_C2_MN_STRM_ATTR_VST_L, 0xf);
+		SetReg(base, PBB_C3_MN_STRM_ATTR_VHT_M, 0x2);
+		SetReg(base, PBB_C4_MN_STRM_ATTR_VHT_L, 0x20);
+		SetReg(base, PBB_C5_MN_STRM_ATTR_VSW_M, 0x0);
+		SetReg(base, PBB_C6_MN_STRM_ATTR_VSW_L, 0x8);
+		SetReg(base, PBB_B5_MSA_MISC0, 0x20);
+		break;
+	case DP_FORMAT_1080P_60:
+		SetReg(base, PBB_B7_MN_STRM_ATTR_HTT_M, 0x8);
+		SetReg(base, PBB_B8_MN_STRM_ATTR_HTT_L, 0x98);
+		SetReg(base, PBB_B9_MN_STRM_ATTR_HST_M, 0x00);
+		SetReg(base, PBB_BA_MN_STRM_ATTR_HST_L, 0xC1);
+		SetReg(base, PBB_BB_MN_STRM_ATTR_HWD_M, 0x7);
+		SetReg(base, PBB_BC_MN_STRM_ATTR_HWD_L, 0x80);
+		SetReg(base, PBB_BD_MN_STRM_ATTR_HSW_M, 0x0);
+		SetReg(base, PBB_BE_MN_STRM_ATTR_HSW_L, 0x2C);
+		SetReg(base, PBB_BF_MN_STRM_ATTR_VTTE_M, 0x4);
+		SetReg(base, PBB_C0_MN_STRM_ATTR_VTTE_L, 0x65);
+		SetReg(base, PBB_C2_MN_STRM_ATTR_VST_L, 0x2A);
+		SetReg(base, PBB_C3_MN_STRM_ATTR_VHT_M, 0x4);
+		SetReg(base, PBB_C4_MN_STRM_ATTR_VHT_L, 0x38);
+		SetReg(base, PBB_C5_MN_STRM_ATTR_VSW_M, 0x0);
+		SetReg(base, PBB_C6_MN_STRM_ATTR_VSW_L, 0x5);
+		SetReg(base, PBB_B5_MSA_MISC0, 0x20);
+		break;
+	case DP_FORMAT_2160P_30:
+		SetReg(base, PBB_B7_MN_STRM_ATTR_HTT_M, 0x0f);
+		SetReg(base, PBB_B8_MN_STRM_ATTR_HTT_L, 0x50);
+		SetReg(base, PBB_B9_MN_STRM_ATTR_HST_M, 0x00);
+		SetReg(base, PBB_BA_MN_STRM_ATTR_HST_L, 0x49);
+		SetReg(base, PBB_BB_MN_STRM_ATTR_HWD_M, 0xf);
+		SetReg(base, PBB_BC_MN_STRM_ATTR_HWD_L, 0x00);
+		SetReg(base, PBB_BD_MN_STRM_ATTR_HSW_M, 0x0);
+		SetReg(base, PBB_BE_MN_STRM_ATTR_HSW_L, 0x20);
+		SetReg(base, PBB_BF_MN_STRM_ATTR_VTTE_M, 0x8);
+		SetReg(base, PBB_C0_MN_STRM_ATTR_VTTE_L, 0x8f);
+		SetReg(base, PBB_C2_MN_STRM_ATTR_VST_L, 0xf);
+		SetReg(base, PBB_C3_MN_STRM_ATTR_VHT_M, 0x8);
+		SetReg(base, PBB_C4_MN_STRM_ATTR_VHT_L, 0x70);
+		SetReg(base, PBB_C5_MN_STRM_ATTR_VSW_M, 0x0);
+		SetReg(base, PBB_C6_MN_STRM_ATTR_VSW_L, 0xa);
+		SetReg(base, PBB_B5_MSA_MISC0, 0x3a);
+		break;
+	case DP_FORMAT_2160P_60:
+		SetReg(base, PBB_B7_MN_STRM_ATTR_HTT_M, 0xf);
+		SetReg(base, PBB_B8_MN_STRM_ATTR_HTT_L, 0x50);
+		SetReg(base, PBB_BA_MN_STRM_ATTR_HST_L, 0x49);
+		SetReg(base, PBB_BB_MN_STRM_ATTR_HWD_M, 0xf);
+		SetReg(base, PBB_BC_MN_STRM_ATTR_HWD_L, 0x00);
+		SetReg(base, PBB_BD_MN_STRM_ATTR_HSW_M, 0x0);
+		SetReg(base, PBB_BE_MN_STRM_ATTR_HSW_L, 0x20);
+		SetReg(base, PBB_BF_MN_STRM_ATTR_VTTE_M, 0x8);
+		SetReg(base, PBB_C0_MN_STRM_ATTR_VTTE_L, 0xae);
+		SetReg(base, PBB_C2_MN_STRM_ATTR_VST_L, 0xf);
+		SetReg(base, PBB_C3_MN_STRM_ATTR_VHT_M, 0x8);
+		SetReg(base, PBB_C4_MN_STRM_ATTR_VHT_L, 0x70);
+		SetReg(base, PBB_C5_MN_STRM_ATTR_VSW_M, 0x0);
+		SetReg(base, PBB_C6_MN_STRM_ATTR_VSW_L, 0x8);
+		SetReg(base, PBB_B5_MSA_MISC0, 0x3a);
+		break;
+	}
+	SetBit(base, PBB_B4_MSA_CTRL, ~_BIT7, _BIT7);
+}
+
+void dptx_sst_setting(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *base = hwinfo->reg_base;
+	bool bMvidHWMode = true;
+	unsigned char ucValidHwMvidMeaCnt = 0;
+	unsigned short usLoopCnt = 0;
+	unsigned short usMeasureTime = 0;
+	unsigned int ulHwMvidMin = 0xFFFFFFFF;
+	unsigned int ulHwMvidMax = 0x00000000;
+	unsigned int pucData[6];
+	int i;
+#if 0
+	if (hwinfo->chip_id != CHIP_ID_RTD1619) {
+		SetReg(base, PBB_A8_MN_VID_AUTO_EN_1, 0x40);
+		SetReg(base, PBB_AA_MN_M_VID_M, 0x46);
+		SetReg(base, PBB_AB_MN_M_VID_L, 0x67);
+		SetReg(base, PBB_AD_MN_N_VID_M, 0x80);
+		SetReg(base, PBB_AE_MN_N_VID_L, 0x00);
+		SetReg(base, PBB_A8_MN_VID_AUTO_EN_1, 0x40);
+		SetBit(base, PBB_A8_MN_VID_AUTO_EN_1, ~(_BIT7 | _BIT6), _BIT6 | _BIT7);
+		goto set_mn_finish;
+	}
+#endif
+	pucData[0] = 0;
+	pucData[1] = 0x8000;
+	pucData[2] = 0;
+	pucData[3] = 0;
+
+	hwinfo->DownStreamInfo.LinkRate = 1;
+	pucData[0] = hwinfo->InputInfo.InputPixelClk * pucData[1];
+	pucData[0] /= (hwinfo->DownStreamInfo.SSCSupport == true) ?
+		(270 * hwinfo->DownStreamInfo.LinkRate *9975 / 10000) :
+		(270 * hwinfo->DownStreamInfo.LinkRate);
+	usMeasureTime = (unsigned short)(pucData[1] /
+		( (hwinfo->DownStreamInfo.SSCSupport == true) ?
+		(27 * hwinfo->DownStreamInfo.LinkRate *9975 / 10000) :
+		(27 * hwinfo->DownStreamInfo.LinkRate)) / 5);
+	usMeasureTime *= 2;
+
+	for (i=0; i<10; i++) {
+		// Enable HW Mvid measure
+		SetBit(base, PBB_A8_MN_VID_AUTO_EN_1, ~_BIT7, _BIT7);
+		// Delay time for one HW mvid measurement period time
+		for(usLoopCnt = 0; usLoopCnt < usMeasureTime; usLoopCnt++)
+			udelay(5);
+		// Disable HW Mvid measure
+		SetBit(base, PBB_A8_MN_VID_AUTO_EN_1, ~_BIT7, 0x00);
+
+		pucData[2] = ((GetReg(base, PBB_AF_MVID_AUTO_H) << 16)
+			| (GetReg(base, PBB_B0_MVID_AUTO_M) << 8)
+			| GetReg(base, PBB_B1_MVID_AUTO_L));
+		if (pucData[2] == 0) {
+			SetReg(base, PBB_A9_MN_M_VID_H,
+				*((unsigned char *)pucData+2));
+			SetReg(base, PBB_AA_MN_M_VID_M,
+				*((unsigned char *)pucData+1));
+			SetReg(base, PBB_AB_MN_M_VID_L,
+				*((unsigned char *)pucData+0));
+
+			bMvidHWMode = false;
+			break;
+		}
+		if(abs(pucData[0] - pucData[2]) > pucData[0] >> 2)
+			continue;
+		if(pucData[3] == 0) {
+			if(pucData[2] < ulHwMvidMin)
+				ulHwMvidMin = pucData[2];
+			if(pucData[2] > ulHwMvidMax)
+				ulHwMvidMax = pucData[2];
+			pucData[3] = pucData[2];
+
+			ucValidHwMvidMeaCnt++;
+			continue;
+		}
+		if(abs(((pucData[3] + (ucValidHwMvidMeaCnt / 2)) /
+			ucValidHwMvidMeaCnt) - pucData[2]) < 0x50) {
+			if(pucData[2] < ulHwMvidMin)
+				ulHwMvidMin = pucData[2];
+			if(pucData[2] > ulHwMvidMax)
+				ulHwMvidMax = pucData[2];
+			pucData[3] += pucData[2];
+
+			ucValidHwMvidMeaCnt++;
+		}
+	}
+
+	if(bMvidHWMode == true) {
+		if(ucValidHwMvidMeaCnt > 2) {
+			pucData[3] -= ulHwMvidMax + ulHwMvidMin;
+			ucValidHwMvidMeaCnt -= 2;
+			pucData[3] = ((pucData[3] + (ucValidHwMvidMeaCnt / 2))
+					/ ucValidHwMvidMeaCnt);
+			if(abs(pucData[0] - pucData[3]) > (pucData[0] >> 1))
+				pucData[3] = pucData[0];
+		} else
+			pucData[3] = pucData[0];
+
+		SetReg(base, PBB_A9_MN_M_VID_H, *((unsigned char *)pucData+14));
+		SetReg(base, PBB_AA_MN_M_VID_M, *((unsigned char *)pucData+13));
+		SetReg(base, PBB_AB_MN_M_VID_L, *((unsigned char *)pucData+12));
+	}
+	SetReg(base, PBB_AC_MN_N_VID_H, *((unsigned char *)pucData+6));
+	SetReg(base, PBB_AD_MN_N_VID_M, *((unsigned char *)pucData+5));
+	SetReg(base, PBB_AE_MN_N_VID_L, *((unsigned char *)pucData+4));
+	SetBit(base, PBB_B4_MSA_CTRL, ~_BIT6, 0x00);
+	SetBit(base, PBB_A8_MN_VID_AUTO_EN_1, ~(_BIT7 | _BIT6), _BIT6);
+
+//set_mn_finish:
+	dptx_sstmsa_setting(hwinfo);
+	dptx_sst_displayformat_setting(hwinfo);
+
+	SetReg(base, PBB_A4_PG_FIFO_CTRL, 0xFF);
+	
+#if defined(AUDIO_ON) && AUDIO_ON
+	dptx_sst_audioplay_setting(hwinfo);
+#else
+	SetReg(base, PBB_C7_VBID, 0x4);
+	SetReg(base, PBB_D4_ARBITER_SEC_END_CNT_HB, 0);
+#endif
+}
+
+void vo_common_setting(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *pll_base = hwinfo->pll_base;
+	void __iomem *vo_base = hwinfo->vo_base;
+
+	writel(0x10C167, pll_base + 0x260);
+	writel(0x7, pll_base + 0x264);
+	writel(0x3, pll_base + 0x264);
+	mdelay(10);
+	if (hwinfo->chip_id == CHIP_ID_RTD1619) {
+		writel(0x10, vo_base + 0xc);
+		writel(0x3, vo_base);
+		writel(0x5, vo_base + 0x8);
+		writel(0x1401, vo_base + 0x2c);
+		writel(0x2000000, vo_base + 0x3c);
+		writel(0x3000000, vo_base + 0x40);
+	} else {
+		writel(0x10, vo_base + 0x8);
+		writel(0x3, vo_base);
+		writel(0x5, vo_base + 0x4);
+		writel(0x1401, vo_base + 0x28);
+		writel(0x2000000, vo_base + 0x38);
+		writel(0x3000000, vo_base + 0x3c);
+	}
+
+#ifndef TESTING
+	if (hwinfo->chip_id == CHIP_ID_RTD1619) {
+		writel(0x8000800, vo_base + 0x1a10);
+		writel(0x800, vo_base + 0x1a14);
+		writel(0xed83e80, vo_base + 0x1a18);
+		writel(0x3c410c99, vo_base + 0x1a1c);
+		writel(0x0, vo_base + 0x1a20);
+		writel(0x150cda, vo_base + 0x1a24);
+		writel(0xc4a, vo_base + 0x1a28);
+	} else {
+		writel(0x8000800, vo_base + 0xdfc);
+		writel(0x800, vo_base + 0xe00);
+		writel(0xed83e80, vo_base + 0xe04);
+		writel(0x3c410c99, vo_base + 0xe08);
+		writel(0x0, vo_base + 0xe0C);
+		writel(0x150cda, vo_base + 0xe10);
+		writel(0xc4a, vo_base + 0xe14);
+	}
+#else
+	writel(0x8000000, vo_base + 0x1a10);
+	writel(0x0, vo_base + 0x1a14);
+	writel(0x8000000, vo_base + 0x1a18);
+	writel(0x800, vo_base + 0x1a1c);
+	writel(0x0, vo_base + 0x1a20);
+	writel(0x0, vo_base + 0x1a24);
+	writel(0x0, vo_base + 0x1a28);
+#endif
+}
+
+void dptx_lvdsint_en(struct rtk_dptx_hwinfo *hwinfo, int en)
+{
+	void __iomem *lvds_base = hwinfo->lvds_base;
+	void __iomem *base = hwinfo->reg_base;
+	unsigned int reg;
+
+	reg = readl(lvds_base + DV_SYNC_INT);
+	if(en) {
+		reg = reg | 0x80000000;
+	} else {
+		SetReg(base, PBB_C8_VBID_FW_CTL, 0x1);
+		reg = reg & ~0x80000000;
+	}
+	writel(reg, lvds_base + DV_SYNC_INT);
+}
+
+void dptx_set_vo(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *vo_base = hwinfo->vo_base;
+
+	vo_common_setting(hwinfo);
+
+	switch (hwinfo->out_type) {
+	case DP_FORMAT_720P_60:
+		writel(0x500, vo_base + 0x48);
+		writel(0x500, vo_base + 0x4c);
+		writel(0x5002d0, vo_base + 0x68);
+		writel(0x50002d0, vo_base + 0xd78);
+		break;
+	case DP_FORMAT_1024_768:
+		writel(0x400, vo_base + 0x48);
+		writel(0x400, vo_base + 0x4c);
+		writel(0x400300, vo_base + 0x68);
+		writel(0x4000300, vo_base + 0xd78);
+		break;
+	case DP_FORMAT_1440_768:
+		writel(0x5a0, vo_base + 0x48);
+		writel(0x5a0, vo_base + 0x4c);
+		writel(0x5a0300, vo_base + 0x68);
+		writel(0x5a00300, vo_base + 0xd78);
+		break;
+	case DP_FORMAT_1440_900:
+		writel(0x5a0, vo_base + 0x48);
+		writel(0x5a0, vo_base + 0x4c);
+		writel(0x5a0384, vo_base + 0x68);
+		writel(0x5a00384, vo_base + 0xd78);
+		break;
+	case DP_FORMAT_1280_800:
+		writel(0x500, vo_base + 0x48);
+		writel(0x500, vo_base + 0x4c);
+		writel(0x500320, vo_base + 0x68);
+		writel(0x5000320, vo_base + 0xd78);
+		break;
+	case DP_FORMAT_960_544:
+		writel(0x3c0, vo_base + 0x48);
+		writel(0x3c0, vo_base + 0x4c);
+		writel(0x3c0220, vo_base + 0x68);
+		writel(0x3c00220, vo_base + 0xd78);
+		break;
+	case DP_FORMAT_1080P_60:
+		writel(0x780, vo_base + 0x4c);
+		writel(0x780, vo_base + 0x50);
+		writel(0x780438, vo_base + 0x90);
+		writel(0x7800438, vo_base + 0x17ac);
+		break;
+	case DP_FORMAT_2160P_30:
+		writel(0xf00, vo_base + 0x4c);
+		writel(0xf00, vo_base + 0x50);
+		writel(0xf00870, vo_base + 0x90);
+		writel(0xf000870, vo_base + 0x17ac);
+		break;
+	default:
+		pr_err("can't no support this resolution");
+		break;
+	}
+}
+
+void dptx_set_resolution(struct rtk_dptx_hwinfo *hwinfo)
+{
+	void __iomem *lvds_base = hwinfo->lvds_base;
+	void __iomem *base = hwinfo->reg_base;
+	void __iomem *vo_base = hwinfo->vo_base;
+
+	if (!hwinfo->vo_en)
+		SetReg(base, PBB_C8_VBID_FW_CTL, 0x1);
+
+	switch (hwinfo->out_type) {
+	case DP_FORMAT_720P_60:
+		hwinfo->InputInfo.InputPixelClk = 74;
+		hwinfo->DownStreamInfo.LaneNum = _DP_ONE_LANE;
+
+		SetReg(lvds_base, CT_CTRL, 0);
+		SetReg(lvds_base, DH_WIDTH, 0x28);
+		SetReg(lvds_base, DH_TOTAL, 0x6720672);
+		SetReg(lvds_base, DH_DEN_START_END, 0x0fb05fb);
+		SetReg(lvds_base, DV_DEN_START_END_F1, 0x1a02ea);
+		SetReg(lvds_base, DV_TOTAL, 0x2ee);
+		SetReg(lvds_base, DV_VS_START_END_F1, 0x10006);
+		SetReg(lvds_base, DV_SYNC_INT, 0x000002eb | (hwinfo->vo_en << 31));
+		break;
+	case DP_FORMAT_1024_768:
+		hwinfo->InputInfo.InputPixelClk = 65;
+		hwinfo->DownStreamInfo.LaneNum = _DP_ONE_LANE;
+
+		SetReg(lvds_base, CT_CTRL, 0);
+		SetReg(lvds_base, DH_WIDTH, 0x88);
+		SetReg(lvds_base, DH_TOTAL, 0x5400540);
+		SetReg(lvds_base, DH_DEN_START_END, 0x11f051f);
+		SetReg(lvds_base, DV_DEN_START_END_F1, 0x240324);
+		SetReg(lvds_base, DV_TOTAL, 0x326);
+		SetReg(lvds_base, DV_VS_START_END_F1, 0x10007);
+		SetReg(lvds_base, DV_SYNC_INT, 0x00000325 | (hwinfo->vo_en << 31));
+		break;
+	case DP_FORMAT_1440_768:
+		hwinfo->InputInfo.InputPixelClk = 72;
+		hwinfo->DownStreamInfo.LaneNum = _DP_TWO_LANE;
+
+		SetReg(lvds_base, CT_CTRL, 0);
+		SetReg(lvds_base, DH_WIDTH, 0x20);
+		SetReg(lvds_base, DH_TOTAL, 0x5f005f0);
+		SetReg(lvds_base, DH_DEN_START_END, 0x03f05df);
+		SetReg(lvds_base, DV_DEN_START_END_F1, 0xf030f);
+		SetReg(lvds_base, DV_TOTAL, 0x316);
+		SetReg(lvds_base, DV_VS_START_END_F1, 0x10009);
+		SetReg(lvds_base, DV_SYNC_INT, 0x00000310 | (hwinfo->vo_en << 31));
+		break;
+	case DP_FORMAT_1440_900:
+		hwinfo->InputInfo.InputPixelClk = 85;
+		hwinfo->DownStreamInfo.LaneNum = _DP_TWO_LANE;
+
+		SetReg(lvds_base, CT_CTRL, 0);
+		SetReg(lvds_base, DH_WIDTH, 0x20);
+		SetReg(lvds_base, DH_TOTAL, 0x5f005f0);
+		SetReg(lvds_base, DH_DEN_START_END, 0x03f05df);
+		SetReg(lvds_base, DV_DEN_START_END_F1, 0xf0393);
+		SetReg(lvds_base, DV_TOTAL, 0x39e);
+		SetReg(lvds_base, DV_VS_START_END_F1, 0x10009);
+		SetReg(lvds_base, DV_SYNC_INT, 0x00000394 | (hwinfo->vo_en << 31));
+		break;
+	case DP_FORMAT_1280_800:
+		hwinfo->InputInfo.InputPixelClk = 67;
+		hwinfo->DownStreamInfo.LaneNum = _DP_TWO_LANE;
+
+		SetReg(lvds_base, CT_CTRL, 0);
+		SetReg(lvds_base, DH_WIDTH, 0x20);
+		SetReg(lvds_base, DH_TOTAL, 0x5500550);
+		SetReg(lvds_base, DH_DEN_START_END, 0x03f053f);
+		SetReg(lvds_base, DV_DEN_START_END_F1, 0xf032f);
+		SetReg(lvds_base, DV_TOTAL, 0x337);
+		SetReg(lvds_base, DV_VS_START_END_F1, 0x10009);
+		SetReg(lvds_base, DV_SYNC_INT, 0x00000330 | (hwinfo->vo_en << 31));
+		break;
+	case DP_FORMAT_960_544:
+		hwinfo->InputInfo.InputPixelClk = 35;
+		hwinfo->DownStreamInfo.LaneNum = _DP_ONE_LANE;
+
+		SetReg(lvds_base, CT_CTRL, 0);
+		SetReg(lvds_base, DH_WIDTH, 0x20);
+		SetReg(lvds_base, DH_TOTAL, 0x4100410);
+		SetReg(lvds_base, DH_DEN_START_END, 0x03f03ff);
+		SetReg(lvds_base, DV_DEN_START_END_F1, 0xf022f);
+		SetReg(lvds_base, DV_TOTAL, 0x230);
+		SetReg(lvds_base, DV_VS_START_END_F1, 0x10009);
+		SetReg(lvds_base, DV_SYNC_INT, 0x00000230 | (hwinfo->vo_en << 31));
+		break;
+	case DP_FORMAT_1080P_60:
+		hwinfo->InputInfo.InputPixelClk = 148;
+		hwinfo->DownStreamInfo.LaneNum = _DP_TWO_LANE;
+
+		SetReg(lvds_base, CT_CTRL, 0);
+		SetReg(lvds_base, DH_WIDTH, 0x2C);
+		SetReg(lvds_base, DH_TOTAL, 0x8980898);
+		SetReg(lvds_base, DH_DEN_START_END, 0xb70837);
+		SetReg(lvds_base, DV_DEN_START_END_F1, 0x2A0462);
+		SetReg(lvds_base, DV_TOTAL, 0x465);
+		SetReg(lvds_base, DV_VS_START_END_F1, 0x10006);
+		SetReg(lvds_base, DV_SYNC_INT, 0x00000463 | (hwinfo->vo_en << 31));
+		break;
+	case DP_FORMAT_2160P_30:
+		hwinfo->InputInfo.InputPixelClk = 257;
+		hwinfo->DownStreamInfo.LaneNum = _DP_TWO_LANE;
+
+		SetReg(lvds_base, CT_CTRL, 1);
+		SetReg(lvds_base, CT_COE_1, 0x2000);
+		SetReg(lvds_base, CT_COE_2, 0x0);
+		SetReg(lvds_base, CT_COE_3, 0x2000);
+		SetReg(lvds_base, CT_COE_4, 0x20000000);
+		SetReg(lvds_base, CT_COE_5, 0x0);
+		SetReg(lvds_base, CT_COE_6, 0x0);
+
+		SetReg(lvds_base, DH_WIDTH, 0x20);
+		SetReg(lvds_base, DH_TOTAL, 0xf500f50);
+		SetReg(lvds_base, DH_DEN_START_END, 0x3f0f3f);
+		SetReg(lvds_base, DV_DEN_START_END_F1, 0xf087f);
+		SetReg(lvds_base, DV_TOTAL, 0x88f);
+		SetReg(lvds_base, DV_VS_START_END_F1, 0x10009);
+		SetReg(lvds_base, DV_SYNC_INT, 0x00000880 | (hwinfo->vo_en << 31));
+		break;
+	default:
+		pr_err("can't no support this resolution");
+		break;
+	}
+	if (hwinfo->vo_en)
+		dptx_set_vo(hwinfo);
+	dptx_sst_setting(hwinfo);
+
+	if (hwinfo->DownStreamInfo.LaneNum == _DP_ONE_LANE) {
+		SetReg(base, PBB_00_DP_PHY_CTRL, 0x14);
+		SetReg(base, PBB_A0_DP_MAC_CTRL, 0x5);
+		SetReg(lvds_base, AIF_EDP1, 0x1);
+	} else if (hwinfo->DownStreamInfo.LaneNum == _DP_TWO_LANE) {
+		SetReg(base, PBB_00_DP_PHY_CTRL, 0x38);
+		SetReg(base, PBB_A0_DP_MAC_CTRL, 0x6);
+		SetReg(lvds_base, AIF_EDP1, 0x3);
+	}
+	SetReg(base, PBC_A7_DPTX_SFIFO_CTRL0, 0x80);
+	SetReg(base, PBB_0D_DPTX_PHY_CTRL, 0x15);
+
+	if (hwinfo->vo_en) {
+		if (hwinfo->chip_id == CHIP_ID_RTD1619) {
+			writel(0x47, vo_base + 0x1b08);
+			writel(0x3, vo_base + 0x1a8c);
+		} else {
+			writel(0x47, vo_base + 0xec4);
+			writel(0x3, vo_base + 0x20);
+		}
+	}
+}
+
+bool dptx_config_tv_system(struct rtk_dptx_hwinfo *hwinfo)
+{
+	bool ret;
+
+	dptx_set_resolution(hwinfo);
+
+	ret = dptx_link_training(hwinfo);
+	if(ret == false)
+		pr_err("dptx - Link Training fail\n");
+	else
+		pr_info("dptx - Link Training Success\n");
+
+	return ret;
+}
diff --git a/drivers/media/platform/rtk_dptx/dptx_hwapi.h b/drivers/media/platform/rtk_dptx/dptx_hwapi.h
new file mode 100644
index 00000000..24845b8
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_hwapi.h
@@ -0,0 +1,237 @@
+/*
+ *  dptx_hwapi.h - RTK display port driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __DPTX_HWAPI_H__
+#define __DPTX_HWAPI_H__
+
+#include <linux/fs.h>
+#include <linux/io.h>
+#include "dptx_reg.h"
+
+#include <soc/realtek/rtk_chip.h>
+
+enum
+{
+	DP_FORMAT_720P_60 = 0,
+	DP_FORMAT_1024_768,
+	DP_FORMAT_1080P_60,
+	DP_FORMAT_2160P_30,
+	DP_FORMAT_2160P_60,
+	DP_FORMAT_1440_768,
+	DP_FORMAT_1440_900,
+	DP_FORMAT_1280_800,
+	DP_FORMAT_960_544,
+};
+
+enum
+{
+	_DP_ONE_LANE = 1,
+	_DP_TWO_LANE = 2,
+	_DP_FOUR_LANE = 4,
+};
+
+enum
+{
+	_DP_TX_LEVEL_0 = 0x00,
+	_DP_TX_LEVEL_1,
+	_DP_TX_LEVEL_2,
+	_DP_TX_LEVEL_3,
+};
+
+enum
+{
+	_DP_TX_LANE_0 = 0x00,
+	_DP_TX_LANE_1,
+	_DP_TX_LANE_2,
+	_DP_TX_LANE_3,
+};
+
+enum
+{
+	_DP_TP_NONE = 0x00,
+	_DP_TP_1,
+	_DP_TP_2,
+	_DP_TP_3,
+};
+
+enum
+{
+	_DP_TX_TP1 = 0x00,
+	_DP_TX_TP2,
+	_DP_TX_TP_END,
+};
+
+enum
+{
+	_DP_TX_TRAINING_NO_RESULT = 0x00,
+	_DP_TX_TP1_FAIL,
+	_DP_TX_TP2_FAIL,
+	_DP_TX_TP1_ADJUST_FAIL,
+	_DP_TX_TP2_ADJUST_FAIL,
+	_DP_TX_TP1_PASS,
+	_DP_TX_TP2_PASS,
+	_DP_TX_TRAINING_PASS,
+	_DP_TX_TRAINING_FAIL,
+};
+
+enum
+{
+	_DP_LANE0_MAX_POST_CURSOR2_REACHED = _BIT2,
+	_DP_LANE1_MAX_POST_CURSOR2_REACHED = _BIT6,
+	_DP_LANE2_MAX_POST_CURSOR2_REACHED = _BIT2,
+	_DP_LANE3_MAX_POST_CURSOR2_REACHED = _BIT6,
+	_DP_SCRAMBLING_DISABLE = _BIT5,
+};
+
+enum
+{
+	_SEC_PACKET_TYPE_AUDIO_TIMESTAMP = 0x01,
+	_SEC_PACKET_TYPE_AUDIO_STREAM = 0x02,
+	_SEC_PACKET_TYPE_VSC = 0x07,
+	_SEC_PACKET_TYPE_INFOFRAME_AVI = 0x0A,
+	_SEC_PACKET_TYPE_INFOFRAME_AUDIO = 0x0C,
+	_SEC_PACKET_TYPE_INFOFRAME_MPEG = 0x0D,
+	_SEC_PACKET_TYPE_INFOFRAME_RSV = 0x0F,
+};
+
+enum
+{
+	_DP_HDCP_STATE_IDLE = 0,
+	_DP_HDCP_STATE_AUTH_1,
+	_DP_HDCP_STATE_AUTH_1_COMPARE_R0,
+	_DP_HDCP_STATE_AUTH_2,
+	_DP_HDCP_STATE_AUTH_PASS,
+};
+
+enum
+{
+	_DP_IRQ_HDCP_NONE = 0,
+	_DP_IRQ_HDCP_V_READY = _BIT0,
+	_DP_IRQ_HDCP_R0_AVAILABLE = _BIT1,
+	_DP_IRQ_HDCP_LINK_INTEGRITY_FAIL = _BIT2,
+	_DP_IRQ_HDCP_REAUTH_REQUEST = _BIT3,
+};
+
+enum
+{
+	_DP_HDCP_AUTH_EVENT_NONE = 0,
+	_DP_HDCP_AUTH_EVENT_LINK_INTEGRITY_FAIL,
+	_DP_HDCP_AUTH_EVENT_REAUTH,
+	_DP_HDCP_AUTH_EVENT_MSG_QUERY_REAUTH,
+	_DP_HDCP_AUTH_EVENT_PLUG_CHANGED,
+	_DP_HDCP_AUTH_EVENT_PASS,
+	_DP_HDCP_AUTH_EVENT_DEVICE_DEPTH_MAX,
+};
+
+struct DPTxDownStreamInfo
+{
+	unsigned char DPCDRev;
+	unsigned char PeerDeviceType : 3;
+	unsigned char LinkRate;
+	unsigned char LaneNum : 3;
+	unsigned char MSGCapStatus : 1;
+	unsigned char DPPlugStatus : 1;
+	unsigned char DPPlugChange : 1;
+	unsigned char LegacyPlugStatus : 1;
+	unsigned char EnhanceFraming : 1;
+	unsigned char AlternateSrCapable : 1;
+	unsigned char FramingChangeCapable : 1;
+	unsigned char SSCSupport : 1;
+	unsigned char TP3Support : 1;
+	unsigned char NumberOfSDP : 1;
+	unsigned char NumberOfSDPSink : 1;
+	unsigned char MaxLinkRate;
+	unsigned char DownStreamInfoReady : 1;
+	unsigned char UpRequestCap : 1;
+};
+
+struct DPTxInputInfo
+{
+	unsigned char ColorDepth : 3;
+	unsigned char ColorSpace : 3;
+	unsigned char AudioReadyToPlay : 1;
+	unsigned char AudioFrequency;
+	unsigned char AudioChannelCount : 3;
+	unsigned short InputPixelClk;
+	unsigned char InterlaceMode : 1;
+	unsigned char InterlaceVTotalNumber : 1;
+	unsigned short HorizontalDataEnablePeriod;
+};
+
+struct DPTxLTInfo
+{
+	unsigned char LTState : 2;
+	unsigned char LTResult : 4;
+	unsigned char TP1LaneSameVolCnt[4];
+	unsigned char TP1Cnt : 3;
+	unsigned char TP2Cnt : 3;
+	unsigned char LinkPBNPerTimeSlot;
+	unsigned char LaneAdj[4];
+	unsigned char Lane01LTStatus;
+	unsigned char Lane23LTStatus;
+	unsigned char LaneAlignStatus;
+	unsigned char AdjReqLane01;
+	unsigned char AdjReqLane23;
+};
+
+struct DPTxHDCPAuthInfo
+{
+	unsigned int AuthState : 4;
+	unsigned int AuthStateChange : 1;
+	unsigned int AuthDownstreamEvent;
+	unsigned int IsHDCPSupported : 1;
+	unsigned int IsDownstreamRepeater : 1;
+	unsigned int BInfoDevice;
+	unsigned int BInfoDepth;
+	unsigned int R0Timeout : 1;
+	unsigned int VReadyTimeout : 1;
+	unsigned int PollingVReady : 1;
+	unsigned int VReadyBit : 1;
+	unsigned int AuthStart : 1;
+	unsigned int AuthHold : 1;
+};
+
+#define HDCP_DEVICE_COUNT_MAX		127
+
+struct rtk_dptx_hwinfo {
+	enum rtd_chip_id chip_id;
+	enum rtd_chip_revision chip_revision;
+
+	void __iomem *reg_base;
+	void __iomem *pll_base;
+	void __iomem *lvds_base;
+	void __iomem *vo_base;
+	
+	struct DPTxDownStreamInfo DownStreamInfo;
+	struct DPTxInputInfo InputInfo;
+	struct DPTxLTInfo LTInfo;
+	struct DPTxHDCPAuthInfo HDCPInfo;
+
+	unsigned char ksvfifo[HDCP_DEVICE_COUNT_MAX * 5];
+	int out_type;
+	int aux_status;
+	struct semaphore sem;
+
+	int vo_en;
+};
+
+void dptx_pixelpll_setting(struct rtk_dptx_hwinfo *hwinfo);
+void dptx_dppll_setting(struct rtk_dptx_hwinfo *hwinfo);
+void dptx_initial(struct rtk_dptx_hwinfo *hwinfo);
+
+void dptx_lvdsint_en(struct rtk_dptx_hwinfo *hwinfo, int en);
+void dptx_close_phy(struct rtk_dptx_hwinfo *hwinfo);
+void dptx_close_pll(struct rtk_dptx_hwinfo *hwinfo);
+
+int dptx_read_edid(struct rtk_dptx_hwinfo *hwinfo,
+		unsigned char *ptr, int length);
+bool dptx_config_tv_system(struct rtk_dptx_hwinfo *hwinfo);
+#endif  //__DPTX_HWAPI_H__
diff --git a/drivers/media/platform/rtk_dptx/dptx_reg.h b/drivers/media/platform/rtk_dptx/dptx_reg.h
new file mode 100644
index 00000000..436f0c9
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_reg.h
@@ -0,0 +1,575 @@
+/*
+ *  dptx_reg.h - RTK display port driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _DPTX_REG_H_INCLUDED_
+#define _DPTX_REG_H_INCLUDED_
+
+static inline void SetBit(void __iomem *base, unsigned int offset,
+		unsigned int mask, unsigned int value)
+{
+	unsigned int reg;
+
+	reg = readl(base + offset);
+	reg &= mask;
+	reg |= value;
+	writel(reg, base + offset);
+}
+
+static inline void SetReg(void __iomem *base, unsigned int offset, unsigned int value)
+{
+	writel(value, base + offset);
+}
+
+static inline int __maybe_unused GetBit(void __iomem *base, unsigned int offset, unsigned int mask)
+{
+	unsigned int reg;
+
+	reg = readl(base + offset);
+	reg &= mask;
+
+	return reg;
+}
+
+static inline unsigned int GetReg(void __iomem *base, unsigned int offset)
+{
+	return readl(base + offset);
+}
+
+#define _BIT0		0x00000001
+#define _BIT1		0x00000002
+#define _BIT2		0x00000004
+#define _BIT3		0x00000008
+#define _BIT4		0x00000010
+#define _BIT5		0x00000020
+#define _BIT6		0x00000040
+#define _BIT7		0x00000080
+#define _BIT8		0x00000100
+#define _BIT9		0x00000200
+#define _BIT10		0x00000400
+#define _BIT11		0x00000800
+#define _BIT12		0x00001000
+#define _BIT13		0x00002000
+#define _BIT14		0x00004000
+#define _BIT15		0x00008000
+#define _BIT16		0x00010000
+#define _BIT17		0x00020000
+#define _BIT18		0x00040000
+#define _BIT19		0x00080000
+#define _BIT20		0x00100000
+#define _BIT21		0x00200000
+#define _BIT22		0x00400000
+#define _BIT23		0x00800000
+#define _BIT24		0x01000000
+#define _BIT25		0x02000000
+#define _BIT26		0x04000000
+#define _BIT27		0x08000000
+#define _BIT28		0x10000000
+#define _BIT29		0x20000000
+#define _BIT30		0x40000000
+#define _BIT31		0x80000000
+
+//--------------------------------------
+//        DPTX Digital PHY CTRL
+//--------------------------------------
+
+#define PBB_00_DP_PHY_CTRL                                          0x000
+#define PBB_01_DPTX_ML_PAT_SEL                                      0x004
+#define PBB_02_CUSTOM_PATTERN_0                                     0x008
+#define PBB_03_CUSTOM_PATTERN_1                                     0x00C
+#define PBB_04_CUSTOM_PATTERN_2                                     0x010
+#define PBB_05_CUSTOM_PATTERN_3                                     0x014
+#define PBB_06_CUSTOM_PATTERN_4                                     0x018
+#define PBB_07_CUSTOM_PATTERN_5                                     0x01C
+#define PBB_08_CUSTOM_PATTERN_6                                     0x020
+#define PBB_09_CUSTOM_PATTERN_7                                     0x024
+#define PBB_0A_CUSTOM_PATTERN_8                                     0x028
+#define PBB_0B_CUSTOM_PATTERN_9                                     0x02C
+#define PBB_0C_COMPLIANCE_EYE_PATTERN                               0x030
+#define PBB_0D_DPTX_PHY_CTRL                                        0x034
+#define PBB_0E_DPTX_LANE_SWAP                                       0x038
+#define PBB_0F_DPTX_8B10B_TST                                       0x03C
+#define PBB_10_DPTX_PHY_DUMMY                                       0x040
+#define PBB_11_RIV0                                                 0x044
+#define PBB_12_RIV1                                                 0x048
+#define PBB_13_RIV2                                                 0x04C
+#define PBB_14_RIV3                                                 0x050
+#define PBB_15_RIV4                                                 0x054
+#define PBB_16_RIV5                                                 0x058
+#define PBB_17_RIV6                                                 0x05C
+#define PBB_18_RIV7                                                 0x060
+#define PBB_30_DPTX_HDCP_CTRL1                                      0x0C0
+#define PBB_31_DPTX_HDCP_CTRL2                                      0x0C4
+#define PBB_32_DP_HDCP_KEY_DL_PORT                                  0x0C8
+#define PBB_33_DP_HDCP_KEY_OUTPUT                                   0x0CC
+#define PBB_34_AN_BYTE_7                                            0x0D0
+#define PBB_35_AN_BYTE_6                                            0x0D4
+#define PBB_36_AN_BYTE_5                                            0x0D8
+#define PBB_37_AN_BYTE_4                                            0x0DC
+#define PBB_38_AN_BYTE_3                                            0x0E0
+#define PBB_39_AN_BYTE_2                                            0x0E4
+#define PBB_3A_AN_BYTE_1                                            0x0E8
+#define PBB_3B_AN_BYTE_0                                            0x0EC
+#define PBB_3C_M0_BYTE_7                                            0x0F0
+#define PBB_3D_M0_BYTE_6                                            0x0F4
+#define PBB_3E_M0_BYTE_5                                            0x0F8
+#define PBB_3F_M0_BYTE_4                                            0x0FC
+#define PBB_40_M0_BYTE_3                                            0x100
+#define PBB_41_M0_BYTE_2                                            0x104
+#define PBB_42_M0_BYTE_1                                            0x108
+#define PBB_43_M0_BYTE_0                                            0x10C
+#define PBB_44_KM_BYTE_6                                            0x110
+#define PBB_45_KM_BYTE_5                                            0x114
+#define PBB_46_KM_BYTE_4                                            0x118
+#define PBB_47_KM_BYTE_3                                            0x11C
+#define PBB_48_KM_BYTE_2                                            0x120
+#define PBB_49_KM_BYTE_1                                            0x124
+#define PBB_4A_KM_BYTE_0                                            0x128
+#define PBB_4B_R0_BYTE_MSB                                          0x12C
+#define PBB_4C_R0_BYTE_LSB                                          0x130
+#define PBB_4D_RI_BYTE_MSB                                          0x134
+#define PBB_4E_RI_BYTE_LSB                                          0x138
+#define PBB_4F_BKSV_0                                               0x13C
+#define PBB_50_BKSV_1                                               0x140
+#define PBB_51_BKSV_2                                               0x144
+#define PBB_52_BKSV_3                                               0x148
+#define PBB_53_BKSV_4                                               0x14C
+#define PBB_54_HDCP_TX_LIP_H                                        0x150
+#define PBB_55_HDCP_TX_LIP_L                                        0x154
+#define PBB_56_DP_HDCP_TX                                           0x158
+#define PBB_57_DP_HDCP_BIST                                         0x15C
+#define PBB_58_DP_HDCP_AN_SEED                                      0x160
+#define PBB_59_HDCP_IRQ_EVENT                                       0x164
+#define PBB_5A_DPTX_HDCP_TST                                        0x168
+#define PBB_5B_DP_HDCP_TX_SHA_CTRL                                  0x16C
+#define PBB_5C_DP_HDCP_TX_SHA_DATA_3                                0x170
+#define PBB_5D_DP_HDCP_TX_SHA_DATA_2                                0x174
+#define PBB_5E_DP_HDCP_TX_SHA_DATA_1                                0x178
+#define PBB_5F_DP_HDCP_TX_SHA_DATA_0                                0x17C
+#define PBB_60_DP_HDCP_TX_SHA_OUT_3                                 0x180
+#define PBB_61_DP_HDCP_TX_SHA_OUT_2                                 0x184
+#define PBB_62_DP_HDCP_TX_SHA_OUT_1                                 0x188
+#define PBB_63_DP_HDCP_TX_SHA_OUT_0                                 0x18C
+#define PBB_64_HDCP_ECF_BYTE0                                       0x190
+#define PBB_65_HDCP_ECF_BYTE1                                       0x194
+#define PBB_66_HDCP_ECF_BYTE2                                       0x198
+#define PBB_67_HDCP_ECF_BYTE3                                       0x19C
+#define PBB_68_HDCP_ECF_BYTE4                                       0x1A0
+#define PBB_69_HDCP_ECF_BYTE5                                       0x1A4
+#define PBB_6A_HDCP_ECF_BYTE6                                       0x1A8
+#define PBB_6B_HDCP_ECF_BYTE7                                       0x1AC
+#define PBB_6C_DP_STREAM_1_PBN                                      0x1B0
+#define PBB_6D_DP_STREAM_2_PBN                                      0x1B4
+#define PBB_6E_DP_STREAM_3_PBN                                      0x1B8
+#define PBB_6F_DP_STREAM_4_PBN                                      0x1BC
+#define PBB_80_HDCP_AES_CIPHER_KEY_15                               0x200
+#define PBB_81_HDCP_AES_CIPHER_KEY_14                               0x204
+#define PBB_82_HDCP_AES_CIPHER_KEY_13                               0x208
+#define PBB_83_HDCP_AES_CIPHER_KEY_12                               0x20C
+#define PBB_84_HDCP_AES_CIPHER_KEY_11                               0x210
+#define PBB_85_HDCP_AES_CIPHER_KEY_10                               0x214
+#define PBB_86_HDCP_AES_CIPHER_KEY_9                                0x218
+#define PBB_87_HDCP_AES_CIPHER_KEY_8                                0x21C
+#define PBB_88_HDCP_AES_CIPHER_KEY_7                                0x220
+#define PBB_89_HDCP_AES_CIPHER_KEY_6                                0x224
+#define PBB_8A_HDCP_AES_CIPHER_KEY_5                                0x228
+#define PBB_8B_HDCP_AES_CIPHER_KEY_4                                0x22C
+#define PBB_8C_HDCP_AES_CIPHER_KEY_3                                0x230
+#define PBB_8D_HDCP_AES_CIPHER_KEY_2                                0x234
+#define PBB_8E_HDCP_AES_CIPHER_KEY_1                                0x238
+#define PBB_8F_HDCP_AES_CIPHER_KEY_0                                0x23C
+#define PBB_90_HDCP22_CTRL                                          0x240
+#define PBB_91_HDCP22_TYPE_AES_0                                    0x244
+#define PBB_92_HDCP22_TYPE_AES_1                                    0x248
+#define PBB_9A_DUMMY_1                                              0x268
+#define PBB_9B_DUMMY_2                                              0x26C
+#define PBB_9C_DUMMY_3                                              0x270
+
+
+
+//--------------------------------------
+//        DPTX HPD Detection
+//--------------------------------------
+
+#define PBB_70_HPD_CTRL                                             0x1C0
+#define PBB_71_HPD_IRQ                                              0x1C4
+#define PBB_72_HPD_IRQ_EN                                           0x1C8
+#define PBB_73_HPD_TIMER1                                           0x1CC
+#define PBB_74_HPD_TIMER2                                           0x1D0
+#define PBB_75_HPD_TIMER3                                           0x1D4
+#define PBB_76_HPD_TIMER4                                           0x1D8
+#define PBB_77_HPD_TIMER5                                           0x1DC
+#define PBB_78_HPD_TIMER6                                           0x1E0
+#define PBB_79_HPD_TIMER7                                           0x1E4
+#define PBB_7A_HPD_LONG0                                            0x1E8
+#define PBB_7B_HPD_LONG1                                            0x1EC
+#define PBB_7C_HPD_STATE                                            0x1F0
+#define PBB_7D_RESERVED_0                                           0x1F4
+#define PBB_7E_RESERVED_1                                           0x1F8
+
+
+
+//--------------------------------------
+//        DPTX link MAC
+//--------------------------------------
+
+#define PBB_A0_DP_MAC_CTRL                                          0x280
+#define PBB_A1_DP_RESET_CTRL                                        0x284
+#define PBB_A2_DP_DEBUG_CTRL                                        0x288
+#define PBB_A3_DPTX_IRQ_CTRL                                        0x28C
+#define PBB_A4_PG_FIFO_CTRL                                         0x290
+#define PBB_A5_MAX_WL                                               0x294
+#define PBB_A6_LFIFO_WL                                             0x298
+#define PBB_A7_PG_INTERRUPT_CTRL                                    0x29C
+#define PBB_A8_MN_VID_AUTO_EN_1                                     0x2A0
+#define PBB_A9_MN_M_VID_H                                           0x2A4
+#define PBB_AA_MN_M_VID_M                                           0x2A8
+#define PBB_AB_MN_M_VID_L                                           0x2AC
+#define PBB_AC_MN_N_VID_H                                           0x2B0
+#define PBB_AD_MN_N_VID_M                                           0x2B4
+#define PBB_AE_MN_N_VID_L                                           0x2B8
+#define PBB_AF_MVID_AUTO_H                                          0x2BC
+#define PBB_B0_MVID_AUTO_M                                          0x2C0
+#define PBB_B1_MVID_AUTO_L                                          0x2C4
+#define PBB_B2_NVID_ASYNC_M                                         0x2C8
+#define PBB_B3_NVID_ASYNC_L                                         0x2CC
+#define PBB_B4_MSA_CTRL                                             0x2D0
+#define PBB_B5_MSA_MISC0                                            0x2D4
+#define PBB_B6_MN_STRM_ATTR_MISC1                                   0x2D8
+#define PBB_B7_MN_STRM_ATTR_HTT_M                                   0x2DC
+#define PBB_B8_MN_STRM_ATTR_HTT_L                                   0x2E0
+#define PBB_B9_MN_STRM_ATTR_HST_M                                   0x2E4
+#define PBB_BA_MN_STRM_ATTR_HST_L                                   0x2E8
+#define PBB_BB_MN_STRM_ATTR_HWD_M                                   0x2EC
+#define PBB_BC_MN_STRM_ATTR_HWD_L                                   0x2F0
+#define PBB_BD_MN_STRM_ATTR_HSW_M                                   0x2F4
+#define PBB_BE_MN_STRM_ATTR_HSW_L                                   0x2F8
+#define PBB_BF_MN_STRM_ATTR_VTTE_M                                  0x2FC
+#define PBB_C0_MN_STRM_ATTR_VTTE_L                                  0x300
+#define PBB_C1_MN_STRM_ATTR_VST_M                                   0x304
+#define PBB_C2_MN_STRM_ATTR_VST_L                                   0x308
+#define PBB_C3_MN_STRM_ATTR_VHT_M                                   0x30C
+#define PBB_C4_MN_STRM_ATTR_VHT_L                                   0x310
+#define PBB_C5_MN_STRM_ATTR_VSW_M                                   0x314
+#define PBB_C6_MN_STRM_ATTR_VSW_L                                   0x318
+#define PBB_C7_VBID                                                 0x31C
+#define PBB_C8_VBID_FW_CTL                                          0x320
+#define PBB_C9_ARBITER_CTRL                                         0x324
+#define PBB_CA_V_DATA_PER_LINE0                                     0x328
+#define PBB_CB_V_DATA_PER_LINE1                                     0x32C
+#define PBB_CC_TU_SIZE                                              0x330
+#define PBB_CD_TU_DATA_SIZE0                                        0x334
+#define PBB_CE_TU_DATA_SIZE1                                        0x338
+#define PBB_CF_HDEALY0                                              0x33C
+#define PBB_D0_HDEALY1                                              0x340
+#define PBB_D1_AUTO_HDEALY0                                         0x344
+#define PBB_D2_AUTO_HDEALY1                                         0x348
+#define PBB_D3_LFIFO_WL_SET                                         0x34C
+#define PBB_D4_ARBITER_SEC_END_CNT_HB                               0x350
+#define PBB_D5_ARBITER_SEC_END_CNT_LB                               0x354
+#define PBB_D6_ARBITER_DEBUG                                        0x358
+#define PBB_D7_DPTX_CTSFIFO_CTRL                                    0x35C
+#define PBB_D8_DPTX_CTSFIFO_RSV1                                    0x360
+#define PBB_D9_DPTX_TOP_CTL                                         0x364
+#define PBB_DA_DPTX_TOP_RSV1                                        0x368
+#define PBB_DB_DPTX_TOP_RSV2                                        0x36C
+#define PBB_DC_ARBITER_MIN_H_BLANK_WIDTH_HB                         0x370
+#define PBB_DD_ARBITER_MIN_H_BLANK_WIDTH_LB                         0x374
+#define PBB_DE_ARBITER_INTERRUPT_CTRL                               0x378
+#define PBB_DF_VESA_FMT_REGEN                                       0x37C
+#define PBB_E0_DPTX_CLK_GEN                                         0x380
+#define PBB_E1_PG_MBIST_CTRL                                        0x384
+#define PBB_E2_PG_DRF_MBIST_CTRL                                    0x388
+#define PBB_F0_ARBITER_SEC_IDLE_END_CNT                             0x3C0
+#define PBB_F8_DPTX_TOP_RSV3                                        0x3E0
+#define PBB_F9_DPTX_TOP_RSV4                                        0x3E4
+#define PBB_FA_DPTX_TOP_RSV5                                        0x3E8
+#define PBB_FB_DPTX_TOP_RSV6                                        0x3EC
+#define PBB_FC_DPTX_TOP_RSV7                                        0x3F0
+#define PBB_FD_DPTX_TOP_RSV8                                        0x3F4
+#define PBB_FE_DPTX_TOP_RSV9                                        0x3F8
+#define PBB_FF_DPTX_TOP_RSV10                                       0x3FC
+
+
+
+//--------------------------------------
+//        DPTX MAC CTRL1
+//--------------------------------------
+
+#define PBC_00_SEC_FUNCTION_CTRL                                    0x400
+#define PBC_01_SEC_RESERVED_0                                       0x404
+#define PBC_02_SEC_DBUF_CTRL                                        0x408
+#define PBC_03_SEC_DEBUG                                            0x40C
+#define PBC_04_SEC_PSR_DB0                                          0x410
+#define PBC_05_SEC_PSR_DB1                                          0x414
+#define PBC_06_SEC_PSR_DB2                                          0x418
+#define PBC_07_SEC_PSR_DB3                                          0x41C
+#define PBC_08_SEC_PSR_DB4                                          0x420
+#define PBC_09_SEC_PSR_DB5                                          0x424
+#define PBC_0A_SEC_PSR_DB6                                          0x428
+#define PBC_0B_SEC_PSR_DB7                                          0x42C
+#define PBC_0C_SEC_PSR_DB8                                          0x430
+#define PBC_0D_SEC_PSR_DB9                                          0x434
+#define PBC_0E_SEC_PSR_DB10                                         0x438
+#define PBC_0F_SEC_PSR_DB11                                         0x43C
+#define PBC_10_SEC_PSR_DB12                                         0x440
+#define PBC_11_SEC_PSR_DB13                                         0x444
+#define PBC_12_SEC_PSR_DB14                                         0x448
+#define PBC_13_SEC_PSR_DB15                                         0x44C
+#define PBC_14_SEC_RESERVED_1                                       0x450
+#define PBC_15_SEC_RESERVED_2                                       0x454
+#define PBC_16_SEC_RESERVED_3                                       0x458
+#define PBC_17_SEC_RESERVED_4                                       0x45C
+#define PBC_18_AUD_FUNCTION_CTRL1                                   0x460
+#define PBC_19_AUD_PAYLOAD_B3                                       0x464
+#define PBC_1A_DP_AUD_ID                                            0x468
+#define PBC_1B_SEC_RESERVED_6                                       0x46C
+#define PBC_1C_AUD_FIFO_CTRL                                        0x470
+#define PBC_1D_AUD_LFIFO_MAX_WL                                     0x474
+#define PBC_1E_AUD_LFIFO_WL                                         0x478
+#define PBC_1F_AUD_INTERRUPT_CTRL                                   0x47C
+#define PBC_20_AUD_TS_MAUD_H                                        0x480
+#define PBC_21_AUD_TS_MAUD_M                                        0x484
+#define PBC_22_AUD_TS_MAUD_L                                        0x488
+#define PBC_23_AUD_TS_NAUD_H                                        0x48C
+#define PBC_24_AUD_TS_NAUD_M                                        0x490
+#define PBC_25_AUD_TS_NAUD_L                                        0x494
+#define PBC_26_SEC_INFO_AUD_DB0                                     0x498
+#define PBC_27_SEC_INFO_AUD_DB1                                     0x49C
+#define PBC_28_SEC_INFO_AUD_DB2                                     0x4A0
+#define PBC_29_SEC_INFO_AUD_DB3                                     0x4A4
+#define PBC_2A_SEC_INFO_AUD_DB4                                     0x4A8
+#define PBC_2B_SEC_INFO_AUD_DB5                                     0x4AC
+#define PBC_2C_SEC_INFO_AUD_DB6                                     0x4B0
+#define PBC_2D_SEC_INFO_AUD_DB7                                     0x4B4
+#define PBC_2E_SEC_INFO_AUD_DB8                                     0x4B8
+#define PBC_2F_SEC_INFO_AUD_DB9                                     0x4BC
+#define PBC_30_SEC_INFO_AVI_DB0                                     0x4C0
+#define PBC_31_SEC_INFO_AVI_DB1                                     0x4C4
+#define PBC_32_SEC_INFO_AVI_DB2                                     0x4C8
+#define PBC_33_SEC_INFO_AVI_DB3                                     0x4CC
+#define PBC_34_SEC_INFO_AVI_DB4                                     0x4D0
+#define PBC_35_SEC_INFO_AVI_DB5                                     0x4D4
+#define PBC_36_SEC_INFO_AVI_DB6                                     0x4D8
+#define PBC_37_SEC_INFO_AVI_DB7                                     0x4DC
+#define PBC_38_SEC_INFO_AVI_DB8                                     0x4E0
+#define PBC_39_SEC_INFO_AVI_DB9                                     0x4E4
+#define PBC_3A_SEC_INFO_AVI_DB10                                    0x4E8
+#define PBC_3B_SEC_INFO_AVI_DB11                                    0x4EC
+#define PBC_3C_SEC_INFO_AVI_DB12                                    0x4F0
+#define PBC_3D_SEC_INFO_MPEG_DB0                                    0x4F4
+#define PBC_3E_SEC_INFO_MPEG_DB1                                    0x4F8
+#define PBC_3F_SEC_INFO_MPEG_DB2                                    0x4FC
+#define PBC_40_SEC_INFO_MPEG_DB3                                    0x500
+#define PBC_41_SEC_INFO_MPEG_DB4                                    0x504
+#define PBC_42_SEC_INFO_MPEG_DB5                                    0x508
+#define PBC_43_SEC_INFO_MPEG_DB6                                    0x50C
+#define PBC_44_SEC_INFO_MPEG_DB7                                    0x510
+#define PBC_45_SEC_INFO_MPEG_DB8                                    0x514
+#define PBC_46_SEC_INFO_MPEG_DB9                                    0x518
+#define PBC_47_AUD_FUNCTION_CTRL2                                   0x51C
+#define PBC_48_AUD_FUNCTION_CTRL3                                   0x520
+#define PBC_49_MST_SEC_PKT_ID                                       0x524
+#define PBC_4A_MST_SEC_PKT_HB3                                      0x528
+#define PBC_4B_SEC_RS_DECODE_CTRL                                   0x52C
+#define PBC_4C_SEC_AUD_FREQDET_CTRL                                 0x530
+#define PBC_4D_SEC_AUD_XCLK_DIV                                     0x534
+#define PBC_4E_SEC_AUD_FREQ_TIME                                    0x538
+#define PBC_4F_SEC_AUD_SAMPLE_CNT_HB                                0x53C
+#define PBC_50_SEC_AUD_SAMPLE_CNT_LB                                0x540
+#define PBC_51_AUD_MBIST_CTRL                                       0x544
+#define PBC_52_AUD_DRF_MBIST_CTRL                                   0x548
+#define PBC_53_DP_INFO_FM_RSV0                                      0x54C
+#define PBC_54_DP_INFO_FM_RSV1                                      0x550
+#define PBC_55_DP_INFO_FM_ADR                                       0x554
+#define PBC_56_DP_INFO_FM_DAT                                       0x558
+#define PBC_57_RESERVED_57                                          0x55C
+#define PBC_58_VSC_RX_DB0                                           0x560
+#define PBC_59_VSC_RX_DB1                                           0x564
+#define PBC_5A_VSC_RX_DB2                                           0x568
+#define PBC_5B_VSC_RX_DB3                                           0x56C
+#define PBC_5C_VSC_RX_DB4                                           0x570
+#define PBC_5D_VSC_RX_DB5                                           0x574
+#define PBC_5E_VSC_RX_DB6                                           0x578
+#define PBC_5F_VSC_RX_DB7                                           0x57C
+#define PBC_60_AUD_FREQ_TH_0                                        0x580
+#define PBC_61_AUD_FREQ_TH_1                                        0x584
+#define PBC_62_AUD_FREQ_TH_2                                        0x588
+#define PBC_63_AUD_FREQ_TH_3                                        0x58C
+#define PBC_64_AUD_FREQ_TH_4                                        0x590
+#define PBC_65_AUD_FREQ_TH_5                                        0x594
+#define PBC_66_AUD_FREQ_TH_6                                        0x598
+#define PBC_67_RESERVED_67                                          0x59C
+#define PBC_68_RESERVED_68                                          0x5A0
+#define PBC_69_RESERVED_69                                          0x5A4
+#define PBC_6A_VSC_CTRL_0                                           0x5A8
+#define PBC_6B_VSC_RX_HB0                                           0x5AC
+#define PBC_6C_VSC_RX_HB1                                           0x5B0
+#define PBC_6D_VSC_RX_HB2                                           0x5B4
+#define PBC_6E_VSC_RX_HB3                                           0x5B8
+#define PBC_70_SEC_AWD_CTRL                                         0x5C0
+#define PBC_71_SEC_AWD_STATUS_0                                     0x5C4
+#define PBC_72_SEC_IRQ_CTRL0                                        0x5C8
+#define PBC_73_SEC_PH_HB0                                           0x5CC
+#define PBC_74_SEC_PH_HB1                                           0x5D0
+#define PBC_75_SEC_PH_HB2                                           0x5D4
+#define PBC_76_SEC_PH_HB3                                           0x5D8
+#define PBC_77_SEC_PH_PB0                                           0x5DC
+#define PBC_78_SEC_PH_PB1                                           0x5E0
+#define PBC_79_SEC_PH_PB2                                           0x5E4
+#define PBC_7A_SEC_PH_PB3                                           0x5E8
+#define PBC_7B_SEC_PH_PACKET_TYPE                                   0x5EC
+#define PBC_80_SEC_AWD_STATUS_1                                     0x600
+#define PBC_81_DP_INFO_VAR_EN_M                                     0x604
+#define PBC_82_DP_INFO_VAR_EN_L                                     0x608
+#define PBC_83_DP_INFO_VAR_ST_M                                     0x60C
+#define PBC_84_DP_INFO_VAR_ST_L                                     0x610
+#define PBC_85_CH_STATUS_0                                          0x614
+#define PBC_86_CH_STATUS_1                                          0x618
+#define PBC_87_CH_STATUS_2                                          0x61C
+#define PBC_88_CH_STATUS_3                                          0x620
+#define PBC_89_CH_STATUS_4                                          0x624
+#define PBC_8A_DP_AVWD_CTRL0                                        0x628
+#define PBC_8B_RESERVED_8B                                          0x62C
+#define PBC_8C_RESERVED_8C                                          0x630
+#define PBC_8D_RESERVED_8D                                          0x634
+#define PBC_8E_RESERVED_8E                                          0x638
+#define PBC_8F_DPTX_I2S_CTRL                                        0x63C
+#define PBC_90_SEC_IRQ_CTRL1                                        0x640
+#define PBC_95_DUMMY_95                                             0x654
+#define PBC_96_DUMMY_96                                             0x658
+#define PBC_97_DUMMY_97                                             0x65C
+#define PBC_98_DUMMY_98                                             0x660
+#define PBC_99_DUMMY_99                                             0x664
+#define PBC_9A_DUMMY_9A                                             0x668
+#define PBC_9B_DUMMY_9B                                             0x66C
+#define PBC_9C_DUMMY_9C                                             0x670
+
+
+
+//--------------------------------------
+//        DPTX link MAC
+//--------------------------------------
+
+#define PBC_A0_DPTX_PHY_CTRL0                                       0x680
+#define PBC_A1_DPTX_PHY_CTRL1                                       0x684
+#define PBC_A2_DPTX_RCV_DET0                                        0x688
+#define PBC_A3_DPTX_RCV_DET1                                        0x68C
+#define PBC_A4_DPTX_PN_SWAP                                         0x690
+#define PBC_A7_DPTX_SFIFO_CTRL0                                     0x69C
+#define PBC_A8_DPTX_SFIFO_CTRL1                                     0x6A0
+#define PBC_A9_DPTX_SFIFO_LANE_SWAP0                                0x6A4
+#define PBC_AA_DPTX_SFIFO_LANE_SWAP1                                0x6A8
+#define PBC_AB_DPTX_SFIFO_INT_EN                                    0x6AC
+
+
+
+//--------------------------------------
+//        DPTX AUX Analog PHY CTRL
+//--------------------------------------
+
+#define PBD_60_DIG_TX_04                                            0x980
+#define PBD_61_AUX_1                                                0x984
+#define PBD_62_AUX_2                                                0x988
+#define PBD_63_AUX_3                                                0x98C
+#define PBD_64_AUX_4                                                0x990
+#define PBD_65_AUX_5                                                0x994
+#define PBD_66_AUX_6                                                0x998
+#define PBD_67_DIG_TX_03                                            0x99C
+
+
+
+//--------------------------------------
+//        DPTX AUX MAC CTRL
+//--------------------------------------
+
+#define PBD_A0_AUX_TX_CTRL                                          0xA80
+#define PBD_A1_AUX_TIMEOUT                                          0xA84
+#define PBD_A2_AUX_FSM_STATUS                                       0xA88
+#define PBD_A3_AUXTX_TRAN_CTRL                                      0xA8C
+#define PBD_A4_AUXTX_REQ_CMD                                        0xA90
+#define PBD_A5_AUXTX_REQ_ADDR_M                                     0xA94
+#define PBD_A6_AUXTX_REQ_ADDR_L                                     0xA98
+#define PBD_A7_AUXTX_REQ_LEN                                        0xA9C
+#define PBD_A8_AUXTX_REQ_DATA                                       0xAA0
+#define PBD_A9_AUX_REPLY_CMD                                        0xAA4
+#define PBD_AA_AUX_REPLY_DATA                                       0xAA8
+#define PBD_AB_AUX_FIFO_CTRL                                        0xAAC
+#define PBD_AC_AUX_TX_FIFO_STATUS                                   0xAB0
+#define PBD_AD_AUX_FIFO_RD_PTR                                      0xAB4
+#define PBD_AE_AUX_FIFO_WR_PTR                                      0xAB8
+#define PBD_AF_AUX_RETRY_1                                          0xABC
+#define PBD_B0_AUX_RETRY_2                                          0xAC0
+#define PBD_B1_AUX_IRQ_EVENT                                        0xAC4
+#define PBD_B2_AUX_IRQ_EN                                           0xAC8
+#define PBD_F0_AUX_DIG_PHY2                                         0xBC0
+#define PBD_F1_AUX_DIG_PHY3                                         0xBC4
+#define PBD_F2_AUX_DIG_PHY4                                         0xBC8
+#define PBD_F3_AUX_DIG_PHY5                                         0xBCC
+#define PBD_F4_AUX_DIG_PHY6                                         0xBD0
+#define PBD_F5_AUX_DIG_PHY7                                         0xBD4
+#define PBD_F6_AUX_DIG_PHY8                                         0xBD8
+#define PBD_F7_AUX_DIG_PHY9                                         0xBDC
+#define PBD_F8_AUX_DEBUG                                            0xBE0
+
+
+//--------------------------------------
+//        LVDS Combo AIF
+//--------------------------------------
+#define AIF_MISC		0x0
+#define AIF_EDP1		0x40
+#define AIF_EDP2		0x44
+#define CT_CTRL			0x100
+#define CT_COE_1		0x108
+#define CT_COE_2		0x10c
+#define CT_COE_3		0x110
+#define CT_COE_4		0x114
+#define CT_COE_5		0x118
+#define CT_COE_6		0x11c
+#define DH_WIDTH		0x404
+#define DH_TOTAL		0x408
+#define DH_DEN_START_END	0x40c
+#define DV_DEN_START_END_F1	0x410
+#define DV_TOTAL		0x418
+#define DV_VS_START_END_F1	0x41c
+#define DV_SYNC_INT		0x42c
+
+
+//--------------------------------------
+//       LVDS and EDP PLL Control Register
+//--------------------------------------
+#define DISP_PLL_DIV2	0x24
+#define PLL_HDMI	0x190
+#define PLL_HDMI_LDO1	0x230
+#define PLL_EDP1	0x248
+#define PLL_EDP2	0x24c
+#define PLL_PIXEL1	0x250
+#define PLL_PIXEL2	0x254
+
+//--------------------------------------
+//       EDP PLL_SSC_DIG Control Register
+//--------------------------------------
+#define PLL_SSC_DIG_EDP0	0x5e0
+#define PLL_SSC_DIG_EDP1	0x5e4
+#define PLL_SSC_DIG_EDP2	0x5e8
+#define PLL_SSC_DIG_EDP3	0x5ec
+#define PLL_SSC_DIG_EDP4	0x5f0
+#define PLL_SSC_DIG_EDP5	0x5f4
+#define PLL_SSC_DIG_EDP_DBG1	0x5f8
+#define PLL_SSC_DIG_EDP_DBG2	0x5fc
+
+//--------------------------------------
+//       PIXEL PLL_SSC_DIG Control Register
+//--------------------------------------
+#define PLL_SSC_DIG_PIXEL0	0x600
+#define PLL_SSC_DIG_PIXEL1	0x604
+#define PLL_SSC_DIG_PIXEL2	0x608
+
+#endif
diff --git a/drivers/media/platform/rtk_dptx/dptx_rpc.c b/drivers/media/platform/rtk_dptx/dptx_rpc.c
new file mode 100644
index 00000000..4912d2f
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_rpc.c
@@ -0,0 +1,145 @@
+/*
+ *  dptx_rpc.c - RTK display port driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/dma-mapping.h>
+
+#include "dptx_rpc.h"
+
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+#define CONVERT_FOR_AVCPU(x)		((unsigned int)(x) | 0xA0000000)
+#else
+#define CONVERT_FOR_AVCPU(x)		(x)
+#endif
+
+
+extern struct ion_device *rtk_phoenix_ion_device;
+
+int RPC_TOAGENT_DPTX_QUERY_TV_System(struct ion_client *client,
+			struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *arg)
+{
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *i_rpc = NULL;
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *o_rpc = NULL;
+	int ret = -1;
+	struct ion_handle *handle = NULL;
+	unsigned int RPC_ret;
+	size_t len;
+	ion_phys_addr_t dat;
+	unsigned int offset;
+
+	handle = ion_alloc(client, 4096, 1024,
+			RTK_PHOENIX_ION_HEAP_AUDIO_MASK, ION_FLAG_NONCACHED |
+			ION_FLAG_SCPUACC |
+			ION_FLAG_ACPUACC);
+	if (IS_ERR(handle)) {
+		pr_err("%s ion_alloc fail\n", __FUNCTION__);
+		goto exit;
+	}
+	if(ion_phys(client, handle, &dat, &len) != 0) {
+		pr_err("%s ion_phys fail\n", __FUNCTION__);
+		goto exit;
+	}
+
+	i_rpc = ion_map_kernel(client, handle);
+	offset = get_rpc_alignment_offset(
+			sizeof(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM));
+	o_rpc = (struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *)
+				((unsigned long)i_rpc + offset);
+
+	if (send_rpc_command(RPC_AUDIO,
+			ENUM_VIDEO_KERNEL_RPC_QUERY_CONFIG_TV_SYSTEM,
+			CONVERT_FOR_AVCPU(dat),
+			CONVERT_FOR_AVCPU(dat + offset),
+			&RPC_ret))
+	{
+		pr_err("%s RPC fail\n", __FUNCTION__);
+		goto exit;
+	}
+	ret = 0;
+
+	memcpy(arg, o_rpc, sizeof(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM));
+
+	arg->interfaceType = htonl(arg->interfaceType);
+	arg->videoInfo.standard = htonl(arg->videoInfo.standard);
+	arg->videoInfo.pedType  = htonl(arg->videoInfo.pedType);
+	arg->videoInfo.dataInt0 = htonl(arg->videoInfo.dataInt0);
+	arg->videoInfo.dataInt1 = htonl(arg->videoInfo.dataInt1);
+
+	arg->dptxInfo.dptxMode  = htonl(arg->dptxInfo.dptxMode);
+	arg->dptxInfo.audioSampleFreq = htonl(arg->dptxInfo.audioSampleFreq);
+	arg->dptxInfo.dataInt0  = htonl(arg->dptxInfo.dataInt0);
+	arg->dptxInfo.hdmi2p0_feature = htonl(arg->dptxInfo.hdmi2p0_feature);
+	arg->dptxInfo.hdmi_off_mode = htonl(arg->dptxInfo.hdmi_off_mode);
+	arg->dptxInfo.reserved3 = htonl(arg->dptxInfo.reserved3);
+	arg->dptxInfo.reserved4 = htonl(arg->dptxInfo.reserved4);
+exit:
+	if(handle != NULL) {
+		ion_unmap_kernel(client, handle);
+		ion_free(client, handle);
+	}
+	return ret;
+}
+
+int RPC_TOAGENT_DPTX_Config_TV_System(struct ion_client *client,
+			struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *arg)
+{
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *rpc = NULL;
+	unsigned int RPC_ret;
+	ion_phys_addr_t dat;
+	struct ion_handle *handle = NULL;
+	size_t len;
+	int ret = -1;
+
+	handle = ion_alloc(client, 4096, 1024,
+			RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+			ION_FLAG_NONCACHED | ION_FLAG_SCPUACC |	ION_FLAG_ACPUACC);
+	if (IS_ERR(handle)) {
+		pr_err("%s ion_alloc fail\n", __FUNCTION__);
+		goto exit;
+	}
+	if(ion_phys(client, handle, &dat, &len) != 0) {
+		pr_err("%s ion_phys fail\n", __FUNCTION__);
+		goto exit;
+	}
+	rpc = ion_map_kernel(client, handle);
+	 
+	memcpy(rpc, arg, sizeof(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM));
+
+	rpc->interfaceType = htonl(arg->interfaceType);
+	rpc->videoInfo.standard = htonl(arg->videoInfo.standard);
+	rpc->videoInfo.pedType  = htonl(arg->videoInfo.pedType);
+	rpc->videoInfo.dataInt0 = htonl(arg->videoInfo.dataInt0);
+	rpc->videoInfo.dataInt1 = htonl(arg->videoInfo.dataInt1);
+
+	rpc->dptxInfo.dptxMode  = htonl(arg->dptxInfo.dptxMode);
+	rpc->dptxInfo.audioSampleFreq = htonl(arg->dptxInfo.audioSampleFreq);
+	rpc->dptxInfo.dataInt0  = htonl(arg->dptxInfo.dataInt0);
+	rpc->dptxInfo.hdmi2p0_feature = htonl(arg->dptxInfo.hdmi2p0_feature);
+	rpc->dptxInfo.hdmi_off_mode = htonl(arg->dptxInfo.hdmi_off_mode);
+	rpc->dptxInfo.reserved3 = htonl(arg->dptxInfo.reserved3);
+	rpc->dptxInfo.reserved4 = htonl(arg->dptxInfo.reserved4);
+
+	if (send_rpc_command(RPC_AUDIO,
+			ENUM_VIDEO_KERNEL_RPC_CONFIG_TV_SYSTEM,
+			CONVERT_FOR_AVCPU(dat),
+			CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM))),
+			&RPC_ret))
+	{
+		pr_err("%s RPC fail\n", __FUNCTION__);
+		goto exit;
+	}
+	ret = 0;
+exit:
+	if(handle != NULL) {
+		ion_unmap_kernel(client, handle);
+		ion_free(client, handle);
+	}
+	return ret;
+}
diff --git a/drivers/media/platform/rtk_dptx/dptx_rpc.h b/drivers/media/platform/rtk_dptx/dptx_rpc.h
new file mode 100644
index 00000000..6c6c071
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_rpc.h
@@ -0,0 +1,243 @@
+/*
+ *  dptx_rpc.h - RTK display port driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _DPTX_RPC_H_
+#define _DPTX_RPC_H_
+
+#include <soc/realtek/kernel-rpc.h>
+
+#include "uapi/ion.h"
+#include "ion/ion.h"
+#include "uapi/ion_rtk.h"
+//#include "uapi/rtk_phoenix_ion.h"
+
+typedef enum
+{
+	ENUM_KERNEL_RPC_CREATE_AGENT,
+	ENUM_KERNEL_RPC_INIT_RINGBUF,
+	ENUM_KERNEL_RPC_PRIVATEINFO,
+	ENUM_KERNEL_RPC_RUN,
+	ENUM_KERNEL_RPC_PAUSE,
+	ENUM_KERNEL_RPC_SWITCH_FOCUS,
+	ENUM_KERNEL_RPC_MALLOC_ADDR,
+	ENUM_KERNEL_RPC_VOLUME_CONTROL,
+	ENUM_KERNEL_RPC_FLUSH,
+	ENUM_KERNEL_RPC_CONNECT,
+	ENUM_KERNEL_RPC_SETREFCLOCK,
+	ENUM_KERNEL_RPC_DAC_I2S_CONFIG,
+	ENUM_KERNEL_RPC_DAC_SPDIF_CONFIG,
+	ENUM_KERNEL_RPC_HDMI_OUT_EDID,
+	ENUM_KERNEL_RPC_HDMI_OUT_EDID2,
+	ENUM_KERNEL_RPC_HDMI_SET,
+	ENUM_KERNEL_RPC_HDMI_MUTE,
+	ENUM_KERNEL_RPC_ASK_DBG_MEM_ADDR,
+	ENUM_KERNEL_RPC_DESTROY,
+	ENUM_KERNEL_RPC_STOP,
+	ENUM_KERNEL_RPC_CHECK_READY,   // check if Audio get memory pool from AP
+	ENUM_KERNEL_RPC_GET_MUTE_N_VOLUME,	 // get mute and volume level
+	ENUM_KERNEL_RPC_EOS,
+	ENUM_KERNEL_RPC_ADC0_CONFIG,
+	ENUM_KERNEL_RPC_ADC1_CONFIG,
+	ENUM_KERNEL_RPC_ADC2_CONFIG,
+#if defined(AUDIO_TV_PLATFORM)
+	ENUM_KERNEL_RPC_BBADC_CONFIG,
+	ENUM_KERNEL_RPC_I2SI_CONFIG,
+	ENUM_KERNEL_RPC_SPDIFI_CONFIG,
+#endif // AUDIO_TV_PLATFORM
+	ENUM_KERNEL_RPC_HDMI_OUT_VSDB,
+	ENUM_VIDEO_KERNEL_RPC_CONFIG_TV_SYSTEM,
+	ENUM_VIDEO_KERNEL_RPC_CONFIG_HDMI_INFO_FRAME,
+	ENUM_VIDEO_KERNEL_RPC_QUERY_DISPLAY_WIN,
+	ENUM_VIDEO_KERNEL_RPC_PP_INIT_PIN,
+	ENUM_KERNEL_RPC_INIT_RINGBUF_AO,
+	ENUM_VIDEO_KERNEL_RPC_VOUT_EDID_DATA,
+	ENUM_KERNEL_RPC_AUDIO_POWER_SET,
+	ENUM_VIDEO_KERNEL_RPC_VOUT_VDAC_SET,
+	ENUM_VIDEO_KERNEL_RPC_QUERY_CONFIG_TV_SYSTEM
+} ENUM_AUDIO_KERNEL_RPC_CMD;
+
+enum VO_DPTX_MODE {
+	VO_DVI_ON = 0,
+	VO_DPTX_ON = 1,
+	VO_DPTX_OFF = 2,
+};
+typedef enum VO_DPTX_MODE VO_DPTX_MODE;
+ 
+enum VO_DPTX_AUDIO_SAMPLE_FREQ {
+	VO_DPTX_AUDIO_NULL = 0,
+	VO_DPTX_AUDIO_32K = 1,
+	VO_DPTX_AUDIO_44_1K = 2,
+	VO_DPTX_AUDIO_48K = 3,
+	VO_DPTX_AUDIO_88_2K = 4,
+	VO_DPTX_AUDIO_96K = 5,
+	VO_DPTX_AUDIO_176_4K = 6,
+	VO_DPTX_AUDIO_192K = 7,
+};
+typedef enum VO_DPTX_AUDIO_SAMPLE_FREQ VO_DPTX_AUDIO_SAMPLE_FREQ;
+
+enum VO_INTERFACE_TYPE {
+	VO_ANALOG_AND_DIGITAL = 0,
+	VO_ANALOG_ONLY = 1,
+	VO_DIGITAL_ONLY = 2,
+	VO_DISPLAY_PORT_ONLY = 3,
+	VO_HDMI_AND_DISPLAY_PORT_SAME_SOURCE = 4,
+	VO_HDMI_AND_DISPLAY_PORT_DIFF_SOURCE = 5,
+	VO_DISPLAY_PORT_AND_CVBS_SAME_SOURCE = 6,
+	VO_HDMI_AND_DP_DIFF_SOURCE_WITH_CVBS = 7,
+	VO_FORCE_DP_OFF = 8,
+ };
+typedef enum VO_INTERFACE_TYPE VO_INTERFACE_TYPE;
+
+enum VO_PEDESTAL_TYPE {
+	VO_PEDESTAL_TYPE_300_700_ON = 0,
+	VO_PEDESTAL_TYPE_300_700_OFF = 1,
+	VO_PEDESTAL_TYPE_286_714_ON = 2,
+	VO_PEDESTAL_TYPE_286_714_OFF = 3,
+};
+typedef enum VO_PEDESTAL_TYPE VO_PEDESTAL_TYPE;
+
+enum VO_STANDARD {
+	VO_STANDARD_NTSC_M = 0,
+	VO_STANDARD_NTSC_J = 1,
+	VO_STANDARD_NTSC_443 = 2,
+	VO_STANDARD_PAL_B = 3,
+	VO_STANDARD_PAL_D = 4,
+	VO_STANDARD_PAL_G = 5,
+	VO_STANDARD_PAL_H = 6,
+	VO_STANDARD_PAL_I = 7,
+	VO_STANDARD_PAL_N = 8,
+	VO_STANDARD_PAL_NC = 9,
+	VO_STANDARD_PAL_M = 10,
+	VO_STANDARD_PAL_60 = 11,
+	VO_STANDARD_SECAM = 12,
+	VO_STANDARD_HDTV_720P_60 = 13,
+	VO_STANDARD_HDTV_720P_50 = 14,
+	VO_STANDARD_HDTV_720P_30 = 15,
+	VO_STANDARD_HDTV_720P_25 = 16,
+	VO_STANDARD_HDTV_720P_24 = 17,
+	VO_STANDARD_HDTV_1080I_60 = 18,
+	VO_STANDARD_HDTV_1080I_50 = 19,
+	VO_STANDARD_HDTV_1080P_30 = 20,
+	VO_STANDARD_HDTV_1080P_25 = 21,
+	VO_STANDARD_HDTV_1080P_24 = 22,
+	VO_STANDARD_VGA = 23,
+	VO_STANDARD_SVGA = 24,
+	VO_STANDARD_HDTV_1080P_60 = 25,
+	VO_STANDARD_HDTV_1080P_50 = 26,
+	VO_STANDARD_HDTV_1080I_59 = 27,
+	VO_STANDARD_HDTV_720P_59 = 28,
+	VO_STANDARD_HDTV_1080P_23 = 29,
+	VO_STANDARD_HDTV_1080P_59 = 30,
+	VO_STANDARD_HDTV_1080P_60_3D = 31,
+	VO_STANDARD_HDTV_1080P_50_3D = 32,
+	VO_STANDARD_HDTV_1080P_30_3D = 33,
+	VO_STANDARD_HDTV_1080P_24_3D = 34,
+	VO_STANDARD_HDTV_720P_60_3D = 35,
+	VO_STANDARD_HDTV_720P_50_3D = 36,
+	VO_STANDARD_HDTV_720P_30_3D = 37,
+	VO_STANDARD_HDTV_720P_24_3D = 38,
+	VO_STANDARD_HDTV_720P_59_3D = 39,
+	VO_STANDARD_HDTV_1080I_60_3D = 40,
+	VO_STANDARD_HDTV_1080I_59_3D = 41,
+	VO_STANDARD_HDTV_1080I_50_3D = 42,
+	VO_STANDARD_HDTV_1080P_23_3D = 43,
+	VO_STANDARD_HDTV_2160P_30 = 44,
+	VO_STANDARD_HDTV_2160P_29 = 45,
+	VO_STANDARD_HDTV_2160P_25 = 46,
+	VO_STANDARD_HDTV_2160P_24 = 47,
+	VO_STANDARD_HDTV_2160P_23 = 48,
+	VO_STANDARD_HDTV_4096_2160P_24 = 49,
+	VO_STANDARD_HDTV_2160P_60 = 50,
+	VO_STANDARD_HDTV_2160P_50 = 51,
+	VO_STANDARD_HDTV_4096_2160P_25 = 52,
+	VO_STANDARD_HDTV_4096_2160P_30 = 53,
+	VO_STANDARD_HDTV_4096_2160P_50 = 54,
+	VO_STANDARD_HDTV_4096_2160P_60 = 55,
+	VO_STANDARD_HDTV_2160P_60_420 = 56,
+	VO_STANDARD_HDTV_2160P_50_420 = 57,
+	VO_STANDARD_HDTV_4096_2160P_60_420 = 58,
+	VO_STANDARD_HDTV_4096_2160P_50_420 = 59,
+	VO_STANDARD_DP_FORMAT_1920_1080P_60 = 60,
+	VO_STANDARD_DP_FORMAT_2160P_30 = 61,
+	VO_STANDARD_HDTV_2160P_24_3D = 62,
+	VO_STANDARD_HDTV_2160P_23_3D = 63,
+	VO_STANDARD_HDTV_2160P_59 = 64,
+	VO_STANDARD_HDTV_2160P_59_420 =65,
+	VO_STANDARD_HDTV_2160P_25_3D = 66,
+	VO_STANDARD_HDTV_2160P_30_3D = 67,
+	VO_STANDARD_HDTV_2160P_50_3D = 68,
+	VO_STANDARD_HDTV_2160P_60_3D = 69,
+	VO_STANDARD_HDTV_4096_2160P_24_3D = 70,
+	VO_STANDARD_HDTV_4096_2160P_25_3D = 71,
+	VO_STANDARD_HDTV_4096_2160P_30_3D = 72,
+	VO_STANDARD_HDTV_4096_2160P_50_3D = 73,
+	VO_STANDARD_HDTV_4096_2160P_60_3D = 74,
+	VO_STANDARD_DP_FORMAT_1280_720P_60 = 75,
+	VO_STANDARD_DP_FORMAT_3840_2160P_60 = 76,
+	VO_STANDARD_DP_FORMAT_1024_768P_60 = 77,
+	VO_STANDARD_HDTV_2160P_50_422_12bit = 78,
+	VO_STANDARD_HDTV_2160P_60_422_12bit = 79,
+	VO_STANDARD_DP_FORMAT_1280_800P_60 = 80,
+	VO_STANDARD_DP_FORMAT_1440_900P_60 = 81,
+	VO_STANDARD_DP_FORMAT_1440_768P_60 = 82,
+	VO_STANDARD_DP_FORMAT_960_544P_60 = 83,
+	VO_STANDARD_ERROR = 84,
+};
+typedef enum VO_STANDARD VO_STANDARD;
+
+enum VO_HDMI_OFF_MODE {
+	VO_HDMI_OFF_CLOCK_OFF = 0,
+	VO_HDMI_OFF_CLOCK_ON = 1,
+};
+typedef enum VO_HDMI_OFF_MODE VO_HDMI_OFF_MODE;
+
+struct VIDEO_RPC_VOUT_CONFIG_DPTX_INFO_FRAME {
+	enum VO_DPTX_MODE dptxMode;
+	enum VO_DPTX_AUDIO_SAMPLE_FREQ audioSampleFreq;
+	u_char audioChannelCount;
+	u_char dataByte1;
+	u_char dataByte2;
+	u_char dataByte3;
+	u_char dataByte4;
+	u_char dataByte5;
+	u_int dataInt0;
+	u_int hdmi2p0_feature;//[Bit0]HDMI 2.0 [Bit1]Scramble
+	enum VO_HDMI_OFF_MODE hdmi_off_mode;
+	u_int reserved3;
+	u_int reserved4;
+};
+typedef struct VIDEO_RPC_VOUT_CONFIG_DPTX_INFO_FRAME VIDEO_RPC_VOUT_CONFIG_DPTX_INFO_FRAME;
+
+struct VIDEO_RPC_VOUT_CONFIG_VIDEO_STANDARD {
+	enum VO_STANDARD standard;
+	u_char enProg;
+	u_char enDIF;
+	u_char enCompRGB;
+	enum VO_PEDESTAL_TYPE pedType;
+	u_int dataInt0;
+	u_int dataInt1;
+};
+typedef struct VIDEO_RPC_VOUT_CONFIG_VIDEO_STANDARD VIDEO_RPC_VOUT_CONFIG_VIDEO_STANDARD;
+
+
+struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM {
+	enum VO_INTERFACE_TYPE interfaceType;
+	struct VIDEO_RPC_VOUT_CONFIG_VIDEO_STANDARD videoInfo;
+	struct VIDEO_RPC_VOUT_CONFIG_DPTX_INFO_FRAME dptxInfo;
+};
+typedef struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM;
+
+struct ion_client* get_ion_client(const char *name);
+
+int RPC_TOAGENT_DPTX_QUERY_TV_System(struct ion_client *client, struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *arg);
+int RPC_TOAGENT_DPTX_Config_TV_System(struct ion_client *client, struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *arg);
+#endif//_DPTX_RPC_H_
+
diff --git a/drivers/media/platform/rtk_dptx/dptx_switch.c b/drivers/media/platform/rtk_dptx/dptx_switch.c
new file mode 100644
index 00000000..313c088
--- /dev/null
+++ b/drivers/media/platform/rtk_dptx/dptx_switch.c
@@ -0,0 +1,140 @@
+/*
+ *  dptx_switch.c - RTK display port driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/interrupt.h>
+#include <linux/of.h>
+#include <linux/of_irq.h>
+#include <linux/of_gpio.h>
+
+#include "dptx_core.h"
+
+#define DPTX_SWITCH_NAME "dptx"
+
+static irqreturn_t rtk_hpd_isr(int irq, void *dev_id)
+{
+	struct rtk_dptx_switch *swdev = (struct rtk_dptx_switch *)dev_id;
+
+	schedule_delayed_work(&swdev->work, 1);
+
+	return IRQ_HANDLED;
+}
+
+static ssize_t dptx_switch_print_state(struct switch_dev *sdev, char *buffer)
+{
+	struct rtk_dptx_switch *swdev = 
+			container_of(sdev, struct rtk_dptx_switch, sw);
+
+	return sprintf(buffer, "%d", swdev->state);
+}
+
+int dptx_switch_get_state(struct rtk_dptx_switch *swdev)
+{
+	swdev->state = gpio_get_value(swdev->hpd_gpio);
+	return swdev->state;
+}
+
+static void dptx_switch_work_func(struct work_struct *work)
+{
+	struct rtk_dptx_switch *swdev =
+			container_of(work, struct rtk_dptx_switch, work.work);
+	struct rtk_dptx_device *dptx_dev =
+			container_of(swdev, struct rtk_dptx_device, swdev);
+	struct device *dev = dptx_dev->dev;
+
+	dptx_dev->isr_signal = true;
+	swdev->state = gpio_get_value(swdev->hpd_gpio);
+	if (swdev->state != switch_get_state(&swdev->sw))
+		dev_info(dev, "%s\n", swdev->state?"plugged in":"pulled out");
+	else
+		return;
+
+	if (!swdev->state)
+		dptx_dev->cap.sink_cap_available = false;
+
+	if (swdev->state && dptx_dev->selftest)
+		dptx_config_tv_system(&dptx_dev->hwinfo);
+
+	switch_set_state(&swdev->sw, swdev->state);
+	wake_up_interruptible(&dptx_dev->hpd_wait);
+}
+
+int rtk_dptx_switch_suspend(struct rtk_dptx_device *dptx_dev)
+{
+	struct rtk_dptx_switch *swdev = &dptx_dev->swdev;
+
+	disable_irq(swdev->hpd_irq);
+
+	swdev->state = 0;
+	switch_set_state(&swdev->sw, swdev->state);
+	return 0;
+}
+
+int rtk_dptx_switch_resume(struct rtk_dptx_device *dptx_dev)
+{
+	struct rtk_dptx_switch *swdev = &dptx_dev->swdev;
+
+	enable_irq(swdev->hpd_irq);
+	schedule_delayed_work(&swdev->work, 10);
+	return 0;
+}
+
+int register_dptx_switch(struct rtk_dptx_device *dptx_dev)
+{
+	struct device *dev = dptx_dev->dev;
+	struct device_node *hpd;
+	struct rtk_dptx_switch *swdev;
+	int irq;
+	int gpio;
+
+	swdev = &dptx_dev->swdev;
+
+	hpd = of_get_child_by_name(dev->of_node, "dp_hpd");
+	if (IS_ERR(hpd)) {
+		dev_err(dev, "[%s] can't get hot plug child node\n", __func__);
+		goto fail;
+	}
+
+	gpio = of_get_gpio(hpd, 0);
+	if (gpio < 0) {
+		dev_err(dev, "[%s] can't find hot plug gpio in dtb\n", __func__);
+		goto fail;
+	}
+
+	if (gpio_request(gpio, hpd->name)) {
+		dev_err(dev, "[%s] can't get hot plug gpio\n", __func__);
+		goto fail;
+	}
+	gpio_direction_input(gpio);
+	gpio_set_debounce(gpio, 30*1000);
+	swdev->hpd_gpio = gpio;
+
+	irq = gpio_to_irq(gpio);
+	irq_set_irq_type(irq, IRQ_TYPE_EDGE_BOTH);
+	if (request_irq(irq, rtk_hpd_isr, IRQF_SHARED, "DP_HPD", swdev)) {
+		dev_err(dev, "[%s] request hot plug irq fail\n", __func__);
+		goto fail;
+	}
+	swdev->hpd_irq = irq;
+
+	swdev->sw.name = DPTX_SWITCH_NAME;
+	swdev->sw.print_state = dptx_switch_print_state;
+	if (switch_dev_register(&swdev->sw) < 0) {
+		dev_err(dev, "[%s] register switch device err\n", __func__);
+		goto fail;
+	}
+
+	INIT_DELAYED_WORK(&swdev->work, dptx_switch_work_func);
+
+	switch_set_state(&swdev->sw, 0);
+	schedule_delayed_work(&swdev->work, 200);
+fail:
+	return -1;
+}
diff --git a/drivers/media/platform/rtk_hdcptx/Kconfig b/drivers/media/platform/rtk_hdcptx/Kconfig
new file mode 100644
index 00000000..d3aced0
--- /dev/null
+++ b/drivers/media/platform/rtk_hdcptx/Kconfig
@@ -0,0 +1,16 @@
+
+config RTK_HDCP_1x
+	tristate "HDCP TX 1.x for Realtek RTD1295 platform"
+	select I2C
+	select SWITCH
+	default n
+	help
+	  Say Y, if you want to enable HDCP TX 1.x feature on Realtek RTD1295 platform.
+	  
+config RTK_HDCP_1x_TEE
+	tristate "HDCP TX 1.4 TEE for Realtek platform"
+	select RTK_HDCP_1x
+	select TEE
+	default n
+	---help---
+	  Say Y, if you want to enable HDCP TX 1.4 TEE driver on Realtek platform.
diff --git a/drivers/media/platform/rtk_hdcptx/Makefile b/drivers/media/platform/rtk_hdcptx/Makefile
new file mode 100644
index 00000000..6ad1ddd
--- /dev/null
+++ b/drivers/media/platform/rtk_hdcptx/Makefile
@@ -0,0 +1,12 @@
+# Copyright (C) 2007-2014 Realtek Semiconductor Corporation.
+# Makefile for HDCP 1.x linux kernel module.
+#
+
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmitx/
+
+obj-$(CONFIG_RTK_HDCP_1x) += hdcp.o
+hdcp-$(CONFIG_RTK_HDCP_1x) := hdcp_top.o hdcp_lib.o hdcp_ddc.o
+
+ifndef CONFIG_RTK_HDCP_1x_TEE
+hdcp-$(CONFIG_RTK_HDCP_1x) += hdcp_lib_hw.o
+endif
diff --git a/drivers/media/platform/rtk_hdcptx/hdcp.h b/drivers/media/platform/rtk_hdcptx/hdcp.h
new file mode 100644
index 00000000..fc381f4
--- /dev/null
+++ b/drivers/media/platform/rtk_hdcptx/hdcp.h
@@ -0,0 +1,349 @@
+/*
+ * hdcp.h - RTK hdcp tx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDCP_H_
+#define _HDCP_H_
+
+
+/********************************/
+/* Structures related to ioctl  */
+/********************************/
+
+/* HDCP key size in 32-bit words */
+#define DESHDCP_KEY_SIZE 160
+#define HDCP_PK_SIZE 280
+#define HDCP_Aksv_SIZE 5
+
+#define HDCP14_PARAM_KEY_SIZE   288
+
+/* HDCP ioctl */
+#include <linux/ioctl.h>
+#include <linux/types.h>
+#include <asm/io.h>
+
+struct hdcp_encrypt_control {
+	uint32_t in_key[DESHDCP_KEY_SIZE];
+	uint32_t *out_key;
+};
+
+struct hdcp_enable_control {
+	uint8_t PK[HDCP_PK_SIZE];
+	uint8_t Aksv[HDCP_Aksv_SIZE];
+	int nb_retry;
+};
+
+#define MAX_SHA_DATA_SIZE       645
+#define MAX_SHA_VPRIME_SIZE     20
+#define SHA_BLK_SIZE   64
+#define SHA1_HASH_SIZE   5
+#define KSVLIST_SIZE   640
+
+/* For HDCP2.2 repeater */
+#define RECEIVERID_SIZE (40/8)
+#define MAX_DEVICECOUNT (32)
+
+struct hdcp_sha_in {
+	uint8_t data[MAX_SHA_DATA_SIZE];
+	uint32_t byte_counter;
+	uint8_t vprime[MAX_SHA_VPRIME_SIZE];
+};
+
+struct hdcp_wait_control {
+	uint32_t event;
+	struct hdcp_sha_in *data;
+};
+
+struct hdcp_ksvlist_info {
+	uint8_t Aksv[HDCP_Aksv_SIZE];
+	uint8_t ksvlist[KSVLIST_SIZE];
+	uint8_t bstatus[2];
+	uint32_t device_count;
+	uint8_t Bksv[HDCP_Aksv_SIZE];
+};
+
+
+struct H2_RepeaterAuthSendRxIdList_PayLoad {
+	unsigned char Rxinfo[2];
+	unsigned char Seq_num[3];
+	unsigned char VPrime[32]; //V_SIZE/2
+	unsigned char Receiver_ID_LIST[RECEIVERID_SIZE*MAX_DEVICECOUNT]; //V_SIZE/2
+	unsigned char maxDevsExceeded; /* true if devcount > 31*/
+	unsigned char maxCascadeExceeded;   /* true if depth > 4*/
+	unsigned char deviceCount;
+	unsigned char depth;
+	unsigned char HDCP2_0_repeater_downstream;
+	unsigned char HDCP1_device_downstream;
+} __attribute__((packed));
+
+struct hdcp_key14_param {
+	unsigned char enc_key14[HDCP14_PARAM_KEY_SIZE];
+};
+
+enum {
+	HDCP_ENABLE,
+	HDCP_DISABLE,
+	HDCP_QUERY_STATUS,
+	HDCP_QUERY_SINK_HDCP_CAPABLE,
+	HDCP_GET_DOWNSTREAM_KSVLIST,
+	HDCP_SET_22_CIPHER,
+	HDCP_CONTROL_22_CIPHER,
+	HDCP_SET_22_REPEATER_INFO,
+	HDCP_SET_PARAM_KEY,
+};
+
+/* HDCP state */
+#define HDCP_STATE_DISABLED             0
+#define HDCP_STATE_INIT                 1
+#define HDCP_STATE_AUTH_1ST_STEP        2
+#define HDCP_STATE_AUTH_2ND_STEP        3
+#define HDCP_STATE_AUTH_3RD_STEP        4
+#define HDCP_STATE_AUTH_FAIL_RESTARTING 5
+#define HDCP_STATE_AUTH_FAILURE         6
+
+/* HDCP events */
+#define HDCP_EVENT_STEP1	(1 << 0x0)
+#define HDCP_EVENT_STEP2	(1 << 0x1)
+#define HDCP_EVENT_EXIT		(1 << 0x2)
+
+/* HDCP user space status */
+#define HDCP_US_NO_ERR		(0 << 8)
+#define HDCP_US_FAILURE		(1 << 8)
+
+#ifdef __KERNEL__
+
+#include <linux/mutex.h>
+#include <linux/workqueue.h>
+#include <linux/init.h>
+#include <linux/kernel.h>
+#include <linux/io.h>
+#include <linux/slab.h>
+#include <linux/fs.h>
+
+
+enum hdcp_repeater {
+	HDCP_RECEIVER = 0,
+	HDCP_REPEATER = 1
+};
+
+enum encryption_state {
+	HDCP_ENC_OFF = 0x0,
+	HDCP_ENC_ON  = 0x1
+};
+
+enum ri_state {
+	HDCP_RI_OFF = 0x0,
+	HDCP_RI_ON  = 0x1
+};
+
+enum av_mute {
+	AV_MUTE_SET = 0x01,
+	AV_MUTE_CLEAR = 0x10
+};
+
+enum sink_hdcp_capable {
+	HDCP_INCAPABLE = 0,
+	HDCP_CAPABLE = 1
+};
+
+enum {
+	HDCP_22_CIPHER_DEFAULT,
+	HDCP_22_CIPHER_PAUSE,
+	HDCP_22_CIPHER_RESUME,
+};
+
+/***************************/
+/* Definitions             */
+/***************************/
+
+/* Status / error codes */
+#define HDCP_OK                 0
+#define HDCP_DDC_ERROR          1
+#define HDCP_AUTH_FAILURE       2
+#define HDCP_AKSV_ERROR         3
+#define HDCP_3DES_ERROR         4
+#define HDCP_SHA1_ERROR         5
+#define HDCP_DRIVER_ERROR       6
+#define HDCP_CANCELLED_AUTH     7
+
+#define HDCP_INFINITE_REAUTH    0x100
+#define HDCP_MAX_FAIL_MESSAGES  3
+
+
+/* HDCP 1.4Spec, must not read the R0' sooner than 100ms after write Aksv */
+#define HDCP_R0_DELAY           120
+#define HDCP_KSV_TIMEOUT_DELAY  5000
+
+/* Event source */
+#define HDCP_SRC_SHIFT          8
+#define HDCP_IOCTL_SRC          (0x1 << HDCP_SRC_SHIFT)
+#define HDCP_HDMI_SRC           (0x2 << HDCP_SRC_SHIFT)
+#define HDCP_IRQ_SRC            (0x4 << HDCP_SRC_SHIFT)
+#define HDCP_WORKQUEUE_SRC      (0x8 << HDCP_SRC_SHIFT)
+
+/* Workqueue events */
+/* Note: HDCP_ENABLE_CTL, HDCP_R0_EXP_EVENT, HDCP_KSV_TIMEOUT_EVENT and
+ * HDCP_AUTH_REATT_EVENT can be cancelled by HDCP disabling
+ */
+#define HDCP_ENABLE_CTL         (HDCP_IOCTL_SRC         | 0)
+#define HDCP_DISABLE_CTL        (HDCP_IOCTL_SRC         | 1)
+#define HDCP_START_FRAME_EVENT  (HDCP_HDMI_SRC          | 2)
+#define HDCP_STOP_FRAME_EVENT   (HDCP_HDMI_SRC          | 3)
+#define HDCP_HPD_LOW_EVENT      (HDCP_IRQ_SRC           | 4)
+#define HDCP_RI_FAIL_EVENT      (HDCP_IRQ_SRC           | 5)
+#define HDCP_KSV_LIST_RDY_EVENT (HDCP_IRQ_SRC           | 6)
+
+#define HDCP_R0_EXP_EVENT       (HDCP_WORKQUEUE_SRC     | 7)
+#define HDCP_KSV_TIMEOUT_EVENT  (HDCP_WORKQUEUE_SRC     | 8)
+#define HDCP_AUTH_REATT_EVENT   (HDCP_WORKQUEUE_SRC     | 9)
+/* #define HDCP_R0_CHECK_EVENT   (HDCP_WORKQUEUE_SRC     | 0xa) */
+
+/* IRQ status */
+#define HDCP_IRQ_RI_FAIL 0x01
+#define HDCP_IRQ_KSV_RDY 0x02
+
+enum hdcp_states {
+	HDCP_DISABLED,
+	HDCP_ENABLE_PENDING,
+	HDCP_AUTHENTICATION_START,
+	HDCP_WAIT_R0_DELAY,
+	HDCP_WAIT_KSV_LIST,
+	HDCP_LINK_INTEGRITY_CHECK,
+	HDCP_KEY_ENCRYPTION_ONGOING
+};
+
+enum hdmi_states {
+	HDMI_STOPPED,
+	HDMI_STARTED
+};
+
+struct hdcp_delayed_work {
+	struct delayed_work work;
+	int event;
+};
+
+struct hdcp {
+	void __iomem *hdcp_base_addr;
+	unsigned int hdcp_irq_num;
+	struct mutex lock;
+	struct hdcp_enable_control *en_ctrl;
+	enum hdmi_states hdmi_state;
+	enum hdcp_states hdcp_state;
+	int auth_state;
+	struct delayed_work *pending_start;
+	/* Following variable should store works submitted from workqueue
+	 * context
+	 * WARNING: only ONE work at a time can be stored (no conflict
+	 * should happen). It is used to allow cancelled pending works when
+	 * disabling HDCP
+	 */
+	struct delayed_work *pending_wq_event;
+	int retry_cnt;
+	int reauth_delay;
+	int fail_cnt;
+	int av_mute_needed;
+	int print_messages;
+	int dss_state;
+	int hdmi_restart;
+	int hpd_low;
+	spinlock_t spinlock;
+	struct workqueue_struct *workqueue;
+	int hdcp_up_event;
+	int hdcp_down_event;
+	bool hdcp_keys_loaded;
+	int hdcp_enabled;
+	int hdcp2p2_enabled;
+};
+
+/**
+ * riv           : hw_riv_1_(1-2)
+ * ks_xor_lc128  : sw_key_1_(1-4)
+ * frame_num     : frame_num_(1-2)
+ * frame_num_add : frame_num_add_(1-2)
+ * data_num      : data_num
+ * data_num_add  : data_num_add
+ * hdcp_22_en    : hdcp_22_ctrl:hdcp_22_en
+ * aes_sw_en     : hdcp_22_ctrl:aes_sw_en
+ */
+struct HDCP_22_CIPHER_INFO {
+	unsigned long long frame_num;
+	unsigned long long frame_num_add;
+	unsigned int data_num;
+	unsigned int data_num_add;
+	unsigned int rsvd_1;
+	unsigned int rsvd_2;
+	unsigned int rsvd_3;
+	unsigned char riv[8];
+	unsigned char ks_xor_lc128[16];
+	unsigned char hdcp_22_en;
+	unsigned char aes_sw_en;
+	unsigned char rsvd_4;
+	unsigned char rsvd_5;
+};
+
+extern struct hdcp hdcp;
+extern struct hdcp_sha_in sha_input;
+extern struct hdcp_ksvlist_info ksvlist_info;
+
+/***************************/
+/* Macros for accessing HW */
+/***************************/
+
+#define WR_REG_32(base, offset, val)    writel(val, (volatile unsigned int*)(base + offset))
+#define RD_REG_32(base, offset)         readl((volatile unsigned int*)(base + offset))
+
+
+#undef FLD_MASK
+#define FLD_MASK(start, end)    (((1 << (start - end + 1)) - 1) << (end))
+#undef FLD_VAL
+#define FLD_VAL(val, start, end) (((val) << end) & FLD_MASK(start, end))
+#define FLD_GET(val, start, end) (((val) & FLD_MASK(start, end)) >> (end))
+#define FLD_MOD(orig, val, start, end) \
+	(((orig) & ~FLD_MASK(start, end)) | FLD_VAL(val, start, end))
+
+#define WR_FIELD_32(base, offset, start, end, val) \
+	WR_REG_32(base, offset, FLD_MOD(RD_REG_32(base, offset), val, start, end))
+
+#define RD_FIELD_32(base, offset, start, end) \
+	((RD_REG_32(base, offset) & FLD_MASK(start, end)) >> (end))
+
+
+#define __RTK_HDCP_GENERIC_DEBUG__  0
+
+#if __RTK_HDCP_GENERIC_DEBUG__
+#define HDCP_DEBUG(format, ...) printk("HDCP_DEBUG: " format "\n", ## __VA_ARGS__)
+#else
+#define HDCP_DEBUG(format, ...)
+#endif
+
+#define HDCP_ERROR(format, ...) printk(KERN_ERR "HDCP_ERROR: " format "\n", ## __VA_ARGS__)
+#define HDCP_INFO(format, ...) printk(KERN_WARNING "HDCP_INFO: " format "\n", ## __VA_ARGS__)
+
+/***************************/
+/* Function prototypes     */
+/***************************/
+
+/* IP control */
+int hdcp_lib_disable(void);
+int hdcp_lib_step1_start(void);
+int hdcp_lib_step1_r0_check(void);
+int hdcp_lib_step2(void);
+int hdcp_lib_irq(void);
+void hdcp_lib_auto_ri_check(bool state);
+void hdcp_lib_auto_bcaps_rdy_check(bool state);
+void hdcp_lib_set_av_mute(enum av_mute av_mute_state);
+int hdcp_lib_r0_check(void);
+int hdcp_lib_query_sink_hdcp_capable(void);
+void hdcp_lib_set_22_cipher(struct HDCP_22_CIPHER_INFO *arg);
+void hdcp_lib_control_22_cipher(int control_flag);
+
+#endif /* __KERNEL__ */
+
+#endif /* _HDCP_H_ */
diff --git a/drivers/media/platform/rtk_hdcptx/hdcp_ddc.c b/drivers/media/platform/rtk_hdcptx/hdcp_ddc.c
new file mode 100644
index 00000000..9c09bba
--- /dev/null
+++ b/drivers/media/platform/rtk_hdcptx/hdcp_ddc.c
@@ -0,0 +1,89 @@
+/*
+ * hdcp_ddc.c - RTK hdcp tx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/delay.h>
+#include <linux/i2c.h>
+#include "hdcp.h"
+
+#define HDCP_I2C_SPEED I2C_M_LOW_SPEED_80
+
+int ddc_write(int len, unsigned char start, unsigned char *buf)
+{
+	struct i2c_adapter *p_adap;
+	unsigned char bus_id = 1;
+	unsigned char *data;
+
+	data = kzalloc((len+1)*sizeof(unsigned char), GFP_KERNEL);
+
+	data[0] = start;
+	memcpy(data+1, buf, len);
+
+#if 0
+	int i;
+
+	for (i = 0; i < len+1; i++)
+		HDCP_DEBUG("data[%d]=0x%x\n", i, data[i]);
+
+	for (i = 0; i < len; i++)
+		HDCP_DEBUG("buf[%d]=0x%x\n", i, buf[i]);
+#endif
+
+	struct i2c_msg msgs[] = {
+		{
+			.addr	= 0x3A,
+			.flags	= HDCP_I2C_SPEED,
+			.len	= len+1,
+			.buf	= data,
+		}
+	};
+
+	p_adap = i2c_get_adapter(bus_id);
+	if (p_adap == NULL) {
+		HDCP_ERROR("get adapter %d failed\n", bus_id);
+		return -ENODEV;
+	}
+
+	if (i2c_transfer(p_adap, msgs, 1) == 1)
+		return 0;
+
+	return -ECOMM;
+}
+
+int ddc_read(int len, unsigned char start, unsigned char *buf)
+{
+	struct i2c_adapter *p_adap;
+	unsigned char bus_id = 1;
+
+	struct i2c_msg msgs[] = {
+		{
+			.addr	= 0x3A,
+			.flags	= HDCP_I2C_SPEED,
+			.len	= 1,
+			.buf	= &start,
+		}, {
+			.addr	= 0x3A,
+			.flags	= HDCP_I2C_SPEED | I2C_M_RD,
+			.len	= len,
+			.buf	= buf,
+		}
+	};
+
+	p_adap = i2c_get_adapter(bus_id);
+	if (p_adap == NULL) {
+		HDCP_ERROR("hdcp get adapter %d failed\n", bus_id);
+		return -ENODEV;
+	}
+
+	if (i2c_transfer(p_adap, msgs, 2) == 2)
+		return 0;
+
+	return -ECOMM;
+}
diff --git a/drivers/media/platform/rtk_hdcptx/hdcp_ddc.h b/drivers/media/platform/rtk_hdcptx/hdcp_ddc.h
new file mode 100644
index 00000000..0b112ef
--- /dev/null
+++ b/drivers/media/platform/rtk_hdcptx/hdcp_ddc.h
@@ -0,0 +1,74 @@
+/*
+ * hdcp_ddc.h - RTK hdcp tx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/ioctl.h>
+#include <linux/types.h>
+
+enum ddc_operation {
+	DDC_READ,
+	DDC_WRITE
+};
+
+/***********************/
+/* DDC addresses  */
+/***********************/
+#define DDC_BKSV_ADDR           0x00
+#define DDC_Ri_ADDR             0x08
+#define DDC_AKSV_ADDR           0x10
+#define DDC_AN_ADDR             0x18
+#define DDC_V_ADDR              0x20
+#define DDC_BCAPS_ADDR          0x40
+#define DDC_BSTATUS_ADDR        0x41
+#define DDC_KSV_FIFO_ADDR       0x43
+
+#define DDC_BKSV_LEN            5
+#define DDC_Ri_LEN              2
+#define DDC_AKSV_LEN            5
+#define DDC_AN_LEN              8
+#define DDC_V_LEN               20
+#define DDC_BCAPS_LEN           1
+#define DDC_BSTATUS_LEN         2
+
+#define DDC_BIT_REPEATER        6
+/* Bit5:READY of Bcaps, KSV FIFO ready */
+#define DDC_BIT_READY           5
+
+#define DDC_BSTATUS0_MAX_DEVS   0x80
+#define DDC_BSTATUS0_DEV_COUNT  0x7F
+#define DDC_BSTATUS1_MAX_CASC   0x08
+
+
+/* DDC access timeout in ms */
+#define DDC_TIMEOUT     500
+#define DDC_STOP_FRAME_BLOCKING_TIMEOUT (2*DDC_TIMEOUT)
+
+#define MAX_DDC_ERR     5
+
+/* Status / error codes */
+#define DDC_OK                  0
+#define DDC_ERROR               1
+
+
+#define RD_FIELD_32(base, offset, start, end) \
+	((RD_REG_32(base, offset) & FLD_MASK(start, end)) >> (end))
+
+
+struct ddc {
+	void __iomem *hdmi_wp_base_addr;
+	struct mutex lock;
+	spinlock_t spinlock;
+};
+extern struct ddc ddc;
+
+/* DDC */
+int ddc_read(int len, unsigned char start, unsigned char *buf);
+int ddc_write(int len, unsigned char start, unsigned char *buf);
+
diff --git a/drivers/media/platform/rtk_hdcptx/hdcp_lib.c b/drivers/media/platform/rtk_hdcptx/hdcp_lib.c
new file mode 100644
index 00000000..585764a
--- /dev/null
+++ b/drivers/media/platform/rtk_hdcptx/hdcp_lib.c
@@ -0,0 +1,644 @@
+/*
+ * hdcp_lib.c - RTK hdcp tx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/delay.h>
+#include <linux/dma-mapping.h>
+#include <linux/i2c.h>
+#include <linux/delay.h>
+#include <linux/interrupt.h>
+
+#include "hdcp_top.h"
+#include "hdcp_lib_hw.h"
+#include "hdcp.h"
+#include "hdcp_ddc.h"
+
+#include "hdmitx_reg.h"
+
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+/* RX function, for HDCP repeater */
+extern void HdmiRx_save_tx_ksv(struct hdcp_ksvlist_info *tx_ksv);
+extern void HdmiRx_set_bstatus(unsigned char byte1, unsigned char byte0);
+#endif
+
+static int hdcp_lib_read_aksv(uint8_t *ksv_data);
+static int hdcp_lib_initiate_step1(void);
+static int hdcp_lib_check_ksv(uint8_t ksv[5]);
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_read_aksv
+ *-----------------------------------------------------------------------------
+ */
+static int hdcp_lib_read_aksv(uint8_t *ksv_data)
+{
+	if (hdcp.hdcp_enabled == 0)
+		return -HDCP_CANCELLED_AUTH;
+
+	*(ksv_data+0) = hdcp.en_ctrl->Aksv[0];
+	*(ksv_data+1) = hdcp.en_ctrl->Aksv[1];
+	*(ksv_data+2) = hdcp.en_ctrl->Aksv[2];
+	*(ksv_data+3) = hdcp.en_ctrl->Aksv[3];
+	*(ksv_data+4) = hdcp.en_ctrl->Aksv[4];
+
+	return HDCP_OK;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_check_ksv
+ *-----------------------------------------------------------------------------
+ */
+static int hdcp_lib_check_ksv(uint8_t ksv[5])
+{
+	int i;
+	int j;
+	int zero;
+	int one;
+
+	zero = 0;
+	one = 0;
+	for (i = 0; i < 5; i++) {
+		/* Count number of zero / one */
+		for (j = 0; j < 8; j++) {
+			if (ksv[i] & (0x01 << j))
+				one++;
+			else
+				zero++;
+		}
+	}
+
+	if (one == zero)
+		return HDCP_OK;
+	else
+		return -HDCP_AKSV_ERROR;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_initiate_step1
+ *-----------------------------------------------------------------------------
+ */
+static int hdcp_lib_initiate_step1(void)
+{
+	/*
+	 * HDCP authentication steps:
+	 *   1) Read Bksv - check validity (is HDMI Rx supporting HDCP ?)
+	 *   2) Initializes HDCP (CP reset release)
+	 *   3) Read Bcaps - is HDMI Rx a repeater ?
+	 *   *** First part authentication ***
+	 *   4) Read Bksv - check validity (is HDMI Rx supporting HDCP ?)
+	 *   5) Generates An
+	 *   6) DDC: Writes An, Aksv
+	 *   7) DDC: Write Bksv
+	 */
+	int status = HDCP_OK;
+	uint8_t an_ksv_data[5];
+	uint8_t an_bksv_data[5];
+	uint8_t rx_type;
+	uint8_t genAn[8];
+
+	/* HDCP_DEBUG("[%s] %s  %d :%u\n", __FILE__, __func__, __LINE__, jiffies_to_msecs(jiffies)); */
+	/* Generate An */
+	status = hdcp_lib_generate_an(genAn);
+
+	if (status != HDCP_OK)
+		return status;
+
+	HDCP_DEBUG("AN: %x %x %x %x %x %x %x %x",
+		genAn[0], genAn[1], genAn[2], genAn[3],
+		genAn[4], genAn[5], genAn[6], genAn[7]);
+
+	status = hdcp_lib_read_aksv(an_ksv_data);
+	if (status != HDCP_OK)
+		return status;
+
+	HDCP_INFO("AKSV: %02x %02x %02x %02x %02x",
+		an_ksv_data[0], an_ksv_data[1], an_ksv_data[2],
+		an_ksv_data[3], an_ksv_data[4]);
+
+	status = hdcp_lib_check_ksv(an_ksv_data);
+	if (status != HDCP_OK) {
+		HDCP_ERROR("AKSV error (number of,0 and 1)\n");
+		HDCP_ERROR("AKSV: %02x %02x %02x %02x %02x",
+			an_ksv_data[0], an_ksv_data[1], an_ksv_data[2],
+			an_ksv_data[3], an_ksv_data[4]);
+		return status;
+	}
+	memcpy(ksvlist_info.Aksv, an_ksv_data, sizeof(an_ksv_data));
+
+	/* DDC: Write An */
+	if (ddc_write(DDC_AN_LEN, DDC_AN_ADDR, genAn))
+		return -DDC_ERROR;
+
+	/* DDC: Write AKSV */
+	if (ddc_write(DDC_AKSV_LEN, DDC_AKSV_ADDR, an_ksv_data))
+		return -DDC_ERROR;
+
+	/* Read BCAPS to determine if HDCP RX is a repeater */
+	if (ddc_read(DDC_BCAPS_LEN, DDC_BCAPS_ADDR, &rx_type))
+		return -DDC_ERROR;
+
+	rx_type = FLD_GET(rx_type, DDC_BIT_REPEATER, DDC_BIT_REPEATER);
+
+	/* Set repeater bit in HDCP CTRL */
+	if (rx_type == 1) {
+
+		hdcp_lib_set_repeater_bit_in_tx(HDCP_REPEATER);
+
+		HDCP_DEBUG("HDCP RX is a repeater");
+	} else {
+
+		hdcp_lib_set_repeater_bit_in_tx(HDCP_RECEIVER);
+
+		HDCP_DEBUG("HDCP RX is a receiver");
+	}
+
+	/* DDC: Read BKSV from RX */
+	if (ddc_read(DDC_BKSV_LEN, DDC_BKSV_ADDR, an_bksv_data))
+		return -DDC_ERROR;
+
+	if (hdcp_lib_check_ksv(an_bksv_data)) {
+		HDCP_ERROR("Invalid BKSV: %02x %02x %02x %02x %02x",
+			an_bksv_data[0], an_bksv_data[1], an_bksv_data[2],
+			an_bksv_data[3], an_bksv_data[4]);
+		return -HDCP_AKSV_ERROR;
+	}
+
+	memcpy(ksvlist_info.Bksv, an_bksv_data, sizeof(an_bksv_data));
+
+	HDCP_DEBUG("BKSV: %02x %02x %02x %02x %02x",
+		an_bksv_data[0], an_bksv_data[1], an_bksv_data[2],
+		an_bksv_data[3], an_bksv_data[4]);
+
+	HDCP_DEBUG("PK: %02x %02x %02x %02x %02x",
+		hdcp.en_ctrl->PK[0], hdcp.en_ctrl->PK[1], hdcp.en_ctrl->PK[2],
+		hdcp.en_ctrl->PK[3], hdcp.en_ctrl->PK[4]);
+
+	/* Authentication 1st step initiated HERE */
+	status = hdcp_lib_write_bksv(an_bksv_data);
+
+	return status;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_step1_start
+ *-----------------------------------------------------------------------------
+ */
+int hdcp_lib_step1_start(void)
+{
+	int status;
+
+	/* HDCP_DEBUG("[%s] %s  %d :%u\n", __FILE__, __func__, __LINE__, jiffies_to_msecs(jiffies)); */
+
+#if 0
+	/* Set AV Mute if needed */
+	if (hdcp.av_mute_needed)
+		hdcp_lib_set_av_mute(AV_MUTE_SET);
+
+	/* Must turn encryption off when AVMUTE */
+		hdcp_lib_set_encryption(HDCP_ENC_OFF);
+#endif
+	status = hdcp_lib_initiate_step1();
+
+	return status;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_r0_check
+ *----------------------------------------------------------------------------
+ */
+int hdcp_lib_r0_check(void)
+{
+	uint8_t ro_rx[2] = {0, 0};
+	uint8_t ro_tx[2] = {0, 0};
+
+	/* DDC: Read Ri' from RX */
+	if (ddc_read(DDC_Ri_LEN, DDC_Ri_ADDR, ro_rx))
+		return -DDC_ERROR;
+
+	ro_tx[0] = (RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_LIR)>>8)&0xff;
+	ro_tx[1] = (RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_LIR)>>16)&0xff;
+
+	/* Compare values */
+	if ((ro_rx[0] == ro_tx[0]) && (ro_rx[1] == ro_tx[1])) {
+		HDCP_DEBUG("ROTX: %x%x RORX:%x%x\n", ro_tx[0], ro_tx[1], ro_rx[0], ro_rx[1]);
+		return HDCP_OK;
+	} else {
+		HDCP_ERROR("ROTX: %x%x RORX:%x%x\n", ro_tx[0], ro_tx[1], ro_rx[0], ro_rx[1]);
+		return -HDCP_AUTH_FAILURE;
+	}
+
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_auto_ri_check
+ *-----------------------------------------------------------------------------
+ */
+void hdcp_lib_auto_ri_check(bool state)
+{
+	void *irq_dev_id = (void *)&hdcp.hdcp_irq_num;
+
+	if (state == true) {
+
+		hdcp_lib_set_wider_window();
+
+		if (request_irq(hdcp.hdcp_irq_num, HDCP_interrupt_handler, IRQF_SHARED, "rtk_hdcp", irq_dev_id)) {
+			HDCP_ERROR("request HDCP irq failed");
+		} else {
+			HDCP_DEBUG("request HDCP irq %d", hdcp.hdcp_irq_num);
+
+			hdcp_lib_set_ri_interrupt(HDCP_RI_ON);
+		}
+	} else {
+		hdcp_lib_set_ri_interrupt(HDCP_RI_OFF);
+	}
+
+	HDCP_DEBUG("[%s] %s  %d :%u ,state=%s\n", __FILE__, __func__, __LINE__,
+		jiffies_to_msecs(jiffies), state == true ? "ON" : "OFF");
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_polling_bcaps_rdy_check
+ *-----------------------------------------------------------------------------
+ */
+int hdcp_lib_polling_bcaps_rdy_check(void)
+{
+	uint8_t ready_bit;
+	int i;
+
+	/*
+	 * State A8:Wait for Ready.
+	 * sets up 5 secs timer and polls the Receiver's READY bit.
+	 */
+	for (i = 0; i < 50; i++) {
+		ready_bit = 0;
+		if (ddc_read(DDC_BCAPS_LEN, DDC_BCAPS_ADDR, &ready_bit))
+			HDCP_ERROR("I2c error, read Bcaps failed");
+
+		if (FLD_GET(ready_bit, DDC_BIT_READY, DDC_BIT_READY)) {
+			HDCP_DEBUG("Bcaps ready bit asserted");
+			return HDCP_OK;
+		} else {
+			usleep_range(100000, 110000);
+		}
+	}
+
+	return -HDCP_AUTH_FAILURE;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_step1_r0_check
+ *-----------------------------------------------------------------------------
+ */
+int hdcp_lib_step1_r0_check(void)
+{
+	int status;
+	uint8_t rx_type;
+
+	/*
+	 * HDCP authentication steps:
+	 * 1) DDC: Read M0'
+	 * 2) Compare M0 and M0'
+	 * if Rx is a receiver: switch to authentication step 3
+	 * 3) Enable encryption / auto Ri check / disable AV mute
+	 * if Rx is a repeater: switch to authentication step 2
+	 * 3) Get M0 from HDMI IP and store it for further processing (V)
+	 * 4) Enable encryption / auto Ri check / auto BCAPS RDY polling
+	 *     Disable AV mute
+	 */
+
+	/* HDCP_DEBUG("[%s] %s  %d :%u\n", __FILE__,__FUNCTION__,__LINE__,jiffies_to_msecs(jiffies)); */
+
+	status = hdcp_lib_r0_check();
+	if (status < 0)
+		return status;
+
+	/* Authentication 1st step done */
+	HDCP_INFO("R0 check success");
+
+	/*
+	 * Now prepare 2nd step authentication in case of RX repeater and
+	 * enable encryption / Ri check
+	 */
+
+	/* Read BCAPS to determine if HDCP RX is a repeater */
+	if (ddc_read(DDC_BCAPS_LEN, DDC_BCAPS_ADDR, &rx_type))
+		return -DDC_ERROR;
+
+	rx_type = FLD_GET(rx_type, DDC_BIT_REPEATER, DDC_BIT_REPEATER);
+
+	if (rx_type == 0) {
+		/* Receiver: enable encryption and auto Ri check */
+		hdcp_lib_set_encryption(HDCP_ENC_ON);
+
+		hdcp_lib_auto_ri_check(true);
+	}
+
+	return status;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_dump_sha
+ *-----------------------------------------------------------------------------
+ */
+static void __maybe_unused
+hdcp_lib_dump_sha(struct hdcp_sha_in *sha)
+{
+	int i;
+
+	pr_info("sha.byte_counter= %d\n", sha->byte_counter);
+
+	pr_info("sha.vprime=[ ");
+	for (i = 0; i < MAX_SHA_VPRIME_SIZE; i++)
+		pr_info("0x%x,", sha->vprime[i]);
+
+	pr_info("]\n");
+	pr_info("sha.data=[ ");
+
+	for (i = 0; i < sha->byte_counter; i++)
+		pr_info("0x%x,", sha->data[i]);
+
+	pr_info("]\n");
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_verify_V
+ *-----------------------------------------------------------------------------
+ */
+static void __maybe_unused
+hdcp_lib_dump_SHA_block(uint8_t *sha_blk)
+{
+	int i;
+
+	for (i = 0; i < SHA_BLK_SIZE/4; i++)
+		HDCP_DEBUG("sha_blk[%2d,%2d,%2d,%2d]= %2x, %2x, %2x, %2x,",
+			4*i+0, 4*i+1, 4*i+2, 4*i+3,
+			sha_blk[4*i+0], sha_blk[4*i+1], sha_blk[4*i+2], sha_blk[4*i+3]);
+
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_step2
+ *-----------------------------------------------------------------------------
+ */
+int hdcp_lib_step2(void)
+{
+	/*
+	 * HDCP authentication steps:
+	 *   1) Disable auto Ri check
+	 *   2) DDC: read BStatus (nb of devices, MAX_DEV
+	 */
+	uint8_t bstatus[2] = {0};
+	int status = HDCP_OK;
+	int i;
+
+	HDCP_DEBUG("[%s] %s  %d :%u", __FILE__, __func__, __LINE__, jiffies_to_msecs(jiffies));
+
+	status = hdcp_lib_polling_bcaps_rdy_check();
+	if (status != HDCP_OK) {
+		HDCP_ERROR("polling Bcaps ready failed\n");
+#ifndef CONFIG_RTK_HDCP1x_REPEATER
+		return status;
+#endif
+	}
+
+	/* DDC: Read Bstatus (1st byte) from Rx */
+	if (ddc_read(DDC_BSTATUS_LEN, DDC_BSTATUS_ADDR, bstatus))
+		return -DDC_ERROR;
+
+	HDCP_DEBUG("bstatus=0x%x,0x%x", bstatus[0], bstatus[1]);
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+		HdmiRx_set_bstatus(bstatus[1], bstatus[0]);
+
+		if (status != HDCP_OK)
+			return status;
+#endif
+
+	/* Check BStatus topology errors */
+	if (bstatus[0] & DDC_BSTATUS0_MAX_DEVS) {
+		HDCP_ERROR("MAX_DEV_EXCEEDED set");
+		return -HDCP_AUTH_FAILURE;
+	}
+
+	if (bstatus[1] & DDC_BSTATUS1_MAX_CASC) {
+		HDCP_ERROR("MAX_CASCADE_EXCEEDED set");
+		return -HDCP_AUTH_FAILURE;
+	}
+
+	HDCP_DEBUG("Retrieving KSV list...");
+	/* Get KSV list size */
+	sha_input.byte_counter = (bstatus[0] & DDC_BSTATUS0_DEV_COUNT) * 5;
+
+	/* Clear all SHA input data */
+	/* TODO: should be done earlier at HDCP init */
+	memset(sha_input.data, 0, MAX_SHA_DATA_SIZE);
+
+	/* DDC: read KSV list */
+	if (sha_input.byte_counter) {
+		if (ddc_read(sha_input.byte_counter, DDC_KSV_FIFO_ADDR, (uint8_t *)&sha_input.data)) {
+			return -DDC_ERROR;
+		} else {
+			ksvlist_info.device_count = (bstatus[0] & DDC_BSTATUS0_DEV_COUNT);
+			memcpy(ksvlist_info.ksvlist, sha_input.data, sizeof(ksvlist_info.ksvlist));
+			memcpy(ksvlist_info.bstatus, bstatus, sizeof(ksvlist_info.bstatus));
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+			/* Send KSV list to RX immediately for Repeater CTS 3C-II */
+			HdmiRx_save_tx_ksv(&ksvlist_info);
+#endif
+		}
+	}
+
+	/* Read and add Bstatus */
+	hdcp_lib_SHA_append_bstatus_M0(&sha_input, bstatus);
+
+	/* Read V' */
+	if (ddc_read(DDC_V_LEN, DDC_V_ADDR, sha_input.vprime))
+		return -DDC_ERROR;
+
+	for (i = 0; i < 5; i++) {
+		HDCP_DEBUG("sha_input.vprime[%d]=%x,%x,%x,%x\n", 4*i,
+			sha_input.vprime[4*i+0], sha_input.vprime[4*i+1],
+			sha_input.vprime[4*i+2], sha_input.vprime[4*i+3]);
+	}
+	/* hdcp_lib_dump_sha(&sha_input); */
+
+	status = hdcp_lib_compute_V(&sha_input);
+	if (status != HDCP_OK)
+		goto sha_err;
+
+	status = hdcp_lib_verify_V(&sha_input);
+
+	if (status == HDCP_OK) {
+		/* Re-enable Ri check */
+		/* Receiver: enable encryption and auto Ri check */
+		hdcp_lib_set_encryption(HDCP_ENC_ON);
+
+		hdcp_lib_auto_ri_check(true);
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+		HdmiRx_save_tx_ksv(&ksvlist_info);
+#endif
+	}
+
+sha_err:
+	return status;
+}
+
+int hdcp_lib_query_sink_hdcp_capable(void)
+{
+	uint8_t an_bksv_data[5];
+	int i;
+	int retry = 15;
+
+	/* HDCP CTS 1A-04: Continue to read the HDCP port for 20 seconds */
+	for (i = 0; i < retry; i++) {
+		if (ddc_read(DDC_BKSV_LEN, DDC_BKSV_ADDR, an_bksv_data)) {
+			HDCP_ERROR("Read BKSV error %d time(s)", i);
+		} else {
+
+			if (hdcp_lib_check_ksv(an_bksv_data))
+				HDCP_ERROR("Check BKSV error(%d)", i);
+			else
+				return 0;
+		}
+		msleep(1500);
+	}
+
+	return -HDCP_AKSV_ERROR;
+}
+
+void hdcp_lib_dump_22_cipher_setting(void)
+{
+	HDCP_DEBUG("HDCP_2_2_HW_RIV_1=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_RIV_1));
+	HDCP_DEBUG("HDCP_2_2_HW_RIV_2=0x08%x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_RIV_2));
+
+	HDCP_DEBUG("HDCP_2_2_SW_KEY_1_1=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_SW_KEY_1_1));
+	HDCP_DEBUG("HDCP_2_2_SW_KEY_1_2=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_SW_KEY_1_2));
+	HDCP_DEBUG("HDCP_2_2_SW_KEY_1_3=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_SW_KEY_1_3));
+	HDCP_DEBUG("HDCP_2_2_SW_KEY_1_4=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_SW_KEY_1_4));
+
+	HDCP_DEBUG("HDCP_2_2_HW_FRAME_NUM_1=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_FRAME_NUM_1));
+	HDCP_DEBUG("HDCP_2_2_HW_FRAME_NUM_2=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_FRAME_NUM_2));
+
+	HDCP_DEBUG("HDCP_2_2_HW_FRAME_NUM_ADD_1=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1));
+	HDCP_DEBUG("HDCP_2_2_HW_FRAME_NUM_ADD_2=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2));
+
+	HDCP_DEBUG("HDCP_2_2_HW_DATA_NUM=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_DATA_NUM));
+
+	HDCP_DEBUG("HDCP_2_2_HW_DATA_NUM_ADD=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_DATA_NUM_ADD));
+
+	HDCP_DEBUG("HDCP_2_2_CTRL=0x%08x",
+		RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_CTRL));
+
+}
+
+void hdcp_lib_set_1x_state_machine_for_22_cipher(void)
+{
+	/* set HDCP 1.4 state machine */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH,
+		HDMI_HDCP_AUTH_write_en1(1)|HDMI_HDCP_AUTH_authrequest(1));
+	udelay(1);
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH,
+		HDMI_HDCP_AUTH_write_en2(1)|HDMI_HDCP_AUTH_authcompute(1));
+	udelay(1);
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH,
+		HDMI_HDCP_AUTH_write_en4(1)|HDMI_HDCP_AUTH_deviceauthenticated(1));
+
+}
+
+void hdcp_lib_set_22_cipher(struct HDCP_22_CIPHER_INFO *arg)
+{
+	if (arg->hdcp_22_en == 1)
+		hdcp_lib_set_1x_state_machine_for_22_cipher();
+
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_CTRL,
+		HDMI_HDCP_2_2_CTRL_write_en4(1)|HDMI_HDCP_2_2_CTRL_hdcp_2_2_en(arg->hdcp_22_en));
+
+	/* riv           : hw_riv_1_(1-2) */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_RIV_1,
+		arg->riv[0]|(arg->riv[1]<<8)|(arg->riv[2]<<16)|(arg->riv[3]<<24));
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_RIV_2,
+		arg->riv[4]|(arg->riv[5]<<8)|(arg->riv[6]<<16)|(arg->riv[7]<<24));
+
+	/* ks_xor_lc128  : sw_key_1_(1-4) */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_SW_KEY_1_1,
+		(arg->ks_xor_lc128[0])|
+		(arg->ks_xor_lc128[1]<<8)|
+		(arg->ks_xor_lc128[2]<<16)|
+		(arg->ks_xor_lc128[3]<<24));
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_SW_KEY_1_2,
+		(arg->ks_xor_lc128[4])|
+		(arg->ks_xor_lc128[5]<<8)|
+		(arg->ks_xor_lc128[6]<<16)|
+		(arg->ks_xor_lc128[7]<<24));
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_SW_KEY_1_3,
+		(arg->ks_xor_lc128[8])|
+		(arg->ks_xor_lc128[9]<<8)|
+		(arg->ks_xor_lc128[10]<<16)|
+		(arg->ks_xor_lc128[11]<<24));
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_SW_KEY_1_4,
+		(arg->ks_xor_lc128[12])|
+		(arg->ks_xor_lc128[13]<<8)|
+		(arg->ks_xor_lc128[14]<<16)|
+		(arg->ks_xor_lc128[15]<<24));
+
+	/* frame_num     : frame_num_(1-2) */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_FRAME_NUM_1, (u32)arg->frame_num);
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_FRAME_NUM_2, (u32)(arg->frame_num>>32));
+
+	/* frame_num_add : frame_num_add_(1-2)	*/
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1, (u32)arg->frame_num_add);
+
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2, (u32)(arg->frame_num_add>>32));
+
+	/* data_num      : data_num */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_DATA_NUM, arg->data_num);
+
+	/* data_num_add  : data_num_add */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_HW_DATA_NUM_ADD, arg->data_num_add);
+
+	/* aes_sw_en     : hdcp_22_ctrl:aes_sw_en */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_CTRL,
+		HDMI_HDCP_2_2_CTRL_write_en3(1)|HDMI_HDCP_2_2_CTRL_aes_sw_en(1));/* always set to SW mode first */
+
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_2_2_CTRL,
+		HDMI_HDCP_2_2_CTRL_write_en3(1)|HDMI_HDCP_2_2_CTRL_aes_sw_en(arg->aes_sw_en));
+
+	/* hdcp_lib_dump_22_cipher_setting(); */
+
+}
+
+void hdcp_lib_control_22_cipher(int control_flag)
+{
+	if (control_flag == HDCP_22_CIPHER_RESUME) {
+		/* Enable HDCP22 encrypt */
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_CR,
+			HDMI_HDCP_CR_write_en4(1)|HDMI_HDCP_CR_en1_1_feature(1)|
+			HDMI_HDCP_CR_write_en1(1)|HDMI_HDCP_CR_hdcp_encryptenable(1));
+		HDCP_INFO("Enable 22 enc");
+	} else {
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_CR,
+			HDMI_HDCP_CR_write_en1(1)|HDMI_HDCP_CR_hdcp_encryptenable(0));
+		HDCP_INFO("Disable 22 enc");
+	}
+
+}
diff --git a/drivers/media/platform/rtk_hdcptx/hdcp_lib_hw.c b/drivers/media/platform/rtk_hdcptx/hdcp_lib_hw.c
new file mode 100644
index 00000000..33abcce
--- /dev/null
+++ b/drivers/media/platform/rtk_hdcptx/hdcp_lib_hw.c
@@ -0,0 +1,600 @@
+/*
+ * hdcp_lib_hw.c - RTK hdcp tx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/delay.h>
+
+#include "hdcp_top.h"
+#include "hdcp.h"
+#include "hdcp_ddc.h"
+#include "hdmitx_reg.h"
+
+static void hdcp_lib_read_an(uint8_t *an);
+static int hdcp_lib_generateKm(uint8_t *Bksv);
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_check_repeater_bit_in_tx
+ *-----------------------------------------------------------------------------
+ */
+int hdcp_lib_check_repeater_bit_in_tx(void)
+{
+	int ret_value;
+
+	ret_value = HDMI_HDCP_CR_get_downstrisrepeater(RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_CR));
+
+	return ret_value;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_read_an
+ *-----------------------------------------------------------------------------
+ */
+static void hdcp_lib_read_an(uint8_t *an)
+{
+	unsigned int temp;
+
+	/*
+	 * Convert HDCP An from bit endien to little endien
+	 * HDCP An should stored in little endien,	but HDCP HW store in big endien
+	 */
+
+	temp = RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_ANLR);/* HDCP_ANLR => An LSB */
+
+	an[0] = temp & 0x0ff;
+	an[1] = (temp >> 8) & 0xff;
+	an[2] = (temp >> 16) & 0xff;
+	an[3] = (temp >> 24) & 0xff;
+
+	temp = RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_ANMR);/* HDCP_ANMR => An MSB */
+
+	an[4] = temp & 0x0ff;
+	an[5] = (temp >> 8) & 0xff;
+	an[6] = (temp >> 16) & 0xff;
+	an[7] = (temp >> 24) & 0xff;
+
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_generate_an (Generate An using HDCP HW)
+ *-----------------------------------------------------------------------------
+ */
+int hdcp_lib_generate_an(uint8_t *an)
+{
+	int retry = 0;
+
+	/* Get An */
+	/* get An influence from CRC64 */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH,
+		HDMI_HDCP_AUTH_write_en9(0) |
+		HDMI_HDCP_AUTH_ddpken(0) |
+		HDMI_HDCP_AUTH_write_en8(0) |
+		HDMI_HDCP_AUTH_resetkmacc(0) |
+		HDMI_HDCP_AUTH_write_en7(0) |
+		HDMI_HDCP_AUTH_update_an(0) |
+		HDMI_HDCP_AUTH_write_en6(1) |
+		HDMI_HDCP_AUTH_aninfreq(1) |
+		HDMI_HDCP_AUTH_write_en5(0) |
+		HDMI_HDCP_AUTH_seedload(0) |
+		HDMI_HDCP_AUTH_write_en4(0) |
+		HDMI_HDCP_AUTH_deviceauthenticated(0) |
+		HDMI_HDCP_AUTH_write_en3(0) |
+		HDMI_HDCP_AUTH_forcetounauthenticated(0) |
+		HDMI_HDCP_AUTH_write_en2(0) |
+		HDMI_HDCP_AUTH_authcompute(0) |
+		HDMI_HDCP_AUTH_write_en1(0) |
+		HDMI_HDCP_AUTH_authrequest(0));
+
+	/* set An Influence Mode, influence will be load from AnIR0, AnIR1 */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_CR,
+		HDMI_HDCP_CR_write_en4(1) |
+		HDMI_HDCP_CR_en1_1_feature(1) |
+		HDMI_HDCP_CR_write_en3(0) |
+		HDMI_HDCP_CR_downstrisrepeater(0) |
+		HDMI_HDCP_CR_write_en2(1) |
+		HDMI_HDCP_CR_aninfluencemode(1) |
+		HDMI_HDCP_CR_write_en1(0) |
+		HDMI_HDCP_CR_hdcp_encryptenable(0));
+
+	/* trigger to get An */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH,
+		HDMI_HDCP_AUTH_write_en9(0) |
+		HDMI_HDCP_AUTH_ddpken(0) |
+		HDMI_HDCP_AUTH_write_en8(0) |
+		HDMI_HDCP_AUTH_resetkmacc(0) |
+		HDMI_HDCP_AUTH_write_en7(0) |
+		HDMI_HDCP_AUTH_update_an(0) |
+		HDMI_HDCP_AUTH_write_en6(0) |
+		HDMI_HDCP_AUTH_aninfreq(0) |
+		HDMI_HDCP_AUTH_write_en5(0) |
+		HDMI_HDCP_AUTH_seedload(0) |
+		HDMI_HDCP_AUTH_write_en4(0) |
+		HDMI_HDCP_AUTH_deviceauthenticated(0) |
+		HDMI_HDCP_AUTH_write_en3(0) |
+		HDMI_HDCP_AUTH_forcetounauthenticated(0) |
+		HDMI_HDCP_AUTH_write_en2(0) |
+		HDMI_HDCP_AUTH_authcompute(0) |
+		HDMI_HDCP_AUTH_write_en1(1) |
+		HDMI_HDCP_AUTH_authrequest(1));
+
+	/* check if An is ready */
+	while (!HDMI_HDCP_SR_get_anready(RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SR))) {
+		mdelay(100);
+
+		if (retry >= 5)
+			return -HDCP_AUTH_FAILURE;
+
+		retry++;
+	}
+
+	/*
+	 * Leave An influence mode
+	 * Set use internal rander bit generator
+	 */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_CR,
+		HDMI_HDCP_CR_write_en4(1) |
+		HDMI_HDCP_CR_en1_1_feature(1) |
+		HDMI_HDCP_CR_write_en3(0) |
+		HDMI_HDCP_CR_downstrisrepeater(0) |
+		HDMI_HDCP_CR_write_en2(1) |
+		HDMI_HDCP_CR_aninfluencemode(0) |
+		HDMI_HDCP_CR_write_en1(0) |
+		HDMI_HDCP_CR_hdcp_encryptenable(0));
+
+	hdcp_lib_read_an(an);
+
+	HDCP_DEBUG("AN1: %x %x %x %x %x %x %x %x",
+		an[0], an[1], an[2], an[3], an[4], an[5], an[6], an[7]);
+
+	return HDCP_OK;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_set_repeater_bit_in_tx
+ *-----------------------------------------------------------------------------
+ */
+void hdcp_lib_set_repeater_bit_in_tx(enum hdcp_repeater rx_mode)
+{
+	HDCP_DEBUG("hdcp_lib_set_repeater_bit_in_tx() value=%d", rx_mode);
+
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_CR,
+		HDMI_HDCP_CR_write_en4(1) |
+		HDMI_HDCP_CR_en1_1_feature(1) |
+		HDMI_HDCP_CR_write_en3(1) |
+		HDMI_HDCP_CR_downstrisrepeater(rx_mode) |
+		HDMI_HDCP_CR_write_en2(0) |
+		HDMI_HDCP_CR_aninfluencemode(0) |
+		HDMI_HDCP_CR_write_en1(0) |
+		HDMI_HDCP_CR_hdcp_encryptenable(0));
+}
+
+void hdcp_lib_set_wider_window(void)
+{
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_OWR,
+		HDMI_HDCP_OWR_write_en2(1) | HDMI_HDCP_OWR_hdcpoppwinend(526) |
+		HDMI_HDCP_OWR_write_en1(1) | HDMI_HDCP_OWR_hdcpoppwinstart(510));
+}
+
+void hdcp_lib_set_ri_interrupt(enum ri_state state)
+{
+	if (state == HDCP_RI_ON) {
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_INTEN,
+			HDMI_INTEN_enriupdint(1) |
+			HDMI_INTEN_enpjupdint(0) |
+			HDMI_INTEN_write_data(1));
+	} else {
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_INTEN,
+			HDMI_INTEN_enriupdint(0) |
+			HDMI_INTEN_enpjupdint(0) |
+			HDMI_INTEN_write_data(1));
+	}
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_set_encryption
+ *-----------------------------------------------------------------------------
+ */
+void hdcp_lib_set_encryption(enum encryption_state enc_state)
+{
+	int rx_mode;
+
+	rx_mode = hdcp_lib_check_repeater_bit_in_tx();
+
+	if (enc_state == HDCP_ENC_ON) {
+		/* set HDCP module to authenticated state */
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH,
+			HDMI_HDCP_AUTH_write_en9(0) | HDMI_HDCP_AUTH_ddpken(0) |
+			HDMI_HDCP_AUTH_write_en8(0) | HDMI_HDCP_AUTH_resetkmacc(0) |
+			HDMI_HDCP_AUTH_write_en7(0) | HDMI_HDCP_AUTH_update_an(0) |
+			HDMI_HDCP_AUTH_write_en6(0) | HDMI_HDCP_AUTH_aninfreq(0) |
+			HDMI_HDCP_AUTH_write_en5(0) | HDMI_HDCP_AUTH_seedload(0) |
+			HDMI_HDCP_AUTH_write_en4(1) | HDMI_HDCP_AUTH_deviceauthenticated(1) |
+			HDMI_HDCP_AUTH_write_en3(0) | HDMI_HDCP_AUTH_forcetounauthenticated(0) |
+			HDMI_HDCP_AUTH_write_en2(0) | HDMI_HDCP_AUTH_authcompute(0) |
+			HDMI_HDCP_AUTH_write_en1(0) | HDMI_HDCP_AUTH_authrequest(0));
+
+		/* start encryption */
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_CR,
+			HDMI_HDCP_CR_write_en4(1) | HDMI_HDCP_CR_en1_1_feature(1) |
+			HDMI_HDCP_CR_write_en3(0) | HDMI_HDCP_CR_downstrisrepeater(rx_mode) |
+			HDMI_HDCP_CR_write_en2(0) | HDMI_HDCP_CR_aninfluencemode(0) |
+			HDMI_HDCP_CR_write_en1(1) | HDMI_HDCP_CR_hdcp_encryptenable(1));
+
+	} else if (enc_state == HDCP_ENC_OFF) {
+
+		/* disable link integry check */
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_INTEN,
+			HDMI_INTEN_enriupdint(1) |
+			HDMI_INTEN_enpjupdint(1) |
+			HDMI_INTEN_write_data(0));
+
+		/* force Encryption disable */
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_CR,
+			HDMI_HDCP_CR_write_en4(1) | HDMI_HDCP_CR_en1_1_feature(1) |
+			HDMI_HDCP_CR_write_en3(0) | HDMI_HDCP_CR_downstrisrepeater(rx_mode) |
+			HDMI_HDCP_CR_write_en2(0) | HDMI_HDCP_CR_aninfluencemode(0) |
+			HDMI_HDCP_CR_write_en1(1) | HDMI_HDCP_CR_hdcp_encryptenable(0));
+
+		/* force HDCP module to unauthenticated state */
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH,
+			HDMI_HDCP_AUTH_write_en9(0) | HDMI_HDCP_AUTH_ddpken(0) |
+			HDMI_HDCP_AUTH_write_en8(0) | HDMI_HDCP_AUTH_resetkmacc(0) |
+			HDMI_HDCP_AUTH_write_en7(0) | HDMI_HDCP_AUTH_update_an(0) |
+			HDMI_HDCP_AUTH_write_en6(0) | HDMI_HDCP_AUTH_aninfreq(0) |
+			HDMI_HDCP_AUTH_write_en5(0) | HDMI_HDCP_AUTH_seedload(0) |
+			HDMI_HDCP_AUTH_write_en4(0) | HDMI_HDCP_AUTH_deviceauthenticated(0) |
+			HDMI_HDCP_AUTH_write_en3(1) | HDMI_HDCP_AUTH_forcetounauthenticated(1) |
+			HDMI_HDCP_AUTH_write_en2(0) | HDMI_HDCP_AUTH_authcompute(0) |
+			HDMI_HDCP_AUTH_write_en1(0) | HDMI_HDCP_AUTH_authrequest(0));
+
+	} else {
+		HDCP_ERROR("unknown ENC state");
+	}
+
+	if (hdcp.print_messages)
+		HDCP_DEBUG("Encryption state changed: %s HDCP_AUTH_reg: %02x",
+			enc_state == HDCP_ENC_OFF ? "OFF" : "ON",
+			RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH));
+
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_SHA_append_bstatus_M0
+ *-----------------------------------------------------------------------------
+ */
+void hdcp_lib_SHA_append_bstatus_M0(struct hdcp_sha_in *sha, uint8_t *data)
+{
+	uint32_t MILSW;
+	uint32_t MIMSW;
+
+	sha->data[sha->byte_counter++] = data[0];
+	sha->data[sha->byte_counter++] = data[1];
+
+	MILSW = RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_MILSW);
+	MIMSW = RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_MIMSW);
+
+	memcpy((void *)&sha->data[sha->byte_counter], &MILSW, sizeof(MILSW));
+	sha->byte_counter += sizeof(MILSW);
+	memcpy((void *)&sha->data[sha->byte_counter], &MIMSW, sizeof(MIMSW));
+	sha->byte_counter += sizeof(MIMSW);
+
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_compute_V
+ *-----------------------------------------------------------------------------
+ */
+int hdcp_lib_compute_V(struct hdcp_sha_in *sha)
+{
+	int blk_num = 0;
+	uint8_t sha_blk[64];
+	uint32_t sha_wd;
+	int i, j, retry = 0;
+	int sha_no_padding_len = (sha->byte_counter/32);
+	int sha_data_len_in_bit = sha->byte_counter*8;
+
+	/* calculate SHA data(w/o padding) length in byte */
+	if (sha->byte_counter & (32-1))
+		sha_no_padding_len++;
+
+	/* padding */
+	sha->data[sha->byte_counter++] = 0x80;
+	sha->data[sha->byte_counter++] = 0x0;
+
+	/* total length= Ksv list + Bstatus + M0 + padding*2 + SHA data len(bytes)	*/
+	blk_num = (sha->byte_counter + sha_no_padding_len)/SHA_BLK_SIZE;
+	if ((sha->byte_counter + sha_no_padding_len) & (SHA_BLK_SIZE-1))
+		blk_num++;
+
+	for (j = 0; j < blk_num; j++) {
+		memset(sha_blk, 0, SHA_BLK_SIZE);
+		memcpy(sha_blk, (void *)&sha->data[SHA_BLK_SIZE*j], SHA_BLK_SIZE);
+
+		/*fill data length(bits) of the last blk */
+		if (j == (blk_num-1)) {
+			for (i = 0; i < sha_no_padding_len; i++) {
+				sha_blk[SHA_BLK_SIZE-1-i] = sha_data_len_in_bit % 256;
+				sha_data_len_in_bit /= 256;
+			}
+		}
+
+		/* hdcp_lib_dump_SHA_block(sha_blk); */
+
+		/* reset pointer */
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SHACR,
+			HDMI_HDCP_SHACR_shastart(0) | HDMI_HDCP_SHACR_shafirst(0) |
+			HDMI_HDCP_SHACR_rstshaptr(1) | HDMI_HDCP_SHACR_write_data(1));
+
+		/* 16 = SHA_BLK_SIZE/word */
+		for (i = 0; i < 16; i++) {
+			sha_wd = (sha_blk[4*i+0]<<24) | (sha_blk[4*i+1]<<16) |
+				(sha_blk[4*i+2]<<8) | (sha_blk[4*i+3]<<0);/* change endian */
+
+			HDCP_DEBUG("sha_blk[%2d,%2d,%2d,%2d]= %2x %2x %2x %2x, sha_wd=%x\n",
+				4*i+0, 4*i+1, 4*i+2, 4*i+3,
+				sha_blk[4*i+0], sha_blk[4*i+1], sha_blk[4*i+2], sha_blk[4*i+3],
+				sha_wd);
+			/* push first 512bits data */
+			WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SHADR, HDMI_HDCP_SHADR_sha_data(sha_wd));
+			/* wait hardware */
+			udelay(1);
+		}
+
+		if (j == 0) {
+			WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SHACR,
+				HDMI_HDCP_SHACR_shastart(1) | HDMI_HDCP_SHACR_shafirst(1) |
+				HDMI_HDCP_SHACR_rstshaptr(0) | HDMI_HDCP_SHACR_write_data(1));/* set first and start */
+		} else {
+			WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SHACR,
+				HDMI_HDCP_SHACR_shastart(0) | HDMI_HDCP_SHACR_shafirst(1) |
+				HDMI_HDCP_SHACR_rstshaptr(0) | HDMI_HDCP_SHACR_write_data(0));/* reset first bit */
+
+			WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SHACR,
+				HDMI_HDCP_SHACR_shastart(1) | HDMI_HDCP_SHACR_shafirst(0) |
+				HDMI_HDCP_SHACR_rstshaptr(0) | HDMI_HDCP_SHACR_write_data(1));/*set start */
+		}
+		/* wait hardware */
+		udelay(5);
+	}
+
+	/* wait for ready */
+	while (!HDMI_HDCP_SHARR_get_shaready(RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SHARR))) {
+		udelay(1);
+		if (retry >= 20) {
+			HDCP_ERROR("2rd step authentication : compute V failed\n");
+			return -HDCP_SHA1_ERROR;
+		}
+		retry++;
+	}
+
+	HDCP_INFO("2rd step authentication : compute V is done\n");
+
+	return HDCP_OK;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_verify_V
+ *-----------------------------------------------------------------------------
+ */
+int hdcp_lib_verify_V(struct hdcp_sha_in *sha)
+{
+	int i;
+	int retry;
+	uint32_t data;
+
+	retry = 0;
+	for (i = 0; i < SHA1_HASH_SIZE; i++) {
+		memcpy(&data, (void *)&sha->vprime[4*i], sizeof(data));
+		HDCP_DEBUG("2rd step authentication : v data=%x", data);
+		/* should not swap */
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SHADR, HDMI_HDCP_SHADR_sha_data(data));
+	}
+
+	/* wait for ready */
+	while (!HDMI_HDCP_SHARR_get_shaready(RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SHARR))) {
+
+		mdelay(100);
+		if (retry >= 30) {
+			HDCP_ERROR("2rd step authentication : timeout of shaready;verify V failed\n");
+			return -HDCP_SHA1_ERROR;
+		}
+		retry++;
+	}
+
+	if (HDMI_HDCP_SHARR_get_vmatch(RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SHARR))) {
+		HDCP_INFO("2rd step authentication : verify V passed");
+		return HDCP_OK;
+	} else {
+		HDCP_ERROR("2rd step authentication : verify V failed");
+		return -HDCP_SHA1_ERROR;
+	}
+
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_generateKm
+ *-----------------------------------------------------------------------------
+ */
+static int hdcp_lib_generateKm(uint8_t *Bksv)
+{
+	int i, j;
+	int key0 = 0, key1 = 0;
+	unsigned char DK1, DK2, DK3, DK4, DK5, DK6, DK7;
+	int retry = 0;
+
+	if (hdcp.hdcp_enabled == 0)
+		return -HDCP_CANCELLED_AUTH;
+
+	for (i = 0; i < 5; i++) {
+		for (j = 0; j < 8; j++) {
+			if (Bksv[i] & (1<<j)) {
+
+				DK1 = hdcp.en_ctrl->PK[i*56+j*7];
+				DK2 = hdcp.en_ctrl->PK[i*56+j*7+1];
+				DK3 = hdcp.en_ctrl->PK[i*56+j*7+2];
+				DK4 = hdcp.en_ctrl->PK[i*56+j*7+3];
+				DK5 = hdcp.en_ctrl->PK[i*56+j*7+4];
+				DK6 = hdcp.en_ctrl->PK[i*56+j*7+5];
+				DK7 = hdcp.en_ctrl->PK[i*56+j*7+6];
+				key1 = DK7&0x0ff;
+				key1 = (key1<<8)|DK6;
+				key1 = (key1<<8)|DK5;
+				key1 = (key1<<8)|DK4;
+				key0 = DK3&0x0ff;
+				key0 = (key0<<8)|DK2;
+				key0 = (key0<<8)|DK1;
+
+				/* write to HW */
+				WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_DPKLR,
+					HDMI_HDCP_DPKLR_ddpklsb24(key0) |
+					HDMI_HDCP_DPKLR_dpkencpnt(0x55));
+				WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_DPKMR,
+					HDMI_HDCP_DPKMR_ddpkmsw(key1));
+
+				/* trigger accumulation */
+				WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH,
+					HDMI_HDCP_AUTH_write_en9(1) |
+					HDMI_HDCP_AUTH_ddpken(1) |
+					HDMI_HDCP_AUTH_write_en8(0) |
+					HDMI_HDCP_AUTH_resetkmacc(0) |
+					HDMI_HDCP_AUTH_write_en7(0) |
+					HDMI_HDCP_AUTH_update_an(0) |
+					HDMI_HDCP_AUTH_write_en6(0) |
+					HDMI_HDCP_AUTH_aninfreq(0) |
+					HDMI_HDCP_AUTH_write_en5(0) |
+					HDMI_HDCP_AUTH_seedload(0) |
+					HDMI_HDCP_AUTH_write_en4(0) |
+					HDMI_HDCP_AUTH_deviceauthenticated(0) |
+					HDMI_HDCP_AUTH_write_en3(0) |
+					HDMI_HDCP_AUTH_forcetounauthenticated(0) |
+					HDMI_HDCP_AUTH_write_en2(0) |
+					HDMI_HDCP_AUTH_authcompute(0) |
+					HDMI_HDCP_AUTH_write_en1(0) |
+					HDMI_HDCP_AUTH_authrequest(0));
+
+				/* wait HW accumulation */
+				while (!HDMI_HDCP_SR_get_curdpkaccdone(RD_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_SR)))
+					retry++;
+
+			}
+		}
+	}
+
+	return HDCP_OK;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_write_bksv
+ *-----------------------------------------------------------------------------
+ */
+int hdcp_lib_write_bksv(uint8_t *ksv_data)
+{
+	int status = HDCP_OK;
+
+	/* force Encryption disable */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_CR,
+		HDMI_HDCP_CR_write_en4(1) |
+		HDMI_HDCP_CR_en1_1_feature(1) |
+		HDMI_HDCP_CR_write_en3(0) |
+		HDMI_HDCP_CR_downstrisrepeater(0) |
+		HDMI_HDCP_CR_write_en2(0) |
+		HDMI_HDCP_CR_aninfluencemode(0) |
+		HDMI_HDCP_CR_write_en1(1) |
+		HDMI_HDCP_CR_hdcp_encryptenable(0));
+
+	/* reset Km accumulation */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH,
+		HDMI_HDCP_AUTH_write_en9(0) |
+		HDMI_HDCP_AUTH_ddpken(0) |
+		HDMI_HDCP_AUTH_write_en8(1) |
+		HDMI_HDCP_AUTH_resetkmacc(1) |
+		HDMI_HDCP_AUTH_write_en7(0) |
+		HDMI_HDCP_AUTH_update_an(0) |
+		HDMI_HDCP_AUTH_write_en6(0) |
+		HDMI_HDCP_AUTH_aninfreq(0) |
+		HDMI_HDCP_AUTH_write_en5(0) |
+		HDMI_HDCP_AUTH_seedload(0) |
+		HDMI_HDCP_AUTH_write_en4(0) |
+		HDMI_HDCP_AUTH_deviceauthenticated(0) |
+		HDMI_HDCP_AUTH_write_en3(0) |
+		HDMI_HDCP_AUTH_forcetounauthenticated(0) |
+		HDMI_HDCP_AUTH_write_en2(0) |
+		HDMI_HDCP_AUTH_authcompute(0) |
+		HDMI_HDCP_AUTH_write_en1(0) |
+		HDMI_HDCP_AUTH_authrequest(0));
+
+	status = hdcp_lib_generateKm(ksv_data);
+	if (status != HDCP_OK)
+		return status;
+
+	/* disable Ri update interrupt */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_INTEN,
+		HDMI_INTEN_enriupdint(1) |
+		HDMI_INTEN_enpjupdint(0) |
+		HDMI_INTEN_write_data(0));
+
+	/* clear Ri updated pending bit */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_INTST,
+		HDMI_INTST_riupdated(0) | HDMI_INTST_pjupdated(0));
+
+	/* trigger hdcpBlockCipher at authentication */
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_HDCP_AUTH,
+		HDMI_HDCP_AUTH_write_en9(0) |
+		HDMI_HDCP_AUTH_ddpken(0) |
+		HDMI_HDCP_AUTH_write_en8(0) |
+		HDMI_HDCP_AUTH_resetkmacc(0) |
+		HDMI_HDCP_AUTH_write_en7(0) |
+		HDMI_HDCP_AUTH_update_an(0) |
+		HDMI_HDCP_AUTH_write_en6(0) |
+		HDMI_HDCP_AUTH_aninfreq(0) |
+		HDMI_HDCP_AUTH_write_en5(0) |
+		HDMI_HDCP_AUTH_seedload(0) |
+		HDMI_HDCP_AUTH_write_en4(0) |
+		HDMI_HDCP_AUTH_deviceauthenticated(0) |
+		HDMI_HDCP_AUTH_write_en3(0) |
+		HDMI_HDCP_AUTH_forcetounauthenticated(0) |
+		HDMI_HDCP_AUTH_write_en2(1) |
+		HDMI_HDCP_AUTH_authcompute(1) |
+		HDMI_HDCP_AUTH_write_en1(0) |
+		HDMI_HDCP_AUTH_authrequest(0));
+
+	return status;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_set_av_mute
+ *-----------------------------------------------------------------------------
+ */
+void hdcp_lib_set_av_mute(enum av_mute av_mute_state)
+{
+	/* spin_lock_irqsave(&hdcp.spinlock, flags); */
+
+	if (av_mute_state == AV_MUTE_SET) {
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_GCPCR,
+			HDMI_GCPCR_enablegcp(1) | HDMI_GCPCR_gcp_clearavmute(1) |
+			HDMI_GCPCR_gcp_setavmute(1) | HDMI_GCPCR_write_data(0));
+
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_GCPCR,
+			HDMI_GCPCR_enablegcp(1) | HDMI_GCPCR_gcp_clearavmute(0) |
+			HDMI_GCPCR_gcp_setavmute(1) | HDMI_GCPCR_write_data(1));
+	} else if (av_mute_state == AV_MUTE_CLEAR) {
+		WR_REG_32(hdcp.hdcp_base_addr, HDMI_GCPCR,
+			HDMI_GCPCR_enablegcp(1) | HDMI_GCPCR_gcp_clearavmute(1) |
+			HDMI_GCPCR_gcp_setavmute(1) | HDMI_GCPCR_write_data(0));
+
+			WR_REG_32(hdcp.hdcp_base_addr, HDMI_GCPCR,
+				HDMI_GCPCR_enablegcp(1) | HDMI_GCPCR_gcp_clearavmute(1) |
+				HDMI_GCPCR_gcp_setavmute(0) | HDMI_GCPCR_write_data(1));
+	} else {
+			HDCP_ERROR("unknown av mute parameter\n");
+	}
+	/* spin_unlock_irqrestore(&hdcp.spinlock, flags); */
+
+}
+
diff --git a/drivers/media/platform/rtk_hdcptx/hdcp_lib_hw.h b/drivers/media/platform/rtk_hdcptx/hdcp_lib_hw.h
new file mode 100644
index 00000000..659b0eb
--- /dev/null
+++ b/drivers/media/platform/rtk_hdcptx/hdcp_lib_hw.h
@@ -0,0 +1,56 @@
+/*
+ * hdcp_lib_hw.h - RTK hdcp tx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifdef CONFIG_RTK_HDCP_1x_TEE
+
+extern void ta_hdcp14_init(void);
+extern void ta_hdcp14_deinit(void);
+extern int ta_hdcp_lib_check_repeater_bit_in_tx(void);
+extern int ta_hdcp_lib_generate_an(uint8_t *an);
+extern void ta_hdcp_lib_set_repeater_bit_in_tx(enum hdcp_repeater rx_mode);
+extern void ta_hdcp_lib_set_wider_window(void);
+extern void ta_hdcp_lib_set_ri(enum ri_state ri_state);
+extern void ta_hdcp_lib_set_encryption(enum encryption_state enc_state);
+extern int ta_hdcp_lib_SHA_append_bstatus_M0(struct hdcp_sha_in *sha, uint8_t *bstatus);
+extern int ta_hdcp_lib_compute_V(struct hdcp_sha_in *sha);
+extern int ta_hdcp_lib_verify_V(struct hdcp_sha_in *sha);
+extern void ta_hdcp_lib_set_av_mute(enum av_mute av_mute_state);
+extern int ta_hdcp_lib_write_bksv(uint8_t *ksv_data);
+extern int ta_hdcp_set_param_key(unsigned char *param_key);
+
+#define hdcp_lib_check_repeater_bit_in_tx(arg) ta_hdcp_lib_check_repeater_bit_in_tx(arg)
+#define hdcp_lib_generate_an(arg) ta_hdcp_lib_generate_an(arg)
+#define hdcp_lib_set_repeater_bit_in_tx(arg) ta_hdcp_lib_set_repeater_bit_in_tx(arg)
+#define hdcp_lib_set_wider_window(arg) ta_hdcp_lib_set_wider_window(arg)
+#define hdcp_lib_set_ri_interrupt(arg) ta_hdcp_lib_set_ri(arg)
+#define hdcp_lib_set_encryption(arg) ta_hdcp_lib_set_encryption(arg)
+#define hdcp_lib_SHA_append_bstatus_M0(arg1, arg2) ta_hdcp_lib_SHA_append_bstatus_M0(arg1, arg2)
+#define hdcp_lib_compute_V(arg) ta_hdcp_lib_compute_V(arg)
+#define hdcp_lib_verify_V(arg) ta_hdcp_lib_verify_V(arg)
+#define hdcp_lib_write_bksv(arg) ta_hdcp_lib_write_bksv(arg)
+#define hdcp_lib_set_av_mute(arg) ta_hdcp_lib_set_av_mute(arg)
+
+#else
+
+int hdcp_lib_check_repeater_bit_in_tx(void);
+int hdcp_lib_generate_an(uint8_t *an);
+void hdcp_lib_set_repeater_bit_in_tx(enum hdcp_repeater rx_mode);
+void hdcp_lib_set_wider_window(void);
+void hdcp_lib_set_ri_interrupt(enum ri_state state);
+void hdcp_lib_set_encryption(enum encryption_state enc_state);
+void hdcp_lib_SHA_append_bstatus_M0(struct hdcp_sha_in *sha, uint8_t *data);
+int hdcp_lib_compute_V(struct hdcp_sha_in *sha);
+int hdcp_lib_verify_V(struct hdcp_sha_in *sha);
+int hdcp_lib_write_bksv(uint8_t *ksv_data);
+void hdcp_lib_set_av_mute(enum av_mute av_mute_state);
+
+#endif
+
diff --git a/drivers/media/platform/rtk_hdcptx/hdcp_top.c b/drivers/media/platform/rtk_hdcptx/hdcp_top.c
new file mode 100644
index 00000000..8b1a140
--- /dev/null
+++ b/drivers/media/platform/rtk_hdcptx/hdcp_top.c
@@ -0,0 +1,1014 @@
+/*
+ * hdcp_top.c - RTK hdcp tx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/uaccess.h>
+#include <linux/delay.h>
+#include <linux/wait.h>
+#include <linux/sched.h>
+
+#include <linux/miscdevice.h>
+#include <linux/firmware.h>
+#include <linux/i2c.h>
+#include <linux/interrupt.h>
+
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+
+#include "hdcp.h"
+
+#include "hdmitx_reg.h"
+#include "hdcp_top.h"
+#include "hdcp_lib_hw.h"
+
+struct hdcp hdcp;
+struct hdcp_sha_in sha_input;
+struct hdcp_ksvlist_info ksvlist_info;
+
+static int hdcp_wait_re_entrance;
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+/* RX function, for HDCP repeater*/
+extern void HdmiRx_disable_bcaps_ready(void);
+extern void HdmiRx_save_tx_ksv(struct hdcp_ksvlist_info *tx_ksv);
+#endif
+
+/* State machine / workqueue */
+static void hdcp_wq_start_authentication(void);
+static void hdcp_wq_check_r0(void);
+static void hdcp_wq_step2_authentication(void);
+static void hdcp_wq_authentication_failure(void);
+static void hdcp_work_queue(struct work_struct *work);
+static struct delayed_work *hdcp_submit_work(int event, int delay);
+static void hdcp_cancel_work(struct delayed_work **work);
+
+/* Control */
+static long hdcp_enable_ctl(void __user *argp);
+static long hdcp_disable_ctl(void);
+static long hdcp_query_status_ctl(void __user *argp);
+
+
+/* Driver */
+static int __init hdcp_init(void);
+static void __exit hdcp_exit(void);
+
+
+static DECLARE_WAIT_QUEUE_HEAD(hdcp_up_wait_queue);
+static DECLARE_WAIT_QUEUE_HEAD(hdcp_down_wait_queue);
+
+void hdcp_set_state(struct miscdevice *pdev, int state);
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+//void HdmiRx_save_hdcp2p2_repeater_state(struct H2_RepeaterAuthSendRxIdList_PayLoad *repeater_info);
+#endif
+
+struct miscdevice mdev;
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_wq_start_authentication
+ *-----------------------------------------------------------------------------
+ */
+static void hdcp_wq_start_authentication(void)
+{
+	int status = HDCP_OK;
+
+	hdcp.hdcp_state = HDCP_AUTHENTICATION_START;
+	hdcp.auth_state = HDCP_STATE_INIT;
+	hdcp_set_state(&mdev, hdcp.auth_state);
+
+	if (hdcp.print_messages)
+		HDCP_INFO("Authentication start");
+
+	/* Step 1 part 1 (until R0 calc delay) */
+	status = hdcp_lib_step1_start();
+
+	if (status == -HDCP_AKSV_ERROR) {
+		hdcp_wq_authentication_failure();
+	} else if (status == -HDCP_CANCELLED_AUTH) {
+		HDCP_ERROR("Authentication step 1 cancelled");
+		return;
+	} else if (status != HDCP_OK) {
+		hdcp_wq_authentication_failure();
+	} else {
+		hdcp.hdcp_state = HDCP_WAIT_R0_DELAY;
+		hdcp.auth_state = HDCP_STATE_AUTH_1ST_STEP;
+		hdcp.pending_wq_event = hdcp_submit_work(HDCP_R0_EXP_EVENT, HDCP_R0_DELAY);
+	}
+
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_wq_check_r0
+ *-----------------------------------------------------------------------------
+ */
+static void hdcp_wq_check_r0(void)
+{
+	int status = hdcp_lib_step1_r0_check();
+
+	if (status == -HDCP_CANCELLED_AUTH) {
+		HDCP_ERROR("Authentication step 1/R0 cancelled.");
+		return;
+	} else if (status < 0) {
+		hdcp_wq_authentication_failure();
+	} else {
+		hdcp.fail_cnt = 0;
+		hdcp.print_messages = 1;
+		if (hdcp_lib_check_repeater_bit_in_tx()) {
+			/* Repeater */
+			HDCP_INFO("authentication step 1 successful - Repeater");
+
+			hdcp.hdcp_state = HDCP_WAIT_KSV_LIST;
+			hdcp.auth_state = HDCP_STATE_AUTH_2ND_STEP;
+			hdcp.pending_wq_event =
+				hdcp_submit_work(HDCP_KSV_LIST_RDY_EVENT, 500);
+		} else {
+			/* Receiver */
+			HDCP_INFO("authentication step 1 successful - Receiver");
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+			ksvlist_info.device_count = 0;
+			ksvlist_info.bstatus[0] = 0;
+			ksvlist_info.bstatus[1] = 0;
+			HdmiRx_save_tx_ksv(&ksvlist_info);
+#endif
+			/* hdcp.av_mute_needed = 1; */
+			hdcp.hdcp_state = HDCP_LINK_INTEGRITY_CHECK;
+			hdcp.auth_state = HDCP_STATE_AUTH_3RD_STEP;
+			hdcp_set_state(&mdev, hdcp.auth_state);
+
+			/* Restore retry counter */
+			if (hdcp.en_ctrl->nb_retry == 0)
+				hdcp.retry_cnt = HDCP_INFINITE_REAUTH;
+			else
+				hdcp.retry_cnt = hdcp.en_ctrl->nb_retry;
+		}
+	}
+
+}
+
+static void hdcp_wq_auto_check_r0(void)
+{
+	int status;
+
+	status = hdcp_lib_r0_check();
+	if (status == -HDCP_CANCELLED_AUTH) {
+		HDCP_ERROR("Authentication step 3 cancelled.");
+		return;
+	} else if (status < 0) {
+		hdcp_wq_authentication_failure();
+	} else {
+		hdcp.fail_cnt = 0;
+		hdcp.print_messages = 1;
+
+		/* Receiver */
+		HDCP_DEBUG("hdcp_wq_auto_check_r0 successful - %s",
+			hdcp_lib_check_repeater_bit_in_tx() ? "Repeater" : "Receiver");
+
+		/* hdcp.av_mute_needed = 1; */
+		hdcp.hdcp_state = HDCP_LINK_INTEGRITY_CHECK;
+		hdcp.auth_state = HDCP_STATE_AUTH_3RD_STEP;
+	}
+
+}
+
+irqreturn_t HDCP_interrupt_handler(int irq, void *dev_id)
+{
+	if (HDMI_INTST_get_riupdated(RD_REG_32(hdcp.hdcp_base_addr, HDMI_INTST))) {
+		hdcp.hdcp_state = HDCP_LINK_INTEGRITY_CHECK;
+		hdcp_submit_work(HDCP_START_FRAME_EVENT, 0);
+	}
+
+	WR_REG_32(hdcp.hdcp_base_addr, HDMI_INTST, 0);
+
+	return IRQ_HANDLED;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_wq_step2_authentication
+ *-----------------------------------------------------------------------------
+ */
+static void hdcp_wq_step2_authentication(void)
+{
+	int status = HDCP_OK;
+
+	HDCP_DEBUG("[%s] %s  %d :%u", __FILE__, __func__, __LINE__, jiffies_to_msecs(jiffies));
+
+	/* KSV list timeout is running and should be canceled */
+	hdcp_cancel_work(&hdcp.pending_wq_event);
+
+	status = hdcp_lib_step2();
+
+	if (status == -HDCP_CANCELLED_AUTH) {
+		HDCP_ERROR("Authentication step 2 cancelled.");
+		return;
+	} else if (status < 0) {
+		hdcp_wq_authentication_failure();
+	} else {
+		HDCP_INFO("Repeater authentication step 2 successful");
+
+		/* hdcp.av_mute_needed = 1; */
+		hdcp.hdcp_state = HDCP_LINK_INTEGRITY_CHECK;
+		hdcp.auth_state = HDCP_STATE_AUTH_3RD_STEP;
+		hdcp_set_state(&mdev, hdcp.auth_state);
+
+		/* Restore retry counter */
+		if (hdcp.en_ctrl->nb_retry == 0)
+			hdcp.retry_cnt = HDCP_INFINITE_REAUTH;
+		else
+			hdcp.retry_cnt = hdcp.en_ctrl->nb_retry;
+	}
+
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_wq_authentication_failure
+ *-----------------------------------------------------------------------------
+ */
+static void hdcp_wq_authentication_failure(void)
+{
+	if (hdcp.hdmi_state == HDMI_STOPPED) {
+		hdcp.auth_state = HDCP_STATE_AUTH_FAILURE;
+		hdcp_set_state(&mdev, hdcp.auth_state);
+		return;
+	} else if ((hdcp.hdcp_state == HDCP_DISABLED) && (hdcp.auth_state == HDCP_STATE_DISABLED)) {
+		HDCP_INFO("Already disabled, skip failure process");
+		return;
+	}
+
+	hdcp_lib_auto_ri_check(false);
+
+	if (hdcp.av_mute_needed)
+		hdcp_lib_set_av_mute(AV_MUTE_SET);
+
+	hdcp_lib_set_encryption(HDCP_ENC_OFF);
+
+	hdcp_cancel_work(&hdcp.pending_wq_event);
+
+	if (hdcp.retry_cnt && (hdcp.hdmi_state != HDMI_STOPPED)) {
+
+		if (hdcp.retry_cnt < HDCP_INFINITE_REAUTH) {
+			hdcp.retry_cnt--;
+			HDCP_ERROR("authentication failed - retrying, attempts=%d", hdcp.retry_cnt);
+		} else {
+			hdcp.fail_cnt++;
+			if (hdcp.print_messages) {
+
+				if (hdcp.fail_cnt < HDCP_MAX_FAIL_MESSAGES) {
+					HDCP_ERROR("authentication failed - retrying");
+				} else {
+					hdcp.print_messages = 0;
+					HDCP_ERROR(" authentication failed %d consecutive times", hdcp.fail_cnt);
+					HDCP_ERROR(" will keep trying but silencing logs until hotplug or success");
+				}
+			}
+		}
+
+		hdcp.hdcp_state = HDCP_AUTHENTICATION_START;
+		hdcp.auth_state = HDCP_STATE_AUTH_FAIL_RESTARTING;
+
+		hdcp.pending_wq_event =
+			hdcp_submit_work(HDCP_AUTH_REATT_EVENT, hdcp.reauth_delay);
+
+		if (hdcp.reauth_delay == 0)
+			hdcp.reauth_delay = 100;
+		else if (hdcp.reauth_delay < 1600)
+			hdcp.reauth_delay = hdcp.reauth_delay * 2;
+
+	} else {
+		HDCP_ERROR("authentication failed -HDCP disabled\n");
+		hdcp.hdcp_state = HDCP_ENABLE_PENDING;
+		hdcp.auth_state = HDCP_STATE_AUTH_FAILURE;
+		hdcp_set_state(&mdev, hdcp.auth_state);
+	}
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+	HdmiRx_disable_bcaps_ready();
+#endif
+	/* hdcp_set_state(&mdev, hdcp.auth_state); */
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_work_queue
+ *-----------------------------------------------------------------------------
+ */
+static void hdcp_work_queue(struct work_struct *work)
+{
+	struct hdcp_delayed_work *hdcp_w = container_of(work, struct hdcp_delayed_work, work.work);
+	int event = hdcp_w->event;
+
+	mutex_lock(&hdcp.lock);
+
+	HDCP_DEBUG("hdcp_work_queue() - START - %u hdmi=%d hdcp=%d auth=%d evt= %x %d",
+		jiffies_to_msecs(jiffies),
+		hdcp.hdmi_state,
+		hdcp.hdcp_state,
+		hdcp.auth_state,
+		(event & 0xFF00) >> 8,
+		event & 0xFF);
+
+	/*
+	 * Clear pending_wq_event
+	 * In case a delayed work is scheduled from the state machine
+	 * "pending_wq_event" is used to memorize pointer on the event to be
+	 * able to cancel any pending work in case HDCP is disabled
+	 */
+	if (event & HDCP_WORKQUEUE_SRC)
+		hdcp.pending_wq_event = 0;
+
+	/* First handle HDMI state */
+	if (event == HDCP_START_FRAME_EVENT) {
+		hdcp.pending_start = 0;
+		hdcp.hdmi_state = HDMI_STARTED;
+	}
+
+	if (event == HDCP_DISABLE_CTL)  {
+		hdcp.retry_cnt = 0;
+		hdcp_wq_authentication_failure();
+	}
+
+	/* HDCP state machine */
+	switch (hdcp.hdcp_state) {
+	case HDCP_DISABLED:
+		/* HDCP enable control or re-authentication event */
+		if (event == HDCP_ENABLE_CTL) {
+
+			if (hdcp.en_ctrl->nb_retry == 0)
+				hdcp.retry_cnt = HDCP_INFINITE_REAUTH;
+			else
+				hdcp.retry_cnt = hdcp.en_ctrl->nb_retry;
+
+			if (hdcp.hdmi_state == HDMI_STARTED)
+				hdcp_wq_start_authentication();
+			else
+				hdcp.hdcp_state = HDCP_ENABLE_PENDING;
+		}
+		break;
+
+	case HDCP_ENABLE_PENDING:
+		/* HDMI start frame event */
+		if (event == HDCP_START_FRAME_EVENT)
+			hdcp_wq_start_authentication();
+		break;
+
+	case HDCP_AUTHENTICATION_START:
+		/* Re-authentication */
+		if (event == HDCP_AUTH_REATT_EVENT)
+			hdcp_wq_start_authentication();
+		break;
+
+	case HDCP_WAIT_R0_DELAY:
+		/* R0 timer elapsed */
+		if (event == HDCP_R0_EXP_EVENT)
+			hdcp_wq_check_r0();
+		break;
+
+	case HDCP_WAIT_KSV_LIST:
+
+		if (event == HDCP_RI_FAIL_EVENT) {
+			/* Ri failure */
+			HDCP_ERROR("Ri check failure");
+			hdcp_wq_authentication_failure();
+		} else if (event == HDCP_KSV_LIST_RDY_EVENT) {
+			/* KSV list ready event */
+			hdcp_wq_step2_authentication();
+		} else if (event == HDCP_KSV_TIMEOUT_EVENT) {
+			/* Timeout */
+			HDCP_ERROR("BCAPS polling timeout\n");
+			hdcp_wq_authentication_failure();
+		}
+		break;
+
+	case HDCP_LINK_INTEGRITY_CHECK:
+		hdcp_wq_auto_check_r0();
+		/* Ri failure */
+		if (event == HDCP_RI_FAIL_EVENT) {
+			HDCP_ERROR("Ri check failure\n");
+			hdcp_wq_authentication_failure();
+		}
+		break;
+
+	default:
+		HDCP_ERROR("error - unknow HDCP state\n");
+		break;
+	} /* end of switch (hdcp.hdcp_state) */
+
+	kfree(hdcp_w);
+	hdcp_w = 0;
+	if (event == HDCP_START_FRAME_EVENT)
+		hdcp.pending_start = 0;
+
+	if (event == HDCP_KSV_LIST_RDY_EVENT || event == HDCP_R0_EXP_EVENT)
+		hdcp.pending_wq_event = 0;
+
+	HDCP_DEBUG("hdcp_work_queue() - END - %u hdmi=%d hdcp=%d auth=%d evt=%x %d ",
+		jiffies_to_msecs(jiffies),
+		hdcp.hdmi_state,
+		hdcp.hdcp_state,
+		hdcp.auth_state,
+		(event & 0xFF00) >> 8,
+		event & 0xFF);
+
+	mutex_unlock(&hdcp.lock);
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_submit_work
+ *-----------------------------------------------------------------------------
+ */
+static struct delayed_work *hdcp_submit_work(int event, int delay)
+{
+	struct hdcp_delayed_work *work;
+
+	if (hdcp.hdcp_enabled == 0) {
+		HDCP_INFO("Cancel submit work because hdcp_enabled is 0");
+		return 0;
+	}
+
+	work = kmalloc(sizeof(struct hdcp_delayed_work), GFP_ATOMIC);
+
+	if (work) {
+		INIT_DELAYED_WORK(&work->work, hdcp_work_queue);
+		work->event = event;
+		queue_delayed_work(hdcp.workqueue,
+			&work->work, msecs_to_jiffies(delay));
+	} else {
+		HDCP_ERROR("Cannot allocate memory to create work");
+		return 0;
+	}
+
+	return &work->work;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_cancel_work
+ *-----------------------------------------------------------------------------
+ */
+static void hdcp_cancel_work(struct delayed_work **work)
+{
+	int ret = 0;
+
+	if (*work) {
+		ret = cancel_delayed_work(*work);
+
+		if (ret != 1) {
+			ret = cancel_work_sync(&((*work)->work));
+			HDCP_ERROR("Canceling work failed - cancel_work_sync done %d", ret);
+		}
+
+		kfree(*work);
+		*work = 0;
+	}
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_enable_ctl
+ *-----------------------------------------------------------------------------
+ */
+static long hdcp_enable_ctl(void __user *argp)
+{
+	hdcp.hdcp_enabled = 1;
+
+	if (hdcp.en_ctrl == 0) {
+		hdcp.en_ctrl = kmalloc(sizeof(struct hdcp_enable_control), GFP_KERNEL);
+
+		if (hdcp.en_ctrl == 0) {
+			HDCP_ERROR("Cannot allocate memory for HDCP enable control struct");
+			return -EFAULT;
+		}
+	}
+
+	if (copy_from_user(hdcp.en_ctrl, argp, sizeof(struct hdcp_enable_control))) {
+		HDCP_ERROR("Error copying from user space - enable ioctl");
+		return -EFAULT;
+	}
+
+	/* Post event to workqueue */
+	if (hdcp_submit_work(HDCP_ENABLE_CTL, 0) == 0)
+		return -EFAULT;
+
+	return 0;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_disable_ctl
+ *-----------------------------------------------------------------------------
+ */
+static long hdcp_disable_ctl(void)
+{
+	HDCP_DEBUG("[%s] %s  %d :%u\n", __FILE__, __FUNCTION__, __LINE__, jiffies_to_msecs(jiffies));
+
+	hdcp.hdcp_enabled = 0;
+
+	hdcp_cancel_work(&hdcp.pending_start);
+	hdcp_cancel_work(&hdcp.pending_wq_event);
+
+	hdcp_lib_auto_ri_check(false);
+
+	hdcp_lib_set_encryption(HDCP_ENC_OFF);
+
+	/* Variable init */
+	/* hdcp.en_ctrl  = 0; */
+	hdcp.hdcp_state = HDCP_DISABLED;
+	hdcp.pending_start = 0;
+	hdcp.pending_wq_event = 0;
+	hdcp.retry_cnt = 0;
+	hdcp.reauth_delay = 0;
+	hdcp.auth_state = HDCP_STATE_DISABLED;
+	hdcp.hdcp_up_event = 0;
+	hdcp.hdcp_down_event = 0;
+	hdcp_wait_re_entrance = 0;
+	hdcp.hpd_low = 0;
+	hdcp.hdmi_state = HDMI_STARTED;
+
+	return 0;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_query_status_ctl
+ *-----------------------------------------------------------------------------
+ */
+static long hdcp_query_status_ctl(void __user *argp)
+{
+	uint32_t status;
+
+	HDCP_DEBUG("[%s] %s  %d :%u", __FILE__, __func__, __LINE__, jiffies_to_msecs(jiffies));
+
+	status = hdcp.auth_state;
+
+	if (copy_to_user(argp, &status, sizeof(status))) {
+		HDCP_ERROR("%s:failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+	return 0;
+}
+
+
+static long hdcp_query_sink_hdcp_capable_ctl(void __user *argp)
+{
+	uint32_t hdcp_capable;
+
+	HDCP_DEBUG("[%s] %s  %d :%u", __FILE__, __func__, __LINE__, jiffies_to_msecs(jiffies));
+
+	if (hdcp_lib_query_sink_hdcp_capable()) {
+		hdcp_set_state(&mdev, hdcp.auth_state);
+		hdcp_capable = HDCP_INCAPABLE;
+		HDCP_INFO("[%s] HDCP_INCAPABLE, auth_state(%d)", __func__, hdcp.auth_state);
+	} else {
+		hdcp_capable = HDCP_CAPABLE;
+	}
+
+	if (copy_to_user(argp, &hdcp_capable, sizeof(hdcp_capable))) {
+		HDCP_ERROR("%s:failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+	return 0;
+}
+
+static long hdcp_get_downstream_KSVlist_ctl(void __user *argp)
+{
+	HDCP_DEBUG("[%s] %s  %d :%u", __FILE__, __func__, __LINE__, jiffies_to_msecs(jiffies));
+
+	if (copy_to_user(argp, &ksvlist_info, sizeof(struct hdcp_ksvlist_info))) {
+		HDCP_DEBUG("[%s]ksvlist info failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+	return 0;
+}
+
+static long hdcp_set_22_cipher_ctl(void __user *argp)
+{
+	struct HDCP_22_CIPHER_INFO cipher_info;
+
+	HDCP_DEBUG("[%s] %s  %d :%u", __FILE__, __func__, __LINE__, jiffies_to_msecs(jiffies));
+
+	if (copy_from_user(&cipher_info, argp, sizeof(cipher_info))) {
+		HDCP_DEBUG("[%s]failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+
+	hdcp_lib_set_22_cipher(&cipher_info);
+
+	return 0;
+}
+
+static long hdcp_control_22_cipher_ctl(void __user *argp)
+{
+	int flag;
+
+	HDCP_DEBUG("[%s] %s  %d :%u", __FILE__, __func__, __LINE__, jiffies_to_msecs(jiffies));
+
+	if (copy_from_user(&flag, argp, sizeof(flag))) {
+		HDCP_DEBUG("[%s]failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+
+	hdcp_lib_control_22_cipher(flag);
+
+	hdcp.hdcp2p2_enabled = flag;
+
+	return 0;
+}
+
+static long hdcp_set_22_repeater_info_ctl(void __user *argp)
+{
+	struct H2_RepeaterAuthSendRxIdList_PayLoad repeater_info;
+
+	HDCP_DEBUG("[%s] %s  %d :%u", __FILE__, __func__, __LINE__, jiffies_to_msecs(jiffies));
+
+	if (copy_from_user(&repeater_info, argp, sizeof(repeater_info))) {
+		HDCP_DEBUG("[%s]failed to copy from user !\n", __func__);
+		return -EFAULT;
+	}
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+	//HdmiRx_save_hdcp2p2_repeater_state(&repeater_info);
+#endif
+
+	HDCP_DEBUG("Rxinfo: %02x %02x", repeater_info.Rxinfo[0], repeater_info.Rxinfo[1]);
+	HDCP_DEBUG("Seq_num: %02x %02x %02x",
+		repeater_info.Seq_num[0], repeater_info.Seq_num[1], repeater_info.Seq_num[2]);
+	HDCP_DEBUG("maxDevsExceeded: %02x", repeater_info.maxDevsExceeded);
+	HDCP_DEBUG("maxCascadeExceeded: %02x", repeater_info.maxCascadeExceeded);
+	HDCP_DEBUG("deviceCount: %02x", repeater_info.deviceCount);
+	HDCP_DEBUG("depth: %02x", repeater_info.depth);
+	HDCP_DEBUG("HDCP2_0_repeater_downstream: %02x", repeater_info.HDCP2_0_repeater_downstream);
+	HDCP_DEBUG("HDCP1_device_downstream: %02x", repeater_info.HDCP1_device_downstream);
+	HDCP_DEBUG("Receive ID list : %02x , %02x, %02x, %02x, %02x",
+		repeater_info.Receiver_ID_LIST[0], repeater_info.Receiver_ID_LIST[1],
+		repeater_info.Receiver_ID_LIST[2], repeater_info.Receiver_ID_LIST[3],
+		repeater_info.Receiver_ID_LIST[4]);
+	return 0;
+}
+
+#ifdef CONFIG_RTK_HDCP_1x_TEE
+static long hdcp_set_param_key14(void __user *argp)
+{
+	struct hdcp_key14_param key;
+
+	if (copy_from_user(&key, argp, sizeof(key))) {
+		HDCP_DEBUG("[%s]failed to copy from user !\n", __func__);
+		return -EFAULT;
+	}
+
+	ta_hdcp_set_param_key((unsigned char *)&key);
+
+	return 0;
+}
+#endif
+
+int hdcp_open(struct inode *inode, struct file *filp)
+{
+	if (nonseekable_open(inode, filp))
+		return -ENODEV;
+
+	return 0;
+}
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_ioctl
+ *-----------------------------------------------------------------------------
+ */
+long hdcp_ioctl(struct file *fd, unsigned int cmd, unsigned long arg)
+{
+	void __user *argp = (void __user *)arg;
+
+	HDCP_DEBUG("ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+		_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+
+#ifdef CONFIG_RTK_HDCP_1x_TEE
+	ta_hdcp14_init();
+#endif
+
+	switch (cmd) {
+#ifdef CONFIG_RTK_HDCP_1x_TEE
+	case HDCP_SET_PARAM_KEY:
+		return hdcp_set_param_key14(argp);
+#endif
+	case HDCP_ENABLE:
+		return hdcp_enable_ctl(argp);
+
+	case HDCP_DISABLE:
+		return hdcp_disable_ctl();
+
+	case HDCP_QUERY_STATUS:
+		return hdcp_query_status_ctl(argp);
+
+	case HDCP_QUERY_SINK_HDCP_CAPABLE:
+		return hdcp_query_sink_hdcp_capable_ctl(argp);
+
+	case HDCP_GET_DOWNSTREAM_KSVLIST:
+		return hdcp_get_downstream_KSVlist_ctl(argp);
+
+	case HDCP_SET_22_CIPHER:
+		return hdcp_set_22_cipher_ctl(argp);
+
+	case HDCP_CONTROL_22_CIPHER:
+		return hdcp_control_22_cipher_ctl(argp);
+
+	case HDCP_SET_22_REPEATER_INFO:
+		return hdcp_set_22_repeater_info_ctl(argp);
+
+	default:
+		return -ENOTTY;
+	} /* End switch */
+}
+
+#ifdef CONFIG_64BIT
+long compat_hdcp_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	if (!file->f_op->unlocked_ioctl)
+		return -ENOTTY;
+	else
+		return file->f_op->unlocked_ioctl(file, cmd, (unsigned long)compat_ptr(arg));
+}
+#endif
+
+/******************************************************************************
+ * HDCP driver init/exit
+ *****************************************************************************/
+
+const struct file_operations hdcp_fops = {
+	.owner = THIS_MODULE,
+	.open = hdcp_open,
+	.unlocked_ioctl = hdcp_ioctl,
+#ifdef CONFIG_64BIT
+	.compat_ioctl = compat_hdcp_ioctl,
+#endif
+};
+
+static ssize_t hdcp_state_show(struct device *device, struct device_attribute *attr, char *buffer)
+{
+	HDCP_DEBUG("%s\n", __func__);
+	return sprintf(buffer, "%d", hdcp.auth_state);
+}
+
+static ssize_t hdcp_name_show(struct device *device, struct device_attribute *attr, char *buffer)
+{
+	HDCP_DEBUG("%s\n", __func__);
+	return sprintf(buffer, "%s\n", "hdcp");
+}
+
+static ssize_t hdcp_hdcp1x_en_show(struct device *device, struct device_attribute *attr, char *buffer)
+{
+	ssize_t ret_count;
+
+	HDCP_DEBUG("%s\n", __func__);
+
+	ret_count = sprintf(buffer, "%s\n", (hdcp.hdcp_enabled == 1)?"Enable":"Disable");
+
+	return ret_count;
+}
+
+static ssize_t hdcp_hdcp2p2_en_show(struct device *device, struct device_attribute *attr, char *buffer)
+{
+	ssize_t ret_count;
+
+	HDCP_DEBUG("%s\n", __func__);
+
+	ret_count = sprintf(buffer, "%s\n", (hdcp.hdcp2p2_enabled == HDCP_22_CIPHER_RESUME)?"Enable":"Disable");
+
+	return ret_count;
+}
+
+void hdcp_set_state(struct miscdevice *pdev, int state)
+{
+	char name_buf[120];
+	char state_buf[120];
+	char *prop_buf;
+	char *envp[3];
+	int env_offset = 0;
+	int length;
+
+	prop_buf = (char *)get_zeroed_page(GFP_KERNEL);
+	if (prop_buf) {
+		length = hdcp_name_show(pdev->this_device, NULL, prop_buf);
+		if (length > 0) {
+			if (prop_buf[length - 1] == '\n')
+				prop_buf[length - 1] = 0;
+			snprintf(name_buf, sizeof(name_buf), "HDCP1x_NAME=%s", prop_buf);
+			envp[env_offset++] = name_buf;
+		}
+
+		length = hdcp_state_show(pdev->this_device, NULL, prop_buf);
+		if (length > 0) {
+			if (prop_buf[length - 1] == '\n')
+				prop_buf[length - 1] = 0;
+			snprintf(state_buf, sizeof(state_buf), "HDCP1x_STATE=%s", prop_buf);
+			envp[env_offset++] = state_buf;
+		}
+
+		envp[env_offset] = NULL;
+		kobject_uevent_env(&pdev->this_device->kobj, KOBJ_CHANGE, envp);
+		free_page((unsigned long)prop_buf);
+	} else {
+		HDCP_ERROR("Out of memory in %s\n", __func__);
+		kobject_uevent(&pdev->this_device->kobj, KOBJ_CHANGE);
+	}
+
+}
+
+/* /sys/class/misc/hdcp/state */
+static DEVICE_ATTR(state, 0444, hdcp_state_show, NULL);
+/* /sys/class/misc/hdcp/name */
+static DEVICE_ATTR(name, 0444, hdcp_name_show, NULL);
+/* /sys/class/misc/hdcp/hdcp1x_en */
+static DEVICE_ATTR(hdcp1x_en, 0444, hdcp_hdcp1x_en_show, NULL);
+/* /sys/class/misc/hdcp/hdcp2p2_en */
+static DEVICE_ATTR(hdcp2p2_en, 0444, hdcp_hdcp2p2_en_show, NULL);
+
+
+static int rtk_hdcptx_probe(struct platform_device *pdev)
+{
+	struct device_node __maybe_unused *hdcp_node;
+	int ret;
+
+	HDCP_INFO("Driver init");
+
+	hdcp.hdcp_base_addr = of_iomap(pdev->dev.of_node, 0);
+	if (!hdcp.hdcp_base_addr) {
+		HDCP_ERROR("HDCP iomap error");
+		goto err_map_hdcp;
+	}
+
+	hdcp.hdcp_irq_num = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (!hdcp.hdcp_irq_num)
+		HDCP_ERROR("map hdcp irq num failed");
+	else
+		HDCP_INFO("hdcp_irq_num=%d", hdcp.hdcp_irq_num);
+
+	mutex_init(&hdcp.lock);
+
+	mdev.minor = MISC_DYNAMIC_MINOR;
+	mdev.name = "hdcp";
+	mdev.mode = 0666;
+	mdev.fops = &hdcp_fops;
+
+	if (misc_register(&mdev)) {
+		HDCP_ERROR("Could not add character driver\n");
+		goto err_register;
+	}
+
+	mutex_lock(&hdcp.lock);
+
+	/* Variable init */
+	hdcp.en_ctrl  = 0;
+	hdcp.hdcp_state = HDCP_DISABLED;
+	hdcp.pending_start = 0;
+	hdcp.pending_wq_event = 0;
+	hdcp.retry_cnt = 0;
+	hdcp.reauth_delay = 0;
+	hdcp.auth_state = HDCP_STATE_DISABLED;
+	hdcp.hdcp_up_event = 0;
+	hdcp.hdcp_down_event = 0;
+	hdcp_wait_re_entrance = 0;
+	hdcp.hpd_low = 0;
+	hdcp.hdcp_enabled = -1;
+
+	/* Init sysfs */
+	ret = device_create_file(mdev.this_device, &dev_attr_state);
+	if (ret < 0)
+		goto err_add_driver;
+
+	ret = device_create_file(mdev.this_device, &dev_attr_name);
+	if (ret < 0)
+		goto err_add_driver;
+
+	ret = device_create_file(mdev.this_device, &dev_attr_hdcp1x_en);
+	if (ret < 0)
+		goto err_add_driver;
+
+	ret = device_create_file(mdev.this_device, &dev_attr_hdcp2p2_en);
+	if (ret < 0)
+		goto err_add_driver;
+
+	spin_lock_init(&hdcp.spinlock);
+
+	hdcp.workqueue = create_singlethread_workqueue("hdcp");
+	if (hdcp.workqueue == NULL)
+		goto err_add_driver;
+
+	hdcp.hdmi_state = HDMI_STARTED;
+
+	memset(&ksvlist_info, 0x0, sizeof(struct hdcp_ksvlist_info));
+	mutex_unlock(&hdcp.lock);
+
+	return 0;
+
+err_add_driver:
+	misc_deregister(&mdev);
+
+err_register:
+	mutex_destroy(&hdcp.lock);
+	iounmap(hdcp.hdcp_base_addr);
+
+err_map_hdcp:
+	return -EFAULT;
+}
+
+static int rtk_hdcptx_suspend(struct device *dev)
+{
+	HDCP_INFO("Enter %s", __func__);
+
+#ifdef CONFIG_RTK_HDCP_1x_TEE
+	/* tee_client should be closed before enter suspend */
+	ta_hdcp14_deinit();
+#endif
+
+	HDCP_INFO("Exit %s", __func__);
+
+	return 0;
+}
+
+static int rtk_hdcptx_resume(struct device *dev)
+{
+	HDCP_INFO("Enter %s", __func__);
+	HDCP_INFO("Exit %s", __func__);
+
+	return 0;
+}
+
+static void rtk_hdcptx_shutdown(struct platform_device *pdev)
+{
+	HDCP_INFO("Enter %s", __func__);
+
+#ifdef CONFIG_RTK_HDCP_1x_TEE
+	ta_hdcp14_deinit();
+#endif
+
+	HDCP_INFO("Exit %s", __func__);
+}
+
+static const struct of_device_id rtk_hdcptx_dt_ids[] = {
+	{ .compatible = "realtek,rtk129x-hdcptx", },
+	{ .compatible = "realtek,rtk139x-hdcptx", },
+	{ .compatible = "realtek,rtd161x-hdcptx", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_hdcptx_dt_ids);
+
+static const struct dev_pm_ops rtk_hdcptx_pm_ops = {
+	.suspend    = rtk_hdcptx_suspend,
+	.resume     = rtk_hdcptx_resume,
+	.freeze     = rtk_hdcptx_suspend,
+	.thaw       = rtk_hdcptx_resume,
+};
+
+static struct platform_driver rtk_hdcptx_driver = {
+	.probe = rtk_hdcptx_probe,
+	.driver = {
+		.name = "rtk_hdcptx",
+		.owner = THIS_MODULE,
+		.of_match_table = of_match_ptr(rtk_hdcptx_dt_ids),
+#ifdef CONFIG_PM
+		.pm = &rtk_hdcptx_pm_ops,
+#endif
+	},
+	.shutdown = rtk_hdcptx_shutdown,
+};
+
+static int __init hdcp_init(void)
+{
+	if (platform_driver_register(&rtk_hdcptx_driver)) {
+		HDCP_ERROR("Could not register platform driver");
+		goto err_register;
+	}
+
+	return 0;
+
+err_register:
+	platform_driver_unregister(&rtk_hdcptx_driver);
+
+	return -EFAULT;
+}
+
+static void __exit hdcp_exit(void)
+{
+	mutex_lock(&hdcp.lock);
+
+	kfree(hdcp.en_ctrl);
+
+	misc_deregister(&mdev);
+
+	/* Unmap HDCP */
+	iounmap(hdcp.hdcp_base_addr);
+
+	destroy_workqueue(hdcp.workqueue);
+
+	mutex_unlock(&hdcp.lock);
+
+	mutex_destroy(&hdcp.lock);
+}
+
+module_init(hdcp_init);
+module_exit(hdcp_exit);
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Realtek HDCP kernel module");
diff --git a/drivers/media/platform/rtk_hdcptx/hdcp_top.h b/drivers/media/platform/rtk_hdcptx/hdcp_top.h
new file mode 100644
index 00000000..b9614bb
--- /dev/null
+++ b/drivers/media/platform/rtk_hdcptx/hdcp_top.h
@@ -0,0 +1,27 @@
+/*
+ * hdcp_top.h - RTK hdcp tx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDCP_TOP_H_
+#define _HDCP_TOP_H_
+
+#include <linux/interrupt.h>
+#include "hdcp.h"
+
+#if IS_ENABLED(CONFIG_COMPAT)
+long compat_hdcp_ioctl(struct file *file, unsigned int cmd, unsigned long arg);
+#else
+#define compat_hdcp_ioctl  NULL
+#endif
+
+irqreturn_t HDCP_interrupt_handler(int irq, void *dev_id);
+
+
+#endif /* _HDCP_TOP_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/Kconfig b/drivers/media/platform/rtk_hdmirx/Kconfig
new file mode 100644
index 00000000..294cfc1
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/Kconfig
@@ -0,0 +1,35 @@
+config RTK_HDMIRX
+	tristate "HDMIRX for Realtek RTD platform"
+	select MEDIA_CAMERA_SUPPORT
+	select VIDEO_DEV
+	select I2C
+	select VIDEO_V4L2
+	select VIDEOBUF2_CORE
+	select VIDEOBUF_GEN
+	select VIDEOBUF2_VMALLOC
+	select VIDEOBUF2_DMA_CONTIG
+	default n
+	---help---
+	  Say Y, if you want to enable HDMI RX driver on Realtek RTD platform.
+
+config RTK_HDCP1x_REPEATER
+	tristate "HDCP 1.x Repeater for Realtek platform"
+	select RTK_HDMIRX
+    select RTK_HDCP_1x
+	default n
+	---help---
+	  Say Y, if you want to enable HDCP 1.x repeater on Realtek platform.
+
+config RTK_HDCPRX_1P4_TEE
+	tristate "HDCP RX HDCP 1.4 TEE for Realtek platform"
+	select TEE
+	default n
+	---help---
+	  Say Y, if you want to enable HDCP RX 1.4 TEE driver on Realtek platform.
+
+config RTK_HDCPRX_2P2
+	tristate "HDCP RX 2.2 for Realtek platform"
+	select RTK_HDMIRX
+	default n
+	---help---
+		Say Y, if you want to enable HDCP RX 2.2 driver on Realtek platform.
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/Makefile b/drivers/media/platform/rtk_hdmirx/rtd129x/Makefile
new file mode 100644
index 00000000..c1c0dda
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/Makefile
@@ -0,0 +1,23 @@
+
+
+OBJNAME := v4l2_hdmi_rx
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmirx/rtd129x/
+ccflags-y += -I$(srctree)/drivers/video/fbdev/rtk
+ccflags-y += -I$(srctree)/drivers/staging/android
+$(OBJNAME)-objs := v4l2_hdmi_dev.o hdmirx_video_dev.o hdmirx_clk_ctrl.o mipi_wrapper.o \
+	hdmirx_wrapper.o hdmirx_reg.o hdmirx_hdcp.o hdmirx_repeater.o hdmirx_sysfs.o
+
+ifdef CONFIG_RTK_HDCP1x_REPEATER
+$(OBJNAME)-objs += cipher.lib
+endif
+
+ifdef CONFIG_RTK_HDCPRX_2P2
+$(OBJNAME)-objs += hdmirx_hdcp2p2.o hdcp2p2_dev.o
+endif
+
+#obj-m	+= v4l2_hdmi_rx.o
+obj-$(CONFIG_RTK_HDMIRX)	+= v4l2_hdmi_rx.o
+obj-$(CONFIG_RTK_HDMIRX)	+= rx_drv/
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/cipher.lib b/drivers/media/platform/rtk_hdmirx/rtd129x/cipher.lib
new file mode 100644
index 00000000..501d9df
Binary files /dev/null and b/drivers/media/platform/rtk_hdmirx/rtd129x/cipher.lib differ
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdcp2p2_dev.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdcp2p2_dev.c
new file mode 100644
index 00000000..9bc08df
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdcp2p2_dev.c
@@ -0,0 +1,109 @@
+/*
+ * hdmirx_hdcp2p2_dev.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/miscdevice.h>
+
+#include "hdcp2p2_dev.h"
+#include "hdmirx_hdcp2p2.h"
+#include "v4l2_hdmi_dev.h"
+
+
+struct miscdevice hdcp2p2_mdev;
+
+int hdcp2p2_open(struct inode *inode, struct file *filp)
+{
+	if (nonseekable_open(inode, filp))
+		return -ENODEV;
+
+	return 0;
+}
+
+long hdcp2p2_ioctl(struct file *fd, unsigned int cmd, unsigned long arg)
+{
+	void __user *argp = (void __user *)arg;
+	unsigned long ret_val;
+
+	HDMIRX_DEBUG("[HDCP2.2]ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+		_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+
+	ret_val = -ENOTTY;
+
+	switch (cmd) {
+	case HDCP22IOC_INIT:
+		init_hdcp2p2_waitqueue();
+		ret_val = 0;
+		break;
+	case HDCP22IOC_GET_HDCP22_MSG:
+		ret_val = get_hdcp2p2_msg(argp);
+		break;
+	case HDCP22IOC_WRITE_DATA_TO_TX:
+		ret_val = write_hdcp2p2_msg_to_tx(argp);
+		break;
+	case HDCP22IOC_GET_STREAM_MSG:
+		ret_val = get_stream_msg(argp);
+		break;
+	case HDCP22IOC_SET_KS:
+		ret_val = set_hdcp2p2_ks(argp);
+		break;
+	case HDCP22IOC_CLR_MSG_DONE:
+		Clear_Hdmi_hdcp_2_2_Read_Status();
+		ret_val = 0;
+		break;
+	case HDCP22IOC_GET_MSG_DONE:
+		ret_val = get_hdcp2p2_msg_done(argp);
+		break;
+	case HDCP22IOC_SET_STATUS_READY:
+		Set_Rx_status_Ready();
+		ret_val = 0;
+		break;
+	case HDCP22IOC_SET_DOWNSTREAM_DONE:
+		DownStream_done();
+		ret_val = 0;
+		break;
+	case HDCP22IOC_SET_SWITCH_STATE:
+		ret_val = set_hdcp2p2_switch_state(argp);
+		break;
+	default:
+		HDMIRX_ERROR("[HDCP2.2]Unknown ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+			_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+		break;
+	}
+
+	return ret_val;
+}
+
+long compat_hdcp2p2_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	if (!file->f_op->unlocked_ioctl)
+		return -ENOTTY;
+	else
+		return file->f_op->unlocked_ioctl(file, cmd, (unsigned long)compat_ptr(arg));
+}
+
+const struct file_operations rxhdcp2p2_fops = {
+	.owner = THIS_MODULE,
+	.open = hdcp2p2_open,
+	.unlocked_ioctl = hdcp2p2_ioctl,
+	.compat_ioctl = compat_hdcp2p2_ioctl,
+};
+
+void register_hdcp2p2_device(void)
+{
+
+	hdcp2p2_mdev.minor = MISC_DYNAMIC_MINOR;
+	hdcp2p2_mdev.name = "rxhdcp2p2";
+	hdcp2p2_mdev.mode = 0666;
+	hdcp2p2_mdev.fops = &rxhdcp2p2_fops;
+
+	if (misc_register(&hdcp2p2_mdev))
+		HDMIRX_ERROR("[HDCP2.2]Register misc dev fail");
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdcp2p2_dev.h b/drivers/media/platform/rtk_hdmirx/rtd129x/hdcp2p2_dev.h
new file mode 100644
index 00000000..24d9c74
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdcp2p2_dev.h
@@ -0,0 +1,41 @@
+/*
+ * hdcp2p2_dev.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDCP2P2_DEV_H_
+#define __HDCP2P2_DEV_H_
+
+struct rx_hdcp22_msg {
+	unsigned int bLen;
+	unsigned char msg[864];
+	unsigned char g_RX_state;
+} __attribute__ ((packed));
+
+
+struct rx_hdcp22_ks {
+	unsigned char bks[16];
+} __attribute__ ((packed));
+
+
+#define HDCP22IOC_INIT				_IOWR('V', 0, int)
+#define HDCP22IOC_GET_HDCP22_MSG	_IOWR('V', 1, struct rx_hdcp22_msg)
+#define HDCP22IOC_WRITE_DATA_TO_TX	_IOWR('V', 2, struct rx_hdcp22_msg)
+#define HDCP22IOC_GET_STREAM_MSG	_IOWR('V', 3, struct rx_hdcp22_msg)
+#define HDCP22IOC_SET_KS			_IOWR('V', 4, struct rx_hdcp22_ks)
+#define HDCP22IOC_CLR_MSG_DONE		_IOWR('V', 5, int)
+#define HDCP22IOC_GET_MSG_DONE		_IOWR('V', 6, int)
+#define HDCP22IOC_SET_STATUS_READY	_IOWR('V', 7, int)
+#define HDCP22IOC_SET_DOWNSTREAM_DONE	_IOWR('V', 8, int)
+#define HDCP22IOC_SET_SWITCH_STATE	_IOWR('V', 9, int)
+
+
+void register_hdcp2p2_device(void);
+
+#endif /* __HDCP2P2_DEV_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_clk_ctrl.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_clk_ctrl.c
new file mode 100644
index 00000000..68fdd06
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_clk_ctrl.c
@@ -0,0 +1,184 @@
+/*
+ * hdmirx_clk_ctrl.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/of.h>
+
+#include <linux/reset.h>
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+#include <soc/realtek/power-control.h>
+
+#include "hdmirx_clk_ctrl.h"
+
+unsigned int init_flag;
+struct reset_control *reset_mipi;
+struct reset_control *reset_rxwrap;
+struct reset_control *reset_hdmirx;
+struct reset_control *reset_cbustx;
+struct reset_control *reset_cbus_iso;
+struct reset_control *reset_cbustx_iso;
+struct reset_control *reset_cbusrx_iso;
+struct clk *clk_mipi;
+struct clk *clk_hdmirx;
+struct clk *clk_cbustx;
+struct clk *clk_cbus_osc_iso;
+struct clk *clk_cbus_iso;
+struct clk *clk_cbustx_iso;
+struct clk *clk_cbusrx_iso;
+struct power_control *pctrl_hdmirx;
+struct power_control *pctrl_mipi;
+
+unsigned char is_clock_enabled(HDMI_CLK_TYPE clk_type)
+{
+	unsigned char ret_value;
+
+	ret_value = false;
+
+	if (clk_type&CLK_MIPI)
+		ret_value = __clk_is_enabled(clk_mipi);
+
+	return ret_value;
+}
+
+void hdmirx_reset_control(HDMI_CLK_TYPE clk_type, HDMI_CLK_CTL enable)
+{
+	if (clk_type&RST_MIPI) {
+		if (enable)
+			reset_control_deassert(reset_mipi);
+		else
+			reset_control_assert(reset_mipi);
+	}
+}
+
+void hdmirx_clock_control(HDMI_CLK_TYPE clk_type, HDMI_CLK_CTL enable)
+{
+	if (clk_type&CLK_HDMIRX) {
+
+		if ((!reset_hdmirx) || (!clk_hdmirx))
+			HDMIRX_ERROR("[%s] CLK_HDMIRX fail", __func__);
+
+		if (enable) {
+			reset_control_deassert(reset_hdmirx);
+
+			if (init_flag & CLK_HDMIRX) {
+				clk_enable(clk_hdmirx);
+			} else {
+				clk_prepare_enable(clk_hdmirx);
+				init_flag |= CLK_HDMIRX;
+			}
+
+			power_control_power_on(pctrl_hdmirx);
+		} else { /* if not enable */
+			power_control_power_off(pctrl_hdmirx);
+			clk_disable(clk_hdmirx);
+			reset_control_assert(reset_hdmirx);
+		}
+
+	} /* end if if (clk_type&CLK_HDMIRX) */
+
+	if (clk_type&CLK_RXWRAP) {
+
+		if (!reset_rxwrap)
+			HDMIRX_ERROR("[%s] CLK_RXWRAP fail", __func__);
+
+		if (enable)
+			reset_control_deassert(reset_rxwrap);
+		else
+			reset_control_assert(reset_rxwrap);
+	}
+
+	if (clk_type&CLK_MIPI) {
+
+		if ((!reset_mipi) || (!clk_mipi))
+			HDMIRX_ERROR("[%s] CLK_MIPI fail", __func__);
+
+		if (enable) {
+			reset_control_deassert(reset_mipi);
+
+			if (init_flag&CLK_MIPI) {
+				clk_enable(clk_mipi);
+			} else {
+				clk_prepare_enable(clk_mipi);
+				init_flag |= CLK_MIPI;
+			}
+
+			power_control_power_on(pctrl_mipi);
+		} else { /* if not enable */
+			power_control_power_off(pctrl_mipi);
+			clk_disable(clk_mipi);
+			reset_control_assert(reset_mipi);
+		}
+	} /* end of if (clk_type&CLK_MIPI)*/
+
+	if (clk_type&CLK_CBUS) {
+
+		if ((!reset_cbustx) || (!reset_cbus_iso) || (!reset_cbustx_iso) ||
+			(!reset_cbusrx_iso) || (!clk_cbustx) || (!clk_cbus_osc_iso) ||
+			(!clk_cbus_iso) || (!clk_cbustx_iso) || (!clk_cbusrx_iso))
+			HDMIRX_ERROR("[%s] CLK_CBUS fail", __func__);
+
+		if (enable) {
+			reset_control_deassert(reset_cbustx);
+			reset_control_deassert(reset_cbus_iso);
+			reset_control_deassert(reset_cbustx_iso);
+			reset_control_deassert(reset_cbusrx_iso);
+
+			if (init_flag&CLK_CBUS) {
+				clk_enable(clk_cbus_osc_iso);
+				clk_enable(clk_cbus_iso);
+				clk_enable(clk_cbustx_iso);
+				clk_enable(clk_cbusrx_iso);
+			} else {
+				clk_prepare_enable(clk_cbus_osc_iso);
+				clk_prepare_enable(clk_cbus_iso);
+				clk_prepare_enable(clk_cbustx_iso);
+				clk_prepare_enable(clk_cbusrx_iso);
+				init_flag |= CLK_CBUS;
+			}
+		} else { /* if not enable */
+			clk_disable(clk_cbus_osc_iso);
+			clk_disable(clk_cbus_iso);
+			clk_disable(clk_cbustx_iso);
+			clk_disable(clk_cbusrx_iso);
+
+			reset_control_assert(reset_cbustx);
+			reset_control_assert(reset_cbus_iso);
+			reset_control_assert(reset_cbustx_iso);
+			reset_control_assert(reset_cbusrx_iso);
+		}
+	} /* end of if (clk_type&CLK_CBUS)*/
+
+}
+
+void hdmirx_clock_init(struct platform_device *pdev)
+{
+	init_flag = 0;
+
+	reset_mipi = reset_control_get(&pdev->dev, "mipi");
+	reset_rxwrap = reset_control_get(&pdev->dev, "hdmirx_wrap");
+	reset_hdmirx = reset_control_get(&pdev->dev, "hdmirx");
+	reset_cbustx = reset_control_get(&pdev->dev, "cbus_tx");
+	reset_cbus_iso = reset_control_get(&pdev->dev, "cbus");
+	reset_cbustx_iso = reset_control_get(&pdev->dev, "cbustx");
+	reset_cbusrx_iso = reset_control_get(&pdev->dev, "cbusrx");
+
+	clk_mipi = clk_get(&pdev->dev, "mipi");
+	clk_hdmirx = clk_get(&pdev->dev, "hdmirx");
+	clk_cbustx = clk_get(&pdev->dev, "cbus_tx");
+	clk_cbus_osc_iso = clk_get(&pdev->dev, "cbus_osc");
+	clk_cbus_iso = clk_get(&pdev->dev, "cbus_sys");
+	clk_cbustx_iso = clk_get(&pdev->dev, "cbustx_sys");
+	clk_cbusrx_iso = clk_get(&pdev->dev, "cbusrx_sys");
+
+	pctrl_hdmirx = power_control_get("pctrl_disp_hdmi_rx");/* HDMI RX SRAM */
+	pctrl_mipi = power_control_get("pctrl_disp_mipi");/* MIPI SRAM */
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_clk_ctrl.h b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_clk_ctrl.h
new file mode 100644
index 00000000..9256761
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_clk_ctrl.h
@@ -0,0 +1,36 @@
+/*
+ * hdmirx_clk_ctrl.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+
+#include "v4l2_hdmi_dev.h"
+
+typedef enum {
+	CLK_HDMIRX	= 0x1,
+	CLK_RXWRAP	= 0x2,
+	CLK_MIPI	= 0x4,
+	CLK_CBUS	= 0x8,
+	CLK_ALL		= 0xF,
+	RST_MIPI	= 0x10,
+	RST_CBUS	= 0x20,
+	RST_RXWRAP	= 0x40,
+	RST_HDMIRX	= 0x80
+} HDMI_CLK_TYPE;
+
+typedef enum {
+	CTL_DISABLE	= 0,
+	CTL_ENABLE	= 1
+} HDMI_CLK_CTL;
+
+unsigned char is_clock_enabled(HDMI_CLK_TYPE clk_type);
+void hdmirx_reset_control(HDMI_CLK_TYPE clk_type, HDMI_CLK_CTL enable);
+void hdmirx_clock_control(HDMI_CLK_TYPE clk_type, HDMI_CLK_CTL enable);
+void hdmirx_clock_init(struct platform_device *pdev);
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_gen_EDID.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_gen_EDID.c
new file mode 100644
index 00000000..a9a750b
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_gen_EDID.c
@@ -0,0 +1,131 @@
+/*
+ * hdmirx_gen_EDID.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/string.h>
+
+#define COLOR_RGB		0
+#define COLOR_YUV422	1
+#define COLOR_YUV444	2
+
+#define VIC_480P		2
+#define VIC_576P		17
+#define VIC_720P60		4
+#define VIC_1080I60		5
+#define VIC_1080P60		16
+#define VIC_2160P30		95
+#define VIC_2160P60		97
+
+unsigned char base_block[128] = {
+	0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
+	0x4A, 0x8B, 0x95, 0x12, 0x00, 0x00, 0x00, 0x00,
+	0xFF, 0x1A, 0x01, 0x03, 0x81, 0x46, 0x27, 0x78,
+	0x8A, 0xA5, 0x8E, 0xA6, 0x54, 0x4A, 0x9C, 0x26,
+	0x12, 0x45, 0x46, 0x00, 0x00, 0x00, 0x01, 0x01,
+	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
+	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00,
+	0x00, 0xFC, 0x00, 0x52, 0x54, 0x44, 0x31, 0x32,
+	0x39, 0x35, 0x0A, 0x20, 0x20, 0x20, 0x20, 0x20,
+	0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02
+};
+
+unsigned char cea_hdader_rgb[4] = {0x02, 0x03, 0x1A, 0x41};
+unsigned char cea_hdader_yuv422[4] = {0x02, 0x03, 0x1A, 0x51};
+unsigned char cea_hdader_yuv444[4] = {0x02, 0x03, 0x1A, 0x61};
+unsigned char speaker_alloc[4] = {0x83, 0x01, 0x00, 0x00};
+unsigned char vendor_specific[8] = {0x67, 0x03, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x3C};
+unsigned char vendor_specific2p0[8] = {0x67, 0xD8, 0x5D, 0xC4, 0x01, 0x78, 0x80, 0x00};
+unsigned char audio_data[4] = {0x23, 0x09, 0x7F, 0x07};
+unsigned char colorimetry[4] = {0xE3, 0x05, 0x00, 0x00};
+unsigned char detailed_timing[18] = {
+	0x8F, 0x0A, 0xD0, 0x8A, 0x20, 0xE0, 0x2D, 0x10,
+	0x10, 0x3E, 0x96, 0x00, 0x20, 0x58, 0x32, 0x00,
+	0x00, 0x18
+};
+
+
+/**
+ * gernerate_EDID - Generate specific EDID
+ * @color: 0 - RGB, 1 - YUV422, 2 - YUV444
+ * @vic: Video ID Code
+ * @edid_buf: 256 bytes buffer
+ */
+void gernerate_EDID(unsigned char color, unsigned char vic, unsigned char *edid_buf)
+{
+	unsigned int index = 0;
+	unsigned int i;
+	unsigned int sum = 0;
+
+	memset(edid_buf, 0, 256);
+
+	/* Base block */
+	memcpy(&edid_buf[index], base_block, sizeof(base_block));
+	index += sizeof(base_block);
+
+	/* CEA header */
+	switch (color) {
+	case COLOR_RGB:
+		memcpy(&edid_buf[index], cea_hdader_rgb, sizeof(cea_hdader_rgb));
+		break;
+	case COLOR_YUV422:
+		memcpy(&edid_buf[index], cea_hdader_yuv422, sizeof(cea_hdader_yuv422));
+		break;
+	case COLOR_YUV444:
+		memcpy(&edid_buf[index], cea_hdader_yuv444, sizeof(cea_hdader_yuv444));
+		break;
+	default:
+		memcpy(&edid_buf[index], cea_hdader_rgb, sizeof(cea_hdader_rgb));
+		break;
+	}
+	index += sizeof(cea_hdader_rgb);
+
+	/* Speaker Allocation */
+	memcpy(&edid_buf[index], speaker_alloc, sizeof(speaker_alloc));
+	index += sizeof(speaker_alloc);
+
+	/* Vendor Specific 1.4b */
+	memcpy(&edid_buf[index], vendor_specific, sizeof(vendor_specific));
+	index += sizeof(vendor_specific);
+
+	/* Vendor Specific 2.0 */
+	if (vic > 64) {
+		memcpy(&edid_buf[index], vendor_specific2p0, sizeof(vendor_specific2p0));
+		index += sizeof(vendor_specific2p0);
+	}
+
+	/* Video Data */
+	edid_buf[index++] = 0x41;
+	edid_buf[index++] = vic;
+
+	/* Audio Data */
+	memcpy(&edid_buf[index], audio_data, sizeof(audio_data));
+	index += sizeof(audio_data);
+
+	/* Colorimetry */
+	memcpy(&edid_buf[index], colorimetry, sizeof(colorimetry));
+	index += sizeof(colorimetry);
+
+	/* Detailed Timing */
+	memcpy(&edid_buf[index], detailed_timing, sizeof(detailed_timing));
+	index += sizeof(detailed_timing);
+
+	/* Calculate and set checksum */
+	for (i = 0x80; i < 0xFF; i++)
+		sum += edid_buf[i];
+	edid_buf[0xFF] = (0x100-(sum&0xFF))&0xFF;
+
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_hdcp.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_hdcp.c
new file mode 100644
index 00000000..af8f92f
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_hdcp.c
@@ -0,0 +1,547 @@
+/*
+ * hdmirx_hdcp.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmiInternal.h"
+#include "mipi_wrapper.h"
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+#include <soc/realtek/rtk_sha1.h>
+extern unsigned long long hdcp_calculate_m0(unsigned long long aksv_value, unsigned long long an_val);
+#endif
+
+/* HDCP Bcaps */
+#define BCAPS_HDMI_RESERVED	_BIT7
+#define BCAPS_REPEATER		_BIT6
+#define BCAPS_READY			_BIT5
+#define BCAPS_FAST			_BIT4
+#define BCAPS_1_1FEATURES	_BIT1
+#define BCAPS_FAST_REAUTH	_BIT0
+
+#define HDCP_BCAPS_DVI        (BCAPS_HDMI_RESERVED | BCAPS_FAST_REAUTH)
+#define HDCP_BCAPS_HDMI       (BCAPS_HDMI_RESERVED | BCAPS_1_1FEATURES | BCAPS_FAST_REAUTH)
+#define HDCP_BCAPS_REPEATER   (HDCP_BCAPS_HDMI | BCAPS_REPEATER)
+
+/*=================== extern Variable/Function ===================*/
+extern MIPI_TOP_INFO mipi_top;
+extern HDMIRX_IOCTL_STRUCT_T hdmi_ioctl_struct;
+extern HDMI_INFO_T hdmi;
+
+extern void Hdmi_SetHPD(char high);
+/*======================================================*/
+
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+extern void Hdmi_HDCP_2_2_Init(void);
+#endif
+#ifdef CONFIG_RTK_HDCPRX_1P4_TEE
+extern void CA_hdcp1p4_load(void);
+extern unsigned char TA_HDCP1p4_Load_flag;
+extern int TEE2p1_Flag;
+#endif
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+#define HDCP_MAX_KSV	5
+struct hdcp_ksvlist_info tx_ksv_info;
+#define CHECK_INTERVAL 5000
+#define CHECK_TIMES 5
+
+static void hdcp1x_repeater_work_fun(struct work_struct *work);
+static DECLARE_WORK(hdcp1x_repeater_work, hdcp1x_repeater_work_fun);
+#endif
+
+HDCP_KEY_T rx_key;
+static unsigned char hdcpkey_enable = false;
+
+/**
+ * Hdmi_HdcpPortCWrite -
+ *      HDCP DDC port setting download function with auto-address increase
+ *      where HDCP port ddc address for HOST side is 0x74/0x75
+ *
+ * @addr: hdcp register address
+ * @data: data pointer
+ * @num: length data
+ */
+void inline Hdmi_HdcpPortCWrite(unsigned char addr, HDMI_CONST unsigned char *value, unsigned char num)
+{
+	hdmi_rx_reg_mask32(HDCP_PCR, ~_BIT0, 0, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDCP_AP, addr, HDMI_RX_MAC);
+
+	while (num--)
+		hdmi_rx_reg_write32(HDCP_DP, *(value++), HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDCP_PCR, ~_BIT0, _BIT0, HDMI_RX_MAC);
+}
+
+/**
+ * Hdmi_HdcpPortWrite -
+ *      HDCP DDC port setting download function
+ *      where HDCP port ddc address for HOST side is 0x74/0x75
+ *
+ * @addr: hdcp register address
+ * @value: data
+ */
+void Hdmi_HdcpPortWrite(unsigned int addr, unsigned int value)
+{
+	hdmi_rx_reg_write32(HDCP_AP, addr, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDCP_DP, value, HDMI_RX_MAC);
+}
+
+/**
+ * Hdmi_HdcpPortRead -
+ *      HDCP DDC port setting read function
+ *      where HDCP port ddc address for HOST side is 0x74/0x75
+ *
+ * @addr: hdcp register address
+ *
+ * Return: data
+ */
+unsigned char Hdmi_HdcpPortRead(unsigned int addr)
+{
+	hdmi_rx_reg_write32(HDCP_AP, addr, HDMI_RX_MAC);
+	return hdmi_rx_reg_read32(HDCP_DP, HDMI_RX_MAC);
+}
+
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+void HdmiRx_save_tx_ksv(struct hdcp_ksvlist_info *tx_ksv)
+{
+	memcpy(&tx_ksv_info, tx_ksv, sizeof(tx_ksv_info));
+
+	hdmi.tx_hdcp_state = 1;
+	HDMIRX_INFO("TX ksv ready");
+
+	HDMI_PRINTF("TX ksv info:\n");
+	HDMI_PRINTF("device_count(%u)\n", tx_ksv_info.device_count);
+	HDMI_PRINTF("Bstatus(0x%02x%02x)\n", tx_ksv_info.bstatus[1], tx_ksv_info.bstatus[0]);
+	HDMI_PRINTF("Bksv(0x%02x %02x %02x %02x %02x)\n",
+		tx_ksv_info.Bksv[4], tx_ksv_info.Bksv[3], tx_ksv_info.Bksv[2],
+		tx_ksv_info.Bksv[1], tx_ksv_info.Bksv[0]);
+}
+
+struct hdcp_ksvlist_info *HdmiRx_get_tx_ksv(void)
+{
+	return &tx_ksv_info;
+}
+
+void HdmiRx_disable_bcaps_ready(void)
+{
+	unsigned int tmp_value;
+
+	if ((!mipi_top.hdmi_rx_init) || (!hdmi.tx_hdcp_state))/* Already disable */
+		return;
+
+	HDMI_PRINTF("%s\n", __func__);
+	/* Disable Bcaps READY(Bit5) */
+	tmp_value = Hdmi_HdcpPortRead(0x40)&0xDF;/* set bit 5 to 0 */
+	Hdmi_HdcpPortWrite(0x40, tmp_value);
+	hdmi.tx_hdcp_state = 0;
+}
+
+void HdmiRx_set_bstatus(unsigned char byte1, unsigned char byte0)
+{
+	if (!mipi_top.hdmi_rx_init)
+		return;
+	HDMI_PRINTF("%s\n", __func__);
+
+	if ((byte1&0xF) < 0x7)/* less than seven levels */
+		byte1 = (0x1<<4)|((byte1&0xF)+1);
+	else/* Topology error */
+		byte1 = (0x1<<4)|0xF;
+
+	if (byte0 < HDCP_MAX_KSV)/* less than HDCP_MAX_KSV downstream devices */
+		byte0 = byte0+1;
+	else/* Topology error */
+		byte0 = 0xFF;
+
+	Hdmi_HdcpPortWrite(0x41, byte0);
+	Hdmi_HdcpPortWrite(0x42, byte1);
+}
+
+/**
+ * hdcprx_set_bcaps_ready - Enable/Disable Bcaps READY(Bit5)
+ * @enable: 0 disable, 1 enable
+ */
+void hdcprx_set_bcaps_ready(unsigned char enable)
+{
+	unsigned int tmp_value;
+
+	tmp_value = Hdmi_HdcpPortRead(0x40);
+	if (enable)
+		tmp_value |= 0x20;
+	else
+		tmp_value = Hdmi_HdcpPortRead(0x40)&0xDF;
+
+	Hdmi_HdcpPortWrite(0x40, tmp_value);
+}
+
+void Hdmi_Hdcp1xRepeaterAuth(void)
+{
+	UINT8 aksv_reg[5], an_reg[8];
+	unsigned long long AKSV = 0, An = 0;
+	unsigned char *sha_data_buffer;
+	unsigned int sha_index;
+	unsigned char sha1[SHA1_DIGEST_SIZE];
+	unsigned long long Mi;
+	int k;
+	unsigned int i, reg_value, Bstatus;
+	struct hdcp_ksvlist_info *tx_ksv;
+
+	tx_ksv = HdmiRx_get_tx_ksv();
+
+	/* Wait TX ready, Max 1.5 s */
+	for (i = 0; i < 15; i++) {
+		if (hdmi.tx_hdcp_state)
+			break;
+
+		usleep_range(100000, 110000);
+	}
+
+	if (!hdmi.tx_hdcp_state) {
+		HDMIRX_INFO("HDCP TX not ready");
+		goto exit;
+	}
+
+	/* Alloc sha buffer: Bksv(5Bytes), KSV list(5Bytes for each ksv), Bstatus(2Bytes), M0'(8Bytes) */
+	sha_data_buffer = kmalloc((5*(tx_ksv->device_count+1)+10)*sizeof(unsigned char), GFP_KERNEL);
+
+	hdmi_rx_reg_mask32(HDCP_PCR, ~(_BIT1|_BIT0), _BIT1, HDMI_RX_MAC);
+	/* Set KSV list */
+	for (sha_index = 0; sha_index < 5; sha_index++) {
+		/* HDMIRX_INFO("HdcpPortWrite(0x%03x):0x%02x",0x43+(sha_index<<8),tx_ksv->Bksv[sha_index]); */
+		Hdmi_HdcpPortWrite(0x43+(sha_index<<8)/*ksvfifo_ptr*/, tx_ksv->Bksv[sha_index]);
+		sha_data_buffer[sha_index] = tx_ksv->Bksv[sha_index];
+	}
+
+	for (sha_index = 5; sha_index < 5*(tx_ksv->device_count+1); sha_index++) {
+		/* HDMIRX_INFO("HdcpPortWrite(0x%03x):0x%02x",0x43+(sha_index<<8),tx_ksv->ksvlist[sha_index-5]); */
+		Hdmi_HdcpPortWrite(0x43+(sha_index<<8)/*ksvfifo_ptr*/, tx_ksv->ksvlist[sha_index-5]);
+		sha_data_buffer[sha_index] = tx_ksv->ksvlist[sha_index-5];
+	}
+
+	if (hdmi_rx_reg_read32(HDCP_FLAG1, HDMI_RX_MAC)&HDCP_FLAG1_wr_aksv_flag_mask) {
+		HDMIRX_INFO("New AKSV after set KVS list");
+		goto free_exit;
+	}
+
+	/* Set Bstatus, HDMI_MODE[12] MAX_CASCADE_EXCEEDED[11] DEPTH[10:8] DEVICE_COUNT[6:0] */
+	/* Bstatus[15:8] */
+	if ((tx_ksv->bstatus[1]&0xF) < 0x7)/* less than seven levels */
+		Bstatus = (0x1<<12) | ((tx_ksv->bstatus[1]+1)<<8);
+	else/* Topology error */
+		Bstatus = (0x1<<12) | (0xF<<8);
+
+	/* Bstatus[15:8]|Bstatus[7:0] */
+	if (tx_ksv->bstatus[0] < HDCP_MAX_KSV)/* less than HDCP_MAX_KSV downstream devices */
+		Bstatus = Bstatus | (tx_ksv->bstatus[0]+1);
+	else/* Topology error */
+		Bstatus = Bstatus | 0xFF;
+
+	Hdmi_HdcpPortWrite(0x41, Bstatus & 0xFF);
+	Hdmi_HdcpPortWrite(0x42, (Bstatus>>8)&0xFF);
+	sha_data_buffer[sha_index++] = Bstatus & 0xFF;
+	sha_data_buffer[sha_index++] = (Bstatus>>8)&0xFF;
+
+	/* Readback Bstatus */
+	HDMIRX_INFO("HDCP Bstatus:Byte1=0x%02x Byte2=0x%02x",
+		Hdmi_HdcpPortRead(0x41), Hdmi_HdcpPortRead(0x42));
+
+	if (hdmi_rx_reg_read32(HDCP_FLAG1, HDMI_RX_MAC) & HDCP_FLAG1_wr_aksv_flag_mask) {
+		HDMIRX_INFO("New AKSV after get Bstatus");
+		goto free_exit;
+	}
+
+	/* Read AKSV */
+	aksv_reg[0] = Hdmi_HdcpPortRead(0x10);/* [7:0] */
+	aksv_reg[1] = Hdmi_HdcpPortRead(0x11);/* [15:8] */
+	aksv_reg[2] = Hdmi_HdcpPortRead(0x12);/* [23:16] */
+	aksv_reg[3] = Hdmi_HdcpPortRead(0x13);/* [31:24] */
+	aksv_reg[4] = Hdmi_HdcpPortRead(0x14);/* [39:32] */
+	AKSV = 0;
+	for (k = 4; k >= 0; k--)
+		AKSV = AKSV<<8 | aksv_reg[k];
+
+	 HDMIRX_DEBUG("HDCP i=%d AKSV Flag = %x, %x ,%x ,%x, %x AKSV(%llx)",
+		i, aksv_reg[0], aksv_reg[1], aksv_reg[2], aksv_reg[3], aksv_reg[4], AKSV);
+
+	/* Read An */
+	an_reg[0] = Hdmi_HdcpPortRead(0x18);/* [7:0] */
+	an_reg[1] = Hdmi_HdcpPortRead(0x19);/* [15:8] */
+	an_reg[2] = Hdmi_HdcpPortRead(0x1A);
+	an_reg[3] = Hdmi_HdcpPortRead(0x1B);
+	an_reg[4] = Hdmi_HdcpPortRead(0x1C);
+	an_reg[5] = Hdmi_HdcpPortRead(0x1D);
+	an_reg[6] = Hdmi_HdcpPortRead(0x1E);
+	an_reg[7] = Hdmi_HdcpPortRead(0x1F);/* [63:56] */
+	for (k = 7; k >= 0; k--)
+		An = (An<<8) | an_reg[k];
+
+	HDMIRX_DEBUG("HDCP An = 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x ,0x%llx",
+		an_reg[0], an_reg[1], an_reg[2], an_reg[3],
+		an_reg[4], an_reg[5], an_reg[6], an_reg[7], An);
+
+	/* Calcuate V' */
+	Mi = hdcp_calculate_m0(AKSV, An);
+
+	for (k = 0; k < 8; k++)
+		sha_data_buffer[sha_index++] = (Mi>>(k*8))&0xFF;
+
+	/*
+	 * SHA-1 example
+	 * Input "Hello" --> Output "f7ff9e8b7bb2e09b70935a5d785e0cc5d9d0abf0"
+	 * char source[5]={'H', 'e', 'l', 'l', 'o'};
+	 * sha1[0]=0xf7, sha1[1]=0xff, ..., sha1[19]=0xf0
+	 */
+	memset(sha1, 0, SHA1_DIGEST_SIZE*sizeof(unsigned char));
+	MCP_SHA1_Get_Hash(sha_data_buffer, sha_index/*source length*/, sha1);
+
+	/*
+	 * for (k = 0; k < 20; k++)
+	 *	HDMIRX_INFO("sha1[%u]=0x%02x", k, sha1[k]);
+	 */
+
+	/* Set V' */
+	/* SHA-1 H0b */
+	Hdmi_HdcpPortWrite(0x20, sha1[3]);
+	Hdmi_HdcpPortWrite(0x21, sha1[2]);
+	Hdmi_HdcpPortWrite(0x22, sha1[1]);
+	Hdmi_HdcpPortWrite(0x23, sha1[0]);
+	/* SHA-1 H1 */
+	Hdmi_HdcpPortWrite(0x24, sha1[7]);
+	Hdmi_HdcpPortWrite(0x25, sha1[6]);
+	Hdmi_HdcpPortWrite(0x26, sha1[5]);
+	Hdmi_HdcpPortWrite(0x27, sha1[4]);
+	/* SHA-1 H2 */
+	Hdmi_HdcpPortWrite(0x28, sha1[11]);
+	Hdmi_HdcpPortWrite(0x29, sha1[10]);
+	Hdmi_HdcpPortWrite(0x2A, sha1[9]);
+	Hdmi_HdcpPortWrite(0x2B, sha1[8]);
+	/* SHA-1 H3 */
+	Hdmi_HdcpPortWrite(0x2C, sha1[15]);
+	Hdmi_HdcpPortWrite(0x2D, sha1[14]);
+	Hdmi_HdcpPortWrite(0x2E, sha1[13]);
+	Hdmi_HdcpPortWrite(0x2F, sha1[12]);
+	/* SHA-1 H4 */
+	Hdmi_HdcpPortWrite(0x30, sha1[19]);
+	Hdmi_HdcpPortWrite(0x31, sha1[18]);
+	Hdmi_HdcpPortWrite(0x32, sha1[17]);
+	Hdmi_HdcpPortWrite(0x33, sha1[16]);
+
+	/* Reset AP address */
+	hdmi_rx_reg_write32(HDCP_AP, 0x43, HDMI_RX_MAC);
+
+	/* Dump V' */
+	/*
+	 * for (k = 0; k < 20; k++)
+	 *	HDMIRX_INFO("ReadBack V'(%u):0x%02x", k, Hdmi_HdcpPortRead(0x20+k));
+	 */
+
+	/* For CTS 3C-I-03, TE write An twice */
+	for (k = 0; k < CHECK_TIMES; k++) {
+		usleep_range(CHECK_INTERVAL, CHECK_INTERVAL+10);
+		reg_value = hdmi_rx_reg_read32(HDCP_FLAG1, HDMI_RX_MAC);
+		if (reg_value & HDCP_FLAG1_wr_aksv_flag_mask) {
+			HDMIRX_INFO("New AKSV after set V'(%u)", k);
+			goto free_exit;
+		}
+	}
+
+	/* Enable Bcaps READY(Bit5) */
+	if (hdmi.tx_hdcp_state)
+		hdcprx_set_bcaps_ready(1);
+	else
+		HDMIRX_INFO("HDCP TX not ready");
+
+	/* For 3C-I-04 */
+	for (k = 0; k < CHECK_TIMES*10; k++) {
+		usleep_range(CHECK_INTERVAL, CHECK_INTERVAL+10);
+		reg_value = hdmi_rx_reg_read32(HDCP_FLAG1, HDMI_RX_MAC);
+		if (reg_value & HDCP_FLAG1_wr_aksv_flag_mask) {
+			hdcprx_set_bcaps_ready(0);
+			HDMIRX_INFO("New AKSV after Bcaps READY(%u)", k);
+			goto free_exit;
+		}
+	}
+
+free_exit:
+	/* Free sha data buffer */
+	kfree(sha_data_buffer);
+exit:
+	return;
+}
+
+static void hdcp1x_repeater_work_fun(struct work_struct *work)
+{
+	Hdmi_Hdcp1xRepeaterAuth();
+	hdmi_rx_reg_mask32(HDCP_FLAG2, ~HDCP_FLAG2_irq_aksv_en_mask,
+		HDCP_FLAG2_irq_aksv_en_mask, HDMI_RX_MAC);/* Enable AKSV interrupt */
+}
+
+void start_hdcp1x_repeater_work(void)
+{
+	hdcprx_set_bcaps_ready(0);
+
+	hdmi_ioctl_struct.hdcp_state = HDCPRX_STATE_1PX_DISCOVER;/*  Discover HDCP 1.x */
+
+	if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & _BIT0)/* HDMI mode */
+		schedule_work(&hdcp1x_repeater_work);
+}
+#endif
+
+void Hdmi_HdcpFSM(void)
+{
+	UINT32 hdcp_status_flag;
+
+	hdcp_status_flag = hdmi_rx_reg_read32(HDCP_FLAG1, HDMI_RX_MAC);
+
+	/* Get TX write Aksv */
+	if (HDCP_FLAG1_get_wr_aksv_flag(hdcp_status_flag)) {
+#ifdef CONFIG_RTK_HDCPRX_2P2
+		/* Disable HDCP 2.2 */
+		if (HDCP_2P2_CR_hdcp_2p2_en(hdmi_rx_reg_read32(HDCP_2P2_CR, HDMI_RX_MAC))) {
+
+			hdmi_rx_reg_mask32(HDCP_2P2_CR, ~HDCP_2P2_CR_hdcp_2p2_en_mask,
+				0, HDMI_RX_MAC);
+			HDMIRX_INFO("[HDCP] Discover 1.x, disable 2.2");
+		}
+#endif
+		hdmi_ioctl_struct.hdcp_state = HDCPRX_STATE_1PX_DISCOVER;/*  Discover HDCP 1.x */
+
+#ifndef CONFIG_RTK_HDCP1x_REPEATER
+		hdmi_rx_reg_write32(HDCP_FLAG1, HDCP_FLAG1_wr_aksv_flag_mask, HDMI_RX_MAC); /* Clear Aksv flag */
+#endif
+	}
+
+	if (HDCP_FLAG1_get_rd_ri_flag(hdmi_rx_reg_read32(HDCP_FLAG1, HDMI_RX_MAC)))
+		hdmi_rx_reg_write32(HDCP_FLAG1, HDCP_FLAG1_rd_ri_flag_mask, HDMI_RX_MAC);/* Clear Read Ri flag */
+
+	if (hdmi_ioctl_struct.hdcp_state == HDCPRX_STATE_1PX_DISCOVER) {
+		/* Get Ri means HDCP 1.x nego success */
+		if (HDCP_FLAG1_get_rd_ri_flag(hdcp_status_flag))
+			hdmi_ioctl_struct.hdcp_state = HDCPRX_STATE_1PX_ON;
+	}
+}
+
+#ifdef CONFIG_RTK_HDCPRX_1P4_TEE
+void HDMI_HDCP1p4_TEE_LOAD_KEY(void)
+{
+	if (TEE2p1_Flag == 0) {
+		HDMIRX_ERROR("[HDCP TEE] Load key fail, TEE driver not enable");
+		return;
+	}
+
+	CA_hdcp1p4_load();
+
+	rx_key.BKsv[0] =  Hdmi_HdcpPortRead(0x0);
+	rx_key.BKsv[1] =  Hdmi_HdcpPortRead(0x1);
+	rx_key.BKsv[2] =  Hdmi_HdcpPortRead(0x2);
+	rx_key.BKsv[3] =  Hdmi_HdcpPortRead(0x3);
+	rx_key.BKsv[4] =  Hdmi_HdcpPortRead(0x4);
+	HDMIRX_INFO("[HDCP TEE] BKSV = %02x %02x %02x %02x %02x",
+		rx_key.BKsv[0], rx_key.BKsv[1], rx_key.BKsv[2],
+		rx_key.BKsv[3], rx_key.BKsv[4]);
+
+}
+#endif
+
+/**
+ * Hdmi_HdcpInit -HDCP initial function
+ */
+void Hdmi_HdcpInit(void)
+{
+	int i;
+
+	if (!hdcpkey_enable)
+		return;
+
+	HDMIRX_INFO("[HDCP] Hdmi_HdcpInit");
+
+	/* Disable HDCP and clear HDCP address */
+	hdmi_rx_reg_write32(HDCP_CR, 0x06, HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDCP_PCR, ~HDCP_PCR_km_clk_sel_mask,
+		HDCP_PCR_km_clk_sel_mask, HDMI_RX_MAC);
+
+	/* Clear Data Port */
+	hdmi_rx_reg_mask32(HDCP_PCR, ~_BIT0, 0, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDCP_AP, 0x00, HDMI_RX_MAC);
+	for (i = 0; i < 640; i++) {
+		hdmi_rx_reg_write32(HDCP_AP, 0x43 + (i<<8), HDMI_RX_MAC);
+		hdmi_rx_reg_write32(HDCP_DP, 0x00, HDMI_RX_MAC);
+	}
+
+	hdmi_rx_reg_write32(HDCP_AP, 0x00, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDCP_PCR, ~_BIT0, _BIT0, HDMI_RX_MAC);
+
+#ifdef CONFIG_RTK_HDCPRX_1P4_TEE
+	HDMI_HDCP1p4_TEE_LOAD_KEY();
+#else
+	/* Write device private key */
+	for (i = 0; i < 320; i++)
+		hdmi_rx_reg_write32(HDCP_DKAP, rx_key.Key[i], HDMI_RX_MAC);
+#endif
+
+	/* Write BKsv into DDC channel */
+	Hdmi_HdcpPortCWrite(0x00, rx_key.BKsv, 5);
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+	Hdmi_HDCP_2_2_Init();
+	HDMI_PRINTF("HDCP2Vision = %x", Hdmi_HdcpPortRead(0x50));
+#endif
+	hdmi_rx_reg_write32(HDCP_CR, 0x00, HDMI_RX_MAC);
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+	/* Set Bcaps, repeater mode */
+	Hdmi_HdcpPortWrite(0x40, HDCP_BCAPS_REPEATER);
+	/* BIT6:repeater */
+	hdmi_rx_reg_mask32(HDCP_CR, ~(_BIT7|_BIT0|_BIT6),
+		(_BIT7|_BIT0|_BIT6), HDMI_RX_MAC);
+	/* Keep old setting */
+	Hdmi_HdcpPortWrite(0xc4, 0x00);
+	/* Enable AKSV interrupt */
+	hdmi_rx_reg_mask32(HDCP_FLAG2, ~HDCP_FLAG2_irq_aksv_en_mask,
+		HDCP_FLAG2_irq_aksv_en_mask, HDMI_RX_MAC);
+#else
+	/* Set Bcaps */
+	Hdmi_HdcpPortWrite(0x40, HDCP_BCAPS_HDMI);
+	/* Enable HDCP function for all */
+	hdmi_rx_reg_mask32(HDCP_CR, ~(_BIT7|_BIT0),
+		(_BIT7|_BIT0), HDMI_RX_MAC);/* for New_AC_Mode Enable, fix simplay bug */
+#endif
+
+}
+
+void HdmiRx_enable_hdcp(unsigned char *bksv, unsigned char *device_key)
+{
+	/* Return when already save the key */
+	if (hdcpkey_enable)
+		return;
+
+	memset(&rx_key, 0, sizeof(rx_key));
+	memcpy(&rx_key.BKsv, bksv, 5);
+	memcpy(&rx_key.Key, device_key, 320);
+
+	hdcpkey_enable = true;
+	HDMIRX_INFO("HdmiRx_enable_hdcp");
+
+	if (mipi_top.hdmi_rx_init) {
+		Hdmi_SetHPD(0);
+		Hdmi_HdcpInit();
+		HDMI_DELAYMS(500);
+		Hdmi_SetHPD(1);
+	}
+
+}
+
+unsigned char Is_HdmiRx_hdcp1x_enabled(void)
+{
+	return hdcpkey_enable;
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_hdcp2p2.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_hdcp2p2.c
new file mode 100644
index 00000000..a6dcb6a
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_hdcp2p2.c
@@ -0,0 +1,468 @@
+/*
+ * hdmirx_hdcp2p2.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmiInternal.h"
+
+static unsigned char lc128_key[16];
+static unsigned char hdcp2p2key_enable = false;
+
+unsigned char wait_init = 0;
+struct hdcp2p2_wait_event hdcp2p2_wait;
+struct hdcp2p2_wait_event stream_wait;
+
+unsigned char Repeater_clear_repeater_bit;
+/*=================== extern Variable/Function ===================*/
+extern HDMIRX_IOCTL_STRUCT_T hdmi_ioctl_struct;
+
+extern void Hdmi_HdcpPortWrite(unsigned char addr, unsigned char value);
+/*======================================================*/
+
+
+
+/* HDCP2-2  global variable */
+unsigned char g_bmsg_id;
+unsigned char g_RX_state;
+unsigned char g_Rx_Send_State;
+
+unsigned char TX_msg_id[864];
+unsigned char stream_manage_msg[10];
+unsigned char stream_manage_flag;
+unsigned char bLen;
+
+unsigned int b_Tx_Len;
+
+#define HDCP_RXstatus_addr    0x70
+/* Message ID*/
+#define IDEL                    0   /* TX=>RX */
+#define AKE_INIT                2   /* TX=>RX */
+#define AKE_Send_Cert           3   /* RX=>TX */
+#define AKE_NO_Stored_Km        4   /* TX=>RX */
+#define AKE_Stored_Km           5   /* TX=>RX */
+#define AKE_Send_H_prime        7   /* RX=>TX */
+#define AKE_Send_Pariring_Info  8   /* RX=>TX */
+#define LC_Init                 9   /* TX=>RX */
+#define LC_Send_L_prime         10  /* RX=>TX */
+#define SKE_Send_Eks            11  /* TX=>RX */
+/* Repeaterauth Message ID*/
+#define REPEATERAUTH_SEND_RECEIVERID_LIST	12  /* RX=>TX */
+#define REPEATERAUTH_SEND_ACK				15  /* TX=>RX */
+#define REPEATERAUTH_STREAM_MANAGE			16  /* TX=>RX */
+#define REPEATERAUTH_STREAM_READY			17  /* RX=>TX */
+
+/* RX send FSM*/
+#define  RX_FSM_SEND_START		1
+#define  RX_FSM_WAIT			2
+#define  RX_FSM_FINISH			3
+
+/* HDCP 2.2 OFFSET */
+#define Write_Message_offset	0x60
+#define Rxstatus_offset			0x70
+#define Read_Message_offset		0x80
+
+struct work_struct hdcp2p2_msg_work;
+struct work_struct repeaterauth_stream_work;
+static DEFINE_MUTEX(hdcprx2p2_lock);
+
+void Hdmi_HDCP_2_2_msg_work_func(struct work_struct *work);
+void repeaterauth_stream_work_func(struct work_struct *work);
+
+
+char Get_Hdmi_hdcp_2_2_Write_Message(void)
+{
+	unsigned int wr_msg_done;
+
+	wr_msg_done = HDCP_2P2_SR0_get_irq_wr_msg_done(hdmi_rx_reg_read32(HDCP_2P2_SR0, HDMI_RX_MAC));
+	if (wr_msg_done)
+		return 1;
+	else
+		return 0;
+}
+
+char Get_Hdmi_hdcp_2_2_Read_Message(void)
+{
+	unsigned int rd_msg_done;
+
+	rd_msg_done = HDCP_2P2_SR0_get_irq_rd_msg_done(hdmi_rx_reg_read32(HDCP_2P2_SR0, HDMI_RX_MAC));
+	if (rd_msg_done)
+		return 1;
+	else
+		return 0;
+}
+
+void Clear_Hdmi_hdcp_2_2_Read_Status(void)
+{
+	hdmi_rx_reg_write32(HDCP_2P2_SR0, HDCP_2P2_SR0_irq_rd_msg_done_mask, HDMI_RX_MAC);
+}
+
+void HW_Cipher_Setting(unsigned char *lc128)
+{
+	hdmi_rx_reg_mask32(HDCP_2P2_CR, ~(HDCP_2P2_CR_fw_mode_riv_mask),
+		HDCP_2P2_CR_fw_mode_riv_mask, HDMI_RX_MAC);
+
+	/* lc 128 */
+	hdmi_rx_reg_mask32(HDCP_2P2_LC0, ~HDCP_2P2_LC0_lc_mask,
+		(lc128[15]|(lc128[14]<<8)|(lc128[13]<<16)|(lc128[12]<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDCP_2P2_LC1, ~HDCP_2P2_LC1_lc_mask,
+		(lc128[11]|(lc128[10]<<8)|(lc128[9]<<16)|(lc128[8]<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDCP_2P2_LC2, ~HDCP_2P2_LC2_lc_mask,
+		(lc128[7]|(lc128[6]<<8)|(lc128[5]<<16)|(lc128[4]<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDCP_2P2_LC3, ~HDCP_2P2_LC3_lc_mask,
+		(lc128[3]|(lc128[2]<<8)|(lc128[1]<<16)|(lc128[0]<<24)), HDMI_RX_MAC);
+}
+
+void Set_Rx_status_Ready(void)
+{
+
+	hdmi_rx_reg_write32(HDCP_AP, 0x71, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDCP_DP, (0x1 << 2), HDMI_RX_MAC);
+}
+
+void DownStream_done(void)
+{
+	hdmi_rx_reg_mask32(HDCP_2P2_CR, ~HDCP_2P2_CR_downstream_done_mask,
+		HDCP_2P2_CR_downstream_done_mask, HDMI_RX_MAC);
+}
+void KS_Setting(unsigned char *bKs)
+{
+	hdmi_rx_reg_mask32(HDCP_2P2_CR, ~(HDCP_2P2_CR_fw_mode_riv_mask), HDCP_2P2_CR_fw_mode_riv_mask, HDMI_RX_MAC);
+	/* Initial ks value */
+	hdmi_rx_reg_mask32(HDCP_2P2_KS0, ~HDCP_2P2_KS0_ks_mask,
+		((*(bKs+15))|((*(bKs+14))<<8)|((*(bKs+13))<<16)|((*(bKs+12))<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDCP_2P2_KS1, ~HDCP_2P2_KS1_ks_mask,
+		((*(bKs+11))|((*(bKs+10))<<8)|((*(bKs+9))<<16)|((*(bKs+8))<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDCP_2P2_KS2, ~HDCP_2P2_KS2_ks_mask,
+		((*(bKs+7))|((*(bKs+6))<<8)|((*(bKs+5))<<16)|((*(bKs+4))<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDCP_2P2_KS3, ~HDCP_2P2_KS3_ks_mask,
+		((*(bKs+3))|((*(bKs+2))<<8)|((*(bKs+1))<<16)|((*bKs)<<24)), HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDCP_2P2_CR, ~HDCP_2P2_CR_ks_done_mask,
+		HDCP_2P2_CR_ks_done_mask, HDMI_RX_MAC);
+
+	HDMIRX_INFO("[HDCP2.2]Set KS");
+	HDMIRX_DEBUG("[HDCP2.2]KS_Setting bKs  = 0x%x , 0x%x ,0x%x ,0x%x ,0x%x ,0x%x ,0x%x ,0x%x",
+		(*bKs), *(bKs+1), *(bKs+2), *(bKs+3), *(bKs+4), *(bKs+5), *(bKs+6), *(bKs+7));
+}
+
+void Riv_Setting(unsigned char *bRiv)
+{
+	hdmi_rx_reg_mask32(HDCP_2P2_RIV0, ~HDCP_2P2_RIV0_riv_mask,
+		(*(bRiv+7)|(*(bRiv+6)<<8)|(*(bRiv+5)<<16)|(*(bRiv+4)<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDCP_2P2_RIV1, ~HDCP_2P2_RIV1_riv_mask,
+		(*(bRiv+3)|(*(bRiv+2)<<8)|(*(bRiv+1)<<16)|((*bRiv)<<24)), HDMI_RX_MAC);
+
+	HDMIRX_INFO("[HDCP2.2]Set Riv");
+	HDMIRX_DEBUG("[HDCP2.2]Riv_Setting bRiv = 0x%x , 0x%x ,0x%x ,0x%x ,0x%x ,0x%x ,0x%x ,0x%x",
+		(*bRiv), *(bRiv+1), *(bRiv+2), *(bRiv+3), *(bRiv+4), *(bRiv+5), *(bRiv+6), *(bRiv+7));
+	hdmi_ioctl_struct.hdcp_state = HDCPRX_STATE_2P2_ON;/* HDCP 2.2 nego success */
+}
+
+void init_hdcp2p2_waitqueue(void)
+{
+	if (wait_init)
+		return;
+
+	spin_lock_init(&hdcp2p2_wait.slock);
+	init_waitqueue_head(&hdcp2p2_wait.read_wq);
+	hdcp2p2_wait.condition = false;
+
+	spin_lock_init(&stream_wait.slock);
+	init_waitqueue_head(&stream_wait.read_wq);
+	stream_wait.condition = false;
+
+	wait_init = 1;
+}
+
+void HdmiRx_enable_hdcp2p2(unsigned char *key)
+{
+	if (hdcp2p2key_enable)/* Already save the key, return */
+		return;
+
+	if ((key[0] == 0) && (key[1] == 0) && (key[2] == 0) &&
+		(key[3] == 0) && (key[4] == 0))
+		HDMIRX_INFO("[HDCP2.2] Empty key, should be TEE case");
+
+	memset(&lc128_key, 0, sizeof(lc128_key));
+	memcpy(&lc128_key, key, sizeof(lc128_key));
+
+	HDMIRX_INFO("[HDCP2.2] HDCP RX INIT");
+
+	hdcp2p2key_enable = true;
+}
+
+unsigned char Is_HdmiRx_hdcp2p2_enabled(void)
+{
+	return hdcp2p2key_enable;
+}
+
+void Hdmi_HDCP_2_2_Init(void)
+{
+	static unsigned char init_work_flag = 0;
+
+	HDMIRX_INFO("[HDCP2.2] Hdmi_HDCP_2_2_Init");
+
+	Repeater_clear_repeater_bit = 0;
+
+	if (!hdcp2p2key_enable) {
+		HDMIRX_INFO("[HDCP2.2] key not ready");
+		return;
+	}
+
+	/* Init msg work */
+	if (!init_work_flag) {
+		INIT_WORK(&hdcp2p2_msg_work, Hdmi_HDCP_2_2_msg_work_func);
+		INIT_WORK(&repeaterauth_stream_work, repeaterauth_stream_work_func);
+		init_work_flag = 1;
+	}
+
+	hdmi_rx_reg_mask32(HDCP_2P2_CR, ~HDCP_2P2_CR_hdcp_2p2_en_mask,
+		0, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDCP_2P2_SR1, ~HDCP_2P2_SR1_irq_wr_msg_done_en_mask,
+		HDCP_2P2_SR1_irq_wr_msg_done_en_mask, HDMI_RX_MAC);
+
+	/* Should not set cipher when TEE path on */
+	if (lc128_key[0] || lc128_key[1] || lc128_key[2] ||
+		lc128_key[3] || lc128_key[4])
+		HW_Cipher_Setting(&lc128_key[0]);/* SET Lc  */
+
+	/* enable hdcp 2.2 HW interrupt */
+	Hdmi_HdcpPortWrite(0x50, 0x04);/* support hdcp2.2 */
+	hdmi_rx_reg_mask32(HDCP_2P2_SR1, ~HDCP_2P2_SR1_irq_wr_msg_done_en_mask,
+		HDCP_2P2_SR1_irq_wr_msg_done_en_mask, HDMI_RX_MAC);
+}
+
+char  Hdmi_HDCP2_2_Write_Data_to_TX(unsigned char *bSendData, unsigned int wLen)
+{
+	unsigned int i;
+
+	if (bSendData == NULL)
+		return FALSE;
+
+	HDMI_PRINTF("[HDCP2.2] bSendData(%d)\n", bSendData[0]);
+
+	mutex_lock(&hdcprx2p2_lock);
+
+	for (i = 0; i < wLen; i++) {
+		hdmi_rx_reg_write32(HDCP_MSAP, i, HDMI_RX_MAC);
+		hdmi_rx_reg_write32(HDCP_MSDP, *(bSendData+i), HDMI_RX_MAC);
+	}
+
+	hdmi_rx_reg_write32(HDCP_AP, HDCP_RXstatus_addr, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDCP_DP, (wLen&0xFF), HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDCP_AP, HDCP_RXstatus_addr+1, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDCP_DP, ((wLen&0x3FF)>>8), HDMI_RX_MAC);
+
+	mutex_unlock(&hdcprx2p2_lock);
+
+	return TRUE;
+}
+
+void Hdmi_HDCP_2_2_Force_Cipher(void)
+{
+	hdmi_rx_reg_mask32(HDCP_2P2_CR, ~(HDCP_2P2_CR_switch_state_mask),
+		HDCP_2P2_CR_switch_state(0x10), HDMI_RX_MAC);/* set authenticated */
+	hdmi_rx_reg_mask32(HDCP_2P2_CR, ~(HDCP_2P2_CR_apply_state_mask | HDCP_2P2_CR_fw_mode_riv_mask),
+		(HDCP_2P2_CR_apply_state_mask | HDCP_2P2_CR_fw_mode_riv_mask), HDMI_RX_MAC);
+
+}
+
+void Hdmi_HDCP_2_2_msg_work_func(struct work_struct *work)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&hdcp2p2_wait.slock, flags);
+	hdcp2p2_wait.condition = true;
+	wake_up_interruptible(&hdcp2p2_wait.read_wq);
+	spin_unlock_irqrestore(&hdcp2p2_wait.slock, flags);
+}
+
+void repeaterauth_stream_work_func(struct work_struct *work)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&stream_wait.slock, flags);
+	stream_wait.condition = true;
+	wake_up_interruptible(&stream_wait.read_wq);
+	spin_unlock_irqrestore(&stream_wait.slock, flags);
+}
+
+void  Hdmi_HDCP_2_2_msg_hander(void)
+{
+	unsigned char i;
+	/* GET TX mesage */
+	if (Get_Hdmi_hdcp_2_2_Write_Message()) {
+		/* Must close hdcp1.4 when discover hdcp2.2 */
+		if (HDCP_CR_get_hdcp_en(hdmi_rx_reg_read32(HDCP_CR, HDMI_RX_MAC))) {
+			hdmi_rx_reg_mask32(HDCP_CR, ~HDCP_CR_hdcp_en_mask, 0, HDMI_RX_MAC);
+			HDMIRX_INFO("[HDCP2.2] Discover 2.2, disable 1.4");
+		}
+		/* Open hdcp2p2 */
+		hdmi_rx_reg_mask32(HDCP_2P2_CR, ~HDCP_2P2_CR_hdcp_2p2_en_mask,
+			HDCP_2P2_CR_hdcp_2p2_en_mask, HDMI_RX_MAC);
+		hdmi_rx_reg_write32(HDCP_MSAP, 0, HDMI_RX_MAC);
+		g_bmsg_id = hdmi_rx_reg_read32(HDCP_MSDP, HDMI_RX_MAC);
+		TX_msg_id[0] = g_bmsg_id;
+		HDMI_PRINTF("[HDCP2.2] bmsg_id  =%x\n", g_bmsg_id);
+
+		g_Rx_Send_State = RX_FSM_SEND_START;
+		switch (g_bmsg_id) {
+		case AKE_INIT:
+			HDMIRX_INFO("[HDCP2.2] AKE_INIT");
+			/* Discover HDCP 2.2 */
+			hdmi_ioctl_struct.hdcp_state = HDCPRX_STATE_2P2_DISCOVER;
+			g_RX_state = AKE_Send_Cert;
+			bLen = 11;
+			stream_manage_flag = 0;
+			break;
+		case AKE_NO_Stored_Km:
+			HDMIRX_INFO("[HDCP2.2] AKE_NO_Stored_Km");
+			g_RX_state =  AKE_Send_H_prime;
+			bLen = 128;
+			break;
+		case AKE_Stored_Km:
+			HDMIRX_INFO("[HDCP2.2] AKE_Stored_Km");
+			g_RX_state =  AKE_Send_H_prime;
+			bLen = 32;
+			break;
+		case LC_Init:
+			/* HDMIRX_INFO("[HDCP2.2] LC_Init"); */
+			/* Need reply in 20ms */
+			g_RX_state = LC_Send_L_prime;
+			bLen = 8;
+			break;
+		case SKE_Send_Eks:
+			HDMIRX_INFO("[HDCP2.2] SKE_Send_Eks");
+			hdmi_rx_reg_mask32(HDCP_2P2_CR, ~HDCP_2P2_CR_switch_state_mask,
+				HDCP_2P2_CR_switch_state(0x01), HDMI_RX_MAC);
+			hdmi_rx_reg_mask32(HDCP_2P2_CR, ~HDCP_2P2_CR_apply_state_mask,
+				HDCP_2P2_CR_apply_state_mask, HDMI_RX_MAC);
+			bLen = 24;
+			break;
+		case REPEATERAUTH_SEND_ACK:
+			bLen = 16;
+			break;
+		case REPEATERAUTH_STREAM_MANAGE:
+			/* HDMIRX_INFO("[HDCP2.2] REPEATERAUTH_STREAM_MANAGE"); */
+			bLen = 7; /* k=1 */
+			break;
+		default:
+			bLen = 0;
+			HDMI_PRINTF("[HDCP2.2] Unknown message\n");
+			break;
+		}
+
+		if (g_bmsg_id != REPEATERAUTH_STREAM_MANAGE) {
+			for (i = 1; i <= bLen; i++)
+				TX_msg_id[i] = hdmi_rx_reg_read32(HDCP_MSDP, HDMI_RX_MAC);
+		} else {
+			stream_manage_flag = 1;
+			stream_manage_msg[0] = g_bmsg_id;
+			for (i = 1; i <= 7; i++)
+				stream_manage_msg[i] = hdmi_rx_reg_read32(HDCP_MSDP, HDMI_RX_MAC);
+		}
+
+		/* For HW Cipher setting */
+		if (g_bmsg_id == SKE_Send_Eks)
+			Riv_Setting((&(TX_msg_id[17])));/* Set Riv address */
+
+		/* Clear interrupt */
+		hdmi_rx_reg_write32(HDCP_2P2_SR0, HDCP_2P2_SR0_irq_wr_msg_done_mask, HDMI_RX_MAC);
+		hdmi_rx_reg_write32(HDMI_INTCR, 0x80, HDMI_RX_MAC);
+
+		if (g_bmsg_id != REPEATERAUTH_STREAM_MANAGE)
+			schedule_work(&hdcp2p2_msg_work);
+		else
+			schedule_work(&repeaterauth_stream_work);
+	}
+
+}
+
+int get_hdcp2p2_msg(struct rx_hdcp22_msg *msg)
+{
+	int i;
+	unsigned long flags;
+
+	spin_lock_irqsave(&hdcp2p2_wait.slock, flags);
+	hdcp2p2_wait.condition = false;
+	spin_unlock_irqrestore(&hdcp2p2_wait.slock, flags);
+
+	wait_event_interruptible(hdcp2p2_wait.read_wq, hdcp2p2_wait.condition);
+
+	msg->g_RX_state = g_RX_state;
+	for (i = 0; i <= bLen; i++)
+		msg->msg[i] = TX_msg_id[i];
+	msg->bLen = bLen;
+
+	return 0;
+}
+
+int write_hdcp2p2_msg_to_tx(struct rx_hdcp22_msg *msg)
+{
+
+	Hdmi_HDCP2_2_Write_Data_to_TX(msg->msg, msg->bLen);
+
+	return 0;
+}
+
+int get_stream_msg(struct rx_hdcp22_msg *msg)
+{
+	int i;
+	unsigned long flags;
+
+	HDMIRX_INFO("[HDCP2.2] get_stream_msg enter");
+
+	spin_lock_irqsave(&stream_wait.slock, flags);
+	stream_wait.condition = false;
+	spin_unlock_irqrestore(&stream_wait.slock, flags);
+
+	wait_event_interruptible(stream_wait.read_wq, stream_wait.condition);
+
+	msg->bLen = 7;
+	for (i = 0; i <= 7; i++)
+		msg->msg[i] = stream_manage_msg[i];
+
+	HDMIRX_INFO("[HDCP2.2] get_stream_msg exit");
+
+	return 0;
+}
+
+void set_hdcp2p2_condition(void)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&hdcp2p2_wait.slock, flags);
+	hdcp2p2_wait.condition = true;
+	wake_up_interruptible(&hdcp2p2_wait.read_wq);
+	spin_unlock_irqrestore(&hdcp2p2_wait.slock, flags);
+}
+
+int set_hdcp2p2_ks(struct rx_hdcp22_ks *ks)
+{
+	KS_Setting(&ks->bks[0]);
+
+	return 0;
+}
+
+int get_hdcp2p2_msg_done(int *done)
+{
+	*done = (int)Get_Hdmi_hdcp_2_2_Read_Message();
+	return 0;
+}
+
+int set_hdcp2p2_switch_state(int *state)
+{
+	hdmi_rx_reg_mask32(HDCP_2P2_CR, ~HDCP_2P2_CR_switch_state_mask,
+		HDCP_2P2_CR_switch_state(0x10), HDMI_RX_MAC); /* authenticated */
+	hdmi_rx_reg_mask32(HDCP_2P2_CR, ~HDCP_2P2_CR_apply_state_mask,
+		HDCP_2P2_CR_apply_state_mask, HDMI_RX_MAC);
+
+	return 0;
+}
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_hdcp2p2.h b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_hdcp2p2.h
new file mode 100644
index 00000000..cbbe711
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_hdcp2p2.h
@@ -0,0 +1,30 @@
+/*
+ * hdmirx_hdcp2p2.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDCP2P2_H_
+#define __HDCP2P2_H_
+
+#include "hdcp2p2_dev.h"
+
+unsigned char Is_HdmiRx_hdcp2p2_enabled(void);
+
+void init_hdcp2p2_waitqueue(void);
+int get_hdcp2p2_msg(struct rx_hdcp22_msg *msg);
+int write_hdcp2p2_msg_to_tx(struct rx_hdcp22_msg *msg);
+int get_stream_msg(struct rx_hdcp22_msg *msg);
+int set_hdcp2p2_ks(struct rx_hdcp22_ks *ks);
+void Clear_Hdmi_hdcp_2_2_Read_Status(void);
+int get_hdcp2p2_msg_done(int *done);
+void Set_Rx_status_Ready(void);
+void DownStream_done(void);
+int set_hdcp2p2_switch_state(int *state);
+
+#endif /* __HDCP2P2_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_merge_EDID.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_merge_EDID.c
new file mode 100644
index 00000000..368f8e30
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_merge_EDID.c
@@ -0,0 +1,316 @@
+/*
+ * hdmirx_merge_EDID.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmiEDID.h"
+#include "hdmitx.h"
+
+const unsigned char base_block[128] = {
+	0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x4A, 0x8B, 0x95, 0x12, 0x00, 0x00, 0x00, 0x00,
+	0xFF, 0x1A, 0x01, 0x03, 0x81, 0x46, 0x27, 0x78, 0x8A, 0xA5, 0x8E, 0xA6, 0x54, 0x4A, 0x9C, 0x26,
+	0x12, 0x45, 0x46, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
+	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0xFC, 0x00, 0x52, 0x54, 0x44, 0x31, 0x32,
+	0x39, 0x35, 0x0A, 0x20, 0x20, 0x20, 0x20, 0x20, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02
+};
+
+const unsigned char speaker_alloc[4] = {
+	0x83, 0x01, 0x00, 0x00
+};
+const unsigned int speaker_alloc_size = sizeof(speaker_alloc);
+
+const unsigned char vendor_specific[8] = {
+	0x67, 0x03, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x3C
+};
+const unsigned int vendor_specific_size = sizeof(vendor_specific);
+
+const unsigned char colorimetry[4] = {
+	0xE3, 0x05, 0x00, 0x00
+};
+const unsigned int colorimetry_size = sizeof(colorimetry);
+
+/**
+ * int rx_video_support - RX support VIC list
+ */
+#define VIDEO_ARRAY_SIZE 9
+const int rx_video_support[VIDEO_ARRAY_SIZE] = {
+	2, 4, 5, 16, 17, 20, 31, 32, 34
+};
+
+/**
+ * Audio format code
+ * 0x1:PCM,  0x2:AC-3,  0x3:MPEG1-L1/L2,  0x4:MPEG1-L3(MP3)
+ * 0x5:MPEG2(multi-ch),  0x6:AAC,  0x7:DTS,  0x8: ATRAC
+ * 0x9:One-Bit Audio,  0xa:AC-3 Plus,  0xb:DTS-HD,  0xc:MLP(TrueHD)
+ * 0xd:DST,  0xe:WMA Pro
+ */
+#define AUDIO_ARRAY_SIZE 6
+const struct Audio_desc rx_audio_support[AUDIO_ARRAY_SIZE] = {
+	/* PCM: 2CH, 32/44.1/48/88.2/96/176.4/192, 16bit/20bit/24bit */
+	{.coding_type = 0x1,
+	 .channel_count = 2,
+	 .sample_freq_all = 0x7F,
+	 .sample_size_all = 0x7,},
+	/* AC3: 6CH, 32/44.1/48, MaxBitRate 640kHz */
+	{.coding_type = 0x2,
+	 .channel_count = 6,
+	 .sample_freq_all = 0x7,
+	 .max_bit_rate_divided_by_8KHz = 0x50,},
+	/* DTS: 6CH, 32/44.1/48, MaxBitRate 1536kHz */
+	{.coding_type = 0x7,
+	 .channel_count = 6,
+	 .sample_freq_all = 0x7,
+	 .max_bit_rate_divided_by_8KHz = 0xC0,},
+	/* AAC: 8CH, 32/44.1/48/88.2/96, MaxBitRate 2040kHz */
+	{.coding_type = 0x6,
+	 .channel_count = 8,
+	 .sample_freq_all = 0x1F,
+	 .max_bit_rate_divided_by_8KHz = 0xFF,},
+	/* DTS-HD: 6CH, 32/44.1/48 */
+	{.coding_type = 0xB,
+	 .channel_count = 6,
+	 .sample_freq_all = 0x7,},
+	/* AC-3 Plus: 8CH, 32/44.1/48 */
+	{.coding_type = 0xA,
+	 .channel_count = 8,
+	 .sample_freq_all = 0x7,},
+};
+
+/**
+ * struct merge_edid_data
+ * @color_formats: [Bit2] YUV422, [Bit1] YUV444, [Bit0] RGB
+ * @video_size: number of VICs in video_list
+ * @video_list: merged VICs
+ * @audio_size: number of audio data in audio_list
+ * @audio_list: merged audio data
+ */
+struct merge_edid_data {
+	int color_formats;
+	int	video_size;
+	int video_list[VIDEO_ARRAY_SIZE];
+	int audio_size;
+	struct Audio_desc audio_list[AUDIO_ARRAY_SIZE];
+};
+
+struct merge_edid_data edid_data;
+
+void merge_video_data(uint64_t vic)
+{
+	int i;
+
+	HDMIRX_INFO("Merge EDID video data, vic(0x%016llx)", vic);
+
+	edid_data.video_size = 0;
+	for (i = 0; i < VIDEO_ARRAY_SIZE; i++) {
+
+		if (vic & BIT(rx_video_support[i]-1)) {
+			edid_data.video_list[edid_data.video_size] = rx_video_support[i];
+			edid_data.video_size++;
+		}
+	}
+
+	/* Dump match VICs */
+	for (i = 0; i < edid_data.video_size; i++)
+		HDMIRX_DEBUG("Index(%d) VIC(%d)", i, edid_data.video_list[i]);
+
+	if (edid_data.video_size == 0) {
+		HDMIRX_INFO("Merge EDID video data fail, no one match");
+		edid_data.video_size = 2;
+		edid_data.video_list[0] = 32;
+		edid_data.video_list[1] = 34;
+	}
+}
+
+int get_audio_index(unsigned char	coding_type)
+{
+	unsigned int i;
+
+	for (i = 0; i < AUDIO_ARRAY_SIZE; i++) {
+		if (coding_type == rx_audio_support[i].coding_type)
+			return i;
+	}
+
+	return -1;
+}
+
+void merge_audio_data(struct Audio_Data *audio_data)
+{
+	unsigned int i, j;
+	unsigned char coding_type;
+	unsigned char tx_temp, rx_temp;
+	int index;
+
+	HDMIRX_INFO("Merge EDID audio data, ADB_length(%d)", audio_data->ADB_length);
+
+	j = 0;
+	for (i = 0; i < audio_data->ADB_length; i++) {
+		index = get_audio_index(audio_data->ADB[i].coding_type);
+		if (index >= 0) {
+			coding_type = audio_data->ADB[i].coding_type;
+			edid_data.audio_list[j].coding_type = coding_type;
+
+			tx_temp = audio_data->ADB[i].channel_count;
+			rx_temp = rx_audio_support[index].channel_count;
+			edid_data.audio_list[j].channel_count = min(tx_temp, rx_temp);
+
+			tx_temp = audio_data->ADB[i].sample_freq_all;
+			rx_temp = rx_audio_support[index].sample_freq_all;
+			edid_data.audio_list[j].sample_freq_all = tx_temp & rx_temp;
+
+			if (coding_type == 0x1) {
+				tx_temp = audio_data->ADB[i].sample_size_all;
+				rx_temp = rx_audio_support[index].sample_size_all;
+				edid_data.audio_list[j].sample_size_all = tx_temp & rx_temp;
+			} else if ((coding_type >= 2) && (coding_type <= 8)) {
+				tx_temp = audio_data->ADB[i].max_bit_rate_divided_by_8KHz;
+				rx_temp = rx_audio_support[index].max_bit_rate_divided_by_8KHz;
+				edid_data.audio_list[j].max_bit_rate_divided_by_8KHz = min(tx_temp, rx_temp);
+			}
+
+			j++;
+		}
+	}
+	edid_data.audio_size = j;
+
+	HDMIRX_INFO("Merge_EDID, number of match audio format(%u)", edid_data.audio_size);
+	/* Dump match audio */
+	for (i = 0; i < edid_data.audio_size; i++) {
+		HDMIRX_DEBUG("coding_type(%u)", edid_data.audio_list[i].coding_type);
+		HDMIRX_DEBUG("channel_count(%u)", edid_data.audio_list[i].channel_count);
+		HDMIRX_DEBUG("sample_freq_all(0x%x)", edid_data.audio_list[i].sample_freq_all);
+		HDMIRX_DEBUG("sample_size_all(0x%x)", edid_data.audio_list[i].sample_size_all);
+		HDMIRX_DEBUG("max_bit_rate_divided_by_8KHz(0x%x)", edid_data.audio_list[i].max_bit_rate_divided_by_8KHz);
+	}
+
+	if (edid_data.audio_size == 0) {
+		HDMIRX_INFO("Merge EDID audio data fail, no one match");
+		edid_data.audio_size = 1;
+		edid_data.audio_list[0].coding_type = 0x1;
+		edid_data.audio_list[0].channel_count = 0x2;
+		edid_data.audio_list[0].sample_freq_all = 0x6;
+		edid_data.audio_list[0].sample_size_all = 0x0;
+	}
+}
+
+
+/**
+ * gernerate_EDID - Generate specific EDID
+ * @data: Input EDID info
+ * @edid_buf: Output EDID buffer, 256bytes
+ *  Retn : N/A
+ */
+void gernerate_EDID(struct merge_edid_data *data, unsigned char *edid_buf)
+{
+	unsigned int i;
+	unsigned int index = 0;
+	unsigned int data_block_size;
+	unsigned int sum = 0;
+
+	memset(edid_buf, 0, 256);
+
+	/* Base block 128Bytes */
+	memcpy(&edid_buf[index], base_block, sizeof(base_block));
+	index += sizeof(base_block);
+
+	/* Skip CEA Header */
+	index += 4;
+	data_block_size = 4;
+
+	/* Speaker Allocation	*/
+	memcpy(&edid_buf[index], speaker_alloc, speaker_alloc_size);
+	index += speaker_alloc_size;
+	data_block_size += speaker_alloc_size;
+
+	/* Vendor Specific 1.4b */
+	memcpy(&edid_buf[index], vendor_specific, vendor_specific_size);
+	index += vendor_specific_size;
+	data_block_size += vendor_specific_size;
+
+	/* Video Data */
+	edid_buf[index] = (0x2<<5) | (data->video_size);
+	index++;
+	data_block_size++;
+	for (i = 0; i < data->video_size; i++)
+		edid_buf[index++] = data->video_list[i];
+
+	data_block_size += data->video_size;
+
+	/* Audio Data */
+	edid_buf[index] = (0x1<<5) | (data->audio_size*3);
+	index++;
+	data_block_size++;
+	for (i = 0; i < data->audio_size; i++) {
+		edid_buf[index++] = ((data->audio_list[i].coding_type & 0xF) << 3) |
+							((data->audio_list[i].channel_count - 1) & 0x7);
+		edid_buf[index++] = data->audio_list[i].sample_freq_all;
+
+		if (data->audio_list[i].coding_type == 1) {
+			edid_buf[index++] = data->audio_list[i].sample_size_all;
+		} else if ((data->audio_list[i].coding_type >= 2) &&
+					(data->audio_list[i].coding_type <= 8)) {
+			edid_buf[index++] = data->audio_list[i].max_bit_rate_divided_by_8KHz;
+		} else {
+			edid_buf[index++] = 0;
+		}
+	}
+	data_block_size += data->audio_size*3;
+
+	/* Colorimetry */
+	memcpy(&edid_buf[index], colorimetry, colorimetry_size);
+	index += colorimetry_size;
+	data_block_size += colorimetry_size;
+
+	/* CEA Header */
+	edid_buf[0x80] = 0x02;
+	edid_buf[0x81] = 0x03;
+	edid_buf[0x82] = data_block_size;
+	edid_buf[0x83] = BIT(6);/* Audio */
+	if (data->color_formats & DRM_COLOR_FORMAT_YCRCB444)
+		edid_buf[0x83] |= BIT(5);
+	if (data->color_formats & DRM_COLOR_FORMAT_YCRCB422)
+		edid_buf[0x83] |= BIT(4);
+
+	/* Calculate and set checksum */
+	for (i = 0x80; i < 0xFF; i++)
+		sum += edid_buf[i];
+	edid_buf[0xFF] = (0x100-(sum&0xFF))&0xFF;
+
+}
+
+void hdmirx_merge_EDID(struct sink_capabilities_t *sink_cap)
+{
+	int i;
+	unsigned char edid_buf[256];
+
+	memset(&edid_data, 0, sizeof(edid_data));
+
+	edid_data.color_formats = sink_cap->display_info.color_formats;
+
+	merge_video_data(sink_cap->vic);
+
+	merge_audio_data(&sink_cap->audio_data);
+
+	gernerate_EDID(&edid_data, edid_buf);
+
+	HdmiRx_ChangeCurrentEDID(edid_buf);
+
+	for (i = 0; i < 16; i++) {
+		HDMIRX_DEBUG("%02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x",
+			edid_buf[i*16], edid_buf[i*16+1], edid_buf[i*16+2], edid_buf[i*16+3],
+			edid_buf[i*16+4], edid_buf[i*16+5], edid_buf[i*16+6], edid_buf[i*16+7],
+			edid_buf[i*16+8], edid_buf[i*16+9], edid_buf[i*16+10], edid_buf[i*16+11],
+			edid_buf[i*16+12], edid_buf[i*16+13], edid_buf[i*16+14], edid_buf[i*16+15]);
+	}
+}
+
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_reg.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_reg.c
new file mode 100644
index 00000000..a529f84
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_reg.c
@@ -0,0 +1,34 @@
+/*
+ * hdmirx_reg.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "asm/io.h"
+#include "hdmirx_reg.h"
+
+void __iomem *hdmi_rx_base[HDMI_RX_REG_BLOCK_NUM];
+
+
+unsigned int hdmi_rx_reg_read32 (unsigned int addr_offset, HDMI_RX_REG_BASE_TYPE type)
+{
+	return readl(hdmi_rx_base[type] + addr_offset);
+}
+
+void hdmi_rx_reg_write32 (unsigned int addr_offset, unsigned int value, HDMI_RX_REG_BASE_TYPE type)
+{
+	writel(value, hdmi_rx_base[type] + addr_offset);
+}
+
+void hdmi_rx_reg_mask32(unsigned int addr_offset, unsigned int andMask,
+	unsigned int orMask, HDMI_RX_REG_BASE_TYPE type)
+{
+	hdmi_rx_reg_write32(addr_offset, ((hdmi_rx_reg_read32(addr_offset, type) & (andMask)) | (orMask)), type);
+}
+
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_reg.h b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_reg.h
new file mode 100644
index 00000000..360a37a
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_reg.h
@@ -0,0 +1,81 @@
+/*
+ * hdmirx_reg.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDMIRX_REG_H__
+#define __HDMIRX_REG_H__
+
+#include "iso_cbus_tx_reg.h"
+#include "HDMI_fw.h"
+#include "HDMIRXDDC_fw.h"
+#include "MHL_fw.h"
+#include "DFE_fw.h"
+#include "DFE_HDMI_RX_PHY_fw.h"
+#include "hdmirx_wrapper_reg.h"
+#include "mipi_wrapper_reg.h"
+#include "mipi_aphy_reg.h"
+#include "mipi_dphy_reg.h"
+
+
+/* Definitions of Bits */
+#define _ZERO                       0x00
+#define _BIT0                       0x01
+#define _BIT1                       0x02
+#define _BIT2                       0x04
+#define _BIT3                       0x08
+#define _BIT4                       0x10
+#define _BIT5                       0x20
+#define _BIT6                       0x40
+#define _BIT7                       0x80
+#define _BIT8                       0x0100
+#define _BIT9                       0x0200
+#define _BIT10                      0x0400
+#define _BIT11                      0x0800
+#define _BIT12                      0x1000
+#define _BIT13                      0x2000
+#define _BIT14                      0x4000
+#define _BIT15                      0x8000
+#define _BIT16                      0x10000
+#define _BIT17                      0x20000
+#define _BIT18                      0x40000
+#define _BIT19                      0x80000
+#define _BIT20                      0x100000
+#define _BIT21                      0x200000
+#define _BIT22                      0x400000
+#define _BIT23                      0x800000
+#define _BIT24                      0x1000000
+#define _BIT25                      0x2000000
+#define _BIT26                      0x4000000
+#define _BIT27                      0x8000000
+#define _BIT28                      0x10000000
+#define _BIT29                      0x20000000
+#define _BIT30                      0x40000000
+#define _BIT31                      0x80000000
+
+typedef enum {
+	HDMI_TX_CBUS = 0,
+	HDMI_RX_MAC = 1,
+	HDMI_RX_MHL = 1,
+	HDMI_RX_PHY = 1,
+	HDMI_RX_DEF = 1,
+	HDMI_RX_HDMI_WRAPPER = 2,
+	HDMI_RX_DDC = 3,
+	HDMI_RX_MIPI_PHY = 4,
+	HDMI_RX_MIPI = 5,
+	HDMI_RX_REG_BLOCK_NUM = 6
+} HDMI_RX_REG_BASE_TYPE;
+
+
+unsigned int hdmi_rx_reg_read32 (unsigned int addr_offset, HDMI_RX_REG_BASE_TYPE type);
+void hdmi_rx_reg_write32(unsigned int addr_offset, unsigned int value, HDMI_RX_REG_BASE_TYPE type);
+void hdmi_rx_reg_mask32(unsigned int addr_offset, unsigned int andMask,
+	unsigned int orMask, HDMI_RX_REG_BASE_TYPE type);
+
+#endif/* __HDMIRX_REG_H__ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_repeater.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_repeater.c
new file mode 100644
index 00000000..3d6ce4c
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_repeater.c
@@ -0,0 +1,159 @@
+/*
+ * hdmirx_repeater.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmirx_video_dev.h"
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmirx_reg.h"
+#include "mipi_wrapper.h"
+
+#include "rx_drv/hdmiInternal.h"
+
+#if HDMI_REPEATER_SUPPORT
+void __iomem *pll_hdmi2_vaddr;
+void __iomem *disp_pll_vaddr;
+
+void __iomem *pll_ldo1_vaddr;
+void __iomem *pll_ldo2_vaddr;
+void __iomem *pll_ldo3_vaddr;
+void __iomem *pll_ldo4_vaddr;
+void __iomem *pll_ldo5_vaddr;
+
+int hdmi_repeater_mode = 0;/* 0:regular mode, 1:repeater mode */
+
+/*=================== extern Variable/Function ===================*/
+extern MIPI_TOP_INFO mipi_top;
+extern HDMI_INFO_T hdmi;
+
+extern void Hdmi_SetHPD(char high);
+/*======================================================*/
+
+void Set_Hdmitx_source(unsigned char repeater)
+{
+	unsigned int reg_val;
+
+	if (repeater) {
+		/* Bit25:Bit24 */
+		reg_val = readl(pll_ldo3_vaddr)&0xFCFFFFFF;
+
+		/* Set TX clock input from RX */
+		writel(reg_val|(1<<25), pll_ldo3_vaddr);
+
+		/* Set TX data input from RX */
+		writel((1<<26)|(1<<25), disp_pll_vaddr);
+
+		/* Enable HDMI repeater 1.4 mode */
+		hdmi_rx_reg_write32(HDMIRPT, 0x1, HDMI_RX_PHY);
+	} else {
+		/*Set TX clock input from TX */
+		writel(readl(pll_ldo3_vaddr)&0xFCFFFFFF, pll_ldo3_vaddr);
+
+		/* Set TX data input from TX */
+		writel((1<<26), disp_pll_vaddr);
+
+		/* Disable HDMI repeater mode */
+		hdmi_rx_reg_write32(HDMIRPT, 0x0, HDMI_RX_PHY);
+	}
+}
+
+void Set_Hdmitx_PLL(void)
+{
+	unsigned int tmds;
+
+	if (!hdmi_repeater_mode)
+		return;
+
+	tmds = hdmi.b*27/256;
+	if (TMDS_CPS_get_pll_div2_en(hdmi_rx_reg_read32(TMDS_CPS, HDMI_RX_MAC)))
+		tmds = tmds*2;
+
+	HDMIRX_INFO("Set TX PLL, TMDS(%u)", tmds);
+
+	if (tmds > 155) {
+		/* 297MHz */
+		writel(0x00190034, pll_ldo1_vaddr);
+		writel(0x03fc00ff, pll_ldo2_vaddr);
+		writel(0x00bed800, pll_ldo3_vaddr);
+		writel(0x0a00c6d3, pll_ldo4_vaddr);
+		writel(0x00000526, pll_ldo5_vaddr);
+		writel(0x00020210, pll_hdmi2_vaddr);
+	} else if (tmds > 140) {
+		/* 148.5MHz */
+		writel(0x19001005, pll_ldo1_vaddr);
+		writel(0x03fc00ff, pll_ldo2_vaddr);
+		writel(0x00bed800, pll_ldo3_vaddr);
+		writel(0x0a00c000, pll_ldo4_vaddr);
+		writel(0x00000100, pll_ldo5_vaddr);
+		writel(0x00040221, pll_hdmi2_vaddr);
+	} else if (tmds > 70) {
+		/* 74.25MHz */
+		writel(0x0000000f, pll_ldo1_vaddr);
+		writel(0x015400f0, pll_ldo2_vaddr);
+		writel(0x00249000, pll_ldo3_vaddr);
+		writel(0x0000c092, pll_ldo4_vaddr);
+		writel(0x00000002, pll_ldo5_vaddr);
+		writel(0x00060232, pll_hdmi2_vaddr);
+	} else {
+		/* 27MHz */
+		writel(0x00000c0f, pll_ldo1_vaddr);
+		writel(0x035400f0, pll_ldo2_vaddr);
+		writel(0x003c7000, pll_ldo3_vaddr);
+		writel(0x0000c092, pll_ldo4_vaddr);
+		writel(0x00000307, pll_ldo5_vaddr);
+		writel(0x00080243, pll_hdmi2_vaddr);
+	}
+
+	Set_Hdmitx_source(1);
+}
+
+int Get_Hdmi_repeater_mode(void)
+{
+	return hdmi_repeater_mode;
+}
+
+void Set_Hdmi_repeater_mode(int enable)
+{
+
+	if (hdmi_repeater_mode == enable)
+		return;
+
+	if (enable) {
+		HDMIRX_INFO("Enable HDMI repeater mode");
+		pll_hdmi2_vaddr = ioremap(0x98000194, 0x4);
+		pll_ldo1_vaddr = ioremap(0x98000230, 0x4);
+		pll_ldo2_vaddr = ioremap(0x98000234, 0x4);
+		pll_ldo3_vaddr = ioremap(0x98000238, 0x4);
+		pll_ldo4_vaddr = ioremap(0x9800023C, 0x4);
+		pll_ldo5_vaddr = ioremap(0x98000240, 0x4);
+		disp_pll_vaddr = ioremap(0x98000024, 0x4);
+
+		if (mipi_top.hdmi_rx_init) {
+			Hdmi_SetHPD(0);
+			usleep_range(500000, 600000);
+			Hdmi_SetHPD(1);
+		}
+
+	} else {
+		HDMIRX_INFO("Disable HDMI repeater mode");
+		Set_Hdmitx_source(0);
+
+		iounmap(pll_hdmi2_vaddr);
+		iounmap(pll_ldo1_vaddr);
+		iounmap(pll_ldo2_vaddr);
+		iounmap(pll_ldo3_vaddr);
+		iounmap(pll_ldo4_vaddr);
+		iounmap(pll_ldo5_vaddr);
+		iounmap(disp_pll_vaddr);
+	}
+
+	hdmi_repeater_mode = enable;
+}
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_sysfs.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_sysfs.c
new file mode 100644
index 00000000..b974efa
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_sysfs.c
@@ -0,0 +1,147 @@
+/*
+ * hdmirx_sysfs.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmiEDID.h"
+#ifdef CONFIG_RTK_HDCPRX_2P2
+#include "hdmirx_hdcp2p2.h"
+#endif
+
+#include "rx_drv/hdmiInternal.h"
+
+extern HDMIRX_IOCTL_STRUCT_T hdmi_ioctl_struct;
+#if HDMI_REPEATER_SUPPORT
+extern int Get_Hdmi_repeater_mode(void);
+extern void Set_Hdmi_repeater_mode(int enable);
+#endif
+
+static DEFINE_MUTEX(hdmirx_sysfs_lock);
+
+static ssize_t hdmirx_edid_version_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+	ret_count = sprintf(buf, "%s\n", HdmiRx_GetEDID_version()?"2.0":"1.4");
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+
+static ssize_t hdmirx_edid_version_store(struct device *dev, struct device_attribute *attr, const char *buf, size_t size)
+{
+	mutex_lock(&hdmirx_sysfs_lock);
+	if (sysfs_streq(buf, "1.4"))
+		HdmiRx_SetEDID_version(0);
+	else if (sysfs_streq(buf, "2.0"))
+		HdmiRx_SetEDID_version(1);
+	else
+		HDMIRX_ERROR("Set EDID version fail, unknown version\n");
+	mutex_unlock(&hdmirx_sysfs_lock);
+	return size;
+}
+
+static ssize_t hdmirx_hdcp1x_en_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+	ret_count = sprintf(buf, "%s\n", (Is_HdmiRx_hdcp1x_enabled() == true)?"Enable":"Disable");
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+static ssize_t hdmirx_hdcp2p2_en_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	char *hdcp2p2_str[] = {"Disable", "Enable"};
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+	if (Is_HdmiRx_hdcp2p2_enabled() == true)
+		ret_count = sprintf(buf, "%s\n", hdcp2p2_str[1]);
+	else
+		ret_count = sprintf(buf, "%s\n", hdcp2p2_str[0]);
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+#endif
+
+static ssize_t hdmirx_hdcp_status_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	char *hdcp_str[] = {"None", "Nego1.x", "1.x", "Nego2.2", "2.2", "Unknow", "Unknow", "Unknow"};
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+	ret_count = sprintf(buf, "%s\n", hdcp_str[hdmi_ioctl_struct.hdcp_state&0x7]);
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+
+#if HDMI_REPEATER_SUPPORT
+static ssize_t hdmi_repeater_mode_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+	ret_count = sprintf(buf, "%s\n", Get_Hdmi_repeater_mode()?"ON":"OFF");
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+
+static ssize_t hdmi_repeater_mode_store(struct device *dev, struct device_attribute *attr, const char *buf, size_t size)
+{
+	mutex_lock(&hdmirx_sysfs_lock);
+	if (sysfs_streq(buf, "ON") || sysfs_streq(buf, "on"))
+		Set_Hdmi_repeater_mode(1);
+	else if (sysfs_streq(buf, "OFF") || sysfs_streq(buf, "off"))
+		Set_Hdmi_repeater_mode(0);
+	else
+		HDMIRX_ERROR("Set repeater mode fail, unknown mode\n");
+	mutex_unlock(&hdmirx_sysfs_lock);
+	return size;
+}
+#endif
+
+/* /sys/devices/platform/98037000.hdmirx/edid_version */
+static DEVICE_ATTR(edid_version, 0644, hdmirx_edid_version_show, hdmirx_edid_version_store);
+/* /sys/devices/platform/98037000.hdmirx/hdcp1x_en */
+static DEVICE_ATTR(hdcp1x_en, 0444, hdmirx_hdcp1x_en_show, NULL);
+#ifdef CONFIG_RTK_HDCPRX_2P2
+/* /sys/devices/platform/98037000.hdmirx/hdcp2p2_en */
+static DEVICE_ATTR(hdcp2p2_en, 0444, hdmirx_hdcp2p2_en_show, NULL);
+#endif
+/* /sys/devices/platform/98037000.hdmirx/hdcp_status */
+static DEVICE_ATTR(hdcp_status, 0444, hdmirx_hdcp_status_show, NULL);
+#if HDMI_REPEATER_SUPPORT
+/* /sys/devices/platform/98037000.hdmirx/repeater_mode */
+static DEVICE_ATTR(repeater_mode, 0644, hdmi_repeater_mode_show, hdmi_repeater_mode_store);
+#endif
+
+void register_hdmirx_sysfs(struct platform_device *pdev)
+{
+	device_create_file(&pdev->dev, &dev_attr_edid_version);
+
+	device_create_file(&pdev->dev, &dev_attr_hdcp1x_en);
+#ifdef CONFIG_RTK_HDCPRX_2P2
+	device_create_file(&pdev->dev, &dev_attr_hdcp2p2_en);
+#endif
+	device_create_file(&pdev->dev, &dev_attr_hdcp_status);
+
+#if HDMI_REPEATER_SUPPORT
+	device_create_file(&pdev->dev, &dev_attr_repeater_mode);
+#endif
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_sysfs.h b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_sysfs.h
new file mode 100644
index 00000000..3adae21
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_sysfs.h
@@ -0,0 +1,13 @@
+/*
+ * hdmirx_sysfs.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+int register_hdmirx_sysfs(struct platform_device *pdev);
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_video_dev.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_video_dev.c
new file mode 100644
index 00000000..18358eb
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_video_dev.c
@@ -0,0 +1,669 @@
+/*
+ * hdmirx_video_dev.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmirx_video_dev.h"
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmirx_video_dev.h"
+#include "hdmirx_wrapper.h"
+#include "mipi_wrapper.h"
+#include "hdmirx_reg.h"
+
+#include "rx_drv/hdmiInternal.h"
+#include "rx_drv/hdmiEDID.h"
+
+#define HDMI_MEASURE_RETRY_TIMES 10
+
+int hdmi_stream_on = 0;
+int hdmi_timestamp_mode = 0;/* 0:system time, 1:90KHz timer */
+
+struct hdmirx_format_desc {
+	char *name;
+	__u32 fcc;
+};
+const struct hdmirx_format_desc hdmi_rx_fmts[] = {
+	{
+		.name		= "RAW8",
+		.fcc		= V4L2_PIX_FMT_SGRBG8,
+	},
+	{
+		.name		= "RAW10",
+		.fcc		= V4L2_PIX_FMT_SGRBG10,
+	},
+	{
+		.name		= "Y/CbCr 4:2:2",
+		.fcc		= V4L2_PIX_FMT_NV16,
+	},
+	{
+		.name		= "YUV 4:2:0 (NV12)",
+		.fcc		= V4L2_PIX_FMT_NV12,
+	},
+	{
+		.name		= "YUV 4:2:0 (NV21)",
+		.fcc		= V4L2_PIX_FMT_NV21,
+	},
+	{
+		.name		= "ARGB",
+		.fcc		= V4L2_PIX_FMT_RGB32,
+	},
+	{
+		.name		= "BGRA",
+		.fcc		= V4L2_PIX_FMT_BGR32,
+	}
+};
+#define V4L2_HDMI_RX_SUPPORT_FMT_NUM  (sizeof(hdmi_rx_fmts)/sizeof(struct hdmirx_format_desc))
+
+/*=================== extern Variable/Function ===================*/
+extern MIPI_TOP_INFO mipi_top;
+extern HDMI_INFO_T hdmi;
+extern HDMIRX_IOCTL_STRUCT_T hdmi_ioctl_struct;
+
+extern char Hdmi_IsbReady(void);
+extern int Hdmi_get_b_value(void);
+extern unsigned int rx_pitch_measurement(unsigned int output_h, MIPI_OUT_COLOR_SPACE_T output_color);
+extern void HdmiRx_enable_hdcp(unsigned char *bksv, unsigned char *device_key);
+#ifdef CONFIG_RTK_HDCPRX_2P2
+extern void HdmiRx_enable_hdcp2p2(unsigned char *key);
+#endif
+#if HDMI_REPEATER_SUPPORT
+void Set_Hdmi_repeater_mode(int enable);
+#endif
+/*======================================================*/
+
+MIPI_OUT_COLOR_SPACE_T V4L2_format_parse(unsigned int pixelformat)
+{
+	MIPI_OUT_COLOR_SPACE_T output_color;
+
+	switch (pixelformat) {
+	case V4L2_PIX_FMT_NV12:
+		mipi_top.uv_seq = UV_NV12;
+		output_color = OUT_8BIT_YUV420;
+		break;
+	case V4L2_PIX_FMT_NV21:
+		/* main */
+		mipi_top.uv_seq = UV_NV21;
+		output_color = OUT_8BIT_YUV420;
+		break;
+#if 0
+	case V4L2_PIX_FMT_RGB32:
+		output_color = OUT_BGRA;// byte 0~3: ARGB
+		break;
+#endif
+	case V4L2_PIX_FMT_BGR32:
+		/* byte 0~3: BGRA, for HAL_PIXEL_FORMAT_BGRA_8888 */
+		output_color = OUT_ARGB;
+		break;
+	case V4L2_PIX_FMT_NV16:
+		output_color = OUT_8BIT_YUV422;
+		break;
+	default:
+		/* FCC2ASCII */
+		HDMIRX_ERROR("Unsupported pixel format: %c%c%c%c",
+			((char *)(&pixelformat))[0], ((char *)(&pixelformat))[1],
+			((char *)(&pixelformat))[2], ((char *)(&pixelformat))[3]);
+		output_color = OUT_UNKNOW;
+		break;
+	}
+
+	return  output_color;
+}
+
+int out_color_to_bpp(MIPI_OUT_COLOR_SPACE_T output_color)
+{
+	int bpp;
+
+	switch (output_color) {
+	case OUT_8BIT_YUV420:
+		/* V4L2_PIX_FMT_NV12, V4L2_PIX_FMT_NV21 */
+		bpp = 12;
+		break;
+	case OUT_ARGB:
+		/* V4L2_PIX_FMT_BGR32 */
+		bpp = 32;
+		break;
+	case OUT_10BIT_YUV422:
+		bpp = 32;
+		break;
+	default:
+		/* all other ARGB formats */
+		bpp = 32;
+		break;
+	}
+
+	return bpp;
+}
+
+static long v4l2_hdmi_do_ioctl(struct file *file, unsigned int cmd, void *arg)
+{
+	long ret = 0;
+	struct video_device *vdev = video_devdata(file);
+	struct v4l2_hdmi_dev *dev = video_drvdata(file);
+
+	/* HDMIRX_DEBUG(" ioctl TYPE(0x%x) NR(%u) SIZE(%u)",  _IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd)); */
+
+	switch (cmd) {
+	case VIDIOC_QUERYCAP:
+	{
+		struct v4l2_capability *cap = arg;
+
+		/* HDMIRX_INFO(" ioctl VIDIOC_QUERYCAP"); */
+		memset(cap, 0, sizeof(*cap));
+
+		strlcpy(cap->driver, "v4l2_mipi_top", sizeof(cap->driver));
+		strlcpy(cap->card, vdev->name, sizeof(cap->card));
+
+		cap->version = LINUX_VERSION_CODE;
+		cap->capabilities = V4L2_CAP_VIDEO_CAPTURE | V4L2_CAP_STREAMING;
+		break;
+	}
+	case VIDIOC_CROPCAP:
+	{
+		struct v4l2_cropcap *ccap = arg;
+
+		ccap->bounds.left = 0;
+		ccap->bounds.top = 0;
+
+		ccap->bounds.width = 4096;
+		ccap->bounds.height = 2160;
+
+		ccap->defrect = ccap->bounds;
+
+		ccap->pixelaspect.numerator = 1;
+		ccap->pixelaspect.denominator = 1;
+		break;
+	}
+	case VIDIOC_G_CROP:
+	case VIDIOC_S_CROP:
+		ret = -EINVAL;
+		break;
+	case VIDIOC_ENUM_FMT:
+	{
+		struct v4l2_fmtdesc *fmt = arg;
+		struct hdmirx_format_desc *format;
+		enum v4l2_buf_type type = fmt->type;
+		__u32 index = fmt->index;
+
+		/* HDMIRX_INFO(" ioctl VIDIOC_ENUM_FMT"); */
+		memset(fmt, 0, sizeof(*fmt));
+		fmt->index = index;
+		fmt->type = type;
+
+		if (fmt->index >= V4L2_HDMI_RX_SUPPORT_FMT_NUM) {
+			ret = -EINVAL;
+			goto exit;
+		}
+
+		format = &hdmi_rx_fmts[fmt->index];
+		fmt->flags = V4L2_FMT_FLAG_COMPRESSED;
+
+		strlcpy(fmt->description, format->name, sizeof(fmt->description));
+		fmt->description[sizeof(fmt->description) - 1] = 0;
+
+		fmt->pixelformat = format->fcc;
+		break;
+	}
+	case VIDIOC_ENUM_FRAMESIZES:
+	{
+		struct v4l2_frmsizeenum *fsize = arg;
+		int v_len;
+
+		/* HDMIRX_INFO(" ioctl VIDIOC_ENUM_FRAMESIZES"); */
+		/* Look for the given pixel format */
+		if (((hdmi_ioctl_struct.measure_ready == 0) && (mipi_top.src_sel == 1)) ||
+			(fsize->index != 0)) {
+			ret = -EINVAL;
+			goto exit;
+		}
+
+		if (!hdmi.tx_timing.progressive)
+			v_len = mipi_top.v_input_len << 1;
+		else
+			v_len = mipi_top.v_input_len;
+
+		fsize->type = V4L2_FRMSIZE_TYPE_CONTINUOUS;
+		fsize->stepwise.min_width = (mipi_top.h_input_len)/32;
+		fsize->stepwise.max_width = mipi_top.h_input_len;
+		fsize->stepwise.step_width = 1;
+		fsize->stepwise.min_height = v_len/32;
+		fsize->stepwise.max_height = v_len;
+		fsize->stepwise.step_height = 1;
+		HDMIRX_INFO("Act_hor:%u, Act_ver:%u", mipi_top.h_input_len, mipi_top.v_input_len);
+		break;
+	}
+	case VIDIOC_ENUM_FRAMEINTERVALS:
+	{
+		struct v4l2_frmivalenum *fival = arg;
+
+		if (fival->index != 0) {
+			ret = -EINVAL;
+			goto exit;
+		}
+
+		fival->type = V4L2_FRMIVAL_TYPE_DISCRETE;
+		fival->discrete.numerator = 1;
+		if (mipi_top.src_sel == 1) {
+			unsigned int vic;
+
+			vic = drvif_Hdmi_AVI_VIC();
+			if (hdmi_vic_table[vic].interlace)
+				fival->discrete.denominator = hdmi_vic_table[vic].fps/2;
+			else
+				fival->discrete.denominator = hdmi_vic_table[vic].fps;
+		} else {
+				fival->discrete.denominator = 60;
+		}
+		break;
+	}
+	case VIDIOC_S_FMT:
+	{
+		struct v4l2_format *fmt = arg;
+		int v_len;
+
+		dev->width = fmt->fmt.pix.width;
+		dev->height = fmt->fmt.pix.height;
+		dev->outfmt = V4L2_format_parse(fmt->fmt.pix.pixelformat);
+		dev->bpp = out_color_to_bpp(dev->outfmt);
+		HDMIRX_INFO(" ioctl VIDIOC_S_FMT,%dx%d,color=0x%x",
+			fmt->fmt.pix.width, fmt->fmt.pix.height, dev->outfmt);
+
+		if (!hdmi.tx_timing.progressive)
+			v_len = mipi_top.v_input_len << 1;
+		else
+			v_len = mipi_top.v_input_len;
+
+		mipi_top.h_output_len = fmt->fmt.pix.width;
+		mipi_top.v_output_len = fmt->fmt.pix.height;
+		mipi_top.output_color = dev->outfmt;
+		mipi_top.pitch = rx_pitch_measurement(mipi_top.h_output_len, mipi_top.output_color);
+
+		mipi_top.mipi_init = 0;
+		if ((v_len) && (v_len < mipi_top.v_output_len)) {
+			HDMIRX_ERROR("[v_size error :%d<%d]", v_len, mipi_top.v_output_len);
+			ret = -EINVAL;
+			goto exit;
+		}
+
+		if ((mipi_top.h_input_len) && (mipi_top.h_input_len < mipi_top.v_output_len)) {
+			HDMIRX_ERROR("[h_size error :%d<%d]",
+				mipi_top.h_input_len, mipi_top.v_output_len);
+			ret = -EINVAL;
+			goto exit;
+		}
+
+		HDMIRX_INFO(" ioctl VIDIOC_S_FMT,output v(%u) h(%u) color(%u) pitch(%u)",
+			mipi_top.h_output_len, mipi_top.v_output_len,
+			mipi_top.output_color, mipi_top.pitch);
+		break;
+	}
+	case VIDIOC_S_PARM:
+		/* Set USB camera frame rate, unused in RX */
+
+		/* HDMIRX_INFO("Not support fps change"); */
+		break;
+	case VIDIOC_REQBUFS:
+	{
+		/* Buffers & streaming */
+		struct vb2_queue *vq;
+		struct v4l2_requestbuffers *rb = (struct v4l2_requestbuffers *)arg;
+
+		HDMIRX_INFO(" ioctl VIDIOC_REQBUFS count=%d, type=%d, memory=%d",
+			rb->count, rb->type, rb->memory);
+
+		/* Initialize queue */
+		vq = &dev->vb_hdmidq;
+		ret = hdmirx_queue_init(dev, vq, rb->memory);
+		if (ret) {
+			HDMIRX_ERROR("hdmirx_queue_init failed: %ld", ret);
+			goto exit;
+		}
+
+		ret = vb2_reqbufs(vq, rb);
+		if (ret) {
+			HDMIRX_ERROR("vb2_reqbufs failed: %ld", ret);
+			goto exit;
+		}
+		break;
+	}
+	case VIDIOC_QUERYBUF:
+	{
+		struct v4l2_buffer *buf = arg;
+
+		/*
+		 * HDMIRX_INFO(" ioctl VIDIOC_QUERYBUF index(%u) type(%u) length(%u)",
+		 *	buf->index,buf->type,buf->length);
+		 */
+		ret = vb2_querybuf(&dev->vb_hdmidq, buf);
+
+		if (ret < 0)
+			HDMIRX_ERROR(" ioctl VIDIOC_QUERYBUF fail");
+		break;
+	}
+	case VIDIOC_QBUF:
+	{
+		struct v4l2_buffer *buf = arg;
+
+		/* HDMIRX_INFO(" ioctl VIDIOC_QBUF"); */
+
+		ret = vb2_qbuf(&dev->vb_hdmidq, buf);
+
+		if (ret < 0)
+			HDMIRX_ERROR(" ioctl VIDIOC_QBUF fail");
+		break;
+	}
+	case VIDIOC_DQBUF:
+	{
+		struct v4l2_buffer *buf = arg;
+
+		/*HDMIRX_INFO(" ioctl VIDIOC_DQBUF"); */
+
+		ret = vb2_dqbuf(&dev->vb_hdmidq, buf, file->f_flags & O_NONBLOCK);
+		if (ret == 0)
+			atomic_dec(&dev->hdmidq.rcnt);
+
+		/* Avoid userspace seeing broken frames on hotplug or switching tv system */
+		if (unlikely(ret == 0 && hdmi_stream_on == 0))
+			ret = -EINVAL;
+
+		break;
+	}
+	case VIDIOC_STREAMON:
+	{
+		HDMIRX_INFO(" ioctl VIDIOC_STREAMON");
+
+		vb2_streamon(&dev->vb_hdmidq, dev->vb_hdmidq.type);
+
+		break;
+	}
+	case VIDIOC_STREAMOFF:
+	{
+		struct vb2_queue *vq;
+
+		HDMIRX_INFO(" ioctl VIDIOC_STREAMOFF");
+
+		vb2_streamoff(&dev->vb_hdmidq, dev->vb_hdmidq.type);
+
+		/* Release queue */
+		vq = &dev->vb_hdmidq;
+		vb2_queue_release(vq);
+
+		hdmi_timestamp_mode = 0;
+
+		break;
+	}
+	case VIDIOC_QUERY_MIPI_IN_TYPE:
+	{
+		struct v4l2_mipi_in_type *in_type = arg;
+
+		/* HDMIRX_INFO(" ioctl VIDIOC_MIPI_IN_TYPE"); */
+
+		in_type->input_type = mipi_top.src_sel;
+		break;
+	}
+	case VIDIOC_SET_MIPI_IN_TYPE:
+		/* HDMIRX_INFO(" ioctl VIDIOC_SET_MIPI_IN_TYPE"); */
+
+		break;
+	case VIDIOC_ENABLE_RX_HDCP:
+	{
+		struct rx_hdcp_key *rx_key;
+
+		HDMIRX_INFO("ioctl VIDIOC_ENABLE_RX_HDCP\n");
+
+#ifndef CONFIG_RTK_HDCP_1x
+		HDMIRX_ERROR("Enable HDCP fail because HDCP TX is disabled");
+		break;
+#endif
+
+		rx_key = arg;
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+		HdmiRx_enable_hdcp2p2(rx_key->licensed);
+#endif
+		if ((rx_key->ksv[0] == 0) && (rx_key->ksv[1] == 0) &&
+			(rx_key->ksv[2] == 0) && (rx_key->ksv[3] == 0) &&
+			(rx_key->ksv[4] == 0))
+			HDMIRX_INFO("[HDCP1.4] Empty key, should be TEE case");
+
+		HdmiRx_enable_hdcp(rx_key->ksv, rx_key->private_key);
+		break;
+	}
+	case VIDIOC_SET_TIMESTAMP_MODE:
+	{
+		int *mode = arg;
+
+		HDMIRX_INFO("ioctl VIDIOC_SET_TIMESTAMP_MODE\n");
+
+		hdmi_timestamp_mode = (int)*mode;
+
+		break;
+	}
+#if HDMI_REPEATER_SUPPORT
+	case VIDIOC_SET_REPEATER_MODE:
+	{
+		int *repeater_mode = arg;
+
+		HDMIRX_INFO("ioctl VIDIOC_SET_REPEATER_MODE\n");
+
+		Set_Hdmi_repeater_mode((int)*repeater_mode);
+
+		break;
+	}
+#endif
+	case VIDIOC_SET_EDID_TABLE:
+	{
+		/* EDID 256Bytes */
+		HDMIRX_INFO("ioctl VIDIOC_SET_EDID_TABLE\n");
+
+		HdmiRx_ChangeCurrentEDID(arg);
+
+		break;
+	}
+	default:
+		HDMIRX_ERROR("Unknown ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+			_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+		ret = -ENOTTY;
+		break;
+	}
+
+exit:
+	return ret;
+}
+
+long v4l2_hdmi_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	long ret;
+
+	if (0) {
+		pr_info("v4l2_hdmi_ioctl(");
+		v4l_printk_ioctl(NULL, cmd);
+		pr_info(")\n");
+	}
+	HDMIRX_DEBUG(" ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+		_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+	ret = video_usercopy(file, cmd, arg, v4l2_hdmi_do_ioctl);
+	HDMIRX_DEBUG(" return ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+		_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+	return ret;
+}
+
+long compat_v4l2_hdmi_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	long ret_val;
+	struct compat_v4l2_buffer *c_buf;
+	struct v4l2_buffer buf;
+
+	if (!file->f_op->unlocked_ioctl) {
+		ret_val = -ENOTTY;
+		goto exit;
+	}
+
+	switch (cmd) {
+	case VIDIOC_QUERYBUF:
+	case VIDIOC_QBUF:
+	case VIDIOC_DQBUF:
+		memset(&buf, 0, sizeof(buf));
+		c_buf = (void __user *)(unsigned long)compat_ptr(arg);
+		buf.index = c_buf->index;
+		buf.type = c_buf->type;
+		buf.bytesused = c_buf->bytesused;
+		buf.flags = c_buf->flags;
+		buf.field = c_buf->field;
+
+		if (copy_from_user(&buf.timestamp, &c_buf->timestamp, sizeof(c_buf->timestamp)))
+			HDMIRX_ERROR("copy_from_user fail");
+
+		if (copy_from_user(&buf.timecode, &c_buf->timecode, sizeof(c_buf->timecode)))
+			HDMIRX_ERROR("copy_from_user fail");
+
+		buf.m.offset = c_buf->compat_m.offset;
+		buf.m.userptr = (unsigned long)compat_ptr(c_buf->compat_m.userptr);
+		buf.m.fd = c_buf->compat_m.fd;
+		buf.length = c_buf->length;
+		buf.reserved2 = c_buf->reserved2;
+		buf.reserved = c_buf->reserved;
+		ret_val = v4l2_hdmi_do_ioctl(file, cmd, &buf);
+		break;
+	default:
+		ret_val = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+	}
+
+exit:
+	return ret_val;
+}
+
+int v4l2_mipi_top_open(struct file *filp)
+{
+	struct video_device *vdev = video_devdata(filp);
+	struct v4l2_fh *fh = kzalloc(sizeof(*fh), GFP_KERNEL);
+
+	filp->private_data = fh;
+	if (fh == NULL)
+		return -ENOMEM;
+	v4l2_fh_init(fh, vdev);
+	v4l2_fh_add(fh);
+
+	return 0;
+}
+
+static ssize_t show_hdmirx_bufcnt(struct device *cd, struct device_attribute *attr, char *buf)
+{
+	struct video_device *vfd = container_of(cd, struct video_device, dev);
+	struct v4l2_hdmi_dev *dev = (struct v4l2_hdmi_dev *)video_get_drvdata(vfd);
+	struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;
+
+	return sprintf(buf, "qcnt:%d rcnt:%d\n", atomic_read(&hdmidq->qcnt), atomic_read(&hdmidq->rcnt));
+}
+
+static const char * const type[] = {"MIPI", "HDMIRx"};
+static const char * const status[] = {"NotReady", "Ready"};
+static const char * const color[] = {"RGB", "YUV444", "YUV422"};
+static const char * const sm[] = {"Interlaced", "Progressive"};
+static ssize_t show_hdmirx_video_info(struct device *cd, struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count;
+	unsigned char type_index, status_index, mode_index, color_index;
+	unsigned int width = 0, height = 0, vic = 0, fps = 0;
+
+	type_index = mipi_top.src_sel&0x1;
+	status_index = hdmi_ioctl_struct.measure_ready&0x1;
+	width = mipi_top.h_input_len;
+	height = mipi_top.v_input_len;
+	mode_index = hdmi.tx_timing.progressive&0x1;
+	color_index = mipi_top.input_color&0x3;
+
+	if (mode_index == 0) /* interlaced mode */
+		height *= 2;
+
+	if (hdmi_ioctl_struct.measure_ready)
+		vic = drvif_Hdmi_AVI_VIC();
+	else
+		vic = 0;
+
+	fps = hdmi_vic_table[vic].fps;
+
+
+	ret_count = sprintf(buf, "Type:%s\nStatus:%s\nWidth:%u\nHeight:%u\nScanMode:%s\nColor:%s\nFps:%u\n",
+		type[type_index], status[status_index],
+		width, height, sm[mode_index], color[color_index], fps);
+
+	return ret_count;
+}
+
+static const char * const lpcm[] = {"LPCM", "Non-LPCM", "N/A"};
+static ssize_t show_hdmirx_audio_info(struct device *cd,
+	struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count;
+	unsigned int audio_ready = 0, freq = 0, lpcm_index = 2;
+
+	audio_ready = hdmi_ioctl_struct.audio_detect_done;
+
+	if (audio_ready) {
+		freq = hdmi.audio_freq;
+		lpcm_index = hdmi.spdif_type&0x1;
+	}
+
+	ret_count = sprintf(buf, "Ready:%u\n", audio_ready);
+
+	ret_count += sprintf(buf+ret_count, "Freq:%u\n", freq);
+	ret_count += sprintf(buf+ret_count, "SPDIF Type:%s\n", lpcm[lpcm_index]);
+
+	return ret_count;
+}
+
+/* /sys/class/video4linux/video250/hdmirx_bufcnt */
+static DEVICE_ATTR(hdmirx_bufcnt, 0444, show_hdmirx_bufcnt, NULL);
+/* /sys/class/video4linux/video250/hdmirx_video_info */
+static DEVICE_ATTR(hdmirx_video_info, 0444, show_hdmirx_video_info, NULL);
+/* /sys/class/video4linux/video250/hdmirx_audio_info */
+static DEVICE_ATTR(hdmirx_audio_info, 0444, show_hdmirx_audio_info, NULL);
+
+int register_video_device(struct v4l2_hdmi_dev *hdmi_dev)
+{
+	int ret;
+	struct video_device *video_dev;
+
+	HDMIRX_INFO("[%s]", __func__);
+
+	video_dev = &hdmi_dev->vdev;
+	*video_dev = hdmi_template;
+	video_dev->v4l2_dev = &hdmi_dev->v4l2_dev;
+	video_dev->queue = &hdmi_dev->vb_hdmidq;
+
+	dma_set_coherent_mask(&video_dev->dev, DMA_BIT_MASK(32));
+	/*
+	 * Provide a mutex to v4l2 core. It will be used to protect
+	 * all fops and v4l2 ioctls.
+	 */
+	video_dev->lock = &hdmi_dev->mutex;
+	video_set_drvdata(video_dev, hdmi_dev);
+	ret = video_register_device(video_dev, VFL_TYPE_GRABBER, 250);
+	if (ret < 0)
+		return ret;
+
+	ret = device_create_file(&video_dev->dev, &dev_attr_hdmirx_bufcnt);
+	if (ret < 0)
+		goto unreg_vdev;
+	ret = device_create_file(&video_dev->dev, &dev_attr_hdmirx_video_info);
+	if (ret < 0)
+		goto unreg_vdev;
+	ret = device_create_file(&video_dev->dev, &dev_attr_hdmirx_audio_info);
+	if (ret < 0)
+		goto unreg_vdev;
+
+	return 0;
+
+unreg_vdev:
+	video_unregister_device(video_dev);
+	return ret;
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_video_dev.h b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_video_dev.h
new file mode 100644
index 00000000..fb02242
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_video_dev.h
@@ -0,0 +1,76 @@
+/*
+ * hdmirx_video_dev.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDMIRX_VIDEO_DEV_H_
+#define _HDMIRX_VIDEO_DEV_H_
+
+
+#include "v4l2_hdmi_dev.h"
+
+long v4l2_hdmi_ioctl(struct file *file, unsigned int cmd, unsigned long arg);
+long compat_v4l2_hdmi_ioctl(struct file *file, unsigned int cmd, unsigned long arg);
+int v4l2_mipi_top_open(struct file *filp);
+
+struct compat_v4l2_plane {
+	__u32			bytesused;
+	__u32			length;
+	union {
+		__u32		mem_offset;
+		__u32		userptr;
+		__s32		fd;
+	} m;
+	__u32			data_offset;
+	__u32			reserved[11];
+};
+
+struct compat_v4l2_buffer {
+	__u32			index;
+	__u32			type;
+	__u32			bytesused;
+	__u32			flags;
+	__u32			field;
+	struct timeval		timestamp;
+	struct v4l2_timecode	timecode;
+	__u32			sequence;
+
+	/* memory location */
+	__u32			memory;
+	union {
+		__u32           offset;
+		__u32			userptr;
+		struct compat_v4l2_plane *planes;
+		__s32		fd;
+	} compat_m;
+	__u32			length;
+	__u32			reserved2;
+	__u32			reserved;
+};
+
+static const struct v4l2_file_operations hdmi_fops = {
+	.owner			= THIS_MODULE,
+	.open			= v4l2_mipi_top_open,
+	.release		= vb2_fop_release,
+	.read			= vb2_fop_read,
+	.poll			= vb2_fop_poll,
+	.unlocked_ioctl = v4l2_hdmi_ioctl, /* V4L2 ioctl handler */
+	.compat_ioctl32	= compat_v4l2_hdmi_ioctl,
+	.mmap			= vb2_fop_mmap,
+};
+
+static const struct video_device hdmi_template = {
+	.name		= "v4l2_mipi_top",
+	.fops		= &hdmi_fops,
+	.release	= video_device_release_empty,
+};
+
+int register_video_device(struct v4l2_hdmi_dev *hdmi_dev);
+
+#endif/* _HDMIRX_VIDEO_DEV_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_wrapper.c b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_wrapper.c
new file mode 100644
index 00000000..18caecc
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_wrapper.c
@@ -0,0 +1,475 @@
+/*
+ * hdmirx_wrapper.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/printk.h>
+#include <linux/ratelimit.h>
+#include <linux/workqueue.h>
+
+#include "hdmirx_wrapper.h"
+#include "v4l2_hdmi_dev.h"
+#include "hdmirx_reg.h"
+#include "mipi_wrapper.h"
+
+#include "rx_drv/hdmiInternal.h"
+
+/*=================== extern Variable/Function ===================*/
+extern HDMI_INFO_T hdmi;
+extern HDMIRX_IOCTL_STRUCT_T hdmi_ioctl_struct;
+extern MIPI_TOP_INFO mipi_top;
+#if HDMI2p0
+extern u_int8_t bHDMI_6G_flag;
+#endif
+
+extern HDMI_DVI_MODE_T IsHDMI(void);
+#if HDMI_REPEATER_SUPPORT
+extern void Set_Hdmitx_PLL(void);
+#endif
+/*======================================================*/
+
+static void rxdetect_work_fun(struct work_struct *work);
+static DECLARE_DELAYED_WORK(rxdetect_work, rxdetect_work_fun);
+
+static void rxdetect_work_fun(struct work_struct *work)
+{
+	if (hdmi_ioctl_struct.detect_done)
+		set_hdmirx_wrapper_interrupt_en(0, 0, 1);
+}
+
+const unsigned int resolution_format[17][2] = {
+	{ 640,  480},
+	{ 720,  480},
+	{1280,  720},
+	{1920, 1080},
+	{1920,  540},
+	{ 720,  240},
+	{1440,  480},
+	{ 720,  576},
+	{ 720,  288},
+	{1440,  576},
+	{ 720,  400},
+	{ 800,  600},
+	{1024,  768},
+	{1280,  960},
+	{1280, 1024},
+	{3840, 2160},/* For HDMI 1.x 4Kp24/25/30, PacketByte4 VIC=0 */
+	{4096, 2160},/* For HDMI 1.x */
+};
+const unsigned int format_number = sizeof(resolution_format)/sizeof(resolution_format[0]);
+
+const HDMI_VIC_TABLE_T hdmi_vic_table[] = {
+	/* {width, height, fps, interlace} */
+	{   0,    0,  60, 0 }, /* No such vic, set fps=60 for standard timings and DVI mode */
+	{ 640,  480,  60, 0 }, /* VIC: 1 */
+	{ 720,  480,  60, 0 }, /* VIC: 2 , 480p */
+	{ 720,  480,  60, 0 }, /* VIC: 3 */
+	{1280,  720,  60, 0 }, /* VIC: 4 , 720p60 */
+	{1920, 1080,  60, 1 }, /* VIC: 5, 1080i60 */
+	{ 720,  480,  60, 1 }, /* VIC: 6, NTSC */
+	{ 720,  480,  60, 1 }, /* VIC: 7, NTSC */
+	{ 720,  240,  60, 0 }, /* VIC: 8 */
+	{ 720,  240,  60, 0 }, /* VIC: 9 */
+	{2880,  480,  60, 1 }, /* VIC: 10 */
+	{2880,  480,  60, 1 }, /* VIC: 11 */
+	{2880,  240,  60, 0 }, /* VIC: 12 */
+	{2880,  240,  60, 0 }, /* VIC: 13 */
+	{1440,  480,  60, 0 }, /* VIC: 14 */
+	{1440,  480,  60, 0 }, /* VIC: 15 */
+	{1920, 1080,  60, 0 }, /* VIC: 16, 1080p60 */
+	{ 720,  576,  50, 0 }, /* VIC: 17, 576p */
+	{ 720,  576,  50, 0 }, /* VIC: 18 */
+	{1280,  720,  50, 0 }, /* VIC: 19, 720p50 */
+	{1920, 1080,  50, 1 }, /* VIC: 20, 1080i50 */
+	{ 720,  576,  50, 1 }, /* VIC: 21, PAL */
+	{ 720,  576,  50, 1 }, /* VIC: 22 */
+	{ 720,  288,  50, 0 }, /* VIC: 23 */
+	{ 720,  288,  50, 0 }, /* VIC: 24 */
+	{2880,  576,  50, 1 }, /* VIC: 25 */
+	{2880,  576,  50, 1 }, /* VIC: 26 */
+	{2880,  288,  50, 0 }, /* VIC: 27 */
+	{2880,  288,  50, 0 }, /* VIC: 28 */
+	{1440,  576,  50, 0 }, /* VIC: 29 */
+	{1440,  576,  50, 0 }, /* VIC: 30 */
+	{1920, 1080,  50, 0 }, /* VIC: 31, 1080p50 */
+	{1920, 1080,  24, 0 }, /* VIC: 32 */
+	{1920, 1080,  25, 0 }, /* VIC: 33 */
+	{1920, 1080,  30, 0 }, /* VIC: 34 */
+	{2880,  480,  60, 0 }, /* VIC: 35 */
+	{2880,  480,  60, 0 }, /* VIC: 36 */
+	{2880,  576,  50, 0 }, /* VIC: 37 */
+	{2880,  576,  50, 0 }, /* VIC: 38 */
+	{1920, 1080,  50, 1 }, /* VIC: 39 */
+	{1920, 1080, 100, 1 }, /* VIC: 40 */
+	{1280,  720, 100, 0 }, /* VIC: 41 */
+	{ 720,  576, 100, 0 }, /* VIC: 42 */
+	{ 720,  576, 100, 0 }, /* VIC: 43 */
+	{ 720,  576, 100, 1 }, /* VIC: 44 */
+	{ 720,  576, 100, 1 }, /* VIC: 45 */
+	{1920, 1080, 120, 1 }, /* VIC: 46 */
+	{1280,  720, 120, 0 }, /* VIC: 47 */
+	{ 720,  480, 120, 0 }, /* VIC: 48 */
+	{ 720,  480, 120, 0 }, /* VIC: 49 */
+	{ 720,  480, 120, 1 }, /* VIC: 50 */
+	{ 720,  480, 120, 1 }, /* VIC: 51 */
+	{ 720,  576, 200, 0 }, /* VIC: 52 */
+	{ 720,  576, 200, 0 }, /* VIC: 53 */
+	{ 720,  576, 200, 1 }, /* VIC: 54 */
+	{ 720,  576, 200, 1 }, /* VIC: 55 */
+	{ 720,  480, 240, 0 }, /* VIC: 56 */
+	{ 720,  480, 240, 0 }, /* VIC: 57 */
+	{ 720,  480, 240, 1 }, /* VIC: 58 */
+	{ 720,  480, 240, 1 }, /* VIC: 59 */
+	{1280,  720,  24, 0 }, /* VIC: 60 */
+	{1280,  720,  25, 0 }, /* VIC: 61 */
+	{1280,  720,  30, 0 }, /* VIC: 62 */
+	{1920, 1080, 120, 0 }, /* VIC: 63 */
+	{1920, 1080, 100, 0 }, /* VIC: 64 */
+	{1280,  720,  24, 0 }, /* VIC: 65 */
+	{1280,  720,  25, 0 }, /* VIC: 66 */
+	{1280,  720,  30, 0 }, /* VIC: 67 */
+	{1280,  720,  50, 0 }, /* VIC: 68 */
+	{1280,  720,  60, 0 }, /* VIC: 69 */
+	{1280,  720, 100, 0 }, /* VIC: 70 */
+	{1280,  720, 120, 0 }, /* VIC: 71 */
+	{1920, 1080,  24, 0 }, /* VIC: 72 */
+	{1920, 1080,  25, 0 }, /* VIC: 73 */
+	{1920, 1080,  30, 0 }, /* VIC: 74 */
+	{1920, 1080,  50, 0 }, /* VIC: 75 */
+	{1920, 1080,  60, 0 }, /* VIC: 76 */
+	{1920, 1080, 100, 0 }, /* VIC: 77 */
+	{1920, 1080, 120, 0 }, /* VIC: 78 */
+	{1680,  720,  24, 0 }, /* VIC: 79 */
+	{1680,  720,  25, 0 }, /* VIC: 80 */
+	{1680,  720,  30, 0 }, /* VIC: 81 */
+	{1680,  720,  50, 0 }, /* VIC: 82 */
+	{1680,  720,  60, 0 }, /* VIC: 83 */
+	{1680,  720, 100, 0 }, /* VIC: 84 */
+	{1680,  720, 120, 0 }, /* VIC: 85 */
+	{2560, 1080,  24, 0 }, /* VIC: 86 */
+	{2560, 1080,  25, 0 }, /* VIC: 87 */
+	{2560, 1080,  30, 0 }, /* VIC: 88 */
+	{2560, 1080,  50, 0 }, /* VIC: 89 */
+	{2560, 1080,  60, 0 }, /* VIC: 90 */
+	{2560, 1080, 100, 0 }, /* VIC: 91 */
+	{2560, 1080, 120, 0 }, /* VIC: 92 */
+	{3840, 2160,  24, 0 }, /* VIC: 93 */
+	{3840, 2160,  25, 0 }, /* VIC: 94 */
+	{3840, 2160,  30, 0 }, /* VIC: 95 */
+	{3840, 2160,  50, 0 }, /* VIC: 96 */
+	{3840, 2160,  60, 0 }, /* VIC: 97 */
+	{4096, 2160,  24, 0 }, /* VIC: 98 */
+	{4096, 2160,  25, 0 }, /* VIC: 99 */
+	{4096, 2160,  30, 0 }, /* VIC: 100 */
+	{4096, 2160,  50, 0 }, /* VIC: 101 */
+	{4096, 2160,  60, 0 }, /* VIC: 102 */
+	{3840, 2160,  24, 0 }, /* VIC: 103 */
+	{3840, 2160,  25, 0 }, /* VIC: 104 */
+	{3840, 2160,  30, 0 }, /* VIC: 105 */
+	{3840, 2160,  50, 0 }, /* VIC: 106 */
+	{3840, 2160,  60, 0 }, /* VIC: 107 */
+	{3840, 2160,  30, 0 }, /* (108)extened vic: 1 */
+	{3840, 2160,  25, 0 }, /* (109)extened vic: 2 */
+	{3840, 2160,  24, 0 }, /* (110)extened vic: 3 */
+	{4096, 2160,  24, 0 }, /* (111)extened vic: 4 */
+};
+
+
+unsigned char hdmirx_wrapper_convert_color_fmt(HDMI_COLOR_SPACE_T color)
+{
+	unsigned char yuv_fmt;
+
+	switch (color) {
+	case COLOR_RGB:
+		yuv_fmt = 0;
+		break;
+	case COLOR_YUV422:
+		yuv_fmt = 2;
+		break;
+	case COLOR_YUV444:
+	case COLOR_YUV420:/* YUV420to444 */
+		yuv_fmt = 1;
+		break;
+	default:
+		yuv_fmt = 0;
+		HDMIRX_ERROR("[%s] Unsupported color(%u)", __func__, color);
+		break;
+	}
+
+	return yuv_fmt;
+}
+
+void set_hdmirx_wrapper_interrupt_en(int ver_err_en, int hor_err_en, int polarity_detect_en)
+{
+	unsigned int reg_val;
+
+	reg_val = hdmi_rx_reg_read32(HDMIRX_WRAPPER_INTERRUPT_EN, HDMI_RX_HDMI_WRAPPER);
+
+	if (ver_err_en >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en(ver_err_en);
+	}
+	if (hor_err_en >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en(hor_err_en);
+	}
+	if (polarity_detect_en >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en(polarity_detect_en);
+	}
+	hdmi_rx_reg_write32(HDMIRX_WRAPPER_INTERRUPT_EN, reg_val, HDMI_RX_HDMI_WRAPPER);
+}
+
+
+void set_hdmirx_wrapper_active_pixels(unsigned int v_pixel, unsigned int h_pixel)
+{
+	hdmi_rx_reg_write32(HDMIRX_WRAPPER_ACTIVE_PIXELS,
+		HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width(v_pixel) |
+		HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width(h_pixel), HDMI_RX_HDMI_WRAPPER);
+}
+
+
+void set_hdmirx_wrapper_hor_threshold(unsigned int h_threshold)
+{
+	hdmi_rx_reg_write32(HDMIRX_WRAPPER_HOR_THRESHOLD,
+		HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold(h_threshold), HDMI_RX_HDMI_WRAPPER);
+}
+
+
+void set_hdmirx_wrapper_control_0(int fifo_stage, int fw_dma_en,
+	int polarity_set_en, int polarity_set, int yuv_fmt, int hdmirx_en)
+{
+	unsigned int reg_val;
+
+	reg_val = hdmi_rx_reg_read32(HDMIRX_WRAPPER_CONTROL_0, HDMI_RX_HDMI_WRAPPER);
+
+	if (fifo_stage >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_CONTROL_0_fifo_stage_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_CONTROL_0_fifo_stage(fifo_stage);
+	}
+	if (fw_dma_en >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_CONTROL_0_fw_dma_en(fw_dma_en);
+	}
+	if (polarity_set_en >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_CONTROL_0_polarity_set_en(polarity_set_en);
+	}
+	if (polarity_set >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_CONTROL_0_polarity_set_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_CONTROL_0_polarity_set(polarity_set);
+	}
+	if (yuv_fmt >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_CONTROL_0_yuv_fmt(yuv_fmt);
+	}
+	if (hdmirx_en >= 0) {
+		reg_val = reg_val &
+			(~(HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx_mask |
+			HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_mask));
+
+		reg_val = reg_val |
+			HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx(hdmirx_en) |
+			HDMIRX_WRAPPER_CONTROL_0_hdmirx_en(hdmirx_en);
+	}
+	hdmi_rx_reg_write32(HDMIRX_WRAPPER_CONTROL_0, reg_val, HDMI_RX_HDMI_WRAPPER);
+
+}
+
+unsigned int hdmirx_wrapper_get_active_line(void)
+{
+	unsigned int buf0;
+
+	buf0 = HDMIRX_WRAPPER_MONITOR_1_get_line_buf0(hdmi_rx_reg_read32(HDMIRX_WRAPPER_MONITOR_1, HDMI_RX_HDMI_WRAPPER));
+	return buf0;
+}
+
+unsigned int hdmirx_wrapper_get_active_pixel(void)
+{
+	unsigned int reg01;
+	unsigned int buf0;
+
+	reg01 = hdmi_rx_reg_read32(HDMIRX_WRAPPER_DEN_BUF01, HDMI_RX_HDMI_WRAPPER);
+	buf0 = HDMIRX_WRAPPER_DEN_BUF01_get_den_buf0(reg01);
+	return buf0;
+}
+
+static inline unsigned int check_hdmirx_resolution_match(void)
+{
+	unsigned int active_pixel, active_line, height;
+	unsigned int i, vic;
+	unsigned char color_fmt;
+
+	vic = 0;
+	if (IsHDMI())
+		vic = drvif_Hdmi_AVI_VIC();
+
+	active_pixel =	hdmirx_wrapper_get_active_pixel();
+	active_line = hdmirx_wrapper_get_active_line();
+	color_fmt = hdmirx_wrapper_convert_color_fmt(GET_HDMI_COLOR_SPACE());
+
+	if (hdmi_vic_table[vic].interlace)
+		height = active_line*2;
+	else
+		height = active_line;
+
+	if ((active_pixel == hdmi_vic_table[vic].width) &&
+		(height == hdmi_vic_table[vic].height) && vic) {
+
+		mipi_top.h_input_len = active_pixel;
+		mipi_top.v_input_len = active_line;
+		mipi_top.input_color = color_fmt;
+
+		HDMIRX_INFO("Check resolution match => Width(%u) Height(%u) VIC(%u)",
+			active_pixel, height, vic);
+		return 1;
+	} else if (vic == 0) {
+		/* Support standard timings and DVI mode */
+		for (i = 0; i < format_number; i++) {
+			if ((active_pixel == resolution_format[i][0]) &&
+				(active_line == resolution_format[i][1])) {
+
+				mipi_top.h_input_len = active_pixel;
+				mipi_top.v_input_len = active_line;
+				mipi_top.input_color = color_fmt;
+
+				HDMIRX_INFO("Check resolution match => Width(%u) Height(%u) DIV",
+					active_pixel, height);
+				return 1;
+			}
+		}
+	}
+
+	HDMIRX_INFO("Check resolution not match => active_pixel(%u) active_line(%u) VIC(%u)",
+		active_pixel, active_line, vic);
+
+	return 0;
+}
+
+void restartHdmiRxWrapperDetection(void)
+{
+	unsigned char hdcp_state;
+
+	stop_mipi_process();
+	set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+	SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+	SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+	set_hdmirx_wrapper_control_0(-1, 0, -1, -1, -1, -1);/* Stop DMA */
+	set_hdmirx_wrapper_hor_threshold(HDMI_MIN_SUPPORT_H_PIXEL);
+#if HDMI2p0
+	bHDMI_6G_flag = 0;
+#endif
+
+	hdcp_state = hdmi_ioctl_struct.hdcp_state;
+	memset(&hdmi_ioctl_struct, 0, sizeof(hdmi_ioctl_struct));
+	/* Keep hdcp state, clear when cable unplugged */
+	hdmi_ioctl_struct.hdcp_state = hdcp_state;
+}
+
+static const char * const str_color[] = {"RGB", "YUV444", "YUV422"};
+static const char * const str_progressive[] = {"Int", "Prog"};
+void hdmirx_wrapper_isr(void)
+{
+	static unsigned char miss_count = 0;
+	unsigned int status;
+	unsigned int active_pixel, active_line;
+
+	status = hdmi_rx_reg_read32(HDMIRX_WRAPPER_INTERRUPT_STATUS, HDMI_RX_HDMI_WRAPPER);
+
+	if (unlikely(status == 0)) {
+		/* HDMIRX_INFO("do nothing..."); */
+		return;
+	} else if (HDMIRX_WRAPPER_INTERRUPT_STATUS_get_polarity_detect_sts(status)) {
+		/* POLARITY_DETECT, Disable interrupt */
+		set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+
+		if (!check_hdmirx_resolution_match()) {
+			/* Format not match, re-enable polarity detection if miss_count<3 */
+			if (miss_count >= 3) {
+				miss_count = 0;
+				HDMIRX_INFO("Polarity detect fail: Reset detection...\n");
+				restartHdmiRxWrapperDetection();
+			} else {
+				miss_count++;
+				/* Enable wrapper interrupt later */
+				schedule_delayed_work(&rxdetect_work, msecs_to_jiffies(1000));
+			}
+			return;
+		}
+
+		HDMIRX_INFO("Polarity detect done: hor(%u) ver(%u) color(%s) I/P(%s)",
+			mipi_top.h_input_len, mipi_top.v_input_len,
+			str_color[mipi_top.input_color],
+			str_progressive[hdmi.tx_timing.progressive]);
+
+		set_hdmirx_wrapper_active_pixels(mipi_top.v_input_len, mipi_top.h_input_len);
+		set_hdmirx_wrapper_hor_threshold(mipi_top.h_input_len);
+
+		hdmi_ioctl_struct.measure_ready = 1;
+
+#if HDMI_REPEATER_SUPPORT
+		Set_Hdmitx_PLL();
+#endif
+		/* Format match, enable error detection */
+		set_hdmirx_wrapper_interrupt_en(1, 1, 0);
+	} else if (HDMIRX_WRAPPER_INTERRUPT_STATUS_get_hor_err_sts(status)) {
+		/* HOR_ERR */
+		set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+
+		active_pixel =	hdmirx_wrapper_get_active_pixel();
+#if 0
+		if (mipi_top.h_input_len-active_pixel <= 5) {
+			set_hdmirx_wrapper_interrupt_en(1, 1, 0);
+			return;
+		} else if ((mipi_top.h_input_len == 1920) && (active_pixel == 1921)) {
+			set_hdmirx_wrapper_interrupt_en(1, 1, 0);
+			return;
+		}
+#endif
+		HDMIRX_INFO("ISR status:%x reenable polarity detection... pixel(%u)\n",
+			status, active_pixel);
+
+		miss_count = 0;
+		restartHdmiRxWrapperDetection();
+		return;
+	} else if (HDMIRX_WRAPPER_INTERRUPT_STATUS_get_ver_err_sts(status)) {
+		/* VER_ERR */
+		set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+
+		active_line = hdmirx_wrapper_get_active_line();
+#if 0
+		if (mipi_top.v_input_len-active_line <= 5) {
+			set_hdmirx_wrapper_interrupt_en(1, 1, 0);
+			return;
+		} else if ((mipi_top.v_input_len == 1080) && (active_line == 1081)) {
+			set_hdmirx_wrapper_interrupt_en(1, 1, 0);
+			return;
+		}
+#endif
+		HDMIRX_INFO("ISR status:%x reenable polarity detection... line(%u)\n",
+			status, active_line);
+
+		miss_count = 0;
+		restartHdmiRxWrapperDetection();
+		return;
+	}
+}
+
+
+void hdmi_related_wrapper_init(void)
+{
+	/* HDMIRX_INFO("[%s]",  __func__); */
+
+	/* v,h,polarity */
+	set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+	/* fifo_stage,fw_dma_en,polarity_set_en,polarity_set,yuv_fmt,hdmirx_en */
+	set_hdmirx_wrapper_control_0(1, 0, 0, 0, 0, 1);
+	set_hdmirx_wrapper_hor_threshold(HDMI_MIN_SUPPORT_H_PIXEL);
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_wrapper.h b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_wrapper.h
new file mode 100644
index 00000000..d9fc205
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/hdmirx_wrapper.h
@@ -0,0 +1,36 @@
+/*
+ * hdmirx_wrapper.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDMIRX_WRAPPER_H__
+#define __HDMIRX_WRAPPER_H__
+
+#define HDMI_MIN_SUPPORT_H_PIXEL    0x40
+
+typedef struct  {
+	unsigned int width;
+	unsigned int height;
+	unsigned int fps;
+	unsigned int interlace;
+} HDMI_VIC_TABLE_T;
+
+extern const HDMI_VIC_TABLE_T hdmi_vic_table[];
+
+void set_hdmirx_wrapper_interrupt_en(int ver_err_en, int hor_err_en, int polarity_detect_en);
+void set_hdmirx_wrapper_active_pixels(unsigned int v_pixel, unsigned int h_pixel);
+void set_hdmirx_wrapper_hor_threshold(unsigned int h_threshold);
+unsigned int hdmirx_wrapper_get_active_line(void);
+unsigned int hdmirx_wrapper_get_active_pixel(void);
+void set_hdmirx_wrapper_control_0(int fifo_stage, int fw_dma_en,
+	int polarity_set_en, int polarity_set, int yuv_fmt, int hdmirx_en);
+void restartHdmiRxWrapperDetection(void);
+void hdmirx_wrapper_isr(void);
+void hdmi_related_wrapper_init(void);
+#endif/* __HDMIRX_WRAPPER_H__ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/mipi_wrapper.c b/drivers/media/platform/rtk_hdmirx/rtd129x/mipi_wrapper.c
new file mode 100644
index 00000000..f443f69
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/mipi_wrapper.c
@@ -0,0 +1,685 @@
+/*
+ * mipi_wrapper.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "v4l2_hdmi_dev.h"
+#include "mipi_wrapper.h"
+#include "hdmirx_reg.h"
+#include "hdmirx_clk_ctrl.h"
+
+#include "rx_drv/hdmiInternal.h"
+
+MIPI_TOP_INFO mipi_top;
+
+/*=================== extern Variable/Function ===================*/
+extern HDMI_INFO_T hdmi;
+extern int hdmi_stream_on;
+
+extern HDMI_ERR_T Hdmi_CheckConditionChange(void);
+extern void hdmirx_wrapper_isr(void);
+extern void set_hdmirx_wrapper_control_0(int fifo_stage, int fw_dma_en,
+	int polarity_set_en, int polarity_set, int yuv_fmt, int hdmirx_en);
+extern void restartHdmiRxWrapperDetection(void);
+#ifdef CONFIG_RTK_HDCPRX_2P2
+extern void  Hdmi_HDCP_2_2_msg_hander(void);
+#endif
+extern void start_hdcp1x_repeater_work(void);
+/*======================================================*/
+
+extern struct ion_device *rtk_phoenix_ion_device;
+
+void register_mipi_ion(struct v4l2_hdmi_dev *dev)
+{
+	struct mipi_ion_buf *ion_buf;
+	unsigned long size;
+	size_t len;
+	int ret_val;
+
+	size = dev->width * dev->height * dev->bpp/8;
+	/* Increase 1/8 size for prevent MIPI write out of range */
+	size = roundup(size*9/8, 4096);
+
+	ion_buf = &dev->ion_buf;
+	ion_buf->client = ion_client_create(rtk_phoenix_ion_device, "hdmirx");
+
+	ion_buf->handle = ion_alloc(ion_buf->client, size, 4096,
+		RTK_PHOENIX_ION_HEAP_MEDIA_MASK,
+		ION_FLAG_NONCACHED | ION_FLAG_HWIPACC);
+
+	if (IS_ERR(ion_buf->handle))
+		HDMIRX_ERROR("%s ion_alloc fail", __func__);
+
+	ret_val = ion_phys(ion_buf->client, ion_buf->handle, &ion_buf->phys_addr, &len);
+	if (ret_val != 0)
+		HDMIRX_ERROR("%s ion_phys fail", __func__);
+
+	HDMIRX_INFO(" ion_addr=0x%08lx size=%zd", ion_buf->phys_addr, len);
+}
+
+void deregister_mipi_ion(struct v4l2_hdmi_dev *dev)
+{
+	struct mipi_ion_buf *ion_buf;
+
+	ion_buf = &dev->ion_buf;
+
+	if (ion_buf->client != NULL) {
+		HDMIRX_INFO("%s", __func__);
+		ion_free(ion_buf->client, ion_buf->handle);
+		ion_buf->client = NULL;
+	}
+}
+
+void mipi_reset_work_func(struct work_struct *work)
+{
+	hdmirx_reset_control(RST_MIPI, CTL_DISABLE);
+	hdmirx_reset_control(RST_MIPI, CTL_ENABLE);
+}
+
+void stop_mipi_process(void)
+{
+	set_enable_mipi(0);
+	/* Stop DMA */
+	set_hdmirx_wrapper_control_0(-1, 0, -1, -1, -1, -1);
+	/* Reset mipi clock */
+	schedule_work(&mipi_top.mipi_reset_work);
+
+	hdmi_stream_on = 0;
+	mipi_top.mipi_init = 0;
+}
+
+void set_mipi_env(void)
+{
+	HDMIRX_DEBUG("[%s]", __func__);
+
+	/* SEL_DIV_RG */
+	hdmi_rx_reg_write32(MIPI_APHY_REG15,
+		MIPI_APHY_REG15_SEL_DIV_RG(DEMUX16), HDMI_RX_MIPI_PHY);
+	/* Lane mux sel & soft reset */
+	hdmi_rx_reg_write32(MIPI_DPHY_REG4,
+		MIPI_DPHY_REG4_SL_RG(fourlane) | MIPI_DPHY_REG4_Sw_rst(disable), HDMI_RX_MIPI_PHY);
+
+	/* 4 lane */
+	hdmi_rx_reg_write32(MIPI_DPHY_PWDB,
+		MIPI_DPHY_PWDB_L3_pwdb(enable) | MIPI_DPHY_PWDB_L2_pwdb(enable) |
+		MIPI_DPHY_PWDB_L1_pwdb(enable) | MIPI_DPHY_PWDB_L0_pwdb(enable),
+		HDMI_RX_MIPI_PHY);/* Lane1 & Lane2 power on */
+
+	hdmi_rx_reg_write32(MIPI_DPHY_REG0,
+		MIPI_DPHY_REG0_Div_sel(div_bit_16) | MIPI_DPHY_REG0_Lane3_en(enable) |
+		MIPI_DPHY_REG0_Lane2_en(enable) | MIPI_DPHY_REG0_Lane1_en(enable) |
+		MIPI_DPHY_REG0_Lane0_en(enable),
+		HDMI_RX_MIPI_PHY);/* 16bit data width, Lane1 & Lane2 enable */
+
+	hdmi_rx_reg_write32(MIPI_DPHY_REG9,
+		MIPI_DPHY_REG9_Lane3_clk_edge(posedge) | MIPI_DPHY_REG9_Lane2_clk_edge(posedge) |
+		MIPI_DPHY_REG9_Lane1_clk_edge(posedge) | MIPI_DPHY_REG9_Lane0_clk_edge(posedge),
+		HDMI_RX_MIPI_PHY);/* Lane CLK edge */
+
+	hdmi_rx_reg_write32(MIPI_DPHY_REG1,
+		MIPI_DPHY_REG1_yuv_src_sel(SEL_UYVY) | MIPI_DPHY_REG1_dec_format(YUV422_dec_format),
+		HDMI_RX_MIPI_PHY);/* SEL_UYVY //SEL_YUYV & Dec data format for YUV422 */
+
+	hdmi_rx_reg_write32(MIPI_DPHY_REG2, MIPI_DPHY_REG2_D_type(DTYPE_YUY8), HDMI_RX_MIPI_PHY);/* MIPI data type YUV422 8bit */
+
+	hdmi_rx_reg_write32(MIPI_DPHY_REG6,
+		MIPI_DPHY_REG6_Dvld_lane1(0x6) | MIPI_DPHY_REG6_Dvld_lane0(0x6),
+		HDMI_RX_MIPI_PHY);
+	hdmi_rx_reg_write32(MIPI_DPHY_REG7,
+		MIPI_DPHY_REG7_Dvld_lane3(0x6) | MIPI_DPHY_REG7_Dvld_lane2(0x6),
+		HDMI_RX_MIPI_PHY);
+
+}
+
+unsigned int rx_pitch_measurement(unsigned int output_h, MIPI_OUT_COLOR_SPACE_T output_color)
+{
+	unsigned int pitch, pitch_factor;
+
+	HDMIRX_INFO("rx_pitch_measurement,output_color=%x\n", output_color);
+
+	switch (output_color) {
+	case OUT_8BIT_YUV422:
+	case OUT_8BIT_YUV420:
+		pitch_factor = 1;
+		break;
+	case OUT_10BIT_YUV422:
+		pitch_factor = 2;
+		break;
+	default: /* all other RGB case */
+		pitch_factor = 4;
+		break;
+	}
+
+	pitch = output_h * pitch_factor;
+	/* pitch has to be n*16 byte */
+	if (output_color < OUT_ARGB)
+		pitch = roundup16(pitch);
+
+	return pitch;
+}
+
+void set_video_DDR_start_addr(struct v4l2_hdmi_dev *dev)
+{
+	unsigned int addry;
+	unsigned int addruv;
+	unsigned int offset;
+	unsigned long flags = 0;
+	struct hdmi_dmaqueue *hdmidq;
+	struct mipi_ion_buf *ion_buf;
+
+	hdmidq = &dev->hdmidq;
+	ion_buf = &dev->ion_buf;
+
+	offset = roundup16(mipi_top.pitch) * roundup16(mipi_top.v_output_len);
+
+	spin_lock_irqsave(&dev->slock, flags);
+	hdmidq->skip_frame[0] = 1;
+	hdmidq->skip_frame[1] = 1;
+
+	addry = ion_buf->phys_addr;
+	addruv = ion_buf->phys_addr + offset;
+	set_video_dest_addr(addry, addruv, addry, addruv);
+	spin_unlock_irqrestore(&dev->slock, flags);
+
+	HDMIRX_INFO("[%s] addr1y(0x%08x) addr1uv(0x%08x) addr2y(0x%08x) addr2uv(0x%08x)",
+		__func__, addry, addruv, addry, addruv);
+}
+
+void set_mipi_type(unsigned int type)
+{
+	unsigned int reg_val;
+
+	HDMIRX_DEBUG("[%s] type(%u)", __func__, type);
+
+	reg_val = hdmi_rx_reg_read32(MIPI_TYPE, HDMI_RX_MIPI);
+
+	reg_val = reg_val & (~MIPI_TYPE_mipi_type_mask);
+
+	hdmi_rx_reg_write32(MIPI_TYPE, reg_val | MIPI_TYPE_mipi_type(type), HDMI_RX_MIPI);
+}
+
+void set_pic_dest_addr(int addry, int addruv)
+{
+	if (addry >= 0)
+		hdmi_rx_reg_write32(MIPI_SA2, addry, HDMI_RX_MIPI);
+
+
+	if (addruv >= 0)
+		hdmi_rx_reg_write32(MIPI_SA2_UV, addruv, HDMI_RX_MIPI);
+
+}
+
+void set_pic_dest_size(unsigned int dst_width, unsigned int pitch)
+{
+
+	hdmi_rx_reg_write32(MIPI_SIZE1,
+		MIPI_SIZE1_dst_width_pic(dst_width) | MIPI_SIZE1_pitch_pic(pitch), HDMI_RX_MIPI);
+}
+
+void set_video_dest_addr(int addr1y, int addr1uv, int addr2y, int addr2uv)
+{
+	if (addr1y >= 0)
+		hdmi_rx_reg_write32(MIPI_SA0, addr1y, HDMI_RX_MIPI);
+
+	if (addr1uv >= 0)
+		hdmi_rx_reg_write32(MIPI_SA0_UV, addr1uv, HDMI_RX_MIPI);
+
+	if (addr2y >= 0)
+		hdmi_rx_reg_write32(MIPI_SA1, addr2y, HDMI_RX_MIPI);
+
+	if (addr2uv >= 0)
+		hdmi_rx_reg_write32(MIPI_SA1_UV, addr2uv, HDMI_RX_MIPI);
+}
+
+void set_video_dest_size(unsigned int dst_width, unsigned int pitch)
+{
+
+	hdmi_rx_reg_write32(MIPI_SIZE0,
+		MIPI_SIZE0_dst_width_video(dst_width) | MIPI_SIZE0_pitch_video(pitch), HDMI_RX_MIPI);
+}
+
+void set_video_src_size(unsigned int src_width)
+{
+	unsigned int reg_val;
+
+	reg_val = hdmi_rx_reg_read32(MIPI_SIZE2, HDMI_RX_MIPI);
+	reg_val = reg_val & (~MIPI_SIZE2_src_width_video_mask);
+	hdmi_rx_reg_write32(MIPI_SIZE2, reg_val | MIPI_SIZE2_src_width_video(src_width), HDMI_RX_MIPI);
+}
+
+void set_init_mipi_value(MIPI_REG *mipi_reg)
+{
+	unsigned int reg_val = 0;
+
+	reg_val = (mipi_reg->dst_fmt << 27) |
+			(mipi_reg->src_fmt << 25) |
+			(mipi_reg->src_sel << 24) |
+			(mipi_reg->yuv420_uv_seq << 23) |
+			(mipi_reg->vs << 22) |
+			(mipi_reg->vs_near << 21) |
+			(mipi_reg->vs_yodd << 20) |
+			(mipi_reg->vs_codd << 19) |
+			(mipi_reg->hs << 18) |
+			(mipi_reg->hs_yodd << 17) |
+			(mipi_reg->hs_codd << 16) |
+			(mipi_reg->yuv420_fmt << 15) |
+			(mipi_reg->ccs_data_format << 13) |
+			(mipi_reg->yuv_to_rgb << 12) |
+			(mipi_reg->chroma_ds_mode << 11) |
+			(mipi_reg->chroma_ds_en << 10) |
+			(mipi_reg->chroma_us_mode << 9) |
+			(mipi_reg->chroma_us_en << 8) |
+			(mipi_reg->hdmirx_interlace_en << 7) |
+			(mipi_reg->hdmirx_interlace_polarity << 6) |
+			(mipi_reg->int_en4 << 5) |
+			(mipi_reg->int_en3 << 4) |
+			(mipi_reg->int_en2 << 3) |
+			(mipi_reg->int_en1 << 2) |
+			(mipi_reg->int_en0 << 1) |
+			(mipi_reg->en);
+
+	hdmi_rx_reg_write32(MIPI, reg_val, HDMI_RX_MIPI);
+	HDMIRX_INFO("Set MIPI=0x%08x", reg_val);
+	HDMIRX_INFO("Read MIPI=0x%08x", hdmi_rx_reg_read32(MIPI, HDMI_RX_MIPI));
+}
+
+void set_enable_mipi(unsigned char enable)
+{
+	unsigned int reg_val;
+
+	hdmi_rx_reg_mask32(MIPI,
+		~(MIPI_int_en0_mask | MIPI_int_en1_mask | MIPI_int_en2_mask |
+		MIPI_int_en3_mask | MIPI_int_en4_mask | MIPI_en_mask),
+		MIPI_int_en0(enable) | MIPI_int_en1(enable) | MIPI_int_en2(enable) |
+		MIPI_int_en3(enable) | MIPI_int_en4(enable) | MIPI_en(enable),
+		HDMI_RX_MIPI);
+
+	if (enable == 0) {
+		reg_val = hdmi_rx_reg_read32(MIPI_INT_ST, HDMI_RX_MIPI);
+		hdmi_rx_reg_write32(MIPI_INT_ST, reg_val, HDMI_RX_MIPI);
+	}
+}
+
+void set_hs_scaler(unsigned int hsi_offset, unsigned int hsi_phase, unsigned int hsd_out, unsigned int hsd_delta)
+{
+	hdmi_rx_reg_write32(SCALER_HSI,
+		SCALER_HSI_hsi_offset(hsi_offset) |
+		SCALER_HSI_hsi_phase(hsi_phase), HDMI_RX_MIPI);
+
+	hdmi_rx_reg_write32(SCALER_HSD,
+		SCALER_HSD_hsd_out(hsd_out) |
+		SCALER_HSD_hsd_delta(hsd_delta), HDMI_RX_MIPI);
+
+	HDMIRX_INFO("hsd_out=%u,hsd_delta=0x%x", hsd_out, hsd_delta);
+}
+
+void set_hs_coeff(void)
+{
+	unsigned int reg_val;
+
+	/* for Y */
+	reg_val = (0x400<<16) | 0x400;
+	hdmi_rx_reg_write32(SCALER_HSYNC0, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC1, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC2, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC3, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC4, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC5, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC6, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC7, reg_val, HDMI_RX_MIPI);
+
+	/* for U,V */
+	hdmi_rx_reg_write32(SCALER_HSCC0, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC1, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC2, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC3, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC4, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC5, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC6, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC7, reg_val, HDMI_RX_MIPI);
+}
+
+void set_vs_scaler(unsigned int vsi_offset, unsigned int vsi_phase, unsigned int vsd_out, unsigned int vsd_delta)
+{
+	hdmi_rx_reg_write32(SCALER_VSI,
+		SCALER_VSI_vsi_offset(vsi_offset) |
+		SCALER_VSI_vsi_phase(vsi_phase), HDMI_RX_MIPI);
+
+	hdmi_rx_reg_write32(SCALER_VSD,
+		SCALER_VSD_vsd_out(vsd_out) |
+		SCALER_VSD_vsd_delta(vsd_delta), HDMI_RX_MIPI);
+
+	HDMIRX_INFO("vsd_out=%u,vsd_delta=0x%x\n", vsd_out, vsd_delta);
+}
+
+void set_vs_coeff(void)
+{
+	unsigned int reg_val;
+
+	reg_val = (0x800<<16) | 0x800;
+	hdmi_rx_reg_write32(SCALER_VSYC0, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSCC0, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSYC1, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSCC1, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSYC2, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSCC2, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSYC3, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSCC3, reg_val, HDMI_RX_MIPI);
+}
+
+void set_alpha(unsigned int alpha)
+{
+
+	hdmi_rx_reg_write32(CONSTANT_ALPHA, CONSTANT_ALPHA_alpha(alpha), HDMI_RX_MIPI);
+}
+
+void set_YUV2RGB_coeff(void)
+{
+	hdmi_rx_reg_write32(CS_TRANS0,  0x04a80, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS1,  0x00000, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS2,  0x072c0, HDMI_RX_MIPI);
+
+	hdmi_rx_reg_write32(CS_TRANS3,  0x04a80, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS4,  0x1f260, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS5,  0x1ddd0, HDMI_RX_MIPI);
+
+	hdmi_rx_reg_write32(CS_TRANS6,  0x04a80, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS7,  0x08760, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS8,  0x00000, HDMI_RX_MIPI);
+
+	hdmi_rx_reg_write32(CS_TRANS9,  0x0fc20, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS10, 0x00134, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS11, 0x0fb7c, HDMI_RX_MIPI);
+}
+
+void set_RGB2YUV_coeff(void)
+{
+	/* C1~C3 */
+	hdmi_rx_reg_write32(CS_TRANS0,	0x00BB8, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS1,	0x02748, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS2,	0x003F8, HDMI_RX_MIPI);
+	/* C4~C6 */
+	hdmi_rx_reg_write32(CS_TRANS3,	0x1F988, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS4,	0x1EA60, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS5,	0x01C18, HDMI_RX_MIPI);
+	/* C7~C9 */
+	hdmi_rx_reg_write32(CS_TRANS6,	0x01C18, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS7,	0x1E6E9, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS8,	0x1FD7B, HDMI_RX_MIPI);
+	/* K1~K3 */
+	hdmi_rx_reg_write32(CS_TRANS9,	0x00100, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS10, 0x00800, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS11, 0x00800, HDMI_RX_MIPI);
+}
+
+void mipi_scale_down(unsigned int src_width, unsigned int src_height,
+	unsigned int dst_width, unsigned int dst_height)
+{
+	unsigned int delta_num, delta_den, offset, phase;
+
+	if (src_width >= dst_width) {
+		/* set hs_scaler */
+		offset = 0;
+		phase = 0;
+		delta_num = (src_width / dst_width) << 14;
+		delta_den = ((src_width % dst_width)*0x4000) / dst_width;
+		/* set_hs_scaler: offset,phase,out,delta */
+		set_hs_scaler(offset, phase, dst_width, (delta_num | delta_den));
+		set_hs_coeff();
+	}
+
+	if (src_height >= dst_height) {
+		/* set vs_scaler */
+		offset = 0;
+		phase = 0;
+		delta_num = (src_height / dst_height) << 14;
+		delta_den = ((src_height % dst_height)*0x4000) / dst_height;
+		/* set_vs_scaler: offset,phase,out,delta */
+		set_vs_scaler(offset, phase, dst_height, (delta_num | delta_den));
+		set_vs_coeff();
+	}
+}
+
+void setup_mipi(void)
+{
+	MIPI_REG mipi_reg;
+	unsigned int v_input, h_input;
+
+	HDMIRX_INFO("[%s]", __func__);
+
+	set_mipi_env();
+	set_mipi_type(0);/* 0:video, 1:pic */
+
+	memset(&mipi_reg, 0, sizeof(MIPI_REG));
+
+	mipi_reg.dst_fmt = mipi_top.output_color;
+	mipi_reg.src_fmt = mipi_top.input_color;
+	mipi_reg.src_sel = mipi_top.src_sel;
+	mipi_reg.yuv420_uv_seq = mipi_top.uv_seq;
+
+	if (!hdmi.tx_timing.progressive)/* Interlace */
+		v_input = mipi_top.v_input_len*2;
+	else
+		v_input = mipi_top.v_input_len;
+
+	h_input = mipi_top.h_input_len;
+
+	if (v_input > mipi_top.v_output_len)
+		mipi_reg.vs = 1;
+
+	if (h_input > mipi_top.h_output_len)
+		mipi_reg.hs = 1;
+
+	if (mipi_reg.dst_fmt == OUT_10BIT_YUV422)
+		mipi_reg.yuv420_fmt = 1;
+
+	/* mipi_reg.ccs_data_format */
+
+	if ((mipi_top.input_color != IN_RGB888) &&
+		(mipi_top.output_color >= OUT_ARGB)) {
+		/* YUV -> RGB */
+		mipi_reg.yuv_to_rgb = 1;
+		set_alpha(0xff);
+		set_YUV2RGB_coeff();
+	} else if ((mipi_top.input_color == IN_RGB888) &&
+		(mipi_top.output_color <= OUT_10BIT_YUV420)) {
+		/* RGB -> YUV */
+		mipi_reg.chroma_ds_mode = 1;/* 0:drop 1:avg */
+		mipi_reg.chroma_ds_en = 1;
+		mipi_reg.yuv_to_rgb = 1;
+		set_RGB2YUV_coeff();
+	}
+
+	if ((mipi_top.input_color == IN_YUV444) &&
+		(mipi_top.output_color <= OUT_10BIT_YUV420)) {
+		mipi_reg.chroma_ds_mode = 1;/* 0:drop 1:avg */
+		mipi_reg.chroma_ds_en = 1;
+	}
+
+	if ((mipi_top.input_color == IN_YUV422) && (mipi_reg.vs || mipi_reg.hs)) {
+		mipi_reg.chroma_us_mode = 0;/* 0:repeat 1:avg */
+		mipi_reg.chroma_us_en = 1;
+		if (mipi_top.output_color <= OUT_10BIT_YUV420) {
+			mipi_reg.chroma_ds_mode = 1;/* 0:drop 1:avg */
+			mipi_reg.chroma_ds_en = 1;
+		}
+	}
+
+	mipi_reg.hdmirx_interlace_en = (!hdmi.tx_timing.progressive);
+	/* Set polarity: 0 - Button field first, 1 - Top field first */
+	mipi_reg.hdmirx_interlace_polarity = 1;
+
+	mipi_reg.int_en4 = 1;
+	mipi_reg.int_en3 = 1;
+	mipi_reg.int_en2 = 1;
+	mipi_reg.int_en1 = 1;
+	mipi_reg.int_en0 = 1;
+
+	mipi_reg.en = 1;
+
+	set_video_dest_size(mipi_top.h_output_len, mipi_top.pitch);
+	set_video_src_size(mipi_top.h_input_len);
+
+	mipi_scale_down(h_input, v_input,
+		mipi_top.h_output_len, mipi_top.v_output_len);
+
+	hdmi_rx_reg_write32(MIPI_DPHY_REG11,
+		MIPI_DPHY_REG11_Esc_lane3_int_flg(1) |
+		MIPI_DPHY_REG11_Esc_lane2_int_flg(1) |
+		MIPI_DPHY_REG11_Esc_lane1_int_flg(1) |
+		MIPI_DPHY_REG11_Esc_lane0_int_flg(1)|
+		MIPI_DPHY_REG11_Clk_ulps_int_flg(1)|
+		MIPI_DPHY_REG11_Crc16_err_int_flg(1)|
+		MIPI_DPHY_REG11_Ecc_crt_int_flg(1)|
+		MIPI_DPHY_REG11_Ecc_err_int_flg(1), HDMI_RX_MIPI_PHY);
+
+	set_init_mipi_value(&mipi_reg);
+	set_hdmirx_wrapper_control_0(-1, 1, mipi_reg.hdmirx_interlace_en, mipi_reg.hdmirx_interlace_polarity, -1, -1);
+	mipi_top.mipi_init = 1;
+}
+
+void update_mipi_hw_buffer(int src_index, struct v4l2_hdmi_dev *dev, int buffer_empty)
+{
+	unsigned long flags;
+	unsigned int addry;
+	unsigned int addruv;
+	unsigned int offset;
+	struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;
+
+	offset = roundup16(mipi_top.pitch) * roundup16(mipi_top.v_output_len);
+
+	spin_lock_irqsave(&dev->slock, flags);
+
+	if (hdmidq->skip_frame[src_index] == 0) {
+		vb2_buffer_done(&hdmidq->hwbuf[src_index]->vb, VB2_BUF_STATE_DONE);
+		atomic_inc(&hdmidq->rcnt);
+	}
+
+	if (buffer_empty == 0) {
+		hdmidq->hwbuf[src_index] = list_entry(hdmidq->active.next, struct hdmi_buffer, list);
+		list_del(&hdmidq->hwbuf[src_index]->list);
+		atomic_dec(&hdmidq->qcnt);
+		hdmidq->skip_frame[src_index] = 0;
+
+		addry = hdmidq->hwbuf[src_index]->phys;
+		addruv = hdmidq->hwbuf[src_index]->phys + offset;
+	} else {
+		addry = dev->ion_buf.phys_addr;
+		addruv = dev->ion_buf.phys_addr + offset;
+		hdmidq->skip_frame[src_index] = 1;
+		hdmidq->hwbuf[src_index] = NULL;
+	}
+
+	spin_unlock_irqrestore(&dev->slock, flags);
+
+	if (src_index == 0)
+		set_video_dest_addr(addry, addruv, -1, -1);
+	else
+		set_video_dest_addr(-1, -1, addry, addruv);
+}
+
+void hdmi_hw_buf_update(int src_index, struct v4l2_hdmi_dev *dev)
+{
+	static int skip_num = 0;
+	static int total_num = 0;
+	static unsigned long prev_jif = 0;
+	unsigned long flags;
+	int empty;
+	struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;
+
+	if ((mipi_top.src_sel == 1) &&
+		(Hdmi_CheckConditionChange() != HDMI_ERR_NO)) {
+
+		HDMIRX_INFO("Condition change, restart detection");
+		restartHdmiRxWrapperDetection();
+		return;
+	}
+
+	if (mipi_top.mipi_init == 0)
+		return;
+
+	if (unlikely((jiffies - prev_jif) >= (10 * HZ))) {
+		HDMIRX_INFO("skip %d/%d in %lu jiffies\n",
+			skip_num, total_num, jiffies - prev_jif);
+		prev_jif = jiffies;
+		total_num = 0;
+		skip_num = 0;
+	}
+	total_num++;
+
+	spin_lock_irqsave(&dev->slock, flags);
+	empty = list_empty(&hdmidq->active);
+	spin_unlock_irqrestore(&dev->slock, flags);
+
+	if (empty)
+		skip_num++;
+
+	update_mipi_hw_buffer(src_index, dev, empty);
+}
+
+irqreturn_t hdmirx_mipi_isr(int irq, void *dev_id)
+{
+	unsigned int st_reg_val;
+	unsigned int reg_val;
+	struct v4l2_hdmi_dev *dev = dev_id;
+
+	hdmirx_wrapper_isr();
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+	/* Get TX write Aksv */
+	if (HDCP_FLAG1_get_wr_aksv_flag(hdmi_rx_reg_read32(HDCP_FLAG1, HDMI_RX_MAC))) {
+		/* Disable AKSV interrupt */
+		hdmi_rx_reg_mask32(HDCP_FLAG2, ~HDCP_FLAG2_irq_aksv_en_mask,
+			0, HDMI_RX_MAC);
+		/* Clear Aksv flag */
+		hdmi_rx_reg_write32(HDCP_FLAG1, HDCP_FLAG1_wr_aksv_flag_mask, HDMI_RX_MAC);
+		/* Clear HDCP interrupt */
+		hdmi_rx_reg_write32(HDMI_INTCR, HDMI_INTCR_pending_mask, HDMI_RX_MAC);
+		start_hdcp1x_repeater_work();
+	}
+#endif
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+	Hdmi_HDCP_2_2_msg_hander();
+
+	/* Return isr if dma not enabled */
+	if (!HDMIRX_WRAPPER_CONTROL_0_get_fw_dma_en(hdmi_rx_reg_read32(HDMIRX_WRAPPER_CONTROL_0, HDMI_RX_HDMI_WRAPPER)))
+		return IRQ_HANDLED;
+#endif
+
+	st_reg_val = hdmi_rx_reg_read32(MIPI_INT_ST, HDMI_RX_MIPI);
+
+	if (st_reg_val & 0x30) {
+		/* Clear interrupt status */
+		hdmi_rx_reg_write32(MIPI_INT_ST, st_reg_val, HDMI_RX_MIPI);
+
+		HDMIRX_INFO("MIPI frame dropped");
+
+		return IRQ_HANDLED;
+	}
+
+	reg_val = hdmi_rx_reg_read32(MIPI_TYPE, HDMI_RX_MIPI);
+	if (unlikely(reg_val & 0x01)) {
+		/* Picture mode */
+		if (st_reg_val & MIPI_INT_ST_fm_done2_mask)
+			hdmi_rx_reg_write32(MIPI_INT_ST, st_reg_val, HDMI_RX_MIPI);
+	} else {
+		/* Preview or video mode */
+		if (st_reg_val & MIPI_INT_ST_fm_done0_mask)
+			hdmi_hw_buf_update(0, dev);
+		else if (st_reg_val & MIPI_INT_ST_fm_done1_mask)
+			hdmi_hw_buf_update(1, dev);
+
+		/* Clear interrupt status */
+		hdmi_rx_reg_write32(MIPI_INT_ST, st_reg_val, HDMI_RX_MIPI);
+	}
+
+	return IRQ_HANDLED;
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/mipi_wrapper.h b/drivers/media/platform/rtk_hdmirx/rtd129x/mipi_wrapper.h
new file mode 100644
index 00000000..c3b3281
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/mipi_wrapper.h
@@ -0,0 +1,149 @@
+/*
+ * mipi_wrapper.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _MIPI_WRAPPER_H_
+#define _MIPI_WRAPPER_H_
+
+typedef struct {
+	unsigned int dst_fmt;
+	unsigned int src_fmt;
+	unsigned int src_sel;
+	unsigned int yuv420_uv_seq;
+	unsigned int vs;
+	unsigned int vs_near;
+	unsigned int vs_yodd;
+	unsigned int vs_codd;
+	unsigned int hs;
+	unsigned int hs_yodd;
+	unsigned int hs_codd;
+	unsigned int yuv420_fmt;
+	unsigned int ccs_data_format;
+	unsigned int yuv_to_rgb;
+	unsigned int chroma_ds_mode;
+	unsigned int chroma_ds_en;
+	unsigned int chroma_us_mode;
+	unsigned int chroma_us_en;
+	unsigned int hdmirx_interlace_en;
+	unsigned int hdmirx_interlace_polarity;
+	unsigned int int_en4;
+	unsigned int int_en3;
+	unsigned int int_en2;
+	unsigned int int_en1;
+	unsigned int int_en0;
+	unsigned int en;
+} MIPI_REG;
+
+typedef enum {
+	OUT_8BIT_YUV422   = 0x2,
+	OUT_8BIT_YUV420   = 0x3,
+	OUT_10BIT_YUV422  = 0x4,
+	OUT_10BIT_YUV420  = 0x5,
+	OUT_ARGB  = 0x10,
+	OUT_ARBG  = 0x11,
+	OUT_AGRB  = 0x12,
+	OUT_AGBR  = 0x13,
+	OUT_ABRG  = 0x14,
+	OUT_ABGR  = 0x15,
+	OUT_RGBA  = 0x16,
+	OUT_RBGA  = 0x17,
+	OUT_GRBA  = 0x18,
+	OUT_GBRA  = 0x19,
+	OUT_BRGA  = 0x1A,
+	OUT_BGRA  = 0x1B,
+	OUT_UNKNOW
+} MIPI_OUT_COLOR_SPACE_T;
+
+typedef enum {
+	IN_RGB888 = 0x0,
+	IN_YUV444 = 0x1,
+	IN_YUV422 = 0x2,
+	IN_UNKNOW
+} MIPI_IN_COLOR_SPACE_T;
+
+typedef enum {
+	UV_NV12 = 0x0,/* U0V0U1V1 */
+	UV_NV21 = 0x1,/* V0U0V1U1 */
+} MIPI_YUV420_UV_SEQ;
+
+typedef struct {
+	char hdmi_rx_init;
+	char mipi_init;
+	unsigned int src_sel; /* 0:mipi; 1:hdmi_rx */
+	unsigned int h_input_len;
+	unsigned int v_input_len;
+	MIPI_IN_COLOR_SPACE_T input_color;
+	unsigned int h_output_len;
+	unsigned int v_output_len;
+	MIPI_OUT_COLOR_SPACE_T output_color;
+	MIPI_YUV420_UV_SEQ uv_seq;
+	int pitch;
+	struct work_struct mipi_reset_work;
+} MIPI_TOP_INFO;
+
+enum {
+	DEMUX8   = 0x0,
+	DEMUX16  = 0x1,
+	DEMUX32  = 0x2,
+};
+
+enum {
+	Onelane  = 0x0,
+	fourlane = 0x1,
+};
+
+enum {
+	disable = 0x0,
+	enable  = 0x1,
+};
+
+enum {
+	dvi_bit_8  = 0x0,
+	div_bit_16 = 0x1,
+	div_bit_32 = 0x2,
+};
+
+enum {
+	posedge = 0x0,
+	negedge = 0x1,
+};
+
+enum YUV_SRC_SEL {
+	SEL_UYVY  = 0x0,
+	SEL_VYUY  = 0x1,
+	SEL_YVYU  = 0x2,
+	SEL_YUYV  = 0x3,
+};
+
+enum DEC_FORMAT {
+	RAW8_dec_format    = 0x0,
+	RAW10_dec_format   = 0x1,
+	YUV422_dec_format  = 0x2,
+	JPEG_dec_format    = 0x3,
+	RAW12_dec_format   = 0x4,
+};
+
+enum {
+	DTYPE_YUY8    =	   0x1E,
+	DTYPE_MJPEG   =    0x31,
+};
+
+void register_mipi_ion(struct v4l2_hdmi_dev *dev);
+void deregister_mipi_ion(struct v4l2_hdmi_dev *dev);
+void mipi_reset_work_func(struct work_struct *work);
+void stop_mipi_process(void);
+void set_mipi_env(void);
+void set_enable_mipi(unsigned char enable);
+void set_mipi_type(unsigned int type);
+void set_video_dest_addr(int addr1y, int addr1uv, int addr2y, int addr2uv);
+void set_video_DDR_start_addr(struct v4l2_hdmi_dev *dev);
+void setup_mipi(void);
+irqreturn_t hdmirx_mipi_isr(int irq, void *dev_id);
+#endif/* _MIPI_WRAPPER_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/DFE_HDMI_RX_PHY_fw.h b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/DFE_HDMI_RX_PHY_fw.h
new file mode 100644
index 00000000..caf6ec7
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/DFE_HDMI_RX_PHY_fw.h
@@ -0,0 +1,4124 @@
+/*===========*@date:2015/3/6===========*/
+
+#ifndef _DFE_HDMI_RX_PHY_REG_H_INCLUDED_
+#define _DFE_HDMI_RX_PHY_REG_H_INCLUDED_
+
+#define BG                                                            0xa00
+#define BG_reg_addr                                                   "0x98034a00"
+#define BG_reg                                                        0x98034a00
+#define BG_inst_addr                                                  "0x0280"
+#define BG_inst                                                       0x0280
+#define set_BG_reg(data)                                              (*((volatile unsigned int*)BG_reg)=data)
+#define get_BG_reg                                                    (*((volatile unsigned int*)BG_reg))
+#define BG_reg_bg_rbgloop2_shift                                      (7)
+#define BG_reg_bg_rbg_shift                                           (4)
+#define BG_reg_bg_rbg2_shift                                          (2)
+#define BG_reg_bg_pow_shift                                           (1)
+#define BG_reg_bg_envbgup_shift                                       (0)
+#define BG_reg_bg_rbgloop2_mask                                       (0x00000380)
+#define BG_reg_bg_rbg_mask                                            (0x00000070)
+#define BG_reg_bg_rbg2_mask                                           (0x0000000C)
+#define BG_reg_bg_pow_mask                                            (0x00000002)
+#define BG_reg_bg_envbgup_mask                                        (0x00000001)
+#define BG_reg_bg_rbgloop2(data)                                      (0x00000380&((data)<<7))
+#define BG_reg_bg_rbg(data)                                           (0x00000070&((data)<<4))
+#define BG_reg_bg_rbg2(data)                                          (0x0000000C&((data)<<2))
+#define BG_reg_bg_pow(data)                                           (0x00000002&((data)<<1))
+#define BG_reg_bg_envbgup(data)                                       (0x00000001&(data))
+#define BG_get_reg_bg_rbgloop2(data)                                  ((0x00000380&(data))>>7)
+#define BG_get_reg_bg_rbg(data)                                       ((0x00000070&(data))>>4)
+#define BG_get_reg_bg_rbg2(data)                                      ((0x0000000C&(data))>>2)
+#define BG_get_reg_bg_pow(data)                                       ((0x00000002&(data))>>1)
+#define BG_get_reg_bg_envbgup(data)                                   (0x00000001&(data))
+
+
+#define MD                                                            0xa04
+#define MD_reg_addr                                                   "0x98034a04"
+#define MD_reg                                                        0x98034a04
+#define MD_inst_addr                                                  "0x0281"
+#define MD_inst                                                       0x0281
+#define set_MD_reg(data)                                              (*((volatile unsigned int*)MD_reg)=data)
+#define get_MD_reg                                                    (*((volatile unsigned int*)MD_reg))
+#define MD_reg_ck_latch_shift                                         (4)
+#define MD_reg_ck_cmp_shift                                           (3)
+#define MD_reg_ck_ckdet_shift                                         (0)
+#define MD_reg_ck_latch_mask                                          (0x00000010)
+#define MD_reg_ck_cmp_mask                                            (0x00000008)
+#define MD_reg_ck_ckdet_mask                                          (0x00000007)
+#define MD_reg_ck_latch(data)                                         (0x00000010&((data)<<4))
+#define MD_reg_ck_cmp(data)                                           (0x00000008&((data)<<3))
+#define MD_reg_ck_ckdet(data)                                         (0x00000007&(data))
+#define MD_get_reg_ck_latch(data)                                     ((0x00000010&(data))>>4)
+#define MD_get_reg_ck_cmp(data)                                       ((0x00000008&(data))>>3)
+#define MD_get_reg_ck_ckdet(data)                                     (0x00000007&(data))
+
+
+#define LDO                                                           0xa08
+#define LDO_reg_addr                                                  "0x98034a08"
+#define LDO_reg                                                       0x98034a08
+#define LDO_inst_addr                                                 "0x0282"
+#define LDO_inst                                                      0x0282
+#define set_LDO_reg(data)                                             (*((volatile unsigned int*)LDO_reg)=data)
+#define get_LDO_reg                                                   (*((volatile unsigned int*)LDO_reg))
+#define LDO_reg_p2_ldo_sel_shift                                      (7)
+#define LDO_reg_p1_ldo_sel_shift                                      (5)
+#define LDO_reg_p0_ldo_sel_shift                                      (3)
+#define LDO_reg_p2_ldo_pow_shift                                      (2)
+#define LDO_reg_p1_ldo_pow_shift                                      (1)
+#define LDO_reg_p0_ldo_pow_shift                                      (0)
+#define LDO_reg_p2_ldo_sel_mask                                       (0x00000180)
+#define LDO_reg_p1_ldo_sel_mask                                       (0x00000060)
+#define LDO_reg_p0_ldo_sel_mask                                       (0x00000018)
+#define LDO_reg_p2_ldo_pow_mask                                       (0x00000004)
+#define LDO_reg_p1_ldo_pow_mask                                       (0x00000002)
+#define LDO_reg_p0_ldo_pow_mask                                       (0x00000001)
+#define LDO_reg_p2_ldo_sel(data)                                      (0x00000180&((data)<<7))
+#define LDO_reg_p1_ldo_sel(data)                                      (0x00000060&((data)<<5))
+#define LDO_reg_p0_ldo_sel(data)                                      (0x00000018&((data)<<3))
+#define LDO_reg_p2_ldo_pow(data)                                      (0x00000004&((data)<<2))
+#define LDO_reg_p1_ldo_pow(data)                                      (0x00000002&((data)<<1))
+#define LDO_reg_p0_ldo_pow(data)                                      (0x00000001&(data))
+#define LDO_get_reg_p2_ldo_sel(data)                                  ((0x00000180&(data))>>7)
+#define LDO_get_reg_p1_ldo_sel(data)                                  ((0x00000060&(data))>>5)
+#define LDO_get_reg_p0_ldo_sel(data)                                  ((0x00000018&(data))>>3)
+#define LDO_get_reg_p2_ldo_pow(data)                                  ((0x00000004&(data))>>2)
+#define LDO_get_reg_p1_ldo_pow(data)                                  ((0x00000002&(data))>>1)
+#define LDO_get_reg_p0_ldo_pow(data)                                  (0x00000001&(data))
+
+
+#define MHL                                                           0xa0c
+#define MHL_reg_addr                                                  "0x98034a0c"
+#define MHL_reg                                                       0x98034a0c
+#define MHL_inst_addr                                                 "0x0283"
+#define MHL_inst                                                      0x0283
+#define set_MHL_reg(data)                                             (*((volatile unsigned int*)MHL_reg)=data)
+#define get_MHL_reg                                                   (*((volatile unsigned int*)MHL_reg))
+#define MHL_reg_p2_mhl_hdmi_datasel_shift                             (9)
+#define MHL_reg_p2_mhl_hdmi_cksel_shift                               (8)
+#define MHL_reg_p2_mhl_pow_shift                                      (7)
+#define MHL_reg_p1_mhl_hdmi_datasel_shift                             (6)
+#define MHL_reg_p1_mhl_hdmi_cksel_shift                               (5)
+#define MHL_reg_p1_mhl_pow_shift                                      (4)
+#define MHL_reg_p0_mhl_hdmi_cksel_shift                               (3)
+#define MHL_reg_p0_mhl_hdmi_datasel_shift                             (2)
+#define MHL_reg_p0_mhl_pow_shift                                      (1)
+#define MHL_reg_mhl_hdmisel_shift                                     (0)
+#define MHL_reg_p2_mhl_hdmi_datasel_mask                              (0x00000200)
+#define MHL_reg_p2_mhl_hdmi_cksel_mask                                (0x00000100)
+#define MHL_reg_p2_mhl_pow_mask                                       (0x00000080)
+#define MHL_reg_p1_mhl_hdmi_datasel_mask                              (0x00000040)
+#define MHL_reg_p1_mhl_hdmi_cksel_mask                                (0x00000020)
+#define MHL_reg_p1_mhl_pow_mask                                       (0x00000010)
+#define MHL_reg_p0_mhl_hdmi_cksel_mask                                (0x00000008)
+#define MHL_reg_p0_mhl_hdmi_datasel_mask                              (0x00000004)
+#define MHL_reg_p0_mhl_pow_mask                                       (0x00000002)
+#define MHL_reg_mhl_hdmisel_mask                                      (0x00000001)
+#define MHL_reg_p2_mhl_hdmi_datasel(data)                             (0x00000200&((data)<<9))
+#define MHL_reg_p2_mhl_hdmi_cksel(data)                               (0x00000100&((data)<<8))
+#define MHL_reg_p2_mhl_pow(data)                                      (0x00000080&((data)<<7))
+#define MHL_reg_p1_mhl_hdmi_datasel(data)                             (0x00000040&((data)<<6))
+#define MHL_reg_p1_mhl_hdmi_cksel(data)                               (0x00000020&((data)<<5))
+#define MHL_reg_p1_mhl_pow(data)                                      (0x00000010&((data)<<4))
+#define MHL_reg_p0_mhl_hdmi_cksel(data)                               (0x00000008&((data)<<3))
+#define MHL_reg_p0_mhl_hdmi_datasel(data)                             (0x00000004&((data)<<2))
+#define MHL_reg_p0_mhl_pow(data)                                      (0x00000002&((data)<<1))
+#define MHL_reg_mhl_hdmisel(data)                                     (0x00000001&(data))
+#define MHL_get_reg_p2_mhl_hdmi_datasel(data)                         ((0x00000200&(data))>>9)
+#define MHL_get_reg_p2_mhl_hdmi_cksel(data)                           ((0x00000100&(data))>>8)
+#define MHL_get_reg_p2_mhl_pow(data)                                  ((0x00000080&(data))>>7)
+#define MHL_get_reg_p1_mhl_hdmi_datasel(data)                         ((0x00000040&(data))>>6)
+#define MHL_get_reg_p1_mhl_hdmi_cksel(data)                           ((0x00000020&(data))>>5)
+#define MHL_get_reg_p1_mhl_pow(data)                                  ((0x00000010&(data))>>4)
+#define MHL_get_reg_p0_mhl_hdmi_cksel(data)                           ((0x00000008&(data))>>3)
+#define MHL_get_reg_p0_mhl_hdmi_datasel(data)                         ((0x00000004&(data))>>2)
+#define MHL_get_reg_p0_mhl_pow(data)                                  ((0x00000002&(data))>>1)
+#define MHL_get_reg_mhl_hdmisel(data)                                 (0x00000001&(data))
+
+
+#define P0_ACDR1                                                      0xa10
+#define P0_ACDR1_reg_addr                                             "0x98034a10"
+#define P0_ACDR1_reg                                                  0x98034a10
+#define P0_ACDR1_inst_addr                                            "0x0284"
+#define P0_ACDR1_inst                                                 0x0284
+#define set_P0_ACDR1_reg(data)                                        (*((volatile unsigned int*)P0_ACDR1_reg)=data)
+#define get_P0_ACDR1_reg                                              (*((volatile unsigned int*)P0_ACDR1_reg))
+#define P0_ACDR1_reg_p0_acdr_4_shift                                  (24)
+#define P0_ACDR1_reg_p0_acdr_3_shift                                  (16)
+#define P0_ACDR1_reg_p0_acdr_2_shift                                  (8)
+#define P0_ACDR1_reg_p0_acdr_1_shift                                  (0)
+#define P0_ACDR1_reg_p0_acdr_4_mask                                   (0xFF000000)
+#define P0_ACDR1_reg_p0_acdr_3_mask                                   (0x00FF0000)
+#define P0_ACDR1_reg_p0_acdr_2_mask                                   (0x0000FF00)
+#define P0_ACDR1_reg_p0_acdr_1_mask                                   (0x000000FF)
+#define P0_ACDR1_reg_p0_acdr_4(data)                                  (0xFF000000&((data)<<24))
+#define P0_ACDR1_reg_p0_acdr_3(data)                                  (0x00FF0000&((data)<<16))
+#define P0_ACDR1_reg_p0_acdr_2(data)                                  (0x0000FF00&((data)<<8))
+#define P0_ACDR1_reg_p0_acdr_1(data)                                  (0x000000FF&(data))
+#define P0_ACDR1_get_reg_p0_acdr_4(data)                              ((0xFF000000&(data))>>24)
+#define P0_ACDR1_get_reg_p0_acdr_3(data)                              ((0x00FF0000&(data))>>16)
+#define P0_ACDR1_get_reg_p0_acdr_2(data)                              ((0x0000FF00&(data))>>8)
+#define P0_ACDR1_get_reg_p0_acdr_1(data)                              (0x000000FF&(data))
+
+
+#define P0_ACDR2                                                      0xa14
+#define P0_ACDR2_reg_addr                                             "0x98034a14"
+#define P0_ACDR2_reg                                                  0x98034a14
+#define P0_ACDR2_inst_addr                                            "0x0285"
+#define P0_ACDR2_inst                                                 0x0285
+#define set_P0_ACDR2_reg(data)                                        (*((volatile unsigned int*)P0_ACDR2_reg)=data)
+#define get_P0_ACDR2_reg                                              (*((volatile unsigned int*)P0_ACDR2_reg))
+#define P0_ACDR2_reg_p0_acdr_8_shift                                  (24)
+#define P0_ACDR2_reg_p0_acdr_7_shift                                  (16)
+#define P0_ACDR2_reg_p0_acdr_6_shift                                  (8)
+#define P0_ACDR2_reg_p0_acdr_5_shift                                  (0)
+#define P0_ACDR2_reg_p0_acdr_8_mask                                   (0xFF000000)
+#define P0_ACDR2_reg_p0_acdr_7_mask                                   (0x00FF0000)
+#define P0_ACDR2_reg_p0_acdr_6_mask                                   (0x0000FF00)
+#define P0_ACDR2_reg_p0_acdr_5_mask                                   (0x000000FF)
+#define P0_ACDR2_reg_p0_acdr_8(data)                                  (0xFF000000&((data)<<24))
+#define P0_ACDR2_reg_p0_acdr_7(data)                                  (0x00FF0000&((data)<<16))
+#define P0_ACDR2_reg_p0_acdr_6(data)                                  (0x0000FF00&((data)<<8))
+#define P0_ACDR2_reg_p0_acdr_5(data)                                  (0x000000FF&(data))
+#define P0_ACDR2_get_reg_p0_acdr_8(data)                              ((0xFF000000&(data))>>24)
+#define P0_ACDR2_get_reg_p0_acdr_7(data)                              ((0x00FF0000&(data))>>16)
+#define P0_ACDR2_get_reg_p0_acdr_6(data)                              ((0x0000FF00&(data))>>8)
+#define P0_ACDR2_get_reg_p0_acdr_5(data)                              (0x000000FF&(data))
+
+
+#define P0_B1                                                         0xa18
+#define P0_B1_reg_addr                                                "0x98034a18"
+#define P0_B1_reg                                                     0x98034a18
+#define P0_B1_inst_addr                                               "0x0286"
+#define P0_B1_inst                                                    0x0286
+#define set_P0_B1_reg(data)                                           (*((volatile unsigned int*)P0_B1_reg)=data)
+#define get_P0_B1_reg                                                 (*((volatile unsigned int*)P0_B1_reg))
+#define P0_B1_reg_p0_b_4_shift                                        (24)
+#define P0_B1_reg_p0_b_3_shift                                        (16)
+#define P0_B1_reg_p0_b_2_shift                                        (8)
+#define P0_B1_reg_p0_b_1_shift                                        (0)
+#define P0_B1_reg_p0_b_4_mask                                         (0xFF000000)
+#define P0_B1_reg_p0_b_3_mask                                         (0x00FF0000)
+#define P0_B1_reg_p0_b_2_mask                                         (0x0000FF00)
+#define P0_B1_reg_p0_b_1_mask                                         (0x000000FF)
+#define P0_B1_reg_p0_b_4(data)                                        (0xFF000000&((data)<<24))
+#define P0_B1_reg_p0_b_3(data)                                        (0x00FF0000&((data)<<16))
+#define P0_B1_reg_p0_b_2(data)                                        (0x0000FF00&((data)<<8))
+#define P0_B1_reg_p0_b_1(data)                                        (0x000000FF&(data))
+#define P0_B1_get_reg_p0_b_4(data)                                    ((0xFF000000&(data))>>24)
+#define P0_B1_get_reg_p0_b_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_B1_get_reg_p0_b_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_B1_get_reg_p0_b_1(data)                                    (0x000000FF&(data))
+#define P0_b_1_inputoff												(_BIT0)
+#define P0_b_1_FORE_KOFF_RANGE										(_BIT22|_BIT21)
+#define P0_b_4_FORE_KOFF_AUTOK										(_BIT28)
+#define P0_b_CLK_PIX2_RATE_SEL										(_BIT26)
+#define P0_b_DEMUX_BBPD_RSTB										(_BIT25)
+#define P0_b_4_FORE_POW_FORE_KOFF									(_BIT24)
+#define P0_b_3_FORE_EN_FORE_KOFF									(_BIT23)
+
+
+#define P0_B2                                                         0xa1c
+#define P0_B2_reg_addr                                                "0x98034a1c"
+#define P0_B2_reg                                                     0x98034a1c
+#define P0_B2_inst_addr                                               "0x0287"
+#define P0_B2_inst                                                    0x0287
+#define set_P0_B2_reg(data)                                           (*((volatile unsigned int*)P0_B2_reg)=data)
+#define get_P0_B2_reg                                                 (*((volatile unsigned int*)P0_B2_reg))
+#define P0_B2_reg_p0_b_8_shift                                        (24)
+#define P0_B2_reg_p0_b_7_shift                                        (16)
+#define P0_B2_reg_p0_b_6_shift                                        (8)
+#define P0_B2_reg_p0_b_5_shift                                        (0)
+#define P0_B2_reg_p0_b_8_mask                                         (0xFF000000)
+#define P0_B2_reg_p0_b_7_mask                                         (0x00FF0000)
+#define P0_B2_reg_p0_b_6_mask                                         (0x0000FF00)
+#define P0_B2_reg_p0_b_5_mask                                         (0x000000FF)
+#define P0_B2_reg_p0_b_8(data)                                        (0xFF000000&((data)<<24))
+#define P0_B2_reg_p0_b_7(data)                                        (0x00FF0000&((data)<<16))
+#define P0_B2_reg_p0_b_6(data)                                        (0x0000FF00&((data)<<8))
+#define P0_B2_reg_p0_b_5(data)                                        (0x000000FF&(data))
+#define P0_B2_get_reg_p0_b_8(data)                                    ((0xFF000000&(data))>>24)
+#define P0_B2_get_reg_p0_b_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_B2_get_reg_p0_b_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_B2_get_reg_p0_b_5(data)                                    (0x000000FF&(data))
+#define P0_B2_reg_p0_b_8_PR_RATE_SEL_shift						(26)
+#define P0_B2_reg_p0_b_8_DEMUX_shift							(29)
+#define P0_B2_reg_p0_b_7_TAP0_ISEL_shift						(21)
+#define P0_b_8_DEMUX											(_BIT29|_BIT30|_BIT31)
+#define P0_b_8_PR_RATE_SEL										(_BIT26|_BIT27|_BIT28)
+#define P0_b_8_POW_PR											(_BIT25)
+#define P0_b_7_TAP0_ISEL										(_BIT21|_BIT22|_BIT23)
+#define P0_b_7_TAP0_ISEL_400uA									(_BIT22|_BIT23)
+#define P0_b_7_LEQ_ISEL											(_BIT18|_BIT19|_BIT20)
+#define P0_b_7_LEQ_ISEL_400uA									(_BIT19|_BIT20)
+#define P0_b_7_LEQ_ISEL_200uA									(_BIT20)
+#define P0_b_7_PI_ISEL											(_BIT16|_BIT17)
+#define P0_b_6_LEQ_BIT_RATE										(_BIT14|_BIT15)
+#define P0_b_6_LEQ_BIT_RATE_HBR									(_BIT15)
+#define P0_b_6_LEQ_BIT_RATE_MBR									(_BIT14)
+#define P0_b_6_TAP0_HBR											(_BIT13)
+#define P0_b_6_LEQ_PASSIVE_CORNER								(_BIT12|_BIT11)
+#define P0_b_5_LEQ_CURRENT_ADJ									(_BIT3|_BIT4)
+#define P0_b_5_LEQ_CURRENT_ADJ_1X								(_BIT3)
+#define P0_b_5_LEQ_CURRENT_ADJ_1p25X							(_BIT4)
+#define P0_b_5_EQ_POW											(_BIT0)
+
+
+#define P0_B3                                                         0xa20
+#define P0_B3_reg_addr                                                "0x98034a20"
+#define P0_B3_reg                                                     0x98034a20
+#define P0_B3_inst_addr                                               "0x0288"
+#define P0_B3_inst                                                    0x0288
+#define set_P0_B3_reg(data)                                           (*((volatile unsigned int*)P0_B3_reg)=data)
+#define get_P0_B3_reg                                                 (*((volatile unsigned int*)P0_B3_reg))
+#define P0_B3_reg_p0_b_12_shift                                       (24)
+#define P0_B3_reg_p0_b_11_shift                                       (16)
+#define P0_B3_reg_p0_b_10_shift                                       (8)
+#define P0_B3_reg_p0_b_9_shift                                        (0)
+#define P0_B3_reg_p0_b_12_mask                                        (0xFF000000)
+#define P0_B3_reg_p0_b_11_mask                                        (0x00FF0000)
+#define P0_B3_reg_p0_b_10_mask                                        (0x0000FF00)
+#define P0_B3_reg_p0_b_9_mask                                         (0x000000FF)
+#define P0_B3_reg_p0_b_12(data)                                       (0xFF000000&((data)<<24))
+#define P0_B3_reg_p0_b_11(data)                                       (0x00FF0000&((data)<<16))
+#define P0_B3_reg_p0_b_10(data)                                       (0x0000FF00&((data)<<8))
+#define P0_B3_reg_p0_b_9(data)                                        (0x000000FF&(data))
+#define P0_B3_get_reg_p0_b_12(data)                                   ((0xFF000000&(data))>>24)
+#define P0_B3_get_reg_p0_b_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P0_B3_get_reg_p0_b_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P0_B3_get_reg_p0_b_9(data)                                    (0x000000FF&(data))
+#define P0_B_DFE_TAPEN4321											(_BIT6|_BIT5|_BIT4|_BIT3)
+#define P0_b_12_PR													(_BIT24|_BIT25)
+#define P0_b_9_DFE_ADAPTION_POW_EN									(_BIT7)
+#define P0_b_9_DFE_TAP_EN											(_BIT3|_BIT4|_BIT5|_BIT6)
+#define P0_b_9_DFE_TAP1_EN											(_BIT3)
+#define DFE_HDMI_RX_PHY_P0_b_tap_en(data)							(0x00000078&((data)<<3))
+#define P0_b_11_ACDR_RATE_SEL_HALF_RATE								(_BIT16)
+#define P0_b_10_DFE_SUMAMP_LP_MANUALOFF								(_BIT15)
+#define P0_b_10_DFE_SUMAMP_ISEL_mask								(_BIT11|_BIT12|_BIT13)
+#define P0_b_10_DFE_SUMAMP_ISEL_400uA								(_BIT13)
+#define P0_b_10_DFE_PREAMP_ISEL_mask								(_BIT8|_BIT9|_BIT10)
+#define P0_b_10_DFE_PREAMP_ISEL_400uA								(_BIT10)
+
+
+#define P0_B4                                                         0xa24
+#define P0_B4_reg_addr                                                "0x98034a24"
+#define P0_B4_reg                                                     0x98034a24
+#define P0_B4_inst_addr                                               "0x0289"
+#define P0_B4_inst                                                    0x0289
+#define set_P0_B4_reg(data)                                           (*((volatile unsigned int*)P0_B4_reg)=data)
+#define get_P0_B4_reg                                                 (*((volatile unsigned int*)P0_B4_reg))
+#define P0_B4_reg_p0_b_koff_sel_shift                                 (10)
+#define P0_B4_reg_p0_b_koff_bound_shift                               (9)
+#define P0_B4_reg_p0_b_koffok_shift                                   (8)
+#define P0_B4_reg_p0_b_13_shift                                       (0)
+#define P0_B4_reg_p0_b_koff_sel_mask                                  (0x00007C00)
+#define P0_B4_reg_p0_b_koff_bound_mask                                (0x00000200)
+#define P0_B4_reg_p0_b_koffok_mask                                    (0x00000100)
+#define P0_B4_reg_p0_b_13_mask                                        (0x000000FF)
+#define P0_B4_reg_p0_b_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P0_B4_reg_p0_b_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P0_B4_reg_p0_b_koffok(data)                                   (0x00000100&((data)<<8))
+#define P0_B4_reg_p0_b_13(data)                                       (0x000000FF&(data))
+#define P0_B4_get_reg_p0_b_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P0_B4_get_reg_p0_b_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P0_B4_get_reg_p0_b_koffok(data)                               ((0x00000100&(data))>>8)
+#define P0_B4_get_reg_p0_b_13(data)                                   (0x000000FF&(data))
+
+
+#define P0_CK1                                                        0xa28
+#define P0_CK1_reg_addr                                               "0x98034a28"
+#define P0_CK1_reg                                                    0x98034a28
+#define P0_CK1_inst_addr                                              "0x028A"
+#define P0_CK1_inst                                                   0x028A
+#define set_P0_CK1_reg(data)                                          (*((volatile unsigned int*)P0_CK1_reg)=data)
+#define get_P0_CK1_reg                                                (*((volatile unsigned int*)P0_CK1_reg))
+#define P0_CK1_reg_p0_ck_4_shift                                      (24)
+#define P0_CK1_reg_p0_ck_3_CMU_N_code_shift						 	(18)
+#define P0_CK1_reg_p0_ck_3_shift                                      (16)
+#define P0_CK1_reg_p0_ck_2_shift                                      (8)
+#define P0_CK1_reg_p0_ck_1_shift                                      (0)
+#define P0_CK1_reg_p0_ck_4_mask                                       (0xFF000000)
+#define P0_CK1_reg_p0_ck_3_mask                                       (0x00FF0000)
+#define P0_CK1_reg_p0_ck_2_mask                                       (0x0000FF00)
+#define P0_CK1_reg_p0_ck_1_mask                                       (0x000000FF)
+#define P0_CK1_reg_p0_ck_4(data)                                      (0xFF000000&((data)<<24))
+#define P0_CK1_reg_p0_ck_3(data)                                      (0x00FF0000&((data)<<16))
+#define P0_CK1_reg_p0_ck_2(data)                                      (0x0000FF00&((data)<<8))
+#define P0_CK1_reg_p0_ck_1(data)                                      (0x000000FF&(data))
+#define P0_CK1_get_reg_p0_ck_4(data)                                  ((0xFF000000&(data))>>24)
+#define P0_CK1_get_reg_p0_ck_3(data)                                  ((0x00FF0000&(data))>>16)
+#define P0_CK1_get_reg_p0_ck_2(data)                                  ((0x0000FF00&(data))>>8)
+#define P0_CK1_get_reg_p0_ck_1(data)                                  (0x000000FF&(data))
+#define p0_ck_3_CMU_PREDIVN												(_BIT20|_BIT21|_BIT22|_BIT23)
+#define p0_ck_3_CMU_N_code												(_BIT18|_BIT19)
+#define p0_ck_2_CMU_CKIN_SEL											(_BIT12|_BIT13|_BIT14|_BIT15)
+#define p0_CMU_CKOUT_SEL												(_BIT11)
+#define p0_ck_2_CK_MD_REF_SEL											(_BIT9)
+#define p0_ck_1_port_bias												(_BIT2)
+#define p0_ck_1_CKAFE_POW												(_BIT1)
+
+
+#define P0_CK2                                                        0xa2c
+#define P0_CK2_reg_addr                                               "0x98034a2c"
+#define P0_CK2_reg                                                    0x98034a2c
+#define P0_CK2_inst_addr                                              "0x028B"
+#define P0_CK2_inst                                                   0x028B
+#define set_P0_CK2_reg(data)                                          (*((volatile unsigned int*)P0_CK2_reg)=data)
+#define get_P0_CK2_reg                                                (*((volatile unsigned int*)P0_CK2_reg))
+#define P0_CK2_reg_p0_ck_8_shift                                      (24)
+#define P0_CK2_reg_p0_ck_7_shift                                      (16)
+#define P0_CK2_reg_p0_ck_6_shift                                      (8)
+#define P0_CK2_reg_p0_ck_5_shift                                      (0)
+#define P0_CK2_reg_p0_ck_8_mask                                       (0xFF000000)
+#define P0_CK2_reg_p0_ck_7_mask                                       (0x00FF0000)
+#define P0_CK2_reg_p0_ck_6_mask                                       (0x0000FF00)
+#define P0_CK2_reg_p0_ck_5_mask                                       (0x000000FF)
+#define P0_CK2_reg_p0_ck_8(data)                                      (0xFF000000&((data)<<24))
+#define P0_CK2_reg_p0_ck_7(data)                                      (0x00FF0000&((data)<<16))
+#define P0_CK2_reg_p0_ck_6(data)                                      (0x0000FF00&((data)<<8))
+#define P0_CK2_reg_p0_ck_5(data)                                      (0x000000FF&(data))
+#define P0_CK2_get_reg_p0_ck_8(data)                                  ((0xFF000000&(data))>>24)
+#define P0_CK2_get_reg_p0_ck_7(data)                                  ((0x00FF0000&(data))>>16)
+#define P0_CK2_get_reg_p0_ck_6(data)                                  ((0x0000FF00&(data))>>8)
+#define P0_CK2_get_reg_p0_ck_5(data)                                  (0x000000FF&(data))
+#define P0_ck_8_LDO_EN												(_BIT25)
+#define P0_ck_8_VSEL_LDO_A_mask										(_BIT29|_BIT30|_BIT31)
+#define P0_ck_8_VSEL_LDO_D_mask										(_BIT26|_BIT27|_BIT28)
+#define P0_ck_8_LDO_EN_mask											(_BIT25)
+#define P0_ck_8_CMU_BPPSR_mask										(_BIT24)
+#define P0_ck_7_CMU_BYPASS_PI_mask									(_BIT19)
+#define P0_ck_7_CMU_PI_I_SEL_mask									(_BIT16|_BIT17|_BIT18)
+#define P0_ck_6_CMU_BIG_KVCO_mask									(_BIT13)
+#define P0_ck_6_CMU_EN_CAP_mask										(_BIT12)
+#define P0_ck_6_CMU_SEL_CS_mask										(_BIT8|_BIT9|_BIT10)
+#define P0_ck_5_CMU_SEL_PUMP_I_mask									(_BIT4|_BIT5|_BIT6|_BIT7)
+#define P0_ck_5_CMU_SEL_R1_mask										(_BIT0|_BIT1|_BIT2)
+#define DFE_HDMI_RX_PHY_P0_VSEL_LDO_D(data)							(0x1C000000&((data)<<26))
+#define DFE_HDMI_RX_PHY_P0_CMU_BPPSR(data)							(0x01000000&((data)<<24))
+#define DFE_HDMI_RX_PHY_P0_CMU_SEL_CS(data)							(0x00000700&((data)<<8))
+#define DFE_HDMI_RX_PHY_P0_CMU_SEL_PUMP_I(data)						(0x000000F0&((data)<<4))
+#define DFE_HDMI_RX_PHY_P0_CMU_SEL_R1(data)							(0x00000007&((data)<<0))
+#define DFE_HDMI_RX_PHY_P0_VSEL_LDO_A(data)							(0xE0000000&((data)<<29))
+#define DFE_HDMI_RX_PHY_P0_VSEL_LDO_D(data)							(0x1C000000&((data)<<26))
+#define DFE_HDMI_RX_PHY_P0_CMU_BPPSR(data)							(0x01000000&((data)<<24))
+#define DFE_HDMI_RX_PHY_P0_CMU_SEL_CS(data)							(0x00000700&((data)<<8))
+#define DFE_HDMI_RX_PHY_P0_CMU_SEL_PUMP_I(data)						(0x000000F0&((data)<<4))
+#define DFE_HDMI_RX_PHY_P0_CMU_SEL_R1(data)							(0x00000007&((data)<<0))
+
+
+#define P0_CK3                                                        0xa30
+#define P0_CK3_reg_addr                                               "0x98034a30"
+#define P0_CK3_reg                                                    0x98034a30
+#define P0_CK3_inst_addr                                              "0x028C"
+#define P0_CK3_inst                                                   0x028C
+#define set_P0_CK3_reg(data)                                          (*((volatile unsigned int*)P0_CK3_reg)=data)
+#define get_P0_CK3_reg                                                (*((volatile unsigned int*)P0_CK3_reg))
+#define P0_CK3_reg_p0_ck_12_shift                                     (24)
+#define P0_CK3_reg_p0_ck_11_shift                                     (16)
+#define P0_CK3_reg_p0_ck_10_shift                                     (8)
+#define P0_CK3_reg_p0_ck_9_shift                                      (0)
+#define P0_CK3_reg_p0_ck_12_mask                                      (0xFF000000)
+#define P0_CK3_reg_p0_ck_11_mask                                      (0x00FF0000)
+#define P0_CK3_reg_p0_ck_10_mask                                      (0x0000FF00)
+#define P0_CK3_reg_p0_ck_9_mask                                       (0x000000FF)
+#define P0_CK3_reg_p0_ck_12(data)                                     (0xFF000000&((data)<<24))
+#define P0_CK3_reg_p0_ck_11(data)                                     (0x00FF0000&((data)<<16))
+#define P0_CK3_reg_p0_ck_10(data)                                     (0x0000FF00&((data)<<8))
+#define P0_CK3_reg_p0_ck_9(data)                                      (0x000000FF&(data))
+#define P0_CK3_get_reg_p0_ck_12(data)                                 ((0xFF000000&(data))>>24)
+#define P0_CK3_get_reg_p0_ck_11(data)                                 ((0x00FF0000&(data))>>16)
+#define P0_CK3_get_reg_p0_ck_10(data)                                 ((0x0000FF00&(data))>>8)
+#define P0_CK3_get_reg_p0_ck_9(data)                                  (0x000000FF&(data))
+#define P0_ck_9_CMU_PFD_RSTB										(_BIT5)
+#define P0_ck_9_CMU_WDRST											(_BIT2)
+
+
+#define P0_CK4                                                        0xa34
+#define P0_CK4_reg_addr                                               "0x98034a34"
+#define P0_CK4_reg                                                    0x98034a34
+#define P0_CK4_inst_addr                                              "0x028D"
+#define P0_CK4_inst                                                   0x028D
+#define set_P0_CK4_reg(data)                                          (*((volatile unsigned int*)P0_CK4_reg)=data)
+#define get_P0_CK4_reg                                                (*((volatile unsigned int*)P0_CK4_reg))
+#define P0_CK4_reg_p0_ck_13_shift                                     (0)
+#define P0_CK4_reg_p0_ck_13_mask                                      (0x000000FF)
+#define P0_CK4_reg_p0_ck_13(data)                                     (0x000000FF&(data))
+#define P0_CK4_get_reg_p0_ck_13(data)                                 (0x000000FF&(data))
+
+
+#define ENABLE                                                        0xa38
+#define ENABLE_reg_addr                                               "0x98034a38"
+#define ENABLE_reg                                                    0x98034a38
+#define ENABLE_inst_addr                                              "0x028E"
+#define ENABLE_inst                                                   0x028E
+#define set_ENABLE_reg(data)                                          (*((volatile unsigned int*)ENABLE_reg)=data)
+#define get_ENABLE_reg                                                (*((volatile unsigned int*)ENABLE_reg))
+#define ENABLE_reg_p2_en_rx_shift                                     (18)
+#define ENABLE_reg_p2_en_cmu_shift                                    (17)
+#define ENABLE_reg_p2_en_cdr_shift                                    (14)
+#define ENABLE_reg_p1_en_rx_shift                                     (11)
+#define ENABLE_reg_p1_en_cmu_shift                                    (10)
+#define ENABLE_reg_p1_en_cdr_shift                                    (7)
+#define ENABLE_reg_p0_en_rx_shift                                     (4)
+#define ENABLE_reg_p0_en_cmu_shift                                    (3)
+#define ENABLE_reg_p0_en_cdr_shift                                    (0)
+#define ENABLE_reg_p2_en_rx_mask                                      (0x001C0000)
+#define ENABLE_reg_p2_en_cmu_mask                                     (0x00020000)
+#define ENABLE_reg_p2_en_cdr_mask                                     (0x0001C000)
+#define ENABLE_reg_p1_en_rx_mask                                      (0x00003800)
+#define ENABLE_reg_p1_en_cmu_mask                                     (0x00000400)
+#define ENABLE_reg_p1_en_cdr_mask                                     (0x00000380)
+#define ENABLE_reg_p0_en_rx_mask                                      (0x00000070)
+#define ENABLE_reg_p0_en_cmu_mask                                     (0x00000008)
+#define ENABLE_reg_p0_en_cdr_mask                                     (0x00000007)
+#define ENABLE_reg_p2_en_rx(data)                                     (0x001C0000&((data)<<18))
+#define ENABLE_reg_p2_en_cmu(data)                                    (0x00020000&((data)<<17))
+#define ENABLE_reg_p2_en_cdr(data)                                    (0x0001C000&((data)<<14))
+#define ENABLE_reg_p1_en_rx(data)                                     (0x00003800&((data)<<11))
+#define ENABLE_reg_p1_en_cmu(data)                                    (0x00000400&((data)<<10))
+#define ENABLE_reg_p1_en_cdr(data)                                    (0x00000380&((data)<<7))
+#define ENABLE_reg_p0_en_rx(data)                                     (0x00000070&((data)<<4))
+#define ENABLE_reg_p0_en_cmu(data)                                    (0x00000008&((data)<<3))
+#define ENABLE_reg_p0_en_cdr(data)                                    (0x00000007&(data))
+#define ENABLE_get_reg_p2_en_rx(data)                                 ((0x001C0000&(data))>>18)
+#define ENABLE_get_reg_p2_en_cmu(data)                                ((0x00020000&(data))>>17)
+#define ENABLE_get_reg_p2_en_cdr(data)                                ((0x0001C000&(data))>>14)
+#define ENABLE_get_reg_p1_en_rx(data)                                 ((0x00003800&(data))>>11)
+#define ENABLE_get_reg_p1_en_cmu(data)                                ((0x00000400&(data))>>10)
+#define ENABLE_get_reg_p1_en_cdr(data)                                ((0x00000380&(data))>>7)
+#define ENABLE_get_reg_p0_en_rx(data)                                 ((0x00000070&(data))>>4)
+#define ENABLE_get_reg_p0_en_cmu(data)                                ((0x00000008&(data))>>3)
+#define ENABLE_get_reg_p0_en_cdr(data)                                (0x00000007&(data))
+
+
+#define P0_G1                                                         0xa3c
+#define P0_G1_reg_addr                                                "0x98034a3c"
+#define P0_G1_reg                                                     0x98034a3c
+#define P0_G1_inst_addr                                               "0x028F"
+#define P0_G1_inst                                                    0x028F
+#define set_P0_G1_reg(data)                                           (*((volatile unsigned int*)P0_G1_reg)=data)
+#define get_P0_G1_reg                                                 (*((volatile unsigned int*)P0_G1_reg))
+#define P0_G1_reg_p0_g_4_shift                                        (24)
+#define P0_G1_reg_p0_g_3_shift                                        (16)
+#define P0_G1_reg_p0_g_2_shift                                        (8)
+#define P0_G1_reg_p0_g_1_shift                                        (0)
+#define P0_G1_reg_p0_g_4_mask                                         (0xFF000000)
+#define P0_G1_reg_p0_g_3_mask                                         (0x00FF0000)
+#define P0_G1_reg_p0_g_2_mask                                         (0x0000FF00)
+#define P0_G1_reg_p0_g_1_mask                                         (0x000000FF)
+#define P0_G1_reg_p0_g_4(data)                                        (0xFF000000&((data)<<24))
+#define P0_G1_reg_p0_g_3(data)                                        (0x00FF0000&((data)<<16))
+#define P0_G1_reg_p0_g_2(data)                                        (0x0000FF00&((data)<<8))
+#define P0_G1_reg_p0_g_1(data)                                        (0x000000FF&(data))
+#define P0_G1_get_reg_p0_g_4(data)                                    ((0xFF000000&(data))>>24)
+#define P0_G1_get_reg_p0_g_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_G1_get_reg_p0_g_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_G1_get_reg_p0_g_1(data)                                    (0x000000FF&(data))
+#define P0_g_1_inputoff												(_BIT0)
+#define P0_g_1_FORE_KOFF_RANGE										(_BIT22|_BIT21)
+#define P0_g_4_FORE_KOFF_AUTOK										(_BIT28)
+#define P0_g_CLK_PIX2_RATE_SEL										(_BIT26)
+#define P0_g_DEMUX_BBPD_RSTB										(_BIT25)
+#define P0_g_4_FORE_POW_FORE_KOFF									(_BIT24)
+#define P0_g_3_FORE_EN_FORE_KOFF									(_BIT23)
+
+
+#define P0_G2                                                         0xa40
+#define P0_G2_reg_addr                                                "0x98034a40"
+#define P0_G2_reg                                                     0x98034a40
+#define P0_G2_inst_addr                                               "0x0290"
+#define P0_G2_inst                                                    0x0290
+#define set_P0_G2_reg(data)                                           (*((volatile unsigned int*)P0_G2_reg)=data)
+#define get_P0_G2_reg                                                 (*((volatile unsigned int*)P0_G2_reg))
+#define P0_G2_reg_p0_g_8_shift                                        (24)
+#define P0_G2_reg_p0_g_7_shift                                        (16)
+#define P0_G2_reg_p0_g_6_shift                                        (8)
+#define P0_G2_reg_p0_g_5_shift                                        (0)
+#define P0_G2_reg_p0_g_8_mask                                         (0xFF000000)
+#define P0_G2_reg_p0_g_7_mask                                         (0x00FF0000)
+#define P0_G2_reg_p0_g_6_mask                                         (0x0000FF00)
+#define P0_G2_reg_p0_g_5_mask                                         (0x000000FF)
+#define P0_G2_reg_p0_g_8(data)                                        (0xFF000000&((data)<<24))
+#define P0_G2_reg_p0_g_7(data)                                        (0x00FF0000&((data)<<16))
+#define P0_G2_reg_p0_g_6(data)                                        (0x0000FF00&((data)<<8))
+#define P0_G2_reg_p0_g_5(data)                                        (0x000000FF&(data))
+#define P0_G2_get_reg_p0_g_8(data)                                    ((0xFF000000&(data))>>24)
+#define P0_G2_get_reg_p0_g_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_G2_get_reg_p0_g_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_G2_get_reg_p0_g_5(data)                                    (0x000000FF&(data))
+#define P0_G2_reg_p0_g_8_PR_RATE_SEL_shift							(26)
+#define P0_G2_reg_p0_g_8_DEMUX_shift								(29)
+#define P0_G2_reg_p0_g_7_TAP0_ISEL_shift							(21)
+#define P0_g_8_DEMUX												(_BIT29|_BIT30|_BIT31)
+#define P0_g_8_PR_RATE_SEL											(_BIT26|_BIT27|_BIT28)
+#define P0_g_8_POW_PR												(_BIT25)
+#define P0_g_7_TAP0_ISEL											(_BIT21|_BIT22|_BIT23)
+#define P0_g_7_TAP0_ISEL_400uA										(_BIT22|_BIT23)
+#define P0_g_7_LEQ_ISEL												(_BIT18|_BIT19|_BIT20)
+#define P0_g_7_LEQ_ISEL_400uA										(_BIT19|_BIT20)
+#define P0_g_7_LEQ_ISEL_200uA										(_BIT20)
+#define P0_g_7_PI_ISEL												(_BIT16|_BIT17)
+#define P0_g_6_LEQ_BIT_RATE											(_BIT14|_BIT15)
+#define P0_g_6_LEQ_BIT_RATE_HBR										(_BIT15)
+#define P0_g_6_LEQ_BIT_RATE_MBR										(_BIT14)
+#define P0_g_6_TAP0_HBR												(_BIT13)
+#define P0_g_6_LEQ_PASSIVE_CORNER									(_BIT12|_BIT11)
+#define P0_g_5_LEQ_CURRENT_ADJ										(_BIT3|_BIT4)
+#define P0_g_5_LEQ_CURRENT_ADJ_1X									(_BIT3)
+#define P0_g_5_LEQ_CURRENT_ADJ_1p25X								(_BIT4)
+#define P0_g_5_EQ_POW												(_BIT0)
+
+
+#define P0_G3                                                         0xa44
+#define P0_G3_reg_addr                                                "0x98034a44"
+#define P0_G3_reg                                                     0x98034a44
+#define P0_G3_inst_addr                                               "0x0291"
+#define P0_G3_inst                                                    0x0291
+#define set_P0_G3_reg(data)                                           (*((volatile unsigned int*)P0_G3_reg)=data)
+#define get_P0_G3_reg                                                 (*((volatile unsigned int*)P0_G3_reg))
+#define P0_G3_reg_p0_g_12_shift                                       (24)
+#define P0_G3_reg_p0_g_11_shift                                       (16)
+#define P0_G3_reg_p0_g_10_shift                                       (8)
+#define P0_G3_reg_p0_g_9_shift                                        (0)
+#define P0_G3_reg_p0_g_12_mask                                        (0xFF000000)
+#define P0_G3_reg_p0_g_11_mask                                        (0x00FF0000)
+#define P0_G3_reg_p0_g_10_mask                                        (0x0000FF00)
+#define P0_G3_reg_p0_g_9_mask                                         (0x000000FF)
+#define P0_G3_reg_p0_g_12(data)                                       (0xFF000000&((data)<<24))
+#define P0_G3_reg_p0_g_11(data)                                       (0x00FF0000&((data)<<16))
+#define P0_G3_reg_p0_g_10(data)                                       (0x0000FF00&((data)<<8))
+#define P0_G3_reg_p0_g_9(data)                                        (0x000000FF&(data))
+#define P0_G3_get_reg_p0_g_12(data)                                   ((0xFF000000&(data))>>24)
+#define P0_G3_get_reg_p0_g_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P0_G3_get_reg_p0_g_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P0_G3_get_reg_p0_g_9(data)                                    (0x000000FF&(data))
+#define P0_G_DFE_TAPEN4321											(_BIT6|_BIT5|_BIT4|_BIT3)
+#define P0_g_12_PR													(_BIT24|_BIT25)
+#define P0_g_9_DFE_ADAPTION_POW_EN									(_BIT7)
+#define P0_g_9_DFE_TAP_EN											(_BIT3|_BIT4|_BIT5|_BIT6)
+#define P0_g_9_DFE_TAP1_EN											(_BIT3)
+#define DFE_HDMI_RX_PHY_P0_g_tap_en(data)							(0x00000078&((data)<<3))
+#define P0_g_11_ACDR_RATE_SEL_HALF_RATE 							(_BIT16)
+#define P0_g_10_DFE_SUMAMP_LP_MANUALOFF								(_BIT15)
+#define P0_g_10_DFE_SUMAMP_ISEL_mask								(_BIT11|_BIT12|_BIT13)
+#define P0_g_10_DFE_SUMAMP_ISEL_400uA								(_BIT13)
+#define P0_g_10_DFE_PREAMP_ISEL_mask								(_BIT8|_BIT9|_BIT10)
+#define P0_g_10_DFE_PREAMP_ISEL_400uA								(_BIT10)
+
+
+#define P0_G4                                                         0xa48
+#define P0_G4_reg_addr                                                "0x98034a48"
+#define P0_G4_reg                                                     0x98034a48
+#define P0_G4_inst_addr                                               "0x0292"
+#define P0_G4_inst                                                    0x0292
+#define set_P0_G4_reg(data)                                           (*((volatile unsigned int*)P0_G4_reg)=data)
+#define get_P0_G4_reg                                                 (*((volatile unsigned int*)P0_G4_reg))
+#define P0_G4_reg_p0_g_koff_sel_shift                                 (10)
+#define P0_G4_reg_p0_g_koff_bound_shift                               (9)
+#define P0_G4_reg_p0_g_koffok_shift                                   (8)
+#define P0_G4_reg_p0_g_13_shift                                       (0)
+#define P0_G4_reg_p0_g_koff_sel_mask                                  (0x00007C00)
+#define P0_G4_reg_p0_g_koff_bound_mask                                (0x00000200)
+#define P0_G4_reg_p0_g_koffok_mask                                    (0x00000100)
+#define P0_G4_reg_p0_g_13_mask                                        (0x000000FF)
+#define P0_G4_reg_p0_g_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P0_G4_reg_p0_g_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P0_G4_reg_p0_g_koffok(data)                                   (0x00000100&((data)<<8))
+#define P0_G4_reg_p0_g_13(data)                                       (0x000000FF&(data))
+#define P0_G4_get_reg_p0_g_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P0_G4_get_reg_p0_g_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P0_G4_get_reg_p0_g_koffok(data)                               ((0x00000100&(data))>>8)
+#define P0_G4_get_reg_p0_g_13(data)                                   (0x000000FF&(data))
+
+
+#define P0_R1                                                         0xa4c
+#define P0_R1_reg_addr                                                "0x98034a4c"
+#define P0_R1_reg                                                     0x98034a4c
+#define P0_R1_inst_addr                                               "0x0293"
+#define P0_R1_inst                                                    0x0293
+#define set_P0_R1_reg(data)                                           (*((volatile unsigned int*)P0_R1_reg)=data)
+#define get_P0_R1_reg                                                 (*((volatile unsigned int*)P0_R1_reg))
+#define P0_R1_reg_p0_r_4_shift                                        (24)
+#define P0_R1_reg_p0_r_3_shift                                        (16)
+#define P0_R1_reg_p0_r_2_shift                                        (8)
+#define P0_R1_reg_p0_r_1_shift                                        (0)
+#define P0_R1_reg_p0_r_4_mask                                         (0xFF000000)
+#define P0_R1_reg_p0_r_3_mask                                         (0x00FF0000)
+#define P0_R1_reg_p0_r_2_mask                                         (0x0000FF00)
+#define P0_R1_reg_p0_r_1_mask                                         (0x000000FF)
+#define P0_R1_reg_p0_r_4(data)                                        (0xFF000000&((data)<<24))
+#define P0_R1_reg_p0_r_3(data)                                        (0x00FF0000&((data)<<16))
+#define P0_R1_reg_p0_r_2(data)                                        (0x0000FF00&((data)<<8))
+#define P0_R1_reg_p0_r_1(data)                                        (0x000000FF&(data))
+#define P0_R1_get_reg_p0_r_4(data)                                    ((0xFF000000&(data))>>24)
+#define P0_R1_get_reg_p0_r_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_R1_get_reg_p0_r_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_R1_get_reg_p0_r_1(data)                                    (0x000000FF&(data))
+#define  P0_r_4_FORE_KOFF_AUTOK										(_BIT28)
+#define  P0_r_CLK_PIX2_RATE_SEL										(_BIT26)
+#define  P0_r_1_FORE_KOFF_RANGE										(_BIT22|_BIT21)
+#define  P0_r_1_inputoff											(_BIT0)
+#define  P0_r_DEMUX_BBPD_RSTB										(_BIT25)
+#define  P0_r_4_FORE_POW_FORE_KOFF									(_BIT24)
+#define  P0_r_3_FORE_EN_FORE_KOFF									(_BIT23)
+
+
+#define P0_R2                                                         0xa50
+#define P0_R2_reg_addr                                                "0x98034a50"
+#define P0_R2_reg                                                     0x98034a50
+#define P0_R2_inst_addr                                               "0x0294"
+#define P0_R2_inst                                                    0x0294
+#define set_P0_R2_reg(data)                                           (*((volatile unsigned int*)P0_R2_reg)=data)
+#define get_P0_R2_reg                                                 (*((volatile unsigned int*)P0_R2_reg))
+#define P0_R2_reg_p0_r_8_shift                                        (24)
+#define P0_R2_reg_p0_r_7_shift                                        (16)
+#define P0_R2_reg_p0_r_6_shift                                        (8)
+#define P0_R2_reg_p0_r_5_shift                                        (0)
+#define P0_R2_reg_p0_r_8_mask                                         (0xFF000000)
+#define P0_R2_reg_p0_r_7_mask                                         (0x00FF0000)
+#define P0_R2_reg_p0_r_6_mask                                         (0x0000FF00)
+#define P0_R2_reg_p0_r_5_mask                                         (0x000000FF)
+#define P0_R2_reg_p0_r_8(data)                                        (0xFF000000&((data)<<24))
+#define P0_R2_reg_p0_r_7(data)                                        (0x00FF0000&((data)<<16))
+#define P0_R2_reg_p0_r_6(data)                                        (0x0000FF00&((data)<<8))
+#define P0_R2_reg_p0_r_5(data)                                        (0x000000FF&(data))
+#define P0_R2_get_reg_p0_r_8(data)                                    ((0xFF000000&(data))>>24)
+#define P0_R2_get_reg_p0_r_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_R2_get_reg_p0_r_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_R2_get_reg_p0_r_5(data)                                    (0x000000FF&(data))
+#define P0_R2_reg_p0_r_8_PR_RATE_SEL_shift							(26)
+#define P0_R2_reg_p0_r_8_DEMUX_shift								(29)
+#define P0_R2_reg_p0_r_7_TAP0_ISEL_shift							(21)
+#define P0_r_8_DEMUX												(_BIT29|_BIT30|_BIT31)
+#define P0_r_8_PR_RATE_SEL											(_BIT26|_BIT27|_BIT28)
+#define P0_r_8_POW_PR												(_BIT25)
+#define P0_r_7_TAP0_ISEL											(_BIT21|_BIT22|_BIT23)
+#define P0_r_7_TAP0_ISEL_400uA										(_BIT22|_BIT23)
+#define P0_r_7_LEQ_ISEL												(_BIT18|_BIT19|_BIT20)
+#define P0_r_7_LEQ_ISEL_400uA										(_BIT19|_BIT20)
+#define P0_r_7_LEQ_ISEL_200uA										(_BIT20)
+#define P0_r_7_PI_ISEL												(_BIT16|_BIT17)
+#define P0_r_6_LEQ_BIT_RATE											(_BIT14|_BIT15)
+#define P0_r_6_LEQ_BIT_RATE_HBR										(_BIT15)
+#define P0_r_6_LEQ_BIT_RATE_MBR										(_BIT14)
+#define P0_r_6_TAP0_HBR												(_BIT13)
+#define P0_r_6_LEQ_PASSIVE_CORNER									(_BIT12|_BIT11)
+#define P0_r_5_LEQ_CURRENT_ADJ 										(_BIT3|_BIT4)
+#define P0_r_5_LEQ_CURRENT_ADJ_1X									(_BIT3)
+#define P0_r_5_LEQ_CURRENT_ADJ_1p25X								(_BIT4)
+#define P0_r_5_EQ_POW												(_BIT0)
+
+
+#define P0_R3                                                         0xa54
+#define P0_R3_reg_addr                                                "0x98034a54"
+#define P0_R3_reg                                                     0x98034a54
+#define P0_R3_inst_addr                                               "0x0295"
+#define P0_R3_inst                                                    0x0295
+#define set_P0_R3_reg(data)                                           (*((volatile unsigned int*)P0_R3_reg)=data)
+#define get_P0_R3_reg                                                 (*((volatile unsigned int*)P0_R3_reg))
+#define P0_R3_reg_p0_r_12_shift                                       (24)
+#define P0_R3_reg_p0_r_11_shift                                       (16)
+#define P0_R3_reg_p0_r_10_shift                                       (8)
+#define P0_R3_reg_p0_r_9_shift                                        (0)
+#define P0_R3_reg_p0_r_12_mask                                        (0xFF000000)
+#define P0_R3_reg_p0_r_11_mask                                        (0x00FF0000)
+#define P0_R3_reg_p0_r_10_mask                                        (0x0000FF00)
+#define P0_R3_reg_p0_r_9_mask                                         (0x000000FF)
+#define P0_R3_reg_p0_r_12(data)                                       (0xFF000000&((data)<<24))
+#define P0_R3_reg_p0_r_11(data)                                       (0x00FF0000&((data)<<16))
+#define P0_R3_reg_p0_r_10(data)                                       (0x0000FF00&((data)<<8))
+#define P0_R3_reg_p0_r_9(data)                                        (0x000000FF&(data))
+#define P0_R3_get_reg_p0_r_12(data)                                   ((0xFF000000&(data))>>24)
+#define P0_R3_get_reg_p0_r_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P0_R3_get_reg_p0_r_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P0_R3_get_reg_p0_r_9(data)                                    (0x000000FF&(data))
+#define P0_R_DFE_TAPEN4321											(_BIT6|_BIT5|_BIT4|_BIT3)
+#define P0_r_12_PR													(_BIT24|_BIT25)
+#define P0_r_9_DFE_ADAPTION_POW_EN									(_BIT7)
+#define P0_r_9_DFE_TAP_EN											(_BIT3|_BIT4|_BIT5|_BIT6)
+#define P0_r_9_DFE_TAP1_EN											(_BIT3)
+#define DFE_HDMI_RX_PHY_P0_r_tap_en(data)							(0x00000078&((data)<<3))
+#define P0_r_11_ACDR_RATE_SEL										(_BIT24|_BIT25)
+#define P0_r_11_ACDR_RATE_SEL_HALF_RATE								(_BIT16)
+#define P0_r_10_DFE_SUMAMP_LP_MANUALOFF								(_BIT15)
+#define P0_r_10_DFE_SUMAMP_ISEL_mask								(_BIT11|_BIT12|_BIT13)
+#define P0_r_10_DFE_SUMAMP_ISEL_400uA								(_BIT13)
+#define P0_r_10_DFE_PREAMP_ISEL_mask								(_BIT8|_BIT9|_BIT10)
+#define P0_r_10_DFE_PREAMP_ISEL_400uA								(_BIT10)
+
+
+#define P0_R4                                                         0xa58
+#define P0_R4_reg_addr                                                "0x98034a58"
+#define P0_R4_reg                                                     0x98034a58
+#define P0_R4_inst_addr                                               "0x0296"
+#define P0_R4_inst                                                    0x0296
+#define set_P0_R4_reg(data)                                           (*((volatile unsigned int*)P0_R4_reg)=data)
+#define get_P0_R4_reg                                                 (*((volatile unsigned int*)P0_R4_reg))
+#define P0_R4_reg_p0_r_koff_sel_shift                                 (10)
+#define P0_R4_reg_p0_r_koff_bound_shift                               (9)
+#define P0_R4_reg_p0_r_koffok_shift                                   (8)
+#define P0_R4_reg_p0_r_13_shift                                       (0)
+#define P0_R4_reg_p0_r_koff_sel_mask                                  (0x00007C00)
+#define P0_R4_reg_p0_r_koff_bound_mask                                (0x00000200)
+#define P0_R4_reg_p0_r_koffok_mask                                    (0x00000100)
+#define P0_R4_reg_p0_r_13_mask                                        (0x000000FF)
+#define P0_R4_reg_p0_r_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P0_R4_reg_p0_r_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P0_R4_reg_p0_r_koffok(data)                                   (0x00000100&((data)<<8))
+#define P0_R4_reg_p0_r_13(data)                                       (0x000000FF&(data))
+#define P0_R4_get_reg_p0_r_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P0_R4_get_reg_p0_r_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P0_R4_get_reg_p0_r_koffok(data)                               ((0x00000100&(data))>>8)
+#define P0_R4_get_reg_p0_r_13(data)                                   (0x000000FF&(data))
+
+
+#define P1_ACDR1                                                      0xa5c
+#define P1_ACDR1_reg_addr                                             "0x98034a5c"
+#define P1_ACDR1_reg                                                  0x98034a5c
+#define P1_ACDR1_inst_addr                                            "0x0297"
+#define P1_ACDR1_inst                                                 0x0297
+#define set_P1_ACDR1_reg(data)                                        (*((volatile unsigned int*)P1_ACDR1_reg)=data)
+#define get_P1_ACDR1_reg                                              (*((volatile unsigned int*)P1_ACDR1_reg))
+#define P1_ACDR1_reg_p1_acdr_4_shift                                  (24)
+#define P1_ACDR1_reg_p1_acdr_3_shift                                  (16)
+#define P1_ACDR1_reg_p1_acdr_2_shift                                  (8)
+#define P1_ACDR1_reg_p1_acdr_1_shift                                  (0)
+#define P1_ACDR1_reg_p1_acdr_4_mask                                   (0xFF000000)
+#define P1_ACDR1_reg_p1_acdr_3_mask                                   (0x00FF0000)
+#define P1_ACDR1_reg_p1_acdr_2_mask                                   (0x0000FF00)
+#define P1_ACDR1_reg_p1_acdr_1_mask                                   (0x000000FF)
+#define P1_ACDR1_reg_p1_acdr_4(data)                                  (0xFF000000&((data)<<24))
+#define P1_ACDR1_reg_p1_acdr_3(data)                                  (0x00FF0000&((data)<<16))
+#define P1_ACDR1_reg_p1_acdr_2(data)                                  (0x0000FF00&((data)<<8))
+#define P1_ACDR1_reg_p1_acdr_1(data)                                  (0x000000FF&(data))
+#define P1_ACDR1_get_reg_p1_acdr_4(data)                              ((0xFF000000&(data))>>24)
+#define P1_ACDR1_get_reg_p1_acdr_3(data)                              ((0x00FF0000&(data))>>16)
+#define P1_ACDR1_get_reg_p1_acdr_2(data)                              ((0x0000FF00&(data))>>8)
+#define P1_ACDR1_get_reg_p1_acdr_1(data)                              (0x000000FF&(data))
+
+
+#define P1_ACDR2                                                      0xa60
+#define P1_ACDR2_reg_addr                                             "0x98034a60"
+#define P1_ACDR2_reg                                                  0x98034a60
+#define P1_ACDR2_inst_addr                                            "0x0298"
+#define P1_ACDR2_inst                                                 0x0298
+#define set_P1_ACDR2_reg(data)                                        (*((volatile unsigned int*)P1_ACDR2_reg)=data)
+#define get_P1_ACDR2_reg                                              (*((volatile unsigned int*)P1_ACDR2_reg))
+#define P1_ACDR2_reg_p1_acdr_8_shift                                  (24)
+#define P1_ACDR2_reg_p1_acdr_7_shift                                  (16)
+#define P1_ACDR2_reg_p1_acdr_6_shift                                  (8)
+#define P1_ACDR2_reg_p1_acdr_5_shift                                  (0)
+#define P1_ACDR2_reg_p1_acdr_8_mask                                   (0xFF000000)
+#define P1_ACDR2_reg_p1_acdr_7_mask                                   (0x00FF0000)
+#define P1_ACDR2_reg_p1_acdr_6_mask                                   (0x0000FF00)
+#define P1_ACDR2_reg_p1_acdr_5_mask                                   (0x000000FF)
+#define P1_ACDR2_reg_p1_acdr_8(data)                                  (0xFF000000&((data)<<24))
+#define P1_ACDR2_reg_p1_acdr_7(data)                                  (0x00FF0000&((data)<<16))
+#define P1_ACDR2_reg_p1_acdr_6(data)                                  (0x0000FF00&((data)<<8))
+#define P1_ACDR2_reg_p1_acdr_5(data)                                  (0x000000FF&(data))
+#define P1_ACDR2_get_reg_p1_acdr_8(data)                              ((0xFF000000&(data))>>24)
+#define P1_ACDR2_get_reg_p1_acdr_7(data)                              ((0x00FF0000&(data))>>16)
+#define P1_ACDR2_get_reg_p1_acdr_6(data)                              ((0x0000FF00&(data))>>8)
+#define P1_ACDR2_get_reg_p1_acdr_5(data)                              (0x000000FF&(data))
+
+
+#define P1_B1                                                         0xa64
+#define P1_B1_reg_addr                                                "0x98034a64"
+#define P1_B1_reg                                                     0x98034a64
+#define P1_B1_inst_addr                                               "0x0299"
+#define P1_B1_inst                                                    0x0299
+#define set_P1_B1_reg(data)                                           (*((volatile unsigned int*)P1_B1_reg)=data)
+#define get_P1_B1_reg                                                 (*((volatile unsigned int*)P1_B1_reg))
+#define P1_B1_reg_p1_b_4_shift                                        (24)
+#define P1_B1_reg_p1_b_3_shift                                        (16)
+#define P1_B1_reg_p1_b_2_shift                                        (8)
+#define P1_B1_reg_p1_b_1_shift                                        (0)
+#define P1_B1_reg_p1_b_4_mask                                         (0xFF000000)
+#define P1_B1_reg_p1_b_3_mask                                         (0x00FF0000)
+#define P1_B1_reg_p1_b_2_mask                                         (0x0000FF00)
+#define P1_B1_reg_p1_b_1_mask                                         (0x000000FF)
+#define P1_B1_reg_p1_b_4(data)                                        (0xFF000000&((data)<<24))
+#define P1_B1_reg_p1_b_3(data)                                        (0x00FF0000&((data)<<16))
+#define P1_B1_reg_p1_b_2(data)                                        (0x0000FF00&((data)<<8))
+#define P1_B1_reg_p1_b_1(data)                                        (0x000000FF&(data))
+#define P1_B1_get_reg_p1_b_4(data)                                    ((0xFF000000&(data))>>24)
+#define P1_B1_get_reg_p1_b_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_B1_get_reg_p1_b_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_B1_get_reg_p1_b_1(data)                                    (0x000000FF&(data))
+#define P1_b_1_B_LANE_INPUT_OFF											(_BIT0)
+#define P1_b_3_B_FORE_KOFF_RANGE										(_BIT22|_BIT21)
+#define P1_b_1_FORE_KOFF_ADJR											(_BIT16|_BIT17|_BIT18|_BIT19|_BIT20)
+#define P1_b_2_LEQ_BIT_RATE_mask										(_BIT8|_BIT9)
+#define P1_b_2_LEQ_BIT_RATE_MBR											(_BIT8)
+#define P1_b_2_LEQ_BIT_RATE_HBR											(_BIT9)
+
+
+#define P1_B2                                                         0xa68
+#define P1_B2_reg_addr                                                "0x98034a68"
+#define P1_B2_reg                                                     0x98034a68
+#define P1_B2_inst_addr                                               "0x029A"
+#define P1_B2_inst                                                    0x029A
+#define set_P1_B2_reg(data)                                           (*((volatile unsigned int*)P1_B2_reg)=data)
+#define get_P1_B2_reg                                                 (*((volatile unsigned int*)P1_B2_reg))
+#define P1_B2_reg_p1_b_8_shift                                        (24)
+#define P1_B2_reg_p1_b_7_shift                                        (16)
+#define P1_B2_reg_p1_b_6_shift                                        (8)
+#define P1_B2_reg_p1_b_5_shift                                        (0)
+#define P1_B2_reg_p1_b_8_mask                                         (0xFF000000)
+#define P1_B2_reg_p1_b_7_mask                                         (0x00FF0000)
+#define P1_B2_reg_p1_b_6_mask                                         (0x0000FF00)
+#define P1_B2_reg_p1_b_5_mask                                         (0x000000FF)
+#define P1_B2_reg_p1_b_8(data)                                        (0xFF000000&((data)<<24))
+#define P1_B2_reg_p1_b_7(data)                                        (0x00FF0000&((data)<<16))
+#define P1_B2_reg_p1_b_6(data)                                        (0x0000FF00&((data)<<8))
+#define P1_B2_reg_p1_b_5(data)                                        (0x000000FF&(data))
+#define P1_B2_get_reg_p1_b_8(data)                                    ((0xFF000000&(data))>>24)
+#define P1_B2_get_reg_p1_b_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_B2_get_reg_p1_b_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_B2_get_reg_p1_b_5(data)                                    (0x000000FF&(data))
+#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_8_PR_RATE_SEL_shift			(26)
+#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_8_DEMUX_shift				(29)
+#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_7_TAP0_ISEL_shift			(21)
+#define  P1_b_8_DEMUX												(_BIT29|_BIT30|_BIT31)
+#define  P1_b_8_PR_RATE_SEL											(_BIT26|_BIT27|_BIT28)
+#define  P1_b_8_POW_PR												_BIT25
+#define  P1_b_8_BY_PASS_PR											_BIT24
+#define  P1_b_7_TAP0_ISEL											(_BIT21|_BIT22|_BIT23)
+#define  P1_b_7_TAP0_ISEL_400uA										(_BIT22|_BIT23)
+#define  P1_b_7_LEQ_ISEL											(_BIT18|_BIT19|_BIT20)
+#define  P1_b_7_LEQ_ISEL_400uA										(_BIT19|_BIT20)
+#define  P1_b_7_LEQ_ISEL_200uA										(_BIT20)
+#define  P1_b_7_PI_ISEL												(_BIT16|_BIT17)
+#define  P1_b_6_LEQ_BIT_RATE										(_BIT14|_BIT15)
+#define  P1_b_6_LEQ_BIT_RATE_HBR									(_BIT15)
+#define  P1_b_6_LEQ_BIT_RATE_MBR									(_BIT14)
+#define  P1_b_6_TAP0_HBR											(_BIT13)
+#define  P1_b_6_LEQ_PASSIVE_CORNER									( _BIT11|_BIT12)
+#define  P1_b_5_TAP0_CURRENT_ADJ									(_BIT3|_BIT4)
+#define  P1_b_5_TAP0_CURRENT_ADJ_1X									(_BIT3)
+#define  P1_b_5_TAP0_CURRENT_ADJ_1p25X								(_BIT4)
+#define  P1_b_5_EQ_POW												_BIT0
+
+
+#define P1_B3                                                         0xa6c
+#define P1_B3_reg_addr                                                "0x98034a6c"
+#define P1_B3_reg                                                     0x98034a6c
+#define P1_B3_inst_addr                                               "0x029B"
+#define P1_B3_inst                                                    0x029B
+#define set_P1_B3_reg(data)                                           (*((volatile unsigned int*)P1_B3_reg)=data)
+#define get_P1_B3_reg                                                 (*((volatile unsigned int*)P1_B3_reg))
+#define P1_B3_reg_p1_b_12_shift                                       (24)
+#define P1_B3_reg_p1_b_11_shift                                       (16)
+#define P1_B3_reg_p1_b_10_shift                                       (8)
+#define P1_B3_reg_p1_b_9_shift                                        (0)
+#define P1_B3_reg_p1_b_12_mask                                        (0xFF000000)
+#define P1_B3_reg_p1_b_11_mask                                        (0x00FF0000)
+#define P1_B3_reg_p1_b_10_mask                                        (0x0000FF00)
+#define P1_B3_reg_p1_b_9_mask                                         (0x000000FF)
+#define P1_B3_reg_p1_b_12(data)                                       (0xFF000000&((data)<<24))
+#define P1_B3_reg_p1_b_11(data)                                       (0x00FF0000&((data)<<16))
+#define P1_B3_reg_p1_b_10(data)                                       (0x0000FF00&((data)<<8))
+#define P1_B3_reg_p1_b_9(data)                                        (0x000000FF&(data))
+#define P1_B3_get_reg_p1_b_12(data)                                   ((0xFF000000&(data))>>24)
+#define P1_B3_get_reg_p1_b_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P1_B3_get_reg_p1_b_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P1_B3_get_reg_p1_b_9(data)                                    (0x000000FF&(data))
+#define P1_B_DFE_TAPEN4321											(_BIT6|_BIT5|_BIT4|_BIT3)
+#define P1_b_12_PR													(_BIT24|_BIT25)
+#define P1_b_11_ACDR_RATE_SEL_HALF_RATE								(_BIT16)
+#define P1_b_9_DFE_ADAPTION_POW_EN									(_BIT7)
+#define P1_b_9_DFE_TAP_EN											(_BIT3|_BIT4|_BIT5|_BIT6)
+#define P1_b_9_DFE_TAP1_EN											(_BIT3)
+#define DFE_HDMI_RX_PHY_P1_b_tap_en(data)							(0x00000078&((data)<<3))
+
+
+
+#define P1_B4                                                         0xa70
+#define P1_B4_reg_addr                                                "0x98034a70"
+#define P1_B4_reg                                                     0x98034a70
+#define P1_B4_inst_addr                                               "0x029C"
+#define P1_B4_inst                                                    0x029C
+#define set_P1_B4_reg(data)                                           (*((volatile unsigned int*)P1_B4_reg)=data)
+#define get_P1_B4_reg                                                 (*((volatile unsigned int*)P1_B4_reg))
+#define P1_B4_reg_p1_b_koff_sel_shift                                 (10)
+#define P1_B4_reg_p1_b_koff_bound_shift                               (9)
+#define P1_B4_reg_p1_b_koffok_shift                                   (8)
+#define P1_B4_reg_p1_b_13_shift                                       (0)
+#define P1_B4_reg_p1_b_koff_sel_mask                                  (0x00007C00)
+#define P1_B4_reg_p1_b_koff_bound_mask                                (0x00000200)
+#define P1_B4_reg_p1_b_koffok_mask                                    (0x00000100)
+#define P1_B4_reg_p1_b_13_mask                                        (0x000000FF)
+#define P1_B4_reg_p1_b_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P1_B4_reg_p1_b_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P1_B4_reg_p1_b_koffok(data)                                   (0x00000100&((data)<<8))
+#define P1_B4_reg_p1_b_13(data)                                       (0x000000FF&(data))
+#define P1_B4_get_reg_p1_b_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P1_B4_get_reg_p1_b_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P1_B4_get_reg_p1_b_koffok(data)                               ((0x00000100&(data))>>8)
+#define P1_B4_get_reg_p1_b_13(data)                                   (0x000000FF&(data))
+
+
+#define P1_CK1                                                        0xa74
+#define P1_CK1_reg_addr                                               "0x98034a74"
+#define P1_CK1_reg                                                    0x98034a74
+#define P1_CK1_inst_addr                                              "0x029D"
+#define P1_CK1_inst                                                   0x029D
+#define set_P1_CK1_reg(data)                                          (*((volatile unsigned int*)P1_CK1_reg)=data)
+#define get_P1_CK1_reg                                                (*((volatile unsigned int*)P1_CK1_reg))
+#define P1_CK1_reg_p1_ck_4_shift                                      (24)
+#define P1_CK1_reg_p1_ck_3_shift                                      (16)
+#define P1_CK1_reg_p1_ck_2_shift                                      (8)
+#define P1_CK1_reg_p1_ck_1_shift                                      (0)
+#define P1_CK1_reg_p1_ck_4_mask                                       (0xFF000000)
+#define P1_CK1_reg_p1_ck_3_mask                                       (0x00FF0000)
+#define P1_CK1_reg_p1_ck_2_mask                                       (0x0000FF00)
+#define P1_CK1_reg_p1_ck_1_mask                                       (0x000000FF)
+#define P1_CK1_reg_p1_ck_4(data)                                      (0xFF000000&((data)<<24))
+#define P1_CK1_reg_p1_ck_3(data)                                      (0x00FF0000&((data)<<16))
+#define P1_CK1_reg_p1_ck_2(data)                                      (0x0000FF00&((data)<<8))
+#define P1_CK1_reg_p1_ck_1(data)                                      (0x000000FF&(data))
+#define P1_CK1_get_reg_p1_ck_4(data)                                  ((0xFF000000&(data))>>24)
+#define P1_CK1_get_reg_p1_ck_3(data)                                  ((0x00FF0000&(data))>>16)
+#define P1_CK1_get_reg_p1_ck_2(data)                                  ((0x0000FF00&(data))>>8)
+#define P1_CK1_get_reg_p1_ck_1(data)                                  (0x000000FF&(data))
+#define p1_ck_3_CMU_PREDIVN												(_BIT20|_BIT21|_BIT22|_BIT23)
+#define p1_ck_3_CMU_N_code												(_BIT18|_BIT19)
+#define p1_ck_2_CMU_CKIN_SEL											(_BIT12|_BIT13|_BIT14|_BIT15)
+#define p1_CMU_CKOUT_SEL												(_BIT11)
+#define p1_ck_2_CK_MD_REF_SEL											(_BIT9)
+#define p1_ck_1_port_bias												(_BIT2)
+#define p1_ck_1_CKAFE_POW												(_BIT1)
+
+
+#define P1_CK2                                                        0xa78
+#define P1_CK2_reg_addr                                               "0x98034a78"
+#define P1_CK2_reg                                                    0x98034a78
+#define P1_CK2_inst_addr                                              "0x029E"
+#define P1_CK2_inst                                                   0x029E
+#define set_P1_CK2_reg(data)                                          (*((volatile unsigned int*)P1_CK2_reg)=data)
+#define get_P1_CK2_reg                                                (*((volatile unsigned int*)P1_CK2_reg))
+#define P1_CK2_reg_p1_ck_8_shift                                      (24)
+#define P1_CK2_reg_p1_ck_7_shift                                      (16)
+#define P1_CK2_reg_p1_ck_6_shift                                      (8)
+#define P1_CK2_reg_p1_ck_5_shift                                      (0)
+#define P1_CK2_reg_p1_ck_8_mask                                       (0xFF000000)
+#define P1_CK2_reg_p1_ck_7_mask                                       (0x00FF0000)
+#define P1_CK2_reg_p1_ck_6_mask                                       (0x0000FF00)
+#define P1_CK2_reg_p1_ck_5_mask                                       (0x000000FF)
+#define P1_CK2_reg_p1_ck_8(data)                                      (0xFF000000&((data)<<24))
+#define P1_CK2_reg_p1_ck_7(data)                                      (0x00FF0000&((data)<<16))
+#define P1_CK2_reg_p1_ck_6(data)                                      (0x0000FF00&((data)<<8))
+#define P1_CK2_reg_p1_ck_5(data)                                      (0x000000FF&(data))
+#define P1_CK2_get_reg_p1_ck_8(data)                                  ((0xFF000000&(data))>>24)
+#define P1_CK2_get_reg_p1_ck_7(data)                                  ((0x00FF0000&(data))>>16)
+#define P1_CK2_get_reg_p1_ck_6(data)                                  ((0x0000FF00&(data))>>8)
+#define P1_CK2_get_reg_p1_ck_5(data)                                  (0x000000FF&(data))
+#define P1_ck_8_VSEL_LDO_A_mask										(_BIT29|_BIT30|_BIT31)
+#define P1_ck_8_VSEL_LDO_D_mask										(_BIT26|_BIT27|_BIT28)
+#define P1_ck_8_LDO_EN_mask											(_BIT25)
+#define P1_ck_8_CMU_BPPSR_mask										(_BIT24)
+#define P1_ck_7_CMU_BYPASS_PI_mask									(_BIT19)
+#define P1_ck_7_CMU_PI_I_SEL_mask									(_BIT16|_BIT17|_BIT18)
+#define P1_ck_6_CMU_BIG_KVCO_mask									(_BIT13)
+#define P1_ck_6_CMU_EN_CAP_mask										(_BIT12)
+#define P1_ck_6_CMU_SEL_CS_mask										(_BIT8|_BIT9|_BIT10)
+#define P1_ck_5_CMU_SEL_PUMP_I_mask									(_BIT4|_BIT5|_BIT6|_BIT7)
+#define P1_ck_5_CMU_SEL_R1_mask										(_BIT0|_BIT1|_BIT2)
+#define DFE_HDMI_RX_PHY_P1_VSEL_LDO_D(data)							(0x1C000000&((data)<<26))
+#define DFE_HDMI_RX_PHY_P1_CMU_BPPSR(data)							(0x01000000&((data)<<24))
+#define DFE_HDMI_RX_PHY_P1_CMU_SEL_CS(data)							(0x00000700&((data)<<8))
+#define DFE_HDMI_RX_PHY_P1_CMU_SEL_PUMP_I(data)						(0x000000F0&((data)<<4))
+#define DFE_HDMI_RX_PHY_P1_CMU_SEL_R1(data)							(0x00000007&((data)<<0))
+
+
+#define P1_CK3                                                        0xa7c
+#define P1_CK3_reg_addr                                               "0x98034a7c"
+#define P1_CK3_reg                                                    0x98034a7c
+#define P1_CK3_inst_addr                                              "0x029F"
+#define P1_CK3_inst                                                   0x029F
+#define set_P1_CK3_reg(data)                                          (*((volatile unsigned int*)P1_CK3_reg)=data)
+#define get_P1_CK3_reg                                                (*((volatile unsigned int*)P1_CK3_reg))
+#define P1_CK3_reg_p1_ck_12_shift                                     (24)
+#define P1_CK3_reg_p1_ck_11_shift                                     (16)
+#define P1_CK3_reg_p1_ck_10_shift                                     (8)
+#define P1_CK3_reg_p1_ck_9_shift                                      (0)
+#define P1_CK3_reg_p1_ck_12_mask                                      (0xFF000000)
+#define P1_CK3_reg_p1_ck_11_mask                                      (0x00FF0000)
+#define P1_CK3_reg_p1_ck_10_mask                                      (0x0000FF00)
+#define P1_CK3_reg_p1_ck_9_mask                                       (0x000000FF)
+#define P1_CK3_reg_p1_ck_12(data)                                     (0xFF000000&((data)<<24))
+#define P1_CK3_reg_p1_ck_11(data)                                     (0x00FF0000&((data)<<16))
+#define P1_CK3_reg_p1_ck_10(data)                                     (0x0000FF00&((data)<<8))
+#define P1_CK3_reg_p1_ck_9(data)                                      (0x000000FF&(data))
+#define P1_CK3_get_reg_p1_ck_12(data)                                 ((0xFF000000&(data))>>24)
+#define P1_CK3_get_reg_p1_ck_11(data)                                 ((0x00FF0000&(data))>>16)
+#define P1_CK3_get_reg_p1_ck_10(data)                                 ((0x0000FF00&(data))>>8)
+#define P1_CK3_get_reg_p1_ck_9(data)                                  (0x000000FF&(data))
+#define P1_ck_9_CMU_PFD_RSTB										(_BIT5)
+#define P1_ck_9_CMU_WDRST											(_BIT2)
+
+
+#define P1_CK4                                                        0xa80
+#define P1_CK4_reg_addr                                               "0x98034a80"
+#define P1_CK4_reg                                                    0x98034a80
+#define P1_CK4_inst_addr                                              "0x02A0"
+#define P1_CK4_inst                                                   0x02A0
+#define set_P1_CK4_reg(data)                                          (*((volatile unsigned int*)P1_CK4_reg)=data)
+#define get_P1_CK4_reg                                                (*((volatile unsigned int*)P1_CK4_reg))
+#define P1_CK4_reg_p1_ck_13_shift                                     (0)
+#define P1_CK4_reg_p1_ck_13_mask                                      (0x000000FF)
+#define P1_CK4_reg_p1_ck_13(data)                                     (0x000000FF&(data))
+#define P1_CK4_get_reg_p1_ck_13(data)                                 (0x000000FF&(data))
+
+
+#define P1_G1                                                         0xa84
+#define P1_G1_reg_addr                                                "0x98034a84"
+#define P1_G1_reg                                                     0x98034a84
+#define P1_G1_inst_addr                                               "0x02A1"
+#define P1_G1_inst                                                    0x02A1
+#define set_P1_G1_reg(data)                                           (*((volatile unsigned int*)P1_G1_reg)=data)
+#define get_P1_G1_reg                                                 (*((volatile unsigned int*)P1_G1_reg))
+#define P1_G1_reg_p1_g_4_shift                                        (24)
+#define P1_G1_reg_p1_g_3_shift                                        (16)
+#define P1_G1_reg_p1_g_2_shift                                        (8)
+#define P1_G1_reg_p1_g_1_shift                                        (0)
+#define P1_G1_reg_p1_g_4_mask                                         (0xFF000000)
+#define P1_G1_reg_p1_g_3_mask                                         (0x00FF0000)
+#define P1_G1_reg_p1_g_2_mask                                         (0x0000FF00)
+#define P1_G1_reg_p1_g_1_mask                                         (0x000000FF)
+#define P1_G1_reg_p1_g_4(data)                                        (0xFF000000&((data)<<24))
+#define P1_G1_reg_p1_g_3(data)                                        (0x00FF0000&((data)<<16))
+#define P1_G1_reg_p1_g_2(data)                                        (0x0000FF00&((data)<<8))
+#define P1_G1_reg_p1_g_1(data)                                        (0x000000FF&(data))
+#define P1_G1_get_reg_p1_g_4(data)                                    ((0xFF000000&(data))>>24)
+#define P1_G1_get_reg_p1_g_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_G1_get_reg_p1_g_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_G1_get_reg_p1_g_1(data)                                    (0x000000FF&(data))
+#define P1_g_1_G_LANE_INPUT_OFF										(_BIT0)
+#define P1_g_2_LEQ_BIT_RATE_mask									(_BIT8|_BIT9)
+#define P1_g_2_LEQ_BIT_RATE_MBR										(_BIT8)
+#define P1_g_2_LEQ_BIT_RATE_HBR										(_BIT9)
+
+
+#define P1_G2                                                         0xa88
+#define P1_G2_reg_addr                                                "0x98034a88"
+#define P1_G2_reg                                                     0x98034a88
+#define P1_G2_inst_addr                                               "0x02A2"
+#define P1_G2_inst                                                    0x02A2
+#define set_P1_G2_reg(data)                                           (*((volatile unsigned int*)P1_G2_reg)=data)
+#define get_P1_G2_reg                                                 (*((volatile unsigned int*)P1_G2_reg))
+#define P1_G2_reg_p1_g_8_shift                                        (24)
+#define P1_G2_reg_p1_g_7_shift                                        (16)
+#define P1_G2_reg_p1_g_6_shift                                        (8)
+#define P1_G2_reg_p1_g_5_shift                                        (0)
+#define P1_G2_reg_p1_g_8_mask                                         (0xFF000000)
+#define P1_G2_reg_p1_g_7_mask                                         (0x00FF0000)
+#define P1_G2_reg_p1_g_6_mask                                         (0x0000FF00)
+#define P1_G2_reg_p1_g_5_mask                                         (0x000000FF)
+#define P1_G2_reg_p1_g_8(data)                                        (0xFF000000&((data)<<24))
+#define P1_G2_reg_p1_g_7(data)                                        (0x00FF0000&((data)<<16))
+#define P1_G2_reg_p1_g_6(data)                                        (0x0000FF00&((data)<<8))
+#define P1_G2_reg_p1_g_5(data)                                        (0x000000FF&(data))
+#define P1_G2_get_reg_p1_g_8(data)                                    ((0xFF000000&(data))>>24)
+#define P1_G2_get_reg_p1_g_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_G2_get_reg_p1_g_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_G2_get_reg_p1_g_5(data)                                    (0x000000FF&(data))
+#define DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_8_PR_RATE_SEL_shift			(26)
+#define DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_8_DEMUX_shift				(29)
+#define DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_7_TAP0_ISEL_shift			(21)
+#define P1_g_8_DEMUX												(_BIT29|_BIT30|_BIT31)
+#define P1_g_8_PR_RATE_SEL											(_BIT26|_BIT27|_BIT28)
+#define P1_g_8_POW_PR												_BIT25
+#define P1_g_8_BY_PASS_PR											_BIT24
+#define P1_g_7_TAP0_ISEL											(_BIT21|_BIT22|_BIT23)
+#define P1_g_7_TAP0_ISEL_400uA										(_BIT22|_BIT23)
+#define P1_g_7_LEQ_ISEL												(_BIT18|_BIT19|_BIT20)
+#define P1_g_7_LEQ_ISEL_400uA										(_BIT19|_BIT20)
+#define P1_g_7_PI_ISEL												(_BIT16|_BIT17)
+#define P1_g_6_LEQ_BIT_RATE											(_BIT14|_BIT15)
+#define P1_g_6_LEQ_BIT_RATE_HBR										(_BIT15)
+#define P1_g_6_LEQ_BIT_RATE_MBR										(_BIT14)
+#define P1_g_6_TAP0_HBR												(_BIT13)
+#define P1_g_6_LEQ_PASSIVE_CORNER									(_BIT11|_BIT12)
+#define P1_g_5_TAP0_CURRENT_ADJ										(_BIT3|_BIT4)
+#define P1_g_5_TAP0_CURRENT_ADJ_1X									(_BIT3)
+#define P1_g_5_TAP0_CURRENT_ADJ_1p25X								(_BIT4)
+#define P1_g_5_EQ_POW												_BIT0
+
+
+#define P1_G3                                                         0xa8c
+#define P1_G3_reg_addr                                                "0x98034a8c"
+#define P1_G3_reg                                                     0x98034a8c
+#define P1_G3_inst_addr                                               "0x02A3"
+#define P1_G3_inst                                                    0x02A3
+#define set_P1_G3_reg(data)                                           (*((volatile unsigned int*)P1_G3_reg)=data)
+#define get_P1_G3_reg                                                 (*((volatile unsigned int*)P1_G3_reg))
+#define P1_G3_reg_p1_g_12_shift                                       (24)
+#define P1_G3_reg_p1_g_11_shift                                       (16)
+#define P1_G3_reg_p1_g_10_shift                                       (8)
+#define P1_G3_reg_p1_g_9_shift                                        (0)
+#define P1_G3_reg_p1_g_12_mask                                        (0xFF000000)
+#define P1_G3_reg_p1_g_11_mask                                        (0x00FF0000)
+#define P1_G3_reg_p1_g_10_mask                                        (0x0000FF00)
+#define P1_G3_reg_p1_g_9_mask                                         (0x000000FF)
+#define P1_G3_reg_p1_g_12(data)                                       (0xFF000000&((data)<<24))
+#define P1_G3_reg_p1_g_11(data)                                       (0x00FF0000&((data)<<16))
+#define P1_G3_reg_p1_g_10(data)                                       (0x0000FF00&((data)<<8))
+#define P1_G3_reg_p1_g_9(data)                                        (0x000000FF&(data))
+#define P1_G3_get_reg_p1_g_12(data)                                   ((0xFF000000&(data))>>24)
+#define P1_G3_get_reg_p1_g_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P1_G3_get_reg_p1_g_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P1_G3_get_reg_p1_g_9(data)                                    (0x000000FF&(data))
+
+
+#define P1_G4                                                         0xa90
+#define P1_G4_reg_addr                                                "0x98034a90"
+#define P1_G4_reg                                                     0x98034a90
+#define P1_G4_inst_addr                                               "0x02A4"
+#define P1_G4_inst                                                    0x02A4
+#define set_P1_G4_reg(data)                                           (*((volatile unsigned int*)P1_G4_reg)=data)
+#define get_P1_G4_reg                                                 (*((volatile unsigned int*)P1_G4_reg))
+#define P1_G4_reg_p1_g_koff_sel_shift                                 (10)
+#define P1_G4_reg_p1_g_koff_bound_shift                               (9)
+#define P1_G4_reg_p1_g_koffok_shift                                   (8)
+#define P1_G4_reg_p1_g_13_shift                                       (0)
+#define P1_G4_reg_p1_g_koff_sel_mask                                  (0x00007C00)
+#define P1_G4_reg_p1_g_koff_bound_mask                                (0x00000200)
+#define P1_G4_reg_p1_g_koffok_mask                                    (0x00000100)
+#define P1_G4_reg_p1_g_13_mask                                        (0x000000FF)
+#define P1_G4_reg_p1_g_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P1_G4_reg_p1_g_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P1_G4_reg_p1_g_koffok(data)                                   (0x00000100&((data)<<8))
+#define P1_G4_reg_p1_g_13(data)                                       (0x000000FF&(data))
+#define P1_G4_get_reg_p1_g_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P1_G4_get_reg_p1_g_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P1_G4_get_reg_p1_g_koffok(data)                               ((0x00000100&(data))>>8)
+#define P1_G4_get_reg_p1_g_13(data)                                   (0x000000FF&(data))
+
+
+#define P1_R1                                                         0xa94
+#define P1_R1_reg_addr                                                "0x98034a94"
+#define P1_R1_reg                                                     0x98034a94
+#define P1_R1_inst_addr                                               "0x02A5"
+#define P1_R1_inst                                                    0x02A5
+#define set_P1_R1_reg(data)                                           (*((volatile unsigned int*)P1_R1_reg)=data)
+#define get_P1_R1_reg                                                 (*((volatile unsigned int*)P1_R1_reg))
+#define P1_R1_reg_p1_r_4_shift                                        (24)
+#define P1_R1_reg_p1_r_3_shift                                        (16)
+#define P1_R1_reg_p1_r_2_shift                                        (8)
+#define P1_R1_reg_p1_r_1_shift                                        (0)
+#define P1_R1_reg_p1_r_4_mask                                         (0xFF000000)
+#define P1_R1_reg_p1_r_3_mask                                         (0x00FF0000)
+#define P1_R1_reg_p1_r_2_mask                                         (0x0000FF00)
+#define P1_R1_reg_p1_r_1_mask                                         (0x000000FF)
+#define P1_R1_reg_p1_r_4(data)                                        (0xFF000000&((data)<<24))
+#define P1_R1_reg_p1_r_3(data)                                        (0x00FF0000&((data)<<16))
+#define P1_R1_reg_p1_r_2(data)                                        (0x0000FF00&((data)<<8))
+#define P1_R1_reg_p1_r_1(data)                                        (0x000000FF&(data))
+#define P1_R1_get_reg_p1_r_4(data)                                    ((0xFF000000&(data))>>24)
+#define P1_R1_get_reg_p1_r_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_R1_get_reg_p1_r_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_R1_get_reg_p1_r_1(data)                                    (0x000000FF&(data))
+#define P1_r_1_R_LANE_INPUT_OFF										(_BIT0)
+#define P1_r_2_LEQ_BIT_RATE_mask									(_BIT8|_BIT9)
+#define P1_r_2_LEQ_BIT_RATE_MBR										(_BIT8)
+#define P1_r_2_LEQ_BIT_RATE_HBR										(_BIT9)
+
+
+#define P1_R2                                                         0xa98
+#define P1_R2_reg_addr                                                "0x98034a98"
+#define P1_R2_reg                                                     0x98034a98
+#define P1_R2_inst_addr                                               "0x02A6"
+#define P1_R2_inst                                                    0x02A6
+#define set_P1_R2_reg(data)                                           (*((volatile unsigned int*)P1_R2_reg)=data)
+#define get_P1_R2_reg                                                 (*((volatile unsigned int*)P1_R2_reg))
+#define P1_R2_reg_p1_r_8_shift                                        (24)
+#define P1_R2_reg_p1_r_7_shift                                        (16)
+#define P1_R2_reg_p1_r_6_shift                                        (8)
+#define P1_R2_reg_p1_r_5_shift                                        (0)
+#define P1_R2_reg_p1_r_8_mask                                         (0xFF000000)
+#define P1_R2_reg_p1_r_7_mask                                         (0x00FF0000)
+#define P1_R2_reg_p1_r_6_mask                                         (0x0000FF00)
+#define P1_R2_reg_p1_r_5_mask                                         (0x000000FF)
+#define P1_R2_reg_p1_r_8(data)                                        (0xFF000000&((data)<<24))
+#define P1_R2_reg_p1_r_7(data)                                        (0x00FF0000&((data)<<16))
+#define P1_R2_reg_p1_r_6(data)                                        (0x0000FF00&((data)<<8))
+#define P1_R2_reg_p1_r_5(data)                                        (0x000000FF&(data))
+#define P1_R2_get_reg_p1_r_8(data)                                    ((0xFF000000&(data))>>24)
+#define P1_R2_get_reg_p1_r_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_R2_get_reg_p1_r_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_R2_get_reg_p1_r_5(data)                                    (0x000000FF&(data))
+#define DFE_HDMI_RX_PHY_P1_R2_reg_p0_r_8_PR_RATE_SEL_shift			(26)
+#define DFE_HDMI_RX_PHY_P1_R2_reg_p0_r_8_DEMUX_shift				(29)
+#define DFE_HDMI_RX_PHY_P1_R2_reg_p0_r_7_TAP0_ISEL_shift			(21)
+#define P1_r_8_DEMUX												(_BIT29|_BIT30|_BIT31)
+#define P1_r_8_PR_RATE_SEL											(_BIT26|_BIT27|_BIT28)
+#define P1_r_8_POW_PR												_BIT25
+#define P1_r_8_BY_PASS_PR											_BIT24
+#define P1_r_7_TAP0_ISEL											(_BIT21|_BIT22|_BIT23)
+#define P1_r_7_TAP0_ISEL_400uA										(_BIT22|_BIT23)
+#define P1_r_7_LEQ_ISEL												(_BIT18|_BIT19|_BIT20)
+#define P1_r_7_LEQ_ISEL_400uA										(_BIT19|_BIT20)
+#define P1_r_7_PI_ISEL												(_BIT16|_BIT17)
+#define P1_r_6_LEQ_BIT_RATE											(_BIT14|_BIT15)
+#define P1_r_6_LEQ_BIT_RATE_HBR										(_BIT15)
+#define P1_r_6_LEQ_BIT_RATE_MBR										(_BIT14)
+#define P1_r_6_TAP0_HBR												(_BIT13)
+#define P1_r_6_LEQ_PASSIVE_CORNER									(_BIT12|_BIT11)
+#define P1_r_5_TAP0_CURRENT_ADJ										(_BIT3|_BIT4)
+#define P1_r_5_TAP0_CURRENT_ADJ_1X									(_BIT3)
+#define P1_r_5_TAP0_CURRENT_ADJ_1p25X								(_BIT4)
+#define P1_r_5_EQ_POW												_BIT0
+
+
+#define P1_R3                                                         0xa9c
+#define P1_R3_reg_addr                                                "0x98034a9c"
+#define P1_R3_reg                                                     0x98034a9c
+#define P1_R3_inst_addr                                               "0x02A7"
+#define P1_R3_inst                                                    0x02A7
+#define set_P1_R3_reg(data)                                           (*((volatile unsigned int*)P1_R3_reg)=data)
+#define get_P1_R3_reg                                                 (*((volatile unsigned int*)P1_R3_reg))
+#define P1_R3_reg_p1_r_12_shift                                       (24)
+#define P1_R3_reg_p1_r_11_shift                                       (16)
+#define P1_R3_reg_p1_r_10_shift                                       (8)
+#define P1_R3_reg_p1_r_9_shift                                        (0)
+#define P1_R3_reg_p1_r_12_mask                                        (0xFF000000)
+#define P1_R3_reg_p1_r_11_mask                                        (0x00FF0000)
+#define P1_R3_reg_p1_r_10_mask                                        (0x0000FF00)
+#define P1_R3_reg_p1_r_9_mask                                         (0x000000FF)
+#define P1_R3_reg_p1_r_12(data)                                       (0xFF000000&((data)<<24))
+#define P1_R3_reg_p1_r_11(data)                                       (0x00FF0000&((data)<<16))
+#define P1_R3_reg_p1_r_10(data)                                       (0x0000FF00&((data)<<8))
+#define P1_R3_reg_p1_r_9(data)                                        (0x000000FF&(data))
+#define P1_R3_get_reg_p1_r_12(data)                                   ((0xFF000000&(data))>>24)
+#define P1_R3_get_reg_p1_r_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P1_R3_get_reg_p1_r_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P1_R3_get_reg_p1_r_9(data)                                    (0x000000FF&(data))
+
+
+#define P1_R4                                                         0xaa0
+#define P1_R4_reg_addr                                                "0x98034aa0"
+#define P1_R4_reg                                                     0x98034aa0
+#define P1_R4_inst_addr                                               "0x02A8"
+#define P1_R4_inst                                                    0x02A8
+#define set_P1_R4_reg(data)                                           (*((volatile unsigned int*)P1_R4_reg)=data)
+#define get_P1_R4_reg                                                 (*((volatile unsigned int*)P1_R4_reg))
+#define P1_R4_reg_p1_r_koff_sel_shift                                 (10)
+#define P1_R4_reg_p1_r_koff_bound_shift                               (9)
+#define P1_R4_reg_p1_r_koffok_shift                                   (8)
+#define P1_R4_reg_p1_r_13_shift                                       (0)
+#define P1_R4_reg_p1_r_koff_sel_mask                                  (0x00007C00)
+#define P1_R4_reg_p1_r_koff_bound_mask                                (0x00000200)
+#define P1_R4_reg_p1_r_koffok_mask                                    (0x00000100)
+#define P1_R4_reg_p1_r_13_mask                                        (0x000000FF)
+#define P1_R4_reg_p1_r_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P1_R4_reg_p1_r_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P1_R4_reg_p1_r_koffok(data)                                   (0x00000100&((data)<<8))
+#define P1_R4_reg_p1_r_13(data)                                       (0x000000FF&(data))
+#define P1_R4_get_reg_p1_r_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P1_R4_get_reg_p1_r_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P1_R4_get_reg_p1_r_koffok(data)                               ((0x00000100&(data))>>8)
+#define P1_R4_get_reg_p1_r_13(data)                                   (0x000000FF&(data))
+
+
+#define P2_ACDR1                                                      0xaa4
+#define P2_ACDR1_reg_addr                                             "0x98034aa4"
+#define P2_ACDR1_reg                                                  0x98034aa4
+#define P2_ACDR1_inst_addr                                            "0x02A9"
+#define P2_ACDR1_inst                                                 0x02A9
+#define set_P2_ACDR1_reg(data)                                        (*((volatile unsigned int*)P2_ACDR1_reg)=data)
+#define get_P2_ACDR1_reg                                              (*((volatile unsigned int*)P2_ACDR1_reg))
+#define P2_ACDR1_reg_p2_acdr_4_shift                                  (24)
+#define P2_ACDR1_reg_p2_acdr_3_shift                                  (16)
+#define P2_ACDR1_reg_p2_acdr_2_shift                                  (8)
+#define P2_ACDR1_reg_p2_acdr_1_shift                                  (0)
+#define P2_ACDR1_reg_p2_acdr_4_mask                                   (0xFF000000)
+#define P2_ACDR1_reg_p2_acdr_3_mask                                   (0x00FF0000)
+#define P2_ACDR1_reg_p2_acdr_2_mask                                   (0x0000FF00)
+#define P2_ACDR1_reg_p2_acdr_1_mask                                   (0x000000FF)
+#define P2_ACDR1_reg_p2_acdr_4(data)                                  (0xFF000000&((data)<<24))
+#define P2_ACDR1_reg_p2_acdr_3(data)                                  (0x00FF0000&((data)<<16))
+#define P2_ACDR1_reg_p2_acdr_2(data)                                  (0x0000FF00&((data)<<8))
+#define P2_ACDR1_reg_p2_acdr_1(data)                                  (0x000000FF&(data))
+#define P2_ACDR1_get_reg_p2_acdr_4(data)                              ((0xFF000000&(data))>>24)
+#define P2_ACDR1_get_reg_p2_acdr_3(data)                              ((0x00FF0000&(data))>>16)
+#define P2_ACDR1_get_reg_p2_acdr_2(data)                              ((0x0000FF00&(data))>>8)
+#define P2_ACDR1_get_reg_p2_acdr_1(data)                              (0x000000FF&(data))
+
+
+#define P2_ACDR2                                                      0xaa8
+#define P2_ACDR2_reg_addr                                             "0x98034aa8"
+#define P2_ACDR2_reg                                                  0x98034aa8
+#define P2_ACDR2_inst_addr                                            "0x02AA"
+#define P2_ACDR2_inst                                                 0x02AA
+#define set_P2_ACDR2_reg(data)                                        (*((volatile unsigned int*)P2_ACDR2_reg)=data)
+#define get_P2_ACDR2_reg                                              (*((volatile unsigned int*)P2_ACDR2_reg))
+#define P2_ACDR2_reg_p2_acdr_8_shift                                  (24)
+#define P2_ACDR2_reg_p2_acdr_7_shift                                  (16)
+#define P2_ACDR2_reg_p2_acdr_6_shift                                  (8)
+#define P2_ACDR2_reg_p2_acdr_5_shift                                  (0)
+#define P2_ACDR2_reg_p2_acdr_8_mask                                   (0xFF000000)
+#define P2_ACDR2_reg_p2_acdr_7_mask                                   (0x00FF0000)
+#define P2_ACDR2_reg_p2_acdr_6_mask                                   (0x0000FF00)
+#define P2_ACDR2_reg_p2_acdr_5_mask                                   (0x000000FF)
+#define P2_ACDR2_reg_p2_acdr_8(data)                                  (0xFF000000&((data)<<24))
+#define P2_ACDR2_reg_p2_acdr_7(data)                                  (0x00FF0000&((data)<<16))
+#define P2_ACDR2_reg_p2_acdr_6(data)                                  (0x0000FF00&((data)<<8))
+#define P2_ACDR2_reg_p2_acdr_5(data)                                  (0x000000FF&(data))
+#define P2_ACDR2_get_reg_p2_acdr_8(data)                              ((0xFF000000&(data))>>24)
+#define P2_ACDR2_get_reg_p2_acdr_7(data)                              ((0x00FF0000&(data))>>16)
+#define P2_ACDR2_get_reg_p2_acdr_6(data)                              ((0x0000FF00&(data))>>8)
+#define P2_ACDR2_get_reg_p2_acdr_5(data)                              (0x000000FF&(data))
+
+
+#define P2_B1                                                         0xaac
+#define P2_B1_reg_addr                                                "0x98034aac"
+#define P2_B1_reg                                                     0x98034aac
+#define P2_B1_inst_addr                                               "0x02AB"
+#define P2_B1_inst                                                    0x02AB
+#define set_P2_B1_reg(data)                                           (*((volatile unsigned int*)P2_B1_reg)=data)
+#define get_P2_B1_reg                                                 (*((volatile unsigned int*)P2_B1_reg))
+#define P2_B1_reg_p2_b_4_shift                                        (24)
+#define P2_B1_reg_p2_b_3_shift                                        (16)
+#define P2_B1_reg_p2_b_2_shift                                        (8)
+#define P2_B1_reg_p2_b_1_shift                                        (0)
+#define P2_B1_reg_p2_b_4_mask                                         (0xFF000000)
+#define P2_B1_reg_p2_b_3_mask                                         (0x00FF0000)
+#define P2_B1_reg_p2_b_2_mask                                         (0x0000FF00)
+#define P2_B1_reg_p2_b_1_mask                                         (0x000000FF)
+#define P2_B1_reg_p2_b_4(data)                                        (0xFF000000&((data)<<24))
+#define P2_B1_reg_p2_b_3(data)                                        (0x00FF0000&((data)<<16))
+#define P2_B1_reg_p2_b_2(data)                                        (0x0000FF00&((data)<<8))
+#define P2_B1_reg_p2_b_1(data)                                        (0x000000FF&(data))
+#define P2_B1_get_reg_p2_b_4(data)                                    ((0xFF000000&(data))>>24)
+#define P2_B1_get_reg_p2_b_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_B1_get_reg_p2_b_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_B1_get_reg_p2_b_1(data)                                    (0x000000FF&(data))
+
+
+#define P2_B2                                                         0xab0
+#define P2_B2_reg_addr                                                "0x98034ab0"
+#define P2_B2_reg                                                     0x98034ab0
+#define P2_B2_inst_addr                                               "0x02AC"
+#define P2_B2_inst                                                    0x02AC
+#define set_P2_B2_reg(data)                                           (*((volatile unsigned int*)P2_B2_reg)=data)
+#define get_P2_B2_reg                                                 (*((volatile unsigned int*)P2_B2_reg))
+#define P2_B2_reg_p2_b_8_shift                                        (24)
+#define P2_B2_reg_p2_b_7_shift                                        (16)
+#define P2_B2_reg_p2_b_6_shift                                        (8)
+#define P2_B2_reg_p2_b_5_shift                                        (0)
+#define P2_B2_reg_p2_b_8_mask                                         (0xFF000000)
+#define P2_B2_reg_p2_b_7_mask                                         (0x00FF0000)
+#define P2_B2_reg_p2_b_6_mask                                         (0x0000FF00)
+#define P2_B2_reg_p2_b_5_mask                                         (0x000000FF)
+#define P2_B2_reg_p2_b_8(data)                                        (0xFF000000&((data)<<24))
+#define P2_B2_reg_p2_b_7(data)                                        (0x00FF0000&((data)<<16))
+#define P2_B2_reg_p2_b_6(data)                                        (0x0000FF00&((data)<<8))
+#define P2_B2_reg_p2_b_5(data)                                        (0x000000FF&(data))
+#define P2_B2_get_reg_p2_b_8(data)                                    ((0xFF000000&(data))>>24)
+#define P2_B2_get_reg_p2_b_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_B2_get_reg_p2_b_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_B2_get_reg_p2_b_5(data)                                    (0x000000FF&(data))
+
+
+#define P2_B3                                                         0xab4
+#define P2_B3_reg_addr                                                "0x98034ab4"
+#define P2_B3_reg                                                     0x98034ab4
+#define P2_B3_inst_addr                                               "0x02AD"
+#define P2_B3_inst                                                    0x02AD
+#define set_P2_B3_reg(data)                                           (*((volatile unsigned int*)P2_B3_reg)=data)
+#define get_P2_B3_reg                                                 (*((volatile unsigned int*)P2_B3_reg))
+#define P2_B3_reg_p2_b_12_shift                                       (24)
+#define P2_B3_reg_p2_b_11_shift                                       (16)
+#define P2_B3_reg_p2_b_10_shift                                       (8)
+#define P2_B3_reg_p2_b_9_shift                                        (0)
+#define P2_B3_reg_p2_b_12_mask                                        (0xFF000000)
+#define P2_B3_reg_p2_b_11_mask                                        (0x00FF0000)
+#define P2_B3_reg_p2_b_10_mask                                        (0x0000FF00)
+#define P2_B3_reg_p2_b_9_mask                                         (0x000000FF)
+#define P2_B3_reg_p2_b_12(data)                                       (0xFF000000&((data)<<24))
+#define P2_B3_reg_p2_b_11(data)                                       (0x00FF0000&((data)<<16))
+#define P2_B3_reg_p2_b_10(data)                                       (0x0000FF00&((data)<<8))
+#define P2_B3_reg_p2_b_9(data)                                        (0x000000FF&(data))
+#define P2_B3_get_reg_p2_b_12(data)                                   ((0xFF000000&(data))>>24)
+#define P2_B3_get_reg_p2_b_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P2_B3_get_reg_p2_b_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P2_B3_get_reg_p2_b_9(data)                                    (0x000000FF&(data))
+
+
+#define P2_B4                                                         0xab8
+#define P2_B4_reg_addr                                                "0x98034ab8"
+#define P2_B4_reg                                                     0x98034ab8
+#define P2_B4_inst_addr                                               "0x02AE"
+#define P2_B4_inst                                                    0x02AE
+#define set_P2_B4_reg(data)                                           (*((volatile unsigned int*)P2_B4_reg)=data)
+#define get_P2_B4_reg                                                 (*((volatile unsigned int*)P2_B4_reg))
+#define P2_B4_reg_p2_b_koff_sel_shift                                 (10)
+#define P2_B4_reg_p2_b_koff_bound_shift                               (9)
+#define P2_B4_reg_p2_b_koffok_shift                                   (8)
+#define P2_B4_reg_p2_b_13_shift                                       (0)
+#define P2_B4_reg_p2_b_koff_sel_mask                                  (0x00007C00)
+#define P2_B4_reg_p2_b_koff_bound_mask                                (0x00000200)
+#define P2_B4_reg_p2_b_koffok_mask                                    (0x00000100)
+#define P2_B4_reg_p2_b_13_mask                                        (0x000000FF)
+#define P2_B4_reg_p2_b_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P2_B4_reg_p2_b_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P2_B4_reg_p2_b_koffok(data)                                   (0x00000100&((data)<<8))
+#define P2_B4_reg_p2_b_13(data)                                       (0x000000FF&(data))
+#define P2_B4_get_reg_p2_b_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P2_B4_get_reg_p2_b_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P2_B4_get_reg_p2_b_koffok(data)                               ((0x00000100&(data))>>8)
+#define P2_B4_get_reg_p2_b_13(data)                                   (0x000000FF&(data))
+
+
+#define P2_CK1                                                        0xabc
+#define P2_CK1_reg_addr                                               "0x98034abc"
+#define P2_CK1_reg                                                    0x98034abc
+#define P2_CK1_inst_addr                                              "0x02AF"
+#define P2_CK1_inst                                                   0x02AF
+#define set_P2_CK1_reg(data)                                          (*((volatile unsigned int*)P2_CK1_reg)=data)
+#define get_P2_CK1_reg                                                (*((volatile unsigned int*)P2_CK1_reg))
+#define P2_CK1_reg_p2_ck_4_shift                                      (24)
+#define P2_CK1_reg_p2_ck_3_shift                                      (16)
+#define P2_CK1_reg_p2_ck_2_shift                                      (8)
+#define P2_CK1_reg_p2_ck_1_shift                                      (0)
+#define P2_CK1_reg_p2_ck_4_mask                                       (0xFF000000)
+#define P2_CK1_reg_p2_ck_3_mask                                       (0x00FF0000)
+#define P2_CK1_reg_p2_ck_2_mask                                       (0x0000FF00)
+#define P2_CK1_reg_p2_ck_1_mask                                       (0x000000FF)
+#define P2_CK1_reg_p2_ck_4(data)                                      (0xFF000000&((data)<<24))
+#define P2_CK1_reg_p2_ck_3(data)                                      (0x00FF0000&((data)<<16))
+#define P2_CK1_reg_p2_ck_2(data)                                      (0x0000FF00&((data)<<8))
+#define P2_CK1_reg_p2_ck_1(data)                                      (0x000000FF&(data))
+#define P2_CK1_get_reg_p2_ck_4(data)                                  ((0xFF000000&(data))>>24)
+#define P2_CK1_get_reg_p2_ck_3(data)                                  ((0x00FF0000&(data))>>16)
+#define P2_CK1_get_reg_p2_ck_2(data)                                  ((0x0000FF00&(data))>>8)
+#define P2_CK1_get_reg_p2_ck_1(data)                                  (0x000000FF&(data))
+#define p2_ck_3_CMU_N_code												(_BIT18|_BIT19)
+#define p2_ck_2_CMU_CKIN_SEL											(_BIT12|_BIT13|_BIT14|_BIT15)
+#define p2_CMU_CKOUT_SEL												(_BIT11)
+#define p2_ck_2_CK_MD_REF_SEL											(_BIT9)
+#define p2_ck_1_port_bias												(_BIT2)
+#define p2_ck_1_CKAFE_POW												(_BIT1)
+
+
+#define P2_CK2                                                        0xac0
+#define P2_CK2_reg_addr                                               "0x98034ac0"
+#define P2_CK2_reg                                                    0x98034ac0
+#define P2_CK2_inst_addr                                              "0x02B0"
+#define P2_CK2_inst                                                   0x02B0
+#define set_P2_CK2_reg(data)                                          (*((volatile unsigned int*)P2_CK2_reg)=data)
+#define get_P2_CK2_reg                                                (*((volatile unsigned int*)P2_CK2_reg))
+#define P2_CK2_reg_p2_ck_8_shift                                      (24)
+#define P2_CK2_reg_p2_ck_7_shift                                      (16)
+#define P2_CK2_reg_p2_ck_6_shift                                      (8)
+#define P2_CK2_reg_p2_ck_5_shift                                      (0)
+#define P2_CK2_reg_p2_ck_8_mask                                       (0xFF000000)
+#define P2_CK2_reg_p2_ck_7_mask                                       (0x00FF0000)
+#define P2_CK2_reg_p2_ck_6_mask                                       (0x0000FF00)
+#define P2_CK2_reg_p2_ck_5_mask                                       (0x000000FF)
+#define P2_CK2_reg_p2_ck_8(data)                                      (0xFF000000&((data)<<24))
+#define P2_CK2_reg_p2_ck_7(data)                                      (0x00FF0000&((data)<<16))
+#define P2_CK2_reg_p2_ck_6(data)                                      (0x0000FF00&((data)<<8))
+#define P2_CK2_reg_p2_ck_5(data)                                      (0x000000FF&(data))
+#define P2_CK2_get_reg_p2_ck_8(data)                                  ((0xFF000000&(data))>>24)
+#define P2_CK2_get_reg_p2_ck_7(data)                                  ((0x00FF0000&(data))>>16)
+#define P2_CK2_get_reg_p2_ck_6(data)                                  ((0x0000FF00&(data))>>8)
+#define P2_CK2_get_reg_p2_ck_5(data)                                  (0x000000FF&(data))
+
+
+#define P2_CK3                                                        0xac4
+#define P2_CK3_reg_addr                                               "0x98034ac4"
+#define P2_CK3_reg                                                    0x98034ac4
+#define P2_CK3_inst_addr                                              "0x02B1"
+#define P2_CK3_inst                                                   0x02B1
+#define set_P2_CK3_reg(data)                                          (*((volatile unsigned int*)P2_CK3_reg)=data)
+#define get_P2_CK3_reg                                                (*((volatile unsigned int*)P2_CK3_reg))
+#define P2_CK3_reg_p2_ck_12_shift                                     (24)
+#define P2_CK3_reg_p2_ck_11_shift                                     (16)
+#define P2_CK3_reg_p2_ck_10_shift                                     (8)
+#define P2_CK3_reg_p2_ck_9_shift                                      (0)
+#define P2_CK3_reg_p2_ck_12_mask                                      (0xFF000000)
+#define P2_CK3_reg_p2_ck_11_mask                                      (0x00FF0000)
+#define P2_CK3_reg_p2_ck_10_mask                                      (0x0000FF00)
+#define P2_CK3_reg_p2_ck_9_mask                                       (0x000000FF)
+#define P2_CK3_reg_p2_ck_12(data)                                     (0xFF000000&((data)<<24))
+#define P2_CK3_reg_p2_ck_11(data)                                     (0x00FF0000&((data)<<16))
+#define P2_CK3_reg_p2_ck_10(data)                                     (0x0000FF00&((data)<<8))
+#define P2_CK3_reg_p2_ck_9(data)                                      (0x000000FF&(data))
+#define P2_CK3_get_reg_p2_ck_12(data)                                 ((0xFF000000&(data))>>24)
+#define P2_CK3_get_reg_p2_ck_11(data)                                 ((0x00FF0000&(data))>>16)
+#define P2_CK3_get_reg_p2_ck_10(data)                                 ((0x0000FF00&(data))>>8)
+#define P2_CK3_get_reg_p2_ck_9(data)                                  (0x000000FF&(data))
+#define P2_ck_9_CMU_PFD_RSTB										(_BIT5)
+#define P2_ck_9_CMU_WDRST											(_BIT2)
+
+
+#define P2_CK4                                                        0xac8
+#define P2_CK4_reg_addr                                               "0x98034ac8"
+#define P2_CK4_reg                                                    0x98034ac8
+#define P2_CK4_inst_addr                                              "0x02B2"
+#define P2_CK4_inst                                                   0x02B2
+#define set_P2_CK4_reg(data)                                          (*((volatile unsigned int*)P2_CK4_reg)=data)
+#define get_P2_CK4_reg                                                (*((volatile unsigned int*)P2_CK4_reg))
+#define P2_CK4_reg_p2_ck_13_shift                                     (0)
+#define P2_CK4_reg_p2_ck_13_mask                                      (0x000000FF)
+#define P2_CK4_reg_p2_ck_13(data)                                     (0x000000FF&(data))
+#define P2_CK4_get_reg_p2_ck_13(data)                                 (0x000000FF&(data))
+
+
+#define P2_G1                                                         0xacc
+#define P2_G1_reg_addr                                                "0x98034acc"
+#define P2_G1_reg                                                     0x98034acc
+#define P2_G1_inst_addr                                               "0x02B3"
+#define P2_G1_inst                                                    0x02B3
+#define set_P2_G1_reg(data)                                           (*((volatile unsigned int*)P2_G1_reg)=data)
+#define get_P2_G1_reg                                                 (*((volatile unsigned int*)P2_G1_reg))
+#define P2_G1_reg_p2_g_4_shift                                        (24)
+#define P2_G1_reg_p2_g_3_shift                                        (16)
+#define P2_G1_reg_p2_g_2_shift                                        (8)
+#define P2_G1_reg_p2_g_1_shift                                        (0)
+#define P2_G1_reg_p2_g_4_mask                                         (0xFF000000)
+#define P2_G1_reg_p2_g_3_mask                                         (0x00FF0000)
+#define P2_G1_reg_p2_g_2_mask                                         (0x0000FF00)
+#define P2_G1_reg_p2_g_1_mask                                         (0x000000FF)
+#define P2_G1_reg_p2_g_4(data)                                        (0xFF000000&((data)<<24))
+#define P2_G1_reg_p2_g_3(data)                                        (0x00FF0000&((data)<<16))
+#define P2_G1_reg_p2_g_2(data)                                        (0x0000FF00&((data)<<8))
+#define P2_G1_reg_p2_g_1(data)                                        (0x000000FF&(data))
+#define P2_G1_get_reg_p2_g_4(data)                                    ((0xFF000000&(data))>>24)
+#define P2_G1_get_reg_p2_g_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_G1_get_reg_p2_g_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_G1_get_reg_p2_g_1(data)                                    (0x000000FF&(data))
+
+
+#define P2_G2                                                         0xad0
+#define P2_G2_reg_addr                                                "0x98034ad0"
+#define P2_G2_reg                                                     0x98034ad0
+#define P2_G2_inst_addr                                               "0x02B4"
+#define P2_G2_inst                                                    0x02B4
+#define set_P2_G2_reg(data)                                           (*((volatile unsigned int*)P2_G2_reg)=data)
+#define get_P2_G2_reg                                                 (*((volatile unsigned int*)P2_G2_reg))
+#define P2_G2_reg_p2_g_8_shift                                        (24)
+#define P2_G2_reg_p2_g_7_shift                                        (16)
+#define P2_G2_reg_p2_g_6_shift                                        (8)
+#define P2_G2_reg_p2_g_5_shift                                        (0)
+#define P2_G2_reg_p2_g_8_mask                                         (0xFF000000)
+#define P2_G2_reg_p2_g_7_mask                                         (0x00FF0000)
+#define P2_G2_reg_p2_g_6_mask                                         (0x0000FF00)
+#define P2_G2_reg_p2_g_5_mask                                         (0x000000FF)
+#define P2_G2_reg_p2_g_8(data)                                        (0xFF000000&((data)<<24))
+#define P2_G2_reg_p2_g_7(data)                                        (0x00FF0000&((data)<<16))
+#define P2_G2_reg_p2_g_6(data)                                        (0x0000FF00&((data)<<8))
+#define P2_G2_reg_p2_g_5(data)                                        (0x000000FF&(data))
+#define P2_G2_get_reg_p2_g_8(data)                                    ((0xFF000000&(data))>>24)
+#define P2_G2_get_reg_p2_g_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_G2_get_reg_p2_g_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_G2_get_reg_p2_g_5(data)                                    (0x000000FF&(data))
+
+
+#define P2_G3                                                         0xad4
+#define P2_G3_reg_addr                                                "0x98034ad4"
+#define P2_G3_reg                                                     0x98034ad4
+#define P2_G3_inst_addr                                               "0x02B5"
+#define P2_G3_inst                                                    0x02B5
+#define set_P2_G3_reg(data)                                           (*((volatile unsigned int*)P2_G3_reg)=data)
+#define get_P2_G3_reg                                                 (*((volatile unsigned int*)P2_G3_reg))
+#define P2_G3_reg_p2_g_12_shift                                       (24)
+#define P2_G3_reg_p2_g_11_shift                                       (16)
+#define P2_G3_reg_p2_g_10_shift                                       (8)
+#define P2_G3_reg_p2_g_9_shift                                        (0)
+#define P2_G3_reg_p2_g_12_mask                                        (0xFF000000)
+#define P2_G3_reg_p2_g_11_mask                                        (0x00FF0000)
+#define P2_G3_reg_p2_g_10_mask                                        (0x0000FF00)
+#define P2_G3_reg_p2_g_9_mask                                         (0x000000FF)
+#define P2_G3_reg_p2_g_12(data)                                       (0xFF000000&((data)<<24))
+#define P2_G3_reg_p2_g_11(data)                                       (0x00FF0000&((data)<<16))
+#define P2_G3_reg_p2_g_10(data)                                       (0x0000FF00&((data)<<8))
+#define P2_G3_reg_p2_g_9(data)                                        (0x000000FF&(data))
+#define P2_G3_get_reg_p2_g_12(data)                                   ((0xFF000000&(data))>>24)
+#define P2_G3_get_reg_p2_g_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P2_G3_get_reg_p2_g_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P2_G3_get_reg_p2_g_9(data)                                    (0x000000FF&(data))
+
+
+#define P2_G4                                                         0xad8
+#define P2_G4_reg_addr                                                "0x98034ad8"
+#define P2_G4_reg                                                     0x98034ad8
+#define P2_G4_inst_addr                                               "0x02B6"
+#define P2_G4_inst                                                    0x02B6
+#define set_P2_G4_reg(data)                                           (*((volatile unsigned int*)P2_G4_reg)=data)
+#define get_P2_G4_reg                                                 (*((volatile unsigned int*)P2_G4_reg))
+#define P2_G4_reg_p2_g_koff_sel_shift                                 (10)
+#define P2_G4_reg_p2_g_koff_bound_shift                               (9)
+#define P2_G4_reg_p2_g_koffok_shift                                   (8)
+#define P2_G4_reg_p2_g_13_shift                                       (0)
+#define P2_G4_reg_p2_g_koff_sel_mask                                  (0x00007C00)
+#define P2_G4_reg_p2_g_koff_bound_mask                                (0x00000200)
+#define P2_G4_reg_p2_g_koffok_mask                                    (0x00000100)
+#define P2_G4_reg_p2_g_13_mask                                        (0x000000FF)
+#define P2_G4_reg_p2_g_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P2_G4_reg_p2_g_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P2_G4_reg_p2_g_koffok(data)                                   (0x00000100&((data)<<8))
+#define P2_G4_reg_p2_g_13(data)                                       (0x000000FF&(data))
+#define P2_G4_get_reg_p2_g_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P2_G4_get_reg_p2_g_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P2_G4_get_reg_p2_g_koffok(data)                               ((0x00000100&(data))>>8)
+#define P2_G4_get_reg_p2_g_13(data)                                   (0x000000FF&(data))
+
+
+#define P2_R1                                                         0xadc
+#define P2_R1_reg_addr                                                "0x98034adc"
+#define P2_R1_reg                                                     0x98034adc
+#define P2_R1_inst_addr                                               "0x02B7"
+#define P2_R1_inst                                                    0x02B7
+#define set_P2_R1_reg(data)                                           (*((volatile unsigned int*)P2_R1_reg)=data)
+#define get_P2_R1_reg                                                 (*((volatile unsigned int*)P2_R1_reg))
+#define P2_R1_reg_p2_r_4_shift                                        (24)
+#define P2_R1_reg_p2_r_3_shift                                        (16)
+#define P2_R1_reg_p2_r_2_shift                                        (8)
+#define P2_R1_reg_p2_r_1_shift                                        (0)
+#define P2_R1_reg_p2_r_4_mask                                         (0xFF000000)
+#define P2_R1_reg_p2_r_3_mask                                         (0x00FF0000)
+#define P2_R1_reg_p2_r_2_mask                                         (0x0000FF00)
+#define P2_R1_reg_p2_r_1_mask                                         (0x000000FF)
+#define P2_R1_reg_p2_r_4(data)                                        (0xFF000000&((data)<<24))
+#define P2_R1_reg_p2_r_3(data)                                        (0x00FF0000&((data)<<16))
+#define P2_R1_reg_p2_r_2(data)                                        (0x0000FF00&((data)<<8))
+#define P2_R1_reg_p2_r_1(data)                                        (0x000000FF&(data))
+#define P2_R1_get_reg_p2_r_4(data)                                    ((0xFF000000&(data))>>24)
+#define P2_R1_get_reg_p2_r_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_R1_get_reg_p2_r_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_R1_get_reg_p2_r_1(data)                                    (0x000000FF&(data))
+
+
+#define P2_R2                                                         0xae0
+#define P2_R2_reg_addr                                                "0x98034ae0"
+#define P2_R2_reg                                                     0x98034ae0
+#define P2_R2_inst_addr                                               "0x02B8"
+#define P2_R2_inst                                                    0x02B8
+#define set_P2_R2_reg(data)                                           (*((volatile unsigned int*)P2_R2_reg)=data)
+#define get_P2_R2_reg                                                 (*((volatile unsigned int*)P2_R2_reg))
+#define P2_R2_reg_p2_r_8_shift                                        (24)
+#define P2_R2_reg_p2_r_7_shift                                        (16)
+#define P2_R2_reg_p2_r_6_shift                                        (8)
+#define P2_R2_reg_p2_r_5_shift                                        (0)
+#define P2_R2_reg_p2_r_8_mask                                         (0xFF000000)
+#define P2_R2_reg_p2_r_7_mask                                         (0x00FF0000)
+#define P2_R2_reg_p2_r_6_mask                                         (0x0000FF00)
+#define P2_R2_reg_p2_r_5_mask                                         (0x000000FF)
+#define P2_R2_reg_p2_r_8(data)                                        (0xFF000000&((data)<<24))
+#define P2_R2_reg_p2_r_7(data)                                        (0x00FF0000&((data)<<16))
+#define P2_R2_reg_p2_r_6(data)                                        (0x0000FF00&((data)<<8))
+#define P2_R2_reg_p2_r_5(data)                                        (0x000000FF&(data))
+#define P2_R2_get_reg_p2_r_8(data)                                    ((0xFF000000&(data))>>24)
+#define P2_R2_get_reg_p2_r_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_R2_get_reg_p2_r_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_R2_get_reg_p2_r_5(data)                                    (0x000000FF&(data))
+
+
+#define P2_R3                                                         0xae4
+#define P2_R3_reg_addr                                                "0x98034ae4"
+#define P2_R3_reg                                                     0x98034ae4
+#define P2_R3_inst_addr                                               "0x02B9"
+#define P2_R3_inst                                                    0x02B9
+#define set_P2_R3_reg(data)                                           (*((volatile unsigned int*)P2_R3_reg)=data)
+#define get_P2_R3_reg                                                 (*((volatile unsigned int*)P2_R3_reg))
+#define P2_R3_reg_p2_r_12_shift                                       (24)
+#define P2_R3_reg_p2_r_11_shift                                       (16)
+#define P2_R3_reg_p2_r_10_shift                                       (8)
+#define P2_R3_reg_p2_r_9_shift                                        (0)
+#define P2_R3_reg_p2_r_12_mask                                        (0xFF000000)
+#define P2_R3_reg_p2_r_11_mask                                        (0x00FF0000)
+#define P2_R3_reg_p2_r_10_mask                                        (0x0000FF00)
+#define P2_R3_reg_p2_r_9_mask                                         (0x000000FF)
+#define P2_R3_reg_p2_r_12(data)                                       (0xFF000000&((data)<<24))
+#define P2_R3_reg_p2_r_11(data)                                       (0x00FF0000&((data)<<16))
+#define P2_R3_reg_p2_r_10(data)                                       (0x0000FF00&((data)<<8))
+#define P2_R3_reg_p2_r_9(data)                                        (0x000000FF&(data))
+#define P2_R3_get_reg_p2_r_12(data)                                   ((0xFF000000&(data))>>24)
+#define P2_R3_get_reg_p2_r_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P2_R3_get_reg_p2_r_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P2_R3_get_reg_p2_r_9(data)                                    (0x000000FF&(data))
+
+
+#define P2_R4                                                         0xae8
+#define P2_R4_reg_addr                                                "0x98034ae8"
+#define P2_R4_reg                                                     0x98034ae8
+#define P2_R4_inst_addr                                               "0x02BA"
+#define P2_R4_inst                                                    0x02BA
+#define set_P2_R4_reg(data)                                           (*((volatile unsigned int*)P2_R4_reg)=data)
+#define get_P2_R4_reg                                                 (*((volatile unsigned int*)P2_R4_reg))
+#define P2_R4_reg_p2_r_koff_sel_shift                                 (10)
+#define P2_R4_reg_p2_r_koff_bound_shift                               (9)
+#define P2_R4_reg_p2_r_koffok_shift                                   (8)
+#define P2_R4_reg_p2_r_13_shift                                       (0)
+#define P2_R4_reg_p2_r_koff_sel_mask                                  (0x00007C00)
+#define P2_R4_reg_p2_r_koff_bound_mask                                (0x00000200)
+#define P2_R4_reg_p2_r_koffok_mask                                    (0x00000100)
+#define P2_R4_reg_p2_r_13_mask                                        (0x000000FF)
+#define P2_R4_reg_p2_r_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P2_R4_reg_p2_r_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P2_R4_reg_p2_r_koffok(data)                                   (0x00000100&((data)<<8))
+#define P2_R4_reg_p2_r_13(data)                                       (0x000000FF&(data))
+#define P2_R4_get_reg_p2_r_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P2_R4_get_reg_p2_r_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P2_R4_get_reg_p2_r_koffok(data)                               ((0x00000100&(data))>>8)
+#define P2_R4_get_reg_p2_r_13(data)                                   (0x000000FF&(data))
+
+
+#define TEST                                                          0xaec
+#define TEST_reg_addr                                                 "0x98034aec"
+#define TEST_reg                                                      0x98034aec
+#define TEST_inst_addr                                                "0x02BB"
+#define TEST_inst                                                     0x02BB
+#define set_TEST_reg(data)                                            (*((volatile unsigned int*)TEST_reg)=data)
+#define get_TEST_reg                                                  (*((volatile unsigned int*)TEST_reg))
+#define TEST_reg_tst_spad_shift                                       (4)
+#define TEST_reg_stst_shift                                           (0)
+#define TEST_reg_tst_spad_mask                                        (0x00000010)
+#define TEST_reg_stst_mask                                            (0x0000000F)
+#define TEST_reg_tst_spad(data)                                       (0x00000010&((data)<<4))
+#define TEST_reg_stst(data)                                           (0x0000000F&(data))
+#define TEST_get_reg_tst_spad(data)                                   ((0x00000010&(data))>>4)
+#define TEST_get_reg_stst(data)                                       (0x0000000F&(data))
+
+
+#define TOP_IN                                                        0xaf0
+#define TOP_IN_reg_addr                                               "0x98034af0"
+#define TOP_IN_reg                                                    0x98034af0
+#define TOP_IN_inst_addr                                              "0x02BC"
+#define TOP_IN_inst                                                   0x02BC
+#define set_TOP_IN_reg(data)                                          (*((volatile unsigned int*)TOP_IN_reg)=data)
+#define get_TOP_IN_reg                                                (*((volatile unsigned int*)TOP_IN_reg))
+#define TOP_IN_reg_top_in_4_shift                                     (24)
+#define TOP_IN_reg_top_in_3_shift                                     (16)
+#define TOP_IN_reg_top_in_2_shift                                     (8)
+#define TOP_IN_reg_top_in_1_shift                                     (0)
+#define TOP_IN_reg_top_in_4_mask                                      (0xFF000000)
+#define TOP_IN_reg_top_in_3_mask                                      (0x00FF0000)
+#define TOP_IN_reg_top_in_2_mask                                      (0x0000FF00)
+#define TOP_IN_reg_top_in_1_mask                                      (0x000000FF)
+#define TOP_IN_reg_top_in_4(data)                                     (0xFF000000&((data)<<24))
+#define TOP_IN_reg_top_in_3(data)                                     (0x00FF0000&((data)<<16))
+#define TOP_IN_reg_top_in_2(data)                                     (0x0000FF00&((data)<<8))
+#define TOP_IN_reg_top_in_1(data)                                     (0x000000FF&(data))
+#define TOP_IN_get_reg_top_in_4(data)                                 ((0xFF000000&(data))>>24)
+#define TOP_IN_get_reg_top_in_3(data)                                 ((0x00FF0000&(data))>>16)
+#define TOP_IN_get_reg_top_in_2(data)                                 ((0x0000FF00&(data))>>8)
+#define TOP_IN_get_reg_top_in_1(data)                                 (0x000000FF&(data))
+
+
+#define TOP_OUT                                                       0xaf4
+#define TOP_OUT_reg_addr                                              "0x98034af4"
+#define TOP_OUT_reg                                                   0x98034af4
+#define TOP_OUT_inst_addr                                             "0x02BD"
+#define TOP_OUT_inst                                                  0x02BD
+#define set_TOP_OUT_reg(data)                                         (*((volatile unsigned int*)TOP_OUT_reg)=data)
+#define get_TOP_OUT_reg                                               (*((volatile unsigned int*)TOP_OUT_reg))
+#define TOP_OUT_reg_top_out_4_shift                                   (24)
+#define TOP_OUT_reg_top_out_3_shift                                   (16)
+#define TOP_OUT_reg_top_out_2_shift                                   (8)
+#define TOP_OUT_reg_top_out_1_shift                                   (0)
+#define TOP_OUT_reg_top_out_4_mask                                    (0xFF000000)
+#define TOP_OUT_reg_top_out_3_mask                                    (0x00FF0000)
+#define TOP_OUT_reg_top_out_2_mask                                    (0x0000FF00)
+#define TOP_OUT_reg_top_out_1_mask                                    (0x000000FF)
+#define TOP_OUT_reg_top_out_4(data)                                   (0xFF000000&((data)<<24))
+#define TOP_OUT_reg_top_out_3(data)                                   (0x00FF0000&((data)<<16))
+#define TOP_OUT_reg_top_out_2(data)                                   (0x0000FF00&((data)<<8))
+#define TOP_OUT_reg_top_out_1(data)                                   (0x000000FF&(data))
+#define TOP_OUT_get_reg_top_out_4(data)                               ((0xFF000000&(data))>>24)
+#define TOP_OUT_get_reg_top_out_3(data)                               ((0x00FF0000&(data))>>16)
+#define TOP_OUT_get_reg_top_out_2(data)                               ((0x0000FF00&(data))>>8)
+#define TOP_OUT_get_reg_top_out_1(data)                               (0x000000FF&(data))
+
+
+#define Z0K                                                           0xaf8
+#define Z0K_reg_addr                                                  "0x98034af8"
+#define Z0K_reg                                                       0x98034af8
+#define Z0K_inst_addr                                                 "0x02BE"
+#define Z0K_inst                                                      0x02BE
+#define set_Z0K_reg(data)                                             (*((volatile unsigned int*)Z0K_reg)=data)
+#define get_Z0K_reg                                                   (*((volatile unsigned int*)Z0K_reg))
+#define Z0K_reg_z0_z0pow_shift                                        (28)
+#define Z0K_reg_z0_stune_shift                                        (27)
+#define Z0K_reg_z0_res_shift                                          (22)
+#define Z0K_reg_z0_ok_shift                                           (21)
+#define Z0K_reg_z0_entst_shift                                        (20)
+#define Z0K_reg_z0_bound_shift                                        (19)
+#define Z0K_reg_z0_adjr_2_shift                                       (14)
+#define Z0K_reg_z0_adjr_1_shift                                       (9)
+#define Z0K_reg_z0_adjr_0_shift                                       (4)
+#define Z0K_reg_z0tst_shift                                           (0)
+#define Z0K_reg_z0_z0pow_mask                                         (0x10000000)
+#define Z0K_reg_z0_stune_mask                                         (0x08000000)
+#define Z0K_reg_z0_res_mask                                           (0x07C00000)
+#define Z0K_reg_z0_ok_mask                                            (0x00200000)
+#define Z0K_reg_z0_entst_mask                                         (0x00100000)
+#define Z0K_reg_z0_bound_mask                                         (0x00080000)
+#define Z0K_reg_z0_adjr_2_mask                                        (0x0007C000)
+#define Z0K_reg_z0_adjr_1_mask                                        (0x00003E00)
+#define Z0K_reg_z0_adjr_0_mask                                        (0x000001F0)
+#define Z0K_reg_z0tst_mask                                            (0x0000000F)
+#define Z0K_reg_z0_z0pow(data)                                        (0x10000000&((data)<<28))
+#define Z0K_reg_z0_stune(data)                                        (0x08000000&((data)<<27))
+#define Z0K_reg_z0_res(data)                                          (0x07C00000&((data)<<22))
+#define Z0K_reg_z0_ok(data)                                           (0x00200000&((data)<<21))
+#define Z0K_reg_z0_entst(data)                                        (0x00100000&((data)<<20))
+#define Z0K_reg_z0_bound(data)                                        (0x00080000&((data)<<19))
+#define Z0K_reg_z0_adjr_2(data)                                       (0x0007C000&((data)<<14))
+#define Z0K_reg_z0_adjr_1(data)                                       (0x00003E00&((data)<<9))
+#define Z0K_reg_z0_adjr_0(data)                                       (0x000001F0&((data)<<4))
+#define Z0K_reg_z0tst(data)                                           (0x0000000F&(data))
+#define Z0K_get_reg_z0_z0pow(data)                                    ((0x10000000&(data))>>28)
+#define Z0K_get_reg_z0_stune(data)                                    ((0x08000000&(data))>>27)
+#define Z0K_get_reg_z0_res(data)                                      ((0x07C00000&(data))>>22)
+#define Z0K_get_reg_z0_ok(data)                                       ((0x00200000&(data))>>21)
+#define Z0K_get_reg_z0_entst(data)                                    ((0x00100000&(data))>>20)
+#define Z0K_get_reg_z0_bound(data)                                    ((0x00080000&(data))>>19)
+#define Z0K_get_reg_z0_adjr_2(data)                                   ((0x0007C000&(data))>>14)
+#define Z0K_get_reg_z0_adjr_1(data)                                   ((0x00003E00&(data))>>9)
+#define Z0K_get_reg_z0_adjr_0(data)                                   ((0x000001F0&(data))>>4)
+#define Z0K_get_reg_z0tst(data)                                       (0x0000000F&(data))
+
+
+#define Z0POW                                                         0xafc
+#define Z0POW_reg_addr                                                "0x98034afc"
+#define Z0POW_reg                                                     0x98034afc
+#define Z0POW_inst_addr                                               "0x02BF"
+#define Z0POW_inst                                                    0x02BF
+#define set_Z0POW_reg(data)                                           (*((volatile unsigned int*)Z0POW_reg)=data)
+#define get_Z0POW_reg                                                 (*((volatile unsigned int*)Z0POW_reg))
+#define Z0POW_reg_ck_pixel_hdmirpt_div2_shift                         (21)
+#define Z0POW_reg_z0_z300_sel_shift                                   (18)
+#define Z0POW_reg_z0_z300pow_shift                                    (15)
+#define Z0POW_reg_z0_z100_en_shift                                    (12)
+#define Z0POW_reg_z0_z0pow_r_shift                                    (9)
+#define Z0POW_reg_z0_z0pow_g_shift                                    (6)
+#define Z0POW_reg_z0_z0pow_ck_shift                                   (3)
+#define Z0POW_reg_z0_z0pow_b_shift                                    (0)
+#define Z0POW_reg_ck_pixel_hdmirpt_div2_mask                          (0x00200000)
+#define Z0POW_reg_z0_z300_sel_mask                                    (0x001C0000)
+#define Z0POW_reg_z0_z300pow_mask                                     (0x00038000)
+#define Z0POW_reg_z0_z100_en_mask                                     (0x00007000)
+#define Z0POW_reg_z0_z0pow_r_mask                                     (0x00000E00)
+#define Z0POW_reg_z0_z0pow_g_mask                                     (0x000001C0)
+#define Z0POW_reg_z0_z0pow_ck_mask                                    (0x00000038)
+#define Z0POW_reg_z0_z0pow_b_mask                                     (0x00000007)
+#define Z0POW_reg_ck_pixel_hdmirpt_div2(data)                         (0x00200000&((data)<<21))
+#define Z0POW_reg_z0_z300_sel(data)                                   (0x001C0000&((data)<<18))
+#define Z0POW_reg_z0_z300pow(data)                                    (0x00038000&((data)<<15))
+#define Z0POW_reg_z0_z100_en(data)                                    (0x00007000&((data)<<12))
+#define Z0POW_reg_z0_z0pow_r(data)                                    (0x00000E00&((data)<<9))
+#define Z0POW_reg_z0_z0pow_g(data)                                    (0x000001C0&((data)<<6))
+#define Z0POW_reg_z0_z0pow_ck(data)                                   (0x00000038&((data)<<3))
+#define Z0POW_reg_z0_z0pow_b(data)                                    (0x00000007&(data))
+#define Z0POW_get_reg_ck_pixel_hdmirpt_div2(data)                     ((0x00200000&(data))>>21)
+#define Z0POW_get_reg_z0_z300_sel(data)                               ((0x001C0000&(data))>>18)
+#define Z0POW_get_reg_z0_z300pow(data)                                ((0x00038000&(data))>>15)
+#define Z0POW_get_reg_z0_z100_en(data)                                ((0x00007000&(data))>>12)
+#define Z0POW_get_reg_z0_z0pow_r(data)                                ((0x00000E00&(data))>>9)
+#define Z0POW_get_reg_z0_z0pow_g(data)                                ((0x000001C0&(data))>>6)
+#define Z0POW_get_reg_z0_z0pow_ck(data)                               ((0x00000038&(data))>>3)
+#define Z0POW_get_reg_z0_z0pow_b(data)                                (0x00000007&(data))
+
+
+#define MBIAS                                                         0xb00
+#define MBIAS_reg_addr                                                "0x98034b00"
+#define MBIAS_reg                                                     0x98034b00
+#define MBIAS_inst_addr                                               "0x02C0"
+#define MBIAS_inst                                                    0x02C0
+#define MBIAS_reg_mbias_en_shift                                      (0)
+#define MBIAS_reg_mbias_en_mask                                       (0x00000001)
+#define MBIAS_reg_mbias_en(data)                                      (0x00000001&(data))
+#define MBIAS_get_reg_mbias_en(data)                                  (0x00000001&(data))
+
+
+#define HDMIRPT                                                       0xb04
+#define HDMIRPT_reg_addr                                              "0x98034b04"
+#define HDMIRPT_reg                                                   0x98034b04
+#define HDMIRPT_inst_addr                                             "0x02C1"
+#define HDMIRPT_inst                                                  0x02C1
+#define HDMIRPT_reg_hdmirpt_ck_div2_shift                             (4)
+#define HDMIRPT_reg_hdmirpt_ck_sel_shift                              (2)
+#define HDMIRPT_reg_hdmirpt_hdmi2_shift                               (1)
+#define HDMIRPT_reg_hdmirpt_en_shift                                  (0)
+#define HDMIRPT_reg_hdmirpt_ck_div2_mask                              (0x00000010)
+#define HDMIRPT_reg_hdmirpt_ck_sel_mask                               (0x0000000C)
+#define HDMIRPT_reg_hdmirpt_hdmi2_mask                                (0x00000002)
+#define HDMIRPT_reg_hdmirpt_en_mask                                   (0x00000001)
+#define HDMIRPT_reg_hdmirpt_ck_div2(data)                             (0x00000010&((data)<<4))
+#define HDMIRPT_reg_hdmirpt_ck_sel(data)                              (0x0000000C&((data)<<2))
+#define HDMIRPT_reg_hdmirpt_hdmi2(data)                               (0x00000002&((data)<<1))
+#define HDMIRPT_reg_hdmirpt_en(data)                                  (0x00000001&(data))
+#define HDMIRPT_get_reg_hdmirpt_ck_div2(data)                         ((0x00000010&(data))>>4)
+#define HDMIRPT_get_reg_hdmirpt_ck_sel(data)                          ((0x0000000C&(data))>>2)
+#define HDMIRPT_get_reg_hdmirpt_hdmi2(data)                           ((0x00000002&(data))>>1)
+#define HDMIRPT_get_reg_hdmirpt_en(data)                              (0x00000001&(data))
+
+
+#define BYPASS                                                        0xb08
+#define BYPASS_reg_addr                                               "0x98034b08"
+#define BYPASS_reg                                                    0x98034b08
+#define BYPASS_inst_addr                                              "0x02C2"
+#define BYPASS_inst                                                   0x02C2
+#define set_BYPASS_reg(data)                                          (*((volatile unsigned int*)BYPASS_reg)=data)
+#define get_BYPASS_reg                                                (*((volatile unsigned int*)BYPASS_reg))
+#define BYPASS_p2_bypass_ok_shift                                     (2)
+#define BYPASS_p1_bypass_ok_shift                                     (1)
+#define BYPASS_p0_bypass_ok_shift                                     (0)
+#define BYPASS_p2_bypass_ok_mask                                      (0x00000004)
+#define BYPASS_p1_bypass_ok_mask                                      (0x00000002)
+#define BYPASS_p0_bypass_ok_mask                                      (0x00000001)
+#define BYPASS_p2_bypass_ok(data)                                     (0x00000004&((data)<<2))
+#define BYPASS_p1_bypass_ok(data)                                     (0x00000002&((data)<<1))
+#define BYPASS_p0_bypass_ok(data)                                     (0x00000001&(data))
+#define BYPASS_get_p2_bypass_ok(data)                                 ((0x00000004&(data))>>2)
+#define BYPASS_get_p1_bypass_ok(data)                                 ((0x00000002&(data))>>1)
+#define BYPASS_get_p0_bypass_ok(data)                                 (0x00000001&(data))
+
+
+#define RST                                                           0xb0c
+#define RST_reg_addr                                                  "0x98034b0c"
+#define RST_reg                                                       0x98034b0c
+#define RST_inst_addr                                                 "0x02C3"
+#define RST_inst                                                      0x02C3
+#define set_RST_reg(data)                                             (*((volatile unsigned int*)RST_reg)=data)
+#define get_RST_reg                                                   (*((volatile unsigned int*)RST_reg))
+#define RST_eye_monitor_rstn_shift                                    (19)
+#define RST_dfe_rstn_n_shift                                          (18)
+#define RST_reg_p2_acdr_rstb_fsm_shift                                (17)
+#define RST_reg_p1_acdr_rstb_fsm_shift                                (16)
+#define RST_reg_p0_acdr_rstb_fsm_shift                                (15)
+#define RST_p2_ck_vcorstb_shift                                       (14)
+#define RST_p1_ck_vcorstb_shift                                       (13)
+#define RST_p0_ck_vcorstb_shift                                       (12)
+#define RST_p2_ck_pllrstb_shift                                       (11)
+#define RST_p1_ck_pllrstb_shift                                       (10)
+#define RST_p0_ck_pllrstb_shift                                       (9)
+#define RST_p2_r_demux_rstb_shift                                     (8)
+#define RST_p2_g_demux_rstb_shift                                     (7)
+#define RST_p2_b_demux_rstb_shift                                     (6)
+#define RST_p1_r_demux_rstb_shift                                     (5)
+#define RST_p1_g_demux_rstb_shift                                     (4)
+#define RST_p1_b_demux_rstb_shift                                     (3)
+#define RST_p0_r_demux_rstb_shift                                     (2)
+#define RST_p0_g_demux_rstb_shift                                     (1)
+#define RST_p0_b_demux_rstb_shift                                     (0)
+#define RST_eye_monitor_rstn_mask                                     (0x00080000)
+#define RST_dfe_rstn_n_mask                                           (0x00040000)
+#define RST_reg_p2_acdr_rstb_fsm_mask                                 (0x00020000)
+#define RST_reg_p1_acdr_rstb_fsm_mask                                 (0x00010000)
+#define RST_reg_p0_acdr_rstb_fsm_mask                                 (0x00008000)
+#define RST_p2_ck_vcorstb_mask                                        (0x00004000)
+#define RST_p1_ck_vcorstb_mask                                        (0x00002000)
+#define RST_p0_ck_vcorstb_mask                                        (0x00001000)
+#define RST_p2_ck_pllrstb_mask                                        (0x00000800)
+#define RST_p1_ck_pllrstb_mask                                        (0x00000400)
+#define RST_p0_ck_pllrstb_mask                                        (0x00000200)
+#define RST_p2_r_demux_rstb_mask                                      (0x00000100)
+#define RST_p2_g_demux_rstb_mask                                      (0x00000080)
+#define RST_p2_b_demux_rstb_mask                                      (0x00000040)
+#define RST_p1_r_demux_rstb_mask                                      (0x00000020)
+#define RST_p1_g_demux_rstb_mask                                      (0x00000010)
+#define RST_p1_b_demux_rstb_mask                                      (0x00000008)
+#define RST_p0_r_demux_rstb_mask                                      (0x00000004)
+#define RST_p0_g_demux_rstb_mask                                      (0x00000002)
+#define RST_p0_b_demux_rstb_mask                                      (0x00000001)
+#define RST_eye_monitor_rstn(data)                                    (0x00080000&((data)<<19))
+#define RST_dfe_rstn_n(data)                                          (0x00040000&((data)<<18))
+#define RST_reg_p2_acdr_rstb_fsm(data)                                (0x00020000&((data)<<17))
+#define RST_reg_p1_acdr_rstb_fsm(data)                                (0x00010000&((data)<<16))
+#define RST_reg_p0_acdr_rstb_fsm(data)                                (0x00008000&((data)<<15))
+#define RST_p2_ck_vcorstb(data)                                       (0x00004000&((data)<<14))
+#define RST_p1_ck_vcorstb(data)                                       (0x00002000&((data)<<13))
+#define RST_p0_ck_vcorstb(data)                                       (0x00001000&((data)<<12))
+#define RST_p2_ck_pllrstb(data)                                       (0x00000800&((data)<<11))
+#define RST_p1_ck_pllrstb(data)                                       (0x00000400&((data)<<10))
+#define RST_p0_ck_pllrstb(data)                                       (0x00000200&((data)<<9))
+#define RST_p2_r_demux_rstb(data)                                     (0x00000100&((data)<<8))
+#define RST_p2_g_demux_rstb(data)                                     (0x00000080&((data)<<7))
+#define RST_p2_b_demux_rstb(data)                                     (0x00000040&((data)<<6))
+#define RST_p1_r_demux_rstb(data)                                     (0x00000020&((data)<<5))
+#define RST_p1_g_demux_rstb(data)                                     (0x00000010&((data)<<4))
+#define RST_p1_b_demux_rstb(data)                                     (0x00000008&((data)<<3))
+#define RST_p0_r_demux_rstb(data)                                     (0x00000004&((data)<<2))
+#define RST_p0_g_demux_rstb(data)                                     (0x00000002&((data)<<1))
+#define RST_p0_b_demux_rstb(data)                                     (0x00000001&(data))
+#define RST_get_eye_monitor_rstn(data)                                ((0x00080000&(data))>>19)
+#define RST_get_dfe_rstn_n(data)                                      ((0x00040000&(data))>>18)
+#define RST_get_reg_p2_acdr_rstb_fsm(data)                            ((0x00020000&(data))>>17)
+#define RST_get_reg_p1_acdr_rstb_fsm(data)                            ((0x00010000&(data))>>16)
+#define RST_get_reg_p0_acdr_rstb_fsm(data)                            ((0x00008000&(data))>>15)
+#define RST_get_p2_ck_vcorstb(data)                                   ((0x00004000&(data))>>14)
+#define RST_get_p1_ck_vcorstb(data)                                   ((0x00002000&(data))>>13)
+#define RST_get_p0_ck_vcorstb(data)                                   ((0x00001000&(data))>>12)
+#define RST_get_p2_ck_pllrstb(data)                                   ((0x00000800&(data))>>11)
+#define RST_get_p1_ck_pllrstb(data)                                   ((0x00000400&(data))>>10)
+#define RST_get_p0_ck_pllrstb(data)                                   ((0x00000200&(data))>>9)
+#define RST_get_p2_r_demux_rstb(data)                                 ((0x00000100&(data))>>8)
+#define RST_get_p2_g_demux_rstb(data)                                 ((0x00000080&(data))>>7)
+#define RST_get_p2_b_demux_rstb(data)                                 ((0x00000040&(data))>>6)
+#define RST_get_p1_r_demux_rstb(data)                                 ((0x00000020&(data))>>5)
+#define RST_get_p1_g_demux_rstb(data)                                 ((0x00000010&(data))>>4)
+#define RST_get_p1_b_demux_rstb(data)                                 ((0x00000008&(data))>>3)
+#define RST_get_p0_r_demux_rstb(data)                                 ((0x00000004&(data))>>2)
+#define RST_get_p0_g_demux_rstb(data)                                 ((0x00000002&(data))>>1)
+#define RST_get_p0_b_demux_rstb(data)                                 (0x00000001&(data))
+
+
+#define REGD0                                                         0xb1c
+#define REGD0_reg_addr                                                "0x98034b1c"
+#define REGD0_reg                                                     0x98034b1c
+#define REGD0_inst_addr                                               "0x02C7"
+#define REGD0_inst                                                    0x02C7
+#define set_REGD0_reg(data)                                           (*((volatile unsigned int*)REGD0_reg)=data)
+#define get_REGD0_reg                                                 (*((volatile unsigned int*)REGD0_reg))
+#define REGD0_p0_r_dig_rst_n_shift                                    (31)
+#define REGD0_p0_g_dig_rst_n_shift                                    (30)
+#define REGD0_p0_b_dig_rst_n_shift                                    (29)
+#define REGD0_p0_r_cdr_rst_n_shift                                    (28)
+#define REGD0_p0_g_cdr_rst_n_shift                                    (27)
+#define REGD0_p0_b_cdr_rst_n_shift                                    (26)
+#define REGD0_reg_p0_cdr_ckinv_r_shift                                (25)
+#define REGD0_reg_p0_cdr_ckinv_g_shift                                (24)
+#define REGD0_reg_p0_cdr_ckinv_b_shift                                (23)
+#define REGD0_reg_p0_shift_inv_r_shift                                (22)
+#define REGD0_reg_p0_shift_inv_g_shift                                (21)
+#define REGD0_reg_p0_shift_inv_b_shift                                (20)
+#define REGD0_reg_p0_rate_sel_shift                                   (17)
+#define REGD0_reg_p0_kd_shift                                         (16)
+#define REGD0_reg_p0_kp_shift                                         (8)
+#define REGD0_reg_p0_ki_shift                                         (5)
+#define REGD0_reg_p0_bypass_sdm_int_shift                             (4)
+#define REGD0_reg_p0_data_order_shift                                 (3)
+#define REGD0_reg_p0_infifo_cnt_shift                                 (0)
+#define REGD0_p0_r_dig_rst_n_mask                                     (0x80000000)
+#define REGD0_p0_g_dig_rst_n_mask                                     (0x40000000)
+#define REGD0_p0_b_dig_rst_n_mask                                     (0x20000000)
+#define REGD0_p0_r_cdr_rst_n_mask                                     (0x10000000)
+#define REGD0_p0_g_cdr_rst_n_mask                                     (0x08000000)
+#define REGD0_p0_b_cdr_rst_n_mask                                     (0x04000000)
+#define REGD0_reg_p0_cdr_ckinv_r_mask                                 (0x02000000)
+#define REGD0_reg_p0_cdr_ckinv_g_mask                                 (0x01000000)
+#define REGD0_reg_p0_cdr_ckinv_b_mask                                 (0x00800000)
+#define REGD0_reg_p0_shift_inv_r_mask                                 (0x00400000)
+#define REGD0_reg_p0_shift_inv_g_mask                                 (0x00200000)
+#define REGD0_reg_p0_shift_inv_b_mask                                 (0x00100000)
+#define REGD0_reg_p0_rate_sel_mask                                    (0x000E0000)
+#define REGD0_reg_p0_kd_mask                                          (0x00010000)
+#define REGD0_reg_p0_kp_mask                                          (0x0000FF00)
+#define REGD0_reg_p0_ki_mask                                          (0x000000E0)
+#define REGD0_reg_p0_bypass_sdm_int_mask                              (0x00000010)
+#define REGD0_reg_p0_data_order_mask                                  (0x00000008)
+#define REGD0_reg_p0_infifo_cnt_mask                                  (0x00000007)
+#define REGD0_p0_r_dig_rst_n(data)                                    (0x80000000&((data)<<31))
+#define REGD0_p0_g_dig_rst_n(data)                                    (0x40000000&((data)<<30))
+#define REGD0_p0_b_dig_rst_n(data)                                    (0x20000000&((data)<<29))
+#define REGD0_p0_r_cdr_rst_n(data)                                    (0x10000000&((data)<<28))
+#define REGD0_p0_g_cdr_rst_n(data)                                    (0x08000000&((data)<<27))
+#define REGD0_p0_b_cdr_rst_n(data)                                    (0x04000000&((data)<<26))
+#define REGD0_reg_p0_cdr_ckinv_r(data)                                (0x02000000&((data)<<25))
+#define REGD0_reg_p0_cdr_ckinv_g(data)                                (0x01000000&((data)<<24))
+#define REGD0_reg_p0_cdr_ckinv_b(data)                                (0x00800000&((data)<<23))
+#define REGD0_reg_p0_shift_inv_r(data)                                (0x00400000&((data)<<22))
+#define REGD0_reg_p0_shift_inv_g(data)                                (0x00200000&((data)<<21))
+#define REGD0_reg_p0_shift_inv_b(data)                                (0x00100000&((data)<<20))
+#define REGD0_reg_p0_rate_sel(data)                                   (0x000E0000&((data)<<17))
+#define REGD0_reg_p0_kd(data)                                         (0x00010000&((data)<<16))
+#define REGD0_reg_p0_kp(data)                                         (0x0000FF00&((data)<<8))
+#define REGD0_reg_p0_ki(data)                                         (0x000000E0&((data)<<5))
+#define REGD0_reg_p0_bypass_sdm_int(data)                             (0x00000010&((data)<<4))
+#define REGD0_reg_p0_data_order(data)                                 (0x00000008&((data)<<3))
+#define REGD0_reg_p0_infifo_cnt(data)                                 (0x00000007&(data))
+#define REGD0_get_p0_r_dig_rst_n(data)                                ((0x80000000&(data))>>31)
+#define REGD0_get_p0_g_dig_rst_n(data)                                ((0x40000000&(data))>>30)
+#define REGD0_get_p0_b_dig_rst_n(data)                                ((0x20000000&(data))>>29)
+#define REGD0_get_p0_r_cdr_rst_n(data)                                ((0x10000000&(data))>>28)
+#define REGD0_get_p0_g_cdr_rst_n(data)                                ((0x08000000&(data))>>27)
+#define REGD0_get_p0_b_cdr_rst_n(data)                                ((0x04000000&(data))>>26)
+#define REGD0_get_reg_p0_cdr_ckinv_r(data)                            ((0x02000000&(data))>>25)
+#define REGD0_get_reg_p0_cdr_ckinv_g(data)                            ((0x01000000&(data))>>24)
+#define REGD0_get_reg_p0_cdr_ckinv_b(data)                            ((0x00800000&(data))>>23)
+#define REGD0_get_reg_p0_shift_inv_r(data)                            ((0x00400000&(data))>>22)
+#define REGD0_get_reg_p0_shift_inv_g(data)                            ((0x00200000&(data))>>21)
+#define REGD0_get_reg_p0_shift_inv_b(data)                            ((0x00100000&(data))>>20)
+#define REGD0_get_reg_p0_rate_sel(data)                               ((0x000E0000&(data))>>17)
+#define REGD0_get_reg_p0_kd(data)                                     ((0x00010000&(data))>>16)
+#define REGD0_get_reg_p0_kp(data)                                     ((0x0000FF00&(data))>>8)
+#define REGD0_get_reg_p0_ki(data)                                     ((0x000000E0&(data))>>5)
+#define REGD0_get_reg_p0_bypass_sdm_int(data)                         ((0x00000010&(data))>>4)
+#define REGD0_get_reg_p0_data_order(data)                             ((0x00000008&(data))>>3)
+#define REGD0_get_reg_p0_infifo_cnt(data)                             (0x00000007&(data))
+
+
+#define REGD1                                                         0xb20
+#define REGD1_reg_addr                                                "0x98034b20"
+#define REGD1_reg                                                     0x98034b20
+#define REGD1_inst_addr                                               "0x02C8"
+#define REGD1_inst                                                    0x02C8
+#define set_REGD1_reg(data)                                           (*((volatile unsigned int*)REGD1_reg)=data)
+#define get_REGD1_reg                                                 (*((volatile unsigned int*)REGD1_reg))
+#define REGD1_reg_p0_int_init_shift                                   (18)
+#define REGD1_reg_p0_acc2_period_shift                                (8)
+#define REGD1_reg_p0_squ_tri_shift                                    (7)
+#define REGD1_reg_p0_acc2_manual_shift                                (6)
+#define REGD1_reg_p0_testout_sel_shift                                (4)
+#define REGD1_reg_p0_ercnt_en_shift                                   (3)
+#define REGD1_reg_p0_edge_out_shift                                   (2)
+#define REGD1_reg_p0_pi_m_mode_shift                                  (1)
+#define REGD1_reg_p0_dyn_kp_en_shift                                  (0)
+#define REGD1_reg_p0_int_init_mask                                    (0xFFFC0000)
+#define REGD1_reg_p0_acc2_period_mask                                 (0x0003FF00)
+#define REGD1_reg_p0_squ_tri_mask                                     (0x00000080)
+#define REGD1_reg_p0_acc2_manual_mask                                 (0x00000040)
+#define REGD1_reg_p0_testout_sel_mask                                 (0x00000030)
+#define REGD1_reg_p0_ercnt_en_mask                                    (0x00000008)
+#define REGD1_reg_p0_edge_out_mask                                    (0x00000004)
+#define REGD1_reg_p0_pi_m_mode_mask                                   (0x00000002)
+#define REGD1_reg_p0_dyn_kp_en_mask                                   (0x00000001)
+#define REGD1_reg_p0_int_init(data)                                   (0xFFFC0000&((data)<<18))
+#define REGD1_reg_p0_acc2_period(data)                                (0x0003FF00&((data)<<8))
+#define REGD1_reg_p0_squ_tri(data)                                    (0x00000080&((data)<<7))
+#define REGD1_reg_p0_acc2_manual(data)                                (0x00000040&((data)<<6))
+#define REGD1_reg_p0_testout_sel(data)                                (0x00000030&((data)<<4))
+#define REGD1_reg_p0_ercnt_en(data)                                   (0x00000008&((data)<<3))
+#define REGD1_reg_p0_edge_out(data)                                   (0x00000004&((data)<<2))
+#define REGD1_reg_p0_pi_m_mode(data)                                  (0x00000002&((data)<<1))
+#define REGD1_reg_p0_dyn_kp_en(data)                                  (0x00000001&(data))
+#define REGD1_get_reg_p0_int_init(data)                               ((0xFFFC0000&(data))>>18)
+#define REGD1_get_reg_p0_acc2_period(data)                            ((0x0003FF00&(data))>>8)
+#define REGD1_get_reg_p0_squ_tri(data)                                ((0x00000080&(data))>>7)
+#define REGD1_get_reg_p0_acc2_manual(data)                            ((0x00000040&(data))>>6)
+#define REGD1_get_reg_p0_testout_sel(data)                            ((0x00000030&(data))>>4)
+#define REGD1_get_reg_p0_ercnt_en(data)                               ((0x00000008&(data))>>3)
+#define REGD1_get_reg_p0_edge_out(data)                               ((0x00000004&(data))>>2)
+#define REGD1_get_reg_p0_pi_m_mode(data)                              ((0x00000002&(data))>>1)
+#define REGD1_get_reg_p0_dyn_kp_en(data)                              (0x00000001&(data))
+
+
+#define REGD2                                                         0xb24
+#define REGD2_reg_addr                                                "0x98034b24"
+#define REGD2_reg                                                     0x98034b24
+#define REGD2_inst_addr                                               "0x02C9"
+#define REGD2_inst                                                    0x02C9
+#define set_REGD2_reg(data)                                           (*((volatile unsigned int*)REGD2_reg)=data)
+#define get_REGD2_reg                                                 (*((volatile unsigned int*)REGD2_reg))
+#define REGD2_reg_p0_en_m_value_shift                                 (28)
+#define REGD2_reg_p0_st_mode_shift                                    (27)
+#define REGD2_reg_p0_timer_lpf_shift                                  (18)
+#define REGD2_reg_p0_timer_eq_shift                                   (13)
+#define REGD2_reg_p0_timer_ber_shift                                  (8)
+#define REGD2_reg_p0_en_m_value_mask                                  (0xF0000000)
+#define REGD2_reg_p0_st_mode_mask                                     (0x08000000)
+#define REGD2_reg_p0_timer_lpf_mask                                   (0x007C0000)
+#define REGD2_reg_p0_timer_eq_mask                                    (0x0003E000)
+#define REGD2_reg_p0_timer_ber_mask                                   (0x00001F00)
+#define REGD2_reg_p0_en_m_value(data)                                 (0xF0000000&((data)<<28))
+#define REGD2_reg_p0_st_mode(data)                                    (0x08000000&((data)<<27))
+#define REGD2_reg_p0_timer_lpf(data)                                  (0x007C0000&((data)<<18))
+#define REGD2_reg_p0_timer_eq(data)                                   (0x0003E000&((data)<<13))
+#define REGD2_reg_p0_timer_ber(data)                                  (0x00001F00&((data)<<8))
+#define REGD2_get_reg_p0_en_m_value(data)                             ((0xF0000000&(data))>>28)
+#define REGD2_get_reg_p0_st_mode(data)                                ((0x08000000&(data))>>27)
+#define REGD2_get_reg_p0_timer_lpf(data)                              ((0x007C0000&(data))>>18)
+#define REGD2_get_reg_p0_timer_eq(data)                               ((0x0003E000&(data))>>13)
+#define REGD2_get_reg_p0_timer_ber(data)                              ((0x00001F00&(data))>>8)
+
+
+#define REGD3                                                         0xb28
+#define REGD3_reg_addr                                                "0x98034b28"
+#define REGD3_reg                                                     0x98034b28
+#define REGD3_inst_addr                                               "0x02CA"
+#define REGD3_inst                                                    0x02CA
+#define set_REGD3_reg(data)                                           (*((volatile unsigned int*)REGD3_reg)=data)
+#define get_REGD3_reg                                                 (*((volatile unsigned int*)REGD3_reg))
+#define REGD3_p0_st_ro_r_shift                                        (24)
+#define REGD3_p0_en_ro_r_shift                                        (20)
+#define REGD3_p0_st_ro_g_shift                                        (14)
+#define REGD3_p0_en_ro_g_shift                                        (10)
+#define REGD3_p0_st_ro_b_shift                                        (4)
+#define REGD3_p0_en_ro_b_shift                                        (0)
+#define REGD3_p0_st_ro_r_mask                                         (0x1F000000)
+#define REGD3_p0_en_ro_r_mask                                         (0x00F00000)
+#define REGD3_p0_st_ro_g_mask                                         (0x0007C000)
+#define REGD3_p0_en_ro_g_mask                                         (0x00003C00)
+#define REGD3_p0_st_ro_b_mask                                         (0x000001F0)
+#define REGD3_p0_en_ro_b_mask                                         (0x0000000F)
+#define REGD3_p0_st_ro_r(data)                                        (0x1F000000&((data)<<24))
+#define REGD3_p0_en_ro_r(data)                                        (0x00F00000&((data)<<20))
+#define REGD3_p0_st_ro_g(data)                                        (0x0007C000&((data)<<14))
+#define REGD3_p0_en_ro_g(data)                                        (0x00003C00&((data)<<10))
+#define REGD3_p0_st_ro_b(data)                                        (0x000001F0&((data)<<4))
+#define REGD3_p0_en_ro_b(data)                                        (0x0000000F&(data))
+#define REGD3_get_p0_st_ro_r(data)                                    ((0x1F000000&(data))>>24)
+#define REGD3_get_p0_en_ro_r(data)                                    ((0x00F00000&(data))>>20)
+#define REGD3_get_p0_st_ro_g(data)                                    ((0x0007C000&(data))>>14)
+#define REGD3_get_p0_en_ro_g(data)                                    ((0x00003C00&(data))>>10)
+#define REGD3_get_p0_st_ro_b(data)                                    ((0x000001F0&(data))>>4)
+#define REGD3_get_p0_en_ro_b(data)                                    (0x0000000F&(data))
+
+
+#define REGD4                                                         0xb2c
+#define REGD4_reg_addr                                                "0x98034b2c"
+#define REGD4_reg                                                     0x98034b2c
+#define REGD4_inst_addr                                               "0x02CB"
+#define REGD4_inst                                                    0x02CB
+#define set_REGD4_reg(data)                                           (*((volatile unsigned int*)REGD4_reg)=data)
+#define get_REGD4_reg                                                 (*((volatile unsigned int*)REGD4_reg))
+#define REGD4_p0_er_count_r_shift                                     (20)
+#define REGD4_p0_er_count_g_shift                                     (10)
+#define REGD4_p0_er_count_b_shift                                     (0)
+#define REGD4_p0_er_count_r_mask                                      (0x3FF00000)
+#define REGD4_p0_er_count_g_mask                                      (0x000FFC00)
+#define REGD4_p0_er_count_b_mask                                      (0x000003FF)
+#define REGD4_p0_er_count_r(data)                                     (0x3FF00000&((data)<<20))
+#define REGD4_p0_er_count_g(data)                                     (0x000FFC00&((data)<<10))
+#define REGD4_p0_er_count_b(data)                                     (0x000003FF&(data))
+#define REGD4_get_p0_er_count_r(data)                                 ((0x3FF00000&(data))>>20)
+#define REGD4_get_p0_er_count_g(data)                                 ((0x000FFC00&(data))>>10)
+#define REGD4_get_p0_er_count_b(data)                                 (0x000003FF&(data))
+
+
+#define REGD5                                                         0xb30
+#define REGD5_reg_addr                                                "0x98034b30"
+#define REGD5_reg                                                     0x98034b30
+#define REGD5_inst_addr                                               "0x02CC"
+#define REGD5_inst                                                    0x02CC
+#define set_REGD5_reg(data)                                           (*((volatile unsigned int*)REGD5_reg)=data)
+#define get_REGD5_reg                                                 (*((volatile unsigned int*)REGD5_reg))
+#define REGD5_p1_r_dig_rst_n_shift                                    (31)
+#define REGD5_p1_g_dig_rst_n_shift                                    (30)
+#define REGD5_p1_b_dig_rst_n_shift                                    (29)
+#define REGD5_p1_r_cdr_rst_n_shift                                    (28)
+#define REGD5_p1_g_cdr_rst_n_shift                                    (27)
+#define REGD5_p1_b_cdr_rst_n_shift                                    (26)
+#define REGD5_reg_p1_cdr_ckinv_r_shift                                (25)
+#define REGD5_reg_p1_cdr_ckinv_g_shift                                (24)
+#define REGD5_reg_p1_cdr_ckinv_b_shift                                (23)
+#define REGD5_reg_p1_shift_inv_r_shift                                (22)
+#define REGD5_reg_p1_shift_inv_g_shift                                (21)
+#define REGD5_reg_p1_shift_inv_b_shift                                (20)
+#define REGD5_reg_p1_rate_sel_shift                                   (17)
+#define REGD5_reg_p1_kd_shift                                         (16)
+#define REGD5_reg_p1_kp_shift                                         (8)
+#define REGD5_reg_p1_ki_shift                                         (5)
+#define REGD5_reg_p1_bypass_sdm_int_shift                             (4)
+#define REGD5_reg_p1_data_order_shift                                 (3)
+#define REGD5_reg_p1_infifo_cnt_shift                                 (0)
+#define REGD5_p1_r_dig_rst_n_mask                                     (0x80000000)
+#define REGD5_p1_g_dig_rst_n_mask                                     (0x40000000)
+#define REGD5_p1_b_dig_rst_n_mask                                     (0x20000000)
+#define REGD5_p1_r_cdr_rst_n_mask                                     (0x10000000)
+#define REGD5_p1_g_cdr_rst_n_mask                                     (0x08000000)
+#define REGD5_p1_b_cdr_rst_n_mask                                     (0x04000000)
+#define REGD5_reg_p1_cdr_ckinv_r_mask                                 (0x02000000)
+#define REGD5_reg_p1_cdr_ckinv_g_mask                                 (0x01000000)
+#define REGD5_reg_p1_cdr_ckinv_b_mask                                 (0x00800000)
+#define REGD5_reg_p1_shift_inv_r_mask                                 (0x00400000)
+#define REGD5_reg_p1_shift_inv_g_mask                                 (0x00200000)
+#define REGD5_reg_p1_shift_inv_b_mask                                 (0x00100000)
+#define REGD5_reg_p1_rate_sel_mask                                    (0x000E0000)
+#define REGD5_reg_p1_kd_mask                                          (0x00010000)
+#define REGD5_reg_p1_kp_mask                                          (0x0000FF00)
+#define REGD5_reg_p1_ki_mask                                          (0x000000E0)
+#define REGD5_reg_p1_bypass_sdm_int_mask                              (0x00000010)
+#define REGD5_reg_p1_data_order_mask                                  (0x00000008)
+#define REGD5_reg_p1_infifo_cnt_mask                                  (0x00000007)
+#define REGD5_p1_r_dig_rst_n(data)                                    (0x80000000&((data)<<31))
+#define REGD5_p1_g_dig_rst_n(data)                                    (0x40000000&((data)<<30))
+#define REGD5_p1_b_dig_rst_n(data)                                    (0x20000000&((data)<<29))
+#define REGD5_p1_r_cdr_rst_n(data)                                    (0x10000000&((data)<<28))
+#define REGD5_p1_g_cdr_rst_n(data)                                    (0x08000000&((data)<<27))
+#define REGD5_p1_b_cdr_rst_n(data)                                    (0x04000000&((data)<<26))
+#define REGD5_reg_p1_cdr_ckinv_r(data)                                (0x02000000&((data)<<25))
+#define REGD5_reg_p1_cdr_ckinv_g(data)                                (0x01000000&((data)<<24))
+#define REGD5_reg_p1_cdr_ckinv_b(data)                                (0x00800000&((data)<<23))
+#define REGD5_reg_p1_shift_inv_r(data)                                (0x00400000&((data)<<22))
+#define REGD5_reg_p1_shift_inv_g(data)                                (0x00200000&((data)<<21))
+#define REGD5_reg_p1_shift_inv_b(data)                                (0x00100000&((data)<<20))
+#define REGD5_reg_p1_rate_sel(data)                                   (0x000E0000&((data)<<17))
+#define REGD5_reg_p1_kd(data)                                         (0x00010000&((data)<<16))
+#define REGD5_reg_p1_kp(data)                                         (0x0000FF00&((data)<<8))
+#define REGD5_reg_p1_ki(data)                                         (0x000000E0&((data)<<5))
+#define REGD5_reg_p1_bypass_sdm_int(data)                             (0x00000010&((data)<<4))
+#define REGD5_reg_p1_data_order(data)                                 (0x00000008&((data)<<3))
+#define REGD5_reg_p1_infifo_cnt(data)                                 (0x00000007&(data))
+#define REGD5_get_p1_r_dig_rst_n(data)                                ((0x80000000&(data))>>31)
+#define REGD5_get_p1_g_dig_rst_n(data)                                ((0x40000000&(data))>>30)
+#define REGD5_get_p1_b_dig_rst_n(data)                                ((0x20000000&(data))>>29)
+#define REGD5_get_p1_r_cdr_rst_n(data)                                ((0x10000000&(data))>>28)
+#define REGD5_get_p1_g_cdr_rst_n(data)                                ((0x08000000&(data))>>27)
+#define REGD5_get_p1_b_cdr_rst_n(data)                                ((0x04000000&(data))>>26)
+#define REGD5_get_reg_p1_cdr_ckinv_r(data)                            ((0x02000000&(data))>>25)
+#define REGD5_get_reg_p1_cdr_ckinv_g(data)                            ((0x01000000&(data))>>24)
+#define REGD5_get_reg_p1_cdr_ckinv_b(data)                            ((0x00800000&(data))>>23)
+#define REGD5_get_reg_p1_shift_inv_r(data)                            ((0x00400000&(data))>>22)
+#define REGD5_get_reg_p1_shift_inv_g(data)                            ((0x00200000&(data))>>21)
+#define REGD5_get_reg_p1_shift_inv_b(data)                            ((0x00100000&(data))>>20)
+#define REGD5_get_reg_p1_rate_sel(data)                               ((0x000E0000&(data))>>17)
+#define REGD5_get_reg_p1_kd(data)                                     ((0x00010000&(data))>>16)
+#define REGD5_get_reg_p1_kp(data)                                     ((0x0000FF00&(data))>>8)
+#define REGD5_get_reg_p1_ki(data)                                     ((0x000000E0&(data))>>5)
+#define REGD5_get_reg_p1_bypass_sdm_int(data)                         ((0x00000010&(data))>>4)
+#define REGD5_get_reg_p1_data_order(data)                             ((0x00000008&(data))>>3)
+#define REGD5_get_reg_p1_infifo_cnt(data)                             (0x00000007&(data))
+
+
+#define REGD6                                                         0xb34
+#define REGD6_reg_addr                                                "0x98034b34"
+#define REGD6_reg                                                     0x98034b34
+#define REGD6_inst_addr                                               "0x02CD"
+#define REGD6_inst                                                    0x02CD
+#define set_REGD6_reg(data)                                           (*((volatile unsigned int*)REGD6_reg)=data)
+#define get_REGD6_reg                                                 (*((volatile unsigned int*)REGD6_reg))
+#define REGD6_reg_p1_int_init_shift                                   (18)
+#define REGD6_reg_p1_acc2_period_shift                                (8)
+#define REGD6_reg_p1_squ_tri_shift                                    (7)
+#define REGD6_reg_p1_acc2_manual_shift                                (6)
+#define REGD6_reg_p1_testout_sel_shift                                (4)
+#define REGD6_reg_p1_ercnt_en_shift                                   (3)
+#define REGD6_reg_p1_edge_out_shift                                   (2)
+#define REGD6_reg_p1_pi_m_mode_shift                                  (1)
+#define REGD6_reg_p1_dyn_kp_en_shift                                  (0)
+#define REGD6_reg_p1_int_init_mask                                    (0xFFFC0000)
+#define REGD6_reg_p1_acc2_period_mask                                 (0x0003FF00)
+#define REGD6_reg_p1_squ_tri_mask                                     (0x00000080)
+#define REGD6_reg_p1_acc2_manual_mask                                 (0x00000040)
+#define REGD6_reg_p1_testout_sel_mask                                 (0x00000030)
+#define REGD6_reg_p1_ercnt_en_mask                                    (0x00000008)
+#define REGD6_reg_p1_edge_out_mask                                    (0x00000004)
+#define REGD6_reg_p1_pi_m_mode_mask                                   (0x00000002)
+#define REGD6_reg_p1_dyn_kp_en_mask                                   (0x00000001)
+#define REGD6_reg_p1_int_init(data)                                   (0xFFFC0000&((data)<<18))
+#define REGD6_reg_p1_acc2_period(data)                                (0x0003FF00&((data)<<8))
+#define REGD6_reg_p1_squ_tri(data)                                    (0x00000080&((data)<<7))
+#define REGD6_reg_p1_acc2_manual(data)                                (0x00000040&((data)<<6))
+#define REGD6_reg_p1_testout_sel(data)                                (0x00000030&((data)<<4))
+#define REGD6_reg_p1_ercnt_en(data)                                   (0x00000008&((data)<<3))
+#define REGD6_reg_p1_edge_out(data)                                   (0x00000004&((data)<<2))
+#define REGD6_reg_p1_pi_m_mode(data)                                  (0x00000002&((data)<<1))
+#define REGD6_reg_p1_dyn_kp_en(data)                                  (0x00000001&(data))
+#define REGD6_get_reg_p1_int_init(data)                               ((0xFFFC0000&(data))>>18)
+#define REGD6_get_reg_p1_acc2_period(data)                            ((0x0003FF00&(data))>>8)
+#define REGD6_get_reg_p1_squ_tri(data)                                ((0x00000080&(data))>>7)
+#define REGD6_get_reg_p1_acc2_manual(data)                            ((0x00000040&(data))>>6)
+#define REGD6_get_reg_p1_testout_sel(data)                            ((0x00000030&(data))>>4)
+#define REGD6_get_reg_p1_ercnt_en(data)                               ((0x00000008&(data))>>3)
+#define REGD6_get_reg_p1_edge_out(data)                               ((0x00000004&(data))>>2)
+#define REGD6_get_reg_p1_pi_m_mode(data)                              ((0x00000002&(data))>>1)
+#define REGD6_get_reg_p1_dyn_kp_en(data)                              (0x00000001&(data))
+
+
+#define REGD7                                                         0xb38
+#define REGD7_reg_addr                                                "0x98034b38"
+#define REGD7_reg                                                     0x98034b38
+#define REGD7_inst_addr                                               "0x02CE"
+#define REGD7_inst                                                    0x02CE
+#define set_REGD7_reg(data)                                           (*((volatile unsigned int*)REGD7_reg)=data)
+#define get_REGD7_reg                                                 (*((volatile unsigned int*)REGD7_reg))
+#define REGD7_reg_p1_en_m_value_shift                                 (28)
+#define REGD7_reg_p1_st_mode_shift                                    (27)
+#define REGD7_reg_p1_timer_lpf_shift                                  (18)
+#define REGD7_reg_p1_timer_eq_shift                                   (13)
+#define REGD7_reg_p1_timer_ber_shift                                  (8)
+#define REGD7_reg_p1_en_m_value_mask                                  (0xF0000000)
+#define REGD7_reg_p1_st_mode_mask                                     (0x08000000)
+#define REGD7_reg_p1_timer_lpf_mask                                   (0x007C0000)
+#define REGD7_reg_p1_timer_eq_mask                                    (0x0003E000)
+#define REGD7_reg_p1_timer_ber_mask                                   (0x00001F00)
+#define REGD7_reg_p1_en_m_value(data)                                 (0xF0000000&((data)<<28))
+#define REGD7_reg_p1_st_mode(data)                                    (0x08000000&((data)<<27))
+#define REGD7_reg_p1_timer_lpf(data)                                  (0x007C0000&((data)<<18))
+#define REGD7_reg_p1_timer_eq(data)                                   (0x0003E000&((data)<<13))
+#define REGD7_reg_p1_timer_ber(data)                                  (0x00001F00&((data)<<8))
+#define REGD7_get_reg_p1_en_m_value(data)                             ((0xF0000000&(data))>>28)
+#define REGD7_get_reg_p1_st_mode(data)                                ((0x08000000&(data))>>27)
+#define REGD7_get_reg_p1_timer_lpf(data)                              ((0x007C0000&(data))>>18)
+#define REGD7_get_reg_p1_timer_eq(data)                               ((0x0003E000&(data))>>13)
+#define REGD7_get_reg_p1_timer_ber(data)                              ((0x00001F00&(data))>>8)
+
+
+#define REGD8                                                         0xb3c
+#define REGD8_reg_addr                                                "0x98034b3c"
+#define REGD8_reg                                                     0x98034b3c
+#define REGD8_inst_addr                                               "0x02CF"
+#define REGD8_inst                                                    0x02CF
+#define set_REGD8_reg(data)                                           (*((volatile unsigned int*)REGD8_reg)=data)
+#define get_REGD8_reg                                                 (*((volatile unsigned int*)REGD8_reg))
+#define REGD8_p1_st_ro_r_shift                                        (24)
+#define REGD8_p1_en_ro_r_shift                                        (20)
+#define REGD8_p1_st_ro_g_shift                                        (14)
+#define REGD8_p1_en_ro_g_shift                                        (10)
+#define REGD8_p1_st_ro_b_shift                                        (4)
+#define REGD8_p1_en_ro_b_shift                                        (0)
+#define REGD8_p1_st_ro_r_mask                                         (0x1F000000)
+#define REGD8_p1_en_ro_r_mask                                         (0x00F00000)
+#define REGD8_p1_st_ro_g_mask                                         (0x0007C000)
+#define REGD8_p1_en_ro_g_mask                                         (0x00003C00)
+#define REGD8_p1_st_ro_b_mask                                         (0x000001F0)
+#define REGD8_p1_en_ro_b_mask                                         (0x0000000F)
+#define REGD8_p1_st_ro_r(data)                                        (0x1F000000&((data)<<24))
+#define REGD8_p1_en_ro_r(data)                                        (0x00F00000&((data)<<20))
+#define REGD8_p1_st_ro_g(data)                                        (0x0007C000&((data)<<14))
+#define REGD8_p1_en_ro_g(data)                                        (0x00003C00&((data)<<10))
+#define REGD8_p1_st_ro_b(data)                                        (0x000001F0&((data)<<4))
+#define REGD8_p1_en_ro_b(data)                                        (0x0000000F&(data))
+#define REGD8_get_p1_st_ro_r(data)                                    ((0x1F000000&(data))>>24)
+#define REGD8_get_p1_en_ro_r(data)                                    ((0x00F00000&(data))>>20)
+#define REGD8_get_p1_st_ro_g(data)                                    ((0x0007C000&(data))>>14)
+#define REGD8_get_p1_en_ro_g(data)                                    ((0x00003C00&(data))>>10)
+#define REGD8_get_p1_st_ro_b(data)                                    ((0x000001F0&(data))>>4)
+#define REGD8_get_p1_en_ro_b(data)                                    (0x0000000F&(data))
+
+
+#define REGD9                                                         0xb40
+#define REGD9_reg_addr                                                "0x98034b40"
+#define REGD9_reg                                                     0x98034b40
+#define REGD9_inst_addr                                               "0x02D0"
+#define REGD9_inst                                                    0x02D0
+#define set_REGD9_reg(data)                                           (*((volatile unsigned int*)REGD9_reg)=data)
+#define get_REGD9_reg                                                 (*((volatile unsigned int*)REGD9_reg))
+#define REGD9_p1_er_count_r_shift                                     (20)
+#define REGD9_p1_er_count_g_shift                                     (10)
+#define REGD9_p1_er_count_b_shift                                     (0)
+#define REGD9_p1_er_count_r_mask                                      (0x3FF00000)
+#define REGD9_p1_er_count_g_mask                                      (0x000FFC00)
+#define REGD9_p1_er_count_b_mask                                      (0x000003FF)
+#define REGD9_p1_er_count_r(data)                                     (0x3FF00000&((data)<<20))
+#define REGD9_p1_er_count_g(data)                                     (0x000FFC00&((data)<<10))
+#define REGD9_p1_er_count_b(data)                                     (0x000003FF&(data))
+#define REGD9_get_p1_er_count_r(data)                                 ((0x3FF00000&(data))>>20)
+#define REGD9_get_p1_er_count_g(data)                                 ((0x000FFC00&(data))>>10)
+#define REGD9_get_p1_er_count_b(data)                                 (0x000003FF&(data))
+
+
+#define REGD10                                                        0xb44
+#define REGD10_reg_addr                                               "0x98034b44"
+#define REGD10_reg                                                    0x98034b44
+#define REGD10_inst_addr                                              "0x02D1"
+#define REGD10_inst                                                   0x02D1
+#define set_REGD10_reg(data)                                          (*((volatile unsigned int*)REGD10_reg)=data)
+#define get_REGD10_reg                                                (*((volatile unsigned int*)REGD10_reg))
+#define REGD10_p2_r_dig_rst_n_shift                                   (31)
+#define REGD10_p2_g_dig_rst_n_shift                                   (30)
+#define REGD10_p2_b_dig_rst_n_shift                                   (29)
+#define REGD10_p2_r_cdr_rst_n_shift                                   (28)
+#define REGD10_p2_g_cdr_rst_n_shift                                   (27)
+#define REGD10_p2_b_cdr_rst_n_shift                                   (26)
+#define REGD10_reg_p2_cdr_ckinv_r_shift                               (25)
+#define REGD10_reg_p2_cdr_ckinv_g_shift                               (24)
+#define REGD10_reg_p2_cdr_ckinv_b_shift                               (23)
+#define REGD10_reg_p2_shift_inv_r_shift                               (22)
+#define REGD10_reg_p2_shift_inv_g_shift                               (21)
+#define REGD10_reg_p2_shift_inv_b_shift                               (20)
+#define REGD10_reg_p2_rate_sel_shift                                  (17)
+#define REGD10_reg_p2_kd_shift                                        (16)
+#define REGD10_reg_p2_kp_shift                                        (8)
+#define REGD10_reg_p2_ki_shift                                        (5)
+#define REGD10_reg_p2_bypass_sdm_int_shift                            (4)
+#define REGD10_reg_p2_data_order_shift                                (3)
+#define REGD10_reg_p2_infifo_cnt_shift                                (0)
+#define REGD10_p2_r_dig_rst_n_mask                                    (0x80000000)
+#define REGD10_p2_g_dig_rst_n_mask                                    (0x40000000)
+#define REGD10_p2_b_dig_rst_n_mask                                    (0x20000000)
+#define REGD10_p2_r_cdr_rst_n_mask                                    (0x10000000)
+#define REGD10_p2_g_cdr_rst_n_mask                                    (0x08000000)
+#define REGD10_p2_b_cdr_rst_n_mask                                    (0x04000000)
+#define REGD10_reg_p2_cdr_ckinv_r_mask                                (0x02000000)
+#define REGD10_reg_p2_cdr_ckinv_g_mask                                (0x01000000)
+#define REGD10_reg_p2_cdr_ckinv_b_mask                                (0x00800000)
+#define REGD10_reg_p2_shift_inv_r_mask                                (0x00400000)
+#define REGD10_reg_p2_shift_inv_g_mask                                (0x00200000)
+#define REGD10_reg_p2_shift_inv_b_mask                                (0x00100000)
+#define REGD10_reg_p2_rate_sel_mask                                   (0x000E0000)
+#define REGD10_reg_p2_kd_mask                                         (0x00010000)
+#define REGD10_reg_p2_kp_mask                                         (0x0000FF00)
+#define REGD10_reg_p2_ki_mask                                         (0x000000E0)
+#define REGD10_reg_p2_bypass_sdm_int_mask                             (0x00000010)
+#define REGD10_reg_p2_data_order_mask                                 (0x00000008)
+#define REGD10_reg_p2_infifo_cnt_mask                                 (0x00000007)
+#define REGD10_p2_r_dig_rst_n(data)                                   (0x80000000&((data)<<31))
+#define REGD10_p2_g_dig_rst_n(data)                                   (0x40000000&((data)<<30))
+#define REGD10_p2_b_dig_rst_n(data)                                   (0x20000000&((data)<<29))
+#define REGD10_p2_r_cdr_rst_n(data)                                   (0x10000000&((data)<<28))
+#define REGD10_p2_g_cdr_rst_n(data)                                   (0x08000000&((data)<<27))
+#define REGD10_p2_b_cdr_rst_n(data)                                   (0x04000000&((data)<<26))
+#define REGD10_reg_p2_cdr_ckinv_r(data)                               (0x02000000&((data)<<25))
+#define REGD10_reg_p2_cdr_ckinv_g(data)                               (0x01000000&((data)<<24))
+#define REGD10_reg_p2_cdr_ckinv_b(data)                               (0x00800000&((data)<<23))
+#define REGD10_reg_p2_shift_inv_r(data)                               (0x00400000&((data)<<22))
+#define REGD10_reg_p2_shift_inv_g(data)                               (0x00200000&((data)<<21))
+#define REGD10_reg_p2_shift_inv_b(data)                               (0x00100000&((data)<<20))
+#define REGD10_reg_p2_rate_sel(data)                                  (0x000E0000&((data)<<17))
+#define REGD10_reg_p2_kd(data)                                        (0x00010000&((data)<<16))
+#define REGD10_reg_p2_kp(data)                                        (0x0000FF00&((data)<<8))
+#define REGD10_reg_p2_ki(data)                                        (0x000000E0&((data)<<5))
+#define REGD10_reg_p2_bypass_sdm_int(data)                            (0x00000010&((data)<<4))
+#define REGD10_reg_p2_data_order(data)                                (0x00000008&((data)<<3))
+#define REGD10_reg_p2_infifo_cnt(data)                                (0x00000007&(data))
+#define REGD10_get_p2_r_dig_rst_n(data)                               ((0x80000000&(data))>>31)
+#define REGD10_get_p2_g_dig_rst_n(data)                               ((0x40000000&(data))>>30)
+#define REGD10_get_p2_b_dig_rst_n(data)                               ((0x20000000&(data))>>29)
+#define REGD10_get_p2_r_cdr_rst_n(data)                               ((0x10000000&(data))>>28)
+#define REGD10_get_p2_g_cdr_rst_n(data)                               ((0x08000000&(data))>>27)
+#define REGD10_get_p2_b_cdr_rst_n(data)                               ((0x04000000&(data))>>26)
+#define REGD10_get_reg_p2_cdr_ckinv_r(data)                           ((0x02000000&(data))>>25)
+#define REGD10_get_reg_p2_cdr_ckinv_g(data)                           ((0x01000000&(data))>>24)
+#define REGD10_get_reg_p2_cdr_ckinv_b(data)                           ((0x00800000&(data))>>23)
+#define REGD10_get_reg_p2_shift_inv_r(data)                           ((0x00400000&(data))>>22)
+#define REGD10_get_reg_p2_shift_inv_g(data)                           ((0x00200000&(data))>>21)
+#define REGD10_get_reg_p2_shift_inv_b(data)                           ((0x00100000&(data))>>20)
+#define REGD10_get_reg_p2_rate_sel(data)                              ((0x000E0000&(data))>>17)
+#define REGD10_get_reg_p2_kd(data)                                    ((0x00010000&(data))>>16)
+#define REGD10_get_reg_p2_kp(data)                                    ((0x0000FF00&(data))>>8)
+#define REGD10_get_reg_p2_ki(data)                                    ((0x000000E0&(data))>>5)
+#define REGD10_get_reg_p2_bypass_sdm_int(data)                        ((0x00000010&(data))>>4)
+#define REGD10_get_reg_p2_data_order(data)                            ((0x00000008&(data))>>3)
+#define REGD10_get_reg_p2_infifo_cnt(data)                            (0x00000007&(data))
+
+
+#define REGD11                                                        0xb48
+#define REGD11_reg_addr                                               "0x98034b48"
+#define REGD11_reg                                                    0x98034b48
+#define REGD11_inst_addr                                              "0x02D2"
+#define REGD11_inst                                                   0x02D2
+#define set_REGD11_reg(data)                                          (*((volatile unsigned int*)REGD11_reg)=data)
+#define get_REGD11_reg                                                (*((volatile unsigned int*)REGD11_reg))
+#define REGD11_reg_p2_int_init_shift                                  (18)
+#define REGD11_reg_p2_acc2_period_shift                               (8)
+#define REGD11_reg_p2_squ_tri_shift                                   (7)
+#define REGD11_reg_p2_acc2_manual_shift                               (6)
+#define REGD11_reg_p2_testout_sel_shift                               (4)
+#define REGD11_reg_p2_ercnt_en_shift                                  (3)
+#define REGD11_reg_p2_edge_out_shift                                  (2)
+#define REGD11_reg_p2_pi_m_mode_shift                                 (1)
+#define REGD11_reg_p2_dyn_kp_en_shift                                 (0)
+#define REGD11_reg_p2_int_init_mask                                   (0xFFFC0000)
+#define REGD11_reg_p2_acc2_period_mask                                (0x0003FF00)
+#define REGD11_reg_p2_squ_tri_mask                                    (0x00000080)
+#define REGD11_reg_p2_acc2_manual_mask                                (0x00000040)
+#define REGD11_reg_p2_testout_sel_mask                                (0x00000030)
+#define REGD11_reg_p2_ercnt_en_mask                                   (0x00000008)
+#define REGD11_reg_p2_edge_out_mask                                   (0x00000004)
+#define REGD11_reg_p2_pi_m_mode_mask                                  (0x00000002)
+#define REGD11_reg_p2_dyn_kp_en_mask                                  (0x00000001)
+#define REGD11_reg_p2_int_init(data)                                  (0xFFFC0000&((data)<<18))
+#define REGD11_reg_p2_acc2_period(data)                               (0x0003FF00&((data)<<8))
+#define REGD11_reg_p2_squ_tri(data)                                   (0x00000080&((data)<<7))
+#define REGD11_reg_p2_acc2_manual(data)                               (0x00000040&((data)<<6))
+#define REGD11_reg_p2_testout_sel(data)                               (0x00000030&((data)<<4))
+#define REGD11_reg_p2_ercnt_en(data)                                  (0x00000008&((data)<<3))
+#define REGD11_reg_p2_edge_out(data)                                  (0x00000004&((data)<<2))
+#define REGD11_reg_p2_pi_m_mode(data)                                 (0x00000002&((data)<<1))
+#define REGD11_reg_p2_dyn_kp_en(data)                                 (0x00000001&(data))
+#define REGD11_get_reg_p2_int_init(data)                              ((0xFFFC0000&(data))>>18)
+#define REGD11_get_reg_p2_acc2_period(data)                           ((0x0003FF00&(data))>>8)
+#define REGD11_get_reg_p2_squ_tri(data)                               ((0x00000080&(data))>>7)
+#define REGD11_get_reg_p2_acc2_manual(data)                           ((0x00000040&(data))>>6)
+#define REGD11_get_reg_p2_testout_sel(data)                           ((0x00000030&(data))>>4)
+#define REGD11_get_reg_p2_ercnt_en(data)                              ((0x00000008&(data))>>3)
+#define REGD11_get_reg_p2_edge_out(data)                              ((0x00000004&(data))>>2)
+#define REGD11_get_reg_p2_pi_m_mode(data)                             ((0x00000002&(data))>>1)
+#define REGD11_get_reg_p2_dyn_kp_en(data)                             (0x00000001&(data))
+
+
+#define REGD12                                                        0xb4c
+#define REGD12_reg_addr                                               "0x98034b4c"
+#define REGD12_reg                                                    0x98034b4c
+#define REGD12_inst_addr                                              "0x02D3"
+#define REGD12_inst                                                   0x02D3
+#define set_REGD12_reg(data)                                          (*((volatile unsigned int*)REGD12_reg)=data)
+#define get_REGD12_reg                                                (*((volatile unsigned int*)REGD12_reg))
+#define REGD12_reg_p2_en_m_value_shift                                (28)
+#define REGD12_reg_p2_st_mode_shift                                   (27)
+#define REGD12_reg_p2_timer_lpf_shift                                 (18)
+#define REGD12_reg_p2_timer_eq_shift                                  (13)
+#define REGD12_reg_p2_timer_ber_shift                                 (8)
+#define REGD12_reg_p2_en_m_value_mask                                 (0xF0000000)
+#define REGD12_reg_p2_st_mode_mask                                    (0x08000000)
+#define REGD12_reg_p2_timer_lpf_mask                                  (0x007C0000)
+#define REGD12_reg_p2_timer_eq_mask                                   (0x0003E000)
+#define REGD12_reg_p2_timer_ber_mask                                  (0x00001F00)
+#define REGD12_reg_p2_en_m_value(data)                                (0xF0000000&((data)<<28))
+#define REGD12_reg_p2_st_mode(data)                                   (0x08000000&((data)<<27))
+#define REGD12_reg_p2_timer_lpf(data)                                 (0x007C0000&((data)<<18))
+#define REGD12_reg_p2_timer_eq(data)                                  (0x0003E000&((data)<<13))
+#define REGD12_reg_p2_timer_ber(data)                                 (0x00001F00&((data)<<8))
+#define REGD12_get_reg_p2_en_m_value(data)                            ((0xF0000000&(data))>>28)
+#define REGD12_get_reg_p2_st_mode(data)                               ((0x08000000&(data))>>27)
+#define REGD12_get_reg_p2_timer_lpf(data)                             ((0x007C0000&(data))>>18)
+#define REGD12_get_reg_p2_timer_eq(data)                              ((0x0003E000&(data))>>13)
+#define REGD12_get_reg_p2_timer_ber(data)                             ((0x00001F00&(data))>>8)
+
+
+#define REGD13                                                        0xb50
+#define REGD13_reg_addr                                               "0x98034b50"
+#define REGD13_reg                                                    0x98034b50
+#define REGD13_inst_addr                                              "0x02D4"
+#define REGD13_inst                                                   0x02D4
+#define set_REGD13_reg(data)                                          (*((volatile unsigned int*)REGD13_reg)=data)
+#define get_REGD13_reg                                                (*((volatile unsigned int*)REGD13_reg))
+#define REGD13_p2_st_ro_r_shift                                       (24)
+#define REGD13_p2_en_ro_r_shift                                       (20)
+#define REGD13_p2_st_ro_g_shift                                       (14)
+#define REGD13_p2_en_ro_g_shift                                       (10)
+#define REGD13_p2_st_ro_b_shift                                       (4)
+#define REGD13_p2_en_ro_b_shift                                       (0)
+#define REGD13_p2_st_ro_r_mask                                        (0x1F000000)
+#define REGD13_p2_en_ro_r_mask                                        (0x00F00000)
+#define REGD13_p2_st_ro_g_mask                                        (0x0007C000)
+#define REGD13_p2_en_ro_g_mask                                        (0x00003C00)
+#define REGD13_p2_st_ro_b_mask                                        (0x000001F0)
+#define REGD13_p2_en_ro_b_mask                                        (0x0000000F)
+#define REGD13_p2_st_ro_r(data)                                       (0x1F000000&((data)<<24))
+#define REGD13_p2_en_ro_r(data)                                       (0x00F00000&((data)<<20))
+#define REGD13_p2_st_ro_g(data)                                       (0x0007C000&((data)<<14))
+#define REGD13_p2_en_ro_g(data)                                       (0x00003C00&((data)<<10))
+#define REGD13_p2_st_ro_b(data)                                       (0x000001F0&((data)<<4))
+#define REGD13_p2_en_ro_b(data)                                       (0x0000000F&(data))
+#define REGD13_get_p2_st_ro_r(data)                                   ((0x1F000000&(data))>>24)
+#define REGD13_get_p2_en_ro_r(data)                                   ((0x00F00000&(data))>>20)
+#define REGD13_get_p2_st_ro_g(data)                                   ((0x0007C000&(data))>>14)
+#define REGD13_get_p2_en_ro_g(data)                                   ((0x00003C00&(data))>>10)
+#define REGD13_get_p2_st_ro_b(data)                                   ((0x000001F0&(data))>>4)
+#define REGD13_get_p2_en_ro_b(data)                                   (0x0000000F&(data))
+
+
+#define REGD14                                                        0xb54
+#define REGD14_reg_addr                                               "0x98034b54"
+#define REGD14_reg                                                    0x98034b54
+#define REGD14_inst_addr                                              "0x02D5"
+#define REGD14_inst                                                   0x02D5
+#define set_REGD14_reg(data)                                          (*((volatile unsigned int*)REGD14_reg)=data)
+#define get_REGD14_reg                                                (*((volatile unsigned int*)REGD14_reg))
+#define REGD14_p2_er_count_r_shift                                    (20)
+#define REGD14_p2_er_count_g_shift                                    (10)
+#define REGD14_p2_er_count_b_shift                                    (0)
+#define REGD14_p2_er_count_r_mask                                     (0x3FF00000)
+#define REGD14_p2_er_count_g_mask                                     (0x000FFC00)
+#define REGD14_p2_er_count_b_mask                                     (0x000003FF)
+#define REGD14_p2_er_count_r(data)                                    (0x3FF00000&((data)<<20))
+#define REGD14_p2_er_count_g(data)                                    (0x000FFC00&((data)<<10))
+#define REGD14_p2_er_count_b(data)                                    (0x000003FF&(data))
+#define REGD14_get_p2_er_count_r(data)                                ((0x3FF00000&(data))>>20)
+#define REGD14_get_p2_er_count_g(data)                                ((0x000FFC00&(data))>>10)
+#define REGD14_get_p2_er_count_b(data)                                (0x000003FF&(data))
+
+
+#define REGD15                                                        0xb58
+#define REGD15_reg_addr                                               "0x98034b58"
+#define REGD15_reg                                                    0x98034b58
+#define REGD15_inst_addr                                              "0x02D6"
+#define REGD15_inst                                                   0x02D6
+#define set_REGD15_reg(data)                                          (*((volatile unsigned int*)REGD15_reg)=data)
+#define get_REGD15_reg                                                (*((volatile unsigned int*)REGD15_reg))
+#define REGD15_reg_p0_bypass_clk_rdy_shift                            (31)
+#define REGD15_reg_p0_bypass_eqen_rdy_shift                           (30)
+#define REGD15_reg_p0_bypass_data_rdy_shift                           (29)
+#define REGD15_reg_p0_bypass_pi_shift                                 (28)
+#define REGD15_reg_p0_data_rdy_time_shift                             (24)
+#define REGD15_reg_p0_en_clkout_manual_shift                          (23)
+#define REGD15_reg_p0_en_eqen_manual_shift                            (22)
+#define REGD15_reg_p0_en_data_manual_shift                            (21)
+#define REGD15_reg_p0_eqen_rdy_time_shift                             (17)
+#define REGD15_reg_p0_order_shift                                     (16)
+#define REGD15_reg_p0_pll_wd_base_time_shift                          (13)
+#define REGD15_reg_p0_pll_wd_en_shift                                 (12)
+#define REGD15_reg_p0_pll_wd_rst_wid_shift                            (10)
+#define REGD15_reg_p0_pll_wd_time_rdy_shift                           (8)
+#define REGD15_reg_p0_acdr_l0_en_shift                                (7)
+#define REGD15_reg_p0_bypass_eqen_rdy_l0_shift                        (6)
+#define REGD15_reg_p0_bypass_data_rdy_l0_shift                        (5)
+#define REGD15_reg_p0_en_eqen_manual_l0_shift                         (4)
+#define REGD15_reg_p0_en_data_manual_l0_shift                         (3)
+#define REGD15_p0_pll_wd_ckrdy_ro_shift                               (2)
+#define REGD15_p0_pll_wd_rst_wc_shift                                 (1)
+#define REGD15_p0_wdog_rst_n_shift                                    (0)
+#define REGD15_reg_p0_bypass_clk_rdy_mask                             (0x80000000)
+#define REGD15_reg_p0_bypass_eqen_rdy_mask                            (0x40000000)
+#define REGD15_reg_p0_bypass_data_rdy_mask                            (0x20000000)
+#define REGD15_reg_p0_bypass_pi_mask                                  (0x10000000)
+#define REGD15_reg_p0_data_rdy_time_mask                              (0x0F000000)
+#define REGD15_reg_p0_en_clkout_manual_mask                           (0x00800000)
+#define REGD15_reg_p0_en_eqen_manual_mask                             (0x00400000)
+#define REGD15_reg_p0_en_data_manual_mask                             (0x00200000)
+#define REGD15_reg_p0_eqen_rdy_time_mask                              (0x001E0000)
+#define REGD15_reg_p0_order_mask                                      (0x00010000)
+#define REGD15_reg_p0_pll_wd_base_time_mask                           (0x0000E000)
+#define REGD15_reg_p0_pll_wd_en_mask                                  (0x00001000)
+#define REGD15_reg_p0_pll_wd_rst_wid_mask                             (0x00000C00)
+#define REGD15_reg_p0_pll_wd_time_rdy_mask                            (0x00000300)
+#define REGD15_reg_p0_acdr_l0_en_mask                                 (0x00000080)
+#define REGD15_reg_p0_bypass_eqen_rdy_l0_mask                         (0x00000040)
+#define REGD15_reg_p0_bypass_data_rdy_l0_mask                         (0x00000020)
+#define REGD15_reg_p0_en_eqen_manual_l0_mask                          (0x00000010)
+#define REGD15_reg_p0_en_data_manual_l0_mask                          (0x00000008)
+#define REGD15_p0_pll_wd_ckrdy_ro_mask                                (0x00000004)
+#define REGD15_p0_pll_wd_rst_wc_mask                                  (0x00000002)
+#define REGD15_p0_wdog_rst_n_mask                                     (0x00000001)
+#define REGD15_reg_p0_bypass_clk_rdy(data)                            (0x80000000&((data)<<31))
+#define REGD15_reg_p0_bypass_eqen_rdy(data)                           (0x40000000&((data)<<30))
+#define REGD15_reg_p0_bypass_data_rdy(data)                           (0x20000000&((data)<<29))
+#define REGD15_reg_p0_bypass_pi(data)                                 (0x10000000&((data)<<28))
+#define REGD15_reg_p0_data_rdy_time(data)                             (0x0F000000&((data)<<24))
+#define REGD15_reg_p0_en_clkout_manual(data)                          (0x00800000&((data)<<23))
+#define REGD15_reg_p0_en_eqen_manual(data)                            (0x00400000&((data)<<22))
+#define REGD15_reg_p0_en_data_manual(data)                            (0x00200000&((data)<<21))
+#define REGD15_reg_p0_eqen_rdy_time(data)                             (0x001E0000&((data)<<17))
+#define REGD15_reg_p0_order(data)                                     (0x00010000&((data)<<16))
+#define REGD15_reg_p0_pll_wd_base_time(data)                          (0x0000E000&((data)<<13))
+#define REGD15_reg_p0_pll_wd_en(data)                                 (0x00001000&((data)<<12))
+#define REGD15_reg_p0_pll_wd_rst_wid(data)                            (0x00000C00&((data)<<10))
+#define REGD15_reg_p0_pll_wd_time_rdy(data)                           (0x00000300&((data)<<8))
+#define REGD15_reg_p0_acdr_l0_en(data)                                (0x00000080&((data)<<7))
+#define REGD15_reg_p0_bypass_eqen_rdy_l0(data)                        (0x00000040&((data)<<6))
+#define REGD15_reg_p0_bypass_data_rdy_l0(data)                        (0x00000020&((data)<<5))
+#define REGD15_reg_p0_en_eqen_manual_l0(data)                         (0x00000010&((data)<<4))
+#define REGD15_reg_p0_en_data_manual_l0(data)                         (0x00000008&((data)<<3))
+#define REGD15_p0_pll_wd_ckrdy_ro(data)                               (0x00000004&((data)<<2))
+#define REGD15_p0_pll_wd_rst_wc(data)                                 (0x00000002&((data)<<1))
+#define REGD15_p0_wdog_rst_n(data)                                    (0x00000001&(data))
+#define REGD15_get_reg_p0_bypass_clk_rdy(data)                        ((0x80000000&(data))>>31)
+#define REGD15_get_reg_p0_bypass_eqen_rdy(data)                       ((0x40000000&(data))>>30)
+#define REGD15_get_reg_p0_bypass_data_rdy(data)                       ((0x20000000&(data))>>29)
+#define REGD15_get_reg_p0_bypass_pi(data)                             ((0x10000000&(data))>>28)
+#define REGD15_get_reg_p0_data_rdy_time(data)                         ((0x0F000000&(data))>>24)
+#define REGD15_get_reg_p0_en_clkout_manual(data)                      ((0x00800000&(data))>>23)
+#define REGD15_get_reg_p0_en_eqen_manual(data)                        ((0x00400000&(data))>>22)
+#define REGD15_get_reg_p0_en_data_manual(data)                        ((0x00200000&(data))>>21)
+#define REGD15_get_reg_p0_eqen_rdy_time(data)                         ((0x001E0000&(data))>>17)
+#define REGD15_get_reg_p0_order(data)                                 ((0x00010000&(data))>>16)
+#define REGD15_get_reg_p0_pll_wd_base_time(data)                      ((0x0000E000&(data))>>13)
+#define REGD15_get_reg_p0_pll_wd_en(data)                             ((0x00001000&(data))>>12)
+#define REGD15_get_reg_p0_pll_wd_rst_wid(data)                        ((0x00000C00&(data))>>10)
+#define REGD15_get_reg_p0_pll_wd_time_rdy(data)                       ((0x00000300&(data))>>8)
+#define REGD15_get_reg_p0_acdr_l0_en(data)                            ((0x00000080&(data))>>7)
+#define REGD15_get_reg_p0_bypass_eqen_rdy_l0(data)                    ((0x00000040&(data))>>6)
+#define REGD15_get_reg_p0_bypass_data_rdy_l0(data)                    ((0x00000020&(data))>>5)
+#define REGD15_get_reg_p0_en_eqen_manual_l0(data)                     ((0x00000010&(data))>>4)
+#define REGD15_get_reg_p0_en_data_manual_l0(data)                     ((0x00000008&(data))>>3)
+#define REGD15_get_p0_pll_wd_ckrdy_ro(data)                           ((0x00000004&(data))>>2)
+#define REGD15_get_p0_pll_wd_rst_wc(data)                             ((0x00000002&(data))>>1)
+#define REGD15_get_p0_wdog_rst_n(data)                                (0x00000001&(data))
+
+
+#define REGD16                                                        0xb5c
+#define REGD16_reg_addr                                               "0x98034b5c"
+#define REGD16_reg                                                    0x98034b5c
+#define REGD16_inst_addr                                              "0x02D7"
+#define REGD16_inst                                                   0x02D7
+#define set_REGD16_reg(data)                                          (*((volatile unsigned int*)REGD16_reg)=data)
+#define get_REGD16_reg                                                (*((volatile unsigned int*)REGD16_reg))
+#define REGD16_reg_p0_wd_sdm_en_shift                                 (31)
+#define REGD16_reg_p0_f_code_shift                                    (16)
+#define REGD16_reg_p0_n_code_shift                                    (0)
+#define REGD16_reg_p0_wd_sdm_en_mask                                  (0x80000000)
+#define REGD16_reg_p0_f_code_mask                                     (0x0FFF0000)
+#define REGD16_reg_p0_n_code_mask                                     (0x000001FF)
+#define REGD16_reg_p0_wd_sdm_en(data)                                 (0x80000000&((data)<<31))
+#define REGD16_reg_p0_f_code(data)                                    (0x0FFF0000&((data)<<16))
+#define REGD16_reg_p0_n_code(data)                                    (0x000001FF&(data))
+#define REGD16_get_reg_p0_wd_sdm_en(data)                             ((0x80000000&(data))>>31)
+#define REGD16_get_reg_p0_f_code(data)                                ((0x0FFF0000&(data))>>16)
+#define REGD16_get_reg_p0_n_code(data)                                (0x000001FF&(data))
+
+
+#define REGD17                                                        0xb60
+#define REGD17_reg_addr                                               "0x98034b60"
+#define REGD17_reg                                                    0x98034b60
+#define REGD17_inst_addr                                              "0x02D8"
+#define REGD17_inst                                                   0x02D8
+#define set_REGD17_reg(data)                                          (*((volatile unsigned int*)REGD17_reg)=data)
+#define get_REGD17_reg                                                (*((volatile unsigned int*)REGD17_reg))
+#define REGD17_reg_p1_bypass_clk_rdy_shift                            (31)
+#define REGD17_reg_p1_bypass_eqen_rdy_shift                           (30)
+#define REGD17_reg_p1_bypass_data_rdy_shift                           (29)
+#define REGD17_reg_p1_bypass_pi_shift                                 (28)
+#define REGD17_reg_p1_data_rdy_time_shift                             (24)
+#define REGD17_reg_p1_en_clkout_manual_shift                          (23)
+#define REGD17_reg_p1_en_eqen_manual_shift                            (22)
+#define REGD17_reg_p1_en_data_manual_shift                            (21)
+#define REGD17_reg_p1_eqen_rdy_time_shift                             (17)
+#define REGD17_reg_p1_order_shift                                     (16)
+#define REGD17_reg_p1_pll_wd_base_time_shift                          (13)
+#define REGD17_reg_p1_pll_wd_en_shift                                 (12)
+#define REGD17_reg_p1_pll_wd_rst_wid_shift                            (10)
+#define REGD17_reg_p1_pll_wd_time_rdy_shift                           (8)
+#define REGD17_reg_p1_acdr_l0_en_shift                                (7)
+#define REGD17_reg_p1_bypass_eqen_rdy_l0_shift                        (6)
+#define REGD17_reg_p1_bypass_data_rdy_l0_shift                        (5)
+#define REGD17_reg_p1_en_eqen_manual_l0_shift                         (4)
+#define REGD17_reg_p1_en_data_manual_l0_shift                         (3)
+#define REGD17_p1_pll_wd_ckrdy_ro_shift                               (2)
+#define REGD17_p1_pll_wd_rst_wc_shift                                 (1)
+#define REGD17_p1_wdog_rst_n_shift                                    (0)
+#define REGD17_reg_p1_bypass_clk_rdy_mask                             (0x80000000)
+#define REGD17_reg_p1_bypass_eqen_rdy_mask                            (0x40000000)
+#define REGD17_reg_p1_bypass_data_rdy_mask                            (0x20000000)
+#define REGD17_reg_p1_bypass_pi_mask                                  (0x10000000)
+#define REGD17_reg_p1_data_rdy_time_mask                              (0x0F000000)
+#define REGD17_reg_p1_en_clkout_manual_mask                           (0x00800000)
+#define REGD17_reg_p1_en_eqen_manual_mask                             (0x00400000)
+#define REGD17_reg_p1_en_data_manual_mask                             (0x00200000)
+#define REGD17_reg_p1_eqen_rdy_time_mask                              (0x001E0000)
+#define REGD17_reg_p1_order_mask                                      (0x00010000)
+#define REGD17_reg_p1_pll_wd_base_time_mask                           (0x0000E000)
+#define REGD17_reg_p1_pll_wd_en_mask                                  (0x00001000)
+#define REGD17_reg_p1_pll_wd_rst_wid_mask                             (0x00000C00)
+#define REGD17_reg_p1_pll_wd_time_rdy_mask                            (0x00000300)
+#define REGD17_reg_p1_acdr_l0_en_mask                                 (0x00000080)
+#define REGD17_reg_p1_bypass_eqen_rdy_l0_mask                         (0x00000040)
+#define REGD17_reg_p1_bypass_data_rdy_l0_mask                         (0x00000020)
+#define REGD17_reg_p1_en_eqen_manual_l0_mask                          (0x00000010)
+#define REGD17_reg_p1_en_data_manual_l0_mask                          (0x00000008)
+#define REGD17_p1_pll_wd_ckrdy_ro_mask                                (0x00000004)
+#define REGD17_p1_pll_wd_rst_wc_mask                                  (0x00000002)
+#define REGD17_p1_wdog_rst_n_mask                                     (0x00000001)
+#define REGD17_reg_p1_bypass_clk_rdy(data)                            (0x80000000&((data)<<31))
+#define REGD17_reg_p1_bypass_eqen_rdy(data)                           (0x40000000&((data)<<30))
+#define REGD17_reg_p1_bypass_data_rdy(data)                           (0x20000000&((data)<<29))
+#define REGD17_reg_p1_bypass_pi(data)                                 (0x10000000&((data)<<28))
+#define REGD17_reg_p1_data_rdy_time(data)                             (0x0F000000&((data)<<24))
+#define REGD17_reg_p1_en_clkout_manual(data)                          (0x00800000&((data)<<23))
+#define REGD17_reg_p1_en_eqen_manual(data)                            (0x00400000&((data)<<22))
+#define REGD17_reg_p1_en_data_manual(data)                            (0x00200000&((data)<<21))
+#define REGD17_reg_p1_eqen_rdy_time(data)                             (0x001E0000&((data)<<17))
+#define REGD17_reg_p1_order(data)                                     (0x00010000&((data)<<16))
+#define REGD17_reg_p1_pll_wd_base_time(data)                          (0x0000E000&((data)<<13))
+#define REGD17_reg_p1_pll_wd_en(data)                                 (0x00001000&((data)<<12))
+#define REGD17_reg_p1_pll_wd_rst_wid(data)                            (0x00000C00&((data)<<10))
+#define REGD17_reg_p1_pll_wd_time_rdy(data)                           (0x00000300&((data)<<8))
+#define REGD17_reg_p1_acdr_l0_en(data)                                (0x00000080&((data)<<7))
+#define REGD17_reg_p1_bypass_eqen_rdy_l0(data)                        (0x00000040&((data)<<6))
+#define REGD17_reg_p1_bypass_data_rdy_l0(data)                        (0x00000020&((data)<<5))
+#define REGD17_reg_p1_en_eqen_manual_l0(data)                         (0x00000010&((data)<<4))
+#define REGD17_reg_p1_en_data_manual_l0(data)                         (0x00000008&((data)<<3))
+#define REGD17_p1_pll_wd_ckrdy_ro(data)                               (0x00000004&((data)<<2))
+#define REGD17_p1_pll_wd_rst_wc(data)                                 (0x00000002&((data)<<1))
+#define REGD17_p1_wdog_rst_n(data)                                    (0x00000001&(data))
+#define REGD17_get_reg_p1_bypass_clk_rdy(data)                        ((0x80000000&(data))>>31)
+#define REGD17_get_reg_p1_bypass_eqen_rdy(data)                       ((0x40000000&(data))>>30)
+#define REGD17_get_reg_p1_bypass_data_rdy(data)                       ((0x20000000&(data))>>29)
+#define REGD17_get_reg_p1_bypass_pi(data)                             ((0x10000000&(data))>>28)
+#define REGD17_get_reg_p1_data_rdy_time(data)                         ((0x0F000000&(data))>>24)
+#define REGD17_get_reg_p1_en_clkout_manual(data)                      ((0x00800000&(data))>>23)
+#define REGD17_get_reg_p1_en_eqen_manual(data)                        ((0x00400000&(data))>>22)
+#define REGD17_get_reg_p1_en_data_manual(data)                        ((0x00200000&(data))>>21)
+#define REGD17_get_reg_p1_eqen_rdy_time(data)                         ((0x001E0000&(data))>>17)
+#define REGD17_get_reg_p1_order(data)                                 ((0x00010000&(data))>>16)
+#define REGD17_get_reg_p1_pll_wd_base_time(data)                      ((0x0000E000&(data))>>13)
+#define REGD17_get_reg_p1_pll_wd_en(data)                             ((0x00001000&(data))>>12)
+#define REGD17_get_reg_p1_pll_wd_rst_wid(data)                        ((0x00000C00&(data))>>10)
+#define REGD17_get_reg_p1_pll_wd_time_rdy(data)                       ((0x00000300&(data))>>8)
+#define REGD17_get_reg_p1_acdr_l0_en(data)                            ((0x00000080&(data))>>7)
+#define REGD17_get_reg_p1_bypass_eqen_rdy_l0(data)                    ((0x00000040&(data))>>6)
+#define REGD17_get_reg_p1_bypass_data_rdy_l0(data)                    ((0x00000020&(data))>>5)
+#define REGD17_get_reg_p1_en_eqen_manual_l0(data)                     ((0x00000010&(data))>>4)
+#define REGD17_get_reg_p1_en_data_manual_l0(data)                     ((0x00000008&(data))>>3)
+#define REGD17_get_p1_pll_wd_ckrdy_ro(data)                           ((0x00000004&(data))>>2)
+#define REGD17_get_p1_pll_wd_rst_wc(data)                             ((0x00000002&(data))>>1)
+#define REGD17_get_p1_wdog_rst_n(data)                                (0x00000001&(data))
+
+
+#define REGD18                                                        0xb64
+#define REGD18_reg_addr                                               "0x98034b64"
+#define REGD18_reg                                                    0x98034b64
+#define REGD18_inst_addr                                              "0x02D9"
+#define REGD18_inst                                                   0x02D9
+#define set_REGD18_reg(data)                                          (*((volatile unsigned int*)REGD18_reg)=data)
+#define get_REGD18_reg                                                (*((volatile unsigned int*)REGD18_reg))
+#define REGD18_reg_p1_wd_sdm_en_shift                                 (31)
+#define REGD18_reg_p1_f_code_shift                                    (16)
+#define REGD18_reg_p1_n_code_shift                                    (0)
+#define REGD18_reg_p1_wd_sdm_en_mask                                  (0x80000000)
+#define REGD18_reg_p1_f_code_mask                                     (0x0FFF0000)
+#define REGD18_reg_p1_n_code_mask                                     (0x000001FF)
+#define REGD18_reg_p1_wd_sdm_en(data)                                 (0x80000000&((data)<<31))
+#define REGD18_reg_p1_f_code(data)                                    (0x0FFF0000&((data)<<16))
+#define REGD18_reg_p1_n_code(data)                                    (0x000001FF&(data))
+#define REGD18_get_reg_p1_wd_sdm_en(data)                             ((0x80000000&(data))>>31)
+#define REGD18_get_reg_p1_f_code(data)                                ((0x0FFF0000&(data))>>16)
+#define REGD18_get_reg_p1_n_code(data)                                (0x000001FF&(data))
+
+
+#define REGD19                                                        0xb68
+#define REGD19_reg_addr                                               "0x98034b68"
+#define REGD19_reg                                                    0x98034b68
+#define REGD19_inst_addr                                              "0x02DA"
+#define REGD19_inst                                                   0x02DA
+#define set_REGD19_reg(data)                                          (*((volatile unsigned int*)REGD19_reg)=data)
+#define get_REGD19_reg                                                (*((volatile unsigned int*)REGD19_reg))
+#define REGD19_reg_p2_bypass_clk_rdy_shift                            (31)
+#define REGD19_reg_p2_bypass_eqen_rdy_shift                           (30)
+#define REGD19_reg_p2_bypass_data_rdy_shift                           (29)
+#define REGD19_reg_p2_bypass_pi_shift                                 (28)
+#define REGD19_reg_p2_data_rdy_time_shift                             (24)
+#define REGD19_reg_p2_en_clkout_manual_shift                          (23)
+#define REGD19_reg_p2_en_eqen_manual_shift                            (22)
+#define REGD19_reg_p2_en_data_manual_shift                            (21)
+#define REGD19_reg_p2_eqen_rdy_time_shift                             (17)
+#define REGD19_reg_p2_order_shift                                     (16)
+#define REGD19_reg_p2_pll_wd_base_time_shift                          (13)
+#define REGD19_reg_p2_pll_wd_en_shift                                 (12)
+#define REGD19_reg_p2_pll_wd_rst_wid_shift                            (10)
+#define REGD19_reg_p2_pll_wd_time_rdy_shift                           (8)
+#define REGD19_reg_p2_acdr_l0_en_shift                                (7)
+#define REGD19_reg_p2_bypass_eqen_rdy_l0_shift                        (6)
+#define REGD19_reg_p2_bypass_data_rdy_l0_shift                        (5)
+#define REGD19_reg_p2_en_eqen_manual_l0_shift                         (4)
+#define REGD19_reg_p2_en_data_manual_l0_shift                         (3)
+#define REGD19_p2_pll_wd_ckrdy_ro_shift                               (2)
+#define REGD19_p2_pll_wd_rst_wc_shift                                 (1)
+#define REGD19_p2_wdog_rst_n_shift                                    (0)
+#define REGD19_reg_p2_bypass_clk_rdy_mask                             (0x80000000)
+#define REGD19_reg_p2_bypass_eqen_rdy_mask                            (0x40000000)
+#define REGD19_reg_p2_bypass_data_rdy_mask                            (0x20000000)
+#define REGD19_reg_p2_bypass_pi_mask                                  (0x10000000)
+#define REGD19_reg_p2_data_rdy_time_mask                              (0x0F000000)
+#define REGD19_reg_p2_en_clkout_manual_mask                           (0x00800000)
+#define REGD19_reg_p2_en_eqen_manual_mask                             (0x00400000)
+#define REGD19_reg_p2_en_data_manual_mask                             (0x00200000)
+#define REGD19_reg_p2_eqen_rdy_time_mask                              (0x001E0000)
+#define REGD19_reg_p2_order_mask                                      (0x00010000)
+#define REGD19_reg_p2_pll_wd_base_time_mask                           (0x0000E000)
+#define REGD19_reg_p2_pll_wd_en_mask                                  (0x00001000)
+#define REGD19_reg_p2_pll_wd_rst_wid_mask                             (0x00000C00)
+#define REGD19_reg_p2_pll_wd_time_rdy_mask                            (0x00000300)
+#define REGD19_reg_p2_acdr_l0_en_mask                                 (0x00000080)
+#define REGD19_reg_p2_bypass_eqen_rdy_l0_mask                         (0x00000040)
+#define REGD19_reg_p2_bypass_data_rdy_l0_mask                         (0x00000020)
+#define REGD19_reg_p2_en_eqen_manual_l0_mask                          (0x00000010)
+#define REGD19_reg_p2_en_data_manual_l0_mask                          (0x00000008)
+#define REGD19_p2_pll_wd_ckrdy_ro_mask                                (0x00000004)
+#define REGD19_p2_pll_wd_rst_wc_mask                                  (0x00000002)
+#define REGD19_p2_wdog_rst_n_mask                                     (0x00000001)
+#define REGD19_reg_p2_bypass_clk_rdy(data)                            (0x80000000&((data)<<31))
+#define REGD19_reg_p2_bypass_eqen_rdy(data)                           (0x40000000&((data)<<30))
+#define REGD19_reg_p2_bypass_data_rdy(data)                           (0x20000000&((data)<<29))
+#define REGD19_reg_p2_bypass_pi(data)                                 (0x10000000&((data)<<28))
+#define REGD19_reg_p2_data_rdy_time(data)                             (0x0F000000&((data)<<24))
+#define REGD19_reg_p2_en_clkout_manual(data)                          (0x00800000&((data)<<23))
+#define REGD19_reg_p2_en_eqen_manual(data)                            (0x00400000&((data)<<22))
+#define REGD19_reg_p2_en_data_manual(data)                            (0x00200000&((data)<<21))
+#define REGD19_reg_p2_eqen_rdy_time(data)                             (0x001E0000&((data)<<17))
+#define REGD19_reg_p2_order(data)                                     (0x00010000&((data)<<16))
+#define REGD19_reg_p2_pll_wd_base_time(data)                          (0x0000E000&((data)<<13))
+#define REGD19_reg_p2_pll_wd_en(data)                                 (0x00001000&((data)<<12))
+#define REGD19_reg_p2_pll_wd_rst_wid(data)                            (0x00000C00&((data)<<10))
+#define REGD19_reg_p2_pll_wd_time_rdy(data)                           (0x00000300&((data)<<8))
+#define REGD19_reg_p2_acdr_l0_en(data)                                (0x00000080&((data)<<7))
+#define REGD19_reg_p2_bypass_eqen_rdy_l0(data)                        (0x00000040&((data)<<6))
+#define REGD19_reg_p2_bypass_data_rdy_l0(data)                        (0x00000020&((data)<<5))
+#define REGD19_reg_p2_en_eqen_manual_l0(data)                         (0x00000010&((data)<<4))
+#define REGD19_reg_p2_en_data_manual_l0(data)                         (0x00000008&((data)<<3))
+#define REGD19_p2_pll_wd_ckrdy_ro(data)                               (0x00000004&((data)<<2))
+#define REGD19_p2_pll_wd_rst_wc(data)                                 (0x00000002&((data)<<1))
+#define REGD19_p2_wdog_rst_n(data)                                    (0x00000001&(data))
+#define REGD19_get_reg_p2_bypass_clk_rdy(data)                        ((0x80000000&(data))>>31)
+#define REGD19_get_reg_p2_bypass_eqen_rdy(data)                       ((0x40000000&(data))>>30)
+#define REGD19_get_reg_p2_bypass_data_rdy(data)                       ((0x20000000&(data))>>29)
+#define REGD19_get_reg_p2_bypass_pi(data)                             ((0x10000000&(data))>>28)
+#define REGD19_get_reg_p2_data_rdy_time(data)                         ((0x0F000000&(data))>>24)
+#define REGD19_get_reg_p2_en_clkout_manual(data)                      ((0x00800000&(data))>>23)
+#define REGD19_get_reg_p2_en_eqen_manual(data)                        ((0x00400000&(data))>>22)
+#define REGD19_get_reg_p2_en_data_manual(data)                        ((0x00200000&(data))>>21)
+#define REGD19_get_reg_p2_eqen_rdy_time(data)                         ((0x001E0000&(data))>>17)
+#define REGD19_get_reg_p2_order(data)                                 ((0x00010000&(data))>>16)
+#define REGD19_get_reg_p2_pll_wd_base_time(data)                      ((0x0000E000&(data))>>13)
+#define REGD19_get_reg_p2_pll_wd_en(data)                             ((0x00001000&(data))>>12)
+#define REGD19_get_reg_p2_pll_wd_rst_wid(data)                        ((0x00000C00&(data))>>10)
+#define REGD19_get_reg_p2_pll_wd_time_rdy(data)                       ((0x00000300&(data))>>8)
+#define REGD19_get_reg_p2_acdr_l0_en(data)                            ((0x00000080&(data))>>7)
+#define REGD19_get_reg_p2_bypass_eqen_rdy_l0(data)                    ((0x00000040&(data))>>6)
+#define REGD19_get_reg_p2_bypass_data_rdy_l0(data)                    ((0x00000020&(data))>>5)
+#define REGD19_get_reg_p2_en_eqen_manual_l0(data)                     ((0x00000010&(data))>>4)
+#define REGD19_get_reg_p2_en_data_manual_l0(data)                     ((0x00000008&(data))>>3)
+#define REGD19_get_p2_pll_wd_ckrdy_ro(data)                           ((0x00000004&(data))>>2)
+#define REGD19_get_p2_pll_wd_rst_wc(data)                             ((0x00000002&(data))>>1)
+#define REGD19_get_p2_wdog_rst_n(data)                                (0x00000001&(data))
+
+
+#define REGD20                                                        0xb6c
+#define REGD20_reg_addr                                               "0x98034b6c"
+#define REGD20_reg                                                    0x98034b6c
+#define REGD20_inst_addr                                              "0x02DB"
+#define REGD20_inst                                                   0x02DB
+#define set_REGD20_reg(data)                                          (*((volatile unsigned int*)REGD20_reg)=data)
+#define get_REGD20_reg                                                (*((volatile unsigned int*)REGD20_reg))
+#define REGD20_reg_p2_wd_sdm_en_shift                                 (31)
+#define REGD20_reg_p2_f_code_shift                                    (16)
+#define REGD20_reg_p2_n_code_shift                                    (0)
+#define REGD20_reg_p2_wd_sdm_en_mask                                  (0x80000000)
+#define REGD20_reg_p2_f_code_mask                                     (0x0FFF0000)
+#define REGD20_reg_p2_n_code_mask                                     (0x000001FF)
+#define REGD20_reg_p2_wd_sdm_en(data)                                 (0x80000000&((data)<<31))
+#define REGD20_reg_p2_f_code(data)                                    (0x0FFF0000&((data)<<16))
+#define REGD20_reg_p2_n_code(data)                                    (0x000001FF&(data))
+#define REGD20_get_reg_p2_wd_sdm_en(data)                             ((0x80000000&(data))>>31)
+#define REGD20_get_reg_p2_f_code(data)                                ((0x0FFF0000&(data))>>16)
+#define REGD20_get_reg_p2_n_code(data)                                (0x000001FF&(data))
+
+
+#define REGD21                                                        0xb70
+#define REGD21_reg_addr                                               "0x98034b70"
+#define REGD21_reg                                                    0x98034b70
+#define REGD21_inst_addr                                              "0x02DC"
+#define REGD21_inst                                                   0x02DC
+#define set_REGD21_reg(data)                                          (*((volatile unsigned int*)REGD21_reg)=data)
+#define get_REGD21_reg                                                (*((volatile unsigned int*)REGD21_reg))
+#define REGD21_reg_p0_auto_mode_shift                                 (31)
+#define REGD21_reg_p0_adp_en_manual_shift                             (30)
+#define REGD21_reg_p0_cp_en_manual_shift                              (29)
+#define REGD21_reg_p0_adap_eq_off_shift                               (28)
+#define REGD21_reg_p0_adp_time_shift                                  (23)
+#define REGD21_reg_p0_calib_time_shift                                (20)
+#define REGD21_reg_p0_calib_manual_shift                              (19)
+#define REGD21_reg_p0_calib_late_shift                                (18)
+#define REGD21_reg_p0_vco_coarse_shift                                (11)
+#define REGD21_reg_p0_divide_num_shift                                (4)
+#define REGD21_reg_p0_init_time_shift                                 (1)
+#define REGD21_reg_p0_auto_mode_mask                                  (0x80000000)
+#define REGD21_reg_p0_adp_en_manual_mask                              (0x40000000)
+#define REGD21_reg_p0_cp_en_manual_mask                               (0x20000000)
+#define REGD21_reg_p0_adap_eq_off_mask                                (0x10000000)
+#define REGD21_reg_p0_adp_time_mask                                   (0x0F800000)
+#define REGD21_reg_p0_calib_time_mask                                 (0x00700000)
+#define REGD21_reg_p0_calib_manual_mask                               (0x00080000)
+#define REGD21_reg_p0_calib_late_mask                                 (0x00040000)
+#define REGD21_reg_p0_vco_coarse_mask                                 (0x0003F800)
+#define REGD21_reg_p0_divide_num_mask                                 (0x000007F0)
+#define REGD21_reg_p0_init_time_mask                                  (0x0000000E)
+#define REGD21_reg_p0_auto_mode(data)                                 (0x80000000&((data)<<31))
+#define REGD21_reg_p0_adp_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD21_reg_p0_cp_en_manual(data)                              (0x20000000&((data)<<29))
+#define REGD21_reg_p0_adap_eq_off(data)                               (0x10000000&((data)<<28))
+#define REGD21_reg_p0_adp_time(data)                                  (0x0F800000&((data)<<23))
+#define REGD21_reg_p0_calib_time(data)                                (0x00700000&((data)<<20))
+#define REGD21_reg_p0_calib_manual(data)                              (0x00080000&((data)<<19))
+#define REGD21_reg_p0_calib_late(data)                                (0x00040000&((data)<<18))
+#define REGD21_reg_p0_vco_coarse(data)                                (0x0003F800&((data)<<11))
+#define REGD21_reg_p0_divide_num(data)                                (0x000007F0&((data)<<4))
+#define REGD21_reg_p0_init_time(data)                                 (0x0000000E&((data)<<1))
+#define REGD21_get_reg_p0_auto_mode(data)                             ((0x80000000&(data))>>31)
+#define REGD21_get_reg_p0_adp_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD21_get_reg_p0_cp_en_manual(data)                          ((0x20000000&(data))>>29)
+#define REGD21_get_reg_p0_adap_eq_off(data)                           ((0x10000000&(data))>>28)
+#define REGD21_get_reg_p0_adp_time(data)                              ((0x0F800000&(data))>>23)
+#define REGD21_get_reg_p0_calib_time(data)                            ((0x00700000&(data))>>20)
+#define REGD21_get_reg_p0_calib_manual(data)                          ((0x00080000&(data))>>19)
+#define REGD21_get_reg_p0_calib_late(data)                            ((0x00040000&(data))>>18)
+#define REGD21_get_reg_p0_vco_coarse(data)                            ((0x0003F800&(data))>>11)
+#define REGD21_get_reg_p0_divide_num(data)                            ((0x000007F0&(data))>>4)
+#define REGD21_get_reg_p0_init_time(data)                             ((0x0000000E&(data))>>1)
+
+
+#define REGD22                                                        0xb74
+#define REGD22_reg_addr                                               "0x98034b74"
+#define REGD22_reg                                                    0x98034b74
+#define REGD22_inst_addr                                              "0x02DD"
+#define REGD22_inst                                                   0x02DD
+#define set_REGD22_reg(data)                                          (*((volatile unsigned int*)REGD22_reg)=data)
+#define get_REGD22_reg                                                (*((volatile unsigned int*)REGD22_reg))
+#define REGD22_reg_p0_lock_up_limit_shift                             (16)
+#define REGD22_reg_p0_lock_dn_limit_shift                             (0)
+#define REGD22_reg_p0_lock_up_limit_mask                              (0x07FF0000)
+#define REGD22_reg_p0_lock_dn_limit_mask                              (0x000007FF)
+#define REGD22_reg_p0_lock_up_limit(data)                             (0x07FF0000&((data)<<16))
+#define REGD22_reg_p0_lock_dn_limit(data)                             (0x000007FF&(data))
+#define REGD22_get_reg_p0_lock_up_limit(data)                         ((0x07FF0000&(data))>>16)
+#define REGD22_get_reg_p0_lock_dn_limit(data)                         (0x000007FF&(data))
+
+
+#define REGD23                                                        0xb78
+#define REGD23_reg_addr                                               "0x98034b78"
+#define REGD23_reg                                                    0x98034b78
+#define REGD23_inst_addr                                              "0x02DE"
+#define REGD23_inst                                                   0x02DE
+#define set_REGD23_reg(data)                                          (*((volatile unsigned int*)REGD23_reg)=data)
+#define get_REGD23_reg                                                (*((volatile unsigned int*)REGD23_reg))
+#define REGD23_reg_p0_cdr_cp_shift                                    (12)
+#define REGD23_reg_p0_cdr_r_shift                                     (6)
+#define REGD23_reg_p0_cdr_c_shift                                     (4)
+#define REGD23_reg_p0_vc_sel_shift                                    (2)
+#define REGD23_reg_p0_calib_reset_sel_shift                           (1)
+#define REGD23_reg_p0_cdr_cp_mask                                     (0xFFFFF000)
+#define REGD23_reg_p0_cdr_r_mask                                      (0x00000FC0)
+#define REGD23_reg_p0_cdr_c_mask                                      (0x00000030)
+#define REGD23_reg_p0_vc_sel_mask                                     (0x0000000C)
+#define REGD23_reg_p0_calib_reset_sel_mask                            (0x00000002)
+#define REGD23_reg_p0_cdr_cp(data)                                    (0xFFFFF000&((data)<<12))
+#define REGD23_reg_p0_cdr_r(data)                                     (0x00000FC0&((data)<<6))
+#define REGD23_reg_p0_cdr_c(data)                                     (0x00000030&((data)<<4))
+#define REGD23_reg_p0_vc_sel(data)                                    (0x0000000C&((data)<<2))
+#define REGD23_reg_p0_calib_reset_sel(data)                           (0x00000002&((data)<<1))
+#define REGD23_get_reg_p0_cdr_cp(data)                                ((0xFFFFF000&(data))>>12)
+#define REGD23_get_reg_p0_cdr_r(data)                                 ((0x00000FC0&(data))>>6)
+#define REGD23_get_reg_p0_cdr_c(data)                                 ((0x00000030&(data))>>4)
+#define REGD23_get_reg_p0_vc_sel(data)                                ((0x0000000C&(data))>>2)
+#define REGD23_get_reg_p0_calib_reset_sel(data)                       ((0x00000002&(data))>>1)
+
+
+#define REGD24                                                        0xb7c
+#define REGD24_reg_addr                                               "0x98034b7c"
+#define REGD24_reg                                                    0x98034b7c
+#define REGD24_inst_addr                                              "0x02DF"
+#define REGD24_inst                                                   0x02DF
+#define set_REGD24_reg(data)                                          (*((volatile unsigned int*)REGD24_reg)=data)
+#define get_REGD24_reg                                                (*((volatile unsigned int*)REGD24_reg))
+#define REGD24_reg_p0_slope_lv_up_shift                               (21)
+#define REGD24_reg_p0_slope_lv_dn_shift                               (10)
+#define REGD24_reg_p0_cp_time_shift                                   (5)
+#define REGD24_reg_p0_timer_4_shift                                   (0)
+#define REGD24_reg_p0_slope_lv_up_mask                                (0xFFE00000)
+#define REGD24_reg_p0_slope_lv_dn_mask                                (0x001FFC00)
+#define REGD24_reg_p0_cp_time_mask                                    (0x000003E0)
+#define REGD24_reg_p0_timer_4_mask                                    (0x0000001F)
+#define REGD24_reg_p0_slope_lv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD24_reg_p0_slope_lv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD24_reg_p0_cp_time(data)                                   (0x000003E0&((data)<<5))
+#define REGD24_reg_p0_timer_4(data)                                   (0x0000001F&(data))
+#define REGD24_get_reg_p0_slope_lv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD24_get_reg_p0_slope_lv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD24_get_reg_p0_cp_time(data)                               ((0x000003E0&(data))>>5)
+#define REGD24_get_reg_p0_timer_4(data)                               (0x0000001F&(data))
+
+
+#define REGD25                                                        0xb80
+#define REGD25_reg_addr                                               "0x98034b80"
+#define REGD25_reg                                                    0x98034b80
+#define REGD25_inst_addr                                              "0x02E0"
+#define REGD25_inst                                                   0x02E0
+#define set_REGD25_reg(data)                                          (*((volatile unsigned int*)REGD25_reg)=data)
+#define get_REGD25_reg                                                (*((volatile unsigned int*)REGD25_reg))
+#define REGD25_reg_p0_slope_hv_up_shift                               (21)
+#define REGD25_reg_p0_slope_hv_dn_shift                               (10)
+#define REGD25_reg_p0_timer_5_shift                                   (9)
+#define REGD25_reg_p0_timer_6_shift                                   (4)
+#define REGD25_reg_p0_slope_hv_up_mask                                (0xFFE00000)
+#define REGD25_reg_p0_slope_hv_dn_mask                                (0x001FFC00)
+#define REGD25_reg_p0_timer_5_mask                                    (0x00000200)
+#define REGD25_reg_p0_timer_6_mask                                    (0x000001F0)
+#define REGD25_reg_p0_slope_hv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD25_reg_p0_slope_hv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD25_reg_p0_timer_5(data)                                   (0x00000200&((data)<<9))
+#define REGD25_reg_p0_timer_6(data)                                   (0x000001F0&((data)<<4))
+#define REGD25_get_reg_p0_slope_hv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD25_get_reg_p0_slope_hv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD25_get_reg_p0_timer_5(data)                               ((0x00000200&(data))>>9)
+#define REGD25_get_reg_p0_timer_6(data)                               ((0x000001F0&(data))>>4)
+
+
+#define REGD26                                                        0xb84
+#define REGD26_reg_addr                                               "0x98034b84"
+#define REGD26_reg                                                    0x98034b84
+#define REGD26_inst_addr                                              "0x02E1"
+#define REGD26_inst                                                   0x02E1
+#define set_REGD26_reg(data)                                          (*((volatile unsigned int*)REGD26_reg)=data)
+#define get_REGD26_reg                                                (*((volatile unsigned int*)REGD26_reg))
+#define REGD26_reg_p0_start_en_manual_shift                           (31)
+#define REGD26_reg_p0_pfd_en_manual_shift                             (30)
+#define REGD26_reg_p0_pfd_time_shift                                  (25)
+#define REGD26_reg_p0_pfd_bypass_shift                                (24)
+#define REGD26_reg_p0_rxidle_bypass_shift                             (23)
+#define REGD26_reg_p0_slope_manual_shift                              (22)
+#define REGD26_reg_p0_slope_band_shift                                (17)
+#define REGD26_reg_p0_old_mode_shift                                  (16)
+#define REGD26_reg_p0_start_en_manual_mask                            (0x80000000)
+#define REGD26_reg_p0_pfd_en_manual_mask                              (0x40000000)
+#define REGD26_reg_p0_pfd_time_mask                                   (0x3E000000)
+#define REGD26_reg_p0_pfd_bypass_mask                                 (0x01000000)
+#define REGD26_reg_p0_rxidle_bypass_mask                              (0x00800000)
+#define REGD26_reg_p0_slope_manual_mask                               (0x00400000)
+#define REGD26_reg_p0_slope_band_mask                                 (0x003E0000)
+#define REGD26_reg_p0_old_mode_mask                                   (0x00010000)
+#define REGD26_reg_p0_start_en_manual(data)                           (0x80000000&((data)<<31))
+#define REGD26_reg_p0_pfd_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD26_reg_p0_pfd_time(data)                                  (0x3E000000&((data)<<25))
+#define REGD26_reg_p0_pfd_bypass(data)                                (0x01000000&((data)<<24))
+#define REGD26_reg_p0_rxidle_bypass(data)                             (0x00800000&((data)<<23))
+#define REGD26_reg_p0_slope_manual(data)                              (0x00400000&((data)<<22))
+#define REGD26_reg_p0_slope_band(data)                                (0x003E0000&((data)<<17))
+#define REGD26_reg_p0_old_mode(data)                                  (0x00010000&((data)<<16))
+#define REGD26_get_reg_p0_start_en_manual(data)                       ((0x80000000&(data))>>31)
+#define REGD26_get_reg_p0_pfd_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD26_get_reg_p0_pfd_time(data)                              ((0x3E000000&(data))>>25)
+#define REGD26_get_reg_p0_pfd_bypass(data)                            ((0x01000000&(data))>>24)
+#define REGD26_get_reg_p0_rxidle_bypass(data)                         ((0x00800000&(data))>>23)
+#define REGD26_get_reg_p0_slope_manual(data)                          ((0x00400000&(data))>>22)
+#define REGD26_get_reg_p0_slope_band(data)                            ((0x003E0000&(data))>>17)
+#define REGD26_get_reg_p0_old_mode(data)                              ((0x00010000&(data))>>16)
+
+
+#define REGD27                                                        0xb88
+#define REGD27_reg_addr                                               "0x98034b88"
+#define REGD27_reg                                                    0x98034b88
+#define REGD27_inst_addr                                              "0x02E2"
+#define REGD27_inst                                                   0x02E2
+#define set_REGD27_reg(data)                                          (*((volatile unsigned int*)REGD27_reg)=data)
+#define get_REGD27_reg                                                (*((volatile unsigned int*)REGD27_reg))
+#define REGD27_p0_fld_st_reg_shift                                    (27)
+#define REGD27_p0_adp_en_fsm_reg_shift                                (26)
+#define REGD27_p0_cp_en_fsm_reg_shift                                 (25)
+#define REGD27_p0_coarse_fsm_reg_shift                                (18)
+#define REGD27_p0_pfd_en_fsm_reg_shift                                (17)
+#define REGD27_p0_slope_lv_reg_shift                                  (12)
+#define REGD27_p0_slope_hv_reg_shift                                  (7)
+#define REGD27_p0_slope_final_reg_shift                               (2)
+#define REGD27_p0_fld_st_reg_mask                                     (0xF8000000)
+#define REGD27_p0_adp_en_fsm_reg_mask                                 (0x04000000)
+#define REGD27_p0_cp_en_fsm_reg_mask                                  (0x02000000)
+#define REGD27_p0_coarse_fsm_reg_mask                                 (0x01FC0000)
+#define REGD27_p0_pfd_en_fsm_reg_mask                                 (0x00020000)
+#define REGD27_p0_slope_lv_reg_mask                                   (0x0001F000)
+#define REGD27_p0_slope_hv_reg_mask                                   (0x00000F80)
+#define REGD27_p0_slope_final_reg_mask                                (0x0000007C)
+#define REGD27_p0_fld_st_reg(data)                                    (0xF8000000&((data)<<27))
+#define REGD27_p0_adp_en_fsm_reg(data)                                (0x04000000&((data)<<26))
+#define REGD27_p0_cp_en_fsm_reg(data)                                 (0x02000000&((data)<<25))
+#define REGD27_p0_coarse_fsm_reg(data)                                (0x01FC0000&((data)<<18))
+#define REGD27_p0_pfd_en_fsm_reg(data)                                (0x00020000&((data)<<17))
+#define REGD27_p0_slope_lv_reg(data)                                  (0x0001F000&((data)<<12))
+#define REGD27_p0_slope_hv_reg(data)                                  (0x00000F80&((data)<<7))
+#define REGD27_p0_slope_final_reg(data)                               (0x0000007C&((data)<<2))
+#define REGD27_get_p0_fld_st_reg(data)                                ((0xF8000000&(data))>>27)
+#define REGD27_get_p0_adp_en_fsm_reg(data)                            ((0x04000000&(data))>>26)
+#define REGD27_get_p0_cp_en_fsm_reg(data)                             ((0x02000000&(data))>>25)
+#define REGD27_get_p0_coarse_fsm_reg(data)                            ((0x01FC0000&(data))>>18)
+#define REGD27_get_p0_pfd_en_fsm_reg(data)                            ((0x00020000&(data))>>17)
+#define REGD27_get_p0_slope_lv_reg(data)                              ((0x0001F000&(data))>>12)
+#define REGD27_get_p0_slope_hv_reg(data)                              ((0x00000F80&(data))>>7)
+#define REGD27_get_p0_slope_final_reg(data)                           ((0x0000007C&(data))>>2)
+
+
+#define REGD28                                                        0xb8c
+#define REGD28_reg_addr                                               "0x98034b8c"
+#define REGD28_reg                                                    0x98034b8c
+#define REGD28_inst_addr                                              "0x02E3"
+#define REGD28_inst                                                   0x02E3
+#define set_REGD28_reg(data)                                          (*((volatile unsigned int*)REGD28_reg)=data)
+#define get_REGD28_reg                                                (*((volatile unsigned int*)REGD28_reg))
+#define REGD28_reg_p1_auto_mode_shift                                 (31)
+#define REGD28_reg_p1_adp_en_manual_shift                             (30)
+#define REGD28_reg_p1_cp_en_manual_shift                              (29)
+#define REGD28_reg_p1_adap_eq_off_shift                               (28)
+#define REGD28_reg_p1_adp_time_shift                                  (23)
+#define REGD28_reg_p1_calib_time_shift                                (20)
+#define REGD28_reg_p1_calib_manual_shift                              (19)
+#define REGD28_reg_p1_calib_late_shift                                (18)
+#define REGD28_reg_p1_vco_coarse_shift                                (11)
+#define REGD28_reg_p1_divide_num_shift                                (4)
+#define REGD28_reg_p1_init_time_shift                                 (1)
+#define REGD28_reg_p1_auto_mode_mask                                  (0x80000000)
+#define REGD28_reg_p1_adp_en_manual_mask                              (0x40000000)
+#define REGD28_reg_p1_cp_en_manual_mask                               (0x20000000)
+#define REGD28_reg_p1_adap_eq_off_mask                                (0x10000000)
+#define REGD28_reg_p1_adp_time_mask                                   (0x0F800000)
+#define REGD28_reg_p1_calib_time_mask                                 (0x00700000)
+#define REGD28_reg_p1_calib_manual_mask                               (0x00080000)
+#define REGD28_reg_p1_calib_late_mask                                 (0x00040000)
+#define REGD28_reg_p1_vco_coarse_mask                                 (0x0003F800)
+#define REGD28_reg_p1_divide_num_mask                                 (0x000007F0)
+#define REGD28_reg_p1_init_time_mask                                  (0x0000000E)
+#define REGD28_reg_p1_auto_mode(data)                                 (0x80000000&((data)<<31))
+#define REGD28_reg_p1_adp_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD28_reg_p1_cp_en_manual(data)                              (0x20000000&((data)<<29))
+#define REGD28_reg_p1_adap_eq_off(data)                               (0x10000000&((data)<<28))
+#define REGD28_reg_p1_adp_time(data)                                  (0x0F800000&((data)<<23))
+#define REGD28_reg_p1_calib_time(data)                                (0x00700000&((data)<<20))
+#define REGD28_reg_p1_calib_manual(data)                              (0x00080000&((data)<<19))
+#define REGD28_reg_p1_calib_late(data)                                (0x00040000&((data)<<18))
+#define REGD28_reg_p1_vco_coarse(data)                                (0x0003F800&((data)<<11))
+#define REGD28_reg_p1_divide_num(data)                                (0x000007F0&((data)<<4))
+#define REGD28_reg_p1_init_time(data)                                 (0x0000000E&((data)<<1))
+#define REGD28_get_reg_p1_auto_mode(data)                             ((0x80000000&(data))>>31)
+#define REGD28_get_reg_p1_adp_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD28_get_reg_p1_cp_en_manual(data)                          ((0x20000000&(data))>>29)
+#define REGD28_get_reg_p1_adap_eq_off(data)                           ((0x10000000&(data))>>28)
+#define REGD28_get_reg_p1_adp_time(data)                              ((0x0F800000&(data))>>23)
+#define REGD28_get_reg_p1_calib_time(data)                            ((0x00700000&(data))>>20)
+#define REGD28_get_reg_p1_calib_manual(data)                          ((0x00080000&(data))>>19)
+#define REGD28_get_reg_p1_calib_late(data)                            ((0x00040000&(data))>>18)
+#define REGD28_get_reg_p1_vco_coarse(data)                            ((0x0003F800&(data))>>11)
+#define REGD28_get_reg_p1_divide_num(data)                            ((0x000007F0&(data))>>4)
+#define REGD28_get_reg_p1_init_time(data)                             ((0x0000000E&(data))>>1)
+
+
+#define REGD29                                                        0xb90
+#define REGD29_reg_addr                                               "0x98034b90"
+#define REGD29_reg                                                    0x98034b90
+#define REGD29_inst_addr                                              "0x02E4"
+#define REGD29_inst                                                   0x02E4
+#define set_REGD29_reg(data)                                          (*((volatile unsigned int*)REGD29_reg)=data)
+#define get_REGD29_reg                                                (*((volatile unsigned int*)REGD29_reg))
+#define REGD29_reg_p1_lock_up_limit_shift                             (16)
+#define REGD29_reg_p1_lock_dn_limit_shift                             (0)
+#define REGD29_reg_p1_lock_up_limit_mask                              (0x07FF0000)
+#define REGD29_reg_p1_lock_dn_limit_mask                              (0x000007FF)
+#define REGD29_reg_p1_lock_up_limit(data)                             (0x07FF0000&((data)<<16))
+#define REGD29_reg_p1_lock_dn_limit(data)                             (0x000007FF&(data))
+#define REGD29_get_reg_p1_lock_up_limit(data)                         ((0x07FF0000&(data))>>16)
+#define REGD29_get_reg_p1_lock_dn_limit(data)                         (0x000007FF&(data))
+
+
+#define REGD30                                                        0xb94
+#define REGD30_reg_addr                                               "0x98034b94"
+#define REGD30_reg                                                    0x98034b94
+#define REGD30_inst_addr                                              "0x02E5"
+#define REGD30_inst                                                   0x02E5
+#define set_REGD30_reg(data)                                          (*((volatile unsigned int*)REGD30_reg)=data)
+#define get_REGD30_reg                                                (*((volatile unsigned int*)REGD30_reg))
+#define REGD30_reg_p1_cdr_cp_shift                                    (12)
+#define REGD30_reg_p1_cdr_r_shift                                     (6)
+#define REGD30_reg_p1_cdr_c_shift                                     (4)
+#define REGD30_reg_p1_vc_sel_shift                                    (2)
+#define REGD30_reg_p1_calib_reset_sel_shift                           (1)
+#define REGD30_reg_p1_cdr_cp_mask                                     (0xFFFFF000)
+#define REGD30_reg_p1_cdr_r_mask                                      (0x00000FC0)
+#define REGD30_reg_p1_cdr_c_mask                                      (0x00000030)
+#define REGD30_reg_p1_vc_sel_mask                                     (0x0000000C)
+#define REGD30_reg_p1_calib_reset_sel_mask                            (0x00000002)
+#define REGD30_reg_p1_cdr_cp(data)                                    (0xFFFFF000&((data)<<12))
+#define REGD30_reg_p1_cdr_r(data)                                     (0x00000FC0&((data)<<6))
+#define REGD30_reg_p1_cdr_c(data)                                     (0x00000030&((data)<<4))
+#define REGD30_reg_p1_vc_sel(data)                                    (0x0000000C&((data)<<2))
+#define REGD30_reg_p1_calib_reset_sel(data)                           (0x00000002&((data)<<1))
+#define REGD30_get_reg_p1_cdr_cp(data)                                ((0xFFFFF000&(data))>>12)
+#define REGD30_get_reg_p1_cdr_r(data)                                 ((0x00000FC0&(data))>>6)
+#define REGD30_get_reg_p1_cdr_c(data)                                 ((0x00000030&(data))>>4)
+#define REGD30_get_reg_p1_vc_sel(data)                                ((0x0000000C&(data))>>2)
+#define REGD30_get_reg_p1_calib_reset_sel(data)                       ((0x00000002&(data))>>1)
+
+
+#define REGD31                                                        0xb98
+#define REGD31_reg_addr                                               "0x98034b98"
+#define REGD31_reg                                                    0x98034b98
+#define REGD31_inst_addr                                              "0x02E6"
+#define REGD31_inst                                                   0x02E6
+#define set_REGD31_reg(data)                                          (*((volatile unsigned int*)REGD31_reg)=data)
+#define get_REGD31_reg                                                (*((volatile unsigned int*)REGD31_reg))
+#define REGD31_reg_p1_slope_lv_up_shift                               (21)
+#define REGD31_reg_p1_slope_lv_dn_shift                               (10)
+#define REGD31_reg_p1_cp_time_shift                                   (5)
+#define REGD31_reg_p1_timer_4_shift                                   (0)
+#define REGD31_reg_p1_slope_lv_up_mask                                (0xFFE00000)
+#define REGD31_reg_p1_slope_lv_dn_mask                                (0x001FFC00)
+#define REGD31_reg_p1_cp_time_mask                                    (0x000003E0)
+#define REGD31_reg_p1_timer_4_mask                                    (0x0000001F)
+#define REGD31_reg_p1_slope_lv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD31_reg_p1_slope_lv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD31_reg_p1_cp_time(data)                                   (0x000003E0&((data)<<5))
+#define REGD31_reg_p1_timer_4(data)                                   (0x0000001F&(data))
+#define REGD31_get_reg_p1_slope_lv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD31_get_reg_p1_slope_lv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD31_get_reg_p1_cp_time(data)                               ((0x000003E0&(data))>>5)
+#define REGD31_get_reg_p1_timer_4(data)                               (0x0000001F&(data))
+
+
+#define REGD32                                                        0xb9c
+#define REGD32_reg_addr                                               "0x98034b9c"
+#define REGD32_reg                                                    0x98034b9c
+#define REGD32_inst_addr                                              "0x02E7"
+#define REGD32_inst                                                   0x02E7
+#define set_REGD32_reg(data)                                          (*((volatile unsigned int*)REGD32_reg)=data)
+#define get_REGD32_reg                                                (*((volatile unsigned int*)REGD32_reg))
+#define REGD32_reg_p1_slope_hv_up_shift                               (21)
+#define REGD32_reg_p1_slope_hv_dn_shift                               (10)
+#define REGD32_reg_p1_timer_5_shift                                   (9)
+#define REGD32_reg_p1_timer_6_shift                                   (4)
+#define REGD32_reg_p1_slope_hv_up_mask                                (0xFFE00000)
+#define REGD32_reg_p1_slope_hv_dn_mask                                (0x001FFC00)
+#define REGD32_reg_p1_timer_5_mask                                    (0x00000200)
+#define REGD32_reg_p1_timer_6_mask                                    (0x000001F0)
+#define REGD32_reg_p1_slope_hv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD32_reg_p1_slope_hv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD32_reg_p1_timer_5(data)                                   (0x00000200&((data)<<9))
+#define REGD32_reg_p1_timer_6(data)                                   (0x000001F0&((data)<<4))
+#define REGD32_get_reg_p1_slope_hv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD32_get_reg_p1_slope_hv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD32_get_reg_p1_timer_5(data)                               ((0x00000200&(data))>>9)
+#define REGD32_get_reg_p1_timer_6(data)                               ((0x000001F0&(data))>>4)
+
+
+#define REGD33                                                        0xba0
+#define REGD33_reg_addr                                               "0x98034ba0"
+#define REGD33_reg                                                    0x98034ba0
+#define REGD33_inst_addr                                              "0x02E8"
+#define REGD33_inst                                                   0x02E8
+#define set_REGD33_reg(data)                                          (*((volatile unsigned int*)REGD33_reg)=data)
+#define get_REGD33_reg                                                (*((volatile unsigned int*)REGD33_reg))
+#define REGD33_reg_p1_start_en_manual_shift                           (31)
+#define REGD33_reg_p1_pfd_en_manual_shift                             (30)
+#define REGD33_reg_p1_pfd_time_shift                                  (25)
+#define REGD33_reg_p1_pfd_bypass_shift                                (24)
+#define REGD33_reg_p1_rxidle_bypass_shift                             (23)
+#define REGD33_reg_p1_slope_manual_shift                              (22)
+#define REGD33_reg_p1_slope_band_shift                                (17)
+#define REGD33_reg_p1_old_mode_shift                                  (16)
+#define REGD33_reg_p1_start_en_manual_mask                            (0x80000000)
+#define REGD33_reg_p1_pfd_en_manual_mask                              (0x40000000)
+#define REGD33_reg_p1_pfd_time_mask                                   (0x3E000000)
+#define REGD33_reg_p1_pfd_bypass_mask                                 (0x01000000)
+#define REGD33_reg_p1_rxidle_bypass_mask                              (0x00800000)
+#define REGD33_reg_p1_slope_manual_mask                               (0x00400000)
+#define REGD33_reg_p1_slope_band_mask                                 (0x003E0000)
+#define REGD33_reg_p1_old_mode_mask                                   (0x00010000)
+#define REGD33_reg_p1_start_en_manual(data)                           (0x80000000&((data)<<31))
+#define REGD33_reg_p1_pfd_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD33_reg_p1_pfd_time(data)                                  (0x3E000000&((data)<<25))
+#define REGD33_reg_p1_pfd_bypass(data)                                (0x01000000&((data)<<24))
+#define REGD33_reg_p1_rxidle_bypass(data)                             (0x00800000&((data)<<23))
+#define REGD33_reg_p1_slope_manual(data)                              (0x00400000&((data)<<22))
+#define REGD33_reg_p1_slope_band(data)                                (0x003E0000&((data)<<17))
+#define REGD33_reg_p1_old_mode(data)                                  (0x00010000&((data)<<16))
+#define REGD33_get_reg_p1_start_en_manual(data)                       ((0x80000000&(data))>>31)
+#define REGD33_get_reg_p1_pfd_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD33_get_reg_p1_pfd_time(data)                              ((0x3E000000&(data))>>25)
+#define REGD33_get_reg_p1_pfd_bypass(data)                            ((0x01000000&(data))>>24)
+#define REGD33_get_reg_p1_rxidle_bypass(data)                         ((0x00800000&(data))>>23)
+#define REGD33_get_reg_p1_slope_manual(data)                          ((0x00400000&(data))>>22)
+#define REGD33_get_reg_p1_slope_band(data)                            ((0x003E0000&(data))>>17)
+#define REGD33_get_reg_p1_old_mode(data)                              ((0x00010000&(data))>>16)
+
+
+#define REGD34                                                        0xba4
+#define REGD34_reg_addr                                               "0x98034ba4"
+#define REGD34_reg                                                    0x98034ba4
+#define REGD34_inst_addr                                              "0x02E9"
+#define REGD34_inst                                                   0x02E9
+#define set_REGD34_reg(data)                                          (*((volatile unsigned int*)REGD34_reg)=data)
+#define get_REGD34_reg                                                (*((volatile unsigned int*)REGD34_reg))
+#define REGD34_p1_fld_st_reg_shift                                    (27)
+#define REGD34_p1_adp_en_fsm_reg_shift                                (26)
+#define REGD34_p1_cp_en_fsm_reg_shift                                 (25)
+#define REGD34_p1_coarse_fsm_reg_shift                                (18)
+#define REGD34_p1_pfd_en_fsm_reg_shift                                (17)
+#define REGD34_p1_slope_lv_reg_shift                                  (12)
+#define REGD34_p1_slope_hv_reg_shift                                  (7)
+#define REGD34_p1_slope_final_reg_shift                               (2)
+#define REGD34_p1_fld_st_reg_mask                                     (0xF8000000)
+#define REGD34_p1_adp_en_fsm_reg_mask                                 (0x04000000)
+#define REGD34_p1_cp_en_fsm_reg_mask                                  (0x02000000)
+#define REGD34_p1_coarse_fsm_reg_mask                                 (0x01FC0000)
+#define REGD34_p1_pfd_en_fsm_reg_mask                                 (0x00020000)
+#define REGD34_p1_slope_lv_reg_mask                                   (0x0001F000)
+#define REGD34_p1_slope_hv_reg_mask                                   (0x00000F80)
+#define REGD34_p1_slope_final_reg_mask                                (0x0000007C)
+#define REGD34_p1_fld_st_reg(data)                                    (0xF8000000&((data)<<27))
+#define REGD34_p1_adp_en_fsm_reg(data)                                (0x04000000&((data)<<26))
+#define REGD34_p1_cp_en_fsm_reg(data)                                 (0x02000000&((data)<<25))
+#define REGD34_p1_coarse_fsm_reg(data)                                (0x01FC0000&((data)<<18))
+#define REGD34_p1_pfd_en_fsm_reg(data)                                (0x00020000&((data)<<17))
+#define REGD34_p1_slope_lv_reg(data)                                  (0x0001F000&((data)<<12))
+#define REGD34_p1_slope_hv_reg(data)                                  (0x00000F80&((data)<<7))
+#define REGD34_p1_slope_final_reg(data)                               (0x0000007C&((data)<<2))
+#define REGD34_get_p1_fld_st_reg(data)                                ((0xF8000000&(data))>>27)
+#define REGD34_get_p1_adp_en_fsm_reg(data)                            ((0x04000000&(data))>>26)
+#define REGD34_get_p1_cp_en_fsm_reg(data)                             ((0x02000000&(data))>>25)
+#define REGD34_get_p1_coarse_fsm_reg(data)                            ((0x01FC0000&(data))>>18)
+#define REGD34_get_p1_pfd_en_fsm_reg(data)                            ((0x00020000&(data))>>17)
+#define REGD34_get_p1_slope_lv_reg(data)                              ((0x0001F000&(data))>>12)
+#define REGD34_get_p1_slope_hv_reg(data)                              ((0x00000F80&(data))>>7)
+#define REGD34_get_p1_slope_final_reg(data)                           ((0x0000007C&(data))>>2)
+
+
+#define REGD35                                                        0xba8
+#define REGD35_reg_addr                                               "0x98034ba8"
+#define REGD35_reg                                                    0x98034ba8
+#define REGD35_inst_addr                                              "0x02EA"
+#define REGD35_inst                                                   0x02EA
+#define set_REGD35_reg(data)                                          (*((volatile unsigned int*)REGD35_reg)=data)
+#define get_REGD35_reg                                                (*((volatile unsigned int*)REGD35_reg))
+#define REGD35_reg_p2_auto_mode_shift                                 (31)
+#define REGD35_reg_p2_adp_en_manual_shift                             (30)
+#define REGD35_reg_p2_cp_en_manual_shift                              (29)
+#define REGD35_reg_p2_adap_eq_off_shift                               (28)
+#define REGD35_reg_p2_adp_time_shift                                  (23)
+#define REGD35_reg_p2_calib_time_shift                                (20)
+#define REGD35_reg_p2_calib_manual_shift                              (19)
+#define REGD35_reg_p2_calib_late_shift                                (18)
+#define REGD35_reg_p2_vco_coarse_shift                                (11)
+#define REGD35_reg_p2_divide_num_shift                                (4)
+#define REGD35_reg_p2_init_time_shift                                 (1)
+#define REGD35_reg_p2_auto_mode_mask                                  (0x80000000)
+#define REGD35_reg_p2_adp_en_manual_mask                              (0x40000000)
+#define REGD35_reg_p2_cp_en_manual_mask                               (0x20000000)
+#define REGD35_reg_p2_adap_eq_off_mask                                (0x10000000)
+#define REGD35_reg_p2_adp_time_mask                                   (0x0F800000)
+#define REGD35_reg_p2_calib_time_mask                                 (0x00700000)
+#define REGD35_reg_p2_calib_manual_mask                               (0x00080000)
+#define REGD35_reg_p2_calib_late_mask                                 (0x00040000)
+#define REGD35_reg_p2_vco_coarse_mask                                 (0x0003F800)
+#define REGD35_reg_p2_divide_num_mask                                 (0x000007F0)
+#define REGD35_reg_p2_init_time_mask                                  (0x0000000E)
+#define REGD35_reg_p2_auto_mode(data)                                 (0x80000000&((data)<<31))
+#define REGD35_reg_p2_adp_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD35_reg_p2_cp_en_manual(data)                              (0x20000000&((data)<<29))
+#define REGD35_reg_p2_adap_eq_off(data)                               (0x10000000&((data)<<28))
+#define REGD35_reg_p2_adp_time(data)                                  (0x0F800000&((data)<<23))
+#define REGD35_reg_p2_calib_time(data)                                (0x00700000&((data)<<20))
+#define REGD35_reg_p2_calib_manual(data)                              (0x00080000&((data)<<19))
+#define REGD35_reg_p2_calib_late(data)                                (0x00040000&((data)<<18))
+#define REGD35_reg_p2_vco_coarse(data)                                (0x0003F800&((data)<<11))
+#define REGD35_reg_p2_divide_num(data)                                (0x000007F0&((data)<<4))
+#define REGD35_reg_p2_init_time(data)                                 (0x0000000E&((data)<<1))
+#define REGD35_get_reg_p2_auto_mode(data)                             ((0x80000000&(data))>>31)
+#define REGD35_get_reg_p2_adp_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD35_get_reg_p2_cp_en_manual(data)                          ((0x20000000&(data))>>29)
+#define REGD35_get_reg_p2_adap_eq_off(data)                           ((0x10000000&(data))>>28)
+#define REGD35_get_reg_p2_adp_time(data)                              ((0x0F800000&(data))>>23)
+#define REGD35_get_reg_p2_calib_time(data)                            ((0x00700000&(data))>>20)
+#define REGD35_get_reg_p2_calib_manual(data)                          ((0x00080000&(data))>>19)
+#define REGD35_get_reg_p2_calib_late(data)                            ((0x00040000&(data))>>18)
+#define REGD35_get_reg_p2_vco_coarse(data)                            ((0x0003F800&(data))>>11)
+#define REGD35_get_reg_p2_divide_num(data)                            ((0x000007F0&(data))>>4)
+#define REGD35_get_reg_p2_init_time(data)                             ((0x0000000E&(data))>>1)
+
+
+#define REGD36                                                        0xbac
+#define REGD36_reg_addr                                               "0x98034bac"
+#define REGD36_reg                                                    0x98034bac
+#define REGD36_inst_addr                                              "0x02EB"
+#define REGD36_inst                                                   0x02EB
+#define set_REGD36_reg(data)                                          (*((volatile unsigned int*)REGD36_reg)=data)
+#define get_REGD36_reg                                                (*((volatile unsigned int*)REGD36_reg))
+#define REGD36_reg_p2_lock_up_limit_shift                             (16)
+#define REGD36_reg_p2_lock_dn_limit_shift                             (0)
+#define REGD36_reg_p2_lock_up_limit_mask                              (0x07FF0000)
+#define REGD36_reg_p2_lock_dn_limit_mask                              (0x000007FF)
+#define REGD36_reg_p2_lock_up_limit(data)                             (0x07FF0000&((data)<<16))
+#define REGD36_reg_p2_lock_dn_limit(data)                             (0x000007FF&(data))
+#define REGD36_get_reg_p2_lock_up_limit(data)                         ((0x07FF0000&(data))>>16)
+#define REGD36_get_reg_p2_lock_dn_limit(data)                         (0x000007FF&(data))
+
+
+#define REGD37                                                        0xbb0
+#define REGD37_reg_addr                                               "0x98034bb0"
+#define REGD37_reg                                                    0x98034bb0
+#define REGD37_inst_addr                                              "0x02EC"
+#define REGD37_inst                                                   0x02EC
+#define set_REGD37_reg(data)                                          (*((volatile unsigned int*)REGD37_reg)=data)
+#define get_REGD37_reg                                                (*((volatile unsigned int*)REGD37_reg))
+#define REGD37_reg_p2_cdr_cp_shift                                    (12)
+#define REGD37_reg_p2_cdr_r_shift                                     (6)
+#define REGD37_reg_p2_cdr_c_shift                                     (4)
+#define REGD37_reg_p2_vc_sel_shift                                    (2)
+#define REGD37_reg_p2_calib_reset_sel_shift                           (1)
+#define REGD37_reg_p2_cdr_cp_mask                                     (0xFFFFF000)
+#define REGD37_reg_p2_cdr_r_mask                                      (0x00000FC0)
+#define REGD37_reg_p2_cdr_c_mask                                      (0x00000030)
+#define REGD37_reg_p2_vc_sel_mask                                     (0x0000000C)
+#define REGD37_reg_p2_calib_reset_sel_mask                            (0x00000002)
+#define REGD37_reg_p2_cdr_cp(data)                                    (0xFFFFF000&((data)<<12))
+#define REGD37_reg_p2_cdr_r(data)                                     (0x00000FC0&((data)<<6))
+#define REGD37_reg_p2_cdr_c(data)                                     (0x00000030&((data)<<4))
+#define REGD37_reg_p2_vc_sel(data)                                    (0x0000000C&((data)<<2))
+#define REGD37_reg_p2_calib_reset_sel(data)                           (0x00000002&((data)<<1))
+#define REGD37_get_reg_p2_cdr_cp(data)                                ((0xFFFFF000&(data))>>12)
+#define REGD37_get_reg_p2_cdr_r(data)                                 ((0x00000FC0&(data))>>6)
+#define REGD37_get_reg_p2_cdr_c(data)                                 ((0x00000030&(data))>>4)
+#define REGD37_get_reg_p2_vc_sel(data)                                ((0x0000000C&(data))>>2)
+#define REGD37_get_reg_p2_calib_reset_sel(data)                       ((0x00000002&(data))>>1)
+
+
+#define REGD38                                                        0xbb4
+#define REGD38_reg_addr                                               "0x98034bb4"
+#define REGD38_reg                                                    0x98034bb4
+#define REGD38_inst_addr                                              "0x02ED"
+#define REGD38_inst                                                   0x02ED
+#define set_REGD38_reg(data)                                          (*((volatile unsigned int*)REGD38_reg)=data)
+#define get_REGD38_reg                                                (*((volatile unsigned int*)REGD38_reg))
+#define REGD38_reg_p2_slope_lv_up_shift                               (21)
+#define REGD38_reg_p2_slope_lv_dn_shift                               (10)
+#define REGD38_reg_p2_cp_time_shift                                   (5)
+#define REGD38_reg_p2_timer_4_shift                                   (0)
+#define REGD38_reg_p2_slope_lv_up_mask                                (0xFFE00000)
+#define REGD38_reg_p2_slope_lv_dn_mask                                (0x001FFC00)
+#define REGD38_reg_p2_cp_time_mask                                    (0x000003E0)
+#define REGD38_reg_p2_timer_4_mask                                    (0x0000001F)
+#define REGD38_reg_p2_slope_lv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD38_reg_p2_slope_lv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD38_reg_p2_cp_time(data)                                   (0x000003E0&((data)<<5))
+#define REGD38_reg_p2_timer_4(data)                                   (0x0000001F&(data))
+#define REGD38_get_reg_p2_slope_lv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD38_get_reg_p2_slope_lv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD38_get_reg_p2_cp_time(data)                               ((0x000003E0&(data))>>5)
+#define REGD38_get_reg_p2_timer_4(data)                               (0x0000001F&(data))
+
+
+#define REGD39                                                        0xbb8
+#define REGD39_reg_addr                                               "0x98034bb8"
+#define REGD39_reg                                                    0x98034bb8
+#define REGD39_inst_addr                                              "0x02EE"
+#define REGD39_inst                                                   0x02EE
+#define set_REGD39_reg(data)                                          (*((volatile unsigned int*)REGD39_reg)=data)
+#define get_REGD39_reg                                                (*((volatile unsigned int*)REGD39_reg))
+#define REGD39_reg_p2_slope_hv_up_shift                               (21)
+#define REGD39_reg_p2_slope_hv_dn_shift                               (10)
+#define REGD39_reg_p2_timer_5_shift                                   (9)
+#define REGD39_reg_p2_timer_6_shift                                   (4)
+#define REGD39_reg_p2_slope_hv_up_mask                                (0xFFE00000)
+#define REGD39_reg_p2_slope_hv_dn_mask                                (0x001FFC00)
+#define REGD39_reg_p2_timer_5_mask                                    (0x00000200)
+#define REGD39_reg_p2_timer_6_mask                                    (0x000001F0)
+#define REGD39_reg_p2_slope_hv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD39_reg_p2_slope_hv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD39_reg_p2_timer_5(data)                                   (0x00000200&((data)<<9))
+#define REGD39_reg_p2_timer_6(data)                                   (0x000001F0&((data)<<4))
+#define REGD39_get_reg_p2_slope_hv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD39_get_reg_p2_slope_hv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD39_get_reg_p2_timer_5(data)                               ((0x00000200&(data))>>9)
+#define REGD39_get_reg_p2_timer_6(data)                               ((0x000001F0&(data))>>4)
+
+
+#define REGD40                                                        0xbbc
+#define REGD40_reg_addr                                               "0x98034bbc"
+#define REGD40_reg                                                    0x98034bbc
+#define REGD40_inst_addr                                              "0x02EF"
+#define REGD40_inst                                                   0x02EF
+#define set_REGD40_reg(data)                                          (*((volatile unsigned int*)REGD40_reg)=data)
+#define get_REGD40_reg                                                (*((volatile unsigned int*)REGD40_reg))
+#define REGD40_reg_p2_start_en_manual_shift                           (31)
+#define REGD40_reg_p2_pfd_en_manual_shift                             (30)
+#define REGD40_reg_p2_pfd_time_shift                                  (25)
+#define REGD40_reg_p2_pfd_bypass_shift                                (24)
+#define REGD40_reg_p2_rxidle_bypass_shift                             (23)
+#define REGD40_reg_p2_slope_manual_shift                              (22)
+#define REGD40_reg_p2_slope_band_shift                                (17)
+#define REGD40_reg_p2_old_mode_shift                                  (16)
+#define REGD40_reg_p2_start_en_manual_mask                            (0x80000000)
+#define REGD40_reg_p2_pfd_en_manual_mask                              (0x40000000)
+#define REGD40_reg_p2_pfd_time_mask                                   (0x3E000000)
+#define REGD40_reg_p2_pfd_bypass_mask                                 (0x01000000)
+#define REGD40_reg_p2_rxidle_bypass_mask                              (0x00800000)
+#define REGD40_reg_p2_slope_manual_mask                               (0x00400000)
+#define REGD40_reg_p2_slope_band_mask                                 (0x003E0000)
+#define REGD40_reg_p2_old_mode_mask                                   (0x00010000)
+#define REGD40_reg_p2_start_en_manual(data)                           (0x80000000&((data)<<31))
+#define REGD40_reg_p2_pfd_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD40_reg_p2_pfd_time(data)                                  (0x3E000000&((data)<<25))
+#define REGD40_reg_p2_pfd_bypass(data)                                (0x01000000&((data)<<24))
+#define REGD40_reg_p2_rxidle_bypass(data)                             (0x00800000&((data)<<23))
+#define REGD40_reg_p2_slope_manual(data)                              (0x00400000&((data)<<22))
+#define REGD40_reg_p2_slope_band(data)                                (0x003E0000&((data)<<17))
+#define REGD40_reg_p2_old_mode(data)                                  (0x00010000&((data)<<16))
+#define REGD40_get_reg_p2_start_en_manual(data)                       ((0x80000000&(data))>>31)
+#define REGD40_get_reg_p2_pfd_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD40_get_reg_p2_pfd_time(data)                              ((0x3E000000&(data))>>25)
+#define REGD40_get_reg_p2_pfd_bypass(data)                            ((0x01000000&(data))>>24)
+#define REGD40_get_reg_p2_rxidle_bypass(data)                         ((0x00800000&(data))>>23)
+#define REGD40_get_reg_p2_slope_manual(data)                          ((0x00400000&(data))>>22)
+#define REGD40_get_reg_p2_slope_band(data)                            ((0x003E0000&(data))>>17)
+#define REGD40_get_reg_p2_old_mode(data)                              ((0x00010000&(data))>>16)
+
+
+#define REGD41                                                        0xbc0
+#define REGD41_reg_addr                                               "0x98034bc0"
+#define REGD41_reg                                                    0x98034bc0
+#define REGD41_inst_addr                                              "0x02F0"
+#define REGD41_inst                                                   0x02F0
+#define set_REGD41_reg(data)                                          (*((volatile unsigned int*)REGD41_reg)=data)
+#define get_REGD41_reg                                                (*((volatile unsigned int*)REGD41_reg))
+#define REGD41_p2_fld_st_reg_shift                                    (27)
+#define REGD41_p2_adp_en_fsm_reg_shift                                (26)
+#define REGD41_p2_cp_en_fsm_reg_shift                                 (25)
+#define REGD41_p2_coarse_fsm_reg_shift                                (18)
+#define REGD41_p2_pfd_en_fsm_reg_shift                                (17)
+#define REGD41_p2_slope_lv_reg_shift                                  (12)
+#define REGD41_p2_slope_hv_reg_shift                                  (7)
+#define REGD41_p2_slope_final_reg_shift                               (2)
+#define REGD41_p2_fld_st_reg_mask                                     (0xF8000000)
+#define REGD41_p2_adp_en_fsm_reg_mask                                 (0x04000000)
+#define REGD41_p2_cp_en_fsm_reg_mask                                  (0x02000000)
+#define REGD41_p2_coarse_fsm_reg_mask                                 (0x01FC0000)
+#define REGD41_p2_pfd_en_fsm_reg_mask                                 (0x00020000)
+#define REGD41_p2_slope_lv_reg_mask                                   (0x0001F000)
+#define REGD41_p2_slope_hv_reg_mask                                   (0x00000F80)
+#define REGD41_p2_slope_final_reg_mask                                (0x0000007C)
+#define REGD41_p2_fld_st_reg(data)                                    (0xF8000000&((data)<<27))
+#define REGD41_p2_adp_en_fsm_reg(data)                                (0x04000000&((data)<<26))
+#define REGD41_p2_cp_en_fsm_reg(data)                                 (0x02000000&((data)<<25))
+#define REGD41_p2_coarse_fsm_reg(data)                                (0x01FC0000&((data)<<18))
+#define REGD41_p2_pfd_en_fsm_reg(data)                                (0x00020000&((data)<<17))
+#define REGD41_p2_slope_lv_reg(data)                                  (0x0001F000&((data)<<12))
+#define REGD41_p2_slope_hv_reg(data)                                  (0x00000F80&((data)<<7))
+#define REGD41_p2_slope_final_reg(data)                               (0x0000007C&((data)<<2))
+#define REGD41_get_p2_fld_st_reg(data)                                ((0xF8000000&(data))>>27)
+#define REGD41_get_p2_adp_en_fsm_reg(data)                            ((0x04000000&(data))>>26)
+#define REGD41_get_p2_cp_en_fsm_reg(data)                             ((0x02000000&(data))>>25)
+#define REGD41_get_p2_coarse_fsm_reg(data)                            ((0x01FC0000&(data))>>18)
+#define REGD41_get_p2_pfd_en_fsm_reg(data)                            ((0x00020000&(data))>>17)
+#define REGD41_get_p2_slope_lv_reg(data)                              ((0x0001F000&(data))>>12)
+#define REGD41_get_p2_slope_hv_reg(data)                              ((0x00000F80&(data))>>7)
+#define REGD41_get_p2_slope_final_reg(data)                           ((0x0000007C&(data))>>2)
+
+
+#define REGD42                                                        0xbc4
+#define REGD42_reg_addr                                               "0x98034bc4"
+#define REGD42_reg                                                    0x98034bc4
+#define REGD42_inst_addr                                              "0x02F1"
+#define REGD42_inst                                                   0x02F1
+#define set_REGD42_reg(data)                                          (*((volatile unsigned int*)REGD42_reg)=data)
+#define get_REGD42_reg                                                (*((volatile unsigned int*)REGD42_reg))
+#define REGD42_p0_ck_md_rstb_shift                                    (31)
+#define REGD42_reg_p0_ck_md_threshold_shift                           (25)
+#define REGD42_reg_p0_ck_md_debounce_shift                            (18)
+#define REGD42_reg_p0_ck_md_sel_shift                                 (16)
+#define REGD42_reg_p0_ck_md_auto_shift                                (15)
+#define REGD42_reg_p0_ck_md_adj_shift                                 (11)
+#define REGD42_reg_p0_ck_error_limit_shift                            (6)
+#define REGD42_reg_p0_ck_md_reserved_shift                            (2)
+#define REGD42_p0_ck_md_rstb_mask                                     (0x80000000)
+#define REGD42_reg_p0_ck_md_threshold_mask                            (0x7E000000)
+#define REGD42_reg_p0_ck_md_debounce_mask                             (0x01FC0000)
+#define REGD42_reg_p0_ck_md_sel_mask                                  (0x00030000)
+#define REGD42_reg_p0_ck_md_auto_mask                                 (0x00008000)
+#define REGD42_reg_p0_ck_md_adj_mask                                  (0x00007800)
+#define REGD42_reg_p0_ck_error_limit_mask                             (0x000007C0)
+#define REGD42_reg_p0_ck_md_reserved_mask                             (0x0000003C)
+#define REGD42_p0_ck_md_rstb(data)                                    (0x80000000&((data)<<31))
+#define REGD42_reg_p0_ck_md_threshold(data)                           (0x7E000000&((data)<<25))
+#define REGD42_reg_p0_ck_md_debounce(data)                            (0x01FC0000&((data)<<18))
+#define REGD42_reg_p0_ck_md_sel(data)                                 (0x00030000&((data)<<16))
+#define REGD42_reg_p0_ck_md_auto(data)                                (0x00008000&((data)<<15))
+#define REGD42_reg_p0_ck_md_adj(data)                                 (0x00007800&((data)<<11))
+#define REGD42_reg_p0_ck_error_limit(data)                            (0x000007C0&((data)<<6))
+#define REGD42_reg_p0_ck_md_reserved(data)                            (0x0000003C&((data)<<2))
+#define REGD42_get_p0_ck_md_rstb(data)                                ((0x80000000&(data))>>31)
+#define REGD42_get_reg_p0_ck_md_threshold(data)                       ((0x7E000000&(data))>>25)
+#define REGD42_get_reg_p0_ck_md_debounce(data)                        ((0x01FC0000&(data))>>18)
+#define REGD42_get_reg_p0_ck_md_sel(data)                             ((0x00030000&(data))>>16)
+#define REGD42_get_reg_p0_ck_md_auto(data)                            ((0x00008000&(data))>>15)
+#define REGD42_get_reg_p0_ck_md_adj(data)                             ((0x00007800&(data))>>11)
+#define REGD42_get_reg_p0_ck_error_limit(data)                        ((0x000007C0&(data))>>6)
+#define REGD42_get_reg_p0_ck_md_reserved(data)                        ((0x0000003C&(data))>>2)
+
+
+#define REGD43                                                        0xbc8
+#define REGD43_reg_addr                                               "0x98034bc8"
+#define REGD43_reg                                                    0x98034bc8
+#define REGD43_inst_addr                                              "0x02F2"
+#define REGD43_inst                                                   0x02F2
+#define set_REGD43_reg(data)                                          (*((volatile unsigned int*)REGD43_reg)=data)
+#define get_REGD43_reg                                                (*((volatile unsigned int*)REGD43_reg))
+#define REGD43_p0_ck_md_count_shift                                   (19)
+#define REGD43_p0_ck_rate_shift                                       (15)
+#define REGD43_p0_unstable_count_shift                                (10)
+#define REGD43_p0_ck_md_ok_shift                                      (9)
+#define REGD43_p0_clock_unstable_flag_shift                           (8)
+#define REGD43_p0_ck_md_count_mask                                    (0xFFF80000)
+#define REGD43_p0_ck_rate_mask                                        (0x00078000)
+#define REGD43_p0_unstable_count_mask                                 (0x00007C00)
+#define REGD43_p0_ck_md_ok_mask                                       (0x00000200)
+#define REGD43_p0_clock_unstable_flag_mask                            (0x00000100)
+#define REGD43_p0_ck_md_count(data)                                   (0xFFF80000&((data)<<19))
+#define REGD43_p0_ck_rate(data)                                       (0x00078000&((data)<<15))
+#define REGD43_p0_unstable_count(data)                                (0x00007C00&((data)<<10))
+#define REGD43_p0_ck_md_ok(data)                                      (0x00000200&((data)<<9))
+#define REGD43_p0_clock_unstable_flag(data)                           (0x00000100&((data)<<8))
+#define REGD43_get_p0_ck_md_count(data)                               ((0xFFF80000&(data))>>19)
+#define REGD43_get_p0_ck_rate(data)                                   ((0x00078000&(data))>>15)
+#define REGD43_get_p0_unstable_count(data)                            ((0x00007C00&(data))>>10)
+#define REGD43_get_p0_ck_md_ok(data)                                  ((0x00000200&(data))>>9)
+#define REGD43_get_p0_clock_unstable_flag(data)                       ((0x00000100&(data))>>8)
+
+
+#define REGD44                                                        0xbcc
+#define REGD44_reg_addr                                               "0x98034bcc"
+#define REGD44_reg                                                    0x98034bcc
+#define REGD44_inst_addr                                              "0x02F3"
+#define REGD44_inst                                                   0x02F3
+#define set_REGD44_reg(data)                                          (*((volatile unsigned int*)REGD44_reg)=data)
+#define get_REGD44_reg                                                (*((volatile unsigned int*)REGD44_reg))
+#define REGD44_p1_ck_md_rstb_shift                                    (31)
+#define REGD44_reg_p1_ck_md_threshold_shift                           (25)
+#define REGD44_reg_p1_ck_md_debounce_shift                            (18)
+#define REGD44_reg_p1_ck_md_sel_shift                                 (16)
+#define REGD44_reg_p1_ck_md_auto_shift                                (15)
+#define REGD44_reg_p1_ck_md_adj_shift                                 (11)
+#define REGD44_reg_p1_ck_error_limit_shift                            (6)
+#define REGD44_reg_p1_ck_md_reserved_shift                            (2)
+#define REGD44_p1_ck_md_rstb_mask                                     (0x80000000)
+#define REGD44_reg_p1_ck_md_threshold_mask                            (0x7E000000)
+#define REGD44_reg_p1_ck_md_debounce_mask                             (0x01FC0000)
+#define REGD44_reg_p1_ck_md_sel_mask                                  (0x00030000)
+#define REGD44_reg_p1_ck_md_auto_mask                                 (0x00008000)
+#define REGD44_reg_p1_ck_md_adj_mask                                  (0x00007800)
+#define REGD44_reg_p1_ck_error_limit_mask                             (0x000007C0)
+#define REGD44_reg_p1_ck_md_reserved_mask                             (0x0000003C)
+#define REGD44_p1_ck_md_rstb(data)                                    (0x80000000&((data)<<31))
+#define REGD44_reg_p1_ck_md_threshold(data)                           (0x7E000000&((data)<<25))
+#define REGD44_reg_p1_ck_md_debounce(data)                            (0x01FC0000&((data)<<18))
+#define REGD44_reg_p1_ck_md_sel(data)                                 (0x00030000&((data)<<16))
+#define REGD44_reg_p1_ck_md_auto(data)                                (0x00008000&((data)<<15))
+#define REGD44_reg_p1_ck_md_adj(data)                                 (0x00007800&((data)<<11))
+#define REGD44_reg_p1_ck_error_limit(data)                            (0x000007C0&((data)<<6))
+#define REGD44_reg_p1_ck_md_reserved(data)                            (0x0000003C&((data)<<2))
+#define REGD44_get_p1_ck_md_rstb(data)                                ((0x80000000&(data))>>31)
+#define REGD44_get_reg_p1_ck_md_threshold(data)                       ((0x7E000000&(data))>>25)
+#define REGD44_get_reg_p1_ck_md_debounce(data)                        ((0x01FC0000&(data))>>18)
+#define REGD44_get_reg_p1_ck_md_sel(data)                             ((0x00030000&(data))>>16)
+#define REGD44_get_reg_p1_ck_md_auto(data)                            ((0x00008000&(data))>>15)
+#define REGD44_get_reg_p1_ck_md_adj(data)                             ((0x00007800&(data))>>11)
+#define REGD44_get_reg_p1_ck_error_limit(data)                        ((0x000007C0&(data))>>6)
+#define REGD44_get_reg_p1_ck_md_reserved(data)                        ((0x0000003C&(data))>>2)
+
+
+#define REGD45                                                        0xbd0
+#define REGD45_reg_addr                                               "0x98034bd0"
+#define REGD45_reg                                                    0x98034bd0
+#define REGD45_inst_addr                                              "0x02F4"
+#define REGD45_inst                                                   0x02F4
+#define set_REGD45_reg(data)                                          (*((volatile unsigned int*)REGD45_reg)=data)
+#define get_REGD45_reg                                                (*((volatile unsigned int*)REGD45_reg))
+#define REGD45_p1_ck_md_count_shift                                   (19)
+#define REGD45_p1_ck_rate_shift                                       (15)
+#define REGD45_p1_unstable_count_shift                                (10)
+#define REGD45_p1_ck_md_ok_shift                                      (9)
+#define REGD45_p1_clock_unstable_flag_shift                           (8)
+#define REGD45_p1_ck_md_count_mask                                    (0xFFF80000)
+#define REGD45_p1_ck_rate_mask                                        (0x00078000)
+#define REGD45_p1_unstable_count_mask                                 (0x00007C00)
+#define REGD45_p1_ck_md_ok_mask                                       (0x00000200)
+#define REGD45_p1_clock_unstable_flag_mask                            (0x00000100)
+#define REGD45_p1_ck_md_count(data)                                   (0xFFF80000&((data)<<19))
+#define REGD45_p1_ck_rate(data)                                       (0x00078000&((data)<<15))
+#define REGD45_p1_unstable_count(data)                                (0x00007C00&((data)<<10))
+#define REGD45_p1_ck_md_ok(data)                                      (0x00000200&((data)<<9))
+#define REGD45_p1_clock_unstable_flag(data)                           (0x00000100&((data)<<8))
+#define REGD45_get_p1_ck_md_count(data)                               ((0xFFF80000&(data))>>19)
+#define REGD45_get_p1_ck_rate(data)                                   ((0x00078000&(data))>>15)
+#define REGD45_get_p1_unstable_count(data)                            ((0x00007C00&(data))>>10)
+#define REGD45_get_p1_ck_md_ok(data)                                  ((0x00000200&(data))>>9)
+#define REGD45_get_p1_clock_unstable_flag(data)                       ((0x00000100&(data))>>8)
+
+
+#define REGD46                                                        0xbd4
+#define REGD46_reg_addr                                               "0x98034bd4"
+#define REGD46_reg                                                    0x98034bd4
+#define REGD46_inst_addr                                              "0x02F5"
+#define REGD46_inst                                                   0x02F5
+#define set_REGD46_reg(data)                                          (*((volatile unsigned int*)REGD46_reg)=data)
+#define get_REGD46_reg                                                (*((volatile unsigned int*)REGD46_reg))
+#define REGD46_p2_ck_md_rstb_shift                                    (31)
+#define REGD46_reg_p2_ck_md_threshold_shift                           (25)
+#define REGD46_reg_p2_ck_md_debounce_shift                            (18)
+#define REGD46_reg_p2_ck_md_sel_shift                                 (16)
+#define REGD46_reg_p2_ck_md_auto_shift                                (15)
+#define REGD46_reg_p2_ck_md_adj_shift                                 (11)
+#define REGD46_reg_p2_ck_error_limit_shift                            (6)
+#define REGD46_reg_p2_ck_md_reserved_shift                            (2)
+#define REGD46_p2_ck_md_rstb_mask                                     (0x80000000)
+#define REGD46_reg_p2_ck_md_threshold_mask                            (0x7E000000)
+#define REGD46_reg_p2_ck_md_debounce_mask                             (0x01FC0000)
+#define REGD46_reg_p2_ck_md_sel_mask                                  (0x00030000)
+#define REGD46_reg_p2_ck_md_auto_mask                                 (0x00008000)
+#define REGD46_reg_p2_ck_md_adj_mask                                  (0x00007800)
+#define REGD46_reg_p2_ck_error_limit_mask                             (0x000007C0)
+#define REGD46_reg_p2_ck_md_reserved_mask                             (0x0000003C)
+#define REGD46_p2_ck_md_rstb(data)                                    (0x80000000&((data)<<31))
+#define REGD46_reg_p2_ck_md_threshold(data)                           (0x7E000000&((data)<<25))
+#define REGD46_reg_p2_ck_md_debounce(data)                            (0x01FC0000&((data)<<18))
+#define REGD46_reg_p2_ck_md_sel(data)                                 (0x00030000&((data)<<16))
+#define REGD46_reg_p2_ck_md_auto(data)                                (0x00008000&((data)<<15))
+#define REGD46_reg_p2_ck_md_adj(data)                                 (0x00007800&((data)<<11))
+#define REGD46_reg_p2_ck_error_limit(data)                            (0x000007C0&((data)<<6))
+#define REGD46_reg_p2_ck_md_reserved(data)                            (0x0000003C&((data)<<2))
+#define REGD46_get_p2_ck_md_rstb(data)                                ((0x80000000&(data))>>31)
+#define REGD46_get_reg_p2_ck_md_threshold(data)                       ((0x7E000000&(data))>>25)
+#define REGD46_get_reg_p2_ck_md_debounce(data)                        ((0x01FC0000&(data))>>18)
+#define REGD46_get_reg_p2_ck_md_sel(data)                             ((0x00030000&(data))>>16)
+#define REGD46_get_reg_p2_ck_md_auto(data)                            ((0x00008000&(data))>>15)
+#define REGD46_get_reg_p2_ck_md_adj(data)                             ((0x00007800&(data))>>11)
+#define REGD46_get_reg_p2_ck_error_limit(data)                        ((0x000007C0&(data))>>6)
+#define REGD46_get_reg_p2_ck_md_reserved(data)                        ((0x0000003C&(data))>>2)
+
+
+#define REGD47                                                        0xbd8
+#define REGD47_reg_addr                                               "0x98034bd8"
+#define REGD47_reg                                                    0x98034bd8
+#define REGD47_inst_addr                                              "0x02F6"
+#define REGD47_inst                                                   0x02F6
+#define set_REGD47_reg(data)                                          (*((volatile unsigned int*)REGD47_reg)=data)
+#define get_REGD47_reg                                                (*((volatile unsigned int*)REGD47_reg))
+#define REGD47_p2_ck_md_count_shift                                   (19)
+#define REGD47_p2_ck_rate_shift                                       (15)
+#define REGD47_p2_unstable_count_shift                                (10)
+#define REGD47_p2_ck_md_ok_shift                                      (9)
+#define REGD47_p2_clock_unstable_flag_shift                           (8)
+#define REGD47_p2_ck_md_count_mask                                    (0xFFF80000)
+#define REGD47_p2_ck_rate_mask                                        (0x00078000)
+#define REGD47_p2_unstable_count_mask                                 (0x00007C00)
+#define REGD47_p2_ck_md_ok_mask                                       (0x00000200)
+#define REGD47_p2_clock_unstable_flag_mask                            (0x00000100)
+#define REGD47_p2_ck_md_count(data)                                   (0xFFF80000&((data)<<19))
+#define REGD47_p2_ck_rate(data)                                       (0x00078000&((data)<<15))
+#define REGD47_p2_unstable_count(data)                                (0x00007C00&((data)<<10))
+#define REGD47_p2_ck_md_ok(data)                                      (0x00000200&((data)<<9))
+#define REGD47_p2_clock_unstable_flag(data)                           (0x00000100&((data)<<8))
+#define REGD47_get_p2_ck_md_count(data)                               ((0xFFF80000&(data))>>19)
+#define REGD47_get_p2_ck_rate(data)                                   ((0x00078000&(data))>>15)
+#define REGD47_get_p2_unstable_count(data)                            ((0x00007C00&(data))>>10)
+#define REGD47_get_p2_ck_md_ok(data)                                  ((0x00000200&(data))>>9)
+#define REGD47_get_p2_clock_unstable_flag(data)                       ((0x00000100&(data))>>8)
+
+
+#define REGD48                                                        0xbdc
+#define REGD48_reg_addr                                               "0x98034bdc"
+#define REGD48_reg                                                    0x98034bdc
+#define REGD48_inst_addr                                              "0x02F7"
+#define REGD48_inst                                                   0x02F7
+#define set_REGD48_reg(data)                                          (*((volatile unsigned int*)REGD48_reg)=data)
+#define get_REGD48_reg                                                (*((volatile unsigned int*)REGD48_reg))
+#define REGD48_reg_dig_debug_sel_shift                                (28)
+#define REGD48_reg_dig_reserved_0_shift                               (20)
+#define REGD48_reg_dig_reserved_1_shift                               (12)
+#define REGD48_reg_dig_reserved_2_shift                               (4)
+#define REGD48_reg_dig_debug_sel_mask                                 (0xF0000000)
+#define REGD48_reg_dig_reserved_0_mask                                (0x0FF00000)
+#define REGD48_reg_dig_reserved_1_mask                                (0x000FF000)
+#define REGD48_reg_dig_reserved_2_mask                                (0x00000FF0)
+#define REGD48_reg_dig_debug_sel(data)                                (0xF0000000&((data)<<28))
+#define REGD48_reg_dig_reserved_0(data)                               (0x0FF00000&((data)<<20))
+#define REGD48_reg_dig_reserved_1(data)                               (0x000FF000&((data)<<12))
+#define REGD48_reg_dig_reserved_2(data)                               (0x00000FF0&((data)<<4))
+#define REGD48_get_reg_dig_debug_sel(data)                            ((0xF0000000&(data))>>28)
+#define REGD48_get_reg_dig_reserved_0(data)                           ((0x0FF00000&(data))>>20)
+#define REGD48_get_reg_dig_reserved_1(data)                           ((0x000FF000&(data))>>12)
+#define REGD48_get_reg_dig_reserved_2(data)                           ((0x00000FF0&(data))>>4)
+
+
+#define REGD49                                                        0xbe0
+#define REGD49_reg_addr                                               "0x98034be0"
+#define REGD49_reg                                                    0x98034be0
+#define REGD49_inst_addr                                              "0x02F8"
+#define REGD49_inst                                                   0x02F8
+#define set_REGD49_reg(data)                                          (*((volatile unsigned int*)REGD49_reg)=data)
+#define get_REGD49_reg                                                (*((volatile unsigned int*)REGD49_reg))
+#define REGD49_reg_p0_st_m_value_shift                                (0)
+#define REGD49_reg_p0_st_m_value_mask                                 (0xFFFFFFFF)
+#define REGD49_reg_p0_st_m_value(data)                                (0xFFFFFFFF&(data))
+#define REGD49_get_reg_p0_st_m_value(data)                            (0xFFFFFFFF&(data))
+
+
+#define REGD50                                                        0xbe4
+#define REGD50_reg_addr                                               "0x98034be4"
+#define REGD50_reg                                                    0x98034be4
+#define REGD50_inst_addr                                              "0x02F9"
+#define REGD50_inst                                                   0x02F9
+#define set_REGD50_reg(data)                                          (*((volatile unsigned int*)REGD50_reg)=data)
+#define get_REGD50_reg                                                (*((volatile unsigned int*)REGD50_reg))
+#define REGD50_reg_p1_st_m_value_shift                                (0)
+#define REGD50_reg_p1_st_m_value_mask                                 (0xFFFFFFFF)
+#define REGD50_reg_p1_st_m_value(data)                                (0xFFFFFFFF&(data))
+#define REGD50_get_reg_p1_st_m_value(data)                            (0xFFFFFFFF&(data))
+
+
+#define REGD51                                                        0xbe8
+#define REGD51_reg_addr                                               "0x98034be8"
+#define REGD51_reg                                                    0x98034be8
+#define REGD51_inst_addr                                              "0x02FA"
+#define REGD51_inst                                                   0x02FA
+#define set_REGD51_reg(data)                                          (*((volatile unsigned int*)REGD51_reg)=data)
+#define get_REGD51_reg                                                (*((volatile unsigned int*)REGD51_reg))
+#define REGD51_reg_p2_st_m_value_shift                                (0)
+#define REGD51_reg_p2_st_m_value_mask                                 (0xFFFFFFFF)
+#define REGD51_reg_p2_st_m_value(data)                                (0xFFFFFFFF&(data))
+#define REGD51_get_reg_p2_st_m_value(data)                            (0xFFFFFFFF&(data))
+
+
+#define REGD52                                                        0xbec
+#define REGD52_reg_addr                                               "0x98034bec"
+#define REGD52_reg                                                    0x98034bec
+#define REGD52_inst_addr                                              "0x02FB"
+#define REGD52_inst                                                   0x02FB
+#define set_REGD52_reg(data)                                          (*((volatile unsigned int*)REGD52_reg)=data)
+#define get_REGD52_reg                                                (*((volatile unsigned int*)REGD52_reg))
+#define REGD52_reg_eye_monitor_ck_sel_shift                           (20)
+#define REGD52_eye_monitor_dout_shift                                 (0)
+#define REGD52_reg_eye_monitor_ck_sel_mask                            (0x00300000)
+#define REGD52_eye_monitor_dout_mask                                  (0x0000FFFF)
+#define REGD52_reg_eye_monitor_ck_sel(data)                           (0x00300000&((data)<<20))
+#define REGD52_eye_monitor_dout(data)                                 (0x0000FFFF&(data))
+#define REGD52_get_reg_eye_monitor_ck_sel(data)                       ((0x00300000&(data))>>20)
+#define REGD52_get_eye_monitor_dout(data)                             (0x0000FFFF&(data))
+
+
+#define REGD53                                                        0xbf0
+#define REGD53_reg_addr                                               "0x98034bf0"
+#define REGD53_reg                                                    0x98034bf0
+#define REGD53_inst_addr                                              "0x02FC"
+#define REGD53_inst                                                   0x02FC
+#define set_REGD53_reg(data)                                          (*((volatile unsigned int*)REGD53_reg)=data)
+#define get_REGD53_reg                                                (*((volatile unsigned int*)REGD53_reg))
+#define REGD53_reg_p0_st_m_value_g_shift                              (0)
+#define REGD53_reg_p0_st_m_value_g_mask                               (0xFFFFFFFF)
+#define REGD53_reg_p0_st_m_value_g(data)                              (0xFFFFFFFF&(data))
+#define REGD53_get_reg_p0_st_m_value_g(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD54                                                        0xbf4
+#define REGD54_reg_addr                                               "0x98034bf4"
+#define REGD54_reg                                                    0x98034bf4
+#define REGD54_inst_addr                                              "0x02FD"
+#define REGD54_inst                                                   0x02FD
+#define set_REGD54_reg(data)                                          (*((volatile unsigned int*)REGD54_reg)=data)
+#define get_REGD54_reg                                                (*((volatile unsigned int*)REGD54_reg))
+#define REGD54_reg_p1_st_m_value_g_shift                              (0)
+#define REGD54_reg_p1_st_m_value_g_mask                               (0xFFFFFFFF)
+#define REGD54_reg_p1_st_m_value_g(data)                              (0xFFFFFFFF&(data))
+#define REGD54_get_reg_p1_st_m_value_g(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD55                                                        0xbf8
+#define REGD55_reg_addr                                               "0x98034bf8"
+#define REGD55_reg                                                    0x98034bf8
+#define REGD55_inst_addr                                              "0x02FE"
+#define REGD55_inst                                                   0x02FE
+#define set_REGD55_reg(data)                                          (*((volatile unsigned int*)REGD55_reg)=data)
+#define get_REGD55_reg                                                (*((volatile unsigned int*)REGD55_reg))
+#define REGD55_reg_p2_st_m_value_g_shift                              (0)
+#define REGD55_reg_p2_st_m_value_g_mask                               (0xFFFFFFFF)
+#define REGD55_reg_p2_st_m_value_g(data)                              (0xFFFFFFFF&(data))
+#define REGD55_get_reg_p2_st_m_value_g(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD56                                                        0xbfc
+#define REGD56_reg_addr                                               "0x98034bfc"
+#define REGD56_reg                                                    0x98034bfc
+#define REGD56_inst_addr                                              "0x02FF"
+#define REGD56_inst                                                   0x02FF
+#define set_REGD56_reg(data)                                          (*((volatile unsigned int*)REGD56_reg)=data)
+#define get_REGD56_reg                                                (*((volatile unsigned int*)REGD56_reg))
+#define REGD56_reg_p0_st_m_value_b_shift                              (0)
+#define REGD56_reg_p0_st_m_value_b_mask                               (0xFFFFFFFF)
+#define REGD56_reg_p0_st_m_value_b(data)                              (0xFFFFFFFF&(data))
+#define REGD56_get_reg_p0_st_m_value_b(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD57                                                        0xc00
+#define REGD57_reg_addr                                               "0x98034c00"
+#define REGD57_reg                                                    0x98034c00
+#define REGD57_inst_addr                                              "0x0300"
+#define REGD57_inst                                                   0x0300
+#define set_REGD57_reg(data)                                          (*((volatile unsigned int*)REGD57_reg)=data)
+#define get_REGD57_reg                                                (*((volatile unsigned int*)REGD57_reg))
+#define REGD57_reg_p1_st_m_value_b_shift                              (0)
+#define REGD57_reg_p1_st_m_value_b_mask                               (0xFFFFFFFF)
+#define REGD57_reg_p1_st_m_value_b(data)                              (0xFFFFFFFF&(data))
+#define REGD57_get_reg_p1_st_m_value_b(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD58                                                        0xc04
+#define REGD58_reg_addr                                               "0x98034c04"
+#define REGD58_reg                                                    0x98034c04
+#define REGD58_inst_addr                                              "0x0301"
+#define REGD58_inst                                                   0x0301
+#define set_REGD58_reg(data)                                          (*((volatile unsigned int*)REGD58_reg)=data)
+#define get_REGD58_reg                                                (*((volatile unsigned int*)REGD58_reg))
+#define REGD58_reg_p2_st_m_value_b_shift                              (0)
+#define REGD58_reg_p2_st_m_value_b_mask                               (0xFFFFFFFF)
+#define REGD58_reg_p2_st_m_value_b(data)                              (0xFFFFFFFF&(data))
+#define REGD58_get_reg_p2_st_m_value_b(data)                          (0xFFFFFFFF&(data))
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/DFE_fw.h b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/DFE_fw.h
new file mode 100644
index 00000000..eaa0375
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/DFE_fw.h
@@ -0,0 +1,721 @@
+/*===========*@date:2015/3/6===========*/
+
+#ifndef _DFE_REG_H_INCLUDED_
+#define _DFE_REG_H_INCLUDED_
+
+
+#define REG_DFE_EN_L0                                                 0xf00
+#define REG_DFE_EN_L0_reg_addr                                        "0x98034f00"
+#define REG_DFE_EN_L0_reg                                             0x98034f00
+#define REG_DFE_EN_L0_inst_addr                                       "0x03C0"
+#define REG_DFE_EN_L0_inst                                            0x03C0
+#define set_REG_DFE_EN_L0_reg(data)                                   (*((volatile unsigned int*)REG_DFE_EN_L0_reg)=data)
+#define get_REG_DFE_EN_L0_reg                                         (*((volatile unsigned int*)REG_DFE_EN_L0_reg))
+#define REG_DFE_EN_L0_clk_inv_lane0_shift                             (31)
+#define REG_DFE_EN_L0_timer_ctrl_en_lane0_shift                       (30)
+#define REG_DFE_EN_L0_reduce_adapt_gain_lane0_shift                   (28)
+#define REG_DFE_EN_L0_rl_det_en_lane0_shift                           (27)
+#define REG_DFE_EN_L0_rl_det_mode_lane0_shift                         (26)
+#define REG_DFE_EN_L0_rl_threshold_lane0_shift                        (24)
+#define REG_DFE_EN_L0_dfe_adapt_en_lane0_shift                        (16)
+#define REG_DFE_EN_L0_le_min_lane0_shift                              (11)
+#define REG_DFE_EN_L0_le_init_lane0_shift                             (6)
+#define REG_DFE_EN_L0_tap4_init_lane0_shift                           (0)
+#define REG_DFE_EN_L0_clk_inv_lane0_mask                              (0x80000000)
+#define REG_DFE_EN_L0_timer_ctrl_en_lane0_mask                        (0x40000000)
+#define REG_DFE_EN_L0_reduce_adapt_gain_lane0_mask                    (0x30000000)
+#define REG_DFE_EN_L0_rl_det_en_lane0_mask                            (0x08000000)
+#define REG_DFE_EN_L0_rl_det_mode_lane0_mask                          (0x04000000)
+#define REG_DFE_EN_L0_rl_threshold_lane0_mask                         (0x03000000)
+#define REG_DFE_EN_L0_dfe_adapt_en_lane0_mask                         (0x00FF0000)
+#define REG_DFE_EN_L0_le_min_lane0_mask                               (0x0000F800)
+#define REG_DFE_EN_L0_le_init_lane0_mask                              (0x000007C0)
+#define REG_DFE_EN_L0_tap4_init_lane0_mask                            (0x0000003F)
+#define REG_DFE_EN_L0_clk_inv_lane0(data)                             (0x80000000&((data)<<31))
+#define REG_DFE_EN_L0_timer_ctrl_en_lane0(data)                       (0x40000000&((data)<<30))
+#define REG_DFE_EN_L0_reduce_adapt_gain_lane0(data)                   (0x30000000&((data)<<28))
+#define REG_DFE_EN_L0_rl_det_en_lane0(data)                           (0x08000000&((data)<<27))
+#define REG_DFE_EN_L0_rl_det_mode_lane0(data)                         (0x04000000&((data)<<26))
+#define REG_DFE_EN_L0_rl_threshold_lane0(data)                        (0x03000000&((data)<<24))
+#define REG_DFE_EN_L0_dfe_adapt_en_lane0(data)                        (0x00FF0000&((data)<<16))
+#define REG_DFE_EN_L0_le_min_lane0(data)                              (0x0000F800&((data)<<11))
+#define REG_DFE_EN_L0_le_init_lane0(data)                             (0x000007C0&((data)<<6))
+#define REG_DFE_EN_L0_tap4_init_lane0(data)                           (0x0000003F&(data))
+#define REG_DFE_EN_L0_get_clk_inv_lane0(data)                         ((0x80000000&(data))>>31)
+#define REG_DFE_EN_L0_get_timer_ctrl_en_lane0(data)                   ((0x40000000&(data))>>30)
+#define REG_DFE_EN_L0_get_reduce_adapt_gain_lane0(data)               ((0x30000000&(data))>>28)
+#define REG_DFE_EN_L0_get_rl_det_en_lane0(data)                       ((0x08000000&(data))>>27)
+#define REG_DFE_EN_L0_get_rl_det_mode_lane0(data)                     ((0x04000000&(data))>>26)
+#define REG_DFE_EN_L0_get_rl_threshold_lane0(data)                    ((0x03000000&(data))>>24)
+#define REG_DFE_EN_L0_get_dfe_adapt_en_lane0(data)                    ((0x00FF0000&(data))>>16)
+#define REG_DFE_EN_L0_get_le_min_lane0(data)                          ((0x0000F800&(data))>>11)
+#define REG_DFE_EN_L0_get_le_init_lane0(data)                         ((0x000007C0&(data))>>6)
+#define REG_DFE_EN_L0_get_tap4_init_lane0(data)                       (0x0000003F&(data))
+#define REG_dfe_adapt_en_lane0_TAP0									_BIT16
+#define REG_dfe_adapt_en_lane0_TAP1 								_BIT17
+#define REG_dfe_adapt_en_lane0_TAP2 								_BIT18
+#define REG_dfe_adapt_en_lane0_TAP3 								_BIT19
+#define REG_dfe_adapt_en_lane0_TAP4 								_BIT20
+#define REG_dfe_adapt_en_lane0_SERVO								_BIT21
+#define REG_dfe_adapt_en_lane0_Vth									_BIT22
+#define REG_dfe_adapt_en_lane0_LE									_BIT23
+
+
+#define REG_DFE_INIT0_L0                                              0xf04
+#define REG_DFE_INIT0_L0_reg_addr                                     "0x98034f04"
+#define REG_DFE_INIT0_L0_reg                                          0x98034f04
+#define REG_DFE_INIT0_L0_inst_addr                                    "0x03C1"
+#define REG_DFE_INIT0_L0_inst                                         0x03C1
+#define set_REG_DFE_INIT0_L0_reg(data)                                (*((volatile unsigned int*)REG_DFE_INIT0_L0_reg)=data)
+#define get_REG_DFE_INIT0_L0_reg                                      (*((volatile unsigned int*)REG_DFE_INIT0_L0_reg))
+#define REG_DFE_INIT0_L0_tap3_init_lane0_shift                        (26)
+#define REG_DFE_INIT0_L0_tap2_init_lane0_shift                        (20)
+#define REG_DFE_INIT0_L0_tap1_init_lane0_shift                        (14)
+#define REG_DFE_INIT0_L0_tap0_init_lane0_shift                        (9)
+#define REG_DFE_INIT0_L0_servo_init_lane0_shift                       (4)
+#define REG_DFE_INIT0_L0_vth_init_lane0_shift                         (0)
+#define REG_DFE_INIT0_L0_tap3_init_lane0_mask                         (0xFC000000)
+#define REG_DFE_INIT0_L0_tap2_init_lane0_mask                         (0x03F00000)
+#define REG_DFE_INIT0_L0_tap1_init_lane0_mask                         (0x000FC000)
+#define REG_DFE_INIT0_L0_tap0_init_lane0_mask                         (0x00003E00)
+#define REG_DFE_INIT0_L0_servo_init_lane0_mask                        (0x000001F0)
+#define REG_DFE_INIT0_L0_vth_init_lane0_mask                          (0x0000000F)
+#define REG_DFE_INIT0_L0_tap3_init_lane0(data)                        (0xFC000000&((data)<<26))
+#define REG_DFE_INIT0_L0_tap2_init_lane0(data)                        (0x03F00000&((data)<<20))
+#define REG_DFE_INIT0_L0_tap1_init_lane0(data)                        (0x000FC000&((data)<<14))
+#define REG_DFE_INIT0_L0_tap0_init_lane0(data)                        (0x00003E00&((data)<<9))
+#define REG_DFE_INIT0_L0_servo_init_lane0(data)                       (0x000001F0&((data)<<4))
+#define REG_DFE_INIT0_L0_vth_init_lane0(data)                         (0x0000000F&(data))
+#define REG_DFE_INIT0_L0_get_tap3_init_lane0(data)                    ((0xFC000000&(data))>>26)
+#define REG_DFE_INIT0_L0_get_tap2_init_lane0(data)                    ((0x03F00000&(data))>>20)
+#define REG_DFE_INIT0_L0_get_tap1_init_lane0(data)                    ((0x000FC000&(data))>>14)
+#define REG_DFE_INIT0_L0_get_tap0_init_lane0(data)                    ((0x00003E00&(data))>>9)
+#define REG_DFE_INIT0_L0_get_servo_init_lane0(data)                   ((0x000001F0&(data))>>4)
+#define REG_DFE_INIT0_L0_get_vth_init_lane0(data)                     (0x0000000F&(data))
+
+
+#define REG_DFE_INIT1_L0                                              0xf08
+#define REG_DFE_INIT1_L0_reg_addr                                     "0x98034f08"
+#define REG_DFE_INIT1_L0_reg                                          0x98034f08
+#define REG_DFE_INIT1_L0_inst_addr                                    "0x03C2"
+#define REG_DFE_INIT1_L0_inst                                         0x03C2
+#define set_REG_DFE_INIT1_L0_reg(data)                                (*((volatile unsigned int*)REG_DFE_INIT1_L0_reg)=data)
+#define get_REG_DFE_INIT1_L0_reg                                      (*((volatile unsigned int*)REG_DFE_INIT1_L0_reg))
+#define REG_DFE_INIT1_L0_load_in_init_lane0_shift                     (24)
+#define REG_DFE_INIT1_L0_init1_rev1_lane0_shift                       (18)
+#define REG_DFE_INIT1_L0_de_video_inv_lane0_shift                     (17)
+#define REG_DFE_INIT1_L0_de_packet_inv_lane0_shift                    (16)
+#define REG_DFE_INIT1_L0_de_video_en_lane0_shift                      (15)
+#define REG_DFE_INIT1_L0_de_packet_en_lane0_shift                     (14)
+#define REG_DFE_INIT1_L0_init1_rev0_lane0_shift                       (0)
+#define REG_DFE_INIT1_L0_load_in_init_lane0_mask                      (0xFF000000)
+#define REG_DFE_INIT1_L0_init1_rev1_lane0_mask                        (0x00FC0000)
+#define REG_DFE_INIT1_L0_de_video_inv_lane0_mask                      (0x00020000)
+#define REG_DFE_INIT1_L0_de_packet_inv_lane0_mask                     (0x00010000)
+#define REG_DFE_INIT1_L0_de_video_en_lane0_mask                       (0x00008000)
+#define REG_DFE_INIT1_L0_de_packet_en_lane0_mask                      (0x00004000)
+#define REG_DFE_INIT1_L0_init1_rev0_lane0_mask                        (0x00003FFF)
+#define REG_DFE_INIT1_L0_load_in_init_lane0(data)                     (0xFF000000&((data)<<24))
+#define REG_DFE_INIT1_L0_init1_rev1_lane0(data)                       (0x00FC0000&((data)<<18))
+#define REG_DFE_INIT1_L0_de_video_inv_lane0(data)                     (0x00020000&((data)<<17))
+#define REG_DFE_INIT1_L0_de_packet_inv_lane0(data)                    (0x00010000&((data)<<16))
+#define REG_DFE_INIT1_L0_de_video_en_lane0(data)                      (0x00008000&((data)<<15))
+#define REG_DFE_INIT1_L0_de_packet_en_lane0(data)                     (0x00004000&((data)<<14))
+#define REG_DFE_INIT1_L0_init1_rev0_lane0(data)                       (0x00003FFF&(data))
+#define REG_DFE_INIT1_L0_get_load_in_init_lane0(data)                 ((0xFF000000&(data))>>24)
+#define REG_DFE_INIT1_L0_get_init1_rev1_lane0(data)                   ((0x00FC0000&(data))>>18)
+#define REG_DFE_INIT1_L0_get_de_video_inv_lane0(data)                 ((0x00020000&(data))>>17)
+#define REG_DFE_INIT1_L0_get_de_packet_inv_lane0(data)                ((0x00010000&(data))>>16)
+#define REG_DFE_INIT1_L0_get_de_video_en_lane0(data)                  ((0x00008000&(data))>>15)
+#define REG_DFE_INIT1_L0_get_de_packet_en_lane0(data)                 ((0x00004000&(data))>>14)
+#define REG_DFE_INIT1_L0_get_init1_rev0_lane0(data)                   (0x00003FFF&(data))
+#define load_in_init_lane0_LE										(_BIT31)
+#define load_in_init_lane0_vth										(_BIT30)
+#define load_in_init_lane0_tap1										(_BIT25)
+#define load_in_init_lane0_tap0										(_BIT24)
+
+
+#define REG_DFE_EN_L1                                                 0xf10
+#define REG_DFE_EN_L1_reg_addr                                        "0x98034f10"
+#define REG_DFE_EN_L1_reg                                             0x98034f10
+#define REG_DFE_EN_L1_inst_addr                                       "0x03C4"
+#define REG_DFE_EN_L1_inst                                            0x03C4
+#define set_REG_DFE_EN_L1_reg(data)                                   (*((volatile unsigned int*)REG_DFE_EN_L1_reg)=data)
+#define get_REG_DFE_EN_L1_reg                                         (*((volatile unsigned int*)REG_DFE_EN_L1_reg))
+#define REG_DFE_EN_L1_clk_inv_lane1_shift                             (31)
+#define REG_DFE_EN_L1_timer_ctrl_en_lane1_shift                       (30)
+#define REG_DFE_EN_L1_reduce_adapt_gain_lane1_shift                   (28)
+#define REG_DFE_EN_L1_rl_det_en_lane1_shift                           (27)
+#define REG_DFE_EN_L1_rl_det_mode_lane1_shift                         (26)
+#define REG_DFE_EN_L1_rl_threshold_lane1_shift                        (24)
+#define REG_DFE_EN_L1_dfe_adapt_en_lane1_shift                        (16)
+#define REG_DFE_EN_L1_le_min_lane1_shift                              (11)
+#define REG_DFE_EN_L1_le_init_lane1_shift                             (6)
+#define REG_DFE_EN_L1_tap4_init_lane1_shift                           (0)
+#define REG_DFE_EN_L1_clk_inv_lane1_mask                              (0x80000000)
+#define REG_DFE_EN_L1_timer_ctrl_en_lane1_mask                        (0x40000000)
+#define REG_DFE_EN_L1_reduce_adapt_gain_lane1_mask                    (0x30000000)
+#define REG_DFE_EN_L1_rl_det_en_lane1_mask                            (0x08000000)
+#define REG_DFE_EN_L1_rl_det_mode_lane1_mask                          (0x04000000)
+#define REG_DFE_EN_L1_rl_threshold_lane1_mask                         (0x03000000)
+#define REG_DFE_EN_L1_dfe_adapt_en_lane1_mask                         (0x00FF0000)
+#define REG_DFE_EN_L1_le_min_lane1_mask                               (0x0000F800)
+#define REG_DFE_EN_L1_le_init_lane1_mask                              (0x000007C0)
+#define REG_DFE_EN_L1_tap4_init_lane1_mask                            (0x0000003F)
+#define REG_DFE_EN_L1_clk_inv_lane1(data)                             (0x80000000&((data)<<31))
+#define REG_DFE_EN_L1_timer_ctrl_en_lane1(data)                       (0x40000000&((data)<<30))
+#define REG_DFE_EN_L1_reduce_adapt_gain_lane1(data)                   (0x30000000&((data)<<28))
+#define REG_DFE_EN_L1_rl_det_en_lane1(data)                           (0x08000000&((data)<<27))
+#define REG_DFE_EN_L1_rl_det_mode_lane1(data)                         (0x04000000&((data)<<26))
+#define REG_DFE_EN_L1_rl_threshold_lane1(data)                        (0x03000000&((data)<<24))
+#define REG_DFE_EN_L1_dfe_adapt_en_lane1(data)                        (0x00FF0000&((data)<<16))
+#define REG_DFE_EN_L1_le_min_lane1(data)                              (0x0000F800&((data)<<11))
+#define REG_DFE_EN_L1_le_init_lane1(data)                             (0x000007C0&((data)<<6))
+#define REG_DFE_EN_L1_tap4_init_lane1(data)                           (0x0000003F&(data))
+#define REG_DFE_EN_L1_get_clk_inv_lane1(data)                         ((0x80000000&(data))>>31)
+#define REG_DFE_EN_L1_get_timer_ctrl_en_lane1(data)                   ((0x40000000&(data))>>30)
+#define REG_DFE_EN_L1_get_reduce_adapt_gain_lane1(data)               ((0x30000000&(data))>>28)
+#define REG_DFE_EN_L1_get_rl_det_en_lane1(data)                       ((0x08000000&(data))>>27)
+#define REG_DFE_EN_L1_get_rl_det_mode_lane1(data)                     ((0x04000000&(data))>>26)
+#define REG_DFE_EN_L1_get_rl_threshold_lane1(data)                    ((0x03000000&(data))>>24)
+#define REG_DFE_EN_L1_get_dfe_adapt_en_lane1(data)                    ((0x00FF0000&(data))>>16)
+#define REG_DFE_EN_L1_get_le_min_lane1(data)                          ((0x0000F800&(data))>>11)
+#define REG_DFE_EN_L1_get_le_init_lane1(data)                         ((0x000007C0&(data))>>6)
+#define REG_DFE_EN_L1_get_tap4_init_lane1(data)                       (0x0000003F&(data))
+#define REG_dfe_adapt_en_lane1_TAP0									_BIT16
+#define REG_dfe_adapt_en_lane1_TAP1 								_BIT17
+#define REG_dfe_adapt_en_lane1_TAP2 								_BIT18
+#define REG_dfe_adapt_en_lane1_TAP3 								_BIT19
+#define REG_dfe_adapt_en_lane1_TAP4 								_BIT20
+#define REG_dfe_adapt_en_lane1_SERVO								_BIT21
+#define REG_dfe_adapt_en_lane1_Vth									_BIT22
+#define REG_dfe_adapt_en_lane1_LE									_BIT23
+
+
+#define REG_DFE_INIT0_L1                                              0xf14
+#define REG_DFE_INIT0_L1_reg_addr                                     "0x98034f14"
+#define REG_DFE_INIT0_L1_reg                                          0x98034f14
+#define REG_DFE_INIT0_L1_inst_addr                                    "0x03C5"
+#define REG_DFE_INIT0_L1_inst                                         0x03C5
+#define set_REG_DFE_INIT0_L1_reg(data)                                (*((volatile unsigned int*)REG_DFE_INIT0_L1_reg)=data)
+#define get_REG_DFE_INIT0_L1_reg                                      (*((volatile unsigned int*)REG_DFE_INIT0_L1_reg))
+#define REG_DFE_INIT0_L1_tap3_init_lane1_shift                        (26)
+#define REG_DFE_INIT0_L1_tap2_init_lane1_shift                        (20)
+#define REG_DFE_INIT0_L1_tap1_init_lane1_shift                        (14)
+#define REG_DFE_INIT0_L1_tap0_init_lane1_shift                        (9)
+#define REG_DFE_INIT0_L1_servo_init_lane1_shift                       (4)
+#define REG_DFE_INIT0_L1_vth_init_lane1_shift                         (0)
+#define REG_DFE_INIT0_L1_tap3_init_lane1_mask                         (0xFC000000)
+#define REG_DFE_INIT0_L1_tap2_init_lane1_mask                         (0x03F00000)
+#define REG_DFE_INIT0_L1_tap1_init_lane1_mask                         (0x000FC000)
+#define REG_DFE_INIT0_L1_tap0_init_lane1_mask                         (0x00003E00)
+#define REG_DFE_INIT0_L1_servo_init_lane1_mask                        (0x000001F0)
+#define REG_DFE_INIT0_L1_vth_init_lane1_mask                          (0x0000000F)
+#define REG_DFE_INIT0_L1_tap3_init_lane1(data)                        (0xFC000000&((data)<<26))
+#define REG_DFE_INIT0_L1_tap2_init_lane1(data)                        (0x03F00000&((data)<<20))
+#define REG_DFE_INIT0_L1_tap1_init_lane1(data)                        (0x000FC000&((data)<<14))
+#define REG_DFE_INIT0_L1_tap0_init_lane1(data)                        (0x00003E00&((data)<<9))
+#define REG_DFE_INIT0_L1_servo_init_lane1(data)                       (0x000001F0&((data)<<4))
+#define REG_DFE_INIT0_L1_vth_init_lane1(data)                         (0x0000000F&(data))
+#define REG_DFE_INIT0_L1_get_tap3_init_lane1(data)                    ((0xFC000000&(data))>>26)
+#define REG_DFE_INIT0_L1_get_tap2_init_lane1(data)                    ((0x03F00000&(data))>>20)
+#define REG_DFE_INIT0_L1_get_tap1_init_lane1(data)                    ((0x000FC000&(data))>>14)
+#define REG_DFE_INIT0_L1_get_tap0_init_lane1(data)                    ((0x00003E00&(data))>>9)
+#define REG_DFE_INIT0_L1_get_servo_init_lane1(data)                   ((0x000001F0&(data))>>4)
+#define REG_DFE_INIT0_L1_get_vth_init_lane1(data)                     (0x0000000F&(data))
+
+
+#define REG_DFE_INIT1_L1                                              0xf18
+#define REG_DFE_INIT1_L1_reg_addr                                     "0x98034f18"
+#define REG_DFE_INIT1_L1_reg                                          0x98034f18
+#define REG_DFE_INIT1_L1_inst_addr                                    "0x03C6"
+#define REG_DFE_INIT1_L1_inst                                         0x03C6
+#define set_REG_DFE_INIT1_L1_reg(data)                                (*((volatile unsigned int*)REG_DFE_INIT1_L1_reg)=data)
+#define get_REG_DFE_INIT1_L1_reg                                      (*((volatile unsigned int*)REG_DFE_INIT1_L1_reg))
+#define REG_DFE_INIT1_L1_load_in_init_lane1_shift                     (24)
+#define REG_DFE_INIT1_L1_init1_rev1_lane1_shift                       (18)
+#define REG_DFE_INIT1_L1_de_video_inv_lane1_shift                     (17)
+#define REG_DFE_INIT1_L1_de_packet_inv_lane1_shift                    (16)
+#define REG_DFE_INIT1_L1_de_video_en_lane1_shift                      (15)
+#define REG_DFE_INIT1_L1_de_packet_en_lane1_shift                     (14)
+#define REG_DFE_INIT1_L1_init1_rev0_lane1_shift                       (0)
+#define REG_DFE_INIT1_L1_load_in_init_lane1_mask                      (0xFF000000)
+#define REG_DFE_INIT1_L1_init1_rev1_lane1_mask                        (0x00FC0000)
+#define REG_DFE_INIT1_L1_de_video_inv_lane1_mask                      (0x00020000)
+#define REG_DFE_INIT1_L1_de_packet_inv_lane1_mask                     (0x00010000)
+#define REG_DFE_INIT1_L1_de_video_en_lane1_mask                       (0x00008000)
+#define REG_DFE_INIT1_L1_de_packet_en_lane1_mask                      (0x00004000)
+#define REG_DFE_INIT1_L1_init1_rev0_lane1_mask                        (0x00003FFF)
+#define REG_DFE_INIT1_L1_load_in_init_lane1(data)                     (0xFF000000&((data)<<24))
+#define REG_DFE_INIT1_L1_init1_rev1_lane1(data)                       (0x00FC0000&((data)<<18))
+#define REG_DFE_INIT1_L1_de_video_inv_lane1(data)                     (0x00020000&((data)<<17))
+#define REG_DFE_INIT1_L1_de_packet_inv_lane1(data)                    (0x00010000&((data)<<16))
+#define REG_DFE_INIT1_L1_de_video_en_lane1(data)                      (0x00008000&((data)<<15))
+#define REG_DFE_INIT1_L1_de_packet_en_lane1(data)                     (0x00004000&((data)<<14))
+#define REG_DFE_INIT1_L1_init1_rev0_lane1(data)                       (0x00003FFF&(data))
+#define REG_DFE_INIT1_L1_get_load_in_init_lane1(data)                 ((0xFF000000&(data))>>24)
+#define REG_DFE_INIT1_L1_get_init1_rev1_lane1(data)                   ((0x00FC0000&(data))>>18)
+#define REG_DFE_INIT1_L1_get_de_video_inv_lane1(data)                 ((0x00020000&(data))>>17)
+#define REG_DFE_INIT1_L1_get_de_packet_inv_lane1(data)                ((0x00010000&(data))>>16)
+#define REG_DFE_INIT1_L1_get_de_video_en_lane1(data)                  ((0x00008000&(data))>>15)
+#define REG_DFE_INIT1_L1_get_de_packet_en_lane1(data)                 ((0x00004000&(data))>>14)
+#define REG_DFE_INIT1_L1_get_init1_rev0_lane1(data)                   (0x00003FFF&(data))
+
+
+#define REG_DFE_EN_L2                                                 0xf20
+#define REG_DFE_EN_L2_reg_addr                                        "0x98034f20"
+#define REG_DFE_EN_L2_reg                                             0x98034f20
+#define REG_DFE_EN_L2_inst_addr                                       "0x03C8"
+#define REG_DFE_EN_L2_inst                                            0x03C8
+#define set_REG_DFE_EN_L2_reg(data)                                   (*((volatile unsigned int*)REG_DFE_EN_L2_reg)=data)
+#define get_REG_DFE_EN_L2_reg                                         (*((volatile unsigned int*)REG_DFE_EN_L2_reg))
+#define REG_DFE_EN_L2_clk_inv_lane2_shift                             (31)
+#define REG_DFE_EN_L2_timer_ctrl_en_lane2_shift                       (30)
+#define REG_DFE_EN_L2_reduce_adapt_gain_lane2_shift                   (28)
+#define REG_DFE_EN_L2_rl_det_en_lane2_shift                           (27)
+#define REG_DFE_EN_L2_rl_det_mode_lane2_shift                         (26)
+#define REG_DFE_EN_L2_rl_threshold_lane2_shift                        (24)
+#define REG_DFE_EN_L2_dfe_adapt_en_lane2_shift                        (16)
+#define REG_DFE_EN_L2_le_min_lane2_shift                              (11)
+#define REG_DFE_EN_L2_le_init_lane2_shift                             (6)
+#define REG_DFE_EN_L2_tap4_init_lane2_shift                           (0)
+#define REG_DFE_EN_L2_clk_inv_lane2_mask                              (0x80000000)
+#define REG_DFE_EN_L2_timer_ctrl_en_lane2_mask                        (0x40000000)
+#define REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask                    (0x30000000)
+#define REG_DFE_EN_L2_rl_det_en_lane2_mask                            (0x08000000)
+#define REG_DFE_EN_L2_rl_det_mode_lane2_mask                          (0x04000000)
+#define REG_DFE_EN_L2_rl_threshold_lane2_mask                         (0x03000000)
+#define REG_DFE_EN_L2_dfe_adapt_en_lane2_mask                         (0x00FF0000)
+#define REG_DFE_EN_L2_le_min_lane2_mask                               (0x0000F800)
+#define REG_DFE_EN_L2_le_init_lane2_mask                              (0x000007C0)
+#define REG_DFE_EN_L2_tap4_init_lane2_mask                            (0x0000003F)
+#define REG_DFE_EN_L2_clk_inv_lane2(data)                             (0x80000000&((data)<<31))
+#define REG_DFE_EN_L2_timer_ctrl_en_lane2(data)                       (0x40000000&((data)<<30))
+#define REG_DFE_EN_L2_reduce_adapt_gain_lane2(data)                   (0x30000000&((data)<<28))
+#define REG_DFE_EN_L2_rl_det_en_lane2(data)                           (0x08000000&((data)<<27))
+#define REG_DFE_EN_L2_rl_det_mode_lane2(data)                         (0x04000000&((data)<<26))
+#define REG_DFE_EN_L2_rl_threshold_lane2(data)                        (0x03000000&((data)<<24))
+#define REG_DFE_EN_L2_dfe_adapt_en_lane2(data)                        (0x00FF0000&((data)<<16))
+#define REG_DFE_EN_L2_le_min_lane2(data)                              (0x0000F800&((data)<<11))
+#define REG_DFE_EN_L2_le_init_lane2(data)                             (0x000007C0&((data)<<6))
+#define REG_DFE_EN_L2_tap4_init_lane2(data)                           (0x0000003F&(data))
+#define REG_DFE_EN_L2_get_clk_inv_lane2(data)                         ((0x80000000&(data))>>31)
+#define REG_DFE_EN_L2_get_timer_ctrl_en_lane2(data)                   ((0x40000000&(data))>>30)
+#define REG_DFE_EN_L2_get_reduce_adapt_gain_lane2(data)               ((0x30000000&(data))>>28)
+#define REG_DFE_EN_L2_get_rl_det_en_lane2(data)                       ((0x08000000&(data))>>27)
+#define REG_DFE_EN_L2_get_rl_det_mode_lane2(data)                     ((0x04000000&(data))>>26)
+#define REG_DFE_EN_L2_get_rl_threshold_lane2(data)                    ((0x03000000&(data))>>24)
+#define REG_DFE_EN_L2_get_dfe_adapt_en_lane2(data)                    ((0x00FF0000&(data))>>16)
+#define REG_DFE_EN_L2_get_le_min_lane2(data)                          ((0x0000F800&(data))>>11)
+#define REG_DFE_EN_L2_get_le_init_lane2(data)                         ((0x000007C0&(data))>>6)
+#define REG_DFE_EN_L2_get_tap4_init_lane2(data)                       (0x0000003F&(data))
+#define REG_dfe_adapt_en_lane2_TAP0 								_BIT16
+#define REG_dfe_adapt_en_lane2_TAP1 								_BIT17
+#define REG_dfe_adapt_en_lane2_TAP2 								_BIT18
+#define REG_dfe_adapt_en_lane2_TAP3 								_BIT19
+#define REG_dfe_adapt_en_lane2_TAP4 								_BIT20
+#define REG_dfe_adapt_en_lane2_SERVO								_BIT21
+#define REG_dfe_adapt_en_lane2_Vth									_BIT22
+#define REG_dfe_adapt_en_lane2_LE									_BIT23
+
+
+#define REG_DFE_INIT0_L2                                              0xf24
+#define REG_DFE_INIT0_L2_reg_addr                                     "0x98034f24"
+#define REG_DFE_INIT0_L2_reg                                          0x98034f24
+#define REG_DFE_INIT0_L2_inst_addr                                    "0x03C9"
+#define REG_DFE_INIT0_L2_inst                                         0x03C9
+#define set_REG_DFE_INIT0_L2_reg(data)                                (*((volatile unsigned int*)REG_DFE_INIT0_L2_reg)=data)
+#define get_REG_DFE_INIT0_L2_reg                                      (*((volatile unsigned int*)REG_DFE_INIT0_L2_reg))
+#define REG_DFE_INIT0_L2_tap3_init_lane2_shift                        (26)
+#define REG_DFE_INIT0_L2_tap2_init_lane2_shift                        (20)
+#define REG_DFE_INIT0_L2_tap1_init_lane2_shift                        (14)
+#define REG_DFE_INIT0_L2_tap0_init_lane2_shift                        (9)
+#define REG_DFE_INIT0_L2_servo_init_lane2_shift                       (4)
+#define REG_DFE_INIT0_L2_vth_init_lane2_shift                         (0)
+#define REG_DFE_INIT0_L2_tap3_init_lane2_mask                         (0xFC000000)
+#define REG_DFE_INIT0_L2_tap2_init_lane2_mask                         (0x03F00000)
+#define REG_DFE_INIT0_L2_tap1_init_lane2_mask                         (0x000FC000)
+#define REG_DFE_INIT0_L2_tap0_init_lane2_mask                         (0x00003E00)
+#define REG_DFE_INIT0_L2_servo_init_lane2_mask                        (0x000001F0)
+#define REG_DFE_INIT0_L2_vth_init_lane2_mask                          (0x0000000F)
+#define REG_DFE_INIT0_L2_tap3_init_lane2(data)                        (0xFC000000&((data)<<26))
+#define REG_DFE_INIT0_L2_tap2_init_lane2(data)                        (0x03F00000&((data)<<20))
+#define REG_DFE_INIT0_L2_tap1_init_lane2(data)                        (0x000FC000&((data)<<14))
+#define REG_DFE_INIT0_L2_tap0_init_lane2(data)                        (0x00003E00&((data)<<9))
+#define REG_DFE_INIT0_L2_servo_init_lane2(data)                       (0x000001F0&((data)<<4))
+#define REG_DFE_INIT0_L2_vth_init_lane2(data)                         (0x0000000F&(data))
+#define REG_DFE_INIT0_L2_get_tap3_init_lane2(data)                    ((0xFC000000&(data))>>26)
+#define REG_DFE_INIT0_L2_get_tap2_init_lane2(data)                    ((0x03F00000&(data))>>20)
+#define REG_DFE_INIT0_L2_get_tap1_init_lane2(data)                    ((0x000FC000&(data))>>14)
+#define REG_DFE_INIT0_L2_get_tap0_init_lane2(data)                    ((0x00003E00&(data))>>9)
+#define REG_DFE_INIT0_L2_get_servo_init_lane2(data)                   ((0x000001F0&(data))>>4)
+#define REG_DFE_INIT0_L2_get_vth_init_lane2(data)                     (0x0000000F&(data))
+
+
+#define REG_DFE_INIT1_L2                                              0xf28
+#define REG_DFE_INIT1_L2_reg_addr                                     "0x98034f28"
+#define REG_DFE_INIT1_L2_reg                                          0x98034f28
+#define REG_DFE_INIT1_L2_inst_addr                                    "0x03CA"
+#define REG_DFE_INIT1_L2_inst                                         0x03CA
+#define set_REG_DFE_INIT1_L2_reg(data)                                (*((volatile unsigned int*)REG_DFE_INIT1_L2_reg)=data)
+#define get_REG_DFE_INIT1_L2_reg                                      (*((volatile unsigned int*)REG_DFE_INIT1_L2_reg))
+#define REG_DFE_INIT1_L2_load_in_init_lane2_shift                     (24)
+#define REG_DFE_INIT1_L2_init1_rev1_lane2_shift                       (18)
+#define REG_DFE_INIT1_L2_de_video_inv_lane2_shift                     (17)
+#define REG_DFE_INIT1_L2_de_packet_inv_lane2_shift                    (16)
+#define REG_DFE_INIT1_L2_de_video_en_lane2_shift                      (15)
+#define REG_DFE_INIT1_L2_de_packet_en_lane2_shift                     (14)
+#define REG_DFE_INIT1_L2_init1_rev0_lane2_shift                       (0)
+#define REG_DFE_INIT1_L2_load_in_init_lane2_mask                      (0xFF000000)
+#define REG_DFE_INIT1_L2_init1_rev1_lane2_mask                        (0x00FC0000)
+#define REG_DFE_INIT1_L2_de_video_inv_lane2_mask                      (0x00020000)
+#define REG_DFE_INIT1_L2_de_packet_inv_lane2_mask                     (0x00010000)
+#define REG_DFE_INIT1_L2_de_video_en_lane2_mask                       (0x00008000)
+#define REG_DFE_INIT1_L2_de_packet_en_lane2_mask                      (0x00004000)
+#define REG_DFE_INIT1_L2_init1_rev0_lane2_mask                        (0x00003FFF)
+#define REG_DFE_INIT1_L2_load_in_init_lane2(data)                     (0xFF000000&((data)<<24))
+#define REG_DFE_INIT1_L2_init1_rev1_lane2(data)                       (0x00FC0000&((data)<<18))
+#define REG_DFE_INIT1_L2_de_video_inv_lane2(data)                     (0x00020000&((data)<<17))
+#define REG_DFE_INIT1_L2_de_packet_inv_lane2(data)                    (0x00010000&((data)<<16))
+#define REG_DFE_INIT1_L2_de_video_en_lane2(data)                      (0x00008000&((data)<<15))
+#define REG_DFE_INIT1_L2_de_packet_en_lane2(data)                     (0x00004000&((data)<<14))
+#define REG_DFE_INIT1_L2_init1_rev0_lane2(data)                       (0x00003FFF&(data))
+#define REG_DFE_INIT1_L2_get_load_in_init_lane2(data)                 ((0xFF000000&(data))>>24)
+#define REG_DFE_INIT1_L2_get_init1_rev1_lane2(data)                   ((0x00FC0000&(data))>>18)
+#define REG_DFE_INIT1_L2_get_de_video_inv_lane2(data)                 ((0x00020000&(data))>>17)
+#define REG_DFE_INIT1_L2_get_de_packet_inv_lane2(data)                ((0x00010000&(data))>>16)
+#define REG_DFE_INIT1_L2_get_de_video_en_lane2(data)                  ((0x00008000&(data))>>15)
+#define REG_DFE_INIT1_L2_get_de_packet_en_lane2(data)                 ((0x00004000&(data))>>14)
+#define REG_DFE_INIT1_L2_get_init1_rev0_lane2(data)                   (0x00003FFF&(data))
+
+
+#define REG_DFE_MODE                                                  0xf30
+#define REG_DFE_MODE_reg_addr                                         "0x98034f30"
+#define REG_DFE_MODE_reg                                              0x98034f30
+#define REG_DFE_MODE_inst_addr                                        "0x03CC"
+#define REG_DFE_MODE_inst                                             0x03CC
+#define set_REG_DFE_MODE_reg(data)                                    (*((volatile unsigned int*)REG_DFE_MODE_reg)=data)
+#define get_REG_DFE_MODE_reg                                          (*((volatile unsigned int*)REG_DFE_MODE_reg))
+#define REG_DFE_MODE_adapt_mode_shift                                 (30)
+#define REG_DFE_MODE_edge_det_mode_shift                              (29)
+#define REG_DFE_MODE_transition_only_shift                            (28)
+#define REG_DFE_MODE_le_auto_reload_shift                             (27)
+#define REG_DFE_MODE_tap1_delay_shift                                 (24)
+#define REG_DFE_MODE_tap24_delay_shift                                (21)
+#define REG_DFE_MODE_le_delay_shift                                   (18)
+#define REG_DFE_MODE_servo_delay_shift                                (16)
+#define REG_DFE_MODE_gray_en_shift                                    (8)
+#define REG_DFE_MODE_dfe_adapt_rstb_shift                             (4)
+#define REG_DFE_MODE_tap0_trans_shift                                 (3)
+#define REG_DFE_MODE_tap0_notrans_shift                               (2)
+#define REG_DFE_MODE_servo_notrans_shift                              (1)
+#define REG_DFE_MODE_servo_trans_shift                                (0)
+#define REG_DFE_MODE_adapt_mode_mask                                  (0xC0000000)
+#define REG_DFE_MODE_edge_det_mode_mask                               (0x20000000)
+#define REG_DFE_MODE_transition_only_mask                             (0x10000000)
+#define REG_DFE_MODE_le_auto_reload_mask                              (0x08000000)
+#define REG_DFE_MODE_tap1_delay_mask                                  (0x07000000)
+#define REG_DFE_MODE_tap24_delay_mask                                 (0x00E00000)
+#define REG_DFE_MODE_le_delay_mask                                    (0x001C0000)
+#define REG_DFE_MODE_servo_delay_mask                                 (0x00030000)
+#define REG_DFE_MODE_gray_en_mask                                     (0x0000FF00)
+#define REG_DFE_MODE_dfe_adapt_rstb_mask                              (0x000000F0)
+#define REG_DFE_MODE_tap0_trans_mask                                  (0x00000008)
+#define REG_DFE_MODE_tap0_notrans_mask                                (0x00000004)
+#define REG_DFE_MODE_servo_notrans_mask                               (0x00000002)
+#define REG_DFE_MODE_servo_trans_mask                                 (0x00000001)
+#define REG_DFE_MODE_adapt_mode(data)                                 (0xC0000000&((data)<<30))
+#define REG_DFE_MODE_edge_det_mode(data)                              (0x20000000&((data)<<29))
+#define REG_DFE_MODE_transition_only(data)                            (0x10000000&((data)<<28))
+#define REG_DFE_MODE_le_auto_reload(data)                             (0x08000000&((data)<<27))
+#define REG_DFE_MODE_tap1_delay(data)                                 (0x07000000&((data)<<24))
+#define REG_DFE_MODE_tap24_delay(data)                                (0x00E00000&((data)<<21))
+#define REG_DFE_MODE_le_delay(data)                                   (0x001C0000&((data)<<18))
+#define REG_DFE_MODE_servo_delay(data)                                (0x00030000&((data)<<16))
+#define REG_DFE_MODE_gray_en(data)                                    (0x0000FF00&((data)<<8))
+#define REG_DFE_MODE_dfe_adapt_rstb(data)                             (0x000000F0&((data)<<4))
+#define REG_DFE_MODE_tap0_trans(data)                                 (0x00000008&((data)<<3))
+#define REG_DFE_MODE_tap0_notrans(data)                               (0x00000004&((data)<<2))
+#define REG_DFE_MODE_servo_notrans(data)                              (0x00000002&((data)<<1))
+#define REG_DFE_MODE_servo_trans(data)                                (0x00000001&(data))
+#define REG_DFE_MODE_get_adapt_mode(data)                             ((0xC0000000&(data))>>30)
+#define REG_DFE_MODE_get_edge_det_mode(data)                          ((0x20000000&(data))>>29)
+#define REG_DFE_MODE_get_transition_only(data)                        ((0x10000000&(data))>>28)
+#define REG_DFE_MODE_get_le_auto_reload(data)                         ((0x08000000&(data))>>27)
+#define REG_DFE_MODE_get_tap1_delay(data)                             ((0x07000000&(data))>>24)
+#define REG_DFE_MODE_get_tap24_delay(data)                            ((0x00E00000&(data))>>21)
+#define REG_DFE_MODE_get_le_delay(data)                               ((0x001C0000&(data))>>18)
+#define REG_DFE_MODE_get_servo_delay(data)                            ((0x00030000&(data))>>16)
+#define REG_DFE_MODE_get_gray_en(data)                                ((0x0000FF00&(data))>>8)
+#define REG_DFE_MODE_get_dfe_adapt_rstb(data)                         ((0x000000F0&(data))>>4)
+#define REG_DFE_MODE_get_tap0_trans(data)                             ((0x00000008&(data))>>3)
+#define REG_DFE_MODE_get_tap0_notrans(data)                           ((0x00000004&(data))>>2)
+#define REG_DFE_MODE_get_servo_notrans(data)                          ((0x00000002&(data))>>1)
+#define REG_DFE_MODE_get_servo_trans(data)                            (0x00000001&(data))
+
+
+#define REG_DFE_GAIN                                                  0xf34
+#define REG_DFE_GAIN_reg_addr                                         "0x98034f34"
+#define REG_DFE_GAIN_reg                                              0x98034f34
+#define REG_DFE_GAIN_inst_addr                                        "0x03CD"
+#define REG_DFE_GAIN_inst                                             0x03CD
+#define set_REG_DFE_GAIN_reg(data)                                    (*((volatile unsigned int*)REG_DFE_GAIN_reg)=data)
+#define get_REG_DFE_GAIN_reg                                          (*((volatile unsigned int*)REG_DFE_GAIN_reg))
+#define REG_DFE_GAIN_tap0_gain_shift                                  (29)
+#define REG_DFE_GAIN_tap1_gain_shift                                  (26)
+#define REG_DFE_GAIN_tap2_gain_shift                                  (23)
+#define REG_DFE_GAIN_tap3_gain_shift                                  (20)
+#define REG_DFE_GAIN_tap4_gain_shift                                  (17)
+#define REG_DFE_GAIN_servo_gain_shift                                 (14)
+#define REG_DFE_GAIN_le_gain1_shift                                   (11)
+#define REG_DFE_GAIN_le_gain2_shift                                   (8)
+#define REG_DFE_GAIN_le2_sign_shift                                   (7)
+#define REG_DFE_GAIN_le_gain_prec_shift                               (4)
+#define REG_DFE_GAIN_le_prec_sign_shift                               (3)
+#define REG_DFE_GAIN_trans_rlength_shift                              (0)
+#define REG_DFE_GAIN_tap0_gain_mask                                   (0xE0000000)
+#define REG_DFE_GAIN_tap1_gain_mask                                   (0x1C000000)
+#define REG_DFE_GAIN_tap2_gain_mask                                   (0x03800000)
+#define REG_DFE_GAIN_tap3_gain_mask                                   (0x00700000)
+#define REG_DFE_GAIN_tap4_gain_mask                                   (0x000E0000)
+#define REG_DFE_GAIN_servo_gain_mask                                  (0x0001C000)
+#define REG_DFE_GAIN_le_gain1_mask                                    (0x00003800)
+#define REG_DFE_GAIN_le_gain2_mask                                    (0x00000700)
+#define REG_DFE_GAIN_le2_sign_mask                                    (0x00000080)
+#define REG_DFE_GAIN_le_gain_prec_mask                                (0x00000070)
+#define REG_DFE_GAIN_le_prec_sign_mask                                (0x00000008)
+#define REG_DFE_GAIN_trans_rlength_mask                               (0x00000007)
+#define REG_DFE_GAIN_tap0_gain(data)                                  (0xE0000000&((data)<<29))
+#define REG_DFE_GAIN_tap1_gain(data)                                  (0x1C000000&((data)<<26))
+#define REG_DFE_GAIN_tap2_gain(data)                                  (0x03800000&((data)<<23))
+#define REG_DFE_GAIN_tap3_gain(data)                                  (0x00700000&((data)<<20))
+#define REG_DFE_GAIN_tap4_gain(data)                                  (0x000E0000&((data)<<17))
+#define REG_DFE_GAIN_servo_gain(data)                                 (0x0001C000&((data)<<14))
+#define REG_DFE_GAIN_le_gain1(data)                                   (0x00003800&((data)<<11))
+#define REG_DFE_GAIN_le_gain2(data)                                   (0x00000700&((data)<<8))
+#define REG_DFE_GAIN_le2_sign(data)                                   (0x00000080&((data)<<7))
+#define REG_DFE_GAIN_le_gain_prec(data)                               (0x00000070&((data)<<4))
+#define REG_DFE_GAIN_le_prec_sign(data)                               (0x00000008&((data)<<3))
+#define REG_DFE_GAIN_trans_rlength(data)                              (0x00000007&(data))
+#define REG_DFE_GAIN_get_tap0_gain(data)                              ((0xE0000000&(data))>>29)
+#define REG_DFE_GAIN_get_tap1_gain(data)                              ((0x1C000000&(data))>>26)
+#define REG_DFE_GAIN_get_tap2_gain(data)                              ((0x03800000&(data))>>23)
+#define REG_DFE_GAIN_get_tap3_gain(data)                              ((0x00700000&(data))>>20)
+#define REG_DFE_GAIN_get_tap4_gain(data)                              ((0x000E0000&(data))>>17)
+#define REG_DFE_GAIN_get_servo_gain(data)                             ((0x0001C000&(data))>>14)
+#define REG_DFE_GAIN_get_le_gain1(data)                               ((0x00003800&(data))>>11)
+#define REG_DFE_GAIN_get_le_gain2(data)                               ((0x00000700&(data))>>8)
+#define REG_DFE_GAIN_get_le2_sign(data)                               ((0x00000080&(data))>>7)
+#define REG_DFE_GAIN_get_le_gain_prec(data)                           ((0x00000070&(data))>>4)
+#define REG_DFE_GAIN_get_le_prec_sign(data)                           ((0x00000008&(data))>>3)
+#define REG_DFE_GAIN_get_trans_rlength(data)                          (0x00000007&(data))
+
+
+#define REG_DFE_LIMIT0                                                0xf38
+#define REG_DFE_LIMIT0_reg_addr                                       "0x98034f38"
+#define REG_DFE_LIMIT0_reg                                            0x98034f38
+#define REG_DFE_LIMIT0_inst_addr                                      "0x03CE"
+#define REG_DFE_LIMIT0_inst                                           0x03CE
+#define set_REG_DFE_LIMIT0_reg(data)                                  (*((volatile unsigned int*)REG_DFE_LIMIT0_reg)=data)
+#define get_REG_DFE_LIMIT0_reg                                        (*((volatile unsigned int*)REG_DFE_LIMIT0_reg))
+#define REG_DFE_LIMIT0_tap0_max_shift                                 (27)
+#define REG_DFE_LIMIT0_tap1_min_shift                                 (21)
+#define REG_DFE_LIMIT0_tap2_max_shift                                 (16)
+#define REG_DFE_LIMIT0_tap2_min_shift                                 (11)
+#define REG_DFE_LIMIT0_tap3_max_shift                                 (6)
+#define REG_DFE_LIMIT0_tap3_min_shift                                 (1)
+#define REG_DFE_LIMIT0_edge_last_notrans_shift                        (0)
+#define REG_DFE_LIMIT0_tap0_max_mask                                  (0xF8000000)
+#define REG_DFE_LIMIT0_tap1_min_mask                                  (0x07E00000)
+#define REG_DFE_LIMIT0_tap2_max_mask                                  (0x001F0000)
+#define REG_DFE_LIMIT0_tap2_min_mask                                  (0x0000F800)
+#define REG_DFE_LIMIT0_tap3_max_mask                                  (0x000007C0)
+#define REG_DFE_LIMIT0_tap3_min_mask                                  (0x0000003E)
+#define REG_DFE_LIMIT0_edge_last_notrans_mask                         (0x00000001)
+#define REG_DFE_LIMIT0_tap0_max(data)                                 (0xF8000000&((data)<<27))
+#define REG_DFE_LIMIT0_tap1_min(data)                                 (0x07E00000&((data)<<21))
+#define REG_DFE_LIMIT0_tap2_max(data)                                 (0x001F0000&((data)<<16))
+#define REG_DFE_LIMIT0_tap2_min(data)                                 (0x0000F800&((data)<<11))
+#define REG_DFE_LIMIT0_tap3_max(data)                                 (0x000007C0&((data)<<6))
+#define REG_DFE_LIMIT0_tap3_min(data)                                 (0x0000003E&((data)<<1))
+#define REG_DFE_LIMIT0_edge_last_notrans(data)                        (0x00000001&(data))
+#define REG_DFE_LIMIT0_get_tap0_max(data)                             ((0xF8000000&(data))>>27)
+#define REG_DFE_LIMIT0_get_tap1_min(data)                             ((0x07E00000&(data))>>21)
+#define REG_DFE_LIMIT0_get_tap2_max(data)                             ((0x001F0000&(data))>>16)
+#define REG_DFE_LIMIT0_get_tap2_min(data)                             ((0x0000F800&(data))>>11)
+#define REG_DFE_LIMIT0_get_tap3_max(data)                             ((0x000007C0&(data))>>6)
+#define REG_DFE_LIMIT0_get_tap3_min(data)                             ((0x0000003E&(data))>>1)
+#define REG_DFE_LIMIT0_get_edge_last_notrans(data)                    (0x00000001&(data))
+
+
+#define REG_DFE_LIMIT1                                                0xf3c
+#define REG_DFE_LIMIT1_reg_addr                                       "0x98034f3c"
+#define REG_DFE_LIMIT1_reg                                            0x98034f3c
+#define REG_DFE_LIMIT1_inst_addr                                      "0x03CF"
+#define REG_DFE_LIMIT1_inst                                           0x03CF
+#define set_REG_DFE_LIMIT1_reg(data)                                  (*((volatile unsigned int*)REG_DFE_LIMIT1_reg)=data)
+#define get_REG_DFE_LIMIT1_reg                                        (*((volatile unsigned int*)REG_DFE_LIMIT1_reg))
+#define REG_DFE_LIMIT1_tap4_max_shift                                 (27)
+#define REG_DFE_LIMIT1_tap4_min_shift                                 (22)
+#define REG_DFE_LIMIT1_vth_min_shift                                  (19)
+#define REG_DFE_LIMIT1_vth_max_shift                                  (15)
+#define REG_DFE_LIMIT1_vth_threshold_shift                            (12)
+#define REG_DFE_LIMIT1_tap0_threshold_shift                           (8)
+#define REG_DFE_LIMIT1_tap0_adjust_shift                              (6)
+#define REG_DFE_LIMIT1_tap1_trans_shift                               (5)
+#define REG_DFE_LIMIT1_limit1_rev_shift                               (0)
+#define REG_DFE_LIMIT1_tap4_max_mask                                  (0xF8000000)
+#define REG_DFE_LIMIT1_tap4_min_mask                                  (0x07C00000)
+#define REG_DFE_LIMIT1_vth_min_mask                                   (0x00380000)
+#define REG_DFE_LIMIT1_vth_max_mask                                   (0x00078000)
+#define REG_DFE_LIMIT1_vth_threshold_mask                             (0x00007000)
+#define REG_DFE_LIMIT1_tap0_threshold_mask                            (0x00000F00)
+#define REG_DFE_LIMIT1_tap0_adjust_mask                               (0x000000C0)
+#define REG_DFE_LIMIT1_tap1_trans_mask                                (0x00000020)
+#define REG_DFE_LIMIT1_limit1_rev_mask                                (0x0000001F)
+#define REG_DFE_LIMIT1_tap4_max(data)                                 (0xF8000000&((data)<<27))
+#define REG_DFE_LIMIT1_tap4_min(data)                                 (0x07C00000&((data)<<22))
+#define REG_DFE_LIMIT1_vth_min(data)                                  (0x00380000&((data)<<19))
+#define REG_DFE_LIMIT1_vth_max(data)                                  (0x00078000&((data)<<15))
+#define REG_DFE_LIMIT1_vth_threshold(data)                            (0x00007000&((data)<<12))
+#define REG_DFE_LIMIT1_tap0_threshold(data)                           (0x00000F00&((data)<<8))
+#define REG_DFE_LIMIT1_tap0_adjust(data)                              (0x000000C0&((data)<<6))
+#define REG_DFE_LIMIT1_tap1_trans(data)                               (0x00000020&((data)<<5))
+#define REG_DFE_LIMIT1_limit1_rev(data)                               (0x0000001F&(data))
+#define REG_DFE_LIMIT1_get_tap4_max(data)                             ((0xF8000000&(data))>>27)
+#define REG_DFE_LIMIT1_get_tap4_min(data)                             ((0x07C00000&(data))>>22)
+#define REG_DFE_LIMIT1_get_vth_min(data)                              ((0x00380000&(data))>>19)
+#define REG_DFE_LIMIT1_get_vth_max(data)                              ((0x00078000&(data))>>15)
+#define REG_DFE_LIMIT1_get_vth_threshold(data)                        ((0x00007000&(data))>>12)
+#define REG_DFE_LIMIT1_get_tap0_threshold(data)                       ((0x00000F00&(data))>>8)
+#define REG_DFE_LIMIT1_get_tap0_adjust(data)                          ((0x000000C0&(data))>>6)
+#define REG_DFE_LIMIT1_get_tap1_trans(data)                           ((0x00000020&(data))>>5)
+#define REG_DFE_LIMIT1_get_limit1_rev(data)                           (0x0000001F&(data))
+
+
+#define REG_DFE_LIMIT2                                                0xf40
+#define REG_DFE_LIMIT2_reg_addr                                       "0x98034f40"
+#define REG_DFE_LIMIT2_reg                                            0x98034f40
+#define REG_DFE_LIMIT2_inst_addr                                      "0x03D0"
+#define REG_DFE_LIMIT2_inst                                           0x03D0
+#define set_REG_DFE_LIMIT2_reg(data)                                  (*((volatile unsigned int*)REG_DFE_LIMIT2_reg)=data)
+#define get_REG_DFE_LIMIT2_reg                                        (*((volatile unsigned int*)REG_DFE_LIMIT2_reg))
+#define REG_DFE_LIMIT2_servo_divisor_shift                            (26)
+#define REG_DFE_LIMIT2_tap_divisor_shift                              (20)
+#define REG_DFE_LIMIT2_vth_divisor_shift                              (16)
+#define REG_DFE_LIMIT2_limit2_rev_shift                               (0)
+#define REG_DFE_LIMIT2_servo_divisor_mask                             (0xFC000000)
+#define REG_DFE_LIMIT2_tap_divisor_mask                               (0x03F00000)
+#define REG_DFE_LIMIT2_vth_divisor_mask                               (0x000F0000)
+#define REG_DFE_LIMIT2_limit2_rev_mask                                (0x0000FFFF)
+#define REG_DFE_LIMIT2_servo_divisor(data)                            (0xFC000000&((data)<<26))
+#define REG_DFE_LIMIT2_tap_divisor(data)                              (0x03F00000&((data)<<20))
+#define REG_DFE_LIMIT2_vth_divisor(data)                              (0x000F0000&((data)<<16))
+#define REG_DFE_LIMIT2_limit2_rev(data)                               (0x0000FFFF&(data))
+#define REG_DFE_LIMIT2_get_servo_divisor(data)                        ((0xFC000000&(data))>>26)
+#define REG_DFE_LIMIT2_get_tap_divisor(data)                          ((0x03F00000&(data))>>20)
+#define REG_DFE_LIMIT2_get_vth_divisor(data)                          ((0x000F0000&(data))>>16)
+#define REG_DFE_LIMIT2_get_limit2_rev(data)                           (0x0000FFFF&(data))
+
+
+#define REG_DFE_READBACK                                              0xf44
+#define REG_DFE_READBACK_reg_addr                                     "0x98034f44"
+#define REG_DFE_READBACK_reg                                          0x98034f44
+#define REG_DFE_READBACK_inst_addr                                    "0x03D1"
+#define REG_DFE_READBACK_inst                                         0x03D1
+#define set_REG_DFE_READBACK_reg(data)                                (*((volatile unsigned int*)REG_DFE_READBACK_reg)=data)
+#define get_REG_DFE_READBACK_reg                                      (*((volatile unsigned int*)REG_DFE_READBACK_reg))
+#define REG_DFE_READBACK_record_limit_en_shift                        (31)
+#define REG_DFE_READBACK_lane_sel_shift                               (29)
+#define REG_DFE_READBACK_limit_sel_shift                              (24)
+#define REG_DFE_READBACK_limit_data_shift                             (16)
+#define REG_DFE_READBACK_coef_sel_shift                               (8)
+#define REG_DFE_READBACK_coef_data_shift                              (0)
+#define REG_DFE_READBACK_record_limit_en_mask                         (0x80000000)
+#define REG_DFE_READBACK_lane_sel_mask                                (0x60000000)
+#define REG_DFE_READBACK_limit_sel_mask                               (0x1F000000)
+#define REG_DFE_READBACK_limit_data_mask                              (0x00FF0000)
+#define REG_DFE_READBACK_coef_sel_mask                                (0x0000FF00)
+#define REG_DFE_READBACK_coef_data_mask                               (0x000000FF)
+#define REG_DFE_READBACK_record_limit_en(data)                        (0x80000000&((data)<<31))
+#define REG_DFE_READBACK_lane_sel(data)                               (0x60000000&((data)<<29))
+#define REG_DFE_READBACK_limit_sel(data)                              (0x1F000000&((data)<<24))
+#define REG_DFE_READBACK_limit_data(data)                             (0x00FF0000&((data)<<16))
+#define REG_DFE_READBACK_coef_sel(data)                               (0x0000FF00&((data)<<8))
+#define REG_DFE_READBACK_coef_data(data)                              (0x000000FF&(data))
+#define REG_DFE_READBACK_get_record_limit_en(data)                    ((0x80000000&(data))>>31)
+#define REG_DFE_READBACK_get_lane_sel(data)                           ((0x60000000&(data))>>29)
+#define REG_DFE_READBACK_get_limit_sel(data)                          ((0x1F000000&(data))>>24)
+#define REG_DFE_READBACK_get_limit_data(data)                         ((0x00FF0000&(data))>>16)
+#define REG_DFE_READBACK_get_coef_sel(data)                           ((0x0000FF00&(data))>>8)
+#define REG_DFE_READBACK_get_coef_data(data)                          (0x000000FF&(data))
+#define limit_set_lane_mask											(_BIT30|_BIT29)
+#define limit_set_lane_shift										(29)
+#define limit_set_mask												(_BIT28|_BIT27|_BIT26|_BIT25|_BIT24)
+#define limit_sel(data)												(limit_set_mask&((data)<<24))
+#define get_Tap0_max(data)											((0x1F0000&(data))>>16)
+#define get_Tap0_min(data)											((0x1F0000&(data))>>16)
+#define get_Tap1_max(data)											((0x3F0000&(data))>>16)
+#define get_Tap1_min(data)											((0x3F0000&(data))>>16)
+#define get_LEQ_max(data)											((0x1F0000&(data))>>16)
+#define get_LEQ_min(data)											((0x1F0000&(data))>>16)
+#define coef_set_lane_mask											(_BIT15|_BIT14)
+#define coef_set_lane_shift											(14)
+#define coef_set_mask												(_BIT13|_BIT12|_BIT11|_BIT10|_BIT9|_BIT8)
+#define coef_sel(data)												(coef_set_mask&((data)<<8))
+#define get_VTH_coef(data)											(0xF&(data))
+#define get_TAP0_coef(data)											(0x1F&(data))
+#define get_TAP1_coef(data)											(0x3F&(data))
+#define get_TAP2_coef_sign(data)									(0x20&(data))
+#define get_TAP2_coef(data)											(0x1F&(data))
+#define get_TAP3_coef_sign(data)									(0x20&(data))
+#define get_TAP3_coef(data)											(0x1F&(data))
+#define get_TAP4_coef_sign(data)									(0x20&(data))
+#define get_TAP4_coef(data)											(0x1F&(data))
+#define get_SERVO_coef(data)										(0x1F&(data))
+#define get_LE1_coef(data)											(0x1F&(data))
+#define get_CurrentStep_coef(data)									((0x30&(data))>>4)
+#define get_BufferMode_coef(data)									((0xc0&(data))>>6)
+
+
+#define REG_DFE_FLAG                                                  0xf48
+#define REG_DFE_FLAG_reg_addr                                         "0x98034f48"
+#define REG_DFE_FLAG_reg                                              0x98034f48
+#define REG_DFE_FLAG_inst_addr                                        "0x03D2"
+#define REG_DFE_FLAG_inst                                             0x03D2
+#define set_REG_DFE_FLAG_reg(data)                                    (*((volatile unsigned int*)REG_DFE_FLAG_reg)=data)
+#define get_REG_DFE_FLAG_reg                                          (*((volatile unsigned int*)REG_DFE_FLAG_reg))
+#define REG_DFE_FLAG_adapt_fail_flag_shift                            (28)
+#define REG_DFE_FLAG_adapt_swing_max_flag_shift                       (24)
+#define REG_DFE_FLAG_flag_rev1_shift                                  (12)
+#define REG_DFE_FLAG_flag_rev2_shift                                  (0)
+#define REG_DFE_FLAG_adapt_fail_flag_mask                             (0xF0000000)
+#define REG_DFE_FLAG_adapt_swing_max_flag_mask                        (0x0F000000)
+#define REG_DFE_FLAG_flag_rev1_mask                                   (0x00FFF000)
+#define REG_DFE_FLAG_flag_rev2_mask                                   (0x00000FFF)
+#define REG_DFE_FLAG_adapt_fail_flag(data)                            (0xF0000000&((data)<<28))
+#define REG_DFE_FLAG_adapt_swing_max_flag(data)                       (0x0F000000&((data)<<24))
+#define REG_DFE_FLAG_flag_rev1(data)                                  (0x00FFF000&((data)<<12))
+#define REG_DFE_FLAG_flag_rev2(data)                                  (0x00000FFF&(data))
+#define REG_DFE_FLAG_get_adapt_fail_flag(data)                        ((0xF0000000&(data))>>28)
+#define REG_DFE_FLAG_get_adapt_swing_max_flag(data)                   ((0x0F000000&(data))>>24)
+#define REG_DFE_FLAG_get_flag_rev1(data)                              ((0x00FFF000&(data))>>12)
+#define REG_DFE_FLAG_get_flag_rev2(data)                              (0x00000FFF&(data))
+
+
+#define REG_DFE_DEBUG                                                 0xf50
+#define REG_DFE_DEBUG_reg_addr                                        "0x98034f50"
+#define REG_DFE_DEBUG_reg                                             0x98034f50
+#define REG_DFE_DEBUG_inst_addr                                       "0x03D4"
+#define REG_DFE_DEBUG_inst                                            0x03D4
+#define set_REG_DFE_DEBUG_reg(data)                                   (*((volatile unsigned int*)REG_DFE_DEBUG_reg)=data)
+#define get_REG_DFE_DEBUG_reg                                         (*((volatile unsigned int*)REG_DFE_DEBUG_reg))
+#define REG_DFE_DEBUG_debug_rev_shift                                 (5)
+#define REG_DFE_DEBUG_debug_sel_shift                                 (0)
+#define REG_DFE_DEBUG_debug_rev_mask                                  (0xFFFFFFE0)
+#define REG_DFE_DEBUG_debug_sel_mask                                  (0x0000001F)
+#define REG_DFE_DEBUG_debug_rev(data)                                 (0xFFFFFFE0&((data)<<5))
+#define REG_DFE_DEBUG_debug_sel(data)                                 (0x0000001F&(data))
+#define REG_DFE_DEBUG_get_debug_rev(data)                             ((0xFFFFFFE0&(data))>>5)
+#define REG_DFE_DEBUG_get_debug_sel(data)                             (0x0000001F&(data))
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/HDMIRXDDC_fw.h b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/HDMIRXDDC_fw.h
new file mode 100644
index 00000000..f7b0453
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/HDMIRXDDC_fw.h
@@ -0,0 +1,582 @@
+// This file is generated using the spec version 1.39, firmware template version 1.39and SRIF Parser                                                                                source code SVN rev:802                    Version flow no.:1.1.66
+#ifndef _DDC_REG_H_INCLUDED_
+#define _DDC_REG_H_INCLUDED_
+
+#define DDC2_I2C_CR                                                   0x00
+#define DDC2_I2C_CR_reg_addr                                          "0x98037704"
+
+#define DDC2_I2C_SR1                                                  0x04
+#define DDC2_I2C_SR1_reg_addr                                         "0x98037704"
+#define DDC2_I2C_SR1_reg                                              0x98037704
+#define DDC2_I2C_SR1_inst_addr                                        "0x01C1"
+#define DDC2_I2C_SR1_inst                                             0x01C1
+#define DDC2_I2C_SR1_cmderr_shift                                     (7)
+#define DDC2_I2C_SR1_finish_shift                                     (4)
+#define DDC2_I2C_SR1_timeout_shift                                    (3)
+#define DDC2_I2C_SR1_cmderr_mask                                      (0x00000080)
+#define DDC2_I2C_SR1_finish_mask                                      (0x00000010)
+#define DDC2_I2C_SR1_timeout_mask                                     (0x00000008)
+#define DDC2_I2C_SR1_cmderr(data)                                     (0x00000080&((data)<<7))
+#define DDC2_I2C_SR1_finish(data)                                     (0x00000010&((data)<<4))
+#define DDC2_I2C_SR1_timeout(data)                                    (0x00000008&((data)<<3))
+#define DDC2_I2C_SR1_get_cmderr(data)                                 ((0x00000080&(data))>>7)
+#define DDC2_I2C_SR1_get_finish(data)                                 ((0x00000010&(data))>>4)
+#define DDC2_I2C_SR1_get_timeout(data)                                ((0x00000008&(data))>>3)
+
+
+#define DDC2_I2C_TR                                                   0x08
+#define DDC2_I2C_TR_reg_addr                                          "0x98037708"
+#define DDC2_I2C_TR_reg                                               0x98037708
+#define DDC2_I2C_TR_inst_addr                                         "0x01C2"
+#define DDC2_I2C_TR_inst                                              0x01C2
+#define DDC2_I2C_TR_timeout_val_shift                                 (0)
+#define DDC2_I2C_TR_timeout_val_mask                                  (0x000000FF)
+#define DDC2_I2C_TR_timeout_val(data)                                 (0x000000FF&(data))
+#define DDC2_I2C_TR_get_timeout_val(data)                             (0x000000FF&(data))
+
+
+#define DDC2_EDID_CR                                                  0x0c
+#define DDC2_EDID_CR_reg_addr                                         "0x9803770c"
+#define DDC2_EDID_CR_reg                                              0x9803770c
+#define DDC2_EDID_CR_inst_addr                                        "0x01C3"
+#define DDC2_EDID_CR_inst                                             0x01C3
+#define DDC2_EDID_CR_edid_address_shift                               (5)
+#define DDC2_EDID_CR_finish_int_en_shift                              (4)
+#define DDC2_EDID_CR_ddc2_force_shift                                 (3)
+#define DDC2_EDID_CR_ddc2b_force_shift                                (2)
+#define DDC2_EDID_CR_edid_srwen_shift                                 (1)
+#define DDC2_EDID_CR_edid_en_shift                                    (0)
+#define DDC2_EDID_CR_edid_address_mask                                (0x000000E0)
+#define DDC2_EDID_CR_finish_int_en_mask                               (0x00000010)
+#define DDC2_EDID_CR_ddc2_force_mask                                  (0x00000008)
+#define DDC2_EDID_CR_ddc2b_force_mask                                 (0x00000004)
+#define DDC2_EDID_CR_edid_srwen_mask                                  (0x00000002)
+#define DDC2_EDID_CR_edid_en_mask                                     (0x00000001)
+#define DDC2_EDID_CR_edid_address(data)                               (0x000000E0&((data)<<5))
+#define DDC2_EDID_CR_finish_int_en(data)                              (0x00000010&((data)<<4))
+#define DDC2_EDID_CR_ddc2_force(data)                                 (0x00000008&((data)<<3))
+#define DDC2_EDID_CR_ddc2b_force(data)                                (0x00000004&((data)<<2))
+#define DDC2_EDID_CR_edid_srwen(data)                                 (0x00000002&((data)<<1))
+#define DDC2_EDID_CR_edid_en(data)                                    (0x00000001&(data))
+#define DDC2_EDID_CR_get_edid_address(data)                           ((0x000000E0&(data))>>5)
+#define DDC2_EDID_CR_get_finish_int_en(data)                          ((0x00000010&(data))>>4)
+#define DDC2_EDID_CR_get_ddc2_force(data)                             ((0x00000008&(data))>>3)
+#define DDC2_EDID_CR_get_ddc2b_force(data)                            ((0x00000004&(data))>>2)
+#define DDC2_EDID_CR_get_edid_srwen(data)                             ((0x00000002&(data))>>1)
+#define DDC2_EDID_CR_get_edid_en(data)                                (0x00000001&(data))
+
+
+#define DDC2_DDC_VCR                                                  0x10
+#define DDC2_DDC_VCR_reg_addr                                         "0x98037710"
+#define DDC2_DDC_VCR_reg                                              0x98037710
+#define DDC2_DDC_VCR_inst_addr                                        "0x01C4"
+#define DDC2_DDC_VCR_inst                                             0x01C4
+#define DDC2_DDC_VCR_ddc2_vcount_shift                                (0)
+#define DDC2_DDC_VCR_ddc2_vcount_mask                                 (0x000000FF)
+#define DDC2_DDC_VCR_ddc2_vcount(data)                                (0x000000FF&(data))
+#define DDC2_DDC_VCR_get_ddc2_vcount(data)                            (0x000000FF&(data))
+
+
+#define DDC2_EDID_IMSWSAR                                             0x14
+#define DDC2_EDID_IMSWSAR_reg_addr                                    "0x98037714"
+#define DDC2_EDID_IMSWSAR_reg                                         0x98037714
+#define DDC2_EDID_IMSWSAR_inst_addr                                   "0x01C5"
+#define DDC2_EDID_IMSWSAR_inst                                        0x01C5
+#define DDC2_EDID_IMSWSAR_edid_sadr_shift                             (0)
+#define DDC2_EDID_IMSWSAR_edid_sadr_mask                              (0x000000FF)
+#define DDC2_EDID_IMSWSAR_edid_sadr(data)                             (0x000000FF&(data))
+#define DDC2_EDID_IMSWSAR_get_edid_sadr(data)                         (0x000000FF&(data))
+
+
+#define DDC2_EDID_IMSWEAR                                             0x18
+#define DDC2_EDID_IMSWEAR_reg_addr                                    "0x98037718"
+#define DDC2_EDID_IMSWEAR_reg                                         0x98037718
+#define DDC2_EDID_IMSWEAR_inst_addr                                   "0x01C6"
+#define DDC2_EDID_IMSWEAR_inst                                        0x01C6
+#define DDC2_EDID_IMSWEAR_edid_eadr_shift                             (0)
+#define DDC2_EDID_IMSWEAR_edid_eadr_mask                              (0x000000FF)
+#define DDC2_EDID_IMSWEAR_edid_eadr(data)                             (0x000000FF&(data))
+#define DDC2_EDID_IMSWEAR_get_edid_eadr(data)                         (0x000000FF&(data))
+
+
+#define DDC2_EDID_IR                                                  0x1c
+#define DDC2_EDID_IR_reg_addr                                         "0x9803771c"
+#define DDC2_EDID_IR_reg                                              0x9803771c
+#define DDC2_EDID_IR_inst_addr                                        "0x01C7"
+#define DDC2_EDID_IR_inst                                             0x01C7
+#define DDC2_EDID_IR_edidmode_shift                                   (6)
+#define DDC2_EDID_IR_edidsubaddress_shift                             (5)
+#define DDC2_EDID_IR_edidstop_shift                                   (4)
+#define DDC2_EDID_IR_i2c_m_rd_st_ie_shift                             (3)
+#define DDC2_EDID_IR_i2c_m_rd_sp_ie_shift                             (2)
+#define DDC2_EDID_IR_edidsubaddress_ie_shift                          (1)
+#define DDC2_EDID_IR_edidstop_ie_shift                                (0)
+#define DDC2_EDID_IR_edidmode_mask                                    (0x00000040)
+#define DDC2_EDID_IR_edidsubaddress_mask                              (0x00000020)
+#define DDC2_EDID_IR_edidstop_mask                                    (0x00000010)
+#define DDC2_EDID_IR_i2c_m_rd_st_ie_mask                              (0x00000008)
+#define DDC2_EDID_IR_i2c_m_rd_sp_ie_mask                              (0x00000004)
+#define DDC2_EDID_IR_edidsubaddress_ie_mask                           (0x00000002)
+#define DDC2_EDID_IR_edidstop_ie_mask                                 (0x00000001)
+#define DDC2_EDID_IR_edidmode(data)                                   (0x00000040&((data)<<6))
+#define DDC2_EDID_IR_edidsubaddress(data)                             (0x00000020&((data)<<5))
+#define DDC2_EDID_IR_edidstop(data)                                   (0x00000010&((data)<<4))
+#define DDC2_EDID_IR_i2c_m_rd_st_ie(data)                             (0x00000008&((data)<<3))
+#define DDC2_EDID_IR_i2c_m_rd_sp_ie(data)                             (0x00000004&((data)<<2))
+#define DDC2_EDID_IR_edidsubaddress_ie(data)                          (0x00000002&((data)<<1))
+#define DDC2_EDID_IR_edidstop_ie(data)                                (0x00000001&(data))
+#define DDC2_EDID_IR_get_edidmode(data)                               ((0x00000040&(data))>>6)
+#define DDC2_EDID_IR_get_edidsubaddress(data)                         ((0x00000020&(data))>>5)
+#define DDC2_EDID_IR_get_edidstop(data)                               ((0x00000010&(data))>>4)
+#define DDC2_EDID_IR_get_i2c_m_rd_st_ie(data)                         ((0x00000008&(data))>>3)
+#define DDC2_EDID_IR_get_i2c_m_rd_sp_ie(data)                         ((0x00000004&(data))>>2)
+#define DDC2_EDID_IR_get_edidsubaddress_ie(data)                      ((0x00000002&(data))>>1)
+#define DDC2_EDID_IR_get_edidstop_ie(data)                            (0x00000001&(data))
+
+
+#define DDC2_DDC_SIR                                                  0x20
+#define DDC2_DDC_SIR_reg_addr                                         "0x98037720"
+#define DDC2_DDC_SIR_reg                                              0x98037720
+#define DDC2_DDC_SIR_inst_addr                                        "0x01C8"
+#define DDC2_DDC_SIR_inst                                             0x01C8
+#define DDC2_DDC_SIR_edidap_shift                                     (0)
+#define DDC2_DDC_SIR_edidap_mask                                      (0x000000FF)
+#define DDC2_DDC_SIR_edidap(data)                                     (0x000000FF&(data))
+#define DDC2_DDC_SIR_get_edidap(data)                                 (0x000000FF&(data))
+
+
+#define DDC2_DDC_SAP                                                  0x24
+#define DDC2_DDC_SAP_reg_addr                                         "0x98037724"
+#define DDC2_DDC_SAP_reg                                              0x98037724
+#define DDC2_DDC_SAP_inst_addr                                        "0x01C9"
+#define DDC2_DDC_SAP_inst                                             0x01C9
+#define DDC2_DDC_SAP_ediddp_shift                                     (0)
+#define DDC2_DDC_SAP_ediddp_mask                                      (0x000000FF)
+#define DDC2_DDC_SAP_ediddp(data)                                     (0x000000FF&(data))
+#define DDC2_DDC_SAP_get_ediddp(data)                                 (0x000000FF&(data))
+
+
+#define DDC2_DDC_BISTCR                                               0x28
+#define DDC2_DDC_BISTCR_reg_addr                                      "0x98037728"
+#define DDC2_DDC_BISTCR_reg                                           0x98037728
+#define DDC2_DDC_BISTCR_inst_addr                                     "0x01CA"
+#define DDC2_DDC_BISTCR_inst                                          0x01CA
+#define DDC2_DDC_BISTCR_ddc_bist_rme_shift                            (4)
+#define DDC2_DDC_BISTCR_ddc_bist_rm_shift                             (0)
+#define DDC2_DDC_BISTCR_ddc_bist_rme_mask                             (0x00000010)
+#define DDC2_DDC_BISTCR_ddc_bist_rm_mask                              (0x0000000F)
+#define DDC2_DDC_BISTCR_ddc_bist_rme(data)                            (0x00000010&((data)<<4))
+#define DDC2_DDC_BISTCR_ddc_bist_rm(data)                             (0x0000000F&(data))
+#define DDC2_DDC_BISTCR_get_ddc_bist_rme(data)                        ((0x00000010&(data))>>4)
+#define DDC2_DDC_BISTCR_get_ddc_bist_rm(data)                         (0x0000000F&(data))
+
+
+#define DDC2_DDC_SCR                                                  0x2c
+#define DDC2_DDC_SCR_reg_addr                                         "0x9803772c"
+#define DDC2_DDC_SCR_reg                                              0x9803772c
+#define DDC2_DDC_SCR_inst_addr                                        "0x01CB"
+#define DDC2_DDC_SCR_inst                                             0x01CB
+#define DDC2_DDC_SCR_segpt_latie_shift                                (7)
+#define DDC2_DDC_SCR_dataoutputdelay_sel_shift                        (4)
+#define DDC2_DDC_SCR_i2c_m_rd_st_sts_shift                            (2)
+#define DDC2_DDC_SCR_i2c_m_rd_sp_sts_shift                            (1)
+#define DDC2_DDC_SCR_sgid_en_shift                                    (0)
+#define DDC2_DDC_SCR_segpt_latie_mask                                 (0x00000080)
+#define DDC2_DDC_SCR_dataoutputdelay_sel_mask                         (0x00000070)
+#define DDC2_DDC_SCR_i2c_m_rd_st_sts_mask                             (0x00000004)
+#define DDC2_DDC_SCR_i2c_m_rd_sp_sts_mask                             (0x00000002)
+#define DDC2_DDC_SCR_sgid_en_mask                                     (0x00000001)
+#define DDC2_DDC_SCR_segpt_latie(data)                                (0x00000080&((data)<<7))
+#define DDC2_DDC_SCR_dataoutputdelay_sel(data)                        (0x00000070&((data)<<4))
+#define DDC2_DDC_SCR_i2c_m_rd_st_sts(data)                            (0x00000004&((data)<<2))
+#define DDC2_DDC_SCR_i2c_m_rd_sp_sts(data)                            (0x00000002&((data)<<1))
+#define DDC2_DDC_SCR_sgid_en(data)                                    (0x00000001&(data))
+#define DDC2_DDC_SCR_get_segpt_latie(data)                            ((0x00000080&(data))>>7)
+#define DDC2_DDC_SCR_get_dataoutputdelay_sel(data)                    ((0x00000070&(data))>>4)
+#define DDC2_DDC_SCR_get_i2c_m_rd_st_sts(data)                        ((0x00000004&(data))>>2)
+#define DDC2_DDC_SCR_get_i2c_m_rd_sp_sts(data)                        ((0x00000002&(data))>>1)
+#define DDC2_DDC_SCR_get_sgid_en(data)                                (0x00000001&(data))
+
+
+#define DDC2_DDC_SSAR                                                 0x30
+#define DDC2_DDC_SSAR_reg_addr                                        "0x98037730"
+#define DDC2_DDC_SSAR_reg                                             0x98037730
+#define DDC2_DDC_SSAR_inst_addr                                       "0x01CC"
+#define DDC2_DDC_SSAR_inst                                            0x01CC
+#define DDC2_DDC_SSAR_sgid_address_shift                              (1)
+#define DDC2_DDC_SSAR_sgid_dtrden_shift                               (0)
+#define DDC2_DDC_SSAR_sgid_address_mask                               (0x000000FE)
+#define DDC2_DDC_SSAR_sgid_dtrden_mask                                (0x00000001)
+#define DDC2_DDC_SSAR_sgid_address(data)                              (0x000000FE&((data)<<1))
+#define DDC2_DDC_SSAR_sgid_dtrden(data)                               (0x00000001&(data))
+#define DDC2_DDC_SSAR_get_sgid_address(data)                          ((0x000000FE&(data))>>1)
+#define DDC2_DDC_SSAR_get_sgid_dtrden(data)                           (0x00000001&(data))
+
+
+#define DDC2_DDC_SPR                                                  0x34
+#define DDC2_DDC_SPR_reg_addr                                         "0x98037734"
+#define DDC2_DDC_SPR_reg                                              0x98037734
+#define DDC2_DDC_SPR_inst_addr                                        "0x01CD"
+#define DDC2_DDC_SPR_inst                                             0x01CD
+#define DDC2_DDC_SPR_segpt_latched_shift                              (7)
+#define DDC2_DDC_SPR_seg_pt_shift                                     (0)
+#define DDC2_DDC_SPR_segpt_latched_mask                               (0x00000080)
+#define DDC2_DDC_SPR_seg_pt_mask                                      (0x0000007F)
+#define DDC2_DDC_SPR_segpt_latched(data)                              (0x00000080&((data)<<7))
+#define DDC2_DDC_SPR_seg_pt(data)                                     (0x0000007F&(data))
+#define DDC2_DDC_SPR_get_segpt_latched(data)                          ((0x00000080&(data))>>7)
+#define DDC2_DDC_SPR_get_seg_pt(data)                                 (0x0000007F&(data))
+
+
+#define DDC2_DDC_SFCR                                                 0x38
+#define DDC2_DDC_SFCR_reg_addr                                        "0x98037738"
+#define DDC2_DDC_SFCR_reg                                             0x98037738
+#define DDC2_DDC_SFCR_inst_addr                                       "0x01CE"
+#define DDC2_DDC_SFCR_inst                                            0x01CE
+#define DDC2_DDC_SFCR_special_mode_shift                              (3)
+#define DDC2_DDC_SFCR_doffpt_reset_shift                              (2)
+#define DDC2_DDC_SFCR_diffpt_reset_shift                              (1)
+#define DDC2_DDC_SFCR_ciid_en_shift                                   (0)
+#define DDC2_DDC_SFCR_special_mode_mask                               (0x00000008)
+#define DDC2_DDC_SFCR_doffpt_reset_mask                               (0x00000004)
+#define DDC2_DDC_SFCR_diffpt_reset_mask                               (0x00000002)
+#define DDC2_DDC_SFCR_ciid_en_mask                                    (0x00000001)
+#define DDC2_DDC_SFCR_special_mode(data)                              (0x00000008&((data)<<3))
+#define DDC2_DDC_SFCR_doffpt_reset(data)                              (0x00000004&((data)<<2))
+#define DDC2_DDC_SFCR_diffpt_reset(data)                              (0x00000002&((data)<<1))
+#define DDC2_DDC_SFCR_ciid_en(data)                                   (0x00000001&(data))
+#define DDC2_DDC_SFCR_get_special_mode(data)                          ((0x00000008&(data))>>3)
+#define DDC2_DDC_SFCR_get_doffpt_reset(data)                          ((0x00000004&(data))>>2)
+#define DDC2_DDC_SFCR_get_diffpt_reset(data)                          ((0x00000002&(data))>>1)
+#define DDC2_DDC_SFCR_get_ciid_en(data)                               (0x00000001&(data))
+
+
+#define DDC2_DDC_SFSAR                                                0x3c
+#define DDC2_DDC_SFSAR_reg_addr                                       "0x9803773c"
+#define DDC2_DDC_SFSAR_reg                                            0x9803773c
+#define DDC2_DDC_SFSAR_inst_addr                                      "0x01CF"
+#define DDC2_DDC_SFSAR_inst                                           0x01CF
+#define DDC2_DDC_SFSAR_ciid_address_shift                             (1)
+#define DDC2_DDC_SFSAR_cirws_current_shift                            (0)
+#define DDC2_DDC_SFSAR_ciid_address_mask                              (0x000000FE)
+#define DDC2_DDC_SFSAR_cirws_current_mask                             (0x00000001)
+#define DDC2_DDC_SFSAR_ciid_address(data)                             (0x000000FE&((data)<<1))
+#define DDC2_DDC_SFSAR_cirws_current(data)                            (0x00000001&(data))
+#define DDC2_DDC_SFSAR_get_ciid_address(data)                         ((0x000000FE&(data))>>1)
+#define DDC2_DDC_SFSAR_get_cirws_current(data)                        (0x00000001&(data))
+
+
+#define DDC2_DDC_SFDR                                                 0x40
+#define DDC2_DDC_SFDR_reg_addr                                        "0x98037740"
+#define DDC2_DDC_SFDR_reg                                             0x98037740
+#define DDC2_DDC_SFDR_inst_addr                                       "0x01D0"
+#define DDC2_DDC_SFDR_inst                                            0x01D0
+#define DDC2_DDC_SFDR_ciiddp_shift                                    (0)
+#define DDC2_DDC_SFDR_ciiddp_mask                                     (0x000000FF)
+#define DDC2_DDC_SFDR_ciiddp(data)                                    (0x000000FF&(data))
+#define DDC2_DDC_SFDR_get_ciiddp(data)                                (0x000000FF&(data))
+
+
+#define DDC2_DDC_SFBSR                                                0x44
+#define DDC2_DDC_SFBSR_reg_addr                                       "0x98037744"
+#define DDC2_DDC_SFBSR_reg                                            0x98037744
+#define DDC2_DDC_SFBSR_inst_addr                                      "0x01D1"
+#define DDC2_DDC_SFBSR_inst                                           0x01D1
+#define DDC2_DDC_SFBSR_cirws_2nd_shift                                (5)
+#define DDC2_DDC_SFBSR_cirws_1st_shift                                (4)
+#define DDC2_DDC_SFBSR_cippt_2nd_shift                                (3)
+#define DDC2_DDC_SFBSR_cispt_2nd_shift                                (2)
+#define DDC2_DDC_SFBSR_cippt_1st_shift                                (1)
+#define DDC2_DDC_SFBSR_cispt_1st_shift                                (0)
+#define DDC2_DDC_SFBSR_cirws_2nd_mask                                 (0x00000020)
+#define DDC2_DDC_SFBSR_cirws_1st_mask                                 (0x00000010)
+#define DDC2_DDC_SFBSR_cippt_2nd_mask                                 (0x00000008)
+#define DDC2_DDC_SFBSR_cispt_2nd_mask                                 (0x00000004)
+#define DDC2_DDC_SFBSR_cippt_1st_mask                                 (0x00000002)
+#define DDC2_DDC_SFBSR_cispt_1st_mask                                 (0x00000001)
+#define DDC2_DDC_SFBSR_cirws_2nd(data)                                (0x00000020&((data)<<5))
+#define DDC2_DDC_SFBSR_cirws_1st(data)                                (0x00000010&((data)<<4))
+#define DDC2_DDC_SFBSR_cippt_2nd(data)                                (0x00000008&((data)<<3))
+#define DDC2_DDC_SFBSR_cispt_2nd(data)                                (0x00000004&((data)<<2))
+#define DDC2_DDC_SFBSR_cippt_1st(data)                                (0x00000002&((data)<<1))
+#define DDC2_DDC_SFBSR_cispt_1st(data)                                (0x00000001&(data))
+#define DDC2_DDC_SFBSR_get_cirws_2nd(data)                            ((0x00000020&(data))>>5)
+#define DDC2_DDC_SFBSR_get_cirws_1st(data)                            ((0x00000010&(data))>>4)
+#define DDC2_DDC_SFBSR_get_cippt_2nd(data)                            ((0x00000008&(data))>>3)
+#define DDC2_DDC_SFBSR_get_cispt_2nd(data)                            ((0x00000004&(data))>>2)
+#define DDC2_DDC_SFBSR_get_cippt_1st(data)                            ((0x00000002&(data))>>1)
+#define DDC2_DDC_SFBSR_get_cispt_1st(data)                            (0x00000001&(data))
+
+
+#define DDC2_DDC_SFIBLR                                               0x48
+#define DDC2_DDC_SFIBLR_reg_addr                                      "0x98037748"
+#define DDC2_DDC_SFIBLR_reg                                           0x98037748
+#define DDC2_DDC_SFIBLR_inst_addr                                     "0x01D2"
+#define DDC2_DDC_SFIBLR_inst                                          0x01D2
+#define DDC2_DDC_SFIBLR_ffdi_dlen_shift                               (0)
+#define DDC2_DDC_SFIBLR_ffdi_dlen_mask                                (0x0000001F)
+#define DDC2_DDC_SFIBLR_ffdi_dlen(data)                               (0x0000001F&(data))
+#define DDC2_DDC_SFIBLR_get_ffdi_dlen(data)                           (0x0000001F&(data))
+
+
+#define DDC2_DDC_SFIBRWPR                                             0x4c
+#define DDC2_DDC_SFIBRWPR_reg_addr                                    "0x9803774c"
+#define DDC2_DDC_SFIBRWPR_reg                                         0x9803774c
+#define DDC2_DDC_SFIBRWPR_inst_addr                                   "0x01D3"
+#define DDC2_DDC_SFIBRWPR_inst                                        0x01D3
+#define DDC2_DDC_SFIBRWPR_diff_wpt_shift                              (4)
+#define DDC2_DDC_SFIBRWPR_diff_rpt_shift                              (0)
+#define DDC2_DDC_SFIBRWPR_diff_wpt_mask                               (0x000000F0)
+#define DDC2_DDC_SFIBRWPR_diff_rpt_mask                               (0x0000000F)
+#define DDC2_DDC_SFIBRWPR_diff_wpt(data)                              (0x000000F0&((data)<<4))
+#define DDC2_DDC_SFIBRWPR_diff_rpt(data)                              (0x0000000F&(data))
+#define DDC2_DDC_SFIBRWPR_get_diff_wpt(data)                          ((0x000000F0&(data))>>4)
+#define DDC2_DDC_SFIBRWPR_get_diff_rpt(data)                          (0x0000000F&(data))
+
+
+#define DDC2_DDC_SFIBSWPR                                             0x50
+#define DDC2_DDC_SFIBSWPR_reg_addr                                    "0x98037750"
+#define DDC2_DDC_SFIBSWPR_reg                                         0x98037750
+#define DDC2_DDC_SFIBSWPR_inst_addr                                   "0x01D4"
+#define DDC2_DDC_SFIBSWPR_inst                                        0x01D4
+#define DDC2_DDC_SFIBSWPR_diffstop_pt_shift                           (0)
+#define DDC2_DDC_SFIBSWPR_diffstop_pt_mask                            (0x0000000F)
+#define DDC2_DDC_SFIBSWPR_diffstop_pt(data)                           (0x0000000F&(data))
+#define DDC2_DDC_SFIBSWPR_get_diffstop_pt(data)                       (0x0000000F&(data))
+
+
+#define DDC2_DDC_SFOBSR                                               0x54
+#define DDC2_DDC_SFOBSR_reg_addr                                      "0x98037754"
+#define DDC2_DDC_SFOBSR_reg                                           0x98037754
+#define DDC2_DDC_SFOBSR_inst_addr                                     "0x01D5"
+#define DDC2_DDC_SFOBSR_inst                                          0x01D5
+#define DDC2_DDC_SFOBSR_ffdo_dlen_shift                               (0)
+#define DDC2_DDC_SFOBSR_ffdo_dlen_mask                                (0x0000001F)
+#define DDC2_DDC_SFOBSR_ffdo_dlen(data)                               (0x0000001F&(data))
+#define DDC2_DDC_SFOBSR_get_ffdo_dlen(data)                           (0x0000001F&(data))
+
+
+#define DDC2_DDC_SFOBRWPR                                             0x58
+#define DDC2_DDC_SFOBRWPR_reg_addr                                    "0x98037758"
+#define DDC2_DDC_SFOBRWPR_reg                                         0x98037758
+#define DDC2_DDC_SFOBRWPR_inst_addr                                   "0x01D6"
+#define DDC2_DDC_SFOBRWPR_inst                                        0x01D6
+#define DDC2_DDC_SFOBRWPR_doff_wpt_shift                              (4)
+#define DDC2_DDC_SFOBRWPR_doff_rpt_shift                              (0)
+#define DDC2_DDC_SFOBRWPR_doff_wpt_mask                               (0x000000F0)
+#define DDC2_DDC_SFOBRWPR_doff_rpt_mask                               (0x0000000F)
+#define DDC2_DDC_SFOBRWPR_doff_wpt(data)                              (0x000000F0&((data)<<4))
+#define DDC2_DDC_SFOBRWPR_doff_rpt(data)                              (0x0000000F&(data))
+#define DDC2_DDC_SFOBRWPR_get_doff_wpt(data)                          ((0x000000F0&(data))>>4)
+#define DDC2_DDC_SFOBRWPR_get_doff_rpt(data)                          (0x0000000F&(data))
+
+
+#define DDC2_DDC_SFSR                                                 0x5c
+#define DDC2_DDC_SFSR_reg_addr                                        "0x9803775c"
+#define DDC2_DDC_SFSR_reg                                             0x9803775c
+#define DDC2_DDC_SFSR_inst_addr                                       "0x01D7"
+#define DDC2_DDC_SFSR_inst                                            0x01D7
+#define DDC2_DDC_SFSR_ffdouf_st_shift                                 (7)
+#define DDC2_DDC_SFSR_ffdiof_st_shift                                 (6)
+#define DDC2_DDC_SFSR_ffdonf_st_shift                                 (5)
+#define DDC2_DDC_SFSR_ffdoet_st_shift                                 (4)
+#define DDC2_DDC_SFSR_ffdifu_st_shift                                 (3)
+#define DDC2_DDC_SFSR_ffdine_st_shift                                 (2)
+#define DDC2_DDC_SFSR_ffdouf_st_mask                                  (0x00000080)
+#define DDC2_DDC_SFSR_ffdiof_st_mask                                  (0x00000040)
+#define DDC2_DDC_SFSR_ffdonf_st_mask                                  (0x00000020)
+#define DDC2_DDC_SFSR_ffdoet_st_mask                                  (0x00000010)
+#define DDC2_DDC_SFSR_ffdifu_st_mask                                  (0x00000008)
+#define DDC2_DDC_SFSR_ffdine_st_mask                                  (0x00000004)
+#define DDC2_DDC_SFSR_ffdouf_st(data)                                 (0x00000080&((data)<<7))
+#define DDC2_DDC_SFSR_ffdiof_st(data)                                 (0x00000040&((data)<<6))
+#define DDC2_DDC_SFSR_ffdonf_st(data)                                 (0x00000020&((data)<<5))
+#define DDC2_DDC_SFSR_ffdoet_st(data)                                 (0x00000010&((data)<<4))
+#define DDC2_DDC_SFSR_ffdifu_st(data)                                 (0x00000008&((data)<<3))
+#define DDC2_DDC_SFSR_ffdine_st(data)                                 (0x00000004&((data)<<2))
+#define DDC2_DDC_SFSR_get_ffdouf_st(data)                             ((0x00000080&(data))>>7)
+#define DDC2_DDC_SFSR_get_ffdiof_st(data)                             ((0x00000040&(data))>>6)
+#define DDC2_DDC_SFSR_get_ffdonf_st(data)                             ((0x00000020&(data))>>5)
+#define DDC2_DDC_SFSR_get_ffdoet_st(data)                             ((0x00000010&(data))>>4)
+#define DDC2_DDC_SFSR_get_ffdifu_st(data)                             ((0x00000008&(data))>>3)
+#define DDC2_DDC_SFSR_get_ffdine_st(data)                             ((0x00000004&(data))>>2)
+
+
+#define DDC2_DDC_SFIR                                                 0x60
+#define DDC2_DDC_SFIR_reg_addr                                        "0x98037760"
+#define DDC2_DDC_SFIR_reg                                             0x98037760
+#define DDC2_DDC_SFIR_inst_addr                                       "0x01D8"
+#define DDC2_DDC_SFIR_inst                                            0x01D8
+#define DDC2_DDC_SFIR_ffdouf_ie_shift                                 (7)
+#define DDC2_DDC_SFIR_ffdiof_ie_shift                                 (6)
+#define DDC2_DDC_SFIR_ffdonf_ie_shift                                 (5)
+#define DDC2_DDC_SFIR_ffdoet_ie_shift                                 (4)
+#define DDC2_DDC_SFIR_ffdifu_ie_shift                                 (3)
+#define DDC2_DDC_SFIR_ffdine_ie_shift                                 (2)
+#define DDC2_DDC_SFIR_cippt_ie_shift                                  (1)
+#define DDC2_DDC_SFIR_cispt_ie_shift                                  (0)
+#define DDC2_DDC_SFIR_ffdouf_ie_mask                                  (0x00000080)
+#define DDC2_DDC_SFIR_ffdiof_ie_mask                                  (0x00000040)
+#define DDC2_DDC_SFIR_ffdonf_ie_mask                                  (0x00000020)
+#define DDC2_DDC_SFIR_ffdoet_ie_mask                                  (0x00000010)
+#define DDC2_DDC_SFIR_ffdifu_ie_mask                                  (0x00000008)
+#define DDC2_DDC_SFIR_ffdine_ie_mask                                  (0x00000004)
+#define DDC2_DDC_SFIR_cippt_ie_mask                                   (0x00000002)
+#define DDC2_DDC_SFIR_cispt_ie_mask                                   (0x00000001)
+#define DDC2_DDC_SFIR_ffdouf_ie(data)                                 (0x00000080&((data)<<7))
+#define DDC2_DDC_SFIR_ffdiof_ie(data)                                 (0x00000040&((data)<<6))
+#define DDC2_DDC_SFIR_ffdonf_ie(data)                                 (0x00000020&((data)<<5))
+#define DDC2_DDC_SFIR_ffdoet_ie(data)                                 (0x00000010&((data)<<4))
+#define DDC2_DDC_SFIR_ffdifu_ie(data)                                 (0x00000008&((data)<<3))
+#define DDC2_DDC_SFIR_ffdine_ie(data)                                 (0x00000004&((data)<<2))
+#define DDC2_DDC_SFIR_cippt_ie(data)                                  (0x00000002&((data)<<1))
+#define DDC2_DDC_SFIR_cispt_ie(data)                                  (0x00000001&(data))
+#define DDC2_DDC_SFIR_get_ffdouf_ie(data)                             ((0x00000080&(data))>>7)
+#define DDC2_DDC_SFIR_get_ffdiof_ie(data)                             ((0x00000040&(data))>>6)
+#define DDC2_DDC_SFIR_get_ffdonf_ie(data)                             ((0x00000020&(data))>>5)
+#define DDC2_DDC_SFIR_get_ffdoet_ie(data)                             ((0x00000010&(data))>>4)
+#define DDC2_DDC_SFIR_get_ffdifu_ie(data)                             ((0x00000008&(data))>>3)
+#define DDC2_DDC_SFIR_get_ffdine_ie(data)                             ((0x00000004&(data))>>2)
+#define DDC2_DDC_SFIR_get_cippt_ie(data)                              ((0x00000002&(data))>>1)
+#define DDC2_DDC_SFIR_get_cispt_ie(data)                              (0x00000001&(data))
+
+
+#define DDC2_DDC_FSMS                                                 0x64
+#define DDC2_DDC_FSMS_reg_addr                                        "0x98037764"
+#define DDC2_DDC_FSMS_reg                                             0x98037764
+#define DDC2_DDC_FSMS_inst_addr                                       "0x01D9"
+#define DDC2_DDC_FSMS_inst                                            0x01D9
+#define DDC2_DDC_FSMS_cmdfsm_st_shift                                 (0)
+#define DDC2_DDC_FSMS_cmdfsm_st_mask                                  (0x000000FF)
+#define DDC2_DDC_FSMS_cmdfsm_st(data)                                 (0x000000FF&(data))
+#define DDC2_DDC_FSMS_get_cmdfsm_st(data)                             (0x000000FF&(data))
+
+
+#define DDC2_DDC_DUMMY                                                0x68
+#define DDC2_DDC_DUMMY_reg_addr                                       "0x98037768"
+#define DDC2_DDC_DUMMY_reg                                            0x98037768
+#define DDC2_DDC_DUMMY_inst_addr                                      "0x01DA"
+#define DDC2_DDC_DUMMY_inst                                           0x01DA
+#define DDC2_DDC_DUMMY_dummy98037768_7_0_shift                        (0)
+#define DDC2_DDC_DUMMY_dummy98037768_7_0_mask                         (0x000000FF)
+#define DDC2_DDC_DUMMY_dummy98037768_7_0(data)                        (0x000000FF&(data))
+#define DDC2_DDC_DUMMY_get_dummy98037768_7_0(data)                    (0x000000FF&(data))
+
+
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN                                0x70
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_reg_addr                       "0x98037770"
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_reg                            0x98037770
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_inst_addr                      "0x01DC"
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_inst                           0x01DC
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_start_irq_en_shift             (1)
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_stop_irq_en_shift              (0)
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_start_irq_en_mask              (0x00000002)
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_stop_irq_en_mask               (0x00000001)
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_start_irq_en(data)             (0x00000002&((data)<<1))
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_stop_irq_en(data)              (0x00000001&(data))
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_get_start_irq_en(data)         ((0x00000002&(data))>>1)
+#define DDC2_DDC_EDID_SRAM_READ_IRQ_EN_get_stop_irq_en(data)          (0x00000001&(data))
+
+
+#define DDC2_DDC_EDID_SRAM_READ_AUX                                   0x74
+#define DDC2_DDC_EDID_SRAM_READ_AUX_reg_addr                          "0x98037774"
+#define DDC2_DDC_EDID_SRAM_READ_AUX_reg                               0x98037774
+#define DDC2_DDC_EDID_SRAM_READ_AUX_inst_addr                         "0x01DD"
+#define DDC2_DDC_EDID_SRAM_READ_AUX_inst                              0x01DD
+#define DDC2_DDC_EDID_SRAM_READ_AUX_start_shift                       (1)
+#define DDC2_DDC_EDID_SRAM_READ_AUX_stop_shift                        (0)
+#define DDC2_DDC_EDID_SRAM_READ_AUX_start_mask                        (0x00000002)
+#define DDC2_DDC_EDID_SRAM_READ_AUX_stop_mask                         (0x00000001)
+#define DDC2_DDC_EDID_SRAM_READ_AUX_start(data)                       (0x00000002&((data)<<1))
+#define DDC2_DDC_EDID_SRAM_READ_AUX_stop(data)                        (0x00000001&(data))
+#define DDC2_DDC_EDID_SRAM_READ_AUX_get_start(data)                   ((0x00000002&(data))>>1)
+#define DDC2_DDC_EDID_SRAM_READ_AUX_get_stop(data)                    (0x00000001&(data))
+
+
+#define DDC2_DDC_BIST_MODE                                            0x78
+#define DDC2_DDC_BIST_MODE_reg_addr                                   "0x98037778"
+#define DDC2_DDC_BIST_MODE_reg                                        0x98037778
+#define DDC2_DDC_BIST_MODE_inst_addr                                  "0x01DE"
+#define DDC2_DDC_BIST_MODE_inst                                       0x01DE
+#define DDC2_DDC_BIST_MODE_ddc_bist_mode_shift                        (0)
+#define DDC2_DDC_BIST_MODE_ddc_bist_mode_mask                         (0x00000001)
+#define DDC2_DDC_BIST_MODE_ddc_bist_mode(data)                        (0x00000001&(data))
+#define DDC2_DDC_BIST_MODE_get_ddc_bist_mode(data)                    (0x00000001&(data))
+
+
+#define DDC2_DDC_BIST_DONE                                            0x7c
+#define DDC2_DDC_BIST_DONE_reg_addr                                   "0x9803777c"
+#define DDC2_DDC_BIST_DONE_reg                                        0x9803777c
+#define DDC2_DDC_BIST_DONE_inst_addr                                  "0x01DF"
+#define DDC2_DDC_BIST_DONE_inst                                       0x01DF
+#define DDC2_DDC_BIST_DONE_ddc_bist_done_shift                        (0)
+#define DDC2_DDC_BIST_DONE_ddc_bist_done_mask                         (0x00000001)
+#define DDC2_DDC_BIST_DONE_ddc_bist_done(data)                        (0x00000001&(data))
+#define DDC2_DDC_BIST_DONE_get_ddc_bist_done(data)                    (0x00000001&(data))
+
+
+#define DDC2_DDC_BIST_FAIL                                            0x80
+#define DDC2_DDC_BIST_FAIL_reg_addr                                   "0x98037780"
+#define DDC2_DDC_BIST_FAIL_reg                                        0x98037780
+#define DDC2_DDC_BIST_FAIL_inst_addr                                  "0x01E0"
+#define DDC2_DDC_BIST_FAIL_inst                                       0x01E0
+#define DDC2_DDC_BIST_FAIL_ddc_bist_fail_shift                        (0)
+#define DDC2_DDC_BIST_FAIL_ddc_bist_fail_mask                         (0x00000001)
+#define DDC2_DDC_BIST_FAIL_ddc_bist_fail(data)                        (0x00000001&(data))
+#define DDC2_DDC_BIST_FAIL_get_ddc_bist_fail(data)                    (0x00000001&(data))
+
+
+#define DDC2_DDC_DRF_MODE                                             0x84
+#define DDC2_DDC_DRF_MODE_reg_addr                                    "0x98037784"
+#define DDC2_DDC_DRF_MODE_reg                                         0x98037784
+#define DDC2_DDC_DRF_MODE_inst_addr                                   "0x01E1"
+#define DDC2_DDC_DRF_MODE_inst                                        0x01E1
+#define DDC2_DDC_DRF_MODE_ddc_drf_mode_shift                          (0)
+#define DDC2_DDC_DRF_MODE_ddc_drf_mode_mask                           (0x00000001)
+#define DDC2_DDC_DRF_MODE_ddc_drf_mode(data)                          (0x00000001&(data))
+#define DDC2_DDC_DRF_MODE_get_ddc_drf_mode(data)                      (0x00000001&(data))
+
+
+#define DDC2_DDC_DRF_RESUME                                           0x88
+#define DDC2_DDC_DRF_RESUME_reg_addr                                  "0x98037788"
+#define DDC2_DDC_DRF_RESUME_reg                                       0x98037788
+#define DDC2_DDC_DRF_RESUME_inst_addr                                 "0x01E2"
+#define DDC2_DDC_DRF_RESUME_inst                                      0x01E2
+#define DDC2_DDC_DRF_RESUME_ddc_drf_resume_shift                      (0)
+#define DDC2_DDC_DRF_RESUME_ddc_drf_resume_mask                       (0x00000001)
+#define DDC2_DDC_DRF_RESUME_ddc_drf_resume(data)                      (0x00000001&(data))
+#define DDC2_DDC_DRF_RESUME_get_ddc_drf_resume(data)                  (0x00000001&(data))
+
+
+#define DDC2_DDC_DRF_DONE                                             0x8c
+#define DDC2_DDC_DRF_DONE_reg_addr                                    "0x9803778c"
+#define DDC2_DDC_DRF_DONE_reg                                         0x9803778c
+#define DDC2_DDC_DRF_DONE_inst_addr                                   "0x01E3"
+#define DDC2_DDC_DRF_DONE_inst                                        0x01E3
+#define DDC2_DDC_DRF_DONE_ddc_drf_done_shift                          (0)
+#define DDC2_DDC_DRF_DONE_ddc_drf_done_mask                           (0x00000001)
+#define DDC2_DDC_DRF_DONE_ddc_drf_done(data)                          (0x00000001&(data))
+#define DDC2_DDC_DRF_DONE_get_ddc_drf_done(data)                      (0x00000001&(data))
+
+
+#define DDC2_DDC_DRF_PAUSE                                            0x90
+#define DDC2_DDC_DRF_PAUSE_reg_addr                                   "0x98037790"
+#define DDC2_DDC_DRF_PAUSE_reg                                        0x98037790
+#define DDC2_DDC_DRF_PAUSE_inst_addr                                  "0x01E4"
+#define DDC2_DDC_DRF_PAUSE_inst                                       0x01E4
+#define DDC2_DDC_DRF_PAUSE_ddc_drf_pause_shift                        (0)
+#define DDC2_DDC_DRF_PAUSE_ddc_drf_pause_mask                         (0x00000001)
+#define DDC2_DDC_DRF_PAUSE_ddc_drf_pause(data)                        (0x00000001&(data))
+#define DDC2_DDC_DRF_PAUSE_get_ddc_drf_pause(data)                    (0x00000001&(data))
+
+
+#define DDC2_DDC_DRF_FAIL                                             0x94
+#define DDC2_DDC_DRF_FAIL_reg_addr                                    "0x98037794"
+#define DDC2_DDC_DRF_FAIL_reg                                         0x98037794
+#define DDC2_DDC_DRF_FAIL_inst_addr                                   "0x01E5"
+#define DDC2_DDC_DRF_FAIL_inst                                        0x01E5
+#define DDC2_DDC_DRF_FAIL_ddc_drf_fail_shift                          (0)
+#define DDC2_DDC_DRF_FAIL_ddc_drf_fail_mask                           (0x00000001)
+#define DDC2_DDC_DRF_FAIL_ddc_drf_fail(data)                          (0x00000001&(data))
+#define DDC2_DDC_DRF_FAIL_get_ddc_drf_fail(data)                      (0x00000001&(data))
+#endif//_DDC_REG_H_INCLUDED_
\ No newline at end of file
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/HDMI_fw.h b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/HDMI_fw.h
new file mode 100644
index 00000000..a1e4c6f
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/HDMI_fw.h
@@ -0,0 +1,5540 @@
+/*===========*@date:2015/3/6===========*/
+
+#ifndef _HDMI_RX_REG_H_INCLUDED_
+#define _HDMI_RX_REG_H_INCLUDED_
+
+#define TMDS_MSR0                                                     0x000
+#define TMDS_MSR0_reg_addr                                            "0x98034000"
+#define TMDS_MSR0_reg                                                 0x98034000
+#define TMDS_MSR0_inst_addr                                           "0x0000"
+#define TMDS_MSR0_inst                                                0x0000
+#define set_TMDS_MSR0_reg(data)                                       (*((volatile unsigned int*)TMDS_MSR0_reg)=data)
+#define get_TMDS_MSR0_reg                                             (*((volatile unsigned int*)TMDS_MSR0_reg))
+#define TMDS_MSR0_tmm_shift                                           (7)
+#define TMDS_MSR0_mt_shift                                            (4)
+#define TMDS_MSR0_ncp_shift                                           (0)
+#define TMDS_MSR0_tmm_mask                                            (0x00000080)
+#define TMDS_MSR0_mt_mask                                             (0x00000070)
+#define TMDS_MSR0_ncp_mask                                            (0x0000000F)
+#define TMDS_MSR0_tmm(data)                                           (0x00000080&((data)<<7))
+#define TMDS_MSR0_mt(data)                                            (0x00000070&((data)<<4))
+#define TMDS_MSR0_ncp(data)                                           (0x0000000F&(data))
+#define TMDS_MSR0_get_tmm(data)                                       ((0x00000080&(data))>>7)
+#define TMDS_MSR0_get_mt(data)                                        ((0x00000070&(data))>>4)
+#define TMDS_MSR0_get_ncp(data)                                       (0x0000000F&(data))
+
+
+#define TMDS_MSR1                                                     0x004
+#define TMDS_MSR1_reg_addr                                            "0x98034004"
+#define TMDS_MSR1_reg                                                 0x98034004
+#define TMDS_MSR1_inst_addr                                           "0x0001"
+#define TMDS_MSR1_inst                                                0x0001
+#define set_TMDS_MSR1_reg(data)                                       (*((volatile unsigned int*)TMDS_MSR1_reg)=data)
+#define get_TMDS_MSR1_reg                                             (*((volatile unsigned int*)TMDS_MSR1_reg))
+#define TMDS_MSR1_tms_shift                                           (12)
+#define TMDS_MSR1_mrs_shift                                           (10)
+#define TMDS_MSR1_ms_shift                                            (8)
+#define TMDS_MSR1_ctc_shift                                           (7)
+#define TMDS_MSR1_vmr_shift                                           (0)
+#define TMDS_MSR1_tms_mask                                            (0x00001000)
+#define TMDS_MSR1_mrs_mask                                            (0x00000C00)
+#define TMDS_MSR1_ms_mask                                             (0x00000300)
+#define TMDS_MSR1_ctc_mask                                            (0x00000080)
+#define TMDS_MSR1_vmr_mask                                            (0x0000007F)
+#define TMDS_MSR1_tms(data)                                           (0x00001000&((data)<<12))
+#define TMDS_MSR1_mrs(data)                                           (0x00000C00&((data)<<10))
+#define TMDS_MSR1_ms(data)                                            (0x00000300&((data)<<8))
+#define TMDS_MSR1_ctc(data)                                           (0x00000080&((data)<<7))
+#define TMDS_MSR1_vmr(data)                                           (0x0000007F&(data))
+#define TMDS_MSR1_get_tms(data)                                       ((0x00001000&(data))>>12)
+#define TMDS_MSR1_get_mrs(data)                                       ((0x00000C00&(data))>>10)
+#define TMDS_MSR1_get_ms(data)                                        ((0x00000300&(data))>>8)
+#define TMDS_MSR1_get_ctc(data)                                       ((0x00000080&(data))>>7)
+#define TMDS_MSR1_get_vmr(data)                                       (0x0000007F&(data))
+
+
+#define TMDS_CRCC                                                     0x008
+#define TMDS_CRCC_reg_addr                                            "0x98034008"
+#define TMDS_CRCC_reg                                                 0x98034008
+#define TMDS_CRCC_inst_addr                                           "0x0002"
+#define TMDS_CRCC_inst                                                0x0002
+#define set_TMDS_CRCC_reg(data)                                       (*((volatile unsigned int*)TMDS_CRCC_reg)=data)
+#define get_TMDS_CRCC_reg                                             (*((volatile unsigned int*)TMDS_CRCC_reg))
+#define TMDS_CRCC_crc_r_en_shift                                      (7)
+#define TMDS_CRCC_crc_g_en_shift                                      (6)
+#define TMDS_CRCC_crc_b_en_shift                                      (5)
+#define TMDS_CRCC_crc_done_shift                                      (4)
+#define TMDS_CRCC_crc_nonstable_shift                                 (3)
+#define TMDS_CRCC_crcts_shift                                         (1)
+#define TMDS_CRCC_crcc_shift                                          (0)
+#define TMDS_CRCC_crc_r_en_mask                                       (0x00000080)
+#define TMDS_CRCC_crc_g_en_mask                                       (0x00000040)
+#define TMDS_CRCC_crc_b_en_mask                                       (0x00000020)
+#define TMDS_CRCC_crc_done_mask                                       (0x00000010)
+#define TMDS_CRCC_crc_nonstable_mask                                  (0x00000008)
+#define TMDS_CRCC_crcts_mask                                          (0x00000006)
+#define TMDS_CRCC_crcc_mask                                           (0x00000001)
+#define TMDS_CRCC_crc_r_en(data)                                      (0x00000080&((data)<<7))
+#define TMDS_CRCC_crc_g_en(data)                                      (0x00000040&((data)<<6))
+#define TMDS_CRCC_crc_b_en(data)                                      (0x00000020&((data)<<5))
+#define TMDS_CRCC_crc_done(data)                                      (0x00000010&((data)<<4))
+#define TMDS_CRCC_crc_nonstable(data)                                 (0x00000008&((data)<<3))
+#define TMDS_CRCC_crcts(data)                                         (0x00000006&((data)<<1))
+#define TMDS_CRCC_crcc(data)                                          (0x00000001&(data))
+#define TMDS_CRCC_get_crc_r_en(data)                                  ((0x00000080&(data))>>7)
+#define TMDS_CRCC_get_crc_g_en(data)                                  ((0x00000040&(data))>>6)
+#define TMDS_CRCC_get_crc_b_en(data)                                  ((0x00000020&(data))>>5)
+#define TMDS_CRCC_get_crc_done(data)                                  ((0x00000010&(data))>>4)
+#define TMDS_CRCC_get_crc_nonstable(data)                             ((0x00000008&(data))>>3)
+#define TMDS_CRCC_get_crcts(data)                                     ((0x00000006&(data))>>1)
+#define TMDS_CRCC_get_crcc(data)                                      (0x00000001&(data))
+
+
+#define TMDS_CRCO0                                                    0x00c
+#define TMDS_CRCO0_reg_addr                                           "0x9803400c"
+#define TMDS_CRCO0_reg                                                0x9803400c
+#define TMDS_CRCO0_inst_addr                                          "0x0003"
+#define TMDS_CRCO0_inst                                               0x0003
+#define set_TMDS_CRCO0_reg(data)                                      (*((volatile unsigned int*)TMDS_CRCO0_reg)=data)
+#define get_TMDS_CRCO0_reg                                            (*((volatile unsigned int*)TMDS_CRCO0_reg))
+#define TMDS_CRCO0_crcob2_3_shift                                     (16)
+#define TMDS_CRCO0_crcob2_2_shift                                     (8)
+#define TMDS_CRCO0_crcob2_1_shift                                     (0)
+#define TMDS_CRCO0_crcob2_3_mask                                      (0x00FF0000)
+#define TMDS_CRCO0_crcob2_2_mask                                      (0x0000FF00)
+#define TMDS_CRCO0_crcob2_1_mask                                      (0x000000FF)
+#define TMDS_CRCO0_crcob2_3(data)                                     (0x00FF0000&((data)<<16))
+#define TMDS_CRCO0_crcob2_2(data)                                     (0x0000FF00&((data)<<8))
+#define TMDS_CRCO0_crcob2_1(data)                                     (0x000000FF&(data))
+#define TMDS_CRCO0_get_crcob2_3(data)                                 ((0x00FF0000&(data))>>16)
+#define TMDS_CRCO0_get_crcob2_2(data)                                 ((0x0000FF00&(data))>>8)
+#define TMDS_CRCO0_get_crcob2_1(data)                                 (0x000000FF&(data))
+
+
+#define TMDS_CRCO1                                                    0x010
+#define TMDS_CRCO1_reg_addr                                           "0x98034010"
+#define TMDS_CRCO1_reg                                                0x98034010
+#define TMDS_CRCO1_inst_addr                                          "0x0004"
+#define TMDS_CRCO1_inst                                               0x0004
+#define set_TMDS_CRCO1_reg(data)                                      (*((volatile unsigned int*)TMDS_CRCO1_reg)=data)
+#define get_TMDS_CRCO1_reg                                            (*((volatile unsigned int*)TMDS_CRCO1_reg))
+#define TMDS_CRCO1_crcob2_6_shift                                     (16)
+#define TMDS_CRCO1_crcob2_5_shift                                     (8)
+#define TMDS_CRCO1_crcob2_4_shift                                     (0)
+#define TMDS_CRCO1_crcob2_6_mask                                      (0x00FF0000)
+#define TMDS_CRCO1_crcob2_5_mask                                      (0x0000FF00)
+#define TMDS_CRCO1_crcob2_4_mask                                      (0x000000FF)
+#define TMDS_CRCO1_crcob2_6(data)                                     (0x00FF0000&((data)<<16))
+#define TMDS_CRCO1_crcob2_5(data)                                     (0x0000FF00&((data)<<8))
+#define TMDS_CRCO1_crcob2_4(data)                                     (0x000000FF&(data))
+#define TMDS_CRCO1_get_crcob2_6(data)                                 ((0x00FF0000&(data))>>16)
+#define TMDS_CRCO1_get_crcob2_5(data)                                 ((0x0000FF00&(data))>>8)
+#define TMDS_CRCO1_get_crcob2_4(data)                                 (0x000000FF&(data))
+
+
+#define TMDS_CTRL                                                     0x014
+#define TMDS_CTRL_reg_addr                                            "0x98034014"
+#define TMDS_CTRL_reg                                                 0x98034014
+#define TMDS_CTRL_inst_addr                                           "0x0005"
+#define TMDS_CTRL_inst                                                0x0005
+#define set_TMDS_CTRL_reg(data)                                       (*((volatile unsigned int*)TMDS_CTRL_reg)=data)
+#define get_TMDS_CTRL_reg                                             (*((volatile unsigned int*)TMDS_CTRL_reg))
+#define TMDS_CTRL_bcd_shift                                           (7)
+#define TMDS_CTRL_gcd_shift                                           (6)
+#define TMDS_CTRL_rcd_shift                                           (5)
+#define TMDS_CTRL_ho_shift                                            (4)
+#define TMDS_CTRL_yo_shift                                            (3)
+#define TMDS_CTRL_dummy_2_0_shift                                     (0)
+#define TMDS_CTRL_bcd_mask                                            (0x00000080)
+#define TMDS_CTRL_gcd_mask                                            (0x00000040)
+#define TMDS_CTRL_rcd_mask                                            (0x00000020)
+#define TMDS_CTRL_ho_mask                                             (0x00000010)
+#define TMDS_CTRL_yo_mask                                             (0x00000008)
+#define TMDS_CTRL_dummy_2_0_mask                                      (0x00000007)
+#define TMDS_CTRL_bcd(data)                                           (0x00000080&((data)<<7))
+#define TMDS_CTRL_gcd(data)                                           (0x00000040&((data)<<6))
+#define TMDS_CTRL_rcd(data)                                           (0x00000020&((data)<<5))
+#define TMDS_CTRL_ho(data)                                            (0x00000010&((data)<<4))
+#define TMDS_CTRL_yo(data)                                            (0x00000008&((data)<<3))
+#define TMDS_CTRL_dummy_2_0(data)                                     (0x00000007&(data))
+#define TMDS_CTRL_get_bcd(data)                                       ((0x00000080&(data))>>7)
+#define TMDS_CTRL_get_gcd(data)                                       ((0x00000040&(data))>>6)
+#define TMDS_CTRL_get_rcd(data)                                       ((0x00000020&(data))>>5)
+#define TMDS_CTRL_get_ho(data)                                        ((0x00000010&(data))>>4)
+#define TMDS_CTRL_get_yo(data)                                        ((0x00000008&(data))>>3)
+#define TMDS_CTRL_get_dummy_2_0(data)                                 (0x00000007&(data))
+
+
+#define TMDS_OUTCTL                                                   0x018
+#define TMDS_OUTCTL_reg_addr                                          "0x98034018"
+#define TMDS_OUTCTL_reg                                               0x98034018
+#define TMDS_OUTCTL_inst_addr                                         "0x0006"
+#define TMDS_OUTCTL_inst                                              0x0006
+#define set_TMDS_OUTCTL_reg(data)                                     (*((volatile unsigned int*)TMDS_OUTCTL_reg)=data)
+#define get_TMDS_OUTCTL_reg                                           (*((volatile unsigned int*)TMDS_OUTCTL_reg))
+#define TMDS_OUTCTL_trcoe_r_shift                                     (13)
+#define TMDS_OUTCTL_tgcoe_r_shift                                     (12)
+#define TMDS_OUTCTL_tbcoe_r_shift                                     (11)
+#define TMDS_OUTCTL_ocke_r_shift                                      (10)
+#define TMDS_OUTCTL_aoe_shift                                         (9)
+#define TMDS_OUTCTL_trcoe_shift                                       (8)
+#define TMDS_OUTCTL_tgcoe_shift                                       (7)
+#define TMDS_OUTCTL_tbcoe_shift                                       (6)
+#define TMDS_OUTCTL_ocke_shift                                        (5)
+#define TMDS_OUTCTL_ockie_shift                                       (4)
+#define TMDS_OUTCTL_dummy_3_shift                                     (3)
+#define TMDS_OUTCTL_dummy_2_shift                                     (2)
+#define TMDS_OUTCTL_dummy_1_shift                                     (1)
+#define TMDS_OUTCTL_dummy_0_shift                                     (0)
+#define TMDS_OUTCTL_trcoe_r_mask                                      (0x00002000)
+#define TMDS_OUTCTL_tgcoe_r_mask                                      (0x00001000)
+#define TMDS_OUTCTL_tbcoe_r_mask                                      (0x00000800)
+#define TMDS_OUTCTL_ocke_r_mask                                       (0x00000400)
+#define TMDS_OUTCTL_aoe_mask                                          (0x00000200)
+#define TMDS_OUTCTL_trcoe_mask                                        (0x00000100)
+#define TMDS_OUTCTL_tgcoe_mask                                        (0x00000080)
+#define TMDS_OUTCTL_tbcoe_mask                                        (0x00000040)
+#define TMDS_OUTCTL_ocke_mask                                         (0x00000020)
+#define TMDS_OUTCTL_ockie_mask                                        (0x00000010)
+#define TMDS_OUTCTL_dummy_3_mask                                      (0x00000008)
+#define TMDS_OUTCTL_dummy_2_mask                                      (0x00000004)
+#define TMDS_OUTCTL_dummy_1_mask                                      (0x00000002)
+#define TMDS_OUTCTL_dummy_0_mask                                      (0x00000001)
+#define TMDS_OUTCTL_trcoe_r(data)                                     (0x00002000&((data)<<13))
+#define TMDS_OUTCTL_tgcoe_r(data)                                     (0x00001000&((data)<<12))
+#define TMDS_OUTCTL_tbcoe_r(data)                                     (0x00000800&((data)<<11))
+#define TMDS_OUTCTL_ocke_r(data)                                      (0x00000400&((data)<<10))
+#define TMDS_OUTCTL_aoe(data)                                         (0x00000200&((data)<<9))
+#define TMDS_OUTCTL_trcoe(data)                                       (0x00000100&((data)<<8))
+#define TMDS_OUTCTL_tgcoe(data)                                       (0x00000080&((data)<<7))
+#define TMDS_OUTCTL_tbcoe(data)                                       (0x00000040&((data)<<6))
+#define TMDS_OUTCTL_ocke(data)                                        (0x00000020&((data)<<5))
+#define TMDS_OUTCTL_ockie(data)                                       (0x00000010&((data)<<4))
+#define TMDS_OUTCTL_dummy_3(data)                                     (0x00000008&((data)<<3))
+#define TMDS_OUTCTL_dummy_2(data)                                     (0x00000004&((data)<<2))
+#define TMDS_OUTCTL_dummy_1(data)                                     (0x00000002&((data)<<1))
+#define TMDS_OUTCTL_dummy_0(data)                                     (0x00000001&(data))
+#define TMDS_OUTCTL_get_trcoe_r(data)                                 ((0x00002000&(data))>>13)
+#define TMDS_OUTCTL_get_tgcoe_r(data)                                 ((0x00001000&(data))>>12)
+#define TMDS_OUTCTL_get_tbcoe_r(data)                                 ((0x00000800&(data))>>11)
+#define TMDS_OUTCTL_get_ocke_r(data)                                  ((0x00000400&(data))>>10)
+#define TMDS_OUTCTL_get_aoe(data)                                     ((0x00000200&(data))>>9)
+#define TMDS_OUTCTL_get_trcoe(data)                                   ((0x00000100&(data))>>8)
+#define TMDS_OUTCTL_get_tgcoe(data)                                   ((0x00000080&(data))>>7)
+#define TMDS_OUTCTL_get_tbcoe(data)                                   ((0x00000040&(data))>>6)
+#define TMDS_OUTCTL_get_ocke(data)                                    ((0x00000020&(data))>>5)
+#define TMDS_OUTCTL_get_ockie(data)                                   ((0x00000010&(data))>>4)
+#define TMDS_OUTCTL_get_dummy_3(data)                                 ((0x00000008&(data))>>3)
+#define TMDS_OUTCTL_get_dummy_2(data)                                 ((0x00000004&(data))>>2)
+#define TMDS_OUTCTL_get_dummy_1(data)                                 ((0x00000002&(data))>>1)
+#define TMDS_OUTCTL_get_dummy_0(data)                                 (0x00000001&(data))
+
+
+#define TMDS_PWDCTL                                                   0x01c
+#define TMDS_PWDCTL_reg_addr                                          "0x9803401c"
+#define TMDS_PWDCTL_reg                                               0x9803401c
+#define TMDS_PWDCTL_inst_addr                                         "0x0007"
+#define TMDS_PWDCTL_inst                                              0x0007
+#define set_TMDS_PWDCTL_reg(data)                                     (*((volatile unsigned int*)TMDS_PWDCTL_reg)=data)
+#define get_TMDS_PWDCTL_reg                                           (*((volatile unsigned int*)TMDS_PWDCTL_reg))
+#define TMDS_PWDCTL_ecc_r_shift                                       (31)
+#define TMDS_PWDCTL_erip_r_shift                                      (30)
+#define TMDS_PWDCTL_egip_r_shift                                      (29)
+#define TMDS_PWDCTL_ebip_r_shift                                      (28)
+#define TMDS_PWDCTL_dummy_27_10_shift                                 (10)
+#define TMDS_PWDCTL_video_preamble_off_en_shift                       (9)
+#define TMDS_PWDCTL_hs_width_sel_shift                                (8)
+#define TMDS_PWDCTL_deo_shift                                         (7)
+#define TMDS_PWDCTL_brcw_shift                                        (6)
+#define TMDS_PWDCTL_pnsw_shift                                        (5)
+#define TMDS_PWDCTL_iccaf_shift                                       (4)
+#define TMDS_PWDCTL_ecc_shift                                         (3)
+#define TMDS_PWDCTL_erip_shift                                        (2)
+#define TMDS_PWDCTL_egip_shift                                        (1)
+#define TMDS_PWDCTL_ebip_shift                                        (0)
+#define TMDS_PWDCTL_ecc_r_mask                                        (0x80000000)
+#define TMDS_PWDCTL_erip_r_mask                                       (0x40000000)
+#define TMDS_PWDCTL_egip_r_mask                                       (0x20000000)
+#define TMDS_PWDCTL_ebip_r_mask                                       (0x10000000)
+#define TMDS_PWDCTL_dummy_27_10_mask                                  (0x0FFFFC00)
+#define TMDS_PWDCTL_video_preamble_off_en_mask                        (0x00000200)
+#define TMDS_PWDCTL_hs_width_sel_mask                                 (0x00000100)
+#define TMDS_PWDCTL_deo_mask                                          (0x00000080)
+#define TMDS_PWDCTL_brcw_mask                                         (0x00000040)
+#define TMDS_PWDCTL_pnsw_mask                                         (0x00000020)
+#define TMDS_PWDCTL_iccaf_mask                                        (0x00000010)
+#define TMDS_PWDCTL_ecc_mask                                          (0x00000008)
+#define TMDS_PWDCTL_erip_mask                                         (0x00000004)
+#define TMDS_PWDCTL_egip_mask                                         (0x00000002)
+#define TMDS_PWDCTL_ebip_mask                                         (0x00000001)
+#define TMDS_PWDCTL_ecc_r(data)                                       (0x80000000&((data)<<31))
+#define TMDS_PWDCTL_erip_r(data)                                      (0x40000000&((data)<<30))
+#define TMDS_PWDCTL_egip_r(data)                                      (0x20000000&((data)<<29))
+#define TMDS_PWDCTL_ebip_r(data)                                      (0x10000000&((data)<<28))
+#define TMDS_PWDCTL_dummy_27_10(data)                                 (0x0FFFFC00&((data)<<10))
+#define TMDS_PWDCTL_video_preamble_off_en(data)                       (0x00000200&((data)<<9))
+#define TMDS_PWDCTL_hs_width_sel(data)                                (0x00000100&((data)<<8))
+#define TMDS_PWDCTL_deo(data)                                         (0x00000080&((data)<<7))
+#define TMDS_PWDCTL_brcw(data)                                        (0x00000040&((data)<<6))
+#define TMDS_PWDCTL_pnsw(data)                                        (0x00000020&((data)<<5))
+#define TMDS_PWDCTL_iccaf(data)                                       (0x00000010&((data)<<4))
+#define TMDS_PWDCTL_ecc(data)                                         (0x00000008&((data)<<3))
+#define TMDS_PWDCTL_erip(data)                                        (0x00000004&((data)<<2))
+#define TMDS_PWDCTL_egip(data)                                        (0x00000002&((data)<<1))
+#define TMDS_PWDCTL_ebip(data)                                        (0x00000001&(data))
+#define TMDS_PWDCTL_get_ecc_r(data)                                   ((0x80000000&(data))>>31)
+#define TMDS_PWDCTL_get_erip_r(data)                                  ((0x40000000&(data))>>30)
+#define TMDS_PWDCTL_get_egip_r(data)                                  ((0x20000000&(data))>>29)
+#define TMDS_PWDCTL_get_ebip_r(data)                                  ((0x10000000&(data))>>28)
+#define TMDS_PWDCTL_get_dummy_27_10(data)                             ((0x0FFFFC00&(data))>>10)
+#define TMDS_PWDCTL_get_video_preamble_off_en(data)                   ((0x00000200&(data))>>9)
+#define TMDS_PWDCTL_get_hs_width_sel(data)                            ((0x00000100&(data))>>8)
+#define TMDS_PWDCTL_get_deo(data)                                     ((0x00000080&(data))>>7)
+#define TMDS_PWDCTL_get_brcw(data)                                    ((0x00000040&(data))>>6)
+#define TMDS_PWDCTL_get_pnsw(data)                                    ((0x00000020&(data))>>5)
+#define TMDS_PWDCTL_get_iccaf(data)                                   ((0x00000010&(data))>>4)
+#define TMDS_PWDCTL_get_ecc(data)                                     ((0x00000008&(data))>>3)
+#define TMDS_PWDCTL_get_erip(data)                                    ((0x00000004&(data))>>2)
+#define TMDS_PWDCTL_get_egip(data)                                    ((0x00000002&(data))>>1)
+#define TMDS_PWDCTL_get_ebip(data)                                    (0x00000001&(data))
+
+
+#define TMDS_Z0CC                                                     0x020
+#define TMDS_Z0CC_reg_addr                                            "0x98034020"
+#define TMDS_Z0CC_reg                                                 0x98034020
+#define TMDS_Z0CC_inst_addr                                           "0x0008"
+#define TMDS_Z0CC_inst                                                0x0008
+#define set_TMDS_Z0CC_reg(data)                                       (*((volatile unsigned int*)TMDS_Z0CC_reg)=data)
+#define get_TMDS_Z0CC_reg                                             (*((volatile unsigned int*)TMDS_Z0CC_reg))
+#define TMDS_Z0CC_hde_shift                                           (0)
+#define TMDS_Z0CC_hde_mask                                            (0x00000001)
+#define TMDS_Z0CC_hde(data)                                           (0x00000001&(data))
+#define TMDS_Z0CC_get_hde(data)                                       (0x00000001&(data))
+
+
+#define TMDS_CPS                                                      0x024
+#define TMDS_CPS_reg_addr                                             "0x98034024"
+#define TMDS_CPS_reg                                                  0x98034024
+#define TMDS_CPS_inst_addr                                            "0x0009"
+#define TMDS_CPS_inst                                                 0x0009
+#define set_TMDS_CPS_reg(data)                                        (*((volatile unsigned int*)TMDS_CPS_reg)=data)
+#define get_TMDS_CPS_reg                                              (*((volatile unsigned int*)TMDS_CPS_reg))
+#define TMDS_CPS_pll_div2_en_shift                                    (9)
+#define TMDS_CPS_no_clk_in_shift                                      (8)
+#define TMDS_CPS_clkv_meas_sel_shift                                  (6)
+#define TMDS_CPS_de_inv_disable_shift                                 (5)
+#define TMDS_CPS_de_err_pulse_en_shift                                (4)
+#define TMDS_CPS_clr_infoframe_dvi_shift                              (3)
+#define TMDS_CPS_auto_dvi2hdmi_shift                                  (2)
+#define TMDS_CPS_dummy_1_0_shift                                      (0)
+#define TMDS_CPS_pll_div2_en_mask                                     (0x00000200)
+#define TMDS_CPS_no_clk_in_mask                                       (0x00000100)
+#define TMDS_CPS_clkv_meas_sel_mask                                   (0x000000C0)
+#define TMDS_CPS_de_inv_disable_mask                                  (0x00000020)
+#define TMDS_CPS_de_err_pulse_en_mask                                 (0x00000010)
+#define TMDS_CPS_clr_infoframe_dvi_mask                               (0x00000008)
+#define TMDS_CPS_auto_dvi2hdmi_mask                                   (0x00000004)
+#define TMDS_CPS_dummy_1_0_mask                                       (0x00000003)
+#define TMDS_CPS_pll_div2_en(data)                                    (0x00000200&((data)<<9))
+#define TMDS_CPS_no_clk_in(data)                                      (0x00000100&((data)<<8))
+#define TMDS_CPS_clkv_meas_sel(data)                                  (0x000000C0&((data)<<6))
+#define TMDS_CPS_de_inv_disable(data)                                 (0x00000020&((data)<<5))
+#define TMDS_CPS_de_err_pulse_en(data)                                (0x00000010&((data)<<4))
+#define TMDS_CPS_clr_infoframe_dvi(data)                              (0x00000008&((data)<<3))
+#define TMDS_CPS_auto_dvi2hdmi(data)                                  (0x00000004&((data)<<2))
+#define TMDS_CPS_dummy_1_0(data)                                      (0x00000003&(data))
+#define TMDS_CPS_get_pll_div2_en(data)                                ((0x00000200&(data))>>9)
+#define TMDS_CPS_get_no_clk_in(data)                                  ((0x00000100&(data))>>8)
+#define TMDS_CPS_get_clkv_meas_sel(data)                              ((0x000000C0&(data))>>6)
+#define TMDS_CPS_get_de_inv_disable(data)                             ((0x00000020&(data))>>5)
+#define TMDS_CPS_get_de_err_pulse_en(data)                            ((0x00000010&(data))>>4)
+#define TMDS_CPS_get_clr_infoframe_dvi(data)                          ((0x00000008&(data))>>3)
+#define TMDS_CPS_get_auto_dvi2hdmi(data)                              ((0x00000004&(data))>>2)
+#define TMDS_CPS_get_dummy_1_0(data)                                  (0x00000003&(data))
+
+
+#define TMDS_UDC                                                      0x028
+#define TMDS_UDC_reg_addr                                             "0x98034028"
+#define TMDS_UDC_reg                                                  0x98034028
+#define TMDS_UDC_inst_addr                                            "0x000A"
+#define TMDS_UDC_inst                                                 0x000A
+#define set_TMDS_UDC_reg(data)                                        (*((volatile unsigned int*)TMDS_UDC_reg)=data)
+#define get_TMDS_UDC_reg                                              (*((volatile unsigned int*)TMDS_UDC_reg))
+#define TMDS_UDC_debug_sel_shift                                      (4)
+#define TMDS_UDC_dummy_3_shift                                        (3)
+#define TMDS_UDC_cptest_shift                                         (2)
+#define TMDS_UDC_hmtm_shift                                           (0)
+#define TMDS_UDC_debug_sel_mask                                       (0x000003F0)
+#define TMDS_UDC_dummy_3_mask                                         (0x00000008)
+#define TMDS_UDC_cptest_mask                                          (0x00000004)
+#define TMDS_UDC_hmtm_mask                                            (0x00000003)
+#define TMDS_UDC_debug_sel(data)                                      (0x000003F0&((data)<<4))
+#define TMDS_UDC_dummy_3(data)                                        (0x00000008&((data)<<3))
+#define TMDS_UDC_cptest(data)                                         (0x00000004&((data)<<2))
+#define TMDS_UDC_hmtm(data)                                           (0x00000003&(data))
+#define TMDS_UDC_get_debug_sel(data)                                  ((0x000003F0&(data))>>4)
+#define TMDS_UDC_get_dummy_3(data)                                    ((0x00000008&(data))>>3)
+#define TMDS_UDC_get_cptest(data)                                     ((0x00000004&(data))>>2)
+#define TMDS_UDC_get_hmtm(data)                                       (0x00000003&(data))
+
+
+#define TMDS_ERRC                                                     0x02c
+#define TMDS_ERRC_reg_addr                                            "0x9803402c"
+#define TMDS_ERRC_reg                                                 0x9803402c
+#define TMDS_ERRC_inst_addr                                           "0x000B"
+#define TMDS_ERRC_inst                                                0x000B
+#define set_TMDS_ERRC_reg(data)                                       (*((volatile unsigned int*)TMDS_ERRC_reg)=data)
+#define get_TMDS_ERRC_reg                                             (*((volatile unsigned int*)TMDS_ERRC_reg))
+#define TMDS_ERRC_nl_shift                                            (0)
+#define TMDS_ERRC_nl_mask                                             (0x00000007)
+#define TMDS_ERRC_nl(data)                                            (0x00000007&(data))
+#define TMDS_ERRC_get_nl(data)                                        (0x00000007&(data))
+
+
+#define TMDS_OUT_CTRL                                                 0x030
+#define TMDS_OUT_CTRL_reg_addr                                        "0x98034030"
+#define TMDS_OUT_CTRL_reg                                             0x98034030
+#define TMDS_OUT_CTRL_inst_addr                                       "0x000C"
+#define TMDS_OUT_CTRL_inst                                            0x000C
+#define set_TMDS_OUT_CTRL_reg(data)                                   (*((volatile unsigned int*)TMDS_OUT_CTRL_reg)=data)
+#define get_TMDS_OUT_CTRL_reg                                         (*((volatile unsigned int*)TMDS_OUT_CTRL_reg))
+#define TMDS_OUT_CTRL_tmds_bypass_shift                               (7)
+#define TMDS_OUT_CTRL_dummy_6_0_shift                                 (0)
+#define TMDS_OUT_CTRL_tmds_bypass_mask                                (0x00000080)
+#define TMDS_OUT_CTRL_dummy_6_0_mask                                  (0x0000007F)
+#define TMDS_OUT_CTRL_tmds_bypass(data)                               (0x00000080&((data)<<7))
+#define TMDS_OUT_CTRL_dummy_6_0(data)                                 (0x0000007F&(data))
+#define TMDS_OUT_CTRL_get_tmds_bypass(data)                           ((0x00000080&(data))>>7)
+#define TMDS_OUT_CTRL_get_dummy_6_0(data)                             (0x0000007F&(data))
+
+
+#define TMDS_ROUT                                                     0x034
+#define TMDS_ROUT_reg_addr                                            "0x98034034"
+#define TMDS_ROUT_reg                                                 0x98034034
+#define TMDS_ROUT_inst_addr                                           "0x000D"
+#define TMDS_ROUT_inst                                                0x000D
+#define set_TMDS_ROUT_reg(data)                                       (*((volatile unsigned int*)TMDS_ROUT_reg)=data)
+#define get_TMDS_ROUT_reg                                             (*((volatile unsigned int*)TMDS_ROUT_reg))
+#define TMDS_ROUT_tmds_rout_h_shift                                   (8)
+#define TMDS_ROUT_tmds_rout_l_shift                                   (0)
+#define TMDS_ROUT_tmds_rout_h_mask                                    (0x0000FF00)
+#define TMDS_ROUT_tmds_rout_l_mask                                    (0x000000FF)
+#define TMDS_ROUT_tmds_rout_h(data)                                   (0x0000FF00&((data)<<8))
+#define TMDS_ROUT_tmds_rout_l(data)                                   (0x000000FF&(data))
+#define TMDS_ROUT_get_tmds_rout_h(data)                               ((0x0000FF00&(data))>>8)
+#define TMDS_ROUT_get_tmds_rout_l(data)                               (0x000000FF&(data))
+
+
+#define TMDS_GOUT                                                     0x038
+#define TMDS_GOUT_reg_addr                                            "0x98034038"
+#define TMDS_GOUT_reg                                                 0x98034038
+#define TMDS_GOUT_inst_addr                                           "0x000E"
+#define TMDS_GOUT_inst                                                0x000E
+#define set_TMDS_GOUT_reg(data)                                       (*((volatile unsigned int*)TMDS_GOUT_reg)=data)
+#define get_TMDS_GOUT_reg                                             (*((volatile unsigned int*)TMDS_GOUT_reg))
+#define TMDS_GOUT_tmds_gout_h_shift                                   (8)
+#define TMDS_GOUT_tmds_gout_l_shift                                   (0)
+#define TMDS_GOUT_tmds_gout_h_mask                                    (0x0000FF00)
+#define TMDS_GOUT_tmds_gout_l_mask                                    (0x000000FF)
+#define TMDS_GOUT_tmds_gout_h(data)                                   (0x0000FF00&((data)<<8))
+#define TMDS_GOUT_tmds_gout_l(data)                                   (0x000000FF&(data))
+#define TMDS_GOUT_get_tmds_gout_h(data)                               ((0x0000FF00&(data))>>8)
+#define TMDS_GOUT_get_tmds_gout_l(data)                               (0x000000FF&(data))
+
+
+#define TMDS_BOUT                                                     0x03c
+#define TMDS_BOUT_reg_addr                                            "0x9803403c"
+#define TMDS_BOUT_reg                                                 0x9803403c
+#define TMDS_BOUT_inst_addr                                           "0x000F"
+#define TMDS_BOUT_inst                                                0x000F
+#define set_TMDS_BOUT_reg(data)                                       (*((volatile unsigned int*)TMDS_BOUT_reg)=data)
+#define get_TMDS_BOUT_reg                                             (*((volatile unsigned int*)TMDS_BOUT_reg))
+#define TMDS_BOUT_tmds_bout_h_shift                                   (8)
+#define TMDS_BOUT_tmds_bout_l_shift                                   (0)
+#define TMDS_BOUT_tmds_bout_h_mask                                    (0x0000FF00)
+#define TMDS_BOUT_tmds_bout_l_mask                                    (0x000000FF)
+#define TMDS_BOUT_tmds_bout_h(data)                                   (0x0000FF00&((data)<<8))
+#define TMDS_BOUT_tmds_bout_l(data)                                   (0x000000FF&(data))
+#define TMDS_BOUT_get_tmds_bout_h(data)                               ((0x0000FF00&(data))>>8)
+#define TMDS_BOUT_get_tmds_bout_l(data)                               (0x000000FF&(data))
+
+
+#define TMDS_DPC0                                                     0x040
+#define TMDS_DPC0_reg_addr                                            "0x98034040"
+#define TMDS_DPC0_reg                                                 0x98034040
+#define TMDS_DPC0_inst_addr                                           "0x0010"
+#define TMDS_DPC0_inst                                                0x0010
+#define set_TMDS_DPC0_reg(data)                                       (*((volatile unsigned int*)TMDS_DPC0_reg)=data)
+#define get_TMDS_DPC0_reg                                             (*((volatile unsigned int*)TMDS_DPC0_reg))
+#define TMDS_DPC0_dpc_pp_valid_shift                                  (9)
+#define TMDS_DPC0_dpc_default_ph_shift                                (8)
+#define TMDS_DPC0_dpc_pp_shift                                        (4)
+#define TMDS_DPC0_dpc_cd_shift                                        (0)
+#define TMDS_DPC0_dpc_pp_valid_mask                                   (0x00000200)
+#define TMDS_DPC0_dpc_default_ph_mask                                 (0x00000100)
+#define TMDS_DPC0_dpc_pp_mask                                         (0x000000F0)
+#define TMDS_DPC0_dpc_cd_mask                                         (0x0000000F)
+#define TMDS_DPC0_dpc_pp_valid(data)                                  (0x00000200&((data)<<9))
+#define TMDS_DPC0_dpc_default_ph(data)                                (0x00000100&((data)<<8))
+#define TMDS_DPC0_dpc_pp(data)                                        (0x000000F0&((data)<<4))
+#define TMDS_DPC0_dpc_cd(data)                                        (0x0000000F&(data))
+#define TMDS_DPC0_get_dpc_pp_valid(data)                              ((0x00000200&(data))>>9)
+#define TMDS_DPC0_get_dpc_default_ph(data)                            ((0x00000100&(data))>>8)
+#define TMDS_DPC0_get_dpc_pp(data)                                    ((0x000000F0&(data))>>4)
+#define TMDS_DPC0_get_dpc_cd(data)                                    (0x0000000F&(data))
+
+
+#define TMDS_DPC1                                                     0x044
+#define TMDS_DPC1_reg_addr                                            "0x98034044"
+#define TMDS_DPC1_reg                                                 0x98034044
+#define TMDS_DPC1_inst_addr                                           "0x0011"
+#define TMDS_DPC1_inst                                                0x0011
+#define set_TMDS_DPC1_reg(data)                                       (*((volatile unsigned int*)TMDS_DPC1_reg)=data)
+#define get_TMDS_DPC1_reg                                             (*((volatile unsigned int*)TMDS_DPC1_reg))
+#define TMDS_DPC1_dpc_cd_chg_flag_shift                               (18)
+#define TMDS_DPC1_dpc_cd_chg_wd_en_shift                              (17)
+#define TMDS_DPC1_dpc_cd_chg_int_en_shift                             (16)
+#define TMDS_DPC1_dummy_15_11_shift                                   (11)
+#define TMDS_DPC1_dpc_auto_shift                                      (10)
+#define TMDS_DPC1_dpc_pp_valid_fw_shift                               (9)
+#define TMDS_DPC1_dpc_default_ph_fw_shift                             (8)
+#define TMDS_DPC1_dpc_pp_fw_shift                                     (4)
+#define TMDS_DPC1_dpc_cd_fw_shift                                     (0)
+#define TMDS_DPC1_dpc_cd_chg_flag_mask                                (0x00040000)
+#define TMDS_DPC1_dpc_cd_chg_wd_en_mask                               (0x00020000)
+#define TMDS_DPC1_dpc_cd_chg_int_en_mask                              (0x00010000)
+#define TMDS_DPC1_dummy_15_11_mask                                    (0x0000F800)
+#define TMDS_DPC1_dpc_auto_mask                                       (0x00000400)
+#define TMDS_DPC1_dpc_pp_valid_fw_mask                                (0x00000200)
+#define TMDS_DPC1_dpc_default_ph_fw_mask                              (0x00000100)
+#define TMDS_DPC1_dpc_pp_fw_mask                                      (0x000000F0)
+#define TMDS_DPC1_dpc_cd_fw_mask                                      (0x0000000F)
+#define TMDS_DPC1_dpc_cd_chg_flag(data)                               (0x00040000&((data)<<18))
+#define TMDS_DPC1_dpc_cd_chg_wd_en(data)                              (0x00020000&((data)<<17))
+#define TMDS_DPC1_dpc_cd_chg_int_en(data)                             (0x00010000&((data)<<16))
+#define TMDS_DPC1_dummy_15_11(data)                                   (0x0000F800&((data)<<11))
+#define TMDS_DPC1_dpc_auto(data)                                      (0x00000400&((data)<<10))
+#define TMDS_DPC1_dpc_pp_valid_fw(data)                               (0x00000200&((data)<<9))
+#define TMDS_DPC1_dpc_default_ph_fw(data)                             (0x00000100&((data)<<8))
+#define TMDS_DPC1_dpc_pp_fw(data)                                     (0x000000F0&((data)<<4))
+#define TMDS_DPC1_dpc_cd_fw(data)                                     (0x0000000F&(data))
+#define TMDS_DPC1_get_dpc_cd_chg_flag(data)                           ((0x00040000&(data))>>18)
+#define TMDS_DPC1_get_dpc_cd_chg_wd_en(data)                          ((0x00020000&(data))>>17)
+#define TMDS_DPC1_get_dpc_cd_chg_int_en(data)                         ((0x00010000&(data))>>16)
+#define TMDS_DPC1_get_dummy_15_11(data)                               ((0x0000F800&(data))>>11)
+#define TMDS_DPC1_get_dpc_auto(data)                                  ((0x00000400&(data))>>10)
+#define TMDS_DPC1_get_dpc_pp_valid_fw(data)                           ((0x00000200&(data))>>9)
+#define TMDS_DPC1_get_dpc_default_ph_fw(data)                         ((0x00000100&(data))>>8)
+#define TMDS_DPC1_get_dpc_pp_fw(data)                                 ((0x000000F0&(data))>>4)
+#define TMDS_DPC1_get_dpc_cd_fw(data)                                 (0x0000000F&(data))
+
+
+#define TMDS_DPC_SET0                                                 0x048
+#define TMDS_DPC_SET0_reg_addr                                        "0x98034048"
+#define TMDS_DPC_SET0_reg                                             0x98034048
+#define TMDS_DPC_SET0_inst_addr                                       "0x0012"
+#define TMDS_DPC_SET0_inst                                            0x0012
+#define set_TMDS_DPC_SET0_reg(data)                                   (*((volatile unsigned int*)TMDS_DPC_SET0_reg)=data)
+#define get_TMDS_DPC_SET0_reg                                         (*((volatile unsigned int*)TMDS_DPC_SET0_reg))
+#define TMDS_DPC_SET0_dpc_bypass_dis_shift                            (8)
+#define TMDS_DPC_SET0_dpc_en_shift                                    (7)
+#define TMDS_DPC_SET0_phase_errcnt_in_shift                           (4)
+#define TMDS_DPC_SET0_phase_clrcnt_in_shift                           (1)
+#define TMDS_DPC_SET0_phase_clr_sel_shift                             (0)
+#define TMDS_DPC_SET0_dpc_bypass_dis_mask                             (0x00000100)
+#define TMDS_DPC_SET0_dpc_en_mask                                     (0x00000080)
+#define TMDS_DPC_SET0_phase_errcnt_in_mask                            (0x00000070)
+#define TMDS_DPC_SET0_phase_clrcnt_in_mask                            (0x0000000E)
+#define TMDS_DPC_SET0_phase_clr_sel_mask                              (0x00000001)
+#define TMDS_DPC_SET0_dpc_bypass_dis(data)                            (0x00000100&((data)<<8))
+#define TMDS_DPC_SET0_dpc_en(data)                                    (0x00000080&((data)<<7))
+#define TMDS_DPC_SET0_phase_errcnt_in(data)                           (0x00000070&((data)<<4))
+#define TMDS_DPC_SET0_phase_clrcnt_in(data)                           (0x0000000E&((data)<<1))
+#define TMDS_DPC_SET0_phase_clr_sel(data)                             (0x00000001&(data))
+#define TMDS_DPC_SET0_get_dpc_bypass_dis(data)                        ((0x00000100&(data))>>8)
+#define TMDS_DPC_SET0_get_dpc_en(data)                                ((0x00000080&(data))>>7)
+#define TMDS_DPC_SET0_get_phase_errcnt_in(data)                       ((0x00000070&(data))>>4)
+#define TMDS_DPC_SET0_get_phase_clrcnt_in(data)                       ((0x0000000E&(data))>>1)
+#define TMDS_DPC_SET0_get_phase_clr_sel(data)                         (0x00000001&(data))
+
+
+#define TMDS_DPC_SET1                                                 0x04c
+#define TMDS_DPC_SET1_reg_addr                                        "0x9803404c"
+#define TMDS_DPC_SET1_reg                                             0x9803404c
+#define TMDS_DPC_SET1_inst_addr                                       "0x0013"
+#define TMDS_DPC_SET1_inst                                            0x0013
+#define set_TMDS_DPC_SET1_reg(data)                                   (*((volatile unsigned int*)TMDS_DPC_SET1_reg)=data)
+#define get_TMDS_DPC_SET1_reg                                         (*((volatile unsigned int*)TMDS_DPC_SET1_reg))
+#define TMDS_DPC_SET1_set_full_noti_shift                             (4)
+#define TMDS_DPC_SET1_set_empty_noti_shift                            (0)
+#define TMDS_DPC_SET1_set_full_noti_mask                              (0x000000F0)
+#define TMDS_DPC_SET1_set_empty_noti_mask                             (0x0000000F)
+#define TMDS_DPC_SET1_set_full_noti(data)                             (0x000000F0&((data)<<4))
+#define TMDS_DPC_SET1_set_empty_noti(data)                            (0x0000000F&(data))
+#define TMDS_DPC_SET1_get_set_full_noti(data)                         ((0x000000F0&(data))>>4)
+#define TMDS_DPC_SET1_get_set_empty_noti(data)                        (0x0000000F&(data))
+
+
+#define TMDS_DPC_SET2                                                 0x050
+#define TMDS_DPC_SET2_reg_addr                                        "0x98034050"
+#define TMDS_DPC_SET2_reg                                             0x98034050
+#define TMDS_DPC_SET2_inst_addr                                       "0x0014"
+#define TMDS_DPC_SET2_inst                                            0x0014
+#define set_TMDS_DPC_SET2_reg(data)                                   (*((volatile unsigned int*)TMDS_DPC_SET2_reg)=data)
+#define get_TMDS_DPC_SET2_reg                                         (*((volatile unsigned int*)TMDS_DPC_SET2_reg))
+#define TMDS_DPC_SET2_fifo_errcnt_in_shift                            (5)
+#define TMDS_DPC_SET2_clr_phase_flag_shift                            (4)
+#define TMDS_DPC_SET2_clr_fifo_flag_shift                             (3)
+#define TMDS_DPC_SET2_dpc_phase_ok_shift                              (2)
+#define TMDS_DPC_SET2_dpc_phase_err_flag_shift                        (1)
+#define TMDS_DPC_SET2_dpc_fifo_err_flag_shift                         (0)
+#define TMDS_DPC_SET2_fifo_errcnt_in_mask                             (0x000000E0)
+#define TMDS_DPC_SET2_clr_phase_flag_mask                             (0x00000010)
+#define TMDS_DPC_SET2_clr_fifo_flag_mask                              (0x00000008)
+#define TMDS_DPC_SET2_dpc_phase_ok_mask                               (0x00000004)
+#define TMDS_DPC_SET2_dpc_phase_err_flag_mask                         (0x00000002)
+#define TMDS_DPC_SET2_dpc_fifo_err_flag_mask                          (0x00000001)
+#define TMDS_DPC_SET2_fifo_errcnt_in(data)                            (0x000000E0&((data)<<5))
+#define TMDS_DPC_SET2_clr_phase_flag(data)                            (0x00000010&((data)<<4))
+#define TMDS_DPC_SET2_clr_fifo_flag(data)                             (0x00000008&((data)<<3))
+#define TMDS_DPC_SET2_dpc_phase_ok(data)                              (0x00000004&((data)<<2))
+#define TMDS_DPC_SET2_dpc_phase_err_flag(data)                        (0x00000002&((data)<<1))
+#define TMDS_DPC_SET2_dpc_fifo_err_flag(data)                         (0x00000001&(data))
+#define TMDS_DPC_SET2_get_fifo_errcnt_in(data)                        ((0x000000E0&(data))>>5)
+#define TMDS_DPC_SET2_get_clr_phase_flag(data)                        ((0x00000010&(data))>>4)
+#define TMDS_DPC_SET2_get_clr_fifo_flag(data)                         ((0x00000008&(data))>>3)
+#define TMDS_DPC_SET2_get_dpc_phase_ok(data)                          ((0x00000004&(data))>>2)
+#define TMDS_DPC_SET2_get_dpc_phase_err_flag(data)                    ((0x00000002&(data))>>1)
+#define TMDS_DPC_SET2_get_dpc_fifo_err_flag(data)                     (0x00000001&(data))
+
+
+#define TMDS_DPC_SET3                                                 0x054
+#define TMDS_DPC_SET3_reg_addr                                        "0x98034054"
+#define TMDS_DPC_SET3_reg                                             0x98034054
+#define TMDS_DPC_SET3_inst_addr                                       "0x0015"
+#define TMDS_DPC_SET3_inst                                            0x0015
+#define set_TMDS_DPC_SET3_reg(data)                                   (*((volatile unsigned int*)TMDS_DPC_SET3_reg)=data)
+#define get_TMDS_DPC_SET3_reg                                         (*((volatile unsigned int*)TMDS_DPC_SET3_reg))
+#define TMDS_DPC_SET3_dpc_fifo_over_flag_shift                        (7)
+#define TMDS_DPC_SET3_dpc_fifo_under_flag_shift                       (6)
+#define TMDS_DPC_SET3_dpc_fifo_over_xflag_shift                       (5)
+#define TMDS_DPC_SET3_dpc_fifo_under_xflag_shift                      (4)
+#define TMDS_DPC_SET3_dpc_fifo_over_flag_mask                         (0x00000080)
+#define TMDS_DPC_SET3_dpc_fifo_under_flag_mask                        (0x00000040)
+#define TMDS_DPC_SET3_dpc_fifo_over_xflag_mask                        (0x00000020)
+#define TMDS_DPC_SET3_dpc_fifo_under_xflag_mask                       (0x00000010)
+#define TMDS_DPC_SET3_dpc_fifo_over_flag(data)                        (0x00000080&((data)<<7))
+#define TMDS_DPC_SET3_dpc_fifo_under_flag(data)                       (0x00000040&((data)<<6))
+#define TMDS_DPC_SET3_dpc_fifo_over_xflag(data)                       (0x00000020&((data)<<5))
+#define TMDS_DPC_SET3_dpc_fifo_under_xflag(data)                      (0x00000010&((data)<<4))
+#define TMDS_DPC_SET3_get_dpc_fifo_over_flag(data)                    ((0x00000080&(data))>>7)
+#define TMDS_DPC_SET3_get_dpc_fifo_under_flag(data)                   ((0x00000040&(data))>>6)
+#define TMDS_DPC_SET3_get_dpc_fifo_over_xflag(data)                   ((0x00000020&(data))>>5)
+#define TMDS_DPC_SET3_get_dpc_fifo_under_xflag(data)                  ((0x00000010&(data))>>4)
+
+
+#define TMDS_DET_CTL                                                  0x058
+#define TMDS_DET_CTL_reg_addr                                         "0x98034058"
+#define TMDS_DET_CTL_reg                                              0x98034058
+#define TMDS_DET_CTL_inst_addr                                        "0x0016"
+#define TMDS_DET_CTL_inst                                             0x0016
+#define set_TMDS_DET_CTL_reg(data)                                    (*((volatile unsigned int*)TMDS_DET_CTL_reg)=data)
+#define get_TMDS_DET_CTL_reg                                          (*((volatile unsigned int*)TMDS_DET_CTL_reg))
+#define TMDS_DET_CTL_de_sel_shift                                     (28)
+#define TMDS_DET_CTL_tran_err_thrd_shift                              (24)
+#define TMDS_DET_CTL_neg_de_err_thrd_shift                            (20)
+#define TMDS_DET_CTL_pos_de_err_thrd_shift                            (16)
+#define TMDS_DET_CTL_dummy_15_shift                                   (15)
+#define TMDS_DET_CTL_neg_de_lowbd_shift                               (8)
+#define TMDS_DET_CTL_dummy_7_6_shift                                  (6)
+#define TMDS_DET_CTL_pos_de_lowbd_shift                               (0)
+#define TMDS_DET_CTL_de_sel_mask                                      (0x10000000)
+#define TMDS_DET_CTL_tran_err_thrd_mask                               (0x0F000000)
+#define TMDS_DET_CTL_neg_de_err_thrd_mask                             (0x00F00000)
+#define TMDS_DET_CTL_pos_de_err_thrd_mask                             (0x000F0000)
+#define TMDS_DET_CTL_dummy_15_mask                                    (0x00008000)
+#define TMDS_DET_CTL_neg_de_lowbd_mask                                (0x00007F00)
+#define TMDS_DET_CTL_dummy_7_6_mask                                   (0x000000C0)
+#define TMDS_DET_CTL_pos_de_lowbd_mask                                (0x0000003F)
+#define TMDS_DET_CTL_de_sel(data)                                     (0x10000000&((data)<<28))
+#define TMDS_DET_CTL_tran_err_thrd(data)                              (0x0F000000&((data)<<24))
+#define TMDS_DET_CTL_neg_de_err_thrd(data)                            (0x00F00000&((data)<<20))
+#define TMDS_DET_CTL_pos_de_err_thrd(data)                            (0x000F0000&((data)<<16))
+#define TMDS_DET_CTL_dummy_15(data)                                   (0x00008000&((data)<<15))
+#define TMDS_DET_CTL_neg_de_lowbd(data)                               (0x00007F00&((data)<<8))
+#define TMDS_DET_CTL_dummy_7_6(data)                                  (0x000000C0&((data)<<6))
+#define TMDS_DET_CTL_pos_de_lowbd(data)                               (0x0000003F&(data))
+#define TMDS_DET_CTL_get_de_sel(data)                                 ((0x10000000&(data))>>28)
+#define TMDS_DET_CTL_get_tran_err_thrd(data)                          ((0x0F000000&(data))>>24)
+#define TMDS_DET_CTL_get_neg_de_err_thrd(data)                        ((0x00F00000&(data))>>20)
+#define TMDS_DET_CTL_get_pos_de_err_thrd(data)                        ((0x000F0000&(data))>>16)
+#define TMDS_DET_CTL_get_dummy_15(data)                               ((0x00008000&(data))>>15)
+#define TMDS_DET_CTL_get_neg_de_lowbd(data)                           ((0x00007F00&(data))>>8)
+#define TMDS_DET_CTL_get_dummy_7_6(data)                              ((0x000000C0&(data))>>6)
+#define TMDS_DET_CTL_get_pos_de_lowbd(data)                           (0x0000003F&(data))
+
+
+#define TMDS_DET_STS                                                  0x05c
+#define TMDS_DET_STS_reg_addr                                         "0x9803405c"
+#define TMDS_DET_STS_reg                                              0x9803405c
+#define TMDS_DET_STS_inst_addr                                        "0x0017"
+#define TMDS_DET_STS_inst                                             0x0017
+#define set_TMDS_DET_STS_reg(data)                                    (*((volatile unsigned int*)TMDS_DET_STS_reg)=data)
+#define get_TMDS_DET_STS_reg                                          (*((volatile unsigned int*)TMDS_DET_STS_reg))
+#define TMDS_DET_STS_red_tran_err_flag_shift                          (8)
+#define TMDS_DET_STS_grn_tran_err_flag_shift                          (7)
+#define TMDS_DET_STS_blu_tran_err_flag_shift                          (6)
+#define TMDS_DET_STS_red_pos_de_err_flag_shift                        (5)
+#define TMDS_DET_STS_grn_pos_de_err_flag_shift                        (4)
+#define TMDS_DET_STS_blu_pos_de_err_flag_shift                        (3)
+#define TMDS_DET_STS_red_neg_de_err_flag_shift                        (2)
+#define TMDS_DET_STS_grn_neg_de_err_flag_shift                        (1)
+#define TMDS_DET_STS_blu_neg_de_err_flag_shift                        (0)
+#define TMDS_DET_STS_red_tran_err_flag_mask                           (0x00000100)
+#define TMDS_DET_STS_grn_tran_err_flag_mask                           (0x00000080)
+#define TMDS_DET_STS_blu_tran_err_flag_mask                           (0x00000040)
+#define TMDS_DET_STS_red_pos_de_err_flag_mask                         (0x00000020)
+#define TMDS_DET_STS_grn_pos_de_err_flag_mask                         (0x00000010)
+#define TMDS_DET_STS_blu_pos_de_err_flag_mask                         (0x00000008)
+#define TMDS_DET_STS_red_neg_de_err_flag_mask                         (0x00000004)
+#define TMDS_DET_STS_grn_neg_de_err_flag_mask                         (0x00000002)
+#define TMDS_DET_STS_blu_neg_de_err_flag_mask                         (0x00000001)
+#define TMDS_DET_STS_red_tran_err_flag(data)                          (0x00000100&((data)<<8))
+#define TMDS_DET_STS_grn_tran_err_flag(data)                          (0x00000080&((data)<<7))
+#define TMDS_DET_STS_blu_tran_err_flag(data)                          (0x00000040&((data)<<6))
+#define TMDS_DET_STS_red_pos_de_err_flag(data)                        (0x00000020&((data)<<5))
+#define TMDS_DET_STS_grn_pos_de_err_flag(data)                        (0x00000010&((data)<<4))
+#define TMDS_DET_STS_blu_pos_de_err_flag(data)                        (0x00000008&((data)<<3))
+#define TMDS_DET_STS_red_neg_de_err_flag(data)                        (0x00000004&((data)<<2))
+#define TMDS_DET_STS_grn_neg_de_err_flag(data)                        (0x00000002&((data)<<1))
+#define TMDS_DET_STS_blu_neg_de_err_flag(data)                        (0x00000001&(data))
+#define TMDS_DET_STS_get_red_tran_err_flag(data)                      ((0x00000100&(data))>>8)
+#define TMDS_DET_STS_get_grn_tran_err_flag(data)                      ((0x00000080&(data))>>7)
+#define TMDS_DET_STS_get_blu_tran_err_flag(data)                      ((0x00000040&(data))>>6)
+#define TMDS_DET_STS_get_red_pos_de_err_flag(data)                    ((0x00000020&(data))>>5)
+#define TMDS_DET_STS_get_grn_pos_de_err_flag(data)                    ((0x00000010&(data))>>4)
+#define TMDS_DET_STS_get_blu_pos_de_err_flag(data)                    ((0x00000008&(data))>>3)
+#define TMDS_DET_STS_get_red_neg_de_err_flag(data)                    ((0x00000004&(data))>>2)
+#define TMDS_DET_STS_get_grn_neg_de_err_flag(data)                    ((0x00000002&(data))>>1)
+#define TMDS_DET_STS_get_blu_neg_de_err_flag(data)                    (0x00000001&(data))
+
+
+#define VIDEO_BIT_ERR_DET                                             0x060
+#define VIDEO_BIT_ERR_DET_reg_addr                                    "0x98034060"
+#define VIDEO_BIT_ERR_DET_reg                                         0x98034060
+#define VIDEO_BIT_ERR_DET_inst_addr                                   "0x0018"
+#define VIDEO_BIT_ERR_DET_inst                                        0x0018
+#define set_VIDEO_BIT_ERR_DET_reg(data)                               (*((volatile unsigned int*)VIDEO_BIT_ERR_DET_reg)=data)
+#define get_VIDEO_BIT_ERR_DET_reg                                     (*((volatile unsigned int*)VIDEO_BIT_ERR_DET_reg))
+#define VIDEO_BIT_ERR_DET_thd_shift                                   (16)
+#define VIDEO_BIT_ERR_DET_disparity_reset_mode_shift                  (12)
+#define VIDEO_BIT_ERR_DET_irq_en_shift                                (11)
+#define VIDEO_BIT_ERR_DET_reset_shift                                 (10)
+#define VIDEO_BIT_ERR_DET_period_shift                                (4)
+#define VIDEO_BIT_ERR_DET_ch_sel_shift                                (2)
+#define VIDEO_BIT_ERR_DET_mode_shift                                  (1)
+#define VIDEO_BIT_ERR_DET_en_shift                                    (0)
+#define VIDEO_BIT_ERR_DET_thd_mask                                    (0xFFFF0000)
+#define VIDEO_BIT_ERR_DET_disparity_reset_mode_mask                   (0x00001000)
+#define VIDEO_BIT_ERR_DET_irq_en_mask                                 (0x00000800)
+#define VIDEO_BIT_ERR_DET_reset_mask                                  (0x00000400)
+#define VIDEO_BIT_ERR_DET_period_mask                                 (0x000003F0)
+#define VIDEO_BIT_ERR_DET_ch_sel_mask                                 (0x0000000C)
+#define VIDEO_BIT_ERR_DET_mode_mask                                   (0x00000002)
+#define VIDEO_BIT_ERR_DET_en_mask                                     (0x00000001)
+#define VIDEO_BIT_ERR_DET_thd(data)                                   (0xFFFF0000&((data)<<16))
+#define VIDEO_BIT_ERR_DET_disparity_reset_mode(data)                  (0x00001000&((data)<<12))
+#define VIDEO_BIT_ERR_DET_irq_en(data)                                (0x00000800&((data)<<11))
+#define VIDEO_BIT_ERR_DET_reset(data)                                 (0x00000400&((data)<<10))
+#define VIDEO_BIT_ERR_DET_period(data)                                (0x000003F0&((data)<<4))
+#define VIDEO_BIT_ERR_DET_ch_sel(data)                                (0x0000000C&((data)<<2))
+#define VIDEO_BIT_ERR_DET_mode(data)                                  (0x00000002&((data)<<1))
+#define VIDEO_BIT_ERR_DET_en(data)                                    (0x00000001&(data))
+#define VIDEO_BIT_ERR_DET_get_thd(data)                               ((0xFFFF0000&(data))>>16)
+#define VIDEO_BIT_ERR_DET_get_disparity_reset_mode(data)              ((0x00001000&(data))>>12)
+#define VIDEO_BIT_ERR_DET_get_irq_en(data)                            ((0x00000800&(data))>>11)
+#define VIDEO_BIT_ERR_DET_get_reset(data)                             ((0x00000400&(data))>>10)
+#define VIDEO_BIT_ERR_DET_get_period(data)                            ((0x000003F0&(data))>>4)
+#define VIDEO_BIT_ERR_DET_get_ch_sel(data)                            ((0x0000000C&(data))>>2)
+#define VIDEO_BIT_ERR_DET_get_mode(data)                              ((0x00000002&(data))>>1)
+#define VIDEO_BIT_ERR_DET_get_en(data)                                (0x00000001&(data))
+
+
+#define VIDEO_BIT_ERR_STATUS_B                                        0x064
+#define VIDEO_BIT_ERR_STATUS_B_reg_addr                               "0x98034064"
+#define VIDEO_BIT_ERR_STATUS_B_reg                                    0x98034064
+#define VIDEO_BIT_ERR_STATUS_B_inst_addr                              "0x0019"
+#define VIDEO_BIT_ERR_STATUS_B_inst                                   0x0019
+#define set_VIDEO_BIT_ERR_STATUS_B_reg(data)                          (*((volatile unsigned int*)VIDEO_BIT_ERR_STATUS_B_reg)=data)
+#define get_VIDEO_BIT_ERR_STATUS_B_reg                                (*((volatile unsigned int*)VIDEO_BIT_ERR_STATUS_B_reg))
+#define VIDEO_BIT_ERR_STATUS_B_ad_max_b_shift                         (26)
+#define VIDEO_BIT_ERR_STATUS_B_ad_min_b_shift                         (20)
+#define VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_shift                   (19)
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_shift                    (18)
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_b_shift                        (17)
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_shift                 (16)
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_b_shift                    (0)
+#define VIDEO_BIT_ERR_STATUS_B_ad_max_b_mask                          (0xFC000000)
+#define VIDEO_BIT_ERR_STATUS_B_ad_min_b_mask                          (0x03F00000)
+#define VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask                    (0x00080000)
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask                     (0x00040000)
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask                         (0x00020000)
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask                  (0x00010000)
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_b_mask                     (0x0000FFFF)
+#define VIDEO_BIT_ERR_STATUS_B_ad_max_b(data)                         (0xFC000000&((data)<<26))
+#define VIDEO_BIT_ERR_STATUS_B_ad_min_b(data)                         (0x03F00000&((data)<<20))
+#define VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b(data)                   (0x00080000&((data)<<19))
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b(data)                    (0x00040000&((data)<<18))
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_b(data)                        (0x00020000&((data)<<17))
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b(data)                 (0x00010000&((data)<<16))
+#define VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_b(data)                    (0x0000FFFF&(data))
+#define VIDEO_BIT_ERR_STATUS_B_get_ad_max_b(data)                     ((0xFC000000&(data))>>26)
+#define VIDEO_BIT_ERR_STATUS_B_get_ad_min_b(data)                     ((0x03F00000&(data))>>20)
+#define VIDEO_BIT_ERR_STATUS_B_get_no_dis_reset_b(data)               ((0x00080000&(data))>>19)
+#define VIDEO_BIT_ERR_STATUS_B_get_bit_err_thd_b(data)                ((0x00040000&(data))>>18)
+#define VIDEO_BIT_ERR_STATUS_B_get_bit_err_b(data)                    ((0x00020000&(data))>>17)
+#define VIDEO_BIT_ERR_STATUS_B_get_bit_err_cnt_of_b(data)             ((0x00010000&(data))>>16)
+#define VIDEO_BIT_ERR_STATUS_B_get_bit_err_cnt_b(data)                (0x0000FFFF&(data))
+
+
+#define VIDEO_BIT_ERR_STATUS_G                                        0x068
+#define VIDEO_BIT_ERR_STATUS_G_reg_addr                               "0x98034068"
+#define VIDEO_BIT_ERR_STATUS_G_reg                                    0x98034068
+#define VIDEO_BIT_ERR_STATUS_G_inst_addr                              "0x001A"
+#define VIDEO_BIT_ERR_STATUS_G_inst                                   0x001A
+#define set_VIDEO_BIT_ERR_STATUS_G_reg(data)                          (*((volatile unsigned int*)VIDEO_BIT_ERR_STATUS_G_reg)=data)
+#define get_VIDEO_BIT_ERR_STATUS_G_reg                                (*((volatile unsigned int*)VIDEO_BIT_ERR_STATUS_G_reg))
+#define VIDEO_BIT_ERR_STATUS_G_ad_max_g_shift                         (26)
+#define VIDEO_BIT_ERR_STATUS_G_ad_min_g_shift                         (20)
+#define VIDEO_BIT_ERR_STATUS_G_no_dis_reset_g_shift                   (19)
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_thd_g_shift                    (18)
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_g_shift                        (17)
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_of_g_shift                 (16)
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_g_shift                    (0)
+#define VIDEO_BIT_ERR_STATUS_G_ad_max_g_mask                          (0xFC000000)
+#define VIDEO_BIT_ERR_STATUS_G_ad_min_g_mask                          (0x03F00000)
+#define VIDEO_BIT_ERR_STATUS_G_no_dis_reset_g_mask                    (0x00080000)
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_thd_g_mask                     (0x00040000)
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_g_mask                         (0x00020000)
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_of_g_mask                  (0x00010000)
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_g_mask                     (0x0000FFFF)
+#define VIDEO_BIT_ERR_STATUS_G_ad_max_g(data)                         (0xFC000000&((data)<<26))
+#define VIDEO_BIT_ERR_STATUS_G_ad_min_g(data)                         (0x03F00000&((data)<<20))
+#define VIDEO_BIT_ERR_STATUS_G_no_dis_reset_g(data)                   (0x00080000&((data)<<19))
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_thd_g(data)                    (0x00040000&((data)<<18))
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_g(data)                        (0x00020000&((data)<<17))
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_of_g(data)                 (0x00010000&((data)<<16))
+#define VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_g(data)                    (0x0000FFFF&(data))
+#define VIDEO_BIT_ERR_STATUS_G_get_ad_max_g(data)                     ((0xFC000000&(data))>>26)
+#define VIDEO_BIT_ERR_STATUS_G_get_ad_min_g(data)                     ((0x03F00000&(data))>>20)
+#define VIDEO_BIT_ERR_STATUS_G_get_no_dis_reset_g(data)               ((0x00080000&(data))>>19)
+#define VIDEO_BIT_ERR_STATUS_G_get_bit_err_thd_g(data)                ((0x00040000&(data))>>18)
+#define VIDEO_BIT_ERR_STATUS_G_get_bit_err_g(data)                    ((0x00020000&(data))>>17)
+#define VIDEO_BIT_ERR_STATUS_G_get_bit_err_cnt_of_g(data)             ((0x00010000&(data))>>16)
+#define VIDEO_BIT_ERR_STATUS_G_get_bit_err_cnt_g(data)                (0x0000FFFF&(data))
+
+
+#define VIDEO_BIT_ERR_STATUS_R                                        0x06c
+#define VIDEO_BIT_ERR_STATUS_R_reg_addr                               "0x9803406c"
+#define VIDEO_BIT_ERR_STATUS_R_reg                                    0x9803406c
+#define VIDEO_BIT_ERR_STATUS_R_inst_addr                              "0x001B"
+#define VIDEO_BIT_ERR_STATUS_R_inst                                   0x001B
+#define set_VIDEO_BIT_ERR_STATUS_R_reg(data)                          (*((volatile unsigned int*)VIDEO_BIT_ERR_STATUS_R_reg)=data)
+#define get_VIDEO_BIT_ERR_STATUS_R_reg                                (*((volatile unsigned int*)VIDEO_BIT_ERR_STATUS_R_reg))
+#define VIDEO_BIT_ERR_STATUS_R_ad_max_r_shift                         (26)
+#define VIDEO_BIT_ERR_STATUS_R_ad_min_r_shift                         (20)
+#define VIDEO_BIT_ERR_STATUS_R_no_dis_reset_r_shift                   (19)
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_thd_r_shift                    (18)
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_r_shift                        (17)
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_of_r_shift                 (16)
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_r_shift                    (0)
+#define VIDEO_BIT_ERR_STATUS_R_ad_max_r_mask                          (0xFC000000)
+#define VIDEO_BIT_ERR_STATUS_R_ad_min_r_mask                          (0x03F00000)
+#define VIDEO_BIT_ERR_STATUS_R_no_dis_reset_r_mask                    (0x00080000)
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_thd_r_mask                     (0x00040000)
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_r_mask                         (0x00020000)
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_of_r_mask                  (0x00010000)
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_r_mask                     (0x0000FFFF)
+#define VIDEO_BIT_ERR_STATUS_R_ad_max_r(data)                         (0xFC000000&((data)<<26))
+#define VIDEO_BIT_ERR_STATUS_R_ad_min_r(data)                         (0x03F00000&((data)<<20))
+#define VIDEO_BIT_ERR_STATUS_R_no_dis_reset_r(data)                   (0x00080000&((data)<<19))
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_thd_r(data)                    (0x00040000&((data)<<18))
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_r(data)                        (0x00020000&((data)<<17))
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_of_r(data)                 (0x00010000&((data)<<16))
+#define VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_r(data)                    (0x0000FFFF&(data))
+#define VIDEO_BIT_ERR_STATUS_R_get_ad_max_r(data)                     ((0xFC000000&(data))>>26)
+#define VIDEO_BIT_ERR_STATUS_R_get_ad_min_r(data)                     ((0x03F00000&(data))>>20)
+#define VIDEO_BIT_ERR_STATUS_R_get_no_dis_reset_r(data)               ((0x00080000&(data))>>19)
+#define VIDEO_BIT_ERR_STATUS_R_get_bit_err_thd_r(data)                ((0x00040000&(data))>>18)
+#define VIDEO_BIT_ERR_STATUS_R_get_bit_err_r(data)                    ((0x00020000&(data))>>17)
+#define VIDEO_BIT_ERR_STATUS_R_get_bit_err_cnt_of_r(data)             ((0x00010000&(data))>>16)
+#define VIDEO_BIT_ERR_STATUS_R_get_bit_err_cnt_r(data)                (0x0000FFFF&(data))
+
+
+#define TERC4_ERR_DET                                                 0x070
+#define TERC4_ERR_DET_reg_addr                                        "0x98034070"
+#define TERC4_ERR_DET_reg                                             0x98034070
+#define TERC4_ERR_DET_inst_addr                                       "0x001C"
+#define TERC4_ERR_DET_inst                                            0x001C
+#define set_TERC4_ERR_DET_reg(data)                                   (*((volatile unsigned int*)TERC4_ERR_DET_reg)=data)
+#define get_TERC4_ERR_DET_reg                                         (*((volatile unsigned int*)TERC4_ERR_DET_reg))
+#define TERC4_ERR_DET_terc4_thd_shift                                 (0)
+#define TERC4_ERR_DET_terc4_thd_mask                                  (0x0000FFFF)
+#define TERC4_ERR_DET_terc4_thd(data)                                 (0x0000FFFF&(data))
+#define TERC4_ERR_DET_get_terc4_thd(data)                             (0x0000FFFF&(data))
+
+
+#define TERC4_ERR_STATUS_B                                            0x074
+#define TERC4_ERR_STATUS_B_reg_addr                                   "0x98034074"
+#define TERC4_ERR_STATUS_B_reg                                        0x98034074
+#define TERC4_ERR_STATUS_B_inst_addr                                  "0x001D"
+#define TERC4_ERR_STATUS_B_inst                                       0x001D
+#define set_TERC4_ERR_STATUS_B_reg(data)                              (*((volatile unsigned int*)TERC4_ERR_STATUS_B_reg)=data)
+#define get_TERC4_ERR_STATUS_B_reg                                    (*((volatile unsigned int*)TERC4_ERR_STATUS_B_reg))
+#define TERC4_ERR_STATUS_B_terc4_err_thd_b_shift                      (18)
+#define TERC4_ERR_STATUS_B_terc4_err_b_shift                          (17)
+#define TERC4_ERR_STATUS_B_terc4_err_cnt_of_b_shift                   (16)
+#define TERC4_ERR_STATUS_B_terc4_err_cnt_b_shift                      (0)
+#define TERC4_ERR_STATUS_B_terc4_err_thd_b_mask                       (0x00040000)
+#define TERC4_ERR_STATUS_B_terc4_err_b_mask                           (0x00020000)
+#define TERC4_ERR_STATUS_B_terc4_err_cnt_of_b_mask                    (0x00010000)
+#define TERC4_ERR_STATUS_B_terc4_err_cnt_b_mask                       (0x0000FFFF)
+#define TERC4_ERR_STATUS_B_terc4_err_thd_b(data)                      (0x00040000&((data)<<18))
+#define TERC4_ERR_STATUS_B_terc4_err_b(data)                          (0x00020000&((data)<<17))
+#define TERC4_ERR_STATUS_B_terc4_err_cnt_of_b(data)                   (0x00010000&((data)<<16))
+#define TERC4_ERR_STATUS_B_terc4_err_cnt_b(data)                      (0x0000FFFF&(data))
+#define TERC4_ERR_STATUS_B_get_terc4_err_thd_b(data)                  ((0x00040000&(data))>>18)
+#define TERC4_ERR_STATUS_B_get_terc4_err_b(data)                      ((0x00020000&(data))>>17)
+#define TERC4_ERR_STATUS_B_get_terc4_err_cnt_of_b(data)               ((0x00010000&(data))>>16)
+#define TERC4_ERR_STATUS_B_get_terc4_err_cnt_b(data)                  (0x0000FFFF&(data))
+
+
+#define TERC4_ERR_STATUS_G                                            0x078
+#define TERC4_ERR_STATUS_G_reg_addr                                   "0x98034078"
+#define TERC4_ERR_STATUS_G_reg                                        0x98034078
+#define TERC4_ERR_STATUS_G_inst_addr                                  "0x001E"
+#define TERC4_ERR_STATUS_G_inst                                       0x001E
+#define set_TERC4_ERR_STATUS_G_reg(data)                              (*((volatile unsigned int*)TERC4_ERR_STATUS_G_reg)=data)
+#define get_TERC4_ERR_STATUS_G_reg                                    (*((volatile unsigned int*)TERC4_ERR_STATUS_G_reg))
+#define TERC4_ERR_STATUS_G_terc4_err_thd_g_shift                      (18)
+#define TERC4_ERR_STATUS_G_terc4_err_g_shift                          (17)
+#define TERC4_ERR_STATUS_G_terc4_err_cnt_of_g_shift                   (16)
+#define TERC4_ERR_STATUS_G_terc4_err_cnt_g_shift                      (0)
+#define TERC4_ERR_STATUS_G_terc4_err_thd_g_mask                       (0x00040000)
+#define TERC4_ERR_STATUS_G_terc4_err_g_mask                           (0x00020000)
+#define TERC4_ERR_STATUS_G_terc4_err_cnt_of_g_mask                    (0x00010000)
+#define TERC4_ERR_STATUS_G_terc4_err_cnt_g_mask                       (0x0000FFFF)
+#define TERC4_ERR_STATUS_G_terc4_err_thd_g(data)                      (0x00040000&((data)<<18))
+#define TERC4_ERR_STATUS_G_terc4_err_g(data)                          (0x00020000&((data)<<17))
+#define TERC4_ERR_STATUS_G_terc4_err_cnt_of_g(data)                   (0x00010000&((data)<<16))
+#define TERC4_ERR_STATUS_G_terc4_err_cnt_g(data)                      (0x0000FFFF&(data))
+#define TERC4_ERR_STATUS_G_get_terc4_err_thd_g(data)                  ((0x00040000&(data))>>18)
+#define TERC4_ERR_STATUS_G_get_terc4_err_g(data)                      ((0x00020000&(data))>>17)
+#define TERC4_ERR_STATUS_G_get_terc4_err_cnt_of_g(data)               ((0x00010000&(data))>>16)
+#define TERC4_ERR_STATUS_G_get_terc4_err_cnt_g(data)                  (0x0000FFFF&(data))
+
+
+#define TERC4_ERR_STATUS_R                                            0x07c
+#define TERC4_ERR_STATUS_R_reg_addr                                   "0x9803407c"
+#define TERC4_ERR_STATUS_R_reg                                        0x9803407c
+#define TERC4_ERR_STATUS_R_inst_addr                                  "0x001F"
+#define TERC4_ERR_STATUS_R_inst                                       0x001F
+#define set_TERC4_ERR_STATUS_R_reg(data)                              (*((volatile unsigned int*)TERC4_ERR_STATUS_R_reg)=data)
+#define get_TERC4_ERR_STATUS_R_reg                                    (*((volatile unsigned int*)TERC4_ERR_STATUS_R_reg))
+#define TERC4_ERR_STATUS_R_terc4_err_thd_r_shift                      (18)
+#define TERC4_ERR_STATUS_R_terc4_err_r_shift                          (17)
+#define TERC4_ERR_STATUS_R_terc4_err_cnt_of_r_shift                   (16)
+#define TERC4_ERR_STATUS_R_terc4_err_cnt_r_shift                      (0)
+#define TERC4_ERR_STATUS_R_terc4_err_thd_r_mask                       (0x00040000)
+#define TERC4_ERR_STATUS_R_terc4_err_r_mask                           (0x00020000)
+#define TERC4_ERR_STATUS_R_terc4_err_cnt_of_r_mask                    (0x00010000)
+#define TERC4_ERR_STATUS_R_terc4_err_cnt_r_mask                       (0x0000FFFF)
+#define TERC4_ERR_STATUS_R_terc4_err_thd_r(data)                      (0x00040000&((data)<<18))
+#define TERC4_ERR_STATUS_R_terc4_err_r(data)                          (0x00020000&((data)<<17))
+#define TERC4_ERR_STATUS_R_terc4_err_cnt_of_r(data)                   (0x00010000&((data)<<16))
+#define TERC4_ERR_STATUS_R_terc4_err_cnt_r(data)                      (0x0000FFFF&(data))
+#define TERC4_ERR_STATUS_R_get_terc4_err_thd_r(data)                  ((0x00040000&(data))>>18)
+#define TERC4_ERR_STATUS_R_get_terc4_err_r(data)                      ((0x00020000&(data))>>17)
+#define TERC4_ERR_STATUS_R_get_terc4_err_cnt_of_r(data)               ((0x00010000&(data))>>16)
+#define TERC4_ERR_STATUS_R_get_terc4_err_cnt_r(data)                  (0x0000FFFF&(data))
+
+
+#define HDMI_SR                                                       0x080
+#define HDMI_SR_reg_addr                                              "0x98034080"
+#define HDMI_SR_reg                                                   0x98034080
+#define HDMI_SR_inst_addr                                             "0x0020"
+#define HDMI_SR_inst                                                  0x0020
+#define set_HDMI_SR_reg(data)                                         (*((volatile unsigned int*)HDMI_SR_reg)=data)
+#define get_HDMI_SR_reg                                               (*((volatile unsigned int*)HDMI_SR_reg))
+#define HDMI_SR_avmute_bg_shift                                       (7)
+#define HDMI_SR_avmute_shift                                          (6)
+#define HDMI_SR_vic_shift                                             (5)
+#define HDMI_SR_spdiftype_shift                                       (4)
+#define HDMI_SR_pllsts_shift                                          (3)
+#define HDMI_SR_afifoof_shift                                         (2)
+#define HDMI_SR_afifouf_shift                                         (1)
+#define HDMI_SR_mode_shift                                            (0)
+#define HDMI_SR_avmute_bg_mask                                        (0x00000080)
+#define HDMI_SR_avmute_mask                                           (0x00000040)
+#define HDMI_SR_vic_mask                                              (0x00000020)
+#define HDMI_SR_spdiftype_mask                                        (0x00000010)
+#define HDMI_SR_pllsts_mask                                           (0x00000008)
+#define HDMI_SR_afifoof_mask                                          (0x00000004)
+#define HDMI_SR_afifouf_mask                                          (0x00000002)
+#define HDMI_SR_mode_mask                                             (0x00000001)
+#define HDMI_SR_avmute_bg(data)                                       (0x00000080&((data)<<7))
+#define HDMI_SR_avmute(data)                                          (0x00000040&((data)<<6))
+#define HDMI_SR_vic(data)                                             (0x00000020&((data)<<5))
+#define HDMI_SR_spdiftype(data)                                       (0x00000010&((data)<<4))
+#define HDMI_SR_pllsts(data)                                          (0x00000008&((data)<<3))
+#define HDMI_SR_afifoof(data)                                         (0x00000004&((data)<<2))
+#define HDMI_SR_afifouf(data)                                         (0x00000002&((data)<<1))
+#define HDMI_SR_mode(data)                                            (0x00000001&(data))
+#define HDMI_SR_get_avmute_bg(data)                                   ((0x00000080&(data))>>7)
+#define HDMI_SR_get_avmute(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_SR_get_vic(data)                                         ((0x00000020&(data))>>5)
+#define HDMI_SR_get_spdiftype(data)                                   ((0x00000010&(data))>>4)
+#define HDMI_SR_get_pllsts(data)                                      ((0x00000008&(data))>>3)
+#define HDMI_SR_get_afifoof(data)                                     ((0x00000004&(data))>>2)
+#define HDMI_SR_get_afifouf(data)                                     ((0x00000002&(data))>>1)
+#define HDMI_SR_get_mode(data)                                        (0x00000001&(data))
+
+
+#define HDMI_GPVS                                                     0x084
+#define HDMI_GPVS_reg_addr                                            "0x98034084"
+#define HDMI_GPVS_reg                                                 0x98034084
+#define HDMI_GPVS_inst_addr                                           "0x0021"
+#define HDMI_GPVS_inst                                                0x0021
+#define set_HDMI_GPVS_reg(data)                                       (*((volatile unsigned int*)HDMI_GPVS_reg)=data)
+#define get_HDMI_GPVS_reg                                             (*((volatile unsigned int*)HDMI_GPVS_reg))
+#define HDMI_GPVS_fvsps_shift                                         (14)
+#define HDMI_GPVS_gmps_v_shift                                        (13)
+#define HDMI_GPVS_vsps_v_shift                                        (12)
+#define HDMI_GPVS_gmps_shift                                          (11)
+#define HDMI_GPVS_vsps_shift                                          (10)
+#define HDMI_GPVS_nps_shift                                           (9)
+#define HDMI_GPVS_dummy_8_shift                                       (8)
+#define HDMI_GPVS_dummy_7_shift                                       (7)
+#define HDMI_GPVS_pis_6_shift                                         (6)
+#define HDMI_GPVS_pis_5_shift                                         (5)
+#define HDMI_GPVS_pvs_4_shift                                         (4)
+#define HDMI_GPVS_pvs_3_shift                                         (3)
+#define HDMI_GPVS_pvs_2_shift                                         (2)
+#define HDMI_GPVS_pvs_1_shift                                         (1)
+#define HDMI_GPVS_pvs_0_shift                                         (0)
+#define HDMI_GPVS_fvsps_mask                                          (0x00004000)
+#define HDMI_GPVS_gmps_v_mask                                         (0x00002000)
+#define HDMI_GPVS_vsps_v_mask                                         (0x00001000)
+#define HDMI_GPVS_gmps_mask                                           (0x00000800)
+#define HDMI_GPVS_vsps_mask                                           (0x00000400)
+#define HDMI_GPVS_nps_mask                                            (0x00000200)
+#define HDMI_GPVS_dummy_8_mask                                        (0x00000100)
+#define HDMI_GPVS_dummy_7_mask                                        (0x00000080)
+#define HDMI_GPVS_pis_6_mask                                          (0x00000040)
+#define HDMI_GPVS_pis_5_mask                                          (0x00000020)
+#define HDMI_GPVS_pvs_4_mask                                          (0x00000010)
+#define HDMI_GPVS_pvs_3_mask                                          (0x00000008)
+#define HDMI_GPVS_pvs_2_mask                                          (0x00000004)
+#define HDMI_GPVS_pvs_1_mask                                          (0x00000002)
+#define HDMI_GPVS_pvs_0_mask                                          (0x00000001)
+#define HDMI_GPVS_fvsps(data)                                         (0x00004000&((data)<<14))
+#define HDMI_GPVS_gmps_v(data)                                        (0x00002000&((data)<<13))
+#define HDMI_GPVS_vsps_v(data)                                        (0x00001000&((data)<<12))
+#define HDMI_GPVS_gmps(data)                                          (0x00000800&((data)<<11))
+#define HDMI_GPVS_vsps(data)                                          (0x00000400&((data)<<10))
+#define HDMI_GPVS_nps(data)                                           (0x00000200&((data)<<9))
+#define HDMI_GPVS_dummy_8(data)                                       (0x00000100&((data)<<8))
+#define HDMI_GPVS_dummy_7(data)                                       (0x00000080&((data)<<7))
+#define HDMI_GPVS_pis_6(data)                                         (0x00000040&((data)<<6))
+#define HDMI_GPVS_pis_5(data)                                         (0x00000020&((data)<<5))
+#define HDMI_GPVS_pvs_4(data)                                         (0x00000010&((data)<<4))
+#define HDMI_GPVS_pvs_3(data)                                         (0x00000008&((data)<<3))
+#define HDMI_GPVS_pvs_2(data)                                         (0x00000004&((data)<<2))
+#define HDMI_GPVS_pvs_1(data)                                         (0x00000002&((data)<<1))
+#define HDMI_GPVS_pvs_0(data)                                         (0x00000001&(data))
+#define HDMI_GPVS_get_fvsps(data)                                     ((0x00004000&(data))>>14)
+#define HDMI_GPVS_get_gmps_v(data)                                    ((0x00002000&(data))>>13)
+#define HDMI_GPVS_get_vsps_v(data)                                    ((0x00001000&(data))>>12)
+#define HDMI_GPVS_get_gmps(data)                                      ((0x00000800&(data))>>11)
+#define HDMI_GPVS_get_vsps(data)                                      ((0x00000400&(data))>>10)
+#define HDMI_GPVS_get_nps(data)                                       ((0x00000200&(data))>>9)
+#define HDMI_GPVS_get_dummy_8(data)                                   ((0x00000100&(data))>>8)
+#define HDMI_GPVS_get_dummy_7(data)                                   ((0x00000080&(data))>>7)
+#define HDMI_GPVS_get_pis_6(data)                                     ((0x00000040&(data))>>6)
+#define HDMI_GPVS_get_pis_5(data)                                     ((0x00000020&(data))>>5)
+#define HDMI_GPVS_get_pvs_4(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_GPVS_get_pvs_3(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_GPVS_get_pvs_2(data)                                     ((0x00000004&(data))>>2)
+#define HDMI_GPVS_get_pvs_1(data)                                     ((0x00000002&(data))>>1)
+#define HDMI_GPVS_get_pvs_0(data)                                     (0x00000001&(data))
+
+
+#define HDMI_PSAP                                                     0x088
+#define HDMI_PSAP_reg_addr                                            "0x98034088"
+#define HDMI_PSAP_reg                                                 0x98034088
+#define HDMI_PSAP_inst_addr                                           "0x0022"
+#define HDMI_PSAP_inst                                                0x0022
+#define set_HDMI_PSAP_reg(data)                                       (*((volatile unsigned int*)HDMI_PSAP_reg)=data)
+#define get_HDMI_PSAP_reg                                             (*((volatile unsigned int*)HDMI_PSAP_reg))
+#define HDMI_PSAP_apss_shift                                          (0)
+#define HDMI_PSAP_apss_mask                                           (0x000001FF)
+#define HDMI_PSAP_apss(data)                                          (0x000001FF&(data))
+#define HDMI_PSAP_get_apss(data)                                      (0x000001FF&(data))
+
+
+#define HDMI_PSDP                                                     0x08c
+#define HDMI_PSDP_reg_addr                                            "0x9803408c"
+#define HDMI_PSDP_reg                                                 0x9803408c
+#define HDMI_PSDP_inst_addr                                           "0x0023"
+#define HDMI_PSDP_inst                                                0x0023
+#define set_HDMI_PSDP_reg(data)                                       (*((volatile unsigned int*)HDMI_PSDP_reg)=data)
+#define get_HDMI_PSDP_reg                                             (*((volatile unsigned int*)HDMI_PSDP_reg))
+#define HDMI_PSDP_dpss_shift                                          (0)
+#define HDMI_PSDP_dpss_mask                                           (0x000000FF)
+#define HDMI_PSDP_dpss(data)                                          (0x000000FF&(data))
+#define HDMI_PSDP_get_dpss(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_SCR                                                      0x090
+#define HDMI_SCR_reg_addr                                             "0x98034090"
+#define HDMI_SCR_reg                                                  0x98034090
+#define HDMI_SCR_inst_addr                                            "0x0024"
+#define HDMI_SCR_inst                                                 0x0024
+#define set_HDMI_SCR_reg(data)                                        (*((volatile unsigned int*)HDMI_SCR_reg)=data)
+#define get_HDMI_SCR_reg                                              (*((volatile unsigned int*)HDMI_SCR_reg))
+#define HDMI_SCR_nval_shift                                           (8)
+#define HDMI_SCR_no_vs_det_en_shift                                   (6)
+#define HDMI_SCR_dvi_reset_ds_cm_en_shift                             (5)
+#define HDMI_SCR_packet_ignore_shift                                  (4)
+#define HDMI_SCR_mode_shift                                           (3)
+#define HDMI_SCR_msmode_shift                                         (2)
+#define HDMI_SCR_cabs_shift                                           (1)
+#define HDMI_SCR_fcddip_shift                                         (0)
+#define HDMI_SCR_nval_mask                                            (0x0000FF00)
+#define HDMI_SCR_no_vs_det_en_mask                                    (0x00000040)
+#define HDMI_SCR_dvi_reset_ds_cm_en_mask                              (0x00000020)
+#define HDMI_SCR_packet_ignore_mask                                   (0x00000010)
+#define HDMI_SCR_mode_mask                                            (0x00000008)
+#define HDMI_SCR_msmode_mask                                          (0x00000004)
+#define HDMI_SCR_cabs_mask                                            (0x00000002)
+#define HDMI_SCR_fcddip_mask                                          (0x00000001)
+#define HDMI_SCR_nval(data)                                           (0x0000FF00&((data)<<8))
+#define HDMI_SCR_no_vs_det_en(data)                                   (0x00000040&((data)<<6))
+#define HDMI_SCR_dvi_reset_ds_cm_en(data)                             (0x00000020&((data)<<5))
+#define HDMI_SCR_packet_ignore(data)                                  (0x00000010&((data)<<4))
+#define HDMI_SCR_mode(data)                                           (0x00000008&((data)<<3))
+#define HDMI_SCR_msmode(data)                                         (0x00000004&((data)<<2))
+#define HDMI_SCR_cabs(data)                                           (0x00000002&((data)<<1))
+#define HDMI_SCR_fcddip(data)                                         (0x00000001&(data))
+#define HDMI_SCR_get_nval(data)                                       ((0x0000FF00&(data))>>8)
+#define HDMI_SCR_get_no_vs_det_en(data)                               ((0x00000040&(data))>>6)
+#define HDMI_SCR_get_dvi_reset_ds_cm_en(data)                         ((0x00000020&(data))>>5)
+#define HDMI_SCR_get_packet_ignore(data)                              ((0x00000010&(data))>>4)
+#define HDMI_SCR_get_mode(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_SCR_get_msmode(data)                                     ((0x00000004&(data))>>2)
+#define HDMI_SCR_get_cabs(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_SCR_get_fcddip(data)                                     (0x00000001&(data))
+
+
+#define HDMI_BCHCR                                                    0x094
+#define HDMI_BCHCR_reg_addr                                           "0x98034094"
+#define HDMI_BCHCR_reg                                                0x98034094
+#define HDMI_BCHCR_inst_addr                                          "0x0025"
+#define HDMI_BCHCR_inst                                               0x0025
+#define set_HDMI_BCHCR_reg(data)                                      (*((volatile unsigned int*)HDMI_BCHCR_reg)=data)
+#define get_HDMI_BCHCR_reg                                            (*((volatile unsigned int*)HDMI_BCHCR_reg))
+#define HDMI_BCHCR_spcss_shift                                        (5)
+#define HDMI_BCHCR_enrwe_shift                                        (4)
+#define HDMI_BCHCR_bche_shift                                         (3)
+#define HDMI_BCHCR_bches_shift                                        (2)
+#define HDMI_BCHCR_bches2_shift                                       (1)
+#define HDMI_BCHCR_pe_shift                                           (0)
+#define HDMI_BCHCR_spcss_mask                                         (0x00000020)
+#define HDMI_BCHCR_enrwe_mask                                         (0x00000010)
+#define HDMI_BCHCR_bche_mask                                          (0x00000008)
+#define HDMI_BCHCR_bches_mask                                         (0x00000004)
+#define HDMI_BCHCR_bches2_mask                                        (0x00000002)
+#define HDMI_BCHCR_pe_mask                                            (0x00000001)
+#define HDMI_BCHCR_spcss(data)                                        (0x00000020&((data)<<5))
+#define HDMI_BCHCR_enrwe(data)                                        (0x00000010&((data)<<4))
+#define HDMI_BCHCR_bche(data)                                         (0x00000008&((data)<<3))
+#define HDMI_BCHCR_bches(data)                                        (0x00000004&((data)<<2))
+#define HDMI_BCHCR_bches2(data)                                       (0x00000002&((data)<<1))
+#define HDMI_BCHCR_pe(data)                                           (0x00000001&(data))
+#define HDMI_BCHCR_get_spcss(data)                                    ((0x00000020&(data))>>5)
+#define HDMI_BCHCR_get_enrwe(data)                                    ((0x00000010&(data))>>4)
+#define HDMI_BCHCR_get_bche(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_BCHCR_get_bches(data)                                    ((0x00000004&(data))>>2)
+#define HDMI_BCHCR_get_bches2(data)                                   ((0x00000002&(data))>>1)
+#define HDMI_BCHCR_get_pe(data)                                       (0x00000001&(data))
+
+
+#define HDMI_AVMCR                                                    0x098
+#define HDMI_AVMCR_reg_addr                                           "0x98034098"
+#define HDMI_AVMCR_reg                                                0x98034098
+#define HDMI_AVMCR_inst_addr                                          "0x0026"
+#define HDMI_AVMCR_inst                                               0x0026
+#define set_HDMI_AVMCR_reg(data)                                      (*((volatile unsigned int*)HDMI_AVMCR_reg)=data)
+#define get_HDMI_AVMCR_reg                                            (*((volatile unsigned int*)HDMI_AVMCR_reg))
+#define HDMI_AVMCR_wd_ptg_en_shift                                    (10)
+#define HDMI_AVMCR_wd_vclk_en_shift                                   (9)
+#define HDMI_AVMCR_avmute_flag_shift                                  (8)
+#define HDMI_AVMCR_avmute_win_en_shift                                (7)
+#define HDMI_AVMCR_aoc_shift                                          (6)
+#define HDMI_AVMCR_aomc_shift                                         (5)
+#define HDMI_AVMCR_awd_shift                                          (4)
+#define HDMI_AVMCR_ve_shift                                           (3)
+#define HDMI_AVMCR_ampic_shift                                        (2)
+#define HDMI_AVMCR_vdpic_shift                                        (1)
+#define HDMI_AVMCR_nfpss_shift                                        (0)
+#define HDMI_AVMCR_wd_ptg_en_mask                                     (0x00000400)
+#define HDMI_AVMCR_wd_vclk_en_mask                                    (0x00000200)
+#define HDMI_AVMCR_avmute_flag_mask                                   (0x00000100)
+#define HDMI_AVMCR_avmute_win_en_mask                                 (0x00000080)
+#define HDMI_AVMCR_aoc_mask                                           (0x00000040)
+#define HDMI_AVMCR_aomc_mask                                          (0x00000020)
+#define HDMI_AVMCR_awd_mask                                           (0x00000010)
+#define HDMI_AVMCR_ve_mask                                            (0x00000008)
+#define HDMI_AVMCR_ampic_mask                                         (0x00000004)
+#define HDMI_AVMCR_vdpic_mask                                         (0x00000002)
+#define HDMI_AVMCR_nfpss_mask                                         (0x00000001)
+#define HDMI_AVMCR_wd_ptg_en(data)                                    (0x00000400&((data)<<10))
+#define HDMI_AVMCR_wd_vclk_en(data)                                   (0x00000200&((data)<<9))
+#define HDMI_AVMCR_avmute_flag(data)                                  (0x00000100&((data)<<8))
+#define HDMI_AVMCR_avmute_win_en(data)                                (0x00000080&((data)<<7))
+#define HDMI_AVMCR_aoc(data)                                          (0x00000040&((data)<<6))
+#define HDMI_AVMCR_aomc(data)                                         (0x00000020&((data)<<5))
+#define HDMI_AVMCR_awd(data)                                          (0x00000010&((data)<<4))
+#define HDMI_AVMCR_ve(data)                                           (0x00000008&((data)<<3))
+#define HDMI_AVMCR_ampic(data)                                        (0x00000004&((data)<<2))
+#define HDMI_AVMCR_vdpic(data)                                        (0x00000002&((data)<<1))
+#define HDMI_AVMCR_nfpss(data)                                        (0x00000001&(data))
+#define HDMI_AVMCR_get_wd_ptg_en(data)                                ((0x00000400&(data))>>10)
+#define HDMI_AVMCR_get_wd_vclk_en(data)                               ((0x00000200&(data))>>9)
+#define HDMI_AVMCR_get_avmute_flag(data)                              ((0x00000100&(data))>>8)
+#define HDMI_AVMCR_get_avmute_win_en(data)                            ((0x00000080&(data))>>7)
+#define HDMI_AVMCR_get_aoc(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_AVMCR_get_aomc(data)                                     ((0x00000020&(data))>>5)
+#define HDMI_AVMCR_get_awd(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_AVMCR_get_ve(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_AVMCR_get_ampic(data)                                    ((0x00000004&(data))>>2)
+#define HDMI_AVMCR_get_vdpic(data)                                    ((0x00000002&(data))>>1)
+#define HDMI_AVMCR_get_nfpss(data)                                    (0x00000001&(data))
+
+
+#define HDMI_WDCR0                                                    0x09c
+#define HDMI_WDCR0_reg_addr                                           "0x9803409c"
+#define HDMI_WDCR0_reg                                                0x9803409c
+#define HDMI_WDCR0_inst_addr                                          "0x0027"
+#define HDMI_WDCR0_inst                                               0x0027
+#define set_HDMI_WDCR0_reg(data)                                      (*((volatile unsigned int*)HDMI_WDCR0_reg)=data)
+#define get_HDMI_WDCR0_reg                                            (*((volatile unsigned int*)HDMI_WDCR0_reg))
+#define HDMI_WDCR0_wdm_shift                                          (27)
+#define HDMI_WDCR0_wds_shift                                          (26)
+#define HDMI_WDCR0_awdch_shift                                        (25)
+#define HDMI_WDCR0_vwdch_shift                                        (24)
+#define HDMI_WDCR0_vwdap_shift                                        (23)
+#define HDMI_WDCR0_vwdlf_shift                                        (22)
+#define HDMI_WDCR0_vwdafo_shift                                       (21)
+#define HDMI_WDCR0_vwdafu_shift                                       (20)
+#define HDMI_WDCR0_yv_shift                                           (16)
+#define HDMI_WDCR0_awdck_shift                                        (15)
+#define HDMI_WDCR0_awdlf_shift                                        (14)
+#define HDMI_WDCR0_ch_st_sel_shift                                    (13)
+#define HDMI_WDCR0_vwdact_shift                                       (12)
+#define HDMI_WDCR0_xv_shift                                           (8)
+#define HDMI_WDCR0_asmfe_shift                                        (7)
+#define HDMI_WDCR0_load_d_shift                                       (6)
+#define HDMI_WDCR0_bt_track_en_shift                                  (5)
+#define HDMI_WDCR0_awdct_shift                                        (4)
+#define HDMI_WDCR0_awdap_shift                                        (3)
+#define HDMI_WDCR0_awdfo_shift                                        (2)
+#define HDMI_WDCR0_awdfu_shift                                        (1)
+#define HDMI_WDCR0_ct_shift                                           (0)
+#define HDMI_WDCR0_wdm_mask                                           (0x08000000)
+#define HDMI_WDCR0_wds_mask                                           (0x04000000)
+#define HDMI_WDCR0_awdch_mask                                         (0x02000000)
+#define HDMI_WDCR0_vwdch_mask                                         (0x01000000)
+#define HDMI_WDCR0_vwdap_mask                                         (0x00800000)
+#define HDMI_WDCR0_vwdlf_mask                                         (0x00400000)
+#define HDMI_WDCR0_vwdafo_mask                                        (0x00200000)
+#define HDMI_WDCR0_vwdafu_mask                                        (0x00100000)
+#define HDMI_WDCR0_yv_mask                                            (0x000F0000)
+#define HDMI_WDCR0_awdck_mask                                         (0x00008000)
+#define HDMI_WDCR0_awdlf_mask                                         (0x00004000)
+#define HDMI_WDCR0_ch_st_sel_mask                                     (0x00002000)
+#define HDMI_WDCR0_vwdact_mask                                        (0x00001000)
+#define HDMI_WDCR0_xv_mask                                            (0x00000F00)
+#define HDMI_WDCR0_asmfe_mask                                         (0x00000080)
+#define HDMI_WDCR0_load_d_mask                                        (0x00000040)
+#define HDMI_WDCR0_bt_track_en_mask                                   (0x00000020)
+#define HDMI_WDCR0_awdct_mask                                         (0x00000010)
+#define HDMI_WDCR0_awdap_mask                                         (0x00000008)
+#define HDMI_WDCR0_awdfo_mask                                         (0x00000004)
+#define HDMI_WDCR0_awdfu_mask                                         (0x00000002)
+#define HDMI_WDCR0_ct_mask                                            (0x00000001)
+#define HDMI_WDCR0_wdm(data)                                          (0x08000000&((data)<<27))
+#define HDMI_WDCR0_wds(data)                                          (0x04000000&((data)<<26))
+#define HDMI_WDCR0_awdch(data)                                        (0x02000000&((data)<<25))
+#define HDMI_WDCR0_vwdch(data)                                        (0x01000000&((data)<<24))
+#define HDMI_WDCR0_vwdap(data)                                        (0x00800000&((data)<<23))
+#define HDMI_WDCR0_vwdlf(data)                                        (0x00400000&((data)<<22))
+#define HDMI_WDCR0_vwdafo(data)                                       (0x00200000&((data)<<21))
+#define HDMI_WDCR0_vwdafu(data)                                       (0x00100000&((data)<<20))
+#define HDMI_WDCR0_yv(data)                                           (0x000F0000&((data)<<16))
+#define HDMI_WDCR0_awdck(data)                                        (0x00008000&((data)<<15))
+#define HDMI_WDCR0_awdlf(data)                                        (0x00004000&((data)<<14))
+#define HDMI_WDCR0_ch_st_sel(data)                                    (0x00002000&((data)<<13))
+#define HDMI_WDCR0_vwdact(data)                                       (0x00001000&((data)<<12))
+#define HDMI_WDCR0_xv(data)                                           (0x00000F00&((data)<<8))
+#define HDMI_WDCR0_asmfe(data)                                        (0x00000080&((data)<<7))
+#define HDMI_WDCR0_load_d(data)                                       (0x00000040&((data)<<6))
+#define HDMI_WDCR0_bt_track_en(data)                                  (0x00000020&((data)<<5))
+#define HDMI_WDCR0_awdct(data)                                        (0x00000010&((data)<<4))
+#define HDMI_WDCR0_awdap(data)                                        (0x00000008&((data)<<3))
+#define HDMI_WDCR0_awdfo(data)                                        (0x00000004&((data)<<2))
+#define HDMI_WDCR0_awdfu(data)                                        (0x00000002&((data)<<1))
+#define HDMI_WDCR0_ct(data)                                           (0x00000001&(data))
+#define HDMI_WDCR0_get_wdm(data)                                      ((0x08000000&(data))>>27)
+#define HDMI_WDCR0_get_wds(data)                                      ((0x04000000&(data))>>26)
+#define HDMI_WDCR0_get_awdch(data)                                    ((0x02000000&(data))>>25)
+#define HDMI_WDCR0_get_vwdch(data)                                    ((0x01000000&(data))>>24)
+#define HDMI_WDCR0_get_vwdap(data)                                    ((0x00800000&(data))>>23)
+#define HDMI_WDCR0_get_vwdlf(data)                                    ((0x00400000&(data))>>22)
+#define HDMI_WDCR0_get_vwdafo(data)                                   ((0x00200000&(data))>>21)
+#define HDMI_WDCR0_get_vwdafu(data)                                   ((0x00100000&(data))>>20)
+#define HDMI_WDCR0_get_yv(data)                                       ((0x000F0000&(data))>>16)
+#define HDMI_WDCR0_get_awdck(data)                                    ((0x00008000&(data))>>15)
+#define HDMI_WDCR0_get_awdlf(data)                                    ((0x00004000&(data))>>14)
+#define HDMI_WDCR0_get_ch_st_sel(data)                                ((0x00002000&(data))>>13)
+#define HDMI_WDCR0_get_vwdact(data)                                   ((0x00001000&(data))>>12)
+#define HDMI_WDCR0_get_xv(data)                                       ((0x00000F00&(data))>>8)
+#define HDMI_WDCR0_get_asmfe(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_WDCR0_get_load_d(data)                                   ((0x00000040&(data))>>6)
+#define HDMI_WDCR0_get_bt_track_en(data)                              ((0x00000020&(data))>>5)
+#define HDMI_WDCR0_get_awdct(data)                                    ((0x00000010&(data))>>4)
+#define HDMI_WDCR0_get_awdap(data)                                    ((0x00000008&(data))>>3)
+#define HDMI_WDCR0_get_awdfo(data)                                    ((0x00000004&(data))>>2)
+#define HDMI_WDCR0_get_awdfu(data)                                    ((0x00000002&(data))>>1)
+#define HDMI_WDCR0_get_ct(data)                                       (0x00000001&(data))
+
+
+#define HDMI_DBCR                                                     0x0a0
+#define HDMI_DBCR_reg_addr                                            "0x980340a0"
+#define HDMI_DBCR_reg                                                 0x980340a0
+#define HDMI_DBCR_inst_addr                                           "0x0028"
+#define HDMI_DBCR_inst                                                0x0028
+#define set_HDMI_DBCR_reg(data)                                       (*((volatile unsigned int*)HDMI_DBCR_reg)=data)
+#define get_HDMI_DBCR_reg                                             (*((volatile unsigned int*)HDMI_DBCR_reg))
+#define HDMI_DBCR_aldbfv_shift                                        (3)
+#define HDMI_DBCR_aldbfo_shift                                        (2)
+#define HDMI_DBCR_aldbfu_shift                                        (1)
+#define HDMI_DBCR_aldbpn_shift                                        (0)
+#define HDMI_DBCR_aldbfv_mask                                         (0x00000008)
+#define HDMI_DBCR_aldbfo_mask                                         (0x00000004)
+#define HDMI_DBCR_aldbfu_mask                                         (0x00000002)
+#define HDMI_DBCR_aldbpn_mask                                         (0x00000001)
+#define HDMI_DBCR_aldbfv(data)                                        (0x00000008&((data)<<3))
+#define HDMI_DBCR_aldbfo(data)                                        (0x00000004&((data)<<2))
+#define HDMI_DBCR_aldbfu(data)                                        (0x00000002&((data)<<1))
+#define HDMI_DBCR_aldbpn(data)                                        (0x00000001&(data))
+#define HDMI_DBCR_get_aldbfv(data)                                    ((0x00000008&(data))>>3)
+#define HDMI_DBCR_get_aldbfo(data)                                    ((0x00000004&(data))>>2)
+#define HDMI_DBCR_get_aldbfu(data)                                    ((0x00000002&(data))>>1)
+#define HDMI_DBCR_get_aldbpn(data)                                    (0x00000001&(data))
+
+
+#define HDMI_AWDSR                                                    0x0a4
+#define HDMI_AWDSR_reg_addr                                           "0x980340a4"
+#define HDMI_AWDSR_reg                                                0x980340a4
+#define HDMI_AWDSR_inst_addr                                          "0x0029"
+#define HDMI_AWDSR_inst                                               0x0029
+#define set_HDMI_AWDSR_reg(data)                                      (*((volatile unsigned int*)HDMI_AWDSR_reg)=data)
+#define get_HDMI_AWDSR_reg                                            (*((volatile unsigned int*)HDMI_AWDSR_reg))
+#define HDMI_AWDSR_awdpvsb_shift                                      (0)
+#define HDMI_AWDSR_awdpvsb_mask                                       (0x0000007F)
+#define HDMI_AWDSR_awdpvsb(data)                                      (0x0000007F&(data))
+#define HDMI_AWDSR_get_awdpvsb(data)                                  (0x0000007F&(data))
+
+
+#define HDMI_VWDSR                                                    0x0a8
+#define HDMI_VWDSR_reg_addr                                           "0x980340a8"
+#define HDMI_VWDSR_reg                                                0x980340a8
+#define HDMI_VWDSR_inst_addr                                          "0x002A"
+#define HDMI_VWDSR_inst                                               0x002A
+#define set_HDMI_VWDSR_reg(data)                                      (*((volatile unsigned int*)HDMI_VWDSR_reg)=data)
+#define get_HDMI_VWDSR_reg                                            (*((volatile unsigned int*)HDMI_VWDSR_reg))
+#define HDMI_VWDSR_vwdpvsb_shift                                      (0)
+#define HDMI_VWDSR_vwdpvsb_mask                                       (0x0000007F)
+#define HDMI_VWDSR_vwdpvsb(data)                                      (0x0000007F&(data))
+#define HDMI_VWDSR_get_vwdpvsb(data)                                  (0x0000007F&(data))
+
+
+#define HDMI_PAMICR                                                   0x0ac
+#define HDMI_PAMICR_reg_addr                                          "0x980340ac"
+#define HDMI_PAMICR_reg                                               0x980340ac
+#define HDMI_PAMICR_inst_addr                                         "0x002B"
+#define HDMI_PAMICR_inst                                              0x002B
+#define set_HDMI_PAMICR_reg(data)                                     (*((volatile unsigned int*)HDMI_PAMICR_reg)=data)
+#define get_HDMI_PAMICR_reg                                           (*((volatile unsigned int*)HDMI_PAMICR_reg))
+#define HDMI_PAMICR_icpvsb_shift                                      (0)
+#define HDMI_PAMICR_icpvsb_mask                                       (0x0000007F)
+#define HDMI_PAMICR_icpvsb(data)                                      (0x0000007F&(data))
+#define HDMI_PAMICR_get_icpvsb(data)                                  (0x0000007F&(data))
+
+
+#define HDMI_PTRSV1                                                   0x0b0
+#define HDMI_PTRSV1_reg_addr                                          "0x980340b0"
+#define HDMI_PTRSV1_reg                                               0x980340b0
+#define HDMI_PTRSV1_inst_addr                                         "0x002C"
+#define HDMI_PTRSV1_inst                                              0x002C
+#define set_HDMI_PTRSV1_reg(data)                                     (*((volatile unsigned int*)HDMI_PTRSV1_reg)=data)
+#define get_HDMI_PTRSV1_reg                                           (*((volatile unsigned int*)HDMI_PTRSV1_reg))
+#define HDMI_PTRSV1_dummy_31_24_shift                                 (24)
+#define HDMI_PTRSV1_dummy_23_16_shift                                 (16)
+#define HDMI_PTRSV1_pt2_shift                                         (8)
+#define HDMI_PTRSV1_pt1_shift                                         (0)
+#define HDMI_PTRSV1_dummy_31_24_mask                                  (0xFF000000)
+#define HDMI_PTRSV1_dummy_23_16_mask                                  (0x00FF0000)
+#define HDMI_PTRSV1_pt2_mask                                          (0x0000FF00)
+#define HDMI_PTRSV1_pt1_mask                                          (0x000000FF)
+#define HDMI_PTRSV1_dummy_31_24(data)                                 (0xFF000000&((data)<<24))
+#define HDMI_PTRSV1_dummy_23_16(data)                                 (0x00FF0000&((data)<<16))
+#define HDMI_PTRSV1_pt2(data)                                         (0x0000FF00&((data)<<8))
+#define HDMI_PTRSV1_pt1(data)                                         (0x000000FF&(data))
+#define HDMI_PTRSV1_get_dummy_31_24(data)                             ((0xFF000000&(data))>>24)
+#define HDMI_PTRSV1_get_dummy_23_16(data)                             ((0x00FF0000&(data))>>16)
+#define HDMI_PTRSV1_get_pt2(data)                                     ((0x0000FF00&(data))>>8)
+#define HDMI_PTRSV1_get_pt1(data)                                     (0x000000FF&(data))
+
+
+#define HDMI_PVGCR0                                                   0x0b4
+#define HDMI_PVGCR0_reg_addr                                          "0x980340b4"
+#define HDMI_PVGCR0_reg                                               0x980340b4
+#define HDMI_PVGCR0_inst_addr                                         "0x002D"
+#define HDMI_PVGCR0_inst                                              0x002D
+#define set_HDMI_PVGCR0_reg(data)                                     (*((volatile unsigned int*)HDMI_PVGCR0_reg)=data)
+#define get_HDMI_PVGCR0_reg                                           (*((volatile unsigned int*)HDMI_PVGCR0_reg))
+#define HDMI_PVGCR0_pvsef_shift                                       (0)
+#define HDMI_PVGCR0_pvsef_mask                                        (0xFFFFFFFF)
+#define HDMI_PVGCR0_pvsef(data)                                       (0xFFFFFFFF&(data))
+#define HDMI_PVGCR0_get_pvsef(data)                                   (0xFFFFFFFF&(data))
+
+
+#define HDMI_PVSR0                                                    0x0b8
+#define HDMI_PVSR0_reg_addr                                           "0x980340b8"
+#define HDMI_PVSR0_reg                                                0x980340b8
+#define HDMI_PVSR0_inst_addr                                          "0x002E"
+#define HDMI_PVSR0_inst                                               0x002E
+#define set_HDMI_PVSR0_reg(data)                                      (*((volatile unsigned int*)HDMI_PVSR0_reg)=data)
+#define get_HDMI_PVSR0_reg                                            (*((volatile unsigned int*)HDMI_PVSR0_reg))
+#define HDMI_PVSR0_pvs_shift                                          (0)
+#define HDMI_PVSR0_pvs_mask                                           (0xFFFFFFFF)
+#define HDMI_PVSR0_pvs(data)                                          (0xFFFFFFFF&(data))
+#define HDMI_PVSR0_get_pvs(data)                                      (0xFFFFFFFF&(data))
+
+
+#define HDMI_VCR                                                      0x0bc
+#define HDMI_VCR_reg_addr                                             "0x980340bc"
+#define HDMI_VCR_reg                                                  0x980340bc
+#define HDMI_VCR_inst_addr                                            "0x002F"
+#define HDMI_VCR_inst                                                 0x002F
+#define set_HDMI_VCR_reg(data)                                        (*((volatile unsigned int*)HDMI_VCR_reg)=data)
+#define get_HDMI_VCR_reg                                              (*((volatile unsigned int*)HDMI_VCR_reg))
+#define HDMI_VCR_cbus_ddc_chsel_shift                                 (28)
+#define HDMI_VCR_hdmi_field_shift                                     (27)
+#define HDMI_VCR_int_pro_chg_flag_shift                               (26)
+#define HDMI_VCR_int_pro_chg_wd_en_shift                              (25)
+#define HDMI_VCR_int_pro_chg_int_en_shift                             (24)
+#define HDMI_VCR_hdcp_ddc_chsel_shift                                 (22)
+#define HDMI_VCR_iclk_sel_shift                                       (20)
+#define HDMI_VCR_csc_r_shift                                          (18)
+#define HDMI_VCR_hdirq_shift                                          (17)
+#define HDMI_VCR_csam_shift                                           (16)
+#define HDMI_VCR_csc_shift                                            (14)
+#define HDMI_VCR_field_decide_sel_shift                               (13)
+#define HDMI_VCR_prdsam_shift                                         (12)
+#define HDMI_VCR_dsc_r_shift                                          (8)
+#define HDMI_VCR_eoi_shift                                            (7)
+#define HDMI_VCR_eot_shift                                            (6)
+#define HDMI_VCR_se_shift                                             (5)
+#define HDMI_VCR_rs_shift                                             (4)
+#define HDMI_VCR_dsc_shift                                            (0)
+#define HDMI_VCR_cbus_ddc_chsel_mask                                  (0x10000000)
+#define HDMI_VCR_hdmi_field_mask                                      (0x08000000)
+#define HDMI_VCR_int_pro_chg_flag_mask                                (0x04000000)
+#define HDMI_VCR_int_pro_chg_wd_en_mask                               (0x02000000)
+#define HDMI_VCR_int_pro_chg_int_en_mask                              (0x01000000)
+#define HDMI_VCR_hdcp_ddc_chsel_mask                                  (0x00C00000)
+#define HDMI_VCR_iclk_sel_mask                                        (0x00300000)
+#define HDMI_VCR_csc_r_mask                                           (0x000C0000)
+#define HDMI_VCR_hdirq_mask                                           (0x00020000)
+#define HDMI_VCR_csam_mask                                            (0x00010000)
+#define HDMI_VCR_csc_mask                                             (0x0000C000)
+#define HDMI_VCR_field_decide_sel_mask                                (0x00002000)
+#define HDMI_VCR_prdsam_mask                                          (0x00001000)
+#define HDMI_VCR_dsc_r_mask                                           (0x00000F00)
+#define HDMI_VCR_eoi_mask                                             (0x00000080)
+#define HDMI_VCR_eot_mask                                             (0x00000040)
+#define HDMI_VCR_se_mask                                              (0x00000020)
+#define HDMI_VCR_rs_mask                                              (0x00000010)
+#define HDMI_VCR_dsc_mask                                             (0x0000000F)
+#define HDMI_VCR_cbus_ddc_chsel(data)                                 (0x10000000&((data)<<28))
+#define HDMI_VCR_hdmi_field(data)                                     (0x08000000&((data)<<27))
+#define HDMI_VCR_int_pro_chg_flag(data)                               (0x04000000&((data)<<26))
+#define HDMI_VCR_int_pro_chg_wd_en(data)                              (0x02000000&((data)<<25))
+#define HDMI_VCR_int_pro_chg_int_en(data)                             (0x01000000&((data)<<24))
+#define HDMI_VCR_hdcp_ddc_chsel(data)                                 (0x00C00000&((data)<<22))
+#define HDMI_VCR_iclk_sel(data)                                       (0x00300000&((data)<<20))
+#define HDMI_VCR_csc_r(data)                                          (0x000C0000&((data)<<18))
+#define HDMI_VCR_hdirq(data)                                          (0x00020000&((data)<<17))
+#define HDMI_VCR_csam(data)                                           (0x00010000&((data)<<16))
+#define HDMI_VCR_csc(data)                                            (0x0000C000&((data)<<14))
+#define HDMI_VCR_field_decide_sel(data)                               (0x00002000&((data)<<13))
+#define HDMI_VCR_prdsam(data)                                         (0x00001000&((data)<<12))
+#define HDMI_VCR_dsc_r(data)                                          (0x00000F00&((data)<<8))
+#define HDMI_VCR_eoi(data)                                            (0x00000080&((data)<<7))
+#define HDMI_VCR_eot(data)                                            (0x00000040&((data)<<6))
+#define HDMI_VCR_se(data)                                             (0x00000020&((data)<<5))
+#define HDMI_VCR_rs(data)                                             (0x00000010&((data)<<4))
+#define HDMI_VCR_dsc(data)                                            (0x0000000F&(data))
+#define HDMI_VCR_get_cbus_ddc_chsel(data)                             ((0x10000000&(data))>>28)
+#define HDMI_VCR_get_hdmi_field(data)                                 ((0x08000000&(data))>>27)
+#define HDMI_VCR_get_int_pro_chg_flag(data)                           ((0x04000000&(data))>>26)
+#define HDMI_VCR_get_int_pro_chg_wd_en(data)                          ((0x02000000&(data))>>25)
+#define HDMI_VCR_get_int_pro_chg_int_en(data)                         ((0x01000000&(data))>>24)
+#define HDMI_VCR_get_hdcp_ddc_chsel(data)                             ((0x00C00000&(data))>>22)
+#define HDMI_VCR_get_iclk_sel(data)                                   ((0x00300000&(data))>>20)
+#define HDMI_VCR_get_csc_r(data)                                      ((0x000C0000&(data))>>18)
+#define HDMI_VCR_get_hdirq(data)                                      ((0x00020000&(data))>>17)
+#define HDMI_VCR_get_csam(data)                                       ((0x00010000&(data))>>16)
+#define HDMI_VCR_get_csc(data)                                        ((0x0000C000&(data))>>14)
+#define HDMI_VCR_get_field_decide_sel(data)                           ((0x00002000&(data))>>13)
+#define HDMI_VCR_get_prdsam(data)                                     ((0x00001000&(data))>>12)
+#define HDMI_VCR_get_dsc_r(data)                                      ((0x00000F00&(data))>>8)
+#define HDMI_VCR_get_eoi(data)                                        ((0x00000080&(data))>>7)
+#define HDMI_VCR_get_eot(data)                                        ((0x00000040&(data))>>6)
+#define HDMI_VCR_get_se(data)                                         ((0x00000020&(data))>>5)
+#define HDMI_VCR_get_rs(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_VCR_get_dsc(data)                                        (0x0000000F&(data))
+
+
+#define HDMI_ACRCR                                                    0x0c0
+#define HDMI_ACRCR_reg_addr                                           "0x980340c0"
+#define HDMI_ACRCR_reg                                                0x980340c0
+#define HDMI_ACRCR_inst_addr                                          "0x0030"
+#define HDMI_ACRCR_inst                                               0x0030
+#define set_HDMI_ACRCR_reg(data)                                      (*((volatile unsigned int*)HDMI_ACRCR_reg)=data)
+#define get_HDMI_ACRCR_reg                                            (*((volatile unsigned int*)HDMI_ACRCR_reg))
+#define HDMI_ACRCR_pucnr_shift                                        (1)
+#define HDMI_ACRCR_pucsr_shift                                        (0)
+#define HDMI_ACRCR_pucnr_mask                                         (0x00000002)
+#define HDMI_ACRCR_pucsr_mask                                         (0x00000001)
+#define HDMI_ACRCR_pucnr(data)                                        (0x00000002&((data)<<1))
+#define HDMI_ACRCR_pucsr(data)                                        (0x00000001&(data))
+#define HDMI_ACRCR_get_pucnr(data)                                    ((0x00000002&(data))>>1)
+#define HDMI_ACRCR_get_pucsr(data)                                    (0x00000001&(data))
+
+
+#define HDMI_ACRSR0                                                   0x0c4
+#define HDMI_ACRSR0_reg_addr                                          "0x980340c4"
+#define HDMI_ACRSR0_reg                                               0x980340c4
+#define HDMI_ACRSR0_inst_addr                                         "0x0031"
+#define HDMI_ACRSR0_inst                                              0x0031
+#define set_HDMI_ACRSR0_reg(data)                                     (*((volatile unsigned int*)HDMI_ACRSR0_reg)=data)
+#define get_HDMI_ACRSR0_reg                                           (*((volatile unsigned int*)HDMI_ACRSR0_reg))
+#define HDMI_ACRSR0_cts_shift                                         (0)
+#define HDMI_ACRSR0_cts_mask                                          (0x000FFFFF)
+#define HDMI_ACRSR0_cts(data)                                         (0x000FFFFF&(data))
+#define HDMI_ACRSR0_get_cts(data)                                     (0x000FFFFF&(data))
+
+
+#define HDMI_ACRSR1                                                   0x0c8
+#define HDMI_ACRSR1_reg_addr                                          "0x980340c8"
+#define HDMI_ACRSR1_reg                                               0x980340c8
+#define HDMI_ACRSR1_inst_addr                                         "0x0032"
+#define HDMI_ACRSR1_inst                                              0x0032
+#define set_HDMI_ACRSR1_reg(data)                                     (*((volatile unsigned int*)HDMI_ACRSR1_reg)=data)
+#define get_HDMI_ACRSR1_reg                                           (*((volatile unsigned int*)HDMI_ACRSR1_reg))
+#define HDMI_ACRSR1_n_shift                                           (0)
+#define HDMI_ACRSR1_n_mask                                            (0x000FFFFF)
+#define HDMI_ACRSR1_n(data)                                           (0x000FFFFF&(data))
+#define HDMI_ACRSR1_get_n(data)                                       (0x000FFFFF&(data))
+
+
+#define HDMI_ACS0                                                     0x0cc
+#define HDMI_ACS0_reg_addr                                            "0x980340cc"
+#define HDMI_ACS0_reg                                                 0x980340cc
+#define HDMI_ACS0_inst_addr                                           "0x0033"
+#define HDMI_ACS0_inst                                                0x0033
+#define set_HDMI_ACS0_reg(data)                                       (*((volatile unsigned int*)HDMI_ACS0_reg)=data)
+#define get_HDMI_ACS0_reg                                             (*((volatile unsigned int*)HDMI_ACS0_reg))
+#define HDMI_ACS0_cs_shift                                            (0)
+#define HDMI_ACS0_cs_mask                                             (0x0000FFFF)
+#define HDMI_ACS0_cs(data)                                            (0x0000FFFF&(data))
+#define HDMI_ACS0_get_cs(data)                                        (0x0000FFFF&(data))
+
+
+#define HDMI_ACS1                                                     0x0d0
+#define HDMI_ACS1_reg_addr                                            "0x980340d0"
+#define HDMI_ACS1_reg                                                 0x980340d0
+#define HDMI_ACS1_inst_addr                                           "0x0034"
+#define HDMI_ACS1_inst                                                0x0034
+#define set_HDMI_ACS1_reg(data)                                       (*((volatile unsigned int*)HDMI_ACS1_reg)=data)
+#define get_HDMI_ACS1_reg                                             (*((volatile unsigned int*)HDMI_ACS1_reg))
+#define HDMI_ACS1_cs_shift                                            (0)
+#define HDMI_ACS1_cs_mask                                             (0x00FFFFFF)
+#define HDMI_ACS1_cs(data)                                            (0x00FFFFFF&(data))
+#define HDMI_ACS1_get_cs(data)                                        (0x00FFFFFF&(data))
+
+
+#define HDMI_INTCR                                                    0x0d4
+#define HDMI_INTCR_reg_addr                                           "0x980340d4"
+#define HDMI_INTCR_reg                                                0x980340d4
+#define HDMI_INTCR_inst_addr                                          "0x0035"
+#define HDMI_INTCR_inst                                               0x0035
+#define set_HDMI_INTCR_reg(data)                                      (*((volatile unsigned int*)HDMI_INTCR_reg)=data)
+#define get_HDMI_INTCR_reg                                            (*((volatile unsigned int*)HDMI_INTCR_reg))
+#define HDMI_INTCR_pending_shift                                      (7)
+#define HDMI_INTCR_avmute_shift                                       (6)
+#define HDMI_INTCR_fifod_shift                                        (5)
+#define HDMI_INTCR_act_shift                                          (4)
+#define HDMI_INTCR_apll_shift                                         (3)
+#define HDMI_INTCR_afifoo_shift                                       (2)
+#define HDMI_INTCR_afifou_shift                                       (1)
+#define HDMI_INTCR_vc_shift                                           (0)
+#define HDMI_INTCR_pending_mask                                       (0x00000080)
+#define HDMI_INTCR_avmute_mask                                        (0x00000040)
+#define HDMI_INTCR_fifod_mask                                         (0x00000020)
+#define HDMI_INTCR_act_mask                                           (0x00000010)
+#define HDMI_INTCR_apll_mask                                          (0x00000008)
+#define HDMI_INTCR_afifoo_mask                                        (0x00000004)
+#define HDMI_INTCR_afifou_mask                                        (0x00000002)
+#define HDMI_INTCR_vc_mask                                            (0x00000001)
+#define HDMI_INTCR_pending(data)                                      (0x00000080&((data)<<7))
+#define HDMI_INTCR_avmute(data)                                       (0x00000040&((data)<<6))
+#define HDMI_INTCR_fifod(data)                                        (0x00000020&((data)<<5))
+#define HDMI_INTCR_act(data)                                          (0x00000010&((data)<<4))
+#define HDMI_INTCR_apll(data)                                         (0x00000008&((data)<<3))
+#define HDMI_INTCR_afifoo(data)                                       (0x00000004&((data)<<2))
+#define HDMI_INTCR_afifou(data)                                       (0x00000002&((data)<<1))
+#define HDMI_INTCR_vc(data)                                           (0x00000001&(data))
+#define HDMI_INTCR_get_pending(data)                                  ((0x00000080&(data))>>7)
+#define HDMI_INTCR_get_avmute(data)                                   ((0x00000040&(data))>>6)
+#define HDMI_INTCR_get_fifod(data)                                    ((0x00000020&(data))>>5)
+#define HDMI_INTCR_get_act(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_INTCR_get_apll(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_INTCR_get_afifoo(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_INTCR_get_afifou(data)                                   ((0x00000002&(data))>>1)
+#define HDMI_INTCR_get_vc(data)                                       (0x00000001&(data))
+
+
+#define HDMI_ALCR                                                     0x0d8
+#define HDMI_ALCR_reg_addr                                            "0x980340d8"
+#define HDMI_ALCR_reg                                                 0x980340d8
+#define HDMI_ALCR_inst_addr                                           "0x0036"
+#define HDMI_ALCR_inst                                                0x0036
+#define set_HDMI_ALCR_reg(data)                                       (*((volatile unsigned int*)HDMI_ALCR_reg)=data)
+#define get_HDMI_ALCR_reg                                             (*((volatile unsigned int*)HDMI_ALCR_reg))
+#define HDMI_ALCR_lo1_shift                                           (6)
+#define HDMI_ALCR_lo2_shift                                           (4)
+#define HDMI_ALCR_lo3_shift                                           (2)
+#define HDMI_ALCR_lo4_shift                                           (0)
+#define HDMI_ALCR_lo1_mask                                            (0x000000C0)
+#define HDMI_ALCR_lo2_mask                                            (0x00000030)
+#define HDMI_ALCR_lo3_mask                                            (0x0000000C)
+#define HDMI_ALCR_lo4_mask                                            (0x00000003)
+#define HDMI_ALCR_lo1(data)                                           (0x000000C0&((data)<<6))
+#define HDMI_ALCR_lo2(data)                                           (0x00000030&((data)<<4))
+#define HDMI_ALCR_lo3(data)                                           (0x0000000C&((data)<<2))
+#define HDMI_ALCR_lo4(data)                                           (0x00000003&(data))
+#define HDMI_ALCR_get_lo1(data)                                       ((0x000000C0&(data))>>6)
+#define HDMI_ALCR_get_lo2(data)                                       ((0x00000030&(data))>>4)
+#define HDMI_ALCR_get_lo3(data)                                       ((0x0000000C&(data))>>2)
+#define HDMI_ALCR_get_lo4(data)                                       (0x00000003&(data))
+
+
+#define HDMI_AOCR                                                     0x0dc
+#define HDMI_AOCR_reg_addr                                            "0x980340dc"
+#define HDMI_AOCR_reg                                                 0x980340dc
+#define HDMI_AOCR_inst_addr                                           "0x0037"
+#define HDMI_AOCR_inst                                                0x0037
+#define set_HDMI_AOCR_reg(data)                                       (*((volatile unsigned int*)HDMI_AOCR_reg)=data)
+#define get_HDMI_AOCR_reg                                             (*((volatile unsigned int*)HDMI_AOCR_reg))
+#define HDMI_AOCR_i2s_clk_en_dvi_shift                                (8)
+#define HDMI_AOCR_spdifo1_shift                                       (7)
+#define HDMI_AOCR_spdifo2_shift                                       (6)
+#define HDMI_AOCR_spdifo3_shift                                       (5)
+#define HDMI_AOCR_spdifo4_shift                                       (4)
+#define HDMI_AOCR_i2so1_shift                                         (3)
+#define HDMI_AOCR_i2so2_shift                                         (2)
+#define HDMI_AOCR_i2so3_shift                                         (1)
+#define HDMI_AOCR_i2so4_shift                                         (0)
+#define HDMI_AOCR_i2s_clk_en_dvi_mask                                 (0x00000100)
+#define HDMI_AOCR_spdifo1_mask                                        (0x00000080)
+#define HDMI_AOCR_spdifo2_mask                                        (0x00000040)
+#define HDMI_AOCR_spdifo3_mask                                        (0x00000020)
+#define HDMI_AOCR_spdifo4_mask                                        (0x00000010)
+#define HDMI_AOCR_i2so1_mask                                          (0x00000008)
+#define HDMI_AOCR_i2so2_mask                                          (0x00000004)
+#define HDMI_AOCR_i2so3_mask                                          (0x00000002)
+#define HDMI_AOCR_i2so4_mask                                          (0x00000001)
+#define HDMI_AOCR_i2s_clk_en_dvi(data)                                (0x00000100&((data)<<8))
+#define HDMI_AOCR_spdifo1(data)                                       (0x00000080&((data)<<7))
+#define HDMI_AOCR_spdifo2(data)                                       (0x00000040&((data)<<6))
+#define HDMI_AOCR_spdifo3(data)                                       (0x00000020&((data)<<5))
+#define HDMI_AOCR_spdifo4(data)                                       (0x00000010&((data)<<4))
+#define HDMI_AOCR_i2so1(data)                                         (0x00000008&((data)<<3))
+#define HDMI_AOCR_i2so2(data)                                         (0x00000004&((data)<<2))
+#define HDMI_AOCR_i2so3(data)                                         (0x00000002&((data)<<1))
+#define HDMI_AOCR_i2so4(data)                                         (0x00000001&(data))
+#define HDMI_AOCR_get_i2s_clk_en_dvi(data)                            ((0x00000100&(data))>>8)
+#define HDMI_AOCR_get_spdifo1(data)                                   ((0x00000080&(data))>>7)
+#define HDMI_AOCR_get_spdifo2(data)                                   ((0x00000040&(data))>>6)
+#define HDMI_AOCR_get_spdifo3(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_AOCR_get_spdifo4(data)                                   ((0x00000010&(data))>>4)
+#define HDMI_AOCR_get_i2so1(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_AOCR_get_i2so2(data)                                     ((0x00000004&(data))>>2)
+#define HDMI_AOCR_get_i2so3(data)                                     ((0x00000002&(data))>>1)
+#define HDMI_AOCR_get_i2so4(data)                                     (0x00000001&(data))
+
+
+#define HDMI_BCSR                                                     0x0e0
+#define HDMI_BCSR_reg_addr                                            "0x980340e0"
+#define HDMI_BCSR_reg                                                 0x980340e0
+#define HDMI_BCSR_inst_addr                                           "0x0038"
+#define HDMI_BCSR_inst                                                0x0038
+#define set_HDMI_BCSR_reg(data)                                       (*((volatile unsigned int*)HDMI_BCSR_reg)=data)
+#define get_HDMI_BCSR_reg                                             (*((volatile unsigned int*)HDMI_BCSR_reg))
+#define HDMI_BCSR_nvlgb_shift                                         (5)
+#define HDMI_BCSR_nalgb_shift                                         (4)
+#define HDMI_BCSR_natgb_shift                                         (3)
+#define HDMI_BCSR_ngb_shift                                           (2)
+#define HDMI_BCSR_pe_shift                                            (1)
+#define HDMI_BCSR_gcp_shift                                           (0)
+#define HDMI_BCSR_nvlgb_mask                                          (0x00000020)
+#define HDMI_BCSR_nalgb_mask                                          (0x00000010)
+#define HDMI_BCSR_natgb_mask                                          (0x00000008)
+#define HDMI_BCSR_ngb_mask                                            (0x00000004)
+#define HDMI_BCSR_pe_mask                                             (0x00000002)
+#define HDMI_BCSR_gcp_mask                                            (0x00000001)
+#define HDMI_BCSR_nvlgb(data)                                         (0x00000020&((data)<<5))
+#define HDMI_BCSR_nalgb(data)                                         (0x00000010&((data)<<4))
+#define HDMI_BCSR_natgb(data)                                         (0x00000008&((data)<<3))
+#define HDMI_BCSR_ngb(data)                                           (0x00000004&((data)<<2))
+#define HDMI_BCSR_pe(data)                                            (0x00000002&((data)<<1))
+#define HDMI_BCSR_gcp(data)                                           (0x00000001&(data))
+#define HDMI_BCSR_get_nvlgb(data)                                     ((0x00000020&(data))>>5)
+#define HDMI_BCSR_get_nalgb(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_BCSR_get_natgb(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_BCSR_get_ngb(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_BCSR_get_pe(data)                                        ((0x00000002&(data))>>1)
+#define HDMI_BCSR_get_gcp(data)                                       (0x00000001&(data))
+
+
+#define HDMI_ASR0                                                     0x0e4
+#define HDMI_ASR0_reg_addr                                            "0x980340e4"
+#define HDMI_ASR0_reg                                                 0x980340e4
+#define HDMI_ASR0_inst_addr                                           "0x0039"
+#define HDMI_ASR0_inst                                                0x0039
+#define set_HDMI_ASR0_reg(data)                                       (*((volatile unsigned int*)HDMI_ASR0_reg)=data)
+#define get_HDMI_ASR0_reg                                             (*((volatile unsigned int*)HDMI_ASR0_reg))
+#define HDMI_ASR0_fsre_shift                                          (2)
+#define HDMI_ASR0_fsif_shift                                          (1)
+#define HDMI_ASR0_fscs_shift                                          (0)
+#define HDMI_ASR0_fsre_mask                                           (0x00000004)
+#define HDMI_ASR0_fsif_mask                                           (0x00000002)
+#define HDMI_ASR0_fscs_mask                                           (0x00000001)
+#define HDMI_ASR0_fsre(data)                                          (0x00000004&((data)<<2))
+#define HDMI_ASR0_fsif(data)                                          (0x00000002&((data)<<1))
+#define HDMI_ASR0_fscs(data)                                          (0x00000001&(data))
+#define HDMI_ASR0_get_fsre(data)                                      ((0x00000004&(data))>>2)
+#define HDMI_ASR0_get_fsif(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_ASR0_get_fscs(data)                                      (0x00000001&(data))
+
+
+#define HDMI_ASR1                                                     0x0e8
+#define HDMI_ASR1_reg_addr                                            "0x980340e8"
+#define HDMI_ASR1_reg                                                 0x980340e8
+#define HDMI_ASR1_inst_addr                                           "0x003A"
+#define HDMI_ASR1_inst                                                0x003A
+#define set_HDMI_ASR1_reg(data)                                       (*((volatile unsigned int*)HDMI_ASR1_reg)=data)
+#define get_HDMI_ASR1_reg                                             (*((volatile unsigned int*)HDMI_ASR1_reg))
+#define HDMI_ASR1_fbif_shift                                          (4)
+#define HDMI_ASR1_fbcs_shift                                          (0)
+#define HDMI_ASR1_fbif_mask                                           (0x00000070)
+#define HDMI_ASR1_fbcs_mask                                           (0x0000000F)
+#define HDMI_ASR1_fbif(data)                                          (0x00000070&((data)<<4))
+#define HDMI_ASR1_fbcs(data)                                          (0x0000000F&(data))
+#define HDMI_ASR1_get_fbif(data)                                      ((0x00000070&(data))>>4)
+#define HDMI_ASR1_get_fbcs(data)                                      (0x0000000F&(data))
+
+
+#define HDMI_VIDEO_FORMAT                                             0x0ec
+#define HDMI_VIDEO_FORMAT_reg_addr                                    "0x980340ec"
+#define HDMI_VIDEO_FORMAT_reg                                         0x980340ec
+#define HDMI_VIDEO_FORMAT_inst_addr                                   "0x003B"
+#define HDMI_VIDEO_FORMAT_inst                                        0x003B
+#define set_HDMI_VIDEO_FORMAT_reg(data)                               (*((volatile unsigned int*)HDMI_VIDEO_FORMAT_reg)=data)
+#define get_HDMI_VIDEO_FORMAT_reg                                     (*((volatile unsigned int*)HDMI_VIDEO_FORMAT_reg))
+#define HDMI_VIDEO_FORMAT_hvf_shift                                   (8)
+#define HDMI_VIDEO_FORMAT_hdmi_vic_shift                              (0)
+#define HDMI_VIDEO_FORMAT_hvf_mask                                    (0x00000700)
+#define HDMI_VIDEO_FORMAT_hdmi_vic_mask                               (0x000000FF)
+#define HDMI_VIDEO_FORMAT_hvf(data)                                   (0x00000700&((data)<<8))
+#define HDMI_VIDEO_FORMAT_hdmi_vic(data)                              (0x000000FF&(data))
+#define HDMI_VIDEO_FORMAT_get_hvf(data)                               ((0x00000700&(data))>>8)
+#define HDMI_VIDEO_FORMAT_get_hdmi_vic(data)                          (0x000000FF&(data))
+
+
+#define HDMI_3D_FORMAT                                                0x0f0
+#define HDMI_3D_FORMAT_reg_addr                                       "0x980340f0"
+#define HDMI_3D_FORMAT_reg                                            0x980340f0
+#define HDMI_3D_FORMAT_inst_addr                                      "0x003C"
+#define HDMI_3D_FORMAT_inst                                           0x003C
+#define set_HDMI_3D_FORMAT_reg(data)                                  (*((volatile unsigned int*)HDMI_3D_FORMAT_reg)=data)
+#define get_HDMI_3D_FORMAT_reg                                        (*((volatile unsigned int*)HDMI_3D_FORMAT_reg))
+#define HDMI_3D_FORMAT_hdmi_3d_ext_data_shift                         (12)
+#define HDMI_3D_FORMAT_hdmi_3d_metadata_type_shift                    (9)
+#define HDMI_3D_FORMAT_hdmi_3d_structure_shift                        (4)
+#define HDMI_3D_FORMAT_hdmi_3d_meta_present_shift                     (3)
+#define HDMI_3D_FORMAT_hdmi_3d_ext_data_mask                          (0x0000F000)
+#define HDMI_3D_FORMAT_hdmi_3d_metadata_type_mask                     (0x00000E00)
+#define HDMI_3D_FORMAT_hdmi_3d_structure_mask                         (0x000000F0)
+#define HDMI_3D_FORMAT_hdmi_3d_meta_present_mask                      (0x00000008)
+#define HDMI_3D_FORMAT_hdmi_3d_ext_data(data)                         (0x0000F000&((data)<<12))
+#define HDMI_3D_FORMAT_hdmi_3d_metadata_type(data)                    (0x00000E00&((data)<<9))
+#define HDMI_3D_FORMAT_hdmi_3d_structure(data)                        (0x000000F0&((data)<<4))
+#define HDMI_3D_FORMAT_hdmi_3d_meta_present(data)                     (0x00000008&((data)<<3))
+#define HDMI_3D_FORMAT_get_hdmi_3d_ext_data(data)                     ((0x0000F000&(data))>>12)
+#define HDMI_3D_FORMAT_get_hdmi_3d_metadata_type(data)                ((0x00000E00&(data))>>9)
+#define HDMI_3D_FORMAT_get_hdmi_3d_structure(data)                    ((0x000000F0&(data))>>4)
+#define HDMI_3D_FORMAT_get_hdmi_3d_meta_present(data)                 ((0x00000008&(data))>>3)
+
+
+#define HDMI_FVSI                                                     0x0f4
+#define HDMI_FVSI_reg_addr                                            "0x980340f4"
+#define HDMI_FVSI_reg                                                 0x980340f4
+#define HDMI_FVSI_inst_addr                                           "0x003D"
+#define HDMI_FVSI_inst                                                0x003D
+#define set_HDMI_FVSI_reg(data)                                       (*((volatile unsigned int*)HDMI_FVSI_reg)=data)
+#define get_HDMI_FVSI_reg                                             (*((volatile unsigned int*)HDMI_FVSI_reg))
+#define HDMI_FVSI_info_3d_preferred2dview_shift                       (13)
+#define HDMI_FVSI_info_3d_viewdependency_shift                        (11)
+#define HDMI_FVSI_info_3d_dualview_shift                              (10)
+#define HDMI_FVSI_info_3d_additionalinfo_present_shift                (9)
+#define HDMI_FVSI_info_3d_f_ext_data_shift                            (5)
+#define HDMI_FVSI_info_3d_f_structure_shift                           (1)
+#define HDMI_FVSI_info_3d_valid_shift                                 (0)
+#define HDMI_FVSI_info_3d_preferred2dview_mask                        (0x00006000)
+#define HDMI_FVSI_info_3d_viewdependency_mask                         (0x00001800)
+#define HDMI_FVSI_info_3d_dualview_mask                               (0x00000400)
+#define HDMI_FVSI_info_3d_additionalinfo_present_mask                 (0x00000200)
+#define HDMI_FVSI_info_3d_f_ext_data_mask                             (0x000001E0)
+#define HDMI_FVSI_info_3d_f_structure_mask                            (0x0000001E)
+#define HDMI_FVSI_info_3d_valid_mask                                  (0x00000001)
+#define HDMI_FVSI_info_3d_preferred2dview(data)                       (0x00006000&((data)<<13))
+#define HDMI_FVSI_info_3d_viewdependency(data)                        (0x00001800&((data)<<11))
+#define HDMI_FVSI_info_3d_dualview(data)                              (0x00000400&((data)<<10))
+#define HDMI_FVSI_info_3d_additionalinfo_present(data)                (0x00000200&((data)<<9))
+#define HDMI_FVSI_info_3d_f_ext_data(data)                            (0x000001E0&((data)<<5))
+#define HDMI_FVSI_info_3d_f_structure(data)                           (0x0000001E&((data)<<1))
+#define HDMI_FVSI_info_3d_valid(data)                                 (0x00000001&(data))
+#define HDMI_FVSI_get_info_3d_preferred2dview(data)                   ((0x00006000&(data))>>13)
+#define HDMI_FVSI_get_info_3d_viewdependency(data)                    ((0x00001800&(data))>>11)
+#define HDMI_FVSI_get_info_3d_dualview(data)                          ((0x00000400&(data))>>10)
+#define HDMI_FVSI_get_info_3d_additionalinfo_present(data)            ((0x00000200&(data))>>9)
+#define HDMI_FVSI_get_info_3d_f_ext_data(data)                        ((0x000001E0&(data))>>5)
+#define HDMI_FVSI_get_info_3d_f_structure(data)                       ((0x0000001E&(data))>>1)
+#define HDMI_FVSI_get_info_3d_valid(data)                             (0x00000001&(data))
+
+
+#define CH_CR                                                         0x0f8
+#define CH_CR_reg_addr                                                "0x980340f8"
+#define CH_CR_reg                                                     0x980340f8
+#define CH_CR_inst_addr                                               "0x003E"
+#define CH_CR_inst                                                    0x003E
+#define set_CH_CR_reg(data)                                           (*((volatile unsigned int*)CH_CR_reg)=data)
+#define get_CH_CR_reg                                                 (*((volatile unsigned int*)CH_CR_reg))
+#define CH_CR_r_ch_afifo_en_shift                                     (24)
+#define CH_CR_g_ch_afifo_en_shift                                     (23)
+#define CH_CR_b_ch_afifo_en_shift                                     (22)
+#define CH_CR_ch_sync_sel_shift                                       (20)
+#define CH_CR_dummy_19_17_shift                                       (17)
+#define CH_CR_rden_thr_shift                                          (12)
+#define CH_CR_dummy_11_9_shift                                        (9)
+#define CH_CR_udwater_thr_shift                                       (4)
+#define CH_CR_dummy_3_2_shift                                         (2)
+#define CH_CR_flush_shift                                             (1)
+#define CH_CR_ch_afifo_irq_en_shift                                   (0)
+#define CH_CR_r_ch_afifo_en_mask                                      (0x01000000)
+#define CH_CR_g_ch_afifo_en_mask                                      (0x00800000)
+#define CH_CR_b_ch_afifo_en_mask                                      (0x00400000)
+#define CH_CR_ch_sync_sel_mask                                        (0x00300000)
+#define CH_CR_dummy_19_17_mask                                        (0x000E0000)
+#define CH_CR_rden_thr_mask                                           (0x0001F000)
+#define CH_CR_dummy_11_9_mask                                         (0x00000E00)
+#define CH_CR_udwater_thr_mask                                        (0x000001F0)
+#define CH_CR_dummy_3_2_mask                                          (0x0000000C)
+#define CH_CR_flush_mask                                              (0x00000002)
+#define CH_CR_ch_afifo_irq_en_mask                                    (0x00000001)
+#define CH_CR_r_ch_afifo_en(data)                                     (0x01000000&((data)<<24))
+#define CH_CR_g_ch_afifo_en(data)                                     (0x00800000&((data)<<23))
+#define CH_CR_b_ch_afifo_en(data)                                     (0x00400000&((data)<<22))
+#define CH_CR_ch_sync_sel(data)                                       (0x00300000&((data)<<20))
+#define CH_CR_dummy_19_17(data)                                       (0x000E0000&((data)<<17))
+#define CH_CR_rden_thr(data)                                          (0x0001F000&((data)<<12))
+#define CH_CR_dummy_11_9(data)                                        (0x00000E00&((data)<<9))
+#define CH_CR_udwater_thr(data)                                       (0x000001F0&((data)<<4))
+#define CH_CR_dummy_3_2(data)                                         (0x0000000C&((data)<<2))
+#define CH_CR_flush(data)                                             (0x00000002&((data)<<1))
+#define CH_CR_ch_afifo_irq_en(data)                                   (0x00000001&(data))
+#define CH_CR_get_r_ch_afifo_en(data)                                 ((0x01000000&(data))>>24)
+#define CH_CR_get_g_ch_afifo_en(data)                                 ((0x00800000&(data))>>23)
+#define CH_CR_get_b_ch_afifo_en(data)                                 ((0x00400000&(data))>>22)
+#define CH_CR_get_ch_sync_sel(data)                                   ((0x00300000&(data))>>20)
+#define CH_CR_get_dummy_19_17(data)                                   ((0x000E0000&(data))>>17)
+#define CH_CR_get_rden_thr(data)                                      ((0x0001F000&(data))>>12)
+#define CH_CR_get_dummy_11_9(data)                                    ((0x00000E00&(data))>>9)
+#define CH_CR_get_udwater_thr(data)                                   ((0x000001F0&(data))>>4)
+#define CH_CR_get_dummy_3_2(data)                                     ((0x0000000C&(data))>>2)
+#define CH_CR_get_flush(data)                                         ((0x00000002&(data))>>1)
+#define CH_CR_get_ch_afifo_irq_en(data)                               (0x00000001&(data))
+
+
+#define CH_SR                                                         0x0fc
+#define CH_SR_reg_addr                                                "0x980340fc"
+#define CH_SR_reg                                                     0x980340fc
+#define CH_SR_inst_addr                                               "0x003F"
+#define CH_SR_inst                                                    0x003F
+#define set_CH_SR_reg(data)                                           (*((volatile unsigned int*)CH_SR_reg)=data)
+#define get_CH_SR_reg                                                 (*((volatile unsigned int*)CH_SR_reg))
+#define CH_SR_rgb_de_align_flag_shift                                 (30)
+#define CH_SR_r_rwclk_det_timeout_flag_shift                          (29)
+#define CH_SR_r_wrclk_det_timeout_flag_shift                          (28)
+#define CH_SR_g_rwclk_det_timeout_flag_shift                          (27)
+#define CH_SR_g_wrclk_det_timeout_flag_shift                          (26)
+#define CH_SR_b_rwclk_det_timeout_flag_shift                          (25)
+#define CH_SR_b_wrclk_det_timeout_flag_shift                          (24)
+#define CH_SR_r_rudflow_flag_shift                                    (23)
+#define CH_SR_r_wovflow_flag_shift                                    (22)
+#define CH_SR_r_rflush_flag_shift                                     (21)
+#define CH_SR_r_rw_water_lv_shift                                     (16)
+#define CH_SR_g_rudflow_flag_shift                                    (15)
+#define CH_SR_g_wovflow_flag_shift                                    (14)
+#define CH_SR_g_rflush_flag_shift                                     (13)
+#define CH_SR_g_rw_water_lv_shift                                     (8)
+#define CH_SR_b_rudflow_flag_shift                                    (7)
+#define CH_SR_b_wovflow_flag_shift                                    (6)
+#define CH_SR_b_rflush_flag_shift                                     (5)
+#define CH_SR_b_rw_water_lv_shift                                     (0)
+#define CH_SR_rgb_de_align_flag_mask                                  (0x40000000)
+#define CH_SR_r_rwclk_det_timeout_flag_mask                           (0x20000000)
+#define CH_SR_r_wrclk_det_timeout_flag_mask                           (0x10000000)
+#define CH_SR_g_rwclk_det_timeout_flag_mask                           (0x08000000)
+#define CH_SR_g_wrclk_det_timeout_flag_mask                           (0x04000000)
+#define CH_SR_b_rwclk_det_timeout_flag_mask                           (0x02000000)
+#define CH_SR_b_wrclk_det_timeout_flag_mask                           (0x01000000)
+#define CH_SR_r_rudflow_flag_mask                                     (0x00800000)
+#define CH_SR_r_wovflow_flag_mask                                     (0x00400000)
+#define CH_SR_r_rflush_flag_mask                                      (0x00200000)
+#define CH_SR_r_rw_water_lv_mask                                      (0x001F0000)
+#define CH_SR_g_rudflow_flag_mask                                     (0x00008000)
+#define CH_SR_g_wovflow_flag_mask                                     (0x00004000)
+#define CH_SR_g_rflush_flag_mask                                      (0x00002000)
+#define CH_SR_g_rw_water_lv_mask                                      (0x00001F00)
+#define CH_SR_b_rudflow_flag_mask                                     (0x00000080)
+#define CH_SR_b_wovflow_flag_mask                                     (0x00000040)
+#define CH_SR_b_rflush_flag_mask                                      (0x00000020)
+#define CH_SR_b_rw_water_lv_mask                                      (0x0000001F)
+#define CH_SR_rgb_de_align_flag(data)                                 (0x40000000&((data)<<30))
+#define CH_SR_r_rwclk_det_timeout_flag(data)                          (0x20000000&((data)<<29))
+#define CH_SR_r_wrclk_det_timeout_flag(data)                          (0x10000000&((data)<<28))
+#define CH_SR_g_rwclk_det_timeout_flag(data)                          (0x08000000&((data)<<27))
+#define CH_SR_g_wrclk_det_timeout_flag(data)                          (0x04000000&((data)<<26))
+#define CH_SR_b_rwclk_det_timeout_flag(data)                          (0x02000000&((data)<<25))
+#define CH_SR_b_wrclk_det_timeout_flag(data)                          (0x01000000&((data)<<24))
+#define CH_SR_r_rudflow_flag(data)                                    (0x00800000&((data)<<23))
+#define CH_SR_r_wovflow_flag(data)                                    (0x00400000&((data)<<22))
+#define CH_SR_r_rflush_flag(data)                                     (0x00200000&((data)<<21))
+#define CH_SR_r_rw_water_lv(data)                                     (0x001F0000&((data)<<16))
+#define CH_SR_g_rudflow_flag(data)                                    (0x00008000&((data)<<15))
+#define CH_SR_g_wovflow_flag(data)                                    (0x00004000&((data)<<14))
+#define CH_SR_g_rflush_flag(data)                                     (0x00002000&((data)<<13))
+#define CH_SR_g_rw_water_lv(data)                                     (0x00001F00&((data)<<8))
+#define CH_SR_b_rudflow_flag(data)                                    (0x00000080&((data)<<7))
+#define CH_SR_b_wovflow_flag(data)                                    (0x00000040&((data)<<6))
+#define CH_SR_b_rflush_flag(data)                                     (0x00000020&((data)<<5))
+#define CH_SR_b_rw_water_lv(data)                                     (0x0000001F&(data))
+#define CH_SR_get_rgb_de_align_flag(data)                             ((0x40000000&(data))>>30)
+#define CH_SR_get_r_rwclk_det_timeout_flag(data)                      ((0x20000000&(data))>>29)
+#define CH_SR_get_r_wrclk_det_timeout_flag(data)                      ((0x10000000&(data))>>28)
+#define CH_SR_get_g_rwclk_det_timeout_flag(data)                      ((0x08000000&(data))>>27)
+#define CH_SR_get_g_wrclk_det_timeout_flag(data)                      ((0x04000000&(data))>>26)
+#define CH_SR_get_b_rwclk_det_timeout_flag(data)                      ((0x02000000&(data))>>25)
+#define CH_SR_get_b_wrclk_det_timeout_flag(data)                      ((0x01000000&(data))>>24)
+#define CH_SR_get_r_rudflow_flag(data)                                ((0x00800000&(data))>>23)
+#define CH_SR_get_r_wovflow_flag(data)                                ((0x00400000&(data))>>22)
+#define CH_SR_get_r_rflush_flag(data)                                 ((0x00200000&(data))>>21)
+#define CH_SR_get_r_rw_water_lv(data)                                 ((0x001F0000&(data))>>16)
+#define CH_SR_get_g_rudflow_flag(data)                                ((0x00008000&(data))>>15)
+#define CH_SR_get_g_wovflow_flag(data)                                ((0x00004000&(data))>>14)
+#define CH_SR_get_g_rflush_flag(data)                                 ((0x00002000&(data))>>13)
+#define CH_SR_get_g_rw_water_lv(data)                                 ((0x00001F00&(data))>>8)
+#define CH_SR_get_b_rudflow_flag(data)                                ((0x00000080&(data))>>7)
+#define CH_SR_get_b_wovflow_flag(data)                                ((0x00000040&(data))>>6)
+#define CH_SR_get_b_rflush_flag(data)                                 ((0x00000020&(data))>>5)
+#define CH_SR_get_b_rw_water_lv(data)                                 (0x0000001F&(data))
+
+
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ                                  0x100
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_reg_addr                         "0x98034100"
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_reg                              0x98034100
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_inst_addr                        "0x0040"
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_inst                             0x0040
+#define set_AUDIO_SAMPLE_RATE_CHANGE_IRQ_reg(data)                    (*((volatile unsigned int*)AUDIO_SAMPLE_RATE_CHANGE_IRQ_reg)=data)
+#define get_AUDIO_SAMPLE_RATE_CHANGE_IRQ_reg                          (*((volatile unsigned int*)AUDIO_SAMPLE_RATE_CHANGE_IRQ_reg))
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ncts_chg_irq_shift            (3)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ncts_chg_irq_shift               (2)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ch_status_chg_irq_shift       (1)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ch_status_chg_irq_shift          (0)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ncts_chg_irq_mask             (0x00000008)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ncts_chg_irq_mask                (0x00000004)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ch_status_chg_irq_mask        (0x00000002)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ch_status_chg_irq_mask           (0x00000001)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ncts_chg_irq(data)            (0x00000008&((data)<<3))
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ncts_chg_irq(data)               (0x00000004&((data)<<2))
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ch_status_chg_irq(data)       (0x00000002&((data)<<1))
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ch_status_chg_irq(data)          (0x00000001&(data))
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_en_ncts_chg_irq(data)        ((0x00000008&(data))>>3)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_ncts_chg_irq(data)           ((0x00000004&(data))>>2)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_en_ch_status_chg_irq(data)   ((0x00000002&(data))>>1)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_ch_status_chg_irq(data)      (0x00000001&(data))
+
+
+#define HIGH_BIT_RATE_AUDIO_PACKET                                    0x104
+#define HIGH_BIT_RATE_AUDIO_PACKET_reg_addr                           "0x98034104"
+#define HIGH_BIT_RATE_AUDIO_PACKET_reg                                0x98034104
+#define HIGH_BIT_RATE_AUDIO_PACKET_inst_addr                          "0x0041"
+#define HIGH_BIT_RATE_AUDIO_PACKET_inst                               0x0041
+#define set_HIGH_BIT_RATE_AUDIO_PACKET_reg(data)                      (*((volatile unsigned int*)HIGH_BIT_RATE_AUDIO_PACKET_reg)=data)
+#define get_HIGH_BIT_RATE_AUDIO_PACKET_reg                            (*((volatile unsigned int*)HIGH_BIT_RATE_AUDIO_PACKET_reg))
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual_shift        (2)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw_shift            (1)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_shift               (0)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual_mask         (0x00000004)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw_mask             (0x00000002)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_mask                (0x00000001)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual(data)        (0x00000004&((data)<<2))
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw(data)            (0x00000002&((data)<<1))
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode(data)               (0x00000001&(data))
+#define HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode_manual(data)    ((0x00000004&(data))>>2)
+#define HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode_fw(data)        ((0x00000002&(data))>>1)
+#define HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode(data)           (0x00000001&(data))
+
+
+#define HDMI_AFCR                                                     0x108
+#define HDMI_AFCR_reg_addr                                            "0x98034108"
+#define HDMI_AFCR_reg                                                 0x98034108
+#define HDMI_AFCR_inst_addr                                           "0x0042"
+#define HDMI_AFCR_inst                                                0x0042
+#define set_HDMI_AFCR_reg(data)                                       (*((volatile unsigned int*)HDMI_AFCR_reg)=data)
+#define get_HDMI_AFCR_reg                                             (*((volatile unsigned int*)HDMI_AFCR_reg))
+#define HDMI_AFCR_dummy_31_14_shift                                   (14)
+#define HDMI_AFCR_gain_bypass_en_shift                                (13)
+#define HDMI_AFCR_afifof_shift                                        (12)
+#define HDMI_AFCR_afifoe_shift                                        (11)
+#define HDMI_AFCR_afifowe_r_shift                                     (10)
+#define HDMI_AFCR_afifore_r_shift                                     (8)
+#define HDMI_AFCR_tst_i2s_sw_shift                                    (7)
+#define HDMI_AFCR_aoem_shift                                          (6)
+#define HDMI_AFCR_aoc_shift                                           (5)
+#define HDMI_AFCR_audio_test_enable_shift                             (4)
+#define HDMI_AFCR_mgc_shift                                           (3)
+#define HDMI_AFCR_afifowe_shift                                       (2)
+#define HDMI_AFCR_afifore_shift                                       (0)
+#define HDMI_AFCR_dummy_31_14_mask                                    (0xFFFFC000)
+#define HDMI_AFCR_gain_bypass_en_mask                                 (0x00002000)
+#define HDMI_AFCR_afifof_mask                                         (0x00001000)
+#define HDMI_AFCR_afifoe_mask                                         (0x00000800)
+#define HDMI_AFCR_afifowe_r_mask                                      (0x00000400)
+#define HDMI_AFCR_afifore_r_mask                                      (0x00000300)
+#define HDMI_AFCR_tst_i2s_sw_mask                                     (0x00000080)
+#define HDMI_AFCR_aoem_mask                                           (0x00000040)
+#define HDMI_AFCR_aoc_mask                                            (0x00000020)
+#define HDMI_AFCR_audio_test_enable_mask                              (0x00000010)
+#define HDMI_AFCR_mgc_mask                                            (0x00000008)
+#define HDMI_AFCR_afifowe_mask                                        (0x00000004)
+#define HDMI_AFCR_afifore_mask                                        (0x00000003)
+#define HDMI_AFCR_dummy_31_14(data)                                   (0xFFFFC000&((data)<<14))
+#define HDMI_AFCR_gain_bypass_en(data)                                (0x00002000&((data)<<13))
+#define HDMI_AFCR_afifof(data)                                        (0x00001000&((data)<<12))
+#define HDMI_AFCR_afifoe(data)                                        (0x00000800&((data)<<11))
+#define HDMI_AFCR_afifowe_r(data)                                     (0x00000400&((data)<<10))
+#define HDMI_AFCR_afifore_r(data)                                     (0x00000300&((data)<<8))
+#define HDMI_AFCR_tst_i2s_sw(data)                                    (0x00000080&((data)<<7))
+#define HDMI_AFCR_aoem(data)                                          (0x00000040&((data)<<6))
+#define HDMI_AFCR_aoc(data)                                           (0x00000020&((data)<<5))
+#define HDMI_AFCR_audio_test_enable(data)                             (0x00000010&((data)<<4))
+#define HDMI_AFCR_mgc(data)                                           (0x00000008&((data)<<3))
+#define HDMI_AFCR_afifowe(data)                                       (0x00000004&((data)<<2))
+#define HDMI_AFCR_afifore(data)                                       (0x00000003&(data))
+#define HDMI_AFCR_get_dummy_31_14(data)                               ((0xFFFFC000&(data))>>14)
+#define HDMI_AFCR_get_gain_bypass_en(data)                            ((0x00002000&(data))>>13)
+#define HDMI_AFCR_get_afifof(data)                                    ((0x00001000&(data))>>12)
+#define HDMI_AFCR_get_afifoe(data)                                    ((0x00000800&(data))>>11)
+#define HDMI_AFCR_get_afifowe_r(data)                                 ((0x00000400&(data))>>10)
+#define HDMI_AFCR_get_afifore_r(data)                                 ((0x00000300&(data))>>8)
+#define HDMI_AFCR_get_tst_i2s_sw(data)                                ((0x00000080&(data))>>7)
+#define HDMI_AFCR_get_aoem(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_AFCR_get_aoc(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_AFCR_get_audio_test_enable(data)                         ((0x00000010&(data))>>4)
+#define HDMI_AFCR_get_mgc(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_AFCR_get_afifowe(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_AFCR_get_afifore(data)                                   (0x00000003&(data))
+//For SW function
+#define MHL_CTS_TEST_ON												_BIT31
+#define MHL_CTS_TEST_PP_MODE										_BIT30
+#define MHL_HDMI_SETPHY_BYPASS										_BIT29
+#define MHL_HDMI_PHY_BYPASS											_BIT28
+#define MHL_HDMI_Bit_Error_check									_BIT27
+#define MHL3_RUN_6G													(_BIT26)
+#define MHL3_RUN_3G													(_BIT25)
+#define MHL3_RUN_1p5G												(_BIT25|_BIT26)
+#define MHL3_RUN_16bit												(_BIT24)  /*_BIT24=1: 16bit; _BIT24=0: 24bit */
+#define MHL3_BYPASS_CBUS_CLK										(_BIT23)
+#define HDMI_6G_TEST												(_BIT22)
+#define HDMI_Force_3G												(_BIT21)
+
+
+#define HDMI_AFSR                                                     0x10c
+#define HDMI_AFSR_reg_addr                                            "0x9803410c"
+#define HDMI_AFSR_reg                                                 0x9803410c
+#define HDMI_AFSR_inst_addr                                           "0x0043"
+#define HDMI_AFSR_inst                                                0x0043
+#define set_HDMI_AFSR_reg(data)                                       (*((volatile unsigned int*)HDMI_AFSR_reg)=data)
+#define get_HDMI_AFSR_reg                                             (*((volatile unsigned int*)HDMI_AFSR_reg))
+#define HDMI_AFSR_audio_bist_clksel_shift                             (0)
+#define HDMI_AFSR_audio_bist_clksel_mask                              (0x00000001)
+#define HDMI_AFSR_audio_bist_clksel(data)                             (0x00000001&(data))
+#define HDMI_AFSR_get_audio_bist_clksel(data)                         (0x00000001&(data))
+
+
+#define HDMI_MAGCR0                                                   0x110
+#define HDMI_MAGCR0_reg_addr                                          "0x98034110"
+#define HDMI_MAGCR0_reg                                               0x98034110
+#define HDMI_MAGCR0_inst_addr                                         "0x0044"
+#define HDMI_MAGCR0_inst                                              0x0044
+#define set_HDMI_MAGCR0_reg(data)                                     (*((volatile unsigned int*)HDMI_MAGCR0_reg)=data)
+#define get_HDMI_MAGCR0_reg                                           (*((volatile unsigned int*)HDMI_MAGCR0_reg))
+#define HDMI_MAGCR0_agi_shift                                         (13)
+#define HDMI_MAGCR0_agd_shift                                         (8)
+#define HDMI_MAGCR0_mg_shift                                          (0)
+#define HDMI_MAGCR0_agi_mask                                          (0x0000E000)
+#define HDMI_MAGCR0_agd_mask                                          (0x00001F00)
+#define HDMI_MAGCR0_mg_mask                                           (0x000000FF)
+#define HDMI_MAGCR0_agi(data)                                         (0x0000E000&((data)<<13))
+#define HDMI_MAGCR0_agd(data)                                         (0x00001F00&((data)<<8))
+#define HDMI_MAGCR0_mg(data)                                          (0x000000FF&(data))
+#define HDMI_MAGCR0_get_agi(data)                                     ((0x0000E000&(data))>>13)
+#define HDMI_MAGCR0_get_agd(data)                                     ((0x00001F00&(data))>>8)
+#define HDMI_MAGCR0_get_mg(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_MAG_M_FINAL                                              0x114
+#define HDMI_MAG_M_FINAL_reg_addr                                     "0x98034114"
+#define HDMI_MAG_M_FINAL_reg                                          0x98034114
+#define HDMI_MAG_M_FINAL_inst_addr                                    "0x0045"
+#define HDMI_MAG_M_FINAL_inst                                         0x0045
+#define set_HDMI_MAG_M_FINAL_reg(data)                                (*((volatile unsigned int*)HDMI_MAG_M_FINAL_reg)=data)
+#define get_HDMI_MAG_M_FINAL_reg                                      (*((volatile unsigned int*)HDMI_MAG_M_FINAL_reg))
+#define HDMI_MAG_M_FINAL_ldp_time_shift                               (21)
+#define HDMI_MAG_M_FINAL_ldp_time_mode_shift                          (20)
+#define HDMI_MAG_M_FINAL_fg_r_shift                                   (12)
+#define HDMI_MAG_M_FINAL_fg_l_shift                                   (4)
+#define HDMI_MAG_M_FINAL_auto_dly_mod_shift                           (3)
+#define HDMI_MAG_M_FINAL_fg_en_shift                                  (2)
+#define HDMI_MAG_M_FINAL_ffg_l_shift                                  (1)
+#define HDMI_MAG_M_FINAL_ffg_r_shift                                  (0)
+#define HDMI_MAG_M_FINAL_ldp_time_mask                                (0x7FE00000)
+#define HDMI_MAG_M_FINAL_ldp_time_mode_mask                           (0x00100000)
+#define HDMI_MAG_M_FINAL_fg_r_mask                                    (0x000FF000)
+#define HDMI_MAG_M_FINAL_fg_l_mask                                    (0x00000FF0)
+#define HDMI_MAG_M_FINAL_auto_dly_mod_mask                            (0x00000008)
+#define HDMI_MAG_M_FINAL_fg_en_mask                                   (0x00000004)
+#define HDMI_MAG_M_FINAL_ffg_l_mask                                   (0x00000002)
+#define HDMI_MAG_M_FINAL_ffg_r_mask                                   (0x00000001)
+#define HDMI_MAG_M_FINAL_ldp_time(data)                               (0x7FE00000&((data)<<21))
+#define HDMI_MAG_M_FINAL_ldp_time_mode(data)                          (0x00100000&((data)<<20))
+#define HDMI_MAG_M_FINAL_fg_r(data)                                   (0x000FF000&((data)<<12))
+#define HDMI_MAG_M_FINAL_fg_l(data)                                   (0x00000FF0&((data)<<4))
+#define HDMI_MAG_M_FINAL_auto_dly_mod(data)                           (0x00000008&((data)<<3))
+#define HDMI_MAG_M_FINAL_fg_en(data)                                  (0x00000004&((data)<<2))
+#define HDMI_MAG_M_FINAL_ffg_l(data)                                  (0x00000002&((data)<<1))
+#define HDMI_MAG_M_FINAL_ffg_r(data)                                  (0x00000001&(data))
+#define HDMI_MAG_M_FINAL_get_ldp_time(data)                           ((0x7FE00000&(data))>>21)
+#define HDMI_MAG_M_FINAL_get_ldp_time_mode(data)                      ((0x00100000&(data))>>20)
+#define HDMI_MAG_M_FINAL_get_fg_r(data)                               ((0x000FF000&(data))>>12)
+#define HDMI_MAG_M_FINAL_get_fg_l(data)                               ((0x00000FF0&(data))>>4)
+#define HDMI_MAG_M_FINAL_get_auto_dly_mod(data)                       ((0x00000008&(data))>>3)
+#define HDMI_MAG_M_FINAL_get_fg_en(data)                              ((0x00000004&(data))>>2)
+#define HDMI_MAG_M_FINAL_get_ffg_l(data)                              ((0x00000002&(data))>>1)
+#define HDMI_MAG_M_FINAL_get_ffg_r(data)                              (0x00000001&(data))
+
+
+#define ZCD_CTRL                                                      0x118
+#define ZCD_CTRL_reg_addr                                             "0x98034118"
+#define ZCD_CTRL_reg                                                  0x98034118
+#define ZCD_CTRL_inst_addr                                            "0x0046"
+#define ZCD_CTRL_inst                                                 0x0046
+#define set_ZCD_CTRL_reg(data)                                        (*((volatile unsigned int*)ZCD_CTRL_reg)=data)
+#define get_ZCD_CTRL_reg                                              (*((volatile unsigned int*)ZCD_CTRL_reg))
+#define ZCD_CTRL_zcd_ch7_done_shift                                   (23)
+#define ZCD_CTRL_zcd_ch6_done_shift                                   (22)
+#define ZCD_CTRL_zcd_ch5_done_shift                                   (21)
+#define ZCD_CTRL_zcd_ch4_done_shift                                   (20)
+#define ZCD_CTRL_zcd_ch3_done_shift                                   (19)
+#define ZCD_CTRL_zcd_ch2_done_shift                                   (18)
+#define ZCD_CTRL_zcd_ch1_done_shift                                   (17)
+#define ZCD_CTRL_zcd_ch0_done_shift                                   (16)
+#define ZCD_CTRL_zcd_timeout_shift                                    (8)
+#define ZCD_CTRL_zcd_en_shift                                         (7)
+#define ZCD_CTRL_zcd_sep_8ch_shift                                    (6)
+#define ZCD_CTRL_zcd_sep_st_shift                                     (5)
+#define ZCD_CTRL_dummy_4_0_shift                                      (0)
+#define ZCD_CTRL_zcd_ch7_done_mask                                    (0x00800000)
+#define ZCD_CTRL_zcd_ch6_done_mask                                    (0x00400000)
+#define ZCD_CTRL_zcd_ch5_done_mask                                    (0x00200000)
+#define ZCD_CTRL_zcd_ch4_done_mask                                    (0x00100000)
+#define ZCD_CTRL_zcd_ch3_done_mask                                    (0x00080000)
+#define ZCD_CTRL_zcd_ch2_done_mask                                    (0x00040000)
+#define ZCD_CTRL_zcd_ch1_done_mask                                    (0x00020000)
+#define ZCD_CTRL_zcd_ch0_done_mask                                    (0x00010000)
+#define ZCD_CTRL_zcd_timeout_mask                                     (0x00007F00)
+#define ZCD_CTRL_zcd_en_mask                                          (0x00000080)
+#define ZCD_CTRL_zcd_sep_8ch_mask                                     (0x00000040)
+#define ZCD_CTRL_zcd_sep_st_mask                                      (0x00000020)
+#define ZCD_CTRL_dummy_4_0_mask                                       (0x0000001F)
+#define ZCD_CTRL_zcd_ch7_done(data)                                   (0x00800000&((data)<<23))
+#define ZCD_CTRL_zcd_ch6_done(data)                                   (0x00400000&((data)<<22))
+#define ZCD_CTRL_zcd_ch5_done(data)                                   (0x00200000&((data)<<21))
+#define ZCD_CTRL_zcd_ch4_done(data)                                   (0x00100000&((data)<<20))
+#define ZCD_CTRL_zcd_ch3_done(data)                                   (0x00080000&((data)<<19))
+#define ZCD_CTRL_zcd_ch2_done(data)                                   (0x00040000&((data)<<18))
+#define ZCD_CTRL_zcd_ch1_done(data)                                   (0x00020000&((data)<<17))
+#define ZCD_CTRL_zcd_ch0_done(data)                                   (0x00010000&((data)<<16))
+#define ZCD_CTRL_zcd_timeout(data)                                    (0x00007F00&((data)<<8))
+#define ZCD_CTRL_zcd_en(data)                                         (0x00000080&((data)<<7))
+#define ZCD_CTRL_zcd_sep_8ch(data)                                    (0x00000040&((data)<<6))
+#define ZCD_CTRL_zcd_sep_st(data)                                     (0x00000020&((data)<<5))
+#define ZCD_CTRL_dummy_4_0(data)                                      (0x0000001F&(data))
+#define ZCD_CTRL_get_zcd_ch7_done(data)                               ((0x00800000&(data))>>23)
+#define ZCD_CTRL_get_zcd_ch6_done(data)                               ((0x00400000&(data))>>22)
+#define ZCD_CTRL_get_zcd_ch5_done(data)                               ((0x00200000&(data))>>21)
+#define ZCD_CTRL_get_zcd_ch4_done(data)                               ((0x00100000&(data))>>20)
+#define ZCD_CTRL_get_zcd_ch3_done(data)                               ((0x00080000&(data))>>19)
+#define ZCD_CTRL_get_zcd_ch2_done(data)                               ((0x00040000&(data))>>18)
+#define ZCD_CTRL_get_zcd_ch1_done(data)                               ((0x00020000&(data))>>17)
+#define ZCD_CTRL_get_zcd_ch0_done(data)                               ((0x00010000&(data))>>16)
+#define ZCD_CTRL_get_zcd_timeout(data)                                ((0x00007F00&(data))>>8)
+#define ZCD_CTRL_get_zcd_en(data)                                     ((0x00000080&(data))>>7)
+#define ZCD_CTRL_get_zcd_sep_8ch(data)                                ((0x00000040&(data))>>6)
+#define ZCD_CTRL_get_zcd_sep_st(data)                                 ((0x00000020&(data))>>5)
+#define ZCD_CTRL_get_dummy_4_0(data)                                  (0x0000001F&(data))
+
+
+#define AUDIO_FREQDET                                                 0x11c
+#define AUDIO_FREQDET_reg_addr                                        "0x9803411c"
+#define AUDIO_FREQDET_reg                                             0x9803411c
+#define AUDIO_FREQDET_inst_addr                                       "0x0047"
+#define AUDIO_FREQDET_inst                                            0x0047
+#define set_AUDIO_FREQDET_reg(data)                                   (*((volatile unsigned int*)AUDIO_FREQDET_reg)=data)
+#define get_AUDIO_FREQDET_reg                                         (*((volatile unsigned int*)AUDIO_FREQDET_reg))
+#define AUDIO_FREQDET_xtal_div_shift                                  (24)
+#define AUDIO_FREQDET_afreq_meas_result_shift                         (12)
+#define AUDIO_FREQDET_afreq_meas_range_shift                          (9)
+#define AUDIO_FREQDET_popup_afreq_meas_result_shift                   (8)
+#define AUDIO_FREQDET_audio_freq_detect_shift                         (7)
+#define AUDIO_FREQDET_auto_load_scode_shift                           (6)
+#define AUDIO_FREQDET_awd_by_freqchange_shift                         (5)
+#define AUDIO_FREQDET_awd_by_noaudio_shift                            (4)
+#define AUDIO_FREQDET_irq_by_freqchange_shift                         (3)
+#define AUDIO_FREQDET_irq_by_noaudio_shift                            (2)
+#define AUDIO_FREQDET_freqchange_shift                                (1)
+#define AUDIO_FREQDET_noaudio_shift                                   (0)
+#define AUDIO_FREQDET_xtal_div_mask                                   (0xFF000000)
+#define AUDIO_FREQDET_afreq_meas_result_mask                          (0x00FFF000)
+#define AUDIO_FREQDET_afreq_meas_range_mask                           (0x00000E00)
+#define AUDIO_FREQDET_popup_afreq_meas_result_mask                    (0x00000100)
+#define AUDIO_FREQDET_audio_freq_detect_mask                          (0x00000080)
+#define AUDIO_FREQDET_auto_load_scode_mask                            (0x00000040)
+#define AUDIO_FREQDET_awd_by_freqchange_mask                          (0x00000020)
+#define AUDIO_FREQDET_awd_by_noaudio_mask                             (0x00000010)
+#define AUDIO_FREQDET_irq_by_freqchange_mask                          (0x00000008)
+#define AUDIO_FREQDET_irq_by_noaudio_mask                             (0x00000004)
+#define AUDIO_FREQDET_freqchange_mask                                 (0x00000002)
+#define AUDIO_FREQDET_noaudio_mask                                    (0x00000001)
+#define AUDIO_FREQDET_xtal_div(data)                                  (0xFF000000&((data)<<24))
+#define AUDIO_FREQDET_afreq_meas_result(data)                         (0x00FFF000&((data)<<12))
+#define AUDIO_FREQDET_afreq_meas_range(data)                          (0x00000E00&((data)<<9))
+#define AUDIO_FREQDET_popup_afreq_meas_result(data)                   (0x00000100&((data)<<8))
+#define AUDIO_FREQDET_audio_freq_detect(data)                         (0x00000080&((data)<<7))
+#define AUDIO_FREQDET_auto_load_scode(data)                           (0x00000040&((data)<<6))
+#define AUDIO_FREQDET_awd_by_freqchange(data)                         (0x00000020&((data)<<5))
+#define AUDIO_FREQDET_awd_by_noaudio(data)                            (0x00000010&((data)<<4))
+#define AUDIO_FREQDET_irq_by_freqchange(data)                         (0x00000008&((data)<<3))
+#define AUDIO_FREQDET_irq_by_noaudio(data)                            (0x00000004&((data)<<2))
+#define AUDIO_FREQDET_freqchange(data)                                (0x00000002&((data)<<1))
+#define AUDIO_FREQDET_noaudio(data)                                   (0x00000001&(data))
+#define AUDIO_FREQDET_get_xtal_div(data)                              ((0xFF000000&(data))>>24)
+#define AUDIO_FREQDET_get_afreq_meas_result(data)                     ((0x00FFF000&(data))>>12)
+#define AUDIO_FREQDET_get_afreq_meas_range(data)                      ((0x00000E00&(data))>>9)
+#define AUDIO_FREQDET_get_popup_afreq_meas_result(data)               ((0x00000100&(data))>>8)
+#define AUDIO_FREQDET_get_audio_freq_detect(data)                     ((0x00000080&(data))>>7)
+#define AUDIO_FREQDET_get_auto_load_scode(data)                       ((0x00000040&(data))>>6)
+#define AUDIO_FREQDET_get_awd_by_freqchange(data)                     ((0x00000020&(data))>>5)
+#define AUDIO_FREQDET_get_awd_by_noaudio(data)                        ((0x00000010&(data))>>4)
+#define AUDIO_FREQDET_get_irq_by_freqchange(data)                     ((0x00000008&(data))>>3)
+#define AUDIO_FREQDET_get_irq_by_noaudio(data)                        ((0x00000004&(data))>>2)
+#define AUDIO_FREQDET_get_freqchange(data)                            ((0x00000002&(data))>>1)
+#define AUDIO_FREQDET_get_noaudio(data)                               (0x00000001&(data))
+
+
+#define RANGE0_1                                                      0x120
+#define RANGE0_1_reg_addr                                             "0x98034120"
+#define RANGE0_1_reg                                                  0x98034120
+#define RANGE0_1_inst_addr                                            "0x0048"
+#define RANGE0_1_inst                                                 0x0048
+#define set_RANGE0_1_reg(data)                                        (*((volatile unsigned int*)RANGE0_1_reg)=data)
+#define get_RANGE0_1_reg                                              (*((volatile unsigned int*)RANGE0_1_reg))
+#define RANGE0_1_range0_th_shift                                      (12)
+#define RANGE0_1_range1_th_shift                                      (0)
+#define RANGE0_1_range0_th_mask                                       (0x00FFF000)
+#define RANGE0_1_range1_th_mask                                       (0x00000FFF)
+#define RANGE0_1_range0_th(data)                                      (0x00FFF000&((data)<<12))
+#define RANGE0_1_range1_th(data)                                      (0x00000FFF&(data))
+#define RANGE0_1_get_range0_th(data)                                  ((0x00FFF000&(data))>>12)
+#define RANGE0_1_get_range1_th(data)                                  (0x00000FFF&(data))
+
+
+#define RANGE2_3                                                      0x124
+#define RANGE2_3_reg_addr                                             "0x98034124"
+#define RANGE2_3_reg                                                  0x98034124
+#define RANGE2_3_inst_addr                                            "0x0049"
+#define RANGE2_3_inst                                                 0x0049
+#define set_RANGE2_3_reg(data)                                        (*((volatile unsigned int*)RANGE2_3_reg)=data)
+#define get_RANGE2_3_reg                                              (*((volatile unsigned int*)RANGE2_3_reg))
+#define RANGE2_3_range2_th_shift                                      (12)
+#define RANGE2_3_range3_th_shift                                      (0)
+#define RANGE2_3_range2_th_mask                                       (0x00FFF000)
+#define RANGE2_3_range3_th_mask                                       (0x00000FFF)
+#define RANGE2_3_range2_th(data)                                      (0x00FFF000&((data)<<12))
+#define RANGE2_3_range3_th(data)                                      (0x00000FFF&(data))
+#define RANGE2_3_get_range2_th(data)                                  ((0x00FFF000&(data))>>12)
+#define RANGE2_3_get_range3_th(data)                                  (0x00000FFF&(data))
+
+
+#define RANGE4_5                                                      0x128
+#define RANGE4_5_reg_addr                                             "0x98034128"
+#define RANGE4_5_reg                                                  0x98034128
+#define RANGE4_5_inst_addr                                            "0x004A"
+#define RANGE4_5_inst                                                 0x004A
+#define set_RANGE4_5_reg(data)                                        (*((volatile unsigned int*)RANGE4_5_reg)=data)
+#define get_RANGE4_5_reg                                              (*((volatile unsigned int*)RANGE4_5_reg))
+#define RANGE4_5_range4_th_shift                                      (12)
+#define RANGE4_5_range5_th_shift                                      (0)
+#define RANGE4_5_range4_th_mask                                       (0x00FFF000)
+#define RANGE4_5_range5_th_mask                                       (0x00000FFF)
+#define RANGE4_5_range4_th(data)                                      (0x00FFF000&((data)<<12))
+#define RANGE4_5_range5_th(data)                                      (0x00000FFF&(data))
+#define RANGE4_5_get_range4_th(data)                                  ((0x00FFF000&(data))>>12)
+#define RANGE4_5_get_range5_th(data)                                  (0x00000FFF&(data))
+
+
+#define PRESET_S_CODE0                                                0x12c
+#define PRESET_S_CODE0_reg_addr                                       "0x9803412c"
+#define PRESET_S_CODE0_reg                                            0x9803412c
+#define PRESET_S_CODE0_inst_addr                                      "0x004B"
+#define PRESET_S_CODE0_inst                                           0x004B
+#define set_PRESET_S_CODE0_reg(data)                                  (*((volatile unsigned int*)PRESET_S_CODE0_reg)=data)
+#define get_PRESET_S_CODE0_reg                                        (*((volatile unsigned int*)PRESET_S_CODE0_reg))
+#define PRESET_S_CODE0_pre_set_s1_code3_shift                         (31)
+#define PRESET_S_CODE0_pre_set_s_code3_shift                          (24)
+#define PRESET_S_CODE0_pre_set_s1_code2_shift                         (23)
+#define PRESET_S_CODE0_pre_set_s_code2_shift                          (16)
+#define PRESET_S_CODE0_pre_set_s1_code1_shift                         (15)
+#define PRESET_S_CODE0_pre_set_s_code1_shift                          (8)
+#define PRESET_S_CODE0_pre_set_s1_code0_shift                         (7)
+#define PRESET_S_CODE0_pre_set_s_code0_shift                          (0)
+#define PRESET_S_CODE0_pre_set_s1_code3_mask                          (0x80000000)
+#define PRESET_S_CODE0_pre_set_s_code3_mask                           (0x7F000000)
+#define PRESET_S_CODE0_pre_set_s1_code2_mask                          (0x00800000)
+#define PRESET_S_CODE0_pre_set_s_code2_mask                           (0x007F0000)
+#define PRESET_S_CODE0_pre_set_s1_code1_mask                          (0x00008000)
+#define PRESET_S_CODE0_pre_set_s_code1_mask                           (0x00007F00)
+#define PRESET_S_CODE0_pre_set_s1_code0_mask                          (0x00000080)
+#define PRESET_S_CODE0_pre_set_s_code0_mask                           (0x0000007F)
+#define PRESET_S_CODE0_pre_set_s1_code3(data)                         (0x80000000&((data)<<31))
+#define PRESET_S_CODE0_pre_set_s_code3(data)                          (0x7F000000&((data)<<24))
+#define PRESET_S_CODE0_pre_set_s1_code2(data)                         (0x00800000&((data)<<23))
+#define PRESET_S_CODE0_pre_set_s_code2(data)                          (0x007F0000&((data)<<16))
+#define PRESET_S_CODE0_pre_set_s1_code1(data)                         (0x00008000&((data)<<15))
+#define PRESET_S_CODE0_pre_set_s_code1(data)                          (0x00007F00&((data)<<8))
+#define PRESET_S_CODE0_pre_set_s1_code0(data)                         (0x00000080&((data)<<7))
+#define PRESET_S_CODE0_pre_set_s_code0(data)                          (0x0000007F&(data))
+#define PRESET_S_CODE0_get_pre_set_s1_code3(data)                     ((0x80000000&(data))>>31)
+#define PRESET_S_CODE0_get_pre_set_s_code3(data)                      ((0x7F000000&(data))>>24)
+#define PRESET_S_CODE0_get_pre_set_s1_code2(data)                     ((0x00800000&(data))>>23)
+#define PRESET_S_CODE0_get_pre_set_s_code2(data)                      ((0x007F0000&(data))>>16)
+#define PRESET_S_CODE0_get_pre_set_s1_code1(data)                     ((0x00008000&(data))>>15)
+#define PRESET_S_CODE0_get_pre_set_s_code1(data)                      ((0x00007F00&(data))>>8)
+#define PRESET_S_CODE0_get_pre_set_s1_code0(data)                     ((0x00000080&(data))>>7)
+#define PRESET_S_CODE0_get_pre_set_s_code0(data)                      (0x0000007F&(data))
+
+
+#define PRESET_S_CODE1                                                0x130
+#define PRESET_S_CODE1_reg_addr                                       "0x98034130"
+#define PRESET_S_CODE1_reg                                            0x98034130
+#define PRESET_S_CODE1_inst_addr                                      "0x004C"
+#define PRESET_S_CODE1_inst                                           0x004C
+#define set_PRESET_S_CODE1_reg(data)                                  (*((volatile unsigned int*)PRESET_S_CODE1_reg)=data)
+#define get_PRESET_S_CODE1_reg                                        (*((volatile unsigned int*)PRESET_S_CODE1_reg))
+#define PRESET_S_CODE1_dp_abuf_wr_mod_en_shift                        (23)
+#define PRESET_S_CODE1_auto_stop_trk_en_shift                         (22)
+#define PRESET_S_CODE1_trk_mod_en_shift                               (21)
+#define PRESET_S_CODE1_afsm_mod_en_shift                              (20)
+#define PRESET_S_CODE1_pre_set_sm_code0_shift                         (15)
+#define PRESET_S_CODE1_pre_set_sm_code1_shift                         (14)
+#define PRESET_S_CODE1_pre_set_sm_code2_shift                         (13)
+#define PRESET_S_CODE1_pre_set_sm_code3_shift                         (12)
+#define PRESET_S_CODE1_pre_set_sm_code4_shift                         (11)
+#define PRESET_S_CODE1_pre_set_s1_code4_shift                         (7)
+#define PRESET_S_CODE1_pre_set_s_code4_shift                          (0)
+#define PRESET_S_CODE1_dp_abuf_wr_mod_en_mask                         (0x00800000)
+#define PRESET_S_CODE1_auto_stop_trk_en_mask                          (0x00400000)
+#define PRESET_S_CODE1_trk_mod_en_mask                                (0x00200000)
+#define PRESET_S_CODE1_afsm_mod_en_mask                               (0x00100000)
+#define PRESET_S_CODE1_pre_set_sm_code0_mask                          (0x00008000)
+#define PRESET_S_CODE1_pre_set_sm_code1_mask                          (0x00004000)
+#define PRESET_S_CODE1_pre_set_sm_code2_mask                          (0x00002000)
+#define PRESET_S_CODE1_pre_set_sm_code3_mask                          (0x00001000)
+#define PRESET_S_CODE1_pre_set_sm_code4_mask                          (0x00000800)
+#define PRESET_S_CODE1_pre_set_s1_code4_mask                          (0x00000080)
+#define PRESET_S_CODE1_pre_set_s_code4_mask                           (0x0000007F)
+#define PRESET_S_CODE1_dp_abuf_wr_mod_en(data)                        (0x00800000&((data)<<23))
+#define PRESET_S_CODE1_auto_stop_trk_en(data)                         (0x00400000&((data)<<22))
+#define PRESET_S_CODE1_trk_mod_en(data)                               (0x00200000&((data)<<21))
+#define PRESET_S_CODE1_afsm_mod_en(data)                              (0x00100000&((data)<<20))
+#define PRESET_S_CODE1_pre_set_sm_code0(data)                         (0x00008000&((data)<<15))
+#define PRESET_S_CODE1_pre_set_sm_code1(data)                         (0x00004000&((data)<<14))
+#define PRESET_S_CODE1_pre_set_sm_code2(data)                         (0x00002000&((data)<<13))
+#define PRESET_S_CODE1_pre_set_sm_code3(data)                         (0x00001000&((data)<<12))
+#define PRESET_S_CODE1_pre_set_sm_code4(data)                         (0x00000800&((data)<<11))
+#define PRESET_S_CODE1_pre_set_s1_code4(data)                         (0x00000080&((data)<<7))
+#define PRESET_S_CODE1_pre_set_s_code4(data)                          (0x0000007F&(data))
+#define PRESET_S_CODE1_get_dp_abuf_wr_mod_en(data)                    ((0x00800000&(data))>>23)
+#define PRESET_S_CODE1_get_auto_stop_trk_en(data)                     ((0x00400000&(data))>>22)
+#define PRESET_S_CODE1_get_trk_mod_en(data)                           ((0x00200000&(data))>>21)
+#define PRESET_S_CODE1_get_afsm_mod_en(data)                          ((0x00100000&(data))>>20)
+#define PRESET_S_CODE1_get_pre_set_sm_code0(data)                     ((0x00008000&(data))>>15)
+#define PRESET_S_CODE1_get_pre_set_sm_code1(data)                     ((0x00004000&(data))>>14)
+#define PRESET_S_CODE1_get_pre_set_sm_code2(data)                     ((0x00002000&(data))>>13)
+#define PRESET_S_CODE1_get_pre_set_sm_code3(data)                     ((0x00001000&(data))>>12)
+#define PRESET_S_CODE1_get_pre_set_sm_code4(data)                     ((0x00000800&(data))>>11)
+#define PRESET_S_CODE1_get_pre_set_s1_code4(data)                     ((0x00000080&(data))>>7)
+#define PRESET_S_CODE1_get_pre_set_s_code4(data)                      (0x0000007F&(data))
+
+
+#define PRBS_R_CTRL                                                   0x134
+#define PRBS_R_CTRL_reg_addr                                          "0x98034134"
+#define PRBS_R_CTRL_reg                                               0x98034134
+#define PRBS_R_CTRL_inst_addr                                         "0x004D"
+#define PRBS_R_CTRL_inst                                              0x004D
+#define set_PRBS_R_CTRL_reg(data)                                     (*((volatile unsigned int*)PRBS_R_CTRL_reg)=data)
+#define get_PRBS_R_CTRL_reg                                           (*((volatile unsigned int*)PRBS_R_CTRL_reg))
+#define PRBS_R_CTRL_prbs23_rxen_shift                                 (28)
+#define PRBS_R_CTRL_prbs_rxbist_err_cnt_shift                         (20)
+#define PRBS_R_CTRL_prbs_err_cnt_shift                                (16)
+#define PRBS_R_CTRL_prbs_bit_err_shift                                (4)
+#define PRBS_R_CTRL_prbs_lock_shift                                   (3)
+#define PRBS_R_CTRL_prbs_err_cnt_clr_shift                            (2)
+#define PRBS_R_CTRL_prbs_reverse_shift                                (1)
+#define PRBS_R_CTRL_prbs7_rxen_shift                                  (0)
+#define PRBS_R_CTRL_prbs23_rxen_mask                                  (0x10000000)
+#define PRBS_R_CTRL_prbs_rxbist_err_cnt_mask                          (0x0FF00000)
+#define PRBS_R_CTRL_prbs_err_cnt_mask                                 (0x000F0000)
+#define PRBS_R_CTRL_prbs_bit_err_mask                                 (0x00003FF0)
+#define PRBS_R_CTRL_prbs_lock_mask                                    (0x00000008)
+#define PRBS_R_CTRL_prbs_err_cnt_clr_mask                             (0x00000004)
+#define PRBS_R_CTRL_prbs_reverse_mask                                 (0x00000002)
+#define PRBS_R_CTRL_prbs7_rxen_mask                                   (0x00000001)
+#define PRBS_R_CTRL_prbs23_rxen(data)                                 (0x10000000&((data)<<28))
+#define PRBS_R_CTRL_prbs_rxbist_err_cnt(data)                         (0x0FF00000&((data)<<20))
+#define PRBS_R_CTRL_prbs_err_cnt(data)                                (0x000F0000&((data)<<16))
+#define PRBS_R_CTRL_prbs_bit_err(data)                                (0x00003FF0&((data)<<4))
+#define PRBS_R_CTRL_prbs_lock(data)                                   (0x00000008&((data)<<3))
+#define PRBS_R_CTRL_prbs_err_cnt_clr(data)                            (0x00000004&((data)<<2))
+#define PRBS_R_CTRL_prbs_reverse(data)                                (0x00000002&((data)<<1))
+#define PRBS_R_CTRL_prbs7_rxen(data)                                  (0x00000001&(data))
+#define PRBS_R_CTRL_get_prbs23_rxen(data)                             ((0x10000000&(data))>>28)
+#define PRBS_R_CTRL_get_prbs_rxbist_err_cnt(data)                     ((0x0FF00000&(data))>>20)
+#define PRBS_R_CTRL_get_prbs_err_cnt(data)                            ((0x000F0000&(data))>>16)
+#define PRBS_R_CTRL_get_prbs_bit_err(data)                            ((0x00003FF0&(data))>>4)
+#define PRBS_R_CTRL_get_prbs_lock(data)                               ((0x00000008&(data))>>3)
+#define PRBS_R_CTRL_get_prbs_err_cnt_clr(data)                        ((0x00000004&(data))>>2)
+#define PRBS_R_CTRL_get_prbs_reverse(data)                            ((0x00000002&(data))>>1)
+#define PRBS_R_CTRL_get_prbs7_rxen(data)                              (0x00000001&(data))
+
+
+#define PRBS_G_CTRL                                                   0x138
+#define PRBS_G_CTRL_reg_addr                                          "0x98034138"
+#define PRBS_G_CTRL_reg                                               0x98034138
+#define PRBS_G_CTRL_inst_addr                                         "0x004E"
+#define PRBS_G_CTRL_inst                                              0x004E
+#define set_PRBS_G_CTRL_reg(data)                                     (*((volatile unsigned int*)PRBS_G_CTRL_reg)=data)
+#define get_PRBS_G_CTRL_reg                                           (*((volatile unsigned int*)PRBS_G_CTRL_reg))
+#define PRBS_G_CTRL_prbs23_rxen_shift                                 (28)
+#define PRBS_G_CTRL_prbs_rxbist_err_cnt_shift                         (20)
+#define PRBS_G_CTRL_prbs_err_cnt_shift                                (16)
+#define PRBS_G_CTRL_prbs_bit_err_shift                                (4)
+#define PRBS_G_CTRL_prbs_lock_shift                                   (3)
+#define PRBS_G_CTRL_prbs_err_cnt_clr_shift                            (2)
+#define PRBS_G_CTRL_prbs_reverse_shift                                (1)
+#define PRBS_G_CTRL_prbs7_rxen_shift                                  (0)
+#define PRBS_G_CTRL_prbs23_rxen_mask                                  (0x10000000)
+#define PRBS_G_CTRL_prbs_rxbist_err_cnt_mask                          (0x0FF00000)
+#define PRBS_G_CTRL_prbs_err_cnt_mask                                 (0x000F0000)
+#define PRBS_G_CTRL_prbs_bit_err_mask                                 (0x00003FF0)
+#define PRBS_G_CTRL_prbs_lock_mask                                    (0x00000008)
+#define PRBS_G_CTRL_prbs_err_cnt_clr_mask                             (0x00000004)
+#define PRBS_G_CTRL_prbs_reverse_mask                                 (0x00000002)
+#define PRBS_G_CTRL_prbs7_rxen_mask                                   (0x00000001)
+#define PRBS_G_CTRL_prbs23_rxen(data)                                 (0x10000000&((data)<<28))
+#define PRBS_G_CTRL_prbs_rxbist_err_cnt(data)                         (0x0FF00000&((data)<<20))
+#define PRBS_G_CTRL_prbs_err_cnt(data)                                (0x000F0000&((data)<<16))
+#define PRBS_G_CTRL_prbs_bit_err(data)                                (0x00003FF0&((data)<<4))
+#define PRBS_G_CTRL_prbs_lock(data)                                   (0x00000008&((data)<<3))
+#define PRBS_G_CTRL_prbs_err_cnt_clr(data)                            (0x00000004&((data)<<2))
+#define PRBS_G_CTRL_prbs_reverse(data)                                (0x00000002&((data)<<1))
+#define PRBS_G_CTRL_prbs7_rxen(data)                                  (0x00000001&(data))
+#define PRBS_G_CTRL_get_prbs23_rxen(data)                             ((0x10000000&(data))>>28)
+#define PRBS_G_CTRL_get_prbs_rxbist_err_cnt(data)                     ((0x0FF00000&(data))>>20)
+#define PRBS_G_CTRL_get_prbs_err_cnt(data)                            ((0x000F0000&(data))>>16)
+#define PRBS_G_CTRL_get_prbs_bit_err(data)                            ((0x00003FF0&(data))>>4)
+#define PRBS_G_CTRL_get_prbs_lock(data)                               ((0x00000008&(data))>>3)
+#define PRBS_G_CTRL_get_prbs_err_cnt_clr(data)                        ((0x00000004&(data))>>2)
+#define PRBS_G_CTRL_get_prbs_reverse(data)                            ((0x00000002&(data))>>1)
+#define PRBS_G_CTRL_get_prbs7_rxen(data)                              (0x00000001&(data))
+
+
+#define PRBS_B_CTRL                                                   0x13c
+#define PRBS_B_CTRL_reg_addr                                          "0x9803413c"
+#define PRBS_B_CTRL_reg                                               0x9803413c
+#define PRBS_B_CTRL_inst_addr                                         "0x004F"
+#define PRBS_B_CTRL_inst                                              0x004F
+#define set_PRBS_B_CTRL_reg(data)                                     (*((volatile unsigned int*)PRBS_B_CTRL_reg)=data)
+#define get_PRBS_B_CTRL_reg                                           (*((volatile unsigned int*)PRBS_B_CTRL_reg))
+#define PRBS_B_CTRL_prbs23_rxen_shift                                 (28)
+#define PRBS_B_CTRL_prbs_rxbist_err_cnt_shift                         (20)
+#define PRBS_B_CTRL_prbs_err_cnt_shift                                (16)
+#define PRBS_B_CTRL_prbs_bit_err_shift                                (4)
+#define PRBS_B_CTRL_prbs_lock_shift                                   (3)
+#define PRBS_B_CTRL_prbs_err_cnt_clr_shift                            (2)
+#define PRBS_B_CTRL_prbs_reverse_shift                                (1)
+#define PRBS_B_CTRL_prbs7_rxen_shift                                  (0)
+#define PRBS_B_CTRL_prbs23_rxen_mask                                  (0x10000000)
+#define PRBS_B_CTRL_prbs_rxbist_err_cnt_mask                          (0x0FF00000)
+#define PRBS_B_CTRL_prbs_err_cnt_mask                                 (0x000F0000)
+#define PRBS_B_CTRL_prbs_bit_err_mask                                 (0x00003FF0)
+#define PRBS_B_CTRL_prbs_lock_mask                                    (0x00000008)
+#define PRBS_B_CTRL_prbs_err_cnt_clr_mask                             (0x00000004)
+#define PRBS_B_CTRL_prbs_reverse_mask                                 (0x00000002)
+#define PRBS_B_CTRL_prbs7_rxen_mask                                   (0x00000001)
+#define PRBS_B_CTRL_prbs23_rxen(data)                                 (0x10000000&((data)<<28))
+#define PRBS_B_CTRL_prbs_rxbist_err_cnt(data)                         (0x0FF00000&((data)<<20))
+#define PRBS_B_CTRL_prbs_err_cnt(data)                                (0x000F0000&((data)<<16))
+#define PRBS_B_CTRL_prbs_bit_err(data)                                (0x00003FF0&((data)<<4))
+#define PRBS_B_CTRL_prbs_lock(data)                                   (0x00000008&((data)<<3))
+#define PRBS_B_CTRL_prbs_err_cnt_clr(data)                            (0x00000004&((data)<<2))
+#define PRBS_B_CTRL_prbs_reverse(data)                                (0x00000002&((data)<<1))
+#define PRBS_B_CTRL_prbs7_rxen(data)                                  (0x00000001&(data))
+#define PRBS_B_CTRL_get_prbs23_rxen(data)                             ((0x10000000&(data))>>28)
+#define PRBS_B_CTRL_get_prbs_rxbist_err_cnt(data)                     ((0x0FF00000&(data))>>20)
+#define PRBS_B_CTRL_get_prbs_err_cnt(data)                            ((0x000F0000&(data))>>16)
+#define PRBS_B_CTRL_get_prbs_bit_err(data)                            ((0x00003FF0&(data))>>4)
+#define PRBS_B_CTRL_get_prbs_lock(data)                               ((0x00000008&(data))>>3)
+#define PRBS_B_CTRL_get_prbs_err_cnt_clr(data)                        ((0x00000004&(data))>>2)
+#define PRBS_B_CTRL_get_prbs_reverse(data)                            ((0x00000002&(data))>>1)
+#define PRBS_B_CTRL_get_prbs7_rxen(data)                              (0x00000001&(data))
+
+
+#define HDMI_LEADING_GB_CMP_CTRL                                      0x140
+#define HDMI_LEADING_GB_CMP_CTRL_reg_addr                             "0x98034140"
+#define HDMI_LEADING_GB_CMP_CTRL_reg                                  0x98034140
+#define HDMI_LEADING_GB_CMP_CTRL_inst_addr                            "0x0050"
+#define HDMI_LEADING_GB_CMP_CTRL_inst                                 0x0050
+#define set_HDMI_LEADING_GB_CMP_CTRL_reg(data)                        (*((volatile unsigned int*)HDMI_LEADING_GB_CMP_CTRL_reg)=data)
+#define get_HDMI_LEADING_GB_CMP_CTRL_reg                              (*((volatile unsigned int*)HDMI_LEADING_GB_CMP_CTRL_reg))
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag_shift                   (30)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en_shift                  (29)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en_shift                 (28)
+#define HDMI_LEADING_GB_CMP_CTRL_preamble_shift                       (24)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_value_shift                      (8)
+#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel_shift                   (4)
+#define HDMI_LEADING_GB_CMP_CTRL_channel_sel_shift                    (2)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti_shift                  (1)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en_shift                     (0)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag_mask                    (0x40000000)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en_mask                   (0x20000000)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en_mask                  (0x10000000)
+#define HDMI_LEADING_GB_CMP_CTRL_preamble_mask                        (0x0F000000)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_value_mask                       (0x0003FF00)
+#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel_mask                    (0x00000010)
+#define HDMI_LEADING_GB_CMP_CTRL_channel_sel_mask                     (0x0000000C)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti_mask                   (0x00000002)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en_mask                      (0x00000001)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag(data)                   (0x40000000&((data)<<30))
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en(data)                  (0x20000000&((data)<<29))
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en(data)                 (0x10000000&((data)<<28))
+#define HDMI_LEADING_GB_CMP_CTRL_preamble(data)                       (0x0F000000&((data)<<24))
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_value(data)                      (0x0003FF00&((data)<<8))
+#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel(data)                   (0x00000010&((data)<<4))
+#define HDMI_LEADING_GB_CMP_CTRL_channel_sel(data)                    (0x0000000C&((data)<<2))
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti(data)                  (0x00000002&((data)<<1))
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en(data)                     (0x00000001&(data))
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_flag(data)               ((0x40000000&(data))>>30)
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_wd_en(data)              ((0x20000000&(data))>>29)
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_int_en(data)             ((0x10000000&(data))>>28)
+#define HDMI_LEADING_GB_CMP_CTRL_get_preamble(data)                   ((0x0F000000&(data))>>24)
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_value(data)                  ((0x0003FF00&(data))>>8)
+#define HDMI_LEADING_GB_CMP_CTRL_get_dvi_mode_sel(data)               ((0x00000010&(data))>>4)
+#define HDMI_LEADING_GB_CMP_CTRL_get_channel_sel(data)                ((0x0000000C&(data))>>2)
+#define HDMI_LEADING_GB_CMP_CTRL_get_lgb_cal_conti(data)              ((0x00000002&(data))>>1)
+#define HDMI_LEADING_GB_CMP_CTRL_get_lgb_cal_en(data)                 (0x00000001&(data))
+
+
+#define HDMI_LEADING_GB_CMP_TIMES                                     0x144
+#define HDMI_LEADING_GB_CMP_TIMES_reg_addr                            "0x98034144"
+#define HDMI_LEADING_GB_CMP_TIMES_reg                                 0x98034144
+#define HDMI_LEADING_GB_CMP_TIMES_inst_addr                           "0x0051"
+#define HDMI_LEADING_GB_CMP_TIMES_inst                                0x0051
+#define set_HDMI_LEADING_GB_CMP_TIMES_reg(data)                       (*((volatile unsigned int*)HDMI_LEADING_GB_CMP_TIMES_reg)=data)
+#define get_HDMI_LEADING_GB_CMP_TIMES_reg                             (*((volatile unsigned int*)HDMI_LEADING_GB_CMP_TIMES_reg))
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt_shift                   (16)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_times_shift                     (0)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt_mask                    (0xFFFF0000)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_times_mask                      (0x0000FFFF)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt(data)                   (0xFFFF0000&((data)<<16))
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_times(data)                     (0x0000FFFF&(data))
+#define HDMI_LEADING_GB_CMP_TIMES_get_cmp_err_cnt(data)               ((0xFFFF0000&(data))>>16)
+#define HDMI_LEADING_GB_CMP_TIMES_get_cmp_times(data)                 (0x0000FFFF&(data))
+
+
+#define HDMI_LEADING_GB_CMP_CNT                                       0x148
+#define HDMI_LEADING_GB_CMP_CNT_reg_addr                              "0x98034148"
+#define HDMI_LEADING_GB_CMP_CNT_reg                                   0x98034148
+#define HDMI_LEADING_GB_CMP_CNT_inst_addr                             "0x0052"
+#define HDMI_LEADING_GB_CMP_CNT_inst                                  0x0052
+#define set_HDMI_LEADING_GB_CMP_CNT_reg(data)                         (*((volatile unsigned int*)HDMI_LEADING_GB_CMP_CNT_reg)=data)
+#define get_HDMI_LEADING_GB_CMP_CNT_reg                               (*((volatile unsigned int*)HDMI_LEADING_GB_CMP_CNT_reg))
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_shift                (16)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame_shift       (0)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_mask                 (0xFFFF0000)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame_mask        (0x0000FFFF)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt(data)                (0xFFFF0000&((data)<<16))
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame(data)       (0x0000FFFF&(data))
+#define HDMI_LEADING_GB_CMP_CNT_get_preamble_cmp_cnt(data)            ((0xFFFF0000&(data))>>16)
+#define HDMI_LEADING_GB_CMP_CNT_get_preamble_cmp_cnt_by_frame(data)   (0x0000FFFF&(data))
+
+
+#define AUDIO_CTS_UP_BOUND                                            0x14c
+#define AUDIO_CTS_UP_BOUND_reg_addr                                   "0x9803414c"
+#define AUDIO_CTS_UP_BOUND_reg                                        0x9803414c
+#define AUDIO_CTS_UP_BOUND_inst_addr                                  "0x0053"
+#define AUDIO_CTS_UP_BOUND_inst                                       0x0053
+#define set_AUDIO_CTS_UP_BOUND_reg(data)                              (*((volatile unsigned int*)AUDIO_CTS_UP_BOUND_reg)=data)
+#define get_AUDIO_CTS_UP_BOUND_reg                                    (*((volatile unsigned int*)AUDIO_CTS_UP_BOUND_reg))
+#define AUDIO_CTS_UP_BOUND_cts_over_flag_shift                        (31)
+#define AUDIO_CTS_UP_BOUND_cts_clip_en_shift                          (20)
+#define AUDIO_CTS_UP_BOUND_cts_up_bound_shift                         (0)
+#define AUDIO_CTS_UP_BOUND_cts_over_flag_mask                         (0x80000000)
+#define AUDIO_CTS_UP_BOUND_cts_clip_en_mask                           (0x00100000)
+#define AUDIO_CTS_UP_BOUND_cts_up_bound_mask                          (0x000FFFFF)
+#define AUDIO_CTS_UP_BOUND_cts_over_flag(data)                        (0x80000000&((data)<<31))
+#define AUDIO_CTS_UP_BOUND_cts_clip_en(data)                          (0x00100000&((data)<<20))
+#define AUDIO_CTS_UP_BOUND_cts_up_bound(data)                         (0x000FFFFF&(data))
+#define AUDIO_CTS_UP_BOUND_get_cts_over_flag(data)                    ((0x80000000&(data))>>31)
+#define AUDIO_CTS_UP_BOUND_get_cts_clip_en(data)                      ((0x00100000&(data))>>20)
+#define AUDIO_CTS_UP_BOUND_get_cts_up_bound(data)                     (0x000FFFFF&(data))
+
+
+#define AUDIO_CTS_LOW_BOUND                                           0x150
+#define AUDIO_CTS_LOW_BOUND_reg_addr                                  "0x98034150"
+#define AUDIO_CTS_LOW_BOUND_reg                                       0x98034150
+#define AUDIO_CTS_LOW_BOUND_inst_addr                                 "0x0054"
+#define AUDIO_CTS_LOW_BOUND_inst                                      0x0054
+#define set_AUDIO_CTS_LOW_BOUND_reg(data)                             (*((volatile unsigned int*)AUDIO_CTS_LOW_BOUND_reg)=data)
+#define get_AUDIO_CTS_LOW_BOUND_reg                                   (*((volatile unsigned int*)AUDIO_CTS_LOW_BOUND_reg))
+#define AUDIO_CTS_LOW_BOUND_cts_under_flag_shift                      (31)
+#define AUDIO_CTS_LOW_BOUND_cts_low_bound_shift                       (0)
+#define AUDIO_CTS_LOW_BOUND_cts_under_flag_mask                       (0x80000000)
+#define AUDIO_CTS_LOW_BOUND_cts_low_bound_mask                        (0x000FFFFF)
+#define AUDIO_CTS_LOW_BOUND_cts_under_flag(data)                      (0x80000000&((data)<<31))
+#define AUDIO_CTS_LOW_BOUND_cts_low_bound(data)                       (0x000FFFFF&(data))
+#define AUDIO_CTS_LOW_BOUND_get_cts_under_flag(data)                  ((0x80000000&(data))>>31)
+#define AUDIO_CTS_LOW_BOUND_get_cts_low_bound(data)                   (0x000FFFFF&(data))
+
+
+#define AUDIO_N_UP_BOUND                                              0x154
+#define AUDIO_N_UP_BOUND_reg_addr                                     "0x98034154"
+#define AUDIO_N_UP_BOUND_reg                                          0x98034154
+#define AUDIO_N_UP_BOUND_inst_addr                                    "0x0055"
+#define AUDIO_N_UP_BOUND_inst                                         0x0055
+#define set_AUDIO_N_UP_BOUND_reg(data)                                (*((volatile unsigned int*)AUDIO_N_UP_BOUND_reg)=data)
+#define get_AUDIO_N_UP_BOUND_reg                                      (*((volatile unsigned int*)AUDIO_N_UP_BOUND_reg))
+#define AUDIO_N_UP_BOUND_n_over_flag_shift                            (31)
+#define AUDIO_N_UP_BOUND_n_clip_en_shift                              (20)
+#define AUDIO_N_UP_BOUND_n_up_bound_shift                             (0)
+#define AUDIO_N_UP_BOUND_n_over_flag_mask                             (0x80000000)
+#define AUDIO_N_UP_BOUND_n_clip_en_mask                               (0x00100000)
+#define AUDIO_N_UP_BOUND_n_up_bound_mask                              (0x000FFFFF)
+#define AUDIO_N_UP_BOUND_n_over_flag(data)                            (0x80000000&((data)<<31))
+#define AUDIO_N_UP_BOUND_n_clip_en(data)                              (0x00100000&((data)<<20))
+#define AUDIO_N_UP_BOUND_n_up_bound(data)                             (0x000FFFFF&(data))
+#define AUDIO_N_UP_BOUND_get_n_over_flag(data)                        ((0x80000000&(data))>>31)
+#define AUDIO_N_UP_BOUND_get_n_clip_en(data)                          ((0x00100000&(data))>>20)
+#define AUDIO_N_UP_BOUND_get_n_up_bound(data)                         (0x000FFFFF&(data))
+
+
+#define AUDIO_N_LOW_BOUND                                             0x158
+#define AUDIO_N_LOW_BOUND_reg_addr                                    "0x98034158"
+#define AUDIO_N_LOW_BOUND_reg                                         0x98034158
+#define AUDIO_N_LOW_BOUND_inst_addr                                   "0x0056"
+#define AUDIO_N_LOW_BOUND_inst                                        0x0056
+#define set_AUDIO_N_LOW_BOUND_reg(data)                               (*((volatile unsigned int*)AUDIO_N_LOW_BOUND_reg)=data)
+#define get_AUDIO_N_LOW_BOUND_reg                                     (*((volatile unsigned int*)AUDIO_N_LOW_BOUND_reg))
+#define AUDIO_N_LOW_BOUND_n_under_flag_shift                          (31)
+#define AUDIO_N_LOW_BOUND_n_low_bound_shift                           (0)
+#define AUDIO_N_LOW_BOUND_n_under_flag_mask                           (0x80000000)
+#define AUDIO_N_LOW_BOUND_n_low_bound_mask                            (0x000FFFFF)
+#define AUDIO_N_LOW_BOUND_n_under_flag(data)                          (0x80000000&((data)<<31))
+#define AUDIO_N_LOW_BOUND_n_low_bound(data)                           (0x000FFFFF&(data))
+#define AUDIO_N_LOW_BOUND_get_n_under_flag(data)                      ((0x80000000&(data))>>31)
+#define AUDIO_N_LOW_BOUND_get_n_low_bound(data)                       (0x000FFFFF&(data))
+
+
+#define MHL_HDMI_MAC_CTRL                                             0x15c
+#define MHL_HDMI_MAC_CTRL_reg_addr                                    "0x9803415c"
+#define MHL_HDMI_MAC_CTRL_reg                                         0x9803415c
+#define MHL_HDMI_MAC_CTRL_inst_addr                                   "0x0057"
+#define MHL_HDMI_MAC_CTRL_inst                                        0x0057
+#define set_MHL_HDMI_MAC_CTRL_reg(data)                               (*((volatile unsigned int*)MHL_HDMI_MAC_CTRL_reg)=data)
+#define get_MHL_HDMI_MAC_CTRL_reg                                     (*((volatile unsigned int*)MHL_HDMI_MAC_CTRL_reg))
+#define MHL_HDMI_MAC_CTRL_hporch_offset_shift                         (16)
+#define MHL_HDMI_MAC_CTRL_dummy_15_14_shift                           (14)
+#define MHL_HDMI_MAC_CTRL_en_packet_retiming_vsrst_shift              (13)
+#define MHL_HDMI_MAC_CTRL_pp_mode_output_shift                        (12)
+#define MHL_HDMI_MAC_CTRL_packet_mhl_en_shift                         (8)
+#define MHL_HDMI_MAC_CTRL_xor_pixel_sel_shift                         (5)
+#define MHL_HDMI_MAC_CTRL_cal_pixel_sel_shift                         (4)
+#define MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_shift                     (0)
+#define MHL_HDMI_MAC_CTRL_hporch_offset_mask                          (0x03FF0000)
+#define MHL_HDMI_MAC_CTRL_dummy_15_14_mask                            (0x0000C000)
+#define MHL_HDMI_MAC_CTRL_en_packet_retiming_vsrst_mask               (0x00002000)
+#define MHL_HDMI_MAC_CTRL_pp_mode_output_mask                         (0x00001000)
+#define MHL_HDMI_MAC_CTRL_packet_mhl_en_mask                          (0x00000100)
+#define MHL_HDMI_MAC_CTRL_xor_pixel_sel_mask                          (0x000000E0)
+#define MHL_HDMI_MAC_CTRL_cal_pixel_sel_mask                          (0x00000010)
+#define MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_mask                      (0x00000001)
+#define MHL_HDMI_MAC_CTRL_hporch_offset(data)                         (0x03FF0000&((data)<<16))
+#define MHL_HDMI_MAC_CTRL_dummy_15_14(data)                           (0x0000C000&((data)<<14))
+#define MHL_HDMI_MAC_CTRL_en_packet_retiming_vsrst(data)              (0x00002000&((data)<<13))
+#define MHL_HDMI_MAC_CTRL_pp_mode_output(data)                        (0x00001000&((data)<<12))
+#define MHL_HDMI_MAC_CTRL_packet_mhl_en(data)                         (0x00000100&((data)<<8))
+#define MHL_HDMI_MAC_CTRL_xor_pixel_sel(data)                         (0x000000E0&((data)<<5))
+#define MHL_HDMI_MAC_CTRL_cal_pixel_sel(data)                         (0x00000010&((data)<<4))
+#define MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en(data)                     (0x00000001&(data))
+#define MHL_HDMI_MAC_CTRL_get_hporch_offset(data)                     ((0x03FF0000&(data))>>16)
+#define MHL_HDMI_MAC_CTRL_get_dummy_15_14(data)                       ((0x0000C000&(data))>>14)
+#define MHL_HDMI_MAC_CTRL_get_en_packet_retiming_vsrst(data)          ((0x00002000&(data))>>13)
+#define MHL_HDMI_MAC_CTRL_get_pp_mode_output(data)                    ((0x00001000&(data))>>12)
+#define MHL_HDMI_MAC_CTRL_get_packet_mhl_en(data)                     ((0x00000100&(data))>>8)
+#define MHL_HDMI_MAC_CTRL_get_xor_pixel_sel(data)                     ((0x000000E0&(data))>>5)
+#define MHL_HDMI_MAC_CTRL_get_cal_pixel_sel(data)                     ((0x00000010&(data))>>4)
+#define MHL_HDMI_MAC_CTRL_get_ch_dec_pp_mode_en(data)                 (0x00000001&(data))
+
+
+#define MHL_3D_FORMAT                                                 0x160
+#define MHL_3D_FORMAT_reg_addr                                        "0x98034160"
+#define MHL_3D_FORMAT_reg                                             0x98034160
+#define MHL_3D_FORMAT_inst_addr                                       "0x0058"
+#define MHL_3D_FORMAT_inst                                            0x0058
+#define set_MHL_3D_FORMAT_reg(data)                                   (*((volatile unsigned int*)MHL_3D_FORMAT_reg)=data)
+#define get_MHL_3D_FORMAT_reg                                         (*((volatile unsigned int*)MHL_3D_FORMAT_reg))
+#define MHL_3D_FORMAT_mhl_3d_fmt_shift                                (26)
+#define MHL_3D_FORMAT_mhl_vid_shift                                   (24)
+#define MHL_3D_FORMAT_oui_shift                                       (0)
+#define MHL_3D_FORMAT_mhl_3d_fmt_mask                                 (0x3C000000)
+#define MHL_3D_FORMAT_mhl_vid_mask                                    (0x03000000)
+#define MHL_3D_FORMAT_oui_mask                                        (0x00FFFFFF)
+#define MHL_3D_FORMAT_mhl_3d_fmt(data)                                (0x3C000000&((data)<<26))
+#define MHL_3D_FORMAT_mhl_vid(data)                                   (0x03000000&((data)<<24))
+#define MHL_3D_FORMAT_oui(data)                                       (0x00FFFFFF&(data))
+#define MHL_3D_FORMAT_get_mhl_3d_fmt(data)                            ((0x3C000000&(data))>>26)
+#define MHL_3D_FORMAT_get_mhl_vid(data)                               ((0x03000000&(data))>>24)
+#define MHL_3D_FORMAT_get_oui(data)                                   (0x00FFFFFF&(data))
+
+
+#define MHL_3P0_FORMAT0                                               0x164
+#define MHL_3P0_FORMAT0_reg_addr                                      "0x98034164"
+#define MHL_3P0_FORMAT0_reg                                           0x98034164
+#define MHL_3P0_FORMAT0_inst_addr                                     "0x0059"
+#define MHL_3P0_FORMAT0_inst                                          0x0059
+#define set_MHL_3P0_FORMAT0_reg(data)                                 (*((volatile unsigned int*)MHL_3P0_FORMAT0_reg)=data)
+#define get_MHL_3P0_FORMAT0_reg                                       (*((volatile unsigned int*)MHL_3P0_FORMAT0_reg))
+#define MHL_3P0_FORMAT0_mhl_hev_fmt_shift                             (17)
+#define MHL_3P0_FORMAT0_sep_aud_shift                                 (16)
+#define MHL_3P0_FORMAT0_mhl_hev_fmt_type_shift                        (0)
+#define MHL_3P0_FORMAT0_mhl_hev_fmt_mask                              (0x00060000)
+#define MHL_3P0_FORMAT0_sep_aud_mask                                  (0x00010000)
+#define MHL_3P0_FORMAT0_mhl_hev_fmt_type_mask                         (0x0000FFFF)
+#define MHL_3P0_FORMAT0_mhl_hev_fmt(data)                             (0x00060000&((data)<<17))
+#define MHL_3P0_FORMAT0_sep_aud(data)                                 (0x00010000&((data)<<16))
+#define MHL_3P0_FORMAT0_mhl_hev_fmt_type(data)                        (0x0000FFFF&(data))
+#define MHL_3P0_FORMAT0_get_mhl_hev_fmt(data)                         ((0x00060000&(data))>>17)
+#define MHL_3P0_FORMAT0_get_sep_aud(data)                             ((0x00010000&(data))>>16)
+#define MHL_3P0_FORMAT0_get_mhl_hev_fmt_type(data)                    (0x0000FFFF&(data))
+
+
+#define MHL_3P0_FORMAT1                                               0x168
+#define MHL_3P0_FORMAT1_reg_addr                                      "0x98034168"
+#define MHL_3P0_FORMAT1_reg                                           0x98034168
+#define MHL_3P0_FORMAT1_inst_addr                                     "0x005A"
+#define MHL_3P0_FORMAT1_inst                                          0x005A
+#define set_MHL_3P0_FORMAT1_reg(data)                                 (*((volatile unsigned int*)MHL_3P0_FORMAT1_reg)=data)
+#define get_MHL_3P0_FORMAT1_reg                                       (*((volatile unsigned int*)MHL_3P0_FORMAT1_reg))
+#define MHL_3P0_FORMAT1_acrfs_div_shift                               (21)
+#define MHL_3P0_FORMAT1_av_delay_dir_shift                            (20)
+#define MHL_3P0_FORMAT1_av_delay_sync_shift                           (0)
+#define MHL_3P0_FORMAT1_acrfs_div_mask                                (0x00E00000)
+#define MHL_3P0_FORMAT1_av_delay_dir_mask                             (0x00100000)
+#define MHL_3P0_FORMAT1_av_delay_sync_mask                            (0x000FFFFF)
+#define MHL_3P0_FORMAT1_acrfs_div(data)                               (0x00E00000&((data)<<21))
+#define MHL_3P0_FORMAT1_av_delay_dir(data)                            (0x00100000&((data)<<20))
+#define MHL_3P0_FORMAT1_av_delay_sync(data)                           (0x000FFFFF&(data))
+#define MHL_3P0_FORMAT1_get_acrfs_div(data)                           ((0x00E00000&(data))>>21)
+#define MHL_3P0_FORMAT1_get_av_delay_dir(data)                        ((0x00100000&(data))>>20)
+#define MHL_3P0_FORMAT1_get_av_delay_sync(data)                       (0x000FFFFF&(data))
+
+
+#define LIGHT_SLEEP                                                   0x170
+#define LIGHT_SLEEP_reg_addr                                          "0x98034170"
+#define LIGHT_SLEEP_reg                                               0x98034170
+#define LIGHT_SLEEP_inst_addr                                         "0x005C"
+#define LIGHT_SLEEP_inst                                              0x005C
+#define set_LIGHT_SLEEP_reg(data)                                     (*((volatile unsigned int*)LIGHT_SLEEP_reg)=data)
+#define get_LIGHT_SLEEP_reg                                           (*((volatile unsigned int*)LIGHT_SLEEP_reg))
+#define LIGHT_SLEEP_yuv420_ls3_shift                                  (8)
+#define LIGHT_SLEEP_yuv420_ls2_shift                                  (7)
+#define LIGHT_SLEEP_yuv420_ls1_shift                                  (6)
+#define LIGHT_SLEEP_yuv420_ls0_shift                                  (5)
+#define LIGHT_SLEEP_hdcp_2p2_ls1_shift                                (4)
+#define LIGHT_SLEEP_hdcp_2p2_ls0_shift                                (3)
+#define LIGHT_SLEEP_hdcp_ksvfifo_ls_shift                             (2)
+#define LIGHT_SLEEP_hdcp_ls_shift                                     (1)
+#define LIGHT_SLEEP_audio_ls_shift                                    (0)
+#define LIGHT_SLEEP_yuv420_ls3_mask                                   (0x00000100)
+#define LIGHT_SLEEP_yuv420_ls2_mask                                   (0x00000080)
+#define LIGHT_SLEEP_yuv420_ls1_mask                                   (0x00000040)
+#define LIGHT_SLEEP_yuv420_ls0_mask                                   (0x00000020)
+#define LIGHT_SLEEP_hdcp_2p2_ls1_mask                                 (0x00000010)
+#define LIGHT_SLEEP_hdcp_2p2_ls0_mask                                 (0x00000008)
+#define LIGHT_SLEEP_hdcp_ksvfifo_ls_mask                              (0x00000004)
+#define LIGHT_SLEEP_hdcp_ls_mask                                      (0x00000002)
+#define LIGHT_SLEEP_audio_ls_mask                                     (0x00000001)
+#define LIGHT_SLEEP_yuv420_ls3(data)                                  (0x00000100&((data)<<8))
+#define LIGHT_SLEEP_yuv420_ls2(data)                                  (0x00000080&((data)<<7))
+#define LIGHT_SLEEP_yuv420_ls1(data)                                  (0x00000040&((data)<<6))
+#define LIGHT_SLEEP_yuv420_ls0(data)                                  (0x00000020&((data)<<5))
+#define LIGHT_SLEEP_hdcp_2p2_ls1(data)                                (0x00000010&((data)<<4))
+#define LIGHT_SLEEP_hdcp_2p2_ls0(data)                                (0x00000008&((data)<<3))
+#define LIGHT_SLEEP_hdcp_ksvfifo_ls(data)                             (0x00000004&((data)<<2))
+#define LIGHT_SLEEP_hdcp_ls(data)                                     (0x00000002&((data)<<1))
+#define LIGHT_SLEEP_audio_ls(data)                                    (0x00000001&(data))
+#define LIGHT_SLEEP_get_yuv420_ls3(data)                              ((0x00000100&(data))>>8)
+#define LIGHT_SLEEP_get_yuv420_ls2(data)                              ((0x00000080&(data))>>7)
+#define LIGHT_SLEEP_get_yuv420_ls1(data)                              ((0x00000040&(data))>>6)
+#define LIGHT_SLEEP_get_yuv420_ls0(data)                              ((0x00000020&(data))>>5)
+#define LIGHT_SLEEP_get_hdcp_2p2_ls1(data)                            ((0x00000010&(data))>>4)
+#define LIGHT_SLEEP_get_hdcp_2p2_ls0(data)                            ((0x00000008&(data))>>3)
+#define LIGHT_SLEEP_get_hdcp_ksvfifo_ls(data)                         ((0x00000004&(data))>>2)
+#define LIGHT_SLEEP_get_hdcp_ls(data)                                 ((0x00000002&(data))>>1)
+#define LIGHT_SLEEP_get_audio_ls(data)                                (0x00000001&(data))
+
+
+#define READ_MARGIN2                                                  0x174
+#define READ_MARGIN2_reg_addr                                         "0x98034174"
+#define READ_MARGIN2_reg                                              0x98034174
+#define READ_MARGIN2_inst_addr                                        "0x005D"
+#define READ_MARGIN2_inst                                             0x005D
+#define set_READ_MARGIN2_reg(data)                                    (*((volatile unsigned int*)READ_MARGIN2_reg)=data)
+#define get_READ_MARGIN2_reg                                          (*((volatile unsigned int*)READ_MARGIN2_reg))
+#define READ_MARGIN2_yuv420_rm3_shift                                 (12)
+#define READ_MARGIN2_yuv420_rm2_shift                                 (8)
+#define READ_MARGIN2_yuv420_rm1_shift                                 (4)
+#define READ_MARGIN2_yuv420_rm0_shift                                 (0)
+#define READ_MARGIN2_yuv420_rm3_mask                                  (0x0000F000)
+#define READ_MARGIN2_yuv420_rm2_mask                                  (0x00000F00)
+#define READ_MARGIN2_yuv420_rm1_mask                                  (0x000000F0)
+#define READ_MARGIN2_yuv420_rm0_mask                                  (0x0000000F)
+#define READ_MARGIN2_yuv420_rm3(data)                                 (0x0000F000&((data)<<12))
+#define READ_MARGIN2_yuv420_rm2(data)                                 (0x00000F00&((data)<<8))
+#define READ_MARGIN2_yuv420_rm1(data)                                 (0x000000F0&((data)<<4))
+#define READ_MARGIN2_yuv420_rm0(data)                                 (0x0000000F&(data))
+#define READ_MARGIN2_get_yuv420_rm3(data)                             ((0x0000F000&(data))>>12)
+#define READ_MARGIN2_get_yuv420_rm2(data)                             ((0x00000F00&(data))>>8)
+#define READ_MARGIN2_get_yuv420_rm1(data)                             ((0x000000F0&(data))>>4)
+#define READ_MARGIN2_get_yuv420_rm0(data)                             (0x0000000F&(data))
+
+
+#define READ_MARGIN_ENABLE                                            0x178
+#define READ_MARGIN_ENABLE_reg_addr                                   "0x98034178"
+#define READ_MARGIN_ENABLE_reg                                        0x98034178
+#define READ_MARGIN_ENABLE_inst_addr                                  "0x005E"
+#define READ_MARGIN_ENABLE_inst                                       0x005E
+#define set_READ_MARGIN_ENABLE_reg(data)                              (*((volatile unsigned int*)READ_MARGIN_ENABLE_reg)=data)
+#define get_READ_MARGIN_ENABLE_reg                                    (*((volatile unsigned int*)READ_MARGIN_ENABLE_reg))
+#define READ_MARGIN_ENABLE_yuv420_rme3_shift                          (8)
+#define READ_MARGIN_ENABLE_yuv420_rme2_shift                          (7)
+#define READ_MARGIN_ENABLE_yuv420_rme1_shift                          (6)
+#define READ_MARGIN_ENABLE_yuv420_rme0_shift                          (5)
+#define READ_MARGIN_ENABLE_hdcp_2p2_rme1_shift                        (4)
+#define READ_MARGIN_ENABLE_hdcp_2p2_rme0_shift                        (3)
+#define READ_MARGIN_ENABLE_hdcp_ksvfifo_rme_shift                     (2)
+#define READ_MARGIN_ENABLE_hdcp_rme_shift                             (1)
+#define READ_MARGIN_ENABLE_audio_rme_shift                            (0)
+#define READ_MARGIN_ENABLE_yuv420_rme3_mask                           (0x00000100)
+#define READ_MARGIN_ENABLE_yuv420_rme2_mask                           (0x00000080)
+#define READ_MARGIN_ENABLE_yuv420_rme1_mask                           (0x00000040)
+#define READ_MARGIN_ENABLE_yuv420_rme0_mask                           (0x00000020)
+#define READ_MARGIN_ENABLE_hdcp_2p2_rme1_mask                         (0x00000010)
+#define READ_MARGIN_ENABLE_hdcp_2p2_rme0_mask                         (0x00000008)
+#define READ_MARGIN_ENABLE_hdcp_ksvfifo_rme_mask                      (0x00000004)
+#define READ_MARGIN_ENABLE_hdcp_rme_mask                              (0x00000002)
+#define READ_MARGIN_ENABLE_audio_rme_mask                             (0x00000001)
+#define READ_MARGIN_ENABLE_yuv420_rme3(data)                          (0x00000100&((data)<<8))
+#define READ_MARGIN_ENABLE_yuv420_rme2(data)                          (0x00000080&((data)<<7))
+#define READ_MARGIN_ENABLE_yuv420_rme1(data)                          (0x00000040&((data)<<6))
+#define READ_MARGIN_ENABLE_yuv420_rme0(data)                          (0x00000020&((data)<<5))
+#define READ_MARGIN_ENABLE_hdcp_2p2_rme1(data)                        (0x00000010&((data)<<4))
+#define READ_MARGIN_ENABLE_hdcp_2p2_rme0(data)                        (0x00000008&((data)<<3))
+#define READ_MARGIN_ENABLE_hdcp_ksvfifo_rme(data)                     (0x00000004&((data)<<2))
+#define READ_MARGIN_ENABLE_hdcp_rme(data)                             (0x00000002&((data)<<1))
+#define READ_MARGIN_ENABLE_audio_rme(data)                            (0x00000001&(data))
+#define READ_MARGIN_ENABLE_get_yuv420_rme3(data)                      ((0x00000100&(data))>>8)
+#define READ_MARGIN_ENABLE_get_yuv420_rme2(data)                      ((0x00000080&(data))>>7)
+#define READ_MARGIN_ENABLE_get_yuv420_rme1(data)                      ((0x00000040&(data))>>6)
+#define READ_MARGIN_ENABLE_get_yuv420_rme0(data)                      ((0x00000020&(data))>>5)
+#define READ_MARGIN_ENABLE_get_hdcp_2p2_rme1(data)                    ((0x00000010&(data))>>4)
+#define READ_MARGIN_ENABLE_get_hdcp_2p2_rme0(data)                    ((0x00000008&(data))>>3)
+#define READ_MARGIN_ENABLE_get_hdcp_ksvfifo_rme(data)                 ((0x00000004&(data))>>2)
+#define READ_MARGIN_ENABLE_get_hdcp_rme(data)                         ((0x00000002&(data))>>1)
+#define READ_MARGIN_ENABLE_get_audio_rme(data)                        (0x00000001&(data))
+
+
+#define READ_MARGIN                                                   0x17c
+#define READ_MARGIN_reg_addr                                          "0x9803417c"
+#define READ_MARGIN_reg                                               0x9803417c
+#define READ_MARGIN_inst_addr                                         "0x005F"
+#define READ_MARGIN_inst                                              0x005F
+#define set_READ_MARGIN_reg(data)                                     (*((volatile unsigned int*)READ_MARGIN_reg)=data)
+#define get_READ_MARGIN_reg                                           (*((volatile unsigned int*)READ_MARGIN_reg))
+#define READ_MARGIN_hdcp_2p2_rm1_shift                                (16)
+#define READ_MARGIN_hdcp_2p2_rm0_shift                                (12)
+#define READ_MARGIN_hdcp_ksvfifo_rm_shift                             (8)
+#define READ_MARGIN_hdcp_rm_shift                                     (4)
+#define READ_MARGIN_audio_rm_shift                                    (0)
+#define READ_MARGIN_hdcp_2p2_rm1_mask                                 (0x000F0000)
+#define READ_MARGIN_hdcp_2p2_rm0_mask                                 (0x0000F000)
+#define READ_MARGIN_hdcp_ksvfifo_rm_mask                              (0x00000F00)
+#define READ_MARGIN_hdcp_rm_mask                                      (0x000000F0)
+#define READ_MARGIN_audio_rm_mask                                     (0x0000000F)
+#define READ_MARGIN_hdcp_2p2_rm1(data)                                (0x000F0000&((data)<<16))
+#define READ_MARGIN_hdcp_2p2_rm0(data)                                (0x0000F000&((data)<<12))
+#define READ_MARGIN_hdcp_ksvfifo_rm(data)                             (0x00000F00&((data)<<8))
+#define READ_MARGIN_hdcp_rm(data)                                     (0x000000F0&((data)<<4))
+#define READ_MARGIN_audio_rm(data)                                    (0x0000000F&(data))
+#define READ_MARGIN_get_hdcp_2p2_rm1(data)                            ((0x000F0000&(data))>>16)
+#define READ_MARGIN_get_hdcp_2p2_rm0(data)                            ((0x0000F000&(data))>>12)
+#define READ_MARGIN_get_hdcp_ksvfifo_rm(data)                         ((0x00000F00&(data))>>8)
+#define READ_MARGIN_get_hdcp_rm(data)                                 ((0x000000F0&(data))>>4)
+#define READ_MARGIN_get_audio_rm(data)                                (0x0000000F&(data))
+
+
+#define BIST_MODE                                                     0x180
+#define BIST_MODE_reg_addr                                            "0x98034180"
+#define BIST_MODE_reg                                                 0x98034180
+#define BIST_MODE_inst_addr                                           "0x0060"
+#define BIST_MODE_inst                                                0x0060
+#define set_BIST_MODE_reg(data)                                       (*((volatile unsigned int*)BIST_MODE_reg)=data)
+#define get_BIST_MODE_reg                                             (*((volatile unsigned int*)BIST_MODE_reg))
+#define BIST_MODE_yuv420_bist_en_shift                                (4)
+#define BIST_MODE_hdcp_2p2_bist_en_shift                              (3)
+#define BIST_MODE_hdcp_ksvfifo_bist_en_shift                          (2)
+#define BIST_MODE_hdcp_bist_en_shift                                  (1)
+#define BIST_MODE_audio_bist_en_shift                                 (0)
+#define BIST_MODE_yuv420_bist_en_mask                                 (0x00000010)
+#define BIST_MODE_hdcp_2p2_bist_en_mask                               (0x00000008)
+#define BIST_MODE_hdcp_ksvfifo_bist_en_mask                           (0x00000004)
+#define BIST_MODE_hdcp_bist_en_mask                                   (0x00000002)
+#define BIST_MODE_audio_bist_en_mask                                  (0x00000001)
+#define BIST_MODE_yuv420_bist_en(data)                                (0x00000010&((data)<<4))
+#define BIST_MODE_hdcp_2p2_bist_en(data)                              (0x00000008&((data)<<3))
+#define BIST_MODE_hdcp_ksvfifo_bist_en(data)                          (0x00000004&((data)<<2))
+#define BIST_MODE_hdcp_bist_en(data)                                  (0x00000002&((data)<<1))
+#define BIST_MODE_audio_bist_en(data)                                 (0x00000001&(data))
+#define BIST_MODE_get_yuv420_bist_en(data)                            ((0x00000010&(data))>>4)
+#define BIST_MODE_get_hdcp_2p2_bist_en(data)                          ((0x00000008&(data))>>3)
+#define BIST_MODE_get_hdcp_ksvfifo_bist_en(data)                      ((0x00000004&(data))>>2)
+#define BIST_MODE_get_hdcp_bist_en(data)                              ((0x00000002&(data))>>1)
+#define BIST_MODE_get_audio_bist_en(data)                             (0x00000001&(data))
+
+
+#define BIST_DONE                                                     0x184
+#define BIST_DONE_reg_addr                                            "0x98034184"
+#define BIST_DONE_reg                                                 0x98034184
+#define BIST_DONE_inst_addr                                           "0x0061"
+#define BIST_DONE_inst                                                0x0061
+#define set_BIST_DONE_reg(data)                                       (*((volatile unsigned int*)BIST_DONE_reg)=data)
+#define get_BIST_DONE_reg                                             (*((volatile unsigned int*)BIST_DONE_reg))
+#define BIST_DONE_yuv420_bist_done_shift                              (4)
+#define BIST_DONE_hdcp_2p2_bist_done_shift                            (3)
+#define BIST_DONE_hdcp_ksvfifo_bist_done_shift                        (2)
+#define BIST_DONE_hdcp_bist_done_shift                                (1)
+#define BIST_DONE_audio_bist_done_shift                               (0)
+#define BIST_DONE_yuv420_bist_done_mask                               (0x00000010)
+#define BIST_DONE_hdcp_2p2_bist_done_mask                             (0x00000008)
+#define BIST_DONE_hdcp_ksvfifo_bist_done_mask                         (0x00000004)
+#define BIST_DONE_hdcp_bist_done_mask                                 (0x00000002)
+#define BIST_DONE_audio_bist_done_mask                                (0x00000001)
+#define BIST_DONE_yuv420_bist_done(data)                              (0x00000010&((data)<<4))
+#define BIST_DONE_hdcp_2p2_bist_done(data)                            (0x00000008&((data)<<3))
+#define BIST_DONE_hdcp_ksvfifo_bist_done(data)                        (0x00000004&((data)<<2))
+#define BIST_DONE_hdcp_bist_done(data)                                (0x00000002&((data)<<1))
+#define BIST_DONE_audio_bist_done(data)                               (0x00000001&(data))
+#define BIST_DONE_get_yuv420_bist_done(data)                          ((0x00000010&(data))>>4)
+#define BIST_DONE_get_hdcp_2p2_bist_done(data)                        ((0x00000008&(data))>>3)
+#define BIST_DONE_get_hdcp_ksvfifo_bist_done(data)                    ((0x00000004&(data))>>2)
+#define BIST_DONE_get_hdcp_bist_done(data)                            ((0x00000002&(data))>>1)
+#define BIST_DONE_get_audio_bist_done(data)                           (0x00000001&(data))
+
+
+#define BIST_FAIL                                                     0x188
+#define BIST_FAIL_reg_addr                                            "0x98034188"
+#define BIST_FAIL_reg                                                 0x98034188
+#define BIST_FAIL_inst_addr                                           "0x0062"
+#define BIST_FAIL_inst                                                0x0062
+#define set_BIST_FAIL_reg(data)                                       (*((volatile unsigned int*)BIST_FAIL_reg)=data)
+#define get_BIST_FAIL_reg                                             (*((volatile unsigned int*)BIST_FAIL_reg))
+#define BIST_FAIL_yuv420_bist_fail_shift                              (4)
+#define BIST_FAIL_hdcp_2p2_bist_fail_shift                            (3)
+#define BIST_FAIL_hdcp_ksvfifo_bist_fail_shift                        (2)
+#define BIST_FAIL_hdcp_bist_fail_shift                                (1)
+#define BIST_FAIL_audio_bist_fail_shift                               (0)
+#define BIST_FAIL_yuv420_bist_fail_mask                               (0x00000010)
+#define BIST_FAIL_hdcp_2p2_bist_fail_mask                             (0x00000008)
+#define BIST_FAIL_hdcp_ksvfifo_bist_fail_mask                         (0x00000004)
+#define BIST_FAIL_hdcp_bist_fail_mask                                 (0x00000002)
+#define BIST_FAIL_audio_bist_fail_mask                                (0x00000001)
+#define BIST_FAIL_yuv420_bist_fail(data)                              (0x00000010&((data)<<4))
+#define BIST_FAIL_hdcp_2p2_bist_fail(data)                            (0x00000008&((data)<<3))
+#define BIST_FAIL_hdcp_ksvfifo_bist_fail(data)                        (0x00000004&((data)<<2))
+#define BIST_FAIL_hdcp_bist_fail(data)                                (0x00000002&((data)<<1))
+#define BIST_FAIL_audio_bist_fail(data)                               (0x00000001&(data))
+#define BIST_FAIL_get_yuv420_bist_fail(data)                          ((0x00000010&(data))>>4)
+#define BIST_FAIL_get_hdcp_2p2_bist_fail(data)                        ((0x00000008&(data))>>3)
+#define BIST_FAIL_get_hdcp_ksvfifo_bist_fail(data)                    ((0x00000004&(data))>>2)
+#define BIST_FAIL_get_hdcp_bist_fail(data)                            ((0x00000002&(data))>>1)
+#define BIST_FAIL_get_audio_bist_fail(data)                           (0x00000001&(data))
+
+
+#define DRF_MODE                                                      0x18c
+#define DRF_MODE_reg_addr                                             "0x9803418c"
+#define DRF_MODE_reg                                                  0x9803418c
+#define DRF_MODE_inst_addr                                            "0x0063"
+#define DRF_MODE_inst                                                 0x0063
+#define set_DRF_MODE_reg(data)                                        (*((volatile unsigned int*)DRF_MODE_reg)=data)
+#define get_DRF_MODE_reg                                              (*((volatile unsigned int*)DRF_MODE_reg))
+#define DRF_MODE_yuv420_drf_mode_shift                                (4)
+#define DRF_MODE_hdcp_2p2_drf_mode_shift                              (3)
+#define DRF_MODE_hdcp_ksvfifo_drf_mode_shift                          (2)
+#define DRF_MODE_hdcp_drf_mode_shift                                  (1)
+#define DRF_MODE_audio_drf_mode_shift                                 (0)
+#define DRF_MODE_yuv420_drf_mode_mask                                 (0x00000010)
+#define DRF_MODE_hdcp_2p2_drf_mode_mask                               (0x00000008)
+#define DRF_MODE_hdcp_ksvfifo_drf_mode_mask                           (0x00000004)
+#define DRF_MODE_hdcp_drf_mode_mask                                   (0x00000002)
+#define DRF_MODE_audio_drf_mode_mask                                  (0x00000001)
+#define DRF_MODE_yuv420_drf_mode(data)                                (0x00000010&((data)<<4))
+#define DRF_MODE_hdcp_2p2_drf_mode(data)                              (0x00000008&((data)<<3))
+#define DRF_MODE_hdcp_ksvfifo_drf_mode(data)                          (0x00000004&((data)<<2))
+#define DRF_MODE_hdcp_drf_mode(data)                                  (0x00000002&((data)<<1))
+#define DRF_MODE_audio_drf_mode(data)                                 (0x00000001&(data))
+#define DRF_MODE_get_yuv420_drf_mode(data)                            ((0x00000010&(data))>>4)
+#define DRF_MODE_get_hdcp_2p2_drf_mode(data)                          ((0x00000008&(data))>>3)
+#define DRF_MODE_get_hdcp_ksvfifo_drf_mode(data)                      ((0x00000004&(data))>>2)
+#define DRF_MODE_get_hdcp_drf_mode(data)                              ((0x00000002&(data))>>1)
+#define DRF_MODE_get_audio_drf_mode(data)                             (0x00000001&(data))
+
+
+#define DRF_RESUME                                                    0x190
+#define DRF_RESUME_reg_addr                                           "0x98034190"
+#define DRF_RESUME_reg                                                0x98034190
+#define DRF_RESUME_inst_addr                                          "0x0064"
+#define DRF_RESUME_inst                                               0x0064
+#define set_DRF_RESUME_reg(data)                                      (*((volatile unsigned int*)DRF_RESUME_reg)=data)
+#define get_DRF_RESUME_reg                                            (*((volatile unsigned int*)DRF_RESUME_reg))
+#define DRF_RESUME_yuv420_drf_resume_shift                            (4)
+#define DRF_RESUME_hdcp_2p2_drf_resume_shift                          (3)
+#define DRF_RESUME_hdcp_ksvfifo_drf_resume_shift                      (2)
+#define DRF_RESUME_hdcp_drf_resume_shift                              (1)
+#define DRF_RESUME_audio_drf_resume_shift                             (0)
+#define DRF_RESUME_yuv420_drf_resume_mask                             (0x00000010)
+#define DRF_RESUME_hdcp_2p2_drf_resume_mask                           (0x00000008)
+#define DRF_RESUME_hdcp_ksvfifo_drf_resume_mask                       (0x00000004)
+#define DRF_RESUME_hdcp_drf_resume_mask                               (0x00000002)
+#define DRF_RESUME_audio_drf_resume_mask                              (0x00000001)
+#define DRF_RESUME_yuv420_drf_resume(data)                            (0x00000010&((data)<<4))
+#define DRF_RESUME_hdcp_2p2_drf_resume(data)                          (0x00000008&((data)<<3))
+#define DRF_RESUME_hdcp_ksvfifo_drf_resume(data)                      (0x00000004&((data)<<2))
+#define DRF_RESUME_hdcp_drf_resume(data)                              (0x00000002&((data)<<1))
+#define DRF_RESUME_audio_drf_resume(data)                             (0x00000001&(data))
+#define DRF_RESUME_get_yuv420_drf_resume(data)                        ((0x00000010&(data))>>4)
+#define DRF_RESUME_get_hdcp_2p2_drf_resume(data)                      ((0x00000008&(data))>>3)
+#define DRF_RESUME_get_hdcp_ksvfifo_drf_resume(data)                  ((0x00000004&(data))>>2)
+#define DRF_RESUME_get_hdcp_drf_resume(data)                          ((0x00000002&(data))>>1)
+#define DRF_RESUME_get_audio_drf_resume(data)                         (0x00000001&(data))
+
+
+#define DRF_DONE                                                      0x194
+#define DRF_DONE_reg_addr                                             "0x98034194"
+#define DRF_DONE_reg                                                  0x98034194
+#define DRF_DONE_inst_addr                                            "0x0065"
+#define DRF_DONE_inst                                                 0x0065
+#define set_DRF_DONE_reg(data)                                        (*((volatile unsigned int*)DRF_DONE_reg)=data)
+#define get_DRF_DONE_reg                                              (*((volatile unsigned int*)DRF_DONE_reg))
+#define DRF_DONE_yuv420_drf_done_shift                                (4)
+#define DRF_DONE_hdcp_2p2_drf_done_shift                              (3)
+#define DRF_DONE_hdcp_ksvfifo_drf_done_shift                          (2)
+#define DRF_DONE_hdcp_drf_done_shift                                  (1)
+#define DRF_DONE_audio_drf_done_shift                                 (0)
+#define DRF_DONE_yuv420_drf_done_mask                                 (0x00000010)
+#define DRF_DONE_hdcp_2p2_drf_done_mask                               (0x00000008)
+#define DRF_DONE_hdcp_ksvfifo_drf_done_mask                           (0x00000004)
+#define DRF_DONE_hdcp_drf_done_mask                                   (0x00000002)
+#define DRF_DONE_audio_drf_done_mask                                  (0x00000001)
+#define DRF_DONE_yuv420_drf_done(data)                                (0x00000010&((data)<<4))
+#define DRF_DONE_hdcp_2p2_drf_done(data)                              (0x00000008&((data)<<3))
+#define DRF_DONE_hdcp_ksvfifo_drf_done(data)                          (0x00000004&((data)<<2))
+#define DRF_DONE_hdcp_drf_done(data)                                  (0x00000002&((data)<<1))
+#define DRF_DONE_audio_drf_done(data)                                 (0x00000001&(data))
+#define DRF_DONE_get_yuv420_drf_done(data)                            ((0x00000010&(data))>>4)
+#define DRF_DONE_get_hdcp_2p2_drf_done(data)                          ((0x00000008&(data))>>3)
+#define DRF_DONE_get_hdcp_ksvfifo_drf_done(data)                      ((0x00000004&(data))>>2)
+#define DRF_DONE_get_hdcp_drf_done(data)                              ((0x00000002&(data))>>1)
+#define DRF_DONE_get_audio_drf_done(data)                             (0x00000001&(data))
+
+
+#define DRF_PAUSE                                                     0x198
+#define DRF_PAUSE_reg_addr                                            "0x98034198"
+#define DRF_PAUSE_reg                                                 0x98034198
+#define DRF_PAUSE_inst_addr                                           "0x0066"
+#define DRF_PAUSE_inst                                                0x0066
+#define set_DRF_PAUSE_reg(data)                                       (*((volatile unsigned int*)DRF_PAUSE_reg)=data)
+#define get_DRF_PAUSE_reg                                             (*((volatile unsigned int*)DRF_PAUSE_reg))
+#define DRF_PAUSE_yuv420_drf_pause_shift                              (4)
+#define DRF_PAUSE_hdcp_2p2_drf_pause_shift                            (3)
+#define DRF_PAUSE_hdcp_ksvfifo_drf_pause_shift                        (2)
+#define DRF_PAUSE_hdcp_drf_pause_shift                                (1)
+#define DRF_PAUSE_audio_drf_pause_shift                               (0)
+#define DRF_PAUSE_yuv420_drf_pause_mask                               (0x00000010)
+#define DRF_PAUSE_hdcp_2p2_drf_pause_mask                             (0x00000008)
+#define DRF_PAUSE_hdcp_ksvfifo_drf_pause_mask                         (0x00000004)
+#define DRF_PAUSE_hdcp_drf_pause_mask                                 (0x00000002)
+#define DRF_PAUSE_audio_drf_pause_mask                                (0x00000001)
+#define DRF_PAUSE_yuv420_drf_pause(data)                              (0x00000010&((data)<<4))
+#define DRF_PAUSE_hdcp_2p2_drf_pause(data)                            (0x00000008&((data)<<3))
+#define DRF_PAUSE_hdcp_ksvfifo_drf_pause(data)                        (0x00000004&((data)<<2))
+#define DRF_PAUSE_hdcp_drf_pause(data)                                (0x00000002&((data)<<1))
+#define DRF_PAUSE_audio_drf_pause(data)                               (0x00000001&(data))
+#define DRF_PAUSE_get_yuv420_drf_pause(data)                          ((0x00000010&(data))>>4)
+#define DRF_PAUSE_get_hdcp_2p2_drf_pause(data)                        ((0x00000008&(data))>>3)
+#define DRF_PAUSE_get_hdcp_ksvfifo_drf_pause(data)                    ((0x00000004&(data))>>2)
+#define DRF_PAUSE_get_hdcp_drf_pause(data)                            ((0x00000002&(data))>>1)
+#define DRF_PAUSE_get_audio_drf_pause(data)                           (0x00000001&(data))
+
+
+#define DRF_FAIL                                                      0x19c
+#define DRF_FAIL_reg_addr                                             "0x9803419c"
+#define DRF_FAIL_reg                                                  0x9803419c
+#define DRF_FAIL_inst_addr                                            "0x0067"
+#define DRF_FAIL_inst                                                 0x0067
+#define set_DRF_FAIL_reg(data)                                        (*((volatile unsigned int*)DRF_FAIL_reg)=data)
+#define get_DRF_FAIL_reg                                              (*((volatile unsigned int*)DRF_FAIL_reg))
+#define DRF_FAIL_yuv420_drf_fail_shift                                (4)
+#define DRF_FAIL_hdcp_2p2_drf_fail_shift                              (3)
+#define DRF_FAIL_hdcp_ksvfifo_drf_fail_shift                          (2)
+#define DRF_FAIL_hdcp_drf_fail_shift                                  (1)
+#define DRF_FAIL_audio_drf_fail_shift                                 (0)
+#define DRF_FAIL_yuv420_drf_fail_mask                                 (0x00000010)
+#define DRF_FAIL_hdcp_2p2_drf_fail_mask                               (0x00000008)
+#define DRF_FAIL_hdcp_ksvfifo_drf_fail_mask                           (0x00000004)
+#define DRF_FAIL_hdcp_drf_fail_mask                                   (0x00000002)
+#define DRF_FAIL_audio_drf_fail_mask                                  (0x00000001)
+#define DRF_FAIL_yuv420_drf_fail(data)                                (0x00000010&((data)<<4))
+#define DRF_FAIL_hdcp_2p2_drf_fail(data)                              (0x00000008&((data)<<3))
+#define DRF_FAIL_hdcp_ksvfifo_drf_fail(data)                          (0x00000004&((data)<<2))
+#define DRF_FAIL_hdcp_drf_fail(data)                                  (0x00000002&((data)<<1))
+#define DRF_FAIL_audio_drf_fail(data)                                 (0x00000001&(data))
+#define DRF_FAIL_get_yuv420_drf_fail(data)                            ((0x00000010&(data))>>4)
+#define DRF_FAIL_get_hdcp_2p2_drf_fail(data)                          ((0x00000008&(data))>>3)
+#define DRF_FAIL_get_hdcp_ksvfifo_drf_fail(data)                      ((0x00000004&(data))>>2)
+#define DRF_FAIL_get_hdcp_drf_fail(data)                              ((0x00000002&(data))>>1)
+#define DRF_FAIL_get_audio_drf_fail(data)                             (0x00000001&(data))
+
+
+#define PHY_FIFO_CR                                                   0x1a0
+#define PHY_FIFO_CR_reg_addr                                          "0x980341a0"
+#define PHY_FIFO_CR_reg                                               0x980341a0
+#define PHY_FIFO_CR_inst_addr                                         "0x0068"
+#define PHY_FIFO_CR_inst                                              0x0068
+#define set_PHY_FIFO_CR_reg(data)                                     (*((volatile unsigned int*)PHY_FIFO_CR_reg)=data)
+#define get_PHY_FIFO_CR_reg                                           (*((volatile unsigned int*)PHY_FIFO_CR_reg))
+#define PHY_FIFO_CR_port2_rclk_inv_shift                              (30)
+#define PHY_FIFO_CR_port2_gclk_inv_shift                              (29)
+#define PHY_FIFO_CR_port2_bclk_inv_shift                              (28)
+#define PHY_FIFO_CR_port1_rclk_inv_shift                              (27)
+#define PHY_FIFO_CR_port1_gclk_inv_shift                              (26)
+#define PHY_FIFO_CR_port1_bclk_inv_shift                              (25)
+#define PHY_FIFO_CR_port0_rclk_inv_shift                              (24)
+#define PHY_FIFO_CR_port0_gclk_inv_shift                              (23)
+#define PHY_FIFO_CR_port0_bclk_inv_shift                              (22)
+#define PHY_FIFO_CR_port_sel_shift                                    (20)
+#define PHY_FIFO_CR_port2_r_flush_shift                               (19)
+#define PHY_FIFO_CR_port2_r_afifo_en_shift                            (18)
+#define PHY_FIFO_CR_port2_g_flush_shift                               (17)
+#define PHY_FIFO_CR_port2_g_afifo_en_shift                            (16)
+#define PHY_FIFO_CR_port2_b_flush_shift                               (15)
+#define PHY_FIFO_CR_port2_b_afifo_en_shift                            (14)
+#define PHY_FIFO_CR_dummy_13_shift                                    (13)
+#define PHY_FIFO_CR_port1_r_flush_shift                               (12)
+#define PHY_FIFO_CR_port1_r_afifo_en_shift                            (11)
+#define PHY_FIFO_CR_port1_g_flush_shift                               (10)
+#define PHY_FIFO_CR_port1_g_afifo_en_shift                            (9)
+#define PHY_FIFO_CR_port1_b_flush_shift                               (8)
+#define PHY_FIFO_CR_port1_b_afifo_en_shift                            (7)
+#define PHY_FIFO_CR_dummy_6_shift                                     (6)
+#define PHY_FIFO_CR_port0_r_flush_shift                               (5)
+#define PHY_FIFO_CR_port0_r_afifo_en_shift                            (4)
+#define PHY_FIFO_CR_port0_g_flush_shift                               (3)
+#define PHY_FIFO_CR_port0_g_afifo_en_shift                            (2)
+#define PHY_FIFO_CR_port0_b_flush_shift                               (1)
+#define PHY_FIFO_CR_port0_b_afifo_en_shift                            (0)
+#define PHY_FIFO_CR_port2_rclk_inv_mask                               (0x40000000)
+#define PHY_FIFO_CR_port2_gclk_inv_mask                               (0x20000000)
+#define PHY_FIFO_CR_port2_bclk_inv_mask                               (0x10000000)
+#define PHY_FIFO_CR_port1_rclk_inv_mask                               (0x08000000)
+#define PHY_FIFO_CR_port1_gclk_inv_mask                               (0x04000000)
+#define PHY_FIFO_CR_port1_bclk_inv_mask                               (0x02000000)
+#define PHY_FIFO_CR_port0_rclk_inv_mask                               (0x01000000)
+#define PHY_FIFO_CR_port0_gclk_inv_mask                               (0x00800000)
+#define PHY_FIFO_CR_port0_bclk_inv_mask                               (0x00400000)
+#define PHY_FIFO_CR_port_sel_mask                                     (0x00300000)
+#define PHY_FIFO_CR_port2_r_flush_mask                                (0x00080000)
+#define PHY_FIFO_CR_port2_r_afifo_en_mask                             (0x00040000)
+#define PHY_FIFO_CR_port2_g_flush_mask                                (0x00020000)
+#define PHY_FIFO_CR_port2_g_afifo_en_mask                             (0x00010000)
+#define PHY_FIFO_CR_port2_b_flush_mask                                (0x00008000)
+#define PHY_FIFO_CR_port2_b_afifo_en_mask                             (0x00004000)
+#define PHY_FIFO_CR_dummy_13_mask                                     (0x00002000)
+#define PHY_FIFO_CR_port1_r_flush_mask                                (0x00001000)
+#define PHY_FIFO_CR_port1_r_afifo_en_mask                             (0x00000800)
+#define PHY_FIFO_CR_port1_g_flush_mask                                (0x00000400)
+#define PHY_FIFO_CR_port1_g_afifo_en_mask                             (0x00000200)
+#define PHY_FIFO_CR_port1_b_flush_mask                                (0x00000100)
+#define PHY_FIFO_CR_port1_b_afifo_en_mask                             (0x00000080)
+#define PHY_FIFO_CR_dummy_6_mask                                      (0x00000040)
+#define PHY_FIFO_CR_port0_r_flush_mask                                (0x00000020)
+#define PHY_FIFO_CR_port0_r_afifo_en_mask                             (0x00000010)
+#define PHY_FIFO_CR_port0_g_flush_mask                                (0x00000008)
+#define PHY_FIFO_CR_port0_g_afifo_en_mask                             (0x00000004)
+#define PHY_FIFO_CR_port0_b_flush_mask                                (0x00000002)
+#define PHY_FIFO_CR_port0_b_afifo_en_mask                             (0x00000001)
+#define PHY_FIFO_CR_port2_rclk_inv(data)                              (0x40000000&((data)<<30))
+#define PHY_FIFO_CR_port2_gclk_inv(data)                              (0x20000000&((data)<<29))
+#define PHY_FIFO_CR_port2_bclk_inv(data)                              (0x10000000&((data)<<28))
+#define PHY_FIFO_CR_port1_rclk_inv(data)                              (0x08000000&((data)<<27))
+#define PHY_FIFO_CR_port1_gclk_inv(data)                              (0x04000000&((data)<<26))
+#define PHY_FIFO_CR_port1_bclk_inv(data)                              (0x02000000&((data)<<25))
+#define PHY_FIFO_CR_port0_rclk_inv(data)                              (0x01000000&((data)<<24))
+#define PHY_FIFO_CR_port0_gclk_inv(data)                              (0x00800000&((data)<<23))
+#define PHY_FIFO_CR_port0_bclk_inv(data)                              (0x00400000&((data)<<22))
+#define PHY_FIFO_CR_port_sel(data)                                    (0x00300000&((data)<<20))
+#define PHY_FIFO_CR_port2_r_flush(data)                               (0x00080000&((data)<<19))
+#define PHY_FIFO_CR_port2_r_afifo_en(data)                            (0x00040000&((data)<<18))
+#define PHY_FIFO_CR_port2_g_flush(data)                               (0x00020000&((data)<<17))
+#define PHY_FIFO_CR_port2_g_afifo_en(data)                            (0x00010000&((data)<<16))
+#define PHY_FIFO_CR_port2_b_flush(data)                               (0x00008000&((data)<<15))
+#define PHY_FIFO_CR_port2_b_afifo_en(data)                            (0x00004000&((data)<<14))
+#define PHY_FIFO_CR_dummy_13(data)                                    (0x00002000&((data)<<13))
+#define PHY_FIFO_CR_port1_r_flush(data)                               (0x00001000&((data)<<12))
+#define PHY_FIFO_CR_port1_r_afifo_en(data)                            (0x00000800&((data)<<11))
+#define PHY_FIFO_CR_port1_g_flush(data)                               (0x00000400&((data)<<10))
+#define PHY_FIFO_CR_port1_g_afifo_en(data)                            (0x00000200&((data)<<9))
+#define PHY_FIFO_CR_port1_b_flush(data)                               (0x00000100&((data)<<8))
+#define PHY_FIFO_CR_port1_b_afifo_en(data)                            (0x00000080&((data)<<7))
+#define PHY_FIFO_CR_dummy_6(data)                                     (0x00000040&((data)<<6))
+#define PHY_FIFO_CR_port0_r_flush(data)                               (0x00000020&((data)<<5))
+#define PHY_FIFO_CR_port0_r_afifo_en(data)                            (0x00000010&((data)<<4))
+#define PHY_FIFO_CR_port0_g_flush(data)                               (0x00000008&((data)<<3))
+#define PHY_FIFO_CR_port0_g_afifo_en(data)                            (0x00000004&((data)<<2))
+#define PHY_FIFO_CR_port0_b_flush(data)                               (0x00000002&((data)<<1))
+#define PHY_FIFO_CR_port0_b_afifo_en(data)                            (0x00000001&(data))
+#define PHY_FIFO_CR_get_port2_rclk_inv(data)                          ((0x40000000&(data))>>30)
+#define PHY_FIFO_CR_get_port2_gclk_inv(data)                          ((0x20000000&(data))>>29)
+#define PHY_FIFO_CR_get_port2_bclk_inv(data)                          ((0x10000000&(data))>>28)
+#define PHY_FIFO_CR_get_port1_rclk_inv(data)                          ((0x08000000&(data))>>27)
+#define PHY_FIFO_CR_get_port1_gclk_inv(data)                          ((0x04000000&(data))>>26)
+#define PHY_FIFO_CR_get_port1_bclk_inv(data)                          ((0x02000000&(data))>>25)
+#define PHY_FIFO_CR_get_port0_rclk_inv(data)                          ((0x01000000&(data))>>24)
+#define PHY_FIFO_CR_get_port0_gclk_inv(data)                          ((0x00800000&(data))>>23)
+#define PHY_FIFO_CR_get_port0_bclk_inv(data)                          ((0x00400000&(data))>>22)
+#define PHY_FIFO_CR_get_port_sel(data)                                ((0x00300000&(data))>>20)
+#define PHY_FIFO_CR_get_port2_r_flush(data)                           ((0x00080000&(data))>>19)
+#define PHY_FIFO_CR_get_port2_r_afifo_en(data)                        ((0x00040000&(data))>>18)
+#define PHY_FIFO_CR_get_port2_g_flush(data)                           ((0x00020000&(data))>>17)
+#define PHY_FIFO_CR_get_port2_g_afifo_en(data)                        ((0x00010000&(data))>>16)
+#define PHY_FIFO_CR_get_port2_b_flush(data)                           ((0x00008000&(data))>>15)
+#define PHY_FIFO_CR_get_port2_b_afifo_en(data)                        ((0x00004000&(data))>>14)
+#define PHY_FIFO_CR_get_dummy_13(data)                                ((0x00002000&(data))>>13)
+#define PHY_FIFO_CR_get_port1_r_flush(data)                           ((0x00001000&(data))>>12)
+#define PHY_FIFO_CR_get_port1_r_afifo_en(data)                        ((0x00000800&(data))>>11)
+#define PHY_FIFO_CR_get_port1_g_flush(data)                           ((0x00000400&(data))>>10)
+#define PHY_FIFO_CR_get_port1_g_afifo_en(data)                        ((0x00000200&(data))>>9)
+#define PHY_FIFO_CR_get_port1_b_flush(data)                           ((0x00000100&(data))>>8)
+#define PHY_FIFO_CR_get_port1_b_afifo_en(data)                        ((0x00000080&(data))>>7)
+#define PHY_FIFO_CR_get_dummy_6(data)                                 ((0x00000040&(data))>>6)
+#define PHY_FIFO_CR_get_port0_r_flush(data)                           ((0x00000020&(data))>>5)
+#define PHY_FIFO_CR_get_port0_r_afifo_en(data)                        ((0x00000010&(data))>>4)
+#define PHY_FIFO_CR_get_port0_g_flush(data)                           ((0x00000008&(data))>>3)
+#define PHY_FIFO_CR_get_port0_g_afifo_en(data)                        ((0x00000004&(data))>>2)
+#define PHY_FIFO_CR_get_port0_b_flush(data)                           ((0x00000002&(data))>>1)
+#define PHY_FIFO_CR_get_port0_b_afifo_en(data)                        (0x00000001&(data))
+
+
+#define PHY_FIFO_SR0                                                  0x1a4
+#define PHY_FIFO_SR0_reg_addr                                         "0x980341a4"
+#define PHY_FIFO_SR0_reg                                              0x980341a4
+#define PHY_FIFO_SR0_inst_addr                                        "0x0069"
+#define PHY_FIFO_SR0_inst                                             0x0069
+#define set_PHY_FIFO_SR0_reg(data)                                    (*((volatile unsigned int*)PHY_FIFO_SR0_reg)=data)
+#define get_PHY_FIFO_SR0_reg                                          (*((volatile unsigned int*)PHY_FIFO_SR0_reg))
+#define PHY_FIFO_SR0_port1_r_wrclk_det_timeout_flag_shift             (29)
+#define PHY_FIFO_SR0_port1_r_rwclk_det_timeout_flag_shift             (28)
+#define PHY_FIFO_SR0_port1_r_wovflow_flag_shift                       (27)
+#define PHY_FIFO_SR0_port1_r_rudflow_flag_shift                       (26)
+#define PHY_FIFO_SR0_port1_r_rflush_flag_shift                        (25)
+#define PHY_FIFO_SR0_port1_g_wrclk_det_timeout_flag_shift             (24)
+#define PHY_FIFO_SR0_port1_g_rwclk_det_timeout_flag_shift             (23)
+#define PHY_FIFO_SR0_port1_g_wovflow_flag_shift                       (22)
+#define PHY_FIFO_SR0_port1_g_rudflow_flag_shift                       (21)
+#define PHY_FIFO_SR0_port1_g_rflush_flag_shift                        (20)
+#define PHY_FIFO_SR0_port1_b_wrclk_det_timeout_flag_shift             (19)
+#define PHY_FIFO_SR0_port1_b_rwclk_det_timeout_flag_shift             (18)
+#define PHY_FIFO_SR0_port1_b_wovflow_flag_shift                       (17)
+#define PHY_FIFO_SR0_port1_b_rudflow_flag_shift                       (16)
+#define PHY_FIFO_SR0_port1_b_rflush_flag_shift                        (15)
+#define PHY_FIFO_SR0_port0_r_wrclk_det_timeout_flag_shift             (14)
+#define PHY_FIFO_SR0_port0_r_rwclk_det_timeout_flag_shift             (13)
+#define PHY_FIFO_SR0_port0_r_wovflow_flag_shift                       (12)
+#define PHY_FIFO_SR0_port0_r_rudflow_flag_shift                       (11)
+#define PHY_FIFO_SR0_port0_r_rflush_flag_shift                        (10)
+#define PHY_FIFO_SR0_port0_g_wrclk_det_timeout_flag_shift             (9)
+#define PHY_FIFO_SR0_port0_g_rwclk_det_timeout_flag_shift             (8)
+#define PHY_FIFO_SR0_port0_g_wovflow_flag_shift                       (7)
+#define PHY_FIFO_SR0_port0_g_rudflow_flag_shift                       (6)
+#define PHY_FIFO_SR0_port0_g_rflush_flag_shift                        (5)
+#define PHY_FIFO_SR0_port0_b_wrclk_det_timeout_flag_shift             (4)
+#define PHY_FIFO_SR0_port0_b_rwclk_det_timeout_flag_shift             (3)
+#define PHY_FIFO_SR0_port0_b_wovflow_flag_shift                       (2)
+#define PHY_FIFO_SR0_port0_b_rudflow_flag_shift                       (1)
+#define PHY_FIFO_SR0_port0_b_rflush_flag_shift                        (0)
+#define PHY_FIFO_SR0_port1_r_wrclk_det_timeout_flag_mask              (0x20000000)
+#define PHY_FIFO_SR0_port1_r_rwclk_det_timeout_flag_mask              (0x10000000)
+#define PHY_FIFO_SR0_port1_r_wovflow_flag_mask                        (0x08000000)
+#define PHY_FIFO_SR0_port1_r_rudflow_flag_mask                        (0x04000000)
+#define PHY_FIFO_SR0_port1_r_rflush_flag_mask                         (0x02000000)
+#define PHY_FIFO_SR0_port1_g_wrclk_det_timeout_flag_mask              (0x01000000)
+#define PHY_FIFO_SR0_port1_g_rwclk_det_timeout_flag_mask              (0x00800000)
+#define PHY_FIFO_SR0_port1_g_wovflow_flag_mask                        (0x00400000)
+#define PHY_FIFO_SR0_port1_g_rudflow_flag_mask                        (0x00200000)
+#define PHY_FIFO_SR0_port1_g_rflush_flag_mask                         (0x00100000)
+#define PHY_FIFO_SR0_port1_b_wrclk_det_timeout_flag_mask              (0x00080000)
+#define PHY_FIFO_SR0_port1_b_rwclk_det_timeout_flag_mask              (0x00040000)
+#define PHY_FIFO_SR0_port1_b_wovflow_flag_mask                        (0x00020000)
+#define PHY_FIFO_SR0_port1_b_rudflow_flag_mask                        (0x00010000)
+#define PHY_FIFO_SR0_port1_b_rflush_flag_mask                         (0x00008000)
+#define PHY_FIFO_SR0_port0_r_wrclk_det_timeout_flag_mask              (0x00004000)
+#define PHY_FIFO_SR0_port0_r_rwclk_det_timeout_flag_mask              (0x00002000)
+#define PHY_FIFO_SR0_port0_r_wovflow_flag_mask                        (0x00001000)
+#define PHY_FIFO_SR0_port0_r_rudflow_flag_mask                        (0x00000800)
+#define PHY_FIFO_SR0_port0_r_rflush_flag_mask                         (0x00000400)
+#define PHY_FIFO_SR0_port0_g_wrclk_det_timeout_flag_mask              (0x00000200)
+#define PHY_FIFO_SR0_port0_g_rwclk_det_timeout_flag_mask              (0x00000100)
+#define PHY_FIFO_SR0_port0_g_wovflow_flag_mask                        (0x00000080)
+#define PHY_FIFO_SR0_port0_g_rudflow_flag_mask                        (0x00000040)
+#define PHY_FIFO_SR0_port0_g_rflush_flag_mask                         (0x00000020)
+#define PHY_FIFO_SR0_port0_b_wrclk_det_timeout_flag_mask              (0x00000010)
+#define PHY_FIFO_SR0_port0_b_rwclk_det_timeout_flag_mask              (0x00000008)
+#define PHY_FIFO_SR0_port0_b_wovflow_flag_mask                        (0x00000004)
+#define PHY_FIFO_SR0_port0_b_rudflow_flag_mask                        (0x00000002)
+#define PHY_FIFO_SR0_port0_b_rflush_flag_mask                         (0x00000001)
+#define PHY_FIFO_SR0_port1_r_wrclk_det_timeout_flag(data)             (0x20000000&((data)<<29))
+#define PHY_FIFO_SR0_port1_r_rwclk_det_timeout_flag(data)             (0x10000000&((data)<<28))
+#define PHY_FIFO_SR0_port1_r_wovflow_flag(data)                       (0x08000000&((data)<<27))
+#define PHY_FIFO_SR0_port1_r_rudflow_flag(data)                       (0x04000000&((data)<<26))
+#define PHY_FIFO_SR0_port1_r_rflush_flag(data)                        (0x02000000&((data)<<25))
+#define PHY_FIFO_SR0_port1_g_wrclk_det_timeout_flag(data)             (0x01000000&((data)<<24))
+#define PHY_FIFO_SR0_port1_g_rwclk_det_timeout_flag(data)             (0x00800000&((data)<<23))
+#define PHY_FIFO_SR0_port1_g_wovflow_flag(data)                       (0x00400000&((data)<<22))
+#define PHY_FIFO_SR0_port1_g_rudflow_flag(data)                       (0x00200000&((data)<<21))
+#define PHY_FIFO_SR0_port1_g_rflush_flag(data)                        (0x00100000&((data)<<20))
+#define PHY_FIFO_SR0_port1_b_wrclk_det_timeout_flag(data)             (0x00080000&((data)<<19))
+#define PHY_FIFO_SR0_port1_b_rwclk_det_timeout_flag(data)             (0x00040000&((data)<<18))
+#define PHY_FIFO_SR0_port1_b_wovflow_flag(data)                       (0x00020000&((data)<<17))
+#define PHY_FIFO_SR0_port1_b_rudflow_flag(data)                       (0x00010000&((data)<<16))
+#define PHY_FIFO_SR0_port1_b_rflush_flag(data)                        (0x00008000&((data)<<15))
+#define PHY_FIFO_SR0_port0_r_wrclk_det_timeout_flag(data)             (0x00004000&((data)<<14))
+#define PHY_FIFO_SR0_port0_r_rwclk_det_timeout_flag(data)             (0x00002000&((data)<<13))
+#define PHY_FIFO_SR0_port0_r_wovflow_flag(data)                       (0x00001000&((data)<<12))
+#define PHY_FIFO_SR0_port0_r_rudflow_flag(data)                       (0x00000800&((data)<<11))
+#define PHY_FIFO_SR0_port0_r_rflush_flag(data)                        (0x00000400&((data)<<10))
+#define PHY_FIFO_SR0_port0_g_wrclk_det_timeout_flag(data)             (0x00000200&((data)<<9))
+#define PHY_FIFO_SR0_port0_g_rwclk_det_timeout_flag(data)             (0x00000100&((data)<<8))
+#define PHY_FIFO_SR0_port0_g_wovflow_flag(data)                       (0x00000080&((data)<<7))
+#define PHY_FIFO_SR0_port0_g_rudflow_flag(data)                       (0x00000040&((data)<<6))
+#define PHY_FIFO_SR0_port0_g_rflush_flag(data)                        (0x00000020&((data)<<5))
+#define PHY_FIFO_SR0_port0_b_wrclk_det_timeout_flag(data)             (0x00000010&((data)<<4))
+#define PHY_FIFO_SR0_port0_b_rwclk_det_timeout_flag(data)             (0x00000008&((data)<<3))
+#define PHY_FIFO_SR0_port0_b_wovflow_flag(data)                       (0x00000004&((data)<<2))
+#define PHY_FIFO_SR0_port0_b_rudflow_flag(data)                       (0x00000002&((data)<<1))
+#define PHY_FIFO_SR0_port0_b_rflush_flag(data)                        (0x00000001&(data))
+#define PHY_FIFO_SR0_get_port1_r_wrclk_det_timeout_flag(data)         ((0x20000000&(data))>>29)
+#define PHY_FIFO_SR0_get_port1_r_rwclk_det_timeout_flag(data)         ((0x10000000&(data))>>28)
+#define PHY_FIFO_SR0_get_port1_r_wovflow_flag(data)                   ((0x08000000&(data))>>27)
+#define PHY_FIFO_SR0_get_port1_r_rudflow_flag(data)                   ((0x04000000&(data))>>26)
+#define PHY_FIFO_SR0_get_port1_r_rflush_flag(data)                    ((0x02000000&(data))>>25)
+#define PHY_FIFO_SR0_get_port1_g_wrclk_det_timeout_flag(data)         ((0x01000000&(data))>>24)
+#define PHY_FIFO_SR0_get_port1_g_rwclk_det_timeout_flag(data)         ((0x00800000&(data))>>23)
+#define PHY_FIFO_SR0_get_port1_g_wovflow_flag(data)                   ((0x00400000&(data))>>22)
+#define PHY_FIFO_SR0_get_port1_g_rudflow_flag(data)                   ((0x00200000&(data))>>21)
+#define PHY_FIFO_SR0_get_port1_g_rflush_flag(data)                    ((0x00100000&(data))>>20)
+#define PHY_FIFO_SR0_get_port1_b_wrclk_det_timeout_flag(data)         ((0x00080000&(data))>>19)
+#define PHY_FIFO_SR0_get_port1_b_rwclk_det_timeout_flag(data)         ((0x00040000&(data))>>18)
+#define PHY_FIFO_SR0_get_port1_b_wovflow_flag(data)                   ((0x00020000&(data))>>17)
+#define PHY_FIFO_SR0_get_port1_b_rudflow_flag(data)                   ((0x00010000&(data))>>16)
+#define PHY_FIFO_SR0_get_port1_b_rflush_flag(data)                    ((0x00008000&(data))>>15)
+#define PHY_FIFO_SR0_get_port0_r_wrclk_det_timeout_flag(data)         ((0x00004000&(data))>>14)
+#define PHY_FIFO_SR0_get_port0_r_rwclk_det_timeout_flag(data)         ((0x00002000&(data))>>13)
+#define PHY_FIFO_SR0_get_port0_r_wovflow_flag(data)                   ((0x00001000&(data))>>12)
+#define PHY_FIFO_SR0_get_port0_r_rudflow_flag(data)                   ((0x00000800&(data))>>11)
+#define PHY_FIFO_SR0_get_port0_r_rflush_flag(data)                    ((0x00000400&(data))>>10)
+#define PHY_FIFO_SR0_get_port0_g_wrclk_det_timeout_flag(data)         ((0x00000200&(data))>>9)
+#define PHY_FIFO_SR0_get_port0_g_rwclk_det_timeout_flag(data)         ((0x00000100&(data))>>8)
+#define PHY_FIFO_SR0_get_port0_g_wovflow_flag(data)                   ((0x00000080&(data))>>7)
+#define PHY_FIFO_SR0_get_port0_g_rudflow_flag(data)                   ((0x00000040&(data))>>6)
+#define PHY_FIFO_SR0_get_port0_g_rflush_flag(data)                    ((0x00000020&(data))>>5)
+#define PHY_FIFO_SR0_get_port0_b_wrclk_det_timeout_flag(data)         ((0x00000010&(data))>>4)
+#define PHY_FIFO_SR0_get_port0_b_rwclk_det_timeout_flag(data)         ((0x00000008&(data))>>3)
+#define PHY_FIFO_SR0_get_port0_b_wovflow_flag(data)                   ((0x00000004&(data))>>2)
+#define PHY_FIFO_SR0_get_port0_b_rudflow_flag(data)                   ((0x00000002&(data))>>1)
+#define PHY_FIFO_SR0_get_port0_b_rflush_flag(data)                    (0x00000001&(data))
+
+
+#define PHY_FIFO_SR1                                                  0x1a8
+#define PHY_FIFO_SR1_reg_addr                                         "0x980341a8"
+#define PHY_FIFO_SR1_reg                                              0x980341a8
+#define PHY_FIFO_SR1_inst_addr                                        "0x006A"
+#define PHY_FIFO_SR1_inst                                             0x006A
+#define set_PHY_FIFO_SR1_reg(data)                                    (*((volatile unsigned int*)PHY_FIFO_SR1_reg)=data)
+#define get_PHY_FIFO_SR1_reg                                          (*((volatile unsigned int*)PHY_FIFO_SR1_reg))
+#define PHY_FIFO_SR1_port2_r_wrclk_det_timeout_flag_shift             (14)
+#define PHY_FIFO_SR1_port2_r_rwclk_det_timeout_flag_shift             (13)
+#define PHY_FIFO_SR1_port2_r_wovflow_flag_shift                       (12)
+#define PHY_FIFO_SR1_port2_r_rudflow_flag_shift                       (11)
+#define PHY_FIFO_SR1_port2_r_rflush_flag_shift                        (10)
+#define PHY_FIFO_SR1_port2_g_wrclk_det_timeout_flag_shift             (9)
+#define PHY_FIFO_SR1_port2_g_rwclk_det_timeout_flag_shift             (8)
+#define PHY_FIFO_SR1_port2_g_wovflow_flag_shift                       (7)
+#define PHY_FIFO_SR1_port2_g_rudflow_flag_shift                       (6)
+#define PHY_FIFO_SR1_port2_g_rflush_flag_shift                        (5)
+#define PHY_FIFO_SR1_port2_b_wrclk_det_timeout_flag_shift             (4)
+#define PHY_FIFO_SR1_port2_b_rwclk_det_timeout_flag_shift             (3)
+#define PHY_FIFO_SR1_port2_b_wovflow_flag_shift                       (2)
+#define PHY_FIFO_SR1_port2_b_rudflow_flag_shift                       (1)
+#define PHY_FIFO_SR1_port2_b_rflush_flag_shift                        (0)
+#define PHY_FIFO_SR1_port2_r_wrclk_det_timeout_flag_mask              (0x00004000)
+#define PHY_FIFO_SR1_port2_r_rwclk_det_timeout_flag_mask              (0x00002000)
+#define PHY_FIFO_SR1_port2_r_wovflow_flag_mask                        (0x00001000)
+#define PHY_FIFO_SR1_port2_r_rudflow_flag_mask                        (0x00000800)
+#define PHY_FIFO_SR1_port2_r_rflush_flag_mask                         (0x00000400)
+#define PHY_FIFO_SR1_port2_g_wrclk_det_timeout_flag_mask              (0x00000200)
+#define PHY_FIFO_SR1_port2_g_rwclk_det_timeout_flag_mask              (0x00000100)
+#define PHY_FIFO_SR1_port2_g_wovflow_flag_mask                        (0x00000080)
+#define PHY_FIFO_SR1_port2_g_rudflow_flag_mask                        (0x00000040)
+#define PHY_FIFO_SR1_port2_g_rflush_flag_mask                         (0x00000020)
+#define PHY_FIFO_SR1_port2_b_wrclk_det_timeout_flag_mask              (0x00000010)
+#define PHY_FIFO_SR1_port2_b_rwclk_det_timeout_flag_mask              (0x00000008)
+#define PHY_FIFO_SR1_port2_b_wovflow_flag_mask                        (0x00000004)
+#define PHY_FIFO_SR1_port2_b_rudflow_flag_mask                        (0x00000002)
+#define PHY_FIFO_SR1_port2_b_rflush_flag_mask                         (0x00000001)
+#define PHY_FIFO_SR1_port2_r_wrclk_det_timeout_flag(data)             (0x00004000&((data)<<14))
+#define PHY_FIFO_SR1_port2_r_rwclk_det_timeout_flag(data)             (0x00002000&((data)<<13))
+#define PHY_FIFO_SR1_port2_r_wovflow_flag(data)                       (0x00001000&((data)<<12))
+#define PHY_FIFO_SR1_port2_r_rudflow_flag(data)                       (0x00000800&((data)<<11))
+#define PHY_FIFO_SR1_port2_r_rflush_flag(data)                        (0x00000400&((data)<<10))
+#define PHY_FIFO_SR1_port2_g_wrclk_det_timeout_flag(data)             (0x00000200&((data)<<9))
+#define PHY_FIFO_SR1_port2_g_rwclk_det_timeout_flag(data)             (0x00000100&((data)<<8))
+#define PHY_FIFO_SR1_port2_g_wovflow_flag(data)                       (0x00000080&((data)<<7))
+#define PHY_FIFO_SR1_port2_g_rudflow_flag(data)                       (0x00000040&((data)<<6))
+#define PHY_FIFO_SR1_port2_g_rflush_flag(data)                        (0x00000020&((data)<<5))
+#define PHY_FIFO_SR1_port2_b_wrclk_det_timeout_flag(data)             (0x00000010&((data)<<4))
+#define PHY_FIFO_SR1_port2_b_rwclk_det_timeout_flag(data)             (0x00000008&((data)<<3))
+#define PHY_FIFO_SR1_port2_b_wovflow_flag(data)                       (0x00000004&((data)<<2))
+#define PHY_FIFO_SR1_port2_b_rudflow_flag(data)                       (0x00000002&((data)<<1))
+#define PHY_FIFO_SR1_port2_b_rflush_flag(data)                        (0x00000001&(data))
+#define PHY_FIFO_SR1_get_port2_r_wrclk_det_timeout_flag(data)         ((0x00004000&(data))>>14)
+#define PHY_FIFO_SR1_get_port2_r_rwclk_det_timeout_flag(data)         ((0x00002000&(data))>>13)
+#define PHY_FIFO_SR1_get_port2_r_wovflow_flag(data)                   ((0x00001000&(data))>>12)
+#define PHY_FIFO_SR1_get_port2_r_rudflow_flag(data)                   ((0x00000800&(data))>>11)
+#define PHY_FIFO_SR1_get_port2_r_rflush_flag(data)                    ((0x00000400&(data))>>10)
+#define PHY_FIFO_SR1_get_port2_g_wrclk_det_timeout_flag(data)         ((0x00000200&(data))>>9)
+#define PHY_FIFO_SR1_get_port2_g_rwclk_det_timeout_flag(data)         ((0x00000100&(data))>>8)
+#define PHY_FIFO_SR1_get_port2_g_wovflow_flag(data)                   ((0x00000080&(data))>>7)
+#define PHY_FIFO_SR1_get_port2_g_rudflow_flag(data)                   ((0x00000040&(data))>>6)
+#define PHY_FIFO_SR1_get_port2_g_rflush_flag(data)                    ((0x00000020&(data))>>5)
+#define PHY_FIFO_SR1_get_port2_b_wrclk_det_timeout_flag(data)         ((0x00000010&(data))>>4)
+#define PHY_FIFO_SR1_get_port2_b_rwclk_det_timeout_flag(data)         ((0x00000008&(data))>>3)
+#define PHY_FIFO_SR1_get_port2_b_wovflow_flag(data)                   ((0x00000004&(data))>>2)
+#define PHY_FIFO_SR1_get_port2_b_rudflow_flag(data)                   ((0x00000002&(data))>>1)
+#define PHY_FIFO_SR1_get_port2_b_rflush_flag(data)                    (0x00000001&(data))
+
+
+#define HDMI_CTS_FIFO_CTL                                             0x1ac
+#define HDMI_CTS_FIFO_CTL_reg_addr                                    "0x980341ac"
+#define HDMI_CTS_FIFO_CTL_reg                                         0x980341ac
+#define HDMI_CTS_FIFO_CTL_inst_addr                                   "0x006B"
+#define HDMI_CTS_FIFO_CTL_inst                                        0x006B
+#define set_HDMI_CTS_FIFO_CTL_reg(data)                               (*((volatile unsigned int*)HDMI_CTS_FIFO_CTL_reg)=data)
+#define get_HDMI_CTS_FIFO_CTL_reg                                     (*((volatile unsigned int*)HDMI_CTS_FIFO_CTL_reg))
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_r_shift       (17)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_r_shift        (16)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_g_shift       (15)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_g_shift        (14)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_b_shift       (13)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_b_shift        (12)
+#define HDMI_CTS_FIFO_CTL_dummy_11_shift                              (11)
+#define HDMI_CTS_FIFO_CTL_debug_select_shift                          (10)
+#define HDMI_CTS_FIFO_CTL_hdmi_2x_out_sel_shift                       (8)
+#define HDMI_CTS_FIFO_CTL_hdmi_test_sel_shift                         (4)
+#define HDMI_CTS_FIFO_CTL_hdmi_out_sel_shift                          (3)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi_shift               (2)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi_shift                 (1)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi_shift                (0)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_r_mask        (0x00020000)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_r_mask         (0x00010000)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_g_mask        (0x00008000)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_g_mask         (0x00004000)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_b_mask        (0x00002000)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_b_mask         (0x00001000)
+#define HDMI_CTS_FIFO_CTL_dummy_11_mask                               (0x00000800)
+#define HDMI_CTS_FIFO_CTL_debug_select_mask                           (0x00000400)
+#define HDMI_CTS_FIFO_CTL_hdmi_2x_out_sel_mask                        (0x00000300)
+#define HDMI_CTS_FIFO_CTL_hdmi_test_sel_mask                          (0x000000F0)
+#define HDMI_CTS_FIFO_CTL_hdmi_out_sel_mask                           (0x00000008)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi_mask                (0x00000004)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi_mask                  (0x00000002)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi_mask                 (0x00000001)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_r(data)       (0x00020000&((data)<<17))
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_r(data)        (0x00010000&((data)<<16))
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_g(data)       (0x00008000&((data)<<15))
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_g(data)        (0x00004000&((data)<<14))
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_b(data)       (0x00002000&((data)<<13))
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_b(data)        (0x00001000&((data)<<12))
+#define HDMI_CTS_FIFO_CTL_dummy_11(data)                              (0x00000800&((data)<<11))
+#define HDMI_CTS_FIFO_CTL_debug_select(data)                          (0x00000400&((data)<<10))
+#define HDMI_CTS_FIFO_CTL_hdmi_2x_out_sel(data)                       (0x00000300&((data)<<8))
+#define HDMI_CTS_FIFO_CTL_hdmi_test_sel(data)                         (0x000000F0&((data)<<4))
+#define HDMI_CTS_FIFO_CTL_hdmi_out_sel(data)                          (0x00000008&((data)<<3))
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi(data)               (0x00000004&((data)<<2))
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi(data)                 (0x00000002&((data)<<1))
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi(data)                (0x00000001&(data))
+#define HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_phy_dbgout_r(data)   ((0x00020000&(data))>>17)
+#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_phy_dbgout_r(data)    ((0x00010000&(data))>>16)
+#define HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_phy_dbgout_g(data)   ((0x00008000&(data))>>15)
+#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_phy_dbgout_g(data)    ((0x00004000&(data))>>14)
+#define HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_phy_dbgout_b(data)   ((0x00002000&(data))>>13)
+#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_phy_dbgout_b(data)    ((0x00001000&(data))>>12)
+#define HDMI_CTS_FIFO_CTL_get_dummy_11(data)                          ((0x00000800&(data))>>11)
+#define HDMI_CTS_FIFO_CTL_get_debug_select(data)                      ((0x00000400&(data))>>10)
+#define HDMI_CTS_FIFO_CTL_get_hdmi_2x_out_sel(data)                   ((0x00000300&(data))>>8)
+#define HDMI_CTS_FIFO_CTL_get_hdmi_test_sel(data)                     ((0x000000F0&(data))>>4)
+#define HDMI_CTS_FIFO_CTL_get_hdmi_out_sel(data)                      ((0x00000008&(data))>>3)
+#define HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_hdmi(data)           ((0x00000004&(data))>>2)
+#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_vsrst_hdmi(data)             ((0x00000002&(data))>>1)
+#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_hdmi(data)            (0x00000001&(data))
+
+
+#define CBUS_CLK_CTL                                                  0x1b0
+#define CBUS_CLK_CTL_reg_addr                                         "0x980341b0"
+#define CBUS_CLK_CTL_reg                                              0x980341b0
+#define CBUS_CLK_CTL_inst_addr                                        "0x006C"
+#define CBUS_CLK_CTL_inst                                             0x006C
+#define set_CBUS_CLK_CTL_reg(data)                                    (*((volatile unsigned int*)CBUS_CLK_CTL_reg)=data)
+#define get_CBUS_CLK_CTL_reg                                          (*((volatile unsigned int*)CBUS_CLK_CTL_reg))
+#define CBUS_CLK_CTL_dummy_6_4_shift                                  (4)
+#define CBUS_CLK_CTL_dummy_1_shift                                    (1)
+#define CBUS_CLK_CTL_dummy_0_shift                                    (0)
+#define CBUS_CLK_CTL_dummy_6_4_mask                                   (0x00000070)
+#define CBUS_CLK_CTL_dummy_1_mask                                     (0x00000002)
+#define CBUS_CLK_CTL_dummy_0_mask                                     (0x00000001)
+#define CBUS_CLK_CTL_dummy_6_4(data)                                  (0x00000070&((data)<<4))
+#define CBUS_CLK_CTL_dummy_1(data)                                    (0x00000002&((data)<<1))
+#define CBUS_CLK_CTL_dummy_0(data)                                    (0x00000001&(data))
+#define CBUS_CLK_CTL_get_dummy_6_4(data)                              ((0x00000070&(data))>>4)
+#define CBUS_CLK_CTL_get_dummy_1(data)                                ((0x00000002&(data))>>1)
+#define CBUS_CLK_CTL_get_dummy_0(data)                                (0x00000001&(data))
+
+
+#define HDMI_2P0_CR                                                   0x1b4
+#define HDMI_2P0_CR_reg_addr                                          "0x980341b4"
+#define HDMI_2P0_CR_reg                                               0x980341b4
+#define HDMI_2P0_CR_inst_addr                                         "0x006D"
+#define HDMI_2P0_CR_inst                                              0x006D
+#define set_HDMI_2P0_CR_reg(data)                                     (*((volatile unsigned int*)HDMI_2P0_CR_reg)=data)
+#define get_HDMI_2P0_CR_reg                                           (*((volatile unsigned int*)HDMI_2P0_CR_reg))
+#define HDMI_2P0_CR_gating_en_shift                                   (8)
+#define HDMI_2P0_CR_ctr_char_num_shift                                (1)
+#define HDMI_2P0_CR_hdmi_2p0_en_shift                                 (0)
+#define HDMI_2P0_CR_gating_en_mask                                    (0x00000100)
+#define HDMI_2P0_CR_ctr_char_num_mask                                 (0x000000FE)
+#define HDMI_2P0_CR_hdmi_2p0_en_mask                                  (0x00000001)
+#define HDMI_2P0_CR_gating_en(data)                                   (0x00000100&((data)<<8))
+#define HDMI_2P0_CR_ctr_char_num(data)                                (0x000000FE&((data)<<1))
+#define HDMI_2P0_CR_hdmi_2p0_en(data)                                 (0x00000001&(data))
+#define HDMI_2P0_CR_get_gating_en(data)                               ((0x00000100&(data))>>8)
+#define HDMI_2P0_CR_get_ctr_char_num(data)                            ((0x000000FE&(data))>>1)
+#define HDMI_2P0_CR_get_hdmi_2p0_en(data)                             (0x00000001&(data))
+
+
+#define SCR_CR                                                        0x1b8
+#define SCR_CR_reg_addr                                               "0x980341b8"
+#define SCR_CR_reg                                                    0x980341b8
+#define SCR_CR_inst_addr                                              "0x006E"
+#define SCR_CR_inst                                                   0x006E
+#define set_SCR_CR_reg(data)                                          (*((volatile unsigned int*)SCR_CR_reg)=data)
+#define get_SCR_CR_reg                                                (*((volatile unsigned int*)SCR_CR_reg))
+#define SCR_CR_char_lock_shift                                        (17)
+#define SCR_CR_uscr_fall_bound_err_r_shift                            (16)
+#define SCR_CR_uscr_fall_bound_err_g_shift                            (15)
+#define SCR_CR_uscr_fall_bound_err_b_shift                            (14)
+#define SCR_CR_uscr_per_glitch_r_shift                                (13)
+#define SCR_CR_uscr_per_glitch_g_shift                                (12)
+#define SCR_CR_uscr_per_glitch_b_shift                                (11)
+#define SCR_CR_uscr_char_flag_r_shift                                 (10)
+#define SCR_CR_uscr_char_flag_g_shift                                 (9)
+#define SCR_CR_uscr_char_flag_b_shift                                 (8)
+#define SCR_CR_uscr_num_shift                                         (4)
+#define SCR_CR_dummy_3_2_shift                                        (2)
+#define SCR_CR_scr_en_fw_shift                                        (1)
+#define SCR_CR_scr_auto_shift                                         (0)
+#define SCR_CR_char_lock_mask                                         (0x00020000)
+#define SCR_CR_uscr_fall_bound_err_r_mask                             (0x00010000)
+#define SCR_CR_uscr_fall_bound_err_g_mask                             (0x00008000)
+#define SCR_CR_uscr_fall_bound_err_b_mask                             (0x00004000)
+#define SCR_CR_uscr_per_glitch_r_mask                                 (0x00002000)
+#define SCR_CR_uscr_per_glitch_g_mask                                 (0x00001000)
+#define SCR_CR_uscr_per_glitch_b_mask                                 (0x00000800)
+#define SCR_CR_uscr_char_flag_r_mask                                  (0x00000400)
+#define SCR_CR_uscr_char_flag_g_mask                                  (0x00000200)
+#define SCR_CR_uscr_char_flag_b_mask                                  (0x00000100)
+#define SCR_CR_uscr_num_mask                                          (0x000000F0)
+#define SCR_CR_dummy_3_2_mask                                         (0x0000000C)
+#define SCR_CR_scr_en_fw_mask                                         (0x00000002)
+#define SCR_CR_scr_auto_mask                                          (0x00000001)
+#define SCR_CR_char_lock(data)                                        (0x00020000&((data)<<17))
+#define SCR_CR_uscr_fall_bound_err_r(data)                            (0x00010000&((data)<<16))
+#define SCR_CR_uscr_fall_bound_err_g(data)                            (0x00008000&((data)<<15))
+#define SCR_CR_uscr_fall_bound_err_b(data)                            (0x00004000&((data)<<14))
+#define SCR_CR_uscr_per_glitch_r(data)                                (0x00002000&((data)<<13))
+#define SCR_CR_uscr_per_glitch_g(data)                                (0x00001000&((data)<<12))
+#define SCR_CR_uscr_per_glitch_b(data)                                (0x00000800&((data)<<11))
+#define SCR_CR_uscr_char_flag_r(data)                                 (0x00000400&((data)<<10))
+#define SCR_CR_uscr_char_flag_g(data)                                 (0x00000200&((data)<<9))
+#define SCR_CR_uscr_char_flag_b(data)                                 (0x00000100&((data)<<8))
+#define SCR_CR_uscr_num(data)                                         (0x000000F0&((data)<<4))
+#define SCR_CR_dummy_3_2(data)                                        (0x0000000C&((data)<<2))
+#define SCR_CR_scr_en_fw(data)                                        (0x00000002&((data)<<1))
+#define SCR_CR_scr_auto(data)                                         (0x00000001&(data))
+#define SCR_CR_get_char_lock(data)                                    ((0x00020000&(data))>>17)
+#define SCR_CR_get_uscr_fall_bound_err_r(data)                        ((0x00010000&(data))>>16)
+#define SCR_CR_get_uscr_fall_bound_err_g(data)                        ((0x00008000&(data))>>15)
+#define SCR_CR_get_uscr_fall_bound_err_b(data)                        ((0x00004000&(data))>>14)
+#define SCR_CR_get_uscr_per_glitch_r(data)                            ((0x00002000&(data))>>13)
+#define SCR_CR_get_uscr_per_glitch_g(data)                            ((0x00001000&(data))>>12)
+#define SCR_CR_get_uscr_per_glitch_b(data)                            ((0x00000800&(data))>>11)
+#define SCR_CR_get_uscr_char_flag_r(data)                             ((0x00000400&(data))>>10)
+#define SCR_CR_get_uscr_char_flag_g(data)                             ((0x00000200&(data))>>9)
+#define SCR_CR_get_uscr_char_flag_b(data)                             ((0x00000100&(data))>>8)
+#define SCR_CR_get_uscr_num(data)                                     ((0x000000F0&(data))>>4)
+#define SCR_CR_get_dummy_3_2(data)                                    ((0x0000000C&(data))>>2)
+#define SCR_CR_get_scr_en_fw(data)                                    ((0x00000002&(data))>>1)
+#define SCR_CR_get_scr_auto(data)                                     (0x00000001&(data))
+
+
+#define CERCR                                                         0x1bc
+#define CERCR_reg_addr                                                "0x980341bc"
+#define CERCR_reg                                                     0x980341bc
+#define CERCR_inst_addr                                               "0x006F"
+#define CERCR_inst                                                    0x006F
+#define set_CERCR_reg(data)                                           (*((volatile unsigned int*)CERCR_reg)=data)
+#define get_CERCR_reg                                                 (*((volatile unsigned int*)CERCR_reg))
+#define CERCR_ch_locked_reset_shift                                   (28)
+#define CERCR_ch2_over_max_err_num_shift                              (27)
+#define CERCR_ch1_over_max_err_num_shift                              (26)
+#define CERCR_ch0_over_max_err_num_shift                              (25)
+#define CERCR_max_err_num_shift                                       (15)
+#define CERCR_valid_reset_shift                                       (14)
+#define CERCR_reset_err_det_shift                                     (13)
+#define CERCR_keep_err_det_shift                                      (12)
+#define CERCR_refer_implem_shift                                      (11)
+#define CERCR_reset_shift                                             (10)
+#define CERCR_period_shift                                            (4)
+#define CERCR_dummy_3_2_shift                                         (2)
+#define CERCR_mode_shift                                              (1)
+#define CERCR_en_shift                                                (0)
+#define CERCR_ch_locked_reset_mask                                    (0x10000000)
+#define CERCR_ch2_over_max_err_num_mask                               (0x08000000)
+#define CERCR_ch1_over_max_err_num_mask                               (0x04000000)
+#define CERCR_ch0_over_max_err_num_mask                               (0x02000000)
+#define CERCR_max_err_num_mask                                        (0x01FF8000)
+#define CERCR_valid_reset_mask                                        (0x00004000)
+#define CERCR_reset_err_det_mask                                      (0x00002000)
+#define CERCR_keep_err_det_mask                                       (0x00001000)
+#define CERCR_refer_implem_mask                                       (0x00000800)
+#define CERCR_reset_mask                                              (0x00000400)
+#define CERCR_period_mask                                             (0x000003F0)
+#define CERCR_dummy_3_2_mask                                          (0x0000000C)
+#define CERCR_mode_mask                                               (0x00000002)
+#define CERCR_en_mask                                                 (0x00000001)
+#define CERCR_ch_locked_reset(data)                                   (0x10000000&((data)<<28))
+#define CERCR_ch2_over_max_err_num(data)                              (0x08000000&((data)<<27))
+#define CERCR_ch1_over_max_err_num(data)                              (0x04000000&((data)<<26))
+#define CERCR_ch0_over_max_err_num(data)                              (0x02000000&((data)<<25))
+#define CERCR_max_err_num(data)                                       (0x01FF8000&((data)<<15))
+#define CERCR_valid_reset(data)                                       (0x00004000&((data)<<14))
+#define CERCR_reset_err_det(data)                                     (0x00002000&((data)<<13))
+#define CERCR_keep_err_det(data)                                      (0x00001000&((data)<<12))
+#define CERCR_refer_implem(data)                                      (0x00000800&((data)<<11))
+#define CERCR_reset(data)                                             (0x00000400&((data)<<10))
+#define CERCR_period(data)                                            (0x000003F0&((data)<<4))
+#define CERCR_dummy_3_2(data)                                         (0x0000000C&((data)<<2))
+#define CERCR_mode(data)                                              (0x00000002&((data)<<1))
+#define CERCR_en(data)                                                (0x00000001&(data))
+#define CERCR_get_ch_locked_reset(data)                               ((0x10000000&(data))>>28)
+#define CERCR_get_ch2_over_max_err_num(data)                          ((0x08000000&(data))>>27)
+#define CERCR_get_ch1_over_max_err_num(data)                          ((0x04000000&(data))>>26)
+#define CERCR_get_ch0_over_max_err_num(data)                          ((0x02000000&(data))>>25)
+#define CERCR_get_max_err_num(data)                                   ((0x01FF8000&(data))>>15)
+#define CERCR_get_valid_reset(data)                                   ((0x00004000&(data))>>14)
+#define CERCR_get_reset_err_det(data)                                 ((0x00002000&(data))>>13)
+#define CERCR_get_keep_err_det(data)                                  ((0x00001000&(data))>>12)
+#define CERCR_get_refer_implem(data)                                  ((0x00000800&(data))>>11)
+#define CERCR_get_reset(data)                                         ((0x00000400&(data))>>10)
+#define CERCR_get_period(data)                                        ((0x000003F0&(data))>>4)
+#define CERCR_get_dummy_3_2(data)                                     ((0x0000000C&(data))>>2)
+#define CERCR_get_mode(data)                                          ((0x00000002&(data))>>1)
+#define CERCR_get_en(data)                                            (0x00000001&(data))
+
+
+#define CERSR0                                                        0x1c0
+#define CERSR0_reg_addr                                               "0x980341c0"
+#define CERSR0_reg                                                    0x980341c0
+#define CERSR0_inst_addr                                              "0x0070"
+#define CERSR0_inst                                                   0x0070
+#define set_CERSR0_reg(data)                                          (*((volatile unsigned int*)CERSR0_reg)=data)
+#define get_CERSR0_reg                                                (*((volatile unsigned int*)CERSR0_reg))
+#define CERSR0_err_cnt1_video_shift                                   (16)
+#define CERSR0_err_cnt0_video_shift                                   (0)
+#define CERSR0_err_cnt1_video_mask                                    (0x7FFF0000)
+#define CERSR0_err_cnt0_video_mask                                    (0x00007FFF)
+#define CERSR0_err_cnt1_video(data)                                   (0x7FFF0000&((data)<<16))
+#define CERSR0_err_cnt0_video(data)                                   (0x00007FFF&(data))
+#define CERSR0_get_err_cnt1_video(data)                               ((0x7FFF0000&(data))>>16)
+#define CERSR0_get_err_cnt0_video(data)                               (0x00007FFF&(data))
+
+
+#define CERSR1                                                        0x1c4
+#define CERSR1_reg_addr                                               "0x980341c4"
+#define CERSR1_reg                                                    0x980341c4
+#define CERSR1_inst_addr                                              "0x0071"
+#define CERSR1_inst                                                   0x0071
+#define set_CERSR1_reg(data)                                          (*((volatile unsigned int*)CERSR1_reg)=data)
+#define get_CERSR1_reg                                                (*((volatile unsigned int*)CERSR1_reg))
+#define CERSR1_err_cnt0_pkt_shift                                     (16)
+#define CERSR1_err_cnt2_video_shift                                   (0)
+#define CERSR1_err_cnt0_pkt_mask                                      (0x7FFF0000)
+#define CERSR1_err_cnt2_video_mask                                    (0x00007FFF)
+#define CERSR1_err_cnt0_pkt(data)                                     (0x7FFF0000&((data)<<16))
+#define CERSR1_err_cnt2_video(data)                                   (0x00007FFF&(data))
+#define CERSR1_get_err_cnt0_pkt(data)                                 ((0x7FFF0000&(data))>>16)
+#define CERSR1_get_err_cnt2_video(data)                               (0x00007FFF&(data))
+
+
+#define CERSR2                                                        0x1c8
+#define CERSR2_reg_addr                                               "0x980341c8"
+#define CERSR2_reg                                                    0x980341c8
+#define CERSR2_inst_addr                                              "0x0072"
+#define CERSR2_inst                                                   0x0072
+#define set_CERSR2_reg(data)                                          (*((volatile unsigned int*)CERSR2_reg)=data)
+#define get_CERSR2_reg                                                (*((volatile unsigned int*)CERSR2_reg))
+#define CERSR2_err_cnt2_pkt_shift                                     (16)
+#define CERSR2_err_cnt1_pkt_shift                                     (0)
+#define CERSR2_err_cnt2_pkt_mask                                      (0x7FFF0000)
+#define CERSR2_err_cnt1_pkt_mask                                      (0x00007FFF)
+#define CERSR2_err_cnt2_pkt(data)                                     (0x7FFF0000&((data)<<16))
+#define CERSR2_err_cnt1_pkt(data)                                     (0x00007FFF&(data))
+#define CERSR2_get_err_cnt2_pkt(data)                                 ((0x7FFF0000&(data))>>16)
+#define CERSR2_get_err_cnt1_pkt(data)                                 (0x00007FFF&(data))
+
+
+#define CERSR3                                                        0x1cc
+#define CERSR3_reg_addr                                               "0x980341cc"
+#define CERSR3_reg                                                    0x980341cc
+#define CERSR3_inst_addr                                              "0x0073"
+#define CERSR3_inst                                                   0x0073
+#define set_CERSR3_reg(data)                                          (*((volatile unsigned int*)CERSR3_reg)=data)
+#define get_CERSR3_reg                                                (*((volatile unsigned int*)CERSR3_reg))
+#define CERSR3_err_cnt1_ctr_shift                                     (16)
+#define CERSR3_err_cnt0_ctr_shift                                     (0)
+#define CERSR3_err_cnt1_ctr_mask                                      (0x7FFF0000)
+#define CERSR3_err_cnt0_ctr_mask                                      (0x00007FFF)
+#define CERSR3_err_cnt1_ctr(data)                                     (0x7FFF0000&((data)<<16))
+#define CERSR3_err_cnt0_ctr(data)                                     (0x00007FFF&(data))
+#define CERSR3_get_err_cnt1_ctr(data)                                 ((0x7FFF0000&(data))>>16)
+#define CERSR3_get_err_cnt0_ctr(data)                                 (0x00007FFF&(data))
+
+
+#define CERSR4                                                        0x1d0
+#define CERSR4_reg_addr                                               "0x980341d0"
+#define CERSR4_reg                                                    0x980341d0
+#define CERSR4_inst_addr                                              "0x0074"
+#define CERSR4_inst                                                   0x0074
+#define set_CERSR4_reg(data)                                          (*((volatile unsigned int*)CERSR4_reg)=data)
+#define get_CERSR4_reg                                                (*((volatile unsigned int*)CERSR4_reg))
+#define CERSR4_err_cnt2_ctr_shift                                     (0)
+#define CERSR4_err_cnt2_ctr_mask                                      (0x00007FFF)
+#define CERSR4_err_cnt2_ctr(data)                                     (0x00007FFF&(data))
+#define CERSR4_get_err_cnt2_ctr(data)                                 (0x00007FFF&(data))
+
+
+#define YUV420_CR                                                     0x1d4
+#define YUV420_CR_reg_addr                                            "0x980341d4"
+#define YUV420_CR_reg                                                 0x980341d4
+#define YUV420_CR_inst_addr                                           "0x0075"
+#define YUV420_CR_inst                                                0x0075
+#define set_YUV420_CR_reg(data)                                       (*((volatile unsigned int*)YUV420_CR_reg)=data)
+#define get_YUV420_CR_reg                                             (*((volatile unsigned int*)YUV420_CR_reg))
+#define YUV420_CR_fifo_over_flag_shift                                (2)
+#define YUV420_CR_fifo_under_flag_shift                               (1)
+#define YUV420_CR_en_shift                                            (0)
+#define YUV420_CR_fifo_over_flag_mask                                 (0x00000004)
+#define YUV420_CR_fifo_under_flag_mask                                (0x00000002)
+#define YUV420_CR_en_mask                                             (0x00000001)
+#define YUV420_CR_fifo_over_flag(data)                                (0x00000004&((data)<<2))
+#define YUV420_CR_fifo_under_flag(data)                               (0x00000002&((data)<<1))
+#define YUV420_CR_en(data)                                            (0x00000001&(data))
+#define YUV420_CR_get_fifo_over_flag(data)                            ((0x00000004&(data))>>2)
+#define YUV420_CR_get_fifo_under_flag(data)                           ((0x00000002&(data))>>1)
+#define YUV420_CR_get_en(data)                                        (0x00000001&(data))
+
+
+#define SCDC_CR                                                       0x1d8
+#define SCDC_CR_reg_addr                                              "0x980341d8"
+#define SCDC_CR_reg                                                   0x980341d8
+#define SCDC_CR_inst_addr                                             "0x0076"
+#define SCDC_CR_inst                                                  0x0076
+#define set_SCDC_CR_reg(data)                                         (*((volatile unsigned int*)SCDC_CR_reg)=data)
+#define get_SCDC_CR_reg                                               (*((volatile unsigned int*)SCDC_CR_reg))
+#define SCDC_CR_scdc_reset_shift                                      (5)
+#define SCDC_CR_dummy_4_2_shift                                       (2)
+#define SCDC_CR_maddf_shift                                           (1)
+#define SCDC_CR_scdc_en_shift                                         (0)
+#define SCDC_CR_scdc_reset_mask                                       (0x00000020)
+#define SCDC_CR_dummy_4_2_mask                                        (0x0000001C)
+#define SCDC_CR_maddf_mask                                            (0x00000002)
+#define SCDC_CR_scdc_en_mask                                          (0x00000001)
+#define SCDC_CR_scdc_reset(data)                                      (0x00000020&((data)<<5))
+#define SCDC_CR_dummy_4_2(data)                                       (0x0000001C&((data)<<2))
+#define SCDC_CR_maddf(data)                                           (0x00000002&((data)<<1))
+#define SCDC_CR_scdc_en(data)                                         (0x00000001&(data))
+#define SCDC_CR_get_scdc_reset(data)                                  ((0x00000020&(data))>>5)
+#define SCDC_CR_get_dummy_4_2(data)                                   ((0x0000001C&(data))>>2)
+#define SCDC_CR_get_maddf(data)                                       ((0x00000002&(data))>>1)
+#define SCDC_CR_get_scdc_en(data)                                     (0x00000001&(data))
+
+
+#define SCDC_PCR                                                      0x1dc
+#define SCDC_PCR_reg_addr                                             "0x980341dc"
+#define SCDC_PCR_reg                                                  0x980341dc
+#define SCDC_PCR_inst_addr                                            "0x0077"
+#define SCDC_PCR_inst                                                 0x0077
+#define set_SCDC_PCR_reg(data)                                        (*((volatile unsigned int*)SCDC_PCR_reg)=data)
+#define get_SCDC_PCR_reg                                              (*((volatile unsigned int*)SCDC_PCR_reg))
+#define SCDC_PCR_timeout_flag_shift                                   (31)
+#define SCDC_PCR_timeout_sel_shift                                    (29)
+#define SCDC_PCR_status_flag_shift                                    (28)
+#define SCDC_PCR_config_flag_shift                                    (27)
+#define SCDC_PCR_scrambler_status_flag_shift                          (26)
+#define SCDC_PCR_tmds_config_flag_shift                               (25)
+#define SCDC_PCR_i2c_scl_dly_sel_shift                                (21)
+#define SCDC_PCR_i2c_sda_dly_sel_shift                                (17)
+#define SCDC_PCR_i2c_free_num_shift                                   (10)
+#define SCDC_PCR_rr_retry_sel_shift                                   (8)
+#define SCDC_PCR_dbnc_level_sel_shift                                 (7)
+#define SCDC_PCR_dummy_6_1_shift                                      (1)
+#define SCDC_PCR_apai_shift                                           (0)
+#define SCDC_PCR_timeout_flag_mask                                    (0x80000000)
+#define SCDC_PCR_timeout_sel_mask                                     (0x60000000)
+#define SCDC_PCR_status_flag_mask                                     (0x10000000)
+#define SCDC_PCR_config_flag_mask                                     (0x08000000)
+#define SCDC_PCR_scrambler_status_flag_mask                           (0x04000000)
+#define SCDC_PCR_tmds_config_flag_mask                                (0x02000000)
+#define SCDC_PCR_i2c_scl_dly_sel_mask                                 (0x01E00000)
+#define SCDC_PCR_i2c_sda_dly_sel_mask                                 (0x001E0000)
+#define SCDC_PCR_i2c_free_num_mask                                    (0x0001FC00)
+#define SCDC_PCR_rr_retry_sel_mask                                    (0x00000300)
+#define SCDC_PCR_dbnc_level_sel_mask                                  (0x00000080)
+#define SCDC_PCR_dummy_6_1_mask                                       (0x0000007E)
+#define SCDC_PCR_apai_mask                                            (0x00000001)
+#define SCDC_PCR_timeout_flag(data)                                   (0x80000000&((data)<<31))
+#define SCDC_PCR_timeout_sel(data)                                    (0x60000000&((data)<<29))
+#define SCDC_PCR_status_flag(data)                                    (0x10000000&((data)<<28))
+#define SCDC_PCR_config_flag(data)                                    (0x08000000&((data)<<27))
+#define SCDC_PCR_scrambler_status_flag(data)                          (0x04000000&((data)<<26))
+#define SCDC_PCR_tmds_config_flag(data)                               (0x02000000&((data)<<25))
+#define SCDC_PCR_i2c_scl_dly_sel(data)                                (0x01E00000&((data)<<21))
+#define SCDC_PCR_i2c_sda_dly_sel(data)                                (0x001E0000&((data)<<17))
+#define SCDC_PCR_i2c_free_num(data)                                   (0x0001FC00&((data)<<10))
+#define SCDC_PCR_rr_retry_sel(data)                                   (0x00000300&((data)<<8))
+#define SCDC_PCR_dbnc_level_sel(data)                                 (0x00000080&((data)<<7))
+#define SCDC_PCR_dummy_6_1(data)                                      (0x0000007E&((data)<<1))
+#define SCDC_PCR_apai(data)                                           (0x00000001&(data))
+#define SCDC_PCR_get_timeout_flag(data)                               ((0x80000000&(data))>>31)
+#define SCDC_PCR_get_timeout_sel(data)                                ((0x60000000&(data))>>29)
+#define SCDC_PCR_get_status_flag(data)                                ((0x10000000&(data))>>28)
+#define SCDC_PCR_get_config_flag(data)                                ((0x08000000&(data))>>27)
+#define SCDC_PCR_get_scrambler_status_flag(data)                      ((0x04000000&(data))>>26)
+#define SCDC_PCR_get_tmds_config_flag(data)                           ((0x02000000&(data))>>25)
+#define SCDC_PCR_get_i2c_scl_dly_sel(data)                            ((0x01E00000&(data))>>21)
+#define SCDC_PCR_get_i2c_sda_dly_sel(data)                            ((0x001E0000&(data))>>17)
+#define SCDC_PCR_get_i2c_free_num(data)                               ((0x0001FC00&(data))>>10)
+#define SCDC_PCR_get_rr_retry_sel(data)                               ((0x00000300&(data))>>8)
+#define SCDC_PCR_get_dbnc_level_sel(data)                             ((0x00000080&(data))>>7)
+#define SCDC_PCR_get_dummy_6_1(data)                                  ((0x0000007E&(data))>>1)
+#define SCDC_PCR_get_apai(data)                                       (0x00000001&(data))
+
+
+#define SCDC_AP                                                       0x1e0
+#define SCDC_AP_reg_addr                                              "0x980341e0"
+#define SCDC_AP_reg                                                   0x980341e0
+#define SCDC_AP_inst_addr                                             "0x0078"
+#define SCDC_AP_inst                                                  0x0078
+#define set_SCDC_AP_reg(data)                                         (*((volatile unsigned int*)SCDC_AP_reg)=data)
+#define get_SCDC_AP_reg                                               (*((volatile unsigned int*)SCDC_AP_reg))
+#define SCDC_AP_ap1_shift                                             (0)
+#define SCDC_AP_ap1_mask                                              (0x000000FF)
+#define SCDC_AP_ap1(data)                                             (0x000000FF&(data))
+#define SCDC_AP_get_ap1(data)                                         (0x000000FF&(data))
+
+
+#define SCDC_DP                                                       0x1e4
+#define SCDC_DP_reg_addr                                              "0x980341e4"
+#define SCDC_DP_reg                                                   0x980341e4
+#define SCDC_DP_inst_addr                                             "0x0079"
+#define SCDC_DP_inst                                                  0x0079
+#define set_SCDC_DP_reg(data)                                         (*((volatile unsigned int*)SCDC_DP_reg)=data)
+#define get_SCDC_DP_reg                                               (*((volatile unsigned int*)SCDC_DP_reg))
+#define SCDC_DP_dp1_shift                                             (0)
+#define SCDC_DP_dp1_mask                                              (0x000000FF)
+#define SCDC_DP_dp1(data)                                             (0x000000FF&(data))
+#define SCDC_DP_get_dp1(data)                                         (0x000000FF&(data))
+
+
+#define CLKDETCR                                                      0x1e8
+#define CLKDETCR_reg_addr                                             "0x980341e8"
+#define CLKDETCR_reg                                                  0x980341e8
+#define CLKDETCR_inst_addr                                            "0x007A"
+#define CLKDETCR_inst                                                 0x007A
+#define set_CLKDETCR_reg(data)                                        (*((volatile unsigned int*)CLKDETCR_reg)=data)
+#define get_CLKDETCR_reg                                              (*((volatile unsigned int*)CLKDETCR_reg))
+#define CLKDETCR_clock_det_en_shift                                   (0)
+#define CLKDETCR_clock_det_en_mask                                    (0x00000001)
+#define CLKDETCR_clock_det_en(data)                                   (0x00000001&(data))
+#define CLKDETCR_get_clock_det_en(data)                               (0x00000001&(data))
+
+
+#define CLKDETSR                                                      0x1ec
+#define CLKDETSR_reg_addr                                             "0x980341ec"
+#define CLKDETSR_reg                                                  0x980341ec
+#define CLKDETSR_inst_addr                                            "0x007B"
+#define CLKDETSR_inst                                                 0x007B
+#define set_CLKDETSR_reg(data)                                        (*((volatile unsigned int*)CLKDETSR_reg)=data)
+#define get_CLKDETSR_reg                                              (*((volatile unsigned int*)CLKDETSR_reg))
+#define CLKDETSR_en_tmds_chg_irq_shift                                (5)
+#define CLKDETSR_tmds_chg_irq_shift                                   (4)
+#define CLKDETSR_dummy_3_2_shift                                      (2)
+#define CLKDETSR_clk_not_in_target_irq_en_shift                       (1)
+#define CLKDETSR_clk_not_in_target_shift                              (0)
+#define CLKDETSR_en_tmds_chg_irq_mask                                 (0x00000020)
+#define CLKDETSR_tmds_chg_irq_mask                                    (0x00000010)
+#define CLKDETSR_dummy_3_2_mask                                       (0x0000000C)
+#define CLKDETSR_clk_not_in_target_irq_en_mask                        (0x00000002)
+#define CLKDETSR_clk_not_in_target_mask                               (0x00000001)
+#define CLKDETSR_en_tmds_chg_irq(data)                                (0x00000020&((data)<<5))
+#define CLKDETSR_tmds_chg_irq(data)                                   (0x00000010&((data)<<4))
+#define CLKDETSR_dummy_3_2(data)                                      (0x0000000C&((data)<<2))
+#define CLKDETSR_clk_not_in_target_irq_en(data)                       (0x00000002&((data)<<1))
+#define CLKDETSR_clk_not_in_target(data)                              (0x00000001&(data))
+#define CLKDETSR_get_en_tmds_chg_irq(data)                            ((0x00000020&(data))>>5)
+#define CLKDETSR_get_tmds_chg_irq(data)                               ((0x00000010&(data))>>4)
+#define CLKDETSR_get_dummy_3_2(data)                                  ((0x0000000C&(data))>>2)
+#define CLKDETSR_get_clk_not_in_target_irq_en(data)                   ((0x00000002&(data))>>1)
+#define CLKDETSR_get_clk_not_in_target(data)                          (0x00000001&(data))
+
+
+#define GDI_TMDSCLK_SETTING_00                                        0x1f0
+#define GDI_TMDSCLK_SETTING_00_reg_addr                               "0x980341f0"
+#define GDI_TMDSCLK_SETTING_00_reg                                    0x980341f0
+#define GDI_TMDSCLK_SETTING_00_inst_addr                              "0x007C"
+#define GDI_TMDSCLK_SETTING_00_inst                                   0x007C
+#define set_GDI_TMDSCLK_SETTING_00_reg(data)                          (*((volatile unsigned int*)GDI_TMDSCLK_SETTING_00_reg)=data)
+#define get_GDI_TMDSCLK_SETTING_00_reg                                (*((volatile unsigned int*)GDI_TMDSCLK_SETTING_00_reg))
+#define GDI_TMDSCLK_SETTING_00_dclk_cnt_start_shift                   (16)
+#define GDI_TMDSCLK_SETTING_00_dclk_cnt_end_shift                     (0)
+#define GDI_TMDSCLK_SETTING_00_dclk_cnt_start_mask                    (0x0FFF0000)
+#define GDI_TMDSCLK_SETTING_00_dclk_cnt_end_mask                      (0x00000FFF)
+#define GDI_TMDSCLK_SETTING_00_dclk_cnt_start(data)                   (0x0FFF0000&((data)<<16))
+#define GDI_TMDSCLK_SETTING_00_dclk_cnt_end(data)                     (0x00000FFF&(data))
+#define GDI_TMDSCLK_SETTING_00_get_dclk_cnt_start(data)               ((0x0FFF0000&(data))>>16)
+#define GDI_TMDSCLK_SETTING_00_get_dclk_cnt_end(data)                 (0x00000FFF&(data))
+
+
+#define GDI_TMDSCLK_SETTING_01                                        0x1f4
+#define GDI_TMDSCLK_SETTING_01_reg_addr                               "0x980341f4"
+#define GDI_TMDSCLK_SETTING_01_reg                                    0x980341f4
+#define GDI_TMDSCLK_SETTING_01_inst_addr                              "0x007D"
+#define GDI_TMDSCLK_SETTING_01_inst                                   0x007D
+#define set_GDI_TMDSCLK_SETTING_01_reg(data)                          (*((volatile unsigned int*)GDI_TMDSCLK_SETTING_01_reg)=data)
+#define get_GDI_TMDSCLK_SETTING_01_reg                                (*((volatile unsigned int*)GDI_TMDSCLK_SETTING_01_reg))
+#define GDI_TMDSCLK_SETTING_01_target_for_maximum_clk_counter_shift   (16)
+#define GDI_TMDSCLK_SETTING_01_target_for_minimum_clk_counter_shift   (0)
+#define GDI_TMDSCLK_SETTING_01_target_for_maximum_clk_counter_mask    (0x0FFF0000)
+#define GDI_TMDSCLK_SETTING_01_target_for_minimum_clk_counter_mask    (0x00000FFF)
+#define GDI_TMDSCLK_SETTING_01_target_for_maximum_clk_counter(data)   (0x0FFF0000&((data)<<16))
+#define GDI_TMDSCLK_SETTING_01_target_for_minimum_clk_counter(data)   (0x00000FFF&(data))
+#define GDI_TMDSCLK_SETTING_01_get_target_for_maximum_clk_counter(data)  ((0x0FFF0000&(data))>>16)
+#define GDI_TMDSCLK_SETTING_01_get_target_for_minimum_clk_counter(data)  (0x00000FFF&(data))
+
+
+#define GDI_TMDSCLK_SETTING_02                                        0x1f8
+#define GDI_TMDSCLK_SETTING_02_reg_addr                               "0x980341f8"
+#define GDI_TMDSCLK_SETTING_02_reg                                    0x980341f8
+#define GDI_TMDSCLK_SETTING_02_inst_addr                              "0x007E"
+#define GDI_TMDSCLK_SETTING_02_inst                                   0x007E
+#define set_GDI_TMDSCLK_SETTING_02_reg(data)                          (*((volatile unsigned int*)GDI_TMDSCLK_SETTING_02_reg)=data)
+#define get_GDI_TMDSCLK_SETTING_02_reg                                (*((volatile unsigned int*)GDI_TMDSCLK_SETTING_02_reg))
+#define GDI_TMDSCLK_SETTING_02_clk_counter_err_threshold_shift        (8)
+#define GDI_TMDSCLK_SETTING_02_clk_counter_debounce_shift             (0)
+#define GDI_TMDSCLK_SETTING_02_clk_counter_err_threshold_mask         (0x00000F00)
+#define GDI_TMDSCLK_SETTING_02_clk_counter_debounce_mask              (0x000000FF)
+#define GDI_TMDSCLK_SETTING_02_clk_counter_err_threshold(data)        (0x00000F00&((data)<<8))
+#define GDI_TMDSCLK_SETTING_02_clk_counter_debounce(data)             (0x000000FF&(data))
+#define GDI_TMDSCLK_SETTING_02_get_clk_counter_err_threshold(data)    ((0x00000F00&(data))>>8)
+#define GDI_TMDSCLK_SETTING_02_get_clk_counter_debounce(data)         (0x000000FF&(data))
+
+
+#define HDCP_BIST                                                     0x200
+#define HDCP_BIST_reg_addr                                            "0x98034200"
+#define HDCP_BIST_reg                                                 0x98034200
+#define HDCP_BIST_inst_addr                                           "0x0080"
+#define HDCP_BIST_inst                                                0x0080
+#define set_HDCP_BIST_reg(data)                                       (*((volatile unsigned int*)HDCP_BIST_reg)=data)
+#define get_HDCP_BIST_reg                                             (*((volatile unsigned int*)HDCP_BIST_reg))
+
+
+#define HDCP_CR                                                       0x204
+#define HDCP_CR_reg_addr                                              "0x98034204"
+#define HDCP_CR_reg                                                   0x98034204
+#define HDCP_CR_inst_addr                                             "0x0081"
+#define HDCP_CR_inst                                                  0x0081
+#define set_HDCP_CR_reg(data)                                         (*((volatile unsigned int*)HDCP_CR_reg)=data)
+#define get_HDCP_CR_reg                                               (*((volatile unsigned int*)HDCP_CR_reg))
+#define HDCP_CR_namfe_shift                                           (7)
+#define HDCP_CR_rpt_shift                                             (6)
+#define HDCP_CR_ivsp_shift                                            (5)
+#define HDCP_CR_invvs_shift                                           (4)
+#define HDCP_CR_ivspm_shift                                           (3)
+#define HDCP_CR_maddf_shift                                           (2)
+#define HDCP_CR_dkapde_shift                                          (1)
+#define HDCP_CR_hdcp_en_shift                                         (0)
+#define HDCP_CR_namfe_mask                                            (0x00000080)
+#define HDCP_CR_rpt_mask                                              (0x00000040)
+#define HDCP_CR_ivsp_mask                                             (0x00000020)
+#define HDCP_CR_invvs_mask                                            (0x00000010)
+#define HDCP_CR_ivspm_mask                                            (0x00000008)
+#define HDCP_CR_maddf_mask                                            (0x00000004)
+#define HDCP_CR_dkapde_mask                                           (0x00000002)
+#define HDCP_CR_hdcp_en_mask                                          (0x00000001)
+#define HDCP_CR_namfe(data)                                           (0x00000080&((data)<<7))
+#define HDCP_CR_rpt(data)                                             (0x00000040&((data)<<6))
+#define HDCP_CR_ivsp(data)                                            (0x00000020&((data)<<5))
+#define HDCP_CR_invvs(data)                                           (0x00000010&((data)<<4))
+#define HDCP_CR_ivspm(data)                                           (0x00000008&((data)<<3))
+#define HDCP_CR_maddf(data)                                           (0x00000004&((data)<<2))
+#define HDCP_CR_dkapde(data)                                          (0x00000002&((data)<<1))
+#define HDCP_CR_hdcp_en(data)                                         (0x00000001&(data))
+#define HDCP_CR_get_namfe(data)                                       ((0x00000080&(data))>>7)
+#define HDCP_CR_get_rpt(data)                                         ((0x00000040&(data))>>6)
+#define HDCP_CR_get_ivsp(data)                                        ((0x00000020&(data))>>5)
+#define HDCP_CR_get_invvs(data)                                       ((0x00000010&(data))>>4)
+#define HDCP_CR_get_ivspm(data)                                       ((0x00000008&(data))>>3)
+#define HDCP_CR_get_maddf(data)                                       ((0x00000004&(data))>>2)
+#define HDCP_CR_get_dkapde(data)                                      ((0x00000002&(data))>>1)
+#define HDCP_CR_get_hdcp_en(data)                                     (0x00000001&(data))
+
+
+#define HDCP_DKAP                                                     0x208
+#define HDCP_DKAP_reg_addr                                            "0x98034208"
+#define HDCP_DKAP_reg                                                 0x98034208
+#define HDCP_DKAP_inst_addr                                           "0x0082"
+#define HDCP_DKAP_inst                                                0x0082
+#define set_HDCP_DKAP_reg(data)                                       (*((volatile unsigned int*)HDCP_DKAP_reg)=data)
+#define get_HDCP_DKAP_reg                                             (*((volatile unsigned int*)HDCP_DKAP_reg))
+#define HDCP_DKAP_dkap_shift                                          (0)
+#define HDCP_DKAP_dkap_mask                                           (0x000000FF)
+#define HDCP_DKAP_dkap(data)                                          (0x000000FF&(data))
+#define HDCP_DKAP_get_dkap(data)                                      (0x000000FF&(data))
+
+
+#define HDCP_PCR                                                      0x20c
+#define HDCP_PCR_reg_addr                                             "0x9803420c"
+#define HDCP_PCR_reg                                                  0x9803420c
+#define HDCP_PCR_inst_addr                                            "0x0083"
+#define HDCP_PCR_inst                                                 0x0083
+#define set_HDCP_PCR_reg(data)                                        (*((volatile unsigned int*)HDCP_PCR_reg)=data)
+#define get_HDCP_PCR_reg                                              (*((volatile unsigned int*)HDCP_PCR_reg))
+#define HDCP_PCR_iic_st_shift                                         (28)
+#define HDCP_PCR_i2c_scl_dly_sel_shift                                (24)
+#define HDCP_PCR_i2c_sda_dly_sel_shift                                (20)
+#define HDCP_PCR_tune_up_down_shift                                   (17)
+#define HDCP_PCR_tune_range_shift                                     (10)
+#define HDCP_PCR_ddcdbnc_shift                                        (9)
+#define HDCP_PCR_km_clk_sel_eco_shift                                 (8)
+#define HDCP_PCR_dbnc_level_sel_shift                                 (7)
+#define HDCP_PCR_km_clk_sel_shift                                     (6)
+#define HDCP_PCR_hdcp_vs_sel_shift                                    (5)
+#define HDCP_PCR_enc_tog_shift                                        (4)
+#define HDCP_PCR_avmute_dis_shift                                     (3)
+#define HDCP_PCR_dummy_2_shift                                        (2)
+#define HDCP_PCR_apai_type_shift                                      (1)
+#define HDCP_PCR_apai_shift                                           (0)
+#define HDCP_PCR_iic_st_mask                                          (0x70000000)
+#define HDCP_PCR_i2c_scl_dly_sel_mask                                 (0x0F000000)
+#define HDCP_PCR_i2c_sda_dly_sel_mask                                 (0x00F00000)
+#define HDCP_PCR_tune_up_down_mask                                    (0x00020000)
+#define HDCP_PCR_tune_range_mask                                      (0x0001FC00)
+#define HDCP_PCR_ddcdbnc_mask                                         (0x00000200)
+#define HDCP_PCR_km_clk_sel_eco_mask                                  (0x00000100)
+#define HDCP_PCR_dbnc_level_sel_mask                                  (0x00000080)
+#define HDCP_PCR_km_clk_sel_mask                                      (0x00000040)
+#define HDCP_PCR_hdcp_vs_sel_mask                                     (0x00000020)
+#define HDCP_PCR_enc_tog_mask                                         (0x00000010)
+#define HDCP_PCR_avmute_dis_mask                                      (0x00000008)
+#define HDCP_PCR_dummy_2_mask                                         (0x00000004)
+#define HDCP_PCR_apai_type_mask                                       (0x00000002)
+#define HDCP_PCR_apai_mask                                            (0x00000001)
+#define HDCP_PCR_iic_st(data)                                         (0x70000000&((data)<<28))
+#define HDCP_PCR_i2c_scl_dly_sel(data)                                (0x0F000000&((data)<<24))
+#define HDCP_PCR_i2c_sda_dly_sel(data)                                (0x00F00000&((data)<<20))
+#define HDCP_PCR_tune_up_down(data)                                   (0x00020000&((data)<<17))
+#define HDCP_PCR_tune_range(data)                                     (0x0001FC00&((data)<<10))
+#define HDCP_PCR_ddcdbnc(data)                                        (0x00000200&((data)<<9))
+#define HDCP_PCR_km_clk_sel_eco(data)                                 (0x00000100&((data)<<8))
+#define HDCP_PCR_dbnc_level_sel(data)                                 (0x00000080&((data)<<7))
+#define HDCP_PCR_km_clk_sel(data)                                     (0x00000040&((data)<<6))
+#define HDCP_PCR_hdcp_vs_sel(data)                                    (0x00000020&((data)<<5))
+#define HDCP_PCR_enc_tog(data)                                        (0x00000010&((data)<<4))
+#define HDCP_PCR_avmute_dis(data)                                     (0x00000008&((data)<<3))
+#define HDCP_PCR_dummy_2(data)                                        (0x00000004&((data)<<2))
+#define HDCP_PCR_apai_type(data)                                      (0x00000002&((data)<<1))
+#define HDCP_PCR_apai(data)                                           (0x00000001&(data))
+#define HDCP_PCR_get_iic_st(data)                                     ((0x70000000&(data))>>28)
+#define HDCP_PCR_get_i2c_scl_dly_sel(data)                            ((0x0F000000&(data))>>24)
+#define HDCP_PCR_get_i2c_sda_dly_sel(data)                            ((0x00F00000&(data))>>20)
+#define HDCP_PCR_get_tune_up_down(data)                               ((0x00020000&(data))>>17)
+#define HDCP_PCR_get_tune_range(data)                                 ((0x0001FC00&(data))>>10)
+#define HDCP_PCR_get_ddcdbnc(data)                                    ((0x00000200&(data))>>9)
+#define HDCP_PCR_get_km_clk_sel_eco(data)                             ((0x00000100&(data))>>8)
+#define HDCP_PCR_get_dbnc_level_sel(data)                             ((0x00000080&(data))>>7)
+#define HDCP_PCR_get_km_clk_sel(data)                                 ((0x00000040&(data))>>6)
+#define HDCP_PCR_get_hdcp_vs_sel(data)                                ((0x00000020&(data))>>5)
+#define HDCP_PCR_get_enc_tog(data)                                    ((0x00000010&(data))>>4)
+#define HDCP_PCR_get_avmute_dis(data)                                 ((0x00000008&(data))>>3)
+#define HDCP_PCR_get_dummy_2(data)                                    ((0x00000004&(data))>>2)
+#define HDCP_PCR_get_apai_type(data)                                  ((0x00000002&(data))>>1)
+#define HDCP_PCR_get_apai(data)                                       (0x00000001&(data))
+
+
+#define HDCP_FLAG1                                                    0x210
+#define HDCP_FLAG1_reg_addr                                           "0x98034210"
+#define HDCP_FLAG1_reg                                                0x98034210
+#define HDCP_FLAG1_inst_addr                                          "0x0084"
+#define HDCP_FLAG1_inst                                               0x0084
+#define set_HDCP_FLAG1_reg(data)                                      (*((volatile unsigned int*)HDCP_FLAG1_reg)=data)
+#define get_HDCP_FLAG1_reg                                            (*((volatile unsigned int*)HDCP_FLAG1_reg))
+#define HDCP_FLAG1_wr_aksv_flag_shift                                 (4)
+#define HDCP_FLAG1_rd_ri_flag_shift                                   (3)
+#define HDCP_FLAG1_rd_bksv_flag_shift                                 (2)
+#define HDCP_FLAG1_dummy_1_0_shift                                    (0)
+#define HDCP_FLAG1_wr_aksv_flag_mask                                  (0x00000010)
+#define HDCP_FLAG1_rd_ri_flag_mask                                    (0x00000008)
+#define HDCP_FLAG1_rd_bksv_flag_mask                                  (0x00000004)
+#define HDCP_FLAG1_dummy_1_0_mask                                     (0x00000003)
+#define HDCP_FLAG1_wr_aksv_flag(data)                                 (0x00000010&((data)<<4))
+#define HDCP_FLAG1_rd_ri_flag(data)                                   (0x00000008&((data)<<3))
+#define HDCP_FLAG1_rd_bksv_flag(data)                                 (0x00000004&((data)<<2))
+#define HDCP_FLAG1_dummy_1_0(data)                                    (0x00000003&(data))
+#define HDCP_FLAG1_get_wr_aksv_flag(data)                             ((0x00000010&(data))>>4)
+#define HDCP_FLAG1_get_rd_ri_flag(data)                               ((0x00000008&(data))>>3)
+#define HDCP_FLAG1_get_rd_bksv_flag(data)                             ((0x00000004&(data))>>2)
+#define HDCP_FLAG1_get_dummy_1_0(data)                                (0x00000003&(data))
+
+
+#define HDCP_FLAG2                                                    0x214
+#define HDCP_FLAG2_reg_addr                                           "0x98034214"
+#define HDCP_FLAG2_reg                                                0x98034214
+#define HDCP_FLAG2_inst_addr                                          "0x0085"
+#define HDCP_FLAG2_inst                                               0x0085
+#define set_HDCP_FLAG2_reg(data)                                      (*((volatile unsigned int*)HDCP_FLAG2_reg)=data)
+#define get_HDCP_FLAG2_reg                                            (*((volatile unsigned int*)HDCP_FLAG2_reg))
+#define HDCP_FLAG2_irq_aksv_en_shift                                  (4)
+#define HDCP_FLAG2_irq_ri_en_shift                                    (3)
+#define HDCP_FLAG2_irq_bksv_en_shift                                  (2)
+#define HDCP_FLAG2_dummy_1_0_shift                                    (0)
+#define HDCP_FLAG2_irq_aksv_en_mask                                   (0x00000010)
+#define HDCP_FLAG2_irq_ri_en_mask                                     (0x00000008)
+#define HDCP_FLAG2_irq_bksv_en_mask                                   (0x00000004)
+#define HDCP_FLAG2_dummy_1_0_mask                                     (0x00000003)
+#define HDCP_FLAG2_irq_aksv_en(data)                                  (0x00000010&((data)<<4))
+#define HDCP_FLAG2_irq_ri_en(data)                                    (0x00000008&((data)<<3))
+#define HDCP_FLAG2_irq_bksv_en(data)                                  (0x00000004&((data)<<2))
+#define HDCP_FLAG2_dummy_1_0(data)                                    (0x00000003&(data))
+#define HDCP_FLAG2_get_irq_aksv_en(data)                              ((0x00000010&(data))>>4)
+#define HDCP_FLAG2_get_irq_ri_en(data)                                ((0x00000008&(data))>>3)
+#define HDCP_FLAG2_get_irq_bksv_en(data)                              ((0x00000004&(data))>>2)
+#define HDCP_FLAG2_get_dummy_1_0(data)                                (0x00000003&(data))
+
+
+#define HDCP_AP                                                       0x218
+#define HDCP_AP_reg_addr                                              "0x98034218"
+#define HDCP_AP_reg                                                   0x98034218
+#define HDCP_AP_inst_addr                                             "0x0086"
+#define HDCP_AP_inst                                                  0x0086
+#define set_HDCP_AP_reg(data)                                         (*((volatile unsigned int*)HDCP_AP_reg)=data)
+#define get_HDCP_AP_reg                                               (*((volatile unsigned int*)HDCP_AP_reg))
+#define HDCP_AP_ksvfifo_status_shift                                  (18)
+#define HDCP_AP_dp_ksvfifo_ptr_shift                                  (8)
+#define HDCP_AP_ap1_shift                                             (0)
+#define HDCP_AP_ksvfifo_status_mask                                   (0x00040000)
+#define HDCP_AP_dp_ksvfifo_ptr_mask                                   (0x0003FF00)
+#define HDCP_AP_ap1_mask                                              (0x000000FF)
+#define HDCP_AP_ksvfifo_status(data)                                  (0x00040000&((data)<<18))
+#define HDCP_AP_dp_ksvfifo_ptr(data)                                  (0x0003FF00&((data)<<8))
+#define HDCP_AP_ap1(data)                                             (0x000000FF&(data))
+#define HDCP_AP_get_ksvfifo_status(data)                              ((0x00040000&(data))>>18)
+#define HDCP_AP_get_dp_ksvfifo_ptr(data)                              ((0x0003FF00&(data))>>8)
+#define HDCP_AP_get_ap1(data)                                         (0x000000FF&(data))
+
+
+#define HDCP_DP                                                       0x21c
+#define HDCP_DP_reg_addr                                              "0x9803421c"
+#define HDCP_DP_reg                                                   0x9803421c
+#define HDCP_DP_inst_addr                                             "0x0087"
+#define HDCP_DP_inst                                                  0x0087
+#define set_HDCP_DP_reg(data)                                         (*((volatile unsigned int*)HDCP_DP_reg)=data)
+#define get_HDCP_DP_reg                                               (*((volatile unsigned int*)HDCP_DP_reg))
+#define HDCP_DP_dp1_shift                                             (0)
+#define HDCP_DP_dp1_mask                                              (0x000000FF)
+#define HDCP_DP_dp1(data)                                             (0x000000FF&(data))
+#define HDCP_DP_get_dp1(data)                                         (0x000000FF&(data))
+
+
+#define HDCP_2P2_CR                                                   0x220
+#define HDCP_2P2_CR_reg_addr                                          "0x98034220"
+#define HDCP_2P2_CR_reg                                               0x98034220
+#define HDCP_2P2_CR_inst_addr                                         "0x0088"
+#define HDCP_2P2_CR_inst                                              0x0088
+#define set_HDCP_2P2_CR_reg(data)                                     (*((volatile unsigned int*)HDCP_2P2_CR_reg)=data)
+#define get_HDCP_2P2_CR_reg                                           (*((volatile unsigned int*)HDCP_2P2_CR_reg))
+#define HDCP_2P2_CR_dummy_31_27_shift                                 (27)
+#define HDCP_2P2_CR_fn_auto_inc_shift                                 (26)
+#define HDCP_2P2_CR_apply_cp_fn_shift                                 (25)
+#define HDCP_2P2_CR_ks_encoded_shift                                  (24)
+#define HDCP_2P2_CR_switch_state_shift                                (12)
+#define HDCP_2P2_CR_rpt_thr_unauth_shift                              (11)
+#define HDCP_2P2_CR_fw_mode_riv_shift                                 (10)
+#define HDCP_2P2_CR_apply_state_shift                                 (9)
+#define HDCP_2P2_CR_mspai_shift                                       (8)
+#define HDCP_2P2_CR_new_auth_device_shift                             (7)
+#define HDCP_2P2_CR_verify_id_pass_shift                              (6)
+#define HDCP_2P2_CR_verify_id_done_shift                              (5)
+#define HDCP_2P2_CR_assemble_id_fail_shift                            (4)
+#define HDCP_2P2_CR_downstream_done_shift                             (3)
+#define HDCP_2P2_CR_ks_done_shift                                     (2)
+#define HDCP_2P2_CR_switch_unauth_shift                               (1)
+#define HDCP_2P2_CR_hdcp_2p2_en_shift                                 (0)
+#define HDCP_2P2_CR_dummy_31_27_mask                                  (0xF8000000)
+#define HDCP_2P2_CR_fn_auto_inc_mask                                  (0x04000000)
+#define HDCP_2P2_CR_apply_cp_fn_mask                                  (0x02000000)
+#define HDCP_2P2_CR_ks_encoded_mask                                   (0x01000000)
+#define HDCP_2P2_CR_switch_state_mask                                 (0x00FFF000)
+#define HDCP_2P2_CR_rpt_thr_unauth_mask                               (0x00000800)
+#define HDCP_2P2_CR_fw_mode_riv_mask                                  (0x00000400)
+#define HDCP_2P2_CR_apply_state_mask                                  (0x00000200)
+#define HDCP_2P2_CR_mspai_mask                                        (0x00000100)
+#define HDCP_2P2_CR_new_auth_device_mask                              (0x00000080)
+#define HDCP_2P2_CR_verify_id_pass_mask                               (0x00000040)
+#define HDCP_2P2_CR_verify_id_done_mask                               (0x00000020)
+#define HDCP_2P2_CR_assemble_id_fail_mask                             (0x00000010)
+#define HDCP_2P2_CR_downstream_done_mask                              (0x00000008)
+#define HDCP_2P2_CR_ks_done_mask                                      (0x00000004)
+#define HDCP_2P2_CR_switch_unauth_mask                                (0x00000002)
+#define HDCP_2P2_CR_hdcp_2p2_en_mask                                  (0x00000001)
+#define HDCP_2P2_CR_dummy_31_27(data)                                 (0xF8000000&((data)<<27))
+#define HDCP_2P2_CR_fn_auto_inc(data)                                 (0x04000000&((data)<<26))
+#define HDCP_2P2_CR_apply_cp_fn(data)                                 (0x02000000&((data)<<25))
+#define HDCP_2P2_CR_ks_encoded(data)                                  (0x01000000&((data)<<24))
+#define HDCP_2P2_CR_switch_state(data)                                (0x00FFF000&((data)<<12))
+#define HDCP_2P2_CR_rpt_thr_unauth(data)                              (0x00000800&((data)<<11))
+#define HDCP_2P2_CR_fw_mode_riv(data)                                 (0x00000400&((data)<<10))
+#define HDCP_2P2_CR_apply_state(data)                                 (0x00000200&((data)<<9))
+#define HDCP_2P2_CR_mspai(data)                                       (0x00000100&((data)<<8))
+#define HDCP_2P2_CR_new_auth_device(data)                             (0x00000080&((data)<<7))
+#define HDCP_2P2_CR_verify_id_pass(data)                              (0x00000040&((data)<<6))
+#define HDCP_2P2_CR_verify_id_done(data)                              (0x00000020&((data)<<5))
+#define HDCP_2P2_CR_assemble_id_fail(data)                            (0x00000010&((data)<<4))
+#define HDCP_2P2_CR_downstream_done(data)                             (0x00000008&((data)<<3))
+#define HDCP_2P2_CR_ks_done(data)                                     (0x00000004&((data)<<2))
+#define HDCP_2P2_CR_switch_unauth(data)                               (0x00000002&((data)<<1))
+#define HDCP_2P2_CR_hdcp_2p2_en(data)                                 (0x00000001&(data))
+#define HDCP_2P2_CR_get_dummy_31_27(data)                             ((0xF8000000&(data))>>27)
+#define HDCP_2P2_CR_get_fn_auto_inc(data)                             ((0x04000000&(data))>>26)
+#define HDCP_2P2_CR_get_apply_cp_fn(data)                             ((0x02000000&(data))>>25)
+#define HDCP_2P2_CR_get_ks_encoded(data)                              ((0x01000000&(data))>>24)
+#define HDCP_2P2_CR_get_switch_state(data)                            ((0x00FFF000&(data))>>12)
+#define HDCP_2P2_CR_get_rpt_thr_unauth(data)                          ((0x00000800&(data))>>11)
+#define HDCP_2P2_CR_get_fw_mode_riv(data)                             ((0x00000400&(data))>>10)
+#define HDCP_2P2_CR_get_apply_state(data)                             ((0x00000200&(data))>>9)
+#define HDCP_2P2_CR_get_mspai(data)                                   ((0x00000100&(data))>>8)
+#define HDCP_2P2_CR_get_new_auth_device(data)                         ((0x00000080&(data))>>7)
+#define HDCP_2P2_CR_get_verify_id_pass(data)                          ((0x00000040&(data))>>6)
+#define HDCP_2P2_CR_get_verify_id_done(data)                          ((0x00000020&(data))>>5)
+#define HDCP_2P2_CR_get_assemble_id_fail(data)                        ((0x00000010&(data))>>4)
+#define HDCP_2P2_CR_get_downstream_done(data)                         ((0x00000008&(data))>>3)
+#define HDCP_2P2_CR_get_ks_done(data)                                 ((0x00000004&(data))>>2)
+#define HDCP_2P2_CR_get_switch_unauth(data)                           ((0x00000002&(data))>>1)
+#define HDCP_2P2_CR_get_hdcp_2p2_en(data)                             (0x00000001&(data))
+
+
+#define HDCP_2P2_KS0                                                  0x224
+#define HDCP_2P2_KS0_reg_addr                                         "0x98034224"
+#define HDCP_2P2_KS0_reg                                              0x98034224
+#define HDCP_2P2_KS0_inst_addr                                        "0x0089"
+#define HDCP_2P2_KS0_inst                                             0x0089
+#define set_HDCP_2P2_KS0_reg(data)                                    (*((volatile unsigned int*)HDCP_2P2_KS0_reg)=data)
+#define get_HDCP_2P2_KS0_reg                                          (*((volatile unsigned int*)HDCP_2P2_KS0_reg))
+#define HDCP_2P2_KS0_ks_shift                                         (0)
+#define HDCP_2P2_KS0_ks_mask                                          (0xFFFFFFFF)
+#define HDCP_2P2_KS0_ks(data)                                         (0xFFFFFFFF&(data))
+#define HDCP_2P2_KS0_get_ks(data)                                     (0xFFFFFFFF&(data))
+
+
+#define HDCP_2P2_KS1                                                  0x228
+#define HDCP_2P2_KS1_reg_addr                                         "0x98034228"
+#define HDCP_2P2_KS1_reg                                              0x98034228
+#define HDCP_2P2_KS1_inst_addr                                        "0x008A"
+#define HDCP_2P2_KS1_inst                                             0x008A
+#define set_HDCP_2P2_KS1_reg(data)                                    (*((volatile unsigned int*)HDCP_2P2_KS1_reg)=data)
+#define get_HDCP_2P2_KS1_reg                                          (*((volatile unsigned int*)HDCP_2P2_KS1_reg))
+#define HDCP_2P2_KS1_ks_shift                                         (0)
+#define HDCP_2P2_KS1_ks_mask                                          (0xFFFFFFFF)
+#define HDCP_2P2_KS1_ks(data)                                         (0xFFFFFFFF&(data))
+#define HDCP_2P2_KS1_get_ks(data)                                     (0xFFFFFFFF&(data))
+
+
+#define HDCP_2P2_KS2                                                  0x22c
+#define HDCP_2P2_KS2_reg_addr                                         "0x9803422c"
+#define HDCP_2P2_KS2_reg                                              0x9803422c
+#define HDCP_2P2_KS2_inst_addr                                        "0x008B"
+#define HDCP_2P2_KS2_inst                                             0x008B
+#define set_HDCP_2P2_KS2_reg(data)                                    (*((volatile unsigned int*)HDCP_2P2_KS2_reg)=data)
+#define get_HDCP_2P2_KS2_reg                                          (*((volatile unsigned int*)HDCP_2P2_KS2_reg))
+#define HDCP_2P2_KS2_ks_shift                                         (0)
+#define HDCP_2P2_KS2_ks_mask                                          (0xFFFFFFFF)
+#define HDCP_2P2_KS2_ks(data)                                         (0xFFFFFFFF&(data))
+#define HDCP_2P2_KS2_get_ks(data)                                     (0xFFFFFFFF&(data))
+
+
+#define HDCP_2P2_KS3                                                  0x230
+#define HDCP_2P2_KS3_reg_addr                                         "0x98034230"
+#define HDCP_2P2_KS3_reg                                              0x98034230
+#define HDCP_2P2_KS3_inst_addr                                        "0x008C"
+#define HDCP_2P2_KS3_inst                                             0x008C
+#define set_HDCP_2P2_KS3_reg(data)                                    (*((volatile unsigned int*)HDCP_2P2_KS3_reg)=data)
+#define get_HDCP_2P2_KS3_reg                                          (*((volatile unsigned int*)HDCP_2P2_KS3_reg))
+#define HDCP_2P2_KS3_ks_shift                                         (0)
+#define HDCP_2P2_KS3_ks_mask                                          (0xFFFFFFFF)
+#define HDCP_2P2_KS3_ks(data)                                         (0xFFFFFFFF&(data))
+#define HDCP_2P2_KS3_get_ks(data)                                     (0xFFFFFFFF&(data))
+
+
+#define HDCP_2P2_LC0                                                  0x234
+#define HDCP_2P2_LC0_reg_addr                                         "0x98034234"
+#define HDCP_2P2_LC0_reg                                              0x98034234
+#define HDCP_2P2_LC0_inst_addr                                        "0x008D"
+#define HDCP_2P2_LC0_inst                                             0x008D
+#define set_HDCP_2P2_LC0_reg(data)                                    (*((volatile unsigned int*)HDCP_2P2_LC0_reg)=data)
+#define get_HDCP_2P2_LC0_reg                                          (*((volatile unsigned int*)HDCP_2P2_LC0_reg))
+#define HDCP_2P2_LC0_lc_shift                                         (0)
+#define HDCP_2P2_LC0_lc_mask                                          (0xFFFFFFFF)
+#define HDCP_2P2_LC0_lc(data)                                         (0xFFFFFFFF&(data))
+#define HDCP_2P2_LC0_get_lc(data)                                     (0xFFFFFFFF&(data))
+
+
+#define HDCP_2P2_LC1                                                  0x238
+#define HDCP_2P2_LC1_reg_addr                                         "0x98034238"
+#define HDCP_2P2_LC1_reg                                              0x98034238
+#define HDCP_2P2_LC1_inst_addr                                        "0x008E"
+#define HDCP_2P2_LC1_inst                                             0x008E
+#define set_HDCP_2P2_LC1_reg(data)                                    (*((volatile unsigned int*)HDCP_2P2_LC1_reg)=data)
+#define get_HDCP_2P2_LC1_reg                                          (*((volatile unsigned int*)HDCP_2P2_LC1_reg))
+#define HDCP_2P2_LC1_lc_shift                                         (0)
+#define HDCP_2P2_LC1_lc_mask                                          (0xFFFFFFFF)
+#define HDCP_2P2_LC1_lc(data)                                         (0xFFFFFFFF&(data))
+#define HDCP_2P2_LC1_get_lc(data)                                     (0xFFFFFFFF&(data))
+
+
+#define HDCP_2P2_LC2                                                  0x23c
+#define HDCP_2P2_LC2_reg_addr                                         "0x9803423c"
+#define HDCP_2P2_LC2_reg                                              0x9803423c
+#define HDCP_2P2_LC2_inst_addr                                        "0x008F"
+#define HDCP_2P2_LC2_inst                                             0x008F
+#define set_HDCP_2P2_LC2_reg(data)                                    (*((volatile unsigned int*)HDCP_2P2_LC2_reg)=data)
+#define get_HDCP_2P2_LC2_reg                                          (*((volatile unsigned int*)HDCP_2P2_LC2_reg))
+#define HDCP_2P2_LC2_lc_shift                                         (0)
+#define HDCP_2P2_LC2_lc_mask                                          (0xFFFFFFFF)
+#define HDCP_2P2_LC2_lc(data)                                         (0xFFFFFFFF&(data))
+#define HDCP_2P2_LC2_get_lc(data)                                     (0xFFFFFFFF&(data))
+
+
+#define HDCP_2P2_LC3                                                  0x240
+#define HDCP_2P2_LC3_reg_addr                                         "0x98034240"
+#define HDCP_2P2_LC3_reg                                              0x98034240
+#define HDCP_2P2_LC3_inst_addr                                        "0x0090"
+#define HDCP_2P2_LC3_inst                                             0x0090
+#define set_HDCP_2P2_LC3_reg(data)                                    (*((volatile unsigned int*)HDCP_2P2_LC3_reg)=data)
+#define get_HDCP_2P2_LC3_reg                                          (*((volatile unsigned int*)HDCP_2P2_LC3_reg))
+#define HDCP_2P2_LC3_lc_shift                                         (0)
+#define HDCP_2P2_LC3_lc_mask                                          (0xFFFFFFFF)
+#define HDCP_2P2_LC3_lc(data)                                         (0xFFFFFFFF&(data))
+#define HDCP_2P2_LC3_get_lc(data)                                     (0xFFFFFFFF&(data))
+
+
+#define HDCP_2P2_RIV0                                                 0x244
+#define HDCP_2P2_RIV0_reg_addr                                        "0x98034244"
+#define HDCP_2P2_RIV0_reg                                             0x98034244
+#define HDCP_2P2_RIV0_inst_addr                                       "0x0091"
+#define HDCP_2P2_RIV0_inst                                            0x0091
+#define set_HDCP_2P2_RIV0_reg(data)                                   (*((volatile unsigned int*)HDCP_2P2_RIV0_reg)=data)
+#define get_HDCP_2P2_RIV0_reg                                         (*((volatile unsigned int*)HDCP_2P2_RIV0_reg))
+#define HDCP_2P2_RIV0_riv_shift                                       (0)
+#define HDCP_2P2_RIV0_riv_mask                                        (0xFFFFFFFF)
+#define HDCP_2P2_RIV0_riv(data)                                       (0xFFFFFFFF&(data))
+#define HDCP_2P2_RIV0_get_riv(data)                                   (0xFFFFFFFF&(data))
+
+
+#define HDCP_2P2_RIV1                                                 0x248
+#define HDCP_2P2_RIV1_reg_addr                                        "0x98034248"
+#define HDCP_2P2_RIV1_reg                                             0x98034248
+#define HDCP_2P2_RIV1_inst_addr                                       "0x0092"
+#define HDCP_2P2_RIV1_inst                                            0x0092
+#define set_HDCP_2P2_RIV1_reg(data)                                   (*((volatile unsigned int*)HDCP_2P2_RIV1_reg)=data)
+#define get_HDCP_2P2_RIV1_reg                                         (*((volatile unsigned int*)HDCP_2P2_RIV1_reg))
+#define HDCP_2P2_RIV1_riv_shift                                       (0)
+#define HDCP_2P2_RIV1_riv_mask                                        (0xFFFFFFFF)
+#define HDCP_2P2_RIV1_riv(data)                                       (0xFFFFFFFF&(data))
+#define HDCP_2P2_RIV1_get_riv(data)                                   (0xFFFFFFFF&(data))
+
+
+#define HDCP_2P2_SR0                                                  0x24c
+#define HDCP_2P2_SR0_reg_addr                                         "0x9803424c"
+#define HDCP_2P2_SR0_reg                                              0x9803424c
+#define HDCP_2P2_SR0_inst_addr                                        "0x0093"
+#define HDCP_2P2_SR0_inst                                             0x0093
+#define set_HDCP_2P2_SR0_reg(data)                                    (*((volatile unsigned int*)HDCP_2P2_SR0_reg)=data)
+#define get_HDCP_2P2_SR0_reg                                          (*((volatile unsigned int*)HDCP_2P2_SR0_reg))
+#define HDCP_2P2_SR0_frame_number_shift                               (22)
+#define HDCP_2P2_SR0_irq_fn_compare_fail_shift                        (21)
+#define HDCP_2P2_SR0_irq_crc_fail_shift                               (20)
+#define HDCP_2P2_SR0_irq_no_cp_packet_shift                           (19)
+#define HDCP_2P2_SR0_irq_msg_overwrite_shift                          (18)
+#define HDCP_2P2_SR0_irq_unauth_chg_shift                             (17)
+#define HDCP_2P2_SR0_irq_state_chg_shift                              (16)
+#define HDCP_2P2_SR0_irq_rd_msg_done_shift                            (15)
+#define HDCP_2P2_SR0_irq_wr_msg_done_shift                            (14)
+#define HDCP_2P2_SR0_irq_rd_msg_start_shift                           (13)
+#define HDCP_2P2_SR0_irq_wr_msg_start_shift                           (12)
+#define HDCP_2P2_SR0_state_shift                                      (0)
+#define HDCP_2P2_SR0_frame_number_mask                                (0x3FC00000)
+#define HDCP_2P2_SR0_irq_fn_compare_fail_mask                         (0x00200000)
+#define HDCP_2P2_SR0_irq_crc_fail_mask                                (0x00100000)
+#define HDCP_2P2_SR0_irq_no_cp_packet_mask                            (0x00080000)
+#define HDCP_2P2_SR0_irq_msg_overwrite_mask                           (0x00040000)
+#define HDCP_2P2_SR0_irq_unauth_chg_mask                              (0x00020000)
+#define HDCP_2P2_SR0_irq_state_chg_mask                               (0x00010000)
+#define HDCP_2P2_SR0_irq_rd_msg_done_mask                             (0x00008000)
+#define HDCP_2P2_SR0_irq_wr_msg_done_mask                             (0x00004000)
+#define HDCP_2P2_SR0_irq_rd_msg_start_mask                            (0x00002000)
+#define HDCP_2P2_SR0_irq_wr_msg_start_mask                            (0x00001000)
+#define HDCP_2P2_SR0_state_mask                                       (0x00000FFF)
+#define HDCP_2P2_SR0_frame_number(data)                               (0x3FC00000&((data)<<22))
+#define HDCP_2P2_SR0_irq_fn_compare_fail(data)                        (0x00200000&((data)<<21))
+#define HDCP_2P2_SR0_irq_crc_fail(data)                               (0x00100000&((data)<<20))
+#define HDCP_2P2_SR0_irq_no_cp_packet(data)                           (0x00080000&((data)<<19))
+#define HDCP_2P2_SR0_irq_msg_overwrite(data)                          (0x00040000&((data)<<18))
+#define HDCP_2P2_SR0_irq_unauth_chg(data)                             (0x00020000&((data)<<17))
+#define HDCP_2P2_SR0_irq_state_chg(data)                              (0x00010000&((data)<<16))
+#define HDCP_2P2_SR0_irq_rd_msg_done(data)                            (0x00008000&((data)<<15))
+#define HDCP_2P2_SR0_irq_wr_msg_done(data)                            (0x00004000&((data)<<14))
+#define HDCP_2P2_SR0_irq_rd_msg_start(data)                           (0x00002000&((data)<<13))
+#define HDCP_2P2_SR0_irq_wr_msg_start(data)                           (0x00001000&((data)<<12))
+#define HDCP_2P2_SR0_state(data)                                      (0x00000FFF&(data))
+#define HDCP_2P2_SR0_get_frame_number(data)                           ((0x3FC00000&(data))>>22)
+#define HDCP_2P2_SR0_get_irq_fn_compare_fail(data)                    ((0x00200000&(data))>>21)
+#define HDCP_2P2_SR0_get_irq_crc_fail(data)                           ((0x00100000&(data))>>20)
+#define HDCP_2P2_SR0_get_irq_no_cp_packet(data)                       ((0x00080000&(data))>>19)
+#define HDCP_2P2_SR0_get_irq_msg_overwrite(data)                      ((0x00040000&(data))>>18)
+#define HDCP_2P2_SR0_get_irq_unauth_chg(data)                         ((0x00020000&(data))>>17)
+#define HDCP_2P2_SR0_get_irq_state_chg(data)                          ((0x00010000&(data))>>16)
+#define HDCP_2P2_SR0_get_irq_rd_msg_done(data)                        ((0x00008000&(data))>>15)
+#define HDCP_2P2_SR0_get_irq_wr_msg_done(data)                        ((0x00004000&(data))>>14)
+#define HDCP_2P2_SR0_get_irq_rd_msg_start(data)                       ((0x00002000&(data))>>13)
+#define HDCP_2P2_SR0_get_irq_wr_msg_start(data)                       ((0x00001000&(data))>>12)
+#define HDCP_2P2_SR0_get_state(data)                                  (0x00000FFF&(data))
+
+
+#define HDCP_2P2_SR1                                                  0x250
+#define HDCP_2P2_SR1_reg_addr                                         "0x98034250"
+#define HDCP_2P2_SR1_reg                                              0x98034250
+#define HDCP_2P2_SR1_inst_addr                                        "0x0094"
+#define HDCP_2P2_SR1_inst                                             0x0094
+#define set_HDCP_2P2_SR1_reg(data)                                    (*((volatile unsigned int*)HDCP_2P2_SR1_reg)=data)
+#define get_HDCP_2P2_SR1_reg                                          (*((volatile unsigned int*)HDCP_2P2_SR1_reg))
+#define HDCP_2P2_SR1_crc_fail_wd_en_shift                             (11)
+#define HDCP_2P2_SR1_no_cp_packet_wd_en_shift                         (10)
+#define HDCP_2P2_SR1_irq_fn_compare_fail_en_shift                     (9)
+#define HDCP_2P2_SR1_irq_crc_fail_en_shift                            (8)
+#define HDCP_2P2_SR1_irq_no_cp_packet_en_shift                        (7)
+#define HDCP_2P2_SR1_irq_msg_overwrite_en_shift                       (6)
+#define HDCP_2P2_SR1_irq_unauth_chg_en_shift                          (5)
+#define HDCP_2P2_SR1_irq_state_chg_en_shift                           (4)
+#define HDCP_2P2_SR1_irq_rd_msg_done_en_shift                         (3)
+#define HDCP_2P2_SR1_irq_wr_msg_done_en_shift                         (2)
+#define HDCP_2P2_SR1_irq_rd_msg_start_en_shift                        (1)
+#define HDCP_2P2_SR1_irq_wr_msg_start_en_shift                        (0)
+#define HDCP_2P2_SR1_crc_fail_wd_en_mask                              (0x00000800)
+#define HDCP_2P2_SR1_no_cp_packet_wd_en_mask                          (0x00000400)
+#define HDCP_2P2_SR1_irq_fn_compare_fail_en_mask                      (0x00000200)
+#define HDCP_2P2_SR1_irq_crc_fail_en_mask                             (0x00000100)
+#define HDCP_2P2_SR1_irq_no_cp_packet_en_mask                         (0x00000080)
+#define HDCP_2P2_SR1_irq_msg_overwrite_en_mask                        (0x00000040)
+#define HDCP_2P2_SR1_irq_unauth_chg_en_mask                           (0x00000020)
+#define HDCP_2P2_SR1_irq_state_chg_en_mask                            (0x00000010)
+#define HDCP_2P2_SR1_irq_rd_msg_done_en_mask                          (0x00000008)
+#define HDCP_2P2_SR1_irq_wr_msg_done_en_mask                          (0x00000004)
+#define HDCP_2P2_SR1_irq_rd_msg_start_en_mask                         (0x00000002)
+#define HDCP_2P2_SR1_irq_wr_msg_start_en_mask                         (0x00000001)
+#define HDCP_2P2_SR1_crc_fail_wd_en(data)                             (0x00000800&((data)<<11))
+#define HDCP_2P2_SR1_no_cp_packet_wd_en(data)                         (0x00000400&((data)<<10))
+#define HDCP_2P2_SR1_irq_fn_compare_fail_en(data)                     (0x00000200&((data)<<9))
+#define HDCP_2P2_SR1_irq_crc_fail_en(data)                            (0x00000100&((data)<<8))
+#define HDCP_2P2_SR1_irq_no_cp_packet_en(data)                        (0x00000080&((data)<<7))
+#define HDCP_2P2_SR1_irq_msg_overwrite_en(data)                       (0x00000040&((data)<<6))
+#define HDCP_2P2_SR1_irq_unauth_chg_en(data)                          (0x00000020&((data)<<5))
+#define HDCP_2P2_SR1_irq_state_chg_en(data)                           (0x00000010&((data)<<4))
+#define HDCP_2P2_SR1_irq_rd_msg_done_en(data)                         (0x00000008&((data)<<3))
+#define HDCP_2P2_SR1_irq_wr_msg_done_en(data)                         (0x00000004&((data)<<2))
+#define HDCP_2P2_SR1_irq_rd_msg_start_en(data)                        (0x00000002&((data)<<1))
+#define HDCP_2P2_SR1_irq_wr_msg_start_en(data)                        (0x00000001&(data))
+#define HDCP_2P2_SR1_get_crc_fail_wd_en(data)                         ((0x00000800&(data))>>11)
+#define HDCP_2P2_SR1_get_no_cp_packet_wd_en(data)                     ((0x00000400&(data))>>10)
+#define HDCP_2P2_SR1_get_irq_fn_compare_fail_en(data)                 ((0x00000200&(data))>>9)
+#define HDCP_2P2_SR1_get_irq_crc_fail_en(data)                        ((0x00000100&(data))>>8)
+#define HDCP_2P2_SR1_get_irq_no_cp_packet_en(data)                    ((0x00000080&(data))>>7)
+#define HDCP_2P2_SR1_get_irq_msg_overwrite_en(data)                   ((0x00000040&(data))>>6)
+#define HDCP_2P2_SR1_get_irq_unauth_chg_en(data)                      ((0x00000020&(data))>>5)
+#define HDCP_2P2_SR1_get_irq_state_chg_en(data)                       ((0x00000010&(data))>>4)
+#define HDCP_2P2_SR1_get_irq_rd_msg_done_en(data)                     ((0x00000008&(data))>>3)
+#define HDCP_2P2_SR1_get_irq_wr_msg_done_en(data)                     ((0x00000004&(data))>>2)
+#define HDCP_2P2_SR1_get_irq_rd_msg_start_en(data)                    ((0x00000002&(data))>>1)
+#define HDCP_2P2_SR1_get_irq_wr_msg_start_en(data)                    (0x00000001&(data))
+
+
+#define HDCP_MSAP                                                     0x254
+#define HDCP_MSAP_reg_addr                                            "0x98034254"
+#define HDCP_MSAP_reg                                                 0x98034254
+#define HDCP_MSAP_inst_addr                                           "0x0095"
+#define HDCP_MSAP_inst                                                0x0095
+#define set_HDCP_MSAP_reg(data)                                       (*((volatile unsigned int*)HDCP_MSAP_reg)=data)
+#define get_HDCP_MSAP_reg                                             (*((volatile unsigned int*)HDCP_MSAP_reg))
+#define HDCP_MSAP_ap1_shift                                           (0)
+#define HDCP_MSAP_ap1_mask                                            (0x000003FF)
+#define HDCP_MSAP_ap1(data)                                           (0x000003FF&(data))
+#define HDCP_MSAP_get_ap1(data)                                       (0x000003FF&(data))
+
+
+#define HDCP_MSDP                                                     0x258
+#define HDCP_MSDP_reg_addr                                            "0x98034258"
+#define HDCP_MSDP_reg                                                 0x98034258
+#define HDCP_MSDP_inst_addr                                           "0x0096"
+#define HDCP_MSDP_inst                                                0x0096
+#define set_HDCP_MSDP_reg(data)                                       (*((volatile unsigned int*)HDCP_MSDP_reg)=data)
+#define get_HDCP_MSDP_reg                                             (*((volatile unsigned int*)HDCP_MSDP_reg))
+#define HDCP_MSDP_dp1_shift                                           (0)
+#define HDCP_MSDP_dp1_mask                                            (0x000000FF)
+#define HDCP_MSDP_dp1(data)                                           (0x000000FF&(data))
+#define HDCP_MSDP_get_dp1(data)                                       (0x000000FF&(data))
+
+
+#define HDMI_CMCR                                                     0x300
+#define HDMI_CMCR_reg_addr                                            "0x98034300"
+#define HDMI_CMCR_reg                                                 0x98034300
+#define HDMI_CMCR_inst_addr                                           "0x00C0"
+#define HDMI_CMCR_inst                                                0x00C0
+#define set_HDMI_CMCR_reg(data)                                       (*((volatile unsigned int*)HDMI_CMCR_reg)=data)
+#define get_HDMI_CMCR_reg                                             (*((volatile unsigned int*)HDMI_CMCR_reg))
+#define HDMI_CMCR_icmux_shift                                         (7)
+#define HDMI_CMCR_ocs_shift                                           (5)
+#define HDMI_CMCR_dbdcb_shift                                         (4)
+#define HDMI_CMCR_dummy_3_0_shift                                     (0)
+#define HDMI_CMCR_icmux_mask                                          (0x00000080)
+#define HDMI_CMCR_ocs_mask                                            (0x00000060)
+#define HDMI_CMCR_dbdcb_mask                                          (0x00000010)
+#define HDMI_CMCR_dummy_3_0_mask                                      (0x0000000F)
+#define HDMI_CMCR_icmux(data)                                         (0x00000080&((data)<<7))
+#define HDMI_CMCR_ocs(data)                                           (0x00000060&((data)<<5))
+#define HDMI_CMCR_dbdcb(data)                                         (0x00000010&((data)<<4))
+#define HDMI_CMCR_dummy_3_0(data)                                     (0x0000000F&(data))
+#define HDMI_CMCR_get_icmux(data)                                     ((0x00000080&(data))>>7)
+#define HDMI_CMCR_get_ocs(data)                                       ((0x00000060&(data))>>5)
+#define HDMI_CMCR_get_dbdcb(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_CMCR_get_dummy_3_0(data)                                 (0x0000000F&(data))
+
+
+#define HDMI_MCAPR                                                    0x304
+#define HDMI_MCAPR_reg_addr                                           "0x98034304"
+#define HDMI_MCAPR_reg                                                0x98034304
+#define HDMI_MCAPR_inst_addr                                          "0x00C1"
+#define HDMI_MCAPR_inst                                               0x00C1
+#define set_HDMI_MCAPR_reg(data)                                      (*((volatile unsigned int*)HDMI_MCAPR_reg)=data)
+#define get_HDMI_MCAPR_reg                                            (*((volatile unsigned int*)HDMI_MCAPR_reg))
+#define HDMI_MCAPR_dummy_7_0_shift                                    (0)
+#define HDMI_MCAPR_dummy_7_0_mask                                     (0x000000FF)
+#define HDMI_MCAPR_dummy_7_0(data)                                    (0x000000FF&(data))
+#define HDMI_MCAPR_get_dummy_7_0(data)                                (0x000000FF&(data))
+
+
+#define HDMI_SCAPR                                                    0x308
+#define HDMI_SCAPR_reg_addr                                           "0x98034308"
+#define HDMI_SCAPR_reg                                                0x98034308
+#define HDMI_SCAPR_inst_addr                                          "0x00C2"
+#define HDMI_SCAPR_inst                                               0x00C2
+#define set_HDMI_SCAPR_reg(data)                                      (*((volatile unsigned int*)HDMI_SCAPR_reg)=data)
+#define get_HDMI_SCAPR_reg                                            (*((volatile unsigned int*)HDMI_SCAPR_reg))
+#define HDMI_SCAPR_s1_code_msb_r_shift                                (17)
+#define HDMI_SCAPR_slc_r_shift                                        (16)
+#define HDMI_SCAPR_sc_r_shift                                         (9)
+#define HDMI_SCAPR_s1_code_msb_shift                                  (8)
+#define HDMI_SCAPR_slc_shift                                          (7)
+#define HDMI_SCAPR_sc_shift                                           (0)
+#define HDMI_SCAPR_s1_code_msb_r_mask                                 (0x00020000)
+#define HDMI_SCAPR_slc_r_mask                                         (0x00010000)
+#define HDMI_SCAPR_sc_r_mask                                          (0x0000FE00)
+#define HDMI_SCAPR_s1_code_msb_mask                                   (0x00000100)
+#define HDMI_SCAPR_slc_mask                                           (0x00000080)
+#define HDMI_SCAPR_sc_mask                                            (0x0000007F)
+#define HDMI_SCAPR_s1_code_msb_r(data)                                (0x00020000&((data)<<17))
+#define HDMI_SCAPR_slc_r(data)                                        (0x00010000&((data)<<16))
+#define HDMI_SCAPR_sc_r(data)                                         (0x0000FE00&((data)<<9))
+#define HDMI_SCAPR_s1_code_msb(data)                                  (0x00000100&((data)<<8))
+#define HDMI_SCAPR_slc(data)                                          (0x00000080&((data)<<7))
+#define HDMI_SCAPR_sc(data)                                           (0x0000007F&(data))
+#define HDMI_SCAPR_get_s1_code_msb_r(data)                            ((0x00020000&(data))>>17)
+#define HDMI_SCAPR_get_slc_r(data)                                    ((0x00010000&(data))>>16)
+#define HDMI_SCAPR_get_sc_r(data)                                     ((0x0000FE00&(data))>>9)
+#define HDMI_SCAPR_get_s1_code_msb(data)                              ((0x00000100&(data))>>8)
+#define HDMI_SCAPR_get_slc(data)                                      ((0x00000080&(data))>>7)
+#define HDMI_SCAPR_get_sc(data)                                       (0x0000007F&(data))
+
+
+#define HDMI_DCAPR0                                                   0x30c
+#define HDMI_DCAPR0_reg_addr                                          "0x9803430c"
+#define HDMI_DCAPR0_reg                                               0x9803430c
+#define HDMI_DCAPR0_inst_addr                                         "0x00C3"
+#define HDMI_DCAPR0_inst                                              0x00C3
+#define set_HDMI_DCAPR0_reg(data)                                     (*((volatile unsigned int*)HDMI_DCAPR0_reg)=data)
+#define get_HDMI_DCAPR0_reg                                           (*((volatile unsigned int*)HDMI_DCAPR0_reg))
+#define HDMI_DCAPR0_dcaprh_shift                                      (8)
+#define HDMI_DCAPR0_dcaprl_shift                                      (0)
+#define HDMI_DCAPR0_dcaprh_mask                                       (0x0000FF00)
+#define HDMI_DCAPR0_dcaprl_mask                                       (0x000000FF)
+#define HDMI_DCAPR0_dcaprh(data)                                      (0x0000FF00&((data)<<8))
+#define HDMI_DCAPR0_dcaprl(data)                                      (0x000000FF&(data))
+#define HDMI_DCAPR0_get_dcaprh(data)                                  ((0x0000FF00&(data))>>8)
+#define HDMI_DCAPR0_get_dcaprl(data)                                  (0x000000FF&(data))
+
+
+#define HDMI_PSCR                                                     0x310
+#define HDMI_PSCR_reg_addr                                            "0x98034310"
+#define HDMI_PSCR_reg                                                 0x98034310
+#define HDMI_PSCR_inst_addr                                           "0x00C4"
+#define HDMI_PSCR_inst                                                0x00C4
+#define set_HDMI_PSCR_reg(data)                                       (*((volatile unsigned int*)HDMI_PSCR_reg)=data)
+#define get_HDMI_PSCR_reg                                             (*((volatile unsigned int*)HDMI_PSCR_reg))
+#define HDMI_PSCR_fdint_shift                                         (5)
+#define HDMI_PSCR_etcn_shift                                          (4)
+#define HDMI_PSCR_etfd_shift                                          (3)
+#define HDMI_PSCR_etfbc_shift                                         (2)
+#define HDMI_PSCR_pecs_shift                                          (0)
+#define HDMI_PSCR_fdint_mask                                          (0x000000E0)
+#define HDMI_PSCR_etcn_mask                                           (0x00000010)
+#define HDMI_PSCR_etfd_mask                                           (0x00000008)
+#define HDMI_PSCR_etfbc_mask                                          (0x00000004)
+#define HDMI_PSCR_pecs_mask                                           (0x00000003)
+#define HDMI_PSCR_fdint(data)                                         (0x000000E0&((data)<<5))
+#define HDMI_PSCR_etcn(data)                                          (0x00000010&((data)<<4))
+#define HDMI_PSCR_etfd(data)                                          (0x00000008&((data)<<3))
+#define HDMI_PSCR_etfbc(data)                                         (0x00000004&((data)<<2))
+#define HDMI_PSCR_pecs(data)                                          (0x00000003&(data))
+#define HDMI_PSCR_get_fdint(data)                                     ((0x000000E0&(data))>>5)
+#define HDMI_PSCR_get_etcn(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_PSCR_get_etfd(data)                                      ((0x00000008&(data))>>3)
+#define HDMI_PSCR_get_etfbc(data)                                     ((0x00000004&(data))>>2)
+#define HDMI_PSCR_get_pecs(data)                                      (0x00000003&(data))
+
+
+#define HDMI_AFDD                                                     0x31c
+#define HDMI_AFDD_reg_addr                                            "0x9803431c"
+#define HDMI_AFDD_reg                                                 0x9803431c
+#define HDMI_AFDD_inst_addr                                           "0x00C7"
+#define HDMI_AFDD_inst                                                0x00C7
+#define set_HDMI_AFDD_reg(data)                                       (*((volatile unsigned int*)HDMI_AFDD_reg)=data)
+#define get_HDMI_AFDD_reg                                             (*((volatile unsigned int*)HDMI_AFDD_reg))
+#define HDMI_AFDD_mfddf_shift                                         (24)
+#define HDMI_AFDD_mfddr_shift                                         (16)
+#define HDMI_AFDD_fddf_shift                                          (8)
+#define HDMI_AFDD_fddr_shift                                          (0)
+#define HDMI_AFDD_mfddf_mask                                          (0xFF000000)
+#define HDMI_AFDD_mfddr_mask                                          (0x00FF0000)
+#define HDMI_AFDD_fddf_mask                                           (0x0000FF00)
+#define HDMI_AFDD_fddr_mask                                           (0x000000FF)
+#define HDMI_AFDD_mfddf(data)                                         (0xFF000000&((data)<<24))
+#define HDMI_AFDD_mfddr(data)                                         (0x00FF0000&((data)<<16))
+#define HDMI_AFDD_fddf(data)                                          (0x0000FF00&((data)<<8))
+#define HDMI_AFDD_fddr(data)                                          (0x000000FF&(data))
+#define HDMI_AFDD_get_mfddf(data)                                     ((0xFF000000&(data))>>24)
+#define HDMI_AFDD_get_mfddr(data)                                     ((0x00FF0000&(data))>>16)
+#define HDMI_AFDD_get_fddf(data)                                      ((0x0000FF00&(data))>>8)
+#define HDMI_AFDD_get_fddr(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_FTR                                                      0x320
+#define HDMI_FTR_reg_addr                                             "0x98034320"
+#define HDMI_FTR_reg                                                  0x98034320
+#define HDMI_FTR_inst_addr                                            "0x00C8"
+#define HDMI_FTR_inst                                                 0x00C8
+#define set_HDMI_FTR_reg(data)                                        (*((volatile unsigned int*)HDMI_FTR_reg)=data)
+#define get_HDMI_FTR_reg                                              (*((volatile unsigned int*)HDMI_FTR_reg))
+#define HDMI_FTR_tl2der_shift                                         (6)
+#define HDMI_FTR_tl2def_shift                                         (4)
+#define HDMI_FTR_tt_shift                                             (0)
+#define HDMI_FTR_tl2der_mask                                          (0x000000C0)
+#define HDMI_FTR_tl2def_mask                                          (0x00000030)
+#define HDMI_FTR_tt_mask                                              (0x0000000F)
+#define HDMI_FTR_tl2der(data)                                         (0x000000C0&((data)<<6))
+#define HDMI_FTR_tl2def(data)                                         (0x00000030&((data)<<4))
+#define HDMI_FTR_tt(data)                                             (0x0000000F&(data))
+#define HDMI_FTR_get_tl2der(data)                                     ((0x000000C0&(data))>>6)
+#define HDMI_FTR_get_tl2def(data)                                     ((0x00000030&(data))>>4)
+#define HDMI_FTR_get_tt(data)                                         (0x0000000F&(data))
+
+
+#define HDMI_FBR                                                      0x324
+#define HDMI_FBR_reg_addr                                             "0x98034324"
+#define HDMI_FBR_reg                                                  0x98034324
+#define HDMI_FBR_inst_addr                                            "0x00C9"
+#define HDMI_FBR_inst                                                 0x00C9
+#define set_HDMI_FBR_reg(data)                                        (*((volatile unsigned int*)HDMI_FBR_reg)=data)
+#define get_HDMI_FBR_reg                                              (*((volatile unsigned int*)HDMI_FBR_reg))
+#define HDMI_FBR_tfd_shift                                            (3)
+#define HDMI_FBR_bad_shift                                            (0)
+#define HDMI_FBR_tfd_mask                                             (0x000000F8)
+#define HDMI_FBR_bad_mask                                             (0x00000007)
+#define HDMI_FBR_tfd(data)                                            (0x000000F8&((data)<<3))
+#define HDMI_FBR_bad(data)                                            (0x00000007&(data))
+#define HDMI_FBR_get_tfd(data)                                        ((0x000000F8&(data))>>3)
+#define HDMI_FBR_get_bad(data)                                        (0x00000007&(data))
+
+
+#define HDMI_ICPSNCR0                                                 0x328
+#define HDMI_ICPSNCR0_reg_addr                                        "0x98034328"
+#define HDMI_ICPSNCR0_reg                                             0x98034328
+#define HDMI_ICPSNCR0_inst_addr                                       "0x00CA"
+#define HDMI_ICPSNCR0_inst                                            0x00CA
+#define set_HDMI_ICPSNCR0_reg(data)                                   (*((volatile unsigned int*)HDMI_ICPSNCR0_reg)=data)
+#define get_HDMI_ICPSNCR0_reg                                         (*((volatile unsigned int*)HDMI_ICPSNCR0_reg))
+#define HDMI_ICPSNCR0_ich_shift                                       (8)
+#define HDMI_ICPSNCR0_icl_shift                                       (0)
+#define HDMI_ICPSNCR0_ich_mask                                        (0x0000FF00)
+#define HDMI_ICPSNCR0_icl_mask                                        (0x000000FF)
+#define HDMI_ICPSNCR0_ich(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_ICPSNCR0_icl(data)                                       (0x000000FF&(data))
+#define HDMI_ICPSNCR0_get_ich(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_ICPSNCR0_get_icl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_PCPSNCR0                                                 0x32c
+#define HDMI_PCPSNCR0_reg_addr                                        "0x9803432c"
+#define HDMI_PCPSNCR0_reg                                             0x9803432c
+#define HDMI_PCPSNCR0_inst_addr                                       "0x00CB"
+#define HDMI_PCPSNCR0_inst                                            0x00CB
+#define set_HDMI_PCPSNCR0_reg(data)                                   (*((volatile unsigned int*)HDMI_PCPSNCR0_reg)=data)
+#define get_HDMI_PCPSNCR0_reg                                         (*((volatile unsigned int*)HDMI_PCPSNCR0_reg))
+#define HDMI_PCPSNCR0_pch_shift                                       (8)
+#define HDMI_PCPSNCR0_pcl_shift                                       (0)
+#define HDMI_PCPSNCR0_pch_mask                                        (0x0000FF00)
+#define HDMI_PCPSNCR0_pcl_mask                                        (0x000000FF)
+#define HDMI_PCPSNCR0_pch(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_PCPSNCR0_pcl(data)                                       (0x000000FF&(data))
+#define HDMI_PCPSNCR0_get_pch(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_PCPSNCR0_get_pcl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_ICTPSR0                                                  0x330
+#define HDMI_ICTPSR0_reg_addr                                         "0x98034330"
+#define HDMI_ICTPSR0_reg                                              0x98034330
+#define HDMI_ICTPSR0_inst_addr                                        "0x00CC"
+#define HDMI_ICTPSR0_inst                                             0x00CC
+#define set_HDMI_ICTPSR0_reg(data)                                    (*((volatile unsigned int*)HDMI_ICTPSR0_reg)=data)
+#define get_HDMI_ICTPSR0_reg                                          (*((volatile unsigned int*)HDMI_ICTPSR0_reg))
+#define HDMI_ICTPSR0_icth_shift                                       (8)
+#define HDMI_ICTPSR0_ictl_shift                                       (0)
+#define HDMI_ICTPSR0_icth_mask                                        (0x0000FF00)
+#define HDMI_ICTPSR0_ictl_mask                                        (0x000000FF)
+#define HDMI_ICTPSR0_icth(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_ICTPSR0_ictl(data)                                       (0x000000FF&(data))
+#define HDMI_ICTPSR0_get_icth(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_ICTPSR0_get_ictl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_PCTPSR0                                                  0x334
+#define HDMI_PCTPSR0_reg_addr                                         "0x98034334"
+#define HDMI_PCTPSR0_reg                                              0x98034334
+#define HDMI_PCTPSR0_inst_addr                                        "0x00CD"
+#define HDMI_PCTPSR0_inst                                             0x00CD
+#define set_HDMI_PCTPSR0_reg(data)                                    (*((volatile unsigned int*)HDMI_PCTPSR0_reg)=data)
+#define get_HDMI_PCTPSR0_reg                                          (*((volatile unsigned int*)HDMI_PCTPSR0_reg))
+#define HDMI_PCTPSR0_pcth_shift                                       (8)
+#define HDMI_PCTPSR0_pctl_shift                                       (0)
+#define HDMI_PCTPSR0_pcth_mask                                        (0x0000FF00)
+#define HDMI_PCTPSR0_pctl_mask                                        (0x000000FF)
+#define HDMI_PCTPSR0_pcth(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_PCTPSR0_pctl(data)                                       (0x000000FF&(data))
+#define HDMI_PCTPSR0_get_pcth(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_PCTPSR0_get_pctl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_ICBPSR0                                                  0x338
+#define HDMI_ICBPSR0_reg_addr                                         "0x98034338"
+#define HDMI_ICBPSR0_reg                                              0x98034338
+#define HDMI_ICBPSR0_inst_addr                                        "0x00CE"
+#define HDMI_ICBPSR0_inst                                             0x00CE
+#define set_HDMI_ICBPSR0_reg(data)                                    (*((volatile unsigned int*)HDMI_ICBPSR0_reg)=data)
+#define get_HDMI_ICBPSR0_reg                                          (*((volatile unsigned int*)HDMI_ICBPSR0_reg))
+#define HDMI_ICBPSR0_icbh_shift                                       (8)
+#define HDMI_ICBPSR0_icbl_shift                                       (0)
+#define HDMI_ICBPSR0_icbh_mask                                        (0x0000FF00)
+#define HDMI_ICBPSR0_icbl_mask                                        (0x000000FF)
+#define HDMI_ICBPSR0_icbh(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_ICBPSR0_icbl(data)                                       (0x000000FF&(data))
+#define HDMI_ICBPSR0_get_icbh(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_ICBPSR0_get_icbl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_PCBPSR0                                                  0x33c
+#define HDMI_PCBPSR0_reg_addr                                         "0x9803433c"
+#define HDMI_PCBPSR0_reg                                              0x9803433c
+#define HDMI_PCBPSR0_inst_addr                                        "0x00CF"
+#define HDMI_PCBPSR0_inst                                             0x00CF
+#define set_HDMI_PCBPSR0_reg(data)                                    (*((volatile unsigned int*)HDMI_PCBPSR0_reg)=data)
+#define get_HDMI_PCBPSR0_reg                                          (*((volatile unsigned int*)HDMI_PCBPSR0_reg))
+#define HDMI_PCBPSR0_pcbh_shift                                       (8)
+#define HDMI_PCBPSR0_pcbl_shift                                       (0)
+#define HDMI_PCBPSR0_pcbh_mask                                        (0x0000FF00)
+#define HDMI_PCBPSR0_pcbl_mask                                        (0x000000FF)
+#define HDMI_PCBPSR0_pcbh(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_PCBPSR0_pcbl(data)                                       (0x000000FF&(data))
+#define HDMI_PCBPSR0_get_pcbh(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_PCBPSR0_get_pcbl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_NTX1024TR0                                               0x340
+#define HDMI_NTX1024TR0_reg_addr                                      "0x98034340"
+#define HDMI_NTX1024TR0_reg                                           0x98034340
+#define HDMI_NTX1024TR0_inst_addr                                     "0x00D0"
+#define HDMI_NTX1024TR0_inst                                          0x00D0
+#define set_HDMI_NTX1024TR0_reg(data)                                 (*((volatile unsigned int*)HDMI_NTX1024TR0_reg)=data)
+#define get_HDMI_NTX1024TR0_reg                                       (*((volatile unsigned int*)HDMI_NTX1024TR0_reg))
+#define HDMI_NTX1024TR0_rm_shift                                      (12)
+#define HDMI_NTX1024TR0_nt_shift                                      (0)
+#define HDMI_NTX1024TR0_rm_mask                                       (0x00001000)
+#define HDMI_NTX1024TR0_nt_mask                                       (0x00000FFF)
+#define HDMI_NTX1024TR0_rm(data)                                      (0x00001000&((data)<<12))
+#define HDMI_NTX1024TR0_nt(data)                                      (0x00000FFF&(data))
+#define HDMI_NTX1024TR0_get_rm(data)                                  ((0x00001000&(data))>>12)
+#define HDMI_NTX1024TR0_get_nt(data)                                  (0x00000FFF&(data))
+
+
+#define HDMI_STBPR                                                    0x344
+#define HDMI_STBPR_reg_addr                                           "0x98034344"
+#define HDMI_STBPR_reg                                                0x98034344
+#define HDMI_STBPR_inst_addr                                          "0x00D1"
+#define HDMI_STBPR_inst                                               0x00D1
+#define set_HDMI_STBPR_reg(data)                                      (*((volatile unsigned int*)HDMI_STBPR_reg)=data)
+#define get_HDMI_STBPR_reg                                            (*((volatile unsigned int*)HDMI_STBPR_reg))
+#define HDMI_STBPR_ftb_shift                                          (0)
+#define HDMI_STBPR_ftb_mask                                           (0x000000FF)
+#define HDMI_STBPR_ftb(data)                                          (0x000000FF&(data))
+#define HDMI_STBPR_get_ftb(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_NCPER                                                    0x348
+#define HDMI_NCPER_reg_addr                                           "0x98034348"
+#define HDMI_NCPER_reg                                                0x98034348
+#define HDMI_NCPER_inst_addr                                          "0x00D2"
+#define HDMI_NCPER_inst                                               0x00D2
+#define set_HDMI_NCPER_reg(data)                                      (*((volatile unsigned int*)HDMI_NCPER_reg)=data)
+#define get_HDMI_NCPER_reg                                            (*((volatile unsigned int*)HDMI_NCPER_reg))
+#define HDMI_NCPER_ncper_shift                                        (0)
+#define HDMI_NCPER_ncper_mask                                         (0x000000FF)
+#define HDMI_NCPER_ncper(data)                                        (0x000000FF&(data))
+#define HDMI_NCPER_get_ncper(data)                                    (0x000000FF&(data))
+
+
+#define HDMI_PETR                                                     0x34c
+#define HDMI_PETR_reg_addr                                            "0x9803434c"
+#define HDMI_PETR_reg                                                 0x9803434c
+#define HDMI_PETR_inst_addr                                           "0x00D3"
+#define HDMI_PETR_inst                                                0x00D3
+#define set_HDMI_PETR_reg(data)                                       (*((volatile unsigned int*)HDMI_PETR_reg)=data)
+#define get_HDMI_PETR_reg                                             (*((volatile unsigned int*)HDMI_PETR_reg))
+#define HDMI_PETR_petr_shift                                          (0)
+#define HDMI_PETR_petr_mask                                           (0x000000FF)
+#define HDMI_PETR_petr(data)                                          (0x000000FF&(data))
+#define HDMI_PETR_get_petr(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_AAPNR                                                    0x350
+#define HDMI_AAPNR_reg_addr                                           "0x98034350"
+#define HDMI_AAPNR_reg                                                0x98034350
+#define HDMI_AAPNR_inst_addr                                          "0x00D4"
+#define HDMI_AAPNR_inst                                               0x00D4
+#define set_HDMI_AAPNR_reg(data)                                      (*((volatile unsigned int*)HDMI_AAPNR_reg)=data)
+#define get_HDMI_AAPNR_reg                                            (*((volatile unsigned int*)HDMI_AAPNR_reg))
+#define HDMI_AAPNR_cmvtc_shift                                        (7)
+#define HDMI_AAPNR_cmvbc_shift                                        (6)
+#define HDMI_AAPNR_ssdmou_shift                                       (5)
+#define HDMI_AAPNR_tef_shift                                          (4)
+#define HDMI_AAPNR_w1c5_shift                                         (3)
+#define HDMI_AAPNR_pem_shift                                          (2)
+#define HDMI_AAPNR_esdm_shift                                         (1)
+#define HDMI_AAPNR_dummy_0_shift                                      (0)
+#define HDMI_AAPNR_cmvtc_mask                                         (0x00000080)
+#define HDMI_AAPNR_cmvbc_mask                                         (0x00000040)
+#define HDMI_AAPNR_ssdmou_mask                                        (0x00000020)
+#define HDMI_AAPNR_tef_mask                                           (0x00000010)
+#define HDMI_AAPNR_w1c5_mask                                          (0x00000008)
+#define HDMI_AAPNR_pem_mask                                           (0x00000004)
+#define HDMI_AAPNR_esdm_mask                                          (0x00000002)
+#define HDMI_AAPNR_dummy_0_mask                                       (0x00000001)
+#define HDMI_AAPNR_cmvtc(data)                                        (0x00000080&((data)<<7))
+#define HDMI_AAPNR_cmvbc(data)                                        (0x00000040&((data)<<6))
+#define HDMI_AAPNR_ssdmou(data)                                       (0x00000020&((data)<<5))
+#define HDMI_AAPNR_tef(data)                                          (0x00000010&((data)<<4))
+#define HDMI_AAPNR_w1c5(data)                                         (0x00000008&((data)<<3))
+#define HDMI_AAPNR_pem(data)                                          (0x00000004&((data)<<2))
+#define HDMI_AAPNR_esdm(data)                                         (0x00000002&((data)<<1))
+#define HDMI_AAPNR_dummy_0(data)                                      (0x00000001&(data))
+#define HDMI_AAPNR_get_cmvtc(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_AAPNR_get_cmvbc(data)                                    ((0x00000040&(data))>>6)
+#define HDMI_AAPNR_get_ssdmou(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_AAPNR_get_tef(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_AAPNR_get_w1c5(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_AAPNR_get_pem(data)                                      ((0x00000004&(data))>>2)
+#define HDMI_AAPNR_get_esdm(data)                                     ((0x00000002&(data))>>1)
+#define HDMI_AAPNR_get_dummy_0(data)                                  (0x00000001&(data))
+
+
+#define HDMI_APDMCR                                                   0x354
+#define HDMI_APDMCR_reg_addr                                          "0x98034354"
+#define HDMI_APDMCR_reg                                               0x98034354
+#define HDMI_APDMCR_inst_addr                                         "0x00D5"
+#define HDMI_APDMCR_inst                                              0x00D5
+#define set_HDMI_APDMCR_reg(data)                                     (*((volatile unsigned int*)HDMI_APDMCR_reg)=data)
+#define get_HDMI_APDMCR_reg                                           (*((volatile unsigned int*)HDMI_APDMCR_reg))
+#define HDMI_APDMCR_dummy_7_shift                                     (7)
+#define HDMI_APDMCR_dummy_6_shift                                     (6)
+#define HDMI_APDMCR_edm_shift                                         (5)
+#define HDMI_APDMCR_pst_shift                                         (4)
+#define HDMI_APDMCR_psc_shift                                         (0)
+#define HDMI_APDMCR_dummy_7_mask                                      (0x00000080)
+#define HDMI_APDMCR_dummy_6_mask                                      (0x00000040)
+#define HDMI_APDMCR_edm_mask                                          (0x00000020)
+#define HDMI_APDMCR_pst_mask                                          (0x00000010)
+#define HDMI_APDMCR_psc_mask                                          (0x0000000F)
+#define HDMI_APDMCR_dummy_7(data)                                     (0x00000080&((data)<<7))
+#define HDMI_APDMCR_dummy_6(data)                                     (0x00000040&((data)<<6))
+#define HDMI_APDMCR_edm(data)                                         (0x00000020&((data)<<5))
+#define HDMI_APDMCR_pst(data)                                         (0x00000010&((data)<<4))
+#define HDMI_APDMCR_psc(data)                                         (0x0000000F&(data))
+#define HDMI_APDMCR_get_dummy_7(data)                                 ((0x00000080&(data))>>7)
+#define HDMI_APDMCR_get_dummy_6(data)                                 ((0x00000040&(data))>>6)
+#define HDMI_APDMCR_get_edm(data)                                     ((0x00000020&(data))>>5)
+#define HDMI_APDMCR_get_pst(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_APDMCR_get_psc(data)                                     (0x0000000F&(data))
+
+
+#define HDMI_APTMCR0                                                  0x358
+#define HDMI_APTMCR0_reg_addr                                         "0x98034358"
+#define HDMI_APTMCR0_reg                                              0x98034358
+#define HDMI_APTMCR0_inst_addr                                        "0x00D6"
+#define HDMI_APTMCR0_inst                                             0x00D6
+#define set_HDMI_APTMCR0_reg(data)                                    (*((volatile unsigned int*)HDMI_APTMCR0_reg)=data)
+#define get_HDMI_APTMCR0_reg                                          (*((volatile unsigned int*)HDMI_APTMCR0_reg))
+#define HDMI_APTMCR0_fps_shift                                        (4)
+#define HDMI_APTMCR0_sps_shift                                        (0)
+#define HDMI_APTMCR0_fps_mask                                         (0x000000F0)
+#define HDMI_APTMCR0_sps_mask                                         (0x0000000F)
+#define HDMI_APTMCR0_fps(data)                                        (0x000000F0&((data)<<4))
+#define HDMI_APTMCR0_sps(data)                                        (0x0000000F&(data))
+#define HDMI_APTMCR0_get_fps(data)                                    ((0x000000F0&(data))>>4)
+#define HDMI_APTMCR0_get_sps(data)                                    (0x0000000F&(data))
+
+
+#define HDMI_APTMCR1                                                  0x35c
+#define HDMI_APTMCR1_reg_addr                                         "0x9803435c"
+#define HDMI_APTMCR1_reg                                              0x9803435c
+#define HDMI_APTMCR1_inst_addr                                        "0x00D7"
+#define HDMI_APTMCR1_inst                                             0x00D7
+#define set_HDMI_APTMCR1_reg(data)                                    (*((volatile unsigned int*)HDMI_APTMCR1_reg)=data)
+#define get_HDMI_APTMCR1_reg                                          (*((volatile unsigned int*)HDMI_APTMCR1_reg))
+#define HDMI_APTMCR1_plltm_shift                                      (6)
+#define HDMI_APTMCR1_fpsd_shift                                       (5)
+#define HDMI_APTMCR1_spsd_shift                                       (4)
+#define HDMI_APTMCR1_nfpss_shift                                      (0)
+#define HDMI_APTMCR1_plltm_mask                                       (0x00000040)
+#define HDMI_APTMCR1_fpsd_mask                                        (0x00000020)
+#define HDMI_APTMCR1_spsd_mask                                        (0x00000010)
+#define HDMI_APTMCR1_nfpss_mask                                       (0x0000000F)
+#define HDMI_APTMCR1_plltm(data)                                      (0x00000040&((data)<<6))
+#define HDMI_APTMCR1_fpsd(data)                                       (0x00000020&((data)<<5))
+#define HDMI_APTMCR1_spsd(data)                                       (0x00000010&((data)<<4))
+#define HDMI_APTMCR1_nfpss(data)                                      (0x0000000F&(data))
+#define HDMI_APTMCR1_get_plltm(data)                                  ((0x00000040&(data))>>6)
+#define HDMI_APTMCR1_get_fpsd(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_APTMCR1_get_spsd(data)                                   ((0x00000010&(data))>>4)
+#define HDMI_APTMCR1_get_nfpss(data)                                  (0x0000000F&(data))
+
+
+#define HDMI_NPECR                                                    0x360
+#define HDMI_NPECR_reg_addr                                           "0x98034360"
+#define HDMI_NPECR_reg                                                0x98034360
+#define HDMI_NPECR_inst_addr                                          "0x00D8"
+#define HDMI_NPECR_inst                                               0x00D8
+#define set_HDMI_NPECR_reg(data)                                      (*((volatile unsigned int*)HDMI_NPECR_reg)=data)
+#define get_HDMI_NPECR_reg                                            (*((volatile unsigned int*)HDMI_NPECR_reg))
+#define HDMI_NPECR_ncts_disable_pe_check_en_shift                     (31)
+#define HDMI_NPECR_ncts_re_enable_off_en_shift                        (30)
+#define HDMI_NPECR_ncts_disable_pe_check_status_shift                 (29)
+#define HDMI_NPECR_ncts_disable_pe_check_irq_en_shift                 (28)
+#define HDMI_NPECR_dummy_27_20_shift                                  (20)
+#define HDMI_NPECR_ncts_disable_pe_check_cnt_shift                    (0)
+#define HDMI_NPECR_ncts_disable_pe_check_en_mask                      (0x80000000)
+#define HDMI_NPECR_ncts_re_enable_off_en_mask                         (0x40000000)
+#define HDMI_NPECR_ncts_disable_pe_check_status_mask                  (0x20000000)
+#define HDMI_NPECR_ncts_disable_pe_check_irq_en_mask                  (0x10000000)
+#define HDMI_NPECR_dummy_27_20_mask                                   (0x0FF00000)
+#define HDMI_NPECR_ncts_disable_pe_check_cnt_mask                     (0x000FFFFF)
+#define HDMI_NPECR_ncts_disable_pe_check_en(data)                     (0x80000000&((data)<<31))
+#define HDMI_NPECR_ncts_re_enable_off_en(data)                        (0x40000000&((data)<<30))
+#define HDMI_NPECR_ncts_disable_pe_check_status(data)                 (0x20000000&((data)<<29))
+#define HDMI_NPECR_ncts_disable_pe_check_irq_en(data)                 (0x10000000&((data)<<28))
+#define HDMI_NPECR_dummy_27_20(data)                                  (0x0FF00000&((data)<<20))
+#define HDMI_NPECR_ncts_disable_pe_check_cnt(data)                    (0x000FFFFF&(data))
+#define HDMI_NPECR_get_ncts_disable_pe_check_en(data)                 ((0x80000000&(data))>>31)
+#define HDMI_NPECR_get_ncts_re_enable_off_en(data)                    ((0x40000000&(data))>>30)
+#define HDMI_NPECR_get_ncts_disable_pe_check_status(data)             ((0x20000000&(data))>>29)
+#define HDMI_NPECR_get_ncts_disable_pe_check_irq_en(data)             ((0x10000000&(data))>>28)
+#define HDMI_NPECR_get_dummy_27_20(data)                              ((0x0FF00000&(data))>>20)
+#define HDMI_NPECR_get_ncts_disable_pe_check_cnt(data)                (0x000FFFFF&(data))
+
+
+#define HDMI_NROR                                                     0x364
+#define HDMI_NROR_reg_addr                                            "0x98034364"
+#define HDMI_NROR_reg                                                 0x98034364
+#define HDMI_NROR_inst_addr                                           "0x00D9"
+#define HDMI_NROR_inst                                                0x00D9
+#define set_HDMI_NROR_reg(data)                                       (*((volatile unsigned int*)HDMI_NROR_reg)=data)
+#define get_HDMI_NROR_reg                                             (*((volatile unsigned int*)HDMI_NROR_reg))
+#define HDMI_NROR_ncts_re_enable_off_start_shift                      (16)
+#define HDMI_NROR_ncts_re_enable_off_end_shift                        (0)
+#define HDMI_NROR_ncts_re_enable_off_start_mask                       (0xFFFF0000)
+#define HDMI_NROR_ncts_re_enable_off_end_mask                         (0x0000FFFF)
+#define HDMI_NROR_ncts_re_enable_off_start(data)                      (0xFFFF0000&((data)<<16))
+#define HDMI_NROR_ncts_re_enable_off_end(data)                        (0x0000FFFF&(data))
+#define HDMI_NROR_get_ncts_re_enable_off_start(data)                  ((0xFFFF0000&(data))>>16)
+#define HDMI_NROR_get_ncts_re_enable_off_end(data)                    (0x0000FFFF&(data))
+
+
+#define HDMI_NTX1024TR0_THRESHOLD                                     0x368
+#define HDMI_NTX1024TR0_THRESHOLD_reg_addr                            "0x98034368"
+#define HDMI_NTX1024TR0_THRESHOLD_reg                                 0x98034368
+#define HDMI_NTX1024TR0_THRESHOLD_inst_addr                           "0x00DA"
+#define HDMI_NTX1024TR0_THRESHOLD_inst                                0x00DA
+#define set_HDMI_NTX1024TR0_THRESHOLD_reg(data)                       (*((volatile unsigned int*)HDMI_NTX1024TR0_THRESHOLD_reg)=data)
+#define get_HDMI_NTX1024TR0_THRESHOLD_reg                             (*((volatile unsigned int*)HDMI_NTX1024TR0_THRESHOLD_reg))
+#define HDMI_NTX1024TR0_THRESHOLD_over_threshold_shift                (31)
+#define HDMI_NTX1024TR0_THRESHOLD_under_threshold_shift               (30)
+#define HDMI_NTX1024TR0_THRESHOLD_wd_by_tmds_clk_shift                (29)
+#define HDMI_NTX1024TR0_THRESHOLD_irq_by_tmds_clk_shift               (28)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_up_threshold_shift               (16)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_low_threshold_shift              (0)
+#define HDMI_NTX1024TR0_THRESHOLD_over_threshold_mask                 (0x80000000)
+#define HDMI_NTX1024TR0_THRESHOLD_under_threshold_mask                (0x40000000)
+#define HDMI_NTX1024TR0_THRESHOLD_wd_by_tmds_clk_mask                 (0x20000000)
+#define HDMI_NTX1024TR0_THRESHOLD_irq_by_tmds_clk_mask                (0x10000000)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_up_threshold_mask                (0x0FFF0000)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_low_threshold_mask               (0x00000FFF)
+#define HDMI_NTX1024TR0_THRESHOLD_over_threshold(data)                (0x80000000&((data)<<31))
+#define HDMI_NTX1024TR0_THRESHOLD_under_threshold(data)               (0x40000000&((data)<<30))
+#define HDMI_NTX1024TR0_THRESHOLD_wd_by_tmds_clk(data)                (0x20000000&((data)<<29))
+#define HDMI_NTX1024TR0_THRESHOLD_irq_by_tmds_clk(data)               (0x10000000&((data)<<28))
+#define HDMI_NTX1024TR0_THRESHOLD_nt_up_threshold(data)               (0x0FFF0000&((data)<<16))
+#define HDMI_NTX1024TR0_THRESHOLD_nt_low_threshold(data)              (0x00000FFF&(data))
+#define HDMI_NTX1024TR0_THRESHOLD_get_over_threshold(data)            ((0x80000000&(data))>>31)
+#define HDMI_NTX1024TR0_THRESHOLD_get_under_threshold(data)           ((0x40000000&(data))>>30)
+#define HDMI_NTX1024TR0_THRESHOLD_get_wd_by_tmds_clk(data)            ((0x20000000&(data))>>29)
+#define HDMI_NTX1024TR0_THRESHOLD_get_irq_by_tmds_clk(data)           ((0x10000000&(data))>>28)
+#define HDMI_NTX1024TR0_THRESHOLD_get_nt_up_threshold(data)           ((0x0FFF0000&(data))>>16)
+#define HDMI_NTX1024TR0_THRESHOLD_get_nt_low_threshold(data)          (0x00000FFF&(data))
+
+
+#define HDMI_APLLCR0                                                  0x380
+#define HDMI_APLLCR0_reg_addr                                         "0x98034380"
+#define HDMI_APLLCR0_reg                                              0x98034380
+#define HDMI_APLLCR0_inst_addr                                        "0x00E0"
+#define HDMI_APLLCR0_inst                                             0x00E0
+#define set_HDMI_APLLCR0_reg(data)                                    (*((volatile unsigned int*)HDMI_APLLCR0_reg)=data)
+#define get_HDMI_APLLCR0_reg                                          (*((volatile unsigned int*)HDMI_APLLCR0_reg))
+#define HDMI_APLLCR0_dpll_reg_shift                                   (30)
+#define HDMI_APLLCR0_dpll_m_shift                                     (22)
+#define HDMI_APLLCR0_dpll_reser_shift                                 (17)
+#define HDMI_APLLCR0_dpll_bpsin_shift                                 (16)
+#define HDMI_APLLCR0_dpll_o_shift                                     (14)
+#define HDMI_APLLCR0_dpll_n_shift                                     (6)
+#define HDMI_APLLCR0_dpll_rs_shift                                    (3)
+#define HDMI_APLLCR0_dpll_ip_shift                                    (0)
+#define HDMI_APLLCR0_dpll_reg_mask                                    (0xC0000000)
+#define HDMI_APLLCR0_dpll_m_mask                                      (0x3FC00000)
+#define HDMI_APLLCR0_dpll_reser_mask                                  (0x001E0000)
+#define HDMI_APLLCR0_dpll_bpsin_mask                                  (0x00010000)
+#define HDMI_APLLCR0_dpll_o_mask                                      (0x0000C000)
+#define HDMI_APLLCR0_dpll_n_mask                                      (0x000001C0)
+#define HDMI_APLLCR0_dpll_rs_mask                                     (0x00000038)
+#define HDMI_APLLCR0_dpll_ip_mask                                     (0x00000007)
+#define HDMI_APLLCR0_dpll_reg(data)                                   (0xC0000000&((data)<<30))
+#define HDMI_APLLCR0_dpll_m(data)                                     (0x3FC00000&((data)<<22))
+#define HDMI_APLLCR0_dpll_reser(data)                                 (0x001E0000&((data)<<17))
+#define HDMI_APLLCR0_dpll_bpsin(data)                                 (0x00010000&((data)<<16))
+#define HDMI_APLLCR0_dpll_o(data)                                     (0x0000C000&((data)<<14))
+#define HDMI_APLLCR0_dpll_n(data)                                     (0x000001C0&((data)<<6))
+#define HDMI_APLLCR0_dpll_rs(data)                                    (0x00000038&((data)<<3))
+#define HDMI_APLLCR0_dpll_ip(data)                                    (0x00000007&(data))
+#define HDMI_APLLCR0_get_dpll_reg(data)                               ((0xC0000000&(data))>>30)
+#define HDMI_APLLCR0_get_dpll_m(data)                                 ((0x3FC00000&(data))>>22)
+#define HDMI_APLLCR0_get_dpll_reser(data)                             ((0x001E0000&(data))>>17)
+#define HDMI_APLLCR0_get_dpll_bpsin(data)                             ((0x00010000&(data))>>16)
+#define HDMI_APLLCR0_get_dpll_o(data)                                 ((0x0000C000&(data))>>14)
+#define HDMI_APLLCR0_get_dpll_n(data)                                 ((0x000001C0&(data))>>6)
+#define HDMI_APLLCR0_get_dpll_rs(data)                                ((0x00000038&(data))>>3)
+#define HDMI_APLLCR0_get_dpll_ip(data)                                (0x00000007&(data))
+
+
+#define HDMI_APLLCR1                                                  0x384
+#define HDMI_APLLCR1_reg_addr                                         "0x98034384"
+#define HDMI_APLLCR1_reg                                              0x98034384
+#define HDMI_APLLCR1_inst_addr                                        "0x00E1"
+#define HDMI_APLLCR1_inst                                             0x00E1
+#define set_HDMI_APLLCR1_reg(data)                                    (*((volatile unsigned int*)HDMI_APLLCR1_reg)=data)
+#define get_HDMI_APLLCR1_reg                                          (*((volatile unsigned int*)HDMI_APLLCR1_reg))
+#define HDMI_APLLCR1_dpll_cp_shift                                    (21)
+#define HDMI_APLLCR1_dpll_seltst_shift                                (19)
+#define HDMI_APLLCR1_dpll_cs_shift                                    (17)
+#define HDMI_APLLCR1_dpll_reserve_shift                               (9)
+#define HDMI_APLLCR1_dpll_bpspsw_shift                                (8)
+#define HDMI_APLLCR1_dpll_wdo_shift                                   (7)
+#define HDMI_APLLCR1_dpll_wdrst_shift                                 (6)
+#define HDMI_APLLCR1_dpll_wdset_shift                                 (5)
+#define HDMI_APLLCR1_dummy_4_shift                                    (4)
+#define HDMI_APLLCR1_dpll_stoppsw_shift                               (3)
+#define HDMI_APLLCR1_dpll_freeze_shift                                (2)
+#define HDMI_APLLCR1_dpll_vcorstb_shift                               (1)
+#define HDMI_APLLCR1_dpll_pow_shift                                   (0)
+#define HDMI_APLLCR1_dpll_cp_mask                                     (0x00600000)
+#define HDMI_APLLCR1_dpll_seltst_mask                                 (0x00180000)
+#define HDMI_APLLCR1_dpll_cs_mask                                     (0x00060000)
+#define HDMI_APLLCR1_dpll_reserve_mask                                (0x00000200)
+#define HDMI_APLLCR1_dpll_bpspsw_mask                                 (0x00000100)
+#define HDMI_APLLCR1_dpll_wdo_mask                                    (0x00000080)
+#define HDMI_APLLCR1_dpll_wdrst_mask                                  (0x00000040)
+#define HDMI_APLLCR1_dpll_wdset_mask                                  (0x00000020)
+#define HDMI_APLLCR1_dummy_4_mask                                     (0x00000010)
+#define HDMI_APLLCR1_dpll_stoppsw_mask                                (0x00000008)
+#define HDMI_APLLCR1_dpll_freeze_mask                                 (0x00000004)
+#define HDMI_APLLCR1_dpll_vcorstb_mask                                (0x00000002)
+#define HDMI_APLLCR1_dpll_pow_mask                                    (0x00000001)
+#define HDMI_APLLCR1_dpll_cp(data)                                    (0x00600000&((data)<<21))
+#define HDMI_APLLCR1_dpll_seltst(data)                                (0x00180000&((data)<<19))
+#define HDMI_APLLCR1_dpll_cs(data)                                    (0x00060000&((data)<<17))
+#define HDMI_APLLCR1_dpll_reserve(data)                               (0x00000200&((data)<<9))
+#define HDMI_APLLCR1_dpll_bpspsw(data)                                (0x00000100&((data)<<8))
+#define HDMI_APLLCR1_dpll_wdo(data)                                   (0x00000080&((data)<<7))
+#define HDMI_APLLCR1_dpll_wdrst(data)                                 (0x00000040&((data)<<6))
+#define HDMI_APLLCR1_dpll_wdset(data)                                 (0x00000020&((data)<<5))
+#define HDMI_APLLCR1_dummy_4(data)                                    (0x00000010&((data)<<4))
+#define HDMI_APLLCR1_dpll_stoppsw(data)                               (0x00000008&((data)<<3))
+#define HDMI_APLLCR1_dpll_freeze(data)                                (0x00000004&((data)<<2))
+#define HDMI_APLLCR1_dpll_vcorstb(data)                               (0x00000002&((data)<<1))
+#define HDMI_APLLCR1_dpll_pow(data)                                   (0x00000001&(data))
+#define HDMI_APLLCR1_get_dpll_cp(data)                                ((0x00600000&(data))>>21)
+#define HDMI_APLLCR1_get_dpll_seltst(data)                            ((0x00180000&(data))>>19)
+#define HDMI_APLLCR1_get_dpll_cs(data)                                ((0x00060000&(data))>>17)
+#define HDMI_APLLCR1_get_dpll_reserve(data)                           ((0x00000200&(data))>>9)
+#define HDMI_APLLCR1_get_dpll_bpspsw(data)                            ((0x00000100&(data))>>8)
+#define HDMI_APLLCR1_get_dpll_wdo(data)                               ((0x00000080&(data))>>7)
+#define HDMI_APLLCR1_get_dpll_wdrst(data)                             ((0x00000040&(data))>>6)
+#define HDMI_APLLCR1_get_dpll_wdset(data)                             ((0x00000020&(data))>>5)
+#define HDMI_APLLCR1_get_dummy_4(data)                                ((0x00000010&(data))>>4)
+#define HDMI_APLLCR1_get_dpll_stoppsw(data)                           ((0x00000008&(data))>>3)
+#define HDMI_APLLCR1_get_dpll_freeze(data)                            ((0x00000004&(data))>>2)
+#define HDMI_APLLCR1_get_dpll_vcorstb(data)                           ((0x00000002&(data))>>1)
+#define HDMI_APLLCR1_get_dpll_pow(data)                               (0x00000001&(data))
+#define HDMI_APLLCR1_dpll_CS_MASK									((1<<18)|(1<<17))
+#define HDMI_APLLCR1_dpll_CS_20P									(0)
+#define HDMI_APLLCR1_dpll_CS_25P									(1<<17)
+#define HDMI_APLLCR1_dpll_CS_30P									(2<<17)
+#define HDMI_APLLCR1_dpll_CS_35P									(3<<17)
+
+
+#define HDMI_APLLCR2                                                  0x388
+#define HDMI_APLLCR2_reg_addr                                         "0x98034388"
+#define HDMI_APLLCR2_reg                                              0x98034388
+#define HDMI_APLLCR2_inst_addr                                        "0x00E2"
+#define HDMI_APLLCR2_inst                                             0x00E2
+#define set_HDMI_APLLCR2_reg(data)                                    (*((volatile unsigned int*)HDMI_APLLCR2_reg)=data)
+#define get_HDMI_APLLCR2_reg                                          (*((volatile unsigned int*)HDMI_APLLCR2_reg))
+#define HDMI_APLLCR2_dpll_reloadm_shift                               (0)
+#define HDMI_APLLCR2_dpll_reloadm_mask                                (0x00000001)
+#define HDMI_APLLCR2_dpll_reloadm(data)                               (0x00000001&(data))
+#define HDMI_APLLCR2_get_dpll_reloadm(data)                           (0x00000001&(data))
+
+
+#define HDMI_APLLCR3                                                  0x38c
+#define HDMI_APLLCR3_reg_addr                                         "0x9803438c"
+#define HDMI_APLLCR3_reg                                              0x9803438c
+#define HDMI_APLLCR3_inst_addr                                        "0x00E3"
+#define HDMI_APLLCR3_inst                                             0x00E3
+#define set_HDMI_APLLCR3_reg(data)                                    (*((volatile unsigned int*)HDMI_APLLCR3_reg)=data)
+#define get_HDMI_APLLCR3_reg                                          (*((volatile unsigned int*)HDMI_APLLCR3_reg))
+#define HDMI_APLLCR3_sum_c_samp_shift                                 (0)
+#define HDMI_APLLCR3_sum_c_samp_mask                                  (0x0000FFFF)
+#define HDMI_APLLCR3_sum_c_samp(data)                                 (0x0000FFFF&(data))
+#define HDMI_APLLCR3_get_sum_c_samp(data)                             (0x0000FFFF&(data))
+
+
+#define HDMI_APLL_TESTM                                               0x390
+#define HDMI_APLL_TESTM_reg_addr                                      "0x98034390"
+#define HDMI_APLL_TESTM_reg                                           0x98034390
+#define HDMI_APLL_TESTM_inst_addr                                     "0x00E4"
+#define HDMI_APLL_TESTM_inst                                          0x00E4
+#define set_HDMI_APLL_TESTM_reg(data)                                 (*((volatile unsigned int*)HDMI_APLL_TESTM_reg)=data)
+#define get_HDMI_APLL_TESTM_reg                                       (*((volatile unsigned int*)HDMI_APLL_TESTM_reg))
+#define HDMI_APLL_TESTM_dpll_m_test_shift                             (22)
+#define HDMI_APLL_TESTM_dpll_m_db_shift                               (1)
+#define HDMI_APLL_TESTM_dpll_m_sel_shift                              (0)
+#define HDMI_APLL_TESTM_dpll_m_test_mask                              (0x3FC00000)
+#define HDMI_APLL_TESTM_dpll_m_db_mask                                (0x00000002)
+#define HDMI_APLL_TESTM_dpll_m_sel_mask                               (0x00000001)
+#define HDMI_APLL_TESTM_dpll_m_test(data)                             (0x3FC00000&((data)<<22))
+#define HDMI_APLL_TESTM_dpll_m_db(data)                               (0x00000002&((data)<<1))
+#define HDMI_APLL_TESTM_dpll_m_sel(data)                              (0x00000001&(data))
+#define HDMI_APLL_TESTM_get_dpll_m_test(data)                         ((0x3FC00000&(data))>>22)
+#define HDMI_APLL_TESTM_get_dpll_m_db(data)                           ((0x00000002&(data))>>1)
+#define HDMI_APLL_TESTM_get_dpll_m_sel(data)                          (0x00000001&(data))
+
+
+#define HDMI_VPLLCR0                                                  0x400
+#define HDMI_VPLLCR0_reg_addr                                         "0x98034400"
+#define HDMI_VPLLCR0_reg                                              0x98034400
+#define HDMI_VPLLCR0_inst_addr                                        "0x0100"
+#define HDMI_VPLLCR0_inst                                             0x0100
+#define set_HDMI_VPLLCR0_reg(data)                                    (*((volatile unsigned int*)HDMI_VPLLCR0_reg)=data)
+#define get_HDMI_VPLLCR0_reg                                          (*((volatile unsigned int*)HDMI_VPLLCR0_reg))
+#define HDMI_VPLLCR0_dpll_reg_shift                                   (30)
+#define HDMI_VPLLCR0_dpll_m_shift                                     (22)
+#define HDMI_VPLLCR0_dpll_reser_shift                                 (17)
+#define HDMI_VPLLCR0_dpll_bpsin_shift                                 (16)
+#define HDMI_VPLLCR0_dpll_o_shift                                     (14)
+#define HDMI_VPLLCR0_dpll_n_shift                                     (6)
+#define HDMI_VPLLCR0_dpll_rs_shift                                    (3)
+#define HDMI_VPLLCR0_dpll_ip_shift                                    (0)
+#define HDMI_VPLLCR0_dpll_reg_mask                                    (0xC0000000)
+#define HDMI_VPLLCR0_dpll_m_mask                                      (0x3FC00000)
+#define HDMI_VPLLCR0_dpll_reser_mask                                  (0x001E0000)
+#define HDMI_VPLLCR0_dpll_bpsin_mask                                  (0x00010000)
+#define HDMI_VPLLCR0_dpll_o_mask                                      (0x0000C000)
+#define HDMI_VPLLCR0_dpll_n_mask                                      (0x000001C0)
+#define HDMI_VPLLCR0_dpll_rs_mask                                     (0x00000038)
+#define HDMI_VPLLCR0_dpll_ip_mask                                     (0x00000007)
+#define HDMI_VPLLCR0_dpll_reg(data)                                   (0xC0000000&((data)<<30))
+#define HDMI_VPLLCR0_dpll_m(data)                                     (0x3FC00000&((data)<<22))
+#define HDMI_VPLLCR0_dpll_reser(data)                                 (0x001E0000&((data)<<17))
+#define HDMI_VPLLCR0_dpll_bpsin(data)                                 (0x00010000&((data)<<16))
+#define HDMI_VPLLCR0_dpll_o(data)                                     (0x0000C000&((data)<<14))
+#define HDMI_VPLLCR0_dpll_n(data)                                     (0x000001C0&((data)<<6))
+#define HDMI_VPLLCR0_dpll_rs(data)                                    (0x00000038&((data)<<3))
+#define HDMI_VPLLCR0_dpll_ip(data)                                    (0x00000007&(data))
+#define HDMI_VPLLCR0_get_dpll_reg(data)                               ((0xC0000000&(data))>>30)
+#define HDMI_VPLLCR0_get_dpll_m(data)                                 ((0x3FC00000&(data))>>22)
+#define HDMI_VPLLCR0_get_dpll_reser(data)                             ((0x001E0000&(data))>>17)
+#define HDMI_VPLLCR0_get_dpll_bpsin(data)                             ((0x00010000&(data))>>16)
+#define HDMI_VPLLCR0_get_dpll_o(data)                                 ((0x0000C000&(data))>>14)
+#define HDMI_VPLLCR0_get_dpll_n(data)                                 ((0x000001C0&(data))>>6)
+#define HDMI_VPLLCR0_get_dpll_rs(data)                                ((0x00000038&(data))>>3)
+#define HDMI_VPLLCR0_get_dpll_ip(data)                                (0x00000007&(data))
+
+
+#define HDMI_VPLLCR1                                                  0x404
+#define HDMI_VPLLCR1_reg_addr                                         "0x98034404"
+#define HDMI_VPLLCR1_reg                                              0x98034404
+#define HDMI_VPLLCR1_inst_addr                                        "0x0101"
+#define HDMI_VPLLCR1_inst                                             0x0101
+#define set_HDMI_VPLLCR1_reg(data)                                    (*((volatile unsigned int*)HDMI_VPLLCR1_reg)=data)
+#define get_HDMI_VPLLCR1_reg                                          (*((volatile unsigned int*)HDMI_VPLLCR1_reg))
+#define HDMI_VPLLCR1_dpll_cp_shift                                    (21)
+#define HDMI_VPLLCR1_dpll_seltst_shift                                (19)
+#define HDMI_VPLLCR1_dpll_cs_shift                                    (17)
+#define HDMI_VPLLCR1_dpll_ldo_pow_shift                               (12)
+#define HDMI_VPLLCR1_dpll_ldo_sel_shift                               (10)
+#define HDMI_VPLLCR1_dpll_reserve_shift                               (9)
+#define HDMI_VPLLCR1_dpll_bpspsw_shift                                (8)
+#define HDMI_VPLLCR1_dpll_wdo_shift                                   (7)
+#define HDMI_VPLLCR1_dpll_wdrst_shift                                 (6)
+#define HDMI_VPLLCR1_dpll_wdset_shift                                 (5)
+#define HDMI_VPLLCR1_dummy_4_shift                                    (4)
+#define HDMI_VPLLCR1_dpll_stoppsw_shift                               (3)
+#define HDMI_VPLLCR1_dpll_freeze_shift                                (2)
+#define HDMI_VPLLCR1_dpll_vcorstb_shift                               (1)
+#define HDMI_VPLLCR1_dpll_pow_shift                                   (0)
+#define HDMI_VPLLCR1_dpll_cp_mask                                     (0x00600000)
+#define HDMI_VPLLCR1_dpll_seltst_mask                                 (0x00180000)
+#define HDMI_VPLLCR1_dpll_cs_mask                                     (0x00060000)
+#define HDMI_VPLLCR1_dpll_ldo_pow_mask                                (0x00001000)
+#define HDMI_VPLLCR1_dpll_ldo_sel_mask                                (0x00000C00)
+#define HDMI_VPLLCR1_dpll_reserve_mask                                (0x00000200)
+#define HDMI_VPLLCR1_dpll_bpspsw_mask                                 (0x00000100)
+#define HDMI_VPLLCR1_dpll_wdo_mask                                    (0x00000080)
+#define HDMI_VPLLCR1_dpll_wdrst_mask                                  (0x00000040)
+#define HDMI_VPLLCR1_dpll_wdset_mask                                  (0x00000020)
+#define HDMI_VPLLCR1_dummy_4_mask                                     (0x00000010)
+#define HDMI_VPLLCR1_dpll_stoppsw_mask                                (0x00000008)
+#define HDMI_VPLLCR1_dpll_freeze_mask                                 (0x00000004)
+#define HDMI_VPLLCR1_dpll_vcorstb_mask                                (0x00000002)
+#define HDMI_VPLLCR1_dpll_pow_mask                                    (0x00000001)
+#define HDMI_VPLLCR1_dpll_cp(data)                                    (0x00600000&((data)<<21))
+#define HDMI_VPLLCR1_dpll_seltst(data)                                (0x00180000&((data)<<19))
+#define HDMI_VPLLCR1_dpll_cs(data)                                    (0x00060000&((data)<<17))
+#define HDMI_VPLLCR1_dpll_ldo_pow(data)                               (0x00001000&((data)<<12))
+#define HDMI_VPLLCR1_dpll_ldo_sel(data)                               (0x00000C00&((data)<<10))
+#define HDMI_VPLLCR1_dpll_reserve(data)                               (0x00000200&((data)<<9))
+#define HDMI_VPLLCR1_dpll_bpspsw(data)                                (0x00000100&((data)<<8))
+#define HDMI_VPLLCR1_dpll_wdo(data)                                   (0x00000080&((data)<<7))
+#define HDMI_VPLLCR1_dpll_wdrst(data)                                 (0x00000040&((data)<<6))
+#define HDMI_VPLLCR1_dpll_wdset(data)                                 (0x00000020&((data)<<5))
+#define HDMI_VPLLCR1_dummy_4(data)                                    (0x00000010&((data)<<4))
+#define HDMI_VPLLCR1_dpll_stoppsw(data)                               (0x00000008&((data)<<3))
+#define HDMI_VPLLCR1_dpll_freeze(data)                                (0x00000004&((data)<<2))
+#define HDMI_VPLLCR1_dpll_vcorstb(data)                               (0x00000002&((data)<<1))
+#define HDMI_VPLLCR1_dpll_pow(data)                                   (0x00000001&(data))
+#define HDMI_VPLLCR1_get_dpll_cp(data)                                ((0x00600000&(data))>>21)
+#define HDMI_VPLLCR1_get_dpll_seltst(data)                            ((0x00180000&(data))>>19)
+#define HDMI_VPLLCR1_get_dpll_cs(data)                                ((0x00060000&(data))>>17)
+#define HDMI_VPLLCR1_get_dpll_ldo_pow(data)                           ((0x00001000&(data))>>12)
+#define HDMI_VPLLCR1_get_dpll_ldo_sel(data)                           ((0x00000C00&(data))>>10)
+#define HDMI_VPLLCR1_get_dpll_reserve(data)                           ((0x00000200&(data))>>9)
+#define HDMI_VPLLCR1_get_dpll_bpspsw(data)                            ((0x00000100&(data))>>8)
+#define HDMI_VPLLCR1_get_dpll_wdo(data)                               ((0x00000080&(data))>>7)
+#define HDMI_VPLLCR1_get_dpll_wdrst(data)                             ((0x00000040&(data))>>6)
+#define HDMI_VPLLCR1_get_dpll_wdset(data)                             ((0x00000020&(data))>>5)
+#define HDMI_VPLLCR1_get_dummy_4(data)                                ((0x00000010&(data))>>4)
+#define HDMI_VPLLCR1_get_dpll_stoppsw(data)                           ((0x00000008&(data))>>3)
+#define HDMI_VPLLCR1_get_dpll_freeze(data)                            ((0x00000004&(data))>>2)
+#define HDMI_VPLLCR1_get_dpll_vcorstb(data)                           ((0x00000002&(data))>>1)
+#define HDMI_VPLLCR1_get_dpll_pow(data)                               (0x00000001&(data))
+
+
+#define HDMI_VPLLCR2                                                  0x408
+#define HDMI_VPLLCR2_reg_addr                                         "0x98034408"
+#define HDMI_VPLLCR2_reg                                              0x98034408
+#define HDMI_VPLLCR2_inst_addr                                        "0x0102"
+#define HDMI_VPLLCR2_inst                                             0x0102
+#define set_HDMI_VPLLCR2_reg(data)                                    (*((volatile unsigned int*)HDMI_VPLLCR2_reg)=data)
+#define get_HDMI_VPLLCR2_reg                                          (*((volatile unsigned int*)HDMI_VPLLCR2_reg))
+#define HDMI_VPLLCR2_dpll_reloadm_shift                               (0)
+#define HDMI_VPLLCR2_dpll_reloadm_mask                                (0x00000001)
+#define HDMI_VPLLCR2_dpll_reloadm(data)                               (0x00000001&(data))
+#define HDMI_VPLLCR2_get_dpll_reloadm(data)                           (0x00000001&(data))
+
+
+#define MN_SCLKG_CTRL                                                 0x410
+#define MN_SCLKG_CTRL_reg_addr                                        "0x98034410"
+#define MN_SCLKG_CTRL_reg                                             0x98034410
+#define MN_SCLKG_CTRL_inst_addr                                       "0x0104"
+#define MN_SCLKG_CTRL_inst                                            0x0104
+#define set_MN_SCLKG_CTRL_reg(data)                                   (*((volatile unsigned int*)MN_SCLKG_CTRL_reg)=data)
+#define get_MN_SCLKG_CTRL_reg                                         (*((volatile unsigned int*)MN_SCLKG_CTRL_reg))
+#define MN_SCLKG_CTRL_sclkg_pll_in_sel_shift                          (7)
+#define MN_SCLKG_CTRL_sclkg_oclk_sel_shift                            (5)
+#define MN_SCLKG_CTRL_sclkg_dbuf_shift                                (4)
+#define MN_SCLKG_CTRL_dummy_3_0_shift                                 (0)
+#define MN_SCLKG_CTRL_sclkg_pll_in_sel_mask                           (0x00000080)
+#define MN_SCLKG_CTRL_sclkg_oclk_sel_mask                             (0x00000060)
+#define MN_SCLKG_CTRL_sclkg_dbuf_mask                                 (0x00000010)
+#define MN_SCLKG_CTRL_dummy_3_0_mask                                  (0x0000000F)
+#define MN_SCLKG_CTRL_sclkg_pll_in_sel(data)                          (0x00000080&((data)<<7))
+#define MN_SCLKG_CTRL_sclkg_oclk_sel(data)                            (0x00000060&((data)<<5))
+#define MN_SCLKG_CTRL_sclkg_dbuf(data)                                (0x00000010&((data)<<4))
+#define MN_SCLKG_CTRL_dummy_3_0(data)                                 (0x0000000F&(data))
+#define MN_SCLKG_CTRL_get_sclkg_pll_in_sel(data)                      ((0x00000080&(data))>>7)
+#define MN_SCLKG_CTRL_get_sclkg_oclk_sel(data)                        ((0x00000060&(data))>>5)
+#define MN_SCLKG_CTRL_get_sclkg_dbuf(data)                            ((0x00000010&(data))>>4)
+#define MN_SCLKG_CTRL_get_dummy_3_0(data)                             (0x0000000F&(data))
+
+
+#define MN_SCLKG_DIVS                                                 0x414
+#define MN_SCLKG_DIVS_reg_addr                                        "0x98034414"
+#define MN_SCLKG_DIVS_reg                                             0x98034414
+#define MN_SCLKG_DIVS_inst_addr                                       "0x0105"
+#define MN_SCLKG_DIVS_inst                                            0x0105
+#define set_MN_SCLKG_DIVS_reg(data)                                   (*((volatile unsigned int*)MN_SCLKG_DIVS_reg)=data)
+#define get_MN_SCLKG_DIVS_reg                                         (*((volatile unsigned int*)MN_SCLKG_DIVS_reg))
+#define MN_SCLKG_DIVS_sclkg_pll_div2_en_shift                         (7)
+#define MN_SCLKG_DIVS_sclkg_pll_divs_shift                            (0)
+#define MN_SCLKG_DIVS_sclkg_pll_div2_en_mask                          (0x00000080)
+#define MN_SCLKG_DIVS_sclkg_pll_divs_mask                             (0x0000007F)
+#define MN_SCLKG_DIVS_sclkg_pll_div2_en(data)                         (0x00000080&((data)<<7))
+#define MN_SCLKG_DIVS_sclkg_pll_divs(data)                            (0x0000007F&(data))
+#define MN_SCLKG_DIVS_get_sclkg_pll_div2_en(data)                     ((0x00000080&(data))>>7)
+#define MN_SCLKG_DIVS_get_sclkg_pll_divs(data)                        (0x0000007F&(data))
+
+
+#define MDD_CR                                                        0x500
+#define MDD_CR_reg_addr                                               "0x98034500"
+#define MDD_CR_reg                                                    0x98034500
+#define MDD_CR_inst_addr                                              "0x0140"
+#define MDD_CR_inst                                                   0x0140
+#define set_MDD_CR_reg(data)                                          (*((volatile unsigned int*)MDD_CR_reg)=data)
+#define get_MDD_CR_reg                                                (*((volatile unsigned int*)MDD_CR_reg))
+#define MDD_CR_dummy_16_8_shift                                       (8)
+#define MDD_CR_dummy_7_5_shift                                        (5)
+#define MDD_CR_det_con_shift                                          (4)
+#define MDD_CR_irq_det_chg_en_shift                                   (3)
+#define MDD_CR_dummy_2_1_shift                                        (1)
+#define MDD_CR_en_shift                                               (0)
+#define MDD_CR_dummy_16_8_mask                                        (0x0001FF00)
+#define MDD_CR_dummy_7_5_mask                                         (0x000000E0)
+#define MDD_CR_det_con_mask                                           (0x00000010)
+#define MDD_CR_irq_det_chg_en_mask                                    (0x00000008)
+#define MDD_CR_dummy_2_1_mask                                         (0x00000006)
+#define MDD_CR_en_mask                                                (0x00000001)
+#define MDD_CR_dummy_16_8(data)                                       (0x0001FF00&((data)<<8))
+#define MDD_CR_dummy_7_5(data)                                        (0x000000E0&((data)<<5))
+#define MDD_CR_det_con(data)                                          (0x00000010&((data)<<4))
+#define MDD_CR_irq_det_chg_en(data)                                   (0x00000008&((data)<<3))
+#define MDD_CR_dummy_2_1(data)                                        (0x00000006&((data)<<1))
+#define MDD_CR_en(data)                                               (0x00000001&(data))
+#define MDD_CR_get_dummy_16_8(data)                                   ((0x0001FF00&(data))>>8)
+#define MDD_CR_get_dummy_7_5(data)                                    ((0x000000E0&(data))>>5)
+#define MDD_CR_get_det_con(data)                                      ((0x00000010&(data))>>4)
+#define MDD_CR_get_irq_det_chg_en(data)                               ((0x00000008&(data))>>3)
+#define MDD_CR_get_dummy_2_1(data)                                    ((0x00000006&(data))>>1)
+#define MDD_CR_get_en(data)                                           (0x00000001&(data))
+
+
+#define MDD_SR                                                        0x504
+#define MDD_SR_reg_addr                                               "0x98034504"
+#define MDD_SR_reg                                                    0x98034504
+#define MDD_SR_inst_addr                                              "0x0141"
+#define MDD_SR_inst                                                   0x0141
+#define set_MDD_SR_reg(data)                                          (*((volatile unsigned int*)MDD_SR_reg)=data)
+#define get_MDD_SR_reg                                                (*((volatile unsigned int*)MDD_SR_reg))
+#define MDD_SR_det_result_chg_shift                                   (1)
+#define MDD_SR_det_result_shift                                       (0)
+#define MDD_SR_det_result_chg_mask                                    (0x00000002)
+#define MDD_SR_det_result_mask                                        (0x00000001)
+#define MDD_SR_det_result_chg(data)                                   (0x00000002&((data)<<1))
+#define MDD_SR_det_result(data)                                       (0x00000001&(data))
+#define MDD_SR_get_det_result_chg(data)                               ((0x00000002&(data))>>1)
+#define MDD_SR_get_det_result(data)                                   (0x00000001&(data))
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/MHL_fw.h b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/MHL_fw.h
new file mode 100755
index 00000000..6c95708
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/MHL_fw.h
@@ -0,0 +1,572 @@
+/*===========*@date:2015/3/6===========*/
+
+#ifndef _MHL_RX_REG_H_INCLUDED_
+#define _MHL_RX_REG_H_INCLUDED_
+
+#define MHL_DAL_CTRL                                                  0x600
+#define MHL_DAL_CTRL_reg_addr                                         "0x98034600"
+#define MHL_DAL_CTRL_reg                                              0x98034600
+#define MHL_DAL_CTRL_inst_addr                                        "0x0180"
+#define MHL_DAL_CTRL_inst                                             0x0180
+#define set_MHL_DAL_CTRL_reg(data)                                    (*((volatile unsigned int*)MHL_DAL_CTRL_reg)=data)
+#define get_MHL_DAL_CTRL_reg                                          (*((volatile unsigned int*)MHL_DAL_CTRL_reg))
+#define MHL_DAL_CTRL_dummy_31_29_shift                                (29)
+#define MHL_DAL_CTRL_mhl_de_sel_shift                                 (28)
+#define MHL_DAL_CTRL_mhl_tran_err_thrd_shift                          (24)
+#define MHL_DAL_CTRL_mhl_neg_de_err_thrd_shift                        (20)
+#define MHL_DAL_CTRL_mhl_pos_de_err_thrd_shift                        (16)
+#define MHL_DAL_CTRL_b_r_ch_sel_shift                                 (15)
+#define MHL_DAL_CTRL_mhl_neg_de_lowbd_shift                           (8)
+#define MHL_DAL_CTRL_dummy_7_6_shift                                  (6)
+#define MHL_DAL_CTRL_mhl_pos_de_lowbd_shift                           (0)
+#define MHL_DAL_CTRL_dummy_31_29_mask                                 (0xE0000000)
+#define MHL_DAL_CTRL_mhl_de_sel_mask                                  (0x10000000)
+#define MHL_DAL_CTRL_mhl_tran_err_thrd_mask                           (0x0F000000)
+#define MHL_DAL_CTRL_mhl_neg_de_err_thrd_mask                         (0x00F00000)
+#define MHL_DAL_CTRL_mhl_pos_de_err_thrd_mask                         (0x000F0000)
+#define MHL_DAL_CTRL_b_r_ch_sel_mask                                  (0x00008000)
+#define MHL_DAL_CTRL_mhl_neg_de_lowbd_mask                            (0x00007F00)
+#define MHL_DAL_CTRL_dummy_7_6_mask                                   (0x000000C0)
+#define MHL_DAL_CTRL_mhl_pos_de_lowbd_mask                            (0x0000003F)
+#define MHL_DAL_CTRL_dummy_31_29(data)                                (0xE0000000&((data)<<29))
+#define MHL_DAL_CTRL_mhl_de_sel(data)                                 (0x10000000&((data)<<28))
+#define MHL_DAL_CTRL_mhl_tran_err_thrd(data)                          (0x0F000000&((data)<<24))
+#define MHL_DAL_CTRL_mhl_neg_de_err_thrd(data)                        (0x00F00000&((data)<<20))
+#define MHL_DAL_CTRL_mhl_pos_de_err_thrd(data)                        (0x000F0000&((data)<<16))
+#define MHL_DAL_CTRL_b_r_ch_sel(data)                                 (0x00008000&((data)<<15))
+#define MHL_DAL_CTRL_mhl_neg_de_lowbd(data)                           (0x00007F00&((data)<<8))
+#define MHL_DAL_CTRL_dummy_7_6(data)                                  (0x000000C0&((data)<<6))
+#define MHL_DAL_CTRL_mhl_pos_de_lowbd(data)                           (0x0000003F&(data))
+#define MHL_DAL_CTRL_get_dummy_31_29(data)                            ((0xE0000000&(data))>>29)
+#define MHL_DAL_CTRL_get_mhl_de_sel(data)                             ((0x10000000&(data))>>28)
+#define MHL_DAL_CTRL_get_mhl_tran_err_thrd(data)                      ((0x0F000000&(data))>>24)
+#define MHL_DAL_CTRL_get_mhl_neg_de_err_thrd(data)                    ((0x00F00000&(data))>>20)
+#define MHL_DAL_CTRL_get_mhl_pos_de_err_thrd(data)                    ((0x000F0000&(data))>>16)
+#define MHL_DAL_CTRL_get_b_r_ch_sel(data)                             ((0x00008000&(data))>>15)
+#define MHL_DAL_CTRL_get_mhl_neg_de_lowbd(data)                       ((0x00007F00&(data))>>8)
+#define MHL_DAL_CTRL_get_dummy_7_6(data)                              ((0x000000C0&(data))>>6)
+#define MHL_DAL_CTRL_get_mhl_pos_de_lowbd(data)                       (0x0000003F&(data))
+
+
+#define MHL_DAL_STATUS                                                0x604
+#define MHL_DAL_STATUS_reg_addr                                       "0x98034604"
+#define MHL_DAL_STATUS_reg                                            0x98034604
+#define MHL_DAL_STATUS_inst_addr                                      "0x0181"
+#define MHL_DAL_STATUS_inst                                           0x0181
+#define set_MHL_DAL_STATUS_reg(data)                                  (*((volatile unsigned int*)MHL_DAL_STATUS_reg)=data)
+#define get_MHL_DAL_STATUS_reg                                        (*((volatile unsigned int*)MHL_DAL_STATUS_reg))
+#define MHL_DAL_STATUS_mhl_de_glitch_cycle_shift                      (4)
+#define MHL_DAL_STATUS_mhl_ver_1_2_shift                              (2)
+#define MHL_DAL_STATUS_mhl_de_glitch_en_shift                         (1)
+#define MHL_DAL_STATUS_pn_swap_shift                                  (0)
+#define MHL_DAL_STATUS_mhl_de_glitch_cycle_mask                       (0x000000F0)
+#define MHL_DAL_STATUS_mhl_ver_1_2_mask                               (0x00000004)
+#define MHL_DAL_STATUS_mhl_de_glitch_en_mask                          (0x00000002)
+#define MHL_DAL_STATUS_pn_swap_mask                                   (0x00000001)
+#define MHL_DAL_STATUS_mhl_de_glitch_cycle(data)                      (0x000000F0&((data)<<4))
+#define MHL_DAL_STATUS_mhl_ver_1_2(data)                              (0x00000004&((data)<<2))
+#define MHL_DAL_STATUS_mhl_de_glitch_en(data)                         (0x00000002&((data)<<1))
+#define MHL_DAL_STATUS_pn_swap(data)                                  (0x00000001&(data))
+#define MHL_DAL_STATUS_get_mhl_de_glitch_cycle(data)                  ((0x000000F0&(data))>>4)
+#define MHL_DAL_STATUS_get_mhl_ver_1_2(data)                          ((0x00000004&(data))>>2)
+#define MHL_DAL_STATUS_get_mhl_de_glitch_en(data)                     ((0x00000002&(data))>>1)
+#define MHL_DAL_STATUS_get_pn_swap(data)                              (0x00000001&(data))
+
+
+#define MHL_MD_CTRL                                                   0x608
+#define MHL_MD_CTRL_reg_addr                                          "0x98034608"
+#define MHL_MD_CTRL_reg                                               0x98034608
+#define MHL_MD_CTRL_inst_addr                                         "0x0182"
+#define MHL_MD_CTRL_inst                                              0x0182
+#define set_MHL_MD_CTRL_reg(data)                                     (*((volatile unsigned int*)MHL_MD_CTRL_reg)=data)
+#define get_MHL_MD_CTRL_reg                                           (*((volatile unsigned int*)MHL_MD_CTRL_reg))
+#define MHL_MD_CTRL_mhl_mode_err_wd_shift                             (26)
+#define MHL_MD_CTRL_mhl_mode_err_int_shift                            (25)
+#define MHL_MD_CTRL_mhl_mode_shift                                    (24)
+#define MHL_MD_CTRL_mhl_mode_det_per_sel_shift                        (20)
+#define MHL_MD_CTRL_mhl_mode_det_per_shift                            (4)
+#define MHL_MD_CTRL_mhl_mode_det_shift                                (2)
+#define MHL_MD_CTRL_mhl_mode_det_cont_shift                           (1)
+#define MHL_MD_CTRL_mhl_mode_det_start_shift                          (0)
+#define MHL_MD_CTRL_mhl_mode_err_wd_mask                              (0x04000000)
+#define MHL_MD_CTRL_mhl_mode_err_int_mask                             (0x02000000)
+#define MHL_MD_CTRL_mhl_mode_mask                                     (0x01000000)
+#define MHL_MD_CTRL_mhl_mode_det_per_sel_mask                         (0x00100000)
+#define MHL_MD_CTRL_mhl_mode_det_per_mask                             (0x000FFFF0)
+#define MHL_MD_CTRL_mhl_mode_det_mask                                 (0x0000000C)
+#define MHL_MD_CTRL_mhl_mode_det_cont_mask                            (0x00000002)
+#define MHL_MD_CTRL_mhl_mode_det_start_mask                           (0x00000001)
+#define MHL_MD_CTRL_mhl_mode_err_wd(data)                             (0x04000000&((data)<<26))
+#define MHL_MD_CTRL_mhl_mode_err_int(data)                            (0x02000000&((data)<<25))
+#define MHL_MD_CTRL_mhl_mode(data)                                    (0x01000000&((data)<<24))
+#define MHL_MD_CTRL_mhl_mode_det_per_sel(data)                        (0x00100000&((data)<<20))
+#define MHL_MD_CTRL_mhl_mode_det_per(data)                            (0x000FFFF0&((data)<<4))
+#define MHL_MD_CTRL_mhl_mode_det(data)                                (0x0000000C&((data)<<2))
+#define MHL_MD_CTRL_mhl_mode_det_cont(data)                           (0x00000002&((data)<<1))
+#define MHL_MD_CTRL_mhl_mode_det_start(data)                          (0x00000001&(data))
+#define MHL_MD_CTRL_get_mhl_mode_err_wd(data)                         ((0x04000000&(data))>>26)
+#define MHL_MD_CTRL_get_mhl_mode_err_int(data)                        ((0x02000000&(data))>>25)
+#define MHL_MD_CTRL_get_mhl_mode(data)                                ((0x01000000&(data))>>24)
+#define MHL_MD_CTRL_get_mhl_mode_det_per_sel(data)                    ((0x00100000&(data))>>20)
+#define MHL_MD_CTRL_get_mhl_mode_det_per(data)                        ((0x000FFFF0&(data))>>4)
+#define MHL_MD_CTRL_get_mhl_mode_det(data)                            ((0x0000000C&(data))>>2)
+#define MHL_MD_CTRL_get_mhl_mode_det_cont(data)                       ((0x00000002&(data))>>1)
+#define MHL_MD_CTRL_get_mhl_mode_det_start(data)                      (0x00000001&(data))
+
+
+#define MHL_MD_THRESHOLD                                              0x60c
+#define MHL_MD_THRESHOLD_reg_addr                                     "0x9803460c"
+#define MHL_MD_THRESHOLD_reg                                          0x9803460c
+#define MHL_MD_THRESHOLD_inst_addr                                    "0x0183"
+#define MHL_MD_THRESHOLD_inst                                         0x0183
+#define set_MHL_MD_THRESHOLD_reg(data)                                (*((volatile unsigned int*)MHL_MD_THRESHOLD_reg)=data)
+#define get_MHL_MD_THRESHOLD_reg                                      (*((volatile unsigned int*)MHL_MD_THRESHOLD_reg))
+#define MHL_MD_THRESHOLD_threshold_pp_shift                           (16)
+#define MHL_MD_THRESHOLD_threshold_24bits_shift                       (0)
+#define MHL_MD_THRESHOLD_threshold_pp_mask                            (0xFFFF0000)
+#define MHL_MD_THRESHOLD_threshold_24bits_mask                        (0x0000FFFF)
+#define MHL_MD_THRESHOLD_threshold_pp(data)                           (0xFFFF0000&((data)<<16))
+#define MHL_MD_THRESHOLD_threshold_24bits(data)                       (0x0000FFFF&(data))
+#define MHL_MD_THRESHOLD_get_threshold_pp(data)                       ((0xFFFF0000&(data))>>16)
+#define MHL_MD_THRESHOLD_get_threshold_24bits(data)                   (0x0000FFFF&(data))
+
+
+#define MHL_MD_CNT                                                    0x610
+#define MHL_MD_CNT_reg_addr                                           "0x98034610"
+#define MHL_MD_CNT_reg                                                0x98034610
+#define MHL_MD_CNT_inst_addr                                          "0x0184"
+#define MHL_MD_CNT_inst                                               0x0184
+#define set_MHL_MD_CNT_reg(data)                                      (*((volatile unsigned int*)MHL_MD_CNT_reg)=data)
+#define get_MHL_MD_CNT_reg                                            (*((volatile unsigned int*)MHL_MD_CNT_reg))
+#define MHL_MD_CNT_det_cnt_pp_shift                                   (16)
+#define MHL_MD_CNT_det_cnt_24bit_shift                                (0)
+#define MHL_MD_CNT_det_cnt_pp_mask                                    (0xFFFF0000)
+#define MHL_MD_CNT_det_cnt_24bit_mask                                 (0x0000FFFF)
+#define MHL_MD_CNT_det_cnt_pp(data)                                   (0xFFFF0000&((data)<<16))
+#define MHL_MD_CNT_det_cnt_24bit(data)                                (0x0000FFFF&(data))
+#define MHL_MD_CNT_get_det_cnt_pp(data)                               ((0xFFFF0000&(data))>>16)
+#define MHL_MD_CNT_get_det_cnt_24bit(data)                            (0x0000FFFF&(data))
+
+
+#define MHL_DEMUX_CTRL                                                0x614
+#define MHL_DEMUX_CTRL_reg_addr                                       "0x98034614"
+#define MHL_DEMUX_CTRL_reg                                            0x98034614
+#define MHL_DEMUX_CTRL_inst_addr                                      "0x0185"
+#define MHL_DEMUX_CTRL_inst                                           0x0185
+#define set_MHL_DEMUX_CTRL_reg(data)                                  (*((volatile unsigned int*)MHL_DEMUX_CTRL_reg)=data)
+#define get_MHL_DEMUX_CTRL_reg                                        (*((volatile unsigned int*)MHL_DEMUX_CTRL_reg))
+#define MHL_DEMUX_CTRL_video_wd_en_shift                              (12)
+#define MHL_DEMUX_CTRL_audio_wd_en_shift                              (11)
+#define MHL_DEMUX_CTRL_ch_bound_chg_wd_en_shift                       (10)
+#define MHL_DEMUX_CTRL_ch_bound_chg_int_en_shift                      (9)
+#define MHL_DEMUX_CTRL_ch_bound_chg_det_shift                         (8)
+#define MHL_DEMUX_CTRL_demux_sel_shift                                (4)
+#define MHL_DEMUX_CTRL_dvi_ch_sync_shift                              (3)
+#define MHL_DEMUX_CTRL_mhl_pp_en_shift                                (1)
+#define MHL_DEMUX_CTRL_mhl_en_shift                                   (0)
+#define MHL_DEMUX_CTRL_video_wd_en_mask                               (0x00001000)
+#define MHL_DEMUX_CTRL_audio_wd_en_mask                               (0x00000800)
+#define MHL_DEMUX_CTRL_ch_bound_chg_wd_en_mask                        (0x00000400)
+#define MHL_DEMUX_CTRL_ch_bound_chg_int_en_mask                       (0x00000200)
+#define MHL_DEMUX_CTRL_ch_bound_chg_det_mask                          (0x00000100)
+#define MHL_DEMUX_CTRL_demux_sel_mask                                 (0x00000070)
+#define MHL_DEMUX_CTRL_dvi_ch_sync_mask                               (0x00000008)
+#define MHL_DEMUX_CTRL_mhl_pp_en_mask                                 (0x00000002)
+#define MHL_DEMUX_CTRL_mhl_en_mask                                    (0x00000001)
+#define MHL_DEMUX_CTRL_video_wd_en(data)                              (0x00001000&((data)<<12))
+#define MHL_DEMUX_CTRL_audio_wd_en(data)                              (0x00000800&((data)<<11))
+#define MHL_DEMUX_CTRL_ch_bound_chg_wd_en(data)                       (0x00000400&((data)<<10))
+#define MHL_DEMUX_CTRL_ch_bound_chg_int_en(data)                      (0x00000200&((data)<<9))
+#define MHL_DEMUX_CTRL_ch_bound_chg_det(data)                         (0x00000100&((data)<<8))
+#define MHL_DEMUX_CTRL_demux_sel(data)                                (0x00000070&((data)<<4))
+#define MHL_DEMUX_CTRL_dvi_ch_sync(data)                              (0x00000008&((data)<<3))
+#define MHL_DEMUX_CTRL_mhl_pp_en(data)                                (0x00000002&((data)<<1))
+#define MHL_DEMUX_CTRL_mhl_en(data)                                   (0x00000001&(data))
+#define MHL_DEMUX_CTRL_get_video_wd_en(data)                          ((0x00001000&(data))>>12)
+#define MHL_DEMUX_CTRL_get_audio_wd_en(data)                          ((0x00000800&(data))>>11)
+#define MHL_DEMUX_CTRL_get_ch_bound_chg_wd_en(data)                   ((0x00000400&(data))>>10)
+#define MHL_DEMUX_CTRL_get_ch_bound_chg_int_en(data)                  ((0x00000200&(data))>>9)
+#define MHL_DEMUX_CTRL_get_ch_bound_chg_det(data)                     ((0x00000100&(data))>>8)
+#define MHL_DEMUX_CTRL_get_demux_sel(data)                            ((0x00000070&(data))>>4)
+#define MHL_DEMUX_CTRL_get_dvi_ch_sync(data)                          ((0x00000008&(data))>>3)
+#define MHL_DEMUX_CTRL_get_mhl_pp_en(data)                            ((0x00000002&(data))>>1)
+#define MHL_DEMUX_CTRL_get_mhl_en(data)                               (0x00000001&(data))
+
+
+#define MHL_STATUS                                                    0x618
+#define MHL_STATUS_reg_addr                                           "0x98034618"
+#define MHL_STATUS_reg                                                0x98034618
+#define MHL_STATUS_inst_addr                                          "0x0186"
+#define MHL_STATUS_inst                                               0x0186
+#define set_MHL_STATUS_reg(data)                                      (*((volatile unsigned int*)MHL_STATUS_reg)=data)
+#define get_MHL_STATUS_reg                                            (*((volatile unsigned int*)MHL_STATUS_reg))
+#define MHL_STATUS_ch_bound_chg_shift                                 (12)
+#define MHL_STATUS_mhl_mode_err_shift                                 (8)
+#define MHL_STATUS_non_ctrl_glitch_occ_flag_shift                     (5)
+#define MHL_STATUS_ctrl_glitch_occr_flag_shift                        (4)
+#define MHL_STATUS_mhl_tran_err_flag_shift                            (2)
+#define MHL_STATUS_mhl_pos_de_err_flag_shift                          (1)
+#define MHL_STATUS_mhl_neg_de_err_flag_shift                          (0)
+#define MHL_STATUS_ch_bound_chg_mask                                  (0x00001000)
+#define MHL_STATUS_mhl_mode_err_mask                                  (0x00000100)
+#define MHL_STATUS_non_ctrl_glitch_occ_flag_mask                      (0x00000020)
+#define MHL_STATUS_ctrl_glitch_occr_flag_mask                         (0x00000010)
+#define MHL_STATUS_mhl_tran_err_flag_mask                             (0x00000004)
+#define MHL_STATUS_mhl_pos_de_err_flag_mask                           (0x00000002)
+#define MHL_STATUS_mhl_neg_de_err_flag_mask                           (0x00000001)
+#define MHL_STATUS_ch_bound_chg(data)                                 (0x00001000&((data)<<12))
+#define MHL_STATUS_mhl_mode_err(data)                                 (0x00000100&((data)<<8))
+#define MHL_STATUS_non_ctrl_glitch_occ_flag(data)                     (0x00000020&((data)<<5))
+#define MHL_STATUS_ctrl_glitch_occr_flag(data)                        (0x00000010&((data)<<4))
+#define MHL_STATUS_mhl_tran_err_flag(data)                            (0x00000004&((data)<<2))
+#define MHL_STATUS_mhl_pos_de_err_flag(data)                          (0x00000002&((data)<<1))
+#define MHL_STATUS_mhl_neg_de_err_flag(data)                          (0x00000001&(data))
+#define MHL_STATUS_get_ch_bound_chg(data)                             ((0x00001000&(data))>>12)
+#define MHL_STATUS_get_mhl_mode_err(data)                             ((0x00000100&(data))>>8)
+#define MHL_STATUS_get_non_ctrl_glitch_occ_flag(data)                 ((0x00000020&(data))>>5)
+#define MHL_STATUS_get_ctrl_glitch_occr_flag(data)                    ((0x00000010&(data))>>4)
+#define MHL_STATUS_get_mhl_tran_err_flag(data)                        ((0x00000004&(data))>>2)
+#define MHL_STATUS_get_mhl_pos_de_err_flag(data)                      ((0x00000002&(data))>>1)
+#define MHL_STATUS_get_mhl_neg_de_err_flag(data)                      (0x00000001&(data))
+
+
+#define MHL_CH_CR                                                     0x61c
+#define MHL_CH_CR_reg_addr                                            "0x9803461c"
+#define MHL_CH_CR_reg                                                 0x9803461c
+#define MHL_CH_CR_inst_addr                                           "0x0187"
+#define MHL_CH_CR_inst                                                0x0187
+#define set_MHL_CH_CR_reg(data)                                       (*((volatile unsigned int*)MHL_CH_CR_reg)=data)
+#define get_MHL_CH_CR_reg                                             (*((volatile unsigned int*)MHL_CH_CR_reg))
+#define MHL_CH_CR_mhl_ch1_cr_flush_shift                              (17)
+#define MHL_CH_CR_mhl_ch1_cr_afifo_en_shift                           (16)
+#define MHL_CH_CR_dummy_15_2_shift                                    (2)
+#define MHL_CH_CR_mhl_ch0_cr_flush_shift                              (1)
+#define MHL_CH_CR_mhl_ch0_cr_afifo_en_shift                           (0)
+#define MHL_CH_CR_mhl_ch1_cr_flush_mask                               (0x00020000)
+#define MHL_CH_CR_mhl_ch1_cr_afifo_en_mask                            (0x00010000)
+#define MHL_CH_CR_dummy_15_2_mask                                     (0x0000FFFC)
+#define MHL_CH_CR_mhl_ch0_cr_flush_mask                               (0x00000002)
+#define MHL_CH_CR_mhl_ch0_cr_afifo_en_mask                            (0x00000001)
+#define MHL_CH_CR_mhl_ch1_cr_flush(data)                              (0x00020000&((data)<<17))
+#define MHL_CH_CR_mhl_ch1_cr_afifo_en(data)                           (0x00010000&((data)<<16))
+#define MHL_CH_CR_dummy_15_2(data)                                    (0x0000FFFC&((data)<<2))
+#define MHL_CH_CR_mhl_ch0_cr_flush(data)                              (0x00000002&((data)<<1))
+#define MHL_CH_CR_mhl_ch0_cr_afifo_en(data)                           (0x00000001&(data))
+#define MHL_CH_CR_get_mhl_ch1_cr_flush(data)                          ((0x00020000&(data))>>17)
+#define MHL_CH_CR_get_mhl_ch1_cr_afifo_en(data)                       ((0x00010000&(data))>>16)
+#define MHL_CH_CR_get_dummy_15_2(data)                                ((0x0000FFFC&(data))>>2)
+#define MHL_CH_CR_get_mhl_ch0_cr_flush(data)                          ((0x00000002&(data))>>1)
+#define MHL_CH_CR_get_mhl_ch0_cr_afifo_en(data)                       (0x00000001&(data))
+
+
+#define MHL_CH_SR                                                     0x620
+#define MHL_CH_SR_reg_addr                                            "0x98034620"
+#define MHL_CH_SR_reg                                                 0x98034620
+#define MHL_CH_SR_inst_addr                                           "0x0188"
+#define MHL_CH_SR_inst                                                0x0188
+#define set_MHL_CH_SR_reg(data)                                       (*((volatile unsigned int*)MHL_CH_SR_reg)=data)
+#define get_MHL_CH_SR_reg                                             (*((volatile unsigned int*)MHL_CH_SR_reg))
+#define MHL_CH_SR_mhl_ch1_sr_wrclk_det_timeout_flag_shift             (20)
+#define MHL_CH_SR_mhl_ch1_sr_rwclk_det_timeout_flag_shift             (19)
+#define MHL_CH_SR_mhl_ch1_sr_wovflow_flag_shift                       (18)
+#define MHL_CH_SR_mhl_ch1_sr_rudflow_flag_shift                       (17)
+#define MHL_CH_SR_mhl_ch1_sr_rflush_flag_shift                        (16)
+#define MHL_CH_SR_dummy_15_5_shift                                    (5)
+#define MHL_CH_SR_mhl_ch0_sr_wrclk_det_timeout_flag_shift             (4)
+#define MHL_CH_SR_mhl_ch0_sr_rwclk_det_timeout_flag_shift             (3)
+#define MHL_CH_SR_mhl_ch0_sr_wovflow_flag_shift                       (2)
+#define MHL_CH_SR_mhl_ch0_sr_rudflow_flag_shift                       (1)
+#define MHL_CH_SR_mhl_ch0_sr_rflush_flag_shift                        (0)
+#define MHL_CH_SR_mhl_ch1_sr_wrclk_det_timeout_flag_mask              (0x00100000)
+#define MHL_CH_SR_mhl_ch1_sr_rwclk_det_timeout_flag_mask              (0x00080000)
+#define MHL_CH_SR_mhl_ch1_sr_wovflow_flag_mask                        (0x00040000)
+#define MHL_CH_SR_mhl_ch1_sr_rudflow_flag_mask                        (0x00020000)
+#define MHL_CH_SR_mhl_ch1_sr_rflush_flag_mask                         (0x00010000)
+#define MHL_CH_SR_dummy_15_5_mask                                     (0x0000FFE0)
+#define MHL_CH_SR_mhl_ch0_sr_wrclk_det_timeout_flag_mask              (0x00000010)
+#define MHL_CH_SR_mhl_ch0_sr_rwclk_det_timeout_flag_mask              (0x00000008)
+#define MHL_CH_SR_mhl_ch0_sr_wovflow_flag_mask                        (0x00000004)
+#define MHL_CH_SR_mhl_ch0_sr_rudflow_flag_mask                        (0x00000002)
+#define MHL_CH_SR_mhl_ch0_sr_rflush_flag_mask                         (0x00000001)
+#define MHL_CH_SR_mhl_ch1_sr_wrclk_det_timeout_flag(data)             (0x00100000&((data)<<20))
+#define MHL_CH_SR_mhl_ch1_sr_rwclk_det_timeout_flag(data)             (0x00080000&((data)<<19))
+#define MHL_CH_SR_mhl_ch1_sr_wovflow_flag(data)                       (0x00040000&((data)<<18))
+#define MHL_CH_SR_mhl_ch1_sr_rudflow_flag(data)                       (0x00020000&((data)<<17))
+#define MHL_CH_SR_mhl_ch1_sr_rflush_flag(data)                        (0x00010000&((data)<<16))
+#define MHL_CH_SR_dummy_15_5(data)                                    (0x0000FFE0&((data)<<5))
+#define MHL_CH_SR_mhl_ch0_sr_wrclk_det_timeout_flag(data)             (0x00000010&((data)<<4))
+#define MHL_CH_SR_mhl_ch0_sr_rwclk_det_timeout_flag(data)             (0x00000008&((data)<<3))
+#define MHL_CH_SR_mhl_ch0_sr_wovflow_flag(data)                       (0x00000004&((data)<<2))
+#define MHL_CH_SR_mhl_ch0_sr_rudflow_flag(data)                       (0x00000002&((data)<<1))
+#define MHL_CH_SR_mhl_ch0_sr_rflush_flag(data)                        (0x00000001&(data))
+#define MHL_CH_SR_get_mhl_ch1_sr_wrclk_det_timeout_flag(data)         ((0x00100000&(data))>>20)
+#define MHL_CH_SR_get_mhl_ch1_sr_rwclk_det_timeout_flag(data)         ((0x00080000&(data))>>19)
+#define MHL_CH_SR_get_mhl_ch1_sr_wovflow_flag(data)                   ((0x00040000&(data))>>18)
+#define MHL_CH_SR_get_mhl_ch1_sr_rudflow_flag(data)                   ((0x00020000&(data))>>17)
+#define MHL_CH_SR_get_mhl_ch1_sr_rflush_flag(data)                    ((0x00010000&(data))>>16)
+#define MHL_CH_SR_get_dummy_15_5(data)                                ((0x0000FFE0&(data))>>5)
+#define MHL_CH_SR_get_mhl_ch0_sr_wrclk_det_timeout_flag(data)         ((0x00000010&(data))>>4)
+#define MHL_CH_SR_get_mhl_ch0_sr_rwclk_det_timeout_flag(data)         ((0x00000008&(data))>>3)
+#define MHL_CH_SR_get_mhl_ch0_sr_wovflow_flag(data)                   ((0x00000004&(data))>>2)
+#define MHL_CH_SR_get_mhl_ch0_sr_rudflow_flag(data)                   ((0x00000002&(data))>>1)
+#define MHL_CH_SR_get_mhl_ch0_sr_rflush_flag(data)                    (0x00000001&(data))
+
+
+#define MHL3_CTRL                                                     0x700
+#define MHL3_CTRL_reg_addr                                            "0x98034700"
+#define MHL3_CTRL_reg                                                 0x98034700
+#define MHL3_CTRL_inst_addr                                           "0x01C0"
+#define MHL3_CTRL_inst                                                0x01C0
+#define set_MHL3_CTRL_reg(data)                                       (*((volatile unsigned int*)MHL3_CTRL_reg)=data)
+#define get_MHL3_CTRL_reg                                             (*((volatile unsigned int*)MHL3_CTRL_reg))
+#define MHL3_CTRL_rr_sync_clr_shift                                   (13)
+#define MHL3_CTRL_debug_sel_shift                                     (10)
+#define MHL3_CTRL_pkt_type_decode_sel_shift                           (8)
+#define MHL3_CTRL_errc_sel_shift                                      (5)
+#define MHL3_CTRL_rr_mode_shift                                       (3)
+#define MHL3_CTRL_mhl_ver3_dvi_en_shift                               (2)
+#define MHL3_CTRL_mhl_ver3_24_16_bit_sel_shift                        (1)
+#define MHL3_CTRL_mhl_ver3_en_shift                                   (0)
+#define MHL3_CTRL_rr_sync_clr_mask                                    (0x00002000)
+#define MHL3_CTRL_debug_sel_mask                                      (0x00001C00)
+#define MHL3_CTRL_pkt_type_decode_sel_mask                            (0x00000300)
+#define MHL3_CTRL_errc_sel_mask                                       (0x000000E0)
+#define MHL3_CTRL_rr_mode_mask                                        (0x00000018)
+#define MHL3_CTRL_mhl_ver3_dvi_en_mask                                (0x00000004)
+#define MHL3_CTRL_mhl_ver3_24_16_bit_sel_mask                         (0x00000002)
+#define MHL3_CTRL_mhl_ver3_en_mask                                    (0x00000001)
+#define MHL3_CTRL_rr_sync_clr(data)                                   (0x00002000&((data)<<13))
+#define MHL3_CTRL_debug_sel(data)                                     (0x00001C00&((data)<<10))
+#define MHL3_CTRL_pkt_type_decode_sel(data)                           (0x00000300&((data)<<8))
+#define MHL3_CTRL_errc_sel(data)                                      (0x000000E0&((data)<<5))
+#define MHL3_CTRL_rr_mode(data)                                       (0x00000018&((data)<<3))
+#define MHL3_CTRL_mhl_ver3_dvi_en(data)                               (0x00000004&((data)<<2))
+#define MHL3_CTRL_mhl_ver3_24_16_bit_sel(data)                        (0x00000002&((data)<<1))
+#define MHL3_CTRL_mhl_ver3_en(data)                                   (0x00000001&(data))
+#define MHL3_CTRL_get_rr_sync_clr(data)                               ((0x00002000&(data))>>13)
+#define MHL3_CTRL_get_debug_sel(data)                                 ((0x00001C00&(data))>>10)
+#define MHL3_CTRL_get_pkt_type_decode_sel(data)                       ((0x00000300&(data))>>8)
+#define MHL3_CTRL_get_errc_sel(data)                                  ((0x000000E0&(data))>>5)
+#define MHL3_CTRL_get_rr_mode(data)                                   ((0x00000018&(data))>>3)
+#define MHL3_CTRL_get_mhl_ver3_dvi_en(data)                           ((0x00000004&(data))>>2)
+#define MHL3_CTRL_get_mhl_ver3_24_16_bit_sel(data)                    ((0x00000002&(data))>>1)
+#define MHL3_CTRL_get_mhl_ver3_en(data)                               (0x00000001&(data))
+
+
+#define MHL3_STATUS                                                   0x704
+#define MHL3_STATUS_reg_addr                                          "0x98034704"
+#define MHL3_STATUS_reg                                               0x98034704
+#define MHL3_STATUS_inst_addr                                         "0x01C1"
+#define MHL3_STATUS_inst                                              0x01C1
+#define set_MHL3_STATUS_reg(data)                                     (*((volatile unsigned int*)MHL3_STATUS_reg)=data)
+#define get_MHL3_STATUS_reg                                           (*((volatile unsigned int*)MHL3_STATUS_reg))
+#define MHL3_STATUS_bits_per_pixel_mode_shift                         (8)
+#define MHL3_STATUS_max_trans_symbol_err_shift                        (7)
+#define MHL3_STATUS_rr_err_shift                                      (6)
+#define MHL3_STATUS_blank_payload_len_err_shift                       (5)
+#define MHL3_STATUS_video_payload_len_err_shift                       (4)
+#define MHL3_STATUS_hdr_err_shift                                     (3)
+#define MHL3_STATUS_packet_trail_gb_err_shift                         (2)
+#define MHL3_STATUS_packet_lead_gb_err_shift                          (1)
+#define MHL3_STATUS_video_gb_err_shift                                (0)
+#define MHL3_STATUS_bits_per_pixel_mode_mask                          (0x00000300)
+#define MHL3_STATUS_max_trans_symbol_err_mask                         (0x00000080)
+#define MHL3_STATUS_rr_err_mask                                       (0x00000040)
+#define MHL3_STATUS_blank_payload_len_err_mask                        (0x00000020)
+#define MHL3_STATUS_video_payload_len_err_mask                        (0x00000010)
+#define MHL3_STATUS_hdr_err_mask                                      (0x00000008)
+#define MHL3_STATUS_packet_trail_gb_err_mask                          (0x00000004)
+#define MHL3_STATUS_packet_lead_gb_err_mask                           (0x00000002)
+#define MHL3_STATUS_video_gb_err_mask                                 (0x00000001)
+#define MHL3_STATUS_bits_per_pixel_mode(data)                         (0x00000300&((data)<<8))
+#define MHL3_STATUS_max_trans_symbol_err(data)                        (0x00000080&((data)<<7))
+#define MHL3_STATUS_rr_err(data)                                      (0x00000040&((data)<<6))
+#define MHL3_STATUS_blank_payload_len_err(data)                       (0x00000020&((data)<<5))
+#define MHL3_STATUS_video_payload_len_err(data)                       (0x00000010&((data)<<4))
+#define MHL3_STATUS_hdr_err(data)                                     (0x00000008&((data)<<3))
+#define MHL3_STATUS_packet_trail_gb_err(data)                         (0x00000004&((data)<<2))
+#define MHL3_STATUS_packet_lead_gb_err(data)                          (0x00000002&((data)<<1))
+#define MHL3_STATUS_video_gb_err(data)                                (0x00000001&(data))
+#define MHL3_STATUS_get_bits_per_pixel_mode(data)                     ((0x00000300&(data))>>8)
+#define MHL3_STATUS_get_max_trans_symbol_err(data)                    ((0x00000080&(data))>>7)
+#define MHL3_STATUS_get_rr_err(data)                                  ((0x00000040&(data))>>6)
+#define MHL3_STATUS_get_blank_payload_len_err(data)                   ((0x00000020&(data))>>5)
+#define MHL3_STATUS_get_video_payload_len_err(data)                   ((0x00000010&(data))>>4)
+#define MHL3_STATUS_get_hdr_err(data)                                 ((0x00000008&(data))>>3)
+#define MHL3_STATUS_get_packet_trail_gb_err(data)                     ((0x00000004&(data))>>2)
+#define MHL3_STATUS_get_packet_lead_gb_err(data)                      ((0x00000002&(data))>>1)
+#define MHL3_STATUS_get_video_gb_err(data)                            (0x00000001&(data))
+
+
+#define TMDS_BIT_ERR_DET                                              0x708
+#define TMDS_BIT_ERR_DET_reg_addr                                     "0x98034708"
+#define TMDS_BIT_ERR_DET_reg                                          0x98034708
+#define TMDS_BIT_ERR_DET_inst_addr                                    "0x01C2"
+#define TMDS_BIT_ERR_DET_inst                                         0x01C2
+#define set_TMDS_BIT_ERR_DET_reg(data)                                (*((volatile unsigned int*)TMDS_BIT_ERR_DET_reg)=data)
+#define get_TMDS_BIT_ERR_DET_reg                                      (*((volatile unsigned int*)TMDS_BIT_ERR_DET_reg))
+#define TMDS_BIT_ERR_DET_bit_err_det_thd_shift                        (16)
+#define TMDS_BIT_ERR_DET_bit_err_irq_en_shift                         (11)
+#define TMDS_BIT_ERR_DET_bit_err_reset_shift                          (10)
+#define TMDS_BIT_ERR_DET_bit_err_det_period_shift                     (4)
+#define TMDS_BIT_ERR_DET_bit_err_det_mode_shift                       (1)
+#define TMDS_BIT_ERR_DET_bit_err_det_en_shift                         (0)
+#define TMDS_BIT_ERR_DET_bit_err_det_thd_mask                         (0xFFFF0000)
+#define TMDS_BIT_ERR_DET_bit_err_irq_en_mask                          (0x00000800)
+#define TMDS_BIT_ERR_DET_bit_err_reset_mask                           (0x00000400)
+#define TMDS_BIT_ERR_DET_bit_err_det_period_mask                      (0x000003F0)
+#define TMDS_BIT_ERR_DET_bit_err_det_mode_mask                        (0x00000002)
+#define TMDS_BIT_ERR_DET_bit_err_det_en_mask                          (0x00000001)
+#define TMDS_BIT_ERR_DET_bit_err_det_thd(data)                        (0xFFFF0000&((data)<<16))
+#define TMDS_BIT_ERR_DET_bit_err_irq_en(data)                         (0x00000800&((data)<<11))
+#define TMDS_BIT_ERR_DET_bit_err_reset(data)                          (0x00000400&((data)<<10))
+#define TMDS_BIT_ERR_DET_bit_err_det_period(data)                     (0x000003F0&((data)<<4))
+#define TMDS_BIT_ERR_DET_bit_err_det_mode(data)                       (0x00000002&((data)<<1))
+#define TMDS_BIT_ERR_DET_bit_err_det_en(data)                         (0x00000001&(data))
+#define TMDS_BIT_ERR_DET_get_bit_err_det_thd(data)                    ((0xFFFF0000&(data))>>16)
+#define TMDS_BIT_ERR_DET_get_bit_err_irq_en(data)                     ((0x00000800&(data))>>11)
+#define TMDS_BIT_ERR_DET_get_bit_err_reset(data)                      ((0x00000400&(data))>>10)
+#define TMDS_BIT_ERR_DET_get_bit_err_det_period(data)                 ((0x000003F0&(data))>>4)
+#define TMDS_BIT_ERR_DET_get_bit_err_det_mode(data)                   ((0x00000002&(data))>>1)
+#define TMDS_BIT_ERR_DET_get_bit_err_det_en(data)                     (0x00000001&(data))
+
+
+#define TMDS_BIT_ERR_STATUS                                           0x70c
+#define TMDS_BIT_ERR_STATUS_reg_addr                                  "0x9803470c"
+#define TMDS_BIT_ERR_STATUS_reg                                       0x9803470c
+#define TMDS_BIT_ERR_STATUS_inst_addr                                 "0x01C3"
+#define TMDS_BIT_ERR_STATUS_inst                                      0x01C3
+#define set_TMDS_BIT_ERR_STATUS_reg(data)                             (*((volatile unsigned int*)TMDS_BIT_ERR_STATUS_reg)=data)
+#define get_TMDS_BIT_ERR_STATUS_reg                                   (*((volatile unsigned int*)TMDS_BIT_ERR_STATUS_reg))
+#define TMDS_BIT_ERR_STATUS_tmds_ad_max_shift                         (26)
+#define TMDS_BIT_ERR_STATUS_tmds_ad_min_shift                         (20)
+#define TMDS_BIT_ERR_STATUS_tmds_no_dis_reset_shift                   (19)
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_thd_shift                    (18)
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_shift                        (17)
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_cnt_of_shift                 (16)
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_cnt_shift                    (0)
+#define TMDS_BIT_ERR_STATUS_tmds_ad_max_mask                          (0xFC000000)
+#define TMDS_BIT_ERR_STATUS_tmds_ad_min_mask                          (0x03F00000)
+#define TMDS_BIT_ERR_STATUS_tmds_no_dis_reset_mask                    (0x00080000)
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_thd_mask                     (0x00040000)
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_mask                         (0x00020000)
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_cnt_of_mask                  (0x00010000)
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_cnt_mask                     (0x0000FFFF)
+#define TMDS_BIT_ERR_STATUS_tmds_ad_max(data)                         (0xFC000000&((data)<<26))
+#define TMDS_BIT_ERR_STATUS_tmds_ad_min(data)                         (0x03F00000&((data)<<20))
+#define TMDS_BIT_ERR_STATUS_tmds_no_dis_reset(data)                   (0x00080000&((data)<<19))
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_thd(data)                    (0x00040000&((data)<<18))
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err(data)                        (0x00020000&((data)<<17))
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_cnt_of(data)                 (0x00010000&((data)<<16))
+#define TMDS_BIT_ERR_STATUS_tmds_bit_err_cnt(data)                    (0x0000FFFF&(data))
+#define TMDS_BIT_ERR_STATUS_get_tmds_ad_max(data)                     ((0xFC000000&(data))>>26)
+#define TMDS_BIT_ERR_STATUS_get_tmds_ad_min(data)                     ((0x03F00000&(data))>>20)
+#define TMDS_BIT_ERR_STATUS_get_tmds_no_dis_reset(data)               ((0x00080000&(data))>>19)
+#define TMDS_BIT_ERR_STATUS_get_tmds_bit_err_thd(data)                ((0x00040000&(data))>>18)
+#define TMDS_BIT_ERR_STATUS_get_tmds_bit_err(data)                    ((0x00020000&(data))>>17)
+#define TMDS_BIT_ERR_STATUS_get_tmds_bit_err_cnt_of(data)             ((0x00010000&(data))>>16)
+#define TMDS_BIT_ERR_STATUS_get_tmds_bit_err_cnt(data)                (0x0000FFFF&(data))
+
+
+#define MHL_BIST_CTRL                                                 0x710
+#define MHL_BIST_CTRL_reg_addr                                        "0x98034710"
+#define MHL_BIST_CTRL_reg                                             0x98034710
+#define MHL_BIST_CTRL_inst_addr                                       "0x01C4"
+#define MHL_BIST_CTRL_inst                                            0x01C4
+#define set_MHL_BIST_CTRL_reg(data)                                   (*((volatile unsigned int*)MHL_BIST_CTRL_reg)=data)
+#define get_MHL_BIST_CTRL_reg                                         (*((volatile unsigned int*)MHL_BIST_CTRL_reg))
+#define MHL_BIST_CTRL_bist_frame_num_shift                            (24)
+#define MHL_BIST_CTRL_dummy_23_shift                                  (23)
+#define MHL_BIST_CTRL_fixed10_align_en_shift                          (22)
+#define MHL_BIST_CTRL_bist_fixed_shift                                (12)
+#define MHL_BIST_CTRL_bist_fix10_inverse_shift                        (11)
+#define MHL_BIST_CTRL_bist_data_align_en_shift                        (10)
+#define MHL_BIST_CTRL_bist_data_align_num_shift                       (8)
+#define MHL_BIST_CTRL_bist_en_shift                                   (7)
+#define MHL_BIST_CTRL_bist_pattern_shift                              (5)
+#define MHL_BIST_CTRL_bist_duration_shift                             (4)
+#define MHL_BIST_CTRL_bist_stop_shift                                 (3)
+#define MHL_BIST_CTRL_bist_rdm_bypass_shift                           (2)
+#define MHL_BIST_CTRL_bist_cnt_mode_shift                             (1)
+#define MHL_BIST_CTRL_bist_fixed10_align_bypass_shift                 (0)
+#define MHL_BIST_CTRL_bist_frame_num_mask                             (0xFF000000)
+#define MHL_BIST_CTRL_dummy_23_mask                                   (0x00800000)
+#define MHL_BIST_CTRL_fixed10_align_en_mask                           (0x00400000)
+#define MHL_BIST_CTRL_bist_fixed_mask                                 (0x003FF000)
+#define MHL_BIST_CTRL_bist_fix10_inverse_mask                         (0x00000800)
+#define MHL_BIST_CTRL_bist_data_align_en_mask                         (0x00000400)
+#define MHL_BIST_CTRL_bist_data_align_num_mask                        (0x00000300)
+#define MHL_BIST_CTRL_bist_en_mask                                    (0x00000080)
+#define MHL_BIST_CTRL_bist_pattern_mask                               (0x00000060)
+#define MHL_BIST_CTRL_bist_duration_mask                              (0x00000010)
+#define MHL_BIST_CTRL_bist_stop_mask                                  (0x00000008)
+#define MHL_BIST_CTRL_bist_rdm_bypass_mask                            (0x00000004)
+#define MHL_BIST_CTRL_bist_cnt_mode_mask                              (0x00000002)
+#define MHL_BIST_CTRL_bist_fixed10_align_bypass_mask                  (0x00000001)
+#define MHL_BIST_CTRL_bist_frame_num(data)                            (0xFF000000&((data)<<24))
+#define MHL_BIST_CTRL_dummy_23(data)                                  (0x00800000&((data)<<23))
+#define MHL_BIST_CTRL_fixed10_align_en(data)                          (0x00400000&((data)<<22))
+#define MHL_BIST_CTRL_bist_fixed(data)                                (0x003FF000&((data)<<12))
+#define MHL_BIST_CTRL_bist_fix10_inverse(data)                        (0x00000800&((data)<<11))
+#define MHL_BIST_CTRL_bist_data_align_en(data)                        (0x00000400&((data)<<10))
+#define MHL_BIST_CTRL_bist_data_align_num(data)                       (0x00000300&((data)<<8))
+#define MHL_BIST_CTRL_bist_en(data)                                   (0x00000080&((data)<<7))
+#define MHL_BIST_CTRL_bist_pattern(data)                              (0x00000060&((data)<<5))
+#define MHL_BIST_CTRL_bist_duration(data)                             (0x00000010&((data)<<4))
+#define MHL_BIST_CTRL_bist_stop(data)                                 (0x00000008&((data)<<3))
+#define MHL_BIST_CTRL_bist_rdm_bypass(data)                           (0x00000004&((data)<<2))
+#define MHL_BIST_CTRL_bist_cnt_mode(data)                             (0x00000002&((data)<<1))
+#define MHL_BIST_CTRL_bist_fixed10_align_bypass(data)                 (0x00000001&(data))
+#define MHL_BIST_CTRL_get_bist_frame_num(data)                        ((0xFF000000&(data))>>24)
+#define MHL_BIST_CTRL_get_dummy_23(data)                              ((0x00800000&(data))>>23)
+#define MHL_BIST_CTRL_get_fixed10_align_en(data)                      ((0x00400000&(data))>>22)
+#define MHL_BIST_CTRL_get_bist_fixed(data)                            ((0x003FF000&(data))>>12)
+#define MHL_BIST_CTRL_get_bist_fix10_inverse(data)                    ((0x00000800&(data))>>11)
+#define MHL_BIST_CTRL_get_bist_data_align_en(data)                    ((0x00000400&(data))>>10)
+#define MHL_BIST_CTRL_get_bist_data_align_num(data)                   ((0x00000300&(data))>>8)
+#define MHL_BIST_CTRL_get_bist_en(data)                               ((0x00000080&(data))>>7)
+#define MHL_BIST_CTRL_get_bist_pattern(data)                          ((0x00000060&(data))>>5)
+#define MHL_BIST_CTRL_get_bist_duration(data)                         ((0x00000010&(data))>>4)
+#define MHL_BIST_CTRL_get_bist_stop(data)                             ((0x00000008&(data))>>3)
+#define MHL_BIST_CTRL_get_bist_rdm_bypass(data)                       ((0x00000004&(data))>>2)
+#define MHL_BIST_CTRL_get_bist_cnt_mode(data)                         ((0x00000002&(data))>>1)
+#define MHL_BIST_CTRL_get_bist_fixed10_align_bypass(data)             (0x00000001&(data))
+
+
+#define MHL_BIST_ERR_CNT                                              0x714
+#define MHL_BIST_ERR_CNT_reg_addr                                     "0x98034714"
+#define MHL_BIST_ERR_CNT_reg                                          0x98034714
+#define MHL_BIST_ERR_CNT_inst_addr                                    "0x01C5"
+#define MHL_BIST_ERR_CNT_inst                                         0x01C5
+#define set_MHL_BIST_ERR_CNT_reg(data)                                (*((volatile unsigned int*)MHL_BIST_ERR_CNT_reg)=data)
+#define get_MHL_BIST_ERR_CNT_reg                                      (*((volatile unsigned int*)MHL_BIST_ERR_CNT_reg))
+#define MHL_BIST_ERR_CNT_fixed10_align_done_shift                     (16)
+#define MHL_BIST_ERR_CNT_bist_err_cnt_shift                           (0)
+#define MHL_BIST_ERR_CNT_fixed10_align_done_mask                      (0x00010000)
+#define MHL_BIST_ERR_CNT_bist_err_cnt_mask                            (0x0000FFFF)
+#define MHL_BIST_ERR_CNT_fixed10_align_done(data)                     (0x00010000&((data)<<16))
+#define MHL_BIST_ERR_CNT_bist_err_cnt(data)                           (0x0000FFFF&(data))
+#define MHL_BIST_ERR_CNT_get_fixed10_align_done(data)                 ((0x00010000&(data))>>16)
+#define MHL_BIST_ERR_CNT_get_bist_err_cnt(data)                       (0x0000FFFF&(data))
+
+
+#define HDCP_CTRL                                                     0x718
+#define HDCP_CTRL_reg_addr                                            "0x98034718"
+#define HDCP_CTRL_reg                                                 0x98034718
+#define HDCP_CTRL_inst_addr                                           "0x01C6"
+#define HDCP_CTRL_inst                                                0x01C6
+#define set_HDCP_CTRL_reg(data)                                       (*((volatile unsigned int*)HDCP_CTRL_reg)=data)
+#define get_HDCP_CTRL_reg                                             (*((volatile unsigned int*)HDCP_CTRL_reg))
+#define HDCP_CTRL_enc_window_end_shift                                (12)
+#define HDCP_CTRL_dummy_11_10_shift                                   (10)
+#define HDCP_CTRL_enc_window_start_shift                              (0)
+#define HDCP_CTRL_enc_window_end_mask                                 (0x001FF000)
+#define HDCP_CTRL_dummy_11_10_mask                                    (0x00000C00)
+#define HDCP_CTRL_enc_window_start_mask                               (0x000003FF)
+#define HDCP_CTRL_enc_window_end(data)                                (0x001FF000&((data)<<12))
+#define HDCP_CTRL_dummy_11_10(data)                                   (0x00000C00&((data)<<10))
+#define HDCP_CTRL_enc_window_start(data)                              (0x000003FF&(data))
+#define HDCP_CTRL_get_enc_window_end(data)                            ((0x001FF000&(data))>>12)
+#define HDCP_CTRL_get_dummy_11_10(data)                               ((0x00000C00&(data))>>10)
+#define HDCP_CTRL_get_enc_window_start(data)                          (0x000003FF&(data))
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/hdmirx_wrapper_reg.h b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/hdmirx_wrapper_reg.h
new file mode 100644
index 00000000..9edc545
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/hdmirx_wrapper_reg.h
@@ -0,0 +1,281 @@
+/**************************************************************
+// Spec Version                  : 1.01
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/3/13 14:49:52
+***************************************************************/
+
+
+#ifndef _HDMIRX_WRAPPER_REG_H_INCLUDED_
+#define _HDMIRX_WRAPPER_REG_H_INCLUDED_
+
+#define HDMIRX_WRAPPER_DEN_BUF01                                                     0x00
+#define HDMIRX_WRAPPER_DEN_BUF01_reg_addr                                            "0x98035F00"
+#define HDMIRX_WRAPPER_DEN_BUF01_reg                                                 0x98035F00
+#define set_HDMIRX_WRAPPER_DEN_BUF01_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_DEN_BUF01_reg)=data)
+#define get_HDMIRX_WRAPPER_DEN_BUF01_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_DEN_BUF01_reg))
+#define HDMIRX_WRAPPER_DEN_BUF01_inst_adr                                            "0x00C0"
+#define HDMIRX_WRAPPER_DEN_BUF01_inst                                                0x00C0
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1_shift                                      (16)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1_mask                                       (0x1FFF0000)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1(data)                                      (0x1FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1_src(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF01_get_den_buf1(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0_shift                                      (0)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0_mask                                       (0x00001FFF)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0(data)                                      (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0_src(data)                                  ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_DEN_BUF01_get_den_buf0(data)                                  ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_DEN_BUF23                                                     0x04
+#define HDMIRX_WRAPPER_DEN_BUF23_reg_addr                                            "0x98035F04"
+#define HDMIRX_WRAPPER_DEN_BUF23_reg                                                 0x98035F04
+#define set_HDMIRX_WRAPPER_DEN_BUF23_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_DEN_BUF23_reg)=data)
+#define get_HDMIRX_WRAPPER_DEN_BUF23_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_DEN_BUF23_reg))
+#define HDMIRX_WRAPPER_DEN_BUF23_inst_adr                                            "0x00C1"
+#define HDMIRX_WRAPPER_DEN_BUF23_inst                                                0x00C1
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3_shift                                      (16)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3_mask                                       (0x1FFF0000)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3(data)                                      (0x1FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3_src(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF23_get_den_buf3(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2_shift                                      (0)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2_mask                                       (0x00001FFF)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2(data)                                      (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2_src(data)                                  ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_DEN_BUF23_get_den_buf2(data)                                  ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_HOR_THRESHOLD                                                 0x08
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_reg_addr                                        "0x98035F08"
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_reg                                             0x98035F08
+#define set_HDMIRX_WRAPPER_HOR_THRESHOLD_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_HOR_THRESHOLD_reg)=data)
+#define get_HDMIRX_WRAPPER_HOR_THRESHOLD_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_HOR_THRESHOLD_reg))
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_inst_adr                                        "0x00C2"
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_inst                                            0x00C2
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold_shift                             (0)
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold_mask                              (0x00001FFF)
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold(data)                             (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold_src(data)                         ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_get_hor_threshold(data)                         ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS                                                 0x0C
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_reg_addr                                        "0x98035F0C"
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_reg                                             0x98035F0C
+#define set_HDMIRX_WRAPPER_ACTIVE_PIXELS_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_ACTIVE_PIXELS_reg)=data)
+#define get_HDMIRX_WRAPPER_ACTIVE_PIXELS_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_ACTIVE_PIXELS_reg))
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_inst_adr                                        "0x00C3"
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_inst                                            0x00C3
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width_shift                             (16)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width_mask                              (0x0FFF0000)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width(data)                             (0x0FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width_src(data)                         ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_get_set_ver_width(data)                         ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width_shift                             (0)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width_mask                              (0x00001FFF)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width(data)                             (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width_src(data)                         ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_get_set_hor_width(data)                         ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_MONITOR_0                                                     0x10
+#define HDMIRX_WRAPPER_MONITOR_0_reg_addr                                            "0x98035F10"
+#define HDMIRX_WRAPPER_MONITOR_0_reg                                                 0x98035F10
+#define set_HDMIRX_WRAPPER_MONITOR_0_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_MONITOR_0_reg)=data)
+#define get_HDMIRX_WRAPPER_MONITOR_0_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_MONITOR_0_reg))
+#define HDMIRX_WRAPPER_MONITOR_0_inst_adr                                            "0x00C4"
+#define HDMIRX_WRAPPER_MONITOR_0_inst                                                0x00C4
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt_shift                                (16)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt_mask                                 (0x0FFF0000)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt(data)                                (0x0FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt_src(data)                            ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_MONITOR_0_get_polarity_l_cnt(data)                            ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt_shift                                (0)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt_mask                                 (0x00000FFF)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt(data)                                (0x00000FFF&((data)<<0))
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt_src(data)                            ((0x00000FFF&(data))>>0)
+#define HDMIRX_WRAPPER_MONITOR_0_get_polarity_h_cnt(data)                            ((0x00000FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_MONITOR_1                                                     0x14
+#define HDMIRX_WRAPPER_MONITOR_1_reg_addr                                            "0x98035F14"
+#define HDMIRX_WRAPPER_MONITOR_1_reg                                                 0x98035F14
+#define set_HDMIRX_WRAPPER_MONITOR_1_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_MONITOR_1_reg)=data)
+#define get_HDMIRX_WRAPPER_MONITOR_1_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_MONITOR_1_reg))
+#define HDMIRX_WRAPPER_MONITOR_1_inst_adr                                            "0x00C5"
+#define HDMIRX_WRAPPER_MONITOR_1_inst                                                0x00C5
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity_shift                                  (12)
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity_mask                                   (0x00001000)
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity(data)                                  (0x00001000&((data)<<12))
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity_src(data)                              ((0x00001000&(data))>>12)
+#define HDMIRX_WRAPPER_MONITOR_1_get_mux_polarity(data)                              ((0x00001000&(data))>>12)
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0_shift                                     (0)
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0_mask                                      (0x00000FFF)
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0(data)                                     (0x00000FFF&((data)<<0))
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0_src(data)                                 ((0x00000FFF&(data))>>0)
+#define HDMIRX_WRAPPER_MONITOR_1_get_line_buf0(data)                                 ((0x00000FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_INTERRUPT_EN                                                  0x18
+#define HDMIRX_WRAPPER_INTERRUPT_EN_reg_addr                                         "0x98035F18"
+#define HDMIRX_WRAPPER_INTERRUPT_EN_reg                                              0x98035F18
+#define set_HDMIRX_WRAPPER_INTERRUPT_EN_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_INTERRUPT_EN_reg)=data)
+#define get_HDMIRX_WRAPPER_INTERRUPT_EN_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_INTERRUPT_EN_reg))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_inst_adr                                         "0x00C6"
+#define HDMIRX_WRAPPER_INTERRUPT_EN_inst                                             0x00C6
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_shift                                 (2)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_mask                                  (0x00000004)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en(data)                                 (0x00000004&((data)<<2))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_src(data)                             ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_get_ver_err_en(data)                             ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_shift                                 (1)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_mask                                  (0x00000002)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en(data)                                 (0x00000002&((data)<<1))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_src(data)                             ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_get_hor_err_en(data)                             ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_shift                         (0)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_mask                          (0x00000001)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en(data)                         (0x00000001&((data)<<0))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_src(data)                     ((0x00000001&(data))>>0)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_get_polarity_detect_en(data)                     ((0x00000001&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS                                              0x1C
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_reg_addr                                     "0x98035F1C"
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_reg                                          0x98035F1C
+#define set_HDMIRX_WRAPPER_INTERRUPT_STATUS_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_INTERRUPT_STATUS_reg)=data)
+#define get_HDMIRX_WRAPPER_INTERRUPT_STATUS_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_INTERRUPT_STATUS_reg))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_inst_adr                                     "0x00C7"
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_inst                                         0x00C7
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts_shift                            (2)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts_mask                             (0x00000004)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts(data)                            (0x00000004&((data)<<2))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts_src(data)                        ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_get_ver_err_sts(data)                        ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts_shift                            (1)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts_mask                             (0x00000002)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts(data)                            (0x00000002&((data)<<1))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts_src(data)                        ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_get_hor_err_sts(data)                        ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts_shift                    (0)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts_mask                     (0x00000001)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts(data)                    (0x00000001&((data)<<0))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts_src(data)                ((0x00000001&(data))>>0)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_get_polarity_detect_sts(data)                ((0x00000001&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_CONTROL_0                                                     0x20
+#define HDMIRX_WRAPPER_CONTROL_0_reg_addr                                            "0x98035F20"
+#define HDMIRX_WRAPPER_CONTROL_0_reg                                                 0x98035F20
+#define set_HDMIRX_WRAPPER_CONTROL_0_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_CONTROL_0_reg)=data)
+#define get_HDMIRX_WRAPPER_CONTROL_0_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_CONTROL_0_reg))
+#define HDMIRX_WRAPPER_CONTROL_0_inst_adr                                            "0x00C8"
+#define HDMIRX_WRAPPER_CONTROL_0_inst                                                0x00C8
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_cbusrx_shift                              (13)
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_cbusrx_mask                               (0x00002000)
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_cbusrx(data)                              (0x00002000&((data)<<13))
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_cbusrx_src(data)                          ((0x00002000&(data))>>13)
+#define HDMIRX_WRAPPER_CONTROL_0_get_reg_clken_cbusrx(data)                          ((0x00002000&(data))>>13)
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx_shift                              (12)
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx_mask                               (0x00001000)
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx(data)                              (0x00001000&((data)<<12))
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx_src(data)                          ((0x00001000&(data))>>12)
+#define HDMIRX_WRAPPER_CONTROL_0_get_reg_clken_hdmirx(data)                          ((0x00001000&(data))>>12)
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage_shift                                    (11)
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage_mask                                     (0x00000800)
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage(data)                                    (0x00000800&((data)<<11))
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage_src(data)                                ((0x00000800&(data))>>11)
+#define HDMIRX_WRAPPER_CONTROL_0_get_fifo_stage(data)                                ((0x00000800&(data))>>11)
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_shift                                     (10)
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_mask                                      (0x00000400)
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en(data)                                     (0x00000400&((data)<<10))
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_src(data)                                 ((0x00000400&(data))>>10)
+#define HDMIRX_WRAPPER_CONTROL_0_get_fw_dma_en(data)                                 ((0x00000400&(data))>>10)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_shift                               (9)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_mask                                (0x00000200)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en(data)                               (0x00000200&((data)<<9))
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_src(data)                           ((0x00000200&(data))>>9)
+#define HDMIRX_WRAPPER_CONTROL_0_get_polarity_set_en(data)                           ((0x00000200&(data))>>9)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_shift                                  (8)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_mask                                   (0x00000100)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set(data)                                  (0x00000100&((data)<<8))
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_src(data)                              ((0x00000100&(data))>>8)
+#define HDMIRX_WRAPPER_CONTROL_0_get_polarity_set(data)                              ((0x00000100&(data))>>8)
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_shift                                       (2)
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_mask                                        (0x0000000C)
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt(data)                                       (0x0000000C&((data)<<2))
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_src(data)                                   ((0x0000000C&(data))>>2)
+#define HDMIRX_WRAPPER_CONTROL_0_get_yuv_fmt(data)                                   ((0x0000000C&(data))>>2)
+#define HDMIRX_WRAPPER_CONTROL_0_cbusrx_en_shift                                     (1)
+#define HDMIRX_WRAPPER_CONTROL_0_cbusrx_en_mask                                      (0x00000002)
+#define HDMIRX_WRAPPER_CONTROL_0_cbusrx_en(data)                                     (0x00000002&((data)<<1))
+#define HDMIRX_WRAPPER_CONTROL_0_cbusrx_en_src(data)                                 ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_CONTROL_0_get_cbusrx_en(data)                                 ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_shift                                     (0)
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_mask                                      (0x00000001)
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en(data)                                     (0x00000001&((data)<<0))
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_src(data)                                 ((0x00000001&(data))>>0)
+#define HDMIRX_WRAPPER_CONTROL_0_get_hdmirx_en(data)                                 ((0x00000001&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_CONTROL_1                                                     0x24
+#define HDMIRX_WRAPPER_CONTROL_1_reg_addr                                            "0x98035F24"
+#define HDMIRX_WRAPPER_CONTROL_1_reg                                                 0x98035F24
+#define set_HDMIRX_WRAPPER_CONTROL_1_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_CONTROL_1_reg)=data)
+#define get_HDMIRX_WRAPPER_CONTROL_1_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_CONTROL_1_reg))
+#define HDMIRX_WRAPPER_CONTROL_1_inst_adr                                            "0x00C9"
+#define HDMIRX_WRAPPER_CONTROL_1_inst                                                0x00C9
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl_shift                                    (16)
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl_mask                                     (0xFFFF0000)
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl(data)                                    (0xFFFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl_src(data)                                ((0xFFFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_CONTROL_1_get_dummy_ctrl(data)                                ((0xFFFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_vclk_div_sel_shift                           (12)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_vclk_div_sel_mask                            (0x00007000)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_vclk_div_sel(data)                           (0x00007000&((data)<<12))
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_vclk_div_sel_src(data)                       ((0x00007000&(data))>>12)
+#define HDMIRX_WRAPPER_CONTROL_1_get_hdmirx_vclk_div_sel(data)                       ((0x00007000&(data))>>12)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_fdds_div_sel_shift                           (8)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_fdds_div_sel_mask                            (0x00000700)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_fdds_div_sel(data)                           (0x00000700&((data)<<8))
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_fdds_div_sel_src(data)                       ((0x00000700&(data))>>8)
+#define HDMIRX_WRAPPER_CONTROL_1_get_hdmirx_fdds_div_sel(data)                       ((0x00000700&(data))>>8)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_aclk_div_sel_shift                           (4)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_aclk_div_sel_mask                            (0x00000070)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_aclk_div_sel(data)                           (0x00000070&((data)<<4))
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_aclk_div_sel_src(data)                       ((0x00000070&(data))>>4)
+#define HDMIRX_WRAPPER_CONTROL_1_get_hdmirx_aclk_div_sel(data)                       ((0x00000070&(data))>>4)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel_shift                                     (2)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel_mask                                      (0x00000004)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel(data)                                     (0x00000004&((data)<<2))
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel_src(data)                                 ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_CONTROL_1_get_debug_sel(data)                                 ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux_shift                                     (0)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux_mask                                      (0x00000003)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux(data)                                     (0x00000003&((data)<<0))
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux_src(data)                                 ((0x00000003&(data))>>0)
+#define HDMIRX_WRAPPER_CONTROL_1_get_debug_mux(data)                                 ((0x00000003&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_DUMMY                                                         0x28
+#define HDMIRX_WRAPPER_DUMMY_reg_addr                                                "0x98035F28"
+#define HDMIRX_WRAPPER_DUMMY_reg                                                     0x98035F28
+#define set_HDMIRX_WRAPPER_DUMMY_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_DUMMY_reg)=data)
+#define get_HDMIRX_WRAPPER_DUMMY_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_DUMMY_reg))
+#define HDMIRX_WRAPPER_DUMMY_inst_adr                                                "0x00CA"
+#define HDMIRX_WRAPPER_DUMMY_inst                                                    0x00CA
+#define HDMIRX_WRAPPER_DUMMY_hdmirx_dummy_reg_shift                                  (0)
+#define HDMIRX_WRAPPER_DUMMY_hdmirx_dummy_reg_mask                                   (0xFFFFFFFF)
+#define HDMIRX_WRAPPER_DUMMY_hdmirx_dummy_reg(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMIRX_WRAPPER_DUMMY_hdmirx_dummy_reg_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMIRX_WRAPPER_DUMMY_get_hdmirx_dummy_reg(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/iso_cbus_tx_reg.h b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/iso_cbus_tx_reg.h
new file mode 100644
index 00000000..dfafa46
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/iso_cbus_tx_reg.h
@@ -0,0 +1,707 @@
+/**************************************************************
+// Spec Version                  : 1.0
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/10/1 11:20:51
+***************************************************************/
+
+
+#ifndef _ISO_CBUS_TX_REG_H_INCLUDED_
+#define _ISO_CBUS_TX_REG_H_INCLUDED_
+
+#define ISO_CBUS_TX_PHY_CTRL1                                                        0x00
+#define ISO_CBUS_TX_PHY_CTRL1_reg_addr                                               "0x98037000"
+#define ISO_CBUS_TX_PHY_CTRL1_reg                                                    0x98037000
+#define set_ISO_CBUS_TX_PHY_CTRL1_reg(data)   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL1_reg)=data)
+#define get_ISO_CBUS_TX_PHY_CTRL1_reg   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL1_reg))
+#define ISO_CBUS_TX_PHY_CTRL1_inst_adr                                               "0x0000"
+#define ISO_CBUS_TX_PHY_CTRL1_inst                                                   0x0000
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_TST_EN_TXRX_shift                              (31)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_TST_EN_TXRX_mask                               (0x80000000)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_TST_EN_TXRX(data)                              (0x80000000&((data)<<31))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_TST_EN_TXRX_src(data)                          ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_MHL_TST_EN_TXRX(data)                          ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_TST_SEL_TXRX_shift                                 (28)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_TST_SEL_TXRX_mask                                  (0x70000000)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_TST_SEL_TXRX(data)                                 (0x70000000&((data)<<28))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_TST_SEL_TXRX_src(data)                             ((0x70000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_TST_SEL_TXRX(data)                             ((0x70000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_CBUS_CONTROL_shift                                 (20)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_CBUS_CONTROL_mask                                  (0x0FF00000)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_CBUS_CONTROL(data)                                 (0x0FF00000&((data)<<20))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_CBUS_CONTROL_src(data)                             ((0x0FF00000&(data))>>20)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_CBUS_CONTROL(data)                             ((0x0FF00000&(data))>>20)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_CBUSB_GPIO_TX_shift                            (19)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_CBUSB_GPIO_TX_mask                             (0x00080000)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_CBUSB_GPIO_TX(data)                            (0x00080000&((data)<<19))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_CBUSB_GPIO_TX_src(data)                        ((0x00080000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_SEL_CBUSB_GPIO_TX(data)                        ((0x00080000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_EN_CBUS_TX_shift                                   (18)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_EN_CBUS_TX_mask                                    (0x00040000)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_EN_CBUS_TX(data)                                   (0x00040000&((data)<<18))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_EN_CBUS_TX_src(data)                               ((0x00040000&(data))>>18)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_EN_CBUS_TX(data)                               ((0x00040000&(data))>>18)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_HPD_DET_TX_shift                               (17)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_HPD_DET_TX_mask                                (0x00020000)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_HPD_DET_TX(data)                               (0x00020000&((data)<<17))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_HPD_DET_TX_src(data)                           ((0x00020000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_MHL_HPD_DET_TX(data)                           ((0x00020000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_EN_CMP_TX_shift                                    (16)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_EN_CMP_TX_mask                                     (0x00010000)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_EN_CMP_TX(data)                                    (0x00010000&((data)<<16))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_EN_CMP_TX_src(data)                                ((0x00010000&(data))>>16)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_EN_CMP_TX(data)                                ((0x00010000&(data))>>16)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_HDMI_HPD_VSEL_TX_shift                             (14)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_HDMI_HPD_VSEL_TX_mask                              (0x0000C000)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_HDMI_HPD_VSEL_TX(data)                             (0x0000C000&((data)<<14))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_HDMI_HPD_VSEL_TX_src(data)                         ((0x0000C000&(data))>>14)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_HDMI_HPD_VSEL_TX(data)                         ((0x0000C000&(data))>>14)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_HPD_VSEL_TX_shift                              (12)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_HPD_VSEL_TX_mask                               (0x00003000)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_HPD_VSEL_TX(data)                              (0x00003000&((data)<<12))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_MHL_HPD_VSEL_TX_src(data)                          ((0x00003000&(data))>>12)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_MHL_HPD_VSEL_TX(data)                          ((0x00003000&(data))>>12)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_R1K_HIGH_VSEL_TX_shift                             (10)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_R1K_HIGH_VSEL_TX_mask                              (0x00000C00)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_R1K_HIGH_VSEL_TX(data)                             (0x00000C00&((data)<<10))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_R1K_HIGH_VSEL_TX_src(data)                         ((0x00000C00&(data))>>10)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_R1K_HIGH_VSEL_TX(data)                         ((0x00000C00&(data))>>10)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_R1K_LOW_VSEL_TX_shift                              (8)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_R1K_LOW_VSEL_TX_mask                               (0x00000300)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_R1K_LOW_VSEL_TX(data)                              (0x00000300&((data)<<8))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_R1K_LOW_VSEL_TX_src(data)                          ((0x00000300&(data))>>8)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_R1K_LOW_VSEL_TX(data)                          ((0x00000300&(data))>>8)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_INPUT_HIGH_TX_shift                            (6)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_INPUT_HIGH_TX_mask                             (0x000000C0)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_INPUT_HIGH_TX(data)                            (0x000000C0&((data)<<6))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_INPUT_HIGH_TX_src(data)                        ((0x000000C0&(data))>>6)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_SEL_INPUT_HIGH_TX(data)                        ((0x000000C0&(data))>>6)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_INPUT_LOW_TX_shift                             (4)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_INPUT_LOW_TX_mask                              (0x00000030)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_INPUT_LOW_TX(data)                             (0x00000030&((data)<<4))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_SEL_INPUT_LOW_TX_src(data)                         ((0x00000030&(data))>>4)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_SEL_INPUT_LOW_TX(data)                         ((0x00000030&(data))>>4)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_HDMI_MHL_SEL_shift                                 (3)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_HDMI_MHL_SEL_mask                                  (0x00000008)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_HDMI_MHL_SEL(data)                                 (0x00000008&((data)<<3))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_HDMI_MHL_SEL_src(data)                             ((0x00000008&(data))>>3)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_HDMI_MHL_SEL(data)                             ((0x00000008&(data))>>3)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_PLL_OEB_ECBUSTX_shift                              (2)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_PLL_OEB_ECBUSTX_mask                               (0x00000004)
+#define ISO_CBUS_TX_PHY_CTRL1_REG_PLL_OEB_ECBUSTX(data)                              (0x00000004&((data)<<2))
+#define ISO_CBUS_TX_PHY_CTRL1_REG_PLL_OEB_ECBUSTX_src(data)                          ((0x00000004&(data))>>2)
+#define ISO_CBUS_TX_PHY_CTRL1_get_REG_PLL_OEB_ECBUSTX(data)                          ((0x00000004&(data))>>2)
+
+
+#define ISO_CBUS_TX_PHY_CTRL2                                                        0x04
+#define ISO_CBUS_TX_PHY_CTRL2_reg_addr                                               "0x98037004"
+#define ISO_CBUS_TX_PHY_CTRL2_reg                                                    0x98037004
+#define set_ISO_CBUS_TX_PHY_CTRL2_reg(data)   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL2_reg)=data)
+#define get_ISO_CBUS_TX_PHY_CTRL2_reg   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL2_reg))
+#define ISO_CBUS_TX_PHY_CTRL2_inst_adr                                               "0x0001"
+#define ISO_CBUS_TX_PHY_CTRL2_inst                                                   0x0001
+#define ISO_CBUS_TX_PHY_CTRL2_REG_EN_BUF_ECBUSTX_shift                               (31)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_EN_BUF_ECBUSTX_mask                                (0x80000000)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_EN_BUF_ECBUSTX(data)                               (0x80000000&((data)<<31))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_EN_BUF_ECBUSTX_src(data)                           ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_EN_BUF_ECBUSTX(data)                           ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_FORWD_TST_EN_ECBUSTX_shift                         (30)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_FORWD_TST_EN_ECBUSTX_mask                          (0x40000000)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_FORWD_TST_EN_ECBUSTX(data)                         (0x40000000&((data)<<30))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_FORWD_TST_EN_ECBUSTX_src(data)                     ((0x40000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_FORWD_TST_EN_ECBUSTX(data)                     ((0x40000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_IBSEL_ECBUSTX_shift                            (27)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_IBSEL_ECBUSTX_mask                             (0x38000000)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_IBSEL_ECBUSTX(data)                            (0x38000000&((data)<<27))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_IBSEL_ECBUSTX_src(data)                        ((0x38000000&(data))>>27)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_BUF_IBSEL_ECBUSTX(data)                        ((0x38000000&(data))>>27)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_R50_ECBUSTX_shift                              (23)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_R50_ECBUSTX_mask                               (0x07800000)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_R50_ECBUSTX(data)                              (0x07800000&((data)<<23))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_R50_ECBUSTX_src(data)                          ((0x07800000&(data))>>23)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_BUF_R50_ECBUSTX(data)                          ((0x07800000&(data))>>23)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BKWD_TST_EN_ECBUSTX_shift                          (22)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BKWD_TST_EN_ECBUSTX_mask                           (0x00400000)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BKWD_TST_EN_ECBUSTX(data)                          (0x00400000&((data)<<22))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BKWD_TST_EN_ECBUSTX_src(data)                      ((0x00400000&(data))>>22)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_BKWD_TST_EN_ECBUSTX(data)                      ((0x00400000&(data))>>22)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_HPD_R1K_BYPASS_shift                               (21)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_HPD_R1K_BYPASS_mask                                (0x00200000)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_HPD_R1K_BYPASS(data)                               (0x00200000&((data)<<21))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_HPD_R1K_BYPASS_src(data)                           ((0x00200000&(data))>>21)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_HPD_R1K_BYPASS(data)                           ((0x00200000&(data))>>21)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_CSEL_ECBUSTX_shift                             (19)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_CSEL_ECBUSTX_mask                              (0x00180000)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_CSEL_ECBUSTX(data)                             (0x00180000&((data)<<19))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_CSEL_ECBUSTX_src(data)                         ((0x00180000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_BUF_CSEL_ECBUSTX(data)                         ((0x00180000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_RSEL_ECBUSTX_shift                             (17)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_RSEL_ECBUSTX_mask                              (0x00060000)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_RSEL_ECBUSTX(data)                             (0x00060000&((data)<<17))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_RSEL_ECBUSTX_src(data)                         ((0x00060000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_BUF_RSEL_ECBUSTX(data)                         ((0x00060000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_DELAY_RESERVED_ECBUSTX_shift                       (15)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_DELAY_RESERVED_ECBUSTX_mask                        (0x00018000)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_DELAY_RESERVED_ECBUSTX(data)                       (0x00018000&((data)<<15))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_DELAY_RESERVED_ECBUSTX_src(data)                   ((0x00018000&(data))>>15)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_DELAY_RESERVED_ECBUSTX(data)                   ((0x00018000&(data))>>15)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_HPD_R1K_SEL_shift                                  (11)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_HPD_R1K_SEL_mask                                   (0x00003800)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_HPD_R1K_SEL(data)                                  (0x00003800&((data)<<11))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_HPD_R1K_SEL_src(data)                              ((0x00003800&(data))>>11)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_HPD_R1K_SEL(data)                              ((0x00003800&(data))>>11)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_DELAY_SEL_ECBUSTX_shift                        (7)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_DELAY_SEL_ECBUSTX_mask                         (0x00000780)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_DELAY_SEL_ECBUSTX(data)                        (0x00000780&((data)<<7))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_DELAY_SEL_ECBUSTX_src(data)                    ((0x00000780&(data))>>7)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_BUF_DELAY_SEL_ECBUSTX(data)                    ((0x00000780&(data))>>7)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_VREF_SEL_ECBUSTX_shift                         (4)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_VREF_SEL_ECBUSTX_mask                          (0x00000070)
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_VREF_SEL_ECBUSTX(data)                         (0x00000070&((data)<<4))
+#define ISO_CBUS_TX_PHY_CTRL2_REG_BUF_VREF_SEL_ECBUSTX_src(data)                     ((0x00000070&(data))>>4)
+#define ISO_CBUS_TX_PHY_CTRL2_get_REG_BUF_VREF_SEL_ECBUSTX(data)                     ((0x00000070&(data))>>4)
+
+
+#define ISO_CBUS_TX_PHY_CTRL3                                                        0x08
+#define ISO_CBUS_TX_PHY_CTRL3_reg_addr                                               "0x98037008"
+#define ISO_CBUS_TX_PHY_CTRL3_reg                                                    0x98037008
+#define set_ISO_CBUS_TX_PHY_CTRL3_reg(data)   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL3_reg)=data)
+#define get_ISO_CBUS_TX_PHY_CTRL3_reg   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL3_reg))
+#define ISO_CBUS_TX_PHY_CTRL3_inst_adr                                               "0x0002"
+#define ISO_CBUS_TX_PHY_CTRL3_inst                                                   0x0002
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_CP_ECBUSTX_shift                               (30)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_CP_ECBUSTX_mask                                (0xC0000000)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_CP_ECBUSTX(data)                               (0xC0000000&((data)<<30))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_CP_ECBUSTX_src(data)                           ((0xC0000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_CP_ECBUSTX(data)                           ((0xC0000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_CS_ECBUSTX_shift                               (28)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_CS_ECBUSTX_mask                                (0x30000000)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_CS_ECBUSTX(data)                               (0x30000000&((data)<<28))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_CS_ECBUSTX_src(data)                           ((0x30000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_CS_ECBUSTX(data)                           ((0x30000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO1V_SEL_ECBUSTX_shift                        (24)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO1V_SEL_ECBUSTX_mask                         (0x03000000)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO1V_SEL_ECBUSTX(data)                        (0x03000000&((data)<<24))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO1V_SEL_ECBUSTX_src(data)                    ((0x03000000&(data))>>24)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_LDO1V_SEL_ECBUSTX(data)                    ((0x03000000&(data))>>24)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO_SEL_ECBUSTX_shift                          (22)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO_SEL_ECBUSTX_mask                           (0x00C00000)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO_SEL_ECBUSTX(data)                          (0x00C00000&((data)<<22))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO_SEL_ECBUSTX_src(data)                      ((0x00C00000&(data))>>22)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_LDO_SEL_ECBUSTX(data)                      ((0x00C00000&(data))>>22)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_FREEZE_ECBUSTX_shift                           (21)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_FREEZE_ECBUSTX_mask                            (0x00200000)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_FREEZE_ECBUSTX(data)                           (0x00200000&((data)<<21))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_FREEZE_ECBUSTX_src(data)                       ((0x00200000&(data))>>21)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_FREEZE_ECBUSTX(data)                       ((0x00200000&(data))>>21)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_POW_ECBUSTX_shift                              (20)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_POW_ECBUSTX_mask                               (0x00100000)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_POW_ECBUSTX(data)                              (0x00100000&((data)<<20))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_POW_ECBUSTX_src(data)                          ((0x00100000&(data))>>20)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_POW_ECBUSTX(data)                          ((0x00100000&(data))>>20)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO_POW_ECBUSTX_shift                          (19)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO_POW_ECBUSTX_mask                           (0x00080000)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO_POW_ECBUSTX(data)                          (0x00080000&((data)<<19))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO_POW_ECBUSTX_src(data)                      ((0x00080000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_LDO_POW_ECBUSTX(data)                      ((0x00080000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_VCORSTB_ECBUSTX_shift                          (18)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_VCORSTB_ECBUSTX_mask                           (0x00040000)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_VCORSTB_ECBUSTX(data)                          (0x00040000&((data)<<18))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_VCORSTB_ECBUSTX_src(data)                      ((0x00040000&(data))>>18)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_VCORSTB_ECBUSTX(data)                      ((0x00040000&(data))>>18)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_WDRST_ECBUSTX_shift                            (17)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_WDRST_ECBUSTX_mask                             (0x00020000)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_WDRST_ECBUSTX(data)                            (0x00020000&((data)<<17))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_WDRST_ECBUSTX_src(data)                        ((0x00020000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_WDRST_ECBUSTX(data)                        ((0x00020000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_WDSET_ECBUSTX_shift                            (16)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_WDSET_ECBUSTX_mask                             (0x00010000)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_WDSET_ECBUSTX(data)                            (0x00010000&((data)<<16))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_WDSET_ECBUSTX_src(data)                        ((0x00010000&(data))>>16)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_WDSET_ECBUSTX(data)                        ((0x00010000&(data))>>16)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_M_ECBUSTX_shift                                (8)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_M_ECBUSTX_mask                                 (0x0000FF00)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_M_ECBUSTX(data)                                (0x0000FF00&((data)<<8))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_M_ECBUSTX_src(data)                            ((0x0000FF00&(data))>>8)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_M_ECBUSTX(data)                            ((0x0000FF00&(data))>>8)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_PHSEL_ECBUSTX_shift                            (4)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_PHSEL_ECBUSTX_mask                             (0x000000F0)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_PHSEL_ECBUSTX(data)                            (0x000000F0&((data)<<4))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_PHSEL_ECBUSTX_src(data)                        ((0x000000F0&(data))>>4)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_PHSEL_ECBUSTX(data)                        ((0x000000F0&(data))>>4)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_N_ECBUSTX_shift                                (1)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_N_ECBUSTX_mask                                 (0x0000000E)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_N_ECBUSTX(data)                                (0x0000000E&((data)<<1))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_N_ECBUSTX_src(data)                            ((0x0000000E&(data))>>1)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_N_ECBUSTX(data)                            ((0x0000000E&(data))>>1)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO1V_POW_ECBUSTX_shift                        (0)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO1V_POW_ECBUSTX_mask                         (0x00000001)
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO1V_POW_ECBUSTX(data)                        (0x00000001&((data)<<0))
+#define ISO_CBUS_TX_PHY_CTRL3_REG_PLL_LDO1V_POW_ECBUSTX_src(data)                    ((0x00000001&(data))>>0)
+#define ISO_CBUS_TX_PHY_CTRL3_get_REG_PLL_LDO1V_POW_ECBUSTX(data)                    ((0x00000001&(data))>>0)
+
+
+#define ISO_CBUS_TX_PHY_CTRL4                                                        0x10
+#define ISO_CBUS_TX_PHY_CTRL4_reg_addr                                               "0x98037010"
+#define ISO_CBUS_TX_PHY_CTRL4_reg                                                    0x98037010
+#define set_ISO_CBUS_TX_PHY_CTRL4_reg(data)   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL4_reg)=data)
+#define get_ISO_CBUS_TX_PHY_CTRL4_reg   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL4_reg))
+#define ISO_CBUS_TX_PHY_CTRL4_inst_adr                                               "0x0004"
+#define ISO_CBUS_TX_PHY_CTRL4_inst                                                   0x0004
+#define ISO_CBUS_TX_PHY_CTRL4_REG_AUTO_K_R50_ECBUSTX_shift                           (31)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_AUTO_K_R50_ECBUSTX_mask                            (0x80000000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_AUTO_K_R50_ECBUSTX(data)                           (0x80000000&((data)<<31))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_AUTO_K_R50_ECBUSTX_src(data)                       ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_AUTO_K_R50_ECBUSTX(data)                       ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATAGEN_POW_ECBUSTX_shift                          (30)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATAGEN_POW_ECBUSTX_mask                           (0x40000000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATAGEN_POW_ECBUSTX(data)                          (0x40000000&((data)<<30))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATAGEN_POW_ECBUSTX_src(data)                      ((0x40000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_DATAGEN_POW_ECBUSTX(data)                      ((0x40000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATA_EN_ECBUSTX_shift                              (29)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATA_EN_ECBUSTX_mask                               (0x20000000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATA_EN_ECBUSTX(data)                              (0x20000000&((data)<<29))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATA_EN_ECBUSTX_src(data)                          ((0x20000000&(data))>>29)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_DATA_EN_ECBUSTX(data)                          ((0x20000000&(data))>>29)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATA_IN_SEL_ECBUSTX_shift                          (28)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATA_IN_SEL_ECBUSTX_mask                           (0x10000000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATA_IN_SEL_ECBUSTX(data)                          (0x10000000&((data)<<28))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DATA_IN_SEL_ECBUSTX_src(data)                      ((0x10000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_DATA_IN_SEL_ECBUSTX(data)                      ((0x10000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DELAY_RSEL_ECBUSTX_shift                           (27)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DELAY_RSEL_ECBUSTX_mask                            (0x08000000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DELAY_RSEL_ECBUSTX(data)                           (0x08000000&((data)<<27))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_DELAY_RSEL_ECBUSTX_src(data)                       ((0x08000000&(data))>>27)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_DELAY_RSEL_ECBUSTX(data)                       ((0x08000000&(data))>>27)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_RCAL_EN_ECBUSTX_shift                              (26)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_RCAL_EN_ECBUSTX_mask                               (0x04000000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_RCAL_EN_ECBUSTX(data)                              (0x04000000&((data)<<26))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_RCAL_EN_ECBUSTX_src(data)                          ((0x04000000&(data))>>26)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_RCAL_EN_ECBUSTX(data)                          ((0x04000000&(data))>>26)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BUF_RCAL_ECBUSTX_shift                             (22)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BUF_RCAL_ECBUSTX_mask                              (0x03C00000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BUF_RCAL_ECBUSTX(data)                             (0x03C00000&((data)<<22))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BUF_RCAL_ECBUSTX_src(data)                         ((0x03C00000&(data))>>22)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_BUF_RCAL_ECBUSTX(data)                         ((0x03C00000&(data))>>22)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CKIN_BPS_ECBUSTX_shift                             (21)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CKIN_BPS_ECBUSTX_mask                              (0x00200000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CKIN_BPS_ECBUSTX(data)                             (0x00200000&((data)<<21))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CKIN_BPS_ECBUSTX_src(data)                         ((0x00200000&(data))>>21)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_CKIN_BPS_ECBUSTX(data)                         ((0x00200000&(data))>>21)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CMP_VSEL_ECBUSTX_shift                             (19)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CMP_VSEL_ECBUSTX_mask                              (0x00180000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CMP_VSEL_ECBUSTX(data)                             (0x00180000&((data)<<19))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CMP_VSEL_ECBUSTX_src(data)                         ((0x00180000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_CMP_VSEL_ECBUSTX(data)                         ((0x00180000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CKOUT_EDGE_SEL_ECBUSTX_shift                       (18)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CKOUT_EDGE_SEL_ECBUSTX_mask                        (0x00040000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CKOUT_EDGE_SEL_ECBUSTX(data)                       (0x00040000&((data)<<18))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_CKOUT_EDGE_SEL_ECBUSTX_src(data)                   ((0x00040000&(data))>>18)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_CKOUT_EDGE_SEL_ECBUSTX(data)                   ((0x00040000&(data))>>18)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BKWD_BYP_ECBUSTX_shift                             (17)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BKWD_BYP_ECBUSTX_mask                              (0x00020000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BKWD_BYP_ECBUSTX(data)                             (0x00020000&((data)<<17))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BKWD_BYP_ECBUSTX_src(data)                         ((0x00020000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_BKWD_BYP_ECBUSTX(data)                         ((0x00020000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_TEST_SEL_ECBUSTX_shift                             (15)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_TEST_SEL_ECBUSTX_mask                              (0x00018000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_TEST_SEL_ECBUSTX(data)                             (0x00018000&((data)<<15))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_TEST_SEL_ECBUSTX_src(data)                         ((0x00018000&(data))>>15)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_TEST_SEL_ECBUSTX(data)                         ((0x00018000&(data))>>15)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BUF_VREF_RSEL_ECBUSTX_shift                        (13)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BUF_VREF_RSEL_ECBUSTX_mask                         (0x00006000)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BUF_VREF_RSEL_ECBUSTX(data)                        (0x00006000&((data)<<13))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_BUF_VREF_RSEL_ECBUSTX_src(data)                    ((0x00006000&(data))>>13)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_BUF_VREF_RSEL_ECBUSTX(data)                    ((0x00006000&(data))>>13)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_PLL_RS_ECBUSTX_shift                               (10)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_PLL_RS_ECBUSTX_mask                                (0x00001C00)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_PLL_RS_ECBUSTX(data)                               (0x00001C00&((data)<<10))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_PLL_RS_ECBUSTX_src(data)                           ((0x00001C00&(data))>>10)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_PLL_RS_ECBUSTX(data)                           ((0x00001C00&(data))>>10)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_PLL_IP_ECBUSTX_shift                               (7)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_PLL_IP_ECBUSTX_mask                                (0x00000380)
+#define ISO_CBUS_TX_PHY_CTRL4_REG_PLL_IP_ECBUSTX(data)                               (0x00000380&((data)<<7))
+#define ISO_CBUS_TX_PHY_CTRL4_REG_PLL_IP_ECBUSTX_src(data)                           ((0x00000380&(data))>>7)
+#define ISO_CBUS_TX_PHY_CTRL4_get_REG_PLL_IP_ECBUSTX(data)                           ((0x00000380&(data))>>7)
+
+
+#define ISO_CBUS_TX_PHY_CTRL5                                                        0x14
+#define ISO_CBUS_TX_PHY_CTRL5_reg_addr                                               "0x98037014"
+#define ISO_CBUS_TX_PHY_CTRL5_reg                                                    0x98037014
+#define set_ISO_CBUS_TX_PHY_CTRL5_reg(data)   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL5_reg)=data)
+#define get_ISO_CBUS_TX_PHY_CTRL5_reg   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL5_reg))
+#define ISO_CBUS_TX_PHY_CTRL5_inst_adr                                               "0x0005"
+#define ISO_CBUS_TX_PHY_CTRL5_inst                                                   0x0005
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_I_TX_shift                                        (31)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_I_TX_mask                                         (0x80000000)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_I_TX(data)                                        (0x80000000&((data)<<31))
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_I_TX_src(data)                                    ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_CTRL5_get_CBUS_I_TX(data)                                    ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_E_TX_shift                                        (30)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_E_TX_mask                                         (0x40000000)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_E_TX(data)                                        (0x40000000&((data)<<30))
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_E_TX_src(data)                                    ((0x40000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_CTRL5_get_CBUS_E_TX(data)                                    ((0x40000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_E2_TX_shift                                       (29)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_E2_TX_mask                                        (0x20000000)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_E2_TX(data)                                       (0x20000000&((data)<<29))
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_E2_TX_src(data)                                   ((0x20000000&(data))>>29)
+#define ISO_CBUS_TX_PHY_CTRL5_get_CBUS_E2_TX(data)                                   ((0x20000000&(data))>>29)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_PD_TX_shift                                       (28)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_PD_TX_mask                                        (0x10000000)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_PD_TX(data)                                       (0x10000000&((data)<<28))
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_PD_TX_src(data)                                   ((0x10000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_CTRL5_get_CBUS_PD_TX(data)                                   ((0x10000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_PU_TX_shift                                       (27)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_PU_TX_mask                                        (0x08000000)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_PU_TX(data)                                       (0x08000000&((data)<<27))
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_PU_TX_src(data)                                   ((0x08000000&(data))>>27)
+#define ISO_CBUS_TX_PHY_CTRL5_get_CBUS_PU_TX(data)                                   ((0x08000000&(data))>>27)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_SMT_TX_shift                                      (26)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_SMT_TX_mask                                       (0x04000000)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_SMT_TX(data)                                      (0x04000000&((data)<<26))
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_SMT_TX_src(data)                                  ((0x04000000&(data))>>26)
+#define ISO_CBUS_TX_PHY_CTRL5_get_CBUS_SMT_TX(data)                                  ((0x04000000&(data))>>26)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_SR_TX_shift                                       (25)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_SR_TX_mask                                        (0x02000000)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_SR_TX(data)                                       (0x02000000&((data)<<25))
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_SR_TX_src(data)                                   ((0x02000000&(data))>>25)
+#define ISO_CBUS_TX_PHY_CTRL5_get_CBUS_SR_TX(data)                                   ((0x02000000&(data))>>25)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_O_TX_shift                                        (24)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_O_TX_mask                                         (0x01000000)
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_O_TX(data)                                        (0x01000000&((data)<<24))
+#define ISO_CBUS_TX_PHY_CTRL5_CBUS_O_TX_src(data)                                    ((0x01000000&(data))>>24)
+#define ISO_CBUS_TX_PHY_CTRL5_get_CBUS_O_TX(data)                                    ((0x01000000&(data))>>24)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_PLL_WDO_ECBUSTX_shift                             (23)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_PLL_WDO_ECBUSTX_mask                              (0x00800000)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_PLL_WDO_ECBUSTX(data)                             (0x00800000&((data)<<23))
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_PLL_WDO_ECBUSTX_src(data)                         ((0x00800000&(data))>>23)
+#define ISO_CBUS_TX_PHY_CTRL5_get_REGO_PLL_WDO_ECBUSTX(data)                         ((0x00800000&(data))>>23)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_MHL_HPD_DET_TX_shift                              (22)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_MHL_HPD_DET_TX_mask                               (0x00400000)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_MHL_HPD_DET_TX(data)                              (0x00400000&((data)<<22))
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_MHL_HPD_DET_TX_src(data)                          ((0x00400000&(data))>>22)
+#define ISO_CBUS_TX_PHY_CTRL5_get_REGO_MHL_HPD_DET_TX(data)                          ((0x00400000&(data))>>22)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_5V_DETECT_shift                                   (21)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_5V_DETECT_mask                                    (0x00200000)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_5V_DETECT(data)                                   (0x00200000&((data)<<21))
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_5V_DETECT_src(data)                               ((0x00200000&(data))>>21)
+#define ISO_CBUS_TX_PHY_CTRL5_get_REGO_5V_DETECT(data)                               ((0x00200000&(data))>>21)
+#define ISO_CBUS_TX_PHY_CTRL5_TEST_OUT_TXRX_shift                                    (19)
+#define ISO_CBUS_TX_PHY_CTRL5_TEST_OUT_TXRX_mask                                     (0x00180000)
+#define ISO_CBUS_TX_PHY_CTRL5_TEST_OUT_TXRX(data)                                    (0x00180000&((data)<<19))
+#define ISO_CBUS_TX_PHY_CTRL5_TEST_OUT_TXRX_src(data)                                ((0x00180000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL5_get_TEST_OUT_TXRX(data)                                ((0x00180000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_CAL_R50_shift                                     (0)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_CAL_R50_mask                                      (0x0000000F)
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_CAL_R50(data)                                     (0x0000000F&((data)<<0))
+#define ISO_CBUS_TX_PHY_CTRL5_REGO_CAL_R50_src(data)                                 ((0x0000000F&(data))>>0)
+#define ISO_CBUS_TX_PHY_CTRL5_get_REGO_CAL_R50(data)                                 ((0x0000000F&(data))>>0)
+
+
+#define ISO_CBUS_TX_PHY_CTRL6                                                        0x18
+#define ISO_CBUS_TX_PHY_CTRL6_reg_addr                                               "0x98037018"
+#define ISO_CBUS_TX_PHY_CTRL6_reg                                                    0x98037018
+#define set_ISO_CBUS_TX_PHY_CTRL6_reg(data)   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL6_reg)=data)
+#define get_ISO_CBUS_TX_PHY_CTRL6_reg   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL6_reg))
+#define ISO_CBUS_TX_PHY_CTRL6_inst_adr                                               "0x0006"
+#define ISO_CBUS_TX_PHY_CTRL6_inst                                                   0x0006
+#define ISO_CBUS_TX_PHY_CTRL6_reg_threshold_shift                                    (27)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_threshold_mask                                     (0xF8000000)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_threshold(data)                                    (0xF8000000&((data)<<27))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_threshold_src(data)                                ((0xF8000000&(data))>>27)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_threshold(data)                                ((0xF8000000&(data))>>27)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_ctrl_shift                                     (24)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_ctrl_mask                                      (0x07000000)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_ctrl(data)                                     (0x07000000&((data)<<24))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_ctrl_src(data)                                 ((0x07000000&(data))>>24)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_cal_ctrl(data)                                 ((0x07000000&(data))>>24)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_threshold1_shift                                   (20)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_threshold1_mask                                    (0x00F00000)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_threshold1(data)                                   (0x00F00000&((data)<<20))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_threshold1_src(data)                               ((0x00F00000&(data))>>20)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_threshold1(data)                               ((0x00F00000&(data))>>20)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond_675_shift                                     (19)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond_675_mask                                      (0x00080000)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond_675(data)                                     (0x00080000&((data)<<19))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond_675_src(data)                                 ((0x00080000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_cond_675(data)                                 ((0x00080000&(data))>>19)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond_sel_shift                                     (17)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond_sel_mask                                      (0x00060000)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond_sel(data)                                     (0x00060000&((data)<<17))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond_sel_src(data)                                 ((0x00060000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_cond_sel(data)                                 ((0x00060000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_check_fail_shift                                   (16)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_check_fail_mask                                    (0x00010000)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_check_fail(data)                                   (0x00010000&((data)<<16))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_check_fail_src(data)                               ((0x00010000&(data))>>16)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_check_fail(data)                               ((0x00010000&(data))>>16)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_neg_out_shift                                      (15)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_neg_out_mask                                       (0x00008000)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_neg_out(data)                                      (0x00008000&((data)<<15))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_neg_out_src(data)                                  ((0x00008000&(data))>>15)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_neg_out(data)                                  ((0x00008000&(data))>>15)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond675_sel_shift                                  (13)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond675_sel_mask                                   (0x00006000)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond675_sel(data)                                  (0x00006000&((data)<<13))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cond675_sel_src(data)                              ((0x00006000&(data))>>13)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_cond675_sel(data)                              ((0x00006000&(data))>>13)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dbg_sel_shift                                      (12)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dbg_sel_mask                                       (0x00001000)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dbg_sel(data)                                      (0x00001000&((data)<<12))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dbg_sel_src(data)                                  ((0x00001000&(data))>>12)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_dbg_sel(data)                                  ((0x00001000&(data))>>12)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dphy_en_shift                                      (11)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dphy_en_mask                                       (0x00000800)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dphy_en(data)                                      (0x00000800&((data)<<11))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dphy_en_src(data)                                  ((0x00000800&(data))>>11)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_dphy_en(data)                                  ((0x00000800&(data))>>11)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_next_shift                                     (9)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_next_mask                                      (0x00000600)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_next(data)                                     (0x00000600&((data)<<9))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_next_src(data)                                 ((0x00000600&(data))>>9)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_cal_next(data)                                 ((0x00000600&(data))>>9)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dphy_rst_shift                                     (8)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dphy_rst_mask                                      (0x00000100)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dphy_rst(data)                                     (0x00000100&((data)<<8))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_dphy_rst_src(data)                                 ((0x00000100&(data))>>8)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_dphy_rst(data)                                 ((0x00000100&(data))>>8)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_read_data_shift                                    (4)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_read_data_mask                                     (0x000000F0)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_read_data(data)                                    (0x000000F0&((data)<<4))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_read_data_src(data)                                ((0x000000F0&(data))>>4)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_read_data(data)                                ((0x000000F0&(data))>>4)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_data_sel_shift                                 (0)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_data_sel_mask                                  (0x0000000F)
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_data_sel(data)                                 (0x0000000F&((data)<<0))
+#define ISO_CBUS_TX_PHY_CTRL6_reg_cal_data_sel_src(data)                             ((0x0000000F&(data))>>0)
+#define ISO_CBUS_TX_PHY_CTRL6_get_reg_cal_data_sel(data)                             ((0x0000000F&(data))>>0)
+
+
+#define ISO_CBUS_TX_ISO_DBG0                                                         0x20
+#define ISO_CBUS_TX_ISO_DBG0_reg_addr                                                "0x98037020"
+#define ISO_CBUS_TX_ISO_DBG0_reg                                                     0x98037020
+#define set_ISO_CBUS_TX_ISO_DBG0_reg(data)   (*((volatile unsigned int*) ISO_CBUS_TX_ISO_DBG0_reg)=data)
+#define get_ISO_CBUS_TX_ISO_DBG0_reg   (*((volatile unsigned int*) ISO_CBUS_TX_ISO_DBG0_reg))
+#define ISO_CBUS_TX_ISO_DBG0_inst_adr                                                "0x0008"
+#define ISO_CBUS_TX_ISO_DBG0_inst                                                    0x0008
+#define ISO_CBUS_TX_ISO_DBG0_iso_cbus_dbg_shift                                      (0)
+#define ISO_CBUS_TX_ISO_DBG0_iso_cbus_dbg_mask                                       (0xFFFFFFFF)
+#define ISO_CBUS_TX_ISO_DBG0_iso_cbus_dbg(data)                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_CBUS_TX_ISO_DBG0_iso_cbus_dbg_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_CBUS_TX_ISO_DBG0_get_iso_cbus_dbg(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_CBUS_TX_PHY_CTRL                                                         0xD0
+#define ISO_CBUS_TX_PHY_CTRL_reg_addr                                                "0x980370D0"
+#define ISO_CBUS_TX_PHY_CTRL_reg                                                     0x980370D0
+#define set_ISO_CBUS_TX_PHY_CTRL_reg(data)   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL_reg)=data)
+#define get_ISO_CBUS_TX_PHY_CTRL_reg   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_CTRL_reg))
+#define ISO_CBUS_TX_PHY_CTRL_inst_adr                                                "0x0034"
+#define ISO_CBUS_TX_PHY_CTRL_inst                                                    0x0034
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_BMOS_EN_TX_shift                                (31)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_BMOS_EN_TX_mask                                 (0x80000000)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_BMOS_EN_TX(data)                                (0x80000000&((data)<<31))
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_BMOS_EN_TX_src(data)                            ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_CTRL_get_REG_MHL_BMOS_EN_TX(data)                            ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_CTRL_REG_HDMI_HPD_EN_TX_shift                                (30)
+#define ISO_CBUS_TX_PHY_CTRL_REG_HDMI_HPD_EN_TX_mask                                 (0x40000000)
+#define ISO_CBUS_TX_PHY_CTRL_REG_HDMI_HPD_EN_TX(data)                                (0x40000000&((data)<<30))
+#define ISO_CBUS_TX_PHY_CTRL_REG_HDMI_HPD_EN_TX_src(data)                            ((0x40000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_CTRL_get_REG_HDMI_HPD_EN_TX(data)                            ((0x40000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_R1K_DET_TX_shift                                (29)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_R1K_DET_TX_mask                                 (0x20000000)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_R1K_DET_TX(data)                                (0x20000000&((data)<<29))
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_R1K_DET_TX_src(data)                            ((0x20000000&(data))>>29)
+#define ISO_CBUS_TX_PHY_CTRL_get_REG_MHL_R1K_DET_TX(data)                            ((0x20000000&(data))>>29)
+#define ISO_CBUS_TX_PHY_CTRL_REG_R1K_VTH_SEL_TX_shift                                (28)
+#define ISO_CBUS_TX_PHY_CTRL_REG_R1K_VTH_SEL_TX_mask                                 (0x10000000)
+#define ISO_CBUS_TX_PHY_CTRL_REG_R1K_VTH_SEL_TX(data)                                (0x10000000&((data)<<28))
+#define ISO_CBUS_TX_PHY_CTRL_REG_R1K_VTH_SEL_TX_src(data)                            ((0x10000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_CTRL_get_REG_R1K_VTH_SEL_TX(data)                            ((0x10000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_TST_EN_TX_shift                                 (27)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_TST_EN_TX_mask                                  (0x08000000)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_TST_EN_TX(data)                                 (0x08000000&((data)<<27))
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_TST_EN_TX_src(data)                             ((0x08000000&(data))>>27)
+#define ISO_CBUS_TX_PHY_CTRL_get_REG_MHL_TST_EN_TX(data)                             ((0x08000000&(data))>>27)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_VSEL_TX_shift                                   (24)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_VSEL_TX_mask                                    (0x07000000)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_VSEL_TX(data)                                   (0x07000000&((data)<<24))
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_VSEL_TX_src(data)                               ((0x07000000&(data))>>24)
+#define ISO_CBUS_TX_PHY_CTRL_get_REG_MHL_VSEL_TX(data)                               ((0x07000000&(data))>>24)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_R10K_TX_shift                                   (21)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_R10K_TX_mask                                    (0x00E00000)
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_R10K_TX(data)                                   (0x00E00000&((data)<<21))
+#define ISO_CBUS_TX_PHY_CTRL_REG_MHL_R10K_TX_src(data)                               ((0x00E00000&(data))>>21)
+#define ISO_CBUS_TX_PHY_CTRL_get_REG_MHL_R10K_TX(data)                               ((0x00E00000&(data))>>21)
+#define ISO_CBUS_TX_PHY_CTRL_REG_CBUS_STRC_TX_shift                                  (18)
+#define ISO_CBUS_TX_PHY_CTRL_REG_CBUS_STRC_TX_mask                                   (0x001C0000)
+#define ISO_CBUS_TX_PHY_CTRL_REG_CBUS_STRC_TX(data)                                  (0x001C0000&((data)<<18))
+#define ISO_CBUS_TX_PHY_CTRL_REG_CBUS_STRC_TX_src(data)                              ((0x001C0000&(data))>>18)
+#define ISO_CBUS_TX_PHY_CTRL_get_REG_CBUS_STRC_TX(data)                              ((0x001C0000&(data))>>18)
+#define ISO_CBUS_TX_PHY_CTRL_REG_EN_BIAS_TXRX_shift                                  (17)
+#define ISO_CBUS_TX_PHY_CTRL_REG_EN_BIAS_TXRX_mask                                   (0x00020000)
+#define ISO_CBUS_TX_PHY_CTRL_REG_EN_BIAS_TXRX(data)                                  (0x00020000&((data)<<17))
+#define ISO_CBUS_TX_PHY_CTRL_REG_EN_BIAS_TXRX_src(data)                              ((0x00020000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL_get_REG_EN_BIAS_TXRX(data)                              ((0x00020000&(data))>>17)
+#define ISO_CBUS_TX_PHY_CTRL_TST_SEL_H_TX_shift                                      (15)
+#define ISO_CBUS_TX_PHY_CTRL_TST_SEL_H_TX_mask                                       (0x00018000)
+#define ISO_CBUS_TX_PHY_CTRL_TST_SEL_H_TX(data)                                      (0x00018000&((data)<<15))
+#define ISO_CBUS_TX_PHY_CTRL_TST_SEL_H_TX_src(data)                                  ((0x00018000&(data))>>15)
+#define ISO_CBUS_TX_PHY_CTRL_get_TST_SEL_H_TX(data)                                  ((0x00018000&(data))>>15)
+#define ISO_CBUS_TX_PHY_CTRL_hw_r1k_det_en_shift                                     (14)
+#define ISO_CBUS_TX_PHY_CTRL_hw_r1k_det_en_mask                                      (0x00004000)
+#define ISO_CBUS_TX_PHY_CTRL_hw_r1k_det_en(data)                                     (0x00004000&((data)<<14))
+#define ISO_CBUS_TX_PHY_CTRL_hw_r1k_det_en_src(data)                                 ((0x00004000&(data))>>14)
+#define ISO_CBUS_TX_PHY_CTRL_get_hw_r1k_det_en(data)                                 ((0x00004000&(data))>>14)
+#define ISO_CBUS_TX_PHY_CTRL_cbus_fw_rst_shift                                       (9)
+#define ISO_CBUS_TX_PHY_CTRL_cbus_fw_rst_mask                                        (0x00000200)
+#define ISO_CBUS_TX_PHY_CTRL_cbus_fw_rst(data)                                       (0x00000200&((data)<<9))
+#define ISO_CBUS_TX_PHY_CTRL_cbus_fw_rst_src(data)                                   ((0x00000200&(data))>>9)
+#define ISO_CBUS_TX_PHY_CTRL_get_cbus_fw_rst(data)                                   ((0x00000200&(data))>>9)
+#define ISO_CBUS_TX_PHY_CTRL_cbus_clk_bypass_shift                                   (8)
+#define ISO_CBUS_TX_PHY_CTRL_cbus_clk_bypass_mask                                    (0x00000100)
+#define ISO_CBUS_TX_PHY_CTRL_cbus_clk_bypass(data)                                   (0x00000100&((data)<<8))
+#define ISO_CBUS_TX_PHY_CTRL_cbus_clk_bypass_src(data)                               ((0x00000100&(data))>>8)
+#define ISO_CBUS_TX_PHY_CTRL_get_cbus_clk_bypass(data)                               ((0x00000100&(data))>>8)
+#define ISO_CBUS_TX_PHY_CTRL_sel_clk_75m_shift                                       (4)
+#define ISO_CBUS_TX_PHY_CTRL_sel_clk_75m_mask                                        (0x00000030)
+#define ISO_CBUS_TX_PHY_CTRL_sel_clk_75m(data)                                       (0x00000030&((data)<<4))
+#define ISO_CBUS_TX_PHY_CTRL_sel_clk_75m_src(data)                                   ((0x00000030&(data))>>4)
+#define ISO_CBUS_TX_PHY_CTRL_get_sel_clk_75m(data)                                   ((0x00000030&(data))>>4)
+#define ISO_CBUS_TX_PHY_CTRL_sys_clk_div_shift                                       (0)
+#define ISO_CBUS_TX_PHY_CTRL_sys_clk_div_mask                                        (0x00000007)
+#define ISO_CBUS_TX_PHY_CTRL_sys_clk_div(data)                                       (0x00000007&((data)<<0))
+#define ISO_CBUS_TX_PHY_CTRL_sys_clk_div_src(data)                                   ((0x00000007&(data))>>0)
+#define ISO_CBUS_TX_PHY_CTRL_get_sys_clk_div(data)                                   ((0x00000007&(data))>>0)
+
+
+#define ISO_CBUS_TX_PHY_IRQ                                                          0xD4
+#define ISO_CBUS_TX_PHY_IRQ_reg_addr                                                 "0x980370D4"
+#define ISO_CBUS_TX_PHY_IRQ_reg                                                      0x980370D4
+#define set_ISO_CBUS_TX_PHY_IRQ_reg(data)   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_IRQ_reg)=data)
+#define get_ISO_CBUS_TX_PHY_IRQ_reg   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_IRQ_reg))
+#define ISO_CBUS_TX_PHY_IRQ_inst_adr                                                 "0x0035"
+#define ISO_CBUS_TX_PHY_IRQ_inst                                                     0x0035
+#define ISO_CBUS_TX_PHY_IRQ_cbus_hpd_irq_shift                                       (6)
+#define ISO_CBUS_TX_PHY_IRQ_cbus_hpd_irq_mask                                        (0x00000040)
+#define ISO_CBUS_TX_PHY_IRQ_cbus_hpd_irq(data)                                       (0x00000040&((data)<<6))
+#define ISO_CBUS_TX_PHY_IRQ_cbus_hpd_irq_src(data)                                   ((0x00000040&(data))>>6)
+#define ISO_CBUS_TX_PHY_IRQ_get_cbus_hpd_irq(data)                                   ((0x00000040&(data))>>6)
+#define ISO_CBUS_TX_PHY_IRQ_cbus_hpd_irq_en_shift                                    (5)
+#define ISO_CBUS_TX_PHY_IRQ_cbus_hpd_irq_en_mask                                     (0x00000020)
+#define ISO_CBUS_TX_PHY_IRQ_cbus_hpd_irq_en(data)                                    (0x00000020&((data)<<5))
+#define ISO_CBUS_TX_PHY_IRQ_cbus_hpd_irq_en_src(data)                                ((0x00000020&(data))>>5)
+#define ISO_CBUS_TX_PHY_IRQ_get_cbus_hpd_irq_en(data)                                ((0x00000020&(data))>>5)
+#define ISO_CBUS_TX_PHY_IRQ_detect_5v_irq_shift                                      (4)
+#define ISO_CBUS_TX_PHY_IRQ_detect_5v_irq_mask                                       (0x00000010)
+#define ISO_CBUS_TX_PHY_IRQ_detect_5v_irq(data)                                      (0x00000010&((data)<<4))
+#define ISO_CBUS_TX_PHY_IRQ_detect_5v_irq_src(data)                                  ((0x00000010&(data))>>4)
+#define ISO_CBUS_TX_PHY_IRQ_get_detect_5v_irq(data)                                  ((0x00000010&(data))>>4)
+#define ISO_CBUS_TX_PHY_IRQ_detect_5v_irq_en_shift                                   (3)
+#define ISO_CBUS_TX_PHY_IRQ_detect_5v_irq_en_mask                                    (0x00000008)
+#define ISO_CBUS_TX_PHY_IRQ_detect_5v_irq_en(data)                                   (0x00000008&((data)<<3))
+#define ISO_CBUS_TX_PHY_IRQ_detect_5v_irq_en_src(data)                               ((0x00000008&(data))>>3)
+#define ISO_CBUS_TX_PHY_IRQ_get_detect_5v_irq_en(data)                               ((0x00000008&(data))>>3)
+#define ISO_CBUS_TX_PHY_IRQ_det_z1k_irq_shift                                        (2)
+#define ISO_CBUS_TX_PHY_IRQ_det_z1k_irq_mask                                         (0x00000004)
+#define ISO_CBUS_TX_PHY_IRQ_det_z1k_irq(data)                                        (0x00000004&((data)<<2))
+#define ISO_CBUS_TX_PHY_IRQ_det_z1k_irq_src(data)                                    ((0x00000004&(data))>>2)
+#define ISO_CBUS_TX_PHY_IRQ_get_det_z1k_irq(data)                                    ((0x00000004&(data))>>2)
+#define ISO_CBUS_TX_PHY_IRQ_det_z1k_irq_en_shift                                     (1)
+#define ISO_CBUS_TX_PHY_IRQ_det_z1k_irq_en_mask                                      (0x00000002)
+#define ISO_CBUS_TX_PHY_IRQ_det_z1k_irq_en(data)                                     (0x00000002&((data)<<1))
+#define ISO_CBUS_TX_PHY_IRQ_det_z1k_irq_en_src(data)                                 ((0x00000002&(data))>>1)
+#define ISO_CBUS_TX_PHY_IRQ_get_det_z1k_irq_en(data)                                 ((0x00000002&(data))>>1)
+#define ISO_CBUS_TX_PHY_IRQ_write_data_shift                                         (0)
+#define ISO_CBUS_TX_PHY_IRQ_write_data_mask                                          (0x00000001)
+#define ISO_CBUS_TX_PHY_IRQ_write_data(data)                                         (0x00000001&((data)<<0))
+#define ISO_CBUS_TX_PHY_IRQ_write_data_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_CBUS_TX_PHY_IRQ_get_write_data(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_CBUS_TX_PHY_STATUS                                                       0xDC
+#define ISO_CBUS_TX_PHY_STATUS_reg_addr                                              "0x980370DC"
+#define ISO_CBUS_TX_PHY_STATUS_reg                                                   0x980370DC
+#define set_ISO_CBUS_TX_PHY_STATUS_reg(data)   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_STATUS_reg)=data)
+#define get_ISO_CBUS_TX_PHY_STATUS_reg   (*((volatile unsigned int*) ISO_CBUS_TX_PHY_STATUS_reg))
+#define ISO_CBUS_TX_PHY_STATUS_inst_adr                                              "0x0037"
+#define ISO_CBUS_TX_PHY_STATUS_inst                                                  0x0037
+#define ISO_CBUS_TX_PHY_STATUS_rego_mhl_r1k_det_tx_shift                             (31)
+#define ISO_CBUS_TX_PHY_STATUS_rego_mhl_r1k_det_tx_mask                              (0x80000000)
+#define ISO_CBUS_TX_PHY_STATUS_rego_mhl_r1k_det_tx(data)                             (0x80000000&((data)<<31))
+#define ISO_CBUS_TX_PHY_STATUS_rego_mhl_r1k_det_tx_src(data)                         ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_STATUS_get_rego_mhl_r1k_det_tx(data)                         ((0x80000000&(data))>>31)
+#define ISO_CBUS_TX_PHY_STATUS_hdmi_hpd_out_tx_shift                                 (30)
+#define ISO_CBUS_TX_PHY_STATUS_hdmi_hpd_out_tx_mask                                  (0x40000000)
+#define ISO_CBUS_TX_PHY_STATUS_hdmi_hpd_out_tx(data)                                 (0x40000000&((data)<<30))
+#define ISO_CBUS_TX_PHY_STATUS_hdmi_hpd_out_tx_src(data)                             ((0x40000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_STATUS_get_hdmi_hpd_out_tx(data)                             ((0x40000000&(data))>>30)
+#define ISO_CBUS_TX_PHY_STATUS_hw_en_10k_shift                                       (29)
+#define ISO_CBUS_TX_PHY_STATUS_hw_en_10k_mask                                        (0x20000000)
+#define ISO_CBUS_TX_PHY_STATUS_hw_en_10k(data)                                       (0x20000000&((data)<<29))
+#define ISO_CBUS_TX_PHY_STATUS_hw_en_10k_src(data)                                   ((0x20000000&(data))>>29)
+#define ISO_CBUS_TX_PHY_STATUS_get_hw_en_10k(data)                                   ((0x20000000&(data))>>29)
+#define ISO_CBUS_TX_PHY_STATUS_hw_en_5k_shift                                        (28)
+#define ISO_CBUS_TX_PHY_STATUS_hw_en_5k_mask                                         (0x10000000)
+#define ISO_CBUS_TX_PHY_STATUS_hw_en_5k(data)                                        (0x10000000&((data)<<28))
+#define ISO_CBUS_TX_PHY_STATUS_hw_en_5k_src(data)                                    ((0x10000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_STATUS_get_hw_en_5k(data)                                    ((0x10000000&(data))>>28)
+#define ISO_CBUS_TX_PHY_STATUS_det_r1k_st_shift                                      (26)
+#define ISO_CBUS_TX_PHY_STATUS_det_r1k_st_mask                                       (0x0C000000)
+#define ISO_CBUS_TX_PHY_STATUS_det_r1k_st(data)                                      (0x0C000000&((data)<<26))
+#define ISO_CBUS_TX_PHY_STATUS_det_r1k_st_src(data)                                  ((0x0C000000&(data))>>26)
+#define ISO_CBUS_TX_PHY_STATUS_get_det_r1k_st(data)                                  ((0x0C000000&(data))>>26)
+#define ISO_CBUS_TX_PHY_STATUS_cbus_dbn_shift                                        (25)
+#define ISO_CBUS_TX_PHY_STATUS_cbus_dbn_mask                                         (0x02000000)
+#define ISO_CBUS_TX_PHY_STATUS_cbus_dbn(data)                                        (0x02000000&((data)<<25))
+#define ISO_CBUS_TX_PHY_STATUS_cbus_dbn_src(data)                                    ((0x02000000&(data))>>25)
+#define ISO_CBUS_TX_PHY_STATUS_get_cbus_dbn(data)                                    ((0x02000000&(data))>>25)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_r10k_test_shift                                (24)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_r10k_test_mask                                 (0x01000000)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_r10k_test(data)                                (0x01000000&((data)<<24))
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_r10k_test_src(data)                            ((0x01000000&(data))>>24)
+#define ISO_CBUS_TX_PHY_STATUS_get_hw_mhl_r10k_test(data)                            ((0x01000000&(data))>>24)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_r1k_det_shift                                  (23)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_r1k_det_mask                                   (0x00800000)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_r1k_det(data)                                  (0x00800000&((data)<<23))
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_r1k_det_src(data)                              ((0x00800000&(data))>>23)
+#define ISO_CBUS_TX_PHY_STATUS_get_hw_mhl_r1k_det(data)                              ((0x00800000&(data))>>23)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_bmos_en_shift                                  (22)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_bmos_en_mask                                   (0x00400000)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_bmos_en(data)                                  (0x00400000&((data)<<22))
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_bmos_en_src(data)                              ((0x00400000&(data))>>22)
+#define ISO_CBUS_TX_PHY_STATUS_get_hw_mhl_bmos_en(data)                              ((0x00400000&(data))>>22)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_vtl_sel_shift                                  (21)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_vtl_sel_mask                                   (0x00200000)
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_vtl_sel(data)                                  (0x00200000&((data)<<21))
+#define ISO_CBUS_TX_PHY_STATUS_hw_mhl_vtl_sel_src(data)                              ((0x00200000&(data))>>21)
+#define ISO_CBUS_TX_PHY_STATUS_get_hw_mhl_vtl_sel(data)                              ((0x00200000&(data))>>21)
+#define ISO_CBUS_TX_PHY_STATUS_det_r1k_cnt_shift                                     (8)
+#define ISO_CBUS_TX_PHY_STATUS_det_r1k_cnt_mask                                      (0x0000FF00)
+#define ISO_CBUS_TX_PHY_STATUS_det_r1k_cnt(data)                                     (0x0000FF00&((data)<<8))
+#define ISO_CBUS_TX_PHY_STATUS_det_r1k_cnt_src(data)                                 ((0x0000FF00&(data))>>8)
+#define ISO_CBUS_TX_PHY_STATUS_get_det_r1k_cnt(data)                                 ((0x0000FF00&(data))>>8)
+#define ISO_CBUS_TX_PHY_STATUS_fw_rst_r1k_st_shift                                   (3)
+#define ISO_CBUS_TX_PHY_STATUS_fw_rst_r1k_st_mask                                    (0x00000008)
+#define ISO_CBUS_TX_PHY_STATUS_fw_rst_r1k_st(data)                                   (0x00000008&((data)<<3))
+#define ISO_CBUS_TX_PHY_STATUS_fw_rst_r1k_st_src(data)                               ((0x00000008&(data))>>3)
+#define ISO_CBUS_TX_PHY_STATUS_get_fw_rst_r1k_st(data)                               ((0x00000008&(data))>>3)
+#define ISO_CBUS_TX_PHY_STATUS_fw_r1k_det_en_shift                                   (1)
+#define ISO_CBUS_TX_PHY_STATUS_fw_r1k_det_en_mask                                    (0x00000002)
+#define ISO_CBUS_TX_PHY_STATUS_fw_r1k_det_en(data)                                   (0x00000002&((data)<<1))
+#define ISO_CBUS_TX_PHY_STATUS_fw_r1k_det_en_src(data)                               ((0x00000002&(data))>>1)
+#define ISO_CBUS_TX_PHY_STATUS_get_fw_r1k_det_en(data)                               ((0x00000002&(data))>>1)
+#define ISO_CBUS_TX_PHY_STATUS_fw_r1k_det_shift                                      (0)
+#define ISO_CBUS_TX_PHY_STATUS_fw_r1k_det_mask                                       (0x00000001)
+#define ISO_CBUS_TX_PHY_STATUS_fw_r1k_det(data)                                      (0x00000001&((data)<<0))
+#define ISO_CBUS_TX_PHY_STATUS_fw_r1k_det_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_CBUS_TX_PHY_STATUS_get_fw_r1k_det(data)                                  ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/mipi_aphy_reg.h b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/mipi_aphy_reg.h
new file mode 100644
index 00000000..ffeb4c0
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/mipi_aphy_reg.h
@@ -0,0 +1,543 @@
+/**************************************************************
+// Spec Version                  : 1.00
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/1/21 17:31:33
+***************************************************************/
+
+
+#ifndef _MIPI_APHY_REG_H_INCLUDED_
+#define _MIPI_APHY_REG_H_INCLUDED_
+
+#define MIPI_APHY_REG0                                                               0x00
+#define MIPI_APHY_REG0_reg_addr                                                      "0x98004000"
+#define MIPI_APHY_REG0_reg                                                           0x98004000
+#define set_MIPI_APHY_REG0_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG0_reg)=data)
+#define get_MIPI_APHY_REG0_reg   (*((volatile unsigned int*) MIPI_APHY_REG0_reg))
+#define MIPI_APHY_REG0_inst_adr                                                      "0x0000"
+#define MIPI_APHY_REG0_inst                                                          0x0000
+#define MIPI_APHY_REG0_R50_CAL_RG_shift                                              (0)
+#define MIPI_APHY_REG0_R50_CAL_RG_mask                                               (0x0000003F)
+#define MIPI_APHY_REG0_R50_CAL_RG(data)                                              (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG0_R50_CAL_RG_src(data)                                          ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG0_get_R50_CAL_RG(data)                                          ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG1                                                               0x04
+#define MIPI_APHY_REG1_reg_addr                                                      "0x98004004"
+#define MIPI_APHY_REG1_reg                                                           0x98004004
+#define set_MIPI_APHY_REG1_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG1_reg)=data)
+#define get_MIPI_APHY_REG1_reg   (*((volatile unsigned int*) MIPI_APHY_REG1_reg))
+#define MIPI_APHY_REG1_inst_adr                                                      "0x0001"
+#define MIPI_APHY_REG1_inst                                                          0x0001
+#define MIPI_APHY_REG1_EN_SKW_shift                                                  (7)
+#define MIPI_APHY_REG1_EN_SKW_mask                                                   (0x00000080)
+#define MIPI_APHY_REG1_EN_SKW(data)                                                  (0x00000080&((data)<<7))
+#define MIPI_APHY_REG1_EN_SKW_src(data)                                              ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG1_get_EN_SKW(data)                                              ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG1_EN_AUTO_SKW_shift                                             (6)
+#define MIPI_APHY_REG1_EN_AUTO_SKW_mask                                              (0x00000040)
+#define MIPI_APHY_REG1_EN_AUTO_SKW(data)                                             (0x00000040&((data)<<6))
+#define MIPI_APHY_REG1_EN_AUTO_SKW_src(data)                                         ((0x00000040&(data))>>6)
+#define MIPI_APHY_REG1_get_EN_AUTO_SKW(data)                                         ((0x00000040&(data))>>6)
+#define MIPI_APHY_REG1_PAUSEB_SKW_CAL_shift                                          (5)
+#define MIPI_APHY_REG1_PAUSEB_SKW_CAL_mask                                           (0x00000020)
+#define MIPI_APHY_REG1_PAUSEB_SKW_CAL(data)                                          (0x00000020&((data)<<5))
+#define MIPI_APHY_REG1_PAUSEB_SKW_CAL_src(data)                                      ((0x00000020&(data))>>5)
+#define MIPI_APHY_REG1_get_PAUSEB_SKW_CAL(data)                                      ((0x00000020&(data))>>5)
+#define MIPI_APHY_REG1_EN_AUTO_STPB_SKW_CAL_RG_shift                                 (4)
+#define MIPI_APHY_REG1_EN_AUTO_STPB_SKW_CAL_RG_mask                                  (0x00000010)
+#define MIPI_APHY_REG1_EN_AUTO_STPB_SKW_CAL_RG(data)                                 (0x00000010&((data)<<4))
+#define MIPI_APHY_REG1_EN_AUTO_STPB_SKW_CAL_RG_src(data)                             ((0x00000010&(data))>>4)
+#define MIPI_APHY_REG1_get_EN_AUTO_STPB_SKW_CAL_RG(data)                             ((0x00000010&(data))>>4)
+#define MIPI_APHY_REG1_EN_OSK_shift                                                  (3)
+#define MIPI_APHY_REG1_EN_OSK_mask                                                   (0x00000008)
+#define MIPI_APHY_REG1_EN_OSK(data)                                                  (0x00000008&((data)<<3))
+#define MIPI_APHY_REG1_EN_OSK_src(data)                                              ((0x00000008&(data))>>3)
+#define MIPI_APHY_REG1_get_EN_OSK(data)                                              ((0x00000008&(data))>>3)
+#define MIPI_APHY_REG1_EN_AUTO_OSK_shift                                             (2)
+#define MIPI_APHY_REG1_EN_AUTO_OSK_mask                                              (0x00000004)
+#define MIPI_APHY_REG1_EN_AUTO_OSK(data)                                             (0x00000004&((data)<<2))
+#define MIPI_APHY_REG1_EN_AUTO_OSK_src(data)                                         ((0x00000004&(data))>>2)
+#define MIPI_APHY_REG1_get_EN_AUTO_OSK(data)                                         ((0x00000004&(data))>>2)
+#define MIPI_APHY_REG1_EN_R50_CAL_RG_shift                                           (1)
+#define MIPI_APHY_REG1_EN_R50_CAL_RG_mask                                            (0x00000002)
+#define MIPI_APHY_REG1_EN_R50_CAL_RG(data)                                           (0x00000002&((data)<<1))
+#define MIPI_APHY_REG1_EN_R50_CAL_RG_src(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_APHY_REG1_get_EN_R50_CAL_RG(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_APHY_REG1_EN_R50_AUTO_CAL_RG_shift                                      (0)
+#define MIPI_APHY_REG1_EN_R50_AUTO_CAL_RG_mask                                       (0x00000001)
+#define MIPI_APHY_REG1_EN_R50_AUTO_CAL_RG(data)                                      (0x00000001&((data)<<0))
+#define MIPI_APHY_REG1_EN_R50_AUTO_CAL_RG_src(data)                                  ((0x00000001&(data))>>0)
+#define MIPI_APHY_REG1_get_EN_R50_AUTO_CAL_RG(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIPI_APHY_REG2                                                               0x08
+#define MIPI_APHY_REG2_reg_addr                                                      "0x98004008"
+#define MIPI_APHY_REG2_reg                                                           0x98004008
+#define set_MIPI_APHY_REG2_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG2_reg)=data)
+#define get_MIPI_APHY_REG2_reg   (*((volatile unsigned int*) MIPI_APHY_REG2_reg))
+#define MIPI_APHY_REG2_inst_adr                                                      "0x0002"
+#define MIPI_APHY_REG2_inst                                                          0x0002
+#define MIPI_APHY_REG2_SEL0_PAUSED_SKW_K_RG_shift                                    (7)
+#define MIPI_APHY_REG2_SEL0_PAUSED_SKW_K_RG_mask                                     (0x00000080)
+#define MIPI_APHY_REG2_SEL0_PAUSED_SKW_K_RG(data)                                    (0x00000080&((data)<<7))
+#define MIPI_APHY_REG2_SEL0_PAUSED_SKW_K_RG_src(data)                                ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG2_get_SEL0_PAUSED_SKW_K_RG(data)                                ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG2_LGTH_D0_shift                                                 (4)
+#define MIPI_APHY_REG2_LGTH_D0_mask                                                  (0x00000070)
+#define MIPI_APHY_REG2_LGTH_D0(data)                                                 (0x00000070&((data)<<4))
+#define MIPI_APHY_REG2_LGTH_D0_src(data)                                             ((0x00000070&(data))>>4)
+#define MIPI_APHY_REG2_get_LGTH_D0(data)                                             ((0x00000070&(data))>>4)
+#define MIPI_APHY_REG2_PDBH_k_shift                                                  (3)
+#define MIPI_APHY_REG2_PDBH_k_mask                                                   (0x00000008)
+#define MIPI_APHY_REG2_PDBH_k(data)                                                  (0x00000008&((data)<<3))
+#define MIPI_APHY_REG2_PDBH_k_src(data)                                              ((0x00000008&(data))>>3)
+#define MIPI_APHY_REG2_get_PDBH_k(data)                                              ((0x00000008&(data))>>3)
+#define MIPI_APHY_REG2_PWDB_OSK_shift                                                (2)
+#define MIPI_APHY_REG2_PWDB_OSK_mask                                                 (0x00000004)
+#define MIPI_APHY_REG2_PWDB_OSK(data)                                                (0x00000004&((data)<<2))
+#define MIPI_APHY_REG2_PWDB_OSK_src(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_APHY_REG2_get_PWDB_OSK(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_APHY_REG2_DOUBL_PUMP_shift                                              (1)
+#define MIPI_APHY_REG2_DOUBL_PUMP_mask                                               (0x00000002)
+#define MIPI_APHY_REG2_DOUBL_PUMP(data)                                              (0x00000002&((data)<<1))
+#define MIPI_APHY_REG2_DOUBL_PUMP_src(data)                                          ((0x00000002&(data))>>1)
+#define MIPI_APHY_REG2_get_DOUBL_PUMP(data)                                          ((0x00000002&(data))>>1)
+#define MIPI_APHY_REG2_ENSEL_shift                                                   (0)
+#define MIPI_APHY_REG2_ENSEL_mask                                                    (0x00000001)
+#define MIPI_APHY_REG2_ENSEL(data)                                                   (0x00000001&((data)<<0))
+#define MIPI_APHY_REG2_ENSEL_src(data)                                               ((0x00000001&(data))>>0)
+#define MIPI_APHY_REG2_get_ENSEL(data)                                               ((0x00000001&(data))>>0)
+
+
+#define MIPI_APHY_REG3                                                               0x0C
+#define MIPI_APHY_REG3_reg_addr                                                      "0x9800400C"
+#define MIPI_APHY_REG3_reg                                                           0x9800400C
+#define set_MIPI_APHY_REG3_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG3_reg)=data)
+#define get_MIPI_APHY_REG3_reg   (*((volatile unsigned int*) MIPI_APHY_REG3_reg))
+#define MIPI_APHY_REG3_inst_adr                                                      "0x0003"
+#define MIPI_APHY_REG3_inst                                                          0x0003
+#define MIPI_APHY_REG3_HSPAMP0_RL_RG_shift                                           (0)
+#define MIPI_APHY_REG3_HSPAMP0_RL_RG_mask                                            (0x0000003F)
+#define MIPI_APHY_REG3_HSPAMP0_RL_RG(data)                                           (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG3_HSPAMP0_RL_RG_src(data)                                       ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG3_get_HSPAMP0_RL_RG(data)                                       ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG4                                                               0x10
+#define MIPI_APHY_REG4_reg_addr                                                      "0x98004010"
+#define MIPI_APHY_REG4_reg                                                           0x98004010
+#define set_MIPI_APHY_REG4_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG4_reg)=data)
+#define get_MIPI_APHY_REG4_reg   (*((volatile unsigned int*) MIPI_APHY_REG4_reg))
+#define MIPI_APHY_REG4_inst_adr                                                      "0x0004"
+#define MIPI_APHY_REG4_inst                                                          0x0004
+#define MIPI_APHY_REG4_HSPAMP1_RL_RG_shift                                           (0)
+#define MIPI_APHY_REG4_HSPAMP1_RL_RG_mask                                            (0x0000003F)
+#define MIPI_APHY_REG4_HSPAMP1_RL_RG(data)                                           (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG4_HSPAMP1_RL_RG_src(data)                                       ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG4_get_HSPAMP1_RL_RG(data)                                       ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG5                                                               0x14
+#define MIPI_APHY_REG5_reg_addr                                                      "0x98004014"
+#define MIPI_APHY_REG5_reg                                                           0x98004014
+#define set_MIPI_APHY_REG5_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG5_reg)=data)
+#define get_MIPI_APHY_REG5_reg   (*((volatile unsigned int*) MIPI_APHY_REG5_reg))
+#define MIPI_APHY_REG5_inst_adr                                                      "0x0005"
+#define MIPI_APHY_REG5_inst                                                          0x0005
+#define MIPI_APHY_REG5_SDATA0_SKW_RG_shift                                           (4)
+#define MIPI_APHY_REG5_SDATA0_SKW_RG_mask                                            (0x000000F0)
+#define MIPI_APHY_REG5_SDATA0_SKW_RG(data)                                           (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG5_SDATA0_SKW_RG_src(data)                                       ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG5_get_SDATA0_SKW_RG(data)                                       ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG5_SDATA1_SKW_RG_shift                                           (0)
+#define MIPI_APHY_REG5_SDATA1_SKW_RG_mask                                            (0x0000000F)
+#define MIPI_APHY_REG5_SDATA1_SKW_RG(data)                                           (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG5_SDATA1_SKW_RG_src(data)                                       ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG5_get_SDATA1_SKW_RG(data)                                       ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG6                                                               0x18
+#define MIPI_APHY_REG6_reg_addr                                                      "0x98004018"
+#define MIPI_APHY_REG6_reg                                                           0x98004018
+#define set_MIPI_APHY_REG6_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG6_reg)=data)
+#define get_MIPI_APHY_REG6_reg   (*((volatile unsigned int*) MIPI_APHY_REG6_reg))
+#define MIPI_APHY_REG6_inst_adr                                                      "0x0006"
+#define MIPI_APHY_REG6_inst                                                          0x0006
+#define MIPI_APHY_REG6_SDATA2_SKW_RG_shift                                           (4)
+#define MIPI_APHY_REG6_SDATA2_SKW_RG_mask                                            (0x000000F0)
+#define MIPI_APHY_REG6_SDATA2_SKW_RG(data)                                           (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG6_SDATA2_SKW_RG_src(data)                                       ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG6_get_SDATA2_SKW_RG(data)                                       ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG6_SDATA3_SKW_RG_shift                                           (0)
+#define MIPI_APHY_REG6_SDATA3_SKW_RG_mask                                            (0x0000000F)
+#define MIPI_APHY_REG6_SDATA3_SKW_RG(data)                                           (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG6_SDATA3_SKW_RG_src(data)                                       ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG6_get_SDATA3_SKW_RG(data)                                       ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG7                                                               0x1C
+#define MIPI_APHY_REG7_reg_addr                                                      "0x9800401C"
+#define MIPI_APHY_REG7_reg                                                           0x9800401C
+#define set_MIPI_APHY_REG7_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG7_reg)=data)
+#define get_MIPI_APHY_REG7_reg   (*((volatile unsigned int*) MIPI_APHY_REG7_reg))
+#define MIPI_APHY_REG7_inst_adr                                                      "0x0007"
+#define MIPI_APHY_REG7_inst                                                          0x0007
+#define MIPI_APHY_REG7_SCLK0_SKW_RG_shift                                            (4)
+#define MIPI_APHY_REG7_SCLK0_SKW_RG_mask                                             (0x000000F0)
+#define MIPI_APHY_REG7_SCLK0_SKW_RG(data)                                            (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG7_SCLK0_SKW_RG_src(data)                                        ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG7_get_SCLK0_SKW_RG(data)                                        ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG7_SCLK1_SKW_RG_shift                                            (0)
+#define MIPI_APHY_REG7_SCLK1_SKW_RG_mask                                             (0x0000000F)
+#define MIPI_APHY_REG7_SCLK1_SKW_RG(data)                                            (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG7_SCLK1_SKW_RG_src(data)                                        ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG7_get_SCLK1_SKW_RG(data)                                        ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG8                                                               0x20
+#define MIPI_APHY_REG8_reg_addr                                                      "0x98004020"
+#define MIPI_APHY_REG8_reg                                                           0x98004020
+#define set_MIPI_APHY_REG8_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG8_reg)=data)
+#define get_MIPI_APHY_REG8_reg   (*((volatile unsigned int*) MIPI_APHY_REG8_reg))
+#define MIPI_APHY_REG8_inst_adr                                                      "0x0008"
+#define MIPI_APHY_REG8_inst                                                          0x0008
+#define MIPI_APHY_REG8_SCLK2_SKW_RG_shift                                            (4)
+#define MIPI_APHY_REG8_SCLK2_SKW_RG_mask                                             (0x000000F0)
+#define MIPI_APHY_REG8_SCLK2_SKW_RG(data)                                            (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG8_SCLK2_SKW_RG_src(data)                                        ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG8_get_SCLK2_SKW_RG(data)                                        ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG8_SCLK3_SKW_RG_shift                                            (0)
+#define MIPI_APHY_REG8_SCLK3_SKW_RG_mask                                             (0x0000000F)
+#define MIPI_APHY_REG8_SCLK3_SKW_RG(data)                                            (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG8_SCLK3_SKW_RG_src(data)                                        ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG8_get_SCLK3_SKW_RG(data)                                        ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG9                                                               0x24
+#define MIPI_APHY_REG9_reg_addr                                                      "0x98004024"
+#define MIPI_APHY_REG9_reg                                                           0x98004024
+#define set_MIPI_APHY_REG9_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG9_reg)=data)
+#define get_MIPI_APHY_REG9_reg   (*((volatile unsigned int*) MIPI_APHY_REG9_reg))
+#define MIPI_APHY_REG9_inst_adr                                                      "0x0009"
+#define MIPI_APHY_REG9_inst                                                          0x0009
+#define MIPI_APHY_REG9_HSAMPCK_RL_RG_shift                                           (0)
+#define MIPI_APHY_REG9_HSAMPCK_RL_RG_mask                                            (0x0000003F)
+#define MIPI_APHY_REG9_HSAMPCK_RL_RG(data)                                           (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG9_HSAMPCK_RL_RG_src(data)                                       ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG9_get_HSAMPCK_RL_RG(data)                                       ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG10                                                              0x28
+#define MIPI_APHY_REG10_reg_addr                                                     "0x98004028"
+#define MIPI_APHY_REG10_reg                                                          0x98004028
+#define set_MIPI_APHY_REG10_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG10_reg)=data)
+#define get_MIPI_APHY_REG10_reg   (*((volatile unsigned int*) MIPI_APHY_REG10_reg))
+#define MIPI_APHY_REG10_inst_adr                                                     "0x000A"
+#define MIPI_APHY_REG10_inst                                                         0x000A
+#define MIPI_APHY_REG10_COUNT_RUN_shift                                              (0)
+#define MIPI_APHY_REG10_COUNT_RUN_mask                                               (0x000000FF)
+#define MIPI_APHY_REG10_COUNT_RUN(data)                                              (0x000000FF&((data)<<0))
+#define MIPI_APHY_REG10_COUNT_RUN_src(data)                                          ((0x000000FF&(data))>>0)
+#define MIPI_APHY_REG10_get_COUNT_RUN(data)                                          ((0x000000FF&(data))>>0)
+
+
+#define MIPI_APHY_REG11                                                              0x2C
+#define MIPI_APHY_REG11_reg_addr                                                     "0x9800402C"
+#define MIPI_APHY_REG11_reg                                                          0x9800402C
+#define set_MIPI_APHY_REG11_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG11_reg)=data)
+#define get_MIPI_APHY_REG11_reg   (*((volatile unsigned int*) MIPI_APHY_REG11_reg))
+#define MIPI_APHY_REG11_inst_adr                                                     "0x000B"
+#define MIPI_APHY_REG11_inst                                                         0x000B
+#define MIPI_APHY_REG11_COUNT_RUN_shift                                              (0)
+#define MIPI_APHY_REG11_COUNT_RUN_mask                                               (0x00000001)
+#define MIPI_APHY_REG11_COUNT_RUN(data)                                              (0x00000001&((data)<<0))
+#define MIPI_APHY_REG11_COUNT_RUN_src(data)                                          ((0x00000001&(data))>>0)
+#define MIPI_APHY_REG11_get_COUNT_RUN(data)                                          ((0x00000001&(data))>>0)
+
+
+#define MIPI_APHY_REG12                                                              0x30
+#define MIPI_APHY_REG12_reg_addr                                                     "0x98004030"
+#define MIPI_APHY_REG12_reg                                                          0x98004030
+#define set_MIPI_APHY_REG12_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG12_reg)=data)
+#define get_MIPI_APHY_REG12_reg   (*((volatile unsigned int*) MIPI_APHY_REG12_reg))
+#define MIPI_APHY_REG12_inst_adr                                                     "0x000C"
+#define MIPI_APHY_REG12_inst                                                         0x000C
+#define MIPI_APHY_REG12_COUNT_RT_shift                                               (0)
+#define MIPI_APHY_REG12_COUNT_RT_mask                                                (0x0000007F)
+#define MIPI_APHY_REG12_COUNT_RT(data)                                               (0x0000007F&((data)<<0))
+#define MIPI_APHY_REG12_COUNT_RT_src(data)                                           ((0x0000007F&(data))>>0)
+#define MIPI_APHY_REG12_get_COUNT_RT(data)                                           ((0x0000007F&(data))>>0)
+
+
+#define MIPI_APHY_REG13                                                              0x34
+#define MIPI_APHY_REG13_reg_addr                                                     "0x98004034"
+#define MIPI_APHY_REG13_reg                                                          0x98004034
+#define set_MIPI_APHY_REG13_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG13_reg)=data)
+#define get_MIPI_APHY_REG13_reg   (*((volatile unsigned int*) MIPI_APHY_REG13_reg))
+#define MIPI_APHY_REG13_inst_adr                                                     "0x000D"
+#define MIPI_APHY_REG13_inst                                                         0x000D
+#define MIPI_APHY_REG13_HS_CM_shift                                                  (5)
+#define MIPI_APHY_REG13_HS_CM_mask                                                   (0x000000E0)
+#define MIPI_APHY_REG13_HS_CM(data)                                                  (0x000000E0&((data)<<5))
+#define MIPI_APHY_REG13_HS_CM_src(data)                                              ((0x000000E0&(data))>>5)
+#define MIPI_APHY_REG13_get_HS_CM(data)                                              ((0x000000E0&(data))>>5)
+#define MIPI_APHY_REG13_COUNT_SEL_shift                                              (0)
+#define MIPI_APHY_REG13_COUNT_SEL_mask                                               (0x0000001F)
+#define MIPI_APHY_REG13_COUNT_SEL(data)                                              (0x0000001F&((data)<<0))
+#define MIPI_APHY_REG13_COUNT_SEL_src(data)                                          ((0x0000001F&(data))>>0)
+#define MIPI_APHY_REG13_get_COUNT_SEL(data)                                          ((0x0000001F&(data))>>0)
+
+
+#define MIPI_APHY_REG14                                                              0x38
+#define MIPI_APHY_REG14_reg_addr                                                     "0x98004038"
+#define MIPI_APHY_REG14_reg                                                          0x98004038
+#define set_MIPI_APHY_REG14_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG14_reg)=data)
+#define get_MIPI_APHY_REG14_reg   (*((volatile unsigned int*) MIPI_APHY_REG14_reg))
+#define MIPI_APHY_REG14_inst_adr                                                     "0x000E"
+#define MIPI_APHY_REG14_inst                                                         0x000E
+#define MIPI_APHY_REG14_CMP_REF_shift                                                (4)
+#define MIPI_APHY_REG14_CMP_REF_mask                                                 (0x000000F0)
+#define MIPI_APHY_REG14_CMP_REF(data)                                                (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG14_CMP_REF_src(data)                                            ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG14_get_CMP_REF(data)                                            ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG14_LPAMP_REF_shift                                              (0)
+#define MIPI_APHY_REG14_LPAMP_REF_mask                                               (0x0000000F)
+#define MIPI_APHY_REG14_LPAMP_REF(data)                                              (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG14_LPAMP_REF_src(data)                                          ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG14_get_LPAMP_REF(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG15                                                              0x3C
+#define MIPI_APHY_REG15_reg_addr                                                     "0x9800403C"
+#define MIPI_APHY_REG15_reg                                                          0x9800403C
+#define set_MIPI_APHY_REG15_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG15_reg)=data)
+#define get_MIPI_APHY_REG15_reg   (*((volatile unsigned int*) MIPI_APHY_REG15_reg))
+#define MIPI_APHY_REG15_inst_adr                                                     "0x000F"
+#define MIPI_APHY_REG15_inst                                                         0x000F
+#define MIPI_APHY_REG15_adrst_sel_shift                                              (2)
+#define MIPI_APHY_REG15_adrst_sel_mask                                               (0x0000000C)
+#define MIPI_APHY_REG15_adrst_sel(data)                                              (0x0000000C&((data)<<2))
+#define MIPI_APHY_REG15_adrst_sel_src(data)                                          ((0x0000000C&(data))>>2)
+#define MIPI_APHY_REG15_get_adrst_sel(data)                                          ((0x0000000C&(data))>>2)
+#define MIPI_APHY_REG15_SEL_DIV_RG_shift                                             (0)
+#define MIPI_APHY_REG15_SEL_DIV_RG_mask                                              (0x00000003)
+#define MIPI_APHY_REG15_SEL_DIV_RG(data)                                             (0x00000003&((data)<<0))
+#define MIPI_APHY_REG15_SEL_DIV_RG_src(data)                                         ((0x00000003&(data))>>0)
+#define MIPI_APHY_REG15_get_SEL_DIV_RG(data)                                         ((0x00000003&(data))>>0)
+
+
+#define MIPI_APHY_REG16                                                              0x40
+#define MIPI_APHY_REG16_reg_addr                                                     "0x98004040"
+#define MIPI_APHY_REG16_reg                                                          0x98004040
+#define set_MIPI_APHY_REG16_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG16_reg)=data)
+#define get_MIPI_APHY_REG16_reg   (*((volatile unsigned int*) MIPI_APHY_REG16_reg))
+#define MIPI_APHY_REG16_inst_adr                                                     "0x0010"
+#define MIPI_APHY_REG16_inst                                                         0x0010
+#define MIPI_APHY_REG16_HSAMP3_RL_2RG_shift                                          (0)
+#define MIPI_APHY_REG16_HSAMP3_RL_2RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG16_HSAMP3_RL_2RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG16_HSAMP3_RL_2RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG16_get_HSAMP3_RL_2RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG17                                                              0x44
+#define MIPI_APHY_REG17_reg_addr                                                     "0x98004044"
+#define MIPI_APHY_REG17_reg                                                          0x98004044
+#define set_MIPI_APHY_REG17_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG17_reg)=data)
+#define get_MIPI_APHY_REG17_reg   (*((volatile unsigned int*) MIPI_APHY_REG17_reg))
+#define MIPI_APHY_REG17_inst_adr                                                     "0x0011"
+#define MIPI_APHY_REG17_inst                                                         0x0011
+#define MIPI_APHY_REG17_HSAMP2_RL_2RG_shift                                          (0)
+#define MIPI_APHY_REG17_HSAMP2_RL_2RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG17_HSAMP2_RL_2RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG17_HSAMP2_RL_2RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG17_get_HSAMP2_RL_2RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG18                                                              0x48
+#define MIPI_APHY_REG18_reg_addr                                                     "0x98004048"
+#define MIPI_APHY_REG18_reg                                                          0x98004048
+#define set_MIPI_APHY_REG18_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG18_reg)=data)
+#define get_MIPI_APHY_REG18_reg   (*((volatile unsigned int*) MIPI_APHY_REG18_reg))
+#define MIPI_APHY_REG18_inst_adr                                                     "0x0012"
+#define MIPI_APHY_REG18_inst                                                         0x0012
+#define MIPI_APHY_REG18_HSAMP1_RL_2RG_shift                                          (0)
+#define MIPI_APHY_REG18_HSAMP1_RL_2RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG18_HSAMP1_RL_2RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG18_HSAMP1_RL_2RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG18_get_HSAMP1_RL_2RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG19                                                              0x4C
+#define MIPI_APHY_REG19_reg_addr                                                     "0x9800404C"
+#define MIPI_APHY_REG19_reg                                                          0x9800404C
+#define set_MIPI_APHY_REG19_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG19_reg)=data)
+#define get_MIPI_APHY_REG19_reg   (*((volatile unsigned int*) MIPI_APHY_REG19_reg))
+#define MIPI_APHY_REG19_inst_adr                                                     "0x0013"
+#define MIPI_APHY_REG19_inst                                                         0x0013
+#define MIPI_APHY_REG19_HSAMP0_RL_2RG_shift                                          (0)
+#define MIPI_APHY_REG19_HSAMP0_RL_2RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG19_HSAMP0_RL_2RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG19_HSAMP0_RL_2RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG19_get_HSAMP0_RL_2RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG20                                                              0x50
+#define MIPI_APHY_REG20_reg_addr                                                     "0x98004050"
+#define MIPI_APHY_REG20_reg                                                          0x98004050
+#define set_MIPI_APHY_REG20_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG20_reg)=data)
+#define get_MIPI_APHY_REG20_reg   (*((volatile unsigned int*) MIPI_APHY_REG20_reg))
+#define MIPI_APHY_REG20_inst_adr                                                     "0x0014"
+#define MIPI_APHY_REG20_inst                                                         0x0014
+#define MIPI_APHY_REG20_HSAMPCK_RL_2RG_shift                                         (0)
+#define MIPI_APHY_REG20_HSAMPCK_RL_2RG_mask                                          (0x0000003F)
+#define MIPI_APHY_REG20_HSAMPCK_RL_2RG(data)                                         (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG20_HSAMPCK_RL_2RG_src(data)                                     ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG20_get_HSAMPCK_RL_2RG(data)                                     ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG21                                                              0x54
+#define MIPI_APHY_REG21_reg_addr                                                     "0x98004054"
+#define MIPI_APHY_REG21_reg                                                          0x98004054
+#define set_MIPI_APHY_REG21_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG21_reg)=data)
+#define get_MIPI_APHY_REG21_reg   (*((volatile unsigned int*) MIPI_APHY_REG21_reg))
+#define MIPI_APHY_REG21_inst_adr                                                     "0x0015"
+#define MIPI_APHY_REG21_inst                                                         0x0015
+#define MIPI_APHY_REG21_CLK0_DLY_CODE_2RG_shift                                      (4)
+#define MIPI_APHY_REG21_CLK0_DLY_CODE_2RG_mask                                       (0x000000F0)
+#define MIPI_APHY_REG21_CLK0_DLY_CODE_2RG(data)                                      (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG21_CLK0_DLY_CODE_2RG_src(data)                                  ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG21_get_CLK0_DLY_CODE_2RG(data)                                  ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG21_CLK1_DLY_CODE_2RG_shift                                      (0)
+#define MIPI_APHY_REG21_CLK1_DLY_CODE_2RG_mask                                       (0x0000000F)
+#define MIPI_APHY_REG21_CLK1_DLY_CODE_2RG(data)                                      (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG21_CLK1_DLY_CODE_2RG_src(data)                                  ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG21_get_CLK1_DLY_CODE_2RG(data)                                  ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG22                                                              0x58
+#define MIPI_APHY_REG22_reg_addr                                                     "0x98004058"
+#define MIPI_APHY_REG22_reg                                                          0x98004058
+#define set_MIPI_APHY_REG22_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG22_reg)=data)
+#define get_MIPI_APHY_REG22_reg   (*((volatile unsigned int*) MIPI_APHY_REG22_reg))
+#define MIPI_APHY_REG22_inst_adr                                                     "0x0016"
+#define MIPI_APHY_REG22_inst                                                         0x0016
+#define MIPI_APHY_REG22_CLK2_DLY_CODE_2RG_shift                                      (4)
+#define MIPI_APHY_REG22_CLK2_DLY_CODE_2RG_mask                                       (0x000000F0)
+#define MIPI_APHY_REG22_CLK2_DLY_CODE_2RG(data)                                      (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG22_CLK2_DLY_CODE_2RG_src(data)                                  ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG22_get_CLK2_DLY_CODE_2RG(data)                                  ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG22_CLK3_DLY_CODE_2RG_shift                                      (0)
+#define MIPI_APHY_REG22_CLK3_DLY_CODE_2RG_mask                                       (0x0000000F)
+#define MIPI_APHY_REG22_CLK3_DLY_CODE_2RG(data)                                      (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG22_CLK3_DLY_CODE_2RG_src(data)                                  ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG22_get_CLK3_DLY_CODE_2RG(data)                                  ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG23                                                              0x5C
+#define MIPI_APHY_REG23_reg_addr                                                     "0x9800405C"
+#define MIPI_APHY_REG23_reg                                                          0x9800405C
+#define set_MIPI_APHY_REG23_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG23_reg)=data)
+#define get_MIPI_APHY_REG23_reg   (*((volatile unsigned int*) MIPI_APHY_REG23_reg))
+#define MIPI_APHY_REG23_inst_adr                                                     "0x0017"
+#define MIPI_APHY_REG23_inst                                                         0x0017
+#define MIPI_APHY_REG23_DATA0_DLY_CODE_2RG_shift                                     (4)
+#define MIPI_APHY_REG23_DATA0_DLY_CODE_2RG_mask                                      (0x000000F0)
+#define MIPI_APHY_REG23_DATA0_DLY_CODE_2RG(data)                                     (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG23_DATA0_DLY_CODE_2RG_src(data)                                 ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG23_get_DATA0_DLY_CODE_2RG(data)                                 ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG23_DATA1_DLY_CODE_2RG_shift                                     (0)
+#define MIPI_APHY_REG23_DATA1_DLY_CODE_2RG_mask                                      (0x0000000F)
+#define MIPI_APHY_REG23_DATA1_DLY_CODE_2RG(data)                                     (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG23_DATA1_DLY_CODE_2RG_src(data)                                 ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG23_get_DATA1_DLY_CODE_2RG(data)                                 ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG24                                                              0x60
+#define MIPI_APHY_REG24_reg_addr                                                     "0x98004060"
+#define MIPI_APHY_REG24_reg                                                          0x98004060
+#define set_MIPI_APHY_REG24_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG24_reg)=data)
+#define get_MIPI_APHY_REG24_reg   (*((volatile unsigned int*) MIPI_APHY_REG24_reg))
+#define MIPI_APHY_REG24_inst_adr                                                     "0x0018"
+#define MIPI_APHY_REG24_inst                                                         0x0018
+#define MIPI_APHY_REG24_DATA2_DLY_CODE_2RG_shift                                     (4)
+#define MIPI_APHY_REG24_DATA2_DLY_CODE_2RG_mask                                      (0x000000F0)
+#define MIPI_APHY_REG24_DATA2_DLY_CODE_2RG(data)                                     (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG24_DATA2_DLY_CODE_2RG_src(data)                                 ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG24_get_DATA2_DLY_CODE_2RG(data)                                 ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG24_DATA3_DLY_CODE_2RG_shift                                     (0)
+#define MIPI_APHY_REG24_DATA3_DLY_CODE_2RG_mask                                      (0x0000000F)
+#define MIPI_APHY_REG24_DATA3_DLY_CODE_2RG(data)                                     (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG24_DATA3_DLY_CODE_2RG_src(data)                                 ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG24_get_DATA3_DLY_CODE_2RG(data)                                 ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG25                                                              0x64
+#define MIPI_APHY_REG25_reg_addr                                                     "0x98004064"
+#define MIPI_APHY_REG25_reg                                                          0x98004064
+#define set_MIPI_APHY_REG25_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG25_reg)=data)
+#define get_MIPI_APHY_REG25_reg   (*((volatile unsigned int*) MIPI_APHY_REG25_reg))
+#define MIPI_APHY_REG25_inst_adr                                                     "0x0019"
+#define MIPI_APHY_REG25_inst                                                         0x0019
+#define MIPI_APHY_REG25_R50_CAL_OK_2RG_shift                                         (7)
+#define MIPI_APHY_REG25_R50_CAL_OK_2RG_mask                                          (0x00000080)
+#define MIPI_APHY_REG25_R50_CAL_OK_2RG(data)                                         (0x00000080&((data)<<7))
+#define MIPI_APHY_REG25_R50_CAL_OK_2RG_src(data)                                     ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG25_get_R50_CAL_OK_2RG(data)                                     ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG25_R50_CAL_2RG_shift                                            (0)
+#define MIPI_APHY_REG25_R50_CAL_2RG_mask                                             (0x0000003F)
+#define MIPI_APHY_REG25_R50_CAL_2RG(data)                                            (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG25_R50_CAL_2RG_src(data)                                        ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG25_get_R50_CAL_2RG(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG26                                                              0x68
+#define MIPI_APHY_REG26_reg_addr                                                     "0x98004068"
+#define MIPI_APHY_REG26_reg                                                          0x98004068
+#define set_MIPI_APHY_REG26_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG26_reg)=data)
+#define get_MIPI_APHY_REG26_reg   (*((volatile unsigned int*) MIPI_APHY_REG26_reg))
+#define MIPI_APHY_REG26_inst_adr                                                     "0x001A"
+#define MIPI_APHY_REG26_inst                                                         0x001A
+#define MIPI_APHY_REG26_LANE_OK_shift                                                (0)
+#define MIPI_APHY_REG26_LANE_OK_mask                                                 (0x0000000F)
+#define MIPI_APHY_REG26_LANE_OK(data)                                                (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG26_LANE_OK_src(data)                                            ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG26_get_LANE_OK(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG27                                                              0x84
+#define MIPI_APHY_REG27_reg_addr                                                     "0x98004084"
+#define MIPI_APHY_REG27_reg                                                          0x98004084
+#define set_MIPI_APHY_REG27_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG27_reg)=data)
+#define get_MIPI_APHY_REG27_reg   (*((volatile unsigned int*) MIPI_APHY_REG27_reg))
+#define MIPI_APHY_REG27_inst_adr                                                     "0x0021"
+#define MIPI_APHY_REG27_inst                                                         0x0021
+#define MIPI_APHY_REG27_HSPAMP2_RL_RG_shift                                          (0)
+#define MIPI_APHY_REG27_HSPAMP2_RL_RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG27_HSPAMP2_RL_RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG27_HSPAMP2_RL_RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG27_get_HSPAMP2_RL_RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG28                                                              0x88
+#define MIPI_APHY_REG28_reg_addr                                                     "0x98004088"
+#define MIPI_APHY_REG28_reg                                                          0x98004088
+#define set_MIPI_APHY_REG28_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG28_reg)=data)
+#define get_MIPI_APHY_REG28_reg   (*((volatile unsigned int*) MIPI_APHY_REG28_reg))
+#define MIPI_APHY_REG28_inst_adr                                                     "0x0022"
+#define MIPI_APHY_REG28_inst                                                         0x0022
+#define MIPI_APHY_REG28_HSPAMP3_RL_RG_shift                                          (0)
+#define MIPI_APHY_REG28_HSPAMP3_RL_RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG28_HSPAMP3_RL_RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG28_HSPAMP3_RL_RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG28_get_HSPAMP3_RL_RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/mipi_dphy_reg.h b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/mipi_dphy_reg.h
new file mode 100644
index 00000000..eeb2da4
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/mipi_dphy_reg.h
@@ -0,0 +1,643 @@
+/**************************************************************
+// Spec Version                  : 1.00
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/1/21 17:31:37
+***************************************************************/
+
+
+#ifndef _MIPI_DPHY_REG_H_INCLUDED_
+#define _MIPI_DPHY_REG_H_INCLUDED_
+
+#define MIPI_DPHY_PWDB                                                               0x74
+#define MIPI_DPHY_PWDB_reg_addr                                                      "0x98004074"
+#define MIPI_DPHY_PWDB_reg                                                           0x98004074
+#define set_MIPI_DPHY_PWDB_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_PWDB_reg)=data)
+#define get_MIPI_DPHY_PWDB_reg   (*((volatile unsigned int*) MIPI_DPHY_PWDB_reg))
+#define MIPI_DPHY_PWDB_inst_adr                                                      "0x001D"
+#define MIPI_DPHY_PWDB_inst                                                          0x001D
+#define MIPI_DPHY_PWDB_L3_pwdb_shift                                                 (3)
+#define MIPI_DPHY_PWDB_L3_pwdb_mask                                                  (0x00000008)
+#define MIPI_DPHY_PWDB_L3_pwdb(data)                                                 (0x00000008&((data)<<3))
+#define MIPI_DPHY_PWDB_L3_pwdb_src(data)                                             ((0x00000008&(data))>>3)
+#define MIPI_DPHY_PWDB_get_L3_pwdb(data)                                             ((0x00000008&(data))>>3)
+#define MIPI_DPHY_PWDB_L2_pwdb_shift                                                 (2)
+#define MIPI_DPHY_PWDB_L2_pwdb_mask                                                  (0x00000004)
+#define MIPI_DPHY_PWDB_L2_pwdb(data)                                                 (0x00000004&((data)<<2))
+#define MIPI_DPHY_PWDB_L2_pwdb_src(data)                                             ((0x00000004&(data))>>2)
+#define MIPI_DPHY_PWDB_get_L2_pwdb(data)                                             ((0x00000004&(data))>>2)
+#define MIPI_DPHY_PWDB_L1_pwdb_shift                                                 (1)
+#define MIPI_DPHY_PWDB_L1_pwdb_mask                                                  (0x00000002)
+#define MIPI_DPHY_PWDB_L1_pwdb(data)                                                 (0x00000002&((data)<<1))
+#define MIPI_DPHY_PWDB_L1_pwdb_src(data)                                             ((0x00000002&(data))>>1)
+#define MIPI_DPHY_PWDB_get_L1_pwdb(data)                                             ((0x00000002&(data))>>1)
+#define MIPI_DPHY_PWDB_L0_pwdb_shift                                                 (0)
+#define MIPI_DPHY_PWDB_L0_pwdb_mask                                                  (0x00000001)
+#define MIPI_DPHY_PWDB_L0_pwdb(data)                                                 (0x00000001&((data)<<0))
+#define MIPI_DPHY_PWDB_L0_pwdb_src(data)                                             ((0x00000001&(data))>>0)
+#define MIPI_DPHY_PWDB_get_L0_pwdb(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_RXPRE                                                              0x78
+#define MIPI_DPHY_RXPRE_reg_addr                                                     "0x98004078"
+#define MIPI_DPHY_RXPRE_reg                                                          0x98004078
+#define set_MIPI_DPHY_RXPRE_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_RXPRE_reg)=data)
+#define get_MIPI_DPHY_RXPRE_reg   (*((volatile unsigned int*) MIPI_DPHY_RXPRE_reg))
+#define MIPI_DPHY_RXPRE_inst_adr                                                     "0x001E"
+#define MIPI_DPHY_RXPRE_inst                                                         0x001E
+#define MIPI_DPHY_RXPRE_rxpre_lane_shift                                             (0)
+#define MIPI_DPHY_RXPRE_rxpre_lane_mask                                              (0x000000FF)
+#define MIPI_DPHY_RXPRE_rxpre_lane(data)                                             (0x000000FF&((data)<<0))
+#define MIPI_DPHY_RXPRE_rxpre_lane_src(data)                                         ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_RXPRE_get_rxpre_lane(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_RXPOS                                                              0x7C
+#define MIPI_DPHY_RXPOS_reg_addr                                                     "0x9800407C"
+#define MIPI_DPHY_RXPOS_reg                                                          0x9800407C
+#define set_MIPI_DPHY_RXPOS_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_RXPOS_reg)=data)
+#define get_MIPI_DPHY_RXPOS_reg   (*((volatile unsigned int*) MIPI_DPHY_RXPOS_reg))
+#define MIPI_DPHY_RXPOS_inst_adr                                                     "0x001F"
+#define MIPI_DPHY_RXPOS_inst                                                         0x001F
+#define MIPI_DPHY_RXPOS_rxpos_lane_shift                                             (0)
+#define MIPI_DPHY_RXPOS_rxpos_lane_mask                                              (0x000000FF)
+#define MIPI_DPHY_RXPOS_rxpos_lane(data)                                             (0x000000FF&((data)<<0))
+#define MIPI_DPHY_RXPOS_rxpos_lane_src(data)                                         ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_RXPOS_get_rxpos_lane(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG0                                                               0x80
+#define MIPI_DPHY_REG0_reg_addr                                                      "0x98004080"
+#define MIPI_DPHY_REG0_reg                                                           0x98004080
+#define set_MIPI_DPHY_REG0_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG0_reg)=data)
+#define get_MIPI_DPHY_REG0_reg   (*((volatile unsigned int*) MIPI_DPHY_REG0_reg))
+#define MIPI_DPHY_REG0_inst_adr                                                      "0x0020"
+#define MIPI_DPHY_REG0_inst                                                          0x0020
+#define MIPI_DPHY_REG0_Div_sel_shift                                                 (6)
+#define MIPI_DPHY_REG0_Div_sel_mask                                                  (0x000000C0)
+#define MIPI_DPHY_REG0_Div_sel(data)                                                 (0x000000C0&((data)<<6))
+#define MIPI_DPHY_REG0_Div_sel_src(data)                                             ((0x000000C0&(data))>>6)
+#define MIPI_DPHY_REG0_get_Div_sel(data)                                             ((0x000000C0&(data))>>6)
+#define MIPI_DPHY_REG0_drst_sel_shift                                                (4)
+#define MIPI_DPHY_REG0_drst_sel_mask                                                 (0x00000010)
+#define MIPI_DPHY_REG0_drst_sel(data)                                                (0x00000010&((data)<<4))
+#define MIPI_DPHY_REG0_drst_sel_src(data)                                            ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG0_get_drst_sel(data)                                            ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG0_Lane3_en_shift                                                (3)
+#define MIPI_DPHY_REG0_Lane3_en_mask                                                 (0x00000008)
+#define MIPI_DPHY_REG0_Lane3_en(data)                                                (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG0_Lane3_en_src(data)                                            ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG0_get_Lane3_en(data)                                            ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG0_Lane2_en_shift                                                (2)
+#define MIPI_DPHY_REG0_Lane2_en_mask                                                 (0x00000004)
+#define MIPI_DPHY_REG0_Lane2_en(data)                                                (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG0_Lane2_en_src(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG0_get_Lane2_en(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG0_Lane1_en_shift                                                (1)
+#define MIPI_DPHY_REG0_Lane1_en_mask                                                 (0x00000002)
+#define MIPI_DPHY_REG0_Lane1_en(data)                                                (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG0_Lane1_en_src(data)                                            ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG0_get_Lane1_en(data)                                            ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG0_Lane0_en_shift                                                (0)
+#define MIPI_DPHY_REG0_Lane0_en_mask                                                 (0x00000001)
+#define MIPI_DPHY_REG0_Lane0_en(data)                                                (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG0_Lane0_en_src(data)                                            ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG0_get_Lane0_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG1                                                               0x8C
+#define MIPI_DPHY_REG1_reg_addr                                                      "0x9800408C"
+#define MIPI_DPHY_REG1_reg                                                           0x9800408C
+#define set_MIPI_DPHY_REG1_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG1_reg)=data)
+#define get_MIPI_DPHY_REG1_reg   (*((volatile unsigned int*) MIPI_DPHY_REG1_reg))
+#define MIPI_DPHY_REG1_inst_adr                                                      "0x0023"
+#define MIPI_DPHY_REG1_inst                                                          0x0023
+#define MIPI_DPHY_REG1_yuv_src_sel_shift                                             (4)
+#define MIPI_DPHY_REG1_yuv_src_sel_mask                                              (0x00000030)
+#define MIPI_DPHY_REG1_yuv_src_sel(data)                                             (0x00000030&((data)<<4))
+#define MIPI_DPHY_REG1_yuv_src_sel_src(data)                                         ((0x00000030&(data))>>4)
+#define MIPI_DPHY_REG1_get_yuv_src_sel(data)                                         ((0x00000030&(data))>>4)
+#define MIPI_DPHY_REG1_dec_format_shift                                              (0)
+#define MIPI_DPHY_REG1_dec_format_mask                                               (0x00000007)
+#define MIPI_DPHY_REG1_dec_format(data)                                              (0x00000007&((data)<<0))
+#define MIPI_DPHY_REG1_dec_format_src(data)                                          ((0x00000007&(data))>>0)
+#define MIPI_DPHY_REG1_get_dec_format(data)                                          ((0x00000007&(data))>>0)
+
+
+#define MIPI_DPHY_REG2                                                               0x90
+#define MIPI_DPHY_REG2_reg_addr                                                      "0x98004090"
+#define MIPI_DPHY_REG2_reg                                                           0x98004090
+#define set_MIPI_DPHY_REG2_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG2_reg)=data)
+#define get_MIPI_DPHY_REG2_reg   (*((volatile unsigned int*) MIPI_DPHY_REG2_reg))
+#define MIPI_DPHY_REG2_inst_adr                                                      "0x0024"
+#define MIPI_DPHY_REG2_inst                                                          0x0024
+#define MIPI_DPHY_REG2_D_type_shift                                                  (0)
+#define MIPI_DPHY_REG2_D_type_mask                                                   (0x000000FF)
+#define MIPI_DPHY_REG2_D_type(data)                                                  (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG2_D_type_src(data)                                              ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG2_get_D_type(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG3                                                               0x94
+#define MIPI_DPHY_REG3_reg_addr                                                      "0x98004094"
+#define MIPI_DPHY_REG3_reg                                                           0x98004094
+#define set_MIPI_DPHY_REG3_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG3_reg)=data)
+#define get_MIPI_DPHY_REG3_reg   (*((volatile unsigned int*) MIPI_DPHY_REG3_reg))
+#define MIPI_DPHY_REG3_inst_adr                                                      "0x0025"
+#define MIPI_DPHY_REG3_inst                                                          0x0025
+#define MIPI_DPHY_REG3_D_type_shift                                                  (4)
+#define MIPI_DPHY_REG3_D_type_mask                                                   (0x00000010)
+#define MIPI_DPHY_REG3_D_type(data)                                                  (0x00000010&((data)<<4))
+#define MIPI_DPHY_REG3_D_type_src(data)                                              ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG3_get_D_type(data)                                              ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG3_L3_deglitch_shift                                             (3)
+#define MIPI_DPHY_REG3_L3_deglitch_mask                                              (0x00000008)
+#define MIPI_DPHY_REG3_L3_deglitch(data)                                             (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG3_L3_deglitch_src(data)                                         ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG3_get_L3_deglitch(data)                                         ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG3_L2_deglitch_shift                                             (2)
+#define MIPI_DPHY_REG3_L2_deglitch_mask                                              (0x00000004)
+#define MIPI_DPHY_REG3_L2_deglitch(data)                                             (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG3_L2_deglitch_src(data)                                         ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG3_get_L2_deglitch(data)                                         ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG3_L1_deglitch_shift                                             (1)
+#define MIPI_DPHY_REG3_L1_deglitch_mask                                              (0x00000002)
+#define MIPI_DPHY_REG3_L1_deglitch(data)                                             (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG3_L1_deglitch_src(data)                                         ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG3_get_L1_deglitch(data)                                         ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG3_L0_deglitch_shift                                             (0)
+#define MIPI_DPHY_REG3_L0_deglitch_mask                                              (0x00000001)
+#define MIPI_DPHY_REG3_L0_deglitch(data)                                             (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG3_L0_deglitch_src(data)                                         ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG3_get_L0_deglitch(data)                                         ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG4                                                               0x98
+#define MIPI_DPHY_REG4_reg_addr                                                      "0x98004098"
+#define MIPI_DPHY_REG4_reg                                                           0x98004098
+#define set_MIPI_DPHY_REG4_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG4_reg)=data)
+#define get_MIPI_DPHY_REG4_reg   (*((volatile unsigned int*) MIPI_DPHY_REG4_reg))
+#define MIPI_DPHY_REG4_inst_adr                                                      "0x0026"
+#define MIPI_DPHY_REG4_inst                                                          0x0026
+#define MIPI_DPHY_REG4_SL_RG_shift                                                   (3)
+#define MIPI_DPHY_REG4_SL_RG_mask                                                    (0x00000008)
+#define MIPI_DPHY_REG4_SL_RG(data)                                                   (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG4_SL_RG_src(data)                                               ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG4_get_SL_RG(data)                                               ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG4_Sw_rst_shift                                                  (0)
+#define MIPI_DPHY_REG4_Sw_rst_mask                                                   (0x00000001)
+#define MIPI_DPHY_REG4_Sw_rst(data)                                                  (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG4_Sw_rst_src(data)                                              ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG4_get_Sw_rst(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG5                                                               0x9C
+#define MIPI_DPHY_REG5_reg_addr                                                      "0x9800409C"
+#define MIPI_DPHY_REG5_reg                                                           0x9800409C
+#define set_MIPI_DPHY_REG5_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG5_reg)=data)
+#define get_MIPI_DPHY_REG5_reg   (*((volatile unsigned int*) MIPI_DPHY_REG5_reg))
+#define MIPI_DPHY_REG5_inst_adr                                                      "0x0027"
+#define MIPI_DPHY_REG5_inst                                                          0x0027
+#define MIPI_DPHY_REG5_Bit_switch_en_shift                                           (3)
+#define MIPI_DPHY_REG5_Bit_switch_en_mask                                            (0x00000008)
+#define MIPI_DPHY_REG5_Bit_switch_en(data)                                           (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG5_Bit_switch_en_src(data)                                       ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG5_get_Bit_switch_en(data)                                       ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG5_Crc16_en_shift                                                (2)
+#define MIPI_DPHY_REG5_Crc16_en_mask                                                 (0x00000004)
+#define MIPI_DPHY_REG5_Crc16_en(data)                                                (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG5_Crc16_en_src(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG5_get_Crc16_en(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG5_Ecc_en_shift                                                  (1)
+#define MIPI_DPHY_REG5_Ecc_en_mask                                                   (0x00000002)
+#define MIPI_DPHY_REG5_Ecc_en(data)                                                  (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG5_Ecc_en_src(data)                                              ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG5_get_Ecc_en(data)                                              ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG5_Con_clk_lane_en_shift                                         (0)
+#define MIPI_DPHY_REG5_Con_clk_lane_en_mask                                          (0x00000001)
+#define MIPI_DPHY_REG5_Con_clk_lane_en(data)                                         (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG5_Con_clk_lane_en_src(data)                                     ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG5_get_Con_clk_lane_en(data)                                     ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG6                                                               0xA0
+#define MIPI_DPHY_REG6_reg_addr                                                      "0x980040A0"
+#define MIPI_DPHY_REG6_reg                                                           0x980040A0
+#define set_MIPI_DPHY_REG6_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG6_reg)=data)
+#define get_MIPI_DPHY_REG6_reg   (*((volatile unsigned int*) MIPI_DPHY_REG6_reg))
+#define MIPI_DPHY_REG6_inst_adr                                                      "0x0028"
+#define MIPI_DPHY_REG6_inst                                                          0x0028
+#define MIPI_DPHY_REG6_Dvld_lane1_shift                                              (4)
+#define MIPI_DPHY_REG6_Dvld_lane1_mask                                               (0x000000F0)
+#define MIPI_DPHY_REG6_Dvld_lane1(data)                                              (0x000000F0&((data)<<4))
+#define MIPI_DPHY_REG6_Dvld_lane1_src(data)                                          ((0x000000F0&(data))>>4)
+#define MIPI_DPHY_REG6_get_Dvld_lane1(data)                                          ((0x000000F0&(data))>>4)
+#define MIPI_DPHY_REG6_Dvld_lane0_shift                                              (0)
+#define MIPI_DPHY_REG6_Dvld_lane0_mask                                               (0x0000000F)
+#define MIPI_DPHY_REG6_Dvld_lane0(data)                                              (0x0000000F&((data)<<0))
+#define MIPI_DPHY_REG6_Dvld_lane0_src(data)                                          ((0x0000000F&(data))>>0)
+#define MIPI_DPHY_REG6_get_Dvld_lane0(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define MIPI_DPHY_REG7                                                               0xA4
+#define MIPI_DPHY_REG7_reg_addr                                                      "0x980040A4"
+#define MIPI_DPHY_REG7_reg                                                           0x980040A4
+#define set_MIPI_DPHY_REG7_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG7_reg)=data)
+#define get_MIPI_DPHY_REG7_reg   (*((volatile unsigned int*) MIPI_DPHY_REG7_reg))
+#define MIPI_DPHY_REG7_inst_adr                                                      "0x0029"
+#define MIPI_DPHY_REG7_inst                                                          0x0029
+#define MIPI_DPHY_REG7_Dvld_lane3_shift                                              (4)
+#define MIPI_DPHY_REG7_Dvld_lane3_mask                                               (0x000000F0)
+#define MIPI_DPHY_REG7_Dvld_lane3(data)                                              (0x000000F0&((data)<<4))
+#define MIPI_DPHY_REG7_Dvld_lane3_src(data)                                          ((0x000000F0&(data))>>4)
+#define MIPI_DPHY_REG7_get_Dvld_lane3(data)                                          ((0x000000F0&(data))>>4)
+#define MIPI_DPHY_REG7_Dvld_lane2_shift                                              (0)
+#define MIPI_DPHY_REG7_Dvld_lane2_mask                                               (0x0000000F)
+#define MIPI_DPHY_REG7_Dvld_lane2(data)                                              (0x0000000F&((data)<<0))
+#define MIPI_DPHY_REG7_Dvld_lane2_src(data)                                          ((0x0000000F&(data))>>0)
+#define MIPI_DPHY_REG7_get_Dvld_lane2(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define MIPI_DPHY_REG8                                                               0xA8
+#define MIPI_DPHY_REG8_reg_addr                                                      "0x980040A8"
+#define MIPI_DPHY_REG8_reg                                                           0x980040A8
+#define set_MIPI_DPHY_REG8_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG8_reg)=data)
+#define get_MIPI_DPHY_REG8_reg   (*((volatile unsigned int*) MIPI_DPHY_REG8_reg))
+#define MIPI_DPHY_REG8_inst_adr                                                      "0x002A"
+#define MIPI_DPHY_REG8_inst                                                          0x002A
+#define MIPI_DPHY_REG8_Lane3_sel_shift                                               (6)
+#define MIPI_DPHY_REG8_Lane3_sel_mask                                                (0x000000C0)
+#define MIPI_DPHY_REG8_Lane3_sel(data)                                               (0x000000C0&((data)<<6))
+#define MIPI_DPHY_REG8_Lane3_sel_src(data)                                           ((0x000000C0&(data))>>6)
+#define MIPI_DPHY_REG8_get_Lane3_sel(data)                                           ((0x000000C0&(data))>>6)
+#define MIPI_DPHY_REG8_Lane2_sel_shift                                               (4)
+#define MIPI_DPHY_REG8_Lane2_sel_mask                                                (0x00000030)
+#define MIPI_DPHY_REG8_Lane2_sel(data)                                               (0x00000030&((data)<<4))
+#define MIPI_DPHY_REG8_Lane2_sel_src(data)                                           ((0x00000030&(data))>>4)
+#define MIPI_DPHY_REG8_get_Lane2_sel(data)                                           ((0x00000030&(data))>>4)
+#define MIPI_DPHY_REG8_Lane1_sel_shift                                               (2)
+#define MIPI_DPHY_REG8_Lane1_sel_mask                                                (0x0000000C)
+#define MIPI_DPHY_REG8_Lane1_sel(data)                                               (0x0000000C&((data)<<2))
+#define MIPI_DPHY_REG8_Lane1_sel_src(data)                                           ((0x0000000C&(data))>>2)
+#define MIPI_DPHY_REG8_get_Lane1_sel(data)                                           ((0x0000000C&(data))>>2)
+#define MIPI_DPHY_REG8_Lane0_sel_shift                                               (0)
+#define MIPI_DPHY_REG8_Lane0_sel_mask                                                (0x00000003)
+#define MIPI_DPHY_REG8_Lane0_sel(data)                                               (0x00000003&((data)<<0))
+#define MIPI_DPHY_REG8_Lane0_sel_src(data)                                           ((0x00000003&(data))>>0)
+#define MIPI_DPHY_REG8_get_Lane0_sel(data)                                           ((0x00000003&(data))>>0)
+
+
+#define MIPI_DPHY_REG9                                                               0xAC
+#define MIPI_DPHY_REG9_reg_addr                                                      "0x980040AC"
+#define MIPI_DPHY_REG9_reg                                                           0x980040AC
+#define set_MIPI_DPHY_REG9_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG9_reg)=data)
+#define get_MIPI_DPHY_REG9_reg   (*((volatile unsigned int*) MIPI_DPHY_REG9_reg))
+#define MIPI_DPHY_REG9_inst_adr                                                      "0x002B"
+#define MIPI_DPHY_REG9_inst                                                          0x002B
+#define MIPI_DPHY_REG9_Lane3_clk_edge_shift                                          (3)
+#define MIPI_DPHY_REG9_Lane3_clk_edge_mask                                           (0x00000008)
+#define MIPI_DPHY_REG9_Lane3_clk_edge(data)                                          (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG9_Lane3_clk_edge_src(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG9_get_Lane3_clk_edge(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG9_Lane2_clk_edge_shift                                          (2)
+#define MIPI_DPHY_REG9_Lane2_clk_edge_mask                                           (0x00000004)
+#define MIPI_DPHY_REG9_Lane2_clk_edge(data)                                          (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG9_Lane2_clk_edge_src(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG9_get_Lane2_clk_edge(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG9_Lane1_clk_edge_shift                                          (1)
+#define MIPI_DPHY_REG9_Lane1_clk_edge_mask                                           (0x00000002)
+#define MIPI_DPHY_REG9_Lane1_clk_edge(data)                                          (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG9_Lane1_clk_edge_src(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG9_get_Lane1_clk_edge(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG9_Lane0_clk_edge_shift                                          (0)
+#define MIPI_DPHY_REG9_Lane0_clk_edge_mask                                           (0x00000001)
+#define MIPI_DPHY_REG9_Lane0_clk_edge(data)                                          (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG9_Lane0_clk_edge_src(data)                                      ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG9_get_Lane0_clk_edge(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG10                                                              0xB0
+#define MIPI_DPHY_REG10_reg_addr                                                     "0x980040B0"
+#define MIPI_DPHY_REG10_reg                                                          0x980040B0
+#define set_MIPI_DPHY_REG10_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG10_reg)=data)
+#define get_MIPI_DPHY_REG10_reg   (*((volatile unsigned int*) MIPI_DPHY_REG10_reg))
+#define MIPI_DPHY_REG10_inst_adr                                                     "0x002C"
+#define MIPI_DPHY_REG10_inst                                                         0x002C
+#define MIPI_DPHY_REG10_Esc_lane3_int_en_shift                                       (7)
+#define MIPI_DPHY_REG10_Esc_lane3_int_en_mask                                        (0x00000080)
+#define MIPI_DPHY_REG10_Esc_lane3_int_en(data)                                       (0x00000080&((data)<<7))
+#define MIPI_DPHY_REG10_Esc_lane3_int_en_src(data)                                   ((0x00000080&(data))>>7)
+#define MIPI_DPHY_REG10_get_Esc_lane3_int_en(data)                                   ((0x00000080&(data))>>7)
+#define MIPI_DPHY_REG10_Esc_lane2_int_en_shift                                       (6)
+#define MIPI_DPHY_REG10_Esc_lane2_int_en_mask                                        (0x00000040)
+#define MIPI_DPHY_REG10_Esc_lane2_int_en(data)                                       (0x00000040&((data)<<6))
+#define MIPI_DPHY_REG10_Esc_lane2_int_en_src(data)                                   ((0x00000040&(data))>>6)
+#define MIPI_DPHY_REG10_get_Esc_lane2_int_en(data)                                   ((0x00000040&(data))>>6)
+#define MIPI_DPHY_REG10_Esc_lane1_int_en_shift                                       (5)
+#define MIPI_DPHY_REG10_Esc_lane1_int_en_mask                                        (0x00000020)
+#define MIPI_DPHY_REG10_Esc_lane1_int_en(data)                                       (0x00000020&((data)<<5))
+#define MIPI_DPHY_REG10_Esc_lane1_int_en_src(data)                                   ((0x00000020&(data))>>5)
+#define MIPI_DPHY_REG10_get_Esc_lane1_int_en(data)                                   ((0x00000020&(data))>>5)
+#define MIPI_DPHY_REG10_Esc_lane0_int_en_shift                                       (4)
+#define MIPI_DPHY_REG10_Esc_lane0_int_en_mask                                        (0x00000010)
+#define MIPI_DPHY_REG10_Esc_lane0_int_en(data)                                       (0x00000010&((data)<<4))
+#define MIPI_DPHY_REG10_Esc_lane0_int_en_src(data)                                   ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG10_get_Esc_lane0_int_en(data)                                   ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG10_Clk_ulps_int_en_shift                                        (3)
+#define MIPI_DPHY_REG10_Clk_ulps_int_en_mask                                         (0x00000008)
+#define MIPI_DPHY_REG10_Clk_ulps_int_en(data)                                        (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG10_Clk_ulps_int_en_src(data)                                    ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG10_get_Clk_ulps_int_en(data)                                    ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG10_Crc16_err_int_en_shift                                       (2)
+#define MIPI_DPHY_REG10_Crc16_err_int_en_mask                                        (0x00000004)
+#define MIPI_DPHY_REG10_Crc16_err_int_en(data)                                       (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG10_Crc16_err_int_en_src(data)                                   ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG10_get_Crc16_err_int_en(data)                                   ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG10_Ecc_crt_int_en_shift                                         (1)
+#define MIPI_DPHY_REG10_Ecc_crt_int_en_mask                                          (0x00000002)
+#define MIPI_DPHY_REG10_Ecc_crt_int_en(data)                                         (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG10_Ecc_crt_int_en_src(data)                                     ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG10_get_Ecc_crt_int_en(data)                                     ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG10_Ecc_err_int_en_shift                                         (0)
+#define MIPI_DPHY_REG10_Ecc_err_int_en_mask                                          (0x00000001)
+#define MIPI_DPHY_REG10_Ecc_err_int_en(data)                                         (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG10_Ecc_err_int_en_src(data)                                     ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG10_get_Ecc_err_int_en(data)                                     ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG11                                                              0xB4
+#define MIPI_DPHY_REG11_reg_addr                                                     "0x980040B4"
+#define MIPI_DPHY_REG11_reg                                                          0x980040B4
+#define set_MIPI_DPHY_REG11_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG11_reg)=data)
+#define get_MIPI_DPHY_REG11_reg   (*((volatile unsigned int*) MIPI_DPHY_REG11_reg))
+#define MIPI_DPHY_REG11_inst_adr                                                     "0x002D"
+#define MIPI_DPHY_REG11_inst                                                         0x002D
+#define MIPI_DPHY_REG11_Esc_lane3_int_flg_shift                                      (7)
+#define MIPI_DPHY_REG11_Esc_lane3_int_flg_mask                                       (0x00000080)
+#define MIPI_DPHY_REG11_Esc_lane3_int_flg(data)                                      (0x00000080&((data)<<7))
+#define MIPI_DPHY_REG11_Esc_lane3_int_flg_src(data)                                  ((0x00000080&(data))>>7)
+#define MIPI_DPHY_REG11_get_Esc_lane3_int_flg(data)                                  ((0x00000080&(data))>>7)
+#define MIPI_DPHY_REG11_Esc_lane2_int_flg_shift                                      (6)
+#define MIPI_DPHY_REG11_Esc_lane2_int_flg_mask                                       (0x00000040)
+#define MIPI_DPHY_REG11_Esc_lane2_int_flg(data)                                      (0x00000040&((data)<<6))
+#define MIPI_DPHY_REG11_Esc_lane2_int_flg_src(data)                                  ((0x00000040&(data))>>6)
+#define MIPI_DPHY_REG11_get_Esc_lane2_int_flg(data)                                  ((0x00000040&(data))>>6)
+#define MIPI_DPHY_REG11_Esc_lane1_int_flg_shift                                      (5)
+#define MIPI_DPHY_REG11_Esc_lane1_int_flg_mask                                       (0x00000020)
+#define MIPI_DPHY_REG11_Esc_lane1_int_flg(data)                                      (0x00000020&((data)<<5))
+#define MIPI_DPHY_REG11_Esc_lane1_int_flg_src(data)                                  ((0x00000020&(data))>>5)
+#define MIPI_DPHY_REG11_get_Esc_lane1_int_flg(data)                                  ((0x00000020&(data))>>5)
+#define MIPI_DPHY_REG11_Esc_lane0_int_flg_shift                                      (4)
+#define MIPI_DPHY_REG11_Esc_lane0_int_flg_mask                                       (0x00000010)
+#define MIPI_DPHY_REG11_Esc_lane0_int_flg(data)                                      (0x00000010&((data)<<4))
+#define MIPI_DPHY_REG11_Esc_lane0_int_flg_src(data)                                  ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG11_get_Esc_lane0_int_flg(data)                                  ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG11_Clk_ulps_int_flg_shift                                       (3)
+#define MIPI_DPHY_REG11_Clk_ulps_int_flg_mask                                        (0x00000008)
+#define MIPI_DPHY_REG11_Clk_ulps_int_flg(data)                                       (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG11_Clk_ulps_int_flg_src(data)                                   ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG11_get_Clk_ulps_int_flg(data)                                   ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG11_Crc16_err_int_flg_shift                                      (2)
+#define MIPI_DPHY_REG11_Crc16_err_int_flg_mask                                       (0x00000004)
+#define MIPI_DPHY_REG11_Crc16_err_int_flg(data)                                      (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG11_Crc16_err_int_flg_src(data)                                  ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG11_get_Crc16_err_int_flg(data)                                  ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG11_Ecc_crt_int_flg_shift                                        (1)
+#define MIPI_DPHY_REG11_Ecc_crt_int_flg_mask                                         (0x00000002)
+#define MIPI_DPHY_REG11_Ecc_crt_int_flg(data)                                        (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG11_Ecc_crt_int_flg_src(data)                                    ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG11_get_Ecc_crt_int_flg(data)                                    ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG11_Ecc_err_int_flg_shift                                        (0)
+#define MIPI_DPHY_REG11_Ecc_err_int_flg_mask                                         (0x00000001)
+#define MIPI_DPHY_REG11_Ecc_err_int_flg(data)                                        (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG11_Ecc_err_int_flg_src(data)                                    ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG11_get_Ecc_err_int_flg(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG12                                                              0xB8
+#define MIPI_DPHY_REG12_reg_addr                                                     "0x980040B8"
+#define MIPI_DPHY_REG12_reg                                                          0x980040B8
+#define set_MIPI_DPHY_REG12_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG12_reg)=data)
+#define get_MIPI_DPHY_REG12_reg   (*((volatile unsigned int*) MIPI_DPHY_REG12_reg))
+#define MIPI_DPHY_REG12_inst_adr                                                     "0x002E"
+#define MIPI_DPHY_REG12_inst                                                         0x002E
+#define MIPI_DPHY_REG12_Num_ecc_err_shift                                            (0)
+#define MIPI_DPHY_REG12_Num_ecc_err_mask                                             (0x000000FF)
+#define MIPI_DPHY_REG12_Num_ecc_err(data)                                            (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG12_Num_ecc_err_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG12_get_Num_ecc_err(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG13                                                              0xBC
+#define MIPI_DPHY_REG13_reg_addr                                                     "0x980040BC"
+#define MIPI_DPHY_REG13_reg                                                          0x980040BC
+#define set_MIPI_DPHY_REG13_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG13_reg)=data)
+#define get_MIPI_DPHY_REG13_reg   (*((volatile unsigned int*) MIPI_DPHY_REG13_reg))
+#define MIPI_DPHY_REG13_inst_adr                                                     "0x002F"
+#define MIPI_DPHY_REG13_inst                                                         0x002F
+#define MIPI_DPHY_REG13_Num_ecc_err_shift                                            (0)
+#define MIPI_DPHY_REG13_Num_ecc_err_mask                                             (0x000000FF)
+#define MIPI_DPHY_REG13_Num_ecc_err(data)                                            (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG13_Num_ecc_err_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG13_get_Num_ecc_err(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG14                                                              0xC0
+#define MIPI_DPHY_REG14_reg_addr                                                     "0x980040C0"
+#define MIPI_DPHY_REG14_reg                                                          0x980040C0
+#define set_MIPI_DPHY_REG14_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG14_reg)=data)
+#define get_MIPI_DPHY_REG14_reg   (*((volatile unsigned int*) MIPI_DPHY_REG14_reg))
+#define MIPI_DPHY_REG14_inst_adr                                                     "0x0030"
+#define MIPI_DPHY_REG14_inst                                                         0x0030
+#define MIPI_DPHY_REG14_Num_crc_err_shift                                            (0)
+#define MIPI_DPHY_REG14_Num_crc_err_mask                                             (0x000000FF)
+#define MIPI_DPHY_REG14_Num_crc_err(data)                                            (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG14_Num_crc_err_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG14_get_Num_crc_err(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG15                                                              0xC4
+#define MIPI_DPHY_REG15_reg_addr                                                     "0x980040C4"
+#define MIPI_DPHY_REG15_reg                                                          0x980040C4
+#define set_MIPI_DPHY_REG15_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG15_reg)=data)
+#define get_MIPI_DPHY_REG15_reg   (*((volatile unsigned int*) MIPI_DPHY_REG15_reg))
+#define MIPI_DPHY_REG15_inst_adr                                                     "0x0031"
+#define MIPI_DPHY_REG15_inst                                                         0x0031
+#define MIPI_DPHY_REG15_Num_crc_err_shift                                            (0)
+#define MIPI_DPHY_REG15_Num_crc_err_mask                                             (0x000000FF)
+#define MIPI_DPHY_REG15_Num_crc_err(data)                                            (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG15_Num_crc_err_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG15_get_Num_crc_err(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG16                                                              0xC8
+#define MIPI_DPHY_REG16_reg_addr                                                     "0x980040C8"
+#define MIPI_DPHY_REG16_reg                                                          0x980040C8
+#define set_MIPI_DPHY_REG16_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG16_reg)=data)
+#define get_MIPI_DPHY_REG16_reg   (*((volatile unsigned int*) MIPI_DPHY_REG16_reg))
+#define MIPI_DPHY_REG16_inst_adr                                                     "0x0032"
+#define MIPI_DPHY_REG16_inst                                                         0x0032
+#define MIPI_DPHY_REG16_Clk_term_en_shift                                            (4)
+#define MIPI_DPHY_REG16_Clk_term_en_mask                                             (0x00000010)
+#define MIPI_DPHY_REG16_Clk_term_en(data)                                            (0x00000010&((data)<<4))
+#define MIPI_DPHY_REG16_Clk_term_en_src(data)                                        ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG16_get_Clk_term_en(data)                                        ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG16_Lane3_term_en_shift                                          (3)
+#define MIPI_DPHY_REG16_Lane3_term_en_mask                                           (0x00000008)
+#define MIPI_DPHY_REG16_Lane3_term_en(data)                                          (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG16_Lane3_term_en_src(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG16_get_Lane3_term_en(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG16_Lane2_term_en_shift                                          (2)
+#define MIPI_DPHY_REG16_Lane2_term_en_mask                                           (0x00000004)
+#define MIPI_DPHY_REG16_Lane2_term_en(data)                                          (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG16_Lane2_term_en_src(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG16_get_Lane2_term_en(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG16_Lane1_term_en_shift                                          (1)
+#define MIPI_DPHY_REG16_Lane1_term_en_mask                                           (0x00000002)
+#define MIPI_DPHY_REG16_Lane1_term_en(data)                                          (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG16_Lane1_term_en_src(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG16_get_Lane1_term_en(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG16_Lane0_term_en_shift                                          (0)
+#define MIPI_DPHY_REG16_Lane0_term_en_mask                                           (0x00000001)
+#define MIPI_DPHY_REG16_Lane0_term_en(data)                                          (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG16_Lane0_term_en_src(data)                                      ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG16_get_Lane0_term_en(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG17                                                              0xCC
+#define MIPI_DPHY_REG17_reg_addr                                                     "0x980040CC"
+#define MIPI_DPHY_REG17_reg                                                          0x980040CC
+#define set_MIPI_DPHY_REG17_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG17_reg)=data)
+#define get_MIPI_DPHY_REG17_reg   (*((volatile unsigned int*) MIPI_DPHY_REG17_reg))
+#define MIPI_DPHY_REG17_inst_adr                                                     "0x0033"
+#define MIPI_DPHY_REG17_inst                                                         0x0033
+#define MIPI_DPHY_REG17_Lane3_pwdb_en_shift                                          (3)
+#define MIPI_DPHY_REG17_Lane3_pwdb_en_mask                                           (0x00000008)
+#define MIPI_DPHY_REG17_Lane3_pwdb_en(data)                                          (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG17_Lane3_pwdb_en_src(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG17_get_Lane3_pwdb_en(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG17_Lane2_pwdb_en_shift                                          (2)
+#define MIPI_DPHY_REG17_Lane2_pwdb_en_mask                                           (0x00000004)
+#define MIPI_DPHY_REG17_Lane2_pwdb_en(data)                                          (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG17_Lane2_pwdb_en_src(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG17_get_Lane2_pwdb_en(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG17_Lane1_pwdb_en_shift                                          (1)
+#define MIPI_DPHY_REG17_Lane1_pwdb_en_mask                                           (0x00000002)
+#define MIPI_DPHY_REG17_Lane1_pwdb_en(data)                                          (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG17_Lane1_pwdb_en_src(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG17_get_Lane1_pwdb_en(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG17_Lane0_pwdb_en_shift                                          (0)
+#define MIPI_DPHY_REG17_Lane0_pwdb_en_mask                                           (0x00000001)
+#define MIPI_DPHY_REG17_Lane0_pwdb_en(data)                                          (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG17_Lane0_pwdb_en_src(data)                                      ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG17_get_Lane0_pwdb_en(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG18                                                              0xD0
+#define MIPI_DPHY_REG18_reg_addr                                                     "0x980040D0"
+#define MIPI_DPHY_REG18_reg                                                          0x980040D0
+#define set_MIPI_DPHY_REG18_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG18_reg)=data)
+#define get_MIPI_DPHY_REG18_reg   (*((volatile unsigned int*) MIPI_DPHY_REG18_reg))
+#define MIPI_DPHY_REG18_inst_adr                                                     "0x0034"
+#define MIPI_DPHY_REG18_inst                                                         0x0034
+
+
+#define MIPI_DPHY_REG19                                                              0xD4
+#define MIPI_DPHY_REG19_reg_addr                                                     "0x980040D4"
+#define MIPI_DPHY_REG19_reg                                                          0x980040D4
+#define set_MIPI_DPHY_REG19_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG19_reg)=data)
+#define get_MIPI_DPHY_REG19_reg   (*((volatile unsigned int*) MIPI_DPHY_REG19_reg))
+#define MIPI_DPHY_REG19_inst_adr                                                     "0x0035"
+#define MIPI_DPHY_REG19_inst                                                         0x0035
+
+
+#define MIPI_DPHY_REG20                                                              0xD8
+#define MIPI_DPHY_REG20_reg_addr                                                     "0x980040D8"
+#define MIPI_DPHY_REG20_reg                                                          0x980040D8
+#define set_MIPI_DPHY_REG20_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG20_reg)=data)
+#define get_MIPI_DPHY_REG20_reg   (*((volatile unsigned int*) MIPI_DPHY_REG20_reg))
+#define MIPI_DPHY_REG20_inst_adr                                                     "0x0036"
+#define MIPI_DPHY_REG20_inst                                                         0x0036
+#define MIPI_DPHY_REG20_mipi_dbg_sel_shift                                           (0)
+#define MIPI_DPHY_REG20_mipi_dbg_sel_mask                                            (0x0000000F)
+#define MIPI_DPHY_REG20_mipi_dbg_sel(data)                                           (0x0000000F&((data)<<0))
+#define MIPI_DPHY_REG20_mipi_dbg_sel_src(data)                                       ((0x0000000F&(data))>>0)
+#define MIPI_DPHY_REG20_get_mipi_dbg_sel(data)                                       ((0x0000000F&(data))>>0)
+
+
+#define MIPI_DPHY_REG21                                                              0xDC
+#define MIPI_DPHY_REG21_reg_addr                                                     "0x980040DC"
+#define MIPI_DPHY_REG21_reg                                                          0x980040DC
+#define set_MIPI_DPHY_REG21_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG21_reg)=data)
+#define get_MIPI_DPHY_REG21_reg   (*((volatile unsigned int*) MIPI_DPHY_REG21_reg))
+#define MIPI_DPHY_REG21_inst_adr                                                     "0x0037"
+#define MIPI_DPHY_REG21_inst                                                         0x0037
+#define MIPI_DPHY_REG21_merge_ovfl_cnt_shift                                         (0)
+#define MIPI_DPHY_REG21_merge_ovfl_cnt_mask                                          (0x000000FF)
+#define MIPI_DPHY_REG21_merge_ovfl_cnt(data)                                         (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG21_merge_ovfl_cnt_src(data)                                     ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG21_get_merge_ovfl_cnt(data)                                     ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG22                                                              0xE0
+#define MIPI_DPHY_REG22_reg_addr                                                     "0x980040E0"
+#define MIPI_DPHY_REG22_reg                                                          0x980040E0
+#define set_MIPI_DPHY_REG22_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG22_reg)=data)
+#define get_MIPI_DPHY_REG22_reg   (*((volatile unsigned int*) MIPI_DPHY_REG22_reg))
+#define MIPI_DPHY_REG22_inst_adr                                                     "0x0038"
+#define MIPI_DPHY_REG22_inst                                                         0x0038
+#define MIPI_DPHY_REG22_Lane0_esc_cod_shift                                          (0)
+#define MIPI_DPHY_REG22_Lane0_esc_cod_mask                                           (0x000000FF)
+#define MIPI_DPHY_REG22_Lane0_esc_cod(data)                                          (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG22_Lane0_esc_cod_src(data)                                      ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG22_get_Lane0_esc_cod(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG23                                                              0xE4
+#define MIPI_DPHY_REG23_reg_addr                                                     "0x980040E4"
+#define MIPI_DPHY_REG23_reg                                                          0x980040E4
+#define set_MIPI_DPHY_REG23_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG23_reg)=data)
+#define get_MIPI_DPHY_REG23_reg   (*((volatile unsigned int*) MIPI_DPHY_REG23_reg))
+#define MIPI_DPHY_REG23_inst_adr                                                     "0x0039"
+#define MIPI_DPHY_REG23_inst                                                         0x0039
+#define MIPI_DPHY_REG23_Lane1_esc_cod_shift                                          (0)
+#define MIPI_DPHY_REG23_Lane1_esc_cod_mask                                           (0x000000FF)
+#define MIPI_DPHY_REG23_Lane1_esc_cod(data)                                          (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG23_Lane1_esc_cod_src(data)                                      ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG23_get_Lane1_esc_cod(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG24                                                              0xE8
+#define MIPI_DPHY_REG24_reg_addr                                                     "0x980040E8"
+#define MIPI_DPHY_REG24_reg                                                          0x980040E8
+#define set_MIPI_DPHY_REG24_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG24_reg)=data)
+#define get_MIPI_DPHY_REG24_reg   (*((volatile unsigned int*) MIPI_DPHY_REG24_reg))
+#define MIPI_DPHY_REG24_inst_adr                                                     "0x003A"
+#define MIPI_DPHY_REG24_inst                                                         0x003A
+#define MIPI_DPHY_REG24_Lane2_esc_cod_shift                                          (0)
+#define MIPI_DPHY_REG24_Lane2_esc_cod_mask                                           (0x000000FF)
+#define MIPI_DPHY_REG24_Lane2_esc_cod(data)                                          (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG24_Lane2_esc_cod_src(data)                                      ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG24_get_Lane2_esc_cod(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG25                                                              0xEC
+#define MIPI_DPHY_REG25_reg_addr                                                     "0x980040EC"
+#define MIPI_DPHY_REG25_reg                                                          0x980040EC
+#define set_MIPI_DPHY_REG25_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG25_reg)=data)
+#define get_MIPI_DPHY_REG25_reg   (*((volatile unsigned int*) MIPI_DPHY_REG25_reg))
+#define MIPI_DPHY_REG25_inst_adr                                                     "0x003B"
+#define MIPI_DPHY_REG25_inst                                                         0x003B
+#define MIPI_DPHY_REG25_Lane3_esc_cod_shift                                          (0)
+#define MIPI_DPHY_REG25_Lane3_esc_cod_mask                                           (0x000000FF)
+#define MIPI_DPHY_REG25_Lane3_esc_cod(data)                                          (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG25_Lane3_esc_cod_src(data)                                      ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG25_get_Lane3_esc_cod(data)                                      ((0x000000FF&(data))>>0)
+
+
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/mipi_wrapper_reg.h b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/mipi_wrapper_reg.h
new file mode 100644
index 00000000..f172fb0
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include/mipi_wrapper_reg.h
@@ -0,0 +1,1474 @@
+/**************************************************************
+// Spec Version                  : 1.00
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/8/7 14:49:34
+***************************************************************/
+
+
+#ifndef _MIPI_WRAPPER_REG_H_INCLUDED_
+#define _MIPI_WRAPPER_REG_H_INCLUDED_
+
+#define MIPI                                                                         0x00
+#define MIPI_reg_addr                                                                "0x98004100"
+#define MIPI_reg                                                                     0x98004100
+#define set_MIPI_reg(data)   (*((volatile unsigned int*) MIPI_reg)=data)
+#define get_MIPI_reg   (*((volatile unsigned int*) MIPI_reg))
+#define MIPI_inst_adr                                                                "0x0040"
+#define MIPI_inst                                                                    0x0040
+#define MIPI_dst_fmt_shift                                                           (27)
+#define MIPI_dst_fmt_mask                                                            (0xF8000000)
+#define MIPI_dst_fmt(data)                                                           (0xF8000000&((data)<<27))
+#define MIPI_dst_fmt_src(data)                                                       ((0xF8000000&(data))>>27)
+#define MIPI_get_dst_fmt(data)                                                       ((0xF8000000&(data))>>27)
+#define MIPI_src_fmt_shift                                                           (25)
+#define MIPI_src_fmt_mask                                                            (0x06000000)
+#define MIPI_src_fmt(data)                                                           (0x06000000&((data)<<25))
+#define MIPI_src_fmt_src(data)                                                       ((0x06000000&(data))>>25)
+#define MIPI_get_src_fmt(data)                                                       ((0x06000000&(data))>>25)
+#define MIPI_src_sel_shift                                                           (24)
+#define MIPI_src_sel_mask                                                            (0x01000000)
+#define MIPI_src_sel(data)                                                           (0x01000000&((data)<<24))
+#define MIPI_src_sel_src(data)                                                       ((0x01000000&(data))>>24)
+#define MIPI_get_src_sel(data)                                                       ((0x01000000&(data))>>24)
+#define MIPI_yuv420_uv_seq_shift                                                     (23)
+#define MIPI_yuv420_uv_seq_mask                                                      (0x00800000)
+#define MIPI_yuv420_uv_seq(data)                                                     (0x00800000&((data)<<23))
+#define MIPI_yuv420_uv_seq_src(data)                                                 ((0x00800000&(data))>>23)
+#define MIPI_get_yuv420_uv_seq(data)                                                 ((0x00800000&(data))>>23)
+#define MIPI_vs_shift                                                                (22)
+#define MIPI_vs_mask                                                                 (0x00400000)
+#define MIPI_vs(data)                                                                (0x00400000&((data)<<22))
+#define MIPI_vs_src(data)                                                            ((0x00400000&(data))>>22)
+#define MIPI_get_vs(data)                                                            ((0x00400000&(data))>>22)
+#define MIPI_vs_near_shift                                                           (21)
+#define MIPI_vs_near_mask                                                            (0x00200000)
+#define MIPI_vs_near(data)                                                           (0x00200000&((data)<<21))
+#define MIPI_vs_near_src(data)                                                       ((0x00200000&(data))>>21)
+#define MIPI_get_vs_near(data)                                                       ((0x00200000&(data))>>21)
+#define MIPI_vs_yodd_shift                                                           (20)
+#define MIPI_vs_yodd_mask                                                            (0x00100000)
+#define MIPI_vs_yodd(data)                                                           (0x00100000&((data)<<20))
+#define MIPI_vs_yodd_src(data)                                                       ((0x00100000&(data))>>20)
+#define MIPI_get_vs_yodd(data)                                                       ((0x00100000&(data))>>20)
+#define MIPI_vs_codd_shift                                                           (19)
+#define MIPI_vs_codd_mask                                                            (0x00080000)
+#define MIPI_vs_codd(data)                                                           (0x00080000&((data)<<19))
+#define MIPI_vs_codd_src(data)                                                       ((0x00080000&(data))>>19)
+#define MIPI_get_vs_codd(data)                                                       ((0x00080000&(data))>>19)
+#define MIPI_hs_shift                                                                (18)
+#define MIPI_hs_mask                                                                 (0x00040000)
+#define MIPI_hs(data)                                                                (0x00040000&((data)<<18))
+#define MIPI_hs_src(data)                                                            ((0x00040000&(data))>>18)
+#define MIPI_get_hs(data)                                                            ((0x00040000&(data))>>18)
+#define MIPI_hs_yodd_shift                                                           (17)
+#define MIPI_hs_yodd_mask                                                            (0x00020000)
+#define MIPI_hs_yodd(data)                                                           (0x00020000&((data)<<17))
+#define MIPI_hs_yodd_src(data)                                                       ((0x00020000&(data))>>17)
+#define MIPI_get_hs_yodd(data)                                                       ((0x00020000&(data))>>17)
+#define MIPI_hs_codd_shift                                                           (16)
+#define MIPI_hs_codd_mask                                                            (0x00010000)
+#define MIPI_hs_codd(data)                                                           (0x00010000&((data)<<16))
+#define MIPI_hs_codd_src(data)                                                       ((0x00010000&(data))>>16)
+#define MIPI_get_hs_codd(data)                                                       ((0x00010000&(data))>>16)
+#define MIPI_yuv420_fmt_shift                                                        (15)
+#define MIPI_yuv420_fmt_mask                                                         (0x00008000)
+#define MIPI_yuv420_fmt(data)                                                        (0x00008000&((data)<<15))
+#define MIPI_yuv420_fmt_src(data)                                                    ((0x00008000&(data))>>15)
+#define MIPI_get_yuv420_fmt(data)                                                    ((0x00008000&(data))>>15)
+#define MIPI_ccs_data_format_shift                                                   (13)
+#define MIPI_ccs_data_format_mask                                                    (0x00006000)
+#define MIPI_ccs_data_format(data)                                                   (0x00006000&((data)<<13))
+#define MIPI_ccs_data_format_src(data)                                               ((0x00006000&(data))>>13)
+#define MIPI_get_ccs_data_format(data)                                               ((0x00006000&(data))>>13)
+#define MIPI_yuv_to_rgb_shift                                                        (12)
+#define MIPI_yuv_to_rgb_mask                                                         (0x00001000)
+#define MIPI_yuv_to_rgb(data)                                                        (0x00001000&((data)<<12))
+#define MIPI_yuv_to_rgb_src(data)                                                    ((0x00001000&(data))>>12)
+#define MIPI_get_yuv_to_rgb(data)                                                    ((0x00001000&(data))>>12)
+#define MIPI_chroma_ds_mode_shift                                                    (11)
+#define MIPI_chroma_ds_mode_mask                                                     (0x00000800)
+#define MIPI_chroma_ds_mode(data)                                                    (0x00000800&((data)<<11))
+#define MIPI_chroma_ds_mode_src(data)                                                ((0x00000800&(data))>>11)
+#define MIPI_get_chroma_ds_mode(data)                                                ((0x00000800&(data))>>11)
+#define MIPI_chroma_ds_en_shift                                                      (10)
+#define MIPI_chroma_ds_en_mask                                                       (0x00000400)
+#define MIPI_chroma_ds_en(data)                                                      (0x00000400&((data)<<10))
+#define MIPI_chroma_ds_en_src(data)                                                  ((0x00000400&(data))>>10)
+#define MIPI_get_chroma_ds_en(data)                                                  ((0x00000400&(data))>>10)
+#define MIPI_chroma_us_mode_shift                                                    (9)
+#define MIPI_chroma_us_mode_mask                                                     (0x00000200)
+#define MIPI_chroma_us_mode(data)                                                    (0x00000200&((data)<<9))
+#define MIPI_chroma_us_mode_src(data)                                                ((0x00000200&(data))>>9)
+#define MIPI_get_chroma_us_mode(data)                                                ((0x00000200&(data))>>9)
+#define MIPI_chroma_us_en_shift                                                      (8)
+#define MIPI_chroma_us_en_mask                                                       (0x00000100)
+#define MIPI_chroma_us_en(data)                                                      (0x00000100&((data)<<8))
+#define MIPI_chroma_us_en_src(data)                                                  ((0x00000100&(data))>>8)
+#define MIPI_get_chroma_us_en(data)                                                  ((0x00000100&(data))>>8)
+#define MIPI_hdmirx_interlace_en_shift                                               (7)
+#define MIPI_hdmirx_interlace_en_mask                                                (0x00000080)
+#define MIPI_hdmirx_interlace_en(data)                                               (0x00000080&((data)<<7))
+#define MIPI_hdmirx_interlace_en_src(data)                                           ((0x00000080&(data))>>7)
+#define MIPI_get_hdmirx_interlace_en(data)                                           ((0x00000080&(data))>>7)
+#define MIPI_hdmirx_interlace_polarity_shift                                         (6)
+#define MIPI_hdmirx_interlace_polarity_mask                                          (0x00000040)
+#define MIPI_hdmirx_interlace_polarity(data)                                         (0x00000040&((data)<<6))
+#define MIPI_hdmirx_interlace_polarity_src(data)                                     ((0x00000040&(data))>>6)
+#define MIPI_get_hdmirx_interlace_polarity(data)                                     ((0x00000040&(data))>>6)
+#define MIPI_int_en4_shift                                                           (5)
+#define MIPI_int_en4_mask                                                            (0x00000020)
+#define MIPI_int_en4(data)                                                           (0x00000020&((data)<<5))
+#define MIPI_int_en4_src(data)                                                       ((0x00000020&(data))>>5)
+#define MIPI_get_int_en4(data)                                                       ((0x00000020&(data))>>5)
+#define MIPI_int_en3_shift                                                           (4)
+#define MIPI_int_en3_mask                                                            (0x00000010)
+#define MIPI_int_en3(data)                                                           (0x00000010&((data)<<4))
+#define MIPI_int_en3_src(data)                                                       ((0x00000010&(data))>>4)
+#define MIPI_get_int_en3(data)                                                       ((0x00000010&(data))>>4)
+#define MIPI_int_en2_shift                                                           (3)
+#define MIPI_int_en2_mask                                                            (0x00000008)
+#define MIPI_int_en2(data)                                                           (0x00000008&((data)<<3))
+#define MIPI_int_en2_src(data)                                                       ((0x00000008&(data))>>3)
+#define MIPI_get_int_en2(data)                                                       ((0x00000008&(data))>>3)
+#define MIPI_int_en1_shift                                                           (2)
+#define MIPI_int_en1_mask                                                            (0x00000004)
+#define MIPI_int_en1(data)                                                           (0x00000004&((data)<<2))
+#define MIPI_int_en1_src(data)                                                       ((0x00000004&(data))>>2)
+#define MIPI_get_int_en1(data)                                                       ((0x00000004&(data))>>2)
+#define MIPI_int_en0_shift                                                           (1)
+#define MIPI_int_en0_mask                                                            (0x00000002)
+#define MIPI_int_en0(data)                                                           (0x00000002&((data)<<1))
+#define MIPI_int_en0_src(data)                                                       ((0x00000002&(data))>>1)
+#define MIPI_get_int_en0(data)                                                       ((0x00000002&(data))>>1)
+#define MIPI_en_shift                                                                (0)
+#define MIPI_en_mask                                                                 (0x00000001)
+#define MIPI_en(data)                                                                (0x00000001&((data)<<0))
+#define MIPI_en_src(data)                                                            ((0x00000001&(data))>>0)
+#define MIPI_get_en(data)                                                            ((0x00000001&(data))>>0)
+
+
+#define MIPI_SA0                                                                     0x04
+#define MIPI_SA0_reg_addr                                                            "0x98004104"
+#define MIPI_SA0_reg                                                                 0x98004104
+#define set_MIPI_SA0_reg(data)   (*((volatile unsigned int*) MIPI_SA0_reg)=data)
+#define get_MIPI_SA0_reg   (*((volatile unsigned int*) MIPI_SA0_reg))
+#define MIPI_SA0_inst_adr                                                            "0x0041"
+#define MIPI_SA0_inst                                                                0x0041
+#define MIPI_SA0_sa0_video_shift                                                     (0)
+#define MIPI_SA0_sa0_video_mask                                                      (0xFFFFFFFF)
+#define MIPI_SA0_sa0_video(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA0_sa0_video_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA0_get_sa0_video(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SA1                                                                     0x08
+#define MIPI_SA1_reg_addr                                                            "0x98004108"
+#define MIPI_SA1_reg                                                                 0x98004108
+#define set_MIPI_SA1_reg(data)   (*((volatile unsigned int*) MIPI_SA1_reg)=data)
+#define get_MIPI_SA1_reg   (*((volatile unsigned int*) MIPI_SA1_reg))
+#define MIPI_SA1_inst_adr                                                            "0x0042"
+#define MIPI_SA1_inst                                                                0x0042
+#define MIPI_SA1_sa1_video_shift                                                     (0)
+#define MIPI_SA1_sa1_video_mask                                                      (0xFFFFFFFF)
+#define MIPI_SA1_sa1_video(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA1_sa1_video_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA1_get_sa1_video(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SA2                                                                     0x0C
+#define MIPI_SA2_reg_addr                                                            "0x9800410C"
+#define MIPI_SA2_reg                                                                 0x9800410C
+#define set_MIPI_SA2_reg(data)   (*((volatile unsigned int*) MIPI_SA2_reg)=data)
+#define get_MIPI_SA2_reg   (*((volatile unsigned int*) MIPI_SA2_reg))
+#define MIPI_SA2_inst_adr                                                            "0x0043"
+#define MIPI_SA2_inst                                                                0x0043
+#define MIPI_SA2_sa2_pic_shift                                                       (0)
+#define MIPI_SA2_sa2_pic_mask                                                        (0xFFFFFFFF)
+#define MIPI_SA2_sa2_pic(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA2_sa2_pic_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA2_get_sa2_pic(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SIZE0                                                                   0x10
+#define MIPI_SIZE0_reg_addr                                                          "0x98004110"
+#define MIPI_SIZE0_reg                                                               0x98004110
+#define set_MIPI_SIZE0_reg(data)   (*((volatile unsigned int*) MIPI_SIZE0_reg)=data)
+#define get_MIPI_SIZE0_reg   (*((volatile unsigned int*) MIPI_SIZE0_reg))
+#define MIPI_SIZE0_inst_adr                                                          "0x0044"
+#define MIPI_SIZE0_inst                                                              0x0044
+#define MIPI_SIZE0_dst_width_video_shift                                             (16)
+#define MIPI_SIZE0_dst_width_video_mask                                              (0x1FFF0000)
+#define MIPI_SIZE0_dst_width_video(data)                                             (0x1FFF0000&((data)<<16))
+#define MIPI_SIZE0_dst_width_video_src(data)                                         ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE0_get_dst_width_video(data)                                         ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE0_pitch_video_shift                                                 (0)
+#define MIPI_SIZE0_pitch_video_mask                                                  (0x0000FFFF)
+#define MIPI_SIZE0_pitch_video(data)                                                 (0x0000FFFF&((data)<<0))
+#define MIPI_SIZE0_pitch_video_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define MIPI_SIZE0_get_pitch_video(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define MIPI_SIZE1                                                                   0x14
+#define MIPI_SIZE1_reg_addr                                                          "0x98004114"
+#define MIPI_SIZE1_reg                                                               0x98004114
+#define set_MIPI_SIZE1_reg(data)   (*((volatile unsigned int*) MIPI_SIZE1_reg)=data)
+#define get_MIPI_SIZE1_reg   (*((volatile unsigned int*) MIPI_SIZE1_reg))
+#define MIPI_SIZE1_inst_adr                                                          "0x0045"
+#define MIPI_SIZE1_inst                                                              0x0045
+#define MIPI_SIZE1_dst_width_pic_shift                                               (16)
+#define MIPI_SIZE1_dst_width_pic_mask                                                (0x1FFF0000)
+#define MIPI_SIZE1_dst_width_pic(data)                                               (0x1FFF0000&((data)<<16))
+#define MIPI_SIZE1_dst_width_pic_src(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE1_get_dst_width_pic(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE1_pitch_pic_shift                                                   (0)
+#define MIPI_SIZE1_pitch_pic_mask                                                    (0x0000FFFF)
+#define MIPI_SIZE1_pitch_pic(data)                                                   (0x0000FFFF&((data)<<0))
+#define MIPI_SIZE1_pitch_pic_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define MIPI_SIZE1_get_pitch_pic(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define MIPI_SIZE2                                                                   0x18
+#define MIPI_SIZE2_reg_addr                                                          "0x98004118"
+#define MIPI_SIZE2_reg                                                               0x98004118
+#define set_MIPI_SIZE2_reg(data)   (*((volatile unsigned int*) MIPI_SIZE2_reg)=data)
+#define get_MIPI_SIZE2_reg   (*((volatile unsigned int*) MIPI_SIZE2_reg))
+#define MIPI_SIZE2_inst_adr                                                          "0x0046"
+#define MIPI_SIZE2_inst                                                              0x0046
+#define MIPI_SIZE2_src_width_pic_shift                                               (16)
+#define MIPI_SIZE2_src_width_pic_mask                                                (0x1FFF0000)
+#define MIPI_SIZE2_src_width_pic(data)                                               (0x1FFF0000&((data)<<16))
+#define MIPI_SIZE2_src_width_pic_src(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE2_get_src_width_pic(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE2_src_width_video_shift                                             (0)
+#define MIPI_SIZE2_src_width_video_mask                                              (0x00001FFF)
+#define MIPI_SIZE2_src_width_video(data)                                             (0x00001FFF&((data)<<0))
+#define MIPI_SIZE2_src_width_video_src(data)                                         ((0x00001FFF&(data))>>0)
+#define MIPI_SIZE2_get_src_width_video(data)                                         ((0x00001FFF&(data))>>0)
+
+
+#define MIPI_INDEX0                                                                  0x1C
+#define MIPI_INDEX0_reg_addr                                                         "0x9800411C"
+#define MIPI_INDEX0_reg                                                              0x9800411C
+#define set_MIPI_INDEX0_reg(data)   (*((volatile unsigned int*) MIPI_INDEX0_reg)=data)
+#define get_MIPI_INDEX0_reg   (*((volatile unsigned int*) MIPI_INDEX0_reg))
+#define MIPI_INDEX0_inst_adr                                                         "0x0047"
+#define MIPI_INDEX0_inst                                                             0x0047
+#define MIPI_INDEX0_index_y0_video_shift                                             (16)
+#define MIPI_INDEX0_index_y0_video_mask                                              (0x007F0000)
+#define MIPI_INDEX0_index_y0_video(data)                                             (0x007F0000&((data)<<16))
+#define MIPI_INDEX0_index_y0_video_src(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX0_get_index_y0_video(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX0_index_c0_video_shift                                             (0)
+#define MIPI_INDEX0_index_c0_video_mask                                              (0x0000007F)
+#define MIPI_INDEX0_index_c0_video(data)                                             (0x0000007F&((data)<<0))
+#define MIPI_INDEX0_index_c0_video_src(data)                                         ((0x0000007F&(data))>>0)
+#define MIPI_INDEX0_get_index_c0_video(data)                                         ((0x0000007F&(data))>>0)
+
+
+#define MIPI_INDEX1                                                                  0x20
+#define MIPI_INDEX1_reg_addr                                                         "0x98004120"
+#define MIPI_INDEX1_reg                                                              0x98004120
+#define set_MIPI_INDEX1_reg(data)   (*((volatile unsigned int*) MIPI_INDEX1_reg)=data)
+#define get_MIPI_INDEX1_reg   (*((volatile unsigned int*) MIPI_INDEX1_reg))
+#define MIPI_INDEX1_inst_adr                                                         "0x0048"
+#define MIPI_INDEX1_inst                                                             0x0048
+#define MIPI_INDEX1_index_y1_video_shift                                             (16)
+#define MIPI_INDEX1_index_y1_video_mask                                              (0x007F0000)
+#define MIPI_INDEX1_index_y1_video(data)                                             (0x007F0000&((data)<<16))
+#define MIPI_INDEX1_index_y1_video_src(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX1_get_index_y1_video(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX1_index_c1_video_shift                                             (0)
+#define MIPI_INDEX1_index_c1_video_mask                                              (0x0000007F)
+#define MIPI_INDEX1_index_c1_video(data)                                             (0x0000007F&((data)<<0))
+#define MIPI_INDEX1_index_c1_video_src(data)                                         ((0x0000007F&(data))>>0)
+#define MIPI_INDEX1_get_index_c1_video(data)                                         ((0x0000007F&(data))>>0)
+
+
+#define MIPI_INDEX2                                                                  0x24
+#define MIPI_INDEX2_reg_addr                                                         "0x98004124"
+#define MIPI_INDEX2_reg                                                              0x98004124
+#define set_MIPI_INDEX2_reg(data)   (*((volatile unsigned int*) MIPI_INDEX2_reg)=data)
+#define get_MIPI_INDEX2_reg   (*((volatile unsigned int*) MIPI_INDEX2_reg))
+#define MIPI_INDEX2_inst_adr                                                         "0x0049"
+#define MIPI_INDEX2_inst                                                             0x0049
+#define MIPI_INDEX2_index_y2_pic_shift                                               (16)
+#define MIPI_INDEX2_index_y2_pic_mask                                                (0x007F0000)
+#define MIPI_INDEX2_index_y2_pic(data)                                               (0x007F0000&((data)<<16))
+#define MIPI_INDEX2_index_y2_pic_src(data)                                           ((0x007F0000&(data))>>16)
+#define MIPI_INDEX2_get_index_y2_pic(data)                                           ((0x007F0000&(data))>>16)
+#define MIPI_INDEX2_index_c2_pic_shift                                               (0)
+#define MIPI_INDEX2_index_c2_pic_mask                                                (0x0000007F)
+#define MIPI_INDEX2_index_c2_pic(data)                                               (0x0000007F&((data)<<0))
+#define MIPI_INDEX2_index_c2_pic_src(data)                                           ((0x0000007F&(data))>>0)
+#define MIPI_INDEX2_get_index_c2_pic(data)                                           ((0x0000007F&(data))>>0)
+
+
+#define MIPI_INT_ST                                                                  0x28
+#define MIPI_INT_ST_reg_addr                                                         "0x98004128"
+#define MIPI_INT_ST_reg                                                              0x98004128
+#define set_MIPI_INT_ST_reg(data)   (*((volatile unsigned int*) MIPI_INT_ST_reg)=data)
+#define get_MIPI_INT_ST_reg   (*((volatile unsigned int*) MIPI_INT_ST_reg))
+#define MIPI_INT_ST_inst_adr                                                         "0x004A"
+#define MIPI_INT_ST_inst                                                             0x004A
+#define MIPI_INT_ST_mipi_data_valid_shift                                            (20)
+#define MIPI_INT_ST_mipi_data_valid_mask                                             (0x00100000)
+#define MIPI_INT_ST_mipi_data_valid(data)                                            (0x00100000&((data)<<20))
+#define MIPI_INT_ST_mipi_data_valid_src(data)                                        ((0x00100000&(data))>>20)
+#define MIPI_INT_ST_get_mipi_data_valid(data)                                        ((0x00100000&(data))>>20)
+#define MIPI_INT_ST_mipi_line_end_shift                                              (19)
+#define MIPI_INT_ST_mipi_line_end_mask                                               (0x00080000)
+#define MIPI_INT_ST_mipi_line_end(data)                                              (0x00080000&((data)<<19))
+#define MIPI_INT_ST_mipi_line_end_src(data)                                          ((0x00080000&(data))>>19)
+#define MIPI_INT_ST_get_mipi_line_end(data)                                          ((0x00080000&(data))>>19)
+#define MIPI_INT_ST_mipi_line_start_shift                                            (18)
+#define MIPI_INT_ST_mipi_line_start_mask                                             (0x00040000)
+#define MIPI_INT_ST_mipi_line_start(data)                                            (0x00040000&((data)<<18))
+#define MIPI_INT_ST_mipi_line_start_src(data)                                        ((0x00040000&(data))>>18)
+#define MIPI_INT_ST_get_mipi_line_start(data)                                        ((0x00040000&(data))>>18)
+#define MIPI_INT_ST_mipi_frame_end_shift                                             (17)
+#define MIPI_INT_ST_mipi_frame_end_mask                                              (0x00020000)
+#define MIPI_INT_ST_mipi_frame_end(data)                                             (0x00020000&((data)<<17))
+#define MIPI_INT_ST_mipi_frame_end_src(data)                                         ((0x00020000&(data))>>17)
+#define MIPI_INT_ST_get_mipi_frame_end(data)                                         ((0x00020000&(data))>>17)
+#define MIPI_INT_ST_mipi_frame_start_shift                                           (16)
+#define MIPI_INT_ST_mipi_frame_start_mask                                            (0x00010000)
+#define MIPI_INT_ST_mipi_frame_start(data)                                           (0x00010000&((data)<<16))
+#define MIPI_INT_ST_mipi_frame_start_src(data)                                       ((0x00010000&(data))>>16)
+#define MIPI_INT_ST_get_mipi_frame_start(data)                                       ((0x00010000&(data))>>16)
+#define MIPI_INT_ST_esc_lane3_int_flg_shift                                          (15)
+#define MIPI_INT_ST_esc_lane3_int_flg_mask                                           (0x00008000)
+#define MIPI_INT_ST_esc_lane3_int_flg(data)                                          (0x00008000&((data)<<15))
+#define MIPI_INT_ST_esc_lane3_int_flg_src(data)                                      ((0x00008000&(data))>>15)
+#define MIPI_INT_ST_get_esc_lane3_int_flg(data)                                      ((0x00008000&(data))>>15)
+#define MIPI_INT_ST_esc_lane2_int_flg_shift                                          (14)
+#define MIPI_INT_ST_esc_lane2_int_flg_mask                                           (0x00004000)
+#define MIPI_INT_ST_esc_lane2_int_flg(data)                                          (0x00004000&((data)<<14))
+#define MIPI_INT_ST_esc_lane2_int_flg_src(data)                                      ((0x00004000&(data))>>14)
+#define MIPI_INT_ST_get_esc_lane2_int_flg(data)                                      ((0x00004000&(data))>>14)
+#define MIPI_INT_ST_esc_lane1_int_flg_shift                                          (13)
+#define MIPI_INT_ST_esc_lane1_int_flg_mask                                           (0x00002000)
+#define MIPI_INT_ST_esc_lane1_int_flg(data)                                          (0x00002000&((data)<<13))
+#define MIPI_INT_ST_esc_lane1_int_flg_src(data)                                      ((0x00002000&(data))>>13)
+#define MIPI_INT_ST_get_esc_lane1_int_flg(data)                                      ((0x00002000&(data))>>13)
+#define MIPI_INT_ST_esc_lane0_int_flg_shift                                          (12)
+#define MIPI_INT_ST_esc_lane0_int_flg_mask                                           (0x00001000)
+#define MIPI_INT_ST_esc_lane0_int_flg(data)                                          (0x00001000&((data)<<12))
+#define MIPI_INT_ST_esc_lane0_int_flg_src(data)                                      ((0x00001000&(data))>>12)
+#define MIPI_INT_ST_get_esc_lane0_int_flg(data)                                      ((0x00001000&(data))>>12)
+#define MIPI_INT_ST_clk_ulps_int_flg_shift                                           (11)
+#define MIPI_INT_ST_clk_ulps_int_flg_mask                                            (0x00000800)
+#define MIPI_INT_ST_clk_ulps_int_flg(data)                                           (0x00000800&((data)<<11))
+#define MIPI_INT_ST_clk_ulps_int_flg_src(data)                                       ((0x00000800&(data))>>11)
+#define MIPI_INT_ST_get_clk_ulps_int_flg(data)                                       ((0x00000800&(data))>>11)
+#define MIPI_INT_ST_crc16_err_int_flg_shift                                          (10)
+#define MIPI_INT_ST_crc16_err_int_flg_mask                                           (0x00000400)
+#define MIPI_INT_ST_crc16_err_int_flg(data)                                          (0x00000400&((data)<<10))
+#define MIPI_INT_ST_crc16_err_int_flg_src(data)                                      ((0x00000400&(data))>>10)
+#define MIPI_INT_ST_get_crc16_err_int_flg(data)                                      ((0x00000400&(data))>>10)
+#define MIPI_INT_ST_ecc_crt_int_flg_shift                                            (9)
+#define MIPI_INT_ST_ecc_crt_int_flg_mask                                             (0x00000200)
+#define MIPI_INT_ST_ecc_crt_int_flg(data)                                            (0x00000200&((data)<<9))
+#define MIPI_INT_ST_ecc_crt_int_flg_src(data)                                        ((0x00000200&(data))>>9)
+#define MIPI_INT_ST_get_ecc_crt_int_flg(data)                                        ((0x00000200&(data))>>9)
+#define MIPI_INT_ST_ecc_err_int_flg_shift                                            (8)
+#define MIPI_INT_ST_ecc_err_int_flg_mask                                             (0x00000100)
+#define MIPI_INT_ST_ecc_err_int_flg(data)                                            (0x00000100&((data)<<8))
+#define MIPI_INT_ST_ecc_err_int_flg_src(data)                                        ((0x00000100&(data))>>8)
+#define MIPI_INT_ST_get_ecc_err_int_flg(data)                                        ((0x00000100&(data))>>8)
+#define MIPI_INT_ST_pic_detect_v_fail_shift                                          (7)
+#define MIPI_INT_ST_pic_detect_v_fail_mask                                           (0x00000080)
+#define MIPI_INT_ST_pic_detect_v_fail(data)                                          (0x00000080&((data)<<7))
+#define MIPI_INT_ST_pic_detect_v_fail_src(data)                                      ((0x00000080&(data))>>7)
+#define MIPI_INT_ST_get_pic_detect_v_fail(data)                                      ((0x00000080&(data))>>7)
+#define MIPI_INT_ST_pic_detect_h_fail_shift                                          (6)
+#define MIPI_INT_ST_pic_detect_h_fail_mask                                           (0x00000040)
+#define MIPI_INT_ST_pic_detect_h_fail(data)                                          (0x00000040&((data)<<6))
+#define MIPI_INT_ST_pic_detect_h_fail_src(data)                                      ((0x00000040&(data))>>6)
+#define MIPI_INT_ST_get_pic_detect_h_fail(data)                                      ((0x00000040&(data))>>6)
+#define MIPI_INT_ST_overflow_drop_shift                                              (5)
+#define MIPI_INT_ST_overflow_drop_mask                                               (0x00000020)
+#define MIPI_INT_ST_overflow_drop(data)                                              (0x00000020&((data)<<5))
+#define MIPI_INT_ST_overflow_drop_src(data)                                          ((0x00000020&(data))>>5)
+#define MIPI_INT_ST_get_overflow_drop(data)                                          ((0x00000020&(data))>>5)
+#define MIPI_INT_ST_fm_drop_shift                                                    (4)
+#define MIPI_INT_ST_fm_drop_mask                                                     (0x00000010)
+#define MIPI_INT_ST_fm_drop(data)                                                    (0x00000010&((data)<<4))
+#define MIPI_INT_ST_fm_drop_src(data)                                                ((0x00000010&(data))>>4)
+#define MIPI_INT_ST_get_fm_drop(data)                                                ((0x00000010&(data))>>4)
+#define MIPI_INT_ST_fm_done2_shift                                                   (3)
+#define MIPI_INT_ST_fm_done2_mask                                                    (0x00000008)
+#define MIPI_INT_ST_fm_done2(data)                                                   (0x00000008&((data)<<3))
+#define MIPI_INT_ST_fm_done2_src(data)                                               ((0x00000008&(data))>>3)
+#define MIPI_INT_ST_get_fm_done2(data)                                               ((0x00000008&(data))>>3)
+#define MIPI_INT_ST_fm_done1_shift                                                   (2)
+#define MIPI_INT_ST_fm_done1_mask                                                    (0x00000004)
+#define MIPI_INT_ST_fm_done1(data)                                                   (0x00000004&((data)<<2))
+#define MIPI_INT_ST_fm_done1_src(data)                                               ((0x00000004&(data))>>2)
+#define MIPI_INT_ST_get_fm_done1(data)                                               ((0x00000004&(data))>>2)
+#define MIPI_INT_ST_fm_done0_shift                                                   (1)
+#define MIPI_INT_ST_fm_done0_mask                                                    (0x00000002)
+#define MIPI_INT_ST_fm_done0(data)                                                   (0x00000002&((data)<<1))
+#define MIPI_INT_ST_fm_done0_src(data)                                               ((0x00000002&(data))>>1)
+#define MIPI_INT_ST_get_fm_done0(data)                                               ((0x00000002&(data))>>1)
+#define MIPI_INT_ST_write_data_shift                                                 (0)
+#define MIPI_INT_ST_write_data_mask                                                  (0x00000001)
+#define MIPI_INT_ST_write_data(data)                                                 (0x00000001&((data)<<0))
+#define MIPI_INT_ST_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define MIPI_INT_ST_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MIPI_TYPE                                                                    0x2C
+#define MIPI_TYPE_reg_addr                                                           "0x9800412C"
+#define MIPI_TYPE_reg                                                                0x9800412C
+#define set_MIPI_TYPE_reg(data)   (*((volatile unsigned int*) MIPI_TYPE_reg)=data)
+#define get_MIPI_TYPE_reg   (*((volatile unsigned int*) MIPI_TYPE_reg))
+#define MIPI_TYPE_inst_adr                                                           "0x004B"
+#define MIPI_TYPE_inst                                                               0x004B
+#define MIPI_TYPE_mipi_type_shift                                                    (0)
+#define MIPI_TYPE_mipi_type_mask                                                     (0x00000001)
+#define MIPI_TYPE_mipi_type(data)                                                    (0x00000001&((data)<<0))
+#define MIPI_TYPE_mipi_type_src(data)                                                ((0x00000001&(data))>>0)
+#define MIPI_TYPE_get_mipi_type(data)                                                ((0x00000001&(data))>>0)
+
+
+#define CS_TRANS0                                                                    0x30
+#define CS_TRANS0_reg_addr                                                           "0x98004130"
+#define CS_TRANS0_reg                                                                0x98004130
+#define set_CS_TRANS0_reg(data)   (*((volatile unsigned int*) CS_TRANS0_reg)=data)
+#define get_CS_TRANS0_reg   (*((volatile unsigned int*) CS_TRANS0_reg))
+#define CS_TRANS0_inst_adr                                                           "0x004C"
+#define CS_TRANS0_inst                                                               0x004C
+#define CS_TRANS0_cs_trans0_c1_shift                                                 (0)
+#define CS_TRANS0_cs_trans0_c1_mask                                                  (0x0001FFFF)
+#define CS_TRANS0_cs_trans0_c1(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS0_cs_trans0_c1_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS0_get_cs_trans0_c1(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS1                                                                    0x34
+#define CS_TRANS1_reg_addr                                                           "0x98004134"
+#define CS_TRANS1_reg                                                                0x98004134
+#define set_CS_TRANS1_reg(data)   (*((volatile unsigned int*) CS_TRANS1_reg)=data)
+#define get_CS_TRANS1_reg   (*((volatile unsigned int*) CS_TRANS1_reg))
+#define CS_TRANS1_inst_adr                                                           "0x004D"
+#define CS_TRANS1_inst                                                               0x004D
+#define CS_TRANS1_cs_trans1_c2_shift                                                 (0)
+#define CS_TRANS1_cs_trans1_c2_mask                                                  (0x0001FFFF)
+#define CS_TRANS1_cs_trans1_c2(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS1_cs_trans1_c2_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS1_get_cs_trans1_c2(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS2                                                                    0x38
+#define CS_TRANS2_reg_addr                                                           "0x98004138"
+#define CS_TRANS2_reg                                                                0x98004138
+#define set_CS_TRANS2_reg(data)   (*((volatile unsigned int*) CS_TRANS2_reg)=data)
+#define get_CS_TRANS2_reg   (*((volatile unsigned int*) CS_TRANS2_reg))
+#define CS_TRANS2_inst_adr                                                           "0x004E"
+#define CS_TRANS2_inst                                                               0x004E
+#define CS_TRANS2_cs_trans2_c3_shift                                                 (0)
+#define CS_TRANS2_cs_trans2_c3_mask                                                  (0x0001FFFF)
+#define CS_TRANS2_cs_trans2_c3(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS2_cs_trans2_c3_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS2_get_cs_trans2_c3(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS3                                                                    0x3C
+#define CS_TRANS3_reg_addr                                                           "0x9800413C"
+#define CS_TRANS3_reg                                                                0x9800413C
+#define set_CS_TRANS3_reg(data)   (*((volatile unsigned int*) CS_TRANS3_reg)=data)
+#define get_CS_TRANS3_reg   (*((volatile unsigned int*) CS_TRANS3_reg))
+#define CS_TRANS3_inst_adr                                                           "0x004F"
+#define CS_TRANS3_inst                                                               0x004F
+#define CS_TRANS3_cs_trans3_c4_shift                                                 (0)
+#define CS_TRANS3_cs_trans3_c4_mask                                                  (0x0001FFFF)
+#define CS_TRANS3_cs_trans3_c4(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS3_cs_trans3_c4_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS3_get_cs_trans3_c4(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS4                                                                    0x40
+#define CS_TRANS4_reg_addr                                                           "0x98004140"
+#define CS_TRANS4_reg                                                                0x98004140
+#define set_CS_TRANS4_reg(data)   (*((volatile unsigned int*) CS_TRANS4_reg)=data)
+#define get_CS_TRANS4_reg   (*((volatile unsigned int*) CS_TRANS4_reg))
+#define CS_TRANS4_inst_adr                                                           "0x0050"
+#define CS_TRANS4_inst                                                               0x0050
+#define CS_TRANS4_cs_trans4_c5_shift                                                 (0)
+#define CS_TRANS4_cs_trans4_c5_mask                                                  (0x0001FFFF)
+#define CS_TRANS4_cs_trans4_c5(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS4_cs_trans4_c5_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS4_get_cs_trans4_c5(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS5                                                                    0x44
+#define CS_TRANS5_reg_addr                                                           "0x98004144"
+#define CS_TRANS5_reg                                                                0x98004144
+#define set_CS_TRANS5_reg(data)   (*((volatile unsigned int*) CS_TRANS5_reg)=data)
+#define get_CS_TRANS5_reg   (*((volatile unsigned int*) CS_TRANS5_reg))
+#define CS_TRANS5_inst_adr                                                           "0x0051"
+#define CS_TRANS5_inst                                                               0x0051
+#define CS_TRANS5_cs_trans5_c6_shift                                                 (0)
+#define CS_TRANS5_cs_trans5_c6_mask                                                  (0x0001FFFF)
+#define CS_TRANS5_cs_trans5_c6(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS5_cs_trans5_c6_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS5_get_cs_trans5_c6(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS6                                                                    0x48
+#define CS_TRANS6_reg_addr                                                           "0x98004148"
+#define CS_TRANS6_reg                                                                0x98004148
+#define set_CS_TRANS6_reg(data)   (*((volatile unsigned int*) CS_TRANS6_reg)=data)
+#define get_CS_TRANS6_reg   (*((volatile unsigned int*) CS_TRANS6_reg))
+#define CS_TRANS6_inst_adr                                                           "0x0052"
+#define CS_TRANS6_inst                                                               0x0052
+#define CS_TRANS6_cs_trans6_c7_shift                                                 (0)
+#define CS_TRANS6_cs_trans6_c7_mask                                                  (0x0001FFFF)
+#define CS_TRANS6_cs_trans6_c7(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS6_cs_trans6_c7_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS6_get_cs_trans6_c7(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS7                                                                    0x4C
+#define CS_TRANS7_reg_addr                                                           "0x9800414C"
+#define CS_TRANS7_reg                                                                0x9800414C
+#define set_CS_TRANS7_reg(data)   (*((volatile unsigned int*) CS_TRANS7_reg)=data)
+#define get_CS_TRANS7_reg   (*((volatile unsigned int*) CS_TRANS7_reg))
+#define CS_TRANS7_inst_adr                                                           "0x0053"
+#define CS_TRANS7_inst                                                               0x0053
+#define CS_TRANS7_cs_trans7_c8_shift                                                 (0)
+#define CS_TRANS7_cs_trans7_c8_mask                                                  (0x0001FFFF)
+#define CS_TRANS7_cs_trans7_c8(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS7_cs_trans7_c8_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS7_get_cs_trans7_c8(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS8                                                                    0x50
+#define CS_TRANS8_reg_addr                                                           "0x98004150"
+#define CS_TRANS8_reg                                                                0x98004150
+#define set_CS_TRANS8_reg(data)   (*((volatile unsigned int*) CS_TRANS8_reg)=data)
+#define get_CS_TRANS8_reg   (*((volatile unsigned int*) CS_TRANS8_reg))
+#define CS_TRANS8_inst_adr                                                           "0x0054"
+#define CS_TRANS8_inst                                                               0x0054
+#define CS_TRANS8_cs_trans8_c9_shift                                                 (0)
+#define CS_TRANS8_cs_trans8_c9_mask                                                  (0x0001FFFF)
+#define CS_TRANS8_cs_trans8_c9(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS8_cs_trans8_c9_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS8_get_cs_trans8_c9(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS9                                                                    0x54
+#define CS_TRANS9_reg_addr                                                           "0x98004154"
+#define CS_TRANS9_reg                                                                0x98004154
+#define set_CS_TRANS9_reg(data)   (*((volatile unsigned int*) CS_TRANS9_reg)=data)
+#define get_CS_TRANS9_reg   (*((volatile unsigned int*) CS_TRANS9_reg))
+#define CS_TRANS9_inst_adr                                                           "0x0055"
+#define CS_TRANS9_inst                                                               0x0055
+#define CS_TRANS9_cs_trans9_k1_shift                                                 (0)
+#define CS_TRANS9_cs_trans9_k1_mask                                                  (0x0000FFFF)
+#define CS_TRANS9_cs_trans9_k1(data)                                                 (0x0000FFFF&((data)<<0))
+#define CS_TRANS9_cs_trans9_k1_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define CS_TRANS9_get_cs_trans9_k1(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define CS_TRANS10                                                                   0x58
+#define CS_TRANS10_reg_addr                                                          "0x98004158"
+#define CS_TRANS10_reg                                                               0x98004158
+#define set_CS_TRANS10_reg(data)   (*((volatile unsigned int*) CS_TRANS10_reg)=data)
+#define get_CS_TRANS10_reg   (*((volatile unsigned int*) CS_TRANS10_reg))
+#define CS_TRANS10_inst_adr                                                          "0x0056"
+#define CS_TRANS10_inst                                                              0x0056
+#define CS_TRANS10_cs_trans10_k2_shift                                               (0)
+#define CS_TRANS10_cs_trans10_k2_mask                                                (0x0000FFFF)
+#define CS_TRANS10_cs_trans10_k2(data)                                               (0x0000FFFF&((data)<<0))
+#define CS_TRANS10_cs_trans10_k2_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define CS_TRANS10_get_cs_trans10_k2(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define CS_TRANS11                                                                   0x5C
+#define CS_TRANS11_reg_addr                                                          "0x9800415C"
+#define CS_TRANS11_reg                                                               0x9800415C
+#define set_CS_TRANS11_reg(data)   (*((volatile unsigned int*) CS_TRANS11_reg)=data)
+#define get_CS_TRANS11_reg   (*((volatile unsigned int*) CS_TRANS11_reg))
+#define CS_TRANS11_inst_adr                                                          "0x0057"
+#define CS_TRANS11_inst                                                              0x0057
+#define CS_TRANS11_cs_trans11_k3_shift                                               (0)
+#define CS_TRANS11_cs_trans11_k3_mask                                                (0x0000FFFF)
+#define CS_TRANS11_cs_trans11_k3(data)                                               (0x0000FFFF&((data)<<0))
+#define CS_TRANS11_cs_trans11_k3_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define CS_TRANS11_get_cs_trans11_k3(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define SCALER_HSI                                                                   0x60
+#define SCALER_HSI_reg_addr                                                          "0x98004160"
+#define SCALER_HSI_reg                                                               0x98004160
+#define set_SCALER_HSI_reg(data)   (*((volatile unsigned int*) SCALER_HSI_reg)=data)
+#define get_SCALER_HSI_reg   (*((volatile unsigned int*) SCALER_HSI_reg))
+#define SCALER_HSI_inst_adr                                                          "0x0058"
+#define SCALER_HSI_inst                                                              0x0058
+#define SCALER_HSI_hsi_offset_shift                                                  (16)
+#define SCALER_HSI_hsi_offset_mask                                                   (0x07FF0000)
+#define SCALER_HSI_hsi_offset(data)                                                  (0x07FF0000&((data)<<16))
+#define SCALER_HSI_hsi_offset_src(data)                                              ((0x07FF0000&(data))>>16)
+#define SCALER_HSI_get_hsi_offset(data)                                              ((0x07FF0000&(data))>>16)
+#define SCALER_HSI_hsi_phase_shift                                                   (2)
+#define SCALER_HSI_hsi_phase_mask                                                    (0x0000FFFC)
+#define SCALER_HSI_hsi_phase(data)                                                   (0x0000FFFC&((data)<<2))
+#define SCALER_HSI_hsi_phase_src(data)                                               ((0x0000FFFC&(data))>>2)
+#define SCALER_HSI_get_hsi_phase(data)                                               ((0x0000FFFC&(data))>>2)
+
+
+#define SCALER_HSD                                                                   0x64
+#define SCALER_HSD_reg_addr                                                          "0x98004164"
+#define SCALER_HSD_reg                                                               0x98004164
+#define set_SCALER_HSD_reg(data)   (*((volatile unsigned int*) SCALER_HSD_reg)=data)
+#define get_SCALER_HSD_reg   (*((volatile unsigned int*) SCALER_HSD_reg))
+#define SCALER_HSD_inst_adr                                                          "0x0059"
+#define SCALER_HSD_inst                                                              0x0059
+#define SCALER_HSD_hsd_out_shift                                                     (20)
+#define SCALER_HSD_hsd_out_mask                                                      (0x7FF00000)
+#define SCALER_HSD_hsd_out(data)                                                     (0x7FF00000&((data)<<20))
+#define SCALER_HSD_hsd_out_src(data)                                                 ((0x7FF00000&(data))>>20)
+#define SCALER_HSD_get_hsd_out(data)                                                 ((0x7FF00000&(data))>>20)
+#define SCALER_HSD_hsd_delta_shift                                                   (0)
+#define SCALER_HSD_hsd_delta_mask                                                    (0x0007FFFF)
+#define SCALER_HSD_hsd_delta(data)                                                   (0x0007FFFF&((data)<<0))
+#define SCALER_HSD_hsd_delta_src(data)                                               ((0x0007FFFF&(data))>>0)
+#define SCALER_HSD_get_hsd_delta(data)                                               ((0x0007FFFF&(data))>>0)
+
+
+#define SCALER_VSI                                                                   0x68
+#define SCALER_VSI_reg_addr                                                          "0x98004168"
+#define SCALER_VSI_reg                                                               0x98004168
+#define set_SCALER_VSI_reg(data)   (*((volatile unsigned int*) SCALER_VSI_reg)=data)
+#define get_SCALER_VSI_reg   (*((volatile unsigned int*) SCALER_VSI_reg))
+#define SCALER_VSI_inst_adr                                                          "0x005A"
+#define SCALER_VSI_inst                                                              0x005A
+#define SCALER_VSI_vsi_offset_shift                                                  (16)
+#define SCALER_VSI_vsi_offset_mask                                                   (0x0FFF0000)
+#define SCALER_VSI_vsi_offset(data)                                                  (0x0FFF0000&((data)<<16))
+#define SCALER_VSI_vsi_offset_src(data)                                              ((0x0FFF0000&(data))>>16)
+#define SCALER_VSI_get_vsi_offset(data)                                              ((0x0FFF0000&(data))>>16)
+#define SCALER_VSI_vsi_phase_shift                                                   (2)
+#define SCALER_VSI_vsi_phase_mask                                                    (0x0000FFFC)
+#define SCALER_VSI_vsi_phase(data)                                                   (0x0000FFFC&((data)<<2))
+#define SCALER_VSI_vsi_phase_src(data)                                               ((0x0000FFFC&(data))>>2)
+#define SCALER_VSI_get_vsi_phase(data)                                               ((0x0000FFFC&(data))>>2)
+
+
+#define SCALER_VSD                                                                   0x6C
+#define SCALER_VSD_reg_addr                                                          "0x9800416C"
+#define SCALER_VSD_reg                                                               0x9800416C
+#define set_SCALER_VSD_reg(data)   (*((volatile unsigned int*) SCALER_VSD_reg)=data)
+#define get_SCALER_VSD_reg   (*((volatile unsigned int*) SCALER_VSD_reg))
+#define SCALER_VSD_inst_adr                                                          "0x005B"
+#define SCALER_VSD_inst                                                              0x005B
+#define SCALER_VSD_vsd_out_shift                                                     (20)
+#define SCALER_VSD_vsd_out_mask                                                      (0x7FF00000)
+#define SCALER_VSD_vsd_out(data)                                                     (0x7FF00000&((data)<<20))
+#define SCALER_VSD_vsd_out_src(data)                                                 ((0x7FF00000&(data))>>20)
+#define SCALER_VSD_get_vsd_out(data)                                                 ((0x7FF00000&(data))>>20)
+#define SCALER_VSD_vsd_delta_shift                                                   (0)
+#define SCALER_VSD_vsd_delta_mask                                                    (0x0007FFFF)
+#define SCALER_VSD_vsd_delta(data)                                                   (0x0007FFFF&((data)<<0))
+#define SCALER_VSD_vsd_delta_src(data)                                               ((0x0007FFFF&(data))>>0)
+#define SCALER_VSD_get_vsd_delta(data)                                               ((0x0007FFFF&(data))>>0)
+
+
+#define SCALER_HSYNC0                                                                0x70
+#define SCALER_HSYNC0_reg_addr                                                       "0x98004170"
+#define SCALER_HSYNC0_reg                                                            0x98004170
+#define set_SCALER_HSYNC0_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC0_reg)=data)
+#define get_SCALER_HSYNC0_reg   (*((volatile unsigned int*) SCALER_HSYNC0_reg))
+#define SCALER_HSYNC0_inst_adr                                                       "0x005C"
+#define SCALER_HSYNC0_inst                                                           0x005C
+#define SCALER_HSYNC0_hsync0_c1_shift                                                (16)
+#define SCALER_HSYNC0_hsync0_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC0_hsync0_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC0_hsync0_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC0_get_hsync0_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC0_hsync0_c0_shift                                                (0)
+#define SCALER_HSYNC0_hsync0_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC0_hsync0_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC0_hsync0_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC0_get_hsync0_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC1                                                                0x74
+#define SCALER_HSYNC1_reg_addr                                                       "0x98004174"
+#define SCALER_HSYNC1_reg                                                            0x98004174
+#define set_SCALER_HSYNC1_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC1_reg)=data)
+#define get_SCALER_HSYNC1_reg   (*((volatile unsigned int*) SCALER_HSYNC1_reg))
+#define SCALER_HSYNC1_inst_adr                                                       "0x005D"
+#define SCALER_HSYNC1_inst                                                           0x005D
+#define SCALER_HSYNC1_hsync1_c1_shift                                                (16)
+#define SCALER_HSYNC1_hsync1_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC1_hsync1_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC1_hsync1_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC1_get_hsync1_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC1_hsync1_c0_shift                                                (0)
+#define SCALER_HSYNC1_hsync1_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC1_hsync1_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC1_hsync1_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC1_get_hsync1_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC2                                                                0x78
+#define SCALER_HSYNC2_reg_addr                                                       "0x98004178"
+#define SCALER_HSYNC2_reg                                                            0x98004178
+#define set_SCALER_HSYNC2_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC2_reg)=data)
+#define get_SCALER_HSYNC2_reg   (*((volatile unsigned int*) SCALER_HSYNC2_reg))
+#define SCALER_HSYNC2_inst_adr                                                       "0x005E"
+#define SCALER_HSYNC2_inst                                                           0x005E
+#define SCALER_HSYNC2_hsync2_c1_shift                                                (16)
+#define SCALER_HSYNC2_hsync2_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC2_hsync2_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC2_hsync2_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC2_get_hsync2_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC2_hsync2_c0_shift                                                (0)
+#define SCALER_HSYNC2_hsync2_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC2_hsync2_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC2_hsync2_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC2_get_hsync2_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC3                                                                0x7C
+#define SCALER_HSYNC3_reg_addr                                                       "0x9800417C"
+#define SCALER_HSYNC3_reg                                                            0x9800417C
+#define set_SCALER_HSYNC3_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC3_reg)=data)
+#define get_SCALER_HSYNC3_reg   (*((volatile unsigned int*) SCALER_HSYNC3_reg))
+#define SCALER_HSYNC3_inst_adr                                                       "0x005F"
+#define SCALER_HSYNC3_inst                                                           0x005F
+#define SCALER_HSYNC3_hsync3_c1_shift                                                (16)
+#define SCALER_HSYNC3_hsync3_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC3_hsync3_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC3_hsync3_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC3_get_hsync3_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC3_hsync3_c0_shift                                                (0)
+#define SCALER_HSYNC3_hsync3_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC3_hsync3_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC3_hsync3_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC3_get_hsync3_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC4                                                                0x80
+#define SCALER_HSYNC4_reg_addr                                                       "0x98004180"
+#define SCALER_HSYNC4_reg                                                            0x98004180
+#define set_SCALER_HSYNC4_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC4_reg)=data)
+#define get_SCALER_HSYNC4_reg   (*((volatile unsigned int*) SCALER_HSYNC4_reg))
+#define SCALER_HSYNC4_inst_adr                                                       "0x0060"
+#define SCALER_HSYNC4_inst                                                           0x0060
+#define SCALER_HSYNC4_hsync4_c1_shift                                                (16)
+#define SCALER_HSYNC4_hsync4_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC4_hsync4_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC4_hsync4_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC4_get_hsync4_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC4_hsync4_c0_shift                                                (0)
+#define SCALER_HSYNC4_hsync4_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC4_hsync4_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC4_hsync4_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC4_get_hsync4_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC5                                                                0x84
+#define SCALER_HSYNC5_reg_addr                                                       "0x98004184"
+#define SCALER_HSYNC5_reg                                                            0x98004184
+#define set_SCALER_HSYNC5_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC5_reg)=data)
+#define get_SCALER_HSYNC5_reg   (*((volatile unsigned int*) SCALER_HSYNC5_reg))
+#define SCALER_HSYNC5_inst_adr                                                       "0x0061"
+#define SCALER_HSYNC5_inst                                                           0x0061
+#define SCALER_HSYNC5_hsync5_c1_shift                                                (16)
+#define SCALER_HSYNC5_hsync5_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC5_hsync5_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC5_hsync5_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC5_get_hsync5_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC5_hsync5_c0_shift                                                (0)
+#define SCALER_HSYNC5_hsync5_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC5_hsync5_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC5_hsync5_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC5_get_hsync5_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC6                                                                0x88
+#define SCALER_HSYNC6_reg_addr                                                       "0x98004188"
+#define SCALER_HSYNC6_reg                                                            0x98004188
+#define set_SCALER_HSYNC6_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC6_reg)=data)
+#define get_SCALER_HSYNC6_reg   (*((volatile unsigned int*) SCALER_HSYNC6_reg))
+#define SCALER_HSYNC6_inst_adr                                                       "0x0062"
+#define SCALER_HSYNC6_inst                                                           0x0062
+#define SCALER_HSYNC6_hsync6_c1_shift                                                (16)
+#define SCALER_HSYNC6_hsync6_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC6_hsync6_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC6_hsync6_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC6_get_hsync6_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC6_hsync6_c0_shift                                                (0)
+#define SCALER_HSYNC6_hsync6_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC6_hsync6_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC6_hsync6_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC6_get_hsync6_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC7                                                                0x8C
+#define SCALER_HSYNC7_reg_addr                                                       "0x9800418C"
+#define SCALER_HSYNC7_reg                                                            0x9800418C
+#define set_SCALER_HSYNC7_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC7_reg)=data)
+#define get_SCALER_HSYNC7_reg   (*((volatile unsigned int*) SCALER_HSYNC7_reg))
+#define SCALER_HSYNC7_inst_adr                                                       "0x0063"
+#define SCALER_HSYNC7_inst                                                           0x0063
+#define SCALER_HSYNC7_hsync7_c1_shift                                                (16)
+#define SCALER_HSYNC7_hsync7_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC7_hsync7_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC7_hsync7_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC7_get_hsync7_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC7_hsync7_c0_shift                                                (0)
+#define SCALER_HSYNC7_hsync7_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC7_hsync7_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC7_hsync7_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC7_get_hsync7_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC0                                                                 0x90
+#define SCALER_HSCC0_reg_addr                                                        "0x98004190"
+#define SCALER_HSCC0_reg                                                             0x98004190
+#define set_SCALER_HSCC0_reg(data)   (*((volatile unsigned int*) SCALER_HSCC0_reg)=data)
+#define get_SCALER_HSCC0_reg   (*((volatile unsigned int*) SCALER_HSCC0_reg))
+#define SCALER_HSCC0_inst_adr                                                        "0x0064"
+#define SCALER_HSCC0_inst                                                            0x0064
+#define SCALER_HSCC0_hscc0_c1_shift                                                  (16)
+#define SCALER_HSCC0_hscc0_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC0_hscc0_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC0_hscc0_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC0_get_hscc0_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC0_hscc0_c0_shift                                                  (0)
+#define SCALER_HSCC0_hscc0_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC0_hscc0_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC0_hscc0_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC0_get_hscc0_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC1                                                                 0x94
+#define SCALER_HSCC1_reg_addr                                                        "0x98004194"
+#define SCALER_HSCC1_reg                                                             0x98004194
+#define set_SCALER_HSCC1_reg(data)   (*((volatile unsigned int*) SCALER_HSCC1_reg)=data)
+#define get_SCALER_HSCC1_reg   (*((volatile unsigned int*) SCALER_HSCC1_reg))
+#define SCALER_HSCC1_inst_adr                                                        "0x0065"
+#define SCALER_HSCC1_inst                                                            0x0065
+#define SCALER_HSCC1_hscc1_c1_shift                                                  (16)
+#define SCALER_HSCC1_hscc1_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC1_hscc1_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC1_hscc1_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC1_get_hscc1_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC1_hscc1_c0_shift                                                  (0)
+#define SCALER_HSCC1_hscc1_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC1_hscc1_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC1_hscc1_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC1_get_hscc1_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC2                                                                 0x98
+#define SCALER_HSCC2_reg_addr                                                        "0x98004198"
+#define SCALER_HSCC2_reg                                                             0x98004198
+#define set_SCALER_HSCC2_reg(data)   (*((volatile unsigned int*) SCALER_HSCC2_reg)=data)
+#define get_SCALER_HSCC2_reg   (*((volatile unsigned int*) SCALER_HSCC2_reg))
+#define SCALER_HSCC2_inst_adr                                                        "0x0066"
+#define SCALER_HSCC2_inst                                                            0x0066
+#define SCALER_HSCC2_hscc2_c1_shift                                                  (16)
+#define SCALER_HSCC2_hscc2_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC2_hscc2_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC2_hscc2_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC2_get_hscc2_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC2_hscc2_c0_shift                                                  (0)
+#define SCALER_HSCC2_hscc2_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC2_hscc2_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC2_hscc2_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC2_get_hscc2_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC3                                                                 0x9C
+#define SCALER_HSCC3_reg_addr                                                        "0x9800419C"
+#define SCALER_HSCC3_reg                                                             0x9800419C
+#define set_SCALER_HSCC3_reg(data)   (*((volatile unsigned int*) SCALER_HSCC3_reg)=data)
+#define get_SCALER_HSCC3_reg   (*((volatile unsigned int*) SCALER_HSCC3_reg))
+#define SCALER_HSCC3_inst_adr                                                        "0x0067"
+#define SCALER_HSCC3_inst                                                            0x0067
+#define SCALER_HSCC3_hscc3_c1_shift                                                  (16)
+#define SCALER_HSCC3_hscc3_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC3_hscc3_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC3_hscc3_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC3_get_hscc3_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC3_hscc3_c0_shift                                                  (0)
+#define SCALER_HSCC3_hscc3_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC3_hscc3_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC3_hscc3_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC3_get_hscc3_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC4                                                                 0xA0
+#define SCALER_HSCC4_reg_addr                                                        "0x980041A0"
+#define SCALER_HSCC4_reg                                                             0x980041A0
+#define set_SCALER_HSCC4_reg(data)   (*((volatile unsigned int*) SCALER_HSCC4_reg)=data)
+#define get_SCALER_HSCC4_reg   (*((volatile unsigned int*) SCALER_HSCC4_reg))
+#define SCALER_HSCC4_inst_adr                                                        "0x0068"
+#define SCALER_HSCC4_inst                                                            0x0068
+#define SCALER_HSCC4_hscc4_c1_shift                                                  (16)
+#define SCALER_HSCC4_hscc4_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC4_hscc4_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC4_hscc4_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC4_get_hscc4_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC4_hscc4_c0_shift                                                  (0)
+#define SCALER_HSCC4_hscc4_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC4_hscc4_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC4_hscc4_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC4_get_hscc4_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC5                                                                 0xA4
+#define SCALER_HSCC5_reg_addr                                                        "0x980041A4"
+#define SCALER_HSCC5_reg                                                             0x980041A4
+#define set_SCALER_HSCC5_reg(data)   (*((volatile unsigned int*) SCALER_HSCC5_reg)=data)
+#define get_SCALER_HSCC5_reg   (*((volatile unsigned int*) SCALER_HSCC5_reg))
+#define SCALER_HSCC5_inst_adr                                                        "0x0069"
+#define SCALER_HSCC5_inst                                                            0x0069
+#define SCALER_HSCC5_hscc5_c1_shift                                                  (16)
+#define SCALER_HSCC5_hscc5_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC5_hscc5_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC5_hscc5_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC5_get_hscc5_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC5_hscc5_c0_shift                                                  (0)
+#define SCALER_HSCC5_hscc5_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC5_hscc5_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC5_hscc5_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC5_get_hscc5_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC6                                                                 0xA8
+#define SCALER_HSCC6_reg_addr                                                        "0x980041A8"
+#define SCALER_HSCC6_reg                                                             0x980041A8
+#define set_SCALER_HSCC6_reg(data)   (*((volatile unsigned int*) SCALER_HSCC6_reg)=data)
+#define get_SCALER_HSCC6_reg   (*((volatile unsigned int*) SCALER_HSCC6_reg))
+#define SCALER_HSCC6_inst_adr                                                        "0x006A"
+#define SCALER_HSCC6_inst                                                            0x006A
+#define SCALER_HSCC6_hscc6_c1_shift                                                  (16)
+#define SCALER_HSCC6_hscc6_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC6_hscc6_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC6_hscc6_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC6_get_hscc6_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC6_hscc6_c0_shift                                                  (0)
+#define SCALER_HSCC6_hscc6_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC6_hscc6_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC6_hscc6_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC6_get_hscc6_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC7                                                                 0xAC
+#define SCALER_HSCC7_reg_addr                                                        "0x980041AC"
+#define SCALER_HSCC7_reg                                                             0x980041AC
+#define set_SCALER_HSCC7_reg(data)   (*((volatile unsigned int*) SCALER_HSCC7_reg)=data)
+#define get_SCALER_HSCC7_reg   (*((volatile unsigned int*) SCALER_HSCC7_reg))
+#define SCALER_HSCC7_inst_adr                                                        "0x006B"
+#define SCALER_HSCC7_inst                                                            0x006B
+#define SCALER_HSCC7_hscc7_c1_shift                                                  (16)
+#define SCALER_HSCC7_hscc7_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC7_hscc7_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC7_hscc7_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC7_get_hscc7_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC7_hscc7_c0_shift                                                  (0)
+#define SCALER_HSCC7_hscc7_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC7_hscc7_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC7_hscc7_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC7_get_hscc7_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC0                                                                 0xB0
+#define SCALER_VSYC0_reg_addr                                                        "0x980041B0"
+#define SCALER_VSYC0_reg                                                             0x980041B0
+#define set_SCALER_VSYC0_reg(data)   (*((volatile unsigned int*) SCALER_VSYC0_reg)=data)
+#define get_SCALER_VSYC0_reg   (*((volatile unsigned int*) SCALER_VSYC0_reg))
+#define SCALER_VSYC0_inst_adr                                                        "0x006C"
+#define SCALER_VSYC0_inst                                                            0x006C
+#define SCALER_VSYC0_vsyc0_c1_shift                                                  (16)
+#define SCALER_VSYC0_vsyc0_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC0_vsyc0_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC0_vsyc0_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC0_get_vsyc0_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC0_vsyc0_c0_shift                                                  (0)
+#define SCALER_VSYC0_vsyc0_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC0_vsyc0_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC0_vsyc0_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC0_get_vsyc0_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC1                                                                 0xB4
+#define SCALER_VSYC1_reg_addr                                                        "0x980041B4"
+#define SCALER_VSYC1_reg                                                             0x980041B4
+#define set_SCALER_VSYC1_reg(data)   (*((volatile unsigned int*) SCALER_VSYC1_reg)=data)
+#define get_SCALER_VSYC1_reg   (*((volatile unsigned int*) SCALER_VSYC1_reg))
+#define SCALER_VSYC1_inst_adr                                                        "0x006D"
+#define SCALER_VSYC1_inst                                                            0x006D
+#define SCALER_VSYC1_vsyc1_c1_shift                                                  (16)
+#define SCALER_VSYC1_vsyc1_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC1_vsyc1_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC1_vsyc1_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC1_get_vsyc1_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC1_vsyc1_c0_shift                                                  (0)
+#define SCALER_VSYC1_vsyc1_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC1_vsyc1_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC1_vsyc1_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC1_get_vsyc1_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC2                                                                 0xB8
+#define SCALER_VSYC2_reg_addr                                                        "0x980041B8"
+#define SCALER_VSYC2_reg                                                             0x980041B8
+#define set_SCALER_VSYC2_reg(data)   (*((volatile unsigned int*) SCALER_VSYC2_reg)=data)
+#define get_SCALER_VSYC2_reg   (*((volatile unsigned int*) SCALER_VSYC2_reg))
+#define SCALER_VSYC2_inst_adr                                                        "0x006E"
+#define SCALER_VSYC2_inst                                                            0x006E
+#define SCALER_VSYC2_vsyc2_c1_shift                                                  (16)
+#define SCALER_VSYC2_vsyc2_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC2_vsyc2_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC2_vsyc2_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC2_get_vsyc2_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC2_vsyc2_c0_shift                                                  (0)
+#define SCALER_VSYC2_vsyc2_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC2_vsyc2_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC2_vsyc2_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC2_get_vsyc2_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC3                                                                 0xBC
+#define SCALER_VSYC3_reg_addr                                                        "0x980041BC"
+#define SCALER_VSYC3_reg                                                             0x980041BC
+#define set_SCALER_VSYC3_reg(data)   (*((volatile unsigned int*) SCALER_VSYC3_reg)=data)
+#define get_SCALER_VSYC3_reg   (*((volatile unsigned int*) SCALER_VSYC3_reg))
+#define SCALER_VSYC3_inst_adr                                                        "0x006F"
+#define SCALER_VSYC3_inst                                                            0x006F
+#define SCALER_VSYC3_vsyc3_c1_shift                                                  (16)
+#define SCALER_VSYC3_vsyc3_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC3_vsyc3_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC3_vsyc3_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC3_get_vsyc3_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC3_vsyc3_c0_shift                                                  (0)
+#define SCALER_VSYC3_vsyc3_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC3_vsyc3_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC3_vsyc3_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC3_get_vsyc3_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC0                                                                 0xC0
+#define SCALER_VSCC0_reg_addr                                                        "0x980041C0"
+#define SCALER_VSCC0_reg                                                             0x980041C0
+#define set_SCALER_VSCC0_reg(data)   (*((volatile unsigned int*) SCALER_VSCC0_reg)=data)
+#define get_SCALER_VSCC0_reg   (*((volatile unsigned int*) SCALER_VSCC0_reg))
+#define SCALER_VSCC0_inst_adr                                                        "0x0070"
+#define SCALER_VSCC0_inst                                                            0x0070
+#define SCALER_VSCC0_vscc0_c1_shift                                                  (16)
+#define SCALER_VSCC0_vscc0_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC0_vscc0_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC0_vscc0_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC0_get_vscc0_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC0_vscc0_c0_shift                                                  (0)
+#define SCALER_VSCC0_vscc0_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC0_vscc0_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC0_vscc0_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC0_get_vscc0_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC1                                                                 0xC4
+#define SCALER_VSCC1_reg_addr                                                        "0x980041C4"
+#define SCALER_VSCC1_reg                                                             0x980041C4
+#define set_SCALER_VSCC1_reg(data)   (*((volatile unsigned int*) SCALER_VSCC1_reg)=data)
+#define get_SCALER_VSCC1_reg   (*((volatile unsigned int*) SCALER_VSCC1_reg))
+#define SCALER_VSCC1_inst_adr                                                        "0x0071"
+#define SCALER_VSCC1_inst                                                            0x0071
+#define SCALER_VSCC1_vscc1_c1_shift                                                  (16)
+#define SCALER_VSCC1_vscc1_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC1_vscc1_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC1_vscc1_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC1_get_vscc1_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC1_vscc1_c0_shift                                                  (0)
+#define SCALER_VSCC1_vscc1_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC1_vscc1_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC1_vscc1_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC1_get_vscc1_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC2                                                                 0xC8
+#define SCALER_VSCC2_reg_addr                                                        "0x980041C8"
+#define SCALER_VSCC2_reg                                                             0x980041C8
+#define set_SCALER_VSCC2_reg(data)   (*((volatile unsigned int*) SCALER_VSCC2_reg)=data)
+#define get_SCALER_VSCC2_reg   (*((volatile unsigned int*) SCALER_VSCC2_reg))
+#define SCALER_VSCC2_inst_adr                                                        "0x0072"
+#define SCALER_VSCC2_inst                                                            0x0072
+#define SCALER_VSCC2_vscc2_c1_shift                                                  (16)
+#define SCALER_VSCC2_vscc2_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC2_vscc2_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC2_vscc2_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC2_get_vscc2_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC2_vscc2_c0_shift                                                  (0)
+#define SCALER_VSCC2_vscc2_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC2_vscc2_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC2_vscc2_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC2_get_vscc2_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC3                                                                 0xCC
+#define SCALER_VSCC3_reg_addr                                                        "0x980041CC"
+#define SCALER_VSCC3_reg                                                             0x980041CC
+#define set_SCALER_VSCC3_reg(data)   (*((volatile unsigned int*) SCALER_VSCC3_reg)=data)
+#define get_SCALER_VSCC3_reg   (*((volatile unsigned int*) SCALER_VSCC3_reg))
+#define SCALER_VSCC3_inst_adr                                                        "0x0073"
+#define SCALER_VSCC3_inst                                                            0x0073
+#define SCALER_VSCC3_vscc3_c1_shift                                                  (16)
+#define SCALER_VSCC3_vscc3_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC3_vscc3_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC3_vscc3_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC3_get_vscc3_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC3_vscc3_c0_shift                                                  (0)
+#define SCALER_VSCC3_vscc3_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC3_vscc3_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC3_vscc3_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC3_get_vscc3_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define CONSTANT_ALPHA                                                               0xD0
+#define CONSTANT_ALPHA_reg_addr                                                      "0x980041D0"
+#define CONSTANT_ALPHA_reg                                                           0x980041D0
+#define set_CONSTANT_ALPHA_reg(data)   (*((volatile unsigned int*) CONSTANT_ALPHA_reg)=data)
+#define get_CONSTANT_ALPHA_reg   (*((volatile unsigned int*) CONSTANT_ALPHA_reg))
+#define CONSTANT_ALPHA_inst_adr                                                      "0x0074"
+#define CONSTANT_ALPHA_inst                                                          0x0074
+#define CONSTANT_ALPHA_alpha_shift                                                   (0)
+#define CONSTANT_ALPHA_alpha_mask                                                    (0x000000FF)
+#define CONSTANT_ALPHA_alpha(data)                                                   (0x000000FF&((data)<<0))
+#define CONSTANT_ALPHA_alpha_src(data)                                               ((0x000000FF&(data))>>0)
+#define CONSTANT_ALPHA_get_alpha(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define MIPI_BIST_MODE                                                               0xD4
+#define MIPI_BIST_MODE_reg_addr                                                      "0x980041D4"
+#define MIPI_BIST_MODE_reg                                                           0x980041D4
+#define set_MIPI_BIST_MODE_reg(data)   (*((volatile unsigned int*) MIPI_BIST_MODE_reg)=data)
+#define get_MIPI_BIST_MODE_reg   (*((volatile unsigned int*) MIPI_BIST_MODE_reg))
+#define MIPI_BIST_MODE_inst_adr                                                      "0x0075"
+#define MIPI_BIST_MODE_inst                                                          0x0075
+#define MIPI_BIST_MODE_drf_test_resume_shift                                         (2)
+#define MIPI_BIST_MODE_drf_test_resume_mask                                          (0x00000004)
+#define MIPI_BIST_MODE_drf_test_resume(data)                                         (0x00000004&((data)<<2))
+#define MIPI_BIST_MODE_drf_test_resume_src(data)                                     ((0x00000004&(data))>>2)
+#define MIPI_BIST_MODE_get_drf_test_resume(data)                                     ((0x00000004&(data))>>2)
+#define MIPI_BIST_MODE_drf_bist_mode_shift                                           (1)
+#define MIPI_BIST_MODE_drf_bist_mode_mask                                            (0x00000002)
+#define MIPI_BIST_MODE_drf_bist_mode(data)                                           (0x00000002&((data)<<1))
+#define MIPI_BIST_MODE_drf_bist_mode_src(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_BIST_MODE_get_drf_bist_mode(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_BIST_MODE_bist_mode_shift                                               (0)
+#define MIPI_BIST_MODE_bist_mode_mask                                                (0x00000001)
+#define MIPI_BIST_MODE_bist_mode(data)                                               (0x00000001&((data)<<0))
+#define MIPI_BIST_MODE_bist_mode_src(data)                                           ((0x00000001&(data))>>0)
+#define MIPI_BIST_MODE_get_bist_mode(data)                                           ((0x00000001&(data))>>0)
+
+
+#define MIPI_BIST_RESULT0                                                            0xD8
+#define MIPI_BIST_RESULT0_reg_addr                                                   "0x980041D8"
+#define MIPI_BIST_RESULT0_reg                                                        0x980041D8
+#define set_MIPI_BIST_RESULT0_reg(data)   (*((volatile unsigned int*) MIPI_BIST_RESULT0_reg)=data)
+#define get_MIPI_BIST_RESULT0_reg   (*((volatile unsigned int*) MIPI_BIST_RESULT0_reg))
+#define MIPI_BIST_RESULT0_inst_adr                                                   "0x0076"
+#define MIPI_BIST_RESULT0_inst                                                       0x0076
+#define MIPI_BIST_RESULT0_drf_start_pause_shift                                      (10)
+#define MIPI_BIST_RESULT0_drf_start_pause_mask                                       (0x00000400)
+#define MIPI_BIST_RESULT0_drf_start_pause(data)                                      (0x00000400&((data)<<10))
+#define MIPI_BIST_RESULT0_drf_start_pause_src(data)                                  ((0x00000400&(data))>>10)
+#define MIPI_BIST_RESULT0_get_drf_start_pause(data)                                  ((0x00000400&(data))>>10)
+#define MIPI_BIST_RESULT0_drf_bist_fail3_shift                                       (9)
+#define MIPI_BIST_RESULT0_drf_bist_fail3_mask                                        (0x00000200)
+#define MIPI_BIST_RESULT0_drf_bist_fail3(data)                                       (0x00000200&((data)<<9))
+#define MIPI_BIST_RESULT0_drf_bist_fail3_src(data)                                   ((0x00000200&(data))>>9)
+#define MIPI_BIST_RESULT0_get_drf_bist_fail3(data)                                   ((0x00000200&(data))>>9)
+#define MIPI_BIST_RESULT0_drf_bist_fail2_shift                                       (8)
+#define MIPI_BIST_RESULT0_drf_bist_fail2_mask                                        (0x00000100)
+#define MIPI_BIST_RESULT0_drf_bist_fail2(data)                                       (0x00000100&((data)<<8))
+#define MIPI_BIST_RESULT0_drf_bist_fail2_src(data)                                   ((0x00000100&(data))>>8)
+#define MIPI_BIST_RESULT0_get_drf_bist_fail2(data)                                   ((0x00000100&(data))>>8)
+#define MIPI_BIST_RESULT0_drf_bist_fail1_shift                                       (7)
+#define MIPI_BIST_RESULT0_drf_bist_fail1_mask                                        (0x00000080)
+#define MIPI_BIST_RESULT0_drf_bist_fail1(data)                                       (0x00000080&((data)<<7))
+#define MIPI_BIST_RESULT0_drf_bist_fail1_src(data)                                   ((0x00000080&(data))>>7)
+#define MIPI_BIST_RESULT0_get_drf_bist_fail1(data)                                   ((0x00000080&(data))>>7)
+#define MIPI_BIST_RESULT0_drf_bist_fail0_shift                                       (6)
+#define MIPI_BIST_RESULT0_drf_bist_fail0_mask                                        (0x00000040)
+#define MIPI_BIST_RESULT0_drf_bist_fail0(data)                                       (0x00000040&((data)<<6))
+#define MIPI_BIST_RESULT0_drf_bist_fail0_src(data)                                   ((0x00000040&(data))>>6)
+#define MIPI_BIST_RESULT0_get_drf_bist_fail0(data)                                   ((0x00000040&(data))>>6)
+#define MIPI_BIST_RESULT0_drf_bist_done_shift                                        (5)
+#define MIPI_BIST_RESULT0_drf_bist_done_mask                                         (0x00000020)
+#define MIPI_BIST_RESULT0_drf_bist_done(data)                                        (0x00000020&((data)<<5))
+#define MIPI_BIST_RESULT0_drf_bist_done_src(data)                                    ((0x00000020&(data))>>5)
+#define MIPI_BIST_RESULT0_get_drf_bist_done(data)                                    ((0x00000020&(data))>>5)
+#define MIPI_BIST_RESULT0_bist_fail3_shift                                           (4)
+#define MIPI_BIST_RESULT0_bist_fail3_mask                                            (0x00000010)
+#define MIPI_BIST_RESULT0_bist_fail3(data)                                           (0x00000010&((data)<<4))
+#define MIPI_BIST_RESULT0_bist_fail3_src(data)                                       ((0x00000010&(data))>>4)
+#define MIPI_BIST_RESULT0_get_bist_fail3(data)                                       ((0x00000010&(data))>>4)
+#define MIPI_BIST_RESULT0_bist_fail2_shift                                           (3)
+#define MIPI_BIST_RESULT0_bist_fail2_mask                                            (0x00000008)
+#define MIPI_BIST_RESULT0_bist_fail2(data)                                           (0x00000008&((data)<<3))
+#define MIPI_BIST_RESULT0_bist_fail2_src(data)                                       ((0x00000008&(data))>>3)
+#define MIPI_BIST_RESULT0_get_bist_fail2(data)                                       ((0x00000008&(data))>>3)
+#define MIPI_BIST_RESULT0_bist_fail1_shift                                           (2)
+#define MIPI_BIST_RESULT0_bist_fail1_mask                                            (0x00000004)
+#define MIPI_BIST_RESULT0_bist_fail1(data)                                           (0x00000004&((data)<<2))
+#define MIPI_BIST_RESULT0_bist_fail1_src(data)                                       ((0x00000004&(data))>>2)
+#define MIPI_BIST_RESULT0_get_bist_fail1(data)                                       ((0x00000004&(data))>>2)
+#define MIPI_BIST_RESULT0_bist_fail0_shift                                           (1)
+#define MIPI_BIST_RESULT0_bist_fail0_mask                                            (0x00000002)
+#define MIPI_BIST_RESULT0_bist_fail0(data)                                           (0x00000002&((data)<<1))
+#define MIPI_BIST_RESULT0_bist_fail0_src(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_BIST_RESULT0_get_bist_fail0(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_BIST_RESULT0_bist_done_shift                                            (0)
+#define MIPI_BIST_RESULT0_bist_done_mask                                             (0x00000001)
+#define MIPI_BIST_RESULT0_bist_done(data)                                            (0x00000001&((data)<<0))
+#define MIPI_BIST_RESULT0_bist_done_src(data)                                        ((0x00000001&(data))>>0)
+#define MIPI_BIST_RESULT0_get_bist_done(data)                                        ((0x00000001&(data))>>0)
+
+
+#define MIPI_BIST_RESULT1                                                            0xDC
+#define MIPI_BIST_RESULT1_reg_addr                                                   "0x980041DC"
+#define MIPI_BIST_RESULT1_reg                                                        0x980041DC
+#define set_MIPI_BIST_RESULT1_reg(data)   (*((volatile unsigned int*) MIPI_BIST_RESULT1_reg)=data)
+#define get_MIPI_BIST_RESULT1_reg   (*((volatile unsigned int*) MIPI_BIST_RESULT1_reg))
+#define MIPI_BIST_RESULT1_inst_adr                                                   "0x0077"
+#define MIPI_BIST_RESULT1_inst                                                       0x0077
+#define MIPI_BIST_RESULT1_clk_gate_l4_dis_shift                                      (8)
+#define MIPI_BIST_RESULT1_clk_gate_l4_dis_mask                                       (0x00000100)
+#define MIPI_BIST_RESULT1_clk_gate_l4_dis(data)                                      (0x00000100&((data)<<8))
+#define MIPI_BIST_RESULT1_clk_gate_l4_dis_src(data)                                  ((0x00000100&(data))>>8)
+#define MIPI_BIST_RESULT1_get_clk_gate_l4_dis(data)                                  ((0x00000100&(data))>>8)
+#define MIPI_BIST_RESULT1_clk_gate_dbus_dis_shift                                    (7)
+#define MIPI_BIST_RESULT1_clk_gate_dbus_dis_mask                                     (0x00000080)
+#define MIPI_BIST_RESULT1_clk_gate_dbus_dis(data)                                    (0x00000080&((data)<<7))
+#define MIPI_BIST_RESULT1_clk_gate_dbus_dis_src(data)                                ((0x00000080&(data))>>7)
+#define MIPI_BIST_RESULT1_get_clk_gate_dbus_dis(data)                                ((0x00000080&(data))>>7)
+#define MIPI_BIST_RESULT1_sram_ls_gate_en_shift                                      (6)
+#define MIPI_BIST_RESULT1_sram_ls_gate_en_mask                                       (0x00000040)
+#define MIPI_BIST_RESULT1_sram_ls_gate_en(data)                                      (0x00000040&((data)<<6))
+#define MIPI_BIST_RESULT1_sram_ls_gate_en_src(data)                                  ((0x00000040&(data))>>6)
+#define MIPI_BIST_RESULT1_get_sram_ls_gate_en(data)                                  ((0x00000040&(data))>>6)
+#define MIPI_BIST_RESULT1_sram_ls_shift                                              (5)
+#define MIPI_BIST_RESULT1_sram_ls_mask                                               (0x00000020)
+#define MIPI_BIST_RESULT1_sram_ls(data)                                              (0x00000020&((data)<<5))
+#define MIPI_BIST_RESULT1_sram_ls_src(data)                                          ((0x00000020&(data))>>5)
+#define MIPI_BIST_RESULT1_get_sram_ls(data)                                          ((0x00000020&(data))>>5)
+#define MIPI_BIST_RESULT1_sram_rm_shift                                              (1)
+#define MIPI_BIST_RESULT1_sram_rm_mask                                               (0x0000001E)
+#define MIPI_BIST_RESULT1_sram_rm(data)                                              (0x0000001E&((data)<<1))
+#define MIPI_BIST_RESULT1_sram_rm_src(data)                                          ((0x0000001E&(data))>>1)
+#define MIPI_BIST_RESULT1_get_sram_rm(data)                                          ((0x0000001E&(data))>>1)
+#define MIPI_BIST_RESULT1_sram_rme_shift                                             (0)
+#define MIPI_BIST_RESULT1_sram_rme_mask                                              (0x00000001)
+#define MIPI_BIST_RESULT1_sram_rme(data)                                             (0x00000001&((data)<<0))
+#define MIPI_BIST_RESULT1_sram_rme_src(data)                                         ((0x00000001&(data))>>0)
+#define MIPI_BIST_RESULT1_get_sram_rme(data)                                         ((0x00000001&(data))>>0)
+
+
+#define MIPI_SA0_UV                                                                  0xE0
+#define MIPI_SA0_UV_reg_addr                                                         "0x980041E0"
+#define MIPI_SA0_UV_reg                                                              0x980041E0
+#define set_MIPI_SA0_UV_reg(data)   (*((volatile unsigned int*) MIPI_SA0_UV_reg)=data)
+#define get_MIPI_SA0_UV_reg   (*((volatile unsigned int*) MIPI_SA0_UV_reg))
+#define MIPI_SA0_UV_inst_adr                                                         "0x0078"
+#define MIPI_SA0_UV_inst                                                             0x0078
+#define MIPI_SA0_UV_sa0_video_uv_shift                                               (0)
+#define MIPI_SA0_UV_sa0_video_uv_mask                                                (0xFFFFFFFF)
+#define MIPI_SA0_UV_sa0_video_uv(data)                                               (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA0_UV_sa0_video_uv_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA0_UV_get_sa0_video_uv(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SA1_UV                                                                  0xE4
+#define MIPI_SA1_UV_reg_addr                                                         "0x980041E4"
+#define MIPI_SA1_UV_reg                                                              0x980041E4
+#define set_MIPI_SA1_UV_reg(data)   (*((volatile unsigned int*) MIPI_SA1_UV_reg)=data)
+#define get_MIPI_SA1_UV_reg   (*((volatile unsigned int*) MIPI_SA1_UV_reg))
+#define MIPI_SA1_UV_inst_adr                                                         "0x0079"
+#define MIPI_SA1_UV_inst                                                             0x0079
+#define MIPI_SA1_UV_sa1_video_uv_shift                                               (0)
+#define MIPI_SA1_UV_sa1_video_uv_mask                                                (0xFFFFFFFF)
+#define MIPI_SA1_UV_sa1_video_uv(data)                                               (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA1_UV_sa1_video_uv_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA1_UV_get_sa1_video_uv(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SA2_UV                                                                  0xE8
+#define MIPI_SA2_UV_reg_addr                                                         "0x980041E8"
+#define MIPI_SA2_UV_reg                                                              0x980041E8
+#define set_MIPI_SA2_UV_reg(data)   (*((volatile unsigned int*) MIPI_SA2_UV_reg)=data)
+#define get_MIPI_SA2_UV_reg   (*((volatile unsigned int*) MIPI_SA2_UV_reg))
+#define MIPI_SA2_UV_inst_adr                                                         "0x007A"
+#define MIPI_SA2_UV_inst                                                             0x007A
+#define MIPI_SA2_UV_sa2_pic_uv_shift                                                 (0)
+#define MIPI_SA2_UV_sa2_pic_uv_mask                                                  (0xFFFFFFFF)
+#define MIPI_SA2_UV_sa2_pic_uv(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA2_UV_sa2_pic_uv_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA2_UV_get_sa2_pic_uv(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_RESET                                                                   0xEC
+#define MIPI_RESET_reg_addr                                                          "0x980041EC"
+#define MIPI_RESET_reg                                                               0x980041EC
+#define set_MIPI_RESET_reg(data)   (*((volatile unsigned int*) MIPI_RESET_reg)=data)
+#define get_MIPI_RESET_reg   (*((volatile unsigned int*) MIPI_RESET_reg))
+#define MIPI_RESET_inst_adr                                                          "0x007B"
+#define MIPI_RESET_inst                                                              0x007B
+#define MIPI_RESET_pic_detect_en_shift                                               (2)
+#define MIPI_RESET_pic_detect_en_mask                                                (0x00000004)
+#define MIPI_RESET_pic_detect_en(data)                                               (0x00000004&((data)<<2))
+#define MIPI_RESET_pic_detect_en_src(data)                                           ((0x00000004&(data))>>2)
+#define MIPI_RESET_get_pic_detect_en(data)                                           ((0x00000004&(data))>>2)
+#define MIPI_RESET_pic_detect_int_en_shift                                           (1)
+#define MIPI_RESET_pic_detect_int_en_mask                                            (0x00000002)
+#define MIPI_RESET_pic_detect_int_en(data)                                           (0x00000002&((data)<<1))
+#define MIPI_RESET_pic_detect_int_en_src(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_RESET_get_pic_detect_int_en(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_RESET_mipi_sw_rst_shift                                                 (0)
+#define MIPI_RESET_mipi_sw_rst_mask                                                  (0x00000001)
+#define MIPI_RESET_mipi_sw_rst(data)                                                 (0x00000001&((data)<<0))
+#define MIPI_RESET_mipi_sw_rst_src(data)                                             ((0x00000001&(data))>>0)
+#define MIPI_RESET_get_mipi_sw_rst(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MIPI_DEBUGPORTS                                                              0xF0
+#define MIPI_DEBUGPORTS_reg_addr                                                     "0x980041F0"
+#define MIPI_DEBUGPORTS_reg                                                          0x980041F0
+#define set_MIPI_DEBUGPORTS_reg(data)   (*((volatile unsigned int*) MIPI_DEBUGPORTS_reg)=data)
+#define get_MIPI_DEBUGPORTS_reg   (*((volatile unsigned int*) MIPI_DEBUGPORTS_reg))
+#define MIPI_DEBUGPORTS_inst_adr                                                     "0x007C"
+#define MIPI_DEBUGPORTS_inst                                                         0x007C
+#define MIPI_DEBUGPORTS_dbg_sel_shift                                                (8)
+#define MIPI_DEBUGPORTS_dbg_sel_mask                                                 (0x00000100)
+#define MIPI_DEBUGPORTS_dbg_sel(data)                                                (0x00000100&((data)<<8))
+#define MIPI_DEBUGPORTS_dbg_sel_src(data)                                            ((0x00000100&(data))>>8)
+#define MIPI_DEBUGPORTS_get_dbg_sel(data)                                            ((0x00000100&(data))>>8)
+#define MIPI_DEBUGPORTS_dbg_sel1_shift                                               (4)
+#define MIPI_DEBUGPORTS_dbg_sel1_mask                                                (0x000000F0)
+#define MIPI_DEBUGPORTS_dbg_sel1(data)                                               (0x000000F0&((data)<<4))
+#define MIPI_DEBUGPORTS_dbg_sel1_src(data)                                           ((0x000000F0&(data))>>4)
+#define MIPI_DEBUGPORTS_get_dbg_sel1(data)                                           ((0x000000F0&(data))>>4)
+#define MIPI_DEBUGPORTS_dbg_sel0_shift                                               (0)
+#define MIPI_DEBUGPORTS_dbg_sel0_mask                                                (0x0000000F)
+#define MIPI_DEBUGPORTS_dbg_sel0(data)                                               (0x0000000F&((data)<<0))
+#define MIPI_DEBUGPORTS_dbg_sel0_src(data)                                           ((0x0000000F&(data))>>0)
+#define MIPI_DEBUGPORTS_get_dbg_sel0(data)                                           ((0x0000000F&(data))>>0)
+
+
+#define MIPI_DUMMY_REG0                                                              0xF4
+#define MIPI_DUMMY_REG0_reg_addr                                                     "0x980041F4"
+#define MIPI_DUMMY_REG0_reg                                                          0x980041F4
+#define set_MIPI_DUMMY_REG0_reg(data)   (*((volatile unsigned int*) MIPI_DUMMY_REG0_reg)=data)
+#define get_MIPI_DUMMY_REG0_reg   (*((volatile unsigned int*) MIPI_DUMMY_REG0_reg))
+#define MIPI_DUMMY_REG0_inst_adr                                                     "0x007D"
+#define MIPI_DUMMY_REG0_inst                                                         0x007D
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0_shift                                        (0)
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0_mask                                         (0xFFFFFFFF)
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0(data)                                        (0xFFFFFFFF&((data)<<0))
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define MIPI_DUMMY_REG0_get_mipi_dummy_reg0(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_DUMMY_REG1                                                              0xF8
+#define MIPI_DUMMY_REG1_reg_addr                                                     "0x980041F8"
+#define MIPI_DUMMY_REG1_reg                                                          0x980041F8
+#define set_MIPI_DUMMY_REG1_reg(data)   (*((volatile unsigned int*) MIPI_DUMMY_REG1_reg)=data)
+#define get_MIPI_DUMMY_REG1_reg   (*((volatile unsigned int*) MIPI_DUMMY_REG1_reg))
+#define MIPI_DUMMY_REG1_inst_adr                                                     "0x007E"
+#define MIPI_DUMMY_REG1_inst                                                         0x007E
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1_shift                                        (0)
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1_mask                                         (0xFFFFFFFF)
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1(data)                                        (0xFFFFFFFF&((data)<<0))
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define MIPI_DUMMY_REG1_get_mipi_dummy_reg1(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SIZE3                                                                   0xFC
+#define MIPI_SIZE3_reg_addr                                                          "0x980041FC"
+#define MIPI_SIZE3_reg                                                               0x980041FC
+#define set_MIPI_SIZE3_reg(data)   (*((volatile unsigned int*) MIPI_SIZE3_reg)=data)
+#define get_MIPI_SIZE3_reg   (*((volatile unsigned int*) MIPI_SIZE3_reg))
+#define MIPI_SIZE3_inst_adr                                                          "0x007F"
+#define MIPI_SIZE3_inst                                                              0x007F
+#define MIPI_SIZE3_src_height_shift                                                  (0)
+#define MIPI_SIZE3_src_height_mask                                                   (0x00001FFF)
+#define MIPI_SIZE3_src_height(data)                                                  (0x00001FFF&((data)<<0))
+#define MIPI_SIZE3_src_height_src(data)                                              ((0x00001FFF&(data))>>0)
+#define MIPI_SIZE3_get_src_height(data)                                              ((0x00001FFF&(data))>>0)
+
+
+#define MIPI_RESOLUTION_DETECT                                                       0x100
+#define MIPI_RESOLUTION_DETECT_reg_addr                                              "0x98004200"
+#define MIPI_RESOLUTION_DETECT_reg                                                   0x98004200
+#define set_MIPI_RESOLUTION_DETECT_reg(data)   (*((volatile unsigned int*) MIPI_RESOLUTION_DETECT_reg)=data)
+#define get_MIPI_RESOLUTION_DETECT_reg   (*((volatile unsigned int*) MIPI_RESOLUTION_DETECT_reg))
+#define MIPI_RESOLUTION_DETECT_inst_adr                                              "0x0080"
+#define MIPI_RESOLUTION_DETECT_inst                                                  0x0080
+#define MIPI_RESOLUTION_DETECT_pic_detect_vcnt_shift                                 (13)
+#define MIPI_RESOLUTION_DETECT_pic_detect_vcnt_mask                                  (0x03FFE000)
+#define MIPI_RESOLUTION_DETECT_pic_detect_vcnt(data)                                 (0x03FFE000&((data)<<13))
+#define MIPI_RESOLUTION_DETECT_pic_detect_vcnt_src(data)                             ((0x03FFE000&(data))>>13)
+#define MIPI_RESOLUTION_DETECT_get_pic_detect_vcnt(data)                             ((0x03FFE000&(data))>>13)
+#define MIPI_RESOLUTION_DETECT_pic_detect_hcnt_shift                                 (0)
+#define MIPI_RESOLUTION_DETECT_pic_detect_hcnt_mask                                  (0x00001FFF)
+#define MIPI_RESOLUTION_DETECT_pic_detect_hcnt(data)                                 (0x00001FFF&((data)<<0))
+#define MIPI_RESOLUTION_DETECT_pic_detect_hcnt_src(data)                             ((0x00001FFF&(data))>>0)
+#define MIPI_RESOLUTION_DETECT_get_pic_detect_hcnt(data)                             ((0x00001FFF&(data))>>0)
+
+
+#define MIPI_URGENT                                                                  0x104
+#define MIPI_URGENT_reg_addr                                                         "0x98004204"
+#define MIPI_URGENT_reg                                                              0x98004204
+#define set_MIPI_URGENT_reg(data)   (*((volatile unsigned int*) MIPI_URGENT_reg)=data)
+#define get_MIPI_URGENT_reg   (*((volatile unsigned int*) MIPI_URGENT_reg))
+#define MIPI_URGENT_inst_adr                                                         "0x0081"
+#define MIPI_URGENT_inst                                                             0x0081
+#define MIPI_URGENT_buf_up_bound_shift                                               (0)
+#define MIPI_URGENT_buf_up_bound_mask                                                (0x0000003F)
+#define MIPI_URGENT_buf_up_bound(data)                                               (0x0000003F&((data)<<0))
+#define MIPI_URGENT_buf_up_bound_src(data)                                           ((0x0000003F&(data))>>0)
+#define MIPI_URGENT_get_buf_up_bound(data)                                           ((0x0000003F&(data))>>0)
+
+
+#define MIPI_BUF_USAGE                                                               0x108
+#define MIPI_BUF_USAGE_reg_addr                                                      "0x98004208"
+#define MIPI_BUF_USAGE_reg                                                           0x98004208
+#define set_MIPI_BUF_USAGE_reg(data)   (*((volatile unsigned int*) MIPI_BUF_USAGE_reg)=data)
+#define get_MIPI_BUF_USAGE_reg   (*((volatile unsigned int*) MIPI_BUF_USAGE_reg))
+#define MIPI_BUF_USAGE_inst_adr                                                      "0x0082"
+#define MIPI_BUF_USAGE_inst                                                          0x0082
+#define MIPI_BUF_USAGE_mipi_buf_usage_shift                                          (0)
+#define MIPI_BUF_USAGE_mipi_buf_usage_mask                                           (0x0000003F)
+#define MIPI_BUF_USAGE_mipi_buf_usage(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_BUF_USAGE_mipi_buf_usage_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_BUF_USAGE_get_mipi_buf_usage(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define ISOLATION_ENABLE                                                             0x10C
+#define ISOLATION_ENABLE_reg_addr                                                    "0x9800420C"
+#define ISOLATION_ENABLE_reg                                                         0x9800420C
+#define set_ISOLATION_ENABLE_reg(data)   (*((volatile unsigned int*) ISOLATION_ENABLE_reg)=data)
+#define get_ISOLATION_ENABLE_reg   (*((volatile unsigned int*) ISOLATION_ENABLE_reg))
+#define ISOLATION_ENABLE_inst_adr                                                    "0x0083"
+#define ISOLATION_ENABLE_inst                                                        0x0083
+#define ISOLATION_ENABLE_mipi_isolation_enable_shift                                 (0)
+#define ISOLATION_ENABLE_mipi_isolation_enable_mask                                  (0x00000001)
+#define ISOLATION_ENABLE_mipi_isolation_enable(data)                                 (0x00000001&((data)<<0))
+#define ISOLATION_ENABLE_mipi_isolation_enable_src(data)                             ((0x00000001&(data))>>0)
+#define ISOLATION_ENABLE_get_mipi_isolation_enable(data)                             ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/Makefile b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/Makefile
new file mode 100644
index 00000000..59aecc8
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/Makefile
@@ -0,0 +1,8 @@
+
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmirx/rtd129x/reg_include
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmirx/rtd129x/
+ccflags-y += -I$(srctree)/drivers/staging/android/
+ccflags-y += -I$(srctree)/drivers/tee
+
+obj-$(CONFIG_RTK_HDMIRX)    += hdmiHdmi.o hdmiEDID.o hdmiPhy.o hdmiMS.o
+obj-$(CONFIG_RTK_HDCPRX_1P4_TEE) += TEE2p1_HDCP1p4_ENTRY.o
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/TEE2p1_HDCP1p4_ENTRY.c b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/TEE2p1_HDCP1p4_ENTRY.c
new file mode 100644
index 00000000..48957e7
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/TEE2p1_HDCP1p4_ENTRY.c
@@ -0,0 +1,112 @@
+/*
+ * TEE2p1_HDCP1p4_ENTRY.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/cdev.h>
+#include <linux/device.h>
+#include <linux/fs.h>
+#include <linux/idr.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include <linux/uaccess.h>
+
+#include "tee_private.h"
+#include "tee_client_api.h"
+
+#define TA_HDCP1p4RX_UUID {0x0df2fadb, 0xb2e0, 0x4345, \
+		{0xa4, 0x91, 0xef, 0x0a, 0xcf, 0xae, 0xd1, 0x84} }
+#define TA_HELLO_WORLD_CMD_INC_VALUE 0xff
+#define TA_HDCP1p4_KEY 0x0e
+
+struct tee_context *ctx_HDCP1p4;
+struct tee_ioctl_open_session_arg arg_HDCP1p4;
+struct tee_param  param_HDCP1p4[4];
+
+extern int TEE2p1_Flag;
+
+void HDCP1p4_ta_init(void)
+{
+	TEEC_UUID test_id =	TA_HDCP1p4RX_UUID;
+
+	ctx_HDCP1p4 = tee_client_open_context(NULL, NULL, NULL, NULL);
+
+	memcpy(&arg_HDCP1p4.uuid, &test_id, sizeof(test_id));
+
+	arg_HDCP1p4.clnt_login = TEEC_LOGIN_PUBLIC;
+	arg_HDCP1p4.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	param_HDCP1p4[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param_HDCP1p4[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param_HDCP1p4[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param_HDCP1p4[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_open_session(ctx_HDCP1p4, &arg_HDCP1p4, &param_HDCP1p4);
+
+}
+
+
+int HDCP1p4_ta_deinit(void)
+{
+	int result;
+
+	result = tee_client_close_session(ctx_HDCP1p4, arg_HDCP1p4.session);
+
+	return result;
+}
+
+
+unsigned char  T_KEY[5];
+int  CA_hdcp1p4_RX_SET_KEY(void)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+	struct tee_shm *shm;
+
+	arg_I.func = TA_HDCP1p4_KEY;
+	arg_I.session = arg_HDCP1p4.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+	shm = tee_shm_alloc(ctx_HDCP1p4, 1, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+	invoke_param[1].u.memref.size = 1;
+	invoke_param[1].u.memref.shm = shm;
+
+	memcpy(invoke_param[1].u.memref.shm->kaddr, T_KEY, 1);
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx_HDCP1p4, &arg_I, invoke_param);
+
+	return 0;
+}
+
+void CA_hdcp1p4_load(void)
+{
+	if (TEE2p1_Flag == 0)
+		return;
+
+	HDCP1p4_ta_init();
+	CA_hdcp1p4_RX_SET_KEY();
+	HDCP1p4_ta_deinit();
+
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiEDID.c b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiEDID.c
new file mode 100644
index 00000000..7b35b0f
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiEDID.c
@@ -0,0 +1,300 @@
+/*
+ * hdmiEDID.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/string.h>
+#include <linux/types.h>
+
+#include "v4l2_hdmi_dev.h"
+#include "mipi_wrapper.h"
+#include "hdmiEDID.h"
+#include "hdmirx_reg.h"
+#include "hdmiInternal.h"
+
+/*=================== extern Variable/Function ===================*/
+extern MIPI_TOP_INFO mipi_top;
+
+extern void Hdmi_SetHPD(char high);
+
+#ifdef CONFIG_RTK_HDMITX
+extern int hdmitx_switch_get_state(void);
+#endif
+/*======================================================*/
+
+static void hotplug_pulses_work_fun(struct work_struct *work);
+static DECLARE_WORK(hotplug_pulses_work, hotplug_pulses_work_fun);
+
+HDMIRX_DTS_EDID_TBL_T hdmirx_edid;
+HDMIRX_DTS_EDID_TBL_T hdmirx_edid2p0;
+static int rx_edid_version = 0;/* 0:HDMI 1.4 , 1:HDMI 2.0 */
+
+static void hotplug_pulses_work_fun(struct work_struct *work)
+{
+	HDMIRX_INFO("Set hotplug pulse");
+
+	Hdmi_SetHPD(0);
+	msleep(1000);
+	Hdmi_SetHPD(1);
+}
+
+void HdmiRx_hotplug_pulses(void)
+{
+	if (!mipi_top.hdmi_rx_init)
+		return;
+
+	schedule_work(&hotplug_pulses_work);
+}
+
+char EDIDIsValid(unsigned char *EDID)
+{
+	if (EDID == NULL)
+		return false;
+
+	if ((EDID[0] != 0x0) || (EDID[1] != 0xff) || (EDID[6] != 0xff) || (EDID[7] != 0x0))
+		return false;
+
+	return true;
+}
+
+
+unsigned char drvif_EDIDLoad(unsigned char *EDID, int len)
+{
+	int i;
+
+	if (EDIDIsValid(EDID) == false)
+		return false;
+
+	/* Disable DDC func, write EDID data to sram */
+	hdmi_rx_reg_mask32(DDC2_EDID_CR, ~DDC2_EDID_CR_edid_en_mask, DDC2_EDID_CR_edid_en(0), HDMI_RX_DDC);
+
+
+	for (i = 0; i < len; i++)  {
+		/* total 0 ~ 127 */
+		hdmi_rx_reg_write32(DDC2_DDC_SIR, i, HDMI_RX_DDC);
+		hdmi_rx_reg_write32(DDC2_DDC_SAP, EDID[i], HDMI_RX_DDC);
+	}
+
+	/* Set to No Debounce */
+	hdmi_rx_reg_write32(DDC2_I2C_CR, 0x00, HDMI_RX_DDC);
+
+	/* Enable DDC func */
+	hdmi_rx_reg_mask32(DDC2_EDID_CR, ~DDC2_EDID_CR_edid_en_mask, DDC2_EDID_CR_edid_en(1), HDMI_RX_DDC);
+
+	return true;
+}
+
+void drvif_EDID_DDC12_AUTO_Enable(char enable)
+{
+	hdmi_rx_reg_mask32(DDC2_EDID_CR, ~(DDC2_EDID_CR_ddc2_force_mask | DDC2_EDID_CR_ddc2b_force_mask),
+				(DDC2_EDID_CR_ddc2_force(0) | DDC2_EDID_CR_ddc2b_force((enable)?0:1)), HDMI_RX_DDC);
+
+}
+
+unsigned char HdmiRx_change_edid_physical_addr(unsigned char byteMSB, unsigned char byteLSB)
+{
+	unsigned char ret = false;
+	unsigned char block_tag = 0;
+	unsigned char block_size;
+	unsigned char offset;
+	unsigned char offset_max;
+	unsigned int i;
+	unsigned int sum = 0;
+	HDMIRX_DTS_EDID_TBL_T *EDID_table;
+
+	if ((rx_edid_version == 1) && (hdmirx_edid2p0.valid == true))
+		EDID_table = &hdmirx_edid2p0;
+	else
+		EDID_table = &hdmirx_edid;
+
+	offset = 0x84;/* First data block */
+	offset_max = 0x80+EDID_table->EDID[0x82];
+
+	while (offset < offset_max) {
+		block_tag = EDID_table->EDID[offset] >> 4;
+		block_size = EDID_table->EDID[offset] & 0xF;
+
+		if (block_tag == 6) {
+			/* Physical Address offset */
+			offset += 4;
+			break;
+		}
+
+		/* Next block */
+		offset = offset + block_size + 1;
+	}
+
+	/* Make sure found VSDB */
+	if (block_tag != 6) {
+		HDMIRX_ERROR(" Change EDID physical addr fail, couldn't find vendor specific data block\n");
+		return false;
+	}
+
+	/* Repeater PA Increment */
+	if ((byteMSB&0x0F) == 0x0) {
+		byteMSB = byteMSB | 0x1;
+	} else if ((byteLSB&0xF0) == 0x0) {
+		byteLSB = byteLSB | 0x10;
+	} else if ((byteLSB&0x0F) == 0) {
+		byteLSB = byteLSB | 0x1;
+	} else {
+		byteMSB = 0xFF;
+		byteLSB = 0xFF;
+	}
+
+	HDMIRX_INFO("Set Physical Addr = 0x%02x%02x", byteMSB, byteLSB);
+	EDID_table->EDID[offset] = byteMSB;
+	EDID_table->EDID[offset+1] = byteLSB;
+
+	/* Calculate and set checksum */
+	for (i = 0x80; i < 0xFF; i++)
+		sum += EDID_table->EDID[i];
+	EDID_table->EDID[0xFF] = (0x100-(sum&0xFF))&0xFF;
+
+	/* Reload EDID table */
+	ret = drvif_EDIDLoad(EDID_table->EDID, 256);
+
+	return ret;
+}
+
+void HdmiRx_save_tx_physical_addr(unsigned char byteMSB, unsigned char byteLSB)
+{
+	hdmirx_edid.tx_phy_addr[0] = byteMSB;
+	hdmirx_edid.tx_phy_addr[1] = byteLSB;
+
+	hdmirx_edid2p0.tx_phy_addr[0] = byteMSB;
+	hdmirx_edid2p0.tx_phy_addr[1] = byteLSB;
+
+	if (mipi_top.hdmi_rx_init) {
+		if ((byteMSB != 0xEE) || (byteLSB != 0xEE))
+			HdmiRx_change_edid_physical_addr(byteMSB, byteLSB);
+
+		schedule_work(&hotplug_pulses_work);
+	}
+}
+
+
+void HdmiRx_Save_DTS_EDID_Table(HDMIRX_DTS_EDID_TBL_T *dts_edid)
+{
+	memcpy(hdmirx_edid.EDID, dts_edid->EDID, 256);
+	hdmirx_edid.tx_phy_addr[0] = 0xEE;
+	hdmirx_edid.tx_phy_addr[1] = 0xEE;
+	hdmirx_edid.valid = true;
+}
+
+void HdmiRx_Save_DTS_EDID2p0_Table(HDMIRX_DTS_EDID_TBL_T *dts_edid)
+{
+	memcpy(hdmirx_edid2p0.EDID, dts_edid->EDID, 256);
+	hdmirx_edid2p0.tx_phy_addr[0] = 0xEE;
+	hdmirx_edid2p0.tx_phy_addr[1] = 0xEE;
+	hdmirx_edid2p0.valid = true;
+}
+
+void HdmiRx_SetEDID_version(int version)
+{
+	int old_version;
+	HDMIRX_DTS_EDID_TBL_T *EDID_table;
+
+	old_version = rx_edid_version;
+
+	if (version == 1) {
+		if (hdmirx_edid2p0.valid == true) {
+			rx_edid_version = 1;
+			EDID_table = &hdmirx_edid2p0;
+		} else {
+			HDMIRX_ERROR("Set EDID version fail, 2.0 EDID table not exists");
+			rx_edid_version = 0;
+			EDID_table = &hdmirx_edid;
+		}
+	} else {
+		rx_edid_version = 0;
+		EDID_table = &hdmirx_edid;
+	}
+
+	if (old_version != rx_edid_version) {
+		HDMIRX_INFO("Change EDID to %s version", rx_edid_version?"2.0":"1.4");
+
+		if (mipi_top.hdmi_rx_init) {
+			Hdmi_SetHPD(0);
+			drvif_Hdmi2p0_Scdc_Reset();
+		}
+
+		if ((EDID_table->tx_phy_addr[0] != 0xEE) ||
+			(EDID_table->tx_phy_addr[1] != 0xEE))
+			HdmiRx_change_edid_physical_addr(EDID_table->tx_phy_addr[0], EDID_table->tx_phy_addr[1]);
+		else
+			drvif_EDIDLoad(EDID_table->EDID, 256);
+
+		HDMI_DELAYMS(1000);
+		if (mipi_top.hdmi_rx_init)
+			Hdmi_SetHPD(1);
+	}
+
+}
+
+void HdmiRx_ChangeCurrentEDID(unsigned char *edid)
+{
+	/* HDMIRX_INFO("HdmiRx_ChangeCurrentEDID"); */
+
+	if (rx_edid_version) {
+		memcpy(hdmirx_edid.EDID, edid, 256);
+		hdmirx_edid.valid = true;
+		HdmiRx_SetEDID_version(0);
+	} else {
+		memcpy(hdmirx_edid2p0.EDID, edid, 256);
+		hdmirx_edid2p0.valid = true;
+		HdmiRx_SetEDID_version(1);
+	}
+}
+
+int HdmiRx_GetEDID_version(void)
+{
+	return rx_edid_version;
+}
+
+unsigned char HdmiRx_EnableEDID(void)
+{
+	int i;
+	unsigned char ret = false;
+	HDMIRX_DTS_EDID_TBL_T *EDID_table;
+
+	if ((rx_edid_version == 1) && (hdmirx_edid2p0.valid == true))
+		EDID_table = &hdmirx_edid2p0;
+	else
+		EDID_table = &hdmirx_edid;
+
+	if (EDID_table->valid) {
+/* HDMI 1.4 CTS 9-5, Physical Address Handling */
+#ifdef CONFIG_RTK_HDMITX
+		/* Wait HDMI TX */
+		if (hdmitx_switch_get_state() == 1) {
+			for (i = 0; i < 5; i++) {
+				if ((EDID_table->tx_phy_addr[0] == 0xEE) &&
+					(EDID_table->tx_phy_addr[1] == 0xEE))
+					HDMI_DELAYMS(500);
+				else
+					break;
+			}
+		}
+
+		if ((EDID_table->tx_phy_addr[0] != 0xEE) ||
+			(EDID_table->tx_phy_addr[1] != 0xEE))
+			ret = HdmiRx_change_edid_physical_addr(EDID_table->tx_phy_addr[0], EDID_table->tx_phy_addr[1]);
+		else
+#endif
+		ret = drvif_EDIDLoad(EDID_table->EDID, 256);
+		drvif_EDID_DDC12_AUTO_Enable(0);
+	}
+
+	if (!ret)
+		HDMIRX_ERROR("Enable EDID fail, EDID table not exists or invalid");
+
+	return ret;
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiEDID.h b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiEDID.h
new file mode 100644
index 00000000..0857fde
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiEDID.h
@@ -0,0 +1,28 @@
+/*
+ * mipi_wrapper.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDMIEDID_H_
+#define _HDMIEDID_H_
+
+
+typedef struct {
+	unsigned char EDID[256];
+	unsigned char tx_phy_addr[2];/* TX Physical Address */
+	unsigned char valid;
+} HDMIRX_DTS_EDID_TBL_T;
+
+void HdmiRx_Save_DTS_EDID_Table(HDMIRX_DTS_EDID_TBL_T *dts_edid);
+void HdmiRx_Save_DTS_EDID2p0_Table(HDMIRX_DTS_EDID_TBL_T *dts_edid);
+void HdmiRx_SetEDID_version(int version);
+int HdmiRx_GetEDID_version(void);
+void HdmiRx_ChangeCurrentEDID(unsigned char *edid);
+unsigned char HdmiRx_EnableEDID(void);
+#endif/* _HDMIEDID_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiHdmi.c b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiHdmi.c
new file mode 100644
index 00000000..3aba3e8
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiHdmi.c
@@ -0,0 +1,2277 @@
+/*
+ * hdmiHdmi.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/gpio.h>
+
+#include "hdmiInternal.h"
+#include "mipi_wrapper.h"
+
+/*===================== HDMI 2.0 flag =======================*/
+#if HDMI2p0
+u_int8_t bHDMI_6G_flag;
+u_int8_t b6G_detect_cnt;
+u_int8_t bHDMI_420_Space;/* For YUV420 */
+
+/* SCDC Reg mapping */
+u_int8_t bScdc_reset_flag;
+#define SCDC_TMDS_Config	 0x20
+
+extern UINT8 bSCDC_Enable_flag ;
+#endif
+/*======================================================*/
+
+#define HDMI_MEMSURE_RETRY	2
+
+#define AVI_Data_BYTE1	   (4)
+#define AVI_Data_BYTE3	   (6)
+#define AVI_Data_BYTE4	   (7)
+#define AVI_Data_BYTE5	   (8)
+#define AVI_Y1Y0_mask		0x60
+#define AVI_YQ1YQ0_mask		0xC0
+#define AVI_Q_Range_mask	0x0c
+#define VSIF_PB4			(209)
+#define VSIF_PB5			(210)
+#define RGB_Default			0
+#define RGB_Limite_Range	1
+#define RGB_Full_Range		2
+#define Not_Read			3
+#define YUV_Limite_Range	0
+#define YUV_Full_Range		1
+
+
+HDMI_CONST HDMI_AUDIO_PLL_COEFF_T audio_pll_coeff[] = {
+	{32000, _AUDIO_256_TIMES, 0},
+	{44100, _AUDIO_256_TIMES, 0},
+	{48000, _AUDIO_256_TIMES, 0},
+	{88200, _AUDIO_256_TIMES, 1},
+	{96000, _AUDIO_256_TIMES, 1},
+	{176400, _AUDIO_128_TIMES, 2},
+	{192000, _AUDIO_128_TIMES, 3}
+};
+
+HDMI_CONST HDMI_AUDIO_PLL_PARAM_T hdmi_audiopll_param[] = {
+	{2,   20,	2,	8,	1,	0x1D, 0xDC,  "32K"	   },
+	{2,   20,	2,	6,	1,	0xFE, 0x7A,  "44.1K"  },
+	{2,   22,	2,	6,	1,	0x07, 0x40,  "48K"	   },
+	{2,   20,	1,	6,	1,	0xFE, 0x7A,  "88.2K"  },
+	{2,   22,	1,	6,	1,	0x07, 0x40,  "96K"	   },
+	{2,   20,	1,	6,	0,	0xFE, 0x7A,  "176.4K" },
+	{2,   22,	1,	6,	0,	0x07, 0x40,  "192K"    }
+};
+
+HDMI_CONST unsigned int AUDIO_CHANNEL_STATUS[] = {
+	44100,
+	0,/* 0 indicate standard no support */
+	48000,
+	32000,
+	22000,
+	0,
+	24000,
+	0,
+	88200,
+	0,
+	96000,
+	0,
+	176000,
+	0,
+	192000,
+	0,
+};
+
+HDMI_CONST HDMI_COLOR_SPACE_T ColorMap[] = {
+	COLOR_RGB,    /*  0 */
+	COLOR_YUV422, /* 01 */
+	COLOR_YUV444, /* 10 */
+	COLOR_YUV420, /* 11 */
+};
+
+static unsigned int ACR_N = 0;
+HDMI_INFO_T hdmi;
+unsigned char HDMI_Audio_Conut = 0;
+
+/*=================== extern Variable/Function ===================*/
+extern HDMIRX_IOCTL_STRUCT_T hdmi_ioctl_struct;
+
+extern void CDR_RESET(UINT8 benable);
+extern void Hdmi_PhyInit(void);
+extern int rtd_hdmiRx_cmd(u_int8_t cmd,  void *arg);
+extern void hdmi_z0_set(unsigned char port, unsigned char lane, unsigned char enable);
+extern bool HDMI_Bit_Err_One_Time_Detect(u_int8_t period, u_int16_t thd);
+extern bool Hdmi_MeasureTiming(HDMI_TIMING_T *timing, int b);
+extern void set_hdmirx_wrapper_control_0(int fifo_stage, int fw_dma_en,
+	int polarity_set_en, int polarity_set, int yuv_fmt, int hdmirx_en);
+extern unsigned char hdmirx_wrapper_convert_color_fmt(HDMI_COLOR_SPACE_T color);
+extern void set_hdmirx_wrapper_interrupt_en(int ver_err_en, int hor_err_en, int polarity_detect_en);
+/*======================================================*/
+
+
+void HdmiSetAPStatus(HDMIRX_APSTATUS_T apstatus)
+{
+	unsigned long value = apstatus;
+
+	rtd_hdmiRx_cmd(IOCTRL_HDMI_SET_APSTATUS, (void *)value);
+}
+
+void HdmiGetStruct(HDMIRX_IOCTL_STRUCT_T *ptr)
+{
+	rtd_hdmiRx_cmd(IOCTRL_HDMI_GET_STRUCT, ptr);
+}
+
+HDMI_DVI_MODE_T IsHDMI(void)
+{
+	HDMI_DVI_MODE_T mode;
+#if HDMI2p0
+	unsigned int scr_val;
+
+	scr_val = hdmi_rx_reg_read32(HDMI_SCR, HDMI_RX_MAC);
+	/* Manual HDMI/DVI switch mode */
+	if (HDMI_SCR_get_mode(scr_val)) {
+		if (HDMI_SCR_get_msmode(scr_val))
+			mode = MODE_HDMI;
+		else
+			mode = MODE_DVI;
+		goto exit;
+	}
+#endif
+
+	if (HDMI_SR_get_mode(hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC))) {
+		/* HDMIRX_DEBUG("[%s] HDMI mode",  __func__); */
+		mode = MODE_HDMI;
+	} else {
+		/* HDMIRX_DEBUG("[%s] DVI mode",  __func__); */
+		mode = MODE_DVI;
+	}
+
+exit:
+	return mode;
+}
+
+int Cbus_GetRx5v(void)
+{
+	return ISO_CBUS_TX_PHY_CTRL5_get_REGO_5V_DETECT(hdmi_rx_reg_read32(ISO_CBUS_TX_PHY_CTRL5, HDMI_TX_CBUS));
+}
+
+void Hdmi_SetHPD(char high)
+{
+	HDMIRX_INFO("Set HPD(%u)", high);
+
+	if (high)
+		gpio_direction_output(hdmi.gpio_hpd_ctrl, 0);
+	else
+		gpio_direction_output(hdmi.gpio_hpd_ctrl, 1);
+}
+
+void Hdmi_Power(char enable)
+{
+	if (enable) {
+		hdmi_rx_reg_mask32(TMDS_OUTCTL,
+			~(TMDS_OUTCTL_tbcoe_mask | TMDS_OUTCTL_tgcoe_mask | TMDS_OUTCTL_trcoe_mask | TMDS_OUTCTL_ocke_mask),
+			(TMDS_OUTCTL_tbcoe(1) | TMDS_OUTCTL_tgcoe(1) | TMDS_OUTCTL_trcoe(1) | TMDS_OUTCTL_ocke(1)),
+			HDMI_RX_MAC);/* Enable PLL TMDS, RGB clock output */
+
+#if 1
+		hdmi_rx_reg_mask32(LDO, ~(LDO_reg_p0_ldo_pow_mask), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(MBIAS, ~(0x1), 0x1, HDMI_RX_PHY);
+#else
+		/* LDO power on port0 */
+		hdmi_rx_reg_mask32(LDO,
+			~(LDO_reg_p0_ldo_pow_mask | LDO_reg_p1_ldo_pow_mask | LDO_reg_p2_ldo_pow_mask),
+			LDO_reg_p0_ldo_pow_mask, HDMI_RX_PHY);
+#endif
+		hdmi_z0_set(0/* Port0 */, LN_ALL, 1);
+	} else {
+		/* Disable PLL TMDS, RGB clock output */
+		hdmi_rx_reg_mask32(TMDS_OUTCTL,
+			~(TMDS_OUTCTL_tbcoe_mask | TMDS_OUTCTL_tgcoe_mask | TMDS_OUTCTL_trcoe_mask | TMDS_OUTCTL_ocke_mask),
+			(TMDS_OUTCTL_tbcoe(0) | TMDS_OUTCTL_tgcoe(0) | TMDS_OUTCTL_trcoe(0) | TMDS_OUTCTL_ocke(0)),
+			HDMI_RX_MAC);
+
+#if 1/* Changed by Ken2016/1/18 */
+		hdmi_rx_reg_mask32(LDO,
+			~(LDO_reg_p0_ldo_pow_mask | LDO_reg_p1_ldo_pow_mask | LDO_reg_p2_ldo_pow_mask),
+			(LDO_reg_p0_ldo_pow_mask | LDO_reg_p1_ldo_pow_mask | LDO_reg_p2_ldo_pow_mask), HDMI_RX_PHY);
+#else
+		/* LDO power OFF */
+		hdmi_rx_reg_mask32(LDO,
+			~(LDO_reg_p0_ldo_pow_mask | LDO_reg_p1_ldo_pow_mask | LDO_reg_p2_ldo_pow_mask),
+			0, HDMI_RX_PHY);
+#endif
+		hdmi_z0_set(0 /* Port0 */, LN_ALL, 0);
+	}
+
+}
+
+void Hdmi_TmdsInit(void)
+{
+	/* Initial HDMI */
+	hdmi_rx_reg_mask32(MHL_DEMUX_CTRL,
+		~(MHL_DEMUX_CTRL_mhl_pp_en_mask | MHL_DEMUX_CTRL_mhl_en_mask),
+		0, HDMI_RX_MHL);
+	hdmi_rx_reg_mask32(MHL_HDMI_MAC_CTRL,
+		~(MHL_HDMI_MAC_CTRL_pp_mode_output_mask | MHL_HDMI_MAC_CTRL_packet_mhl_en_mask |
+		MHL_HDMI_MAC_CTRL_xor_pixel_sel_mask | MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_mask),
+		0, HDMI_RX_MAC);
+
+	/* For BCH & debounce */
+	hdmi_rx_reg_mask32(HDMI_BCHCR,
+		~(HDMI_BCHCR_enrwe_mask | HDMI_BCHCR_bche_mask),
+		(HDMI_BCHCR_enrwe(1) | HDMI_BCHCR_bche(1)), HDMI_RX_MAC);/* BCH function enable */
+
+	/* Enable TMDS input */
+	hdmi_rx_reg_mask32(TMDS_PWDCTL,
+		~(TMDS_PWDCTL_ebip_mask | TMDS_PWDCTL_egip_mask | TMDS_PWDCTL_erip_mask | TMDS_PWDCTL_ecc_mask),
+		0, HDMI_RX_MAC);
+
+	/* HDMI&DVI function disable */
+	hdmi_rx_reg_mask32(TMDS_Z0CC, ~TMDS_Z0CC_hde_mask, 0, HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_VCR, ~HDMI_VCR_iclk_sel_mask, HDMI_VCR_iclk_sel(0), HDMI_RX_MAC);
+	/* Measure input clock source sel */
+	hdmi_rx_reg_mask32(TMDS_CPS, ~TMDS_CPS_clkv_meas_sel_mask, TMDS_CPS_clkv_meas_sel(3), HDMI_RX_MAC);
+
+	/* Need to enable video before enable TMDS clock */
+	hdmi_rx_reg_mask32(HDMI_AVMCR, ~HDMI_AVMCR_ve_mask, HDMI_AVMCR_ve(1), HDMI_RX_MAC);
+
+	/* Enable TMDS output */
+	hdmi_rx_reg_mask32(TMDS_OUTCTL,
+		~(TMDS_OUTCTL_ocke_mask | TMDS_OUTCTL_tbcoe_mask | TMDS_OUTCTL_tgcoe_mask | TMDS_OUTCTL_trcoe_mask),
+		(TMDS_OUTCTL_ocke(1) | TMDS_OUTCTL_tbcoe(1) | TMDS_OUTCTL_tgcoe(1) | TMDS_OUTCTL_trcoe(1)), HDMI_RX_MAC);
+
+	/* Video function block enable */
+	hdmi_rx_reg_mask32(TMDS_DPC_SET0, ~TMDS_DPC_SET0_dpc_bypass_dis_mask,
+		TMDS_DPC_SET0_dpc_en(1), HDMI_RX_MAC);
+}
+
+void Hdmi_MacInit(void)
+{
+	hdmi_rx_reg_write32(HDMI_SCR, 0x123, HDMI_RX_MAC);//DVI/HDMI condition(A,B) select  /* hdcp cts1.4 : Bstatus (MSB): 0x00*/
+	hdmi_rx_reg_mask32(HDMI_AFCR,
+		~(HDMI_AFCR_audio_test_enable_mask | HDMI_AFCR_afifowe_mask | HDMI_AFCR_afifore_mask),
+		HDMI_AFCR_audio_test_enable(0) | HDMI_AFCR_afifowe(1) | HDMI_AFCR_afifore(2),
+		HDMI_RX_MAC);/* Enable Audio FIFO */
+
+	/* Enable video & audio output */
+	hdmi_rx_reg_write32(HDMI_AVMCR, 0x48, HDMI_RX_MAC);
+	/* Disable watch dog */
+	hdmi_rx_reg_write32(HDMI_WDCR0, 0x00, HDMI_RX_MAC);
+
+	/* Enable BCH Function */
+	hdmi_rx_reg_mask32(HDMI_BCHCR,
+		(HDMI_BCHCR_pe_mask | HDMI_BCHCR_bche_mask | HDMI_BCHCR_enrwe_mask | HDMI_BCHCR_spcss_mask),
+		(HDMI_BCHCR_pe_mask | HDMI_BCHCR_bche_mask | HDMI_BCHCR_enrwe_mask | HDMI_BCHCR_spcss_mask),
+		HDMI_RX_MAC);
+
+
+#if HDMI2p0/* For hdmi 2.0 spec use */
+	hdmi_rx_reg_mask32(SCDC_CR, (~SCDC_CR_scdc_en_mask), SCDC_CR_scdc_en_mask, HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(SCDC_PCR, (~SCDC_PCR_i2c_free_num_mask), SCDC_PCR_i2c_free_num(0x0a), HDMI_RX_MAC);
+	bScdc_reset_flag = 1;
+	bHDMI_6G_flag = 0;
+	bSCDC_Enable_flag = 0;
+#endif
+
+	hdmi_rx_reg_mask32(HDMI_VCR,
+		~(HDMI_VCR_csam_mask | HDMI_VCR_prdsam_mask),
+		HDMI_VCR_csam(1) | HDMI_VCR_prdsam(1), HDMI_RX_MAC);
+
+	hdmi_rx_reg_write32(HDMI_MAGCR0, 0xE000/*0x14*/, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_PTRSV1, 0x82, HDMI_RX_MAC);
+	/* Clear HDMI interrupt control register */
+	hdmi_rx_reg_write32(HDMI_INTCR, 0, HDMI_RX_MAC);
+	/* Not inverse EVEN/ODD */
+	hdmi_rx_reg_mask32(HDMI_VCR, ~_BIT7, 0, HDMI_RX_MAC);
+
+	/* Disable packet variation Watch Dog */
+	hdmi_rx_reg_mask32(HDMI_PAMICR, ~_BIT0, 0x00, HDMI_RX_MAC);
+
+	/* Enable SPDIF/I2S Output */
+	hdmi_rx_reg_mask32(HDMI_AOCR, (~0x0ff), 0xFF, HDMI_RX_MAC);
+
+	/* cycle debounce*/
+	hdmi_rx_reg_mask32(TMDS_ERRC, ~TMDS_ERRC_nl_mask, TMDS_ERRC_nl(3), HDMI_RX_MAC);
+
+	/* BCH function enable */
+	hdmi_rx_reg_mask32(HDMI_BCHCR,
+		~(HDMI_BCHCR_enrwe_mask | HDMI_BCHCR_bche_mask),
+		(HDMI_BCHCR_enrwe(1) | HDMI_BCHCR_bche(1)), HDMI_RX_MAC);
+}
+
+void Audio_CTS_Bound(void)
+{
+	unsigned long cts_up;
+	unsigned long cts_low;
+	unsigned long b;
+	HDMIRX_IOCTL_STRUCT_T isr_info;
+
+	HdmiGetStruct(&isr_info);
+	b = isr_info.b;
+
+	if (b > 5600) {
+		/* 6G timing */
+		cts_up = 0xfffff;
+		cts_low = 445500 * 7/8;
+	} else if (b > 2750) {
+		/* 3G timing */
+		cts_up = 421875 * 9/8;
+		cts_low = 222750 * 7/8;
+	} else if (b > 1380) {
+		/* 148M */
+		cts_up = 421875 * 9/8;
+		cts_low = 140625 * 7/8;
+	} else if (b > 660) {
+		cts_up = 234375 * 9/8;
+		cts_low = 74250 * 7/8;
+	} else {
+		cts_up = 60060 * 9/8;
+		cts_low = 25200 * 7/8;
+	}
+
+	hdmi_rx_reg_mask32(AUDIO_CTS_UP_BOUND, ~(AUDIO_CTS_UP_BOUND_cts_up_bound_mask),
+		AUDIO_CTS_UP_BOUND_cts_up_bound(cts_up), HDMI_RX_MAC);
+
+	/* CTS low boundary set 20000 */
+	hdmi_rx_reg_mask32(AUDIO_CTS_LOW_BOUND, ~AUDIO_CTS_LOW_BOUND_cts_low_bound_mask,
+		AUDIO_CTS_LOW_BOUND_cts_low_bound(cts_low), HDMI_RX_MAC);
+
+	HDMI_PRINTF("Audio_CTS_Bound H = %ld , L =%ld\n", cts_up, cts_low);
+}
+
+void Audio_N_Bound(int freq)
+{
+	int N_up, N_low;
+
+	if (freq > 190000) {
+		/* 192k */
+		N_up = 46592 * 9/8;
+		N_low = 20480 * 7/8;
+	} else if (freq > 170000) {
+		/* 176.4 */
+		N_up = 71344 * 9/8;
+		N_low = 17836 * 7/8;
+	} else if (freq > 80000) {
+		/* 96k  88.2k */
+		N_up = 35672 * 9/8;
+		N_low = 8918 * 7/8;
+	} else {
+		/* 32k  44.1k  48k */
+		N_up = 17836 * 9/8;
+		N_low = 3072 * 7/8;
+	}
+
+	hdmi_rx_reg_mask32(AUDIO_N_UP_BOUND, ~(AUDIO_N_UP_BOUND_n_up_bound_mask),
+		AUDIO_N_UP_BOUND_n_up_bound(N_up), HDMI_RX_MAC);
+	/* CTS low boundary set 20000 */
+	hdmi_rx_reg_mask32(AUDIO_N_LOW_BOUND, ~AUDIO_N_LOW_BOUND_n_low_bound_mask,
+		AUDIO_N_LOW_BOUND_n_low_bound(N_low), HDMI_RX_MAC);
+
+	HDMI_PRINTF("freq = %d Audio_N_Bound H = %d , L =%d\n", freq, N_up, N_low);
+}
+
+#define FCVO_MIN	250
+#define FCVO_MAX	500
+HDMI_CONST VIDEO_DPLL_RATIO_T dpll_ratio[] = {
+	{15, 15, 1, 1},/* 24 bits */
+	{12, 15, 4, 5},/* 30 bits */
+	{10, 15, 2, 3},/* 36 bits */
+	{15, 30, 1, 2},/* 48 bits */
+};
+/**
+ * Hdmi_VideoPLLSetting
+ * Fin =	Fxtal * 1024 / b
+ * Target vco = ( Fin * m / n )  , TagretVco_HB = 400 ,  TagretVco_LB=200
+ * Fin * M / N / 2^o / 2 * s = Fout = Fin * [24/30, 24/36, 24/48] ,  [10bits, 12bits,16bits]
+ * 200 <  ( Fin * m / n )	< 400  -->	200 <	Fin * 2^o * s * [ 8/5 , 4/3, 1 ]   < 400
+ * Scode_LB =	200 * 15 * b  / ( Fxtal *1024 * [24,20,15] )
+ * Scode_HB =	400 * 15 * b  / ( Fxtal *1024 * [24,20,15] )
+ * Smean = (Scode_LB +Scode_HB ) /2
+ * M/N = [8/5 , 4/3 , 1 ] * S
+ */
+HDMI_bool Hdmi_VideoPLLSetting(int b, int cd, int Enable2X)
+{
+	unsigned int large_ratio;
+	unsigned int Smean;
+	unsigned int Stest;
+	unsigned int m;
+	unsigned int n;
+	unsigned int o;
+	unsigned int fraction1;
+	unsigned int fraction2;
+	unsigned int fvco;
+	unsigned int tmds;
+	unsigned long pixel_clockx1024;
+
+	if (b <= 0)
+		return FALSE;
+
+	if (cd >= 4)
+		cd = 0;
+
+	/* Disable PLL */
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~(HDMI_VPLLCR1_dpll_pow_mask | HDMI_VPLLCR1_dpll_vcorstb_mask |
+		HDMI_VPLLCR1_dpll_freeze_mask | HDMI_VPLLCR1_dpll_stoppsw_mask),
+		HDMI_VPLLCR1_dpll_freeze_mask,
+		HDMI_RX_MAC);
+
+	pixel_clockx1024 = ((unsigned long)hdmi.b * 27 * dpll_ratio[cd].SM * 1024) / (dpll_ratio[cd].SN * 256);
+
+	HDMI_PRINTF("pixel_clock = %ld\n", pixel_clockx1024);
+
+	if ((pixel_clockx1024 < (160 * 1024) && Enable2X == 0) ||
+		(HDMI_VCR_get_csc_r(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC)) == 3)) {
+		/* if pixel_clock is under 160MHz then enable 2X clock maybe for DI */
+		Enable2X = 1;
+	}
+
+	/* interlace must 2 x, MHL not */
+#if HDMI2p0
+	if (bHDMI_420_Space == COLOR_YUV420) {
+		large_ratio = 2;
+		hdmi_rx_reg_mask32(TMDS_CPS, ~TMDS_CPS_pll_div2_en_mask, TMDS_CPS_pll_div2_en(1), HDMI_RX_MAC);
+	} else
+#endif
+	if (Enable2X && (hdmi.tx_timing.progressive == 0)) {
+		large_ratio = 2;
+		hdmi_rx_reg_mask32(TMDS_CPS, ~TMDS_CPS_pll_div2_en_mask, TMDS_CPS_pll_div2_en(1), HDMI_RX_MAC);
+	} else {
+		large_ratio = 1;
+		hdmi_rx_reg_mask32(TMDS_CPS, ~TMDS_CPS_pll_div2_en_mask, TMDS_CPS_pll_div2_en(0), HDMI_RX_MAC);
+	}
+
+#if HDMI2p0
+	if (bHDMI_420_Space == COLOR_YUV420)
+		hdmi_rx_reg_mask32(TMDS_DPC_SET0, ~TMDS_DPC_SET0_dpc_bypass_dis_mask, TMDS_DPC_SET0_dpc_bypass_dis(1), HDMI_RX_MAC);
+	else
+#endif
+	if (cd || (Enable2X && (hdmi.tx_timing.progressive == 0)))
+		hdmi_rx_reg_mask32(TMDS_DPC_SET0, ~TMDS_DPC_SET0_dpc_bypass_dis_mask, TMDS_DPC_SET0_dpc_bypass_dis(1), HDMI_RX_MAC);
+	else
+		hdmi_rx_reg_mask32(TMDS_DPC_SET0, ~TMDS_DPC_SET0_dpc_bypass_dis_mask, TMDS_DPC_SET0_dpc_bypass_dis(0), HDMI_RX_MAC);
+
+	if (large_ratio != 1) {
+		pixel_clockx1024 = (hdmi.b * 27 * dpll_ratio[cd].SM * 1024 * 2) / (dpll_ratio[cd].SN * 256);
+		HDMI_PRINTF("large_ratio=%d, 2X pixel clock PLL = %ld\n", large_ratio, pixel_clockx1024);
+	}
+
+	if (pixel_clockx1024 == 0) {
+		HDMI_PRINTF("pixel_clockx1024 is zero\n");
+		return FALSE;
+	}
+
+	o = 1;
+	Smean = 0;
+	Stest = 1;
+	while (pixel_clockx1024 <= (200*1024)) {
+		if (Smean == 0)
+			Stest = 1;
+		else
+			Stest = Smean * 2;
+		/* 2---> 2^o */
+		if (((pixel_clockx1024*2)*Stest) >= (FCVO_MIN*1024))
+			break;
+		Smean++;
+	};
+
+	if (pixel_clockx1024 > (200*1024)) {
+		/* >200MHz */
+		o = 0;
+		Smean = 0;
+	}
+	HDMI_PRINTF("Smean = %d\n", Smean);
+
+	n = 0;
+	do {
+		n += dpll_ratio[cd].RatioN;
+		m = ((dpll_ratio[cd].RatioM * Stest * n * large_ratio)<<o) / dpll_ratio[cd].RatioN;
+		HDMI_PRINTF("%d %d\n", m, n);
+	} while (n < 2);
+
+	fvco = (hdmi.b * 27 * m) / (256 * n);
+
+	/*
+	 * Icp x (N/M) x (27M/Fin) = 0.95uA
+	 * Icp x (N/M) x (27M/(27Mx1024/b) = 0.95
+	 * Icp x (N/M) x (b/1024) = 0.95
+	 * Icp x (N/M) x (b/1024) x 100 = 95
+	 * Icp = (Mx1024x95)/(Nxbx100)
+	 */
+	fraction1 = ((unsigned long)m*95*4*b / (n*256*100));/* 2bit fractional part */
+	fraction2 = 0x00;
+	HDMI_PRINTF("***************fraction1=%d\n", fraction1);
+
+	if (fraction1 >= 10)
+		fraction1 -= 10;
+
+	if (fraction1 >= 40) {
+		/* 2bit fractional part */
+		fraction1 -= 40;
+		fraction2 |= 0x04;
+	}
+
+	if (fraction1 >= 20) {
+		/* 2bit fractional part */
+		fraction1 -= 20;
+		fraction2 |= 0x02;
+	}
+
+	if (fraction1 >= 10) {
+		/* 2bit fractional part */
+		fraction1 -= 10;
+		fraction2 |= 0x01;
+	}
+	HDMI_PRINTF("***************fraction2=%d\n", fraction2);
+	/* fraction2 |= 0x18; */
+
+	/* mag2 PLL bug	m min must > 1 , or PLL will crash */
+	if (((m-2) == 0)) {
+		n = n*2;
+		m = m*2;
+	}
+
+	tmds = hdmi.b*27/256;
+
+	if (tmds > 600)
+		return FALSE;
+
+	HDMIRX_INFO("PLL Setting b(%d) cd(%d) TMDS(%dMHz) P(%u) 2X(%d) 6G_flag(%u)",
+		hdmi.b, cd, tmds, hdmi.tx_timing.progressive, Enable2X, bHDMI_6G_flag);
+	HDMI_PRINTF("***************TMDS=%d MHz\n", tmds);
+	HDMI_PRINTF("***************cd=%d\n", cd);
+	HDMI_PRINTF("***************m=%d\n", m);
+	HDMI_PRINTF("***************n=%d\n", n);
+	HDMI_PRINTF("***************o=%d\n", o);
+	HDMI_PRINTF("***************s=%d\n", Smean);
+	/* HDMI_PRINTF("***************fraction1=%d\n", fraction1); */
+	HDMI_PRINTF("***************fraction2=%d\n", fraction2);
+	HDMI_PRINTF("***************pixel_clockx1024=%ld\n", pixel_clockx1024);
+	HDMI_PRINTF("***************fvco=%d MHz\n", fvco);
+	HDMI_PRINTF("***************larget=%d\n", large_ratio);
+
+	/* set video PLL parameter */
+	hdmi_rx_reg_write32(HDMI_VPLLCR0,
+		HDMI_VPLLCR0_dpll_m(m-2) | HDMI_VPLLCR0_dpll_o(o) |
+		HDMI_VPLLCR0_dpll_n(n-2) | HDMI_VPLLCR0_dpll_rs(3) |
+		HDMI_VPLLCR0_dpll_ip(fraction2),
+		HDMI_RX_MAC);
+
+	/* set video PLL output divider */
+	hdmi_rx_reg_write32(MN_SCLKG_DIVS, Smean, HDMI_RX_MAC);
+
+	/* video PLL double buffer load */
+	hdmi_rx_reg_mask32(MN_SCLKG_CTRL, ~_BIT4, _BIT4, HDMI_RX_MAC);
+	usleep_range(5, 6);
+
+	/* video PLL power enable */
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1, ~(HDMI_VPLLCR1_dpll_ldo_pow_mask),
+		HDMI_VPLLCR1_dpll_ldo_pow_mask, HDMI_RX_MAC);
+	usleep_range(5, 6);
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~(HDMI_VPLLCR1_dpll_pow_mask | HDMI_VPLLCR1_dpll_stoppsw_mask),
+		HDMI_VPLLCR1_dpll_pow_mask | HDMI_VPLLCR1_dpll_stoppsw_mask,
+		HDMI_RX_MAC);
+	usleep_range(5, 6);
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1, ~HDMI_VPLLCR1_dpll_vcorstb_mask,
+		HDMI_VPLLCR1_dpll_vcorstb_mask, HDMI_RX_MAC);
+	usleep_range(10, 15);
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1, ~HDMI_VPLLCR1_dpll_freeze_mask,
+		0, HDMI_RX_MAC);
+
+	HDMI_PRINTF("Hdmi_VideoPLLSetting d404 = %x\n", hdmi_rx_reg_read32(HDMI_VPLLCR1, HDMI_RX_MAC));
+
+	/* CDR reset for fix resolution recognize fail */
+	CDR_RESET(1);
+	usleep_range(10000, 11000);
+	CDR_RESET(0);
+	/* Wait CDR stable */
+	usleep_range(50000, 51000);
+
+	return TRUE;
+}
+
+unsigned char Hdmi_AudioPLLSetting(int freq, HDMI_AUDIO_TRACK_MODE track_mode)
+{
+	u_int8_t coeff = 0;
+	u_int8_t i;
+	int timeout = 10;
+	u_int32_t tmp1;
+	u_int32_t I_Code = 0, S = 0;
+
+	for (i = 0; i < 7; i++) {
+		if (audio_pll_coeff[i].freq == freq)  {
+			coeff = audio_pll_coeff[i].coeff;
+			/* rate = audio_pll_coeff[i].rate; */
+			goto PLL_SETTING;
+		}
+	}
+	HDMI_PRINTF("Unsupport audio freq = %d\n", freq);
+	return FALSE;
+
+PLL_SETTING:
+	/* (2)audio output enable = auto mode */
+	hdmi_rx_reg_mask32(HDMI_AFCR, ~_BIT6, _BIT6, HDMI_RX_MAC);
+
+	/* (3)Disable trend and boundary tracking */
+	hdmi_rx_reg_mask32(HDMI_WDCR0, ~HDMI_WDCR0_bt_track_en_mask, 0x0, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_PSCR, ~(_BIT3|_BIT2), 0x00, HDMI_RX_MAC);
+	/* Update Double Buffer */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+
+	/* (4)FSM back to Pre-mode */
+	hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT5, 0x00, HDMI_RX_MAC);
+
+	/* (5)Disable N/CTS tracking */
+	/* CTS has glitch not to tracking disable */
+	hdmi_rx_reg_mask32(AUDIO_CTS_UP_BOUND, ~_BIT20, 0x0, HDMI_RX_MAC);
+	/* N has glitch not to tracking disable */
+	hdmi_rx_reg_mask32(AUDIO_N_UP_BOUND, ~_BIT20, 0x0, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_PSCR, ~_BIT4, 0x00, HDMI_RX_MAC);
+	/* Update Double Buffer */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+
+	/* (6)Disable SDM */
+	hdmi_rx_reg_mask32(HDMI_AAPNR, ~_BIT1, 0x0, HDMI_RX_MAC);
+
+	/* (7)Disable PLL */
+	hdmi_rx_reg_mask32(HDMI_APLLCR1,
+		~(HDMI_APLLCR1_dpll_freeze_mask|HDMI_APLLCR1_dpll_vcorstb_mask|HDMI_APLLCR1_dpll_pow_mask),
+		(HDMI_APLLCR1_dpll_freeze_mask), HDMI_RX_MAC);
+
+	/* (8)resetS &S1 code to avoid dead lock */
+	/* PLL output clk sel from crystal */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~(_BIT6|_BIT5), 0x0, HDMI_RX_MAC);
+	/* S1 & S2 code clear to 0 , to avoid dead lock */
+	hdmi_rx_reg_write32(HDMI_SCAPR, 0x00, HDMI_RX_MAC);
+	/* Update Double Buffer */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+	HDMI_DELAYMS(1);
+	/* PLL output clk sel from VCO */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~(_BIT6|_BIT5), (_BIT6), HDMI_RX_MAC);
+	/* Enable Double Buffer */
+	hdmi_rx_reg_write32(HDMI_CMCR, 0x50, HDMI_RX_MAC);
+
+	/* (9)D code */
+	hdmi_rx_reg_write32(HDMI_DCAPR0, (hdmi_audiopll_param[i].D_HighByte << 8) | hdmi_audiopll_param[i].D_LowByte, HDMI_RX_MAC);
+	/* Enable Double Buffer for K/M/S/D/O */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~(HDMI_CMCR_dbdcb_mask), HDMI_CMCR_dbdcb(1), HDMI_RX_MAC);
+
+	/* (10)Initial PLL */
+	hdmi_rx_reg_mask32(HDMI_APLLCR0,
+		~(HDMI_APLLCR0_dpll_m_mask | HDMI_APLLCR0_dpll_o_mask | HDMI_APLLCR0_dpll_n_mask),
+		HDMI_APLLCR0_dpll_m(hdmi_audiopll_param[i].M - 2) | HDMI_APLLCR0_dpll_o(hdmi_audiopll_param[i].O),
+		HDMI_RX_MAC);
+	/* Enable Double Buffer for K/M/S/D/O */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~(HDMI_CMCR_dbdcb_mask), HDMI_CMCR_dbdcb(1), HDMI_RX_MAC);
+	/* set audio PLL N code */
+	if (hdmi_audiopll_param[i].N < 2) {
+		hdmi_rx_reg_mask32(HDMI_APLLCR0,
+			~(HDMI_APLLCR0_dpll_bpsin_mask | HDMI_APLLCR0_dpll_n_mask),
+			HDMI_APLLCR0_dpll_bpsin(1) | HDMI_APLLCR0_dpll_n(0), HDMI_RX_MAC);
+	} else {
+		hdmi_rx_reg_mask32(HDMI_APLLCR0,
+			~(HDMI_APLLCR0_dpll_bpsin_mask | HDMI_APLLCR0_dpll_n_mask),
+			HDMI_APLLCR0_dpll_bpsin(0) | HDMI_APLLCR0_dpll_n(hdmi_audiopll_param[i].N-2), HDMI_RX_MAC);
+	}
+	/* Enable Double Buffer for K/M/S/D/O */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~(HDMI_CMCR_dbdcb_mask), HDMI_CMCR_dbdcb(1), HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_SCAPR, (hdmi_audiopll_param[i].S1) ? ((hdmi_audiopll_param[i].S / 2) | 0x80) : (hdmi_audiopll_param[i].S / 2), HDMI_RX_MAC);
+	/* S1 code */
+	hdmi_rx_reg_write32(PRESET_S_CODE1, 0xf800, HDMI_RX_MAC);
+	/* set Icp */
+	hdmi_rx_reg_mask32(HDMI_APLLCR0, ~(_BIT2|_BIT1|_BIT0), 0x3, HDMI_RX_MAC);
+	/* Enable Double Buffer for K/M/S/D/O */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+	/* set RS=13k */
+	hdmi_rx_reg_mask32(HDMI_APLLCR0, ~(_BIT5|_BIT4|_BIT3), (_BIT4|_BIT3), HDMI_RX_MAC);
+	/* Enable Double Buffer for K/M/S/D/O */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+
+	/* set CS=42pf */
+	hdmi_rx_reg_mask32(HDMI_APLLCR1, ~(HDMI_APLLCR1_dpll_CS_MASK), (HDMI_APLLCR1_dpll_CS_35P), HDMI_RX_MAC);
+	/* Enable Double Buffer for K/M/S/D/O */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+	/* Enable PLL */
+	hdmi_rx_reg_mask32(HDMI_APLLCR1, ~(HDMI_APLLCR1_dpll_stoppsw_mask | HDMI_APLLCR1_dpll_pow_mask),
+		(HDMI_APLLCR1_dpll_pow_mask | HDMI_APLLCR1_dpll_stoppsw_mask), HDMI_RX_MAC);
+	/* RST */
+	hdmi_rx_reg_mask32(HDMI_APLLCR1, ~(HDMI_APLLCR1_dpll_vcorstb_mask), (HDMI_APLLCR1_dpll_vcorstb_mask), HDMI_RX_MAC);
+
+	HDMI_PRINTF(" m = %x\n o = %x\n s = %x\n ", hdmi_audiopll_param[i].M, hdmi_audiopll_param[i].O, hdmi_audiopll_param[i].S);
+	/* Wait PLL Stable */
+	HDMI_DELAYMS(1);
+	/* PLL un-freeze */
+	hdmi_rx_reg_mask32(HDMI_APLLCR1, ~HDMI_APLLCR1_dpll_freeze_mask, 0x0, HDMI_RX_MAC);//
+	/* (11)Enable SDM */
+	hdmi_rx_reg_mask32(HDMI_AAPNR, ~HDMI_AAPNR_esdm_mask, HDMI_AAPNR_esdm_mask, HDMI_RX_MAC);
+	HDMI_DELAYMS(1);
+
+	if (track_mode == HDMI_AUDIO_N_CTS_TREND_BOUND) {
+		HDMI_PRINTF("\n *****N/CTS Trend& Boundary Tracking*****\n");
+		/*
+		 * (12)Enable N/CTS tracking
+		 * Modify N/CTS tracking parameter  USER:kistlin DATE:2011/08/04
+		 * for phase error count source Fpec = Fdds = Fvco/4
+		 * PEpec x Tpec = delta(Tvco)xNxSxPLLO = Tvco(1/8)(D[15:0]/2^16)xNxSxPLLO
+		 * D[15:0] = PEpec x Tpec /[Tvco(1/8)(1//2^16)xNxSxPLLO]
+		 * and D[15:0] = PEpec x (1/8)Icode
+		 * Icode calculate I code =2^24/(N*S*PLLO)
+		 *
+		 * for phase error count source = fvco/4,fdds
+		 * Icode calculate I code =2*2048*2^10/(N*S*PLLO)
+		 */
+		if (hdmi_audiopll_param[i].S1)
+			S = hdmi_audiopll_param[i].S*2;
+		else
+			S = hdmi_audiopll_param[i].S;
+
+		HDMI_PRINTF("S = %d , ACR_N=%d,	hdmi_audiopll_param[i].O = %d\n",
+			S, ACR_N, hdmi_audiopll_param[i].O);
+
+		if (ACR_N) {
+			I_Code = 16*1024*1024/(ACR_N*S*(hdmi_audiopll_param[i].O<<1));
+			I_Code = I_Code;
+		} else {
+			I_Code = 0x02;
+		}
+
+		/* calculate 4*N*(1/128fa) */
+		tmp1 = 4*ACR_N*1000/(128*freq);
+		if (tmp1 < 5)
+			tmp1 = tmp1;/* CTS*Tv < tmp1/4 > 2* CTS*Tv,	CTS*Tv(0.67ms~3.3ms) */
+		else if (tmp1 < 9)
+			tmp1 = tmp1+2;
+		else
+			tmp1 = tmp1+3;
+
+		/* HDMI_PRINTF( "I Code = %d\n",I_Code); */
+		/* HDMI_PRINTF( "tmp1 = %d\n",tmp1); */
+
+		/* Set I code of Ncts[15:8] */
+		hdmi_rx_reg_write32(HDMI_ICPSNCR0, I_Code, HDMI_RX_MAC);
+		/* Set P code of Ncts [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCPSNCR0, 0x0000, HDMI_RX_MAC);
+
+		hdmi_rx_reg_mask32(HDMI_NPECR, ~HDMI_NPECR_ncts_re_enable_off_en_mask,
+			HDMI_NPECR_ncts_re_enable_off_en_mask, HDMI_RX_MAC);
+		/* Enable N_CTS tracking & set FIFO depth */
+		hdmi_rx_reg_write32(HDMI_PSCR, 0x92, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+
+		/* phase error threshold */
+		hdmi_rx_reg_write32(HDMI_PETR, 0x1e, HDMI_RX_MAC);
+		for (timeout = 0; timeout < 25; timeout++) {
+			hdmi_rx_reg_mask32(HDMI_SR, ~_BIT3, _BIT3, HDMI_RX_MAC);
+			hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+			HDMI_DELAYMS(20);
+			if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT3)) == 0)
+				break;
+		}
+
+		if (timeout == 25)
+			HDMI_PRINTF("PLL 1st check not lock = %x\n", hdmi_rx_reg_read32(HDMI_NCPER, HDMI_RX_MAC));
+		else
+			HDMI_PRINTF("PLL 1st check lock count = %d\n", timeout);
+
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~HDMI_PSCR_etcn_mask, 0, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~HDMI_CMCR_dbdcb_mask, HDMI_CMCR_dbdcb_mask, HDMI_RX_MAC);
+
+		hdmi_rx_reg_mask32(HDMI_NPECR, ~HDMI_NPECR_ncts_re_enable_off_en_mask, 0, HDMI_RX_MAC);
+		/* Set I code of Ncts[15:8] */
+		hdmi_rx_reg_write32(HDMI_ICPSNCR0, (HDMI_ICPSNCR0_icl(0x02)|HDMI_ICPSNCR0_ich(0)), HDMI_RX_MAC);
+		/* Set P code of Ncts [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCPSNCR0, (HDMI_PCPSNCR0_pcl(0x0)|HDMI_PCPSNCR0_pch(0x20)), HDMI_RX_MAC);
+
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~HDMI_PSCR_etcn_mask, HDMI_PSCR_etcn_mask, HDMI_RX_MAC);
+
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~HDMI_CMCR_dbdcb_mask, HDMI_CMCR_dbdcb_mask, HDMI_RX_MAC);
+
+		Audio_CTS_Bound();
+
+		Audio_N_Bound(freq);
+
+		/* CTS has glitch not to tracking enable */
+		hdmi_rx_reg_mask32(AUDIO_CTS_UP_BOUND, ~_BIT20, _BIT20, HDMI_RX_MAC);
+		/* N has glitch not to tracking enable */
+		hdmi_rx_reg_mask32(AUDIO_N_UP_BOUND, ~_BIT20, _BIT20, HDMI_RX_MAC);
+
+		/* (13)Wait PLL lock by N&CTS tracking */
+		hdmi_rx_reg_write32(HDMI_PETR, 0x1e, HDMI_RX_MAC);/* phase error threshold */
+		for (timeout = 0; timeout < 25; timeout++) {
+			hdmi_rx_reg_mask32(HDMI_SR, ~_BIT3, _BIT3, HDMI_RX_MAC);
+			hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+			HDMI_DELAYMS(20);
+			if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT3)) == 0)
+				break;
+		}
+
+		if (timeout == 25)
+			HDMI_PRINTF("PLL not lock = %x\n", hdmi_rx_reg_read32(HDMI_NCPER, HDMI_RX_MAC));
+		else
+			HDMI_PRINTF("PLL lock count = %d\n", timeout);
+
+		/* (14)FSM Initial */
+		hdmi_rx_reg_write32(HDMI_FBR, 0x74, HDMI_RX_MAC);
+		/* FSM entry Pre-mode (AOC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT6, _BIT6, HDMI_RX_MAC);
+		/* FSM entry next step (AOMC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT5, _BIT5, HDMI_RX_MAC);
+		HDMI_DELAYMS(1);/* wait fifo to target fifo level */
+
+		/* (15)Enable trend and boundary tracking */
+		/* Set I code  of trend [15:8] */
+		hdmi_rx_reg_write32(HDMI_ICTPSR0, 0x0005, HDMI_RX_MAC);
+		/* Set P code of trend [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCTPSR0, 0x02FF, HDMI_RX_MAC);
+		/* Set I code of bnd [15:8] */
+		hdmi_rx_reg_write32(HDMI_ICBPSR0, 0x0005, HDMI_RX_MAC);
+		/* Set P code of bnd [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCBPSR0, 0x02FF, HDMI_RX_MAC);
+		/* Set Boundary Tracking Update Response Time */
+		hdmi_rx_reg_write32(HDMI_STBPR, 0x01, HDMI_RX_MAC);
+		/* Enable trend and boundary tracking */
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~(_BIT3|_BIT2), (_BIT3|_BIT2), HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+		HDMI_DELAYMS(20);
+		/* Enable trend and boundary tracking */
+		hdmi_rx_reg_mask32(HDMI_WDCR0, ~HDMI_WDCR0_bt_track_en_mask, HDMI_WDCR0_bt_track_en_mask, HDMI_RX_MAC);
+	} else if (track_mode == HDMI_AUDIO_TREND_BOUND) {
+		HDMI_PRINTF("\n ***** TREND_BOUND Tracking*****\n");
+		/* (14)FSM Initial */
+		hdmi_rx_reg_write32(HDMI_FBR, 0x74, HDMI_RX_MAC);
+		/* FSM entry Pre-mode (AOC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT6, _BIT6, HDMI_RX_MAC);
+		/* FSM entry next step (AOMC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT5, _BIT5, HDMI_RX_MAC);
+		HDMI_DELAYMS(1);/* wait fifo to target fifo level */
+
+		/* (15)Enable trend and boundary tracking */
+		/* Set I code  of trend [15:8] */
+		hdmi_rx_reg_write32(HDMI_ICTPSR0, 0x0005, HDMI_RX_MAC);
+		/* Set P code of trend [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCTPSR0, 0x02FF, HDMI_RX_MAC);
+		/* Set I code of bnd [15:8] */
+		hdmi_rx_reg_write32(HDMI_ICBPSR0, 0x0001, HDMI_RX_MAC);
+		/* Set P code of bnd [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCBPSR0, 0x02FF, HDMI_RX_MAC);
+		/* Set Boundary Tracking Update Response Time */
+		hdmi_rx_reg_write32(HDMI_STBPR, 0x01, HDMI_RX_MAC);
+		/* FIFO depth tracking */
+		hdmi_rx_reg_write32(HDMI_PSCR,
+			(HDMI_PSCR_fdint(4) | HDMI_PSCR_etcn(0) | HDMI_PSCR_etfd(1) |
+			HDMI_PSCR_etfbc(1) | HDMI_PSCR_pecs(2)), HDMI_RX_MAC);
+		/* Enable trend and boundary tracking */
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~(_BIT3|_BIT2), (_BIT3|_BIT2), HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+		HDMI_DELAYMS(20);
+		/* Enable trend and boundary tracking */
+		hdmi_rx_reg_mask32(HDMI_WDCR0, ~HDMI_WDCR0_bt_track_en_mask, HDMI_WDCR0_bt_track_en_mask, HDMI_RX_MAC);
+
+	} else {
+		/* H/W N/CTS Tracking */
+		HDMI_PRINTF("\n ***** N/CTS Tracking*****\n");
+		/* (12)Enable N/CTS tracking */
+		if (hdmi_audiopll_param[i].S1)
+			S = hdmi_audiopll_param[i].S * 2;
+		else
+			S = hdmi_audiopll_param[i].S;
+
+		HDMI_PRINTF("S = %d , ACR_N=%d ,	hdmi_audiopll_param[i].O = %d\n",
+			S, ACR_N, hdmi_audiopll_param[i].O);
+
+		if (ACR_N) {
+			I_Code = 16*1024*1024/(ACR_N*S*(hdmi_audiopll_param[i].O<<1));
+			I_Code = I_Code;
+		} else {
+			I_Code = 0x02;
+		}
+		/* Calculate 4*N*(1/128fa) */
+		tmp1 = 4*ACR_N*1000/(128*freq);
+		if (tmp1 < 5)
+			tmp1 = tmp1;/* CTS*Tv < tmp1/4 > 2* CTS*Tv,	CTS*Tv(0.67ms~3.3ms) */
+		else if (tmp1 < 9)
+			tmp1 = tmp1+2;
+		else
+			tmp1 = tmp1+3;
+
+		/* HDMI_PRINTF( "I Code = %d\n", I_Code); */
+		/* HDMI_PRINTF( "tmp1 = %d\n", tmp1); */
+
+		/* Set I code of Ncts[15:8] */
+		hdmi_rx_reg_write32(HDMI_ICPSNCR0, I_Code, HDMI_RX_MAC);
+		/* Set P code of Ncts [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCPSNCR0, 0x0000, HDMI_RX_MAC);
+
+		hdmi_rx_reg_mask32(HDMI_NPECR, ~HDMI_NPECR_ncts_re_enable_off_en_mask,
+			HDMI_NPECR_ncts_re_enable_off_en_mask, HDMI_RX_MAC);
+		/* Enable N_CTS tracking & set FIFO depth */
+		hdmi_rx_reg_write32(HDMI_PSCR, 0x92, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+
+		/* phase error threshold */
+		hdmi_rx_reg_write32(HDMI_PETR, 0x1e, HDMI_RX_MAC);
+		for (timeout = 0; timeout < 25; timeout++) {
+			hdmi_rx_reg_mask32(HDMI_SR, ~_BIT3, _BIT3, HDMI_RX_MAC);
+			hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+			HDMI_DELAYMS(20);
+			if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT3)) == 0)
+				break;
+		}
+
+		if (timeout == 25)
+			HDMI_PRINTF("PLL 1st check not lock = %x\n",
+				hdmi_rx_reg_read32(HDMI_NCPER, HDMI_RX_MAC));
+		else
+			HDMI_PRINTF("PLL 1st check lock count = %d\n", timeout);
+
+		/* Disable N_CTS tracking */
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~_BIT4, 0, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+		/* N_CTS tracking re-enable toggle function disable */
+		hdmi_rx_reg_mask32(HDMI_NPECR, ~HDMI_NPECR_ncts_re_enable_off_en_mask, 0, HDMI_RX_MAC);
+		/* Set I code of Ncts[15:8] */
+		hdmi_rx_reg_write32(HDMI_ICPSNCR0, 0x0002, HDMI_RX_MAC);
+		/* Set P code of Ncts [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCPSNCR0, 0x2000, HDMI_RX_MAC);
+		/* Enable N_CTS tracking */
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+
+		Audio_CTS_Bound();
+
+		Audio_N_Bound(freq);
+		/* CTS has glitch not to tracking enable */
+		hdmi_rx_reg_mask32(AUDIO_CTS_UP_BOUND, ~_BIT20, _BIT20, HDMI_RX_MAC);
+		/* N has glitch not to tracking enable */
+		hdmi_rx_reg_mask32(AUDIO_N_UP_BOUND, ~_BIT20, _BIT20, HDMI_RX_MAC);
+
+		/* (13)Wait PLL lock by N&CTS tracking */
+		/* phase error threshold */
+		hdmi_rx_reg_write32(HDMI_PETR, 0x1e, HDMI_RX_MAC);
+		for (timeout = 0; timeout < 25; timeout++) {
+			hdmi_rx_reg_mask32(HDMI_SR, ~_BIT3, _BIT3, HDMI_RX_MAC);
+			hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+			HDMI_DELAYMS(20);
+			if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT3)) == 0)
+				break;
+		}
+
+		if (timeout == 25)
+			HDMI_PRINTF("PLL not lock = %x\n",
+				hdmi_rx_reg_read32(HDMI_NCPER, HDMI_RX_MAC));
+		else
+			HDMI_PRINTF("PLL lock count = %d\n", timeout);
+
+		/* (14)FSM Initial */
+		/* Target FIFO depth = 14 ,Boundary address distance = 7 */
+		hdmi_rx_reg_write32(HDMI_FBR, 0x77, HDMI_RX_MAC);
+		/* FSM entry Pre-mode (AOC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT6, _BIT6, HDMI_RX_MAC);
+		/* FSM entry next step (AOMC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT5, _BIT5, HDMI_RX_MAC);
+		HDMI_DELAYMS(1);/* wait fifo to target fifo level */
+	}
+
+	/* (16)Wait FIFO stable */
+	for (timeout = 0; timeout < 5; timeout++) {
+		hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+		HDMI_DELAYMS(20);
+		if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT3|_BIT2|_BIT1)) == 0)
+			break;
+		hdmi_rx_reg_mask32(HDMI_SR, ~(_BIT3|_BIT2|_BIT1), (_BIT3|_BIT2|_BIT1), HDMI_RX_MAC);
+	}
+
+	if (timeout == 5)
+		HDMI_PRINTF("FIFO Unstable  = %x\n", hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+	else
+		HDMI_PRINTF("FIFO timeout count = %d\n", timeout);
+
+	HDMI_PRINTF("HDMI_HDMI_AVMCR_reg = %x\n", hdmi_rx_reg_read32(HDMI_AVMCR, HDMI_RX_MAC));
+
+	return TRUE;
+
+}
+
+void Hdmi_AudioOutputDisable(void)
+{
+	hdmi_rx_reg_mask32(HDMI_AVMCR, ~(_BIT6 | _BIT5), _BIT6, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_CMCR, 0x50, HDMI_RX_MAC);/* K code =2 */
+}
+
+void Hdmi_AudioOutputEnable(void)
+{
+	hdmi_rx_reg_mask32(HDMI_AVMCR, ~(_BIT6|_BIT5), (_BIT6|_BIT5), HDMI_RX_MAC);
+}
+
+unsigned char Hdmi_WaitAudioSample(void)
+{
+	char   timeout_cnt = 6;
+
+	/* looking for ACR info using RSV2 */
+	/* Wait for ACR : Packet Type = 0x01 */
+	hdmi_rx_reg_mask32(HDMI_PTRSV1, ~0x00FF00, 0x02<<8, HDMI_RX_MAC);
+	/* Clear RSV2 indicator */
+	hdmi_rx_reg_write32(HDMI_GPVS, _BIT6, HDMI_RX_MAC);
+
+	/* Wait 30ms max. to wait ACR */
+	for (; timeout_cnt > 0; timeout_cnt--) {
+		HDMI_DELAYMS(10);
+		if (hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC) & _BIT6) {
+			hdmi_rx_reg_write32(HDMI_PSAP, 110, HDMI_RX_MAC);
+
+			if (hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC) & 0x10)
+				SET_HDMI_AUDIO_LAYOUT(1);
+			else
+				SET_HDMI_AUDIO_LAYOUT(0);
+
+			/* HDMI_PRINTF("Layout = %d\n", GET_HDMI_AUDIO_LAYOUT()); */
+			hdmi_rx_reg_write32(HIGH_BIT_RATE_AUDIO_PACKET, 0x04, HDMI_RX_MAC);
+
+			return TRUE;
+		}
+	}
+
+	HDMI_PRINTF("Audio Sample miss\n");
+	return FALSE;
+}
+
+int Hdmi_AudioFreqCorrect(unsigned int freq, unsigned long b, HDMI_AUDIO_TRACK_MODE *track_mode)
+{
+	unsigned int b_ratio = 1000;
+
+	*track_mode = HDMI_AUDIO_N_CTS_TREND_BOUND;
+
+	freq *= 10;
+	if ((freq >= (31700*b_ratio/100)) && (freq <= (32300*b_ratio/100)))
+		freq = 32000;
+	else if ((freq >= (43500*b_ratio/100)) && (freq <= (44600*b_ratio/100)))
+		freq = 44100;
+	else if ((freq >= 47500*b_ratio/100) && (freq <= (48500*b_ratio/100)))
+		freq = 48000;
+	else if ((freq >= (87700*b_ratio/100)) && (freq <= (88700*b_ratio/100)))
+		freq = 88200;
+	else if ((freq >= (95500*b_ratio/100)) && (freq <= (96500*b_ratio/100)))
+		freq = 96000;
+	else if ((freq >= (175400*b_ratio/100)) && (freq <= (177400*b_ratio/100)))
+		freq = 176400;
+	else if ((freq >= (191000*b_ratio/100)) && (freq <= (193000*b_ratio/100)))
+		freq = 192000;
+	else
+		freq = 0;
+
+	return freq;
+}
+
+void Hdmi_GetAudioFreq(HDMI_AUDIO_FREQ_T *freq, HDMI_AUDIO_TRACK_MODE *track_mode)
+{
+	unsigned long cts, n, b;
+	unsigned char count = 0;
+	HDMIRX_IOCTL_STRUCT_T isr_info;
+
+	freq->ACR_freq = 0;
+	freq->AudioInfo_freq = 0;
+	freq->SPDIF_freq = 0;
+
+	/* Set trigger to get CTS&N and LPCM Channel Status Info */
+
+	/* Start Pop up N_CTS value */
+	hdmi_rx_reg_mask32(HDMI_ACRCR, ~(_BIT1|_BIT0), _BIT1|_BIT0, HDMI_RX_MAC);
+
+	/* Restart measure b */
+	hdmi_rx_reg_mask32(HDMI_NTX1024TR0, ~_BIT3, _BIT3, HDMI_RX_MAC);
+
+	/* Clear Info Frame update indicator */
+	hdmi_rx_reg_write32(HDMI_ASR0, 0x07, HDMI_RX_MAC);
+
+	for (count = 0; count < 15; count++) {
+		if (((hdmi_rx_reg_read32(HDMI_ACRCR, HDMI_RX_MAC) & (_BIT1|_BIT0)) == 0) &&
+			((hdmi_rx_reg_read32(HDMI_ASR0, HDMI_RX_MAC) & 0x01) == 0x01))
+			break;
+		HDMI_DELAYMS(10);
+	}
+	if (count >= 15)
+		HDMI_PRINTF("POP UP TIME OUT %x  %x\n",
+			hdmi_rx_reg_read32(HDMI_ACRCR, HDMI_RX_MAC),
+			hdmi_rx_reg_read32(HDMI_ASR0, HDMI_RX_MAC));
+
+	HDMI_PRINTF("POP UP TIME %d\n", count);
+
+	/* Get Audio Frequency from CTS&N */
+	cts = HDMI_ACRSR0_get_cts(hdmi_rx_reg_read32(HDMI_ACRSR0, HDMI_RX_MAC));
+	n =  HDMI_ACRSR1_get_n(hdmi_rx_reg_read32(HDMI_ACRSR1, HDMI_RX_MAC));
+
+	ACR_N = n;
+	HdmiGetStruct(&isr_info);
+	b = isr_info.b;
+
+	HDMI_PRINTF("cts=%ld\nn=%ld\nb=%ld\n", cts, n, b);
+
+	if ((cts == 0) || (n == 0) || (b == 0))
+		goto METHOD_AUDIO_INFO;
+
+	/*
+	 * 128fs = 1024/b * fx * N / CTS  =>  fs = (1024 * fx *N)/(128 * b * CTS) = (8 * fx *N)/(b*CTS)
+	 * calculate freq in 0.1kHz unit
+	 * freq = (unsigned long)8 * 2 * 10000 * HDMI_RTD_XTAL/ cts * n / ((unsigned long)b * 1000);
+	 */
+	freq->ACR_freq = ((((270000 * b)/256)/128) * n) / (cts);
+	freq->ACR_freq *= 100;
+
+	freq->ACR_freq = Hdmi_AudioFreqCorrect(freq->ACR_freq, b, track_mode);
+
+	/* Get Audio Frequency from Audio Info Frame */
+METHOD_AUDIO_INFO:
+
+	if ((hdmi_rx_reg_read32(HDMI_ASR0, HDMI_RX_MAC) & 0x01) == 0x01)
+		freq->SPDIF_freq = AUDIO_CHANNEL_STATUS[hdmi_rx_reg_read32(HDMI_ASR1, HDMI_RX_MAC)&0xf];
+
+	HDMI_PRINTF("\n *************** SPDIF freq=%ld\n", freq->SPDIF_freq);
+}
+
+
+HDMI_bool Hdmi_AudioModeDetect(void)
+{
+	unsigned char result = FALSE;
+	unsigned int d_code;
+	int i;
+	HDMI_AUDIO_FREQ_T t, t2;
+	HDMI_AUDIO_TRACK_MODE track_mode;
+	static unsigned int spdif_freq;
+
+	if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & _BIT6) {
+		HDMI_PRINTF("Audio Detect AV Mute\n");
+		Hdmi_AudioOutputDisable();
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		return FALSE;
+	}
+
+	switch (GET_HDMI_AUDIO_FSM()) {
+	case AUDIO_FSM_AUDIO_START:
+		HDMI_PRINTF("AUDIO_FSM_AUDIO_START\n");
+
+		hdmi_ioctl_struct.audio_detect_done = 0;
+
+		SET_HDMI_AUDIO_TYPE(HDMI_AUDIO_PCM);
+
+		SET_HDMI_HBR_MODE(0);
+		/* clear Overflow,Underflow,phase_non_lock, auto load double buffter */
+		hdmi_rx_reg_write32(HDMI_DBCR, 0x00, HDMI_RX_MAC);
+		/*Disable audio watch dog*/
+		hdmi_rx_reg_mask32(HDMI_WDCR0, (~_BIT15), 0x00, HDMI_RX_MAC);/* disable  tmds clock audio watch dog */
+		hdmi_rx_reg_mask32(HDMI_WDCR0, ~(_BIT1|_BIT2|_BIT3|_BIT4), 0x00, HDMI_RX_MAC);
+		Hdmi_AudioOutputDisable();
+
+		/*Disable FIFO trend tracking*/
+		hdmi_rx_reg_write32(HDMI_PSCR, 0xE2, HDMI_RX_MAC);
+		/*Update Double Buffer*/
+		hdmi_rx_reg_write32(HDMI_CMCR, 0x50, HDMI_RX_MAC);//K code =2
+
+		if (Hdmi_WaitAudioSample() == FALSE)
+			break;
+
+		/* reset state if only pattern change without timing change */
+		HDMI_Audio_Conut = 0;
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_FREQ_DETECT);
+	case AUDIO_FSM_FREQ_DETECT:
+		HDMI_PRINTF("AUDIO_FSM_FREQ_DETECT\n");
+		if (HDMI_AUDIO_IS_LPCM() == 0) {
+			HDMI_PRINTF("HDMI NON-PCM Audio\n");
+			SET_HDMI_AUDIO_TYPE(HDMI_AUDIO_NPCM);
+		}
+
+		if (HDMI_AUDIO_IS_LPCM() || HDMI_AUDIO_SUPPORT_NON_PCM()) {
+			Hdmi_GetAudioFreq(&t, &track_mode);
+			/*detect HDMI audio freq twice for stable freq */
+			Hdmi_GetAudioFreq(&t2, &track_mode);
+			HDMI_PRINTF("Hdmi_GetAudioFreq t=%ld\n", t.ACR_freq);
+			HDMI_PRINTF("Hdmi_GetAudioFreq t2=%ld\n", t2.ACR_freq);
+			if ((t.ACR_freq != 0) && (t.ACR_freq == t2.ACR_freq)) {
+				if (HDMI_Audio_Conut == 0) {
+					HDMI_Audio_Conut = 1;
+					if (Hdmi_AudioPLLSetting(t.ACR_freq, track_mode) == TRUE) {
+						SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_WAIT_PLL_READY);
+						spdif_freq = t.SPDIF_freq;
+						break;
+					}
+				} else {
+					/* HDMI_Audio_Conut  = 1, force to trend_boundary tracking */
+					HDMI_Audio_Conut = 0;
+					if (Hdmi_AudioPLLSetting(t.ACR_freq, HDMI_AUDIO_TREND_BOUND) == TRUE) {
+						SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_WAIT_PLL_READY);
+						spdif_freq = t.SPDIF_freq;
+						break;
+					}
+				}
+			} else {
+				if ((t.ACR_freq == 0) || (t2.ACR_freq == 0)) {
+					/* cts = 0,use t.SPDIF_freq and force to trend_boundary tracking */
+					if (Hdmi_AudioPLLSetting(t.SPDIF_freq, HDMI_AUDIO_TREND_BOUND) == TRUE) {
+						if (t.SPDIF_freq == t2.SPDIF_freq) {
+							SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_WAIT_PLL_READY);
+							spdif_freq = t.SPDIF_freq;
+							break;
+						}
+					}
+				}
+			}
+		}
+
+		break;
+	case AUDIO_FSM_AUDIO_WAIT_PLL_READY:
+		HDMI_PRINTF("AUDIO_FSM_AUDIO_WAIT_PLL_READY\n");
+
+		for (i = 0; i < 5; i++) {
+			hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+			HDMI_DELAYMS(20);
+			if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT3|_BIT2|_BIT1)) == 0)
+				break;
+			hdmi_rx_reg_mask32(HDMI_SR, ~(_BIT3|_BIT2|_BIT1), (_BIT3|_BIT2|_BIT1), HDMI_RX_MAC);
+		}
+
+		HDMI_PRINTF("FIFO timeout count2= %d\n", i);
+		if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT1|_BIT2|_BIT3)) {
+			HDMI_PRINTF("Audio PLL not ready = %x\n", hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+			SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+			return FALSE;
+		}
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START_OUT);
+	/* Play audio here */
+	case AUDIO_FSM_AUDIO_START_OUT:
+		HDMI_PRINTF("AUDIO_FSM_AUDIO_START_OUT\n");
+		hdmi_rx_reg_mask32(HDMI_DBCR, 0xF0, 0x0F, HDMI_RX_MAC);
+
+		d_code = hdmi_rx_reg_read32(HDMI_APLLCR3, HDMI_RX_MAC);
+
+		for (i = 0; i < 5; i++) {
+			if (d_code == hdmi_rx_reg_read32(HDMI_APLLCR3, HDMI_RX_MAC))
+				break;
+		}
+		/* pre-set D code */
+		hdmi_rx_reg_write32(HDMI_DCAPR0, d_code, HDMI_RX_MAC);
+
+		/* pre-disable N/CTS tracking & FIFO depth */
+		hdmi_rx_reg_write32(HDMI_PSCR, 0xE2, HDMI_RX_MAC);
+
+		/* Enable audio Overflow & Underflow watch dog but not Audio type wdg */
+		hdmi_rx_reg_mask32(HDMI_WDCR0, ~(_BIT1|_BIT2|_BIT3|_BIT4),
+			_BIT1|_BIT2|_BIT3|_BIT4, HDMI_RX_MAC);
+		/* Enable audio tmds clock  watch dog */
+		hdmi_rx_reg_mask32(HDMI_WDCR0, (~_BIT15), _BIT15, HDMI_RX_MAC);
+
+		Hdmi_AudioOutputEnable();
+
+		/* Enable SPDIF/I2S Output */
+		hdmi_rx_reg_mask32(HDMI_AOCR, (unsigned char)(~0x0ff), 0xFF, HDMI_RX_MAC);
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_CHECK);
+		result = TRUE;
+
+		hdmi.audio_freq = spdif_freq;
+		hdmi.spdif_type = HDMI_SR_get_spdiftype(hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+		hdmi_ioctl_struct.audio_detect_done = 1;
+
+		break;
+	case AUDIO_FSM_AUDIO_CHECK:
+		/* if FIFO overflow then restart Audio process */
+		if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT3)) {
+			HDMI_PRINTF("Audio Output Disable cause by pll unlock :%x\n",
+				hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+
+			Hdmi_AudioOutputDisable();
+			SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		}
+		if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT1|_BIT2)) {
+			HDMI_PRINTF("Audio Output Disable cause by over_underflow :%x\n",
+				hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+
+			Hdmi_AudioOutputDisable();
+			SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		}
+
+		if ((hdmi_rx_reg_read32(HDMI_AVMCR, HDMI_RX_MAC) & (_BIT5)) == 0) {
+			HDMI_PRINTF("Audio Output Disable cause by AVMCR output disable:%x\n",
+				hdmi_rx_reg_read32(HDMI_AVMCR, HDMI_RX_MAC));
+
+			Hdmi_AudioOutputDisable();
+			SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		}
+
+		/* if TX change audio mode to non-LPCM */
+		if ((HDMI_AUDIO_IS_LPCM() == 0) && (HDMI_AUDIO_SUPPORT_NON_PCM() == 0)) {
+			Hdmi_AudioOutputDisable();
+			HDMI_PRINTF("Audio Output Disable cause non-Linear PCM\n");
+			SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		}
+		if (((HDMI_AUDIO_IS_LPCM()) && GET_HDMI_AUDIO_TYPE()) ||
+			((HDMI_AUDIO_IS_LPCM() == 0) && (GET_HDMI_AUDIO_TYPE() == 0))) {
+			Hdmi_AudioOutputDisable();
+			HDMI_PRINTF("Audio Type change\n");
+			SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		}
+
+		break;
+	default:
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		break;
+	} /* end of switch (GET_HDMI_AUDIO_FSM()) */
+
+	return result;
+}
+
+void Hdmi_VideoOutputDisable(void)
+{
+	hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT3, 0x00, HDMI_RX_MAC);
+}
+
+void Hdmi_VideoOutputEnable(void)
+{
+	hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT3, _BIT3, HDMI_RX_MAC);
+}
+
+void hdmi_clock_port_select(int port, char enable)
+{
+	switch (port) {
+	case HDMI_CHANNEL0:
+		/* port 0 set CKAFE power ,port bias ,input reference no hysteresis amp */
+		hdmi_rx_reg_mask32(P0_CK1, ~(P0_CK1_reg_p0_ck_1_mask|p0_ck_2_CMU_CKIN_SEL),
+			(p0_ck_1_CKAFE_POW|p0_ck_1_port_bias|_BIT13|_BIT14|_BIT15), HDMI_RX_PHY);
+
+		/* port 1 set CKAFE power ,port bias ,input reference no hysteresis amp */
+		hdmi_rx_reg_mask32(P1_CK1, ~(P1_CK1_reg_p1_ck_1_mask|p1_ck_2_CMU_CKIN_SEL), 0, HDMI_RX_PHY);
+
+		/* port 2 set CKAFE power ,port bias ,input reference no hysteresis amp */
+		hdmi_rx_reg_mask32(P2_CK1, ~(P2_CK1_reg_p2_ck_1_mask|p2_ck_2_CMU_CKIN_SEL), 0, HDMI_RX_PHY);
+		break;
+	default:
+		HDMIRX_INFO("[%s] Unknow port", __func__);
+		break;
+	}
+}
+
+void hdmi_phy_port_select(int port, char enable)
+{
+	hdmi_z0_set(port, LN_ALL, 1);
+
+	/* CK_TX select from which port */
+	hdmi_rx_reg_mask32(TOP_IN, ~TOP_IN_reg_top_in_1_mask, TOP_IN_reg_top_in_1(1<<port), HDMI_RX_PHY);
+	hdmi_clock_port_select(port, enable);
+	/* Digital part sel port */
+	hdmi_rx_reg_mask32(PHY_FIFO_CR, ~PHY_FIFO_CR_port_sel_mask, PHY_FIFO_CR_port_sel(port), HDMI_RX_MAC);
+	/* Clock detect */
+	hdmi_rx_reg_mask32(MD, ~MD_reg_ck_ckdet_mask, MD_reg_ck_ckdet(1<<port), HDMI_RX_PHY);
+
+	switch (port) {
+	case HDMI_CHANNEL0:
+		/* mode detect clock reset */
+		hdmi_rx_reg_mask32(REGD42, ~(REGD42_p0_ck_md_rstb_mask), (REGD42_p0_ck_md_rstb_mask), HDMI_RX_PHY);
+
+		/* HDMI mode & MHL 2.0 buffer power off */
+		hdmi_rx_reg_mask32(MHL, ~(MHL_reg_p0_mhl_hdmi_cksel_mask|MHL_reg_p0_mhl_hdmi_datasel_mask|MHL_reg_p0_mhl_hdmi_cksel_mask),
+			(MHL_reg_p0_mhl_hdmi_datasel_mask|MHL_reg_p0_mhl_hdmi_cksel_mask), HDMI_RX_PHY);
+
+		/* B lane PR power on & EQ power */
+		hdmi_rx_reg_mask32(P0_B2, ~(P0_b_8_POW_PR|P0_b_5_EQ_POW), (P0_b_8_POW_PR|P0_b_5_EQ_POW), HDMI_RX_PHY);
+		/* G lane PR power on  & EQ power */
+		hdmi_rx_reg_mask32(P0_G2, ~(P0_g_8_POW_PR|P0_g_5_EQ_POW), (P0_g_8_POW_PR|P0_g_5_EQ_POW), HDMI_RX_PHY);
+
+		/* R lane PR power on  & EQ power */
+		hdmi_rx_reg_mask32(P0_R2, ~(P0_r_8_POW_PR|P0_r_5_EQ_POW), (P0_r_8_POW_PR|P0_r_5_EQ_POW), HDMI_RX_PHY);
+
+		/* port bias  & CK AFE power */
+		hdmi_rx_reg_mask32(P0_CK1, ~(p0_ck_1_port_bias|p0_ck_1_CKAFE_POW), (p0_ck_1_port_bias|p0_ck_1_CKAFE_POW), HDMI_RX_PHY);
+
+		/* LDO enable */
+		hdmi_rx_reg_mask32(P0_CK2, ~(P0_ck_8_LDO_EN), (P0_ck_8_LDO_EN), HDMI_RX_PHY);
+		/* PLL enable  need to check close other port or not */
+		hdmi_rx_reg_mask32(ENABLE, ~(ENABLE_reg_p0_en_cmu_mask), (ENABLE_reg_p0_en_cmu_mask), HDMI_RX_PHY);
+		/* ynchronous FIFO control  invert */
+		hdmi_rx_reg_mask32(PHY_FIFO_CR, ~(PHY_FIFO_CR_port0_bclk_inv_mask|PHY_FIFO_CR_port0_gclk_inv_mask|PHY_FIFO_CR_port0_rclk_inv_mask),
+			(PHY_FIFO_CR_port0_bclk_inv_mask|PHY_FIFO_CR_port0_gclk_inv_mask|PHY_FIFO_CR_port0_rclk_inv_mask), HDMI_RX_MAC);
+
+		break;
+
+	default:
+		HDMIRX_INFO("[%s] Unknow port", __func__);
+	break;
+	} /* end of switch (port) */
+
+}
+
+HDMI_ERR_T Hdmi_CheckConditionChange(void)
+{
+	HDMIRX_IOCTL_STRUCT_T isr_info;
+
+	HdmiGetStruct(&isr_info);
+
+	if (isr_info.b < 10) {
+		/* HDMIRX_DEBUG("b < 10 change = %d  " ,isr_info.b); */
+		return HDMI_EER_GENERIC;
+	}
+
+	if (HDMI_ABS(hdmi.b, isr_info.b) > 4) {
+		/* HDMIRX_DEBUG(" abs b > 4  change"); */
+		return HDMI_EER_GENERIC;
+	}
+
+	if ((unsigned int)GET_HDMI_CD() != (hdmi_rx_reg_read32(TMDS_DPC0, HDMI_RX_MAC) & 0xf)) {
+		/* HDMIRX_DEBUG("color depth"); */
+		return HDMI_EER_GENERIC;
+	}
+
+	if (isr_info.b_change) {
+		/* HDMIRX_DEBUG("b change = %d",isr_info.b); */
+		return HDMI_EER_GENERIC;
+	}
+
+	if (GET_ISHDMI() != IsHDMI()) {
+		/* HDMIRX_DEBUG("HDMI/DVI change"); */
+		return HDMI_EER_GENERIC;
+	}
+
+	return HDMI_ERR_NO;
+}
+
+HDMI_COLOR_SPACE_T Hdmi_GetColorSpace(void)
+{
+	UINT8 bColor_temp;
+	HDMIRX_IOCTL_STRUCT_T isr_info;
+
+	HdmiGetStruct(&isr_info);
+
+	bColor_temp = (HDMI_COLOR_SPACE_T)HDMI_VCR_get_csc_r(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+
+	if (bColor_temp == COLOR_YUV420) {
+		bColor_temp = COLOR_YUV444;
+		/* Enable YUV420to444 */
+		hdmi_rx_reg_mask32(YUV420_CR, ~YUV420_CR_en_mask, YUV420_CR_en_mask, HDMI_RX_MAC);
+	} else {
+		/* Disable YUV420to444 */
+		hdmi_rx_reg_mask32(YUV420_CR, ~YUV420_CR_en_mask, 0, HDMI_RX_MAC);
+	}
+
+	hdmi.gen_timing.color = (HDMI_COLOR_SPACE_T)bColor_temp;
+
+	return ColorMap[hdmi.gen_timing.color];
+}
+
+
+HDMI_bool Hdmi_Measure(void)
+{
+	int retry;
+	HDMI_TIMING_T temp;
+
+	if (Hdmi_MeasureTiming(&hdmi.tx_timing, hdmi.b) == FALSE) {
+#if HDMI2p0
+		TMDS_6G_Recovery();
+#endif
+		HDMI_PRINTF("Hdmi_MeasureTiming Error\n");
+		return MEASURE_FAIL;
+	}
+
+	if (hdmi.tx_timing.v_act_len > hdmi.tx_timing.v_total)
+		return MEASURE_FAIL;
+
+	if (hdmi.tx_timing.h_act_len > hdmi.tx_timing.h_total)
+		return MEASURE_FAIL;
+
+	if (hdmi.tx_timing.h_act_len < 120)
+		return MEASURE_FAIL;
+
+	if (hdmi.tx_timing.v_act_len < 240)
+		return MEASURE_FAIL;
+
+
+	for (retry = 0; retry < HDMI_MEMSURE_RETRY; retry++) {
+		if (Hdmi_MeasureTiming(&temp, hdmi.b) == FALSE) {
+			HDMI_PRINTF("Hdmi_MeasureTiming Error\n");
+			return MEASURE_FAIL;
+		}
+
+		if (ABS(temp.h_total, hdmi.tx_timing.h_total) != 0)
+			return MEASURE_FAIL;
+		if (ABS(temp.v_total, hdmi.tx_timing.v_total) > 5)
+			return MEASURE_FAIL;
+
+		if (ABS(temp.h_act_len, hdmi.tx_timing.h_act_len) != 0)
+			return MEASURE_FAIL;
+		if (ABS(temp.v_act_len, hdmi.tx_timing.v_act_len) != 0)
+			return MEASURE_FAIL;
+
+		if (ABS(temp.h_freq, hdmi.tx_timing.h_freq) > 5)
+			return MEASURE_FAIL;
+		if (ABS(temp.v_freq,  hdmi.tx_timing.v_freq) > 5)
+			return MEASURE_FAIL;
+	}
+
+#if HDMI2p0
+	b6G_detect_cnt = 0;
+#endif
+
+	return _MODE_SUCCESS;
+}
+
+void Hdmi_DumpState(void)
+{
+#if HDMI_INTERNAL_DEBUG
+	char *colormetry_name[]  = {
+		"HDMI_COLORIMETRY_NOSPECIFIED",
+		"HDMI_COLORIMETRY_601",
+		"HDMI_COLORIMETRY_709",
+		"HDMI_COLORIMETRY_XYYCC601",
+		"HDMI_COLORIMETRY_XYYCC709",
+		"HDMI_COLORIMETRY_SYCC601",
+		"HDMI_COLORIMETRY_ADOBE_YCC601",
+		"HDMI_COLORIMETRY_ADOBE_RGB",
+	};
+	char *depth_name[] = {
+		"HDMI_COLOR_DEPTH_8B",
+		"HDMI_COLOR_DEPTH_10B",
+		"HDMI_COLOR_DEPTH_12B",
+		"HDMI_COLOR_DEPTH_16B",
+	};
+	char *colorspace_name[] = {
+		"COLOR_RGB",
+		"COLOR_YUV422",
+		"COLOR_YUV444",
+		"COLOR_YUV420",
+		"COLOR_UNKNOW"
+	};
+	char *hdmi_3d_name[] = {
+		"HDMI3D_FRAME_PACKING",
+		"HDMI3D_FIELD_ALTERNATIVE",
+		"HDMI3D_LINE_ALTERNATIVE",
+		"HDMI3D_SIDE_BY_SIDE_FULL",
+		"HDMI3D_L_DEPTH",
+		"HDMI3D_L_DEPTH_GPX",
+		"HDMI3D_TOP_AND_BOTTOM",
+		"HDMI3D_RSV0",
+		"HDMI3D_SIDE_BY_SIDE_HALF",
+		"HDMI3D_RSV1",
+		"HDMI3D_2D_ONLY",
+	};
+#endif
+	HDMI_PRINTF("bHDMIColorSpace = %s\n",
+		hdmi.tx_timing.color < (sizeof(colorspace_name)/4) ? colorspace_name[hdmi.tx_timing.color] : "UNDEFINED");
+	HDMI_PRINTF("IsInterlaced = %d\n", GET_HDMI_ISINTERLACE());
+	HDMI_PRINTF("bIsHDMIDVI = %d\n", GET_ISHDMI());
+	HDMI_PRINTF("VedioFSMState = %d\n", GET_HDMI_VIDEO_FSM());
+	HDMI_PRINTF("AudioFSMState = %d\n", GET_HDMI_AUDIO_FSM());
+	HDMI_PRINTF("ColorDepth = %s\n",
+		hdmi.tx_timing.depth < (sizeof(depth_name)/4) ? depth_name[hdmi.tx_timing.depth] : "UNDEFINED");
+	HDMI_PRINTF("ColorMetry = %s\n",
+		hdmi.tx_timing.colorimetry < (sizeof(colormetry_name)/4) ? colormetry_name[hdmi.tx_timing.colorimetry] : "UNDEFINED");
+	HDMI_PRINTF("3D Format  = %s\n",
+		hdmi.tx_timing.hdmi_3dformat < (sizeof(hdmi_3d_name)/4) ? hdmi_3d_name[hdmi.tx_timing.hdmi_3dformat] : "UNDEFINED");
+	HDMI_PRINTF("FW 3D Format	= %s\n",
+		hdmi.gen_timing.hdmi_3dformat < (sizeof(hdmi_3d_name)/4) ? hdmi_3d_name[hdmi.gen_timing.hdmi_3dformat] : "UNDEFINED");
+
+	if (hdmi.gen_timing.hdmi_3dformat < HDMI3D_2D_ONLY) {
+		HDMI_PRINTF("FW ColorDepth = %s\n",
+			hdmi.gen_timing.depth < (sizeof(depth_name)/4) ? depth_name[hdmi.gen_timing.depth] : "UNDEFINED");
+		HDMI_PRINTF("FW ColorMetry = %s\n",
+			hdmi.gen_timing.colorimetry < (sizeof(colormetry_name)/4) ? colormetry_name[hdmi.gen_timing.colorimetry] : "UNDEFINED");
+	}
+	/* HDMI_PRINTF( "Is422 = %d\n", GET_SCALER_IS422()); */
+}
+
+
+#if HDMI2p0
+unsigned char drvif_Hdmi2p0_Scdc_Read(unsigned char addr)
+{
+	hdmi_rx_reg_write32(SCDC_AP, addr, HDMI_RX_MAC);
+	return hdmi_rx_reg_read32(SCDC_DP, HDMI_RX_MAC);
+}
+
+void drvif_Hdmi2p0_Scdc_Write(unsigned char addr, unsigned char value)
+{
+	hdmi_rx_reg_write32(SCDC_AP, addr, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(SCDC_DP, value, HDMI_RX_MAC);
+}
+
+void drvif_Hdmi2p0_Scdc_Reset(void)
+{
+	hdmi_rx_reg_mask32(SCDC_CR, ~(SCDC_CR_scdc_reset_mask), SCDC_CR_scdc_reset_mask, HDMI_RX_MAC);
+	HDMIRX_INFO("[HDMI2.0] Rest SCDC");
+	hdmi_rx_reg_mask32(SCDC_CR, ~(SCDC_CR_scdc_reset_mask), 0, HDMI_RX_MAC);
+	bHDMI_6G_flag = 0;
+}
+
+void drvif_Hdmi2p0_DetectMode(void)
+{
+	UINT8 bTMDSStatus = 0;
+
+	/* Dummy Bit for 6G test */
+	if (hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC)&HDMI_6G_TEST) {
+		bHDMI_6G_flag = 1;
+		/* Manual enable scrambling */
+		hdmi_rx_reg_mask32(SCR_CR, ~(SCR_CR_scr_en_fw_mask|SCR_CR_scr_auto_mask),
+			SCR_CR_scr_en_fw_mask, HDMI_RX_MAC);
+		HDMI_PRINTF("[HDMI2.0] TMDS mode clock 40X  CTS mode\n");
+	} else {
+		bTMDSStatus = drvif_Hdmi2p0_Scdc_Read(SCDC_TMDS_Config);
+		if (((bTMDSStatus&_BIT1) == _BIT1) && ((bTMDSStatus&_BIT0) == _BIT0)) {
+			bHDMI_6G_flag = 1;
+			HDMI_PRINTF("[HDMI2.0] TMDS mode clock 40X\n");
+		} else {
+			/* For 6G recovery setting */
+			if (b6G_detect_cnt > 2) {
+				bHDMI_6G_flag = 1;
+				HDMI_PRINTF("[HDMI2.0] TMDS mode clock 40X\n");
+			} else {
+				bHDMI_6G_flag = 0;
+				HDMI_PRINTF("[HDMI2.0] TMDS mode clock 10X\n");
+			}
+		}
+	}
+
+	/* alwyas open hdmi2.0 setting */
+	hdmi_rx_reg_mask32(HDMI_2P0_CR, ~(HDMI_2P0_CR_hdmi_2p0_en_mask),
+		HDMI_2P0_CR_hdmi_2p0_en_mask, HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(SCR_CR, ~(SCR_CR_scr_auto_mask), SCR_CR_scr_auto_mask, HDMI_RX_MAC);
+	if ((bTMDSStatus&_BIT0) == _BIT0) {/* Scrambling */
+		/* For RGB bug */
+		hdmi_rx_reg_mask32(HDMI_SCR, ~(HDMI_SCR_dvi_reset_ds_cm_en_mask), 0, HDMI_RX_MAC);
+		/* Manual enable scrambling */
+		hdmi_rx_reg_mask32(SCR_CR, ~(SCR_CR_scr_en_fw_mask|SCR_CR_scr_auto_mask), SCR_CR_scr_en_fw_mask, HDMI_RX_MAC);
+		/* Manual switch to HDMI mode for fix 6G no sound */
+		hdmi_rx_reg_mask32(HDMI_SCR, ~(HDMI_SCR_mode_mask|HDMI_SCR_msmode_mask),
+			(HDMI_SCR_mode_mask|HDMI_SCR_msmode_mask), HDMI_RX_MAC);
+	} else {
+		hdmi_rx_reg_mask32(HDMI_SCR, ~(HDMI_SCR_dvi_reset_ds_cm_en_mask),
+			HDMI_SCR_dvi_reset_ds_cm_en_mask, HDMI_RX_MAC);
+		/* Manual disable scrambling */
+		hdmi_rx_reg_mask32(SCR_CR, ~(SCR_CR_scr_en_fw_mask|SCR_CR_scr_auto_mask), 0, HDMI_RX_MAC);
+		/* Turn off manual HDMI/DVI mode, auto detect */
+		hdmi_rx_reg_mask32(HDMI_SCR, ~(HDMI_SCR_mode_mask|HDMI_SCR_msmode_mask), 0, HDMI_RX_MAC);
+	}
+
+}
+
+void drvif_Hdmi2p0_Error_Count(void)
+{
+	u_int32_t tout = 5;
+	/* HW reset */
+	/* Clock reset */
+	hdmi_rx_reg_mask32(CERCR, ~(CERCR_ch_locked_reset_mask), CERCR_ch_locked_reset_mask, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(CERCR,
+		~(CERCR_valid_reset_mask | CERCR_reset_err_det_mask | CERCR_keep_err_det_mask | CERCR_refer_implem_mask | CERCR_reset_mask),
+		(CERCR_valid_reset_mask | CERCR_reset_err_det_mask | CERCR_keep_err_det_mask | CERCR_refer_implem_mask | CERCR_reset_mask), HDMI_RX_MAC);
+	/* Set period & mode */
+	hdmi_rx_reg_mask32(CERCR, ~(CERCR_period_mask | CERCR_mode_mask), CERCR_period_mask, HDMI_RX_MAC);
+	/* Release reset */
+	hdmi_rx_reg_mask32(CERCR, ~(CERCR_ch_locked_reset_mask), 0, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(CERCR, ~(CERCR_valid_reset_mask | CERCR_reset_err_det_mask | CERCR_keep_err_det_mask | CERCR_refer_implem_mask | CERCR_reset_mask),
+		0, HDMI_RX_MAC);
+	/* Set enable */
+	hdmi_rx_reg_mask32(CERCR, ~(CERCR_en_mask), CERCR_en_mask, HDMI_RX_MAC);
+
+	while (CERCR_get_en(hdmi_rx_reg_read32(CERCR, HDMI_RX_MAC)) && tout--)
+		HDMI_DELAYMS(50);
+
+	HDMI_PRINTF("[HDMI][BER] [video]   cnt0  bit_err_cnt=%d ,cnt1 bit_err_cnt=%d  ,cnt2 bit_err_cnt=%d\n",
+		CERSR0_get_err_cnt0_video(hdmi_rx_reg_read32(CERSR0, HDMI_RX_MAC)),
+		CERSR0_get_err_cnt1_video(hdmi_rx_reg_read32(CERSR0, HDMI_RX_MAC)),
+		CERSR1_get_err_cnt2_video(hdmi_rx_reg_read32(CERSR1, HDMI_RX_MAC)));
+	HDMI_PRINTF("[HDMI][BER] [packet]  cnt0  bit_err_cnt=%d ,cnt1 bit_err_cnt=%d  ,cnt2 bit_err_cnt=%d\n",
+		CERSR1_get_err_cnt0_pkt(hdmi_rx_reg_read32(CERSR1, HDMI_RX_MAC)),
+		CERSR2_get_err_cnt1_pkt(hdmi_rx_reg_read32(CERSR2, HDMI_RX_MAC)),
+		CERSR2_get_err_cnt2_pkt(hdmi_rx_reg_read32(CERSR2, HDMI_RX_MAC)));
+	HDMI_PRINTF("[HDMI][BER] [control]  cnt0  bit_err_cnt=%d ,cnt1 bit_err_cnt=%d  ,cnt2 bit_err_cnt=%d\n",
+		CERSR3_get_err_cnt0_ctr(hdmi_rx_reg_read32(CERSR3, HDMI_RX_MAC)),
+		CERSR3_get_err_cnt1_ctr(hdmi_rx_reg_read32(CERSR3, HDMI_RX_MAC)),
+		CERSR4_get_err_cnt2_ctr(hdmi_rx_reg_read32(CERSR4, HDMI_RX_MAC)));
+}
+
+void TMDS_6G_Recovery(void)
+{
+	/* IF SCDC not right , toggle 6G flag setting */
+	if (hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC) & HDMI_6G_TEST) {
+		HDMI_PRINTF("[HDMI2.0] CTS mode\n");
+	} else {
+		if ((drvif_Hdmi2p0_Scdc_Read(SCDC_TMDS_Config)&_BIT1) != _BIT1) {
+			b6G_detect_cnt++;
+			if (b6G_detect_cnt > 2) {
+				/* detect 6 G or not */
+				bHDMI_6G_flag?(bHDMI_6G_flag = 0):(bHDMI_6G_flag = 1);
+				b6G_detect_cnt = 0;
+			}
+		}
+	}
+}
+
+void HDMI_YUV420_Setting(void)
+{
+	bHDMI_420_Space = HDMI_VCR_get_csc_r(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+	if (bHDMI_420_Space == COLOR_YUV420) {
+		hdmi_rx_reg_mask32(YUV420_CR, ~YUV420_CR_en_mask, YUV420_CR_en_mask, HDMI_RX_MAC);
+		HDMIRX_INFO("HDMI420 mode");
+	}
+	HDMI_PRINTF("[HDMI2.0] color space  mode =%d\n",
+		HDMI_VCR_get_csc_r(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC)));
+
+	if ((IsHDMI() == MODE_DVI) || (bHDMI_420_Space != COLOR_YUV420))
+		hdmi_rx_reg_mask32(YUV420_CR, ~YUV420_CR_en_mask, 0, HDMI_RX_MAC);
+
+}
+#endif/* end of #if HDMI2p0 */
+
+
+unsigned char drvif_Hdmi_GetColorDepth(void)
+{
+	if (GET_HDMI_CD() >= 4)
+		return (GET_HDMI_CD()-4);
+	else
+		return 0;
+}
+
+unsigned char drvif_Hdmi_VSIF_VIC(void)
+{
+	unsigned char reg_val;
+
+	hdmi_rx_reg_write32(HDMI_PSAP, VSIF_PB4, HDMI_RX_MAC);
+	reg_val = hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC);
+
+	if ((reg_val>>5) == 1) {
+		/* HDMI_Video_Format==1 */
+		hdmi_rx_reg_write32(HDMI_PSAP, VSIF_PB5, HDMI_RX_MAC);
+		reg_val = hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC);
+		HDMIRX_DEBUG("Extended_VIC=%u", reg_val);
+		/* hdmi_vic_table 108~111 */
+		switch (reg_val) {
+		case 1:
+			reg_val = 108;
+			break;
+		case 2:
+			reg_val = 109;
+			break;
+		case 3:
+			reg_val = 110;
+			break;
+		case 4:
+			reg_val = 111;
+			break;
+		default:
+			reg_val = 0;
+			break;
+		}
+
+		return reg_val;
+	}
+
+	return 0;
+}
+
+unsigned char drvif_Hdmi_AVI_VIC(void)
+{
+	unsigned char vic;
+
+	hdmi_rx_reg_write32(HDMI_PSAP, AVI_Data_BYTE4, HDMI_RX_MAC);
+
+	vic = (hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC)) & 0x7F;
+
+	if (vic == 0)/* Get extened VIC */
+		vic = drvif_Hdmi_VSIF_VIC();
+	else if (vic > 107)
+		vic = 0;
+
+	return vic;
+}
+
+unsigned char drvif_Hdmi_AVI_RGB_Range(void)
+{
+	unsigned char Temp, RGB_Temp, YUV_Temp;
+
+	/* Looking for ACR info using RSV2 */
+	HDMI_PRINTF("drvif_Hdmi_AVI_RGB_Range\n");
+	/* Read AVI infor REG direct */
+	hdmi_rx_reg_write32(HDMI_PSAP, AVI_Data_BYTE1, HDMI_RX_MAC);
+
+	Temp =	(hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC) & AVI_Y1Y0_mask)>>5;
+
+	if (Temp == 0) {
+		/* Read AVI infor Data Byte 3 */
+		hdmi_rx_reg_write32(HDMI_PSAP, AVI_Data_BYTE3, HDMI_RX_MAC);
+		RGB_Temp = (hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC) & AVI_Q_Range_mask)>>2;
+		switch (RGB_Temp) {
+		case RGB_Default:
+			SET_HDMI_RGB_Q_RANGE(RGB_Default);
+			HDMI_PRINTF("drvif_Hdmi_AVI_RGB_Range test0  = %d\n", GET_HDMI_RGB_Q_RANGE());
+			break;
+		case RGB_Limite_Range:
+			SET_HDMI_RGB_Q_RANGE(RGB_Limite_Range);
+			HDMI_PRINTF("drvif_Hdmi_AVI_RGB_Range test1 = %d\n", GET_HDMI_RGB_Q_RANGE());
+			break;
+		case RGB_Full_Range:
+			SET_HDMI_RGB_Q_RANGE(RGB_Full_Range);
+			HDMI_PRINTF("drvif_Hdmi_AVI_RGB_Range test2  = %d\n", GET_HDMI_RGB_Q_RANGE());
+			break;
+		default:
+			break;
+		}
+		HDMI_PRINTF("drvif_Hdmi_AVI_RGB_Range = %d\n", RGB_Temp);
+	} else if ((Temp == 0x01) || (Temp == 0x02)) {
+		/* Read AVI infor Data Byte 3 */
+		hdmi_rx_reg_write32(HDMI_PSAP, AVI_Data_BYTE5, HDMI_RX_MAC);
+		YUV_Temp = (hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC) & AVI_YQ1YQ0_mask)>>6;
+		switch (YUV_Temp) {
+		case YUV_Limite_Range:
+			SET_HDMI_RGB_Q_RANGE(RGB_Limite_Range);
+			HDMI_PRINTF("drvif_Hdmi_AVI_YUV_Range test1 = %d\n", GET_HDMI_RGB_Q_RANGE());
+			break;
+		case YUV_Full_Range:
+			SET_HDMI_RGB_Q_RANGE(RGB_Full_Range);
+			HDMI_PRINTF("drvif_Hdmi_AVI_YUV_Range test2  = %d\n", GET_HDMI_RGB_Q_RANGE());
+			break;
+		default:
+			break;
+		}
+		HDMI_PRINTF("drvif_Hdmi_AVI_YUV_Range = %d\n", YUV_Temp);
+	}
+
+	return Temp;
+}
+
+
+HDMI_bool drvif_Hdmi_DetectMode(void)
+{
+	unsigned char result = _MODE_DETECT;
+	HDMIRX_IOCTL_STRUCT_T isr_info;
+	unsigned char yuv_fmt;
+	unsigned int retry_times = 0;
+
+retry:
+	if (Hdmi_CheckConditionChange() != HDMI_ERR_NO) {
+		SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+	}
+
+	switch (GET_HDMI_VIDEO_FSM()) {
+	case MAIN_FSM_HDMI_SETUP_VEDIO_PLL:
+		/* HDMI_PRINTF("MAIN_FSM_HDMI_SETUP_VEDIO_PLL\n"); */
+		HDMI_Audio_Conut = 0;
+
+		/* Clear Audio Watch Dog and Set X: 15 */
+		hdmi_rx_reg_mask32(HDMI_WDCR0, ~0xFFDF9E, 0x00, HDMI_RX_MAC);
+		/* Not inverse EVEN/ODD */
+		hdmi_rx_reg_mask32(HDMI_VCR, (~_BIT7), 0, HDMI_RX_MAC);
+
+		/* Enable auto detection of colorspace and pixel repeat */
+		hdmi_rx_reg_mask32(HDMI_VCR, ~(HDMI_VCR_csam_mask | HDMI_VCR_prdsam_mask),
+			HDMI_VCR_csam(1)|HDMI_VCR_prdsam(1), HDMI_RX_MAC);
+
+		hdmi_rx_reg_mask32(MHL_DEMUX_CTRL, ~MHL_DEMUX_CTRL_dvi_ch_sync_mask, 0, HDMI_RX_MHL);
+		/* Clear status, prepare to check interlace/progressive */
+		hdmi_rx_reg_mask32(HDMI_VCR, ~(HDMI_VCR_se_mask | HDMI_VCR_eot_mask | HDMI_VCR_int_pro_chg_flag_mask),
+			HDMI_VCR_eot_mask, HDMI_RX_MAC);
+
+		memset(&hdmi.gen_timing, 0, sizeof(hdmi.gen_timing));
+
+		/* Get TMDS b value for ISR/high priority task */
+		HdmiGetStruct(&isr_info);
+		hdmi.b = isr_info.b;
+
+		if (hdmi.b < 116)
+			return _MODE_NOSIGNAL;
+
+#if HDMI2p0
+		drvif_Hdmi2p0_DetectMode();
+#endif
+		/* Measure interlace/progressive */
+		hdmi.tx_timing.progressive = (Hdmi_GetInterlace(HDMI_MS_MODE_ONESHOT) == 0);
+		SET_HDMI_ISINTERLACE((hdmi.tx_timing.progressive == 0));
+		/* Measure color depth */
+		SET_HDMI_CD(hdmi_rx_reg_read32(TMDS_DPC0, HDMI_RX_MAC) & (0x0f));
+		/* tx_timing */
+		hdmi.tx_timing.depth = (HDMI_COLOR_DEPTH_T) drvif_Hdmi_GetColorDepth();
+
+#if HDMI2p0
+		HDMI_YUV420_Setting();
+
+		/* Setup Video PLL */
+		if (bHDMI_420_Space == COLOR_YUV420) {
+			if (!Hdmi_VideoPLLSetting(hdmi.b, (int)hdmi.tx_timing.depth, 1))
+				return _MODE_NOSIGNAL;
+		} else
+#endif
+		if ((hdmi.tx_timing.progressive) == 0) {
+			if (!Hdmi_VideoPLLSetting(hdmi.b, (int)hdmi.tx_timing.depth, 1))
+				return _MODE_NOSIGNAL;
+		} else {
+			if (!Hdmi_VideoPLLSetting(hdmi.b, (int)hdmi.tx_timing.depth, 0))
+				return _MODE_NOSIGNAL;
+		}
+
+		SET_ISHDMI(IsHDMI());
+
+		if ((GET_ISHDMI() == MODE_DVI)) {
+			/* Disable Auto color space detect,Auto pixel reapeat down sample */
+			HDMI_PRINTF("DVI mode setting\n");
+			hdmi_rx_reg_mask32(HDMI_VCR, ~(HDMI_VCR_csam_mask | HDMI_VCR_prdsam_mask | HDMI_VCR_dsc_mask),
+				HDMI_VCR_csam(0) | HDMI_VCR_prdsam(0) | HDMI_VCR_dsc(0), HDMI_RX_MAC);
+			/* Set down sampling  =1 can't set if no this delay */
+			HDMI_DELAYMS(20);
+			/* Set down sampling = 1 */
+			hdmi_rx_reg_mask32(HDMI_VCR, ~(HDMI_VCR_csam_mask | HDMI_VCR_prdsam_mask | HDMI_VCR_dsc_mask | HDMI_VCR_csc_mask),
+				HDMI_VCR_csam(0) | HDMI_VCR_prdsam(0) | HDMI_VCR_dsc(0) | HDMI_VCR_csc(0), HDMI_RX_MAC);
+		}
+
+		Hdmi_Get3DInfo(HDMI_MS_MODE_ONESHOT_INIT);
+		SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_MEASURE);
+		/* goto retry; */
+		/* break; */
+	case MAIN_FSM_HDMI_MEASURE:
+		HDMI_PRINTF("MAIN_FSM_HDMI_MEASURE\n");
+
+		Hdmi_VideoOutputEnable();
+		if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC)&HDMI_SR_avmute_mask) {
+			HDMI_PRINTF("AV Mute\n");
+			HdmiSetAPStatus(HDMIRX_DETECT_AVMUTE);
+		} else {
+			HdmiSetAPStatus(HDMIRX_DETECT_FAIL);
+		}
+
+		if (GET_ISHDMI() == MODE_HDMI)
+			SET_HDMI_COLOR_SPACE(Hdmi_GetColorSpace());
+		else
+			SET_HDMI_COLOR_SPACE(COLOR_RGB);/* Determine Color Space */
+
+
+		if (GET_HDMI_ISINTERLACE() != Hdmi_GetInterlace(HDMI_MS_MODE_ONESHOT)) {
+			HDMI_PRINTF("interlace change in measure mode\n");
+			/* Reset Check mode state to initial */
+			SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+			return _MODE_DETECT;
+		}
+
+#if HDMI2p0
+		if (bHDMI_420_Space != HDMI_VCR_get_csc_r(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC))) {
+			HDMI_PRINTF("color space change in measure mode\n");
+			/* Reset Check mode state to initial */
+			SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+			return _MODE_DETECT;
+		}
+#endif
+		result = Hdmi_Measure();
+		if (result != _MODE_SUCCESS) {
+			/* Reset Check mode state to initial */
+			SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+			HDMI_Bit_Err_One_Time_Detect(100, 20);
+			if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & _BIT6)
+				return _MODE_DETECT;
+
+			return result;
+		}
+
+		if (GET_HDMI_ISINTERLACE() != Hdmi_GetInterlace(HDMI_MS_MODE_ONESHOT)) {
+			HDMI_PRINTF("interlace change in measure mode\n");
+			/* Reset Check mode state to initial */
+			SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+			return _MODE_DETECT;
+		}
+
+		HdmiSetAPStatus(HDMIRX_DETECT_SUCCESS);
+
+		hdmi.tx_timing.hdmi_3dformat = Hdmi_Get3DInfo(HDMI_MS_MODE_ONESHOT_GET_RESULT);
+		SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_DISPLAY_ON);
+
+		/* Prevent stuck in this function */
+		if (retry_times < 3) {
+			retry_times++;
+			goto retry;
+		}
+
+		break;
+
+	case MAIN_FSM_HDMI_DISPLAY_ON:
+		HDMI_PRINTF("MAIN_FSM_HDMI_DISPLAY_ON\n");
+		if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & HDMI_SR_avmute_mask) != 0) {
+			HDMI_PRINTF("#################### AV mute ####################\n");
+			/* Clear AV mute flag */
+			hdmi_rx_reg_mask32(HDMI_AVMCR, ~(HDMI_AVMCR_avmute_flag_mask), HDMI_AVMCR_avmute_flag_mask, HDMI_RX_MAC);
+			hdmi_rx_reg_mask32(HDMI_AVMCR, ~(HDMI_AVMCR_avmute_flag_mask), 0, HDMI_RX_MAC);
+			/* Reset Check mode state to initial */
+			SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+			return _MODE_DETECT;
+		}
+		/* Determine DVI/HDMI mode */
+		if (GET_ISHDMI() == MODE_HDMI) {
+			/* Determine Color Space */
+			SET_HDMI_COLOR_SPACE(Hdmi_GetColorSpace());
+		} else {
+			/* Determine Color Space */
+			SET_HDMI_COLOR_SPACE(COLOR_RGB);
+			HDMIRX_INFO("DVI mode");
+		}
+
+		if (GET_HDMI_ISINTERLACE() != Hdmi_GetInterlace(HDMI_MS_MODE_ONESHOT)) {
+			HDMI_PRINTF("interlace change in measure mode\n");
+			/* Reset Check mode state to initial */
+			SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+			return _MODE_DETECT;
+		}
+		/* To gather detail information from TX */
+		hdmi.tx_timing.colorimetry = Hdmi_GetColorimetry();
+		hdmi.tx_timing.color = GET_HDMI_COLOR_SPACE();
+		hdmi.tx_timing.depth = (HDMI_COLOR_DEPTH_T) drvif_Hdmi_GetColorDepth();
+		HDMIRX_INFO("FSM_HDMI_DISPLAY_ON colorimetry(%u) color(%u) progressive(%u) depth(%u)",
+			hdmi.tx_timing.colorimetry, hdmi.tx_timing.color,
+			hdmi.tx_timing.progressive, hdmi.tx_timing.depth);
+
+		Hdmi_Get3DGenTiming(&hdmi.tx_timing, &hdmi.gen_timing);
+
+		Hdmi_DumpState();
+
+		if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & HDMI_SR_avmute_mask) {
+			HDMI_PRINTF("#################### AV mute ####################\n");
+			/* Clear AV mute flag */
+			hdmi_rx_reg_mask32(HDMI_AVMCR, ~(HDMI_AVMCR_avmute_flag_mask), HDMI_AVMCR_avmute_flag_mask, HDMI_RX_MAC);
+			hdmi_rx_reg_mask32(HDMI_AVMCR, ~(HDMI_AVMCR_avmute_flag_mask), 0, HDMI_RX_MAC);
+			/* Reset Check mode state to initial */
+			SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+			return _MODE_DETECT;
+		}
+		/* Clear status flag */
+		hdmi_rx_reg_write32(HDMI_SR, hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC), HDMI_RX_MAC);
+
+#if 1/* HDMI_FIX_GREEN_LINE */
+		hdmi_rx_reg_mask32(TMDS_OUT_CTRL, ~(TMDS_OUT_CTRL_tmds_bypass_mask),
+			TMDS_OUT_CTRL_tmds_bypass(1), HDMI_RX_MAC);
+		hdmi_rx_reg_write32(TMDS_ROUT, 0, HDMI_RX_MAC);
+		hdmi_rx_reg_write32(TMDS_GOUT, 0, HDMI_RX_MAC);
+		hdmi_rx_reg_write32(TMDS_BOUT, 0, HDMI_RX_MAC);
+		if (GET_HDMI_COLOR_SPACE() != COLOR_RGB) {
+			hdmi_rx_reg_mask32(TMDS_OUT_CTRL, ~(TMDS_OUT_CTRL_tmds_bypass_mask),
+				TMDS_OUT_CTRL_tmds_bypass(0), HDMI_RX_MAC);
+			hdmi_rx_reg_write32(TMDS_ROUT, 0x8000, HDMI_RX_MAC);
+			hdmi_rx_reg_write32(TMDS_GOUT, 0x1000, HDMI_RX_MAC);
+			hdmi_rx_reg_write32(TMDS_BOUT, 0x8000, HDMI_RX_MAC);
+		}
+#endif
+
+		SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_WAIT_READY);
+
+		SET_IS_FIRST_CHECK_MODE(1);
+
+		/* drvif_Hdmi_AVI_RGB_Range(); */
+
+		/* Enable rx wrapper detect */
+		yuv_fmt = hdmirx_wrapper_convert_color_fmt(hdmi.tx_timing.color);
+		set_hdmirx_wrapper_control_0(-1, -1, -1, -1, yuv_fmt, -1);
+		hdmi_ioctl_struct.detect_done = 1;
+		set_hdmirx_wrapper_interrupt_en(0, 0, 1);
+		return _MODE_SUCCESS;
+		/* break; */
+	case MAIN_FSM_HDMI_MEASURE_ACTIVE_SPACE:
+		break;
+	case MAIN_FSM_HDMI_WAIT_READY:
+		hdmi.tx_timing.color = Hdmi_GetColorSpace();
+		if (hdmi.tx_timing.color != GET_HDMI_COLOR_SPACE()) {
+			SET_HDMI_COLOR_SPACE(hdmi.tx_timing.color);
+			HDMI_PRINTF("Color Space Change = %d\n", hdmi.tx_timing.color);
+		}
+
+		if (hdmi.resume) {
+			SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_MEASURE);
+			return _MODE_DETECT;
+		}
+
+		if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & _BIT6)
+			return _MODE_DETECT;
+
+		return _MODE_SUCCESS;
+
+		break;
+
+	default:
+		/* Reset Check mode state to initial */
+		SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+		break;
+	}
+
+	return result;
+}
+
+HDMI_bool drvif_Hdmi_CheckMode(void)
+{
+	HDMIRX_IOCTL_STRUCT_T isr_info;
+
+	HdmiSetAPStatus(HDMIRX_CHECK_MODE);
+
+#if HDMI_INTERNAL_DEBUG
+	Hdmi_CRC_check();
+#endif
+
+	if (GET_ISHDMI() == MODE_HDMI) {/* HDMI mode */
+		/* Check Vedio Format change */
+		if (Hdmi_GetColorSpace() != GET_HDMI_COLOR_SPACE()) {
+			HDMI_PRINTF("Color Space Change\n");
+			SET_HDMI_COLOR_SPACE(Hdmi_GetColorSpace());
+			return FALSE;
+		};
+
+		Hdmi_AudioModeDetect();
+
+		if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & _BIT6) {
+			Hdmi_VideoOutputDisable();
+			Hdmi_AudioOutputDisable();
+			HDMI_PRINTF("AVMute ON----> Force re-detect signal\n");
+			SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+			SET_IS_FIRST_DETECT_MODE(1);
+			return FALSE;
+		}
+	}
+#if 1// TODO: Remove?
+	if (GET_HDMI_ISINTERLACE() != Hdmi_GetInterlace(HDMI_MS_MODE_ONESHOT)) {
+		Hdmi_VideoOutputDisable();
+		Hdmi_AudioOutputDisable();
+		HDMI_PRINTF("IsInterlaced change\n");
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		SET_IS_FIRST_DETECT_MODE(1);
+		return FALSE;
+	}
+#endif
+	if (GET_ISHDMI() != IsHDMI()) {
+		Hdmi_VideoOutputDisable();
+		Hdmi_AudioOutputDisable();
+		HDMI_PRINTF("bIsHDMIDVI change\n");
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		SET_IS_FIRST_DETECT_MODE(1);
+		return FALSE;
+	}
+
+	if ((unsigned int)GET_HDMI_CD() != (hdmi_rx_reg_read32(TMDS_DPC0, HDMI_RX_MAC) & 0xf)) {
+		Hdmi_VideoOutputDisable();
+		Hdmi_AudioOutputDisable();
+		HDMI_PRINTF("bIsHDMIDVI change\n");
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		SET_IS_FIRST_DETECT_MODE(1);
+		return FALSE;
+	}
+
+	HdmiGetStruct(&isr_info);
+	if (ABS(hdmi.b, isr_info.b) > 4) {
+		Hdmi_VideoOutputDisable();
+		Hdmi_AudioOutputDisable();
+		HDMI_PRINTF("isr_info.b change\n");
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		SET_IS_FIRST_DETECT_MODE(1);
+		return FALSE;
+	};
+
+	if (isr_info.b_change) {
+		Hdmi_VideoOutputDisable();
+		Hdmi_AudioOutputDisable();
+		HDMI_PRINTF("b change = %d\n", isr_info.b);
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		SET_IS_FIRST_DETECT_MODE(1);
+		return FALSE;
+	}
+
+	if (hdmi.resume) {
+		hdmi.resume = 0;
+		HDMI_PRINTF("hdmi user resume\n");
+		Hdmi_VideoOutputDisable();
+		Hdmi_AudioOutputDisable();
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		SET_IS_FIRST_DETECT_MODE(1);
+		return FALSE;
+	}
+	return TRUE;
+}
+
+
+void drvif_Hdmi_InitSrc(unsigned char channel)
+{
+	HDMIRX_INFO("[%s] ", __func__);
+
+	/* Set channel before hdmi_power() */
+	SET_HDMI_CHANNEL(channel);
+
+	hdmi_phy_port_select(HDMI_CHANNEL0, 1);
+
+	/* DMI power on , exit power saving mode */
+	Hdmi_Power(1);
+
+	Hdmi_TmdsInit();
+
+	Hdmi_MacInit();
+
+	/* Setup Audio PLL */
+	Hdmi_AudioOutputDisable();
+
+	/* Reset hdmi struct */
+	SET_HDMI_BOOT_FIRST_RUN(0);
+	SET_IS_FIRST_DETECT_MODE(1);
+	SET_HDMI_COLOR_SPACE(COLOR_RGB);
+	SET_HDMI_ISINTERLACE(0);
+	SET_ISHDMI(MODE_DVI);
+	SET_HDMI_CD(0);
+	SET_HDMI_CHANNEL(HDMI_CHANNEL0);
+
+	/* Reset FSM */
+	SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+	SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+
+	hdmi.b = 0;
+	hdmi.tx_timing.hdmi_3dformat = HDMI3D_2D_ONLY;
+	hdmi.vsync_cnt = 0;
+
+}
+
+
+void drvif_Hdmi_Release(void)
+{
+	HDMIRX_DEBUG("[%s] ", __func__);
+
+	SET_IS_FIRST_DETECT_MODE(1);
+	HdmiSetAPStatus(HDMIRX_RELEASED);
+
+	Hdmi_AudioOutputDisable();
+	Hdmi_VideoOutputDisable();
+
+	Hdmi_Power(0);
+
+#if HDMI2p0
+	hdmi_rx_reg_mask32(SCDC_CR, (~SCDC_CR_scdc_reset_mask), SCDC_CR_scdc_reset_mask, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(SCDC_CR, (~SCDC_CR_scdc_reset_mask), 0, HDMI_RX_MAC);
+#endif
+
+}
+
+
+void drvif_Hdmi_Init(void)
+{
+	HDMIRX_INFO("[%s] ", __func__);
+
+	hdmi.hw_dither12x10_enable = 0;
+	hdmi.hw_hdmi_dma = HDMI_3D_OPMODE_HW;
+
+	hdmi.fast_boot_source = -1;
+	hdmi.force_all_3d_disable = 1;
+	hdmi.force_3dto2d_enable = 0;
+	hdmi.force_2dto3d_enable = 0;
+	hdmi.force_2dto3d_mode = HDMI3D_2D_ONLY;
+	hdmi.hdmi3d_capability = 0;
+	hdmi.enable_3ddma = 1;
+
+	hdmi.path_policy = HDMI_PATH_POLICY_2D_ONLY;
+
+	Hdmi_PhyInit();
+	Hdmi_HdcpInit();
+}
+
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiInternal.h b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiInternal.h
new file mode 100644
index 00000000..cbde802
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiInternal.h
@@ -0,0 +1,604 @@
+/*
+ * hdmiInternal.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDMI_INTERNAL_H_
+#define __HDMI_INTERNAL_H_
+
+#include <linux/delay.h>
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmirx_reg.h"
+#include "hdcp2p2_dev.h"
+
+#define HDMI_INTERNAL_DEBUG 0
+
+#if HDMI_INTERNAL_DEBUG
+#define HDMI_PRINTF(format, ...)	pr_info("[HDMI RX DBG]" format, ## __VA_ARGS__)
+#else
+#define HDMI_PRINTF(format, ...)	do {} while(0)
+#endif
+
+#ifndef UINT8
+	typedef int INT32;
+	typedef unsigned int UINT32;
+	typedef unsigned short	UINT16;
+	typedef char	UINT8;
+#endif
+
+#ifndef TRUE
+#define TRUE true
+#define FALSE false
+#endif
+
+#ifndef ABS
+#define ABS(x, y)				((x > y) ? (x-y) : (y-x))
+#endif
+
+#define _AUDIO_128_TIMES		1
+#define _AUDIO_256_TIMES		2
+
+#define HDMI_AUDIO_PCM	0
+#define HDMI_AUDIO_NPCM	1
+
+typedef  unsigned char HDMI_bool;
+
+typedef enum {
+	HDMI_ERR_NO = 0,
+	HDMI_EER_GENERIC,
+	HDMI_ERR_ONMS_ONESHOT,
+	HDMI_ERR_ONMS_CONTINUOUS_INIT,
+	HDMI_ERR_ONMS_CONTINUOUS_CHECK,
+	HDMI_ERR_ONMS_WRONG_TIMING,
+	HDMI_ERR_ONMS_WRONG_PARAM,
+	HDMI_ERR_3D_WRONG_OPMODE,
+	HDMI_ERR_3D_NO_MEM,
+	HDMI_ERR_4XXTO4XX_WRONG_PARAM,
+	HDMI_EER_MEASURE_ACTIVESPACE_FAIL,
+	HDMI_EER_VODMA_NOT_READY,
+} HDMI_ERR_T;
+
+#define HDMI2p0	 1 /* HDMI2.0 */
+#define HDMI_REPEATER_SUPPORT  1
+
+#define HDMI_PHY_IDLE_PATCH_ENABLE	1
+#define HDMI_PHY_IDLE_PATCH_COUNT 15
+
+/* hdmi_z0_set */
+#define LN_Z300POW	0x10
+#define LN_CK	0x08
+#define LN_B	0x04
+#define LN_G	0x02
+#define LN_R	0x01
+#define LN_ALL (LN_Z300POW|LN_CK|LN_B|LN_G|LN_R)
+
+#define HDMI_ABS(x, y)		((x > y) ? (x-y) : (y-x))
+
+#define HDMI_DELAYUS(x)    do{ udelay(x); }while(0)
+#define HDMI_DELAYMS(x)    do{ if(in_atomic()) mdelay(x); else msleep(x); }while(0)
+
+#define HDMI_CONST		const
+
+enum _MODE_RESULT {
+	_MODE_NOSIGNAL	= 0xFF,
+	_MODE_NOSUPPORT = 0xFE,
+	_MODE_NOCABLE	= 0xFD,
+	_MODE_SUCCESS	= 0xFC,
+	_MODE_DETECT	= 0xFB,
+	_MDOE_UNDKOWN	= 0xFA,
+};
+#define MEASURE_FAIL  _MODE_DETECT
+
+typedef enum {
+	MODE_DVI = 0x0,
+	MODE_HDMI,
+	MODE_UNKNOW
+} HDMI_DVI_MODE_T;
+
+typedef enum _HDMI_CHANNEL_TYPE{
+	HDMI_CHANNEL0 = 0,
+} HDMI_CHANNEL_TYPE;
+
+typedef enum {
+	HDMI_MS_MODE_ONESHOT = 0,
+	HDMI_MS_MODE_CONTINUOUS_INIT,
+	HDMI_MS_MODE_CONTINUOUS_CHECK,
+	HDMI_MS_MODE_ONESHOT_INIT,
+	HDMI_MS_MODE_ONESHOT_GET_RESULT,
+	HDMI_MS_MODE_ONESHOT_POLARITY_FIXED,
+} HDMI_MS_MODE_T;
+
+typedef enum {
+	MAIN_FSM_HDMI_SETUP_VEDIO_PLL = 0,
+	MAIN_FSM_HDMI_MEASURE,
+	MAIN_FSM_HDMI_MEASURE_ACTIVE_SPACE,
+	MAIN_FSM_HDMI_WAIT_READY,
+	MAIN_FSM_HDMI_DISPLAY_ON,
+} HDMI_MAIN_FSM_T;
+
+typedef enum {
+	AUDIO_FSM_AUDIO_START = 0,
+	AUDIO_FSM_FREQ_DETECT,
+	AUDIO_FSM_AUDIO_WAIT_TO_START,
+	AUDIO_FSM_AUDIO_START_OUT,
+	AUDIO_FSM_AUDIO_WAIT_PLL_READY,
+	AUDIO_FSM_AUDIO_CHECK
+} HDMI_AUDIO_FSM_T;
+
+typedef enum {
+	AUDIO_FORMAT_LPCM = 0,
+	AUDIO_FORMAT_NONLPCM
+} HDMI_AUDIO_FORMAT_T;
+
+typedef enum {
+	HDMI_AUDIO_N_CTS_TREND_BOUND = 0,
+	HDMI_AUDIO_TREND_BOUND,
+	HDMI_AUDIO_N_CTS,
+} HDMI_AUDIO_TRACK_MODE;
+
+typedef enum {
+	HDMIRX_DETECT_FAIL = 0,
+	HDMIRX_DETECT_SUCCESS,
+	HDMIRX_DETECT_AVMUTE,
+	HDMIRX_CHECK_MODE,
+	HDMIRX_RELEASED,
+} HDMIRX_APSTATUS_T;
+
+typedef enum {
+	IOCTRL_HDMI_PHY_START = 0,
+	IOCTRL_HDMI_PHY_STOP,
+	IOCTRL_HDMI_GET_STRUCT,
+	IOCTRL_HDMI_SET_TIMER,
+	IOCTRL_HDMI_GET_TIMER,
+	IOCTRL_HDMI_AUDIO_PLL_SAMPLE_START,
+	IOCTRL_HDMI_AUDIO_PLL_SAMPLE_STOP,
+	IOCTRL_HDMI_AUDIO_PLL_SAMPLE_DUMP,
+	IOCTRL_HDMI_SET_APSTATUS
+}  HDMIRX_IOCTL_T;
+
+typedef enum {
+	MODE_RAG_DEFAULT	= 0x0,
+	MODE_RAG_LIMIT,
+	MODE_RAG_FULL,
+	MODE_RAG_UNKNOW
+} HDMI_RGB_YUV_RANGE_MODE_T;
+
+typedef enum {
+	HDMI_COLORIMETRY_NOSPECIFIED = 0,
+	HDMI_COLORIMETRY_601,
+	HDMI_COLORIMETRY_709,
+	HDMI_COLORIMETRY_XYYCC601,
+	HDMI_COLORIMETRY_XYYCC709,
+	HDMI_COLORIMETRY_SYCC601,
+	HDMI_COLORIMETRY_ADOBE_YCC601,
+	HDMI_COLORIMETRY_ADOBE_RGB,
+} HDMI_COLORIMETRY_T;
+
+typedef enum {
+	COLOR_RGB = 0x00,
+	COLOR_YUV422,
+	COLOR_YUV444,
+	COLOR_YUV420,
+	COLOR_UNKNOW
+} HDMI_COLOR_SPACE_T;
+
+typedef enum {
+	HDMI_COLOR_DEPTH_8B = 0,
+	HDMI_COLOR_DEPTH_10B,
+	HDMI_COLOR_DEPTH_12B,
+	HDMI_COLOR_DEPTH_16B,
+} HDMI_COLOR_DEPTH_T;
+
+typedef enum {
+	HDMI_3D_OPMODE_DISABLE = 0,
+	HDMI_3D_OPMODE_HW,
+	HDMI_3D_OPMODE_HW_2DONLY_L,
+	HDMI_3D_OPMODE_HW_2DONLY_R,
+	HDMI_3D_OPMODE_SW,
+	HDMI_3D_OPMODE_HW_NODMA
+} HDMI_3D_OPMODE_T;
+
+typedef enum {
+	HDMI_PTG_MODE_BACKGROUD_ONLY,
+	HDMI_PTG_MODE_H_COLOR_BAR,
+	HDMI_PTG_MODE_V_COLOR_BAR,
+	HDMI_PTG_MODE_H_GREDIENT,
+	HDMI_PTG_MODE_V_GREDIENT,
+	HDMI_PTG_MODE_HV_GREDIENT,
+	HDMI_PTG_MODE_BITMAP,
+	HDMI_PTG_CROSS_COLOR_SEQ0,
+	HDMI_PTG_CROSS_COLOR_SEQ1,
+	HDMI_PTG_CROSS_COLOR_SEQ2,
+	HDMI_PTG_CROSS_COLOR_SEQ3,
+} HDMI_PTG_MODE_T;
+
+typedef enum {
+	HDMI_PATH_POLICY_2D_ONLY = 0,
+	HDMI_PATH_POLICY_3D_NODMA,
+	HDMI_PATH_POLICY_3D_DMA
+} HDMI_PATH_POLICY_T;
+
+typedef enum {
+	HDMI3D_FRAME_PACKING = 0,
+	HDMI3D_FIELD_ALTERNATIVE = 1,
+	HDMI3D_LINE_ALTERNATIVE = 2,
+	HDMI3D_SIDE_BY_SIDE_FULL = 3,
+	HDMI3D_L_DEPTH = 4,
+	HDMI3D_L_DEPTH_GPX = 5,
+	HDMI3D_TOP_AND_BOTTOM = 6,
+	HDMI3D_FRAMESEQUENCE = 7,
+	HDMI3D_SIDE_BY_SIDE_HALF = 8,
+	/* --- new 3D format --- */
+	HDMI3D_LINE_BY_LINE = 9,
+	HDMI3D_VERTICAL_STRIPE = 10,
+	HDMI3D_CHECKER_BOARD = 11,
+	HDMI3D_REALID = 12,
+	HDMI3D_SENSIO = 13,
+	/* ------------------- */
+	HDMI3D_RSV1,
+	HDMI3D_2D_ONLY,
+	HDMI3D_UNKOWN = 0xFFFFFFFF
+} HDMI_3D_T;
+
+typedef enum {
+	HDCPRX_STATE_NONE = 0,
+	HDCPRX_STATE_1PX_DISCOVER = 1,
+	HDCPRX_STATE_1PX_ON = 2,
+	HDCPRX_STATE_2P2_DISCOVER = 3,
+	HDCPRX_STATE_2P2_ON = 4
+} HDCPRX_STATE;
+
+typedef struct	{
+	char *name;
+	int progressive;
+	unsigned int h_act_len;
+	unsigned int v_act_len;
+	unsigned int lr_v_act_len;
+	unsigned int v_active_space1;
+	unsigned int v_active_space2;
+} HDMI_ACTIVE_SPACE_TABLE_T;
+
+typedef struct {
+	unsigned char SM;
+	unsigned char SN;
+	unsigned char RatioM;
+	unsigned char RatioN;
+} VIDEO_DPLL_RATIO_T;
+
+typedef struct {
+	int freq;
+	unsigned char coeff;
+	unsigned char rate;
+} HDMI_AUDIO_PLL_COEFF_T;
+
+typedef struct {
+	unsigned char N;
+	unsigned char M;
+	unsigned char O;
+	unsigned char S;
+	unsigned char S1;
+	unsigned int D_HighByte;
+	unsigned int D_LowByte;
+	const char *sample_rate;
+} HDMI_AUDIO_PLL_PARAM_T;
+
+/**
+ * HDMI_AUDIO_FREQ_T
+ * @ACR_freq: Audio Frequency from ACR
+ * @AudioInfo_freq: Audio Frequency from Audio Info Frame
+ * @SPDIF_freq: Audio Frequency from SPDIF Channel Status Info
+ */
+typedef struct {
+	unsigned long ACR_freq;
+	unsigned long AudioInfo_freq;
+	unsigned long SPDIF_freq;
+} HDMI_AUDIO_FREQ_T;
+
+typedef struct {
+	u_int16_t b_upper;
+	u_int16_t b_lower;
+	u_int16_t M_code;
+	u_int16_t N_code;
+	u_int8_t PI_DIV;
+	u_int8_t DEMUX;
+	u_int8_t RATE_SEL;
+	u_int8_t CK_LDOD;
+	u_int8_t CK_CS;
+	u_int8_t CK_RS;
+	u_int8_t EQ_adj;
+	u_int8_t CDR_bias;
+	u_int8_t CDR_KP;
+	u_int8_t CDR_KP2;
+	u_int8_t CDR_KI;
+	u_int8_t CDR_KD;
+	u_int8_t EQ_gain;
+	u_int8_t EQ_bias;
+	u_int8_t CK_Icp;
+	u_int8_t PR;
+	u_int8_t pscaler;
+	u_int8_t vsel_ldo;
+	char *band_name;
+} HDMI_PHY_PARAM_T;
+
+typedef struct {
+	unsigned short b;
+	unsigned short b_pre;
+	unsigned short b_count;
+	unsigned short b_debouce_count;
+	u_int8_t b_mhl_debounce;
+	HDMI_bool b_change;
+	HDMI_bool avi_info_in;
+	unsigned short avi_info_miss_cnt;
+	unsigned short LG_patch_timer;
+	unsigned short timer;
+	short	 hotplug_timer;
+	unsigned short hotplug_delay_count;
+	unsigned char DEF_ready;
+	unsigned char measure_ready;
+	unsigned char detect_done;
+	unsigned char audio_detect_done;
+	unsigned char hdcp_state;/* enum HDCPRX_STATE */
+} HDMIRX_IOCTL_STRUCT_T;
+
+typedef struct {
+	HDMIRX_APSTATUS_T apstatus;
+	unsigned int idle_count;
+} HDMIRX_PHY_IDLE_PATCH_T;
+
+typedef struct {
+	unsigned char *uncache;
+	void *cache;
+	unsigned long phyaddr;
+	unsigned int size;
+} HDMI_CAPTURE_BUFFER_T;
+
+typedef struct {
+	unsigned char BKsv[5];
+	unsigned char Key[320];
+} HDCP_KEY_T;
+
+#if (defined ENABLE_HDCPKEY_ENDIAN_SWAP)
+typedef struct {
+	unsigned char BKsv[5];
+	unsigned char Key[328];
+} HDCP_KEY_T1;
+#endif
+
+typedef struct {
+	HDMI_COLOR_DEPTH_T depth;
+	HDMI_COLOR_SPACE_T color;
+	HDMI_COLORIMETRY_T	colorimetry;
+	char progressive;/* 0 --> interlaced ; 1 --> progressive */
+	HDMI_3D_T hdmi_3dformat;
+
+	unsigned int v_total;
+	unsigned int h_total;
+	unsigned int v_act_len;
+	unsigned int h_act_len;
+	unsigned int v_act_sta;
+	unsigned int h_act_sta;
+	unsigned int h_sync_high;
+	unsigned int v_freq;
+	unsigned int h_freq;
+	unsigned int polarity;
+	unsigned int mode_id;
+	unsigned int modetable_index;
+
+	/* only for fram packing */
+	unsigned int v_active_space1;
+	unsigned int v_active_space2;
+
+	/* quincunx */
+	unsigned int quincunx_en;
+	unsigned int quincunx_mode;
+
+} HDMI_TIMING_T;
+
+
+/* share with VO DMA */
+typedef struct {
+	HDMI_TIMING_T *ptx_timing;
+	HDMI_TIMING_T *pgen_timing;
+	/* for 3d */
+	unsigned int frame_rate_x2;
+	unsigned int enable_4xxto4xx;
+	unsigned int pixel_bits;
+
+	int down_sample_number;
+
+	int enable;/* 3d global enable */
+	/* video ring buffer */
+	unsigned int cap_rp;/* W: Video R:System */
+	unsigned int cap_wp;/* W: System R:Video */
+	int cap_size;
+	HDMI_CAPTURE_BUFFER_T cap_buffer_pool;
+	HDMI_CAPTURE_BUFFER_T cap_buffer[8];
+	/* freeze */
+	unsigned int vodma_freeze;/* W: System R:Video */
+	unsigned int hdmi_freeze;
+	unsigned int force_2d;/* 0: 3d  1:L only 2:R only  */
+	/* pull down 22 */
+	unsigned int pulldown22;
+	HDMI_COLOR_SPACE_T	cap_color_fmt;
+	int cap_pixel_bits;
+	HDMI_COLOR_DEPTH_T cap_colordepth;
+	HDMI_COLOR_SPACE_T cap_colorspace;
+	HDMI_TIMING_T vodma_timing;
+	HDMI_3D_OPMODE_T opmode;
+	HDMI_CAPTURE_BUFFER_T cap_total_buffer;
+} HDMI_3DDMA_CTRL_T;
+
+
+typedef struct {
+	unsigned int Info;  /* [0:1] Color Space */
+						/* [2] IsInterlace */
+						/* [3] is hdmi/dvi */
+						/* [4:7] color depth */
+						/* [8] current channel */
+
+	unsigned char FSM; /* [0:3] Video FSM */
+					   /*  [4:7] Audio FSM */
+
+	unsigned short b;
+
+#if (defined ENABLE_HDCPKEY_ENDIAN_SWAP)
+	HDCP_KEY_T1 *hdcpkey;
+#else
+	HDCP_KEY_T *hdcpkey;
+#endif
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+	unsigned char tx_hdcp_state;
+#endif
+
+	HDMI_TIMING_T  tx_timing;
+	HDMI_TIMING_T  gen_timing;
+	HDMI_TIMING_T  vodma_timing;
+
+	unsigned int timer;
+	int		fast_boot_source;
+	/* user defined 3d parameter */
+	int		force_all_3d_disable;
+	int		force_2dto3d_enable;
+	HDMI_3D_T force_2dto3d_mode;
+	int		force_3dto2d_enable;
+	int		force_3dto2d_lr_sel;
+	HDMI_PATH_POLICY_T path_policy;
+	int		enable_3ddma;
+	int hw_pattern_gen_enable;
+	HDMI_PTG_MODE_T hw_pattern_gen_mode;
+	HDMI_3D_OPMODE_T   hw_hdmi_dma;
+	int		hw_dither12x10_enable;
+	int		hw_dither10x8_enable;
+	int		hw_4xxto4xx_enable;
+
+	int		hw_rgbtoyuv_enable;
+
+	int		resume;
+	int		exit_check;
+	int		hdmi3d_capability;
+	unsigned int vsync_cnt;
+	HDMI_CAPTURE_BUFFER_T total_buffer;
+	HDMI_3DDMA_CTRL_T hdmi_3dctrl;
+	HDMI_3DDMA_CTRL_T *hdmi3dctrl_cache;
+	unsigned long hdmi3dctrl_phyaddr;
+	unsigned char hdmi_spd_device_info;
+
+	/* HPD */
+	int rx_5v_state;
+	int gpio_hpd_ctrl;
+	int gpio_5v_det;
+
+	unsigned int audio_freq;
+	unsigned char spdif_type;/* 0:LPCM,1:Non-LPCM */
+} HDMI_INFO_T;
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+#define HDCP_Aksv_SIZE 5
+#define KSVLIST_SIZE   640
+struct hdcp_ksvlist_info {
+	uint8_t Aksv[HDCP_Aksv_SIZE];
+	uint8_t ksvlist[KSVLIST_SIZE];
+	uint8_t bstatus[2];
+	uint32_t device_count;
+	uint8_t Bksv[HDCP_Aksv_SIZE];
+};
+#endif
+
+struct hdcp2p2_wait_event {
+	spinlock_t slock;
+	wait_queue_head_t read_wq;
+	unsigned int condition;
+};
+
+/*
+ * HDMI Driver Private MARCO
+ */
+#define HDMI_AUDIO_SUPPORT_NON_PCM()		(1)
+#define HDMI_AUDIO_IS_LPCM()  ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & _BIT4) == 0)
+
+#define GET_HDMI_COLOR_SPACE()		((HDMI_COLOR_SPACE_T) (hdmi.Info & (_BIT0 | _BIT1)))
+#define GET_HDMI_ISINTERLACE()		((hdmi.Info & (_BIT2)) >> 2)
+#define GET_ISHDMI()				((HDMI_DVI_MODE_T)((hdmi.Info & _BIT3) >> 3))
+#define GET_HDMI_CHANNEL()			((hdmi.Info & (_BIT8 | _BIT9)) >> 8)
+#define GET_HDMI_CD()				((hdmi.Info & (0xf0)) >> 4)
+#define GET_HDMI_DEONLY_MODE()		((hdmi.Info & _BIT10) >> 10)
+#define GET_HDMI_AVMUTE_MODE()		((hdmi.Info & _BIT11) >> 11)
+#define GET_HDMI_AUDIO_LAYOUT()     ((hdmi.Info & _BIT12) >> 12)
+#define GET_IS_FIRST_CHECK_MODE()	((hdmi.Info & _BIT13) >> 13)
+#define GET_IS_FIRST_DETECT_MODE()	((hdmi.Info & _BIT14) >> 14)
+#define GET_DVI_AUDIO_PATH_SETUP()	((hdmi.Info & _BIT15) >> 15)
+#define GET_HDMI_AUDIO_PATH_SETUP()	((hdmi.Info & _BIT16) >> 16)
+
+#define GET_HDMI_AUDIO_TYPE()		((hdmi.Info & _BIT17) >> 17)
+#define GET_HDMI_HBR_MODE()         ((hdmi.Info & _BIT18) >> 18)
+#define GET_HDMI_BOOT_FIRST_RUN()	((hdmi.Info & _BIT19) >> 19)
+#define GET_HDMI_FASTER_BOOT_EN()	((hdmi.Info & _BIT20) >> 20)
+#define GET_HDMI_FASTER_SWITCH_EN()	((hdmi.Info & _BIT21) >> 21)
+#define GET_HDMI_RGB_Q_RANGE()		((HDMI_RGB_YUV_RANGE_MODE_T)(hdmi.Info & (_BIT22|_BIT23)) >> 22)
+#define GET_HDMI_OSD_MODE()			((hdmi.Info & (_BIT29 | _BIT30)) >> 29)
+
+#define GET_HDMI_VIDEO_FSM()		(hdmi.FSM & 0x0F)
+#define GET_HDMI_AUDIO_FSM()		((hdmi.FSM & 0xF0) >> 4)
+
+#define SET_HDMI_COLOR_SPACE(x)		(hdmi.Info = ((hdmi.Info & ~(_BIT0 | _BIT1))  | (((unsigned int) x & 0x03))))
+#define SET_HDMI_CD(x)				(hdmi.Info = ((hdmi.Info & ~(0xf0))  | (((unsigned int) x & 0x0f) << 4)))
+#define SET_HDMI_ISINTERLACE(x)		do {hdmi.Info = ((hdmi.Info & (~_BIT2))  | (((unsigned int) x & 0x01) << 2)); \
+											 hdmi.tx_timing.progressive = (x == 0);} while(0)
+#define SET_ISHDMI(x)				(hdmi.Info =	((hdmi.Info & ~_BIT3)  | (((unsigned int) x & 0x01) << 3)))
+#define SET_HDMI_CHANNEL(x) 		(hdmi.Info =	((hdmi.Info & ~(_BIT8 | _BIT9))  | (((unsigned int) x & 0x03) << 8)))
+#define SET_HDMI_DEONLY_MODE(x) 	(hdmi.Info = ((hdmi.Info & (~_BIT10))  | (((unsigned int) x & 0x01) << 10)))
+#define SET_HDMI_AVMUTE_MODE(x) 	(hdmi.Info = ((hdmi.Info & (~_BIT11))  | (((unsigned int) x & 0x01) << 11)))
+#define SET_HDMI_AUDIO_LAYOUT(x)	(hdmi.Info = ((hdmi.Info & (~_BIT12))  | (((unsigned int) x & 0x01) << 12)))
+#define SET_IS_FIRST_CHECK_MODE(x)	(hdmi.Info = ((hdmi.Info & (~_BIT13))  | (((unsigned int) x & 0x01) << 13)))
+#define SET_IS_FIRST_DETECT_MODE(x) (hdmi.Info = ((hdmi.Info & (~_BIT14))  | (((unsigned int) x & 0x01) << 14)))
+#define SET_DVI_AUDIO_PATH_SETUP(x) (hdmi.Info = ((hdmi.Info & (~_BIT15))  | (((unsigned int) x & 0x01) << 15)))
+#define SET_HDMI_AUDIO_PATH_SETUP(x)(hdmi.Info = ((hdmi.Info & (~_BIT16))  | (((unsigned int) x & 0x01) << 16)))
+
+#define SET_HDMI_AUDIO_TYPE(x)		(hdmi.Info = ((hdmi.Info & (~_BIT17))  | (((unsigned int) x & 0x01) << 17)))
+#define SET_HDMI_HBR_MODE(x)		(hdmi.Info = ((hdmi.Info & (~_BIT18))  | (((unsigned int) x & 0x01) << 18)))
+#define SET_HDMI_BOOT_FIRST_RUN(x)	(hdmi.Info = ((hdmi.Info & (~_BIT19))  | (((unsigned int) x & 0x01) << 19)))
+#define SET_HDMI_FASTER_BOOT_EN(x)	(hdmi.Info = ((hdmi.Info & (~_BIT20))  | (((unsigned int) x & 0x01) << 20)))
+#define SET_HDMI_FASTER_SWITCH_EN(x)(hdmi.Info = ((hdmi.Info & (~_BIT21))  | (((unsigned int) x & 0x01) << 21)))
+#define SET_HDMI_RGB_Q_RANGE(x) 	(hdmi.Info = ((hdmi.Info & (~(_BIT22|_BIT23)))	| (((unsigned int) x & 0x03) << 22)))
+#define SET_HDMI_OSD_MODE(x)		(hdmi.Info = ((hdmi.Info & ~(_BIT29 | _BIT30))	| (((unsigned int) x & 0x03) << 29)))
+#define SET_HDMI_VIDEO_FSM(x)		(hdmi.FSM = (hdmi.FSM & 0xF0) | ((unsigned char) x & 0x0F))
+#define SET_HDMI_AUDIO_FSM(x)		(hdmi.FSM = (hdmi.FSM & 0x0F) | (((unsigned char) x & 0x0F) << 4))
+
+/*=================== hdmiMS ===================*/
+#if HDMI_INTERNAL_DEBUG
+int Hdmi_CRC_check(void);
+#endif
+unsigned char Hdmi_WaitVsync(int num);
+unsigned int Hdmi_GetVSyncCountInit(void);
+unsigned int Hdmi_GetVSyncCount(void);
+bool Hdmi_GetInterlace(HDMI_MS_MODE_T mode);
+HDMI_COLORIMETRY_T Hdmi_GetColorimetry(void);
+HDMI_ERR_T Hdmi_MeasureActiveSpace(HDMI_TIMING_T *tx_timing, HDMI_TIMING_T *gen_timing);
+HDMI_3D_T Hdmi_Get3DInfo(HDMI_MS_MODE_T mode);
+unsigned char Hdmi_Get3DExtInfo(void);
+void Hdmi_Get3DGenTiming(HDMI_TIMING_T *tx_timing, HDMI_TIMING_T *gen_timing);
+
+/*=================== hdmirx_hdcp ===================*/
+void Hdmi_HdcpInit(void);
+unsigned char Is_HdmiRx_hdcp1x_enabled(void);
+
+
+/*=================== hdmiHdmi ===================*/
+unsigned char drvif_Hdmi_AVI_VIC(void);
+#if HDMI2p0
+void drvif_Hdmi2p0_Scdc_Reset(void);
+void drvif_Hdmi2p0_Error_Count(void);
+void TMDS_6G_Recovery(void);
+#endif
+
+
+#endif /* __HDMI_INTERNAL_H_ */
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiMS.c b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiMS.c
new file mode 100644
index 00000000..19eca0d
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiMS.c
@@ -0,0 +1,568 @@
+/*
+ * hdmiMS.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmiInternal.h"
+
+/*=================== extern Variable/Function ===================*/
+#if HDMI2p0
+extern u_int8_t   bHDMI_420_Space;/* For YUV420 */
+#endif
+extern HDMI_INFO_T hdmi;
+extern HDMI_CONST VIDEO_DPLL_RATIO_T dpll_ratio[];
+
+extern unsigned int hdmirx_wrapper_get_active_pixel(void);
+extern unsigned int hdmirx_wrapper_get_active_line(void);
+/*======================================================*/
+
+
+HDMI_ACTIVE_SPACE_TABLE_T hdmi_active_space_table[] = {
+	{ "1080P FramePacking",  1, 1920,  1080*2 + 45, 1080, 45, 0 },
+	{ "720P FramePacking",	1, 1280,  720*2 + 30, 720, 30, 0 },
+	{ "480P FramePacking",	1, 720,  480*2 + 45, 480, 45, 0 },
+	{ "576P FramePacking",	1, 720,  576*2 + 49, 576, 49, 0 },
+	{ "1080I FramePacking",  0, 1920,  540*4 + 22 + 23*2, 540, 23, 22 },
+	{ "576I FramePacking",	0, 720,  288*4 + 32 + 21*2, 288, 21, 32 },
+	{ "480I FramePacking",	0, 720,  240*4 + 22 + 23*2, 240, 23, 22 },
+	{ NULL,  1, 1920,  520, 40, 0 },
+};
+
+#if HDMI_INTERNAL_DEBUG/* RD test */
+int Hdmi_CRC_check(void)
+{
+	UINT8 tmo = 50;
+	unsigned int crc_result;
+	static unsigned int pre_crc_result = 0;
+
+	/* Disable CRC check */
+	hdmi_rx_reg_mask32(TMDS_CRCC, ~TMDS_CRCC_crcc_mask, 0, HDMI_RX_MAC);
+	/* Enable CRC check */
+	hdmi_rx_reg_mask32(TMDS_CRCC, ~TMDS_CRCC_crcc_mask, TMDS_CRCC_crcc(1), HDMI_RX_MAC);
+
+	/* Wait CRC done bit */
+	while (!(hdmi_rx_reg_read32(TMDS_CRCC, HDMI_RX_MAC)&TMDS_CRCC_crc_done_mask)) {
+		usleep_range(10000, 15000);/* 10~15ms */
+		if (!tmo--) {
+			/* HDMI_PRINTF("[HDMI] WARNING: FAIL: Wait CRC Timeout !!!\n"); */
+			HDMIRX_INFO("CRC check timeout");
+			return FALSE;
+		}
+	}
+
+	crc_result = hdmi_rx_reg_read32(TMDS_CRCO0, HDMI_RX_MAC);
+
+	if (crc_result != pre_crc_result) {
+		pre_crc_result = crc_result;
+		HDMIRX_INFO("CRC result changed (0x%08x)", crc_result);
+	}
+
+	return TRUE;
+}
+#endif
+
+unsigned char Hdmi_WaitVsync(int num)
+{
+	int i;
+
+	hdmi_rx_reg_mask32(TMDS_CTRL, ~TMDS_CTRL_yo_mask, TMDS_CTRL_yo(1), HDMI_RX_MAC);
+
+	for (i = 0; i < num; i++) {
+		/* Wait vsync done */
+		if (TMDS_CTRL_get_yo(hdmi_rx_reg_read32(TMDS_CTRL, HDMI_RX_MAC)))
+			return 1;
+
+		usleep_range(10000, 15000);/* 10~15ms */
+	}
+
+	HDMI_PRINTF("Wait vsync timeout\n");
+	return 0;
+}
+
+unsigned int Hdmi_GetVSyncCountInit(void)
+{
+	hdmi.vsync_cnt = 0;
+
+	return hdmi.vsync_cnt;
+}
+unsigned int Hdmi_GetVSyncCount(void)
+{
+	if (TMDS_CTRL_get_yo(hdmi_rx_reg_read32(TMDS_CTRL, HDMI_RX_MAC))) {
+		hdmi_rx_reg_mask32(TMDS_CTRL, ~TMDS_CTRL_yo_mask, TMDS_CTRL_yo(1), HDMI_RX_MAC);
+		hdmi.vsync_cnt++;
+	}
+
+	return hdmi.vsync_cnt;
+}
+
+bool Hdmi_GetInterlace(HDMI_MS_MODE_T mode)
+{
+	static unsigned int count_now, count_target;
+	static unsigned char wrap_around;
+	static int progressive = 0;
+	progressive = !GET_HDMI_ISINTERLACE();
+
+	switch (mode) {
+	case HDMI_MS_MODE_ONESHOT:
+		/* Clear status, prepare to check interlace/progressive */
+		hdmi_rx_reg_mask32(HDMI_VCR, ~(HDMI_VCR_se_mask|HDMI_VCR_eot_mask|HDMI_VCR_int_pro_chg_flag_mask), HDMI_VCR_eot_mask, HDMI_RX_MAC);
+		Hdmi_WaitVsync(15);
+		Hdmi_WaitVsync(15);/* Wait vsync twice for interlace mode */
+		if (hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC) & HDMI_VCR_eot_mask) {
+			/* Interlace mode */
+			/* HDMIRX_INFO("interlaced mode"); */
+			progressive = 0;
+			return 1;
+		} else {
+			/* HDMIRX_INFO(" Progressive mode"); */
+			progressive = 1;
+			return 0;
+		}
+		break;
+
+	case HDMI_MS_MODE_CONTINUOUS_INIT:
+		/* Clear status */
+		hdmi_rx_reg_mask32(HDMI_VCR, ~HDMI_VCR_eot_mask, HDMI_VCR_eot(1), HDMI_RX_MAC);
+		Hdmi_GetVSyncCountInit();
+		count_now = Hdmi_GetVSyncCount();
+		count_target = count_now + 4;
+		if (count_target < count_now)
+			wrap_around = 1;
+		break;
+
+	case HDMI_MS_MODE_CONTINUOUS_CHECK:
+		if (count_now > Hdmi_GetVSyncCount())
+			wrap_around = 0;
+
+		count_now = Hdmi_GetVSyncCount();
+		if (count_now  > count_target && wrap_around == 0) {
+			if (hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC) & _BIT6)
+				progressive = 0;/* Interlace mode */
+			else
+				progressive = 1;
+
+			Hdmi_GetInterlace(HDMI_MS_MODE_CONTINUOUS_INIT);
+		}
+		break;
+	default:
+		break;
+	}
+
+	if (progressive)
+		return 0;
+	else
+		return 1;
+}
+
+HDMI_COLORIMETRY_T Hdmi_GetColorimetry(void)
+{
+	unsigned int C, EC;
+
+	hdmi_rx_reg_write32(HDMI_PSAP, 0x0, HDMI_RX_MAC);
+	if (hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC) != 0)
+		return HDMI_COLORIMETRY_NOSPECIFIED;
+
+	hdmi_rx_reg_write32(HDMI_PSAP, 0x5, HDMI_RX_MAC);
+	C = ((hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC) >> 6) & 0x03);
+	hdmi_rx_reg_write32(HDMI_PSAP, 0x6, HDMI_RX_MAC);
+	EC = ((hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC) >> 4) & 0x07);
+
+	if (C != 0x03) {
+		return (HDMI_COLORIMETRY_T) C;
+	} else {
+		return (HDMI_COLORIMETRY_T) (HDMI_COLORIMETRY_XYYCC601 + EC);
+	}
+
+}
+
+char Hdmi_GetPixelDownSample(void)
+{
+	if (HDMI_VCR_get_prdsam(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC))) {
+		return HDMI_VCR_get_dsc_r(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+	} else {
+		return HDMI_VCR_get_dsc(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+	}
+}
+
+int Hdmi_GetColorDepth(void)
+{
+	return TMDS_DPC0_dpc_cd(hdmi_rx_reg_read32(TMDS_DPC0, HDMI_RX_MAC));
+}
+
+HDMI_ERR_T Hdmi_MeasureActiveSpace(HDMI_TIMING_T *tx_timing, HDMI_TIMING_T *gen_timing)
+{
+	int i = 0;
+	int fields;
+
+	HDMI_PRINTF("tx_timing->h_act_len = %d\n", tx_timing->h_act_len);
+	HDMI_PRINTF("tx_timing->v_act_len = %d\n", tx_timing->v_act_len);
+
+	while (hdmi_active_space_table[i].name) {
+			HDMI_PRINTF(" hdmi_active_space_table[%d].h_act_len = %d\n", i, hdmi_active_space_table[i].h_act_len);
+			HDMI_PRINTF(" hdmi_active_space_table[%d].v_act_len = %d\n", i, hdmi_active_space_table[i].v_act_len);
+
+		if (tx_timing->h_act_len == hdmi_active_space_table[i].h_act_len && tx_timing->v_act_len == hdmi_active_space_table[i].v_act_len) {
+			gen_timing->v_act_len = hdmi_active_space_table[i].lr_v_act_len;
+			tx_timing->v_active_space1 = hdmi_active_space_table[i].v_active_space1;
+			tx_timing->v_active_space2 = hdmi_active_space_table[i].v_active_space2;
+			gen_timing->v_active_space1 = hdmi_active_space_table[i].v_active_space1;
+			gen_timing->v_active_space2 = hdmi_active_space_table[i].v_active_space2;
+			gen_timing->progressive = hdmi_active_space_table[i].progressive;
+			fields = gen_timing->progressive ? 2 : 4;
+			/* gen_timing->progressive = tx_timing->progressive; */
+			gen_timing->color = tx_timing->color;
+			gen_timing->depth = tx_timing->depth;
+
+			gen_timing->v_freq = tx_timing->v_freq * fields;
+			gen_timing->v_total = tx_timing->v_total / fields;
+			gen_timing->h_freq = tx_timing->h_freq;
+			gen_timing->h_act_len = tx_timing->h_act_len;
+			gen_timing->h_total = tx_timing->h_total;
+			gen_timing->h_act_sta = tx_timing->h_act_sta;
+			gen_timing->v_act_sta = tx_timing->v_act_sta;
+			HDMI_PRINTF("%s\n", hdmi_active_space_table[i].name);
+			return HDMI_ERR_NO;
+		}
+		i++;
+	}
+
+	gen_timing->progressive = 1;
+	fields = gen_timing->progressive ? 2 : 4;
+	/* gen_timing->progressive = tx_timing->progressive; */
+	gen_timing->color = tx_timing->color;
+	gen_timing->depth = tx_timing->depth;
+
+	gen_timing->v_freq = tx_timing->v_freq * fields;
+	gen_timing->v_total = tx_timing->v_total / fields;
+	gen_timing->h_freq = tx_timing->h_freq;
+	gen_timing->h_act_len = tx_timing->h_act_len;
+	gen_timing->h_total = tx_timing->h_total;
+	gen_timing->h_act_sta = tx_timing->h_act_sta;
+	gen_timing->v_act_sta = tx_timing->v_act_sta;
+	gen_timing->v_act_len = (tx_timing->v_act_len - tx_timing->v_act_sta) / 2;
+	gen_timing->v_active_space1 = tx_timing->v_act_sta;
+	gen_timing->v_active_space2 = 0;
+	tx_timing->v_active_space1 = tx_timing->v_act_sta;
+	tx_timing->v_active_space2 = 0;
+
+	HDMI_PRINTF("Unknow frame packing fomat and force to 2D\n");
+
+	return HDMI_EER_MEASURE_ACTIVESPACE_FAIL;
+}
+
+HDMI_3D_T Hdmi_Get3DInfo(HDMI_MS_MODE_T mode)
+{
+	char   timeout = 10;
+	HDMI_3D_T result;
+
+	switch (mode) {
+	case HDMI_MS_MODE_ONESHOT:
+		hdmi_rx_reg_mask32(HDMI_PTRSV1, ~0x00FF00, 0x81<<8, HDMI_RX_MAC);
+		/* Clear RSV2 indicator */
+		hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_pis_6_mask, HDMI_RX_MAC);
+
+		for (timeout = 12; timeout > 0; timeout--) {
+			HDMI_DELAYMS(10);
+			if (hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC) & HDMI_GPVS_pis_6_mask) {
+				/* if 3D format indication present is absent, return 2D anyway */
+				if (HDMI_VIDEO_FORMAT_get_hvf(hdmi_rx_reg_read32(HDMI_VIDEO_FORMAT, HDMI_RX_MAC)) != 0x02)
+					return HDMI3D_2D_ONLY;
+				else
+					return (HDMI_3D_T) HDMI_3D_FORMAT_get_hdmi_3d_structure(hdmi_rx_reg_read32(HDMI_3D_FORMAT, HDMI_RX_MAC));
+			}
+		}
+		if (timeout == 0)
+			HDMI_PRINTF("Hdmi_Get3DInfo timeout\n");
+		return HDMI3D_2D_ONLY;
+		break;
+
+	case HDMI_MS_MODE_ONESHOT_INIT:
+		/* Packet Type = 0x81(HDMI Vendor Specific InfoFrame) */
+		hdmi_rx_reg_mask32(HDMI_PTRSV1, 0xffff00ff, 0x00008100, HDMI_RX_MAC);
+		/*Clear RSV2 indicator*/
+		hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_pis_6_mask, HDMI_RX_MAC);
+		break;
+
+	case HDMI_MS_MODE_ONESHOT_GET_RESULT:
+		if (hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC) & HDMI_GPVS_pis_6_mask) {
+			/* if 3D format indication present is absent, return 2D anyway */
+			if (HDMI_VIDEO_FORMAT_get_hvf(hdmi_rx_reg_read32(HDMI_VIDEO_FORMAT, HDMI_RX_MAC)) != 0x02)
+				result = HDMI3D_2D_ONLY;
+			else
+				result = (HDMI_3D_T) HDMI_3D_FORMAT_get_hdmi_3d_structure(hdmi_rx_reg_read32(HDMI_3D_FORMAT, HDMI_RX_MAC));
+
+			switch ((unsigned int)result) {
+			case HDMI3D_FRAME_PACKING:
+			case HDMI3D_LINE_ALTERNATIVE:
+			case HDMI3D_2D_ONLY:
+			case HDMI3D_SIDE_BY_SIDE_FULL:
+			case HDMI3D_TOP_AND_BOTTOM:
+				break;
+			default:
+				HDMI_PRINTF("3D mode %d not support\n", result);
+				return HDMI3D_2D_ONLY;
+				break;
+			}
+			return result;
+		} else {
+			return HDMI3D_2D_ONLY;
+		}
+		break;
+	default:
+		return HDMI3D_UNKOWN;
+		break;
+	}
+
+	return HDMI3D_UNKOWN;
+}
+
+unsigned char Hdmi_Get3DExtInfo(void)
+{
+	return HDMI_3D_FORMAT_get_hdmi_3d_ext_data(hdmi_rx_reg_read32(HDMI_3D_FORMAT, HDMI_RX_MAC));
+}
+
+void Hdmi_Get3DGenTiming(HDMI_TIMING_T *tx_timing, HDMI_TIMING_T *gen_timing)
+{
+	/* Determine output 3D format */
+	switch (hdmi.path_policy) {
+	case HDMI_PATH_POLICY_2D_ONLY:
+		gen_timing->hdmi_3dformat = HDMI3D_2D_ONLY;
+		hdmi.hw_hdmi_dma = HDMI_3D_OPMODE_DISABLE;
+		break;
+	case HDMI_PATH_POLICY_3D_NODMA:
+		hdmi.hw_hdmi_dma = HDMI_3D_OPMODE_DISABLE;
+		if (tx_timing->hdmi_3dformat == HDMI3D_FRAME_PACKING)
+			gen_timing->hdmi_3dformat = HDMI3D_FRAME_PACKING;
+		else
+			gen_timing->hdmi_3dformat = HDMI3D_2D_ONLY;
+		break;
+	case HDMI_PATH_POLICY_3D_DMA:
+		if (hdmi.hdmi3d_capability == 0) {
+			gen_timing->hdmi_3dformat = HDMI3D_2D_ONLY;
+		} else if (hdmi.force_all_3d_disable) {
+			gen_timing->hdmi_3dformat = HDMI3D_2D_ONLY;
+		} else if (hdmi.force_2dto3d_enable && tx_timing->hdmi_3dformat == HDMI3D_2D_ONLY) {
+			gen_timing->hdmi_3dformat = hdmi.force_2dto3d_mode;
+			hdmi.hw_hdmi_dma = HDMI_3D_OPMODE_HW;
+		} else if (hdmi.force_3dto2d_enable && tx_timing->hdmi_3dformat != HDMI3D_2D_ONLY) {
+			if (hdmi.force_3dto2d_lr_sel)
+				hdmi.hw_hdmi_dma = HDMI_3D_OPMODE_HW_2DONLY_L;
+			else
+				hdmi.hw_hdmi_dma = HDMI_3D_OPMODE_HW_2DONLY_R;
+		} else {
+			gen_timing->hdmi_3dformat = tx_timing->hdmi_3dformat;
+			if (gen_timing->hdmi_3dformat != HDMI3D_2D_ONLY)
+				hdmi.hw_hdmi_dma = HDMI_3D_OPMODE_HW;
+			else
+				hdmi.hw_hdmi_dma = HDMI_3D_OPMODE_DISABLE;
+		}
+		break;
+	}
+
+	gen_timing->colorimetry = tx_timing->colorimetry;
+	gen_timing->color = tx_timing->color;
+	gen_timing->depth = tx_timing->depth;
+	gen_timing->quincunx_en = 0;
+
+	switch (gen_timing->hdmi_3dformat) {
+	case HDMI3D_2D_ONLY:
+		/* 3d convert to 2D , don't do DI */
+		if (tx_timing->hdmi_3dformat != HDMI3D_2D_ONLY)
+			gen_timing->progressive = 1;
+		else
+			gen_timing->progressive = tx_timing->progressive;
+
+		gen_timing->v_total = tx_timing->v_total;
+		gen_timing->v_act_len = tx_timing->v_act_len;
+		gen_timing->v_act_sta = tx_timing->v_act_sta;
+		gen_timing->h_total = tx_timing->h_total;
+		gen_timing->h_act_len = tx_timing->h_act_len;
+		gen_timing->h_act_sta = tx_timing->h_act_sta;
+		gen_timing->v_freq = tx_timing->v_freq;
+		gen_timing->h_freq = tx_timing->h_freq;
+		break;
+	case HDMI3D_FRAME_PACKING:
+		Hdmi_MeasureActiveSpace(tx_timing, gen_timing);
+		break;
+	case HDMI3D_LINE_ALTERNATIVE:
+		gen_timing->progressive = tx_timing->progressive;
+		gen_timing->v_total = tx_timing->v_total/2;
+		gen_timing->v_act_len = tx_timing->v_act_len/2;
+		gen_timing->v_act_sta = tx_timing->v_act_sta;
+		gen_timing->h_total = tx_timing->h_total;
+		gen_timing->h_act_len = tx_timing->h_act_len;
+		gen_timing->h_act_sta = tx_timing->h_act_sta;
+		gen_timing->v_freq = tx_timing->v_freq*2;
+		gen_timing->h_freq = tx_timing->h_freq;
+		break;
+	case HDMI3D_SIDE_BY_SIDE_FULL:
+		HDMI_PRINTF("HDMI3D_SIDE_BY_SIDE_FULL\n");
+		gen_timing->progressive = tx_timing->progressive;
+		gen_timing->v_total = tx_timing->v_total/2;
+		gen_timing->v_act_len = tx_timing->v_act_len;
+		gen_timing->v_act_sta = tx_timing->v_act_sta;
+		gen_timing->h_total = tx_timing->h_total/2;
+		gen_timing->h_act_len = tx_timing->h_act_len/2;
+		gen_timing->h_act_sta = tx_timing->h_act_sta/2;
+		gen_timing->v_freq = tx_timing->v_freq * 2;
+		gen_timing->h_freq = tx_timing->h_freq;
+		break;
+	case HDMI3D_TOP_AND_BOTTOM:
+		HDMI_PRINTF("HDMI3D_TOP_AND_BOTTOM\n");
+		gen_timing->progressive = tx_timing->progressive;
+		gen_timing->v_total = tx_timing->v_total/2;
+		gen_timing->v_act_len = tx_timing->v_act_len/2;
+		gen_timing->v_act_sta = tx_timing->v_act_sta/2;
+		gen_timing->h_total = tx_timing->h_total;
+		gen_timing->h_act_len = tx_timing->h_act_len;
+		gen_timing->h_act_sta = tx_timing->h_act_sta;
+		gen_timing->v_freq = tx_timing->v_freq * 2;
+		gen_timing->h_freq = tx_timing->h_freq;
+		break;
+	case HDMI3D_SIDE_BY_SIDE_HALF:
+		HDMI_PRINTF("HDMI3D_SIDE_BY_SIDE_HALF\n");
+		gen_timing->progressive = tx_timing->progressive;
+		gen_timing->v_total = tx_timing->v_total/2;
+		gen_timing->v_act_len = tx_timing->v_act_len;
+		gen_timing->v_act_sta = tx_timing->v_act_sta;
+		gen_timing->h_total = tx_timing->h_total/2;
+		gen_timing->h_act_len = tx_timing->h_act_len/2;
+		gen_timing->h_act_sta = tx_timing->h_act_sta/2;
+		gen_timing->v_freq = tx_timing->v_freq * 2;
+		gen_timing->h_freq = tx_timing->h_freq;
+		gen_timing->quincunx_en = tx_timing->quincunx_en;
+		gen_timing->quincunx_mode = tx_timing->quincunx_mode;
+		break;
+	case HDMI3D_FIELD_ALTERNATIVE:
+		HDMI_PRINTF("HDMI3D_FIELD_ALTERNATIVE\n");
+		gen_timing->progressive = tx_timing->progressive;
+		gen_timing->v_total = tx_timing->v_total/2;
+		gen_timing->v_act_len = tx_timing->v_act_len;
+		gen_timing->v_act_sta = tx_timing->v_act_sta;
+		gen_timing->h_total = tx_timing->h_total;
+		gen_timing->h_act_len = tx_timing->h_act_len;
+		gen_timing->h_act_sta = tx_timing->h_act_sta;
+		gen_timing->v_freq = tx_timing->v_freq * 2;
+		gen_timing->h_freq = tx_timing->h_freq;
+		break;
+	default:
+		break;
+	}
+
+	/* Determine 3D HW PATH format */
+	if (hdmi.path_policy == HDMI_PATH_POLICY_3D_NODMA) {
+		if (gen_timing->hdmi_3dformat == HDMI3D_FRAME_PACKING &&
+			tx_timing->hdmi_3dformat  == HDMI3D_FRAME_PACKING &&
+			gen_timing->progressive == 0)
+			hdmi.hw_hdmi_dma = HDMI_3D_OPMODE_HW_NODMA;
+	}
+}
+
+int hdmi_onms_measure(HDMI_TIMING_T *timing)
+{
+	timing->h_act_len = hdmirx_wrapper_get_active_pixel();
+	timing->v_act_len = hdmirx_wrapper_get_active_line();
+
+	timing->h_total = timing->h_act_len;
+	timing->v_total = timing->v_act_len;
+
+	if ((timing->h_act_len == 0) || (timing->v_act_len == 0) ||
+		(timing->h_total == 0) || (timing->v_total == 0))
+		return HDMI_ERR_ONMS_WRONG_TIMING;
+	else
+		return HDMI_ERR_NO;
+}
+
+
+bool Hdmi_MeasureTiming(HDMI_TIMING_T *timing, int b)
+{
+	unsigned char cd;
+	unsigned int Q, D;
+	int downsample;
+
+	downsample = Hdmi_GetPixelDownSample();
+	cd = Hdmi_GetColorDepth();
+
+	if (hdmi_onms_measure(timing) != HDMI_ERR_NO)
+		return FALSE;
+
+	if (downsample != Hdmi_GetPixelDownSample())  {
+		HDMI_PRINTF("down sample number change\n");
+		return FALSE;
+	}
+
+	if (cd != Hdmi_GetColorDepth()) {
+		HDMI_PRINTF("color depth change\n");
+		return FALSE;
+	}
+
+	if (GET_HDMI_ISINTERLACE() != Hdmi_GetInterlace(HDMI_MS_MODE_CONTINUOUS_CHECK)) {
+		HDMI_PRINTF("interlace change\n");
+		return FALSE;
+	}
+
+	timing->progressive = GET_HDMI_ISINTERLACE() == 0;
+
+	/* timing compansation */
+	if (GET_HDMI_ISINTERLACE() && GET_HDMI_DEONLY_MODE()) {
+		if ((timing->v_total & 0x01) == 1) {
+			/* ODD field */
+			timing->v_act_sta -= 1;
+			timing->v_total -= 1;
+		}
+	}
+
+	/* Horizontal active width must be even */
+	if (timing->h_act_len & 0x01)
+		timing->h_act_len -= 1;
+
+	/* To calculate IVFreq */
+	if (cd >= 0x04 && cd < 0x08)
+		cd = cd - 0x04;
+	else
+		cd = 0;
+
+	if (b != 0) {
+		/* Implement Q = (27000000 * hdmi.b / 256 * RatioM) / RatioN */
+		D = ((downsample & 0x0f) + 1) * timing->h_total;
+
+		Q = ((27000000UL * dpll_ratio[cd].RatioM)) / (dpll_ratio[cd].RatioN * 256);
+		Q = (hdmi.b * Q);
+		Q = ((Q + (D >> 1)) / D);
+
+		timing->h_freq = (Q + 50) / 100;
+		timing->v_freq = (Q * 10 + (timing->v_total>>1)) / timing->v_total;
+
+#if HDMI2p0
+		if (bHDMI_420_Space == COLOR_YUV420)
+			timing->v_freq = 2*timing->v_freq;
+#endif
+	} else {
+		timing->h_freq = 0;
+		timing->v_freq = 0;
+	}
+
+	HDMI_PRINTF("IVTotal: %d\n", timing->v_total);
+	HDMI_PRINTF("IHTotal: %d\n", timing->h_total);
+
+	HDMI_PRINTF("IHWidth:%d\n", timing->h_act_len);
+	HDMI_PRINTF("IVHeight:%d\n", timing->v_act_len);
+
+	HDMI_PRINTF("IVStart:%d\n", timing->v_act_sta);
+	HDMI_PRINTF("IHStart:%d\n", timing->h_act_sta);
+
+	if (timing->h_freq)
+		HDMI_PRINTF("IHFreq:%d\n", timing->h_freq);
+	if (timing->v_freq)
+		HDMI_PRINTF("IVFreq:%d\n", timing->v_freq);
+
+	return TRUE;
+
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiPhy.c b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiPhy.c
new file mode 100644
index 00000000..0d97593
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/rx_drv/hdmiPhy.c
@@ -0,0 +1,1674 @@
+/*
+ * hdmiPhy.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmiInternal.h"
+
+#define HDMI_B_TEST_COUNT_MAX  1
+
+#define	ManualZ0  0xE
+
+/* TMDS clock define */
+#define TMDS_6G     5688
+#define TMDS_5G     4740
+#define TMDS_4G     3792
+#define TMDS_3G     2844
+#define TMDS_1p5G   1422
+
+#define Fore_Koff_Range  1 /* Range maybe 0  1  2   3 */
+#define Fore_Koff_FIX    1
+
+/*=================== Global Variable ===========================*/
+UINT8 bSCDC_Enable_flag, bSCDC_debounce_cnt, bUPdata_flag;/* For hdmi 2.0 SCDC set flag */
+HDMIRX_PHY_IDLE_PATCH_T hdmi_phy_idle_patch;
+HDMIRX_IOCTL_STRUCT_T hdmi_ioctl_struct;
+
+u_int32_t clock_bound_3g;
+u_int32_t clock_bound_1p5g;
+u_int32_t clock_bound_110m;
+u_int32_t clock_bound_45m;
+
+/* For DFE close timing setting */
+UINT8 bDFE_Close_Flag, bDFE_Close_Cnt;
+/*=========================================================*/
+
+extern void Hdmi_HdcpFSM(void);
+
+#if HDMI2p0
+extern u_int8_t bHDMI_6G_flag;
+extern u_int8_t b6G_detect_cnt;
+#endif
+extern HDMI_INFO_T hdmi;
+
+const HDMI_PHY_PARAM_T hdmi_phy_param[] = {
+/* QC 2016/01/18 */
+/*  B_upper           M_code              PI_DIV              RATE_SEL                    CK_CS                   *EQ_manual                     CDR_KP                          CDR_KI                 *EQ_gain                 CK_Icp            pscaler			band_name */
+/*             B_lower             N_code           DEMUX                   *CK_LDOD                      CK_RS                     *CDR_bias                       *CDR_KP2                  CDR_KD                *EQ_bias                   PR			vsel_ldo */
+	{5860, 2844,    16,     0,     0,     1,      0x0,      0x3,      0x4,      0x2,      0x2,      0x1,    (0x08<<0),      0x0,      0x1,      0x0,    0x0,    0x1,    0x3,    0x0, 0x0,      7,   "300M~6000M half rate"},  /* 300~600 M */
+	{2844, 1422,    36,     2,     1,     2,      0x1,      0x3,      0x4,      0x2,      0x4,      0x1,    (0x20<<0),      0x4,      0x1,      0x0,    0x1,    0x1,    0x7,    0x0, 0x0,      7,   "150M~300M full rate"},	  /* 150~300 M */
+	{1422,  711,    36,     1,     2,     3,      0x2,      0x3,      0x4,      0x2,      0x9,      0x1,    (0x20<<0),      0x0,      0x0,      0x0,    0x1,    0x1,    0x7,    0x1, 0x0,      7,   "75M~150M full rate+DS1"},/* 75~150 M */
+	{ 711,  355,    36,     0,     3,     3,      0x2,      0x3,      0x4,      0x2,      0x4,      0x1,    (0x10<<0),      0x0,      0x0,      0x0,    0x1,    0x1,    0x7,    0x2, 0x0,      7,   "37.5M~75M full rate+DS2"},	/* 37.5~75M */
+	{ 355,  128,    76,     0,     4,     3,      0x2,      0x3,      0x4,      0x7,      0x4,      0x1,    (0x10<<0),      0x0,      0x0,      0x0,    0x1,    0x1,    0x3,    0x3, 0x0,      7,   "13.5M~37M full rate+DS3"}, /* 13.5M~ 37.5M */
+};
+
+void HDMI_MAG2_SetDFE_Close(void);
+
+void hdmi_z0_set(unsigned char port, unsigned char lane, unsigned char enable)
+{
+	unsigned int bmask = 0;
+
+	if (lane&LN_Z300POW)
+		bmask |= Z0POW_reg_z0_z300pow(1<<port);
+
+	if (lane&LN_CK)
+		bmask |= Z0POW_reg_z0_z0pow_ck(1<<port);
+
+	if (lane&LN_B)
+		bmask |= Z0POW_reg_z0_z0pow_b(1<<port);
+
+	if (lane&LN_G)
+		bmask |= Z0POW_reg_z0_z0pow_g(1<<port);
+
+	if (lane&LN_R)
+		bmask |= Z0POW_reg_z0_z0pow_r(1<<port);
+
+	hdmi_rx_reg_mask32(Z0POW, ~bmask, enable?bmask:0, HDMI_RX_PHY);
+}
+
+void Z0_Calibration(void)
+{
+	/* Z0 disable,Z0 manual=11000 */
+	hdmi_rx_reg_mask32(Z0K, ~(Z0K_reg_z0_z0pow_mask|Z0K_reg_z0_stune_mask), 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(Z0K, ~(Z0K_reg_z0_adjr_0_mask|Z0K_reg_z0_adjr_1_mask|Z0K_reg_z0_adjr_2_mask),
+		(Z0K_reg_z0_adjr_0(ManualZ0)|Z0K_reg_z0_adjr_1(ManualZ0)|Z0K_reg_z0_adjr_2(ManualZ0)), HDMI_RX_PHY);
+}
+
+void HDMI_MHL_Mode_Detect_Sel(UINT8 bHDMI_mode)
+{
+	if (bHDMI_mode) {
+		hdmi_rx_reg_mask32(P0_CK1, ~p0_ck_2_CK_MD_REF_SEL, p0_ck_2_CK_MD_REF_SEL, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P1_CK1, ~p1_ck_2_CK_MD_REF_SEL, p1_ck_2_CK_MD_REF_SEL, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P2_CK1, ~p2_ck_2_CK_MD_REF_SEL, p2_ck_2_CK_MD_REF_SEL, HDMI_RX_PHY);
+	} else {
+		/* HHL mode */
+		hdmi_rx_reg_mask32(P0_CK1, ~p0_ck_2_CK_MD_REF_SEL, 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P1_CK1, ~p1_ck_2_CK_MD_REF_SEL, 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P2_CK1, ~p2_ck_2_CK_MD_REF_SEL, 0, HDMI_RX_PHY);
+	}
+}
+
+void Forground_EQ(void)
+{
+	/* Forground manual */
+	/* Port0 */
+	hdmi_rx_reg_mask32(P0_B1, ~(P1_b_1_FORE_KOFF_ADJR), _BIT20, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_G1, ~(P1_b_1_FORE_KOFF_ADJR), _BIT20, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_R1, ~(P1_b_1_FORE_KOFF_ADJR), _BIT20, HDMI_RX_PHY);
+
+	hdmi_rx_reg_mask32(P1_B1, ~(P1_b_1_FORE_KOFF_ADJR), _BIT20, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P1_G1, ~(P1_b_1_FORE_KOFF_ADJR), _BIT20, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P1_R1, ~(P1_b_1_FORE_KOFF_ADJR), _BIT20, HDMI_RX_PHY);
+
+	hdmi_rx_reg_mask32(P2_B1, ~(P1_b_1_FORE_KOFF_ADJR), _BIT20, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P2_G1, ~(P1_b_1_FORE_KOFF_ADJR), _BIT20, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P2_R1, ~(P1_b_1_FORE_KOFF_ADJR), _BIT20, HDMI_RX_PHY);
+
+	HDMIRX_DEBUG("[%s] EQ manual 0x%08x", __func__, hdmi_rx_reg_read32(P1_B1, HDMI_RX_PHY));
+}
+
+void Hdmi_TriggerbMeasurement(UINT8 bport)
+{
+	/* mode dect set release */
+	hdmi_rx_reg_mask32(REGD42, ~REGD42_p0_ck_md_rstb_mask, 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(REGD44, ~REGD44_p1_ck_md_rstb_mask, 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(REGD46, ~REGD46_p2_ck_md_rstb_mask, 0, HDMI_RX_PHY);
+
+	hdmi_rx_reg_mask32(REGD42, ~REGD42_p0_ck_md_rstb_mask, REGD42_p0_ck_md_rstb_mask, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(REGD44, ~REGD44_p1_ck_md_rstb_mask, REGD44_p1_ck_md_rstb_mask, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(REGD46, ~REGD46_p2_ck_md_rstb_mask, REGD46_p2_ck_md_rstb_mask, HDMI_RX_PHY);
+
+	/* HDMI_PRINTF("Hdmi_TriggerbMeasurement\n"); */
+	if (bport == 0)
+		hdmi_rx_reg_mask32(REGD43, ~REGD43_p0_ck_md_ok_mask, REGD43_p0_ck_md_ok_mask, HDMI_RX_PHY);
+	else if (bport == 1)
+		hdmi_rx_reg_mask32(REGD45, ~REGD45_p1_ck_md_ok_mask, REGD45_p1_ck_md_ok_mask, HDMI_RX_PHY);
+	else if (bport == 2)
+		hdmi_rx_reg_mask32(REGD47, ~REGD47_p2_ck_md_ok_mask, REGD47_p2_ck_md_ok_mask, HDMI_RX_PHY);
+
+	/* PMM clk detect function disable */
+	hdmi_rx_reg_mask32(CLKDETCR, ~_BIT0, 0, HDMI_RX_MAC);
+	/* Clr PMM clk detect flag */
+	hdmi_rx_reg_mask32(CLKDETSR, ~_BIT0, _BIT0, HDMI_RX_MAC);
+	/* PMM clk detect function enable */
+	hdmi_rx_reg_mask32(CLKDETCR, ~_BIT0, _BIT0, HDMI_RX_MAC);
+}
+
+void Hdmi_PhyInit(void)
+{
+	/* Enable bandgap power */
+	hdmi_rx_reg_mask32(BG, ~BG_reg_bg_pow_mask, BG_reg_bg_pow_mask, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(TOP_IN, ~(_BIT20|_BIT21), _BIT20, HDMI_RX_PHY);
+
+	/* Dfault hdmi mode (other :MHL3.0 mode ) */
+	HDMI_MHL_Mode_Detect_Sel(1);/* HDMI mode */
+
+	Forground_EQ();
+
+	/* Set z0 manual */
+	Z0_Calibration();
+
+	HDMI_MHL_Mode_Detect_Sel(1);
+}
+
+char Hdmi_IsbReady(void)
+{
+	if (hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC) & HDMI_Force_3G)/* For test CTS 3G */
+		return TRUE;
+
+	if (hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC) & MHL3_BYPASS_CBUS_CLK)
+		return TRUE;
+
+	if (REGD43_get_p0_ck_md_ok(hdmi_rx_reg_read32(REGD43, HDMI_RX_PHY)) == 0)
+		return FALSE;
+	else
+		return TRUE;
+
+	return TRUE;
+}
+
+int Hdmi_get_b_value(void)
+{
+	u_int8_t  bTimeout = 5;
+	int wValue;
+
+	if (hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC) & MHL3_BYPASS_CBUS_CLK)
+		return 710;
+
+
+	hdmi_rx_reg_mask32(REGD43, ~REGD43_p0_ck_md_ok_mask, REGD43_p0_ck_md_ok_mask, HDMI_RX_PHY);
+	do {
+		HDMI_DELAYMS(1);
+		bTimeout--;
+	} while ((!REGD43_get_p0_ck_md_ok(hdmi_rx_reg_read32(REGD43, HDMI_RX_PHY))) && (bTimeout));
+
+	/* HDMI_PRINTF("Hdmi_get_b_value = %d\n", bTimeout); */
+	if (bTimeout != 0) {
+		hdmi_rx_reg_mask32(REGD43, ~REGD43_p0_ck_md_ok_mask, REGD43_p0_ck_md_ok_mask, HDMI_RX_PHY);
+		wValue = REGD43_get_p0_ck_md_count(hdmi_rx_reg_read32(REGD43, HDMI_RX_PHY));
+	} else {
+		wValue = 0;
+	}
+
+	return wValue;
+}
+
+void hdmi_clear_b_struct(void)
+{
+	hdmi_ioctl_struct.b_pre = 0;
+	hdmi_ioctl_struct.b_count = 0;
+	hdmi_ioctl_struct.b  = 0;
+}
+
+void CMU_Reset(UINT8 benable)
+{
+	if (benable == 0) {
+		/* Release (power on) */
+		HDMI_PRINTF("CMU_Release\n");
+		hdmi_rx_reg_mask32(ENABLE, ~(ENABLE_reg_p0_en_cmu_mask), (ENABLE_reg_p0_en_cmu_mask), HDMI_RX_PHY);
+	} else {
+		/* Reset (power off) */
+		HDMI_PRINTF("CMU_Reset\n");
+		hdmi_rx_reg_mask32(ENABLE, ~(ENABLE_reg_p0_en_cmu_mask), (0), HDMI_RX_PHY);
+	}
+}
+
+void DEMUX_RESET(UINT8 benable)
+{
+	if (benable == 0) {
+		/* Release */
+		hdmi_rx_reg_mask32(RST, ~(RST_p0_r_demux_rstb_mask|RST_p0_g_demux_rstb_mask|RST_p0_b_demux_rstb_mask),
+			(RST_p0_r_demux_rstb_mask|RST_p0_g_demux_rstb_mask|RST_p0_b_demux_rstb_mask), HDMI_RX_PHY);
+
+		hdmi_rx_reg_mask32(RST, ~(RST_p0_ck_pllrstb_mask|RST_p0_ck_vcorstb_mask),
+			(RST_p0_ck_pllrstb_mask|RST_p0_ck_vcorstb_mask), HDMI_RX_PHY);
+
+		hdmi_rx_reg_mask32(RST, ~RST_dfe_rstn_n_mask, RST_dfe_rstn_n_mask, HDMI_RX_PHY);
+	} else {
+		hdmi_rx_reg_mask32(RST, ~RST_dfe_rstn_n_mask, 0, HDMI_RX_PHY);
+
+		hdmi_rx_reg_mask32(RST, ~(RST_p0_ck_pllrstb_mask|RST_p0_ck_vcorstb_mask),
+			0, HDMI_RX_PHY);
+
+		hdmi_rx_reg_mask32(RST, ~(RST_p0_r_demux_rstb_mask|RST_p0_g_demux_rstb_mask|RST_p0_b_demux_rstb_mask),
+			0, HDMI_RX_PHY);
+	}
+}
+
+
+void CDR_RESET(UINT8 benable)
+{
+	if (benable == 0) {
+		/* Release */
+		hdmi_rx_reg_mask32(REGD0,
+			~(REGD0_p0_r_dig_rst_n_mask | REGD0_p0_g_dig_rst_n_mask |
+			REGD0_p0_b_dig_rst_n_mask | REGD0_p0_r_cdr_rst_n_mask |
+			REGD0_p0_g_cdr_rst_n_mask | REGD0_p0_b_cdr_rst_n_mask),
+			(REGD0_p0_r_dig_rst_n_mask | REGD0_p0_g_dig_rst_n_mask |
+			REGD0_p0_b_dig_rst_n_mask | REGD0_p0_r_cdr_rst_n_mask |
+			REGD0_p0_g_cdr_rst_n_mask | REGD0_p0_b_cdr_rst_n_mask),
+			HDMI_RX_PHY);
+		/* HDMI_PRINTF("[HDMI] DEMUX_release\n"); */
+	} else {
+		/* Reset */
+		hdmi_rx_reg_mask32(REGD0, ~(REGD0_p0_r_dig_rst_n_mask|REGD0_p0_g_dig_rst_n_mask|REGD0_p0_b_dig_rst_n_mask),
+			0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(REGD0, ~(REGD0_p0_r_cdr_rst_n_mask|REGD0_p0_g_cdr_rst_n_mask|REGD0_p0_b_cdr_rst_n_mask),
+			0, HDMI_RX_PHY);
+		/* HDMI_PRINTF("[HDMI] CDR_RESET\n"); */
+	}
+}
+
+
+void DIC_AFIFO_ENABLE(u_int8_t enable)
+{
+	if (enable == 1) {
+		HDMI_PRINTF("DIC_AFIFO_ENABLE\n");
+		hdmi_rx_reg_mask32(CH_CR,
+			~(CH_CR_r_ch_afifo_en_mask|CH_CR_g_ch_afifo_en_mask|CH_CR_b_ch_afifo_en_mask),
+			(CH_CR_r_ch_afifo_en_mask|CH_CR_g_ch_afifo_en_mask|CH_CR_b_ch_afifo_en_mask), HDMI_RX_MAC);
+	} else {
+		hdmi_rx_reg_mask32(CH_CR,
+			~(CH_CR_r_ch_afifo_en_mask|CH_CR_g_ch_afifo_en_mask|CH_CR_b_ch_afifo_en_mask),
+			0, HDMI_RX_MAC);
+	}
+}
+
+void CLOSE_RST_MAC(void)
+{
+	hdmi_rx_reg_mask32(TMDS_DPC_SET0, ~(TMDS_DPC_SET0_dpc_en_mask), 0, HDMI_RX_MAC);
+	/* Dic fifio reset */
+	DIC_AFIFO_ENABLE(0);
+
+	/* Disable TMDS input */
+	hdmi_rx_reg_mask32(TMDS_PWDCTL,
+		~(TMDS_PWDCTL_ebip_mask|TMDS_PWDCTL_egip_mask|TMDS_PWDCTL_erip_mask|TMDS_PWDCTL_ecc_mask),
+		0, HDMI_RX_MAC);
+	/* HDMI&DVI function disable */
+	hdmi_rx_reg_mask32(TMDS_Z0CC, ~TMDS_Z0CC_hde_mask, 0, HDMI_RX_MAC);
+
+	/* Analog cdr reset */
+	CDR_RESET(1);
+	DEMUX_RESET(1);
+	CMU_Reset(1);
+}
+
+void OPEN_RST_MAC(void)
+{
+	hdmi_rx_reg_mask32(TMDS_Z0CC, ~TMDS_Z0CC_hde_mask, TMDS_Z0CC_hde(1), HDMI_RX_MAC);
+	usleep_range(1000, 1100);
+	HDMI_PRINTF("0xb800d01c=0x%x--MAC reset\n",
+		hdmi_rx_reg_read32(TMDS_PWDCTL, HDMI_RX_MAC));
+
+	/* Enable TMDS input */
+	hdmi_rx_reg_mask32(TMDS_PWDCTL,
+		~(TMDS_PWDCTL_ebip_mask|TMDS_PWDCTL_egip_mask|TMDS_PWDCTL_erip_mask|TMDS_PWDCTL_ecc_mask),
+		(TMDS_PWDCTL_ebip(1)|TMDS_PWDCTL_egip(1)|TMDS_PWDCTL_erip(1)|TMDS_PWDCTL_ecc(1)), HDMI_RX_MAC);
+
+	usleep_range(1000, 1100);
+	HDMI_PRINTF("0xb800d01c=0x%x--MAC set\n",
+		hdmi_rx_reg_read32(TMDS_PWDCTL, HDMI_RX_MAC));
+
+	DIC_AFIFO_ENABLE(1);
+	hdmi_rx_reg_mask32(TMDS_DPC_SET0, ~(TMDS_DPC_SET0_dpc_en_mask), TMDS_DPC_SET0_dpc_en_mask, HDMI_RX_MAC);
+}
+
+void DFE_POWER(u_int8_t enable)
+{
+	if (enable) {
+		hdmi_rx_reg_mask32(P0_B3, ~(P1_b_9_DFE_ADAPTION_POW_EN|P1_b_9_DFE_TAP_EN), (P1_b_9_DFE_ADAPTION_POW_EN|DFE_HDMI_RX_PHY_P1_b_tap_en(0x3)), HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P0_G3, ~(P1_b_9_DFE_ADAPTION_POW_EN|P1_b_9_DFE_TAP_EN), (P1_b_9_DFE_ADAPTION_POW_EN|DFE_HDMI_RX_PHY_P1_b_tap_en(0x3)), HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P0_R3, ~(P1_b_9_DFE_ADAPTION_POW_EN|P1_b_9_DFE_TAP_EN), (P1_b_9_DFE_ADAPTION_POW_EN|DFE_HDMI_RX_PHY_P1_b_tap_en(0x3)), HDMI_RX_PHY);
+	}
+}
+
+void SetClockBoundary(void)
+{
+	clock_bound_3g = TMDS_3G;
+	clock_bound_1p5g = TMDS_1p5G;
+	clock_bound_45m = 430;
+	clock_bound_110m = 1042;
+	HDMI_PRINTF("[HDMI] clock_bound_3g=%d\n", clock_bound_3g);
+}
+
+void EQ_bias_band_setting(u_int32_t b)
+{
+	UINT32 B1_addr, G1_addr, R1_addr;
+	UINT32 B2_addr, G2_addr, R2_addr;
+	UINT32 B3_addr, G3_addr, R3_addr;
+
+	DFE_POWER(1);
+
+	B1_addr = P0_B1;
+	B2_addr = P0_B2;
+	B3_addr = P0_B3;
+	G1_addr = P0_G1;
+	G2_addr = P0_G2;
+	G3_addr = P0_G3;
+	R1_addr = P0_R1;
+	R2_addr = P0_R2;
+	R3_addr = P0_R3;
+
+	SetClockBoundary();
+
+	if (b > clock_bound_3g) {
+		/* Over  3G HBR */
+
+#if 1/* QC 2016/01/18 */
+		/*B lane */
+		/* tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(B2_addr,
+			~(P0_b_7_TAP0_ISEL|P0_b_7_LEQ_ISEL|P0_b_6_LEQ_BIT_RATE|P0_b_6_TAP0_HBR|P0_b_5_LEQ_CURRENT_ADJ),
+			(P0_b_7_TAP0_ISEL_400uA|P0_b_7_LEQ_ISEL_400uA|P0_b_6_LEQ_BIT_RATE_HBR|P0_b_6_LEQ_BIT_RATE_HBR|P0_b_6_TAP0_HBR|P0_b_5_LEQ_CURRENT_ADJ_1p25X),
+			HDMI_RX_PHY);
+		/*G lane */
+		/* tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(G2_addr,
+			~(P0_g_7_TAP0_ISEL|P0_g_7_LEQ_ISEL|P0_g_6_LEQ_BIT_RATE|P0_g_6_TAP0_HBR|P0_g_5_LEQ_CURRENT_ADJ),
+			(P0_b_7_TAP0_ISEL_400uA|P0_b_7_LEQ_ISEL_400uA|P0_g_6_LEQ_BIT_RATE_HBR|P0_g_6_LEQ_BIT_RATE_HBR|P0_g_6_TAP0_HBR|P0_g_5_LEQ_CURRENT_ADJ_1p25X),
+			HDMI_RX_PHY);
+
+		/* R lane */
+		/* tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(R2_addr,
+			~(P0_r_7_TAP0_ISEL|P0_r_7_LEQ_ISEL|P0_r_6_LEQ_BIT_RATE|P0_r_6_TAP0_HBR|P0_r_5_LEQ_CURRENT_ADJ),
+			(P0_b_7_TAP0_ISEL_400uA|P0_b_7_LEQ_ISEL_400uA|P0_r_6_LEQ_BIT_RATE_HBR|P0_r_6_LEQ_BIT_RATE_HBR|P0_r_6_TAP0_HBR|P0_r_5_LEQ_CURRENT_ADJ_1p25X),
+			HDMI_RX_PHY);
+#endif
+
+		/* B */
+		hdmi_rx_reg_mask32(B3_addr,
+			~(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_mask|P0_b_10_DFE_PREAMP_ISEL_mask|P0_b_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_400uA|P0_b_10_DFE_PREAMP_ISEL_400uA|P0_b_10_DFE_SUMAMP_LP_MANUALOFF),
+			HDMI_RX_PHY);
+		/* G */
+		hdmi_rx_reg_mask32(G3_addr,
+			~(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_mask|P0_g_10_DFE_PREAMP_ISEL_mask|P0_g_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_400uA|P0_g_10_DFE_PREAMP_ISEL_400uA|P0_g_10_DFE_SUMAMP_LP_MANUALOFF),
+			HDMI_RX_PHY);
+		/* R */
+		hdmi_rx_reg_mask32(R3_addr,
+			~(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_mask|P0_r_10_DFE_PREAMP_ISEL_mask|P0_r_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_400uA|P0_r_10_DFE_PREAMP_ISEL_400uA|P0_r_10_DFE_SUMAMP_LP_MANUALOFF),
+			HDMI_RX_PHY);
+
+		/* LEQ_BIT_RATE */
+#if 1/* QC 2016/01/18 */
+		hdmi_rx_reg_mask32(B1_addr, ~(P1_b_2_LEQ_BIT_RATE_mask|P0_b_CLK_PIX2_RATE_SEL), P1_b_2_LEQ_BIT_RATE_HBR, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G1_addr, ~(P1_g_2_LEQ_BIT_RATE_mask|P0_g_CLK_PIX2_RATE_SEL), P1_g_2_LEQ_BIT_RATE_HBR, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R1_addr, ~(P1_r_2_LEQ_BIT_RATE_mask|P0_r_CLK_PIX2_RATE_SEL), P1_r_2_LEQ_BIT_RATE_HBR, HDMI_RX_PHY);
+#endif
+
+		/* PI_SEL  & pr bypass */
+		hdmi_rx_reg_mask32(B2_addr, ~(P1_b_7_PI_ISEL|P1_b_8_BY_PASS_PR|P1_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G2_addr, ~(P1_g_7_PI_ISEL|P1_g_8_BY_PASS_PR|P1_g_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R2_addr, ~(P1_r_7_PI_ISEL|P1_r_8_BY_PASS_PR|P1_r_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+
+		/* PR sel */
+		if ((b > TMDS_5G) && (b < TMDS_6G)) {
+			/* 5G~6G */
+			/* B */
+			hdmi_rx_reg_mask32(B3_addr, ~P0_b_12_PR, 0, HDMI_RX_PHY);
+			/* G */
+			hdmi_rx_reg_mask32(G3_addr, ~P0_g_12_PR, 0, HDMI_RX_PHY);
+			/* R */
+			hdmi_rx_reg_mask32(R3_addr, ~P0_r_12_PR, 0, HDMI_RX_PHY);
+		} else if ((b > TMDS_4G) && (b < TMDS_5G)) {
+			/* 4G~5G */
+			/* B */
+			hdmi_rx_reg_mask32(B3_addr, ~P0_b_12_PR, _BIT24, HDMI_RX_PHY);
+			/* G */
+			hdmi_rx_reg_mask32(G3_addr, ~P0_g_12_PR, _BIT24, HDMI_RX_PHY);
+			/*R */
+			hdmi_rx_reg_mask32(R3_addr, ~P0_r_12_PR, _BIT24, HDMI_RX_PHY);
+		} else {
+			/* 3G~ 4G */
+			/* B */
+			hdmi_rx_reg_mask32(B3_addr, ~P0_b_12_PR, _BIT25, HDMI_RX_PHY);
+			/* G */
+			hdmi_rx_reg_mask32(G3_addr, ~P0_g_12_PR, _BIT25, HDMI_RX_PHY);
+			/* R */
+			hdmi_rx_reg_mask32(R3_addr, ~P0_r_12_PR, _BIT25, HDMI_RX_PHY);
+		}
+		HDMI_PRINTF("bias_band > 3G\n");
+
+	} else if (b > clock_bound_1p5g) {
+		/* 3G ~1.5G */
+
+		/* B lane, tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(B2_addr,
+			~(P0_b_7_TAP0_ISEL|P0_b_7_LEQ_ISEL|P0_b_6_LEQ_BIT_RATE|P0_b_6_TAP0_HBR|P0_b_5_LEQ_CURRENT_ADJ),
+			(P0_b_7_TAP0_ISEL_400uA|P0_b_7_LEQ_ISEL_200uA|P0_b_6_LEQ_BIT_RATE_MBR|P0_b_6_TAP0_HBR|P0_b_5_LEQ_CURRENT_ADJ_1X),
+			HDMI_RX_PHY);
+
+		/* G lane, tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(G2_addr,
+			~(P0_g_7_TAP0_ISEL|P0_g_7_LEQ_ISEL|P0_g_6_LEQ_BIT_RATE|P0_g_6_TAP0_HBR|P0_g_5_LEQ_CURRENT_ADJ),
+			(P0_g_7_TAP0_ISEL_400uA|P0_g_7_LEQ_ISEL_200uA|P0_g_6_LEQ_BIT_RATE_MBR|P0_g_6_TAP0_HBR|P0_g_5_LEQ_CURRENT_ADJ_1X),
+			HDMI_RX_PHY);
+
+		/* R lane, tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(R2_addr,
+			~(P0_r_7_TAP0_ISEL|P0_r_7_LEQ_ISEL|P0_r_6_LEQ_BIT_RATE|P0_r_6_TAP0_HBR|P0_r_5_LEQ_CURRENT_ADJ),
+			(P0_r_7_TAP0_ISEL_400uA|P0_r_7_LEQ_ISEL_200uA|P0_r_6_LEQ_BIT_RATE_MBR|P0_r_6_TAP0_HBR|P0_r_5_LEQ_CURRENT_ADJ_1X),
+			HDMI_RX_PHY);
+
+		/* B */
+		hdmi_rx_reg_mask32(B3_addr,
+			~(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_mask|P0_b_10_DFE_PREAMP_ISEL_mask|P0_b_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_400uA|P0_b_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+
+		/* G */
+		hdmi_rx_reg_mask32(G3_addr,
+			~(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_mask|P0_g_10_DFE_PREAMP_ISEL_mask|P0_g_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_400uA|P0_g_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+
+		/* R */
+		hdmi_rx_reg_mask32(R3_addr,
+			~(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_mask|P0_r_10_DFE_PREAMP_ISEL_mask|P0_r_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_400uA|P0_r_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+
+		/* LEQ_BIT_RATE */
+#if 1/* QC 2016/01/18 */
+		hdmi_rx_reg_mask32(B1_addr, ~(P1_b_2_LEQ_BIT_RATE_mask|P0_b_CLK_PIX2_RATE_SEL), (P1_b_2_LEQ_BIT_RATE_MBR|P0_b_CLK_PIX2_RATE_SEL), HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G1_addr, ~(P1_g_2_LEQ_BIT_RATE_mask|P0_g_CLK_PIX2_RATE_SEL), (P1_g_2_LEQ_BIT_RATE_MBR|P0_g_CLK_PIX2_RATE_SEL), HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R1_addr, ~(P1_r_2_LEQ_BIT_RATE_mask|P0_r_CLK_PIX2_RATE_SEL), (P1_r_2_LEQ_BIT_RATE_MBR|P0_r_CLK_PIX2_RATE_SEL), HDMI_RX_PHY);
+#endif
+
+		/* PI_SEL  & pr bypass */
+		hdmi_rx_reg_mask32(B2_addr, ~(P1_b_7_PI_ISEL|P1_b_8_BY_PASS_PR|P1_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G2_addr, ~(P1_g_7_PI_ISEL|P1_g_8_BY_PASS_PR|P1_g_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R2_addr, ~(P1_r_7_PI_ISEL|P1_r_8_BY_PASS_PR|P1_r_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		HDMI_PRINTF("Bias_band = 1.5G~3G\n");
+	} else {
+		/* Under 1.5G */
+
+		/* B lane, tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+#if 1/* QC 2016/01/18 */
+		hdmi_rx_reg_mask32(B2_addr,
+			~(P0_b_7_TAP0_ISEL|P0_b_7_LEQ_ISEL|P0_b_6_LEQ_BIT_RATE|P0_b_6_TAP0_HBR|P0_b_5_LEQ_CURRENT_ADJ),
+			(P0_b_5_LEQ_CURRENT_ADJ_1X|P0_b_7_TAP0_ISEL_400uA),
+			HDMI_RX_PHY);
+
+		/* G lane, tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(G2_addr,
+			~(P0_g_7_TAP0_ISEL|P0_g_7_LEQ_ISEL|P0_g_6_LEQ_BIT_RATE|P0_g_6_TAP0_HBR|P0_g_5_LEQ_CURRENT_ADJ),
+			(P0_g_5_LEQ_CURRENT_ADJ_1X|P0_g_7_TAP0_ISEL_400uA),
+			HDMI_RX_PHY);
+
+		/* R lane, tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(R2_addr,
+			~(P0_r_7_TAP0_ISEL|P0_r_7_LEQ_ISEL|P0_r_6_LEQ_BIT_RATE|P0_r_6_TAP0_HBR|P0_r_5_LEQ_CURRENT_ADJ),
+			(P0_r_5_LEQ_CURRENT_ADJ_1X|P0_r_7_TAP0_ISEL_400uA),
+			HDMI_RX_PHY);
+#endif
+
+		/* B */
+		hdmi_rx_reg_mask32(B3_addr,
+			~(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_mask|P0_b_10_DFE_PREAMP_ISEL_mask|P0_b_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_400uA|P0_b_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+
+		/* G */
+		hdmi_rx_reg_mask32(G3_addr,
+			~(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_mask|P0_g_10_DFE_PREAMP_ISEL_mask|P0_g_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_400uA|P0_g_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+
+		/* R */
+		hdmi_rx_reg_mask32(R3_addr,
+			~(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_mask|P0_r_10_DFE_PREAMP_ISEL_mask|P0_r_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_400uA|P0_r_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+
+		/* LEQ_BIT_RATE */
+#if 1/* QC 2016/01/18 */
+		hdmi_rx_reg_mask32(B1_addr, ~(P1_b_2_LEQ_BIT_RATE_mask|P0_b_CLK_PIX2_RATE_SEL), P0_b_CLK_PIX2_RATE_SEL, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G1_addr, ~(P1_g_2_LEQ_BIT_RATE_mask|P0_g_CLK_PIX2_RATE_SEL), P0_g_CLK_PIX2_RATE_SEL, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R1_addr, ~(P1_r_2_LEQ_BIT_RATE_mask|P0_r_CLK_PIX2_RATE_SEL), P0_r_CLK_PIX2_RATE_SEL, HDMI_RX_PHY);
+#endif
+
+		/* PI_SEL  & pr bypass */
+		hdmi_rx_reg_mask32(B2_addr, ~(P1_b_7_PI_ISEL|P1_b_8_BY_PASS_PR|P1_b_6_LEQ_PASSIVE_CORNER), _BIT16, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G2_addr, ~(P1_g_7_PI_ISEL|P1_g_8_BY_PASS_PR|P1_g_6_LEQ_PASSIVE_CORNER), _BIT16, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R2_addr, ~(P1_r_7_PI_ISEL|P1_r_8_BY_PASS_PR|P1_r_6_LEQ_PASSIVE_CORNER), _BIT16, HDMI_RX_PHY);
+		HDMI_PRINTF("bias_band <1.5G\n");
+	}
+
+}
+
+void HDMI_Set_Phy_Table(u_int8_t mode)
+{
+	u_int32_t wReg1, wReg2, wCk1Reg, wCk2Reg, ck_md_sel;
+	u_int32_t B2Reg, G2REG, R2REG;
+
+	wReg1 = REGD16;
+	wReg2 = REGD0;
+	wCk1Reg = P0_CK1;
+	B2Reg = P0_B2;
+	G2REG = P0_G2;
+	R2REG = P0_R2;
+	wCk2Reg = P0_CK2;
+	ck_md_sel = REGD42;
+
+	/* Set M & N & PI_DIV & DEMUX   */
+	/* M code */
+	hdmi_rx_reg_mask32(wReg1, ~REGD16_reg_p0_n_code_mask,
+		hdmi_phy_param[mode].M_code<<REGD16_reg_p0_n_code_shift, HDMI_RX_PHY);
+	/* N code */
+	hdmi_rx_reg_mask32(wCk1Reg, ~(p1_ck_3_CMU_N_code|p1_ck_3_CMU_PREDIVN),
+		hdmi_phy_param[mode].N_code<<P0_CK1_reg_p0_ck_3_CMU_N_code_shift, HDMI_RX_PHY);
+
+	/* PI_DIV code */
+	hdmi_rx_reg_mask32(B2Reg, ~P0_b_8_PR_RATE_SEL, hdmi_phy_param[mode].PI_DIV<<P0_B2_reg_p0_b_8_PR_RATE_SEL_shift, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(G2REG, ~P0_b_8_PR_RATE_SEL, hdmi_phy_param[mode].PI_DIV<<P0_B2_reg_p0_b_8_PR_RATE_SEL_shift, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(R2REG, ~P0_b_8_PR_RATE_SEL, hdmi_phy_param[mode].PI_DIV<<P0_B2_reg_p0_b_8_PR_RATE_SEL_shift, HDMI_RX_PHY);
+
+	/* DEMUX code */
+	hdmi_rx_reg_mask32(B2Reg, ~P0_b_8_DEMUX, hdmi_phy_param[mode].DEMUX<<P0_B2_reg_p0_b_8_DEMUX_shift, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(G2REG, ~P0_b_8_DEMUX, hdmi_phy_param[mode].DEMUX<<P0_B2_reg_p0_b_8_DEMUX_shift, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(R2REG, ~P0_b_8_DEMUX, hdmi_phy_param[mode].DEMUX<<P0_B2_reg_p0_b_8_DEMUX_shift, HDMI_RX_PHY);
+
+	/* LDO enable, CMU VCO select */
+	hdmi_rx_reg_mask32(wCk2Reg,
+		~(P0_ck_5_CMU_SEL_R1_mask | P0_ck_5_CMU_SEL_PUMP_I_mask |
+		P0_ck_6_CMU_BIG_KVCO_mask | P0_ck_7_CMU_BYPASS_PI_mask |
+		P0_ck_8_LDO_EN_mask | P0_ck_8_VSEL_LDO_D_mask |
+		P0_ck_8_VSEL_LDO_A_mask),
+		((hdmi_phy_param[mode].CK_RS<<0) | (hdmi_phy_param[mode].CK_Icp<<4) |
+		P0_ck_6_CMU_BIG_KVCO_mask | P0_ck_7_CMU_BYPASS_PI_mask | P0_ck_8_LDO_EN_mask |
+		DFE_HDMI_RX_PHY_P0_VSEL_LDO_A(hdmi_phy_param[mode].vsel_ldo)),
+		HDMI_RX_PHY);
+
+	/* KP set */
+	hdmi_rx_reg_mask32(wReg2,
+		~(REGD0_reg_p0_kp_mask|REGD0_reg_p0_bypass_sdm_int_mask|REGD5_reg_p1_rate_sel_mask),
+		((hdmi_phy_param[mode].CDR_KP<<REGD0_reg_p0_kp_shift)|REGD0_reg_p0_bypass_sdm_int_mask|(REGD5_reg_p1_rate_sel(hdmi_phy_param[mode].RATE_SEL))),
+		HDMI_RX_PHY);
+
+	hdmi_rx_reg_mask32(ck_md_sel, ~REGD42_reg_p0_ck_md_sel_mask, REGD42_reg_p0_ck_md_sel(0), HDMI_RX_PHY);
+
+#if 1/* QC 2016/01/18 */
+	hdmi_rx_reg_mask32(wCk2Reg, ~(P1_ck_6_CMU_SEL_CS_mask), hdmi_phy_param[mode].CK_CS<<8, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(wReg2, ~(REGD0_reg_p0_ki_mask), hdmi_phy_param[mode].CDR_KI<<REGD0_reg_p0_ki_shift, HDMI_RX_PHY);
+#endif
+}
+
+void PHY_DFE_Setting(UINT8 mode)
+{
+	hdmi_rx_reg_mask32(REGD21,
+		~(REGD28_reg_p1_auto_mode_mask | REGD28_reg_p1_adp_en_manual_mask | REGD28_reg_p1_adp_time_mask |
+		REGD28_reg_p1_calib_time_mask | REGD28_reg_p1_calib_late_mask | REGD28_reg_p1_vco_coarse_mask |
+		REGD28_reg_p1_divide_num_mask | REGD28_reg_p1_init_time_mask),
+		(REGD28_reg_p1_adp_en_manual_mask | _BIT25 | _BIT20 | _BIT18 | _BIT16 | _BIT15 | _BIT9 | _BIT7 | _BIT1),
+		HDMI_RX_PHY);
+
+
+	hdmi_rx_reg_mask32(REGD24, ~(REGD31_reg_p1_cp_time_mask|REGD31_reg_p1_timer_4_mask), (REGD31_reg_p1_cp_time(4)|REGD31_reg_p1_timer_4(2)), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(REGD25, ~(REGD32_reg_p1_timer_5_mask|REGD32_reg_p1_timer_6_mask), REGD32_reg_p1_timer_6(7), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(REGD26,
+		~(REGD33_reg_p1_rxidle_bypass_mask|REGD33_reg_p1_slope_band_mask|REGD33_reg_p1_old_mode_mask|_BIT15),
+		(REGD33_reg_p1_rxidle_bypass_mask|REGD33_reg_p1_slope_band(8)|_BIT15),
+		HDMI_RX_PHY);
+
+	/* Digital part Reg setting */
+	hdmi_rx_reg_mask32(PHY_FIFO_CR,
+		~(PHY_FIFO_CR_port0_b_afifo_en_mask | PHY_FIFO_CR_port0_b_flush_mask |
+		PHY_FIFO_CR_port0_g_afifo_en_mask | PHY_FIFO_CR_port0_g_flush_mask |
+		PHY_FIFO_CR_port0_r_afifo_en_mask | PHY_FIFO_CR_port0_r_flush_mask),
+		(PHY_FIFO_CR_port0_b_afifo_en_mask | PHY_FIFO_CR_port0_b_flush_mask |
+		PHY_FIFO_CR_port0_g_afifo_en_mask | PHY_FIFO_CR_port0_g_flush_mask |
+		PHY_FIFO_CR_port0_r_afifo_en_mask | PHY_FIFO_CR_port0_r_flush_mask),
+		HDMI_RX_MAC);
+}
+
+void DFE_second_flow(void)
+{
+	UINT8 bLan0_TAP0Max;
+	UINT8 bLan1_TAP0Max;
+	UINT8 bLan2_TAP0Max;
+
+	HDMI_PRINTF("[DFE open] ENABLE  VTH & TAP0\n");
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~REG_DFE_READBACK_record_limit_en_mask, REG_DFE_READBACK_record_limit_en(1), HDMI_RX_DEF);
+	HDMI_PRINTF("[DFE open] ENABLE  VTH & TAP0\n");
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~REG_DFE_READBACK_record_limit_en_mask, REG_DFE_READBACK_record_limit_en(0), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0, ~(REG_dfe_adapt_en_lane0_TAP0|REG_dfe_adapt_en_lane0_Vth), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1, ~(REG_dfe_adapt_en_lane1_TAP0|REG_dfe_adapt_en_lane1_Vth), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2, ~(REG_dfe_adapt_en_lane2_TAP0|REG_dfe_adapt_en_lane2_Vth), 0, HDMI_RX_DEF);
+
+	/* Read Tap0 max */
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_lane_mask, 0<<limit_set_lane_shift, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_mask, 0, HDMI_RX_DEF);
+	usleep_range(10000, 11000);
+	bLan0_TAP0Max = get_Tap0_max(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+	HDMI_PRINTF("[DFE open] TAP0 MAX lane0 =%x\n", bLan0_TAP0Max);
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_lane_mask, 1<<limit_set_lane_shift, HDMI_RX_DEF);
+	bLan1_TAP0Max = get_Tap0_max(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+	HDMI_PRINTF("[DFE open] TAP0 MAX lane1 =%x\n", bLan1_TAP0Max);
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_lane_mask, 2<<limit_set_lane_shift, HDMI_RX_DEF);
+	bLan2_TAP0Max = get_Tap0_max(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+	HDMI_PRINTF("[DFE open] TAP0 MAX lane2 =%x\n", bLan2_TAP0Max);
+
+	/* LOAD TAP0 max -1  & Vth 4 */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+		~(REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		(REG_DFE_INIT0_L0_tap0_init_lane0(bLan0_TAP0Max-1))|REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+		~(REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		(REG_DFE_INIT0_L0_tap0_init_lane0(bLan1_TAP0Max-1))|REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+		~(REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		(REG_DFE_INIT0_L0_tap0_init_lane0(bLan2_TAP0Max-1))|REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DEF);
+
+	/* Load initial data */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0,
+		~(load_in_init_lane0_tap0|load_in_init_lane0_vth),
+		(load_in_init_lane0_tap0|load_in_init_lane0_vth), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1,
+		~(load_in_init_lane0_tap0|load_in_init_lane0_vth),
+		(load_in_init_lane0_tap0|load_in_init_lane0_vth), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2,
+		~(load_in_init_lane0_tap0|load_in_init_lane0_vth),
+		(load_in_init_lane0_tap0|load_in_init_lane0_vth), HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(load_in_init_lane0_tap0|load_in_init_lane0_vth), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(load_in_init_lane0_tap0|load_in_init_lane0_vth), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(load_in_init_lane0_tap0|load_in_init_lane0_vth), 0, HDMI_RX_DEF);
+
+}
+
+void PHY_FORE_KOFF(void)
+{
+	UINT32 w_b_addr_control;
+	UINT32 w_g_addr_control;
+	UINT32 w_r_addr_control;
+	UINT32 w_b_addr_result;
+	UINT32 w_g_addr_result;
+	UINT32 w_r_addr_result;
+	UINT32 koff_r_result;
+	UINT32 koff_g_result;
+	UINT32 koff_b_result;
+	UINT8 i;
+	UINT8 j;
+
+	w_b_addr_control = P0_B1;
+	w_g_addr_control = P0_G1;
+	w_r_addr_control = P0_R1;
+	w_b_addr_result = P0_B4;
+	w_g_addr_result = P0_G4;
+	w_r_addr_result = P0_R4;
+
+	/* Initial circuit power */
+	hdmi_rx_reg_mask32(w_b_addr_control, ~(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK|P0_b_4_FORE_POW_FORE_KOFF),
+		(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_g_addr_control, ~(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK|P0_b_4_FORE_POW_FORE_KOFF),
+		(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_r_addr_control, ~(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK|P0_b_4_FORE_POW_FORE_KOFF),
+		(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK), HDMI_RX_PHY);
+	/* Cut input off */
+	hdmi_rx_reg_mask32(w_b_addr_control, ~(P0_b_1_inputoff), P0_b_1_inputoff, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_g_addr_control, ~(P0_b_1_inputoff), P0_b_1_inputoff, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_r_addr_control, ~(P0_b_1_inputoff), P0_b_1_inputoff, HDMI_RX_PHY);
+
+	/* For b lane */
+	for (i = 0; i < Fore_Koff_Range+1; i++) {
+#if Fore_Koff_FIX
+		hdmi_rx_reg_mask32(w_b_addr_control, ~(P0_b_4_FORE_POW_FORE_KOFF), 0, HDMI_RX_PHY);
+#endif
+		/* Set k off range */
+		hdmi_rx_reg_mask32(w_b_addr_control, ~(P0_b_1_FORE_KOFF_RANGE), i<<21, HDMI_RX_PHY);
+		/* Start cal */
+		hdmi_rx_reg_mask32(w_b_addr_control, ~(P0_b_4_FORE_POW_FORE_KOFF), P0_b_4_FORE_POW_FORE_KOFF, HDMI_RX_PHY);
+
+		/* Wait finish cal */
+		j = 0;
+		while (!((hdmi_rx_reg_read32(w_b_addr_result, HDMI_RX_PHY)) & P0_B4_reg_p0_b_koffok_mask)) {
+			if (j >= 3) {
+				HDMIRX_INFO("Wait b lane koff timeout\n");
+				break;
+			}
+			usleep_range(10000, 11000);/* Wait for koffok */
+			j++;
+		}
+
+		if (hdmi_rx_reg_read32(w_b_addr_result, HDMI_RX_PHY) & P0_B4_reg_p0_b_koff_bound_mask)
+
+		/* For dummy write , or koff_g_result can't up date */
+		koff_b_result = 0x01;
+		koff_b_result = P0_B4_get_reg_p0_b_koff_sel(hdmi_rx_reg_read32(w_b_addr_result, HDMI_RX_PHY));
+
+		if (!(hdmi_rx_reg_read32(w_b_addr_result, HDMI_RX_PHY) & P0_B4_reg_p0_b_koff_bound_mask)) {
+			HDMI_PRINTF("PHY_FORE_KOFF range =%x OK ! B lane fore =0x%x\n",
+				i, koff_b_result);
+			break;
+		}
+
+		HDMI_PRINTF("PHY_FORE_KOFF range%u out of B range\n", i);
+
+	}
+
+
+	/* For g lane */
+	for (i = 0; i < Fore_Koff_Range+1; i++) {
+#if  Fore_Koff_FIX
+		hdmi_rx_reg_mask32(w_g_addr_control, ~(P0_b_4_FORE_POW_FORE_KOFF), 0, HDMI_RX_PHY);
+#endif
+		/* Set k off range */
+		hdmi_rx_reg_mask32(w_g_addr_control, ~(P0_b_1_FORE_KOFF_RANGE), i<<21, HDMI_RX_PHY);
+
+		/* Start cal */
+		hdmi_rx_reg_mask32(w_g_addr_control, ~(P0_b_4_FORE_POW_FORE_KOFF), P0_b_4_FORE_POW_FORE_KOFF, HDMI_RX_PHY);
+
+		/* Wait finish cal */
+		j = 0;
+		while (!((hdmi_rx_reg_read32(w_g_addr_result, HDMI_RX_PHY)) & P0_B4_reg_p0_b_koffok_mask)) {
+			if (j >= 3) {
+				HDMIRX_INFO("Wait g lane koff timeout\n");
+				break;
+			}
+			usleep_range(10000, 11000);/* Wait for koffok */
+			j++;
+		}
+
+		if (hdmi_rx_reg_read32(w_g_addr_result, HDMI_RX_PHY) & P0_B4_reg_p0_b_koff_bound_mask)
+			koff_g_result = 0x01;/* For dummy write , or koff_g_result can't up date */
+
+		koff_g_result = P0_B4_get_reg_p0_b_koff_sel(hdmi_rx_reg_read32(w_g_addr_result, HDMI_RX_PHY));
+
+		if (!(hdmi_rx_reg_read32(w_g_addr_result, HDMI_RX_PHY) & P0_B4_reg_p0_b_koff_bound_mask)) {
+			HDMI_PRINTF("PHY_FORE_KOFF range =%d OK ! G lane fore =%x\n",
+				i, koff_g_result);
+			break;
+		}
+
+		HDMI_PRINTF("PHY_FORE_KOFF range%u out of G range\n", i);
+	}
+
+
+	/* For r lane */
+	for (i = 0; i < 3+1; i++) {
+#if Fore_Koff_FIX
+		hdmi_rx_reg_mask32(w_r_addr_control, ~(P0_b_4_FORE_POW_FORE_KOFF), 0, HDMI_RX_PHY);
+#endif
+		/* Set k off range */
+		hdmi_rx_reg_mask32(w_r_addr_control, ~(P0_b_1_FORE_KOFF_RANGE), i<<21, HDMI_RX_PHY);
+
+		/* Start cal */
+		hdmi_rx_reg_mask32(w_r_addr_control, ~(P0_b_4_FORE_POW_FORE_KOFF), P0_b_4_FORE_POW_FORE_KOFF, HDMI_RX_PHY);
+
+		/* Wait finish cal */
+		/* QC 2016/01/18 */
+		j = 0;
+		while (!((hdmi_rx_reg_read32(w_r_addr_result, HDMI_RX_PHY))&P0_B4_reg_p0_b_koffok_mask)) {
+			if (j >= 3) {
+				HDMIRX_INFO("Wait R lane koff timeout\n");
+				break;
+			}
+			usleep_range(10000, 11000);/* Wait for koffok */
+			j++;
+		}
+
+		if (hdmi_rx_reg_read32(w_r_addr_result, HDMI_RX_PHY) & P0_B4_reg_p0_b_koff_bound_mask)
+			koff_r_result = 0x01;/* For dummy write , or koff_g_result can't up date */
+
+		koff_r_result = P0_B4_get_reg_p0_b_koff_sel(hdmi_rx_reg_read32(w_r_addr_result, HDMI_RX_PHY));
+
+		if (!(hdmi_rx_reg_read32(w_r_addr_result, HDMI_RX_PHY) & P0_B4_reg_p0_b_koff_bound_mask)) {
+			HDMI_PRINTF("PHY_FORE_KOFF range =%x OK ! R lane fore =0x%x\n",
+				i, koff_r_result);
+			break;
+		}
+
+		HDMI_PRINTF("PHY_FORE_KOFF range%u out of R range\n", i);
+	}
+
+	/* Cut input on */
+	hdmi_rx_reg_mask32(w_b_addr_control, ~(P0_b_1_inputoff), 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_g_addr_control, ~(P0_b_1_inputoff), 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_r_addr_control, ~(P0_b_1_inputoff), 0, HDMI_RX_PHY);
+
+	HDMI_PRINTF("PHY_FORE_KOFF B lane fore =%x ,G lane fore =%x,R lane fore =%x\n",
+		koff_b_result, koff_g_result, koff_r_result);
+
+}
+
+void LOAD_LE_MAX(void)
+{
+	UINT8 bLan0_LEMax;
+	UINT8 bLan1_LEMax;
+	UINT8 bLan2_LEMax;
+
+	/* Read Tap0 max */
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_lane_mask, 0<<limit_set_lane_shift, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_mask, limit_sel(4), HDMI_RX_DEF);
+
+	bLan0_LEMax = get_Tap0_max(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_lane_mask, 1<<limit_set_lane_shift, HDMI_RX_DEF);
+	bLan1_LEMax = get_Tap0_max(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_lane_mask, 2<<limit_set_lane_shift, HDMI_RX_DEF);
+	bLan2_LEMax = get_Tap0_max(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+
+	HDMI_PRINTF("[PHY][DFE open] LE MAX lane0 =0x%x\n", bLan0_LEMax);
+	HDMI_PRINTF("[PHY][DFE open] LE MAX lane1 =0x%x\n", bLan1_LEMax);
+	HDMI_PRINTF("[PHY][DFE open] LE MAX lane2 =0x%x\n", bLan2_LEMax);
+
+    /* Load LE max */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0, ~(REG_DFE_INIT0_L0_tap1_init_lane0_mask), (REG_DFE_INIT0_L0_tap1_init_lane0(bLan0_LEMax)), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1, ~(REG_DFE_INIT0_L0_tap1_init_lane0_mask), (REG_DFE_INIT0_L0_tap1_init_lane0(bLan1_LEMax)), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2, ~(REG_DFE_INIT0_L0_tap1_init_lane0_mask), (REG_DFE_INIT0_L0_tap1_init_lane0(bLan2_LEMax)), HDMI_RX_DEF);
+
+	/* Load initial data */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(load_in_init_lane0_tap1), (load_in_init_lane0_tap1), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(load_in_init_lane0_tap1), (load_in_init_lane0_tap1), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(load_in_init_lane0_tap1), (load_in_init_lane0_tap1), HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(load_in_init_lane0_tap1), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(load_in_init_lane0_tap1), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(load_in_init_lane0_tap1), 0, HDMI_RX_DEF);
+}
+
+void Dump_DFE_Para(u_int8_t lane)
+{
+	UINT8 bLEmax;
+	UINT8 bLEmin;
+	UINT8 bTap0min;
+	UINT8 bTap0max;
+	UINT8 bTap1;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_lane_mask, lane<<limit_set_lane_shift, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_mask, 0, HDMI_RX_DEF);
+
+	bTap0max = get_Tap0_max(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_mask, limit_sel(1), HDMI_RX_DEF);
+
+	bTap0min = get_Tap0_min(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_mask, limit_sel(4), HDMI_RX_DEF);
+
+	bLEmax = get_LEQ_max(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~limit_set_mask, limit_sel(5), HDMI_RX_DEF);
+
+	bLEmin = get_LEQ_min(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+
+	/* Read DFE result */
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~coef_set_lane_mask, lane<<coef_set_lane_shift, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~coef_set_mask, 0, HDMI_RX_DEF);
+
+	HDMI_PRINTF("[PHY] ********************Lane%d******************\n", lane);
+	HDMI_PRINTF("[PHY] Lane%d Tap0 max = 0x%02x, min = 0x%02x\n", lane, bTap0max, bTap0min);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~coef_set_mask, coef_sel(1), HDMI_RX_DEF);
+
+	HDMI_PRINTF("[PHY] Lane%d COEF Tap0=0x%02x\n",
+		lane, get_TAP0_coef(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF)));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~coef_set_mask, coef_sel(2), HDMI_RX_DEF);
+
+	bTap1 = get_TAP1_coef(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~coef_set_mask, coef_sel(3), HDMI_RX_DEF);
+
+	HDMI_PRINTF("Tap1=0x%02x, Tap2=%+d\n",
+		bTap1, (get_TAP2_coef_sign(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF))) ?
+		-get_TAP2_coef(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF)) : get_TAP2_coef(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF)));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~coef_set_mask, coef_sel(7), HDMI_RX_DEF);
+
+	HDMI_PRINTF("[PHY] Lane%d LE max = 0x%02x, min = 0x%02x\n", lane, bLEmax, bLEmin);
+
+	HDMI_PRINTF("[PHY] Lane%d LE COEF = 0x%x\n\n",
+		lane, get_LE1_coef(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DEF)));
+
+}
+
+void HDMI_MAG2_SetDFE(int b, int dfe_mode)
+{
+	HDMI_PRINTF("[PHY][%s] b(%d) dfe_mode(%d)\n", __func__, b, dfe_mode);
+	/* Script file */
+	hdmi_rx_reg_mask32(REG_DFE_MODE,
+		~(REG_DFE_MODE_adapt_mode_mask |
+		REG_DFE_MODE_edge_det_mode_mask |
+		REG_DFE_MODE_transition_only_mask |
+		REG_DFE_MODE_tap1_delay_mask |
+		REG_DFE_MODE_tap24_delay_mask |
+		REG_DFE_MODE_le_delay_mask |
+		REG_DFE_MODE_servo_delay_mask |
+		REG_DFE_MODE_gray_en_mask |
+		REG_DFE_MODE_dfe_adapt_rstb_mask |
+		REG_DFE_MODE_tap0_notrans_mask |
+		REG_DFE_MODE_servo_notrans_mask),
+		(REG_DFE_MODE_adapt_mode(dfe_mode) |
+		REG_DFE_MODE_edge_det_mode(0) |
+		REG_DFE_MODE_transition_only_mask |
+		REG_DFE_MODE_tap1_delay(1) |
+		REG_DFE_MODE_tap24_delay(1) |
+		REG_DFE_MODE_le_delay(1) |
+		REG_DFE_MODE_gray_en_mask |
+		REG_DFE_MODE_tap0_notrans_mask |
+		REG_DFE_MODE_servo_notrans_mask |
+		_BIT16),
+		HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_DFE_EN_L0_clk_inv_lane0_mask |
+		REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask |
+		REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask |
+		REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask |
+		REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		(REG_DFE_EN_L2_timer_ctrl_en_lane2_mask | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2)) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) |
+		REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(22),
+		HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_DFE_EN_L1_clk_inv_lane1_mask |
+		REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask |
+		REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask |
+		REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask |
+		REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		(REG_DFE_EN_L2_timer_ctrl_en_lane2_mask | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2)) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) |
+		REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(22),
+		HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_DFE_EN_L2_clk_inv_lane2_mask |
+		REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask |
+		REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask |
+		REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask |
+		REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		(REG_DFE_EN_L2_timer_ctrl_en_lane2_mask | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2)) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) |
+		REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(22),
+		HDMI_RX_DEF);
+
+	/* Set initial value  TAP0 TAP1 TAP2 TAP3 */
+	/* Tap1 =0xc Tap0 =0xc servo =0xf */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask | REG_DFE_INIT0_L0_tap0_init_lane0_mask |
+		REG_DFE_INIT0_L0_servo_init_lane0_mask | REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap1_init_lane0(0xc) | REG_DFE_INIT0_L0_tap0_init_lane0(0xc) |
+		REG_DFE_INIT0_L0_servo_init_lane0(0xf) | REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask | REG_DFE_INIT0_L0_tap0_init_lane0_mask |
+		REG_DFE_INIT0_L0_servo_init_lane0_mask | REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap1_init_lane0(0xc) | REG_DFE_INIT0_L0_tap0_init_lane0(0xc) |
+		REG_DFE_INIT0_L0_servo_init_lane0(0xf) | REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask | REG_DFE_INIT0_L0_tap0_init_lane0_mask |
+		REG_DFE_INIT0_L0_servo_init_lane0_mask | REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap1_init_lane0(0xc) | REG_DFE_INIT0_L0_tap0_init_lane0(0xc) |
+		REG_DFE_INIT0_L0_servo_init_lane0(0xf) | REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), (_BIT19|_BIT21|_BIT23), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), (_BIT19|_BIT21|_BIT23), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), (_BIT19|_BIT21|_BIT23), HDMI_RX_DEF);
+
+	/* Load initial data */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DEF);
+
+	/* Adapt reset release */
+	hdmi_rx_reg_mask32(REG_DFE_MODE, ~(REG_DFE_MODE_dfe_adapt_rstb_mask), REG_DFE_MODE_dfe_adapt_rstb_mask, HDMI_RX_DEF);
+	/* Set run length = 4 */
+	hdmi_rx_reg_mask32(REG_DFE_GAIN, ~(REG_DFE_GAIN_trans_rlength_mask), REG_DFE_GAIN_trans_rlength(2), HDMI_RX_DEF);
+	/* Set tap tap1 tap2 max min value */
+#if 1/* QC 2016/01/18 */
+	if ((b < 2844) &&  (b > 1420)) {
+		/* 3G ~1.5G */
+		hdmi_rx_reg_mask32(REG_DFE_LIMIT0,
+			~(REG_DFE_LIMIT0_tap0_max_mask | REG_DFE_LIMIT0_tap1_min_mask |
+			REG_DFE_LIMIT0_tap2_max_mask | REG_DFE_LIMIT0_tap2_min_mask),
+			REG_DFE_LIMIT0_tap0_max(0x18) | REG_DFE_LIMIT0_tap1_min(0x10) |
+			REG_DFE_LIMIT0_tap2_max(0x0a) | REG_DFE_LIMIT0_tap2_min(0x19),
+			HDMI_RX_DEF);
+	} else {
+		hdmi_rx_reg_mask32(REG_DFE_LIMIT0,
+			~(REG_DFE_LIMIT0_tap0_max_mask | REG_DFE_LIMIT0_tap1_min_mask |
+			REG_DFE_LIMIT0_tap2_max_mask | REG_DFE_LIMIT0_tap2_min_mask),
+			REG_DFE_LIMIT0_tap0_max(0x18) | REG_DFE_LIMIT0_tap1_min(0x35) |
+			REG_DFE_LIMIT0_tap2_max(0x0a) | REG_DFE_LIMIT0_tap2_min(0x19),
+			HDMI_RX_DEF);
+	}
+#endif
+	/* Vth_min=0, Vth_max=0x7, Vth_th=0, Tap0_th=0 */
+	hdmi_rx_reg_mask32(REG_DFE_LIMIT1,
+		~(REG_DFE_LIMIT1_vth_min_mask | REG_DFE_LIMIT1_vth_max_mask |
+		REG_DFE_LIMIT1_vth_threshold_mask | REG_DFE_LIMIT1_tap0_threshold_mask |
+		REG_DFE_LIMIT1_tap0_adjust_mask | REG_DFE_LIMIT1_tap1_trans_mask),
+		REG_DFE_LIMIT1_vth_min(0) | REG_DFE_LIMIT1_vth_max(0x7) |
+		REG_DFE_LIMIT1_tap0_adjust(0x02) | REG_DFE_LIMIT1_tap1_trans_mask,
+		HDMI_RX_DEF);
+	/* ENABLE  VTH & TAP0 */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth),
+		REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth, HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth),
+		REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth, HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth),
+		REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth, HDMI_RX_DEF);
+
+	usleep_range(50000, 51000);/* Delay before turn off TAP0 adjust(DFE_second_flow) */
+
+#if 1/* QC 2016/01/18 */
+	DFE_second_flow();
+
+	PHY_FORE_KOFF();
+
+	/* Enable TAP1 & LE */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP1|REG_dfe_adapt_en_lane0_LE|REG_dfe_adapt_en_lane0_TAP2),
+		(REG_dfe_adapt_en_lane0_TAP1|REG_dfe_adapt_en_lane0_LE|REG_dfe_adapt_en_lane0_TAP2),
+		HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP1|REG_dfe_adapt_en_lane1_LE|REG_dfe_adapt_en_lane1_TAP2),
+		(REG_dfe_adapt_en_lane1_TAP1|REG_dfe_adapt_en_lane1_LE|REG_dfe_adapt_en_lane1_TAP2),
+		HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP1|REG_dfe_adapt_en_lane2_LE|REG_dfe_adapt_en_lane2_TAP2),
+		(REG_dfe_adapt_en_lane2_TAP1|REG_dfe_adapt_en_lane2_LE|REG_dfe_adapt_en_lane2_TAP2),
+		HDMI_RX_DEF);
+#endif
+
+	bDFE_Close_Flag = 1;
+
+	/* Close DEF */
+	usleep_range(80000, 85000);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~REG_DFE_READBACK_record_limit_en_mask, REG_DFE_READBACK_record_limit_en(1), HDMI_RX_MAC);
+	usleep_range(70000, 75000);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~REG_DFE_READBACK_record_limit_en_mask, REG_DFE_READBACK_record_limit_en(0), HDMI_RX_MAC);
+	usleep_range(70000, 75000);
+	HDMI_MAG2_SetDFE_Close();
+
+}
+
+void HDMI_MAG2_SetDFE_MS_speed(int b, int dfe_mode)
+{
+	HDMI_PRINTF("[PHY][%s] b(%d) dfe_mode(%d)\n", __func__, b, dfe_mode);
+
+	hdmi_rx_reg_mask32(REG_DFE_MODE,
+		~(REG_DFE_MODE_adapt_mode_mask | REG_DFE_MODE_edge_det_mode_mask |
+		REG_DFE_MODE_transition_only_mask | REG_DFE_MODE_tap1_delay_mask |
+		REG_DFE_MODE_tap24_delay_mask | REG_DFE_MODE_le_delay_mask |
+		REG_DFE_MODE_servo_delay_mask | REG_DFE_MODE_gray_en_mask |
+		REG_DFE_MODE_dfe_adapt_rstb_mask | REG_DFE_MODE_tap0_notrans_mask |
+		REG_DFE_MODE_servo_notrans_mask),
+		REG_DFE_MODE_adapt_mode(dfe_mode) | REG_DFE_MODE_edge_det_mode(0) |
+		REG_DFE_MODE_transition_only_mask | REG_DFE_MODE_tap1_delay(1) |
+		REG_DFE_MODE_tap24_delay(1) | REG_DFE_MODE_le_delay(1) |
+		REG_DFE_MODE_gray_en_mask | REG_DFE_MODE_tap0_notrans_mask |
+		REG_DFE_MODE_servo_notrans_mask | _BIT16,
+		HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_DFE_EN_L0_clk_inv_lane0_mask | REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask | REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask | REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask | REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		(REG_DFE_EN_L2_timer_ctrl_en_lane2_mask | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2)) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) | REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(0x3),
+		HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_DFE_EN_L1_clk_inv_lane1_mask | REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask | REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask | REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask | REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		(REG_DFE_EN_L2_timer_ctrl_en_lane2_mask|REG_DFE_EN_L2_reduce_adapt_gain_lane2(2)) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) | REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(0x3),
+		HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_DFE_EN_L2_clk_inv_lane2_mask | REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask | REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask | REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask | REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		(REG_DFE_EN_L2_timer_ctrl_en_lane2_mask | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2)) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) | REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(0x3),
+		HDMI_RX_DEF);
+
+	/* Set initial value	TAP0 TAP1 TAP2 TAP3 */
+	/* Tap1 =0xc Tap0 =0xc servo =0xf */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask | REG_DFE_INIT0_L0_tap0_init_lane0_mask |
+		REG_DFE_INIT0_L0_servo_init_lane0_mask | REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap1_init_lane0(0x0) | REG_DFE_INIT0_L0_tap0_init_lane0(0xc) |
+		REG_DFE_INIT0_L0_servo_init_lane0(0xf) | REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask | REG_DFE_INIT0_L0_tap0_init_lane0_mask |
+		REG_DFE_INIT0_L0_servo_init_lane0_mask | REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap1_init_lane0(0x0) | REG_DFE_INIT0_L0_tap0_init_lane0(0xc) |
+		REG_DFE_INIT0_L0_servo_init_lane0(0xf) | REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask | REG_DFE_INIT0_L0_tap0_init_lane0_mask |
+		REG_DFE_INIT0_L0_servo_init_lane0_mask | REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap1_init_lane0(0x0) | REG_DFE_INIT0_L0_tap0_init_lane0(0xc) |
+		REG_DFE_INIT0_L0_servo_init_lane0(0xf) | REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DEF);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), (_BIT19|_BIT21|_BIT23), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), (_BIT19|_BIT21|_BIT23), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), (_BIT19|_BIT21|_BIT23), HDMI_RX_DEF);
+
+	/* Load initial data */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DEF);
+
+	HDMI_PRINTF("[PHY][DFE open] DFE load initial value\n");
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DEF);
+
+	/* Adapt reset release */
+	hdmi_rx_reg_mask32(REG_DFE_MODE, ~(REG_DFE_MODE_dfe_adapt_rstb_mask), REG_DFE_MODE_dfe_adapt_rstb_mask, HDMI_RX_DEF);
+	/* Set run length = 4 */
+	hdmi_rx_reg_mask32(REG_DFE_GAIN, ~(REG_DFE_GAIN_trans_rlength_mask), REG_DFE_GAIN_trans_rlength(2), HDMI_RX_DEF);
+	/* Set tap tap1 tap2 max min value */
+	hdmi_rx_reg_mask32(REG_DFE_LIMIT0,
+		~(REG_DFE_LIMIT0_tap0_max_mask|REG_DFE_LIMIT0_tap1_min_mask|REG_DFE_LIMIT0_tap2_max_mask|REG_DFE_LIMIT0_tap2_min_mask),
+		(REG_DFE_LIMIT0_tap0_max(0x18)|REG_DFE_LIMIT0_tap1_min(0x35)|REG_DFE_LIMIT0_tap2_max(0x0a)|REG_DFE_LIMIT0_tap2_min(0x19)),
+		HDMI_RX_DEF);
+	/* Vth_min=0,Vth_max=0x7,Vth_th=0,Tap0_th=0 */
+	hdmi_rx_reg_mask32(REG_DFE_LIMIT1,
+		~(REG_DFE_LIMIT1_vth_min_mask | REG_DFE_LIMIT1_vth_max_mask |
+		REG_DFE_LIMIT1_vth_threshold_mask | REG_DFE_LIMIT1_tap0_threshold_mask |
+		REG_DFE_LIMIT1_tap0_adjust_mask | REG_DFE_LIMIT1_tap1_trans_mask),
+		REG_DFE_LIMIT1_vth_min(0) | REG_DFE_LIMIT1_vth_max(0x7) |
+		REG_DFE_LIMIT1_tap0_adjust(0x02) | REG_DFE_LIMIT1_tap1_trans_mask,
+		HDMI_RX_DEF);
+	/* ENABLE  VTH & TAP0 */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0, ~(REG_dfe_adapt_en_lane0_TAP0|REG_dfe_adapt_en_lane0_Vth), (REG_dfe_adapt_en_lane0_TAP0|REG_dfe_adapt_en_lane0_Vth), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1, ~(REG_dfe_adapt_en_lane1_TAP0|REG_dfe_adapt_en_lane1_Vth), (REG_dfe_adapt_en_lane1_TAP0|REG_dfe_adapt_en_lane1_Vth), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2, ~(REG_dfe_adapt_en_lane2_TAP0|REG_dfe_adapt_en_lane2_Vth), (REG_dfe_adapt_en_lane2_TAP0|REG_dfe_adapt_en_lane2_Vth), HDMI_RX_DEF);
+	HDMI_PRINTF("[PHY][DFE open] ENABLE  VTH & TAP0\n");
+	/* ENABLE TAP1 & LE */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0, ~(REG_dfe_adapt_en_lane0_TAP1|REG_dfe_adapt_en_lane0_LE), (REG_dfe_adapt_en_lane0_TAP1), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1, ~(REG_dfe_adapt_en_lane1_TAP1|REG_dfe_adapt_en_lane1_LE), (REG_dfe_adapt_en_lane1_TAP1), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2, ~(REG_dfe_adapt_en_lane2_TAP1|REG_dfe_adapt_en_lane2_LE), (REG_dfe_adapt_en_lane2_TAP1), HDMI_RX_DEF);
+	HDMI_PRINTF("[PHY][DFE open] ENABLE TAP1\n");
+
+	bDFE_Close_Flag = 1;
+
+	/* Close DEF */
+	usleep_range(80000, 85000);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~REG_DFE_READBACK_record_limit_en_mask, REG_DFE_READBACK_record_limit_en(1), HDMI_RX_MAC);
+	usleep_range(70000, 75000);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~REG_DFE_READBACK_record_limit_en_mask, REG_DFE_READBACK_record_limit_en(0), HDMI_RX_MAC);
+	usleep_range(75000, 76000);
+	HDMI_MAG2_SetDFE_Close();
+
+}
+
+void DFE_Manual_Set(void)
+{
+	u_int8_t lane;
+
+	/* DFE register release */
+	hdmi_rx_reg_mask32(RST, ~RST_dfe_rstn_n_mask, RST_dfe_rstn_n_mask, HDMI_RX_PHY);
+
+	/* Disable dfe */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0, ~(REG_DFE_EN_L0_clk_inv_lane0_mask|REG_DFE_EN_L0_dfe_adapt_en_lane0_mask), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1, ~(REG_DFE_EN_L1_clk_inv_lane1_mask|REG_DFE_EN_L1_dfe_adapt_en_lane1_mask), 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2, ~(REG_DFE_EN_L2_clk_inv_lane2_mask|REG_DFE_EN_L2_dfe_adapt_en_lane2_mask), 0, HDMI_RX_DEF);
+
+	/* Adaptive mode sel */
+	hdmi_rx_reg_mask32(REG_DFE_MODE, ~REG_DFE_MODE_adapt_mode_mask, REG_DFE_MODE_adapt_mode(3), HDMI_RX_DEF);
+
+	/* lane0 LE coefficient min */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0, ~REG_DFE_EN_L0_le_min_lane0_mask, REG_DFE_EN_L0_le_min_lane0(0xf), HDMI_RX_DEF);
+	/* lane1 LE coefficient min */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1, ~REG_DFE_EN_L1_le_min_lane1_mask, REG_DFE_EN_L1_le_min_lane1(0xf), HDMI_RX_DEF);
+	/* lane2 LE coefficient min */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2, ~REG_DFE_EN_L2_le_min_lane2_mask, REG_DFE_EN_L2_le_min_lane2(0xf), HDMI_RX_DEF);
+
+	/* tap1 initial,  lane0/lane1/lane2 */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0, ~REG_DFE_INIT0_L0_tap1_init_lane0_mask, REG_DFE_INIT0_L0_tap1_init_lane0(5), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1, ~REG_DFE_INIT0_L1_tap1_init_lane1_mask, REG_DFE_INIT0_L1_tap1_init_lane1(5), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2, ~REG_DFE_INIT0_L2_tap1_init_lane2_mask, REG_DFE_INIT0_L2_tap1_init_lane2(5), HDMI_RX_DEF);
+
+	/* tap0 initial, lane0/lane1/lane2 */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0, ~REG_DFE_INIT0_L0_tap0_init_lane0_mask, REG_DFE_INIT0_L0_tap0_init_lane0(0xc), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1, ~REG_DFE_INIT0_L1_tap0_init_lane1_mask, REG_DFE_INIT0_L1_tap0_init_lane1(0xc), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2, ~REG_DFE_INIT0_L2_tap0_init_lane2_mask, REG_DFE_INIT0_L2_tap0_init_lane2(0xc), HDMI_RX_DEF);
+
+	/* DEF initial load, lane0/lane1/lane2 */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~REG_DFE_INIT1_L0_load_in_init_lane0_mask, REG_DFE_INIT1_L0_load_in_init_lane0(3), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~REG_DFE_INIT1_L1_load_in_init_lane1_mask, REG_DFE_INIT1_L1_load_in_init_lane1(3), HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~REG_DFE_INIT1_L2_load_in_init_lane2_mask, REG_DFE_INIT1_L2_load_in_init_lane2(3), HDMI_RX_DEF);
+	HDMI_DELAYMS(1);
+	/* DEF initial load done */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~REG_DFE_INIT1_L0_load_in_init_lane0_mask, 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~REG_DFE_INIT1_L1_load_in_init_lane1_mask, 0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~REG_DFE_INIT1_L2_load_in_init_lane2_mask, 0, HDMI_RX_DEF);
+
+	/* Enable tap1~4 B/G/R */
+	hdmi_rx_reg_mask32(P0_B3, ~P0_B_DFE_TAPEN4321, P0_B_DFE_TAPEN4321, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_G3, ~P0_G_DFE_TAPEN4321, P0_G_DFE_TAPEN4321, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_R3, ~P0_R_DFE_TAPEN4321, P0_R_DFE_TAPEN4321, HDMI_RX_PHY);
+
+	for (lane = 0; lane < 3; lane++)
+		Dump_DFE_Para(lane);
+
+	hdmi_ioctl_struct.DEF_ready = 1;
+}
+
+void HDMI_MAG2_SetDFE_Close(void)
+{
+	u_int8_t lane;
+
+#if 1/* QC 2016/01/18 */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth |
+		REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_TAP2 |
+		REG_dfe_adapt_en_lane0_LE),
+		0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth |
+		REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_TAP2 |
+		REG_dfe_adapt_en_lane1_LE),
+		0, HDMI_RX_DEF);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth |
+		REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_TAP2 |
+		REG_dfe_adapt_en_lane2_LE),
+		0, HDMI_RX_DEF);
+#endif
+
+	/* limit value record */
+	hdmi_rx_reg_mask32(REG_DFE_READBACK, ~REG_DFE_READBACK_record_limit_en_mask,
+		REG_DFE_READBACK_record_limit_en(0), HDMI_RX_DEF);
+
+
+	/* Read result max and min value */
+	for (lane = 0; lane < 3; lane++)
+		Dump_DFE_Para(lane);
+
+	bDFE_Close_Flag = 0;
+	bDFE_Close_Cnt = 0;
+	hdmi_ioctl_struct.DEF_ready = 1;
+	HDMI_PRINTF("[PHY][DFE open] HDMI_MAG2_SetDFE_Close\n");
+}
+
+
+void SetupTMDSPhy(u_int32_t b, char force)
+{
+	u_int8_t mode, dfe_mode = 3;
+	bool b_mode_found = 0;
+
+	if ((HDMI_ABS(hdmi_ioctl_struct.b, b) < 20) && (force == 0))
+		return;
+
+	if (hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC)&MHL_HDMI_PHY_BYPASS)
+		return;
+
+	hdmi_ioctl_struct.b = b;
+	hdmi_ioctl_struct.b_change = 1;
+	hdmi_phy_idle_patch.idle_count = 0;
+#if HDMI2p0
+	b6G_detect_cnt = 0;
+#endif
+
+	hdmi_rx_reg_mask32(HDCP_CR, ~HDCP_CR_hdcp_en_mask, 0, HDMI_RX_MAC);
+
+	CLOSE_RST_MAC();
+
+	EQ_bias_band_setting(b);
+
+	for (mode = 0; mode < 5; mode++) {
+		if (hdmi_phy_param[mode].b_upper > b && hdmi_phy_param[mode].b_lower <= b) {
+			HDMI_Set_Phy_Table(mode);
+			b_mode_found = 1;
+			break;
+		}
+	}
+
+	if (!b_mode_found) {
+		HDMI_PRINTF("Not Found in PhyMode (b=%d)\n", b);
+		return;
+	}
+
+	hdmi_rx_reg_mask32(RST, ~(P1_ck_9_CMU_WDRST), P1_ck_9_CMU_WDRST, HDMI_RX_PHY);
+
+	/* PFD_RSTB	release */
+	hdmi_rx_reg_mask32(P0_CK3, ~(P0_ck_9_CMU_PFD_RSTB|P0_ck_9_CMU_WDRST), (P0_ck_9_CMU_PFD_RSTB|P0_ck_9_CMU_WDRST), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P1_CK3, ~(P1_ck_9_CMU_PFD_RSTB|P0_ck_9_CMU_WDRST), (P1_ck_9_CMU_PFD_RSTB|P0_ck_9_CMU_WDRST), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P2_CK3, ~(P2_ck_9_CMU_PFD_RSTB|P0_ck_9_CMU_WDRST), (P2_ck_9_CMU_PFD_RSTB|P0_ck_9_CMU_WDRST), HDMI_RX_PHY);
+
+	CMU_Reset(0);
+	DEMUX_RESET(0);
+	CDR_RESET(0);
+
+	hdmi_rx_reg_write32(REGD15, 0xE4E84505, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(REGD16, ~(_BIT31), _BIT31, HDMI_RX_PHY);
+
+	PHY_DFE_Setting(mode);
+
+	if (b > clock_bound_110m)
+		HDMI_MAG2_SetDFE(b, dfe_mode);
+	else if ((b > clock_bound_45m) && (b < clock_bound_110m))
+		HDMI_MAG2_SetDFE_MS_speed(b, 2);
+	else
+		DFE_Manual_Set();
+
+	/* Prevent influence HDCP2.2 */
+	if (hdmi_ioctl_struct.hdcp_state < HDCPRX_STATE_2P2_DISCOVER)
+		hdmi_rx_reg_mask32(HDCP_CR, ~HDCP_CR_hdcp_en_mask, HDCP_CR_hdcp_en_mask, HDMI_RX_MAC);
+
+	OPEN_RST_MAC();
+
+	HDMI_PRINTF("****************** ");
+	HDMI_PRINTF("setup phy[0805] %d %d", hdmi_ioctl_struct.b, b);
+	HDMI_PRINTF("******************\n");
+}
+
+bool HDMI_Bit_Err_One_Time_Detect(u_int8_t period, u_int16_t thd)
+{
+	u_int32_t tout = 60;
+
+	/* Mode */
+	hdmi_rx_reg_mask32(VIDEO_BIT_ERR_DET, ~VIDEO_BIT_ERR_DET_mode_mask, 0, HDMI_RX_MAC);
+	/* Period */
+	hdmi_rx_reg_mask32(VIDEO_BIT_ERR_DET, ~VIDEO_BIT_ERR_DET_period_mask, VIDEO_BIT_ERR_DET_period(period), HDMI_RX_MAC);
+	/* thd */
+	hdmi_rx_reg_mask32(VIDEO_BIT_ERR_DET, ~VIDEO_BIT_ERR_DET_thd_mask, VIDEO_BIT_ERR_DET_thd(thd), HDMI_RX_MAC);
+
+	/* disable */
+	hdmi_rx_reg_mask32(VIDEO_BIT_ERR_DET, ~VIDEO_BIT_ERR_DET_en_mask, 0, HDMI_RX_MAC);
+	/* reset cnt */
+	hdmi_rx_reg_mask32(VIDEO_BIT_ERR_DET, ~VIDEO_BIT_ERR_DET_reset_mask, VIDEO_BIT_ERR_DET_reset_mask, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(VIDEO_BIT_ERR_DET, ~VIDEO_BIT_ERR_DET_reset_mask, 0, HDMI_RX_MAC);
+	HDMI_DELAYMS(1);
+
+	/* For clear, wclr_out */
+	hdmi_rx_reg_mask32(VIDEO_BIT_ERR_STATUS_B,
+		~(VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask),
+		VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask,
+		HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(VIDEO_BIT_ERR_STATUS_G,
+		~(VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask),
+		VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask,
+		HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(VIDEO_BIT_ERR_STATUS_R,
+		~(VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask),
+		VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask | VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask,
+		HDMI_RX_MAC);
+
+	HDMI_DELAYMS(1);
+	hdmi_rx_reg_mask32(VIDEO_BIT_ERR_DET, ~VIDEO_BIT_ERR_DET_en_mask, VIDEO_BIT_ERR_DET_en_mask, HDMI_RX_MAC);
+
+	while (VIDEO_BIT_ERR_DET_get_en(hdmi_rx_reg_read32(VIDEO_BIT_ERR_DET, HDMI_RX_MAC)) && tout--)
+		HDMI_DELAYMS(1);
+
+	HDMI_PRINTF("[PHY][BER] B bit_err_cnt=%d, G bit_err_cnt=%d, R bit_err_cnt=%d\n",
+		VIDEO_BIT_ERR_STATUS_B_get_bit_err_cnt_b(hdmi_rx_reg_read32(VIDEO_BIT_ERR_STATUS_B, HDMI_RX_MAC)),
+		VIDEO_BIT_ERR_STATUS_B_get_bit_err_thd_b(hdmi_rx_reg_read32(VIDEO_BIT_ERR_STATUS_G, HDMI_RX_MAC)),
+		VIDEO_BIT_ERR_STATUS_R_get_bit_err_cnt_r(hdmi_rx_reg_read32(VIDEO_BIT_ERR_STATUS_R, HDMI_RX_MAC)));
+	return TRUE;
+}
+
+
+int HdmiMeasureVedioClock(void)
+{
+	u_int32_t b;
+
+	if (hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC) & _BIT5) {
+		/* RSV1 received */
+		hdmi_ioctl_struct.avi_info_in = 1;
+		hdmi_rx_reg_write32(HDMI_GPVS, _BIT5, HDMI_RX_MAC);
+		hdmi_ioctl_struct.avi_info_miss_cnt = 0;
+	} else {
+		hdmi_ioctl_struct.avi_info_miss_cnt++;
+		if (hdmi_ioctl_struct.avi_info_miss_cnt > 200) {
+			/* HDMI_PRINTF("AVI info miss %x\n", hdmiport_in(HDMI_HDMI_ACRCR_RO_VADDR)); */
+			hdmi_ioctl_struct.avi_info_in = 0;
+			hdmi_ioctl_struct.avi_info_miss_cnt = 0;
+		}
+	}
+
+	if (Hdmi_IsbReady() == TRUE) {
+		if (hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC) & HDMI_Force_3G) {
+			HDMI_PRINTF("HDMI 3G force mode\n");
+			b =  2815;/* 3G mode */
+		} else {
+			b =  Hdmi_get_b_value();
+#if HDMI2p0
+			b = (bHDMI_6G_flag?4:1)*b;
+#endif
+		}
+
+		hdmi_ioctl_struct.b_debouce_count = 0;
+		if ((HDMI_ABS(b, hdmi_ioctl_struct.b_pre) < 20) && (b > 116)) {
+			if (hdmi_ioctl_struct.b_count >= HDMI_B_TEST_COUNT_MAX) {
+				if (!(hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC)&MHL_HDMI_SETPHY_BYPASS))
+					SetupTMDSPhy(b, 0);
+
+				hdmi_ioctl_struct.b_count = 0;
+			} else {
+				hdmi_ioctl_struct.b_count++;
+			}
+		} else {
+			hdmi_clear_b_struct();
+			hdmi_ioctl_struct.b_pre = b;
+		}
+		Hdmi_TriggerbMeasurement(GET_HDMI_CHANNEL());
+	} else {
+		/* HDMI is not ready */
+		Hdmi_TriggerbMeasurement(GET_HDMI_CHANNEL());
+		hdmi_ioctl_struct.b_debouce_count++;
+
+		if (hdmi_ioctl_struct.b_debouce_count < 2)
+			return 0;
+
+		hdmi_clear_b_struct();
+		hdmi_ioctl_struct.b_debouce_count = 0;
+		return 0;
+	}
+
+	return -1;
+}
+
+#if HDMI_PHY_IDLE_PATCH_ENABLE
+void HdmiPhyElectricalIdlePatch(void)
+{
+	if (hdmi_ioctl_struct.b != 0 && HDMI_ABS(hdmi_ioctl_struct.b, hdmi_ioctl_struct.b_pre) < 20) {
+		if ((hdmi_phy_idle_patch.apstatus == HDMIRX_DETECT_FAIL) || (hdmi_phy_idle_patch.apstatus == HDMIRX_DETECT_AVMUTE)) {
+			hdmi_phy_idle_patch.idle_count++;
+			if (hdmi_phy_idle_patch.idle_count >= HDMI_PHY_IDLE_PATCH_COUNT) {
+				HDMIRX_INFO("PHY idle count %d, reset PHY\n", hdmi_phy_idle_patch.idle_count);
+
+				if (!(hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC)&MHL_HDMI_SETPHY_BYPASS))
+					SetupTMDSPhy(hdmi_ioctl_struct.b, 1);
+			}
+		}
+	}
+}
+#endif
+
+
+int rtd_hdmiRx_cmd(u_int8_t cmd,  void *arg)
+{
+	switch ((HDMIRX_IOCTL_T) cmd) {
+	case IOCTRL_HDMI_PHY_START:
+		HDMIRX_DEBUG("[%s] IOCTRL_HDMI_PHY_START", __func__);
+		hdmi_ioctl_struct.b = 0;
+		hdmi_ioctl_struct.b_change = 0;
+		hdmi_ioctl_struct.b_pre = 0;
+		hdmi_ioctl_struct.b_count = 0;
+		hdmi_ioctl_struct.LG_patch_timer = 0;
+		hdmi_phy_idle_patch.idle_count = 0;
+		hdmi_ioctl_struct.hotplug_delay_count = 0;
+
+		/* port 0 auto mode */
+		hdmi_rx_reg_mask32(REGD42, ~REGD42_reg_p0_ck_md_auto_mask, REGD42_reg_p0_ck_md_auto_mask, HDMI_RX_PHY);
+		/* port 1 auto mode */
+		hdmi_rx_reg_mask32(REGD44, ~REGD44_reg_p1_ck_md_auto_mask, REGD44_reg_p1_ck_md_auto_mask, HDMI_RX_PHY);
+		/* port2 auto mode */
+		hdmi_rx_reg_mask32(REGD46, ~REGD46_reg_p2_ck_md_auto_mask, REGD46_reg_p2_ck_md_auto_mask, HDMI_RX_PHY);
+		/* PMM clk detect enable */
+		hdmi_rx_reg_mask32(CLKDETCR, ~_BIT0, _BIT0, HDMI_RX_MAC);
+		Hdmi_TriggerbMeasurement(HDMI_CHANNEL0);
+		break;
+
+	case IOCTRL_HDMI_PHY_STOP:
+		HDMIRX_DEBUG("[%s] IOCTRL_HDMI_PHY_STOP", __func__);
+		hdmi_ioctl_struct.b = 0;
+		hdmi_ioctl_struct.b_change = 0;
+		hdmi_ioctl_struct.b_pre = 0;
+		hdmi_ioctl_struct.LG_patch_timer = 0;
+		hdmi_phy_idle_patch.idle_count = 0;
+		hdmi_ioctl_struct.hotplug_delay_count = 0;
+
+		/* port 0 auto mode */
+		hdmi_rx_reg_mask32(REGD42, ~REGD42_reg_p0_ck_md_auto_mask, 0, HDMI_RX_PHY);
+		/* port 1 auto mode */
+		hdmi_rx_reg_mask32(REGD44, ~REGD44_reg_p1_ck_md_auto_mask, 0, HDMI_RX_PHY);
+		/* port2 auto mode */
+		hdmi_rx_reg_mask32(REGD46, ~REGD46_reg_p2_ck_md_auto_mask, 0, HDMI_RX_PHY);
+		/* PMM clk detect disable */
+		hdmi_rx_reg_mask32(CLKDETCR, ~_BIT0, 0, HDMI_RX_MAC);
+		break;
+
+	case IOCTRL_HDMI_GET_STRUCT:
+		/* HDMIRX_DEBUG("[%s] IOCTRL_HDMI_GET_STRUCT",  __func__); */
+		memcpy(arg, &hdmi_ioctl_struct, sizeof(HDMIRX_IOCTL_STRUCT_T));
+		hdmi_ioctl_struct.b_change = 0;
+		break;
+
+	case IOCTRL_HDMI_SET_TIMER:
+		HDMIRX_DEBUG("[%s] IOCTRL_HDMI_SET_TIMER", __func__);
+		memcpy(&(hdmi_ioctl_struct.timer), arg, sizeof(hdmi_ioctl_struct.timer));
+		break;
+
+	case IOCTRL_HDMI_GET_TIMER:
+		HDMIRX_DEBUG("[%s] IOCTRL_HDMI_GET_TIMER", __func__);
+		memcpy(arg, &(hdmi_ioctl_struct.timer), sizeof(hdmi_ioctl_struct.timer));
+		break;
+
+	case IOCTRL_HDMI_SET_APSTATUS:
+		/* HDMIRX_DEBUG("[%s] IOCTRL_HDMI_SET_APSTATUS",  __func__); */
+		hdmi_phy_idle_patch.apstatus  = (HDMIRX_APSTATUS_T) (unsigned long) arg;
+
+		if (hdmi_phy_idle_patch.apstatus != HDMIRX_DETECT_FAIL)
+			hdmi_phy_idle_patch.idle_count = 0;
+
+		break;
+
+	default:
+		break;
+	}
+
+	return 0;
+}
+
+void rtd_hdmiPhy_ISR(void)
+{
+	unsigned int hdmi_psap_addr = hdmi_rx_reg_read32(HDMI_PSAP, HDMI_RX_MAC);
+
+	if (hdmi_ioctl_struct.LG_patch_timer != 0)
+		hdmi_ioctl_struct.LG_patch_timer--;
+
+	if (hdmi_ioctl_struct.timer != 0)
+		hdmi_ioctl_struct.timer--;
+
+	HdmiMeasureVedioClock();
+
+#if HDMI_PHY_IDLE_PATCH_ENABLE
+	HdmiPhyElectricalIdlePatch();
+#endif
+
+	Hdmi_HdcpFSM();
+
+	if (bDFE_Close_Flag == 1) {
+		if (bDFE_Close_Cnt == 2)
+			hdmi_rx_reg_mask32(REG_DFE_READBACK, ~REG_DFE_READBACK_record_limit_en_mask, REG_DFE_READBACK_record_limit_en(1), HDMI_RX_MAC);
+		else if (bDFE_Close_Cnt == 3)
+			hdmi_rx_reg_mask32(REG_DFE_READBACK, ~REG_DFE_READBACK_record_limit_en_mask, REG_DFE_READBACK_record_limit_en(0), HDMI_RX_MAC);
+		bDFE_Close_Cnt++;
+		if (bDFE_Close_Cnt >= 3)
+			HDMI_MAG2_SetDFE_Close();
+	}
+
+	/* Bit Error check */
+	if (hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC)&MHL_HDMI_Bit_Error_check) {
+#if HDMI2p0
+		if (bHDMI_6G_flag == 1)
+			drvif_Hdmi2p0_Error_Count();
+		else
+#endif
+		HDMI_Bit_Err_One_Time_Detect(100, 20);
+	}
+
+	hdmi_rx_reg_write32(HDMI_PSAP, hdmi_psap_addr, HDMI_RX_MAC);
+}
+
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/v4l2_hdmi_dev.c b/drivers/media/platform/rtk_hdmirx/rtd129x/v4l2_hdmi_dev.c
new file mode 100644
index 00000000..7edfa8a
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/v4l2_hdmi_dev.c
@@ -0,0 +1,745 @@
+/*
+ * v4l2_hdmi_dev.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/of.h>
+#include <linux/of_gpio.h>
+#include <linux/gpio.h>
+#include <linux/switch.h>
+#include <linux/time.h>
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmirx_video_dev.h"
+#include "hdmirx_wrapper.h"
+#include "mipi_wrapper.h"
+#include "hdmirx_reg.h"
+#include "hdmirx_sysfs.h"
+#include "hdmirx_clk_ctrl.h"
+#include "hdcp2p2_dev.h"
+
+#include "rx_drv/hdmiInternal.h"
+#include "rx_drv/hdmiEDID.h"
+
+#define MAX_WIDTH 4096
+#define MAX_HEIGHT 2160
+
+static struct task_struct *hdmi_hw_tsk;
+static void __iomem *clk90k_vaddr[2];
+/*=================== extern Variable/Function ===================*/
+extern void __iomem *hdmi_rx_base[HDMI_RX_REG_BLOCK_NUM];
+extern MIPI_TOP_INFO mipi_top;
+extern HDMI_INFO_T hdmi;
+extern HDMIRX_IOCTL_STRUCT_T hdmi_ioctl_struct;
+extern HDMIRX_DTS_EDID_TBL_T hdmirx_edid;
+extern int hdmi_stream_on;
+extern int hdmi_timestamp_mode;// 0:system time, 1:90KHz timer
+
+extern int Cbus_GetRx5v(void);
+extern void Hdmi_SetHPD(char high);
+extern void drvif_Hdmi_Init(void);
+extern void drvif_Hdmi_InitSrc(unsigned char channel);
+extern void drvif_Hdmi_Release(void);
+extern HDMI_bool drvif_Hdmi_DetectMode(void);
+extern HDMI_bool drvif_Hdmi_CheckMode(void);
+extern void rtd_hdmiPhy_ISR(void);
+
+extern unsigned int rtk_suspend_wakeup_flags_get(void);
+/*======================================================*/
+static inline void update_hdmirx_switch_state(struct v4l2_hdmi_dev *dev);
+
+int hdmirx_queue_init(struct v4l2_hdmi_dev *dev, struct vb2_queue *q, enum v4l2_memory memory)
+{
+	q->type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
+	q->io_modes = VB2_MMAP | VB2_USERPTR | VB2_DMABUF; /* | VB2_READ; */
+	q->drv_priv = dev;
+	q->buf_struct_size = sizeof(struct hdmi_buffer);
+	q->ops = &hdmi_qops;
+	q->timestamp_flags = V4L2_BUF_FLAG_TIMESTAMP_MONOTONIC;
+	q->dev = &dev->vdev.dev;
+
+	if (memory == V4L2_MEMORY_USERPTR) {
+		q->mem_ops = &vb2_vmalloc_memops;
+	} else if (memory == V4L2_MEMORY_DMABUF) {
+		q->mem_ops = &vb2_dma_contig_memops;
+	} else if (memory == V4L2_MEMORY_MMAP) {
+		q->mem_ops = &vb2_dma_contig_memops;
+	} else {
+		HDMIRX_ERROR("[%s] Invalid io mode:%d", __func__, memory);
+		return -EINVAL;
+	}
+
+	return vb2_queue_init(q);
+}
+
+int hdmi_queue_setup(struct vb2_queue *vq,
+				unsigned int *nbuffers, unsigned int *nplanes,
+				unsigned int sizes[], struct device *alloc_devs[])
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+	struct hdmi_dmaqueue *dma_q = &dev->hdmidq;
+	unsigned long size;
+
+	HDMIRX_INFO("[%s] outfmt(%u) width(%u) height(%u)",
+		__func__, dev->outfmt, dev->width, dev->height);
+
+	atomic_set(&dma_q->qcnt, 0);
+	atomic_set(&dma_q->rcnt, 0);
+
+	if (dev->outfmt >= OUT_ARGB)
+		size = dev->width * dev->height * dev->bpp / 8;
+	else
+		size = roundup16(dev->width) * roundup16(dev->height) * dev->bpp / 8;
+
+	if (size == 0)
+		return -EINVAL;
+
+	if (*nbuffers == 0)
+		*nbuffers = 32;
+
+	*nplanes = 1;
+
+	sizes[0] = size;
+
+	HDMIRX_INFO("[%s] count=%d, size=%ld", __func__, *nbuffers, size);
+	return 0;
+}
+
+int hdmi_buffer_prepare(struct vb2_buffer *vb)
+{
+	struct vb2_queue *vq = vb->vb2_queue;
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+	struct hdmi_buffer *buf = container_of(vb, struct hdmi_buffer, vb);
+	unsigned long size;
+
+	if (dev->width	< 48 || dev->width	> MAX_WIDTH ||
+		dev->height < 32 || dev->height > MAX_HEIGHT)
+		return -EINVAL;
+
+	if (dev->outfmt >= OUT_ARGB)
+		size = dev->width * dev->height * dev->bpp / 8;
+	else
+		size = roundup16(dev->width) * roundup16(dev->height) * dev->bpp / 8;
+
+	if (vb2_plane_size(vb, 0) < size) {
+		HDMIRX_ERROR("[%s] data will not fit into plane (%lu < %lu)",
+			__func__, vb2_plane_size(vb, 0), size);
+		return -EINVAL;
+	}
+
+	vb2_set_plane_payload(&buf->vb, 0, size);
+
+	if (vq->memory == V4L2_MEMORY_USERPTR) {
+		struct mipi_vb2_vmalloc_buf *vb2_buf;
+		unsigned long pfn;
+
+		vb2_buf = vb->planes[0].mem_priv;
+		follow_pfn(vb2_buf->vma, vb->planes[0].m.userptr, &pfn);
+		buf->phys = __pfn_to_phys(pfn);
+	} else if (vq->memory == V4L2_MEMORY_DMABUF) {
+		buf->phys = vb2_dma_contig_plane_dma_addr(vb, 0);
+	} else if (vq->memory == V4L2_MEMORY_MMAP) {
+		dma_addr_t *addr = vb2_plane_cookie(vb, 0);
+
+		buf->phys = *addr;
+	}
+
+	return 0;
+}
+
+void hdmi_buffer_finish(struct vb2_buffer *vb)
+{
+	u64 clk90k_value;
+
+	if (hdmi_timestamp_mode) {
+		/* 90KHz timer, Read LO first to ensure the correct */
+		clk90k_value = readl(clk90k_vaddr[0]);
+		clk90k_value = (clk90k_value<<32) | readl(clk90k_vaddr[1]);
+		vb->timestamp = clk90k_value;
+	} else {
+		/* System timer */
+		vb->timestamp = ktime_get_ns();
+	}
+}
+
+void hdmi_buffer_queue(struct vb2_buffer *vb)
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vb->vb2_queue);
+	struct hdmi_buffer *buf = container_of(vb, struct hdmi_buffer, vb);
+	struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;
+	unsigned long flags = 0;
+
+	spin_lock_irqsave(&dev->slock, flags);
+	list_add_tail(&buf->list, &hdmidq->active);
+	atomic_inc(&hdmidq->qcnt);
+	spin_unlock_irqrestore(&dev->slock, flags);
+
+}
+
+int hdmi_start_streaming(struct vb2_queue *vq, unsigned int count)
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+
+	HDMIRX_INFO("[%s]", __func__);
+
+	register_mipi_ion(dev);
+
+	set_video_DDR_start_addr(dev);
+
+	/* Enable mipi */
+	setup_mipi();
+	hdmi_stream_on = 1;
+
+	return 0;
+}
+
+void hdmi_stop_generating(struct v4l2_hdmi_dev *dev)
+{
+	struct hdmi_dmaqueue *dma_q = &dev->hdmidq;
+
+	HDMIRX_INFO("[%s]", __func__);
+
+	/*
+	 * Typical driver might need to wait here until dma engine stops.
+	 * In this case we can abort imiedetly, so it's just a noop.
+	 */
+
+	/* Release all active buffers */
+	while (!list_empty(&dma_q->active)) {
+		struct hdmi_buffer *buf;
+
+		buf = list_entry(dma_q->active.next, struct hdmi_buffer, list);
+		list_del(&buf->list);
+		vb2_buffer_done(&buf->vb, VB2_BUF_STATE_ERROR);
+		HDMIRX_INFO("Release[%p/%d] done", buf, buf->vb.index);
+	}
+
+	if (dma_q->hwbuf[0] != NULL) {
+		vb2_buffer_done(&dma_q->hwbuf[0]->vb, VB2_BUF_STATE_ERROR);
+		dma_q->hwbuf[0] = NULL;
+		HDMIRX_INFO("Release hwbuf[0] done");
+	}
+
+	if (dma_q->hwbuf[1] != NULL) {
+		vb2_buffer_done(&dma_q->hwbuf[1]->vb, VB2_BUF_STATE_ERROR);
+		dma_q->hwbuf[1] = NULL;
+		HDMIRX_INFO("Release hwbuf[1] done");
+	}
+
+}
+
+void hdmi_stop_streaming(struct vb2_queue *vq)
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+
+	HDMIRX_INFO("[%s]", __func__);
+
+	if (is_clock_enabled(CLK_MIPI) && hdmi.rx_5v_state)
+		stop_mipi_process();
+
+	hdmi_stop_generating(dev);
+
+	deregister_mipi_ion(dev);
+}
+
+void hdmi_unlock(struct vb2_queue *vq)
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+
+	mutex_unlock(&dev->mutex);
+}
+
+void hdmi_lock(struct vb2_queue *vq)
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+
+	mutex_lock(&dev->mutex);
+}
+
+void  rx5v_do_task(struct v4l2_hdmi_dev *dev)
+{
+	int state;
+
+	if (hdmi.gpio_5v_det < 0)
+		state = Cbus_GetRx5v();
+	else
+		state = gpio_get_value(hdmi.gpio_5v_det);
+
+	if (!state && hdmi.rx_5v_state) {
+		/* RX unplugged */
+		HDMIRX_INFO("Cable Unplugged");
+
+		stop_mipi_process();
+		/* Stop DMA */
+		set_hdmirx_wrapper_control_0(-1, 0, -1, -1, -1, -1);
+		/* Disable wrapper interrupt */
+		set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+		drvif_Hdmi_Release();
+		memset(&hdmi_ioctl_struct, 0, sizeof(hdmi_ioctl_struct));
+		SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		mipi_top.hdmi_rx_init = 0;
+
+		hdmi.rx_5v_state = 0;
+		Hdmi_SetHPD(0);
+
+		/* Delay for RX service turn off audio, prevent AudioFW crash */
+		update_hdmirx_switch_state(dev);
+		usleep_range(280000, 300000);
+
+		/* Stop hdmirx */
+		set_hdmirx_wrapper_control_0(-1, -1, -1, -1, -1, 0);
+		/* Disable RX clock */
+		hdmirx_clock_control(CLK_HDMIRX|CLK_RXWRAP|CLK_MIPI, CTL_DISABLE);
+	} else if (state && !hdmi.rx_5v_state) {
+		/* RX plugged */
+		HDMIRX_INFO("Cable Plugged");
+
+		/* Enable RX clock */
+		hdmirx_clock_control(CLK_HDMIRX|CLK_RXWRAP|CLK_MIPI, CTL_ENABLE);
+		/* Enable hdmirx */
+		set_hdmirx_wrapper_control_0(-1, -1, -1, -1, -1, 1);
+		hdmi.rx_5v_state = 1;
+	}
+}
+
+void hdmi_rx_process(void)
+{
+	unsigned char ret;
+	static int state = 0;
+
+	if (mipi_top.hdmi_rx_init == 0) {
+		hdmi_related_wrapper_init();
+		HdmiRx_EnableEDID();
+		drvif_Hdmi_Init();
+		drvif_Hdmi_InitSrc(HDMI_CHANNEL0);
+		mipi_top.hdmi_rx_init = 1;
+		state = 0;
+		Hdmi_SetHPD(1);/* set hotplug pin high */
+	}
+
+	switch (state) {
+	case 0:
+		if (hdmi_ioctl_struct.DEF_ready) {
+			if (drvif_Hdmi_DetectMode() == _MODE_SUCCESS)
+				state++;
+		}
+		break;
+	case 1:
+		ret = drvif_Hdmi_CheckMode();
+		if ((ret == FALSE) && hdmi_ioctl_struct.detect_done) {
+			HDMIRX_INFO("Check mode is false, restart HDMI Rx wrapper detection ret(%d)\n", ret);
+			state = 0;
+			restartHdmiRxWrapperDetection();
+		} else if (hdmi_ioctl_struct.detect_done == 0) {
+			HDMIRX_INFO("Check mode is fine, but detect_done=0 ret(%d)\n", ret);
+			state = 0;
+		}
+		break;
+	default:
+		state = 0;
+		break;
+	}
+}
+
+static inline void update_hdmirx_switch_state(struct v4l2_hdmi_dev *dev)
+{
+	unsigned char hdcp_state = 0;
+	static unsigned char audio_count = 0;
+
+	if (hdmi_ioctl_struct.measure_ready != switch_get_state(&dev->sdev)) {
+		switch_set_state(&dev->sdev, hdmi_ioctl_struct.measure_ready);
+		pr_err("\033[0;31m[HDMI RX] switch hdmi rx state to %d\033[m\n",
+			hdmi_ioctl_struct.measure_ready);
+	}
+
+
+	if (!hdmi_ioctl_struct.audio_detect_done)
+		audio_count = 0;
+
+	if (hdmi_ioctl_struct.audio_detect_done != switch_get_state(&dev->asdev)) {
+		if (hdmi_ioctl_struct.audio_detect_done)
+			audio_count++;
+
+		if ((!hdmi_ioctl_struct.audio_detect_done) || (audio_count >= 10)) {
+			switch_set_state(&dev->asdev, hdmi_ioctl_struct.audio_detect_done);
+			HDMIRX_INFO("switch audio detect state to %d", hdmi_ioctl_struct.audio_detect_done);
+		}
+	}
+
+	if ((hdmi_ioctl_struct.hdcp_state == HDCPRX_STATE_1PX_ON) ||
+		(hdmi_ioctl_struct.hdcp_state == HDCPRX_STATE_2P2_ON))
+		hdcp_state = 1;
+
+	if (hdcp_state != switch_get_state(&dev->hsdev)) {
+		switch_set_state(&dev->hsdev, hdcp_state);
+		HDMIRX_INFO("switch hdcp state to %d", hdcp_state);
+	}
+}
+
+static int mipi_top_thread(void *arg)
+{
+	unsigned int i;
+	struct v4l2_hdmi_dev *dev = arg;
+
+	for (;;) {
+		if (kthread_should_stop())
+			break;
+
+		rx5v_do_task(dev);
+
+		if (mipi_top.src_sel == 1) {
+			if (hdmi.rx_5v_state) {
+				hdmi_rx_process();
+				for (i = 0; i < 3; i++) {
+					update_hdmirx_switch_state(dev);
+					usleep_range(70000, 75000);/* 70ms~75ms */
+					if (mipi_top.hdmi_rx_init)
+						rtd_hdmiPhy_ISR();
+				}
+			} else {
+				msleep(250);
+			}
+		}
+
+	}
+	return 0;
+}
+
+
+int hdmirx_rtk_drv_probe(struct platform_device *pdev)
+{
+	int ret, i;
+	u32 irq;
+	struct v4l2_hdmi_dev *hdmi_dev;
+	struct switch_dev *sdev;/* video switch device */
+	struct switch_dev *asdev;/* audio switch device */
+	struct switch_dev *hsdev; /* hdcp switch device */
+	const u32 *edid_table_pro;
+	int edid_cell_size;
+	HDMIRX_DTS_EDID_TBL_T dts_edid_table;
+
+	/* Get clock controller */
+	hdmirx_clock_init(pdev);
+
+	/* Release reset, enable clock */
+	hdmirx_clock_control(CLK_ALL, CTL_ENABLE);
+
+	/* Disable RX clock for saving power */
+	hdmirx_clock_control(CLK_HDMIRX | CLK_RXWRAP | CLK_MIPI, CTL_DISABLE);
+
+	if (WARN_ON(!(pdev->dev.of_node))) {
+		HDMIRX_ERROR("[%s] No device node", __func__);
+		ret = -ENODEV;
+		goto exit;
+	}
+
+	/* Initialize global variables */
+	memset(&mipi_top, 0, sizeof(mipi_top));
+	memset(&hdmi, 0, sizeof(hdmi));
+	memset(&hdmi_ioctl_struct, 0, sizeof(hdmi_ioctl_struct));
+	memset(&hdmirx_edid, 0, sizeof(hdmirx_edid));
+
+	for (i = 0; i < HDMI_RX_REG_BLOCK_NUM; i++) {
+		hdmi_rx_base[i] = of_iomap(pdev->dev.of_node, i);
+		WARN(!(hdmi_rx_base[i]), "Unable to map HDMI RX base registers\n");
+	}
+
+	/* 90KHz timer */
+	clk90k_vaddr[0] = ioremap(0x9801B540, 0x4);/* LK90K_LO */
+	clk90k_vaddr[1] = ioremap(0x9801B544, 0x4);/* CLK90K_HI */
+
+	/* Save EDID table */
+	edid_table_pro = of_get_property(pdev->dev.of_node, "Realtek,edid-table", &edid_cell_size);
+	if (edid_table_pro && (edid_cell_size == 1024)) {
+		edid_cell_size = edid_cell_size / 4;/*Each Read is 4bytes (1world), so divide it by 4*/
+		for (i = 0; i < edid_cell_size; i++)
+			dts_edid_table.EDID[i] = (unsigned char) of_read_number(edid_table_pro, 1 + i);
+
+		HdmiRx_Save_DTS_EDID_Table(&dts_edid_table);
+	} else {
+		HDMIRX_ERROR("[%s] Parsing EDID table content failed", __func__);
+	}
+
+	/* Save HDMI2.0 EDID table */
+	edid_table_pro = of_get_property(pdev->dev.of_node, "Realtek,edid2p0-table", &edid_cell_size);
+	if (edid_table_pro && (edid_cell_size == 1024)) {
+		/*Each Read is 4bytes (1world), so divide it by 4*/
+		edid_cell_size = edid_cell_size / 4;
+		for (i = 0; i < edid_cell_size; i++)
+			dts_edid_table.EDID[i] = (unsigned char) of_read_number(edid_table_pro, 1 + i);
+
+		HdmiRx_Save_DTS_EDID2p0_Table(&dts_edid_table);
+	} else {
+		HDMIRX_ERROR("[%s] Parsing 2.0 EDID table content failed", __func__);
+	}
+
+	/* HPD control GPIO */
+	hdmi.gpio_hpd_ctrl = of_get_named_gpio(pdev->dev.of_node, "gpio-rx-hpd-ctrl", 0);
+	if (hdmi.gpio_hpd_ctrl < 0) {
+		HDMIRX_ERROR("Get gpio-rx-hpd-ctrl fail");
+		ret = -ENODEV;
+		goto exit;
+	} else {
+		HDMIRX_INFO("HPD control gpio(%d)", hdmi.gpio_hpd_ctrl);
+		if (!gpio_is_valid(hdmi.gpio_hpd_ctrl))
+			HDMIRX_ERROR("gpio %d is not valid", hdmi.gpio_hpd_ctrl);
+		if (gpio_request(hdmi.gpio_hpd_ctrl, pdev->dev.of_node->name))
+			HDMIRX_ERROR("Request gpio %d fail", hdmi.gpio_hpd_ctrl);
+	}
+	Hdmi_SetHPD(0);
+
+	/* 5V detect GPIO */
+	hdmi.gpio_5v_det = of_get_named_gpio(pdev->dev.of_node, "gpio-5v-detect", 0);
+	if (hdmi.gpio_5v_det < 0) {
+		HDMIRX_INFO("Use cbus 5V detect");
+	} else {
+		HDMIRX_INFO("5V detect gpio(%d)", hdmi.gpio_5v_det);
+		if (!gpio_is_valid(hdmi.gpio_5v_det))
+			HDMIRX_ERROR("gpio %d is not valid", hdmi.gpio_5v_det);
+		if (gpio_request(hdmi.gpio_5v_det, pdev->dev.of_node->name))
+			HDMIRX_ERROR("Request gpio %d fail", hdmi.gpio_5v_det);
+
+		gpio_direction_input(hdmi.gpio_5v_det);
+	}
+
+	/* Register v4l2 device */
+	hdmi_dev = kzalloc(sizeof(*hdmi_dev), GFP_KERNEL);
+	if (!hdmi_dev) {
+		HDMIRX_ERROR("[%s] kzalloc fail", __func__);
+		ret = -ENOMEM;
+		goto exit;
+	}
+	snprintf(hdmi_dev->v4l2_dev.name, sizeof(hdmi_dev->v4l2_dev.name), "v4l2_mipi_top");
+	ret = v4l2_device_register(NULL, &hdmi_dev->v4l2_dev);
+	if (ret < 0) {
+		HDMIRX_ERROR("[%s] Register v4l2 device fail", __func__);
+		goto free_dev;
+	}
+	if (ret)
+		goto free_dev;
+
+	pdev->dev.platform_data = hdmi_dev;
+
+	/* Set default value */
+	hdmi_dev->width = 1920;
+	hdmi_dev->height = 1080;
+	hdmi_dev->bpp = 12;/* OUT_YUV420 */
+
+	mipi_top.src_sel = 1;
+
+	/* Initialize locks */
+	spin_lock_init(&hdmi_dev->slock);
+	mutex_init(&hdmi_dev->mutex);
+
+	/* Init video dma queues */
+	INIT_LIST_HEAD(&hdmi_dev->hdmidq.active);
+
+	if (register_video_device(hdmi_dev) < 0) {
+		HDMIRX_ERROR("[%s] Register video device fail", __func__);
+		goto free_dev;
+	}
+
+	/* Register interrupt handle */
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	WARN(!(irq), "[HDMI RX] irq map fail\n");
+	if (request_irq(irq, hdmirx_mipi_isr, IRQF_SHARED, "mipi", hdmi_dev))
+		HDMIRX_ERROR("Cannot register IRQ %d", irq);
+	else
+		HDMIRX_INFO("mipi irq(%d)", irq);
+
+	/* Register switch device */
+	sdev = &hdmi_dev->sdev;
+	memset(sdev, 0, sizeof(*sdev));
+	sdev->name = "rx_video";
+	ret = switch_dev_register(sdev);
+	if (ret < 0)
+		goto unreg_vdev;
+	switch_set_state(&hdmi_dev->sdev, 0);
+
+	/* Register audio switch device */
+	asdev = &hdmi_dev->asdev;
+	memset(asdev, 0, sizeof(*asdev));
+	asdev->name = "rx_audio";
+	ret = switch_dev_register(asdev);
+	if (ret < 0)
+		goto unreg_vdev;
+	switch_set_state(&hdmi_dev->asdev, 0);
+
+	/* Register hdcp switch device */
+	hsdev = &hdmi_dev->hsdev;
+	hsdev->name = "rx_hdcp";
+	ret = switch_dev_register(hsdev);
+	if (ret < 0)
+		goto unreg_vdev;
+	switch_set_state(&hdmi_dev->hsdev, 0);
+
+	/* Register sysfs */
+	register_hdmirx_sysfs(pdev);
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+	register_hdcp2p2_device();
+#endif
+
+	/* Init reset MIPI clock work function */
+	INIT_WORK(&mipi_top.mipi_reset_work, mipi_reset_work_func);
+
+	/* HDMI RX thread */
+	hdmi_hw_tsk = kthread_create(mipi_top_thread, hdmi_dev, "mipi_hw_thread");
+	if (IS_ERR(hdmi_hw_tsk)) {
+		ret = PTR_ERR(hdmi_hw_tsk);
+		hdmi_hw_tsk = NULL;
+		goto unreg_vdev;
+	}
+	wake_up_process(hdmi_hw_tsk);
+
+	return 0;
+
+unreg_vdev:
+	video_unregister_device(&hdmi_dev->vdev);
+free_dev:
+	kfree(hdmi_dev);
+exit:
+	return ret;
+}
+
+int hdmirx_rtk_drv_remove(struct platform_device *pdev)
+{
+	struct fb_info *info = platform_get_drvdata(pdev);
+
+	HDMIRX_INFO("driver remove\n");
+	if (info) {
+		unregister_framebuffer(info);
+		framebuffer_release(info);
+	}
+	return 0;
+}
+
+#ifdef CONFIG_SUSPEND
+static int hdmirx_rtk_drv_suspend(struct device *dev)
+{
+	struct platform_device *pdev;
+	struct v4l2_hdmi_dev *hdmi_dev;
+
+	HDMIRX_INFO(" Enter %s", __func__);
+
+	kthread_stop(hdmi_hw_tsk);
+
+	/* Switch rx state to 0 */
+	pdev = to_platform_device(dev);
+	hdmi_dev = pdev->dev.platform_data;
+	if (switch_get_state(&hdmi_dev->sdev)) {
+		pr_err("\033[0;31m[HDMI RX] switch hdmi rx state to %d\033[m\n", 0);
+		switch_set_state(&hdmi_dev->sdev, 0);
+	}
+
+	if (hdmi.rx_5v_state) {
+		stop_mipi_process();
+		/* Stop DMA */
+		set_hdmirx_wrapper_control_0(-1, 0, -1, -1, -1, -1);
+		/* Disable wrapper interrupt */
+		set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+		drvif_Hdmi_Release();
+		memset(&hdmi_ioctl_struct, 0, sizeof(hdmi_ioctl_struct));
+		SET_HDMI_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+		SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		mipi_top.hdmi_rx_init = 0;
+		hdmi.rx_5v_state = 0;
+
+		/* Stop hdmirx */
+		set_hdmirx_wrapper_control_0(-1, -1, -1, -1, -1, 0);
+		/* Disable  RX clock */
+		hdmirx_clock_control(CLK_HDMIRX | CLK_RXWRAP | CLK_MIPI, CTL_DISABLE);
+	}
+
+	Hdmi_SetHPD(0);
+
+	if (rtk_suspend_wakeup_flags_get()&(0x1U << 5))
+		HDMIRX_INFO("CEC wakeup is enabled, skip turn off cbus clock");
+	else
+		hdmirx_clock_control(CLK_CBUS, CTL_DISABLE);/* Disable  Cbus clock */
+
+	HDMIRX_INFO(" Exit %s", __func__);
+	return 0;
+}
+
+static int hdmirx_rtk_drv_resume(struct device *dev)
+{
+	struct platform_device *pdev;
+	struct v4l2_hdmi_dev *hdmi_dev;
+
+	HDMIRX_INFO("Enter %s", __func__);
+
+	pdev = to_platform_device(dev);
+	hdmi_dev = pdev->dev.platform_data;
+
+	/* Release reset, enable clock */
+	if (rtk_suspend_wakeup_flags_get()&(0x1U << 5)) {
+		hdmirx_clock_control(CLK_HDMIRX | CLK_RXWRAP | CLK_MIPI, CTL_ENABLE);
+		HDMIRX_INFO("CEC wakeup is enabled, only turn on hdmirx clock");
+	} else {
+		hdmirx_clock_control(CLK_ALL, CTL_ENABLE);
+	}
+
+	/* Disable RX clock for saving power */
+	hdmirx_clock_control(CLK_HDMIRX | CLK_RXWRAP | CLK_MIPI, CTL_DISABLE);
+
+	Hdmi_SetHPD(0);
+	hdmi_hw_tsk = kthread_run(mipi_top_thread, hdmi_dev, "mipi_hw_thread");
+
+	HDMIRX_INFO("Exit %s", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_hdmirx_pm_ops = {
+	.suspend    = hdmirx_rtk_drv_suspend,
+	.resume     = hdmirx_rtk_drv_resume,
+};
+#endif /* CONFIG_SUSPEND */
+
+static const struct of_device_id hdmirx_rtk_dt_ids[] = {
+	{ .compatible = "Realtek,rtk-mipi-top", },
+	{},
+};
+
+struct platform_driver hdmirx_rtk_driver = {
+	.probe  = hdmirx_rtk_drv_probe,
+	.remove = hdmirx_rtk_drv_remove,
+	.driver = {
+		.name   = "rtk-mipi-top",
+		.owner  = THIS_MODULE,
+		.of_match_table = of_match_ptr(hdmirx_rtk_dt_ids),
+#ifdef CONFIG_SUSPEND
+		.pm = &rtk_hdmirx_pm_ops,
+#endif /* CONFIG_SUSPEND */
+	},
+};
+
+static int __init hdmirx_init(void)
+{
+	int retval = 0;
+
+	HDMIRX_INFO("driver init");
+	retval = platform_driver_register(&hdmirx_rtk_driver);
+	HDMIRX_INFO("driver init done");
+
+	return retval;
+}
+
+static void __exit hdmi_exit(void)
+{
+	HDMIRX_INFO("driver exit");
+	// TODO:
+	platform_driver_unregister(&hdmirx_rtk_driver);
+}
+
+module_init(hdmirx_init);
+module_exit(hdmi_exit);
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Realtek HDMI RX kernel module");
diff --git a/drivers/media/platform/rtk_hdmirx/rtd129x/v4l2_hdmi_dev.h b/drivers/media/platform/rtk_hdmirx/rtd129x/v4l2_hdmi_dev.h
new file mode 100755
index 00000000..1959e33
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd129x/v4l2_hdmi_dev.h
@@ -0,0 +1,158 @@
+/*
+ * v4l2_hdmi_dev.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef V4L2_HDMI_DEV_H
+#define V4L2_HDMI_DEV_H
+
+#include <linux/module.h>
+#include <linux/errno.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/font.h>
+#include <linux/mutex.h>
+#include <linux/videodev2.h>
+#include <linux/kthread.h>
+#include <linux/freezer.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/interrupt.h>
+#include <linux/of.h>
+#include <linux/platform_device.h>
+#include <linux/dma-contiguous.h>
+#include <linux/device.h>
+#include <linux/fb.h>
+#include <linux/switch.h>
+
+#include <media/videobuf2-vmalloc.h>
+#include <media/videobuf2-dma-contig.h>
+#include <media/videobuf2-core.h>
+#include <media/v4l2-device.h>
+#include <media/v4l2-ioctl.h>
+#include <media/v4l2-ctrls.h>
+#include <media/v4l2-fh.h>
+#include <media/v4l2-event.h>
+#include <media/v4l2-common.h>
+#include <media/videobuf2-memops.h>
+
+#include <asm/page.h>
+#include <asm/memory.h>
+
+#include "ion/ion.h"
+#include "uapi/ion.h"
+#include "uapi/ion_rtk.h"
+
+
+#define __RTK_HDMI_RX_DEBUG__	0
+
+#if __RTK_HDMI_RX_DEBUG__
+#define HDMIRX_DEBUG(format, ...) pr_err("[HDMI RX DBG]" format "\n", ## __VA_ARGS__)
+#else
+#define HDMIRX_DEBUG(format, ...)
+#endif
+
+#define HDMIRX_ERROR(format, ...) printk(KERN_ERR "[HDMI RX ERR]" format "\n", ## __VA_ARGS__)
+#define HDMIRX_INFO(format, ...) printk(KERN_WARNING "[HDMI RX]" format "\n", ## __VA_ARGS__)
+
+
+#define roundup16(x)	roundup(x, 16)
+
+
+/* buffer for one video frame */
+struct hdmi_buffer {
+	/* common vb2_v4l2_buffer stuff -- must be first */
+	struct vb2_buffer vb;
+	__u32 flags;
+	__u32 field;
+	struct v4l2_timecode timecode;
+	__u32 sequence;
+	/* Private data */
+	u32		phys;
+	struct list_head	list;
+};
+
+struct hdmi_dmaqueue {
+	atomic_t			rcnt;/* Number of buffers already processed by hw */
+	atomic_t			qcnt;/* Number of buffers waiting for hw process */
+	struct list_head	active;
+	struct hdmi_buffer	*hwbuf[2];
+	unsigned char skip_frame[2];
+};
+
+struct mipi_ion_buf {
+	struct ion_client *client;
+	struct ion_handle *handle;
+	ion_phys_addr_t phys_addr;
+};
+
+struct v4l2_hdmi_dev {
+	struct v4l2_device		v4l2_dev;
+	struct video_device		vdev;
+	struct switch_dev		sdev;/* Video switch device */
+	struct switch_dev		asdev;/* Audio switch device */
+	struct switch_dev		hsdev;/* HDCP switch device */
+
+	spinlock_t		slock;
+	struct mutex	mutex; /* Protects queue */
+
+	struct hdmi_dmaqueue	   hdmidq;
+
+	/* video capture */
+	unsigned int		   width;
+	unsigned int		   height;
+	unsigned int		   outfmt;
+	unsigned int		   bpp;
+	struct vb2_queue	   vb_hdmidq;
+
+	struct mipi_ion_buf ion_buf;
+};
+
+int hdmi_queue_setup(struct vb2_queue *vq,
+		unsigned int *nbuffers, unsigned int *nplanes,
+		unsigned int sizes[], struct device *alloc_devs[]);
+int hdmi_buffer_prepare(struct vb2_buffer *vb);
+void hdmi_buffer_finish(struct vb2_buffer *vb);
+void hdmi_buffer_queue(struct vb2_buffer *vb);
+int hdmi_start_streaming(struct vb2_queue *vq, unsigned int count);
+void hdmi_stop_streaming(struct vb2_queue *vq);
+void hdmi_unlock(struct vb2_queue *vq);
+void hdmi_lock(struct vb2_queue *vq);
+
+static const struct vb2_ops hdmi_qops = {
+	.queue_setup     = hdmi_queue_setup,
+	.buf_prepare     = hdmi_buffer_prepare,
+	.buf_finish      = hdmi_buffer_finish,
+	.buf_queue       = hdmi_buffer_queue,
+	.start_streaming = hdmi_start_streaming,
+	.stop_streaming  = hdmi_stop_streaming,
+	.wait_prepare    = hdmi_unlock,
+	.wait_finish     = hdmi_lock,
+};
+
+struct mipi_vb2_vmalloc_buf {
+	void *vaddr;
+	struct page **pages;
+	struct vm_area_struct *vma;
+	int write;
+	u32 size;
+	unsigned int n_pages;
+	atomic_t refcount;
+	struct vb2_vmarea_handler handler;
+	struct dma_buf *dbuf;
+};
+
+int hdmirx_queue_init(struct v4l2_hdmi_dev *dev, struct vb2_queue *q, enum v4l2_memory memory);
+int hdmirx_rtk_drv_probe(struct platform_device *pdev);
+int hdmirx_rtk_drv_remove(struct platform_device *pdev);
+
+#endif/* V4L2_HDMI_DEV_H */
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/Makefile b/drivers/media/platform/rtk_hdmirx/rtd161x/Makefile
new file mode 100644
index 00000000..15c8d2b
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/Makefile
@@ -0,0 +1,23 @@
+
+
+OBJNAME := v4l2_hdmi_rx
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmirx/rtd161x/
+ccflags-y += -I$(srctree)/drivers/video/fbdev/rtk
+ccflags-y += -I$(srctree)/drivers/staging/android
+$(OBJNAME)-objs := v4l2_hdmi_dev.o hdmirx_video_dev.o hdmirx_clk_ctrl.o mipi_wrapper.o \
+	hdmirx_wrapper.o hdmirx_reg.o hdmirx_hdcp.o hdmirx_repeater.o hdmirx_sysfs.o
+
+ifdef CONFIG_RTK_HDCP1x_REPEATER
+$(OBJNAME)-objs += cipher.lib
+endif
+
+ifdef CONFIG_RTK_HDCPRX_2P2
+$(OBJNAME)-objs += hdmirx_hdcp2p2.o hdcp2p2_dev.o
+endif
+
+#obj-m	+= v4l2_hdmi_rx.o
+obj-$(CONFIG_RTK_HDMIRX)	+= v4l2_hdmi_rx.o
+obj-$(CONFIG_RTK_HDMIRX)	+= rx_drv/
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/cipher.lib b/drivers/media/platform/rtk_hdmirx/rtd161x/cipher.lib
new file mode 100644
index 00000000..501d9df
Binary files /dev/null and b/drivers/media/platform/rtk_hdmirx/rtd161x/cipher.lib differ
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdcp2p2_dev.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdcp2p2_dev.c
new file mode 100644
index 00000000..cbe66be
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdcp2p2_dev.c
@@ -0,0 +1,227 @@
+/*
+ * hdmirx_hdcp2p2_dev.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/miscdevice.h>
+
+#include "hdcp2p2_dev.h"
+#include "hdmirx_hdcp2p2.h"
+#include "v4l2_hdmi_dev.h"
+
+
+struct miscdevice hdcp2p2_mdev;
+
+long ops_get_hdcp2p2_msg(void __user *argp)
+{
+	long ret;
+	struct rx_hdcp22_msg msg;
+
+	ret = 0;
+
+	get_hdcp2p2_msg(&msg);
+
+	if (copy_to_user(argp, &msg, sizeof(msg))) {
+		HDMIRX_ERROR("%s:failed to copy to user !", __func__);
+		ret = -EFAULT;
+	}
+
+	return ret;
+}
+
+long ops_write_data_to_tx(void __user *argp)
+{
+	long ret;
+	struct rx_hdcp22_msg msg;
+
+	ret = 0;
+
+	if (copy_from_user(&msg, argp, sizeof(msg))) {
+		HDMIRX_ERROR("%s:failed to copy from user !", __func__);
+		ret = -EFAULT;
+		goto exit;
+	}
+
+	write_hdcp2p2_msg_to_tx(&msg);
+
+exit:
+	return ret;
+}
+
+long ops_get_stream_msg(void __user *argp)
+{
+	long ret;
+	struct rx_hdcp22_msg msg;
+
+	ret = 0;
+
+	get_stream_msg(&msg);
+
+	if (copy_to_user(argp, &msg, sizeof(msg))) {
+		HDMIRX_ERROR("%s:failed to copy to user !", __func__);
+		ret = -EFAULT;
+	}
+
+	return ret;
+}
+
+long ops_set_ks(void __user *argp)
+{
+	long ret;
+	struct rx_hdcp22_ks ks;
+
+	ret = 0;
+
+	if (copy_from_user(&ks, argp, sizeof(ks))) {
+		HDMIRX_ERROR("%s:failed to copy from user !", __func__);
+		ret = -EFAULT;
+		goto exit;
+	}
+
+	set_hdcp2p2_ks(&ks);
+
+exit:
+	return ret;
+}
+
+long ops_get_msg_done(void __user *argp)
+{
+	long ret;
+	int done;
+
+	ret = 0;
+
+	get_hdcp2p2_msg_done(&done);
+
+	if (copy_to_user(argp, &done, sizeof(done))) {
+		HDMIRX_ERROR("%s:failed to copy to user !", __func__);
+		ret = -EFAULT;
+	}
+
+	return ret;
+}
+
+long ops_set_switch_state(void __user *argp)
+{
+	long ret;
+	int state;
+
+	ret = 0;
+
+	if (copy_from_user(&state, argp, sizeof(state))) {
+		HDMIRX_ERROR("%s:failed to copy from user !", __func__);
+		ret = -EFAULT;
+		goto exit;
+	}
+
+	set_hdcp2p2_switch_state(&state);
+
+exit:
+	return ret;
+}
+
+int hdcp2p2_open(struct inode *inode, struct file *filp)
+{
+	if (nonseekable_open(inode, filp))
+		return -ENODEV;
+
+	return 0;
+}
+
+long hdcp2p2_ioctl(struct file *fd, unsigned int cmd, unsigned long arg)
+{
+	void __user *argp = (void __user *)arg;
+	unsigned long ret_val;
+
+	HDMIRX_DEBUG("[HDCP2.2]ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+		_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+
+	ret_val = -ENOTTY;
+
+	switch (cmd) {
+	case HDCP22IOC_INIT:
+		init_hdcp2p2_waitqueue();
+		ret_val = 0;
+		break;
+	case HDCP22IOC_GET_HDCP22_MSG:
+		ret_val = ops_get_hdcp2p2_msg(argp);
+		break;
+	case HDCP22IOC_WRITE_DATA_TO_TX:
+		ret_val = ops_write_data_to_tx(argp);
+		break;
+	case HDCP22IOC_GET_STREAM_MSG:
+		ret_val = ops_get_stream_msg(argp);
+		break;
+	case HDCP22IOC_SET_KS:
+		ret_val = ops_set_ks(argp);
+		break;
+	case HDCP22IOC_CLR_MSG_DONE:
+		Clear_Hdmi_hdcp_2_2_Read_Status();
+		ret_val = 0;
+		break;
+	case HDCP22IOC_GET_MSG_DONE:
+		ret_val = ops_get_msg_done(argp);
+		break;
+	case HDCP22IOC_SET_STATUS_READY:
+		Set_Rx_status_Ready();
+		ret_val = 0;
+		break;
+	case HDCP22IOC_SET_DOWNSTREAM_DONE:
+		DownStream_done();
+		ret_val = 0;
+		break;
+	case HDCP22IOC_SET_SWITCH_STATE:
+		ret_val = ops_set_switch_state(argp);
+		break;
+	default:
+		HDMIRX_ERROR("[HDCP2.2]Unknown ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+			_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+		break;
+	}
+
+	return ret_val;
+}
+
+#if defined(CONFIG_CPU_V7)
+long compat_hdcp2p2_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	if (!file->f_op->unlocked_ioctl)
+		return -ENOTTY;
+	else
+		return file->f_op->unlocked_ioctl(file, cmd, arg);
+}
+#else
+long compat_hdcp2p2_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	if (!file->f_op->unlocked_ioctl)
+		return -ENOTTY;
+	else
+		return file->f_op->unlocked_ioctl(file, cmd, (unsigned long)compat_ptr(arg));
+}
+#endif
+
+const struct file_operations rxhdcp2p2_fops = {
+	.owner = THIS_MODULE,
+	.open = hdcp2p2_open,
+	.unlocked_ioctl = hdcp2p2_ioctl,
+	.compat_ioctl = compat_hdcp2p2_ioctl,
+};
+
+void register_hdcp2p2_device(void)
+{
+
+	hdcp2p2_mdev.minor = MISC_DYNAMIC_MINOR;
+	hdcp2p2_mdev.name = "rxhdcp2p2";
+	hdcp2p2_mdev.mode = 0666;
+	hdcp2p2_mdev.fops = &rxhdcp2p2_fops;
+
+	if (misc_register(&hdcp2p2_mdev))
+		HDMIRX_ERROR("[HDCP2.2]Register misc dev fail");
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdcp2p2_dev.h b/drivers/media/platform/rtk_hdmirx/rtd161x/hdcp2p2_dev.h
new file mode 100644
index 00000000..24d9c74
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdcp2p2_dev.h
@@ -0,0 +1,41 @@
+/*
+ * hdcp2p2_dev.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDCP2P2_DEV_H_
+#define __HDCP2P2_DEV_H_
+
+struct rx_hdcp22_msg {
+	unsigned int bLen;
+	unsigned char msg[864];
+	unsigned char g_RX_state;
+} __attribute__ ((packed));
+
+
+struct rx_hdcp22_ks {
+	unsigned char bks[16];
+} __attribute__ ((packed));
+
+
+#define HDCP22IOC_INIT				_IOWR('V', 0, int)
+#define HDCP22IOC_GET_HDCP22_MSG	_IOWR('V', 1, struct rx_hdcp22_msg)
+#define HDCP22IOC_WRITE_DATA_TO_TX	_IOWR('V', 2, struct rx_hdcp22_msg)
+#define HDCP22IOC_GET_STREAM_MSG	_IOWR('V', 3, struct rx_hdcp22_msg)
+#define HDCP22IOC_SET_KS			_IOWR('V', 4, struct rx_hdcp22_ks)
+#define HDCP22IOC_CLR_MSG_DONE		_IOWR('V', 5, int)
+#define HDCP22IOC_GET_MSG_DONE		_IOWR('V', 6, int)
+#define HDCP22IOC_SET_STATUS_READY	_IOWR('V', 7, int)
+#define HDCP22IOC_SET_DOWNSTREAM_DONE	_IOWR('V', 8, int)
+#define HDCP22IOC_SET_SWITCH_STATE	_IOWR('V', 9, int)
+
+
+void register_hdcp2p2_device(void);
+
+#endif /* __HDCP2P2_DEV_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_clk_ctrl.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_clk_ctrl.c
new file mode 100644
index 00000000..6b47665
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_clk_ctrl.c
@@ -0,0 +1,183 @@
+/*
+ * hdmirx_clk_ctrl.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/of.h>
+
+#include <linux/reset.h>
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+#include <linux/pm_runtime.h>
+#include <soc/realtek/power-control.h>
+
+#include "hdmirx_clk_ctrl.h"
+
+static struct device *phdmirx_dev;
+unsigned int init_flag;
+struct reset_control *reset_mipi;
+struct reset_control *reset_rxwrap;
+struct reset_control *reset_hdmirx;
+struct reset_control *reset_cbus_iso;
+struct reset_control *reset_cbustx_iso;
+struct reset_control *reset_cbusrx_iso;
+struct clk *clk_mipi;
+struct clk *clk_hdmirx;
+struct clk *clk_cbus_osc_iso;
+struct clk *clk_cbus_iso;
+struct clk *clk_cbustx_iso;
+struct clk *clk_cbusrx_iso;
+struct power_control *pc_hdmirx;
+
+unsigned char is_clock_enabled(HDMI_CLK_TYPE clk_type)
+{
+	unsigned char ret_value;
+
+	ret_value = false;
+
+	if (clk_type&CLK_MIPI)
+		ret_value = __clk_is_enabled(clk_mipi);
+
+	return ret_value;
+}
+
+void hdmirx_reset_control(HDMI_CLK_TYPE clk_type, HDMI_CLK_CTL enable)
+{
+	if (clk_type&RST_MIPI) {
+		if (enable)
+			reset_control_deassert(reset_mipi);
+		else
+			reset_control_assert(reset_mipi);
+	}
+}
+
+void hdmirx_clock_control(HDMI_CLK_TYPE clk_type, HDMI_CLK_CTL enable)
+{
+	if (clk_type&CLK_HDMIRX) {
+
+		if ((!reset_hdmirx) || (!clk_hdmirx))
+			HDMIRX_ERROR("[%s] CLK_HDMIRX fail", __func__);
+
+		if (enable) {
+			reset_control_deassert(reset_hdmirx);
+
+			if (init_flag & CLK_HDMIRX) {
+				clk_enable(clk_hdmirx);
+			} else {
+				clk_prepare_enable(clk_hdmirx);
+				init_flag |= CLK_HDMIRX;
+			}
+
+			power_control_power_on(pc_hdmirx);
+		} else { /* if not enable */
+			power_control_power_off(pc_hdmirx);
+			clk_disable(clk_hdmirx);
+			reset_control_assert(reset_hdmirx);
+		}
+
+	} /* end if if (clk_type&CLK_HDMIRX) */
+
+	if (clk_type&CLK_RXWRAP) {
+
+		if (!reset_rxwrap)
+			HDMIRX_ERROR("[%s] CLK_RXWRAP fail", __func__);
+
+		if (enable)
+			reset_control_deassert(reset_rxwrap);
+		else
+			reset_control_assert(reset_rxwrap);
+	}
+
+	if (clk_type&CLK_MIPI) {
+
+		if ((!reset_mipi) || (!clk_mipi))
+			HDMIRX_ERROR("[%s] CLK_MIPI fail", __func__);
+
+		if (enable) {
+			reset_control_deassert(reset_mipi);
+
+			if (init_flag&CLK_MIPI) {
+				clk_enable(clk_mipi);
+			} else {
+				clk_prepare_enable(clk_mipi);
+				init_flag |= CLK_MIPI;
+			}
+
+		} else { /* if not enable */
+			clk_disable(clk_mipi);
+			reset_control_assert(reset_mipi);
+		}
+	} /* end of if (clk_type&CLK_MIPI)*/
+
+	if (clk_type&CLK_CBUS) {
+
+		if ((!reset_cbus_iso) || (!reset_cbustx_iso) ||
+			(!reset_cbusrx_iso) || (!clk_cbus_osc_iso) ||
+			(!clk_cbus_iso) || (!clk_cbustx_iso) || (!clk_cbusrx_iso))
+			HDMIRX_ERROR("[%s] CLK_CBUS fail", __func__);
+
+		if (enable) {
+			reset_control_deassert(reset_cbus_iso);
+			reset_control_deassert(reset_cbustx_iso);
+			reset_control_deassert(reset_cbusrx_iso);
+
+			if (init_flag&CLK_CBUS) {
+				clk_enable(clk_cbus_osc_iso);
+				clk_enable(clk_cbus_iso);
+				clk_enable(clk_cbustx_iso);
+				clk_enable(clk_cbusrx_iso);
+			} else {
+				clk_prepare_enable(clk_cbus_osc_iso);
+				clk_prepare_enable(clk_cbus_iso);
+				clk_prepare_enable(clk_cbustx_iso);
+				clk_prepare_enable(clk_cbusrx_iso);
+				init_flag |= CLK_CBUS;
+			}
+		} else { /* if not enable */
+			clk_disable(clk_cbus_osc_iso);
+			clk_disable(clk_cbus_iso);
+			clk_disable(clk_cbustx_iso);
+			clk_disable(clk_cbusrx_iso);
+
+			reset_control_assert(reset_cbus_iso);
+			reset_control_assert(reset_cbustx_iso);
+			reset_control_assert(reset_cbusrx_iso);
+		}
+	} /* end of if (clk_type&CLK_CBUS)*/
+
+}
+
+void hdmirx_clock_init(struct platform_device *pdev)
+{
+	init_flag = 0;
+
+	phdmirx_dev = &pdev->dev;
+
+	reset_mipi = reset_control_get(&pdev->dev, "mipi");
+	reset_rxwrap = reset_control_get(&pdev->dev, "hdmirx_wrap");
+	reset_hdmirx = reset_control_get(&pdev->dev, "hdmirx");
+	/* cbus reset shared with cec */
+	reset_cbus_iso = reset_control_get_shared(&pdev->dev, "cbus");
+	reset_cbustx_iso = reset_control_get_shared(&pdev->dev, "cbustx");
+	reset_cbusrx_iso = reset_control_get_shared(&pdev->dev, "cbusrx");
+
+	clk_mipi = clk_get(&pdev->dev, "mipi");
+	clk_hdmirx = clk_get(&pdev->dev, "hdmirx");
+	clk_cbus_osc_iso = clk_get(&pdev->dev, "cbus_osc");
+	clk_cbus_iso = clk_get(&pdev->dev, "cbus_sys");
+	clk_cbustx_iso = clk_get(&pdev->dev, "cbustx_sys");
+	clk_cbusrx_iso = clk_get(&pdev->dev, "cbusrx_sys");
+
+	pc_hdmirx = of_power_control_get_by_index(pdev->dev.of_node, 0);
+	if (IS_ERR(pc_hdmirx)) {
+		dev_warn(&pdev->dev, "failed to get power_control\n");
+		pc_hdmirx = NULL;
+	}
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_clk_ctrl.h b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_clk_ctrl.h
new file mode 100644
index 00000000..9256761
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_clk_ctrl.h
@@ -0,0 +1,36 @@
+/*
+ * hdmirx_clk_ctrl.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+
+#include "v4l2_hdmi_dev.h"
+
+typedef enum {
+	CLK_HDMIRX	= 0x1,
+	CLK_RXWRAP	= 0x2,
+	CLK_MIPI	= 0x4,
+	CLK_CBUS	= 0x8,
+	CLK_ALL		= 0xF,
+	RST_MIPI	= 0x10,
+	RST_CBUS	= 0x20,
+	RST_RXWRAP	= 0x40,
+	RST_HDMIRX	= 0x80
+} HDMI_CLK_TYPE;
+
+typedef enum {
+	CTL_DISABLE	= 0,
+	CTL_ENABLE	= 1
+} HDMI_CLK_CTL;
+
+unsigned char is_clock_enabled(HDMI_CLK_TYPE clk_type);
+void hdmirx_reset_control(HDMI_CLK_TYPE clk_type, HDMI_CLK_CTL enable);
+void hdmirx_clock_control(HDMI_CLK_TYPE clk_type, HDMI_CLK_CTL enable);
+void hdmirx_clock_init(struct platform_device *pdev);
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_gen_EDID.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_gen_EDID.c
new file mode 100644
index 00000000..a9a750b
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_gen_EDID.c
@@ -0,0 +1,131 @@
+/*
+ * hdmirx_gen_EDID.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/string.h>
+
+#define COLOR_RGB		0
+#define COLOR_YUV422	1
+#define COLOR_YUV444	2
+
+#define VIC_480P		2
+#define VIC_576P		17
+#define VIC_720P60		4
+#define VIC_1080I60		5
+#define VIC_1080P60		16
+#define VIC_2160P30		95
+#define VIC_2160P60		97
+
+unsigned char base_block[128] = {
+	0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
+	0x4A, 0x8B, 0x95, 0x12, 0x00, 0x00, 0x00, 0x00,
+	0xFF, 0x1A, 0x01, 0x03, 0x81, 0x46, 0x27, 0x78,
+	0x8A, 0xA5, 0x8E, 0xA6, 0x54, 0x4A, 0x9C, 0x26,
+	0x12, 0x45, 0x46, 0x00, 0x00, 0x00, 0x01, 0x01,
+	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
+	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00,
+	0x00, 0xFC, 0x00, 0x52, 0x54, 0x44, 0x31, 0x32,
+	0x39, 0x35, 0x0A, 0x20, 0x20, 0x20, 0x20, 0x20,
+	0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02
+};
+
+unsigned char cea_hdader_rgb[4] = {0x02, 0x03, 0x1A, 0x41};
+unsigned char cea_hdader_yuv422[4] = {0x02, 0x03, 0x1A, 0x51};
+unsigned char cea_hdader_yuv444[4] = {0x02, 0x03, 0x1A, 0x61};
+unsigned char speaker_alloc[4] = {0x83, 0x01, 0x00, 0x00};
+unsigned char vendor_specific[8] = {0x67, 0x03, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x3C};
+unsigned char vendor_specific2p0[8] = {0x67, 0xD8, 0x5D, 0xC4, 0x01, 0x78, 0x80, 0x00};
+unsigned char audio_data[4] = {0x23, 0x09, 0x7F, 0x07};
+unsigned char colorimetry[4] = {0xE3, 0x05, 0x00, 0x00};
+unsigned char detailed_timing[18] = {
+	0x8F, 0x0A, 0xD0, 0x8A, 0x20, 0xE0, 0x2D, 0x10,
+	0x10, 0x3E, 0x96, 0x00, 0x20, 0x58, 0x32, 0x00,
+	0x00, 0x18
+};
+
+
+/**
+ * gernerate_EDID - Generate specific EDID
+ * @color: 0 - RGB, 1 - YUV422, 2 - YUV444
+ * @vic: Video ID Code
+ * @edid_buf: 256 bytes buffer
+ */
+void gernerate_EDID(unsigned char color, unsigned char vic, unsigned char *edid_buf)
+{
+	unsigned int index = 0;
+	unsigned int i;
+	unsigned int sum = 0;
+
+	memset(edid_buf, 0, 256);
+
+	/* Base block */
+	memcpy(&edid_buf[index], base_block, sizeof(base_block));
+	index += sizeof(base_block);
+
+	/* CEA header */
+	switch (color) {
+	case COLOR_RGB:
+		memcpy(&edid_buf[index], cea_hdader_rgb, sizeof(cea_hdader_rgb));
+		break;
+	case COLOR_YUV422:
+		memcpy(&edid_buf[index], cea_hdader_yuv422, sizeof(cea_hdader_yuv422));
+		break;
+	case COLOR_YUV444:
+		memcpy(&edid_buf[index], cea_hdader_yuv444, sizeof(cea_hdader_yuv444));
+		break;
+	default:
+		memcpy(&edid_buf[index], cea_hdader_rgb, sizeof(cea_hdader_rgb));
+		break;
+	}
+	index += sizeof(cea_hdader_rgb);
+
+	/* Speaker Allocation */
+	memcpy(&edid_buf[index], speaker_alloc, sizeof(speaker_alloc));
+	index += sizeof(speaker_alloc);
+
+	/* Vendor Specific 1.4b */
+	memcpy(&edid_buf[index], vendor_specific, sizeof(vendor_specific));
+	index += sizeof(vendor_specific);
+
+	/* Vendor Specific 2.0 */
+	if (vic > 64) {
+		memcpy(&edid_buf[index], vendor_specific2p0, sizeof(vendor_specific2p0));
+		index += sizeof(vendor_specific2p0);
+	}
+
+	/* Video Data */
+	edid_buf[index++] = 0x41;
+	edid_buf[index++] = vic;
+
+	/* Audio Data */
+	memcpy(&edid_buf[index], audio_data, sizeof(audio_data));
+	index += sizeof(audio_data);
+
+	/* Colorimetry */
+	memcpy(&edid_buf[index], colorimetry, sizeof(colorimetry));
+	index += sizeof(colorimetry);
+
+	/* Detailed Timing */
+	memcpy(&edid_buf[index], detailed_timing, sizeof(detailed_timing));
+	index += sizeof(detailed_timing);
+
+	/* Calculate and set checksum */
+	for (i = 0x80; i < 0xFF; i++)
+		sum += edid_buf[i];
+	edid_buf[0xFF] = (0x100-(sum&0xFF))&0xFF;
+
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_hdcp.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_hdcp.c
new file mode 100644
index 00000000..d73061b
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_hdcp.c
@@ -0,0 +1,566 @@
+/*
+ * hdmirx_hdcp.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmiInternal.h"
+#include "mipi_wrapper.h"
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+#include <soc/realtek/rtk_sha1.h>
+extern unsigned long long hdcp_calculate_m0(unsigned long long aksv_value, unsigned long long an_val);
+#endif
+
+/* HDCP Bcaps */
+#define BCAPS_HDMI_RESERVED	_BIT7
+#define BCAPS_REPEATER		_BIT6
+#define BCAPS_READY			_BIT5
+#define BCAPS_FAST			_BIT4
+#define BCAPS_1_1FEATURES	_BIT1
+#define BCAPS_FAST_REAUTH	_BIT0
+
+#define HDCP_BCAPS_DVI        (BCAPS_HDMI_RESERVED | BCAPS_FAST | BCAPS_FAST_REAUTH)
+#define HDCP_BCAPS_HDMI       (BCAPS_HDMI_RESERVED | BCAPS_FAST | BCAPS_1_1FEATURES | BCAPS_FAST_REAUTH)
+#define HDCP_BCAPS_REPEATER   (HDCP_BCAPS_HDMI | BCAPS_REPEATER)
+
+/*=================== extern Variable/Function ===================*/
+extern MIPI_TOP_INFO mipi_top;
+
+/*======================================================*/
+
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+extern void Hdmi_HDCP_2_2_Init(void);
+#endif
+#ifdef CONFIG_RTK_HDCPRX_1P4_TEE
+extern void CA_hdcp1p4_load(void);
+extern unsigned char TA_HDCP1p4_Load_flag;
+extern int TEE2p1_Flag;
+#endif
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+#define HDCP_MAX_KSV	5
+struct hdcp_ksvlist_info tx_ksv_info;
+#define CHECK_INTERVAL 5000
+#define CHECK_TIMES 5
+
+static void hdcp1x_repeater_work_fun(struct work_struct *work);
+static DECLARE_WORK(hdcp1x_repeater_work, hdcp1x_repeater_work_fun);
+#endif
+
+HDCP_KEY_T rx_key;
+static unsigned char hdcpkey_enable = false;
+
+/**
+ * Hdmi_HdcpPortCWrite -
+ *      HDCP DDC port setting download function with auto-address increase
+ *      where HDCP port ddc address for HOST side is 0x74/0x75
+ *
+ * @addr: hdcp register address
+ * @data: data pointer
+ * @num: length data
+ */
+void inline Hdmi_HdcpPortCWrite(unsigned char addr, HDMI_CONST unsigned char *value, unsigned char num)
+{
+	hdmi_rx_reg_mask32(HDMI_HDCP_PCR, ~_BIT0, 0, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_HDCP_AP, addr, HDMI_RX_MAC);
+
+	while (num--)
+		hdmi_rx_reg_write32(HDMI_HDCP_DP, *(value++), HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_HDCP_PCR, ~_BIT0, _BIT0, HDMI_RX_MAC);
+}
+
+/**
+ * Hdmi_HdcpPortWrite -
+ *      HDCP DDC port setting download function
+ *      where HDCP port ddc address for HOST side is 0x74/0x75
+ *
+ * @addr: hdcp register address
+ * @value: data
+ */
+void Hdmi_HdcpPortWrite(unsigned int addr, unsigned int value)
+{
+	hdmi_rx_reg_write32(HDMI_HDCP_AP, addr, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_HDCP_DP, value, HDMI_RX_MAC);
+}
+
+/**
+ * Hdmi_HdcpPortRead -
+ *      HDCP DDC port setting read function
+ *      where HDCP port ddc address for HOST side is 0x74/0x75
+ *
+ * @addr: hdcp register address
+ *
+ * Return: data
+ */
+unsigned char Hdmi_HdcpPortRead(unsigned int addr)
+{
+	hdmi_rx_reg_write32(HDMI_HDCP_AP, addr, HDMI_RX_MAC);
+	return hdmi_rx_reg_read32(HDMI_HDCP_DP, HDMI_RX_MAC);
+}
+
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+void HdmiRx_save_tx_ksv(struct hdcp_ksvlist_info *tx_ksv)
+{
+	memcpy(&tx_ksv_info, tx_ksv, sizeof(tx_ksv_info));
+
+	hdmi.tx_hdcp_state = 1;
+	HDMIRX_INFO("TX ksv ready");
+
+	HDMI_PRINTF("TX ksv info:\n");
+	HDMI_PRINTF("device_count(%u)\n", tx_ksv_info.device_count);
+	HDMI_PRINTF("Bstatus(0x%02x%02x)\n", tx_ksv_info.bstatus[1], tx_ksv_info.bstatus[0]);
+	HDMI_PRINTF("Bksv(0x%02x %02x %02x %02x %02x)\n",
+		tx_ksv_info.Bksv[4], tx_ksv_info.Bksv[3], tx_ksv_info.Bksv[2],
+		tx_ksv_info.Bksv[1], tx_ksv_info.Bksv[0]);
+}
+
+struct hdcp_ksvlist_info *HdmiRx_get_tx_ksv(void)
+{
+	return &tx_ksv_info;
+}
+
+void HdmiRx_disable_bcaps_ready(void)
+{
+	unsigned int tmp_value;
+
+	if ((!mipi_top.hdmi_rx_init) || (!hdmi.tx_hdcp_state))/* Already disable */
+		return;
+
+	HDMI_PRINTF("%s\n", __func__);
+	/* Disable Bcaps READY(Bit5) */
+	tmp_value = Hdmi_HdcpPortRead(0x40)&0xDF;/* set bit 5 to 0 */
+	Hdmi_HdcpPortWrite(0x40, tmp_value);
+	hdmi.tx_hdcp_state = 0;
+}
+
+void HdmiRx_set_bstatus(unsigned char byte1, unsigned char byte0)
+{
+	if (!mipi_top.hdmi_rx_init)
+		return;
+	HDMI_PRINTF("%s\n", __func__);
+
+	if ((byte1&0xF) < 0x7)/* less than seven levels */
+		byte1 = (0x1<<4)|((byte1&0xF)+1);
+	else/* Topology error */
+		byte1 = (0x1<<4)|0xF;
+
+	if (byte0 < HDCP_MAX_KSV)/* less than HDCP_MAX_KSV downstream devices */
+		byte0 = byte0+1;
+	else/* Topology error */
+		byte0 = 0xFF;
+
+	Hdmi_HdcpPortWrite(0x41, byte0);
+	Hdmi_HdcpPortWrite(0x42, byte1);
+}
+
+/**
+ * hdcprx_set_bcaps_ready - Enable/Disable Bcaps READY(Bit5)
+ * @enable: 0 disable, 1 enable
+ */
+void hdcprx_set_bcaps_ready(unsigned char enable)
+{
+	unsigned int tmp_value;
+
+	tmp_value = Hdmi_HdcpPortRead(0x40);
+	if (enable)
+		tmp_value |= 0x20;
+	else
+		tmp_value = Hdmi_HdcpPortRead(0x40)&0xDF;
+
+	Hdmi_HdcpPortWrite(0x40, tmp_value);
+}
+
+void Hdmi_Hdcp1xRepeaterAuth(void)
+{
+	UINT8 aksv_reg[5], an_reg[8];
+	unsigned long long AKSV = 0, An = 0;
+	unsigned char *sha_data_buffer;
+	unsigned int sha_index;
+	unsigned char sha1[SHA1_DIGEST_SIZE];
+	unsigned long long Mi;
+	int k;
+	unsigned int i, reg_value, Bstatus;
+	struct hdcp_ksvlist_info *tx_ksv;
+
+	tx_ksv = HdmiRx_get_tx_ksv();
+
+	/* Wait TX ready, Max 1.5 s */
+	for (i = 0; i < 15; i++) {
+		if (hdmi.tx_hdcp_state)
+			break;
+
+		usleep_range(100000, 110000);
+	}
+
+	if (!hdmi.tx_hdcp_state) {
+		HDMIRX_INFO("HDCP TX not ready");
+		goto exit;
+	}
+
+	/* Alloc sha buffer: Bksv(5Bytes), KSV list(5Bytes for each ksv), Bstatus(2Bytes), M0'(8Bytes) */
+	sha_data_buffer = kmalloc((5*(tx_ksv->device_count+1)+10)*sizeof(unsigned char), GFP_KERNEL);
+
+	hdmi_rx_reg_mask32(HDMI_HDCP_PCR, ~(_BIT1|_BIT0), _BIT1, HDMI_RX_MAC);
+	/* Set KSV list */
+	for (sha_index = 0; sha_index < 5; sha_index++) {
+		/* HDMIRX_INFO("HdcpPortWrite(0x%03x):0x%02x",0x43+(sha_index<<8),tx_ksv->Bksv[sha_index]); */
+		Hdmi_HdcpPortWrite(0x43+(sha_index<<8)/*ksvfifo_ptr*/, tx_ksv->Bksv[sha_index]);
+		sha_data_buffer[sha_index] = tx_ksv->Bksv[sha_index];
+	}
+
+	for (sha_index = 5; sha_index < 5*(tx_ksv->device_count+1); sha_index++) {
+		/* HDMIRX_INFO("HdcpPortWrite(0x%03x):0x%02x",0x43+(sha_index<<8),tx_ksv->ksvlist[sha_index-5]); */
+		Hdmi_HdcpPortWrite(0x43+(sha_index<<8)/*ksvfifo_ptr*/, tx_ksv->ksvlist[sha_index-5]);
+		sha_data_buffer[sha_index] = tx_ksv->ksvlist[sha_index-5];
+	}
+
+	if (hdmi_rx_reg_read32(HDMI_HDCP_FLAG1, HDMI_RX_MAC)&HDMI_HDCP_FLAG1_wr_aksv_flag_mask) {
+		HDMIRX_INFO("New AKSV after set KVS list");
+		goto free_exit;
+	}
+
+	/* Set Bstatus, HDMI_MODE[12] MAX_CASCADE_EXCEEDED[11] DEPTH[10:8] DEVICE_COUNT[6:0] */
+	/* Bstatus[15:8] */
+	if ((tx_ksv->bstatus[1]&0xF) < 0x7)/* less than seven levels */
+		Bstatus = (0x1<<12) | ((tx_ksv->bstatus[1]+1)<<8);
+	else/* Topology error */
+		Bstatus = (0x1<<12) | (0xF<<8);
+
+	/* Bstatus[15:8]|Bstatus[7:0] */
+	if (tx_ksv->bstatus[0] < HDCP_MAX_KSV)/* less than HDCP_MAX_KSV downstream devices */
+		Bstatus = Bstatus | (tx_ksv->bstatus[0]+1);
+	else/* Topology error */
+		Bstatus = Bstatus | 0xFF;
+
+	Hdmi_HdcpPortWrite(0x41, Bstatus & 0xFF);
+	Hdmi_HdcpPortWrite(0x42, (Bstatus>>8)&0xFF);
+	sha_data_buffer[sha_index++] = Bstatus & 0xFF;
+	sha_data_buffer[sha_index++] = (Bstatus>>8)&0xFF;
+
+	/* Readback Bstatus */
+	HDMIRX_INFO("HDCP Bstatus:Byte1=0x%02x Byte2=0x%02x",
+		Hdmi_HdcpPortRead(0x41), Hdmi_HdcpPortRead(0x42));
+
+	if (hdmi_rx_reg_read32(HDMI_HDCP_FLAG1, HDMI_RX_MAC) & HDMI_HDCP_FLAG1_wr_aksv_flag_mask) {
+		HDMIRX_INFO("New AKSV after get Bstatus");
+		goto free_exit;
+	}
+
+	/* Read AKSV */
+	aksv_reg[0] = Hdmi_HdcpPortRead(0x10);/* [7:0] */
+	aksv_reg[1] = Hdmi_HdcpPortRead(0x11);/* [15:8] */
+	aksv_reg[2] = Hdmi_HdcpPortRead(0x12);/* [23:16] */
+	aksv_reg[3] = Hdmi_HdcpPortRead(0x13);/* [31:24] */
+	aksv_reg[4] = Hdmi_HdcpPortRead(0x14);/* [39:32] */
+	AKSV = 0;
+	for (k = 4; k >= 0; k--)
+		AKSV = AKSV<<8 | aksv_reg[k];
+
+	 HDMIRX_DEBUG("HDCP i=%d AKSV Flag = %x, %x ,%x ,%x, %x AKSV(%llx)",
+		i, aksv_reg[0], aksv_reg[1], aksv_reg[2], aksv_reg[3], aksv_reg[4], AKSV);
+
+	/* Read An */
+	an_reg[0] = Hdmi_HdcpPortRead(0x18);/* [7:0] */
+	an_reg[1] = Hdmi_HdcpPortRead(0x19);/* [15:8] */
+	an_reg[2] = Hdmi_HdcpPortRead(0x1A);
+	an_reg[3] = Hdmi_HdcpPortRead(0x1B);
+	an_reg[4] = Hdmi_HdcpPortRead(0x1C);
+	an_reg[5] = Hdmi_HdcpPortRead(0x1D);
+	an_reg[6] = Hdmi_HdcpPortRead(0x1E);
+	an_reg[7] = Hdmi_HdcpPortRead(0x1F);/* [63:56] */
+	for (k = 7; k >= 0; k--)
+		An = (An<<8) | an_reg[k];
+
+	HDMIRX_DEBUG("HDCP An = 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x ,0x%llx",
+		an_reg[0], an_reg[1], an_reg[2], an_reg[3],
+		an_reg[4], an_reg[5], an_reg[6], an_reg[7], An);
+
+	/* Calcuate V' */
+	Mi = hdcp_calculate_m0(AKSV, An);
+
+	for (k = 0; k < 8; k++)
+		sha_data_buffer[sha_index++] = (Mi>>(k*8))&0xFF;
+
+	/*
+	 * SHA-1 example
+	 * Input "Hello" --> Output "f7ff9e8b7bb2e09b70935a5d785e0cc5d9d0abf0"
+	 * char source[5]={'H', 'e', 'l', 'l', 'o'};
+	 * sha1[0]=0xf7, sha1[1]=0xff, ..., sha1[19]=0xf0
+	 */
+	memset(sha1, 0, SHA1_DIGEST_SIZE*sizeof(unsigned char));
+	MCP_SHA1_Get_Hash(sha_data_buffer, sha_index/*source length*/, sha1);
+
+	/*
+	 * for (k = 0; k < 20; k++)
+	 *	HDMIRX_INFO("sha1[%u]=0x%02x", k, sha1[k]);
+	 */
+
+	/* Set V' */
+	/* SHA-1 H0b */
+	Hdmi_HdcpPortWrite(0x20, sha1[3]);
+	Hdmi_HdcpPortWrite(0x21, sha1[2]);
+	Hdmi_HdcpPortWrite(0x22, sha1[1]);
+	Hdmi_HdcpPortWrite(0x23, sha1[0]);
+	/* SHA-1 H1 */
+	Hdmi_HdcpPortWrite(0x24, sha1[7]);
+	Hdmi_HdcpPortWrite(0x25, sha1[6]);
+	Hdmi_HdcpPortWrite(0x26, sha1[5]);
+	Hdmi_HdcpPortWrite(0x27, sha1[4]);
+	/* SHA-1 H2 */
+	Hdmi_HdcpPortWrite(0x28, sha1[11]);
+	Hdmi_HdcpPortWrite(0x29, sha1[10]);
+	Hdmi_HdcpPortWrite(0x2A, sha1[9]);
+	Hdmi_HdcpPortWrite(0x2B, sha1[8]);
+	/* SHA-1 H3 */
+	Hdmi_HdcpPortWrite(0x2C, sha1[15]);
+	Hdmi_HdcpPortWrite(0x2D, sha1[14]);
+	Hdmi_HdcpPortWrite(0x2E, sha1[13]);
+	Hdmi_HdcpPortWrite(0x2F, sha1[12]);
+	/* SHA-1 H4 */
+	Hdmi_HdcpPortWrite(0x30, sha1[19]);
+	Hdmi_HdcpPortWrite(0x31, sha1[18]);
+	Hdmi_HdcpPortWrite(0x32, sha1[17]);
+	Hdmi_HdcpPortWrite(0x33, sha1[16]);
+
+	/* Reset AP address */
+	hdmi_rx_reg_write32(HDMI_HDCP_AP, 0x43, HDMI_RX_MAC);
+
+	/* Dump V' */
+	/*
+	 * for (k = 0; k < 20; k++)
+	 *	HDMIRX_INFO("ReadBack V'(%u):0x%02x", k, Hdmi_HdcpPortRead(0x20+k));
+	 */
+
+	/* For CTS 3C-I-03, TE write An twice */
+	for (k = 0; k < CHECK_TIMES; k++) {
+		usleep_range(CHECK_INTERVAL, CHECK_INTERVAL+10);
+		reg_value = hdmi_rx_reg_read32(HDMI_HDCP_FLAG1, HDMI_RX_MAC);
+		if (reg_value & HDCP_FLAG1_wr_aksv_flag_mask) {
+			HDMIRX_INFO("New AKSV after set V'(%u)", k);
+			goto free_exit;
+		}
+	}
+
+	/* Enable Bcaps READY(Bit5) */
+	if (hdmi.tx_hdcp_state)
+		hdcprx_set_bcaps_ready(1);
+	else
+		HDMIRX_INFO("HDCP TX not ready");
+
+	/* For 3C-I-04 */
+	for (k = 0; k < CHECK_TIMES*10; k++) {
+		usleep_range(CHECK_INTERVAL, CHECK_INTERVAL+10);
+		reg_value = hdmi_rx_reg_read32(HDMI_HDCP_FLAG1, HDMI_RX_MAC);
+		if (reg_value & HDCP_FLAG1_wr_aksv_flag_mask) {
+			hdcprx_set_bcaps_ready(0);
+			HDMIRX_INFO("New AKSV after Bcaps READY(%u)", k);
+			goto free_exit;
+		}
+	}
+
+free_exit:
+	/* Free sha data buffer */
+	kfree(sha_data_buffer);
+exit:
+	return;
+}
+
+static void hdcp1x_repeater_work_fun(struct work_struct *work)
+{
+	Hdmi_Hdcp1xRepeaterAuth();
+	hdmi_rx_reg_mask32(HDMI_HDCP_FLAG2, ~HDCP_FLAG2_irq_aksv_en_mask,
+		HDMI_HDCP_FLAG2_irq_aksv_en_mask, HDMI_RX_MAC);/* Enable AKSV interrupt */
+}
+
+void start_hdcp1x_repeater_work(void)
+{
+	hdcprx_set_bcaps_ready(0);
+
+	hdmirx_state.hdcp_state = HDCPRX_STATE_1PX_DISCOVER;/*  Discover HDCP 1.x */
+
+	if (hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & _BIT0)/* HDMI mode */
+		schedule_work(&hdcp1x_repeater_work);
+}
+#endif
+
+void Hdmi_HdcpFSM(void)
+{
+	UINT32 hdcp_status_flag;
+
+	hdcp_status_flag = hdmi_rx_reg_read32(HDMI_HDCP_FLAG1, HDMI_RX_MAC);
+
+	/* Get TX write Aksv */
+	if (HDMI_HDCP_FLAG1_get_wr_aksv_flag(hdcp_status_flag)) {
+#ifdef CONFIG_RTK_HDCPRX_2P2
+		/* Disable HDCP 2.2 */
+		if (HDMI_HDCP_2P2_CR_hdcp_2p2_en(hdmi_rx_reg_read32(HDMI_HDCP_2P2_CR, HDMI_RX_MAC))) {
+
+			hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~HDMI_HDCP_2P2_CR_hdcp_2p2_en_mask,
+				0, HDMI_RX_MAC);
+			HDMIRX_INFO("[HDCP] Discover 1.x, disable 2.2");
+		}
+#endif
+		hdmirx_state.hdcp_state = HDCPRX_STATE_1PX_DISCOVER;/*  Discover HDCP 1.x */
+
+#ifndef CONFIG_RTK_HDCP1x_REPEATER
+		hdmi_rx_reg_write32(HDMI_HDCP_FLAG1, HDMI_HDCP_FLAG1_wr_aksv_flag_mask, HDMI_RX_MAC); /* Clear Aksv flag */
+#endif
+	}
+
+	if (HDMI_HDCP_FLAG1_get_rd_ri_flag(hdmi_rx_reg_read32(HDMI_HDCP_FLAG1, HDMI_RX_MAC)))
+		hdmi_rx_reg_write32(HDMI_HDCP_FLAG1, HDMI_HDCP_FLAG1_rd_ri_flag_mask, HDMI_RX_MAC);/* Clear Read Ri flag */
+
+	if (hdmirx_state.hdcp_state == HDCPRX_STATE_1PX_DISCOVER) {
+		/* Get Ri means HDCP 1.x nego success */
+		if (HDMI_HDCP_FLAG1_get_rd_ri_flag(hdcp_status_flag))
+			hdmirx_state.hdcp_state = HDCPRX_STATE_1PX_ON;
+	}
+}
+
+#ifdef CONFIG_RTK_HDCPRX_1P4_TEE
+void HDMI_HDCP1p4_TEE_LOAD_KEY(void)
+{
+	if (TEE2p1_Flag == 0) {
+		HDMIRX_ERROR("[HDCP TEE] Load key fail, TEE driver not enable");
+		return;
+	}
+
+	CA_hdcp1p4_load();
+
+	rx_key.BKsv[0] =  Hdmi_HdcpPortRead(0x0);
+	rx_key.BKsv[1] =  Hdmi_HdcpPortRead(0x1);
+	rx_key.BKsv[2] =  Hdmi_HdcpPortRead(0x2);
+	rx_key.BKsv[3] =  Hdmi_HdcpPortRead(0x3);
+	rx_key.BKsv[4] =  Hdmi_HdcpPortRead(0x4);
+	HDMIRX_INFO("[HDCP TEE] BKSV = %02x %02x %02x %02x %02x",
+		rx_key.BKsv[0], rx_key.BKsv[1], rx_key.BKsv[2],
+		rx_key.BKsv[3], rx_key.BKsv[4]);
+
+}
+#endif
+
+/**
+ * Hdmi_HdcpInit -HDCP initial function
+ */
+void Hdmi_HdcpInit(void)
+{
+	int i;
+
+	if (!hdcpkey_enable)
+		return;
+
+	HDMIRX_INFO("[HDCP] Hdmi_HdcpInit");
+
+	/* Disable HDCP and clear HDCP address */
+	hdmi_rx_reg_mask32(HDMI_HDCP_CR,
+		~(HDMI_HDCP_CR_hdcp_clk_switch_auto_mask |
+		HDMI_HDCP_CR_maddf_mask |
+		HDMI_HDCP_CR_dkapde_mask |
+		HDMI_HDCP_CR_hdcp_en_mask),
+		HDMI_HDCP_CR_hdcp_clk_switch_auto(1) |
+		HDMI_HDCP_CR_maddf(1) |
+		HDMI_HDCP_CR_dkapde(1) |
+		HDMI_HDCP_CR_hdcp_en(0),
+		HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_HDCP_PCR,
+		~(HDMI_HDCP_PCR_km_clk_sel_mask | HDMI_HDCP_PCR_enc_tog_mask),
+		0, HDMI_RX_MAC);
+
+#if 0
+	/* Clear Data Port */
+	hdmi_rx_reg_mask32(HDMI_HDCP_PCR, ~_BIT0, 0, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_HDCP_AP, 0x00, HDMI_RX_MAC);
+	for (i = 0; i < 640; i++) {
+		hdmi_rx_reg_write32(HDMI_HDCP_AP, 0x43 + (i<<8), HDMI_RX_MAC);
+		hdmi_rx_reg_write32(HDMI_HDCP_DP, 0x00, HDMI_RX_MAC);
+	}
+
+	hdmi_rx_reg_write32(HDMI_HDCP_AP, 0x00, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_HDCP_PCR, ~_BIT0, _BIT0, HDMI_RX_MAC);
+#endif
+
+#ifdef CONFIG_RTK_HDCPRX_1P4_TEE
+	HDMI_HDCP1p4_TEE_LOAD_KEY();
+#else
+	/* Write device private key */
+	for (i = 0; i < 320; i++)
+		hdmi_rx_reg_write32(HDMI_HDCP_DKAP, rx_key.Key[i], HDMI_RX_MAC);
+#endif
+
+	/* Write BKsv into DDC channel */
+	Hdmi_HdcpPortCWrite(0x00, rx_key.BKsv, 5);
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+	Hdmi_HDCP_2_2_Init();
+	HDMI_PRINTF("HDCP2Vision = %x", Hdmi_HdcpPortRead(0x50));
+#endif
+	hdmi_rx_reg_mask32(HDMI_HDCP_CR,
+		~(HDMI_HDCP_CR_maddf_mask |
+		HDMI_HDCP_CR_dkapde_mask |
+		HDMI_HDCP_CR_hdcp_en_mask),
+		HDMI_HDCP_CR_maddf(0) |
+		HDMI_HDCP_CR_dkapde(0) |
+		HDMI_HDCP_CR_hdcp_en(0),
+		HDMI_RX_MAC);
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+	/* Set Bcaps, repeater mode */
+	Hdmi_HdcpPortWrite(0x40, HDCP_BCAPS_REPEATER);
+	hdmi_rx_reg_mask32(HDMI_HDCP_CR,
+		~(HDMI_HDCP_CR_namfe_mask | HDMI_HDCP_CR_hdcp_en_mask),
+		HDMI_HDCP_CR_namfe(1) | HDMI_HDCP_CR_hdcp_en(1),
+		HDMI_RX_MAC);/* for New_AC_Mode Enable, fix simplay bug */
+	/* Keep old setting */
+	Hdmi_HdcpPortWrite(0xc4, 0x00);
+	/* Enable AKSV interrupt */
+	hdmi_rx_reg_mask32(HDMI_HDCP_FLAG2, ~HDMI_HDCP_FLAG2_irq_aksv_en_mask,
+		HDCP_FLAG2_irq_aksv_en_mask, HDMI_RX_MAC);
+#else
+	/* Set Bcaps */
+	Hdmi_HdcpPortWrite(0x40, HDCP_BCAPS_HDMI);
+	/* Enable HDCP function for all */
+	hdmi_rx_reg_mask32(HDMI_HDCP_CR,
+		~(HDMI_HDCP_CR_namfe_mask | HDMI_HDCP_CR_hdcp_en_mask),
+		HDMI_HDCP_CR_namfe(1) | HDMI_HDCP_CR_hdcp_en(1),
+		HDMI_RX_MAC);/* for New_AC_Mode Enable, fix simplay bug */
+#endif
+
+}
+
+void HdmiRx_enable_hdcp(unsigned char *bksv, unsigned char *device_key)
+{
+	/* Return when already save the key */
+	if (hdcpkey_enable)
+		return;
+
+	memset(&rx_key, 0, sizeof(rx_key));
+	memcpy(&rx_key.BKsv, bksv, 5);
+	memcpy(&rx_key.Key, device_key, 320);
+
+	hdcpkey_enable = true;
+	HDMIRX_INFO("HdmiRx_enable_hdcp");
+
+	if (mipi_top.hdmi_rx_init) {
+		Hdmi_SetHPD(0);
+		Hdmi_HdcpInit();
+		HDMI_DELAYMS(500);
+		Hdmi_SetHPD(1);
+	}
+
+}
+
+unsigned char Is_HdmiRx_hdcp1x_enabled(void)
+{
+	return hdcpkey_enable;
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_hdcp2p2.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_hdcp2p2.c
new file mode 100644
index 00000000..10325de
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_hdcp2p2.c
@@ -0,0 +1,467 @@
+/*
+ * hdmirx_hdcp2p2.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmiInternal.h"
+
+static unsigned char lc128_key[16];
+static unsigned char hdcp2p2key_enable = false;
+
+unsigned char wait_init = 0;
+struct hdcp2p2_wait_event hdcp2p2_wait;
+struct hdcp2p2_wait_event stream_wait;
+
+unsigned char Repeater_clear_repeater_bit;
+/*=================== extern Variable/Function ===================*/
+extern void Hdmi_HdcpPortWrite(unsigned char addr, unsigned char value);
+/*======================================================*/
+
+
+
+/* HDCP2-2  global variable */
+unsigned char g_bmsg_id;
+unsigned char g_RX_state;
+unsigned char g_Rx_Send_State;
+
+unsigned char TX_msg_id[864];
+unsigned char stream_manage_msg[10];
+unsigned char stream_manage_flag;
+unsigned char bLen;
+
+unsigned int b_Tx_Len;
+
+#define HDCP_RXstatus_addr    0x70
+/* Message ID*/
+#define IDEL                    0   /* TX=>RX */
+#define AKE_INIT                2   /* TX=>RX */
+#define AKE_Send_Cert           3   /* RX=>TX */
+#define AKE_NO_Stored_Km        4   /* TX=>RX */
+#define AKE_Stored_Km           5   /* TX=>RX */
+#define AKE_Send_H_prime        7   /* RX=>TX */
+#define AKE_Send_Pariring_Info  8   /* RX=>TX */
+#define LC_Init                 9   /* TX=>RX */
+#define LC_Send_L_prime         10  /* RX=>TX */
+#define SKE_Send_Eks            11  /* TX=>RX */
+/* Repeaterauth Message ID*/
+#define REPEATERAUTH_SEND_RECEIVERID_LIST	12  /* RX=>TX */
+#define REPEATERAUTH_SEND_ACK				15  /* TX=>RX */
+#define REPEATERAUTH_STREAM_MANAGE			16  /* TX=>RX */
+#define REPEATERAUTH_STREAM_READY			17  /* RX=>TX */
+
+/* RX send FSM*/
+#define  RX_FSM_SEND_START		1
+#define  RX_FSM_WAIT			2
+#define  RX_FSM_FINISH			3
+
+/* HDCP 2.2 OFFSET */
+#define Write_Message_offset	0x60
+#define Rxstatus_offset			0x70
+#define Read_Message_offset		0x80
+
+struct work_struct hdcp2p2_msg_work;
+struct work_struct repeaterauth_stream_work;
+static DEFINE_MUTEX(hdcprx2p2_lock);
+
+void Hdmi_HDCP_2_2_msg_work_func(struct work_struct *work);
+void repeaterauth_stream_work_func(struct work_struct *work);
+
+
+char Get_Hdmi_hdcp_2_2_Write_Message(void)
+{
+	unsigned int wr_msg_done;
+
+	wr_msg_done = HDMI_HDCP_2P2_SR0_get_irq_wr_msg_done(hdmi_rx_reg_read32(HDMI_HDCP_2P2_SR0, HDMI_RX_MAC));
+	if (wr_msg_done)
+		return 1;
+	else
+		return 0;
+}
+
+char Get_Hdmi_hdcp_2_2_Read_Message(void)
+{
+	unsigned int rd_msg_done;
+
+	rd_msg_done = HDMI_HDCP_2P2_SR0_get_irq_rd_msg_done(hdmi_rx_reg_read32(HDMI_HDCP_2P2_SR0, HDMI_RX_MAC));
+	if (rd_msg_done)
+		return 1;
+	else
+		return 0;
+}
+
+void Clear_Hdmi_hdcp_2_2_Read_Status(void)
+{
+	hdmi_rx_reg_write32(HDMI_HDCP_2P2_SR0, HDMI_HDCP_2P2_SR0_irq_rd_msg_done_mask, HDMI_RX_MAC);
+}
+
+void HW_Cipher_Setting(unsigned char *lc128)
+{
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~(HDMI_HDCP_2P2_CR_fw_mode_riv_mask),
+		HDMI_HDCP_2P2_CR_fw_mode_riv_mask, HDMI_RX_MAC);
+
+	/* lc 128 */
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_LC0, ~HDMI_HDCP_2P2_LC0_lc_mask,
+		(lc128[15]|(lc128[14]<<8)|(lc128[13]<<16)|(lc128[12]<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_LC1, ~HDMI_HDCP_2P2_LC1_lc_mask,
+		(lc128[11]|(lc128[10]<<8)|(lc128[9]<<16)|(lc128[8]<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_LC2, ~HDMI_HDCP_2P2_LC2_lc_mask,
+		(lc128[7]|(lc128[6]<<8)|(lc128[5]<<16)|(lc128[4]<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_LC3, ~HDMI_HDCP_2P2_LC3_lc_mask,
+		(lc128[3]|(lc128[2]<<8)|(lc128[1]<<16)|(lc128[0]<<24)), HDMI_RX_MAC);
+}
+
+void Set_Rx_status_Ready(void)
+{
+
+	hdmi_rx_reg_write32(HDMI_HDCP_AP, 0x71, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_HDCP_DP, (0x1 << 2), HDMI_RX_MAC);
+}
+
+void DownStream_done(void)
+{
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~HDMI_HDCP_2P2_CR_downstream_done_mask,
+		HDMI_HDCP_2P2_CR_downstream_done_mask, HDMI_RX_MAC);
+}
+void KS_Setting(unsigned char *bKs)
+{
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR,
+		~(HDMI_HDCP_2P2_CR_fw_mode_riv_mask), HDMI_HDCP_2P2_CR_fw_mode_riv_mask, HDMI_RX_MAC);
+	/* Initial ks value */
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_KS0, ~HDMI_HDCP_2P2_KS0_ks_mask,
+		((*(bKs+15))|((*(bKs+14))<<8)|((*(bKs+13))<<16)|((*(bKs+12))<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_KS1, ~HDMI_HDCP_2P2_KS1_ks_mask,
+		((*(bKs+11))|((*(bKs+10))<<8)|((*(bKs+9))<<16)|((*(bKs+8))<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_KS2, ~HDMI_HDCP_2P2_KS2_ks_mask,
+		((*(bKs+7))|((*(bKs+6))<<8)|((*(bKs+5))<<16)|((*(bKs+4))<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_KS3, ~HDMI_HDCP_2P2_KS3_ks_mask,
+		((*(bKs+3))|((*(bKs+2))<<8)|((*(bKs+1))<<16)|((*bKs)<<24)), HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~HDMI_HDCP_2P2_CR_ks_done_mask,
+		HDMI_HDCP_2P2_CR_ks_done_mask, HDMI_RX_MAC);
+
+	HDMIRX_INFO("[HDCP2.2]Set KS");
+	HDMIRX_DEBUG("[HDCP2.2]KS_Setting bKs  = 0x%x , 0x%x ,0x%x ,0x%x ,0x%x ,0x%x ,0x%x ,0x%x",
+		(*bKs), *(bKs+1), *(bKs+2), *(bKs+3), *(bKs+4), *(bKs+5), *(bKs+6), *(bKs+7));
+}
+
+void Riv_Setting(unsigned char *bRiv)
+{
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_RIV0, ~HDMI_HDCP_2P2_RIV0_riv_mask,
+		(*(bRiv+7)|(*(bRiv+6)<<8)|(*(bRiv+5)<<16)|(*(bRiv+4)<<24)), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_RIV1, ~HDMI_HDCP_2P2_RIV1_riv_mask,
+		(*(bRiv+3)|(*(bRiv+2)<<8)|(*(bRiv+1)<<16)|((*bRiv)<<24)), HDMI_RX_MAC);
+
+	HDMIRX_INFO("[HDCP2.2]Set Riv");
+	HDMIRX_DEBUG("[HDCP2.2]Riv_Setting bRiv = 0x%x , 0x%x ,0x%x ,0x%x ,0x%x ,0x%x ,0x%x ,0x%x",
+		(*bRiv), *(bRiv+1), *(bRiv+2), *(bRiv+3), *(bRiv+4), *(bRiv+5), *(bRiv+6), *(bRiv+7));
+	hdmirx_state.hdcp_state = HDCPRX_STATE_2P2_ON;/* HDCP 2.2 nego success */
+}
+
+void init_hdcp2p2_waitqueue(void)
+{
+	if (wait_init)
+		return;
+
+	spin_lock_init(&hdcp2p2_wait.slock);
+	init_waitqueue_head(&hdcp2p2_wait.read_wq);
+	hdcp2p2_wait.condition = false;
+
+	spin_lock_init(&stream_wait.slock);
+	init_waitqueue_head(&stream_wait.read_wq);
+	stream_wait.condition = false;
+
+	wait_init = 1;
+}
+
+void HdmiRx_enable_hdcp2p2(unsigned char *key)
+{
+	if (hdcp2p2key_enable)/* Already save the key, return */
+		return;
+
+	if ((key[0] == 0) && (key[1] == 0) && (key[2] == 0) &&
+		(key[3] == 0) && (key[4] == 0))
+		HDMIRX_INFO("[HDCP2.2] Empty key, should be TEE case");
+
+	memset(&lc128_key, 0, sizeof(lc128_key));
+	memcpy(&lc128_key, key, sizeof(lc128_key));
+
+	HDMIRX_INFO("[HDCP2.2] HDCP RX INIT");
+
+	hdcp2p2key_enable = true;
+}
+
+unsigned char Is_HdmiRx_hdcp2p2_enabled(void)
+{
+	return hdcp2p2key_enable;
+}
+
+void Hdmi_HDCP_2_2_Init(void)
+{
+	static unsigned char init_work_flag = 0;
+
+	HDMIRX_INFO("[HDCP2.2] Hdmi_HDCP_2_2_Init");
+
+	Repeater_clear_repeater_bit = 0;
+
+	if (!hdcp2p2key_enable) {
+		HDMIRX_INFO("[HDCP2.2] key not ready");
+		return;
+	}
+
+	/* Init msg work */
+	if (!init_work_flag) {
+		INIT_WORK(&hdcp2p2_msg_work, Hdmi_HDCP_2_2_msg_work_func);
+		INIT_WORK(&repeaterauth_stream_work, repeaterauth_stream_work_func);
+		init_work_flag = 1;
+	}
+
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~HDMI_HDCP_2P2_CR_hdcp_2p2_en_mask,
+		0, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_SR1, ~HDMI_HDCP_2P2_SR1_irq_wr_msg_done_en_mask,
+		HDMI_HDCP_2P2_SR1_irq_wr_msg_done_en_mask, HDMI_RX_MAC);
+
+	/* Should not set cipher when TEE path on */
+	if (lc128_key[0] || lc128_key[1] || lc128_key[2] ||
+		lc128_key[3] || lc128_key[4])
+		HW_Cipher_Setting(&lc128_key[0]);/* SET Lc  */
+
+	/* enable hdcp 2.2 HW interrupt */
+	Hdmi_HdcpPortWrite(0x50, 0x04);/* support hdcp2.2 */
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_SR1, ~HDMI_HDCP_2P2_SR1_irq_wr_msg_done_en_mask,
+		HDMI_HDCP_2P2_SR1_irq_wr_msg_done_en_mask, HDMI_RX_MAC);
+}
+
+char  Hdmi_HDCP2_2_Write_Data_to_TX(unsigned char *bSendData, unsigned int wLen)
+{
+	unsigned int i;
+
+	if (bSendData == NULL)
+		return FALSE;
+
+	HDMI_PRINTF("[HDCP2.2] bSendData(%d)\n", bSendData[0]);
+
+	mutex_lock(&hdcprx2p2_lock);
+
+	for (i = 0; i < wLen; i++) {
+		hdmi_rx_reg_write32(HDMI_HDCP_MSAP, i, HDMI_RX_MAC);
+		hdmi_rx_reg_write32(HDMI_HDCP_MSDP, *(bSendData+i), HDMI_RX_MAC);
+	}
+
+	hdmi_rx_reg_write32(HDMI_HDCP_AP, HDCP_RXstatus_addr, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_HDCP_DP, (wLen&0xFF), HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_HDCP_AP, HDCP_RXstatus_addr+1, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_HDCP_DP, ((wLen&0x3FF)>>8), HDMI_RX_MAC);
+
+	mutex_unlock(&hdcprx2p2_lock);
+
+	return TRUE;
+}
+
+void Hdmi_HDCP_2_2_Force_Cipher(void)
+{
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~(HDMI_HDCP_2P2_CR_switch_state_mask),
+		HDMI_HDCP_2P2_CR_switch_state(0x10), HDMI_RX_MAC);/* set authenticated */
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~(HDMI_HDCP_2P2_CR_apply_state_mask | HDMI_HDCP_2P2_CR_fw_mode_riv_mask),
+		(HDMI_HDCP_2P2_CR_apply_state_mask | HDMI_HDCP_2P2_CR_fw_mode_riv_mask), HDMI_RX_MAC);
+
+}
+
+void Hdmi_HDCP_2_2_msg_work_func(struct work_struct *work)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&hdcp2p2_wait.slock, flags);
+	hdcp2p2_wait.condition = true;
+	wake_up_interruptible(&hdcp2p2_wait.read_wq);
+	spin_unlock_irqrestore(&hdcp2p2_wait.slock, flags);
+}
+
+void repeaterauth_stream_work_func(struct work_struct *work)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&stream_wait.slock, flags);
+	stream_wait.condition = true;
+	wake_up_interruptible(&stream_wait.read_wq);
+	spin_unlock_irqrestore(&stream_wait.slock, flags);
+}
+
+void  Hdmi_HDCP_2_2_msg_hander(void)
+{
+	unsigned char i;
+	/* GET TX mesage */
+	if (Get_Hdmi_hdcp_2_2_Write_Message()) {
+		/* Must close hdcp1.4 when discover hdcp2.2 */
+		if (HDMI_HDCP_CR_get_hdcp_en(hdmi_rx_reg_read32(HDMI_HDCP_CR, HDMI_RX_MAC))) {
+			hdmi_rx_reg_mask32(HDMI_HDCP_CR, ~HDMI_HDCP_CR_hdcp_en_mask, 0, HDMI_RX_MAC);
+			HDMIRX_INFO("[HDCP2.2] Discover 2.2, disable 1.4");
+		}
+		/* Open hdcp2p2 */
+		hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~HDMI_HDCP_2P2_CR_hdcp_2p2_en_mask,
+			HDMI_HDCP_2P2_CR_hdcp_2p2_en_mask, HDMI_RX_MAC);
+		hdmi_rx_reg_write32(HDMI_HDCP_MSAP, 0, HDMI_RX_MAC);
+		g_bmsg_id = hdmi_rx_reg_read32(HDMI_HDCP_MSDP, HDMI_RX_MAC);
+		TX_msg_id[0] = g_bmsg_id;
+		HDMI_PRINTF("[HDCP2.2] bmsg_id  =%x\n", g_bmsg_id);
+
+		g_Rx_Send_State = RX_FSM_SEND_START;
+		switch (g_bmsg_id) {
+		case AKE_INIT:
+			HDMIRX_INFO("[HDCP2.2] AKE_INIT");
+			/* Discover HDCP 2.2 */
+			hdmirx_state.hdcp_state = HDCPRX_STATE_2P2_DISCOVER;
+			g_RX_state = AKE_Send_Cert;
+			bLen = 11;
+			stream_manage_flag = 0;
+			break;
+		case AKE_NO_Stored_Km:
+			HDMIRX_INFO("[HDCP2.2] AKE_NO_Stored_Km");
+			g_RX_state =  AKE_Send_H_prime;
+			bLen = 128;
+			break;
+		case AKE_Stored_Km:
+			HDMIRX_INFO("[HDCP2.2] AKE_Stored_Km");
+			g_RX_state =  AKE_Send_H_prime;
+			bLen = 32;
+			break;
+		case LC_Init:
+			/* HDMIRX_INFO("[HDCP2.2] LC_Init"); */
+			/* Need reply in 20ms */
+			g_RX_state = LC_Send_L_prime;
+			bLen = 8;
+			break;
+		case SKE_Send_Eks:
+			HDMIRX_INFO("[HDCP2.2] SKE_Send_Eks");
+			hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~HDMI_HDCP_2P2_CR_switch_state_mask,
+				HDMI_HDCP_2P2_CR_switch_state(0x01), HDMI_RX_MAC);
+			hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~HDMI_HDCP_2P2_CR_apply_state_mask,
+				HDMI_HDCP_2P2_CR_apply_state_mask, HDMI_RX_MAC);
+			bLen = 24;
+			break;
+		case REPEATERAUTH_SEND_ACK:
+			bLen = 16;
+			break;
+		case REPEATERAUTH_STREAM_MANAGE:
+			/* HDMIRX_INFO("[HDCP2.2] REPEATERAUTH_STREAM_MANAGE"); */
+			bLen = 7; /* k=1 */
+			break;
+		default:
+			bLen = 0;
+			HDMI_PRINTF("[HDCP2.2] Unknown message\n");
+			break;
+		}
+
+		if (g_bmsg_id != REPEATERAUTH_STREAM_MANAGE) {
+			for (i = 1; i <= bLen; i++)
+				TX_msg_id[i] = hdmi_rx_reg_read32(HDMI_HDCP_MSDP, HDMI_RX_MAC);
+		} else {
+			stream_manage_flag = 1;
+			stream_manage_msg[0] = g_bmsg_id;
+			for (i = 1; i <= 7; i++)
+				stream_manage_msg[i] = hdmi_rx_reg_read32(HDMI_HDCP_MSDP, HDMI_RX_MAC);
+		}
+
+		/* For HW Cipher setting */
+		if (g_bmsg_id == SKE_Send_Eks)
+			Riv_Setting((&(TX_msg_id[17])));/* Set Riv address */
+
+		/* Clear interrupt */
+		hdmi_rx_reg_write32(HDMI_HDCP_2P2_SR0, HDMI_HDCP_2P2_SR0_irq_wr_msg_done_mask, HDMI_RX_MAC);
+		hdmi_rx_reg_write32(HDMI_INTCR, 0x80, HDMI_RX_MAC);
+
+		if (g_bmsg_id != REPEATERAUTH_STREAM_MANAGE)
+			schedule_work(&hdcp2p2_msg_work);
+		else
+			schedule_work(&repeaterauth_stream_work);
+	}
+
+}
+
+int get_hdcp2p2_msg(struct rx_hdcp22_msg *msg)
+{
+	int i;
+	unsigned long flags;
+
+	spin_lock_irqsave(&hdcp2p2_wait.slock, flags);
+	hdcp2p2_wait.condition = false;
+	spin_unlock_irqrestore(&hdcp2p2_wait.slock, flags);
+
+	wait_event_interruptible(hdcp2p2_wait.read_wq, hdcp2p2_wait.condition);
+
+	msg->g_RX_state = g_RX_state;
+	for (i = 0; i <= bLen; i++)
+		msg->msg[i] = TX_msg_id[i];
+	msg->bLen = bLen;
+
+	return 0;
+}
+
+int write_hdcp2p2_msg_to_tx(struct rx_hdcp22_msg *msg)
+{
+
+	Hdmi_HDCP2_2_Write_Data_to_TX(msg->msg, msg->bLen);
+
+	return 0;
+}
+
+int get_stream_msg(struct rx_hdcp22_msg *msg)
+{
+	int i;
+	unsigned long flags;
+
+	HDMIRX_INFO("[HDCP2.2] get_stream_msg enter");
+
+	spin_lock_irqsave(&stream_wait.slock, flags);
+	stream_wait.condition = false;
+	spin_unlock_irqrestore(&stream_wait.slock, flags);
+
+	wait_event_interruptible(stream_wait.read_wq, stream_wait.condition);
+
+	msg->bLen = 7;
+	for (i = 0; i <= 7; i++)
+		msg->msg[i] = stream_manage_msg[i];
+
+	HDMIRX_INFO("[HDCP2.2] get_stream_msg exit");
+
+	return 0;
+}
+
+void set_hdcp2p2_condition(void)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&hdcp2p2_wait.slock, flags);
+	hdcp2p2_wait.condition = true;
+	wake_up_interruptible(&hdcp2p2_wait.read_wq);
+	spin_unlock_irqrestore(&hdcp2p2_wait.slock, flags);
+}
+
+int set_hdcp2p2_ks(struct rx_hdcp22_ks *ks)
+{
+	KS_Setting(&ks->bks[0]);
+
+	return 0;
+}
+
+int get_hdcp2p2_msg_done(int *done)
+{
+	*done = (int)Get_Hdmi_hdcp_2_2_Read_Message();
+	return 0;
+}
+
+int set_hdcp2p2_switch_state(int *state)
+{
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~HDMI_HDCP_2P2_CR_switch_state_mask,
+		HDMI_HDCP_2P2_CR_switch_state(0x10), HDMI_RX_MAC); /* authenticated */
+	hdmi_rx_reg_mask32(HDMI_HDCP_2P2_CR, ~HDMI_HDCP_2P2_CR_apply_state_mask,
+		HDMI_HDCP_2P2_CR_apply_state_mask, HDMI_RX_MAC);
+
+	return 0;
+}
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_hdcp2p2.h b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_hdcp2p2.h
new file mode 100644
index 00000000..cbbe711
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_hdcp2p2.h
@@ -0,0 +1,30 @@
+/*
+ * hdmirx_hdcp2p2.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDCP2P2_H_
+#define __HDCP2P2_H_
+
+#include "hdcp2p2_dev.h"
+
+unsigned char Is_HdmiRx_hdcp2p2_enabled(void);
+
+void init_hdcp2p2_waitqueue(void);
+int get_hdcp2p2_msg(struct rx_hdcp22_msg *msg);
+int write_hdcp2p2_msg_to_tx(struct rx_hdcp22_msg *msg);
+int get_stream_msg(struct rx_hdcp22_msg *msg);
+int set_hdcp2p2_ks(struct rx_hdcp22_ks *ks);
+void Clear_Hdmi_hdcp_2_2_Read_Status(void);
+int get_hdcp2p2_msg_done(int *done);
+void Set_Rx_status_Ready(void);
+void DownStream_done(void);
+int set_hdcp2p2_switch_state(int *state);
+
+#endif /* __HDCP2P2_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_merge_EDID.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_merge_EDID.c
new file mode 100644
index 00000000..368f8e30
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_merge_EDID.c
@@ -0,0 +1,316 @@
+/*
+ * hdmirx_merge_EDID.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmiEDID.h"
+#include "hdmitx.h"
+
+const unsigned char base_block[128] = {
+	0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x4A, 0x8B, 0x95, 0x12, 0x00, 0x00, 0x00, 0x00,
+	0xFF, 0x1A, 0x01, 0x03, 0x81, 0x46, 0x27, 0x78, 0x8A, 0xA5, 0x8E, 0xA6, 0x54, 0x4A, 0x9C, 0x26,
+	0x12, 0x45, 0x46, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
+	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0xFC, 0x00, 0x52, 0x54, 0x44, 0x31, 0x32,
+	0x39, 0x35, 0x0A, 0x20, 0x20, 0x20, 0x20, 0x20, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02
+};
+
+const unsigned char speaker_alloc[4] = {
+	0x83, 0x01, 0x00, 0x00
+};
+const unsigned int speaker_alloc_size = sizeof(speaker_alloc);
+
+const unsigned char vendor_specific[8] = {
+	0x67, 0x03, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x3C
+};
+const unsigned int vendor_specific_size = sizeof(vendor_specific);
+
+const unsigned char colorimetry[4] = {
+	0xE3, 0x05, 0x00, 0x00
+};
+const unsigned int colorimetry_size = sizeof(colorimetry);
+
+/**
+ * int rx_video_support - RX support VIC list
+ */
+#define VIDEO_ARRAY_SIZE 9
+const int rx_video_support[VIDEO_ARRAY_SIZE] = {
+	2, 4, 5, 16, 17, 20, 31, 32, 34
+};
+
+/**
+ * Audio format code
+ * 0x1:PCM,  0x2:AC-3,  0x3:MPEG1-L1/L2,  0x4:MPEG1-L3(MP3)
+ * 0x5:MPEG2(multi-ch),  0x6:AAC,  0x7:DTS,  0x8: ATRAC
+ * 0x9:One-Bit Audio,  0xa:AC-3 Plus,  0xb:DTS-HD,  0xc:MLP(TrueHD)
+ * 0xd:DST,  0xe:WMA Pro
+ */
+#define AUDIO_ARRAY_SIZE 6
+const struct Audio_desc rx_audio_support[AUDIO_ARRAY_SIZE] = {
+	/* PCM: 2CH, 32/44.1/48/88.2/96/176.4/192, 16bit/20bit/24bit */
+	{.coding_type = 0x1,
+	 .channel_count = 2,
+	 .sample_freq_all = 0x7F,
+	 .sample_size_all = 0x7,},
+	/* AC3: 6CH, 32/44.1/48, MaxBitRate 640kHz */
+	{.coding_type = 0x2,
+	 .channel_count = 6,
+	 .sample_freq_all = 0x7,
+	 .max_bit_rate_divided_by_8KHz = 0x50,},
+	/* DTS: 6CH, 32/44.1/48, MaxBitRate 1536kHz */
+	{.coding_type = 0x7,
+	 .channel_count = 6,
+	 .sample_freq_all = 0x7,
+	 .max_bit_rate_divided_by_8KHz = 0xC0,},
+	/* AAC: 8CH, 32/44.1/48/88.2/96, MaxBitRate 2040kHz */
+	{.coding_type = 0x6,
+	 .channel_count = 8,
+	 .sample_freq_all = 0x1F,
+	 .max_bit_rate_divided_by_8KHz = 0xFF,},
+	/* DTS-HD: 6CH, 32/44.1/48 */
+	{.coding_type = 0xB,
+	 .channel_count = 6,
+	 .sample_freq_all = 0x7,},
+	/* AC-3 Plus: 8CH, 32/44.1/48 */
+	{.coding_type = 0xA,
+	 .channel_count = 8,
+	 .sample_freq_all = 0x7,},
+};
+
+/**
+ * struct merge_edid_data
+ * @color_formats: [Bit2] YUV422, [Bit1] YUV444, [Bit0] RGB
+ * @video_size: number of VICs in video_list
+ * @video_list: merged VICs
+ * @audio_size: number of audio data in audio_list
+ * @audio_list: merged audio data
+ */
+struct merge_edid_data {
+	int color_formats;
+	int	video_size;
+	int video_list[VIDEO_ARRAY_SIZE];
+	int audio_size;
+	struct Audio_desc audio_list[AUDIO_ARRAY_SIZE];
+};
+
+struct merge_edid_data edid_data;
+
+void merge_video_data(uint64_t vic)
+{
+	int i;
+
+	HDMIRX_INFO("Merge EDID video data, vic(0x%016llx)", vic);
+
+	edid_data.video_size = 0;
+	for (i = 0; i < VIDEO_ARRAY_SIZE; i++) {
+
+		if (vic & BIT(rx_video_support[i]-1)) {
+			edid_data.video_list[edid_data.video_size] = rx_video_support[i];
+			edid_data.video_size++;
+		}
+	}
+
+	/* Dump match VICs */
+	for (i = 0; i < edid_data.video_size; i++)
+		HDMIRX_DEBUG("Index(%d) VIC(%d)", i, edid_data.video_list[i]);
+
+	if (edid_data.video_size == 0) {
+		HDMIRX_INFO("Merge EDID video data fail, no one match");
+		edid_data.video_size = 2;
+		edid_data.video_list[0] = 32;
+		edid_data.video_list[1] = 34;
+	}
+}
+
+int get_audio_index(unsigned char	coding_type)
+{
+	unsigned int i;
+
+	for (i = 0; i < AUDIO_ARRAY_SIZE; i++) {
+		if (coding_type == rx_audio_support[i].coding_type)
+			return i;
+	}
+
+	return -1;
+}
+
+void merge_audio_data(struct Audio_Data *audio_data)
+{
+	unsigned int i, j;
+	unsigned char coding_type;
+	unsigned char tx_temp, rx_temp;
+	int index;
+
+	HDMIRX_INFO("Merge EDID audio data, ADB_length(%d)", audio_data->ADB_length);
+
+	j = 0;
+	for (i = 0; i < audio_data->ADB_length; i++) {
+		index = get_audio_index(audio_data->ADB[i].coding_type);
+		if (index >= 0) {
+			coding_type = audio_data->ADB[i].coding_type;
+			edid_data.audio_list[j].coding_type = coding_type;
+
+			tx_temp = audio_data->ADB[i].channel_count;
+			rx_temp = rx_audio_support[index].channel_count;
+			edid_data.audio_list[j].channel_count = min(tx_temp, rx_temp);
+
+			tx_temp = audio_data->ADB[i].sample_freq_all;
+			rx_temp = rx_audio_support[index].sample_freq_all;
+			edid_data.audio_list[j].sample_freq_all = tx_temp & rx_temp;
+
+			if (coding_type == 0x1) {
+				tx_temp = audio_data->ADB[i].sample_size_all;
+				rx_temp = rx_audio_support[index].sample_size_all;
+				edid_data.audio_list[j].sample_size_all = tx_temp & rx_temp;
+			} else if ((coding_type >= 2) && (coding_type <= 8)) {
+				tx_temp = audio_data->ADB[i].max_bit_rate_divided_by_8KHz;
+				rx_temp = rx_audio_support[index].max_bit_rate_divided_by_8KHz;
+				edid_data.audio_list[j].max_bit_rate_divided_by_8KHz = min(tx_temp, rx_temp);
+			}
+
+			j++;
+		}
+	}
+	edid_data.audio_size = j;
+
+	HDMIRX_INFO("Merge_EDID, number of match audio format(%u)", edid_data.audio_size);
+	/* Dump match audio */
+	for (i = 0; i < edid_data.audio_size; i++) {
+		HDMIRX_DEBUG("coding_type(%u)", edid_data.audio_list[i].coding_type);
+		HDMIRX_DEBUG("channel_count(%u)", edid_data.audio_list[i].channel_count);
+		HDMIRX_DEBUG("sample_freq_all(0x%x)", edid_data.audio_list[i].sample_freq_all);
+		HDMIRX_DEBUG("sample_size_all(0x%x)", edid_data.audio_list[i].sample_size_all);
+		HDMIRX_DEBUG("max_bit_rate_divided_by_8KHz(0x%x)", edid_data.audio_list[i].max_bit_rate_divided_by_8KHz);
+	}
+
+	if (edid_data.audio_size == 0) {
+		HDMIRX_INFO("Merge EDID audio data fail, no one match");
+		edid_data.audio_size = 1;
+		edid_data.audio_list[0].coding_type = 0x1;
+		edid_data.audio_list[0].channel_count = 0x2;
+		edid_data.audio_list[0].sample_freq_all = 0x6;
+		edid_data.audio_list[0].sample_size_all = 0x0;
+	}
+}
+
+
+/**
+ * gernerate_EDID - Generate specific EDID
+ * @data: Input EDID info
+ * @edid_buf: Output EDID buffer, 256bytes
+ *  Retn : N/A
+ */
+void gernerate_EDID(struct merge_edid_data *data, unsigned char *edid_buf)
+{
+	unsigned int i;
+	unsigned int index = 0;
+	unsigned int data_block_size;
+	unsigned int sum = 0;
+
+	memset(edid_buf, 0, 256);
+
+	/* Base block 128Bytes */
+	memcpy(&edid_buf[index], base_block, sizeof(base_block));
+	index += sizeof(base_block);
+
+	/* Skip CEA Header */
+	index += 4;
+	data_block_size = 4;
+
+	/* Speaker Allocation	*/
+	memcpy(&edid_buf[index], speaker_alloc, speaker_alloc_size);
+	index += speaker_alloc_size;
+	data_block_size += speaker_alloc_size;
+
+	/* Vendor Specific 1.4b */
+	memcpy(&edid_buf[index], vendor_specific, vendor_specific_size);
+	index += vendor_specific_size;
+	data_block_size += vendor_specific_size;
+
+	/* Video Data */
+	edid_buf[index] = (0x2<<5) | (data->video_size);
+	index++;
+	data_block_size++;
+	for (i = 0; i < data->video_size; i++)
+		edid_buf[index++] = data->video_list[i];
+
+	data_block_size += data->video_size;
+
+	/* Audio Data */
+	edid_buf[index] = (0x1<<5) | (data->audio_size*3);
+	index++;
+	data_block_size++;
+	for (i = 0; i < data->audio_size; i++) {
+		edid_buf[index++] = ((data->audio_list[i].coding_type & 0xF) << 3) |
+							((data->audio_list[i].channel_count - 1) & 0x7);
+		edid_buf[index++] = data->audio_list[i].sample_freq_all;
+
+		if (data->audio_list[i].coding_type == 1) {
+			edid_buf[index++] = data->audio_list[i].sample_size_all;
+		} else if ((data->audio_list[i].coding_type >= 2) &&
+					(data->audio_list[i].coding_type <= 8)) {
+			edid_buf[index++] = data->audio_list[i].max_bit_rate_divided_by_8KHz;
+		} else {
+			edid_buf[index++] = 0;
+		}
+	}
+	data_block_size += data->audio_size*3;
+
+	/* Colorimetry */
+	memcpy(&edid_buf[index], colorimetry, colorimetry_size);
+	index += colorimetry_size;
+	data_block_size += colorimetry_size;
+
+	/* CEA Header */
+	edid_buf[0x80] = 0x02;
+	edid_buf[0x81] = 0x03;
+	edid_buf[0x82] = data_block_size;
+	edid_buf[0x83] = BIT(6);/* Audio */
+	if (data->color_formats & DRM_COLOR_FORMAT_YCRCB444)
+		edid_buf[0x83] |= BIT(5);
+	if (data->color_formats & DRM_COLOR_FORMAT_YCRCB422)
+		edid_buf[0x83] |= BIT(4);
+
+	/* Calculate and set checksum */
+	for (i = 0x80; i < 0xFF; i++)
+		sum += edid_buf[i];
+	edid_buf[0xFF] = (0x100-(sum&0xFF))&0xFF;
+
+}
+
+void hdmirx_merge_EDID(struct sink_capabilities_t *sink_cap)
+{
+	int i;
+	unsigned char edid_buf[256];
+
+	memset(&edid_data, 0, sizeof(edid_data));
+
+	edid_data.color_formats = sink_cap->display_info.color_formats;
+
+	merge_video_data(sink_cap->vic);
+
+	merge_audio_data(&sink_cap->audio_data);
+
+	gernerate_EDID(&edid_data, edid_buf);
+
+	HdmiRx_ChangeCurrentEDID(edid_buf);
+
+	for (i = 0; i < 16; i++) {
+		HDMIRX_DEBUG("%02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x",
+			edid_buf[i*16], edid_buf[i*16+1], edid_buf[i*16+2], edid_buf[i*16+3],
+			edid_buf[i*16+4], edid_buf[i*16+5], edid_buf[i*16+6], edid_buf[i*16+7],
+			edid_buf[i*16+8], edid_buf[i*16+9], edid_buf[i*16+10], edid_buf[i*16+11],
+			edid_buf[i*16+12], edid_buf[i*16+13], edid_buf[i*16+14], edid_buf[i*16+15]);
+	}
+}
+
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_reg.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_reg.c
new file mode 100644
index 00000000..468e168
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_reg.c
@@ -0,0 +1,47 @@
+/*
+ * hdmirx_reg.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "asm/io.h"
+#include "hdmirx_reg.h"
+
+void __iomem *hdmi_rx_base[HDMI_RX_REG_BLOCK_NUM];
+
+const unsigned int reg_size[HDMI_RX_REG_BLOCK_NUM] =
+{
+	0xE0, 0xF54, 0x4C, 0x98, 0x224, 0x48
+};
+
+unsigned int hdmi_rx_reg_read32 (unsigned int addr_offset, HDMI_RX_REG_BASE_TYPE type)
+{
+	if (addr_offset > reg_size[type])
+		pr_err("[HDMI RX ERR] Wrong access, type(%u) offset(0x%x)\n", type, addr_offset);
+	//else
+		//pr_err("Read type(%u) offset(0x%x)\n", type, addr_offset);
+
+	return readl(hdmi_rx_base[type] + addr_offset);
+}
+
+void hdmi_rx_reg_write32 (unsigned int addr_offset, unsigned int value, HDMI_RX_REG_BASE_TYPE type)
+{
+	if (addr_offset > reg_size[type])
+		pr_err("[HDMI RX ERR] Wrong access, type(%u) offset(0x%x)\n", type, addr_offset);
+	//else
+		//pr_err("Write type(%u) offset(0x%x)\n", type, addr_offset);
+	writel(value, hdmi_rx_base[type] + addr_offset);
+}
+
+void hdmi_rx_reg_mask32(unsigned int addr_offset, unsigned int andMask,
+	unsigned int orMask, HDMI_RX_REG_BASE_TYPE type)
+{
+	hdmi_rx_reg_write32(addr_offset, ((hdmi_rx_reg_read32(addr_offset, type) & (andMask)) | (orMask)), type);
+}
+
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_reg.h b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_reg.h
new file mode 100644
index 00000000..8f97b4d
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_reg.h
@@ -0,0 +1,78 @@
+/*
+ * hdmirx_reg.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDMIRX_REG_H__
+#define __HDMIRX_REG_H__
+
+#include "HDMI_fw.h"
+#include "HDMIRXDDC_fw.h"
+#include "DFE_fw.h"
+#include "DFE_HDMI_RX_PHY_fw.h"
+#include "hdmirx_wrapper_reg.h"
+#include "mipi_wrapper_reg.h"
+#include "misc_reg.h"
+
+
+/* Definitions of Bits */
+#define _ZERO                       0x00
+#define _BIT0                       0x01
+#define _BIT1                       0x02
+#define _BIT2                       0x04
+#define _BIT3                       0x08
+#define _BIT4                       0x10
+#define _BIT5                       0x20
+#define _BIT6                       0x40
+#define _BIT7                       0x80
+#define _BIT8                       0x0100
+#define _BIT9                       0x0200
+#define _BIT10                      0x0400
+#define _BIT11                      0x0800
+#define _BIT12                      0x1000
+#define _BIT13                      0x2000
+#define _BIT14                      0x4000
+#define _BIT15                      0x8000
+#define _BIT16                      0x10000
+#define _BIT17                      0x20000
+#define _BIT18                      0x40000
+#define _BIT19                      0x80000
+#define _BIT20                      0x100000
+#define _BIT21                      0x200000
+#define _BIT22                      0x400000
+#define _BIT23                      0x800000
+#define _BIT24                      0x1000000
+#define _BIT25                      0x2000000
+#define _BIT26                      0x4000000
+#define _BIT27                      0x8000000
+#define _BIT28                      0x10000000
+#define _BIT29                      0x20000000
+#define _BIT30                      0x40000000
+#define _BIT31                      0x80000000
+
+typedef enum {
+	HDMI_TX_CBUS = 0,
+	HDMI_RX_MAC = 1,
+	HDMI_RX_MHL = 1,
+	HDMI_RX_PHY = 1,
+	HDMI_RX_DFE = 1,
+	HDMI_RX_HDMI_WRAPPER = 2,
+	HDMI_RX_DDC = 3,
+	HDMI_RX_MIPI = 4,
+	HDMI_RX_CLK90K = 5,
+	HDMI_RX_REG_BLOCK_NUM = 6
+} HDMI_RX_REG_BASE_TYPE;
+
+
+unsigned int hdmi_rx_reg_read32 (unsigned int addr_offset, HDMI_RX_REG_BASE_TYPE type);
+void hdmi_rx_reg_write32(unsigned int addr_offset, unsigned int value, HDMI_RX_REG_BASE_TYPE type);
+void hdmi_rx_reg_mask32(unsigned int addr_offset, unsigned int andMask,
+	unsigned int orMask, HDMI_RX_REG_BASE_TYPE type);
+
+#endif/* __HDMIRX_REG_H__ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_repeater.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_repeater.c
new file mode 100644
index 00000000..e026aea
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_repeater.c
@@ -0,0 +1,158 @@
+/*
+ * hdmirx_repeater.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmirx_video_dev.h"
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmirx_reg.h"
+#include "mipi_wrapper.h"
+
+#include "rx_drv/hdmiInternal.h"
+
+#if HDMI_REPEATER_SUPPORT
+void __iomem *pll_hdmi2_vaddr;
+void __iomem *disp_pll_vaddr;
+
+void __iomem *pll_ldo1_vaddr;
+void __iomem *pll_ldo2_vaddr;
+void __iomem *pll_ldo3_vaddr;
+void __iomem *pll_ldo4_vaddr;
+void __iomem *pll_ldo5_vaddr;
+
+int hdmi_repeater_mode = 0;/* 0:regular mode, 1:repeater mode */
+
+/*=================== extern Variable/Function ===================*/
+extern MIPI_TOP_INFO mipi_top;
+
+extern void Hdmi_SetHPD(char high);
+/*======================================================*/
+
+void Set_Hdmitx_source(unsigned char repeater)
+{
+	unsigned int reg_val;
+
+	if (repeater) {
+		/* Bit25:Bit24 */
+		reg_val = readl(pll_ldo3_vaddr)&0xFCFFFFFF;
+
+		/* Set TX clock input from RX */
+		writel(reg_val|(1<<25), pll_ldo3_vaddr);
+
+		/* Set TX data input from RX */
+		writel((1<<26)|(1<<25), disp_pll_vaddr);
+
+		/* Enable HDMI repeater 1.4 mode */
+		hdmi_rx_reg_write32(HDMIRPT, 0x1, HDMI_RX_PHY);
+	} else {
+		/*Set TX clock input from TX */
+		writel(readl(pll_ldo3_vaddr)&0xFCFFFFFF, pll_ldo3_vaddr);
+
+		/* Set TX data input from TX */
+		writel((1<<26), disp_pll_vaddr);
+
+		/* Disable HDMI repeater mode */
+		hdmi_rx_reg_write32(HDMIRPT, 0x0, HDMI_RX_PHY);
+	}
+}
+
+void Set_Hdmitx_PLL(void)
+{
+	unsigned int tmds;
+
+	if (!hdmi_repeater_mode)
+		return;
+
+	tmds = rxphy_get_clk()*27/256;
+	if (HDMI_TMDS_CPS_get_pll_div2_en(hdmi_rx_reg_read32(HDMI_TMDS_CPS, HDMI_RX_MAC)))
+		tmds = tmds*2;
+
+	HDMIRX_INFO("Set TX PLL, TMDS(%u)", tmds);
+
+	if (tmds > 155) {
+		/* 297MHz */
+		writel(0x01190474, pll_ldo1_vaddr);
+		writel(0xF77454FF, pll_ldo2_vaddr);
+		writel(0x03AEFC00, pll_ldo3_vaddr);
+		writel(0x0A00C049, pll_ldo4_vaddr);
+		writel(0x0000072C, pll_ldo5_vaddr);
+		writel(0x00020210, pll_hdmi2_vaddr);
+	} else if (tmds > 140) {
+		/* 148.5MHz */
+		writel(0x19001045, pll_ldo1_vaddr);
+		writel(0xF77400FF, pll_ldo2_vaddr);
+		writel(0x03bed800, pll_ldo3_vaddr);
+		writel(0x0A014000, pll_ldo4_vaddr);
+		writel(0x0000040B, pll_ldo5_vaddr);
+		writel(0x00040221, pll_hdmi2_vaddr);
+	} else if (tmds > 70) {
+		/* 74.25MHz */
+		writel(0x0100004f, pll_ldo1_vaddr);
+		writel(0x72A800F0, pll_ldo2_vaddr);
+		writel(0x03BCB400, pll_ldo3_vaddr);
+		writel(0x0000c092, pll_ldo4_vaddr);
+		writel(0x00000002, pll_ldo5_vaddr);
+		writel(0x00060232, pll_hdmi2_vaddr);
+	} else {
+		/* 27MHz */
+		writel(0x01000C4F, pll_ldo1_vaddr);
+		writel(0xEAA800F0, pll_ldo2_vaddr);
+		writel(0x03BD7400, pll_ldo3_vaddr);
+		writel(0x0000c092, pll_ldo4_vaddr);
+		writel(0x00000307, pll_ldo5_vaddr);
+		writel(0x00080243, pll_hdmi2_vaddr);
+	}
+
+	Set_Hdmitx_source(1);
+}
+
+int Get_Hdmi_repeater_mode(void)
+{
+	return hdmi_repeater_mode;
+}
+
+void Set_Hdmi_repeater_mode(int enable)
+{
+
+	if (hdmi_repeater_mode == enable)
+		return;
+
+	if (enable) {
+		HDMIRX_INFO("Enable HDMI repeater mode");
+		pll_hdmi2_vaddr = ioremap(0x98000194, 0x4);
+		pll_ldo1_vaddr = ioremap(0x98000230, 0x4);
+		pll_ldo2_vaddr = ioremap(0x98000234, 0x4);
+		pll_ldo3_vaddr = ioremap(0x98000238, 0x4);
+		pll_ldo4_vaddr = ioremap(0x9800023C, 0x4);
+		pll_ldo5_vaddr = ioremap(0x98000240, 0x4);
+		disp_pll_vaddr = ioremap(0x98000024, 0x4);
+
+		if (mipi_top.hdmi_rx_init) {
+			Hdmi_SetHPD(0);
+			usleep_range(500000, 600000);
+			Hdmi_SetHPD(1);
+		}
+
+	} else {
+		HDMIRX_INFO("Disable HDMI repeater mode");
+		Set_Hdmitx_source(0);
+
+		iounmap(pll_hdmi2_vaddr);
+		iounmap(pll_ldo1_vaddr);
+		iounmap(pll_ldo2_vaddr);
+		iounmap(pll_ldo3_vaddr);
+		iounmap(pll_ldo4_vaddr);
+		iounmap(pll_ldo5_vaddr);
+		iounmap(disp_pll_vaddr);
+	}
+
+	hdmi_repeater_mode = enable;
+}
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_sysfs.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_sysfs.c
new file mode 100644
index 00000000..c5180c3
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_sysfs.c
@@ -0,0 +1,522 @@
+/*
+ * hdmirx_sysfs.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmiEDID.h"
+#ifdef CONFIG_RTK_HDCPRX_2P2
+#include "hdmirx_hdcp2p2.h"
+#endif
+
+#include "rx_drv/hdmiInternal.h"
+
+#if HDMI_REPEATER_SUPPORT
+extern int Get_Hdmi_repeater_mode(void);
+extern void Set_Hdmi_repeater_mode(int enable);
+#endif
+
+static DEFINE_MUTEX(hdmirx_sysfs_lock);
+
+static const char * const avi_s[] = {
+	"No Data", "Overscanned", "Underscanned", "Future"
+};
+
+static const char * const avi_b[] = {
+	"Bar Data not present", "V Bar Info present",
+	"H Bar Info present", "V&H Bar Info present"
+};
+
+static const char * const avi_a[] = {
+	"No Active Format Information",
+	"Active Format Information present"
+};
+
+static const char * const avi_y[] = {
+	"RGB", "YCbCr4:2:2", "YCbCr4:4:4", "YCbCr4:2:0",
+	"Reserved", "Reserved", "Reserved", "IDO-Defined"
+};
+
+static const char * const avi_r[] = {
+	"No AFD Specified", "Reserved", "Reserved", "Reserved",
+	"Greater than 16:9", "Reserved", "Reserved", "Reserved",
+	"Same as Picture", "4:3(Center)", "16:9(Center)", "14:9(Center)",
+	"Reserved", "4:3 image alternative 14:9 center",
+	"16:9 image alternative 14:9 center",
+	"16:9 image alternative 4:3 center"
+};
+
+static const char * const avi_m[] = {
+	"No Data", "4:3", "16:9", "Reserved"
+};
+
+static const char * const avi_c[] = {
+	"No Data", "SMPTE 170M", "ITU-R BT.709", "Extended Colorimetry"
+};
+
+static const char * const avi_sc[] = {
+	"Unknown", "Horizontally", "Vertically", "Horizontally & Vertically"
+};
+
+static const char * const avi_q[] = {
+	"Default", "Limited Range", "Full Rnage", "Reserved"
+};
+
+static const char * const avi_ec[] = {
+	"xvYCC601", "xvYCC709", "sYCC601", "AdobeYCC601",
+	"AdobeRGB", "ITU-R BT.2020 Y'cC'bcC'rc",
+	"ITU-R BT.2020 R'G'B' or Y'C'bC'r", "Reserved"
+};
+
+static const char * const avi_itc[] = {
+	"No data", "IT content"
+};
+
+static const char * const avi_pr[] = {
+	"No Repetition", "Pixel Data sent 2 times",
+	"Pixel Data sent 3 times", "Pixel Data sent 4 times",
+	"Pixel Data sent 5 times", "Pixel Data sent 6 times",
+	"Pixel Data sent 7 times", "Pixel Data sent 8 times",
+	"Pixel Data sent 9 times", "Pixel Data sent 10 times",
+	"Reserved", "Reserved",
+	"Reserved", "Reserved",
+	"Reserved", "Reserved",
+};
+
+static const char * const avi_cn[] = {
+	"Graphics", "Photo", "Cinema", "Game"
+};
+
+static const char * const avi_yq[] = {
+	"Limited Range", "Full Range", "Reserved", "Reserved"
+};
+
+static const char * const spd_source_info[] = {
+	"unknown", "Digital STB", "DVD player", "D-VHS",
+	"HDD Videorecorder", "DVC", "DSC", "Video CD",
+	"Game", "PC general", "BD Super Audio CD", "HD DVD",
+	"PMP", "Reserved", "Reserved", "Reserved"
+};
+
+static const char * const audio_cc[] = {
+	"Refer to Stream Header", "2 channels", "3 channels", "4 channels",
+	"5 channels", "6 channels", "7 channels", "8 channels"
+};
+
+static const char * const audio_ct[] = {
+	"Refer to Stream Header", "L-PCM", "AC-3", "MPEG-1",
+	"MP3", "MPEG2", "AAC LC", "DTS",
+	"ATRAC", "One Bit Audio", "Enhanced AC-3", "DTS-HD",
+	"MAT", "DST", "WMA Pro", "Refer to Audio CXT"
+};
+
+static const char * const audio_ss[] = {
+	"Refer to Stream Header", "16 bit", "20 bit", "24 bit"
+};
+
+static const char * const audio_sf[] = {
+	"Refer to Stream Header", "32 kHz", "44.1 kHz", "48 kHz",
+	"88.2 kHz", "96 kHz", "176.4 kHz", "192 kHz"
+};
+
+static const char * const drm_eotf[] = {
+	"Traditional gamma - SDR Luminance Range",
+	"Traditional gamma - HDR Luminance Range",
+	"SMPTE ST 2084 [40]",
+	"Hybrid Log-Gamma (HLG) based on ITU-R BT.2100-0 [50]",
+	"Reserved", "Reserved", "Reserved", "Reserved"
+};
+
+static ssize_t hdmirx_edid_version_show(struct device *dev,
+	struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+	ret_count = sprintf(buf, "%s\n", HdmiRx_GetEDID_version()?"2.0":"1.4");
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+
+static ssize_t hdmirx_edid_version_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t size)
+{
+	mutex_lock(&hdmirx_sysfs_lock);
+	if (sysfs_streq(buf, "1.4"))
+		HdmiRx_SetEDID_version(0);
+	else if (sysfs_streq(buf, "2.0"))
+		HdmiRx_SetEDID_version(1);
+	else
+		HDMIRX_ERROR("Set EDID version fail, unknown version\n");
+	mutex_unlock(&hdmirx_sysfs_lock);
+	return size;
+}
+
+static void dump_avi_infoframe(void)
+{
+	if (hdmi_rx.avi_t.type_code != INFOFRAME_AVI) {
+		pr_err("No AVI InfoFrame\n");
+		return;
+	}
+
+	pr_err("Type Code: 0x%02x\n", hdmi_rx.avi_t.type_code);
+	pr_err("Version Number: %u\n", hdmi_rx.avi_t.ver);
+	pr_err("Length of InfoFrame: %u\n", hdmi_rx.avi_t.len);
+	pr_err("Scan Information: %s\n", avi_s[hdmi_rx.avi_t.S&0x3]);
+	pr_err("Bar Data Present: %s\n", avi_b[hdmi_rx.avi_t.B&0x3]);
+	pr_err("Active Format Present: %s\n", avi_a[hdmi_rx.avi_t.A&0x1]);
+	pr_err("RGB or YCbCr: %s\n", avi_y[hdmi_rx.avi_t.Y&0x7]);
+	pr_err("Active Portion Aspect Ratio: %s\n", avi_r[hdmi_rx.avi_t.R&0xF]);
+	pr_err("Picture Aspect Ratio: %s\n", avi_m[hdmi_rx.avi_t.M&0x3]);
+	pr_err("Colorimetry: %s\n", avi_c[hdmi_rx.avi_t.C&0x3]);
+	pr_err("Non-Uniform Picture: %s\n", avi_c[hdmi_rx.avi_t.C&0x3]);
+	pr_err("Non-Uniform Picture Scaling: %s\n",
+		avi_sc[hdmi_rx.avi_t.SC&0x3]);
+	pr_err("RGB Quanitzation Range: %s\n", avi_q[hdmi_rx.avi_t.Q&0x3]);
+	pr_err("Extended Colorimetry: %s\n", avi_ec[hdmi_rx.avi_t.EC&0x7]);
+	pr_err("IT content: %s\n", avi_itc[hdmi_rx.avi_t.ITC&0x1]);
+	pr_err("VIC: %u\n", hdmi_rx.avi_t.VIC);
+	pr_err("Pixel Repetition Factor: %s\n", avi_pr[hdmi_rx.avi_t.PR&0xF]);
+	pr_err("IT Content Type: %s\n", avi_cn[hdmi_rx.avi_t.CN&0x3]);
+	pr_err("YCC Quantization Range: %s\n", avi_yq[hdmi_rx.avi_t.YQ&0x3]);
+	pr_err("ETB: %02x%02x\n",
+		hdmi_rx.avi_t.ETB15_08, hdmi_rx.avi_t.ETB07_00);
+	pr_err("SBB: %02x%02x\n",
+		hdmi_rx.avi_t.SBB15_08, hdmi_rx.avi_t.SBB07_00);
+	pr_err("ELB: %02x%02x\n",
+		hdmi_rx.avi_t.ELB15_08, hdmi_rx.avi_t.ELB07_00);
+	pr_err("SRB: %02x%02x\n",
+		hdmi_rx.avi_t.SRB15_08, hdmi_rx.avi_t.SRB07_00);
+}
+
+static void dump_vsi_infoframe(void)
+{
+	if (hdmi_rx.vsi_t.type_code != INFOFRAME_VSI) {
+		pr_err("No VSI InfoFrame\n");
+		return;
+	}
+
+	pr_err("Type Code: 0x%02x\n", hdmi_rx.vsi_t.type_code);
+	pr_err("Version Number: %u\n", hdmi_rx.vsi_t.ver);
+	pr_err("Length of InfoFrame: %u\n", hdmi_rx.vsi_t.len);
+	pr_err("IEEE Reg ID: %02x %02x %02x\n",
+		hdmi_rx.vsi_t.Reg_ID[0], hdmi_rx.vsi_t.Reg_ID[1],
+		hdmi_rx.vsi_t.Reg_ID[2]);
+	pr_err("Vendor-Specific Payload:\n");
+	pr_err("%02x %02x %02x %02x %02x %02x %02x %02x %02x %02x\n",
+		hdmi_rx.vsi_t.Payload[0], hdmi_rx.vsi_t.Payload[1],
+		hdmi_rx.vsi_t.Payload[2], hdmi_rx.vsi_t.Payload[3],
+		hdmi_rx.vsi_t.Payload[4], hdmi_rx.vsi_t.Payload[5],
+		hdmi_rx.vsi_t.Payload[6], hdmi_rx.vsi_t.Payload[7],
+		hdmi_rx.vsi_t.Payload[8], hdmi_rx.vsi_t.Payload[9]);
+	pr_err("%02x %02x %02x %02x %02x %02x %02x %02x %02x %02x\n",
+		hdmi_rx.vsi_t.Payload[10], hdmi_rx.vsi_t.Payload[11],
+		hdmi_rx.vsi_t.Payload[12], hdmi_rx.vsi_t.Payload[13],
+		hdmi_rx.vsi_t.Payload[14], hdmi_rx.vsi_t.Payload[15],
+		hdmi_rx.vsi_t.Payload[16], hdmi_rx.vsi_t.Payload[17],
+		hdmi_rx.vsi_t.Payload[18], hdmi_rx.vsi_t.Payload[19]);
+	pr_err("%02x %02x %02x %02x %02x\n",
+		hdmi_rx.vsi_t.Payload[20], hdmi_rx.vsi_t.Payload[21],
+		hdmi_rx.vsi_t.Payload[22], hdmi_rx.vsi_t.Payload[23],
+		hdmi_rx.vsi_t.Payload[24]);
+
+}
+
+static void dump_spd_infoframe(void)
+{
+	if (hdmi_rx.spd_t.type_code != INFOFRAME_SPD) {
+		pr_err("No SPD InfoFrame\n");
+		return;
+	}
+
+	pr_err("Type Code: 0x%02x\n", hdmi_rx.spd_t.type_code);
+	pr_err("Version Number: %u\n", hdmi_rx.spd_t.ver);
+	pr_err("Length of InfoFrame: %u\n", hdmi_rx.spd_t.len);
+	pr_err("Vendor Name: %c%c%c%c%c%c%c%c\n",
+		hdmi_rx.spd_t.VendorName[0], hdmi_rx.spd_t.VendorName[1],
+		hdmi_rx.spd_t.VendorName[2], hdmi_rx.spd_t.VendorName[3],
+		hdmi_rx.spd_t.VendorName[4], hdmi_rx.spd_t.VendorName[5],
+		hdmi_rx.spd_t.VendorName[6], hdmi_rx.spd_t.VendorName[7]);
+	pr_err("Product Description: %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",
+		hdmi_rx.spd_t.ProductDesc[0], hdmi_rx.spd_t.ProductDesc[1],
+		hdmi_rx.spd_t.ProductDesc[2], hdmi_rx.spd_t.ProductDesc[3],
+		hdmi_rx.spd_t.ProductDesc[4], hdmi_rx.spd_t.ProductDesc[5],
+		hdmi_rx.spd_t.ProductDesc[6], hdmi_rx.spd_t.ProductDesc[7],
+		hdmi_rx.spd_t.ProductDesc[8], hdmi_rx.spd_t.ProductDesc[9],
+		hdmi_rx.spd_t.ProductDesc[10], hdmi_rx.spd_t.ProductDesc[11],
+		hdmi_rx.spd_t.ProductDesc[12], hdmi_rx.spd_t.ProductDesc[13],
+		hdmi_rx.spd_t.ProductDesc[14], hdmi_rx.spd_t.ProductDesc[15]);
+
+	if (hdmi_rx.spd_t.SourceInfo < 0xF)
+		pr_err("Source Information: %s\n",
+			spd_source_info[hdmi_rx.spd_t.SourceInfo]);
+	else
+		pr_err("Source Information: Reserved\n");
+
+}
+
+static void dump_audio_infoframe(void)
+{
+	if (hdmi_rx.audiopkt_t.type_code != INFOFRAME_AUDIO) {
+		pr_err("No AUDIO InfoFrame\n");
+		return;
+	}
+
+	pr_err("Type Code: 0x%02x\n", hdmi_rx.audiopkt_t.type_code);
+	pr_err("Version Number: %u\n", hdmi_rx.audiopkt_t.ver);
+	pr_err("Length of InfoFrame: %u\n", hdmi_rx.audiopkt_t.len);
+	pr_err("Audio Channel Count: %s\n",
+		audio_cc[hdmi_rx.audiopkt_t.CC&0x7]);
+	pr_err("Audio Coding Type: %s\n", audio_ct[hdmi_rx.audiopkt_t.CT&0xF]);
+	pr_err("Sample Size: %s\n", audio_ss[hdmi_rx.audiopkt_t.SS&0x3]);
+	pr_err("Sample Frequency: %s\n", audio_sf[hdmi_rx.audiopkt_t.SF&0x7]);
+	pr_err("CXT: %02x\n", hdmi_rx.audiopkt_t.CXT);
+	pr_err("CA: %02x\n", hdmi_rx.audiopkt_t.CA);
+	pr_err("LFEPBL: %02x\n", hdmi_rx.audiopkt_t.LFEPBL);
+	pr_err("Level Shift Value: %udB\n", hdmi_rx.audiopkt_t.LSV);
+	pr_err("DM_INH: %u\n", hdmi_rx.audiopkt_t.DM_INH);
+}
+
+static void dump_drm_infoframe(void)
+{
+	if (hdmi_rx.drm_t.type_code != INFOFRAME_DRM) {
+		pr_err("No DRM InfoFrame\n");
+		return;
+	}
+
+	pr_err("Type Code: 0x%02x\n", hdmi_rx.drm_t.type_code);
+	pr_err("Version Number: %u\n", hdmi_rx.drm_t.ver);
+	pr_err("Length of InfoFrame: %u\n", hdmi_rx.drm_t.len);
+	pr_err("EOTF: %s\n", drm_eotf[hdmi_rx.drm_t.eEOTFtype&0x7]);
+	pr_err("Static_Metadata_Descriptor_ID: %u\n", hdmi_rx.drm_t.eMeta_Desc);
+
+	if (hdmi_rx.drm_t.display_primaries_x0 >= 0xC350)
+		pr_err("display_primaries_x0: 1.00000\n");
+	else
+		pr_err("display_primaries_x0: 0.%05u\n",
+			hdmi_rx.drm_t.display_primaries_x0 * 2);
+
+	if (hdmi_rx.drm_t.display_primaries_y0 >= 0xC350)
+		pr_err("display_primaries_y0: 1.00000\n");
+	else
+		pr_err("display_primaries_y0: 0.%05u\n",
+			hdmi_rx.drm_t.display_primaries_y0 * 2);
+
+	if (hdmi_rx.drm_t.display_primaries_x1 >= 0xC350)
+		pr_err("display_primaries_x1: 1.00000\n");
+	else
+		pr_err("display_primaries_x1: 0.%05u\n",
+			hdmi_rx.drm_t.display_primaries_x1 * 2);
+
+	if (hdmi_rx.drm_t.display_primaries_y1 >= 0xC350)
+		pr_err("display_primaries_y1: 1.00000\n");
+	else
+		pr_err("display_primaries_y1: 0.%05u\n",
+			hdmi_rx.drm_t.display_primaries_y1 * 2);
+
+	if (hdmi_rx.drm_t.display_primaries_x2 >= 0xC350)
+		pr_err("display_primaries_x2: 1.00000\n");
+	else
+		pr_err("display_primaries_x2: 0.%05u\n",
+			hdmi_rx.drm_t.display_primaries_x2 * 2);
+
+	if (hdmi_rx.drm_t.display_primaries_y2 >= 0xC350)
+		pr_err("display_primaries_y2: 1.00000\n");
+	else
+		pr_err("display_primaries_y2: 0.%05u\n",
+			hdmi_rx.drm_t.display_primaries_y2 * 2);
+
+	if (hdmi_rx.drm_t.white_point_x >= 0xC350)
+		pr_err("white_point_x: 1.00000\n");
+	else
+		pr_err("white_point_x: 0.%05u\n",
+			hdmi_rx.drm_t.white_point_x * 2);
+
+	if (hdmi_rx.drm_t.white_point_y >= 0xC350)
+		pr_err("white_point_y: 1.00000\n");
+	else
+		pr_err("white_point_y: 0.%05u\n",
+			hdmi_rx.drm_t.white_point_y * 2);
+
+	pr_err("max_display_mastering_luminance: %05u cd/m2\n",
+			hdmi_rx.drm_t.max_display_mastering_luminance);
+
+	pr_err("max_display_mastering_luminance: %u.%05u cd/m2\n",
+			hdmi_rx.drm_t.min_display_mastering_luminance / 10000,
+			hdmi_rx.drm_t.min_display_mastering_luminance % 10000);
+
+	pr_err("maximum_content_light_level: %05u cd/m2\n",
+			hdmi_rx.drm_t.maximum_content_light_level);
+
+	pr_err("maximum_frame_average_light_level: %05u cd/m2\n",
+			hdmi_rx.drm_t.maximum_frame_average_light_level);
+}
+
+
+static ssize_t hdmirx_infoframe_show(struct device *dev,
+	struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+
+	ret_count = sprintf(buf, "avi: %s\n",
+		(hdmi_rx.avi_t.type_code == INFOFRAME_AVI)?"Y":"n");
+
+	ret_count += sprintf(buf + ret_count, "vsi: %s\n",
+		(hdmi_rx.vsi_t.type_code == INFOFRAME_VSI)?"Y":"n");
+
+	ret_count += sprintf(buf + ret_count, "spd: %s\n",
+		(hdmi_rx.spd_t.type_code == INFOFRAME_SPD)?"Y":"n");
+
+	ret_count += sprintf(buf + ret_count, "audio: %s\n",
+		(hdmi_rx.audiopkt_t.type_code == INFOFRAME_AUDIO)?"Y":"n");
+
+	ret_count += sprintf(buf + ret_count, "drm: %s\n",
+		(hdmi_rx.drm_t.type_code == INFOFRAME_DRM)?"Y":"n");
+
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+
+static ssize_t hdmirx_infoframe_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t size)
+{
+	mutex_lock(&hdmirx_sysfs_lock);
+
+	if (sysfs_streq(buf, "avi"))
+		dump_avi_infoframe();
+	else if (sysfs_streq(buf, "vsi"))
+		dump_vsi_infoframe();
+	else if (sysfs_streq(buf, "spd"))
+		dump_spd_infoframe();
+	else if (sysfs_streq(buf, "audio"))
+		dump_audio_infoframe();
+	else if (sysfs_streq(buf, "drm"))
+		dump_drm_infoframe();
+
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return size;
+}
+
+static ssize_t hdmirx_hdcp1x_en_show(struct device *dev,
+	struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+
+	ret_count = sprintf(buf, "%s\n",
+		(Is_HdmiRx_hdcp1x_enabled() == true)?"Enable":"Disable");
+
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+static ssize_t hdmirx_hdcp2p2_en_show(struct device *dev,
+	struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+
+	ret_count = sprintf(buf, "%s\n",
+		(Is_HdmiRx_hdcp2p2_enabled() == true)?"Enable":"Disable");
+
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+#endif
+
+static const char * const hdcp_str[] = {
+	"None", "Nego1.x", "1.x", "Nego2.2",
+	"2.2", "Unknow", "Unknow", "Unknow"
+};
+static ssize_t hdmirx_hdcp_status_show(struct device *dev,
+	struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+	ret_count = sprintf(buf, "%s\n", hdcp_str[hdmirx_state.hdcp_state&0x7]);
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+
+#if HDMI_REPEATER_SUPPORT
+static ssize_t hdmi_repeater_mode_show(struct device *dev,
+	struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count = 0;
+
+	mutex_lock(&hdmirx_sysfs_lock);
+	ret_count = sprintf(buf, "%s\n", Get_Hdmi_repeater_mode()?"ON":"OFF");
+	mutex_unlock(&hdmirx_sysfs_lock);
+
+	return ret_count;
+}
+
+static ssize_t hdmi_repeater_mode_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t size)
+{
+	mutex_lock(&hdmirx_sysfs_lock);
+	if (sysfs_streq(buf, "ON") || sysfs_streq(buf, "on"))
+		Set_Hdmi_repeater_mode(1);
+	else if (sysfs_streq(buf, "OFF") || sysfs_streq(buf, "off"))
+		Set_Hdmi_repeater_mode(0);
+	else
+		HDMIRX_ERROR("Set repeater mode fail, unknown mode\n");
+	mutex_unlock(&hdmirx_sysfs_lock);
+	return size;
+}
+#endif
+
+/* /sys/devices/platform/98037000.hdmirx/edid_version */
+static DEVICE_ATTR(edid_version, 0644,
+	hdmirx_edid_version_show, hdmirx_edid_version_store);
+/* /sys/devices/platform/98037000.hdmirx/infoframe */
+static DEVICE_ATTR(infoframe, 0644,
+	hdmirx_infoframe_show, hdmirx_infoframe_store);
+/* /sys/devices/platform/98037000.hdmirx/hdcp1x_en */
+static DEVICE_ATTR(hdcp1x_en, 0444, hdmirx_hdcp1x_en_show, NULL);
+#ifdef CONFIG_RTK_HDCPRX_2P2
+/* /sys/devices/platform/98037000.hdmirx/hdcp2p2_en */
+static DEVICE_ATTR(hdcp2p2_en, 0444, hdmirx_hdcp2p2_en_show, NULL);
+#endif
+/* /sys/devices/platform/98037000.hdmirx/hdcp_status */
+static DEVICE_ATTR(hdcp_status, 0444, hdmirx_hdcp_status_show, NULL);
+#if HDMI_REPEATER_SUPPORT
+/* /sys/devices/platform/98037000.hdmirx/repeater_mode */
+static DEVICE_ATTR(repeater_mode, 0644,
+	hdmi_repeater_mode_show, hdmi_repeater_mode_store);
+#endif
+
+void register_hdmirx_sysfs(struct platform_device *pdev)
+{
+	device_create_file(&pdev->dev, &dev_attr_edid_version);
+	device_create_file(&pdev->dev, &dev_attr_infoframe);
+
+	device_create_file(&pdev->dev, &dev_attr_hdcp1x_en);
+#ifdef CONFIG_RTK_HDCPRX_2P2
+	device_create_file(&pdev->dev, &dev_attr_hdcp2p2_en);
+#endif
+	device_create_file(&pdev->dev, &dev_attr_hdcp_status);
+
+#if HDMI_REPEATER_SUPPORT
+	device_create_file(&pdev->dev, &dev_attr_repeater_mode);
+#endif
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_sysfs.h b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_sysfs.h
new file mode 100644
index 00000000..3adae21
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_sysfs.h
@@ -0,0 +1,13 @@
+/*
+ * hdmirx_sysfs.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+int register_hdmirx_sysfs(struct platform_device *pdev);
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_video_dev.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_video_dev.c
new file mode 100644
index 00000000..29f83d6
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_video_dev.c
@@ -0,0 +1,794 @@
+/*
+ * hdmirx_video_dev.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmirx_video_dev.h"
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmirx_video_dev.h"
+#include "hdmirx_wrapper.h"
+#include "mipi_wrapper.h"
+#include "hdmirx_reg.h"
+
+#include "rx_drv/hdmiInternal.h"
+#include "rx_drv/hdmiEDID.h"
+
+#define HDMI_MEASURE_RETRY_TIMES 10
+
+int hdmi_stream_on = 0;
+int hdmi_timestamp_mode = 0;/* 0:system time, 1:90KHz timer */
+
+struct hdmirx_format_desc {
+	char *name;
+	__u32 fcc;
+};
+const struct hdmirx_format_desc hdmi_rx_fmts[] = {
+	{
+		.name		= "Y/CbCr 4:2:2",
+		.fcc		= V4L2_PIX_FMT_YUYV,
+	},
+	{
+		.name		= "YUV 4:2:0 (NV12)",
+		.fcc		= V4L2_PIX_FMT_NV12,
+	},
+	{
+		.name		= "YUV 4:2:0 (NV21)",
+		.fcc		= V4L2_PIX_FMT_NV21,
+	},
+	{
+		.name		= "YUV 4:2:0 10bit (NV12 10bit)",
+		.fcc		= V4L2_PIX_FMT_NV12M,
+	},
+	{
+		.name		= "YUV 4:2:0 10bit (NV21 10bit)",
+		.fcc		= V4L2_PIX_FMT_NV21M,
+	},
+	{
+		.name		= "ARGB",
+		.fcc		= V4L2_PIX_FMT_ARGB32,
+	},
+	{
+		.name		= "BGRA",
+		.fcc		= V4L2_PIX_FMT_ABGR32,
+	}
+};
+#define V4L2_HDMI_RX_SUPPORT_FMT_NUM  (sizeof(hdmi_rx_fmts)/sizeof(struct hdmirx_format_desc))
+
+/*=================== extern Variable/Function ===================*/
+extern MIPI_TOP_INFO mipi_top;
+
+extern char Hdmi_IsbReady(void);
+extern int Hdmi_get_b_value(void);
+extern unsigned int rx_pitch_measurement(unsigned int output_h, MIPI_OUT_COLOR_SPACE_T output_color);
+extern void HdmiRx_enable_hdcp(unsigned char *bksv, unsigned char *device_key);
+#ifdef CONFIG_RTK_HDCPRX_2P2
+extern void HdmiRx_enable_hdcp2p2(unsigned char *key);
+#endif
+#if HDMI_REPEATER_SUPPORT
+void Set_Hdmi_repeater_mode(int enable);
+#endif
+/*======================================================*/
+
+MIPI_OUT_COLOR_SPACE_T V4L2_format_parse(unsigned int pixelformat)
+{
+	MIPI_OUT_COLOR_SPACE_T output_color;
+
+	switch (pixelformat) {
+	case V4L2_PIX_FMT_NV12:
+		mipi_top.uv_seq = UV_NV12;
+		output_color = OUT_8BIT_YUV420;
+		break;
+
+	case V4L2_PIX_FMT_NV21:
+		/* main */
+		mipi_top.uv_seq = UV_NV21;
+		output_color = OUT_8BIT_YUV420;
+		break;
+
+	case V4L2_PIX_FMT_NV12M:
+		mipi_top.uv_seq = UV_NV12;
+		output_color = OUT_10BIT_YUV420;
+		break;
+
+	case V4L2_PIX_FMT_NV21M:
+		mipi_top.uv_seq = UV_NV21;
+		output_color = OUT_10BIT_YUV420;
+		break;
+
+	case V4L2_PIX_FMT_ARGB32:
+		/* byte 0~3: ARGB-8-8-8-8 */
+		output_color = OUT_ARGB;
+		break;
+
+	case V4L2_PIX_FMT_ABGR32:
+		/* byte 0~3: BGRA-8-8-8-8 */
+		output_color = OUT_BGRA;
+		break;
+	case V4L2_PIX_FMT_YUYV:
+		output_color = OUT_8BIT_YUV422;
+		break;
+	default:
+		/* FCC2ASCII */
+		HDMIRX_ERROR("Unsupported pixel format: %c%c%c%c",
+			((char *)(&pixelformat))[0], ((char *)(&pixelformat))[1],
+			((char *)(&pixelformat))[2], ((char *)(&pixelformat))[3]);
+		output_color = OUT_UNKNOW;
+		break;
+	}
+
+	return  output_color;
+}
+
+int out_color_to_bpp(MIPI_OUT_COLOR_SPACE_T output_color)
+{
+	int bpp;
+
+	switch (output_color) {
+	case OUT_8BIT_YUV420:
+		/* V4L2_PIX_FMT_NV12, V4L2_PIX_FMT_NV21 */
+		bpp = 12;
+		break;
+	case OUT_10BIT_YUV420:
+		/* V4L2_PIX_FMT_NV12M, V4L2_PIX_FMT_NV21M */
+		bpp = 16;
+		break;
+	case OUT_ARGB:
+		/* V4L2_PIX_FMT_BGR32 */
+		bpp = 32;
+		break;
+	case OUT_10BIT_YUV422:
+		bpp = 32;
+		break;
+	default:
+		/* All other RGB formats */
+		bpp = 32;
+		break;
+	}
+
+	return bpp;
+}
+
+static long v4l2_hdmi_do_ioctl(struct file *file, unsigned int cmd, void *arg)
+{
+	long ret = 0;
+	struct video_device *vdev = video_devdata(file);
+	struct v4l2_hdmi_dev *dev = video_drvdata(file);
+
+	/* HDMIRX_DEBUG(" ioctl TYPE(0x%x) NR(%u) SIZE(%u)",  _IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd)); */
+
+	switch (cmd) {
+	case VIDIOC_QUERYCAP:
+	{
+		struct v4l2_capability *cap = arg;
+
+		/* HDMIRX_INFO(" ioctl VIDIOC_QUERYCAP"); */
+		memset(cap, 0, sizeof(*cap));
+
+		strlcpy(cap->driver, "v4l2_mipi_top", sizeof(cap->driver));
+		strlcpy(cap->card, vdev->name, sizeof(cap->card));
+
+		cap->version = LINUX_VERSION_CODE;
+		cap->capabilities = V4L2_CAP_VIDEO_CAPTURE | V4L2_CAP_STREAMING;
+		break;
+	}
+	case VIDIOC_CROPCAP:
+	{
+		struct v4l2_cropcap *ccap = arg;
+
+		ccap->bounds.left = 0;
+		ccap->bounds.top = 0;
+
+		ccap->bounds.width = 4096;
+		ccap->bounds.height = 2160;
+
+		ccap->defrect = ccap->bounds;
+
+		ccap->pixelaspect.numerator = 1;
+		ccap->pixelaspect.denominator = 1;
+		break;
+	}
+	case VIDIOC_G_CROP:
+	case VIDIOC_S_CROP:
+		ret = -EINVAL;
+		break;
+	case VIDIOC_ENUM_FMT:
+	{
+		struct v4l2_fmtdesc *fmt = arg;
+		struct hdmirx_format_desc *format;
+		enum v4l2_buf_type type = fmt->type;
+		__u32 index = fmt->index;
+
+		/* HDMIRX_INFO(" ioctl VIDIOC_ENUM_FMT"); */
+		memset(fmt, 0, sizeof(*fmt));
+		fmt->index = index;
+		fmt->type = type;
+
+		if (fmt->index >= V4L2_HDMI_RX_SUPPORT_FMT_NUM) {
+			ret = -EINVAL;
+			goto exit;
+		}
+
+		format = &hdmi_rx_fmts[fmt->index];
+		fmt->flags = V4L2_FMT_FLAG_COMPRESSED;
+
+		strlcpy(fmt->description, format->name, sizeof(fmt->description));
+		fmt->description[sizeof(fmt->description) - 1] = 0;
+
+		fmt->pixelformat = format->fcc;
+		break;
+	}
+	case VIDIOC_ENUM_FRAMESIZES:
+	{
+		struct v4l2_frmsizeenum *fsize = arg;
+		int v_len;
+
+		/* HDMIRX_INFO(" ioctl VIDIOC_ENUM_FRAMESIZES"); */
+		/* Look for the given pixel format */
+		if (((hdmirx_state.measure_ready == 0) && (mipi_top.src_sel == 1)) ||
+			(fsize->index != 0)) {
+			ret = -EINVAL;
+			goto exit;
+		}
+
+		if (hdmi_rx.timing_t.is_interlace)
+			v_len = mipi_top.v_input_len << 1;
+		else
+			v_len = mipi_top.v_input_len;
+
+		fsize->type = V4L2_FRMSIZE_TYPE_CONTINUOUS;
+		fsize->stepwise.min_width = (mipi_top.h_input_len)/32;
+		fsize->stepwise.max_width = mipi_top.h_input_len;
+		fsize->stepwise.step_width = 1;
+		fsize->stepwise.min_height = v_len/32;
+		fsize->stepwise.max_height = v_len;
+		fsize->stepwise.step_height = 1;
+		HDMIRX_INFO("Act_hor:%u, Act_ver:%u", mipi_top.h_input_len, mipi_top.v_input_len);
+		break;
+	}
+	case VIDIOC_ENUM_FRAMEINTERVALS:
+	{
+		struct v4l2_frmivalenum *fival = arg;
+
+		if (fival->index != 0) {
+			ret = -EINVAL;
+			goto exit;
+		}
+
+		fival->type = V4L2_FRMIVAL_TYPE_DISCRETE;
+		fival->discrete.numerator = 1;
+		if (mipi_top.src_sel == 1) {
+			unsigned int vic;
+
+			vic = lib_hdmi_get_vic();
+			if (hdmi_vic_table[vic].interlace)
+				fival->discrete.denominator = hdmi_vic_table[vic].fps/2;
+			else
+				fival->discrete.denominator = hdmi_vic_table[vic].fps;
+		} else {
+				fival->discrete.denominator = 60;
+		}
+		break;
+	}
+	case VIDIOC_S_FMT:
+	{
+		struct v4l2_format *fmt = arg;
+		int v_len;
+
+		dev->width = fmt->fmt.pix.width;
+		dev->height = fmt->fmt.pix.height;
+		dev->outfmt = V4L2_format_parse(fmt->fmt.pix.pixelformat);
+		dev->bpp = out_color_to_bpp(dev->outfmt);
+		HDMIRX_INFO(" ioctl VIDIOC_S_FMT,%dx%d,color=0x%x",
+			fmt->fmt.pix.width, fmt->fmt.pix.height, dev->outfmt);
+
+		if (hdmi_rx.timing_t.is_interlace)
+			v_len = mipi_top.v_input_len << 1;
+		else
+			v_len = mipi_top.v_input_len;
+
+		mipi_top.h_output_len = fmt->fmt.pix.width;
+		mipi_top.v_output_len = fmt->fmt.pix.height;
+		mipi_top.output_color = dev->outfmt;
+		mipi_top.pitch = rx_pitch_measurement(mipi_top.h_output_len, mipi_top.output_color);
+
+		mipi_top.mipi_init = 0;
+		if ((v_len) && (v_len < mipi_top.v_output_len)) {
+			HDMIRX_ERROR("[v_size error :%d<%d]", v_len, mipi_top.v_output_len);
+			ret = -EINVAL;
+			goto exit;
+		}
+
+		if ((mipi_top.h_input_len) && (mipi_top.h_input_len < mipi_top.v_output_len)) {
+			HDMIRX_ERROR("[h_size error :%d<%d]",
+				mipi_top.h_input_len, mipi_top.v_output_len);
+			ret = -EINVAL;
+			goto exit;
+		}
+
+		HDMIRX_INFO(" ioctl VIDIOC_S_FMT,output v(%u) h(%u) color(%u) pitch(%u)",
+			mipi_top.h_output_len, mipi_top.v_output_len,
+			mipi_top.output_color, mipi_top.pitch);
+		break;
+	}
+	case VIDIOC_S_PARM:
+		/* Set USB camera frame rate, unused in RX */
+
+		/* HDMIRX_INFO("Not support fps change"); */
+		break;
+	case VIDIOC_REQBUFS:
+	{
+		/* Buffers & streaming */
+		struct vb2_queue *vq;
+		struct v4l2_requestbuffers *rb = (struct v4l2_requestbuffers *)arg;
+
+		HDMIRX_INFO(" ioctl VIDIOC_REQBUFS count=%d, type=%d, memory=%d",
+			rb->count, rb->type, rb->memory);
+
+		/* Initialize queue */
+		vq = &dev->vb_hdmidq;
+		ret = hdmirx_queue_init(dev, vq, rb->memory);
+		if (ret) {
+			HDMIRX_ERROR("hdmirx_queue_init failed: %ld", ret);
+			goto exit;
+		}
+
+		ret = vb2_reqbufs(vq, rb);
+		if (ret) {
+			HDMIRX_ERROR("vb2_reqbufs failed: %ld", ret);
+			goto exit;
+		}
+		break;
+	}
+	case VIDIOC_QUERYBUF:
+	{
+		struct v4l2_buffer *buf = arg;
+
+		/*
+		 * HDMIRX_INFO(" ioctl VIDIOC_QUERYBUF index(%u) type(%u) length(%u)",
+		 *	buf->index,buf->type,buf->length);
+		 */
+		ret = vb2_querybuf(&dev->vb_hdmidq, buf);
+
+		if (ret < 0)
+			HDMIRX_ERROR(" ioctl VIDIOC_QUERYBUF fail");
+		break;
+	}
+	case VIDIOC_QBUF:
+	{
+		struct v4l2_buffer *buf = arg;
+
+		/* HDMIRX_INFO(" ioctl VIDIOC_QBUF"); */
+
+		ret = vb2_qbuf(&dev->vb_hdmidq, buf);
+
+		if (ret < 0)
+			HDMIRX_ERROR(" ioctl VIDIOC_QBUF fail");
+		break;
+	}
+	case VIDIOC_DQBUF:
+	{
+		struct v4l2_buffer *buf = arg;
+
+		/*HDMIRX_INFO(" ioctl VIDIOC_DQBUF"); */
+
+		ret = vb2_dqbuf(&dev->vb_hdmidq, buf, file->f_flags & O_NONBLOCK);
+		if (ret == 0)
+			atomic_dec(&dev->hdmidq.rcnt);
+
+		/* Avoid userspace seeing broken frames on hotplug or switching tv system */
+		if (unlikely(ret == 0 && hdmi_stream_on == 0))
+			ret = -EINVAL;
+
+		break;
+	}
+	case VIDIOC_STREAMON:
+	{
+		HDMIRX_INFO(" ioctl VIDIOC_STREAMON");
+
+		vb2_streamon(&dev->vb_hdmidq, dev->vb_hdmidq.type);
+
+		break;
+	}
+	case VIDIOC_STREAMOFF:
+	{
+		struct vb2_queue *vq;
+
+		HDMIRX_INFO(" ioctl VIDIOC_STREAMOFF");
+
+		vb2_streamoff(&dev->vb_hdmidq, dev->vb_hdmidq.type);
+
+		/* Release queue */
+		vq = &dev->vb_hdmidq;
+		vb2_queue_release(vq);
+
+		hdmi_timestamp_mode = 0;
+
+		break;
+	}
+	case VIDIOC_QUERY_MIPI_IN_TYPE:
+	{
+		struct v4l2_mipi_in_type *in_type = arg;
+
+		/* HDMIRX_INFO(" ioctl VIDIOC_MIPI_IN_TYPE"); */
+
+		in_type->input_type = mipi_top.src_sel;
+		break;
+	}
+	case VIDIOC_SET_MIPI_IN_TYPE:
+		/* HDMIRX_INFO(" ioctl VIDIOC_SET_MIPI_IN_TYPE"); */
+
+		break;
+	case VIDIOC_ENABLE_RX_HDCP:
+	{
+		struct rx_hdcp_key *rx_key;
+
+		HDMIRX_INFO("ioctl VIDIOC_ENABLE_RX_HDCP\n");
+
+#ifndef CONFIG_RTK_HDCP_1x
+		HDMIRX_ERROR("Enable HDCP fail because HDCP TX is disabled");
+		break;
+#endif
+
+		rx_key = arg;
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+		HdmiRx_enable_hdcp2p2(rx_key->licensed);
+#endif
+		if ((rx_key->ksv[0] == 0) && (rx_key->ksv[1] == 0) &&
+			(rx_key->ksv[2] == 0) && (rx_key->ksv[3] == 0) &&
+			(rx_key->ksv[4] == 0))
+			HDMIRX_INFO("[HDCP1.4] Empty key, should be TEE case");
+
+		HdmiRx_enable_hdcp(rx_key->ksv, rx_key->private_key);
+		break;
+	}
+	case VIDIOC_SET_TIMESTAMP_MODE:
+	{
+		int *mode = arg;
+
+		HDMIRX_INFO("ioctl VIDIOC_SET_TIMESTAMP_MODE\n");
+
+		hdmi_timestamp_mode = (int)*mode;
+
+		break;
+	}
+#if HDMI_REPEATER_SUPPORT
+	case VIDIOC_SET_REPEATER_MODE:
+	{
+		int *repeater_mode = arg;
+
+		HDMIRX_INFO("ioctl VIDIOC_SET_REPEATER_MODE\n");
+
+		Set_Hdmi_repeater_mode((int)*repeater_mode);
+
+		break;
+	}
+#endif
+	case VIDIOC_SET_EDID_TABLE:
+	{
+		/* EDID 256Bytes */
+		HDMIRX_INFO("ioctl VIDIOC_SET_EDID_TABLE\n");
+
+		HdmiRx_ChangeCurrentEDID(arg);
+
+		break;
+	}
+	case VIDIOC_GET_INFOFRAME:
+	{
+		struct infoframe_packet *info_packet = arg;
+		unsigned char type = info_packet->type;
+
+		memset(info_packet, 0, sizeof(struct infoframe_packet));
+
+		switch (type) {
+		case INFOFRAME_VSI:
+			memcpy(info_packet, &hdmi_rx.vsi_t, sizeof(hdmi_rx.vsi_t));
+			break;
+		case INFOFRAME_AVI:
+			memcpy(info_packet, &hdmi_rx.avi_t, sizeof(hdmi_rx.avi_t));
+			break;
+		case INFOFRAME_SPD:
+			memcpy(info_packet, &hdmi_rx.spd_t, sizeof(hdmi_rx.spd_t));
+			break;
+		case INFOFRAME_AUDIO:
+			memcpy(info_packet, &hdmi_rx.audiopkt_t, sizeof(hdmi_rx.audiopkt_t));
+			/* Put Audio Type to last byte of data_byte  */
+			info_packet->data_byte[28] = hdmi_rx.audio_t.coding_type;
+			break;
+		case INFOFRAME_DRM:
+			memcpy(info_packet, &hdmi_rx.drm_t, sizeof(hdmi_rx.drm_t));
+			break;
+		default:
+			break;
+		}
+
+		break;
+	}
+	default:
+		HDMIRX_ERROR("Unknown ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+			_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+		ret = -ENOTTY;
+		break;
+	}
+
+exit:
+	return ret;
+}
+
+long v4l2_hdmi_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	long ret;
+
+	if (0) {
+		pr_info("v4l2_hdmi_ioctl(");
+		v4l_printk_ioctl(NULL, cmd);
+		pr_info(")\n");
+	}
+	HDMIRX_DEBUG(" ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+		_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+	ret = video_usercopy(file, cmd, arg, v4l2_hdmi_do_ioctl);
+	HDMIRX_DEBUG(" return ioctl TYPE(0x%x) NR(%u) SIZE(%u)",
+		_IOC_TYPE(cmd), _IOC_NR(cmd), _IOC_SIZE(cmd));
+	return ret;
+}
+
+#ifdef CONFIG_64BIT
+long compat_v4l2_hdmi_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	long ret_val;
+	struct compat_v4l2_buffer *c_buf;
+	struct v4l2_buffer buf;
+
+	if (!file->f_op->unlocked_ioctl) {
+		ret_val = -ENOTTY;
+		goto exit;
+	}
+
+	switch (cmd) {
+	case VIDIOC_QUERYBUF:
+	case VIDIOC_QBUF:
+	case VIDIOC_DQBUF:
+		memset(&buf, 0, sizeof(buf));
+		c_buf = (void __user *)(unsigned long)compat_ptr(arg);
+		buf.index = c_buf->index;
+		buf.type = c_buf->type;
+		buf.bytesused = c_buf->bytesused;
+		buf.flags = c_buf->flags;
+		buf.field = c_buf->field;
+
+		if (copy_from_user(&buf.timestamp, &c_buf->timestamp, sizeof(c_buf->timestamp)))
+			HDMIRX_ERROR("copy_from_user fail");
+
+		if (copy_from_user(&buf.timecode, &c_buf->timecode, sizeof(c_buf->timecode)))
+			HDMIRX_ERROR("copy_from_user fail");
+
+		buf.m.offset = c_buf->compat_m.offset;
+		buf.m.userptr = (unsigned long)compat_ptr(c_buf->compat_m.userptr);
+		buf.m.fd = c_buf->compat_m.fd;
+		buf.length = c_buf->length;
+		buf.reserved2 = c_buf->reserved2;
+		buf.reserved = c_buf->reserved;
+		ret_val = v4l2_hdmi_do_ioctl(file, cmd, &buf);
+		break;
+	default:
+		ret_val = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+	}
+
+exit:
+	return ret_val;
+}
+#endif /* end of CONFIG_64BIT */
+
+int v4l2_mipi_top_open(struct file *filp)
+{
+	struct video_device *vdev = video_devdata(filp);
+	struct v4l2_fh *fh = kzalloc(sizeof(*fh), GFP_KERNEL);
+
+	filp->private_data = fh;
+	if (fh == NULL)
+		return -ENOMEM;
+	v4l2_fh_init(fh, vdev);
+	v4l2_fh_add(fh);
+
+	return 0;
+}
+
+static ssize_t show_hdmirx_bufcnt(struct device *cd,
+	struct device_attribute *attr, char *buf)
+{
+	struct video_device *vfd;
+	struct v4l2_hdmi_dev *dev;
+	struct hdmi_dmaqueue *hdmidq;
+	ssize_t ret_count;
+
+	vfd = container_of(cd, struct video_device, dev);
+	dev = (struct v4l2_hdmi_dev *)video_get_drvdata(vfd);
+	hdmidq = &dev->hdmidq;
+
+	ret_count = sprintf(buf, "qcnt:%d rcnt:%d\n",
+		atomic_read(&hdmidq->qcnt), atomic_read(&hdmidq->rcnt));
+
+	return ret_count;
+}
+
+static const char * const type[] = {"MIPI", "HDMIRx"};
+static const char * const status[] = {"NotReady", "Ready"};
+static const char * const color[] = {"RGB", "YUV444", "YUV422"};
+static const char * const sm[] = {"Progressive", "Interlaced"};
+static const char * const depth[] = {"8Bit", "10Bit", "12Bit", "16Bit"};
+static ssize_t show_hdmirx_video_info(struct device *cd,
+	struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count;
+	unsigned char type_index;
+	unsigned char status_index;
+	unsigned char mode_index;
+	unsigned char color_index;
+	unsigned char depth_index;
+	unsigned int width;
+	unsigned int height;
+	unsigned int vic;
+	unsigned int fps;
+
+	type_index = mipi_top.src_sel&0x1;
+	status_index = hdmirx_state.measure_ready&0x1;
+	width = mipi_top.h_input_len;
+	height = mipi_top.v_input_len;
+	mode_index = hdmi_rx.timing_t.is_interlace&0x1;
+	color_index = mipi_top.input_color&0x3;
+	depth_index = hdmi_rx.timing_t.colordepth&0x3;
+
+	if (mode_index == 1) /* interlaced mode */
+		height *= 2;
+
+	if (hdmirx_state.measure_ready)
+		vic = lib_hdmi_get_vic();
+	else
+		vic = 0;
+
+	fps = hdmi_vic_table[vic].fps;
+
+	ret_count = sprintf(buf, "Type:%s\nStatus:%s\nWidth:%u\nHeight:%u\n",
+		type[type_index], status[status_index],
+		width, height);
+	ret_count += sprintf(buf+ret_count,
+		"ScanMode:%s\nColor:%s\nFps:%u\nDepth:%s\n",
+		sm[mode_index], color[color_index], fps, depth[depth_index]);
+
+	ret_count += sprintf(buf+ret_count,
+		"HDR:%s\n",
+		(hdmi_rx.drm_t.type_code == INFOFRAME_DRM)?"Yes":"No");
+
+	return ret_count;
+}
+
+static const char * const lpcm[] = {"LPCM", "Non-LPCM", "HBR", "N/A"};
+static const char * const coding_type[] = {
+	"Stream Header", "L-PCM", "AC3", "MPEG-1",
+	"MP3", "MPEG2", "AAC LC", "DTS",
+	"ATRAC", "One Bit Audio", "Enhanced AC-3", "DTS-HD",
+	"MAT", "DST", "WMA Pro", "CXT"
+};
+static const char * const ex_coding_type[] = {
+	"CT", "Unknown", "Unknown", "Unknown",
+	"MPEG-4 HE AAC", "MPEG-4 HE AAC v2", "MPEG-4 AAC LC", "DRA",
+	"MPEG-4 HE AAC+", "Unknown", "MPEG-4 AAC LC+", "Unknown",
+	"Unknown", "Unknown", "Unknown", "Unknown"
+};
+static const char * const channel_count[] = {
+	"Stream Header", "2 channels", "3 channels", "4 channels",
+	"5 channels", "6 channels", "7 channels", "8 channels"
+};
+static const char * const sampling_freq[] = {
+	"Stream Header", "32 kHz", "44.1 kHz", "48 kHz",
+	"88.2 kHz", "96 kHz", "176.4 kHz", "192 kHz"
+};
+static const char * const sampling_size[] = {
+	"Stream Header", "16 bit", "20 bit", "24 bit"
+};
+static ssize_t show_hdmirx_audio_info(struct device *cd,
+	struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count;
+	unsigned int audio_ready = 0;
+	unsigned int freq = 0;
+	unsigned int lpcm_index = 3;
+	unsigned char ct_index;
+	unsigned char cc_index;
+	unsigned char sf_index;
+	unsigned char ss_index;
+
+	audio_ready = hdmirx_state.audio_detect_done;
+
+	if (audio_ready) {
+		freq = hdmi_rx.audio_t.audio_freq;
+		lpcm_index = hdmi_rx.audio_t.coding_type&0x3;
+		hdmi_update_audiopkt();
+	}
+
+	ret_count = sprintf(buf, "Ready:%u\n", audio_ready);
+
+	ret_count += sprintf(buf+ret_count, "Freq:%u\n", freq);
+	ret_count += sprintf(buf+ret_count,
+		"SPDIF Type:%s\n", lpcm[lpcm_index]);
+
+	ct_index = hdmi_rx.audiopkt_t.CT & 0xF;
+	if (ct_index != 0xF) {
+		ret_count += sprintf(buf+ret_count,
+			"Coding Type:%s\n", coding_type[ct_index]);
+	} else {
+		ct_index = hdmi_rx.audiopkt_t.CXT & 0xF;
+		ret_count += sprintf(buf+ret_count,
+			"Coding Type:%s\n", ex_coding_type[ct_index]);
+	}
+
+	cc_index = hdmi_rx.audiopkt_t.CC & 0x7;
+	ret_count += sprintf(buf+ret_count,
+		"Channel Count:%s\n", channel_count[cc_index]);
+
+	sf_index = hdmi_rx.audiopkt_t.SF & 0x7;
+	ret_count += sprintf(buf+ret_count,
+		"Sampling Freq:%s\n", sampling_freq[sf_index]);
+
+	ss_index = hdmi_rx.audiopkt_t.SS & 0x3;
+	ret_count += sprintf(buf+ret_count,
+		"Sampling Size:%s\n", sampling_size[ss_index]);
+
+	return ret_count;
+}
+
+/* /sys/class/video4linux/video250/hdmirx_bufcnt */
+static DEVICE_ATTR(hdmirx_bufcnt, 0444, show_hdmirx_bufcnt, NULL);
+/* /sys/class/video4linux/video250/hdmirx_video_info */
+static DEVICE_ATTR(hdmirx_video_info, 0444, show_hdmirx_video_info, NULL);
+/* /sys/class/video4linux/video250/hdmirx_audio_info */
+static DEVICE_ATTR(hdmirx_audio_info, 0444, show_hdmirx_audio_info, NULL);
+
+int register_video_device(struct v4l2_hdmi_dev *hdmi_dev)
+{
+	int ret;
+	struct video_device *video_dev;
+
+	HDMIRX_INFO("[%s]", __func__);
+
+	video_dev = &hdmi_dev->vdev;
+	*video_dev = hdmi_template;
+	video_dev->v4l2_dev = &hdmi_dev->v4l2_dev;
+	video_dev->queue = &hdmi_dev->vb_hdmidq;
+
+	dma_set_coherent_mask(&video_dev->dev, DMA_BIT_MASK(32));
+	/*
+	 * Provide a mutex to v4l2 core. It will be used to protect
+	 * all fops and v4l2 ioctls.
+	 */
+	video_dev->lock = &hdmi_dev->mutex;
+	video_set_drvdata(video_dev, hdmi_dev);
+	ret = video_register_device(video_dev, VFL_TYPE_GRABBER, 250);
+	if (ret < 0)
+		return ret;
+
+	ret = device_create_file(&video_dev->dev, &dev_attr_hdmirx_bufcnt);
+	if (ret < 0)
+		goto unreg_vdev;
+	ret = device_create_file(&video_dev->dev, &dev_attr_hdmirx_video_info);
+	if (ret < 0)
+		goto unreg_vdev;
+	ret = device_create_file(&video_dev->dev, &dev_attr_hdmirx_audio_info);
+	if (ret < 0)
+		goto unreg_vdev;
+
+	return 0;
+
+unreg_vdev:
+	video_unregister_device(video_dev);
+	return ret;
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_video_dev.h b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_video_dev.h
new file mode 100644
index 00000000..9a07dfc
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_video_dev.h
@@ -0,0 +1,78 @@
+/*
+ * hdmirx_video_dev.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDMIRX_VIDEO_DEV_H_
+#define _HDMIRX_VIDEO_DEV_H_
+
+
+#include "v4l2_hdmi_dev.h"
+
+long v4l2_hdmi_ioctl(struct file *file, unsigned int cmd, unsigned long arg);
+long compat_v4l2_hdmi_ioctl(struct file *file, unsigned int cmd, unsigned long arg);
+int v4l2_mipi_top_open(struct file *filp);
+
+struct compat_v4l2_plane {
+	__u32			bytesused;
+	__u32			length;
+	union {
+		__u32		mem_offset;
+		__u32		userptr;
+		__s32		fd;
+	} m;
+	__u32			data_offset;
+	__u32			reserved[11];
+};
+
+struct compat_v4l2_buffer {
+	__u32			index;
+	__u32			type;
+	__u32			bytesused;
+	__u32			flags;
+	__u32			field;
+	struct timeval		timestamp;
+	struct v4l2_timecode	timecode;
+	__u32			sequence;
+
+	/* memory location */
+	__u32			memory;
+	union {
+		__u32           offset;
+		__u32			userptr;
+		struct compat_v4l2_plane *planes;
+		__s32		fd;
+	} compat_m;
+	__u32			length;
+	__u32			reserved2;
+	__u32			reserved;
+};
+
+static const struct v4l2_file_operations hdmi_fops = {
+	.owner			= THIS_MODULE,
+	.open			= v4l2_mipi_top_open,
+	.release		= vb2_fop_release,
+	.read			= vb2_fop_read,
+	.poll			= vb2_fop_poll,
+	.unlocked_ioctl = v4l2_hdmi_ioctl, /* V4L2 ioctl handler */
+#ifdef CONFIG_64BIT
+	.compat_ioctl32	= compat_v4l2_hdmi_ioctl,
+#endif /* end of CONFIG_64BIT */
+	.mmap			= vb2_fop_mmap,
+};
+
+static const struct video_device hdmi_template = {
+	.name		= "v4l2_mipi_top",
+	.fops		= &hdmi_fops,
+	.release	= video_device_release_empty,
+};
+
+int register_video_device(struct v4l2_hdmi_dev *hdmi_dev);
+
+#endif/* _HDMIRX_VIDEO_DEV_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_wrapper.c b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_wrapper.c
new file mode 100644
index 00000000..8c1a0d7
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_wrapper.c
@@ -0,0 +1,468 @@
+/*
+ * hdmirx_wrapper.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/printk.h>
+#include <linux/ratelimit.h>
+#include <linux/workqueue.h>
+
+#include "hdmirx_wrapper.h"
+#include "v4l2_hdmi_dev.h"
+#include "hdmirx_reg.h"
+#include "mipi_wrapper.h"
+
+#include "rx_drv/hdmiInternal.h"
+
+/*=================== extern Variable/Function ===================*/
+extern MIPI_TOP_INFO mipi_top;
+
+#if HDMI_REPEATER_SUPPORT
+extern void Set_Hdmitx_PLL(void);
+#endif
+/*======================================================*/
+
+static void rxdetect_work_fun(struct work_struct *work);
+static DECLARE_DELAYED_WORK(rxdetect_work, rxdetect_work_fun);
+
+static void rxdetect_work_fun(struct work_struct *work)
+{
+	if (hdmirx_state.detect_done)
+		set_hdmirx_wrapper_interrupt_en(0, 0, 1);
+}
+
+const unsigned int resolution_format[17][2] = {
+	{ 640,  480},
+	{ 720,  480},
+	{1280,  720},
+	{1920, 1080},
+	{1920,  540},
+	{ 720,  240},
+	{1440,  480},
+	{ 720,  576},
+	{ 720,  288},
+	{1440,  576},
+	{ 720,  400},
+	{ 800,  600},
+	{1024,  768},
+	{1280,  960},
+	{1280, 1024},
+	{3840, 2160},/* For HDMI 1.x 4Kp24/25/30, PacketByte4 VIC=0 */
+	{4096, 2160},/* For HDMI 1.x */
+};
+const unsigned int format_number = sizeof(resolution_format)/sizeof(resolution_format[0]);
+
+const HDMI_VIC_TABLE_T hdmi_vic_table[] = {
+	/* {width, height, fps, interlace} */
+	{   0,    0,  60, 0 }, /* No such vic, set fps=60 for standard timings and DVI mode */
+	{ 640,  480,  60, 0 }, /* VIC: 1 */
+	{ 720,  480,  60, 0 }, /* VIC: 2 , 480p */
+	{ 720,  480,  60, 0 }, /* VIC: 3 */
+	{1280,  720,  60, 0 }, /* VIC: 4 , 720p60 */
+	{1920, 1080,  60, 1 }, /* VIC: 5, 1080i60 */
+	{ 720,  480,  60, 1 }, /* VIC: 6, NTSC */
+	{ 720,  480,  60, 1 }, /* VIC: 7, NTSC */
+	{ 720,  240,  60, 0 }, /* VIC: 8 */
+	{ 720,  240,  60, 0 }, /* VIC: 9 */
+	{2880,  480,  60, 1 }, /* VIC: 10 */
+	{2880,  480,  60, 1 }, /* VIC: 11 */
+	{2880,  240,  60, 0 }, /* VIC: 12 */
+	{2880,  240,  60, 0 }, /* VIC: 13 */
+	{1440,  480,  60, 0 }, /* VIC: 14 */
+	{1440,  480,  60, 0 }, /* VIC: 15 */
+	{1920, 1080,  60, 0 }, /* VIC: 16, 1080p60 */
+	{ 720,  576,  50, 0 }, /* VIC: 17, 576p */
+	{ 720,  576,  50, 0 }, /* VIC: 18 */
+	{1280,  720,  50, 0 }, /* VIC: 19, 720p50 */
+	{1920, 1080,  50, 1 }, /* VIC: 20, 1080i50 */
+	{ 720,  576,  50, 1 }, /* VIC: 21, PAL */
+	{ 720,  576,  50, 1 }, /* VIC: 22 */
+	{ 720,  288,  50, 0 }, /* VIC: 23 */
+	{ 720,  288,  50, 0 }, /* VIC: 24 */
+	{2880,  576,  50, 1 }, /* VIC: 25 */
+	{2880,  576,  50, 1 }, /* VIC: 26 */
+	{2880,  288,  50, 0 }, /* VIC: 27 */
+	{2880,  288,  50, 0 }, /* VIC: 28 */
+	{1440,  576,  50, 0 }, /* VIC: 29 */
+	{1440,  576,  50, 0 }, /* VIC: 30 */
+	{1920, 1080,  50, 0 }, /* VIC: 31, 1080p50 */
+	{1920, 1080,  24, 0 }, /* VIC: 32 */
+	{1920, 1080,  25, 0 }, /* VIC: 33 */
+	{1920, 1080,  30, 0 }, /* VIC: 34 */
+	{2880,  480,  60, 0 }, /* VIC: 35 */
+	{2880,  480,  60, 0 }, /* VIC: 36 */
+	{2880,  576,  50, 0 }, /* VIC: 37 */
+	{2880,  576,  50, 0 }, /* VIC: 38 */
+	{1920, 1080,  50, 1 }, /* VIC: 39 */
+	{1920, 1080, 100, 1 }, /* VIC: 40 */
+	{1280,  720, 100, 0 }, /* VIC: 41 */
+	{ 720,  576, 100, 0 }, /* VIC: 42 */
+	{ 720,  576, 100, 0 }, /* VIC: 43 */
+	{ 720,  576, 100, 1 }, /* VIC: 44 */
+	{ 720,  576, 100, 1 }, /* VIC: 45 */
+	{1920, 1080, 120, 1 }, /* VIC: 46 */
+	{1280,  720, 120, 0 }, /* VIC: 47 */
+	{ 720,  480, 120, 0 }, /* VIC: 48 */
+	{ 720,  480, 120, 0 }, /* VIC: 49 */
+	{ 720,  480, 120, 1 }, /* VIC: 50 */
+	{ 720,  480, 120, 1 }, /* VIC: 51 */
+	{ 720,  576, 200, 0 }, /* VIC: 52 */
+	{ 720,  576, 200, 0 }, /* VIC: 53 */
+	{ 720,  576, 200, 1 }, /* VIC: 54 */
+	{ 720,  576, 200, 1 }, /* VIC: 55 */
+	{ 720,  480, 240, 0 }, /* VIC: 56 */
+	{ 720,  480, 240, 0 }, /* VIC: 57 */
+	{ 720,  480, 240, 1 }, /* VIC: 58 */
+	{ 720,  480, 240, 1 }, /* VIC: 59 */
+	{1280,  720,  24, 0 }, /* VIC: 60 */
+	{1280,  720,  25, 0 }, /* VIC: 61 */
+	{1280,  720,  30, 0 }, /* VIC: 62 */
+	{1920, 1080, 120, 0 }, /* VIC: 63 */
+	{1920, 1080, 100, 0 }, /* VIC: 64 */
+	{1280,  720,  24, 0 }, /* VIC: 65 */
+	{1280,  720,  25, 0 }, /* VIC: 66 */
+	{1280,  720,  30, 0 }, /* VIC: 67 */
+	{1280,  720,  50, 0 }, /* VIC: 68 */
+	{1280,  720,  60, 0 }, /* VIC: 69 */
+	{1280,  720, 100, 0 }, /* VIC: 70 */
+	{1280,  720, 120, 0 }, /* VIC: 71 */
+	{1920, 1080,  24, 0 }, /* VIC: 72 */
+	{1920, 1080,  25, 0 }, /* VIC: 73 */
+	{1920, 1080,  30, 0 }, /* VIC: 74 */
+	{1920, 1080,  50, 0 }, /* VIC: 75 */
+	{1920, 1080,  60, 0 }, /* VIC: 76 */
+	{1920, 1080, 100, 0 }, /* VIC: 77 */
+	{1920, 1080, 120, 0 }, /* VIC: 78 */
+	{1680,  720,  24, 0 }, /* VIC: 79 */
+	{1680,  720,  25, 0 }, /* VIC: 80 */
+	{1680,  720,  30, 0 }, /* VIC: 81 */
+	{1680,  720,  50, 0 }, /* VIC: 82 */
+	{1680,  720,  60, 0 }, /* VIC: 83 */
+	{1680,  720, 100, 0 }, /* VIC: 84 */
+	{1680,  720, 120, 0 }, /* VIC: 85 */
+	{2560, 1080,  24, 0 }, /* VIC: 86 */
+	{2560, 1080,  25, 0 }, /* VIC: 87 */
+	{2560, 1080,  30, 0 }, /* VIC: 88 */
+	{2560, 1080,  50, 0 }, /* VIC: 89 */
+	{2560, 1080,  60, 0 }, /* VIC: 90 */
+	{2560, 1080, 100, 0 }, /* VIC: 91 */
+	{2560, 1080, 120, 0 }, /* VIC: 92 */
+	{3840, 2160,  24, 0 }, /* VIC: 93 */
+	{3840, 2160,  25, 0 }, /* VIC: 94 */
+	{3840, 2160,  30, 0 }, /* VIC: 95 */
+	{3840, 2160,  50, 0 }, /* VIC: 96 */
+	{3840, 2160,  60, 0 }, /* VIC: 97 */
+	{4096, 2160,  24, 0 }, /* VIC: 98 */
+	{4096, 2160,  25, 0 }, /* VIC: 99 */
+	{4096, 2160,  30, 0 }, /* VIC: 100 */
+	{4096, 2160,  50, 0 }, /* VIC: 101 */
+	{4096, 2160,  60, 0 }, /* VIC: 102 */
+	{3840, 2160,  24, 0 }, /* VIC: 103 */
+	{3840, 2160,  25, 0 }, /* VIC: 104 */
+	{3840, 2160,  30, 0 }, /* VIC: 105 */
+	{3840, 2160,  50, 0 }, /* VIC: 106 */
+	{3840, 2160,  60, 0 }, /* VIC: 107 */
+	{3840, 2160,  30, 0 }, /* (108)extened vic: 1 */
+	{3840, 2160,  25, 0 }, /* (109)extened vic: 2 */
+	{3840, 2160,  24, 0 }, /* (110)extened vic: 3 */
+	{4096, 2160,  24, 0 }, /* (111)extened vic: 4 */
+};
+
+
+unsigned char hdmirx_wrapper_convert_color_fmt(unsigned char color)
+{
+	unsigned char yuv_fmt;
+
+	switch (color) {
+	case COLOR_RGB:
+		yuv_fmt = 0;
+		break;
+	case COLOR_YUV422:
+		yuv_fmt = 2;
+		break;
+	case COLOR_YUV444:
+	case COLOR_YUV420:/* YUV420to444 */
+		yuv_fmt = 1;
+		break;
+	default:
+		yuv_fmt = 0;
+		HDMIRX_ERROR("[%s] Unsupported color(%u)", __func__, color);
+		break;
+	}
+
+	return yuv_fmt;
+}
+
+void set_hdmirx_wrapper_interrupt_en(int ver_err_en, int hor_err_en, int polarity_detect_en)
+{
+	unsigned int reg_val;
+
+	reg_val = hdmi_rx_reg_read32(HDMIRX_WRAPPER_INTERRUPT_EN, HDMI_RX_HDMI_WRAPPER);
+
+	if (ver_err_en >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en(ver_err_en);
+	}
+	if (hor_err_en >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en(hor_err_en);
+	}
+	if (polarity_detect_en >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en(polarity_detect_en);
+	}
+	hdmi_rx_reg_write32(HDMIRX_WRAPPER_INTERRUPT_EN, reg_val, HDMI_RX_HDMI_WRAPPER);
+}
+
+
+void set_hdmirx_wrapper_active_pixels(unsigned int v_pixel, unsigned int h_pixel)
+{
+	hdmi_rx_reg_write32(HDMIRX_WRAPPER_ACTIVE_PIXELS,
+		HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width(v_pixel) |
+		HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width(h_pixel), HDMI_RX_HDMI_WRAPPER);
+}
+
+
+void set_hdmirx_wrapper_hor_threshold(unsigned int h_threshold)
+{
+	hdmi_rx_reg_write32(HDMIRX_WRAPPER_HOR_THRESHOLD,
+		HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold(h_threshold), HDMI_RX_HDMI_WRAPPER);
+}
+
+
+void set_hdmirx_wrapper_control_0(int fifo_stage, int fw_dma_en,
+	int polarity_set_en, int polarity_set, int yuv_fmt, int hdmirx_en)
+{
+	unsigned int reg_val;
+
+	reg_val = hdmi_rx_reg_read32(HDMIRX_WRAPPER_CONTROL_0, HDMI_RX_HDMI_WRAPPER);
+
+	if (fifo_stage >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_CONTROL_0_fifo_stage_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_CONTROL_0_fifo_stage(fifo_stage);
+	}
+	if (fw_dma_en >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_CONTROL_0_fw_dma_en(fw_dma_en);
+	}
+	if (polarity_set_en >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_CONTROL_0_polarity_set_en(polarity_set_en);
+	}
+	if (polarity_set >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_CONTROL_0_polarity_set_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_CONTROL_0_polarity_set(polarity_set);
+	}
+	if (yuv_fmt >= 0) {
+		reg_val = reg_val & (~HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_mask);
+		reg_val = reg_val | HDMIRX_WRAPPER_CONTROL_0_yuv_fmt(yuv_fmt);
+	}
+	if (hdmirx_en >= 0) {
+		reg_val = reg_val &
+			(~(HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx_mask |
+			HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_mask));
+
+		reg_val = reg_val |
+			HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx(hdmirx_en) |
+			HDMIRX_WRAPPER_CONTROL_0_hdmirx_en(hdmirx_en);
+	}
+	hdmi_rx_reg_write32(HDMIRX_WRAPPER_CONTROL_0, reg_val, HDMI_RX_HDMI_WRAPPER);
+
+}
+
+unsigned int hdmirx_wrapper_get_active_line(void)
+{
+	unsigned int buf0;
+
+	buf0 = HDMIRX_WRAPPER_MONITOR_1_get_line_buf0(hdmi_rx_reg_read32(HDMIRX_WRAPPER_MONITOR_1, HDMI_RX_HDMI_WRAPPER));
+	return buf0;
+}
+
+unsigned int hdmirx_wrapper_get_active_pixel(void)
+{
+	unsigned int reg01;
+	unsigned int buf0;
+
+	reg01 = hdmi_rx_reg_read32(HDMIRX_WRAPPER_DEN_BUF01, HDMI_RX_HDMI_WRAPPER);
+	buf0 = HDMIRX_WRAPPER_DEN_BUF01_get_den_buf0(reg01);
+	return buf0;
+}
+
+static inline unsigned int check_hdmirx_resolution_match(void)
+{
+	unsigned int active_pixel, active_line, height;
+	unsigned int i, vic;
+	unsigned char color_fmt;
+
+	vic = 0;
+	if (lib_hdmi_is_hdmi_mode())
+		vic = lib_hdmi_get_vic();
+
+	active_pixel =	hdmirx_wrapper_get_active_pixel();
+	active_line = hdmirx_wrapper_get_active_line();
+	color_fmt = hdmirx_wrapper_convert_color_fmt(GET_H_COLOR_SPACE());
+
+	if (hdmi_rx.timing_t.is_interlace)
+		height = active_line*2;
+	else
+		height = active_line;
+
+	if ((active_pixel == hdmi_vic_table[vic].width) &&
+		(height == hdmi_vic_table[vic].height) && vic) {
+
+		mipi_top.h_input_len = active_pixel;
+		mipi_top.v_input_len = active_line;
+		mipi_top.input_color = color_fmt;
+
+		HDMIRX_INFO("Check resolution match => Width(%u) Height(%u) VIC(%u)",
+			active_pixel, height, vic);
+		return 1;
+	} else if (vic == 0) {
+		/* Support standard timings and DVI mode */
+		for (i = 0; i < format_number; i++) {
+			if ((active_pixel == resolution_format[i][0]) &&
+				(active_line == resolution_format[i][1])) {
+
+				mipi_top.h_input_len = active_pixel;
+				mipi_top.v_input_len = active_line;
+				mipi_top.input_color = color_fmt;
+
+				HDMIRX_INFO("Check resolution match => Width(%u) Height(%u) DIV",
+					active_pixel, height);
+				return 1;
+			}
+		}
+	}
+
+	HDMIRX_INFO("Check resolution not match => active_pixel(%u) active_line(%u) VIC(%u)",
+		active_pixel, active_line, vic);
+
+	return 0;
+}
+
+void restartHdmiRxWrapperDetection(void)
+{
+	unsigned char hdcp_state;
+
+	stop_mipi_process();
+	set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+	SET_H_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+	SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+	rxphy_init_struct();/* Reset phy state */
+	set_hdmirx_wrapper_control_0(-1, 0, -1, -1, -1, -1);/* Stop DMA */
+	set_hdmirx_wrapper_hor_threshold(HDMI_MIN_SUPPORT_H_PIXEL);
+
+	hdcp_state = hdmirx_state.hdcp_state;
+	memset(&hdmirx_state, 0, sizeof(hdmirx_state));
+	memset(&hdmi_rx.timing_t, 0, sizeof(hdmi_rx.timing_t));
+	/* Keep hdcp state, clear when cable unplugged */
+	hdmirx_state.hdcp_state = hdcp_state;
+}
+
+static const char * const str_color[] = {"RGB", "YUV444", "YUV422"};
+static const char * const str_interlace[] = {"Prog", "Int"};
+void hdmirx_wrapper_isr(void)
+{
+	static unsigned char miss_count = 0;
+	unsigned int status;
+	unsigned int active_pixel, active_line;
+
+	status = hdmi_rx_reg_read32(HDMIRX_WRAPPER_INTERRUPT_STATUS, HDMI_RX_HDMI_WRAPPER);
+
+	if (unlikely(status == 0)) {
+		/* HDMIRX_INFO("do nothing..."); */
+		return;
+	} else if (HDMIRX_WRAPPER_INTERRUPT_STATUS_get_polarity_detect_sts(status)) {
+		/* POLARITY_DETECT, Disable interrupt */
+		set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+
+		if (!check_hdmirx_resolution_match()) {
+			/* Format not match, re-enable polarity detection if miss_count<3 */
+			if (miss_count >= 3) {
+				miss_count = 0;
+				HDMIRX_INFO("Polarity detect fail: Reset detection...\n");
+				restartHdmiRxWrapperDetection();
+			} else {
+				miss_count++;
+				/* Enable wrapper interrupt later */
+				schedule_delayed_work(&rxdetect_work, msecs_to_jiffies(1000));
+			}
+			return;
+		}
+
+		HDMIRX_INFO("Polarity detect done: hor(%u) ver(%u) color(%s) I/P(%s)",
+			mipi_top.h_input_len, mipi_top.v_input_len,
+			str_color[mipi_top.input_color],
+			str_interlace[hdmi_rx.timing_t.is_interlace]);
+
+		set_hdmirx_wrapper_active_pixels(mipi_top.v_input_len, mipi_top.h_input_len);
+		set_hdmirx_wrapper_hor_threshold(mipi_top.h_input_len);
+
+		hdmirx_state.measure_ready = 1;
+
+#if HDMI_REPEATER_SUPPORT
+		Set_Hdmitx_PLL();
+#endif
+		/* Format match, enable error detection */
+		set_hdmirx_wrapper_interrupt_en(1, 1, 0);
+	} else if (HDMIRX_WRAPPER_INTERRUPT_STATUS_get_hor_err_sts(status)) {
+		/* HOR_ERR */
+		set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+
+		active_pixel =	hdmirx_wrapper_get_active_pixel();
+#if 0
+		if (mipi_top.h_input_len-active_pixel <= 5) {
+			set_hdmirx_wrapper_interrupt_en(1, 1, 0);
+			return;
+		} else if ((mipi_top.h_input_len == 1920) && (active_pixel == 1921)) {
+			set_hdmirx_wrapper_interrupt_en(1, 1, 0);
+			return;
+		}
+#endif
+		HDMIRX_INFO("ISR status:%x reenable polarity detection... pixel(%u)\n",
+			status, active_pixel);
+
+		miss_count = 0;
+		restartHdmiRxWrapperDetection();
+		return;
+	} else if (HDMIRX_WRAPPER_INTERRUPT_STATUS_get_ver_err_sts(status)) {
+		/* VER_ERR */
+		set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+
+		active_line = hdmirx_wrapper_get_active_line();
+#if 0
+		if (mipi_top.v_input_len-active_line <= 5) {
+			set_hdmirx_wrapper_interrupt_en(1, 1, 0);
+			return;
+		} else if ((mipi_top.v_input_len == 1080) && (active_line == 1081)) {
+			set_hdmirx_wrapper_interrupt_en(1, 1, 0);
+			return;
+		}
+#endif
+		HDMIRX_INFO("ISR status:%x reenable polarity detection... line(%u)\n",
+			status, active_line);
+
+		miss_count = 0;
+		restartHdmiRxWrapperDetection();
+		return;
+	}
+}
+
+
+void hdmi_related_wrapper_init(void)
+{
+	/* HDMIRX_INFO("[%s]",  __func__); */
+
+	/* v,h,polarity */
+	set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+	/* fifo_stage,fw_dma_en,polarity_set_en,polarity_set,yuv_fmt,hdmirx_en */
+	set_hdmirx_wrapper_control_0(1, 0, 0, 0, 0, 1);
+	set_hdmirx_wrapper_hor_threshold(HDMI_MIN_SUPPORT_H_PIXEL);
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_wrapper.h b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_wrapper.h
new file mode 100644
index 00000000..8324651
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/hdmirx_wrapper.h
@@ -0,0 +1,37 @@
+/*
+ * hdmirx_wrapper.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDMIRX_WRAPPER_H__
+#define __HDMIRX_WRAPPER_H__
+
+#define HDMI_MIN_SUPPORT_H_PIXEL    0x40
+
+typedef struct  {
+	unsigned int width;
+	unsigned int height;
+	unsigned int fps;
+	unsigned int interlace;
+} HDMI_VIC_TABLE_T;
+
+extern const HDMI_VIC_TABLE_T hdmi_vic_table[];
+
+unsigned char hdmirx_wrapper_convert_color_fmt(unsigned char color);
+void set_hdmirx_wrapper_interrupt_en(int ver_err_en, int hor_err_en, int polarity_detect_en);
+void set_hdmirx_wrapper_active_pixels(unsigned int v_pixel, unsigned int h_pixel);
+void set_hdmirx_wrapper_hor_threshold(unsigned int h_threshold);
+unsigned int hdmirx_wrapper_get_active_line(void);
+unsigned int hdmirx_wrapper_get_active_pixel(void);
+void set_hdmirx_wrapper_control_0(int fifo_stage, int fw_dma_en,
+	int polarity_set_en, int polarity_set, int yuv_fmt, int hdmirx_en);
+void restartHdmiRxWrapperDetection(void);
+void hdmirx_wrapper_isr(void);
+void hdmi_related_wrapper_init(void);
+#endif/* __HDMIRX_WRAPPER_H__ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/mipi_wrapper.c b/drivers/media/platform/rtk_hdmirx/rtd161x/mipi_wrapper.c
new file mode 100644
index 00000000..be66154
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/mipi_wrapper.c
@@ -0,0 +1,626 @@
+/*
+ * mipi_wrapper.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "v4l2_hdmi_dev.h"
+#include "mipi_wrapper.h"
+#include "hdmirx_reg.h"
+#include "hdmirx_clk_ctrl.h"
+
+#include "rx_drv/hdmiInternal.h"
+
+MIPI_TOP_INFO mipi_top;
+unsigned int drop_count = 0;
+/*=================== extern Variable/Function ===================*/
+extern int hdmi_stream_on;
+
+extern void hdmirx_wrapper_isr(void);
+extern void set_hdmirx_wrapper_control_0(int fifo_stage, int fw_dma_en,
+	int polarity_set_en, int polarity_set, int yuv_fmt, int hdmirx_en);
+extern void restartHdmiRxWrapperDetection(void);
+#ifdef CONFIG_RTK_HDCPRX_2P2
+extern void  Hdmi_HDCP_2_2_msg_hander(void);
+#endif
+extern void start_hdcp1x_repeater_work(void);
+/*======================================================*/
+
+extern struct ion_device *rtk_phoenix_ion_device;
+
+void register_mipi_ion(struct v4l2_hdmi_dev *dev)
+{
+	struct mipi_ion_buf *ion_buf;
+	unsigned long size;
+	size_t len;
+	int ret_val;
+
+	size = dev->width * dev->height * dev->bpp/8;
+	/* Increase 1/8 size for prevent MIPI write out of range */
+	size = roundup(size*9/8, 4096);
+
+	ion_buf = &dev->ion_buf;
+	ion_buf->client = ion_client_create(rtk_phoenix_ion_device, "hdmirx");
+
+	ion_buf->handle = ion_alloc(ion_buf->client, size, 4096,
+		RTK_PHOENIX_ION_HEAP_MEDIA_MASK,
+		ION_FLAG_NONCACHED | ION_FLAG_HWIPACC);
+
+	if (IS_ERR(ion_buf->handle))
+		HDMIRX_ERROR("%s ion_alloc fail", __func__);
+
+	ret_val = ion_phys(ion_buf->client, ion_buf->handle, &ion_buf->phys_addr, &len);
+	if (ret_val != 0)
+		HDMIRX_ERROR("%s ion_phys fail", __func__);
+
+	HDMIRX_INFO(" ion_addr=0x%08lx size=%zd", ion_buf->phys_addr, len);
+}
+
+void deregister_mipi_ion(struct v4l2_hdmi_dev *dev)
+{
+	struct mipi_ion_buf *ion_buf;
+
+	ion_buf = &dev->ion_buf;
+
+	if (ion_buf->client != NULL) {
+		HDMIRX_INFO("%s", __func__);
+		ion_free(ion_buf->client, ion_buf->handle);
+		ion_buf->client = NULL;
+	}
+}
+
+void mipi_reset_work_func(struct work_struct *work)
+{
+	hdmirx_reset_control(RST_MIPI, CTL_DISABLE);
+	hdmirx_reset_control(RST_MIPI, CTL_ENABLE);
+}
+
+void stop_mipi_process(void)
+{
+	set_enable_mipi(0);
+	/* Stop DMA */
+	set_hdmirx_wrapper_control_0(-1, 0, -1, -1, -1, -1);
+	/* Reset mipi clock */
+	schedule_work(&mipi_top.mipi_reset_work);
+
+	hdmi_stream_on = 0;
+	mipi_top.mipi_init = 0;
+}
+
+unsigned int rx_pitch_measurement(unsigned int output_h, MIPI_OUT_COLOR_SPACE_T output_color)
+{
+	unsigned int pitch;
+
+	HDMIRX_INFO("rx_pitch_measurement,output_color=%x\n", output_color);
+
+	switch (output_color) {
+	case OUT_8BIT_YUV422:
+	case OUT_8BIT_YUV420:
+		pitch = output_h;
+		break;
+	case OUT_10BIT_YUV422:
+	case OUT_10BIT_YUV420:
+		/* YUV_10BIT_4BYTE_3PIXEL, Four bytes-three pixels */
+		pitch = ((roundup16(output_h) + 11)/12)*16;
+		break;
+	default: /* all other RGB case */
+		pitch = output_h * 4;
+		break;
+	}
+
+	/* pitch has to be n*16 byte */
+	if (output_color < OUT_ARGB)
+		pitch = roundup16(pitch);
+
+	return pitch;
+}
+
+void set_video_DDR_start_addr(struct v4l2_hdmi_dev *dev)
+{
+	unsigned int addry;
+	unsigned int addruv;
+	unsigned int offset;
+	unsigned long flags = 0;
+	struct hdmi_dmaqueue *hdmidq;
+	struct mipi_ion_buf *ion_buf;
+
+	hdmidq = &dev->hdmidq;
+	ion_buf = &dev->ion_buf;
+
+	offset = roundup16(mipi_top.pitch) * roundup16(mipi_top.v_output_len);
+
+	spin_lock_irqsave(&dev->slock, flags);
+	hdmidq->skip_frame[0] = 1;
+	hdmidq->skip_frame[1] = 1;
+
+	addry = ion_buf->phys_addr;
+	addruv = ion_buf->phys_addr + offset;
+	set_video_dest_addr(addry, addruv, addry, addruv);
+	spin_unlock_irqrestore(&dev->slock, flags);
+
+	HDMIRX_INFO("[%s] addr1y(0x%08x) addr1uv(0x%08x) addr2y(0x%08x) addr2uv(0x%08x)",
+		__func__, addry, addruv, addry, addruv);
+}
+
+void set_mipi_type(unsigned int type)
+{
+	unsigned int reg_val;
+
+	HDMIRX_DEBUG("[%s] type(%u)", __func__, type);
+
+	reg_val = hdmi_rx_reg_read32(MIPI_TYPE, HDMI_RX_MIPI);
+
+	reg_val = reg_val & (~MIPI_TYPE_mipi_type_mask);
+
+	hdmi_rx_reg_write32(MIPI_TYPE, reg_val | MIPI_TYPE_mipi_type(type), HDMI_RX_MIPI);
+}
+
+void set_pic_dest_addr(int addry, int addruv)
+{
+	if (addry >= 0)
+		hdmi_rx_reg_write32(MIPI_SA2, addry, HDMI_RX_MIPI);
+
+
+	if (addruv >= 0)
+		hdmi_rx_reg_write32(MIPI_SA2_UV, addruv, HDMI_RX_MIPI);
+
+}
+
+void set_pic_dest_size(unsigned int dst_width, unsigned int pitch)
+{
+
+	hdmi_rx_reg_write32(MIPI_SIZE1,
+		MIPI_SIZE1_dst_width_pic(dst_width) | MIPI_SIZE1_pitch_pic(pitch), HDMI_RX_MIPI);
+}
+
+void set_video_dest_addr(int addr1y, int addr1uv, int addr2y, int addr2uv)
+{
+	if (addr1y >= 0)
+		hdmi_rx_reg_write32(MIPI_SA0, addr1y, HDMI_RX_MIPI);
+
+	if (addr1uv >= 0)
+		hdmi_rx_reg_write32(MIPI_SA0_UV, addr1uv, HDMI_RX_MIPI);
+
+	if (addr2y >= 0)
+		hdmi_rx_reg_write32(MIPI_SA1, addr2y, HDMI_RX_MIPI);
+
+	if (addr2uv >= 0)
+		hdmi_rx_reg_write32(MIPI_SA1_UV, addr2uv, HDMI_RX_MIPI);
+}
+
+void set_video_dest_size(unsigned int dst_width, unsigned int pitch)
+{
+
+	hdmi_rx_reg_write32(MIPI_SIZE0,
+		MIPI_SIZE0_dst_width_video(dst_width) | MIPI_SIZE0_pitch_video(pitch), HDMI_RX_MIPI);
+}
+
+void set_video_src_size(unsigned int src_width)
+{
+	unsigned int reg_val;
+
+	reg_val = hdmi_rx_reg_read32(MIPI_SIZE2, HDMI_RX_MIPI);
+	reg_val = reg_val & (~MIPI_SIZE2_src_width_video_mask);
+	hdmi_rx_reg_write32(MIPI_SIZE2, reg_val | MIPI_SIZE2_src_width_video(src_width), HDMI_RX_MIPI);
+}
+
+void set_init_mipi_value(MIPI_REG *mipi_reg)
+{
+	unsigned int reg_val = 0;
+
+	reg_val = (mipi_reg->dst_fmt << 27) |
+			(mipi_reg->src_fmt << 25) |
+			(mipi_reg->src_sel << 24) |
+			(mipi_reg->yuv420_uv_seq << 23) |
+			(mipi_reg->vs << 22) |
+			(mipi_reg->vs_near << 21) |
+			(mipi_reg->vs_yodd << 20) |
+			(mipi_reg->vs_codd << 19) |
+			(mipi_reg->hs << 18) |
+			(mipi_reg->hs_yodd << 17) |
+			(mipi_reg->hs_codd << 16) |
+			(mipi_reg->yuv420_fmt << 15) |
+			(mipi_reg->ccs_data_format << 13) |
+			(mipi_reg->yuv_to_rgb << 12) |
+			(mipi_reg->chroma_ds_mode << 11) |
+			(mipi_reg->chroma_ds_en << 10) |
+			(mipi_reg->chroma_us_mode << 9) |
+			(mipi_reg->chroma_us_en << 8) |
+			(mipi_reg->hdmirx_interlace_en << 7) |
+			(mipi_reg->hdmirx_interlace_polarity << 6) |
+			(mipi_reg->int_en4 << 5) |
+			(mipi_reg->int_en3 << 4) |
+			(mipi_reg->int_en2 << 3) |
+			(mipi_reg->int_en1 << 2) |
+			(mipi_reg->int_en0 << 1) |
+			(mipi_reg->en);
+
+	hdmi_rx_reg_write32(MIPI, reg_val, HDMI_RX_MIPI);
+	HDMIRX_INFO("Set MIPI=0x%08x", reg_val);
+	HDMIRX_INFO("Read MIPI=0x%08x", hdmi_rx_reg_read32(MIPI, HDMI_RX_MIPI));
+}
+
+void set_enable_mipi(unsigned char enable)
+{
+	unsigned int reg_val;
+
+	hdmi_rx_reg_mask32(MIPI,
+		~(MIPI_int_en0_mask | MIPI_int_en1_mask | MIPI_int_en2_mask |
+		MIPI_int_en3_mask | MIPI_int_en4_mask | MIPI_en_mask),
+		MIPI_int_en0(enable) | MIPI_int_en1(enable) | MIPI_int_en2(enable) |
+		MIPI_int_en3(enable) | MIPI_int_en4(enable) | MIPI_en(enable),
+		HDMI_RX_MIPI);
+
+	if (enable == 0) {
+		reg_val = hdmi_rx_reg_read32(MIPI_INT_ST, HDMI_RX_MIPI);
+		hdmi_rx_reg_write32(MIPI_INT_ST, reg_val, HDMI_RX_MIPI);
+	}
+}
+
+void set_hs_scaler(unsigned int hsi_offset, unsigned int hsi_phase, unsigned int hsd_out, unsigned int hsd_delta)
+{
+	hdmi_rx_reg_write32(SCALER_HSI,
+		SCALER_HSI_hsi_offset(hsi_offset) |
+		SCALER_HSI_hsi_phase(hsi_phase), HDMI_RX_MIPI);
+
+	hdmi_rx_reg_write32(SCALER_HSD,
+		SCALER_HSD_hsd_out(hsd_out) |
+		SCALER_HSD_hsd_delta(hsd_delta), HDMI_RX_MIPI);
+
+	HDMIRX_INFO("hsd_out=%u,hsd_delta=0x%x", hsd_out, hsd_delta);
+}
+
+void set_hs_coeff(void)
+{
+	unsigned int reg_val;
+
+	/* for Y */
+	reg_val = (0x400<<16) | 0x400;
+	hdmi_rx_reg_write32(SCALER_HSYNC0, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC1, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC2, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC3, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC4, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC5, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC6, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSYNC7, reg_val, HDMI_RX_MIPI);
+
+	/* for U,V */
+	hdmi_rx_reg_write32(SCALER_HSCC0, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC1, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC2, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC3, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC4, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC5, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC6, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_HSCC7, reg_val, HDMI_RX_MIPI);
+}
+
+void set_vs_scaler(unsigned int vsi_offset, unsigned int vsi_phase, unsigned int vsd_out, unsigned int vsd_delta)
+{
+	hdmi_rx_reg_write32(SCALER_VSI,
+		SCALER_VSI_vsi_offset(vsi_offset) |
+		SCALER_VSI_vsi_phase(vsi_phase), HDMI_RX_MIPI);
+
+	hdmi_rx_reg_write32(SCALER_VSD,
+		SCALER_VSD_vsd_out(vsd_out) |
+		SCALER_VSD_vsd_delta(vsd_delta), HDMI_RX_MIPI);
+
+	HDMIRX_INFO("vsd_out=%u,vsd_delta=0x%x\n", vsd_out, vsd_delta);
+}
+
+void set_vs_coeff(void)
+{
+	unsigned int reg_val;
+
+	reg_val = (0x800<<16) | 0x800;
+	hdmi_rx_reg_write32(SCALER_VSYC0, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSCC0, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSYC1, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSCC1, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSYC2, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSCC2, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSYC3, reg_val, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(SCALER_VSCC3, reg_val, HDMI_RX_MIPI);
+}
+
+void set_alpha(unsigned int alpha)
+{
+
+	hdmi_rx_reg_write32(CONSTANT_ALPHA, CONSTANT_ALPHA_alpha(alpha), HDMI_RX_MIPI);
+}
+
+void set_YUV2RGB_coeff(void)
+{
+	hdmi_rx_reg_write32(CS_TRANS0,  0x04a80, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS1,  0x00000, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS2,  0x072c0, HDMI_RX_MIPI);
+
+	hdmi_rx_reg_write32(CS_TRANS3,  0x04a80, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS4,  0x1f260, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS5,  0x1ddd0, HDMI_RX_MIPI);
+
+	hdmi_rx_reg_write32(CS_TRANS6,  0x04a80, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS7,  0x08760, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS8,  0x00000, HDMI_RX_MIPI);
+
+	hdmi_rx_reg_write32(CS_TRANS9,  0x0fc20, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS10, 0x00134, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS11, 0x0fb7c, HDMI_RX_MIPI);
+}
+
+void set_RGB2YUV_coeff(void)
+{
+	/* C1~C3 */
+	hdmi_rx_reg_write32(CS_TRANS0,	0x00BB8, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS1,	0x02748, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS2,	0x003F8, HDMI_RX_MIPI);
+	/* C4~C6 */
+	hdmi_rx_reg_write32(CS_TRANS3,	0x1F988, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS4,	0x1EA60, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS5,	0x01C18, HDMI_RX_MIPI);
+	/* C7~C9 */
+	hdmi_rx_reg_write32(CS_TRANS6,	0x01C18, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS7,	0x1E6E9, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS8,	0x1FD7B, HDMI_RX_MIPI);
+	/* K1~K3 */
+	hdmi_rx_reg_write32(CS_TRANS9,	0x00100, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS10, 0x00800, HDMI_RX_MIPI);
+	hdmi_rx_reg_write32(CS_TRANS11, 0x00800, HDMI_RX_MIPI);
+}
+
+void mipi_scale_down(unsigned int src_width, unsigned int src_height,
+	unsigned int dst_width, unsigned int dst_height)
+{
+	unsigned int delta_num, delta_den, offset, phase;
+
+	if (src_width >= dst_width) {
+		/* set hs_scaler */
+		offset = 0;
+		phase = 0;
+		delta_num = (src_width / dst_width) << 14;
+		delta_den = ((src_width % dst_width)*0x4000) / dst_width;
+		/* set_hs_scaler: offset,phase,out,delta */
+		set_hs_scaler(offset, phase, dst_width, (delta_num | delta_den));
+		set_hs_coeff();
+	}
+
+	if (src_height >= dst_height) {
+		/* set vs_scaler */
+		offset = 0;
+		phase = 0;
+		delta_num = (src_height / dst_height) << 14;
+		delta_den = ((src_height % dst_height)*0x4000) / dst_height;
+		/* set_vs_scaler: offset,phase,out,delta */
+		set_vs_scaler(offset, phase, dst_height, (delta_num | delta_den));
+		set_vs_coeff();
+	}
+}
+
+void setup_mipi(void)
+{
+	MIPI_REG mipi_reg;
+	unsigned int v_input, h_input;
+
+	HDMIRX_INFO("[%s]", __func__);
+
+	set_mipi_type(0);/* 0:video, 1:pic */
+
+	memset(&mipi_reg, 0, sizeof(MIPI_REG));
+
+	mipi_reg.dst_fmt = mipi_top.output_color;
+	mipi_reg.src_fmt = mipi_top.input_color;
+	mipi_reg.src_sel = mipi_top.src_sel;
+	mipi_reg.yuv420_uv_seq = mipi_top.uv_seq;
+
+	if (hdmi_rx.timing_t.is_interlace)/* Interlace */
+		v_input = mipi_top.v_input_len*2;
+	else
+		v_input = mipi_top.v_input_len;
+
+	h_input = mipi_top.h_input_len;
+
+	if (v_input > mipi_top.v_output_len)
+		mipi_reg.vs = 1;
+
+	if (h_input > mipi_top.h_output_len)
+		mipi_reg.hs = 1;
+
+	if ((mipi_reg.dst_fmt == OUT_10BIT_YUV422) ||
+		(mipi_reg.dst_fmt == OUT_10BIT_YUV420))
+		mipi_reg.yuv420_fmt = YUV_10BIT_4BYTE_3PIXEL;
+
+	/* mipi_reg.ccs_data_format */
+
+	if ((mipi_top.input_color != IN_RGB888) &&
+		(mipi_top.output_color >= OUT_ARGB)) {
+		/* YUV -> RGB */
+		mipi_reg.yuv_to_rgb = 1;
+		set_alpha(0xff);
+		set_YUV2RGB_coeff();
+	} else if ((mipi_top.input_color == IN_RGB888) &&
+		(mipi_top.output_color <= OUT_10BIT_YUV420)) {
+		/* RGB -> YUV */
+		mipi_reg.chroma_ds_mode = 1;/* 0:drop 1:avg */
+		mipi_reg.chroma_ds_en = 1;
+		mipi_reg.yuv_to_rgb = 1;
+		set_RGB2YUV_coeff();
+	}
+
+	if ((mipi_top.input_color == IN_YUV444) &&
+		(mipi_top.output_color <= OUT_10BIT_YUV420)) {
+		mipi_reg.chroma_ds_mode = 1;/* 0:drop 1:avg */
+		mipi_reg.chroma_ds_en = 1;
+	}
+
+	if ((mipi_top.input_color == IN_YUV422) && (mipi_reg.vs || mipi_reg.hs)) {
+		mipi_reg.chroma_us_mode = 0;/* 0:repeat 1:avg */
+		mipi_reg.chroma_us_en = 1;
+		if (mipi_top.output_color <= OUT_10BIT_YUV420) {
+			mipi_reg.chroma_ds_mode = 1;/* 0:drop 1:avg */
+			mipi_reg.chroma_ds_en = 1;
+		}
+	}
+
+	mipi_reg.hdmirx_interlace_en = (hdmi_rx.timing_t.is_interlace);
+	/* Set polarity: 0 - Button field first, 1 - Top field first */
+	mipi_reg.hdmirx_interlace_polarity = 1;
+
+	mipi_reg.int_en4 = 1;
+	mipi_reg.int_en3 = 1;
+	mipi_reg.int_en2 = 1;
+	mipi_reg.int_en1 = 1;
+	mipi_reg.int_en0 = 1;
+
+	mipi_reg.en = 1;
+
+	set_video_dest_size(mipi_top.h_output_len, mipi_top.pitch);
+	set_video_src_size(mipi_top.h_input_len);
+
+	mipi_scale_down(h_input, v_input,
+		mipi_top.h_output_len, mipi_top.v_output_len);
+
+	set_init_mipi_value(&mipi_reg);
+	set_hdmirx_wrapper_control_0(-1, 1, mipi_reg.hdmirx_interlace_en, mipi_reg.hdmirx_interlace_polarity, -1, -1);
+
+	hdmi_rx_reg_write32(MIPI_URGENT, 0x10, HDMI_RX_MIPI);
+	mipi_top.mipi_init = 1;
+}
+
+void update_mipi_hw_buffer(int src_index, struct v4l2_hdmi_dev *dev, int buffer_empty)
+{
+	unsigned long flags;
+	unsigned int addry;
+	unsigned int addruv;
+	unsigned int offset;
+	struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;
+
+	offset = roundup16(mipi_top.pitch) * roundup16(mipi_top.v_output_len);
+
+	spin_lock_irqsave(&dev->slock, flags);
+
+	if (hdmidq->skip_frame[src_index] == 0) {
+		vb2_buffer_done(&hdmidq->hwbuf[src_index]->vb, VB2_BUF_STATE_DONE);
+		atomic_inc(&hdmidq->rcnt);
+	}
+
+	if (buffer_empty == 0) {
+		hdmidq->hwbuf[src_index] = list_entry(hdmidq->active.next, struct hdmi_buffer, list);
+		list_del(&hdmidq->hwbuf[src_index]->list);
+		atomic_dec(&hdmidq->qcnt);
+		hdmidq->skip_frame[src_index] = 0;
+
+		addry = hdmidq->hwbuf[src_index]->phys;
+		addruv = hdmidq->hwbuf[src_index]->phys + offset;
+	} else {
+		addry = dev->ion_buf.phys_addr;
+		addruv = dev->ion_buf.phys_addr + offset;
+		hdmidq->skip_frame[src_index] = 1;
+		hdmidq->hwbuf[src_index] = NULL;
+	}
+
+	spin_unlock_irqrestore(&dev->slock, flags);
+
+	if (src_index == 0)
+		set_video_dest_addr(addry, addruv, -1, -1);
+	else
+		set_video_dest_addr(-1, -1, addry, addruv);
+}
+
+void hdmi_hw_buf_update(int src_index, struct v4l2_hdmi_dev *dev)
+{
+	static int skip_num = 0;
+	static int total_num = 0;
+	static unsigned long prev_jif = 0;
+	unsigned long flags;
+	int empty;
+	struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;
+
+	if (mipi_top.mipi_init == 0)
+		return;
+
+	if (unlikely((jiffies - prev_jif) >= (10 * HZ))) {
+		HDMIRX_INFO("skip %d/%d in %lu jiffies, drop %u frames\n",
+			skip_num, total_num, jiffies - prev_jif, drop_count);
+		prev_jif = jiffies;
+		total_num = 0;
+		skip_num = 0;
+		drop_count = 0;
+	}
+	total_num++;
+
+	spin_lock_irqsave(&dev->slock, flags);
+	empty = list_empty(&hdmidq->active);
+	spin_unlock_irqrestore(&dev->slock, flags);
+
+	if (empty)
+		skip_num++;
+
+	update_mipi_hw_buffer(src_index, dev, empty);
+}
+
+irqreturn_t hdmirx_mipi_isr(int irq, void *dev_id)
+{
+	unsigned int st_reg_val;
+	unsigned int reg_val;
+	struct v4l2_hdmi_dev *dev = dev_id;
+
+	hdmirx_wrapper_isr();
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+	/* Get TX write Aksv */
+	if (HDCP_FLAG1_get_wr_aksv_flag(hdmi_rx_reg_read32(HDCP_FLAG1, HDMI_RX_MAC))) {
+		/* Disable AKSV interrupt */
+		hdmi_rx_reg_mask32(HDCP_FLAG2, ~HDCP_FLAG2_irq_aksv_en_mask,
+			0, HDMI_RX_MAC);
+		/* Clear Aksv flag */
+		hdmi_rx_reg_write32(HDCP_FLAG1, HDCP_FLAG1_wr_aksv_flag_mask, HDMI_RX_MAC);
+		/* Clear HDCP interrupt */
+		hdmi_rx_reg_write32(HDMI_INTCR, HDMI_INTCR_pending_mask, HDMI_RX_MAC);
+		start_hdcp1x_repeater_work();
+	}
+#endif
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+	Hdmi_HDCP_2_2_msg_hander();
+
+	/* Return isr if dma not enabled */
+	if (!HDMIRX_WRAPPER_CONTROL_0_get_fw_dma_en(hdmi_rx_reg_read32(HDMIRX_WRAPPER_CONTROL_0, HDMI_RX_HDMI_WRAPPER)))
+		return IRQ_HANDLED;
+#endif
+
+	st_reg_val = hdmi_rx_reg_read32(MIPI_INT_ST, HDMI_RX_MIPI);
+
+	if (st_reg_val & 0x30) {
+		/* Clear interrupt status */
+		hdmi_rx_reg_write32(MIPI_INT_ST, st_reg_val, HDMI_RX_MIPI);
+
+		drop_count++;
+
+		return IRQ_HANDLED;
+	}
+
+	reg_val = hdmi_rx_reg_read32(MIPI_TYPE, HDMI_RX_MIPI);
+	if (unlikely(reg_val & 0x01)) {
+		/* Picture mode */
+		if (st_reg_val & MIPI_INT_ST_fm_done2_mask)
+			hdmi_rx_reg_write32(MIPI_INT_ST, st_reg_val, HDMI_RX_MIPI);
+	} else {
+		/* Preview or video mode */
+		if (st_reg_val & MIPI_INT_ST_fm_done0_mask)
+			hdmi_hw_buf_update(0, dev);
+		else if (st_reg_val & MIPI_INT_ST_fm_done1_mask)
+			hdmi_hw_buf_update(1, dev);
+
+		/* Clear interrupt status */
+		hdmi_rx_reg_write32(MIPI_INT_ST, st_reg_val, HDMI_RX_MIPI);
+	}
+
+	return IRQ_HANDLED;
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/mipi_wrapper.h b/drivers/media/platform/rtk_hdmirx/rtd161x/mipi_wrapper.h
new file mode 100644
index 00000000..cbd0d02
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/mipi_wrapper.h
@@ -0,0 +1,154 @@
+/*
+ * mipi_wrapper.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _MIPI_WRAPPER_H_
+#define _MIPI_WRAPPER_H_
+
+typedef struct {
+	unsigned int dst_fmt;
+	unsigned int src_fmt;
+	unsigned int src_sel;
+	unsigned int yuv420_uv_seq;
+	unsigned int vs;
+	unsigned int vs_near;
+	unsigned int vs_yodd;
+	unsigned int vs_codd;
+	unsigned int hs;
+	unsigned int hs_yodd;
+	unsigned int hs_codd;
+	unsigned int yuv420_fmt;
+	unsigned int ccs_data_format;
+	unsigned int yuv_to_rgb;
+	unsigned int chroma_ds_mode;
+	unsigned int chroma_ds_en;
+	unsigned int chroma_us_mode;
+	unsigned int chroma_us_en;
+	unsigned int hdmirx_interlace_en;
+	unsigned int hdmirx_interlace_polarity;
+	unsigned int int_en4;
+	unsigned int int_en3;
+	unsigned int int_en2;
+	unsigned int int_en1;
+	unsigned int int_en0;
+	unsigned int en;
+} MIPI_REG;
+
+typedef enum {
+	OUT_8BIT_YUV422   = 0x2,
+	OUT_8BIT_YUV420   = 0x3,
+	OUT_10BIT_YUV422  = 0x4,
+	OUT_10BIT_YUV420  = 0x5,
+	OUT_ARGB  = 0x10,
+	OUT_ARBG  = 0x11,
+	OUT_AGRB  = 0x12,
+	OUT_AGBR  = 0x13,
+	OUT_ABRG  = 0x14,
+	OUT_ABGR  = 0x15,
+	OUT_RGBA  = 0x16,
+	OUT_RBGA  = 0x17,
+	OUT_GRBA  = 0x18,
+	OUT_GBRA  = 0x19,
+	OUT_BRGA  = 0x1A,
+	OUT_BGRA  = 0x1B,
+	OUT_UNKNOW
+} MIPI_OUT_COLOR_SPACE_T;
+
+typedef enum {
+	IN_RGB888 = 0x0,
+	IN_YUV444 = 0x1,
+	IN_YUV422 = 0x2,
+	IN_UNKNOW
+} MIPI_IN_COLOR_SPACE_T;
+
+typedef enum {
+	UV_NV12 = 0x0,/* U0V0U1V1 */
+	UV_NV21 = 0x1,/* V0U0V1U1 */
+} MIPI_YUV420_UV_SEQ;
+
+enum {
+	YUV_10BIT_4BYTE_3PIXEL = 0,
+	YUV_10BIT_2BYTE_1PIXEL = 1,
+};
+
+typedef struct {
+	char hdmi_rx_init;
+	char mipi_init;
+	unsigned int src_sel; /* 0:mipi; 1:hdmi_rx */
+	unsigned int h_input_len;
+	unsigned int v_input_len;
+	MIPI_IN_COLOR_SPACE_T input_color;
+	unsigned int h_output_len;
+	unsigned int v_output_len;
+	MIPI_OUT_COLOR_SPACE_T output_color;
+	MIPI_YUV420_UV_SEQ uv_seq;
+	int pitch;
+	struct work_struct mipi_reset_work;
+} MIPI_TOP_INFO;
+
+enum {
+	DEMUX8   = 0x0,
+	DEMUX16  = 0x1,
+	DEMUX32  = 0x2,
+};
+
+enum {
+	Onelane  = 0x0,
+	fourlane = 0x1,
+};
+
+enum {
+	disable = 0x0,
+	enable  = 0x1,
+};
+
+enum {
+	dvi_bit_8  = 0x0,
+	div_bit_16 = 0x1,
+	div_bit_32 = 0x2,
+};
+
+enum {
+	posedge = 0x0,
+	negedge = 0x1,
+};
+
+enum YUV_SRC_SEL {
+	SEL_UYVY  = 0x0,
+	SEL_VYUY  = 0x1,
+	SEL_YVYU  = 0x2,
+	SEL_YUYV  = 0x3,
+};
+
+enum DEC_FORMAT {
+	RAW8_dec_format    = 0x0,
+	RAW10_dec_format   = 0x1,
+	YUV422_dec_format  = 0x2,
+	JPEG_dec_format    = 0x3,
+	RAW12_dec_format   = 0x4,
+};
+
+enum {
+	DTYPE_YUY8    =	   0x1E,
+	DTYPE_MJPEG   =    0x31,
+};
+
+void register_mipi_ion(struct v4l2_hdmi_dev *dev);
+void deregister_mipi_ion(struct v4l2_hdmi_dev *dev);
+void mipi_reset_work_func(struct work_struct *work);
+void stop_mipi_process(void);
+void set_mipi_env(void);
+void set_enable_mipi(unsigned char enable);
+void set_mipi_type(unsigned int type);
+void set_video_dest_addr(int addr1y, int addr1uv, int addr2y, int addr2uv);
+void set_video_DDR_start_addr(struct v4l2_hdmi_dev *dev);
+void setup_mipi(void);
+irqreturn_t hdmirx_mipi_isr(int irq, void *dev_id);
+#endif/* _MIPI_WRAPPER_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/DFE_HDMI_RX_PHY_fw.h b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/DFE_HDMI_RX_PHY_fw.h
new file mode 100644
index 00000000..0040153
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/DFE_HDMI_RX_PHY_fw.h
@@ -0,0 +1,5277 @@
+/*
+ * DFE_HDMI_RX_PHY_fw.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+
+#ifndef _DFE_HDMI_RX_PHY_REG_H_INCLUDED_
+#define _DFE_HDMI_RX_PHY_REG_H_INCLUDED_
+
+
+#define BG                                                            0xa00
+#define BG_reg_addr                                                   "0x98034a00"
+#define BG_reg                                                        0x98034a00
+#define BG_inst_addr                                                  "0x0280"
+#define BG_inst                                                       0x0280
+#define BG_reg_bg_rbgloop2_shift                                      (7)
+#define BG_reg_bg_rbg_shift                                           (4)
+#define BG_reg_bg_rbg2_shift                                          (2)
+#define BG_reg_bg_pow_shift                                           (1)
+#define BG_reg_bg_envbgup_shift                                       (0)
+#define BG_reg_bg_rbgloop2_mask                                       (0x00000380)
+#define BG_reg_bg_rbg_mask                                            (0x00000070)
+#define BG_reg_bg_rbg2_mask                                           (0x0000000C)
+#define BG_reg_bg_pow_mask                                            (0x00000002)
+#define BG_reg_bg_envbgup_mask                                        (0x00000001)
+#define BG_reg_bg_rbgloop2(data)                                      (0x00000380&((data)<<7))
+#define BG_reg_bg_rbg(data)                                           (0x00000070&((data)<<4))
+#define BG_reg_bg_rbg2(data)                                          (0x0000000C&((data)<<2))
+#define BG_reg_bg_pow(data)                                           (0x00000002&((data)<<1))
+#define BG_reg_bg_envbgup(data)                                       (0x00000001&(data))
+#define BG_get_reg_bg_rbgloop2(data)                                  ((0x00000380&(data))>>7)
+#define BG_get_reg_bg_rbg(data)                                       ((0x00000070&(data))>>4)
+#define BG_get_reg_bg_rbg2(data)                                      ((0x0000000C&(data))>>2)
+#define BG_get_reg_bg_pow(data)                                       ((0x00000002&(data))>>1)
+#define BG_get_reg_bg_envbgup(data)                                   (0x00000001&(data))
+
+
+#define MD                                                            0xa04
+#define MD_reg_addr                                                   "0x98034a04"
+#define MD_reg                                                        0x98034a04
+#define MD_inst_addr                                                  "0x0281"
+#define MD_inst                                                       0x0281
+#define MD_reg_ck_latch_shift                                         (5)
+#define MD_reg_ck_cmp_shift                                           (4)
+#define MD_reg_ck_ckdet_shift                                         (0)
+#define MD_reg_ck_latch_mask                                          (0x00000020)
+#define MD_reg_ck_cmp_mask                                            (0x00000010)
+#define MD_reg_ck_ckdet_mask                                          (0x0000000F)
+#define MD_reg_ck_latch(data)                                         (0x00000020&((data)<<5))
+#define MD_reg_ck_cmp(data)                                           (0x00000010&((data)<<4))
+#define MD_reg_ck_ckdet(data)                                         (0x0000000F&(data))
+#define MD_get_reg_ck_latch(data)                                     ((0x00000020&(data))>>5)
+#define MD_get_reg_ck_cmp(data)                                       ((0x00000010&(data))>>4)
+#define MD_get_reg_ck_ckdet(data)                                     (0x0000000F&(data))
+
+
+#define LDO                                                           0xa08
+#define LDO_reg_addr                                                  "0x98034a08"
+#define LDO_reg                                                       0x98034a08
+#define LDO_inst_addr                                                 "0x0282"
+#define LDO_inst                                                      0x0282
+#define LDO_reg_ldo_mossel_shift                                      (12)
+#define LDO_reg_p3_ldo_sel_shift                                      (10)
+#define LDO_reg_p2_ldo_sel_shift                                      (8)
+#define LDO_reg_p1_ldo_sel_shift                                      (6)
+#define LDO_reg_p0_ldo_sel_shift                                      (4)
+#define LDO_reg_p3_ldo_pow_shift                                      (3)
+#define LDO_reg_p2_ldo_pow_shift                                      (2)
+#define LDO_reg_p1_ldo_pow_shift                                      (1)
+#define LDO_reg_p0_ldo_pow_shift                                      (0)
+#define LDO_reg_ldo_mossel_mask                                       (0x00007000)
+#define LDO_reg_p3_ldo_sel_mask                                       (0x00000C00)
+#define LDO_reg_p2_ldo_sel_mask                                       (0x00000300)
+#define LDO_reg_p1_ldo_sel_mask                                       (0x000000C0)
+#define LDO_reg_p0_ldo_sel_mask                                       (0x00000030)
+#define LDO_reg_p3_ldo_pow_mask                                       (0x00000008)
+#define LDO_reg_p2_ldo_pow_mask                                       (0x00000004)
+#define LDO_reg_p1_ldo_pow_mask                                       (0x00000002)
+#define LDO_reg_p0_ldo_pow_mask                                       (0x00000001)
+#define LDO_reg_ldo_mossel(data)                                      (0x00007000&((data)<<12))
+#define LDO_reg_p3_ldo_sel(data)                                      (0x00000C00&((data)<<10))
+#define LDO_reg_p2_ldo_sel(data)                                      (0x00000300&((data)<<8))
+#define LDO_reg_p1_ldo_sel(data)                                      (0x000000C0&((data)<<6))
+#define LDO_reg_p0_ldo_sel(data)                                      (0x00000030&((data)<<4))
+#define LDO_reg_p3_ldo_pow(data)                                      (0x00000008&((data)<<3))
+#define LDO_reg_p2_ldo_pow(data)                                      (0x00000004&((data)<<2))
+#define LDO_reg_p1_ldo_pow(data)                                      (0x00000002&((data)<<1))
+#define LDO_reg_p0_ldo_pow(data)                                      (0x00000001&(data))
+#define LDO_get_reg_ldo_mossel(data)                                  ((0x00007000&(data))>>12)
+#define LDO_get_reg_p3_ldo_sel(data)                                  ((0x00000C00&(data))>>10)
+#define LDO_get_reg_p2_ldo_sel(data)                                  ((0x00000300&(data))>>8)
+#define LDO_get_reg_p1_ldo_sel(data)                                  ((0x000000C0&(data))>>6)
+#define LDO_get_reg_p0_ldo_sel(data)                                  ((0x00000030&(data))>>4)
+#define LDO_get_reg_p3_ldo_pow(data)                                  ((0x00000008&(data))>>3)
+#define LDO_get_reg_p2_ldo_pow(data)                                  ((0x00000004&(data))>>2)
+#define LDO_get_reg_p1_ldo_pow(data)                                  ((0x00000002&(data))>>1)
+#define LDO_get_reg_p0_ldo_pow(data)                                  (0x00000001&(data))
+
+
+#define MHL                                                           0xa0c
+#define MHL_reg_addr                                                  "0x98034a0c"
+#define MHL_reg                                                       0x98034a0c
+#define MHL_inst_addr                                                 "0x0283"
+#define MHL_inst                                                      0x0283
+#define MHL_reg_p3_mhl_hdmi_datasel_shift                             (12)
+#define MHL_reg_p3_mhl_hdmi_cksel_shift                               (11)
+#define MHL_reg_p3_mhl_pow_shift                                      (10)
+#define MHL_reg_p2_mhl_hdmi_datasel_shift                             (9)
+#define MHL_reg_p2_mhl_hdmi_cksel_shift                               (8)
+#define MHL_reg_p2_mhl_pow_shift                                      (7)
+#define MHL_reg_p1_mhl_hdmi_datasel_shift                             (6)
+#define MHL_reg_p1_mhl_hdmi_cksel_shift                               (5)
+#define MHL_reg_p1_mhl_pow_shift                                      (4)
+#define MHL_reg_p0_mhl_hdmi_cksel_shift                               (3)
+#define MHL_reg_p0_mhl_hdmi_datasel_shift                             (2)
+#define MHL_reg_p0_mhl_pow_shift                                      (1)
+#define MHL_reg_mhl_hdmisel_shift                                     (0)
+#define MHL_reg_p3_mhl_hdmi_datasel_mask                              (0x00001000)
+#define MHL_reg_p3_mhl_hdmi_cksel_mask                                (0x00000800)
+#define MHL_reg_p3_mhl_pow_mask                                       (0x00000400)
+#define MHL_reg_p2_mhl_hdmi_datasel_mask                              (0x00000200)
+#define MHL_reg_p2_mhl_hdmi_cksel_mask                                (0x00000100)
+#define MHL_reg_p2_mhl_pow_mask                                       (0x00000080)
+#define MHL_reg_p1_mhl_hdmi_datasel_mask                              (0x00000040)
+#define MHL_reg_p1_mhl_hdmi_cksel_mask                                (0x00000020)
+#define MHL_reg_p1_mhl_pow_mask                                       (0x00000010)
+#define MHL_reg_p0_mhl_hdmi_cksel_mask                                (0x00000008)
+#define MHL_reg_p0_mhl_hdmi_datasel_mask                              (0x00000004)
+#define MHL_reg_p0_mhl_pow_mask                                       (0x00000002)
+#define MHL_reg_mhl_hdmisel_mask                                      (0x00000001)
+#define MHL_reg_p3_mhl_hdmi_datasel(data)                             (0x00001000&((data)<<12))
+#define MHL_reg_p3_mhl_hdmi_cksel(data)                               (0x00000800&((data)<<11))
+#define MHL_reg_p3_mhl_pow(data)                                      (0x00000400&((data)<<10))
+#define MHL_reg_p2_mhl_hdmi_datasel(data)                             (0x00000200&((data)<<9))
+#define MHL_reg_p2_mhl_hdmi_cksel(data)                               (0x00000100&((data)<<8))
+#define MHL_reg_p2_mhl_pow(data)                                      (0x00000080&((data)<<7))
+#define MHL_reg_p1_mhl_hdmi_datasel(data)                             (0x00000040&((data)<<6))
+#define MHL_reg_p1_mhl_hdmi_cksel(data)                               (0x00000020&((data)<<5))
+#define MHL_reg_p1_mhl_pow(data)                                      (0x00000010&((data)<<4))
+#define MHL_reg_p0_mhl_hdmi_cksel(data)                               (0x00000008&((data)<<3))
+#define MHL_reg_p0_mhl_hdmi_datasel(data)                             (0x00000004&((data)<<2))
+#define MHL_reg_p0_mhl_pow(data)                                      (0x00000002&((data)<<1))
+#define MHL_reg_mhl_hdmisel(data)                                     (0x00000001&(data))
+#define MHL_get_reg_p3_mhl_hdmi_datasel(data)                         ((0x00001000&(data))>>12)
+#define MHL_get_reg_p3_mhl_hdmi_cksel(data)                           ((0x00000800&(data))>>11)
+#define MHL_get_reg_p3_mhl_pow(data)                                  ((0x00000400&(data))>>10)
+#define MHL_get_reg_p2_mhl_hdmi_datasel(data)                         ((0x00000200&(data))>>9)
+#define MHL_get_reg_p2_mhl_hdmi_cksel(data)                           ((0x00000100&(data))>>8)
+#define MHL_get_reg_p2_mhl_pow(data)                                  ((0x00000080&(data))>>7)
+#define MHL_get_reg_p1_mhl_hdmi_datasel(data)                         ((0x00000040&(data))>>6)
+#define MHL_get_reg_p1_mhl_hdmi_cksel(data)                           ((0x00000020&(data))>>5)
+#define MHL_get_reg_p1_mhl_pow(data)                                  ((0x00000010&(data))>>4)
+#define MHL_get_reg_p0_mhl_hdmi_cksel(data)                           ((0x00000008&(data))>>3)
+#define MHL_get_reg_p0_mhl_hdmi_datasel(data)                         ((0x00000004&(data))>>2)
+#define MHL_get_reg_p0_mhl_pow(data)                                  ((0x00000002&(data))>>1)
+#define MHL_get_reg_mhl_hdmisel(data)                                 (0x00000001&(data))
+
+
+#define ENABLE                                                        0xa10
+#define ENABLE_reg_addr                                               "0x98034a10"
+#define ENABLE_reg                                                    0x98034a10
+#define ENABLE_inst_addr                                              "0x0284"
+#define ENABLE_inst                                                   0x0284
+#define ENABLE_reg_p3_en_rx_shift                                     (25)
+#define ENABLE_reg_p3_en_cmu_shift                                    (24)
+#define ENABLE_reg_p3_en_cdr_shift                                    (21)
+#define ENABLE_reg_p2_en_rx_shift                                     (18)
+#define ENABLE_reg_p2_en_cmu_shift                                    (17)
+#define ENABLE_reg_p2_en_cdr_shift                                    (14)
+#define ENABLE_reg_p1_en_rx_shift                                     (11)
+#define ENABLE_reg_p1_en_cmu_shift                                    (10)
+#define ENABLE_reg_p1_en_cdr_shift                                    (7)
+#define ENABLE_reg_p0_en_rx_shift                                     (4)
+#define ENABLE_reg_p0_en_cmu_shift                                    (3)
+#define ENABLE_reg_p0_en_cdr_shift                                    (0)
+#define ENABLE_reg_p3_en_rx_mask                                      (0x0E000000)
+#define ENABLE_reg_p3_en_cmu_mask                                     (0x01000000)
+#define ENABLE_reg_p3_en_cdr_mask                                     (0x00E00000)
+#define ENABLE_reg_p2_en_rx_mask                                      (0x001C0000)
+#define ENABLE_reg_p2_en_cmu_mask                                     (0x00020000)
+#define ENABLE_reg_p2_en_cdr_mask                                     (0x0001C000)
+#define ENABLE_reg_p1_en_rx_mask                                      (0x00003800)
+#define ENABLE_reg_p1_en_cmu_mask                                     (0x00000400)
+#define ENABLE_reg_p1_en_cdr_mask                                     (0x00000380)
+#define ENABLE_reg_p0_en_rx_mask                                      (0x00000070)
+#define ENABLE_reg_p0_en_cmu_mask                                     (0x00000008)
+#define ENABLE_reg_p0_en_cdr_mask                                     (0x00000007)
+#define ENABLE_reg_p3_en_rx(data)                                     (0x0E000000&((data)<<25))
+#define ENABLE_reg_p3_en_cmu(data)                                    (0x01000000&((data)<<24))
+#define ENABLE_reg_p3_en_cdr(data)                                    (0x00E00000&((data)<<21))
+#define ENABLE_reg_p2_en_rx(data)                                     (0x001C0000&((data)<<18))
+#define ENABLE_reg_p2_en_cmu(data)                                    (0x00020000&((data)<<17))
+#define ENABLE_reg_p2_en_cdr(data)                                    (0x0001C000&((data)<<14))
+#define ENABLE_reg_p1_en_rx(data)                                     (0x00003800&((data)<<11))
+#define ENABLE_reg_p1_en_cmu(data)                                    (0x00000400&((data)<<10))
+#define ENABLE_reg_p1_en_cdr(data)                                    (0x00000380&((data)<<7))
+#define ENABLE_reg_p0_en_rx(data)                                     (0x00000070&((data)<<4))
+#define ENABLE_reg_p0_en_cmu(data)                                    (0x00000008&((data)<<3))
+#define ENABLE_reg_p0_en_cdr(data)                                    (0x00000007&(data))
+#define ENABLE_get_reg_p3_en_rx(data)                                 ((0x0E000000&(data))>>25)
+#define ENABLE_get_reg_p3_en_cmu(data)                                ((0x01000000&(data))>>24)
+#define ENABLE_get_reg_p3_en_cdr(data)                                ((0x00E00000&(data))>>21)
+#define ENABLE_get_reg_p2_en_rx(data)                                 ((0x001C0000&(data))>>18)
+#define ENABLE_get_reg_p2_en_cmu(data)                                ((0x00020000&(data))>>17)
+#define ENABLE_get_reg_p2_en_cdr(data)                                ((0x0001C000&(data))>>14)
+#define ENABLE_get_reg_p1_en_rx(data)                                 ((0x00003800&(data))>>11)
+#define ENABLE_get_reg_p1_en_cmu(data)                                ((0x00000400&(data))>>10)
+#define ENABLE_get_reg_p1_en_cdr(data)                                ((0x00000380&(data))>>7)
+#define ENABLE_get_reg_p0_en_rx(data)                                 ((0x00000070&(data))>>4)
+#define ENABLE_get_reg_p0_en_cmu(data)                                ((0x00000008&(data))>>3)
+#define ENABLE_get_reg_p0_en_cdr(data)                                (0x00000007&(data))
+
+
+#define TEST                                                          0xa14
+#define TEST_reg_addr                                                 "0x98034a14"
+#define TEST_reg                                                      0x98034a14
+#define TEST_inst_addr                                                "0x0285"
+#define TEST_inst                                                     0x0285
+#define TEST_reg_tst_spad_shift                                       (4)
+#define TEST_reg_stst_shift                                           (0)
+#define TEST_reg_tst_spad_mask                                        (0x00000010)
+#define TEST_reg_stst_mask                                            (0x0000000F)
+#define TEST_reg_tst_spad(data)                                       (0x00000010&((data)<<4))
+#define TEST_reg_stst(data)                                           (0x0000000F&(data))
+#define TEST_get_reg_tst_spad(data)                                   ((0x00000010&(data))>>4)
+#define TEST_get_reg_stst(data)                                       (0x0000000F&(data))
+
+
+#define TOP_IN                                                        0xa18
+#define TOP_IN_reg_addr                                               "0x98034a18"
+#define TOP_IN_reg                                                    0x98034a18
+#define TOP_IN_inst_addr                                              "0x0286"
+#define TOP_IN_inst                                                   0x0286
+#define TOP_IN_reg_top_in_4_shift                                     (24)
+#define TOP_IN_reg_top_in_3_shift                                     (16)
+#define TOP_IN_reg_top_in_2_shift                                     (8)
+#define TOP_IN_reg_top_in_1_shift                                     (0)
+#define TOP_IN_reg_top_in_4_mask                                      (0xFF000000)
+#define TOP_IN_reg_top_in_3_mask                                      (0x00FF0000)
+#define TOP_IN_reg_top_in_2_mask                                      (0x0000FF00)
+#define TOP_IN_reg_top_in_1_mask                                      (0x000000FF)
+#define TOP_IN_reg_top_in_4(data)                                     (0xFF000000&((data)<<24))
+#define TOP_IN_reg_top_in_3(data)                                     (0x00FF0000&((data)<<16))
+#define TOP_IN_reg_top_in_2(data)                                     (0x0000FF00&((data)<<8))
+#define TOP_IN_reg_top_in_1(data)                                     (0x000000FF&(data))
+#define TOP_IN_get_reg_top_in_4(data)                                 ((0xFF000000&(data))>>24)
+#define TOP_IN_get_reg_top_in_3(data)                                 ((0x00FF0000&(data))>>16)
+#define TOP_IN_get_reg_top_in_2(data)                                 ((0x0000FF00&(data))>>8)
+#define TOP_IN_get_reg_top_in_1(data)                                 (0x000000FF&(data))
+#define TOP_IN_REG_IBHN_TUNE                           (_BIT21|_BIT20)
+#define TOP_IN_CK_TX_3                                 (_BIT3)
+#define TOP_IN_CK_TX_2                                 (_BIT2)
+#define TOP_IN_CK_TX_1                                 (_BIT1)
+#define TOP_IN_CK_TX_0                                 (_BIT0)
+#define TOP_IN_Z0_FIX_SELECT_0                         (_BIT9|_BIT8)
+#define TOP_IN_Z0_FIX_SELECT_1                         (_BIT11|_BIT10)
+#define TOP_IN_Z0_FIX_SELECT_2                         (_BIT13|_BIT12)
+#define TOP_IN_Z0_FIX_SELECT_3                         (_BIT15|_BIT14)
+#define TOP_IN_BIAS_POW                                (_BIT16)
+
+
+#define TOP_OUT                                                       0xa1c
+#define TOP_OUT_reg_addr                                              "0x98034a1c"
+#define TOP_OUT_reg                                                   0x98034a1c
+#define TOP_OUT_inst_addr                                             "0x0287"
+#define TOP_OUT_inst                                                  0x0287
+#define TOP_OUT_reg_top_out_4_shift                                   (24)
+#define TOP_OUT_reg_top_out_3_shift                                   (16)
+#define TOP_OUT_reg_top_out_2_shift                                   (8)
+#define TOP_OUT_reg_top_out_1_shift                                   (0)
+#define TOP_OUT_reg_top_out_4_mask                                    (0xFF000000)
+#define TOP_OUT_reg_top_out_3_mask                                    (0x00FF0000)
+#define TOP_OUT_reg_top_out_2_mask                                    (0x0000FF00)
+#define TOP_OUT_reg_top_out_1_mask                                    (0x000000FF)
+#define TOP_OUT_reg_top_out_4(data)                                   (0xFF000000&((data)<<24))
+#define TOP_OUT_reg_top_out_3(data)                                   (0x00FF0000&((data)<<16))
+#define TOP_OUT_reg_top_out_2(data)                                   (0x0000FF00&((data)<<8))
+#define TOP_OUT_reg_top_out_1(data)                                   (0x000000FF&(data))
+#define TOP_OUT_get_reg_top_out_4(data)                               ((0xFF000000&(data))>>24)
+#define TOP_OUT_get_reg_top_out_3(data)                               ((0x00FF0000&(data))>>16)
+#define TOP_OUT_get_reg_top_out_2(data)                               ((0x0000FF00&(data))>>8)
+#define TOP_OUT_get_reg_top_out_1(data)                               (0x000000FF&(data))
+
+
+#define Z0POW                                                         0xa20
+#define Z0POW_reg_addr                                                "0x98034a20"
+#define Z0POW_reg                                                     0x98034a20
+#define Z0POW_inst_addr                                               "0x0288"
+#define Z0POW_inst                                                    0x0288
+#define Z0POW_reg_z0_z300_sel_shift                                   (24)
+#define Z0POW_reg_z0_z300pow_shift                                    (20)
+#define Z0POW_reg_z0_z100_en_shift                                    (16)
+#define Z0POW_reg_z0_z0pow_r_shift                                    (12)
+#define Z0POW_reg_z0_z0pow_g_shift                                    (8)
+#define Z0POW_reg_z0_z0pow_ck_shift                                   (4)
+#define Z0POW_reg_z0_z0pow_b_shift                                    (0)
+#define Z0POW_reg_z0_z300_sel_mask                                    (0x0F000000)
+#define Z0POW_reg_z0_z300pow_mask                                     (0x00F00000)
+#define Z0POW_reg_z0_z100_en_mask                                     (0x000F0000)
+#define Z0POW_reg_z0_z0pow_r_mask                                     (0x0000F000)
+#define Z0POW_reg_z0_z0pow_g_mask                                     (0x00000F00)
+#define Z0POW_reg_z0_z0pow_ck_mask                                    (0x000000F0)
+#define Z0POW_reg_z0_z0pow_b_mask                                     (0x0000000F)
+#define Z0POW_reg_z0_z300_sel(data)                                   (0x0F000000&((data)<<24))
+#define Z0POW_reg_z0_z300pow(data)                                    (0x00F00000&((data)<<20))
+#define Z0POW_reg_z0_z100_en(data)                                    (0x000F0000&((data)<<16))
+#define Z0POW_reg_z0_z0pow_r(data)                                    (0x0000F000&((data)<<12))
+#define Z0POW_reg_z0_z0pow_g(data)                                    (0x00000F00&((data)<<8))
+#define Z0POW_reg_z0_z0pow_ck(data)                                   (0x000000F0&((data)<<4))
+#define Z0POW_reg_z0_z0pow_b(data)                                    (0x0000000F&(data))
+#define Z0POW_get_reg_z0_z300_sel(data)                               ((0x0F000000&(data))>>24)
+#define Z0POW_get_reg_z0_z300pow(data)                                ((0x00F00000&(data))>>20)
+#define Z0POW_get_reg_z0_z100_en(data)                                ((0x000F0000&(data))>>16)
+#define Z0POW_get_reg_z0_z0pow_r(data)                                ((0x0000F000&(data))>>12)
+#define Z0POW_get_reg_z0_z0pow_g(data)                                ((0x00000F00&(data))>>8)
+#define Z0POW_get_reg_z0_z0pow_ck(data)                               ((0x000000F0&(data))>>4)
+#define Z0POW_get_reg_z0_z0pow_b(data)                                (0x0000000F&(data))
+
+
+#define Z0K                                                           0xa24
+#define Z0K_reg_addr                                                  "0x98034a24"
+#define Z0K_reg                                                       0x98034a24
+#define Z0K_inst_addr                                                 "0x0289"
+#define Z0K_inst                                                      0x0289
+#define Z0K_reg_z0_z0pow_shift                                        (28)
+#define Z0K_reg_z0_stune_shift                                        (27)
+#define Z0K_reg_z0_res_shift                                          (22)
+#define Z0K_reg_z0_ok_shift                                           (21)
+#define Z0K_reg_z0_entst_shift                                        (20)
+#define Z0K_reg_z0_bound_shift                                        (19)
+#define Z0K_reg_z0_adjr_2_shift                                       (14)
+#define Z0K_reg_z0_adjr_1_shift                                       (9)
+#define Z0K_reg_z0_adjr_0_shift                                       (4)
+#define Z0K_reg_z0tst_shift                                           (0)
+#define Z0K_reg_z0_z0pow_mask                                         (0x10000000)
+#define Z0K_reg_z0_stune_mask                                         (0x08000000)
+#define Z0K_reg_z0_res_mask                                           (0x07C00000)
+#define Z0K_reg_z0_ok_mask                                            (0x00200000)
+#define Z0K_reg_z0_entst_mask                                         (0x00100000)
+#define Z0K_reg_z0_bound_mask                                         (0x00080000)
+#define Z0K_reg_z0_adjr_2_mask                                        (0x0007C000)
+#define Z0K_reg_z0_adjr_1_mask                                        (0x00003E00)
+#define Z0K_reg_z0_adjr_0_mask                                        (0x000001F0)
+#define Z0K_reg_z0tst_mask                                            (0x0000000F)
+#define Z0K_reg_z0_z0pow(data)                                        (0x10000000&((data)<<28))
+#define Z0K_reg_z0_stune(data)                                        (0x08000000&((data)<<27))
+#define Z0K_reg_z0_res(data)                                          (0x07C00000&((data)<<22))
+#define Z0K_reg_z0_ok(data)                                           (0x00200000&((data)<<21))
+#define Z0K_reg_z0_entst(data)                                        (0x00100000&((data)<<20))
+#define Z0K_reg_z0_bound(data)                                        (0x00080000&((data)<<19))
+#define Z0K_reg_z0_adjr_2(data)                                       (0x0007C000&((data)<<14))
+#define Z0K_reg_z0_adjr_1(data)                                       (0x00003E00&((data)<<9))
+#define Z0K_reg_z0_adjr_0(data)                                       (0x000001F0&((data)<<4))
+#define Z0K_reg_z0tst(data)                                           (0x0000000F&(data))
+#define Z0K_get_reg_z0_z0pow(data)                                    ((0x10000000&(data))>>28)
+#define Z0K_get_reg_z0_stune(data)                                    ((0x08000000&(data))>>27)
+#define Z0K_get_reg_z0_res(data)                                      ((0x07C00000&(data))>>22)
+#define Z0K_get_reg_z0_ok(data)                                       ((0x00200000&(data))>>21)
+#define Z0K_get_reg_z0_entst(data)                                    ((0x00100000&(data))>>20)
+#define Z0K_get_reg_z0_bound(data)                                    ((0x00080000&(data))>>19)
+#define Z0K_get_reg_z0_adjr_2(data)                                   ((0x0007C000&(data))>>14)
+#define Z0K_get_reg_z0_adjr_1(data)                                   ((0x00003E00&(data))>>9)
+#define Z0K_get_reg_z0_adjr_0(data)                                   ((0x000001F0&(data))>>4)
+#define Z0K_get_reg_z0tst(data)                                       (0x0000000F&(data))
+
+
+#define Z0K_2                                                         0xa28
+#define Z0K_2_reg_addr                                                "0x98034a28"
+#define Z0K_2_reg                                                     0x98034a28
+#define Z0K_2_inst_addr                                               "0x028A"
+#define Z0K_2_inst                                                    0x028A
+#define Z0K_2_reg_z0_adjr_3_shift                                     (0)
+#define Z0K_2_reg_z0_adjr_3_mask                                      (0x0000001F)
+#define Z0K_2_reg_z0_adjr_3(data)                                     (0x0000001F&(data))
+#define Z0K_2_get_reg_z0_adjr_3(data)                                 (0x0000001F&(data))
+
+
+#define P0_ACDR1                                                      0xa30
+#define P0_ACDR1_reg_addr                                             "0x98034a30"
+#define P0_ACDR1_reg                                                  0x98034a30
+#define P0_ACDR1_inst_addr                                            "0x028C"
+#define P0_ACDR1_inst                                                 0x028C
+#define P0_ACDR1_reg_p0_acdr_4_shift                                  (24)
+#define P0_ACDR1_reg_p0_acdr_3_shift                                  (16)
+#define P0_ACDR1_reg_p0_acdr_2_shift                                  (8)
+#define P0_ACDR1_reg_p0_acdr_1_shift                                  (0)
+#define P0_ACDR1_reg_p0_acdr_4_mask                                   (0xFF000000)
+#define P0_ACDR1_reg_p0_acdr_3_mask                                   (0x00FF0000)
+#define P0_ACDR1_reg_p0_acdr_2_mask                                   (0x0000FF00)
+#define P0_ACDR1_reg_p0_acdr_1_mask                                   (0x000000FF)
+#define P0_ACDR1_reg_p0_acdr_4(data)                                  (0xFF000000&((data)<<24))
+#define P0_ACDR1_reg_p0_acdr_3(data)                                  (0x00FF0000&((data)<<16))
+#define P0_ACDR1_reg_p0_acdr_2(data)                                  (0x0000FF00&((data)<<8))
+#define P0_ACDR1_reg_p0_acdr_1(data)                                  (0x000000FF&(data))
+#define P0_ACDR1_get_reg_p0_acdr_4(data)                              ((0xFF000000&(data))>>24)
+#define P0_ACDR1_get_reg_p0_acdr_3(data)                              ((0x00FF0000&(data))>>16)
+#define P0_ACDR1_get_reg_p0_acdr_2(data)                              ((0x0000FF00&(data))>>8)
+#define P0_ACDR1_get_reg_p0_acdr_1(data)                              (0x000000FF&(data))
+
+
+#define P0_ACDR2                                                      0xa34
+#define P0_ACDR2_reg_addr                                             "0x98034a34"
+#define P0_ACDR2_reg                                                  0x98034a34
+#define P0_ACDR2_inst_addr                                            "0x028D"
+#define P0_ACDR2_inst                                                 0x028D
+#define P0_ACDR2_reg_p0_acdr_8_shift                                  (24)
+#define P0_ACDR2_reg_p0_acdr_7_shift                                  (16)
+#define P0_ACDR2_reg_p0_acdr_6_shift                                  (8)
+#define P0_ACDR2_reg_p0_acdr_5_shift                                  (0)
+#define P0_ACDR2_reg_p0_acdr_8_mask                                   (0xFF000000)
+#define P0_ACDR2_reg_p0_acdr_7_mask                                   (0x00FF0000)
+#define P0_ACDR2_reg_p0_acdr_6_mask                                   (0x0000FF00)
+#define P0_ACDR2_reg_p0_acdr_5_mask                                   (0x000000FF)
+#define P0_ACDR2_reg_p0_acdr_8(data)                                  (0xFF000000&((data)<<24))
+#define P0_ACDR2_reg_p0_acdr_7(data)                                  (0x00FF0000&((data)<<16))
+#define P0_ACDR2_reg_p0_acdr_6(data)                                  (0x0000FF00&((data)<<8))
+#define P0_ACDR2_reg_p0_acdr_5(data)                                  (0x000000FF&(data))
+#define P0_ACDR2_get_reg_p0_acdr_8(data)                              ((0xFF000000&(data))>>24)
+#define P0_ACDR2_get_reg_p0_acdr_7(data)                              ((0x00FF0000&(data))>>16)
+#define P0_ACDR2_get_reg_p0_acdr_6(data)                              ((0x0000FF00&(data))>>8)
+#define P0_ACDR2_get_reg_p0_acdr_5(data)                              (0x000000FF&(data))
+
+
+#define P0_B1                                                         0xa40
+#define P0_B1_reg_addr                                                "0x98034a40"
+#define P0_B1_reg                                                     0x98034a40
+#define P0_B1_inst_addr                                               "0x0290"
+#define P0_B1_inst                                                    0x0290
+#define P0_B1_reg_p0_b_4_shift                                        (24)
+#define P0_B1_reg_p0_b_3_shift                                        (16)
+#define P0_B1_reg_p0_b_2_shift                                        (8)
+#define P0_B1_reg_p0_b_1_shift                                        (0)
+#define P0_B1_reg_p0_b_4_mask                                         (0xFF000000)
+#define P0_B1_reg_p0_b_3_mask                                         (0x00FF0000)
+#define P0_B1_reg_p0_b_2_mask                                         (0x0000FF00)
+#define P0_B1_reg_p0_b_1_mask                                         (0x000000FF)
+#define P0_B1_reg_p0_b_4(data)                                        (0xFF000000&((data)<<24))
+#define P0_B1_reg_p0_b_3(data)                                        (0x00FF0000&((data)<<16))
+#define P0_B1_reg_p0_b_2(data)                                        (0x0000FF00&((data)<<8))
+#define P0_B1_reg_p0_b_1(data)                                        (0x000000FF&(data))
+#define P0_B1_get_reg_p0_b_4(data)                                    ((0xFF000000&(data))>>24)
+#define P0_B1_get_reg_p0_b_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_B1_get_reg_p0_b_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_B1_get_reg_p0_b_1(data)                                    (0x000000FF&(data))
+#define P0_b_4_FORE_KOFF_AUTOK                         (_BIT28)
+#define P0_b_CLK_PIX2_RATE_SEL                         (_BIT26)
+#define P0_b_DEMUX_BBPD_RSTB                           (_BIT25)
+#define P0_b_4_FORE_POW_FORE_KOFF                      (_BIT24)
+#define P0_b_3_FORE_EN_FORE_KOFF                       (_BIT23)
+#define P0_b_1_FORE_KOFF_RANGE                         (_BIT22|_BIT21)
+#define P0_b_1_inputoff_p                              (_BIT2)
+#define P0_b_1_inputoff_n                              (_BIT1)
+#define P0_b_1_inputoff                                (_BIT0)
+#define P0_b_1_FORE_KOFF_ADJR                          (_BIT16|_BIT17|_BIT18|_BIT19|_BIT20)
+#define P0_b_2_LEQ_BIT_RATE_mask                       (_BIT8|_BIT9)
+#define P0_b_2_LEQ_BIT_RATE_MBR                        (_BIT8)
+#define P0_b_2_LEQ_BIT_RATE_HBR                        (_BIT9)
+#define P1_b_2_LEQ_BIT_RATE_mask                       (_BIT8|_BIT9)
+#define P1_b_2_LEQ_BIT_RATE_MBR                        (_BIT8)
+#define P1_b_2_LEQ_BIT_RATE_HBR                        (_BIT9)
+#define P2_b_2_LEQ_BIT_RATE_mask                       (_BIT8|_BIT9)
+#define P2_b_2_LEQ_BIT_RATE_MBR                        (_BIT8)
+#define P2_b_2_LEQ_BIT_RATE_HBR                        (_BIT9)
+
+
+#define P0_B2                                                         0xa44
+#define P0_B2_reg_addr                                                "0x98034a44"
+#define P0_B2_reg                                                     0x98034a44
+#define P0_B2_inst_addr                                               "0x0291"
+#define P0_B2_inst                                                    0x0291
+#define P0_B2_reg_p0_b_8_shift                                        (24)
+#define P0_B2_reg_p0_b_7_shift                                        (16)
+#define P0_B2_reg_p0_b_6_shift                                        (8)
+#define P0_B2_reg_p0_b_5_shift                                        (0)
+#define P0_B2_reg_p0_b_8_mask                                         (0xFF000000)
+#define P0_B2_reg_p0_b_7_mask                                         (0x00FF0000)
+#define P0_B2_reg_p0_b_6_mask                                         (0x0000FF00)
+#define P0_B2_reg_p0_b_5_mask                                         (0x000000FF)
+#define P0_B2_reg_p0_b_8(data)                                        (0xFF000000&((data)<<24))
+#define P0_B2_reg_p0_b_7(data)                                        (0x00FF0000&((data)<<16))
+#define P0_B2_reg_p0_b_6(data)                                        (0x0000FF00&((data)<<8))
+#define P0_B2_reg_p0_b_5(data)                                        (0x000000FF&(data))
+#define P0_B2_get_reg_p0_b_8(data)                                    ((0xFF000000&(data))>>24)
+#define P0_B2_get_reg_p0_b_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_B2_get_reg_p0_b_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_B2_get_reg_p0_b_5(data)                                    (0x000000FF&(data))
+#define P0_b_8_DEMUX                                   (_BIT29|_BIT30|_BIT31)
+#define P0_b_8_PR_RATE_SEL                             (_BIT26|_BIT27|_BIT28)
+#define P0_b_8_POW_PR                                  (_BIT25)
+#define P0_b_8_BY_PASS_PR                              (_BIT24)
+#define P0_b_7_TAP0_ISEL                               (_BIT21|_BIT22|_BIT23)
+#define P0_b_7_TAP0_ISEL_400uA                         (_BIT22|_BIT23)
+#define P0_b_7_LEQ_ISEL                                (_BIT18|_BIT19|_BIT20)
+#define P0_b_7_LEQ_ISEL_400uA                          (_BIT19|_BIT20)
+#define P0_b_7_LEQ_ISEL_200uA                          (_BIT20)
+#define P0_b_7_PI_ISEL                                 (_BIT16|_BIT17)
+#define P0_b_6_LEQ_BIT_RATE                            (_BIT14|_BIT15)
+#define P0_b_6_LEQ_BIT_RATE_HBR                        (_BIT15)
+#define P0_b_6_LEQ_BIT_RATE_MBR                        (_BIT14)
+#define P0_b_6_TAP0_HBR                                (_BIT13)
+#define P0_b_6_LEQ_PASSIVE_CORNER                      (_BIT12|_BIT11)
+#define P0_b_6_TAP0_LE_ISO                             (_BIT8)
+#define P0_b_5_LEQ_CURRENT_ADJ                         (_BIT3|_BIT4)
+#define P0_b_5_LEQ_CURRENT_ADJ_1X                      (_BIT3)
+#define P0_b_5_LEQ_CURRENT_ADJ_1p25X                   (_BIT4)
+#define P0_b_5_EQ_POW                                  (_BIT0)
+#define p0_b_8_ACDR_CLK_SEL                            (_BIT24)
+
+
+#define P0_B3                                                         0xa48
+#define P0_B3_reg_addr                                                "0x98034a48"
+#define P0_B3_reg                                                     0x98034a48
+#define P0_B3_inst_addr                                               "0x0292"
+#define P0_B3_inst                                                    0x0292
+#define P0_B3_reg_p0_b_12_shift                                       (24)
+#define P0_B3_reg_p0_b_11_shift                                       (16)
+#define P0_B3_reg_p0_b_10_shift                                       (8)
+#define P0_B3_reg_p0_b_9_shift                                        (0)
+#define P0_B3_reg_p0_b_12_mask                                        (0xFF000000)
+#define P0_B3_reg_p0_b_11_mask                                        (0x00FF0000)
+#define P0_B3_reg_p0_b_10_mask                                        (0x0000FF00)
+#define P0_B3_reg_p0_b_9_mask                                         (0x000000FF)
+#define P0_B3_reg_p0_b_12(data)                                       (0xFF000000&((data)<<24))
+#define P0_B3_reg_p0_b_11(data)                                       (0x00FF0000&((data)<<16))
+#define P0_B3_reg_p0_b_10(data)                                       (0x0000FF00&((data)<<8))
+#define P0_B3_reg_p0_b_9(data)                                        (0x000000FF&(data))
+#define P0_B3_get_reg_p0_b_12(data)                                   ((0xFF000000&(data))>>24)
+#define P0_B3_get_reg_p0_b_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P0_B3_get_reg_p0_b_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P0_B3_get_reg_p0_b_9(data)                                    (0x000000FF&(data))
+#define P0_b_12_PI_CURRENT                             (_BIT28)
+#define P0_b_12_PI_CSEL                                (_BIT24|_BIT25)
+#define P0_b_9_DFE_ADAPTION_POW_EN                     (_BIT7)
+#define P0_b_9_DFE_TAP_EN                              (_BIT3|_BIT4|_BIT5|_BIT6)
+#define P0_b_9_DFE_TAP1_EN                             (_BIT3)
+#define P0_DFE_ADAPTION_EN(data)                       (0x00000080&((data)<<7))
+#define P0_b_tap_en(data)                              (0x00000078&((data)<<3))
+#define P0_b_11_ACDR_RATE_SEL_HALF_RATE                (_BIT16)
+#define P0_b_10_DFE_SUMAMP_LP_MANUALOFF                (_BIT15)
+#define P0_b_10_DFE_SUMAMP_ISEL_mask                   (_BIT11|_BIT12|_BIT13)
+#define P0_b_10_DFE_SUMAMP_ISEL_400uA                  (_BIT13)
+#define P0_b_10_DFE_PREAMP_ISEL_mask                   (_BIT8|_BIT9|_BIT10)
+#define P0_b_10_DFE_PREAMP_ISEL_400uA                  (_BIT10)
+#define P0_b_12_PR                                     (_BIT24|_BIT25)
+
+
+#define P0_B4                                                         0xa4c
+#define P0_B4_reg_addr                                                "0x98034a4c"
+#define P0_B4_reg                                                     0x98034a4c
+#define P0_B4_inst_addr                                               "0x0293"
+#define P0_B4_inst                                                    0x0293
+#define P0_B4_reg_p0_b_koff_sel_shift                                 (10)
+#define P0_B4_reg_p0_b_koff_bound_shift                               (9)
+#define P0_B4_reg_p0_b_koffok_shift                                   (8)
+#define P0_B4_reg_p0_b_13_shift                                       (0)
+#define P0_B4_reg_p0_b_koff_sel_mask                                  (0x00007C00)
+#define P0_B4_reg_p0_b_koff_bound_mask                                (0x00000200)
+#define P0_B4_reg_p0_b_koffok_mask                                    (0x00000100)
+#define P0_B4_reg_p0_b_13_mask                                        (0x000000FF)
+#define P0_B4_reg_p0_b_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P0_B4_reg_p0_b_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P0_B4_reg_p0_b_koffok(data)                                   (0x00000100&((data)<<8))
+#define P0_B4_reg_p0_b_13(data)                                       (0x000000FF&(data))
+#define P0_B4_get_reg_p0_b_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P0_B4_get_reg_p0_b_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P0_B4_get_reg_p0_b_koffok(data)                               ((0x00000100&(data))>>8)
+#define P0_B4_get_reg_p0_b_13(data)                                   (0x000000FF&(data))
+
+
+#define P0_CK1                                                        0xa50
+#define P0_CK1_reg_addr                                               "0x98034a50"
+#define P0_CK1_reg                                                    0x98034a50
+#define P0_CK1_inst_addr                                              "0x0294"
+#define P0_CK1_inst                                                   0x0294
+#define P0_CK1_reg_p0_ck_4_shift                                      (24)
+#define P0_CK1_reg_p0_ck_3_shift                                      (16)
+#define P0_CK1_reg_p0_ck_2_shift                                      (8)
+#define P0_CK1_reg_p0_ck_1_shift                                      (0)
+#define P0_CK1_reg_p0_ck_4_mask                                       (0xFF000000)
+#define P0_CK1_reg_p0_ck_3_mask                                       (0x00FF0000)
+#define P0_CK1_reg_p0_ck_2_mask                                       (0x0000FF00)
+#define P0_CK1_reg_p0_ck_1_mask                                       (0x000000FF)
+#define P0_CK1_reg_p0_ck_4(data)                                      (0xFF000000&((data)<<24))
+#define P0_CK1_reg_p0_ck_3(data)                                      (0x00FF0000&((data)<<16))
+#define P0_CK1_reg_p0_ck_2(data)                                      (0x0000FF00&((data)<<8))
+#define P0_CK1_reg_p0_ck_1(data)                                      (0x000000FF&(data))
+#define P0_CK1_get_reg_p0_ck_4(data)                                  ((0xFF000000&(data))>>24)
+#define P0_CK1_get_reg_p0_ck_3(data)                                  ((0x00FF0000&(data))>>16)
+#define P0_CK1_get_reg_p0_ck_2(data)                                  ((0x0000FF00&(data))>>8)
+#define P0_CK1_get_reg_p0_ck_1(data)                                  (0x000000FF&(data))
+#define p0_ck_3_CMU_PREDIVN                            (_BIT20|_BIT21|_BIT22|_BIT23)
+#define p0_ck_3_CMU_N_code                             (_BIT18|_BIT19)
+#define p0_ck_3_CMU_SEL_D4                             (_BIT16)
+#define p0_ck_2_CMU_CKIN_SEL                           (_BIT15)
+#define p0_ck_2_ACDR_CBUS_REF                          (_BIT13|_BIT14)
+#define p0_ck_2_CK_MD_DET_SEL                          (_BIT12)
+#define p0_CMU_CKOUT_SEL                               (_BIT11)
+#define p0_CMU_CKAFE_ENHANCE_BIAS                      (_BIT10)
+#define p0_ck_2_CK_MD_REF_SEL                          (_BIT9)
+#define p0_CK_2_CKD2S_EN0                              (_BIT8)
+#define p0_ck_1_port_bias                              (_BIT2)
+#define p0_ck_1_CKAFE_POW                              (_BIT1)
+
+
+#define P0_CK2                                                        0xa54
+#define P0_CK2_reg_addr                                               "0x98034a54"
+#define P0_CK2_reg                                                    0x98034a54
+#define P0_CK2_inst_addr                                              "0x0295"
+#define P0_CK2_inst                                                   0x0295
+#define P0_CK2_reg_p0_ck_8_shift                                      (24)
+#define P0_CK2_reg_p0_ck_7_shift                                      (16)
+#define P0_CK2_reg_p0_ck_6_shift                                      (8)
+#define P0_CK2_reg_p0_ck_5_shift                                      (0)
+#define P0_CK2_reg_p0_ck_8_mask                                       (0xFF000000)
+#define P0_CK2_reg_p0_ck_7_mask                                       (0x00FF0000)
+#define P0_CK2_reg_p0_ck_6_mask                                       (0x0000FF00)
+#define P0_CK2_reg_p0_ck_5_mask                                       (0x000000FF)
+#define P0_CK2_reg_p0_ck_8(data)                                      (0xFF000000&((data)<<24))
+#define P0_CK2_reg_p0_ck_7(data)                                      (0x00FF0000&((data)<<16))
+#define P0_CK2_reg_p0_ck_6(data)                                      (0x0000FF00&((data)<<8))
+#define P0_CK2_reg_p0_ck_5(data)                                      (0x000000FF&(data))
+#define P0_CK2_get_reg_p0_ck_8(data)                                  ((0xFF000000&(data))>>24)
+#define P0_CK2_get_reg_p0_ck_7(data)                                  ((0x00FF0000&(data))>>16)
+#define P0_CK2_get_reg_p0_ck_6(data)                                  ((0x0000FF00&(data))>>8)
+#define P0_CK2_get_reg_p0_ck_5(data)                                  (0x000000FF&(data))
+#define P0_VSEL_LDO(data)                              (0xE0000000&((data)<<29))
+#define P0_CCO_BAND_SEL(data)                          (0x1C000000&((data)<<26))
+#define P0_CMU_BPPSR(data)                             (0x01000000&((data)<<24))
+#define P0_CMU_SEL_CS(data)                            (0x00000700&((data)<<8))
+#define P0_CMU_SEL_PUMP_I(data)                        (0x000000F0&((data)<<4))
+#define P0_CMU_SEL_R1(data)                            (0x00000007&((data)<<0))
+#define P0_get_CMU_BPPSR(data)                         ((0x01000000&(data))>>24)
+#define P0_ck_8_VSEL_LDO_A_mask                        (_BIT29|_BIT30|_BIT31)
+#define P0_ck_8_CCO_BAND_SEL_mask                      (_BIT26|_BIT27|_BIT28)
+#define P0_ck_8_LDO_EN_mask                            (_BIT25)
+#define P0_ck_8_CMU_BPPSR_mask                         (_BIT24)
+#define P0_ck_8_CMU_SEL_CP_mask                        (_BIT20|_BIT21)
+#define P0_ck_7_CMU_BYPASS_PI_mask                     (_BIT19)
+#define P0_ck_7_CMU_PI_I_SEL_mask                      (_BIT16|_BIT17|_BIT18)
+#define p0_ck_6_KVCO_ENHANCE                           (_BIT26)
+#define P0_ck_6_CMU_BIG_KVCO_mask                      (_BIT13)
+#define P0_ck_6_CMU_EN_CAP_mask                        (_BIT12)
+#define P0_ck_6_CMU_SEL_CS_mask                        (_BIT8|_BIT9|_BIT10)
+#define P0_ck_5_CMU_SEL_PUMP_I_mask                    (_BIT4|_BIT5|_BIT6|_BIT7)
+#define P0_ck_5_CMU_SEL_PUMP_DB_mask                   (_BIT3)
+#define P0_ck_5_CMU_SEL_R1_mask                        (_BIT0|_BIT1|_BIT2)
+
+
+#define P0_CK3                                                        0xa58
+#define P0_CK3_reg_addr                                               "0x98034a58"
+#define P0_CK3_reg                                                    0x98034a58
+#define P0_CK3_inst_addr                                              "0x0296"
+#define P0_CK3_inst                                                   0x0296
+#define P0_CK3_reg_p0_ck_12_shift                                     (24)
+#define P0_CK3_reg_p0_ck_11_shift                                     (16)
+#define P0_CK3_reg_p0_ck_10_shift                                     (8)
+#define P0_CK3_reg_p0_ck_9_shift                                      (0)
+#define P0_CK3_reg_p0_ck_12_mask                                      (0xFF000000)
+#define P0_CK3_reg_p0_ck_11_mask                                      (0x00FF0000)
+#define P0_CK3_reg_p0_ck_10_mask                                      (0x0000FF00)
+#define P0_CK3_reg_p0_ck_9_mask                                       (0x000000FF)
+#define P0_CK3_reg_p0_ck_12(data)                                     (0xFF000000&((data)<<24))
+#define P0_CK3_reg_p0_ck_11(data)                                     (0x00FF0000&((data)<<16))
+#define P0_CK3_reg_p0_ck_10(data)                                     (0x0000FF00&((data)<<8))
+#define P0_CK3_reg_p0_ck_9(data)                                      (0x000000FF&(data))
+#define P0_CK3_get_reg_p0_ck_12(data)                                 ((0xFF000000&(data))>>24)
+#define P0_CK3_get_reg_p0_ck_11(data)                                 ((0x00FF0000&(data))>>16)
+#define P0_CK3_get_reg_p0_ck_10(data)                                 ((0x0000FF00&(data))>>8)
+#define P0_CK3_get_reg_p0_ck_9(data)                                  (0x000000FF&(data))
+#define P0_ck_9_CMU_PFD_RSTB                           (_BIT5)
+#define P0_ck_9_CMU_WDRST                              (_BIT2)
+
+
+#define P0_CK4                                                        0xa5c
+#define P0_CK4_reg_addr                                               "0x98034a5c"
+#define P0_CK4_reg                                                    0x98034a5c
+#define P0_CK4_inst_addr                                              "0x0297"
+#define P0_CK4_inst                                                   0x0297
+#define P0_CK4_reg_p0_ck_13_shift                                     (0)
+#define P0_CK4_reg_p0_ck_13_mask                                      (0x000000FF)
+#define P0_CK4_reg_p0_ck_13(data)                                     (0x000000FF&(data))
+#define P0_CK4_get_reg_p0_ck_13(data)                                 (0x000000FF&(data))
+
+
+#define P0_G1                                                         0xa60
+#define P0_G1_reg_addr                                                "0x98034a60"
+#define P0_G1_reg                                                     0x98034a60
+#define P0_G1_inst_addr                                               "0x0298"
+#define P0_G1_inst                                                    0x0298
+#define P0_G1_reg_p0_g_4_shift                                        (24)
+#define P0_G1_reg_p0_g_3_shift                                        (16)
+#define P0_G1_reg_p0_g_2_shift                                        (8)
+#define P0_G1_reg_p0_g_1_shift                                        (0)
+#define P0_G1_reg_p0_g_4_mask                                         (0xFF000000)
+#define P0_G1_reg_p0_g_3_mask                                         (0x00FF0000)
+#define P0_G1_reg_p0_g_2_mask                                         (0x0000FF00)
+#define P0_G1_reg_p0_g_1_mask                                         (0x000000FF)
+#define P0_G1_reg_p0_g_4(data)                                        (0xFF000000&((data)<<24))
+#define P0_G1_reg_p0_g_3(data)                                        (0x00FF0000&((data)<<16))
+#define P0_G1_reg_p0_g_2(data)                                        (0x0000FF00&((data)<<8))
+#define P0_G1_reg_p0_g_1(data)                                        (0x000000FF&(data))
+#define P0_G1_get_reg_p0_g_4(data)                                    ((0xFF000000&(data))>>24)
+#define P0_G1_get_reg_p0_g_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_G1_get_reg_p0_g_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_G1_get_reg_p0_g_1(data)                                    (0x000000FF&(data))
+#define P0_g_4_FORE_KOFF_AUTOK                         (_BIT28)
+#define P0_g_CLK_PIX2_RATE_SEL                         (_BIT26)
+#define P0_g_DEMUX_BBPD_RSTB                           (_BIT25)
+#define P0_g_4_FORE_POW_FORE_KOFF                      (_BIT24)
+#define P0_g_3_FORE_EN_FORE_KOFF                       (_BIT23)
+#define P0_g_1_FORE_KOFF_RANGE                         (_BIT22|_BIT21)
+#define P0_g_1_inputoff_p                              (_BIT2)
+#define P0_g_1_inputoff_n                              (_BIT1)
+#define P0_g_1_inputoff                                (_BIT0)
+#define P0_g_1_FORE_KOFF_ADJR                          (_BIT16|_BIT17|_BIT18|_BIT19|_BIT20)
+#define P0_g_2_LEQ_BIT_RATE_mask                       (_BIT8|_BIT9)
+#define P0_g_2_LEQ_BIT_RATE_MBR                        (_BIT8)
+#define P0_g_2_LEQ_BIT_RATE_HBR                        (_BIT9)
+#define P1_g_2_LEQ_BIT_RATE_mask                       (_BIT8|_BIT9)
+#define P1_g_2_LEQ_BIT_RATE_MBR                        (_BIT8)
+#define P1_g_2_LEQ_BIT_RATE_HBR                        (_BIT9)
+#define P2_g_2_LEQ_BIT_RATE_mask                       (_BIT8|_BIT9)
+#define P2_g_2_LEQ_BIT_RATE_MBR                        (_BIT8)
+#define P2_g_2_LEQ_BIT_RATE_HBR                        (_BIT9)
+
+
+#define P0_G2                                                         0xa64
+#define P0_G2_reg_addr                                                "0x98034a64"
+#define P0_G2_reg                                                     0x98034a64
+#define P0_G2_inst_addr                                               "0x0299"
+#define P0_G2_inst                                                    0x0299
+#define P0_G2_reg_p0_g_8_shift                                        (24)
+#define P0_G2_reg_p0_g_7_shift                                        (16)
+#define P0_G2_reg_p0_g_6_shift                                        (8)
+#define P0_G2_reg_p0_g_5_shift                                        (0)
+#define P0_G2_reg_p0_g_8_mask                                         (0xFF000000)
+#define P0_G2_reg_p0_g_7_mask                                         (0x00FF0000)
+#define P0_G2_reg_p0_g_6_mask                                         (0x0000FF00)
+#define P0_G2_reg_p0_g_5_mask                                         (0x000000FF)
+#define P0_G2_reg_p0_g_8(data)                                        (0xFF000000&((data)<<24))
+#define P0_G2_reg_p0_g_7(data)                                        (0x00FF0000&((data)<<16))
+#define P0_G2_reg_p0_g_6(data)                                        (0x0000FF00&((data)<<8))
+#define P0_G2_reg_p0_g_5(data)                                        (0x000000FF&(data))
+#define P0_G2_get_reg_p0_g_8(data)                                    ((0xFF000000&(data))>>24)
+#define P0_G2_get_reg_p0_g_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_G2_get_reg_p0_g_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_G2_get_reg_p0_g_5(data)                                    (0x000000FF&(data))
+#define P0_g_8_DEMUX                                   (_BIT29|_BIT30|_BIT31)
+#define P0_g_8_PR_RATE_SEL                             (_BIT26|_BIT27|_BIT28)
+#define P0_g_8_POW_PR                                  (_BIT25)
+#define P0_g_8_BY_PASS_PR                              (_BIT24)
+#define P0_g_7_TAP0_ISEL                               (_BIT21|_BIT22|_BIT23)
+#define P0_g_7_TAP0_ISEL_400uA                         (_BIT22|_BIT23)
+#define P0_g_7_LEQ_ISEL                                (_BIT18|_BIT19|_BIT20)
+#define P0_g_7_LEQ_ISEL_400uA                          (_BIT19|_BIT20)
+#define P0_g_7_LEQ_ISEL_200uA                          (_BIT20)
+#define P0_g_7_PI_ISEL                                 (_BIT16|_BIT17)
+#define P0_g_6_LEQ_BIT_RATE                            (_BIT14|_BIT15)
+#define P0_g_6_LEQ_BIT_RATE_HBR                        (_BIT15)
+#define P0_g_6_LEQ_BIT_RATE_MBR                        (_BIT14)
+#define P0_g_6_TAP0_HBR                                (_BIT13)
+#define P0_g_6_LEQ_PASSIVE_CORNER                      (_BIT12|_BIT11)
+#define P0_g_5_LEQ_CURRENT_ADJ                         (_BIT3|_BIT4)
+#define P0_g_5_LEQ_CURRENT_ADJ_1X                      (_BIT3)
+#define P0_g_5_LEQ_CURRENT_ADJ_1p25X                   (_BIT4)
+#define P0_g_5_EQ_POW                                  (_BIT0)
+
+
+#define P0_G3                                                         0xa68
+#define P0_G3_reg_addr                                                "0x98034a68"
+#define P0_G3_reg                                                     0x98034a68
+#define P0_G3_inst_addr                                               "0x029A"
+#define P0_G3_inst                                                    0x029A
+#define P0_G3_reg_p0_g_12_shift                                       (24)
+#define P0_G3_reg_p0_g_11_shift                                       (16)
+#define P0_G3_reg_p0_g_10_shift                                       (8)
+#define P0_G3_reg_p0_g_9_shift                                        (0)
+#define P0_G3_reg_p0_g_12_mask                                        (0xFF000000)
+#define P0_G3_reg_p0_g_11_mask                                        (0x00FF0000)
+#define P0_G3_reg_p0_g_10_mask                                        (0x0000FF00)
+#define P0_G3_reg_p0_g_9_mask                                         (0x000000FF)
+#define P0_G3_reg_p0_g_12(data)                                       (0xFF000000&((data)<<24))
+#define P0_G3_reg_p0_g_11(data)                                       (0x00FF0000&((data)<<16))
+#define P0_G3_reg_p0_g_10(data)                                       (0x0000FF00&((data)<<8))
+#define P0_G3_reg_p0_g_9(data)                                        (0x000000FF&(data))
+#define P0_G3_get_reg_p0_g_12(data)                                   ((0xFF000000&(data))>>24)
+#define P0_G3_get_reg_p0_g_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P0_G3_get_reg_p0_g_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P0_G3_get_reg_p0_g_9(data)                                    (0x000000FF&(data))
+#define P0_G_DFE_TAPEN4321                             (_BIT6|_BIT5|_BIT4|_BIT3)
+#define P0_g_12_PI_CURRENT                             (_BIT28)
+#define P0_g_12_PI_CSEL                                (_BIT24|_BIT25)
+#define P0_g_9_DFE_ADAPTION_POW_EN                     (_BIT7)
+#define P0_g_9_DFE_TAP_EN                              (_BIT3|_BIT4|_BIT5|_BIT6)
+#define P0_g_9_DFE_TAP1_EN                             (_BIT3)
+#define  P0_g_tap_en(data)                             (0x00000078&((data)<<3))
+#define P0_g_11_ACDR_RATE_SEL_HALF_RATE                (_BIT16)
+#define P0_g_10_DFE_SUMAMP_LP_MANUALOFF                (_BIT15)
+#define P0_g_10_DFE_SUMAMP_ISEL_mask                   (_BIT11|_BIT12|_BIT13)
+#define P0_g_10_DFE_SUMAMP_ISEL_400uA                  (_BIT13)
+#define P0_g_10_DFE_PREAMP_ISEL_mask                   (_BIT8|_BIT9|_BIT10)
+#define P0_g_10_DFE_PREAMP_ISEL_400uA                  (_BIT10)
+
+
+#define P0_G4                                                         0xa6c
+#define P0_G4_reg_addr                                                "0x98034a6c"
+#define P0_G4_reg                                                     0x98034a6c
+#define P0_G4_inst_addr                                               "0x029B"
+#define P0_G4_inst                                                    0x029B
+#define P0_G4_reg_p0_g_koff_sel_shift                                 (10)
+#define P0_G4_reg_p0_g_koff_bound_shift                               (9)
+#define P0_G4_reg_p0_g_koffok_shift                                   (8)
+#define P0_G4_reg_p0_g_13_shift                                       (0)
+#define P0_G4_reg_p0_g_koff_sel_mask                                  (0x00007C00)
+#define P0_G4_reg_p0_g_koff_bound_mask                                (0x00000200)
+#define P0_G4_reg_p0_g_koffok_mask                                    (0x00000100)
+#define P0_G4_reg_p0_g_13_mask                                        (0x000000FF)
+#define P0_G4_reg_p0_g_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P0_G4_reg_p0_g_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P0_G4_reg_p0_g_koffok(data)                                   (0x00000100&((data)<<8))
+#define P0_G4_reg_p0_g_13(data)                                       (0x000000FF&(data))
+#define P0_G4_get_reg_p0_g_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P0_G4_get_reg_p0_g_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P0_G4_get_reg_p0_g_koffok(data)                               ((0x00000100&(data))>>8)
+#define P0_G4_get_reg_p0_g_13(data)                                   (0x000000FF&(data))
+
+
+#define P0_R1                                                         0xa70
+#define P0_R1_reg_addr                                                "0x98034a70"
+#define P0_R1_reg                                                     0x98034a70
+#define P0_R1_inst_addr                                               "0x029C"
+#define P0_R1_inst                                                    0x029C
+#define P0_R1_reg_p0_r_4_shift                                        (24)
+#define P0_R1_reg_p0_r_3_shift                                        (16)
+#define P0_R1_reg_p0_r_2_shift                                        (8)
+#define P0_R1_reg_p0_r_1_shift                                        (0)
+#define P0_R1_reg_p0_r_4_mask                                         (0xFF000000)
+#define P0_R1_reg_p0_r_3_mask                                         (0x00FF0000)
+#define P0_R1_reg_p0_r_2_mask                                         (0x0000FF00)
+#define P0_R1_reg_p0_r_1_mask                                         (0x000000FF)
+#define P0_R1_reg_p0_r_4(data)                                        (0xFF000000&((data)<<24))
+#define P0_R1_reg_p0_r_3(data)                                        (0x00FF0000&((data)<<16))
+#define P0_R1_reg_p0_r_2(data)                                        (0x0000FF00&((data)<<8))
+#define P0_R1_reg_p0_r_1(data)                                        (0x000000FF&(data))
+#define P0_R1_get_reg_p0_r_4(data)                                    ((0xFF000000&(data))>>24)
+#define P0_R1_get_reg_p0_r_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_R1_get_reg_p0_r_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_R1_get_reg_p0_r_1(data)                                    (0x000000FF&(data))
+#define P0_r_4_FORE_KOFF_AUTOK                         (_BIT28)
+#define P0_r_CLK_PIX2_RATE_SEL                         (_BIT26)
+#define P0_r_DEMUX_BBPD_RSTB                           (_BIT25)
+#define P0_r_4_FORE_POW_FORE_KOFF                      (_BIT24)
+#define P0_r_3_FORE_EN_FORE_KOFF                       (_BIT23)
+#define P0_r_1_FORE_KOFF_RANGE                         (_BIT22|_BIT21)
+#define P0_r_1_inputoff                                (_BIT0)
+#define P0_r_1_inputoff_n                              (_BIT1)
+#define P0_r_1_inputoff_p                              (_BIT2)
+#define P0_r_1_FORE_KOFF_ADJR                          (_BIT16|_BIT17|_BIT18|_BIT19|_BIT20)
+#define P0_r_2_LEQ_BIT_RATE_mask                       (_BIT8|_BIT9)
+#define P0_r_2_LEQ_BIT_RATE_MBR                        (_BIT8)
+#define P0_r_2_LEQ_BIT_RATE_HBR                        (_BIT9)
+#define P1_r_2_LEQ_BIT_RATE_mask                       (_BIT8|_BIT9)
+#define P1_r_2_LEQ_BIT_RATE_MBR                        (_BIT8)
+#define P1_r_2_LEQ_BIT_RATE_HBR                        (_BIT9)
+#define P2_r_2_LEQ_BIT_RATE_mask                       (_BIT8|_BIT9)
+#define P2_r_2_LEQ_BIT_RATE_MBR                        (_BIT8)
+#define P2_r_2_LEQ_BIT_RATE_HBR                        (_BIT9)
+
+
+#define P0_R2                                                         0xa74
+#define P0_R2_reg_addr                                                "0x98034a74"
+#define P0_R2_reg                                                     0x98034a74
+#define P0_R2_inst_addr                                               "0x029D"
+#define P0_R2_inst                                                    0x029D
+#define P0_R2_reg_p0_r_8_shift                                        (24)
+#define P0_R2_reg_p0_r_7_shift                                        (16)
+#define P0_R2_reg_p0_r_6_shift                                        (8)
+#define P0_R2_reg_p0_r_5_shift                                        (0)
+#define P0_R2_reg_p0_r_8_mask                                         (0xFF000000)
+#define P0_R2_reg_p0_r_7_mask                                         (0x00FF0000)
+#define P0_R2_reg_p0_r_6_mask                                         (0x0000FF00)
+#define P0_R2_reg_p0_r_5_mask                                         (0x000000FF)
+#define P0_R2_reg_p0_r_8(data)                                        (0xFF000000&((data)<<24))
+#define P0_R2_reg_p0_r_7(data)                                        (0x00FF0000&((data)<<16))
+#define P0_R2_reg_p0_r_6(data)                                        (0x0000FF00&((data)<<8))
+#define P0_R2_reg_p0_r_5(data)                                        (0x000000FF&(data))
+#define P0_R2_get_reg_p0_r_8(data)                                    ((0xFF000000&(data))>>24)
+#define P0_R2_get_reg_p0_r_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P0_R2_get_reg_p0_r_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P0_R2_get_reg_p0_r_5(data)                                    (0x000000FF&(data))
+#define P0_r_8_DEMUX                                   (_BIT29|_BIT30|_BIT31)
+#define P0_r_8_PR_RATE_SEL                             (_BIT26|_BIT27|_BIT28)
+#define P0_r_8_POW_PR                                  (_BIT25)
+#define P0_r_8_BY_PASS_PR                              (_BIT24)
+#define P0_r_7_TAP0_ISEL                               (_BIT21|_BIT22|_BIT23)
+#define P0_r_7_TAP0_ISEL_400uA                         (_BIT22|_BIT23)
+#define P0_r_7_LEQ_ISEL                                (_BIT18|_BIT19|_BIT20)
+#define P0_r_7_LEQ_ISEL_400uA                          (_BIT19|_BIT20)
+#define P0_r_7_LEQ_ISEL_200uA                          (_BIT20)
+#define P0_r_7_PI_ISEL                                 (_BIT16|_BIT17)
+#define P0_r_6_LEQ_BIT_RATE                            (_BIT14|_BIT15)
+#define P0_r_6_LEQ_BIT_RATE_HBR                        (_BIT15)
+#define P0_r_6_LEQ_BIT_RATE_MBR                        (_BIT14)
+#define P0_r_6_TAP0_HBR                                (_BIT13)
+#define P0_r_6_LEQ_PASSIVE_CORNER                      (_BIT12|_BIT11)
+#define P0_r_5_LEQ_CURRENT_ADJ                         (_BIT3|_BIT4)
+#define P0_r_5_LEQ_CURRENT_ADJ_1X                      (_BIT3)
+#define P0_r_5_LEQ_CURRENT_ADJ_1p25X                   (_BIT4)
+#define P0_r_5_EQ_POW                                  (_BIT0)
+
+
+#define P0_R3                                                         0xa78
+#define P0_R3_reg_addr                                                "0x98034a78"
+#define P0_R3_reg                                                     0x98034a78
+#define P0_R3_inst_addr                                               "0x029E"
+#define P0_R3_inst                                                    0x029E
+#define P0_R3_reg_p0_r_12_shift                                       (24)
+#define P0_R3_reg_p0_r_11_shift                                       (16)
+#define P0_R3_reg_p0_r_10_shift                                       (8)
+#define P0_R3_reg_p0_r_9_shift                                        (0)
+#define P0_R3_reg_p0_r_12_mask                                        (0xFF000000)
+#define P0_R3_reg_p0_r_11_mask                                        (0x00FF0000)
+#define P0_R3_reg_p0_r_10_mask                                        (0x0000FF00)
+#define P0_R3_reg_p0_r_9_mask                                         (0x000000FF)
+#define P0_R3_reg_p0_r_12(data)                                       (0xFF000000&((data)<<24))
+#define P0_R3_reg_p0_r_11(data)                                       (0x00FF0000&((data)<<16))
+#define P0_R3_reg_p0_r_10(data)                                       (0x0000FF00&((data)<<8))
+#define P0_R3_reg_p0_r_9(data)                                        (0x000000FF&(data))
+#define P0_R3_get_reg_p0_r_12(data)                                   ((0xFF000000&(data))>>24)
+#define P0_R3_get_reg_p0_r_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P0_R3_get_reg_p0_r_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P0_R3_get_reg_p0_r_9(data)                                    (0x000000FF&(data))
+#define P0_R_DFE_TAPEN4321                             (_BIT6|_BIT5|_BIT4|_BIT3)
+#define P0_r_12_PI_CURRENT                             (_BIT28)
+#define P0_r_12_PI_CSEL                                (_BIT24|_BIT25)
+#define P0_r_9_DFE_ADAPTION_POW_EN                     (_BIT7)
+#define P0_r_9_DFE_TAP_EN                              (_BIT3|_BIT4|_BIT5|_BIT6)
+#define P0_r_9_DFE_TAP1_EN                             (_BIT3)
+#define P0_r_tap_en(data)                              (0x00000078&((data)<<3))
+#define P0_r_11_ACDR_RATE_SEL                          (_BIT24|_BIT25)
+#define P0_r_11_ACDR_RATE_SEL_HALF_RATE                (_BIT16)
+#define P0_r_10_DFE_SUMAMP_LP_MANUALOFF                (_BIT15)
+#define P0_r_10_DFE_SUMAMP_ISEL_mask                   (_BIT11|_BIT12|_BIT13)
+#define P0_r_10_DFE_SUMAMP_ISEL_400uA                  (_BIT13)
+#define P0_r_10_DFE_PREAMP_ISEL_mask                   (_BIT8|_BIT9|_BIT10)
+#define P0_r_10_DFE_PREAMP_ISEL_400uA                  (_BIT10)
+
+
+#define P0_R4                                                         0xa7c
+#define P0_R4_reg_addr                                                "0x98034a7c"
+#define P0_R4_reg                                                     0x98034a7c
+#define P0_R4_inst_addr                                               "0x029F"
+#define P0_R4_inst                                                    0x029F
+#define P0_R4_reg_p0_r_koff_sel_shift                                 (10)
+#define P0_R4_reg_p0_r_koff_bound_shift                               (9)
+#define P0_R4_reg_p0_r_koffok_shift                                   (8)
+#define P0_R4_reg_p0_r_13_shift                                       (0)
+#define P0_R4_reg_p0_r_koff_sel_mask                                  (0x00007C00)
+#define P0_R4_reg_p0_r_koff_bound_mask                                (0x00000200)
+#define P0_R4_reg_p0_r_koffok_mask                                    (0x00000100)
+#define P0_R4_reg_p0_r_13_mask                                        (0x000000FF)
+#define P0_R4_reg_p0_r_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P0_R4_reg_p0_r_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P0_R4_reg_p0_r_koffok(data)                                   (0x00000100&((data)<<8))
+#define P0_R4_reg_p0_r_13(data)                                       (0x000000FF&(data))
+#define P0_R4_get_reg_p0_r_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P0_R4_get_reg_p0_r_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P0_R4_get_reg_p0_r_koffok(data)                               ((0x00000100&(data))>>8)
+#define P0_R4_get_reg_p0_r_13(data)                                   (0x000000FF&(data))
+
+
+#define P1_ACDR1                                                      0xa80
+#define P1_ACDR1_reg_addr                                             "0x98034a80"
+#define P1_ACDR1_reg                                                  0x98034a80
+#define P1_ACDR1_inst_addr                                            "0x02A0"
+#define P1_ACDR1_inst                                                 0x02A0
+#define P1_ACDR1_reg_p1_acdr_4_shift                                  (24)
+#define P1_ACDR1_reg_p1_acdr_3_shift                                  (16)
+#define P1_ACDR1_reg_p1_acdr_2_shift                                  (8)
+#define P1_ACDR1_reg_p1_acdr_1_shift                                  (0)
+#define P1_ACDR1_reg_p1_acdr_4_mask                                   (0xFF000000)
+#define P1_ACDR1_reg_p1_acdr_3_mask                                   (0x00FF0000)
+#define P1_ACDR1_reg_p1_acdr_2_mask                                   (0x0000FF00)
+#define P1_ACDR1_reg_p1_acdr_1_mask                                   (0x000000FF)
+#define P1_ACDR1_reg_p1_acdr_4(data)                                  (0xFF000000&((data)<<24))
+#define P1_ACDR1_reg_p1_acdr_3(data)                                  (0x00FF0000&((data)<<16))
+#define P1_ACDR1_reg_p1_acdr_2(data)                                  (0x0000FF00&((data)<<8))
+#define P1_ACDR1_reg_p1_acdr_1(data)                                  (0x000000FF&(data))
+#define P1_ACDR1_get_reg_p1_acdr_4(data)                              ((0xFF000000&(data))>>24)
+#define P1_ACDR1_get_reg_p1_acdr_3(data)                              ((0x00FF0000&(data))>>16)
+#define P1_ACDR1_get_reg_p1_acdr_2(data)                              ((0x0000FF00&(data))>>8)
+#define P1_ACDR1_get_reg_p1_acdr_1(data)                              (0x000000FF&(data))
+
+
+#define P1_ACDR2                                                      0xa84
+#define P1_ACDR2_reg_addr                                             "0x98034a84"
+#define P1_ACDR2_reg                                                  0x98034a84
+#define P1_ACDR2_inst_addr                                            "0x02A1"
+#define P1_ACDR2_inst                                                 0x02A1
+#define P1_ACDR2_reg_p1_acdr_8_shift                                  (24)
+#define P1_ACDR2_reg_p1_acdr_7_shift                                  (16)
+#define P1_ACDR2_reg_p1_acdr_6_shift                                  (8)
+#define P1_ACDR2_reg_p1_acdr_5_shift                                  (0)
+#define P1_ACDR2_reg_p1_acdr_8_mask                                   (0xFF000000)
+#define P1_ACDR2_reg_p1_acdr_7_mask                                   (0x00FF0000)
+#define P1_ACDR2_reg_p1_acdr_6_mask                                   (0x0000FF00)
+#define P1_ACDR2_reg_p1_acdr_5_mask                                   (0x000000FF)
+#define P1_ACDR2_reg_p1_acdr_8(data)                                  (0xFF000000&((data)<<24))
+#define P1_ACDR2_reg_p1_acdr_7(data)                                  (0x00FF0000&((data)<<16))
+#define P1_ACDR2_reg_p1_acdr_6(data)                                  (0x0000FF00&((data)<<8))
+#define P1_ACDR2_reg_p1_acdr_5(data)                                  (0x000000FF&(data))
+#define P1_ACDR2_get_reg_p1_acdr_8(data)                              ((0xFF000000&(data))>>24)
+#define P1_ACDR2_get_reg_p1_acdr_7(data)                              ((0x00FF0000&(data))>>16)
+#define P1_ACDR2_get_reg_p1_acdr_6(data)                              ((0x0000FF00&(data))>>8)
+#define P1_ACDR2_get_reg_p1_acdr_5(data)                              (0x000000FF&(data))
+
+
+#define P1_B1                                                         0xa90
+#define P1_B1_reg_addr                                                "0x98034a90"
+#define P1_B1_reg                                                     0x98034a90
+#define P1_B1_inst_addr                                               "0x02A4"
+#define P1_B1_inst                                                    0x02A4
+#define P1_B1_reg_p1_b_4_shift                                        (24)
+#define P1_B1_reg_p1_b_3_shift                                        (16)
+#define P1_B1_reg_p1_b_2_shift                                        (8)
+#define P1_B1_reg_p1_b_1_shift                                        (0)
+#define P1_B1_reg_p1_b_4_mask                                         (0xFF000000)
+#define P1_B1_reg_p1_b_3_mask                                         (0x00FF0000)
+#define P1_B1_reg_p1_b_2_mask                                         (0x0000FF00)
+#define P1_B1_reg_p1_b_1_mask                                         (0x000000FF)
+#define P1_B1_reg_p1_b_4(data)                                        (0xFF000000&((data)<<24))
+#define P1_B1_reg_p1_b_3(data)                                        (0x00FF0000&((data)<<16))
+#define P1_B1_reg_p1_b_2(data)                                        (0x0000FF00&((data)<<8))
+#define P1_B1_reg_p1_b_1(data)                                        (0x000000FF&(data))
+#define P1_B1_get_reg_p1_b_4(data)                                    ((0xFF000000&(data))>>24)
+#define P1_B1_get_reg_p1_b_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_B1_get_reg_p1_b_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_B1_get_reg_p1_b_1(data)                                    (0x000000FF&(data))
+
+
+#define P1_B2                                                         0xa94
+#define P1_B2_reg_addr                                                "0x98034a94"
+#define P1_B2_reg                                                     0x98034a94
+#define P1_B2_inst_addr                                               "0x02A5"
+#define P1_B2_inst                                                    0x02A5
+#define P1_B2_reg_p1_b_8_shift                                        (24)
+#define P1_B2_reg_p1_b_7_shift                                        (16)
+#define P1_B2_reg_p1_b_6_shift                                        (8)
+#define P1_B2_reg_p1_b_5_shift                                        (0)
+#define P1_B2_reg_p1_b_8_mask                                         (0xFF000000)
+#define P1_B2_reg_p1_b_7_mask                                         (0x00FF0000)
+#define P1_B2_reg_p1_b_6_mask                                         (0x0000FF00)
+#define P1_B2_reg_p1_b_5_mask                                         (0x000000FF)
+#define P1_B2_reg_p1_b_8(data)                                        (0xFF000000&((data)<<24))
+#define P1_B2_reg_p1_b_7(data)                                        (0x00FF0000&((data)<<16))
+#define P1_B2_reg_p1_b_6(data)                                        (0x0000FF00&((data)<<8))
+#define P1_B2_reg_p1_b_5(data)                                        (0x000000FF&(data))
+#define P1_B2_get_reg_p1_b_8(data)                                    ((0xFF000000&(data))>>24)
+#define P1_B2_get_reg_p1_b_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_B2_get_reg_p1_b_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_B2_get_reg_p1_b_5(data)                                    (0x000000FF&(data))
+
+
+#define P1_B3                                                         0xa98
+#define P1_B3_reg_addr                                                "0x98034a98"
+#define P1_B3_reg                                                     0x98034a98
+#define P1_B3_inst_addr                                               "0x02A6"
+#define P1_B3_inst                                                    0x02A6
+#define P1_B3_reg_p1_b_12_shift                                       (24)
+#define P1_B3_reg_p1_b_11_shift                                       (16)
+#define P1_B3_reg_p1_b_10_shift                                       (8)
+#define P1_B3_reg_p1_b_9_shift                                        (0)
+#define P1_B3_reg_p1_b_12_mask                                        (0xFF000000)
+#define P1_B3_reg_p1_b_11_mask                                        (0x00FF0000)
+#define P1_B3_reg_p1_b_10_mask                                        (0x0000FF00)
+#define P1_B3_reg_p1_b_9_mask                                         (0x000000FF)
+#define P1_B3_reg_p1_b_12(data)                                       (0xFF000000&((data)<<24))
+#define P1_B3_reg_p1_b_11(data)                                       (0x00FF0000&((data)<<16))
+#define P1_B3_reg_p1_b_10(data)                                       (0x0000FF00&((data)<<8))
+#define P1_B3_reg_p1_b_9(data)                                        (0x000000FF&(data))
+#define P1_B3_get_reg_p1_b_12(data)                                   ((0xFF000000&(data))>>24)
+#define P1_B3_get_reg_p1_b_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P1_B3_get_reg_p1_b_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P1_B3_get_reg_p1_b_9(data)                                    (0x000000FF&(data))
+
+
+#define P1_B4                                                         0xa9c
+#define P1_B4_reg_addr                                                "0x98034a9c"
+#define P1_B4_reg                                                     0x98034a9c
+#define P1_B4_inst_addr                                               "0x02A7"
+#define P1_B4_inst                                                    0x02A7
+#define P1_B4_reg_p1_b_koff_sel_shift                                 (10)
+#define P1_B4_reg_p1_b_koff_bound_shift                               (9)
+#define P1_B4_reg_p1_b_koffok_shift                                   (8)
+#define P1_B4_reg_p1_b_13_shift                                       (0)
+#define P1_B4_reg_p1_b_koff_sel_mask                                  (0x00007C00)
+#define P1_B4_reg_p1_b_koff_bound_mask                                (0x00000200)
+#define P1_B4_reg_p1_b_koffok_mask                                    (0x00000100)
+#define P1_B4_reg_p1_b_13_mask                                        (0x000000FF)
+#define P1_B4_reg_p1_b_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P1_B4_reg_p1_b_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P1_B4_reg_p1_b_koffok(data)                                   (0x00000100&((data)<<8))
+#define P1_B4_reg_p1_b_13(data)                                       (0x000000FF&(data))
+#define P1_B4_get_reg_p1_b_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P1_B4_get_reg_p1_b_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P1_B4_get_reg_p1_b_koffok(data)                               ((0x00000100&(data))>>8)
+#define P1_B4_get_reg_p1_b_13(data)                                   (0x000000FF&(data))
+
+
+#define P1_CK1                                                        0xaa0
+#define P1_CK1_reg_addr                                               "0x98034aa0"
+#define P1_CK1_reg                                                    0x98034aa0
+#define P1_CK1_inst_addr                                              "0x02A8"
+#define P1_CK1_inst                                                   0x02A8
+#define P1_CK1_reg_p1_ck_4_shift                                      (24)
+#define P1_CK1_reg_p1_ck_3_shift                                      (16)
+#define P1_CK1_reg_p1_ck_2_shift                                      (8)
+#define P1_CK1_reg_p1_ck_1_shift                                      (0)
+#define P1_CK1_reg_p1_ck_4_mask                                       (0xFF000000)
+#define P1_CK1_reg_p1_ck_3_mask                                       (0x00FF0000)
+#define P1_CK1_reg_p1_ck_2_mask                                       (0x0000FF00)
+#define P1_CK1_reg_p1_ck_1_mask                                       (0x000000FF)
+#define P1_CK1_reg_p1_ck_4(data)                                      (0xFF000000&((data)<<24))
+#define P1_CK1_reg_p1_ck_3(data)                                      (0x00FF0000&((data)<<16))
+#define P1_CK1_reg_p1_ck_2(data)                                      (0x0000FF00&((data)<<8))
+#define P1_CK1_reg_p1_ck_1(data)                                      (0x000000FF&(data))
+#define P1_CK1_get_reg_p1_ck_4(data)                                  ((0xFF000000&(data))>>24)
+#define P1_CK1_get_reg_p1_ck_3(data)                                  ((0x00FF0000&(data))>>16)
+#define P1_CK1_get_reg_p1_ck_2(data)                                  ((0x0000FF00&(data))>>8)
+#define P1_CK1_get_reg_p1_ck_1(data)                                  (0x000000FF&(data))
+
+
+#define P1_CK2                                                        0xaa4
+#define P1_CK2_reg_addr                                               "0x98034aa4"
+#define P1_CK2_reg                                                    0x98034aa4
+#define P1_CK2_inst_addr                                              "0x02A9"
+#define P1_CK2_inst                                                   0x02A9
+#define P1_CK2_reg_p1_ck_8_shift                                      (24)
+#define P1_CK2_reg_p1_ck_7_shift                                      (16)
+#define P1_CK2_reg_p1_ck_6_shift                                      (8)
+#define P1_CK2_reg_p1_ck_5_shift                                      (0)
+#define P1_CK2_reg_p1_ck_8_mask                                       (0xFF000000)
+#define P1_CK2_reg_p1_ck_7_mask                                       (0x00FF0000)
+#define P1_CK2_reg_p1_ck_6_mask                                       (0x0000FF00)
+#define P1_CK2_reg_p1_ck_5_mask                                       (0x000000FF)
+#define P1_CK2_reg_p1_ck_8(data)                                      (0xFF000000&((data)<<24))
+#define P1_CK2_reg_p1_ck_7(data)                                      (0x00FF0000&((data)<<16))
+#define P1_CK2_reg_p1_ck_6(data)                                      (0x0000FF00&((data)<<8))
+#define P1_CK2_reg_p1_ck_5(data)                                      (0x000000FF&(data))
+#define P1_CK2_get_reg_p1_ck_8(data)                                  ((0xFF000000&(data))>>24)
+#define P1_CK2_get_reg_p1_ck_7(data)                                  ((0x00FF0000&(data))>>16)
+#define P1_CK2_get_reg_p1_ck_6(data)                                  ((0x0000FF00&(data))>>8)
+#define P1_CK2_get_reg_p1_ck_5(data)                                  (0x000000FF&(data))
+
+
+#define P1_CK3                                                        0xaa8
+#define P1_CK3_reg_addr                                               "0x98034aa8"
+#define P1_CK3_reg                                                    0x98034aa8
+#define P1_CK3_inst_addr                                              "0x02AA"
+#define P1_CK3_inst                                                   0x02AA
+#define P1_CK3_reg_p1_ck_12_shift                                     (24)
+#define P1_CK3_reg_p1_ck_11_shift                                     (16)
+#define P1_CK3_reg_p1_ck_10_shift                                     (8)
+#define P1_CK3_reg_p1_ck_9_shift                                      (0)
+#define P1_CK3_reg_p1_ck_12_mask                                      (0xFF000000)
+#define P1_CK3_reg_p1_ck_11_mask                                      (0x00FF0000)
+#define P1_CK3_reg_p1_ck_10_mask                                      (0x0000FF00)
+#define P1_CK3_reg_p1_ck_9_mask                                       (0x000000FF)
+#define P1_CK3_reg_p1_ck_12(data)                                     (0xFF000000&((data)<<24))
+#define P1_CK3_reg_p1_ck_11(data)                                     (0x00FF0000&((data)<<16))
+#define P1_CK3_reg_p1_ck_10(data)                                     (0x0000FF00&((data)<<8))
+#define P1_CK3_reg_p1_ck_9(data)                                      (0x000000FF&(data))
+#define P1_CK3_get_reg_p1_ck_12(data)                                 ((0xFF000000&(data))>>24)
+#define P1_CK3_get_reg_p1_ck_11(data)                                 ((0x00FF0000&(data))>>16)
+#define P1_CK3_get_reg_p1_ck_10(data)                                 ((0x0000FF00&(data))>>8)
+#define P1_CK3_get_reg_p1_ck_9(data)                                  (0x000000FF&(data))
+
+
+#define P1_CK4                                                        0xaac
+#define P1_CK4_reg_addr                                               "0x98034aac"
+#define P1_CK4_reg                                                    0x98034aac
+#define P1_CK4_inst_addr                                              "0x02AB"
+#define P1_CK4_inst                                                   0x02AB
+#define P1_CK4_reg_p1_ck_13_shift                                     (0)
+#define P1_CK4_reg_p1_ck_13_mask                                      (0x000000FF)
+#define P1_CK4_reg_p1_ck_13(data)                                     (0x000000FF&(data))
+#define P1_CK4_get_reg_p1_ck_13(data)                                 (0x000000FF&(data))
+
+
+#define P1_G1                                                         0xab0
+#define P1_G1_reg_addr                                                "0x98034ab0"
+#define P1_G1_reg                                                     0x98034ab0
+#define P1_G1_inst_addr                                               "0x02AC"
+#define P1_G1_inst                                                    0x02AC
+#define P1_G1_reg_p1_g_4_shift                                        (24)
+#define P1_G1_reg_p1_g_3_shift                                        (16)
+#define P1_G1_reg_p1_g_2_shift                                        (8)
+#define P1_G1_reg_p1_g_1_shift                                        (0)
+#define P1_G1_reg_p1_g_4_mask                                         (0xFF000000)
+#define P1_G1_reg_p1_g_3_mask                                         (0x00FF0000)
+#define P1_G1_reg_p1_g_2_mask                                         (0x0000FF00)
+#define P1_G1_reg_p1_g_1_mask                                         (0x000000FF)
+#define P1_G1_reg_p1_g_4(data)                                        (0xFF000000&((data)<<24))
+#define P1_G1_reg_p1_g_3(data)                                        (0x00FF0000&((data)<<16))
+#define P1_G1_reg_p1_g_2(data)                                        (0x0000FF00&((data)<<8))
+#define P1_G1_reg_p1_g_1(data)                                        (0x000000FF&(data))
+#define P1_G1_get_reg_p1_g_4(data)                                    ((0xFF000000&(data))>>24)
+#define P1_G1_get_reg_p1_g_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_G1_get_reg_p1_g_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_G1_get_reg_p1_g_1(data)                                    (0x000000FF&(data))
+
+
+#define P1_G2                                                         0xab4
+#define P1_G2_reg_addr                                                "0x98034ab4"
+#define P1_G2_reg                                                     0x98034ab4
+#define P1_G2_inst_addr                                               "0x02AD"
+#define P1_G2_inst                                                    0x02AD
+#define P1_G2_reg_p1_g_8_shift                                        (24)
+#define P1_G2_reg_p1_g_7_shift                                        (16)
+#define P1_G2_reg_p1_g_6_shift                                        (8)
+#define P1_G2_reg_p1_g_5_shift                                        (0)
+#define P1_G2_reg_p1_g_8_mask                                         (0xFF000000)
+#define P1_G2_reg_p1_g_7_mask                                         (0x00FF0000)
+#define P1_G2_reg_p1_g_6_mask                                         (0x0000FF00)
+#define P1_G2_reg_p1_g_5_mask                                         (0x000000FF)
+#define P1_G2_reg_p1_g_8(data)                                        (0xFF000000&((data)<<24))
+#define P1_G2_reg_p1_g_7(data)                                        (0x00FF0000&((data)<<16))
+#define P1_G2_reg_p1_g_6(data)                                        (0x0000FF00&((data)<<8))
+#define P1_G2_reg_p1_g_5(data)                                        (0x000000FF&(data))
+#define P1_G2_get_reg_p1_g_8(data)                                    ((0xFF000000&(data))>>24)
+#define P1_G2_get_reg_p1_g_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_G2_get_reg_p1_g_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_G2_get_reg_p1_g_5(data)                                    (0x000000FF&(data))
+
+
+#define P1_G3                                                         0xab8
+#define P1_G3_reg_addr                                                "0x98034ab8"
+#define P1_G3_reg                                                     0x98034ab8
+#define P1_G3_inst_addr                                               "0x02AE"
+#define P1_G3_inst                                                    0x02AE
+#define P1_G3_reg_p1_g_12_shift                                       (24)
+#define P1_G3_reg_p1_g_11_shift                                       (16)
+#define P1_G3_reg_p1_g_10_shift                                       (8)
+#define P1_G3_reg_p1_g_9_shift                                        (0)
+#define P1_G3_reg_p1_g_12_mask                                        (0xFF000000)
+#define P1_G3_reg_p1_g_11_mask                                        (0x00FF0000)
+#define P1_G3_reg_p1_g_10_mask                                        (0x0000FF00)
+#define P1_G3_reg_p1_g_9_mask                                         (0x000000FF)
+#define P1_G3_reg_p1_g_12(data)                                       (0xFF000000&((data)<<24))
+#define P1_G3_reg_p1_g_11(data)                                       (0x00FF0000&((data)<<16))
+#define P1_G3_reg_p1_g_10(data)                                       (0x0000FF00&((data)<<8))
+#define P1_G3_reg_p1_g_9(data)                                        (0x000000FF&(data))
+#define P1_G3_get_reg_p1_g_12(data)                                   ((0xFF000000&(data))>>24)
+#define P1_G3_get_reg_p1_g_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P1_G3_get_reg_p1_g_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P1_G3_get_reg_p1_g_9(data)                                    (0x000000FF&(data))
+
+
+#define P1_G4                                                         0xabc
+#define P1_G4_reg_addr                                                "0x98034abc"
+#define P1_G4_reg                                                     0x98034abc
+#define P1_G4_inst_addr                                               "0x02AF"
+#define P1_G4_inst                                                    0x02AF
+#define P1_G4_reg_p1_g_koff_sel_shift                                 (10)
+#define P1_G4_reg_p1_g_koff_bound_shift                               (9)
+#define P1_G4_reg_p1_g_koffok_shift                                   (8)
+#define P1_G4_reg_p1_g_13_shift                                       (0)
+#define P1_G4_reg_p1_g_koff_sel_mask                                  (0x00007C00)
+#define P1_G4_reg_p1_g_koff_bound_mask                                (0x00000200)
+#define P1_G4_reg_p1_g_koffok_mask                                    (0x00000100)
+#define P1_G4_reg_p1_g_13_mask                                        (0x000000FF)
+#define P1_G4_reg_p1_g_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P1_G4_reg_p1_g_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P1_G4_reg_p1_g_koffok(data)                                   (0x00000100&((data)<<8))
+#define P1_G4_reg_p1_g_13(data)                                       (0x000000FF&(data))
+#define P1_G4_get_reg_p1_g_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P1_G4_get_reg_p1_g_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P1_G4_get_reg_p1_g_koffok(data)                               ((0x00000100&(data))>>8)
+#define P1_G4_get_reg_p1_g_13(data)                                   (0x000000FF&(data))
+
+
+#define P1_R1                                                         0xac0
+#define P1_R1_reg_addr                                                "0x98034ac0"
+#define P1_R1_reg                                                     0x98034ac0
+#define P1_R1_inst_addr                                               "0x02B0"
+#define P1_R1_inst                                                    0x02B0
+#define P1_R1_reg_p1_r_4_shift                                        (24)
+#define P1_R1_reg_p1_r_3_shift                                        (16)
+#define P1_R1_reg_p1_r_2_shift                                        (8)
+#define P1_R1_reg_p1_r_1_shift                                        (0)
+#define P1_R1_reg_p1_r_4_mask                                         (0xFF000000)
+#define P1_R1_reg_p1_r_3_mask                                         (0x00FF0000)
+#define P1_R1_reg_p1_r_2_mask                                         (0x0000FF00)
+#define P1_R1_reg_p1_r_1_mask                                         (0x000000FF)
+#define P1_R1_reg_p1_r_4(data)                                        (0xFF000000&((data)<<24))
+#define P1_R1_reg_p1_r_3(data)                                        (0x00FF0000&((data)<<16))
+#define P1_R1_reg_p1_r_2(data)                                        (0x0000FF00&((data)<<8))
+#define P1_R1_reg_p1_r_1(data)                                        (0x000000FF&(data))
+#define P1_R1_get_reg_p1_r_4(data)                                    ((0xFF000000&(data))>>24)
+#define P1_R1_get_reg_p1_r_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_R1_get_reg_p1_r_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_R1_get_reg_p1_r_1(data)                                    (0x000000FF&(data))
+
+
+#define P1_R2                                                         0xac4
+#define P1_R2_reg_addr                                                "0x98034ac4"
+#define P1_R2_reg                                                     0x98034ac4
+#define P1_R2_inst_addr                                               "0x02B1"
+#define P1_R2_inst                                                    0x02B1
+#define P1_R2_reg_p1_r_8_shift                                        (24)
+#define P1_R2_reg_p1_r_7_shift                                        (16)
+#define P1_R2_reg_p1_r_6_shift                                        (8)
+#define P1_R2_reg_p1_r_5_shift                                        (0)
+#define P1_R2_reg_p1_r_8_mask                                         (0xFF000000)
+#define P1_R2_reg_p1_r_7_mask                                         (0x00FF0000)
+#define P1_R2_reg_p1_r_6_mask                                         (0x0000FF00)
+#define P1_R2_reg_p1_r_5_mask                                         (0x000000FF)
+#define P1_R2_reg_p1_r_8(data)                                        (0xFF000000&((data)<<24))
+#define P1_R2_reg_p1_r_7(data)                                        (0x00FF0000&((data)<<16))
+#define P1_R2_reg_p1_r_6(data)                                        (0x0000FF00&((data)<<8))
+#define P1_R2_reg_p1_r_5(data)                                        (0x000000FF&(data))
+#define P1_R2_get_reg_p1_r_8(data)                                    ((0xFF000000&(data))>>24)
+#define P1_R2_get_reg_p1_r_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P1_R2_get_reg_p1_r_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P1_R2_get_reg_p1_r_5(data)                                    (0x000000FF&(data))
+
+
+#define P1_R3                                                         0xac8
+#define P1_R3_reg_addr                                                "0x98034ac8"
+#define P1_R3_reg                                                     0x98034ac8
+#define P1_R3_inst_addr                                               "0x02B2"
+#define P1_R3_inst                                                    0x02B2
+#define P1_R3_reg_p1_r_12_shift                                       (24)
+#define P1_R3_reg_p1_r_11_shift                                       (16)
+#define P1_R3_reg_p1_r_10_shift                                       (8)
+#define P1_R3_reg_p1_r_9_shift                                        (0)
+#define P1_R3_reg_p1_r_12_mask                                        (0xFF000000)
+#define P1_R3_reg_p1_r_11_mask                                        (0x00FF0000)
+#define P1_R3_reg_p1_r_10_mask                                        (0x0000FF00)
+#define P1_R3_reg_p1_r_9_mask                                         (0x000000FF)
+#define P1_R3_reg_p1_r_12(data)                                       (0xFF000000&((data)<<24))
+#define P1_R3_reg_p1_r_11(data)                                       (0x00FF0000&((data)<<16))
+#define P1_R3_reg_p1_r_10(data)                                       (0x0000FF00&((data)<<8))
+#define P1_R3_reg_p1_r_9(data)                                        (0x000000FF&(data))
+#define P1_R3_get_reg_p1_r_12(data)                                   ((0xFF000000&(data))>>24)
+#define P1_R3_get_reg_p1_r_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P1_R3_get_reg_p1_r_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P1_R3_get_reg_p1_r_9(data)                                    (0x000000FF&(data))
+
+
+#define P1_R4                                                         0xacc
+#define P1_R4_reg_addr                                                "0x98034acc"
+#define P1_R4_reg                                                     0x98034acc
+#define P1_R4_inst_addr                                               "0x02B3"
+#define P1_R4_inst                                                    0x02B3
+#define P1_R4_reg_p1_r_koff_sel_shift                                 (10)
+#define P1_R4_reg_p1_r_koff_bound_shift                               (9)
+#define P1_R4_reg_p1_r_koffok_shift                                   (8)
+#define P1_R4_reg_p1_r_13_shift                                       (0)
+#define P1_R4_reg_p1_r_koff_sel_mask                                  (0x00007C00)
+#define P1_R4_reg_p1_r_koff_bound_mask                                (0x00000200)
+#define P1_R4_reg_p1_r_koffok_mask                                    (0x00000100)
+#define P1_R4_reg_p1_r_13_mask                                        (0x000000FF)
+#define P1_R4_reg_p1_r_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P1_R4_reg_p1_r_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P1_R4_reg_p1_r_koffok(data)                                   (0x00000100&((data)<<8))
+#define P1_R4_reg_p1_r_13(data)                                       (0x000000FF&(data))
+#define P1_R4_get_reg_p1_r_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P1_R4_get_reg_p1_r_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P1_R4_get_reg_p1_r_koffok(data)                               ((0x00000100&(data))>>8)
+#define P1_R4_get_reg_p1_r_13(data)                                   (0x000000FF&(data))
+
+
+#define P2_ACDR1                                                      0xad0
+#define P2_ACDR1_reg_addr                                             "0x98034ad0"
+#define P2_ACDR1_reg                                                  0x98034ad0
+#define P2_ACDR1_inst_addr                                            "0x02B4"
+#define P2_ACDR1_inst                                                 0x02B4
+#define P2_ACDR1_reg_p2_acdr_4_shift                                  (24)
+#define P2_ACDR1_reg_p2_acdr_3_shift                                  (16)
+#define P2_ACDR1_reg_p2_acdr_2_shift                                  (8)
+#define P2_ACDR1_reg_p2_acdr_1_shift                                  (0)
+#define P2_ACDR1_reg_p2_acdr_4_mask                                   (0xFF000000)
+#define P2_ACDR1_reg_p2_acdr_3_mask                                   (0x00FF0000)
+#define P2_ACDR1_reg_p2_acdr_2_mask                                   (0x0000FF00)
+#define P2_ACDR1_reg_p2_acdr_1_mask                                   (0x000000FF)
+#define P2_ACDR1_reg_p2_acdr_4(data)                                  (0xFF000000&((data)<<24))
+#define P2_ACDR1_reg_p2_acdr_3(data)                                  (0x00FF0000&((data)<<16))
+#define P2_ACDR1_reg_p2_acdr_2(data)                                  (0x0000FF00&((data)<<8))
+#define P2_ACDR1_reg_p2_acdr_1(data)                                  (0x000000FF&(data))
+#define P2_ACDR1_get_reg_p2_acdr_4(data)                              ((0xFF000000&(data))>>24)
+#define P2_ACDR1_get_reg_p2_acdr_3(data)                              ((0x00FF0000&(data))>>16)
+#define P2_ACDR1_get_reg_p2_acdr_2(data)                              ((0x0000FF00&(data))>>8)
+#define P2_ACDR1_get_reg_p2_acdr_1(data)                              (0x000000FF&(data))
+
+
+#define P2_ACDR2                                                      0xad4
+#define P2_ACDR2_reg_addr                                             "0x98034ad4"
+#define P2_ACDR2_reg                                                  0x98034ad4
+#define P2_ACDR2_inst_addr                                            "0x02B5"
+#define P2_ACDR2_inst                                                 0x02B5
+#define P2_ACDR2_reg_p2_acdr_8_shift                                  (24)
+#define P2_ACDR2_reg_p2_acdr_7_shift                                  (16)
+#define P2_ACDR2_reg_p2_acdr_6_shift                                  (8)
+#define P2_ACDR2_reg_p2_acdr_5_shift                                  (0)
+#define P2_ACDR2_reg_p2_acdr_8_mask                                   (0xFF000000)
+#define P2_ACDR2_reg_p2_acdr_7_mask                                   (0x00FF0000)
+#define P2_ACDR2_reg_p2_acdr_6_mask                                   (0x0000FF00)
+#define P2_ACDR2_reg_p2_acdr_5_mask                                   (0x000000FF)
+#define P2_ACDR2_reg_p2_acdr_8(data)                                  (0xFF000000&((data)<<24))
+#define P2_ACDR2_reg_p2_acdr_7(data)                                  (0x00FF0000&((data)<<16))
+#define P2_ACDR2_reg_p2_acdr_6(data)                                  (0x0000FF00&((data)<<8))
+#define P2_ACDR2_reg_p2_acdr_5(data)                                  (0x000000FF&(data))
+#define P2_ACDR2_get_reg_p2_acdr_8(data)                              ((0xFF000000&(data))>>24)
+#define P2_ACDR2_get_reg_p2_acdr_7(data)                              ((0x00FF0000&(data))>>16)
+#define P2_ACDR2_get_reg_p2_acdr_6(data)                              ((0x0000FF00&(data))>>8)
+#define P2_ACDR2_get_reg_p2_acdr_5(data)                              (0x000000FF&(data))
+
+
+#define P2_B1                                                         0xae0
+#define P2_B1_reg_addr                                                "0x98034ae0"
+#define P2_B1_reg                                                     0x98034ae0
+#define P2_B1_inst_addr                                               "0x02B8"
+#define P2_B1_inst                                                    0x02B8
+#define P2_B1_reg_p2_b_4_shift                                        (24)
+#define P2_B1_reg_p2_b_3_shift                                        (16)
+#define P2_B1_reg_p2_b_2_shift                                        (8)
+#define P2_B1_reg_p2_b_1_shift                                        (0)
+#define P2_B1_reg_p2_b_4_mask                                         (0xFF000000)
+#define P2_B1_reg_p2_b_3_mask                                         (0x00FF0000)
+#define P2_B1_reg_p2_b_2_mask                                         (0x0000FF00)
+#define P2_B1_reg_p2_b_1_mask                                         (0x000000FF)
+#define P2_B1_reg_p2_b_4(data)                                        (0xFF000000&((data)<<24))
+#define P2_B1_reg_p2_b_3(data)                                        (0x00FF0000&((data)<<16))
+#define P2_B1_reg_p2_b_2(data)                                        (0x0000FF00&((data)<<8))
+#define P2_B1_reg_p2_b_1(data)                                        (0x000000FF&(data))
+#define P2_B1_get_reg_p2_b_4(data)                                    ((0xFF000000&(data))>>24)
+#define P2_B1_get_reg_p2_b_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_B1_get_reg_p2_b_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_B1_get_reg_p2_b_1(data)                                    (0x000000FF&(data))
+
+
+#define P2_B2                                                         0xae4
+#define P2_B2_reg_addr                                                "0x98034ae4"
+#define P2_B2_reg                                                     0x98034ae4
+#define P2_B2_inst_addr                                               "0x02B9"
+#define P2_B2_inst                                                    0x02B9
+#define P2_B2_reg_p2_b_8_shift                                        (24)
+#define P2_B2_reg_p2_b_7_shift                                        (16)
+#define P2_B2_reg_p2_b_6_shift                                        (8)
+#define P2_B2_reg_p2_b_5_shift                                        (0)
+#define P2_B2_reg_p2_b_8_mask                                         (0xFF000000)
+#define P2_B2_reg_p2_b_7_mask                                         (0x00FF0000)
+#define P2_B2_reg_p2_b_6_mask                                         (0x0000FF00)
+#define P2_B2_reg_p2_b_5_mask                                         (0x000000FF)
+#define P2_B2_reg_p2_b_8(data)                                        (0xFF000000&((data)<<24))
+#define P2_B2_reg_p2_b_7(data)                                        (0x00FF0000&((data)<<16))
+#define P2_B2_reg_p2_b_6(data)                                        (0x0000FF00&((data)<<8))
+#define P2_B2_reg_p2_b_5(data)                                        (0x000000FF&(data))
+#define P2_B2_get_reg_p2_b_8(data)                                    ((0xFF000000&(data))>>24)
+#define P2_B2_get_reg_p2_b_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_B2_get_reg_p2_b_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_B2_get_reg_p2_b_5(data)                                    (0x000000FF&(data))
+
+
+#define P2_B3                                                         0xae8
+#define P2_B3_reg_addr                                                "0x98034ae8"
+#define P2_B3_reg                                                     0x98034ae8
+#define P2_B3_inst_addr                                               "0x02BA"
+#define P2_B3_inst                                                    0x02BA
+#define P2_B3_reg_p2_b_12_shift                                       (24)
+#define P2_B3_reg_p2_b_11_shift                                       (16)
+#define P2_B3_reg_p2_b_10_shift                                       (8)
+#define P2_B3_reg_p2_b_9_shift                                        (0)
+#define P2_B3_reg_p2_b_12_mask                                        (0xFF000000)
+#define P2_B3_reg_p2_b_11_mask                                        (0x00FF0000)
+#define P2_B3_reg_p2_b_10_mask                                        (0x0000FF00)
+#define P2_B3_reg_p2_b_9_mask                                         (0x000000FF)
+#define P2_B3_reg_p2_b_12(data)                                       (0xFF000000&((data)<<24))
+#define P2_B3_reg_p2_b_11(data)                                       (0x00FF0000&((data)<<16))
+#define P2_B3_reg_p2_b_10(data)                                       (0x0000FF00&((data)<<8))
+#define P2_B3_reg_p2_b_9(data)                                        (0x000000FF&(data))
+#define P2_B3_get_reg_p2_b_12(data)                                   ((0xFF000000&(data))>>24)
+#define P2_B3_get_reg_p2_b_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P2_B3_get_reg_p2_b_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P2_B3_get_reg_p2_b_9(data)                                    (0x000000FF&(data))
+
+
+#define P2_B4                                                         0xaec
+#define P2_B4_reg_addr                                                "0x98034aec"
+#define P2_B4_reg                                                     0x98034aec
+#define P2_B4_inst_addr                                               "0x02BB"
+#define P2_B4_inst                                                    0x02BB
+#define P2_B4_reg_p2_b_koff_sel_shift                                 (10)
+#define P2_B4_reg_p2_b_koff_bound_shift                               (9)
+#define P2_B4_reg_p2_b_koffok_shift                                   (8)
+#define P2_B4_reg_p2_b_13_shift                                       (0)
+#define P2_B4_reg_p2_b_koff_sel_mask                                  (0x00007C00)
+#define P2_B4_reg_p2_b_koff_bound_mask                                (0x00000200)
+#define P2_B4_reg_p2_b_koffok_mask                                    (0x00000100)
+#define P2_B4_reg_p2_b_13_mask                                        (0x000000FF)
+#define P2_B4_reg_p2_b_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P2_B4_reg_p2_b_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P2_B4_reg_p2_b_koffok(data)                                   (0x00000100&((data)<<8))
+#define P2_B4_reg_p2_b_13(data)                                       (0x000000FF&(data))
+#define P2_B4_get_reg_p2_b_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P2_B4_get_reg_p2_b_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P2_B4_get_reg_p2_b_koffok(data)                               ((0x00000100&(data))>>8)
+#define P2_B4_get_reg_p2_b_13(data)                                   (0x000000FF&(data))
+
+
+#define P2_CK1                                                        0xaf0
+#define P2_CK1_reg_addr                                               "0x98034af0"
+#define P2_CK1_reg                                                    0x98034af0
+#define P2_CK1_inst_addr                                              "0x02BC"
+#define P2_CK1_inst                                                   0x02BC
+#define P2_CK1_reg_p2_ck_4_shift                                      (24)
+#define P2_CK1_reg_p2_ck_3_shift                                      (16)
+#define P2_CK1_reg_p2_ck_2_shift                                      (8)
+#define P2_CK1_reg_p2_ck_1_shift                                      (0)
+#define P2_CK1_reg_p2_ck_4_mask                                       (0xFF000000)
+#define P2_CK1_reg_p2_ck_3_mask                                       (0x00FF0000)
+#define P2_CK1_reg_p2_ck_2_mask                                       (0x0000FF00)
+#define P2_CK1_reg_p2_ck_1_mask                                       (0x000000FF)
+#define P2_CK1_reg_p2_ck_4(data)                                      (0xFF000000&((data)<<24))
+#define P2_CK1_reg_p2_ck_3(data)                                      (0x00FF0000&((data)<<16))
+#define P2_CK1_reg_p2_ck_2(data)                                      (0x0000FF00&((data)<<8))
+#define P2_CK1_reg_p2_ck_1(data)                                      (0x000000FF&(data))
+#define P2_CK1_get_reg_p2_ck_4(data)                                  ((0xFF000000&(data))>>24)
+#define P2_CK1_get_reg_p2_ck_3(data)                                  ((0x00FF0000&(data))>>16)
+#define P2_CK1_get_reg_p2_ck_2(data)                                  ((0x0000FF00&(data))>>8)
+#define P2_CK1_get_reg_p2_ck_1(data)                                  (0x000000FF&(data))
+
+
+#define P2_CK2                                                        0xaf4
+#define P2_CK2_reg_addr                                               "0x98034af4"
+#define P2_CK2_reg                                                    0x98034af4
+#define P2_CK2_inst_addr                                              "0x02BD"
+#define P2_CK2_inst                                                   0x02BD
+#define P2_CK2_reg_p2_ck_8_shift                                      (24)
+#define P2_CK2_reg_p2_ck_7_shift                                      (16)
+#define P2_CK2_reg_p2_ck_6_shift                                      (8)
+#define P2_CK2_reg_p2_ck_5_shift                                      (0)
+#define P2_CK2_reg_p2_ck_8_mask                                       (0xFF000000)
+#define P2_CK2_reg_p2_ck_7_mask                                       (0x00FF0000)
+#define P2_CK2_reg_p2_ck_6_mask                                       (0x0000FF00)
+#define P2_CK2_reg_p2_ck_5_mask                                       (0x000000FF)
+#define P2_CK2_reg_p2_ck_8(data)                                      (0xFF000000&((data)<<24))
+#define P2_CK2_reg_p2_ck_7(data)                                      (0x00FF0000&((data)<<16))
+#define P2_CK2_reg_p2_ck_6(data)                                      (0x0000FF00&((data)<<8))
+#define P2_CK2_reg_p2_ck_5(data)                                      (0x000000FF&(data))
+#define P2_CK2_get_reg_p2_ck_8(data)                                  ((0xFF000000&(data))>>24)
+#define P2_CK2_get_reg_p2_ck_7(data)                                  ((0x00FF0000&(data))>>16)
+#define P2_CK2_get_reg_p2_ck_6(data)                                  ((0x0000FF00&(data))>>8)
+#define P2_CK2_get_reg_p2_ck_5(data)                                  (0x000000FF&(data))
+
+
+#define P2_CK3                                                        0xaf8
+#define P2_CK3_reg_addr                                               "0x98034af8"
+#define P2_CK3_reg                                                    0x98034af8
+#define P2_CK3_inst_addr                                              "0x02BE"
+#define P2_CK3_inst                                                   0x02BE
+#define P2_CK3_reg_p2_ck_12_shift                                     (24)
+#define P2_CK3_reg_p2_ck_11_shift                                     (16)
+#define P2_CK3_reg_p2_ck_10_shift                                     (8)
+#define P2_CK3_reg_p2_ck_9_shift                                      (0)
+#define P2_CK3_reg_p2_ck_12_mask                                      (0xFF000000)
+#define P2_CK3_reg_p2_ck_11_mask                                      (0x00FF0000)
+#define P2_CK3_reg_p2_ck_10_mask                                      (0x0000FF00)
+#define P2_CK3_reg_p2_ck_9_mask                                       (0x000000FF)
+#define P2_CK3_reg_p2_ck_12(data)                                     (0xFF000000&((data)<<24))
+#define P2_CK3_reg_p2_ck_11(data)                                     (0x00FF0000&((data)<<16))
+#define P2_CK3_reg_p2_ck_10(data)                                     (0x0000FF00&((data)<<8))
+#define P2_CK3_reg_p2_ck_9(data)                                      (0x000000FF&(data))
+#define P2_CK3_get_reg_p2_ck_12(data)                                 ((0xFF000000&(data))>>24)
+#define P2_CK3_get_reg_p2_ck_11(data)                                 ((0x00FF0000&(data))>>16)
+#define P2_CK3_get_reg_p2_ck_10(data)                                 ((0x0000FF00&(data))>>8)
+#define P2_CK3_get_reg_p2_ck_9(data)                                  (0x000000FF&(data))
+
+
+#define P2_CK4                                                        0xafc
+#define P2_CK4_reg_addr                                               "0x98034afc"
+#define P2_CK4_reg                                                    0x98034afc
+#define P2_CK4_inst_addr                                              "0x02BF"
+#define P2_CK4_inst                                                   0x02BF
+#define P2_CK4_reg_p2_ck_13_shift                                     (0)
+#define P2_CK4_reg_p2_ck_13_mask                                      (0x000000FF)
+#define P2_CK4_reg_p2_ck_13(data)                                     (0x000000FF&(data))
+#define P2_CK4_get_reg_p2_ck_13(data)                                 (0x000000FF&(data))
+
+
+#define P2_G1                                                         0xb00
+#define P2_G1_reg_addr                                                "0x98034b00"
+#define P2_G1_reg                                                     0x98034b00
+#define P2_G1_inst_addr                                               "0x02C0"
+#define P2_G1_inst                                                    0x02C0
+#define P2_G1_reg_p2_g_4_shift                                        (24)
+#define P2_G1_reg_p2_g_3_shift                                        (16)
+#define P2_G1_reg_p2_g_2_shift                                        (8)
+#define P2_G1_reg_p2_g_1_shift                                        (0)
+#define P2_G1_reg_p2_g_4_mask                                         (0xFF000000)
+#define P2_G1_reg_p2_g_3_mask                                         (0x00FF0000)
+#define P2_G1_reg_p2_g_2_mask                                         (0x0000FF00)
+#define P2_G1_reg_p2_g_1_mask                                         (0x000000FF)
+#define P2_G1_reg_p2_g_4(data)                                        (0xFF000000&((data)<<24))
+#define P2_G1_reg_p2_g_3(data)                                        (0x00FF0000&((data)<<16))
+#define P2_G1_reg_p2_g_2(data)                                        (0x0000FF00&((data)<<8))
+#define P2_G1_reg_p2_g_1(data)                                        (0x000000FF&(data))
+#define P2_G1_get_reg_p2_g_4(data)                                    ((0xFF000000&(data))>>24)
+#define P2_G1_get_reg_p2_g_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_G1_get_reg_p2_g_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_G1_get_reg_p2_g_1(data)                                    (0x000000FF&(data))
+
+
+#define P2_G2                                                         0xb04
+#define P2_G2_reg_addr                                                "0x98034b04"
+#define P2_G2_reg                                                     0x98034b04
+#define P2_G2_inst_addr                                               "0x02C1"
+#define P2_G2_inst                                                    0x02C1
+#define P2_G2_reg_p2_g_8_shift                                        (24)
+#define P2_G2_reg_p2_g_7_shift                                        (16)
+#define P2_G2_reg_p2_g_6_shift                                        (8)
+#define P2_G2_reg_p2_g_5_shift                                        (0)
+#define P2_G2_reg_p2_g_8_mask                                         (0xFF000000)
+#define P2_G2_reg_p2_g_7_mask                                         (0x00FF0000)
+#define P2_G2_reg_p2_g_6_mask                                         (0x0000FF00)
+#define P2_G2_reg_p2_g_5_mask                                         (0x000000FF)
+#define P2_G2_reg_p2_g_8(data)                                        (0xFF000000&((data)<<24))
+#define P2_G2_reg_p2_g_7(data)                                        (0x00FF0000&((data)<<16))
+#define P2_G2_reg_p2_g_6(data)                                        (0x0000FF00&((data)<<8))
+#define P2_G2_reg_p2_g_5(data)                                        (0x000000FF&(data))
+#define P2_G2_get_reg_p2_g_8(data)                                    ((0xFF000000&(data))>>24)
+#define P2_G2_get_reg_p2_g_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_G2_get_reg_p2_g_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_G2_get_reg_p2_g_5(data)                                    (0x000000FF&(data))
+
+
+#define P2_G3                                                         0xb08
+#define P2_G3_reg_addr                                                "0x98034b08"
+#define P2_G3_reg                                                     0x98034b08
+#define P2_G3_inst_addr                                               "0x02C2"
+#define P2_G3_inst                                                    0x02C2
+#define P2_G3_reg_p2_g_12_shift                                       (24)
+#define P2_G3_reg_p2_g_11_shift                                       (16)
+#define P2_G3_reg_p2_g_10_shift                                       (8)
+#define P2_G3_reg_p2_g_9_shift                                        (0)
+#define P2_G3_reg_p2_g_12_mask                                        (0xFF000000)
+#define P2_G3_reg_p2_g_11_mask                                        (0x00FF0000)
+#define P2_G3_reg_p2_g_10_mask                                        (0x0000FF00)
+#define P2_G3_reg_p2_g_9_mask                                         (0x000000FF)
+#define P2_G3_reg_p2_g_12(data)                                       (0xFF000000&((data)<<24))
+#define P2_G3_reg_p2_g_11(data)                                       (0x00FF0000&((data)<<16))
+#define P2_G3_reg_p2_g_10(data)                                       (0x0000FF00&((data)<<8))
+#define P2_G3_reg_p2_g_9(data)                                        (0x000000FF&(data))
+#define P2_G3_get_reg_p2_g_12(data)                                   ((0xFF000000&(data))>>24)
+#define P2_G3_get_reg_p2_g_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P2_G3_get_reg_p2_g_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P2_G3_get_reg_p2_g_9(data)                                    (0x000000FF&(data))
+
+
+#define P2_G4                                                         0xb0c
+#define P2_G4_reg_addr                                                "0x98034b0c"
+#define P2_G4_reg                                                     0x98034b0c
+#define P2_G4_inst_addr                                               "0x02C3"
+#define P2_G4_inst                                                    0x02C3
+#define P2_G4_reg_p2_g_koff_sel_shift                                 (10)
+#define P2_G4_reg_p2_g_koff_bound_shift                               (9)
+#define P2_G4_reg_p2_g_koffok_shift                                   (8)
+#define P2_G4_reg_p2_g_13_shift                                       (0)
+#define P2_G4_reg_p2_g_koff_sel_mask                                  (0x00007C00)
+#define P2_G4_reg_p2_g_koff_bound_mask                                (0x00000200)
+#define P2_G4_reg_p2_g_koffok_mask                                    (0x00000100)
+#define P2_G4_reg_p2_g_13_mask                                        (0x000000FF)
+#define P2_G4_reg_p2_g_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P2_G4_reg_p2_g_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P2_G4_reg_p2_g_koffok(data)                                   (0x00000100&((data)<<8))
+#define P2_G4_reg_p2_g_13(data)                                       (0x000000FF&(data))
+#define P2_G4_get_reg_p2_g_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P2_G4_get_reg_p2_g_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P2_G4_get_reg_p2_g_koffok(data)                               ((0x00000100&(data))>>8)
+#define P2_G4_get_reg_p2_g_13(data)                                   (0x000000FF&(data))
+
+
+#define P2_R1                                                         0xb10
+#define P2_R1_reg_addr                                                "0x98034b10"
+#define P2_R1_reg                                                     0x98034b10
+#define P2_R1_inst_addr                                               "0x02C4"
+#define P2_R1_inst                                                    0x02C4
+#define P2_R1_reg_p2_r_4_shift                                        (24)
+#define P2_R1_reg_p2_r_3_shift                                        (16)
+#define P2_R1_reg_p2_r_2_shift                                        (8)
+#define P2_R1_reg_p2_r_1_shift                                        (0)
+#define P2_R1_reg_p2_r_4_mask                                         (0xFF000000)
+#define P2_R1_reg_p2_r_3_mask                                         (0x00FF0000)
+#define P2_R1_reg_p2_r_2_mask                                         (0x0000FF00)
+#define P2_R1_reg_p2_r_1_mask                                         (0x000000FF)
+#define P2_R1_reg_p2_r_4(data)                                        (0xFF000000&((data)<<24))
+#define P2_R1_reg_p2_r_3(data)                                        (0x00FF0000&((data)<<16))
+#define P2_R1_reg_p2_r_2(data)                                        (0x0000FF00&((data)<<8))
+#define P2_R1_reg_p2_r_1(data)                                        (0x000000FF&(data))
+#define P2_R1_get_reg_p2_r_4(data)                                    ((0xFF000000&(data))>>24)
+#define P2_R1_get_reg_p2_r_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_R1_get_reg_p2_r_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_R1_get_reg_p2_r_1(data)                                    (0x000000FF&(data))
+
+
+#define P2_R2                                                         0xb14
+#define P2_R2_reg_addr                                                "0x98034b14"
+#define P2_R2_reg                                                     0x98034b14
+#define P2_R2_inst_addr                                               "0x02C5"
+#define P2_R2_inst                                                    0x02C5
+#define P2_R2_reg_p2_r_8_shift                                        (24)
+#define P2_R2_reg_p2_r_7_shift                                        (16)
+#define P2_R2_reg_p2_r_6_shift                                        (8)
+#define P2_R2_reg_p2_r_5_shift                                        (0)
+#define P2_R2_reg_p2_r_8_mask                                         (0xFF000000)
+#define P2_R2_reg_p2_r_7_mask                                         (0x00FF0000)
+#define P2_R2_reg_p2_r_6_mask                                         (0x0000FF00)
+#define P2_R2_reg_p2_r_5_mask                                         (0x000000FF)
+#define P2_R2_reg_p2_r_8(data)                                        (0xFF000000&((data)<<24))
+#define P2_R2_reg_p2_r_7(data)                                        (0x00FF0000&((data)<<16))
+#define P2_R2_reg_p2_r_6(data)                                        (0x0000FF00&((data)<<8))
+#define P2_R2_reg_p2_r_5(data)                                        (0x000000FF&(data))
+#define P2_R2_get_reg_p2_r_8(data)                                    ((0xFF000000&(data))>>24)
+#define P2_R2_get_reg_p2_r_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P2_R2_get_reg_p2_r_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P2_R2_get_reg_p2_r_5(data)                                    (0x000000FF&(data))
+
+
+#define P2_R3                                                         0xb18
+#define P2_R3_reg_addr                                                "0x98034b18"
+#define P2_R3_reg                                                     0x98034b18
+#define P2_R3_inst_addr                                               "0x02C6"
+#define P2_R3_inst                                                    0x02C6
+#define P2_R3_reg_p2_r_12_shift                                       (24)
+#define P2_R3_reg_p2_r_11_shift                                       (16)
+#define P2_R3_reg_p2_r_10_shift                                       (8)
+#define P2_R3_reg_p2_r_9_shift                                        (0)
+#define P2_R3_reg_p2_r_12_mask                                        (0xFF000000)
+#define P2_R3_reg_p2_r_11_mask                                        (0x00FF0000)
+#define P2_R3_reg_p2_r_10_mask                                        (0x0000FF00)
+#define P2_R3_reg_p2_r_9_mask                                         (0x000000FF)
+#define P2_R3_reg_p2_r_12(data)                                       (0xFF000000&((data)<<24))
+#define P2_R3_reg_p2_r_11(data)                                       (0x00FF0000&((data)<<16))
+#define P2_R3_reg_p2_r_10(data)                                       (0x0000FF00&((data)<<8))
+#define P2_R3_reg_p2_r_9(data)                                        (0x000000FF&(data))
+#define P2_R3_get_reg_p2_r_12(data)                                   ((0xFF000000&(data))>>24)
+#define P2_R3_get_reg_p2_r_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P2_R3_get_reg_p2_r_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P2_R3_get_reg_p2_r_9(data)                                    (0x000000FF&(data))
+
+
+#define P2_R4                                                         0xb1c
+#define P2_R4_reg_addr                                                "0x98034b1c"
+#define P2_R4_reg                                                     0x98034b1c
+#define P2_R4_inst_addr                                               "0x02C7"
+#define P2_R4_inst                                                    0x02C7
+#define P2_R4_reg_p2_r_koff_sel_shift                                 (10)
+#define P2_R4_reg_p2_r_koff_bound_shift                               (9)
+#define P2_R4_reg_p2_r_koffok_shift                                   (8)
+#define P2_R4_reg_p2_r_13_shift                                       (0)
+#define P2_R4_reg_p2_r_koff_sel_mask                                  (0x00007C00)
+#define P2_R4_reg_p2_r_koff_bound_mask                                (0x00000200)
+#define P2_R4_reg_p2_r_koffok_mask                                    (0x00000100)
+#define P2_R4_reg_p2_r_13_mask                                        (0x000000FF)
+#define P2_R4_reg_p2_r_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P2_R4_reg_p2_r_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P2_R4_reg_p2_r_koffok(data)                                   (0x00000100&((data)<<8))
+#define P2_R4_reg_p2_r_13(data)                                       (0x000000FF&(data))
+#define P2_R4_get_reg_p2_r_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P2_R4_get_reg_p2_r_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P2_R4_get_reg_p2_r_koffok(data)                               ((0x00000100&(data))>>8)
+#define P2_R4_get_reg_p2_r_13(data)                                   (0x000000FF&(data))
+
+
+#define P3_ACDR1                                                      0xb20
+#define P3_ACDR1_reg_addr                                             "0x98034b20"
+#define P3_ACDR1_reg                                                  0x98034b20
+#define P3_ACDR1_inst_addr                                            "0x02C8"
+#define P3_ACDR1_inst                                                 0x02C8
+#define P3_ACDR1_reg_p3_acdr_4_shift                                  (24)
+#define P3_ACDR1_reg_p3_acdr_3_shift                                  (16)
+#define P3_ACDR1_reg_p3_acdr_2_shift                                  (8)
+#define P3_ACDR1_reg_p3_acdr_1_shift                                  (0)
+#define P3_ACDR1_reg_p3_acdr_4_mask                                   (0xFF000000)
+#define P3_ACDR1_reg_p3_acdr_3_mask                                   (0x00FF0000)
+#define P3_ACDR1_reg_p3_acdr_2_mask                                   (0x0000FF00)
+#define P3_ACDR1_reg_p3_acdr_1_mask                                   (0x000000FF)
+#define P3_ACDR1_reg_p3_acdr_4(data)                                  (0xFF000000&((data)<<24))
+#define P3_ACDR1_reg_p3_acdr_3(data)                                  (0x00FF0000&((data)<<16))
+#define P3_ACDR1_reg_p3_acdr_2(data)                                  (0x0000FF00&((data)<<8))
+#define P3_ACDR1_reg_p3_acdr_1(data)                                  (0x000000FF&(data))
+#define P3_ACDR1_get_reg_p3_acdr_4(data)                              ((0xFF000000&(data))>>24)
+#define P3_ACDR1_get_reg_p3_acdr_3(data)                              ((0x00FF0000&(data))>>16)
+#define P3_ACDR1_get_reg_p3_acdr_2(data)                              ((0x0000FF00&(data))>>8)
+#define P3_ACDR1_get_reg_p3_acdr_1(data)                              (0x000000FF&(data))
+
+
+#define P3_ACDR2                                                      0xb24
+#define P3_ACDR2_reg_addr                                             "0x98034b24"
+#define P3_ACDR2_reg                                                  0x98034b24
+#define P3_ACDR2_inst_addr                                            "0x02C9"
+#define P3_ACDR2_inst                                                 0x02C9
+#define P3_ACDR2_reg_p3_acdr_8_shift                                  (24)
+#define P3_ACDR2_reg_p3_acdr_7_shift                                  (16)
+#define P3_ACDR2_reg_p3_acdr_6_shift                                  (8)
+#define P3_ACDR2_reg_p3_acdr_5_shift                                  (0)
+#define P3_ACDR2_reg_p3_acdr_8_mask                                   (0xFF000000)
+#define P3_ACDR2_reg_p3_acdr_7_mask                                   (0x00FF0000)
+#define P3_ACDR2_reg_p3_acdr_6_mask                                   (0x0000FF00)
+#define P3_ACDR2_reg_p3_acdr_5_mask                                   (0x000000FF)
+#define P3_ACDR2_reg_p3_acdr_8(data)                                  (0xFF000000&((data)<<24))
+#define P3_ACDR2_reg_p3_acdr_7(data)                                  (0x00FF0000&((data)<<16))
+#define P3_ACDR2_reg_p3_acdr_6(data)                                  (0x0000FF00&((data)<<8))
+#define P3_ACDR2_reg_p3_acdr_5(data)                                  (0x000000FF&(data))
+#define P3_ACDR2_get_reg_p3_acdr_8(data)                              ((0xFF000000&(data))>>24)
+#define P3_ACDR2_get_reg_p3_acdr_7(data)                              ((0x00FF0000&(data))>>16)
+#define P3_ACDR2_get_reg_p3_acdr_6(data)                              ((0x0000FF00&(data))>>8)
+#define P3_ACDR2_get_reg_p3_acdr_5(data)                              (0x000000FF&(data))
+
+
+#define P3_B1                                                         0xb30
+#define P3_B1_reg_addr                                                "0x98034b30"
+#define P3_B1_reg                                                     0x98034b30
+#define P3_B1_inst_addr                                               "0x02CC"
+#define P3_B1_inst                                                    0x02CC
+#define P3_B1_reg_p3_b_4_shift                                        (24)
+#define P3_B1_reg_p3_b_3_shift                                        (16)
+#define P3_B1_reg_p3_b_2_shift                                        (8)
+#define P3_B1_reg_p3_b_1_shift                                        (0)
+#define P3_B1_reg_p3_b_4_mask                                         (0xFF000000)
+#define P3_B1_reg_p3_b_3_mask                                         (0x00FF0000)
+#define P3_B1_reg_p3_b_2_mask                                         (0x0000FF00)
+#define P3_B1_reg_p3_b_1_mask                                         (0x000000FF)
+#define P3_B1_reg_p3_b_4(data)                                        (0xFF000000&((data)<<24))
+#define P3_B1_reg_p3_b_3(data)                                        (0x00FF0000&((data)<<16))
+#define P3_B1_reg_p3_b_2(data)                                        (0x0000FF00&((data)<<8))
+#define P3_B1_reg_p3_b_1(data)                                        (0x000000FF&(data))
+#define P3_B1_get_reg_p3_b_4(data)                                    ((0xFF000000&(data))>>24)
+#define P3_B1_get_reg_p3_b_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P3_B1_get_reg_p3_b_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P3_B1_get_reg_p3_b_1(data)                                    (0x000000FF&(data))
+
+
+#define P3_B2                                                         0xb34
+#define P3_B2_reg_addr                                                "0x98034b34"
+#define P3_B2_reg                                                     0x98034b34
+#define P3_B2_inst_addr                                               "0x02CD"
+#define P3_B2_inst                                                    0x02CD
+#define P3_B2_reg_p3_b_8_shift                                        (24)
+#define P3_B2_reg_p3_b_7_shift                                        (16)
+#define P3_B2_reg_p3_b_6_shift                                        (8)
+#define P3_B2_reg_p3_b_5_shift                                        (0)
+#define P3_B2_reg_p3_b_8_mask                                         (0xFF000000)
+#define P3_B2_reg_p3_b_7_mask                                         (0x00FF0000)
+#define P3_B2_reg_p3_b_6_mask                                         (0x0000FF00)
+#define P3_B2_reg_p3_b_5_mask                                         (0x000000FF)
+#define P3_B2_reg_p3_b_8(data)                                        (0xFF000000&((data)<<24))
+#define P3_B2_reg_p3_b_7(data)                                        (0x00FF0000&((data)<<16))
+#define P3_B2_reg_p3_b_6(data)                                        (0x0000FF00&((data)<<8))
+#define P3_B2_reg_p3_b_5(data)                                        (0x000000FF&(data))
+#define P3_B2_get_reg_p3_b_8(data)                                    ((0xFF000000&(data))>>24)
+#define P3_B2_get_reg_p3_b_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P3_B2_get_reg_p3_b_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P3_B2_get_reg_p3_b_5(data)                                    (0x000000FF&(data))
+
+
+#define P3_B3                                                         0xb38
+#define P3_B3_reg_addr                                                "0x98034b38"
+#define P3_B3_reg                                                     0x98034b38
+#define P3_B3_inst_addr                                               "0x02CE"
+#define P3_B3_inst                                                    0x02CE
+#define P3_B3_reg_p3_b_12_shift                                       (24)
+#define P3_B3_reg_p3_b_11_shift                                       (16)
+#define P3_B3_reg_p3_b_10_shift                                       (8)
+#define P3_B3_reg_p3_b_9_shift                                        (0)
+#define P3_B3_reg_p3_b_12_mask                                        (0xFF000000)
+#define P3_B3_reg_p3_b_11_mask                                        (0x00FF0000)
+#define P3_B3_reg_p3_b_10_mask                                        (0x0000FF00)
+#define P3_B3_reg_p3_b_9_mask                                         (0x000000FF)
+#define P3_B3_reg_p3_b_12(data)                                       (0xFF000000&((data)<<24))
+#define P3_B3_reg_p3_b_11(data)                                       (0x00FF0000&((data)<<16))
+#define P3_B3_reg_p3_b_10(data)                                       (0x0000FF00&((data)<<8))
+#define P3_B3_reg_p3_b_9(data)                                        (0x000000FF&(data))
+#define P3_B3_get_reg_p3_b_12(data)                                   ((0xFF000000&(data))>>24)
+#define P3_B3_get_reg_p3_b_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P3_B3_get_reg_p3_b_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P3_B3_get_reg_p3_b_9(data)                                    (0x000000FF&(data))
+
+
+#define P3_B4                                                         0xb3c
+#define P3_B4_reg_addr                                                "0x98034b3c"
+#define P3_B4_reg                                                     0x98034b3c
+#define P3_B4_inst_addr                                               "0x02CF"
+#define P3_B4_inst                                                    0x02CF
+#define P3_B4_reg_p3_b_koff_sel_shift                                 (10)
+#define P3_B4_reg_p3_b_koff_bound_shift                               (9)
+#define P3_B4_reg_p3_b_koffok_shift                                   (8)
+#define P3_B4_reg_p3_b_13_shift                                       (0)
+#define P3_B4_reg_p3_b_koff_sel_mask                                  (0x00007C00)
+#define P3_B4_reg_p3_b_koff_bound_mask                                (0x00000200)
+#define P3_B4_reg_p3_b_koffok_mask                                    (0x00000100)
+#define P3_B4_reg_p3_b_13_mask                                        (0x000000FF)
+#define P3_B4_reg_p3_b_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P3_B4_reg_p3_b_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P3_B4_reg_p3_b_koffok(data)                                   (0x00000100&((data)<<8))
+#define P3_B4_reg_p3_b_13(data)                                       (0x000000FF&(data))
+#define P3_B4_get_reg_p3_b_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P3_B4_get_reg_p3_b_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P3_B4_get_reg_p3_b_koffok(data)                               ((0x00000100&(data))>>8)
+#define P3_B4_get_reg_p3_b_13(data)                                   (0x000000FF&(data))
+
+
+#define P3_CK1                                                        0xb40
+#define P3_CK1_reg_addr                                               "0x98034b40"
+#define P3_CK1_reg                                                    0x98034b40
+#define P3_CK1_inst_addr                                              "0x02D0"
+#define P3_CK1_inst                                                   0x02D0
+#define P3_CK1_reg_p3_ck_4_shift                                      (24)
+#define P3_CK1_reg_p3_ck_3_shift                                      (16)
+#define P3_CK1_reg_p3_ck_2_shift                                      (8)
+#define P3_CK1_reg_p3_ck_1_shift                                      (0)
+#define P3_CK1_reg_p3_ck_4_mask                                       (0xFF000000)
+#define P3_CK1_reg_p3_ck_3_mask                                       (0x00FF0000)
+#define P3_CK1_reg_p3_ck_2_mask                                       (0x0000FF00)
+#define P3_CK1_reg_p3_ck_1_mask                                       (0x000000FF)
+#define P3_CK1_reg_p3_ck_4(data)                                      (0xFF000000&((data)<<24))
+#define P3_CK1_reg_p3_ck_3(data)                                      (0x00FF0000&((data)<<16))
+#define P3_CK1_reg_p3_ck_2(data)                                      (0x0000FF00&((data)<<8))
+#define P3_CK1_reg_p3_ck_1(data)                                      (0x000000FF&(data))
+#define P3_CK1_get_reg_p3_ck_4(data)                                  ((0xFF000000&(data))>>24)
+#define P3_CK1_get_reg_p3_ck_3(data)                                  ((0x00FF0000&(data))>>16)
+#define P3_CK1_get_reg_p3_ck_2(data)                                  ((0x0000FF00&(data))>>8)
+#define P3_CK1_get_reg_p3_ck_1(data)                                  (0x000000FF&(data))
+
+
+#define P3_CK2                                                        0xb44
+#define P3_CK2_reg_addr                                               "0x98034b44"
+#define P3_CK2_reg                                                    0x98034b44
+#define P3_CK2_inst_addr                                              "0x02D1"
+#define P3_CK2_inst                                                   0x02D1
+#define P3_CK2_reg_p3_ck_8_shift                                      (24)
+#define P3_CK2_reg_p3_ck_7_shift                                      (16)
+#define P3_CK2_reg_p3_ck_6_shift                                      (8)
+#define P3_CK2_reg_p3_ck_5_shift                                      (0)
+#define P3_CK2_reg_p3_ck_8_mask                                       (0xFF000000)
+#define P3_CK2_reg_p3_ck_7_mask                                       (0x00FF0000)
+#define P3_CK2_reg_p3_ck_6_mask                                       (0x0000FF00)
+#define P3_CK2_reg_p3_ck_5_mask                                       (0x000000FF)
+#define P3_CK2_reg_p3_ck_8(data)                                      (0xFF000000&((data)<<24))
+#define P3_CK2_reg_p3_ck_7(data)                                      (0x00FF0000&((data)<<16))
+#define P3_CK2_reg_p3_ck_6(data)                                      (0x0000FF00&((data)<<8))
+#define P3_CK2_reg_p3_ck_5(data)                                      (0x000000FF&(data))
+#define P3_CK2_get_reg_p3_ck_8(data)                                  ((0xFF000000&(data))>>24)
+#define P3_CK2_get_reg_p3_ck_7(data)                                  ((0x00FF0000&(data))>>16)
+#define P3_CK2_get_reg_p3_ck_6(data)                                  ((0x0000FF00&(data))>>8)
+#define P3_CK2_get_reg_p3_ck_5(data)                                  (0x000000FF&(data))
+
+
+#define P3_CK3                                                        0xb48
+#define P3_CK3_reg_addr                                               "0x98034b48"
+#define P3_CK3_reg                                                    0x98034b48
+#define P3_CK3_inst_addr                                              "0x02D2"
+#define P3_CK3_inst                                                   0x02D2
+#define P3_CK3_reg_p3_ck_12_shift                                     (24)
+#define P3_CK3_reg_p3_ck_11_shift                                     (16)
+#define P3_CK3_reg_p3_ck_10_shift                                     (8)
+#define P3_CK3_reg_p3_ck_9_shift                                      (0)
+#define P3_CK3_reg_p3_ck_12_mask                                      (0xFF000000)
+#define P3_CK3_reg_p3_ck_11_mask                                      (0x00FF0000)
+#define P3_CK3_reg_p3_ck_10_mask                                      (0x0000FF00)
+#define P3_CK3_reg_p3_ck_9_mask                                       (0x000000FF)
+#define P3_CK3_reg_p3_ck_12(data)                                     (0xFF000000&((data)<<24))
+#define P3_CK3_reg_p3_ck_11(data)                                     (0x00FF0000&((data)<<16))
+#define P3_CK3_reg_p3_ck_10(data)                                     (0x0000FF00&((data)<<8))
+#define P3_CK3_reg_p3_ck_9(data)                                      (0x000000FF&(data))
+#define P3_CK3_get_reg_p3_ck_12(data)                                 ((0xFF000000&(data))>>24)
+#define P3_CK3_get_reg_p3_ck_11(data)                                 ((0x00FF0000&(data))>>16)
+#define P3_CK3_get_reg_p3_ck_10(data)                                 ((0x0000FF00&(data))>>8)
+#define P3_CK3_get_reg_p3_ck_9(data)                                  (0x000000FF&(data))
+
+
+#define P3_CK4                                                        0xb4c
+#define P3_CK4_reg_addr                                               "0x98034b4c"
+#define P3_CK4_reg                                                    0x98034b4c
+#define P3_CK4_inst_addr                                              "0x02D3"
+#define P3_CK4_inst                                                   0x02D3
+#define P3_CK4_reg_p3_ck_13_shift                                     (0)
+#define P3_CK4_reg_p3_ck_13_mask                                      (0x000000FF)
+#define P3_CK4_reg_p3_ck_13(data)                                     (0x000000FF&(data))
+#define P3_CK4_get_reg_p3_ck_13(data)                                 (0x000000FF&(data))
+
+
+#define P3_G1                                                         0xb50
+#define P3_G1_reg_addr                                                "0x98034b50"
+#define P3_G1_reg                                                     0x98034b50
+#define P3_G1_inst_addr                                               "0x02D4"
+#define P3_G1_inst                                                    0x02D4
+#define P3_G1_reg_p3_g_4_shift                                        (24)
+#define P3_G1_reg_p3_g_3_shift                                        (16)
+#define P3_G1_reg_p3_g_2_shift                                        (8)
+#define P3_G1_reg_p3_g_1_shift                                        (0)
+#define P3_G1_reg_p3_g_4_mask                                         (0xFF000000)
+#define P3_G1_reg_p3_g_3_mask                                         (0x00FF0000)
+#define P3_G1_reg_p3_g_2_mask                                         (0x0000FF00)
+#define P3_G1_reg_p3_g_1_mask                                         (0x000000FF)
+#define P3_G1_reg_p3_g_4(data)                                        (0xFF000000&((data)<<24))
+#define P3_G1_reg_p3_g_3(data)                                        (0x00FF0000&((data)<<16))
+#define P3_G1_reg_p3_g_2(data)                                        (0x0000FF00&((data)<<8))
+#define P3_G1_reg_p3_g_1(data)                                        (0x000000FF&(data))
+#define P3_G1_get_reg_p3_g_4(data)                                    ((0xFF000000&(data))>>24)
+#define P3_G1_get_reg_p3_g_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P3_G1_get_reg_p3_g_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P3_G1_get_reg_p3_g_1(data)                                    (0x000000FF&(data))
+
+
+#define P3_G2                                                         0xb54
+#define P3_G2_reg_addr                                                "0x98034b54"
+#define P3_G2_reg                                                     0x98034b54
+#define P3_G2_inst_addr                                               "0x02D5"
+#define P3_G2_inst                                                    0x02D5
+#define P3_G2_reg_p3_g_8_shift                                        (24)
+#define P3_G2_reg_p3_g_7_shift                                        (16)
+#define P3_G2_reg_p3_g_6_shift                                        (8)
+#define P3_G2_reg_p3_g_5_shift                                        (0)
+#define P3_G2_reg_p3_g_8_mask                                         (0xFF000000)
+#define P3_G2_reg_p3_g_7_mask                                         (0x00FF0000)
+#define P3_G2_reg_p3_g_6_mask                                         (0x0000FF00)
+#define P3_G2_reg_p3_g_5_mask                                         (0x000000FF)
+#define P3_G2_reg_p3_g_8(data)                                        (0xFF000000&((data)<<24))
+#define P3_G2_reg_p3_g_7(data)                                        (0x00FF0000&((data)<<16))
+#define P3_G2_reg_p3_g_6(data)                                        (0x0000FF00&((data)<<8))
+#define P3_G2_reg_p3_g_5(data)                                        (0x000000FF&(data))
+#define P3_G2_get_reg_p3_g_8(data)                                    ((0xFF000000&(data))>>24)
+#define P3_G2_get_reg_p3_g_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P3_G2_get_reg_p3_g_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P3_G2_get_reg_p3_g_5(data)                                    (0x000000FF&(data))
+
+
+#define P3_G3                                                         0xb58
+#define P3_G3_reg_addr                                                "0x98034b58"
+#define P3_G3_reg                                                     0x98034b58
+#define P3_G3_inst_addr                                               "0x02D6"
+#define P3_G3_inst                                                    0x02D6
+#define P3_G3_reg_p3_g_12_shift                                       (24)
+#define P3_G3_reg_p3_g_11_shift                                       (16)
+#define P3_G3_reg_p3_g_10_shift                                       (8)
+#define P3_G3_reg_p3_g_9_shift                                        (0)
+#define P3_G3_reg_p3_g_12_mask                                        (0xFF000000)
+#define P3_G3_reg_p3_g_11_mask                                        (0x00FF0000)
+#define P3_G3_reg_p3_g_10_mask                                        (0x0000FF00)
+#define P3_G3_reg_p3_g_9_mask                                         (0x000000FF)
+#define P3_G3_reg_p3_g_12(data)                                       (0xFF000000&((data)<<24))
+#define P3_G3_reg_p3_g_11(data)                                       (0x00FF0000&((data)<<16))
+#define P3_G3_reg_p3_g_10(data)                                       (0x0000FF00&((data)<<8))
+#define P3_G3_reg_p3_g_9(data)                                        (0x000000FF&(data))
+#define P3_G3_get_reg_p3_g_12(data)                                   ((0xFF000000&(data))>>24)
+#define P3_G3_get_reg_p3_g_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P3_G3_get_reg_p3_g_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P3_G3_get_reg_p3_g_9(data)                                    (0x000000FF&(data))
+
+
+#define P3_G4                                                         0xb5c
+#define P3_G4_reg_addr                                                "0x98034b5c"
+#define P3_G4_reg                                                     0x98034b5c
+#define P3_G4_inst_addr                                               "0x02D7"
+#define P3_G4_inst                                                    0x02D7
+#define P3_G4_reg_p3_g_koff_sel_shift                                 (10)
+#define P3_G4_reg_p3_g_koff_bound_shift                               (9)
+#define P3_G4_reg_p3_g_koffok_shift                                   (8)
+#define P3_G4_reg_p3_g_13_shift                                       (0)
+#define P3_G4_reg_p3_g_koff_sel_mask                                  (0x00007C00)
+#define P3_G4_reg_p3_g_koff_bound_mask                                (0x00000200)
+#define P3_G4_reg_p3_g_koffok_mask                                    (0x00000100)
+#define P3_G4_reg_p3_g_13_mask                                        (0x000000FF)
+#define P3_G4_reg_p3_g_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P3_G4_reg_p3_g_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P3_G4_reg_p3_g_koffok(data)                                   (0x00000100&((data)<<8))
+#define P3_G4_reg_p3_g_13(data)                                       (0x000000FF&(data))
+#define P3_G4_get_reg_p3_g_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P3_G4_get_reg_p3_g_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P3_G4_get_reg_p3_g_koffok(data)                               ((0x00000100&(data))>>8)
+#define P3_G4_get_reg_p3_g_13(data)                                   (0x000000FF&(data))
+
+
+#define P3_R1                                                         0xb60
+#define P3_R1_reg_addr                                                "0x98034b60"
+#define P3_R1_reg                                                     0x98034b60
+#define P3_R1_inst_addr                                               "0x02D8"
+#define P3_R1_inst                                                    0x02D8
+#define P3_R1_reg_p3_r_4_shift                                        (24)
+#define P3_R1_reg_p3_r_3_shift                                        (16)
+#define P3_R1_reg_p3_r_2_shift                                        (8)
+#define P3_R1_reg_p3_r_1_shift                                        (0)
+#define P3_R1_reg_p3_r_4_mask                                         (0xFF000000)
+#define P3_R1_reg_p3_r_3_mask                                         (0x00FF0000)
+#define P3_R1_reg_p3_r_2_mask                                         (0x0000FF00)
+#define P3_R1_reg_p3_r_1_mask                                         (0x000000FF)
+#define P3_R1_reg_p3_r_4(data)                                        (0xFF000000&((data)<<24))
+#define P3_R1_reg_p3_r_3(data)                                        (0x00FF0000&((data)<<16))
+#define P3_R1_reg_p3_r_2(data)                                        (0x0000FF00&((data)<<8))
+#define P3_R1_reg_p3_r_1(data)                                        (0x000000FF&(data))
+#define P3_R1_get_reg_p3_r_4(data)                                    ((0xFF000000&(data))>>24)
+#define P3_R1_get_reg_p3_r_3(data)                                    ((0x00FF0000&(data))>>16)
+#define P3_R1_get_reg_p3_r_2(data)                                    ((0x0000FF00&(data))>>8)
+#define P3_R1_get_reg_p3_r_1(data)                                    (0x000000FF&(data))
+
+
+#define P3_R2                                                         0xb64
+#define P3_R2_reg_addr                                                "0x98034b64"
+#define P3_R2_reg                                                     0x98034b64
+#define P3_R2_inst_addr                                               "0x02D9"
+#define P3_R2_inst                                                    0x02D9
+#define P3_R2_reg_p3_r_8_shift                                        (24)
+#define P3_R2_reg_p3_r_7_shift                                        (16)
+#define P3_R2_reg_p3_r_6_shift                                        (8)
+#define P3_R2_reg_p3_r_5_shift                                        (0)
+#define P3_R2_reg_p3_r_8_mask                                         (0xFF000000)
+#define P3_R2_reg_p3_r_7_mask                                         (0x00FF0000)
+#define P3_R2_reg_p3_r_6_mask                                         (0x0000FF00)
+#define P3_R2_reg_p3_r_5_mask                                         (0x000000FF)
+#define P3_R2_reg_p3_r_8(data)                                        (0xFF000000&((data)<<24))
+#define P3_R2_reg_p3_r_7(data)                                        (0x00FF0000&((data)<<16))
+#define P3_R2_reg_p3_r_6(data)                                        (0x0000FF00&((data)<<8))
+#define P3_R2_reg_p3_r_5(data)                                        (0x000000FF&(data))
+#define P3_R2_get_reg_p3_r_8(data)                                    ((0xFF000000&(data))>>24)
+#define P3_R2_get_reg_p3_r_7(data)                                    ((0x00FF0000&(data))>>16)
+#define P3_R2_get_reg_p3_r_6(data)                                    ((0x0000FF00&(data))>>8)
+#define P3_R2_get_reg_p3_r_5(data)                                    (0x000000FF&(data))
+
+
+#define P3_R3                                                         0xb68
+#define P3_R3_reg_addr                                                "0x98034b68"
+#define P3_R3_reg                                                     0x98034b68
+#define P3_R3_inst_addr                                               "0x02DA"
+#define P3_R3_inst                                                    0x02DA
+#define P3_R3_reg_p3_r_12_shift                                       (24)
+#define P3_R3_reg_p3_r_11_shift                                       (16)
+#define P3_R3_reg_p3_r_10_shift                                       (8)
+#define P3_R3_reg_p3_r_9_shift                                        (0)
+#define P3_R3_reg_p3_r_12_mask                                        (0xFF000000)
+#define P3_R3_reg_p3_r_11_mask                                        (0x00FF0000)
+#define P3_R3_reg_p3_r_10_mask                                        (0x0000FF00)
+#define P3_R3_reg_p3_r_9_mask                                         (0x000000FF)
+#define P3_R3_reg_p3_r_12(data)                                       (0xFF000000&((data)<<24))
+#define P3_R3_reg_p3_r_11(data)                                       (0x00FF0000&((data)<<16))
+#define P3_R3_reg_p3_r_10(data)                                       (0x0000FF00&((data)<<8))
+#define P3_R3_reg_p3_r_9(data)                                        (0x000000FF&(data))
+#define P3_R3_get_reg_p3_r_12(data)                                   ((0xFF000000&(data))>>24)
+#define P3_R3_get_reg_p3_r_11(data)                                   ((0x00FF0000&(data))>>16)
+#define P3_R3_get_reg_p3_r_10(data)                                   ((0x0000FF00&(data))>>8)
+#define P3_R3_get_reg_p3_r_9(data)                                    (0x000000FF&(data))
+
+
+#define P3_R4                                                         0xb6c
+#define P3_R4_reg_addr                                                "0x98034b6c"
+#define P3_R4_reg                                                     0x98034b6c
+#define P3_R4_inst_addr                                               "0x02DB"
+#define P3_R4_inst                                                    0x02DB
+#define P3_R4_reg_p3_r_koff_sel_shift                                 (10)
+#define P3_R4_reg_p3_r_koff_bound_shift                               (9)
+#define P3_R4_reg_p3_r_koffok_shift                                   (8)
+#define P3_R4_reg_p3_r_13_shift                                       (0)
+#define P3_R4_reg_p3_r_koff_sel_mask                                  (0x00007C00)
+#define P3_R4_reg_p3_r_koff_bound_mask                                (0x00000200)
+#define P3_R4_reg_p3_r_koffok_mask                                    (0x00000100)
+#define P3_R4_reg_p3_r_13_mask                                        (0x000000FF)
+#define P3_R4_reg_p3_r_koff_sel(data)                                 (0x00007C00&((data)<<10))
+#define P3_R4_reg_p3_r_koff_bound(data)                               (0x00000200&((data)<<9))
+#define P3_R4_reg_p3_r_koffok(data)                                   (0x00000100&((data)<<8))
+#define P3_R4_reg_p3_r_13(data)                                       (0x000000FF&(data))
+#define P3_R4_get_reg_p3_r_koff_sel(data)                             ((0x00007C00&(data))>>10)
+#define P3_R4_get_reg_p3_r_koff_bound(data)                           ((0x00000200&(data))>>9)
+#define P3_R4_get_reg_p3_r_koffok(data)                               ((0x00000100&(data))>>8)
+#define P3_R4_get_reg_p3_r_13(data)                                   (0x000000FF&(data))
+
+
+#define EYE1                                                          0xb70
+#define EYE1_reg_addr                                                 "0x98034b70"
+#define EYE1_reg                                                      0x98034b70
+#define EYE1_inst_addr                                                "0x02DC"
+#define EYE1_inst                                                     0x02DC
+#define EYE1_reg_eye_ref_ctrl_shift                                   (4)
+#define EYE1_reg_eye_pi_en_shift                                      (0)
+#define EYE1_reg_eye_ref_ctrl_mask                                    (0x000003F0)
+#define EYE1_reg_eye_pi_en_mask                                       (0x0000000F)
+#define EYE1_reg_eye_ref_ctrl(data)                                   (0x000003F0&((data)<<4))
+#define EYE1_reg_eye_pi_en(data)                                      (0x0000000F&(data))
+#define EYE1_get_reg_eye_ref_ctrl(data)                               ((0x000003F0&(data))>>4)
+#define EYE1_get_reg_eye_pi_en(data)                                  (0x0000000F&(data))
+
+
+#define EYE2                                                          0xb74
+#define EYE2_reg_addr                                                 "0x98034b74"
+#define EYE2_reg                                                      0x98034b74
+#define EYE2_inst_addr                                                "0x02DD"
+#define EYE2_inst                                                     0x02DD
+#define EYE2_reg_eye_pi_st_shift                                      (0)
+#define EYE2_reg_eye_pi_st_mask                                       (0xFFFFFFFF)
+#define EYE2_reg_eye_pi_st(data)                                      (0xFFFFFFFF&(data))
+#define EYE2_get_reg_eye_pi_st(data)                                  (0xFFFFFFFF&(data))
+
+
+#define BYPASS                                                        0xb78
+#define BYPASS_reg_addr                                               "0x98034b78"
+#define BYPASS_reg                                                    0x98034b78
+#define BYPASS_inst_addr                                              "0x02DE"
+#define BYPASS_inst                                                   0x02DE
+#define BYPASS_p3_bypass_ok_shift                                     (3)
+#define BYPASS_p2_bypass_ok_shift                                     (2)
+#define BYPASS_p1_bypass_ok_shift                                     (1)
+#define BYPASS_p0_bypass_ok_shift                                     (0)
+#define BYPASS_p3_bypass_ok_mask                                      (0x00000008)
+#define BYPASS_p2_bypass_ok_mask                                      (0x00000004)
+#define BYPASS_p1_bypass_ok_mask                                      (0x00000002)
+#define BYPASS_p0_bypass_ok_mask                                      (0x00000001)
+#define BYPASS_p3_bypass_ok(data)                                     (0x00000008&((data)<<3))
+#define BYPASS_p2_bypass_ok(data)                                     (0x00000004&((data)<<2))
+#define BYPASS_p1_bypass_ok(data)                                     (0x00000002&((data)<<1))
+#define BYPASS_p0_bypass_ok(data)                                     (0x00000001&(data))
+#define BYPASS_get_p3_bypass_ok(data)                                 ((0x00000008&(data))>>3)
+#define BYPASS_get_p2_bypass_ok(data)                                 ((0x00000004&(data))>>2)
+#define BYPASS_get_p1_bypass_ok(data)                                 ((0x00000002&(data))>>1)
+#define BYPASS_get_p0_bypass_ok(data)                                 (0x00000001&(data))
+
+
+#define RST                                                           0xb7c
+#define RST_reg_addr                                                  "0x98034b7c"
+#define RST_reg                                                       0x98034b7c
+#define RST_inst_addr                                                 "0x02DF"
+#define RST_inst                                                      0x02DF
+#define RST_eye_monitor_rstn_shift                                    (25)
+#define RST_reg_p3_acdr_rstb_fsm_shift                                (23)
+#define RST_reg_p2_acdr_rstb_fsm_shift                                (22)
+#define RST_reg_p1_acdr_rstb_fsm_shift                                (21)
+#define RST_reg_p0_acdr_rstb_fsm_shift                                (20)
+#define RST_p3_ck_vcorstb_shift                                       (19)
+#define RST_p2_ck_vcorstb_shift                                       (18)
+#define RST_p1_ck_vcorstb_shift                                       (17)
+#define RST_p0_ck_vcorstb_shift                                       (16)
+#define RST_p3_ck_pllrstb_shift                                       (15)
+#define RST_p2_ck_pllrstb_shift                                       (14)
+#define RST_p1_ck_pllrstb_shift                                       (13)
+#define RST_p0_ck_pllrstb_shift                                       (12)
+#define RST_p3_r_demux_rstb_shift                                     (11)
+#define RST_p3_g_demux_rstb_shift                                     (10)
+#define RST_p3_b_demux_rstb_shift                                     (9)
+#define RST_p2_r_demux_rstb_shift                                     (8)
+#define RST_p2_g_demux_rstb_shift                                     (7)
+#define RST_p2_b_demux_rstb_shift                                     (6)
+#define RST_p1_r_demux_rstb_shift                                     (5)
+#define RST_p1_g_demux_rstb_shift                                     (4)
+#define RST_p1_b_demux_rstb_shift                                     (3)
+#define RST_p0_r_demux_rstb_shift                                     (2)
+#define RST_p0_g_demux_rstb_shift                                     (1)
+#define RST_p0_b_demux_rstb_shift                                     (0)
+#define RST_eye_monitor_rstn_mask                                     (0x02000000)
+#define RST_reg_p3_acdr_rstb_fsm_mask                                 (0x00800000)
+#define RST_reg_p2_acdr_rstb_fsm_mask                                 (0x00400000)
+#define RST_reg_p1_acdr_rstb_fsm_mask                                 (0x00200000)
+#define RST_reg_p0_acdr_rstb_fsm_mask                                 (0x00100000)
+#define RST_p3_ck_vcorstb_mask                                        (0x00080000)
+#define RST_p2_ck_vcorstb_mask                                        (0x00040000)
+#define RST_p1_ck_vcorstb_mask                                        (0x00020000)
+#define RST_p0_ck_vcorstb_mask                                        (0x00010000)
+#define RST_p3_ck_pllrstb_mask                                        (0x00008000)
+#define RST_p2_ck_pllrstb_mask                                        (0x00004000)
+#define RST_p1_ck_pllrstb_mask                                        (0x00002000)
+#define RST_p0_ck_pllrstb_mask                                        (0x00001000)
+#define RST_p3_r_demux_rstb_mask                                      (0x00000800)
+#define RST_p3_g_demux_rstb_mask                                      (0x00000400)
+#define RST_p3_b_demux_rstb_mask                                      (0x00000200)
+#define RST_p2_r_demux_rstb_mask                                      (0x00000100)
+#define RST_p2_g_demux_rstb_mask                                      (0x00000080)
+#define RST_p2_b_demux_rstb_mask                                      (0x00000040)
+#define RST_p1_r_demux_rstb_mask                                      (0x00000020)
+#define RST_p1_g_demux_rstb_mask                                      (0x00000010)
+#define RST_p1_b_demux_rstb_mask                                      (0x00000008)
+#define RST_p0_r_demux_rstb_mask                                      (0x00000004)
+#define RST_p0_g_demux_rstb_mask                                      (0x00000002)
+#define RST_p0_b_demux_rstb_mask                                      (0x00000001)
+#define RST_eye_monitor_rstn(data)                                    (0x02000000&((data)<<25))
+#define RST_reg_p3_acdr_rstb_fsm(data)                                (0x00800000&((data)<<23))
+#define RST_reg_p2_acdr_rstb_fsm(data)                                (0x00400000&((data)<<22))
+#define RST_reg_p1_acdr_rstb_fsm(data)                                (0x00200000&((data)<<21))
+#define RST_reg_p0_acdr_rstb_fsm(data)                                (0x00100000&((data)<<20))
+#define RST_p3_ck_vcorstb(data)                                       (0x00080000&((data)<<19))
+#define RST_p2_ck_vcorstb(data)                                       (0x00040000&((data)<<18))
+#define RST_p1_ck_vcorstb(data)                                       (0x00020000&((data)<<17))
+#define RST_p0_ck_vcorstb(data)                                       (0x00010000&((data)<<16))
+#define RST_p3_ck_pllrstb(data)                                       (0x00008000&((data)<<15))
+#define RST_p2_ck_pllrstb(data)                                       (0x00004000&((data)<<14))
+#define RST_p1_ck_pllrstb(data)                                       (0x00002000&((data)<<13))
+#define RST_p0_ck_pllrstb(data)                                       (0x00001000&((data)<<12))
+#define RST_p3_r_demux_rstb(data)                                     (0x00000800&((data)<<11))
+#define RST_p3_g_demux_rstb(data)                                     (0x00000400&((data)<<10))
+#define RST_p3_b_demux_rstb(data)                                     (0x00000200&((data)<<9))
+#define RST_p2_r_demux_rstb(data)                                     (0x00000100&((data)<<8))
+#define RST_p2_g_demux_rstb(data)                                     (0x00000080&((data)<<7))
+#define RST_p2_b_demux_rstb(data)                                     (0x00000040&((data)<<6))
+#define RST_p1_r_demux_rstb(data)                                     (0x00000020&((data)<<5))
+#define RST_p1_g_demux_rstb(data)                                     (0x00000010&((data)<<4))
+#define RST_p1_b_demux_rstb(data)                                     (0x00000008&((data)<<3))
+#define RST_p0_r_demux_rstb(data)                                     (0x00000004&((data)<<2))
+#define RST_p0_g_demux_rstb(data)                                     (0x00000002&((data)<<1))
+#define RST_p0_b_demux_rstb(data)                                     (0x00000001&(data))
+#define RST_get_eye_monitor_rstn(data)                                ((0x02000000&(data))>>25)
+#define RST_get_reg_p3_acdr_rstb_fsm(data)                            ((0x00800000&(data))>>23)
+#define RST_get_reg_p2_acdr_rstb_fsm(data)                            ((0x00400000&(data))>>22)
+#define RST_get_reg_p1_acdr_rstb_fsm(data)                            ((0x00200000&(data))>>21)
+#define RST_get_reg_p0_acdr_rstb_fsm(data)                            ((0x00100000&(data))>>20)
+#define RST_get_p3_ck_vcorstb(data)                                   ((0x00080000&(data))>>19)
+#define RST_get_p2_ck_vcorstb(data)                                   ((0x00040000&(data))>>18)
+#define RST_get_p1_ck_vcorstb(data)                                   ((0x00020000&(data))>>17)
+#define RST_get_p0_ck_vcorstb(data)                                   ((0x00010000&(data))>>16)
+#define RST_get_p3_ck_pllrstb(data)                                   ((0x00008000&(data))>>15)
+#define RST_get_p2_ck_pllrstb(data)                                   ((0x00004000&(data))>>14)
+#define RST_get_p1_ck_pllrstb(data)                                   ((0x00002000&(data))>>13)
+#define RST_get_p0_ck_pllrstb(data)                                   ((0x00001000&(data))>>12)
+#define RST_get_p3_r_demux_rstb(data)                                 ((0x00000800&(data))>>11)
+#define RST_get_p3_g_demux_rstb(data)                                 ((0x00000400&(data))>>10)
+#define RST_get_p3_b_demux_rstb(data)                                 ((0x00000200&(data))>>9)
+#define RST_get_p2_r_demux_rstb(data)                                 ((0x00000100&(data))>>8)
+#define RST_get_p2_g_demux_rstb(data)                                 ((0x00000080&(data))>>7)
+#define RST_get_p2_b_demux_rstb(data)                                 ((0x00000040&(data))>>6)
+#define RST_get_p1_r_demux_rstb(data)                                 ((0x00000020&(data))>>5)
+#define RST_get_p1_g_demux_rstb(data)                                 ((0x00000010&(data))>>4)
+#define RST_get_p1_b_demux_rstb(data)                                 ((0x00000008&(data))>>3)
+#define RST_get_p0_r_demux_rstb(data)                                 ((0x00000004&(data))>>2)
+#define RST_get_p0_g_demux_rstb(data)                                 ((0x00000002&(data))>>1)
+#define RST_get_p0_b_demux_rstb(data)                                 (0x00000001&(data))
+
+
+#define MBIAS                                                         0xb80
+#define MBIAS_reg_addr                                                "0x98034b80"
+#define MBIAS_reg                                                     0x98034b80
+#define MBIAS_inst_addr                                               "0x02E0"
+#define MBIAS_inst                                                    0x02E0
+#define MBIAS_reg_mbias_en_shift                                      (0)
+#define MBIAS_reg_mbias_en_mask                                       (0x00000001)
+#define MBIAS_reg_mbias_en(data)                                      (0x00000001&(data))
+#define MBIAS_get_reg_mbias_en(data)                                  (0x00000001&(data))
+
+
+#define HDMIRPT                                                       0xb84
+#define HDMIRPT_reg_addr                                              "0x98034b84"
+#define HDMIRPT_reg                                                   0x98034b84
+#define HDMIRPT_inst_addr                                             "0x02E1"
+#define HDMIRPT_inst                                                  0x02E1
+#define HDMIRPT_reg_hdmirpt_ck_div2_shift                             (4)
+#define HDMIRPT_reg_hdmirpt_ck_sel_shift                              (2)
+#define HDMIRPT_reg_hdmirpt_hdmi2_shift                               (1)
+#define HDMIRPT_reg_hdmirpt_en_shift                                  (0)
+#define HDMIRPT_reg_hdmirpt_ck_div2_mask                              (0x00000010)
+#define HDMIRPT_reg_hdmirpt_ck_sel_mask                               (0x0000000C)
+#define HDMIRPT_reg_hdmirpt_hdmi2_mask                                (0x00000002)
+#define HDMIRPT_reg_hdmirpt_en_mask                                   (0x00000001)
+#define HDMIRPT_reg_hdmirpt_ck_div2(data)                             (0x00000010&((data)<<4))
+#define HDMIRPT_reg_hdmirpt_ck_sel(data)                              (0x0000000C&((data)<<2))
+#define HDMIRPT_reg_hdmirpt_hdmi2(data)                               (0x00000002&((data)<<1))
+#define HDMIRPT_reg_hdmirpt_en(data)                                  (0x00000001&(data))
+#define HDMIRPT_get_reg_hdmirpt_ck_div2(data)                         ((0x00000010&(data))>>4)
+#define HDMIRPT_get_reg_hdmirpt_ck_sel(data)                          ((0x0000000C&(data))>>2)
+#define HDMIRPT_get_reg_hdmirpt_hdmi2(data)                           ((0x00000002&(data))>>1)
+#define HDMIRPT_get_reg_hdmirpt_en(data)                              (0x00000001&(data))
+
+
+#define REGD0                                                         0xb8c
+#define REGD0_reg_addr                                                "0x98034b8c"
+#define REGD0_reg                                                     0x98034b8c
+#define REGD0_inst_addr                                               "0x02E3"
+#define REGD0_inst                                                    0x02E3
+#define REGD0_p0_r_dig_rst_n_shift                                    (31)
+#define REGD0_p0_g_dig_rst_n_shift                                    (30)
+#define REGD0_p0_b_dig_rst_n_shift                                    (29)
+#define REGD0_p0_r_cdr_rst_n_shift                                    (28)
+#define REGD0_p0_g_cdr_rst_n_shift                                    (27)
+#define REGD0_p0_b_cdr_rst_n_shift                                    (26)
+#define REGD0_reg_p0_cdr_ckinv_r_shift                                (25)
+#define REGD0_reg_p0_cdr_ckinv_g_shift                                (24)
+#define REGD0_reg_p0_cdr_ckinv_b_shift                                (23)
+#define REGD0_reg_p0_shift_inv_r_shift                                (22)
+#define REGD0_reg_p0_shift_inv_g_shift                                (21)
+#define REGD0_reg_p0_shift_inv_b_shift                                (20)
+#define REGD0_reg_p0_rate_sel_shift                                   (17)
+#define REGD0_reg_p0_kd_shift                                         (16)
+#define REGD0_reg_p0_kp_shift                                         (8)
+#define REGD0_reg_p0_ki_shift                                         (5)
+#define REGD0_reg_p0_bypass_sdm_int_shift                             (4)
+#define REGD0_reg_p0_data_order_shift                                 (3)
+#define REGD0_reg_p0_infifo_cnt_shift                                 (0)
+#define REGD0_p0_r_dig_rst_n_mask                                     (0x80000000)
+#define REGD0_p0_g_dig_rst_n_mask                                     (0x40000000)
+#define REGD0_p0_b_dig_rst_n_mask                                     (0x20000000)
+#define REGD0_p0_r_cdr_rst_n_mask                                     (0x10000000)
+#define REGD0_p0_g_cdr_rst_n_mask                                     (0x08000000)
+#define REGD0_p0_b_cdr_rst_n_mask                                     (0x04000000)
+#define REGD0_reg_p0_cdr_ckinv_r_mask                                 (0x02000000)
+#define REGD0_reg_p0_cdr_ckinv_g_mask                                 (0x01000000)
+#define REGD0_reg_p0_cdr_ckinv_b_mask                                 (0x00800000)
+#define REGD0_reg_p0_shift_inv_r_mask                                 (0x00400000)
+#define REGD0_reg_p0_shift_inv_g_mask                                 (0x00200000)
+#define REGD0_reg_p0_shift_inv_b_mask                                 (0x00100000)
+#define REGD0_reg_p0_rate_sel_mask                                    (0x000E0000)
+#define REGD0_reg_p0_kd_mask                                          (0x00010000)
+#define REGD0_reg_p0_kp_mask                                          (0x0000FF00)
+#define REGD0_reg_p0_ki_mask                                          (0x000000E0)
+#define REGD0_reg_p0_bypass_sdm_int_mask                              (0x00000010)
+#define REGD0_reg_p0_data_order_mask                                  (0x00000008)
+#define REGD0_reg_p0_infifo_cnt_mask                                  (0x00000007)
+#define REGD0_p0_r_dig_rst_n(data)                                    (0x80000000&((data)<<31))
+#define REGD0_p0_g_dig_rst_n(data)                                    (0x40000000&((data)<<30))
+#define REGD0_p0_b_dig_rst_n(data)                                    (0x20000000&((data)<<29))
+#define REGD0_p0_r_cdr_rst_n(data)                                    (0x10000000&((data)<<28))
+#define REGD0_p0_g_cdr_rst_n(data)                                    (0x08000000&((data)<<27))
+#define REGD0_p0_b_cdr_rst_n(data)                                    (0x04000000&((data)<<26))
+#define REGD0_reg_p0_cdr_ckinv_r(data)                                (0x02000000&((data)<<25))
+#define REGD0_reg_p0_cdr_ckinv_g(data)                                (0x01000000&((data)<<24))
+#define REGD0_reg_p0_cdr_ckinv_b(data)                                (0x00800000&((data)<<23))
+#define REGD0_reg_p0_shift_inv_r(data)                                (0x00400000&((data)<<22))
+#define REGD0_reg_p0_shift_inv_g(data)                                (0x00200000&((data)<<21))
+#define REGD0_reg_p0_shift_inv_b(data)                                (0x00100000&((data)<<20))
+#define REGD0_reg_p0_rate_sel(data)                                   (0x000E0000&((data)<<17))
+#define REGD0_reg_p0_kd(data)                                         (0x00010000&((data)<<16))
+#define REGD0_reg_p0_kp(data)                                         (0x0000FF00&((data)<<8))
+#define REGD0_reg_p0_ki(data)                                         (0x000000E0&((data)<<5))
+#define REGD0_reg_p0_bypass_sdm_int(data)                             (0x00000010&((data)<<4))
+#define REGD0_reg_p0_data_order(data)                                 (0x00000008&((data)<<3))
+#define REGD0_reg_p0_infifo_cnt(data)                                 (0x00000007&(data))
+#define REGD0_get_p0_r_dig_rst_n(data)                                ((0x80000000&(data))>>31)
+#define REGD0_get_p0_g_dig_rst_n(data)                                ((0x40000000&(data))>>30)
+#define REGD0_get_p0_b_dig_rst_n(data)                                ((0x20000000&(data))>>29)
+#define REGD0_get_p0_r_cdr_rst_n(data)                                ((0x10000000&(data))>>28)
+#define REGD0_get_p0_g_cdr_rst_n(data)                                ((0x08000000&(data))>>27)
+#define REGD0_get_p0_b_cdr_rst_n(data)                                ((0x04000000&(data))>>26)
+#define REGD0_get_reg_p0_cdr_ckinv_r(data)                            ((0x02000000&(data))>>25)
+#define REGD0_get_reg_p0_cdr_ckinv_g(data)                            ((0x01000000&(data))>>24)
+#define REGD0_get_reg_p0_cdr_ckinv_b(data)                            ((0x00800000&(data))>>23)
+#define REGD0_get_reg_p0_shift_inv_r(data)                            ((0x00400000&(data))>>22)
+#define REGD0_get_reg_p0_shift_inv_g(data)                            ((0x00200000&(data))>>21)
+#define REGD0_get_reg_p0_shift_inv_b(data)                            ((0x00100000&(data))>>20)
+#define REGD0_get_reg_p0_rate_sel(data)                               ((0x000E0000&(data))>>17)
+#define REGD0_get_reg_p0_kd(data)                                     ((0x00010000&(data))>>16)
+#define REGD0_get_reg_p0_kp(data)                                     ((0x0000FF00&(data))>>8)
+#define REGD0_get_reg_p0_ki(data)                                     ((0x000000E0&(data))>>5)
+#define REGD0_get_reg_p0_bypass_sdm_int(data)                         ((0x00000010&(data))>>4)
+#define REGD0_get_reg_p0_data_order(data)                             ((0x00000008&(data))>>3)
+#define REGD0_get_reg_p0_infifo_cnt(data)                             (0x00000007&(data))
+
+
+#define REGD1                                                         0xb90
+#define REGD1_reg_addr                                                "0x98034b90"
+#define REGD1_reg                                                     0x98034b90
+#define REGD1_inst_addr                                               "0x02E4"
+#define REGD1_inst                                                    0x02E4
+#define REGD1_reg_p0_int_init_shift                                   (18)
+#define REGD1_reg_p0_acc2_period_shift                                (8)
+#define REGD1_reg_p0_squ_tri_shift                                    (7)
+#define REGD1_reg_p0_acc2_manual_shift                                (6)
+#define REGD1_reg_p0_testout_sel_shift                                (4)
+#define REGD1_reg_p0_ercnt_en_shift                                   (3)
+#define REGD1_reg_p0_edge_out_shift                                   (2)
+#define REGD1_reg_p0_pi_m_mode_shift                                  (1)
+#define REGD1_reg_p0_dyn_kp_en_shift                                  (0)
+#define REGD1_reg_p0_int_init_mask                                    (0xFFFC0000)
+#define REGD1_reg_p0_acc2_period_mask                                 (0x0003FF00)
+#define REGD1_reg_p0_squ_tri_mask                                     (0x00000080)
+#define REGD1_reg_p0_acc2_manual_mask                                 (0x00000040)
+#define REGD1_reg_p0_testout_sel_mask                                 (0x00000030)
+#define REGD1_reg_p0_ercnt_en_mask                                    (0x00000008)
+#define REGD1_reg_p0_edge_out_mask                                    (0x00000004)
+#define REGD1_reg_p0_pi_m_mode_mask                                   (0x00000002)
+#define REGD1_reg_p0_dyn_kp_en_mask                                   (0x00000001)
+#define REGD1_reg_p0_int_init(data)                                   (0xFFFC0000&((data)<<18))
+#define REGD1_reg_p0_acc2_period(data)                                (0x0003FF00&((data)<<8))
+#define REGD1_reg_p0_squ_tri(data)                                    (0x00000080&((data)<<7))
+#define REGD1_reg_p0_acc2_manual(data)                                (0x00000040&((data)<<6))
+#define REGD1_reg_p0_testout_sel(data)                                (0x00000030&((data)<<4))
+#define REGD1_reg_p0_ercnt_en(data)                                   (0x00000008&((data)<<3))
+#define REGD1_reg_p0_edge_out(data)                                   (0x00000004&((data)<<2))
+#define REGD1_reg_p0_pi_m_mode(data)                                  (0x00000002&((data)<<1))
+#define REGD1_reg_p0_dyn_kp_en(data)                                  (0x00000001&(data))
+#define REGD1_get_reg_p0_int_init(data)                               ((0xFFFC0000&(data))>>18)
+#define REGD1_get_reg_p0_acc2_period(data)                            ((0x0003FF00&(data))>>8)
+#define REGD1_get_reg_p0_squ_tri(data)                                ((0x00000080&(data))>>7)
+#define REGD1_get_reg_p0_acc2_manual(data)                            ((0x00000040&(data))>>6)
+#define REGD1_get_reg_p0_testout_sel(data)                            ((0x00000030&(data))>>4)
+#define REGD1_get_reg_p0_ercnt_en(data)                               ((0x00000008&(data))>>3)
+#define REGD1_get_reg_p0_edge_out(data)                               ((0x00000004&(data))>>2)
+#define REGD1_get_reg_p0_pi_m_mode(data)                              ((0x00000002&(data))>>1)
+#define REGD1_get_reg_p0_dyn_kp_en(data)                              (0x00000001&(data))
+
+
+#define REGD2                                                         0xb94
+#define REGD2_reg_addr                                                "0x98034b94"
+#define REGD2_reg                                                     0x98034b94
+#define REGD2_inst_addr                                               "0x02E5"
+#define REGD2_inst                                                    0x02E5
+#define REGD2_reg_p0_en_m_value_shift                                 (28)
+#define REGD2_reg_p0_st_mode_shift                                    (27)
+#define REGD2_reg_p0_timer_lpf_shift                                  (18)
+#define REGD2_reg_p0_timer_eq_shift                                   (13)
+#define REGD2_reg_p0_timer_ber_shift                                  (8)
+#define REGD2_reg_p0_en_m_value_mask                                  (0xF0000000)
+#define REGD2_reg_p0_st_mode_mask                                     (0x08000000)
+#define REGD2_reg_p0_timer_lpf_mask                                   (0x007C0000)
+#define REGD2_reg_p0_timer_eq_mask                                    (0x0003E000)
+#define REGD2_reg_p0_timer_ber_mask                                   (0x00001F00)
+#define REGD2_reg_p0_en_m_value(data)                                 (0xF0000000&((data)<<28))
+#define REGD2_reg_p0_st_mode(data)                                    (0x08000000&((data)<<27))
+#define REGD2_reg_p0_timer_lpf(data)                                  (0x007C0000&((data)<<18))
+#define REGD2_reg_p0_timer_eq(data)                                   (0x0003E000&((data)<<13))
+#define REGD2_reg_p0_timer_ber(data)                                  (0x00001F00&((data)<<8))
+#define REGD2_get_reg_p0_en_m_value(data)                             ((0xF0000000&(data))>>28)
+#define REGD2_get_reg_p0_st_mode(data)                                ((0x08000000&(data))>>27)
+#define REGD2_get_reg_p0_timer_lpf(data)                              ((0x007C0000&(data))>>18)
+#define REGD2_get_reg_p0_timer_eq(data)                               ((0x0003E000&(data))>>13)
+#define REGD2_get_reg_p0_timer_ber(data)                              ((0x00001F00&(data))>>8)
+
+
+#define REGD3                                                         0xb98
+#define REGD3_reg_addr                                                "0x98034b98"
+#define REGD3_reg                                                     0x98034b98
+#define REGD3_inst_addr                                               "0x02E6"
+#define REGD3_inst                                                    0x02E6
+#define REGD3_p0_st_ro_r_shift                                        (24)
+#define REGD3_p0_en_ro_r_shift                                        (20)
+#define REGD3_p0_st_ro_g_shift                                        (14)
+#define REGD3_p0_en_ro_g_shift                                        (10)
+#define REGD3_p0_st_ro_b_shift                                        (4)
+#define REGD3_p0_en_ro_b_shift                                        (0)
+#define REGD3_p0_st_ro_r_mask                                         (0x1F000000)
+#define REGD3_p0_en_ro_r_mask                                         (0x00F00000)
+#define REGD3_p0_st_ro_g_mask                                         (0x0007C000)
+#define REGD3_p0_en_ro_g_mask                                         (0x00003C00)
+#define REGD3_p0_st_ro_b_mask                                         (0x000001F0)
+#define REGD3_p0_en_ro_b_mask                                         (0x0000000F)
+#define REGD3_p0_st_ro_r(data)                                        (0x1F000000&((data)<<24))
+#define REGD3_p0_en_ro_r(data)                                        (0x00F00000&((data)<<20))
+#define REGD3_p0_st_ro_g(data)                                        (0x0007C000&((data)<<14))
+#define REGD3_p0_en_ro_g(data)                                        (0x00003C00&((data)<<10))
+#define REGD3_p0_st_ro_b(data)                                        (0x000001F0&((data)<<4))
+#define REGD3_p0_en_ro_b(data)                                        (0x0000000F&(data))
+#define REGD3_get_p0_st_ro_r(data)                                    ((0x1F000000&(data))>>24)
+#define REGD3_get_p0_en_ro_r(data)                                    ((0x00F00000&(data))>>20)
+#define REGD3_get_p0_st_ro_g(data)                                    ((0x0007C000&(data))>>14)
+#define REGD3_get_p0_en_ro_g(data)                                    ((0x00003C00&(data))>>10)
+#define REGD3_get_p0_st_ro_b(data)                                    ((0x000001F0&(data))>>4)
+#define REGD3_get_p0_en_ro_b(data)                                    (0x0000000F&(data))
+
+
+#define REGD4                                                         0xb9c
+#define REGD4_reg_addr                                                "0x98034b9c"
+#define REGD4_reg                                                     0x98034b9c
+#define REGD4_inst_addr                                               "0x02E7"
+#define REGD4_inst                                                    0x02E7
+#define REGD4_p0_er_count_r_shift                                     (20)
+#define REGD4_p0_er_count_g_shift                                     (10)
+#define REGD4_p0_er_count_b_shift                                     (0)
+#define REGD4_p0_er_count_r_mask                                      (0x3FF00000)
+#define REGD4_p0_er_count_g_mask                                      (0x000FFC00)
+#define REGD4_p0_er_count_b_mask                                      (0x000003FF)
+#define REGD4_p0_er_count_r(data)                                     (0x3FF00000&((data)<<20))
+#define REGD4_p0_er_count_g(data)                                     (0x000FFC00&((data)<<10))
+#define REGD4_p0_er_count_b(data)                                     (0x000003FF&(data))
+#define REGD4_get_p0_er_count_r(data)                                 ((0x3FF00000&(data))>>20)
+#define REGD4_get_p0_er_count_g(data)                                 ((0x000FFC00&(data))>>10)
+#define REGD4_get_p0_er_count_b(data)                                 (0x000003FF&(data))
+
+
+#define REGD5                                                         0xba0
+#define REGD5_reg_addr                                                "0x98034ba0"
+#define REGD5_reg                                                     0x98034ba0
+#define REGD5_inst_addr                                               "0x02E8"
+#define REGD5_inst                                                    0x02E8
+#define REGD5_p1_r_dig_rst_n_shift                                    (31)
+#define REGD5_p1_g_dig_rst_n_shift                                    (30)
+#define REGD5_p1_b_dig_rst_n_shift                                    (29)
+#define REGD5_p1_r_cdr_rst_n_shift                                    (28)
+#define REGD5_p1_g_cdr_rst_n_shift                                    (27)
+#define REGD5_p1_b_cdr_rst_n_shift                                    (26)
+#define REGD5_reg_p1_cdr_ckinv_r_shift                                (25)
+#define REGD5_reg_p1_cdr_ckinv_g_shift                                (24)
+#define REGD5_reg_p1_cdr_ckinv_b_shift                                (23)
+#define REGD5_reg_p1_shift_inv_r_shift                                (22)
+#define REGD5_reg_p1_shift_inv_g_shift                                (21)
+#define REGD5_reg_p1_shift_inv_b_shift                                (20)
+#define REGD5_reg_p1_rate_sel_shift                                   (17)
+#define REGD5_reg_p1_kd_shift                                         (16)
+#define REGD5_reg_p1_kp_shift                                         (8)
+#define REGD5_reg_p1_ki_shift                                         (5)
+#define REGD5_reg_p1_bypass_sdm_int_shift                             (4)
+#define REGD5_reg_p1_data_order_shift                                 (3)
+#define REGD5_reg_p1_infifo_cnt_shift                                 (0)
+#define REGD5_p1_r_dig_rst_n_mask                                     (0x80000000)
+#define REGD5_p1_g_dig_rst_n_mask                                     (0x40000000)
+#define REGD5_p1_b_dig_rst_n_mask                                     (0x20000000)
+#define REGD5_p1_r_cdr_rst_n_mask                                     (0x10000000)
+#define REGD5_p1_g_cdr_rst_n_mask                                     (0x08000000)
+#define REGD5_p1_b_cdr_rst_n_mask                                     (0x04000000)
+#define REGD5_reg_p1_cdr_ckinv_r_mask                                 (0x02000000)
+#define REGD5_reg_p1_cdr_ckinv_g_mask                                 (0x01000000)
+#define REGD5_reg_p1_cdr_ckinv_b_mask                                 (0x00800000)
+#define REGD5_reg_p1_shift_inv_r_mask                                 (0x00400000)
+#define REGD5_reg_p1_shift_inv_g_mask                                 (0x00200000)
+#define REGD5_reg_p1_shift_inv_b_mask                                 (0x00100000)
+#define REGD5_reg_p1_rate_sel_mask                                    (0x000E0000)
+#define REGD5_reg_p1_kd_mask                                          (0x00010000)
+#define REGD5_reg_p1_kp_mask                                          (0x0000FF00)
+#define REGD5_reg_p1_ki_mask                                          (0x000000E0)
+#define REGD5_reg_p1_bypass_sdm_int_mask                              (0x00000010)
+#define REGD5_reg_p1_data_order_mask                                  (0x00000008)
+#define REGD5_reg_p1_infifo_cnt_mask                                  (0x00000007)
+#define REGD5_p1_r_dig_rst_n(data)                                    (0x80000000&((data)<<31))
+#define REGD5_p1_g_dig_rst_n(data)                                    (0x40000000&((data)<<30))
+#define REGD5_p1_b_dig_rst_n(data)                                    (0x20000000&((data)<<29))
+#define REGD5_p1_r_cdr_rst_n(data)                                    (0x10000000&((data)<<28))
+#define REGD5_p1_g_cdr_rst_n(data)                                    (0x08000000&((data)<<27))
+#define REGD5_p1_b_cdr_rst_n(data)                                    (0x04000000&((data)<<26))
+#define REGD5_reg_p1_cdr_ckinv_r(data)                                (0x02000000&((data)<<25))
+#define REGD5_reg_p1_cdr_ckinv_g(data)                                (0x01000000&((data)<<24))
+#define REGD5_reg_p1_cdr_ckinv_b(data)                                (0x00800000&((data)<<23))
+#define REGD5_reg_p1_shift_inv_r(data)                                (0x00400000&((data)<<22))
+#define REGD5_reg_p1_shift_inv_g(data)                                (0x00200000&((data)<<21))
+#define REGD5_reg_p1_shift_inv_b(data)                                (0x00100000&((data)<<20))
+#define REGD5_reg_p1_rate_sel(data)                                   (0x000E0000&((data)<<17))
+#define REGD5_reg_p1_kd(data)                                         (0x00010000&((data)<<16))
+#define REGD5_reg_p1_kp(data)                                         (0x0000FF00&((data)<<8))
+#define REGD5_reg_p1_ki(data)                                         (0x000000E0&((data)<<5))
+#define REGD5_reg_p1_bypass_sdm_int(data)                             (0x00000010&((data)<<4))
+#define REGD5_reg_p1_data_order(data)                                 (0x00000008&((data)<<3))
+#define REGD5_reg_p1_infifo_cnt(data)                                 (0x00000007&(data))
+#define REGD5_get_p1_r_dig_rst_n(data)                                ((0x80000000&(data))>>31)
+#define REGD5_get_p1_g_dig_rst_n(data)                                ((0x40000000&(data))>>30)
+#define REGD5_get_p1_b_dig_rst_n(data)                                ((0x20000000&(data))>>29)
+#define REGD5_get_p1_r_cdr_rst_n(data)                                ((0x10000000&(data))>>28)
+#define REGD5_get_p1_g_cdr_rst_n(data)                                ((0x08000000&(data))>>27)
+#define REGD5_get_p1_b_cdr_rst_n(data)                                ((0x04000000&(data))>>26)
+#define REGD5_get_reg_p1_cdr_ckinv_r(data)                            ((0x02000000&(data))>>25)
+#define REGD5_get_reg_p1_cdr_ckinv_g(data)                            ((0x01000000&(data))>>24)
+#define REGD5_get_reg_p1_cdr_ckinv_b(data)                            ((0x00800000&(data))>>23)
+#define REGD5_get_reg_p1_shift_inv_r(data)                            ((0x00400000&(data))>>22)
+#define REGD5_get_reg_p1_shift_inv_g(data)                            ((0x00200000&(data))>>21)
+#define REGD5_get_reg_p1_shift_inv_b(data)                            ((0x00100000&(data))>>20)
+#define REGD5_get_reg_p1_rate_sel(data)                               ((0x000E0000&(data))>>17)
+#define REGD5_get_reg_p1_kd(data)                                     ((0x00010000&(data))>>16)
+#define REGD5_get_reg_p1_kp(data)                                     ((0x0000FF00&(data))>>8)
+#define REGD5_get_reg_p1_ki(data)                                     ((0x000000E0&(data))>>5)
+#define REGD5_get_reg_p1_bypass_sdm_int(data)                         ((0x00000010&(data))>>4)
+#define REGD5_get_reg_p1_data_order(data)                             ((0x00000008&(data))>>3)
+#define REGD5_get_reg_p1_infifo_cnt(data)                             (0x00000007&(data))
+
+
+#define REGD6                                                         0xba4
+#define REGD6_reg_addr                                                "0x98034ba4"
+#define REGD6_reg                                                     0x98034ba4
+#define REGD6_inst_addr                                               "0x02E9"
+#define REGD6_inst                                                    0x02E9
+#define REGD6_reg_p1_int_init_shift                                   (18)
+#define REGD6_reg_p1_acc2_period_shift                                (8)
+#define REGD6_reg_p1_squ_tri_shift                                    (7)
+#define REGD6_reg_p1_acc2_manual_shift                                (6)
+#define REGD6_reg_p1_testout_sel_shift                                (4)
+#define REGD6_reg_p1_ercnt_en_shift                                   (3)
+#define REGD6_reg_p1_edge_out_shift                                   (2)
+#define REGD6_reg_p1_pi_m_mode_shift                                  (1)
+#define REGD6_reg_p1_dyn_kp_en_shift                                  (0)
+#define REGD6_reg_p1_int_init_mask                                    (0xFFFC0000)
+#define REGD6_reg_p1_acc2_period_mask                                 (0x0003FF00)
+#define REGD6_reg_p1_squ_tri_mask                                     (0x00000080)
+#define REGD6_reg_p1_acc2_manual_mask                                 (0x00000040)
+#define REGD6_reg_p1_testout_sel_mask                                 (0x00000030)
+#define REGD6_reg_p1_ercnt_en_mask                                    (0x00000008)
+#define REGD6_reg_p1_edge_out_mask                                    (0x00000004)
+#define REGD6_reg_p1_pi_m_mode_mask                                   (0x00000002)
+#define REGD6_reg_p1_dyn_kp_en_mask                                   (0x00000001)
+#define REGD6_reg_p1_int_init(data)                                   (0xFFFC0000&((data)<<18))
+#define REGD6_reg_p1_acc2_period(data)                                (0x0003FF00&((data)<<8))
+#define REGD6_reg_p1_squ_tri(data)                                    (0x00000080&((data)<<7))
+#define REGD6_reg_p1_acc2_manual(data)                                (0x00000040&((data)<<6))
+#define REGD6_reg_p1_testout_sel(data)                                (0x00000030&((data)<<4))
+#define REGD6_reg_p1_ercnt_en(data)                                   (0x00000008&((data)<<3))
+#define REGD6_reg_p1_edge_out(data)                                   (0x00000004&((data)<<2))
+#define REGD6_reg_p1_pi_m_mode(data)                                  (0x00000002&((data)<<1))
+#define REGD6_reg_p1_dyn_kp_en(data)                                  (0x00000001&(data))
+#define REGD6_get_reg_p1_int_init(data)                               ((0xFFFC0000&(data))>>18)
+#define REGD6_get_reg_p1_acc2_period(data)                            ((0x0003FF00&(data))>>8)
+#define REGD6_get_reg_p1_squ_tri(data)                                ((0x00000080&(data))>>7)
+#define REGD6_get_reg_p1_acc2_manual(data)                            ((0x00000040&(data))>>6)
+#define REGD6_get_reg_p1_testout_sel(data)                            ((0x00000030&(data))>>4)
+#define REGD6_get_reg_p1_ercnt_en(data)                               ((0x00000008&(data))>>3)
+#define REGD6_get_reg_p1_edge_out(data)                               ((0x00000004&(data))>>2)
+#define REGD6_get_reg_p1_pi_m_mode(data)                              ((0x00000002&(data))>>1)
+#define REGD6_get_reg_p1_dyn_kp_en(data)                              (0x00000001&(data))
+
+
+#define REGD7                                                         0xba8
+#define REGD7_reg_addr                                                "0x98034ba8"
+#define REGD7_reg                                                     0x98034ba8
+#define REGD7_inst_addr                                               "0x02EA"
+#define REGD7_inst                                                    0x02EA
+#define REGD7_reg_p1_en_m_value_shift                                 (28)
+#define REGD7_reg_p1_st_mode_shift                                    (27)
+#define REGD7_reg_p1_timer_lpf_shift                                  (18)
+#define REGD7_reg_p1_timer_eq_shift                                   (13)
+#define REGD7_reg_p1_timer_ber_shift                                  (8)
+#define REGD7_reg_p1_en_m_value_mask                                  (0xF0000000)
+#define REGD7_reg_p1_st_mode_mask                                     (0x08000000)
+#define REGD7_reg_p1_timer_lpf_mask                                   (0x007C0000)
+#define REGD7_reg_p1_timer_eq_mask                                    (0x0003E000)
+#define REGD7_reg_p1_timer_ber_mask                                   (0x00001F00)
+#define REGD7_reg_p1_en_m_value(data)                                 (0xF0000000&((data)<<28))
+#define REGD7_reg_p1_st_mode(data)                                    (0x08000000&((data)<<27))
+#define REGD7_reg_p1_timer_lpf(data)                                  (0x007C0000&((data)<<18))
+#define REGD7_reg_p1_timer_eq(data)                                   (0x0003E000&((data)<<13))
+#define REGD7_reg_p1_timer_ber(data)                                  (0x00001F00&((data)<<8))
+#define REGD7_get_reg_p1_en_m_value(data)                             ((0xF0000000&(data))>>28)
+#define REGD7_get_reg_p1_st_mode(data)                                ((0x08000000&(data))>>27)
+#define REGD7_get_reg_p1_timer_lpf(data)                              ((0x007C0000&(data))>>18)
+#define REGD7_get_reg_p1_timer_eq(data)                               ((0x0003E000&(data))>>13)
+#define REGD7_get_reg_p1_timer_ber(data)                              ((0x00001F00&(data))>>8)
+
+
+#define REGD8                                                         0xbac
+#define REGD8_reg_addr                                                "0x98034bac"
+#define REGD8_reg                                                     0x98034bac
+#define REGD8_inst_addr                                               "0x02EB"
+#define REGD8_inst                                                    0x02EB
+#define REGD8_p1_st_ro_r_shift                                        (24)
+#define REGD8_p1_en_ro_r_shift                                        (20)
+#define REGD8_p1_st_ro_g_shift                                        (14)
+#define REGD8_p1_en_ro_g_shift                                        (10)
+#define REGD8_p1_st_ro_b_shift                                        (4)
+#define REGD8_p1_en_ro_b_shift                                        (0)
+#define REGD8_p1_st_ro_r_mask                                         (0x1F000000)
+#define REGD8_p1_en_ro_r_mask                                         (0x00F00000)
+#define REGD8_p1_st_ro_g_mask                                         (0x0007C000)
+#define REGD8_p1_en_ro_g_mask                                         (0x00003C00)
+#define REGD8_p1_st_ro_b_mask                                         (0x000001F0)
+#define REGD8_p1_en_ro_b_mask                                         (0x0000000F)
+#define REGD8_p1_st_ro_r(data)                                        (0x1F000000&((data)<<24))
+#define REGD8_p1_en_ro_r(data)                                        (0x00F00000&((data)<<20))
+#define REGD8_p1_st_ro_g(data)                                        (0x0007C000&((data)<<14))
+#define REGD8_p1_en_ro_g(data)                                        (0x00003C00&((data)<<10))
+#define REGD8_p1_st_ro_b(data)                                        (0x000001F0&((data)<<4))
+#define REGD8_p1_en_ro_b(data)                                        (0x0000000F&(data))
+#define REGD8_get_p1_st_ro_r(data)                                    ((0x1F000000&(data))>>24)
+#define REGD8_get_p1_en_ro_r(data)                                    ((0x00F00000&(data))>>20)
+#define REGD8_get_p1_st_ro_g(data)                                    ((0x0007C000&(data))>>14)
+#define REGD8_get_p1_en_ro_g(data)                                    ((0x00003C00&(data))>>10)
+#define REGD8_get_p1_st_ro_b(data)                                    ((0x000001F0&(data))>>4)
+#define REGD8_get_p1_en_ro_b(data)                                    (0x0000000F&(data))
+
+
+#define REGD9                                                         0xbb0
+#define REGD9_reg_addr                                                "0x98034bb0"
+#define REGD9_reg                                                     0x98034bb0
+#define REGD9_inst_addr                                               "0x02EC"
+#define REGD9_inst                                                    0x02EC
+#define REGD9_p1_er_count_r_shift                                     (20)
+#define REGD9_p1_er_count_g_shift                                     (10)
+#define REGD9_p1_er_count_b_shift                                     (0)
+#define REGD9_p1_er_count_r_mask                                      (0x3FF00000)
+#define REGD9_p1_er_count_g_mask                                      (0x000FFC00)
+#define REGD9_p1_er_count_b_mask                                      (0x000003FF)
+#define REGD9_p1_er_count_r(data)                                     (0x3FF00000&((data)<<20))
+#define REGD9_p1_er_count_g(data)                                     (0x000FFC00&((data)<<10))
+#define REGD9_p1_er_count_b(data)                                     (0x000003FF&(data))
+#define REGD9_get_p1_er_count_r(data)                                 ((0x3FF00000&(data))>>20)
+#define REGD9_get_p1_er_count_g(data)                                 ((0x000FFC00&(data))>>10)
+#define REGD9_get_p1_er_count_b(data)                                 (0x000003FF&(data))
+
+
+#define REGD10                                                        0xbb4
+#define REGD10_reg_addr                                               "0x98034bb4"
+#define REGD10_reg                                                    0x98034bb4
+#define REGD10_inst_addr                                              "0x02ED"
+#define REGD10_inst                                                   0x02ED
+#define REGD10_p2_r_dig_rst_n_shift                                   (31)
+#define REGD10_p2_g_dig_rst_n_shift                                   (30)
+#define REGD10_p2_b_dig_rst_n_shift                                   (29)
+#define REGD10_p2_r_cdr_rst_n_shift                                   (28)
+#define REGD10_p2_g_cdr_rst_n_shift                                   (27)
+#define REGD10_p2_b_cdr_rst_n_shift                                   (26)
+#define REGD10_reg_p2_cdr_ckinv_r_shift                               (25)
+#define REGD10_reg_p2_cdr_ckinv_g_shift                               (24)
+#define REGD10_reg_p2_cdr_ckinv_b_shift                               (23)
+#define REGD10_reg_p2_shift_inv_r_shift                               (22)
+#define REGD10_reg_p2_shift_inv_g_shift                               (21)
+#define REGD10_reg_p2_shift_inv_b_shift                               (20)
+#define REGD10_reg_p2_rate_sel_shift                                  (17)
+#define REGD10_reg_p2_kd_shift                                        (16)
+#define REGD10_reg_p2_kp_shift                                        (8)
+#define REGD10_reg_p2_ki_shift                                        (5)
+#define REGD10_reg_p2_bypass_sdm_int_shift                            (4)
+#define REGD10_reg_p2_data_order_shift                                (3)
+#define REGD10_reg_p2_infifo_cnt_shift                                (0)
+#define REGD10_p2_r_dig_rst_n_mask                                    (0x80000000)
+#define REGD10_p2_g_dig_rst_n_mask                                    (0x40000000)
+#define REGD10_p2_b_dig_rst_n_mask                                    (0x20000000)
+#define REGD10_p2_r_cdr_rst_n_mask                                    (0x10000000)
+#define REGD10_p2_g_cdr_rst_n_mask                                    (0x08000000)
+#define REGD10_p2_b_cdr_rst_n_mask                                    (0x04000000)
+#define REGD10_reg_p2_cdr_ckinv_r_mask                                (0x02000000)
+#define REGD10_reg_p2_cdr_ckinv_g_mask                                (0x01000000)
+#define REGD10_reg_p2_cdr_ckinv_b_mask                                (0x00800000)
+#define REGD10_reg_p2_shift_inv_r_mask                                (0x00400000)
+#define REGD10_reg_p2_shift_inv_g_mask                                (0x00200000)
+#define REGD10_reg_p2_shift_inv_b_mask                                (0x00100000)
+#define REGD10_reg_p2_rate_sel_mask                                   (0x000E0000)
+#define REGD10_reg_p2_kd_mask                                         (0x00010000)
+#define REGD10_reg_p2_kp_mask                                         (0x0000FF00)
+#define REGD10_reg_p2_ki_mask                                         (0x000000E0)
+#define REGD10_reg_p2_bypass_sdm_int_mask                             (0x00000010)
+#define REGD10_reg_p2_data_order_mask                                 (0x00000008)
+#define REGD10_reg_p2_infifo_cnt_mask                                 (0x00000007)
+#define REGD10_p2_r_dig_rst_n(data)                                   (0x80000000&((data)<<31))
+#define REGD10_p2_g_dig_rst_n(data)                                   (0x40000000&((data)<<30))
+#define REGD10_p2_b_dig_rst_n(data)                                   (0x20000000&((data)<<29))
+#define REGD10_p2_r_cdr_rst_n(data)                                   (0x10000000&((data)<<28))
+#define REGD10_p2_g_cdr_rst_n(data)                                   (0x08000000&((data)<<27))
+#define REGD10_p2_b_cdr_rst_n(data)                                   (0x04000000&((data)<<26))
+#define REGD10_reg_p2_cdr_ckinv_r(data)                               (0x02000000&((data)<<25))
+#define REGD10_reg_p2_cdr_ckinv_g(data)                               (0x01000000&((data)<<24))
+#define REGD10_reg_p2_cdr_ckinv_b(data)                               (0x00800000&((data)<<23))
+#define REGD10_reg_p2_shift_inv_r(data)                               (0x00400000&((data)<<22))
+#define REGD10_reg_p2_shift_inv_g(data)                               (0x00200000&((data)<<21))
+#define REGD10_reg_p2_shift_inv_b(data)                               (0x00100000&((data)<<20))
+#define REGD10_reg_p2_rate_sel(data)                                  (0x000E0000&((data)<<17))
+#define REGD10_reg_p2_kd(data)                                        (0x00010000&((data)<<16))
+#define REGD10_reg_p2_kp(data)                                        (0x0000FF00&((data)<<8))
+#define REGD10_reg_p2_ki(data)                                        (0x000000E0&((data)<<5))
+#define REGD10_reg_p2_bypass_sdm_int(data)                            (0x00000010&((data)<<4))
+#define REGD10_reg_p2_data_order(data)                                (0x00000008&((data)<<3))
+#define REGD10_reg_p2_infifo_cnt(data)                                (0x00000007&(data))
+#define REGD10_get_p2_r_dig_rst_n(data)                               ((0x80000000&(data))>>31)
+#define REGD10_get_p2_g_dig_rst_n(data)                               ((0x40000000&(data))>>30)
+#define REGD10_get_p2_b_dig_rst_n(data)                               ((0x20000000&(data))>>29)
+#define REGD10_get_p2_r_cdr_rst_n(data)                               ((0x10000000&(data))>>28)
+#define REGD10_get_p2_g_cdr_rst_n(data)                               ((0x08000000&(data))>>27)
+#define REGD10_get_p2_b_cdr_rst_n(data)                               ((0x04000000&(data))>>26)
+#define REGD10_get_reg_p2_cdr_ckinv_r(data)                           ((0x02000000&(data))>>25)
+#define REGD10_get_reg_p2_cdr_ckinv_g(data)                           ((0x01000000&(data))>>24)
+#define REGD10_get_reg_p2_cdr_ckinv_b(data)                           ((0x00800000&(data))>>23)
+#define REGD10_get_reg_p2_shift_inv_r(data)                           ((0x00400000&(data))>>22)
+#define REGD10_get_reg_p2_shift_inv_g(data)                           ((0x00200000&(data))>>21)
+#define REGD10_get_reg_p2_shift_inv_b(data)                           ((0x00100000&(data))>>20)
+#define REGD10_get_reg_p2_rate_sel(data)                              ((0x000E0000&(data))>>17)
+#define REGD10_get_reg_p2_kd(data)                                    ((0x00010000&(data))>>16)
+#define REGD10_get_reg_p2_kp(data)                                    ((0x0000FF00&(data))>>8)
+#define REGD10_get_reg_p2_ki(data)                                    ((0x000000E0&(data))>>5)
+#define REGD10_get_reg_p2_bypass_sdm_int(data)                        ((0x00000010&(data))>>4)
+#define REGD10_get_reg_p2_data_order(data)                            ((0x00000008&(data))>>3)
+#define REGD10_get_reg_p2_infifo_cnt(data)                            (0x00000007&(data))
+
+
+#define REGD11                                                        0xbb8
+#define REGD11_reg_addr                                               "0x98034bb8"
+#define REGD11_reg                                                    0x98034bb8
+#define REGD11_inst_addr                                              "0x02EE"
+#define REGD11_inst                                                   0x02EE
+#define REGD11_reg_p2_int_init_shift                                  (18)
+#define REGD11_reg_p2_acc2_period_shift                               (8)
+#define REGD11_reg_p2_squ_tri_shift                                   (7)
+#define REGD11_reg_p2_acc2_manual_shift                               (6)
+#define REGD11_reg_p2_testout_sel_shift                               (4)
+#define REGD11_reg_p2_ercnt_en_shift                                  (3)
+#define REGD11_reg_p2_edge_out_shift                                  (2)
+#define REGD11_reg_p2_pi_m_mode_shift                                 (1)
+#define REGD11_reg_p2_dyn_kp_en_shift                                 (0)
+#define REGD11_reg_p2_int_init_mask                                   (0xFFFC0000)
+#define REGD11_reg_p2_acc2_period_mask                                (0x0003FF00)
+#define REGD11_reg_p2_squ_tri_mask                                    (0x00000080)
+#define REGD11_reg_p2_acc2_manual_mask                                (0x00000040)
+#define REGD11_reg_p2_testout_sel_mask                                (0x00000030)
+#define REGD11_reg_p2_ercnt_en_mask                                   (0x00000008)
+#define REGD11_reg_p2_edge_out_mask                                   (0x00000004)
+#define REGD11_reg_p2_pi_m_mode_mask                                  (0x00000002)
+#define REGD11_reg_p2_dyn_kp_en_mask                                  (0x00000001)
+#define REGD11_reg_p2_int_init(data)                                  (0xFFFC0000&((data)<<18))
+#define REGD11_reg_p2_acc2_period(data)                               (0x0003FF00&((data)<<8))
+#define REGD11_reg_p2_squ_tri(data)                                   (0x00000080&((data)<<7))
+#define REGD11_reg_p2_acc2_manual(data)                               (0x00000040&((data)<<6))
+#define REGD11_reg_p2_testout_sel(data)                               (0x00000030&((data)<<4))
+#define REGD11_reg_p2_ercnt_en(data)                                  (0x00000008&((data)<<3))
+#define REGD11_reg_p2_edge_out(data)                                  (0x00000004&((data)<<2))
+#define REGD11_reg_p2_pi_m_mode(data)                                 (0x00000002&((data)<<1))
+#define REGD11_reg_p2_dyn_kp_en(data)                                 (0x00000001&(data))
+#define REGD11_get_reg_p2_int_init(data)                              ((0xFFFC0000&(data))>>18)
+#define REGD11_get_reg_p2_acc2_period(data)                           ((0x0003FF00&(data))>>8)
+#define REGD11_get_reg_p2_squ_tri(data)                               ((0x00000080&(data))>>7)
+#define REGD11_get_reg_p2_acc2_manual(data)                           ((0x00000040&(data))>>6)
+#define REGD11_get_reg_p2_testout_sel(data)                           ((0x00000030&(data))>>4)
+#define REGD11_get_reg_p2_ercnt_en(data)                              ((0x00000008&(data))>>3)
+#define REGD11_get_reg_p2_edge_out(data)                              ((0x00000004&(data))>>2)
+#define REGD11_get_reg_p2_pi_m_mode(data)                             ((0x00000002&(data))>>1)
+#define REGD11_get_reg_p2_dyn_kp_en(data)                             (0x00000001&(data))
+
+
+#define REGD12                                                        0xbbc
+#define REGD12_reg_addr                                               "0x98034bbc"
+#define REGD12_reg                                                    0x98034bbc
+#define REGD12_inst_addr                                              "0x02EF"
+#define REGD12_inst                                                   0x02EF
+#define REGD12_reg_p2_en_m_value_shift                                (28)
+#define REGD12_reg_p2_st_mode_shift                                   (27)
+#define REGD12_reg_p2_timer_lpf_shift                                 (18)
+#define REGD12_reg_p2_timer_eq_shift                                  (13)
+#define REGD12_reg_p2_timer_ber_shift                                 (8)
+#define REGD12_reg_p2_en_m_value_mask                                 (0xF0000000)
+#define REGD12_reg_p2_st_mode_mask                                    (0x08000000)
+#define REGD12_reg_p2_timer_lpf_mask                                  (0x007C0000)
+#define REGD12_reg_p2_timer_eq_mask                                   (0x0003E000)
+#define REGD12_reg_p2_timer_ber_mask                                  (0x00001F00)
+#define REGD12_reg_p2_en_m_value(data)                                (0xF0000000&((data)<<28))
+#define REGD12_reg_p2_st_mode(data)                                   (0x08000000&((data)<<27))
+#define REGD12_reg_p2_timer_lpf(data)                                 (0x007C0000&((data)<<18))
+#define REGD12_reg_p2_timer_eq(data)                                  (0x0003E000&((data)<<13))
+#define REGD12_reg_p2_timer_ber(data)                                 (0x00001F00&((data)<<8))
+#define REGD12_get_reg_p2_en_m_value(data)                            ((0xF0000000&(data))>>28)
+#define REGD12_get_reg_p2_st_mode(data)                               ((0x08000000&(data))>>27)
+#define REGD12_get_reg_p2_timer_lpf(data)                             ((0x007C0000&(data))>>18)
+#define REGD12_get_reg_p2_timer_eq(data)                              ((0x0003E000&(data))>>13)
+#define REGD12_get_reg_p2_timer_ber(data)                             ((0x00001F00&(data))>>8)
+
+
+#define REGD13                                                        0xbc0
+#define REGD13_reg_addr                                               "0x98034bc0"
+#define REGD13_reg                                                    0x98034bc0
+#define REGD13_inst_addr                                              "0x02F0"
+#define REGD13_inst                                                   0x02F0
+#define REGD13_p2_st_ro_r_shift                                       (24)
+#define REGD13_p2_en_ro_r_shift                                       (20)
+#define REGD13_p2_st_ro_g_shift                                       (14)
+#define REGD13_p2_en_ro_g_shift                                       (10)
+#define REGD13_p2_st_ro_b_shift                                       (4)
+#define REGD13_p2_en_ro_b_shift                                       (0)
+#define REGD13_p2_st_ro_r_mask                                        (0x1F000000)
+#define REGD13_p2_en_ro_r_mask                                        (0x00F00000)
+#define REGD13_p2_st_ro_g_mask                                        (0x0007C000)
+#define REGD13_p2_en_ro_g_mask                                        (0x00003C00)
+#define REGD13_p2_st_ro_b_mask                                        (0x000001F0)
+#define REGD13_p2_en_ro_b_mask                                        (0x0000000F)
+#define REGD13_p2_st_ro_r(data)                                       (0x1F000000&((data)<<24))
+#define REGD13_p2_en_ro_r(data)                                       (0x00F00000&((data)<<20))
+#define REGD13_p2_st_ro_g(data)                                       (0x0007C000&((data)<<14))
+#define REGD13_p2_en_ro_g(data)                                       (0x00003C00&((data)<<10))
+#define REGD13_p2_st_ro_b(data)                                       (0x000001F0&((data)<<4))
+#define REGD13_p2_en_ro_b(data)                                       (0x0000000F&(data))
+#define REGD13_get_p2_st_ro_r(data)                                   ((0x1F000000&(data))>>24)
+#define REGD13_get_p2_en_ro_r(data)                                   ((0x00F00000&(data))>>20)
+#define REGD13_get_p2_st_ro_g(data)                                   ((0x0007C000&(data))>>14)
+#define REGD13_get_p2_en_ro_g(data)                                   ((0x00003C00&(data))>>10)
+#define REGD13_get_p2_st_ro_b(data)                                   ((0x000001F0&(data))>>4)
+#define REGD13_get_p2_en_ro_b(data)                                   (0x0000000F&(data))
+
+
+#define REGD14                                                        0xbc4
+#define REGD14_reg_addr                                               "0x98034bc4"
+#define REGD14_reg                                                    0x98034bc4
+#define REGD14_inst_addr                                              "0x02F1"
+#define REGD14_inst                                                   0x02F1
+#define REGD14_p2_er_count_r_shift                                    (20)
+#define REGD14_p2_er_count_g_shift                                    (10)
+#define REGD14_p2_er_count_b_shift                                    (0)
+#define REGD14_p2_er_count_r_mask                                     (0x3FF00000)
+#define REGD14_p2_er_count_g_mask                                     (0x000FFC00)
+#define REGD14_p2_er_count_b_mask                                     (0x000003FF)
+#define REGD14_p2_er_count_r(data)                                    (0x3FF00000&((data)<<20))
+#define REGD14_p2_er_count_g(data)                                    (0x000FFC00&((data)<<10))
+#define REGD14_p2_er_count_b(data)                                    (0x000003FF&(data))
+#define REGD14_get_p2_er_count_r(data)                                ((0x3FF00000&(data))>>20)
+#define REGD14_get_p2_er_count_g(data)                                ((0x000FFC00&(data))>>10)
+#define REGD14_get_p2_er_count_b(data)                                (0x000003FF&(data))
+
+
+#define REGD15                                                        0xbc8
+#define REGD15_reg_addr                                               "0x98034bc8"
+#define REGD15_reg                                                    0x98034bc8
+#define REGD15_inst_addr                                              "0x02F2"
+#define REGD15_inst                                                   0x02F2
+#define REGD15_p3_r_dig_rst_n_shift                                   (31)
+#define REGD15_p3_g_dig_rst_n_shift                                   (30)
+#define REGD15_p3_b_dig_rst_n_shift                                   (29)
+#define REGD15_p3_r_cdr_rst_n_shift                                   (28)
+#define REGD15_p3_g_cdr_rst_n_shift                                   (27)
+#define REGD15_p3_b_cdr_rst_n_shift                                   (26)
+#define REGD15_reg_p3_cdr_ckinv_r_shift                               (25)
+#define REGD15_reg_p3_cdr_ckinv_g_shift                               (24)
+#define REGD15_reg_p3_cdr_ckinv_b_shift                               (23)
+#define REGD15_reg_p3_shift_inv_r_shift                               (22)
+#define REGD15_reg_p3_shift_inv_g_shift                               (21)
+#define REGD15_reg_p3_shift_inv_b_shift                               (20)
+#define REGD15_reg_p3_rate_sel_shift                                  (17)
+#define REGD15_reg_p3_kd_shift                                        (16)
+#define REGD15_reg_p3_kp_shift                                        (8)
+#define REGD15_reg_p3_ki_shift                                        (5)
+#define REGD15_reg_p3_bypass_sdm_int_shift                            (4)
+#define REGD15_reg_p3_data_order_shift                                (3)
+#define REGD15_reg_p3_infifo_cnt_shift                                (0)
+#define REGD15_p3_r_dig_rst_n_mask                                    (0x80000000)
+#define REGD15_p3_g_dig_rst_n_mask                                    (0x40000000)
+#define REGD15_p3_b_dig_rst_n_mask                                    (0x20000000)
+#define REGD15_p3_r_cdr_rst_n_mask                                    (0x10000000)
+#define REGD15_p3_g_cdr_rst_n_mask                                    (0x08000000)
+#define REGD15_p3_b_cdr_rst_n_mask                                    (0x04000000)
+#define REGD15_reg_p3_cdr_ckinv_r_mask                                (0x02000000)
+#define REGD15_reg_p3_cdr_ckinv_g_mask                                (0x01000000)
+#define REGD15_reg_p3_cdr_ckinv_b_mask                                (0x00800000)
+#define REGD15_reg_p3_shift_inv_r_mask                                (0x00400000)
+#define REGD15_reg_p3_shift_inv_g_mask                                (0x00200000)
+#define REGD15_reg_p3_shift_inv_b_mask                                (0x00100000)
+#define REGD15_reg_p3_rate_sel_mask                                   (0x000E0000)
+#define REGD15_reg_p3_kd_mask                                         (0x00010000)
+#define REGD15_reg_p3_kp_mask                                         (0x0000FF00)
+#define REGD15_reg_p3_ki_mask                                         (0x000000E0)
+#define REGD15_reg_p3_bypass_sdm_int_mask                             (0x00000010)
+#define REGD15_reg_p3_data_order_mask                                 (0x00000008)
+#define REGD15_reg_p3_infifo_cnt_mask                                 (0x00000007)
+#define REGD15_p3_r_dig_rst_n(data)                                   (0x80000000&((data)<<31))
+#define REGD15_p3_g_dig_rst_n(data)                                   (0x40000000&((data)<<30))
+#define REGD15_p3_b_dig_rst_n(data)                                   (0x20000000&((data)<<29))
+#define REGD15_p3_r_cdr_rst_n(data)                                   (0x10000000&((data)<<28))
+#define REGD15_p3_g_cdr_rst_n(data)                                   (0x08000000&((data)<<27))
+#define REGD15_p3_b_cdr_rst_n(data)                                   (0x04000000&((data)<<26))
+#define REGD15_reg_p3_cdr_ckinv_r(data)                               (0x02000000&((data)<<25))
+#define REGD15_reg_p3_cdr_ckinv_g(data)                               (0x01000000&((data)<<24))
+#define REGD15_reg_p3_cdr_ckinv_b(data)                               (0x00800000&((data)<<23))
+#define REGD15_reg_p3_shift_inv_r(data)                               (0x00400000&((data)<<22))
+#define REGD15_reg_p3_shift_inv_g(data)                               (0x00200000&((data)<<21))
+#define REGD15_reg_p3_shift_inv_b(data)                               (0x00100000&((data)<<20))
+#define REGD15_reg_p3_rate_sel(data)                                  (0x000E0000&((data)<<17))
+#define REGD15_reg_p3_kd(data)                                        (0x00010000&((data)<<16))
+#define REGD15_reg_p3_kp(data)                                        (0x0000FF00&((data)<<8))
+#define REGD15_reg_p3_ki(data)                                        (0x000000E0&((data)<<5))
+#define REGD15_reg_p3_bypass_sdm_int(data)                            (0x00000010&((data)<<4))
+#define REGD15_reg_p3_data_order(data)                                (0x00000008&((data)<<3))
+#define REGD15_reg_p3_infifo_cnt(data)                                (0x00000007&(data))
+#define REGD15_get_p3_r_dig_rst_n(data)                               ((0x80000000&(data))>>31)
+#define REGD15_get_p3_g_dig_rst_n(data)                               ((0x40000000&(data))>>30)
+#define REGD15_get_p3_b_dig_rst_n(data)                               ((0x20000000&(data))>>29)
+#define REGD15_get_p3_r_cdr_rst_n(data)                               ((0x10000000&(data))>>28)
+#define REGD15_get_p3_g_cdr_rst_n(data)                               ((0x08000000&(data))>>27)
+#define REGD15_get_p3_b_cdr_rst_n(data)                               ((0x04000000&(data))>>26)
+#define REGD15_get_reg_p3_cdr_ckinv_r(data)                           ((0x02000000&(data))>>25)
+#define REGD15_get_reg_p3_cdr_ckinv_g(data)                           ((0x01000000&(data))>>24)
+#define REGD15_get_reg_p3_cdr_ckinv_b(data)                           ((0x00800000&(data))>>23)
+#define REGD15_get_reg_p3_shift_inv_r(data)                           ((0x00400000&(data))>>22)
+#define REGD15_get_reg_p3_shift_inv_g(data)                           ((0x00200000&(data))>>21)
+#define REGD15_get_reg_p3_shift_inv_b(data)                           ((0x00100000&(data))>>20)
+#define REGD15_get_reg_p3_rate_sel(data)                              ((0x000E0000&(data))>>17)
+#define REGD15_get_reg_p3_kd(data)                                    ((0x00010000&(data))>>16)
+#define REGD15_get_reg_p3_kp(data)                                    ((0x0000FF00&(data))>>8)
+#define REGD15_get_reg_p3_ki(data)                                    ((0x000000E0&(data))>>5)
+#define REGD15_get_reg_p3_bypass_sdm_int(data)                        ((0x00000010&(data))>>4)
+#define REGD15_get_reg_p3_data_order(data)                            ((0x00000008&(data))>>3)
+#define REGD15_get_reg_p3_infifo_cnt(data)                            (0x00000007&(data))
+
+
+#define REGD16                                                        0xbcc
+#define REGD16_reg_addr                                               "0x98034bcc"
+#define REGD16_reg                                                    0x98034bcc
+#define REGD16_inst_addr                                              "0x02F3"
+#define REGD16_inst                                                   0x02F3
+#define REGD16_reg_p3_int_init_shift                                  (18)
+#define REGD16_reg_p3_acc2_period_shift                               (8)
+#define REGD16_reg_p3_squ_tri_shift                                   (7)
+#define REGD16_reg_p3_acc2_manual_shift                               (6)
+#define REGD16_reg_p3_testout_sel_shift                               (4)
+#define REGD16_reg_p3_ercnt_en_shift                                  (3)
+#define REGD16_reg_p3_edge_out_shift                                  (2)
+#define REGD16_reg_p3_pi_m_mode_shift                                 (1)
+#define REGD16_reg_p3_dyn_kp_en_shift                                 (0)
+#define REGD16_reg_p3_int_init_mask                                   (0xFFFC0000)
+#define REGD16_reg_p3_acc2_period_mask                                (0x0003FF00)
+#define REGD16_reg_p3_squ_tri_mask                                    (0x00000080)
+#define REGD16_reg_p3_acc2_manual_mask                                (0x00000040)
+#define REGD16_reg_p3_testout_sel_mask                                (0x00000030)
+#define REGD16_reg_p3_ercnt_en_mask                                   (0x00000008)
+#define REGD16_reg_p3_edge_out_mask                                   (0x00000004)
+#define REGD16_reg_p3_pi_m_mode_mask                                  (0x00000002)
+#define REGD16_reg_p3_dyn_kp_en_mask                                  (0x00000001)
+#define REGD16_reg_p3_int_init(data)                                  (0xFFFC0000&((data)<<18))
+#define REGD16_reg_p3_acc2_period(data)                               (0x0003FF00&((data)<<8))
+#define REGD16_reg_p3_squ_tri(data)                                   (0x00000080&((data)<<7))
+#define REGD16_reg_p3_acc2_manual(data)                               (0x00000040&((data)<<6))
+#define REGD16_reg_p3_testout_sel(data)                               (0x00000030&((data)<<4))
+#define REGD16_reg_p3_ercnt_en(data)                                  (0x00000008&((data)<<3))
+#define REGD16_reg_p3_edge_out(data)                                  (0x00000004&((data)<<2))
+#define REGD16_reg_p3_pi_m_mode(data)                                 (0x00000002&((data)<<1))
+#define REGD16_reg_p3_dyn_kp_en(data)                                 (0x00000001&(data))
+#define REGD16_get_reg_p3_int_init(data)                              ((0xFFFC0000&(data))>>18)
+#define REGD16_get_reg_p3_acc2_period(data)                           ((0x0003FF00&(data))>>8)
+#define REGD16_get_reg_p3_squ_tri(data)                               ((0x00000080&(data))>>7)
+#define REGD16_get_reg_p3_acc2_manual(data)                           ((0x00000040&(data))>>6)
+#define REGD16_get_reg_p3_testout_sel(data)                           ((0x00000030&(data))>>4)
+#define REGD16_get_reg_p3_ercnt_en(data)                              ((0x00000008&(data))>>3)
+#define REGD16_get_reg_p3_edge_out(data)                              ((0x00000004&(data))>>2)
+#define REGD16_get_reg_p3_pi_m_mode(data)                             ((0x00000002&(data))>>1)
+#define REGD16_get_reg_p3_dyn_kp_en(data)                             (0x00000001&(data))
+
+
+#define REGD17                                                        0xbd0
+#define REGD17_reg_addr                                               "0x98034bd0"
+#define REGD17_reg                                                    0x98034bd0
+#define REGD17_inst_addr                                              "0x02F4"
+#define REGD17_inst                                                   0x02F4
+#define REGD17_reg_p3_en_m_value_shift                                (28)
+#define REGD17_reg_p3_st_mode_shift                                   (27)
+#define REGD17_reg_p3_timer_lpf_shift                                 (18)
+#define REGD17_reg_p3_timer_eq_shift                                  (13)
+#define REGD17_reg_p3_timer_ber_shift                                 (8)
+#define REGD17_reg_p3_en_m_value_mask                                 (0xF0000000)
+#define REGD17_reg_p3_st_mode_mask                                    (0x08000000)
+#define REGD17_reg_p3_timer_lpf_mask                                  (0x007C0000)
+#define REGD17_reg_p3_timer_eq_mask                                   (0x0003E000)
+#define REGD17_reg_p3_timer_ber_mask                                  (0x00001F00)
+#define REGD17_reg_p3_en_m_value(data)                                (0xF0000000&((data)<<28))
+#define REGD17_reg_p3_st_mode(data)                                   (0x08000000&((data)<<27))
+#define REGD17_reg_p3_timer_lpf(data)                                 (0x007C0000&((data)<<18))
+#define REGD17_reg_p3_timer_eq(data)                                  (0x0003E000&((data)<<13))
+#define REGD17_reg_p3_timer_ber(data)                                 (0x00001F00&((data)<<8))
+#define REGD17_get_reg_p3_en_m_value(data)                            ((0xF0000000&(data))>>28)
+#define REGD17_get_reg_p3_st_mode(data)                               ((0x08000000&(data))>>27)
+#define REGD17_get_reg_p3_timer_lpf(data)                             ((0x007C0000&(data))>>18)
+#define REGD17_get_reg_p3_timer_eq(data)                              ((0x0003E000&(data))>>13)
+#define REGD17_get_reg_p3_timer_ber(data)                             ((0x00001F00&(data))>>8)
+
+
+#define REGD18                                                        0xbd4
+#define REGD18_reg_addr                                               "0x98034bd4"
+#define REGD18_reg                                                    0x98034bd4
+#define REGD18_inst_addr                                              "0x02F5"
+#define REGD18_inst                                                   0x02F5
+#define REGD18_p3_st_ro_r_shift                                       (24)
+#define REGD18_p3_en_ro_r_shift                                       (20)
+#define REGD18_p3_st_ro_g_shift                                       (14)
+#define REGD18_p3_en_ro_g_shift                                       (10)
+#define REGD18_p3_st_ro_b_shift                                       (4)
+#define REGD18_p3_en_ro_b_shift                                       (0)
+#define REGD18_p3_st_ro_r_mask                                        (0x1F000000)
+#define REGD18_p3_en_ro_r_mask                                        (0x00F00000)
+#define REGD18_p3_st_ro_g_mask                                        (0x0007C000)
+#define REGD18_p3_en_ro_g_mask                                        (0x00003C00)
+#define REGD18_p3_st_ro_b_mask                                        (0x000001F0)
+#define REGD18_p3_en_ro_b_mask                                        (0x0000000F)
+#define REGD18_p3_st_ro_r(data)                                       (0x1F000000&((data)<<24))
+#define REGD18_p3_en_ro_r(data)                                       (0x00F00000&((data)<<20))
+#define REGD18_p3_st_ro_g(data)                                       (0x0007C000&((data)<<14))
+#define REGD18_p3_en_ro_g(data)                                       (0x00003C00&((data)<<10))
+#define REGD18_p3_st_ro_b(data)                                       (0x000001F0&((data)<<4))
+#define REGD18_p3_en_ro_b(data)                                       (0x0000000F&(data))
+#define REGD18_get_p3_st_ro_r(data)                                   ((0x1F000000&(data))>>24)
+#define REGD18_get_p3_en_ro_r(data)                                   ((0x00F00000&(data))>>20)
+#define REGD18_get_p3_st_ro_g(data)                                   ((0x0007C000&(data))>>14)
+#define REGD18_get_p3_en_ro_g(data)                                   ((0x00003C00&(data))>>10)
+#define REGD18_get_p3_st_ro_b(data)                                   ((0x000001F0&(data))>>4)
+#define REGD18_get_p3_en_ro_b(data)                                   (0x0000000F&(data))
+
+
+#define REGD19                                                        0xbd8
+#define REGD19_reg_addr                                               "0x98034bd8"
+#define REGD19_reg                                                    0x98034bd8
+#define REGD19_inst_addr                                              "0x02F6"
+#define REGD19_inst                                                   0x02F6
+#define REGD19_p3_er_count_r_shift                                    (20)
+#define REGD19_p3_er_count_g_shift                                    (10)
+#define REGD19_p3_er_count_b_shift                                    (0)
+#define REGD19_p3_er_count_r_mask                                     (0x3FF00000)
+#define REGD19_p3_er_count_g_mask                                     (0x000FFC00)
+#define REGD19_p3_er_count_b_mask                                     (0x000003FF)
+#define REGD19_p3_er_count_r(data)                                    (0x3FF00000&((data)<<20))
+#define REGD19_p3_er_count_g(data)                                    (0x000FFC00&((data)<<10))
+#define REGD19_p3_er_count_b(data)                                    (0x000003FF&(data))
+#define REGD19_get_p3_er_count_r(data)                                ((0x3FF00000&(data))>>20)
+#define REGD19_get_p3_er_count_g(data)                                ((0x000FFC00&(data))>>10)
+#define REGD19_get_p3_er_count_b(data)                                (0x000003FF&(data))
+
+
+#define REGD20                                                        0xbdc
+#define REGD20_reg_addr                                               "0x98034bdc"
+#define REGD20_reg                                                    0x98034bdc
+#define REGD20_inst_addr                                              "0x02F7"
+#define REGD20_inst                                                   0x02F7
+#define REGD20_reg_p0_bypass_clk_rdy_shift                            (31)
+#define REGD20_reg_p0_bypass_eqen_rdy_shift                           (30)
+#define REGD20_reg_p0_bypass_data_rdy_shift                           (29)
+#define REGD20_reg_p0_bypass_pi_shift                                 (28)
+#define REGD20_reg_p0_data_rdy_time_shift                             (24)
+#define REGD20_reg_p0_en_clkout_manual_shift                          (23)
+#define REGD20_reg_p0_en_eqen_manual_shift                            (22)
+#define REGD20_reg_p0_en_data_manual_shift                            (21)
+#define REGD20_reg_p0_eqen_rdy_time_shift                             (17)
+#define REGD20_reg_p0_order_shift                                     (16)
+#define REGD20_reg_p0_pll_wd_base_time_shift                          (13)
+#define REGD20_reg_p0_pll_wd_en_shift                                 (12)
+#define REGD20_reg_p0_pll_wd_rst_wid_shift                            (10)
+#define REGD20_reg_p0_pll_wd_time_rdy_shift                           (8)
+#define REGD20_reg_p0_acdr_l0_en_shift                                (7)
+#define REGD20_reg_p0_bypass_eqen_rdy_l0_shift                        (6)
+#define REGD20_reg_p0_bypass_data_rdy_l0_shift                        (5)
+#define REGD20_reg_p0_en_eqen_manual_l0_shift                         (4)
+#define REGD20_reg_p0_en_data_manual_l0_shift                         (3)
+#define REGD20_p0_pll_wd_ckrdy_ro_shift                               (2)
+#define REGD20_p0_pll_wd_rst_wc_shift                                 (1)
+#define REGD20_p0_wdog_rst_n_shift                                    (0)
+#define REGD20_reg_p0_bypass_clk_rdy_mask                             (0x80000000)
+#define REGD20_reg_p0_bypass_eqen_rdy_mask                            (0x40000000)
+#define REGD20_reg_p0_bypass_data_rdy_mask                            (0x20000000)
+#define REGD20_reg_p0_bypass_pi_mask                                  (0x10000000)
+#define REGD20_reg_p0_data_rdy_time_mask                              (0x0F000000)
+#define REGD20_reg_p0_en_clkout_manual_mask                           (0x00800000)
+#define REGD20_reg_p0_en_eqen_manual_mask                             (0x00400000)
+#define REGD20_reg_p0_en_data_manual_mask                             (0x00200000)
+#define REGD20_reg_p0_eqen_rdy_time_mask                              (0x001E0000)
+#define REGD20_reg_p0_order_mask                                      (0x00010000)
+#define REGD20_reg_p0_pll_wd_base_time_mask                           (0x0000E000)
+#define REGD20_reg_p0_pll_wd_en_mask                                  (0x00001000)
+#define REGD20_reg_p0_pll_wd_rst_wid_mask                             (0x00000C00)
+#define REGD20_reg_p0_pll_wd_time_rdy_mask                            (0x00000300)
+#define REGD20_reg_p0_acdr_l0_en_mask                                 (0x00000080)
+#define REGD20_reg_p0_bypass_eqen_rdy_l0_mask                         (0x00000040)
+#define REGD20_reg_p0_bypass_data_rdy_l0_mask                         (0x00000020)
+#define REGD20_reg_p0_en_eqen_manual_l0_mask                          (0x00000010)
+#define REGD20_reg_p0_en_data_manual_l0_mask                          (0x00000008)
+#define REGD20_p0_pll_wd_ckrdy_ro_mask                                (0x00000004)
+#define REGD20_p0_pll_wd_rst_wc_mask                                  (0x00000002)
+#define REGD20_p0_wdog_rst_n_mask                                     (0x00000001)
+#define REGD20_reg_p0_bypass_clk_rdy(data)                            (0x80000000&((data)<<31))
+#define REGD20_reg_p0_bypass_eqen_rdy(data)                           (0x40000000&((data)<<30))
+#define REGD20_reg_p0_bypass_data_rdy(data)                           (0x20000000&((data)<<29))
+#define REGD20_reg_p0_bypass_pi(data)                                 (0x10000000&((data)<<28))
+#define REGD20_reg_p0_data_rdy_time(data)                             (0x0F000000&((data)<<24))
+#define REGD20_reg_p0_en_clkout_manual(data)                          (0x00800000&((data)<<23))
+#define REGD20_reg_p0_en_eqen_manual(data)                            (0x00400000&((data)<<22))
+#define REGD20_reg_p0_en_data_manual(data)                            (0x00200000&((data)<<21))
+#define REGD20_reg_p0_eqen_rdy_time(data)                             (0x001E0000&((data)<<17))
+#define REGD20_reg_p0_order(data)                                     (0x00010000&((data)<<16))
+#define REGD20_reg_p0_pll_wd_base_time(data)                          (0x0000E000&((data)<<13))
+#define REGD20_reg_p0_pll_wd_en(data)                                 (0x00001000&((data)<<12))
+#define REGD20_reg_p0_pll_wd_rst_wid(data)                            (0x00000C00&((data)<<10))
+#define REGD20_reg_p0_pll_wd_time_rdy(data)                           (0x00000300&((data)<<8))
+#define REGD20_reg_p0_acdr_l0_en(data)                                (0x00000080&((data)<<7))
+#define REGD20_reg_p0_bypass_eqen_rdy_l0(data)                        (0x00000040&((data)<<6))
+#define REGD20_reg_p0_bypass_data_rdy_l0(data)                        (0x00000020&((data)<<5))
+#define REGD20_reg_p0_en_eqen_manual_l0(data)                         (0x00000010&((data)<<4))
+#define REGD20_reg_p0_en_data_manual_l0(data)                         (0x00000008&((data)<<3))
+#define REGD20_p0_pll_wd_ckrdy_ro(data)                               (0x00000004&((data)<<2))
+#define REGD20_p0_pll_wd_rst_wc(data)                                 (0x00000002&((data)<<1))
+#define REGD20_p0_wdog_rst_n(data)                                    (0x00000001&(data))
+#define REGD20_get_reg_p0_bypass_clk_rdy(data)                        ((0x80000000&(data))>>31)
+#define REGD20_get_reg_p0_bypass_eqen_rdy(data)                       ((0x40000000&(data))>>30)
+#define REGD20_get_reg_p0_bypass_data_rdy(data)                       ((0x20000000&(data))>>29)
+#define REGD20_get_reg_p0_bypass_pi(data)                             ((0x10000000&(data))>>28)
+#define REGD20_get_reg_p0_data_rdy_time(data)                         ((0x0F000000&(data))>>24)
+#define REGD20_get_reg_p0_en_clkout_manual(data)                      ((0x00800000&(data))>>23)
+#define REGD20_get_reg_p0_en_eqen_manual(data)                        ((0x00400000&(data))>>22)
+#define REGD20_get_reg_p0_en_data_manual(data)                        ((0x00200000&(data))>>21)
+#define REGD20_get_reg_p0_eqen_rdy_time(data)                         ((0x001E0000&(data))>>17)
+#define REGD20_get_reg_p0_order(data)                                 ((0x00010000&(data))>>16)
+#define REGD20_get_reg_p0_pll_wd_base_time(data)                      ((0x0000E000&(data))>>13)
+#define REGD20_get_reg_p0_pll_wd_en(data)                             ((0x00001000&(data))>>12)
+#define REGD20_get_reg_p0_pll_wd_rst_wid(data)                        ((0x00000C00&(data))>>10)
+#define REGD20_get_reg_p0_pll_wd_time_rdy(data)                       ((0x00000300&(data))>>8)
+#define REGD20_get_reg_p0_acdr_l0_en(data)                            ((0x00000080&(data))>>7)
+#define REGD20_get_reg_p0_bypass_eqen_rdy_l0(data)                    ((0x00000040&(data))>>6)
+#define REGD20_get_reg_p0_bypass_data_rdy_l0(data)                    ((0x00000020&(data))>>5)
+#define REGD20_get_reg_p0_en_eqen_manual_l0(data)                     ((0x00000010&(data))>>4)
+#define REGD20_get_reg_p0_en_data_manual_l0(data)                     ((0x00000008&(data))>>3)
+#define REGD20_get_p0_pll_wd_ckrdy_ro(data)                           ((0x00000004&(data))>>2)
+#define REGD20_get_p0_pll_wd_rst_wc(data)                             ((0x00000002&(data))>>1)
+#define REGD20_get_p0_wdog_rst_n(data)                                (0x00000001&(data))
+
+
+#define REGD21                                                        0xbe0
+#define REGD21_reg_addr                                               "0x98034be0"
+#define REGD21_reg                                                    0x98034be0
+#define REGD21_inst_addr                                              "0x02F8"
+#define REGD21_inst                                                   0x02F8
+#define REGD21_reg_p0_wd_sdm_en_shift                                 (31)
+#define REGD21_reg_p0_f_code_shift                                    (16)
+#define REGD21_reg_p0_n_code_shift                                    (0)
+#define REGD21_reg_p0_wd_sdm_en_mask                                  (0x80000000)
+#define REGD21_reg_p0_f_code_mask                                     (0x0FFF0000)
+#define REGD21_reg_p0_n_code_mask                                     (0x000001FF)
+#define REGD21_reg_p0_wd_sdm_en(data)                                 (0x80000000&((data)<<31))
+#define REGD21_reg_p0_f_code(data)                                    (0x0FFF0000&((data)<<16))
+#define REGD21_reg_p0_n_code(data)                                    (0x000001FF&(data))
+#define REGD21_get_reg_p0_wd_sdm_en(data)                             ((0x80000000&(data))>>31)
+#define REGD21_get_reg_p0_f_code(data)                                ((0x0FFF0000&(data))>>16)
+#define REGD21_get_reg_p0_n_code(data)                                (0x000001FF&(data))
+
+
+#define REGD22                                                        0xbe4
+#define REGD22_reg_addr                                               "0x98034be4"
+#define REGD22_reg                                                    0x98034be4
+#define REGD22_inst_addr                                              "0x02F9"
+#define REGD22_inst                                                   0x02F9
+#define REGD22_reg_p1_bypass_clk_rdy_shift                            (31)
+#define REGD22_reg_p1_bypass_eqen_rdy_shift                           (30)
+#define REGD22_reg_p1_bypass_data_rdy_shift                           (29)
+#define REGD22_reg_p1_bypass_pi_shift                                 (28)
+#define REGD22_reg_p1_data_rdy_time_shift                             (24)
+#define REGD22_reg_p1_en_clkout_manual_shift                          (23)
+#define REGD22_reg_p1_en_eqen_manual_shift                            (22)
+#define REGD22_reg_p1_en_data_manual_shift                            (21)
+#define REGD22_reg_p1_eqen_rdy_time_shift                             (17)
+#define REGD22_reg_p1_order_shift                                     (16)
+#define REGD22_reg_p1_pll_wd_base_time_shift                          (13)
+#define REGD22_reg_p1_pll_wd_en_shift                                 (12)
+#define REGD22_reg_p1_pll_wd_rst_wid_shift                            (10)
+#define REGD22_reg_p1_pll_wd_time_rdy_shift                           (8)
+#define REGD22_reg_p1_acdr_l0_en_shift                                (7)
+#define REGD22_reg_p1_bypass_eqen_rdy_l0_shift                        (6)
+#define REGD22_reg_p1_bypass_data_rdy_l0_shift                        (5)
+#define REGD22_reg_p1_en_eqen_manual_l0_shift                         (4)
+#define REGD22_reg_p1_en_data_manual_l0_shift                         (3)
+#define REGD22_p1_pll_wd_ckrdy_ro_shift                               (2)
+#define REGD22_p1_pll_wd_rst_wc_shift                                 (1)
+#define REGD22_p1_wdog_rst_n_shift                                    (0)
+#define REGD22_reg_p1_bypass_clk_rdy_mask                             (0x80000000)
+#define REGD22_reg_p1_bypass_eqen_rdy_mask                            (0x40000000)
+#define REGD22_reg_p1_bypass_data_rdy_mask                            (0x20000000)
+#define REGD22_reg_p1_bypass_pi_mask                                  (0x10000000)
+#define REGD22_reg_p1_data_rdy_time_mask                              (0x0F000000)
+#define REGD22_reg_p1_en_clkout_manual_mask                           (0x00800000)
+#define REGD22_reg_p1_en_eqen_manual_mask                             (0x00400000)
+#define REGD22_reg_p1_en_data_manual_mask                             (0x00200000)
+#define REGD22_reg_p1_eqen_rdy_time_mask                              (0x001E0000)
+#define REGD22_reg_p1_order_mask                                      (0x00010000)
+#define REGD22_reg_p1_pll_wd_base_time_mask                           (0x0000E000)
+#define REGD22_reg_p1_pll_wd_en_mask                                  (0x00001000)
+#define REGD22_reg_p1_pll_wd_rst_wid_mask                             (0x00000C00)
+#define REGD22_reg_p1_pll_wd_time_rdy_mask                            (0x00000300)
+#define REGD22_reg_p1_acdr_l0_en_mask                                 (0x00000080)
+#define REGD22_reg_p1_bypass_eqen_rdy_l0_mask                         (0x00000040)
+#define REGD22_reg_p1_bypass_data_rdy_l0_mask                         (0x00000020)
+#define REGD22_reg_p1_en_eqen_manual_l0_mask                          (0x00000010)
+#define REGD22_reg_p1_en_data_manual_l0_mask                          (0x00000008)
+#define REGD22_p1_pll_wd_ckrdy_ro_mask                                (0x00000004)
+#define REGD22_p1_pll_wd_rst_wc_mask                                  (0x00000002)
+#define REGD22_p1_wdog_rst_n_mask                                     (0x00000001)
+#define REGD22_reg_p1_bypass_clk_rdy(data)                            (0x80000000&((data)<<31))
+#define REGD22_reg_p1_bypass_eqen_rdy(data)                           (0x40000000&((data)<<30))
+#define REGD22_reg_p1_bypass_data_rdy(data)                           (0x20000000&((data)<<29))
+#define REGD22_reg_p1_bypass_pi(data)                                 (0x10000000&((data)<<28))
+#define REGD22_reg_p1_data_rdy_time(data)                             (0x0F000000&((data)<<24))
+#define REGD22_reg_p1_en_clkout_manual(data)                          (0x00800000&((data)<<23))
+#define REGD22_reg_p1_en_eqen_manual(data)                            (0x00400000&((data)<<22))
+#define REGD22_reg_p1_en_data_manual(data)                            (0x00200000&((data)<<21))
+#define REGD22_reg_p1_eqen_rdy_time(data)                             (0x001E0000&((data)<<17))
+#define REGD22_reg_p1_order(data)                                     (0x00010000&((data)<<16))
+#define REGD22_reg_p1_pll_wd_base_time(data)                          (0x0000E000&((data)<<13))
+#define REGD22_reg_p1_pll_wd_en(data)                                 (0x00001000&((data)<<12))
+#define REGD22_reg_p1_pll_wd_rst_wid(data)                            (0x00000C00&((data)<<10))
+#define REGD22_reg_p1_pll_wd_time_rdy(data)                           (0x00000300&((data)<<8))
+#define REGD22_reg_p1_acdr_l0_en(data)                                (0x00000080&((data)<<7))
+#define REGD22_reg_p1_bypass_eqen_rdy_l0(data)                        (0x00000040&((data)<<6))
+#define REGD22_reg_p1_bypass_data_rdy_l0(data)                        (0x00000020&((data)<<5))
+#define REGD22_reg_p1_en_eqen_manual_l0(data)                         (0x00000010&((data)<<4))
+#define REGD22_reg_p1_en_data_manual_l0(data)                         (0x00000008&((data)<<3))
+#define REGD22_p1_pll_wd_ckrdy_ro(data)                               (0x00000004&((data)<<2))
+#define REGD22_p1_pll_wd_rst_wc(data)                                 (0x00000002&((data)<<1))
+#define REGD22_p1_wdog_rst_n(data)                                    (0x00000001&(data))
+#define REGD22_get_reg_p1_bypass_clk_rdy(data)                        ((0x80000000&(data))>>31)
+#define REGD22_get_reg_p1_bypass_eqen_rdy(data)                       ((0x40000000&(data))>>30)
+#define REGD22_get_reg_p1_bypass_data_rdy(data)                       ((0x20000000&(data))>>29)
+#define REGD22_get_reg_p1_bypass_pi(data)                             ((0x10000000&(data))>>28)
+#define REGD22_get_reg_p1_data_rdy_time(data)                         ((0x0F000000&(data))>>24)
+#define REGD22_get_reg_p1_en_clkout_manual(data)                      ((0x00800000&(data))>>23)
+#define REGD22_get_reg_p1_en_eqen_manual(data)                        ((0x00400000&(data))>>22)
+#define REGD22_get_reg_p1_en_data_manual(data)                        ((0x00200000&(data))>>21)
+#define REGD22_get_reg_p1_eqen_rdy_time(data)                         ((0x001E0000&(data))>>17)
+#define REGD22_get_reg_p1_order(data)                                 ((0x00010000&(data))>>16)
+#define REGD22_get_reg_p1_pll_wd_base_time(data)                      ((0x0000E000&(data))>>13)
+#define REGD22_get_reg_p1_pll_wd_en(data)                             ((0x00001000&(data))>>12)
+#define REGD22_get_reg_p1_pll_wd_rst_wid(data)                        ((0x00000C00&(data))>>10)
+#define REGD22_get_reg_p1_pll_wd_time_rdy(data)                       ((0x00000300&(data))>>8)
+#define REGD22_get_reg_p1_acdr_l0_en(data)                            ((0x00000080&(data))>>7)
+#define REGD22_get_reg_p1_bypass_eqen_rdy_l0(data)                    ((0x00000040&(data))>>6)
+#define REGD22_get_reg_p1_bypass_data_rdy_l0(data)                    ((0x00000020&(data))>>5)
+#define REGD22_get_reg_p1_en_eqen_manual_l0(data)                     ((0x00000010&(data))>>4)
+#define REGD22_get_reg_p1_en_data_manual_l0(data)                     ((0x00000008&(data))>>3)
+#define REGD22_get_p1_pll_wd_ckrdy_ro(data)                           ((0x00000004&(data))>>2)
+#define REGD22_get_p1_pll_wd_rst_wc(data)                             ((0x00000002&(data))>>1)
+#define REGD22_get_p1_wdog_rst_n(data)                                (0x00000001&(data))
+
+
+#define REGD23                                                        0xbe8
+#define REGD23_reg_addr                                               "0x98034be8"
+#define REGD23_reg                                                    0x98034be8
+#define REGD23_inst_addr                                              "0x02FA"
+#define REGD23_inst                                                   0x02FA
+#define REGD23_reg_p1_wd_sdm_en_shift                                 (31)
+#define REGD23_reg_p1_f_code_shift                                    (16)
+#define REGD23_reg_p1_n_code_shift                                    (0)
+#define REGD23_reg_p1_wd_sdm_en_mask                                  (0x80000000)
+#define REGD23_reg_p1_f_code_mask                                     (0x0FFF0000)
+#define REGD23_reg_p1_n_code_mask                                     (0x000001FF)
+#define REGD23_reg_p1_wd_sdm_en(data)                                 (0x80000000&((data)<<31))
+#define REGD23_reg_p1_f_code(data)                                    (0x0FFF0000&((data)<<16))
+#define REGD23_reg_p1_n_code(data)                                    (0x000001FF&(data))
+#define REGD23_get_reg_p1_wd_sdm_en(data)                             ((0x80000000&(data))>>31)
+#define REGD23_get_reg_p1_f_code(data)                                ((0x0FFF0000&(data))>>16)
+#define REGD23_get_reg_p1_n_code(data)                                (0x000001FF&(data))
+
+
+#define REGD24                                                        0xbec
+#define REGD24_reg_addr                                               "0x98034bec"
+#define REGD24_reg                                                    0x98034bec
+#define REGD24_inst_addr                                              "0x02FB"
+#define REGD24_inst                                                   0x02FB
+#define REGD24_reg_p2_bypass_clk_rdy_shift                            (31)
+#define REGD24_reg_p2_bypass_eqen_rdy_shift                           (30)
+#define REGD24_reg_p2_bypass_data_rdy_shift                           (29)
+#define REGD24_reg_p2_bypass_pi_shift                                 (28)
+#define REGD24_reg_p2_data_rdy_time_shift                             (24)
+#define REGD24_reg_p2_en_clkout_manual_shift                          (23)
+#define REGD24_reg_p2_en_eqen_manual_shift                            (22)
+#define REGD24_reg_p2_en_data_manual_shift                            (21)
+#define REGD24_reg_p2_eqen_rdy_time_shift                             (17)
+#define REGD24_reg_p2_order_shift                                     (16)
+#define REGD24_reg_p2_pll_wd_base_time_shift                          (13)
+#define REGD24_reg_p2_pll_wd_en_shift                                 (12)
+#define REGD24_reg_p2_pll_wd_rst_wid_shift                            (10)
+#define REGD24_reg_p2_pll_wd_time_rdy_shift                           (8)
+#define REGD24_reg_p2_acdr_l0_en_shift                                (7)
+#define REGD24_reg_p2_bypass_eqen_rdy_l0_shift                        (6)
+#define REGD24_reg_p2_bypass_data_rdy_l0_shift                        (5)
+#define REGD24_reg_p2_en_eqen_manual_l0_shift                         (4)
+#define REGD24_reg_p2_en_data_manual_l0_shift                         (3)
+#define REGD24_p2_pll_wd_ckrdy_ro_shift                               (2)
+#define REGD24_p2_pll_wd_rst_wc_shift                                 (1)
+#define REGD24_p2_wdog_rst_n_shift                                    (0)
+#define REGD24_reg_p2_bypass_clk_rdy_mask                             (0x80000000)
+#define REGD24_reg_p2_bypass_eqen_rdy_mask                            (0x40000000)
+#define REGD24_reg_p2_bypass_data_rdy_mask                            (0x20000000)
+#define REGD24_reg_p2_bypass_pi_mask                                  (0x10000000)
+#define REGD24_reg_p2_data_rdy_time_mask                              (0x0F000000)
+#define REGD24_reg_p2_en_clkout_manual_mask                           (0x00800000)
+#define REGD24_reg_p2_en_eqen_manual_mask                             (0x00400000)
+#define REGD24_reg_p2_en_data_manual_mask                             (0x00200000)
+#define REGD24_reg_p2_eqen_rdy_time_mask                              (0x001E0000)
+#define REGD24_reg_p2_order_mask                                      (0x00010000)
+#define REGD24_reg_p2_pll_wd_base_time_mask                           (0x0000E000)
+#define REGD24_reg_p2_pll_wd_en_mask                                  (0x00001000)
+#define REGD24_reg_p2_pll_wd_rst_wid_mask                             (0x00000C00)
+#define REGD24_reg_p2_pll_wd_time_rdy_mask                            (0x00000300)
+#define REGD24_reg_p2_acdr_l0_en_mask                                 (0x00000080)
+#define REGD24_reg_p2_bypass_eqen_rdy_l0_mask                         (0x00000040)
+#define REGD24_reg_p2_bypass_data_rdy_l0_mask                         (0x00000020)
+#define REGD24_reg_p2_en_eqen_manual_l0_mask                          (0x00000010)
+#define REGD24_reg_p2_en_data_manual_l0_mask                          (0x00000008)
+#define REGD24_p2_pll_wd_ckrdy_ro_mask                                (0x00000004)
+#define REGD24_p2_pll_wd_rst_wc_mask                                  (0x00000002)
+#define REGD24_p2_wdog_rst_n_mask                                     (0x00000001)
+#define REGD24_reg_p2_bypass_clk_rdy(data)                            (0x80000000&((data)<<31))
+#define REGD24_reg_p2_bypass_eqen_rdy(data)                           (0x40000000&((data)<<30))
+#define REGD24_reg_p2_bypass_data_rdy(data)                           (0x20000000&((data)<<29))
+#define REGD24_reg_p2_bypass_pi(data)                                 (0x10000000&((data)<<28))
+#define REGD24_reg_p2_data_rdy_time(data)                             (0x0F000000&((data)<<24))
+#define REGD24_reg_p2_en_clkout_manual(data)                          (0x00800000&((data)<<23))
+#define REGD24_reg_p2_en_eqen_manual(data)                            (0x00400000&((data)<<22))
+#define REGD24_reg_p2_en_data_manual(data)                            (0x00200000&((data)<<21))
+#define REGD24_reg_p2_eqen_rdy_time(data)                             (0x001E0000&((data)<<17))
+#define REGD24_reg_p2_order(data)                                     (0x00010000&((data)<<16))
+#define REGD24_reg_p2_pll_wd_base_time(data)                          (0x0000E000&((data)<<13))
+#define REGD24_reg_p2_pll_wd_en(data)                                 (0x00001000&((data)<<12))
+#define REGD24_reg_p2_pll_wd_rst_wid(data)                            (0x00000C00&((data)<<10))
+#define REGD24_reg_p2_pll_wd_time_rdy(data)                           (0x00000300&((data)<<8))
+#define REGD24_reg_p2_acdr_l0_en(data)                                (0x00000080&((data)<<7))
+#define REGD24_reg_p2_bypass_eqen_rdy_l0(data)                        (0x00000040&((data)<<6))
+#define REGD24_reg_p2_bypass_data_rdy_l0(data)                        (0x00000020&((data)<<5))
+#define REGD24_reg_p2_en_eqen_manual_l0(data)                         (0x00000010&((data)<<4))
+#define REGD24_reg_p2_en_data_manual_l0(data)                         (0x00000008&((data)<<3))
+#define REGD24_p2_pll_wd_ckrdy_ro(data)                               (0x00000004&((data)<<2))
+#define REGD24_p2_pll_wd_rst_wc(data)                                 (0x00000002&((data)<<1))
+#define REGD24_p2_wdog_rst_n(data)                                    (0x00000001&(data))
+#define REGD24_get_reg_p2_bypass_clk_rdy(data)                        ((0x80000000&(data))>>31)
+#define REGD24_get_reg_p2_bypass_eqen_rdy(data)                       ((0x40000000&(data))>>30)
+#define REGD24_get_reg_p2_bypass_data_rdy(data)                       ((0x20000000&(data))>>29)
+#define REGD24_get_reg_p2_bypass_pi(data)                             ((0x10000000&(data))>>28)
+#define REGD24_get_reg_p2_data_rdy_time(data)                         ((0x0F000000&(data))>>24)
+#define REGD24_get_reg_p2_en_clkout_manual(data)                      ((0x00800000&(data))>>23)
+#define REGD24_get_reg_p2_en_eqen_manual(data)                        ((0x00400000&(data))>>22)
+#define REGD24_get_reg_p2_en_data_manual(data)                        ((0x00200000&(data))>>21)
+#define REGD24_get_reg_p2_eqen_rdy_time(data)                         ((0x001E0000&(data))>>17)
+#define REGD24_get_reg_p2_order(data)                                 ((0x00010000&(data))>>16)
+#define REGD24_get_reg_p2_pll_wd_base_time(data)                      ((0x0000E000&(data))>>13)
+#define REGD24_get_reg_p2_pll_wd_en(data)                             ((0x00001000&(data))>>12)
+#define REGD24_get_reg_p2_pll_wd_rst_wid(data)                        ((0x00000C00&(data))>>10)
+#define REGD24_get_reg_p2_pll_wd_time_rdy(data)                       ((0x00000300&(data))>>8)
+#define REGD24_get_reg_p2_acdr_l0_en(data)                            ((0x00000080&(data))>>7)
+#define REGD24_get_reg_p2_bypass_eqen_rdy_l0(data)                    ((0x00000040&(data))>>6)
+#define REGD24_get_reg_p2_bypass_data_rdy_l0(data)                    ((0x00000020&(data))>>5)
+#define REGD24_get_reg_p2_en_eqen_manual_l0(data)                     ((0x00000010&(data))>>4)
+#define REGD24_get_reg_p2_en_data_manual_l0(data)                     ((0x00000008&(data))>>3)
+#define REGD24_get_p2_pll_wd_ckrdy_ro(data)                           ((0x00000004&(data))>>2)
+#define REGD24_get_p2_pll_wd_rst_wc(data)                             ((0x00000002&(data))>>1)
+#define REGD24_get_p2_wdog_rst_n(data)                                (0x00000001&(data))
+
+
+#define REGD25                                                        0xbf0
+#define REGD25_reg_addr                                               "0x98034bf0"
+#define REGD25_reg                                                    0x98034bf0
+#define REGD25_inst_addr                                              "0x02FC"
+#define REGD25_inst                                                   0x02FC
+#define REGD25_reg_p2_wd_sdm_en_shift                                 (31)
+#define REGD25_reg_p2_f_code_shift                                    (16)
+#define REGD25_reg_p2_n_code_shift                                    (0)
+#define REGD25_reg_p2_wd_sdm_en_mask                                  (0x80000000)
+#define REGD25_reg_p2_f_code_mask                                     (0x0FFF0000)
+#define REGD25_reg_p2_n_code_mask                                     (0x000001FF)
+#define REGD25_reg_p2_wd_sdm_en(data)                                 (0x80000000&((data)<<31))
+#define REGD25_reg_p2_f_code(data)                                    (0x0FFF0000&((data)<<16))
+#define REGD25_reg_p2_n_code(data)                                    (0x000001FF&(data))
+#define REGD25_get_reg_p2_wd_sdm_en(data)                             ((0x80000000&(data))>>31)
+#define REGD25_get_reg_p2_f_code(data)                                ((0x0FFF0000&(data))>>16)
+#define REGD25_get_reg_p2_n_code(data)                                (0x000001FF&(data))
+
+
+#define REGD26                                                        0xbf4
+#define REGD26_reg_addr                                               "0x98034bf4"
+#define REGD26_reg                                                    0x98034bf4
+#define REGD26_inst_addr                                              "0x02FD"
+#define REGD26_inst                                                   0x02FD
+#define REGD26_reg_p3_bypass_clk_rdy_shift                            (31)
+#define REGD26_reg_p3_bypass_eqen_rdy_shift                           (30)
+#define REGD26_reg_p3_bypass_data_rdy_shift                           (29)
+#define REGD26_reg_p3_bypass_pi_shift                                 (28)
+#define REGD26_reg_p3_data_rdy_time_shift                             (24)
+#define REGD26_reg_p3_en_clkout_manual_shift                          (23)
+#define REGD26_reg_p3_en_eqen_manual_shift                            (22)
+#define REGD26_reg_p3_en_data_manual_shift                            (21)
+#define REGD26_reg_p3_eqen_rdy_time_shift                             (17)
+#define REGD26_reg_p3_order_shift                                     (16)
+#define REGD26_reg_p3_pll_wd_base_time_shift                          (13)
+#define REGD26_reg_p3_pll_wd_en_shift                                 (12)
+#define REGD26_reg_p3_pll_wd_rst_wid_shift                            (10)
+#define REGD26_reg_p3_pll_wd_time_rdy_shift                           (8)
+#define REGD26_reg_p3_acdr_l0_en_shift                                (7)
+#define REGD26_reg_p3_bypass_eqen_rdy_l0_shift                        (6)
+#define REGD26_reg_p3_bypass_data_rdy_l0_shift                        (5)
+#define REGD26_reg_p3_en_eqen_manual_l0_shift                         (4)
+#define REGD26_reg_p3_en_data_manual_l0_shift                         (3)
+#define REGD26_p3_pll_wd_ckrdy_ro_shift                               (2)
+#define REGD26_p3_pll_wd_rst_wc_shift                                 (1)
+#define REGD26_p3_wdog_rst_n_shift                                    (0)
+#define REGD26_reg_p3_bypass_clk_rdy_mask                             (0x80000000)
+#define REGD26_reg_p3_bypass_eqen_rdy_mask                            (0x40000000)
+#define REGD26_reg_p3_bypass_data_rdy_mask                            (0x20000000)
+#define REGD26_reg_p3_bypass_pi_mask                                  (0x10000000)
+#define REGD26_reg_p3_data_rdy_time_mask                              (0x0F000000)
+#define REGD26_reg_p3_en_clkout_manual_mask                           (0x00800000)
+#define REGD26_reg_p3_en_eqen_manual_mask                             (0x00400000)
+#define REGD26_reg_p3_en_data_manual_mask                             (0x00200000)
+#define REGD26_reg_p3_eqen_rdy_time_mask                              (0x001E0000)
+#define REGD26_reg_p3_order_mask                                      (0x00010000)
+#define REGD26_reg_p3_pll_wd_base_time_mask                           (0x0000E000)
+#define REGD26_reg_p3_pll_wd_en_mask                                  (0x00001000)
+#define REGD26_reg_p3_pll_wd_rst_wid_mask                             (0x00000C00)
+#define REGD26_reg_p3_pll_wd_time_rdy_mask                            (0x00000300)
+#define REGD26_reg_p3_acdr_l0_en_mask                                 (0x00000080)
+#define REGD26_reg_p3_bypass_eqen_rdy_l0_mask                         (0x00000040)
+#define REGD26_reg_p3_bypass_data_rdy_l0_mask                         (0x00000020)
+#define REGD26_reg_p3_en_eqen_manual_l0_mask                          (0x00000010)
+#define REGD26_reg_p3_en_data_manual_l0_mask                          (0x00000008)
+#define REGD26_p3_pll_wd_ckrdy_ro_mask                                (0x00000004)
+#define REGD26_p3_pll_wd_rst_wc_mask                                  (0x00000002)
+#define REGD26_p3_wdog_rst_n_mask                                     (0x00000001)
+#define REGD26_reg_p3_bypass_clk_rdy(data)                            (0x80000000&((data)<<31))
+#define REGD26_reg_p3_bypass_eqen_rdy(data)                           (0x40000000&((data)<<30))
+#define REGD26_reg_p3_bypass_data_rdy(data)                           (0x20000000&((data)<<29))
+#define REGD26_reg_p3_bypass_pi(data)                                 (0x10000000&((data)<<28))
+#define REGD26_reg_p3_data_rdy_time(data)                             (0x0F000000&((data)<<24))
+#define REGD26_reg_p3_en_clkout_manual(data)                          (0x00800000&((data)<<23))
+#define REGD26_reg_p3_en_eqen_manual(data)                            (0x00400000&((data)<<22))
+#define REGD26_reg_p3_en_data_manual(data)                            (0x00200000&((data)<<21))
+#define REGD26_reg_p3_eqen_rdy_time(data)                             (0x001E0000&((data)<<17))
+#define REGD26_reg_p3_order(data)                                     (0x00010000&((data)<<16))
+#define REGD26_reg_p3_pll_wd_base_time(data)                          (0x0000E000&((data)<<13))
+#define REGD26_reg_p3_pll_wd_en(data)                                 (0x00001000&((data)<<12))
+#define REGD26_reg_p3_pll_wd_rst_wid(data)                            (0x00000C00&((data)<<10))
+#define REGD26_reg_p3_pll_wd_time_rdy(data)                           (0x00000300&((data)<<8))
+#define REGD26_reg_p3_acdr_l0_en(data)                                (0x00000080&((data)<<7))
+#define REGD26_reg_p3_bypass_eqen_rdy_l0(data)                        (0x00000040&((data)<<6))
+#define REGD26_reg_p3_bypass_data_rdy_l0(data)                        (0x00000020&((data)<<5))
+#define REGD26_reg_p3_en_eqen_manual_l0(data)                         (0x00000010&((data)<<4))
+#define REGD26_reg_p3_en_data_manual_l0(data)                         (0x00000008&((data)<<3))
+#define REGD26_p3_pll_wd_ckrdy_ro(data)                               (0x00000004&((data)<<2))
+#define REGD26_p3_pll_wd_rst_wc(data)                                 (0x00000002&((data)<<1))
+#define REGD26_p3_wdog_rst_n(data)                                    (0x00000001&(data))
+#define REGD26_get_reg_p3_bypass_clk_rdy(data)                        ((0x80000000&(data))>>31)
+#define REGD26_get_reg_p3_bypass_eqen_rdy(data)                       ((0x40000000&(data))>>30)
+#define REGD26_get_reg_p3_bypass_data_rdy(data)                       ((0x20000000&(data))>>29)
+#define REGD26_get_reg_p3_bypass_pi(data)                             ((0x10000000&(data))>>28)
+#define REGD26_get_reg_p3_data_rdy_time(data)                         ((0x0F000000&(data))>>24)
+#define REGD26_get_reg_p3_en_clkout_manual(data)                      ((0x00800000&(data))>>23)
+#define REGD26_get_reg_p3_en_eqen_manual(data)                        ((0x00400000&(data))>>22)
+#define REGD26_get_reg_p3_en_data_manual(data)                        ((0x00200000&(data))>>21)
+#define REGD26_get_reg_p3_eqen_rdy_time(data)                         ((0x001E0000&(data))>>17)
+#define REGD26_get_reg_p3_order(data)                                 ((0x00010000&(data))>>16)
+#define REGD26_get_reg_p3_pll_wd_base_time(data)                      ((0x0000E000&(data))>>13)
+#define REGD26_get_reg_p3_pll_wd_en(data)                             ((0x00001000&(data))>>12)
+#define REGD26_get_reg_p3_pll_wd_rst_wid(data)                        ((0x00000C00&(data))>>10)
+#define REGD26_get_reg_p3_pll_wd_time_rdy(data)                       ((0x00000300&(data))>>8)
+#define REGD26_get_reg_p3_acdr_l0_en(data)                            ((0x00000080&(data))>>7)
+#define REGD26_get_reg_p3_bypass_eqen_rdy_l0(data)                    ((0x00000040&(data))>>6)
+#define REGD26_get_reg_p3_bypass_data_rdy_l0(data)                    ((0x00000020&(data))>>5)
+#define REGD26_get_reg_p3_en_eqen_manual_l0(data)                     ((0x00000010&(data))>>4)
+#define REGD26_get_reg_p3_en_data_manual_l0(data)                     ((0x00000008&(data))>>3)
+#define REGD26_get_p3_pll_wd_ckrdy_ro(data)                           ((0x00000004&(data))>>2)
+#define REGD26_get_p3_pll_wd_rst_wc(data)                             ((0x00000002&(data))>>1)
+#define REGD26_get_p3_wdog_rst_n(data)                                (0x00000001&(data))
+
+
+#define REGD27                                                        0xbf8
+#define REGD27_reg_addr                                               "0x98034bf8"
+#define REGD27_reg                                                    0x98034bf8
+#define REGD27_inst_addr                                              "0x02FE"
+#define REGD27_inst                                                   0x02FE
+#define REGD27_reg_p3_wd_sdm_en_shift                                 (31)
+#define REGD27_reg_p3_f_code_shift                                    (16)
+#define REGD27_reg_p3_n_code_shift                                    (0)
+#define REGD27_reg_p3_wd_sdm_en_mask                                  (0x80000000)
+#define REGD27_reg_p3_f_code_mask                                     (0x0FFF0000)
+#define REGD27_reg_p3_n_code_mask                                     (0x000001FF)
+#define REGD27_reg_p3_wd_sdm_en(data)                                 (0x80000000&((data)<<31))
+#define REGD27_reg_p3_f_code(data)                                    (0x0FFF0000&((data)<<16))
+#define REGD27_reg_p3_n_code(data)                                    (0x000001FF&(data))
+#define REGD27_get_reg_p3_wd_sdm_en(data)                             ((0x80000000&(data))>>31)
+#define REGD27_get_reg_p3_f_code(data)                                ((0x0FFF0000&(data))>>16)
+#define REGD27_get_reg_p3_n_code(data)                                (0x000001FF&(data))
+
+
+#define REGD28                                                        0xbfc
+#define REGD28_reg_addr                                               "0x98034bfc"
+#define REGD28_reg                                                    0x98034bfc
+#define REGD28_inst_addr                                              "0x02FF"
+#define REGD28_inst                                                   0x02FF
+#define REGD28_reg_p0_auto_mode_shift                                 (31)
+#define REGD28_reg_p0_adp_en_manual_shift                             (30)
+#define REGD28_reg_p0_cp_en_manual_shift                              (29)
+#define REGD28_reg_p0_adap_eq_off_shift                               (28)
+#define REGD28_reg_p0_adp_time_shift                                  (23)
+#define REGD28_reg_p0_calib_time_shift                                (20)
+#define REGD28_reg_p0_calib_manual_shift                              (19)
+#define REGD28_reg_p0_calib_late_shift                                (18)
+#define REGD28_reg_p0_vco_coarse_shift                                (11)
+#define REGD28_reg_p0_divide_num_shift                                (4)
+#define REGD28_reg_p0_init_time_shift                                 (1)
+#define REGD28_reg_p0_auto_mode_mask                                  (0x80000000)
+#define REGD28_reg_p0_adp_en_manual_mask                              (0x40000000)
+#define REGD28_reg_p0_cp_en_manual_mask                               (0x20000000)
+#define REGD28_reg_p0_adap_eq_off_mask                                (0x10000000)
+#define REGD28_reg_p0_adp_time_mask                                   (0x0F800000)
+#define REGD28_reg_p0_calib_time_mask                                 (0x00700000)
+#define REGD28_reg_p0_calib_manual_mask                               (0x00080000)
+#define REGD28_reg_p0_calib_late_mask                                 (0x00040000)
+#define REGD28_reg_p0_vco_coarse_mask                                 (0x0003F800)
+#define REGD28_reg_p0_divide_num_mask                                 (0x000007F0)
+#define REGD28_reg_p0_init_time_mask                                  (0x0000000E)
+#define REGD28_reg_p0_auto_mode(data)                                 (0x80000000&((data)<<31))
+#define REGD28_reg_p0_adp_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD28_reg_p0_cp_en_manual(data)                              (0x20000000&((data)<<29))
+#define REGD28_reg_p0_adap_eq_off(data)                               (0x10000000&((data)<<28))
+#define REGD28_reg_p0_adp_time(data)                                  (0x0F800000&((data)<<23))
+#define REGD28_reg_p0_calib_time(data)                                (0x00700000&((data)<<20))
+#define REGD28_reg_p0_calib_manual(data)                              (0x00080000&((data)<<19))
+#define REGD28_reg_p0_calib_late(data)                                (0x00040000&((data)<<18))
+#define REGD28_reg_p0_vco_coarse(data)                                (0x0003F800&((data)<<11))
+#define REGD28_reg_p0_divide_num(data)                                (0x000007F0&((data)<<4))
+#define REGD28_reg_p0_init_time(data)                                 (0x0000000E&((data)<<1))
+#define REGD28_get_reg_p0_auto_mode(data)                             ((0x80000000&(data))>>31)
+#define REGD28_get_reg_p0_adp_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD28_get_reg_p0_cp_en_manual(data)                          ((0x20000000&(data))>>29)
+#define REGD28_get_reg_p0_adap_eq_off(data)                           ((0x10000000&(data))>>28)
+#define REGD28_get_reg_p0_adp_time(data)                              ((0x0F800000&(data))>>23)
+#define REGD28_get_reg_p0_calib_time(data)                            ((0x00700000&(data))>>20)
+#define REGD28_get_reg_p0_calib_manual(data)                          ((0x00080000&(data))>>19)
+#define REGD28_get_reg_p0_calib_late(data)                            ((0x00040000&(data))>>18)
+#define REGD28_get_reg_p0_vco_coarse(data)                            ((0x0003F800&(data))>>11)
+#define REGD28_get_reg_p0_divide_num(data)                            ((0x000007F0&(data))>>4)
+#define REGD28_get_reg_p0_init_time(data)                             ((0x0000000E&(data))>>1)
+
+
+#define REGD29                                                        0xc00
+#define REGD29_reg_addr                                               "0x98034c00"
+#define REGD29_reg                                                    0x98034c00
+#define REGD29_inst_addr                                              "0x0300"
+#define REGD29_inst                                                   0x0300
+#define REGD29_reg_p0_lock_up_limit_shift                             (16)
+#define REGD29_reg_p0_lock_dn_limit_shift                             (0)
+#define REGD29_reg_p0_lock_up_limit_mask                              (0x07FF0000)
+#define REGD29_reg_p0_lock_dn_limit_mask                              (0x000007FF)
+#define REGD29_reg_p0_lock_up_limit(data)                             (0x07FF0000&((data)<<16))
+#define REGD29_reg_p0_lock_dn_limit(data)                             (0x000007FF&(data))
+#define REGD29_get_reg_p0_lock_up_limit(data)                         ((0x07FF0000&(data))>>16)
+#define REGD29_get_reg_p0_lock_dn_limit(data)                         (0x000007FF&(data))
+
+
+#define REGD30                                                        0xc04
+#define REGD30_reg_addr                                               "0x98034c04"
+#define REGD30_reg                                                    0x98034c04
+#define REGD30_inst_addr                                              "0x0301"
+#define REGD30_inst                                                   0x0301
+#define REGD30_reg_p0_cdr_cp_shift                                    (12)
+#define REGD30_reg_p0_cdr_r_shift                                     (6)
+#define REGD30_reg_p0_cdr_c_shift                                     (4)
+#define REGD30_reg_p0_vc_sel_shift                                    (2)
+#define REGD30_reg_p0_calib_reset_sel_shift                           (1)
+#define REGD30_reg_p0_cdr_cp_mask                                     (0xFFFFF000)
+#define REGD30_reg_p0_cdr_r_mask                                      (0x00000FC0)
+#define REGD30_reg_p0_cdr_c_mask                                      (0x00000030)
+#define REGD30_reg_p0_vc_sel_mask                                     (0x0000000C)
+#define REGD30_reg_p0_calib_reset_sel_mask                            (0x00000002)
+#define REGD30_reg_p0_cdr_cp(data)                                    (0xFFFFF000&((data)<<12))
+#define REGD30_reg_p0_cdr_r(data)                                     (0x00000FC0&((data)<<6))
+#define REGD30_reg_p0_cdr_c(data)                                     (0x00000030&((data)<<4))
+#define REGD30_reg_p0_vc_sel(data)                                    (0x0000000C&((data)<<2))
+#define REGD30_reg_p0_calib_reset_sel(data)                           (0x00000002&((data)<<1))
+#define REGD30_get_reg_p0_cdr_cp(data)                                ((0xFFFFF000&(data))>>12)
+#define REGD30_get_reg_p0_cdr_r(data)                                 ((0x00000FC0&(data))>>6)
+#define REGD30_get_reg_p0_cdr_c(data)                                 ((0x00000030&(data))>>4)
+#define REGD30_get_reg_p0_vc_sel(data)                                ((0x0000000C&(data))>>2)
+#define REGD30_get_reg_p0_calib_reset_sel(data)                       ((0x00000002&(data))>>1)
+
+
+#define REGD31                                                        0xc08
+#define REGD31_reg_addr                                               "0x98034c08"
+#define REGD31_reg                                                    0x98034c08
+#define REGD31_inst_addr                                              "0x0302"
+#define REGD31_inst                                                   0x0302
+#define REGD31_reg_p0_slope_lv_up_shift                               (21)
+#define REGD31_reg_p0_slope_lv_dn_shift                               (10)
+#define REGD31_reg_p0_cp_time_shift                                   (5)
+#define REGD31_reg_p0_timer_4_shift                                   (0)
+#define REGD31_reg_p0_slope_lv_up_mask                                (0xFFE00000)
+#define REGD31_reg_p0_slope_lv_dn_mask                                (0x001FFC00)
+#define REGD31_reg_p0_cp_time_mask                                    (0x000003E0)
+#define REGD31_reg_p0_timer_4_mask                                    (0x0000001F)
+#define REGD31_reg_p0_slope_lv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD31_reg_p0_slope_lv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD31_reg_p0_cp_time(data)                                   (0x000003E0&((data)<<5))
+#define REGD31_reg_p0_timer_4(data)                                   (0x0000001F&(data))
+#define REGD31_get_reg_p0_slope_lv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD31_get_reg_p0_slope_lv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD31_get_reg_p0_cp_time(data)                               ((0x000003E0&(data))>>5)
+#define REGD31_get_reg_p0_timer_4(data)                               (0x0000001F&(data))
+
+
+#define REGD32                                                        0xc0c
+#define REGD32_reg_addr                                               "0x98034c0c"
+#define REGD32_reg                                                    0x98034c0c
+#define REGD32_inst_addr                                              "0x0303"
+#define REGD32_inst                                                   0x0303
+#define REGD32_reg_p0_slope_hv_up_shift                               (21)
+#define REGD32_reg_p0_slope_hv_dn_shift                               (10)
+#define REGD32_reg_p0_timer_5_shift                                   (9)
+#define REGD32_reg_p0_timer_6_shift                                   (4)
+#define REGD32_reg_p0_slope_hv_up_mask                                (0xFFE00000)
+#define REGD32_reg_p0_slope_hv_dn_mask                                (0x001FFC00)
+#define REGD32_reg_p0_timer_5_mask                                    (0x00000200)
+#define REGD32_reg_p0_timer_6_mask                                    (0x000001F0)
+#define REGD32_reg_p0_slope_hv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD32_reg_p0_slope_hv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD32_reg_p0_timer_5(data)                                   (0x00000200&((data)<<9))
+#define REGD32_reg_p0_timer_6(data)                                   (0x000001F0&((data)<<4))
+#define REGD32_get_reg_p0_slope_hv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD32_get_reg_p0_slope_hv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD32_get_reg_p0_timer_5(data)                               ((0x00000200&(data))>>9)
+#define REGD32_get_reg_p0_timer_6(data)                               ((0x000001F0&(data))>>4)
+
+
+#define REGD33                                                        0xc10
+#define REGD33_reg_addr                                               "0x98034c10"
+#define REGD33_reg                                                    0x98034c10
+#define REGD33_inst_addr                                              "0x0304"
+#define REGD33_inst                                                   0x0304
+#define REGD33_reg_p0_start_en_manual_shift                           (31)
+#define REGD33_reg_p0_pfd_en_manual_shift                             (30)
+#define REGD33_reg_p0_pfd_time_shift                                  (25)
+#define REGD33_reg_p0_pfd_bypass_shift                                (24)
+#define REGD33_reg_p0_rxidle_bypass_shift                             (23)
+#define REGD33_reg_p0_slope_manual_shift                              (22)
+#define REGD33_reg_p0_slope_band_shift                                (17)
+#define REGD33_reg_p0_old_mode_shift                                  (16)
+#define REGD33_reg_p0_start_en_manual_mask                            (0x80000000)
+#define REGD33_reg_p0_pfd_en_manual_mask                              (0x40000000)
+#define REGD33_reg_p0_pfd_time_mask                                   (0x3E000000)
+#define REGD33_reg_p0_pfd_bypass_mask                                 (0x01000000)
+#define REGD33_reg_p0_rxidle_bypass_mask                              (0x00800000)
+#define REGD33_reg_p0_slope_manual_mask                               (0x00400000)
+#define REGD33_reg_p0_slope_band_mask                                 (0x003E0000)
+#define REGD33_reg_p0_old_mode_mask                                   (0x00010000)
+#define REGD33_reg_p0_start_en_manual(data)                           (0x80000000&((data)<<31))
+#define REGD33_reg_p0_pfd_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD33_reg_p0_pfd_time(data)                                  (0x3E000000&((data)<<25))
+#define REGD33_reg_p0_pfd_bypass(data)                                (0x01000000&((data)<<24))
+#define REGD33_reg_p0_rxidle_bypass(data)                             (0x00800000&((data)<<23))
+#define REGD33_reg_p0_slope_manual(data)                              (0x00400000&((data)<<22))
+#define REGD33_reg_p0_slope_band(data)                                (0x003E0000&((data)<<17))
+#define REGD33_reg_p0_old_mode(data)                                  (0x00010000&((data)<<16))
+#define REGD33_get_reg_p0_start_en_manual(data)                       ((0x80000000&(data))>>31)
+#define REGD33_get_reg_p0_pfd_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD33_get_reg_p0_pfd_time(data)                              ((0x3E000000&(data))>>25)
+#define REGD33_get_reg_p0_pfd_bypass(data)                            ((0x01000000&(data))>>24)
+#define REGD33_get_reg_p0_rxidle_bypass(data)                         ((0x00800000&(data))>>23)
+#define REGD33_get_reg_p0_slope_manual(data)                          ((0x00400000&(data))>>22)
+#define REGD33_get_reg_p0_slope_band(data)                            ((0x003E0000&(data))>>17)
+#define REGD33_get_reg_p0_old_mode(data)                              ((0x00010000&(data))>>16)
+
+
+#define REGD34                                                        0xc14
+#define REGD34_reg_addr                                               "0x98034c14"
+#define REGD34_reg                                                    0x98034c14
+#define REGD34_inst_addr                                              "0x0305"
+#define REGD34_inst                                                   0x0305
+#define REGD34_p0_fld_st_reg_shift                                    (27)
+#define REGD34_p0_adp_en_fsm_reg_shift                                (26)
+#define REGD34_p0_cp_en_fsm_reg_shift                                 (25)
+#define REGD34_p0_coarse_fsm_reg_shift                                (18)
+#define REGD34_p0_pfd_en_fsm_reg_shift                                (17)
+#define REGD34_p0_slope_lv_reg_shift                                  (12)
+#define REGD34_p0_slope_hv_reg_shift                                  (7)
+#define REGD34_p0_slope_final_reg_shift                               (2)
+#define REGD34_p0_fld_st_reg_mask                                     (0xF8000000)
+#define REGD34_p0_adp_en_fsm_reg_mask                                 (0x04000000)
+#define REGD34_p0_cp_en_fsm_reg_mask                                  (0x02000000)
+#define REGD34_p0_coarse_fsm_reg_mask                                 (0x01FC0000)
+#define REGD34_p0_pfd_en_fsm_reg_mask                                 (0x00020000)
+#define REGD34_p0_slope_lv_reg_mask                                   (0x0001F000)
+#define REGD34_p0_slope_hv_reg_mask                                   (0x00000F80)
+#define REGD34_p0_slope_final_reg_mask                                (0x0000007C)
+#define REGD34_p0_fld_st_reg(data)                                    (0xF8000000&((data)<<27))
+#define REGD34_p0_adp_en_fsm_reg(data)                                (0x04000000&((data)<<26))
+#define REGD34_p0_cp_en_fsm_reg(data)                                 (0x02000000&((data)<<25))
+#define REGD34_p0_coarse_fsm_reg(data)                                (0x01FC0000&((data)<<18))
+#define REGD34_p0_pfd_en_fsm_reg(data)                                (0x00020000&((data)<<17))
+#define REGD34_p0_slope_lv_reg(data)                                  (0x0001F000&((data)<<12))
+#define REGD34_p0_slope_hv_reg(data)                                  (0x00000F80&((data)<<7))
+#define REGD34_p0_slope_final_reg(data)                               (0x0000007C&((data)<<2))
+#define REGD34_get_p0_fld_st_reg(data)                                ((0xF8000000&(data))>>27)
+#define REGD34_get_p0_adp_en_fsm_reg(data)                            ((0x04000000&(data))>>26)
+#define REGD34_get_p0_cp_en_fsm_reg(data)                             ((0x02000000&(data))>>25)
+#define REGD34_get_p0_coarse_fsm_reg(data)                            ((0x01FC0000&(data))>>18)
+#define REGD34_get_p0_pfd_en_fsm_reg(data)                            ((0x00020000&(data))>>17)
+#define REGD34_get_p0_slope_lv_reg(data)                              ((0x0001F000&(data))>>12)
+#define REGD34_get_p0_slope_hv_reg(data)                              ((0x00000F80&(data))>>7)
+#define REGD34_get_p0_slope_final_reg(data)                           ((0x0000007C&(data))>>2)
+
+
+#define REGD35                                                        0xc18
+#define REGD35_reg_addr                                               "0x98034c18"
+#define REGD35_reg                                                    0x98034c18
+#define REGD35_inst_addr                                              "0x0306"
+#define REGD35_inst                                                   0x0306
+#define REGD35_reg_p1_auto_mode_shift                                 (31)
+#define REGD35_reg_p1_adp_en_manual_shift                             (30)
+#define REGD35_reg_p1_cp_en_manual_shift                              (29)
+#define REGD35_reg_p1_adap_eq_off_shift                               (28)
+#define REGD35_reg_p1_adp_time_shift                                  (23)
+#define REGD35_reg_p1_calib_time_shift                                (20)
+#define REGD35_reg_p1_calib_manual_shift                              (19)
+#define REGD35_reg_p1_calib_late_shift                                (18)
+#define REGD35_reg_p1_vco_coarse_shift                                (11)
+#define REGD35_reg_p1_divide_num_shift                                (4)
+#define REGD35_reg_p1_init_time_shift                                 (1)
+#define REGD35_reg_p1_auto_mode_mask                                  (0x80000000)
+#define REGD35_reg_p1_adp_en_manual_mask                              (0x40000000)
+#define REGD35_reg_p1_cp_en_manual_mask                               (0x20000000)
+#define REGD35_reg_p1_adap_eq_off_mask                                (0x10000000)
+#define REGD35_reg_p1_adp_time_mask                                   (0x0F800000)
+#define REGD35_reg_p1_calib_time_mask                                 (0x00700000)
+#define REGD35_reg_p1_calib_manual_mask                               (0x00080000)
+#define REGD35_reg_p1_calib_late_mask                                 (0x00040000)
+#define REGD35_reg_p1_vco_coarse_mask                                 (0x0003F800)
+#define REGD35_reg_p1_divide_num_mask                                 (0x000007F0)
+#define REGD35_reg_p1_init_time_mask                                  (0x0000000E)
+#define REGD35_reg_p1_auto_mode(data)                                 (0x80000000&((data)<<31))
+#define REGD35_reg_p1_adp_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD35_reg_p1_cp_en_manual(data)                              (0x20000000&((data)<<29))
+#define REGD35_reg_p1_adap_eq_off(data)                               (0x10000000&((data)<<28))
+#define REGD35_reg_p1_adp_time(data)                                  (0x0F800000&((data)<<23))
+#define REGD35_reg_p1_calib_time(data)                                (0x00700000&((data)<<20))
+#define REGD35_reg_p1_calib_manual(data)                              (0x00080000&((data)<<19))
+#define REGD35_reg_p1_calib_late(data)                                (0x00040000&((data)<<18))
+#define REGD35_reg_p1_vco_coarse(data)                                (0x0003F800&((data)<<11))
+#define REGD35_reg_p1_divide_num(data)                                (0x000007F0&((data)<<4))
+#define REGD35_reg_p1_init_time(data)                                 (0x0000000E&((data)<<1))
+#define REGD35_get_reg_p1_auto_mode(data)                             ((0x80000000&(data))>>31)
+#define REGD35_get_reg_p1_adp_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD35_get_reg_p1_cp_en_manual(data)                          ((0x20000000&(data))>>29)
+#define REGD35_get_reg_p1_adap_eq_off(data)                           ((0x10000000&(data))>>28)
+#define REGD35_get_reg_p1_adp_time(data)                              ((0x0F800000&(data))>>23)
+#define REGD35_get_reg_p1_calib_time(data)                            ((0x00700000&(data))>>20)
+#define REGD35_get_reg_p1_calib_manual(data)                          ((0x00080000&(data))>>19)
+#define REGD35_get_reg_p1_calib_late(data)                            ((0x00040000&(data))>>18)
+#define REGD35_get_reg_p1_vco_coarse(data)                            ((0x0003F800&(data))>>11)
+#define REGD35_get_reg_p1_divide_num(data)                            ((0x000007F0&(data))>>4)
+#define REGD35_get_reg_p1_init_time(data)                             ((0x0000000E&(data))>>1)
+
+
+#define REGD36                                                        0xc1c
+#define REGD36_reg_addr                                               "0x98034c1c"
+#define REGD36_reg                                                    0x98034c1c
+#define REGD36_inst_addr                                              "0x0307"
+#define REGD36_inst                                                   0x0307
+#define REGD36_reg_p1_lock_up_limit_shift                             (16)
+#define REGD36_reg_p1_lock_dn_limit_shift                             (0)
+#define REGD36_reg_p1_lock_up_limit_mask                              (0x07FF0000)
+#define REGD36_reg_p1_lock_dn_limit_mask                              (0x000007FF)
+#define REGD36_reg_p1_lock_up_limit(data)                             (0x07FF0000&((data)<<16))
+#define REGD36_reg_p1_lock_dn_limit(data)                             (0x000007FF&(data))
+#define REGD36_get_reg_p1_lock_up_limit(data)                         ((0x07FF0000&(data))>>16)
+#define REGD36_get_reg_p1_lock_dn_limit(data)                         (0x000007FF&(data))
+
+
+#define REGD37                                                        0xc20
+#define REGD37_reg_addr                                               "0x98034c20"
+#define REGD37_reg                                                    0x98034c20
+#define REGD37_inst_addr                                              "0x0308"
+#define REGD37_inst                                                   0x0308
+#define REGD37_reg_p1_cdr_cp_shift                                    (12)
+#define REGD37_reg_p1_cdr_r_shift                                     (6)
+#define REGD37_reg_p1_cdr_c_shift                                     (4)
+#define REGD37_reg_p1_vc_sel_shift                                    (2)
+#define REGD37_reg_p1_calib_reset_sel_shift                           (1)
+#define REGD37_reg_p1_cdr_cp_mask                                     (0xFFFFF000)
+#define REGD37_reg_p1_cdr_r_mask                                      (0x00000FC0)
+#define REGD37_reg_p1_cdr_c_mask                                      (0x00000030)
+#define REGD37_reg_p1_vc_sel_mask                                     (0x0000000C)
+#define REGD37_reg_p1_calib_reset_sel_mask                            (0x00000002)
+#define REGD37_reg_p1_cdr_cp(data)                                    (0xFFFFF000&((data)<<12))
+#define REGD37_reg_p1_cdr_r(data)                                     (0x00000FC0&((data)<<6))
+#define REGD37_reg_p1_cdr_c(data)                                     (0x00000030&((data)<<4))
+#define REGD37_reg_p1_vc_sel(data)                                    (0x0000000C&((data)<<2))
+#define REGD37_reg_p1_calib_reset_sel(data)                           (0x00000002&((data)<<1))
+#define REGD37_get_reg_p1_cdr_cp(data)                                ((0xFFFFF000&(data))>>12)
+#define REGD37_get_reg_p1_cdr_r(data)                                 ((0x00000FC0&(data))>>6)
+#define REGD37_get_reg_p1_cdr_c(data)                                 ((0x00000030&(data))>>4)
+#define REGD37_get_reg_p1_vc_sel(data)                                ((0x0000000C&(data))>>2)
+#define REGD37_get_reg_p1_calib_reset_sel(data)                       ((0x00000002&(data))>>1)
+
+
+#define REGD38                                                        0xc24
+#define REGD38_reg_addr                                               "0x98034c24"
+#define REGD38_reg                                                    0x98034c24
+#define REGD38_inst_addr                                              "0x0309"
+#define REGD38_inst                                                   0x0309
+#define REGD38_reg_p1_slope_lv_up_shift                               (21)
+#define REGD38_reg_p1_slope_lv_dn_shift                               (10)
+#define REGD38_reg_p1_cp_time_shift                                   (5)
+#define REGD38_reg_p1_timer_4_shift                                   (0)
+#define REGD38_reg_p1_slope_lv_up_mask                                (0xFFE00000)
+#define REGD38_reg_p1_slope_lv_dn_mask                                (0x001FFC00)
+#define REGD38_reg_p1_cp_time_mask                                    (0x000003E0)
+#define REGD38_reg_p1_timer_4_mask                                    (0x0000001F)
+#define REGD38_reg_p1_slope_lv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD38_reg_p1_slope_lv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD38_reg_p1_cp_time(data)                                   (0x000003E0&((data)<<5))
+#define REGD38_reg_p1_timer_4(data)                                   (0x0000001F&(data))
+#define REGD38_get_reg_p1_slope_lv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD38_get_reg_p1_slope_lv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD38_get_reg_p1_cp_time(data)                               ((0x000003E0&(data))>>5)
+#define REGD38_get_reg_p1_timer_4(data)                               (0x0000001F&(data))
+
+
+#define REGD39                                                        0xc28
+#define REGD39_reg_addr                                               "0x98034c28"
+#define REGD39_reg                                                    0x98034c28
+#define REGD39_inst_addr                                              "0x030A"
+#define REGD39_inst                                                   0x030A
+#define REGD39_reg_p1_slope_hv_up_shift                               (21)
+#define REGD39_reg_p1_slope_hv_dn_shift                               (10)
+#define REGD39_reg_p1_timer_5_shift                                   (9)
+#define REGD39_reg_p1_timer_6_shift                                   (4)
+#define REGD39_reg_p1_slope_hv_up_mask                                (0xFFE00000)
+#define REGD39_reg_p1_slope_hv_dn_mask                                (0x001FFC00)
+#define REGD39_reg_p1_timer_5_mask                                    (0x00000200)
+#define REGD39_reg_p1_timer_6_mask                                    (0x000001F0)
+#define REGD39_reg_p1_slope_hv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD39_reg_p1_slope_hv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD39_reg_p1_timer_5(data)                                   (0x00000200&((data)<<9))
+#define REGD39_reg_p1_timer_6(data)                                   (0x000001F0&((data)<<4))
+#define REGD39_get_reg_p1_slope_hv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD39_get_reg_p1_slope_hv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD39_get_reg_p1_timer_5(data)                               ((0x00000200&(data))>>9)
+#define REGD39_get_reg_p1_timer_6(data)                               ((0x000001F0&(data))>>4)
+
+
+#define REGD40                                                        0xc2c
+#define REGD40_reg_addr                                               "0x98034c2c"
+#define REGD40_reg                                                    0x98034c2c
+#define REGD40_inst_addr                                              "0x030B"
+#define REGD40_inst                                                   0x030B
+#define REGD40_reg_p1_start_en_manual_shift                           (31)
+#define REGD40_reg_p1_pfd_en_manual_shift                             (30)
+#define REGD40_reg_p1_pfd_time_shift                                  (25)
+#define REGD40_reg_p1_pfd_bypass_shift                                (24)
+#define REGD40_reg_p1_rxidle_bypass_shift                             (23)
+#define REGD40_reg_p1_slope_manual_shift                              (22)
+#define REGD40_reg_p1_slope_band_shift                                (17)
+#define REGD40_reg_p1_old_mode_shift                                  (16)
+#define REGD40_reg_p1_start_en_manual_mask                            (0x80000000)
+#define REGD40_reg_p1_pfd_en_manual_mask                              (0x40000000)
+#define REGD40_reg_p1_pfd_time_mask                                   (0x3E000000)
+#define REGD40_reg_p1_pfd_bypass_mask                                 (0x01000000)
+#define REGD40_reg_p1_rxidle_bypass_mask                              (0x00800000)
+#define REGD40_reg_p1_slope_manual_mask                               (0x00400000)
+#define REGD40_reg_p1_slope_band_mask                                 (0x003E0000)
+#define REGD40_reg_p1_old_mode_mask                                   (0x00010000)
+#define REGD40_reg_p1_start_en_manual(data)                           (0x80000000&((data)<<31))
+#define REGD40_reg_p1_pfd_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD40_reg_p1_pfd_time(data)                                  (0x3E000000&((data)<<25))
+#define REGD40_reg_p1_pfd_bypass(data)                                (0x01000000&((data)<<24))
+#define REGD40_reg_p1_rxidle_bypass(data)                             (0x00800000&((data)<<23))
+#define REGD40_reg_p1_slope_manual(data)                              (0x00400000&((data)<<22))
+#define REGD40_reg_p1_slope_band(data)                                (0x003E0000&((data)<<17))
+#define REGD40_reg_p1_old_mode(data)                                  (0x00010000&((data)<<16))
+#define REGD40_get_reg_p1_start_en_manual(data)                       ((0x80000000&(data))>>31)
+#define REGD40_get_reg_p1_pfd_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD40_get_reg_p1_pfd_time(data)                              ((0x3E000000&(data))>>25)
+#define REGD40_get_reg_p1_pfd_bypass(data)                            ((0x01000000&(data))>>24)
+#define REGD40_get_reg_p1_rxidle_bypass(data)                         ((0x00800000&(data))>>23)
+#define REGD40_get_reg_p1_slope_manual(data)                          ((0x00400000&(data))>>22)
+#define REGD40_get_reg_p1_slope_band(data)                            ((0x003E0000&(data))>>17)
+#define REGD40_get_reg_p1_old_mode(data)                              ((0x00010000&(data))>>16)
+
+
+#define REGD41                                                        0xc30
+#define REGD41_reg_addr                                               "0x98034c30"
+#define REGD41_reg                                                    0x98034c30
+#define REGD41_inst_addr                                              "0x030C"
+#define REGD41_inst                                                   0x030C
+#define REGD41_p1_fld_st_reg_shift                                    (27)
+#define REGD41_p1_adp_en_fsm_reg_shift                                (26)
+#define REGD41_p1_cp_en_fsm_reg_shift                                 (25)
+#define REGD41_p1_coarse_fsm_reg_shift                                (18)
+#define REGD41_p1_pfd_en_fsm_reg_shift                                (17)
+#define REGD41_p1_slope_lv_reg_shift                                  (12)
+#define REGD41_p1_slope_hv_reg_shift                                  (7)
+#define REGD41_p1_slope_final_reg_shift                               (2)
+#define REGD41_p1_fld_st_reg_mask                                     (0xF8000000)
+#define REGD41_p1_adp_en_fsm_reg_mask                                 (0x04000000)
+#define REGD41_p1_cp_en_fsm_reg_mask                                  (0x02000000)
+#define REGD41_p1_coarse_fsm_reg_mask                                 (0x01FC0000)
+#define REGD41_p1_pfd_en_fsm_reg_mask                                 (0x00020000)
+#define REGD41_p1_slope_lv_reg_mask                                   (0x0001F000)
+#define REGD41_p1_slope_hv_reg_mask                                   (0x00000F80)
+#define REGD41_p1_slope_final_reg_mask                                (0x0000007C)
+#define REGD41_p1_fld_st_reg(data)                                    (0xF8000000&((data)<<27))
+#define REGD41_p1_adp_en_fsm_reg(data)                                (0x04000000&((data)<<26))
+#define REGD41_p1_cp_en_fsm_reg(data)                                 (0x02000000&((data)<<25))
+#define REGD41_p1_coarse_fsm_reg(data)                                (0x01FC0000&((data)<<18))
+#define REGD41_p1_pfd_en_fsm_reg(data)                                (0x00020000&((data)<<17))
+#define REGD41_p1_slope_lv_reg(data)                                  (0x0001F000&((data)<<12))
+#define REGD41_p1_slope_hv_reg(data)                                  (0x00000F80&((data)<<7))
+#define REGD41_p1_slope_final_reg(data)                               (0x0000007C&((data)<<2))
+#define REGD41_get_p1_fld_st_reg(data)                                ((0xF8000000&(data))>>27)
+#define REGD41_get_p1_adp_en_fsm_reg(data)                            ((0x04000000&(data))>>26)
+#define REGD41_get_p1_cp_en_fsm_reg(data)                             ((0x02000000&(data))>>25)
+#define REGD41_get_p1_coarse_fsm_reg(data)                            ((0x01FC0000&(data))>>18)
+#define REGD41_get_p1_pfd_en_fsm_reg(data)                            ((0x00020000&(data))>>17)
+#define REGD41_get_p1_slope_lv_reg(data)                              ((0x0001F000&(data))>>12)
+#define REGD41_get_p1_slope_hv_reg(data)                              ((0x00000F80&(data))>>7)
+#define REGD41_get_p1_slope_final_reg(data)                           ((0x0000007C&(data))>>2)
+
+
+#define REGD42                                                        0xc34
+#define REGD42_reg_addr                                               "0x98034c34"
+#define REGD42_reg                                                    0x98034c34
+#define REGD42_inst_addr                                              "0x030D"
+#define REGD42_inst                                                   0x030D
+#define REGD42_reg_p2_auto_mode_shift                                 (31)
+#define REGD42_reg_p2_adp_en_manual_shift                             (30)
+#define REGD42_reg_p2_cp_en_manual_shift                              (29)
+#define REGD42_reg_p2_adap_eq_off_shift                               (28)
+#define REGD42_reg_p2_adp_time_shift                                  (23)
+#define REGD42_reg_p2_calib_time_shift                                (20)
+#define REGD42_reg_p2_calib_manual_shift                              (19)
+#define REGD42_reg_p2_calib_late_shift                                (18)
+#define REGD42_reg_p2_vco_coarse_shift                                (11)
+#define REGD42_reg_p2_divide_num_shift                                (4)
+#define REGD42_reg_p2_init_time_shift                                 (1)
+#define REGD42_reg_p2_auto_mode_mask                                  (0x80000000)
+#define REGD42_reg_p2_adp_en_manual_mask                              (0x40000000)
+#define REGD42_reg_p2_cp_en_manual_mask                               (0x20000000)
+#define REGD42_reg_p2_adap_eq_off_mask                                (0x10000000)
+#define REGD42_reg_p2_adp_time_mask                                   (0x0F800000)
+#define REGD42_reg_p2_calib_time_mask                                 (0x00700000)
+#define REGD42_reg_p2_calib_manual_mask                               (0x00080000)
+#define REGD42_reg_p2_calib_late_mask                                 (0x00040000)
+#define REGD42_reg_p2_vco_coarse_mask                                 (0x0003F800)
+#define REGD42_reg_p2_divide_num_mask                                 (0x000007F0)
+#define REGD42_reg_p2_init_time_mask                                  (0x0000000E)
+#define REGD42_reg_p2_auto_mode(data)                                 (0x80000000&((data)<<31))
+#define REGD42_reg_p2_adp_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD42_reg_p2_cp_en_manual(data)                              (0x20000000&((data)<<29))
+#define REGD42_reg_p2_adap_eq_off(data)                               (0x10000000&((data)<<28))
+#define REGD42_reg_p2_adp_time(data)                                  (0x0F800000&((data)<<23))
+#define REGD42_reg_p2_calib_time(data)                                (0x00700000&((data)<<20))
+#define REGD42_reg_p2_calib_manual(data)                              (0x00080000&((data)<<19))
+#define REGD42_reg_p2_calib_late(data)                                (0x00040000&((data)<<18))
+#define REGD42_reg_p2_vco_coarse(data)                                (0x0003F800&((data)<<11))
+#define REGD42_reg_p2_divide_num(data)                                (0x000007F0&((data)<<4))
+#define REGD42_reg_p2_init_time(data)                                 (0x0000000E&((data)<<1))
+#define REGD42_get_reg_p2_auto_mode(data)                             ((0x80000000&(data))>>31)
+#define REGD42_get_reg_p2_adp_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD42_get_reg_p2_cp_en_manual(data)                          ((0x20000000&(data))>>29)
+#define REGD42_get_reg_p2_adap_eq_off(data)                           ((0x10000000&(data))>>28)
+#define REGD42_get_reg_p2_adp_time(data)                              ((0x0F800000&(data))>>23)
+#define REGD42_get_reg_p2_calib_time(data)                            ((0x00700000&(data))>>20)
+#define REGD42_get_reg_p2_calib_manual(data)                          ((0x00080000&(data))>>19)
+#define REGD42_get_reg_p2_calib_late(data)                            ((0x00040000&(data))>>18)
+#define REGD42_get_reg_p2_vco_coarse(data)                            ((0x0003F800&(data))>>11)
+#define REGD42_get_reg_p2_divide_num(data)                            ((0x000007F0&(data))>>4)
+#define REGD42_get_reg_p2_init_time(data)                             ((0x0000000E&(data))>>1)
+
+
+#define REGD43                                                        0xc38
+#define REGD43_reg_addr                                               "0x98034c38"
+#define REGD43_reg                                                    0x98034c38
+#define REGD43_inst_addr                                              "0x030E"
+#define REGD43_inst                                                   0x030E
+#define REGD43_reg_p2_lock_up_limit_shift                             (16)
+#define REGD43_reg_p2_lock_dn_limit_shift                             (0)
+#define REGD43_reg_p2_lock_up_limit_mask                              (0x07FF0000)
+#define REGD43_reg_p2_lock_dn_limit_mask                              (0x000007FF)
+#define REGD43_reg_p2_lock_up_limit(data)                             (0x07FF0000&((data)<<16))
+#define REGD43_reg_p2_lock_dn_limit(data)                             (0x000007FF&(data))
+#define REGD43_get_reg_p2_lock_up_limit(data)                         ((0x07FF0000&(data))>>16)
+#define REGD43_get_reg_p2_lock_dn_limit(data)                         (0x000007FF&(data))
+
+
+#define REGD44                                                        0xc3c
+#define REGD44_reg_addr                                               "0x98034c3c"
+#define REGD44_reg                                                    0x98034c3c
+#define REGD44_inst_addr                                              "0x030F"
+#define REGD44_inst                                                   0x030F
+#define REGD44_reg_p2_cdr_cp_shift                                    (12)
+#define REGD44_reg_p2_cdr_r_shift                                     (6)
+#define REGD44_reg_p2_cdr_c_shift                                     (4)
+#define REGD44_reg_p2_vc_sel_shift                                    (2)
+#define REGD44_reg_p2_calib_reset_sel_shift                           (1)
+#define REGD44_reg_p2_cdr_cp_mask                                     (0xFFFFF000)
+#define REGD44_reg_p2_cdr_r_mask                                      (0x00000FC0)
+#define REGD44_reg_p2_cdr_c_mask                                      (0x00000030)
+#define REGD44_reg_p2_vc_sel_mask                                     (0x0000000C)
+#define REGD44_reg_p2_calib_reset_sel_mask                            (0x00000002)
+#define REGD44_reg_p2_cdr_cp(data)                                    (0xFFFFF000&((data)<<12))
+#define REGD44_reg_p2_cdr_r(data)                                     (0x00000FC0&((data)<<6))
+#define REGD44_reg_p2_cdr_c(data)                                     (0x00000030&((data)<<4))
+#define REGD44_reg_p2_vc_sel(data)                                    (0x0000000C&((data)<<2))
+#define REGD44_reg_p2_calib_reset_sel(data)                           (0x00000002&((data)<<1))
+#define REGD44_get_reg_p2_cdr_cp(data)                                ((0xFFFFF000&(data))>>12)
+#define REGD44_get_reg_p2_cdr_r(data)                                 ((0x00000FC0&(data))>>6)
+#define REGD44_get_reg_p2_cdr_c(data)                                 ((0x00000030&(data))>>4)
+#define REGD44_get_reg_p2_vc_sel(data)                                ((0x0000000C&(data))>>2)
+#define REGD44_get_reg_p2_calib_reset_sel(data)                       ((0x00000002&(data))>>1)
+
+
+#define REGD45                                                        0xc40
+#define REGD45_reg_addr                                               "0x98034c40"
+#define REGD45_reg                                                    0x98034c40
+#define REGD45_inst_addr                                              "0x0310"
+#define REGD45_inst                                                   0x0310
+#define REGD45_reg_p2_slope_lv_up_shift                               (21)
+#define REGD45_reg_p2_slope_lv_dn_shift                               (10)
+#define REGD45_reg_p2_cp_time_shift                                   (5)
+#define REGD45_reg_p2_timer_4_shift                                   (0)
+#define REGD45_reg_p2_slope_lv_up_mask                                (0xFFE00000)
+#define REGD45_reg_p2_slope_lv_dn_mask                                (0x001FFC00)
+#define REGD45_reg_p2_cp_time_mask                                    (0x000003E0)
+#define REGD45_reg_p2_timer_4_mask                                    (0x0000001F)
+#define REGD45_reg_p2_slope_lv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD45_reg_p2_slope_lv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD45_reg_p2_cp_time(data)                                   (0x000003E0&((data)<<5))
+#define REGD45_reg_p2_timer_4(data)                                   (0x0000001F&(data))
+#define REGD45_get_reg_p2_slope_lv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD45_get_reg_p2_slope_lv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD45_get_reg_p2_cp_time(data)                               ((0x000003E0&(data))>>5)
+#define REGD45_get_reg_p2_timer_4(data)                               (0x0000001F&(data))
+
+
+#define REGD46                                                        0xc44
+#define REGD46_reg_addr                                               "0x98034c44"
+#define REGD46_reg                                                    0x98034c44
+#define REGD46_inst_addr                                              "0x0311"
+#define REGD46_inst                                                   0x0311
+#define REGD46_reg_p2_slope_hv_up_shift                               (21)
+#define REGD46_reg_p2_slope_hv_dn_shift                               (10)
+#define REGD46_reg_p2_timer_5_shift                                   (9)
+#define REGD46_reg_p2_timer_6_shift                                   (4)
+#define REGD46_reg_p2_slope_hv_up_mask                                (0xFFE00000)
+#define REGD46_reg_p2_slope_hv_dn_mask                                (0x001FFC00)
+#define REGD46_reg_p2_timer_5_mask                                    (0x00000200)
+#define REGD46_reg_p2_timer_6_mask                                    (0x000001F0)
+#define REGD46_reg_p2_slope_hv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD46_reg_p2_slope_hv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD46_reg_p2_timer_5(data)                                   (0x00000200&((data)<<9))
+#define REGD46_reg_p2_timer_6(data)                                   (0x000001F0&((data)<<4))
+#define REGD46_get_reg_p2_slope_hv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD46_get_reg_p2_slope_hv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD46_get_reg_p2_timer_5(data)                               ((0x00000200&(data))>>9)
+#define REGD46_get_reg_p2_timer_6(data)                               ((0x000001F0&(data))>>4)
+
+
+#define REGD47                                                        0xc48
+#define REGD47_reg_addr                                               "0x98034c48"
+#define REGD47_reg                                                    0x98034c48
+#define REGD47_inst_addr                                              "0x0312"
+#define REGD47_inst                                                   0x0312
+#define REGD47_reg_p2_start_en_manual_shift                           (31)
+#define REGD47_reg_p2_pfd_en_manual_shift                             (30)
+#define REGD47_reg_p2_pfd_time_shift                                  (25)
+#define REGD47_reg_p2_pfd_bypass_shift                                (24)
+#define REGD47_reg_p2_rxidle_bypass_shift                             (23)
+#define REGD47_reg_p2_slope_manual_shift                              (22)
+#define REGD47_reg_p2_slope_band_shift                                (17)
+#define REGD47_reg_p2_old_mode_shift                                  (16)
+#define REGD47_reg_p2_start_en_manual_mask                            (0x80000000)
+#define REGD47_reg_p2_pfd_en_manual_mask                              (0x40000000)
+#define REGD47_reg_p2_pfd_time_mask                                   (0x3E000000)
+#define REGD47_reg_p2_pfd_bypass_mask                                 (0x01000000)
+#define REGD47_reg_p2_rxidle_bypass_mask                              (0x00800000)
+#define REGD47_reg_p2_slope_manual_mask                               (0x00400000)
+#define REGD47_reg_p2_slope_band_mask                                 (0x003E0000)
+#define REGD47_reg_p2_old_mode_mask                                   (0x00010000)
+#define REGD47_reg_p2_start_en_manual(data)                           (0x80000000&((data)<<31))
+#define REGD47_reg_p2_pfd_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD47_reg_p2_pfd_time(data)                                  (0x3E000000&((data)<<25))
+#define REGD47_reg_p2_pfd_bypass(data)                                (0x01000000&((data)<<24))
+#define REGD47_reg_p2_rxidle_bypass(data)                             (0x00800000&((data)<<23))
+#define REGD47_reg_p2_slope_manual(data)                              (0x00400000&((data)<<22))
+#define REGD47_reg_p2_slope_band(data)                                (0x003E0000&((data)<<17))
+#define REGD47_reg_p2_old_mode(data)                                  (0x00010000&((data)<<16))
+#define REGD47_get_reg_p2_start_en_manual(data)                       ((0x80000000&(data))>>31)
+#define REGD47_get_reg_p2_pfd_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD47_get_reg_p2_pfd_time(data)                              ((0x3E000000&(data))>>25)
+#define REGD47_get_reg_p2_pfd_bypass(data)                            ((0x01000000&(data))>>24)
+#define REGD47_get_reg_p2_rxidle_bypass(data)                         ((0x00800000&(data))>>23)
+#define REGD47_get_reg_p2_slope_manual(data)                          ((0x00400000&(data))>>22)
+#define REGD47_get_reg_p2_slope_band(data)                            ((0x003E0000&(data))>>17)
+#define REGD47_get_reg_p2_old_mode(data)                              ((0x00010000&(data))>>16)
+
+
+#define REGD48                                                        0xc4c
+#define REGD48_reg_addr                                               "0x98034c4c"
+#define REGD48_reg                                                    0x98034c4c
+#define REGD48_inst_addr                                              "0x0313"
+#define REGD48_inst                                                   0x0313
+#define REGD48_p2_fld_st_reg_shift                                    (27)
+#define REGD48_p2_adp_en_fsm_reg_shift                                (26)
+#define REGD48_p2_cp_en_fsm_reg_shift                                 (25)
+#define REGD48_p2_coarse_fsm_reg_shift                                (18)
+#define REGD48_p2_pfd_en_fsm_reg_shift                                (17)
+#define REGD48_p2_slope_lv_reg_shift                                  (12)
+#define REGD48_p2_slope_hv_reg_shift                                  (7)
+#define REGD48_p2_slope_final_reg_shift                               (2)
+#define REGD48_p2_fld_st_reg_mask                                     (0xF8000000)
+#define REGD48_p2_adp_en_fsm_reg_mask                                 (0x04000000)
+#define REGD48_p2_cp_en_fsm_reg_mask                                  (0x02000000)
+#define REGD48_p2_coarse_fsm_reg_mask                                 (0x01FC0000)
+#define REGD48_p2_pfd_en_fsm_reg_mask                                 (0x00020000)
+#define REGD48_p2_slope_lv_reg_mask                                   (0x0001F000)
+#define REGD48_p2_slope_hv_reg_mask                                   (0x00000F80)
+#define REGD48_p2_slope_final_reg_mask                                (0x0000007C)
+#define REGD48_p2_fld_st_reg(data)                                    (0xF8000000&((data)<<27))
+#define REGD48_p2_adp_en_fsm_reg(data)                                (0x04000000&((data)<<26))
+#define REGD48_p2_cp_en_fsm_reg(data)                                 (0x02000000&((data)<<25))
+#define REGD48_p2_coarse_fsm_reg(data)                                (0x01FC0000&((data)<<18))
+#define REGD48_p2_pfd_en_fsm_reg(data)                                (0x00020000&((data)<<17))
+#define REGD48_p2_slope_lv_reg(data)                                  (0x0001F000&((data)<<12))
+#define REGD48_p2_slope_hv_reg(data)                                  (0x00000F80&((data)<<7))
+#define REGD48_p2_slope_final_reg(data)                               (0x0000007C&((data)<<2))
+#define REGD48_get_p2_fld_st_reg(data)                                ((0xF8000000&(data))>>27)
+#define REGD48_get_p2_adp_en_fsm_reg(data)                            ((0x04000000&(data))>>26)
+#define REGD48_get_p2_cp_en_fsm_reg(data)                             ((0x02000000&(data))>>25)
+#define REGD48_get_p2_coarse_fsm_reg(data)                            ((0x01FC0000&(data))>>18)
+#define REGD48_get_p2_pfd_en_fsm_reg(data)                            ((0x00020000&(data))>>17)
+#define REGD48_get_p2_slope_lv_reg(data)                              ((0x0001F000&(data))>>12)
+#define REGD48_get_p2_slope_hv_reg(data)                              ((0x00000F80&(data))>>7)
+#define REGD48_get_p2_slope_final_reg(data)                           ((0x0000007C&(data))>>2)
+
+
+#define REGD49                                                        0xc50
+#define REGD49_reg_addr                                               "0x98034c50"
+#define REGD49_reg                                                    0x98034c50
+#define REGD49_inst_addr                                              "0x0314"
+#define REGD49_inst                                                   0x0314
+#define REGD49_reg_p3_auto_mode_shift                                 (31)
+#define REGD49_reg_p3_adp_en_manual_shift                             (30)
+#define REGD49_reg_p3_cp_en_manual_shift                              (29)
+#define REGD49_reg_p3_adap_eq_off_shift                               (28)
+#define REGD49_reg_p3_adp_time_shift                                  (23)
+#define REGD49_reg_p3_calib_time_shift                                (20)
+#define REGD49_reg_p3_calib_manual_shift                              (19)
+#define REGD49_reg_p3_calib_late_shift                                (18)
+#define REGD49_reg_p3_vco_coarse_shift                                (11)
+#define REGD49_reg_p3_divide_num_shift                                (4)
+#define REGD49_reg_p3_init_time_shift                                 (1)
+#define REGD49_reg_p3_auto_mode_mask                                  (0x80000000)
+#define REGD49_reg_p3_adp_en_manual_mask                              (0x40000000)
+#define REGD49_reg_p3_cp_en_manual_mask                               (0x20000000)
+#define REGD49_reg_p3_adap_eq_off_mask                                (0x10000000)
+#define REGD49_reg_p3_adp_time_mask                                   (0x0F800000)
+#define REGD49_reg_p3_calib_time_mask                                 (0x00700000)
+#define REGD49_reg_p3_calib_manual_mask                               (0x00080000)
+#define REGD49_reg_p3_calib_late_mask                                 (0x00040000)
+#define REGD49_reg_p3_vco_coarse_mask                                 (0x0003F800)
+#define REGD49_reg_p3_divide_num_mask                                 (0x000007F0)
+#define REGD49_reg_p3_init_time_mask                                  (0x0000000E)
+#define REGD49_reg_p3_auto_mode(data)                                 (0x80000000&((data)<<31))
+#define REGD49_reg_p3_adp_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD49_reg_p3_cp_en_manual(data)                              (0x20000000&((data)<<29))
+#define REGD49_reg_p3_adap_eq_off(data)                               (0x10000000&((data)<<28))
+#define REGD49_reg_p3_adp_time(data)                                  (0x0F800000&((data)<<23))
+#define REGD49_reg_p3_calib_time(data)                                (0x00700000&((data)<<20))
+#define REGD49_reg_p3_calib_manual(data)                              (0x00080000&((data)<<19))
+#define REGD49_reg_p3_calib_late(data)                                (0x00040000&((data)<<18))
+#define REGD49_reg_p3_vco_coarse(data)                                (0x0003F800&((data)<<11))
+#define REGD49_reg_p3_divide_num(data)                                (0x000007F0&((data)<<4))
+#define REGD49_reg_p3_init_time(data)                                 (0x0000000E&((data)<<1))
+#define REGD49_get_reg_p3_auto_mode(data)                             ((0x80000000&(data))>>31)
+#define REGD49_get_reg_p3_adp_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD49_get_reg_p3_cp_en_manual(data)                          ((0x20000000&(data))>>29)
+#define REGD49_get_reg_p3_adap_eq_off(data)                           ((0x10000000&(data))>>28)
+#define REGD49_get_reg_p3_adp_time(data)                              ((0x0F800000&(data))>>23)
+#define REGD49_get_reg_p3_calib_time(data)                            ((0x00700000&(data))>>20)
+#define REGD49_get_reg_p3_calib_manual(data)                          ((0x00080000&(data))>>19)
+#define REGD49_get_reg_p3_calib_late(data)                            ((0x00040000&(data))>>18)
+#define REGD49_get_reg_p3_vco_coarse(data)                            ((0x0003F800&(data))>>11)
+#define REGD49_get_reg_p3_divide_num(data)                            ((0x000007F0&(data))>>4)
+#define REGD49_get_reg_p3_init_time(data)                             ((0x0000000E&(data))>>1)
+
+
+#define REGD50                                                        0xc54
+#define REGD50_reg_addr                                               "0x98034c54"
+#define REGD50_reg                                                    0x98034c54
+#define REGD50_inst_addr                                              "0x0315"
+#define REGD50_inst                                                   0x0315
+#define REGD50_reg_p3_lock_up_limit_shift                             (16)
+#define REGD50_reg_p3_lock_dn_limit_shift                             (0)
+#define REGD50_reg_p3_lock_up_limit_mask                              (0x07FF0000)
+#define REGD50_reg_p3_lock_dn_limit_mask                              (0x000007FF)
+#define REGD50_reg_p3_lock_up_limit(data)                             (0x07FF0000&((data)<<16))
+#define REGD50_reg_p3_lock_dn_limit(data)                             (0x000007FF&(data))
+#define REGD50_get_reg_p3_lock_up_limit(data)                         ((0x07FF0000&(data))>>16)
+#define REGD50_get_reg_p3_lock_dn_limit(data)                         (0x000007FF&(data))
+
+
+#define REGD51                                                        0xc58
+#define REGD51_reg_addr                                               "0x98034c58"
+#define REGD51_reg                                                    0x98034c58
+#define REGD51_inst_addr                                              "0x0316"
+#define REGD51_inst                                                   0x0316
+#define REGD51_reg_p3_cdr_cp_shift                                    (12)
+#define REGD51_reg_p3_cdr_r_shift                                     (6)
+#define REGD51_reg_p3_cdr_c_shift                                     (4)
+#define REGD51_reg_p3_vc_sel_shift                                    (2)
+#define REGD51_reg_p3_calib_reset_sel_shift                           (1)
+#define REGD51_reg_p3_cdr_cp_mask                                     (0xFFFFF000)
+#define REGD51_reg_p3_cdr_r_mask                                      (0x00000FC0)
+#define REGD51_reg_p3_cdr_c_mask                                      (0x00000030)
+#define REGD51_reg_p3_vc_sel_mask                                     (0x0000000C)
+#define REGD51_reg_p3_calib_reset_sel_mask                            (0x00000002)
+#define REGD51_reg_p3_cdr_cp(data)                                    (0xFFFFF000&((data)<<12))
+#define REGD51_reg_p3_cdr_r(data)                                     (0x00000FC0&((data)<<6))
+#define REGD51_reg_p3_cdr_c(data)                                     (0x00000030&((data)<<4))
+#define REGD51_reg_p3_vc_sel(data)                                    (0x0000000C&((data)<<2))
+#define REGD51_reg_p3_calib_reset_sel(data)                           (0x00000002&((data)<<1))
+#define REGD51_get_reg_p3_cdr_cp(data)                                ((0xFFFFF000&(data))>>12)
+#define REGD51_get_reg_p3_cdr_r(data)                                 ((0x00000FC0&(data))>>6)
+#define REGD51_get_reg_p3_cdr_c(data)                                 ((0x00000030&(data))>>4)
+#define REGD51_get_reg_p3_vc_sel(data)                                ((0x0000000C&(data))>>2)
+#define REGD51_get_reg_p3_calib_reset_sel(data)                       ((0x00000002&(data))>>1)
+
+
+#define REGD52                                                        0xc5c
+#define REGD52_reg_addr                                               "0x98034c5c"
+#define REGD52_reg                                                    0x98034c5c
+#define REGD52_inst_addr                                              "0x0317"
+#define REGD52_inst                                                   0x0317
+#define REGD52_reg_p3_slope_lv_up_shift                               (21)
+#define REGD52_reg_p3_slope_lv_dn_shift                               (10)
+#define REGD52_reg_p3_cp_time_shift                                   (5)
+#define REGD52_reg_p3_timer_4_shift                                   (0)
+#define REGD52_reg_p3_slope_lv_up_mask                                (0xFFE00000)
+#define REGD52_reg_p3_slope_lv_dn_mask                                (0x001FFC00)
+#define REGD52_reg_p3_cp_time_mask                                    (0x000003E0)
+#define REGD52_reg_p3_timer_4_mask                                    (0x0000001F)
+#define REGD52_reg_p3_slope_lv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD52_reg_p3_slope_lv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD52_reg_p3_cp_time(data)                                   (0x000003E0&((data)<<5))
+#define REGD52_reg_p3_timer_4(data)                                   (0x0000001F&(data))
+#define REGD52_get_reg_p3_slope_lv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD52_get_reg_p3_slope_lv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD52_get_reg_p3_cp_time(data)                               ((0x000003E0&(data))>>5)
+#define REGD52_get_reg_p3_timer_4(data)                               (0x0000001F&(data))
+
+
+#define REGD53                                                        0xc60
+#define REGD53_reg_addr                                               "0x98034c60"
+#define REGD53_reg                                                    0x98034c60
+#define REGD53_inst_addr                                              "0x0318"
+#define REGD53_inst                                                   0x0318
+#define REGD53_reg_p3_slope_hv_up_shift                               (21)
+#define REGD53_reg_p3_slope_hv_dn_shift                               (10)
+#define REGD53_reg_p3_timer_5_shift                                   (9)
+#define REGD53_reg_p3_timer_6_shift                                   (4)
+#define REGD53_reg_p3_slope_hv_up_mask                                (0xFFE00000)
+#define REGD53_reg_p3_slope_hv_dn_mask                                (0x001FFC00)
+#define REGD53_reg_p3_timer_5_mask                                    (0x00000200)
+#define REGD53_reg_p3_timer_6_mask                                    (0x000001F0)
+#define REGD53_reg_p3_slope_hv_up(data)                               (0xFFE00000&((data)<<21))
+#define REGD53_reg_p3_slope_hv_dn(data)                               (0x001FFC00&((data)<<10))
+#define REGD53_reg_p3_timer_5(data)                                   (0x00000200&((data)<<9))
+#define REGD53_reg_p3_timer_6(data)                                   (0x000001F0&((data)<<4))
+#define REGD53_get_reg_p3_slope_hv_up(data)                           ((0xFFE00000&(data))>>21)
+#define REGD53_get_reg_p3_slope_hv_dn(data)                           ((0x001FFC00&(data))>>10)
+#define REGD53_get_reg_p3_timer_5(data)                               ((0x00000200&(data))>>9)
+#define REGD53_get_reg_p3_timer_6(data)                               ((0x000001F0&(data))>>4)
+
+
+#define REGD54                                                        0xc64
+#define REGD54_reg_addr                                               "0x98034c64"
+#define REGD54_reg                                                    0x98034c64
+#define REGD54_inst_addr                                              "0x0319"
+#define REGD54_inst                                                   0x0319
+#define REGD54_reg_p3_start_en_manual_shift                           (31)
+#define REGD54_reg_p3_pfd_en_manual_shift                             (30)
+#define REGD54_reg_p3_pfd_time_shift                                  (25)
+#define REGD54_reg_p3_pfd_bypass_shift                                (24)
+#define REGD54_reg_p3_rxidle_bypass_shift                             (23)
+#define REGD54_reg_p3_slope_manual_shift                              (22)
+#define REGD54_reg_p3_slope_band_shift                                (17)
+#define REGD54_reg_p3_old_mode_shift                                  (16)
+#define REGD54_reg_p3_start_en_manual_mask                            (0x80000000)
+#define REGD54_reg_p3_pfd_en_manual_mask                              (0x40000000)
+#define REGD54_reg_p3_pfd_time_mask                                   (0x3E000000)
+#define REGD54_reg_p3_pfd_bypass_mask                                 (0x01000000)
+#define REGD54_reg_p3_rxidle_bypass_mask                              (0x00800000)
+#define REGD54_reg_p3_slope_manual_mask                               (0x00400000)
+#define REGD54_reg_p3_slope_band_mask                                 (0x003E0000)
+#define REGD54_reg_p3_old_mode_mask                                   (0x00010000)
+#define REGD54_reg_p3_start_en_manual(data)                           (0x80000000&((data)<<31))
+#define REGD54_reg_p3_pfd_en_manual(data)                             (0x40000000&((data)<<30))
+#define REGD54_reg_p3_pfd_time(data)                                  (0x3E000000&((data)<<25))
+#define REGD54_reg_p3_pfd_bypass(data)                                (0x01000000&((data)<<24))
+#define REGD54_reg_p3_rxidle_bypass(data)                             (0x00800000&((data)<<23))
+#define REGD54_reg_p3_slope_manual(data)                              (0x00400000&((data)<<22))
+#define REGD54_reg_p3_slope_band(data)                                (0x003E0000&((data)<<17))
+#define REGD54_reg_p3_old_mode(data)                                  (0x00010000&((data)<<16))
+#define REGD54_get_reg_p3_start_en_manual(data)                       ((0x80000000&(data))>>31)
+#define REGD54_get_reg_p3_pfd_en_manual(data)                         ((0x40000000&(data))>>30)
+#define REGD54_get_reg_p3_pfd_time(data)                              ((0x3E000000&(data))>>25)
+#define REGD54_get_reg_p3_pfd_bypass(data)                            ((0x01000000&(data))>>24)
+#define REGD54_get_reg_p3_rxidle_bypass(data)                         ((0x00800000&(data))>>23)
+#define REGD54_get_reg_p3_slope_manual(data)                          ((0x00400000&(data))>>22)
+#define REGD54_get_reg_p3_slope_band(data)                            ((0x003E0000&(data))>>17)
+#define REGD54_get_reg_p3_old_mode(data)                              ((0x00010000&(data))>>16)
+
+
+#define REGD55                                                        0xc68
+#define REGD55_reg_addr                                               "0x98034c68"
+#define REGD55_reg                                                    0x98034c68
+#define REGD55_inst_addr                                              "0x031A"
+#define REGD55_inst                                                   0x031A
+#define REGD55_p3_fld_st_reg_shift                                    (27)
+#define REGD55_p3_adp_en_fsm_reg_shift                                (26)
+#define REGD55_p3_cp_en_fsm_reg_shift                                 (25)
+#define REGD55_p3_coarse_fsm_reg_shift                                (18)
+#define REGD55_p3_pfd_en_fsm_reg_shift                                (17)
+#define REGD55_p3_slope_lv_reg_shift                                  (12)
+#define REGD55_p3_slope_hv_reg_shift                                  (7)
+#define REGD55_p3_slope_final_reg_shift                               (2)
+#define REGD55_p3_fld_st_reg_mask                                     (0xF8000000)
+#define REGD55_p3_adp_en_fsm_reg_mask                                 (0x04000000)
+#define REGD55_p3_cp_en_fsm_reg_mask                                  (0x02000000)
+#define REGD55_p3_coarse_fsm_reg_mask                                 (0x01FC0000)
+#define REGD55_p3_pfd_en_fsm_reg_mask                                 (0x00020000)
+#define REGD55_p3_slope_lv_reg_mask                                   (0x0001F000)
+#define REGD55_p3_slope_hv_reg_mask                                   (0x00000F80)
+#define REGD55_p3_slope_final_reg_mask                                (0x0000007C)
+#define REGD55_p3_fld_st_reg(data)                                    (0xF8000000&((data)<<27))
+#define REGD55_p3_adp_en_fsm_reg(data)                                (0x04000000&((data)<<26))
+#define REGD55_p3_cp_en_fsm_reg(data)                                 (0x02000000&((data)<<25))
+#define REGD55_p3_coarse_fsm_reg(data)                                (0x01FC0000&((data)<<18))
+#define REGD55_p3_pfd_en_fsm_reg(data)                                (0x00020000&((data)<<17))
+#define REGD55_p3_slope_lv_reg(data)                                  (0x0001F000&((data)<<12))
+#define REGD55_p3_slope_hv_reg(data)                                  (0x00000F80&((data)<<7))
+#define REGD55_p3_slope_final_reg(data)                               (0x0000007C&((data)<<2))
+#define REGD55_get_p3_fld_st_reg(data)                                ((0xF8000000&(data))>>27)
+#define REGD55_get_p3_adp_en_fsm_reg(data)                            ((0x04000000&(data))>>26)
+#define REGD55_get_p3_cp_en_fsm_reg(data)                             ((0x02000000&(data))>>25)
+#define REGD55_get_p3_coarse_fsm_reg(data)                            ((0x01FC0000&(data))>>18)
+#define REGD55_get_p3_pfd_en_fsm_reg(data)                            ((0x00020000&(data))>>17)
+#define REGD55_get_p3_slope_lv_reg(data)                              ((0x0001F000&(data))>>12)
+#define REGD55_get_p3_slope_hv_reg(data)                              ((0x00000F80&(data))>>7)
+#define REGD55_get_p3_slope_final_reg(data)                           ((0x0000007C&(data))>>2)
+
+
+#define REGD56                                                        0xc6c
+#define REGD56_reg_addr                                               "0x98034c6c"
+#define REGD56_reg                                                    0x98034c6c
+#define REGD56_inst_addr                                              "0x031B"
+#define REGD56_inst                                                   0x031B
+#define REGD56_p0_ck_md_rstb_shift                                    (31)
+#define REGD56_reg_p0_ck_md_threshold_shift                           (25)
+#define REGD56_reg_p0_ck_md_debounce_shift                            (18)
+#define REGD56_reg_p0_ck_md_sel_shift                                 (16)
+#define REGD56_reg_p0_ck_md_auto_shift                                (15)
+#define REGD56_reg_p0_ck_md_adj_shift                                 (11)
+#define REGD56_reg_p0_ck_error_limit_shift                            (6)
+#define REGD56_reg_p0_ck_md_reserved_shift                            (2)
+#define REGD56_p0_ck_md_rstb_mask                                     (0x80000000)
+#define REGD56_reg_p0_ck_md_threshold_mask                            (0x7E000000)
+#define REGD56_reg_p0_ck_md_debounce_mask                             (0x01FC0000)
+#define REGD56_reg_p0_ck_md_sel_mask                                  (0x00030000)
+#define REGD56_reg_p0_ck_md_auto_mask                                 (0x00008000)
+#define REGD56_reg_p0_ck_md_adj_mask                                  (0x00007800)
+#define REGD56_reg_p0_ck_error_limit_mask                             (0x000007C0)
+#define REGD56_reg_p0_ck_md_reserved_mask                             (0x0000003C)
+#define REGD56_p0_ck_md_rstb(data)                                    (0x80000000&((data)<<31))
+#define REGD56_reg_p0_ck_md_threshold(data)                           (0x7E000000&((data)<<25))
+#define REGD56_reg_p0_ck_md_debounce(data)                            (0x01FC0000&((data)<<18))
+#define REGD56_reg_p0_ck_md_sel(data)                                 (0x00030000&((data)<<16))
+#define REGD56_reg_p0_ck_md_auto(data)                                (0x00008000&((data)<<15))
+#define REGD56_reg_p0_ck_md_adj(data)                                 (0x00007800&((data)<<11))
+#define REGD56_reg_p0_ck_error_limit(data)                            (0x000007C0&((data)<<6))
+#define REGD56_reg_p0_ck_md_reserved(data)                            (0x0000003C&((data)<<2))
+#define REGD56_get_p0_ck_md_rstb(data)                                ((0x80000000&(data))>>31)
+#define REGD56_get_reg_p0_ck_md_threshold(data)                       ((0x7E000000&(data))>>25)
+#define REGD56_get_reg_p0_ck_md_debounce(data)                        ((0x01FC0000&(data))>>18)
+#define REGD56_get_reg_p0_ck_md_sel(data)                             ((0x00030000&(data))>>16)
+#define REGD56_get_reg_p0_ck_md_auto(data)                            ((0x00008000&(data))>>15)
+#define REGD56_get_reg_p0_ck_md_adj(data)                             ((0x00007800&(data))>>11)
+#define REGD56_get_reg_p0_ck_error_limit(data)                        ((0x000007C0&(data))>>6)
+#define REGD56_get_reg_p0_ck_md_reserved(data)                        ((0x0000003C&(data))>>2)
+
+
+#define REGD57                                                        0xc70
+#define REGD57_reg_addr                                               "0x98034c70"
+#define REGD57_reg                                                    0x98034c70
+#define REGD57_inst_addr                                              "0x031C"
+#define REGD57_inst                                                   0x031C
+#define REGD57_p0_ck_md_count_shift                                   (19)
+#define REGD57_p0_ck_rate_shift                                       (15)
+#define REGD57_p0_unstable_count_shift                                (10)
+#define REGD57_p0_ck_md_ok_shift                                      (9)
+#define REGD57_p0_clock_unstable_flag_shift                           (8)
+#define REGD57_p0_ck_md_count_mask                                    (0xFFF80000)
+#define REGD57_p0_ck_rate_mask                                        (0x00078000)
+#define REGD57_p0_unstable_count_mask                                 (0x00007C00)
+#define REGD57_p0_ck_md_ok_mask                                       (0x00000200)
+#define REGD57_p0_clock_unstable_flag_mask                            (0x00000100)
+#define REGD57_p0_ck_md_count(data)                                   (0xFFF80000&((data)<<19))
+#define REGD57_p0_ck_rate(data)                                       (0x00078000&((data)<<15))
+#define REGD57_p0_unstable_count(data)                                (0x00007C00&((data)<<10))
+#define REGD57_p0_ck_md_ok(data)                                      (0x00000200&((data)<<9))
+#define REGD57_p0_clock_unstable_flag(data)                           (0x00000100&((data)<<8))
+#define REGD57_get_p0_ck_md_count(data)                               ((0xFFF80000&(data))>>19)
+#define REGD57_get_p0_ck_rate(data)                                   ((0x00078000&(data))>>15)
+#define REGD57_get_p0_unstable_count(data)                            ((0x00007C00&(data))>>10)
+#define REGD57_get_p0_ck_md_ok(data)                                  ((0x00000200&(data))>>9)
+#define REGD57_get_p0_clock_unstable_flag(data)                       ((0x00000100&(data))>>8)
+
+
+#define REGD58                                                        0xc74
+#define REGD58_reg_addr                                               "0x98034c74"
+#define REGD58_reg                                                    0x98034c74
+#define REGD58_inst_addr                                              "0x031D"
+#define REGD58_inst                                                   0x031D
+#define REGD58_p1_ck_md_rstb_shift                                    (31)
+#define REGD58_reg_p1_ck_md_threshold_shift                           (25)
+#define REGD58_reg_p1_ck_md_debounce_shift                            (18)
+#define REGD58_reg_p1_ck_md_sel_shift                                 (16)
+#define REGD58_reg_p1_ck_md_auto_shift                                (15)
+#define REGD58_reg_p1_ck_md_adj_shift                                 (11)
+#define REGD58_reg_p1_ck_error_limit_shift                            (6)
+#define REGD58_reg_p1_ck_md_reserved_shift                            (2)
+#define REGD58_p1_ck_md_rstb_mask                                     (0x80000000)
+#define REGD58_reg_p1_ck_md_threshold_mask                            (0x7E000000)
+#define REGD58_reg_p1_ck_md_debounce_mask                             (0x01FC0000)
+#define REGD58_reg_p1_ck_md_sel_mask                                  (0x00030000)
+#define REGD58_reg_p1_ck_md_auto_mask                                 (0x00008000)
+#define REGD58_reg_p1_ck_md_adj_mask                                  (0x00007800)
+#define REGD58_reg_p1_ck_error_limit_mask                             (0x000007C0)
+#define REGD58_reg_p1_ck_md_reserved_mask                             (0x0000003C)
+#define REGD58_p1_ck_md_rstb(data)                                    (0x80000000&((data)<<31))
+#define REGD58_reg_p1_ck_md_threshold(data)                           (0x7E000000&((data)<<25))
+#define REGD58_reg_p1_ck_md_debounce(data)                            (0x01FC0000&((data)<<18))
+#define REGD58_reg_p1_ck_md_sel(data)                                 (0x00030000&((data)<<16))
+#define REGD58_reg_p1_ck_md_auto(data)                                (0x00008000&((data)<<15))
+#define REGD58_reg_p1_ck_md_adj(data)                                 (0x00007800&((data)<<11))
+#define REGD58_reg_p1_ck_error_limit(data)                            (0x000007C0&((data)<<6))
+#define REGD58_reg_p1_ck_md_reserved(data)                            (0x0000003C&((data)<<2))
+#define REGD58_get_p1_ck_md_rstb(data)                                ((0x80000000&(data))>>31)
+#define REGD58_get_reg_p1_ck_md_threshold(data)                       ((0x7E000000&(data))>>25)
+#define REGD58_get_reg_p1_ck_md_debounce(data)                        ((0x01FC0000&(data))>>18)
+#define REGD58_get_reg_p1_ck_md_sel(data)                             ((0x00030000&(data))>>16)
+#define REGD58_get_reg_p1_ck_md_auto(data)                            ((0x00008000&(data))>>15)
+#define REGD58_get_reg_p1_ck_md_adj(data)                             ((0x00007800&(data))>>11)
+#define REGD58_get_reg_p1_ck_error_limit(data)                        ((0x000007C0&(data))>>6)
+#define REGD58_get_reg_p1_ck_md_reserved(data)                        ((0x0000003C&(data))>>2)
+
+
+#define REGD59                                                        0xc78
+#define REGD59_reg_addr                                               "0x98034c78"
+#define REGD59_reg                                                    0x98034c78
+#define REGD59_inst_addr                                              "0x031E"
+#define REGD59_inst                                                   0x031E
+#define REGD59_p1_ck_md_count_shift                                   (19)
+#define REGD59_p1_ck_rate_shift                                       (15)
+#define REGD59_p1_unstable_count_shift                                (10)
+#define REGD59_p1_ck_md_ok_shift                                      (9)
+#define REGD59_p1_clock_unstable_flag_shift                           (8)
+#define REGD59_p1_ck_md_count_mask                                    (0xFFF80000)
+#define REGD59_p1_ck_rate_mask                                        (0x00078000)
+#define REGD59_p1_unstable_count_mask                                 (0x00007C00)
+#define REGD59_p1_ck_md_ok_mask                                       (0x00000200)
+#define REGD59_p1_clock_unstable_flag_mask                            (0x00000100)
+#define REGD59_p1_ck_md_count(data)                                   (0xFFF80000&((data)<<19))
+#define REGD59_p1_ck_rate(data)                                       (0x00078000&((data)<<15))
+#define REGD59_p1_unstable_count(data)                                (0x00007C00&((data)<<10))
+#define REGD59_p1_ck_md_ok(data)                                      (0x00000200&((data)<<9))
+#define REGD59_p1_clock_unstable_flag(data)                           (0x00000100&((data)<<8))
+#define REGD59_get_p1_ck_md_count(data)                               ((0xFFF80000&(data))>>19)
+#define REGD59_get_p1_ck_rate(data)                                   ((0x00078000&(data))>>15)
+#define REGD59_get_p1_unstable_count(data)                            ((0x00007C00&(data))>>10)
+#define REGD59_get_p1_ck_md_ok(data)                                  ((0x00000200&(data))>>9)
+#define REGD59_get_p1_clock_unstable_flag(data)                       ((0x00000100&(data))>>8)
+
+
+#define REGD60                                                        0xc7c
+#define REGD60_reg_addr                                               "0x98034c7c"
+#define REGD60_reg                                                    0x98034c7c
+#define REGD60_inst_addr                                              "0x031F"
+#define REGD60_inst                                                   0x031F
+#define REGD60_p2_ck_md_rstb_shift                                    (31)
+#define REGD60_reg_p2_ck_md_threshold_shift                           (25)
+#define REGD60_reg_p2_ck_md_debounce_shift                            (18)
+#define REGD60_reg_p2_ck_md_sel_shift                                 (16)
+#define REGD60_reg_p2_ck_md_auto_shift                                (15)
+#define REGD60_reg_p2_ck_md_adj_shift                                 (11)
+#define REGD60_reg_p2_ck_error_limit_shift                            (6)
+#define REGD60_reg_p2_ck_md_reserved_shift                            (2)
+#define REGD60_p2_ck_md_rstb_mask                                     (0x80000000)
+#define REGD60_reg_p2_ck_md_threshold_mask                            (0x7E000000)
+#define REGD60_reg_p2_ck_md_debounce_mask                             (0x01FC0000)
+#define REGD60_reg_p2_ck_md_sel_mask                                  (0x00030000)
+#define REGD60_reg_p2_ck_md_auto_mask                                 (0x00008000)
+#define REGD60_reg_p2_ck_md_adj_mask                                  (0x00007800)
+#define REGD60_reg_p2_ck_error_limit_mask                             (0x000007C0)
+#define REGD60_reg_p2_ck_md_reserved_mask                             (0x0000003C)
+#define REGD60_p2_ck_md_rstb(data)                                    (0x80000000&((data)<<31))
+#define REGD60_reg_p2_ck_md_threshold(data)                           (0x7E000000&((data)<<25))
+#define REGD60_reg_p2_ck_md_debounce(data)                            (0x01FC0000&((data)<<18))
+#define REGD60_reg_p2_ck_md_sel(data)                                 (0x00030000&((data)<<16))
+#define REGD60_reg_p2_ck_md_auto(data)                                (0x00008000&((data)<<15))
+#define REGD60_reg_p2_ck_md_adj(data)                                 (0x00007800&((data)<<11))
+#define REGD60_reg_p2_ck_error_limit(data)                            (0x000007C0&((data)<<6))
+#define REGD60_reg_p2_ck_md_reserved(data)                            (0x0000003C&((data)<<2))
+#define REGD60_get_p2_ck_md_rstb(data)                                ((0x80000000&(data))>>31)
+#define REGD60_get_reg_p2_ck_md_threshold(data)                       ((0x7E000000&(data))>>25)
+#define REGD60_get_reg_p2_ck_md_debounce(data)                        ((0x01FC0000&(data))>>18)
+#define REGD60_get_reg_p2_ck_md_sel(data)                             ((0x00030000&(data))>>16)
+#define REGD60_get_reg_p2_ck_md_auto(data)                            ((0x00008000&(data))>>15)
+#define REGD60_get_reg_p2_ck_md_adj(data)                             ((0x00007800&(data))>>11)
+#define REGD60_get_reg_p2_ck_error_limit(data)                        ((0x000007C0&(data))>>6)
+#define REGD60_get_reg_p2_ck_md_reserved(data)                        ((0x0000003C&(data))>>2)
+
+
+#define REGD61                                                        0xc80
+#define REGD61_reg_addr                                               "0x98034c80"
+#define REGD61_reg                                                    0x98034c80
+#define REGD61_inst_addr                                              "0x0320"
+#define REGD61_inst                                                   0x0320
+#define REGD61_p2_ck_md_count_shift                                   (19)
+#define REGD61_p2_ck_rate_shift                                       (15)
+#define REGD61_p2_unstable_count_shift                                (10)
+#define REGD61_p2_ck_md_ok_shift                                      (9)
+#define REGD61_p2_clock_unstable_flag_shift                           (8)
+#define REGD61_p2_ck_md_count_mask                                    (0xFFF80000)
+#define REGD61_p2_ck_rate_mask                                        (0x00078000)
+#define REGD61_p2_unstable_count_mask                                 (0x00007C00)
+#define REGD61_p2_ck_md_ok_mask                                       (0x00000200)
+#define REGD61_p2_clock_unstable_flag_mask                            (0x00000100)
+#define REGD61_p2_ck_md_count(data)                                   (0xFFF80000&((data)<<19))
+#define REGD61_p2_ck_rate(data)                                       (0x00078000&((data)<<15))
+#define REGD61_p2_unstable_count(data)                                (0x00007C00&((data)<<10))
+#define REGD61_p2_ck_md_ok(data)                                      (0x00000200&((data)<<9))
+#define REGD61_p2_clock_unstable_flag(data)                           (0x00000100&((data)<<8))
+#define REGD61_get_p2_ck_md_count(data)                               ((0xFFF80000&(data))>>19)
+#define REGD61_get_p2_ck_rate(data)                                   ((0x00078000&(data))>>15)
+#define REGD61_get_p2_unstable_count(data)                            ((0x00007C00&(data))>>10)
+#define REGD61_get_p2_ck_md_ok(data)                                  ((0x00000200&(data))>>9)
+#define REGD61_get_p2_clock_unstable_flag(data)                       ((0x00000100&(data))>>8)
+
+
+#define REGD62                                                        0xc84
+#define REGD62_reg_addr                                               "0x98034c84"
+#define REGD62_reg                                                    0x98034c84
+#define REGD62_inst_addr                                              "0x0321"
+#define REGD62_inst                                                   0x0321
+#define REGD62_p3_ck_md_rstb_shift                                    (31)
+#define REGD62_reg_p3_ck_md_threshold_shift                           (25)
+#define REGD62_reg_p3_ck_md_debounce_shift                            (18)
+#define REGD62_reg_p3_ck_md_sel_shift                                 (16)
+#define REGD62_reg_p3_ck_md_auto_shift                                (15)
+#define REGD62_reg_p3_ck_md_adj_shift                                 (11)
+#define REGD62_reg_p3_ck_error_limit_shift                            (6)
+#define REGD62_reg_p3_ck_md_reserved_shift                            (2)
+#define REGD62_p3_ck_md_rstb_mask                                     (0x80000000)
+#define REGD62_reg_p3_ck_md_threshold_mask                            (0x7E000000)
+#define REGD62_reg_p3_ck_md_debounce_mask                             (0x01FC0000)
+#define REGD62_reg_p3_ck_md_sel_mask                                  (0x00030000)
+#define REGD62_reg_p3_ck_md_auto_mask                                 (0x00008000)
+#define REGD62_reg_p3_ck_md_adj_mask                                  (0x00007800)
+#define REGD62_reg_p3_ck_error_limit_mask                             (0x000007C0)
+#define REGD62_reg_p3_ck_md_reserved_mask                             (0x0000003C)
+#define REGD62_p3_ck_md_rstb(data)                                    (0x80000000&((data)<<31))
+#define REGD62_reg_p3_ck_md_threshold(data)                           (0x7E000000&((data)<<25))
+#define REGD62_reg_p3_ck_md_debounce(data)                            (0x01FC0000&((data)<<18))
+#define REGD62_reg_p3_ck_md_sel(data)                                 (0x00030000&((data)<<16))
+#define REGD62_reg_p3_ck_md_auto(data)                                (0x00008000&((data)<<15))
+#define REGD62_reg_p3_ck_md_adj(data)                                 (0x00007800&((data)<<11))
+#define REGD62_reg_p3_ck_error_limit(data)                            (0x000007C0&((data)<<6))
+#define REGD62_reg_p3_ck_md_reserved(data)                            (0x0000003C&((data)<<2))
+#define REGD62_get_p3_ck_md_rstb(data)                                ((0x80000000&(data))>>31)
+#define REGD62_get_reg_p3_ck_md_threshold(data)                       ((0x7E000000&(data))>>25)
+#define REGD62_get_reg_p3_ck_md_debounce(data)                        ((0x01FC0000&(data))>>18)
+#define REGD62_get_reg_p3_ck_md_sel(data)                             ((0x00030000&(data))>>16)
+#define REGD62_get_reg_p3_ck_md_auto(data)                            ((0x00008000&(data))>>15)
+#define REGD62_get_reg_p3_ck_md_adj(data)                             ((0x00007800&(data))>>11)
+#define REGD62_get_reg_p3_ck_error_limit(data)                        ((0x000007C0&(data))>>6)
+#define REGD62_get_reg_p3_ck_md_reserved(data)                        ((0x0000003C&(data))>>2)
+
+
+#define REGD63                                                        0xc88
+#define REGD63_reg_addr                                               "0x98034c88"
+#define REGD63_reg                                                    0x98034c88
+#define REGD63_inst_addr                                              "0x0322"
+#define REGD63_inst                                                   0x0322
+#define REGD63_p3_ck_md_count_shift                                   (19)
+#define REGD63_p3_ck_rate_shift                                       (15)
+#define REGD63_p3_unstable_count_shift                                (10)
+#define REGD63_p3_ck_md_ok_shift                                      (9)
+#define REGD63_p3_clock_unstable_flag_shift                           (8)
+#define REGD63_p3_ck_md_count_mask                                    (0xFFF80000)
+#define REGD63_p3_ck_rate_mask                                        (0x00078000)
+#define REGD63_p3_unstable_count_mask                                 (0x00007C00)
+#define REGD63_p3_ck_md_ok_mask                                       (0x00000200)
+#define REGD63_p3_clock_unstable_flag_mask                            (0x00000100)
+#define REGD63_p3_ck_md_count(data)                                   (0xFFF80000&((data)<<19))
+#define REGD63_p3_ck_rate(data)                                       (0x00078000&((data)<<15))
+#define REGD63_p3_unstable_count(data)                                (0x00007C00&((data)<<10))
+#define REGD63_p3_ck_md_ok(data)                                      (0x00000200&((data)<<9))
+#define REGD63_p3_clock_unstable_flag(data)                           (0x00000100&((data)<<8))
+#define REGD63_get_p3_ck_md_count(data)                               ((0xFFF80000&(data))>>19)
+#define REGD63_get_p3_ck_rate(data)                                   ((0x00078000&(data))>>15)
+#define REGD63_get_p3_unstable_count(data)                            ((0x00007C00&(data))>>10)
+#define REGD63_get_p3_ck_md_ok(data)                                  ((0x00000200&(data))>>9)
+#define REGD63_get_p3_clock_unstable_flag(data)                       ((0x00000100&(data))>>8)
+
+
+#define REGD64                                                        0xc8c
+#define REGD64_reg_addr                                               "0x98034c8c"
+#define REGD64_reg                                                    0x98034c8c
+#define REGD64_inst_addr                                              "0x0323"
+#define REGD64_inst                                                   0x0323
+#define REGD64_reg_dig_reserved_0_shift                               (24)
+#define REGD64_reg_dig_reserved_1_shift                               (16)
+#define REGD64_reg_dig_reserved_2_shift                               (8)
+#define REGD64_reg_dig_reserved_3_shift                               (0)
+#define REGD64_reg_dig_reserved_0_mask                                (0xFF000000)
+#define REGD64_reg_dig_reserved_1_mask                                (0x00FF0000)
+#define REGD64_reg_dig_reserved_2_mask                                (0x0000FF00)
+#define REGD64_reg_dig_reserved_3_mask                                (0x000000FF)
+#define REGD64_reg_dig_reserved_0(data)                               (0xFF000000&((data)<<24))
+#define REGD64_reg_dig_reserved_1(data)                               (0x00FF0000&((data)<<16))
+#define REGD64_reg_dig_reserved_2(data)                               (0x0000FF00&((data)<<8))
+#define REGD64_reg_dig_reserved_3(data)                               (0x000000FF&(data))
+#define REGD64_get_reg_dig_reserved_0(data)                           ((0xFF000000&(data))>>24)
+#define REGD64_get_reg_dig_reserved_1(data)                           ((0x00FF0000&(data))>>16)
+#define REGD64_get_reg_dig_reserved_2(data)                           ((0x0000FF00&(data))>>8)
+#define REGD64_get_reg_dig_reserved_3(data)                           (0x000000FF&(data))
+
+
+#define REGD65                                                        0xc90
+#define REGD65_reg_addr                                               "0x98034c90"
+#define REGD65_reg                                                    0x98034c90
+#define REGD65_inst_addr                                              "0x0324"
+#define REGD65_inst                                                   0x0324
+#define REGD65_reg_dig_debug_sel_shift                                (27)
+#define REGD65_reg_dig_debug_sel_mask                                 (0xF8000000)
+#define REGD65_reg_dig_debug_sel(data)                                (0xF8000000&((data)<<27))
+#define REGD65_get_reg_dig_debug_sel(data)                            ((0xF8000000&(data))>>27)
+
+
+#define REGD66                                                        0xc94
+#define REGD66_reg_addr                                               "0x98034c94"
+#define REGD66_reg                                                    0x98034c94
+#define REGD66_inst_addr                                              "0x0325"
+#define REGD66_inst                                                   0x0325
+#define REGD66_reg_p0_st_m_value_shift                                (0)
+#define REGD66_reg_p0_st_m_value_mask                                 (0xFFFFFFFF)
+#define REGD66_reg_p0_st_m_value(data)                                (0xFFFFFFFF&(data))
+#define REGD66_get_reg_p0_st_m_value(data)                            (0xFFFFFFFF&(data))
+
+
+#define REGD67                                                        0xc98
+#define REGD67_reg_addr                                               "0x98034c98"
+#define REGD67_reg                                                    0x98034c98
+#define REGD67_inst_addr                                              "0x0326"
+#define REGD67_inst                                                   0x0326
+#define REGD67_reg_p1_st_m_value_shift                                (0)
+#define REGD67_reg_p1_st_m_value_mask                                 (0xFFFFFFFF)
+#define REGD67_reg_p1_st_m_value(data)                                (0xFFFFFFFF&(data))
+#define REGD67_get_reg_p1_st_m_value(data)                            (0xFFFFFFFF&(data))
+
+
+#define REGD68                                                        0xc9c
+#define REGD68_reg_addr                                               "0x98034c9c"
+#define REGD68_reg                                                    0x98034c9c
+#define REGD68_inst_addr                                              "0x0327"
+#define REGD68_inst                                                   0x0327
+#define REGD68_reg_p2_st_m_value_shift                                (0)
+#define REGD68_reg_p2_st_m_value_mask                                 (0xFFFFFFFF)
+#define REGD68_reg_p2_st_m_value(data)                                (0xFFFFFFFF&(data))
+#define REGD68_get_reg_p2_st_m_value(data)                            (0xFFFFFFFF&(data))
+
+
+#define REGD69                                                        0xca0
+#define REGD69_reg_addr                                               "0x98034ca0"
+#define REGD69_reg                                                    0x98034ca0
+#define REGD69_inst_addr                                              "0x0328"
+#define REGD69_inst                                                   0x0328
+#define REGD69_reg_p3_st_m_value_shift                                (0)
+#define REGD69_reg_p3_st_m_value_mask                                 (0xFFFFFFFF)
+#define REGD69_reg_p3_st_m_value(data)                                (0xFFFFFFFF&(data))
+#define REGD69_get_reg_p3_st_m_value(data)                            (0xFFFFFFFF&(data))
+
+
+#define REGD70                                                        0xca4
+#define REGD70_reg_addr                                               "0x98034ca4"
+#define REGD70_reg                                                    0x98034ca4
+#define REGD70_inst_addr                                              "0x0329"
+#define REGD70_inst                                                   0x0329
+#define REGD70_reg_eye_monitor_ck_sel_shift                           (20)
+#define REGD70_eye_monitor_dout_shift                                 (0)
+#define REGD70_reg_eye_monitor_ck_sel_mask                            (0x00300000)
+#define REGD70_eye_monitor_dout_mask                                  (0x0000FFFF)
+#define REGD70_reg_eye_monitor_ck_sel(data)                           (0x00300000&((data)<<20))
+#define REGD70_eye_monitor_dout(data)                                 (0x0000FFFF&(data))
+#define REGD70_get_reg_eye_monitor_ck_sel(data)                       ((0x00300000&(data))>>20)
+#define REGD70_get_eye_monitor_dout(data)                             (0x0000FFFF&(data))
+
+
+#define REGD71                                                        0xca8
+#define REGD71_reg_addr                                               "0x98034ca8"
+#define REGD71_reg                                                    0x98034ca8
+#define REGD71_inst_addr                                              "0x032A"
+#define REGD71_inst                                                   0x032A
+#define REGD71_reg_p0_st_m_value_g_shift                              (0)
+#define REGD71_reg_p0_st_m_value_g_mask                               (0xFFFFFFFF)
+#define REGD71_reg_p0_st_m_value_g(data)                              (0xFFFFFFFF&(data))
+#define REGD71_get_reg_p0_st_m_value_g(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD72                                                        0xcac
+#define REGD72_reg_addr                                               "0x98034cac"
+#define REGD72_reg                                                    0x98034cac
+#define REGD72_inst_addr                                              "0x032B"
+#define REGD72_inst                                                   0x032B
+#define REGD72_reg_p1_st_m_value_g_shift                              (0)
+#define REGD72_reg_p1_st_m_value_g_mask                               (0xFFFFFFFF)
+#define REGD72_reg_p1_st_m_value_g(data)                              (0xFFFFFFFF&(data))
+#define REGD72_get_reg_p1_st_m_value_g(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD73                                                        0xcb0
+#define REGD73_reg_addr                                               "0x98034cb0"
+#define REGD73_reg                                                    0x98034cb0
+#define REGD73_inst_addr                                              "0x032C"
+#define REGD73_inst                                                   0x032C
+#define REGD73_reg_p2_st_m_value_g_shift                              (0)
+#define REGD73_reg_p2_st_m_value_g_mask                               (0xFFFFFFFF)
+#define REGD73_reg_p2_st_m_value_g(data)                              (0xFFFFFFFF&(data))
+#define REGD73_get_reg_p2_st_m_value_g(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD74                                                        0xcb4
+#define REGD74_reg_addr                                               "0x98034cb4"
+#define REGD74_reg                                                    0x98034cb4
+#define REGD74_inst_addr                                              "0x032D"
+#define REGD74_inst                                                   0x032D
+#define REGD74_reg_p3_st_m_value_g_shift                              (0)
+#define REGD74_reg_p3_st_m_value_g_mask                               (0xFFFFFFFF)
+#define REGD74_reg_p3_st_m_value_g(data)                              (0xFFFFFFFF&(data))
+#define REGD74_get_reg_p3_st_m_value_g(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD75                                                        0xcb8
+#define REGD75_reg_addr                                               "0x98034cb8"
+#define REGD75_reg                                                    0x98034cb8
+#define REGD75_inst_addr                                              "0x032E"
+#define REGD75_inst                                                   0x032E
+#define REGD75_reg_p0_st_m_value_b_shift                              (0)
+#define REGD75_reg_p0_st_m_value_b_mask                               (0xFFFFFFFF)
+#define REGD75_reg_p0_st_m_value_b(data)                              (0xFFFFFFFF&(data))
+#define REGD75_get_reg_p0_st_m_value_b(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD76                                                        0xcbc
+#define REGD76_reg_addr                                               "0x98034cbc"
+#define REGD76_reg                                                    0x98034cbc
+#define REGD76_inst_addr                                              "0x032F"
+#define REGD76_inst                                                   0x032F
+#define REGD76_reg_p1_st_m_value_b_shift                              (0)
+#define REGD76_reg_p1_st_m_value_b_mask                               (0xFFFFFFFF)
+#define REGD76_reg_p1_st_m_value_b(data)                              (0xFFFFFFFF&(data))
+#define REGD76_get_reg_p1_st_m_value_b(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD77                                                        0xcc0
+#define REGD77_reg_addr                                               "0x98034cc0"
+#define REGD77_reg                                                    0x98034cc0
+#define REGD77_inst_addr                                              "0x0330"
+#define REGD77_inst                                                   0x0330
+#define REGD77_reg_p2_st_m_value_b_shift                              (0)
+#define REGD77_reg_p2_st_m_value_b_mask                               (0xFFFFFFFF)
+#define REGD77_reg_p2_st_m_value_b(data)                              (0xFFFFFFFF&(data))
+#define REGD77_get_reg_p2_st_m_value_b(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD78                                                        0xcc4
+#define REGD78_reg_addr                                               "0x98034cc4"
+#define REGD78_reg                                                    0x98034cc4
+#define REGD78_inst_addr                                              "0x0331"
+#define REGD78_inst                                                   0x0331
+#define REGD78_reg_p3_st_m_value_b_shift                              (0)
+#define REGD78_reg_p3_st_m_value_b_mask                               (0xFFFFFFFF)
+#define REGD78_reg_p3_st_m_value_b(data)                              (0xFFFFFFFF&(data))
+#define REGD78_get_reg_p3_st_m_value_b(data)                          (0xFFFFFFFF&(data))
+
+
+#define REGD79                                                        0xcc8
+#define REGD79_reg_addr                                               "0x98034cc8"
+#define REGD79_reg                                                    0x98034cc8
+#define REGD79_inst_addr                                              "0x0332"
+#define REGD79_inst                                                   0x0332
+#define REGD79_reg_p0_enable_one_zero_r_shift                         (18)
+#define REGD79_reg_p0_prbs_invs_r_shift                               (17)
+#define REGD79_reg_p0_pattern_sel_r_shift                             (16)
+#define REGD79_p0_pkt_count_r_shift                                   (8)
+#define REGD79_p0_err_count_r_shift                                   (0)
+#define REGD79_reg_p0_enable_one_zero_r_mask                          (0x00040000)
+#define REGD79_reg_p0_prbs_invs_r_mask                                (0x00020000)
+#define REGD79_reg_p0_pattern_sel_r_mask                              (0x00010000)
+#define REGD79_p0_pkt_count_r_mask                                    (0x0000FF00)
+#define REGD79_p0_err_count_r_mask                                    (0x000000FF)
+#define REGD79_reg_p0_enable_one_zero_r(data)                         (0x00040000&((data)<<18))
+#define REGD79_reg_p0_prbs_invs_r(data)                               (0x00020000&((data)<<17))
+#define REGD79_reg_p0_pattern_sel_r(data)                             (0x00010000&((data)<<16))
+#define REGD79_p0_pkt_count_r(data)                                   (0x0000FF00&((data)<<8))
+#define REGD79_p0_err_count_r(data)                                   (0x000000FF&(data))
+#define REGD79_get_reg_p0_enable_one_zero_r(data)                     ((0x00040000&(data))>>18)
+#define REGD79_get_reg_p0_prbs_invs_r(data)                           ((0x00020000&(data))>>17)
+#define REGD79_get_reg_p0_pattern_sel_r(data)                         ((0x00010000&(data))>>16)
+#define REGD79_get_p0_pkt_count_r(data)                               ((0x0000FF00&(data))>>8)
+#define REGD79_get_p0_err_count_r(data)                               (0x000000FF&(data))
+
+
+#define REGD80                                                        0xccc
+#define REGD80_reg_addr                                               "0x98034ccc"
+#define REGD80_reg                                                    0x98034ccc
+#define REGD80_inst_addr                                              "0x0333"
+#define REGD80_inst                                                   0x0333
+#define REGD80_reg_p0_enable_one_zero_g_shift                         (18)
+#define REGD80_reg_p0_prbs_invs_g_shift                               (17)
+#define REGD80_reg_p0_pattern_sel_g_shift                             (16)
+#define REGD80_p0_pkt_count_g_shift                                   (8)
+#define REGD80_p0_err_count_g_shift                                   (0)
+#define REGD80_reg_p0_enable_one_zero_g_mask                          (0x00040000)
+#define REGD80_reg_p0_prbs_invs_g_mask                                (0x00020000)
+#define REGD80_reg_p0_pattern_sel_g_mask                              (0x00010000)
+#define REGD80_p0_pkt_count_g_mask                                    (0x0000FF00)
+#define REGD80_p0_err_count_g_mask                                    (0x000000FF)
+#define REGD80_reg_p0_enable_one_zero_g(data)                         (0x00040000&((data)<<18))
+#define REGD80_reg_p0_prbs_invs_g(data)                               (0x00020000&((data)<<17))
+#define REGD80_reg_p0_pattern_sel_g(data)                             (0x00010000&((data)<<16))
+#define REGD80_p0_pkt_count_g(data)                                   (0x0000FF00&((data)<<8))
+#define REGD80_p0_err_count_g(data)                                   (0x000000FF&(data))
+#define REGD80_get_reg_p0_enable_one_zero_g(data)                     ((0x00040000&(data))>>18)
+#define REGD80_get_reg_p0_prbs_invs_g(data)                           ((0x00020000&(data))>>17)
+#define REGD80_get_reg_p0_pattern_sel_g(data)                         ((0x00010000&(data))>>16)
+#define REGD80_get_p0_pkt_count_g(data)                               ((0x0000FF00&(data))>>8)
+#define REGD80_get_p0_err_count_g(data)                               (0x000000FF&(data))
+
+
+#define REGD81                                                        0xcd0
+#define REGD81_reg_addr                                               "0x98034cd0"
+#define REGD81_reg                                                    0x98034cd0
+#define REGD81_inst_addr                                              "0x0334"
+#define REGD81_inst                                                   0x0334
+#define REGD81_reg_p0_enable_one_zero_b_shift                         (18)
+#define REGD81_reg_p0_prbs_invs_b_shift                               (17)
+#define REGD81_reg_p0_pattern_sel_b_shift                             (16)
+#define REGD81_p0_pkt_count_b_shift                                   (8)
+#define REGD81_p0_err_count_b_shift                                   (0)
+#define REGD81_reg_p0_enable_one_zero_b_mask                          (0x00040000)
+#define REGD81_reg_p0_prbs_invs_b_mask                                (0x00020000)
+#define REGD81_reg_p0_pattern_sel_b_mask                              (0x00010000)
+#define REGD81_p0_pkt_count_b_mask                                    (0x0000FF00)
+#define REGD81_p0_err_count_b_mask                                    (0x000000FF)
+#define REGD81_reg_p0_enable_one_zero_b(data)                         (0x00040000&((data)<<18))
+#define REGD81_reg_p0_prbs_invs_b(data)                               (0x00020000&((data)<<17))
+#define REGD81_reg_p0_pattern_sel_b(data)                             (0x00010000&((data)<<16))
+#define REGD81_p0_pkt_count_b(data)                                   (0x0000FF00&((data)<<8))
+#define REGD81_p0_err_count_b(data)                                   (0x000000FF&(data))
+#define REGD81_get_reg_p0_enable_one_zero_b(data)                     ((0x00040000&(data))>>18)
+#define REGD81_get_reg_p0_prbs_invs_b(data)                           ((0x00020000&(data))>>17)
+#define REGD81_get_reg_p0_pattern_sel_b(data)                         ((0x00010000&(data))>>16)
+#define REGD81_get_p0_pkt_count_b(data)                               ((0x0000FF00&(data))>>8)
+#define REGD81_get_p0_err_count_b(data)                               (0x000000FF&(data))
+
+
+#define REGD82                                                        0xcd4
+#define REGD82_reg_addr                                               "0x98034cd4"
+#define REGD82_reg                                                    0x98034cd4
+#define REGD82_inst_addr                                              "0x0335"
+#define REGD82_inst                                                   0x0335
+#define REGD82_reg_p1_enable_one_zero_r_shift                         (18)
+#define REGD82_reg_p1_prbs_invs_r_shift                               (17)
+#define REGD82_reg_p1_pattern_sel_r_shift                             (16)
+#define REGD82_p1_pkt_count_r_shift                                   (8)
+#define REGD82_p1_err_count_r_shift                                   (0)
+#define REGD82_reg_p1_enable_one_zero_r_mask                          (0x00040000)
+#define REGD82_reg_p1_prbs_invs_r_mask                                (0x00020000)
+#define REGD82_reg_p1_pattern_sel_r_mask                              (0x00010000)
+#define REGD82_p1_pkt_count_r_mask                                    (0x0000FF00)
+#define REGD82_p1_err_count_r_mask                                    (0x000000FF)
+#define REGD82_reg_p1_enable_one_zero_r(data)                         (0x00040000&((data)<<18))
+#define REGD82_reg_p1_prbs_invs_r(data)                               (0x00020000&((data)<<17))
+#define REGD82_reg_p1_pattern_sel_r(data)                             (0x00010000&((data)<<16))
+#define REGD82_p1_pkt_count_r(data)                                   (0x0000FF00&((data)<<8))
+#define REGD82_p1_err_count_r(data)                                   (0x000000FF&(data))
+#define REGD82_get_reg_p1_enable_one_zero_r(data)                     ((0x00040000&(data))>>18)
+#define REGD82_get_reg_p1_prbs_invs_r(data)                           ((0x00020000&(data))>>17)
+#define REGD82_get_reg_p1_pattern_sel_r(data)                         ((0x00010000&(data))>>16)
+#define REGD82_get_p1_pkt_count_r(data)                               ((0x0000FF00&(data))>>8)
+#define REGD82_get_p1_err_count_r(data)                               (0x000000FF&(data))
+
+
+#define REGD83                                                        0xcd8
+#define REGD83_reg_addr                                               "0x98034cd8"
+#define REGD83_reg                                                    0x98034cd8
+#define REGD83_inst_addr                                              "0x0336"
+#define REGD83_inst                                                   0x0336
+#define REGD83_reg_p1_enable_one_zero_g_shift                         (18)
+#define REGD83_reg_p1_prbs_invs_g_shift                               (17)
+#define REGD83_reg_p1_pattern_sel_g_shift                             (16)
+#define REGD83_p1_pkt_count_g_shift                                   (8)
+#define REGD83_p1_err_count_g_shift                                   (0)
+#define REGD83_reg_p1_enable_one_zero_g_mask                          (0x00040000)
+#define REGD83_reg_p1_prbs_invs_g_mask                                (0x00020000)
+#define REGD83_reg_p1_pattern_sel_g_mask                              (0x00010000)
+#define REGD83_p1_pkt_count_g_mask                                    (0x0000FF00)
+#define REGD83_p1_err_count_g_mask                                    (0x000000FF)
+#define REGD83_reg_p1_enable_one_zero_g(data)                         (0x00040000&((data)<<18))
+#define REGD83_reg_p1_prbs_invs_g(data)                               (0x00020000&((data)<<17))
+#define REGD83_reg_p1_pattern_sel_g(data)                             (0x00010000&((data)<<16))
+#define REGD83_p1_pkt_count_g(data)                                   (0x0000FF00&((data)<<8))
+#define REGD83_p1_err_count_g(data)                                   (0x000000FF&(data))
+#define REGD83_get_reg_p1_enable_one_zero_g(data)                     ((0x00040000&(data))>>18)
+#define REGD83_get_reg_p1_prbs_invs_g(data)                           ((0x00020000&(data))>>17)
+#define REGD83_get_reg_p1_pattern_sel_g(data)                         ((0x00010000&(data))>>16)
+#define REGD83_get_p1_pkt_count_g(data)                               ((0x0000FF00&(data))>>8)
+#define REGD83_get_p1_err_count_g(data)                               (0x000000FF&(data))
+
+
+#define REGD84                                                        0xcdc
+#define REGD84_reg_addr                                               "0x98034cdc"
+#define REGD84_reg                                                    0x98034cdc
+#define REGD84_inst_addr                                              "0x0337"
+#define REGD84_inst                                                   0x0337
+#define REGD84_reg_p1_enable_one_zero_b_shift                         (18)
+#define REGD84_reg_p1_prbs_invs_b_shift                               (17)
+#define REGD84_reg_p1_pattern_sel_b_shift                             (16)
+#define REGD84_p1_pkt_count_b_shift                                   (8)
+#define REGD84_p1_err_count_b_shift                                   (0)
+#define REGD84_reg_p1_enable_one_zero_b_mask                          (0x00040000)
+#define REGD84_reg_p1_prbs_invs_b_mask                                (0x00020000)
+#define REGD84_reg_p1_pattern_sel_b_mask                              (0x00010000)
+#define REGD84_p1_pkt_count_b_mask                                    (0x0000FF00)
+#define REGD84_p1_err_count_b_mask                                    (0x000000FF)
+#define REGD84_reg_p1_enable_one_zero_b(data)                         (0x00040000&((data)<<18))
+#define REGD84_reg_p1_prbs_invs_b(data)                               (0x00020000&((data)<<17))
+#define REGD84_reg_p1_pattern_sel_b(data)                             (0x00010000&((data)<<16))
+#define REGD84_p1_pkt_count_b(data)                                   (0x0000FF00&((data)<<8))
+#define REGD84_p1_err_count_b(data)                                   (0x000000FF&(data))
+#define REGD84_get_reg_p1_enable_one_zero_b(data)                     ((0x00040000&(data))>>18)
+#define REGD84_get_reg_p1_prbs_invs_b(data)                           ((0x00020000&(data))>>17)
+#define REGD84_get_reg_p1_pattern_sel_b(data)                         ((0x00010000&(data))>>16)
+#define REGD84_get_p1_pkt_count_b(data)                               ((0x0000FF00&(data))>>8)
+#define REGD84_get_p1_err_count_b(data)                               (0x000000FF&(data))
+
+
+#define REGD85                                                        0xce0
+#define REGD85_reg_addr                                               "0x98034ce0"
+#define REGD85_reg                                                    0x98034ce0
+#define REGD85_inst_addr                                              "0x0338"
+#define REGD85_inst                                                   0x0338
+#define REGD85_reg_p2_enable_one_zero_r_shift                         (18)
+#define REGD85_reg_p2_prbs_invs_r_shift                               (17)
+#define REGD85_reg_p2_pattern_sel_r_shift                             (16)
+#define REGD85_p2_pkt_count_r_shift                                   (8)
+#define REGD85_p2_err_count_r_shift                                   (0)
+#define REGD85_reg_p2_enable_one_zero_r_mask                          (0x00040000)
+#define REGD85_reg_p2_prbs_invs_r_mask                                (0x00020000)
+#define REGD85_reg_p2_pattern_sel_r_mask                              (0x00010000)
+#define REGD85_p2_pkt_count_r_mask                                    (0x0000FF00)
+#define REGD85_p2_err_count_r_mask                                    (0x000000FF)
+#define REGD85_reg_p2_enable_one_zero_r(data)                         (0x00040000&((data)<<18))
+#define REGD85_reg_p2_prbs_invs_r(data)                               (0x00020000&((data)<<17))
+#define REGD85_reg_p2_pattern_sel_r(data)                             (0x00010000&((data)<<16))
+#define REGD85_p2_pkt_count_r(data)                                   (0x0000FF00&((data)<<8))
+#define REGD85_p2_err_count_r(data)                                   (0x000000FF&(data))
+#define REGD85_get_reg_p2_enable_one_zero_r(data)                     ((0x00040000&(data))>>18)
+#define REGD85_get_reg_p2_prbs_invs_r(data)                           ((0x00020000&(data))>>17)
+#define REGD85_get_reg_p2_pattern_sel_r(data)                         ((0x00010000&(data))>>16)
+#define REGD85_get_p2_pkt_count_r(data)                               ((0x0000FF00&(data))>>8)
+#define REGD85_get_p2_err_count_r(data)                               (0x000000FF&(data))
+
+
+#define REGD86                                                        0xce4
+#define REGD86_reg_addr                                               "0x98034ce4"
+#define REGD86_reg                                                    0x98034ce4
+#define REGD86_inst_addr                                              "0x0339"
+#define REGD86_inst                                                   0x0339
+#define REGD86_reg_p2_enable_one_zero_g_shift                         (18)
+#define REGD86_reg_p2_prbs_invs_g_shift                               (17)
+#define REGD86_reg_p2_pattern_sel_g_shift                             (16)
+#define REGD86_p2_pkt_count_g_shift                                   (8)
+#define REGD86_p2_err_count_g_shift                                   (0)
+#define REGD86_reg_p2_enable_one_zero_g_mask                          (0x00040000)
+#define REGD86_reg_p2_prbs_invs_g_mask                                (0x00020000)
+#define REGD86_reg_p2_pattern_sel_g_mask                              (0x00010000)
+#define REGD86_p2_pkt_count_g_mask                                    (0x0000FF00)
+#define REGD86_p2_err_count_g_mask                                    (0x000000FF)
+#define REGD86_reg_p2_enable_one_zero_g(data)                         (0x00040000&((data)<<18))
+#define REGD86_reg_p2_prbs_invs_g(data)                               (0x00020000&((data)<<17))
+#define REGD86_reg_p2_pattern_sel_g(data)                             (0x00010000&((data)<<16))
+#define REGD86_p2_pkt_count_g(data)                                   (0x0000FF00&((data)<<8))
+#define REGD86_p2_err_count_g(data)                                   (0x000000FF&(data))
+#define REGD86_get_reg_p2_enable_one_zero_g(data)                     ((0x00040000&(data))>>18)
+#define REGD86_get_reg_p2_prbs_invs_g(data)                           ((0x00020000&(data))>>17)
+#define REGD86_get_reg_p2_pattern_sel_g(data)                         ((0x00010000&(data))>>16)
+#define REGD86_get_p2_pkt_count_g(data)                               ((0x0000FF00&(data))>>8)
+#define REGD86_get_p2_err_count_g(data)                               (0x000000FF&(data))
+
+
+#define REGD87                                                        0xce8
+#define REGD87_reg_addr                                               "0x98034ce8"
+#define REGD87_reg                                                    0x98034ce8
+#define REGD87_inst_addr                                              "0x033A"
+#define REGD87_inst                                                   0x033A
+#define REGD87_reg_p2_enable_one_zero_b_shift                         (18)
+#define REGD87_reg_p2_prbs_invs_b_shift                               (17)
+#define REGD87_reg_p2_pattern_sel_b_shift                             (16)
+#define REGD87_p2_pkt_count_b_shift                                   (8)
+#define REGD87_p2_err_count_b_shift                                   (0)
+#define REGD87_reg_p2_enable_one_zero_b_mask                          (0x00040000)
+#define REGD87_reg_p2_prbs_invs_b_mask                                (0x00020000)
+#define REGD87_reg_p2_pattern_sel_b_mask                              (0x00010000)
+#define REGD87_p2_pkt_count_b_mask                                    (0x0000FF00)
+#define REGD87_p2_err_count_b_mask                                    (0x000000FF)
+#define REGD87_reg_p2_enable_one_zero_b(data)                         (0x00040000&((data)<<18))
+#define REGD87_reg_p2_prbs_invs_b(data)                               (0x00020000&((data)<<17))
+#define REGD87_reg_p2_pattern_sel_b(data)                             (0x00010000&((data)<<16))
+#define REGD87_p2_pkt_count_b(data)                                   (0x0000FF00&((data)<<8))
+#define REGD87_p2_err_count_b(data)                                   (0x000000FF&(data))
+#define REGD87_get_reg_p2_enable_one_zero_b(data)                     ((0x00040000&(data))>>18)
+#define REGD87_get_reg_p2_prbs_invs_b(data)                           ((0x00020000&(data))>>17)
+#define REGD87_get_reg_p2_pattern_sel_b(data)                         ((0x00010000&(data))>>16)
+#define REGD87_get_p2_pkt_count_b(data)                               ((0x0000FF00&(data))>>8)
+#define REGD87_get_p2_err_count_b(data)                               (0x000000FF&(data))
+
+
+#define REGD88                                                        0xcec
+#define REGD88_reg_addr                                               "0x98034cec"
+#define REGD88_reg                                                    0x98034cec
+#define REGD88_inst_addr                                              "0x033B"
+#define REGD88_inst                                                   0x033B
+#define REGD88_reg_p3_enable_one_zero_r_shift                         (18)
+#define REGD88_reg_p3_prbs_invs_r_shift                               (17)
+#define REGD88_reg_p3_pattern_sel_r_shift                             (16)
+#define REGD88_p3_pkt_count_r_shift                                   (8)
+#define REGD88_p3_err_count_r_shift                                   (0)
+#define REGD88_reg_p3_enable_one_zero_r_mask                          (0x00040000)
+#define REGD88_reg_p3_prbs_invs_r_mask                                (0x00020000)
+#define REGD88_reg_p3_pattern_sel_r_mask                              (0x00010000)
+#define REGD88_p3_pkt_count_r_mask                                    (0x0000FF00)
+#define REGD88_p3_err_count_r_mask                                    (0x000000FF)
+#define REGD88_reg_p3_enable_one_zero_r(data)                         (0x00040000&((data)<<18))
+#define REGD88_reg_p3_prbs_invs_r(data)                               (0x00020000&((data)<<17))
+#define REGD88_reg_p3_pattern_sel_r(data)                             (0x00010000&((data)<<16))
+#define REGD88_p3_pkt_count_r(data)                                   (0x0000FF00&((data)<<8))
+#define REGD88_p3_err_count_r(data)                                   (0x000000FF&(data))
+#define REGD88_get_reg_p3_enable_one_zero_r(data)                     ((0x00040000&(data))>>18)
+#define REGD88_get_reg_p3_prbs_invs_r(data)                           ((0x00020000&(data))>>17)
+#define REGD88_get_reg_p3_pattern_sel_r(data)                         ((0x00010000&(data))>>16)
+#define REGD88_get_p3_pkt_count_r(data)                               ((0x0000FF00&(data))>>8)
+#define REGD88_get_p3_err_count_r(data)                               (0x000000FF&(data))
+
+
+#define REGD89                                                        0xcf0
+#define REGD89_reg_addr                                               "0x98034cf0"
+#define REGD89_reg                                                    0x98034cf0
+#define REGD89_inst_addr                                              "0x033C"
+#define REGD89_inst                                                   0x033C
+#define REGD89_reg_p3_enable_one_zero_g_shift                         (18)
+#define REGD89_reg_p3_prbs_invs_g_shift                               (17)
+#define REGD89_reg_p3_pattern_sel_g_shift                             (16)
+#define REGD89_p3_pkt_count_g_shift                                   (8)
+#define REGD89_p3_err_count_g_shift                                   (0)
+#define REGD89_reg_p3_enable_one_zero_g_mask                          (0x00040000)
+#define REGD89_reg_p3_prbs_invs_g_mask                                (0x00020000)
+#define REGD89_reg_p3_pattern_sel_g_mask                              (0x00010000)
+#define REGD89_p3_pkt_count_g_mask                                    (0x0000FF00)
+#define REGD89_p3_err_count_g_mask                                    (0x000000FF)
+#define REGD89_reg_p3_enable_one_zero_g(data)                         (0x00040000&((data)<<18))
+#define REGD89_reg_p3_prbs_invs_g(data)                               (0x00020000&((data)<<17))
+#define REGD89_reg_p3_pattern_sel_g(data)                             (0x00010000&((data)<<16))
+#define REGD89_p3_pkt_count_g(data)                                   (0x0000FF00&((data)<<8))
+#define REGD89_p3_err_count_g(data)                                   (0x000000FF&(data))
+#define REGD89_get_reg_p3_enable_one_zero_g(data)                     ((0x00040000&(data))>>18)
+#define REGD89_get_reg_p3_prbs_invs_g(data)                           ((0x00020000&(data))>>17)
+#define REGD89_get_reg_p3_pattern_sel_g(data)                         ((0x00010000&(data))>>16)
+#define REGD89_get_p3_pkt_count_g(data)                               ((0x0000FF00&(data))>>8)
+#define REGD89_get_p3_err_count_g(data)                               (0x000000FF&(data))
+
+
+#define REGD90                                                        0xcf4
+#define REGD90_reg_addr                                               "0x98034cf4"
+#define REGD90_reg                                                    0x98034cf4
+#define REGD90_inst_addr                                              "0x033D"
+#define REGD90_inst                                                   0x033D
+#define REGD90_reg_p3_enable_one_zero_b_shift                         (18)
+#define REGD90_reg_p3_prbs_invs_b_shift                               (17)
+#define REGD90_reg_p3_pattern_sel_b_shift                             (16)
+#define REGD90_p3_pkt_count_b_shift                                   (8)
+#define REGD90_p3_err_count_b_shift                                   (0)
+#define REGD90_reg_p3_enable_one_zero_b_mask                          (0x00040000)
+#define REGD90_reg_p3_prbs_invs_b_mask                                (0x00020000)
+#define REGD90_reg_p3_pattern_sel_b_mask                              (0x00010000)
+#define REGD90_p3_pkt_count_b_mask                                    (0x0000FF00)
+#define REGD90_p3_err_count_b_mask                                    (0x000000FF)
+#define REGD90_reg_p3_enable_one_zero_b(data)                         (0x00040000&((data)<<18))
+#define REGD90_reg_p3_prbs_invs_b(data)                               (0x00020000&((data)<<17))
+#define REGD90_reg_p3_pattern_sel_b(data)                             (0x00010000&((data)<<16))
+#define REGD90_p3_pkt_count_b(data)                                   (0x0000FF00&((data)<<8))
+#define REGD90_p3_err_count_b(data)                                   (0x000000FF&(data))
+#define REGD90_get_reg_p3_enable_one_zero_b(data)                     ((0x00040000&(data))>>18)
+#define REGD90_get_reg_p3_prbs_invs_b(data)                           ((0x00020000&(data))>>17)
+#define REGD90_get_reg_p3_pattern_sel_b(data)                         ((0x00010000&(data))>>16)
+#define REGD90_get_p3_pkt_count_b(data)                               ((0x0000FF00&(data))>>8)
+#define REGD90_get_p3_err_count_b(data)                               (0x000000FF&(data))
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/DFE_fw.h b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/DFE_fw.h
new file mode 100644
index 00000000..44cb302
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/DFE_fw.h
@@ -0,0 +1,707 @@
+/*
+ * DFE_fw.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _DFE_REG_H_INCLUDED_
+#define _DFE_REG_H_INCLUDED_
+
+#define REG_DFE_EN_L0                                              0xe00
+#define REG_DFE_EN_L0_reg_addr                                     "0x98034e00"
+#define REG_DFE_EN_L0_reg                                          0x98034e00
+#define REG_DFE_EN_L0_inst_addr                                    "0x0380"
+#define REG_DFE_EN_L0_inst                                         0x0380
+#define REG_DFE_EN_L0_clk_inv_lane0_shift                       (31)
+#define REG_DFE_EN_L0_timer_ctrl_en_lane0_shift                 (30)
+#define REG_DFE_EN_L0_reduce_adapt_gain_lane0_shift             (28)
+#define REG_DFE_EN_L0_rl_det_en_lane0_shift                     (27)
+#define REG_DFE_EN_L0_rl_det_mode_lane0_shift                   (26)
+#define REG_DFE_EN_L0_rl_threshold_lane0_shift                  (24)
+#define REG_DFE_EN_L0_dfe_adapt_en_lane0_shift                  (16)
+#define REG_DFE_EN_L0_le_min_lane0_shift                        (11)
+#define REG_DFE_EN_L0_le_init_lane0_shift                       (6)
+#define REG_DFE_EN_L0_tap4_init_lane0_shift                     (0)
+#define REG_DFE_EN_L0_clk_inv_lane0_mask                        (0x80000000)
+#define REG_DFE_EN_L0_timer_ctrl_en_lane0_mask                  (0x40000000)
+#define REG_DFE_EN_L0_reduce_adapt_gain_lane0_mask              (0x30000000)
+#define REG_DFE_EN_L0_rl_det_en_lane0_mask                      (0x08000000)
+#define REG_DFE_EN_L0_rl_det_mode_lane0_mask                    (0x04000000)
+#define REG_DFE_EN_L0_rl_threshold_lane0_mask                   (0x03000000)
+#define REG_DFE_EN_L0_dfe_adapt_en_lane0_mask                   (0x00FF0000)
+#define REG_DFE_EN_L0_le_min_lane0_mask                         (0x0000F800)
+#define REG_DFE_EN_L0_le_init_lane0_mask                        (0x000007C0)
+#define REG_DFE_EN_L0_tap4_init_lane0_mask                      (0x0000003F)
+#define REG_DFE_EN_L0_clk_inv_lane0(data)                       (0x80000000&((data)<<31))
+#define REG_DFE_EN_L0_timer_ctrl_en_lane0(data)                 (0x40000000&((data)<<30))
+#define REG_DFE_EN_L0_reduce_adapt_gain_lane0(data)             (0x30000000&((data)<<28))
+#define REG_DFE_EN_L0_rl_det_en_lane0(data)                     (0x08000000&((data)<<27))
+#define REG_DFE_EN_L0_rl_det_mode_lane0(data)                   (0x04000000&((data)<<26))
+#define REG_DFE_EN_L0_rl_threshold_lane0(data)                  (0x03000000&((data)<<24))
+#define REG_DFE_EN_L0_dfe_adapt_en_lane0(data)                  (0x00FF0000&((data)<<16))
+#define REG_DFE_EN_L0_le_min_lane0(data)                        (0x0000F800&((data)<<11))
+#define REG_DFE_EN_L0_le_init_lane0(data)                       (0x000007C0&((data)<<6))
+#define REG_DFE_EN_L0_tap4_init_lane0(data)                     (0x0000003F&(data))
+#define REG_DFE_EN_L0_get_clk_inv_lane0(data)                   ((0x80000000&(data))>>31)
+#define REG_DFE_EN_L0_get_timer_ctrl_en_lane0(data)             ((0x40000000&(data))>>30)
+#define REG_DFE_EN_L0_get_reduce_adapt_gain_lane0(data)         ((0x30000000&(data))>>28)
+#define REG_DFE_EN_L0_get_rl_det_en_lane0(data)                 ((0x08000000&(data))>>27)
+#define REG_DFE_EN_L0_get_rl_det_mode_lane0(data)               ((0x04000000&(data))>>26)
+#define REG_DFE_EN_L0_get_rl_threshold_lane0(data)              ((0x03000000&(data))>>24)
+#define REG_DFE_EN_L0_get_dfe_adapt_en_lane0(data)              ((0x00FF0000&(data))>>16)
+#define REG_DFE_EN_L0_get_le_min_lane0(data)                    ((0x0000F800&(data))>>11)
+#define REG_DFE_EN_L0_get_le_init_lane0(data)                   ((0x000007C0&(data))>>6)
+#define REG_DFE_EN_L0_get_tap4_init_lane0(data)                 (0x0000003F&(data))
+#define REG_dfe_adapt_en_lane0_TAP0									_BIT16
+#define REG_dfe_adapt_en_lane0_TAP1 								_BIT17
+#define REG_dfe_adapt_en_lane0_TAP2 								_BIT18
+#define REG_dfe_adapt_en_lane0_TAP3 								_BIT19
+#define REG_dfe_adapt_en_lane0_TAP4 								_BIT20
+#define REG_dfe_adapt_en_lane0_SERVO								_BIT21
+#define REG_dfe_adapt_en_lane0_Vth									_BIT22
+#define REG_dfe_adapt_en_lane0_LE									_BIT23
+
+
+#define REG_DFE_INIT0_L0                                           0xe04
+#define REG_DFE_INIT0_L0_reg_addr                                  "0x98034e04"
+#define REG_DFE_INIT0_L0_reg                                       0x98034e04
+#define REG_DFE_INIT0_L0_inst_addr                                 "0x0381"
+#define REG_DFE_INIT0_L0_inst                                      0x0381
+#define REG_DFE_INIT0_L0_tap3_init_lane0_shift                  (26)
+#define REG_DFE_INIT0_L0_tap2_init_lane0_shift                  (20)
+#define REG_DFE_INIT0_L0_tap1_init_lane0_shift                  (14)
+#define REG_DFE_INIT0_L0_tap0_init_lane0_shift                  (7)
+#define REG_DFE_INIT0_L0_init1_rev0_lane0_shift                 (4)
+#define REG_DFE_INIT0_L0_vth_init_lane0_shift                   (0)
+#define REG_DFE_INIT0_L0_tap3_init_lane0_mask                   (0xFC000000)
+#define REG_DFE_INIT0_L0_tap2_init_lane0_mask                   (0x03F00000)
+#define REG_DFE_INIT0_L0_tap1_init_lane0_mask                   (0x000FC000)
+#define REG_DFE_INIT0_L0_tap0_init_lane0_mask                   (0x00003F80)
+#define REG_DFE_INIT0_L0_init1_rev0_lane0_mask                  (0x00000070)
+#define REG_DFE_INIT0_L0_vth_init_lane0_mask                    (0x0000000F)
+#define REG_DFE_INIT0_L0_tap3_init_lane0(data)                  (0xFC000000&((data)<<26))
+#define REG_DFE_INIT0_L0_tap2_init_lane0(data)                  (0x03F00000&((data)<<20))
+#define REG_DFE_INIT0_L0_tap1_init_lane0(data)                  (0x000FC000&((data)<<14))
+#define REG_DFE_INIT0_L0_tap0_init_lane0(data)                  (0x00003F80&((data)<<7))
+#define REG_DFE_INIT0_L0_init1_rev0_lane0(data)                 (0x00000070&((data)<<4))
+#define REG_DFE_INIT0_L0_vth_init_lane0(data)                   (0x0000000F&(data))
+#define REG_DFE_INIT0_L0_get_tap3_init_lane0(data)              ((0xFC000000&(data))>>26)
+#define REG_DFE_INIT0_L0_get_tap2_init_lane0(data)              ((0x03F00000&(data))>>20)
+#define REG_DFE_INIT0_L0_get_tap1_init_lane0(data)              ((0x000FC000&(data))>>14)
+#define REG_DFE_INIT0_L0_get_tap0_init_lane0(data)              ((0x00003F80&(data))>>7)
+#define REG_DFE_INIT0_L0_get_init1_rev0_lane0(data)             ((0x00000070&(data))>>4)
+#define REG_DFE_INIT0_L0_get_vth_init_lane0(data)               (0x0000000F&(data))
+
+
+#define REG_DFE_INIT1_L0                                           0xe08
+#define REG_DFE_INIT1_L0_reg_addr                                  "0x98034e08"
+#define REG_DFE_INIT1_L0_reg                                       0x98034e08
+#define REG_DFE_INIT1_L0_inst_addr                                 "0x0382"
+#define REG_DFE_INIT1_L0_inst                                      0x0382
+#define REG_DFE_INIT1_L0_load_in_init_lane0_shift               (24)
+#define REG_DFE_INIT1_L0_init1_rev1_lane0_shift                 (18)
+#define REG_DFE_INIT1_L0_de_video_inv_lane0_shift               (17)
+#define REG_DFE_INIT1_L0_de_packet_inv_lane0_shift              (16)
+#define REG_DFE_INIT1_L0_de_video_en_lane0_shift                (15)
+#define REG_DFE_INIT1_L0_de_packet_en_lane0_shift               (14)
+#define REG_DFE_INIT1_L0_servo_init_lane0_shift                 (9)
+#define REG_DFE_INIT1_L0_init1_rev2_lane0_shift                 (0)
+#define REG_DFE_INIT1_L0_load_in_init_lane0_mask                (0xFF000000)
+#define REG_DFE_INIT1_L0_init1_rev1_lane0_mask                  (0x00FC0000)
+#define REG_DFE_INIT1_L0_de_video_inv_lane0_mask                (0x00020000)
+#define REG_DFE_INIT1_L0_de_packet_inv_lane0_mask               (0x00010000)
+#define REG_DFE_INIT1_L0_de_video_en_lane0_mask                 (0x00008000)
+#define REG_DFE_INIT1_L0_de_packet_en_lane0_mask                (0x00004000)
+#define REG_DFE_INIT1_L0_servo_init_lane0_mask                  (0x00003E00)
+#define REG_DFE_INIT1_L0_init1_rev2_lane0_mask                  (0x000001FF)
+#define REG_DFE_INIT1_L0_load_in_init_lane0(data)               (0xFF000000&((data)<<24))
+#define REG_DFE_INIT1_L0_init1_rev1_lane0(data)                 (0x00FC0000&((data)<<18))
+#define REG_DFE_INIT1_L0_de_video_inv_lane0(data)               (0x00020000&((data)<<17))
+#define REG_DFE_INIT1_L0_de_packet_inv_lane0(data)              (0x00010000&((data)<<16))
+#define REG_DFE_INIT1_L0_de_video_en_lane0(data)                (0x00008000&((data)<<15))
+#define REG_DFE_INIT1_L0_de_packet_en_lane0(data)               (0x00004000&((data)<<14))
+#define REG_DFE_INIT1_L0_servo_init_lane0(data)                 (0x00003E00&((data)<<9))
+#define REG_DFE_INIT1_L0_init1_rev2_lane0(data)                 (0x000001FF&(data))
+#define REG_DFE_INIT1_L0_get_load_in_init_lane0(data)           ((0xFF000000&(data))>>24)
+#define REG_DFE_INIT1_L0_get_init1_rev1_lane0(data)             ((0x00FC0000&(data))>>18)
+#define REG_DFE_INIT1_L0_get_de_video_inv_lane0(data)           ((0x00020000&(data))>>17)
+#define REG_DFE_INIT1_L0_get_de_packet_inv_lane0(data)          ((0x00010000&(data))>>16)
+#define REG_DFE_INIT1_L0_get_de_video_en_lane0(data)            ((0x00008000&(data))>>15)
+#define REG_DFE_INIT1_L0_get_de_packet_en_lane0(data)           ((0x00004000&(data))>>14)
+#define REG_DFE_INIT1_L0_get_servo_init_lane0(data)             ((0x00003E00&(data))>>9)
+#define REG_DFE_INIT1_L0_get_init1_rev2_lane0(data)             (0x000001FF&(data))
+
+
+#define REG_DFE_EN_L1                                              0xe10
+#define REG_DFE_EN_L1_reg_addr                                     "0x98034e10"
+#define REG_DFE_EN_L1_reg                                          0x98034e10
+#define REG_DFE_EN_L1_inst_addr                                    "0x0384"
+#define REG_DFE_EN_L1_inst                                         0x0384
+#define REG_DFE_EN_L1_clk_inv_lane1_shift                       (31)
+#define REG_DFE_EN_L1_timer_ctrl_en_lane1_shift                 (30)
+#define REG_DFE_EN_L1_reduce_adapt_gain_lane1_shift             (28)
+#define REG_DFE_EN_L1_rl_det_en_lane1_shift                     (27)
+#define REG_DFE_EN_L1_rl_det_mode_lane1_shift                   (26)
+#define REG_DFE_EN_L1_rl_threshold_lane1_shift                  (24)
+#define REG_DFE_EN_L1_dfe_adapt_en_lane1_shift                  (16)
+#define REG_DFE_EN_L1_le_min_lane1_shift                        (11)
+#define REG_DFE_EN_L1_le_init_lane1_shift                       (6)
+#define REG_DFE_EN_L1_tap4_init_lane1_shift                     (0)
+#define REG_DFE_EN_L1_clk_inv_lane1_mask                        (0x80000000)
+#define REG_DFE_EN_L1_timer_ctrl_en_lane1_mask                  (0x40000000)
+#define REG_DFE_EN_L1_reduce_adapt_gain_lane1_mask              (0x30000000)
+#define REG_DFE_EN_L1_rl_det_en_lane1_mask                      (0x08000000)
+#define REG_DFE_EN_L1_rl_det_mode_lane1_mask                    (0x04000000)
+#define REG_DFE_EN_L1_rl_threshold_lane1_mask                   (0x03000000)
+#define REG_DFE_EN_L1_dfe_adapt_en_lane1_mask                   (0x00FF0000)
+#define REG_DFE_EN_L1_le_min_lane1_mask                         (0x0000F800)
+#define REG_DFE_EN_L1_le_init_lane1_mask                        (0x000007C0)
+#define REG_DFE_EN_L1_tap4_init_lane1_mask                      (0x0000003F)
+#define REG_DFE_EN_L1_clk_inv_lane1(data)                       (0x80000000&((data)<<31))
+#define REG_DFE_EN_L1_timer_ctrl_en_lane1(data)                 (0x40000000&((data)<<30))
+#define REG_DFE_EN_L1_reduce_adapt_gain_lane1(data)             (0x30000000&((data)<<28))
+#define REG_DFE_EN_L1_rl_det_en_lane1(data)                     (0x08000000&((data)<<27))
+#define REG_DFE_EN_L1_rl_det_mode_lane1(data)                   (0x04000000&((data)<<26))
+#define REG_DFE_EN_L1_rl_threshold_lane1(data)                  (0x03000000&((data)<<24))
+#define REG_DFE_EN_L1_dfe_adapt_en_lane1(data)                  (0x00FF0000&((data)<<16))
+#define REG_DFE_EN_L1_le_min_lane1(data)                        (0x0000F800&((data)<<11))
+#define REG_DFE_EN_L1_le_init_lane1(data)                       (0x000007C0&((data)<<6))
+#define REG_DFE_EN_L1_tap4_init_lane1(data)                     (0x0000003F&(data))
+#define REG_DFE_EN_L1_get_clk_inv_lane1(data)                   ((0x80000000&(data))>>31)
+#define REG_DFE_EN_L1_get_timer_ctrl_en_lane1(data)             ((0x40000000&(data))>>30)
+#define REG_DFE_EN_L1_get_reduce_adapt_gain_lane1(data)         ((0x30000000&(data))>>28)
+#define REG_DFE_EN_L1_get_rl_det_en_lane1(data)                 ((0x08000000&(data))>>27)
+#define REG_DFE_EN_L1_get_rl_det_mode_lane1(data)               ((0x04000000&(data))>>26)
+#define REG_DFE_EN_L1_get_rl_threshold_lane1(data)              ((0x03000000&(data))>>24)
+#define REG_DFE_EN_L1_get_dfe_adapt_en_lane1(data)              ((0x00FF0000&(data))>>16)
+#define REG_DFE_EN_L1_get_le_min_lane1(data)                    ((0x0000F800&(data))>>11)
+#define REG_DFE_EN_L1_get_le_init_lane1(data)                   ((0x000007C0&(data))>>6)
+#define REG_DFE_EN_L1_get_tap4_init_lane1(data)                 (0x0000003F&(data))
+#define REG_dfe_adapt_en_lane1_TAP0									_BIT16
+#define REG_dfe_adapt_en_lane1_TAP1 								_BIT17
+#define REG_dfe_adapt_en_lane1_TAP2 								_BIT18
+#define REG_dfe_adapt_en_lane1_TAP3 								_BIT19
+#define REG_dfe_adapt_en_lane1_TAP4 								_BIT20
+#define REG_dfe_adapt_en_lane1_SERVO								_BIT21
+#define REG_dfe_adapt_en_lane1_Vth									_BIT22
+#define REG_dfe_adapt_en_lane1_LE									_BIT23
+
+
+#define REG_DFE_INIT0_L1                                           0xe14
+#define REG_DFE_INIT0_L1_reg_addr                                  "0x98034e14"
+#define REG_DFE_INIT0_L1_reg                                       0x98034e14
+#define REG_DFE_INIT0_L1_inst_addr                                 "0x0385"
+#define REG_DFE_INIT0_L1_inst                                      0x0385
+#define REG_DFE_INIT0_L1_tap3_init_lane1_shift                  (26)
+#define REG_DFE_INIT0_L1_tap2_init_lane1_shift                  (20)
+#define REG_DFE_INIT0_L1_tap1_init_lane1_shift                  (14)
+#define REG_DFE_INIT0_L1_tap0_init_lane1_shift                  (7)
+#define REG_DFE_INIT0_L1_init1_rev0_lane1_shift                 (4)
+#define REG_DFE_INIT0_L1_vth_init_lane1_shift                   (0)
+#define REG_DFE_INIT0_L1_tap3_init_lane1_mask                   (0xFC000000)
+#define REG_DFE_INIT0_L1_tap2_init_lane1_mask                   (0x03F00000)
+#define REG_DFE_INIT0_L1_tap1_init_lane1_mask                   (0x000FC000)
+#define REG_DFE_INIT0_L1_tap0_init_lane1_mask                   (0x00003F80)
+#define REG_DFE_INIT0_L1_init1_rev0_lane1_mask                  (0x00000070)
+#define REG_DFE_INIT0_L1_vth_init_lane1_mask                    (0x0000000F)
+#define REG_DFE_INIT0_L1_tap3_init_lane1(data)                  (0xFC000000&((data)<<26))
+#define REG_DFE_INIT0_L1_tap2_init_lane1(data)                  (0x03F00000&((data)<<20))
+#define REG_DFE_INIT0_L1_tap1_init_lane1(data)                  (0x000FC000&((data)<<14))
+#define REG_DFE_INIT0_L1_tap0_init_lane1(data)                  (0x00003F80&((data)<<7))
+#define REG_DFE_INIT0_L1_init1_rev0_lane1(data)                 (0x00000070&((data)<<4))
+#define REG_DFE_INIT0_L1_vth_init_lane1(data)                   (0x0000000F&(data))
+#define REG_DFE_INIT0_L1_get_tap3_init_lane1(data)              ((0xFC000000&(data))>>26)
+#define REG_DFE_INIT0_L1_get_tap2_init_lane1(data)              ((0x03F00000&(data))>>20)
+#define REG_DFE_INIT0_L1_get_tap1_init_lane1(data)              ((0x000FC000&(data))>>14)
+#define REG_DFE_INIT0_L1_get_tap0_init_lane1(data)              ((0x00003F80&(data))>>7)
+#define REG_DFE_INIT0_L1_get_init1_rev0_lane1(data)             ((0x00000070&(data))>>4)
+#define REG_DFE_INIT0_L1_get_vth_init_lane1(data)               (0x0000000F&(data))
+
+
+#define REG_DFE_INIT1_L1                                           0xe18
+#define REG_DFE_INIT1_L1_reg_addr                                  "0x98034e18"
+#define REG_DFE_INIT1_L1_reg                                       0x98034e18
+#define REG_DFE_INIT1_L1_inst_addr                                 "0x0386"
+#define REG_DFE_INIT1_L1_inst                                      0x0386
+#define REG_DFE_INIT1_L1_load_in_init_lane1_shift               (24)
+#define REG_DFE_INIT1_L1_init1_rev1_lane1_shift                 (18)
+#define REG_DFE_INIT1_L1_de_video_inv_lane1_shift               (17)
+#define REG_DFE_INIT1_L1_de_packet_inv_lane1_shift              (16)
+#define REG_DFE_INIT1_L1_de_video_en_lane1_shift                (15)
+#define REG_DFE_INIT1_L1_de_packet_en_lane1_shift               (14)
+#define REG_DFE_INIT1_L1_servo_init_lane1_shift                 (9)
+#define REG_DFE_INIT1_L1_init1_rev2_lane1_shift                 (0)
+#define REG_DFE_INIT1_L1_load_in_init_lane1_mask                (0xFF000000)
+#define REG_DFE_INIT1_L1_init1_rev1_lane1_mask                  (0x00FC0000)
+#define REG_DFE_INIT1_L1_de_video_inv_lane1_mask                (0x00020000)
+#define REG_DFE_INIT1_L1_de_packet_inv_lane1_mask               (0x00010000)
+#define REG_DFE_INIT1_L1_de_video_en_lane1_mask                 (0x00008000)
+#define REG_DFE_INIT1_L1_de_packet_en_lane1_mask                (0x00004000)
+#define REG_DFE_INIT1_L1_servo_init_lane1_mask                  (0x00003E00)
+#define REG_DFE_INIT1_L1_init1_rev2_lane1_mask                  (0x000001FF)
+#define REG_DFE_INIT1_L1_load_in_init_lane1(data)               (0xFF000000&((data)<<24))
+#define REG_DFE_INIT1_L1_init1_rev1_lane1(data)                 (0x00FC0000&((data)<<18))
+#define REG_DFE_INIT1_L1_de_video_inv_lane1(data)               (0x00020000&((data)<<17))
+#define REG_DFE_INIT1_L1_de_packet_inv_lane1(data)              (0x00010000&((data)<<16))
+#define REG_DFE_INIT1_L1_de_video_en_lane1(data)                (0x00008000&((data)<<15))
+#define REG_DFE_INIT1_L1_de_packet_en_lane1(data)               (0x00004000&((data)<<14))
+#define REG_DFE_INIT1_L1_servo_init_lane1(data)                 (0x00003E00&((data)<<9))
+#define REG_DFE_INIT1_L1_init1_rev2_lane1(data)                 (0x000001FF&(data))
+#define REG_DFE_INIT1_L1_get_load_in_init_lane1(data)           ((0xFF000000&(data))>>24)
+#define REG_DFE_INIT1_L1_get_init1_rev1_lane1(data)             ((0x00FC0000&(data))>>18)
+#define REG_DFE_INIT1_L1_get_de_video_inv_lane1(data)           ((0x00020000&(data))>>17)
+#define REG_DFE_INIT1_L1_get_de_packet_inv_lane1(data)          ((0x00010000&(data))>>16)
+#define REG_DFE_INIT1_L1_get_de_video_en_lane1(data)            ((0x00008000&(data))>>15)
+#define REG_DFE_INIT1_L1_get_de_packet_en_lane1(data)           ((0x00004000&(data))>>14)
+#define REG_DFE_INIT1_L1_get_servo_init_lane1(data)             ((0x00003E00&(data))>>9)
+#define REG_DFE_INIT1_L1_get_init1_rev2_lane1(data)             (0x000001FF&(data))
+
+
+#define REG_DFE_EN_L2                                              0xe20
+#define REG_DFE_EN_L2_reg_addr                                     "0x98034e20"
+#define REG_DFE_EN_L2_reg                                          0x98034e20
+#define REG_DFE_EN_L2_inst_addr                                    "0x0388"
+#define REG_DFE_EN_L2_inst                                         0x0388
+#define REG_DFE_EN_L2_clk_inv_lane2_shift                       (31)
+#define REG_DFE_EN_L2_timer_ctrl_en_lane2_shift                 (30)
+#define REG_DFE_EN_L2_reduce_adapt_gain_lane2_shift             (28)
+#define REG_DFE_EN_L2_rl_det_en_lane2_shift                     (27)
+#define REG_DFE_EN_L2_rl_det_mode_lane2_shift                   (26)
+#define REG_DFE_EN_L2_rl_threshold_lane2_shift                  (24)
+#define REG_DFE_EN_L2_dfe_adapt_en_lane2_shift                  (16)
+#define REG_DFE_EN_L2_le_min_lane2_shift                        (11)
+#define REG_DFE_EN_L2_le_init_lane2_shift                       (6)
+#define REG_DFE_EN_L2_tap4_init_lane2_shift                     (0)
+#define REG_DFE_EN_L2_clk_inv_lane2_mask                        (0x80000000)
+#define REG_DFE_EN_L2_timer_ctrl_en_lane2_mask                  (0x40000000)
+#define REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask              (0x30000000)
+#define REG_DFE_EN_L2_rl_det_en_lane2_mask                      (0x08000000)
+#define REG_DFE_EN_L2_rl_det_mode_lane2_mask                    (0x04000000)
+#define REG_DFE_EN_L2_rl_threshold_lane2_mask                   (0x03000000)
+#define REG_DFE_EN_L2_dfe_adapt_en_lane2_mask                   (0x00FF0000)
+#define REG_DFE_EN_L2_le_min_lane2_mask                         (0x0000F800)
+#define REG_DFE_EN_L2_le_init_lane2_mask                        (0x000007C0)
+#define REG_DFE_EN_L2_tap4_init_lane2_mask                      (0x0000003F)
+#define REG_DFE_EN_L2_clk_inv_lane2(data)                       (0x80000000&((data)<<31))
+#define REG_DFE_EN_L2_timer_ctrl_en_lane2(data)                 (0x40000000&((data)<<30))
+#define REG_DFE_EN_L2_reduce_adapt_gain_lane2(data)             (0x30000000&((data)<<28))
+#define REG_DFE_EN_L2_rl_det_en_lane2(data)                     (0x08000000&((data)<<27))
+#define REG_DFE_EN_L2_rl_det_mode_lane2(data)                   (0x04000000&((data)<<26))
+#define REG_DFE_EN_L2_rl_threshold_lane2(data)                  (0x03000000&((data)<<24))
+#define REG_DFE_EN_L2_dfe_adapt_en_lane2(data)                  (0x00FF0000&((data)<<16))
+#define REG_DFE_EN_L2_le_min_lane2(data)                        (0x0000F800&((data)<<11))
+#define REG_DFE_EN_L2_le_init_lane2(data)                       (0x000007C0&((data)<<6))
+#define REG_DFE_EN_L2_tap4_init_lane2(data)                     (0x0000003F&(data))
+#define REG_DFE_EN_L2_get_clk_inv_lane2(data)                   ((0x80000000&(data))>>31)
+#define REG_DFE_EN_L2_get_timer_ctrl_en_lane2(data)             ((0x40000000&(data))>>30)
+#define REG_DFE_EN_L2_get_reduce_adapt_gain_lane2(data)         ((0x30000000&(data))>>28)
+#define REG_DFE_EN_L2_get_rl_det_en_lane2(data)                 ((0x08000000&(data))>>27)
+#define REG_DFE_EN_L2_get_rl_det_mode_lane2(data)               ((0x04000000&(data))>>26)
+#define REG_DFE_EN_L2_get_rl_threshold_lane2(data)              ((0x03000000&(data))>>24)
+#define REG_DFE_EN_L2_get_dfe_adapt_en_lane2(data)              ((0x00FF0000&(data))>>16)
+#define REG_DFE_EN_L2_get_le_min_lane2(data)                    ((0x0000F800&(data))>>11)
+#define REG_DFE_EN_L2_get_le_init_lane2(data)                   ((0x000007C0&(data))>>6)
+#define REG_DFE_EN_L2_get_tap4_init_lane2(data)                 (0x0000003F&(data))
+#define REG_dfe_adapt_en_lane2_TAP0 								_BIT16
+#define REG_dfe_adapt_en_lane2_TAP1 								_BIT17
+#define REG_dfe_adapt_en_lane2_TAP2 								_BIT18
+#define REG_dfe_adapt_en_lane2_TAP3 								_BIT19
+#define REG_dfe_adapt_en_lane2_TAP4 								_BIT20
+#define REG_dfe_adapt_en_lane2_SERVO								_BIT21
+#define REG_dfe_adapt_en_lane2_Vth									_BIT22
+#define REG_dfe_adapt_en_lane2_LE									_BIT23
+
+
+#define REG_DFE_INIT0_L2                                           0xe24
+#define REG_DFE_INIT0_L2_reg_addr                                  "0x98034e24"
+#define REG_DFE_INIT0_L2_reg                                       0x98034e24
+#define REG_DFE_INIT0_L2_inst_addr                                 "0x0389"
+#define REG_DFE_INIT0_L2_inst                                      0x0389
+#define REG_DFE_INIT0_L2_tap3_init_lane2_shift                  (26)
+#define REG_DFE_INIT0_L2_tap2_init_lane2_shift                  (20)
+#define REG_DFE_INIT0_L2_tap1_init_lane2_shift                  (14)
+#define REG_DFE_INIT0_L2_tap0_init_lane2_shift                  (7)
+#define REG_DFE_INIT0_L2_init1_rev0_lane2_shift                 (4)
+#define REG_DFE_INIT0_L2_vth_init_lane2_shift                   (0)
+#define REG_DFE_INIT0_L2_tap3_init_lane2_mask                   (0xFC000000)
+#define REG_DFE_INIT0_L2_tap2_init_lane2_mask                   (0x03F00000)
+#define REG_DFE_INIT0_L2_tap1_init_lane2_mask                   (0x000FC000)
+#define REG_DFE_INIT0_L2_tap0_init_lane2_mask                   (0x00003F80)
+#define REG_DFE_INIT0_L2_init1_rev0_lane2_mask                  (0x00000070)
+#define REG_DFE_INIT0_L2_vth_init_lane2_mask                    (0x0000000F)
+#define REG_DFE_INIT0_L2_tap3_init_lane2(data)                  (0xFC000000&((data)<<26))
+#define REG_DFE_INIT0_L2_tap2_init_lane2(data)                  (0x03F00000&((data)<<20))
+#define REG_DFE_INIT0_L2_tap1_init_lane2(data)                  (0x000FC000&((data)<<14))
+#define REG_DFE_INIT0_L2_tap0_init_lane2(data)                  (0x00003F80&((data)<<7))
+#define REG_DFE_INIT0_L2_init1_rev0_lane2(data)                 (0x00000070&((data)<<4))
+#define REG_DFE_INIT0_L2_vth_init_lane2(data)                   (0x0000000F&(data))
+#define REG_DFE_INIT0_L2_get_tap3_init_lane2(data)              ((0xFC000000&(data))>>26)
+#define REG_DFE_INIT0_L2_get_tap2_init_lane2(data)              ((0x03F00000&(data))>>20)
+#define REG_DFE_INIT0_L2_get_tap1_init_lane2(data)              ((0x000FC000&(data))>>14)
+#define REG_DFE_INIT0_L2_get_tap0_init_lane2(data)              ((0x00003F80&(data))>>7)
+#define REG_DFE_INIT0_L2_get_init1_rev0_lane2(data)             ((0x00000070&(data))>>4)
+#define REG_DFE_INIT0_L2_get_vth_init_lane2(data)               (0x0000000F&(data))
+
+
+#define REG_DFE_INIT1_L2                                           0xe28
+#define REG_DFE_INIT1_L2_reg_addr                                  "0x98034e28"
+#define REG_DFE_INIT1_L2_reg                                       0x98034e28
+#define REG_DFE_INIT1_L2_inst_addr                                 "0x038A"
+#define REG_DFE_INIT1_L2_inst                                      0x038A
+#define REG_DFE_INIT1_L2_load_in_init_lane2_shift               (24)
+#define REG_DFE_INIT1_L2_init1_rev1_lane2_shift                 (18)
+#define REG_DFE_INIT1_L2_de_video_inv_lane2_shift               (17)
+#define REG_DFE_INIT1_L2_de_packet_inv_lane2_shift              (16)
+#define REG_DFE_INIT1_L2_de_video_en_lane2_shift                (15)
+#define REG_DFE_INIT1_L2_de_packet_en_lane2_shift               (14)
+#define REG_DFE_INIT1_L2_servo_init_lane2_shift                 (9)
+#define REG_DFE_INIT1_L2_init1_rev2_lane2_shift                 (0)
+#define REG_DFE_INIT1_L2_load_in_init_lane2_mask                (0xFF000000)
+#define REG_DFE_INIT1_L2_init1_rev1_lane2_mask                  (0x00FC0000)
+#define REG_DFE_INIT1_L2_de_video_inv_lane2_mask                (0x00020000)
+#define REG_DFE_INIT1_L2_de_packet_inv_lane2_mask               (0x00010000)
+#define REG_DFE_INIT1_L2_de_video_en_lane2_mask                 (0x00008000)
+#define REG_DFE_INIT1_L2_de_packet_en_lane2_mask                (0x00004000)
+#define REG_DFE_INIT1_L2_servo_init_lane2_mask                  (0x00003E00)
+#define REG_DFE_INIT1_L2_init1_rev2_lane2_mask                  (0x000001FF)
+#define REG_DFE_INIT1_L2_load_in_init_lane2(data)               (0xFF000000&((data)<<24))
+#define REG_DFE_INIT1_L2_init1_rev1_lane2(data)                 (0x00FC0000&((data)<<18))
+#define REG_DFE_INIT1_L2_de_video_inv_lane2(data)               (0x00020000&((data)<<17))
+#define REG_DFE_INIT1_L2_de_packet_inv_lane2(data)              (0x00010000&((data)<<16))
+#define REG_DFE_INIT1_L2_de_video_en_lane2(data)                (0x00008000&((data)<<15))
+#define REG_DFE_INIT1_L2_de_packet_en_lane2(data)               (0x00004000&((data)<<14))
+#define REG_DFE_INIT1_L2_servo_init_lane2(data)                 (0x00003E00&((data)<<9))
+#define REG_DFE_INIT1_L2_init1_rev2_lane2(data)                 (0x000001FF&(data))
+#define REG_DFE_INIT1_L2_get_load_in_init_lane2(data)           ((0xFF000000&(data))>>24)
+#define REG_DFE_INIT1_L2_get_init1_rev1_lane2(data)             ((0x00FC0000&(data))>>18)
+#define REG_DFE_INIT1_L2_get_de_video_inv_lane2(data)           ((0x00020000&(data))>>17)
+#define REG_DFE_INIT1_L2_get_de_packet_inv_lane2(data)          ((0x00010000&(data))>>16)
+#define REG_DFE_INIT1_L2_get_de_video_en_lane2(data)            ((0x00008000&(data))>>15)
+#define REG_DFE_INIT1_L2_get_de_packet_en_lane2(data)           ((0x00004000&(data))>>14)
+#define REG_DFE_INIT1_L2_get_servo_init_lane2(data)             ((0x00003E00&(data))>>9)
+#define REG_DFE_INIT1_L2_get_init1_rev2_lane2(data)             (0x000001FF&(data))
+#define LOAD_IN_INIT_LE                                         (_BIT31)
+#define LOAD_IN_INIT_VTH                                        (_BIT30)
+#define LOAD_IN_INIT_SERVO                                      (_BIT29)
+#define LOAD_IN_INIT_TAP4                                       (_BIT28)
+#define LOAD_IN_INIT_TAP3                                       (_BIT27)
+#define LOAD_IN_INIT_TAP2                                       (_BIT26)
+#define LOAD_IN_INIT_TAP1                                       (_BIT25)
+#define LOAD_IN_INIT_TAP0                                       (_BIT24)
+#define LOAD_IN_INIT_ALL (LOAD_IN_INIT_LE|LOAD_IN_INIT_VTH|LOAD_IN_INIT_SERVO|LOAD_IN_INIT_TAP4|LOAD_IN_INIT_TAP3|LOAD_IN_INIT_TAP2|LOAD_IN_INIT_TAP1|LOAD_IN_INIT_TAP0)
+
+
+#define REG_DFE_MODE                                               0xe30
+#define REG_DFE_MODE_reg_addr                                      "0x98034e30"
+#define REG_DFE_MODE_reg                                           0x98034e30
+#define REG_DFE_MODE_inst_addr                                     "0x038C"
+#define REG_DFE_MODE_inst                                          0x038C
+#define REG_DFE_MODE_adapt_mode_shift                           (30)
+#define REG_DFE_MODE_edge_det_mode_shift                        (29)
+#define REG_DFE_MODE_transition_only_shift                      (28)
+#define REG_DFE_MODE_le_auto_reload_shift                       (27)
+#define REG_DFE_MODE_tap1_delay_shift                           (24)
+#define REG_DFE_MODE_tap24_delay_shift                          (21)
+#define REG_DFE_MODE_le_delay_shift                             (18)
+#define REG_DFE_MODE_servo_delay_shift                          (16)
+#define REG_DFE_MODE_gray_en_shift                              (8)
+#define REG_DFE_MODE_dfe_adapt_rstb_shift                       (4)
+#define REG_DFE_MODE_tap0_trans_shift                           (3)
+#define REG_DFE_MODE_tap0_notrans_shift                         (2)
+#define REG_DFE_MODE_servo_notrans_shift                        (1)
+#define REG_DFE_MODE_servo_trans_shift                          (0)
+#define REG_DFE_MODE_adapt_mode_mask                            (0xC0000000)
+#define REG_DFE_MODE_edge_det_mode_mask                         (0x20000000)
+#define REG_DFE_MODE_transition_only_mask                       (0x10000000)
+#define REG_DFE_MODE_le_auto_reload_mask                        (0x08000000)
+#define REG_DFE_MODE_tap1_delay_mask                            (0x07000000)
+#define REG_DFE_MODE_tap24_delay_mask                           (0x00E00000)
+#define REG_DFE_MODE_le_delay_mask                              (0x001C0000)
+#define REG_DFE_MODE_servo_delay_mask                           (0x00030000)
+#define REG_DFE_MODE_gray_en_mask                               (0x0000FF00)
+#define REG_DFE_MODE_dfe_adapt_rstb_mask                        (0x000000F0)
+#define REG_DFE_MODE_tap0_trans_mask                            (0x00000008)
+#define REG_DFE_MODE_tap0_notrans_mask                          (0x00000004)
+#define REG_DFE_MODE_servo_notrans_mask                         (0x00000002)
+#define REG_DFE_MODE_servo_trans_mask                           (0x00000001)
+#define REG_DFE_MODE_adapt_mode(data)                           (0xC0000000&((data)<<30))
+#define REG_DFE_MODE_edge_det_mode(data)                        (0x20000000&((data)<<29))
+#define REG_DFE_MODE_transition_only(data)                      (0x10000000&((data)<<28))
+#define REG_DFE_MODE_le_auto_reload(data)                       (0x08000000&((data)<<27))
+#define REG_DFE_MODE_tap1_delay(data)                           (0x07000000&((data)<<24))
+#define REG_DFE_MODE_tap24_delay(data)                          (0x00E00000&((data)<<21))
+#define REG_DFE_MODE_le_delay(data)                             (0x001C0000&((data)<<18))
+#define REG_DFE_MODE_servo_delay(data)                          (0x00030000&((data)<<16))
+#define REG_DFE_MODE_gray_en(data)                              (0x0000FF00&((data)<<8))
+#define REG_DFE_MODE_dfe_adapt_rstb(data)                       (0x000000F0&((data)<<4))
+#define REG_DFE_MODE_tap0_trans(data)                           (0x00000008&((data)<<3))
+#define REG_DFE_MODE_tap0_notrans(data)                         (0x00000004&((data)<<2))
+#define REG_DFE_MODE_servo_notrans(data)                        (0x00000002&((data)<<1))
+#define REG_DFE_MODE_servo_trans(data)                          (0x00000001&(data))
+#define REG_DFE_MODE_get_adapt_mode(data)                       ((0xC0000000&(data))>>30)
+#define REG_DFE_MODE_get_edge_det_mode(data)                    ((0x20000000&(data))>>29)
+#define REG_DFE_MODE_get_transition_only(data)                  ((0x10000000&(data))>>28)
+#define REG_DFE_MODE_get_le_auto_reload(data)                   ((0x08000000&(data))>>27)
+#define REG_DFE_MODE_get_tap1_delay(data)                       ((0x07000000&(data))>>24)
+#define REG_DFE_MODE_get_tap24_delay(data)                      ((0x00E00000&(data))>>21)
+#define REG_DFE_MODE_get_le_delay(data)                         ((0x001C0000&(data))>>18)
+#define REG_DFE_MODE_get_servo_delay(data)                      ((0x00030000&(data))>>16)
+#define REG_DFE_MODE_get_gray_en(data)                          ((0x0000FF00&(data))>>8)
+#define REG_DFE_MODE_get_dfe_adapt_rstb(data)                   ((0x000000F0&(data))>>4)
+#define REG_DFE_MODE_get_tap0_trans(data)                       ((0x00000008&(data))>>3)
+#define REG_DFE_MODE_get_tap0_notrans(data)                     ((0x00000004&(data))>>2)
+#define REG_DFE_MODE_get_servo_notrans(data)                    ((0x00000002&(data))>>1)
+#define REG_DFE_MODE_get_servo_trans(data)                      (0x00000001&(data))
+
+
+#define REG_DFE_GAIN                                               0xe34
+#define REG_DFE_GAIN_reg_addr                                      "0x98034e34"
+#define REG_DFE_GAIN_reg                                           0x98034e34
+#define REG_DFE_GAIN_inst_addr                                     "0x038D"
+#define REG_DFE_GAIN_inst                                          0x038D
+#define REG_DFE_GAIN_tap0_gain_shift                            (29)
+#define REG_DFE_GAIN_tap1_gain_shift                            (26)
+#define REG_DFE_GAIN_tap2_gain_shift                            (23)
+#define REG_DFE_GAIN_tap3_gain_shift                            (20)
+#define REG_DFE_GAIN_tap4_gain_shift                            (17)
+#define REG_DFE_GAIN_servo_gain_shift                           (14)
+#define REG_DFE_GAIN_le_gain1_shift                             (11)
+#define REG_DFE_GAIN_le_gain2_shift                             (8)
+#define REG_DFE_GAIN_le2_sign_shift                             (7)
+#define REG_DFE_GAIN_le_gain_prec_shift                         (4)
+#define REG_DFE_GAIN_le_prec_sign_shift                         (3)
+#define REG_DFE_GAIN_trans_rlength_shift                        (0)
+#define REG_DFE_GAIN_tap0_gain_mask                             (0xE0000000)
+#define REG_DFE_GAIN_tap1_gain_mask                             (0x1C000000)
+#define REG_DFE_GAIN_tap2_gain_mask                             (0x03800000)
+#define REG_DFE_GAIN_tap3_gain_mask                             (0x00700000)
+#define REG_DFE_GAIN_tap4_gain_mask                             (0x000E0000)
+#define REG_DFE_GAIN_servo_gain_mask                            (0x0001C000)
+#define REG_DFE_GAIN_le_gain1_mask                              (0x00003800)
+#define REG_DFE_GAIN_le_gain2_mask                              (0x00000700)
+#define REG_DFE_GAIN_le2_sign_mask                              (0x00000080)
+#define REG_DFE_GAIN_le_gain_prec_mask                          (0x00000070)
+#define REG_DFE_GAIN_le_prec_sign_mask                          (0x00000008)
+#define REG_DFE_GAIN_trans_rlength_mask                         (0x00000007)
+#define REG_DFE_GAIN_tap0_gain(data)                            (0xE0000000&((data)<<29))
+#define REG_DFE_GAIN_tap1_gain(data)                            (0x1C000000&((data)<<26))
+#define REG_DFE_GAIN_tap2_gain(data)                            (0x03800000&((data)<<23))
+#define REG_DFE_GAIN_tap3_gain(data)                            (0x00700000&((data)<<20))
+#define REG_DFE_GAIN_tap4_gain(data)                            (0x000E0000&((data)<<17))
+#define REG_DFE_GAIN_servo_gain(data)                           (0x0001C000&((data)<<14))
+#define REG_DFE_GAIN_le_gain1(data)                             (0x00003800&((data)<<11))
+#define REG_DFE_GAIN_le_gain2(data)                             (0x00000700&((data)<<8))
+#define REG_DFE_GAIN_le2_sign(data)                             (0x00000080&((data)<<7))
+#define REG_DFE_GAIN_le_gain_prec(data)                         (0x00000070&((data)<<4))
+#define REG_DFE_GAIN_le_prec_sign(data)                         (0x00000008&((data)<<3))
+#define REG_DFE_GAIN_trans_rlength(data)                        (0x00000007&(data))
+#define REG_DFE_GAIN_get_tap0_gain(data)                        ((0xE0000000&(data))>>29)
+#define REG_DFE_GAIN_get_tap1_gain(data)                        ((0x1C000000&(data))>>26)
+#define REG_DFE_GAIN_get_tap2_gain(data)                        ((0x03800000&(data))>>23)
+#define REG_DFE_GAIN_get_tap3_gain(data)                        ((0x00700000&(data))>>20)
+#define REG_DFE_GAIN_get_tap4_gain(data)                        ((0x000E0000&(data))>>17)
+#define REG_DFE_GAIN_get_servo_gain(data)                       ((0x0001C000&(data))>>14)
+#define REG_DFE_GAIN_get_le_gain1(data)                         ((0x00003800&(data))>>11)
+#define REG_DFE_GAIN_get_le_gain2(data)                         ((0x00000700&(data))>>8)
+#define REG_DFE_GAIN_get_le2_sign(data)                         ((0x00000080&(data))>>7)
+#define REG_DFE_GAIN_get_le_gain_prec(data)                     ((0x00000070&(data))>>4)
+#define REG_DFE_GAIN_get_le_prec_sign(data)                     ((0x00000008&(data))>>3)
+#define REG_DFE_GAIN_get_trans_rlength(data)                    (0x00000007&(data))
+
+
+#define REG_DFE_LIMIT0                                             0xe38
+#define REG_DFE_LIMIT0_reg_addr                                    "0x98034e38"
+#define REG_DFE_LIMIT0_reg                                         0x98034e38
+#define REG_DFE_LIMIT0_inst_addr                                   "0x038E"
+#define REG_DFE_LIMIT0_inst                                        0x038E
+#define REG_DFE_LIMIT0_limit0_rev_shift                         (26)
+#define REG_DFE_LIMIT0_tap1_min_shift                           (20)
+#define REG_DFE_LIMIT0_tap2_max_shift                           (15)
+#define REG_DFE_LIMIT0_tap2_min_shift                           (10)
+#define REG_DFE_LIMIT0_tap3_max_shift                           (5)
+#define REG_DFE_LIMIT0_tap3_min_shift                           (0)
+#define REG_DFE_LIMIT0_limit0_rev_mask                          (0xFC000000)
+#define REG_DFE_LIMIT0_tap1_min_mask                            (0x03F00000)
+#define REG_DFE_LIMIT0_tap2_max_mask                            (0x000F8000)
+#define REG_DFE_LIMIT0_tap2_min_mask                            (0x00007C00)
+#define REG_DFE_LIMIT0_tap3_max_mask                            (0x000003E0)
+#define REG_DFE_LIMIT0_tap3_min_mask                            (0x0000001F)
+#define REG_DFE_LIMIT0_limit0_rev(data)                         (0xFC000000&((data)<<26))
+#define REG_DFE_LIMIT0_tap1_min(data)                           (0x03F00000&((data)<<20))
+#define REG_DFE_LIMIT0_tap2_max(data)                           (0x000F8000&((data)<<15))
+#define REG_DFE_LIMIT0_tap2_min(data)                           (0x00007C00&((data)<<10))
+#define REG_DFE_LIMIT0_tap3_max(data)                           (0x000003E0&((data)<<5))
+#define REG_DFE_LIMIT0_tap3_min(data)                           (0x0000001F&(data))
+#define REG_DFE_LIMIT0_get_limit0_rev(data)                     ((0xFC000000&(data))>>26)
+#define REG_DFE_LIMIT0_get_tap1_min(data)                       ((0x03F00000&(data))>>20)
+#define REG_DFE_LIMIT0_get_tap2_max(data)                       ((0x000F8000&(data))>>15)
+#define REG_DFE_LIMIT0_get_tap2_min(data)                       ((0x00007C00&(data))>>10)
+#define REG_DFE_LIMIT0_get_tap3_max(data)                       ((0x000003E0&(data))>>5)
+#define REG_DFE_LIMIT0_get_tap3_min(data)                       (0x0000001F&(data))
+
+
+#define REG_DFE_LIMIT1                                             0xe3c
+#define REG_DFE_LIMIT1_reg_addr                                    "0x98034e3c"
+#define REG_DFE_LIMIT1_reg                                         0x98034e3c
+#define REG_DFE_LIMIT1_inst_addr                                   "0x038F"
+#define REG_DFE_LIMIT1_inst                                        0x038F
+#define REG_DFE_LIMIT1_tap4_max_shift                           (27)
+#define REG_DFE_LIMIT1_tap4_min_shift                           (22)
+#define REG_DFE_LIMIT1_vth_min_shift                            (19)
+#define REG_DFE_LIMIT1_vth_max_shift                            (15)
+#define REG_DFE_LIMIT1_vth_threshold_shift                      (12)
+#define REG_DFE_LIMIT1_tap0_threshold_shift                     (8)
+#define REG_DFE_LIMIT1_tap0_adjust_shift                        (6)
+#define REG_DFE_LIMIT1_tap1_trans_shift                         (5)
+#define REG_DFE_LIMIT1_edge_last_notrans_shift                  (4)
+#define REG_DFE_LIMIT1_limit1_rev_shift                         (0)
+#define REG_DFE_LIMIT1_tap4_max_mask                            (0xF8000000)
+#define REG_DFE_LIMIT1_tap4_min_mask                            (0x07C00000)
+#define REG_DFE_LIMIT1_vth_min_mask                             (0x00380000)
+#define REG_DFE_LIMIT1_vth_max_mask                             (0x00078000)
+#define REG_DFE_LIMIT1_vth_threshold_mask                       (0x00007000)
+#define REG_DFE_LIMIT1_tap0_threshold_mask                      (0x00000F00)
+#define REG_DFE_LIMIT1_tap0_adjust_mask                         (0x000000C0)
+#define REG_DFE_LIMIT1_tap1_trans_mask                          (0x00000020)
+#define REG_DFE_LIMIT1_edge_last_notrans_mask                   (0x00000010)
+#define REG_DFE_LIMIT1_limit1_rev_mask                          (0x0000000F)
+#define REG_DFE_LIMIT1_tap4_max(data)                           (0xF8000000&((data)<<27))
+#define REG_DFE_LIMIT1_tap4_min(data)                           (0x07C00000&((data)<<22))
+#define REG_DFE_LIMIT1_vth_min(data)                            (0x00380000&((data)<<19))
+#define REG_DFE_LIMIT1_vth_max(data)                            (0x00078000&((data)<<15))
+#define REG_DFE_LIMIT1_vth_threshold(data)                      (0x00007000&((data)<<12))
+#define REG_DFE_LIMIT1_tap0_threshold(data)                     (0x00000F00&((data)<<8))
+#define REG_DFE_LIMIT1_tap0_adjust(data)                        (0x000000C0&((data)<<6))
+#define REG_DFE_LIMIT1_tap1_trans(data)                         (0x00000020&((data)<<5))
+#define REG_DFE_LIMIT1_edge_last_notrans(data)                  (0x00000010&((data)<<4))
+#define REG_DFE_LIMIT1_limit1_rev(data)                         (0x0000000F&(data))
+#define REG_DFE_LIMIT1_get_tap4_max(data)                       ((0xF8000000&(data))>>27)
+#define REG_DFE_LIMIT1_get_tap4_min(data)                       ((0x07C00000&(data))>>22)
+#define REG_DFE_LIMIT1_get_vth_min(data)                        ((0x00380000&(data))>>19)
+#define REG_DFE_LIMIT1_get_vth_max(data)                        ((0x00078000&(data))>>15)
+#define REG_DFE_LIMIT1_get_vth_threshold(data)                  ((0x00007000&(data))>>12)
+#define REG_DFE_LIMIT1_get_tap0_threshold(data)                 ((0x00000F00&(data))>>8)
+#define REG_DFE_LIMIT1_get_tap0_adjust(data)                    ((0x000000C0&(data))>>6)
+#define REG_DFE_LIMIT1_get_tap1_trans(data)                     ((0x00000020&(data))>>5)
+#define REG_DFE_LIMIT1_get_edge_last_notrans(data)              ((0x00000010&(data))>>4)
+#define REG_DFE_LIMIT1_get_limit1_rev(data)                     (0x0000000F&(data))
+
+
+#define REG_DFE_LIMIT2                                             0xe40
+#define REG_DFE_LIMIT2_reg_addr                                    "0x98034e40"
+#define REG_DFE_LIMIT2_reg                                         0x98034e40
+#define REG_DFE_LIMIT2_inst_addr                                   "0x0390"
+#define REG_DFE_LIMIT2_inst                                        0x0390
+#define REG_DFE_LIMIT2_servo_divisor_shift                      (26)
+#define REG_DFE_LIMIT2_tap_divisor_shift                        (20)
+#define REG_DFE_LIMIT2_vth_divisor_shift                        (16)
+#define REG_DFE_LIMIT2_tap0_max_shift                           (9)
+#define REG_DFE_LIMIT2_limit2_rev_shift                         (0)
+#define REG_DFE_LIMIT2_servo_divisor_mask                       (0xFC000000)
+#define REG_DFE_LIMIT2_tap_divisor_mask                         (0x03F00000)
+#define REG_DFE_LIMIT2_vth_divisor_mask                         (0x000F0000)
+#define REG_DFE_LIMIT2_tap0_max_mask                            (0x0000FE00)
+#define REG_DFE_LIMIT2_limit2_rev_mask                          (0x000001FF)
+#define REG_DFE_LIMIT2_servo_divisor(data)                      (0xFC000000&((data)<<26))
+#define REG_DFE_LIMIT2_tap_divisor(data)                        (0x03F00000&((data)<<20))
+#define REG_DFE_LIMIT2_vth_divisor(data)                        (0x000F0000&((data)<<16))
+#define REG_DFE_LIMIT2_tap0_max(data)                           (0x0000FE00&((data)<<9))
+#define REG_DFE_LIMIT2_limit2_rev(data)                         (0x000001FF&(data))
+#define REG_DFE_LIMIT2_get_servo_divisor(data)                  ((0xFC000000&(data))>>26)
+#define REG_DFE_LIMIT2_get_tap_divisor(data)                    ((0x03F00000&(data))>>20)
+#define REG_DFE_LIMIT2_get_vth_divisor(data)                    ((0x000F0000&(data))>>16)
+#define REG_DFE_LIMIT2_get_tap0_max(data)                       ((0x0000FE00&(data))>>9)
+#define REG_DFE_LIMIT2_get_limit2_rev(data)                     (0x000001FF&(data))
+
+
+#define REG_DFE_READBACK                                           0xe44
+#define REG_DFE_READBACK_reg_addr                                  "0x98034e44"
+#define REG_DFE_READBACK_reg                                       0x98034e44
+#define REG_DFE_READBACK_inst_addr                                 "0x0391"
+#define REG_DFE_READBACK_inst                                      0x0391
+#define REG_DFE_READBACK_record_limit_en_shift                  (31)
+#define REG_DFE_READBACK_lane_sel_shift                         (29)
+#define REG_DFE_READBACK_limit_sel_shift                        (24)
+#define REG_DFE_READBACK_limit_data_shift                       (16)
+#define REG_DFE_READBACK_coef_sel_shift                         (8)
+#define REG_DFE_READBACK_coef_data_shift                        (0)
+#define REG_DFE_READBACK_record_limit_en_mask                   (0x80000000)
+#define REG_DFE_READBACK_lane_sel_mask                          (0x60000000)
+#define REG_DFE_READBACK_limit_sel_mask                         (0x1F000000)
+#define REG_DFE_READBACK_limit_data_mask                        (0x00FF0000)
+#define REG_DFE_READBACK_coef_sel_mask                          (0x0000FF00)
+#define REG_DFE_READBACK_coef_data_mask                         (0x000000FF)
+#define REG_DFE_READBACK_record_limit_en(data)                  (0x80000000&((data)<<31))
+#define REG_DFE_READBACK_lane_sel(data)                         (0x60000000&((data)<<29))
+#define REG_DFE_READBACK_limit_sel(data)                        (0x1F000000&((data)<<24))
+#define REG_DFE_READBACK_limit_data(data)                       (0x00FF0000&((data)<<16))
+#define REG_DFE_READBACK_coef_sel(data)                         (0x0000FF00&((data)<<8))
+#define REG_DFE_READBACK_coef_data(data)                        (0x000000FF&(data))
+#define REG_DFE_READBACK_get_record_limit_en(data)              ((0x80000000&(data))>>31)
+#define REG_DFE_READBACK_get_lane_sel(data)                     ((0x60000000&(data))>>29)
+#define REG_DFE_READBACK_get_limit_sel(data)                    ((0x1F000000&(data))>>24)
+#define REG_DFE_READBACK_get_limit_data(data)                   ((0x00FF0000&(data))>>16)
+#define REG_DFE_READBACK_get_coef_sel(data)                     ((0x0000FF00&(data))>>8)
+#define REG_DFE_READBACK_get_coef_data(data)                    (0x000000FF&(data))
+#define LIMIT_TAP0_MAX          0
+#define LIMIT_TAP0_MIN          1
+#define LIMIT_TAP1_MAX          2
+#define LIMIT_TAP1_MIN          3
+#define LIMIT_LE_MAX            4
+#define LIMIT_LE_MIN            5
+
+#define COEF_VTH                0
+#define COEF_TAP0               1
+#define COEF_TAP1               2
+#define COEF_TAP2               3
+#define COEF_TAP3               4
+#define COEF_TAP4               5
+#define COEF_SERVO              6
+#define COEF_LE                 7
+
+#define get_TAP2_coef_sign(data)       (0x20&(data))
+#define get_TAP2_coef(data)            (0x1F&(data))
+
+
+#define REG_DFE_FLAG                                               0xe48
+#define REG_DFE_FLAG_reg_addr                                      "0x98034e48"
+#define REG_DFE_FLAG_reg                                           0x98034e48
+#define REG_DFE_FLAG_inst_addr                                     "0x0392"
+#define REG_DFE_FLAG_inst                                          0x0392
+#define REG_DFE_FLAG_adapt_fail_flag_shift                      (28)
+#define REG_DFE_FLAG_adapt_swing_max_flag_shift                 (24)
+#define REG_DFE_FLAG_flag_rev1_shift                            (12)
+#define REG_DFE_FLAG_flag_rev2_shift                            (0)
+#define REG_DFE_FLAG_adapt_fail_flag_mask                       (0xF0000000)
+#define REG_DFE_FLAG_adapt_swing_max_flag_mask                  (0x0F000000)
+#define REG_DFE_FLAG_flag_rev1_mask                             (0x00FFF000)
+#define REG_DFE_FLAG_flag_rev2_mask                             (0x00000FFF)
+#define REG_DFE_FLAG_adapt_fail_flag(data)                      (0xF0000000&((data)<<28))
+#define REG_DFE_FLAG_adapt_swing_max_flag(data)                 (0x0F000000&((data)<<24))
+#define REG_DFE_FLAG_flag_rev1(data)                            (0x00FFF000&((data)<<12))
+#define REG_DFE_FLAG_flag_rev2(data)                            (0x00000FFF&(data))
+#define REG_DFE_FLAG_get_adapt_fail_flag(data)                  ((0xF0000000&(data))>>28)
+#define REG_DFE_FLAG_get_adapt_swing_max_flag(data)             ((0x0F000000&(data))>>24)
+#define REG_DFE_FLAG_get_flag_rev1(data)                        ((0x00FFF000&(data))>>12)
+#define REG_DFE_FLAG_get_flag_rev2(data)                        (0x00000FFF&(data))
+
+
+#define REG_DFE_DEBUG                                              0xe4c
+#define REG_DFE_DEBUG_reg_addr                                     "0x98034e4c"
+#define REG_DFE_DEBUG_reg                                          0x98034e4c
+#define REG_DFE_DEBUG_inst_addr                                    "0x0393"
+#define REG_DFE_DEBUG_inst                                         0x0393
+#define REG_DFE_DEBUG_debug_rev_shift                           (5)
+#define REG_DFE_DEBUG_debug_sel_shift                           (0)
+#define REG_DFE_DEBUG_debug_rev_mask                            (0xFFFFFFE0)
+#define REG_DFE_DEBUG_debug_sel_mask                            (0x0000001F)
+#define REG_DFE_DEBUG_debug_rev(data)                           (0xFFFFFFE0&((data)<<5))
+#define REG_DFE_DEBUG_debug_sel(data)                           (0x0000001F&(data))
+#define REG_DFE_DEBUG_get_debug_rev(data)                       ((0xFFFFFFE0&(data))>>5)
+#define REG_DFE_DEBUG_get_debug_sel(data)                       (0x0000001F&(data))
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/HDMIRXDDC_fw.h b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/HDMIRXDDC_fw.h
new file mode 100644
index 00000000..35c9808
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/HDMIRXDDC_fw.h
@@ -0,0 +1,592 @@
+/*
+ * HDMIRXDDC_fw.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _DDC_REG_H_INCLUDED_
+#define _DDC_REG_H_INCLUDED_
+
+#define DDC1_I2C_CR                                                   0x00
+#define DDC1_I2C_CR_reg_addr                                          "0x98037704"
+
+#define DDC1_I2C_SR1                                                  0x04
+#define DDC1_I2C_SR1_reg_addr                                         "0x98037704"
+#define DDC1_I2C_SR1_reg                                              0x98037704
+#define DDC1_I2C_SR1_inst_addr                                        "0x01C1"
+#define DDC1_I2C_SR1_inst                                             0x01C1
+#define DDC1_I2C_SR1_cmderr_shift                                     (7)
+#define DDC1_I2C_SR1_finish_shift                                     (4)
+#define DDC1_I2C_SR1_timeout_shift                                    (3)
+#define DDC1_I2C_SR1_cmderr_mask                                      (0x00000080)
+#define DDC1_I2C_SR1_finish_mask                                      (0x00000010)
+#define DDC1_I2C_SR1_timeout_mask                                     (0x00000008)
+#define DDC1_I2C_SR1_cmderr(data)                                     (0x00000080&((data)<<7))
+#define DDC1_I2C_SR1_finish(data)                                     (0x00000010&((data)<<4))
+#define DDC1_I2C_SR1_timeout(data)                                    (0x00000008&((data)<<3))
+#define DDC1_I2C_SR1_get_cmderr(data)                                 ((0x00000080&(data))>>7)
+#define DDC1_I2C_SR1_get_finish(data)                                 ((0x00000010&(data))>>4)
+#define DDC1_I2C_SR1_get_timeout(data)                                ((0x00000008&(data))>>3)
+
+
+#define DDC1_I2C_TR                                                   0x08
+#define DDC1_I2C_TR_reg_addr                                          "0x98037708"
+#define DDC1_I2C_TR_reg                                               0x98037708
+#define DDC1_I2C_TR_inst_addr                                         "0x01C2"
+#define DDC1_I2C_TR_inst                                              0x01C2
+#define DDC1_I2C_TR_timeout_val_shift                                 (0)
+#define DDC1_I2C_TR_timeout_val_mask                                  (0x000000FF)
+#define DDC1_I2C_TR_timeout_val(data)                                 (0x000000FF&(data))
+#define DDC1_I2C_TR_get_timeout_val(data)                             (0x000000FF&(data))
+
+
+#define DDC1_EDID_CR                                                  0x0c
+#define DDC1_EDID_CR_reg_addr                                         "0x9803770c"
+#define DDC1_EDID_CR_reg                                              0x9803770c
+#define DDC1_EDID_CR_inst_addr                                        "0x01C3"
+#define DDC1_EDID_CR_inst                                             0x01C3
+#define DDC1_EDID_CR_edid_address_shift                               (5)
+#define DDC1_EDID_CR_finish_int_en_shift                              (4)
+#define DDC1_EDID_CR_DDC1_force_shift                                 (3)
+#define DDC1_EDID_CR_ddc2b_force_shift                                (2)
+#define DDC1_EDID_CR_edid_srwen_shift                                 (1)
+#define DDC1_EDID_CR_edid_en_shift                                    (0)
+#define DDC1_EDID_CR_edid_address_mask                                (0x000000E0)
+#define DDC1_EDID_CR_finish_int_en_mask                               (0x00000010)
+#define DDC1_EDID_CR_DDC1_force_mask                                  (0x00000008)
+#define DDC1_EDID_CR_ddc2b_force_mask                                 (0x00000004)
+#define DDC1_EDID_CR_edid_srwen_mask                                  (0x00000002)
+#define DDC1_EDID_CR_edid_en_mask                                     (0x00000001)
+#define DDC1_EDID_CR_edid_address(data)                               (0x000000E0&((data)<<5))
+#define DDC1_EDID_CR_finish_int_en(data)                              (0x00000010&((data)<<4))
+#define DDC1_EDID_CR_DDC1_force(data)                                 (0x00000008&((data)<<3))
+#define DDC1_EDID_CR_ddc2b_force(data)                                (0x00000004&((data)<<2))
+#define DDC1_EDID_CR_edid_srwen(data)                                 (0x00000002&((data)<<1))
+#define DDC1_EDID_CR_edid_en(data)                                    (0x00000001&(data))
+#define DDC1_EDID_CR_get_edid_address(data)                           ((0x000000E0&(data))>>5)
+#define DDC1_EDID_CR_get_finish_int_en(data)                          ((0x00000010&(data))>>4)
+#define DDC1_EDID_CR_get_DDC1_force(data)                             ((0x00000008&(data))>>3)
+#define DDC1_EDID_CR_get_ddc2b_force(data)                            ((0x00000004&(data))>>2)
+#define DDC1_EDID_CR_get_edid_srwen(data)                             ((0x00000002&(data))>>1)
+#define DDC1_EDID_CR_get_edid_en(data)                                (0x00000001&(data))
+
+
+#define DDC1_DDC_VCR                                                  0x10
+#define DDC1_DDC_VCR_reg_addr                                         "0x98037710"
+#define DDC1_DDC_VCR_reg                                              0x98037710
+#define DDC1_DDC_VCR_inst_addr                                        "0x01C4"
+#define DDC1_DDC_VCR_inst                                             0x01C4
+#define DDC1_DDC_VCR_DDC1_vcount_shift                                (0)
+#define DDC1_DDC_VCR_DDC1_vcount_mask                                 (0x000000FF)
+#define DDC1_DDC_VCR_DDC1_vcount(data)                                (0x000000FF&(data))
+#define DDC1_DDC_VCR_get_DDC1_vcount(data)                            (0x000000FF&(data))
+
+
+#define DDC1_EDID_IMSWSAR                                             0x14
+#define DDC1_EDID_IMSWSAR_reg_addr                                    "0x98037714"
+#define DDC1_EDID_IMSWSAR_reg                                         0x98037714
+#define DDC1_EDID_IMSWSAR_inst_addr                                   "0x01C5"
+#define DDC1_EDID_IMSWSAR_inst                                        0x01C5
+#define DDC1_EDID_IMSWSAR_edid_sadr_shift                             (0)
+#define DDC1_EDID_IMSWSAR_edid_sadr_mask                              (0x000000FF)
+#define DDC1_EDID_IMSWSAR_edid_sadr(data)                             (0x000000FF&(data))
+#define DDC1_EDID_IMSWSAR_get_edid_sadr(data)                         (0x000000FF&(data))
+
+
+#define DDC1_EDID_IMSWEAR                                             0x18
+#define DDC1_EDID_IMSWEAR_reg_addr                                    "0x98037718"
+#define DDC1_EDID_IMSWEAR_reg                                         0x98037718
+#define DDC1_EDID_IMSWEAR_inst_addr                                   "0x01C6"
+#define DDC1_EDID_IMSWEAR_inst                                        0x01C6
+#define DDC1_EDID_IMSWEAR_edid_eadr_shift                             (0)
+#define DDC1_EDID_IMSWEAR_edid_eadr_mask                              (0x000000FF)
+#define DDC1_EDID_IMSWEAR_edid_eadr(data)                             (0x000000FF&(data))
+#define DDC1_EDID_IMSWEAR_get_edid_eadr(data)                         (0x000000FF&(data))
+
+
+#define DDC1_EDID_IR                                                  0x1c
+#define DDC1_EDID_IR_reg_addr                                         "0x9803771c"
+#define DDC1_EDID_IR_reg                                              0x9803771c
+#define DDC1_EDID_IR_inst_addr                                        "0x01C7"
+#define DDC1_EDID_IR_inst                                             0x01C7
+#define DDC1_EDID_IR_edidmode_shift                                   (6)
+#define DDC1_EDID_IR_edidsubaddress_shift                             (5)
+#define DDC1_EDID_IR_edidstop_shift                                   (4)
+#define DDC1_EDID_IR_i2c_m_rd_st_ie_shift                             (3)
+#define DDC1_EDID_IR_i2c_m_rd_sp_ie_shift                             (2)
+#define DDC1_EDID_IR_edidsubaddress_ie_shift                          (1)
+#define DDC1_EDID_IR_edidstop_ie_shift                                (0)
+#define DDC1_EDID_IR_edidmode_mask                                    (0x00000040)
+#define DDC1_EDID_IR_edidsubaddress_mask                              (0x00000020)
+#define DDC1_EDID_IR_edidstop_mask                                    (0x00000010)
+#define DDC1_EDID_IR_i2c_m_rd_st_ie_mask                              (0x00000008)
+#define DDC1_EDID_IR_i2c_m_rd_sp_ie_mask                              (0x00000004)
+#define DDC1_EDID_IR_edidsubaddress_ie_mask                           (0x00000002)
+#define DDC1_EDID_IR_edidstop_ie_mask                                 (0x00000001)
+#define DDC1_EDID_IR_edidmode(data)                                   (0x00000040&((data)<<6))
+#define DDC1_EDID_IR_edidsubaddress(data)                             (0x00000020&((data)<<5))
+#define DDC1_EDID_IR_edidstop(data)                                   (0x00000010&((data)<<4))
+#define DDC1_EDID_IR_i2c_m_rd_st_ie(data)                             (0x00000008&((data)<<3))
+#define DDC1_EDID_IR_i2c_m_rd_sp_ie(data)                             (0x00000004&((data)<<2))
+#define DDC1_EDID_IR_edidsubaddress_ie(data)                          (0x00000002&((data)<<1))
+#define DDC1_EDID_IR_edidstop_ie(data)                                (0x00000001&(data))
+#define DDC1_EDID_IR_get_edidmode(data)                               ((0x00000040&(data))>>6)
+#define DDC1_EDID_IR_get_edidsubaddress(data)                         ((0x00000020&(data))>>5)
+#define DDC1_EDID_IR_get_edidstop(data)                               ((0x00000010&(data))>>4)
+#define DDC1_EDID_IR_get_i2c_m_rd_st_ie(data)                         ((0x00000008&(data))>>3)
+#define DDC1_EDID_IR_get_i2c_m_rd_sp_ie(data)                         ((0x00000004&(data))>>2)
+#define DDC1_EDID_IR_get_edidsubaddress_ie(data)                      ((0x00000002&(data))>>1)
+#define DDC1_EDID_IR_get_edidstop_ie(data)                            (0x00000001&(data))
+
+
+#define DDC1_DDC_SIR                                                  0x20
+#define DDC1_DDC_SIR_reg_addr                                         "0x98037720"
+#define DDC1_DDC_SIR_reg                                              0x98037720
+#define DDC1_DDC_SIR_inst_addr                                        "0x01C8"
+#define DDC1_DDC_SIR_inst                                             0x01C8
+#define DDC1_DDC_SIR_edidap_shift                                     (0)
+#define DDC1_DDC_SIR_edidap_mask                                      (0x000000FF)
+#define DDC1_DDC_SIR_edidap(data)                                     (0x000000FF&(data))
+#define DDC1_DDC_SIR_get_edidap(data)                                 (0x000000FF&(data))
+
+
+#define DDC1_DDC_SAP                                                  0x24
+#define DDC1_DDC_SAP_reg_addr                                         "0x98037724"
+#define DDC1_DDC_SAP_reg                                              0x98037724
+#define DDC1_DDC_SAP_inst_addr                                        "0x01C9"
+#define DDC1_DDC_SAP_inst                                             0x01C9
+#define DDC1_DDC_SAP_ediddp_shift                                     (0)
+#define DDC1_DDC_SAP_ediddp_mask                                      (0x000000FF)
+#define DDC1_DDC_SAP_ediddp(data)                                     (0x000000FF&(data))
+#define DDC1_DDC_SAP_get_ediddp(data)                                 (0x000000FF&(data))
+
+
+#define DDC1_DDC_BISTCR                                               0x28
+#define DDC1_DDC_BISTCR_reg_addr                                      "0x98037728"
+#define DDC1_DDC_BISTCR_reg                                           0x98037728
+#define DDC1_DDC_BISTCR_inst_addr                                     "0x01CA"
+#define DDC1_DDC_BISTCR_inst                                          0x01CA
+#define DDC1_DDC_BISTCR_ddc_bist_rme_shift                            (4)
+#define DDC1_DDC_BISTCR_ddc_bist_rm_shift                             (0)
+#define DDC1_DDC_BISTCR_ddc_bist_rme_mask                             (0x00000010)
+#define DDC1_DDC_BISTCR_ddc_bist_rm_mask                              (0x0000000F)
+#define DDC1_DDC_BISTCR_ddc_bist_rme(data)                            (0x00000010&((data)<<4))
+#define DDC1_DDC_BISTCR_ddc_bist_rm(data)                             (0x0000000F&(data))
+#define DDC1_DDC_BISTCR_get_ddc_bist_rme(data)                        ((0x00000010&(data))>>4)
+#define DDC1_DDC_BISTCR_get_ddc_bist_rm(data)                         (0x0000000F&(data))
+
+
+#define DDC1_DDC_SCR                                                  0x2c
+#define DDC1_DDC_SCR_reg_addr                                         "0x9803772c"
+#define DDC1_DDC_SCR_reg                                              0x9803772c
+#define DDC1_DDC_SCR_inst_addr                                        "0x01CB"
+#define DDC1_DDC_SCR_inst                                             0x01CB
+#define DDC1_DDC_SCR_segpt_latie_shift                                (7)
+#define DDC1_DDC_SCR_dataoutputdelay_sel_shift                        (4)
+#define DDC1_DDC_SCR_i2c_m_rd_st_sts_shift                            (2)
+#define DDC1_DDC_SCR_i2c_m_rd_sp_sts_shift                            (1)
+#define DDC1_DDC_SCR_sgid_en_shift                                    (0)
+#define DDC1_DDC_SCR_segpt_latie_mask                                 (0x00000080)
+#define DDC1_DDC_SCR_dataoutputdelay_sel_mask                         (0x00000070)
+#define DDC1_DDC_SCR_i2c_m_rd_st_sts_mask                             (0x00000004)
+#define DDC1_DDC_SCR_i2c_m_rd_sp_sts_mask                             (0x00000002)
+#define DDC1_DDC_SCR_sgid_en_mask                                     (0x00000001)
+#define DDC1_DDC_SCR_segpt_latie(data)                                (0x00000080&((data)<<7))
+#define DDC1_DDC_SCR_dataoutputdelay_sel(data)                        (0x00000070&((data)<<4))
+#define DDC1_DDC_SCR_i2c_m_rd_st_sts(data)                            (0x00000004&((data)<<2))
+#define DDC1_DDC_SCR_i2c_m_rd_sp_sts(data)                            (0x00000002&((data)<<1))
+#define DDC1_DDC_SCR_sgid_en(data)                                    (0x00000001&(data))
+#define DDC1_DDC_SCR_get_segpt_latie(data)                            ((0x00000080&(data))>>7)
+#define DDC1_DDC_SCR_get_dataoutputdelay_sel(data)                    ((0x00000070&(data))>>4)
+#define DDC1_DDC_SCR_get_i2c_m_rd_st_sts(data)                        ((0x00000004&(data))>>2)
+#define DDC1_DDC_SCR_get_i2c_m_rd_sp_sts(data)                        ((0x00000002&(data))>>1)
+#define DDC1_DDC_SCR_get_sgid_en(data)                                (0x00000001&(data))
+
+
+#define DDC1_DDC_SSAR                                                 0x30
+#define DDC1_DDC_SSAR_reg_addr                                        "0x98037730"
+#define DDC1_DDC_SSAR_reg                                             0x98037730
+#define DDC1_DDC_SSAR_inst_addr                                       "0x01CC"
+#define DDC1_DDC_SSAR_inst                                            0x01CC
+#define DDC1_DDC_SSAR_sgid_address_shift                              (1)
+#define DDC1_DDC_SSAR_sgid_dtrden_shift                               (0)
+#define DDC1_DDC_SSAR_sgid_address_mask                               (0x000000FE)
+#define DDC1_DDC_SSAR_sgid_dtrden_mask                                (0x00000001)
+#define DDC1_DDC_SSAR_sgid_address(data)                              (0x000000FE&((data)<<1))
+#define DDC1_DDC_SSAR_sgid_dtrden(data)                               (0x00000001&(data))
+#define DDC1_DDC_SSAR_get_sgid_address(data)                          ((0x000000FE&(data))>>1)
+#define DDC1_DDC_SSAR_get_sgid_dtrden(data)                           (0x00000001&(data))
+
+
+#define DDC1_DDC_SPR                                                  0x34
+#define DDC1_DDC_SPR_reg_addr                                         "0x98037734"
+#define DDC1_DDC_SPR_reg                                              0x98037734
+#define DDC1_DDC_SPR_inst_addr                                        "0x01CD"
+#define DDC1_DDC_SPR_inst                                             0x01CD
+#define DDC1_DDC_SPR_segpt_latched_shift                              (7)
+#define DDC1_DDC_SPR_seg_pt_shift                                     (0)
+#define DDC1_DDC_SPR_segpt_latched_mask                               (0x00000080)
+#define DDC1_DDC_SPR_seg_pt_mask                                      (0x0000007F)
+#define DDC1_DDC_SPR_segpt_latched(data)                              (0x00000080&((data)<<7))
+#define DDC1_DDC_SPR_seg_pt(data)                                     (0x0000007F&(data))
+#define DDC1_DDC_SPR_get_segpt_latched(data)                          ((0x00000080&(data))>>7)
+#define DDC1_DDC_SPR_get_seg_pt(data)                                 (0x0000007F&(data))
+
+
+#define DDC1_DDC_SFCR                                                 0x38
+#define DDC1_DDC_SFCR_reg_addr                                        "0x98037738"
+#define DDC1_DDC_SFCR_reg                                             0x98037738
+#define DDC1_DDC_SFCR_inst_addr                                       "0x01CE"
+#define DDC1_DDC_SFCR_inst                                            0x01CE
+#define DDC1_DDC_SFCR_special_mode_shift                              (3)
+#define DDC1_DDC_SFCR_doffpt_reset_shift                              (2)
+#define DDC1_DDC_SFCR_diffpt_reset_shift                              (1)
+#define DDC1_DDC_SFCR_ciid_en_shift                                   (0)
+#define DDC1_DDC_SFCR_special_mode_mask                               (0x00000008)
+#define DDC1_DDC_SFCR_doffpt_reset_mask                               (0x00000004)
+#define DDC1_DDC_SFCR_diffpt_reset_mask                               (0x00000002)
+#define DDC1_DDC_SFCR_ciid_en_mask                                    (0x00000001)
+#define DDC1_DDC_SFCR_special_mode(data)                              (0x00000008&((data)<<3))
+#define DDC1_DDC_SFCR_doffpt_reset(data)                              (0x00000004&((data)<<2))
+#define DDC1_DDC_SFCR_diffpt_reset(data)                              (0x00000002&((data)<<1))
+#define DDC1_DDC_SFCR_ciid_en(data)                                   (0x00000001&(data))
+#define DDC1_DDC_SFCR_get_special_mode(data)                          ((0x00000008&(data))>>3)
+#define DDC1_DDC_SFCR_get_doffpt_reset(data)                          ((0x00000004&(data))>>2)
+#define DDC1_DDC_SFCR_get_diffpt_reset(data)                          ((0x00000002&(data))>>1)
+#define DDC1_DDC_SFCR_get_ciid_en(data)                               (0x00000001&(data))
+
+
+#define DDC1_DDC_SFSAR                                                0x3c
+#define DDC1_DDC_SFSAR_reg_addr                                       "0x9803773c"
+#define DDC1_DDC_SFSAR_reg                                            0x9803773c
+#define DDC1_DDC_SFSAR_inst_addr                                      "0x01CF"
+#define DDC1_DDC_SFSAR_inst                                           0x01CF
+#define DDC1_DDC_SFSAR_ciid_address_shift                             (1)
+#define DDC1_DDC_SFSAR_cirws_current_shift                            (0)
+#define DDC1_DDC_SFSAR_ciid_address_mask                              (0x000000FE)
+#define DDC1_DDC_SFSAR_cirws_current_mask                             (0x00000001)
+#define DDC1_DDC_SFSAR_ciid_address(data)                             (0x000000FE&((data)<<1))
+#define DDC1_DDC_SFSAR_cirws_current(data)                            (0x00000001&(data))
+#define DDC1_DDC_SFSAR_get_ciid_address(data)                         ((0x000000FE&(data))>>1)
+#define DDC1_DDC_SFSAR_get_cirws_current(data)                        (0x00000001&(data))
+
+
+#define DDC1_DDC_SFDR                                                 0x40
+#define DDC1_DDC_SFDR_reg_addr                                        "0x98037740"
+#define DDC1_DDC_SFDR_reg                                             0x98037740
+#define DDC1_DDC_SFDR_inst_addr                                       "0x01D0"
+#define DDC1_DDC_SFDR_inst                                            0x01D0
+#define DDC1_DDC_SFDR_ciiddp_shift                                    (0)
+#define DDC1_DDC_SFDR_ciiddp_mask                                     (0x000000FF)
+#define DDC1_DDC_SFDR_ciiddp(data)                                    (0x000000FF&(data))
+#define DDC1_DDC_SFDR_get_ciiddp(data)                                (0x000000FF&(data))
+
+
+#define DDC1_DDC_SFBSR                                                0x44
+#define DDC1_DDC_SFBSR_reg_addr                                       "0x98037744"
+#define DDC1_DDC_SFBSR_reg                                            0x98037744
+#define DDC1_DDC_SFBSR_inst_addr                                      "0x01D1"
+#define DDC1_DDC_SFBSR_inst                                           0x01D1
+#define DDC1_DDC_SFBSR_cirws_2nd_shift                                (5)
+#define DDC1_DDC_SFBSR_cirws_1st_shift                                (4)
+#define DDC1_DDC_SFBSR_cippt_2nd_shift                                (3)
+#define DDC1_DDC_SFBSR_cispt_2nd_shift                                (2)
+#define DDC1_DDC_SFBSR_cippt_1st_shift                                (1)
+#define DDC1_DDC_SFBSR_cispt_1st_shift                                (0)
+#define DDC1_DDC_SFBSR_cirws_2nd_mask                                 (0x00000020)
+#define DDC1_DDC_SFBSR_cirws_1st_mask                                 (0x00000010)
+#define DDC1_DDC_SFBSR_cippt_2nd_mask                                 (0x00000008)
+#define DDC1_DDC_SFBSR_cispt_2nd_mask                                 (0x00000004)
+#define DDC1_DDC_SFBSR_cippt_1st_mask                                 (0x00000002)
+#define DDC1_DDC_SFBSR_cispt_1st_mask                                 (0x00000001)
+#define DDC1_DDC_SFBSR_cirws_2nd(data)                                (0x00000020&((data)<<5))
+#define DDC1_DDC_SFBSR_cirws_1st(data)                                (0x00000010&((data)<<4))
+#define DDC1_DDC_SFBSR_cippt_2nd(data)                                (0x00000008&((data)<<3))
+#define DDC1_DDC_SFBSR_cispt_2nd(data)                                (0x00000004&((data)<<2))
+#define DDC1_DDC_SFBSR_cippt_1st(data)                                (0x00000002&((data)<<1))
+#define DDC1_DDC_SFBSR_cispt_1st(data)                                (0x00000001&(data))
+#define DDC1_DDC_SFBSR_get_cirws_2nd(data)                            ((0x00000020&(data))>>5)
+#define DDC1_DDC_SFBSR_get_cirws_1st(data)                            ((0x00000010&(data))>>4)
+#define DDC1_DDC_SFBSR_get_cippt_2nd(data)                            ((0x00000008&(data))>>3)
+#define DDC1_DDC_SFBSR_get_cispt_2nd(data)                            ((0x00000004&(data))>>2)
+#define DDC1_DDC_SFBSR_get_cippt_1st(data)                            ((0x00000002&(data))>>1)
+#define DDC1_DDC_SFBSR_get_cispt_1st(data)                            (0x00000001&(data))
+
+
+#define DDC1_DDC_SFIBLR                                               0x48
+#define DDC1_DDC_SFIBLR_reg_addr                                      "0x98037748"
+#define DDC1_DDC_SFIBLR_reg                                           0x98037748
+#define DDC1_DDC_SFIBLR_inst_addr                                     "0x01D2"
+#define DDC1_DDC_SFIBLR_inst                                          0x01D2
+#define DDC1_DDC_SFIBLR_ffdi_dlen_shift                               (0)
+#define DDC1_DDC_SFIBLR_ffdi_dlen_mask                                (0x0000001F)
+#define DDC1_DDC_SFIBLR_ffdi_dlen(data)                               (0x0000001F&(data))
+#define DDC1_DDC_SFIBLR_get_ffdi_dlen(data)                           (0x0000001F&(data))
+
+
+#define DDC1_DDC_SFIBRWPR                                             0x4c
+#define DDC1_DDC_SFIBRWPR_reg_addr                                    "0x9803774c"
+#define DDC1_DDC_SFIBRWPR_reg                                         0x9803774c
+#define DDC1_DDC_SFIBRWPR_inst_addr                                   "0x01D3"
+#define DDC1_DDC_SFIBRWPR_inst                                        0x01D3
+#define DDC1_DDC_SFIBRWPR_diff_wpt_shift                              (4)
+#define DDC1_DDC_SFIBRWPR_diff_rpt_shift                              (0)
+#define DDC1_DDC_SFIBRWPR_diff_wpt_mask                               (0x000000F0)
+#define DDC1_DDC_SFIBRWPR_diff_rpt_mask                               (0x0000000F)
+#define DDC1_DDC_SFIBRWPR_diff_wpt(data)                              (0x000000F0&((data)<<4))
+#define DDC1_DDC_SFIBRWPR_diff_rpt(data)                              (0x0000000F&(data))
+#define DDC1_DDC_SFIBRWPR_get_diff_wpt(data)                          ((0x000000F0&(data))>>4)
+#define DDC1_DDC_SFIBRWPR_get_diff_rpt(data)                          (0x0000000F&(data))
+
+
+#define DDC1_DDC_SFIBSWPR                                             0x50
+#define DDC1_DDC_SFIBSWPR_reg_addr                                    "0x98037750"
+#define DDC1_DDC_SFIBSWPR_reg                                         0x98037750
+#define DDC1_DDC_SFIBSWPR_inst_addr                                   "0x01D4"
+#define DDC1_DDC_SFIBSWPR_inst                                        0x01D4
+#define DDC1_DDC_SFIBSWPR_diffstop_pt_shift                           (0)
+#define DDC1_DDC_SFIBSWPR_diffstop_pt_mask                            (0x0000000F)
+#define DDC1_DDC_SFIBSWPR_diffstop_pt(data)                           (0x0000000F&(data))
+#define DDC1_DDC_SFIBSWPR_get_diffstop_pt(data)                       (0x0000000F&(data))
+
+
+#define DDC1_DDC_SFOBSR                                               0x54
+#define DDC1_DDC_SFOBSR_reg_addr                                      "0x98037754"
+#define DDC1_DDC_SFOBSR_reg                                           0x98037754
+#define DDC1_DDC_SFOBSR_inst_addr                                     "0x01D5"
+#define DDC1_DDC_SFOBSR_inst                                          0x01D5
+#define DDC1_DDC_SFOBSR_ffdo_dlen_shift                               (0)
+#define DDC1_DDC_SFOBSR_ffdo_dlen_mask                                (0x0000001F)
+#define DDC1_DDC_SFOBSR_ffdo_dlen(data)                               (0x0000001F&(data))
+#define DDC1_DDC_SFOBSR_get_ffdo_dlen(data)                           (0x0000001F&(data))
+
+
+#define DDC1_DDC_SFOBRWPR                                             0x58
+#define DDC1_DDC_SFOBRWPR_reg_addr                                    "0x98037758"
+#define DDC1_DDC_SFOBRWPR_reg                                         0x98037758
+#define DDC1_DDC_SFOBRWPR_inst_addr                                   "0x01D6"
+#define DDC1_DDC_SFOBRWPR_inst                                        0x01D6
+#define DDC1_DDC_SFOBRWPR_doff_wpt_shift                              (4)
+#define DDC1_DDC_SFOBRWPR_doff_rpt_shift                              (0)
+#define DDC1_DDC_SFOBRWPR_doff_wpt_mask                               (0x000000F0)
+#define DDC1_DDC_SFOBRWPR_doff_rpt_mask                               (0x0000000F)
+#define DDC1_DDC_SFOBRWPR_doff_wpt(data)                              (0x000000F0&((data)<<4))
+#define DDC1_DDC_SFOBRWPR_doff_rpt(data)                              (0x0000000F&(data))
+#define DDC1_DDC_SFOBRWPR_get_doff_wpt(data)                          ((0x000000F0&(data))>>4)
+#define DDC1_DDC_SFOBRWPR_get_doff_rpt(data)                          (0x0000000F&(data))
+
+
+#define DDC1_DDC_SFSR                                                 0x5c
+#define DDC1_DDC_SFSR_reg_addr                                        "0x9803775c"
+#define DDC1_DDC_SFSR_reg                                             0x9803775c
+#define DDC1_DDC_SFSR_inst_addr                                       "0x01D7"
+#define DDC1_DDC_SFSR_inst                                            0x01D7
+#define DDC1_DDC_SFSR_ffdouf_st_shift                                 (7)
+#define DDC1_DDC_SFSR_ffdiof_st_shift                                 (6)
+#define DDC1_DDC_SFSR_ffdonf_st_shift                                 (5)
+#define DDC1_DDC_SFSR_ffdoet_st_shift                                 (4)
+#define DDC1_DDC_SFSR_ffdifu_st_shift                                 (3)
+#define DDC1_DDC_SFSR_ffdine_st_shift                                 (2)
+#define DDC1_DDC_SFSR_ffdouf_st_mask                                  (0x00000080)
+#define DDC1_DDC_SFSR_ffdiof_st_mask                                  (0x00000040)
+#define DDC1_DDC_SFSR_ffdonf_st_mask                                  (0x00000020)
+#define DDC1_DDC_SFSR_ffdoet_st_mask                                  (0x00000010)
+#define DDC1_DDC_SFSR_ffdifu_st_mask                                  (0x00000008)
+#define DDC1_DDC_SFSR_ffdine_st_mask                                  (0x00000004)
+#define DDC1_DDC_SFSR_ffdouf_st(data)                                 (0x00000080&((data)<<7))
+#define DDC1_DDC_SFSR_ffdiof_st(data)                                 (0x00000040&((data)<<6))
+#define DDC1_DDC_SFSR_ffdonf_st(data)                                 (0x00000020&((data)<<5))
+#define DDC1_DDC_SFSR_ffdoet_st(data)                                 (0x00000010&((data)<<4))
+#define DDC1_DDC_SFSR_ffdifu_st(data)                                 (0x00000008&((data)<<3))
+#define DDC1_DDC_SFSR_ffdine_st(data)                                 (0x00000004&((data)<<2))
+#define DDC1_DDC_SFSR_get_ffdouf_st(data)                             ((0x00000080&(data))>>7)
+#define DDC1_DDC_SFSR_get_ffdiof_st(data)                             ((0x00000040&(data))>>6)
+#define DDC1_DDC_SFSR_get_ffdonf_st(data)                             ((0x00000020&(data))>>5)
+#define DDC1_DDC_SFSR_get_ffdoet_st(data)                             ((0x00000010&(data))>>4)
+#define DDC1_DDC_SFSR_get_ffdifu_st(data)                             ((0x00000008&(data))>>3)
+#define DDC1_DDC_SFSR_get_ffdine_st(data)                             ((0x00000004&(data))>>2)
+
+
+#define DDC1_DDC_SFIR                                                 0x60
+#define DDC1_DDC_SFIR_reg_addr                                        "0x98037760"
+#define DDC1_DDC_SFIR_reg                                             0x98037760
+#define DDC1_DDC_SFIR_inst_addr                                       "0x01D8"
+#define DDC1_DDC_SFIR_inst                                            0x01D8
+#define DDC1_DDC_SFIR_ffdouf_ie_shift                                 (7)
+#define DDC1_DDC_SFIR_ffdiof_ie_shift                                 (6)
+#define DDC1_DDC_SFIR_ffdonf_ie_shift                                 (5)
+#define DDC1_DDC_SFIR_ffdoet_ie_shift                                 (4)
+#define DDC1_DDC_SFIR_ffdifu_ie_shift                                 (3)
+#define DDC1_DDC_SFIR_ffdine_ie_shift                                 (2)
+#define DDC1_DDC_SFIR_cippt_ie_shift                                  (1)
+#define DDC1_DDC_SFIR_cispt_ie_shift                                  (0)
+#define DDC1_DDC_SFIR_ffdouf_ie_mask                                  (0x00000080)
+#define DDC1_DDC_SFIR_ffdiof_ie_mask                                  (0x00000040)
+#define DDC1_DDC_SFIR_ffdonf_ie_mask                                  (0x00000020)
+#define DDC1_DDC_SFIR_ffdoet_ie_mask                                  (0x00000010)
+#define DDC1_DDC_SFIR_ffdifu_ie_mask                                  (0x00000008)
+#define DDC1_DDC_SFIR_ffdine_ie_mask                                  (0x00000004)
+#define DDC1_DDC_SFIR_cippt_ie_mask                                   (0x00000002)
+#define DDC1_DDC_SFIR_cispt_ie_mask                                   (0x00000001)
+#define DDC1_DDC_SFIR_ffdouf_ie(data)                                 (0x00000080&((data)<<7))
+#define DDC1_DDC_SFIR_ffdiof_ie(data)                                 (0x00000040&((data)<<6))
+#define DDC1_DDC_SFIR_ffdonf_ie(data)                                 (0x00000020&((data)<<5))
+#define DDC1_DDC_SFIR_ffdoet_ie(data)                                 (0x00000010&((data)<<4))
+#define DDC1_DDC_SFIR_ffdifu_ie(data)                                 (0x00000008&((data)<<3))
+#define DDC1_DDC_SFIR_ffdine_ie(data)                                 (0x00000004&((data)<<2))
+#define DDC1_DDC_SFIR_cippt_ie(data)                                  (0x00000002&((data)<<1))
+#define DDC1_DDC_SFIR_cispt_ie(data)                                  (0x00000001&(data))
+#define DDC1_DDC_SFIR_get_ffdouf_ie(data)                             ((0x00000080&(data))>>7)
+#define DDC1_DDC_SFIR_get_ffdiof_ie(data)                             ((0x00000040&(data))>>6)
+#define DDC1_DDC_SFIR_get_ffdonf_ie(data)                             ((0x00000020&(data))>>5)
+#define DDC1_DDC_SFIR_get_ffdoet_ie(data)                             ((0x00000010&(data))>>4)
+#define DDC1_DDC_SFIR_get_ffdifu_ie(data)                             ((0x00000008&(data))>>3)
+#define DDC1_DDC_SFIR_get_ffdine_ie(data)                             ((0x00000004&(data))>>2)
+#define DDC1_DDC_SFIR_get_cippt_ie(data)                              ((0x00000002&(data))>>1)
+#define DDC1_DDC_SFIR_get_cispt_ie(data)                              (0x00000001&(data))
+
+
+#define DDC1_DDC_FSMS                                                 0x64
+#define DDC1_DDC_FSMS_reg_addr                                        "0x98037764"
+#define DDC1_DDC_FSMS_reg                                             0x98037764
+#define DDC1_DDC_FSMS_inst_addr                                       "0x01D9"
+#define DDC1_DDC_FSMS_inst                                            0x01D9
+#define DDC1_DDC_FSMS_cmdfsm_st_shift                                 (0)
+#define DDC1_DDC_FSMS_cmdfsm_st_mask                                  (0x000000FF)
+#define DDC1_DDC_FSMS_cmdfsm_st(data)                                 (0x000000FF&(data))
+#define DDC1_DDC_FSMS_get_cmdfsm_st(data)                             (0x000000FF&(data))
+
+
+#define DDC1_DDC_DUMMY                                                0x68
+#define DDC1_DDC_DUMMY_reg_addr                                       "0x98037768"
+#define DDC1_DDC_DUMMY_reg                                            0x98037768
+#define DDC1_DDC_DUMMY_inst_addr                                      "0x01DA"
+#define DDC1_DDC_DUMMY_inst                                           0x01DA
+#define DDC1_DDC_DUMMY_dummy98037768_7_0_shift                        (0)
+#define DDC1_DDC_DUMMY_dummy98037768_7_0_mask                         (0x000000FF)
+#define DDC1_DDC_DUMMY_dummy98037768_7_0(data)                        (0x000000FF&(data))
+#define DDC1_DDC_DUMMY_get_dummy98037768_7_0(data)                    (0x000000FF&(data))
+
+
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN                                0x70
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_reg_addr                       "0x98037770"
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_reg                            0x98037770
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_inst_addr                      "0x01DC"
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_inst                           0x01DC
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_start_irq_en_shift             (1)
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_stop_irq_en_shift              (0)
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_start_irq_en_mask              (0x00000002)
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_stop_irq_en_mask               (0x00000001)
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_start_irq_en(data)             (0x00000002&((data)<<1))
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_stop_irq_en(data)              (0x00000001&(data))
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_get_start_irq_en(data)         ((0x00000002&(data))>>1)
+#define DDC1_DDC_EDID_SRAM_READ_IRQ_EN_get_stop_irq_en(data)          (0x00000001&(data))
+
+
+#define DDC1_DDC_EDID_SRAM_READ_AUX                                   0x74
+#define DDC1_DDC_EDID_SRAM_READ_AUX_reg_addr                          "0x98037774"
+#define DDC1_DDC_EDID_SRAM_READ_AUX_reg                               0x98037774
+#define DDC1_DDC_EDID_SRAM_READ_AUX_inst_addr                         "0x01DD"
+#define DDC1_DDC_EDID_SRAM_READ_AUX_inst                              0x01DD
+#define DDC1_DDC_EDID_SRAM_READ_AUX_start_shift                       (1)
+#define DDC1_DDC_EDID_SRAM_READ_AUX_stop_shift                        (0)
+#define DDC1_DDC_EDID_SRAM_READ_AUX_start_mask                        (0x00000002)
+#define DDC1_DDC_EDID_SRAM_READ_AUX_stop_mask                         (0x00000001)
+#define DDC1_DDC_EDID_SRAM_READ_AUX_start(data)                       (0x00000002&((data)<<1))
+#define DDC1_DDC_EDID_SRAM_READ_AUX_stop(data)                        (0x00000001&(data))
+#define DDC1_DDC_EDID_SRAM_READ_AUX_get_start(data)                   ((0x00000002&(data))>>1)
+#define DDC1_DDC_EDID_SRAM_READ_AUX_get_stop(data)                    (0x00000001&(data))
+
+
+#define DDC1_DDC_BIST_MODE                                            0x78
+#define DDC1_DDC_BIST_MODE_reg_addr                                   "0x98037778"
+#define DDC1_DDC_BIST_MODE_reg                                        0x98037778
+#define DDC1_DDC_BIST_MODE_inst_addr                                  "0x01DE"
+#define DDC1_DDC_BIST_MODE_inst                                       0x01DE
+#define DDC1_DDC_BIST_MODE_ddc_bist_mode_shift                        (0)
+#define DDC1_DDC_BIST_MODE_ddc_bist_mode_mask                         (0x00000001)
+#define DDC1_DDC_BIST_MODE_ddc_bist_mode(data)                        (0x00000001&(data))
+#define DDC1_DDC_BIST_MODE_get_ddc_bist_mode(data)                    (0x00000001&(data))
+
+
+#define DDC1_DDC_BIST_DONE                                            0x7c
+#define DDC1_DDC_BIST_DONE_reg_addr                                   "0x9803777c"
+#define DDC1_DDC_BIST_DONE_reg                                        0x9803777c
+#define DDC1_DDC_BIST_DONE_inst_addr                                  "0x01DF"
+#define DDC1_DDC_BIST_DONE_inst                                       0x01DF
+#define DDC1_DDC_BIST_DONE_ddc_bist_done_shift                        (0)
+#define DDC1_DDC_BIST_DONE_ddc_bist_done_mask                         (0x00000001)
+#define DDC1_DDC_BIST_DONE_ddc_bist_done(data)                        (0x00000001&(data))
+#define DDC1_DDC_BIST_DONE_get_ddc_bist_done(data)                    (0x00000001&(data))
+
+
+#define DDC1_DDC_BIST_FAIL                                            0x80
+#define DDC1_DDC_BIST_FAIL_reg_addr                                   "0x98037780"
+#define DDC1_DDC_BIST_FAIL_reg                                        0x98037780
+#define DDC1_DDC_BIST_FAIL_inst_addr                                  "0x01E0"
+#define DDC1_DDC_BIST_FAIL_inst                                       0x01E0
+#define DDC1_DDC_BIST_FAIL_ddc_bist_fail_shift                        (0)
+#define DDC1_DDC_BIST_FAIL_ddc_bist_fail_mask                         (0x00000001)
+#define DDC1_DDC_BIST_FAIL_ddc_bist_fail(data)                        (0x00000001&(data))
+#define DDC1_DDC_BIST_FAIL_get_ddc_bist_fail(data)                    (0x00000001&(data))
+
+
+#define DDC1_DDC_DRF_MODE                                             0x84
+#define DDC1_DDC_DRF_MODE_reg_addr                                    "0x98037784"
+#define DDC1_DDC_DRF_MODE_reg                                         0x98037784
+#define DDC1_DDC_DRF_MODE_inst_addr                                   "0x01E1"
+#define DDC1_DDC_DRF_MODE_inst                                        0x01E1
+#define DDC1_DDC_DRF_MODE_ddc_drf_mode_shift                          (0)
+#define DDC1_DDC_DRF_MODE_ddc_drf_mode_mask                           (0x00000001)
+#define DDC1_DDC_DRF_MODE_ddc_drf_mode(data)                          (0x00000001&(data))
+#define DDC1_DDC_DRF_MODE_get_ddc_drf_mode(data)                      (0x00000001&(data))
+
+
+#define DDC1_DDC_DRF_RESUME                                           0x88
+#define DDC1_DDC_DRF_RESUME_reg_addr                                  "0x98037788"
+#define DDC1_DDC_DRF_RESUME_reg                                       0x98037788
+#define DDC1_DDC_DRF_RESUME_inst_addr                                 "0x01E2"
+#define DDC1_DDC_DRF_RESUME_inst                                      0x01E2
+#define DDC1_DDC_DRF_RESUME_ddc_drf_resume_shift                      (0)
+#define DDC1_DDC_DRF_RESUME_ddc_drf_resume_mask                       (0x00000001)
+#define DDC1_DDC_DRF_RESUME_ddc_drf_resume(data)                      (0x00000001&(data))
+#define DDC1_DDC_DRF_RESUME_get_ddc_drf_resume(data)                  (0x00000001&(data))
+
+
+#define DDC1_DDC_DRF_DONE                                             0x8c
+#define DDC1_DDC_DRF_DONE_reg_addr                                    "0x9803778c"
+#define DDC1_DDC_DRF_DONE_reg                                         0x9803778c
+#define DDC1_DDC_DRF_DONE_inst_addr                                   "0x01E3"
+#define DDC1_DDC_DRF_DONE_inst                                        0x01E3
+#define DDC1_DDC_DRF_DONE_ddc_drf_done_shift                          (0)
+#define DDC1_DDC_DRF_DONE_ddc_drf_done_mask                           (0x00000001)
+#define DDC1_DDC_DRF_DONE_ddc_drf_done(data)                          (0x00000001&(data))
+#define DDC1_DDC_DRF_DONE_get_ddc_drf_done(data)                      (0x00000001&(data))
+
+
+#define DDC1_DDC_DRF_PAUSE                                            0x90
+#define DDC1_DDC_DRF_PAUSE_reg_addr                                   "0x98037790"
+#define DDC1_DDC_DRF_PAUSE_reg                                        0x98037790
+#define DDC1_DDC_DRF_PAUSE_inst_addr                                  "0x01E4"
+#define DDC1_DDC_DRF_PAUSE_inst                                       0x01E4
+#define DDC1_DDC_DRF_PAUSE_ddc_drf_pause_shift                        (0)
+#define DDC1_DDC_DRF_PAUSE_ddc_drf_pause_mask                         (0x00000001)
+#define DDC1_DDC_DRF_PAUSE_ddc_drf_pause(data)                        (0x00000001&(data))
+#define DDC1_DDC_DRF_PAUSE_get_ddc_drf_pause(data)                    (0x00000001&(data))
+
+
+#define DDC1_DDC_DRF_FAIL                                             0x94
+#define DDC1_DDC_DRF_FAIL_reg_addr                                    "0x98037794"
+#define DDC1_DDC_DRF_FAIL_reg                                         0x98037794
+#define DDC1_DDC_DRF_FAIL_inst_addr                                   "0x01E5"
+#define DDC1_DDC_DRF_FAIL_inst                                        0x01E5
+#define DDC1_DDC_DRF_FAIL_ddc_drf_fail_shift                          (0)
+#define DDC1_DDC_DRF_FAIL_ddc_drf_fail_mask                           (0x00000001)
+#define DDC1_DDC_DRF_FAIL_ddc_drf_fail(data)                          (0x00000001&(data))
+#define DDC1_DDC_DRF_FAIL_get_ddc_drf_fail(data)                      (0x00000001&(data))
+#endif//_DDC_REG_H_INCLUDED_
\ No newline at end of file
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/HDMI_fw.h b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/HDMI_fw.h
new file mode 100644
index 00000000..ae2edc2
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/HDMI_fw.h
@@ -0,0 +1,5515 @@
+/*
+ * HDMI_fw.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDMI_P0_REG_H_INCLUDED_
+#define _HDMI_P0_REG_H_INCLUDED_
+
+#define HDMI_TMDS_MSR0                                               0x000
+#define HDMI_TMDS_MSR0_reg_addr                                      "0x98034000"
+#define HDMI_TMDS_MSR0_reg                                           0x98034000
+#define HDMI_TMDS_MSR0_inst_addr                                     "0x0000"
+#define HDMI_TMDS_MSR0_inst                                          0x0000
+#define HDMI_TMDS_MSR0_tmm_shift                                     (7)
+#define HDMI_TMDS_MSR0_mt_shift                                      (4)
+#define HDMI_TMDS_MSR0_ncp_shift                                     (0)
+#define HDMI_TMDS_MSR0_tmm_mask                                      (0x00000080)
+#define HDMI_TMDS_MSR0_mt_mask                                       (0x00000070)
+#define HDMI_TMDS_MSR0_ncp_mask                                      (0x0000000F)
+#define HDMI_TMDS_MSR0_tmm(data)                                     (0x00000080&((data)<<7))
+#define HDMI_TMDS_MSR0_mt(data)                                      (0x00000070&((data)<<4))
+#define HDMI_TMDS_MSR0_ncp(data)                                     (0x0000000F&(data))
+#define HDMI_TMDS_MSR0_get_tmm(data)                                 ((0x00000080&(data))>>7)
+#define HDMI_TMDS_MSR0_get_mt(data)                                  ((0x00000070&(data))>>4)
+#define HDMI_TMDS_MSR0_get_ncp(data)                                 (0x0000000F&(data))
+
+
+#define HDMI_TMDS_MSR1                                               0x004
+#define HDMI_TMDS_MSR1_reg_addr                                      "0x98034004"
+#define HDMI_TMDS_MSR1_reg                                           0x98034004
+#define HDMI_TMDS_MSR1_inst_addr                                     "0x0001"
+#define HDMI_TMDS_MSR1_inst                                          0x0001
+#define HDMI_TMDS_MSR1_tms_shift                                     (12)
+#define HDMI_TMDS_MSR1_mrs_shift                                     (10)
+#define HDMI_TMDS_MSR1_ms_shift                                      (8)
+#define HDMI_TMDS_MSR1_ctc_shift                                     (7)
+#define HDMI_TMDS_MSR1_vmr_shift                                     (0)
+#define HDMI_TMDS_MSR1_tms_mask                                      (0x00001000)
+#define HDMI_TMDS_MSR1_mrs_mask                                      (0x00000C00)
+#define HDMI_TMDS_MSR1_ms_mask                                       (0x00000300)
+#define HDMI_TMDS_MSR1_ctc_mask                                      (0x00000080)
+#define HDMI_TMDS_MSR1_vmr_mask                                      (0x0000007F)
+#define HDMI_TMDS_MSR1_tms(data)                                     (0x00001000&((data)<<12))
+#define HDMI_TMDS_MSR1_mrs(data)                                     (0x00000C00&((data)<<10))
+#define HDMI_TMDS_MSR1_ms(data)                                      (0x00000300&((data)<<8))
+#define HDMI_TMDS_MSR1_ctc(data)                                     (0x00000080&((data)<<7))
+#define HDMI_TMDS_MSR1_vmr(data)                                     (0x0000007F&(data))
+#define HDMI_TMDS_MSR1_get_tms(data)                                 ((0x00001000&(data))>>12)
+#define HDMI_TMDS_MSR1_get_mrs(data)                                 ((0x00000C00&(data))>>10)
+#define HDMI_TMDS_MSR1_get_ms(data)                                  ((0x00000300&(data))>>8)
+#define HDMI_TMDS_MSR1_get_ctc(data)                                 ((0x00000080&(data))>>7)
+#define HDMI_TMDS_MSR1_get_vmr(data)                                 (0x0000007F&(data))
+
+
+#define HDMI_TMDS_CRCC                                               0x008
+#define HDMI_TMDS_CRCC_reg_addr                                      "0x98034008"
+#define HDMI_TMDS_CRCC_reg                                           0x98034008
+#define HDMI_TMDS_CRCC_inst_addr                                     "0x0002"
+#define HDMI_TMDS_CRCC_inst                                          0x0002
+#define HDMI_TMDS_CRCC_crc_r_en_shift                                (7)
+#define HDMI_TMDS_CRCC_crc_g_en_shift                                (6)
+#define HDMI_TMDS_CRCC_crc_b_en_shift                                (5)
+#define HDMI_TMDS_CRCC_crc_done_shift                                (4)
+#define HDMI_TMDS_CRCC_crc_nonstable_shift                           (3)
+#define HDMI_TMDS_CRCC_crcts_shift                                   (1)
+#define HDMI_TMDS_CRCC_crcc_shift                                    (0)
+#define HDMI_TMDS_CRCC_crc_r_en_mask                                 (0x00000080)
+#define HDMI_TMDS_CRCC_crc_g_en_mask                                 (0x00000040)
+#define HDMI_TMDS_CRCC_crc_b_en_mask                                 (0x00000020)
+#define HDMI_TMDS_CRCC_crc_done_mask                                 (0x00000010)
+#define HDMI_TMDS_CRCC_crc_nonstable_mask                            (0x00000008)
+#define HDMI_TMDS_CRCC_crcts_mask                                    (0x00000006)
+#define HDMI_TMDS_CRCC_crcc_mask                                     (0x00000001)
+#define HDMI_TMDS_CRCC_crc_r_en(data)                                (0x00000080&((data)<<7))
+#define HDMI_TMDS_CRCC_crc_g_en(data)                                (0x00000040&((data)<<6))
+#define HDMI_TMDS_CRCC_crc_b_en(data)                                (0x00000020&((data)<<5))
+#define HDMI_TMDS_CRCC_crc_done(data)                                (0x00000010&((data)<<4))
+#define HDMI_TMDS_CRCC_crc_nonstable(data)                           (0x00000008&((data)<<3))
+#define HDMI_TMDS_CRCC_crcts(data)                                   (0x00000006&((data)<<1))
+#define HDMI_TMDS_CRCC_crcc(data)                                    (0x00000001&(data))
+#define HDMI_TMDS_CRCC_get_crc_r_en(data)                            ((0x00000080&(data))>>7)
+#define HDMI_TMDS_CRCC_get_crc_g_en(data)                            ((0x00000040&(data))>>6)
+#define HDMI_TMDS_CRCC_get_crc_b_en(data)                            ((0x00000020&(data))>>5)
+#define HDMI_TMDS_CRCC_get_crc_done(data)                            ((0x00000010&(data))>>4)
+#define HDMI_TMDS_CRCC_get_crc_nonstable(data)                       ((0x00000008&(data))>>3)
+#define HDMI_TMDS_CRCC_get_crcts(data)                               ((0x00000006&(data))>>1)
+#define HDMI_TMDS_CRCC_get_crcc(data)                                (0x00000001&(data))
+
+
+#define HDMI_TMDS_CRCO0                                              0x00c
+#define HDMI_TMDS_CRCO0_reg_addr                                     "0x9803400c"
+#define HDMI_TMDS_CRCO0_reg                                          0x9803400c
+#define HDMI_TMDS_CRCO0_inst_addr                                    "0x0003"
+#define HDMI_TMDS_CRCO0_inst                                         0x0003
+#define HDMI_TMDS_CRCO0_crcob2_3_shift                               (16)
+#define HDMI_TMDS_CRCO0_crcob2_2_shift                               (8)
+#define HDMI_TMDS_CRCO0_crcob2_1_shift                               (0)
+#define HDMI_TMDS_CRCO0_crcob2_3_mask                                (0x00FF0000)
+#define HDMI_TMDS_CRCO0_crcob2_2_mask                                (0x0000FF00)
+#define HDMI_TMDS_CRCO0_crcob2_1_mask                                (0x000000FF)
+#define HDMI_TMDS_CRCO0_crcob2_3(data)                               (0x00FF0000&((data)<<16))
+#define HDMI_TMDS_CRCO0_crcob2_2(data)                               (0x0000FF00&((data)<<8))
+#define HDMI_TMDS_CRCO0_crcob2_1(data)                               (0x000000FF&(data))
+#define HDMI_TMDS_CRCO0_get_crcob2_3(data)                           ((0x00FF0000&(data))>>16)
+#define HDMI_TMDS_CRCO0_get_crcob2_2(data)                           ((0x0000FF00&(data))>>8)
+#define HDMI_TMDS_CRCO0_get_crcob2_1(data)                           (0x000000FF&(data))
+
+
+#define HDMI_TMDS_CRCO1                                              0x010
+#define HDMI_TMDS_CRCO1_reg_addr                                     "0x98034010"
+#define HDMI_TMDS_CRCO1_reg                                          0x98034010
+#define HDMI_TMDS_CRCO1_inst_addr                                    "0x0004"
+#define HDMI_TMDS_CRCO1_inst                                         0x0004
+#define HDMI_TMDS_CRCO1_crcob2_6_shift                               (16)
+#define HDMI_TMDS_CRCO1_crcob2_5_shift                               (8)
+#define HDMI_TMDS_CRCO1_crcob2_4_shift                               (0)
+#define HDMI_TMDS_CRCO1_crcob2_6_mask                                (0x00FF0000)
+#define HDMI_TMDS_CRCO1_crcob2_5_mask                                (0x0000FF00)
+#define HDMI_TMDS_CRCO1_crcob2_4_mask                                (0x000000FF)
+#define HDMI_TMDS_CRCO1_crcob2_6(data)                               (0x00FF0000&((data)<<16))
+#define HDMI_TMDS_CRCO1_crcob2_5(data)                               (0x0000FF00&((data)<<8))
+#define HDMI_TMDS_CRCO1_crcob2_4(data)                               (0x000000FF&(data))
+#define HDMI_TMDS_CRCO1_get_crcob2_6(data)                           ((0x00FF0000&(data))>>16)
+#define HDMI_TMDS_CRCO1_get_crcob2_5(data)                           ((0x0000FF00&(data))>>8)
+#define HDMI_TMDS_CRCO1_get_crcob2_4(data)                           (0x000000FF&(data))
+
+
+#define HDMI_TMDS_CTRL                                               0x014
+#define HDMI_TMDS_CTRL_reg_addr                                      "0x98034014"
+#define HDMI_TMDS_CTRL_reg                                           0x98034014
+#define HDMI_TMDS_CTRL_inst_addr                                     "0x0005"
+#define HDMI_TMDS_CTRL_inst                                          0x0005
+#define HDMI_TMDS_CTRL_bcd_shift                                     (7)
+#define HDMI_TMDS_CTRL_gcd_shift                                     (6)
+#define HDMI_TMDS_CTRL_rcd_shift                                     (5)
+#define HDMI_TMDS_CTRL_ho_shift                                      (4)
+#define HDMI_TMDS_CTRL_yo_shift                                      (3)
+#define HDMI_TMDS_CTRL_dummy98034014_2_0_shift                       (0)
+#define HDMI_TMDS_CTRL_bcd_mask                                      (0x00000080)
+#define HDMI_TMDS_CTRL_gcd_mask                                      (0x00000040)
+#define HDMI_TMDS_CTRL_rcd_mask                                      (0x00000020)
+#define HDMI_TMDS_CTRL_ho_mask                                       (0x00000010)
+#define HDMI_TMDS_CTRL_yo_mask                                       (0x00000008)
+#define HDMI_TMDS_CTRL_dummy98034014_2_0_mask                        (0x00000007)
+#define HDMI_TMDS_CTRL_bcd(data)                                     (0x00000080&((data)<<7))
+#define HDMI_TMDS_CTRL_gcd(data)                                     (0x00000040&((data)<<6))
+#define HDMI_TMDS_CTRL_rcd(data)                                     (0x00000020&((data)<<5))
+#define HDMI_TMDS_CTRL_ho(data)                                      (0x00000010&((data)<<4))
+#define HDMI_TMDS_CTRL_yo(data)                                      (0x00000008&((data)<<3))
+#define HDMI_TMDS_CTRL_dummy98034014_2_0(data)                       (0x00000007&(data))
+#define HDMI_TMDS_CTRL_get_bcd(data)                                 ((0x00000080&(data))>>7)
+#define HDMI_TMDS_CTRL_get_gcd(data)                                 ((0x00000040&(data))>>6)
+#define HDMI_TMDS_CTRL_get_rcd(data)                                 ((0x00000020&(data))>>5)
+#define HDMI_TMDS_CTRL_get_ho(data)                                  ((0x00000010&(data))>>4)
+#define HDMI_TMDS_CTRL_get_yo(data)                                  ((0x00000008&(data))>>3)
+#define HDMI_TMDS_CTRL_get_dummy98034014_2_0(data)                   (0x00000007&(data))
+#define HDMI_TMDS_CTRL_rgbcd_mask                       (_BIT7|_BIT6|_BIT5)
+
+
+#define HDMI_TMDS_OUTCTL                                             0x018
+#define HDMI_TMDS_OUTCTL_reg_addr                                    "0x98034018"
+#define HDMI_TMDS_OUTCTL_reg                                         0x98034018
+#define HDMI_TMDS_OUTCTL_inst_addr                                   "0x0006"
+#define HDMI_TMDS_OUTCTL_inst                                        0x0006
+#define HDMI_TMDS_OUTCTL_trcoe_r_shift                               (13)
+#define HDMI_TMDS_OUTCTL_tgcoe_r_shift                               (12)
+#define HDMI_TMDS_OUTCTL_tbcoe_r_shift                               (11)
+#define HDMI_TMDS_OUTCTL_ocke_r_shift                                (10)
+#define HDMI_TMDS_OUTCTL_aoe_shift                                   (9)
+#define HDMI_TMDS_OUTCTL_trcoe_shift                                 (8)
+#define HDMI_TMDS_OUTCTL_tgcoe_shift                                 (7)
+#define HDMI_TMDS_OUTCTL_tbcoe_shift                                 (6)
+#define HDMI_TMDS_OUTCTL_ocke_shift                                  (5)
+#define HDMI_TMDS_OUTCTL_ockie_shift                                 (4)
+#define HDMI_TMDS_OUTCTL_focke_shift                                 (3)
+#define HDMI_TMDS_OUTCTL_cbus_dbg_cke_shift                          (2)
+#define HDMI_TMDS_OUTCTL_dummy98034018_1_shift                       (1)
+#define HDMI_TMDS_OUTCTL_dummy98034018_0_shift                       (0)
+#define HDMI_TMDS_OUTCTL_trcoe_r_mask                                (0x00002000)
+#define HDMI_TMDS_OUTCTL_tgcoe_r_mask                                (0x00001000)
+#define HDMI_TMDS_OUTCTL_tbcoe_r_mask                                (0x00000800)
+#define HDMI_TMDS_OUTCTL_ocke_r_mask                                 (0x00000400)
+#define HDMI_TMDS_OUTCTL_aoe_mask                                    (0x00000200)
+#define HDMI_TMDS_OUTCTL_trcoe_mask                                  (0x00000100)
+#define HDMI_TMDS_OUTCTL_tgcoe_mask                                  (0x00000080)
+#define HDMI_TMDS_OUTCTL_tbcoe_mask                                  (0x00000040)
+#define HDMI_TMDS_OUTCTL_ocke_mask                                   (0x00000020)
+#define HDMI_TMDS_OUTCTL_ockie_mask                                  (0x00000010)
+#define HDMI_TMDS_OUTCTL_focke_mask                                  (0x00000008)
+#define HDMI_TMDS_OUTCTL_cbus_dbg_cke_mask                           (0x00000004)
+#define HDMI_TMDS_OUTCTL_dummy98034018_1_mask                        (0x00000002)
+#define HDMI_TMDS_OUTCTL_dummy98034018_0_mask                        (0x00000001)
+#define HDMI_TMDS_OUTCTL_trcoe_r(data)                               (0x00002000&((data)<<13))
+#define HDMI_TMDS_OUTCTL_tgcoe_r(data)                               (0x00001000&((data)<<12))
+#define HDMI_TMDS_OUTCTL_tbcoe_r(data)                               (0x00000800&((data)<<11))
+#define HDMI_TMDS_OUTCTL_ocke_r(data)                                (0x00000400&((data)<<10))
+#define HDMI_TMDS_OUTCTL_aoe(data)                                   (0x00000200&((data)<<9))
+#define HDMI_TMDS_OUTCTL_trcoe(data)                                 (0x00000100&((data)<<8))
+#define HDMI_TMDS_OUTCTL_tgcoe(data)                                 (0x00000080&((data)<<7))
+#define HDMI_TMDS_OUTCTL_tbcoe(data)                                 (0x00000040&((data)<<6))
+#define HDMI_TMDS_OUTCTL_ocke(data)                                  (0x00000020&((data)<<5))
+#define HDMI_TMDS_OUTCTL_ockie(data)                                 (0x00000010&((data)<<4))
+#define HDMI_TMDS_OUTCTL_focke(data)                                 (0x00000008&((data)<<3))
+#define HDMI_TMDS_OUTCTL_cbus_dbg_cke(data)                          (0x00000004&((data)<<2))
+#define HDMI_TMDS_OUTCTL_dummy98034018_1(data)                       (0x00000002&((data)<<1))
+#define HDMI_TMDS_OUTCTL_dummy98034018_0(data)                       (0x00000001&(data))
+#define HDMI_TMDS_OUTCTL_get_trcoe_r(data)                           ((0x00002000&(data))>>13)
+#define HDMI_TMDS_OUTCTL_get_tgcoe_r(data)                           ((0x00001000&(data))>>12)
+#define HDMI_TMDS_OUTCTL_get_tbcoe_r(data)                           ((0x00000800&(data))>>11)
+#define HDMI_TMDS_OUTCTL_get_ocke_r(data)                            ((0x00000400&(data))>>10)
+#define HDMI_TMDS_OUTCTL_get_aoe(data)                               ((0x00000200&(data))>>9)
+#define HDMI_TMDS_OUTCTL_get_trcoe(data)                             ((0x00000100&(data))>>8)
+#define HDMI_TMDS_OUTCTL_get_tgcoe(data)                             ((0x00000080&(data))>>7)
+#define HDMI_TMDS_OUTCTL_get_tbcoe(data)                             ((0x00000040&(data))>>6)
+#define HDMI_TMDS_OUTCTL_get_ocke(data)                              ((0x00000020&(data))>>5)
+#define HDMI_TMDS_OUTCTL_get_ockie(data)                             ((0x00000010&(data))>>4)
+#define HDMI_TMDS_OUTCTL_get_focke(data)                             ((0x00000008&(data))>>3)
+#define HDMI_TMDS_OUTCTL_get_cbus_dbg_cke(data)                      ((0x00000004&(data))>>2)
+#define HDMI_TMDS_OUTCTL_get_dummy98034018_1(data)                   ((0x00000002&(data))>>1)
+#define HDMI_TMDS_OUTCTL_get_dummy98034018_0(data)                   (0x00000001&(data))
+
+
+#define HDMI_TMDS_PWDCTL                                             0x01c
+#define HDMI_TMDS_PWDCTL_reg_addr                                    "0x9803401c"
+#define HDMI_TMDS_PWDCTL_reg                                         0x9803401c
+#define HDMI_TMDS_PWDCTL_inst_addr                                   "0x0007"
+#define HDMI_TMDS_PWDCTL_inst                                        0x0007
+#define HDMI_TMDS_PWDCTL_ecc_r_shift                                 (31)
+#define HDMI_TMDS_PWDCTL_erip_r_shift                                (30)
+#define HDMI_TMDS_PWDCTL_egip_r_shift                                (29)
+#define HDMI_TMDS_PWDCTL_ebip_r_shift                                (28)
+#define HDMI_TMDS_PWDCTL_dummy9803401c_27_10_shift                   (10)
+#define HDMI_TMDS_PWDCTL_video_preamble_off_en_shift                 (9)
+#define HDMI_TMDS_PWDCTL_hs_width_sel_shift                          (8)
+#define HDMI_TMDS_PWDCTL_deo_shift                                   (7)
+#define HDMI_TMDS_PWDCTL_brcw_shift                                  (6)
+#define HDMI_TMDS_PWDCTL_pnsw_shift                                  (5)
+#define HDMI_TMDS_PWDCTL_iccaf_shift                                 (4)
+#define HDMI_TMDS_PWDCTL_ecc_shift                                   (3)
+#define HDMI_TMDS_PWDCTL_erip_shift                                  (2)
+#define HDMI_TMDS_PWDCTL_egip_shift                                  (1)
+#define HDMI_TMDS_PWDCTL_ebip_shift                                  (0)
+#define HDMI_TMDS_PWDCTL_ecc_r_mask                                  (0x80000000)
+#define HDMI_TMDS_PWDCTL_erip_r_mask                                 (0x40000000)
+#define HDMI_TMDS_PWDCTL_egip_r_mask                                 (0x20000000)
+#define HDMI_TMDS_PWDCTL_ebip_r_mask                                 (0x10000000)
+#define HDMI_TMDS_PWDCTL_dummy9803401c_27_10_mask                    (0x0FFFFC00)
+#define HDMI_TMDS_PWDCTL_video_preamble_off_en_mask                  (0x00000200)
+#define HDMI_TMDS_PWDCTL_hs_width_sel_mask                           (0x00000100)
+#define HDMI_TMDS_PWDCTL_deo_mask                                    (0x00000080)
+#define HDMI_TMDS_PWDCTL_brcw_mask                                   (0x00000040)
+#define HDMI_TMDS_PWDCTL_pnsw_mask                                   (0x00000020)
+#define HDMI_TMDS_PWDCTL_iccaf_mask                                  (0x00000010)
+#define HDMI_TMDS_PWDCTL_ecc_mask                                    (0x00000008)
+#define HDMI_TMDS_PWDCTL_erip_mask                                   (0x00000004)
+#define HDMI_TMDS_PWDCTL_egip_mask                                   (0x00000002)
+#define HDMI_TMDS_PWDCTL_ebip_mask                                   (0x00000001)
+#define HDMI_TMDS_PWDCTL_ecc_r(data)                                 (0x80000000&((data)<<31))
+#define HDMI_TMDS_PWDCTL_erip_r(data)                                (0x40000000&((data)<<30))
+#define HDMI_TMDS_PWDCTL_egip_r(data)                                (0x20000000&((data)<<29))
+#define HDMI_TMDS_PWDCTL_ebip_r(data)                                (0x10000000&((data)<<28))
+#define HDMI_TMDS_PWDCTL_dummy9803401c_27_10(data)                   (0x0FFFFC00&((data)<<10))
+#define HDMI_TMDS_PWDCTL_video_preamble_off_en(data)                 (0x00000200&((data)<<9))
+#define HDMI_TMDS_PWDCTL_hs_width_sel(data)                          (0x00000100&((data)<<8))
+#define HDMI_TMDS_PWDCTL_deo(data)                                   (0x00000080&((data)<<7))
+#define HDMI_TMDS_PWDCTL_brcw(data)                                  (0x00000040&((data)<<6))
+#define HDMI_TMDS_PWDCTL_pnsw(data)                                  (0x00000020&((data)<<5))
+#define HDMI_TMDS_PWDCTL_iccaf(data)                                 (0x00000010&((data)<<4))
+#define HDMI_TMDS_PWDCTL_ecc(data)                                   (0x00000008&((data)<<3))
+#define HDMI_TMDS_PWDCTL_erip(data)                                  (0x00000004&((data)<<2))
+#define HDMI_TMDS_PWDCTL_egip(data)                                  (0x00000002&((data)<<1))
+#define HDMI_TMDS_PWDCTL_ebip(data)                                  (0x00000001&(data))
+#define HDMI_TMDS_PWDCTL_get_ecc_r(data)                             ((0x80000000&(data))>>31)
+#define HDMI_TMDS_PWDCTL_get_erip_r(data)                            ((0x40000000&(data))>>30)
+#define HDMI_TMDS_PWDCTL_get_egip_r(data)                            ((0x20000000&(data))>>29)
+#define HDMI_TMDS_PWDCTL_get_ebip_r(data)                            ((0x10000000&(data))>>28)
+#define HDMI_TMDS_PWDCTL_get_dummy9803401c_27_10(data)               ((0x0FFFFC00&(data))>>10)
+#define HDMI_TMDS_PWDCTL_get_video_preamble_off_en(data)             ((0x00000200&(data))>>9)
+#define HDMI_TMDS_PWDCTL_get_hs_width_sel(data)                      ((0x00000100&(data))>>8)
+#define HDMI_TMDS_PWDCTL_get_deo(data)                               ((0x00000080&(data))>>7)
+#define HDMI_TMDS_PWDCTL_get_brcw(data)                              ((0x00000040&(data))>>6)
+#define HDMI_TMDS_PWDCTL_get_pnsw(data)                              ((0x00000020&(data))>>5)
+#define HDMI_TMDS_PWDCTL_get_iccaf(data)                             ((0x00000010&(data))>>4)
+#define HDMI_TMDS_PWDCTL_get_ecc(data)                               ((0x00000008&(data))>>3)
+#define HDMI_TMDS_PWDCTL_get_erip(data)                              ((0x00000004&(data))>>2)
+#define HDMI_TMDS_PWDCTL_get_egip(data)                              ((0x00000002&(data))>>1)
+#define HDMI_TMDS_PWDCTL_get_ebip(data)                              (0x00000001&(data))
+
+
+#define HDMI_TMDS_Z0CC                                               0x020
+#define HDMI_TMDS_Z0CC_reg_addr                                      "0x98034020"
+#define HDMI_TMDS_Z0CC_reg                                           0x98034020
+#define HDMI_TMDS_Z0CC_inst_addr                                     "0x0008"
+#define HDMI_TMDS_Z0CC_inst                                          0x0008
+#define HDMI_TMDS_Z0CC_hde_shift                                     (0)
+#define HDMI_TMDS_Z0CC_hde_mask                                      (0x00000001)
+#define HDMI_TMDS_Z0CC_hde(data)                                     (0x00000001&(data))
+#define HDMI_TMDS_Z0CC_get_hde(data)                                 (0x00000001&(data))
+
+
+#define HDMI_TMDS_CPS                                                0x024
+#define HDMI_TMDS_CPS_reg_addr                                       "0x98034024"
+#define HDMI_TMDS_CPS_reg                                            0x98034024
+#define HDMI_TMDS_CPS_inst_addr                                      "0x0009"
+#define HDMI_TMDS_CPS_inst                                           0x0009
+#define HDMI_TMDS_CPS_pk_gb_num_shift                                (18)
+#define HDMI_TMDS_CPS_vd_gb_num_shift                                (16)
+#define HDMI_TMDS_CPS_pk_pre_num_shift                               (13)
+#define HDMI_TMDS_CPS_vd_pre_num_shift                               (10)
+#define HDMI_TMDS_CPS_pll_div2_en_shift                              (9)
+#define HDMI_TMDS_CPS_no_clk_in_shift                                (8)
+#define HDMI_TMDS_CPS_clkv_meas_sel_shift                            (6)
+#define HDMI_TMDS_CPS_de_inv_disable_shift                           (5)
+#define HDMI_TMDS_CPS_de_err_pulse_en_shift                          (4)
+#define HDMI_TMDS_CPS_clr_infoframe_dvi_shift                        (3)
+#define HDMI_TMDS_CPS_auto_dvi2hdmi_shift                            (2)
+#define HDMI_TMDS_CPS_dummy98034024_1_0_shift                        (0)
+#define HDMI_TMDS_CPS_pk_gb_num_mask                                 (0x000C0000)
+#define HDMI_TMDS_CPS_vd_gb_num_mask                                 (0x00030000)
+#define HDMI_TMDS_CPS_pk_pre_num_mask                                (0x0000E000)
+#define HDMI_TMDS_CPS_vd_pre_num_mask                                (0x00001C00)
+#define HDMI_TMDS_CPS_pll_div2_en_mask                               (0x00000200)
+#define HDMI_TMDS_CPS_no_clk_in_mask                                 (0x00000100)
+#define HDMI_TMDS_CPS_clkv_meas_sel_mask                             (0x000000C0)
+#define HDMI_TMDS_CPS_de_inv_disable_mask                            (0x00000020)
+#define HDMI_TMDS_CPS_de_err_pulse_en_mask                           (0x00000010)
+#define HDMI_TMDS_CPS_clr_infoframe_dvi_mask                         (0x00000008)
+#define HDMI_TMDS_CPS_auto_dvi2hdmi_mask                             (0x00000004)
+#define HDMI_TMDS_CPS_dummy98034024_1_0_mask                         (0x00000003)
+#define HDMI_TMDS_CPS_pk_gb_num(data)                                (0x000C0000&((data)<<18))
+#define HDMI_TMDS_CPS_vd_gb_num(data)                                (0x00030000&((data)<<16))
+#define HDMI_TMDS_CPS_pk_pre_num(data)                               (0x0000E000&((data)<<13))
+#define HDMI_TMDS_CPS_vd_pre_num(data)                               (0x00001C00&((data)<<10))
+#define HDMI_TMDS_CPS_pll_div2_en(data)                              (0x00000200&((data)<<9))
+#define HDMI_TMDS_CPS_no_clk_in(data)                                (0x00000100&((data)<<8))
+#define HDMI_TMDS_CPS_clkv_meas_sel(data)                            (0x000000C0&((data)<<6))
+#define HDMI_TMDS_CPS_de_inv_disable(data)                           (0x00000020&((data)<<5))
+#define HDMI_TMDS_CPS_de_err_pulse_en(data)                          (0x00000010&((data)<<4))
+#define HDMI_TMDS_CPS_clr_infoframe_dvi(data)                        (0x00000008&((data)<<3))
+#define HDMI_TMDS_CPS_auto_dvi2hdmi(data)                            (0x00000004&((data)<<2))
+#define HDMI_TMDS_CPS_dummy98034024_1_0(data)                        (0x00000003&(data))
+#define HDMI_TMDS_CPS_get_pk_gb_num(data)                            ((0x000C0000&(data))>>18)
+#define HDMI_TMDS_CPS_get_vd_gb_num(data)                            ((0x00030000&(data))>>16)
+#define HDMI_TMDS_CPS_get_pk_pre_num(data)                           ((0x0000E000&(data))>>13)
+#define HDMI_TMDS_CPS_get_vd_pre_num(data)                           ((0x00001C00&(data))>>10)
+#define HDMI_TMDS_CPS_get_pll_div2_en(data)                          ((0x00000200&(data))>>9)
+#define HDMI_TMDS_CPS_get_no_clk_in(data)                            ((0x00000100&(data))>>8)
+#define HDMI_TMDS_CPS_get_clkv_meas_sel(data)                        ((0x000000C0&(data))>>6)
+#define HDMI_TMDS_CPS_get_de_inv_disable(data)                       ((0x00000020&(data))>>5)
+#define HDMI_TMDS_CPS_get_de_err_pulse_en(data)                      ((0x00000010&(data))>>4)
+#define HDMI_TMDS_CPS_get_clr_infoframe_dvi(data)                    ((0x00000008&(data))>>3)
+#define HDMI_TMDS_CPS_get_auto_dvi2hdmi(data)                        ((0x00000004&(data))>>2)
+#define HDMI_TMDS_CPS_get_dummy98034024_1_0(data)                    (0x00000003&(data))
+
+
+#define HDMI_TMDS_UDC                                                0x028
+#define HDMI_TMDS_UDC_reg_addr                                       "0x98034028"
+#define HDMI_TMDS_UDC_reg                                            0x98034028
+#define HDMI_TMDS_UDC_inst_addr                                      "0x000A"
+#define HDMI_TMDS_UDC_inst                                           0x000A
+#define HDMI_TMDS_UDC_debug_sel_shift                                (4)
+#define HDMI_TMDS_UDC_dummy98034028_3_shift                          (3)
+#define HDMI_TMDS_UDC_cptest_shift                                   (2)
+#define HDMI_TMDS_UDC_hmtm_shift                                     (0)
+#define HDMI_TMDS_UDC_debug_sel_mask                                 (0x000003F0)
+#define HDMI_TMDS_UDC_dummy98034028_3_mask                           (0x00000008)
+#define HDMI_TMDS_UDC_cptest_mask                                    (0x00000004)
+#define HDMI_TMDS_UDC_hmtm_mask                                      (0x00000003)
+#define HDMI_TMDS_UDC_debug_sel(data)                                (0x000003F0&((data)<<4))
+#define HDMI_TMDS_UDC_dummy98034028_3(data)                          (0x00000008&((data)<<3))
+#define HDMI_TMDS_UDC_cptest(data)                                   (0x00000004&((data)<<2))
+#define HDMI_TMDS_UDC_hmtm(data)                                     (0x00000003&(data))
+#define HDMI_TMDS_UDC_get_debug_sel(data)                            ((0x000003F0&(data))>>4)
+#define HDMI_TMDS_UDC_get_dummy98034028_3(data)                      ((0x00000008&(data))>>3)
+#define HDMI_TMDS_UDC_get_cptest(data)                               ((0x00000004&(data))>>2)
+#define HDMI_TMDS_UDC_get_hmtm(data)                                 (0x00000003&(data))
+
+
+#define HDMI_TMDS_ERRC                                               0x02c
+#define HDMI_TMDS_ERRC_reg_addr                                      "0x9803402c"
+#define HDMI_TMDS_ERRC_reg                                           0x9803402c
+#define HDMI_TMDS_ERRC_inst_addr                                     "0x000B"
+#define HDMI_TMDS_ERRC_inst                                          0x000B
+#define HDMI_TMDS_ERRC_nl_shift                                      (0)
+#define HDMI_TMDS_ERRC_nl_mask                                       (0x00000007)
+#define HDMI_TMDS_ERRC_nl(data)                                      (0x00000007&(data))
+#define HDMI_TMDS_ERRC_get_nl(data)                                  (0x00000007&(data))
+
+
+#define HDMI_TMDS_OUT_CTRL                                           0x030
+#define HDMI_TMDS_OUT_CTRL_reg_addr                                  "0x98034030"
+#define HDMI_TMDS_OUT_CTRL_reg                                       0x98034030
+#define HDMI_TMDS_OUT_CTRL_inst_addr                                 "0x000C"
+#define HDMI_TMDS_OUT_CTRL_inst                                      0x000C
+#define HDMI_TMDS_OUT_CTRL_tmds_bypass_shift                         (7)
+#define HDMI_TMDS_OUT_CTRL_dummy98034030_6_0_shift                   (0)
+#define HDMI_TMDS_OUT_CTRL_tmds_bypass_mask                          (0x00000080)
+#define HDMI_TMDS_OUT_CTRL_dummy98034030_6_0_mask                    (0x0000007F)
+#define HDMI_TMDS_OUT_CTRL_tmds_bypass(data)                         (0x00000080&((data)<<7))
+#define HDMI_TMDS_OUT_CTRL_dummy98034030_6_0(data)                   (0x0000007F&(data))
+#define HDMI_TMDS_OUT_CTRL_get_tmds_bypass(data)                     ((0x00000080&(data))>>7)
+#define HDMI_TMDS_OUT_CTRL_get_dummy98034030_6_0(data)               (0x0000007F&(data))
+
+
+#define HDMI_TMDS_ROUT                                               0x034
+#define HDMI_TMDS_ROUT_reg_addr                                      "0x98034034"
+#define HDMI_TMDS_ROUT_reg                                           0x98034034
+#define HDMI_TMDS_ROUT_inst_addr                                     "0x000D"
+#define HDMI_TMDS_ROUT_inst                                          0x000D
+#define HDMI_TMDS_ROUT_tmds_rout_h_shift                             (8)
+#define HDMI_TMDS_ROUT_tmds_rout_l_shift                             (0)
+#define HDMI_TMDS_ROUT_tmds_rout_h_mask                              (0x0000FF00)
+#define HDMI_TMDS_ROUT_tmds_rout_l_mask                              (0x000000FF)
+#define HDMI_TMDS_ROUT_tmds_rout_h(data)                             (0x0000FF00&((data)<<8))
+#define HDMI_TMDS_ROUT_tmds_rout_l(data)                             (0x000000FF&(data))
+#define HDMI_TMDS_ROUT_get_tmds_rout_h(data)                         ((0x0000FF00&(data))>>8)
+#define HDMI_TMDS_ROUT_get_tmds_rout_l(data)                         (0x000000FF&(data))
+
+
+#define HDMI_TMDS_GOUT                                               0x038
+#define HDMI_TMDS_GOUT_reg_addr                                      "0x98034038"
+#define HDMI_TMDS_GOUT_reg                                           0x98034038
+#define HDMI_TMDS_GOUT_inst_addr                                     "0x000E"
+#define HDMI_TMDS_GOUT_inst                                          0x000E
+#define HDMI_TMDS_GOUT_tmds_gout_h_shift                             (8)
+#define HDMI_TMDS_GOUT_tmds_gout_l_shift                             (0)
+#define HDMI_TMDS_GOUT_tmds_gout_h_mask                              (0x0000FF00)
+#define HDMI_TMDS_GOUT_tmds_gout_l_mask                              (0x000000FF)
+#define HDMI_TMDS_GOUT_tmds_gout_h(data)                             (0x0000FF00&((data)<<8))
+#define HDMI_TMDS_GOUT_tmds_gout_l(data)                             (0x000000FF&(data))
+#define HDMI_TMDS_GOUT_get_tmds_gout_h(data)                         ((0x0000FF00&(data))>>8)
+#define HDMI_TMDS_GOUT_get_tmds_gout_l(data)                         (0x000000FF&(data))
+
+
+#define HDMI_TMDS_BOUT                                               0x03c
+#define HDMI_TMDS_BOUT_reg_addr                                      "0x9803403c"
+#define HDMI_TMDS_BOUT_reg                                           0x9803403c
+#define HDMI_TMDS_BOUT_inst_addr                                     "0x000F"
+#define HDMI_TMDS_BOUT_inst                                          0x000F
+#define HDMI_TMDS_BOUT_tmds_bout_h_shift                             (8)
+#define HDMI_TMDS_BOUT_tmds_bout_l_shift                             (0)
+#define HDMI_TMDS_BOUT_tmds_bout_h_mask                              (0x0000FF00)
+#define HDMI_TMDS_BOUT_tmds_bout_l_mask                              (0x000000FF)
+#define HDMI_TMDS_BOUT_tmds_bout_h(data)                             (0x0000FF00&((data)<<8))
+#define HDMI_TMDS_BOUT_tmds_bout_l(data)                             (0x000000FF&(data))
+#define HDMI_TMDS_BOUT_get_tmds_bout_h(data)                         ((0x0000FF00&(data))>>8)
+#define HDMI_TMDS_BOUT_get_tmds_bout_l(data)                         (0x000000FF&(data))
+
+
+#define HDMI_TMDS_DPC0                                               0x040
+#define HDMI_TMDS_DPC0_reg_addr                                      "0x98034040"
+#define HDMI_TMDS_DPC0_reg                                           0x98034040
+#define HDMI_TMDS_DPC0_inst_addr                                     "0x0010"
+#define HDMI_TMDS_DPC0_inst                                          0x0010
+#define HDMI_TMDS_DPC0_dpc_pp_valid_shift                            (9)
+#define HDMI_TMDS_DPC0_dpc_default_ph_shift                          (8)
+#define HDMI_TMDS_DPC0_dpc_pp_shift                                  (4)
+#define HDMI_TMDS_DPC0_dpc_cd_shift                                  (0)
+#define HDMI_TMDS_DPC0_dpc_pp_valid_mask                             (0x00000200)
+#define HDMI_TMDS_DPC0_dpc_default_ph_mask                           (0x00000100)
+#define HDMI_TMDS_DPC0_dpc_pp_mask                                   (0x000000F0)
+#define HDMI_TMDS_DPC0_dpc_cd_mask                                   (0x0000000F)
+#define HDMI_TMDS_DPC0_dpc_pp_valid(data)                            (0x00000200&((data)<<9))
+#define HDMI_TMDS_DPC0_dpc_default_ph(data)                          (0x00000100&((data)<<8))
+#define HDMI_TMDS_DPC0_dpc_pp(data)                                  (0x000000F0&((data)<<4))
+#define HDMI_TMDS_DPC0_dpc_cd(data)                                  (0x0000000F&(data))
+#define HDMI_TMDS_DPC0_get_dpc_pp_valid(data)                        ((0x00000200&(data))>>9)
+#define HDMI_TMDS_DPC0_get_dpc_default_ph(data)                      ((0x00000100&(data))>>8)
+#define HDMI_TMDS_DPC0_get_dpc_pp(data)                              ((0x000000F0&(data))>>4)
+#define HDMI_TMDS_DPC0_get_dpc_cd(data)                              (0x0000000F&(data))
+
+
+#define HDMI_TMDS_DPC1                                               0x044
+#define HDMI_TMDS_DPC1_reg_addr                                      "0x98034044"
+#define HDMI_TMDS_DPC1_reg                                           0x98034044
+#define HDMI_TMDS_DPC1_inst_addr                                     "0x0011"
+#define HDMI_TMDS_DPC1_inst                                          0x0011
+#define HDMI_TMDS_DPC1_dpc_cd_chg_flag_shift                         (18)
+#define HDMI_TMDS_DPC1_dpc_cd_chg_wd_en_shift                        (17)
+#define HDMI_TMDS_DPC1_dpc_cd_chg_int_en_shift                       (16)
+#define HDMI_TMDS_DPC1_dummy98034044_15_11_shift                     (11)
+#define HDMI_TMDS_DPC1_dpc_auto_shift                                (10)
+#define HDMI_TMDS_DPC1_dpc_pp_valid_fw_shift                         (9)
+#define HDMI_TMDS_DPC1_dpc_default_ph_fw_shift                       (8)
+#define HDMI_TMDS_DPC1_dpc_pp_fw_shift                               (4)
+#define HDMI_TMDS_DPC1_dpc_cd_fw_shift                               (0)
+#define HDMI_TMDS_DPC1_dpc_cd_chg_flag_mask                          (0x00040000)
+#define HDMI_TMDS_DPC1_dpc_cd_chg_wd_en_mask                         (0x00020000)
+#define HDMI_TMDS_DPC1_dpc_cd_chg_int_en_mask                        (0x00010000)
+#define HDMI_TMDS_DPC1_dummy98034044_15_11_mask                      (0x0000F800)
+#define HDMI_TMDS_DPC1_dpc_auto_mask                                 (0x00000400)
+#define HDMI_TMDS_DPC1_dpc_pp_valid_fw_mask                          (0x00000200)
+#define HDMI_TMDS_DPC1_dpc_default_ph_fw_mask                        (0x00000100)
+#define HDMI_TMDS_DPC1_dpc_pp_fw_mask                                (0x000000F0)
+#define HDMI_TMDS_DPC1_dpc_cd_fw_mask                                (0x0000000F)
+#define HDMI_TMDS_DPC1_dpc_cd_chg_flag(data)                         (0x00040000&((data)<<18))
+#define HDMI_TMDS_DPC1_dpc_cd_chg_wd_en(data)                        (0x00020000&((data)<<17))
+#define HDMI_TMDS_DPC1_dpc_cd_chg_int_en(data)                       (0x00010000&((data)<<16))
+#define HDMI_TMDS_DPC1_dummy98034044_15_11(data)                     (0x0000F800&((data)<<11))
+#define HDMI_TMDS_DPC1_dpc_auto(data)                                (0x00000400&((data)<<10))
+#define HDMI_TMDS_DPC1_dpc_pp_valid_fw(data)                         (0x00000200&((data)<<9))
+#define HDMI_TMDS_DPC1_dpc_default_ph_fw(data)                       (0x00000100&((data)<<8))
+#define HDMI_TMDS_DPC1_dpc_pp_fw(data)                               (0x000000F0&((data)<<4))
+#define HDMI_TMDS_DPC1_dpc_cd_fw(data)                               (0x0000000F&(data))
+#define HDMI_TMDS_DPC1_get_dpc_cd_chg_flag(data)                     ((0x00040000&(data))>>18)
+#define HDMI_TMDS_DPC1_get_dpc_cd_chg_wd_en(data)                    ((0x00020000&(data))>>17)
+#define HDMI_TMDS_DPC1_get_dpc_cd_chg_int_en(data)                   ((0x00010000&(data))>>16)
+#define HDMI_TMDS_DPC1_get_dummy98034044_15_11(data)                 ((0x0000F800&(data))>>11)
+#define HDMI_TMDS_DPC1_get_dpc_auto(data)                            ((0x00000400&(data))>>10)
+#define HDMI_TMDS_DPC1_get_dpc_pp_valid_fw(data)                     ((0x00000200&(data))>>9)
+#define HDMI_TMDS_DPC1_get_dpc_default_ph_fw(data)                   ((0x00000100&(data))>>8)
+#define HDMI_TMDS_DPC1_get_dpc_pp_fw(data)                           ((0x000000F0&(data))>>4)
+#define HDMI_TMDS_DPC1_get_dpc_cd_fw(data)                           (0x0000000F&(data))
+
+
+#define HDMI_TMDS_DPC_SET0                                           0x048
+#define HDMI_TMDS_DPC_SET0_reg_addr                                  "0x98034048"
+#define HDMI_TMDS_DPC_SET0_reg                                       0x98034048
+#define HDMI_TMDS_DPC_SET0_inst_addr                                 "0x0012"
+#define HDMI_TMDS_DPC_SET0_inst                                      0x0012
+#define HDMI_TMDS_DPC_SET0_dpc_bypass_dis_shift                      (8)
+#define HDMI_TMDS_DPC_SET0_dpc_en_shift                              (7)
+#define HDMI_TMDS_DPC_SET0_phase_errcnt_in_shift                     (4)
+#define HDMI_TMDS_DPC_SET0_phase_clrcnt_in_shift                     (1)
+#define HDMI_TMDS_DPC_SET0_phase_clr_sel_shift                       (0)
+#define HDMI_TMDS_DPC_SET0_dpc_bypass_dis_mask                       (0x00000100)
+#define HDMI_TMDS_DPC_SET0_dpc_en_mask                               (0x00000080)
+#define HDMI_TMDS_DPC_SET0_phase_errcnt_in_mask                      (0x00000070)
+#define HDMI_TMDS_DPC_SET0_phase_clrcnt_in_mask                      (0x0000000E)
+#define HDMI_TMDS_DPC_SET0_phase_clr_sel_mask                        (0x00000001)
+#define HDMI_TMDS_DPC_SET0_dpc_bypass_dis(data)                      (0x00000100&((data)<<8))
+#define HDMI_TMDS_DPC_SET0_dpc_en(data)                              (0x00000080&((data)<<7))
+#define HDMI_TMDS_DPC_SET0_phase_errcnt_in(data)                     (0x00000070&((data)<<4))
+#define HDMI_TMDS_DPC_SET0_phase_clrcnt_in(data)                     (0x0000000E&((data)<<1))
+#define HDMI_TMDS_DPC_SET0_phase_clr_sel(data)                       (0x00000001&(data))
+#define HDMI_TMDS_DPC_SET0_get_dpc_bypass_dis(data)                  ((0x00000100&(data))>>8)
+#define HDMI_TMDS_DPC_SET0_get_dpc_en(data)                          ((0x00000080&(data))>>7)
+#define HDMI_TMDS_DPC_SET0_get_phase_errcnt_in(data)                 ((0x00000070&(data))>>4)
+#define HDMI_TMDS_DPC_SET0_get_phase_clrcnt_in(data)                 ((0x0000000E&(data))>>1)
+#define HDMI_TMDS_DPC_SET0_get_phase_clr_sel(data)                   (0x00000001&(data))
+
+
+#define HDMI_TMDS_DPC_SET1                                           0x04c
+#define HDMI_TMDS_DPC_SET1_reg_addr                                  "0x9803404c"
+#define HDMI_TMDS_DPC_SET1_reg                                       0x9803404c
+#define HDMI_TMDS_DPC_SET1_inst_addr                                 "0x0013"
+#define HDMI_TMDS_DPC_SET1_inst                                      0x0013
+#define HDMI_TMDS_DPC_SET1_set_full_noti_shift                       (4)
+#define HDMI_TMDS_DPC_SET1_set_empty_noti_shift                      (0)
+#define HDMI_TMDS_DPC_SET1_set_full_noti_mask                        (0x000000F0)
+#define HDMI_TMDS_DPC_SET1_set_empty_noti_mask                       (0x0000000F)
+#define HDMI_TMDS_DPC_SET1_set_full_noti(data)                       (0x000000F0&((data)<<4))
+#define HDMI_TMDS_DPC_SET1_set_empty_noti(data)                      (0x0000000F&(data))
+#define HDMI_TMDS_DPC_SET1_get_set_full_noti(data)                   ((0x000000F0&(data))>>4)
+#define HDMI_TMDS_DPC_SET1_get_set_empty_noti(data)                  (0x0000000F&(data))
+
+
+#define HDMI_TMDS_DPC_SET2                                           0x050
+#define HDMI_TMDS_DPC_SET2_reg_addr                                  "0x98034050"
+#define HDMI_TMDS_DPC_SET2_reg                                       0x98034050
+#define HDMI_TMDS_DPC_SET2_inst_addr                                 "0x0014"
+#define HDMI_TMDS_DPC_SET2_inst                                      0x0014
+#define HDMI_TMDS_DPC_SET2_fifo_errcnt_in_shift                      (5)
+#define HDMI_TMDS_DPC_SET2_clr_phase_flag_shift                      (4)
+#define HDMI_TMDS_DPC_SET2_clr_fifo_flag_shift                       (3)
+#define HDMI_TMDS_DPC_SET2_dpc_phase_ok_shift                        (2)
+#define HDMI_TMDS_DPC_SET2_dpc_phase_err_flag_shift                  (1)
+#define HDMI_TMDS_DPC_SET2_dpc_fifo_err_flag_shift                   (0)
+#define HDMI_TMDS_DPC_SET2_fifo_errcnt_in_mask                       (0x000000E0)
+#define HDMI_TMDS_DPC_SET2_clr_phase_flag_mask                       (0x00000010)
+#define HDMI_TMDS_DPC_SET2_clr_fifo_flag_mask                        (0x00000008)
+#define HDMI_TMDS_DPC_SET2_dpc_phase_ok_mask                         (0x00000004)
+#define HDMI_TMDS_DPC_SET2_dpc_phase_err_flag_mask                   (0x00000002)
+#define HDMI_TMDS_DPC_SET2_dpc_fifo_err_flag_mask                    (0x00000001)
+#define HDMI_TMDS_DPC_SET2_fifo_errcnt_in(data)                      (0x000000E0&((data)<<5))
+#define HDMI_TMDS_DPC_SET2_clr_phase_flag(data)                      (0x00000010&((data)<<4))
+#define HDMI_TMDS_DPC_SET2_clr_fifo_flag(data)                       (0x00000008&((data)<<3))
+#define HDMI_TMDS_DPC_SET2_dpc_phase_ok(data)                        (0x00000004&((data)<<2))
+#define HDMI_TMDS_DPC_SET2_dpc_phase_err_flag(data)                  (0x00000002&((data)<<1))
+#define HDMI_TMDS_DPC_SET2_dpc_fifo_err_flag(data)                   (0x00000001&(data))
+#define HDMI_TMDS_DPC_SET2_get_fifo_errcnt_in(data)                  ((0x000000E0&(data))>>5)
+#define HDMI_TMDS_DPC_SET2_get_clr_phase_flag(data)                  ((0x00000010&(data))>>4)
+#define HDMI_TMDS_DPC_SET2_get_clr_fifo_flag(data)                   ((0x00000008&(data))>>3)
+#define HDMI_TMDS_DPC_SET2_get_dpc_phase_ok(data)                    ((0x00000004&(data))>>2)
+#define HDMI_TMDS_DPC_SET2_get_dpc_phase_err_flag(data)              ((0x00000002&(data))>>1)
+#define HDMI_TMDS_DPC_SET2_get_dpc_fifo_err_flag(data)               (0x00000001&(data))
+
+
+#define HDMI_TMDS_DPC_SET3                                           0x054
+#define HDMI_TMDS_DPC_SET3_reg_addr                                  "0x98034054"
+#define HDMI_TMDS_DPC_SET3_reg                                       0x98034054
+#define HDMI_TMDS_DPC_SET3_inst_addr                                 "0x0015"
+#define HDMI_TMDS_DPC_SET3_inst                                      0x0015
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_over_flag_shift                  (7)
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_under_flag_shift                 (6)
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_over_xflag_shift                 (5)
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_under_xflag_shift                (4)
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_over_flag_mask                   (0x00000080)
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_under_flag_mask                  (0x00000040)
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_over_xflag_mask                  (0x00000020)
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_under_xflag_mask                 (0x00000010)
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_over_flag(data)                  (0x00000080&((data)<<7))
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_under_flag(data)                 (0x00000040&((data)<<6))
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_over_xflag(data)                 (0x00000020&((data)<<5))
+#define HDMI_TMDS_DPC_SET3_dpc_fifo_under_xflag(data)                (0x00000010&((data)<<4))
+#define HDMI_TMDS_DPC_SET3_get_dpc_fifo_over_flag(data)              ((0x00000080&(data))>>7)
+#define HDMI_TMDS_DPC_SET3_get_dpc_fifo_under_flag(data)             ((0x00000040&(data))>>6)
+#define HDMI_TMDS_DPC_SET3_get_dpc_fifo_over_xflag(data)             ((0x00000020&(data))>>5)
+#define HDMI_TMDS_DPC_SET3_get_dpc_fifo_under_xflag(data)            ((0x00000010&(data))>>4)
+
+
+#define HDMI_TMDS_DET_CTL                                            0x058
+#define HDMI_TMDS_DET_CTL_reg_addr                                   "0x98034058"
+#define HDMI_TMDS_DET_CTL_reg                                        0x98034058
+#define HDMI_TMDS_DET_CTL_inst_addr                                  "0x0016"
+#define HDMI_TMDS_DET_CTL_inst                                       0x0016
+#define HDMI_TMDS_DET_CTL_de_sel_shift                               (28)
+#define HDMI_TMDS_DET_CTL_tran_err_thrd_shift                        (24)
+#define HDMI_TMDS_DET_CTL_neg_de_err_thrd_shift                      (20)
+#define HDMI_TMDS_DET_CTL_pos_de_err_thrd_shift                      (16)
+#define HDMI_TMDS_DET_CTL_dummy98034058_15_shift                     (15)
+#define HDMI_TMDS_DET_CTL_neg_de_lowbd_shift                         (8)
+#define HDMI_TMDS_DET_CTL_dummy98034058_7_6_shift                    (6)
+#define HDMI_TMDS_DET_CTL_pos_de_lowbd_shift                         (0)
+#define HDMI_TMDS_DET_CTL_de_sel_mask                                (0x10000000)
+#define HDMI_TMDS_DET_CTL_tran_err_thrd_mask                         (0x0F000000)
+#define HDMI_TMDS_DET_CTL_neg_de_err_thrd_mask                       (0x00F00000)
+#define HDMI_TMDS_DET_CTL_pos_de_err_thrd_mask                       (0x000F0000)
+#define HDMI_TMDS_DET_CTL_dummy98034058_15_mask                      (0x00008000)
+#define HDMI_TMDS_DET_CTL_neg_de_lowbd_mask                          (0x00007F00)
+#define HDMI_TMDS_DET_CTL_dummy98034058_7_6_mask                     (0x000000C0)
+#define HDMI_TMDS_DET_CTL_pos_de_lowbd_mask                          (0x0000003F)
+#define HDMI_TMDS_DET_CTL_de_sel(data)                               (0x10000000&((data)<<28))
+#define HDMI_TMDS_DET_CTL_tran_err_thrd(data)                        (0x0F000000&((data)<<24))
+#define HDMI_TMDS_DET_CTL_neg_de_err_thrd(data)                      (0x00F00000&((data)<<20))
+#define HDMI_TMDS_DET_CTL_pos_de_err_thrd(data)                      (0x000F0000&((data)<<16))
+#define HDMI_TMDS_DET_CTL_dummy98034058_15(data)                     (0x00008000&((data)<<15))
+#define HDMI_TMDS_DET_CTL_neg_de_lowbd(data)                         (0x00007F00&((data)<<8))
+#define HDMI_TMDS_DET_CTL_dummy98034058_7_6(data)                    (0x000000C0&((data)<<6))
+#define HDMI_TMDS_DET_CTL_pos_de_lowbd(data)                         (0x0000003F&(data))
+#define HDMI_TMDS_DET_CTL_get_de_sel(data)                           ((0x10000000&(data))>>28)
+#define HDMI_TMDS_DET_CTL_get_tran_err_thrd(data)                    ((0x0F000000&(data))>>24)
+#define HDMI_TMDS_DET_CTL_get_neg_de_err_thrd(data)                  ((0x00F00000&(data))>>20)
+#define HDMI_TMDS_DET_CTL_get_pos_de_err_thrd(data)                  ((0x000F0000&(data))>>16)
+#define HDMI_TMDS_DET_CTL_get_dummy98034058_15(data)                 ((0x00008000&(data))>>15)
+#define HDMI_TMDS_DET_CTL_get_neg_de_lowbd(data)                     ((0x00007F00&(data))>>8)
+#define HDMI_TMDS_DET_CTL_get_dummy98034058_7_6(data)                ((0x000000C0&(data))>>6)
+#define HDMI_TMDS_DET_CTL_get_pos_de_lowbd(data)                     (0x0000003F&(data))
+
+
+#define HDMI_TMDS_DET_STS                                            0x05c
+#define HDMI_TMDS_DET_STS_reg_addr                                   "0x9803405c"
+#define HDMI_TMDS_DET_STS_reg                                        0x9803405c
+#define HDMI_TMDS_DET_STS_inst_addr                                  "0x0017"
+#define HDMI_TMDS_DET_STS_inst                                       0x0017
+#define HDMI_TMDS_DET_STS_red_tran_err_flag_shift                    (8)
+#define HDMI_TMDS_DET_STS_grn_tran_err_flag_shift                    (7)
+#define HDMI_TMDS_DET_STS_blu_tran_err_flag_shift                    (6)
+#define HDMI_TMDS_DET_STS_red_pos_de_err_flag_shift                  (5)
+#define HDMI_TMDS_DET_STS_grn_pos_de_err_flag_shift                  (4)
+#define HDMI_TMDS_DET_STS_blu_pos_de_err_flag_shift                  (3)
+#define HDMI_TMDS_DET_STS_red_neg_de_err_flag_shift                  (2)
+#define HDMI_TMDS_DET_STS_grn_neg_de_err_flag_shift                  (1)
+#define HDMI_TMDS_DET_STS_blu_neg_de_err_flag_shift                  (0)
+#define HDMI_TMDS_DET_STS_red_tran_err_flag_mask                     (0x00000100)
+#define HDMI_TMDS_DET_STS_grn_tran_err_flag_mask                     (0x00000080)
+#define HDMI_TMDS_DET_STS_blu_tran_err_flag_mask                     (0x00000040)
+#define HDMI_TMDS_DET_STS_red_pos_de_err_flag_mask                   (0x00000020)
+#define HDMI_TMDS_DET_STS_grn_pos_de_err_flag_mask                   (0x00000010)
+#define HDMI_TMDS_DET_STS_blu_pos_de_err_flag_mask                   (0x00000008)
+#define HDMI_TMDS_DET_STS_red_neg_de_err_flag_mask                   (0x00000004)
+#define HDMI_TMDS_DET_STS_grn_neg_de_err_flag_mask                   (0x00000002)
+#define HDMI_TMDS_DET_STS_blu_neg_de_err_flag_mask                   (0x00000001)
+#define HDMI_TMDS_DET_STS_red_tran_err_flag(data)                    (0x00000100&((data)<<8))
+#define HDMI_TMDS_DET_STS_grn_tran_err_flag(data)                    (0x00000080&((data)<<7))
+#define HDMI_TMDS_DET_STS_blu_tran_err_flag(data)                    (0x00000040&((data)<<6))
+#define HDMI_TMDS_DET_STS_red_pos_de_err_flag(data)                  (0x00000020&((data)<<5))
+#define HDMI_TMDS_DET_STS_grn_pos_de_err_flag(data)                  (0x00000010&((data)<<4))
+#define HDMI_TMDS_DET_STS_blu_pos_de_err_flag(data)                  (0x00000008&((data)<<3))
+#define HDMI_TMDS_DET_STS_red_neg_de_err_flag(data)                  (0x00000004&((data)<<2))
+#define HDMI_TMDS_DET_STS_grn_neg_de_err_flag(data)                  (0x00000002&((data)<<1))
+#define HDMI_TMDS_DET_STS_blu_neg_de_err_flag(data)                  (0x00000001&(data))
+#define HDMI_TMDS_DET_STS_get_red_tran_err_flag(data)                ((0x00000100&(data))>>8)
+#define HDMI_TMDS_DET_STS_get_grn_tran_err_flag(data)                ((0x00000080&(data))>>7)
+#define HDMI_TMDS_DET_STS_get_blu_tran_err_flag(data)                ((0x00000040&(data))>>6)
+#define HDMI_TMDS_DET_STS_get_red_pos_de_err_flag(data)              ((0x00000020&(data))>>5)
+#define HDMI_TMDS_DET_STS_get_grn_pos_de_err_flag(data)              ((0x00000010&(data))>>4)
+#define HDMI_TMDS_DET_STS_get_blu_pos_de_err_flag(data)              ((0x00000008&(data))>>3)
+#define HDMI_TMDS_DET_STS_get_red_neg_de_err_flag(data)              ((0x00000004&(data))>>2)
+#define HDMI_TMDS_DET_STS_get_grn_neg_de_err_flag(data)              ((0x00000002&(data))>>1)
+#define HDMI_TMDS_DET_STS_get_blu_neg_de_err_flag(data)              (0x00000001&(data))
+
+
+#define HDMI_VIDEO_BIT_ERR_DET                                       0x060
+#define HDMI_VIDEO_BIT_ERR_DET_reg_addr                              "0x98034060"
+#define HDMI_VIDEO_BIT_ERR_DET_reg                                   0x98034060
+#define HDMI_VIDEO_BIT_ERR_DET_inst_addr                             "0x0018"
+#define HDMI_VIDEO_BIT_ERR_DET_inst                                  0x0018
+#define HDMI_VIDEO_BIT_ERR_DET_thd_shift                             (16)
+#define HDMI_VIDEO_BIT_ERR_DET_disparity_reset_mode_shift            (12)
+#define HDMI_VIDEO_BIT_ERR_DET_irq_en_shift                          (11)
+#define HDMI_VIDEO_BIT_ERR_DET_reset_shift                           (10)
+#define HDMI_VIDEO_BIT_ERR_DET_period_shift                          (4)
+#define HDMI_VIDEO_BIT_ERR_DET_ch_sel_shift                          (2)
+#define HDMI_VIDEO_BIT_ERR_DET_mode_shift                            (1)
+#define HDMI_VIDEO_BIT_ERR_DET_en_shift                              (0)
+#define HDMI_VIDEO_BIT_ERR_DET_thd_mask                              (0xFFFF0000)
+#define HDMI_VIDEO_BIT_ERR_DET_disparity_reset_mode_mask             (0x00001000)
+#define HDMI_VIDEO_BIT_ERR_DET_irq_en_mask                           (0x00000800)
+#define HDMI_VIDEO_BIT_ERR_DET_reset_mask                            (0x00000400)
+#define HDMI_VIDEO_BIT_ERR_DET_period_mask                           (0x000003F0)
+#define HDMI_VIDEO_BIT_ERR_DET_ch_sel_mask                           (0x0000000C)
+#define HDMI_VIDEO_BIT_ERR_DET_mode_mask                             (0x00000002)
+#define HDMI_VIDEO_BIT_ERR_DET_en_mask                               (0x00000001)
+#define HDMI_VIDEO_BIT_ERR_DET_thd(data)                             (0xFFFF0000&((data)<<16))
+#define HDMI_VIDEO_BIT_ERR_DET_disparity_reset_mode(data)            (0x00001000&((data)<<12))
+#define HDMI_VIDEO_BIT_ERR_DET_irq_en(data)                          (0x00000800&((data)<<11))
+#define HDMI_VIDEO_BIT_ERR_DET_reset(data)                           (0x00000400&((data)<<10))
+#define HDMI_VIDEO_BIT_ERR_DET_period(data)                          (0x000003F0&((data)<<4))
+#define HDMI_VIDEO_BIT_ERR_DET_ch_sel(data)                          (0x0000000C&((data)<<2))
+#define HDMI_VIDEO_BIT_ERR_DET_mode(data)                            (0x00000002&((data)<<1))
+#define HDMI_VIDEO_BIT_ERR_DET_en(data)                              (0x00000001&(data))
+#define HDMI_VIDEO_BIT_ERR_DET_get_thd(data)                         ((0xFFFF0000&(data))>>16)
+#define HDMI_VIDEO_BIT_ERR_DET_get_disparity_reset_mode(data)        ((0x00001000&(data))>>12)
+#define HDMI_VIDEO_BIT_ERR_DET_get_irq_en(data)                      ((0x00000800&(data))>>11)
+#define HDMI_VIDEO_BIT_ERR_DET_get_reset(data)                       ((0x00000400&(data))>>10)
+#define HDMI_VIDEO_BIT_ERR_DET_get_period(data)                      ((0x000003F0&(data))>>4)
+#define HDMI_VIDEO_BIT_ERR_DET_get_ch_sel(data)                      ((0x0000000C&(data))>>2)
+#define HDMI_VIDEO_BIT_ERR_DET_get_mode(data)                        ((0x00000002&(data))>>1)
+#define HDMI_VIDEO_BIT_ERR_DET_get_en(data)                          (0x00000001&(data))
+
+
+#define HDMI_VIDEO_BIT_ERR_STATUS_B                                  0x064
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_reg_addr                         "0x98034064"
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_reg                              0x98034064
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_inst_addr                        "0x0019"
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_inst                             0x0019
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_ad_max_b_shift                   (26)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_ad_min_b_shift                   (20)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_shift             (19)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_shift              (18)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b_shift                  (17)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_shift           (16)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_b_shift              (0)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_ad_max_b_mask                    (0xFC000000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_ad_min_b_mask                    (0x03F00000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask              (0x00080000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask               (0x00040000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask                   (0x00020000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask            (0x00010000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_b_mask               (0x0000FFFF)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_ad_max_b(data)                   (0xFC000000&((data)<<26))
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_ad_min_b(data)                   (0x03F00000&((data)<<20))
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b(data)             (0x00080000&((data)<<19))
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b(data)              (0x00040000&((data)<<18))
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b(data)                  (0x00020000&((data)<<17))
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b(data)           (0x00010000&((data)<<16))
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_b(data)              (0x0000FFFF&(data))
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_get_ad_max_b(data)               ((0xFC000000&(data))>>26)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_get_ad_min_b(data)               ((0x03F00000&(data))>>20)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_get_no_dis_reset_b(data)         ((0x00080000&(data))>>19)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_get_bit_err_thd_b(data)          ((0x00040000&(data))>>18)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_get_bit_err_b(data)              ((0x00020000&(data))>>17)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_get_bit_err_cnt_of_b(data)       ((0x00010000&(data))>>16)
+#define HDMI_VIDEO_BIT_ERR_STATUS_B_get_bit_err_cnt_b(data)          (0x0000FFFF&(data))
+
+
+#define HDMI_VIDEO_BIT_ERR_STATUS_G                                  0x068
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_reg_addr                         "0x98034068"
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_reg                              0x98034068
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_inst_addr                        "0x001A"
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_inst                             0x001A
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_ad_max_g_shift                   (26)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_ad_min_g_shift                   (20)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_no_dis_reset_g_shift             (19)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_thd_g_shift              (18)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_g_shift                  (17)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_of_g_shift           (16)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_g_shift              (0)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_ad_max_g_mask                    (0xFC000000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_ad_min_g_mask                    (0x03F00000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_no_dis_reset_g_mask              (0x00080000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_thd_g_mask               (0x00040000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_g_mask                   (0x00020000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_of_g_mask            (0x00010000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_g_mask               (0x0000FFFF)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_ad_max_g(data)                   (0xFC000000&((data)<<26))
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_ad_min_g(data)                   (0x03F00000&((data)<<20))
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_no_dis_reset_g(data)             (0x00080000&((data)<<19))
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_thd_g(data)              (0x00040000&((data)<<18))
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_g(data)                  (0x00020000&((data)<<17))
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_of_g(data)           (0x00010000&((data)<<16))
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_g(data)              (0x0000FFFF&(data))
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_get_ad_max_g(data)               ((0xFC000000&(data))>>26)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_get_ad_min_g(data)               ((0x03F00000&(data))>>20)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_get_no_dis_reset_g(data)         ((0x00080000&(data))>>19)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_get_bit_err_thd_g(data)          ((0x00040000&(data))>>18)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_get_bit_err_g(data)              ((0x00020000&(data))>>17)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_get_bit_err_cnt_of_g(data)       ((0x00010000&(data))>>16)
+#define HDMI_VIDEO_BIT_ERR_STATUS_G_get_bit_err_cnt_g(data)          (0x0000FFFF&(data))
+
+
+#define HDMI_VIDEO_BIT_ERR_STATUS_R                                  0x06c
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_reg_addr                         "0x9803406c"
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_reg                              0x9803406c
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_inst_addr                        "0x001B"
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_inst                             0x001B
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_ad_max_r_shift                   (26)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_ad_min_r_shift                   (20)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_no_dis_reset_r_shift             (19)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_thd_r_shift              (18)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_r_shift                  (17)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_of_r_shift           (16)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_r_shift              (0)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_ad_max_r_mask                    (0xFC000000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_ad_min_r_mask                    (0x03F00000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_no_dis_reset_r_mask              (0x00080000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_thd_r_mask               (0x00040000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_r_mask                   (0x00020000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_of_r_mask            (0x00010000)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_r_mask               (0x0000FFFF)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_ad_max_r(data)                   (0xFC000000&((data)<<26))
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_ad_min_r(data)                   (0x03F00000&((data)<<20))
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_no_dis_reset_r(data)             (0x00080000&((data)<<19))
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_thd_r(data)              (0x00040000&((data)<<18))
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_r(data)                  (0x00020000&((data)<<17))
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_of_r(data)           (0x00010000&((data)<<16))
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_r(data)              (0x0000FFFF&(data))
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_get_ad_max_r(data)               ((0xFC000000&(data))>>26)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_get_ad_min_r(data)               ((0x03F00000&(data))>>20)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_get_no_dis_reset_r(data)         ((0x00080000&(data))>>19)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_get_bit_err_thd_r(data)          ((0x00040000&(data))>>18)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_get_bit_err_r(data)              ((0x00020000&(data))>>17)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_get_bit_err_cnt_of_r(data)       ((0x00010000&(data))>>16)
+#define HDMI_VIDEO_BIT_ERR_STATUS_R_get_bit_err_cnt_r(data)          (0x0000FFFF&(data))
+
+
+#define HDMI_TERC4_ERR_DET                                           0x070
+#define HDMI_TERC4_ERR_DET_reg_addr                                  "0x98034070"
+#define HDMI_TERC4_ERR_DET_reg                                       0x98034070
+#define HDMI_TERC4_ERR_DET_inst_addr                                 "0x001C"
+#define HDMI_TERC4_ERR_DET_inst                                      0x001C
+#define HDMI_TERC4_ERR_DET_terc4_thd_shift                           (0)
+#define HDMI_TERC4_ERR_DET_terc4_thd_mask                            (0x0000FFFF)
+#define HDMI_TERC4_ERR_DET_terc4_thd(data)                           (0x0000FFFF&(data))
+#define HDMI_TERC4_ERR_DET_get_terc4_thd(data)                       (0x0000FFFF&(data))
+
+
+#define HDMI_TERC4_ERR_STATUS_B                                      0x074
+#define HDMI_TERC4_ERR_STATUS_B_reg_addr                             "0x98034074"
+#define HDMI_TERC4_ERR_STATUS_B_reg                                  0x98034074
+#define HDMI_TERC4_ERR_STATUS_B_inst_addr                            "0x001D"
+#define HDMI_TERC4_ERR_STATUS_B_inst                                 0x001D
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_thd_b_shift                (18)
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_b_shift                    (17)
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_of_b_shift             (16)
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_b_shift                (0)
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_thd_b_mask                 (0x00040000)
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_b_mask                     (0x00020000)
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_of_b_mask              (0x00010000)
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_b_mask                 (0x0000FFFF)
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_thd_b(data)                (0x00040000&((data)<<18))
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_b(data)                    (0x00020000&((data)<<17))
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_of_b(data)             (0x00010000&((data)<<16))
+#define HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_b(data)                (0x0000FFFF&(data))
+#define HDMI_TERC4_ERR_STATUS_B_get_terc4_err_thd_b(data)            ((0x00040000&(data))>>18)
+#define HDMI_TERC4_ERR_STATUS_B_get_terc4_err_b(data)                ((0x00020000&(data))>>17)
+#define HDMI_TERC4_ERR_STATUS_B_get_terc4_err_cnt_of_b(data)         ((0x00010000&(data))>>16)
+#define HDMI_TERC4_ERR_STATUS_B_get_terc4_err_cnt_b(data)            (0x0000FFFF&(data))
+
+
+#define HDMI_TERC4_ERR_STATUS_G                                      0x078
+#define HDMI_TERC4_ERR_STATUS_G_reg_addr                             "0x98034078"
+#define HDMI_TERC4_ERR_STATUS_G_reg                                  0x98034078
+#define HDMI_TERC4_ERR_STATUS_G_inst_addr                            "0x001E"
+#define HDMI_TERC4_ERR_STATUS_G_inst                                 0x001E
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_thd_g_shift                (18)
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_g_shift                    (17)
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_of_g_shift             (16)
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_g_shift                (0)
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_thd_g_mask                 (0x00040000)
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_g_mask                     (0x00020000)
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_of_g_mask              (0x00010000)
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_g_mask                 (0x0000FFFF)
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_thd_g(data)                (0x00040000&((data)<<18))
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_g(data)                    (0x00020000&((data)<<17))
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_of_g(data)             (0x00010000&((data)<<16))
+#define HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_g(data)                (0x0000FFFF&(data))
+#define HDMI_TERC4_ERR_STATUS_G_get_terc4_err_thd_g(data)            ((0x00040000&(data))>>18)
+#define HDMI_TERC4_ERR_STATUS_G_get_terc4_err_g(data)                ((0x00020000&(data))>>17)
+#define HDMI_TERC4_ERR_STATUS_G_get_terc4_err_cnt_of_g(data)         ((0x00010000&(data))>>16)
+#define HDMI_TERC4_ERR_STATUS_G_get_terc4_err_cnt_g(data)            (0x0000FFFF&(data))
+
+
+#define HDMI_TERC4_ERR_STATUS_R                                      0x07c
+#define HDMI_TERC4_ERR_STATUS_R_reg_addr                             "0x9803407c"
+#define HDMI_TERC4_ERR_STATUS_R_reg                                  0x9803407c
+#define HDMI_TERC4_ERR_STATUS_R_inst_addr                            "0x001F"
+#define HDMI_TERC4_ERR_STATUS_R_inst                                 0x001F
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_thd_r_shift                (18)
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_r_shift                    (17)
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_of_r_shift             (16)
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_r_shift                (0)
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_thd_r_mask                 (0x00040000)
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_r_mask                     (0x00020000)
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_of_r_mask              (0x00010000)
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_r_mask                 (0x0000FFFF)
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_thd_r(data)                (0x00040000&((data)<<18))
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_r(data)                    (0x00020000&((data)<<17))
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_of_r(data)             (0x00010000&((data)<<16))
+#define HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_r(data)                (0x0000FFFF&(data))
+#define HDMI_TERC4_ERR_STATUS_R_get_terc4_err_thd_r(data)            ((0x00040000&(data))>>18)
+#define HDMI_TERC4_ERR_STATUS_R_get_terc4_err_r(data)                ((0x00020000&(data))>>17)
+#define HDMI_TERC4_ERR_STATUS_R_get_terc4_err_cnt_of_r(data)         ((0x00010000&(data))>>16)
+#define HDMI_TERC4_ERR_STATUS_R_get_terc4_err_cnt_r(data)            (0x0000FFFF&(data))
+
+
+#define HDMI_SR                                                 0x080
+#define HDMI_SR_reg_addr                                        "0x98034080"
+#define HDMI_SR_reg                                             0x98034080
+#define HDMI_SR_inst_addr                                       "0x0020"
+#define HDMI_SR_inst                                            0x0020
+#define HDMI_SR_avmute_bg_shift                                 (7)
+#define HDMI_SR_avmute_shift                                    (6)
+#define HDMI_SR_vic_shift                                       (5)
+#define HDMI_SR_spdiftype_shift                                 (4)
+#define HDMI_SR_pllsts_shift                                    (3)
+#define HDMI_SR_afifoof_shift                                   (2)
+#define HDMI_SR_afifouf_shift                                   (1)
+#define HDMI_SR_mode_shift                                      (0)
+#define HDMI_SR_avmute_bg_mask                                  (0x00000080)
+#define HDMI_SR_avmute_mask                                     (0x00000040)
+#define HDMI_SR_vic_mask                                        (0x00000020)
+#define HDMI_SR_spdiftype_mask                                  (0x00000010)
+#define HDMI_SR_pllsts_mask                                     (0x00000008)
+#define HDMI_SR_afifoof_mask                                    (0x00000004)
+#define HDMI_SR_afifouf_mask                                    (0x00000002)
+#define HDMI_SR_mode_mask                                       (0x00000001)
+#define HDMI_SR_avmute_bg(data)                                 (0x00000080&((data)<<7))
+#define HDMI_SR_avmute(data)                                    (0x00000040&((data)<<6))
+#define HDMI_SR_vic(data)                                       (0x00000020&((data)<<5))
+#define HDMI_SR_spdiftype(data)                                 (0x00000010&((data)<<4))
+#define HDMI_SR_pllsts(data)                                    (0x00000008&((data)<<3))
+#define HDMI_SR_afifoof(data)                                   (0x00000004&((data)<<2))
+#define HDMI_SR_afifouf(data)                                   (0x00000002&((data)<<1))
+#define HDMI_SR_mode(data)                                      (0x00000001&(data))
+#define HDMI_SR_get_avmute_bg(data)                             ((0x00000080&(data))>>7)
+#define HDMI_SR_get_avmute(data)                                ((0x00000040&(data))>>6)
+#define HDMI_SR_get_vic(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_SR_get_spdiftype(data)                             ((0x00000010&(data))>>4)
+#define HDMI_SR_get_pllsts(data)                                ((0x00000008&(data))>>3)
+#define HDMI_SR_get_afifoof(data)                               ((0x00000004&(data))>>2)
+#define HDMI_SR_get_afifouf(data)                               ((0x00000002&(data))>>1)
+#define HDMI_SR_get_mode(data)                                  (0x00000001&(data))
+
+
+#define HDMI_GPVS                                               0x084
+#define HDMI_GPVS_reg_addr                                      "0x98034084"
+#define HDMI_GPVS_reg                                           0x98034084
+#define HDMI_GPVS_inst_addr                                     "0x0021"
+#define HDMI_GPVS_inst                                          0x0021
+#define HDMI_GPVS_dummy98034084_31_shift                        (31)
+#define HDMI_GPVS_dummy98034084_30_shift                        (30)
+#define HDMI_GPVS_dummy98034084_29_shift                        (29)
+#define HDMI_GPVS_dummy98034084_28_shift                        (28)
+#define HDMI_GPVS_drmps_v_shift                                 (27)
+#define HDMI_GPVS_mpegps_v_shift                                (26)
+#define HDMI_GPVS_aps_v_shift                                   (25)
+#define HDMI_GPVS_spdps_v_shift                                 (24)
+#define HDMI_GPVS_avips_v_shift                                 (23)
+#define HDMI_GPVS_vsps_v_shift                                  (22)
+#define HDMI_GPVS_gmps_v_shift                                  (21)
+#define HDMI_GPVS_isrc1ps_v_shift                               (20)
+#define HDMI_GPVS_acpps_v_shift                                 (19)
+#define HDMI_GPVS_dummy98034084_18_shift                        (18)
+#define HDMI_GPVS_dummy98034084_17_shift                        (17)
+#define HDMI_GPVS_dummy98034084_16_shift                        (16)
+#define HDMI_GPVS_dummy98034084_15_shift                        (15)
+#define HDMI_GPVS_drmps_shift                                   (14)
+#define HDMI_GPVS_mpegps_shift                                  (13)
+#define HDMI_GPVS_aps_shift                                     (12)
+#define HDMI_GPVS_spdps_shift                                   (11)
+#define HDMI_GPVS_avips_shift                                   (10)
+#define HDMI_GPVS_fvsps_shift                                   (9)
+#define HDMI_GPVS_vsps_shift                                    (8)
+#define HDMI_GPVS_gmps_shift                                    (7)
+#define HDMI_GPVS_isrc1ps_shift                                 (6)
+#define HDMI_GPVS_acpps_shift                                   (5)
+#define HDMI_GPVS_nps_shift                                     (4)
+#define HDMI_GPVS_rsv3ps_shift                                  (3)
+#define HDMI_GPVS_rsv2ps_shift                                  (2)
+#define HDMI_GPVS_rsv1ps_shift                                  (1)
+#define HDMI_GPVS_rsv0ps_shift                                  (0)
+#define HDMI_GPVS_dummy98034084_31_mask                         (0x80000000)
+#define HDMI_GPVS_dummy98034084_30_mask                         (0x40000000)
+#define HDMI_GPVS_dummy98034084_29_mask                         (0x20000000)
+#define HDMI_GPVS_dummy98034084_28_mask                         (0x10000000)
+#define HDMI_GPVS_drmps_v_mask                                  (0x08000000)
+#define HDMI_GPVS_mpegps_v_mask                                 (0x04000000)
+#define HDMI_GPVS_aps_v_mask                                    (0x02000000)
+#define HDMI_GPVS_spdps_v_mask                                  (0x01000000)
+#define HDMI_GPVS_avips_v_mask                                  (0x00800000)
+#define HDMI_GPVS_vsps_v_mask                                   (0x00400000)
+#define HDMI_GPVS_gmps_v_mask                                   (0x00200000)
+#define HDMI_GPVS_isrc1ps_v_mask                                (0x00100000)
+#define HDMI_GPVS_acpps_v_mask                                  (0x00080000)
+#define HDMI_GPVS_dummy98034084_18_mask                         (0x00040000)
+#define HDMI_GPVS_dummy98034084_17_mask                         (0x00020000)
+#define HDMI_GPVS_dummy98034084_16_mask                         (0x00010000)
+#define HDMI_GPVS_dummy98034084_15_mask                         (0x00008000)
+#define HDMI_GPVS_drmps_mask                                    (0x00004000)
+#define HDMI_GPVS_mpegps_mask                                   (0x00002000)
+#define HDMI_GPVS_aps_mask                                      (0x00001000)
+#define HDMI_GPVS_spdps_mask                                    (0x00000800)
+#define HDMI_GPVS_avips_mask                                    (0x00000400)
+#define HDMI_GPVS_fvsps_mask                                    (0x00000200)
+#define HDMI_GPVS_vsps_mask                                     (0x00000100)
+#define HDMI_GPVS_gmps_mask                                     (0x00000080)
+#define HDMI_GPVS_isrc1ps_mask                                  (0x00000040)
+#define HDMI_GPVS_acpps_mask                                    (0x00000020)
+#define HDMI_GPVS_nps_mask                                      (0x00000010)
+#define HDMI_GPVS_rsv3ps_mask                                   (0x00000008)
+#define HDMI_GPVS_rsv2ps_mask                                   (0x00000004)
+#define HDMI_GPVS_rsv1ps_mask                                   (0x00000002)
+#define HDMI_GPVS_rsv0ps_mask                                   (0x00000001)
+#define HDMI_GPVS_dummy98034084_31(data)                        (0x80000000&((data)<<31))
+#define HDMI_GPVS_dummy98034084_30(data)                        (0x40000000&((data)<<30))
+#define HDMI_GPVS_dummy98034084_29(data)                        (0x20000000&((data)<<29))
+#define HDMI_GPVS_dummy98034084_28(data)                        (0x10000000&((data)<<28))
+#define HDMI_GPVS_drmps_v(data)                                 (0x08000000&((data)<<27))
+#define HDMI_GPVS_mpegps_v(data)                                (0x04000000&((data)<<26))
+#define HDMI_GPVS_aps_v(data)                                   (0x02000000&((data)<<25))
+#define HDMI_GPVS_spdps_v(data)                                 (0x01000000&((data)<<24))
+#define HDMI_GPVS_avips_v(data)                                 (0x00800000&((data)<<23))
+#define HDMI_GPVS_vsps_v(data)                                  (0x00400000&((data)<<22))
+#define HDMI_GPVS_gmps_v(data)                                  (0x00200000&((data)<<21))
+#define HDMI_GPVS_isrc1ps_v(data)                               (0x00100000&((data)<<20))
+#define HDMI_GPVS_acpps_v(data)                                 (0x00080000&((data)<<19))
+#define HDMI_GPVS_dummy98034084_18(data)                        (0x00040000&((data)<<18))
+#define HDMI_GPVS_dummy98034084_17(data)                        (0x00020000&((data)<<17))
+#define HDMI_GPVS_dummy98034084_16(data)                        (0x00010000&((data)<<16))
+#define HDMI_GPVS_dummy98034084_15(data)                        (0x00008000&((data)<<15))
+#define HDMI_GPVS_drmps(data)                                   (0x00004000&((data)<<14))
+#define HDMI_GPVS_mpegps(data)                                  (0x00002000&((data)<<13))
+#define HDMI_GPVS_aps(data)                                     (0x00001000&((data)<<12))
+#define HDMI_GPVS_spdps(data)                                   (0x00000800&((data)<<11))
+#define HDMI_GPVS_avips(data)                                   (0x00000400&((data)<<10))
+#define HDMI_GPVS_fvsps(data)                                   (0x00000200&((data)<<9))
+#define HDMI_GPVS_vsps(data)                                    (0x00000100&((data)<<8))
+#define HDMI_GPVS_gmps(data)                                    (0x00000080&((data)<<7))
+#define HDMI_GPVS_isrc1ps(data)                                 (0x00000040&((data)<<6))
+#define HDMI_GPVS_acpps(data)                                   (0x00000020&((data)<<5))
+#define HDMI_GPVS_nps(data)                                     (0x00000010&((data)<<4))
+#define HDMI_GPVS_rsv3ps(data)                                  (0x00000008&((data)<<3))
+#define HDMI_GPVS_rsv2ps(data)                                  (0x00000004&((data)<<2))
+#define HDMI_GPVS_rsv1ps(data)                                  (0x00000002&((data)<<1))
+#define HDMI_GPVS_rsv0ps(data)                                  (0x00000001&(data))
+#define HDMI_GPVS_get_dummy98034084_31(data)                    ((0x80000000&(data))>>31)
+#define HDMI_GPVS_get_dummy98034084_30(data)                    ((0x40000000&(data))>>30)
+#define HDMI_GPVS_get_dummy98034084_29(data)                    ((0x20000000&(data))>>29)
+#define HDMI_GPVS_get_dummy98034084_28(data)                    ((0x10000000&(data))>>28)
+#define HDMI_GPVS_get_drmps_v(data)                             ((0x08000000&(data))>>27)
+#define HDMI_GPVS_get_mpegps_v(data)                            ((0x04000000&(data))>>26)
+#define HDMI_GPVS_get_aps_v(data)                               ((0x02000000&(data))>>25)
+#define HDMI_GPVS_get_spdps_v(data)                             ((0x01000000&(data))>>24)
+#define HDMI_GPVS_get_avips_v(data)                             ((0x00800000&(data))>>23)
+#define HDMI_GPVS_get_vsps_v(data)                              ((0x00400000&(data))>>22)
+#define HDMI_GPVS_get_gmps_v(data)                              ((0x00200000&(data))>>21)
+#define HDMI_GPVS_get_isrc1ps_v(data)                           ((0x00100000&(data))>>20)
+#define HDMI_GPVS_get_acpps_v(data)                             ((0x00080000&(data))>>19)
+#define HDMI_GPVS_get_dummy98034084_18(data)                    ((0x00040000&(data))>>18)
+#define HDMI_GPVS_get_dummy98034084_17(data)                    ((0x00020000&(data))>>17)
+#define HDMI_GPVS_get_dummy98034084_16(data)                    ((0x00010000&(data))>>16)
+#define HDMI_GPVS_get_dummy98034084_15(data)                    ((0x00008000&(data))>>15)
+#define HDMI_GPVS_get_drmps(data)                               ((0x00004000&(data))>>14)
+#define HDMI_GPVS_get_mpegps(data)                              ((0x00002000&(data))>>13)
+#define HDMI_GPVS_get_aps(data)                                 ((0x00001000&(data))>>12)
+#define HDMI_GPVS_get_spdps(data)                               ((0x00000800&(data))>>11)
+#define HDMI_GPVS_get_avips(data)                               ((0x00000400&(data))>>10)
+#define HDMI_GPVS_get_fvsps(data)                               ((0x00000200&(data))>>9)
+#define HDMI_GPVS_get_vsps(data)                                ((0x00000100&(data))>>8)
+#define HDMI_GPVS_get_gmps(data)                                ((0x00000080&(data))>>7)
+#define HDMI_GPVS_get_isrc1ps(data)                             ((0x00000040&(data))>>6)
+#define HDMI_GPVS_get_acpps(data)                               ((0x00000020&(data))>>5)
+#define HDMI_GPVS_get_nps(data)                                 ((0x00000010&(data))>>4)
+#define HDMI_GPVS_get_rsv3ps(data)                              ((0x00000008&(data))>>3)
+#define HDMI_GPVS_get_rsv2ps(data)                              ((0x00000004&(data))>>2)
+#define HDMI_GPVS_get_rsv1ps(data)                              ((0x00000002&(data))>>1)
+#define HDMI_GPVS_get_rsv0ps(data)                              (0x00000001&(data))
+
+
+#define HDMI_PSAP                                               0x088
+#define HDMI_PSAP_reg_addr                                      "0x98034088"
+#define HDMI_PSAP_reg                                           0x98034088
+#define HDMI_PSAP_inst_addr                                     "0x0022"
+#define HDMI_PSAP_inst                                          0x0022
+#define HDMI_PSAP_apss_shift                                    (0)
+#define HDMI_PSAP_apss_mask                                     (0x000001FF)
+#define HDMI_PSAP_apss(data)                                    (0x000001FF&(data))
+#define HDMI_PSAP_get_apss(data)                                (0x000001FF&(data))
+
+
+#define HDMI_PSDP                                               0x08c
+#define HDMI_PSDP_reg_addr                                      "0x9803408c"
+#define HDMI_PSDP_reg                                           0x9803408c
+#define HDMI_PSDP_inst_addr                                     "0x0023"
+#define HDMI_PSDP_inst                                          0x0023
+#define HDMI_PSDP_dpss_shift                                    (0)
+#define HDMI_PSDP_dpss_mask                                     (0x000000FF)
+#define HDMI_PSDP_dpss(data)                                    (0x000000FF&(data))
+#define HDMI_PSDP_get_dpss(data)                                (0x000000FF&(data))
+
+
+#define HDMI_SCR                                                0x090
+#define HDMI_SCR_reg_addr                                       "0x98034090"
+#define HDMI_SCR_reg                                            0x98034090
+#define HDMI_SCR_inst_addr                                      "0x0024"
+#define HDMI_SCR_inst                                           0x0024
+#define HDMI_SCR_packet_header_parsing_mode_shift               (16)
+#define HDMI_SCR_nval_shift                                     (8)
+#define HDMI_SCR_no_vs_det_en_shift                             (6)
+#define HDMI_SCR_dvi_reset_ds_cm_en_shift                       (5)
+#define HDMI_SCR_packet_ignore_shift                            (4)
+#define HDMI_SCR_mode_shift                                     (3)
+#define HDMI_SCR_msmode_shift                                   (2)
+#define HDMI_SCR_cabs_shift                                     (1)
+#define HDMI_SCR_fcddip_shift                                   (0)
+#define HDMI_SCR_packet_header_parsing_mode_mask                (0x00010000)
+#define HDMI_SCR_nval_mask                                      (0x0000FF00)
+#define HDMI_SCR_no_vs_det_en_mask                              (0x00000040)
+#define HDMI_SCR_dvi_reset_ds_cm_en_mask                        (0x00000020)
+#define HDMI_SCR_packet_ignore_mask                             (0x00000010)
+#define HDMI_SCR_mode_mask                                      (0x00000008)
+#define HDMI_SCR_msmode_mask                                    (0x00000004)
+#define HDMI_SCR_cabs_mask                                      (0x00000002)
+#define HDMI_SCR_fcddip_mask                                    (0x00000001)
+#define HDMI_SCR_packet_header_parsing_mode(data)               (0x00010000&((data)<<16))
+#define HDMI_SCR_nval(data)                                     (0x0000FF00&((data)<<8))
+#define HDMI_SCR_no_vs_det_en(data)                             (0x00000040&((data)<<6))
+#define HDMI_SCR_dvi_reset_ds_cm_en(data)                       (0x00000020&((data)<<5))
+#define HDMI_SCR_packet_ignore(data)                            (0x00000010&((data)<<4))
+#define HDMI_SCR_mode(data)                                     (0x00000008&((data)<<3))
+#define HDMI_SCR_msmode(data)                                   (0x00000004&((data)<<2))
+#define HDMI_SCR_cabs(data)                                     (0x00000002&((data)<<1))
+#define HDMI_SCR_fcddip(data)                                   (0x00000001&(data))
+#define HDMI_SCR_get_packet_header_parsing_mode(data)           ((0x00010000&(data))>>16)
+#define HDMI_SCR_get_nval(data)                                 ((0x0000FF00&(data))>>8)
+#define HDMI_SCR_get_no_vs_det_en(data)                         ((0x00000040&(data))>>6)
+#define HDMI_SCR_get_dvi_reset_ds_cm_en(data)                   ((0x00000020&(data))>>5)
+#define HDMI_SCR_get_packet_ignore(data)                        ((0x00000010&(data))>>4)
+#define HDMI_SCR_get_mode(data)                                 ((0x00000008&(data))>>3)
+#define HDMI_SCR_get_msmode(data)                               ((0x00000004&(data))>>2)
+#define HDMI_SCR_get_cabs(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_SCR_get_fcddip(data)                               (0x00000001&(data))
+
+
+#define HDMI_BCHCR                                              0x094
+#define HDMI_BCHCR_reg_addr                                     "0x98034094"
+#define HDMI_BCHCR_reg                                          0x98034094
+#define HDMI_BCHCR_inst_addr                                    "0x0025"
+#define HDMI_BCHCR_inst                                         0x0025
+#define HDMI_BCHCR_spcss_shift                                  (5)
+#define HDMI_BCHCR_enrwe_shift                                  (4)
+#define HDMI_BCHCR_bche_shift                                   (3)
+#define HDMI_BCHCR_bches_shift                                  (2)
+#define HDMI_BCHCR_bches2_shift                                 (1)
+#define HDMI_BCHCR_pe_shift                                     (0)
+#define HDMI_BCHCR_spcss_mask                                   (0x00000020)
+#define HDMI_BCHCR_enrwe_mask                                   (0x00000010)
+#define HDMI_BCHCR_bche_mask                                    (0x00000008)
+#define HDMI_BCHCR_bches_mask                                   (0x00000004)
+#define HDMI_BCHCR_bches2_mask                                  (0x00000002)
+#define HDMI_BCHCR_pe_mask                                      (0x00000001)
+#define HDMI_BCHCR_spcss(data)                                  (0x00000020&((data)<<5))
+#define HDMI_BCHCR_enrwe(data)                                  (0x00000010&((data)<<4))
+#define HDMI_BCHCR_bche(data)                                   (0x00000008&((data)<<3))
+#define HDMI_BCHCR_bches(data)                                  (0x00000004&((data)<<2))
+#define HDMI_BCHCR_bches2(data)                                 (0x00000002&((data)<<1))
+#define HDMI_BCHCR_pe(data)                                     (0x00000001&(data))
+#define HDMI_BCHCR_get_spcss(data)                              ((0x00000020&(data))>>5)
+#define HDMI_BCHCR_get_enrwe(data)                              ((0x00000010&(data))>>4)
+#define HDMI_BCHCR_get_bche(data)                               ((0x00000008&(data))>>3)
+#define HDMI_BCHCR_get_bches(data)                              ((0x00000004&(data))>>2)
+#define HDMI_BCHCR_get_bches2(data)                             ((0x00000002&(data))>>1)
+#define HDMI_BCHCR_get_pe(data)                                 (0x00000001&(data))
+
+
+#define HDMI_AVMCR                                              0x098
+#define HDMI_AVMCR_reg_addr                                     "0x98034098"
+#define HDMI_AVMCR_reg                                          0x98034098
+#define HDMI_AVMCR_inst_addr                                    "0x0026"
+#define HDMI_AVMCR_inst                                         0x0026
+#define HDMI_AVMCR_wd_ptg_en_shift                              (10)
+#define HDMI_AVMCR_wd_vclk_en_shift                             (9)
+#define HDMI_AVMCR_avmute_flag_shift                            (8)
+#define HDMI_AVMCR_avmute_win_en_shift                          (7)
+#define HDMI_AVMCR_aoc_shift                                    (6)
+#define HDMI_AVMCR_aomc_shift                                   (5)
+#define HDMI_AVMCR_awd_shift                                    (4)
+#define HDMI_AVMCR_ve_shift                                     (3)
+#define HDMI_AVMCR_ampic_shift                                  (2)
+#define HDMI_AVMCR_vdpic_shift                                  (1)
+#define HDMI_AVMCR_nfpss_shift                                  (0)
+#define HDMI_AVMCR_wd_ptg_en_mask                               (0x00000400)
+#define HDMI_AVMCR_wd_vclk_en_mask                              (0x00000200)
+#define HDMI_AVMCR_avmute_flag_mask                             (0x00000100)
+#define HDMI_AVMCR_avmute_win_en_mask                           (0x00000080)
+#define HDMI_AVMCR_aoc_mask                                     (0x00000040)
+#define HDMI_AVMCR_aomc_mask                                    (0x00000020)
+#define HDMI_AVMCR_awd_mask                                     (0x00000010)
+#define HDMI_AVMCR_ve_mask                                      (0x00000008)
+#define HDMI_AVMCR_ampic_mask                                   (0x00000004)
+#define HDMI_AVMCR_vdpic_mask                                   (0x00000002)
+#define HDMI_AVMCR_nfpss_mask                                   (0x00000001)
+#define HDMI_AVMCR_wd_ptg_en(data)                              (0x00000400&((data)<<10))
+#define HDMI_AVMCR_wd_vclk_en(data)                             (0x00000200&((data)<<9))
+#define HDMI_AVMCR_avmute_flag(data)                            (0x00000100&((data)<<8))
+#define HDMI_AVMCR_avmute_win_en(data)                          (0x00000080&((data)<<7))
+#define HDMI_AVMCR_aoc(data)                                    (0x00000040&((data)<<6))
+#define HDMI_AVMCR_aomc(data)                                   (0x00000020&((data)<<5))
+#define HDMI_AVMCR_awd(data)                                    (0x00000010&((data)<<4))
+#define HDMI_AVMCR_ve(data)                                     (0x00000008&((data)<<3))
+#define HDMI_AVMCR_ampic(data)                                  (0x00000004&((data)<<2))
+#define HDMI_AVMCR_vdpic(data)                                  (0x00000002&((data)<<1))
+#define HDMI_AVMCR_nfpss(data)                                  (0x00000001&(data))
+#define HDMI_AVMCR_get_wd_ptg_en(data)                          ((0x00000400&(data))>>10)
+#define HDMI_AVMCR_get_wd_vclk_en(data)                         ((0x00000200&(data))>>9)
+#define HDMI_AVMCR_get_avmute_flag(data)                        ((0x00000100&(data))>>8)
+#define HDMI_AVMCR_get_avmute_win_en(data)                      ((0x00000080&(data))>>7)
+#define HDMI_AVMCR_get_aoc(data)                                ((0x00000040&(data))>>6)
+#define HDMI_AVMCR_get_aomc(data)                               ((0x00000020&(data))>>5)
+#define HDMI_AVMCR_get_awd(data)                                ((0x00000010&(data))>>4)
+#define HDMI_AVMCR_get_ve(data)                                 ((0x00000008&(data))>>3)
+#define HDMI_AVMCR_get_ampic(data)                              ((0x00000004&(data))>>2)
+#define HDMI_AVMCR_get_vdpic(data)                              ((0x00000002&(data))>>1)
+#define HDMI_AVMCR_get_nfpss(data)                              (0x00000001&(data))
+
+
+#define HDMI_WDCR0                                              0x09c
+#define HDMI_WDCR0_reg_addr                                     "0x9803409c"
+#define HDMI_WDCR0_reg                                          0x9803409c
+#define HDMI_WDCR0_inst_addr                                    "0x0027"
+#define HDMI_WDCR0_inst                                         0x0027
+#define HDMI_WDCR0_wdm_shift                                    (27)
+#define HDMI_WDCR0_wds_shift                                    (26)
+#define HDMI_WDCR0_awdch_shift                                  (25)
+#define HDMI_WDCR0_vwdch_shift                                  (24)
+#define HDMI_WDCR0_vwdap_shift                                  (23)
+#define HDMI_WDCR0_vwdlf_shift                                  (22)
+#define HDMI_WDCR0_vwdafo_shift                                 (21)
+#define HDMI_WDCR0_vwdafu_shift                                 (20)
+#define HDMI_WDCR0_yv_shift                                     (16)
+#define HDMI_WDCR0_awdck_shift                                  (15)
+#define HDMI_WDCR0_awdlf_shift                                  (14)
+#define HDMI_WDCR0_ch_st_sel_shift                              (13)
+#define HDMI_WDCR0_vwdact_shift                                 (12)
+#define HDMI_WDCR0_xv_shift                                     (8)
+#define HDMI_WDCR0_asmfe_shift                                  (7)
+#define HDMI_WDCR0_load_d_shift                                 (6)
+#define HDMI_WDCR0_bt_track_en_shift                            (5)
+#define HDMI_WDCR0_awdct_shift                                  (4)
+#define HDMI_WDCR0_awdap_shift                                  (3)
+#define HDMI_WDCR0_awdfo_shift                                  (2)
+#define HDMI_WDCR0_awdfu_shift                                  (1)
+#define HDMI_WDCR0_ct_shift                                     (0)
+#define HDMI_WDCR0_wdm_mask                                     (0x08000000)
+#define HDMI_WDCR0_wds_mask                                     (0x04000000)
+#define HDMI_WDCR0_awdch_mask                                   (0x02000000)
+#define HDMI_WDCR0_vwdch_mask                                   (0x01000000)
+#define HDMI_WDCR0_vwdap_mask                                   (0x00800000)
+#define HDMI_WDCR0_vwdlf_mask                                   (0x00400000)
+#define HDMI_WDCR0_vwdafo_mask                                  (0x00200000)
+#define HDMI_WDCR0_vwdafu_mask                                  (0x00100000)
+#define HDMI_WDCR0_yv_mask                                      (0x000F0000)
+#define HDMI_WDCR0_awdck_mask                                   (0x00008000)
+#define HDMI_WDCR0_awdlf_mask                                   (0x00004000)
+#define HDMI_WDCR0_ch_st_sel_mask                               (0x00002000)
+#define HDMI_WDCR0_vwdact_mask                                  (0x00001000)
+#define HDMI_WDCR0_xv_mask                                      (0x00000F00)
+#define HDMI_WDCR0_asmfe_mask                                   (0x00000080)
+#define HDMI_WDCR0_load_d_mask                                  (0x00000040)
+#define HDMI_WDCR0_bt_track_en_mask                             (0x00000020)
+#define HDMI_WDCR0_awdct_mask                                   (0x00000010)
+#define HDMI_WDCR0_awdap_mask                                   (0x00000008)
+#define HDMI_WDCR0_awdfo_mask                                   (0x00000004)
+#define HDMI_WDCR0_awdfu_mask                                   (0x00000002)
+#define HDMI_WDCR0_ct_mask                                      (0x00000001)
+#define HDMI_WDCR0_wdm(data)                                    (0x08000000&((data)<<27))
+#define HDMI_WDCR0_wds(data)                                    (0x04000000&((data)<<26))
+#define HDMI_WDCR0_awdch(data)                                  (0x02000000&((data)<<25))
+#define HDMI_WDCR0_vwdch(data)                                  (0x01000000&((data)<<24))
+#define HDMI_WDCR0_vwdap(data)                                  (0x00800000&((data)<<23))
+#define HDMI_WDCR0_vwdlf(data)                                  (0x00400000&((data)<<22))
+#define HDMI_WDCR0_vwdafo(data)                                 (0x00200000&((data)<<21))
+#define HDMI_WDCR0_vwdafu(data)                                 (0x00100000&((data)<<20))
+#define HDMI_WDCR0_yv(data)                                     (0x000F0000&((data)<<16))
+#define HDMI_WDCR0_awdck(data)                                  (0x00008000&((data)<<15))
+#define HDMI_WDCR0_awdlf(data)                                  (0x00004000&((data)<<14))
+#define HDMI_WDCR0_ch_st_sel(data)                              (0x00002000&((data)<<13))
+#define HDMI_WDCR0_vwdact(data)                                 (0x00001000&((data)<<12))
+#define HDMI_WDCR0_xv(data)                                     (0x00000F00&((data)<<8))
+#define HDMI_WDCR0_asmfe(data)                                  (0x00000080&((data)<<7))
+#define HDMI_WDCR0_load_d(data)                                 (0x00000040&((data)<<6))
+#define HDMI_WDCR0_bt_track_en(data)                            (0x00000020&((data)<<5))
+#define HDMI_WDCR0_awdct(data)                                  (0x00000010&((data)<<4))
+#define HDMI_WDCR0_awdap(data)                                  (0x00000008&((data)<<3))
+#define HDMI_WDCR0_awdfo(data)                                  (0x00000004&((data)<<2))
+#define HDMI_WDCR0_awdfu(data)                                  (0x00000002&((data)<<1))
+#define HDMI_WDCR0_ct(data)                                     (0x00000001&(data))
+#define HDMI_WDCR0_get_wdm(data)                                ((0x08000000&(data))>>27)
+#define HDMI_WDCR0_get_wds(data)                                ((0x04000000&(data))>>26)
+#define HDMI_WDCR0_get_awdch(data)                              ((0x02000000&(data))>>25)
+#define HDMI_WDCR0_get_vwdch(data)                              ((0x01000000&(data))>>24)
+#define HDMI_WDCR0_get_vwdap(data)                              ((0x00800000&(data))>>23)
+#define HDMI_WDCR0_get_vwdlf(data)                              ((0x00400000&(data))>>22)
+#define HDMI_WDCR0_get_vwdafo(data)                             ((0x00200000&(data))>>21)
+#define HDMI_WDCR0_get_vwdafu(data)                             ((0x00100000&(data))>>20)
+#define HDMI_WDCR0_get_yv(data)                                 ((0x000F0000&(data))>>16)
+#define HDMI_WDCR0_get_awdck(data)                              ((0x00008000&(data))>>15)
+#define HDMI_WDCR0_get_awdlf(data)                              ((0x00004000&(data))>>14)
+#define HDMI_WDCR0_get_ch_st_sel(data)                          ((0x00002000&(data))>>13)
+#define HDMI_WDCR0_get_vwdact(data)                             ((0x00001000&(data))>>12)
+#define HDMI_WDCR0_get_xv(data)                                 ((0x00000F00&(data))>>8)
+#define HDMI_WDCR0_get_asmfe(data)                              ((0x00000080&(data))>>7)
+#define HDMI_WDCR0_get_load_d(data)                             ((0x00000040&(data))>>6)
+#define HDMI_WDCR0_get_bt_track_en(data)                        ((0x00000020&(data))>>5)
+#define HDMI_WDCR0_get_awdct(data)                              ((0x00000010&(data))>>4)
+#define HDMI_WDCR0_get_awdap(data)                              ((0x00000008&(data))>>3)
+#define HDMI_WDCR0_get_awdfo(data)                              ((0x00000004&(data))>>2)
+#define HDMI_WDCR0_get_awdfu(data)                              ((0x00000002&(data))>>1)
+#define HDMI_WDCR0_get_ct(data)                                 (0x00000001&(data))
+
+
+#define HDMI_DBCR                                               0x0a0
+#define HDMI_DBCR_reg_addr                                      "0x980340a0"
+#define HDMI_DBCR_reg                                           0x980340a0
+#define HDMI_DBCR_inst_addr                                     "0x0028"
+#define HDMI_DBCR_inst                                          0x0028
+#define HDMI_DBCR_aldbfv_shift                                  (3)
+#define HDMI_DBCR_aldbfo_shift                                  (2)
+#define HDMI_DBCR_aldbfu_shift                                  (1)
+#define HDMI_DBCR_aldbpn_shift                                  (0)
+#define HDMI_DBCR_aldbfv_mask                                   (0x00000008)
+#define HDMI_DBCR_aldbfo_mask                                   (0x00000004)
+#define HDMI_DBCR_aldbfu_mask                                   (0x00000002)
+#define HDMI_DBCR_aldbpn_mask                                   (0x00000001)
+#define HDMI_DBCR_aldbfv(data)                                  (0x00000008&((data)<<3))
+#define HDMI_DBCR_aldbfo(data)                                  (0x00000004&((data)<<2))
+#define HDMI_DBCR_aldbfu(data)                                  (0x00000002&((data)<<1))
+#define HDMI_DBCR_aldbpn(data)                                  (0x00000001&(data))
+#define HDMI_DBCR_get_aldbfv(data)                              ((0x00000008&(data))>>3)
+#define HDMI_DBCR_get_aldbfo(data)                              ((0x00000004&(data))>>2)
+#define HDMI_DBCR_get_aldbfu(data)                              ((0x00000002&(data))>>1)
+#define HDMI_DBCR_get_aldbpn(data)                              (0x00000001&(data))
+
+
+#define HDMI_AWDSR                                              0x0a4
+#define HDMI_AWDSR_reg_addr                                     "0x980340a4"
+#define HDMI_AWDSR_reg                                          0x980340a4
+#define HDMI_AWDSR_inst_addr                                    "0x0029"
+#define HDMI_AWDSR_inst                                         0x0029
+#define HDMI_AWDSR_awdpvsb_shift                                (0)
+#define HDMI_AWDSR_awdpvsb_mask                                 (0x0000007F)
+#define HDMI_AWDSR_awdpvsb(data)                                (0x0000007F&(data))
+#define HDMI_AWDSR_get_awdpvsb(data)                            (0x0000007F&(data))
+
+
+#define HDMI_VWDSR                                              0x0a8
+#define HDMI_VWDSR_reg_addr                                     "0x980340a8"
+#define HDMI_VWDSR_reg                                          0x980340a8
+#define HDMI_VWDSR_inst_addr                                    "0x002A"
+#define HDMI_VWDSR_inst                                         0x002A
+#define HDMI_VWDSR_vwdpvsb_shift                                (0)
+#define HDMI_VWDSR_vwdpvsb_mask                                 (0x0000007F)
+#define HDMI_VWDSR_vwdpvsb(data)                                (0x0000007F&(data))
+#define HDMI_VWDSR_get_vwdpvsb(data)                            (0x0000007F&(data))
+
+
+#define HDMI_PAMICR                                             0x0ac
+#define HDMI_PAMICR_reg_addr                                    "0x980340ac"
+#define HDMI_PAMICR_reg                                         0x980340ac
+#define HDMI_PAMICR_inst_addr                                   "0x002B"
+#define HDMI_PAMICR_inst                                        0x002B
+#define HDMI_PAMICR_icpvsb_shift                                (0)
+#define HDMI_PAMICR_icpvsb_mask                                 (0x0000007F)
+#define HDMI_PAMICR_icpvsb(data)                                (0x0000007F&(data))
+#define HDMI_PAMICR_get_icpvsb(data)                            (0x0000007F&(data))
+
+
+#define HDMI_PTRSV1                                             0x0b0
+#define HDMI_PTRSV1_reg_addr                                    "0x980340b0"
+#define HDMI_PTRSV1_reg                                         0x980340b0
+#define HDMI_PTRSV1_inst_addr                                   "0x002C"
+#define HDMI_PTRSV1_inst                                        0x002C
+#define HDMI_PTRSV1_pt3_shift                                   (24)
+#define HDMI_PTRSV1_pt2_shift                                   (16)
+#define HDMI_PTRSV1_pt1_shift                                   (8)
+#define HDMI_PTRSV1_pt0_shift                                   (0)
+#define HDMI_PTRSV1_pt3_mask                                    (0xFF000000)
+#define HDMI_PTRSV1_pt2_mask                                    (0x00FF0000)
+#define HDMI_PTRSV1_pt1_mask                                    (0x0000FF00)
+#define HDMI_PTRSV1_pt0_mask                                    (0x000000FF)
+#define HDMI_PTRSV1_pt3(data)                                   (0xFF000000&((data)<<24))
+#define HDMI_PTRSV1_pt2(data)                                   (0x00FF0000&((data)<<16))
+#define HDMI_PTRSV1_pt1(data)                                   (0x0000FF00&((data)<<8))
+#define HDMI_PTRSV1_pt0(data)                                   (0x000000FF&(data))
+#define HDMI_PTRSV1_get_pt3(data)                               ((0xFF000000&(data))>>24)
+#define HDMI_PTRSV1_get_pt2(data)                               ((0x00FF0000&(data))>>16)
+#define HDMI_PTRSV1_get_pt1(data)                               ((0x0000FF00&(data))>>8)
+#define HDMI_PTRSV1_get_pt0(data)                               (0x000000FF&(data))
+
+
+#define HDMI_PVGCR0                                             0x0b4
+#define HDMI_PVGCR0_reg_addr                                    "0x980340b4"
+#define HDMI_PVGCR0_reg                                         0x980340b4
+#define HDMI_PVGCR0_inst_addr                                   "0x002D"
+#define HDMI_PVGCR0_inst                                        0x002D
+#define HDMI_PVGCR0_pvsef_shift                                 (0)
+#define HDMI_PVGCR0_pvsef_mask                                  (0xFFFFFFFF)
+#define HDMI_PVGCR0_pvsef(data)                                 (0xFFFFFFFF&(data))
+#define HDMI_PVGCR0_get_pvsef(data)                             (0xFFFFFFFF&(data))
+
+
+#define HDMI_PVSR0                                              0x0b8
+#define HDMI_PVSR0_reg_addr                                     "0x980340b8"
+#define HDMI_PVSR0_reg                                          0x980340b8
+#define HDMI_PVSR0_inst_addr                                    "0x002E"
+#define HDMI_PVSR0_inst                                         0x002E
+#define HDMI_PVSR0_pvs_shift                                    (0)
+#define HDMI_PVSR0_pvs_mask                                     (0xFFFFFFFF)
+#define HDMI_PVSR0_pvs(data)                                    (0xFFFFFFFF&(data))
+#define HDMI_PVSR0_get_pvs(data)                                (0xFFFFFFFF&(data))
+
+
+#define HDMI_VCR                                                0x0bc
+#define HDMI_VCR_reg_addr                                       "0x980340bc"
+#define HDMI_VCR_reg                                            0x980340bc
+#define HDMI_VCR_inst_addr                                      "0x002F"
+#define HDMI_VCR_inst                                           0x002F
+#define HDMI_VCR_cbus_ddc_chsel_shift                           (28)
+#define HDMI_VCR_hdmi_field_shift                               (27)
+#define HDMI_VCR_int_pro_chg_flag_shift                         (26)
+#define HDMI_VCR_int_pro_chg_wd_en_shift                        (25)
+#define HDMI_VCR_int_pro_chg_int_en_shift                       (24)
+#define HDMI_VCR_hdcp_ddc_chsel_shift                           (22)
+#define HDMI_VCR_iclk_sel_shift                                 (20)
+#define HDMI_VCR_csc_r_shift                                    (18)
+#define HDMI_VCR_hdirq_shift                                    (17)
+#define HDMI_VCR_csam_shift                                     (16)
+#define HDMI_VCR_csc_shift                                      (14)
+#define HDMI_VCR_field_decide_sel_shift                         (13)
+#define HDMI_VCR_prdsam_shift                                   (12)
+#define HDMI_VCR_dsc_r_shift                                    (8)
+#define HDMI_VCR_eoi_shift                                      (7)
+#define HDMI_VCR_eot_shift                                      (6)
+#define HDMI_VCR_se_shift                                       (5)
+#define HDMI_VCR_rs_shift                                       (4)
+#define HDMI_VCR_dsc_shift                                      (0)
+#define HDMI_VCR_cbus_ddc_chsel_mask                            (0x10000000)
+#define HDMI_VCR_hdmi_field_mask                                (0x08000000)
+#define HDMI_VCR_int_pro_chg_flag_mask                          (0x04000000)
+#define HDMI_VCR_int_pro_chg_wd_en_mask                         (0x02000000)
+#define HDMI_VCR_int_pro_chg_int_en_mask                        (0x01000000)
+#define HDMI_VCR_hdcp_ddc_chsel_mask                            (0x00C00000)
+#define HDMI_VCR_iclk_sel_mask                                  (0x00300000)
+#define HDMI_VCR_csc_r_mask                                     (0x000C0000)
+#define HDMI_VCR_hdirq_mask                                     (0x00020000)
+#define HDMI_VCR_csam_mask                                      (0x00010000)
+#define HDMI_VCR_csc_mask                                       (0x0000C000)
+#define HDMI_VCR_field_decide_sel_mask                          (0x00002000)
+#define HDMI_VCR_prdsam_mask                                    (0x00001000)
+#define HDMI_VCR_dsc_r_mask                                     (0x00000F00)
+#define HDMI_VCR_eoi_mask                                       (0x00000080)
+#define HDMI_VCR_eot_mask                                       (0x00000040)
+#define HDMI_VCR_se_mask                                        (0x00000020)
+#define HDMI_VCR_rs_mask                                        (0x00000010)
+#define HDMI_VCR_dsc_mask                                       (0x0000000F)
+#define HDMI_VCR_cbus_ddc_chsel(data)                           (0x10000000&((data)<<28))
+#define HDMI_VCR_hdmi_field(data)                               (0x08000000&((data)<<27))
+#define HDMI_VCR_int_pro_chg_flag(data)                         (0x04000000&((data)<<26))
+#define HDMI_VCR_int_pro_chg_wd_en(data)                        (0x02000000&((data)<<25))
+#define HDMI_VCR_int_pro_chg_int_en(data)                       (0x01000000&((data)<<24))
+#define HDMI_VCR_hdcp_ddc_chsel(data)                           (0x00C00000&((data)<<22))
+#define HDMI_VCR_iclk_sel(data)                                 (0x00300000&((data)<<20))
+#define HDMI_VCR_csc_r(data)                                    (0x000C0000&((data)<<18))
+#define HDMI_VCR_hdirq(data)                                    (0x00020000&((data)<<17))
+#define HDMI_VCR_csam(data)                                     (0x00010000&((data)<<16))
+#define HDMI_VCR_csc(data)                                      (0x0000C000&((data)<<14))
+#define HDMI_VCR_field_decide_sel(data)                         (0x00002000&((data)<<13))
+#define HDMI_VCR_prdsam(data)                                   (0x00001000&((data)<<12))
+#define HDMI_VCR_dsc_r(data)                                    (0x00000F00&((data)<<8))
+#define HDMI_VCR_eoi(data)                                      (0x00000080&((data)<<7))
+#define HDMI_VCR_eot(data)                                      (0x00000040&((data)<<6))
+#define HDMI_VCR_se(data)                                       (0x00000020&((data)<<5))
+#define HDMI_VCR_rs(data)                                       (0x00000010&((data)<<4))
+#define HDMI_VCR_dsc(data)                                      (0x0000000F&(data))
+#define HDMI_VCR_get_cbus_ddc_chsel(data)                       ((0x10000000&(data))>>28)
+#define HDMI_VCR_get_hdmi_field(data)                           ((0x08000000&(data))>>27)
+#define HDMI_VCR_get_int_pro_chg_flag(data)                     ((0x04000000&(data))>>26)
+#define HDMI_VCR_get_int_pro_chg_wd_en(data)                    ((0x02000000&(data))>>25)
+#define HDMI_VCR_get_int_pro_chg_int_en(data)                   ((0x01000000&(data))>>24)
+#define HDMI_VCR_get_hdcp_ddc_chsel(data)                       ((0x00C00000&(data))>>22)
+#define HDMI_VCR_get_iclk_sel(data)                             ((0x00300000&(data))>>20)
+#define HDMI_VCR_get_csc_r(data)                                ((0x000C0000&(data))>>18)
+#define HDMI_VCR_get_hdirq(data)                                ((0x00020000&(data))>>17)
+#define HDMI_VCR_get_csam(data)                                 ((0x00010000&(data))>>16)
+#define HDMI_VCR_get_csc(data)                                  ((0x0000C000&(data))>>14)
+#define HDMI_VCR_get_field_decide_sel(data)                     ((0x00002000&(data))>>13)
+#define HDMI_VCR_get_prdsam(data)                               ((0x00001000&(data))>>12)
+#define HDMI_VCR_get_dsc_r(data)                                ((0x00000F00&(data))>>8)
+#define HDMI_VCR_get_eoi(data)                                  ((0x00000080&(data))>>7)
+#define HDMI_VCR_get_eot(data)                                  ((0x00000040&(data))>>6)
+#define HDMI_VCR_get_se(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_VCR_get_rs(data)                                   ((0x00000010&(data))>>4)
+#define HDMI_VCR_get_dsc(data)                                  (0x0000000F&(data))
+
+
+#define HDMI_ACRCR                                              0x0c0
+#define HDMI_ACRCR_reg_addr                                     "0x980340c0"
+#define HDMI_ACRCR_reg                                          0x980340c0
+#define HDMI_ACRCR_inst_addr                                    "0x0030"
+#define HDMI_ACRCR_inst                                         0x0030
+#define HDMI_ACRCR_pucnr_shift                                  (1)
+#define HDMI_ACRCR_pucsr_shift                                  (0)
+#define HDMI_ACRCR_pucnr_mask                                   (0x00000002)
+#define HDMI_ACRCR_pucsr_mask                                   (0x00000001)
+#define HDMI_ACRCR_pucnr(data)                                  (0x00000002&((data)<<1))
+#define HDMI_ACRCR_pucsr(data)                                  (0x00000001&(data))
+#define HDMI_ACRCR_get_pucnr(data)                              ((0x00000002&(data))>>1)
+#define HDMI_ACRCR_get_pucsr(data)                              (0x00000001&(data))
+
+
+#define HDMI_ACRSR0                                             0x0c4
+#define HDMI_ACRSR0_reg_addr                                    "0x980340c4"
+#define HDMI_ACRSR0_reg                                         0x980340c4
+#define HDMI_ACRSR0_inst_addr                                   "0x0031"
+#define HDMI_ACRSR0_inst                                        0x0031
+#define HDMI_ACRSR0_cts_shift                                   (0)
+#define HDMI_ACRSR0_cts_mask                                    (0x000FFFFF)
+#define HDMI_ACRSR0_cts(data)                                   (0x000FFFFF&(data))
+#define HDMI_ACRSR0_get_cts(data)                               (0x000FFFFF&(data))
+
+
+#define HDMI_ACRSR1                                             0x0c8
+#define HDMI_ACRSR1_reg_addr                                    "0x980340c8"
+#define HDMI_ACRSR1_reg                                         0x980340c8
+#define HDMI_ACRSR1_inst_addr                                   "0x0032"
+#define HDMI_ACRSR1_inst                                        0x0032
+#define HDMI_ACRSR1_n_shift                                     (0)
+#define HDMI_ACRSR1_n_mask                                      (0x000FFFFF)
+#define HDMI_ACRSR1_n(data)                                     (0x000FFFFF&(data))
+#define HDMI_ACRSR1_get_n(data)                                 (0x000FFFFF&(data))
+
+
+#define HDMI_ACS0                                               0x0cc
+#define HDMI_ACS0_reg_addr                                      "0x980340cc"
+#define HDMI_ACS0_reg                                           0x980340cc
+#define HDMI_ACS0_inst_addr                                     "0x0033"
+#define HDMI_ACS0_inst                                          0x0033
+#define HDMI_ACS0_cs_shift                                      (0)
+#define HDMI_ACS0_cs_mask                                       (0x0000FFFF)
+#define HDMI_ACS0_cs(data)                                      (0x0000FFFF&(data))
+#define HDMI_ACS0_get_cs(data)                                  (0x0000FFFF&(data))
+
+
+#define HDMI_ACS1                                               0x0d0
+#define HDMI_ACS1_reg_addr                                      "0x980340d0"
+#define HDMI_ACS1_reg                                           0x980340d0
+#define HDMI_ACS1_inst_addr                                     "0x0034"
+#define HDMI_ACS1_inst                                          0x0034
+#define HDMI_ACS1_cs_shift                                      (0)
+#define HDMI_ACS1_cs_mask                                       (0x00FFFFFF)
+#define HDMI_ACS1_cs(data)                                      (0x00FFFFFF&(data))
+#define HDMI_ACS1_get_cs(data)                                  (0x00FFFFFF&(data))
+
+
+#define HDMI_INTCR                                              0x0d4
+#define HDMI_INTCR_reg_addr                                     "0x980340d4"
+#define HDMI_INTCR_reg                                          0x980340d4
+#define HDMI_INTCR_inst_addr                                    "0x0035"
+#define HDMI_INTCR_inst                                         0x0035
+#define HDMI_INTCR_pending_shift                                (7)
+#define HDMI_INTCR_avmute_shift                                 (6)
+#define HDMI_INTCR_fifod_shift                                  (5)
+#define HDMI_INTCR_act_shift                                    (4)
+#define HDMI_INTCR_apll_shift                                   (3)
+#define HDMI_INTCR_afifoo_shift                                 (2)
+#define HDMI_INTCR_afifou_shift                                 (1)
+#define HDMI_INTCR_vc_shift                                     (0)
+#define HDMI_INTCR_pending_mask                                 (0x00000080)
+#define HDMI_INTCR_avmute_mask                                  (0x00000040)
+#define HDMI_INTCR_fifod_mask                                   (0x00000020)
+#define HDMI_INTCR_act_mask                                     (0x00000010)
+#define HDMI_INTCR_apll_mask                                    (0x00000008)
+#define HDMI_INTCR_afifoo_mask                                  (0x00000004)
+#define HDMI_INTCR_afifou_mask                                  (0x00000002)
+#define HDMI_INTCR_vc_mask                                      (0x00000001)
+#define HDMI_INTCR_pending(data)                                (0x00000080&((data)<<7))
+#define HDMI_INTCR_avmute(data)                                 (0x00000040&((data)<<6))
+#define HDMI_INTCR_fifod(data)                                  (0x00000020&((data)<<5))
+#define HDMI_INTCR_act(data)                                    (0x00000010&((data)<<4))
+#define HDMI_INTCR_apll(data)                                   (0x00000008&((data)<<3))
+#define HDMI_INTCR_afifoo(data)                                 (0x00000004&((data)<<2))
+#define HDMI_INTCR_afifou(data)                                 (0x00000002&((data)<<1))
+#define HDMI_INTCR_vc(data)                                     (0x00000001&(data))
+#define HDMI_INTCR_get_pending(data)                            ((0x00000080&(data))>>7)
+#define HDMI_INTCR_get_avmute(data)                             ((0x00000040&(data))>>6)
+#define HDMI_INTCR_get_fifod(data)                              ((0x00000020&(data))>>5)
+#define HDMI_INTCR_get_act(data)                                ((0x00000010&(data))>>4)
+#define HDMI_INTCR_get_apll(data)                               ((0x00000008&(data))>>3)
+#define HDMI_INTCR_get_afifoo(data)                             ((0x00000004&(data))>>2)
+#define HDMI_INTCR_get_afifou(data)                             ((0x00000002&(data))>>1)
+#define HDMI_INTCR_get_vc(data)                                 (0x00000001&(data))
+
+
+#define HDMI_ALCR                                               0x0d8
+#define HDMI_ALCR_reg_addr                                      "0x980340d8"
+#define HDMI_ALCR_reg                                           0x980340d8
+#define HDMI_ALCR_inst_addr                                     "0x0036"
+#define HDMI_ALCR_inst                                          0x0036
+#define HDMI_ALCR_lo1_shift                                     (6)
+#define HDMI_ALCR_lo2_shift                                     (4)
+#define HDMI_ALCR_lo3_shift                                     (2)
+#define HDMI_ALCR_lo4_shift                                     (0)
+#define HDMI_ALCR_lo1_mask                                      (0x000000C0)
+#define HDMI_ALCR_lo2_mask                                      (0x00000030)
+#define HDMI_ALCR_lo3_mask                                      (0x0000000C)
+#define HDMI_ALCR_lo4_mask                                      (0x00000003)
+#define HDMI_ALCR_lo1(data)                                     (0x000000C0&((data)<<6))
+#define HDMI_ALCR_lo2(data)                                     (0x00000030&((data)<<4))
+#define HDMI_ALCR_lo3(data)                                     (0x0000000C&((data)<<2))
+#define HDMI_ALCR_lo4(data)                                     (0x00000003&(data))
+#define HDMI_ALCR_get_lo1(data)                                 ((0x000000C0&(data))>>6)
+#define HDMI_ALCR_get_lo2(data)                                 ((0x00000030&(data))>>4)
+#define HDMI_ALCR_get_lo3(data)                                 ((0x0000000C&(data))>>2)
+#define HDMI_ALCR_get_lo4(data)                                 (0x00000003&(data))
+
+
+#define HDMI_AOCR                                               0x0dc
+#define HDMI_AOCR_reg_addr                                      "0x980340dc"
+#define HDMI_AOCR_reg                                           0x980340dc
+#define HDMI_AOCR_inst_addr                                     "0x0037"
+#define HDMI_AOCR_inst                                          0x0037
+#define HDMI_AOCR_i2s_clk_en_dvi_shift                          (8)
+#define HDMI_AOCR_spdifo1_shift                                 (7)
+#define HDMI_AOCR_spdifo2_shift                                 (6)
+#define HDMI_AOCR_spdifo3_shift                                 (5)
+#define HDMI_AOCR_spdifo4_shift                                 (4)
+#define HDMI_AOCR_i2so1_shift                                   (3)
+#define HDMI_AOCR_i2so2_shift                                   (2)
+#define HDMI_AOCR_i2so3_shift                                   (1)
+#define HDMI_AOCR_i2so4_shift                                   (0)
+#define HDMI_AOCR_i2s_clk_en_dvi_mask                           (0x00000100)
+#define HDMI_AOCR_spdifo1_mask                                  (0x00000080)
+#define HDMI_AOCR_spdifo2_mask                                  (0x00000040)
+#define HDMI_AOCR_spdifo3_mask                                  (0x00000020)
+#define HDMI_AOCR_spdifo4_mask                                  (0x00000010)
+#define HDMI_AOCR_i2so1_mask                                    (0x00000008)
+#define HDMI_AOCR_i2so2_mask                                    (0x00000004)
+#define HDMI_AOCR_i2so3_mask                                    (0x00000002)
+#define HDMI_AOCR_i2so4_mask                                    (0x00000001)
+#define HDMI_AOCR_i2s_clk_en_dvi(data)                          (0x00000100&((data)<<8))
+#define HDMI_AOCR_spdifo1(data)                                 (0x00000080&((data)<<7))
+#define HDMI_AOCR_spdifo2(data)                                 (0x00000040&((data)<<6))
+#define HDMI_AOCR_spdifo3(data)                                 (0x00000020&((data)<<5))
+#define HDMI_AOCR_spdifo4(data)                                 (0x00000010&((data)<<4))
+#define HDMI_AOCR_i2so1(data)                                   (0x00000008&((data)<<3))
+#define HDMI_AOCR_i2so2(data)                                   (0x00000004&((data)<<2))
+#define HDMI_AOCR_i2so3(data)                                   (0x00000002&((data)<<1))
+#define HDMI_AOCR_i2so4(data)                                   (0x00000001&(data))
+#define HDMI_AOCR_get_i2s_clk_en_dvi(data)                      ((0x00000100&(data))>>8)
+#define HDMI_AOCR_get_spdifo1(data)                             ((0x00000080&(data))>>7)
+#define HDMI_AOCR_get_spdifo2(data)                             ((0x00000040&(data))>>6)
+#define HDMI_AOCR_get_spdifo3(data)                             ((0x00000020&(data))>>5)
+#define HDMI_AOCR_get_spdifo4(data)                             ((0x00000010&(data))>>4)
+#define HDMI_AOCR_get_i2so1(data)                               ((0x00000008&(data))>>3)
+#define HDMI_AOCR_get_i2so2(data)                               ((0x00000004&(data))>>2)
+#define HDMI_AOCR_get_i2so3(data)                               ((0x00000002&(data))>>1)
+#define HDMI_AOCR_get_i2so4(data)                               (0x00000001&(data))
+
+
+#define HDMI_BCSR                                               0x0e0
+#define HDMI_BCSR_reg_addr                                      "0x980340e0"
+#define HDMI_BCSR_reg                                           0x980340e0
+#define HDMI_BCSR_inst_addr                                     "0x0038"
+#define HDMI_BCSR_inst                                          0x0038
+#define HDMI_BCSR_nvlgb_shift                                   (5)
+#define HDMI_BCSR_nalgb_shift                                   (4)
+#define HDMI_BCSR_natgb_shift                                   (3)
+#define HDMI_BCSR_ngb_shift                                     (2)
+#define HDMI_BCSR_pe_shift                                      (1)
+#define HDMI_BCSR_gcp_shift                                     (0)
+#define HDMI_BCSR_nvlgb_mask                                    (0x00000020)
+#define HDMI_BCSR_nalgb_mask                                    (0x00000010)
+#define HDMI_BCSR_natgb_mask                                    (0x00000008)
+#define HDMI_BCSR_ngb_mask                                      (0x00000004)
+#define HDMI_BCSR_pe_mask                                       (0x00000002)
+#define HDMI_BCSR_gcp_mask                                      (0x00000001)
+#define HDMI_BCSR_nvlgb(data)                                   (0x00000020&((data)<<5))
+#define HDMI_BCSR_nalgb(data)                                   (0x00000010&((data)<<4))
+#define HDMI_BCSR_natgb(data)                                   (0x00000008&((data)<<3))
+#define HDMI_BCSR_ngb(data)                                     (0x00000004&((data)<<2))
+#define HDMI_BCSR_pe(data)                                      (0x00000002&((data)<<1))
+#define HDMI_BCSR_gcp(data)                                     (0x00000001&(data))
+#define HDMI_BCSR_get_nvlgb(data)                               ((0x00000020&(data))>>5)
+#define HDMI_BCSR_get_nalgb(data)                               ((0x00000010&(data))>>4)
+#define HDMI_BCSR_get_natgb(data)                               ((0x00000008&(data))>>3)
+#define HDMI_BCSR_get_ngb(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_BCSR_get_pe(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_BCSR_get_gcp(data)                                 (0x00000001&(data))
+
+
+#define HDMI_ASR0                                               0x0e4
+#define HDMI_ASR0_reg_addr                                      "0x980340e4"
+#define HDMI_ASR0_reg                                           0x980340e4
+#define HDMI_ASR0_inst_addr                                     "0x0039"
+#define HDMI_ASR0_inst                                          0x0039
+#define HDMI_ASR0_fsre_shift                                    (2)
+#define HDMI_ASR0_fsif_shift                                    (1)
+#define HDMI_ASR0_fscs_shift                                    (0)
+#define HDMI_ASR0_fsre_mask                                     (0x00000004)
+#define HDMI_ASR0_fsif_mask                                     (0x00000002)
+#define HDMI_ASR0_fscs_mask                                     (0x00000001)
+#define HDMI_ASR0_fsre(data)                                    (0x00000004&((data)<<2))
+#define HDMI_ASR0_fsif(data)                                    (0x00000002&((data)<<1))
+#define HDMI_ASR0_fscs(data)                                    (0x00000001&(data))
+#define HDMI_ASR0_get_fsre(data)                                ((0x00000004&(data))>>2)
+#define HDMI_ASR0_get_fsif(data)                                ((0x00000002&(data))>>1)
+#define HDMI_ASR0_get_fscs(data)                                (0x00000001&(data))
+
+
+#define HDMI_ASR1                                               0x0e8
+#define HDMI_ASR1_reg_addr                                      "0x980340e8"
+#define HDMI_ASR1_reg                                           0x980340e8
+#define HDMI_ASR1_inst_addr                                     "0x003A"
+#define HDMI_ASR1_inst                                          0x003A
+#define HDMI_ASR1_fbif_shift                                    (4)
+#define HDMI_ASR1_fbcs_shift                                    (0)
+#define HDMI_ASR1_fbif_mask                                     (0x00000070)
+#define HDMI_ASR1_fbcs_mask                                     (0x0000000F)
+#define HDMI_ASR1_fbif(data)                                    (0x00000070&((data)<<4))
+#define HDMI_ASR1_fbcs(data)                                    (0x0000000F&(data))
+#define HDMI_ASR1_get_fbif(data)                                ((0x00000070&(data))>>4)
+#define HDMI_ASR1_get_fbcs(data)                                (0x0000000F&(data))
+
+
+#define HDMI_VIDEO_FORMAT                                       0x0ec
+#define HDMI_VIDEO_FORMAT_reg_addr                              "0x980340ec"
+#define HDMI_VIDEO_FORMAT_reg                                   0x980340ec
+#define HDMI_VIDEO_FORMAT_inst_addr                             "0x003B"
+#define HDMI_VIDEO_FORMAT_inst                                  0x003B
+#define HDMI_VIDEO_FORMAT_hvf_shift                             (8)
+#define HDMI_VIDEO_FORMAT_hdmi_vic_shift                        (0)
+#define HDMI_VIDEO_FORMAT_hvf_mask                              (0x00000700)
+#define HDMI_VIDEO_FORMAT_hdmi_vic_mask                         (0x000000FF)
+#define HDMI_VIDEO_FORMAT_hvf(data)                             (0x00000700&((data)<<8))
+#define HDMI_VIDEO_FORMAT_hdmi_vic(data)                        (0x000000FF&(data))
+#define HDMI_VIDEO_FORMAT_get_hvf(data)                         ((0x00000700&(data))>>8)
+#define HDMI_VIDEO_FORMAT_get_hdmi_vic(data)                    (0x000000FF&(data))
+
+
+#define HDMI_3D_FORMAT                                          0x0f0
+#define HDMI_3D_FORMAT_reg_addr                                 "0x980340f0"
+#define HDMI_3D_FORMAT_reg                                      0x980340f0
+#define HDMI_3D_FORMAT_inst_addr                                "0x003C"
+#define HDMI_3D_FORMAT_inst                                     0x003C
+#define HDMI_3D_FORMAT_hdmi_3d_ext_data_shift                   (12)
+#define HDMI_3D_FORMAT_hdmi_3d_metadata_type_shift              (9)
+#define HDMI_3D_FORMAT_hdmi_3d_structure_shift                  (4)
+#define HDMI_3D_FORMAT_hdmi_3d_meta_present_shift               (3)
+#define HDMI_3D_FORMAT_hdmi_3d_ext_data_mask                    (0x0000F000)
+#define HDMI_3D_FORMAT_hdmi_3d_metadata_type_mask               (0x00000E00)
+#define HDMI_3D_FORMAT_hdmi_3d_structure_mask                   (0x000000F0)
+#define HDMI_3D_FORMAT_hdmi_3d_meta_present_mask                (0x00000008)
+#define HDMI_3D_FORMAT_hdmi_3d_ext_data(data)                   (0x0000F000&((data)<<12))
+#define HDMI_3D_FORMAT_hdmi_3d_metadata_type(data)              (0x00000E00&((data)<<9))
+#define HDMI_3D_FORMAT_hdmi_3d_structure(data)                  (0x000000F0&((data)<<4))
+#define HDMI_3D_FORMAT_hdmi_3d_meta_present(data)               (0x00000008&((data)<<3))
+#define HDMI_3D_FORMAT_get_hdmi_3d_ext_data(data)               ((0x0000F000&(data))>>12)
+#define HDMI_3D_FORMAT_get_hdmi_3d_metadata_type(data)          ((0x00000E00&(data))>>9)
+#define HDMI_3D_FORMAT_get_hdmi_3d_structure(data)              ((0x000000F0&(data))>>4)
+#define HDMI_3D_FORMAT_get_hdmi_3d_meta_present(data)           ((0x00000008&(data))>>3)
+
+
+#define HDMI_FVS                                                0x0f4
+#define HDMI_FVS_reg_addr                                       "0x980340f4"
+#define HDMI_FVS_reg                                            0x980340f4
+#define HDMI_FVS_inst_addr                                      "0x003D"
+#define HDMI_FVS_inst                                           0x003D
+#define HDMI_FVS_info_3d_preferred2dview_shift                  (13)
+#define HDMI_FVS_info_3d_viewdependency_shift                   (11)
+#define HDMI_FVS_info_3d_dualview_shift                         (10)
+#define HDMI_FVS_info_3d_additionalinfo_present_shift           (9)
+#define HDMI_FVS_info_3d_f_ext_data_shift                       (5)
+#define HDMI_FVS_info_3d_f_structure_shift                      (1)
+#define HDMI_FVS_info_3d_valid_shift                            (0)
+#define HDMI_FVS_info_3d_preferred2dview_mask                   (0x00006000)
+#define HDMI_FVS_info_3d_viewdependency_mask                    (0x00001800)
+#define HDMI_FVS_info_3d_dualview_mask                          (0x00000400)
+#define HDMI_FVS_info_3d_additionalinfo_present_mask            (0x00000200)
+#define HDMI_FVS_info_3d_f_ext_data_mask                        (0x000001E0)
+#define HDMI_FVS_info_3d_f_structure_mask                       (0x0000001E)
+#define HDMI_FVS_info_3d_valid_mask                             (0x00000001)
+#define HDMI_FVS_info_3d_preferred2dview(data)                  (0x00006000&((data)<<13))
+#define HDMI_FVS_info_3d_viewdependency(data)                   (0x00001800&((data)<<11))
+#define HDMI_FVS_info_3d_dualview(data)                         (0x00000400&((data)<<10))
+#define HDMI_FVS_info_3d_additionalinfo_present(data)           (0x00000200&((data)<<9))
+#define HDMI_FVS_info_3d_f_ext_data(data)                       (0x000001E0&((data)<<5))
+#define HDMI_FVS_info_3d_f_structure(data)                      (0x0000001E&((data)<<1))
+#define HDMI_FVS_info_3d_valid(data)                            (0x00000001&(data))
+#define HDMI_FVS_get_info_3d_preferred2dview(data)              ((0x00006000&(data))>>13)
+#define HDMI_FVS_get_info_3d_viewdependency(data)               ((0x00001800&(data))>>11)
+#define HDMI_FVS_get_info_3d_dualview(data)                     ((0x00000400&(data))>>10)
+#define HDMI_FVS_get_info_3d_additionalinfo_present(data)       ((0x00000200&(data))>>9)
+#define HDMI_FVS_get_info_3d_f_ext_data(data)                   ((0x000001E0&(data))>>5)
+#define HDMI_FVS_get_info_3d_f_structure(data)                  ((0x0000001E&(data))>>1)
+#define HDMI_FVS_get_info_3d_valid(data)                        (0x00000001&(data))
+
+
+#define HDMI_DRM                                                0x0f8
+#define HDMI_DRM_reg_addr                                       "0x980340f8"
+#define HDMI_DRM_reg                                            0x980340f8
+#define HDMI_DRM_inst_addr                                      "0x003E"
+#define HDMI_DRM_inst                                           0x003E
+#define HDMI_DRM_static_metadata_descriptor_id_shift            (4)
+#define HDMI_DRM_eotf_shift                                     (0)
+#define HDMI_DRM_static_metadata_descriptor_id_mask             (0x00000070)
+#define HDMI_DRM_eotf_mask                                      (0x00000007)
+#define HDMI_DRM_static_metadata_descriptor_id(data)            (0x00000070&((data)<<4))
+#define HDMI_DRM_eotf(data)                                     (0x00000007&(data))
+#define HDMI_DRM_get_static_metadata_descriptor_id(data)        ((0x00000070&(data))>>4)
+#define HDMI_DRM_get_eotf(data)                                 (0x00000007&(data))
+
+
+#define HDMI_PCMC                                               0x0fc
+#define HDMI_PCMC_reg_addr                                      "0x980340fc"
+#define HDMI_PCMC_reg                                           0x980340fc
+#define HDMI_PCMC_inst_addr                                     "0x003F"
+#define HDMI_PCMC_inst                                          0x003F
+#define HDMI_PCMC_avi_info_clr_shift                            (15)
+#define HDMI_PCMC_audio_info_clr_shift                          (14)
+#define HDMI_PCMC_acp_clr_shift                                 (13)
+#define HDMI_PCMC_isrc1_clr_shift                               (12)
+#define HDMI_PCMC_isrc2_clr_shift                               (11)
+#define HDMI_PCMC_mpeg_info_clr_shift                           (10)
+#define HDMI_PCMC_vs_info_clr_shift                             (5)
+#define HDMI_PCMC_gm_clr_shift                                  (4)
+#define HDMI_PCMC_fvs_info_clr_shift                            (3)
+#define HDMI_PCMC_drm_info_clr_shift                            (2)
+#define HDMI_PCMC_spd_info_clr_shift                            (1)
+#define HDMI_PCMC_ackg_clr_shift                                (0)
+#define HDMI_PCMC_avi_info_clr_mask                             (0x00008000)
+#define HDMI_PCMC_audio_info_clr_mask                           (0x00004000)
+#define HDMI_PCMC_acp_clr_mask                                  (0x00002000)
+#define HDMI_PCMC_isrc1_clr_mask                                (0x00001000)
+#define HDMI_PCMC_isrc2_clr_mask                                (0x00000800)
+#define HDMI_PCMC_mpeg_info_clr_mask                            (0x00000400)
+#define HDMI_PCMC_vs_info_clr_mask                              (0x00000020)
+#define HDMI_PCMC_gm_clr_mask                                   (0x00000010)
+#define HDMI_PCMC_fvs_info_clr_mask                             (0x00000008)
+#define HDMI_PCMC_drm_info_clr_mask                             (0x00000004)
+#define HDMI_PCMC_spd_info_clr_mask                             (0x00000002)
+#define HDMI_PCMC_ackg_clr_mask                                 (0x00000001)
+#define HDMI_PCMC_avi_info_clr(data)                            (0x00008000&((data)<<15))
+#define HDMI_PCMC_audio_info_clr(data)                          (0x00004000&((data)<<14))
+#define HDMI_PCMC_acp_clr(data)                                 (0x00002000&((data)<<13))
+#define HDMI_PCMC_isrc1_clr(data)                               (0x00001000&((data)<<12))
+#define HDMI_PCMC_isrc2_clr(data)                               (0x00000800&((data)<<11))
+#define HDMI_PCMC_mpeg_info_clr(data)                           (0x00000400&((data)<<10))
+#define HDMI_PCMC_vs_info_clr(data)                             (0x00000020&((data)<<5))
+#define HDMI_PCMC_gm_clr(data)                                  (0x00000010&((data)<<4))
+#define HDMI_PCMC_fvs_info_clr(data)                            (0x00000008&((data)<<3))
+#define HDMI_PCMC_drm_info_clr(data)                            (0x00000004&((data)<<2))
+#define HDMI_PCMC_spd_info_clr(data)                            (0x00000002&((data)<<1))
+#define HDMI_PCMC_ackg_clr(data)                                (0x00000001&(data))
+#define HDMI_PCMC_get_avi_info_clr(data)                        ((0x00008000&(data))>>15)
+#define HDMI_PCMC_get_audio_info_clr(data)                      ((0x00004000&(data))>>14)
+#define HDMI_PCMC_get_acp_clr(data)                             ((0x00002000&(data))>>13)
+#define HDMI_PCMC_get_isrc1_clr(data)                           ((0x00001000&(data))>>12)
+#define HDMI_PCMC_get_isrc2_clr(data)                           ((0x00000800&(data))>>11)
+#define HDMI_PCMC_get_mpeg_info_clr(data)                       ((0x00000400&(data))>>10)
+#define HDMI_PCMC_get_vs_info_clr(data)                         ((0x00000020&(data))>>5)
+#define HDMI_PCMC_get_gm_clr(data)                              ((0x00000010&(data))>>4)
+#define HDMI_PCMC_get_fvs_info_clr(data)                        ((0x00000008&(data))>>3)
+#define HDMI_PCMC_get_drm_info_clr(data)                        ((0x00000004&(data))>>2)
+#define HDMI_PCMC_get_spd_info_clr(data)                        ((0x00000002&(data))>>1)
+#define HDMI_PCMC_get_ackg_clr(data)                            (0x00000001&(data))
+
+
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ                            0x100
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_reg_addr                   "0x98034100"
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_reg                        0x98034100
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_inst_addr                  "0x0040"
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_inst                       0x0040
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ncts_chg_irq_shift      (3)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_ncts_chg_irq_shift         (2)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ch_status_chg_irq_shift (1)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_ch_status_chg_irq_shift    (0)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ncts_chg_irq_mask       (0x00000008)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_ncts_chg_irq_mask          (0x00000004)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ch_status_chg_irq_mask  (0x00000002)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_ch_status_chg_irq_mask     (0x00000001)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ncts_chg_irq(data)      (0x00000008&((data)<<3))
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_ncts_chg_irq(data)         (0x00000004&((data)<<2))
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ch_status_chg_irq(data) (0x00000002&((data)<<1))
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_ch_status_chg_irq(data)    (0x00000001&(data))
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_en_ncts_chg_irq(data)  ((0x00000008&(data))>>3)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_ncts_chg_irq(data)     ((0x00000004&(data))>>2)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_en_ch_status_chg_irq(data)  ((0x00000002&(data))>>1)
+#define HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_ch_status_chg_irq(data)  (0x00000001&(data))
+
+
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET                              0x104
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_reg_addr                     "0x98034104"
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_reg                          0x98034104
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_inst_addr                    "0x0041"
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_inst                         0x0041
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual_shift  (2)
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw_shift      (1)
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_shift         (0)
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual_mask   (0x00000004)
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw_mask       (0x00000002)
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_mask          (0x00000001)
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual(data)  (0x00000004&((data)<<2))
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw(data)      (0x00000002&((data)<<1))
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode(data)         (0x00000001&(data))
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode_manual(data)  ((0x00000004&(data))>>2)
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode_fw(data)  ((0x00000002&(data))>>1)
+#define HDMI_HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode(data)     (0x00000001&(data))
+
+
+#define HDMI_AFCR                                               0x108
+#define HDMI_AFCR_reg_addr                                      "0x98034108"
+#define HDMI_AFCR_reg                                           0x98034108
+#define HDMI_AFCR_inst_addr                                     "0x0042"
+#define HDMI_AFCR_inst                                          0x0042
+#define HDMI_AFCR_dummy98034108_31_14_shift                     (14)
+#define HDMI_AFCR_gain_bypass_en_shift                          (13)
+#define HDMI_AFCR_afifof_shift                                  (12)
+#define HDMI_AFCR_afifoe_shift                                  (11)
+#define HDMI_AFCR_afifowe_r_shift                               (10)
+#define HDMI_AFCR_afifore_r_shift                               (8)
+#define HDMI_AFCR_tst_i2s_sw_shift                              (7)
+#define HDMI_AFCR_aoem_shift                                    (6)
+#define HDMI_AFCR_aoc_shift                                     (5)
+#define HDMI_AFCR_audio_test_enable_shift                       (4)
+#define HDMI_AFCR_mgc_shift                                     (3)
+#define HDMI_AFCR_afifowe_shift                                 (2)
+#define HDMI_AFCR_afifore_shift                                 (0)
+#define HDMI_AFCR_dummy98034108_31_14_mask                      (0xFFFFC000)
+#define HDMI_AFCR_gain_bypass_en_mask                           (0x00002000)
+#define HDMI_AFCR_afifof_mask                                   (0x00001000)
+#define HDMI_AFCR_afifoe_mask                                   (0x00000800)
+#define HDMI_AFCR_afifowe_r_mask                                (0x00000400)
+#define HDMI_AFCR_afifore_r_mask                                (0x00000300)
+#define HDMI_AFCR_tst_i2s_sw_mask                               (0x00000080)
+#define HDMI_AFCR_aoem_mask                                     (0x00000040)
+#define HDMI_AFCR_aoc_mask                                      (0x00000020)
+#define HDMI_AFCR_audio_test_enable_mask                        (0x00000010)
+#define HDMI_AFCR_mgc_mask                                      (0x00000008)
+#define HDMI_AFCR_afifowe_mask                                  (0x00000004)
+#define HDMI_AFCR_afifore_mask                                  (0x00000003)
+#define HDMI_AFCR_dummy98034108_31_14(data)                     (0xFFFFC000&((data)<<14))
+#define HDMI_AFCR_gain_bypass_en(data)                          (0x00002000&((data)<<13))
+#define HDMI_AFCR_afifof(data)                                  (0x00001000&((data)<<12))
+#define HDMI_AFCR_afifoe(data)                                  (0x00000800&((data)<<11))
+#define HDMI_AFCR_afifowe_r(data)                               (0x00000400&((data)<<10))
+#define HDMI_AFCR_afifore_r(data)                               (0x00000300&((data)<<8))
+#define HDMI_AFCR_tst_i2s_sw(data)                              (0x00000080&((data)<<7))
+#define HDMI_AFCR_aoem(data)                                    (0x00000040&((data)<<6))
+#define HDMI_AFCR_aoc(data)                                     (0x00000020&((data)<<5))
+#define HDMI_AFCR_audio_test_enable(data)                       (0x00000010&((data)<<4))
+#define HDMI_AFCR_mgc(data)                                     (0x00000008&((data)<<3))
+#define HDMI_AFCR_afifowe(data)                                 (0x00000004&((data)<<2))
+#define HDMI_AFCR_afifore(data)                                 (0x00000003&(data))
+#define HDMI_AFCR_get_dummy98034108_31_14(data)                 ((0xFFFFC000&(data))>>14)
+#define HDMI_AFCR_get_gain_bypass_en(data)                      ((0x00002000&(data))>>13)
+#define HDMI_AFCR_get_afifof(data)                              ((0x00001000&(data))>>12)
+#define HDMI_AFCR_get_afifoe(data)                              ((0x00000800&(data))>>11)
+#define HDMI_AFCR_get_afifowe_r(data)                           ((0x00000400&(data))>>10)
+#define HDMI_AFCR_get_afifore_r(data)                           ((0x00000300&(data))>>8)
+#define HDMI_AFCR_get_tst_i2s_sw(data)                          ((0x00000080&(data))>>7)
+#define HDMI_AFCR_get_aoem(data)                                ((0x00000040&(data))>>6)
+#define HDMI_AFCR_get_aoc(data)                                 ((0x00000020&(data))>>5)
+#define HDMI_AFCR_get_audio_test_enable(data)                   ((0x00000010&(data))>>4)
+#define HDMI_AFCR_get_mgc(data)                                 ((0x00000008&(data))>>3)
+#define HDMI_AFCR_get_afifowe(data)                             ((0x00000004&(data))>>2)
+#define HDMI_AFCR_get_afifore(data)                             (0x00000003&(data))
+
+
+#define HDMI_AFSR                                               0x10c
+#define HDMI_AFSR_reg_addr                                      "0x9803410c"
+#define HDMI_AFSR_reg                                           0x9803410c
+#define HDMI_AFSR_inst_addr                                     "0x0043"
+#define HDMI_AFSR_inst                                          0x0043
+#define HDMI_AFSR_audio_bist_clksel_shift                       (0)
+#define HDMI_AFSR_audio_bist_clksel_mask                        (0x00000001)
+#define HDMI_AFSR_audio_bist_clksel(data)                       (0x00000001&(data))
+#define HDMI_AFSR_get_audio_bist_clksel(data)                   (0x00000001&(data))
+
+
+#define HDMI_MAGCR0                                             0x110
+#define HDMI_MAGCR0_reg_addr                                    "0x98034110"
+#define HDMI_MAGCR0_reg                                         0x98034110
+#define HDMI_MAGCR0_inst_addr                                   "0x0044"
+#define HDMI_MAGCR0_inst                                        0x0044
+#define HDMI_MAGCR0_agi_shift                                   (13)
+#define HDMI_MAGCR0_agd_shift                                   (8)
+#define HDMI_MAGCR0_mg_shift                                    (0)
+#define HDMI_MAGCR0_agi_mask                                    (0x0000E000)
+#define HDMI_MAGCR0_agd_mask                                    (0x00001F00)
+#define HDMI_MAGCR0_mg_mask                                     (0x000000FF)
+#define HDMI_MAGCR0_agi(data)                                   (0x0000E000&((data)<<13))
+#define HDMI_MAGCR0_agd(data)                                   (0x00001F00&((data)<<8))
+#define HDMI_MAGCR0_mg(data)                                    (0x000000FF&(data))
+#define HDMI_MAGCR0_get_agi(data)                               ((0x0000E000&(data))>>13)
+#define HDMI_MAGCR0_get_agd(data)                               ((0x00001F00&(data))>>8)
+#define HDMI_MAGCR0_get_mg(data)                                (0x000000FF&(data))
+
+
+#define HDMI_MAG_M_FINAL                                        0x114
+#define HDMI_MAG_M_FINAL_reg_addr                               "0x98034114"
+#define HDMI_MAG_M_FINAL_reg                                    0x98034114
+#define HDMI_MAG_M_FINAL_inst_addr                              "0x0045"
+#define HDMI_MAG_M_FINAL_inst                                   0x0045
+#define HDMI_MAG_M_FINAL_ldp_time_shift                         (21)
+#define HDMI_MAG_M_FINAL_ldp_time_mode_shift                    (20)
+#define HDMI_MAG_M_FINAL_fg_r_shift                             (12)
+#define HDMI_MAG_M_FINAL_fg_l_shift                             (4)
+#define HDMI_MAG_M_FINAL_auto_dly_mod_shift                     (3)
+#define HDMI_MAG_M_FINAL_fg_en_shift                            (2)
+#define HDMI_MAG_M_FINAL_ffg_l_shift                            (1)
+#define HDMI_MAG_M_FINAL_ffg_r_shift                            (0)
+#define HDMI_MAG_M_FINAL_ldp_time_mask                          (0x7FE00000)
+#define HDMI_MAG_M_FINAL_ldp_time_mode_mask                     (0x00100000)
+#define HDMI_MAG_M_FINAL_fg_r_mask                              (0x000FF000)
+#define HDMI_MAG_M_FINAL_fg_l_mask                              (0x00000FF0)
+#define HDMI_MAG_M_FINAL_auto_dly_mod_mask                      (0x00000008)
+#define HDMI_MAG_M_FINAL_fg_en_mask                             (0x00000004)
+#define HDMI_MAG_M_FINAL_ffg_l_mask                             (0x00000002)
+#define HDMI_MAG_M_FINAL_ffg_r_mask                             (0x00000001)
+#define HDMI_MAG_M_FINAL_ldp_time(data)                         (0x7FE00000&((data)<<21))
+#define HDMI_MAG_M_FINAL_ldp_time_mode(data)                    (0x00100000&((data)<<20))
+#define HDMI_MAG_M_FINAL_fg_r(data)                             (0x000FF000&((data)<<12))
+#define HDMI_MAG_M_FINAL_fg_l(data)                             (0x00000FF0&((data)<<4))
+#define HDMI_MAG_M_FINAL_auto_dly_mod(data)                     (0x00000008&((data)<<3))
+#define HDMI_MAG_M_FINAL_fg_en(data)                            (0x00000004&((data)<<2))
+#define HDMI_MAG_M_FINAL_ffg_l(data)                            (0x00000002&((data)<<1))
+#define HDMI_MAG_M_FINAL_ffg_r(data)                            (0x00000001&(data))
+#define HDMI_MAG_M_FINAL_get_ldp_time(data)                     ((0x7FE00000&(data))>>21)
+#define HDMI_MAG_M_FINAL_get_ldp_time_mode(data)                ((0x00100000&(data))>>20)
+#define HDMI_MAG_M_FINAL_get_fg_r(data)                         ((0x000FF000&(data))>>12)
+#define HDMI_MAG_M_FINAL_get_fg_l(data)                         ((0x00000FF0&(data))>>4)
+#define HDMI_MAG_M_FINAL_get_auto_dly_mod(data)                 ((0x00000008&(data))>>3)
+#define HDMI_MAG_M_FINAL_get_fg_en(data)                        ((0x00000004&(data))>>2)
+#define HDMI_MAG_M_FINAL_get_ffg_l(data)                        ((0x00000002&(data))>>1)
+#define HDMI_MAG_M_FINAL_get_ffg_r(data)                        (0x00000001&(data))
+
+
+#define HDMI_ZCD_CTRL                                                0x118
+#define HDMI_ZCD_CTRL_reg_addr                                       "0x98034118"
+#define HDMI_ZCD_CTRL_reg                                            0x98034118
+#define HDMI_ZCD_CTRL_inst_addr                                      "0x0046"
+#define HDMI_ZCD_CTRL_inst                                           0x0046
+#define HDMI_ZCD_CTRL_zcd_ch7_done_shift                             (23)
+#define HDMI_ZCD_CTRL_zcd_ch6_done_shift                             (22)
+#define HDMI_ZCD_CTRL_zcd_ch5_done_shift                             (21)
+#define HDMI_ZCD_CTRL_zcd_ch4_done_shift                             (20)
+#define HDMI_ZCD_CTRL_zcd_ch3_done_shift                             (19)
+#define HDMI_ZCD_CTRL_zcd_ch2_done_shift                             (18)
+#define HDMI_ZCD_CTRL_zcd_ch1_done_shift                             (17)
+#define HDMI_ZCD_CTRL_zcd_ch0_done_shift                             (16)
+#define HDMI_ZCD_CTRL_zcd_timeout_shift                              (8)
+#define HDMI_ZCD_CTRL_zcd_en_shift                                   (7)
+#define HDMI_ZCD_CTRL_zcd_sep_8ch_shift                              (6)
+#define HDMI_ZCD_CTRL_zcd_sep_st_shift                               (5)
+#define HDMI_ZCD_CTRL_dummy98034118_4_0_shift                        (0)
+#define HDMI_ZCD_CTRL_zcd_ch7_done_mask                              (0x00800000)
+#define HDMI_ZCD_CTRL_zcd_ch6_done_mask                              (0x00400000)
+#define HDMI_ZCD_CTRL_zcd_ch5_done_mask                              (0x00200000)
+#define HDMI_ZCD_CTRL_zcd_ch4_done_mask                              (0x00100000)
+#define HDMI_ZCD_CTRL_zcd_ch3_done_mask                              (0x00080000)
+#define HDMI_ZCD_CTRL_zcd_ch2_done_mask                              (0x00040000)
+#define HDMI_ZCD_CTRL_zcd_ch1_done_mask                              (0x00020000)
+#define HDMI_ZCD_CTRL_zcd_ch0_done_mask                              (0x00010000)
+#define HDMI_ZCD_CTRL_zcd_timeout_mask                               (0x00007F00)
+#define HDMI_ZCD_CTRL_zcd_en_mask                                    (0x00000080)
+#define HDMI_ZCD_CTRL_zcd_sep_8ch_mask                               (0x00000040)
+#define HDMI_ZCD_CTRL_zcd_sep_st_mask                                (0x00000020)
+#define HDMI_ZCD_CTRL_dummy98034118_4_0_mask                         (0x0000001F)
+#define HDMI_ZCD_CTRL_zcd_ch7_done(data)                             (0x00800000&((data)<<23))
+#define HDMI_ZCD_CTRL_zcd_ch6_done(data)                             (0x00400000&((data)<<22))
+#define HDMI_ZCD_CTRL_zcd_ch5_done(data)                             (0x00200000&((data)<<21))
+#define HDMI_ZCD_CTRL_zcd_ch4_done(data)                             (0x00100000&((data)<<20))
+#define HDMI_ZCD_CTRL_zcd_ch3_done(data)                             (0x00080000&((data)<<19))
+#define HDMI_ZCD_CTRL_zcd_ch2_done(data)                             (0x00040000&((data)<<18))
+#define HDMI_ZCD_CTRL_zcd_ch1_done(data)                             (0x00020000&((data)<<17))
+#define HDMI_ZCD_CTRL_zcd_ch0_done(data)                             (0x00010000&((data)<<16))
+#define HDMI_ZCD_CTRL_zcd_timeout(data)                              (0x00007F00&((data)<<8))
+#define HDMI_ZCD_CTRL_zcd_en(data)                                   (0x00000080&((data)<<7))
+#define HDMI_ZCD_CTRL_zcd_sep_8ch(data)                              (0x00000040&((data)<<6))
+#define HDMI_ZCD_CTRL_zcd_sep_st(data)                               (0x00000020&((data)<<5))
+#define HDMI_ZCD_CTRL_dummy98034118_4_0(data)                        (0x0000001F&(data))
+#define HDMI_ZCD_CTRL_get_zcd_ch7_done(data)                         ((0x00800000&(data))>>23)
+#define HDMI_ZCD_CTRL_get_zcd_ch6_done(data)                         ((0x00400000&(data))>>22)
+#define HDMI_ZCD_CTRL_get_zcd_ch5_done(data)                         ((0x00200000&(data))>>21)
+#define HDMI_ZCD_CTRL_get_zcd_ch4_done(data)                         ((0x00100000&(data))>>20)
+#define HDMI_ZCD_CTRL_get_zcd_ch3_done(data)                         ((0x00080000&(data))>>19)
+#define HDMI_ZCD_CTRL_get_zcd_ch2_done(data)                         ((0x00040000&(data))>>18)
+#define HDMI_ZCD_CTRL_get_zcd_ch1_done(data)                         ((0x00020000&(data))>>17)
+#define HDMI_ZCD_CTRL_get_zcd_ch0_done(data)                         ((0x00010000&(data))>>16)
+#define HDMI_ZCD_CTRL_get_zcd_timeout(data)                          ((0x00007F00&(data))>>8)
+#define HDMI_ZCD_CTRL_get_zcd_en(data)                               ((0x00000080&(data))>>7)
+#define HDMI_ZCD_CTRL_get_zcd_sep_8ch(data)                          ((0x00000040&(data))>>6)
+#define HDMI_ZCD_CTRL_get_zcd_sep_st(data)                           ((0x00000020&(data))>>5)
+#define HDMI_ZCD_CTRL_get_dummy98034118_4_0(data)                    (0x0000001F&(data))
+
+
+#define HDMI_AUDIO_FREQDET                                           0x11c
+#define HDMI_AUDIO_FREQDET_reg_addr                                  "0x9803411c"
+#define HDMI_AUDIO_FREQDET_reg                                       0x9803411c
+#define HDMI_AUDIO_FREQDET_inst_addr                                 "0x0047"
+#define HDMI_AUDIO_FREQDET_inst                                      0x0047
+#define HDMI_AUDIO_FREQDET_xtal_div_shift                            (24)
+#define HDMI_AUDIO_FREQDET_afreq_meas_result_shift                   (12)
+#define HDMI_AUDIO_FREQDET_afreq_meas_range_shift                    (9)
+#define HDMI_AUDIO_FREQDET_popup_afreq_meas_result_shift             (8)
+#define HDMI_AUDIO_FREQDET_audio_freq_detect_shift                   (7)
+#define HDMI_AUDIO_FREQDET_auto_load_scode_shift                     (6)
+#define HDMI_AUDIO_FREQDET_awd_by_freqchange_shift                   (5)
+#define HDMI_AUDIO_FREQDET_awd_by_noaudio_shift                      (4)
+#define HDMI_AUDIO_FREQDET_irq_by_freqchange_shift                   (3)
+#define HDMI_AUDIO_FREQDET_irq_by_noaudio_shift                      (2)
+#define HDMI_AUDIO_FREQDET_freqchange_shift                          (1)
+#define HDMI_AUDIO_FREQDET_noaudio_shift                             (0)
+#define HDMI_AUDIO_FREQDET_xtal_div_mask                             (0xFF000000)
+#define HDMI_AUDIO_FREQDET_afreq_meas_result_mask                    (0x00FFF000)
+#define HDMI_AUDIO_FREQDET_afreq_meas_range_mask                     (0x00000E00)
+#define HDMI_AUDIO_FREQDET_popup_afreq_meas_result_mask              (0x00000100)
+#define HDMI_AUDIO_FREQDET_audio_freq_detect_mask                    (0x00000080)
+#define HDMI_AUDIO_FREQDET_auto_load_scode_mask                      (0x00000040)
+#define HDMI_AUDIO_FREQDET_awd_by_freqchange_mask                    (0x00000020)
+#define HDMI_AUDIO_FREQDET_awd_by_noaudio_mask                       (0x00000010)
+#define HDMI_AUDIO_FREQDET_irq_by_freqchange_mask                    (0x00000008)
+#define HDMI_AUDIO_FREQDET_irq_by_noaudio_mask                       (0x00000004)
+#define HDMI_AUDIO_FREQDET_freqchange_mask                           (0x00000002)
+#define HDMI_AUDIO_FREQDET_noaudio_mask                              (0x00000001)
+#define HDMI_AUDIO_FREQDET_xtal_div(data)                            (0xFF000000&((data)<<24))
+#define HDMI_AUDIO_FREQDET_afreq_meas_result(data)                   (0x00FFF000&((data)<<12))
+#define HDMI_AUDIO_FREQDET_afreq_meas_range(data)                    (0x00000E00&((data)<<9))
+#define HDMI_AUDIO_FREQDET_popup_afreq_meas_result(data)             (0x00000100&((data)<<8))
+#define HDMI_AUDIO_FREQDET_audio_freq_detect(data)                   (0x00000080&((data)<<7))
+#define HDMI_AUDIO_FREQDET_auto_load_scode(data)                     (0x00000040&((data)<<6))
+#define HDMI_AUDIO_FREQDET_awd_by_freqchange(data)                   (0x00000020&((data)<<5))
+#define HDMI_AUDIO_FREQDET_awd_by_noaudio(data)                      (0x00000010&((data)<<4))
+#define HDMI_AUDIO_FREQDET_irq_by_freqchange(data)                   (0x00000008&((data)<<3))
+#define HDMI_AUDIO_FREQDET_irq_by_noaudio(data)                      (0x00000004&((data)<<2))
+#define HDMI_AUDIO_FREQDET_freqchange(data)                          (0x00000002&((data)<<1))
+#define HDMI_AUDIO_FREQDET_noaudio(data)                             (0x00000001&(data))
+#define HDMI_AUDIO_FREQDET_get_xtal_div(data)                        ((0xFF000000&(data))>>24)
+#define HDMI_AUDIO_FREQDET_get_afreq_meas_result(data)               ((0x00FFF000&(data))>>12)
+#define HDMI_AUDIO_FREQDET_get_afreq_meas_range(data)                ((0x00000E00&(data))>>9)
+#define HDMI_AUDIO_FREQDET_get_popup_afreq_meas_result(data)         ((0x00000100&(data))>>8)
+#define HDMI_AUDIO_FREQDET_get_audio_freq_detect(data)               ((0x00000080&(data))>>7)
+#define HDMI_AUDIO_FREQDET_get_auto_load_scode(data)                 ((0x00000040&(data))>>6)
+#define HDMI_AUDIO_FREQDET_get_awd_by_freqchange(data)               ((0x00000020&(data))>>5)
+#define HDMI_AUDIO_FREQDET_get_awd_by_noaudio(data)                  ((0x00000010&(data))>>4)
+#define HDMI_AUDIO_FREQDET_get_irq_by_freqchange(data)               ((0x00000008&(data))>>3)
+#define HDMI_AUDIO_FREQDET_get_irq_by_noaudio(data)                  ((0x00000004&(data))>>2)
+#define HDMI_AUDIO_FREQDET_get_freqchange(data)                      ((0x00000002&(data))>>1)
+#define HDMI_AUDIO_FREQDET_get_noaudio(data)                         (0x00000001&(data))
+
+
+#define HDMI_RANGE0_1                                                0x120
+#define HDMI_RANGE0_1_reg_addr                                       "0x98034120"
+#define HDMI_RANGE0_1_reg                                            0x98034120
+#define HDMI_RANGE0_1_inst_addr                                      "0x0048"
+#define HDMI_RANGE0_1_inst                                           0x0048
+#define HDMI_RANGE0_1_range0_th_shift                                (12)
+#define HDMI_RANGE0_1_range1_th_shift                                (0)
+#define HDMI_RANGE0_1_range0_th_mask                                 (0x00FFF000)
+#define HDMI_RANGE0_1_range1_th_mask                                 (0x00000FFF)
+#define HDMI_RANGE0_1_range0_th(data)                                (0x00FFF000&((data)<<12))
+#define HDMI_RANGE0_1_range1_th(data)                                (0x00000FFF&(data))
+#define HDMI_RANGE0_1_get_range0_th(data)                            ((0x00FFF000&(data))>>12)
+#define HDMI_RANGE0_1_get_range1_th(data)                            (0x00000FFF&(data))
+
+
+#define HDMI_RANGE2_3                                                0x124
+#define HDMI_RANGE2_3_reg_addr                                       "0x98034124"
+#define HDMI_RANGE2_3_reg                                            0x98034124
+#define HDMI_RANGE2_3_inst_addr                                      "0x0049"
+#define HDMI_RANGE2_3_inst                                           0x0049
+#define HDMI_RANGE2_3_range2_th_shift                                (12)
+#define HDMI_RANGE2_3_range3_th_shift                                (0)
+#define HDMI_RANGE2_3_range2_th_mask                                 (0x00FFF000)
+#define HDMI_RANGE2_3_range3_th_mask                                 (0x00000FFF)
+#define HDMI_RANGE2_3_range2_th(data)                                (0x00FFF000&((data)<<12))
+#define HDMI_RANGE2_3_range3_th(data)                                (0x00000FFF&(data))
+#define HDMI_RANGE2_3_get_range2_th(data)                            ((0x00FFF000&(data))>>12)
+#define HDMI_RANGE2_3_get_range3_th(data)                            (0x00000FFF&(data))
+
+
+#define HDMI_RANGE4_5                                                0x128
+#define HDMI_RANGE4_5_reg_addr                                       "0x98034128"
+#define HDMI_RANGE4_5_reg                                            0x98034128
+#define HDMI_RANGE4_5_inst_addr                                      "0x004A"
+#define HDMI_RANGE4_5_inst                                           0x004A
+#define HDMI_RANGE4_5_range4_th_shift                                (12)
+#define HDMI_RANGE4_5_range5_th_shift                                (0)
+#define HDMI_RANGE4_5_range4_th_mask                                 (0x00FFF000)
+#define HDMI_RANGE4_5_range5_th_mask                                 (0x00000FFF)
+#define HDMI_RANGE4_5_range4_th(data)                                (0x00FFF000&((data)<<12))
+#define HDMI_RANGE4_5_range5_th(data)                                (0x00000FFF&(data))
+#define HDMI_RANGE4_5_get_range4_th(data)                            ((0x00FFF000&(data))>>12)
+#define HDMI_RANGE4_5_get_range5_th(data)                            (0x00000FFF&(data))
+
+
+#define HDMI_PRESET_S_CODE0                                          0x12c
+#define HDMI_PRESET_S_CODE0_reg_addr                                 "0x9803412c"
+#define HDMI_PRESET_S_CODE0_reg                                      0x9803412c
+#define HDMI_PRESET_S_CODE0_inst_addr                                "0x004B"
+#define HDMI_PRESET_S_CODE0_inst                                     0x004B
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code3_shift                   (31)
+#define HDMI_PRESET_S_CODE0_pre_set_s_code3_shift                    (24)
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code2_shift                   (23)
+#define HDMI_PRESET_S_CODE0_pre_set_s_code2_shift                    (16)
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code1_shift                   (15)
+#define HDMI_PRESET_S_CODE0_pre_set_s_code1_shift                    (8)
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code0_shift                   (7)
+#define HDMI_PRESET_S_CODE0_pre_set_s_code0_shift                    (0)
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code3_mask                    (0x80000000)
+#define HDMI_PRESET_S_CODE0_pre_set_s_code3_mask                     (0x7F000000)
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code2_mask                    (0x00800000)
+#define HDMI_PRESET_S_CODE0_pre_set_s_code2_mask                     (0x007F0000)
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code1_mask                    (0x00008000)
+#define HDMI_PRESET_S_CODE0_pre_set_s_code1_mask                     (0x00007F00)
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code0_mask                    (0x00000080)
+#define HDMI_PRESET_S_CODE0_pre_set_s_code0_mask                     (0x0000007F)
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code3(data)                   (0x80000000&((data)<<31))
+#define HDMI_PRESET_S_CODE0_pre_set_s_code3(data)                    (0x7F000000&((data)<<24))
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code2(data)                   (0x00800000&((data)<<23))
+#define HDMI_PRESET_S_CODE0_pre_set_s_code2(data)                    (0x007F0000&((data)<<16))
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code1(data)                   (0x00008000&((data)<<15))
+#define HDMI_PRESET_S_CODE0_pre_set_s_code1(data)                    (0x00007F00&((data)<<8))
+#define HDMI_PRESET_S_CODE0_pre_set_s1_code0(data)                   (0x00000080&((data)<<7))
+#define HDMI_PRESET_S_CODE0_pre_set_s_code0(data)                    (0x0000007F&(data))
+#define HDMI_PRESET_S_CODE0_get_pre_set_s1_code3(data)               ((0x80000000&(data))>>31)
+#define HDMI_PRESET_S_CODE0_get_pre_set_s_code3(data)                ((0x7F000000&(data))>>24)
+#define HDMI_PRESET_S_CODE0_get_pre_set_s1_code2(data)               ((0x00800000&(data))>>23)
+#define HDMI_PRESET_S_CODE0_get_pre_set_s_code2(data)                ((0x007F0000&(data))>>16)
+#define HDMI_PRESET_S_CODE0_get_pre_set_s1_code1(data)               ((0x00008000&(data))>>15)
+#define HDMI_PRESET_S_CODE0_get_pre_set_s_code1(data)                ((0x00007F00&(data))>>8)
+#define HDMI_PRESET_S_CODE0_get_pre_set_s1_code0(data)               ((0x00000080&(data))>>7)
+#define HDMI_PRESET_S_CODE0_get_pre_set_s_code0(data)                (0x0000007F&(data))
+
+
+#define HDMI_PRESET_S_CODE1                                          0x130
+#define HDMI_PRESET_S_CODE1_reg_addr                                 "0x98034130"
+#define HDMI_PRESET_S_CODE1_reg                                      0x98034130
+#define HDMI_PRESET_S_CODE1_inst_addr                                "0x004C"
+#define HDMI_PRESET_S_CODE1_inst                                     0x004C
+#define HDMI_PRESET_S_CODE1_dp_abuf_wr_mod_en_shift                  (23)
+#define HDMI_PRESET_S_CODE1_auto_stop_trk_en_shift                   (22)
+#define HDMI_PRESET_S_CODE1_trk_mod_en_shift                         (21)
+#define HDMI_PRESET_S_CODE1_afsm_mod_en_shift                        (20)
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code0_shift                   (15)
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code1_shift                   (14)
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code2_shift                   (13)
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code3_shift                   (12)
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code4_shift                   (11)
+#define HDMI_PRESET_S_CODE1_pre_set_s1_code4_shift                   (7)
+#define HDMI_PRESET_S_CODE1_pre_set_s_code4_shift                    (0)
+#define HDMI_PRESET_S_CODE1_dp_abuf_wr_mod_en_mask                   (0x00800000)
+#define HDMI_PRESET_S_CODE1_auto_stop_trk_en_mask                    (0x00400000)
+#define HDMI_PRESET_S_CODE1_trk_mod_en_mask                          (0x00200000)
+#define HDMI_PRESET_S_CODE1_afsm_mod_en_mask                         (0x00100000)
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code0_mask                    (0x00008000)
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code1_mask                    (0x00004000)
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code2_mask                    (0x00002000)
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code3_mask                    (0x00001000)
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code4_mask                    (0x00000800)
+#define HDMI_PRESET_S_CODE1_pre_set_s1_code4_mask                    (0x00000080)
+#define HDMI_PRESET_S_CODE1_pre_set_s_code4_mask                     (0x0000007F)
+#define HDMI_PRESET_S_CODE1_dp_abuf_wr_mod_en(data)                  (0x00800000&((data)<<23))
+#define HDMI_PRESET_S_CODE1_auto_stop_trk_en(data)                   (0x00400000&((data)<<22))
+#define HDMI_PRESET_S_CODE1_trk_mod_en(data)                         (0x00200000&((data)<<21))
+#define HDMI_PRESET_S_CODE1_afsm_mod_en(data)                        (0x00100000&((data)<<20))
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code0(data)                   (0x00008000&((data)<<15))
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code1(data)                   (0x00004000&((data)<<14))
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code2(data)                   (0x00002000&((data)<<13))
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code3(data)                   (0x00001000&((data)<<12))
+#define HDMI_PRESET_S_CODE1_pre_set_sm_code4(data)                   (0x00000800&((data)<<11))
+#define HDMI_PRESET_S_CODE1_pre_set_s1_code4(data)                   (0x00000080&((data)<<7))
+#define HDMI_PRESET_S_CODE1_pre_set_s_code4(data)                    (0x0000007F&(data))
+#define HDMI_PRESET_S_CODE1_get_dp_abuf_wr_mod_en(data)              ((0x00800000&(data))>>23)
+#define HDMI_PRESET_S_CODE1_get_auto_stop_trk_en(data)               ((0x00400000&(data))>>22)
+#define HDMI_PRESET_S_CODE1_get_trk_mod_en(data)                     ((0x00200000&(data))>>21)
+#define HDMI_PRESET_S_CODE1_get_afsm_mod_en(data)                    ((0x00100000&(data))>>20)
+#define HDMI_PRESET_S_CODE1_get_pre_set_sm_code0(data)               ((0x00008000&(data))>>15)
+#define HDMI_PRESET_S_CODE1_get_pre_set_sm_code1(data)               ((0x00004000&(data))>>14)
+#define HDMI_PRESET_S_CODE1_get_pre_set_sm_code2(data)               ((0x00002000&(data))>>13)
+#define HDMI_PRESET_S_CODE1_get_pre_set_sm_code3(data)               ((0x00001000&(data))>>12)
+#define HDMI_PRESET_S_CODE1_get_pre_set_sm_code4(data)               ((0x00000800&(data))>>11)
+#define HDMI_PRESET_S_CODE1_get_pre_set_s1_code4(data)               ((0x00000080&(data))>>7)
+#define HDMI_PRESET_S_CODE1_get_pre_set_s_code4(data)                (0x0000007F&(data))
+
+
+#define HDMI_PRBS_R_CTRL                                             0x134
+#define HDMI_PRBS_R_CTRL_reg_addr                                    "0x98034134"
+#define HDMI_PRBS_R_CTRL_reg                                         0x98034134
+#define HDMI_PRBS_R_CTRL_inst_addr                                   "0x004D"
+#define HDMI_PRBS_R_CTRL_inst                                        0x004D
+#define HDMI_PRBS_R_CTRL_prbs23_rxen_shift                           (28)
+#define HDMI_PRBS_R_CTRL_prbs_rxbist_err_cnt_shift                   (20)
+#define HDMI_PRBS_R_CTRL_prbs_err_cnt_shift                          (16)
+#define HDMI_PRBS_R_CTRL_prbs_bit_err_shift                          (4)
+#define HDMI_PRBS_R_CTRL_prbs_lock_shift                             (3)
+#define HDMI_PRBS_R_CTRL_prbs_err_cnt_clr_shift                      (2)
+#define HDMI_PRBS_R_CTRL_prbs_reverse_shift                          (1)
+#define HDMI_PRBS_R_CTRL_prbs7_rxen_shift                            (0)
+#define HDMI_PRBS_R_CTRL_prbs23_rxen_mask                            (0x10000000)
+#define HDMI_PRBS_R_CTRL_prbs_rxbist_err_cnt_mask                    (0x0FF00000)
+#define HDMI_PRBS_R_CTRL_prbs_err_cnt_mask                           (0x000F0000)
+#define HDMI_PRBS_R_CTRL_prbs_bit_err_mask                           (0x00003FF0)
+#define HDMI_PRBS_R_CTRL_prbs_lock_mask                              (0x00000008)
+#define HDMI_PRBS_R_CTRL_prbs_err_cnt_clr_mask                       (0x00000004)
+#define HDMI_PRBS_R_CTRL_prbs_reverse_mask                           (0x00000002)
+#define HDMI_PRBS_R_CTRL_prbs7_rxen_mask                             (0x00000001)
+#define HDMI_PRBS_R_CTRL_prbs23_rxen(data)                           (0x10000000&((data)<<28))
+#define HDMI_PRBS_R_CTRL_prbs_rxbist_err_cnt(data)                   (0x0FF00000&((data)<<20))
+#define HDMI_PRBS_R_CTRL_prbs_err_cnt(data)                          (0x000F0000&((data)<<16))
+#define HDMI_PRBS_R_CTRL_prbs_bit_err(data)                          (0x00003FF0&((data)<<4))
+#define HDMI_PRBS_R_CTRL_prbs_lock(data)                             (0x00000008&((data)<<3))
+#define HDMI_PRBS_R_CTRL_prbs_err_cnt_clr(data)                      (0x00000004&((data)<<2))
+#define HDMI_PRBS_R_CTRL_prbs_reverse(data)                          (0x00000002&((data)<<1))
+#define HDMI_PRBS_R_CTRL_prbs7_rxen(data)                            (0x00000001&(data))
+#define HDMI_PRBS_R_CTRL_get_prbs23_rxen(data)                       ((0x10000000&(data))>>28)
+#define HDMI_PRBS_R_CTRL_get_prbs_rxbist_err_cnt(data)               ((0x0FF00000&(data))>>20)
+#define HDMI_PRBS_R_CTRL_get_prbs_err_cnt(data)                      ((0x000F0000&(data))>>16)
+#define HDMI_PRBS_R_CTRL_get_prbs_bit_err(data)                      ((0x00003FF0&(data))>>4)
+#define HDMI_PRBS_R_CTRL_get_prbs_lock(data)                         ((0x00000008&(data))>>3)
+#define HDMI_PRBS_R_CTRL_get_prbs_err_cnt_clr(data)                  ((0x00000004&(data))>>2)
+#define HDMI_PRBS_R_CTRL_get_prbs_reverse(data)                      ((0x00000002&(data))>>1)
+#define HDMI_PRBS_R_CTRL_get_prbs7_rxen(data)                        (0x00000001&(data))
+
+
+#define HDMI_PRBS_G_CTRL                                             0x138
+#define HDMI_PRBS_G_CTRL_reg_addr                                    "0x98034138"
+#define HDMI_PRBS_G_CTRL_reg                                         0x98034138
+#define HDMI_PRBS_G_CTRL_inst_addr                                   "0x004E"
+#define HDMI_PRBS_G_CTRL_inst                                        0x004E
+#define HDMI_PRBS_G_CTRL_prbs23_rxen_shift                           (28)
+#define HDMI_PRBS_G_CTRL_prbs_rxbist_err_cnt_shift                   (20)
+#define HDMI_PRBS_G_CTRL_prbs_err_cnt_shift                          (16)
+#define HDMI_PRBS_G_CTRL_prbs_bit_err_shift                          (4)
+#define HDMI_PRBS_G_CTRL_prbs_lock_shift                             (3)
+#define HDMI_PRBS_G_CTRL_prbs_err_cnt_clr_shift                      (2)
+#define HDMI_PRBS_G_CTRL_prbs_reverse_shift                          (1)
+#define HDMI_PRBS_G_CTRL_prbs7_rxen_shift                            (0)
+#define HDMI_PRBS_G_CTRL_prbs23_rxen_mask                            (0x10000000)
+#define HDMI_PRBS_G_CTRL_prbs_rxbist_err_cnt_mask                    (0x0FF00000)
+#define HDMI_PRBS_G_CTRL_prbs_err_cnt_mask                           (0x000F0000)
+#define HDMI_PRBS_G_CTRL_prbs_bit_err_mask                           (0x00003FF0)
+#define HDMI_PRBS_G_CTRL_prbs_lock_mask                              (0x00000008)
+#define HDMI_PRBS_G_CTRL_prbs_err_cnt_clr_mask                       (0x00000004)
+#define HDMI_PRBS_G_CTRL_prbs_reverse_mask                           (0x00000002)
+#define HDMI_PRBS_G_CTRL_prbs7_rxen_mask                             (0x00000001)
+#define HDMI_PRBS_G_CTRL_prbs23_rxen(data)                           (0x10000000&((data)<<28))
+#define HDMI_PRBS_G_CTRL_prbs_rxbist_err_cnt(data)                   (0x0FF00000&((data)<<20))
+#define HDMI_PRBS_G_CTRL_prbs_err_cnt(data)                          (0x000F0000&((data)<<16))
+#define HDMI_PRBS_G_CTRL_prbs_bit_err(data)                          (0x00003FF0&((data)<<4))
+#define HDMI_PRBS_G_CTRL_prbs_lock(data)                             (0x00000008&((data)<<3))
+#define HDMI_PRBS_G_CTRL_prbs_err_cnt_clr(data)                      (0x00000004&((data)<<2))
+#define HDMI_PRBS_G_CTRL_prbs_reverse(data)                          (0x00000002&((data)<<1))
+#define HDMI_PRBS_G_CTRL_prbs7_rxen(data)                            (0x00000001&(data))
+#define HDMI_PRBS_G_CTRL_get_prbs23_rxen(data)                       ((0x10000000&(data))>>28)
+#define HDMI_PRBS_G_CTRL_get_prbs_rxbist_err_cnt(data)               ((0x0FF00000&(data))>>20)
+#define HDMI_PRBS_G_CTRL_get_prbs_err_cnt(data)                      ((0x000F0000&(data))>>16)
+#define HDMI_PRBS_G_CTRL_get_prbs_bit_err(data)                      ((0x00003FF0&(data))>>4)
+#define HDMI_PRBS_G_CTRL_get_prbs_lock(data)                         ((0x00000008&(data))>>3)
+#define HDMI_PRBS_G_CTRL_get_prbs_err_cnt_clr(data)                  ((0x00000004&(data))>>2)
+#define HDMI_PRBS_G_CTRL_get_prbs_reverse(data)                      ((0x00000002&(data))>>1)
+#define HDMI_PRBS_G_CTRL_get_prbs7_rxen(data)                        (0x00000001&(data))
+
+
+#define HDMI_PRBS_B_CTRL                                             0x13c
+#define HDMI_PRBS_B_CTRL_reg_addr                                    "0x9803413c"
+#define HDMI_PRBS_B_CTRL_reg                                         0x9803413c
+#define HDMI_PRBS_B_CTRL_inst_addr                                   "0x004F"
+#define HDMI_PRBS_B_CTRL_inst                                        0x004F
+#define HDMI_PRBS_B_CTRL_prbs23_rxen_shift                           (28)
+#define HDMI_PRBS_B_CTRL_prbs_rxbist_err_cnt_shift                   (20)
+#define HDMI_PRBS_B_CTRL_prbs_err_cnt_shift                          (16)
+#define HDMI_PRBS_B_CTRL_prbs_bit_err_shift                          (4)
+#define HDMI_PRBS_B_CTRL_prbs_lock_shift                             (3)
+#define HDMI_PRBS_B_CTRL_prbs_err_cnt_clr_shift                      (2)
+#define HDMI_PRBS_B_CTRL_prbs_reverse_shift                          (1)
+#define HDMI_PRBS_B_CTRL_prbs7_rxen_shift                            (0)
+#define HDMI_PRBS_B_CTRL_prbs23_rxen_mask                            (0x10000000)
+#define HDMI_PRBS_B_CTRL_prbs_rxbist_err_cnt_mask                    (0x0FF00000)
+#define HDMI_PRBS_B_CTRL_prbs_err_cnt_mask                           (0x000F0000)
+#define HDMI_PRBS_B_CTRL_prbs_bit_err_mask                           (0x00003FF0)
+#define HDMI_PRBS_B_CTRL_prbs_lock_mask                              (0x00000008)
+#define HDMI_PRBS_B_CTRL_prbs_err_cnt_clr_mask                       (0x00000004)
+#define HDMI_PRBS_B_CTRL_prbs_reverse_mask                           (0x00000002)
+#define HDMI_PRBS_B_CTRL_prbs7_rxen_mask                             (0x00000001)
+#define HDMI_PRBS_B_CTRL_prbs23_rxen(data)                           (0x10000000&((data)<<28))
+#define HDMI_PRBS_B_CTRL_prbs_rxbist_err_cnt(data)                   (0x0FF00000&((data)<<20))
+#define HDMI_PRBS_B_CTRL_prbs_err_cnt(data)                          (0x000F0000&((data)<<16))
+#define HDMI_PRBS_B_CTRL_prbs_bit_err(data)                          (0x00003FF0&((data)<<4))
+#define HDMI_PRBS_B_CTRL_prbs_lock(data)                             (0x00000008&((data)<<3))
+#define HDMI_PRBS_B_CTRL_prbs_err_cnt_clr(data)                      (0x00000004&((data)<<2))
+#define HDMI_PRBS_B_CTRL_prbs_reverse(data)                          (0x00000002&((data)<<1))
+#define HDMI_PRBS_B_CTRL_prbs7_rxen(data)                            (0x00000001&(data))
+#define HDMI_PRBS_B_CTRL_get_prbs23_rxen(data)                       ((0x10000000&(data))>>28)
+#define HDMI_PRBS_B_CTRL_get_prbs_rxbist_err_cnt(data)               ((0x0FF00000&(data))>>20)
+#define HDMI_PRBS_B_CTRL_get_prbs_err_cnt(data)                      ((0x000F0000&(data))>>16)
+#define HDMI_PRBS_B_CTRL_get_prbs_bit_err(data)                      ((0x00003FF0&(data))>>4)
+#define HDMI_PRBS_B_CTRL_get_prbs_lock(data)                         ((0x00000008&(data))>>3)
+#define HDMI_PRBS_B_CTRL_get_prbs_err_cnt_clr(data)                  ((0x00000004&(data))>>2)
+#define HDMI_PRBS_B_CTRL_get_prbs_reverse(data)                      ((0x00000002&(data))>>1)
+#define HDMI_PRBS_B_CTRL_get_prbs7_rxen(data)                        (0x00000001&(data))
+
+
+#define HDMI_LEADING_GB_CMP_CTRL                                0x140
+#define HDMI_LEADING_GB_CMP_CTRL_reg_addr                       "0x98034140"
+#define HDMI_LEADING_GB_CMP_CTRL_reg                            0x98034140
+#define HDMI_LEADING_GB_CMP_CTRL_inst_addr                      "0x0050"
+#define HDMI_LEADING_GB_CMP_CTRL_inst                           0x0050
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag_shift             (30)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en_shift            (29)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en_shift           (28)
+#define HDMI_LEADING_GB_CMP_CTRL_preamble_shift                 (24)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_value_shift                (8)
+#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel_shift             (4)
+#define HDMI_LEADING_GB_CMP_CTRL_channel_sel_shift              (2)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti_shift            (1)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en_shift               (0)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag_mask              (0x40000000)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en_mask             (0x20000000)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en_mask            (0x10000000)
+#define HDMI_LEADING_GB_CMP_CTRL_preamble_mask                  (0x0F000000)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_value_mask                 (0x0003FF00)
+#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel_mask              (0x00000010)
+#define HDMI_LEADING_GB_CMP_CTRL_channel_sel_mask               (0x0000000C)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti_mask             (0x00000002)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en_mask                (0x00000001)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag(data)             (0x40000000&((data)<<30))
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en(data)            (0x20000000&((data)<<29))
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en(data)           (0x10000000&((data)<<28))
+#define HDMI_LEADING_GB_CMP_CTRL_preamble(data)                 (0x0F000000&((data)<<24))
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_value(data)                (0x0003FF00&((data)<<8))
+#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel(data)             (0x00000010&((data)<<4))
+#define HDMI_LEADING_GB_CMP_CTRL_channel_sel(data)              (0x0000000C&((data)<<2))
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti(data)            (0x00000002&((data)<<1))
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en(data)               (0x00000001&(data))
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_flag(data)         ((0x40000000&(data))>>30)
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_wd_en(data)        ((0x20000000&(data))>>29)
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_int_en(data)       ((0x10000000&(data))>>28)
+#define HDMI_LEADING_GB_CMP_CTRL_get_preamble(data)             ((0x0F000000&(data))>>24)
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_value(data)            ((0x0003FF00&(data))>>8)
+#define HDMI_LEADING_GB_CMP_CTRL_get_dvi_mode_sel(data)         ((0x00000010&(data))>>4)
+#define HDMI_LEADING_GB_CMP_CTRL_get_channel_sel(data)          ((0x0000000C&(data))>>2)
+#define HDMI_LEADING_GB_CMP_CTRL_get_lgb_cal_conti(data)        ((0x00000002&(data))>>1)
+#define HDMI_LEADING_GB_CMP_CTRL_get_lgb_cal_en(data)           (0x00000001&(data))
+
+
+#define HDMI_LEADING_GB_CMP_TIMES                               0x144
+#define HDMI_LEADING_GB_CMP_TIMES_reg_addr                      "0x98034144"
+#define HDMI_LEADING_GB_CMP_TIMES_reg                           0x98034144
+#define HDMI_LEADING_GB_CMP_TIMES_inst_addr                     "0x0051"
+#define HDMI_LEADING_GB_CMP_TIMES_inst                          0x0051
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt_shift             (16)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_times_shift               (0)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt_mask              (0xFFFF0000)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_times_mask                (0x0000FFFF)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt(data)             (0xFFFF0000&((data)<<16))
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_times(data)               (0x0000FFFF&(data))
+#define HDMI_LEADING_GB_CMP_TIMES_get_cmp_err_cnt(data)         ((0xFFFF0000&(data))>>16)
+#define HDMI_LEADING_GB_CMP_TIMES_get_cmp_times(data)           (0x0000FFFF&(data))
+
+
+#define HDMI_LEADING_GB_CMP_CNT                                 0x148
+#define HDMI_LEADING_GB_CMP_CNT_reg_addr                        "0x98034148"
+#define HDMI_LEADING_GB_CMP_CNT_reg                             0x98034148
+#define HDMI_LEADING_GB_CMP_CNT_inst_addr                       "0x0052"
+#define HDMI_LEADING_GB_CMP_CNT_inst                            0x0052
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_shift          (16)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame_shift (0)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_mask           (0xFFFF0000)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame_mask  (0x0000FFFF)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt(data)          (0xFFFF0000&((data)<<16))
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame(data) (0x0000FFFF&(data))
+#define HDMI_LEADING_GB_CMP_CNT_get_preamble_cmp_cnt(data)      ((0xFFFF0000&(data))>>16)
+#define HDMI_LEADING_GB_CMP_CNT_get_preamble_cmp_cnt_by_frame(data)  (0x0000FFFF&(data))
+
+
+#define HDMI_AUDIO_CTS_UP_BOUND                                      0x14c
+#define HDMI_AUDIO_CTS_UP_BOUND_reg_addr                             "0x9803414c"
+#define HDMI_AUDIO_CTS_UP_BOUND_reg                                  0x9803414c
+#define HDMI_AUDIO_CTS_UP_BOUND_inst_addr                            "0x0053"
+#define HDMI_AUDIO_CTS_UP_BOUND_inst                                 0x0053
+#define HDMI_AUDIO_CTS_UP_BOUND_cts_over_flag_shift                  (31)
+#define HDMI_AUDIO_CTS_UP_BOUND_cts_clip_en_shift                    (20)
+#define HDMI_AUDIO_CTS_UP_BOUND_cts_up_bound_shift                   (0)
+#define HDMI_AUDIO_CTS_UP_BOUND_cts_over_flag_mask                   (0x80000000)
+#define HDMI_AUDIO_CTS_UP_BOUND_cts_clip_en_mask                     (0x00100000)
+#define HDMI_AUDIO_CTS_UP_BOUND_cts_up_bound_mask                    (0x000FFFFF)
+#define HDMI_AUDIO_CTS_UP_BOUND_cts_over_flag(data)                  (0x80000000&((data)<<31))
+#define HDMI_AUDIO_CTS_UP_BOUND_cts_clip_en(data)                    (0x00100000&((data)<<20))
+#define HDMI_AUDIO_CTS_UP_BOUND_cts_up_bound(data)                   (0x000FFFFF&(data))
+#define HDMI_AUDIO_CTS_UP_BOUND_get_cts_over_flag(data)              ((0x80000000&(data))>>31)
+#define HDMI_AUDIO_CTS_UP_BOUND_get_cts_clip_en(data)                ((0x00100000&(data))>>20)
+#define HDMI_AUDIO_CTS_UP_BOUND_get_cts_up_bound(data)               (0x000FFFFF&(data))
+
+
+#define HDMI_AUDIO_CTS_LOW_BOUND                                     0x150
+#define HDMI_AUDIO_CTS_LOW_BOUND_reg_addr                            "0x98034150"
+#define HDMI_AUDIO_CTS_LOW_BOUND_reg                                 0x98034150
+#define HDMI_AUDIO_CTS_LOW_BOUND_inst_addr                           "0x0054"
+#define HDMI_AUDIO_CTS_LOW_BOUND_inst                                0x0054
+#define HDMI_AUDIO_CTS_LOW_BOUND_cts_under_flag_shift                (31)
+#define HDMI_AUDIO_CTS_LOW_BOUND_cts_low_bound_shift                 (0)
+#define HDMI_AUDIO_CTS_LOW_BOUND_cts_under_flag_mask                 (0x80000000)
+#define HDMI_AUDIO_CTS_LOW_BOUND_cts_low_bound_mask                  (0x000FFFFF)
+#define HDMI_AUDIO_CTS_LOW_BOUND_cts_under_flag(data)                (0x80000000&((data)<<31))
+#define HDMI_AUDIO_CTS_LOW_BOUND_cts_low_bound(data)                 (0x000FFFFF&(data))
+#define HDMI_AUDIO_CTS_LOW_BOUND_get_cts_under_flag(data)            ((0x80000000&(data))>>31)
+#define HDMI_AUDIO_CTS_LOW_BOUND_get_cts_low_bound(data)             (0x000FFFFF&(data))
+
+
+#define HDMI_AUDIO_N_UP_BOUND                                        0x154
+#define HDMI_AUDIO_N_UP_BOUND_reg_addr                               "0x98034154"
+#define HDMI_AUDIO_N_UP_BOUND_reg                                    0x98034154
+#define HDMI_AUDIO_N_UP_BOUND_inst_addr                              "0x0055"
+#define HDMI_AUDIO_N_UP_BOUND_inst                                   0x0055
+#define HDMI_AUDIO_N_UP_BOUND_n_over_flag_shift                      (31)
+#define HDMI_AUDIO_N_UP_BOUND_n_clip_en_shift                        (20)
+#define HDMI_AUDIO_N_UP_BOUND_n_up_bound_shift                       (0)
+#define HDMI_AUDIO_N_UP_BOUND_n_over_flag_mask                       (0x80000000)
+#define HDMI_AUDIO_N_UP_BOUND_n_clip_en_mask                         (0x00100000)
+#define HDMI_AUDIO_N_UP_BOUND_n_up_bound_mask                        (0x000FFFFF)
+#define HDMI_AUDIO_N_UP_BOUND_n_over_flag(data)                      (0x80000000&((data)<<31))
+#define HDMI_AUDIO_N_UP_BOUND_n_clip_en(data)                        (0x00100000&((data)<<20))
+#define HDMI_AUDIO_N_UP_BOUND_n_up_bound(data)                       (0x000FFFFF&(data))
+#define HDMI_AUDIO_N_UP_BOUND_get_n_over_flag(data)                  ((0x80000000&(data))>>31)
+#define HDMI_AUDIO_N_UP_BOUND_get_n_clip_en(data)                    ((0x00100000&(data))>>20)
+#define HDMI_AUDIO_N_UP_BOUND_get_n_up_bound(data)                   (0x000FFFFF&(data))
+
+
+#define HDMI_AUDIO_N_LOW_BOUND                                       0x158
+#define HDMI_AUDIO_N_LOW_BOUND_reg_addr                              "0x98034158"
+#define HDMI_AUDIO_N_LOW_BOUND_reg                                   0x98034158
+#define HDMI_AUDIO_N_LOW_BOUND_inst_addr                             "0x0056"
+#define HDMI_AUDIO_N_LOW_BOUND_inst                                  0x0056
+#define HDMI_AUDIO_N_LOW_BOUND_n_under_flag_shift                    (31)
+#define HDMI_AUDIO_N_LOW_BOUND_n_low_bound_shift                     (0)
+#define HDMI_AUDIO_N_LOW_BOUND_n_under_flag_mask                     (0x80000000)
+#define HDMI_AUDIO_N_LOW_BOUND_n_low_bound_mask                      (0x000FFFFF)
+#define HDMI_AUDIO_N_LOW_BOUND_n_under_flag(data)                    (0x80000000&((data)<<31))
+#define HDMI_AUDIO_N_LOW_BOUND_n_low_bound(data)                     (0x000FFFFF&(data))
+#define HDMI_AUDIO_N_LOW_BOUND_get_n_under_flag(data)                ((0x80000000&(data))>>31)
+#define HDMI_AUDIO_N_LOW_BOUND_get_n_low_bound(data)                 (0x000FFFFF&(data))
+
+
+#define HDMI_MHL_HDMI_MAC_CTRL                                       0x15c
+#define HDMI_MHL_HDMI_MAC_CTRL_reg_addr                              "0x9803415c"
+#define HDMI_MHL_HDMI_MAC_CTRL_reg                                   0x9803415c
+#define HDMI_MHL_HDMI_MAC_CTRL_inst_addr                             "0x0057"
+#define HDMI_MHL_HDMI_MAC_CTRL_inst                                  0x0057
+#define HDMI_MHL_HDMI_MAC_CTRL_hporch_offset_shift                   (16)
+#define HDMI_MHL_HDMI_MAC_CTRL_dummy9803415c_15_14_shift             (14)
+#define HDMI_MHL_HDMI_MAC_CTRL_en_packet_retiming_vsrst_shift        (13)
+#define HDMI_MHL_HDMI_MAC_CTRL_pp_mode_output_shift                  (12)
+#define HDMI_MHL_HDMI_MAC_CTRL_packet_mhl_en_shift                   (8)
+#define HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel_shift                   (5)
+#define HDMI_MHL_HDMI_MAC_CTRL_cal_pixel_sel_shift                   (4)
+#define HDMI_MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_shift               (0)
+#define HDMI_MHL_HDMI_MAC_CTRL_hporch_offset_mask                    (0x03FF0000)
+#define HDMI_MHL_HDMI_MAC_CTRL_dummy9803415c_15_14_mask              (0x0000C000)
+#define HDMI_MHL_HDMI_MAC_CTRL_en_packet_retiming_vsrst_mask         (0x00002000)
+#define HDMI_MHL_HDMI_MAC_CTRL_pp_mode_output_mask                   (0x00001000)
+#define HDMI_MHL_HDMI_MAC_CTRL_packet_mhl_en_mask                    (0x00000100)
+#define HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel_mask                    (0x000000E0)
+#define HDMI_MHL_HDMI_MAC_CTRL_cal_pixel_sel_mask                    (0x00000010)
+#define HDMI_MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_mask                (0x00000001)
+#define HDMI_MHL_HDMI_MAC_CTRL_hporch_offset(data)                   (0x03FF0000&((data)<<16))
+#define HDMI_MHL_HDMI_MAC_CTRL_dummy9803415c_15_14(data)             (0x0000C000&((data)<<14))
+#define HDMI_MHL_HDMI_MAC_CTRL_en_packet_retiming_vsrst(data)        (0x00002000&((data)<<13))
+#define HDMI_MHL_HDMI_MAC_CTRL_pp_mode_output(data)                  (0x00001000&((data)<<12))
+#define HDMI_MHL_HDMI_MAC_CTRL_packet_mhl_en(data)                   (0x00000100&((data)<<8))
+#define HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel(data)                   (0x000000E0&((data)<<5))
+#define HDMI_MHL_HDMI_MAC_CTRL_cal_pixel_sel(data)                   (0x00000010&((data)<<4))
+#define HDMI_MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en(data)               (0x00000001&(data))
+#define HDMI_MHL_HDMI_MAC_CTRL_get_hporch_offset(data)               ((0x03FF0000&(data))>>16)
+#define HDMI_MHL_HDMI_MAC_CTRL_get_dummy9803415c_15_14(data)         ((0x0000C000&(data))>>14)
+#define HDMI_MHL_HDMI_MAC_CTRL_get_en_packet_retiming_vsrst(data)    ((0x00002000&(data))>>13)
+#define HDMI_MHL_HDMI_MAC_CTRL_get_pp_mode_output(data)              ((0x00001000&(data))>>12)
+#define HDMI_MHL_HDMI_MAC_CTRL_get_packet_mhl_en(data)               ((0x00000100&(data))>>8)
+#define HDMI_MHL_HDMI_MAC_CTRL_get_xor_pixel_sel(data)               ((0x000000E0&(data))>>5)
+#define HDMI_MHL_HDMI_MAC_CTRL_get_cal_pixel_sel(data)               ((0x00000010&(data))>>4)
+#define HDMI_MHL_HDMI_MAC_CTRL_get_ch_dec_pp_mode_en(data)           (0x00000001&(data))
+
+
+#define HDMI_MHL_3D_FORMAT                                           0x160
+#define HDMI_MHL_3D_FORMAT_reg_addr                                  "0x98034160"
+#define HDMI_MHL_3D_FORMAT_reg                                       0x98034160
+#define HDMI_MHL_3D_FORMAT_inst_addr                                 "0x0058"
+#define HDMI_MHL_3D_FORMAT_inst                                      0x0058
+#define HDMI_MHL_3D_FORMAT_mhl_3d_fmt_shift                          (26)
+#define HDMI_MHL_3D_FORMAT_mhl_vid_shift                             (24)
+#define HDMI_MHL_3D_FORMAT_oui_shift                                 (0)
+#define HDMI_MHL_3D_FORMAT_mhl_3d_fmt_mask                           (0x3C000000)
+#define HDMI_MHL_3D_FORMAT_mhl_vid_mask                              (0x03000000)
+#define HDMI_MHL_3D_FORMAT_oui_mask                                  (0x00FFFFFF)
+#define HDMI_MHL_3D_FORMAT_mhl_3d_fmt(data)                          (0x3C000000&((data)<<26))
+#define HDMI_MHL_3D_FORMAT_mhl_vid(data)                             (0x03000000&((data)<<24))
+#define HDMI_MHL_3D_FORMAT_oui(data)                                 (0x00FFFFFF&(data))
+#define HDMI_MHL_3D_FORMAT_get_mhl_3d_fmt(data)                      ((0x3C000000&(data))>>26)
+#define HDMI_MHL_3D_FORMAT_get_mhl_vid(data)                         ((0x03000000&(data))>>24)
+#define HDMI_MHL_3D_FORMAT_get_oui(data)                             (0x00FFFFFF&(data))
+
+
+#define HDMI_MHL_3P0_FORMAT0                                         0x164
+#define HDMI_MHL_3P0_FORMAT0_reg_addr                                "0x98034164"
+#define HDMI_MHL_3P0_FORMAT0_reg                                     0x98034164
+#define HDMI_MHL_3P0_FORMAT0_inst_addr                               "0x0059"
+#define HDMI_MHL_3P0_FORMAT0_inst                                    0x0059
+#define HDMI_MHL_3P0_FORMAT0_mhl_hev_fmt_shift                       (17)
+#define HDMI_MHL_3P0_FORMAT0_sep_aud_shift                           (16)
+#define HDMI_MHL_3P0_FORMAT0_mhl_hev_fmt_type_shift                  (0)
+#define HDMI_MHL_3P0_FORMAT0_mhl_hev_fmt_mask                        (0x00060000)
+#define HDMI_MHL_3P0_FORMAT0_sep_aud_mask                            (0x00010000)
+#define HDMI_MHL_3P0_FORMAT0_mhl_hev_fmt_type_mask                   (0x0000FFFF)
+#define HDMI_MHL_3P0_FORMAT0_mhl_hev_fmt(data)                       (0x00060000&((data)<<17))
+#define HDMI_MHL_3P0_FORMAT0_sep_aud(data)                           (0x00010000&((data)<<16))
+#define HDMI_MHL_3P0_FORMAT0_mhl_hev_fmt_type(data)                  (0x0000FFFF&(data))
+#define HDMI_MHL_3P0_FORMAT0_get_mhl_hev_fmt(data)                   ((0x00060000&(data))>>17)
+#define HDMI_MHL_3P0_FORMAT0_get_sep_aud(data)                       ((0x00010000&(data))>>16)
+#define HDMI_MHL_3P0_FORMAT0_get_mhl_hev_fmt_type(data)              (0x0000FFFF&(data))
+
+
+#define HDMI_MHL_3P0_FORMAT1                                         0x168
+#define HDMI_MHL_3P0_FORMAT1_reg_addr                                "0x98034168"
+#define HDMI_MHL_3P0_FORMAT1_reg                                     0x98034168
+#define HDMI_MHL_3P0_FORMAT1_inst_addr                               "0x005A"
+#define HDMI_MHL_3P0_FORMAT1_inst                                    0x005A
+#define HDMI_MHL_3P0_FORMAT1_acrfs_div_shift                         (21)
+#define HDMI_MHL_3P0_FORMAT1_av_delay_dir_shift                      (20)
+#define HDMI_MHL_3P0_FORMAT1_av_delay_sync_shift                     (0)
+#define HDMI_MHL_3P0_FORMAT1_acrfs_div_mask                          (0x00E00000)
+#define HDMI_MHL_3P0_FORMAT1_av_delay_dir_mask                       (0x00100000)
+#define HDMI_MHL_3P0_FORMAT1_av_delay_sync_mask                      (0x000FFFFF)
+#define HDMI_MHL_3P0_FORMAT1_acrfs_div(data)                         (0x00E00000&((data)<<21))
+#define HDMI_MHL_3P0_FORMAT1_av_delay_dir(data)                      (0x00100000&((data)<<20))
+#define HDMI_MHL_3P0_FORMAT1_av_delay_sync(data)                     (0x000FFFFF&(data))
+#define HDMI_MHL_3P0_FORMAT1_get_acrfs_div(data)                     ((0x00E00000&(data))>>21)
+#define HDMI_MHL_3P0_FORMAT1_get_av_delay_dir(data)                  ((0x00100000&(data))>>20)
+#define HDMI_MHL_3P0_FORMAT1_get_av_delay_sync(data)                 (0x000FFFFF&(data))
+
+
+#define HDMI_LIGHT_SLEEP                                             0x16c
+#define HDMI_LIGHT_SLEEP_reg_addr                                    "0x9803416c"
+#define HDMI_LIGHT_SLEEP_reg                                         0x9803416c
+#define HDMI_LIGHT_SLEEP_inst_addr                                   "0x005B"
+#define HDMI_LIGHT_SLEEP_inst                                        0x005B
+#define HDMI_LIGHT_SLEEP_yuv420_ls3_shift                            (8)
+#define HDMI_LIGHT_SLEEP_yuv420_ls2_shift                            (7)
+#define HDMI_LIGHT_SLEEP_yuv420_ls1_shift                            (6)
+#define HDMI_LIGHT_SLEEP_yuv420_ls0_shift                            (5)
+#define HDMI_LIGHT_SLEEP_hdcp_2p2_ls1_shift                          (4)
+#define HDMI_LIGHT_SLEEP_hdcp_2p2_ls0_shift                          (3)
+#define HDMI_LIGHT_SLEEP_hdcp_ksvfifo_ls_shift                       (2)
+#define HDMI_LIGHT_SLEEP_hdcp_ls_shift                               (1)
+#define HDMI_LIGHT_SLEEP_audio_ls_shift                              (0)
+#define HDMI_LIGHT_SLEEP_yuv420_ls3_mask                             (0x00000100)
+#define HDMI_LIGHT_SLEEP_yuv420_ls2_mask                             (0x00000080)
+#define HDMI_LIGHT_SLEEP_yuv420_ls1_mask                             (0x00000040)
+#define HDMI_LIGHT_SLEEP_yuv420_ls0_mask                             (0x00000020)
+#define HDMI_LIGHT_SLEEP_hdcp_2p2_ls1_mask                           (0x00000010)
+#define HDMI_LIGHT_SLEEP_hdcp_2p2_ls0_mask                           (0x00000008)
+#define HDMI_LIGHT_SLEEP_hdcp_ksvfifo_ls_mask                        (0x00000004)
+#define HDMI_LIGHT_SLEEP_hdcp_ls_mask                                (0x00000002)
+#define HDMI_LIGHT_SLEEP_audio_ls_mask                               (0x00000001)
+#define HDMI_LIGHT_SLEEP_yuv420_ls3(data)                            (0x00000100&((data)<<8))
+#define HDMI_LIGHT_SLEEP_yuv420_ls2(data)                            (0x00000080&((data)<<7))
+#define HDMI_LIGHT_SLEEP_yuv420_ls1(data)                            (0x00000040&((data)<<6))
+#define HDMI_LIGHT_SLEEP_yuv420_ls0(data)                            (0x00000020&((data)<<5))
+#define HDMI_LIGHT_SLEEP_hdcp_2p2_ls1(data)                          (0x00000010&((data)<<4))
+#define HDMI_LIGHT_SLEEP_hdcp_2p2_ls0(data)                          (0x00000008&((data)<<3))
+#define HDMI_LIGHT_SLEEP_hdcp_ksvfifo_ls(data)                       (0x00000004&((data)<<2))
+#define HDMI_LIGHT_SLEEP_hdcp_ls(data)                               (0x00000002&((data)<<1))
+#define HDMI_LIGHT_SLEEP_audio_ls(data)                              (0x00000001&(data))
+#define HDMI_LIGHT_SLEEP_get_yuv420_ls3(data)                        ((0x00000100&(data))>>8)
+#define HDMI_LIGHT_SLEEP_get_yuv420_ls2(data)                        ((0x00000080&(data))>>7)
+#define HDMI_LIGHT_SLEEP_get_yuv420_ls1(data)                        ((0x00000040&(data))>>6)
+#define HDMI_LIGHT_SLEEP_get_yuv420_ls0(data)                        ((0x00000020&(data))>>5)
+#define HDMI_LIGHT_SLEEP_get_hdcp_2p2_ls1(data)                      ((0x00000010&(data))>>4)
+#define HDMI_LIGHT_SLEEP_get_hdcp_2p2_ls0(data)                      ((0x00000008&(data))>>3)
+#define HDMI_LIGHT_SLEEP_get_hdcp_ksvfifo_ls(data)                   ((0x00000004&(data))>>2)
+#define HDMI_LIGHT_SLEEP_get_hdcp_ls(data)                           ((0x00000002&(data))>>1)
+#define HDMI_LIGHT_SLEEP_get_audio_ls(data)                          (0x00000001&(data))
+
+
+#define HDMI_READ_MARGIN2                                            0x170
+#define HDMI_READ_MARGIN2_reg_addr                                   "0x98034170"
+#define HDMI_READ_MARGIN2_reg                                        0x98034170
+#define HDMI_READ_MARGIN2_inst_addr                                  "0x005C"
+#define HDMI_READ_MARGIN2_inst                                       0x005C
+#define HDMI_READ_MARGIN2_yuv420_rm3_shift                           (12)
+#define HDMI_READ_MARGIN2_yuv420_rm2_shift                           (8)
+#define HDMI_READ_MARGIN2_yuv420_rm1_shift                           (4)
+#define HDMI_READ_MARGIN2_yuv420_rm0_shift                           (0)
+#define HDMI_READ_MARGIN2_yuv420_rm3_mask                            (0x0000F000)
+#define HDMI_READ_MARGIN2_yuv420_rm2_mask                            (0x00000F00)
+#define HDMI_READ_MARGIN2_yuv420_rm1_mask                            (0x000000F0)
+#define HDMI_READ_MARGIN2_yuv420_rm0_mask                            (0x0000000F)
+#define HDMI_READ_MARGIN2_yuv420_rm3(data)                           (0x0000F000&((data)<<12))
+#define HDMI_READ_MARGIN2_yuv420_rm2(data)                           (0x00000F00&((data)<<8))
+#define HDMI_READ_MARGIN2_yuv420_rm1(data)                           (0x000000F0&((data)<<4))
+#define HDMI_READ_MARGIN2_yuv420_rm0(data)                           (0x0000000F&(data))
+#define HDMI_READ_MARGIN2_get_yuv420_rm3(data)                       ((0x0000F000&(data))>>12)
+#define HDMI_READ_MARGIN2_get_yuv420_rm2(data)                       ((0x00000F00&(data))>>8)
+#define HDMI_READ_MARGIN2_get_yuv420_rm1(data)                       ((0x000000F0&(data))>>4)
+#define HDMI_READ_MARGIN2_get_yuv420_rm0(data)                       (0x0000000F&(data))
+
+
+#define HDMI_READ_MARGIN_ENABLE                                      0x174
+#define HDMI_READ_MARGIN_ENABLE_reg_addr                             "0x98034174"
+#define HDMI_READ_MARGIN_ENABLE_reg                                  0x98034174
+#define HDMI_READ_MARGIN_ENABLE_inst_addr                            "0x005D"
+#define HDMI_READ_MARGIN_ENABLE_inst                                 0x005D
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme3_shift                    (8)
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme2_shift                    (7)
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme1_shift                    (6)
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme0_shift                    (5)
+#define HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme1_shift                  (4)
+#define HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme0_shift                  (3)
+#define HDMI_READ_MARGIN_ENABLE_hdcp_ksvfifo_rme_shift               (2)
+#define HDMI_READ_MARGIN_ENABLE_hdcp_rme_shift                       (1)
+#define HDMI_READ_MARGIN_ENABLE_audio_rme_shift                      (0)
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme3_mask                     (0x00000100)
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme2_mask                     (0x00000080)
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme1_mask                     (0x00000040)
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme0_mask                     (0x00000020)
+#define HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme1_mask                   (0x00000010)
+#define HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme0_mask                   (0x00000008)
+#define HDMI_READ_MARGIN_ENABLE_hdcp_ksvfifo_rme_mask                (0x00000004)
+#define HDMI_READ_MARGIN_ENABLE_hdcp_rme_mask                        (0x00000002)
+#define HDMI_READ_MARGIN_ENABLE_audio_rme_mask                       (0x00000001)
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme3(data)                    (0x00000100&((data)<<8))
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme2(data)                    (0x00000080&((data)<<7))
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme1(data)                    (0x00000040&((data)<<6))
+#define HDMI_READ_MARGIN_ENABLE_yuv420_rme0(data)                    (0x00000020&((data)<<5))
+#define HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme1(data)                  (0x00000010&((data)<<4))
+#define HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme0(data)                  (0x00000008&((data)<<3))
+#define HDMI_READ_MARGIN_ENABLE_hdcp_ksvfifo_rme(data)               (0x00000004&((data)<<2))
+#define HDMI_READ_MARGIN_ENABLE_hdcp_rme(data)                       (0x00000002&((data)<<1))
+#define HDMI_READ_MARGIN_ENABLE_audio_rme(data)                      (0x00000001&(data))
+#define HDMI_READ_MARGIN_ENABLE_get_yuv420_rme3(data)                ((0x00000100&(data))>>8)
+#define HDMI_READ_MARGIN_ENABLE_get_yuv420_rme2(data)                ((0x00000080&(data))>>7)
+#define HDMI_READ_MARGIN_ENABLE_get_yuv420_rme1(data)                ((0x00000040&(data))>>6)
+#define HDMI_READ_MARGIN_ENABLE_get_yuv420_rme0(data)                ((0x00000020&(data))>>5)
+#define HDMI_READ_MARGIN_ENABLE_get_hdcp_2p2_rme1(data)              ((0x00000010&(data))>>4)
+#define HDMI_READ_MARGIN_ENABLE_get_hdcp_2p2_rme0(data)              ((0x00000008&(data))>>3)
+#define HDMI_READ_MARGIN_ENABLE_get_hdcp_ksvfifo_rme(data)           ((0x00000004&(data))>>2)
+#define HDMI_READ_MARGIN_ENABLE_get_hdcp_rme(data)                   ((0x00000002&(data))>>1)
+#define HDMI_READ_MARGIN_ENABLE_get_audio_rme(data)                  (0x00000001&(data))
+
+
+#define HDMI_READ_MARGIN                                             0x178
+#define HDMI_READ_MARGIN_reg_addr                                    "0x98034178"
+#define HDMI_READ_MARGIN_reg                                         0x98034178
+#define HDMI_READ_MARGIN_inst_addr                                   "0x005E"
+#define HDMI_READ_MARGIN_inst                                        0x005E
+#define HDMI_READ_MARGIN_hdcp_2p2_rm1_shift                          (16)
+#define HDMI_READ_MARGIN_hdcp_2p2_rm0_shift                          (12)
+#define HDMI_READ_MARGIN_hdcp_ksvfifo_rm_shift                       (8)
+#define HDMI_READ_MARGIN_hdcp_rm_shift                               (4)
+#define HDMI_READ_MARGIN_audio_rm_shift                              (0)
+#define HDMI_READ_MARGIN_hdcp_2p2_rm1_mask                           (0x000F0000)
+#define HDMI_READ_MARGIN_hdcp_2p2_rm0_mask                           (0x0000F000)
+#define HDMI_READ_MARGIN_hdcp_ksvfifo_rm_mask                        (0x00000F00)
+#define HDMI_READ_MARGIN_hdcp_rm_mask                                (0x000000F0)
+#define HDMI_READ_MARGIN_audio_rm_mask                               (0x0000000F)
+#define HDMI_READ_MARGIN_hdcp_2p2_rm1(data)                          (0x000F0000&((data)<<16))
+#define HDMI_READ_MARGIN_hdcp_2p2_rm0(data)                          (0x0000F000&((data)<<12))
+#define HDMI_READ_MARGIN_hdcp_ksvfifo_rm(data)                       (0x00000F00&((data)<<8))
+#define HDMI_READ_MARGIN_hdcp_rm(data)                               (0x000000F0&((data)<<4))
+#define HDMI_READ_MARGIN_audio_rm(data)                              (0x0000000F&(data))
+#define HDMI_READ_MARGIN_get_hdcp_2p2_rm1(data)                      ((0x000F0000&(data))>>16)
+#define HDMI_READ_MARGIN_get_hdcp_2p2_rm0(data)                      ((0x0000F000&(data))>>12)
+#define HDMI_READ_MARGIN_get_hdcp_ksvfifo_rm(data)                   ((0x00000F00&(data))>>8)
+#define HDMI_READ_MARGIN_get_hdcp_rm(data)                           ((0x000000F0&(data))>>4)
+#define HDMI_READ_MARGIN_get_audio_rm(data)                          (0x0000000F&(data))
+
+
+#define HDMI_BIST_MODE                                               0x17c
+#define HDMI_BIST_MODE_reg_addr                                      "0x9803417c"
+#define HDMI_BIST_MODE_reg                                           0x9803417c
+#define HDMI_BIST_MODE_inst_addr                                     "0x005F"
+#define HDMI_BIST_MODE_inst                                          0x005F
+#define HDMI_BIST_MODE_yuv420_bist_en_shift                          (4)
+#define HDMI_BIST_MODE_hdcp_2p2_bist_en_shift                        (3)
+#define HDMI_BIST_MODE_hdcp_ksvfifo_bist_en_shift                    (2)
+#define HDMI_BIST_MODE_hdcp_bist_en_shift                            (1)
+#define HDMI_BIST_MODE_audio_bist_en_shift                           (0)
+#define HDMI_BIST_MODE_yuv420_bist_en_mask                           (0x00000010)
+#define HDMI_BIST_MODE_hdcp_2p2_bist_en_mask                         (0x00000008)
+#define HDMI_BIST_MODE_hdcp_ksvfifo_bist_en_mask                     (0x00000004)
+#define HDMI_BIST_MODE_hdcp_bist_en_mask                             (0x00000002)
+#define HDMI_BIST_MODE_audio_bist_en_mask                            (0x00000001)
+#define HDMI_BIST_MODE_yuv420_bist_en(data)                          (0x00000010&((data)<<4))
+#define HDMI_BIST_MODE_hdcp_2p2_bist_en(data)                        (0x00000008&((data)<<3))
+#define HDMI_BIST_MODE_hdcp_ksvfifo_bist_en(data)                    (0x00000004&((data)<<2))
+#define HDMI_BIST_MODE_hdcp_bist_en(data)                            (0x00000002&((data)<<1))
+#define HDMI_BIST_MODE_audio_bist_en(data)                           (0x00000001&(data))
+#define HDMI_BIST_MODE_get_yuv420_bist_en(data)                      ((0x00000010&(data))>>4)
+#define HDMI_BIST_MODE_get_hdcp_2p2_bist_en(data)                    ((0x00000008&(data))>>3)
+#define HDMI_BIST_MODE_get_hdcp_ksvfifo_bist_en(data)                ((0x00000004&(data))>>2)
+#define HDMI_BIST_MODE_get_hdcp_bist_en(data)                        ((0x00000002&(data))>>1)
+#define HDMI_BIST_MODE_get_audio_bist_en(data)                       (0x00000001&(data))
+
+
+#define HDMI_BIST_DONE                                               0x180
+#define HDMI_BIST_DONE_reg_addr                                      "0x98034180"
+#define HDMI_BIST_DONE_reg                                           0x98034180
+#define HDMI_BIST_DONE_inst_addr                                     "0x0060"
+#define HDMI_BIST_DONE_inst                                          0x0060
+#define HDMI_BIST_DONE_yuv420_bist_done_shift                        (4)
+#define HDMI_BIST_DONE_hdcp_2p2_bist_done_shift                      (3)
+#define HDMI_BIST_DONE_hdcp_ksvfifo_bist_done_shift                  (2)
+#define HDMI_BIST_DONE_hdcp_bist_done_shift                          (1)
+#define HDMI_BIST_DONE_audio_bist_done_shift                         (0)
+#define HDMI_BIST_DONE_yuv420_bist_done_mask                         (0x00000010)
+#define HDMI_BIST_DONE_hdcp_2p2_bist_done_mask                       (0x00000008)
+#define HDMI_BIST_DONE_hdcp_ksvfifo_bist_done_mask                   (0x00000004)
+#define HDMI_BIST_DONE_hdcp_bist_done_mask                           (0x00000002)
+#define HDMI_BIST_DONE_audio_bist_done_mask                          (0x00000001)
+#define HDMI_BIST_DONE_yuv420_bist_done(data)                        (0x00000010&((data)<<4))
+#define HDMI_BIST_DONE_hdcp_2p2_bist_done(data)                      (0x00000008&((data)<<3))
+#define HDMI_BIST_DONE_hdcp_ksvfifo_bist_done(data)                  (0x00000004&((data)<<2))
+#define HDMI_BIST_DONE_hdcp_bist_done(data)                          (0x00000002&((data)<<1))
+#define HDMI_BIST_DONE_audio_bist_done(data)                         (0x00000001&(data))
+#define HDMI_BIST_DONE_get_yuv420_bist_done(data)                    ((0x00000010&(data))>>4)
+#define HDMI_BIST_DONE_get_hdcp_2p2_bist_done(data)                  ((0x00000008&(data))>>3)
+#define HDMI_BIST_DONE_get_hdcp_ksvfifo_bist_done(data)              ((0x00000004&(data))>>2)
+#define HDMI_BIST_DONE_get_hdcp_bist_done(data)                      ((0x00000002&(data))>>1)
+#define HDMI_BIST_DONE_get_audio_bist_done(data)                     (0x00000001&(data))
+
+
+#define HDMI_BIST_FAIL                                               0x184
+#define HDMI_BIST_FAIL_reg_addr                                      "0x98034184"
+#define HDMI_BIST_FAIL_reg                                           0x98034184
+#define HDMI_BIST_FAIL_inst_addr                                     "0x0061"
+#define HDMI_BIST_FAIL_inst                                          0x0061
+#define HDMI_BIST_FAIL_yuv420_bist_fail_shift                        (4)
+#define HDMI_BIST_FAIL_hdcp_2p2_bist_fail_shift                      (3)
+#define HDMI_BIST_FAIL_hdcp_ksvfifo_bist_fail_shift                  (2)
+#define HDMI_BIST_FAIL_hdcp_bist_fail_shift                          (1)
+#define HDMI_BIST_FAIL_audio_bist_fail_shift                         (0)
+#define HDMI_BIST_FAIL_yuv420_bist_fail_mask                         (0x00000010)
+#define HDMI_BIST_FAIL_hdcp_2p2_bist_fail_mask                       (0x00000008)
+#define HDMI_BIST_FAIL_hdcp_ksvfifo_bist_fail_mask                   (0x00000004)
+#define HDMI_BIST_FAIL_hdcp_bist_fail_mask                           (0x00000002)
+#define HDMI_BIST_FAIL_audio_bist_fail_mask                          (0x00000001)
+#define HDMI_BIST_FAIL_yuv420_bist_fail(data)                        (0x00000010&((data)<<4))
+#define HDMI_BIST_FAIL_hdcp_2p2_bist_fail(data)                      (0x00000008&((data)<<3))
+#define HDMI_BIST_FAIL_hdcp_ksvfifo_bist_fail(data)                  (0x00000004&((data)<<2))
+#define HDMI_BIST_FAIL_hdcp_bist_fail(data)                          (0x00000002&((data)<<1))
+#define HDMI_BIST_FAIL_audio_bist_fail(data)                         (0x00000001&(data))
+#define HDMI_BIST_FAIL_get_yuv420_bist_fail(data)                    ((0x00000010&(data))>>4)
+#define HDMI_BIST_FAIL_get_hdcp_2p2_bist_fail(data)                  ((0x00000008&(data))>>3)
+#define HDMI_BIST_FAIL_get_hdcp_ksvfifo_bist_fail(data)              ((0x00000004&(data))>>2)
+#define HDMI_BIST_FAIL_get_hdcp_bist_fail(data)                      ((0x00000002&(data))>>1)
+#define HDMI_BIST_FAIL_get_audio_bist_fail(data)                     (0x00000001&(data))
+
+
+#define HDMI_DRF_MODE                                                0x188
+#define HDMI_DRF_MODE_reg_addr                                       "0x98034188"
+#define HDMI_DRF_MODE_reg                                            0x98034188
+#define HDMI_DRF_MODE_inst_addr                                      "0x0062"
+#define HDMI_DRF_MODE_inst                                           0x0062
+#define HDMI_DRF_MODE_yuv420_drf_mode_shift                          (4)
+#define HDMI_DRF_MODE_hdcp_2p2_drf_mode_shift                        (3)
+#define HDMI_DRF_MODE_hdcp_ksvfifo_drf_mode_shift                    (2)
+#define HDMI_DRF_MODE_hdcp_drf_mode_shift                            (1)
+#define HDMI_DRF_MODE_audio_drf_mode_shift                           (0)
+#define HDMI_DRF_MODE_yuv420_drf_mode_mask                           (0x00000010)
+#define HDMI_DRF_MODE_hdcp_2p2_drf_mode_mask                         (0x00000008)
+#define HDMI_DRF_MODE_hdcp_ksvfifo_drf_mode_mask                     (0x00000004)
+#define HDMI_DRF_MODE_hdcp_drf_mode_mask                             (0x00000002)
+#define HDMI_DRF_MODE_audio_drf_mode_mask                            (0x00000001)
+#define HDMI_DRF_MODE_yuv420_drf_mode(data)                          (0x00000010&((data)<<4))
+#define HDMI_DRF_MODE_hdcp_2p2_drf_mode(data)                        (0x00000008&((data)<<3))
+#define HDMI_DRF_MODE_hdcp_ksvfifo_drf_mode(data)                    (0x00000004&((data)<<2))
+#define HDMI_DRF_MODE_hdcp_drf_mode(data)                            (0x00000002&((data)<<1))
+#define HDMI_DRF_MODE_audio_drf_mode(data)                           (0x00000001&(data))
+#define HDMI_DRF_MODE_get_yuv420_drf_mode(data)                      ((0x00000010&(data))>>4)
+#define HDMI_DRF_MODE_get_hdcp_2p2_drf_mode(data)                    ((0x00000008&(data))>>3)
+#define HDMI_DRF_MODE_get_hdcp_ksvfifo_drf_mode(data)                ((0x00000004&(data))>>2)
+#define HDMI_DRF_MODE_get_hdcp_drf_mode(data)                        ((0x00000002&(data))>>1)
+#define HDMI_DRF_MODE_get_audio_drf_mode(data)                       (0x00000001&(data))
+
+
+#define HDMI_DRF_RESUME                                              0x18c
+#define HDMI_DRF_RESUME_reg_addr                                     "0x9803418c"
+#define HDMI_DRF_RESUME_reg                                          0x9803418c
+#define HDMI_DRF_RESUME_inst_addr                                    "0x0063"
+#define HDMI_DRF_RESUME_inst                                         0x0063
+#define HDMI_DRF_RESUME_yuv420_drf_resume_shift                      (4)
+#define HDMI_DRF_RESUME_hdcp_2p2_drf_resume_shift                    (3)
+#define HDMI_DRF_RESUME_hdcp_ksvfifo_drf_resume_shift                (2)
+#define HDMI_DRF_RESUME_hdcp_drf_resume_shift                        (1)
+#define HDMI_DRF_RESUME_audio_drf_resume_shift                       (0)
+#define HDMI_DRF_RESUME_yuv420_drf_resume_mask                       (0x00000010)
+#define HDMI_DRF_RESUME_hdcp_2p2_drf_resume_mask                     (0x00000008)
+#define HDMI_DRF_RESUME_hdcp_ksvfifo_drf_resume_mask                 (0x00000004)
+#define HDMI_DRF_RESUME_hdcp_drf_resume_mask                         (0x00000002)
+#define HDMI_DRF_RESUME_audio_drf_resume_mask                        (0x00000001)
+#define HDMI_DRF_RESUME_yuv420_drf_resume(data)                      (0x00000010&((data)<<4))
+#define HDMI_DRF_RESUME_hdcp_2p2_drf_resume(data)                    (0x00000008&((data)<<3))
+#define HDMI_DRF_RESUME_hdcp_ksvfifo_drf_resume(data)                (0x00000004&((data)<<2))
+#define HDMI_DRF_RESUME_hdcp_drf_resume(data)                        (0x00000002&((data)<<1))
+#define HDMI_DRF_RESUME_audio_drf_resume(data)                       (0x00000001&(data))
+#define HDMI_DRF_RESUME_get_yuv420_drf_resume(data)                  ((0x00000010&(data))>>4)
+#define HDMI_DRF_RESUME_get_hdcp_2p2_drf_resume(data)                ((0x00000008&(data))>>3)
+#define HDMI_DRF_RESUME_get_hdcp_ksvfifo_drf_resume(data)            ((0x00000004&(data))>>2)
+#define HDMI_DRF_RESUME_get_hdcp_drf_resume(data)                    ((0x00000002&(data))>>1)
+#define HDMI_DRF_RESUME_get_audio_drf_resume(data)                   (0x00000001&(data))
+
+
+#define HDMI_DRF_DONE                                                0x190
+#define HDMI_DRF_DONE_reg_addr                                       "0x98034190"
+#define HDMI_DRF_DONE_reg                                            0x98034190
+#define HDMI_DRF_DONE_inst_addr                                      "0x0064"
+#define HDMI_DRF_DONE_inst                                           0x0064
+#define HDMI_DRF_DONE_yuv420_drf_done_shift                          (4)
+#define HDMI_DRF_DONE_hdcp_2p2_drf_done_shift                        (3)
+#define HDMI_DRF_DONE_hdcp_ksvfifo_drf_done_shift                    (2)
+#define HDMI_DRF_DONE_hdcp_drf_done_shift                            (1)
+#define HDMI_DRF_DONE_audio_drf_done_shift                           (0)
+#define HDMI_DRF_DONE_yuv420_drf_done_mask                           (0x00000010)
+#define HDMI_DRF_DONE_hdcp_2p2_drf_done_mask                         (0x00000008)
+#define HDMI_DRF_DONE_hdcp_ksvfifo_drf_done_mask                     (0x00000004)
+#define HDMI_DRF_DONE_hdcp_drf_done_mask                             (0x00000002)
+#define HDMI_DRF_DONE_audio_drf_done_mask                            (0x00000001)
+#define HDMI_DRF_DONE_yuv420_drf_done(data)                          (0x00000010&((data)<<4))
+#define HDMI_DRF_DONE_hdcp_2p2_drf_done(data)                        (0x00000008&((data)<<3))
+#define HDMI_DRF_DONE_hdcp_ksvfifo_drf_done(data)                    (0x00000004&((data)<<2))
+#define HDMI_DRF_DONE_hdcp_drf_done(data)                            (0x00000002&((data)<<1))
+#define HDMI_DRF_DONE_audio_drf_done(data)                           (0x00000001&(data))
+#define HDMI_DRF_DONE_get_yuv420_drf_done(data)                      ((0x00000010&(data))>>4)
+#define HDMI_DRF_DONE_get_hdcp_2p2_drf_done(data)                    ((0x00000008&(data))>>3)
+#define HDMI_DRF_DONE_get_hdcp_ksvfifo_drf_done(data)                ((0x00000004&(data))>>2)
+#define HDMI_DRF_DONE_get_hdcp_drf_done(data)                        ((0x00000002&(data))>>1)
+#define HDMI_DRF_DONE_get_audio_drf_done(data)                       (0x00000001&(data))
+
+
+#define HDMI_DRF_PAUSE                                               0x194
+#define HDMI_DRF_PAUSE_reg_addr                                      "0x98034194"
+#define HDMI_DRF_PAUSE_reg                                           0x98034194
+#define HDMI_DRF_PAUSE_inst_addr                                     "0x0065"
+#define HDMI_DRF_PAUSE_inst                                          0x0065
+#define HDMI_DRF_PAUSE_yuv420_drf_pause_shift                        (4)
+#define HDMI_DRF_PAUSE_hdcp_2p2_drf_pause_shift                      (3)
+#define HDMI_DRF_PAUSE_hdcp_ksvfifo_drf_pause_shift                  (2)
+#define HDMI_DRF_PAUSE_hdcp_drf_pause_shift                          (1)
+#define HDMI_DRF_PAUSE_audio_drf_pause_shift                         (0)
+#define HDMI_DRF_PAUSE_yuv420_drf_pause_mask                         (0x00000010)
+#define HDMI_DRF_PAUSE_hdcp_2p2_drf_pause_mask                       (0x00000008)
+#define HDMI_DRF_PAUSE_hdcp_ksvfifo_drf_pause_mask                   (0x00000004)
+#define HDMI_DRF_PAUSE_hdcp_drf_pause_mask                           (0x00000002)
+#define HDMI_DRF_PAUSE_audio_drf_pause_mask                          (0x00000001)
+#define HDMI_DRF_PAUSE_yuv420_drf_pause(data)                        (0x00000010&((data)<<4))
+#define HDMI_DRF_PAUSE_hdcp_2p2_drf_pause(data)                      (0x00000008&((data)<<3))
+#define HDMI_DRF_PAUSE_hdcp_ksvfifo_drf_pause(data)                  (0x00000004&((data)<<2))
+#define HDMI_DRF_PAUSE_hdcp_drf_pause(data)                          (0x00000002&((data)<<1))
+#define HDMI_DRF_PAUSE_audio_drf_pause(data)                         (0x00000001&(data))
+#define HDMI_DRF_PAUSE_get_yuv420_drf_pause(data)                    ((0x00000010&(data))>>4)
+#define HDMI_DRF_PAUSE_get_hdcp_2p2_drf_pause(data)                  ((0x00000008&(data))>>3)
+#define HDMI_DRF_PAUSE_get_hdcp_ksvfifo_drf_pause(data)              ((0x00000004&(data))>>2)
+#define HDMI_DRF_PAUSE_get_hdcp_drf_pause(data)                      ((0x00000002&(data))>>1)
+#define HDMI_DRF_PAUSE_get_audio_drf_pause(data)                     (0x00000001&(data))
+
+
+#define HDMI_DRF_FAIL                                                0x198
+#define HDMI_DRF_FAIL_reg_addr                                       "0x98034198"
+#define HDMI_DRF_FAIL_reg                                            0x98034198
+#define HDMI_DRF_FAIL_inst_addr                                      "0x0066"
+#define HDMI_DRF_FAIL_inst                                           0x0066
+#define HDMI_DRF_FAIL_yuv420_drf_fail_shift                          (4)
+#define HDMI_DRF_FAIL_hdcp_2p2_drf_fail_shift                        (3)
+#define HDMI_DRF_FAIL_hdcp_ksvfifo_drf_fail_shift                    (2)
+#define HDMI_DRF_FAIL_hdcp_drf_fail_shift                            (1)
+#define HDMI_DRF_FAIL_audio_drf_fail_shift                           (0)
+#define HDMI_DRF_FAIL_yuv420_drf_fail_mask                           (0x00000010)
+#define HDMI_DRF_FAIL_hdcp_2p2_drf_fail_mask                         (0x00000008)
+#define HDMI_DRF_FAIL_hdcp_ksvfifo_drf_fail_mask                     (0x00000004)
+#define HDMI_DRF_FAIL_hdcp_drf_fail_mask                             (0x00000002)
+#define HDMI_DRF_FAIL_audio_drf_fail_mask                            (0x00000001)
+#define HDMI_DRF_FAIL_yuv420_drf_fail(data)                          (0x00000010&((data)<<4))
+#define HDMI_DRF_FAIL_hdcp_2p2_drf_fail(data)                        (0x00000008&((data)<<3))
+#define HDMI_DRF_FAIL_hdcp_ksvfifo_drf_fail(data)                    (0x00000004&((data)<<2))
+#define HDMI_DRF_FAIL_hdcp_drf_fail(data)                            (0x00000002&((data)<<1))
+#define HDMI_DRF_FAIL_audio_drf_fail(data)                           (0x00000001&(data))
+#define HDMI_DRF_FAIL_get_yuv420_drf_fail(data)                      ((0x00000010&(data))>>4)
+#define HDMI_DRF_FAIL_get_hdcp_2p2_drf_fail(data)                    ((0x00000008&(data))>>3)
+#define HDMI_DRF_FAIL_get_hdcp_ksvfifo_drf_fail(data)                ((0x00000004&(data))>>2)
+#define HDMI_DRF_FAIL_get_hdcp_drf_fail(data)                        ((0x00000002&(data))>>1)
+#define HDMI_DRF_FAIL_get_audio_drf_fail(data)                       (0x00000001&(data))
+
+
+#define HDMI_PHY_FIFO_CR0                                            0x19c
+#define HDMI_PHY_FIFO_CR0_reg_addr                                   "0x9803419c"
+#define HDMI_PHY_FIFO_CR0_reg                                        0x9803419c
+#define HDMI_PHY_FIFO_CR0_inst_addr                                  "0x0067"
+#define HDMI_PHY_FIFO_CR0_inst                                       0x0067
+#define HDMI_PHY_FIFO_CR0_port3_r_flush_shift                        (26)
+#define HDMI_PHY_FIFO_CR0_port3_r_afifo_en_shift                     (25)
+#define HDMI_PHY_FIFO_CR0_port3_g_flush_shift                        (24)
+#define HDMI_PHY_FIFO_CR0_port3_g_afifo_en_shift                     (23)
+#define HDMI_PHY_FIFO_CR0_port3_b_flush_shift                        (22)
+#define HDMI_PHY_FIFO_CR0_port3_b_afifo_en_shift                     (21)
+#define HDMI_PHY_FIFO_CR0_dummy9803419c_20_shift                     (20)
+#define HDMI_PHY_FIFO_CR0_port2_r_flush_shift                        (19)
+#define HDMI_PHY_FIFO_CR0_port2_r_afifo_en_shift                     (18)
+#define HDMI_PHY_FIFO_CR0_port2_g_flush_shift                        (17)
+#define HDMI_PHY_FIFO_CR0_port2_g_afifo_en_shift                     (16)
+#define HDMI_PHY_FIFO_CR0_port2_b_flush_shift                        (15)
+#define HDMI_PHY_FIFO_CR0_port2_b_afifo_en_shift                     (14)
+#define HDMI_PHY_FIFO_CR0_dummy9803419c_13_shift                     (13)
+#define HDMI_PHY_FIFO_CR0_port1_r_flush_shift                        (12)
+#define HDMI_PHY_FIFO_CR0_port1_r_afifo_en_shift                     (11)
+#define HDMI_PHY_FIFO_CR0_port1_g_flush_shift                        (10)
+#define HDMI_PHY_FIFO_CR0_port1_g_afifo_en_shift                     (9)
+#define HDMI_PHY_FIFO_CR0_port1_b_flush_shift                        (8)
+#define HDMI_PHY_FIFO_CR0_port1_b_afifo_en_shift                     (7)
+#define HDMI_PHY_FIFO_CR0_dummy9803419c_6_shift                      (6)
+#define HDMI_PHY_FIFO_CR0_port0_r_flush_shift                        (5)
+#define HDMI_PHY_FIFO_CR0_port0_r_afifo_en_shift                     (4)
+#define HDMI_PHY_FIFO_CR0_port0_g_flush_shift                        (3)
+#define HDMI_PHY_FIFO_CR0_port0_g_afifo_en_shift                     (2)
+#define HDMI_PHY_FIFO_CR0_port0_b_flush_shift                        (1)
+#define HDMI_PHY_FIFO_CR0_port0_b_afifo_en_shift                     (0)
+#define HDMI_PHY_FIFO_CR0_port3_r_flush_mask                         (0x04000000)
+#define HDMI_PHY_FIFO_CR0_port3_r_afifo_en_mask                      (0x02000000)
+#define HDMI_PHY_FIFO_CR0_port3_g_flush_mask                         (0x01000000)
+#define HDMI_PHY_FIFO_CR0_port3_g_afifo_en_mask                      (0x00800000)
+#define HDMI_PHY_FIFO_CR0_port3_b_flush_mask                         (0x00400000)
+#define HDMI_PHY_FIFO_CR0_port3_b_afifo_en_mask                      (0x00200000)
+#define HDMI_PHY_FIFO_CR0_dummy9803419c_20_mask                      (0x00100000)
+#define HDMI_PHY_FIFO_CR0_port2_r_flush_mask                         (0x00080000)
+#define HDMI_PHY_FIFO_CR0_port2_r_afifo_en_mask                      (0x00040000)
+#define HDMI_PHY_FIFO_CR0_port2_g_flush_mask                         (0x00020000)
+#define HDMI_PHY_FIFO_CR0_port2_g_afifo_en_mask                      (0x00010000)
+#define HDMI_PHY_FIFO_CR0_port2_b_flush_mask                         (0x00008000)
+#define HDMI_PHY_FIFO_CR0_port2_b_afifo_en_mask                      (0x00004000)
+#define HDMI_PHY_FIFO_CR0_dummy9803419c_13_mask                      (0x00002000)
+#define HDMI_PHY_FIFO_CR0_port1_r_flush_mask                         (0x00001000)
+#define HDMI_PHY_FIFO_CR0_port1_r_afifo_en_mask                      (0x00000800)
+#define HDMI_PHY_FIFO_CR0_port1_g_flush_mask                         (0x00000400)
+#define HDMI_PHY_FIFO_CR0_port1_g_afifo_en_mask                      (0x00000200)
+#define HDMI_PHY_FIFO_CR0_port1_b_flush_mask                         (0x00000100)
+#define HDMI_PHY_FIFO_CR0_port1_b_afifo_en_mask                      (0x00000080)
+#define HDMI_PHY_FIFO_CR0_dummy9803419c_6_mask                       (0x00000040)
+#define HDMI_PHY_FIFO_CR0_port0_r_flush_mask                         (0x00000020)
+#define HDMI_PHY_FIFO_CR0_port0_r_afifo_en_mask                      (0x00000010)
+#define HDMI_PHY_FIFO_CR0_port0_g_flush_mask                         (0x00000008)
+#define HDMI_PHY_FIFO_CR0_port0_g_afifo_en_mask                      (0x00000004)
+#define HDMI_PHY_FIFO_CR0_port0_b_flush_mask                         (0x00000002)
+#define HDMI_PHY_FIFO_CR0_port0_b_afifo_en_mask                      (0x00000001)
+#define HDMI_PHY_FIFO_CR0_port3_r_flush(data)                        (0x04000000&((data)<<26))
+#define HDMI_PHY_FIFO_CR0_port3_r_afifo_en(data)                     (0x02000000&((data)<<25))
+#define HDMI_PHY_FIFO_CR0_port3_g_flush(data)                        (0x01000000&((data)<<24))
+#define HDMI_PHY_FIFO_CR0_port3_g_afifo_en(data)                     (0x00800000&((data)<<23))
+#define HDMI_PHY_FIFO_CR0_port3_b_flush(data)                        (0x00400000&((data)<<22))
+#define HDMI_PHY_FIFO_CR0_port3_b_afifo_en(data)                     (0x00200000&((data)<<21))
+#define HDMI_PHY_FIFO_CR0_dummy9803419c_20(data)                     (0x00100000&((data)<<20))
+#define HDMI_PHY_FIFO_CR0_port2_r_flush(data)                        (0x00080000&((data)<<19))
+#define HDMI_PHY_FIFO_CR0_port2_r_afifo_en(data)                     (0x00040000&((data)<<18))
+#define HDMI_PHY_FIFO_CR0_port2_g_flush(data)                        (0x00020000&((data)<<17))
+#define HDMI_PHY_FIFO_CR0_port2_g_afifo_en(data)                     (0x00010000&((data)<<16))
+#define HDMI_PHY_FIFO_CR0_port2_b_flush(data)                        (0x00008000&((data)<<15))
+#define HDMI_PHY_FIFO_CR0_port2_b_afifo_en(data)                     (0x00004000&((data)<<14))
+#define HDMI_PHY_FIFO_CR0_dummy9803419c_13(data)                     (0x00002000&((data)<<13))
+#define HDMI_PHY_FIFO_CR0_port1_r_flush(data)                        (0x00001000&((data)<<12))
+#define HDMI_PHY_FIFO_CR0_port1_r_afifo_en(data)                     (0x00000800&((data)<<11))
+#define HDMI_PHY_FIFO_CR0_port1_g_flush(data)                        (0x00000400&((data)<<10))
+#define HDMI_PHY_FIFO_CR0_port1_g_afifo_en(data)                     (0x00000200&((data)<<9))
+#define HDMI_PHY_FIFO_CR0_port1_b_flush(data)                        (0x00000100&((data)<<8))
+#define HDMI_PHY_FIFO_CR0_port1_b_afifo_en(data)                     (0x00000080&((data)<<7))
+#define HDMI_PHY_FIFO_CR0_dummy9803419c_6(data)                      (0x00000040&((data)<<6))
+#define HDMI_PHY_FIFO_CR0_port0_r_flush(data)                        (0x00000020&((data)<<5))
+#define HDMI_PHY_FIFO_CR0_port0_r_afifo_en(data)                     (0x00000010&((data)<<4))
+#define HDMI_PHY_FIFO_CR0_port0_g_flush(data)                        (0x00000008&((data)<<3))
+#define HDMI_PHY_FIFO_CR0_port0_g_afifo_en(data)                     (0x00000004&((data)<<2))
+#define HDMI_PHY_FIFO_CR0_port0_b_flush(data)                        (0x00000002&((data)<<1))
+#define HDMI_PHY_FIFO_CR0_port0_b_afifo_en(data)                     (0x00000001&(data))
+#define HDMI_PHY_FIFO_CR0_get_port3_r_flush(data)                    ((0x04000000&(data))>>26)
+#define HDMI_PHY_FIFO_CR0_get_port3_r_afifo_en(data)                 ((0x02000000&(data))>>25)
+#define HDMI_PHY_FIFO_CR0_get_port3_g_flush(data)                    ((0x01000000&(data))>>24)
+#define HDMI_PHY_FIFO_CR0_get_port3_g_afifo_en(data)                 ((0x00800000&(data))>>23)
+#define HDMI_PHY_FIFO_CR0_get_port3_b_flush(data)                    ((0x00400000&(data))>>22)
+#define HDMI_PHY_FIFO_CR0_get_port3_b_afifo_en(data)                 ((0x00200000&(data))>>21)
+#define HDMI_PHY_FIFO_CR0_get_dummy9803419c_20(data)                 ((0x00100000&(data))>>20)
+#define HDMI_PHY_FIFO_CR0_get_port2_r_flush(data)                    ((0x00080000&(data))>>19)
+#define HDMI_PHY_FIFO_CR0_get_port2_r_afifo_en(data)                 ((0x00040000&(data))>>18)
+#define HDMI_PHY_FIFO_CR0_get_port2_g_flush(data)                    ((0x00020000&(data))>>17)
+#define HDMI_PHY_FIFO_CR0_get_port2_g_afifo_en(data)                 ((0x00010000&(data))>>16)
+#define HDMI_PHY_FIFO_CR0_get_port2_b_flush(data)                    ((0x00008000&(data))>>15)
+#define HDMI_PHY_FIFO_CR0_get_port2_b_afifo_en(data)                 ((0x00004000&(data))>>14)
+#define HDMI_PHY_FIFO_CR0_get_dummy9803419c_13(data)                 ((0x00002000&(data))>>13)
+#define HDMI_PHY_FIFO_CR0_get_port1_r_flush(data)                    ((0x00001000&(data))>>12)
+#define HDMI_PHY_FIFO_CR0_get_port1_r_afifo_en(data)                 ((0x00000800&(data))>>11)
+#define HDMI_PHY_FIFO_CR0_get_port1_g_flush(data)                    ((0x00000400&(data))>>10)
+#define HDMI_PHY_FIFO_CR0_get_port1_g_afifo_en(data)                 ((0x00000200&(data))>>9)
+#define HDMI_PHY_FIFO_CR0_get_port1_b_flush(data)                    ((0x00000100&(data))>>8)
+#define HDMI_PHY_FIFO_CR0_get_port1_b_afifo_en(data)                 ((0x00000080&(data))>>7)
+#define HDMI_PHY_FIFO_CR0_get_dummy9803419c_6(data)                  ((0x00000040&(data))>>6)
+#define HDMI_PHY_FIFO_CR0_get_port0_r_flush(data)                    ((0x00000020&(data))>>5)
+#define HDMI_PHY_FIFO_CR0_get_port0_r_afifo_en(data)                 ((0x00000010&(data))>>4)
+#define HDMI_PHY_FIFO_CR0_get_port0_g_flush(data)                    ((0x00000008&(data))>>3)
+#define HDMI_PHY_FIFO_CR0_get_port0_g_afifo_en(data)                 ((0x00000004&(data))>>2)
+#define HDMI_PHY_FIFO_CR0_get_port0_b_flush(data)                    ((0x00000002&(data))>>1)
+#define HDMI_PHY_FIFO_CR0_get_port0_b_afifo_en(data)                 (0x00000001&(data))
+
+
+#define HDMI_PHY_FIFO_CR1                                            0x1a0
+#define HDMI_PHY_FIFO_CR1_reg_addr                                   "0x980341a0"
+#define HDMI_PHY_FIFO_CR1_reg                                        0x980341a0
+#define HDMI_PHY_FIFO_CR1_inst_addr                                  "0x0068"
+#define HDMI_PHY_FIFO_CR1_inst                                       0x0068
+#define HDMI_PHY_FIFO_CR1_port3_rclk_inv_shift                       (11)
+#define HDMI_PHY_FIFO_CR1_port3_gclk_inv_shift                       (10)
+#define HDMI_PHY_FIFO_CR1_port3_bclk_inv_shift                       (9)
+#define HDMI_PHY_FIFO_CR1_port2_rclk_inv_shift                       (8)
+#define HDMI_PHY_FIFO_CR1_port2_gclk_inv_shift                       (7)
+#define HDMI_PHY_FIFO_CR1_port2_bclk_inv_shift                       (6)
+#define HDMI_PHY_FIFO_CR1_port1_rclk_inv_shift                       (5)
+#define HDMI_PHY_FIFO_CR1_port1_gclk_inv_shift                       (4)
+#define HDMI_PHY_FIFO_CR1_port1_bclk_inv_shift                       (3)
+#define HDMI_PHY_FIFO_CR1_port0_rclk_inv_shift                       (2)
+#define HDMI_PHY_FIFO_CR1_port0_gclk_inv_shift                       (1)
+#define HDMI_PHY_FIFO_CR1_port0_bclk_inv_shift                       (0)
+#define HDMI_PHY_FIFO_CR1_port3_rclk_inv_mask                        (0x00000800)
+#define HDMI_PHY_FIFO_CR1_port3_gclk_inv_mask                        (0x00000400)
+#define HDMI_PHY_FIFO_CR1_port3_bclk_inv_mask                        (0x00000200)
+#define HDMI_PHY_FIFO_CR1_port2_rclk_inv_mask                        (0x00000100)
+#define HDMI_PHY_FIFO_CR1_port2_gclk_inv_mask                        (0x00000080)
+#define HDMI_PHY_FIFO_CR1_port2_bclk_inv_mask                        (0x00000040)
+#define HDMI_PHY_FIFO_CR1_port1_rclk_inv_mask                        (0x00000020)
+#define HDMI_PHY_FIFO_CR1_port1_gclk_inv_mask                        (0x00000010)
+#define HDMI_PHY_FIFO_CR1_port1_bclk_inv_mask                        (0x00000008)
+#define HDMI_PHY_FIFO_CR1_port0_rclk_inv_mask                        (0x00000004)
+#define HDMI_PHY_FIFO_CR1_port0_gclk_inv_mask                        (0x00000002)
+#define HDMI_PHY_FIFO_CR1_port0_bclk_inv_mask                        (0x00000001)
+#define HDMI_PHY_FIFO_CR1_port3_rclk_inv(data)                       (0x00000800&((data)<<11))
+#define HDMI_PHY_FIFO_CR1_port3_gclk_inv(data)                       (0x00000400&((data)<<10))
+#define HDMI_PHY_FIFO_CR1_port3_bclk_inv(data)                       (0x00000200&((data)<<9))
+#define HDMI_PHY_FIFO_CR1_port2_rclk_inv(data)                       (0x00000100&((data)<<8))
+#define HDMI_PHY_FIFO_CR1_port2_gclk_inv(data)                       (0x00000080&((data)<<7))
+#define HDMI_PHY_FIFO_CR1_port2_bclk_inv(data)                       (0x00000040&((data)<<6))
+#define HDMI_PHY_FIFO_CR1_port1_rclk_inv(data)                       (0x00000020&((data)<<5))
+#define HDMI_PHY_FIFO_CR1_port1_gclk_inv(data)                       (0x00000010&((data)<<4))
+#define HDMI_PHY_FIFO_CR1_port1_bclk_inv(data)                       (0x00000008&((data)<<3))
+#define HDMI_PHY_FIFO_CR1_port0_rclk_inv(data)                       (0x00000004&((data)<<2))
+#define HDMI_PHY_FIFO_CR1_port0_gclk_inv(data)                       (0x00000002&((data)<<1))
+#define HDMI_PHY_FIFO_CR1_port0_bclk_inv(data)                       (0x00000001&(data))
+#define HDMI_PHY_FIFO_CR1_get_port3_rclk_inv(data)                   ((0x00000800&(data))>>11)
+#define HDMI_PHY_FIFO_CR1_get_port3_gclk_inv(data)                   ((0x00000400&(data))>>10)
+#define HDMI_PHY_FIFO_CR1_get_port3_bclk_inv(data)                   ((0x00000200&(data))>>9)
+#define HDMI_PHY_FIFO_CR1_get_port2_rclk_inv(data)                   ((0x00000100&(data))>>8)
+#define HDMI_PHY_FIFO_CR1_get_port2_gclk_inv(data)                   ((0x00000080&(data))>>7)
+#define HDMI_PHY_FIFO_CR1_get_port2_bclk_inv(data)                   ((0x00000040&(data))>>6)
+#define HDMI_PHY_FIFO_CR1_get_port1_rclk_inv(data)                   ((0x00000020&(data))>>5)
+#define HDMI_PHY_FIFO_CR1_get_port1_gclk_inv(data)                   ((0x00000010&(data))>>4)
+#define HDMI_PHY_FIFO_CR1_get_port1_bclk_inv(data)                   ((0x00000008&(data))>>3)
+#define HDMI_PHY_FIFO_CR1_get_port0_rclk_inv(data)                   ((0x00000004&(data))>>2)
+#define HDMI_PHY_FIFO_CR1_get_port0_gclk_inv(data)                   ((0x00000002&(data))>>1)
+#define HDMI_PHY_FIFO_CR1_get_port0_bclk_inv(data)                   (0x00000001&(data))
+
+
+#define HDMI_PHY_FIFO_SR0                                            0x1a4
+#define HDMI_PHY_FIFO_SR0_reg_addr                                   "0x980341a4"
+#define HDMI_PHY_FIFO_SR0_reg                                        0x980341a4
+#define HDMI_PHY_FIFO_SR0_inst_addr                                  "0x0069"
+#define HDMI_PHY_FIFO_SR0_inst                                       0x0069
+#define HDMI_PHY_FIFO_SR0_port1_r_wrclk_det_timeout_flag_shift       (29)
+#define HDMI_PHY_FIFO_SR0_port1_r_rwclk_det_timeout_flag_shift       (28)
+#define HDMI_PHY_FIFO_SR0_port1_r_wovflow_flag_shift                 (27)
+#define HDMI_PHY_FIFO_SR0_port1_r_rudflow_flag_shift                 (26)
+#define HDMI_PHY_FIFO_SR0_port1_r_rflush_flag_shift                  (25)
+#define HDMI_PHY_FIFO_SR0_port1_g_wrclk_det_timeout_flag_shift       (24)
+#define HDMI_PHY_FIFO_SR0_port1_g_rwclk_det_timeout_flag_shift       (23)
+#define HDMI_PHY_FIFO_SR0_port1_g_wovflow_flag_shift                 (22)
+#define HDMI_PHY_FIFO_SR0_port1_g_rudflow_flag_shift                 (21)
+#define HDMI_PHY_FIFO_SR0_port1_g_rflush_flag_shift                  (20)
+#define HDMI_PHY_FIFO_SR0_port1_b_wrclk_det_timeout_flag_shift       (19)
+#define HDMI_PHY_FIFO_SR0_port1_b_rwclk_det_timeout_flag_shift       (18)
+#define HDMI_PHY_FIFO_SR0_port1_b_wovflow_flag_shift                 (17)
+#define HDMI_PHY_FIFO_SR0_port1_b_rudflow_flag_shift                 (16)
+#define HDMI_PHY_FIFO_SR0_port1_b_rflush_flag_shift                  (15)
+#define HDMI_PHY_FIFO_SR0_port0_r_wrclk_det_timeout_flag_shift       (14)
+#define HDMI_PHY_FIFO_SR0_port0_r_rwclk_det_timeout_flag_shift       (13)
+#define HDMI_PHY_FIFO_SR0_port0_r_wovflow_flag_shift                 (12)
+#define HDMI_PHY_FIFO_SR0_port0_r_rudflow_flag_shift                 (11)
+#define HDMI_PHY_FIFO_SR0_port0_r_rflush_flag_shift                  (10)
+#define HDMI_PHY_FIFO_SR0_port0_g_wrclk_det_timeout_flag_shift       (9)
+#define HDMI_PHY_FIFO_SR0_port0_g_rwclk_det_timeout_flag_shift       (8)
+#define HDMI_PHY_FIFO_SR0_port0_g_wovflow_flag_shift                 (7)
+#define HDMI_PHY_FIFO_SR0_port0_g_rudflow_flag_shift                 (6)
+#define HDMI_PHY_FIFO_SR0_port0_g_rflush_flag_shift                  (5)
+#define HDMI_PHY_FIFO_SR0_port0_b_wrclk_det_timeout_flag_shift       (4)
+#define HDMI_PHY_FIFO_SR0_port0_b_rwclk_det_timeout_flag_shift       (3)
+#define HDMI_PHY_FIFO_SR0_port0_b_wovflow_flag_shift                 (2)
+#define HDMI_PHY_FIFO_SR0_port0_b_rudflow_flag_shift                 (1)
+#define HDMI_PHY_FIFO_SR0_port0_b_rflush_flag_shift                  (0)
+#define HDMI_PHY_FIFO_SR0_port1_r_wrclk_det_timeout_flag_mask        (0x20000000)
+#define HDMI_PHY_FIFO_SR0_port1_r_rwclk_det_timeout_flag_mask        (0x10000000)
+#define HDMI_PHY_FIFO_SR0_port1_r_wovflow_flag_mask                  (0x08000000)
+#define HDMI_PHY_FIFO_SR0_port1_r_rudflow_flag_mask                  (0x04000000)
+#define HDMI_PHY_FIFO_SR0_port1_r_rflush_flag_mask                   (0x02000000)
+#define HDMI_PHY_FIFO_SR0_port1_g_wrclk_det_timeout_flag_mask        (0x01000000)
+#define HDMI_PHY_FIFO_SR0_port1_g_rwclk_det_timeout_flag_mask        (0x00800000)
+#define HDMI_PHY_FIFO_SR0_port1_g_wovflow_flag_mask                  (0x00400000)
+#define HDMI_PHY_FIFO_SR0_port1_g_rudflow_flag_mask                  (0x00200000)
+#define HDMI_PHY_FIFO_SR0_port1_g_rflush_flag_mask                   (0x00100000)
+#define HDMI_PHY_FIFO_SR0_port1_b_wrclk_det_timeout_flag_mask        (0x00080000)
+#define HDMI_PHY_FIFO_SR0_port1_b_rwclk_det_timeout_flag_mask        (0x00040000)
+#define HDMI_PHY_FIFO_SR0_port1_b_wovflow_flag_mask                  (0x00020000)
+#define HDMI_PHY_FIFO_SR0_port1_b_rudflow_flag_mask                  (0x00010000)
+#define HDMI_PHY_FIFO_SR0_port1_b_rflush_flag_mask                   (0x00008000)
+#define HDMI_PHY_FIFO_SR0_port0_r_wrclk_det_timeout_flag_mask        (0x00004000)
+#define HDMI_PHY_FIFO_SR0_port0_r_rwclk_det_timeout_flag_mask        (0x00002000)
+#define HDMI_PHY_FIFO_SR0_port0_r_wovflow_flag_mask                  (0x00001000)
+#define HDMI_PHY_FIFO_SR0_port0_r_rudflow_flag_mask                  (0x00000800)
+#define HDMI_PHY_FIFO_SR0_port0_r_rflush_flag_mask                   (0x00000400)
+#define HDMI_PHY_FIFO_SR0_port0_g_wrclk_det_timeout_flag_mask        (0x00000200)
+#define HDMI_PHY_FIFO_SR0_port0_g_rwclk_det_timeout_flag_mask        (0x00000100)
+#define HDMI_PHY_FIFO_SR0_port0_g_wovflow_flag_mask                  (0x00000080)
+#define HDMI_PHY_FIFO_SR0_port0_g_rudflow_flag_mask                  (0x00000040)
+#define HDMI_PHY_FIFO_SR0_port0_g_rflush_flag_mask                   (0x00000020)
+#define HDMI_PHY_FIFO_SR0_port0_b_wrclk_det_timeout_flag_mask        (0x00000010)
+#define HDMI_PHY_FIFO_SR0_port0_b_rwclk_det_timeout_flag_mask        (0x00000008)
+#define HDMI_PHY_FIFO_SR0_port0_b_wovflow_flag_mask                  (0x00000004)
+#define HDMI_PHY_FIFO_SR0_port0_b_rudflow_flag_mask                  (0x00000002)
+#define HDMI_PHY_FIFO_SR0_port0_b_rflush_flag_mask                   (0x00000001)
+#define HDMI_PHY_FIFO_SR0_port1_r_wrclk_det_timeout_flag(data)       (0x20000000&((data)<<29))
+#define HDMI_PHY_FIFO_SR0_port1_r_rwclk_det_timeout_flag(data)       (0x10000000&((data)<<28))
+#define HDMI_PHY_FIFO_SR0_port1_r_wovflow_flag(data)                 (0x08000000&((data)<<27))
+#define HDMI_PHY_FIFO_SR0_port1_r_rudflow_flag(data)                 (0x04000000&((data)<<26))
+#define HDMI_PHY_FIFO_SR0_port1_r_rflush_flag(data)                  (0x02000000&((data)<<25))
+#define HDMI_PHY_FIFO_SR0_port1_g_wrclk_det_timeout_flag(data)       (0x01000000&((data)<<24))
+#define HDMI_PHY_FIFO_SR0_port1_g_rwclk_det_timeout_flag(data)       (0x00800000&((data)<<23))
+#define HDMI_PHY_FIFO_SR0_port1_g_wovflow_flag(data)                 (0x00400000&((data)<<22))
+#define HDMI_PHY_FIFO_SR0_port1_g_rudflow_flag(data)                 (0x00200000&((data)<<21))
+#define HDMI_PHY_FIFO_SR0_port1_g_rflush_flag(data)                  (0x00100000&((data)<<20))
+#define HDMI_PHY_FIFO_SR0_port1_b_wrclk_det_timeout_flag(data)       (0x00080000&((data)<<19))
+#define HDMI_PHY_FIFO_SR0_port1_b_rwclk_det_timeout_flag(data)       (0x00040000&((data)<<18))
+#define HDMI_PHY_FIFO_SR0_port1_b_wovflow_flag(data)                 (0x00020000&((data)<<17))
+#define HDMI_PHY_FIFO_SR0_port1_b_rudflow_flag(data)                 (0x00010000&((data)<<16))
+#define HDMI_PHY_FIFO_SR0_port1_b_rflush_flag(data)                  (0x00008000&((data)<<15))
+#define HDMI_PHY_FIFO_SR0_port0_r_wrclk_det_timeout_flag(data)       (0x00004000&((data)<<14))
+#define HDMI_PHY_FIFO_SR0_port0_r_rwclk_det_timeout_flag(data)       (0x00002000&((data)<<13))
+#define HDMI_PHY_FIFO_SR0_port0_r_wovflow_flag(data)                 (0x00001000&((data)<<12))
+#define HDMI_PHY_FIFO_SR0_port0_r_rudflow_flag(data)                 (0x00000800&((data)<<11))
+#define HDMI_PHY_FIFO_SR0_port0_r_rflush_flag(data)                  (0x00000400&((data)<<10))
+#define HDMI_PHY_FIFO_SR0_port0_g_wrclk_det_timeout_flag(data)       (0x00000200&((data)<<9))
+#define HDMI_PHY_FIFO_SR0_port0_g_rwclk_det_timeout_flag(data)       (0x00000100&((data)<<8))
+#define HDMI_PHY_FIFO_SR0_port0_g_wovflow_flag(data)                 (0x00000080&((data)<<7))
+#define HDMI_PHY_FIFO_SR0_port0_g_rudflow_flag(data)                 (0x00000040&((data)<<6))
+#define HDMI_PHY_FIFO_SR0_port0_g_rflush_flag(data)                  (0x00000020&((data)<<5))
+#define HDMI_PHY_FIFO_SR0_port0_b_wrclk_det_timeout_flag(data)       (0x00000010&((data)<<4))
+#define HDMI_PHY_FIFO_SR0_port0_b_rwclk_det_timeout_flag(data)       (0x00000008&((data)<<3))
+#define HDMI_PHY_FIFO_SR0_port0_b_wovflow_flag(data)                 (0x00000004&((data)<<2))
+#define HDMI_PHY_FIFO_SR0_port0_b_rudflow_flag(data)                 (0x00000002&((data)<<1))
+#define HDMI_PHY_FIFO_SR0_port0_b_rflush_flag(data)                  (0x00000001&(data))
+#define HDMI_PHY_FIFO_SR0_get_port1_r_wrclk_det_timeout_flag(data)   ((0x20000000&(data))>>29)
+#define HDMI_PHY_FIFO_SR0_get_port1_r_rwclk_det_timeout_flag(data)   ((0x10000000&(data))>>28)
+#define HDMI_PHY_FIFO_SR0_get_port1_r_wovflow_flag(data)             ((0x08000000&(data))>>27)
+#define HDMI_PHY_FIFO_SR0_get_port1_r_rudflow_flag(data)             ((0x04000000&(data))>>26)
+#define HDMI_PHY_FIFO_SR0_get_port1_r_rflush_flag(data)              ((0x02000000&(data))>>25)
+#define HDMI_PHY_FIFO_SR0_get_port1_g_wrclk_det_timeout_flag(data)   ((0x01000000&(data))>>24)
+#define HDMI_PHY_FIFO_SR0_get_port1_g_rwclk_det_timeout_flag(data)   ((0x00800000&(data))>>23)
+#define HDMI_PHY_FIFO_SR0_get_port1_g_wovflow_flag(data)             ((0x00400000&(data))>>22)
+#define HDMI_PHY_FIFO_SR0_get_port1_g_rudflow_flag(data)             ((0x00200000&(data))>>21)
+#define HDMI_PHY_FIFO_SR0_get_port1_g_rflush_flag(data)              ((0x00100000&(data))>>20)
+#define HDMI_PHY_FIFO_SR0_get_port1_b_wrclk_det_timeout_flag(data)   ((0x00080000&(data))>>19)
+#define HDMI_PHY_FIFO_SR0_get_port1_b_rwclk_det_timeout_flag(data)   ((0x00040000&(data))>>18)
+#define HDMI_PHY_FIFO_SR0_get_port1_b_wovflow_flag(data)             ((0x00020000&(data))>>17)
+#define HDMI_PHY_FIFO_SR0_get_port1_b_rudflow_flag(data)             ((0x00010000&(data))>>16)
+#define HDMI_PHY_FIFO_SR0_get_port1_b_rflush_flag(data)              ((0x00008000&(data))>>15)
+#define HDMI_PHY_FIFO_SR0_get_port0_r_wrclk_det_timeout_flag(data)   ((0x00004000&(data))>>14)
+#define HDMI_PHY_FIFO_SR0_get_port0_r_rwclk_det_timeout_flag(data)   ((0x00002000&(data))>>13)
+#define HDMI_PHY_FIFO_SR0_get_port0_r_wovflow_flag(data)             ((0x00001000&(data))>>12)
+#define HDMI_PHY_FIFO_SR0_get_port0_r_rudflow_flag(data)             ((0x00000800&(data))>>11)
+#define HDMI_PHY_FIFO_SR0_get_port0_r_rflush_flag(data)              ((0x00000400&(data))>>10)
+#define HDMI_PHY_FIFO_SR0_get_port0_g_wrclk_det_timeout_flag(data)   ((0x00000200&(data))>>9)
+#define HDMI_PHY_FIFO_SR0_get_port0_g_rwclk_det_timeout_flag(data)   ((0x00000100&(data))>>8)
+#define HDMI_PHY_FIFO_SR0_get_port0_g_wovflow_flag(data)             ((0x00000080&(data))>>7)
+#define HDMI_PHY_FIFO_SR0_get_port0_g_rudflow_flag(data)             ((0x00000040&(data))>>6)
+#define HDMI_PHY_FIFO_SR0_get_port0_g_rflush_flag(data)              ((0x00000020&(data))>>5)
+#define HDMI_PHY_FIFO_SR0_get_port0_b_wrclk_det_timeout_flag(data)   ((0x00000010&(data))>>4)
+#define HDMI_PHY_FIFO_SR0_get_port0_b_rwclk_det_timeout_flag(data)   ((0x00000008&(data))>>3)
+#define HDMI_PHY_FIFO_SR0_get_port0_b_wovflow_flag(data)             ((0x00000004&(data))>>2)
+#define HDMI_PHY_FIFO_SR0_get_port0_b_rudflow_flag(data)             ((0x00000002&(data))>>1)
+#define HDMI_PHY_FIFO_SR0_get_port0_b_rflush_flag(data)              (0x00000001&(data))
+
+
+#define HDMI_PHY_FIFO_SR1                                            0x1a8
+#define HDMI_PHY_FIFO_SR1_reg_addr                                   "0x980341a8"
+#define HDMI_PHY_FIFO_SR1_reg                                        0x980341a8
+#define HDMI_PHY_FIFO_SR1_inst_addr                                  "0x006A"
+#define HDMI_PHY_FIFO_SR1_inst                                       0x006A
+#define HDMI_PHY_FIFO_SR1_port3_r_wrclk_det_timeout_flag_shift       (29)
+#define HDMI_PHY_FIFO_SR1_port3_r_rwclk_det_timeout_flag_shift       (28)
+#define HDMI_PHY_FIFO_SR1_port3_r_wovflow_flag_shift                 (27)
+#define HDMI_PHY_FIFO_SR1_port3_r_rudflow_flag_shift                 (26)
+#define HDMI_PHY_FIFO_SR1_port3_r_rflush_flag_shift                  (25)
+#define HDMI_PHY_FIFO_SR1_port3_g_wrclk_det_timeout_flag_shift       (24)
+#define HDMI_PHY_FIFO_SR1_port3_g_rwclk_det_timeout_flag_shift       (23)
+#define HDMI_PHY_FIFO_SR1_port3_g_wovflow_flag_shift                 (22)
+#define HDMI_PHY_FIFO_SR1_port3_g_rudflow_flag_shift                 (21)
+#define HDMI_PHY_FIFO_SR1_port3_g_rflush_flag_shift                  (20)
+#define HDMI_PHY_FIFO_SR1_port3_b_wrclk_det_timeout_flag_shift       (19)
+#define HDMI_PHY_FIFO_SR1_port3_b_rwclk_det_timeout_flag_shift       (18)
+#define HDMI_PHY_FIFO_SR1_port3_b_wovflow_flag_shift                 (17)
+#define HDMI_PHY_FIFO_SR1_port3_b_rudflow_flag_shift                 (16)
+#define HDMI_PHY_FIFO_SR1_port3_b_rflush_flag_shift                  (15)
+#define HDMI_PHY_FIFO_SR1_port2_r_wrclk_det_timeout_flag_shift       (14)
+#define HDMI_PHY_FIFO_SR1_port2_r_rwclk_det_timeout_flag_shift       (13)
+#define HDMI_PHY_FIFO_SR1_port2_r_wovflow_flag_shift                 (12)
+#define HDMI_PHY_FIFO_SR1_port2_r_rudflow_flag_shift                 (11)
+#define HDMI_PHY_FIFO_SR1_port2_r_rflush_flag_shift                  (10)
+#define HDMI_PHY_FIFO_SR1_port2_g_wrclk_det_timeout_flag_shift       (9)
+#define HDMI_PHY_FIFO_SR1_port2_g_rwclk_det_timeout_flag_shift       (8)
+#define HDMI_PHY_FIFO_SR1_port2_g_wovflow_flag_shift                 (7)
+#define HDMI_PHY_FIFO_SR1_port2_g_rudflow_flag_shift                 (6)
+#define HDMI_PHY_FIFO_SR1_port2_g_rflush_flag_shift                  (5)
+#define HDMI_PHY_FIFO_SR1_port2_b_wrclk_det_timeout_flag_shift       (4)
+#define HDMI_PHY_FIFO_SR1_port2_b_rwclk_det_timeout_flag_shift       (3)
+#define HDMI_PHY_FIFO_SR1_port2_b_wovflow_flag_shift                 (2)
+#define HDMI_PHY_FIFO_SR1_port2_b_rudflow_flag_shift                 (1)
+#define HDMI_PHY_FIFO_SR1_port2_b_rflush_flag_shift                  (0)
+#define HDMI_PHY_FIFO_SR1_port3_r_wrclk_det_timeout_flag_mask        (0x20000000)
+#define HDMI_PHY_FIFO_SR1_port3_r_rwclk_det_timeout_flag_mask        (0x10000000)
+#define HDMI_PHY_FIFO_SR1_port3_r_wovflow_flag_mask                  (0x08000000)
+#define HDMI_PHY_FIFO_SR1_port3_r_rudflow_flag_mask                  (0x04000000)
+#define HDMI_PHY_FIFO_SR1_port3_r_rflush_flag_mask                   (0x02000000)
+#define HDMI_PHY_FIFO_SR1_port3_g_wrclk_det_timeout_flag_mask        (0x01000000)
+#define HDMI_PHY_FIFO_SR1_port3_g_rwclk_det_timeout_flag_mask        (0x00800000)
+#define HDMI_PHY_FIFO_SR1_port3_g_wovflow_flag_mask                  (0x00400000)
+#define HDMI_PHY_FIFO_SR1_port3_g_rudflow_flag_mask                  (0x00200000)
+#define HDMI_PHY_FIFO_SR1_port3_g_rflush_flag_mask                   (0x00100000)
+#define HDMI_PHY_FIFO_SR1_port3_b_wrclk_det_timeout_flag_mask        (0x00080000)
+#define HDMI_PHY_FIFO_SR1_port3_b_rwclk_det_timeout_flag_mask        (0x00040000)
+#define HDMI_PHY_FIFO_SR1_port3_b_wovflow_flag_mask                  (0x00020000)
+#define HDMI_PHY_FIFO_SR1_port3_b_rudflow_flag_mask                  (0x00010000)
+#define HDMI_PHY_FIFO_SR1_port3_b_rflush_flag_mask                   (0x00008000)
+#define HDMI_PHY_FIFO_SR1_port2_r_wrclk_det_timeout_flag_mask        (0x00004000)
+#define HDMI_PHY_FIFO_SR1_port2_r_rwclk_det_timeout_flag_mask        (0x00002000)
+#define HDMI_PHY_FIFO_SR1_port2_r_wovflow_flag_mask                  (0x00001000)
+#define HDMI_PHY_FIFO_SR1_port2_r_rudflow_flag_mask                  (0x00000800)
+#define HDMI_PHY_FIFO_SR1_port2_r_rflush_flag_mask                   (0x00000400)
+#define HDMI_PHY_FIFO_SR1_port2_g_wrclk_det_timeout_flag_mask        (0x00000200)
+#define HDMI_PHY_FIFO_SR1_port2_g_rwclk_det_timeout_flag_mask        (0x00000100)
+#define HDMI_PHY_FIFO_SR1_port2_g_wovflow_flag_mask                  (0x00000080)
+#define HDMI_PHY_FIFO_SR1_port2_g_rudflow_flag_mask                  (0x00000040)
+#define HDMI_PHY_FIFO_SR1_port2_g_rflush_flag_mask                   (0x00000020)
+#define HDMI_PHY_FIFO_SR1_port2_b_wrclk_det_timeout_flag_mask        (0x00000010)
+#define HDMI_PHY_FIFO_SR1_port2_b_rwclk_det_timeout_flag_mask        (0x00000008)
+#define HDMI_PHY_FIFO_SR1_port2_b_wovflow_flag_mask                  (0x00000004)
+#define HDMI_PHY_FIFO_SR1_port2_b_rudflow_flag_mask                  (0x00000002)
+#define HDMI_PHY_FIFO_SR1_port2_b_rflush_flag_mask                   (0x00000001)
+#define HDMI_PHY_FIFO_SR1_port3_r_wrclk_det_timeout_flag(data)       (0x20000000&((data)<<29))
+#define HDMI_PHY_FIFO_SR1_port3_r_rwclk_det_timeout_flag(data)       (0x10000000&((data)<<28))
+#define HDMI_PHY_FIFO_SR1_port3_r_wovflow_flag(data)                 (0x08000000&((data)<<27))
+#define HDMI_PHY_FIFO_SR1_port3_r_rudflow_flag(data)                 (0x04000000&((data)<<26))
+#define HDMI_PHY_FIFO_SR1_port3_r_rflush_flag(data)                  (0x02000000&((data)<<25))
+#define HDMI_PHY_FIFO_SR1_port3_g_wrclk_det_timeout_flag(data)       (0x01000000&((data)<<24))
+#define HDMI_PHY_FIFO_SR1_port3_g_rwclk_det_timeout_flag(data)       (0x00800000&((data)<<23))
+#define HDMI_PHY_FIFO_SR1_port3_g_wovflow_flag(data)                 (0x00400000&((data)<<22))
+#define HDMI_PHY_FIFO_SR1_port3_g_rudflow_flag(data)                 (0x00200000&((data)<<21))
+#define HDMI_PHY_FIFO_SR1_port3_g_rflush_flag(data)                  (0x00100000&((data)<<20))
+#define HDMI_PHY_FIFO_SR1_port3_b_wrclk_det_timeout_flag(data)       (0x00080000&((data)<<19))
+#define HDMI_PHY_FIFO_SR1_port3_b_rwclk_det_timeout_flag(data)       (0x00040000&((data)<<18))
+#define HDMI_PHY_FIFO_SR1_port3_b_wovflow_flag(data)                 (0x00020000&((data)<<17))
+#define HDMI_PHY_FIFO_SR1_port3_b_rudflow_flag(data)                 (0x00010000&((data)<<16))
+#define HDMI_PHY_FIFO_SR1_port3_b_rflush_flag(data)                  (0x00008000&((data)<<15))
+#define HDMI_PHY_FIFO_SR1_port2_r_wrclk_det_timeout_flag(data)       (0x00004000&((data)<<14))
+#define HDMI_PHY_FIFO_SR1_port2_r_rwclk_det_timeout_flag(data)       (0x00002000&((data)<<13))
+#define HDMI_PHY_FIFO_SR1_port2_r_wovflow_flag(data)                 (0x00001000&((data)<<12))
+#define HDMI_PHY_FIFO_SR1_port2_r_rudflow_flag(data)                 (0x00000800&((data)<<11))
+#define HDMI_PHY_FIFO_SR1_port2_r_rflush_flag(data)                  (0x00000400&((data)<<10))
+#define HDMI_PHY_FIFO_SR1_port2_g_wrclk_det_timeout_flag(data)       (0x00000200&((data)<<9))
+#define HDMI_PHY_FIFO_SR1_port2_g_rwclk_det_timeout_flag(data)       (0x00000100&((data)<<8))
+#define HDMI_PHY_FIFO_SR1_port2_g_wovflow_flag(data)                 (0x00000080&((data)<<7))
+#define HDMI_PHY_FIFO_SR1_port2_g_rudflow_flag(data)                 (0x00000040&((data)<<6))
+#define HDMI_PHY_FIFO_SR1_port2_g_rflush_flag(data)                  (0x00000020&((data)<<5))
+#define HDMI_PHY_FIFO_SR1_port2_b_wrclk_det_timeout_flag(data)       (0x00000010&((data)<<4))
+#define HDMI_PHY_FIFO_SR1_port2_b_rwclk_det_timeout_flag(data)       (0x00000008&((data)<<3))
+#define HDMI_PHY_FIFO_SR1_port2_b_wovflow_flag(data)                 (0x00000004&((data)<<2))
+#define HDMI_PHY_FIFO_SR1_port2_b_rudflow_flag(data)                 (0x00000002&((data)<<1))
+#define HDMI_PHY_FIFO_SR1_port2_b_rflush_flag(data)                  (0x00000001&(data))
+#define HDMI_PHY_FIFO_SR1_get_port3_r_wrclk_det_timeout_flag(data)   ((0x20000000&(data))>>29)
+#define HDMI_PHY_FIFO_SR1_get_port3_r_rwclk_det_timeout_flag(data)   ((0x10000000&(data))>>28)
+#define HDMI_PHY_FIFO_SR1_get_port3_r_wovflow_flag(data)             ((0x08000000&(data))>>27)
+#define HDMI_PHY_FIFO_SR1_get_port3_r_rudflow_flag(data)             ((0x04000000&(data))>>26)
+#define HDMI_PHY_FIFO_SR1_get_port3_r_rflush_flag(data)              ((0x02000000&(data))>>25)
+#define HDMI_PHY_FIFO_SR1_get_port3_g_wrclk_det_timeout_flag(data)   ((0x01000000&(data))>>24)
+#define HDMI_PHY_FIFO_SR1_get_port3_g_rwclk_det_timeout_flag(data)   ((0x00800000&(data))>>23)
+#define HDMI_PHY_FIFO_SR1_get_port3_g_wovflow_flag(data)             ((0x00400000&(data))>>22)
+#define HDMI_PHY_FIFO_SR1_get_port3_g_rudflow_flag(data)             ((0x00200000&(data))>>21)
+#define HDMI_PHY_FIFO_SR1_get_port3_g_rflush_flag(data)              ((0x00100000&(data))>>20)
+#define HDMI_PHY_FIFO_SR1_get_port3_b_wrclk_det_timeout_flag(data)   ((0x00080000&(data))>>19)
+#define HDMI_PHY_FIFO_SR1_get_port3_b_rwclk_det_timeout_flag(data)   ((0x00040000&(data))>>18)
+#define HDMI_PHY_FIFO_SR1_get_port3_b_wovflow_flag(data)             ((0x00020000&(data))>>17)
+#define HDMI_PHY_FIFO_SR1_get_port3_b_rudflow_flag(data)             ((0x00010000&(data))>>16)
+#define HDMI_PHY_FIFO_SR1_get_port3_b_rflush_flag(data)              ((0x00008000&(data))>>15)
+#define HDMI_PHY_FIFO_SR1_get_port2_r_wrclk_det_timeout_flag(data)   ((0x00004000&(data))>>14)
+#define HDMI_PHY_FIFO_SR1_get_port2_r_rwclk_det_timeout_flag(data)   ((0x00002000&(data))>>13)
+#define HDMI_PHY_FIFO_SR1_get_port2_r_wovflow_flag(data)             ((0x00001000&(data))>>12)
+#define HDMI_PHY_FIFO_SR1_get_port2_r_rudflow_flag(data)             ((0x00000800&(data))>>11)
+#define HDMI_PHY_FIFO_SR1_get_port2_r_rflush_flag(data)              ((0x00000400&(data))>>10)
+#define HDMI_PHY_FIFO_SR1_get_port2_g_wrclk_det_timeout_flag(data)   ((0x00000200&(data))>>9)
+#define HDMI_PHY_FIFO_SR1_get_port2_g_rwclk_det_timeout_flag(data)   ((0x00000100&(data))>>8)
+#define HDMI_PHY_FIFO_SR1_get_port2_g_wovflow_flag(data)             ((0x00000080&(data))>>7)
+#define HDMI_PHY_FIFO_SR1_get_port2_g_rudflow_flag(data)             ((0x00000040&(data))>>6)
+#define HDMI_PHY_FIFO_SR1_get_port2_g_rflush_flag(data)              ((0x00000020&(data))>>5)
+#define HDMI_PHY_FIFO_SR1_get_port2_b_wrclk_det_timeout_flag(data)   ((0x00000010&(data))>>4)
+#define HDMI_PHY_FIFO_SR1_get_port2_b_rwclk_det_timeout_flag(data)   ((0x00000008&(data))>>3)
+#define HDMI_PHY_FIFO_SR1_get_port2_b_wovflow_flag(data)             ((0x00000004&(data))>>2)
+#define HDMI_PHY_FIFO_SR1_get_port2_b_rudflow_flag(data)             ((0x00000002&(data))>>1)
+#define HDMI_PHY_FIFO_SR1_get_port2_b_rflush_flag(data)              (0x00000001&(data))
+
+
+#define HDMI_CTS_FIFO_CTL                                       0x1ac
+#define HDMI_CTS_FIFO_CTL_reg_addr                              "0x980341ac"
+#define HDMI_CTS_FIFO_CTL_reg                                   0x980341ac
+#define HDMI_CTS_FIFO_CTL_inst_addr                             "0x006B"
+#define HDMI_CTS_FIFO_CTL_inst                                  0x006B
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_r_shift (17)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_r_shift  (16)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_g_shift (15)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_g_shift  (14)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_b_shift (13)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_b_shift  (12)
+#define HDMI_CTS_FIFO_CTL_dfe_rstn_n_shift                      (11)
+#define HDMI_CTS_FIFO_CTL_offms_clock_sel_shift                 (10)
+#define HDMI_CTS_FIFO_CTL_hdmi_2x_out_sel_shift                 (8)
+#define HDMI_CTS_FIFO_CTL_hdmi_test_sel_shift                   (4)
+#define HDMI_CTS_FIFO_CTL_hdmi_out_sel_shift                    (3)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi_shift         (2)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi_shift           (1)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi_shift          (0)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_r_mask  (0x00020000)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_r_mask   (0x00010000)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_g_mask  (0x00008000)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_g_mask   (0x00004000)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_b_mask  (0x00002000)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_b_mask   (0x00001000)
+#define HDMI_CTS_FIFO_CTL_dfe_rstn_n_mask                       (0x00000800)
+#define HDMI_CTS_FIFO_CTL_offms_clock_sel_mask                  (0x00000400)
+#define HDMI_CTS_FIFO_CTL_hdmi_2x_out_sel_mask                  (0x00000300)
+#define HDMI_CTS_FIFO_CTL_hdmi_test_sel_mask                    (0x000000F0)
+#define HDMI_CTS_FIFO_CTL_hdmi_out_sel_mask                     (0x00000008)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi_mask          (0x00000004)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi_mask            (0x00000002)
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi_mask           (0x00000001)
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_r(data) (0x00020000&((data)<<17))
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_r(data)  (0x00010000&((data)<<16))
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_g(data) (0x00008000&((data)<<15))
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_g(data)  (0x00004000&((data)<<14))
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_b(data) (0x00002000&((data)<<13))
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_b(data)  (0x00001000&((data)<<12))
+#define HDMI_CTS_FIFO_CTL_dfe_rstn_n(data)                      (0x00000800&((data)<<11))
+#define HDMI_CTS_FIFO_CTL_offms_clock_sel(data)                 (0x00000400&((data)<<10))
+#define HDMI_CTS_FIFO_CTL_hdmi_2x_out_sel(data)                 (0x00000300&((data)<<8))
+#define HDMI_CTS_FIFO_CTL_hdmi_test_sel(data)                   (0x000000F0&((data)<<4))
+#define HDMI_CTS_FIFO_CTL_hdmi_out_sel(data)                    (0x00000008&((data)<<3))
+#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi(data)         (0x00000004&((data)<<2))
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi(data)           (0x00000002&((data)<<1))
+#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi(data)          (0x00000001&(data))
+#define HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_phy_dbgout_r(data)  ((0x00020000&(data))>>17)
+#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_phy_dbgout_r(data)  ((0x00010000&(data))>>16)
+#define HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_phy_dbgout_g(data)  ((0x00008000&(data))>>15)
+#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_phy_dbgout_g(data)  ((0x00004000&(data))>>14)
+#define HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_phy_dbgout_b(data)  ((0x00002000&(data))>>13)
+#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_phy_dbgout_b(data)  ((0x00001000&(data))>>12)
+#define HDMI_CTS_FIFO_CTL_get_dfe_rstn_n(data)                  ((0x00000800&(data))>>11)
+#define HDMI_CTS_FIFO_CTL_get_offms_clock_sel(data)             ((0x00000400&(data))>>10)
+#define HDMI_CTS_FIFO_CTL_get_hdmi_2x_out_sel(data)             ((0x00000300&(data))>>8)
+#define HDMI_CTS_FIFO_CTL_get_hdmi_test_sel(data)               ((0x000000F0&(data))>>4)
+#define HDMI_CTS_FIFO_CTL_get_hdmi_out_sel(data)                ((0x00000008&(data))>>3)
+#define HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_hdmi(data)     ((0x00000004&(data))>>2)
+#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_vsrst_hdmi(data)       ((0x00000002&(data))>>1)
+#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_hdmi(data)      (0x00000001&(data))
+
+
+#define HDMI_CH_CR                                                   0x1b0
+#define HDMI_CH_CR_reg_addr                                          "0x980341b0"
+#define HDMI_CH_CR_reg                                               0x980341b0
+#define HDMI_CH_CR_inst_addr                                         "0x006C"
+#define HDMI_CH_CR_inst                                              0x006C
+#define HDMI_CH_CR_r_ch_afifo_en_shift                               (24)
+#define HDMI_CH_CR_g_ch_afifo_en_shift                               (23)
+#define HDMI_CH_CR_b_ch_afifo_en_shift                               (22)
+#define HDMI_CH_CR_ch_sync_sel_shift                                 (20)
+#define HDMI_CH_CR_dummy980341b0_19_17_shift                         (17)
+#define HDMI_CH_CR_rden_thr_shift                                    (12)
+#define HDMI_CH_CR_dummy980341b0_11_9_shift                          (9)
+#define HDMI_CH_CR_udwater_thr_shift                                 (4)
+#define HDMI_CH_CR_dummy980341b0_3_2_shift                           (2)
+#define HDMI_CH_CR_flush_shift                                       (1)
+#define HDMI_CH_CR_ch_afifo_irq_en_shift                             (0)
+#define HDMI_CH_CR_r_ch_afifo_en_mask                                (0x01000000)
+#define HDMI_CH_CR_g_ch_afifo_en_mask                                (0x00800000)
+#define HDMI_CH_CR_b_ch_afifo_en_mask                                (0x00400000)
+#define HDMI_CH_CR_ch_sync_sel_mask                                  (0x00300000)
+#define HDMI_CH_CR_dummy980341b0_19_17_mask                          (0x000E0000)
+#define HDMI_CH_CR_rden_thr_mask                                     (0x0001F000)
+#define HDMI_CH_CR_dummy980341b0_11_9_mask                           (0x00000E00)
+#define HDMI_CH_CR_udwater_thr_mask                                  (0x000001F0)
+#define HDMI_CH_CR_dummy980341b0_3_2_mask                            (0x0000000C)
+#define HDMI_CH_CR_flush_mask                                        (0x00000002)
+#define HDMI_CH_CR_ch_afifo_irq_en_mask                              (0x00000001)
+#define HDMI_CH_CR_r_ch_afifo_en(data)                               (0x01000000&((data)<<24))
+#define HDMI_CH_CR_g_ch_afifo_en(data)                               (0x00800000&((data)<<23))
+#define HDMI_CH_CR_b_ch_afifo_en(data)                               (0x00400000&((data)<<22))
+#define HDMI_CH_CR_ch_sync_sel(data)                                 (0x00300000&((data)<<20))
+#define HDMI_CH_CR_dummy980341b0_19_17(data)                         (0x000E0000&((data)<<17))
+#define HDMI_CH_CR_rden_thr(data)                                    (0x0001F000&((data)<<12))
+#define HDMI_CH_CR_dummy980341b0_11_9(data)                          (0x00000E00&((data)<<9))
+#define HDMI_CH_CR_udwater_thr(data)                                 (0x000001F0&((data)<<4))
+#define HDMI_CH_CR_dummy980341b0_3_2(data)                           (0x0000000C&((data)<<2))
+#define HDMI_CH_CR_flush(data)                                       (0x00000002&((data)<<1))
+#define HDMI_CH_CR_ch_afifo_irq_en(data)                             (0x00000001&(data))
+#define HDMI_CH_CR_get_r_ch_afifo_en(data)                           ((0x01000000&(data))>>24)
+#define HDMI_CH_CR_get_g_ch_afifo_en(data)                           ((0x00800000&(data))>>23)
+#define HDMI_CH_CR_get_b_ch_afifo_en(data)                           ((0x00400000&(data))>>22)
+#define HDMI_CH_CR_get_ch_sync_sel(data)                             ((0x00300000&(data))>>20)
+#define HDMI_CH_CR_get_dummy980341b0_19_17(data)                     ((0x000E0000&(data))>>17)
+#define HDMI_CH_CR_get_rden_thr(data)                                ((0x0001F000&(data))>>12)
+#define HDMI_CH_CR_get_dummy980341b0_11_9(data)                      ((0x00000E00&(data))>>9)
+#define HDMI_CH_CR_get_udwater_thr(data)                             ((0x000001F0&(data))>>4)
+#define HDMI_CH_CR_get_dummy980341b0_3_2(data)                       ((0x0000000C&(data))>>2)
+#define HDMI_CH_CR_get_flush(data)                                   ((0x00000002&(data))>>1)
+#define HDMI_CH_CR_get_ch_afifo_irq_en(data)                         (0x00000001&(data))
+
+
+#define HDMI_CH_SR                                                   0x1b4
+#define HDMI_CH_SR_reg_addr                                          "0x980341b4"
+#define HDMI_CH_SR_reg                                               0x980341b4
+#define HDMI_CH_SR_inst_addr                                         "0x006D"
+#define HDMI_CH_SR_inst                                              0x006D
+#define HDMI_CH_SR_rgb_de_align_flag_shift                           (30)
+#define HDMI_CH_SR_r_rwclk_det_timeout_flag_shift                    (29)
+#define HDMI_CH_SR_r_wrclk_det_timeout_flag_shift                    (28)
+#define HDMI_CH_SR_g_rwclk_det_timeout_flag_shift                    (27)
+#define HDMI_CH_SR_g_wrclk_det_timeout_flag_shift                    (26)
+#define HDMI_CH_SR_b_rwclk_det_timeout_flag_shift                    (25)
+#define HDMI_CH_SR_b_wrclk_det_timeout_flag_shift                    (24)
+#define HDMI_CH_SR_r_rudflow_flag_shift                              (23)
+#define HDMI_CH_SR_r_wovflow_flag_shift                              (22)
+#define HDMI_CH_SR_r_rflush_flag_shift                               (21)
+#define HDMI_CH_SR_r_rw_water_lv_shift                               (16)
+#define HDMI_CH_SR_g_rudflow_flag_shift                              (15)
+#define HDMI_CH_SR_g_wovflow_flag_shift                              (14)
+#define HDMI_CH_SR_g_rflush_flag_shift                               (13)
+#define HDMI_CH_SR_g_rw_water_lv_shift                               (8)
+#define HDMI_CH_SR_b_rudflow_flag_shift                              (7)
+#define HDMI_CH_SR_b_wovflow_flag_shift                              (6)
+#define HDMI_CH_SR_b_rflush_flag_shift                               (5)
+#define HDMI_CH_SR_b_rw_water_lv_shift                               (0)
+#define HDMI_CH_SR_rgb_de_align_flag_mask                            (0x40000000)
+#define HDMI_CH_SR_r_rwclk_det_timeout_flag_mask                     (0x20000000)
+#define HDMI_CH_SR_r_wrclk_det_timeout_flag_mask                     (0x10000000)
+#define HDMI_CH_SR_g_rwclk_det_timeout_flag_mask                     (0x08000000)
+#define HDMI_CH_SR_g_wrclk_det_timeout_flag_mask                     (0x04000000)
+#define HDMI_CH_SR_b_rwclk_det_timeout_flag_mask                     (0x02000000)
+#define HDMI_CH_SR_b_wrclk_det_timeout_flag_mask                     (0x01000000)
+#define HDMI_CH_SR_r_rudflow_flag_mask                               (0x00800000)
+#define HDMI_CH_SR_r_wovflow_flag_mask                               (0x00400000)
+#define HDMI_CH_SR_r_rflush_flag_mask                                (0x00200000)
+#define HDMI_CH_SR_r_rw_water_lv_mask                                (0x001F0000)
+#define HDMI_CH_SR_g_rudflow_flag_mask                               (0x00008000)
+#define HDMI_CH_SR_g_wovflow_flag_mask                               (0x00004000)
+#define HDMI_CH_SR_g_rflush_flag_mask                                (0x00002000)
+#define HDMI_CH_SR_g_rw_water_lv_mask                                (0x00001F00)
+#define HDMI_CH_SR_b_rudflow_flag_mask                               (0x00000080)
+#define HDMI_CH_SR_b_wovflow_flag_mask                               (0x00000040)
+#define HDMI_CH_SR_b_rflush_flag_mask                                (0x00000020)
+#define HDMI_CH_SR_b_rw_water_lv_mask                                (0x0000001F)
+#define HDMI_CH_SR_rgb_de_align_flag(data)                           (0x40000000&((data)<<30))
+#define HDMI_CH_SR_r_rwclk_det_timeout_flag(data)                    (0x20000000&((data)<<29))
+#define HDMI_CH_SR_r_wrclk_det_timeout_flag(data)                    (0x10000000&((data)<<28))
+#define HDMI_CH_SR_g_rwclk_det_timeout_flag(data)                    (0x08000000&((data)<<27))
+#define HDMI_CH_SR_g_wrclk_det_timeout_flag(data)                    (0x04000000&((data)<<26))
+#define HDMI_CH_SR_b_rwclk_det_timeout_flag(data)                    (0x02000000&((data)<<25))
+#define HDMI_CH_SR_b_wrclk_det_timeout_flag(data)                    (0x01000000&((data)<<24))
+#define HDMI_CH_SR_r_rudflow_flag(data)                              (0x00800000&((data)<<23))
+#define HDMI_CH_SR_r_wovflow_flag(data)                              (0x00400000&((data)<<22))
+#define HDMI_CH_SR_r_rflush_flag(data)                               (0x00200000&((data)<<21))
+#define HDMI_CH_SR_r_rw_water_lv(data)                               (0x001F0000&((data)<<16))
+#define HDMI_CH_SR_g_rudflow_flag(data)                              (0x00008000&((data)<<15))
+#define HDMI_CH_SR_g_wovflow_flag(data)                              (0x00004000&((data)<<14))
+#define HDMI_CH_SR_g_rflush_flag(data)                               (0x00002000&((data)<<13))
+#define HDMI_CH_SR_g_rw_water_lv(data)                               (0x00001F00&((data)<<8))
+#define HDMI_CH_SR_b_rudflow_flag(data)                              (0x00000080&((data)<<7))
+#define HDMI_CH_SR_b_wovflow_flag(data)                              (0x00000040&((data)<<6))
+#define HDMI_CH_SR_b_rflush_flag(data)                               (0x00000020&((data)<<5))
+#define HDMI_CH_SR_b_rw_water_lv(data)                               (0x0000001F&(data))
+#define HDMI_CH_SR_get_rgb_de_align_flag(data)                       ((0x40000000&(data))>>30)
+#define HDMI_CH_SR_get_r_rwclk_det_timeout_flag(data)                ((0x20000000&(data))>>29)
+#define HDMI_CH_SR_get_r_wrclk_det_timeout_flag(data)                ((0x10000000&(data))>>28)
+#define HDMI_CH_SR_get_g_rwclk_det_timeout_flag(data)                ((0x08000000&(data))>>27)
+#define HDMI_CH_SR_get_g_wrclk_det_timeout_flag(data)                ((0x04000000&(data))>>26)
+#define HDMI_CH_SR_get_b_rwclk_det_timeout_flag(data)                ((0x02000000&(data))>>25)
+#define HDMI_CH_SR_get_b_wrclk_det_timeout_flag(data)                ((0x01000000&(data))>>24)
+#define HDMI_CH_SR_get_r_rudflow_flag(data)                          ((0x00800000&(data))>>23)
+#define HDMI_CH_SR_get_r_wovflow_flag(data)                          ((0x00400000&(data))>>22)
+#define HDMI_CH_SR_get_r_rflush_flag(data)                           ((0x00200000&(data))>>21)
+#define HDMI_CH_SR_get_r_rw_water_lv(data)                           ((0x001F0000&(data))>>16)
+#define HDMI_CH_SR_get_g_rudflow_flag(data)                          ((0x00008000&(data))>>15)
+#define HDMI_CH_SR_get_g_wovflow_flag(data)                          ((0x00004000&(data))>>14)
+#define HDMI_CH_SR_get_g_rflush_flag(data)                           ((0x00002000&(data))>>13)
+#define HDMI_CH_SR_get_g_rw_water_lv(data)                           ((0x00001F00&(data))>>8)
+#define HDMI_CH_SR_get_b_rudflow_flag(data)                          ((0x00000080&(data))>>7)
+#define HDMI_CH_SR_get_b_wovflow_flag(data)                          ((0x00000040&(data))>>6)
+#define HDMI_CH_SR_get_b_rflush_flag(data)                           ((0x00000020&(data))>>5)
+#define HDMI_CH_SR_get_b_rw_water_lv(data)                           (0x0000001F&(data))
+
+
+#define HDMI_2P0_CR                                             0x1b8
+#define HDMI_2P0_CR_reg_addr                                    "0x980341b8"
+#define HDMI_2P0_CR_reg                                         0x980341b8
+#define HDMI_2P0_CR_inst_addr                                   "0x006E"
+#define HDMI_2P0_CR_inst                                        0x006E
+#define HDMI_2P0_CR_gating_en_shift                             (8)
+#define HDMI_2P0_CR_ctr_char_num_shift                          (1)
+#define HDMI_2P0_CR_hdmi_2p0_en_shift                           (0)
+#define HDMI_2P0_CR_gating_en_mask                              (0x00000100)
+#define HDMI_2P0_CR_ctr_char_num_mask                           (0x000000FE)
+#define HDMI_2P0_CR_hdmi_2p0_en_mask                            (0x00000001)
+#define HDMI_2P0_CR_gating_en(data)                             (0x00000100&((data)<<8))
+#define HDMI_2P0_CR_ctr_char_num(data)                          (0x000000FE&((data)<<1))
+#define HDMI_2P0_CR_hdmi_2p0_en(data)                           (0x00000001&(data))
+#define HDMI_2P0_CR_get_gating_en(data)                         ((0x00000100&(data))>>8)
+#define HDMI_2P0_CR_get_ctr_char_num(data)                      ((0x000000FE&(data))>>1)
+#define HDMI_2P0_CR_get_hdmi_2p0_en(data)                       (0x00000001&(data))
+
+
+#define HDMI_SCR_CR                                                  0x1bc
+#define HDMI_SCR_CR_reg_addr                                         "0x980341bc"
+#define HDMI_SCR_CR_reg                                              0x980341bc
+#define HDMI_SCR_CR_inst_addr                                        "0x006F"
+#define HDMI_SCR_CR_inst                                             0x006F
+#define HDMI_SCR_CR_char_lock_shift                                  (17)
+#define HDMI_SCR_CR_uscr_fall_bound_err_r_shift                      (16)
+#define HDMI_SCR_CR_uscr_fall_bound_err_g_shift                      (15)
+#define HDMI_SCR_CR_uscr_fall_bound_err_b_shift                      (14)
+#define HDMI_SCR_CR_uscr_per_glitch_r_shift                          (13)
+#define HDMI_SCR_CR_uscr_per_glitch_g_shift                          (12)
+#define HDMI_SCR_CR_uscr_per_glitch_b_shift                          (11)
+#define HDMI_SCR_CR_uscr_char_flag_r_shift                           (10)
+#define HDMI_SCR_CR_uscr_char_flag_g_shift                           (9)
+#define HDMI_SCR_CR_uscr_char_flag_b_shift                           (8)
+#define HDMI_SCR_CR_uscr_num_shift                                   (4)
+#define HDMI_SCR_CR_dummy980341bc_3_2_shift                          (2)
+#define HDMI_SCR_CR_scr_en_fw_shift                                  (1)
+#define HDMI_SCR_CR_scr_auto_shift                                   (0)
+#define HDMI_SCR_CR_char_lock_mask                                   (0x00020000)
+#define HDMI_SCR_CR_uscr_fall_bound_err_r_mask                       (0x00010000)
+#define HDMI_SCR_CR_uscr_fall_bound_err_g_mask                       (0x00008000)
+#define HDMI_SCR_CR_uscr_fall_bound_err_b_mask                       (0x00004000)
+#define HDMI_SCR_CR_uscr_per_glitch_r_mask                           (0x00002000)
+#define HDMI_SCR_CR_uscr_per_glitch_g_mask                           (0x00001000)
+#define HDMI_SCR_CR_uscr_per_glitch_b_mask                           (0x00000800)
+#define HDMI_SCR_CR_uscr_char_flag_r_mask                            (0x00000400)
+#define HDMI_SCR_CR_uscr_char_flag_g_mask                            (0x00000200)
+#define HDMI_SCR_CR_uscr_char_flag_b_mask                            (0x00000100)
+#define HDMI_SCR_CR_uscr_num_mask                                    (0x000000F0)
+#define HDMI_SCR_CR_dummy980341bc_3_2_mask                           (0x0000000C)
+#define HDMI_SCR_CR_scr_en_fw_mask                                   (0x00000002)
+#define HDMI_SCR_CR_scr_auto_mask                                    (0x00000001)
+#define HDMI_SCR_CR_char_lock(data)                                  (0x00020000&((data)<<17))
+#define HDMI_SCR_CR_uscr_fall_bound_err_r(data)                      (0x00010000&((data)<<16))
+#define HDMI_SCR_CR_uscr_fall_bound_err_g(data)                      (0x00008000&((data)<<15))
+#define HDMI_SCR_CR_uscr_fall_bound_err_b(data)                      (0x00004000&((data)<<14))
+#define HDMI_SCR_CR_uscr_per_glitch_r(data)                          (0x00002000&((data)<<13))
+#define HDMI_SCR_CR_uscr_per_glitch_g(data)                          (0x00001000&((data)<<12))
+#define HDMI_SCR_CR_uscr_per_glitch_b(data)                          (0x00000800&((data)<<11))
+#define HDMI_SCR_CR_uscr_char_flag_r(data)                           (0x00000400&((data)<<10))
+#define HDMI_SCR_CR_uscr_char_flag_g(data)                           (0x00000200&((data)<<9))
+#define HDMI_SCR_CR_uscr_char_flag_b(data)                           (0x00000100&((data)<<8))
+#define HDMI_SCR_CR_uscr_num(data)                                   (0x000000F0&((data)<<4))
+#define HDMI_SCR_CR_dummy980341bc_3_2(data)                          (0x0000000C&((data)<<2))
+#define HDMI_SCR_CR_scr_en_fw(data)                                  (0x00000002&((data)<<1))
+#define HDMI_SCR_CR_scr_auto(data)                                   (0x00000001&(data))
+#define HDMI_SCR_CR_get_char_lock(data)                              ((0x00020000&(data))>>17)
+#define HDMI_SCR_CR_get_uscr_fall_bound_err_r(data)                  ((0x00010000&(data))>>16)
+#define HDMI_SCR_CR_get_uscr_fall_bound_err_g(data)                  ((0x00008000&(data))>>15)
+#define HDMI_SCR_CR_get_uscr_fall_bound_err_b(data)                  ((0x00004000&(data))>>14)
+#define HDMI_SCR_CR_get_uscr_per_glitch_r(data)                      ((0x00002000&(data))>>13)
+#define HDMI_SCR_CR_get_uscr_per_glitch_g(data)                      ((0x00001000&(data))>>12)
+#define HDMI_SCR_CR_get_uscr_per_glitch_b(data)                      ((0x00000800&(data))>>11)
+#define HDMI_SCR_CR_get_uscr_char_flag_r(data)                       ((0x00000400&(data))>>10)
+#define HDMI_SCR_CR_get_uscr_char_flag_g(data)                       ((0x00000200&(data))>>9)
+#define HDMI_SCR_CR_get_uscr_char_flag_b(data)                       ((0x00000100&(data))>>8)
+#define HDMI_SCR_CR_get_uscr_num(data)                               ((0x000000F0&(data))>>4)
+#define HDMI_SCR_CR_get_dummy980341bc_3_2(data)                      ((0x0000000C&(data))>>2)
+#define HDMI_SCR_CR_get_scr_en_fw(data)                              ((0x00000002&(data))>>1)
+#define HDMI_SCR_CR_get_scr_auto(data)                               (0x00000001&(data))
+
+
+#define HDMI_CERCR                                                   0x1c0
+#define HDMI_CERCR_reg_addr                                          "0x980341c0"
+#define HDMI_CERCR_reg                                               0x980341c0
+#define HDMI_CERCR_inst_addr                                         "0x0070"
+#define HDMI_CERCR_inst                                              0x0070
+#define HDMI_CERCR_ch_locked_reset_shift                             (28)
+#define HDMI_CERCR_ch2_over_max_err_num_shift                        (27)
+#define HDMI_CERCR_ch1_over_max_err_num_shift                        (26)
+#define HDMI_CERCR_ch0_over_max_err_num_shift                        (25)
+#define HDMI_CERCR_max_err_num_shift                                 (15)
+#define HDMI_CERCR_valid_reset_shift                                 (14)
+#define HDMI_CERCR_reset_err_det_shift                               (13)
+#define HDMI_CERCR_keep_err_det_shift                                (12)
+#define HDMI_CERCR_refer_implem_shift                                (11)
+#define HDMI_CERCR_reset_shift                                       (10)
+#define HDMI_CERCR_period_shift                                      (4)
+#define HDMI_CERCR_dummy980341c0_3_2_shift                           (2)
+#define HDMI_CERCR_mode_shift                                        (1)
+#define HDMI_CERCR_en_shift                                          (0)
+#define HDMI_CERCR_ch_locked_reset_mask                              (0x10000000)
+#define HDMI_CERCR_ch2_over_max_err_num_mask                         (0x08000000)
+#define HDMI_CERCR_ch1_over_max_err_num_mask                         (0x04000000)
+#define HDMI_CERCR_ch0_over_max_err_num_mask                         (0x02000000)
+#define HDMI_CERCR_max_err_num_mask                                  (0x01FF8000)
+#define HDMI_CERCR_valid_reset_mask                                  (0x00004000)
+#define HDMI_CERCR_reset_err_det_mask                                (0x00002000)
+#define HDMI_CERCR_keep_err_det_mask                                 (0x00001000)
+#define HDMI_CERCR_refer_implem_mask                                 (0x00000800)
+#define HDMI_CERCR_reset_mask                                        (0x00000400)
+#define HDMI_CERCR_period_mask                                       (0x000003F0)
+#define HDMI_CERCR_dummy980341c0_3_2_mask                            (0x0000000C)
+#define HDMI_CERCR_mode_mask                                         (0x00000002)
+#define HDMI_CERCR_en_mask                                           (0x00000001)
+#define HDMI_CERCR_ch_locked_reset(data)                             (0x10000000&((data)<<28))
+#define HDMI_CERCR_ch2_over_max_err_num(data)                        (0x08000000&((data)<<27))
+#define HDMI_CERCR_ch1_over_max_err_num(data)                        (0x04000000&((data)<<26))
+#define HDMI_CERCR_ch0_over_max_err_num(data)                        (0x02000000&((data)<<25))
+#define HDMI_CERCR_max_err_num(data)                                 (0x01FF8000&((data)<<15))
+#define HDMI_CERCR_valid_reset(data)                                 (0x00004000&((data)<<14))
+#define HDMI_CERCR_reset_err_det(data)                               (0x00002000&((data)<<13))
+#define HDMI_CERCR_keep_err_det(data)                                (0x00001000&((data)<<12))
+#define HDMI_CERCR_refer_implem(data)                                (0x00000800&((data)<<11))
+#define HDMI_CERCR_reset(data)                                       (0x00000400&((data)<<10))
+#define HDMI_CERCR_period(data)                                      (0x000003F0&((data)<<4))
+#define HDMI_CERCR_dummy980341c0_3_2(data)                           (0x0000000C&((data)<<2))
+#define HDMI_CERCR_mode(data)                                        (0x00000002&((data)<<1))
+#define HDMI_CERCR_en(data)                                          (0x00000001&(data))
+#define HDMI_CERCR_get_ch_locked_reset(data)                         ((0x10000000&(data))>>28)
+#define HDMI_CERCR_get_ch2_over_max_err_num(data)                    ((0x08000000&(data))>>27)
+#define HDMI_CERCR_get_ch1_over_max_err_num(data)                    ((0x04000000&(data))>>26)
+#define HDMI_CERCR_get_ch0_over_max_err_num(data)                    ((0x02000000&(data))>>25)
+#define HDMI_CERCR_get_max_err_num(data)                             ((0x01FF8000&(data))>>15)
+#define HDMI_CERCR_get_valid_reset(data)                             ((0x00004000&(data))>>14)
+#define HDMI_CERCR_get_reset_err_det(data)                           ((0x00002000&(data))>>13)
+#define HDMI_CERCR_get_keep_err_det(data)                            ((0x00001000&(data))>>12)
+#define HDMI_CERCR_get_refer_implem(data)                            ((0x00000800&(data))>>11)
+#define HDMI_CERCR_get_reset(data)                                   ((0x00000400&(data))>>10)
+#define HDMI_CERCR_get_period(data)                                  ((0x000003F0&(data))>>4)
+#define HDMI_CERCR_get_dummy980341c0_3_2(data)                       ((0x0000000C&(data))>>2)
+#define HDMI_CERCR_get_mode(data)                                    ((0x00000002&(data))>>1)
+#define HDMI_CERCR_get_en(data)                                      (0x00000001&(data))
+
+
+#define HDMI_CERSR0                                                  0x1c4
+#define HDMI_CERSR0_reg_addr                                         "0x980341c4"
+#define HDMI_CERSR0_reg                                              0x980341c4
+#define HDMI_CERSR0_inst_addr                                        "0x0071"
+#define HDMI_CERSR0_inst                                             0x0071
+#define HDMI_CERSR0_err_cnt1_video_shift                             (16)
+#define HDMI_CERSR0_err_cnt0_video_shift                             (0)
+#define HDMI_CERSR0_err_cnt1_video_mask                              (0x7FFF0000)
+#define HDMI_CERSR0_err_cnt0_video_mask                              (0x00007FFF)
+#define HDMI_CERSR0_err_cnt1_video(data)                             (0x7FFF0000&((data)<<16))
+#define HDMI_CERSR0_err_cnt0_video(data)                             (0x00007FFF&(data))
+#define HDMI_CERSR0_get_err_cnt1_video(data)                         ((0x7FFF0000&(data))>>16)
+#define HDMI_CERSR0_get_err_cnt0_video(data)                         (0x00007FFF&(data))
+
+
+#define HDMI_CERSR1                                                  0x1c8
+#define HDMI_CERSR1_reg_addr                                         "0x980341c8"
+#define HDMI_CERSR1_reg                                              0x980341c8
+#define HDMI_CERSR1_inst_addr                                        "0x0072"
+#define HDMI_CERSR1_inst                                             0x0072
+#define HDMI_CERSR1_err_cnt0_pkt_shift                               (16)
+#define HDMI_CERSR1_err_cnt2_video_shift                             (0)
+#define HDMI_CERSR1_err_cnt0_pkt_mask                                (0x7FFF0000)
+#define HDMI_CERSR1_err_cnt2_video_mask                              (0x00007FFF)
+#define HDMI_CERSR1_err_cnt0_pkt(data)                               (0x7FFF0000&((data)<<16))
+#define HDMI_CERSR1_err_cnt2_video(data)                             (0x00007FFF&(data))
+#define HDMI_CERSR1_get_err_cnt0_pkt(data)                           ((0x7FFF0000&(data))>>16)
+#define HDMI_CERSR1_get_err_cnt2_video(data)                         (0x00007FFF&(data))
+
+
+#define HDMI_CERSR2                                                  0x1cc
+#define HDMI_CERSR2_reg_addr                                         "0x980341cc"
+#define HDMI_CERSR2_reg                                              0x980341cc
+#define HDMI_CERSR2_inst_addr                                        "0x0073"
+#define HDMI_CERSR2_inst                                             0x0073
+#define HDMI_CERSR2_err_cnt2_pkt_shift                               (16)
+#define HDMI_CERSR2_err_cnt1_pkt_shift                               (0)
+#define HDMI_CERSR2_err_cnt2_pkt_mask                                (0x7FFF0000)
+#define HDMI_CERSR2_err_cnt1_pkt_mask                                (0x00007FFF)
+#define HDMI_CERSR2_err_cnt2_pkt(data)                               (0x7FFF0000&((data)<<16))
+#define HDMI_CERSR2_err_cnt1_pkt(data)                               (0x00007FFF&(data))
+#define HDMI_CERSR2_get_err_cnt2_pkt(data)                           ((0x7FFF0000&(data))>>16)
+#define HDMI_CERSR2_get_err_cnt1_pkt(data)                           (0x00007FFF&(data))
+
+
+#define HDMI_CERSR3                                                  0x1d0
+#define HDMI_CERSR3_reg_addr                                         "0x980341d0"
+#define HDMI_CERSR3_reg                                              0x980341d0
+#define HDMI_CERSR3_inst_addr                                        "0x0074"
+#define HDMI_CERSR3_inst                                             0x0074
+#define HDMI_CERSR3_err_cnt1_ctr_shift                               (16)
+#define HDMI_CERSR3_err_cnt0_ctr_shift                               (0)
+#define HDMI_CERSR3_err_cnt1_ctr_mask                                (0x7FFF0000)
+#define HDMI_CERSR3_err_cnt0_ctr_mask                                (0x00007FFF)
+#define HDMI_CERSR3_err_cnt1_ctr(data)                               (0x7FFF0000&((data)<<16))
+#define HDMI_CERSR3_err_cnt0_ctr(data)                               (0x00007FFF&(data))
+#define HDMI_CERSR3_get_err_cnt1_ctr(data)                           ((0x7FFF0000&(data))>>16)
+#define HDMI_CERSR3_get_err_cnt0_ctr(data)                           (0x00007FFF&(data))
+
+
+#define HDMI_CERSR4                                                  0x1d4
+#define HDMI_CERSR4_reg_addr                                         "0x980341d4"
+#define HDMI_CERSR4_reg                                              0x980341d4
+#define HDMI_CERSR4_inst_addr                                        "0x0075"
+#define HDMI_CERSR4_inst                                             0x0075
+#define HDMI_CERSR4_err_cnt2_ctr_shift                               (0)
+#define HDMI_CERSR4_err_cnt2_ctr_mask                                (0x00007FFF)
+#define HDMI_CERSR4_err_cnt2_ctr(data)                               (0x00007FFF&(data))
+#define HDMI_CERSR4_get_err_cnt2_ctr(data)                           (0x00007FFF&(data))
+
+
+#define HDMI_YUV420_CR                                               0x1d8
+#define HDMI_YUV420_CR_reg_addr                                      "0x980341d8"
+#define HDMI_YUV420_CR_reg                                           0x980341d8
+#define HDMI_YUV420_CR_inst_addr                                     "0x0076"
+#define HDMI_YUV420_CR_inst                                          0x0076
+#define HDMI_YUV420_CR_fifo_over_flag_shift                          (2)
+#define HDMI_YUV420_CR_fifo_under_flag_shift                         (1)
+#define HDMI_YUV420_CR_en_shift                                      (0)
+#define HDMI_YUV420_CR_fifo_over_flag_mask                           (0x00000004)
+#define HDMI_YUV420_CR_fifo_under_flag_mask                          (0x00000002)
+#define HDMI_YUV420_CR_en_mask                                       (0x00000001)
+#define HDMI_YUV420_CR_fifo_over_flag(data)                          (0x00000004&((data)<<2))
+#define HDMI_YUV420_CR_fifo_under_flag(data)                         (0x00000002&((data)<<1))
+#define HDMI_YUV420_CR_en(data)                                      (0x00000001&(data))
+#define HDMI_YUV420_CR_get_fifo_over_flag(data)                      ((0x00000004&(data))>>2)
+#define HDMI_YUV420_CR_get_fifo_under_flag(data)                     ((0x00000002&(data))>>1)
+#define HDMI_YUV420_CR_get_en(data)                                  (0x00000001&(data))
+
+
+#define HDMI_SCDC_CR                                                 0x1dc
+#define HDMI_SCDC_CR_reg_addr                                        "0x980341dc"
+#define HDMI_SCDC_CR_reg                                             0x980341dc
+#define HDMI_SCDC_CR_inst_addr                                       "0x0077"
+#define HDMI_SCDC_CR_inst                                            0x0077
+#define HDMI_SCDC_CR_scdc_reset_shift                                (5)
+#define HDMI_SCDC_CR_dummy980341dc_4_2_shift                         (2)
+#define HDMI_SCDC_CR_maddf_shift                                     (1)
+#define HDMI_SCDC_CR_scdc_en_shift                                   (0)
+#define HDMI_SCDC_CR_scdc_reset_mask                                 (0x00000020)
+#define HDMI_SCDC_CR_dummy980341dc_4_2_mask                          (0x0000001C)
+#define HDMI_SCDC_CR_maddf_mask                                      (0x00000002)
+#define HDMI_SCDC_CR_scdc_en_mask                                    (0x00000001)
+#define HDMI_SCDC_CR_scdc_reset(data)                                (0x00000020&((data)<<5))
+#define HDMI_SCDC_CR_dummy980341dc_4_2(data)                         (0x0000001C&((data)<<2))
+#define HDMI_SCDC_CR_maddf(data)                                     (0x00000002&((data)<<1))
+#define HDMI_SCDC_CR_scdc_en(data)                                   (0x00000001&(data))
+#define HDMI_SCDC_CR_get_scdc_reset(data)                            ((0x00000020&(data))>>5)
+#define HDMI_SCDC_CR_get_dummy980341dc_4_2(data)                     ((0x0000001C&(data))>>2)
+#define HDMI_SCDC_CR_get_maddf(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_SCDC_CR_get_scdc_en(data)                               (0x00000001&(data))
+
+
+#define HDMI_SCDC_PCR                                                0x1e0
+#define HDMI_SCDC_PCR_reg_addr                                       "0x980341e0"
+#define HDMI_SCDC_PCR_reg                                            0x980341e0
+#define HDMI_SCDC_PCR_inst_addr                                      "0x0078"
+#define HDMI_SCDC_PCR_inst                                           0x0078
+#define HDMI_SCDC_PCR_timeout_flag_shift                             (31)
+#define HDMI_SCDC_PCR_timeout_sel_shift                              (29)
+#define HDMI_SCDC_PCR_status_flag_shift                              (28)
+#define HDMI_SCDC_PCR_config_flag_shift                              (27)
+#define HDMI_SCDC_PCR_scrambler_status_flag_shift                    (26)
+#define HDMI_SCDC_PCR_tmds_config_flag_shift                         (25)
+#define HDMI_SCDC_PCR_i2c_scl_dly_sel_shift                          (21)
+#define HDMI_SCDC_PCR_i2c_sda_dly_sel_shift                          (17)
+#define HDMI_SCDC_PCR_i2c_free_num_shift                             (10)
+#define HDMI_SCDC_PCR_rr_retry_sel_shift                             (8)
+#define HDMI_SCDC_PCR_dbnc_level_sel_shift                           (7)
+#define HDMI_SCDC_PCR_dummy980341e0_6_3_shift                        (3)
+#define HDMI_SCDC_PCR_test_rr_added_delay_sel_shift                  (1)
+#define HDMI_SCDC_PCR_apai_shift                                     (0)
+#define HDMI_SCDC_PCR_timeout_flag_mask                              (0x80000000)
+#define HDMI_SCDC_PCR_timeout_sel_mask                               (0x60000000)
+#define HDMI_SCDC_PCR_status_flag_mask                               (0x10000000)
+#define HDMI_SCDC_PCR_config_flag_mask                               (0x08000000)
+#define HDMI_SCDC_PCR_scrambler_status_flag_mask                     (0x04000000)
+#define HDMI_SCDC_PCR_tmds_config_flag_mask                          (0x02000000)
+#define HDMI_SCDC_PCR_i2c_scl_dly_sel_mask                           (0x01E00000)
+#define HDMI_SCDC_PCR_i2c_sda_dly_sel_mask                           (0x001E0000)
+#define HDMI_SCDC_PCR_i2c_free_num_mask                              (0x0001FC00)
+#define HDMI_SCDC_PCR_rr_retry_sel_mask                              (0x00000300)
+#define HDMI_SCDC_PCR_dbnc_level_sel_mask                            (0x00000080)
+#define HDMI_SCDC_PCR_dummy980341e0_6_3_mask                         (0x00000078)
+#define HDMI_SCDC_PCR_test_rr_added_delay_sel_mask                   (0x00000006)
+#define HDMI_SCDC_PCR_apai_mask                                      (0x00000001)
+#define HDMI_SCDC_PCR_timeout_flag(data)                             (0x80000000&((data)<<31))
+#define HDMI_SCDC_PCR_timeout_sel(data)                              (0x60000000&((data)<<29))
+#define HDMI_SCDC_PCR_status_flag(data)                              (0x10000000&((data)<<28))
+#define HDMI_SCDC_PCR_config_flag(data)                              (0x08000000&((data)<<27))
+#define HDMI_SCDC_PCR_scrambler_status_flag(data)                    (0x04000000&((data)<<26))
+#define HDMI_SCDC_PCR_tmds_config_flag(data)                         (0x02000000&((data)<<25))
+#define HDMI_SCDC_PCR_i2c_scl_dly_sel(data)                          (0x01E00000&((data)<<21))
+#define HDMI_SCDC_PCR_i2c_sda_dly_sel(data)                          (0x001E0000&((data)<<17))
+#define HDMI_SCDC_PCR_i2c_free_num(data)                             (0x0001FC00&((data)<<10))
+#define HDMI_SCDC_PCR_rr_retry_sel(data)                             (0x00000300&((data)<<8))
+#define HDMI_SCDC_PCR_dbnc_level_sel(data)                           (0x00000080&((data)<<7))
+#define HDMI_SCDC_PCR_dummy980341e0_6_3(data)                        (0x00000078&((data)<<3))
+#define HDMI_SCDC_PCR_test_rr_added_delay_sel(data)                  (0x00000006&((data)<<1))
+#define HDMI_SCDC_PCR_apai(data)                                     (0x00000001&(data))
+#define HDMI_SCDC_PCR_get_timeout_flag(data)                         ((0x80000000&(data))>>31)
+#define HDMI_SCDC_PCR_get_timeout_sel(data)                          ((0x60000000&(data))>>29)
+#define HDMI_SCDC_PCR_get_status_flag(data)                          ((0x10000000&(data))>>28)
+#define HDMI_SCDC_PCR_get_config_flag(data)                          ((0x08000000&(data))>>27)
+#define HDMI_SCDC_PCR_get_scrambler_status_flag(data)                ((0x04000000&(data))>>26)
+#define HDMI_SCDC_PCR_get_tmds_config_flag(data)                     ((0x02000000&(data))>>25)
+#define HDMI_SCDC_PCR_get_i2c_scl_dly_sel(data)                      ((0x01E00000&(data))>>21)
+#define HDMI_SCDC_PCR_get_i2c_sda_dly_sel(data)                      ((0x001E0000&(data))>>17)
+#define HDMI_SCDC_PCR_get_i2c_free_num(data)                         ((0x0001FC00&(data))>>10)
+#define HDMI_SCDC_PCR_get_rr_retry_sel(data)                         ((0x00000300&(data))>>8)
+#define HDMI_SCDC_PCR_get_dbnc_level_sel(data)                       ((0x00000080&(data))>>7)
+#define HDMI_SCDC_PCR_get_dummy980341e0_6_3(data)                    ((0x00000078&(data))>>3)
+#define HDMI_SCDC_PCR_get_test_rr_added_delay_sel(data)              ((0x00000006&(data))>>1)
+#define HDMI_SCDC_PCR_get_apai(data)                                 (0x00000001&(data))
+
+
+#define HDMI_SCDC_AP                                                 0x1e4
+#define HDMI_SCDC_AP_reg_addr                                        "0x980341e4"
+#define HDMI_SCDC_AP_reg                                             0x980341e4
+#define HDMI_SCDC_AP_inst_addr                                       "0x0079"
+#define HDMI_SCDC_AP_inst                                            0x0079
+#define HDMI_SCDC_AP_ap1_shift                                       (0)
+#define HDMI_SCDC_AP_ap1_mask                                        (0x000000FF)
+#define HDMI_SCDC_AP_ap1(data)                                       (0x000000FF&(data))
+#define HDMI_SCDC_AP_get_ap1(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_SCDC_DP                                                 0x1e8
+#define HDMI_SCDC_DP_reg_addr                                        "0x980341e8"
+#define HDMI_SCDC_DP_reg                                             0x980341e8
+#define HDMI_SCDC_DP_inst_addr                                       "0x007A"
+#define HDMI_SCDC_DP_inst                                            0x007A
+#define HDMI_SCDC_DP_dp1_shift                                       (0)
+#define HDMI_SCDC_DP_dp1_mask                                        (0x000000FF)
+#define HDMI_SCDC_DP_dp1(data)                                       (0x000000FF&(data))
+#define HDMI_SCDC_DP_get_dp1(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_ACDRCLKDETCR                                            0x1ec
+#define HDMI_ACDRCLKDETCR_reg_addr                                   "0x980341ec"
+#define HDMI_ACDRCLKDETCR_reg                                        0x980341ec
+#define HDMI_ACDRCLKDETCR_inst_addr                                  "0x007B"
+#define HDMI_ACDRCLKDETCR_inst                                       0x007B
+#define HDMI_ACDRCLKDETCR_clock_det_en_shift                         (0)
+#define HDMI_ACDRCLKDETCR_clock_det_en_mask                          (0x00000001)
+#define HDMI_ACDRCLKDETCR_clock_det_en(data)                         (0x00000001&(data))
+#define HDMI_ACDRCLKDETCR_get_clock_det_en(data)                     (0x00000001&(data))
+
+
+#define HDMI_ACDRCLKDETSR                                            0x1f0
+#define HDMI_ACDRCLKDETSR_reg_addr                                   "0x980341f0"
+#define HDMI_ACDRCLKDETSR_reg                                        0x980341f0
+#define HDMI_ACDRCLKDETSR_inst_addr                                  "0x007C"
+#define HDMI_ACDRCLKDETSR_inst                                       0x007C
+#define HDMI_ACDRCLKDETSR_en_tmds_chg_irq_shift                      (5)
+#define HDMI_ACDRCLKDETSR_tmds_chg_irq_shift                         (4)
+#define HDMI_ACDRCLKDETSR_dummy980341f0_3_2_shift                    (2)
+#define HDMI_ACDRCLKDETSR_clk_not_in_target_irq_en_shift             (1)
+#define HDMI_ACDRCLKDETSR_clk_not_in_target_shift                    (0)
+#define HDMI_ACDRCLKDETSR_en_tmds_chg_irq_mask                       (0x00000020)
+#define HDMI_ACDRCLKDETSR_tmds_chg_irq_mask                          (0x00000010)
+#define HDMI_ACDRCLKDETSR_dummy980341f0_3_2_mask                     (0x0000000C)
+#define HDMI_ACDRCLKDETSR_clk_not_in_target_irq_en_mask              (0x00000002)
+#define HDMI_ACDRCLKDETSR_clk_not_in_target_mask                     (0x00000001)
+#define HDMI_ACDRCLKDETSR_en_tmds_chg_irq(data)                      (0x00000020&((data)<<5))
+#define HDMI_ACDRCLKDETSR_tmds_chg_irq(data)                         (0x00000010&((data)<<4))
+#define HDMI_ACDRCLKDETSR_dummy980341f0_3_2(data)                    (0x0000000C&((data)<<2))
+#define HDMI_ACDRCLKDETSR_clk_not_in_target_irq_en(data)             (0x00000002&((data)<<1))
+#define HDMI_ACDRCLKDETSR_clk_not_in_target(data)                    (0x00000001&(data))
+#define HDMI_ACDRCLKDETSR_get_en_tmds_chg_irq(data)                  ((0x00000020&(data))>>5)
+#define HDMI_ACDRCLKDETSR_get_tmds_chg_irq(data)                     ((0x00000010&(data))>>4)
+#define HDMI_ACDRCLKDETSR_get_dummy980341f0_3_2(data)                ((0x0000000C&(data))>>2)
+#define HDMI_ACDRCLKDETSR_get_clk_not_in_target_irq_en(data)         ((0x00000002&(data))>>1)
+#define HDMI_ACDRCLKDETSR_get_clk_not_in_target(data)                (0x00000001&(data))
+
+
+#define HDMI_ACDRCLK_SETTING_00                                      0x1f4
+#define HDMI_ACDRCLK_SETTING_00_reg_addr                             "0x980341f4"
+#define HDMI_ACDRCLK_SETTING_00_reg                                  0x980341f4
+#define HDMI_ACDRCLK_SETTING_00_inst_addr                            "0x007D"
+#define HDMI_ACDRCLK_SETTING_00_inst                                 0x007D
+#define HDMI_ACDRCLK_SETTING_00_dclk_cnt_start_shift                 (16)
+#define HDMI_ACDRCLK_SETTING_00_dclk_cnt_end_shift                   (0)
+#define HDMI_ACDRCLK_SETTING_00_dclk_cnt_start_mask                  (0x0FFF0000)
+#define HDMI_ACDRCLK_SETTING_00_dclk_cnt_end_mask                    (0x00000FFF)
+#define HDMI_ACDRCLK_SETTING_00_dclk_cnt_start(data)                 (0x0FFF0000&((data)<<16))
+#define HDMI_ACDRCLK_SETTING_00_dclk_cnt_end(data)                   (0x00000FFF&(data))
+#define HDMI_ACDRCLK_SETTING_00_get_dclk_cnt_start(data)             ((0x0FFF0000&(data))>>16)
+#define HDMI_ACDRCLK_SETTING_00_get_dclk_cnt_end(data)               (0x00000FFF&(data))
+
+
+#define HDMI_ACDRCLK_SETTING_01                                      0x1f8
+#define HDMI_ACDRCLK_SETTING_01_reg_addr                             "0x980341f8"
+#define HDMI_ACDRCLK_SETTING_01_reg                                  0x980341f8
+#define HDMI_ACDRCLK_SETTING_01_inst_addr                            "0x007E"
+#define HDMI_ACDRCLK_SETTING_01_inst                                 0x007E
+#define HDMI_ACDRCLK_SETTING_01_target_for_maximum_clk_counter_shift (16)
+#define HDMI_ACDRCLK_SETTING_01_target_for_minimum_clk_counter_shift (0)
+#define HDMI_ACDRCLK_SETTING_01_target_for_maximum_clk_counter_mask  (0x0FFF0000)
+#define HDMI_ACDRCLK_SETTING_01_target_for_minimum_clk_counter_mask  (0x00000FFF)
+#define HDMI_ACDRCLK_SETTING_01_target_for_maximum_clk_counter(data) (0x0FFF0000&((data)<<16))
+#define HDMI_ACDRCLK_SETTING_01_target_for_minimum_clk_counter(data) (0x00000FFF&(data))
+#define HDMI_ACDRCLK_SETTING_01_get_target_for_maximum_clk_counter(data)  ((0x0FFF0000&(data))>>16)
+#define HDMI_ACDRCLK_SETTING_01_get_target_for_minimum_clk_counter(data)  (0x00000FFF&(data))
+
+
+#define HDMI_ACDRCLK_SETTING_02                                      0x1fc
+#define HDMI_ACDRCLK_SETTING_02_reg_addr                             "0x980341fc"
+#define HDMI_ACDRCLK_SETTING_02_reg                                  0x980341fc
+#define HDMI_ACDRCLK_SETTING_02_inst_addr                            "0x007F"
+#define HDMI_ACDRCLK_SETTING_02_inst                                 0x007F
+#define HDMI_ACDRCLK_SETTING_02_clk_counter_err_threshold_shift      (8)
+#define HDMI_ACDRCLK_SETTING_02_clk_counter_debounce_shift           (0)
+#define HDMI_ACDRCLK_SETTING_02_clk_counter_err_threshold_mask       (0x00000F00)
+#define HDMI_ACDRCLK_SETTING_02_clk_counter_debounce_mask            (0x000000FF)
+#define HDMI_ACDRCLK_SETTING_02_clk_counter_err_threshold(data)      (0x00000F00&((data)<<8))
+#define HDMI_ACDRCLK_SETTING_02_clk_counter_debounce(data)           (0x000000FF&(data))
+#define HDMI_ACDRCLK_SETTING_02_get_clk_counter_err_threshold(data)  ((0x00000F00&(data))>>8)
+#define HDMI_ACDRCLK_SETTING_02_get_clk_counter_debounce(data)       (0x000000FF&(data))
+
+
+#define HDMI_HDCP_BIST                                               0x200
+#define HDMI_HDCP_BIST_reg_addr                                      "0x98034200"
+#define HDMI_HDCP_BIST_reg                                           0x98034200
+#define HDMI_HDCP_BIST_inst_addr                                     "0x0080"
+#define HDMI_HDCP_BIST_inst                                          0x0080
+
+
+#define HDMI_HDCP_CR                                                 0x204
+#define HDMI_HDCP_CR_reg_addr                                        "0x98034204"
+#define HDMI_HDCP_CR_reg                                             0x98034204
+#define HDMI_HDCP_CR_inst_addr                                       "0x0081"
+#define HDMI_HDCP_CR_inst                                            0x0081
+#define HDMI_HDCP_CR_enc_window_end_shift                            (20)
+#define HDMI_HDCP_CR_enc_window_start_shift                          (10)
+#define HDMI_HDCP_CR_hdcp_clk_switch_auto_shift                      (9)
+#define HDMI_HDCP_CR_hdcp_clk_sel_fw_shift                           (8)
+#define HDMI_HDCP_CR_namfe_shift                                     (7)
+#define HDMI_HDCP_CR_rpt_shift                                       (6)
+#define HDMI_HDCP_CR_ivsp_shift                                      (5)
+#define HDMI_HDCP_CR_invvs_shift                                     (4)
+#define HDMI_HDCP_CR_ivspm_shift                                     (3)
+#define HDMI_HDCP_CR_maddf_shift                                     (2)
+#define HDMI_HDCP_CR_dkapde_shift                                    (1)
+#define HDMI_HDCP_CR_hdcp_en_shift                                   (0)
+#define HDMI_HDCP_CR_enc_window_end_mask                             (0x1FF00000)
+#define HDMI_HDCP_CR_enc_window_start_mask                           (0x000FFC00)
+#define HDMI_HDCP_CR_hdcp_clk_switch_auto_mask                       (0x00000200)
+#define HDMI_HDCP_CR_hdcp_clk_sel_fw_mask                            (0x00000100)
+#define HDMI_HDCP_CR_namfe_mask                                      (0x00000080)
+#define HDMI_HDCP_CR_rpt_mask                                        (0x00000040)
+#define HDMI_HDCP_CR_ivsp_mask                                       (0x00000020)
+#define HDMI_HDCP_CR_invvs_mask                                      (0x00000010)
+#define HDMI_HDCP_CR_ivspm_mask                                      (0x00000008)
+#define HDMI_HDCP_CR_maddf_mask                                      (0x00000004)
+#define HDMI_HDCP_CR_dkapde_mask                                     (0x00000002)
+#define HDMI_HDCP_CR_hdcp_en_mask                                    (0x00000001)
+#define HDMI_HDCP_CR_enc_window_end(data)                            (0x1FF00000&((data)<<20))
+#define HDMI_HDCP_CR_enc_window_start(data)                          (0x000FFC00&((data)<<10))
+#define HDMI_HDCP_CR_hdcp_clk_switch_auto(data)                      (0x00000200&((data)<<9))
+#define HDMI_HDCP_CR_hdcp_clk_sel_fw(data)                           (0x00000100&((data)<<8))
+#define HDMI_HDCP_CR_namfe(data)                                     (0x00000080&((data)<<7))
+#define HDMI_HDCP_CR_rpt(data)                                       (0x00000040&((data)<<6))
+#define HDMI_HDCP_CR_ivsp(data)                                      (0x00000020&((data)<<5))
+#define HDMI_HDCP_CR_invvs(data)                                     (0x00000010&((data)<<4))
+#define HDMI_HDCP_CR_ivspm(data)                                     (0x00000008&((data)<<3))
+#define HDMI_HDCP_CR_maddf(data)                                     (0x00000004&((data)<<2))
+#define HDMI_HDCP_CR_dkapde(data)                                    (0x00000002&((data)<<1))
+#define HDMI_HDCP_CR_hdcp_en(data)                                   (0x00000001&(data))
+#define HDMI_HDCP_CR_get_enc_window_end(data)                        ((0x1FF00000&(data))>>20)
+#define HDMI_HDCP_CR_get_enc_window_start(data)                      ((0x000FFC00&(data))>>10)
+#define HDMI_HDCP_CR_get_hdcp_clk_switch_auto(data)                  ((0x00000200&(data))>>9)
+#define HDMI_HDCP_CR_get_hdcp_clk_sel_fw(data)                       ((0x00000100&(data))>>8)
+#define HDMI_HDCP_CR_get_namfe(data)                                 ((0x00000080&(data))>>7)
+#define HDMI_HDCP_CR_get_rpt(data)                                   ((0x00000040&(data))>>6)
+#define HDMI_HDCP_CR_get_ivsp(data)                                  ((0x00000020&(data))>>5)
+#define HDMI_HDCP_CR_get_invvs(data)                                 ((0x00000010&(data))>>4)
+#define HDMI_HDCP_CR_get_ivspm(data)                                 ((0x00000008&(data))>>3)
+#define HDMI_HDCP_CR_get_maddf(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_HDCP_CR_get_dkapde(data)                                ((0x00000002&(data))>>1)
+#define HDMI_HDCP_CR_get_hdcp_en(data)                               (0x00000001&(data))
+
+
+#define HDMI_HDCP_DKAP                                               0x208
+#define HDMI_HDCP_DKAP_reg_addr                                      "0x98034208"
+#define HDMI_HDCP_DKAP_reg                                           0x98034208
+#define HDMI_HDCP_DKAP_inst_addr                                     "0x0082"
+#define HDMI_HDCP_DKAP_inst                                          0x0082
+#define HDMI_HDCP_DKAP_dkap_shift                                    (0)
+#define HDMI_HDCP_DKAP_dkap_mask                                     (0x000000FF)
+#define HDMI_HDCP_DKAP_dkap(data)                                    (0x000000FF&(data))
+#define HDMI_HDCP_DKAP_get_dkap(data)                                (0x000000FF&(data))
+#define HDMI_set_PORT0_HDCP_DKAP_reg(data)   (*((volatile unsigned int*) HDCP_DKAP_reg)=data)
+#define HDMI_get_PORT0_HDCP_DKAP_reg   (*((volatile unsigned int*) HDCP_DKAP_reg))
+
+
+#define HDMI_HDCP_PCR                                                0x20c
+#define HDMI_HDCP_PCR_reg_addr                                       "0x9803420c"
+#define HDMI_HDCP_PCR_reg                                            0x9803420c
+#define HDMI_HDCP_PCR_inst_addr                                      "0x0083"
+#define HDMI_HDCP_PCR_inst                                           0x0083
+#define HDMI_HDCP_PCR_iic_st_shift                                   (28)
+#define HDMI_HDCP_PCR_i2c_scl_dly_sel_shift                          (24)
+#define HDMI_HDCP_PCR_i2c_sda_dly_sel_shift                          (20)
+#define HDMI_HDCP_PCR_tune_up_down_shift                             (17)
+#define HDMI_HDCP_PCR_tune_range_shift                               (10)
+#define HDMI_HDCP_PCR_ddcdbnc_shift                                  (9)
+#define HDMI_HDCP_PCR_dvi_enc_mode_shift                             (8)
+#define HDMI_HDCP_PCR_dbnc_level_sel_shift                           (7)
+#define HDMI_HDCP_PCR_km_clk_sel_shift                               (6)
+#define HDMI_HDCP_PCR_hdcp_vs_sel_shift                              (5)
+#define HDMI_HDCP_PCR_enc_tog_shift                                  (4)
+#define HDMI_HDCP_PCR_avmute_dis_shift                               (3)
+#define HDMI_HDCP_PCR_km_start_sel_shift                             (2)
+#define HDMI_HDCP_PCR_apai_type_shift                                (1)
+#define HDMI_HDCP_PCR_apai_shift                                     (0)
+#define HDMI_HDCP_PCR_iic_st_mask                                    (0x70000000)
+#define HDMI_HDCP_PCR_i2c_scl_dly_sel_mask                           (0x0F000000)
+#define HDMI_HDCP_PCR_i2c_sda_dly_sel_mask                           (0x00F00000)
+#define HDMI_HDCP_PCR_tune_up_down_mask                              (0x00020000)
+#define HDMI_HDCP_PCR_tune_range_mask                                (0x0001FC00)
+#define HDMI_HDCP_PCR_ddcdbnc_mask                                   (0x00000200)
+#define HDMI_HDCP_PCR_dvi_enc_mode_mask                              (0x00000100)
+#define HDMI_HDCP_PCR_dbnc_level_sel_mask                            (0x00000080)
+#define HDMI_HDCP_PCR_km_clk_sel_mask                                (0x00000040)
+#define HDMI_HDCP_PCR_hdcp_vs_sel_mask                               (0x00000020)
+#define HDMI_HDCP_PCR_enc_tog_mask                                   (0x00000010)
+#define HDMI_HDCP_PCR_avmute_dis_mask                                (0x00000008)
+#define HDMI_HDCP_PCR_km_start_sel_mask                              (0x00000004)
+#define HDMI_HDCP_PCR_apai_type_mask                                 (0x00000002)
+#define HDMI_HDCP_PCR_apai_mask                                      (0x00000001)
+#define HDMI_HDCP_PCR_iic_st(data)                                   (0x70000000&((data)<<28))
+#define HDMI_HDCP_PCR_i2c_scl_dly_sel(data)                          (0x0F000000&((data)<<24))
+#define HDMI_HDCP_PCR_i2c_sda_dly_sel(data)                          (0x00F00000&((data)<<20))
+#define HDMI_HDCP_PCR_tune_up_down(data)                             (0x00020000&((data)<<17))
+#define HDMI_HDCP_PCR_tune_range(data)                               (0x0001FC00&((data)<<10))
+#define HDMI_HDCP_PCR_ddcdbnc(data)                                  (0x00000200&((data)<<9))
+#define HDMI_HDCP_PCR_dvi_enc_mode(data)                             (0x00000100&((data)<<8))
+#define HDMI_HDCP_PCR_dbnc_level_sel(data)                           (0x00000080&((data)<<7))
+#define HDMI_HDCP_PCR_km_clk_sel(data)                               (0x00000040&((data)<<6))
+#define HDMI_HDCP_PCR_hdcp_vs_sel(data)                              (0x00000020&((data)<<5))
+#define HDMI_HDCP_PCR_enc_tog(data)                                  (0x00000010&((data)<<4))
+#define HDMI_HDCP_PCR_avmute_dis(data)                               (0x00000008&((data)<<3))
+#define HDMI_HDCP_PCR_km_start_sel(data)                             (0x00000004&((data)<<2))
+#define HDMI_HDCP_PCR_apai_type(data)                                (0x00000002&((data)<<1))
+#define HDMI_HDCP_PCR_apai(data)                                     (0x00000001&(data))
+#define HDMI_HDCP_PCR_get_iic_st(data)                               ((0x70000000&(data))>>28)
+#define HDMI_HDCP_PCR_get_i2c_scl_dly_sel(data)                      ((0x0F000000&(data))>>24)
+#define HDMI_HDCP_PCR_get_i2c_sda_dly_sel(data)                      ((0x00F00000&(data))>>20)
+#define HDMI_HDCP_PCR_get_tune_up_down(data)                         ((0x00020000&(data))>>17)
+#define HDMI_HDCP_PCR_get_tune_range(data)                           ((0x0001FC00&(data))>>10)
+#define HDMI_HDCP_PCR_get_ddcdbnc(data)                              ((0x00000200&(data))>>9)
+#define HDMI_HDCP_PCR_get_dvi_enc_mode(data)                         ((0x00000100&(data))>>8)
+#define HDMI_HDCP_PCR_get_dbnc_level_sel(data)                       ((0x00000080&(data))>>7)
+#define HDMI_HDCP_PCR_get_km_clk_sel(data)                           ((0x00000040&(data))>>6)
+#define HDMI_HDCP_PCR_get_hdcp_vs_sel(data)                          ((0x00000020&(data))>>5)
+#define HDMI_HDCP_PCR_get_enc_tog(data)                              ((0x00000010&(data))>>4)
+#define HDMI_HDCP_PCR_get_avmute_dis(data)                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_PCR_get_km_start_sel(data)                         ((0x00000004&(data))>>2)
+#define HDMI_HDCP_PCR_get_apai_type(data)                            ((0x00000002&(data))>>1)
+#define HDMI_HDCP_PCR_get_apai(data)                                 (0x00000001&(data))
+
+
+#define HDMI_HDCP_FLAG1                                              0x210
+#define HDMI_HDCP_FLAG1_reg_addr                                     "0x98034210"
+#define HDMI_HDCP_FLAG1_reg                                          0x98034210
+#define HDMI_HDCP_FLAG1_inst_addr                                    "0x0084"
+#define HDMI_HDCP_FLAG1_inst                                         0x0084
+#define HDMI_HDCP_FLAG1_akm_flag_shift                               (8)
+#define HDMI_HDCP_FLAG1_adne_flag_shift                              (7)
+#define HDMI_HDCP_FLAG1_ence_flag_shift                              (6)
+#define HDMI_HDCP_FLAG1_nc_flag_shift                                (5)
+#define HDMI_HDCP_FLAG1_wr_aksv_flag_shift                           (4)
+#define HDMI_HDCP_FLAG1_rd_bcap_flag_shift                           (3)
+#define HDMI_HDCP_FLAG1_rd_ri_flag_shift                             (2)
+#define HDMI_HDCP_FLAG1_rd_bksv_flag_shift                           (1)
+#define HDMI_HDCP_FLAG1_dummy98034210_0_shift                        (0)
+#define HDMI_HDCP_FLAG1_akm_flag_mask                                (0x00000100)
+#define HDMI_HDCP_FLAG1_adne_flag_mask                               (0x00000080)
+#define HDMI_HDCP_FLAG1_ence_flag_mask                               (0x00000040)
+#define HDMI_HDCP_FLAG1_nc_flag_mask                                 (0x00000020)
+#define HDMI_HDCP_FLAG1_wr_aksv_flag_mask                            (0x00000010)
+#define HDMI_HDCP_FLAG1_rd_bcap_flag_mask                            (0x00000008)
+#define HDMI_HDCP_FLAG1_rd_ri_flag_mask                              (0x00000004)
+#define HDMI_HDCP_FLAG1_rd_bksv_flag_mask                            (0x00000002)
+#define HDMI_HDCP_FLAG1_dummy98034210_0_mask                         (0x00000001)
+#define HDMI_HDCP_FLAG1_akm_flag(data)                               (0x00000100&((data)<<8))
+#define HDMI_HDCP_FLAG1_adne_flag(data)                              (0x00000080&((data)<<7))
+#define HDMI_HDCP_FLAG1_ence_flag(data)                              (0x00000040&((data)<<6))
+#define HDMI_HDCP_FLAG1_nc_flag(data)                                (0x00000020&((data)<<5))
+#define HDMI_HDCP_FLAG1_wr_aksv_flag(data)                           (0x00000010&((data)<<4))
+#define HDMI_HDCP_FLAG1_rd_bcap_flag(data)                           (0x00000008&((data)<<3))
+#define HDMI_HDCP_FLAG1_rd_ri_flag(data)                             (0x00000004&((data)<<2))
+#define HDMI_HDCP_FLAG1_rd_bksv_flag(data)                           (0x00000002&((data)<<1))
+#define HDMI_HDCP_FLAG1_dummy98034210_0(data)                        (0x00000001&(data))
+#define HDMI_HDCP_FLAG1_get_akm_flag(data)                           ((0x00000100&(data))>>8)
+#define HDMI_HDCP_FLAG1_get_adne_flag(data)                          ((0x00000080&(data))>>7)
+#define HDMI_HDCP_FLAG1_get_ence_flag(data)                          ((0x00000040&(data))>>6)
+#define HDMI_HDCP_FLAG1_get_nc_flag(data)                            ((0x00000020&(data))>>5)
+#define HDMI_HDCP_FLAG1_get_wr_aksv_flag(data)                       ((0x00000010&(data))>>4)
+#define HDMI_HDCP_FLAG1_get_rd_bcap_flag(data)                       ((0x00000008&(data))>>3)
+#define HDMI_HDCP_FLAG1_get_rd_ri_flag(data)                         ((0x00000004&(data))>>2)
+#define HDMI_HDCP_FLAG1_get_rd_bksv_flag(data)                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_FLAG1_get_dummy98034210_0(data)                    (0x00000001&(data))
+
+
+#define HDMI_HDCP_FLAG2                                              0x214
+#define HDMI_HDCP_FLAG2_reg_addr                                     "0x98034214"
+#define HDMI_HDCP_FLAG2_reg                                          0x98034214
+#define HDMI_HDCP_FLAG2_inst_addr                                    "0x0085"
+#define HDMI_HDCP_FLAG2_inst                                         0x0085
+#define HDMI_HDCP_FLAG2_irq_akm_en_shift                             (8)
+#define HDMI_HDCP_FLAG2_irq_adne_en_shift                            (7)
+#define HDMI_HDCP_FLAG2_irq_ence_en_shift                            (6)
+#define HDMI_HDCP_FLAG2_irq_nc_en_shift                              (5)
+#define HDMI_HDCP_FLAG2_irq_aksv_en_shift                            (4)
+#define HDMI_HDCP_FLAG2_irq_bcap_en_shift                            (3)
+#define HDMI_HDCP_FLAG2_irq_ri_en_shift                              (2)
+#define HDMI_HDCP_FLAG2_irq_bksv_en_shift                            (1)
+#define HDMI_HDCP_FLAG2_dummy98034214_0_shift                        (0)
+#define HDMI_HDCP_FLAG2_irq_akm_en_mask                              (0x00000100)
+#define HDMI_HDCP_FLAG2_irq_adne_en_mask                             (0x00000080)
+#define HDMI_HDCP_FLAG2_irq_ence_en_mask                             (0x00000040)
+#define HDMI_HDCP_FLAG2_irq_nc_en_mask                               (0x00000020)
+#define HDMI_HDCP_FLAG2_irq_aksv_en_mask                             (0x00000010)
+#define HDMI_HDCP_FLAG2_irq_bcap_en_mask                             (0x00000008)
+#define HDMI_HDCP_FLAG2_irq_ri_en_mask                               (0x00000004)
+#define HDMI_HDCP_FLAG2_irq_bksv_en_mask                             (0x00000002)
+#define HDMI_HDCP_FLAG2_dummy98034214_0_mask                         (0x00000001)
+#define HDMI_HDCP_FLAG2_irq_akm_en(data)                             (0x00000100&((data)<<8))
+#define HDMI_HDCP_FLAG2_irq_adne_en(data)                            (0x00000080&((data)<<7))
+#define HDMI_HDCP_FLAG2_irq_ence_en(data)                            (0x00000040&((data)<<6))
+#define HDMI_HDCP_FLAG2_irq_nc_en(data)                              (0x00000020&((data)<<5))
+#define HDMI_HDCP_FLAG2_irq_aksv_en(data)                            (0x00000010&((data)<<4))
+#define HDMI_HDCP_FLAG2_irq_bcap_en(data)                            (0x00000008&((data)<<3))
+#define HDMI_HDCP_FLAG2_irq_ri_en(data)                              (0x00000004&((data)<<2))
+#define HDMI_HDCP_FLAG2_irq_bksv_en(data)                            (0x00000002&((data)<<1))
+#define HDMI_HDCP_FLAG2_dummy98034214_0(data)                        (0x00000001&(data))
+#define HDMI_HDCP_FLAG2_get_irq_akm_en(data)                         ((0x00000100&(data))>>8)
+#define HDMI_HDCP_FLAG2_get_irq_adne_en(data)                        ((0x00000080&(data))>>7)
+#define HDMI_HDCP_FLAG2_get_irq_ence_en(data)                        ((0x00000040&(data))>>6)
+#define HDMI_HDCP_FLAG2_get_irq_nc_en(data)                          ((0x00000020&(data))>>5)
+#define HDMI_HDCP_FLAG2_get_irq_aksv_en(data)                        ((0x00000010&(data))>>4)
+#define HDMI_HDCP_FLAG2_get_irq_bcap_en(data)                        ((0x00000008&(data))>>3)
+#define HDMI_HDCP_FLAG2_get_irq_ri_en(data)                          ((0x00000004&(data))>>2)
+#define HDMI_HDCP_FLAG2_get_irq_bksv_en(data)                        ((0x00000002&(data))>>1)
+#define HDMI_HDCP_FLAG2_get_dummy98034214_0(data)                    (0x00000001&(data))
+
+
+#define HDMI_HDCP_AP                                                 0x218
+#define HDMI_HDCP_AP_reg_addr                                        "0x98034218"
+#define HDMI_HDCP_AP_reg                                             0x98034218
+#define HDMI_HDCP_AP_inst_addr                                       "0x0086"
+#define HDMI_HDCP_AP_inst                                            0x0086
+#define HDMI_HDCP_AP_ksvfifo_status_shift                            (18)
+#define HDMI_HDCP_AP_dp_ksvfifo_ptr_shift                            (8)
+#define HDMI_HDCP_AP_ap1_shift                                       (0)
+#define HDMI_HDCP_AP_ksvfifo_status_mask                             (0x00040000)
+#define HDMI_HDCP_AP_dp_ksvfifo_ptr_mask                             (0x0003FF00)
+#define HDMI_HDCP_AP_ap1_mask                                        (0x000000FF)
+#define HDMI_HDCP_AP_ksvfifo_status(data)                            (0x00040000&((data)<<18))
+#define HDMI_HDCP_AP_dp_ksvfifo_ptr(data)                            (0x0003FF00&((data)<<8))
+#define HDMI_HDCP_AP_ap1(data)                                       (0x000000FF&(data))
+#define HDMI_HDCP_AP_get_ksvfifo_status(data)                        ((0x00040000&(data))>>18)
+#define HDMI_HDCP_AP_get_dp_ksvfifo_ptr(data)                        ((0x0003FF00&(data))>>8)
+#define HDMI_HDCP_AP_get_ap1(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_HDCP_DP                                                 0x21c
+#define HDMI_HDCP_DP_reg_addr                                        "0x9803421c"
+#define HDMI_HDCP_DP_reg                                             0x9803421c
+#define HDMI_HDCP_DP_inst_addr                                       "0x0087"
+#define HDMI_HDCP_DP_inst                                            0x0087
+#define HDMI_HDCP_DP_dp1_shift                                       (0)
+#define HDMI_HDCP_DP_dp1_mask                                        (0x000000FF)
+#define HDMI_HDCP_DP_dp1(data)                                       (0x000000FF&(data))
+#define HDMI_HDCP_DP_get_dp1(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_HDCP_2P2_CR                                             0x220
+#define HDMI_HDCP_2P2_CR_reg_addr                                    "0x98034220"
+#define HDMI_HDCP_2P2_CR_reg                                         0x98034220
+#define HDMI_HDCP_2P2_CR_inst_addr                                   "0x0088"
+#define HDMI_HDCP_2P2_CR_inst                                        0x0088
+#define HDMI_HDCP_2P2_CR_dummy98034220_31_28_shift                   (28)
+#define HDMI_HDCP_2P2_CR_enable_reauth_shift                         (27)
+#define HDMI_HDCP_2P2_CR_fn_auto_inc_shift                           (26)
+#define HDMI_HDCP_2P2_CR_apply_cp_fn_shift                           (25)
+#define HDMI_HDCP_2P2_CR_ks_encoded_shift                            (24)
+#define HDMI_HDCP_2P2_CR_switch_state_shift                          (12)
+#define HDMI_HDCP_2P2_CR_rpt_thr_unauth_shift                        (11)
+#define HDMI_HDCP_2P2_CR_fw_mode_riv_shift                           (10)
+#define HDMI_HDCP_2P2_CR_apply_state_shift                           (9)
+#define HDMI_HDCP_2P2_CR_mspai_shift                                 (8)
+#define HDMI_HDCP_2P2_CR_new_auth_device_shift                       (7)
+#define HDMI_HDCP_2P2_CR_verify_id_pass_shift                        (6)
+#define HDMI_HDCP_2P2_CR_verify_id_done_shift                        (5)
+#define HDMI_HDCP_2P2_CR_assemble_id_fail_shift                      (4)
+#define HDMI_HDCP_2P2_CR_downstream_done_shift                       (3)
+#define HDMI_HDCP_2P2_CR_ks_done_shift                               (2)
+#define HDMI_HDCP_2P2_CR_switch_unauth_shift                         (1)
+#define HDMI_HDCP_2P2_CR_hdcp_2p2_en_shift                           (0)
+#define HDMI_HDCP_2P2_CR_dummy98034220_31_28_mask                    (0xF0000000)
+#define HDMI_HDCP_2P2_CR_enable_reauth_mask                          (0x08000000)
+#define HDMI_HDCP_2P2_CR_fn_auto_inc_mask                            (0x04000000)
+#define HDMI_HDCP_2P2_CR_apply_cp_fn_mask                            (0x02000000)
+#define HDMI_HDCP_2P2_CR_ks_encoded_mask                             (0x01000000)
+#define HDMI_HDCP_2P2_CR_switch_state_mask                           (0x00FFF000)
+#define HDMI_HDCP_2P2_CR_rpt_thr_unauth_mask                         (0x00000800)
+#define HDMI_HDCP_2P2_CR_fw_mode_riv_mask                            (0x00000400)
+#define HDMI_HDCP_2P2_CR_apply_state_mask                            (0x00000200)
+#define HDMI_HDCP_2P2_CR_mspai_mask                                  (0x00000100)
+#define HDMI_HDCP_2P2_CR_new_auth_device_mask                        (0x00000080)
+#define HDMI_HDCP_2P2_CR_verify_id_pass_mask                         (0x00000040)
+#define HDMI_HDCP_2P2_CR_verify_id_done_mask                         (0x00000020)
+#define HDMI_HDCP_2P2_CR_assemble_id_fail_mask                       (0x00000010)
+#define HDMI_HDCP_2P2_CR_downstream_done_mask                        (0x00000008)
+#define HDMI_HDCP_2P2_CR_ks_done_mask                                (0x00000004)
+#define HDMI_HDCP_2P2_CR_switch_unauth_mask                          (0x00000002)
+#define HDMI_HDCP_2P2_CR_hdcp_2p2_en_mask                            (0x00000001)
+#define HDMI_HDCP_2P2_CR_dummy98034220_31_28(data)                   (0xF0000000&((data)<<28))
+#define HDMI_HDCP_2P2_CR_enable_reauth(data)                         (0x08000000&((data)<<27))
+#define HDMI_HDCP_2P2_CR_fn_auto_inc(data)                           (0x04000000&((data)<<26))
+#define HDMI_HDCP_2P2_CR_apply_cp_fn(data)                           (0x02000000&((data)<<25))
+#define HDMI_HDCP_2P2_CR_ks_encoded(data)                            (0x01000000&((data)<<24))
+#define HDMI_HDCP_2P2_CR_switch_state(data)                          (0x00FFF000&((data)<<12))
+#define HDMI_HDCP_2P2_CR_rpt_thr_unauth(data)                        (0x00000800&((data)<<11))
+#define HDMI_HDCP_2P2_CR_fw_mode_riv(data)                           (0x00000400&((data)<<10))
+#define HDMI_HDCP_2P2_CR_apply_state(data)                           (0x00000200&((data)<<9))
+#define HDMI_HDCP_2P2_CR_mspai(data)                                 (0x00000100&((data)<<8))
+#define HDMI_HDCP_2P2_CR_new_auth_device(data)                       (0x00000080&((data)<<7))
+#define HDMI_HDCP_2P2_CR_verify_id_pass(data)                        (0x00000040&((data)<<6))
+#define HDMI_HDCP_2P2_CR_verify_id_done(data)                        (0x00000020&((data)<<5))
+#define HDMI_HDCP_2P2_CR_assemble_id_fail(data)                      (0x00000010&((data)<<4))
+#define HDMI_HDCP_2P2_CR_downstream_done(data)                       (0x00000008&((data)<<3))
+#define HDMI_HDCP_2P2_CR_ks_done(data)                               (0x00000004&((data)<<2))
+#define HDMI_HDCP_2P2_CR_switch_unauth(data)                         (0x00000002&((data)<<1))
+#define HDMI_HDCP_2P2_CR_hdcp_2p2_en(data)                           (0x00000001&(data))
+#define HDMI_HDCP_2P2_CR_get_dummy98034220_31_28(data)               ((0xF0000000&(data))>>28)
+#define HDMI_HDCP_2P2_CR_get_enable_reauth(data)                     ((0x08000000&(data))>>27)
+#define HDMI_HDCP_2P2_CR_get_fn_auto_inc(data)                       ((0x04000000&(data))>>26)
+#define HDMI_HDCP_2P2_CR_get_apply_cp_fn(data)                       ((0x02000000&(data))>>25)
+#define HDMI_HDCP_2P2_CR_get_ks_encoded(data)                        ((0x01000000&(data))>>24)
+#define HDMI_HDCP_2P2_CR_get_switch_state(data)                      ((0x00FFF000&(data))>>12)
+#define HDMI_HDCP_2P2_CR_get_rpt_thr_unauth(data)                    ((0x00000800&(data))>>11)
+#define HDMI_HDCP_2P2_CR_get_fw_mode_riv(data)                       ((0x00000400&(data))>>10)
+#define HDMI_HDCP_2P2_CR_get_apply_state(data)                       ((0x00000200&(data))>>9)
+#define HDMI_HDCP_2P2_CR_get_mspai(data)                             ((0x00000100&(data))>>8)
+#define HDMI_HDCP_2P2_CR_get_new_auth_device(data)                   ((0x00000080&(data))>>7)
+#define HDMI_HDCP_2P2_CR_get_verify_id_pass(data)                    ((0x00000040&(data))>>6)
+#define HDMI_HDCP_2P2_CR_get_verify_id_done(data)                    ((0x00000020&(data))>>5)
+#define HDMI_HDCP_2P2_CR_get_assemble_id_fail(data)                  ((0x00000010&(data))>>4)
+#define HDMI_HDCP_2P2_CR_get_downstream_done(data)                   ((0x00000008&(data))>>3)
+#define HDMI_HDCP_2P2_CR_get_ks_done(data)                           ((0x00000004&(data))>>2)
+#define HDMI_HDCP_2P2_CR_get_switch_unauth(data)                     ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2P2_CR_get_hdcp_2p2_en(data)                       (0x00000001&(data))
+
+
+#define HDMI_HDCP_2P2_KS0                                            0x224
+#define HDMI_HDCP_2P2_KS0_reg_addr                                   "0x98034224"
+#define HDMI_HDCP_2P2_KS0_reg                                        0x98034224
+#define HDMI_HDCP_2P2_KS0_inst_addr                                  "0x0089"
+#define HDMI_HDCP_2P2_KS0_inst                                       0x0089
+#define HDMI_HDCP_2P2_KS0_ks_shift                                   (0)
+#define HDMI_HDCP_2P2_KS0_ks_mask                                    (0xFFFFFFFF)
+#define HDMI_HDCP_2P2_KS0_ks(data)                                   (0xFFFFFFFF&(data))
+#define HDMI_HDCP_2P2_KS0_get_ks(data)                               (0xFFFFFFFF&(data))
+#define HDMI_set_PORT0_HDCP_2P2_KS0_reg(data)   (*((volatile unsigned int*) HDCP_2P2_KS0_reg)=data)
+#define HDMI_get_PORT0_HDCP_2P2_KS0_reg   (*((volatile unsigned int*) HDCP_2P2_KS0_reg))
+
+
+#define HDMI_HDCP_2P2_KS1                                            0x228
+#define HDMI_HDCP_2P2_KS1_reg_addr                                   "0x98034228"
+#define HDMI_HDCP_2P2_KS1_reg                                        0x98034228
+#define HDMI_HDCP_2P2_KS1_inst_addr                                  "0x008A"
+#define HDMI_HDCP_2P2_KS1_inst                                       0x008A
+#define HDMI_HDCP_2P2_KS1_ks_shift                                   (0)
+#define HDMI_HDCP_2P2_KS1_ks_mask                                    (0xFFFFFFFF)
+#define HDMI_HDCP_2P2_KS1_ks(data)                                   (0xFFFFFFFF&(data))
+#define HDMI_HDCP_2P2_KS1_get_ks(data)                               (0xFFFFFFFF&(data))
+#define HDMI_set_PORT0_HDCP_2P2_KS1_reg(data)   (*((volatile unsigned int*) HDCP_2P2_KS1_reg)=data)
+#define HDMI_get_PORT0_HDCP_2P2_KS1_reg   (*((volatile unsigned int*) HDCP_2P2_KS1_reg))
+
+
+#define HDMI_HDCP_2P2_KS2                                            0x22c
+#define HDMI_HDCP_2P2_KS2_reg_addr                                   "0x9803422c"
+#define HDMI_HDCP_2P2_KS2_reg                                        0x9803422c
+#define HDMI_HDCP_2P2_KS2_inst_addr                                  "0x008B"
+#define HDMI_HDCP_2P2_KS2_inst                                       0x008B
+#define HDMI_HDCP_2P2_KS2_ks_shift                                   (0)
+#define HDMI_HDCP_2P2_KS2_ks_mask                                    (0xFFFFFFFF)
+#define HDMI_HDCP_2P2_KS2_ks(data)                                   (0xFFFFFFFF&(data))
+#define HDMI_HDCP_2P2_KS2_get_ks(data)                               (0xFFFFFFFF&(data))
+#define HDMI_set_PORT0_HDCP_2P2_KS2_reg(data)   (*((volatile unsigned int*) HDCP_2P2_KS2_reg)=data)
+#define HDMI_get_PORT0_HDCP_2P2_KS2_reg   (*((volatile unsigned int*) HDCP_2P2_KS2_reg))
+
+
+#define HDMI_HDCP_2P2_KS3                                            0x230
+#define HDMI_HDCP_2P2_KS3_reg_addr                                   "0x98034230"
+#define HDMI_HDCP_2P2_KS3_reg                                        0x98034230
+#define HDMI_HDCP_2P2_KS3_inst_addr                                  "0x008C"
+#define HDMI_HDCP_2P2_KS3_inst                                       0x008C
+#define HDMI_HDCP_2P2_KS3_ks_shift                                   (0)
+#define HDMI_HDCP_2P2_KS3_ks_mask                                    (0xFFFFFFFF)
+#define HDMI_HDCP_2P2_KS3_ks(data)                                   (0xFFFFFFFF&(data))
+#define HDMI_HDCP_2P2_KS3_get_ks(data)                               (0xFFFFFFFF&(data))
+#define HDMI_set_PORT0_HDCP_2P2_KS3_reg(data)   (*((volatile unsigned int*) HDCP_2P2_KS3_reg)=data)
+#define HDMI_get_PORT0_HDCP_2P2_KS3_reg   (*((volatile unsigned int*) HDCP_2P2_KS3_reg))
+
+
+#define HDMI_HDCP_2P2_LC0                                            0x234
+#define HDMI_HDCP_2P2_LC0_reg_addr                                   "0x98034234"
+#define HDMI_HDCP_2P2_LC0_reg                                        0x98034234
+#define HDMI_HDCP_2P2_LC0_inst_addr                                  "0x008D"
+#define HDMI_HDCP_2P2_LC0_inst                                       0x008D
+#define HDMI_HDCP_2P2_LC0_lc_shift                                   (0)
+#define HDMI_HDCP_2P2_LC0_lc_mask                                    (0xFFFFFFFF)
+#define HDMI_HDCP_2P2_LC0_lc(data)                                   (0xFFFFFFFF&(data))
+#define HDMI_HDCP_2P2_LC0_get_lc(data)                               (0xFFFFFFFF&(data))
+#define HDMI_set_PORT0_HDCP_2P2_LC0_reg(data)   (*((volatile unsigned int*) HDCP_2P2_LC0_reg)=data)
+#define HDMI_get_PORT0_HDCP_2P2_LC0_reg   (*((volatile unsigned int*) HDCP_2P2_LC0_reg))
+
+
+#define HDMI_HDCP_2P2_LC1                                            0x238
+#define HDMI_HDCP_2P2_LC1_reg_addr                                   "0x98034238"
+#define HDMI_HDCP_2P2_LC1_reg                                        0x98034238
+#define HDMI_HDCP_2P2_LC1_inst_addr                                  "0x008E"
+#define HDMI_HDCP_2P2_LC1_inst                                       0x008E
+#define HDMI_HDCP_2P2_LC1_lc_shift                                   (0)
+#define HDMI_HDCP_2P2_LC1_lc_mask                                    (0xFFFFFFFF)
+#define HDMI_HDCP_2P2_LC1_lc(data)                                   (0xFFFFFFFF&(data))
+#define HDMI_HDCP_2P2_LC1_get_lc(data)                               (0xFFFFFFFF&(data))
+#define HDMI_set_PORT0_HDCP_2P2_LC1_reg(data)   (*((volatile unsigned int*) HDCP_2P2_LC1_reg)=data)
+#define HDMI_get_PORT0_HDCP_2P2_LC1_reg   (*((volatile unsigned int*) HDCP_2P2_LC1_reg))
+
+
+#define HDMI_HDCP_2P2_LC2                                            0x23c
+#define HDMI_HDCP_2P2_LC2_reg_addr                                   "0x9803423c"
+#define HDMI_HDCP_2P2_LC2_reg                                        0x9803423c
+#define HDMI_HDCP_2P2_LC2_inst_addr                                  "0x008F"
+#define HDMI_HDCP_2P2_LC2_inst                                       0x008F
+#define HDMI_HDCP_2P2_LC2_lc_shift                                   (0)
+#define HDMI_HDCP_2P2_LC2_lc_mask                                    (0xFFFFFFFF)
+#define HDMI_HDCP_2P2_LC2_lc(data)                                   (0xFFFFFFFF&(data))
+#define HDMI_HDCP_2P2_LC2_get_lc(data)                               (0xFFFFFFFF&(data))
+#define HDMI_set_PORT0_HDCP_2P2_LC2_reg(data)   (*((volatile unsigned int*) HDCP_2P2_LC2_reg)=data)
+#define HDMI_get_PORT0_HDCP_2P2_LC2_reg   (*((volatile unsigned int*) HDCP_2P2_LC2_reg))
+
+
+#define HDMI_HDCP_2P2_LC3                                            0x240
+#define HDMI_HDCP_2P2_LC3_reg_addr                                   "0x98034240"
+#define HDMI_HDCP_2P2_LC3_reg                                        0x98034240
+#define HDMI_HDCP_2P2_LC3_inst_addr                                  "0x0090"
+#define HDMI_HDCP_2P2_LC3_inst                                       0x0090
+#define HDMI_HDCP_2P2_LC3_lc_shift                                   (0)
+#define HDMI_HDCP_2P2_LC3_lc_mask                                    (0xFFFFFFFF)
+#define HDMI_HDCP_2P2_LC3_lc(data)                                   (0xFFFFFFFF&(data))
+#define HDMI_HDCP_2P2_LC3_get_lc(data)                               (0xFFFFFFFF&(data))
+#define HDMI_set_PORT0_HDCP_2P2_LC3_reg(data)   (*((volatile unsigned int*) HDCP_2P2_LC3_reg)=data)
+#define HDMI_get_PORT0_HDCP_2P2_LC3_reg   (*((volatile unsigned int*) HDCP_2P2_LC3_reg))
+
+
+#define HDMI_HDCP_2P2_RIV0                                           0x244
+#define HDMI_HDCP_2P2_RIV0_reg_addr                                  "0x98034244"
+#define HDMI_HDCP_2P2_RIV0_reg                                       0x98034244
+#define HDMI_HDCP_2P2_RIV0_inst_addr                                 "0x0091"
+#define HDMI_HDCP_2P2_RIV0_inst                                      0x0091
+#define HDMI_HDCP_2P2_RIV0_riv_shift                                 (0)
+#define HDMI_HDCP_2P2_RIV0_riv_mask                                  (0xFFFFFFFF)
+#define HDMI_HDCP_2P2_RIV0_riv(data)                                 (0xFFFFFFFF&(data))
+#define HDMI_HDCP_2P2_RIV0_get_riv(data)                             (0xFFFFFFFF&(data))
+
+
+#define HDMI_HDCP_2P2_RIV1                                           0x248
+#define HDMI_HDCP_2P2_RIV1_reg_addr                                  "0x98034248"
+#define HDMI_HDCP_2P2_RIV1_reg                                       0x98034248
+#define HDMI_HDCP_2P2_RIV1_inst_addr                                 "0x0092"
+#define HDMI_HDCP_2P2_RIV1_inst                                      0x0092
+#define HDMI_HDCP_2P2_RIV1_riv_shift                                 (0)
+#define HDMI_HDCP_2P2_RIV1_riv_mask                                  (0xFFFFFFFF)
+#define HDMI_HDCP_2P2_RIV1_riv(data)                                 (0xFFFFFFFF&(data))
+#define HDMI_HDCP_2P2_RIV1_get_riv(data)                             (0xFFFFFFFF&(data))
+
+
+#define HDMI_HDCP_2P2_SR0                                            0x24c
+#define HDMI_HDCP_2P2_SR0_reg_addr                                   "0x9803424c"
+#define HDMI_HDCP_2P2_SR0_reg                                        0x9803424c
+#define HDMI_HDCP_2P2_SR0_inst_addr                                  "0x0093"
+#define HDMI_HDCP_2P2_SR0_inst                                       0x0093
+#define HDMI_HDCP_2P2_SR0_frame_number_shift                         (22)
+#define HDMI_HDCP_2P2_SR0_irq_fn_compare_fail_shift                  (21)
+#define HDMI_HDCP_2P2_SR0_irq_crc_fail_shift                         (20)
+#define HDMI_HDCP_2P2_SR0_irq_no_cp_packet_shift                     (19)
+#define HDMI_HDCP_2P2_SR0_irq_msg_overwrite_shift                    (18)
+#define HDMI_HDCP_2P2_SR0_irq_unauth_chg_shift                       (17)
+#define HDMI_HDCP_2P2_SR0_irq_state_chg_shift                        (16)
+#define HDMI_HDCP_2P2_SR0_irq_rd_msg_done_shift                      (15)
+#define HDMI_HDCP_2P2_SR0_irq_wr_msg_done_shift                      (14)
+#define HDMI_HDCP_2P2_SR0_irq_rd_msg_start_shift                     (13)
+#define HDMI_HDCP_2P2_SR0_irq_wr_msg_start_shift                     (12)
+#define HDMI_HDCP_2P2_SR0_state_shift                                (0)
+#define HDMI_HDCP_2P2_SR0_frame_number_mask                          (0x3FC00000)
+#define HDMI_HDCP_2P2_SR0_irq_fn_compare_fail_mask                   (0x00200000)
+#define HDMI_HDCP_2P2_SR0_irq_crc_fail_mask                          (0x00100000)
+#define HDMI_HDCP_2P2_SR0_irq_no_cp_packet_mask                      (0x00080000)
+#define HDMI_HDCP_2P2_SR0_irq_msg_overwrite_mask                     (0x00040000)
+#define HDMI_HDCP_2P2_SR0_irq_unauth_chg_mask                        (0x00020000)
+#define HDMI_HDCP_2P2_SR0_irq_state_chg_mask                         (0x00010000)
+#define HDMI_HDCP_2P2_SR0_irq_rd_msg_done_mask                       (0x00008000)
+#define HDMI_HDCP_2P2_SR0_irq_wr_msg_done_mask                       (0x00004000)
+#define HDMI_HDCP_2P2_SR0_irq_rd_msg_start_mask                      (0x00002000)
+#define HDMI_HDCP_2P2_SR0_irq_wr_msg_start_mask                      (0x00001000)
+#define HDMI_HDCP_2P2_SR0_state_mask                                 (0x00000FFF)
+#define HDMI_HDCP_2P2_SR0_frame_number(data)                         (0x3FC00000&((data)<<22))
+#define HDMI_HDCP_2P2_SR0_irq_fn_compare_fail(data)                  (0x00200000&((data)<<21))
+#define HDMI_HDCP_2P2_SR0_irq_crc_fail(data)                         (0x00100000&((data)<<20))
+#define HDMI_HDCP_2P2_SR0_irq_no_cp_packet(data)                     (0x00080000&((data)<<19))
+#define HDMI_HDCP_2P2_SR0_irq_msg_overwrite(data)                    (0x00040000&((data)<<18))
+#define HDMI_HDCP_2P2_SR0_irq_unauth_chg(data)                       (0x00020000&((data)<<17))
+#define HDMI_HDCP_2P2_SR0_irq_state_chg(data)                        (0x00010000&((data)<<16))
+#define HDMI_HDCP_2P2_SR0_irq_rd_msg_done(data)                      (0x00008000&((data)<<15))
+#define HDMI_HDCP_2P2_SR0_irq_wr_msg_done(data)                      (0x00004000&((data)<<14))
+#define HDMI_HDCP_2P2_SR0_irq_rd_msg_start(data)                     (0x00002000&((data)<<13))
+#define HDMI_HDCP_2P2_SR0_irq_wr_msg_start(data)                     (0x00001000&((data)<<12))
+#define HDMI_HDCP_2P2_SR0_state(data)                                (0x00000FFF&(data))
+#define HDMI_HDCP_2P2_SR0_get_frame_number(data)                     ((0x3FC00000&(data))>>22)
+#define HDMI_HDCP_2P2_SR0_get_irq_fn_compare_fail(data)              ((0x00200000&(data))>>21)
+#define HDMI_HDCP_2P2_SR0_get_irq_crc_fail(data)                     ((0x00100000&(data))>>20)
+#define HDMI_HDCP_2P2_SR0_get_irq_no_cp_packet(data)                 ((0x00080000&(data))>>19)
+#define HDMI_HDCP_2P2_SR0_get_irq_msg_overwrite(data)                ((0x00040000&(data))>>18)
+#define HDMI_HDCP_2P2_SR0_get_irq_unauth_chg(data)                   ((0x00020000&(data))>>17)
+#define HDMI_HDCP_2P2_SR0_get_irq_state_chg(data)                    ((0x00010000&(data))>>16)
+#define HDMI_HDCP_2P2_SR0_get_irq_rd_msg_done(data)                  ((0x00008000&(data))>>15)
+#define HDMI_HDCP_2P2_SR0_get_irq_wr_msg_done(data)                  ((0x00004000&(data))>>14)
+#define HDMI_HDCP_2P2_SR0_get_irq_rd_msg_start(data)                 ((0x00002000&(data))>>13)
+#define HDMI_HDCP_2P2_SR0_get_irq_wr_msg_start(data)                 ((0x00001000&(data))>>12)
+#define HDMI_HDCP_2P2_SR0_get_state(data)                            (0x00000FFF&(data))
+
+
+#define HDMI_HDCP_2P2_SR1                                            0x250
+#define HDMI_HDCP_2P2_SR1_reg_addr                                   "0x98034250"
+#define HDMI_HDCP_2P2_SR1_reg                                        0x98034250
+#define HDMI_HDCP_2P2_SR1_inst_addr                                  "0x0094"
+#define HDMI_HDCP_2P2_SR1_inst                                       0x0094
+#define HDMI_HDCP_2P2_SR1_crc_fail_wd_en_shift                       (11)
+#define HDMI_HDCP_2P2_SR1_no_cp_packet_wd_en_shift                   (10)
+#define HDMI_HDCP_2P2_SR1_irq_fn_compare_fail_en_shift               (9)
+#define HDMI_HDCP_2P2_SR1_irq_crc_fail_en_shift                      (8)
+#define HDMI_HDCP_2P2_SR1_irq_no_cp_packet_en_shift                  (7)
+#define HDMI_HDCP_2P2_SR1_irq_msg_overwrite_en_shift                 (6)
+#define HDMI_HDCP_2P2_SR1_irq_unauth_chg_en_shift                    (5)
+#define HDMI_HDCP_2P2_SR1_irq_state_chg_en_shift                     (4)
+#define HDMI_HDCP_2P2_SR1_irq_rd_msg_done_en_shift                   (3)
+#define HDMI_HDCP_2P2_SR1_irq_wr_msg_done_en_shift                   (2)
+#define HDMI_HDCP_2P2_SR1_irq_rd_msg_start_en_shift                  (1)
+#define HDMI_HDCP_2P2_SR1_irq_wr_msg_start_en_shift                  (0)
+#define HDMI_HDCP_2P2_SR1_crc_fail_wd_en_mask                        (0x00000800)
+#define HDMI_HDCP_2P2_SR1_no_cp_packet_wd_en_mask                    (0x00000400)
+#define HDMI_HDCP_2P2_SR1_irq_fn_compare_fail_en_mask                (0x00000200)
+#define HDMI_HDCP_2P2_SR1_irq_crc_fail_en_mask                       (0x00000100)
+#define HDMI_HDCP_2P2_SR1_irq_no_cp_packet_en_mask                   (0x00000080)
+#define HDMI_HDCP_2P2_SR1_irq_msg_overwrite_en_mask                  (0x00000040)
+#define HDMI_HDCP_2P2_SR1_irq_unauth_chg_en_mask                     (0x00000020)
+#define HDMI_HDCP_2P2_SR1_irq_state_chg_en_mask                      (0x00000010)
+#define HDMI_HDCP_2P2_SR1_irq_rd_msg_done_en_mask                    (0x00000008)
+#define HDMI_HDCP_2P2_SR1_irq_wr_msg_done_en_mask                    (0x00000004)
+#define HDMI_HDCP_2P2_SR1_irq_rd_msg_start_en_mask                   (0x00000002)
+#define HDMI_HDCP_2P2_SR1_irq_wr_msg_start_en_mask                   (0x00000001)
+#define HDMI_HDCP_2P2_SR1_crc_fail_wd_en(data)                       (0x00000800&((data)<<11))
+#define HDMI_HDCP_2P2_SR1_no_cp_packet_wd_en(data)                   (0x00000400&((data)<<10))
+#define HDMI_HDCP_2P2_SR1_irq_fn_compare_fail_en(data)               (0x00000200&((data)<<9))
+#define HDMI_HDCP_2P2_SR1_irq_crc_fail_en(data)                      (0x00000100&((data)<<8))
+#define HDMI_HDCP_2P2_SR1_irq_no_cp_packet_en(data)                  (0x00000080&((data)<<7))
+#define HDMI_HDCP_2P2_SR1_irq_msg_overwrite_en(data)                 (0x00000040&((data)<<6))
+#define HDMI_HDCP_2P2_SR1_irq_unauth_chg_en(data)                    (0x00000020&((data)<<5))
+#define HDMI_HDCP_2P2_SR1_irq_state_chg_en(data)                     (0x00000010&((data)<<4))
+#define HDMI_HDCP_2P2_SR1_irq_rd_msg_done_en(data)                   (0x00000008&((data)<<3))
+#define HDMI_HDCP_2P2_SR1_irq_wr_msg_done_en(data)                   (0x00000004&((data)<<2))
+#define HDMI_HDCP_2P2_SR1_irq_rd_msg_start_en(data)                  (0x00000002&((data)<<1))
+#define HDMI_HDCP_2P2_SR1_irq_wr_msg_start_en(data)                  (0x00000001&(data))
+#define HDMI_HDCP_2P2_SR1_get_crc_fail_wd_en(data)                   ((0x00000800&(data))>>11)
+#define HDMI_HDCP_2P2_SR1_get_no_cp_packet_wd_en(data)               ((0x00000400&(data))>>10)
+#define HDMI_HDCP_2P2_SR1_get_irq_fn_compare_fail_en(data)           ((0x00000200&(data))>>9)
+#define HDMI_HDCP_2P2_SR1_get_irq_crc_fail_en(data)                  ((0x00000100&(data))>>8)
+#define HDMI_HDCP_2P2_SR1_get_irq_no_cp_packet_en(data)              ((0x00000080&(data))>>7)
+#define HDMI_HDCP_2P2_SR1_get_irq_msg_overwrite_en(data)             ((0x00000040&(data))>>6)
+#define HDMI_HDCP_2P2_SR1_get_irq_unauth_chg_en(data)                ((0x00000020&(data))>>5)
+#define HDMI_HDCP_2P2_SR1_get_irq_state_chg_en(data)                 ((0x00000010&(data))>>4)
+#define HDMI_HDCP_2P2_SR1_get_irq_rd_msg_done_en(data)               ((0x00000008&(data))>>3)
+#define HDMI_HDCP_2P2_SR1_get_irq_wr_msg_done_en(data)               ((0x00000004&(data))>>2)
+#define HDMI_HDCP_2P2_SR1_get_irq_rd_msg_start_en(data)              ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2P2_SR1_get_irq_wr_msg_start_en(data)              (0x00000001&(data))
+
+
+#define HDMI_HDCP_MSAP                                               0x254
+#define HDMI_HDCP_MSAP_reg_addr                                      "0x98034254"
+#define HDMI_HDCP_MSAP_reg                                           0x98034254
+#define HDMI_HDCP_MSAP_inst_addr                                     "0x0095"
+#define HDMI_HDCP_MSAP_inst                                          0x0095
+#define HDMI_HDCP_MSAP_ap1_shift                                     (0)
+#define HDMI_HDCP_MSAP_ap1_mask                                      (0x000003FF)
+#define HDMI_HDCP_MSAP_ap1(data)                                     (0x000003FF&(data))
+#define HDMI_HDCP_MSAP_get_ap1(data)                                 (0x000003FF&(data))
+
+
+#define HDMI_HDCP_MSDP                                               0x258
+#define HDMI_HDCP_MSDP_reg_addr                                      "0x98034258"
+#define HDMI_HDCP_MSDP_reg                                           0x98034258
+#define HDMI_HDCP_MSDP_inst_addr                                     "0x0096"
+#define HDMI_HDCP_MSDP_inst                                          0x0096
+#define HDMI_HDCP_MSDP_dp1_shift                                     (0)
+#define HDMI_HDCP_MSDP_dp1_mask                                      (0x000000FF)
+#define HDMI_HDCP_MSDP_dp1(data)                                     (0x000000FF&(data))
+#define HDMI_HDCP_MSDP_get_dp1(data)                                 (0x000000FF&(data))
+
+
+#define HDMI_CMCR                                               0x300
+#define HDMI_CMCR_reg_addr                                      "0x98034300"
+#define HDMI_CMCR_reg                                           0x98034300
+#define HDMI_CMCR_inst_addr                                     "0x00C0"
+#define HDMI_CMCR_inst                                          0x00C0
+#define HDMI_CMCR_icmux_shift                                   (7)
+#define HDMI_CMCR_ocs_shift                                     (5)
+#define HDMI_CMCR_dbdcb_shift                                   (4)
+#define HDMI_CMCR_dummy98034300_3_0_shift                       (0)
+#define HDMI_CMCR_icmux_mask                                    (0x00000080)
+#define HDMI_CMCR_ocs_mask                                      (0x00000060)
+#define HDMI_CMCR_dbdcb_mask                                    (0x00000010)
+#define HDMI_CMCR_dummy98034300_3_0_mask                        (0x0000000F)
+#define HDMI_CMCR_icmux(data)                                   (0x00000080&((data)<<7))
+#define HDMI_CMCR_ocs(data)                                     (0x00000060&((data)<<5))
+#define HDMI_CMCR_dbdcb(data)                                   (0x00000010&((data)<<4))
+#define HDMI_CMCR_dummy98034300_3_0(data)                       (0x0000000F&(data))
+#define HDMI_CMCR_get_icmux(data)                               ((0x00000080&(data))>>7)
+#define HDMI_CMCR_get_ocs(data)                                 ((0x00000060&(data))>>5)
+#define HDMI_CMCR_get_dbdcb(data)                               ((0x00000010&(data))>>4)
+#define HDMI_CMCR_get_dummy98034300_3_0(data)                   (0x0000000F&(data))
+
+
+#define HDMI_MCAPR                                              0x304
+#define HDMI_MCAPR_reg_addr                                     "0x98034304"
+#define HDMI_MCAPR_reg                                          0x98034304
+#define HDMI_MCAPR_inst_addr                                    "0x00C1"
+#define HDMI_MCAPR_inst                                         0x00C1
+#define HDMI_MCAPR_dummy98034304_7_0_shift                      (0)
+#define HDMI_MCAPR_dummy98034304_7_0_mask                       (0x000000FF)
+#define HDMI_MCAPR_dummy98034304_7_0(data)                      (0x000000FF&(data))
+#define HDMI_MCAPR_get_dummy98034304_7_0(data)                  (0x000000FF&(data))
+
+
+#define HDMI_SCAPR                                              0x308
+#define HDMI_SCAPR_reg_addr                                     "0x98034308"
+#define HDMI_SCAPR_reg                                          0x98034308
+#define HDMI_SCAPR_inst_addr                                    "0x00C2"
+#define HDMI_SCAPR_inst                                         0x00C2
+#define HDMI_SCAPR_s1_code_msb_r_shift                          (17)
+#define HDMI_SCAPR_slc_r_shift                                  (16)
+#define HDMI_SCAPR_sc_r_shift                                   (9)
+#define HDMI_SCAPR_s1_code_msb_shift                            (8)
+#define HDMI_SCAPR_slc_shift                                    (7)
+#define HDMI_SCAPR_sc_shift                                     (0)
+#define HDMI_SCAPR_s1_code_msb_r_mask                           (0x00020000)
+#define HDMI_SCAPR_slc_r_mask                                   (0x00010000)
+#define HDMI_SCAPR_sc_r_mask                                    (0x0000FE00)
+#define HDMI_SCAPR_s1_code_msb_mask                             (0x00000100)
+#define HDMI_SCAPR_slc_mask                                     (0x00000080)
+#define HDMI_SCAPR_sc_mask                                      (0x0000007F)
+#define HDMI_SCAPR_s1_code_msb_r(data)                          (0x00020000&((data)<<17))
+#define HDMI_SCAPR_slc_r(data)                                  (0x00010000&((data)<<16))
+#define HDMI_SCAPR_sc_r(data)                                   (0x0000FE00&((data)<<9))
+#define HDMI_SCAPR_s1_code_msb(data)                            (0x00000100&((data)<<8))
+#define HDMI_SCAPR_slc(data)                                    (0x00000080&((data)<<7))
+#define HDMI_SCAPR_sc(data)                                     (0x0000007F&(data))
+#define HDMI_SCAPR_get_s1_code_msb_r(data)                      ((0x00020000&(data))>>17)
+#define HDMI_SCAPR_get_slc_r(data)                              ((0x00010000&(data))>>16)
+#define HDMI_SCAPR_get_sc_r(data)                               ((0x0000FE00&(data))>>9)
+#define HDMI_SCAPR_get_s1_code_msb(data)                        ((0x00000100&(data))>>8)
+#define HDMI_SCAPR_get_slc(data)                                ((0x00000080&(data))>>7)
+#define HDMI_SCAPR_get_sc(data)                                 (0x0000007F&(data))
+
+
+#define HDMI_DCAPR0                                             0x30c
+#define HDMI_DCAPR0_reg_addr                                    "0x9803430c"
+#define HDMI_DCAPR0_reg                                         0x9803430c
+#define HDMI_DCAPR0_inst_addr                                   "0x00C3"
+#define HDMI_DCAPR0_inst                                        0x00C3
+#define HDMI_DCAPR0_dcaprh_shift                                (8)
+#define HDMI_DCAPR0_dcaprl_shift                                (0)
+#define HDMI_DCAPR0_dcaprh_mask                                 (0x0000FF00)
+#define HDMI_DCAPR0_dcaprl_mask                                 (0x000000FF)
+#define HDMI_DCAPR0_dcaprh(data)                                (0x0000FF00&((data)<<8))
+#define HDMI_DCAPR0_dcaprl(data)                                (0x000000FF&(data))
+#define HDMI_DCAPR0_get_dcaprh(data)                            ((0x0000FF00&(data))>>8)
+#define HDMI_DCAPR0_get_dcaprl(data)                            (0x000000FF&(data))
+
+
+#define HDMI_PSCR                                               0x310
+#define HDMI_PSCR_reg_addr                                      "0x98034310"
+#define HDMI_PSCR_reg                                           0x98034310
+#define HDMI_PSCR_inst_addr                                     "0x00C4"
+#define HDMI_PSCR_inst                                          0x00C4
+#define HDMI_PSCR_fdint_shift                                   (5)
+#define HDMI_PSCR_etcn_shift                                    (4)
+#define HDMI_PSCR_etfd_shift                                    (3)
+#define HDMI_PSCR_etfbc_shift                                   (2)
+#define HDMI_PSCR_pecs_shift                                    (0)
+#define HDMI_PSCR_fdint_mask                                    (0x000000E0)
+#define HDMI_PSCR_etcn_mask                                     (0x00000010)
+#define HDMI_PSCR_etfd_mask                                     (0x00000008)
+#define HDMI_PSCR_etfbc_mask                                    (0x00000004)
+#define HDMI_PSCR_pecs_mask                                     (0x00000003)
+#define HDMI_PSCR_fdint(data)                                   (0x000000E0&((data)<<5))
+#define HDMI_PSCR_etcn(data)                                    (0x00000010&((data)<<4))
+#define HDMI_PSCR_etfd(data)                                    (0x00000008&((data)<<3))
+#define HDMI_PSCR_etfbc(data)                                   (0x00000004&((data)<<2))
+#define HDMI_PSCR_pecs(data)                                    (0x00000003&(data))
+#define HDMI_PSCR_get_fdint(data)                               ((0x000000E0&(data))>>5)
+#define HDMI_PSCR_get_etcn(data)                                ((0x00000010&(data))>>4)
+#define HDMI_PSCR_get_etfd(data)                                ((0x00000008&(data))>>3)
+#define HDMI_PSCR_get_etfbc(data)                               ((0x00000004&(data))>>2)
+#define HDMI_PSCR_get_pecs(data)                                (0x00000003&(data))
+
+
+#define HDMI_AFDD                                               0x31c
+#define HDMI_AFDD_reg_addr                                      "0x9803431c"
+#define HDMI_AFDD_reg                                           0x9803431c
+#define HDMI_AFDD_inst_addr                                     "0x00C7"
+#define HDMI_AFDD_inst                                          0x00C7
+#define HDMI_AFDD_mfddf_shift                                   (24)
+#define HDMI_AFDD_mfddr_shift                                   (16)
+#define HDMI_AFDD_fddf_shift                                    (8)
+#define HDMI_AFDD_fddr_shift                                    (0)
+#define HDMI_AFDD_mfddf_mask                                    (0xFF000000)
+#define HDMI_AFDD_mfddr_mask                                    (0x00FF0000)
+#define HDMI_AFDD_fddf_mask                                     (0x0000FF00)
+#define HDMI_AFDD_fddr_mask                                     (0x000000FF)
+#define HDMI_AFDD_mfddf(data)                                   (0xFF000000&((data)<<24))
+#define HDMI_AFDD_mfddr(data)                                   (0x00FF0000&((data)<<16))
+#define HDMI_AFDD_fddf(data)                                    (0x0000FF00&((data)<<8))
+#define HDMI_AFDD_fddr(data)                                    (0x000000FF&(data))
+#define HDMI_AFDD_get_mfddf(data)                               ((0xFF000000&(data))>>24)
+#define HDMI_AFDD_get_mfddr(data)                               ((0x00FF0000&(data))>>16)
+#define HDMI_AFDD_get_fddf(data)                                ((0x0000FF00&(data))>>8)
+#define HDMI_AFDD_get_fddr(data)                                (0x000000FF&(data))
+
+
+#define HDMI_FTR                                                0x320
+#define HDMI_FTR_reg_addr                                       "0x98034320"
+#define HDMI_FTR_reg                                            0x98034320
+#define HDMI_FTR_inst_addr                                      "0x00C8"
+#define HDMI_FTR_inst                                           0x00C8
+#define HDMI_FTR_tl2der_shift                                   (6)
+#define HDMI_FTR_tl2def_shift                                   (4)
+#define HDMI_FTR_tt_shift                                       (0)
+#define HDMI_FTR_tl2der_mask                                    (0x000000C0)
+#define HDMI_FTR_tl2def_mask                                    (0x00000030)
+#define HDMI_FTR_tt_mask                                        (0x0000000F)
+#define HDMI_FTR_tl2der(data)                                   (0x000000C0&((data)<<6))
+#define HDMI_FTR_tl2def(data)                                   (0x00000030&((data)<<4))
+#define HDMI_FTR_tt(data)                                       (0x0000000F&(data))
+#define HDMI_FTR_get_tl2der(data)                               ((0x000000C0&(data))>>6)
+#define HDMI_FTR_get_tl2def(data)                               ((0x00000030&(data))>>4)
+#define HDMI_FTR_get_tt(data)                                   (0x0000000F&(data))
+
+
+#define HDMI_FBR                                                0x324
+#define HDMI_FBR_reg_addr                                       "0x98034324"
+#define HDMI_FBR_reg                                            0x98034324
+#define HDMI_FBR_inst_addr                                      "0x00C9"
+#define HDMI_FBR_inst                                           0x00C9
+#define HDMI_FBR_tfd_shift                                      (3)
+#define HDMI_FBR_bad_shift                                      (0)
+#define HDMI_FBR_tfd_mask                                       (0x000000F8)
+#define HDMI_FBR_bad_mask                                       (0x00000007)
+#define HDMI_FBR_tfd(data)                                      (0x000000F8&((data)<<3))
+#define HDMI_FBR_bad(data)                                      (0x00000007&(data))
+#define HDMI_FBR_get_tfd(data)                                  ((0x000000F8&(data))>>3)
+#define HDMI_FBR_get_bad(data)                                  (0x00000007&(data))
+
+
+#define HDMI_ICPSNCR0                                           0x328
+#define HDMI_ICPSNCR0_reg_addr                                  "0x98034328"
+#define HDMI_ICPSNCR0_reg                                       0x98034328
+#define HDMI_ICPSNCR0_inst_addr                                 "0x00CA"
+#define HDMI_ICPSNCR0_inst                                      0x00CA
+#define HDMI_ICPSNCR0_ich_shift                                 (8)
+#define HDMI_ICPSNCR0_icl_shift                                 (0)
+#define HDMI_ICPSNCR0_ich_mask                                  (0x0000FF00)
+#define HDMI_ICPSNCR0_icl_mask                                  (0x000000FF)
+#define HDMI_ICPSNCR0_ich(data)                                 (0x0000FF00&((data)<<8))
+#define HDMI_ICPSNCR0_icl(data)                                 (0x000000FF&(data))
+#define HDMI_ICPSNCR0_get_ich(data)                             ((0x0000FF00&(data))>>8)
+#define HDMI_ICPSNCR0_get_icl(data)                             (0x000000FF&(data))
+
+
+#define HDMI_PCPSNCR0                                           0x32c
+#define HDMI_PCPSNCR0_reg_addr                                  "0x9803432c"
+#define HDMI_PCPSNCR0_reg                                       0x9803432c
+#define HDMI_PCPSNCR0_inst_addr                                 "0x00CB"
+#define HDMI_PCPSNCR0_inst                                      0x00CB
+#define HDMI_PCPSNCR0_pch_shift                                 (8)
+#define HDMI_PCPSNCR0_pcl_shift                                 (0)
+#define HDMI_PCPSNCR0_pch_mask                                  (0x0000FF00)
+#define HDMI_PCPSNCR0_pcl_mask                                  (0x000000FF)
+#define HDMI_PCPSNCR0_pch(data)                                 (0x0000FF00&((data)<<8))
+#define HDMI_PCPSNCR0_pcl(data)                                 (0x000000FF&(data))
+#define HDMI_PCPSNCR0_get_pch(data)                             ((0x0000FF00&(data))>>8)
+#define HDMI_PCPSNCR0_get_pcl(data)                             (0x000000FF&(data))
+
+
+#define HDMI_ICTPSR0                                            0x330
+#define HDMI_ICTPSR0_reg_addr                                   "0x98034330"
+#define HDMI_ICTPSR0_reg                                        0x98034330
+#define HDMI_ICTPSR0_inst_addr                                  "0x00CC"
+#define HDMI_ICTPSR0_inst                                       0x00CC
+#define HDMI_ICTPSR0_icth_shift                                 (8)
+#define HDMI_ICTPSR0_ictl_shift                                 (0)
+#define HDMI_ICTPSR0_icth_mask                                  (0x0000FF00)
+#define HDMI_ICTPSR0_ictl_mask                                  (0x000000FF)
+#define HDMI_ICTPSR0_icth(data)                                 (0x0000FF00&((data)<<8))
+#define HDMI_ICTPSR0_ictl(data)                                 (0x000000FF&(data))
+#define HDMI_ICTPSR0_get_icth(data)                             ((0x0000FF00&(data))>>8)
+#define HDMI_ICTPSR0_get_ictl(data)                             (0x000000FF&(data))
+
+
+#define HDMI_PCTPSR0                                            0x334
+#define HDMI_PCTPSR0_reg_addr                                   "0x98034334"
+#define HDMI_PCTPSR0_reg                                        0x98034334
+#define HDMI_PCTPSR0_inst_addr                                  "0x00CD"
+#define HDMI_PCTPSR0_inst                                       0x00CD
+#define HDMI_PCTPSR0_pcth_shift                                 (8)
+#define HDMI_PCTPSR0_pctl_shift                                 (0)
+#define HDMI_PCTPSR0_pcth_mask                                  (0x0000FF00)
+#define HDMI_PCTPSR0_pctl_mask                                  (0x000000FF)
+#define HDMI_PCTPSR0_pcth(data)                                 (0x0000FF00&((data)<<8))
+#define HDMI_PCTPSR0_pctl(data)                                 (0x000000FF&(data))
+#define HDMI_PCTPSR0_get_pcth(data)                             ((0x0000FF00&(data))>>8)
+#define HDMI_PCTPSR0_get_pctl(data)                             (0x000000FF&(data))
+
+
+#define HDMI_ICBPSR0                                            0x338
+#define HDMI_ICBPSR0_reg_addr                                   "0x98034338"
+#define HDMI_ICBPSR0_reg                                        0x98034338
+#define HDMI_ICBPSR0_inst_addr                                  "0x00CE"
+#define HDMI_ICBPSR0_inst                                       0x00CE
+#define HDMI_ICBPSR0_icbh_shift                                 (8)
+#define HDMI_ICBPSR0_icbl_shift                                 (0)
+#define HDMI_ICBPSR0_icbh_mask                                  (0x0000FF00)
+#define HDMI_ICBPSR0_icbl_mask                                  (0x000000FF)
+#define HDMI_ICBPSR0_icbh(data)                                 (0x0000FF00&((data)<<8))
+#define HDMI_ICBPSR0_icbl(data)                                 (0x000000FF&(data))
+#define HDMI_ICBPSR0_get_icbh(data)                             ((0x0000FF00&(data))>>8)
+#define HDMI_ICBPSR0_get_icbl(data)                             (0x000000FF&(data))
+
+
+#define HDMI_PCBPSR0                                            0x33c
+#define HDMI_PCBPSR0_reg_addr                                   "0x9803433c"
+#define HDMI_PCBPSR0_reg                                        0x9803433c
+#define HDMI_PCBPSR0_inst_addr                                  "0x00CF"
+#define HDMI_PCBPSR0_inst                                       0x00CF
+#define HDMI_PCBPSR0_pcbh_shift                                 (8)
+#define HDMI_PCBPSR0_pcbl_shift                                 (0)
+#define HDMI_PCBPSR0_pcbh_mask                                  (0x0000FF00)
+#define HDMI_PCBPSR0_pcbl_mask                                  (0x000000FF)
+#define HDMI_PCBPSR0_pcbh(data)                                 (0x0000FF00&((data)<<8))
+#define HDMI_PCBPSR0_pcbl(data)                                 (0x000000FF&(data))
+#define HDMI_PCBPSR0_get_pcbh(data)                             ((0x0000FF00&(data))>>8)
+#define HDMI_PCBPSR0_get_pcbl(data)                             (0x000000FF&(data))
+
+
+#define HDMI_NTX1024TR0                                         0x340
+#define HDMI_NTX1024TR0_reg_addr                                "0x98034340"
+#define HDMI_NTX1024TR0_reg                                     0x98034340
+#define HDMI_NTX1024TR0_inst_addr                               "0x00D0"
+#define HDMI_NTX1024TR0_inst                                    0x00D0
+#define HDMI_NTX1024TR0_rm_shift                                (12)
+#define HDMI_NTX1024TR0_nt_shift                                (0)
+#define HDMI_NTX1024TR0_rm_mask                                 (0x00001000)
+#define HDMI_NTX1024TR0_nt_mask                                 (0x00000FFF)
+#define HDMI_NTX1024TR0_rm(data)                                (0x00001000&((data)<<12))
+#define HDMI_NTX1024TR0_nt(data)                                (0x00000FFF&(data))
+#define HDMI_NTX1024TR0_get_rm(data)                            ((0x00001000&(data))>>12)
+#define HDMI_NTX1024TR0_get_nt(data)                            (0x00000FFF&(data))
+
+
+#define HDMI_STBPR                                              0x344
+#define HDMI_STBPR_reg_addr                                     "0x98034344"
+#define HDMI_STBPR_reg                                          0x98034344
+#define HDMI_STBPR_inst_addr                                    "0x00D1"
+#define HDMI_STBPR_inst                                         0x00D1
+#define HDMI_STBPR_ftb_shift                                    (0)
+#define HDMI_STBPR_ftb_mask                                     (0x000000FF)
+#define HDMI_STBPR_ftb(data)                                    (0x000000FF&(data))
+#define HDMI_STBPR_get_ftb(data)                                (0x000000FF&(data))
+
+
+#define HDMI_NCPER                                              0x348
+#define HDMI_NCPER_reg_addr                                     "0x98034348"
+#define HDMI_NCPER_reg                                          0x98034348
+#define HDMI_NCPER_inst_addr                                    "0x00D2"
+#define HDMI_NCPER_inst                                         0x00D2
+#define HDMI_NCPER_ncper_shift                                  (0)
+#define HDMI_NCPER_ncper_mask                                   (0x000000FF)
+#define HDMI_NCPER_ncper(data)                                  (0x000000FF&(data))
+#define HDMI_NCPER_get_ncper(data)                              (0x000000FF&(data))
+
+
+#define HDMI_PETR                                               0x34c
+#define HDMI_PETR_reg_addr                                      "0x9803434c"
+#define HDMI_PETR_reg                                           0x9803434c
+#define HDMI_PETR_inst_addr                                     "0x00D3"
+#define HDMI_PETR_inst                                          0x00D3
+#define HDMI_PETR_petr_shift                                    (0)
+#define HDMI_PETR_petr_mask                                     (0x000000FF)
+#define HDMI_PETR_petr(data)                                    (0x000000FF&(data))
+#define HDMI_PETR_get_petr(data)                                (0x000000FF&(data))
+
+
+#define HDMI_AAPNR                                              0x350
+#define HDMI_AAPNR_reg_addr                                     "0x98034350"
+#define HDMI_AAPNR_reg                                          0x98034350
+#define HDMI_AAPNR_inst_addr                                    "0x00D4"
+#define HDMI_AAPNR_inst                                         0x00D4
+#define HDMI_AAPNR_cmvtc_shift                                  (7)
+#define HDMI_AAPNR_cmvbc_shift                                  (6)
+#define HDMI_AAPNR_ssdmou_shift                                 (5)
+#define HDMI_AAPNR_tef_shift                                    (4)
+#define HDMI_AAPNR_w1c5_shift                                   (3)
+#define HDMI_AAPNR_dummy98034350_2_shift                        (2)
+#define HDMI_AAPNR_esdm_shift                                   (1)
+#define HDMI_AAPNR_dummy98034350_0_shift                        (0)
+#define HDMI_AAPNR_cmvtc_mask                                   (0x00000080)
+#define HDMI_AAPNR_cmvbc_mask                                   (0x00000040)
+#define HDMI_AAPNR_ssdmou_mask                                  (0x00000020)
+#define HDMI_AAPNR_tef_mask                                     (0x00000010)
+#define HDMI_AAPNR_w1c5_mask                                    (0x00000008)
+#define HDMI_AAPNR_dummy98034350_2_mask                         (0x00000004)
+#define HDMI_AAPNR_esdm_mask                                    (0x00000002)
+#define HDMI_AAPNR_dummy98034350_0_mask                         (0x00000001)
+#define HDMI_AAPNR_cmvtc(data)                                  (0x00000080&((data)<<7))
+#define HDMI_AAPNR_cmvbc(data)                                  (0x00000040&((data)<<6))
+#define HDMI_AAPNR_ssdmou(data)                                 (0x00000020&((data)<<5))
+#define HDMI_AAPNR_tef(data)                                    (0x00000010&((data)<<4))
+#define HDMI_AAPNR_w1c5(data)                                   (0x00000008&((data)<<3))
+#define HDMI_AAPNR_dummy98034350_2(data)                        (0x00000004&((data)<<2))
+#define HDMI_AAPNR_esdm(data)                                   (0x00000002&((data)<<1))
+#define HDMI_AAPNR_dummy98034350_0(data)                        (0x00000001&(data))
+#define HDMI_AAPNR_get_cmvtc(data)                              ((0x00000080&(data))>>7)
+#define HDMI_AAPNR_get_cmvbc(data)                              ((0x00000040&(data))>>6)
+#define HDMI_AAPNR_get_ssdmou(data)                             ((0x00000020&(data))>>5)
+#define HDMI_AAPNR_get_tef(data)                                ((0x00000010&(data))>>4)
+#define HDMI_AAPNR_get_w1c5(data)                               ((0x00000008&(data))>>3)
+#define HDMI_AAPNR_get_dummy98034350_2(data)                    ((0x00000004&(data))>>2)
+#define HDMI_AAPNR_get_esdm(data)                               ((0x00000002&(data))>>1)
+#define HDMI_AAPNR_get_dummy98034350_0(data)                    (0x00000001&(data))
+
+
+#define HDMI_APDMCR                                             0x354
+#define HDMI_APDMCR_reg_addr                                    "0x98034354"
+#define HDMI_APDMCR_reg                                         0x98034354
+#define HDMI_APDMCR_inst_addr                                   "0x00D5"
+#define HDMI_APDMCR_inst                                        0x00D5
+#define HDMI_APDMCR_dummy98034354_7_shift                       (7)
+#define HDMI_APDMCR_dummy98034354_6_shift                       (6)
+#define HDMI_APDMCR_edm_shift                                   (5)
+#define HDMI_APDMCR_pst_shift                                   (4)
+#define HDMI_APDMCR_psc_shift                                   (0)
+#define HDMI_APDMCR_dummy98034354_7_mask                        (0x00000080)
+#define HDMI_APDMCR_dummy98034354_6_mask                        (0x00000040)
+#define HDMI_APDMCR_edm_mask                                    (0x00000020)
+#define HDMI_APDMCR_pst_mask                                    (0x00000010)
+#define HDMI_APDMCR_psc_mask                                    (0x0000000F)
+#define HDMI_APDMCR_dummy98034354_7(data)                       (0x00000080&((data)<<7))
+#define HDMI_APDMCR_dummy98034354_6(data)                       (0x00000040&((data)<<6))
+#define HDMI_APDMCR_edm(data)                                   (0x00000020&((data)<<5))
+#define HDMI_APDMCR_pst(data)                                   (0x00000010&((data)<<4))
+#define HDMI_APDMCR_psc(data)                                   (0x0000000F&(data))
+#define HDMI_APDMCR_get_dummy98034354_7(data)                   ((0x00000080&(data))>>7)
+#define HDMI_APDMCR_get_dummy98034354_6(data)                   ((0x00000040&(data))>>6)
+#define HDMI_APDMCR_get_edm(data)                               ((0x00000020&(data))>>5)
+#define HDMI_APDMCR_get_pst(data)                               ((0x00000010&(data))>>4)
+#define HDMI_APDMCR_get_psc(data)                               (0x0000000F&(data))
+
+
+#define HDMI_APTMCR0                                            0x358
+#define HDMI_APTMCR0_reg_addr                                   "0x98034358"
+#define HDMI_APTMCR0_reg                                        0x98034358
+#define HDMI_APTMCR0_inst_addr                                  "0x00D6"
+#define HDMI_APTMCR0_inst                                       0x00D6
+#define HDMI_APTMCR0_fps_shift                                  (4)
+#define HDMI_APTMCR0_sps_shift                                  (0)
+#define HDMI_APTMCR0_fps_mask                                   (0x000000F0)
+#define HDMI_APTMCR0_sps_mask                                   (0x0000000F)
+#define HDMI_APTMCR0_fps(data)                                  (0x000000F0&((data)<<4))
+#define HDMI_APTMCR0_sps(data)                                  (0x0000000F&(data))
+#define HDMI_APTMCR0_get_fps(data)                              ((0x000000F0&(data))>>4)
+#define HDMI_APTMCR0_get_sps(data)                              (0x0000000F&(data))
+
+
+#define HDMI_APTMCR1                                            0x35c
+#define HDMI_APTMCR1_reg_addr                                   "0x9803435c"
+#define HDMI_APTMCR1_reg                                        0x9803435c
+#define HDMI_APTMCR1_inst_addr                                  "0x00D7"
+#define HDMI_APTMCR1_inst                                       0x00D7
+#define HDMI_APTMCR1_plltm_shift                                (6)
+#define HDMI_APTMCR1_fpsd_shift                                 (5)
+#define HDMI_APTMCR1_spsd_shift                                 (4)
+#define HDMI_APTMCR1_nfpss_shift                                (0)
+#define HDMI_APTMCR1_plltm_mask                                 (0x00000040)
+#define HDMI_APTMCR1_fpsd_mask                                  (0x00000020)
+#define HDMI_APTMCR1_spsd_mask                                  (0x00000010)
+#define HDMI_APTMCR1_nfpss_mask                                 (0x0000000F)
+#define HDMI_APTMCR1_plltm(data)                                (0x00000040&((data)<<6))
+#define HDMI_APTMCR1_fpsd(data)                                 (0x00000020&((data)<<5))
+#define HDMI_APTMCR1_spsd(data)                                 (0x00000010&((data)<<4))
+#define HDMI_APTMCR1_nfpss(data)                                (0x0000000F&(data))
+#define HDMI_APTMCR1_get_plltm(data)                            ((0x00000040&(data))>>6)
+#define HDMI_APTMCR1_get_fpsd(data)                             ((0x00000020&(data))>>5)
+#define HDMI_APTMCR1_get_spsd(data)                             ((0x00000010&(data))>>4)
+#define HDMI_APTMCR1_get_nfpss(data)                            (0x0000000F&(data))
+
+
+#define HDMI_NPECR                                              0x360
+#define HDMI_NPECR_reg_addr                                     "0x98034360"
+#define HDMI_NPECR_reg                                          0x98034360
+#define HDMI_NPECR_inst_addr                                    "0x00D8"
+#define HDMI_NPECR_inst                                         0x00D8
+#define HDMI_NPECR_ncts_disable_pe_check_en_shift               (31)
+#define HDMI_NPECR_ncts_re_enable_off_en_shift                  (30)
+#define HDMI_NPECR_ncts_disable_pe_check_status_shift           (29)
+#define HDMI_NPECR_ncts_disable_pe_check_irq_en_shift           (28)
+#define HDMI_NPECR_dummy98034360_27_20_shift                    (20)
+#define HDMI_NPECR_ncts_disable_pe_check_cnt_shift              (0)
+#define HDMI_NPECR_ncts_disable_pe_check_en_mask                (0x80000000)
+#define HDMI_NPECR_ncts_re_enable_off_en_mask                   (0x40000000)
+#define HDMI_NPECR_ncts_disable_pe_check_status_mask            (0x20000000)
+#define HDMI_NPECR_ncts_disable_pe_check_irq_en_mask            (0x10000000)
+#define HDMI_NPECR_dummy98034360_27_20_mask                     (0x0FF00000)
+#define HDMI_NPECR_ncts_disable_pe_check_cnt_mask               (0x000FFFFF)
+#define HDMI_NPECR_ncts_disable_pe_check_en(data)               (0x80000000&((data)<<31))
+#define HDMI_NPECR_ncts_re_enable_off_en(data)                  (0x40000000&((data)<<30))
+#define HDMI_NPECR_ncts_disable_pe_check_status(data)           (0x20000000&((data)<<29))
+#define HDMI_NPECR_ncts_disable_pe_check_irq_en(data)           (0x10000000&((data)<<28))
+#define HDMI_NPECR_dummy98034360_27_20(data)                    (0x0FF00000&((data)<<20))
+#define HDMI_NPECR_ncts_disable_pe_check_cnt(data)              (0x000FFFFF&(data))
+#define HDMI_NPECR_get_ncts_disable_pe_check_en(data)           ((0x80000000&(data))>>31)
+#define HDMI_NPECR_get_ncts_re_enable_off_en(data)              ((0x40000000&(data))>>30)
+#define HDMI_NPECR_get_ncts_disable_pe_check_status(data)       ((0x20000000&(data))>>29)
+#define HDMI_NPECR_get_ncts_disable_pe_check_irq_en(data)       ((0x10000000&(data))>>28)
+#define HDMI_NPECR_get_dummy98034360_27_20(data)                ((0x0FF00000&(data))>>20)
+#define HDMI_NPECR_get_ncts_disable_pe_check_cnt(data)          (0x000FFFFF&(data))
+
+
+#define HDMI_NROR                                               0x364
+#define HDMI_NROR_reg_addr                                      "0x98034364"
+#define HDMI_NROR_reg                                           0x98034364
+#define HDMI_NROR_inst_addr                                     "0x00D9"
+#define HDMI_NROR_inst                                          0x00D9
+#define HDMI_NROR_ncts_re_enable_off_start_shift                (16)
+#define HDMI_NROR_ncts_re_enable_off_end_shift                  (0)
+#define HDMI_NROR_ncts_re_enable_off_start_mask                 (0xFFFF0000)
+#define HDMI_NROR_ncts_re_enable_off_end_mask                   (0x0000FFFF)
+#define HDMI_NROR_ncts_re_enable_off_start(data)                (0xFFFF0000&((data)<<16))
+#define HDMI_NROR_ncts_re_enable_off_end(data)                  (0x0000FFFF&(data))
+#define HDMI_NROR_get_ncts_re_enable_off_start(data)            ((0xFFFF0000&(data))>>16)
+#define HDMI_NROR_get_ncts_re_enable_off_end(data)              (0x0000FFFF&(data))
+
+
+#define HDMI_NTX1024TR0_THRESHOLD                               0x368
+#define HDMI_NTX1024TR0_THRESHOLD_reg_addr                      "0x98034368"
+#define HDMI_NTX1024TR0_THRESHOLD_reg                           0x98034368
+#define HDMI_NTX1024TR0_THRESHOLD_inst_addr                     "0x00DA"
+#define HDMI_NTX1024TR0_THRESHOLD_inst                          0x00DA
+#define HDMI_NTX1024TR0_THRESHOLD_over_threshold_shift          (31)
+#define HDMI_NTX1024TR0_THRESHOLD_under_threshold_shift         (30)
+#define HDMI_NTX1024TR0_THRESHOLD_wd_by_tmds_clk_shift          (29)
+#define HDMI_NTX1024TR0_THRESHOLD_irq_by_tmds_clk_shift         (28)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_up_threshold_shift         (16)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_low_threshold_shift        (0)
+#define HDMI_NTX1024TR0_THRESHOLD_over_threshold_mask           (0x80000000)
+#define HDMI_NTX1024TR0_THRESHOLD_under_threshold_mask          (0x40000000)
+#define HDMI_NTX1024TR0_THRESHOLD_wd_by_tmds_clk_mask           (0x20000000)
+#define HDMI_NTX1024TR0_THRESHOLD_irq_by_tmds_clk_mask          (0x10000000)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_up_threshold_mask          (0x0FFF0000)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_low_threshold_mask         (0x00000FFF)
+#define HDMI_NTX1024TR0_THRESHOLD_over_threshold(data)          (0x80000000&((data)<<31))
+#define HDMI_NTX1024TR0_THRESHOLD_under_threshold(data)         (0x40000000&((data)<<30))
+#define HDMI_NTX1024TR0_THRESHOLD_wd_by_tmds_clk(data)          (0x20000000&((data)<<29))
+#define HDMI_NTX1024TR0_THRESHOLD_irq_by_tmds_clk(data)         (0x10000000&((data)<<28))
+#define HDMI_NTX1024TR0_THRESHOLD_nt_up_threshold(data)         (0x0FFF0000&((data)<<16))
+#define HDMI_NTX1024TR0_THRESHOLD_nt_low_threshold(data)        (0x00000FFF&(data))
+#define HDMI_NTX1024TR0_THRESHOLD_get_over_threshold(data)      ((0x80000000&(data))>>31)
+#define HDMI_NTX1024TR0_THRESHOLD_get_under_threshold(data)     ((0x40000000&(data))>>30)
+#define HDMI_NTX1024TR0_THRESHOLD_get_wd_by_tmds_clk(data)      ((0x20000000&(data))>>29)
+#define HDMI_NTX1024TR0_THRESHOLD_get_irq_by_tmds_clk(data)     ((0x10000000&(data))>>28)
+#define HDMI_NTX1024TR0_THRESHOLD_get_nt_up_threshold(data)     ((0x0FFF0000&(data))>>16)
+#define HDMI_NTX1024TR0_THRESHOLD_get_nt_low_threshold(data)    (0x00000FFF&(data))
+
+
+#define HDMI_APLLCR0                                            0x380
+#define HDMI_APLLCR0_reg_addr                                   "0x98034380"
+#define HDMI_APLLCR0_reg                                        0x98034380
+#define HDMI_APLLCR0_inst_addr                                  "0x00E0"
+#define HDMI_APLLCR0_inst                                       0x00E0
+#define HDMI_APLLCR0_dpll_reg_shift                             (30)
+#define HDMI_APLLCR0_dpll_m_shift                               (22)
+#define HDMI_APLLCR0_dpll_reser_shift                           (17)
+#define HDMI_APLLCR0_dpll_bpsin_shift                           (16)
+#define HDMI_APLLCR0_dpll_o_shift                               (14)
+#define HDMI_APLLCR0_dpll_n_shift                               (6)
+#define HDMI_APLLCR0_dpll_rs_shift                              (3)
+#define HDMI_APLLCR0_dpll_ip_shift                              (0)
+#define HDMI_APLLCR0_dpll_reg_mask                              (0xC0000000)
+#define HDMI_APLLCR0_dpll_m_mask                                (0x3FC00000)
+#define HDMI_APLLCR0_dpll_reser_mask                            (0x001E0000)
+#define HDMI_APLLCR0_dpll_bpsin_mask                            (0x00010000)
+#define HDMI_APLLCR0_dpll_o_mask                                (0x0000C000)
+#define HDMI_APLLCR0_dpll_n_mask                                (0x000001C0)
+#define HDMI_APLLCR0_dpll_rs_mask                               (0x00000038)
+#define HDMI_APLLCR0_dpll_ip_mask                               (0x00000007)
+#define HDMI_APLLCR0_dpll_reg(data)                             (0xC0000000&((data)<<30))
+#define HDMI_APLLCR0_dpll_m(data)                               (0x3FC00000&((data)<<22))
+#define HDMI_APLLCR0_dpll_reser(data)                           (0x001E0000&((data)<<17))
+#define HDMI_APLLCR0_dpll_bpsin(data)                           (0x00010000&((data)<<16))
+#define HDMI_APLLCR0_dpll_o(data)                               (0x0000C000&((data)<<14))
+#define HDMI_APLLCR0_dpll_n(data)                               (0x000001C0&((data)<<6))
+#define HDMI_APLLCR0_dpll_rs(data)                              (0x00000038&((data)<<3))
+#define HDMI_APLLCR0_dpll_ip(data)                              (0x00000007&(data))
+#define HDMI_APLLCR0_get_dpll_reg(data)                         ((0xC0000000&(data))>>30)
+#define HDMI_APLLCR0_get_dpll_m(data)                           ((0x3FC00000&(data))>>22)
+#define HDMI_APLLCR0_get_dpll_reser(data)                       ((0x001E0000&(data))>>17)
+#define HDMI_APLLCR0_get_dpll_bpsin(data)                       ((0x00010000&(data))>>16)
+#define HDMI_APLLCR0_get_dpll_o(data)                           ((0x0000C000&(data))>>14)
+#define HDMI_APLLCR0_get_dpll_n(data)                           ((0x000001C0&(data))>>6)
+#define HDMI_APLLCR0_get_dpll_rs(data)                          ((0x00000038&(data))>>3)
+#define HDMI_APLLCR0_get_dpll_ip(data)                          (0x00000007&(data))
+
+
+#define HDMI_APLLCR1                                            0x384
+#define HDMI_APLLCR1_reg_addr                                   "0x98034384"
+#define HDMI_APLLCR1_reg                                        0x98034384
+#define HDMI_APLLCR1_inst_addr                                  "0x00E1"
+#define HDMI_APLLCR1_inst                                       0x00E1
+#define HDMI_APLLCR1_dpll_cp_shift                              (21)
+#define HDMI_APLLCR1_dpll_seltst_shift                          (19)
+#define HDMI_APLLCR1_dpll_cs_shift                              (17)
+#define HDMI_APLLCR1_dpll_reserve_shift                         (9)
+#define HDMI_APLLCR1_dpll_bpspsw_shift                          (8)
+#define HDMI_APLLCR1_dpll_wdo_shift                             (7)
+#define HDMI_APLLCR1_dpll_wdrst_shift                           (6)
+#define HDMI_APLLCR1_dpll_wdset_shift                           (5)
+#define HDMI_APLLCR1_dpll_rstb_shift                            (4)
+#define HDMI_APLLCR1_dpll_stoppsw_shift                         (3)
+#define HDMI_APLLCR1_dpll_freeze_shift                          (2)
+#define HDMI_APLLCR1_dpll_vcorstb_shift                         (1)
+#define HDMI_APLLCR1_dpll_pow_shift                             (0)
+#define HDMI_APLLCR1_dpll_CS_MASK                               ((1<<18)|(1<<17))
+#define HDMI_APLLCR1_dpll_CS_20P                                (0)
+#define HDMI_APLLCR1_dpll_CS_25P                                (1<<17)
+#define HDMI_APLLCR1_dpll_CS_30P                                (2<<17)
+#define HDMI_APLLCR1_dpll_CS_35P                                (3<<17)
+#define HDMI_APLLCR1_dpll_cp_mask                               (0x00600000)
+#define HDMI_APLLCR1_dpll_seltst_mask                           (0x00180000)
+#define HDMI_APLLCR1_dpll_cs_mask                               (0x00060000)
+#define HDMI_APLLCR1_dpll_reserve_mask                          (0x00000200)
+#define HDMI_APLLCR1_dpll_bpspsw_mask                           (0x00000100)
+#define HDMI_APLLCR1_dpll_wdo_mask                              (0x00000080)
+#define HDMI_APLLCR1_dpll_wdrst_mask                            (0x00000040)
+#define HDMI_APLLCR1_dpll_wdset_mask                            (0x00000020)
+#define HDMI_APLLCR1_dpll_rstb_mask                             (0x00000010)
+#define HDMI_APLLCR1_dpll_stoppsw_mask                          (0x00000008)
+#define HDMI_APLLCR1_dpll_freeze_mask                           (0x00000004)
+#define HDMI_APLLCR1_dpll_vcorstb_mask                          (0x00000002)
+#define HDMI_APLLCR1_dpll_pow_mask                              (0x00000001)
+#define HDMI_APLLCR1_dpll_cp(data)                              (0x00600000&((data)<<21))
+#define HDMI_APLLCR1_dpll_seltst(data)                          (0x00180000&((data)<<19))
+#define HDMI_APLLCR1_dpll_cs(data)                              (0x00060000&((data)<<17))
+#define HDMI_APLLCR1_dpll_reserve(data)                         (0x00000200&((data)<<9))
+#define HDMI_APLLCR1_dpll_bpspsw(data)                          (0x00000100&((data)<<8))
+#define HDMI_APLLCR1_dpll_wdo(data)                             (0x00000080&((data)<<7))
+#define HDMI_APLLCR1_dpll_wdrst(data)                           (0x00000040&((data)<<6))
+#define HDMI_APLLCR1_dpll_wdset(data)                           (0x00000020&((data)<<5))
+#define HDMI_APLLCR1_dpll_rstb(data)                            (0x00000010&((data)<<4))
+#define HDMI_APLLCR1_dpll_stoppsw(data)                         (0x00000008&((data)<<3))
+#define HDMI_APLLCR1_dpll_freeze(data)                          (0x00000004&((data)<<2))
+#define HDMI_APLLCR1_dpll_vcorstb(data)                         (0x00000002&((data)<<1))
+#define HDMI_APLLCR1_dpll_pow(data)                             (0x00000001&(data))
+#define HDMI_APLLCR1_get_dpll_cp(data)                          ((0x00600000&(data))>>21)
+#define HDMI_APLLCR1_get_dpll_seltst(data)                      ((0x00180000&(data))>>19)
+#define HDMI_APLLCR1_get_dpll_cs(data)                          ((0x00060000&(data))>>17)
+#define HDMI_APLLCR1_get_dpll_reserve(data)                     ((0x00000200&(data))>>9)
+#define HDMI_APLLCR1_get_dpll_bpspsw(data)                      ((0x00000100&(data))>>8)
+#define HDMI_APLLCR1_get_dpll_wdo(data)                         ((0x00000080&(data))>>7)
+#define HDMI_APLLCR1_get_dpll_wdrst(data)                       ((0x00000040&(data))>>6)
+#define HDMI_APLLCR1_get_dpll_wdset(data)                       ((0x00000020&(data))>>5)
+#define HDMI_APLLCR1_get_dpll_rstb(data)                        ((0x00000010&(data))>>4)
+#define HDMI_APLLCR1_get_dpll_stoppsw(data)                     ((0x00000008&(data))>>3)
+#define HDMI_APLLCR1_get_dpll_freeze(data)                      ((0x00000004&(data))>>2)
+#define HDMI_APLLCR1_get_dpll_vcorstb(data)                     ((0x00000002&(data))>>1)
+#define HDMI_APLLCR1_get_dpll_pow(data)                         (0x00000001&(data))
+
+
+#define HDMI_APLLCR2                                            0x388
+#define HDMI_APLLCR2_reg_addr                                   "0x98034388"
+#define HDMI_APLLCR2_reg                                        0x98034388
+#define HDMI_APLLCR2_inst_addr                                  "0x00E2"
+#define HDMI_APLLCR2_inst                                       0x00E2
+#define HDMI_APLLCR2_dpll_reloadm_shift                         (0)
+#define HDMI_APLLCR2_dpll_reloadm_mask                          (0x00000001)
+#define HDMI_APLLCR2_dpll_reloadm(data)                         (0x00000001&(data))
+#define HDMI_APLLCR2_get_dpll_reloadm(data)                     (0x00000001&(data))
+
+
+#define HDMI_APLLCR3                                            0x38c
+#define HDMI_APLLCR3_reg_addr                                   "0x9803438c"
+#define HDMI_APLLCR3_reg                                        0x9803438c
+#define HDMI_APLLCR3_inst_addr                                  "0x00E3"
+#define HDMI_APLLCR3_inst                                       0x00E3
+#define HDMI_APLLCR3_sum_c_samp_shift                           (0)
+#define HDMI_APLLCR3_sum_c_samp_mask                            (0x0000FFFF)
+#define HDMI_APLLCR3_sum_c_samp(data)                           (0x0000FFFF&(data))
+#define HDMI_APLLCR3_get_sum_c_samp(data)                       (0x0000FFFF&(data))
+
+
+#define HDMI_APLL_TESTM                                         0x390
+#define HDMI_APLL_TESTM_reg_addr                                "0x98034390"
+#define HDMI_APLL_TESTM_reg                                     0x98034390
+#define HDMI_APLL_TESTM_inst_addr                               "0x00E4"
+#define HDMI_APLL_TESTM_inst                                    0x00E4
+#define HDMI_APLL_TESTM_dpll_m_test_shift                       (22)
+#define HDMI_APLL_TESTM_dpll_m_db_shift                         (1)
+#define HDMI_APLL_TESTM_dpll_m_sel_shift                        (0)
+#define HDMI_APLL_TESTM_dpll_m_test_mask                        (0x3FC00000)
+#define HDMI_APLL_TESTM_dpll_m_db_mask                          (0x00000002)
+#define HDMI_APLL_TESTM_dpll_m_sel_mask                         (0x00000001)
+#define HDMI_APLL_TESTM_dpll_m_test(data)                       (0x3FC00000&((data)<<22))
+#define HDMI_APLL_TESTM_dpll_m_db(data)                         (0x00000002&((data)<<1))
+#define HDMI_APLL_TESTM_dpll_m_sel(data)                        (0x00000001&(data))
+#define HDMI_APLL_TESTM_get_dpll_m_test(data)                   ((0x3FC00000&(data))>>22)
+#define HDMI_APLL_TESTM_get_dpll_m_db(data)                     ((0x00000002&(data))>>1)
+#define HDMI_APLL_TESTM_get_dpll_m_sel(data)                    (0x00000001&(data))
+
+
+#define HDMI_VPLLCR0                                            0x400
+#define HDMI_VPLLCR0_reg_addr                                   "0x98034400"
+#define HDMI_VPLLCR0_reg                                        0x98034400
+#define HDMI_VPLLCR0_inst_addr                                  "0x0100"
+#define HDMI_VPLLCR0_inst                                       0x0100
+#define HDMI_VPLLCR0_dpll_reg_shift                             (30)
+#define HDMI_VPLLCR0_dpll_m_shift                               (22)
+#define HDMI_VPLLCR0_dpll_reser_shift                           (17)
+#define HDMI_VPLLCR0_dpll_bpsin_shift                           (16)
+#define HDMI_VPLLCR0_dpll_o_shift                               (14)
+#define HDMI_VPLLCR0_dpll_n_shift                               (6)
+#define HDMI_VPLLCR0_dpll_rs_shift                              (3)
+#define HDMI_VPLLCR0_dpll_ip_shift                              (0)
+#define HDMI_VPLLCR0_dpll_reg_mask                              (0xC0000000)
+#define HDMI_VPLLCR0_dpll_m_mask                                (0x3FC00000)
+#define HDMI_VPLLCR0_dpll_reser_mask                            (0x001E0000)
+#define HDMI_VPLLCR0_dpll_bpsin_mask                            (0x00010000)
+#define HDMI_VPLLCR0_dpll_o_mask                                (0x0000C000)
+#define HDMI_VPLLCR0_dpll_n_mask                                (0x000001C0)
+#define HDMI_VPLLCR0_dpll_rs_mask                               (0x00000038)
+#define HDMI_VPLLCR0_dpll_ip_mask                               (0x00000007)
+#define HDMI_VPLLCR0_dpll_reg(data)                             (0xC0000000&((data)<<30))
+#define HDMI_VPLLCR0_dpll_m(data)                               (0x3FC00000&((data)<<22))
+#define HDMI_VPLLCR0_dpll_reser(data)                           (0x001E0000&((data)<<17))
+#define HDMI_VPLLCR0_dpll_bpsin(data)                           (0x00010000&((data)<<16))
+#define HDMI_VPLLCR0_dpll_o(data)                               (0x0000C000&((data)<<14))
+#define HDMI_VPLLCR0_dpll_n(data)                               (0x000001C0&((data)<<6))
+#define HDMI_VPLLCR0_dpll_rs(data)                              (0x00000038&((data)<<3))
+#define HDMI_VPLLCR0_dpll_ip(data)                              (0x00000007&(data))
+#define HDMI_VPLLCR0_get_dpll_reg(data)                         ((0xC0000000&(data))>>30)
+#define HDMI_VPLLCR0_get_dpll_m(data)                           ((0x3FC00000&(data))>>22)
+#define HDMI_VPLLCR0_get_dpll_reser(data)                       ((0x001E0000&(data))>>17)
+#define HDMI_VPLLCR0_get_dpll_bpsin(data)                       ((0x00010000&(data))>>16)
+#define HDMI_VPLLCR0_get_dpll_o(data)                           ((0x0000C000&(data))>>14)
+#define HDMI_VPLLCR0_get_dpll_n(data)                           ((0x000001C0&(data))>>6)
+#define HDMI_VPLLCR0_get_dpll_rs(data)                          ((0x00000038&(data))>>3)
+#define HDMI_VPLLCR0_get_dpll_ip(data)                          (0x00000007&(data))
+
+
+#define HDMI_VPLLCR1                                            0x404
+#define HDMI_VPLLCR1_reg_addr                                   "0x98034404"
+#define HDMI_VPLLCR1_reg                                        0x98034404
+#define HDMI_VPLLCR1_inst_addr                                  "0x0101"
+#define HDMI_VPLLCR1_inst                                       0x0101
+#define HDMI_VPLLCR1_dpll_cp_shift                              (21)
+#define HDMI_VPLLCR1_dpll_seltst_shift                          (19)
+#define HDMI_VPLLCR1_dpll_cs_shift                              (17)
+#define HDMI_VPLLCR1_dpll_ldo_pow_shift                         (12)
+#define HDMI_VPLLCR1_dpll_ldo_sel_shift                         (10)
+#define HDMI_VPLLCR1_dpll_reserve_shift                         (9)
+#define HDMI_VPLLCR1_dpll_bpspsw_shift                          (8)
+#define HDMI_VPLLCR1_dpll_wdo_shift                             (7)
+#define HDMI_VPLLCR1_dpll_wdrst_shift                           (6)
+#define HDMI_VPLLCR1_dpll_wdset_shift                           (5)
+#define HDMI_VPLLCR1_dpll_rstb_shift                            (4)
+#define HDMI_VPLLCR1_dpll_stoppsw_shift                         (3)
+#define HDMI_VPLLCR1_dpll_freeze_shift                          (2)
+#define HDMI_VPLLCR1_dpll_vcorstb_shift                         (1)
+#define HDMI_VPLLCR1_dpll_pow_shift                             (0)
+#define HDMI_VPLLCR1_dpll_cp_mask                               (0x00600000)
+#define HDMI_VPLLCR1_dpll_seltst_mask                           (0x00180000)
+#define HDMI_VPLLCR1_dpll_cs_mask                               (0x00060000)
+#define HDMI_VPLLCR1_dpll_ldo_pow_mask                          (0x00001000)
+#define HDMI_VPLLCR1_dpll_ldo_sel_mask                          (0x00000C00)
+#define HDMI_VPLLCR1_dpll_reserve_mask                          (0x00000200)
+#define HDMI_VPLLCR1_dpll_bpspsw_mask                           (0x00000100)
+#define HDMI_VPLLCR1_dpll_wdo_mask                              (0x00000080)
+#define HDMI_VPLLCR1_dpll_wdrst_mask                            (0x00000040)
+#define HDMI_VPLLCR1_dpll_wdset_mask                            (0x00000020)
+#define HDMI_VPLLCR1_dpll_rstb_mask                             (0x00000010)
+#define HDMI_VPLLCR1_dpll_stoppsw_mask                          (0x00000008)
+#define HDMI_VPLLCR1_dpll_freeze_mask                           (0x00000004)
+#define HDMI_VPLLCR1_dpll_vcorstb_mask                          (0x00000002)
+#define HDMI_VPLLCR1_dpll_pow_mask                              (0x00000001)
+#define HDMI_VPLLCR1_dpll_cp(data)                              (0x00600000&((data)<<21))
+#define HDMI_VPLLCR1_dpll_seltst(data)                          (0x00180000&((data)<<19))
+#define HDMI_VPLLCR1_dpll_cs(data)                              (0x00060000&((data)<<17))
+#define HDMI_VPLLCR1_dpll_ldo_pow(data)                         (0x00001000&((data)<<12))
+#define HDMI_VPLLCR1_dpll_ldo_sel(data)                         (0x00000C00&((data)<<10))
+#define HDMI_VPLLCR1_dpll_reserve(data)                         (0x00000200&((data)<<9))
+#define HDMI_VPLLCR1_dpll_bpspsw(data)                          (0x00000100&((data)<<8))
+#define HDMI_VPLLCR1_dpll_wdo(data)                             (0x00000080&((data)<<7))
+#define HDMI_VPLLCR1_dpll_wdrst(data)                           (0x00000040&((data)<<6))
+#define HDMI_VPLLCR1_dpll_wdset(data)                           (0x00000020&((data)<<5))
+#define HDMI_VPLLCR1_dpll_rstb(data)                            (0x00000010&((data)<<4))
+#define HDMI_VPLLCR1_dpll_stoppsw(data)                         (0x00000008&((data)<<3))
+#define HDMI_VPLLCR1_dpll_freeze(data)                          (0x00000004&((data)<<2))
+#define HDMI_VPLLCR1_dpll_vcorstb(data)                         (0x00000002&((data)<<1))
+#define HDMI_VPLLCR1_dpll_pow(data)                             (0x00000001&(data))
+#define HDMI_VPLLCR1_get_dpll_cp(data)                          ((0x00600000&(data))>>21)
+#define HDMI_VPLLCR1_get_dpll_seltst(data)                      ((0x00180000&(data))>>19)
+#define HDMI_VPLLCR1_get_dpll_cs(data)                          ((0x00060000&(data))>>17)
+#define HDMI_VPLLCR1_get_dpll_ldo_pow(data)                     ((0x00001000&(data))>>12)
+#define HDMI_VPLLCR1_get_dpll_ldo_sel(data)                     ((0x00000C00&(data))>>10)
+#define HDMI_VPLLCR1_get_dpll_reserve(data)                     ((0x00000200&(data))>>9)
+#define HDMI_VPLLCR1_get_dpll_bpspsw(data)                      ((0x00000100&(data))>>8)
+#define HDMI_VPLLCR1_get_dpll_wdo(data)                         ((0x00000080&(data))>>7)
+#define HDMI_VPLLCR1_get_dpll_wdrst(data)                       ((0x00000040&(data))>>6)
+#define HDMI_VPLLCR1_get_dpll_wdset(data)                       ((0x00000020&(data))>>5)
+#define HDMI_VPLLCR1_get_dpll_rstb(data)                        ((0x00000010&(data))>>4)
+#define HDMI_VPLLCR1_get_dpll_stoppsw(data)                     ((0x00000008&(data))>>3)
+#define HDMI_VPLLCR1_get_dpll_freeze(data)                      ((0x00000004&(data))>>2)
+#define HDMI_VPLLCR1_get_dpll_vcorstb(data)                     ((0x00000002&(data))>>1)
+#define HDMI_VPLLCR1_get_dpll_pow(data)                         (0x00000001&(data))
+
+
+#define HDMI_VPLLCR2                                            0x408
+#define HDMI_VPLLCR2_reg_addr                                   "0x98034408"
+#define HDMI_VPLLCR2_reg                                        0x98034408
+#define HDMI_VPLLCR2_inst_addr                                  "0x0102"
+#define HDMI_VPLLCR2_inst                                       0x0102
+#define HDMI_VPLLCR2_dpll_reloadm_shift                         (0)
+#define HDMI_VPLLCR2_dpll_reloadm_mask                          (0x00000001)
+#define HDMI_VPLLCR2_dpll_reloadm(data)                         (0x00000001&(data))
+#define HDMI_VPLLCR2_get_dpll_reloadm(data)                     (0x00000001&(data))
+
+
+#define HDMI_MN_SCLKG_CTRL                                           0x410
+#define HDMI_MN_SCLKG_CTRL_reg_addr                                  "0x98034410"
+#define HDMI_MN_SCLKG_CTRL_reg                                       0x98034410
+#define HDMI_MN_SCLKG_CTRL_inst_addr                                 "0x0104"
+#define HDMI_MN_SCLKG_CTRL_inst                                      0x0104
+#define HDMI_MN_SCLKG_CTRL_sclkg_pll_in_sel_shift                    (7)
+#define HDMI_MN_SCLKG_CTRL_sclkg_oclk_sel_shift                      (5)
+#define HDMI_MN_SCLKG_CTRL_sclkg_dbuf_shift                          (4)
+#define HDMI_MN_SCLKG_CTRL_dummy98034410_3_0_shift                   (0)
+#define HDMI_MN_SCLKG_CTRL_sclkg_pll_in_sel_mask                     (0x00000080)
+#define HDMI_MN_SCLKG_CTRL_sclkg_oclk_sel_mask                       (0x00000060)
+#define HDMI_MN_SCLKG_CTRL_sclkg_dbuf_mask                           (0x00000010)
+#define HDMI_MN_SCLKG_CTRL_dummy98034410_3_0_mask                    (0x0000000F)
+#define HDMI_MN_SCLKG_CTRL_sclkg_pll_in_sel(data)                    (0x00000080&((data)<<7))
+#define HDMI_MN_SCLKG_CTRL_sclkg_oclk_sel(data)                      (0x00000060&((data)<<5))
+#define HDMI_MN_SCLKG_CTRL_sclkg_dbuf(data)                          (0x00000010&((data)<<4))
+#define HDMI_MN_SCLKG_CTRL_dummy98034410_3_0(data)                   (0x0000000F&(data))
+#define HDMI_MN_SCLKG_CTRL_get_sclkg_pll_in_sel(data)                ((0x00000080&(data))>>7)
+#define HDMI_MN_SCLKG_CTRL_get_sclkg_oclk_sel(data)                  ((0x00000060&(data))>>5)
+#define HDMI_MN_SCLKG_CTRL_get_sclkg_dbuf(data)                      ((0x00000010&(data))>>4)
+#define HDMI_MN_SCLKG_CTRL_get_dummy98034410_3_0(data)               (0x0000000F&(data))
+
+
+#define HDMI_MN_SCLKG_DIVS                                           0x414
+#define HDMI_MN_SCLKG_DIVS_reg_addr                                  "0x98034414"
+#define HDMI_MN_SCLKG_DIVS_reg                                       0x98034414
+#define HDMI_MN_SCLKG_DIVS_inst_addr                                 "0x0105"
+#define HDMI_MN_SCLKG_DIVS_inst                                      0x0105
+#define HDMI_MN_SCLKG_DIVS_sclkg_pll_div2_en_shift                   (7)
+#define HDMI_MN_SCLKG_DIVS_sclkg_pll_divs_shift                      (0)
+#define HDMI_MN_SCLKG_DIVS_sclkg_pll_div2_en_mask                    (0x00000080)
+#define HDMI_MN_SCLKG_DIVS_sclkg_pll_divs_mask                       (0x0000007F)
+#define HDMI_MN_SCLKG_DIVS_sclkg_pll_div2_en(data)                   (0x00000080&((data)<<7))
+#define HDMI_MN_SCLKG_DIVS_sclkg_pll_divs(data)                      (0x0000007F&(data))
+#define HDMI_MN_SCLKG_DIVS_get_sclkg_pll_div2_en(data)               ((0x00000080&(data))>>7)
+#define HDMI_MN_SCLKG_DIVS_get_sclkg_pll_divs(data)                  (0x0000007F&(data))
+
+
+#define HDMI_MDD_CR                                                  0x500
+#define HDMI_MDD_CR_reg_addr                                         "0x98034500"
+#define HDMI_MDD_CR_reg                                              0x98034500
+#define HDMI_MDD_CR_inst_addr                                        "0x0140"
+#define HDMI_MDD_CR_inst                                             0x0140
+#define HDMI_MDD_CR_dummy98034500_16_8_shift                         (8)
+#define HDMI_MDD_CR_dummy98034500_7_5_shift                          (5)
+#define HDMI_MDD_CR_det_con_shift                                    (4)
+#define HDMI_MDD_CR_irq_det_chg_en_shift                             (3)
+#define HDMI_MDD_CR_dummy98034500_2_1_shift                          (1)
+#define HDMI_MDD_CR_en_shift                                         (0)
+#define HDMI_MDD_CR_dummy98034500_16_8_mask                          (0x0001FF00)
+#define HDMI_MDD_CR_dummy98034500_7_5_mask                           (0x000000E0)
+#define HDMI_MDD_CR_det_con_mask                                     (0x00000010)
+#define HDMI_MDD_CR_irq_det_chg_en_mask                              (0x00000008)
+#define HDMI_MDD_CR_dummy98034500_2_1_mask                           (0x00000006)
+#define HDMI_MDD_CR_en_mask                                          (0x00000001)
+#define HDMI_MDD_CR_dummy98034500_16_8(data)                         (0x0001FF00&((data)<<8))
+#define HDMI_MDD_CR_dummy98034500_7_5(data)                          (0x000000E0&((data)<<5))
+#define HDMI_MDD_CR_det_con(data)                                    (0x00000010&((data)<<4))
+#define HDMI_MDD_CR_irq_det_chg_en(data)                             (0x00000008&((data)<<3))
+#define HDMI_MDD_CR_dummy98034500_2_1(data)                          (0x00000006&((data)<<1))
+#define HDMI_MDD_CR_en(data)                                         (0x00000001&(data))
+#define HDMI_MDD_CR_get_dummy98034500_16_8(data)                     ((0x0001FF00&(data))>>8)
+#define HDMI_MDD_CR_get_dummy98034500_7_5(data)                      ((0x000000E0&(data))>>5)
+#define HDMI_MDD_CR_get_det_con(data)                                ((0x00000010&(data))>>4)
+#define HDMI_MDD_CR_get_irq_det_chg_en(data)                         ((0x00000008&(data))>>3)
+#define HDMI_MDD_CR_get_dummy98034500_2_1(data)                      ((0x00000006&(data))>>1)
+#define HDMI_MDD_CR_get_en(data)                                     (0x00000001&(data))
+
+
+#define HDMI_MDD_SR                                                  0x504
+#define HDMI_MDD_SR_reg_addr                                         "0x98034504"
+#define HDMI_MDD_SR_reg                                              0x98034504
+#define HDMI_MDD_SR_inst_addr                                        "0x0141"
+#define HDMI_MDD_SR_inst                                             0x0141
+#define HDMI_MDD_SR_det_result_chg_shift                             (1)
+#define HDMI_MDD_SR_det_result_shift                                 (0)
+#define HDMI_MDD_SR_det_result_chg_mask                              (0x00000002)
+#define HDMI_MDD_SR_det_result_mask                                  (0x00000001)
+#define HDMI_MDD_SR_det_result_chg(data)                             (0x00000002&((data)<<1))
+#define HDMI_MDD_SR_det_result(data)                                 (0x00000001&(data))
+#define HDMI_MDD_SR_get_det_result_chg(data)                         ((0x00000002&(data))>>1)
+#define HDMI_MDD_SR_get_det_result(data)                             (0x00000001&(data))
+
+
+#define HDMI_FW_FUNC                                                 0x508
+#define HDMI_FW_FUNC_reg_addr                                        "0x98034508"
+#define HDMI_FW_FUNC_reg                                             0x98034508
+#define HDMI_FW_FUNC_inst_addr                                       "0x0142"
+#define HDMI_FW_FUNC_inst                                            0x0142
+#define HDMI_FW_FUNC_application_shift                               (0)
+#define HDMI_FW_FUNC_application_mask                                (0xFFFFFFFF)
+#define HDMI_FW_FUNC_application(data)                               (0xFFFFFFFF&(data))
+#define HDMI_FW_FUNC_get_application(data)                           (0xFFFFFFFF&(data))
+
+
+#define HDMI_PORT_SWITCH                                             0x50c
+#define HDMI_PORT_SWITCH_reg_addr                                    "0x9803450c"
+#define HDMI_PORT_SWITCH_reg                                         0x9803450c
+#define HDMI_PORT_SWITCH_inst_addr                                   "0x0143"
+#define HDMI_PORT_SWITCH_inst                                        0x0143
+#define HDMI_PORT_SWITCH_port_sel_shift                              (2)
+#define HDMI_PORT_SWITCH_offms_port_sel_shift                        (0)
+#define HDMI_PORT_SWITCH_port_sel_mask                               (0x0000000C)
+#define HDMI_PORT_SWITCH_offms_port_sel_mask                         (0x00000003)
+#define HDMI_PORT_SWITCH_port_sel(data)                              (0x0000000C&((data)<<2))
+#define HDMI_PORT_SWITCH_offms_port_sel(data)                        (0x00000003&(data))
+#define HDMI_PORT_SWITCH_get_port_sel(data)                          ((0x0000000C&(data))>>2)
+#define HDMI_PORT_SWITCH_get_offms_port_sel(data)                    (0x00000003&(data))
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/hdmirx_wrapper_reg.h b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/hdmirx_wrapper_reg.h
new file mode 100644
index 00000000..b397cf5
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/hdmirx_wrapper_reg.h
@@ -0,0 +1,327 @@
+/*
+ * hdmirx_wrapper_reg.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDMIRX_WRAPPER_REG_H_INCLUDED_
+#define _HDMIRX_WRAPPER_REG_H_INCLUDED_
+
+#define HDMIRX_WRAPPER_DEN_BUF01                                                     0x00
+#define HDMIRX_WRAPPER_DEN_BUF01_reg_addr                                            "0x98035F00"
+#define HDMIRX_WRAPPER_DEN_BUF01_reg                                                 0x98035F00
+#define HDMIRX_WRAPPER_DEN_BUF01_inst_adr                                            "0x00C0"
+#define HDMIRX_WRAPPER_DEN_BUF01_inst                                                0x00C0
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1_shift                                      (16)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1_mask                                       (0x1FFF0000)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1(data)                                      (0x1FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1_src(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF01_get_den_buf1(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0_shift                                      (0)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0_mask                                       (0x00001FFF)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0(data)                                      (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0_src(data)                                  ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_DEN_BUF01_get_den_buf0(data)                                  ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_DEN_BUF23                                                     0x04
+#define HDMIRX_WRAPPER_DEN_BUF23_reg_addr                                            "0x98035F04"
+#define HDMIRX_WRAPPER_DEN_BUF23_reg                                                 0x98035F04
+#define HDMIRX_WRAPPER_DEN_BUF23_inst_adr                                            "0x00C1"
+#define HDMIRX_WRAPPER_DEN_BUF23_inst                                                0x00C1
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3_shift                                      (16)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3_mask                                       (0x1FFF0000)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3(data)                                      (0x1FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3_src(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF23_get_den_buf3(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2_shift                                      (0)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2_mask                                       (0x00001FFF)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2(data)                                      (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2_src(data)                                  ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_DEN_BUF23_get_den_buf2(data)                                  ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_HOR_THRESHOLD                                                 0x08
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_reg_addr                                        "0x98035F08"
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_reg                                             0x98035F08
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_inst_adr                                        "0x00C2"
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_inst                                            0x00C2
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold_shift                             (0)
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold_mask                              (0x00001FFF)
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold(data)                             (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold_src(data)                         ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_get_hor_threshold(data)                         ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS                                                 0x0C
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_reg_addr                                        "0x98035F0C"
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_reg                                             0x98035F0C
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_inst_adr                                        "0x00C3"
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_inst                                            0x00C3
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width_shift                             (16)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width_mask                              (0x0FFF0000)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width(data)                             (0x0FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width_src(data)                         ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_get_set_ver_width(data)                         ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width_shift                             (0)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width_mask                              (0x00001FFF)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width(data)                             (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width_src(data)                         ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_get_set_hor_width(data)                         ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_MONITOR_0                                                     0x10
+#define HDMIRX_WRAPPER_MONITOR_0_reg_addr                                            "0x98035F10"
+#define HDMIRX_WRAPPER_MONITOR_0_reg                                                 0x98035F10
+#define HDMIRX_WRAPPER_MONITOR_0_inst_adr                                            "0x00C4"
+#define HDMIRX_WRAPPER_MONITOR_0_inst                                                0x00C4
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt_shift                                (16)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt_mask                                 (0x0FFF0000)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt(data)                                (0x0FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt_src(data)                            ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_MONITOR_0_get_polarity_l_cnt(data)                            ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt_shift                                (0)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt_mask                                 (0x00000FFF)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt(data)                                (0x00000FFF&((data)<<0))
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt_src(data)                            ((0x00000FFF&(data))>>0)
+#define HDMIRX_WRAPPER_MONITOR_0_get_polarity_h_cnt(data)                            ((0x00000FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_MONITOR_1                                                     0x14
+#define HDMIRX_WRAPPER_MONITOR_1_reg_addr                                            "0x98035F14"
+#define HDMIRX_WRAPPER_MONITOR_1_reg                                                 0x98035F14
+#define HDMIRX_WRAPPER_MONITOR_1_inst_adr                                            "0x00C5"
+#define HDMIRX_WRAPPER_MONITOR_1_inst                                                0x00C5
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity_shift                                  (12)
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity_mask                                   (0x00001000)
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity(data)                                  (0x00001000&((data)<<12))
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity_src(data)                              ((0x00001000&(data))>>12)
+#define HDMIRX_WRAPPER_MONITOR_1_get_mux_polarity(data)                              ((0x00001000&(data))>>12)
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0_shift                                     (0)
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0_mask                                      (0x00000FFF)
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0(data)                                     (0x00000FFF&((data)<<0))
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0_src(data)                                 ((0x00000FFF&(data))>>0)
+#define HDMIRX_WRAPPER_MONITOR_1_get_line_buf0(data)                                 ((0x00000FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_INTERRUPT_EN                                                  0x18
+#define HDMIRX_WRAPPER_INTERRUPT_EN_reg_addr                                         "0x98035F18"
+#define HDMIRX_WRAPPER_INTERRUPT_EN_reg                                              0x98035F18
+#define HDMIRX_WRAPPER_INTERRUPT_EN_inst_adr                                         "0x00C6"
+#define HDMIRX_WRAPPER_INTERRUPT_EN_inst                                             0x00C6
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_shift                                 (2)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_mask                                  (0x00000004)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en(data)                                 (0x00000004&((data)<<2))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_src(data)                             ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_get_ver_err_en(data)                             ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_shift                                 (1)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_mask                                  (0x00000002)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en(data)                                 (0x00000002&((data)<<1))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_src(data)                             ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_get_hor_err_en(data)                             ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_shift                         (0)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_mask                          (0x00000001)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en(data)                         (0x00000001&((data)<<0))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_src(data)                     ((0x00000001&(data))>>0)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_get_polarity_detect_en(data)                     ((0x00000001&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS                                              0x1C
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_reg_addr                                     "0x98035F1C"
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_reg                                          0x98035F1C
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_inst_adr                                     "0x00C7"
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_inst                                         0x00C7
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts_shift                            (2)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts_mask                             (0x00000004)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts(data)                            (0x00000004&((data)<<2))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts_src(data)                        ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_get_ver_err_sts(data)                        ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts_shift                            (1)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts_mask                             (0x00000002)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts(data)                            (0x00000002&((data)<<1))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts_src(data)                        ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_get_hor_err_sts(data)                        ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts_shift                    (0)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts_mask                     (0x00000001)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts(data)                    (0x00000001&((data)<<0))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts_src(data)                ((0x00000001&(data))>>0)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_get_polarity_detect_sts(data)                ((0x00000001&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_CONTROL_0                                                     0x20
+#define HDMIRX_WRAPPER_CONTROL_0_reg_addr                                            "0x98035F20"
+#define HDMIRX_WRAPPER_CONTROL_0_reg                                                 0x98035F20
+#define HDMIRX_WRAPPER_CONTROL_0_inst_adr                                            "0x00C8"
+#define HDMIRX_WRAPPER_CONTROL_0_inst                                                0x00C8
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_cbusrx_shift                              (13)
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_cbusrx_mask                               (0x00002000)
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_cbusrx(data)                              (0x00002000&((data)<<13))
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_cbusrx_src(data)                          ((0x00002000&(data))>>13)
+#define HDMIRX_WRAPPER_CONTROL_0_get_reg_clken_cbusrx(data)                          ((0x00002000&(data))>>13)
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx_shift                              (12)
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx_mask                               (0x00001000)
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx(data)                              (0x00001000&((data)<<12))
+#define HDMIRX_WRAPPER_CONTROL_0_reg_clken_hdmirx_src(data)                          ((0x00001000&(data))>>12)
+#define HDMIRX_WRAPPER_CONTROL_0_get_reg_clken_hdmirx(data)                          ((0x00001000&(data))>>12)
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage_shift                                    (11)
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage_mask                                     (0x00000800)
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage(data)                                    (0x00000800&((data)<<11))
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage_src(data)                                ((0x00000800&(data))>>11)
+#define HDMIRX_WRAPPER_CONTROL_0_get_fifo_stage(data)                                ((0x00000800&(data))>>11)
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_shift                                     (10)
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_mask                                      (0x00000400)
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en(data)                                     (0x00000400&((data)<<10))
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_src(data)                                 ((0x00000400&(data))>>10)
+#define HDMIRX_WRAPPER_CONTROL_0_get_fw_dma_en(data)                                 ((0x00000400&(data))>>10)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_shift                               (9)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_mask                                (0x00000200)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en(data)                               (0x00000200&((data)<<9))
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_src(data)                           ((0x00000200&(data))>>9)
+#define HDMIRX_WRAPPER_CONTROL_0_get_polarity_set_en(data)                           ((0x00000200&(data))>>9)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_shift                                  (8)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_mask                                   (0x00000100)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set(data)                                  (0x00000100&((data)<<8))
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_src(data)                              ((0x00000100&(data))>>8)
+#define HDMIRX_WRAPPER_CONTROL_0_get_polarity_set(data)                              ((0x00000100&(data))>>8)
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_shift                                       (2)
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_mask                                        (0x0000000C)
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt(data)                                       (0x0000000C&((data)<<2))
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_src(data)                                   ((0x0000000C&(data))>>2)
+#define HDMIRX_WRAPPER_CONTROL_0_get_yuv_fmt(data)                                   ((0x0000000C&(data))>>2)
+#define HDMIRX_WRAPPER_CONTROL_0_cbusrx_en_shift                                     (1)
+#define HDMIRX_WRAPPER_CONTROL_0_cbusrx_en_mask                                      (0x00000002)
+#define HDMIRX_WRAPPER_CONTROL_0_cbusrx_en(data)                                     (0x00000002&((data)<<1))
+#define HDMIRX_WRAPPER_CONTROL_0_cbusrx_en_src(data)                                 ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_CONTROL_0_get_cbusrx_en(data)                                 ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_shift                                     (0)
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_mask                                      (0x00000001)
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en(data)                                     (0x00000001&((data)<<0))
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_src(data)                                 ((0x00000001&(data))>>0)
+#define HDMIRX_WRAPPER_CONTROL_0_get_hdmirx_en(data)                                 ((0x00000001&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_CONTROL_1                                                     0x24
+#define HDMIRX_WRAPPER_CONTROL_1_reg_addr                                            "0x98035F24"
+#define HDMIRX_WRAPPER_CONTROL_1_reg                                                 0x98035F24
+#define HDMIRX_WRAPPER_CONTROL_1_inst_adr                                            "0x00C9"
+#define HDMIRX_WRAPPER_CONTROL_1_inst                                                0x00C9
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl_shift                                    (16)
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl_mask                                     (0xFFFF0000)
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl(data)                                    (0xFFFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl_src(data)                                ((0xFFFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_CONTROL_1_get_dummy_ctrl(data)                                ((0xFFFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_vclk_div_sel_shift                           (12)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_vclk_div_sel_mask                            (0x00007000)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_vclk_div_sel(data)                           (0x00007000&((data)<<12))
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_vclk_div_sel_src(data)                       ((0x00007000&(data))>>12)
+#define HDMIRX_WRAPPER_CONTROL_1_get_hdmirx_vclk_div_sel(data)                       ((0x00007000&(data))>>12)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_fdds_div_sel_shift                           (8)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_fdds_div_sel_mask                            (0x00000700)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_fdds_div_sel(data)                           (0x00000700&((data)<<8))
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_fdds_div_sel_src(data)                       ((0x00000700&(data))>>8)
+#define HDMIRX_WRAPPER_CONTROL_1_get_hdmirx_fdds_div_sel(data)                       ((0x00000700&(data))>>8)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_aclk_div_sel_shift                           (4)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_aclk_div_sel_mask                            (0x00000070)
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_aclk_div_sel(data)                           (0x00000070&((data)<<4))
+#define HDMIRX_WRAPPER_CONTROL_1_hdmirx_aclk_div_sel_src(data)                       ((0x00000070&(data))>>4)
+#define HDMIRX_WRAPPER_CONTROL_1_get_hdmirx_aclk_div_sel(data)                       ((0x00000070&(data))>>4)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel_shift                                     (2)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel_mask                                      (0x0000000C)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel(data)                                     (0x0000000C&((data)<<2))
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel_src(data)                                 ((0x0000000C&(data))>>2)
+#define HDMIRX_WRAPPER_CONTROL_1_get_debug_sel(data)                                 ((0x0000000C&(data))>>2)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux_shift                                     (0)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux_mask                                      (0x00000003)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux(data)                                     (0x00000003&((data)<<0))
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux_src(data)                                 ((0x00000003&(data))>>0)
+#define HDMIRX_WRAPPER_CONTROL_1_get_debug_mux(data)                                 ((0x00000003&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_DUMMY                                                         0x28
+#define HDMIRX_WRAPPER_DUMMY_reg_addr                                                "0x98035F28"
+#define HDMIRX_WRAPPER_DUMMY_reg                                                     0x98035F28
+#define HDMIRX_WRAPPER_DUMMY_inst_adr                                                "0x00CA"
+#define HDMIRX_WRAPPER_DUMMY_inst                                                    0x00CA
+#define HDMIRX_WRAPPER_DUMMY_hdmirx_dummy_reg_shift                                  (0)
+#define HDMIRX_WRAPPER_DUMMY_hdmirx_dummy_reg_mask                                   (0xFFFFFFFF)
+#define HDMIRX_WRAPPER_DUMMY_hdmirx_dummy_reg(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMIRX_WRAPPER_DUMMY_hdmirx_dummy_reg_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMIRX_WRAPPER_DUMMY_get_hdmirx_dummy_reg(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_HDCP_M0_0                                                     0x30
+#define HDMIRX_WRAPPER_HDCP_M0_0_reg_addr                                            "0x98035F30"
+#define HDMIRX_WRAPPER_HDCP_M0_0_reg                                                 0x98035F30
+#define HDMIRX_WRAPPER_HDCP_M0_0_inst_adr                                            "0x00CC"
+#define HDMIRX_WRAPPER_HDCP_M0_0_inst                                                0x00CC
+#define HDMIRX_WRAPPER_HDCP_M0_0_hdcp_m0_0_shift                                     (0)
+#define HDMIRX_WRAPPER_HDCP_M0_0_hdcp_m0_0_mask                                      (0xFFFFFFFF)
+#define HDMIRX_WRAPPER_HDCP_M0_0_hdcp_m0_0(data)                                     (0xFFFFFFFF&((data)<<0))
+#define HDMIRX_WRAPPER_HDCP_M0_0_hdcp_m0_0_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define HDMIRX_WRAPPER_HDCP_M0_0_get_hdcp_m0_0(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_HDCP_M0_1                                                     0x34
+#define HDMIRX_WRAPPER_HDCP_M0_1_reg_addr                                            "0x98035F34"
+#define HDMIRX_WRAPPER_HDCP_M0_1_reg                                                 0x98035F34
+#define HDMIRX_WRAPPER_HDCP_M0_1_inst_adr                                            "0x00CD"
+#define HDMIRX_WRAPPER_HDCP_M0_1_inst                                                0x00CD
+#define HDMIRX_WRAPPER_HDCP_M0_1_hdcp_m0_1_shift                                     (0)
+#define HDMIRX_WRAPPER_HDCP_M0_1_hdcp_m0_1_mask                                      (0xFFFFFFFF)
+#define HDMIRX_WRAPPER_HDCP_M0_1_hdcp_m0_1(data)                                     (0xFFFFFFFF&((data)<<0))
+#define HDMIRX_WRAPPER_HDCP_M0_1_hdcp_m0_1_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define HDMIRX_WRAPPER_HDCP_M0_1_get_hdcp_m0_1(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+#define HDMIRX_WRAPPER_DBG_0                                                         0x40
+#define HDMIRX_WRAPPER_DBG_0_reg_addr                                                "0x98035F40"
+#define HDMIRX_WRAPPER_DBG_0_reg                                                     0x98035F40
+#define HDMIRX_WRAPPER_DBG_0_inst_adr                                                "0x00D0"
+#define HDMIRX_WRAPPER_DBG_0_inst                                                    0x00D0
+#define HDMIRX_WRAPPER_DBG_0_video_data_debug_latch_shift                            (0)
+#define HDMIRX_WRAPPER_DBG_0_video_data_debug_latch_mask                             (0x00000001)
+#define HDMIRX_WRAPPER_DBG_0_video_data_debug_latch(data)                            (0x00000001&((data)<<0))
+#define HDMIRX_WRAPPER_DBG_0_video_data_debug_latch_src(data)                        ((0x00000001&(data))>>0)
+#define HDMIRX_WRAPPER_DBG_0_get_video_data_debug_latch(data)                        ((0x00000001&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_DBG_1                                                         0x44
+#define HDMIRX_WRAPPER_DBG_1_reg_addr                                                "0x98035F44"
+#define HDMIRX_WRAPPER_DBG_1_reg                                                     0x98035F44
+#define HDMIRX_WRAPPER_DBG_1_inst_adr                                                "0x00D1"
+#define HDMIRX_WRAPPER_DBG_1_inst                                                    0x00D1
+#define HDMIRX_WRAPPER_DBG_1_debug_video_data_r_shift                               (0)
+#define HDMIRX_WRAPPER_DBG_1_debug_video_data_r_mask                                (0x00000FFF)
+#define HDMIRX_WRAPPER_DBG_1_debug_video_data_r(data)                               (0x00000FFF&((data)<<0))
+#define HDMIRX_WRAPPER_DBG_1_debug_video_data_r_src(data)                           ((0x00000FFF&(data))>>0)
+#define HDMIRX_WRAPPER_DBG_1_get_debug_video_data_r(data)                           ((0x00000FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_DBG_2                                                         0x48
+#define HDMIRX_WRAPPER_DBG_2_reg_addr                                                "0x98035F48"
+#define HDMIRX_WRAPPER_DBG_2_reg                                                     0x98035F48
+#define HDMIRX_WRAPPER_DBG_2_inst_adr                                                "0x00D2"
+#define HDMIRX_WRAPPER_DBG_2_inst                                                    0x00D2
+#define HDMIRX_WRAPPER_DBG_2_debug_video_data_g_shift                               (0)
+#define HDMIRX_WRAPPER_DBG_2_debug_video_data_g_mask                                (0x00000FFF)
+#define HDMIRX_WRAPPER_DBG_2_debug_video_data_g(data)                               (0x00000FFF&((data)<<0))
+#define HDMIRX_WRAPPER_DBG_2_debug_video_data_g_src(data)                           ((0x00000FFF&(data))>>0)
+#define HDMIRX_WRAPPER_DBG_2_get_debug_video_data_g(data)                           ((0x00000FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_DBG_3                                                         0x4C
+#define HDMIRX_WRAPPER_DBG_3_reg_addr                                                "0x98035F4C"
+#define HDMIRX_WRAPPER_DBG_3_reg                                                     0x98035F4C
+#define HDMIRX_WRAPPER_DBG_3_inst_adr                                                "0x00D3"
+#define HDMIRX_WRAPPER_DBG_3_inst                                                    0x00D3
+#define HDMIRX_WRAPPER_DBG_3_debug_video_data_b_shift                               (0)
+#define HDMIRX_WRAPPER_DBG_3_debug_video_data_b_mask                                (0x00000FFF)
+#define HDMIRX_WRAPPER_DBG_3_debug_video_data_b(data)                               (0x00000FFF&((data)<<0))
+#define HDMIRX_WRAPPER_DBG_3_debug_video_data_b_src(data)                           ((0x00000FFF&(data))>>0)
+#define HDMIRX_WRAPPER_DBG_3_get_debug_video_data_b(data)                           ((0x00000FFF&(data))>>0)
+#endif
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/mipi_wrapper_reg.h b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/mipi_wrapper_reg.h
new file mode 100644
index 00000000..11ef9a8
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/mipi_wrapper_reg.h
@@ -0,0 +1,1403 @@
+/*
+ * mipi_wrapper_reg.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+
+#ifndef _MIPI_WRAPPER_REG_H_INCLUDED_
+#define _MIPI_WRAPPER_REG_H_INCLUDED_
+
+#define MIPI                                                                         0x100
+#define MIPI_reg_addr                                                                "0x98004100"
+#define MIPI_reg                                                                     0x98004100
+#define set_MIPI_reg(data)   (*((volatile unsigned int*) MIPI_reg)=data)
+#define get_MIPI_reg   (*((volatile unsigned int*) MIPI_reg))
+#define MIPI_dst_fmt_shift                                                           (27)
+#define MIPI_dst_fmt_mask                                                            (0xF8000000)
+#define MIPI_dst_fmt(data)                                                           (0xF8000000&((data)<<27))
+#define MIPI_dst_fmt_src(data)                                                       ((0xF8000000&(data))>>27)
+#define MIPI_get_dst_fmt(data)                                                       ((0xF8000000&(data))>>27)
+#define MIPI_src_fmt_shift                                                           (25)
+#define MIPI_src_fmt_mask                                                            (0x06000000)
+#define MIPI_src_fmt(data)                                                           (0x06000000&((data)<<25))
+#define MIPI_src_fmt_src(data)                                                       ((0x06000000&(data))>>25)
+#define MIPI_get_src_fmt(data)                                                       ((0x06000000&(data))>>25)
+#define MIPI_src_sel_shift                                                           (24)
+#define MIPI_src_sel_mask                                                            (0x01000000)
+#define MIPI_src_sel(data)                                                           (0x01000000&((data)<<24))
+#define MIPI_src_sel_src(data)                                                       ((0x01000000&(data))>>24)
+#define MIPI_get_src_sel(data)                                                       ((0x01000000&(data))>>24)
+#define MIPI_yuv420_uv_seq_shift                                                     (23)
+#define MIPI_yuv420_uv_seq_mask                                                      (0x00800000)
+#define MIPI_yuv420_uv_seq(data)                                                     (0x00800000&((data)<<23))
+#define MIPI_yuv420_uv_seq_src(data)                                                 ((0x00800000&(data))>>23)
+#define MIPI_get_yuv420_uv_seq(data)                                                 ((0x00800000&(data))>>23)
+#define MIPI_vs_shift                                                                (22)
+#define MIPI_vs_mask                                                                 (0x00400000)
+#define MIPI_vs(data)                                                                (0x00400000&((data)<<22))
+#define MIPI_vs_src(data)                                                            ((0x00400000&(data))>>22)
+#define MIPI_get_vs(data)                                                            ((0x00400000&(data))>>22)
+#define MIPI_vs_near_shift                                                           (21)
+#define MIPI_vs_near_mask                                                            (0x00200000)
+#define MIPI_vs_near(data)                                                           (0x00200000&((data)<<21))
+#define MIPI_vs_near_src(data)                                                       ((0x00200000&(data))>>21)
+#define MIPI_get_vs_near(data)                                                       ((0x00200000&(data))>>21)
+#define MIPI_vs_yodd_shift                                                           (20)
+#define MIPI_vs_yodd_mask                                                            (0x00100000)
+#define MIPI_vs_yodd(data)                                                           (0x00100000&((data)<<20))
+#define MIPI_vs_yodd_src(data)                                                       ((0x00100000&(data))>>20)
+#define MIPI_get_vs_yodd(data)                                                       ((0x00100000&(data))>>20)
+#define MIPI_vs_codd_shift                                                           (19)
+#define MIPI_vs_codd_mask                                                            (0x00080000)
+#define MIPI_vs_codd(data)                                                           (0x00080000&((data)<<19))
+#define MIPI_vs_codd_src(data)                                                       ((0x00080000&(data))>>19)
+#define MIPI_get_vs_codd(data)                                                       ((0x00080000&(data))>>19)
+#define MIPI_hs_shift                                                                (18)
+#define MIPI_hs_mask                                                                 (0x00040000)
+#define MIPI_hs(data)                                                                (0x00040000&((data)<<18))
+#define MIPI_hs_src(data)                                                            ((0x00040000&(data))>>18)
+#define MIPI_get_hs(data)                                                            ((0x00040000&(data))>>18)
+#define MIPI_hs_yodd_shift                                                           (17)
+#define MIPI_hs_yodd_mask                                                            (0x00020000)
+#define MIPI_hs_yodd(data)                                                           (0x00020000&((data)<<17))
+#define MIPI_hs_yodd_src(data)                                                       ((0x00020000&(data))>>17)
+#define MIPI_get_hs_yodd(data)                                                       ((0x00020000&(data))>>17)
+#define MIPI_hs_codd_shift                                                           (16)
+#define MIPI_hs_codd_mask                                                            (0x00010000)
+#define MIPI_hs_codd(data)                                                           (0x00010000&((data)<<16))
+#define MIPI_hs_codd_src(data)                                                       ((0x00010000&(data))>>16)
+#define MIPI_get_hs_codd(data)                                                       ((0x00010000&(data))>>16)
+#define MIPI_yuv420_fmt_shift                                                        (15)
+#define MIPI_yuv420_fmt_mask                                                         (0x00008000)
+#define MIPI_yuv420_fmt(data)                                                        (0x00008000&((data)<<15))
+#define MIPI_yuv420_fmt_src(data)                                                    ((0x00008000&(data))>>15)
+#define MIPI_get_yuv420_fmt(data)                                                    ((0x00008000&(data))>>15)
+#define MIPI_ccs_data_format_shift                                                   (13)
+#define MIPI_ccs_data_format_mask                                                    (0x00006000)
+#define MIPI_ccs_data_format(data)                                                   (0x00006000&((data)<<13))
+#define MIPI_ccs_data_format_src(data)                                               ((0x00006000&(data))>>13)
+#define MIPI_get_ccs_data_format(data)                                               ((0x00006000&(data))>>13)
+#define MIPI_yuv_to_rgb_shift                                                        (12)
+#define MIPI_yuv_to_rgb_mask                                                         (0x00001000)
+#define MIPI_yuv_to_rgb(data)                                                        (0x00001000&((data)<<12))
+#define MIPI_yuv_to_rgb_src(data)                                                    ((0x00001000&(data))>>12)
+#define MIPI_get_yuv_to_rgb(data)                                                    ((0x00001000&(data))>>12)
+#define MIPI_chroma_ds_mode_shift                                                    (11)
+#define MIPI_chroma_ds_mode_mask                                                     (0x00000800)
+#define MIPI_chroma_ds_mode(data)                                                    (0x00000800&((data)<<11))
+#define MIPI_chroma_ds_mode_src(data)                                                ((0x00000800&(data))>>11)
+#define MIPI_get_chroma_ds_mode(data)                                                ((0x00000800&(data))>>11)
+#define MIPI_chroma_ds_en_shift                                                      (10)
+#define MIPI_chroma_ds_en_mask                                                       (0x00000400)
+#define MIPI_chroma_ds_en(data)                                                      (0x00000400&((data)<<10))
+#define MIPI_chroma_ds_en_src(data)                                                  ((0x00000400&(data))>>10)
+#define MIPI_get_chroma_ds_en(data)                                                  ((0x00000400&(data))>>10)
+#define MIPI_chroma_us_mode_shift                                                    (9)
+#define MIPI_chroma_us_mode_mask                                                     (0x00000200)
+#define MIPI_chroma_us_mode(data)                                                    (0x00000200&((data)<<9))
+#define MIPI_chroma_us_mode_src(data)                                                ((0x00000200&(data))>>9)
+#define MIPI_get_chroma_us_mode(data)                                                ((0x00000200&(data))>>9)
+#define MIPI_chroma_us_en_shift                                                      (8)
+#define MIPI_chroma_us_en_mask                                                       (0x00000100)
+#define MIPI_chroma_us_en(data)                                                      (0x00000100&((data)<<8))
+#define MIPI_chroma_us_en_src(data)                                                  ((0x00000100&(data))>>8)
+#define MIPI_get_chroma_us_en(data)                                                  ((0x00000100&(data))>>8)
+#define MIPI_hdmirx_interlace_en_shift                                               (7)
+#define MIPI_hdmirx_interlace_en_mask                                                (0x00000080)
+#define MIPI_hdmirx_interlace_en(data)                                               (0x00000080&((data)<<7))
+#define MIPI_hdmirx_interlace_en_src(data)                                           ((0x00000080&(data))>>7)
+#define MIPI_get_hdmirx_interlace_en(data)                                           ((0x00000080&(data))>>7)
+#define MIPI_hdmirx_interlace_polarity_shift                                         (6)
+#define MIPI_hdmirx_interlace_polarity_mask                                          (0x00000040)
+#define MIPI_hdmirx_interlace_polarity(data)                                         (0x00000040&((data)<<6))
+#define MIPI_hdmirx_interlace_polarity_src(data)                                     ((0x00000040&(data))>>6)
+#define MIPI_get_hdmirx_interlace_polarity(data)                                     ((0x00000040&(data))>>6)
+#define MIPI_int_en4_shift                                                           (5)
+#define MIPI_int_en4_mask                                                            (0x00000020)
+#define MIPI_int_en4(data)                                                           (0x00000020&((data)<<5))
+#define MIPI_int_en4_src(data)                                                       ((0x00000020&(data))>>5)
+#define MIPI_get_int_en4(data)                                                       ((0x00000020&(data))>>5)
+#define MIPI_int_en3_shift                                                           (4)
+#define MIPI_int_en3_mask                                                            (0x00000010)
+#define MIPI_int_en3(data)                                                           (0x00000010&((data)<<4))
+#define MIPI_int_en3_src(data)                                                       ((0x00000010&(data))>>4)
+#define MIPI_get_int_en3(data)                                                       ((0x00000010&(data))>>4)
+#define MIPI_int_en2_shift                                                           (3)
+#define MIPI_int_en2_mask                                                            (0x00000008)
+#define MIPI_int_en2(data)                                                           (0x00000008&((data)<<3))
+#define MIPI_int_en2_src(data)                                                       ((0x00000008&(data))>>3)
+#define MIPI_get_int_en2(data)                                                       ((0x00000008&(data))>>3)
+#define MIPI_int_en1_shift                                                           (2)
+#define MIPI_int_en1_mask                                                            (0x00000004)
+#define MIPI_int_en1(data)                                                           (0x00000004&((data)<<2))
+#define MIPI_int_en1_src(data)                                                       ((0x00000004&(data))>>2)
+#define MIPI_get_int_en1(data)                                                       ((0x00000004&(data))>>2)
+#define MIPI_int_en0_shift                                                           (1)
+#define MIPI_int_en0_mask                                                            (0x00000002)
+#define MIPI_int_en0(data)                                                           (0x00000002&((data)<<1))
+#define MIPI_int_en0_src(data)                                                       ((0x00000002&(data))>>1)
+#define MIPI_get_int_en0(data)                                                       ((0x00000002&(data))>>1)
+#define MIPI_en_shift                                                                (0)
+#define MIPI_en_mask                                                                 (0x00000001)
+#define MIPI_en(data)                                                                (0x00000001&((data)<<0))
+#define MIPI_en_src(data)                                                            ((0x00000001&(data))>>0)
+#define MIPI_get_en(data)                                                            ((0x00000001&(data))>>0)
+
+
+#define MIPI_SA0                                                                     0x104
+#define MIPI_SA0_reg_addr                                                            "0x98004104"
+#define MIPI_SA0_reg                                                                 0x98004104
+#define set_MIPI_SA0_reg(data)   (*((volatile unsigned int*) MIPI_SA0_reg)=data)
+#define get_MIPI_SA0_reg   (*((volatile unsigned int*) MIPI_SA0_reg))
+#define MIPI_SA0_sa0_video_shift                                                     (0)
+#define MIPI_SA0_sa0_video_mask                                                      (0xFFFFFFFF)
+#define MIPI_SA0_sa0_video(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA0_sa0_video_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA0_get_sa0_video(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SA1                                                                     0x108
+#define MIPI_SA1_reg_addr                                                            "0x98004108"
+#define MIPI_SA1_reg                                                                 0x98004108
+#define set_MIPI_SA1_reg(data)   (*((volatile unsigned int*) MIPI_SA1_reg)=data)
+#define get_MIPI_SA1_reg   (*((volatile unsigned int*) MIPI_SA1_reg))
+#define MIPI_SA1_sa1_video_shift                                                     (0)
+#define MIPI_SA1_sa1_video_mask                                                      (0xFFFFFFFF)
+#define MIPI_SA1_sa1_video(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA1_sa1_video_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA1_get_sa1_video(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SA2                                                                     0x10C
+#define MIPI_SA2_reg_addr                                                            "0x9800410C"
+#define MIPI_SA2_reg                                                                 0x9800410C
+#define set_MIPI_SA2_reg(data)   (*((volatile unsigned int*) MIPI_SA2_reg)=data)
+#define get_MIPI_SA2_reg   (*((volatile unsigned int*) MIPI_SA2_reg))
+#define MIPI_SA2_sa2_pic_shift                                                       (0)
+#define MIPI_SA2_sa2_pic_mask                                                        (0xFFFFFFFF)
+#define MIPI_SA2_sa2_pic(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA2_sa2_pic_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA2_get_sa2_pic(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SIZE0                                                                   0x110
+#define MIPI_SIZE0_reg_addr                                                          "0x98004110"
+#define MIPI_SIZE0_reg                                                               0x98004110
+#define set_MIPI_SIZE0_reg(data)   (*((volatile unsigned int*) MIPI_SIZE0_reg)=data)
+#define get_MIPI_SIZE0_reg   (*((volatile unsigned int*) MIPI_SIZE0_reg))
+#define MIPI_SIZE0_dst_width_video_shift                                             (16)
+#define MIPI_SIZE0_dst_width_video_mask                                              (0x1FFF0000)
+#define MIPI_SIZE0_dst_width_video(data)                                             (0x1FFF0000&((data)<<16))
+#define MIPI_SIZE0_dst_width_video_src(data)                                         ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE0_get_dst_width_video(data)                                         ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE0_pitch_video_shift                                                 (0)
+#define MIPI_SIZE0_pitch_video_mask                                                  (0x0000FFFF)
+#define MIPI_SIZE0_pitch_video(data)                                                 (0x0000FFFF&((data)<<0))
+#define MIPI_SIZE0_pitch_video_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define MIPI_SIZE0_get_pitch_video(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define MIPI_SIZE1                                                                   0x114
+#define MIPI_SIZE1_reg_addr                                                          "0x98004114"
+#define MIPI_SIZE1_reg                                                               0x98004114
+#define set_MIPI_SIZE1_reg(data)   (*((volatile unsigned int*) MIPI_SIZE1_reg)=data)
+#define get_MIPI_SIZE1_reg   (*((volatile unsigned int*) MIPI_SIZE1_reg))
+#define MIPI_SIZE1_dst_width_pic_shift                                               (16)
+#define MIPI_SIZE1_dst_width_pic_mask                                                (0x1FFF0000)
+#define MIPI_SIZE1_dst_width_pic(data)                                               (0x1FFF0000&((data)<<16))
+#define MIPI_SIZE1_dst_width_pic_src(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE1_get_dst_width_pic(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE1_pitch_pic_shift                                                   (0)
+#define MIPI_SIZE1_pitch_pic_mask                                                    (0x0000FFFF)
+#define MIPI_SIZE1_pitch_pic(data)                                                   (0x0000FFFF&((data)<<0))
+#define MIPI_SIZE1_pitch_pic_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define MIPI_SIZE1_get_pitch_pic(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define MIPI_SIZE2                                                                   0x118
+#define MIPI_SIZE2_reg_addr                                                          "0x98004118"
+#define MIPI_SIZE2_reg                                                               0x98004118
+#define set_MIPI_SIZE2_reg(data)   (*((volatile unsigned int*) MIPI_SIZE2_reg)=data)
+#define get_MIPI_SIZE2_reg   (*((volatile unsigned int*) MIPI_SIZE2_reg))
+#define MIPI_SIZE2_src_width_pic_shift                                               (16)
+#define MIPI_SIZE2_src_width_pic_mask                                                (0x1FFF0000)
+#define MIPI_SIZE2_src_width_pic(data)                                               (0x1FFF0000&((data)<<16))
+#define MIPI_SIZE2_src_width_pic_src(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE2_get_src_width_pic(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE2_src_width_video_shift                                             (0)
+#define MIPI_SIZE2_src_width_video_mask                                              (0x00001FFF)
+#define MIPI_SIZE2_src_width_video(data)                                             (0x00001FFF&((data)<<0))
+#define MIPI_SIZE2_src_width_video_src(data)                                         ((0x00001FFF&(data))>>0)
+#define MIPI_SIZE2_get_src_width_video(data)                                         ((0x00001FFF&(data))>>0)
+
+
+#define MIPI_INDEX0                                                                  0x11C
+#define MIPI_INDEX0_reg_addr                                                         "0x9800411C"
+#define MIPI_INDEX0_reg                                                              0x9800411C
+#define set_MIPI_INDEX0_reg(data)   (*((volatile unsigned int*) MIPI_INDEX0_reg)=data)
+#define get_MIPI_INDEX0_reg   (*((volatile unsigned int*) MIPI_INDEX0_reg))
+#define MIPI_INDEX0_index_y0_video_shift                                             (16)
+#define MIPI_INDEX0_index_y0_video_mask                                              (0x007F0000)
+#define MIPI_INDEX0_index_y0_video(data)                                             (0x007F0000&((data)<<16))
+#define MIPI_INDEX0_index_y0_video_src(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX0_get_index_y0_video(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX0_index_c0_video_shift                                             (0)
+#define MIPI_INDEX0_index_c0_video_mask                                              (0x0000007F)
+#define MIPI_INDEX0_index_c0_video(data)                                             (0x0000007F&((data)<<0))
+#define MIPI_INDEX0_index_c0_video_src(data)                                         ((0x0000007F&(data))>>0)
+#define MIPI_INDEX0_get_index_c0_video(data)                                         ((0x0000007F&(data))>>0)
+
+
+#define MIPI_INDEX1                                                                  0x120
+#define MIPI_INDEX1_reg_addr                                                         "0x98004120"
+#define MIPI_INDEX1_reg                                                              0x98004120
+#define set_MIPI_INDEX1_reg(data)   (*((volatile unsigned int*) MIPI_INDEX1_reg)=data)
+#define get_MIPI_INDEX1_reg   (*((volatile unsigned int*) MIPI_INDEX1_reg))
+#define MIPI_INDEX1_index_y1_video_shift                                             (16)
+#define MIPI_INDEX1_index_y1_video_mask                                              (0x007F0000)
+#define MIPI_INDEX1_index_y1_video(data)                                             (0x007F0000&((data)<<16))
+#define MIPI_INDEX1_index_y1_video_src(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX1_get_index_y1_video(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX1_index_c1_video_shift                                             (0)
+#define MIPI_INDEX1_index_c1_video_mask                                              (0x0000007F)
+#define MIPI_INDEX1_index_c1_video(data)                                             (0x0000007F&((data)<<0))
+#define MIPI_INDEX1_index_c1_video_src(data)                                         ((0x0000007F&(data))>>0)
+#define MIPI_INDEX1_get_index_c1_video(data)                                         ((0x0000007F&(data))>>0)
+
+
+#define MIPI_INDEX2                                                                  0x124
+#define MIPI_INDEX2_reg_addr                                                         "0x98004124"
+#define MIPI_INDEX2_reg                                                              0x98004124
+#define set_MIPI_INDEX2_reg(data)   (*((volatile unsigned int*) MIPI_INDEX2_reg)=data)
+#define get_MIPI_INDEX2_reg   (*((volatile unsigned int*) MIPI_INDEX2_reg))
+#define MIPI_INDEX2_index_y2_pic_shift                                               (16)
+#define MIPI_INDEX2_index_y2_pic_mask                                                (0x007F0000)
+#define MIPI_INDEX2_index_y2_pic(data)                                               (0x007F0000&((data)<<16))
+#define MIPI_INDEX2_index_y2_pic_src(data)                                           ((0x007F0000&(data))>>16)
+#define MIPI_INDEX2_get_index_y2_pic(data)                                           ((0x007F0000&(data))>>16)
+#define MIPI_INDEX2_index_c2_pic_shift                                               (0)
+#define MIPI_INDEX2_index_c2_pic_mask                                                (0x0000007F)
+#define MIPI_INDEX2_index_c2_pic(data)                                               (0x0000007F&((data)<<0))
+#define MIPI_INDEX2_index_c2_pic_src(data)                                           ((0x0000007F&(data))>>0)
+#define MIPI_INDEX2_get_index_c2_pic(data)                                           ((0x0000007F&(data))>>0)
+
+
+#define MIPI_INT_ST                                                                  0x128
+#define MIPI_INT_ST_reg_addr                                                         "0x98004128"
+#define MIPI_INT_ST_reg                                                              0x98004128
+#define set_MIPI_INT_ST_reg(data)   (*((volatile unsigned int*) MIPI_INT_ST_reg)=data)
+#define get_MIPI_INT_ST_reg   (*((volatile unsigned int*) MIPI_INT_ST_reg))
+#define MIPI_INT_ST_mipi_data_valid_shift                                            (20)
+#define MIPI_INT_ST_mipi_data_valid_mask                                             (0x00100000)
+#define MIPI_INT_ST_mipi_data_valid(data)                                            (0x00100000&((data)<<20))
+#define MIPI_INT_ST_mipi_data_valid_src(data)                                        ((0x00100000&(data))>>20)
+#define MIPI_INT_ST_get_mipi_data_valid(data)                                        ((0x00100000&(data))>>20)
+#define MIPI_INT_ST_mipi_line_end_shift                                              (19)
+#define MIPI_INT_ST_mipi_line_end_mask                                               (0x00080000)
+#define MIPI_INT_ST_mipi_line_end(data)                                              (0x00080000&((data)<<19))
+#define MIPI_INT_ST_mipi_line_end_src(data)                                          ((0x00080000&(data))>>19)
+#define MIPI_INT_ST_get_mipi_line_end(data)                                          ((0x00080000&(data))>>19)
+#define MIPI_INT_ST_mipi_line_start_shift                                            (18)
+#define MIPI_INT_ST_mipi_line_start_mask                                             (0x00040000)
+#define MIPI_INT_ST_mipi_line_start(data)                                            (0x00040000&((data)<<18))
+#define MIPI_INT_ST_mipi_line_start_src(data)                                        ((0x00040000&(data))>>18)
+#define MIPI_INT_ST_get_mipi_line_start(data)                                        ((0x00040000&(data))>>18)
+#define MIPI_INT_ST_mipi_frame_end_shift                                             (17)
+#define MIPI_INT_ST_mipi_frame_end_mask                                              (0x00020000)
+#define MIPI_INT_ST_mipi_frame_end(data)                                             (0x00020000&((data)<<17))
+#define MIPI_INT_ST_mipi_frame_end_src(data)                                         ((0x00020000&(data))>>17)
+#define MIPI_INT_ST_get_mipi_frame_end(data)                                         ((0x00020000&(data))>>17)
+#define MIPI_INT_ST_mipi_frame_start_shift                                           (16)
+#define MIPI_INT_ST_mipi_frame_start_mask                                            (0x00010000)
+#define MIPI_INT_ST_mipi_frame_start(data)                                           (0x00010000&((data)<<16))
+#define MIPI_INT_ST_mipi_frame_start_src(data)                                       ((0x00010000&(data))>>16)
+#define MIPI_INT_ST_get_mipi_frame_start(data)                                       ((0x00010000&(data))>>16)
+#define MIPI_INT_ST_esc_lane3_int_flg_shift                                          (15)
+#define MIPI_INT_ST_esc_lane3_int_flg_mask                                           (0x00008000)
+#define MIPI_INT_ST_esc_lane3_int_flg(data)                                          (0x00008000&((data)<<15))
+#define MIPI_INT_ST_esc_lane3_int_flg_src(data)                                      ((0x00008000&(data))>>15)
+#define MIPI_INT_ST_get_esc_lane3_int_flg(data)                                      ((0x00008000&(data))>>15)
+#define MIPI_INT_ST_esc_lane2_int_flg_shift                                          (14)
+#define MIPI_INT_ST_esc_lane2_int_flg_mask                                           (0x00004000)
+#define MIPI_INT_ST_esc_lane2_int_flg(data)                                          (0x00004000&((data)<<14))
+#define MIPI_INT_ST_esc_lane2_int_flg_src(data)                                      ((0x00004000&(data))>>14)
+#define MIPI_INT_ST_get_esc_lane2_int_flg(data)                                      ((0x00004000&(data))>>14)
+#define MIPI_INT_ST_esc_lane1_int_flg_shift                                          (13)
+#define MIPI_INT_ST_esc_lane1_int_flg_mask                                           (0x00002000)
+#define MIPI_INT_ST_esc_lane1_int_flg(data)                                          (0x00002000&((data)<<13))
+#define MIPI_INT_ST_esc_lane1_int_flg_src(data)                                      ((0x00002000&(data))>>13)
+#define MIPI_INT_ST_get_esc_lane1_int_flg(data)                                      ((0x00002000&(data))>>13)
+#define MIPI_INT_ST_esc_lane0_int_flg_shift                                          (12)
+#define MIPI_INT_ST_esc_lane0_int_flg_mask                                           (0x00001000)
+#define MIPI_INT_ST_esc_lane0_int_flg(data)                                          (0x00001000&((data)<<12))
+#define MIPI_INT_ST_esc_lane0_int_flg_src(data)                                      ((0x00001000&(data))>>12)
+#define MIPI_INT_ST_get_esc_lane0_int_flg(data)                                      ((0x00001000&(data))>>12)
+#define MIPI_INT_ST_clk_ulps_int_flg_shift                                           (11)
+#define MIPI_INT_ST_clk_ulps_int_flg_mask                                            (0x00000800)
+#define MIPI_INT_ST_clk_ulps_int_flg(data)                                           (0x00000800&((data)<<11))
+#define MIPI_INT_ST_clk_ulps_int_flg_src(data)                                       ((0x00000800&(data))>>11)
+#define MIPI_INT_ST_get_clk_ulps_int_flg(data)                                       ((0x00000800&(data))>>11)
+#define MIPI_INT_ST_crc16_err_int_flg_shift                                          (10)
+#define MIPI_INT_ST_crc16_err_int_flg_mask                                           (0x00000400)
+#define MIPI_INT_ST_crc16_err_int_flg(data)                                          (0x00000400&((data)<<10))
+#define MIPI_INT_ST_crc16_err_int_flg_src(data)                                      ((0x00000400&(data))>>10)
+#define MIPI_INT_ST_get_crc16_err_int_flg(data)                                      ((0x00000400&(data))>>10)
+#define MIPI_INT_ST_ecc_crt_int_flg_shift                                            (9)
+#define MIPI_INT_ST_ecc_crt_int_flg_mask                                             (0x00000200)
+#define MIPI_INT_ST_ecc_crt_int_flg(data)                                            (0x00000200&((data)<<9))
+#define MIPI_INT_ST_ecc_crt_int_flg_src(data)                                        ((0x00000200&(data))>>9)
+#define MIPI_INT_ST_get_ecc_crt_int_flg(data)                                        ((0x00000200&(data))>>9)
+#define MIPI_INT_ST_ecc_err_int_flg_shift                                            (8)
+#define MIPI_INT_ST_ecc_err_int_flg_mask                                             (0x00000100)
+#define MIPI_INT_ST_ecc_err_int_flg(data)                                            (0x00000100&((data)<<8))
+#define MIPI_INT_ST_ecc_err_int_flg_src(data)                                        ((0x00000100&(data))>>8)
+#define MIPI_INT_ST_get_ecc_err_int_flg(data)                                        ((0x00000100&(data))>>8)
+#define MIPI_INT_ST_pic_detect_v_fail_shift                                          (7)
+#define MIPI_INT_ST_pic_detect_v_fail_mask                                           (0x00000080)
+#define MIPI_INT_ST_pic_detect_v_fail(data)                                          (0x00000080&((data)<<7))
+#define MIPI_INT_ST_pic_detect_v_fail_src(data)                                      ((0x00000080&(data))>>7)
+#define MIPI_INT_ST_get_pic_detect_v_fail(data)                                      ((0x00000080&(data))>>7)
+#define MIPI_INT_ST_pic_detect_h_fail_shift                                          (6)
+#define MIPI_INT_ST_pic_detect_h_fail_mask                                           (0x00000040)
+#define MIPI_INT_ST_pic_detect_h_fail(data)                                          (0x00000040&((data)<<6))
+#define MIPI_INT_ST_pic_detect_h_fail_src(data)                                      ((0x00000040&(data))>>6)
+#define MIPI_INT_ST_get_pic_detect_h_fail(data)                                      ((0x00000040&(data))>>6)
+#define MIPI_INT_ST_overflow_drop_shift                                              (5)
+#define MIPI_INT_ST_overflow_drop_mask                                               (0x00000020)
+#define MIPI_INT_ST_overflow_drop(data)                                              (0x00000020&((data)<<5))
+#define MIPI_INT_ST_overflow_drop_src(data)                                          ((0x00000020&(data))>>5)
+#define MIPI_INT_ST_get_overflow_drop(data)                                          ((0x00000020&(data))>>5)
+#define MIPI_INT_ST_fm_drop_shift                                                    (4)
+#define MIPI_INT_ST_fm_drop_mask                                                     (0x00000010)
+#define MIPI_INT_ST_fm_drop(data)                                                    (0x00000010&((data)<<4))
+#define MIPI_INT_ST_fm_drop_src(data)                                                ((0x00000010&(data))>>4)
+#define MIPI_INT_ST_get_fm_drop(data)                                                ((0x00000010&(data))>>4)
+#define MIPI_INT_ST_fm_done2_shift                                                   (3)
+#define MIPI_INT_ST_fm_done2_mask                                                    (0x00000008)
+#define MIPI_INT_ST_fm_done2(data)                                                   (0x00000008&((data)<<3))
+#define MIPI_INT_ST_fm_done2_src(data)                                               ((0x00000008&(data))>>3)
+#define MIPI_INT_ST_get_fm_done2(data)                                               ((0x00000008&(data))>>3)
+#define MIPI_INT_ST_fm_done1_shift                                                   (2)
+#define MIPI_INT_ST_fm_done1_mask                                                    (0x00000004)
+#define MIPI_INT_ST_fm_done1(data)                                                   (0x00000004&((data)<<2))
+#define MIPI_INT_ST_fm_done1_src(data)                                               ((0x00000004&(data))>>2)
+#define MIPI_INT_ST_get_fm_done1(data)                                               ((0x00000004&(data))>>2)
+#define MIPI_INT_ST_fm_done0_shift                                                   (1)
+#define MIPI_INT_ST_fm_done0_mask                                                    (0x00000002)
+#define MIPI_INT_ST_fm_done0(data)                                                   (0x00000002&((data)<<1))
+#define MIPI_INT_ST_fm_done0_src(data)                                               ((0x00000002&(data))>>1)
+#define MIPI_INT_ST_get_fm_done0(data)                                               ((0x00000002&(data))>>1)
+#define MIPI_INT_ST_write_data_shift                                                 (0)
+#define MIPI_INT_ST_write_data_mask                                                  (0x00000001)
+#define MIPI_INT_ST_write_data(data)                                                 (0x00000001&((data)<<0))
+#define MIPI_INT_ST_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define MIPI_INT_ST_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MIPI_TYPE                                                                    0x12C
+#define MIPI_TYPE_reg_addr                                                           "0x9800412C"
+#define MIPI_TYPE_reg                                                                0x9800412C
+#define set_MIPI_TYPE_reg(data)   (*((volatile unsigned int*) MIPI_TYPE_reg)=data)
+#define get_MIPI_TYPE_reg   (*((volatile unsigned int*) MIPI_TYPE_reg))
+#define MIPI_TYPE_mipi_type_shift                                                    (0)
+#define MIPI_TYPE_mipi_type_mask                                                     (0x00000001)
+#define MIPI_TYPE_mipi_type(data)                                                    (0x00000001&((data)<<0))
+#define MIPI_TYPE_mipi_type_src(data)                                                ((0x00000001&(data))>>0)
+#define MIPI_TYPE_get_mipi_type(data)                                                ((0x00000001&(data))>>0)
+
+
+#define CS_TRANS0                                                                    0x130
+#define CS_TRANS0_reg_addr                                                           "0x98004130"
+#define CS_TRANS0_reg                                                                0x98004130
+#define set_CS_TRANS0_reg(data)   (*((volatile unsigned int*) CS_TRANS0_reg)=data)
+#define get_CS_TRANS0_reg   (*((volatile unsigned int*) CS_TRANS0_reg))
+#define CS_TRANS0_cs_trans0_c1_shift                                                 (0)
+#define CS_TRANS0_cs_trans0_c1_mask                                                  (0x0001FFFF)
+#define CS_TRANS0_cs_trans0_c1(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS0_cs_trans0_c1_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS0_get_cs_trans0_c1(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS1                                                                    0x134
+#define CS_TRANS1_reg_addr                                                           "0x98004134"
+#define CS_TRANS1_reg                                                                0x98004134
+#define set_CS_TRANS1_reg(data)   (*((volatile unsigned int*) CS_TRANS1_reg)=data)
+#define get_CS_TRANS1_reg   (*((volatile unsigned int*) CS_TRANS1_reg))
+#define CS_TRANS1_cs_trans1_c2_shift                                                 (0)
+#define CS_TRANS1_cs_trans1_c2_mask                                                  (0x0001FFFF)
+#define CS_TRANS1_cs_trans1_c2(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS1_cs_trans1_c2_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS1_get_cs_trans1_c2(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS2                                                                    0x138
+#define CS_TRANS2_reg_addr                                                           "0x98004138"
+#define CS_TRANS2_reg                                                                0x98004138
+#define set_CS_TRANS2_reg(data)   (*((volatile unsigned int*) CS_TRANS2_reg)=data)
+#define get_CS_TRANS2_reg   (*((volatile unsigned int*) CS_TRANS2_reg))
+#define CS_TRANS2_cs_trans2_c3_shift                                                 (0)
+#define CS_TRANS2_cs_trans2_c3_mask                                                  (0x0001FFFF)
+#define CS_TRANS2_cs_trans2_c3(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS2_cs_trans2_c3_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS2_get_cs_trans2_c3(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS3                                                                    0x13C
+#define CS_TRANS3_reg_addr                                                           "0x9800413C"
+#define CS_TRANS3_reg                                                                0x9800413C
+#define set_CS_TRANS3_reg(data)   (*((volatile unsigned int*) CS_TRANS3_reg)=data)
+#define get_CS_TRANS3_reg   (*((volatile unsigned int*) CS_TRANS3_reg))
+#define CS_TRANS3_cs_trans3_c4_shift                                                 (0)
+#define CS_TRANS3_cs_trans3_c4_mask                                                  (0x0001FFFF)
+#define CS_TRANS3_cs_trans3_c4(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS3_cs_trans3_c4_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS3_get_cs_trans3_c4(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS4                                                                    0x140
+#define CS_TRANS4_reg_addr                                                           "0x98004140"
+#define CS_TRANS4_reg                                                                0x98004140
+#define set_CS_TRANS4_reg(data)   (*((volatile unsigned int*) CS_TRANS4_reg)=data)
+#define get_CS_TRANS4_reg   (*((volatile unsigned int*) CS_TRANS4_reg))
+#define CS_TRANS4_cs_trans4_c5_shift                                                 (0)
+#define CS_TRANS4_cs_trans4_c5_mask                                                  (0x0001FFFF)
+#define CS_TRANS4_cs_trans4_c5(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS4_cs_trans4_c5_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS4_get_cs_trans4_c5(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS5                                                                    0x144
+#define CS_TRANS5_reg_addr                                                           "0x98004144"
+#define CS_TRANS5_reg                                                                0x98004144
+#define set_CS_TRANS5_reg(data)   (*((volatile unsigned int*) CS_TRANS5_reg)=data)
+#define get_CS_TRANS5_reg   (*((volatile unsigned int*) CS_TRANS5_reg))
+#define CS_TRANS5_cs_trans5_c6_shift                                                 (0)
+#define CS_TRANS5_cs_trans5_c6_mask                                                  (0x0001FFFF)
+#define CS_TRANS5_cs_trans5_c6(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS5_cs_trans5_c6_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS5_get_cs_trans5_c6(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS6                                                                    0x148
+#define CS_TRANS6_reg_addr                                                           "0x98004148"
+#define CS_TRANS6_reg                                                                0x98004148
+#define set_CS_TRANS6_reg(data)   (*((volatile unsigned int*) CS_TRANS6_reg)=data)
+#define get_CS_TRANS6_reg   (*((volatile unsigned int*) CS_TRANS6_reg))
+#define CS_TRANS6_cs_trans6_c7_shift                                                 (0)
+#define CS_TRANS6_cs_trans6_c7_mask                                                  (0x0001FFFF)
+#define CS_TRANS6_cs_trans6_c7(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS6_cs_trans6_c7_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS6_get_cs_trans6_c7(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS7                                                                    0x14C
+#define CS_TRANS7_reg_addr                                                           "0x9800414C"
+#define CS_TRANS7_reg                                                                0x9800414C
+#define set_CS_TRANS7_reg(data)   (*((volatile unsigned int*) CS_TRANS7_reg)=data)
+#define get_CS_TRANS7_reg   (*((volatile unsigned int*) CS_TRANS7_reg))
+#define CS_TRANS7_cs_trans7_c8_shift                                                 (0)
+#define CS_TRANS7_cs_trans7_c8_mask                                                  (0x0001FFFF)
+#define CS_TRANS7_cs_trans7_c8(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS7_cs_trans7_c8_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS7_get_cs_trans7_c8(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS8                                                                    0x150
+#define CS_TRANS8_reg_addr                                                           "0x98004150"
+#define CS_TRANS8_reg                                                                0x98004150
+#define set_CS_TRANS8_reg(data)   (*((volatile unsigned int*) CS_TRANS8_reg)=data)
+#define get_CS_TRANS8_reg   (*((volatile unsigned int*) CS_TRANS8_reg))
+#define CS_TRANS8_cs_trans8_c9_shift                                                 (0)
+#define CS_TRANS8_cs_trans8_c9_mask                                                  (0x0001FFFF)
+#define CS_TRANS8_cs_trans8_c9(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS8_cs_trans8_c9_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS8_get_cs_trans8_c9(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS9                                                                    0x154
+#define CS_TRANS9_reg_addr                                                           "0x98004154"
+#define CS_TRANS9_reg                                                                0x98004154
+#define set_CS_TRANS9_reg(data)   (*((volatile unsigned int*) CS_TRANS9_reg)=data)
+#define get_CS_TRANS9_reg   (*((volatile unsigned int*) CS_TRANS9_reg))
+#define CS_TRANS9_cs_trans9_k1_shift                                                 (0)
+#define CS_TRANS9_cs_trans9_k1_mask                                                  (0x0000FFFF)
+#define CS_TRANS9_cs_trans9_k1(data)                                                 (0x0000FFFF&((data)<<0))
+#define CS_TRANS9_cs_trans9_k1_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define CS_TRANS9_get_cs_trans9_k1(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define CS_TRANS10                                                                   0x158
+#define CS_TRANS10_reg_addr                                                          "0x98004158"
+#define CS_TRANS10_reg                                                               0x98004158
+#define set_CS_TRANS10_reg(data)   (*((volatile unsigned int*) CS_TRANS10_reg)=data)
+#define get_CS_TRANS10_reg   (*((volatile unsigned int*) CS_TRANS10_reg))
+#define CS_TRANS10_cs_trans10_k2_shift                                               (0)
+#define CS_TRANS10_cs_trans10_k2_mask                                                (0x0000FFFF)
+#define CS_TRANS10_cs_trans10_k2(data)                                               (0x0000FFFF&((data)<<0))
+#define CS_TRANS10_cs_trans10_k2_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define CS_TRANS10_get_cs_trans10_k2(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define CS_TRANS11                                                                   0x15C
+#define CS_TRANS11_reg_addr                                                          "0x9800415C"
+#define CS_TRANS11_reg                                                               0x9800415C
+#define set_CS_TRANS11_reg(data)   (*((volatile unsigned int*) CS_TRANS11_reg)=data)
+#define get_CS_TRANS11_reg   (*((volatile unsigned int*) CS_TRANS11_reg))
+#define CS_TRANS11_cs_trans11_k3_shift                                               (0)
+#define CS_TRANS11_cs_trans11_k3_mask                                                (0x0000FFFF)
+#define CS_TRANS11_cs_trans11_k3(data)                                               (0x0000FFFF&((data)<<0))
+#define CS_TRANS11_cs_trans11_k3_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define CS_TRANS11_get_cs_trans11_k3(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define SCALER_HSI                                                                   0x160
+#define SCALER_HSI_reg_addr                                                          "0x98004160"
+#define SCALER_HSI_reg                                                               0x98004160
+#define set_SCALER_HSI_reg(data)   (*((volatile unsigned int*) SCALER_HSI_reg)=data)
+#define get_SCALER_HSI_reg   (*((volatile unsigned int*) SCALER_HSI_reg))
+#define SCALER_HSI_hsi_offset_shift                                                  (16)
+#define SCALER_HSI_hsi_offset_mask                                                   (0x1FFF0000)
+#define SCALER_HSI_hsi_offset(data)                                                  (0x1FFF0000&((data)<<16))
+#define SCALER_HSI_hsi_offset_src(data)                                              ((0x1FFF0000&(data))>>16)
+#define SCALER_HSI_get_hsi_offset(data)                                              ((0x1FFF0000&(data))>>16)
+#define SCALER_HSI_hsi_phase_shift                                                   (2)
+#define SCALER_HSI_hsi_phase_mask                                                    (0x0000FFFC)
+#define SCALER_HSI_hsi_phase(data)                                                   (0x0000FFFC&((data)<<2))
+#define SCALER_HSI_hsi_phase_src(data)                                               ((0x0000FFFC&(data))>>2)
+#define SCALER_HSI_get_hsi_phase(data)                                               ((0x0000FFFC&(data))>>2)
+
+
+#define SCALER_HSD                                                                   0x164
+#define SCALER_HSD_reg_addr                                                          "0x98004164"
+#define SCALER_HSD_reg                                                               0x98004164
+#define set_SCALER_HSD_reg(data)   (*((volatile unsigned int*) SCALER_HSD_reg)=data)
+#define get_SCALER_HSD_reg   (*((volatile unsigned int*) SCALER_HSD_reg))
+#define SCALER_HSD_hsd_out_shift                                                     (19)
+#define SCALER_HSD_hsd_out_mask                                                      (0xFFF80000)
+#define SCALER_HSD_hsd_out(data)                                                     (0xFFF80000&((data)<<19))
+#define SCALER_HSD_hsd_out_src(data)                                                 ((0xFFF80000&(data))>>19)
+#define SCALER_HSD_get_hsd_out(data)                                                 ((0xFFF80000&(data))>>19)
+#define SCALER_HSD_hsd_delta_shift                                                   (0)
+#define SCALER_HSD_hsd_delta_mask                                                    (0x0007FFFF)
+#define SCALER_HSD_hsd_delta(data)                                                   (0x0007FFFF&((data)<<0))
+#define SCALER_HSD_hsd_delta_src(data)                                               ((0x0007FFFF&(data))>>0)
+#define SCALER_HSD_get_hsd_delta(data)                                               ((0x0007FFFF&(data))>>0)
+
+
+#define SCALER_VSI                                                                   0x168
+#define SCALER_VSI_reg_addr                                                          "0x98004168"
+#define SCALER_VSI_reg                                                               0x98004168
+#define set_SCALER_VSI_reg(data)   (*((volatile unsigned int*) SCALER_VSI_reg)=data)
+#define get_SCALER_VSI_reg   (*((volatile unsigned int*) SCALER_VSI_reg))
+#define SCALER_VSI_vsi_offset_shift                                                  (16)
+#define SCALER_VSI_vsi_offset_mask                                                   (0x1FFF0000)
+#define SCALER_VSI_vsi_offset(data)                                                  (0x1FFF0000&((data)<<16))
+#define SCALER_VSI_vsi_offset_src(data)                                              ((0x1FFF0000&(data))>>16)
+#define SCALER_VSI_get_vsi_offset(data)                                              ((0x1FFF0000&(data))>>16)
+#define SCALER_VSI_vsi_phase_shift                                                   (2)
+#define SCALER_VSI_vsi_phase_mask                                                    (0x0000FFFC)
+#define SCALER_VSI_vsi_phase(data)                                                   (0x0000FFFC&((data)<<2))
+#define SCALER_VSI_vsi_phase_src(data)                                               ((0x0000FFFC&(data))>>2)
+#define SCALER_VSI_get_vsi_phase(data)                                               ((0x0000FFFC&(data))>>2)
+
+
+#define SCALER_VSD                                                                   0x16C
+#define SCALER_VSD_reg_addr                                                          "0x9800416C"
+#define SCALER_VSD_reg                                                               0x9800416C
+#define set_SCALER_VSD_reg(data)   (*((volatile unsigned int*) SCALER_VSD_reg)=data)
+#define get_SCALER_VSD_reg   (*((volatile unsigned int*) SCALER_VSD_reg))
+#define SCALER_VSD_vsd_out_shift                                                     (19)
+#define SCALER_VSD_vsd_out_mask                                                      (0xFFF80000)
+#define SCALER_VSD_vsd_out(data)                                                     (0xFFF80000&((data)<<19))
+#define SCALER_VSD_vsd_out_src(data)                                                 ((0xFFF80000&(data))>>19)
+#define SCALER_VSD_get_vsd_out(data)                                                 ((0xFFF80000&(data))>>19)
+#define SCALER_VSD_vsd_delta_shift                                                   (0)
+#define SCALER_VSD_vsd_delta_mask                                                    (0x0007FFFF)
+#define SCALER_VSD_vsd_delta(data)                                                   (0x0007FFFF&((data)<<0))
+#define SCALER_VSD_vsd_delta_src(data)                                               ((0x0007FFFF&(data))>>0)
+#define SCALER_VSD_get_vsd_delta(data)                                               ((0x0007FFFF&(data))>>0)
+
+
+#define SCALER_HSYNC0                                                                0x170
+#define SCALER_HSYNC0_reg_addr                                                       "0x98004170"
+#define SCALER_HSYNC0_reg                                                            0x98004170
+#define set_SCALER_HSYNC0_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC0_reg)=data)
+#define get_SCALER_HSYNC0_reg   (*((volatile unsigned int*) SCALER_HSYNC0_reg))
+#define SCALER_HSYNC0_hsync0_c1_shift                                                (16)
+#define SCALER_HSYNC0_hsync0_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC0_hsync0_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC0_hsync0_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC0_get_hsync0_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC0_hsync0_c0_shift                                                (0)
+#define SCALER_HSYNC0_hsync0_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC0_hsync0_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC0_hsync0_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC0_get_hsync0_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC1                                                                0x174
+#define SCALER_HSYNC1_reg_addr                                                       "0x98004174"
+#define SCALER_HSYNC1_reg                                                            0x98004174
+#define set_SCALER_HSYNC1_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC1_reg)=data)
+#define get_SCALER_HSYNC1_reg   (*((volatile unsigned int*) SCALER_HSYNC1_reg))
+#define SCALER_HSYNC1_hsync1_c1_shift                                                (16)
+#define SCALER_HSYNC1_hsync1_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC1_hsync1_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC1_hsync1_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC1_get_hsync1_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC1_hsync1_c0_shift                                                (0)
+#define SCALER_HSYNC1_hsync1_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC1_hsync1_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC1_hsync1_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC1_get_hsync1_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC2                                                                0x178
+#define SCALER_HSYNC2_reg_addr                                                       "0x98004178"
+#define SCALER_HSYNC2_reg                                                            0x98004178
+#define set_SCALER_HSYNC2_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC2_reg)=data)
+#define get_SCALER_HSYNC2_reg   (*((volatile unsigned int*) SCALER_HSYNC2_reg))
+#define SCALER_HSYNC2_hsync2_c1_shift                                                (16)
+#define SCALER_HSYNC2_hsync2_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC2_hsync2_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC2_hsync2_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC2_get_hsync2_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC2_hsync2_c0_shift                                                (0)
+#define SCALER_HSYNC2_hsync2_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC2_hsync2_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC2_hsync2_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC2_get_hsync2_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC3                                                                0x17C
+#define SCALER_HSYNC3_reg_addr                                                       "0x9800417C"
+#define SCALER_HSYNC3_reg                                                            0x9800417C
+#define set_SCALER_HSYNC3_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC3_reg)=data)
+#define get_SCALER_HSYNC3_reg   (*((volatile unsigned int*) SCALER_HSYNC3_reg))
+#define SCALER_HSYNC3_hsync3_c1_shift                                                (16)
+#define SCALER_HSYNC3_hsync3_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC3_hsync3_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC3_hsync3_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC3_get_hsync3_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC3_hsync3_c0_shift                                                (0)
+#define SCALER_HSYNC3_hsync3_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC3_hsync3_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC3_hsync3_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC3_get_hsync3_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC4                                                                0x180
+#define SCALER_HSYNC4_reg_addr                                                       "0x98004180"
+#define SCALER_HSYNC4_reg                                                            0x98004180
+#define set_SCALER_HSYNC4_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC4_reg)=data)
+#define get_SCALER_HSYNC4_reg   (*((volatile unsigned int*) SCALER_HSYNC4_reg))
+#define SCALER_HSYNC4_hsync4_c1_shift                                                (16)
+#define SCALER_HSYNC4_hsync4_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC4_hsync4_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC4_hsync4_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC4_get_hsync4_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC4_hsync4_c0_shift                                                (0)
+#define SCALER_HSYNC4_hsync4_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC4_hsync4_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC4_hsync4_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC4_get_hsync4_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC5                                                                0x184
+#define SCALER_HSYNC5_reg_addr                                                       "0x98004184"
+#define SCALER_HSYNC5_reg                                                            0x98004184
+#define set_SCALER_HSYNC5_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC5_reg)=data)
+#define get_SCALER_HSYNC5_reg   (*((volatile unsigned int*) SCALER_HSYNC5_reg))
+#define SCALER_HSYNC5_hsync5_c1_shift                                                (16)
+#define SCALER_HSYNC5_hsync5_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC5_hsync5_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC5_hsync5_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC5_get_hsync5_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC5_hsync5_c0_shift                                                (0)
+#define SCALER_HSYNC5_hsync5_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC5_hsync5_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC5_hsync5_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC5_get_hsync5_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC6                                                                0x188
+#define SCALER_HSYNC6_reg_addr                                                       "0x98004188"
+#define SCALER_HSYNC6_reg                                                            0x98004188
+#define set_SCALER_HSYNC6_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC6_reg)=data)
+#define get_SCALER_HSYNC6_reg   (*((volatile unsigned int*) SCALER_HSYNC6_reg))
+#define SCALER_HSYNC6_hsync6_c1_shift                                                (16)
+#define SCALER_HSYNC6_hsync6_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC6_hsync6_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC6_hsync6_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC6_get_hsync6_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC6_hsync6_c0_shift                                                (0)
+#define SCALER_HSYNC6_hsync6_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC6_hsync6_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC6_hsync6_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC6_get_hsync6_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC7                                                                0x18C
+#define SCALER_HSYNC7_reg_addr                                                       "0x9800418C"
+#define SCALER_HSYNC7_reg                                                            0x9800418C
+#define set_SCALER_HSYNC7_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC7_reg)=data)
+#define get_SCALER_HSYNC7_reg   (*((volatile unsigned int*) SCALER_HSYNC7_reg))
+#define SCALER_HSYNC7_hsync7_c1_shift                                                (16)
+#define SCALER_HSYNC7_hsync7_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC7_hsync7_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC7_hsync7_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC7_get_hsync7_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC7_hsync7_c0_shift                                                (0)
+#define SCALER_HSYNC7_hsync7_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC7_hsync7_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC7_hsync7_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC7_get_hsync7_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC0                                                                 0x190
+#define SCALER_HSCC0_reg_addr                                                        "0x98004190"
+#define SCALER_HSCC0_reg                                                             0x98004190
+#define set_SCALER_HSCC0_reg(data)   (*((volatile unsigned int*) SCALER_HSCC0_reg)=data)
+#define get_SCALER_HSCC0_reg   (*((volatile unsigned int*) SCALER_HSCC0_reg))
+#define SCALER_HSCC0_hscc0_c1_shift                                                  (16)
+#define SCALER_HSCC0_hscc0_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC0_hscc0_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC0_hscc0_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC0_get_hscc0_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC0_hscc0_c0_shift                                                  (0)
+#define SCALER_HSCC0_hscc0_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC0_hscc0_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC0_hscc0_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC0_get_hscc0_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC1                                                                 0x194
+#define SCALER_HSCC1_reg_addr                                                        "0x98004194"
+#define SCALER_HSCC1_reg                                                             0x98004194
+#define set_SCALER_HSCC1_reg(data)   (*((volatile unsigned int*) SCALER_HSCC1_reg)=data)
+#define get_SCALER_HSCC1_reg   (*((volatile unsigned int*) SCALER_HSCC1_reg))
+#define SCALER_HSCC1_hscc1_c1_shift                                                  (16)
+#define SCALER_HSCC1_hscc1_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC1_hscc1_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC1_hscc1_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC1_get_hscc1_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC1_hscc1_c0_shift                                                  (0)
+#define SCALER_HSCC1_hscc1_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC1_hscc1_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC1_hscc1_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC1_get_hscc1_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC2                                                                 0x198
+#define SCALER_HSCC2_reg_addr                                                        "0x98004198"
+#define SCALER_HSCC2_reg                                                             0x98004198
+#define set_SCALER_HSCC2_reg(data)   (*((volatile unsigned int*) SCALER_HSCC2_reg)=data)
+#define get_SCALER_HSCC2_reg   (*((volatile unsigned int*) SCALER_HSCC2_reg))
+#define SCALER_HSCC2_hscc2_c1_shift                                                  (16)
+#define SCALER_HSCC2_hscc2_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC2_hscc2_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC2_hscc2_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC2_get_hscc2_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC2_hscc2_c0_shift                                                  (0)
+#define SCALER_HSCC2_hscc2_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC2_hscc2_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC2_hscc2_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC2_get_hscc2_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC3                                                                 0x19C
+#define SCALER_HSCC3_reg_addr                                                        "0x9800419C"
+#define SCALER_HSCC3_reg                                                             0x9800419C
+#define set_SCALER_HSCC3_reg(data)   (*((volatile unsigned int*) SCALER_HSCC3_reg)=data)
+#define get_SCALER_HSCC3_reg   (*((volatile unsigned int*) SCALER_HSCC3_reg))
+#define SCALER_HSCC3_hscc3_c1_shift                                                  (16)
+#define SCALER_HSCC3_hscc3_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC3_hscc3_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC3_hscc3_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC3_get_hscc3_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC3_hscc3_c0_shift                                                  (0)
+#define SCALER_HSCC3_hscc3_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC3_hscc3_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC3_hscc3_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC3_get_hscc3_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC4                                                                 0x1A0
+#define SCALER_HSCC4_reg_addr                                                        "0x980041A0"
+#define SCALER_HSCC4_reg                                                             0x980041A0
+#define set_SCALER_HSCC4_reg(data)   (*((volatile unsigned int*) SCALER_HSCC4_reg)=data)
+#define get_SCALER_HSCC4_reg   (*((volatile unsigned int*) SCALER_HSCC4_reg))
+#define SCALER_HSCC4_hscc4_c1_shift                                                  (16)
+#define SCALER_HSCC4_hscc4_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC4_hscc4_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC4_hscc4_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC4_get_hscc4_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC4_hscc4_c0_shift                                                  (0)
+#define SCALER_HSCC4_hscc4_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC4_hscc4_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC4_hscc4_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC4_get_hscc4_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC5                                                                 0x1A4
+#define SCALER_HSCC5_reg_addr                                                        "0x980041A4"
+#define SCALER_HSCC5_reg                                                             0x980041A4
+#define set_SCALER_HSCC5_reg(data)   (*((volatile unsigned int*) SCALER_HSCC5_reg)=data)
+#define get_SCALER_HSCC5_reg   (*((volatile unsigned int*) SCALER_HSCC5_reg))
+#define SCALER_HSCC5_hscc5_c1_shift                                                  (16)
+#define SCALER_HSCC5_hscc5_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC5_hscc5_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC5_hscc5_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC5_get_hscc5_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC5_hscc5_c0_shift                                                  (0)
+#define SCALER_HSCC5_hscc5_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC5_hscc5_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC5_hscc5_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC5_get_hscc5_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC6                                                                 0x1A8
+#define SCALER_HSCC6_reg_addr                                                        "0x980041A8"
+#define SCALER_HSCC6_reg                                                             0x980041A8
+#define set_SCALER_HSCC6_reg(data)   (*((volatile unsigned int*) SCALER_HSCC6_reg)=data)
+#define get_SCALER_HSCC6_reg   (*((volatile unsigned int*) SCALER_HSCC6_reg))
+#define SCALER_HSCC6_hscc6_c1_shift                                                  (16)
+#define SCALER_HSCC6_hscc6_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC6_hscc6_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC6_hscc6_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC6_get_hscc6_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC6_hscc6_c0_shift                                                  (0)
+#define SCALER_HSCC6_hscc6_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC6_hscc6_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC6_hscc6_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC6_get_hscc6_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC7                                                                 0x1AC
+#define SCALER_HSCC7_reg_addr                                                        "0x980041AC"
+#define SCALER_HSCC7_reg                                                             0x980041AC
+#define set_SCALER_HSCC7_reg(data)   (*((volatile unsigned int*) SCALER_HSCC7_reg)=data)
+#define get_SCALER_HSCC7_reg   (*((volatile unsigned int*) SCALER_HSCC7_reg))
+#define SCALER_HSCC7_hscc7_c1_shift                                                  (16)
+#define SCALER_HSCC7_hscc7_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC7_hscc7_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC7_hscc7_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC7_get_hscc7_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC7_hscc7_c0_shift                                                  (0)
+#define SCALER_HSCC7_hscc7_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC7_hscc7_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC7_hscc7_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC7_get_hscc7_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC0                                                                 0x1B0
+#define SCALER_VSYC0_reg_addr                                                        "0x980041B0"
+#define SCALER_VSYC0_reg                                                             0x980041B0
+#define set_SCALER_VSYC0_reg(data)   (*((volatile unsigned int*) SCALER_VSYC0_reg)=data)
+#define get_SCALER_VSYC0_reg   (*((volatile unsigned int*) SCALER_VSYC0_reg))
+#define SCALER_VSYC0_vsyc0_c1_shift                                                  (16)
+#define SCALER_VSYC0_vsyc0_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC0_vsyc0_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC0_vsyc0_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC0_get_vsyc0_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC0_vsyc0_c0_shift                                                  (0)
+#define SCALER_VSYC0_vsyc0_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC0_vsyc0_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC0_vsyc0_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC0_get_vsyc0_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC1                                                                 0x1B4
+#define SCALER_VSYC1_reg_addr                                                        "0x980041B4"
+#define SCALER_VSYC1_reg                                                             0x980041B4
+#define set_SCALER_VSYC1_reg(data)   (*((volatile unsigned int*) SCALER_VSYC1_reg)=data)
+#define get_SCALER_VSYC1_reg   (*((volatile unsigned int*) SCALER_VSYC1_reg))
+#define SCALER_VSYC1_vsyc1_c1_shift                                                  (16)
+#define SCALER_VSYC1_vsyc1_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC1_vsyc1_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC1_vsyc1_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC1_get_vsyc1_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC1_vsyc1_c0_shift                                                  (0)
+#define SCALER_VSYC1_vsyc1_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC1_vsyc1_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC1_vsyc1_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC1_get_vsyc1_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC2                                                                 0x1B8
+#define SCALER_VSYC2_reg_addr                                                        "0x980041B8"
+#define SCALER_VSYC2_reg                                                             0x980041B8
+#define set_SCALER_VSYC2_reg(data)   (*((volatile unsigned int*) SCALER_VSYC2_reg)=data)
+#define get_SCALER_VSYC2_reg   (*((volatile unsigned int*) SCALER_VSYC2_reg))
+#define SCALER_VSYC2_vsyc2_c1_shift                                                  (16)
+#define SCALER_VSYC2_vsyc2_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC2_vsyc2_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC2_vsyc2_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC2_get_vsyc2_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC2_vsyc2_c0_shift                                                  (0)
+#define SCALER_VSYC2_vsyc2_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC2_vsyc2_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC2_vsyc2_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC2_get_vsyc2_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC3                                                                 0x1BC
+#define SCALER_VSYC3_reg_addr                                                        "0x980041BC"
+#define SCALER_VSYC3_reg                                                             0x980041BC
+#define set_SCALER_VSYC3_reg(data)   (*((volatile unsigned int*) SCALER_VSYC3_reg)=data)
+#define get_SCALER_VSYC3_reg   (*((volatile unsigned int*) SCALER_VSYC3_reg))
+#define SCALER_VSYC3_vsyc3_c1_shift                                                  (16)
+#define SCALER_VSYC3_vsyc3_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC3_vsyc3_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC3_vsyc3_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC3_get_vsyc3_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC3_vsyc3_c0_shift                                                  (0)
+#define SCALER_VSYC3_vsyc3_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC3_vsyc3_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC3_vsyc3_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC3_get_vsyc3_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC0                                                                 0x1C0
+#define SCALER_VSCC0_reg_addr                                                        "0x980041C0"
+#define SCALER_VSCC0_reg                                                             0x980041C0
+#define set_SCALER_VSCC0_reg(data)   (*((volatile unsigned int*) SCALER_VSCC0_reg)=data)
+#define get_SCALER_VSCC0_reg   (*((volatile unsigned int*) SCALER_VSCC0_reg))
+#define SCALER_VSCC0_vscc0_c1_shift                                                  (16)
+#define SCALER_VSCC0_vscc0_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC0_vscc0_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC0_vscc0_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC0_get_vscc0_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC0_vscc0_c0_shift                                                  (0)
+#define SCALER_VSCC0_vscc0_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC0_vscc0_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC0_vscc0_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC0_get_vscc0_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC1                                                                 0x1C4
+#define SCALER_VSCC1_reg_addr                                                        "0x980041C4"
+#define SCALER_VSCC1_reg                                                             0x980041C4
+#define set_SCALER_VSCC1_reg(data)   (*((volatile unsigned int*) SCALER_VSCC1_reg)=data)
+#define get_SCALER_VSCC1_reg   (*((volatile unsigned int*) SCALER_VSCC1_reg))
+#define SCALER_VSCC1_vscc1_c1_shift                                                  (16)
+#define SCALER_VSCC1_vscc1_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC1_vscc1_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC1_vscc1_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC1_get_vscc1_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC1_vscc1_c0_shift                                                  (0)
+#define SCALER_VSCC1_vscc1_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC1_vscc1_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC1_vscc1_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC1_get_vscc1_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC2                                                                 0x1C8
+#define SCALER_VSCC2_reg_addr                                                        "0x980041C8"
+#define SCALER_VSCC2_reg                                                             0x980041C8
+#define set_SCALER_VSCC2_reg(data)   (*((volatile unsigned int*) SCALER_VSCC2_reg)=data)
+#define get_SCALER_VSCC2_reg   (*((volatile unsigned int*) SCALER_VSCC2_reg))
+#define SCALER_VSCC2_vscc2_c1_shift                                                  (16)
+#define SCALER_VSCC2_vscc2_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC2_vscc2_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC2_vscc2_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC2_get_vscc2_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC2_vscc2_c0_shift                                                  (0)
+#define SCALER_VSCC2_vscc2_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC2_vscc2_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC2_vscc2_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC2_get_vscc2_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC3                                                                 0x1CC
+#define SCALER_VSCC3_reg_addr                                                        "0x980041CC"
+#define SCALER_VSCC3_reg                                                             0x980041CC
+#define set_SCALER_VSCC3_reg(data)   (*((volatile unsigned int*) SCALER_VSCC3_reg)=data)
+#define get_SCALER_VSCC3_reg   (*((volatile unsigned int*) SCALER_VSCC3_reg))
+#define SCALER_VSCC3_vscc3_c1_shift                                                  (16)
+#define SCALER_VSCC3_vscc3_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC3_vscc3_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC3_vscc3_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC3_get_vscc3_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC3_vscc3_c0_shift                                                  (0)
+#define SCALER_VSCC3_vscc3_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC3_vscc3_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC3_vscc3_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC3_get_vscc3_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define CONSTANT_ALPHA                                                               0x1D0
+#define CONSTANT_ALPHA_reg_addr                                                      "0x980041D0"
+#define CONSTANT_ALPHA_reg                                                           0x980041D0
+#define set_CONSTANT_ALPHA_reg(data)   (*((volatile unsigned int*) CONSTANT_ALPHA_reg)=data)
+#define get_CONSTANT_ALPHA_reg   (*((volatile unsigned int*) CONSTANT_ALPHA_reg))
+#define CONSTANT_ALPHA_alpha_shift                                                   (0)
+#define CONSTANT_ALPHA_alpha_mask                                                    (0x000000FF)
+#define CONSTANT_ALPHA_alpha(data)                                                   (0x000000FF&((data)<<0))
+#define CONSTANT_ALPHA_alpha_src(data)                                               ((0x000000FF&(data))>>0)
+#define CONSTANT_ALPHA_get_alpha(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define MIPI_BIST_MODE                                                               0x1D4
+#define MIPI_BIST_MODE_reg_addr                                                      "0x980041D4"
+#define MIPI_BIST_MODE_reg                                                           0x980041D4
+#define set_MIPI_BIST_MODE_reg(data)   (*((volatile unsigned int*) MIPI_BIST_MODE_reg)=data)
+#define get_MIPI_BIST_MODE_reg   (*((volatile unsigned int*) MIPI_BIST_MODE_reg))
+#define MIPI_BIST_MODE_drf_test_resume_shift                                         (2)
+#define MIPI_BIST_MODE_drf_test_resume_mask                                          (0x00000004)
+#define MIPI_BIST_MODE_drf_test_resume(data)                                         (0x00000004&((data)<<2))
+#define MIPI_BIST_MODE_drf_test_resume_src(data)                                     ((0x00000004&(data))>>2)
+#define MIPI_BIST_MODE_get_drf_test_resume(data)                                     ((0x00000004&(data))>>2)
+#define MIPI_BIST_MODE_drf_bist_mode_shift                                           (1)
+#define MIPI_BIST_MODE_drf_bist_mode_mask                                            (0x00000002)
+#define MIPI_BIST_MODE_drf_bist_mode(data)                                           (0x00000002&((data)<<1))
+#define MIPI_BIST_MODE_drf_bist_mode_src(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_BIST_MODE_get_drf_bist_mode(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_BIST_MODE_bist_mode_shift                                               (0)
+#define MIPI_BIST_MODE_bist_mode_mask                                                (0x00000001)
+#define MIPI_BIST_MODE_bist_mode(data)                                               (0x00000001&((data)<<0))
+#define MIPI_BIST_MODE_bist_mode_src(data)                                           ((0x00000001&(data))>>0)
+#define MIPI_BIST_MODE_get_bist_mode(data)                                           ((0x00000001&(data))>>0)
+
+
+#define MIPI_BIST_RESULT0                                                            0x1D8
+#define MIPI_BIST_RESULT0_reg_addr                                                   "0x980041D8"
+#define MIPI_BIST_RESULT0_reg                                                        0x980041D8
+#define set_MIPI_BIST_RESULT0_reg(data)   (*((volatile unsigned int*) MIPI_BIST_RESULT0_reg)=data)
+#define get_MIPI_BIST_RESULT0_reg   (*((volatile unsigned int*) MIPI_BIST_RESULT0_reg))
+#define MIPI_BIST_RESULT0_drf_start_pause_shift                                      (14)
+#define MIPI_BIST_RESULT0_drf_start_pause_mask                                       (0x00004000)
+#define MIPI_BIST_RESULT0_drf_start_pause(data)                                      (0x00004000&((data)<<14))
+#define MIPI_BIST_RESULT0_drf_start_pause_src(data)                                  ((0x00004000&(data))>>14)
+#define MIPI_BIST_RESULT0_get_drf_start_pause(data)                                  ((0x00004000&(data))>>14)
+#define MIPI_BIST_RESULT0_drf_bist_fail5_shift                                       (13)
+#define MIPI_BIST_RESULT0_drf_bist_fail5_mask                                        (0x00002000)
+#define MIPI_BIST_RESULT0_drf_bist_fail5(data)                                       (0x00002000&((data)<<13))
+#define MIPI_BIST_RESULT0_drf_bist_fail5_src(data)                                   ((0x00002000&(data))>>13)
+#define MIPI_BIST_RESULT0_get_drf_bist_fail5(data)                                   ((0x00002000&(data))>>13)
+#define MIPI_BIST_RESULT0_drf_bist_fail4_shift                                       (12)
+#define MIPI_BIST_RESULT0_drf_bist_fail4_mask                                        (0x00001000)
+#define MIPI_BIST_RESULT0_drf_bist_fail4(data)                                       (0x00001000&((data)<<12))
+#define MIPI_BIST_RESULT0_drf_bist_fail4_src(data)                                   ((0x00001000&(data))>>12)
+#define MIPI_BIST_RESULT0_get_drf_bist_fail4(data)                                   ((0x00001000&(data))>>12)
+#define MIPI_BIST_RESULT0_drf_bist_fail3_shift                                       (11)
+#define MIPI_BIST_RESULT0_drf_bist_fail3_mask                                        (0x00000800)
+#define MIPI_BIST_RESULT0_drf_bist_fail3(data)                                       (0x00000800&((data)<<11))
+#define MIPI_BIST_RESULT0_drf_bist_fail3_src(data)                                   ((0x00000800&(data))>>11)
+#define MIPI_BIST_RESULT0_get_drf_bist_fail3(data)                                   ((0x00000800&(data))>>11)
+#define MIPI_BIST_RESULT0_drf_bist_fail2_shift                                       (10)
+#define MIPI_BIST_RESULT0_drf_bist_fail2_mask                                        (0x00000400)
+#define MIPI_BIST_RESULT0_drf_bist_fail2(data)                                       (0x00000400&((data)<<10))
+#define MIPI_BIST_RESULT0_drf_bist_fail2_src(data)                                   ((0x00000400&(data))>>10)
+#define MIPI_BIST_RESULT0_get_drf_bist_fail2(data)                                   ((0x00000400&(data))>>10)
+#define MIPI_BIST_RESULT0_drf_bist_fail1_shift                                       (9)
+#define MIPI_BIST_RESULT0_drf_bist_fail1_mask                                        (0x00000200)
+#define MIPI_BIST_RESULT0_drf_bist_fail1(data)                                       (0x00000200&((data)<<9))
+#define MIPI_BIST_RESULT0_drf_bist_fail1_src(data)                                   ((0x00000200&(data))>>9)
+#define MIPI_BIST_RESULT0_get_drf_bist_fail1(data)                                   ((0x00000200&(data))>>9)
+#define MIPI_BIST_RESULT0_drf_bist_fail0_shift                                       (8)
+#define MIPI_BIST_RESULT0_drf_bist_fail0_mask                                        (0x00000100)
+#define MIPI_BIST_RESULT0_drf_bist_fail0(data)                                       (0x00000100&((data)<<8))
+#define MIPI_BIST_RESULT0_drf_bist_fail0_src(data)                                   ((0x00000100&(data))>>8)
+#define MIPI_BIST_RESULT0_get_drf_bist_fail0(data)                                   ((0x00000100&(data))>>8)
+#define MIPI_BIST_RESULT0_drf_bist_done_shift                                        (7)
+#define MIPI_BIST_RESULT0_drf_bist_done_mask                                         (0x00000080)
+#define MIPI_BIST_RESULT0_drf_bist_done(data)                                        (0x00000080&((data)<<7))
+#define MIPI_BIST_RESULT0_drf_bist_done_src(data)                                    ((0x00000080&(data))>>7)
+#define MIPI_BIST_RESULT0_get_drf_bist_done(data)                                    ((0x00000080&(data))>>7)
+#define MIPI_BIST_RESULT0_bist_fail5_shift                                           (6)
+#define MIPI_BIST_RESULT0_bist_fail5_mask                                            (0x00000040)
+#define MIPI_BIST_RESULT0_bist_fail5(data)                                           (0x00000040&((data)<<6))
+#define MIPI_BIST_RESULT0_bist_fail5_src(data)                                       ((0x00000040&(data))>>6)
+#define MIPI_BIST_RESULT0_get_bist_fail5(data)                                       ((0x00000040&(data))>>6)
+#define MIPI_BIST_RESULT0_bist_fail4_shift                                           (5)
+#define MIPI_BIST_RESULT0_bist_fail4_mask                                            (0x00000020)
+#define MIPI_BIST_RESULT0_bist_fail4(data)                                           (0x00000020&((data)<<5))
+#define MIPI_BIST_RESULT0_bist_fail4_src(data)                                       ((0x00000020&(data))>>5)
+#define MIPI_BIST_RESULT0_get_bist_fail4(data)                                       ((0x00000020&(data))>>5)
+#define MIPI_BIST_RESULT0_bist_fail3_shift                                           (4)
+#define MIPI_BIST_RESULT0_bist_fail3_mask                                            (0x00000010)
+#define MIPI_BIST_RESULT0_bist_fail3(data)                                           (0x00000010&((data)<<4))
+#define MIPI_BIST_RESULT0_bist_fail3_src(data)                                       ((0x00000010&(data))>>4)
+#define MIPI_BIST_RESULT0_get_bist_fail3(data)                                       ((0x00000010&(data))>>4)
+#define MIPI_BIST_RESULT0_bist_fail2_shift                                           (3)
+#define MIPI_BIST_RESULT0_bist_fail2_mask                                            (0x00000008)
+#define MIPI_BIST_RESULT0_bist_fail2(data)                                           (0x00000008&((data)<<3))
+#define MIPI_BIST_RESULT0_bist_fail2_src(data)                                       ((0x00000008&(data))>>3)
+#define MIPI_BIST_RESULT0_get_bist_fail2(data)                                       ((0x00000008&(data))>>3)
+#define MIPI_BIST_RESULT0_bist_fail1_shift                                           (2)
+#define MIPI_BIST_RESULT0_bist_fail1_mask                                            (0x00000004)
+#define MIPI_BIST_RESULT0_bist_fail1(data)                                           (0x00000004&((data)<<2))
+#define MIPI_BIST_RESULT0_bist_fail1_src(data)                                       ((0x00000004&(data))>>2)
+#define MIPI_BIST_RESULT0_get_bist_fail1(data)                                       ((0x00000004&(data))>>2)
+#define MIPI_BIST_RESULT0_bist_fail0_shift                                           (1)
+#define MIPI_BIST_RESULT0_bist_fail0_mask                                            (0x00000002)
+#define MIPI_BIST_RESULT0_bist_fail0(data)                                           (0x00000002&((data)<<1))
+#define MIPI_BIST_RESULT0_bist_fail0_src(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_BIST_RESULT0_get_bist_fail0(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_BIST_RESULT0_bist_done_shift                                            (0)
+#define MIPI_BIST_RESULT0_bist_done_mask                                             (0x00000001)
+#define MIPI_BIST_RESULT0_bist_done(data)                                            (0x00000001&((data)<<0))
+#define MIPI_BIST_RESULT0_bist_done_src(data)                                        ((0x00000001&(data))>>0)
+#define MIPI_BIST_RESULT0_get_bist_done(data)                                        ((0x00000001&(data))>>0)
+
+
+#define MIPI_BIST_RESULT1                                                            0x1DC
+#define MIPI_BIST_RESULT1_reg_addr                                                   "0x980041DC"
+#define MIPI_BIST_RESULT1_reg                                                        0x980041DC
+#define set_MIPI_BIST_RESULT1_reg(data)   (*((volatile unsigned int*) MIPI_BIST_RESULT1_reg)=data)
+#define get_MIPI_BIST_RESULT1_reg   (*((volatile unsigned int*) MIPI_BIST_RESULT1_reg))
+#define MIPI_BIST_RESULT1_clk_gate_l4_dis_shift                                      (8)
+#define MIPI_BIST_RESULT1_clk_gate_l4_dis_mask                                       (0x00000100)
+#define MIPI_BIST_RESULT1_clk_gate_l4_dis(data)                                      (0x00000100&((data)<<8))
+#define MIPI_BIST_RESULT1_clk_gate_l4_dis_src(data)                                  ((0x00000100&(data))>>8)
+#define MIPI_BIST_RESULT1_get_clk_gate_l4_dis(data)                                  ((0x00000100&(data))>>8)
+#define MIPI_BIST_RESULT1_clk_gate_dbus_dis_shift                                    (7)
+#define MIPI_BIST_RESULT1_clk_gate_dbus_dis_mask                                     (0x00000080)
+#define MIPI_BIST_RESULT1_clk_gate_dbus_dis(data)                                    (0x00000080&((data)<<7))
+#define MIPI_BIST_RESULT1_clk_gate_dbus_dis_src(data)                                ((0x00000080&(data))>>7)
+#define MIPI_BIST_RESULT1_get_clk_gate_dbus_dis(data)                                ((0x00000080&(data))>>7)
+#define MIPI_BIST_RESULT1_sram_ls_gate_en_shift                                      (6)
+#define MIPI_BIST_RESULT1_sram_ls_gate_en_mask                                       (0x00000040)
+#define MIPI_BIST_RESULT1_sram_ls_gate_en(data)                                      (0x00000040&((data)<<6))
+#define MIPI_BIST_RESULT1_sram_ls_gate_en_src(data)                                  ((0x00000040&(data))>>6)
+#define MIPI_BIST_RESULT1_get_sram_ls_gate_en(data)                                  ((0x00000040&(data))>>6)
+#define MIPI_BIST_RESULT1_sram_ls_shift                                              (5)
+#define MIPI_BIST_RESULT1_sram_ls_mask                                               (0x00000020)
+#define MIPI_BIST_RESULT1_sram_ls(data)                                              (0x00000020&((data)<<5))
+#define MIPI_BIST_RESULT1_sram_ls_src(data)                                          ((0x00000020&(data))>>5)
+#define MIPI_BIST_RESULT1_get_sram_ls(data)                                          ((0x00000020&(data))>>5)
+#define MIPI_BIST_RESULT1_sram_rm_shift                                              (1)
+#define MIPI_BIST_RESULT1_sram_rm_mask                                               (0x0000001E)
+#define MIPI_BIST_RESULT1_sram_rm(data)                                              (0x0000001E&((data)<<1))
+#define MIPI_BIST_RESULT1_sram_rm_src(data)                                          ((0x0000001E&(data))>>1)
+#define MIPI_BIST_RESULT1_get_sram_rm(data)                                          ((0x0000001E&(data))>>1)
+#define MIPI_BIST_RESULT1_sram_rme_shift                                             (0)
+#define MIPI_BIST_RESULT1_sram_rme_mask                                              (0x00000001)
+#define MIPI_BIST_RESULT1_sram_rme(data)                                             (0x00000001&((data)<<0))
+#define MIPI_BIST_RESULT1_sram_rme_src(data)                                         ((0x00000001&(data))>>0)
+#define MIPI_BIST_RESULT1_get_sram_rme(data)                                         ((0x00000001&(data))>>0)
+
+
+#define MIPI_SA0_UV                                                                  0x1E0
+#define MIPI_SA0_UV_reg_addr                                                         "0x980041E0"
+#define MIPI_SA0_UV_reg                                                              0x980041E0
+#define set_MIPI_SA0_UV_reg(data)   (*((volatile unsigned int*) MIPI_SA0_UV_reg)=data)
+#define get_MIPI_SA0_UV_reg   (*((volatile unsigned int*) MIPI_SA0_UV_reg))
+#define MIPI_SA0_UV_sa0_video_uv_shift                                               (0)
+#define MIPI_SA0_UV_sa0_video_uv_mask                                                (0xFFFFFFFF)
+#define MIPI_SA0_UV_sa0_video_uv(data)                                               (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA0_UV_sa0_video_uv_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA0_UV_get_sa0_video_uv(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SA1_UV                                                                  0x1E4
+#define MIPI_SA1_UV_reg_addr                                                         "0x980041E4"
+#define MIPI_SA1_UV_reg                                                              0x980041E4
+#define set_MIPI_SA1_UV_reg(data)   (*((volatile unsigned int*) MIPI_SA1_UV_reg)=data)
+#define get_MIPI_SA1_UV_reg   (*((volatile unsigned int*) MIPI_SA1_UV_reg))
+#define MIPI_SA1_UV_sa1_video_uv_shift                                               (0)
+#define MIPI_SA1_UV_sa1_video_uv_mask                                                (0xFFFFFFFF)
+#define MIPI_SA1_UV_sa1_video_uv(data)                                               (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA1_UV_sa1_video_uv_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA1_UV_get_sa1_video_uv(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SA2_UV                                                                  0x1E8
+#define MIPI_SA2_UV_reg_addr                                                         "0x980041E8"
+#define MIPI_SA2_UV_reg                                                              0x980041E8
+#define set_MIPI_SA2_UV_reg(data)   (*((volatile unsigned int*) MIPI_SA2_UV_reg)=data)
+#define get_MIPI_SA2_UV_reg   (*((volatile unsigned int*) MIPI_SA2_UV_reg))
+#define MIPI_SA2_UV_sa2_pic_uv_shift                                                 (0)
+#define MIPI_SA2_UV_sa2_pic_uv_mask                                                  (0xFFFFFFFF)
+#define MIPI_SA2_UV_sa2_pic_uv(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define MIPI_SA2_UV_sa2_pic_uv_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define MIPI_SA2_UV_get_sa2_pic_uv(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_RESET                                                                   0x1EC
+#define MIPI_RESET_reg_addr                                                          "0x980041EC"
+#define MIPI_RESET_reg                                                               0x980041EC
+#define set_MIPI_RESET_reg(data)   (*((volatile unsigned int*) MIPI_RESET_reg)=data)
+#define get_MIPI_RESET_reg   (*((volatile unsigned int*) MIPI_RESET_reg))
+#define MIPI_RESET_pic_detect_en_shift                                               (2)
+#define MIPI_RESET_pic_detect_en_mask                                                (0x00000004)
+#define MIPI_RESET_pic_detect_en(data)                                               (0x00000004&((data)<<2))
+#define MIPI_RESET_pic_detect_en_src(data)                                           ((0x00000004&(data))>>2)
+#define MIPI_RESET_get_pic_detect_en(data)                                           ((0x00000004&(data))>>2)
+#define MIPI_RESET_pic_detect_int_en_shift                                           (1)
+#define MIPI_RESET_pic_detect_int_en_mask                                            (0x00000002)
+#define MIPI_RESET_pic_detect_int_en(data)                                           (0x00000002&((data)<<1))
+#define MIPI_RESET_pic_detect_int_en_src(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_RESET_get_pic_detect_int_en(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_RESET_mipi_sw_rst_shift                                                 (0)
+#define MIPI_RESET_mipi_sw_rst_mask                                                  (0x00000001)
+#define MIPI_RESET_mipi_sw_rst(data)                                                 (0x00000001&((data)<<0))
+#define MIPI_RESET_mipi_sw_rst_src(data)                                             ((0x00000001&(data))>>0)
+#define MIPI_RESET_get_mipi_sw_rst(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MIPI_DEBUGPORTS                                                              0x1F0
+#define MIPI_DEBUGPORTS_reg_addr                                                     "0x980041F0"
+#define MIPI_DEBUGPORTS_reg                                                          0x980041F0
+#define set_MIPI_DEBUGPORTS_reg(data)   (*((volatile unsigned int*) MIPI_DEBUGPORTS_reg)=data)
+#define get_MIPI_DEBUGPORTS_reg   (*((volatile unsigned int*) MIPI_DEBUGPORTS_reg))
+#define MIPI_DEBUGPORTS_dbg_sel_shift                                                (8)
+#define MIPI_DEBUGPORTS_dbg_sel_mask                                                 (0x00000100)
+#define MIPI_DEBUGPORTS_dbg_sel(data)                                                (0x00000100&((data)<<8))
+#define MIPI_DEBUGPORTS_dbg_sel_src(data)                                            ((0x00000100&(data))>>8)
+#define MIPI_DEBUGPORTS_get_dbg_sel(data)                                            ((0x00000100&(data))>>8)
+#define MIPI_DEBUGPORTS_dbg_sel1_shift                                               (4)
+#define MIPI_DEBUGPORTS_dbg_sel1_mask                                                (0x000000F0)
+#define MIPI_DEBUGPORTS_dbg_sel1(data)                                               (0x000000F0&((data)<<4))
+#define MIPI_DEBUGPORTS_dbg_sel1_src(data)                                           ((0x000000F0&(data))>>4)
+#define MIPI_DEBUGPORTS_get_dbg_sel1(data)                                           ((0x000000F0&(data))>>4)
+#define MIPI_DEBUGPORTS_dbg_sel0_shift                                               (0)
+#define MIPI_DEBUGPORTS_dbg_sel0_mask                                                (0x0000000F)
+#define MIPI_DEBUGPORTS_dbg_sel0(data)                                               (0x0000000F&((data)<<0))
+#define MIPI_DEBUGPORTS_dbg_sel0_src(data)                                           ((0x0000000F&(data))>>0)
+#define MIPI_DEBUGPORTS_get_dbg_sel0(data)                                           ((0x0000000F&(data))>>0)
+
+
+#define MIPI_DUMMY_REG0                                                              0x1F4
+#define MIPI_DUMMY_REG0_reg_addr                                                     "0x980041F4"
+#define MIPI_DUMMY_REG0_reg                                                          0x980041F4
+#define set_MIPI_DUMMY_REG0_reg(data)   (*((volatile unsigned int*) MIPI_DUMMY_REG0_reg)=data)
+#define get_MIPI_DUMMY_REG0_reg   (*((volatile unsigned int*) MIPI_DUMMY_REG0_reg))
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0_shift                                        (0)
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0_mask                                         (0xFFFFFFFF)
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0(data)                                        (0xFFFFFFFF&((data)<<0))
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define MIPI_DUMMY_REG0_get_mipi_dummy_reg0(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_DUMMY_REG1                                                              0x1F8
+#define MIPI_DUMMY_REG1_reg_addr                                                     "0x980041F8"
+#define MIPI_DUMMY_REG1_reg                                                          0x980041F8
+#define set_MIPI_DUMMY_REG1_reg(data)   (*((volatile unsigned int*) MIPI_DUMMY_REG1_reg)=data)
+#define get_MIPI_DUMMY_REG1_reg   (*((volatile unsigned int*) MIPI_DUMMY_REG1_reg))
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1_shift                                        (0)
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1_mask                                         (0xFFFFFFFF)
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1(data)                                        (0xFFFFFFFF&((data)<<0))
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define MIPI_DUMMY_REG1_get_mipi_dummy_reg1(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_SIZE3                                                                   0x1FC
+#define MIPI_SIZE3_reg_addr                                                          "0x980041FC"
+#define MIPI_SIZE3_reg                                                               0x980041FC
+#define set_MIPI_SIZE3_reg(data)   (*((volatile unsigned int*) MIPI_SIZE3_reg)=data)
+#define get_MIPI_SIZE3_reg   (*((volatile unsigned int*) MIPI_SIZE3_reg))
+#define MIPI_SIZE3_src_height_shift                                                  (0)
+#define MIPI_SIZE3_src_height_mask                                                   (0x00001FFF)
+#define MIPI_SIZE3_src_height(data)                                                  (0x00001FFF&((data)<<0))
+#define MIPI_SIZE3_src_height_src(data)                                              ((0x00001FFF&(data))>>0)
+#define MIPI_SIZE3_get_src_height(data)                                              ((0x00001FFF&(data))>>0)
+
+
+#define MIPI_RESOLUTION_DETECT                                                       0x200
+#define MIPI_RESOLUTION_DETECT_reg_addr                                              "0x98004200"
+#define MIPI_RESOLUTION_DETECT_reg                                                   0x98004200
+#define set_MIPI_RESOLUTION_DETECT_reg(data)   (*((volatile unsigned int*) MIPI_RESOLUTION_DETECT_reg)=data)
+#define get_MIPI_RESOLUTION_DETECT_reg   (*((volatile unsigned int*) MIPI_RESOLUTION_DETECT_reg))
+#define MIPI_RESOLUTION_DETECT_pic_detect_vcnt_shift                                 (13)
+#define MIPI_RESOLUTION_DETECT_pic_detect_vcnt_mask                                  (0x03FFE000)
+#define MIPI_RESOLUTION_DETECT_pic_detect_vcnt(data)                                 (0x03FFE000&((data)<<13))
+#define MIPI_RESOLUTION_DETECT_pic_detect_vcnt_src(data)                             ((0x03FFE000&(data))>>13)
+#define MIPI_RESOLUTION_DETECT_get_pic_detect_vcnt(data)                             ((0x03FFE000&(data))>>13)
+#define MIPI_RESOLUTION_DETECT_pic_detect_hcnt_shift                                 (0)
+#define MIPI_RESOLUTION_DETECT_pic_detect_hcnt_mask                                  (0x00001FFF)
+#define MIPI_RESOLUTION_DETECT_pic_detect_hcnt(data)                                 (0x00001FFF&((data)<<0))
+#define MIPI_RESOLUTION_DETECT_pic_detect_hcnt_src(data)                             ((0x00001FFF&(data))>>0)
+#define MIPI_RESOLUTION_DETECT_get_pic_detect_hcnt(data)                             ((0x00001FFF&(data))>>0)
+
+
+#define MIPI_URGENT                                                                  0x204
+#define MIPI_URGENT_reg_addr                                                         "0x98004204"
+#define MIPI_URGENT_reg                                                              0x98004204
+#define set_MIPI_URGENT_reg(data)   (*((volatile unsigned int*) MIPI_URGENT_reg)=data)
+#define get_MIPI_URGENT_reg   (*((volatile unsigned int*) MIPI_URGENT_reg))
+#define MIPI_URGENT_buf_up_bound_shift                                               (0)
+#define MIPI_URGENT_buf_up_bound_mask                                                (0x0000003F)
+#define MIPI_URGENT_buf_up_bound(data)                                               (0x0000003F&((data)<<0))
+#define MIPI_URGENT_buf_up_bound_src(data)                                           ((0x0000003F&(data))>>0)
+#define MIPI_URGENT_get_buf_up_bound(data)                                           ((0x0000003F&(data))>>0)
+
+
+#define MIPI_BUF_USAGE                                                               0x208
+#define MIPI_BUF_USAGE_reg_addr                                                      "0x98004208"
+#define MIPI_BUF_USAGE_reg                                                           0x98004208
+#define set_MIPI_BUF_USAGE_reg(data)   (*((volatile unsigned int*) MIPI_BUF_USAGE_reg)=data)
+#define get_MIPI_BUF_USAGE_reg   (*((volatile unsigned int*) MIPI_BUF_USAGE_reg))
+#define MIPI_BUF_USAGE_mipi_buf_usage_shift                                          (0)
+#define MIPI_BUF_USAGE_mipi_buf_usage_mask                                           (0x0000003F)
+#define MIPI_BUF_USAGE_mipi_buf_usage(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_BUF_USAGE_mipi_buf_usage_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_BUF_USAGE_get_mipi_buf_usage(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define ISOLATION_ENABLE                                                             0x20C
+#define ISOLATION_ENABLE_reg_addr                                                    "0x9800420C"
+#define ISOLATION_ENABLE_reg                                                         0x9800420C
+#define set_ISOLATION_ENABLE_reg(data)   (*((volatile unsigned int*) ISOLATION_ENABLE_reg)=data)
+#define get_ISOLATION_ENABLE_reg   (*((volatile unsigned int*) ISOLATION_ENABLE_reg))
+#define ISOLATION_ENABLE_mipi_isolation_enable_shift                                 (0)
+#define ISOLATION_ENABLE_mipi_isolation_enable_mask                                  (0x00000001)
+#define ISOLATION_ENABLE_mipi_isolation_enable(data)                                 (0x00000001&((data)<<0))
+#define ISOLATION_ENABLE_mipi_isolation_enable_src(data)                             ((0x00000001&(data))>>0)
+#define ISOLATION_ENABLE_get_mipi_isolation_enable(data)                             ((0x00000001&(data))>>0)
+
+
+#define BIST_SETTING                                                                 0x210
+#define BIST_SETTING_reg_addr                                                        "0x98004210"
+#define BIST_SETTING_reg                                                             0x98004210
+#define set_BIST_SETTING_reg(data)   (*((volatile unsigned int*) BIST_SETTING_reg)=data)
+#define get_BIST_SETTING_reg   (*((volatile unsigned int*) BIST_SETTING_reg))
+#define BIST_SETTING_bist_set_on_shift                                               (0)
+#define BIST_SETTING_bist_set_on_mask                                                (0x00000001)
+#define BIST_SETTING_bist_set_on(data)                                               (0x00000001&((data)<<0))
+#define BIST_SETTING_bist_set_on_src(data)                                           ((0x00000001&(data))>>0)
+#define BIST_SETTING_get_bist_set_on(data)                                           ((0x00000001&(data))>>0)
+
+
+#define GROUP                                                                        0x214
+#define GROUP_reg_addr                                                               "0x98004214"
+#define GROUP_reg                                                                    0x98004214
+#define set_GROUP_reg(data)   (*((volatile unsigned int*) GROUP_reg)=data)
+#define get_GROUP_reg   (*((volatile unsigned int*) GROUP_reg))
+#define GROUP_grp_lmt_shift                                                          (4)
+#define GROUP_grp_lmt_mask                                                           (0x000001F0)
+#define GROUP_grp_lmt(data)                                                          (0x000001F0&((data)<<4))
+#define GROUP_grp_lmt_src(data)                                                      ((0x000001F0&(data))>>4)
+#define GROUP_get_grp_lmt(data)                                                      ((0x000001F0&(data))>>4)
+#define GROUP_grp_size_shift                                                         (1)
+#define GROUP_grp_size_mask                                                          (0x0000000E)
+#define GROUP_grp_size(data)                                                         (0x0000000E&((data)<<1))
+#define GROUP_grp_size_src(data)                                                     ((0x0000000E&(data))>>1)
+#define GROUP_get_grp_size(data)                                                     ((0x0000000E&(data))>>1)
+#define GROUP_grp_wen_shift                                                          (0)
+#define GROUP_grp_wen_mask                                                           (0x00000001)
+#define GROUP_grp_wen(data)                                                          (0x00000001&((data)<<0))
+#define GROUP_grp_wen_src(data)                                                      ((0x00000001&(data))>>0)
+#define GROUP_get_grp_wen(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define DC_PROTECT                                                                   0x220
+#define DC_PROTECT_reg_addr                                                          "0x98004220"
+#define DC_PROTECT_reg                                                               0x98004220
+#define set_DC_PROTECT_reg(data)   (*((volatile unsigned int*) DC_PROTECT_reg)=data)
+#define get_DC_PROTECT_reg   (*((volatile unsigned int*) DC_PROTECT_reg))
+#define DC_PROTECT_dc_protect_shift                                                  (0)
+#define DC_PROTECT_dc_protect_mask                                                   (0x00000001)
+#define DC_PROTECT_dc_protect(data)                                                  (0x00000001&((data)<<0))
+#define DC_PROTECT_dc_protect_src(data)                                              ((0x00000001&(data))>>0)
+#define DC_PROTECT_get_dc_protect(data)                                              ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/misc_reg.h b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/misc_reg.h
new file mode 100644
index 00000000..b8a3b6f
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include/misc_reg.h
@@ -0,0 +1,38 @@
+/*
+ * misc_reg.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#define MIS_SCPU_CLK90K_LO                                                           0x40
+#define MIS_SCPU_CLK90K_LO_reg_addr                                                  "0x9801B540"
+#define MIS_SCPU_CLK90K_LO_reg                                                       0x9801B540
+#define set_MIS_SCPU_CLK90K_LO_reg(data)   (*((volatile unsigned int*) MIS_SCPU_CLK90K_LO_reg)=data)
+#define get_MIS_SCPU_CLK90K_LO_reg   (*((volatile unsigned int*) MIS_SCPU_CLK90K_LO_reg))
+#define MIS_SCPU_CLK90K_LO_inst_adr                                                  "0x0050"
+#define MIS_SCPU_CLK90K_LO_inst                                                      0x0050
+#define MIS_SCPU_CLK90K_LO_val_shift                                                 (0)
+#define MIS_SCPU_CLK90K_LO_val_mask                                                  (0xFFFFFFFF)
+#define MIS_SCPU_CLK90K_LO_val(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define MIS_SCPU_CLK90K_LO_val_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define MIS_SCPU_CLK90K_LO_get_val(data)                                             ((0xFFFFFFFF&(data))>>0)
+ 
+ 
+#define MIS_SCPU_CLK90K_HI                                                           0x44
+#define MIS_SCPU_CLK90K_HI_reg_addr                                                  "0x9801B544"
+#define MIS_SCPU_CLK90K_HI_reg                                                       0x9801B544
+#define set_MIS_SCPU_CLK90K_HI_reg(data)   (*((volatile unsigned int*) MIS_SCPU_CLK90K_HI_reg)=data)
+#define get_MIS_SCPU_CLK90K_HI_reg   (*((volatile unsigned int*) MIS_SCPU_CLK90K_HI_reg))
+#define MIS_SCPU_CLK90K_HI_inst_adr                                                  "0x0051"
+#define MIS_SCPU_CLK90K_HI_inst                                                      0x0051
+#define MIS_SCPU_CLK90K_HI_val_shift                                                 (0)
+#define MIS_SCPU_CLK90K_HI_val_mask                                                  (0x0000FFFF)
+#define MIS_SCPU_CLK90K_HI_val(data)                                                 (0x0000FFFF&((data)<<0))
+#define MIS_SCPU_CLK90K_HI_val_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define MIS_SCPU_CLK90K_HI_get_val(data)                                             ((0x0000FFFF&(data))>>0)
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/Makefile b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/Makefile
new file mode 100644
index 00000000..222a0a7
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/Makefile
@@ -0,0 +1,8 @@
+
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmirx/rtd161x/reg_include
+ccflags-y += -I$(srctree)/drivers/media/platform/rtk_hdmirx/rtd161x/
+ccflags-y += -I$(srctree)/drivers/staging/android/
+ccflags-y += -I$(srctree)/drivers/tee
+
+obj-$(CONFIG_RTK_HDMIRX)    += hdmiHdmi.o hdmiEDID.o hdmiPhy.o
+obj-$(CONFIG_RTK_HDCPRX_1P4_TEE) += TEE2p1_HDCP1p4_ENTRY.o
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/TEE2p1_HDCP1p4_ENTRY.c b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/TEE2p1_HDCP1p4_ENTRY.c
new file mode 100644
index 00000000..cb5e16f
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/TEE2p1_HDCP1p4_ENTRY.c
@@ -0,0 +1,145 @@
+/*
+ * TEE2p1_HDCP1p4_ENTRY.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/cdev.h>
+#include <linux/device.h>
+#include <linux/fs.h>
+#include <linux/idr.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include <linux/uaccess.h>
+
+#include "tee_private.h"
+#include "tee_client_api.h"
+
+#define TA_HDCP1p4RX_UUID {0x0df2fadb, 0xb2e0, 0x4345, \
+		{0xa4, 0x91, 0xef, 0x0a, 0xcf, 0xae, 0xd1, 0x84} }
+#define TA_HELLO_WORLD_CMD_INC_VALUE 0xff
+#define TA_HDCP1p4_KEY 0x0e
+
+struct tee_context *ctx_hdcprx;
+struct tee_ioctl_open_session_arg arg_hdcprx;
+struct tee_param  param_HDCP1p4[4];
+
+extern int TEE2p1_Flag;
+
+static void uuid_to_octets(uint8_t d[TEE_IOCTL_UUID_LEN], const TEEC_UUID *s)
+{
+	d[0] = s->timeLow >> 24;
+	d[1] = s->timeLow >> 16;
+	d[2] = s->timeLow >> 8;
+	d[3] = s->timeLow;
+	d[4] = s->timeMid >> 8;
+	d[5] = s->timeMid;
+	d[6] = s->timeHiAndVersion >> 8;
+	d[7] = s->timeHiAndVersion;
+	memcpy(d + 8, s->clockSeqAndNode, sizeof(s->clockSeqAndNode));
+}
+
+static int hdcp_optee_match(struct tee_ioctl_version_data *data,
+	const void *vers)
+{
+	return 1;
+}
+
+void HDCP1p4_ta_init(void)
+{
+	struct tee_ioctl_version_data vers = {
+		.impl_id = TEE_OPTEE_CAP_TZ,
+		.impl_caps = TEE_IMPL_ID_OPTEE,
+		.gen_caps = TEE_GEN_CAP_GP,
+	};
+
+	TEEC_UUID ta_id = TA_HDCP1p4RX_UUID;
+
+	ctx_hdcprx = tee_client_open_context(NULL, hdcp_optee_match, NULL, &vers);
+
+	if (IS_ERR(ctx_hdcprx))
+		pr_err("[HDCP RX] get tee context fail\n");
+
+	uuid_to_octets((uint8_t *)&arg_hdcprx.uuid, &ta_id);
+
+	arg_hdcprx.clnt_login = TEEC_LOGIN_PUBLIC;
+	arg_hdcprx.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	param_HDCP1p4[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param_HDCP1p4[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param_HDCP1p4[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param_HDCP1p4[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_open_session(ctx_hdcprx, &arg_hdcprx, param_HDCP1p4);
+
+}
+
+
+int HDCP1p4_ta_deinit(void)
+{
+	int result;
+
+	if (ctx_hdcprx == NULL)
+		return 0;
+
+	result = tee_client_close_session(ctx_hdcprx, arg_hdcprx.session);
+	tee_client_close_context(ctx_hdcprx);
+	ctx_hdcprx = NULL;
+
+	return result;
+}
+
+
+unsigned char  T_KEY[5];
+int  CA_hdcp1p4_RX_SET_KEY(void)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+	struct tee_shm *shm;
+
+	arg_I.func = TA_HDCP1p4_KEY;
+	arg_I.session = arg_hdcprx.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+	shm = tee_shm_alloc(ctx_hdcprx, 1, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+	invoke_param[1].u.memref.size = 1;
+	invoke_param[1].u.memref.shm = shm;
+
+	memcpy(invoke_param[1].u.memref.shm->kaddr, T_KEY, 1);
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx_hdcprx, &arg_I, invoke_param);
+
+	return 0;
+}
+
+void CA_hdcp1p4_load(void)
+{
+	if (TEE2p1_Flag == 0)
+		return;
+
+	HDCP1p4_ta_init();
+	CA_hdcp1p4_RX_SET_KEY();
+	HDCP1p4_ta_deinit();
+
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiEDID.c b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiEDID.c
new file mode 100644
index 00000000..db71862
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiEDID.c
@@ -0,0 +1,303 @@
+/*
+ * hdmiEDID.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/string.h>
+#include <linux/types.h>
+
+#include "v4l2_hdmi_dev.h"
+#include "mipi_wrapper.h"
+#include "hdmiEDID.h"
+#include "hdmirx_reg.h"
+#include "hdmiInternal.h"
+
+/*=================== extern Variable/Function ===================*/
+extern MIPI_TOP_INFO mipi_top;
+
+extern void Hdmi_SetHPD(char high);
+
+#ifdef CONFIG_RTK_HDMITX
+extern int hdmitx_switch_get_state(void);
+#endif
+/*======================================================*/
+
+static void hotplug_pulses_work_fun(struct work_struct *work);
+static DECLARE_WORK(hotplug_pulses_work, hotplug_pulses_work_fun);
+
+HDMIRX_DTS_EDID_TBL_T hdmirx_edid;
+HDMIRX_DTS_EDID_TBL_T hdmirx_edid2p0;
+static int rx_edid_version = 0;/* 0:HDMI 1.4 , 1:HDMI 2.0 */
+
+static void hotplug_pulses_work_fun(struct work_struct *work)
+{
+	HDMIRX_INFO("Set hotplug pulse");
+
+	Hdmi_SetHPD(0);
+	msleep(1000);
+	Hdmi_SetHPD(1);
+}
+
+void HdmiRx_hotplug_pulses(void)
+{
+	if (!mipi_top.hdmi_rx_init)
+		return;
+
+	schedule_work(&hotplug_pulses_work);
+}
+
+char EDIDIsValid(unsigned char *EDID)
+{
+	if (EDID == NULL)
+		return false;
+
+	if ((EDID[0] != 0x0) || (EDID[1] != 0xff) || (EDID[6] != 0xff) || (EDID[7] != 0x0))
+		return false;
+
+	return true;
+}
+
+
+unsigned char drvif_EDIDLoad(unsigned char *EDID, int len)
+{
+	int i;
+
+	if (EDIDIsValid(EDID) == false)
+		return false;
+
+	/* Disable DDC func, write EDID data to sram */
+	hdmi_rx_reg_mask32(DDC1_EDID_CR, ~DDC1_EDID_CR_edid_en_mask, DDC1_EDID_CR_edid_en(0), HDMI_RX_DDC);
+
+
+	for (i = 0; i < len; i++)  {
+		/* total 0 ~ 127 */
+		hdmi_rx_reg_write32(DDC1_DDC_SIR, i, HDMI_RX_DDC);
+		hdmi_rx_reg_write32(DDC1_DDC_SAP, EDID[i], HDMI_RX_DDC);
+	}
+
+	/* Set to No Debounce */
+	hdmi_rx_reg_write32(DDC1_I2C_CR, 0x00, HDMI_RX_DDC);
+
+	/* Enable DDC func */
+	hdmi_rx_reg_mask32(DDC1_EDID_CR, ~DDC1_EDID_CR_edid_en_mask, DDC1_EDID_CR_edid_en(1), HDMI_RX_DDC);
+
+	return true;
+}
+
+void drvif_EDID_DDC12_AUTO_Enable(char enable)
+{
+	hdmi_rx_reg_mask32(DDC1_EDID_CR, ~(DDC1_EDID_CR_DDC1_force_mask | DDC1_EDID_CR_ddc2b_force_mask),
+				(DDC1_EDID_CR_DDC1_force(0) | DDC1_EDID_CR_ddc2b_force((enable)?0:1)), HDMI_RX_DDC);
+
+}
+
+unsigned char HdmiRx_change_edid_physical_addr(unsigned char byteMSB, unsigned char byteLSB)
+{
+	unsigned char ret = false;
+	unsigned char block_tag = 0;
+	unsigned char block_size;
+	unsigned char offset;
+	unsigned char offset_max;
+	unsigned int i;
+	unsigned int sum = 0;
+	HDMIRX_DTS_EDID_TBL_T *EDID_table;
+
+	if ((rx_edid_version == 1) && (hdmirx_edid2p0.valid == true))
+		EDID_table = &hdmirx_edid2p0;
+	else
+		EDID_table = &hdmirx_edid;
+
+	offset = 0x84;/* First data block */
+	offset_max = 0x80+EDID_table->EDID[0x82];
+
+	while (offset < offset_max) {
+		block_tag = EDID_table->EDID[offset] >> 4;
+		block_size = EDID_table->EDID[offset] & 0xF;
+
+		if (block_tag == 6) {
+			/* Physical Address offset */
+			offset += 4;
+			break;
+		}
+
+		/* Next block */
+		offset = offset + block_size + 1;
+	}
+
+	/* Make sure found VSDB */
+	if (block_tag != 6) {
+		HDMIRX_ERROR(" Change EDID physical addr fail, couldn't find vendor specific data block\n");
+		return false;
+	}
+
+	/* Repeater PA Increment */
+	if ((byteMSB&0x0F) == 0x0) {
+		byteMSB = byteMSB | 0x1;
+	} else if ((byteLSB&0xF0) == 0x0) {
+		byteLSB = byteLSB | 0x10;
+	} else if ((byteLSB&0x0F) == 0) {
+		byteLSB = byteLSB | 0x1;
+	} else {
+		byteMSB = 0xFF;
+		byteLSB = 0xFF;
+	}
+
+	HDMIRX_INFO("Set Physical Addr = 0x%02x%02x", byteMSB, byteLSB);
+	EDID_table->EDID[offset] = byteMSB;
+	EDID_table->EDID[offset+1] = byteLSB;
+
+	/* Calculate and set checksum */
+	for (i = 0x80; i < 0xFF; i++)
+		sum += EDID_table->EDID[i];
+	EDID_table->EDID[0xFF] = (0x100-(sum&0xFF))&0xFF;
+
+	/* Reload EDID table */
+	ret = drvif_EDIDLoad(EDID_table->EDID, 256);
+
+	return ret;
+}
+
+void HdmiRx_save_tx_physical_addr(unsigned char byteMSB, unsigned char byteLSB)
+{
+	hdmirx_edid.tx_phy_addr[0] = byteMSB;
+	hdmirx_edid.tx_phy_addr[1] = byteLSB;
+
+	hdmirx_edid2p0.tx_phy_addr[0] = byteMSB;
+	hdmirx_edid2p0.tx_phy_addr[1] = byteLSB;
+
+	if (mipi_top.hdmi_rx_init) {
+		if ((byteMSB != 0xEE) || (byteLSB != 0xEE))
+			HdmiRx_change_edid_physical_addr(byteMSB, byteLSB);
+
+		schedule_work(&hotplug_pulses_work);
+	}
+}
+
+
+void HdmiRx_Save_DTS_EDID_Table(HDMIRX_DTS_EDID_TBL_T *dts_edid)
+{
+	memcpy(hdmirx_edid.EDID, dts_edid->EDID, 256);
+	hdmirx_edid.tx_phy_addr[0] = 0xEE;
+	hdmirx_edid.tx_phy_addr[1] = 0xEE;
+	hdmirx_edid.valid = true;
+}
+
+void HdmiRx_Save_DTS_EDID2p0_Table(HDMIRX_DTS_EDID_TBL_T *dts_edid)
+{
+	memcpy(hdmirx_edid2p0.EDID, dts_edid->EDID, 256);
+	hdmirx_edid2p0.tx_phy_addr[0] = 0xEE;
+	hdmirx_edid2p0.tx_phy_addr[1] = 0xEE;
+	hdmirx_edid2p0.valid = true;
+}
+
+void HdmiRx_SetEDID_version(int version)
+{
+	int old_version;
+	HDMIRX_DTS_EDID_TBL_T *EDID_table;
+
+	old_version = rx_edid_version;
+
+	if (version == 1) {
+		if (hdmirx_edid2p0.valid == true) {
+			rx_edid_version = 1;
+			EDID_table = &hdmirx_edid2p0;
+		} else {
+			HDMIRX_ERROR("Set EDID version fail, 2.0 EDID table not exists");
+			rx_edid_version = 0;
+			EDID_table = &hdmirx_edid;
+		}
+	} else {
+		rx_edid_version = 0;
+		EDID_table = &hdmirx_edid;
+	}
+
+	if (old_version != rx_edid_version) {
+		HDMIRX_INFO("Change EDID to %s version", rx_edid_version?"2.0":"1.4");
+
+		if (mipi_top.hdmi_rx_init) {
+			Hdmi_SetHPD(0);
+#if HDMI2p0
+			lib_hdmi2p0_reset_scdc();
+			lib_hdmi2p0_scramble_enable(0);
+#endif
+		}
+
+		if ((EDID_table->tx_phy_addr[0] != 0xEE) ||
+			(EDID_table->tx_phy_addr[1] != 0xEE))
+			HdmiRx_change_edid_physical_addr(EDID_table->tx_phy_addr[0], EDID_table->tx_phy_addr[1]);
+		else
+			drvif_EDIDLoad(EDID_table->EDID, 256);
+
+		HDMI_DELAYMS(1000);
+		if (mipi_top.hdmi_rx_init)
+			Hdmi_SetHPD(1);
+	}
+
+}
+
+void HdmiRx_ChangeCurrentEDID(unsigned char *edid)
+{
+	/* HDMIRX_INFO("HdmiRx_ChangeCurrentEDID"); */
+
+	if (rx_edid_version) {
+		memcpy(hdmirx_edid.EDID, edid, 256);
+		hdmirx_edid.valid = true;
+		HdmiRx_SetEDID_version(0);
+	} else {
+		memcpy(hdmirx_edid2p0.EDID, edid, 256);
+		hdmirx_edid2p0.valid = true;
+		HdmiRx_SetEDID_version(1);
+	}
+}
+
+int HdmiRx_GetEDID_version(void)
+{
+	return rx_edid_version;
+}
+
+unsigned char HdmiRx_EnableEDID(void)
+{
+	int i;
+	unsigned char ret = false;
+	HDMIRX_DTS_EDID_TBL_T *EDID_table;
+
+	if ((rx_edid_version == 1) && (hdmirx_edid2p0.valid == true))
+		EDID_table = &hdmirx_edid2p0;
+	else
+		EDID_table = &hdmirx_edid;
+
+	if (EDID_table->valid) {
+/* HDMI 1.4 CTS 9-5, Physical Address Handling */
+#ifdef CONFIG_RTK_HDMITX
+		/* Wait HDMI TX */
+		if (hdmitx_switch_get_state() == 1) {
+			for (i = 0; i < 5; i++) {
+				if ((EDID_table->tx_phy_addr[0] == 0xEE) &&
+					(EDID_table->tx_phy_addr[1] == 0xEE))
+					HDMI_DELAYMS(500);
+				else
+					break;
+			}
+		}
+
+		if ((EDID_table->tx_phy_addr[0] != 0xEE) ||
+			(EDID_table->tx_phy_addr[1] != 0xEE))
+			ret = HdmiRx_change_edid_physical_addr(EDID_table->tx_phy_addr[0], EDID_table->tx_phy_addr[1]);
+		else
+#endif
+		ret = drvif_EDIDLoad(EDID_table->EDID, 256);
+		drvif_EDID_DDC12_AUTO_Enable(0);
+	}
+
+	if (!ret)
+		HDMIRX_ERROR("Enable EDID fail, EDID table not exists or invalid");
+
+	return ret;
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiEDID.h b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiEDID.h
new file mode 100644
index 00000000..8c8f7c9
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiEDID.h
@@ -0,0 +1,28 @@
+/*
+ * hdmiEDID.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDMIEDID_H_
+#define _HDMIEDID_H_
+
+
+typedef struct {
+	unsigned char EDID[256];
+	unsigned char tx_phy_addr[2];/* TX Physical Address */
+	unsigned char valid;
+} HDMIRX_DTS_EDID_TBL_T;
+
+void HdmiRx_Save_DTS_EDID_Table(HDMIRX_DTS_EDID_TBL_T *dts_edid);
+void HdmiRx_Save_DTS_EDID2p0_Table(HDMIRX_DTS_EDID_TBL_T *dts_edid);
+void HdmiRx_SetEDID_version(int version);
+int HdmiRx_GetEDID_version(void);
+void HdmiRx_ChangeCurrentEDID(unsigned char *edid);
+unsigned char HdmiRx_EnableEDID(void);
+#endif/* _HDMIEDID_H_ */
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiHdmi.c b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiHdmi.c
new file mode 100644
index 00000000..d32d27f
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiHdmi.c
@@ -0,0 +1,4567 @@
+/*
+ * hdmiHdmi.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/gpio.h>
+
+#include "hdmirx_wrapper.h"
+#include "hdmiInternal.h"
+
+/*
+ * Marco or Definitions
+ */
+#define CLK_STABLE_CNT		3
+#define TMDS_CLOCK_TOLERANCE()	MAX(hdmi_rx.timing_t.tmds_clk_b>>7, 5) /* 6G tolerance should be larger */
+
+#define NO_DRM_INFO_MAX		6
+#define NO_AVI_INFO_MAX		6
+#define NO_VSI_INFO_MAX		6
+#define NO_SPD_INFO_MAX		25 /* 40ms * 25 = 1000 ms */
+#define NO_SPD_CLEAR_PACKET	0
+#define NO_AUDIO_INFO_MAX	6
+#define HDCP_RESET_CNT		30 /* The counter for keeping HDCP 1.4 or 2.2 in no signal state, if timeout, turn on both 1.4 & 2.2*/ 
+
+/*
+ * Const Declarations
+ */
+const VIDEO_DPLL_RATIO_T dpll_ratio[] = {
+	{15, 15, 1, 1},	/* 24 bits */
+	{12, 15, 4, 5},	/* 30 bits */
+	{10, 15, 2, 3},	/* 36 bits */
+	{15, 30, 1, 2},	/* 48 bits */
+};
+
+const VIDEO_DPLL_FIX_T video_pll_main_param[]= {
+	{30, 0, 0b010, 0b100},
+	{62, 3, 0b010, 0b111},
+	{30, 1, 0b010, 0b100},
+	{ 6, 0, 0b000, 0b100},
+	{14, 3, 0b001, 0b101},	
+	{ 6, 1, 0b000, 0b100},
+	{ 6, 2, 0b000, 0b100},
+	{ 6, 3, 0b000, 0b100},
+	{ 6, 4, 0b000, 0b100},
+	{ 6, 6, 0b000, 0b100},
+	{ 2, 3, 0b000, 0b100},
+	{ 2, 4, 0b000, 0b100},
+};
+
+const VIDEO_DPLL_RANGE_T video_pll_others_param[]= {
+	{ 6, 10, 0b000, 0b100},
+	{11, 18, 0b000, 0b111},
+	{19, 30, 0b001, 0b110},
+	{31, 48, 0b010, 0b110},	
+};
+
+const HDMI_AUDIO_PLL_PARAM_T hdmi_audiopll_param[] = {
+	{  32000,  2,   20,  2,  8,  1,  0x1D, 0xDC,  "32K"},
+	{  44100,  2,   20,  2,  6,  1,  0xFC, 0x68,  "44.1K"},
+	{  48000,  2,   22,  2,  6,  1,  0x07, 0x40,  "48K"},
+	{  88200,  2,   20,  1,  6,  1,  0xFE, 0x7A,  "88.2K"},
+	{  96000,  2,   22,  1,  6,  1,  0x07, 0x40,  "96K"},
+	{ 176400,  2,   20,  1,  6,  0,  0xFE, 0x7A,  "176.4K"},
+	{ 192000,  2,   22,  1,  6,  0,  0x07, 0x40,  "192K"},
+#if AUDIO_OVER_192K
+	{ 352800,  2,   22,  1,  6,  0,  0x07, 0x40,  "352.8K"},
+	{ 705600,  2,   22,  1,  6,  0,  0x07, 0x40,  "705.6K"},
+	{1411200,  2,   22,  1,  6,  0,  0x07, 0x40,  "1411.2K"},
+	{1536000,  2,   22,  1,  6,  0,  0x07, 0x40,  "1536K"},
+#endif
+};
+
+const unsigned int AUDIO_CHANNEL_STATUS[] = {
+	44100,
+	0, /* 0 indicate standard no support */
+	48000,
+	32000,
+	22000,
+	0,
+	24000,
+	0,
+	88200,
+	0,
+	96000,
+	0,
+	176400,
+	0,
+	192000,
+	0,
+};
+
+
+const char *colormetry_name[]  = {
+	"HDMI_COLORIMETRY_NOSPECIFIED",
+	"HDMI_COLORIMETRY_601",
+	"HDMI_COLORIMETRY_709",
+	"HDMI_COLORIMETRY_XYYCC601",
+	"HDMI_COLORIMETRY_XYYCC709",
+	"HDMI_COLORIMETRY_SYCC601",
+	"HDMI_COLORIMETRY_ADOBE_YCC601",
+	"HDMI_COLORIMETRY_ADOBE_RGB",
+};
+
+const char *depth_name[] = {
+
+	"HDMI_COLOR_DEPTH_8B",
+	"HDMI_COLOR_DEPTH_10B",
+	"HDMI_COLOR_DEPTH_12B",
+	"HDMI_COLOR_DEPTH_16B",
+
+};
+
+const char *colorspace_name[] = {
+	"COLOR_RGB",
+	"COLOR_YUV422",
+	"COLOR_YUV444",
+	"COLOR_YUV420",
+	"COLOR_UNKNOW"
+};
+
+const char *hdmi_3d_name[] = {
+	"HDMI3D_FRAME_PACKING",
+	"HDMI3D_FIELD_ALTERNATIVE",
+	"HDMI3D_LINE_ALTERNATIVE",
+	"HDMI3D_SIDE_BY_SIDE_FULL",
+	"HDMI3D_L_DEPTH",
+
+	"HDMI3D_L_DEPTH_GPX",
+	"HDMI3D_TOP_AND_BOTTOM",
+	"HDMI3D_RSV0",
+	"HDMI3D_SIDE_BY_SIDE_HALF",
+	"HDMI3D_LINE_BY_LINE",
+
+	"HDMI3D_VERTICAL_STRIPE",
+	"HDMI3D_CHECKER_BOARD",
+	"HDMI3D_REALID",
+	"HDMI3D_SENSIO",
+	"HDMI3D_RSV1",
+
+	"HDMI3D_2D_ONLY",
+};
+
+
+/*
+ * Variables
+ */
+HDMI_PORT_INFO_T	hdmi_rx;
+
+static unsigned int bNeedDebBeforeDisp = 0;
+static unsigned int DispDebCnt = 0;
+static unsigned int DispDebCondition = 0;
+
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+unsigned char hdmi_toggle_hpd_z0_flag = 0;
+HDMI_DC_ON_STATE_E hdmi_dc_on_delay_state = HDMI_DC_ON_NONE;
+#endif
+
+#if HDMI_STR_TOGGLE_HPD_ENABLE
+HDMI_STR_HPD_TOGGLE_STATE_E hdmi_str_toggle_hpd_state = HDMI_STR_HPD_TOGGLE_NONE;
+#endif
+
+#if HDMI_DISPLAY_DELAY_ENABLE
+unsigned char hdmi_delay_display_enable = _DISABLE;
+HDMI_DISPLAY_DELAY_STATE_STATE_E hdmi_delay_display_state = HDMI_DISPLAY_DELAY_NONE;
+#endif
+
+#if 1
+HDMI_SPECIFIC_DEVICE_E hdmi_specific_device = HDMI_SPECIFIC_DEVICE_NONE;
+#endif
+
+
+/*
+ * Funtion Declarations
+ */
+
+
+void hdmi_fix_green_line(void);
+
+
+unsigned char hdmi_update_vsi(void);
+unsigned char hdmi_update_avi(void);
+unsigned char hdmi_update_spd(void);
+unsigned char hdmi_update_audiopkt(void);
+unsigned char hdmi_update_drm(void);
+unsigned char hdmi_update_rsv0_packet(unsigned char len, unsigned char *buf);
+unsigned char hdmi_update_rsv1_packet(unsigned char len, unsigned char *buf);
+unsigned char hdmi_update_rsv2_packet(unsigned char len, unsigned char *buf);
+unsigned char hdmi_update_rsv3_packet(unsigned char len, unsigned char *buf);
+unsigned char hdmi_check_spd_name(unsigned char *vendor_name);
+unsigned char hdmi_check_spd_prod(unsigned char *prod_desc);
+
+unsigned char hdmi_compatibility_check(void);
+unsigned char hdmi_check_avi_colorimetry_info(unsigned char ucInit);
+unsigned char hdmi_no_SPD_packetInfo(void);
+unsigned char hdmi_check_deb_condition_beforeDisp(unsigned char ucInit);
+unsigned char hdmi_check_hdcp_condition(unsigned char ucInit);
+
+
+void hdmi_init(void)
+{
+	HDMIRX_INFO("%s\n", __func__);
+
+	lib_hdmi_power(0);
+
+	hdmi_check_hdcp_condition(TRUE);
+
+	lib_hdmi_phy_init();
+
+	hdmi_port_var_init();
+
+	lib_hdmi_power(1);
+
+	lib_hdmi_tmds_init();
+
+	lib_hdmi_mac_init();
+
+	hdmi_audio_close();
+
+	rxphy_init_struct();
+
+	rxphy_isr_set(1);
+
+	lib_hdmi_gcp_ackg_header_parsing_mode();
+	lib_hdmi_valid_format_condition();
+	lib_hdmi_misc_variable_initial();
+
+	Hdmi_HdcpInit();
+
+	HDMIRX_INFO("%s done\n", __func__);
+
+}
+
+void hdmi_release_source(void)
+{
+	rxphy_isr_set(0);
+	lib_hdmi_power(0);
+
+	hdmi_disconnect_source();
+}
+
+void hdmi_disconnect_source(void)
+{
+	/* Keep PHY_ISR in active, keep power on */
+	lib_hdmi_video_output(0);/* Blanking screen in step 1 */
+	hdmi_port_var_init();
+
+	lib_hdmi_video_output(0);/* Close again, avoid re-open in detect_mode */
+	hdmi_audio_close();
+
+#ifdef HDMI_VIDEO_WD_ENABLE
+	hdmi_watchdog_apply(_DISABLE, HDMI_WD_ALL_COND);
+#endif
+}
+
+void hdmi_port_select(void)
+{
+	/* Reset all mac functions */
+	hdmi_rx_reg_mask32(HDMI_PORT_SWITCH,
+		~HDMI_PORT_SWITCH_port_sel_mask,
+		HDMI_PORT_SWITCH_port_sel(0), HDMI_RX_MAC);
+
+	lib_hdmi_video_output(0);
+}
+
+void hdmi_port_var_init(void)
+{
+	SET_H_VIDEO_FSM(MAIN_FSM_HDMI_WAIT_SYNC);
+	SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+
+	SET_H_INTERLACE(0);
+	SET_H_MODE(MODE_HDMI);
+	SET_H_COLOR_DEPTH(HDMI_COLOR_DEPTH_8B);
+	SET_H_COLOR_SPACE(COLOR_RGB);
+
+	SET_H_3DFORMAT(HDMI3D_2D_ONLY);
+
+	hdmi_audio_var_init();
+}
+
+static const char * const str_mode[] = {"DVI", "HDMI"};
+static const char * const str_interlace[] = {"Prog", "Int"};
+static const char * const str_color[] = {"RGB", "YUV422", "YUV444", "YUV420"};
+static const char * const str_depth[] = {"8Bit", "10Bit", "12Bit", "16Bit"};
+unsigned char hdmi_detect_mode(void)
+{
+	unsigned char ret_val;
+	unsigned char yuv_fmt;
+
+	ret_val = _MODE_NOSIGNAL;
+
+	if (GET_H_VIDEO_FSM() > MAIN_FSM_HDMI_SETUP_VEDIO_PLL) {
+		if (hdmi_check_condition_change())
+			SET_H_VIDEO_FSM(MAIN_FSM_HDMI_WAIT_SYNC);
+	}
+
+	switch (GET_H_VIDEO_FSM()) {
+	case MAIN_FSM_HDMI_WAIT_SYNC:
+		if (hdmi_wait_sync())
+			SET_H_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+		else
+			goto exit;
+		/* break; */
+
+	case MAIN_FSM_HDMI_SETUP_VEDIO_PLL:
+		if (hdmi_setup_video_pll()) {
+			hdmi_check_deb_condition_beforeDisp(TRUE);
+			SET_H_VIDEO_FSM(MAIN_FSM_HDMI_MEASURE);
+		} else {
+			goto exit;
+		}
+		/* break; */
+
+	case MAIN_FSM_HDMI_MEASURE:
+		if (hdmi_measure()) {
+			SET_H_VIDEO_FSM(MAIN_FSM_HDMI_DISPLAY_ON);
+		} else {
+			SET_H_VIDEO_FSM(MAIN_FSM_HDMI_WAIT_SYNC);
+			ret_val = _MODE_DETECT;
+			goto exit;
+		}
+		/* break; */
+
+	case MAIN_FSM_HDMI_DISPLAY_ON:
+		if (hdmi_display_on()) {
+
+			if (lib_hdmi_get_avmute() && !lib_hdmi_get_bch_2bit_error()) {
+				HDMI_PRINTF("[WARNING] AVMUTE...\n");
+				SET_H_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+				goto exit;
+			}
+
+			if (hdmi_check_condition_change()) {
+				SET_H_VIDEO_FSM(MAIN_FSM_HDMI_WAIT_SYNC);
+				goto exit;
+			}
+
+			if (!hdmi_compatibility_check()) {
+				SET_H_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+				goto exit;
+			}
+
+			lib_hdmi_char_err_rst(0);
+			HDMI_PRINTF("FSM_HDMI_DISPLAY_ON OK\n");
+			SET_H_VIDEO_FSM(MAIN_FSM_HDMI_VIDEO_READY);
+			ret_val = _MODE_SUCCESS;
+
+#if HDMI2p0
+			/* Workaround for 6G hw bug */
+			hdmi2p0_align_flush();
+#endif
+			HDMIRX_INFO("FSM_HDMI_DISPLAY_ON  mode(%s) I/P(%s) color(%s) depth(%s)",
+				str_mode[GET_H_MODE()&0x1], str_interlace[GET_H_INTERLACE()&0x1],
+				str_color[GET_H_COLOR_SPACE()&0x3], str_depth[GET_H_COLOR_DEPTH()&0x3]);
+
+			/* Enable rx wrapper detect */
+			yuv_fmt = hdmirx_wrapper_convert_color_fmt(GET_H_COLOR_SPACE());
+			set_hdmirx_wrapper_control_0(-1, -1, -1, -1, yuv_fmt, -1);
+			hdmirx_state.detect_done = 1;
+			set_hdmirx_wrapper_interrupt_en(0, 0, 1);
+		} else {
+			SET_H_VIDEO_FSM(MAIN_FSM_HDMI_WAIT_SYNC);
+			ret_val = _MODE_DETECT;
+		}
+		break;
+
+	case MAIN_FSM_HDMI_VIDEO_READY:
+		if (hdmi_video_ready()) {
+			ret_val = _MODE_SUCCESS;
+		} else {
+			SET_H_VIDEO_FSM(MAIN_FSM_HDMI_WAIT_SYNC);
+			ret_val = _MODE_NOSIGNAL;
+		}
+		break;
+
+	default:
+		break;
+	}
+
+exit:
+	return ret_val;
+}
+
+unsigned char hdmi_check_condition_change(void)
+{
+	unsigned int phy_clk;
+
+	if (!rxphy_is_clk_stable()) {
+		return TRUE;
+	}
+
+	phy_clk = rxphy_get_clk();
+
+	if (phy_clk < VALID_MIN_CLOCK) {
+		HDMI_PRINTF("invalid clock\n");
+		return TRUE;
+	}
+
+	if (HDMI_ABS(phy_clk, hdmi_rx.timing_t.tmds_clk_b) > TMDS_CLOCK_TOLERANCE()) {
+		HDMI_PRINTF("clock change\n");
+		return TRUE;
+	}
+
+	if (GET_H_MODE() == MODE_HDMI) {
+		if (GET_H_COLOR_SPACE() != hdmi_get_colorspace_reg()) {
+			HDMI_PRINTF("colorspace chg from %d to %d\n",
+				GET_H_COLOR_SPACE(), hdmi_get_colorspace_reg());
+			return TRUE;
+		}
+
+		if (GET_H_COLOR_DEPTH() != lib_hdmi_get_color_depth()) {
+			HDMI_PRINTF("color depth chage\n");
+			return TRUE;
+		}
+
+		hdmi_audio_detect();
+	}
+
+	if (GET_H_MODE() != hdmi_get_hdmi_mode_reg()) {
+		HDMI_PRINTF("HDMI/DVI chg from %d to %d\n", GET_H_MODE(), (!GET_H_MODE()));
+		return TRUE;
+	}
+
+	hdmi_update_infoframe();
+
+	return FALSE;
+}
+
+unsigned char hdmi_wait_sync(void)
+{
+	unsigned int curr_clk;
+
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	lib_hdmi_toggle_hpd_z0_check(FALSE);
+#endif
+
+	curr_clk = rxphy_get_clk();
+	if ((curr_clk < VALID_MIN_CLOCK) ||
+		(HDMI_ABS(hdmi_rx.timing_t.tmds_clk_b, curr_clk) > TMDS_CLOCK_TOLERANCE())) {
+		/* Set false if clock is invalid or changed */
+		hdmi_rx.timing_t.tmds_clk_b = curr_clk;
+		hdmi_rx.timing_t.tmds_clk_stable_cnt = 0;
+		if (hdmi_rx.timing_t.is_interlace) {
+			lib_hdmi_clear_interlace_reg();
+			hdmi_rx.timing_t.is_interlace = 0;
+		}
+		return FALSE;
+	}
+
+	if (hdmi_rx.timing_t.tmds_clk_stable_cnt < CLK_STABLE_CNT) {
+		/* Set false if clock is unstable */
+		hdmi_rx.timing_t.tmds_clk_stable_cnt++;
+		return FALSE;
+	}
+	hdmi_rx.timing_t.tmds_clk_b = curr_clk;
+
+	if (!rxphy_get_setphy_done()) {
+		/* HDMI_PRINTF("Wait for set_phy(p%d)\n", port); */
+		return FALSE;
+	}
+
+	hdmi_open_err_detect();
+	lib_hdmi_set_repeat_auto();
+	lib_hdmi_set_colorspace_auto();
+
+	lib_hdmi_bch_error_clr();
+
+	hdmi_audio_var_init();
+	hdmi_reset_all_infoframe();
+	lib_hdmi_audio_set_hbr_manual_mode(0, 0);
+	lib_hdmi_audio_clear_hdr_status();
+
+#if HDMI_AVI_INFO_COLORIMETRY_ENABLE
+	hdmi_check_avi_colorimetry_info(TRUE);
+#endif
+
+	return TRUE;
+}
+
+unsigned char hdmi_setup_video_pll(void)
+{
+	HDMI_PRINTF("FSM_HDMI_SETUP_VEDIO_PLL\n");
+
+	hdmi_port_select();
+
+#ifdef HDMI_VIDEO_WD_ENABLE
+	/* Enable Video and Audio, to prevent Tx HDMI have no audio, the watch dog not work */
+	hdmi_watchdog_apply(_DISABLE, HDMI_WD_ALL_COND);
+#endif
+
+	SET_H_COLOR_DEPTH((HDMI_COLOR_DEPTH_T)lib_hdmi_get_color_depth());
+	SET_H_MODE((HDMI_DVI_MODE_T)hdmi_get_hdmi_mode_reg());
+	SET_H_PIXEL_REPEAT(lib_hdmi_get_pixelrepeat());
+
+	if (GET_H_MODE() == MODE_DVI) {
+		lib_hdmi_set_repeat_manual(0);
+		lib_hdmi_set_colorspace_manual(0);
+	} else {
+		lib_hdmi_set_repeat_auto();
+		lib_hdmi_set_colorspace_auto();
+	}
+
+	SET_H_COLOR_SPACE((HDMI_COLOR_SPACE_T)hdmi_get_colorspace_reg());
+	SET_H_INTERLACE(lib_hdmi_get_is_interlace(HDMI_MS_DIRECT));
+	lib_hdmi_clear_interlace_reg();
+
+	if (!lib_hdmi_set_video_pll(hdmi_rx.timing_t.tmds_clk_b,
+		hdmi_rx.timing_t.colordepth,
+		hdmi_rx.timing_t.is_interlace,
+		hdmi_rx.timing_t.colorspace==COLOR_YUV420))
+		return FALSE;
+
+	return TRUE;
+}
+
+unsigned char hdmi_measure(void)
+{
+	HDMI_PRINTF("FSM_HDMI_MEASURE\n");
+
+	lib_hdmi_meas_select_port();
+	lib_hdmi_video_output(1);
+	lib_hdmi_crc_check();
+
+	/* TODO: Check timing */
+	if (0) {
+		hdmi_rx.meas_retry_cnt++;
+		if (hdmi_rx.meas_retry_cnt > MEAS_RETRY_LIMIT) {
+			rxphy_reset_setphy_proc();
+
+#if HDMI2p0
+			/*
+			 * To prevent Tx unstable, pixel clock unstable, but large than VALID_MIN_CLOCK
+			 * it will let toggle function NG
+			 * pixel clock stable + measure NG
+			 */
+			hdmi2p0_inc_scdc_toggle();
+#endif
+
+#if HDMI_STR_TOGGLE_HPD_ENABLE
+			if (lib_hdmi_get_str_toggle_hpd_state() == HDMI_STR_HPD_TOGGLE_READY) {
+				Hdmi_SetHPD(0);
+				HDMI_DELAYMS(HDMI_STR_TOGGLE_HPD_MS);
+				HDMI_PRINTF("STR on HPD Toggle\n");
+				Hdmi_SetHPD(1);
+				lib_hdmi_set_str_toggle_hpd_state(HDMI_STR_HPD_TOGGLE_NONE);
+			}
+#endif
+		}
+		return FALSE;
+	}
+
+	hdmi_check_crc_0();
+
+	return TRUE;
+}
+
+unsigned char hdmi_display_on(void)
+{
+	if (GET_H_COLOR_SPACE() != hdmi_get_colorspace_reg()) {
+		HDMI_PRINTF("D-CS chg from %d to %d\n",
+			GET_H_COLOR_SPACE(), hdmi_get_colorspace_reg());
+		return FALSE;
+	}
+	if (GET_H_COLOR_DEPTH() != lib_hdmi_get_color_depth()) {
+		HDMI_PRINTF("D-CD chg from %d to %d\n",
+			GET_H_COLOR_DEPTH(), lib_hdmi_get_color_depth());
+		return FALSE;
+	}
+	if (GET_H_PIXEL_REPEAT() != lib_hdmi_get_pixelrepeat()) {
+		HDMI_PRINTF("D-PR chg from %d to %d\n",
+			GET_H_PIXEL_REPEAT(), lib_hdmi_get_pixelrepeat());
+		return FALSE;
+	}
+	if (GET_H_INTERLACE() != lib_hdmi_get_is_interlace(HDMI_MS_DIRECT)) {
+		HDMI_PRINTF("D-IP chg from %d to %d\n",
+			GET_H_INTERLACE(), (!GET_H_INTERLACE()));
+		return FALSE;
+	}
+
+	hdmi_fix_green_line();
+
+#ifdef HDMI_VIDEO_WD_ENABLE
+	hdmi_watchdog_apply(_ENABLE, (HDMI_WD_VIDEO_COND | HDMI_WD_AUDIO_COND));
+#endif
+
+	if (GET_H_MODE()) {
+		SET_H_VIDEO_FORMAT((HDMI_HVF_E)hdmi_get_video_format_reg());
+		SET_H_3DFORMAT((HDMI_3D_T)hdmi_get_3d_structure_reg());
+	}
+
+	HDMI_PRINTF("bHDMIColorSpace = %s\n",
+		GET_H_COLOR_SPACE() < (sizeof(colorspace_name)/4)  ? colorspace_name[GET_H_COLOR_SPACE()] : "UNDEFINED");
+	HDMI_PRINTF("IsInterlaced = %d\n", GET_H_INTERLACE());
+	HDMI_PRINTF("bIsHDMIDVI = %d\n", GET_H_MODE());
+	HDMI_PRINTF("PixelRepeat = %d\n", GET_H_PIXEL_REPEAT());
+	HDMI_PRINTF("ColorDepth = %s\n", GET_H_COLOR_DEPTH() < (sizeof(depth_name)/4)  ? depth_name[GET_H_COLOR_DEPTH()] : "UNDEFINED");
+	HDMI_PRINTF("ColorMetry = %s\n",
+		hdmi_get_colorimetry() < (sizeof(colormetry_name)/4)  ? colormetry_name[hdmi_get_colorimetry()]: "UNDEFINED");
+	HDMI_PRINTF("3D Format  = %s\n", GET_H_3DFORMAT() < (sizeof(hdmi_3d_name)/4) ? hdmi_3d_name[GET_H_3DFORMAT()] : "UNDEFINED");
+
+	return TRUE;
+}
+
+unsigned char hdmi_video_ready(void)
+{
+	/* To prevent picture have short time garbage before display */
+	if (lib_hdmi_get_avmute() && !lib_hdmi_get_bch_2bit_error()) {
+		HDMI_PRINTF("[WARNING] AVMUTE 2...\n");
+		SET_H_VIDEO_FSM(MAIN_FSM_HDMI_WAIT_SYNC);
+		return FALSE;
+	}
+
+	return TRUE;
+}
+
+
+unsigned char hdmi_check_mode(void)
+{
+	if (lib_hdmi_get_avmute() && (lib_hdmi_is_wdm_enable() || !lib_hdmi_get_bch_2bit_error())) {
+		lib_hdmi_video_output(0);
+		lib_hdmi_audio_output(0);
+		HDMI_PRINTF("check_mode: [WARNING] AVMUTE 3...\n");
+		return FALSE;
+	}
+
+	if (GET_H_VIDEO_FSM() != MAIN_FSM_HDMI_VIDEO_READY) {
+		HDMI_PRINTF("check_mode: changed_1\n");
+		return FALSE;
+	}
+
+	if (hdmi_check_condition_change()) {
+		lib_hdmi_video_output(0);
+		lib_hdmi_audio_output(0);
+		HDMI_PRINTF("check_mode: changed_2\n");
+		return FALSE;
+	}
+
+#if HDMI_INT_PRO_CHG_FLAG_ENABLE
+	if (lib_hdmi_get_is_interlace_change() == TRUE) {
+		HDMI_PRINTF("interlace chg\n");
+		return FALSE;
+	}
+#else //#if HDMI_INT_PRO_CHG_FLAG_ENABLE
+	if (GET_H_INTERLACE() != hdmi_get_interlace_conti_mode()) {
+		HDMI_PRINTF("check_mode: interlace chg from %d to %d\n", GET_H_INTERLACE(), (!GET_H_INTERLACE()));
+		return FALSE;
+	}
+#endif //#if HDMI_INT_PRO_CHG_FLAG_ENABLE
+
+
+#if 1/* BITERR_PATCH */
+	if (hdmi_rx.timing_t.tmds_clk_b > 2900) {
+		/* > 3G */
+		if (hdmi_char_err_detection()) {
+			if (hdmi_is_long_cable()) {
+				hdmi_dfe_recovery_6g_long_cable();
+			}
+		}
+	} else if (hdmi_rx.timing_t.tmds_clk_b > 1042) {
+		/* > 1.1G */
+		if (hdmi_bit_err_detection()) {
+		//	hdmi_dfe_recovery_mi_speed();
+		}
+	}
+#endif
+
+	return TRUE;
+}
+
+void hdmi_reset_video_state(void)
+{
+	SET_H_VIDEO_FSM(MAIN_FSM_HDMI_WAIT_SYNC);
+
+	SET_H_INTERLACE(0);
+	SET_H_MODE(MODE_HDMI);
+	SET_H_COLOR_DEPTH(HDMI_COLOR_DEPTH_8B);
+	SET_H_COLOR_SPACE(COLOR_RGB);
+
+	SET_H_3DFORMAT(HDMI3D_2D_ONLY);
+}
+
+unsigned char hdmi_get_video_state(void)
+{
+	return GET_H_VIDEO_FSM();
+}
+
+void hdmi_reset_meas_counter(void)
+{
+	hdmi_rx.meas_retry_cnt = 0;
+}
+
+void hdmi_check_crc_0(void)
+{
+	if (lib_hdmi_read_crc())
+		return;
+
+	HDMI_PRINTF("CRC=00000000000, cs=%d\n", GET_H_COLOR_SPACE());
+
+	if (GET_H_COLOR_SPACE() == COLOR_YUV420) {
+		lib_hdmi_420_en(0);
+		HDMI_DELAYMS(20);
+		lib_hdmi_420_en(1);
+	}
+}
+
+
+#if HDMI2p0
+void hdmi2p0_check_tmds_config(void)
+{
+	unsigned char cfg, hail_hydra;
+
+	cfg = lib_hdmi2p0_get_tmds_config();
+
+	hail_hydra = (hdmi_rx.scramble_flag|hdmi_rx.clock40x_flag);
+
+
+	if (hdmi_rx.hdmi2p0_tmds_toggle_flag > 10) {
+		hdmi_rx.scramble_flag = ((cfg&_BIT0) != 0);
+		hdmi_rx.clock40x_flag = ((cfg&_BIT1) != 0);
+	} else if (hdmi_rx.hdmi2p0_tmds_toggle_flag > 2) {
+		hdmi_rx.scramble_flag = ((cfg&_BIT0) == 0);
+		hdmi_rx.clock40x_flag = ((cfg&_BIT1) == 0);
+		//HDMI_PRINTF("HDMI2.0 swap\n");
+	} else {
+		hdmi_rx.scramble_flag = ((cfg&_BIT0) != 0);
+		hdmi_rx.clock40x_flag = ((cfg&_BIT1) != 0);
+	}
+
+	if (!hail_hydra && (hdmi_rx.scramble_flag||hdmi_rx.clock40x_flag)) {
+		HDMI_PRINTF("HDMI2.0 SCDC: got it\n");
+	}
+
+}
+
+unsigned char hdmi2p0_get_scramble_flag(void)
+{
+	return hdmi_rx.scramble_flag;
+}
+
+unsigned char hdmi2p0_get_clock40x_flag(void)
+{
+	return hdmi_rx.clock40x_flag;
+}
+
+void hdmi2p0_fource_6g(void)
+{
+	hdmi_rx.scramble_flag = 1;
+	hdmi_rx.clock40x_flag = 1;
+}
+
+void hdmi2p0_detect_config(void)
+{
+	lib_hdmi2p0_scramble_enable(hdmi_rx.scramble_flag);
+
+}
+
+void hdmi2p0_reset_scdc_toggle(void)
+{
+	hdmi_rx.hdmi2p0_tmds_toggle_flag = 0;
+}
+
+void hdmi2p0_inc_scdc_toggle(void)
+{
+	if(hdmi_rx.hdmi2p0_tmds_toggle_flag >= 0xfe)
+		hdmi_rx.hdmi2p0_tmds_toggle_flag = 0;
+	else
+	hdmi_rx.hdmi2p0_tmds_toggle_flag++;
+}
+
+void hdmi2p0_align_flush(void)
+{
+	unsigned int flush_timeout, flush_count = 0;
+
+	hdmi_rx_reg_mask32(HDMI_CH_SR, ~_ZERO, 0, HDMI_RX_MAC); /* write 1 clear */
+
+	while (!(hdmi_rx_reg_read32(HDMI_CH_SR, HDMI_RX_MAC) & _BIT30)) {
+		hdmi_rx_reg_mask32(HDMI_CH_CR, ~_BIT1, _BIT1, HDMI_RX_MAC);
+		flush_timeout = 0;
+		flush_count++;
+
+		while (hdmi_rx_reg_read32(HDMI_CH_CR, HDMI_RX_MAC) & _BIT1) {
+			HDMI_DELAYMS(1);
+			flush_timeout++;
+
+			if (flush_timeout >= 10) {
+				HDMI_PRINTF("[HDMI] Align Flush flush_timeout\n");
+				break;
+			}
+		}
+
+		hdmi_rx_reg_mask32(HDMI_CH_SR, ~_ZERO, 0, HDMI_RX_MAC); /* write 1 clear */
+
+		if (flush_count >= 50) {
+			HDMI_PRINTF("[HDMI] Align Flush Fail\n");
+			break;
+		}
+
+		HDMI_DELAYMS(20);
+	}
+
+}
+
+#endif
+
+unsigned char hdmi_get_timing(HDMI_TIMING_T *ptiming)
+{
+	if (GET_H_VIDEO_FSM() == MAIN_FSM_HDMI_VIDEO_READY) {
+		memcpy(ptiming, &hdmi_rx.timing_t, sizeof(HDMI_TIMING_T));
+		return TRUE;
+	} else {
+		memset(ptiming, 0, sizeof(HDMI_TIMING_T));
+		return FALSE;
+	}
+
+	return FALSE;
+}
+
+unsigned char hdmi_get_interlace_conti_mode(void)
+{
+unsigned char is_intc= 0;
+
+	if (hdmi_rx.vs_cnt > 3) {
+		is_intc = lib_hdmi_get_is_interlace(HDMI_MS_DIRECT);
+		lib_hdmi_clear_interlace_reg();
+		hdmi_rx.vs_cnt = 0;
+		return is_intc;
+	} else {
+		lib_hdmi_vsync_checked();
+		hdmi_rx.vs_cnt++;
+		return hdmi_rx.timing_t.is_interlace;
+	}
+
+}
+
+unsigned char hdmi_get_is_interlace(void)
+{
+	return GET_H_INTERLACE();
+}
+
+unsigned char hdmi_get_hdmi_mode_reg(void)
+{
+#if HDMI2p0
+	if (hdmi2p0_get_clock40x_flag() || hdmi2p0_get_scramble_flag()) {
+		return TRUE;
+	}
+#endif
+
+	return lib_hdmi_is_hdmi_mode();
+
+}
+
+unsigned char hdmi_get_hdmi_mode(void)
+{
+	return GET_H_MODE();
+}
+
+unsigned char hdmi_get_colordepth(void)
+{
+	return GET_H_COLOR_DEPTH();
+}
+
+unsigned char hdmi_get_colorspace_reg(void)
+{
+	if (!hdmi_get_hdmi_mode_reg()) {
+		return COLOR_RGB;
+	}
+
+	return lib_hdmi_get_colorspace();
+}
+
+unsigned char hdmi_get_colorspace(void)
+{
+	if (GET_H_COLOR_SPACE() == COLOR_YUV420)
+		return COLOR_YUV444;
+	else
+		return GET_H_COLOR_SPACE();
+
+}
+
+unsigned char hdmi_get_video_format_reg(void)
+{
+	if (hdmi_rx.vsi_t.len == 0)
+		return HVF_NO;
+
+	return lib_hdmi_get_video_format();
+}
+
+unsigned char hdmi_get_video_format(void)
+{
+	return GET_H_VIDEO_FORMAT();
+}
+
+unsigned char hdmi_get_3d_structure_reg(void)
+{
+	if (hdmi_rx.vsi_t.len == 0)
+		return HDMI3D_2D_ONLY;
+
+	if (lib_hdmi_get_video_format() != HVF_3D)
+		return HDMI3D_2D_ONLY;
+	else
+		return lib_hdmi_get_3d_structure();
+}
+
+
+unsigned char hdmi_get_3d_structure(void)
+{
+	if (hdmi_rx.vsi_t.len == 0)
+		return HDMI3D_2D_ONLY;
+
+	return GET_H_3DFORMAT();
+}
+
+unsigned char hdmi_get_colorimetry(void)
+{
+	if (hdmi_rx.avi_t.len == 0) return 0;
+
+	return (hdmi_rx.avi_t.C == 3)?
+		(hdmi_rx.avi_t.EC+HDMI_COLORIMETRY_XYYCC601):hdmi_rx.avi_t.C;
+}
+
+unsigned char hdmi_get_color_range(void)
+{
+	if (hdmi_rx.avi_t.len == 0)
+		return 0;
+
+	if (hdmi_rx.avi_t.Y == 0) {	// RGB
+		return hdmi_rx.avi_t.Q;
+	} else if (hdmi_rx.avi_t.Y == 1 || hdmi_rx.avi_t.Y == 2 || hdmi_rx.avi_t.Y == 3) {	// YUV
+		return (hdmi_rx.avi_t.YQ<3)?(hdmi_rx.avi_t.YQ+1):MODE_RAG_DEFAULT;
+	} else {
+		return MODE_RAG_DEFAULT;
+	}
+}
+
+unsigned char hdmi_get_audio_coding_type(unsigned char *code_type)
+{
+	if (hdmi_rx.audiopkt_t.len == 0)
+		return 0;
+
+	*code_type = hdmi_rx.audiopkt_t.CT;
+	if (hdmi_rx.audiopkt_t.CT == 0)
+		*code_type = lib_hdmi_audio_get_channel_status15_0(0xFF00, 8);
+
+	return 1;
+}
+
+unsigned int hdmi_get_tmds_clockx10(void)
+{
+	if (GET_H_VIDEO_FSM() < MAIN_FSM_HDMI_MEASURE)
+		return 0;
+	return (lib_hdmi_get_clock()*270)>>8;
+}
+
+void hdmi_fix_green_line(void) //k3l need to check
+{
+	if (GET_H_COLOR_SPACE() == COLOR_RGB)
+		lib_hdmi_tmds_out_ctrl(1, 0, 0, 0);
+	else
+		lib_hdmi_tmds_out_ctrl(0, 0x8000, 0x1000, 0x8000);
+}
+
+
+void hdmi_audio_var_init(void)
+{
+	hdmi_rx.audio_t.coding_type= 0;
+	hdmi_rx.audio_t.audio_freq = 0;
+	hdmi_rx.audio_t.sr_mismatch_cnt = 0;
+	hdmi_rx.audio_t.track_mode_tgl = 0;
+}
+
+unsigned char hdmi_audio_is_pll_ready(void)
+{
+	unsigned char timeout;
+
+	for (timeout = 0; timeout < 5; timeout++) {
+		lib_hdmi_audio_clear_phase_error();
+		HDMI_DELAYMS(20);
+		if (!(lib_hdmi_audio_is_pll_unlock()||lib_hdmi_audio_is_fifo_overflow()||lib_hdmi_audio_is_fifo_underflow()))
+			return TRUE;
+		lib_hdmi_audio_wclr_pll_unlock();
+		lib_hdmi_audio_wclr_fifo_overflow();
+		lib_hdmi_audio_wclr_fifo_underflow();
+	}
+
+	HDMI_PRINTF("[ERR] FIFO Unstable = %x\n", hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+	return FALSE;
+
+}
+
+unsigned char hdmi_audio_set_pll(unsigned int freq, unsigned char ucACR_N,HDMI_AUDIO_TRACK_MODE track_mode)
+{
+	u_int8_t i;
+	int timeout = 10;
+	u_int32_t I_Code = 0, S = 0;
+	unsigned int clk;
+
+	for (i = 0; i < 7; i++) {
+		if (hdmi_audiopll_param[i].freq == freq)
+			goto PLL_SETTING;
+	}
+	HDMI_PRINTF( "Unsupport audio freq = %d\n", freq);
+	return FALSE;
+
+PLL_SETTING:
+
+	clk = hdmi_rx.timing_t.tmds_clk_b;
+
+	/* (2)audio output enable = auto mode */
+	hdmi_rx_reg_mask32(HDMI_AFCR, ~_BIT6, _BIT6, HDMI_RX_MAC);
+
+	/* (3)Disable trend and boundary tracking */
+	hdmi_rx_reg_mask32(HDMI_WDCR0, ~HDMI_WDCR0_bt_track_en_mask, 0x0, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_PSCR, ~(_BIT3 |_BIT2), 0x0, HDMI_RX_MAC);
+	/* Update Double Buffer */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4 , _BIT4, HDMI_RX_MAC);
+
+	/* (4)FSM back to Pre-mode */
+	hdmi_rx_reg_mask32(HDMI_AVMCR , ~_BIT5, 0x0, HDMI_RX_MAC);
+
+	/* (5)Disable N/CTS tracking */
+	/* CTS has glitch not to tracking disable */
+	hdmi_rx_reg_mask32(HDMI_AUDIO_CTS_UP_BOUND, ~_BIT20, 0x0, HDMI_RX_MAC);
+	/* N has glitch not to tracking disable */
+	hdmi_rx_reg_mask32(HDMI_AUDIO_N_UP_BOUND, ~_BIT20, 0x0, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_PSCR, ~_BIT4, 0x00, HDMI_RX_MAC);
+	/* Update Double Buffer */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+
+	/*(6)Disable SDM*/
+	hdmi_rx_reg_mask32(HDMI_AAPNR, ~_BIT1, 0x0, HDMI_RX_MAC);
+
+	/*(7)Disable PLL*/
+	hdmi_rx_reg_mask32(HDMI_APLLCR1, ~HDMI_APLLCR1_dpll_rstb_mask, 0x0, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_APLLCR1,
+		~(HDMI_APLLCR1_dpll_freeze_mask|HDMI_APLLCR1_dpll_vcorstb_mask|HDMI_APLLCR1_dpll_pow_mask),
+		(HDMI_APLLCR1_dpll_freeze_mask ), HDMI_RX_MAC);
+
+	/* (8)resetS &S1 code to avoid dead lock */
+	/* PLL output clk sel from crystal */
+	hdmi_rx_reg_mask32(HDMI_CMCR,  ~( _BIT6|_BIT5), 0x0, HDMI_RX_MAC);
+	/* S1 & S2 code clear to 0 , to avoid dead lock */
+	hdmi_rx_reg_write32(HDMI_SCAPR, 0x00, HDMI_RX_MAC);
+	/* Update Double Buffer */
+	hdmi_rx_reg_mask32(HDMI_CMCR,~_BIT4 , _BIT4, HDMI_RX_MAC);
+    HDMI_DELAYUS(10);
+    /* PLL output clk sel from VCO */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~( _BIT6|_BIT5), (_BIT6), HDMI_RX_MAC);
+	/* Update Double Buffer */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+
+	/*(9)D code*/
+	hdmi_rx_reg_write32(HDMI_DCAPR0,
+		(hdmi_audiopll_param[i].D_HighByte << 8) | hdmi_audiopll_param[i].D_LowByte, HDMI_RX_MAC);
+	/* Enable Double Buffer for K/M/S/D/O */
+	hdmi_rx_reg_mask32(HDMI_CMCR, ~(HDMI_CMCR_dbdcb_mask), HDMI_CMCR_dbdcb(1), HDMI_RX_MAC);
+
+	/*(10)Initial PLL*/
+	/* Set audio PLL N code */
+	if (hdmi_audiopll_param[i].N < 2) {
+		hdmi_rx_reg_mask32(HDMI_APLLCR0,
+			~(HDMI_APLLCR0_dpll_m_mask | HDMI_APLLCR0_dpll_o_mask | HDMI_APLLCR0_dpll_bpsin_mask | HDMI_APLLCR0_dpll_n_mask), 	
+			HDMI_APLLCR0_dpll_m(hdmi_audiopll_param[i].M - 2) | HDMI_APLLCR0_dpll_o(hdmi_audiopll_param[i].O) |
+			HDMI_APLLCR0_dpll_bpsin(1) | HDMI_APLLCR0_dpll_n(0), HDMI_RX_MAC);
+	} else {
+		hdmi_rx_reg_mask32(HDMI_APLLCR0,
+			~(HDMI_APLLCR0_dpll_m_mask |HDMI_APLLCR0_dpll_o_mask |HDMI_APLLCR0_dpll_bpsin_mask | HDMI_APLLCR0_dpll_n_mask),
+			HDMI_APLLCR0_dpll_m(hdmi_audiopll_param[i].M - 2) | HDMI_APLLCR0_dpll_o(hdmi_audiopll_param[i].O) |
+			HDMI_APLLCR0_dpll_bpsin(0) | HDMI_APLLCR0_dpll_n(hdmi_audiopll_param[i].N-2), HDMI_RX_MAC);
+	}
+	/* Enable Double Buffer for K/M/S/D/O */
+	hdmi_rx_reg_mask32(HDMI_CMCR,~(HDMI_CMCR_dbdcb_mask),HDMI_CMCR_dbdcb(1), HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_SCAPR,
+		(hdmi_audiopll_param[i].S1) ? ((hdmi_audiopll_param[i].S / 2) | 0x80) : (hdmi_audiopll_param[i].S / 2),
+		HDMI_RX_MAC);
+	/* S1 code */
+	hdmi_rx_reg_write32(HDMI_PRESET_S_CODE1, 0xf800, HDMI_RX_MAC);
+	/* Set Icp 4u */
+	hdmi_rx_reg_mask32(HDMI_APLLCR0, ~(_BIT2|_BIT1|_BIT0), _BIT0, HDMI_RX_MAC);
+	/* Set RS=26k */
+	hdmi_rx_reg_mask32(HDMI_APLLCR0,
+		~(_BIT5|_BIT4|_BIT3), (_BIT5| _BIT3), HDMI_RX_MAC);
+	/* Set CS=42pf */
+	hdmi_rx_reg_mask32(HDMI_APLLCR1,
+		~(HDMI_APLLCR1_dpll_CS_MASK), (HDMI_APLLCR1_dpll_CS_35P), HDMI_RX_MAC);
+	/* Set CP=1.5pf */
+	hdmi_rx_reg_mask32(HDMI_APLLCR1, ~(_BIT22|_BIT21), _BIT21, HDMI_RX_MAC);
+	/* Enable PLL */
+	hdmi_rx_reg_mask32(HDMI_APLLCR1,
+		~(HDMI_APLLCR1_dpll_stoppsw_mask | HDMI_APLLCR1_dpll_pow_mask),
+		(HDMI_APLLCR1_dpll_pow_mask | HDMI_APLLCR1_dpll_stoppsw_mask),
+		HDMI_RX_MAC);
+	/* RST */
+	hdmi_rx_reg_mask32(HDMI_APLLCR1,
+		~(HDMI_APLLCR1_dpll_vcorstb_mask), (HDMI_APLLCR1_dpll_vcorstb_mask), HDMI_RX_MAC);
+
+	HDMI_PRINTF(" m = %x\n o = %x\n s = %x\n ",
+		hdmi_audiopll_param[i].M, hdmi_audiopll_param[i].O, hdmi_audiopll_param[i].S);
+	/* Wait PLL Stable */
+	HDMI_DELAYUS(1);
+	/* PLL un-freeze */
+	hdmi_rx_reg_mask32(HDMI_APLLCR1,
+		~HDMI_APLLCR1_dpll_rstb_mask, HDMI_APLLCR1_dpll_rstb_mask, HDMI_RX_MAC);
+	/* Wait PLL stable */
+	HDMI_DELAYUS(40);
+	hdmi_rx_reg_mask32(HDMI_APLLCR1,
+		~HDMI_APLLCR1_dpll_freeze_mask, 0x0, HDMI_RX_MAC);
+
+	/* (11)Enable SDM */
+	hdmi_rx_reg_mask32(HDMI_AAPNR,
+		~HDMI_AAPNR_esdm_mask, HDMI_AAPNR_esdm_mask, HDMI_RX_MAC);
+	HDMI_DELAYUS(1);
+
+	if (track_mode == HDMI_AUDIO_N_CTS_TREND_BOUND) {
+		HDMI_PRINTF("\n *****N/CTS Trend& Boundary Tracking*****\n");
+		/*
+		 * (12)Enable N/CTS tracking
+		 * Modify N/CTS tracking parameter  USER:kistlin DATE:2011/08/04
+		 * for phase error count source Fpec = Fdds = Fvco/4
+		 * PEpec x Tpec = delta(Tvco)xNxSxPLLO = Tvco(1/8)(D[15:0]/2^16)xNxSxPLLO
+		 * D[15:0] = PEpec x Tpec /[Tvco(1/8)(1//2^16)xNxSxPLLO]
+		 * and D[15:0] = PEpec x (1/8)Icode
+		 * Icode calculate I code =2^24/(N*S*PLLO)
+		 *
+		 * for phase error count source = fvco/4,fdds
+		 * Icode calculate I code =2*2048*2^10/(N*S*PLLO)
+		 */
+		if (hdmi_audiopll_param[i].S1)
+			S = hdmi_audiopll_param[i].S*2;
+		else
+			S = hdmi_audiopll_param[i].S;
+
+		HDMI_PRINTF("S = %d , ACR_N=%d, hdmi_audiopll_param[i].O = %d\n",
+			S, ucACR_N, hdmi_audiopll_param[i].O );
+
+		if (ucACR_N) {
+			I_Code =16*1024*1024/(ucACR_N*S*(hdmi_audiopll_param[i].O<<1));
+		} else
+			I_Code = 0x02;
+
+		/* HDMI_PRINTF( "I Code = %d\n", I_Code); */
+		/* HDMI_PRINTF( "tmp1 = %d\n", tmp1); */
+
+		/* Set I code of Ncts[15:8] */
+		hdmi_rx_reg_write32(HDMI_ICPSNCR0, I_Code, HDMI_RX_MAC);
+		/* Set P code of Ncts [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCPSNCR0, 0x0, HDMI_RX_MAC);
+		/* N_CTS tracking re-enable toggle function enable */
+		hdmi_rx_reg_mask32(HDMI_NPECR,
+			~HDMI_NPECR_ncts_re_enable_off_en_mask,
+			HDMI_NPECR_ncts_re_enable_off_en_mask, HDMI_RX_MAC);
+		/* Enable N_CTS tracking & set FIFO depth */
+		hdmi_rx_reg_write32(HDMI_PSCR, 0x92, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+
+		/* Phase error threshold */
+		hdmi_rx_reg_write32(HDMI_PETR, 0x1e, HDMI_RX_MAC);
+		for (timeout = 0; timeout < 25; timeout++) {
+			hdmi_rx_reg_mask32(HDMI_SR, ~_BIT3, _BIT3, HDMI_RX_MAC);
+			hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+			HDMI_DELAYMS(20);
+			if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT3)) == 0)
+				break;
+		}
+
+		if (timeout == 25)
+			HDMI_PRINTF("PLL 1st check not lock = %x\n", hdmi_rx_reg_read32(HDMI_NCPER, HDMI_RX_MAC));
+		else
+			HDMI_PRINTF("PLL 1st check lock count = %d\n", timeout);
+
+		/* Sisable N_CTS tracking */
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~HDMI_PSCR_etcn_mask, 0, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR,
+			~HDMI_CMCR_dbdcb_mask, HDMI_CMCR_dbdcb_mask, HDMI_RX_MAC);
+		/* N_CTS tracking re-enable toggle function disable */
+		hdmi_rx_reg_mask32(HDMI_NPECR,
+			~HDMI_NPECR_ncts_re_enable_off_en_mask, 0, HDMI_RX_MAC);
+		/* Set I code of Ncts[15:8] */
+		hdmi_rx_reg_write32(HDMI_ICPSNCR0,
+			HDMI_ICPSNCR0_ich(0)|HDMI_ICPSNCR0_icl(0x02), HDMI_RX_MAC);
+		/* Set P code of Ncts [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCPSNCR0,
+			HDMI_PCPSNCR0_pch(0x20)|HDMI_PCPSNCR0_pcl(0x0), HDMI_RX_MAC);
+		/* Enable N_CTS tracking */
+		hdmi_rx_reg_mask32(HDMI_PSCR,
+			~HDMI_PSCR_etcn_mask, HDMI_PSCR_etcn_mask, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR,
+			~HDMI_CMCR_dbdcb_mask, HDMI_CMCR_dbdcb_mask, HDMI_RX_MAC);
+		/* N&CTS boundary set */
+		lib_hdmi_audio_cts_bound(clk);
+		lib_hdmi_audio_n_bound(freq);
+
+		/* CTS has glitch not to tracking enable */
+		hdmi_rx_reg_mask32(HDMI_AUDIO_CTS_UP_BOUND, ~_BIT20, _BIT20, HDMI_RX_MAC);
+		/* N has glitch not to tracking enable */
+		hdmi_rx_reg_mask32(HDMI_AUDIO_N_UP_BOUND, ~_BIT20, _BIT20, HDMI_RX_MAC);
+
+		/*(13)Wait PLL lock by N&CTS tracking*/
+		hdmi_rx_reg_write32(HDMI_PETR, 0x1e, HDMI_RX_MAC);/* Phase error threshold */
+		for (timeout = 0; timeout < 25; timeout++) {
+			hdmi_rx_reg_mask32(HDMI_SR, ~_BIT3, _BIT3, HDMI_RX_MAC);
+			hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+			HDMI_DELAYMS(20);
+			if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT3)) == 0)
+				break;
+		}
+
+		if (timeout == 25)
+			HDMI_PRINTF("PLL not lock = %x\n", hdmi_rx_reg_read32(HDMI_NCPER, HDMI_RX_MAC));
+		else
+			HDMI_PRINTF("PLL lock count = %d\n", timeout);
+
+		/*(14)FSM Initial*/
+		hdmi_rx_reg_write32(HDMI_FBR, 0x74, HDMI_RX_MAC);
+		/* FSM entry Pre-mode (AOC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT6, _BIT6, HDMI_RX_MAC);
+		/* FSM entry next step (AOMC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT5 ,_BIT5, HDMI_RX_MAC);
+		/* Wait fifo to target fifo level */
+		HDMI_DELAYUS(1);
+
+		/*(15)Enable trend and boundary tracking*/
+		/* Set I code  of trend [15:8] */
+		hdmi_rx_reg_write32(HDMI_ICTPSR0, 0x0005, HDMI_RX_MAC);
+		/* Set P code of trend [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCTPSR0, 0x02FF, HDMI_RX_MAC);
+		/* Set I code of bnd [15:8] */
+		hdmi_rx_reg_write32(HDMI_ICBPSR0, 0x0005, HDMI_RX_MAC);
+		/* Set P code of bnd [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCBPSR0, 0x02FF, HDMI_RX_MAC);
+		/* Set Boundary Tracking Update Response Time */
+		hdmi_rx_reg_write32(HDMI_STBPR, 0x01, HDMI_RX_MAC);
+		/* Enable trend and boundary tracking */
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~(_BIT3|_BIT2), (_BIT3|_BIT2), HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+		HDMI_DELAYMS(20);
+		/* Enable trend and boundary tracking */
+		hdmi_rx_reg_mask32(HDMI_WDCR0,
+			~HDMI_WDCR0_bt_track_en_mask,
+			HDMI_WDCR0_bt_track_en_mask, HDMI_RX_MAC);
+	} else if(track_mode == HDMI_AUDIO_TREND_BOUND) {
+		HDMI_PRINTF("\n ***** TREND_BOUND Tracking*****\n");
+		/* (14)FSM Initial */
+		hdmi_rx_reg_write32(HDMI_FBR, 0x74, HDMI_RX_MAC);
+		/* FSM entry Pre-mode (AOC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT6, _BIT6, HDMI_RX_MAC);
+		/* FSM entry next step (AOMC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT5, _BIT5, HDMI_RX_MAC);
+		/* Wait fifo to target fifo level */
+		HDMI_DELAYUS(1);
+
+		/* (15)Enable trend and boundary tracking */
+		/* Set I code  of trend [15:8] */
+		hdmi_rx_reg_write32(HDMI_ICTPSR0, 0x0005, HDMI_RX_MAC);
+		/* Set P code of trend [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCTPSR0, 0x02FF, HDMI_RX_MAC);
+		/* Set I code of bnd [15:8] */
+		hdmi_rx_reg_write32(HDMI_ICBPSR0, 0x0001, HDMI_RX_MAC);
+		/* Set P code of bnd [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCBPSR0, 0x2000, HDMI_RX_MAC);
+		/* Set Boundary Tracking Update Response Time */
+		hdmi_rx_reg_write32(HDMI_STBPR, 0x01, HDMI_RX_MAC);
+		/* FIFO depth tracking */
+		hdmi_rx_reg_write32(HDMI_PSCR,
+			HDMI_PSCR_fdint(4)|HDMI_PSCR_etcn(0)|HDMI_PSCR_etfd(1)|
+			HDMI_PSCR_etfbc(1)|HDMI_PSCR_pecs(2),
+			HDMI_RX_MAC);
+		/* <1>Enable trend and boundary tracking */
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~(_BIT3|_BIT2), (_BIT3|_BIT2), HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+		HDMI_DELAYMS(20);
+		/* <2>Enable trend and boundary tracking */
+		hdmi_rx_reg_mask32(HDMI_WDCR0,
+			~HDMI_WDCR0_bt_track_en_mask, HDMI_WDCR0_bt_track_en_mask, HDMI_RX_MAC);
+
+	} else {
+		/*  H/W N/CTS Tracking */
+		HDMI_PRINTF("\n ***** N/CTS Tracking*****\n");
+		/*(12)Enable N/CTS tracking*/
+		if (hdmi_audiopll_param[i].S1)
+			S = hdmi_audiopll_param[i].S*2;
+		else
+			S = hdmi_audiopll_param[i].S;
+
+		HDMI_PRINTF("S = %d , ACR_N=%d, hdmi_audiopll_param[i].O = %d\n",
+			S, ucACR_N, hdmi_audiopll_param[i].O);
+
+		if (ucACR_N)
+			I_Code =16*1024*1024/(ucACR_N*S*(hdmi_audiopll_param[i].O<<1));
+		else
+			I_Code = 0x02;
+
+		/* HDMI_PRINTF("I Code = %d\n", I_Code); */
+		/* HDMI_PRINTF("tmp1 = %d\n", tmp1); */
+
+		/* Set I code of Ncts[15:8] */
+		hdmi_rx_reg_write32(HDMI_ICPSNCR0, I_Code, HDMI_RX_MAC);
+		/* Set P code of Ncts [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCPSNCR0, 0x0000, HDMI_RX_MAC);
+		/* N_CTS tracking re-enable toggle function enable */
+		hdmi_rx_reg_mask32(HDMI_NPECR,
+			~HDMI_NPECR_ncts_re_enable_off_en_mask,
+			HDMI_NPECR_ncts_re_enable_off_en_mask, HDMI_RX_MAC);
+		/* Enable N_CTS tracking & set FIFO depth */
+		hdmi_rx_reg_write32(HDMI_PSCR, 0x92, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+
+		/* Phase error threshold */
+		hdmi_rx_reg_write32(HDMI_PETR, 0x1e, HDMI_RX_MAC);
+		for (timeout = 0; timeout < 25; timeout++) {
+			hdmi_rx_reg_mask32(HDMI_SR, ~_BIT3, _BIT3, HDMI_RX_MAC);
+			hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+			HDMI_DELAYMS(20);
+			if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & _BIT3) == 0)
+				break;
+		}
+
+		if (timeout == 25)
+			HDMI_PRINTF("PLL 1st check not lock = %x\n", hdmi_rx_reg_read32(HDMI_NCPER, HDMI_RX_MAC));
+		else
+			HDMI_PRINTF("PLL 1st check lock count = %d\n", timeout);
+
+		/* Disable N_CTS tracking */
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~_BIT4, 0, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+		/* N_CTS tracking re-enable toggle function disable */
+		hdmi_rx_reg_mask32(HDMI_NPECR,
+			~HDMI_NPECR_ncts_re_enable_off_en_mask, 0, HDMI_RX_MAC);
+		/* Set I code of Ncts[15:8] */
+		hdmi_rx_reg_write32(HDMI_ICPSNCR0, 0x0002, HDMI_RX_MAC);
+		/* Set P code of Ncts [15:8] */
+		hdmi_rx_reg_write32(HDMI_PCPSNCR0, 0x2000, HDMI_RX_MAC);
+		/* Enable N_CTS tracking */
+		hdmi_rx_reg_mask32(HDMI_PSCR, ~_BIT4, _BIT4, HDMI_RX_MAC);
+		/* Update Double Buffer */
+		hdmi_rx_reg_mask32(HDMI_CMCR, ~_BIT4 , _BIT4, HDMI_RX_MAC);
+
+		/* N&CTS boundary set */
+		lib_hdmi_audio_cts_bound(clk);
+		lib_hdmi_audio_n_bound(freq);
+
+		/* CTS has glitch not to tracking enable */
+		hdmi_rx_reg_mask32(HDMI_AUDIO_CTS_UP_BOUND, ~_BIT20, _BIT20, HDMI_RX_MAC);
+		/* N has glitch not to tracking enable */
+		hdmi_rx_reg_mask32(HDMI_AUDIO_N_UP_BOUND, ~_BIT20, _BIT20, HDMI_RX_MAC);
+
+		/*(13)Wait PLL lock by N&CTS tracking*/
+		/* Phase error threshold */
+		hdmi_rx_reg_write32(HDMI_PETR, 0x1e, HDMI_RX_MAC);
+		for (timeout = 0; timeout < 25; timeout++) {
+			hdmi_rx_reg_mask32(HDMI_SR, ~_BIT3, _BIT3, HDMI_RX_MAC);
+			hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+			HDMI_DELAYMS(20);
+			if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & _BIT3) == 0)
+				break;
+		}
+
+		if (timeout == 25)
+			HDMI_PRINTF("PLL not lock = %x\n", hdmi_rx_reg_read32(HDMI_NCPER, HDMI_RX_MAC));
+		else
+			HDMI_PRINTF("PLL lock count = %d\n", timeout);
+
+		/* (14)FSM Initial */
+		/* Target FIFO depth = 14 ,Boundary address distance = 7 */
+		hdmi_rx_reg_write32(HDMI_FBR, 0x77, HDMI_RX_MAC);
+		/* FSM entry Pre-mode (AOC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT6, _BIT6, HDMI_RX_MAC);
+		/* FSM entry next step (AOMC=1) */
+		hdmi_rx_reg_mask32(HDMI_AVMCR, ~_BIT5, _BIT5, HDMI_RX_MAC);
+		/* Wait fifo to target fifo level */
+		HDMI_DELAYUS(1);
+	}
+
+#if 0
+	/* (16)Wait FIFO stable */
+	for (timeout = 0; timeout < 5; timeout++) {
+		hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+		HDMI_DELAYMS(20);
+		if ((hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC) & (_BIT3|_BIT2|_BIT1)) == 0)
+			break;
+		hdmi_rx_reg_mask32(HDMI_SR, ~(_BIT3|_BIT2|_BIT1), (_BIT3|_BIT2|_BIT1), HDMI_RX_MAC);
+	}
+
+	if (timeout == 5)
+		HDMI_PRINTF("FIFO Unstable = %x \n", hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+	else
+		HDMI_PRINTF("FIFO timeout count = %d\n", timeout);
+
+	HDMI_PRINTF("HDMI_AVMCR_reg = %x\n", hdmi_rx_reg_read32(HDMI_AVMCR, HDMI_RX_MAC));
+#endif
+	return TRUE;
+
+}
+
+unsigned int hdmi_audio_freq_correction(unsigned int freq)
+{
+	const unsigned int b_ratio = 1000;
+
+	freq *= 10;
+	if((freq >= (31700*b_ratio/100)) && (freq <= (32300*b_ratio/100)))
+		freq = 32000;
+	else if((freq >= (43500*b_ratio/100)) && (freq <= (44600*b_ratio/100)))
+		freq = 44100;
+	else if((freq >= 47500*b_ratio/100) && (freq <= (48500*b_ratio/100)))
+		freq = 48000;
+	else if((freq >= (87700*b_ratio/100)) && (freq <= (88700*b_ratio/100)))
+		freq = 88200;
+	else if((freq >= (95500*b_ratio/100)) && (freq <= (96500*b_ratio/100)))
+		freq = 96000;
+	else if((freq >= (175400*b_ratio/100)) && (freq <= (177400*b_ratio/100)))
+		freq = 176400;
+	else if((freq >= (191000*b_ratio/100)) && (freq <= (193000*b_ratio/100)))
+		freq = 192000;
+#if AUDIO_OVER_192K
+	else if ((freq >= (351800*b_ratio/100)) && (freq <= (353800*b_ratio/100)))
+		freq = 352800;
+	else if ((freq >= (383000*b_ratio/100)) && (freq <= (385000*b_ratio/100)))
+		freq = 384000;
+	else if ((freq >= (704600*b_ratio/100)) && (freq <= (706600*b_ratio/100)))
+		freq = 705600;
+	else if ((freq >= (767000*b_ratio/100)) && (freq <= (769000*b_ratio/100)))
+		freq = 768000;
+	else if ((freq >= (1401200*b_ratio/100)) && (freq <= (1421200*b_ratio/100)))
+		freq = 1411200;
+	else if ((freq >= (1526000*b_ratio/100))&& (freq <= (1546000*b_ratio/100)))
+		freq = 1536000;
+#endif
+	else
+		freq = 0;
+
+
+	return freq;
+}
+
+void hdmi_audio_get_freq(HDMI_AUDIO_FREQ_T *freq, HDMI_AUDIO_TRACK_MODE *track_mode)
+{
+
+	unsigned long cts, n, b;
+	unsigned char count = 0;
+
+	freq->ACR_freq = 0;
+	freq->AudioInfo_freq = 0;
+	freq->SPDIF_freq = 0;
+	freq->ACR_N = 0;
+
+	/* Set trigger to get CTS&N and LPCM Channel Status Info */
+
+	/* Start Pop up N_CTS value */
+	lib_hdmi_audio_pop_n_cts();
+
+	/* Clear Info Frame update indicator */
+	lib_hdmi_audio_clear_fs();
+
+	if (!hdmi_audio_wait_acr())
+		HDMI_PRINTF("No N/CTS packet\n");
+
+	for (count = 0; count < 15; count++) {
+		if (lib_hdmi_audio_pop_n_cts_done() && lib_hdmi_audio_fs_from_cs())
+			break;
+
+		HDMI_DELAYUS(10000);
+	}
+
+	if (count >= 15)
+		HDMI_PRINTF("[ERR] POP UP TIME OUT\n");
+
+	HDMI_PRINTF("POP UP TIME %d\n",count);
+
+	/* debug options: bit0 or bit1 */
+	if (lib_hdmi_audio_fs_from_cs())
+		freq->SPDIF_freq = AUDIO_CHANNEL_STATUS[lib_hdmi_audio_get_freq_from_cs()];
+
+	HDMI_PRINTF("*************** SPDIF freq=%ld\n", freq->SPDIF_freq);
+
+	/* Get Audio Frequency from CTS&N */
+
+	cts = lib_hdmi_audio_get_cts();
+	n = lib_hdmi_audio_get_n();
+	b = hdmi_rx.timing_t.tmds_clk_b;
+	freq->ACR_N = n;
+
+	HDMI_PRINTF("(cts=%ld)(n=%ld)(b=%ld)\n", cts, n, b);
+
+	if (cts == 0 || n == 0 || b == 0)
+		return;
+
+	/*
+	 * 128fs = 1024/b * fx * N / CTS  =>  fs = (1024 * fx *N)/(128 * b * CTS) = (8 * fx *N)/(b*CTS)
+	 * calculate freq in 0.1kHz unit
+	 * freq = (unsigned long)8 * 2 * 10000 * HDMI_RTD_XTAL/ cts * n / ((unsigned long)b * 1000);
+	 */
+	freq->ACR_freq = ((((270000 * b)/256)/128) * n) / (cts);
+	freq->ACR_freq *= 100;
+	freq->ACR_freq = hdmi_audio_freq_correction(freq->ACR_freq);
+
+	/* HBR mode */
+	if (lib_hdmi_audio_get_hbr_manual_mode()) {
+		if (freq->ACR_freq != 192000) {
+			HDMI_PRINTF("WARNING!!! HBR need to equal 192K(%ld)\n", freq->ACR_freq);
+			freq->ACR_freq = 192000;
+		}
+	}
+
+	*track_mode = HDMI_AUDIO_N_CTS_TREND_BOUND;
+
+}
+
+unsigned char hdmi_audio_detect(void)
+{
+	#define MATCH_THRD	15
+	unsigned char result = FALSE;
+	HDMI_AUDIO_FREQ_T t, t2;
+	HDMI_AUDIO_TRACK_MODE track_mode;
+	static unsigned int spdif_freq;
+
+	if (((GET_H_VIDEO_FSM() != MAIN_FSM_HDMI_DISPLAY_ON) && (GET_H_VIDEO_FSM() != MAIN_FSM_HDMI_VIDEO_READY)) ||
+		(lib_hdmi_get_avmute() && !lib_hdmi_get_bch_2bit_error()) ||
+		(hdmi_rx.timing_t.tmds_clk_b < VALID_MIN_CLOCK)) {
+
+		lib_hdmi_audio_output(0);
+		SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		return FALSE;
+	}
+
+	switch (GET_H_AUDIO_FSM()) {
+	case AUDIO_FSM_AUDIO_START:
+		/* HDMI_PRINTF("AUDIO_FSM_AUDIO_START\n"); */
+		SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		lib_hdmi_audio_init();
+
+		lib_hdmi_audio_set_hbr_manual_mode(0, 0);
+		hdmi_rx.audio_t.sr_mismatch_cnt = 0;
+
+		/* Wait for audio sample packet */
+#if AUDIO_HBR_DETECT
+		if (!hdmi_audio_wait_2_samples())
+			break;
+#else
+		if (!hdmi_audio_wait_sample())
+			break;
+#endif
+
+		SET_H_AUDIO_FSM(AUDIO_FSM_FREQ_DETECT);
+
+		break;
+	case AUDIO_FSM_FREQ_DETECT:
+		HDMI_PRINTF("AUDIO_FSM_FREQ_DETECT\n");
+
+#ifdef HDMI_VIDEO_WD_ENABLE
+		hdmi_watchdog_apply(_DISABLE, HDMI_WD_AUDIO_COND);
+#endif
+
+		hdmi_audio_get_freq(&t, &track_mode);
+		hdmi_audio_get_freq(&t2, &track_mode);
+		HDMI_PRINTF("Hdmi_GetAudioFreq t=%ld\n", t.ACR_freq);
+		HDMI_PRINTF("Hdmi_GetAudioFreq t2=%ld\n", t2.ACR_freq);
+
+		if ((t.ACR_freq != 0) && (t.ACR_freq == t2.ACR_freq)) {
+			if (HDMI_ABS(t.ACR_freq, t.SPDIF_freq) > (t.ACR_freq/20)) {
+
+				HDMI_PRINTF("[HDMI] Freq in N/CTS and CS are not match!!(cnt=%d)\n",
+					hdmi_rx.audio_t.sr_mismatch_cnt);
+
+				if (lib_hdmi_audio_get_hbr_manual_mode()) {
+					/* HBRr mode */
+					HDMI_PRINTF("Audio HBR mode\n");
+				} else{
+					if (hdmi_rx.audio_t.sr_mismatch_cnt < MATCH_THRD) {
+						hdmi_rx.audio_t.sr_mismatch_cnt++;
+						break;
+					} else {
+						hdmi_rx.audio_t.sr_mismatch_cnt = 0;
+					}
+				}
+			}
+
+			if (hdmi_rx.audio_t.track_mode_tgl == 1) {
+				hdmi_rx.audio_t.track_mode_tgl = 0;
+				if (hdmi_audio_set_pll(t.ACR_freq, t.ACR_N, track_mode)) {
+					SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_WAIT_PLL_READY);
+					spdif_freq = t.SPDIF_freq;
+					break;
+				}
+			} else {
+				hdmi_rx.audio_t.track_mode_tgl = 1;
+				if (hdmi_audio_set_pll(t.ACR_freq, t.ACR_N, HDMI_AUDIO_TREND_BOUND)) {
+					SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_WAIT_PLL_READY);
+					spdif_freq = t.SPDIF_freq;
+					break;
+				}
+			}
+		} else {
+			if ((t.ACR_freq == 0)||(t2.ACR_freq == 0)) {
+				/* cts = 0,use t.SPDIF_freq and force to trend_boundary tracking */
+				if (hdmi_audio_set_pll(t.SPDIF_freq, t.ACR_N, HDMI_AUDIO_TREND_BOUND)) {
+					if (t.SPDIF_freq == t2.SPDIF_freq) {
+						SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_WAIT_PLL_READY);
+						spdif_freq = t.SPDIF_freq;
+						break;
+					}
+				}
+			}
+		}
+		break;
+	case AUDIO_FSM_AUDIO_WAIT_PLL_READY:
+		HDMI_PRINTF("AUDIO_FSM_AUDIO_WAIT_PLL_READY\n");
+
+		if (!hdmi_audio_is_pll_ready()) {
+			SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+			return FALSE;
+		}
+
+		SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START_OUT);
+		break;
+	case AUDIO_FSM_AUDIO_START_OUT:
+		HDMI_PRINTF("AUDIO_FSM_AUDIO_START_OUT\n");
+
+		lib_hdmi_audio_generate();
+		lib_hdmi_audio_output(1);
+
+#ifdef HDMI_VIDEO_WD_ENABLE
+		hdmi_watchdog_apply(_ENABLE, HDMI_WD_AUDIO_COND);
+#endif
+
+		SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_CHECK);
+		result = TRUE;
+
+		hdmi_rx.audio_t.coding_type = lib_hdmi_audio_get_format();
+		hdmi_rx.audio_t.audio_freq = spdif_freq;
+		hdmirx_state.audio_detect_done = 1;
+
+		break;
+	case AUDIO_FSM_AUDIO_CHECK:
+		hdmi_rx.audio_t.track_mode_tgl = 0;
+
+		if (!hdmi_audio_is_pll_ready()) {
+			lib_hdmi_audio_output(0);
+			SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		}
+
+		if (!lib_hdmi_audio_is_output()) {
+			lib_hdmi_audio_output(0);
+			SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		}
+
+		if (hdmi_rx.audio_t.coding_type != lib_hdmi_audio_get_format()) {
+			lib_hdmi_audio_output(0);
+			SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+			HDMI_PRINTF("Audio Type change=%d\n", lib_hdmi_audio_get_format());
+		}
+
+		if (GET_H_AUDIO_FSM() == AUDIO_FSM_AUDIO_START)
+			hdmirx_state.audio_detect_done = 0;
+
+		break;
+	default:
+		SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		break;
+	}
+
+	return result;
+}
+
+void hdmi_audio_close(void)
+{
+	lib_hdmi_audio_output(0);
+
+	SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+}
+
+void hdmi_audio_reset_status(void)
+{
+	SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+}
+
+unsigned char hdmi_audio_get_current_status(void)
+{
+	return GET_H_AUDIO_FSM();
+}
+
+/* Audio Clock Regeneration (N/CTS) */
+unsigned char hdmi_audio_wait_acr(void)
+{
+	
+	unsigned char i, bch_err;
+
+	lib_hdmi_set_rsv_packet_type(0, 0x01);
+	lib_hdmi_clear_rsv_packet0_status();
+
+	for (i = 0; i < 5; i++) {
+		if (hdmi_update_rsv0_packet(1, &bch_err)) {
+			/* acr no checksum bit, do not check */
+			return ((bch_err & 0x1f) == 0);
+		}
+		HDMI_DELAYMS(10);
+	}
+
+	return FALSE;
+}
+
+/* Audio Sample (L-PCM and IEC 61937 compressed formats) */
+unsigned char hdmi_audio_wait_sample(void)
+{
+	unsigned char i, buf[2];
+
+	lib_hdmi_set_rsv_packet_type(0, 0x02);
+	lib_hdmi_clear_rsv_packet0_status();
+
+	for (i = 0; i < 5; i++) {
+		if (hdmi_update_rsv0_packet(2, buf)) {
+			lib_hdmi_audio_set_hbr_manual_mode(1, 0);
+			return TRUE;
+		}
+		HDMI_DELAYMS(10);
+	}
+
+	return FALSE;
+}
+
+/* Audio Sample (02) (L-PCM and IEC 61937 compressed formats) */
+unsigned char hdmi_audio_wait_2_samples(void)
+{
+	/* HBR sample (09) */
+	unsigned char i, buf[9];
+
+	/* Is packet_02 in reserved_0? */
+	lib_hdmi_set_rsv_packet_type(0, 0x02);
+	lib_hdmi_clear_rsv_packet0_status();
+
+	/* Is packet_09 in reserved_1? */
+	lib_hdmi_set_rsv_packet_type(1, 0x09);
+	lib_hdmi_clear_rsv_packet1_status();
+
+	for (i = 0; i < 5; i++) {
+		if (hdmi_update_rsv1_packet(9, buf) || lib_hdmi_audio_get_hbr_mode()) {
+			lib_hdmi_audio_set_hbr_manual_mode(1, 1);
+			HDMI_PRINTF("Got HBR packet\n");
+			return TRUE;
+		}
+		HDMI_DELAYMS(10);
+	}
+
+	if (hdmi_update_rsv0_packet(2, buf)) {
+		/* follow up Merlin-1 setting, review this later */
+		lib_hdmi_audio_set_hbr_manual_mode(1, 0);
+		return TRUE;
+	}
+
+	return FALSE;
+}
+
+void Hdmi_SetHPD(char high)
+{
+	HDMIRX_INFO("Set HPD(%u)", high);
+
+	if (high)
+		gpio_direction_output(hdmi_rx.gpio_hpd_ctrl, 0);
+	else
+		gpio_direction_output(hdmi_rx.gpio_hpd_ctrl, 1);
+
+}
+
+
+void hdmi_check_connection_state(void)
+{
+	unsigned char conn_st;
+
+	// TODO: Move to 5V detect flow
+	conn_st = 1;
+
+	if (conn_st != hdmi_rx.rx_5v_state) {
+		if (conn_st) {
+			/* Reset CED until measure done */
+			lib_hdmi_char_err_rst(1);
+		} else {
+#if HDMI2p0
+			lib_hdmi2p0_reset_scdc();
+			lib_hdmi2p0_scramble_enable(0);
+#endif	
+			lib_hdmi_clear_avmute();
+
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+			lib_hdmi_set_toggle_hpd_z0_flag(FALSE);
+#endif
+
+			lib_hdmi_misc_variable_initial();
+		}
+	}
+
+	//hdmi_rx.cable_conn = conn_st;
+}
+
+
+void hdmi_reset_all_infoframe(void)
+{
+	memset(&hdmi_rx.vsi_t, 0, sizeof(HDMI_VSI_T));
+	hdmi_rx.no_vsi_cnt = 0;
+	lib_hdmi_clear_fvs_received_status();
+	lib_hdmi_clear_vs_received_status();
+
+	memset(&hdmi_rx.avi_t, 0, sizeof(HDMI_AVI_T));
+	hdmi_rx.no_avi_cnt = 0;
+	lib_hdmi_clear_avi_received_status();
+
+	memset(&hdmi_rx.spd_t, 0, sizeof(HDMI_SPD_T));
+	hdmi_rx.no_spd_cnt = 0;
+	lib_hdmi_clear_spd_received_status();
+
+	memset(&hdmi_rx.audiopkt_t, 0, sizeof(HDMI_AUDIO_T));
+	hdmi_rx.no_audiopkt_cnt = 0;
+	lib_hdmi_clear_audiopkt_received_status();
+
+	memset(&hdmi_rx.drm_t, 0, sizeof(HDMI_DRM_T));
+	hdmi_rx.no_drm_cnt = 0;
+	lib_hdmi_clear_drm_received_status();
+
+}
+
+void hdmi_update_infoframe(void)
+{
+	unsigned char is_drm_here = hdmi_rx.drm_t.type_code;
+	unsigned char is_avi_here = hdmi_rx.avi_t.type_code;
+	unsigned char is_spd_here = hdmi_rx.spd_t.type_code;
+	unsigned char is_audio_here = hdmi_rx.audiopkt_t.type_code;
+	unsigned char is_vsi_here = hdmi_rx.vsi_t.ver;/* vsi has 2 version-type (861-G) */
+
+	if (GET_H_VIDEO_FSM() < MAIN_FSM_HDMI_MEASURE || GET_H_MODE() != MODE_HDMI)
+		return;
+
+	if (hdmi_update_drm()) {
+		hdmi_rx.no_drm_cnt = 0;
+		hdmirx_state.hdr_received = 1;
+	} else {
+		if (++hdmi_rx.no_drm_cnt > NO_DRM_INFO_MAX) {
+			memset(&hdmi_rx.drm_t, 0, sizeof(HDMI_DRM_T));
+			hdmi_rx.no_drm_cnt = 0;
+			hdmirx_state.hdr_received = 0;
+		}
+	}
+
+	if (hdmi_update_avi()) {
+		hdmi_rx.no_avi_cnt = 0;
+	} else {
+		if (++hdmi_rx.no_avi_cnt > NO_AVI_INFO_MAX) {
+			memset(&hdmi_rx.avi_t, 0, sizeof(HDMI_AVI_T));
+			hdmi_rx.no_avi_cnt = 0;
+		}
+	}
+
+	if (hdmi_update_vsi()) {
+		hdmi_rx.no_vsi_cnt = 0;
+	} else {
+		if (++hdmi_rx.no_vsi_cnt > NO_VSI_INFO_MAX) {
+			memset(&hdmi_rx.vsi_t, 0, sizeof(HDMI_VSI_T));
+			hdmi_rx.no_vsi_cnt = 0;
+		}
+	}
+
+	if (hdmi_update_spd()) {
+		hdmi_rx.no_spd_cnt = 0;
+	} else {
+#if NO_SPD_CLEAR_PACKET
+		if (++hdmi_rx.no_spd_cnt > NO_SPD_INFO_MAX) {
+			memset(&hdmi_rx.spd_t, 0, sizeof(HDMI_SPD_T));
+			hdmi_rx.no_spd_cnt = 0;
+		}
+#endif
+	}
+
+	if (hdmi_update_audiopkt()) {
+		hdmi_rx.no_audiopkt_cnt = 0;
+	} else {
+		if (++hdmi_rx.no_audiopkt_cnt > NO_AUDIO_INFO_MAX) {
+			memset(&hdmi_rx.audiopkt_t, 0, sizeof(HDMI_AUDIO_T));
+			hdmi_rx.no_audiopkt_cnt = 0;
+		}
+	}
+
+	if (is_drm_here != hdmi_rx.drm_t.type_code) {
+		HDMI_PRINTF("DRM INFO=%d\n", hdmi_rx.drm_t.type_code);
+	}
+	if (is_avi_here != hdmi_rx.avi_t.type_code) {
+		HDMI_PRINTF("AVI INFO=%d\n", hdmi_rx.avi_t.type_code);
+	}
+	if (is_spd_here != hdmi_rx.spd_t.type_code) {
+		HDMI_PRINTF("SPD INFO=%d\n", hdmi_rx.spd_t.type_code);
+	}
+	if (is_audio_here != hdmi_rx.audiopkt_t.type_code) {
+		HDMI_PRINTF("AUD INFO=%d\n", hdmi_rx.audiopkt_t.type_code);
+	}
+	if (is_vsi_here != hdmi_rx.vsi_t.ver) {
+		HDMI_PRINTF("VSI INFO=%d (%x,%x,%x)\n",
+			hdmi_rx.vsi_t.ver, hdmi_rx.vsi_t.Reg_ID[0],
+			hdmi_rx.vsi_t.Reg_ID[1], hdmi_rx.vsi_t.Reg_ID[2]);
+		/*
+		 * 0xd8, 0x5d, 0xc4 is hdmi2.0 FVSPS (QD980 Forum VS)
+		 * 0x03, 0x0c, 0x00 is hdmi1.4 VSPS or Dolby (QD980 LLC VS)
+		 * QD980 has a bug, it needs to toggle & apply twice then send correct info.
+		 */
+	}
+
+}
+
+unsigned char hdmi_get_hdmi_mode_infoframe(void)
+{
+	if (GET_H_VIDEO_FSM() < MAIN_FSM_HDMI_DISPLAY_ON)
+		return 0;
+
+	if (GET_H_MODE() == MODE_HDMI)
+		return 1;
+
+	return 0;
+}
+
+unsigned char hdmi_get_vs_infoframe(HDMI_VSI_T *p_vsi_t)
+{
+	if ((GET_H_VIDEO_FSM() < MAIN_FSM_HDMI_MEASURE) ||
+		(GET_H_MODE() != MODE_HDMI))
+		return 0;
+
+	if (hdmi_rx.vsi_t.type_code == 0)
+		return 0;
+
+	memcpy(p_vsi_t, &hdmi_rx.vsi_t, sizeof(HDMI_VSI_T));
+	return 1;
+}
+
+unsigned char hdmi_get_avi_infoframe(HDMI_AVI_T *p_avi_t)
+{
+	if ((GET_H_VIDEO_FSM() < MAIN_FSM_HDMI_MEASURE) ||
+		(GET_H_MODE() != MODE_HDMI))
+		return 0;
+
+	if (hdmi_rx.avi_t.type_code == 0)
+		return 0;
+
+	memcpy(p_avi_t, &hdmi_rx.avi_t, sizeof(HDMI_AVI_T));
+	return 1;
+}
+
+unsigned char hdmi_get_spd_infoframe(HDMI_SPD_T *p_spd_t)
+{
+	if ((GET_H_VIDEO_FSM() < MAIN_FSM_HDMI_MEASURE) ||
+		(GET_H_MODE() != MODE_HDMI))
+		return 0;
+
+	if (hdmi_rx.spd_t.type_code == 0)
+		return 0;
+
+	memcpy(p_spd_t, &hdmi_rx.spd_t, sizeof(HDMI_SPD_T));
+	return 1;
+}
+
+unsigned char hdmi_get_audio_infoframe(HDMI_AUDIO_T *p_audio_t)
+{
+	if ((GET_H_VIDEO_FSM() < MAIN_FSM_HDMI_MEASURE) ||
+		(GET_H_MODE() != MODE_HDMI))
+		return 0;
+
+	if (hdmi_rx.audiopkt_t.type_code == 0)
+		return 0;
+
+	memcpy(p_audio_t, &hdmi_rx.audiopkt_t, sizeof(HDMI_AUDIO_T));
+	return 1;
+}
+
+unsigned char hdmi_get_drm_infoframe(HDMI_DRM_T *p_drm_t)
+{
+	if ((GET_H_VIDEO_FSM() < MAIN_FSM_HDMI_VIDEO_READY) ||
+		(GET_H_MODE() != MODE_HDMI))
+		return 0;
+
+	if (hdmi_rx.drm_t.type_code == 0)
+		return 0;
+
+	memcpy(p_drm_t, &hdmi_rx.drm_t, sizeof(HDMI_DRM_T));
+	return 1;
+}
+
+#define VSI_PKT_LEN      31
+#define VSI_PKT_CONT_LEN 12
+unsigned char hdmi_update_vsi(void)
+{
+	unsigned char sta_pos;
+	unsigned char len;
+	unsigned char pkt_buf[VSI_PKT_LEN] = {0};
+	unsigned char len_extend;
+
+#if HDMI2p0
+	if (lib_hdmi_is_fvs_received()) {
+		lib_hdmi_clear_fvs_received_status();
+		sta_pos = 253;
+		len = 11;
+	} else 
+#endif
+	if (lib_hdmi_is_vs_received()) {
+		lib_hdmi_clear_vs_received_status();
+		sta_pos = 203;
+		len = 18;
+	} else {
+		return FALSE;
+	}
+
+
+	lib_hdmi_read_packet_sram(sta_pos, len, pkt_buf);
+
+	/*
+	 * pkt_buf[0]; => version
+	 * pkt_buf[1]; => len
+	 * pkt_buf[2]; => checksum
+	 */
+
+	if (sta_pos == 203) {
+		if (pkt_buf[1] > 15) {
+			/* len > 15 */
+			len_extend = pkt_buf[1] - 15;
+
+			if(len_extend >= VSI_PKT_CONT_LEN)
+				lib_hdmi_read_packet_sram(323, VSI_PKT_CONT_LEN, &pkt_buf[18]);
+			else
+				lib_hdmi_read_packet_sram(323, len_extend, &pkt_buf[18]);
+
+			len = pkt_buf[1] + 3;
+		}
+	}
+	hdmi_rx.vsi_t.type_code = INFOFRAME_VSI;
+	/* use len for memcpy because copy size will be 11 or 18 */
+	memcpy(&hdmi_rx.vsi_t.ver, pkt_buf, len);
+
+	return TRUE;
+}
+
+#define AVI_PKT_LEN 	  16
+#define AVI_PKT_CONT_LEN  14
+#define AVI_PKT_TOTAL_LEN (AVI_PKT_LEN + AVI_PKT_CONT_LEN)
+unsigned char hdmi_update_avi(void)
+{
+	unsigned char pkt_buf[AVI_PKT_TOTAL_LEN] = {0};
+	unsigned char len_extend;
+
+	if (!lib_hdmi_is_avi_received())
+		return FALSE;
+
+	lib_hdmi_clear_avi_received_status();
+
+	lib_hdmi_read_packet_sram(1, AVI_PKT_LEN, pkt_buf);
+	pkt_buf[2] = pkt_buf[1];/* len */
+	pkt_buf[1] = pkt_buf[0];/* version */
+	pkt_buf[0] = INFOFRAME_AVI;
+
+	if (pkt_buf[2] > 13) {
+		len_extend = pkt_buf[2] - 13;
+
+		if (len_extend >= AVI_PKT_CONT_LEN)
+			lib_hdmi_read_packet_sram(335, AVI_PKT_CONT_LEN, &pkt_buf[16]);
+		else
+			lib_hdmi_read_packet_sram(335, len_extend, &pkt_buf[16]);
+	}
+
+	memcpy(&hdmi_rx.avi_t, pkt_buf, sizeof(HDMI_AVI_T));
+	return TRUE;
+}
+
+#define SPD_PKT_LEN	28
+unsigned char hdmi_update_spd(void)
+{	
+	unsigned char pkt_buf[SPD_PKT_LEN] = {0};
+
+	if (!lib_hdmi_is_spd_received())
+		return FALSE;
+
+	lib_hdmi_clear_spd_received_status();
+
+	lib_hdmi_read_packet_sram(295, SPD_PKT_LEN, pkt_buf);
+	pkt_buf[2] = pkt_buf[1];/* len */
+	pkt_buf[1] = pkt_buf[0];/* version */
+	pkt_buf[0] = INFOFRAME_SPD;
+
+	memcpy(&hdmi_rx.spd_t, pkt_buf, sizeof(HDMI_SPD_T));
+	return TRUE;
+}
+
+#define AUDIO_PKT_LEN 13
+unsigned char hdmi_update_audiopkt(void)
+{
+	unsigned char pkt_buf[AUDIO_PKT_LEN] = {0};
+
+	if (!lib_hdmi_is_audiopkt_received())
+		return FALSE;
+
+	lib_hdmi_clear_audiopkt_received_status();
+
+	lib_hdmi_read_packet_sram(18, AUDIO_PKT_LEN, pkt_buf);
+	pkt_buf[2] = pkt_buf[1];/* len */
+	pkt_buf[1] = pkt_buf[0];/* version */
+	pkt_buf[0] = INFOFRAME_AUDIO;
+
+	memcpy(&hdmi_rx.audiopkt_t, pkt_buf, AUDIO_PKT_LEN);
+	return TRUE;
+
+}
+
+#define DRM_PKT_LEN	29
+unsigned char hdmi_update_drm(void)
+{
+	unsigned char pkt_buf[DRM_PKT_LEN] = {0};
+
+	if (!lib_hdmi_is_drm_received())
+		return FALSE;
+
+	lib_hdmi_clear_drm_received_status();
+
+	lib_hdmi_read_packet_sram(265, DRM_PKT_LEN, pkt_buf);
+
+	((unsigned char*)(&hdmi_rx.drm_t))[2] = pkt_buf[1];/* len */
+	((unsigned char*)(&hdmi_rx.drm_t))[1] = pkt_buf[0];/* version */
+	((unsigned char*)(&hdmi_rx.drm_t))[0] = INFOFRAME_DRM;/* Info Frame Type */
+
+	hdmi_rx.drm_t.eEOTFtype  = pkt_buf[3];
+	hdmi_rx.drm_t.eMeta_Desc = pkt_buf[4];
+	hdmi_rx.drm_t.display_primaries_x0 = pkt_buf[5]|(pkt_buf[6]<<8);
+	hdmi_rx.drm_t.display_primaries_y0 = pkt_buf[7]|(pkt_buf[8]<<8);
+	hdmi_rx.drm_t.display_primaries_x1 = pkt_buf[9]|(pkt_buf[10]<<8);
+	hdmi_rx.drm_t.display_primaries_y1 = pkt_buf[11]|(pkt_buf[12]<<8);
+	hdmi_rx.drm_t.display_primaries_x2 = pkt_buf[13]|(pkt_buf[14]<<8);
+	hdmi_rx.drm_t.display_primaries_y2 = pkt_buf[15]|(pkt_buf[16]<<8);
+	hdmi_rx.drm_t.white_point_x = pkt_buf[17]|(pkt_buf[18]<<8);
+	hdmi_rx.drm_t.white_point_y = pkt_buf[19]|(pkt_buf[20]<<8);
+	hdmi_rx.drm_t.max_display_mastering_luminance = pkt_buf[21]|(pkt_buf[22]<<8);
+	hdmi_rx.drm_t.min_display_mastering_luminance = pkt_buf[23]|(pkt_buf[24]<<8);
+	hdmi_rx.drm_t.maximum_content_light_level = pkt_buf[25]|(pkt_buf[26]<<8);
+	hdmi_rx.drm_t.maximum_frame_average_light_level = pkt_buf[27]|(pkt_buf[28]<<8);
+
+	return TRUE;
+}
+
+
+unsigned char hdmi_update_rsv0_packet(unsigned char len, unsigned char *buf)
+{
+	if (!lib_hdmi_is_rsv_packet0_received())
+		return FALSE;
+
+	lib_hdmi_read_packet_sram(78, len, buf);
+	return TRUE;
+}
+
+unsigned char hdmi_update_rsv1_packet(unsigned char len, unsigned char *buf)
+{
+	if (!lib_hdmi_is_rsv_packet1_received())
+		return FALSE;
+
+	lib_hdmi_read_packet_sram(109, len, buf);
+	return TRUE;
+}
+
+unsigned char hdmi_update_rsv2_packet(unsigned char len, unsigned char *buf)
+{
+	if (!lib_hdmi_is_rsv_packet2_received())
+		return FALSE;
+
+	lib_hdmi_read_packet_sram(140, len, buf);
+	return TRUE;
+}
+
+unsigned char hdmi_update_rsv3_packet(unsigned char len, unsigned char *buf)
+{
+	if (!lib_hdmi_is_rsv_packet3_received())
+		return FALSE;
+
+	lib_hdmi_read_packet_sram(171, len, buf);
+	return TRUE;
+}
+
+
+unsigned char hdmi_check_spd_name(unsigned char *vendor_name)
+{
+	unsigned char i;
+
+	if (hdmi_rx.spd_t.type_code == 0)
+		return 0;
+
+#if 0
+	HDMI_PRINTF("VendorName [%x, %x, %x, %x, %x, %x, %x, %x]\n",
+		hdmi_rx.spd_t.VendorName[0], hdmi_rx.spd_t.VendorName[1],
+		hdmi_rx.spd_t.VendorName[2], hdmi_rx.spd_t.VendorName[3],
+		hdmi_rx.spd_t.VendorName[4], hdmi_rx.spd_t.VendorName[5],
+		hdmi_rx.spd_t.VendorName[6], hdmi_rx.spd_t.VendorName[7]);
+#endif
+
+	for (i = 0; i < 8; i++) {
+		if (hdmi_rx.spd_t.VendorName[i] != vendor_name[i])
+			return 0;
+	}
+
+	return 1;
+}
+
+unsigned char hdmi_check_spd_prod(unsigned char *prod_desc)
+{
+	unsigned char i;
+
+	if (hdmi_rx.spd_t.type_code == 0)
+		return 0;
+
+#if 0
+	HDMI_PRINTF("ProductDesc [%x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x]\n",
+		hdmi_rx.spd_t.ProductDesc[0], hdmi_rx.spd_t.ProductDesc[1],
+		hdmi_rx.spd_t.ProductDesc[2], hdmi_rx.spd_t.ProductDesc[3],
+		hdmi_rx.spd_t.ProductDesc[4], hdmi_rx.spd_t.ProductDesc[5],
+		hdmi_rx.spd_t.ProductDesc[6], hdmi_rx.spd_t.ProductDesc[7],
+		hdmi_rx.spd_t.ProductDesc[8], hdmi_rx.spd_t.ProductDesc[9],
+		hdmi_rx.spd_t.ProductDesc[10], hdmi_rx.spd_t.ProductDesc[11],
+		hdmi_rx.spd_t.ProductDesc[12], hdmi_rx.spd_t.ProductDesc[13],
+		hdmi_rx.spd_t.ProductDesc[14], hdmi_rx.spd_t.ProductDesc[15]);
+#endif
+
+	for (i = 0; i < 16; i++) {
+		if (hdmi_rx.spd_t.ProductDesc[i] != prod_desc[i])
+			return 0;
+	}
+
+	return 1;
+}
+
+
+unsigned char hdmi_compatibility_check(void)
+{
+	HDMI_POOR_DEV_T btv_stb = {
+		{0x42, 0x72, 0x6f, 0x61, 0x64, 0x63, 0x6f, 0x6d},
+		{0x53, 0x54, 0x42, 0x20, 0x52, 0x65, 0x66, 0x73, 0x77, 0x20, 0x44, 0x65, 0x73, 0x69, 0x67, 0x6e}};
+
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	/* [STB-14] KT UHD STB (IC1000) */
+	HDMI_POOR_DEV_T kt_stb_IC1000 = {
+		{0x4b, 0x61, 0x6f, 0x6e, 0x00, 0x63, 0x6f, 0x6d},
+		{0x49, 0x43, 0x31, 0x30, 0x30, 0x30, 0x00, 0x63, 0x65, 0x20, 0x42, 0x6f, 0x61, 0x72, 0x64, 0x00}};
+
+#endif
+#if HDMI_STR_TOGGLE_HPD_ENABLE
+	/* [STB-20] IC1100 - KT olleh GiGA UHD tv STB */
+	HDMI_POOR_DEV_T kt_stb_IC1100 = {
+		{0x4b, 0x61, 0x6f, 0x6e, 0x00, 0x63, 0x6f, 0x6d},
+		{0x49, 0x43, 0x31, 0x31, 0x30, 0x30, 0x00, 0x63, 0x65, 0x20, 0x42, 0x6f, 0x61, 0x72, 0x64, 0x00}};
+
+	HDMI_POOR_DEV_T kt_stb_GX_KT600EJ = {
+		{0x53, 0x61, 0x6d, 0x73, 0x75, 0x6e, 0x67, 0x0},
+		{0x47, 0x58, 0x2d, 0x4b, 0x54, 0x36, 0x30, 0x30, 0x45, 0x4a, 0x0, 0x6f, 0x61, 0x72, 0x64, 0x0}};
+#endif
+
+#if HDMI_DISPLAY_DELAY_ENABLE
+	/* LHB755 - LG */
+	HDMI_POOR_DEV_T LHB755 = {
+		{0x4d, 0x54, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x00},
+		{0x42, 0x44, 0x20, 0x50, 0x4c, 0x41, 0x59, 0x45, 0x52, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
+
+	HDMI_POOR_DEV_T Samsung_GX_HC630CH = {
+		{0x42, 0x72, 0x6f, 0x61, 0x64, 0x63, 0x6f, 0x6d},
+		{0x53, 0x54, 0x42, 0x20, 0x47, 0x58, 0x36, 0x33, 0x30, 0x43, 0x48, 0x0, 0x61, 0x72, 0x64, 0x0}};
+#endif /* End of #if HDMI_DISPLAY_DELAY_ENABLE */
+
+
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	lib_hdmi_set_toggle_hpd_z0_flag(FALSE);
+#endif
+
+#if HDMI_STR_TOGGLE_HPD_ENABLE
+	lib_hdmi_set_str_toggle_hpd_state(HDMI_STR_HPD_TOGGLE_NONE);
+#endif 
+
+	if (hdmi_check_spd_name(btv_stb.spd_vn_name) && hdmi_check_spd_prod(btv_stb.psd_pd_desc)) {
+		/* SKbox transient garbage */
+		HDMI_PRINTF("This is SKBOX!!!!!!!\n");
+		/* lib_hdmi_hdcp_port_write(0xC4, 0x8); */
+		lib_hdmi_set_specific_device(HDMI_SPECIFIC_DEVICE_SK_STB);
+	}
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	else if (hdmi_check_spd_name(kt_stb_IC1000.spd_vn_name) && hdmi_check_spd_prod(kt_stb_IC1000.psd_pd_desc)) {
+		/* SKbox transient garbage */
+		HDMI_PRINTF("This is KT STB IC1000 !!!!!!!\n");
+		lib_hdmi_set_toggle_hpd_z0_flag(TRUE);
+		lib_hdmi_dc_on_delay_check(TRUE);
+		lib_hdmi_set_specific_device(HDMI_SPECIFIC_DEVICE_KT_STB_IC1000);
+	}
+#endif
+#if HDMI_STR_TOGGLE_HPD_ENABLE
+	else if (hdmi_check_spd_name(kt_stb_IC1100.spd_vn_name) && hdmi_check_spd_prod(kt_stb_IC1100.psd_pd_desc)) {
+		/* KT STB and TV STR off/on, can not display */
+		HDMI_PRINTF("This is KT STB IC1100 !!!!!!!\n");
+		lib_hdmi_set_str_toggle_hpd_state(HDMI_STR_HPD_TOGGLE_ENTER);
+		lib_hdmi_set_specific_device(HDMI_SPECIFIC_DEVICE_KT_STB_IC1100);
+	} else if (hdmi_check_spd_name(kt_stb_GX_KT600EJ.spd_vn_name) && hdmi_check_spd_prod(kt_stb_GX_KT600EJ.psd_pd_desc)) {
+		/* KT STB and TV STR off/on, no signal */
+		HDMI_PRINTF("This is KT STB kt_stb_GX_KT600EJ !!!!!!!\n");
+		lib_hdmi_set_str_toggle_hpd_state(HDMI_STR_HPD_TOGGLE_ENTER);
+		lib_hdmi_set_specific_device(HDMI_SPECIFIC_DEVICE_KT_STB_KT600EJ);
+	}
+#endif/* End of #if HDMI_STR_TOGGLE_HPD_ENABLE */
+#if HDMI_DISPLAY_DELAY_ENABLE
+	else if (hdmi_check_spd_name(LHB755.spd_vn_name) && hdmi_check_spd_prod(LHB755.psd_pd_desc)) {
+		/* LHB755 - LG, change timing flicker */
+		HDMI_PRINTF("This is DVD LHB755 !!!!!!!\n");
+		lib_hdmi_set_delay_display_enable(_ENABLE);
+		lib_hdmi_set_specific_device(HDMI_SPECIFIC_DEVICE_LHB_755);
+
+		if (lib_hdmi_get_delay_display_state() == HDMI_DISPLAY_DELAY_NONE) {
+			lib_hdmi_set_delay_display_state(HDMI_DISPLAY_DELAY_INIT);
+			lib_hdmi_delay_check_before_display(TRUE);
+		}
+	}
+	else if (hdmi_check_spd_name(Samsung_GX_HC630CH.spd_vn_name) && hdmi_check_spd_prod(Samsung_GX_HC630CH.psd_pd_desc)) {
+		/* HDMI_SPECIFIC_DEVICE_SAMSUNG_GX_HC630CH change resolution flicker */
+		HDMI_PRINTF("This is SAMSUNG_GX_HC630CH !!!!!!!\n");
+		lib_hdmi_set_delay_display_enable(_ENABLE);
+		lib_hdmi_set_specific_device(HDMI_SPECIFIC_DEVICE_SAMSUNG_GX_HC630CH);
+
+		if (lib_hdmi_get_delay_display_state() == HDMI_DISPLAY_DELAY_NONE) {
+			lib_hdmi_set_delay_display_state(HDMI_DISPLAY_DELAY_INIT);
+			lib_hdmi_delay_check_before_display(TRUE);
+		}
+	} else if(0 == hdmi_rx.spd_t.type_code) {
+
+		if ((hdmi_rx.timing_t.h_act_len == 3840) &&
+			(hdmi_rx.timing_t.v_act_len == 2160) &&
+			(hdmi_rx.avi_t.VIC == 97)) {
+
+			if (hdmi_no_SPD_packetInfo() == TRUE) {
+
+				if (lib_hdmi_hdcp14_is_onoff() == _ENABLE) {
+					if ((GET_H_COLOR_SPACE() == COLOR_YUV420) && (GET_H_COLOR_DEPTH() == HDMI_COLOR_DEPTH_10B)) {
+						HDMI_PRINTF("This is GiGa_Genie_KAO_CT1100_LB @ 4K2K !!!!!!!\n");
+						lib_hdmi_set_delay_display_enable(_ENABLE);
+						lib_hdmi_set_specific_device(HDMI_SPECIFIC_DEVICE_KT_STB_KAO_CT1100);
+
+						if (lib_hdmi_get_delay_display_state() ==HDMI_DISPLAY_DELAY_NONE) {
+							lib_hdmi_set_delay_display_state(HDMI_DISPLAY_DELAY_INIT);
+							lib_hdmi_delay_check_before_display(TRUE);
+						}
+					}
+				}
+			}
+		}
+	}
+#endif/* End of #if HDMI_DISPLAY_DELAY_ENABLE */
+
+
+#if HDMI_AVI_INFO_COLORIMETRY_ENABLE
+	if (hdmi_check_avi_colorimetry_info(FALSE) == FALSE) {
+		SET_H_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+		return FALSE;
+	}
+#endif
+
+#if HDMI_CHECK_HDCP_ENABLE
+	if (hdmi_check_hdcp_condition(FALSE) == FALSE) {
+		SET_H_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+		return FALSE;
+	}
+#endif
+
+	hdmi_check_deb_condition_beforeDisp(FALSE);
+
+	return TRUE;
+
+}
+
+
+/* To fix blu-ray player, NS-BRDVD short time unstable */
+unsigned char hdmi_check_stable_before_display(void)
+{
+	if (bNeedDebBeforeDisp == 1) {
+		if( DispDebCnt > 0 ) {
+			HDMI_PRINTF("------>debouncing =%d, %d\n", bNeedDebBeforeDisp, DispDebCnt);
+			DispDebCnt--;
+			return FALSE;
+		}
+	}
+	bNeedDebBeforeDisp = 0;
+	DispDebCondition = 0;
+
+#if HDMI_DISPLAY_DELAY_ENABLE
+	lib_hdmi_set_delay_display_enable(_DISABLE);
+	lib_hdmi_set_delay_display_state(HDMI_DISPLAY_DELAY_NONE);
+#endif
+
+	if (GET_H_VIDEO_FSM() != MAIN_FSM_HDMI_VIDEO_READY) {
+		HDMI_PRINTF("B-check_mode_changed_1\n");
+		return FALSE;
+	}
+
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	if (lib_hdmi_dc_on_delay_check(FALSE) == FALSE)
+		return FALSE;
+#endif
+
+	if (hdmi_check_condition_change()) {
+		lib_hdmi_video_output(0);
+		lib_hdmi_audio_output(0);
+		HDMI_PRINTF("B-check_mode_changed_2\n");
+		return FALSE;
+	}
+
+#if HDMI_INT_PRO_CHG_FLAG_ENABLE
+	if (lib_hdmi_get_is_interlace_change() == TRUE) {
+		HDMI_PRINTF("B-interlace chg\n");
+		return FALSE;
+	}
+#else
+	if (GET_H_INTERLACE() != hdmi_get_interlace_conti_mode()) {
+		HDMI_PRINTF("B-interlace chg from %d to %d\n", GET_H_INTERLACE(), (!GET_H_INTERLACE()));
+		return FALSE;
+	}
+#endif
+
+	return TRUE;
+}
+
+
+unsigned char hdmi_watchdog_apply(unsigned char Enable, unsigned char Condition)
+{
+#ifdef HDMI_VIDEO_WD_ENABLE
+	UINT8 ucEnable_WatchDog = FALSE;
+	static UINT8 ucWatchDog_Mask = 0x00;
+
+	if (Enable == _ENABLE)
+		ucWatchDog_Mask = ucWatchDog_Mask | Condition;
+	else
+		ucWatchDog_Mask = ucWatchDog_Mask & (~Condition);
+
+	if ((ucWatchDog_Mask & (HDMI_WD_VIDEO_COND | HDMI_WD_AUDIO_COND | HDMI_WD_VSC_COND)) == HDMI_WD_ALL_COND)
+		ucEnable_WatchDog = TRUE;
+	else
+		ucEnable_WatchDog = FALSE;
+
+	if (GET_H_MODE() == MODE_DVI)
+		ucEnable_WatchDog = _DISABLE;
+
+	if (ucEnable_WatchDog == _ENABLE) {
+		lib_hdmi_wdm_enable(1);
+		lib_hdmi_auto_avmute_enable(1);
+	} else {
+		lib_hdmi_wdm_enable(0);
+		lib_hdmi_auto_avmute_enable(0);
+	}
+#endif/* End of #ifdef HDMI_VIDEO_WD_ENABLE */
+
+	return FALSE;
+}
+
+
+unsigned char hdmi_check_avi_colorimetry_info(unsigned char ucInit)
+{
+#if HDMI_AVI_INFO_COLORIMETRY_ENABLE
+	static unsigned char avi_debounce;
+
+	if(ucInit == TRUE) {
+		avi_debounce = HDMI_AVI_INFO_COLORIMETRY_DEBOUNCE_CNT;
+		return TRUE;
+	}
+
+	if (GET_H_MODE() == MODE_DVI)
+		return TRUE;
+
+	/* 160ms/times */
+	if (hdmi_rx.avi_t.type_code == 2) {
+
+		if (hdmi_rx.avi_t.len == 0) {
+			/* For other case */
+		} else {
+			if ((hdmi_rx.avi_t.EC == 0) && (hdmi_rx.avi_t.C == 0)) {
+				if (avi_debounce) {
+					/* Just for 2 depth = LG Bluray BP-550 + Speaker YAMAHA YSP-5600 special case, wait more time */
+					if((hdmi_rx.spd_t.VendorName[0] == 0x59) && (hdmi_rx.spd_t.VendorName[1] == 0x61)
+						&& (hdmi_rx.spd_t.VendorName[2] == 0x6d) && (hdmi_rx.spd_t.VendorName[3] == 0x61)
+						&& (hdmi_rx.spd_t.VendorName[4] == 0x68) && (hdmi_rx.spd_t.VendorName[5] == 0x61)
+						&& (hdmi_rx.spd_t.VendorName[6] == 0x00) && (hdmi_rx.spd_t.VendorName[7]) == 0x00) {
+
+						avi_debounce--;
+						HDMI_PRINTF("EC /C avi_debounce1=%x\n", avi_debounce);
+						return FALSE;
+					}
+#if 0
+					HDMI_PRINTF("VendorName [%x, %x, %x, %x, %x, %x, %x, %x]\n", hdmi_rx.spd_t.VendorName[0],
+						hdmi_rx.spd_t.VendorName[1], hdmi_rx.spd_t.VendorName[2],
+						hdmi_rx.spd_t.VendorName[3], hdmi_rx.spd_t.VendorName[4],
+						hdmi_rx.spd_t.VendorName[5], hdmi_rx.spd_t.VendorName[6],
+						hdmi_rx.spd_t.VendorName[7]);
+
+					HDMI_PRINTF("EC /C avi_debounce1 exit\n");
+#endif
+				}
+			}
+		}
+	}
+#endif/* End of #if HDMI_AVI_INFO_COLORIMETRY_ENABLE */
+
+	return TRUE;
+}
+
+
+unsigned char hdmi_no_SPD_packetInfo(void)
+{
+	if((hdmi_rx.spd_t.VendorName[0] == 0) && (hdmi_rx.spd_t.VendorName[1] == 0) &&
+		(hdmi_rx.spd_t.VendorName[2] == 0) && (hdmi_rx.spd_t.VendorName[3] == 0) &&
+		(hdmi_rx.spd_t.VendorName[4] == 0) && (hdmi_rx.spd_t.VendorName[5] == 0) &&
+		(hdmi_rx.spd_t.VendorName[6] == 0) && (hdmi_rx.spd_t.VendorName[7] == 0)) {
+
+		if((hdmi_rx.spd_t.ProductDesc[0] == 0) && (hdmi_rx.spd_t.ProductDesc[1] == 0) &&
+			(hdmi_rx.spd_t.ProductDesc[2] == 0) && (hdmi_rx.spd_t.ProductDesc[3] == 0) &&
+			(hdmi_rx.spd_t.ProductDesc[4] == 0) && (hdmi_rx.spd_t.ProductDesc[5] == 0) &&
+			(hdmi_rx.spd_t.ProductDesc[6] == 0) && (hdmi_rx.spd_t.ProductDesc[7] == 0) &&
+			(hdmi_rx.spd_t.ProductDesc[8] == 0) && (hdmi_rx.spd_t.ProductDesc[9] == 0) &&
+			(hdmi_rx.spd_t.ProductDesc[10] == 0) && (hdmi_rx.spd_t.ProductDesc[11] == 0) &&
+			(hdmi_rx.spd_t.ProductDesc[12] == 0) && (hdmi_rx.spd_t.ProductDesc[13] == 0) &&
+			(hdmi_rx.spd_t.ProductDesc[14] == 0) && (hdmi_rx.spd_t.ProductDesc[15] == 0))
+			return TRUE;
+	}
+	return FALSE;
+}
+
+
+unsigned char hdmi_check_deb_condition_beforeDisp(unsigned char ucInit)
+{
+	unsigned int cur_v_act_len = hdmi_rx.timing_t.v_act_len;
+	unsigned int cur_h_act_len = hdmi_rx.timing_t.h_act_len;
+
+	if (ucInit == TRUE) {
+		if (bNeedDebBeforeDisp == 0 ) {
+			DispDebCnt = 0;
+		}
+		return TRUE;
+	}
+
+	if (((cur_h_act_len == 1280 && cur_v_act_len == 720) || (cur_h_act_len ==1360 && cur_v_act_len == 768)
+		||(cur_h_act_len ==1920 && cur_v_act_len == 540) || (cur_h_act_len == 3840 && cur_v_act_len == 2160))
+		&& (lib_hdmi_hdcp14_is_onoff() == _ENABLE)
+		&& (hdmi_no_SPD_packetInfo() == TRUE)) {
+
+		HDMI_PRINTF("...............checking h/v= (%d, %d) [%d-%d], c=%d, vic=%d\n",
+			cur_h_act_len, cur_v_act_len, bNeedDebBeforeDisp, DispDebCondition, DispDebCnt, hdmi_rx.avi_t.VIC);
+
+		//deb start point: condition1
+		if( (cur_h_act_len==1360 && cur_v_act_len == 768) && (bNeedDebBeforeDisp == 0) && (hdmi_rx.avi_t.VIC == 0))
+		{
+			bNeedDebBeforeDisp = 1;
+			DispDebCnt = DISP_DEB_CNT_APPLETV;
+			DispDebCondition = 1;
+
+			HDMI_PRINTF("**************************** disp deb start1!!\n");
+		}
+
+		//deb again: condition2 =1360x768->1280x720
+		if((cur_h_act_len==1280 && cur_v_act_len == 720) && (DispDebCondition==1))
+		{
+			DispDebCnt = DISP_DEB_CNT_APPLETV;
+			DispDebCondition = 2;
+
+			HDMI_PRINTF("**************************** disp deb start2!!\n");
+		}
+
+		//LewisLee DATE:2016/12/22
+		//WOSQRTK-10354, PC40000
+		// 3840x2160 timing, HDMI cable plug in/out will flicker
+		if( (cur_h_act_len == 3840 && cur_v_act_len == 2160) && (bNeedDebBeforeDisp == 0) && (hdmi_rx.avi_t.VIC == 0))
+		{
+			bNeedDebBeforeDisp = 1;
+			DispDebCnt = DISP_DEB_CNT_PC40000;
+			DispDebCondition = 3;
+
+			HDMI_PRINTF("**************************** disp deb start3!!\n");
+		}
+	}
+	else {
+
+		DispDebCondition = 0;
+		DispDebCnt = 0;
+		bNeedDebBeforeDisp = 0;
+	}
+
+	return TRUE;
+}
+
+//==========================================
+
+//USER:LewisLee Date:2016/10/08
+//Fix TV power on, PS 4 flocker
+//No HDCP => stable clock => display => HDCP => flicker => display
+unsigned char hdmi_check_hdcp_condition(unsigned char ucInit)
+{
+#if HDMI_CHECK_HDCP_ENABLE
+	hdmi_p0_port0_hdcp_flag1_RBUS hdmi_p0_port0_hdcp_flag1_reg;
+	static unsigned char HDCP_debounce;
+
+	if (ucInit == TRUE) {
+		HDCP_debounce = HDMI_HDCP_DEBOUNCE_CNT;
+		return TRUE;
+	}
+
+	if (GET_H_MODE() == MODE_DVI)
+		return TRUE;
+
+	if (HDCP_debounce == 0)
+		return TRUE;
+
+#if 0
+	HDMI_PRINTF("VendorName [%x, %x, %x, %x, %x, %x, %x, %x]\n", hdmi_rx.spd_t.VendorName[0],
+		hdmi_rx.spd_t.VendorName[1], hdmi_rx.spd_t.VendorName[2],
+		hdmi_rx.spd_t.VendorName[3], hdmi_rx.spd_t.VendorName[4],
+		hdmi_rx.spd_t.VendorName[5], hdmi_rx.spd_t.VendorName[6],
+		hdmi_rx.spd_t.VendorName[7]);
+
+	HDMI_PRINTF("ProductDesc [%x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x, %x]\n",
+		hdmi_rx.spd_t.ProductDesc[0], hdmi_rx.spd_t.ProductDesc[1],
+		hdmi_rx.spd_t.ProductDesc[2], hdmi_rx.spd_t.ProductDesc[3],
+		hdmi_rx.spd_t.ProductDesc[4], hdmi_rx.spd_t.ProductDesc[5],
+		hdmi_rx.spd_t.ProductDesc[6], hdmi_rx.spd_t.ProductDesc[7],
+		hdmi_rx.spd_t.ProductDesc[8], hdmi_rx.spd_t.ProductDesc[9],
+		hdmi_rx.spd_t.ProductDesc[10], hdmi_rx.spd_t.ProductDesc[11],
+		hdmi_rx.spd_t.ProductDesc[12], hdmi_rx.spd_t.ProductDesc[13],
+		hdmi_rx.spd_t.ProductDesc[14], hdmi_rx.spd_t.ProductDesc[15] );
+#endif //#if 0
+
+	// 160ms/times
+	// VendorName = SCEI
+	if((hdmi_rx.spd_t.VendorName[0] == 0x53) && (hdmi_rx.spd_t.VendorName[1] == 0x43) &&
+		(hdmi_rx.spd_t.VendorName[2] == 0x45) && (hdmi_rx.spd_t.VendorName[3] == 0x49) &&
+		(hdmi_rx.spd_t.VendorName[4] == 0x00) && (hdmi_rx.spd_t.VendorName[5] == 0x00) &&
+		(hdmi_rx.spd_t.VendorName[6] == 0x00) && (hdmi_rx.spd_t.VendorName[7] == 0x00)) {
+
+		// ProductDesc = PS4
+		if((hdmi_rx.spd_t.ProductDesc[0] == 0x50) && (hdmi_rx.spd_t.ProductDesc[1] == 0x53)
+			&& (hdmi_rx.spd_t.ProductDesc[2] == 0x34) && (hdmi_rx.spd_t.ProductDesc[3] == 0x00)
+			&& (hdmi_rx.spd_t.ProductDesc[4] == 0x00) && (hdmi_rx.spd_t.ProductDesc[5] == 0x00)
+			&& (hdmi_rx.spd_t.ProductDesc[6] == 0x00) && (hdmi_rx.spd_t.ProductDesc[7] == 0x00)
+			&& (hdmi_rx.spd_t.ProductDesc[8] == 0x00) && (hdmi_rx.spd_t.ProductDesc[9] == 0x00)
+			&& (hdmi_rx.spd_t.ProductDesc[10] == 0x00) && (hdmi_rx.spd_t.ProductDesc[11] == 0x00)
+			&& (hdmi_rx.spd_t.ProductDesc[12] == 0x00) && (hdmi_rx.spd_t.ProductDesc[13] == 0x00)
+			&& (hdmi_rx.spd_t.ProductDesc[14] == 0x00) && (hdmi_rx.spd_t.ProductDesc[15]) == 0x00) {
+
+				hdmi_p0_port0_hdcp_flag1_reg.regValue = hdmi_rx_reg_read32(HDCP_FLAG1, HDMI_RX_MAC);
+
+				if((hdmi_p0_port0_hdcp_flag1_reg.wr_aksv_flag == 0) && (0 == hdmi_p0_port0_hdcp_flag1_reg.rd_ri_flag)) {
+					//Need check HDCP 1.4 or 2.2
+					HDCP_debounce--;
+
+					HDMI_PRINTF("[HDCP] HDCP_debounce=%x\n", HDCP_debounce);
+					if (lib_hdmi_hdcp14_is_onoff() == _ENABLE)
+						return FALSE;
+				}
+			}
+	}
+
+	HDCP_debounce = 0; // need check it can clear in here or not
+
+//	HDMI_PRINTF("[HDCP] HDCP_debounce exit\n");
+#endif //#if HDMI_CHECK_HDCP_ENABLE
+
+	return TRUE;
+}
+
+
+unsigned char hdmi_get_avmute(void)
+{
+	if (GET_H_VIDEO_FSM() == MAIN_FSM_HDMI_VIDEO_READY) {
+		if (lib_hdmi_get_avmute() && !lib_hdmi_get_bch_2bit_error()) {
+			HDMI_PRINTF("This is AVMUTE\n");
+			return TRUE;
+		}
+	}
+
+	return FALSE;
+}
+
+
+/*********************************************************************************
+*
+*	hdmi_lib.c
+*
+*********************************************************************************/
+
+void lib_hdmi_power(unsigned char enable)
+{
+
+	if (enable) {
+		/* Enable PLL TMDS, RGB clock output */
+		hdmi_rx_reg_mask32(HDMI_TMDS_OUTCTL,
+			~(HDMI_TMDS_OUTCTL_tbcoe_mask | HDMI_TMDS_OUTCTL_tgcoe_mask | HDMI_TMDS_OUTCTL_trcoe_mask | HDMI_TMDS_OUTCTL_ocke_mask),
+			(HDMI_TMDS_OUTCTL_tbcoe(1) | HDMI_TMDS_OUTCTL_tgcoe(1) | HDMI_TMDS_OUTCTL_trcoe(1) | HDMI_TMDS_OUTCTL_ocke(1)),
+			HDMI_RX_MAC);
+		hdmi_rx_reg_mask32(LDO, ~LDO_reg_p0_ldo_pow_mask, LDO_reg_p0_ldo_pow_mask, HDMI_RX_PHY);
+
+
+		lib_hdmi_z0_set(LN_ALL, 1);
+
+		hdmi_rx_reg_mask32(MBIAS,
+			~MBIAS_reg_mbias_en_mask, MBIAS_reg_mbias_en_mask, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(Z0POW,
+			~Z0POW_reg_z0_z300pow_mask, Z0POW_reg_z0_z300pow(1), HDMI_RX_PHY);
+
+	} else {
+		/* Disable PLL TMDS, RGB clock output */
+		hdmi_rx_reg_mask32(HDMI_TMDS_OUTCTL,
+			~(HDMI_TMDS_OUTCTL_tbcoe_mask | HDMI_TMDS_OUTCTL_tgcoe_mask | HDMI_TMDS_OUTCTL_trcoe_mask | HDMI_TMDS_OUTCTL_ocke_mask),
+			(HDMI_TMDS_OUTCTL_tbcoe(0) | HDMI_TMDS_OUTCTL_tgcoe(0) | HDMI_TMDS_OUTCTL_trcoe(0) | HDMI_TMDS_OUTCTL_ocke(0)),
+			HDMI_RX_MAC);
+
+		lib_hdmi_z0_set(LN_ALL, 0);
+
+		hdmi_rx_reg_mask32(MBIAS, ~MBIAS_reg_mbias_en_mask, 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(Z0POW, ~Z0POW_reg_z0_z300pow_mask, Z0POW_reg_z0_z300pow(0), HDMI_RX_PHY);
+	}
+
+}
+
+void lib_hdmi_tmds_init(void)
+{
+	hdmi_rx_reg_mask32(HDMI_PORT_SWITCH,
+		~HDMI_PORT_SWITCH_port_sel_mask,
+		HDMI_PORT_SWITCH_port_sel(0), HDMI_RX_MAC);
+
+	/* Port0 select */
+	hdmi_rx_reg_mask32(MD,
+		~MD_reg_ck_ckdet_mask, MD_get_reg_ck_ckdet(1), HDMI_RX_PHY);
+
+	/* Enable TMDS input */
+	hdmi_rx_reg_mask32(HDMI_TMDS_PWDCTL,
+		~(HDMI_TMDS_PWDCTL_ebip_mask|HDMI_TMDS_PWDCTL_egip_mask|HDMI_TMDS_PWDCTL_erip_mask|HDMI_TMDS_PWDCTL_ecc_mask),
+		(HDMI_TMDS_PWDCTL_ebip_mask|HDMI_TMDS_PWDCTL_egip_mask|HDMI_TMDS_PWDCTL_erip_mask|HDMI_TMDS_PWDCTL_ecc_mask),
+		HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_VCR,
+		~HDMI_VCR_iclk_sel_mask, HDMI_VCR_iclk_sel(0), HDMI_RX_MAC);
+	/* Measure input clock source sel */
+	hdmi_rx_reg_mask32(HDMI_TMDS_CPS,
+		~HDMI_TMDS_CPS_clkv_meas_sel_mask, HDMI_TMDS_CPS_clkv_meas_sel(3), HDMI_RX_MAC);
+
+}
+
+void lib_hdmi_mac_init(void)
+{
+	hdmi_rx_reg_mask32(HDMI_PHY_FIFO_CR1,
+		~((HDMI_PHY_FIFO_CR1_port0_bclk_inv_mask|HDMI_PHY_FIFO_CR1_port0_gclk_inv_mask|HDMI_PHY_FIFO_CR1_port0_rclk_inv_mask)),
+		(HDMI_PHY_FIFO_CR1_port0_bclk_inv_mask|HDMI_PHY_FIFO_CR1_port0_gclk_inv_mask|HDMI_PHY_FIFO_CR1_port0_rclk_inv_mask),
+		HDMI_RX_MAC);
+
+	lib_hdmi_mac_afifo_enable();
+
+	/* 20161018: SL8800 HDCP CTS1.4, contiune test without disconnect tmds_clock */
+	/* hdcp cts1.4 : Bstatus (MSB): 0x00 */
+	hdmi_rx_reg_write32(HDMI_SCR, 0x163, HDMI_RX_MAC);
+	/* Enable Audio FIFO */
+	hdmi_rx_reg_mask32(HDMI_AFCR,
+		~(HDMI_AFCR_audio_test_enable_mask|0x07), 0x06, HDMI_RX_MAC);
+	/* Enable video & audio output */
+	hdmi_rx_reg_write32(HDMI_AVMCR, 0x48, HDMI_RX_MAC);
+	/* Disable watch dog */
+	hdmi_rx_reg_write32(HDMI_WDCR0, 0x00, HDMI_RX_MAC);
+
+
+#if HDMI2p0
+	hdmi_rx_reg_mask32(HDMI_SCDC_CR,
+		~HDMI_SCDC_CR_scdc_en_mask, HDMI_SCDC_CR_scdc_en_mask, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_2P0_CR,
+		~HDMI_2P0_CR_hdmi_2p0_en_mask,
+		HDMI_2P0_CR_hdmi_2p0_en_mask, HDMI_RX_MAC);
+	/*  HDMI2.0/10.4.1.2/Sink Devices compliant with this version of the specification shall set Sink Version = 1 */
+	lib_hdmi_scdc_write(0x01, 0x01);
+#endif
+
+	hdmi_rx_reg_mask32(HDMI_HDCP_PCR,
+		~(HDMI_HDCP_PCR_km_clk_sel_mask|HDMI_HDCP_PCR_hdcp_vs_sel_mask),
+		(HDMI_HDCP_PCR_km_clk_sel_mask|HDMI_HDCP_PCR_hdcp_vs_sel_mask), HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_VCR,
+		~(HDMI_VCR_prdsam_mask|HDMI_VCR_csam_mask),
+		HDMI_VCR_prdsam(1)|HDMI_VCR_csam(1), HDMI_RX_MAC);
+
+	hdmi_rx_reg_write32(HDMI_MAGCR0, 0xE000, HDMI_RX_MAC);
+
+	hdmi_rx_reg_write32(HDMI_INTCR, 0, HDMI_RX_MAC);
+	/* Not inverse EVEN/ODD */
+	hdmi_rx_reg_mask32(HDMI_VCR, ~(HDMI_VCR_eoi_mask), 0, HDMI_RX_MAC);
+	/* Disable packet variation Watch Dog */
+	hdmi_rx_reg_mask32(HDMI_PAMICR, ~HDMI_PAMICR_icpvsb_mask, 0x00, HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_TMDS_ERRC,
+		~HDMI_TMDS_ERRC_nl_mask, HDMI_TMDS_ERRC_nl(3), HDMI_RX_MAC);
+	/*  Enable BCH Function */
+	hdmi_rx_reg_mask32(HDMI_BCHCR,
+		~(HDMI_BCHCR_pe_mask|HDMI_BCHCR_bche_mask|HDMI_BCHCR_enrwe_mask|HDMI_BCHCR_spcss_mask),
+		(HDMI_BCHCR_pe_mask|HDMI_BCHCR_bche_mask|HDMI_BCHCR_enrwe_mask|HDMI_BCHCR_spcss_mask),
+		HDMI_RX_MAC);
+	/* Clear Audio Watch Dog and Set X: 15 */
+	hdmi_rx_reg_mask32(HDMI_WDCR0, ~0xFFDF9E, 0x00, HDMI_RX_MAC);
+
+#if MEASURE_FROM_TMDS_CLOCK
+	hdmi_rx_reg_mask32(HDMI_CTS_FIFO_CTL,
+		~(HDMI_CTS_FIFO_CTL_offms_clock_sel_mask), 0x0, HDMI_RX_MAC);
+#else
+	hdmi_rx_reg_mask32(HDMI_CTS_FIFO_CTL,
+		~(HDMI_CTS_FIFO_CTL_offms_clock_sel_mask),
+		HDMI_CTS_FIFO_CTL_offms_clock_sel_mask, HDMI_RX_MAC);
+#endif
+
+	/* Reset CED until measure done */
+	lib_hdmi_char_err_rst(1);
+
+	/* When ac on, need this for hdcp auth, otherwise no clock in MSHG-800 */
+	lib_hdmi_mac_release();
+
+}
+
+unsigned char lib_hdmi_hdcp14_is_onoff(void)
+{
+	unsigned char hdcp_en;
+
+	hdcp_en = HDMI_HDCP_CR_get_hdcp_en(hdmi_rx_reg_read32(HDMI_HDCP_CR, HDMI_RX_MAC));
+	return hdcp_en;
+}
+
+void lib_hdmi_meas_select_port(void)
+{
+	hdmi_rx_reg_mask32(HDMI_PORT_SWITCH,
+		~HDMI_PORT_SWITCH_offms_port_sel_mask,
+		HDMI_PORT_SWITCH_offms_port_sel(0), HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_rgb_status_ready(void)
+{
+	unsigned int rgb_cd;
+	unsigned char ready;
+
+	ready = 0;
+
+	rgb_cd = hdmi_rx_reg_read32(HDMI_TMDS_CTRL, HDMI_RX_MAC) & HDMI_TMDS_CTRL_rgbcd_mask;
+	if (rgb_cd == HDMI_TMDS_CTRL_rgbcd_mask)
+		ready = 1;
+
+	return ready;
+}
+
+void lib_hdmi_clear_rgb_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_TMDS_CTRL,
+		HDMI_TMDS_CTRL_rgbcd_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_vsync_checked(void)
+{
+	unsigned char i;
+
+	hdmi_rx_reg_write32(HDMI_TMDS_CTRL, HDMI_TMDS_CTRL_yo_mask, HDMI_RX_MAC);
+	for (i = 0; i < 15; i++) {
+		if (HDMI_TMDS_CTRL_get_yo(hdmi_rx_reg_read32(HDMI_TMDS_CTRL, HDMI_RX_MAC)))
+			return TRUE;
+
+		HDMI_DELAYUS(5000);
+	}
+
+	HDMI_PRINTF("[WARNING] Vsync cannot seen?\n");
+	return FALSE;
+}
+
+unsigned char lib_hdmi_get_color_depth(void)
+{
+	unsigned char cd;
+
+	cd = HDMI_TMDS_DPC0_dpc_cd(hdmi_rx_reg_read32(HDMI_TMDS_DPC0, HDMI_RX_MAC));
+	if (cd > 3)
+		return (cd-4);
+	else
+		return 0;
+}
+
+void lib_hdmi_clear_interlace_reg(void)
+{
+	unsigned int val;
+
+#if HDMI_INT_PRO_CHG_FLAG_ENABLE
+	val = hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC) & (~(HDMI_VCR_int_pro_chg_flag_mask|HDMI_VCR_eot_mask|HDMI_VCR_se_mask));
+	hdmi_rx_reg_write32(HDMI_VCR,
+		(val|HDMI_VCR_int_pro_chg_flag_mask|HDMI_VCR_eot_mask|HDMI_VCR_se_mask), HDMI_RX_MAC);
+#else
+	val = hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC) & (~(HDMI_VCR_int_pro_chg_flag_mask|HDMI_VCR_eot_mask|HDMI_VCR_se_mask));
+	hdmi_rx_reg_write32(HDMI_VCR, (val|HDMI_VCR_eot_mask|HDMI_VCR_se_mask), HDMI_RX_MAC);
+#endif
+
+	/* Reset vsync */
+	hdmi_rx_reg_write32(HDMI_TMDS_CTRL, HDMI_TMDS_CTRL_yo_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_get_is_interlace(HDMI_MS_T ms_mode)
+{
+	unsigned char i;
+
+	if (ms_mode == HDMI_MS_ONESHOT) {
+		lib_hdmi_clear_interlace_reg();
+		for (i = 0; i < 4; i++)
+			lib_hdmi_vsync_checked();
+	}
+
+	if (HDMI_VCR_get_se(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC))) {
+		lib_hdmi_clear_interlace_reg();
+		return 0;
+	} else {
+		return HDMI_VCR_get_eot(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+	}
+}
+
+unsigned char lib_hdmi_get_is_interlace_change(void)
+{
+#if HDMI_INT_PRO_CHG_FLAG_ENABLE
+	if (HDMI_VCR_get_int_pro_chg_flag(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC)))
+		return TRUE;
+#endif
+
+	return FALSE;
+}
+
+void lib_hdmi_set_repeat_manual(unsigned char rep_value)
+{
+	unsigned int val;
+
+	val = hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC) & (~(HDMI_VCR_int_pro_chg_flag_mask|HDMI_VCR_eot_mask|HDMI_VCR_se_mask|HDMI_VCR_prdsam_mask));
+	hdmi_rx_reg_write32(HDMI_VCR, val, HDMI_RX_MAC);
+
+	val &= ~HDMI_VCR_dsc_mask;
+	hdmi_rx_reg_write32(HDMI_VCR, val|HDMI_VCR_dsc(rep_value), HDMI_RX_MAC);
+}
+
+void lib_hdmi_set_repeat_auto(void)
+{
+	unsigned int val;
+
+	val = hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC) & (~(HDMI_VCR_int_pro_chg_flag_mask|HDMI_VCR_eot_mask|HDMI_VCR_se_mask));
+	hdmi_rx_reg_write32(HDMI_VCR, val|HDMI_VCR_prdsam_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_get_pixelrepeat(void)
+{
+	if (HDMI_VCR_get_prdsam(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC)))
+		return HDMI_VCR_get_dsc_r(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+	else
+		return HDMI_VCR_get_dsc(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+
+}
+
+void lib_hdmi_set_colorspace_manual(unsigned char color_space)
+{
+	unsigned int val;
+
+	val = hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC) & (~(HDMI_VCR_int_pro_chg_flag_mask|HDMI_VCR_eot_mask|HDMI_VCR_se_mask|HDMI_VCR_csam_mask));
+	hdmi_rx_reg_write32(HDMI_VCR, val, HDMI_RX_MAC);
+
+	HDMI_DELAYMS(20);
+
+	val &= ~HDMI_VCR_csc_mask;
+	hdmi_rx_reg_write32(HDMI_VCR, val|HDMI_VCR_csc(color_space), HDMI_RX_MAC);
+}
+
+void lib_hdmi_set_colorspace_auto(void)
+{
+	unsigned int val;
+
+	val = hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC) & (~(HDMI_VCR_int_pro_chg_flag_mask|HDMI_VCR_eot_mask|HDMI_VCR_se_mask));
+	hdmi_rx_reg_write32(HDMI_VCR, val|HDMI_VCR_csam_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_get_colorspace(void)
+{
+	unsigned char csc;
+
+	if (HDMI_VCR_get_csam(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC)))
+		csc = HDMI_VCR_get_csc_r(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+	else
+		csc = HDMI_VCR_get_csc(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+
+	return csc;
+}
+
+unsigned char lib_hdmi_is_hdmi_mode(void)
+{
+	unsigned char mode;
+	unsigned int scr_val;
+
+	mode = MODE_DVI;
+
+	scr_val = hdmi_rx_reg_read32(HDMI_SCR, HDMI_RX_MAC);
+	if (HDMI_SCR_get_mode(scr_val)) {
+		if (HDMI_SCR_get_msmode(scr_val))
+			mode = MODE_HDMI;
+		goto exit;
+	}
+
+	scr_val = hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC);
+	if (HDMI_SR_get_mode(scr_val))
+		mode = MODE_HDMI;
+
+exit:
+	return mode;
+}
+
+#define AVI_Data_BYTE4     7
+#define VSIF_PB4           209
+#define VSIF_PB5           210
+unsigned char lib_hdmi_get_vic(void)
+{
+	unsigned char reg_val;
+	unsigned char vic;
+
+	hdmi_rx_reg_write32(HDMI_PSAP, AVI_Data_BYTE4, HDMI_RX_MAC);
+
+	vic = (hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC)) & 0x7F;
+
+	if (vic == 0) {
+		/* Get extened VIC */
+		hdmi_rx_reg_write32(HDMI_PSAP, VSIF_PB4, HDMI_RX_MAC);
+		reg_val = hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC);
+
+		if ((reg_val>>5) == 1) {
+				/* HDMI_Video_Format==1 */
+				hdmi_rx_reg_write32(HDMI_PSAP, VSIF_PB5, HDMI_RX_MAC);
+				reg_val = hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC);
+				HDMIRX_DEBUG("Extended_VIC=%u", reg_val);
+				/* hdmi_vic_table 108~111 */
+				switch (reg_val) {
+				case 1:
+					vic = 108;
+					break;
+				case 2:
+					vic = 109;
+					break;
+				case 3:
+					vic = 110;
+					break;
+				case 4:
+					vic = 111;
+					break;
+				default:
+					vic = 0;
+					break;
+				}
+		}
+	} else if (vic > 107) {
+		vic = 0;
+	}
+
+	return vic;
+
+}
+
+unsigned char lib_hdmi_get_video_format(void)
+{
+	unsigned char format;
+
+	format = HDMI_VIDEO_FORMAT_get_hvf(hdmi_rx_reg_read32(HDMI_VIDEO_FORMAT, HDMI_RX_MAC));
+	return format;
+}
+
+unsigned char lib_hdmi_get_3d_structure(void)
+{
+	unsigned char _3d_struct;
+
+	_3d_struct = HDMI_3D_FORMAT_get_hdmi_3d_structure(hdmi_rx_reg_read32(HDMI_3D_FORMAT, HDMI_RX_MAC));
+	return _3d_struct;
+}
+
+/**
+ * lib_hdmi_get_3d_extdata
+ *
+ * Return:
+ * 3D Ext Data
+ * Horizontal sub-sampling
+ * 0000:Odd/Left picture, Odd/Right picture
+ * 0001:Odd/Left picture, Even/Right picture
+ * 0010:Even/Left picture, Odd/Right picture
+ * 0011:Even/Left picture, Even/Right picture
+ * Quincunx matrix
+ * 0100:Odd/Left picture, Odd/Right picture
+ * 0101:Odd/Left picture, Even/Right picture
+ * 0110:Even/Left picture, Odd/Right picture
+ * 0111:Even/Left picture, Even/Right picture
+ */
+unsigned char lib_hdmi_get_3d_extdata(void)
+{
+	unsigned char _3d_extdata;
+
+	_3d_extdata = HDMI_3D_FORMAT_get_hdmi_3d_ext_data(hdmi_rx_reg_read32(HDMI_3D_FORMAT, HDMI_RX_MAC));
+	return _3d_extdata;
+}
+
+/**
+ * lib_hdmi_get_vsi_vic
+ *
+ * Return:
+ * HDMI_VIC
+ * 0x01:4Kx2K@30Hz
+ * 0x02:4Kx2K@25Hz
+ * 0x03:4Kx2K@24Hz
+ * 0x04:4Kx2K@24Hz(SMPTE)
+ */
+unsigned char lib_hdmi_get_vsi_vic(void)
+{
+	unsigned char vsi_vic;
+
+	vsi_vic = HDMI_VIDEO_FORMAT_get_hdmi_vic(hdmi_rx_reg_read32(HDMI_VIDEO_FORMAT, HDMI_RX_MAC));
+	return vsi_vic;
+}
+
+
+#define FVCO_MIN  250
+#define FVCO_MAX  500
+unsigned char lib_hdmi_set_video_pll(unsigned int b_clk, unsigned char cd, unsigned char is_interlace, unsigned char is_420)
+{
+	/*
+	 * Fin =   Fxtal * b / 256
+	 * Target vco = ( Fin * m / n )     , TagretVco_HB = 500 ,  TagretVco_LB=250
+	 * Fin * m / n / 2^o / 2 * s = pixel clock = Fin * [24/30, 24/36, 24/48] ,  [10bits, 12bits,16bits]
+	 *
+	 * FVCO = Fin * m / n
+	 * Fin = TMDS clock = pixel clock * SN/SM   --> pixel clock = Fin * SM / SN
+	 * pixel clock = FVCO / 2^o / 2*s
+	 * Fin * SM / SN = FVCO / 2^o / 2*s
+	 * FVCO = Fin *  2^o * 2*s * SM/SN
+	 * FVCO = Fin * 2^o * s * [24/30 * 2, 24/36 * 2, 24/48 * 2] --> Fin * 2^o * s * [8/5,4/3,1]
+	 * 250 <  ( Fin * m / n )  < 500  -->  250 <   Fin * 2^o * s * [ 8/5 , 4/3, 1 ]   < 500
+	 */
+	unsigned char enable_2x = 0;
+	unsigned int large_ratio, Smean, Stest, m, n, o, fvco;
+	unsigned long pixel_clockx1024;
+	unsigned int bpsin, fpfd1024;
+	unsigned int i, j, tabsize;
+	unsigned char dpll_rs, dpll_ip;
+
+
+	hdmi_rx_reg_mask32(HDMI_YUV420_CR, ~(HDMI_YUV420_CR_en_mask), 0, HDMI_RX_MAC);
+	HDMI_DELAYUS(1);
+	hdmi_rx_reg_mask32(HDMI_TMDS_DPC_SET0, ~(HDMI_TMDS_DPC_SET0_dpc_en_mask), 0, HDMI_RX_MAC);
+	HDMI_DELAYUS(1);
+	/* Disable PLL */
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~(HDMI_VPLLCR1_dpll_pow_mask|HDMI_VPLLCR1_dpll_vcorstb_mask|HDMI_VPLLCR1_dpll_stoppsw_mask),
+		0, HDMI_RX_MAC);
+	HDMI_DELAYUS(1);
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~(HDMI_VPLLCR1_dpll_rstb_mask), 0, HDMI_RX_MAC);
+	HDMI_DELAYUS(1);
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~(HDMI_VPLLCR1_dpll_freeze_mask),
+		HDMI_VPLLCR1_dpll_freeze_mask, HDMI_RX_MAC);
+
+	/*
+	 * tmds clock = b * 27 / 256
+	 * tmds clock = pixel clock * SN/SM --> b* 27 / 256 = pixel clock * SN/SM
+	 * pixel clock = b * 27 * M / (SN * 256)
+	 * pixel clock * 1024 = b * 27 * M * 1024 / (N * 256)
+	 */
+	pixel_clockx1024 = ((unsigned long)b_clk * 27 * dpll_ratio[cd].SM * 1024) / (dpll_ratio[cd].SN * 256);
+	HDMI_PRINTF("pixel_clock = %ld\n", pixel_clockx1024);
+	if (pixel_clockx1024 == 0) {
+		HDMI_PRINTF("[ERR] pixel_clockx1024 is zero=%d,%d\n", b_clk, cd);
+		return FALSE;
+	}
+
+	enable_2x = is_interlace;
+
+	if ((pixel_clockx1024 < (160 * 1024) && enable_2x == 0) || (is_420)) {
+		/* If pixel_clock is under 160MHz then enable 2X clock maybe for DI */
+		enable_2x = 1;
+	}
+
+
+	/* Interlace must 2x */
+	if (enable_2x) {
+		large_ratio = 2;
+		hdmi_rx_reg_mask32(HDMI_TMDS_CPS,
+			~HDMI_TMDS_CPS_pll_div2_en_mask,
+			HDMI_TMDS_CPS_pll_div2_en(1), HDMI_RX_MAC);
+	} else {
+		large_ratio = 1;
+		hdmi_rx_reg_mask32(HDMI_TMDS_CPS,
+			~HDMI_TMDS_CPS_pll_div2_en_mask,
+			HDMI_TMDS_CPS_pll_div2_en(0), HDMI_RX_MAC);
+	}
+
+
+	if  (cd || enable_2x) {
+		hdmi_rx_reg_mask32(HDMI_TMDS_DPC_SET0,
+			~HDMI_TMDS_DPC_SET0_dpc_bypass_dis_mask,
+			HDMI_TMDS_DPC_SET0_dpc_bypass_dis(1), HDMI_RX_MAC);
+	} else {
+		hdmi_rx_reg_mask32(HDMI_TMDS_DPC_SET0,
+			~HDMI_TMDS_DPC_SET0_dpc_bypass_dis_mask,
+			HDMI_TMDS_DPC_SET0_dpc_bypass_dis(0), HDMI_RX_MAC);
+	}
+
+	if (large_ratio != 1)
+		pixel_clockx1024 <<= 1;
+
+	/*
+	 *  s = smean
+	 * FVCO_MIN * 1024 / 2^o / 2s <= pixel_clock1024
+	 * (pixel_clock1024 * 2^o) * 2s >= FVCO_MIN * 1024
+	 * (pixel_clock1024 * 2) * 2s >= FVCO_MIN * 1024
+	 * ex: s = 0 , 2s = Stest = 1 (no div)
+	 * ex: s = 1 , 2s = Stest = 2 (div 2)
+	 */
+	o = 1;
+	Smean = 0;
+	Stest = 1;
+	while (pixel_clockx1024 <= (200*1024)) {
+		if (Smean == 0)
+			Stest = 1;
+		else
+			Stest = Smean * 2;
+		/* 2---> 2^o */
+		if (((pixel_clockx1024*2)*Stest) >= (FVCO_MIN*1024))
+			break;
+		Smean++;
+	};
+
+	if (pixel_clockx1024 > (200*1024)) {
+		/* >200MHz */
+		o = 0;
+		Smean = 0;
+	}
+#if 0
+	else if (pixel_clockx1024 > (100*1024)) {
+		/* 100MHz ~200MHz */
+		o = 1;
+		Smean = 0;
+	} else if (pixel_clockx1024 > (50*1024)) {
+		/* 50MHz ~100MHz */
+		o = 1;
+		Smean = 1;
+	} else if (pixel_clockx1024 > (25*1024)) {
+		/* 25MHz ~50MHz */
+		o = 1;
+		Smean = 2;
+	} else {
+		/* 13.5MHz~25MHz */
+		o = 1;
+		Smean = 4;
+	}
+
+	HDMI_PRINTF("Smean =  %d\n", Smean);
+
+	if (Smean == 0)
+		Stest = 1;
+	else
+		Stest = Smean * 2;
+#endif
+
+	/*
+	 * FVCO = Fin * m / n
+	 * Fin = TMDS clock = pixel clock * SN/SM   --> pixel clock = Fin * SM / SN
+	 * pixel clock = FVCO / 2^o / 2*s *  (1/large_ratio)
+	 * Fin * SM / SN = FVCO / 2^o / 2*s * (1/large_ratio)
+	 * FVCO = Fin *  2^o * 2*s * SM/SN * large_ratio
+	 * Fin * m / n = Fin * 2^o * 2*s * SM/SN * large_ratio
+	 * m/n = 2^o * 2*s * SM/SN * large_ratio
+	 * when n determined, m = SM * (2*s) * n * large_ratio * 2^o / SN
+	 * m = (SM * (2*s) * n * large_ratio ) << o / SN
+	 */
+	n = 0;
+	do {
+		n += dpll_ratio[cd].RatioN;
+		m = ((dpll_ratio[cd].RatioM * Stest * n * large_ratio)<<o) / dpll_ratio[cd].RatioN;
+		/* HDMI_PRINTF( "step1%d %d\n", m, n); */
+	} while (n < 2);
+
+	/* M code must >= 6 */
+	while (m < 8) {
+		n += dpll_ratio[cd].RatioN;
+		m = ((dpll_ratio[cd].RatioM * Stest * n * large_ratio)<<o) / dpll_ratio[cd].RatioN;
+		/* HDMI_PRINTF( "step2:%d %d\n", m, n); */
+	}
+
+
+	if (n > 8) {
+		n = 0;
+		do {
+			n += dpll_ratio[cd].RatioN;
+			m = ((dpll_ratio[cd].RatioM * Stest * n * large_ratio)<<o) / dpll_ratio[cd].RatioN;
+			/* HDMI_PRINTF( "step3:%d %d\n", m, n); */
+		} while (n < 2);
+	}
+
+
+	fvco = (b_clk * 27 * m) / (256 * n);
+
+
+	/* mag2 PLL bug  m min must > 1 , or PLL will crash */
+	while (m < 3) {
+		n <<= 1;
+		m <<= 1;
+	}
+	if (n > 9)
+		HDMI_PRINTF("[ERR] m=%d, n=%d > 9\n", m, n);
+
+	/* HDMI_PRINTF("***************TMDS=%d\n", b_clk); */
+	/* HDMI_PRINTF("***************cd=%d\n", cd); */
+	/* HDMI_PRINTF("***************m=%d\n", m); */
+	/* HDMI_PRINTF("***************n=%d\n", n); */
+	/* HDMI_PRINTF("***************o=%d\n", o); */
+	/* HDMI_PRINTF("***************s=%d\n", Smean); */
+	/* HDMI_PRINTF("***************fraction1=%d\n", fraction1); */
+	/* HDMI_PRINTF("***************fraction2=%d\n", fraction2); */
+	/* HDMI_PRINTF("***************pixel_clockx1024=%ld\n", pixel_clockx1024); */
+	/* HDMI_PRINTF("***************fvco=%d MHz\n", fvco); */
+	/* HDMI_PRINTF("***************larget=%d\n", large_ratio); */
+	HDMI_PRINTF("fvco=%d MHz\n", fvco);
+
+
+
+#if 0
+	/*
+	 * Icp x (N/M) x (27M/Fin) = 0.95uA
+	 * Icp x (N/M) x (27M/(27Mx1024/b) = 0.95
+	 * Icp x (N/M) x (b/1024) = 0.95
+	 * Icp x (N/M) x (b/1024) x 100 = 95
+	 * Icp = (Mx1024x95)/(Nxbx100)
+	 */
+	unsigned int fraction1, fraction2;
+
+	fraction1 = ((unsigned long)m*95*4*b_clk / (n*256*100));/* 2bit fractional part */
+	fraction2 = 0x00;
+	/* HDMI_PRINTF("***************fraction1=%d\n", fraction1); */
+
+	if (fraction1 >= 10)
+		fraction1 -= 10;
+
+	if (fraction1 >= 40) {
+		/* 2bit fractional part */
+		fraction1 -= 40;
+		fraction2 |= 0x04;
+	}
+
+	if (fraction1 >= 20) {
+		/* 2bit fractional part */
+		fraction1 -= 20;
+		fraction2 |= 0x02;
+	}
+
+	if (fraction1 >= 10) {
+		/* 2bit fractional part */
+		fraction1 -= 10;
+		fraction2 |= 0x01;
+	}
+	/* HDMI_PRINTF("***************fraction2=%d\n", fraction2); */
+	/* fraction2 |= 0x18; */
+
+#else
+
+	tabsize = sizeof(video_pll_main_param)/sizeof(VIDEO_DPLL_FIX_T);
+
+	/* Search main table */
+	for (i = 0; i < tabsize; ++i) {
+		if (((m - 2) == video_pll_main_param[i].dpll_M) && ((n - 2) == video_pll_main_param[i].dpll_N)) {
+			dpll_ip = video_pll_main_param[i].dpll_IP;
+			dpll_rs = video_pll_main_param[i].dpll_RS;
+			break;
+		}
+	}
+
+	/* Search other table,  if not fiind in main table */
+	if (i >= tabsize) {
+		/* fpfd = fin/(DPLL_BPSIN + (1-DPLL_BPSIN) * (DPLL_N+2)) */
+		bpsin = HDMI_VPLLCR0_get_dpll_bpsin(hdmi_rx_reg_read32(HDMI_VPLLCR0, HDMI_RX_MAC));
+
+		fpfd1024 = (b_clk * 27 * 1024 / 256) / (bpsin + ((1-bpsin) * n));
+
+		/* (13.5 - 0.3) * 1024 = 13516  ,  (40+0.3) * 1024 = 41267  (margin +- 0.3M) */
+		if ((fpfd1024 < 13516) || (fpfd1024 > 41267))/* margin +- 0.3M */
+			HDMI_PRINTF("[WARNING] fpfd is not correct range %d \n", fpfd1024);
+
+		for (j = 0; j < 4; ++j) {
+			if (((m - 2) >= video_pll_others_param[j].min_M) &&
+				((m - 2) <= video_pll_others_param[j].max_M)) {
+
+				dpll_ip = video_pll_others_param[j].dpll_IP;
+				dpll_rs = video_pll_others_param[j].dpll_RS;
+				break;
+			}
+		}
+
+		if (j == 4) {
+			dpll_ip = 2;
+			dpll_rs = 3;
+			HDMI_PRINTF("[ERROR] video pll table not find\n");
+		}
+	}
+
+
+	/* HDMI_PRINTF("***************ip=%d\n", dpll_ip); */
+	/* HDMI_PRINTF("***************rs=%d\n", dpll_rs); */
+
+#endif
+
+	/* Set video PLL parameter */
+	hdmi_rx_reg_write32(HDMI_VPLLCR0,
+		HDMI_VPLLCR0_dpll_m(m-2) | HDMI_VPLLCR0_dpll_o(o) |
+		HDMI_VPLLCR0_dpll_n(n-2) | HDMI_VPLLCR0_dpll_rs(dpll_rs) |
+		HDMI_VPLLCR0_dpll_ip(dpll_ip), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~(HDMI_VPLLCR1_dpll_cp_mask | HDMI_VPLLCR1_dpll_cs_mask),
+		HDMI_VPLLCR1_dpll_cp(1) | HDMI_VPLLCR1_dpll_cs(3), HDMI_RX_MAC);
+	/* Set video PLL output divider */
+	hdmi_rx_reg_write32(HDMI_MN_SCLKG_DIVS, Smean, HDMI_RX_MAC);
+	/* Video PLL double buffer load */
+	hdmi_rx_reg_mask32(HDMI_MN_SCLKG_CTRL,
+		~HDMI_MN_SCLKG_CTRL_sclkg_dbuf_mask,
+		HDMI_MN_SCLKG_CTRL_sclkg_dbuf_mask, HDMI_RX_MAC);
+	HDMI_DELAYUS(1);
+
+	/* Video PLL power enable */
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~(HDMI_VPLLCR1_dpll_ldo_pow_mask),
+		HDMI_VPLLCR1_dpll_ldo_pow_mask, HDMI_RX_MAC);
+	HDMI_DELAYUS(1);
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~(HDMI_VPLLCR1_dpll_pow_mask|HDMI_VPLLCR1_dpll_stoppsw_mask),
+		HDMI_VPLLCR1_dpll_pow_mask|HDMI_VPLLCR1_dpll_stoppsw_mask, HDMI_RX_MAC);
+	HDMI_DELAYUS(1);
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~HDMI_VPLLCR1_dpll_vcorstb_mask, HDMI_VPLLCR1_dpll_vcorstb_mask, HDMI_RX_MAC);
+	HDMI_DELAYUS(1);
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~HDMI_VPLLCR1_dpll_rstb_mask, HDMI_VPLLCR1_dpll_rstb_mask, HDMI_RX_MAC);
+	HDMI_DELAYUS(40);
+	hdmi_rx_reg_mask32(HDMI_VPLLCR1,
+		~HDMI_VPLLCR1_dpll_freeze_mask, 0, HDMI_RX_MAC);
+
+	/* PLL clock need to enable ouput before pll_pow and 420_en on */
+	lib_hdmi_video_output(1);
+
+	HDMI_DELAYUS(1);
+	hdmi_rx_reg_mask32(HDMI_TMDS_DPC_SET0,
+		~(HDMI_TMDS_DPC_SET0_dpc_en_mask), HDMI_TMDS_DPC_SET0_dpc_en_mask, HDMI_RX_MAC);
+	HDMI_DELAYUS(1);
+	hdmi_rx_reg_mask32(HDMI_YUV420_CR,
+		~(HDMI_YUV420_CR_en_mask), HDMI_YUV420_CR_en(is_420), HDMI_RX_MAC);
+
+	return TRUE;
+}
+
+
+void lib_hdmi_video_output(unsigned char on)
+{
+	if (on)
+		hdmi_rx_reg_mask32(HDMI_AVMCR,
+			~HDMI_AVMCR_ve_mask, HDMI_AVMCR_ve_mask, HDMI_RX_MAC);
+	else
+		hdmi_rx_reg_mask32(HDMI_AVMCR,
+			~HDMI_AVMCR_ve_mask, 0, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_video_output(void)
+{
+	unsigned char ve;
+
+	ve = HDMI_AVMCR_get_ve(hdmi_rx_reg_read32(HDMI_AVMCR, HDMI_RX_MAC));
+	return ve;
+}
+
+void lib_hdmi_clear_avmute(void)
+{
+	hdmi_rx_reg_mask32(HDMI_AVMCR,
+		~(HDMI_AVMCR_avmute_flag_mask), HDMI_AVMCR_avmute_flag_mask, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_AVMCR,
+		~(HDMI_AVMCR_avmute_flag_mask), 0, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_get_avmute(void)
+{
+	unsigned char avmute;
+
+	avmute = HDMI_SR_get_avmute(hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+	return avmute;
+}
+
+unsigned char lib_hdmi_get_bch_1bit_error(void)
+{
+	unsigned char bches;
+
+	bches = HDMI_BCHCR_get_bches(hdmi_rx_reg_read32(HDMI_BCHCR, HDMI_RX_MAC));
+	return bches;
+}
+
+unsigned char lib_hdmi_get_bch_2bit_error(void)
+{
+	unsigned char bches2;
+
+	bches2 = HDMI_BCHCR_get_bches2(hdmi_rx_reg_read32(HDMI_BCHCR, HDMI_RX_MAC));
+	return bches2;
+}
+
+void lib_hdmi_bch_error_clr(void)
+{
+	hdmi_rx_reg_mask32(HDMI_BCHCR,
+		~(HDMI_BCHCR_bches_mask|HDMI_BCHCR_bches2_mask),
+		(HDMI_BCHCR_bches_mask|HDMI_BCHCR_bches2_mask), HDMI_RX_MAC);
+}
+
+void lib_hdmi_wdm_enable(unsigned char enable)
+{
+	hdmi_rx_reg_mask32(HDMI_WDCR0,
+		~HDMI_WDCR0_wdm_mask, HDMI_WDCR0_wdm(enable), HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_wdm_enable(void)
+{
+	unsigned char wdm;
+
+	wdm = HDMI_WDCR0_get_wdm(hdmi_rx_reg_read32(HDMI_WDCR0, HDMI_RX_MAC));
+	return wdm;
+}
+
+void lib_hdmi_auto_avmute_enable(unsigned char enable)
+{
+	hdmi_rx_reg_mask32(HDMI_WDCR0,
+		~HDMI_WDCR0_asmfe_mask, HDMI_WDCR0_asmfe(enable), HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_auto_avmute_enable(void)
+{
+	unsigned char asmfe;
+
+	asmfe = HDMI_WDCR0_get_asmfe(hdmi_rx_reg_read32(HDMI_WDCR0, HDMI_RX_MAC));
+	return asmfe;
+}
+
+void lib_hdmi_tmds_out_ctrl(unsigned char bypass, unsigned int r, unsigned int g, unsigned int b)
+{
+	hdmi_rx_reg_mask32(HDMI_TMDS_OUT_CTRL,
+		~(HDMI_TMDS_OUT_CTRL_tmds_bypass_mask),
+		HDMI_TMDS_OUT_CTRL_tmds_bypass(bypass), HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_TMDS_ROUT, r, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_TMDS_GOUT, g, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_TMDS_BOUT, b, HDMI_RX_MAC);
+}
+
+
+void lib_hdmi_mac_afifo_enable(void)
+{
+	hdmi_rx_reg_mask32(HDMI_PHY_FIFO_CR0,
+		~((HDMI_PHY_FIFO_CR0_port0_b_afifo_en_mask|HDMI_PHY_FIFO_CR0_port0_b_flush_mask|
+		HDMI_PHY_FIFO_CR0_port0_g_afifo_en_mask|HDMI_PHY_FIFO_CR0_port0_g_flush_mask|
+		HDMI_PHY_FIFO_CR0_port0_r_afifo_en_mask|HDMI_PHY_FIFO_CR0_port0_r_flush_mask)),
+		(HDMI_PHY_FIFO_CR0_port0_b_afifo_en_mask|HDMI_PHY_FIFO_CR0_port0_b_flush_mask|
+		HDMI_PHY_FIFO_CR0_port0_g_afifo_en_mask|HDMI_PHY_FIFO_CR0_port0_g_flush_mask|
+		HDMI_PHY_FIFO_CR0_port0_r_afifo_en_mask|HDMI_PHY_FIFO_CR0_port0_r_flush_mask),
+		HDMI_RX_MAC);
+}
+
+void lib_hdmi_420_en(unsigned char en)
+{
+	hdmi_rx_reg_mask32(HDMI_YUV420_CR,
+		~HDMI_YUV420_CR_en_mask, HDMI_YUV420_CR_get_en(en), HDMI_RX_MAC);
+}
+
+void lib_hdmi_crc_check(void)
+{
+	hdmi_rx_reg_write32(HDMI_TMDS_CRCC,
+		HDMI_TMDS_CRCC_crc_r_en_mask|HDMI_TMDS_CRCC_crc_g_en_mask|HDMI_TMDS_CRCC_crc_b_en_mask|
+		HDMI_TMDS_CRCC_crc_nonstable_mask|HDMI_TMDS_CRCC_crcc_mask, HDMI_RX_MAC);
+}
+
+unsigned int lib_hdmi_read_crc(void)
+{
+	return hdmi_rx_reg_read32(HDMI_TMDS_CRCO0, HDMI_RX_MAC);
+}
+
+
+#if HDMI2p0
+unsigned char lib_hdmi_scdc_read(unsigned char addr)
+{
+	hdmi_rx_reg_write32(HDMI_SCDC_AP, addr, HDMI_RX_MAC);
+	return hdmi_rx_reg_read32(HDMI_SCDC_DP, HDMI_RX_MAC);
+}
+
+void lib_hdmi_scdc_write(unsigned char addr, unsigned char value)
+{
+	hdmi_rx_reg_write32(HDMI_SCDC_AP, addr, HDMI_RX_MAC);
+	hdmi_rx_reg_write32(HDMI_SCDC_DP, value, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi2p0_get_tmds_config(void)
+{
+	return lib_hdmi_scdc_read(0x20);
+}
+
+void lib_hdmi2p0_reset_scdc(void)
+{
+	hdmi_rx_reg_mask32(HDMI_SCDC_CR,
+		~HDMI_SCDC_CR_scdc_reset_mask,
+		HDMI_SCDC_CR_scdc_reset_mask, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_SCDC_CR,
+		~HDMI_SCDC_CR_scdc_reset_mask, 0, HDMI_RX_MAC);
+	HDMI_PRINTF("HDMI2.0 SCDC: clear\n");
+}
+
+void lib_hdmi2p0_scdc_update_flag(void)
+{
+	/* HDMI2.0 spec: 10.4.1.3 */
+	if (((lib_hdmi_scdc_read(0x10)&_BIT2) == _BIT2)) {
+		lib_hdmi_scdc_write(0x10, 0x00);
+		lib_hdmi_scdc_write(0x10, 0x04);
+	}
+}
+
+void lib_hdmi2p0_scramble_enable(unsigned char on_off)
+{
+	if (on_off) {
+		/* HDMI_PRINTF("HDMI2.0 Scramble Enable\n"); */
+		/* For RGB bug */
+		hdmi_rx_reg_mask32(HDMI_SCR,
+			~(HDMI_SCR_dvi_reset_ds_cm_en_mask), 0, HDMI_RX_MAC);
+		/* Force scramble mode for no scramble bug */
+		hdmi_rx_reg_mask32(HDMI_SCR_CR,
+			~(HDMI_SCR_CR_scr_en_fw_mask|HDMI_SCR_CR_scr_auto_mask),
+			HDMI_SCR_CR_scr_en_fw_mask, HDMI_RX_MAC);
+		/* For 6G audio bug setting */
+		hdmi_rx_reg_mask32(HDMI_SCR,
+			~(HDMI_SCR_mode_mask|HDMI_SCR_msmode_mask),
+			(HDMI_SCR_mode_mask|HDMI_SCR_msmode_mask), HDMI_RX_MAC);
+	} else {
+		/* HDMI_PRINTF("HDMI2.0 Scramble disable\n"); */
+		hdmi_rx_reg_mask32(HDMI_SCR,
+			~(HDMI_SCR_dvi_reset_ds_cm_en_mask),
+			HDMI_SCR_dvi_reset_ds_cm_en_mask, HDMI_RX_MAC);
+		/* For 6G audio bug setting */
+		/* Force scramble mode for no scramble bug */
+		hdmi_rx_reg_mask32(HDMI_SCR_CR,
+			~(HDMI_SCR_CR_scr_en_fw_mask|HDMI_SCR_CR_scr_auto_mask),
+			0, HDMI_RX_MAC);
+		/* For 6G audio bug setting */
+		hdmi_rx_reg_mask32(HDMI_SCR,
+			~(HDMI_SCR_mode_mask|HDMI_SCR_msmode_mask), 0, HDMI_RX_MAC);
+	}
+}
+
+#endif
+
+
+void lib_hdmi_read_packet_sram(unsigned int start_addr, unsigned char len, unsigned char *pbuf)
+{
+	unsigned char i;
+
+	hdmi_rx_reg_write32(HDMI_PSAP, start_addr, HDMI_RX_MAC);
+	for (i = 0; i < len; i++) {
+		hdmi_rx_reg_write32(HDMI_PSAP, start_addr+i, HDMI_RX_MAC);
+		pbuf[i] = hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC);
+	}
+}
+
+unsigned char lib_hdmi_is_fvs_received(void)
+{
+	return HDMI_GPVS_get_fvsps(hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC));
+}
+
+void lib_hdmi_clear_fvs_received_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_fvsps_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_vs_received(void)
+{
+	return HDMI_GPVS_get_vsps(hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC));
+}
+
+void lib_hdmi_clear_vs_received_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_vsps_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_avi_received(void)
+{
+	return HDMI_GPVS_get_avips(hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC));
+}
+
+void lib_hdmi_clear_avi_received_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_avips_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_spd_received(void)
+{
+	return HDMI_GPVS_get_spdps(hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC));
+}
+
+void lib_hdmi_clear_spd_received_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_spdps_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_audiopkt_received(void)
+{
+	return HDMI_GPVS_get_aps(hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC));
+}
+
+void lib_hdmi_clear_audiopkt_received_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_aps_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_drm_received(void)
+{
+	return HDMI_GPVS_get_drmps(hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC));
+}
+
+void lib_hdmi_clear_drm_received_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_drmps_mask, HDMI_RX_MAC);
+}
+
+
+void lib_hdmi_set_rsv_packet_type(unsigned char index, unsigned char pkt_type)
+{
+	hdmi_rx_reg_mask32(HDMI_PTRSV1,
+		~(HDMI_PTRSV1_pt0_mask<<(index<<3)),
+		pkt_type<<(index<<3), HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_rsv_packet0_received(void)
+{
+	return HDMI_GPVS_get_rsv0ps(hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC));
+}
+
+void lib_hdmi_clear_rsv_packet0_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_rsv0ps_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_rsv_packet1_received(void)
+{
+	unsigned char rsv1ps;
+
+	rsv1ps = HDMI_GPVS_get_rsv1ps(hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC));
+	return rsv1ps;
+}
+
+void lib_hdmi_clear_rsv_packet1_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_rsv1ps_mask, HDMI_RX_MAC);
+}
+
+
+unsigned char lib_hdmi_is_rsv_packet2_received(void)
+{
+	unsigned char rsv2ps;
+
+	rsv2ps = HDMI_GPVS_get_rsv2ps(hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC));
+	return rsv2ps;
+}
+
+void lib_hdmi_clear_rsv_packet2_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_rsv2ps_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_is_rsv_packet3_received(void)
+{
+	unsigned char rsv3ps;
+
+	rsv3ps = HDMI_GPVS_get_rsv3ps(hdmi_rx_reg_read32(HDMI_GPVS, HDMI_RX_MAC));
+	return rsv3ps;
+}
+
+void lib_hdmi_clear_rsv_packet3_status(void)
+{
+	hdmi_rx_reg_write32(HDMI_GPVS, HDMI_GPVS_rsv3ps_mask, HDMI_RX_MAC);
+}
+
+
+void lib_hdmi_gcp_ackg_header_parsing_mode(void)
+{
+	hdmi_rx_reg_mask32(HDMI_SCR,
+		~HDMI_SCR_packet_header_parsing_mode_mask,
+		HDMI_SCR_packet_header_parsing_mode(1),
+		HDMI_RX_MAC);
+}
+
+void lib_hdmi_valid_format_condition(void)
+{
+	hdmi_rx_reg_mask32(HDMI_TMDS_CPS,
+		~(HDMI_TMDS_CPS_pk_gb_num_mask | HDMI_TMDS_CPS_vd_gb_num_mask |
+		HDMI_TMDS_CPS_pk_pre_num_mask | HDMI_TMDS_CPS_vd_pre_num_mask),
+		(HDMI_TMDS_CPS_pk_gb_num(HDMI_PK_GB_NUM) | HDMI_TMDS_CPS_vd_gb_num(HDMI_VD_GB_NUM) |
+		HDMI_TMDS_CPS_pk_pre_num(HDMI_PK_PRE_NUM) | HDMI_TMDS_CPS_vd_pre_num(HDMI_VD_PRE_NUM)),
+		HDMI_RX_MAC);
+}
+
+void lib_hdmi_audio_init(void)
+{
+	/* Clear Overflow,Underflow,phase_non_lock, auto load double buffter */
+	hdmi_rx_reg_write32(HDMI_DBCR, 0x00, HDMI_RX_MAC);
+	/* Disable audio watch dog */
+	hdmi_rx_reg_mask32(HDMI_WDCR0, ~HDMI_WDCR0_awdck_mask, 0x00, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_WDCR0,
+		~(HDMI_WDCR0_awdfu_mask|HDMI_WDCR0_awdfo_mask|HDMI_WDCR0_awdap_mask|HDMI_WDCR0_awdct_mask),
+		0x0, HDMI_RX_MAC);
+
+	lib_hdmi_audio_output(0);
+
+	/*Disable FIFO trend tracking*/
+	hdmi_rx_reg_write32(HDMI_PSCR, 0xE2, HDMI_RX_MAC);
+	/*Update Double Buffer*/
+	hdmi_rx_reg_write32(HDMI_CMCR, 0x50, HDMI_RX_MAC);/* K code=2 */
+
+	hdmi_rx_reg_mask32(HDMI_WDCR0,
+		~(HDMI_WDCR0_wdm_mask|HDMI_WDCR0_asmfe_mask),
+		HDMI_WDCR0_wdm(0)|HDMI_WDCR0_asmfe(0), HDMI_RX_MAC);
+
+}
+
+
+/**
+ * lib_hdmi_audio_get_type - Get audio type
+ *
+ * Return:
+ *   0 - PCM
+ *   1 - Non-PCM(RAW)
+ *   2 - HBR
+ */
+unsigned char lib_hdmi_audio_get_format(void)
+{
+	unsigned int reg_val;
+	unsigned char is_nonpcm;
+	unsigned char is_hbr;
+	unsigned char audio_type;
+
+	is_nonpcm = HDMI_SR_get_spdiftype(hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+
+	if (is_nonpcm) {
+		reg_val = hdmi_rx_reg_read32(HDMI_HIGH_BIT_RATE_AUDIO_PACKET, HDMI_RX_MAC);
+		is_hbr = HDMI_HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode(reg_val);
+
+		if (is_hbr)
+			audio_type = AUDIO_FORMAT_HBR;
+		else
+			audio_type = AUDIO_FORMAT_NONLPCM;
+	} else {
+		audio_type = AUDIO_FORMAT_LPCM;
+	}
+
+	return audio_type;
+}
+
+void lib_hdmi_audio_pop_n_cts(void)
+{
+	hdmi_rx_reg_mask32(HDMI_ACRCR,
+		~(HDMI_ACRCR_pucnr_mask|HDMI_ACRCR_pucsr_mask),
+		(HDMI_ACRCR_pucnr_mask|HDMI_ACRCR_pucsr_mask), HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_audio_pop_n_cts_done(void)
+{
+	return ((hdmi_rx_reg_read32(HDMI_ACRCR, HDMI_RX_MAC) & (HDMI_ACRCR_pucnr_mask|HDMI_ACRCR_pucsr_mask)) == 0);
+}
+
+unsigned int lib_hdmi_audio_get_n(void)
+{
+	unsigned int n;
+
+	n = HDMI_ACRSR1_get_n(hdmi_rx_reg_read32(HDMI_ACRSR1, HDMI_RX_MAC));
+	return n;
+}
+
+unsigned int lib_hdmi_audio_get_cts(void)
+{
+	unsigned int cts;
+
+	cts = HDMI_ACRSR0_get_cts(hdmi_rx_reg_read32(HDMI_ACRSR0, HDMI_RX_MAC));
+	return cts;
+}
+
+
+void lib_hdmi_audio_clear_fs(void)
+{
+	hdmi_rx_reg_write32(HDMI_ASR0,
+		(HDMI_ASR0_fsre_mask|HDMI_ASR0_fsif_mask|HDMI_ASR0_fscs_mask), HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_audio_fs_from_cs(void)
+{
+	unsigned char fbcs;
+
+	fbcs = HDMI_ASR0_fscs(hdmi_rx_reg_read32(HDMI_ASR0, HDMI_RX_MAC));
+	return fbcs;
+}
+
+unsigned char lib_hdmi_audio_get_freq_from_cs(void)
+{
+	unsigned char fbcs;
+
+	fbcs = HDMI_ASR1_get_fbcs(hdmi_rx_reg_read32(HDMI_ASR1, HDMI_RX_MAC));
+	return fbcs;
+}
+
+void lib_hdmi_audio_cts_bound(unsigned int clk)
+{
+	unsigned long cts_up, cts_low;
+
+	if (clk > 5600) {
+		/* 6G timing */
+		cts_up = 0xfffff;
+		cts_low = 445500 *7/8;
+	} else if (clk > 2750) {
+		/* 3G timing */
+		cts_up = 421875 * 9/8;
+		cts_low = 222750 * 7/8;
+	} else if (clk > 1380) {
+		/* 148M */
+		cts_up = 421875 * 9/8;
+		cts_low = 140625 * 7/8;
+	} else if (clk > 660) {
+		cts_up = 234375 * 9/8;
+		cts_low = 74250 * 7/8 ;
+	} else {
+		cts_up = 60060 * 9/8;
+		cts_low = 25200 * 7/8;
+	}
+
+	hdmi_rx_reg_mask32(HDMI_AUDIO_CTS_UP_BOUND,
+		~(HDMI_AUDIO_CTS_UP_BOUND_cts_up_bound_mask),
+		HDMI_AUDIO_CTS_UP_BOUND_cts_up_bound(cts_up), HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_AUDIO_CTS_LOW_BOUND,
+		~HDMI_AUDIO_CTS_LOW_BOUND_cts_low_bound_mask,
+		HDMI_AUDIO_CTS_LOW_BOUND_cts_low_bound(cts_low), HDMI_RX_MAC);
+}
+
+void lib_hdmi_audio_n_bound(unsigned int freq)
+{
+	int N_up, N_low;
+
+	if (freq > 190000) {
+		/* 192k */
+		N_up = 46592 *9/8;
+		N_low = 20480 * 7/8 ;
+	} else if (freq > 170000) {
+		/* 176.4 */
+		N_up = 71344 * 9/8;
+		N_low = 17836 * 7/8;
+	} else if (freq >80000) {
+		/* 96 k 88.2k */
+		N_up = 35672 * 9/8;
+		N_low = 8918 * 7/8;
+	} else {
+		/* 32k  44.1k  48k */
+		N_up = 17836 * 9/8;
+		N_low = 3072 * 7/8;
+	}
+
+	hdmi_rx_reg_mask32(HDMI_AUDIO_N_UP_BOUND,
+		~(HDMI_AUDIO_N_UP_BOUND_n_up_bound_mask),
+		HDMI_AUDIO_N_UP_BOUND_n_up_bound(N_up), HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_AUDIO_N_LOW_BOUND,
+		~HDMI_AUDIO_N_LOW_BOUND_n_low_bound_mask,
+		HDMI_AUDIO_N_LOW_BOUND_n_low_bound(N_low), HDMI_RX_MAC);
+
+	HDMI_PRINTF("freq = %d Audio_N_Bound H = %d , L =%d\n", freq, N_up, N_low);
+}
+
+
+unsigned char lib_hdmi_audio_is_pll_unlock(void)
+{
+	unsigned char pllsts;
+
+	pllsts = HDMI_SR_get_pllsts(hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+	return pllsts;
+}
+
+void lib_hdmi_audio_wclr_pll_unlock(void)
+{
+	hdmi_rx_reg_write32(HDMI_SR, HDMI_SR_pllsts_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_audio_is_fifo_overflow(void)
+{
+	unsigned char fifo_of;
+
+	fifo_of = HDMI_SR_get_afifoof(hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+	return fifo_of;
+}
+
+void lib_hdmi_audio_wclr_fifo_overflow(void)
+{
+	hdmi_rx_reg_write32(HDMI_SR, HDMI_SR_afifoof_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_audio_is_fifo_underflow(void)
+{
+	unsigned char fifo_uf;
+
+	fifo_uf = HDMI_SR_get_afifouf(hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC));
+	return fifo_uf;
+}
+
+void lib_hdmi_audio_wclr_fifo_underflow(void)
+{
+	hdmi_rx_reg_write32(HDMI_SR, HDMI_SR_afifouf_mask, HDMI_RX_MAC);
+}
+
+void lib_hdmi_audio_clear_phase_error(void)
+{
+	hdmi_rx_reg_write32(HDMI_NCPER, 0xff, HDMI_RX_MAC);
+}
+
+
+void lib_hdmi_audio_generate(void)
+{
+	unsigned char i;
+	unsigned int d_code;
+
+	hdmi_rx_reg_mask32(HDMI_DBCR, 0xF0, 0x0F, HDMI_RX_MAC);
+
+	d_code = hdmi_rx_reg_read32(HDMI_APLLCR3, HDMI_RX_MAC);
+
+	for (i = 0; i < 5; i++) {
+		if (d_code == hdmi_rx_reg_read32(HDMI_APLLCR3, HDMI_RX_MAC))
+			break;
+	}
+
+	/* Pre-set D code */
+	hdmi_rx_reg_write32(HDMI_DCAPR0, d_code, HDMI_RX_MAC);
+	/* Pre-disable N/CTS tracking & FIFO depth */
+	hdmi_rx_reg_write32(HDMI_PSCR, 0xE2, HDMI_RX_MAC);
+
+	/* Enable audio Overflow & Underflow watch dog but not Audio type wdg */
+	hdmi_rx_reg_mask32(HDMI_WDCR0,
+		~(_BIT1|_BIT2|_BIT3|_BIT4), (_BIT1|_BIT2|_BIT3|_BIT4), HDMI_RX_MAC);
+	/* Enable audio tmds clock  watch dog */
+	hdmi_rx_reg_mask32(HDMI_WDCR0, ~_BIT15, _BIT15, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_audio_is_output(void)
+{
+	unsigned char aomc;
+
+	aomc = HDMI_AVMCR_get_aomc(hdmi_rx_reg_read32(HDMI_AVMCR, HDMI_RX_MAC));
+
+	return aomc;
+}
+
+
+void lib_hdmi_audio_output(unsigned char on)
+{
+	if (on) {
+		hdmi_rx_reg_mask32(HDMI_AVMCR,
+			~(HDMI_AVMCR_aoc_mask|HDMI_AVMCR_aomc_mask),
+			(HDMI_AVMCR_aoc_mask|HDMI_AVMCR_aomc_mask), HDMI_RX_MAC);
+		hdmi_rx_reg_mask32(HDMI_AOCR,
+			~(HDMI_AOCR_spdifo1_mask|HDMI_AOCR_spdifo2_mask|
+			HDMI_AOCR_spdifo3_mask|HDMI_AOCR_spdifo4_mask|
+			HDMI_AOCR_i2so1_mask|HDMI_AOCR_i2so2_mask|
+			HDMI_AOCR_i2so3_mask|HDMI_AOCR_i2so4_mask),
+			(HDMI_AOCR_spdifo1_mask|HDMI_AOCR_spdifo2_mask|
+			HDMI_AOCR_spdifo3_mask|HDMI_AOCR_spdifo4_mask|
+			HDMI_AOCR_i2so1_mask|HDMI_AOCR_i2so2_mask|
+			HDMI_AOCR_i2so3_mask|HDMI_AOCR_i2so4_mask),
+			HDMI_RX_MAC);
+	} else {
+		hdmi_rx_reg_mask32(HDMI_AOCR,
+			~(HDMI_AOCR_spdifo1_mask|HDMI_AOCR_spdifo2_mask|
+			HDMI_AOCR_spdifo3_mask|HDMI_AOCR_spdifo4_mask|
+			HDMI_AOCR_i2so1_mask|HDMI_AOCR_i2so2_mask|
+			HDMI_AOCR_i2so3_mask|HDMI_AOCR_i2so4_mask),
+			0, HDMI_RX_MAC);
+
+		hdmi_rx_reg_mask32(HDMI_AVMCR,
+			~(HDMI_AVMCR_aoc_mask|HDMI_AVMCR_aomc_mask),
+			HDMI_AVMCR_aoc_mask, HDMI_RX_MAC);
+	}
+}
+
+void lib_hdmi_audio_set_hbr_manual_mode(unsigned char manu, unsigned char mode_fw)
+{
+	hdmi_rx_reg_mask32(HDMI_HIGH_BIT_RATE_AUDIO_PACKET,
+		~(HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual_mask |
+		HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw_mask),
+		HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual(manu) |
+		HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw(mode_fw),
+		HDMI_RX_MAC);
+
+	/* Write 1 clear */
+	hdmi_rx_reg_mask32(HDMI_HIGH_BIT_RATE_AUDIO_PACKET,
+		~(HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_mask),
+		HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode(1), HDMI_RX_MAC);
+}
+
+void lib_hdmi_audio_clear_hdr_status(void)
+{
+	hdmi_rx_reg_mask32(HDMI_HIGH_BIT_RATE_AUDIO_PACKET,
+		~HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_mask,
+		HDMI_HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_audio_get_hbr_manual_mode(void)
+{
+	unsigned char manual_mode;
+
+	manual_mode = HDMI_HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode_fw(hdmi_rx_reg_read32(HDMI_HIGH_BIT_RATE_AUDIO_PACKET, HDMI_RX_MAC));
+
+	return manual_mode;
+}
+
+
+unsigned char lib_hdmi_audio_get_hbr_mode(void)
+{
+	unsigned char hbr_mode;
+
+	hbr_mode = HDMI_HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode(hdmi_rx_reg_read32(HDMI_HIGH_BIT_RATE_AUDIO_PACKET, HDMI_RX_MAC));
+
+	return hbr_mode;
+}
+
+unsigned char lib_hdmi_audio_get_channel_status15_0(unsigned int bitmask, unsigned int bitshift)
+{
+	hdmi_rx_reg_write32(HDMI_ACRCR, HDMI_ACRCR_pucsr_mask, HDMI_RX_MAC);
+	HDMI_DELAYMS(80);
+	return ((bitmask&(hdmi_rx_reg_read32(HDMI_ACS0, HDMI_RX_MAC)))>>bitshift);
+}
+
+unsigned char lib_hdmi_audio_get_channel_status39_16(unsigned int bitmask, unsigned int bitshift)
+{
+	hdmi_rx_reg_write32(HDMI_ACRCR, HDMI_ACRCR_pucsr_mask, HDMI_RX_MAC);
+	HDMI_DELAYMS(80);
+	return ((bitmask&(hdmi_rx_reg_read32(HDMI_ACS1, HDMI_RX_MAC)))>>bitshift);
+}
+
+void lib_hdmi_set_toggle_hpd_z0_flag(unsigned char uc_flag)
+{
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	/* HDMI_PRINTF("lib_hdmi_set_toggle_hpd_z0_flag=%d\n", uc_flag); */
+	hdmi_toggle_hpd_z0_flag = uc_flag;
+#endif
+}
+
+unsigned char lib_hdmi_get_toggle_hpd_z0_flag(void)
+{
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	return hdmi_toggle_hpd_z0_flag;
+#endif
+
+	return FALSE;
+}
+
+unsigned char lib_hdmi_toggle_hpd_z0_check(unsigned char ucInit)
+{
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	static unsigned int start_time = 0;
+	static unsigned int current_time = 0;
+
+	if (lib_hdmi_get_toggle_hpd_z0_flag() == FALSE)
+		return TRUE;
+
+	if (ucInit == TRUE) {
+		/* Need to think, if start time almost overflow */
+		start_time = hdmi_rx_reg_read32(MIS_SCPU_CLK90K_LO ,HDMI_RX_CLK90K)/90;
+		current_time = start_time;
+		HDMI_PRINTF("lib_hdmi_toggle_hpd_z0_check, start=%d\n", start_time);
+		return TRUE;
+	}
+
+	current_time = hdmi_rx_reg_read32(MIS_SCPU_CLK90K_LO ,HDMI_RX_CLK90K)/90;
+
+	if (current_time >= start_time) {
+		if (current_time - start_time >= HDMI_START_TOGGLE_HPD_Z0_MS) {
+			Hdmi_SetHPD(0);
+			lib_hdmi_z0_set(LN_ALL, 0);
+			HDMI_DELAYMS(HDMI_TOGGLE_HPD_Z0_MS);
+			lib_hdmi_z0_set(LN_ALL, 1);
+			Hdmi_SetHPD(1);
+			HDMI_PRINTF("lib_hdmi_toggle_hpd_z0_check, time=%d\n", current_time);
+			lib_hdmi_set_dc_on_delay_state(HDMI_DC_ON_ENABLE_DELAY);
+			lib_hdmi_set_toggle_hpd_z0_flag(FALSE);
+		}
+	} else {
+		/* current_time <= start_time */
+		HDMI_PRINTF("lib_hdmi_toggle_hpd_z0_check over, start_time=%d, current_time=%d\n", start_time, current_time);
+		lib_hdmi_set_toggle_hpd_z0_flag(FALSE);
+	}
+#endif /* End of #if HDMI_TOGGLE_HPD_Z0_ENABLE */
+
+	return TRUE;
+}
+
+void lib_hdmi_set_dc_on_delay_state(HDMI_DC_ON_STATE_E state)
+{
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	/* HDMI_PRINTF("lib_hdmi_set_dc_on_delay_state=%d\n", state); */
+	hdmi_dc_on_delay_state = state;
+#endif
+}
+
+HDMI_DC_ON_STATE_E lib_hdmi_get_dc_on_delay_state(void)
+{
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	return hdmi_dc_on_delay_state;
+#endif
+
+	return HDMI_DC_ON_NONE;
+}
+
+unsigned char lib_hdmi_dc_on_delay_check(unsigned char ucInit)
+{
+#if HDMI_TOGGLE_HPD_Z0_ENABLE
+	static unsigned int start_time = 0;
+	static unsigned int current_time = 0;
+
+	if (lib_hdmi_get_toggle_hpd_z0_flag() == FALSE)
+		return TRUE;
+
+	if (ucInit == TRUE) {
+		if (lib_hdmi_get_dc_on_delay_state() != HDMI_DC_ON_ENABLE_DELAY)
+			return TRUE;
+
+		lib_hdmi_set_dc_on_delay_state(HDMI_DC_ON_START_TIME);
+		/* Need to think, if start time almost overflow */
+		start_time = hdmi_rx_reg_read32(MIS_SCPU_CLK90K_LO ,HDMI_RX_CLK90K)/90;
+		current_time = start_time;
+		HDMI_PRINTF("lib_hdmi_dc_on_delay_check, start=%d\n", start_time);
+		return TRUE;
+	}
+
+	if (lib_hdmi_get_dc_on_delay_state() != HDMI_DC_ON_START_TIME)
+		return TRUE;
+
+	current_time = hdmi_rx_reg_read32(MIS_SCPU_CLK90K_LO ,HDMI_RX_CLK90K)/90;
+
+	if (current_time >= start_time) {
+		if (current_time - start_time >= HDMI_DC_ON_DELAY_MS) {
+			HDMI_PRINTF("lib_hdmi_dc_on_delay_check, time=%d\n", current_time);
+			lib_hdmi_set_dc_on_delay_state(HDMI_DC_ON_FINISH);
+			return TRUE;
+		}
+	} else {
+		/* current_time <= start_time */
+		HDMI_PRINTF("lib_hdmi_dc_on_delay_check over, start_time=%d, current_time=%d\n", start_time, current_time);
+		lib_hdmi_set_dc_on_delay_state(HDMI_DC_ON_NONE);
+		return TRUE;
+	}
+
+	return FALSE;
+#endif/* End of #if HDMI_TOGGLE_HPD_Z0_ENABLE */
+
+	return TRUE;
+}
+
+void lib_hdmi_set_str_toggle_hpd_state(HDMI_STR_HPD_TOGGLE_STATE_E state)
+{
+#if HDMI_STR_TOGGLE_HPD_ENABLE
+	/* HDMI_PRINTF("lib_hdmi_set_str_toggle_hpd_state=%d\n", state); */
+	hdmi_str_toggle_hpd_state = state;
+#endif
+}
+
+HDMI_STR_HPD_TOGGLE_STATE_E lib_hdmi_get_str_toggle_hpd_state(void)
+{
+#if HDMI_STR_TOGGLE_HPD_ENABLE
+	return hdmi_str_toggle_hpd_state;
+#endif
+
+	return HDMI_STR_HPD_TOGGLE_NONE;
+}
+
+void lib_hdmi_set_delay_display_enable(unsigned char ucEnable)
+{
+#if HDMI_DISPLAY_DELAY_ENABLE
+	/* HDMI_PRINTF("lib_hdmi_set_delay_display_enable=%d\n", ucEnable); */
+	hdmi_delay_display_enable = ucEnable;
+#endif
+}
+
+unsigned char lib_hdmi_get_delay_display_enable(void)
+{
+#if HDMI_DISPLAY_DELAY_ENABLE
+	return hdmi_delay_display_enable;
+#endif
+
+	return _DISABLE;
+}
+
+void lib_hdmi_set_delay_display_state(HDMI_DISPLAY_DELAY_STATE_STATE_E state)
+{
+#if HDMI_DISPLAY_DELAY_ENABLE
+	/* HDMI_PRINTF("lib_hdmi_set_delay_display_state=%d\n", state); */
+	hdmi_delay_display_state = state;
+#endif
+}
+
+HDMI_DISPLAY_DELAY_STATE_STATE_E lib_hdmi_get_delay_display_state(void)
+{
+#if HDMI_DISPLAY_DELAY_ENABLE
+	return hdmi_delay_display_state;
+#endif
+
+	return HDMI_DISPLAY_DELAY_NONE;
+}
+
+unsigned char lib_hdmi_delay_check_before_display(unsigned char ucInit)
+{
+#if HDMI_DISPLAY_DELAY_ENABLE
+	static unsigned int start_time = 0;
+	static unsigned int current_time = 0;
+	unsigned int Delay_Time = 0;
+
+	if (lib_hdmi_get_delay_display_enable() == _DISABLE)
+		return TRUE;
+
+	if (ucInit == TRUE) {
+		if (lib_hdmi_get_delay_display_state() == HDMI_DISPLAY_DELAY_INIT) {
+			lib_hdmi_set_delay_display_state(HDMI_DISPLAY_DELAY_START);
+			/* Need to think, if start time almost overflow */
+			start_time = hdmi_rx_reg_read32(MIS_SCPU_CLK90K_LO ,HDMI_RX_CLK90K)/90;
+			current_time = start_time;
+			HDMI_PRINTF("lib_hdmi_delay_check_before_display, start=%d\n", start_time);
+		}
+		return TRUE;
+	}
+
+	if (lib_hdmi_get_delay_display_state() != HDMI_DISPLAY_DELAY_START)
+		return TRUE;
+
+	Delay_Time = lib_hdmi_get_delay_display_time();
+	current_time = hdmi_rx_reg_read32(MIS_SCPU_CLK90K_LO ,HDMI_RX_CLK90K)/90;
+
+	if (current_time >= start_time) {
+		if (current_time - start_time >= Delay_Time) {
+			HDMI_PRINTF("lib_hdmi_delay_check_before_display, time=%d\n", current_time);
+			lib_hdmi_set_delay_display_state(HDMI_DISPLAY_DELAY_FINISH);
+			return TRUE;
+		}
+	} else {
+		/* current_time <= start_time */
+		HDMI_PRINTF("lib_hdmi_delay_check_before_display over, start_time=%d, current_time=%d\n", start_time, current_time);
+		lib_hdmi_set_delay_display_state(HDMI_DISPLAY_DELAY_FINISH);
+		return TRUE;
+	}
+
+	return FALSE;
+#endif/* End of #if HDMI_DISPLAY_DELAY_ENABLE */
+
+	return TRUE;
+}
+
+unsigned int lib_hdmi_get_delay_display_time(void)
+{
+	unsigned int DelayTime = 0;/* ms */
+
+	switch (lib_hdmi_get_specific_device()) {
+	case HDMI_SPECIFIC_DEVICE_LHB_755:
+		DelayTime = HDMI_DISPLAY_DELAY_LHB_755_MS;
+		break;
+
+	case HDMI_SPECIFIC_DEVICE_ROKU_ULTRA_4640R:
+		DelayTime = HDMI_DISPLAY_DELAY_ROKU_ULTRA_4640R_MS;
+		break;
+
+	case HDMI_SPECIFIC_DEVICE_SAMSUNG_GX_HC630CH:
+		DelayTime = HDMI_DISPLAY_DELAY_SAMSUNG_GX_HC630CH_MS;
+		break;
+
+	case HDMI_SPECIFIC_DEVICE_KT_STB_KAO_CT1100:
+		DelayTime = HDMI_DISPLAY_DELAY_KT_STB_KAO_CT1100_MS;
+		break;
+
+	default:
+		DelayTime = 0;
+		break;
+	}
+
+	return DelayTime;
+}
+
+
+void lib_hdmi_set_specific_device(HDMI_SPECIFIC_DEVICE_E device)
+{
+	/* HDMI_PRINTF("lib_hdmi_set_specific_device=%d\n", device); */
+	hdmi_specific_device = device;
+}
+
+HDMI_SPECIFIC_DEVICE_E lib_hdmi_get_specific_device(void)
+{
+	return hdmi_specific_device;
+}
+
+void lib_hdmi_misc_variable_initial(void)
+{
+	lib_hdmi_set_specific_device(HDMI_SPECIFIC_DEVICE_NONE);
+
+#if HDMI_DISPLAY_DELAY_ENABLE
+	lib_hdmi_set_delay_display_enable(_DISABLE);
+	lib_hdmi_set_delay_display_state(HDMI_DISPLAY_DELAY_NONE);
+#endif
+}
+
+u64 lib_hdmi_get_clk90k(void)
+{
+	u64 clk90k_value;
+
+	/* 90KHz timer, Read LO first to ensure the correct */
+	clk90k_value = hdmi_rx_reg_read32(MIS_SCPU_CLK90K_LO ,HDMI_RX_CLK90K);
+	clk90k_value = (clk90k_value<<32) | hdmi_rx_reg_read32(MIS_SCPU_CLK90K_HI ,HDMI_RX_CLK90K);
+
+	return clk90k_value;
+}
+
+void lib_hdmi_dbg_reg_dump(void)
+{
+	#define AUDIO_REG_DBG 1
+	#define VIDEO_REG_DBG 1
+
+	HDMI_PRINTF("===================Dump Reg Start===================\n");
+#if AUDIO_REG_DBG
+	HDMI_PRINTF("###################Audio Part Begin###################\n");
+	HDMI_PRINTF("SR=%x AFCR=%x\n",
+		hdmi_rx_reg_read32(HDMI_SR, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_AFCR, HDMI_RX_MAC));
+
+	HDMI_PRINTF("ASR0=%x ASR1=%x\n",
+		hdmi_rx_reg_read32(HDMI_ASR0, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_ASR1, HDMI_RX_MAC));
+
+	HDMI_PRINTF("APLLCR0=%x APLLCR1=%x APLLCR2=%x APLLCR3=%x\n",
+		hdmi_rx_reg_read32(HDMI_APLLCR0, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_APLLCR1, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_APLLCR2, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_APLLCR3, HDMI_RX_MAC));
+
+	HDMI_PRINTF("ACRCR= %x ACRSR0=%x ACRSR1=%x\n",
+		hdmi_rx_reg_read32(HDMI_ACRCR, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_ACRSR0, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_ACRSR1, HDMI_RX_MAC));
+
+	HDMI_PRINTF("CTS_UP_BOUND=%x  CTS_LOW_BOUND=%x\n",
+		hdmi_rx_reg_read32(HDMI_AUDIO_CTS_UP_BOUND, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_AUDIO_CTS_LOW_BOUND, HDMI_RX_MAC));
+
+	HDMI_PRINTF("N_UP_BOUND=%x  N_LOW_BOUND=%x\n",
+		hdmi_rx_reg_read32(HDMI_AUDIO_N_UP_BOUND, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_AUDIO_N_LOW_BOUND, HDMI_RX_MAC));
+
+	HDMI_PRINTF("INTCR=%x SR_CHG=%x AOCR=%x\n",
+		hdmi_rx_reg_read32(HDMI_INTCR, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_AOCR, HDMI_RX_MAC));
+
+	HDMI_PRINTF("###################Audio Part End###################\n");
+#endif
+
+#if VIDEO_REG_DBG
+	HDMI_PRINTF("###################TMDS Channel Status Begin###################\n");
+	HDMI_PRINTF("TMDS_CTRL=%x TMDS_OUTCTL=%x\n",
+		hdmi_rx_reg_read32(HDMI_TMDS_CTRL, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_TMDS_OUTCTL, HDMI_RX_MAC));
+	HDMI_PRINTF("###################TMDS Channel Status End###################\n");
+
+
+	HDMI_PRINTF("###################Deep Color Status Begin###################\n");
+	HDMI_PRINTF("DPC_SET2=%x DPC_SET3=%x\n",
+		hdmi_rx_reg_read32(HDMI_TMDS_DPC_SET2, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_TMDS_DPC_SET3, HDMI_RX_MAC));
+	HDMI_PRINTF("###################Deep Color Status End###################\n");
+
+
+	HDMI_PRINTF("###################Data Enable Error Status Begin###################\n");
+	HDMI_PRINTF("DET_STS=%x\n",
+		hdmi_rx_reg_read32(HDMI_TMDS_DET_STS, HDMI_RX_MAC));
+	HDMI_PRINTF("###################Data Enable Error Status End###################\n");
+
+	HDMI_PRINTF("###################Video Data Error Detect Begin###################\n");
+	HDMI_PRINTF("BIT_ERR_B=%x BIT_ERR_G=%x BIT_ERR_R=%x\n",
+		hdmi_rx_reg_read32(HDMI_VIDEO_BIT_ERR_STATUS_B, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_VIDEO_BIT_ERR_STATUS_G, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_VIDEO_BIT_ERR_STATUS_R, HDMI_RX_MAC));
+	HDMI_PRINTF("TREC4_ERR_B=%x TREC4_ERR_G=%x TREC4_ERR_R=%x\n",
+		hdmi_rx_reg_read32(HDMI_TERC4_ERR_STATUS_B, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_TERC4_ERR_STATUS_G, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_TERC4_ERR_STATUS_R, HDMI_RX_MAC));
+	HDMI_PRINTF("BCH_ERR=%x\n", hdmi_rx_reg_read32(HDMI_BCHCR, HDMI_RX_MAC));
+	HDMI_PRINTF("###################Video Data Error Detect End###################\n");
+
+
+	HDMI_PRINTF("################### Video Control Register Begin###################\n");
+	HDMI_PRINTF("VCR=%x\n", hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+	HDMI_PRINTF("###################Video Control Register End###################\n");
+
+	HDMI_PRINTF("###################Guard Band Error Status Begin###################\n");
+	HDMI_PRINTF("BCSR=%x\n", hdmi_rx_reg_read32(HDMI_BCSR, HDMI_RX_MAC));
+	HDMI_PRINTF("###################Guard Band Error Status End###################\n");
+
+
+	HDMI_PRINTF("###################PRBS Status Begin###################\n");
+	HDMI_PRINTF("PRBS_R=%x PRBS_G=%x PRBS_B=%x\n",
+		hdmi_rx_reg_read32(HDMI_PRBS_R_CTRL, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_PRBS_G_CTRL, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_PRBS_B_CTRL, HDMI_RX_MAC));
+	HDMI_PRINTF("###################PRBS Status End###################\n");
+
+
+	HDMI_PRINTF("###################Asynchronous Fifo Status Begin###################\n");
+	HDMI_PRINTF("FIFO_SR0=%x FIFO_SR1=%x\n",
+		hdmi_rx_reg_read32(HDMI_PHY_FIFO_SR0, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_PHY_FIFO_SR1, HDMI_RX_MAC));
+
+	HDMI_PRINTF("CHSR=%x\n", hdmi_rx_reg_read32(HDMI_CH_SR, HDMI_RX_MAC));
+	HDMI_PRINTF("###################PHY Asynchronous Fifo Status End###################\n");
+
+
+	HDMI_PRINTF("###################Asynchronous Fifo Status Begin###################\n");
+	HDMI_PRINTF("FIFO_SR0=%x FIFO_SR1=%x\n",
+		hdmi_rx_reg_read32(HDMI_PHY_FIFO_SR0, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_PHY_FIFO_SR1, HDMI_RX_MAC));
+
+	HDMI_PRINTF("CHSR=%x\n", hdmi_rx_reg_read32(HDMI_CH_SR, HDMI_RX_MAC));
+	HDMI_PRINTF("###################PHY Asynchronous Fifo Status End###################\n");
+
+#if HDMI2p0
+	HDMI_PRINTF("###################Scramble Status Begin###################\n");
+	HDMI_PRINTF("SCR_CR=%x\n", hdmi_rx_reg_read32(HDMI_SCR_CR, HDMI_RX_MAC));
+	HDMI_PRINTF("###################Scramble Status End###################\n");
+
+
+	HDMI_PRINTF("###################CED Status Begin###################\n");
+	HDMI_PRINTF("CER_SR0=%x CER_SR1=%x CER_SR2=%x\n",
+		hdmi_rx_reg_read32(HDMI_CERSR0, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_CERSR1, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_CERSR2, HDMI_RX_MAC));
+
+	HDMI_PRINTF("CER_SR3=%x CER_SR4=%x\n",
+		hdmi_rx_reg_read32(HDMI_CERSR3, HDMI_RX_MAC),
+		hdmi_rx_reg_read32(HDMI_CERSR4, HDMI_RX_MAC));
+	HDMI_PRINTF("###################CED Statuss End###################\n");
+
+
+	HDMI_PRINTF("###################YUV420 FIFO Status Begin###################\n");
+	HDMI_PRINTF("YUV420_CR=%x\n",
+		hdmi_rx_reg_read32(HDMI_YUV420_CR, HDMI_RX_MAC));
+	HDMI_PRINTF("###################YUV420 FIFO Status End###################\n");
+
+
+	HDMI_PRINTF("###################PMM CLK Status Begin###################\n");
+	HDMI_PRINTF("CLK_DET_SR=%x\n",
+		hdmi_rx_reg_read32(HDMI_ACDRCLKDETSR, HDMI_RX_MAC));
+	HDMI_PRINTF("###################PMM CLK Status End###################\n");
+#endif
+
+#endif
+
+	HDMI_PRINTF("===================Dump Reg End===================\n");
+
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiInternal.h b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiInternal.h
new file mode 100644
index 00000000..b687aa5
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiInternal.h
@@ -0,0 +1,922 @@
+/*
+ * hdmiInternal.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDMI_INTERNAL_H_
+#define __HDMI_INTERNAL_H_
+
+#include <linux/delay.h>
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmirx_reg.h"
+#include "hdcp2p2_dev.h"
+
+#define HDMI_INTERNAL_DEBUG 0
+
+#if HDMI_INTERNAL_DEBUG
+#define HDMI_PRINTF(format, ...)	pr_err("[HDMI RX DBG]" format "\n", ## __VA_ARGS__)
+#else
+#define HDMI_PRINTF(format, ...)	do {} while(0)
+#endif
+
+#ifndef UINT8
+	typedef unsigned char UINT8;
+	typedef int INT32;
+	typedef unsigned int UINT32;
+#endif
+
+#ifndef TRUE
+#define TRUE true
+#define FALSE false
+#endif
+
+#ifndef _ENABLE
+#define _ENABLE	1
+#endif
+
+#ifndef _DISABLE
+#define _DISABLE	0
+#endif
+
+#ifndef ABS
+#define ABS(x, y)				((x > y) ? (x-y) : (y-x))
+#endif
+
+#ifndef MAX
+	#define MAX(a, b)           (((a) > (b)) ? (a) : (b))
+#endif
+
+#ifndef MIN
+	#define MIN(a, b)           (((a) < (b)) ? (a) : (b))
+#endif
+
+typedef  unsigned char HDMI_bool;
+
+#define HDMI2p0	 1 /* HDMI2.0 */
+#define HDMI_REPEATER_SUPPORT  1
+#define AUDIO_HBR_DETECT       1
+#define AUDIO_OVER_192K        1
+#define BIST_DFE_SCAN          0
+#define MEASURE_FROM_TMDS_CLOCK 0 /*  0: PIXEL CLOCK  1:TMDS CLOCK */
+#define TMDS_ERR_DET_SHORT_PERIOD  1
+#define HDMI_INT_PRO_CHG_FLAG_ENABLE  1
+
+/* Video WatchDog function enable */
+#define HDMI_VIDEO_WD_ENABLE   1
+#define HDMI_WD_VIDEO_COND     _BIT0
+#define HDMI_WD_AUDIO_COND     _BIT1
+#define HDMI_WD_VSC_COND       _BIT2
+#define HDMI_WD_ALL_COND       (HDMI_WD_VIDEO_COND | HDMI_WD_AUDIO_COND | HDMI_WD_VSC_COND)
+
+/* For fix colorimetry NG case */
+#define HDMI_AVI_INFO_COLORIMETRY_ENABLE        1
+#define HDMI_AVI_INFO_COLORIMETRY_DEBOUNCE_CNT  25
+
+/* STB DC off/on, will send AV mute after display, let it flicker */
+#define HDMI_TOGGLE_HPD_Z0_ENABLE    1
+#define HDMI_START_TOGGLE_HPD_Z0_MS  5000
+#define HDMI_TOGGLE_HPD_Z0_MS        400/* some times NG at 100 ~ 200, 500 ms is good */
+#define HDMI_DC_ON_DELAY_MS          5000
+
+/* STR TV and STB DC off/on together, It will keep to send AVMute, can not display */
+#define HDMI_STR_TOGGLE_HPD_ENABLE   1
+#define HDMI_STR_TOGGLE_HPD_MS       400
+
+/* For Tx output stable clock => unstbale => stable*/
+#define HDMI_DISPLAY_DELAY_ENABLE         1
+#define HDMI_DISPLAY_DELAY_LHB_755_MS     600
+#define HDMI_DISPLAY_DELAY_LHB_755_MS_2   200
+#define HDMI_DISPLAY_DELAY_ROKU_ULTRA_4640R_MS     1500/* >1500ms OK */
+#define HDMI_DISPLAY_DELAY_SAMSUNG_GX_HC630CH_MS   2000/* >1500ms OK */
+#define HDMI_DISPLAY_DELAY_KT_STB_KAO_CT1100_MS    500/* >500ms OK */
+
+/* Fix Tx send stable clock at first, and check HDCP later */
+#define HDMI_CHECK_HDCP_ENABLE            0
+#define HDMI_HDCP_DEBOUNCE_CNT            25
+
+#define VALID_MIN_CLOCK         116
+#define MEAS_RETRY_LIMIT        6
+
+#define DISP_DEB_CNT_APPLETV   2
+#define DISP_DEB_CNT_PC40000   2
+
+
+/* lib_hdmi_z0_set */
+#define LN_Z300POW	0x10
+#define LN_CK	0x08
+#define LN_B	0x04
+#define LN_G	0x02
+#define LN_R	0x01
+#define LN_ALL (LN_Z300POW|LN_CK|LN_B|LN_G|LN_R)
+
+/* lib_hdmi_valid_format_condition */
+#define HDMI_PK_GB_NUM   1
+#define HDMI_VD_GB_NUM   1
+#define HDMI_PK_PRE_NUM  3
+#define HDMI_VD_PRE_NUM  3
+
+#define HDMI_ABS(x, y)		((x > y) ? (x-y) : (y-x))
+
+#define HDMI_DELAYUS(x)    usleep_range(x, x+10)
+#define HDMI_DELAYMS(x)    msleep(x)
+
+#define HDMI_CONST		const
+
+typedef enum {
+	HDMI_ERR_NO = 0,
+	HDMI_EER_GENERIC,
+	HDMI_ERR_ONMS_ONESHOT,
+	HDMI_ERR_ONMS_CONTINUOUS_INIT,
+	HDMI_ERR_ONMS_CONTINUOUS_CHECK,
+	HDMI_ERR_ONMS_WRONG_TIMING,
+	HDMI_ERR_ONMS_WRONG_PARAM,
+	HDMI_ERR_3D_WRONG_OPMODE,
+	HDMI_ERR_3D_NO_MEM,
+	HDMI_ERR_4XXTO4XX_WRONG_PARAM,
+	HDMI_EER_MEASURE_ACTIVESPACE_FAIL,
+	HDMI_EER_VODMA_NOT_READY,
+} HDMI_ERR_T;
+
+enum _MODE_RESULT {
+	_MODE_NOSIGNAL	= 0xFF,
+	_MODE_NOSUPPORT = 0xFE,
+	_MODE_NOCABLE	= 0xFD,
+	_MODE_SUCCESS	= 0xFC,
+	_MODE_DETECT	= 0xFB,
+	_MDOE_UNDKOWN	= 0xFA,
+};
+#define MEASURE_FAIL  _MODE_DETECT
+
+typedef enum {
+	MODE_DVI = 0x0,
+	MODE_HDMI,
+	MODE_UNKNOW
+} HDMI_DVI_MODE_T;
+
+typedef enum {
+	HDMI_MS_MODE_ONESHOT = 0,
+	HDMI_MS_MODE_CONTINUOUS_INIT,
+	HDMI_MS_MODE_CONTINUOUS_CHECK,
+	HDMI_MS_MODE_ONESHOT_INIT,
+	HDMI_MS_MODE_ONESHOT_GET_RESULT,
+	HDMI_MS_MODE_ONESHOT_POLARITY_FIXED,
+} HDMI_MS_MODE_T;
+
+typedef enum {
+	AUDIO_FSM_AUDIO_START = 0,
+	AUDIO_FSM_FREQ_DETECT,
+	AUDIO_FSM_AUDIO_WAIT_TO_START,
+	AUDIO_FSM_AUDIO_START_OUT,
+	AUDIO_FSM_AUDIO_WAIT_PLL_READY,
+	AUDIO_FSM_AUDIO_CHECK
+} HDMI_AUDIO_FSM_T;
+
+typedef enum {
+	AUDIO_FORMAT_LPCM = 0,
+	AUDIO_FORMAT_NONLPCM,
+	AUDIO_FORMAT_HBR
+} HDMI_AUDIO_FORMAT_T;
+
+typedef enum {
+	HDMI_MS_ONESHOT = 0,
+	HDMI_MS_CONTINUOUS,
+	HDMI_MS_DIRECT
+} HDMI_MS_T;
+
+typedef enum {
+	HDMI_AUDIO_N_CTS_TREND_BOUND = 0,
+	HDMI_AUDIO_TREND_BOUND,
+	HDMI_AUDIO_N_CTS,
+} HDMI_AUDIO_TRACK_MODE;
+
+typedef enum {
+	HDMIRX_DETECT_FAIL = 0,
+	HDMIRX_DETECT_SUCCESS,
+	HDMIRX_DETECT_AVMUTE,
+	HDMIRX_CHECK_MODE,
+	HDMIRX_RELEASED,
+} HDMIRX_APSTATUS_T;
+
+typedef enum {
+	IOCTRL_HDMI_PHY_START = 0,
+	IOCTRL_HDMI_PHY_STOP,
+	IOCTRL_HDMI_GET_STRUCT,
+	IOCTRL_HDMI_SET_TIMER,
+	IOCTRL_HDMI_GET_TIMER,
+	IOCTRL_HDMI_AUDIO_PLL_SAMPLE_START,
+	IOCTRL_HDMI_AUDIO_PLL_SAMPLE_STOP,
+	IOCTRL_HDMI_AUDIO_PLL_SAMPLE_DUMP,
+	IOCTRL_HDMI_SET_APSTATUS
+}  HDMIRX_IOCTL_T;
+
+typedef enum {
+	MODE_RAG_DEFAULT	= 0x0,
+	MODE_RAG_LIMIT,
+	MODE_RAG_FULL,
+	MODE_RAG_UNKNOW
+} HDMI_RGB_YUV_RANGE_MODE_T;
+
+typedef enum {
+	HDMI_COLORIMETRY_NOSPECIFIED = 0,
+	HDMI_COLORIMETRY_601,
+	HDMI_COLORIMETRY_709,
+	HDMI_COLORIMETRY_XYYCC601,
+	HDMI_COLORIMETRY_XYYCC709,
+	HDMI_COLORIMETRY_SYCC601,
+	HDMI_COLORIMETRY_ADOBE_YCC601,
+	HDMI_COLORIMETRY_ADOBE_RGB,
+} HDMI_COLORIMETRY_T;
+
+typedef enum {
+	COLOR_RGB = 0x00,
+	COLOR_YUV422,
+	COLOR_YUV444,
+	COLOR_YUV420,
+	COLOR_UNKNOW
+} HDMI_COLOR_SPACE_T;
+
+typedef enum {
+	HDMI_COLOR_DEPTH_8B = 0,
+	HDMI_COLOR_DEPTH_10B,
+	HDMI_COLOR_DEPTH_12B,
+	HDMI_COLOR_DEPTH_16B,
+} HDMI_COLOR_DEPTH_T;
+
+typedef enum {
+	HDMI_3D_OPMODE_DISABLE = 0,
+	HDMI_3D_OPMODE_HW,
+	HDMI_3D_OPMODE_HW_2DONLY_L,
+	HDMI_3D_OPMODE_HW_2DONLY_R,
+	HDMI_3D_OPMODE_SW,
+	HDMI_3D_OPMODE_HW_NODMA
+} HDMI_3D_OPMODE_T;
+
+typedef enum {
+	HDMI_PTG_MODE_BACKGROUD_ONLY,
+	HDMI_PTG_MODE_H_COLOR_BAR,
+	HDMI_PTG_MODE_V_COLOR_BAR,
+	HDMI_PTG_MODE_H_GREDIENT,
+	HDMI_PTG_MODE_V_GREDIENT,
+	HDMI_PTG_MODE_HV_GREDIENT,
+	HDMI_PTG_MODE_BITMAP,
+	HDMI_PTG_CROSS_COLOR_SEQ0,
+	HDMI_PTG_CROSS_COLOR_SEQ1,
+	HDMI_PTG_CROSS_COLOR_SEQ2,
+	HDMI_PTG_CROSS_COLOR_SEQ3,
+} HDMI_PTG_MODE_T;
+
+typedef enum {
+	HDMI_PATH_POLICY_2D_ONLY = 0,
+	HDMI_PATH_POLICY_3D_NODMA,
+	HDMI_PATH_POLICY_3D_DMA
+} HDMI_PATH_POLICY_T;
+
+typedef enum {
+	HVF_NO,
+	HVF_EXT,
+	HVF_3D,
+	HVF_RESERVED
+} HDMI_HVF_E;
+
+typedef enum {
+	HDMI3D_FRAME_PACKING = 0,
+	HDMI3D_FIELD_ALTERNATIVE = 1,
+	HDMI3D_LINE_ALTERNATIVE = 2,
+	HDMI3D_SIDE_BY_SIDE_FULL = 3,
+	HDMI3D_L_DEPTH = 4,
+	HDMI3D_L_DEPTH_GPX = 5,
+	HDMI3D_TOP_AND_BOTTOM = 6,
+	HDMI3D_FRAMESEQUENCE = 7,
+	HDMI3D_SIDE_BY_SIDE_HALF = 8,
+	/* --- new 3D format --- */
+	HDMI3D_LINE_BY_LINE = 9,
+	HDMI3D_VERTICAL_STRIPE = 10,
+	HDMI3D_CHECKER_BOARD = 11,
+	HDMI3D_REALID = 12,
+	HDMI3D_SENSIO = 13,
+	/* ------------------- */
+	HDMI3D_RSV1,
+	HDMI3D_2D_ONLY,
+	HDMI3D_UNKOWN = 0xFFFFFFFF
+} HDMI_3D_T;
+
+typedef enum {
+	HDCPRX_STATE_NONE = 0,
+	HDCPRX_STATE_1PX_DISCOVER = 1,
+	HDCPRX_STATE_1PX_ON = 2,
+	HDCPRX_STATE_2P2_DISCOVER = 3,
+	HDCPRX_STATE_2P2_ON = 4
+} HDCPRX_STATE;
+
+typedef enum _HDMI_DC_ON_STATE_ {
+	HDMI_DC_ON_NONE = 0,
+	HDMI_DC_ON_ENABLE_DELAY,
+	HDMI_DC_ON_START_TIME,
+	HDMI_DC_ON_FINISH,
+	HDMI_DC_ON_UNKNOW
+} HDMI_DC_ON_STATE_E;
+
+typedef enum _HDMI_STR_HPD_TOGGLE_STATE_ {
+	HDMI_STR_HPD_TOGGLE_NONE = 0,
+	HDMI_STR_HPD_TOGGLE_ENTER,
+	HDMI_STR_HPD_TOGGLE_READY,
+	HDMI_STR_HPD_TOGGLE_UNKNOW,
+} HDMI_STR_HPD_TOGGLE_STATE_E;
+
+typedef enum _HDMI_DISPLAY_DELAY_STATE_ {
+	HDMI_DISPLAY_DELAY_NONE = 0,
+	HDMI_DISPLAY_DELAY_INIT,
+	HDMI_DISPLAY_DELAY_START,
+	HDMI_DISPLAY_DELAY_FINISH,
+} HDMI_DISPLAY_DELAY_STATE_STATE_E;
+
+typedef enum _HDMI_SPECIFIC_DEVICE_ {
+	HDMI_SPECIFIC_DEVICE_NONE = 0,
+	HDMI_SPECIFIC_DEVICE_SK_STB,
+	HDMI_SPECIFIC_DEVICE_KT_STB_IC1000,
+	HDMI_SPECIFIC_DEVICE_KT_STB_IC1100,
+	HDMI_SPECIFIC_DEVICE_KT_STB_KT600EJ,
+	HDMI_SPECIFIC_DEVICE_LHB_755,
+	HDMI_SPECIFIC_DEVICE_ROKU_ULTRA_4640R,
+	HDMI_SPECIFIC_DEVICE_SAMSUNG_GX_HC630CH,
+	HDMI_SPECIFIC_DEVICE_KT_STB_KAO_CT1100,
+} HDMI_SPECIFIC_DEVICE_E;
+
+typedef enum {
+	MAIN_FSM_HDMI_WAIT_SYNC,
+	MAIN_FSM_HDMI_SETUP_VEDIO_PLL,
+	MAIN_FSM_HDMI_MEASURE,
+	MAIN_FSM_HDMI_MEASURE_ACTIVE_SPACE,
+	MAIN_FSM_HDMI_WAIT_READY,
+	MAIN_FSM_HDMI_DISPLAY_ON,
+	MAIN_FSM_HDMI_VIDEO_READY
+} HDMI_MAIN_FSM_T;
+
+enum INFOFRAME_TYPE_CODES {
+	INFOFRAME_VSI = 0x81,
+	INFOFRAME_AVI = 0x82,
+	INFOFRAME_SPD = 0x83,
+	INFOFRAME_AUDIO = 0x84,
+	INFOFRAME_MPEG = 0x85,
+	INFOFRAME_NTSC = 0x86,
+	INFOFRAME_DRM = 0x87,
+};
+
+typedef struct {
+	unsigned char spd_vn_name[8];
+	unsigned char psd_pd_desc[16];
+} HDMI_POOR_DEV_T;
+
+typedef struct	{
+	char name[25];
+	int progressive;
+	unsigned int h_act_len;
+	unsigned int v_act_len;
+	unsigned int lr_v_act_len;
+	unsigned int v_active_space1;
+	unsigned int v_active_space2;
+} HDMI_ACTIVE_SPACE_TABLE_T;
+
+typedef struct {
+	unsigned char type_code;
+	unsigned char ver;
+	unsigned char len;
+	unsigned char Checksum;
+	unsigned char Reg_ID[3];
+	unsigned char Payload[25];
+} HDMI_VSI_T;
+
+typedef struct {
+	unsigned char type_code;
+	unsigned char ver;
+	unsigned char len;
+	unsigned int  S:2;
+	unsigned int  B:2;
+	unsigned int  A:1;
+	unsigned int  Y:3;
+	unsigned int  R:4;
+	unsigned int  M:2;
+	unsigned int  C:2;
+	unsigned int  SC:2;
+	unsigned int  Q:2;
+	unsigned int  EC:3;
+	unsigned int  ITC:1;
+	unsigned int  VIC:8;
+	unsigned int  PR:4;
+	unsigned int  CN:2;
+	unsigned int  YQ:2;
+	unsigned char ETB07_00;
+	unsigned char ETB15_08;
+	unsigned char SBB07_00;
+	unsigned char SBB15_08;
+	unsigned char ELB07_00;
+	unsigned char ELB15_08;
+	unsigned char SRB07_00;
+	unsigned char SRB15_08;
+} HDMI_AVI_T;
+
+typedef struct {
+	unsigned char type_code;
+	unsigned char ver;
+	unsigned char len;
+	unsigned char VendorName[8];
+	unsigned char ProductDesc[16];
+	unsigned char SourceInfo;
+} HDMI_SPD_T;
+
+/**
+ * HDMI_AUDIO_T - Audio InfoFrame
+ */
+typedef struct {
+	unsigned char type_code;
+	unsigned char ver;
+	unsigned char len;
+	/* DataByte1 */
+	unsigned char  CC:3;
+	unsigned char  F13:1;
+	unsigned char  CT:4;
+	/* DataByte2 */
+	unsigned char  SS:2;
+	unsigned char  SF:3;
+	unsigned char  F27_25:3;
+	/* DataByte3 */
+	unsigned char  CXT:5;
+	unsigned char  F37_35:3;
+	/* DataByte4 */
+	unsigned char  CA:8;
+	/* DataByte5 */
+	unsigned char  LFEPBL:2;
+	unsigned char  F52:1;
+	unsigned char  LSV:4;
+	unsigned char  DM_INH:1;
+	/* DataByte6-10 */
+	unsigned char F67_60;
+	unsigned char F77_70;
+	unsigned char F87_80;
+	unsigned char F97_90;
+	unsigned char F107_100;
+} HDMI_AUDIO_T;
+
+typedef struct {
+	unsigned char type_code;
+	unsigned char ver;
+	unsigned char len;
+	unsigned char  eEOTFtype;
+	unsigned char  eMeta_Desc;
+	unsigned short display_primaries_x0;
+	unsigned short display_primaries_y0;
+	unsigned short display_primaries_x1;
+	unsigned short display_primaries_y1;
+	unsigned short display_primaries_x2;
+	unsigned short display_primaries_y2;
+	unsigned short white_point_x;
+	unsigned short white_point_y;
+	unsigned short max_display_mastering_luminance;
+	unsigned short min_display_mastering_luminance;
+	unsigned short maximum_content_light_level;
+	unsigned short maximum_frame_average_light_level;
+	unsigned char  reserved;
+} __attribute__((packed)) HDMI_DRM_T;
+
+typedef struct {
+	unsigned char SM;
+	unsigned char SN;
+	unsigned char RatioM;
+	unsigned char RatioN;
+} VIDEO_DPLL_RATIO_T;
+
+typedef struct {
+	unsigned char dpll_M;
+	unsigned char dpll_N;
+	unsigned char dpll_IP;
+	unsigned char dpll_RS;
+} VIDEO_DPLL_FIX_T;
+
+typedef struct {
+	unsigned char min_M;
+	unsigned char max_M;
+	unsigned char dpll_IP;
+	unsigned char dpll_RS;
+} VIDEO_DPLL_RANGE_T;
+
+typedef struct {
+	int freq;
+	unsigned char coeff;
+	unsigned char rate;
+} HDMI_AUDIO_PLL_COEFF_T;
+
+typedef struct {
+	unsigned int  freq;
+	unsigned char N;
+	unsigned char M;
+	unsigned char O;
+	unsigned char S;
+	unsigned char S1;
+	unsigned int D_HighByte;
+	unsigned int D_LowByte;
+	const char *sample_rate;
+} HDMI_AUDIO_PLL_PARAM_T;
+
+
+/**
+ * HDMI_AUDIO_FREQ_T
+ * @ACR_freq: Audio Frequency from ACR
+ * @AudioInfo_freq: Audio Frequency from Audio Info Frame
+ * @SPDIF_freq: Audio Frequency from SPDIF Channel Status Info
+ */
+typedef struct {
+	unsigned long ACR_freq;
+	unsigned long AudioInfo_freq;
+	unsigned long SPDIF_freq;
+	unsigned int ACR_N;
+} HDMI_AUDIO_FREQ_T;
+
+typedef struct {
+	u_int16_t b_upper;
+	u_int16_t b_lower;
+	u_int16_t M_code;
+	u_int16_t N_code;
+
+	u_int8_t PI_DIV;
+	u_int8_t DEMUX;
+	u_int8_t RATE_SEL;
+	u_int8_t CK_LDOD;
+	u_int8_t CK_CS;
+
+	u_int8_t CK_RS;
+	u_int8_t EQ_adj;
+	u_int8_t CDR_bias;
+	u_int8_t CDR_KP;
+	u_int8_t CDR_KP2;
+
+	u_int8_t CDR_KI;
+	u_int8_t CDR_KD;
+	u_int8_t EQ_gain;
+	u_int8_t EQ_bias;
+	u_int8_t CK_Icp;
+
+	u_int8_t PR;
+	u_int8_t pscaler;
+	u_int8_t vsel_ldo;
+	u_int8_t CMU_SEL_D4;
+	u_int8_t Icp_DUL;
+
+	u_int8_t PI_CSEL;
+	u_int8_t PI_CURRENT;
+	u_int8_t PI_ISEL;
+	u_int8_t EN_CAP;
+	u_int8_t CMU_KVCO;
+	const char band_name[30];
+} HDMI_PHY_PARAM_T;
+
+typedef struct {
+	u_int16_t fvco_upper;
+	u_int16_t fvco_lower;
+	u_int8_t CMU_KVCO;
+	u_int8_t EN_CAP;
+	u_int8_t CCO_BAND_SEL;
+	u_int8_t PI_ISEL;
+	u_int8_t PI_CSEL;
+} HDMI_PHY_PARAM2_T;
+
+typedef struct {
+	unsigned char DEF_ready;
+	unsigned char measure_ready;
+	unsigned char detect_done;
+	unsigned char audio_detect_done;
+	unsigned char hdcp_state;/* enum HDCPRX_STATE */
+	unsigned char hdr_received;
+} HDMIRX_STATE_STRUCT_T;
+
+typedef struct {
+	HDMIRX_APSTATUS_T apstatus;
+	unsigned int idle_count;
+} HDMIRX_PHY_IDLE_PATCH_T;
+
+typedef struct {
+	unsigned char BKsv[5];
+	unsigned char Key[320];
+} HDCP_KEY_T;
+
+typedef struct {
+	unsigned int v_total;
+	unsigned int h_total;
+	unsigned int v_act_len;
+	unsigned int h_act_len;
+	unsigned int v_act_sta;
+	unsigned int h_act_sta;
+	unsigned int v_freq;
+	unsigned int h_freq;
+	unsigned int polarity;
+	unsigned int mode_id;
+	unsigned int modetable_index;
+	unsigned char is_interlace;
+
+	HDMI_DVI_MODE_T 	mode;
+	HDMI_COLOR_DEPTH_T colordepth;
+	HDMI_COLOR_SPACE_T colorspace;
+	HDMI_COLORIMETRY_T  colorimetry;
+	unsigned char pixel_repeat;
+
+	HDMI_HVF_E hvf;
+	HDMI_3D_T h3dformat;
+
+	unsigned int tmds_clk_b;
+
+	unsigned char tmds_clk_stable_cnt;
+
+	/* Only for fram packing */
+	unsigned int v_active_space1;
+	unsigned int v_active_space2;
+} HDMI_TIMING_T;
+
+
+typedef struct {
+	unsigned char coding_type;/* 0=pcm; 1=nonpcm */
+	unsigned int audio_freq;
+	unsigned char sr_mismatch_cnt;
+	unsigned char track_mode_tgl;
+} HDMI_AUDIO_STATE;
+
+typedef struct {
+	HDMI_PHY_PARAM_T phy_param_t;
+
+	HDMI_TIMING_T timing_t;
+	HDMI_AUDIO_STATE audio_t;
+
+	HDMI_AVI_T avi_t;
+	HDMI_VSI_T vsi_t;
+	HDMI_SPD_T spd_t;
+	HDMI_AUDIO_T audiopkt_t;
+	HDMI_DRM_T drm_t;
+	unsigned char no_avi_cnt;
+	unsigned char no_vsi_cnt;
+	unsigned char no_spd_cnt;
+	unsigned char no_audiopkt_cnt;
+	unsigned char no_drm_cnt;
+
+	HDMI_MAIN_FSM_T video_fsm;
+	HDMI_AUDIO_FSM_T audio_fsm;
+
+#if HDMI2p0
+	unsigned char scramble_flag;
+	unsigned char clock40x_flag;
+	unsigned char hdmi2p0_tmds_toggle_flag;
+#endif
+
+	unsigned char vs_cnt;
+
+	unsigned char meas_retry_cnt;
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+	unsigned char tx_hdcp_state;
+#endif
+
+	/* HPD */
+	int rx_5v_state;
+	int gpio_hpd_ctrl;
+	int gpio_5v_det;
+
+} HDMI_PORT_INFO_T;
+
+#ifdef CONFIG_RTK_HDCP1x_REPEATER
+#define HDCP_Aksv_SIZE 5
+#define KSVLIST_SIZE   640
+struct hdcp_ksvlist_info {
+	uint8_t Aksv[HDCP_Aksv_SIZE];
+	uint8_t ksvlist[KSVLIST_SIZE];
+	uint8_t bstatus[2];
+	uint32_t device_count;
+	uint8_t Bksv[HDCP_Aksv_SIZE];
+};
+#endif
+
+struct hdcp2p2_wait_event {
+	spinlock_t slock;
+	wait_queue_head_t read_wq;
+	unsigned int condition;
+};
+
+/*
+ * HDMI Driver Private MARCO
+ */
+#define SET_H_VIDEO_FSM(fsm)	(hdmi_rx.video_fsm = fsm)
+#define SET_H_AUDIO_FSM(fsm)	(hdmi_rx.audio_fsm = fsm)
+	
+#define SET_H_INTERLACE(interlace)	(hdmi_rx.timing_t.is_interlace = interlace)
+#define SET_H_MODE(m)		(hdmi_rx.timing_t.mode = m)
+#define SET_H_COLOR_DEPTH(color)	(hdmi_rx.timing_t.colordepth= color)
+#define SET_H_COLOR_SPACE(color)	(hdmi_rx.timing_t.colorspace = color)
+#define SET_H_PIXEL_REPEAT(pr)	(hdmi_rx.timing_t.pixel_repeat = pr)
+#define SET_H_VIDEO_FORMAT(fmt)	(hdmi_rx.timing_t.hvf = fmt)
+#define SET_H_3DFORMAT(fmt) 	(hdmi_rx.timing_t.h3dformat = fmt)
+	
+#define SET_AUDIO_TYPE(type)	(hdmi_rx.audio_type = type)
+	
+#define GET_H_VIDEO_FSM()		(hdmi_rx.video_fsm)
+#define GET_H_AUDIO_FSM()		(hdmi_rx.audio_fsm)
+	
+#define GET_H_INTERLACE()		(hdmi_rx.timing_t.is_interlace)
+#define GET_H_MODE()		(hdmi_rx.timing_t.mode)
+#define GET_H_COLOR_DEPTH()	(hdmi_rx.timing_t.colordepth)
+#define GET_H_COLOR_SPACE()	(hdmi_rx.timing_t.colorspace)
+#define GET_H_PIXEL_REPEAT()	(hdmi_rx.timing_t.pixel_repeat)
+#define GET_H_VIDEO_FORMAT() 	(hdmi_rx.timing_t.hvf)
+#define GET_H_3DFORMAT() 		(hdmi_rx.timing_t.h3dformat)
+	
+#define GET_AUDIO_TYPE()		(hdmi_rx.audio_type)
+
+extern HDMI_PORT_INFO_T	hdmi_rx;
+extern HDMIRX_STATE_STRUCT_T hdmirx_state;
+
+/* hdmiPhy*/
+extern void lib_hdmi_phy_init(void);
+extern int rxphy_isr(void);
+extern void rxphy_init_struct(void);
+extern void rxphy_isr_set(unsigned char en);
+extern unsigned char rxphy_is_clk_stable(void);
+extern unsigned int rxphy_get_clk(void);
+extern unsigned char rxphy_get_setphy_done(void);
+extern void hdmi_open_err_detect(void);
+extern unsigned char lib_hdmi_is_clk_ready(void);
+extern unsigned int lib_hdmi_get_clock(void);
+extern void lib_hdmi_trigger_measure_start(void);
+extern void rxphy_reset_setphy_proc(void);
+extern unsigned char hdmi_char_err_detection(void);
+extern unsigned char hdmi_is_long_cable(void);
+extern void hdmi_dfe_recovery_6g_long_cable(void);
+extern void lib_hdmi_trigger_measure_stop(void);
+extern void hdmi_set_phy(unsigned int b);
+extern unsigned char hdmi_dfe_record(unsigned int clk);
+extern unsigned char hdmi_dfe_close(unsigned int clk, unsigned char phy_state);
+extern void hdmi_dfe_hi_speed(unsigned int b_clk);
+extern void hdmi_dfe_mi_speed(unsigned int b_clk);
+extern void lib_hdmi_mac_release(void);
+extern void hdmi_dfe_6g_long_cable_patch(void);
+extern void hdmi_dump_dfe_para(void);
+extern void lib_hdmi_ck_md_ref_sel(void);
+extern void lib_hdmi_z0_set(unsigned char lane, unsigned char enable);
+
+
+/* hdmiHdmi */
+extern void Hdmi_SetHPD(char high);
+extern void hdmi_init(void);
+extern unsigned char hdmi_detect_mode(void);
+extern unsigned char hdmi_audio_detect(void);
+extern void hdmi_release_source(void);
+extern void hdmi_port_var_init(void);
+extern void hdmi_audio_close(void);
+extern void hdmi_disconnect_source(void);
+extern void lib_hdmi_video_output(unsigned char on);
+extern unsigned char hdmi_watchdog_apply(unsigned char Enable, unsigned char Condition);
+extern void hdmi_audio_var_init(void);
+extern unsigned char hdmi_check_condition_change(void);
+extern unsigned char hdmi_wait_sync(void);
+extern unsigned char hdmi_setup_video_pll(void);
+extern unsigned char hdmi_measure(void);
+extern unsigned char hdmi_display_on(void);
+extern unsigned char hdmi_video_ready(void);
+extern unsigned char hdmi_get_colorspace_reg(void);
+extern unsigned char hdmi_get_colordepth(void);
+extern unsigned char hdmi_get_colorimetry(void);
+extern unsigned char hdmi_get_hdmi_mode_reg(void);
+extern void hdmi_reset_all_infoframe(void);
+extern void hdmi_update_infoframe(void);
+extern unsigned char hdmi_update_audiopkt(void);
+extern unsigned char lib_hdmi_get_vic(void);
+extern void hdmi_reset_video_state(void);
+extern void hdmi_check_connection_state(void);
+extern void hdmi2p0_check_tmds_config(void);
+extern unsigned char hdmi2p0_get_clock40x_flag(void);
+extern void hdmi2p0_reset_scdc_toggle(void);
+extern void hdmi2p0_inc_scdc_toggle(void);
+extern void hdmi2p0_align_flush(void);
+extern void hdmi_check_crc_0(void);
+extern unsigned char hdmi_get_video_format_reg(void);
+extern unsigned char hdmi_get_3d_structure_reg(void);
+extern unsigned char hdmi_bit_err_detection(void);
+extern void hdmi_reset_meas_counter(void);
+extern void hdmi2p0_detect_config(void);
+extern unsigned char hdmi_audio_wait_acr(void);
+
+
+/* hmi_lib*/
+extern void lib_hdmi_power(unsigned char enable);
+extern void lib_hdmi_tmds_init(void);
+extern void lib_hdmi_mac_init(void);
+extern void lib_hdmi_gcp_ackg_header_parsing_mode(void);
+extern void lib_hdmi_valid_format_condition(void);
+extern void lib_hdmi_misc_variable_initial(void);
+extern unsigned char lib_hdmi_get_avmute(void);
+extern unsigned char lib_hdmi_get_bch_2bit_error(void);
+extern void lib_hdmi_char_err_rst(unsigned char rst);
+extern unsigned char lib_hdmi_toggle_hpd_z0_check(unsigned char ucInit);
+extern void lib_hdmi_clear_interlace_reg(void);
+extern void lib_hdmi_set_repeat_auto(void);
+extern void lib_hdmi_set_colorspace_auto(void);
+extern void lib_hdmi_bch_error_clr(void);
+extern void lib_hdmi_audio_set_hbr_manual_mode(unsigned char manu, unsigned char mode_fw);
+extern void lib_hdmi_audio_clear_hdr_status(void);
+extern void lib_hdmi2p0_scdc_update_flag(void);
+extern unsigned char lib_hdmi_get_color_depth(void);
+extern unsigned char lib_hdmi_get_pixelrepeat(void);
+extern void lib_hdmi_set_colorspace_manual(unsigned char color_space);
+extern unsigned char lib_hdmi_get_is_interlace(HDMI_MS_T ms_mode);
+extern unsigned char lib_hdmi_set_video_pll(unsigned int b_clk, unsigned char cd, unsigned char is_interlace, unsigned char is_420);
+extern void lib_hdmi_meas_select_port(void);
+extern void lib_hdmi_crc_check(void);
+extern void lib_hdmi_set_str_toggle_hpd_state(HDMI_STR_HPD_TOGGLE_STATE_E state);
+extern HDMI_STR_HPD_TOGGLE_STATE_E lib_hdmi_get_str_toggle_hpd_state(void);
+extern unsigned char lib_hdmi_is_wdm_enable(void);
+extern void lib_hdmi_audio_output(unsigned char on);
+extern unsigned char lib_hdmi_get_is_interlace_change(void);
+extern unsigned int lib_hdmi_read_crc(void);
+extern void lib_hdmi_420_en(unsigned char en);
+extern unsigned char lib_hdmi2p0_get_tmds_config(void);
+extern void lib_hdmi2p0_scramble_enable(unsigned char on_off);
+extern unsigned char lib_hdmi_vsync_checked(void);
+extern unsigned char lib_hdmi_is_hdmi_mode(void);
+extern unsigned char lib_hdmi_get_colorspace(void);
+extern unsigned char lib_hdmi_get_video_format(void);
+extern unsigned char lib_hdmi_get_3d_structure(void);
+extern unsigned char lib_hdmi_audio_get_channel_status15_0(unsigned int bitmask, unsigned int bitshift);
+extern void lib_hdmi_tmds_out_ctrl(unsigned char bypass, unsigned int r, unsigned int g, unsigned int b);
+extern void lib_hdmi_audio_clear_phase_error(void);
+extern unsigned char lib_hdmi_audio_is_pll_unlock(void);
+extern unsigned char lib_hdmi_audio_is_fifo_overflow(void);
+extern unsigned char lib_hdmi_audio_is_fifo_underflow(void);
+extern void lib_hdmi_audio_wclr_pll_unlock(void);
+extern void lib_hdmi_audio_wclr_fifo_overflow(void);
+extern void lib_hdmi_audio_wclr_fifo_underflow(void);
+extern void lib_hdmi_audio_cts_bound(unsigned int clk);
+extern void lib_hdmi_audio_n_bound(unsigned int freq);
+extern void lib_hdmi2p0_reset_scdc(void);
+extern void lib_hdmi_mac_afifo_enable(void);
+extern void lib_hdmi_set_repeat_manual(unsigned char rep_value);
+extern void lib_hdmi_audio_pop_n_cts(void);
+extern void lib_hdmi_audio_clear_fs(void);
+extern unsigned char lib_hdmi_audio_pop_n_cts_done(void);
+extern unsigned char lib_hdmi_audio_fs_from_cs(void);
+extern unsigned char lib_hdmi_audio_get_freq_from_cs(void);
+extern unsigned int lib_hdmi_audio_get_n(void);
+extern unsigned int lib_hdmi_audio_get_cts(void);
+extern unsigned char lib_hdmi_audio_get_hbr_manual_mode(void);
+extern void lib_hdmi_audio_init(void);
+extern unsigned char hdmi_audio_wait_2_samples(void);
+extern void lib_hdmi_audio_generate(void);
+extern unsigned char lib_hdmi_audio_get_format(void);
+extern unsigned char lib_hdmi_audio_is_output(void);
+extern void lib_hdmi_set_rsv_packet_type(unsigned char index, unsigned char pkt_type);
+extern void lib_hdmi_clear_rsv_packet0_status(void);
+extern void lib_hdmi_clear_rsv_packet1_status(void);
+extern unsigned char lib_hdmi_audio_get_hbr_mode(void);
+extern void lib_hdmi_clear_avmute(void);
+extern void lib_hdmi_set_toggle_hpd_z0_flag(unsigned char uc_flag);
+extern void lib_hdmi_clear_fvs_received_status(void);
+extern void lib_hdmi_clear_vs_received_status(void);
+extern void lib_hdmi_clear_avi_received_status(void);
+extern void lib_hdmi_clear_spd_received_status(void);
+extern void lib_hdmi_clear_audiopkt_received_status(void);
+extern void lib_hdmi_clear_drm_received_status(void);
+extern unsigned char lib_hdmi_is_fvs_received(void);
+extern unsigned char lib_hdmi_is_vs_received(void);
+extern unsigned char lib_hdmi_is_avi_received(void);
+extern unsigned char lib_hdmi_is_spd_received(void);
+extern unsigned char lib_hdmi_is_audiopkt_received(void);
+extern unsigned char lib_hdmi_is_drm_received(void);
+extern unsigned char lib_hdmi_is_rsv_packet0_received(void);
+extern unsigned char lib_hdmi_is_rsv_packet1_received(void);
+extern unsigned char lib_hdmi_is_rsv_packet2_received(void);
+extern unsigned char lib_hdmi_is_rsv_packet3_received(void);
+extern void lib_hdmi_set_specific_device(HDMI_SPECIFIC_DEVICE_E device);
+extern unsigned char lib_hdmi_dc_on_delay_check(unsigned char ucInit);
+extern void lib_hdmi_set_delay_display_enable(unsigned char ucEnable);
+extern HDMI_DISPLAY_DELAY_STATE_STATE_E lib_hdmi_get_delay_display_state(void);
+extern void lib_hdmi_set_delay_display_state(HDMI_DISPLAY_DELAY_STATE_STATE_E state);
+extern unsigned char lib_hdmi_delay_check_before_display(unsigned char ucInit);
+extern unsigned char lib_hdmi_hdcp14_is_onoff(void);
+extern void lib_hdmi_wdm_enable(unsigned char enable);
+extern void lib_hdmi_auto_avmute_enable(unsigned char enable);
+extern unsigned char lib_hdmi_scdc_read(unsigned char addr);
+extern void lib_hdmi_scdc_write(unsigned char addr, unsigned char value);
+extern void lib_hdmi_read_packet_sram(unsigned int start_addr, unsigned char len, unsigned char *pbuf);
+extern void lib_hdmi_set_dc_on_delay_state(HDMI_DC_ON_STATE_E state);
+extern unsigned int lib_hdmi_get_delay_display_time(void);
+extern HDMI_SPECIFIC_DEVICE_E lib_hdmi_get_specific_device(void);
+extern u64 lib_hdmi_get_clk90k(void);
+
+
+/* hdmirx_hdcp */
+extern void Hdmi_HdcpFSM(void);
+extern void Hdmi_HdcpInit(void);
+extern unsigned char Is_HdmiRx_hdcp1x_enabled(void);
+
+#endif /* __HDMI_INTERNAL_H_ */
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiMS.c b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiMS.c
new file mode 100644
index 00000000..0232014
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiMS.c
@@ -0,0 +1,141 @@
+/*
+ * hdmiMS.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmiInternal.h"
+
+/*=================== extern Variable/Function ===================*/
+#if HDMI2p0
+extern u_int8_t   bHDMI_420_Space;/* For YUV420 */
+#endif
+extern HDMI_CONST VIDEO_DPLL_RATIO_T dpll_ratio[];
+
+extern unsigned int hdmirx_wrapper_get_active_pixel(void);
+extern unsigned int hdmirx_wrapper_get_active_line(void);
+/*======================================================*/
+
+
+#if HDMI_INTERNAL_DEBUG/* RD test */
+int Hdmi_CRC_check(void)
+{
+	UINT8 tmo = 50;
+	unsigned int crc_result;
+	static unsigned int pre_crc_result = 0;
+
+	/* Disable CRC check */
+	hdmi_rx_reg_mask32(TMDS_CRCC, ~TMDS_CRCC_crcc_mask, 0, HDMI_RX_MAC);
+	/* Enable CRC check */
+	hdmi_rx_reg_mask32(TMDS_CRCC, ~TMDS_CRCC_crcc_mask, TMDS_CRCC_crcc(1), HDMI_RX_MAC);
+
+	/* Wait CRC done bit */
+	while (!(hdmi_rx_reg_read32(TMDS_CRCC, HDMI_RX_MAC)&TMDS_CRCC_crc_done_mask)) {
+		usleep_range(10000, 15000);/* 10~15ms */
+		if (!tmo--) {
+			/* HDMI_PRINTF("[HDMI] WARNING: FAIL: Wait CRC Timeout !!!\n"); */
+			HDMIRX_INFO("CRC check timeout");
+			return FALSE;
+		}
+	}
+
+	crc_result = hdmi_rx_reg_read32(TMDS_CRCO0, HDMI_RX_MAC);
+
+	if (crc_result != pre_crc_result) {
+		pre_crc_result = crc_result;
+		HDMIRX_INFO("CRC result changed (0x%08x)", crc_result);
+	}
+
+	return TRUE;
+}
+#endif
+
+unsigned char Hdmi_WaitVsync(int num)
+{
+	int i;
+
+	hdmi_rx_reg_mask32(HDMI_TMDS_CTRL, ~TMDS_CTRL_yo_mask, TMDS_CTRL_yo(1), HDMI_RX_MAC);
+
+	for (i = 0; i < num; i++) {
+		/* Wait vsync done */
+		if (TMDS_CTRL_get_yo(hdmi_rx_reg_read32(HDMI_TMDS_CTRL, HDMI_RX_MAC)))
+			return 1;
+
+		usleep_range(10000, 15000);/* 10~15ms */
+	}
+
+	HDMI_PRINTF("Wait vsync timeout\n");
+	return 0;
+}
+
+unsigned int Hdmi_GetVSyncCountInit(void)
+{
+	hdmi_rx.vs_cnt = 0;
+
+	return hdmi.vsync_cnt;
+}
+unsigned int Hdmi_GetVSyncCount(void)
+{
+	if (TMDS_CTRL_get_yo(hdmi_rx_reg_read32(HDMI_TMDS_CTRL, HDMI_RX_MAC))) {
+		hdmi_rx_reg_mask32(HDMI_TMDS_CTRL, ~HDMI_TMDS_CTRL_yo_mask, HDMI_TMDS_CTRL_yo(1), HDMI_RX_MAC);
+		hdmi.vsync_cnt++;
+	}
+
+	return hdmi.vsync_cnt;
+}
+
+HDMI_COLORIMETRY_T Hdmi_GetColorimetry(void)
+{
+	unsigned int C, EC;
+
+	hdmi_rx_reg_write32(HDMI_PSAP, 0x0, HDMI_RX_MAC);
+	if (hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC) != 0)
+		return HDMI_COLORIMETRY_NOSPECIFIED;
+
+	hdmi_rx_reg_write32(HDMI_PSAP, 0x5, HDMI_RX_MAC);
+	C = ((hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC) >> 6) & 0x03);
+	hdmi_rx_reg_write32(HDMI_PSAP, 0x6, HDMI_RX_MAC);
+	EC = ((hdmi_rx_reg_read32(HDMI_PSDP, HDMI_RX_MAC) >> 4) & 0x07);
+
+	if (C != 0x03) {
+		return (HDMI_COLORIMETRY_T) C;
+	} else {
+		return (HDMI_COLORIMETRY_T) (HDMI_COLORIMETRY_XYYCC601 + EC);
+	}
+
+}
+
+char Hdmi_GetPixelDownSample(void)
+{
+	if (HDMI_VCR_get_prdsam(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC))) {
+		return HDMI_VCR_get_dsc_r(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+	} else {
+		return HDMI_VCR_get_dsc(hdmi_rx_reg_read32(HDMI_VCR, HDMI_RX_MAC));
+	}
+}
+
+int Hdmi_GetColorDepth(void)
+{
+	return TMDS_DPC0_dpc_cd(hdmi_rx_reg_read32(TMDS_DPC0, HDMI_RX_MAC));
+}
+
+int hdmi_onms_measure(HDMI_TIMING_T *timing)
+{
+	timing->h_act_len = hdmirx_wrapper_get_active_pixel();
+	timing->v_act_len = hdmirx_wrapper_get_active_line();
+
+	timing->h_total = timing->h_act_len;
+	timing->v_total = timing->v_act_len;
+
+	if ((timing->h_act_len == 0) || (timing->v_act_len == 0) ||
+		(timing->h_total == 0) || (timing->v_total == 0))
+		return HDMI_ERR_ONMS_WRONG_TIMING;
+	else
+		return HDMI_ERR_NO;
+}
+
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiPhy.c b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiPhy.c
new file mode 100644
index 00000000..edfa78e
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/rx_drv/hdmiPhy.c
@@ -0,0 +1,2853 @@
+/*
+ * hdmiPhy.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmiInternal.h"
+
+
+/*
+ * Marco or Definitions
+ */
+#ifndef IRQ_HANDLED
+#define IRQ_HANDLED  1
+#define IRQ_NONE     0
+#endif
+
+
+#define CLOCK_TOLERANCE()     (phy_st.clk_tolerance)
+#define CLK_DEBOUNCE_CNT        7 /* Set 2, it will easy to set phy in background and influence others */
+#define CLK_DEBOUNCE_SHORT_CNT  1 /* To prevent Tx HDCP handshake too fast */
+#define NOCLK_DEBOUNCE_CNT      8 /* Count for confirm it's no clock, (QD980>5, has sudden no clock and clear scdc) */
+#define CLK_UNSTABLE_CNT        2 /* Count for clock unstable change */
+
+#define TMDS_CHAR_ERR_PERIOD    4
+#define TMDS_CHAR_ERR_THREAD    8
+#define TMDS_CHAR_ERR_MAX_LOOP  8 /* TMDS_CHAR_ERR_PERIOD*2 is safe */
+
+#define TMDS_BIT_ERR_PERIOD     16
+#define TMDS_BIT_ERR_THREAD     32
+#define TMDS_BIT_ERR_MAX_LOOP   32 /* TMDS_BIT_ERR_PERIOD*2 is safe */
+
+#define MAX_ERR_DETECT_TIMES    10
+
+#define ManualZ0                0x12
+#define HDMI_EQ_LE_NOT_ZERO_ENABLE
+
+
+
+/* TMDS clock define */
+#define TMDS_6G     5688
+#define TMDS_5G     4740
+#define TMDS_4G     3792
+#define TMDS_3G     2844
+#define TMDS_1p5G   1422
+
+
+/* Fvco = (Fi*M*Prescalar*CMU_SEL_D4)/N */
+HDMI_PHY_PARAM_T hdmi_phy_param[] = {
+	/* 300~600 M */
+	{.b_upper = 5860, .b_lower = 2844, .M_code = 16, .N_code = 0,
+	 .PI_DIV = 0, .DEMUX = 1, .RATE_SEL = 0x0, .CK_LDOD = 0x3, .CK_CS = 0x3,
+	 .CK_RS = 0x2, .EQ_adj = 0x2, .CDR_bias = 0x1, .CDR_KP = (0x8 << 0), .CDR_KP2 = 0x0,
+	 .CDR_KI = 0x1, .CDR_KD = 0x0, .EQ_gain = 0x0, .EQ_bias = 0x1, .CK_Icp = 0x7,
+	 .PR = 0x0, .pscaler = 0x0, .vsel_ldo = 7, .CMU_SEL_D4 = 0x0, .Icp_DUL = 0x0,
+	 .PI_CSEL = 0x0, .PI_CURRENT = 0x0, .PI_ISEL = 0x0, .EN_CAP = 0x0, .CMU_KVCO = 0x1,
+	 .band_name = "300M~600M half rate"},
+	/* 150~300 M For LG UD generator issue to change Kp 5=>6 , M/N => 20/2 */
+	{.b_upper = 2844, .b_lower = 1422, .M_code = 36, .N_code = 1,
+	 .PI_DIV = 1, .DEMUX = 2, .RATE_SEL = 0x1, .CK_LDOD = 0x3, .CK_CS = 0x3,
+	 .CK_RS = 0x2, .EQ_adj = 0x4, .CDR_bias = 0x1, .CDR_KP = (0x20 << 0), .CDR_KP2 = 0x4,
+	 .CDR_KI = 0x1, .CDR_KD = 0x0, .EQ_gain = 0x1, .EQ_bias = 0x1, .CK_Icp = 0x4,
+	 .PR = 0x0, .pscaler = 0x1, .vsel_ldo = 7, .CMU_SEL_D4 = 0x0, .Icp_DUL = 0x0,
+	 .PI_CSEL = 0x0, .PI_CURRENT = 0x0, .PI_ISEL = 0x0, .EN_CAP = 0x0, .CMU_KVCO = 0x1,
+	 .band_name = "150M~300M full rate"},
+	/* 75~150 M */
+	{.b_upper = 1422, .b_lower = 711, .M_code = 36, .N_code = 0,
+	 .PI_DIV = 2, .DEMUX = 3, .RATE_SEL = 0x2, .CK_LDOD = 0x3, .CK_CS = 0x3,
+	 .CK_RS = 0x2, .EQ_adj = 0x9, .CDR_bias = 0x1, .CDR_KP = (0x20 << 0), .CDR_KP2 = 0x0,
+	 .CDR_KI = 0x0, .CDR_KD = 0x0, .EQ_gain = 0x1, .EQ_bias = 0x1, .CK_Icp = 0x6,
+	 .PR = 0x1, .pscaler = 0x1, .vsel_ldo = 7, .CMU_SEL_D4 = 0x0, .Icp_DUL = 0x0,
+	 .PI_CSEL = 0x0, .PI_CURRENT = 0x0, .PI_ISEL = 0x0, .EN_CAP = 0x0, .CMU_KVCO = 0x1,
+	 .band_name = "75M~150M full rate+DS1"},
+	/* 37.5~75M */
+	{.b_upper = 711, .b_lower = 355, .M_code = 76, .N_code = 0,
+	 .PI_DIV = 3, .DEMUX = 3, .RATE_SEL = 0x2, .CK_LDOD = 0x3, .CK_CS = 0x3,
+	 .CK_RS = 0x2, .EQ_adj = 0x4, .CDR_bias = 0x1, .CDR_KP = (0x10 << 0), .CDR_KP2 = 0x0,
+	 .CDR_KI = 0x0, .CDR_KD = 0x0, .EQ_gain = 0x1, .EQ_bias = 0x1, .CK_Icp = 0x6,
+	 .PR = 0x2, .pscaler = 0x1, .vsel_ldo = 7, .CMU_SEL_D4 = 0x0, .Icp_DUL = 0x1,
+	 .PI_CSEL = 0x0, .PI_CURRENT = 0x0, .PI_ISEL = 0x0, .EN_CAP = 0x0, .CMU_KVCO = 0x1,
+	 .band_name = "37.5M~75M full rate+DS2"},
+	/* 13.5M~ 37.5M */
+	{.b_upper = 355, .b_lower = 128, .M_code = 76, .N_code = 0,
+	 .PI_DIV = 4, .DEMUX = 3, .RATE_SEL = 0x2, .CK_LDOD = 0x3, .CK_CS = 0x3,
+	 .CK_RS = 0x7, .EQ_adj = 0x4, .CDR_bias = 0x1, .CDR_KP = (0x10 << 0), .CDR_KP2 = 0x0,
+	 .CDR_KI = 0x0, .CDR_KD = 0x0, .EQ_gain = 0x1, .EQ_bias = 0x1, .CK_Icp = 0x4,
+	 .PR = 0x3, .pscaler = 0x1, .vsel_ldo = 7, .CMU_SEL_D4 = 0x1, .Icp_DUL = 0x1,
+	 .PI_CSEL = 0x0, .PI_CURRENT = 0x0, .PI_ISEL = 0x0, .EN_CAP = 0x0, .CMU_KVCO = 0x1,
+	 .band_name = "13.5M~37M full rate+DS3"},
+};
+
+
+HDMI_PHY_PARAM2_T hdmi_phy_param2[] = {
+	{.fvco_upper = 6000, .fvco_lower = 5500, .CMU_KVCO = 0x1, .EN_CAP = 0x0, .CCO_BAND_SEL = 0x4, .PI_ISEL = 0x0, .PI_CSEL = 0x0},
+	{.fvco_upper = 5500, .fvco_lower = 5000, .CMU_KVCO = 0x1, .EN_CAP = 0x0, .CCO_BAND_SEL = 0x4, .PI_ISEL = 0x0, .PI_CSEL = 0x0},
+	{.fvco_upper = 5000, .fvco_lower = 4000, .CMU_KVCO = 0x1, .EN_CAP = 0x0, .CCO_BAND_SEL = 0x1, .PI_ISEL = 0x0, .PI_CSEL = 0x1},
+	{.fvco_upper = 4000, .fvco_lower = 3000, .CMU_KVCO = 0x0, .EN_CAP = 0x0, .CCO_BAND_SEL = 0x0, .PI_ISEL = 0x1, .PI_CSEL = 0x2},
+	{.fvco_upper = 3000, .fvco_lower = 2500, .CMU_KVCO = 0x0, .EN_CAP = 0x0, .CCO_BAND_SEL = 0x0, .PI_ISEL = 0x1, .PI_CSEL = 0x3},
+	{.fvco_upper = 2500, .fvco_lower = 2000, .CMU_KVCO = 0x0, .EN_CAP = 0x0, .CCO_BAND_SEL = 0x0, .PI_ISEL = 0x1, .PI_CSEL = 0x3},
+};
+
+typedef enum {
+	PHY_PROC_INIT,
+	PHY_PROC_RECORD,
+	PHY_PROC_CLOSE_ADP,
+	PHY_PROC_RECOVER_6G_LONGCABLE,
+	PHY_PROC_RECOVER_6G_LONGCABLE_RECORD,
+	PHY_PROC_RECOVER_6G_LONGCABLE_CLOSE_ADP,
+	PHY_PROC_RECOVER_MI,
+	PHY_PROC_DONE,
+} HDMIRX_PHY_PROC_T;
+
+
+typedef struct {
+	unsigned char vth;
+	unsigned char tap0;
+	unsigned char tap0max;
+	unsigned char tap0min;
+	unsigned char tap1;
+	unsigned char le;
+	unsigned char lemax;
+	unsigned char lemin;
+	signed char tap2;
+} HDMIRX_PHY_DFE_T;
+
+typedef struct {
+	unsigned int clk;
+	unsigned int clk_pre;
+	unsigned int clk_debounce_count;
+	unsigned int clk_unstable_count;
+	unsigned int noclk_debounce_count;
+	unsigned int clk_tolerance;
+	unsigned char clk_stable;
+
+	unsigned char rxphy_40x;
+
+	HDMIRX_PHY_PROC_T phy_proc_state;
+
+	unsigned int char_err_loop;
+	unsigned int char_err_occurred;
+	unsigned char detect_6g_longcable;
+
+	unsigned int bit_err_loop;
+	unsigned int bit_err_occurred;
+
+	unsigned int error_detect_count;
+	HDMIRX_PHY_DFE_T dfe_t[3];
+
+} HDMIRX_PHY_STRUCT_T;
+
+
+/*
+ * Variables
+ */
+unsigned int clock_bound_3g;
+unsigned int clock_bound_1p5g;
+unsigned int clock_bound_110m;
+unsigned int clock_bound_45m;
+
+HDMIRX_PHY_STRUCT_T phy_st;
+
+unsigned int phy_isr_en;
+
+HDMIRX_STATE_STRUCT_T hdmirx_state;
+
+
+/*
+ * Funtion Declarations
+ */
+unsigned char rxphy_measure(void);
+unsigned char rxphy_is_clock_stable(unsigned int clk_tmp);
+void rxphy_job(void);
+
+void lib_hdmi_wdg_rst(unsigned char rst);
+void lib_hdmi_afifo_enable(unsigned char enable);
+void lib_hdmi_mac_reset(void);
+//void lib_hdmi_mac_release(void);
+void lib_hdmi_dfe_power(unsigned char en);
+#ifdef CONFIG_POWER_SAVING_MODE
+void lib_hdmi_eq_pi_power_en(unsigned char en);
+#endif
+void lib_hdmi_eq_bias_band_setting(unsigned int b);
+
+void lib_hdmi_set_dfe(unsigned int b, unsigned char dfe_mode);
+void lib_hdmi_set_dfe_mid_band(unsigned int b_clk, int dfe_mode);
+void lib_hdmi_dfe_manual_set(void);
+unsigned char lib_hdmi_dfe_tap0_fix(void);
+void lib_hdmi_tap0_fix_small_swing(void);
+
+void lib_hdmi_dfe_second_flow(unsigned int b_clk);
+void lib_hdmi_load_le_max(void);
+void lib_hdmi_dfe_examine_le_coef(unsigned int b_clk);
+void lib_hdmi_set_dfe_close(void);
+void lib_hdmi_dfe_record_enable(unsigned char onoff);
+unsigned char lib_hdmi_dfe_is_record_enable(void);
+void lib_hdmi_dfe_init_vth(unsigned char bgr, unsigned char value);
+void lib_hdmi_dfe_init_tap0(unsigned char bgr, unsigned char value);
+void lib_hdmi_dfe_init_tap1(unsigned char bgr, unsigned char value);
+void lib_hdmi_dfe_init_tap2(unsigned char bgr, signed char value);
+void lib_hdmi_dfe_init_le(unsigned char bgr, unsigned char value);
+void lib_hdmi_dfe_load_in_adp(unsigned char bgr, unsigned int option);
+unsigned char lib_hdmi_dfe_get_vth(unsigned char lane);
+unsigned char lib_hdmi_dfe_get_tap0(unsigned char lane);
+unsigned char lib_hdmi_dfe_get_tap0max(unsigned char lane);
+unsigned char lib_hdmi_dfe_get_tap0min(unsigned char lane);
+unsigned char lib_hdmi_dfe_get_tap1(unsigned char lane);
+unsigned char lib_hdmi_dfe_get_tap1max(unsigned char lane);
+unsigned char lib_hdmi_dfe_get_tap1min(unsigned char lane);
+char lib_hdmi_dfe_get_tap2(unsigned char lane);
+unsigned char lib_hdmi_dfe_get_le(unsigned char lane);
+unsigned char lib_hdmi_dfe_get_lemax(unsigned char lane);
+unsigned char lib_hdmi_dfe_get_lemin(unsigned char lane);
+
+void lib_hdmi_cmu_pll_en(unsigned char enable);
+void lib_hdmi_demux_ck_vcopll_rst(unsigned char rst);
+void lib_hdmi_dfe_rst(unsigned char rst);
+void lib_hdmi_cdr_rst(unsigned char rst);
+void lib_hdmi_wdog(void);
+void lib_hdmi_dfe_config_setting(void);
+void lib_hdmi_set_phy_table(HDMI_PHY_PARAM_T *phy_param);
+void lib_hdmi_cco_band_config(unsigned int bclk, HDMI_PHY_PARAM_T *phy_param);
+
+unsigned char lib_hdmi_acdr_check_result(void);
+void lib_hdmi_fg_koffset_manual_adjust(unsigned int r, unsigned int g, unsigned int b);
+void lib_hdmi_fg_koffset_manual(void);
+void lib_hdmi_fg_koffset_auto(void);
+void lib_hdmi_fg_koffset_proc(void);
+void lib_hdmi_fg_koffset_disable(void);
+void lib_hdmi_z0_calibration(void);
+
+void lib_hdmi_char_err_rst(unsigned char rst);
+void lib_hdmi_char_err_start(unsigned char conti_mode, unsigned char period);
+unsigned char lib_hdmi_char_err_det_done(void);
+unsigned char lib_hdmi_char_err_get_error(unsigned int *r_err, unsigned int *g_err, unsigned int *b_err);
+void lib_hdmi_bit_err_start(unsigned char conti_mode, unsigned char period);
+unsigned char lib_hdmi_bit_err_det_done(void);
+unsigned char lib_hdmi_bit_err_get_error(unsigned int *r_err, unsigned int *g_err, unsigned int *b_err);
+
+#if 1/* Only for jtest */
+void debug_hdmi_dfe_scan(void);
+#endif
+
+
+void rxphy_isr_set(unsigned char en)
+{
+	phy_isr_en = en;
+}
+
+void rxphy_init_struct(void)
+{
+	memset(&phy_st, 0, sizeof(HDMIRX_PHY_STRUCT_T));
+}
+
+int rxphy_isr(void)
+{
+	if (phy_isr_en) {
+
+		if (rxphy_measure())
+			rxphy_job();
+		else
+			hdmi_reset_video_state();
+
+		//hdmi_check_connection_state();
+
+		Hdmi_HdcpFSM();
+
+		lib_hdmi2p0_scdc_update_flag();
+	}
+
+	return IRQ_HANDLED;
+
+}
+
+unsigned char rxphy_measure(void)
+{
+	unsigned int clk_tmp = 0;
+	unsigned char clk_stable_prev = phy_st.clk_stable;
+
+	if (lib_hdmi_is_clk_ready()) {
+		clk_tmp = lib_hdmi_get_clock();
+#if HDMI2p0
+		/* Check scdc flag */
+		hdmi2p0_check_tmds_config();
+#endif
+	}
+
+	lib_hdmi_trigger_measure_start();
+
+	if (clk_tmp > VALID_MIN_CLOCK) {
+#if HDMI2p0
+		/* It's possible for 40x only when clock=(3G~6G)/4 */
+		if ((hdmi2p0_get_clock40x_flag()) &&
+			(clk_tmp < 1422 && clk_tmp > 699)) {
+			clk_tmp <<= 2;/* HDMI2.0, change clock to clock*4 */
+			phy_st.rxphy_40x = 1;
+		}
+#endif
+
+		if (HDMI_ABS(clk_tmp, phy_st.clk_pre) < CLOCK_TOLERANCE()) {
+			/* Get valid clock and close to previous clock */
+			if (rxphy_is_clock_stable(clk_tmp)) {
+				phy_st.clk_stable = 1;
+				phy_st.clk = clk_tmp;
+			}
+			phy_st.clk_unstable_count = 0;
+		} else if (phy_st.clk_unstable_count < CLK_UNSTABLE_CNT) {
+			/* Get valid clock but different with previous clock, count for debouncing */
+			phy_st.clk_unstable_count++;
+		} else {
+			/* Get valid clock but different with previous clock */
+			phy_st.clk = 0;
+			phy_st.clk_pre = clk_tmp;
+			phy_st.clk_tolerance = MAX(clk_tmp>>7, 5);
+			phy_st.clk_debounce_count = 0;
+			phy_st.clk_unstable_count = 0;
+			phy_st.clk_stable = 0;
+			phy_st.phy_proc_state = PHY_PROC_INIT;
+		}
+
+		phy_st.noclk_debounce_count = 0;
+
+	} else {
+		/* clk_tmp <= VALID_MIN_CLOCK */
+		if (phy_st.noclk_debounce_count < NOCLK_DEBOUNCE_CNT) {
+			/* NO clock, and start debouncing */
+			phy_st.noclk_debounce_count++;
+		} else {
+			/* NO clock, really!!  Then reset clk_info */
+			if (phy_st.clk_pre) {
+				phy_st.clk_pre = 0;
+				phy_st.clk = 0;
+				phy_st.clk_debounce_count = 0;
+				phy_st.clk_unstable_count = 0;
+				phy_st.clk_stable = 0;
+				phy_st.phy_proc_state = PHY_PROC_INIT;
+			}
+
+			hdmi2p0_reset_scdc_toggle();
+			if (phy_st.rxphy_40x) {
+				/* NO clock, and reset clk_info and then reset SCDC */
+				lib_hdmi2p0_reset_scdc();
+				phy_st.rxphy_40x = 0;
+			}
+		}
+	}
+
+	lib_hdmi_trigger_measure_stop();
+
+	if (clk_stable_prev != phy_st.clk_stable) {
+
+		HDMI_PRINTF("clk_stable from %d to %d\n", clk_stable_prev,
+			phy_st.clk_stable);
+
+		lib_hdmi_misc_variable_initial();
+	}
+
+	if (phy_st.clk_stable)
+		return TRUE;
+	else
+		return FALSE;
+
+}
+
+/**
+ * rxphy_is_clock_stable
+ *
+ * Return: 1 when clock is stable
+ */
+unsigned char rxphy_is_clock_stable(unsigned int clk_tmp)
+{
+	if (phy_st.clk_debounce_count >= CLK_DEBOUNCE_CNT)
+		return 1;
+	else
+		phy_st.clk_debounce_count++;
+
+	return 0;
+}
+
+void rxphy_job(void)
+{
+	switch (phy_st.phy_proc_state) {
+	case PHY_PROC_INIT:
+		hdmi_set_phy(phy_st.clk);
+
+		hdmi_reset_meas_counter();
+
+		if (phy_st.clk <= clock_bound_45m)
+			phy_st.phy_proc_state = PHY_PROC_CLOSE_ADP;
+		else
+			phy_st.phy_proc_state = PHY_PROC_RECORD;
+
+		break;
+	case PHY_PROC_RECORD:
+		if (hdmi_dfe_record(phy_st.clk))
+			phy_st.phy_proc_state = PHY_PROC_CLOSE_ADP;
+		else
+			break;
+	case PHY_PROC_CLOSE_ADP:
+		if (hdmi_dfe_close(phy_st.clk, PHY_PROC_CLOSE_ADP)) {
+#if HDMI2p0
+			hdmi2p0_detect_config();
+#endif
+			phy_st.phy_proc_state = PHY_PROC_DONE;
+		}
+		break;
+	case PHY_PROC_DONE:
+
+		break;
+	/* Belowing are for recovery flow in check_mode stage */
+	case PHY_PROC_RECOVER_6G_LONGCABLE:
+		hdmi_dfe_hi_speed(phy_st.clk);
+		phy_st.phy_proc_state = PHY_PROC_RECOVER_6G_LONGCABLE_RECORD;
+		break;
+	case PHY_PROC_RECOVER_6G_LONGCABLE_RECORD:
+		if (hdmi_dfe_record(phy_st.clk))
+			phy_st.phy_proc_state = PHY_PROC_RECOVER_6G_LONGCABLE_CLOSE_ADP;
+		else
+			break;
+	case PHY_PROC_RECOVER_6G_LONGCABLE_CLOSE_ADP:
+		hdmi_dfe_close(phy_st.clk, PHY_PROC_RECOVER_6G_LONGCABLE_CLOSE_ADP);
+		phy_st.phy_proc_state = PHY_PROC_DONE;
+		break;
+	case PHY_PROC_RECOVER_MI:
+		hdmi_dfe_mi_speed(phy_st.clk);
+		phy_st.phy_proc_state = PHY_PROC_RECORD;
+		break;
+	default:
+		phy_st.phy_proc_state = PHY_PROC_INIT;
+		break;
+	}
+
+}
+
+void rxphy_force_clear_clk_st(void)
+{
+	/*
+	 * case 1: clk=1080p50->1080p60, timing changed, but clock is the same, then force to re-set phy
+	 * case 2: clk=4k2kp60->1080p60, timing changed, but clock is the same, then force to re-set phy (also need to clear SCDC)
+	 */
+	rxphy_init_struct();
+}
+
+unsigned int rxphy_get_clk(void)
+{
+	return phy_st.clk;
+}
+
+unsigned char rxphy_is_clk_stable(void)
+{
+	return phy_st.clk_stable;
+}
+
+unsigned char rxphy_get_setphy_done(void)
+{
+	return (phy_st.phy_proc_state == PHY_PROC_DONE);
+}
+
+void rxphy_reset_setphy_proc(void)
+{
+	phy_st.phy_proc_state = PHY_PROC_INIT;
+	HDMI_PRINTF("%s\n", __func__);
+}
+
+void hdmi_dfe_recovery_6g_long_cable(void)
+{
+	phy_st.phy_proc_state = PHY_PROC_RECOVER_6G_LONGCABLE;
+}
+
+void hdmi_dfe_recovery_mi_speed(void)
+{
+	phy_st.phy_proc_state = PHY_PROC_RECOVER_MI;
+}
+
+void hdmi_set_phy(unsigned int b)
+{
+	unsigned char mode;
+	bool b_mode_found = 0;
+	HDMI_PHY_PARAM_T *p_phy_table;
+	unsigned char tb_size = 0;
+
+	HDMI_PRINTF("%s  b=%d\n", __func__, b);
+
+	if (b == 0)
+		return;
+
+	lib_hdmi_mac_reset();
+
+	lib_hdmi_cdr_rst(1);
+	lib_hdmi_demux_ck_vcopll_rst(1);
+	lib_hdmi_wdg_rst(1);
+	lib_hdmi_cmu_pll_en(0);
+	HDMI_DELAYMS(20);
+	lib_hdmi_eq_bias_band_setting(b);
+
+	p_phy_table = hdmi_phy_param;
+	tb_size = sizeof(hdmi_phy_param)/sizeof(HDMI_PHY_PARAM_T);
+
+	HDMI_PRINTF("phy table size=%d\n", tb_size);
+	for (mode = 0; mode < tb_size; mode++) {
+		if (p_phy_table[mode].b_upper > b && p_phy_table[mode].b_lower <= b) {
+			lib_hdmi_cco_band_config(b, &p_phy_table[mode]);
+			lib_hdmi_set_phy_table(&p_phy_table[mode]);
+
+			b_mode_found = 1;
+			break;
+		}
+	}
+
+	if (!b_mode_found) {
+		HDMI_PRINTF("Not Found in PhyMode (b=%d)\n", b);
+		return;
+	}
+
+#ifdef CONFIG_POWER_SAVING_MODE
+	lib_hdmi_eq_pi_power_en(1);
+#endif
+	HDMI_DELAYMS(20);
+
+	lib_hdmi_wdg_rst(0);
+
+	lib_hdmi_wdog();
+	lib_hdmi_cmu_pll_en(1);
+	HDMI_DELAYMS(5);
+
+	lib_hdmi_demux_ck_vcopll_rst(0);
+	HDMI_DELAYMS(50);
+
+	lib_hdmi_cdr_rst(0);
+
+	HDMI_DELAYMS(30);
+
+	lib_hdmi_dfe_config_setting();
+
+	lib_hdmi_fg_koffset_disable();
+
+	if (b > clock_bound_110m)
+		lib_hdmi_set_dfe(b, 3);
+	else if ((b > clock_bound_45m) && (b < clock_bound_110m))
+		lib_hdmi_set_dfe_mid_band(b, 2);
+	else
+		lib_hdmi_dfe_manual_set();
+
+	/* Prevent influence HDCP2.2 */
+	if (hdmirx_state.hdcp_state < HDCPRX_STATE_2P2_DISCOVER)
+		hdmi_rx_reg_mask32(HDMI_HDCP_CR, ~HDMI_HDCP_CR_hdcp_en_mask,
+			HDMI_HDCP_CR_hdcp_en_mask, HDMI_RX_MAC);
+
+	HDMI_DELAYMS(1);
+	lib_hdmi_mac_release();
+
+}
+
+unsigned char hdmi_dfe_record(unsigned int clk)
+{
+	if (lib_hdmi_dfe_is_record_enable()) {
+		lib_hdmi_dfe_record_enable(0);
+		return TRUE;
+	} else {
+		lib_hdmi_dfe_record_enable(1);
+		return FALSE;
+	}
+}
+
+unsigned char hdmi_dfe_close(unsigned int clk, unsigned char phy_state)
+{
+	unsigned char lane;
+
+	lib_hdmi_set_dfe_close();
+
+
+	switch (phy_state) {
+	case PHY_PROC_CLOSE_ADP:
+		if (clk > 2900)/*  > 3G */
+			lib_hdmi_load_le_max();
+		else
+			lib_hdmi_dfe_examine_le_coef(clk);
+		break;
+	case PHY_PROC_RECOVER_6G_LONGCABLE_CLOSE_ADP:
+		hdmi_dfe_6g_long_cable_patch();
+		break;
+	default:
+		break;
+	}
+
+	for (lane = 0; lane < 3; lane++) {
+		phy_st.dfe_t[lane].tap0max = lib_hdmi_dfe_get_tap0max(lane);
+		phy_st.dfe_t[lane].tap0min = lib_hdmi_dfe_get_tap0min(lane);
+		phy_st.dfe_t[lane].vth = lib_hdmi_dfe_get_vth(lane);
+		phy_st.dfe_t[lane].tap0 = lib_hdmi_dfe_get_tap0(lane);
+		phy_st.dfe_t[lane].tap1 = lib_hdmi_dfe_get_tap1(lane);
+		phy_st.dfe_t[lane].tap2 = lib_hdmi_dfe_get_tap2(lane);
+		phy_st.dfe_t[lane].le = lib_hdmi_dfe_get_le(lane);
+		phy_st.dfe_t[lane].lemax = lib_hdmi_dfe_get_lemax(lane);
+		phy_st.dfe_t[lane].lemin = lib_hdmi_dfe_get_lemin(lane);
+	}
+
+	hdmi_dump_dfe_para();
+
+	return TRUE;
+}
+
+void hdmi_dfe_hi_speed(unsigned int b_clk)
+{
+	HDMI_PRINTF("%s\n", __func__);
+
+	lib_hdmi_dfe_power(1);
+	HDMI_DELAYMS(1);
+	/* ENABLE  VTH & TAP0 */
+	lib_hdmi_dfe_init_vth((LN_R|LN_G|LN_B), 0x03);
+	lib_hdmi_dfe_init_tap0((LN_R|LN_G|LN_B), 0x14);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth),
+		(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth),
+		(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth),
+		(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth), HDMI_RX_DFE);
+
+	lib_hdmi_dfe_second_flow(b_clk);
+
+	lib_hdmi_dfe_init_tap1((LN_R|LN_G|LN_B), 0x0c);
+	lib_hdmi_dfe_init_tap2((LN_R|LN_G|LN_B), 0x00);
+	lib_hdmi_dfe_init_le((LN_R|LN_G|LN_B), 0x08);
+
+	if (b_clk > 2700) {
+		/* 3G need tap2 but below not need */
+		hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+			~(REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_LE | REG_dfe_adapt_en_lane0_TAP2),
+			(REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_LE | REG_dfe_adapt_en_lane0_TAP2),
+			HDMI_RX_DFE);
+		hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+			~(REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_LE | REG_dfe_adapt_en_lane1_TAP2),
+			(REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_LE | REG_dfe_adapt_en_lane1_TAP2),
+			HDMI_RX_DFE);
+		hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+			~(REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_LE | REG_dfe_adapt_en_lane2_TAP2),
+			(REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_LE | REG_dfe_adapt_en_lane2_TAP2),
+			HDMI_RX_DFE);
+	} else {
+		hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+			~(REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_LE | REG_dfe_adapt_en_lane0_TAP2),
+			(REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_LE),
+			HDMI_RX_DFE);
+		hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+			~(REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_LE | REG_dfe_adapt_en_lane1_TAP2),
+			(REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_LE),
+			HDMI_RX_DFE);
+		hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+			~(REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_LE | REG_dfe_adapt_en_lane2_TAP2),
+			(REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_LE),
+			HDMI_RX_DFE);
+	}
+
+}
+
+void hdmi_dfe_6g_long_cable_patch(void)
+{
+	signed char tap2;
+	unsigned char lemax;
+
+	tap2 = lib_hdmi_dfe_get_tap2(1);
+	lib_hdmi_dfe_init_tap2(LN_G, MIN(tap2+6, 10));
+
+	lemax = lib_hdmi_dfe_get_lemax(1);
+	lemax += lib_hdmi_dfe_get_tap1max(1);
+	lib_hdmi_dfe_init_tap1(LN_G, MIN(lemax+4, 63));
+
+	HDMI_PRINTF("%s end\n", __func__);
+}
+
+void hdmi_dfe_mi_speed(unsigned int b_clk)
+{
+	HDMI_PRINTF("%s\n", __func__);
+
+	lib_hdmi_dfe_power(1);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_LE | REG_dfe_adapt_en_lane0_TAP2),
+		(REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_LE | REG_dfe_adapt_en_lane0_TAP2),
+		HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_LE | REG_dfe_adapt_en_lane1_TAP2),
+		(REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_LE | REG_dfe_adapt_en_lane1_TAP2),
+		HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_LE | REG_dfe_adapt_en_lane2_TAP2),
+		(REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_LE | REG_dfe_adapt_en_lane2_TAP2),
+		HDMI_RX_DFE);
+}
+
+#if TMDS_ERR_DET_SHORT_PERIOD
+
+void hdmi_open_err_detect(void)
+{
+	phy_st.error_detect_count = 0;
+}
+
+
+unsigned char hdmi_err_detect_stop(void)
+{
+	if (phy_st.error_detect_count > MAX_ERR_DETECT_TIMES) {
+		return 1;
+	} else {
+		++phy_st.error_detect_count;
+		return 0;
+	}
+
+}
+
+#endif
+
+unsigned char hdmi_char_err_detection(void)
+{
+	unsigned int r_err = 0, g_err = 0, b_err = 0;
+
+#if TMDS_ERR_DET_SHORT_PERIOD
+	if (hdmi_err_detect_stop())
+		return 0;
+#endif
+
+	if (phy_st.char_err_loop == 0) {
+		lib_hdmi_char_err_start(0, TMDS_CHAR_ERR_PERIOD);
+		phy_st.char_err_loop++;
+
+	} else {
+		if (lib_hdmi_char_err_get_error(&r_err, &g_err, &b_err)) {
+			phy_st.char_err_loop = 0;
+			phy_st.detect_6g_longcable = 0;
+
+			if ((g_err > TMDS_CHAR_ERR_THREAD) &&
+				(r_err < 10) && (b_err < 10) &&
+				((phy_st.dfe_t[1].le+phy_st.dfe_t[1].tap1) > 10))
+				phy_st.detect_6g_longcable = 1;
+
+			if ((r_err > TMDS_CHAR_ERR_THREAD) || (g_err > TMDS_CHAR_ERR_THREAD) || (b_err > TMDS_CHAR_ERR_THREAD))
+				HDMI_PRINTF("[CHAR_ERR](%d, %d, %d)\n", r_err, g_err, b_err);
+
+			return 1;
+		}
+
+		if (phy_st.char_err_loop > TMDS_CHAR_ERR_MAX_LOOP) {
+			phy_st.char_err_loop = 0;
+			phy_st.detect_6g_longcable = 0;
+			HDMI_PRINTF("[CHAR_ERR] Life is too short.\n");
+		} else {
+			phy_st.char_err_loop++;
+		}
+
+	}
+
+	return 0;
+
+}
+
+unsigned char hdmi_bit_err_detection(void)
+{
+	unsigned int r_err = 0, g_err = 0, b_err = 0;
+
+#if TMDS_ERR_DET_SHORT_PERIOD
+	if (hdmi_err_detect_stop())
+		return 0;
+#endif
+
+	if (phy_st.bit_err_loop == 0) {
+		lib_hdmi_bit_err_start(0, TMDS_BIT_ERR_PERIOD);
+		phy_st.bit_err_loop++;
+
+	} else {
+		if (lib_hdmi_bit_err_get_error(&r_err, &g_err, &b_err)) {
+			phy_st.bit_err_loop = 0;
+
+			if ((r_err > TMDS_BIT_ERR_THREAD) || (g_err > TMDS_BIT_ERR_THREAD) || (b_err > TMDS_BIT_ERR_THREAD)) {
+				HDMI_PRINTF("[BIT_ERR](%d, %d, %d)\n", r_err, g_err, b_err);
+				return 1;
+			}
+			/* HDMI_PRINTF("[BIT_ERR](%d, %d, %d)\n", r_err, g_err, b_err); */
+			return 0;
+		}
+
+		if (phy_st.bit_err_loop > TMDS_BIT_ERR_MAX_LOOP) {
+			phy_st.bit_err_loop = 0;
+			HDMI_PRINTF("[BIT_ERR] Life is too short.\n");
+		} else {
+			phy_st.bit_err_loop++;
+		}
+
+	}
+
+	return 0;
+
+}
+
+unsigned char hdmi_is_long_cable(void)
+{
+	return phy_st.detect_6g_longcable;
+}
+
+void hdmi_dump_dfe_para(void)
+{
+	unsigned char lane;
+
+	for (lane = 0; lane < 3; lane++) {
+		HDMI_PRINTF("********************Lane%d******************\n", lane);
+		HDMI_PRINTF("[DFE] Lane%d Vth=0x%x\n", lane, phy_st.dfe_t[lane].vth);
+		HDMI_PRINTF("[DFE] Lane%d Tap0=0x%x, max=0x%02x, min=0x%02x\n",
+			lane, phy_st.dfe_t[lane].tap0, phy_st.dfe_t[lane].tap0max, phy_st.dfe_t[lane].tap0min);
+
+		HDMI_PRINTF("[DFE] Lane%d Tap1=0x%02x, Tap2=%+d\n",
+			lane, phy_st.dfe_t[lane].tap1, phy_st.dfe_t[lane].tap2);
+
+		HDMI_PRINTF("[DFE] Lane%d LE=0x%02x, max=0x%02x, min=0x%02x\n",
+			lane, phy_st.dfe_t[lane].le, phy_st.dfe_t[lane].lemax, phy_st.dfe_t[lane].lemin);
+	}
+}
+
+#ifdef CONFIG_POWER_SAVING_MODE
+void hdmi_phy_pw_saving(unsigned char port)
+{
+	lib_hdmi_cdr_rst(1);
+	lib_hdmi_demux_ck_vcopll_rst(1);
+
+	lib_hdmi_eq_pi_power_en(0);
+	lib_hdmi_cmu_pll_en(0);
+}
+#endif
+
+void lib_hdmi_trigger_measurement(void)
+{
+	hdmi_rx_reg_mask32(REGD56, ~REGD56_p0_ck_md_rstb_mask, 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(REGD56,
+		~REGD56_p0_ck_md_rstb_mask, REGD56_p0_ck_md_rstb_mask, HDMI_RX_PHY);
+	hdmi_rx_reg_write32(REGD57, REGD57_p0_ck_md_ok_mask, HDMI_RX_PHY);
+}
+
+void lib_hdmi_trigger_measure_start(void)
+{
+	hdmi_rx_reg_mask32(REGD56, ~REGD56_p0_ck_md_rstb_mask, 0, HDMI_RX_PHY);
+}
+
+void lib_hdmi_trigger_measure_stop(void)
+{
+	hdmi_rx_reg_mask32(REGD56,
+		~REGD56_p0_ck_md_rstb_mask, REGD56_p0_ck_md_rstb_mask, HDMI_RX_PHY);
+}
+
+unsigned char lib_hdmi_is_clk_ready(void)
+{
+	hdmi_rx_reg_write32(REGD57, REGD57_p0_ck_md_ok_mask, HDMI_RX_PHY);
+	HDMI_DELAYUS(20);
+
+	if (REGD57_get_p0_ck_md_ok(hdmi_rx_reg_read32(REGD57, HDMI_RX_PHY)))
+		return TRUE;
+	else
+		return FALSE;
+}
+
+unsigned int lib_hdmi_get_clock(void)
+{
+	unsigned int b;
+
+	b = REGD57_get_p0_ck_md_count(hdmi_rx_reg_read32(REGD57, HDMI_RX_PHY));
+	return b;
+}
+
+void lib_hdmi_phy_init(void)
+{
+	/* Enable bandgap power */
+	hdmi_rx_reg_mask32(TOP_IN, ~TOP_IN_BIAS_POW, TOP_IN_BIAS_POW, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(TOP_IN, ~(TOP_IN_REG_IBHN_TUNE), _BIT20, HDMI_RX_PHY);
+	lib_hdmi_cmu_pll_en(1);
+	HDMI_PRINTF("ENABLE_reg=0x%08x\n", hdmi_rx_reg_read32(ENABLE, HDMI_RX_PHY));
+
+	hdmi_rx_reg_mask32(TOP_IN, ~(TOP_IN_CK_TX_0), (TOP_IN_CK_TX_0), HDMI_RX_PHY);
+
+	/* Default hdmi mode */
+	lib_hdmi_ck_md_ref_sel();
+	lib_hdmi_fg_koffset_manual_adjust(0x10, 0x10, 0x10);
+
+	lib_hdmi_z0_calibration();
+
+	hdmi_rx_reg_mask32(P0_CK1,
+		~(p0_ck_2_CMU_CKIN_SEL | p0_ck_2_ACDR_CBUS_REF |
+		p0_ck_2_CK_MD_DET_SEL | p0_CMU_CKAFE_ENHANCE_BIAS |
+		p0_CK_2_CKD2S_EN0 | P0_CK1_reg_p0_ck_1_mask),
+		(p0_ck_2_CMU_CKIN_SEL | p0_ck_2_ACDR_CBUS_REF |
+		p0_ck_2_CK_MD_DET_SEL | p0_CMU_CKAFE_ENHANCE_BIAS |
+		p0_CK_2_CKD2S_EN0 | p0_ck_1_port_bias | p0_ck_1_CKAFE_POW),
+		HDMI_RX_PHY);
+	/* When ac on, need this for hdcp auth */
+	hdmi_rx_reg_mask32(P0_CK2,
+		~P0_ck_8_LDO_EN_mask, P0_ck_8_LDO_EN_mask, HDMI_RX_PHY);
+
+	hdmi_rx_reg_mask32(P0_R2, ~P0_b_DEMUX_BBPD_RSTB, P0_b_DEMUX_BBPD_RSTB, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_G2, ~P0_b_DEMUX_BBPD_RSTB, P0_b_DEMUX_BBPD_RSTB, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_B2, ~P0_b_DEMUX_BBPD_RSTB, P0_b_DEMUX_BBPD_RSTB, HDMI_RX_PHY);
+
+}
+
+
+void lib_hdmi_z0_set(unsigned char lane, unsigned char enable)
+{
+	unsigned int bmask = 0;
+
+	if (lane&LN_CK)
+		bmask |= Z0POW_reg_z0_z0pow_ck(1);
+
+	if (lane&LN_B)
+		bmask |= Z0POW_reg_z0_z0pow_b(1);
+
+	if (lane&LN_G)
+		bmask |= Z0POW_reg_z0_z0pow_g(1);
+
+	if (lane&LN_R)
+		bmask |= Z0POW_reg_z0_z0pow_r(1);
+
+	if (!bmask)
+		return;
+
+	hdmi_rx_reg_mask32(Z0POW, ~bmask, enable?bmask:0, HDMI_RX_PHY);
+
+	hdmi_rx_reg_mask32(TOP_IN,
+		~(TOP_IN_Z0_FIX_SELECT_0), enable?(TOP_IN_Z0_FIX_SELECT_0):0, HDMI_RX_PHY);
+
+}
+
+
+/**
+ * lib_hdmi_z300_sel
+ *
+ * @mode: 0-active mode, 1-vcm mode
+ */
+void lib_hdmi_z300_sel(unsigned char mode)
+{
+	if (mode)
+		hdmi_rx_reg_mask32(Z0POW, ~(Z0POW_reg_z0_z300_sel(1)), Z0POW_reg_z0_z300_sel(1), HDMI_RX_PHY);
+	else
+		hdmi_rx_reg_mask32(Z0POW, ~(Z0POW_reg_z0_z300_sel(1)), 0, HDMI_RX_PHY);
+}
+
+
+void lib_hdmi_ck_md_ref_sel(void)
+{
+	hdmi_rx_reg_mask32(P0_CK1, ~p0_ck_2_CK_MD_REF_SEL, p0_ck_2_CK_MD_REF_SEL, HDMI_RX_PHY);
+}
+
+
+void lib_hdmi_wdg_rst(unsigned char rst)
+{
+	if (rst)
+		hdmi_rx_reg_mask32(P0_CK3,
+			~(P0_ck_9_CMU_PFD_RSTB|_BIT3|P0_ck_9_CMU_WDRST|_BIT1),
+			(_BIT3|P0_ck_9_CMU_WDRST), HDMI_RX_PHY);/* PFD_RSTB  reset */
+	else
+		hdmi_rx_reg_mask32(P0_CK3,
+			~(P0_ck_9_CMU_PFD_RSTB|_BIT3|P0_ck_9_CMU_WDRST|_BIT1),
+			(P0_ck_9_CMU_PFD_RSTB|_BIT1), HDMI_RX_PHY);/* release, normal */
+}
+
+
+void lib_hdmi_afifo_enable(unsigned char enable)
+{
+	if (enable)
+		hdmi_rx_reg_mask32(HDMI_CH_CR,
+			~(HDMI_CH_CR_r_ch_afifo_en_mask|HDMI_CH_CR_g_ch_afifo_en_mask|HDMI_CH_CR_b_ch_afifo_en_mask),
+			(HDMI_CH_CR_r_ch_afifo_en_mask|HDMI_CH_CR_g_ch_afifo_en_mask|HDMI_CH_CR_b_ch_afifo_en_mask),
+			HDMI_RX_MAC);
+	else
+		hdmi_rx_reg_mask32(HDMI_CH_CR,
+			~(HDMI_CH_CR_r_ch_afifo_en_mask|HDMI_CH_CR_g_ch_afifo_en_mask|HDMI_CH_CR_b_ch_afifo_en_mask),
+			0, HDMI_RX_MAC);
+}
+
+void lib_hdmi_mac_reset(void)
+{
+	hdmi_rx_reg_mask32(HDMI_TMDS_DPC_SET0, ~(HDMI_TMDS_DPC_SET0_dpc_en_mask), 0, HDMI_RX_MAC);
+	lib_hdmi_afifo_enable(0);
+	/* Disable TMDS input */
+	hdmi_rx_reg_mask32(HDMI_TMDS_PWDCTL,
+		~(HDMI_TMDS_PWDCTL_ebip_mask|HDMI_TMDS_PWDCTL_egip_mask|HDMI_TMDS_PWDCTL_erip_mask|HDMI_TMDS_PWDCTL_ecc_mask),
+		0, HDMI_RX_MAC);
+	/* HDMI&DVI function disable */
+	hdmi_rx_reg_mask32(HDMI_TMDS_Z0CC, ~HDMI_TMDS_Z0CC_hde_mask, 0, HDMI_RX_MAC);
+}
+
+void lib_hdmi_mac_release(void)
+{
+	HDMI_DELAYMS(1);
+	hdmi_rx_reg_mask32(HDMI_TMDS_Z0CC, ~HDMI_TMDS_Z0CC_hde_mask, HDMI_TMDS_Z0CC_hde(1), HDMI_RX_MAC);
+
+	HDMI_DELAYMS(1);
+	/* Enable TMDS input */
+	hdmi_rx_reg_mask32(HDMI_TMDS_PWDCTL,
+		~(HDMI_TMDS_PWDCTL_ebip_mask|HDMI_TMDS_PWDCTL_egip_mask|HDMI_TMDS_PWDCTL_erip_mask|HDMI_TMDS_PWDCTL_ecc_mask),
+		(HDMI_TMDS_PWDCTL_ebip(1)|HDMI_TMDS_PWDCTL_egip(1)|HDMI_TMDS_PWDCTL_erip(1)|HDMI_TMDS_PWDCTL_ecc(1)),
+		HDMI_RX_MAC);
+	HDMI_DELAYMS(1);
+	lib_hdmi_afifo_enable(1);
+	hdmi_rx_reg_mask32(HDMI_TMDS_DPC_SET0,
+		~HDMI_TMDS_DPC_SET0_dpc_en_mask, HDMI_TMDS_DPC_SET0_dpc_en_mask, HDMI_RX_MAC);
+}
+
+void lib_hdmi_dfe_power(unsigned char en)
+{
+	hdmi_rx_reg_mask32(P0_B3, ~(P0_b_9_DFE_ADAPTION_POW_EN|P0_b_9_DFE_TAP_EN), (P0_DFE_ADAPTION_EN((en != 0))|P0_b_tap_en(0x3)), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_G3, ~(P0_b_9_DFE_ADAPTION_POW_EN|P0_b_9_DFE_TAP_EN), (P0_DFE_ADAPTION_EN((en != 0))|P0_b_tap_en(0x3)), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_R3, ~(P0_b_9_DFE_ADAPTION_POW_EN|P0_b_9_DFE_TAP_EN), (P0_DFE_ADAPTION_EN((en != 0))|P0_b_tap_en(0x3)), HDMI_RX_PHY);
+}
+
+void lib_hdmi_eq_set_clock_boundary(void)
+{
+	clock_bound_3g = TMDS_3G;
+	clock_bound_1p5g = TMDS_1p5G;
+	clock_bound_45m = 430;
+	clock_bound_110m = 1042;
+
+	/* HDMI_PRINTF("clock_bound_3g=%d\n", clock_bound_3g); */
+}
+
+#ifdef CONFIG_POWER_SAVING_MODE
+void lib_hdmi_eq_pi_power_en(unsigned char en)
+{
+	if (en) {
+		hdmi_rx_reg_mask32(P0_B2, ~(P0_b_5_EQ_POW), P0_b_5_EQ_POW, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P0_G2, ~(P0_b_5_EQ_POW), P0_b_5_EQ_POW, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P0_R2, ~(P0_b_5_EQ_POW), P0_b_5_EQ_POW, HDMI_RX_PHY);
+
+		HDMI_DELAYUS(10);
+
+		hdmi_rx_reg_mask32(P0_B2, ~(P0_b_8_POW_PR), P0_b_8_POW_PR, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P0_G2, ~(P0_b_8_POW_PR), P0_b_8_POW_PR, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P0_R2, ~(P0_b_8_POW_PR), P0_b_8_POW_PR, HDMI_RX_PHY);
+	} else {
+		hdmi_rx_reg_mask32(P0_B2, ~(P0_b_8_POW_PR|P0_b_5_EQ_POW), 0x0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P0_G2, ~(P0_b_8_POW_PR|P0_b_5_EQ_POW), 0x0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(P0_R2, ~(P0_b_8_POW_PR|P0_b_5_EQ_POW), 0x0, HDMI_RX_PHY);
+	}
+
+}
+#endif
+
+void lib_hdmi_eq_bias_band_setting(unsigned int b)
+{
+	UINT32 B1_addr, G1_addr, R1_addr;
+	UINT32 B2_addr, G2_addr, R2_addr;
+	UINT32 B3_addr, G3_addr, R3_addr;
+
+	B1_addr = P0_B1;
+	B2_addr = P0_B2;
+	B3_addr = P0_B3;
+	G1_addr = P0_G1;
+	G2_addr = P0_G2;
+	G3_addr = P0_G3;
+	R1_addr = P0_R1;
+	R2_addr = P0_R2;
+	R3_addr = P0_R3;
+
+	lib_hdmi_eq_set_clock_boundary();
+
+	hdmi_rx_reg_mask32(B2_addr, ~P0_b_6_TAP0_LE_ISO, P0_b_6_TAP0_LE_ISO, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(G2_addr, ~P0_b_6_TAP0_LE_ISO, P0_b_6_TAP0_LE_ISO, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(R2_addr, ~P0_b_6_TAP0_LE_ISO, P0_b_6_TAP0_LE_ISO, HDMI_RX_PHY);
+
+
+	if (b > clock_bound_3g) {
+		/* Over  3G HBR */
+		hdmi_rx_reg_mask32(B2_addr,
+			~(P0_b_7_TAP0_ISEL|P0_b_7_LEQ_ISEL|P0_b_6_LEQ_BIT_RATE|P0_b_6_TAP0_HBR|P0_b_5_LEQ_CURRENT_ADJ),
+			(P0_b_7_TAP0_ISEL_400uA | P0_b_7_LEQ_ISEL_400uA | P0_b_6_LEQ_BIT_RATE_HBR | P0_b_6_LEQ_BIT_RATE_HBR | P0_b_6_TAP0_HBR | P0_b_5_LEQ_CURRENT_ADJ_1p25X),
+			HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G2_addr,
+			~(P0_g_7_TAP0_ISEL|P0_g_7_LEQ_ISEL|P0_g_6_LEQ_BIT_RATE|P0_g_6_TAP0_HBR|P0_g_5_LEQ_CURRENT_ADJ),
+			(P0_b_7_TAP0_ISEL_400uA | P0_b_7_LEQ_ISEL_400uA | P0_g_6_LEQ_BIT_RATE_HBR | P0_g_6_LEQ_BIT_RATE_HBR | P0_g_6_TAP0_HBR | P0_b_5_LEQ_CURRENT_ADJ_1p25X),
+			HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R2_addr,
+			~(P0_r_7_TAP0_ISEL|P0_r_7_LEQ_ISEL|P0_r_6_LEQ_BIT_RATE|P0_r_6_TAP0_HBR|P0_r_5_LEQ_CURRENT_ADJ),
+			(P0_b_7_TAP0_ISEL_400uA | P0_b_7_LEQ_ISEL_400uA | P0_r_6_LEQ_BIT_RATE_HBR | P0_r_6_LEQ_BIT_RATE_HBR | P0_r_6_TAP0_HBR | P0_b_5_LEQ_CURRENT_ADJ_1p25X),
+			HDMI_RX_PHY);
+
+		/* B */
+		hdmi_rx_reg_mask32(B3_addr,
+			~(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_mask|P0_b_10_DFE_PREAMP_ISEL_mask|P0_b_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_400uA|P0_b_10_DFE_PREAMP_ISEL_400uA|P0_b_10_DFE_SUMAMP_LP_MANUALOFF),
+			HDMI_RX_PHY);
+		/* G */
+		hdmi_rx_reg_mask32(G3_addr,
+			~(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_mask|P0_g_10_DFE_PREAMP_ISEL_mask|P0_g_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_400uA|P0_g_10_DFE_PREAMP_ISEL_400uA|P0_g_10_DFE_SUMAMP_LP_MANUALOFF),
+			HDMI_RX_PHY);
+		/* R */
+		hdmi_rx_reg_mask32(R3_addr,
+			~(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_mask|P0_r_10_DFE_PREAMP_ISEL_mask|P0_r_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_400uA|P0_r_10_DFE_PREAMP_ISEL_400uA|P0_r_10_DFE_SUMAMP_LP_MANUALOFF),
+			HDMI_RX_PHY);
+
+		/* LEQ_BIT_RATE */
+		hdmi_rx_reg_mask32(B1_addr, ~(P1_b_2_LEQ_BIT_RATE_mask|P0_b_CLK_PIX2_RATE_SEL), P1_b_2_LEQ_BIT_RATE_HBR, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G1_addr, ~(P1_g_2_LEQ_BIT_RATE_mask|P0_g_CLK_PIX2_RATE_SEL), P1_g_2_LEQ_BIT_RATE_HBR, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R1_addr, ~(P1_r_2_LEQ_BIT_RATE_mask|P0_r_CLK_PIX2_RATE_SEL), P1_r_2_LEQ_BIT_RATE_HBR, HDMI_RX_PHY);
+
+		/* PI_SEL  & pr bypass */
+		hdmi_rx_reg_mask32(B2_addr, ~(P0_b_7_PI_ISEL | p0_b_8_ACDR_CLK_SEL | P0_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G2_addr, ~(P0_g_7_PI_ISEL | p0_b_8_ACDR_CLK_SEL | P0_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R2_addr, ~(P0_r_7_PI_ISEL | p0_b_8_ACDR_CLK_SEL | P0_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+
+		/* PR sel */
+		/* B */
+		hdmi_rx_reg_mask32(B3_addr, ~P0_b_12_PR, 0, HDMI_RX_PHY);
+		/* G */
+		hdmi_rx_reg_mask32(G3_addr, ~P0_b_12_PR, 0, HDMI_RX_PHY);
+		/* R */
+		hdmi_rx_reg_mask32(R3_addr, ~P0_b_12_PR, 0, HDMI_RX_PHY);
+
+	} else if (b > clock_bound_1p5g) {
+		/* 3G ~1.5G */
+
+		/* B lane */
+		/* tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(B2_addr,
+			~(P0_b_7_TAP0_ISEL|P0_b_7_LEQ_ISEL|P0_b_6_LEQ_BIT_RATE|P0_b_6_TAP0_HBR|P0_b_5_LEQ_CURRENT_ADJ),
+			(P0_b_7_TAP0_ISEL_400uA|P0_b_7_LEQ_ISEL_200uA|P0_b_6_LEQ_BIT_RATE_MBR|P0_b_6_TAP0_HBR|P0_b_5_LEQ_CURRENT_ADJ_1X),
+			HDMI_RX_PHY);
+
+		/*G lane */
+		/* tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(G2_addr,
+			~(P0_g_7_TAP0_ISEL|P0_g_7_LEQ_ISEL|P0_g_6_LEQ_BIT_RATE|P0_g_6_TAP0_HBR|P0_g_5_LEQ_CURRENT_ADJ),
+			(P0_g_7_TAP0_ISEL_400uA|P0_g_7_LEQ_ISEL_200uA|P0_g_6_LEQ_BIT_RATE_MBR|P0_g_6_TAP0_HBR|P0_g_5_LEQ_CURRENT_ADJ_1X),
+			HDMI_RX_PHY);
+
+		/*R lane */
+		/* tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(R2_addr,
+			~(P0_r_7_TAP0_ISEL|P0_r_7_LEQ_ISEL|P0_r_6_LEQ_BIT_RATE|P0_r_6_TAP0_HBR|P0_r_5_LEQ_CURRENT_ADJ),
+			(P0_r_7_TAP0_ISEL_400uA|P0_r_7_LEQ_ISEL_200uA|P0_r_6_LEQ_BIT_RATE_MBR|P0_r_6_TAP0_HBR|P0_r_5_LEQ_CURRENT_ADJ_1X),
+			HDMI_RX_PHY);
+
+		/* B */
+		hdmi_rx_reg_mask32(B3_addr,
+			~(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_mask|P0_b_10_DFE_PREAMP_ISEL_mask|P0_b_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_400uA|P0_b_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+		/* G */
+		hdmi_rx_reg_mask32(G3_addr,
+			~(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_mask|P0_g_10_DFE_PREAMP_ISEL_mask|P0_g_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_400uA|P0_g_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+		/* R */
+		hdmi_rx_reg_mask32(R3_addr,
+			~(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_mask|P0_r_10_DFE_PREAMP_ISEL_mask|P0_r_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_400uA|P0_r_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+
+		/* LEQ_BIT_RATE */
+		hdmi_rx_reg_mask32(B1_addr,
+			~(P1_b_2_LEQ_BIT_RATE_mask|P0_b_CLK_PIX2_RATE_SEL), (P1_b_2_LEQ_BIT_RATE_MBR|P0_b_CLK_PIX2_RATE_SEL), HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G1_addr,
+			~(P1_g_2_LEQ_BIT_RATE_mask|P0_g_CLK_PIX2_RATE_SEL), (P1_g_2_LEQ_BIT_RATE_MBR|P0_g_CLK_PIX2_RATE_SEL), HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R1_addr,
+			~(P1_r_2_LEQ_BIT_RATE_mask|P0_r_CLK_PIX2_RATE_SEL), (P1_r_2_LEQ_BIT_RATE_MBR|P0_r_CLK_PIX2_RATE_SEL), HDMI_RX_PHY);
+
+		/* PI_SEL  & pr bypass */
+		hdmi_rx_reg_mask32(B2_addr,
+			~(P0_b_7_PI_ISEL | p0_b_8_ACDR_CLK_SEL | P0_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G2_addr,
+			~(P0_b_7_PI_ISEL | p0_b_8_ACDR_CLK_SEL | P0_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R2_addr,
+			~(P0_b_7_PI_ISEL | p0_b_8_ACDR_CLK_SEL | P0_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+
+		/* PR sel */
+		/* B */
+		hdmi_rx_reg_mask32(B3_addr, ~P0_b_12_PR, 0, HDMI_RX_PHY);
+		/* G */
+		hdmi_rx_reg_mask32(G3_addr, ~P0_b_12_PR, 0, HDMI_RX_PHY);
+		/* R */
+		hdmi_rx_reg_mask32(R3_addr, ~P0_b_12_PR, 0, HDMI_RX_PHY);
+	} else {
+		/* Under 1.5G */
+
+		/*B lane */
+		/* tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(B2_addr,
+			~(P0_b_7_TAP0_ISEL|P0_b_7_LEQ_ISEL|P0_b_6_LEQ_BIT_RATE|P0_b_6_TAP0_HBR|P0_b_5_LEQ_CURRENT_ADJ),
+			(P0_b_5_LEQ_CURRENT_ADJ_1X|P0_b_7_TAP0_ISEL_400uA), HDMI_RX_PHY);
+
+		/* G lane */
+		/* tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(G2_addr,
+			~(P0_g_7_TAP0_ISEL|P0_g_7_LEQ_ISEL|P0_g_6_LEQ_BIT_RATE|P0_g_6_TAP0_HBR|P0_g_5_LEQ_CURRENT_ADJ),
+			(P0_g_5_LEQ_CURRENT_ADJ_1X|P0_g_7_TAP0_ISEL_400uA), HDMI_RX_PHY);
+
+		/*R lane */
+		/* tap0_ISEL   LEQ_ISEL   EQ_bit_rate  tap_HBR */
+		hdmi_rx_reg_mask32(R2_addr,
+			~(P0_r_7_TAP0_ISEL|P0_r_7_LEQ_ISEL|P0_r_6_LEQ_BIT_RATE|P0_r_6_TAP0_HBR|P0_r_5_LEQ_CURRENT_ADJ),
+			(P0_r_5_LEQ_CURRENT_ADJ_1X|P0_r_7_TAP0_ISEL_400uA), HDMI_RX_PHY);
+
+		/* B */
+		hdmi_rx_reg_mask32(B3_addr,
+			~(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_mask|P0_b_10_DFE_PREAMP_ISEL_mask|P0_b_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_b_11_ACDR_RATE_SEL_HALF_RATE|P0_b_10_DFE_SUMAMP_ISEL_400uA|P0_b_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+		/* G */
+		hdmi_rx_reg_mask32(G3_addr,
+			~(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_mask|P0_g_10_DFE_PREAMP_ISEL_mask|P0_g_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_g_11_ACDR_RATE_SEL_HALF_RATE|P0_g_10_DFE_SUMAMP_ISEL_400uA|P0_g_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+		/* R */
+		hdmi_rx_reg_mask32(R3_addr,
+			~(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_mask|P0_r_10_DFE_PREAMP_ISEL_mask|P0_r_10_DFE_SUMAMP_LP_MANUALOFF),
+			(P0_r_11_ACDR_RATE_SEL_HALF_RATE|P0_r_10_DFE_SUMAMP_ISEL_400uA|P0_r_10_DFE_PREAMP_ISEL_400uA),
+			HDMI_RX_PHY);
+
+		/* LEQ_BIT_RATE */
+		hdmi_rx_reg_mask32(B1_addr,
+			~(P1_b_2_LEQ_BIT_RATE_mask|P0_b_CLK_PIX2_RATE_SEL), P0_b_CLK_PIX2_RATE_SEL, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G1_addr,
+			~(P1_g_2_LEQ_BIT_RATE_mask|P0_g_CLK_PIX2_RATE_SEL), P0_g_CLK_PIX2_RATE_SEL, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R1_addr,
+			~(P1_r_2_LEQ_BIT_RATE_mask|P0_r_CLK_PIX2_RATE_SEL), P0_r_CLK_PIX2_RATE_SEL, HDMI_RX_PHY);
+
+		/* PI_SEL  & pr bypass */
+		hdmi_rx_reg_mask32(B2_addr,
+			~(P0_b_7_PI_ISEL | p0_b_8_ACDR_CLK_SEL | P0_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(G2_addr,
+			~(P0_b_7_PI_ISEL | p0_b_8_ACDR_CLK_SEL | P0_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(R2_addr,
+			~(P0_b_7_PI_ISEL | p0_b_8_ACDR_CLK_SEL | P0_b_6_LEQ_PASSIVE_CORNER), 0, HDMI_RX_PHY);
+
+		/* PR sel */
+		/* B */
+		hdmi_rx_reg_mask32(B3_addr, ~P0_b_12_PR, 0, HDMI_RX_PHY);
+		/* G */
+		hdmi_rx_reg_mask32(G3_addr, ~P0_b_12_PR, 0, HDMI_RX_PHY);
+		/* R */
+		hdmi_rx_reg_mask32(R3_addr, ~P0_b_12_PR, 0, HDMI_RX_PHY);
+	}
+
+}
+
+
+void lib_hdmi_set_dfe(unsigned int b, unsigned char dfe_mode)
+{
+	HDMI_PRINTF("%s\n", __func__);
+
+	lib_hdmi_dfe_power(1);
+	hdmi_rx_reg_mask32(REG_DFE_MODE,
+		~(REG_DFE_MODE_adapt_mode_mask | REG_DFE_MODE_edge_det_mode_mask |
+		REG_DFE_MODE_transition_only_mask | REG_DFE_MODE_tap1_delay_mask |
+		REG_DFE_MODE_tap24_delay_mask | REG_DFE_MODE_le_delay_mask |
+		REG_DFE_MODE_servo_delay_mask | REG_DFE_MODE_gray_en_mask |
+		REG_DFE_MODE_dfe_adapt_rstb_mask | REG_DFE_MODE_tap0_notrans_mask),
+		REG_DFE_MODE_adapt_mode(dfe_mode) | REG_DFE_MODE_edge_det_mode(0) |
+		REG_DFE_MODE_transition_only_mask | REG_DFE_MODE_tap1_delay(1) |
+		REG_DFE_MODE_tap24_delay(1) | REG_DFE_MODE_le_delay(1) |
+		REG_DFE_MODE_servo_delay(1) | REG_DFE_MODE_gray_en_mask |
+		REG_DFE_MODE_tap0_notrans_mask, HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_DFE_EN_L0_clk_inv_lane0_mask | REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask | REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask | REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask | REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		(REG_DFE_EN_L2_timer_ctrl_en_lane2_mask | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2)) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) | REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(0x8), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_DFE_EN_L1_clk_inv_lane1_mask | REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask | REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask | REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask | REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		(REG_DFE_EN_L2_timer_ctrl_en_lane2_mask | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2)) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) | REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(0x8), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_DFE_EN_L2_clk_inv_lane2_mask | REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask | REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask | REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask | REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		(REG_DFE_EN_L2_timer_ctrl_en_lane2_mask | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2)) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) | REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(0x8), HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask|REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		(REG_DFE_INIT0_L0_tap1_init_lane0(0xc)|REG_DFE_INIT0_L0_tap0_init_lane0(0x14)|REG_DFE_INIT0_L0_vth_init_lane0(0x3)),
+		HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask|REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		(REG_DFE_INIT0_L0_tap1_init_lane0(0xc)|REG_DFE_INIT0_L0_tap0_init_lane0(0x14)|REG_DFE_INIT0_L0_vth_init_lane0(0x3)),
+		HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask|REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		(REG_DFE_INIT0_L0_tap1_init_lane0(0xc)|REG_DFE_INIT0_L0_tap0_init_lane0(0x14)|REG_DFE_INIT0_L0_vth_init_lane0(0x3)),
+		HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), (_BIT19|_BIT21|_BIT23), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), (_BIT19|_BIT21|_BIT23), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), (_BIT19|_BIT21|_BIT23), HDMI_RX_DFE);
+
+	/* Load initial data */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DFE);
+
+	HDMI_DELAYMS(1);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DFE);
+
+	/* Adapt reset release */
+	hdmi_rx_reg_mask32(REG_DFE_MODE,
+		~REG_DFE_MODE_dfe_adapt_rstb_mask, REG_DFE_MODE_dfe_adapt_rstb_mask, HDMI_RX_DFE);
+	/* set run length = 4 */
+	hdmi_rx_reg_mask32(REG_DFE_GAIN,
+		~REG_DFE_GAIN_trans_rlength_mask, REG_DFE_GAIN_trans_rlength(2), HDMI_RX_DFE);
+
+	/* Set tap tap1 tap2 max min value */
+	if (b < 2844 && b > 1420) {
+		/* 3G ~1.5G */
+		hdmi_rx_reg_mask32(REG_DFE_LIMIT0,
+			~(REG_DFE_LIMIT0_tap1_min_mask|REG_DFE_LIMIT0_tap2_max_mask|REG_DFE_LIMIT0_tap2_min_mask),
+			(REG_DFE_LIMIT0_tap1_min(0x10)|REG_DFE_LIMIT0_tap2_max(0x14)|REG_DFE_LIMIT0_tap2_min(0xa)),
+			HDMI_RX_DFE);
+
+		hdmi_rx_reg_mask32(REG_DFE_LIMIT2,
+			~REG_DFE_LIMIT2_tap0_max_mask, REG_DFE_LIMIT2_tap0_max(0x24), HDMI_RX_DFE);
+	} else {
+		hdmi_rx_reg_mask32(REG_DFE_LIMIT0,
+			~(REG_DFE_LIMIT0_tap1_min_mask|REG_DFE_LIMIT0_tap2_max_mask|REG_DFE_LIMIT0_tap2_min_mask),
+			REG_DFE_LIMIT0_tap1_min(0x35)|REG_DFE_LIMIT0_tap2_max(0x14)|REG_DFE_LIMIT0_tap2_min(0x0),
+			HDMI_RX_DFE);
+
+		hdmi_rx_reg_mask32(REG_DFE_LIMIT2,
+			~REG_DFE_LIMIT2_tap0_max_mask, REG_DFE_LIMIT2_tap0_max(0x24), HDMI_RX_DFE);
+	}
+
+	/* Vth_min=0,Vth_max=0x7,Vth_th=0,Tap0_th=0 */
+	hdmi_rx_reg_mask32(REG_DFE_LIMIT1,
+		~(REG_DFE_LIMIT1_vth_min_mask | REG_DFE_LIMIT1_vth_max_mask |
+		REG_DFE_LIMIT1_vth_threshold_mask | REG_DFE_LIMIT1_tap0_threshold_mask |
+		REG_DFE_LIMIT1_tap0_adjust_mask | REG_DFE_LIMIT1_tap1_trans_mask),
+		REG_DFE_LIMIT1_vth_min(0) | REG_DFE_LIMIT1_vth_max(0x7) |
+		REG_DFE_LIMIT1_tap0_adjust(0x02) | REG_DFE_LIMIT1_tap1_trans(1),
+		HDMI_RX_DFE);
+
+	/* ENABLE  VTH & TAP0 */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth),
+		REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth),
+		REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth),
+		REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth, HDMI_RX_DFE);
+
+	HDMI_DELAYMS(5);
+
+	lib_hdmi_dfe_second_flow(b);
+	HDMI_DELAYMS(10);
+	lib_hdmi_fg_koffset_proc();
+
+	lib_hdmi_tap0_fix_small_swing();
+	HDMI_DELAYMS(10);
+	lib_hdmi_fg_koffset_proc();
+	HDMI_DELAYMS(1);
+
+	if (b > 2700) {
+		/* 3G need tap2 but below not need */
+		hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+			~(REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_LE | REG_dfe_adapt_en_lane0_TAP2),
+			REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_LE | REG_dfe_adapt_en_lane0_TAP2,
+			HDMI_RX_DFE);
+		hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+			~(REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_LE | REG_dfe_adapt_en_lane1_TAP2),
+			REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_LE | REG_dfe_adapt_en_lane1_TAP2,
+			HDMI_RX_DFE);
+		hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+			~(REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_LE | REG_dfe_adapt_en_lane2_TAP2),
+			REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_LE | REG_dfe_adapt_en_lane2_TAP2,
+			HDMI_RX_DFE);
+	} else {
+		hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+			~(REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_LE | REG_dfe_adapt_en_lane0_TAP2),
+			REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_LE,
+			HDMI_RX_DFE);
+		hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+			~(REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_LE | REG_dfe_adapt_en_lane1_TAP2),
+			REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_LE,
+			HDMI_RX_DFE);
+		hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+			~(REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_LE | REG_dfe_adapt_en_lane2_TAP2),
+			REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_LE,
+			HDMI_RX_DFE);
+	}
+
+}
+
+void lib_hdmi_set_dfe_mid_band(unsigned int b_clk, int dfe_mode)
+{
+	HDMI_PRINTF("%s\n", __func__);
+
+	lib_hdmi_dfe_power(1);
+
+	hdmi_rx_reg_mask32(REG_DFE_MODE,
+		~(REG_DFE_MODE_adapt_mode_mask | REG_DFE_MODE_edge_det_mode_mask |
+		REG_DFE_MODE_transition_only_mask | REG_DFE_MODE_tap1_delay_mask |
+		REG_DFE_MODE_tap24_delay_mask | REG_DFE_MODE_le_delay_mask |
+		REG_DFE_MODE_servo_delay_mask | REG_DFE_MODE_gray_en_mask |
+		REG_DFE_MODE_dfe_adapt_rstb_mask | REG_DFE_MODE_tap0_notrans_mask),
+		REG_DFE_MODE_adapt_mode(dfe_mode) | REG_DFE_MODE_edge_det_mode(0) |
+		REG_DFE_MODE_transition_only(1) | REG_DFE_MODE_tap1_delay(1) |
+		REG_DFE_MODE_tap24_delay(1) | REG_DFE_MODE_le_delay(1) |
+		REG_DFE_MODE_servo_delay(1) | REG_DFE_MODE_gray_en(1) |
+		REG_DFE_MODE_tap0_notrans(1), HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_DFE_EN_L0_clk_inv_lane0_mask | REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask | REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask | REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask | REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		REG_DFE_EN_L2_timer_ctrl_en_lane2(1) | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) | REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(0x5), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_DFE_EN_L1_clk_inv_lane1_mask | REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask | REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask | REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask | REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		REG_DFE_EN_L2_timer_ctrl_en_lane2(1) | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) | REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(0x5), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_DFE_EN_L2_clk_inv_lane2_mask | REG_DFE_EN_L2_timer_ctrl_en_lane2_mask |
+		REG_DFE_EN_L2_reduce_adapt_gain_lane2_mask | REG_DFE_EN_L2_rl_det_en_lane2_mask |
+		REG_DFE_EN_L2_rl_threshold_lane2_mask | REG_DFE_EN_L2_dfe_adapt_en_lane2_mask |
+		REG_DFE_EN_L2_le_min_lane2_mask | REG_DFE_EN_L2_le_init_lane2_mask |
+		REG_DFE_EN_L2_tap4_init_lane2_mask),
+		REG_DFE_EN_L2_timer_ctrl_en_lane2(1) | REG_DFE_EN_L2_reduce_adapt_gain_lane2(2) |
+		REG_DFE_EN_L2_rl_threshold_lane2(1) | REG_DFE_EN_L2_le_min_lane2(0x18) |
+		REG_DFE_EN_L2_le_init_lane2(0x5), HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask|REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap1_init_lane0(0x0)|REG_DFE_INIT0_L0_tap0_init_lane0(0x14)|REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask|REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap1_init_lane0(0x0)|REG_DFE_INIT0_L0_tap0_init_lane0(0x14)|REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask|REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap1_init_lane0(0x0)|REG_DFE_INIT0_L0_tap0_init_lane0(0x14)|REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), _BIT19|_BIT21|_BIT23, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), _BIT19|_BIT21|_BIT23, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_init1_rev1_lane0_mask), _BIT19|_BIT21|_BIT23, HDMI_RX_DFE);
+
+	/* Load initial data */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0,
+		~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1,
+		~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2,
+		~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), REG_DFE_INIT1_L0_load_in_init_lane0_mask, HDMI_RX_DFE);
+
+	HDMI_DELAYMS(1);
+
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(REG_DFE_INIT1_L0_load_in_init_lane0_mask), 0, HDMI_RX_DFE);
+
+
+	/* Adapt reset release */
+	hdmi_rx_reg_mask32(REG_DFE_MODE, ~(REG_DFE_MODE_dfe_adapt_rstb_mask), REG_DFE_MODE_dfe_adapt_rstb_mask, HDMI_RX_DFE);
+	/* Set run length = 4 */
+	hdmi_rx_reg_mask32(REG_DFE_GAIN, ~(REG_DFE_GAIN_trans_rlength_mask), REG_DFE_GAIN_trans_rlength(2), HDMI_RX_DFE);
+
+	/* Set tap tap1 tap2 max min value */
+	hdmi_rx_reg_mask32(REG_DFE_LIMIT0,
+		~(REG_DFE_LIMIT0_tap1_min_mask|REG_DFE_LIMIT0_tap2_max_mask|REG_DFE_LIMIT0_tap2_min_mask),
+		REG_DFE_LIMIT0_tap1_min(0x35)|REG_DFE_LIMIT0_tap2_max(0x14)|REG_DFE_LIMIT0_tap2_min(0xa),
+		HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_LIMIT2,
+		~(REG_DFE_LIMIT2_tap0_max_mask), REG_DFE_LIMIT2_tap0_max(0x24), HDMI_RX_DFE);
+
+	/* Vth_min=0,Vth_max=0x7,Vth_th=0,Tap0_th=0 */
+	hdmi_rx_reg_mask32(REG_DFE_LIMIT1,
+		~(REG_DFE_LIMIT1_vth_min_mask | REG_DFE_LIMIT1_vth_max_mask |
+		REG_DFE_LIMIT1_vth_threshold_mask | REG_DFE_LIMIT1_tap0_threshold_mask |
+		REG_DFE_LIMIT1_tap0_adjust_mask | REG_DFE_LIMIT1_tap1_trans_mask),
+		REG_DFE_LIMIT1_vth_min(0) | REG_DFE_LIMIT1_vth_max(0x7) |
+		REG_DFE_LIMIT1_tap0_adjust(0x02) | REG_DFE_LIMIT1_tap1_trans(1),
+		HDMI_RX_DFE);
+
+	/* ENABLE  VTH & TAP0 */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth),
+		REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth),
+		REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth),
+		REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth, HDMI_RX_DFE);
+
+	HDMI_DELAYMS(10);
+
+	lib_hdmi_dfe_second_flow(b_clk);
+	lib_hdmi_fg_koffset_proc();
+
+	lib_hdmi_tap0_fix_small_swing();
+	lib_hdmi_fg_koffset_proc();
+
+	/* ENABLE  VTH & TAP0 */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth),
+		REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth),
+		REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth),
+		REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth, HDMI_RX_DFE);
+
+}
+
+void lib_hdmi_dfe_manual_set(void)
+{
+	HDMI_PRINTF("%s\n", __func__);
+
+	lib_hdmi_dfe_rst(0);
+
+	/* Disable dfe */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0, ~REG_DFE_EN_L0_dfe_adapt_en_lane0_mask, 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1, ~REG_DFE_EN_L1_dfe_adapt_en_lane1_mask, 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2, ~REG_DFE_EN_L2_dfe_adapt_en_lane2_mask, 0, HDMI_RX_DFE);
+
+	/* Adaptive mode sel */
+	hdmi_rx_reg_mask32(REG_DFE_MODE,
+		~REG_DFE_MODE_adapt_mode_mask, REG_DFE_MODE_adapt_mode(3), HDMI_RX_DFE);
+
+	/* lane0 LE coefficient min */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~REG_DFE_EN_L0_le_min_lane0_mask, REG_DFE_EN_L0_le_min_lane0(0xf), HDMI_RX_DFE);
+	/* lane1 LE coefficient min */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~REG_DFE_EN_L1_le_min_lane1_mask, REG_DFE_EN_L1_le_min_lane1(0xf), HDMI_RX_DFE);
+	/* lane2 LE coefficient min */
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~REG_DFE_EN_L2_le_min_lane2_mask, REG_DFE_EN_L2_le_min_lane2(0xf), HDMI_RX_DFE);
+
+	/* lane0 tap1 initial */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+		~REG_DFE_INIT0_L0_tap1_init_lane0_mask, REG_DFE_INIT0_L0_tap1_init_lane0(5), HDMI_RX_DFE);
+	/* lane1 tap1 initial */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+		~REG_DFE_INIT0_L1_tap1_init_lane1_mask, REG_DFE_INIT0_L1_tap1_init_lane1(5), HDMI_RX_DFE);
+	/* lane2 tap1 initial */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+		~REG_DFE_INIT0_L2_tap1_init_lane2_mask, REG_DFE_INIT0_L2_tap1_init_lane2(5), HDMI_RX_DFE);
+
+	/* lane0 tap0 initial */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+		~REG_DFE_INIT0_L0_tap0_init_lane0_mask, REG_DFE_INIT0_L0_tap0_init_lane0(0x14), HDMI_RX_DFE);
+	/* lane1 tap0 initial */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+		~REG_DFE_INIT0_L1_tap0_init_lane1_mask, REG_DFE_INIT0_L1_tap0_init_lane1(0x14), HDMI_RX_DFE);
+	/* lane2 tap0 initial */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+		~REG_DFE_INIT0_L2_tap0_init_lane2_mask, REG_DFE_INIT0_L2_tap0_init_lane2(0x14), HDMI_RX_DFE);
+
+	/* lane0  initial load */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0,
+		~REG_DFE_INIT1_L0_load_in_init_lane0_mask, REG_DFE_INIT1_L0_load_in_init_lane0(3), HDMI_RX_DFE);
+	/* lane1  initial load */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1,
+		~REG_DFE_INIT1_L1_load_in_init_lane1_mask, REG_DFE_INIT1_L1_load_in_init_lane1(3), HDMI_RX_DFE);
+	/* lane2  initial load */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2,
+		~REG_DFE_INIT1_L2_load_in_init_lane2_mask, REG_DFE_INIT1_L2_load_in_init_lane2(3), HDMI_RX_DFE);
+
+	HDMI_DELAYUS(10);
+
+	/* lane0  initial load */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0,
+		~REG_DFE_INIT1_L0_load_in_init_lane0_mask, 0, HDMI_RX_DFE);
+	/* lane1  initial load */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1,
+		~REG_DFE_INIT1_L1_load_in_init_lane1_mask, 0, HDMI_RX_DFE);
+	/* lane2  initial load */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2,
+		~REG_DFE_INIT1_L2_load_in_init_lane2_mask, 0, HDMI_RX_DFE);
+
+	lib_hdmi_fg_koffset_proc();
+
+}
+
+
+unsigned char lib_hdmi_dfe_tap0_fix(void)
+{
+	unsigned char i, tap0max[3], tap0[3];
+	unsigned char tap0_max_of_3, tap0_min_of_3;
+
+	/* Read Tap0 max */
+	for (i = 0; i < 3; i++) {
+		tap0max[i] = lib_hdmi_dfe_get_tap0max(i);
+		tap0[i] = lib_hdmi_dfe_get_tap0(i);
+	}
+
+	if ((tap0max[0] > 2) && (tap0max[1] > 2) && (tap0max[2] > 2))
+		return FALSE;
+
+	tap0_max_of_3 = MAX(tap0[0], MAX(tap0[1], tap0[2]));
+	tap0_min_of_3 = MIN(tap0[0], MIN(tap0[1], tap0[2]));
+
+	if ((tap0_max_of_3 - tap0_min_of_3) < 8)
+		return FALSE;
+
+	HDMI_PRINTF("%s\n", __func__);
+	lib_hdmi_dfe_init_vth((LN_R|LN_G|LN_B), 0x03);
+	lib_hdmi_dfe_init_tap0((LN_R|LN_G|LN_B), 0x14);
+
+#if 1
+	HDMI_DELAYUS(300);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth),
+		REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth),
+		REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth),
+		REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth, HDMI_RX_DFE);
+
+	HDMI_DELAYUS(700);
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_record_limit_en_mask,
+		REG_DFE_READBACK_record_limit_en(1), HDMI_RX_DFE);
+
+	HDMI_DELAYMS(10);
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_record_limit_en_mask,
+		REG_DFE_READBACK_record_limit_en(0), HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth),
+		0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth),
+		0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth),
+		0, HDMI_RX_DFE);
+#endif
+
+	return TRUE;
+}
+
+
+void lib_hdmi_tap0_fix_small_swing(void)
+{
+	HDMI_PRINTF("%s\n", __func__);
+
+	lib_hdmi_dfe_init_vth((LN_R|LN_G|LN_B), 0x03);
+	lib_hdmi_dfe_init_tap0((LN_R|LN_G|LN_B), 0x14);
+
+	HDMI_DELAYUS(300);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth),
+		REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth),
+		REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth),
+		REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth, HDMI_RX_DFE);
+
+	HDMI_DELAYUS(700);
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_record_limit_en_mask,
+		REG_DFE_READBACK_record_limit_en(1), HDMI_RX_DFE);
+
+	HDMI_DELAYMS(10);
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_record_limit_en_mask,
+		REG_DFE_READBACK_record_limit_en(0), HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth), 0, HDMI_RX_DFE);
+
+}
+
+
+void lib_hdmi_dfe_second_flow(unsigned int b_clk)
+{
+	unsigned char i, tap0max[3];
+
+	HDMI_DELAYUS(300);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_record_limit_en_mask,
+		REG_DFE_READBACK_record_limit_en(1), HDMI_RX_DFE);
+	HDMI_DELAYMS(10);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_record_limit_en_mask,
+		REG_DFE_READBACK_record_limit_en(0), HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth), 0, HDMI_RX_DFE);
+
+	if (b_clk > 5000)
+		lib_hdmi_dfe_tap0_fix();
+
+	/* Read Tap0 max */
+	for (i = 0; i < 3; i++) {
+		tap0max[i] = lib_hdmi_dfe_get_tap0max(i);
+		tap0max[i] = (tap0max[i] > 2)?(tap0max[i]-2):0;
+	}
+
+	/* LOAD TAP0 max -1  & Vth 4 */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+		~(REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap0_init_lane0(tap0max[0])|REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+		~(REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap0_init_lane0(tap0max[1])|REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+		~(REG_DFE_INIT0_L0_tap0_init_lane0_mask|REG_DFE_INIT0_L0_vth_init_lane0_mask),
+		REG_DFE_INIT0_L0_tap0_init_lane0(tap0max[2])|REG_DFE_INIT0_L0_vth_init_lane0(0x3),
+		HDMI_RX_DFE);
+
+	/* Load initial data */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0,
+		~(LOAD_IN_INIT_TAP0|LOAD_IN_INIT_VTH),
+		LOAD_IN_INIT_TAP0|LOAD_IN_INIT_VTH, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1,
+		~(LOAD_IN_INIT_TAP0|LOAD_IN_INIT_VTH),
+		LOAD_IN_INIT_TAP0|LOAD_IN_INIT_VTH, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2,
+		~(LOAD_IN_INIT_TAP0|LOAD_IN_INIT_VTH),
+		LOAD_IN_INIT_TAP0|LOAD_IN_INIT_VTH, HDMI_RX_DFE);
+	HDMI_DELAYUS(100);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0,
+		~(LOAD_IN_INIT_TAP0|LOAD_IN_INIT_VTH), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1,
+		~(LOAD_IN_INIT_TAP0|LOAD_IN_INIT_VTH), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2,
+		~(LOAD_IN_INIT_TAP0|LOAD_IN_INIT_VTH), 0, HDMI_RX_DFE);
+
+}
+
+void lib_hdmi_load_le_max(void)
+{
+	unsigned char lemax[3];
+
+	HDMI_PRINTF("%s\n", __func__);
+
+	/* Read LE max */
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_limit_sel_mask, REG_DFE_READBACK_limit_sel(LIMIT_LE_MAX), HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(0), HDMI_RX_DFE);
+	lemax[0] = REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(1), HDMI_RX_DFE);
+	lemax[1] = REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(2), HDMI_RX_DFE);
+	lemax[2] = REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_limit_sel_mask, REG_DFE_READBACK_limit_sel(LIMIT_TAP1_MAX), HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(0), HDMI_RX_DFE);
+	lemax[0] += REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(1), HDMI_RX_DFE);
+	lemax[1] += REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(2), HDMI_RX_DFE);
+	lemax[2] += REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+
+	/* LOAD LE max */
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask), REG_DFE_INIT0_L0_tap1_init_lane0(lemax[0]), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask), REG_DFE_INIT0_L0_tap1_init_lane0(lemax[1]), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+		~(REG_DFE_INIT0_L0_tap1_init_lane0_mask), REG_DFE_INIT0_L0_tap1_init_lane0(lemax[2]), HDMI_RX_DFE);
+
+	/* Load initial data */
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0,
+		~(LOAD_IN_INIT_TAP1), LOAD_IN_INIT_TAP1, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1,
+		~(LOAD_IN_INIT_TAP1), LOAD_IN_INIT_TAP1, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2,
+		~(LOAD_IN_INIT_TAP1), LOAD_IN_INIT_TAP1, HDMI_RX_DFE);
+	HDMI_DELAYUS(10);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(LOAD_IN_INIT_TAP1), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(LOAD_IN_INIT_TAP1), 0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(LOAD_IN_INIT_TAP1), 0, HDMI_RX_DFE);
+
+}
+
+void lib_hdmi_dfe_examine_le_coef(unsigned int b_clk)
+{
+	unsigned char max_tap0, min_tap0;
+
+	max_tap0 = MAX(lib_hdmi_dfe_get_tap0(0), MAX(lib_hdmi_dfe_get_tap0(1), lib_hdmi_dfe_get_tap0(2)));
+	min_tap0 = MIN(lib_hdmi_dfe_get_tap0(0), MIN(lib_hdmi_dfe_get_tap0(1), lib_hdmi_dfe_get_tap0(2)));
+
+	HDMI_PRINTF ("%s-(max=%d, min=%d, b_clk=%d)\n",
+		__func__, max_tap0, min_tap0, b_clk);
+
+	if ((max_tap0-min_tap0 > 10) && ((b_clk > 2000) && (b_clk < 2200))) {
+		if (lib_hdmi_dfe_get_le(0) < 1) {
+			hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+				~(REG_DFE_INIT0_L0_tap1_init_lane0_mask), REG_DFE_INIT0_L0_tap1_init_lane0(0x1), HDMI_RX_DFE);
+			HDMI_DELAYUS(10);
+			hdmi_rx_reg_mask32(REG_DFE_INIT1_L0,
+				~(LOAD_IN_INIT_TAP1), LOAD_IN_INIT_TAP1, HDMI_RX_DFE);
+			HDMI_DELAYUS(10);
+			hdmi_rx_reg_mask32(REG_DFE_INIT1_L0,
+				~(LOAD_IN_INIT_TAP1), 0, HDMI_RX_DFE);
+			HDMI_PRINTF("[RELE_L0] LE reload 0x1\n");
+		}
+
+		if (lib_hdmi_dfe_get_le(1) < 1) {
+			hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+				~(REG_DFE_INIT0_L0_tap1_init_lane0_mask), REG_DFE_INIT0_L0_tap1_init_lane0(0x1), HDMI_RX_DFE);
+			HDMI_DELAYUS(10);
+			hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(LOAD_IN_INIT_TAP1), LOAD_IN_INIT_TAP1, HDMI_RX_DFE);
+			HDMI_DELAYUS(10);
+			hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(LOAD_IN_INIT_TAP1), 0, HDMI_RX_DFE);
+			HDMI_PRINTF("[RELE_L1] LE reload 0x1\n");
+		}
+
+		if (lib_hdmi_dfe_get_le(2) < 4) {
+			hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+				~(REG_DFE_INIT0_L0_tap1_init_lane0_mask), REG_DFE_INIT0_L0_tap1_init_lane0(0x6), HDMI_RX_DFE);
+			HDMI_DELAYUS(10);
+			hdmi_rx_reg_mask32(REG_DFE_INIT1_L2,
+				~(LOAD_IN_INIT_TAP1), LOAD_IN_INIT_TAP1, HDMI_RX_DFE);
+			HDMI_DELAYUS(10);
+			hdmi_rx_reg_mask32(REG_DFE_INIT1_L2,
+				~(LOAD_IN_INIT_TAP1), 0, HDMI_RX_DFE);
+			HDMI_PRINTF("[RELE_L2] LE reload 0x6\n");
+		}
+	}
+
+}
+
+void lib_hdmi_set_dfe_close(void)
+{
+	HDMI_PRINTF("%s", __func__);
+
+	hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+		~(REG_dfe_adapt_en_lane0_TAP0 | REG_dfe_adapt_en_lane0_Vth |
+		REG_dfe_adapt_en_lane0_TAP1 | REG_dfe_adapt_en_lane0_TAP2 |
+		REG_dfe_adapt_en_lane0_LE),
+		0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+		~(REG_dfe_adapt_en_lane1_TAP0 | REG_dfe_adapt_en_lane1_Vth |
+		REG_dfe_adapt_en_lane1_TAP1 | REG_dfe_adapt_en_lane1_TAP2 |
+		REG_dfe_adapt_en_lane1_LE),
+		0, HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+		~(REG_dfe_adapt_en_lane2_TAP0 | REG_dfe_adapt_en_lane2_Vth |
+		REG_dfe_adapt_en_lane2_TAP1 | REG_dfe_adapt_en_lane2_TAP2 |
+		REG_dfe_adapt_en_lane2_LE),
+		0, HDMI_RX_DFE);
+
+	/* Limit value record */
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_record_limit_en_mask,
+		REG_DFE_READBACK_record_limit_en(0), HDMI_RX_DFE);
+
+	hdmirx_state.DEF_ready = 1;
+
+}
+
+void lib_hdmi_dfe_record_enable(unsigned char onoff)
+{
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_record_limit_en_mask,
+		REG_DFE_READBACK_record_limit_en(onoff), HDMI_RX_DFE);
+}
+
+unsigned char lib_hdmi_dfe_is_record_enable(void)
+{
+	unsigned char temp;
+
+	temp = REG_DFE_READBACK_get_record_limit_en(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return temp;
+}
+
+void lib_hdmi_dfe_init_vth(unsigned char bgr, unsigned char value)
+{
+	if (bgr&LN_R)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+			~REG_DFE_INIT0_L2_vth_init_lane2_mask,
+			REG_DFE_INIT0_L2_vth_init_lane2(value), HDMI_RX_DFE);
+
+	if (bgr&LN_G)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+			~REG_DFE_INIT0_L1_vth_init_lane1_mask,
+			REG_DFE_INIT0_L2_vth_init_lane2(value), HDMI_RX_DFE);
+
+	if (bgr&LN_B)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+			~REG_DFE_INIT0_L0_vth_init_lane0_mask,
+			REG_DFE_INIT0_L0_vth_init_lane0(value), HDMI_RX_DFE);
+
+
+	lib_hdmi_dfe_load_in_adp(bgr, LOAD_IN_INIT_VTH);
+}
+
+void lib_hdmi_dfe_init_tap0(unsigned char bgr, unsigned char value)
+{
+	if (bgr&LN_R)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+			~REG_DFE_INIT0_L2_tap0_init_lane2_mask,
+			REG_DFE_INIT0_L2_tap0_init_lane2(value), HDMI_RX_DFE);
+
+	if (bgr&LN_G)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+			~REG_DFE_INIT0_L1_tap0_init_lane1_mask,
+			REG_DFE_INIT0_L1_tap0_init_lane1(value), HDMI_RX_DFE);
+
+	if (bgr&LN_B)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+			~REG_DFE_INIT0_L0_tap0_init_lane0_mask,
+			REG_DFE_INIT0_L0_tap0_init_lane0(value), HDMI_RX_DFE);
+
+	lib_hdmi_dfe_load_in_adp(bgr, LOAD_IN_INIT_TAP0);
+}
+
+void lib_hdmi_dfe_init_tap1(unsigned char bgr, unsigned char value)
+{
+	if (bgr&LN_R)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+			~REG_DFE_INIT0_L2_tap1_init_lane2_mask,
+			REG_DFE_INIT0_L2_tap1_init_lane2(value), HDMI_RX_DFE);
+
+	if (bgr&LN_G)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+			~REG_DFE_INIT0_L1_tap1_init_lane1_mask,
+			REG_DFE_INIT0_L1_tap1_init_lane1(value), HDMI_RX_DFE);
+
+	if (bgr&LN_B)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+			~REG_DFE_INIT0_L0_tap1_init_lane0_mask,
+			REG_DFE_INIT0_L0_tap1_init_lane0(value), HDMI_RX_DFE);
+
+	lib_hdmi_dfe_load_in_adp(bgr, LOAD_IN_INIT_TAP1);
+}
+
+void lib_hdmi_dfe_init_tap2(unsigned char bgr, signed char value)
+{
+	if (value < 0)
+		value = 0x20|((-value)&0x1f);
+	else
+		value = (value&0x1f);
+
+	if (bgr&LN_R)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L2,
+			~REG_DFE_INIT0_L2_tap2_init_lane2_mask,
+			REG_DFE_INIT0_L2_tap2_init_lane2(value), HDMI_RX_DFE);
+
+	if (bgr&LN_G)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L1,
+			~REG_DFE_INIT0_L1_tap2_init_lane1_mask,
+			REG_DFE_INIT0_L1_tap2_init_lane1(value), HDMI_RX_DFE);
+
+	if (bgr&LN_B)
+		hdmi_rx_reg_mask32(REG_DFE_INIT0_L0,
+			~REG_DFE_INIT0_L0_tap2_init_lane0_mask,
+			REG_DFE_INIT0_L0_tap2_init_lane0(value), HDMI_RX_DFE);
+
+	lib_hdmi_dfe_load_in_adp(bgr, LOAD_IN_INIT_TAP2);
+}
+
+void lib_hdmi_dfe_init_le(unsigned char bgr, unsigned char value)
+{
+	if (bgr&LN_R)
+		hdmi_rx_reg_mask32(REG_DFE_EN_L2,
+			~REG_DFE_EN_L2_le_init_lane2_mask,
+			REG_DFE_EN_L2_le_init_lane2(value), HDMI_RX_DFE);
+
+	if (bgr&LN_G)
+		hdmi_rx_reg_mask32(REG_DFE_EN_L1,
+			~REG_DFE_EN_L1_le_init_lane1_mask,
+			REG_DFE_EN_L1_le_init_lane1(value), HDMI_RX_DFE);
+
+	if (bgr&LN_B)
+		hdmi_rx_reg_mask32(REG_DFE_EN_L0,
+			~REG_DFE_EN_L0_le_init_lane0_mask,
+			REG_DFE_EN_L0_le_init_lane0(value), HDMI_RX_DFE);
+
+	lib_hdmi_dfe_load_in_adp(bgr, LOAD_IN_INIT_LE);
+}
+
+void lib_hdmi_dfe_load_in_adp(unsigned char bgr, unsigned int option)
+{
+	if (bgr&LN_R)
+		hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(option), option, HDMI_RX_DFE);
+
+	if (bgr&LN_G)
+		hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(option), option, HDMI_RX_DFE);
+
+	if (bgr&LN_B)
+		hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(option), option, HDMI_RX_DFE);
+
+
+	HDMI_DELAYUS(10);
+
+	if (bgr&LN_R)
+		hdmi_rx_reg_mask32(REG_DFE_INIT1_L2, ~(option), 0, HDMI_RX_DFE);
+
+	if (bgr&LN_G)
+		hdmi_rx_reg_mask32(REG_DFE_INIT1_L1, ~(option), 0, HDMI_RX_DFE);
+
+	if (bgr&LN_B)
+		hdmi_rx_reg_mask32(REG_DFE_INIT1_L0, ~(option), 0, HDMI_RX_DFE);
+
+}
+
+unsigned char lib_hdmi_dfe_get_vth(unsigned char lane)
+{
+	unsigned char coef_data;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_coef_sel_mask,
+		REG_DFE_READBACK_coef_sel(COEF_VTH), HDMI_RX_DFE);
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask,
+		REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	coef_data = REG_DFE_READBACK_get_coef_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return coef_data;
+}
+
+unsigned char lib_hdmi_dfe_get_tap0(unsigned char lane)
+{
+	unsigned char coef_data;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_coef_sel_mask, REG_DFE_READBACK_coef_sel(COEF_TAP0), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	coef_data = REG_DFE_READBACK_get_coef_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return coef_data;
+}
+
+unsigned char lib_hdmi_dfe_get_tap0max(unsigned char lane)
+{
+	unsigned char limit_data;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_limit_sel_mask, REG_DFE_READBACK_limit_sel(LIMIT_TAP0_MAX), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	limit_data = REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return limit_data;
+}
+
+unsigned char lib_hdmi_dfe_get_tap0min(unsigned char lane)
+{
+	unsigned char limit_data;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_limit_sel_mask, REG_DFE_READBACK_limit_sel(LIMIT_TAP0_MIN), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	limit_data = REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return limit_data;
+}
+
+unsigned char lib_hdmi_dfe_get_tap1(unsigned char lane)
+{
+	unsigned char coef_data;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_coef_sel_mask, REG_DFE_READBACK_coef_sel(COEF_TAP1), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	coef_data = REG_DFE_READBACK_get_coef_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return coef_data;
+}
+
+unsigned char lib_hdmi_dfe_get_tap1max(unsigned char lane)
+{
+	unsigned char limit_data;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_limit_sel_mask, REG_DFE_READBACK_limit_sel(LIMIT_TAP1_MAX), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	limit_data = REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return limit_data;
+}
+
+unsigned char lib_hdmi_dfe_get_tap1min(unsigned char lane)
+{
+	unsigned char limit_data;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_limit_sel_mask, REG_DFE_READBACK_limit_sel(LIMIT_TAP1_MIN), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	limit_data = REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return limit_data;
+}
+
+char lib_hdmi_dfe_get_tap2(unsigned char lane)
+{
+	unsigned char coef;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_coef_sel_mask, REG_DFE_READBACK_coef_sel(COEF_TAP2), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	coef = get_TAP2_coef_sign(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE)) ? \
+		-get_TAP2_coef(REG_DFE_READBACK_get_coef_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE))) :
+		get_TAP2_coef(REG_DFE_READBACK_get_coef_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE)));
+
+	return coef;
+}
+
+unsigned char lib_hdmi_dfe_get_le(unsigned char lane)
+{
+	unsigned char coef_data;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_coef_sel_mask, REG_DFE_READBACK_coef_sel(COEF_LE), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	coef_data = REG_DFE_READBACK_get_coef_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return coef_data;
+}
+
+unsigned char lib_hdmi_dfe_get_lemax(unsigned char lane)
+{
+	unsigned char limit_data;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_limit_sel_mask, REG_DFE_READBACK_limit_sel(LIMIT_LE_MAX), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	limit_data = REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return limit_data;
+}
+
+unsigned char lib_hdmi_dfe_get_lemin(unsigned char lane)
+{
+	unsigned char limit_data;
+
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_limit_sel_mask, REG_DFE_READBACK_limit_sel(LIMIT_LE_MIN), HDMI_RX_DFE);
+	hdmi_rx_reg_mask32(REG_DFE_READBACK,
+		~REG_DFE_READBACK_lane_sel_mask, REG_DFE_READBACK_lane_sel(lane), HDMI_RX_DFE);
+
+	limit_data = REG_DFE_READBACK_get_limit_data(hdmi_rx_reg_read32(REG_DFE_READBACK, HDMI_RX_DFE));
+	return limit_data;
+}
+
+
+
+void lib_hdmi_cmu_pll_en(unsigned char enable)
+{
+	hdmi_rx_reg_mask32(ENABLE,
+		~ENABLE_reg_p0_en_cmu_mask, enable?ENABLE_reg_p0_en_cmu_mask:0, HDMI_RX_PHY);
+}
+
+/**
+ * lib_hdmi_demux_ck_vcopll_rst
+ *
+ * @rst: 1-reset, 0-normal working operation
+ */
+void lib_hdmi_demux_ck_vcopll_rst(unsigned char rst)
+{
+	if (rst) {
+		lib_hdmi_dfe_rst(1);
+		hdmi_rx_reg_mask32(RST,
+			~(RST_p0_r_demux_rstb_mask|RST_p0_g_demux_rstb_mask|RST_p0_b_demux_rstb_mask), 0, HDMI_RX_PHY);
+	} else {
+		hdmi_rx_reg_mask32(RST,
+			~(RST_p0_r_demux_rstb_mask|RST_p0_g_demux_rstb_mask|RST_p0_b_demux_rstb_mask),
+			RST_p0_r_demux_rstb_mask|RST_p0_g_demux_rstb_mask|RST_p0_b_demux_rstb_mask, HDMI_RX_PHY);
+		lib_hdmi_dfe_rst(0);
+	}
+
+}
+
+/**
+ * lib_hdmi_dfe_rst
+ *
+ * @rst: 1-reset, 0-normal working operation
+ */
+void lib_hdmi_dfe_rst(unsigned char rst)
+{
+	hdmi_rx_reg_mask32(HDMI_CTS_FIFO_CTL,
+		~HDMI_CTS_FIFO_CTL_dfe_rstn_n_mask, rst?0:HDMI_CTS_FIFO_CTL_dfe_rstn_n_mask, HDMI_RX_MAC);
+
+}
+
+/**
+ * lib_hdmi_cdr_rst
+ *
+ * @rst: 1-reset, 0-normal working operation
+ */
+void lib_hdmi_cdr_rst(unsigned char rst)
+{
+	if (rst) {
+		hdmi_rx_reg_mask32(REGD0,
+			~(REGD0_p0_r_dig_rst_n_mask|REGD0_p0_g_dig_rst_n_mask|REGD0_p0_b_dig_rst_n_mask), 0, HDMI_RX_PHY);
+		hdmi_rx_reg_mask32(REGD0,
+			~(REGD0_p0_r_cdr_rst_n_mask|REGD0_p0_g_cdr_rst_n_mask|REGD0_p0_b_cdr_rst_n_mask), 0, HDMI_RX_PHY);
+	} else {
+		hdmi_rx_reg_mask32(REGD0,
+			~(REGD0_p0_r_dig_rst_n_mask | REGD0_p0_g_dig_rst_n_mask | REGD0_p0_b_dig_rst_n_mask |
+			REGD0_p0_r_cdr_rst_n_mask | REGD0_p0_g_cdr_rst_n_mask | REGD0_p0_b_cdr_rst_n_mask),
+			REGD0_p0_r_dig_rst_n(1) | REGD0_p0_g_dig_rst_n(1) | REGD0_p0_b_dig_rst_n(1) |
+			REGD0_p0_r_cdr_rst_n(1) | REGD0_p0_g_cdr_rst_n(1) | REGD0_p0_b_cdr_rst_n(1),
+			HDMI_RX_PHY);
+	}
+
+}
+
+void lib_hdmi_wdog(void)
+{
+
+	hdmi_rx_reg_write32(REGD20, 0xE4E84505, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(REGD21,
+		~(REGD21_reg_p0_wd_sdm_en_mask), 0, HDMI_RX_PHY);
+	HDMI_DELAYMS(5);
+	hdmi_rx_reg_mask32(REGD21,
+		~(REGD21_reg_p0_wd_sdm_en_mask), REGD21_reg_p0_wd_sdm_en_mask, HDMI_RX_PHY);
+
+}
+
+void lib_hdmi_dfe_config_setting(void)
+{
+	lib_hdmi_mac_afifo_enable();
+}
+
+
+void lib_hdmi_set_phy_table(HDMI_PHY_PARAM_T *phy_param)
+{
+	unsigned int wReg1, wReg2, wCk1Reg, wCk2Reg, ck_md_sel;
+	unsigned int B2REG, G2REG, R2REG;
+	unsigned int B3REG, G3REG, R3REG;
+
+	wReg1 = REGD21;
+	wReg2 = REGD0;
+	wCk1Reg = P0_CK1;
+	B2REG = P0_B2;
+	G2REG = P0_G2;
+	R2REG = P0_R2;
+	B3REG = P0_B3;
+	G3REG = P0_G3;
+	R3REG = P0_R3;
+	wCk2Reg = P0_CK2;
+	ck_md_sel = REGD56;
+
+	hdmi_rx_reg_mask32(B3REG, ~(P0_b_12_PI_CSEL|P0_b_12_PI_CURRENT), (phy_param->PI_CURRENT<<28)|(phy_param->PI_CSEL<<24), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(G3REG, ~(P0_g_12_PI_CSEL|P0_g_12_PI_CURRENT), (phy_param->PI_CURRENT<<28)|(phy_param->PI_CSEL<<24), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(R3REG, ~(P0_r_12_PI_CSEL|P0_r_12_PI_CURRENT), (phy_param->PI_CURRENT<<28)|(phy_param->PI_CSEL<<24), HDMI_RX_PHY);
+
+	/* M code set */
+	hdmi_rx_reg_mask32(wReg1, ~REGD21_reg_p0_n_code_mask, phy_param->M_code<<REGD21_reg_p0_n_code_shift, HDMI_RX_PHY);
+
+	/* N code */
+	hdmi_rx_reg_mask32(wCk1Reg, ~(p0_ck_3_CMU_N_code|p0_ck_3_CMU_PREDIVN), phy_param->N_code<<18, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(wCk1Reg, ~(p0_ck_3_CMU_SEL_D4), phy_param->CMU_SEL_D4 << 16, HDMI_RX_PHY);
+
+	/* PI_DIV */
+	hdmi_rx_reg_mask32(B2REG, ~P0_b_8_PR_RATE_SEL, phy_param->PI_DIV<<26, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(G2REG, ~P0_b_8_PR_RATE_SEL, phy_param->PI_DIV<<26, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(R2REG, ~P0_b_8_PR_RATE_SEL, phy_param->PI_DIV<<26, HDMI_RX_PHY);
+
+	/* DEMUX */
+	hdmi_rx_reg_mask32(B2REG, ~(P0_b_8_DEMUX|P0_b_7_PI_ISEL), (phy_param->DEMUX<<29)|(phy_param->PI_ISEL<<16), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(G2REG, ~(P0_b_8_DEMUX|P0_b_7_PI_ISEL), (phy_param->DEMUX<<29)|(phy_param->PI_ISEL<<16), HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(R2REG, ~(P0_b_8_DEMUX|P0_b_7_PI_ISEL), (phy_param->DEMUX<<29)|(phy_param->PI_ISEL<<16), HDMI_RX_PHY);
+
+	hdmi_rx_reg_mask32(wCk2Reg,
+		~(P0_ck_5_CMU_SEL_R1_mask | P0_ck_5_CMU_SEL_PUMP_DB_mask |
+		P0_ck_5_CMU_SEL_PUMP_I_mask | P0_ck_6_CMU_SEL_CS_mask |
+		P0_ck_6_CMU_EN_CAP_mask | P0_ck_6_CMU_BIG_KVCO_mask |
+		P0_ck_7_CMU_BYPASS_PI_mask | P0_ck_8_CMU_SEL_CP_mask |
+		P0_ck_8_CMU_BPPSR_mask | P0_ck_8_LDO_EN_mask |
+		P0_ck_8_VSEL_LDO_A_mask),
+		(phy_param->CK_RS<<0) | (phy_param->Icp_DUL<<3) |
+		(phy_param->CK_Icp<<4) | (phy_param->CK_CS<<8) |
+		(phy_param->EN_CAP << 12) | (phy_param->CMU_KVCO << 13) |
+		P0_ck_7_CMU_BYPASS_PI_mask | P0_CMU_BPPSR(phy_param->pscaler) |
+		P0_ck_8_LDO_EN_mask | P0_VSEL_LDO(3), HDMI_RX_PHY);
+
+	hdmi_rx_reg_mask32(wReg2,
+		~(REGD5_reg_p1_rate_sel_mask | REGD0_reg_p0_kp_mask |
+		REGD0_reg_p0_ki_mask | REGD0_reg_p0_bypass_sdm_int_mask),
+		REGD5_reg_p1_rate_sel(phy_param->RATE_SEL) | (phy_param->CDR_KP<<REGD0_reg_p0_kp_shift) |
+		(phy_param->CDR_KI<<REGD0_reg_p0_ki_shift) | REGD0_reg_p0_bypass_sdm_int_mask, HDMI_RX_PHY);
+
+	hdmi_rx_reg_mask32(ck_md_sel,
+		~REGD56_reg_p0_ck_md_sel_mask, REGD56_reg_p0_ck_md_sel(0), HDMI_RX_PHY);
+
+}
+
+
+
+void lib_hdmi_cco_band_config(unsigned int bclk, HDMI_PHY_PARAM_T *phy_param)
+{
+	HDMI_PHY_PARAM2_T *phy_param2 = &hdmi_phy_param2[0];
+	unsigned char i = 0, tabsize = 0;
+	unsigned int Fvco;
+	unsigned int tmds_b = bclk;
+
+	/* Fvco=[(Fin x prescaler x SEL_D4 x M_Code)  N_Code ] */
+	/* Fin=[(b+1)x27256] */
+
+	if (hdmi2p0_get_clock40x_flag()) {
+		if (((bclk >> 2) < 1422) && ((bclk >> 2) > 699))
+			tmds_b = (bclk >> 2);
+	}
+
+	/* cco band */
+	Fvco = (tmds_b + 1) * 27 * (phy_param->pscaler ? 1 : 2) * (1 << phy_param->CMU_SEL_D4) * (phy_param->M_code + 4);
+	Fvco = (Fvco / (1 << phy_param->N_code)) >> 8;
+
+	tabsize = sizeof(hdmi_phy_param2)/sizeof(HDMI_PHY_PARAM2_T);
+
+	for (i = 0 ; i < tabsize ; ++i) {
+		if ((Fvco >= hdmi_phy_param2[i].fvco_lower) && (Fvco < phy_param2[i].fvco_upper))
+			break;
+	}
+	HDMI_PRINTF("Fvco=%x-----------------------------------------\n", Fvco);
+	if (i >= tabsize) {
+		HDMI_PRINTF("Not Found in PHY_PARAM2 (Fvco=%d)\n", Fvco);
+		return;
+	}
+
+	phy_param2 = &hdmi_phy_param2[i];
+
+	hdmi_rx_reg_mask32(P0_CK2,
+		~(P0_ck_8_CCO_BAND_SEL_mask),
+		P0_CCO_BAND_SEL(phy_param2->CCO_BAND_SEL), HDMI_RX_PHY);
+
+}
+
+
+unsigned char lib_hdmi_acdr_check_result(void)
+{
+	HDMI_PRINTF("lib_hdmi_acdr_check_result skip\n");
+	return TRUE;
+}
+
+
+void lib_hdmi_fg_koffset_manual_adjust(unsigned int r, unsigned int g, unsigned int b)
+{
+
+	hdmi_rx_reg_mask32(P0_R1, ~P0_b_1_FORE_KOFF_ADJR, r<<16, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_G1, ~P0_b_1_FORE_KOFF_ADJR, g<<16, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_B1, ~P0_b_1_FORE_KOFF_ADJR, b<<16, HDMI_RX_PHY);
+
+}
+
+void lib_hdmi_fg_koffset_manual(void)
+{
+
+	hdmi_rx_reg_mask32(P0_R1, ~P0_r_4_FORE_KOFF_AUTOK, 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_G1, ~P0_g_4_FORE_KOFF_AUTOK, 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_B1, ~P0_b_4_FORE_KOFF_AUTOK, 0, HDMI_RX_PHY);
+
+}
+
+#define FORE_KOFF_RANGE  1  /* range maybe 0  1  2   3 */
+void lib_hdmi_fg_koffset_auto(void)
+{
+	UINT8 i, k_cnt;
+	UINT32 w_b_addr_control, w_g_addr_control, w_r_addr_control;
+	UINT32 w_b_addr_result, w_g_addr_result, w_r_addr_result;
+	volatile u_int32_t koff_r_result ;
+	volatile u_int32_t  koff_g_result;
+	volatile u_int32_t  koff_b_result;
+
+	w_b_addr_control = P0_B1;
+	w_g_addr_control = P0_G1;
+	w_r_addr_control = P0_R1;
+	w_b_addr_result = P0_B4;
+	w_g_addr_result = P0_G4;
+	w_r_addr_result = P0_R4;
+
+	/* Initial circuit power */
+	hdmi_rx_reg_mask32(w_b_addr_control,
+		~(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK|P0_b_4_FORE_POW_FORE_KOFF),
+		P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_g_addr_control,
+		~(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK|P0_b_4_FORE_POW_FORE_KOFF),
+		P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_r_addr_control,
+		~(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK|P0_b_4_FORE_POW_FORE_KOFF),
+		P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK, HDMI_RX_PHY);
+	/* Cut input off */
+	hdmi_rx_reg_mask32(w_b_addr_control,
+		~(P0_b_1_inputoff), P0_b_1_inputoff, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_g_addr_control,
+		~(P0_b_1_inputoff), P0_b_1_inputoff, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_r_addr_control,
+		~(P0_b_1_inputoff), P0_b_1_inputoff, HDMI_RX_PHY);
+
+	/* For b lane */
+	for (i = 0; i < FORE_KOFF_RANGE+1; i++) {
+		hdmi_rx_reg_mask32(w_b_addr_control,
+			~(P0_b_4_FORE_POW_FORE_KOFF), 0, HDMI_RX_PHY);
+
+		/* Set k off range */
+		hdmi_rx_reg_mask32(w_b_addr_control,
+			~(P0_b_1_FORE_KOFF_RANGE), i<<21, HDMI_RX_PHY);
+
+		/* Start cal */
+		hdmi_rx_reg_mask32(w_b_addr_control,
+			~(P0_b_4_FORE_POW_FORE_KOFF), P0_b_4_FORE_POW_FORE_KOFF, HDMI_RX_PHY);
+
+		/* Wait finish cal */
+		k_cnt = 100;
+		while (!((hdmi_rx_reg_read32(w_b_addr_result, HDMI_RX_PHY))&P0_B4_reg_p0_b_koffok_mask) && --k_cnt)
+			HDMI_DELAYUS(200);
+
+		if (k_cnt == 0)
+			HDMI_PRINTF("[ERROR] %s: func err(B)\n", __func__);
+
+		koff_b_result = P0_B4_get_reg_p0_b_koff_sel(hdmi_rx_reg_read32(w_b_addr_result, HDMI_RX_PHY));
+
+		if (!(hdmi_rx_reg_read32(w_b_addr_result, HDMI_RX_PHY) & P0_B4_reg_p0_b_koff_bound_mask))
+			break;
+
+		if (i == FORE_KOFF_RANGE)
+			HDMI_PRINTF("[ERROR] %s: out of B range (value=%d)\n", __func__, i);
+	}
+
+
+	/* For g lane */
+	for (i = 0; i < FORE_KOFF_RANGE+1; i++) {
+		hdmi_rx_reg_mask32(w_g_addr_control,
+			~(P0_b_4_FORE_POW_FORE_KOFF), 0, HDMI_RX_PHY);
+
+		/* Set k off range */
+		hdmi_rx_reg_mask32(w_g_addr_control,
+			~(P0_b_1_FORE_KOFF_RANGE), i<<21, HDMI_RX_PHY);
+
+		/* Start cal */
+		hdmi_rx_reg_mask32(w_g_addr_control,
+			~(P0_b_4_FORE_POW_FORE_KOFF), P0_b_4_FORE_POW_FORE_KOFF, HDMI_RX_PHY);
+
+		/* Wait finish cal */
+		k_cnt = 100;
+		while (!((hdmi_rx_reg_read32(w_g_addr_result, HDMI_RX_PHY))&P0_B4_reg_p0_b_koffok_mask) && --k_cnt)
+			HDMI_DELAYUS(200);
+
+		if (k_cnt == 0)
+			HDMI_PRINTF("[ERROR] %s: func err(G)\n", __func__);
+
+		koff_g_result = P0_B4_get_reg_p0_b_koff_sel(hdmi_rx_reg_read32(w_g_addr_result, HDMI_RX_PHY));
+
+		if (!(hdmi_rx_reg_read32(w_g_addr_result, HDMI_RX_PHY) & P0_B4_reg_p0_b_koff_bound_mask))
+			break;
+
+		if (i == FORE_KOFF_RANGE)
+			HDMI_PRINTF("[ERROR] %s: out of G range (value=%d)\n", __func__, i);
+
+	}
+
+
+	/* For r lane */
+	for (i = 0; i < FORE_KOFF_RANGE+1; i++) {
+		hdmi_rx_reg_mask32(w_r_addr_control,
+			~(P0_b_4_FORE_POW_FORE_KOFF), 0, HDMI_RX_PHY);
+
+		/* Set k off range */
+		hdmi_rx_reg_mask32(w_r_addr_control,
+			~(P0_b_1_FORE_KOFF_RANGE), i<<21, HDMI_RX_PHY);
+
+		/* Start cal */
+		hdmi_rx_reg_mask32(w_r_addr_control,
+			~(P0_b_4_FORE_POW_FORE_KOFF), P0_b_4_FORE_POW_FORE_KOFF, HDMI_RX_PHY);
+
+		/* Wait finish cal */
+		k_cnt = 100;
+		while (!((hdmi_rx_reg_read32(w_r_addr_result, HDMI_RX_PHY))&P0_B4_reg_p0_b_koffok_mask) && --k_cnt)
+			HDMI_DELAYUS(200);
+
+		if (k_cnt == 0)
+			HDMI_PRINTF("[ERROR] %s: func err(R)\n", __func__);
+
+		koff_r_result = P0_B4_get_reg_p0_b_koff_sel(hdmi_rx_reg_read32(w_r_addr_result, HDMI_RX_PHY));
+
+		if (!(hdmi_rx_reg_read32(w_r_addr_result, HDMI_RX_PHY) & P0_B4_reg_p0_b_koff_bound_mask))
+			break;
+
+		if (i == FORE_KOFF_RANGE)
+			HDMI_PRINTF("[ERROR] %s: out of R range (value=%d)\n", __func__, i);
+
+	}
+
+	/* Cut input on */
+	hdmi_rx_reg_mask32(w_b_addr_control, ~P0_b_1_inputoff, 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_g_addr_control, ~P0_b_1_inputoff, 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(w_r_addr_control, ~P0_b_1_inputoff, 0, HDMI_RX_PHY);
+
+	HDMI_PRINTF("FG KOFFSET=(b=%d,g=%d,r=%d)\n", koff_b_result, koff_g_result, koff_r_result);
+
+}
+
+void lib_hdmi_fg_koffset_proc(void)
+{
+
+	lib_hdmi_fg_koffset_auto();
+	lib_hdmi_cdr_rst(1);
+	HDMI_DELAYUS(20);
+	lib_hdmi_cdr_rst(0);
+	HDMI_DELAYMS(10);
+
+}
+
+void lib_hdmi_fg_koffset_disable(void)
+{
+
+	hdmi_rx_reg_mask32(P0_B1, ~(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_POW_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK), 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_G1, ~(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_POW_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK), 0, HDMI_RX_PHY);
+	hdmi_rx_reg_mask32(P0_R1, ~(P0_b_3_FORE_EN_FORE_KOFF|P0_b_4_FORE_POW_FORE_KOFF|P0_b_4_FORE_KOFF_AUTOK), 0, HDMI_RX_PHY);
+
+}
+
+void lib_hdmi_z0_calibration(void)
+{
+	hdmi_rx_reg_mask32(Z0K,
+		~(Z0K_reg_z0_adjr_0_mask | Z0K_reg_z0_adjr_1_mask | Z0K_reg_z0_adjr_2_mask),
+		Z0K_reg_z0_adjr_0(ManualZ0) | Z0K_reg_z0_adjr_1(ManualZ0) | Z0K_reg_z0_adjr_2(ManualZ0),
+		HDMI_RX_PHY);
+}
+
+
+void lib_hdmi_char_err_rst(unsigned char rst)
+{
+	if (rst) {
+		hdmi_rx_reg_mask32(HDMI_CERCR, ~(HDMI_CERCR_en_mask), 0, HDMI_RX_MAC);
+		hdmi_rx_reg_mask32(HDMI_CERCR,
+			~(HDMI_CERCR_valid_reset_mask|HDMI_CERCR_reset_err_det_mask|HDMI_CERCR_reset_mask),
+			(HDMI_CERCR_valid_reset_mask|HDMI_CERCR_reset_err_det_mask|HDMI_CERCR_reset_mask),
+			HDMI_RX_MAC);
+	} else {
+		hdmi_rx_reg_mask32(HDMI_CERCR,
+			~(HDMI_CERCR_valid_reset_mask|HDMI_CERCR_reset_err_det_mask|HDMI_CERCR_reset_mask),
+			0, HDMI_RX_MAC);
+	}
+}
+
+void lib_hdmi_char_err_start(unsigned char conti_mode, unsigned char period)
+{
+	hdmi_rx_reg_mask32(HDMI_CERCR, ~(HDMI_CERCR_en_mask), 0, HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_CERCR,
+		~(HDMI_CERCR_ch_locked_reset_mask|HDMI_CERCR_reset_mask),
+		HDMI_CERCR_ch_locked_reset_mask|HDMI_CERCR_reset_mask, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_CERCR,
+		~(HDMI_CERCR_valid_reset_mask|HDMI_CERCR_keep_err_det_mask),
+		HDMI_CERCR_valid_reset_mask|HDMI_CERCR_keep_err_det_mask, HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_CERCR,
+		~(HDMI_CERCR_period_mask|HDMI_CERCR_mode_mask),
+		HDMI_CERCR_period(period)|HDMI_CERCR_mode(conti_mode), HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_CERCR,
+		~(HDMI_CERCR_ch_locked_reset_mask|HDMI_CERCR_reset_mask), 0, HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_CERCR,
+		~(HDMI_CERCR_valid_reset_mask|HDMI_CERCR_keep_err_det_mask), 0, HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_CERCR,
+		~HDMI_CERCR_refer_implem_mask, HDMI_CERCR_refer_implem_mask, HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_CERCR,
+		~HDMI_CERCR_en_mask, HDMI_CERCR_en_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_char_err_det_done(void)
+{
+	unsigned char temp;
+
+	temp = !HDMI_CERCR_get_en(hdmi_rx_reg_read32(HDMI_CERCR, HDMI_RX_MAC));
+	return temp;
+}
+
+unsigned char lib_hdmi_char_err_get_error(unsigned int *r_err, unsigned int *g_err, unsigned int *b_err)
+{
+	unsigned int reg_val;
+
+	reg_val = hdmi_rx_reg_read32(HDMI_CERCR, HDMI_RX_MAC);
+	if (HDMI_CERCR_get_en(reg_val) &&
+		(!HDMI_CERCR_get_ch0_over_max_err_num(reg_val) &&
+		!HDMI_CERCR_get_ch1_over_max_err_num(reg_val) &&
+		!HDMI_CERCR_get_ch2_over_max_err_num(reg_val)))
+		return 0;/* Not yet finish counting */
+
+	*b_err = HDMI_CERSR0_get_err_cnt0_video(hdmi_rx_reg_read32(HDMI_CERSR0, HDMI_RX_MAC));
+	*g_err = HDMI_CERSR0_get_err_cnt1_video(hdmi_rx_reg_read32(HDMI_CERSR0, HDMI_RX_MAC));
+	*r_err = HDMI_CERSR1_get_err_cnt2_video(hdmi_rx_reg_read32(HDMI_CERSR1, HDMI_RX_MAC));
+
+	return 1;
+}
+
+void lib_hdmi_bit_err_start(unsigned char conti_mode, unsigned char period)
+{
+	/* Disable */
+	hdmi_rx_reg_mask32(HDMI_VIDEO_BIT_ERR_DET,
+		~HDMI_VIDEO_BIT_ERR_DET_en_mask, 0, HDMI_RX_MAC);
+	/* Reset cnt */
+	hdmi_rx_reg_mask32(HDMI_VIDEO_BIT_ERR_DET,
+		~HDMI_VIDEO_BIT_ERR_DET_reset_mask, HDMI_VIDEO_BIT_ERR_DET_reset_mask, HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_VIDEO_BIT_ERR_DET,
+		~HDMI_VIDEO_BIT_ERR_DET_mode_mask, HDMI_VIDEO_BIT_ERR_DET_mode(conti_mode), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_VIDEO_BIT_ERR_DET,
+		~HDMI_VIDEO_BIT_ERR_DET_period_mask, HDMI_VIDEO_BIT_ERR_DET_period(period), HDMI_RX_MAC);
+	hdmi_rx_reg_mask32(HDMI_VIDEO_BIT_ERR_DET,
+		~HDMI_VIDEO_BIT_ERR_DET_thd_mask, HDMI_VIDEO_BIT_ERR_DET_thd(1), HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_VIDEO_BIT_ERR_DET,
+		~HDMI_VIDEO_BIT_ERR_DET_reset_mask, 0, HDMI_RX_MAC);
+
+	/* wclr_out */
+	hdmi_rx_reg_mask32(HDMI_VIDEO_BIT_ERR_STATUS_B,
+		~(HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask),
+		(HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask),
+		HDMI_RX_MAC);
+
+	/* wclr_out */
+	hdmi_rx_reg_mask32(HDMI_VIDEO_BIT_ERR_STATUS_G,
+		~(HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask),
+		(HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask),
+		HDMI_RX_MAC);
+
+	/* wclr_out */
+	hdmi_rx_reg_mask32(HDMI_VIDEO_BIT_ERR_STATUS_R,
+		~(HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask),
+		(HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask |
+		HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask),
+		HDMI_RX_MAC);
+
+	hdmi_rx_reg_mask32(HDMI_VIDEO_BIT_ERR_DET,
+		~HDMI_VIDEO_BIT_ERR_DET_en_mask, HDMI_VIDEO_BIT_ERR_DET_en_mask, HDMI_RX_MAC);
+}
+
+unsigned char lib_hdmi_bit_err_det_done(void)
+{
+	unsigned char temp;
+
+	temp = !HDMI_VIDEO_BIT_ERR_DET_get_en(hdmi_rx_reg_read32(HDMI_VIDEO_BIT_ERR_DET, HDMI_RX_MAC));
+	return temp;
+}
+
+unsigned char lib_hdmi_bit_err_get_error(unsigned int *r_err, unsigned int *g_err, unsigned int *b_err)
+{
+	if (HDMI_VIDEO_BIT_ERR_DET_get_en(hdmi_rx_reg_read32(HDMI_VIDEO_BIT_ERR_DET, HDMI_RX_MAC)))
+		return 0;/* Not yet finish counting */
+
+	*r_err = HDMI_VIDEO_BIT_ERR_STATUS_R_get_bit_err_cnt_r(hdmi_rx_reg_read32(HDMI_VIDEO_BIT_ERR_STATUS_R, HDMI_RX_MAC));
+	*g_err = HDMI_VIDEO_BIT_ERR_STATUS_G_get_bit_err_cnt_g(hdmi_rx_reg_read32(HDMI_VIDEO_BIT_ERR_STATUS_G, HDMI_RX_MAC));
+	*b_err = HDMI_VIDEO_BIT_ERR_STATUS_B_get_bit_err_cnt_b(hdmi_rx_reg_read32(HDMI_VIDEO_BIT_ERR_STATUS_B, HDMI_RX_MAC));
+
+	return 1;
+}
+
+
+#if BIST_DFE_SCAN
+/*
+ * Debug Functions
+ */
+void debug_hdmi_dfe_scan(void)
+{
+	signed char dfe_arg;
+	unsigned int bit_r_err, bit_g_err, bit_b_err, ch_r_err, ch_g_err, ch_b_err;
+	unsigned char mode;
+
+	for (dfe_arg = 0; dfe_arg < 0x24; dfe_arg++) {
+		lib_hdmi_dfe_init_tap0((LN_R|LN_G|LN_B), dfe_arg);
+		//lib_hdmi_dfe_init_tap1((LN_R|LN_G|LN_B), dfe_arg);
+		//lib_hdmi_dfe_init_tap2((LN_R|LN_G|LN_B), dfe_arg);
+		HDMI_DELAYUS(100);
+
+		lib_hdmi_bit_err_start(0, 10);
+		lib_hdmi_char_err_start(0, 10);
+
+		while (!lib_hdmi_bit_err_get_error(&bit_r_err, &bit_g_err, &bit_b_err))
+			HDMI_DELAYMS(20);
+
+		while (!lib_hdmi_char_err_get_error(&ch_r_err, &ch_g_err, &ch_b_err))
+			HDMI_DELAYMS(20);
+
+		HDMI_PRINTF("tap0=%02d, [CH](%05d, %05d, %05d); [BIT](%05d, %05d, %05d)\n",
+			dfe_arg, ch_r_err, ch_g_err, ch_b_err, bit_r_err, bit_g_err, bit_b_err);
+	}
+
+	lib_hdmi_dfe_init_tap0(LN_B, phy_st.dfe_t[0].tap0);
+	lib_hdmi_dfe_init_tap0(LN_G, phy_st.dfe_t[1].tap0);
+	lib_hdmi_dfe_init_tap0(LN_R, phy_st.dfe_t[2].tap0);
+
+
+	mode = REG_DFE_MODE_get_adapt_mode(hdmi_rx_reg_read32(REG_DFE_MODE, HDMI_RX_DFE));
+
+
+	if (mode == 2) {
+		for (dfe_arg = 0; dfe_arg < 60; dfe_arg++) {
+			//lib_hdmi_dfe_init_tap0((LN_R|LN_G|LN_B), dfe_arg);
+			//lib_hdmi_dfe_init_tap1((LN_R|LN_G|LN_B), dfe_arg);
+			lib_hdmi_dfe_init_le((LN_R|LN_G|LN_B), dfe_arg);
+			//lib_hdmi_dfe_init_tap2((LN_R|LN_G|LN_B), dfe_arg);
+			HDMI_DELAYUS(100);
+
+			lib_hdmi_bit_err_start(0, 10);
+			lib_hdmi_char_err_start(0, 10);
+
+			while (!lib_hdmi_bit_err_get_error(&bit_r_err, &bit_g_err, &bit_b_err))
+				HDMI_DELAYMS(20);
+
+			while (!lib_hdmi_char_err_get_error(&ch_r_err, &ch_g_err, &ch_b_err))
+				HDMI_DELAYMS(20);
+
+			HDMI_PRINTF("le=%02d, [CH](%05d, %05d, %05d); [BIT](%05d, %05d, %05d)\n",
+				dfe_arg, ch_r_err, ch_g_err, ch_b_err, bit_r_err, bit_g_err, bit_b_err);
+		}
+
+		lib_hdmi_dfe_init_le(LN_B, phy_st.dfe_t[0].le);
+		lib_hdmi_dfe_init_le(LN_G, phy_st.dfe_t[1].le);
+		lib_hdmi_dfe_init_le(LN_R, phy_st.dfe_t[2].le);
+
+	} else {
+		/* mode 3 */
+		for (dfe_arg = 0; dfe_arg < 60; dfe_arg++) {
+			//lib_hdmi_dfe_init_tap0((LN_R|LN_G|LN_B), dfe_arg);
+			lib_hdmi_dfe_init_tap1((LN_R|LN_G|LN_B), dfe_arg);
+			//lib_hdmi_dfe_init_tap2((LN_R|LN_G|LN_B), dfe_arg);
+			HDMI_DELAYUS(100);
+
+			lib_hdmi_bit_err_start(0, 10);
+			lib_hdmi_char_err_start(0, 10);
+
+			while (!lib_hdmi_bit_err_get_error(&bit_r_err, &bit_g_err, &bit_b_err))
+				HDMI_DELAYMS(20);
+
+			while (!lib_hdmi_char_err_get_error(&ch_r_err, &ch_g_err, &ch_b_err))
+				HDMI_DELAYMS(20);
+
+			HDMI_PRINTF("le=%02d, [CH](%05d, %05d, %05d); [BIT](%05d, %05d, %05d)\n",
+				dfe_arg, ch_r_err, ch_g_err, ch_b_err, bit_r_err, bit_g_err, bit_b_err);
+		}
+
+		lib_hdmi_dfe_init_tap1(LN_B, phy_st.dfe_t[0].tap1+phy_st.dfe_t[0].le);
+		lib_hdmi_dfe_init_tap1(LN_G, phy_st.dfe_t[1].tap1+phy_st.dfe_t[1].le);
+		lib_hdmi_dfe_init_tap1(LN_R, phy_st.dfe_t[2].tap1+phy_st.dfe_t[2].le);
+	}
+
+
+	for (dfe_arg = -15; dfe_arg < 15; dfe_arg++) {
+		//lib_hdmi_dfe_init_tap0((LN_R|LN_G|LN_B), dfe_arg);
+		//lib_hdmi_dfe_init_tap1((LN_R|LN_G|LN_B), dfe_arg);
+		lib_hdmi_dfe_init_tap2((LN_R|LN_G|LN_B), dfe_arg);
+		HDMI_DELAYUS(100);
+
+		lib_hdmi_bit_err_start(0, 10);
+		lib_hdmi_char_err_start(0, 10);
+
+		while (!lib_hdmi_bit_err_get_error(&bit_r_err, &bit_g_err, &bit_b_err))
+			HDMI_DELAYMS(20);
+
+		while (!lib_hdmi_char_err_get_error(&ch_r_err, &ch_g_err, &ch_b_err))
+			HDMI_DELAYMS(20);
+
+		HDMI_PRINTF("tap2=%02d, [CH](%05d, %05d, %05d); [BIT](%05d, %05d, %05d)\n",
+			dfe_arg, ch_r_err, ch_g_err, ch_b_err, bit_r_err, bit_g_err, bit_b_err);
+	}
+
+	lib_hdmi_dfe_init_tap2(LN_B, phy_st.dfe_t[0].tap2);
+	lib_hdmi_dfe_init_tap2(LN_G, phy_st.dfe_t[1].tap2);
+	lib_hdmi_dfe_init_tap2(LN_R, phy_st.dfe_t[2].tap2);
+
+}
+#endif
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/v4l2_hdmi_dev.c b/drivers/media/platform/rtk_hdmirx/rtd161x/v4l2_hdmi_dev.c
new file mode 100644
index 00000000..d7074fd
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/v4l2_hdmi_dev.c
@@ -0,0 +1,768 @@
+/*
+ * v4l2_hdmi_dev.c - RTK hdmi rx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/of.h>
+#include <linux/of_gpio.h>
+#include <linux/gpio.h>
+#include <linux/switch.h>
+#include <linux/time.h>
+
+#include "v4l2_hdmi_dev.h"
+#include "hdmirx_video_dev.h"
+#include "hdmirx_wrapper.h"
+#include "mipi_wrapper.h"
+#include "hdmirx_reg.h"
+#include "hdmirx_sysfs.h"
+#include "hdmirx_clk_ctrl.h"
+#include "hdcp2p2_dev.h"
+
+#include "rx_drv/hdmiInternal.h"
+#include "rx_drv/hdmiEDID.h"
+
+#define MAX_WIDTH 4096
+#define MAX_HEIGHT 2160
+
+static struct task_struct *hdmi_hw_tsk;
+/*=================== extern Variable/Function ===================*/
+extern void __iomem *hdmi_rx_base[HDMI_RX_REG_BLOCK_NUM];
+extern MIPI_TOP_INFO mipi_top;
+extern HDMIRX_DTS_EDID_TBL_T hdmirx_edid;
+extern int hdmi_stream_on;
+extern int hdmi_timestamp_mode;// 0:system time, 1:90KHz timer
+
+extern unsigned int rtk_suspend_wakeup_flags_get(void);
+/*======================================================*/
+static inline void update_hdmirx_switch_state(struct v4l2_hdmi_dev *dev);
+
+int hdmirx_queue_init(struct v4l2_hdmi_dev *dev, struct vb2_queue *q, enum v4l2_memory memory)
+{
+	q->type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
+	q->io_modes = VB2_MMAP | VB2_USERPTR | VB2_DMABUF; /* | VB2_READ; */
+	q->drv_priv = dev;
+	q->buf_struct_size = sizeof(struct hdmi_buffer);
+	q->ops = &hdmi_qops;
+	q->timestamp_flags = V4L2_BUF_FLAG_TIMESTAMP_MONOTONIC;
+	q->dev = &dev->vdev.dev;
+
+	if (memory == V4L2_MEMORY_USERPTR) {
+		q->mem_ops = &vb2_vmalloc_memops;
+	} else if (memory == V4L2_MEMORY_DMABUF) {
+		q->mem_ops = &vb2_dma_contig_memops;
+	} else if (memory == V4L2_MEMORY_MMAP) {
+		q->mem_ops = &vb2_dma_contig_memops;
+	} else {
+		HDMIRX_ERROR("[%s] Invalid io mode:%d", __func__, memory);
+		return -EINVAL;
+	}
+
+	return vb2_queue_init(q);
+}
+
+int hdmi_queue_setup(struct vb2_queue *vq,
+				unsigned int *nbuffers, unsigned int *nplanes,
+				unsigned int sizes[], struct device *alloc_devs[])
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+	struct hdmi_dmaqueue *dma_q = &dev->hdmidq;
+	unsigned long size;
+
+	HDMIRX_INFO("[%s] outfmt(%u) width(%u) height(%u)",
+		__func__, dev->outfmt, dev->width, dev->height);
+
+	atomic_set(&dma_q->qcnt, 0);
+	atomic_set(&dma_q->rcnt, 0);
+
+	if (dev->outfmt == OUT_10BIT_YUV420) {
+		size = mipi_top.pitch * roundup16(dev->height);/* y_size */
+		size = size + (size >> 1);/* y_size x 1.5 */
+	} else if (dev->outfmt >= OUT_ARGB) {
+		size = dev->width * dev->height * dev->bpp / 8;
+	} else {
+		size = roundup16(dev->width) * roundup16(dev->height) * dev->bpp / 8;
+	}
+
+	if (size == 0)
+		return -EINVAL;
+
+	if (*nbuffers == 0)
+		*nbuffers = 32;
+
+	*nplanes = 1;
+
+	sizes[0] = size;
+
+	HDMIRX_INFO("[%s] count=%d, size=%ld", __func__, *nbuffers, size);
+	return 0;
+}
+
+int hdmi_buffer_prepare(struct vb2_buffer *vb)
+{
+	struct vb2_queue *vq = vb->vb2_queue;
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+	struct hdmi_buffer *buf = container_of(vb, struct hdmi_buffer, vb);
+	unsigned long size;
+
+	if (dev->width	< 48 || dev->width	> MAX_WIDTH ||
+		dev->height < 32 || dev->height > MAX_HEIGHT)
+		return -EINVAL;
+
+	if (dev->outfmt == OUT_10BIT_YUV420) {
+		size = mipi_top.pitch * roundup16(dev->height);/* y_size */
+		size = size + (size >> 1);/* y_size x 1.5 */
+	} else if (dev->outfmt >= OUT_ARGB) {
+		size = dev->width * dev->height * dev->bpp / 8;
+	} else {
+		size = roundup16(dev->width) * roundup16(dev->height) * dev->bpp / 8;
+	}
+
+	if (vb2_plane_size(vb, 0) < size) {
+		HDMIRX_ERROR("[%s] data will not fit into plane (%lu < %lu)",
+			__func__, vb2_plane_size(vb, 0), size);
+		return -EINVAL;
+	}
+
+	vb2_set_plane_payload(&buf->vb, 0, size);
+
+	if (vq->memory == V4L2_MEMORY_USERPTR) {
+		struct mipi_vb2_vmalloc_buf *vb2_buf;
+		unsigned long pfn;
+
+		vb2_buf = vb->planes[0].mem_priv;
+		follow_pfn(vb2_buf->vma, vb->planes[0].m.userptr, &pfn);
+		buf->phys = __pfn_to_phys(pfn);
+	} else if (vq->memory == V4L2_MEMORY_DMABUF) {
+		buf->phys = vb2_dma_contig_plane_dma_addr(vb, 0);
+	} else if (vq->memory == V4L2_MEMORY_MMAP) {
+		dma_addr_t *addr = vb2_plane_cookie(vb, 0);
+
+		buf->phys = *addr;
+	}
+
+	return 0;
+}
+
+void hdmi_buffer_finish(struct vb2_buffer *vb)
+{
+	if (hdmi_timestamp_mode) {
+		vb->timestamp = lib_hdmi_get_clk90k();
+	} else {
+		/* System timer */
+		vb->timestamp = ktime_get_ns();
+	}
+}
+
+void hdmi_buffer_queue(struct vb2_buffer *vb)
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vb->vb2_queue);
+	struct hdmi_buffer *buf = container_of(vb, struct hdmi_buffer, vb);
+	struct hdmi_dmaqueue *hdmidq = &dev->hdmidq;
+	unsigned long flags = 0;
+
+	spin_lock_irqsave(&dev->slock, flags);
+	list_add_tail(&buf->list, &hdmidq->active);
+	atomic_inc(&hdmidq->qcnt);
+	spin_unlock_irqrestore(&dev->slock, flags);
+
+}
+
+int hdmi_start_streaming(struct vb2_queue *vq, unsigned int count)
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+
+	HDMIRX_INFO("[%s]", __func__);
+
+	register_mipi_ion(dev);
+
+	set_video_DDR_start_addr(dev);
+
+	/* Enable mipi */
+	setup_mipi();
+	hdmi_stream_on = 1;
+
+	return 0;
+}
+
+void hdmi_stop_generating(struct v4l2_hdmi_dev *dev)
+{
+	struct hdmi_dmaqueue *dma_q = &dev->hdmidq;
+
+	HDMIRX_INFO("[%s]", __func__);
+
+	/*
+	 * Typical driver might need to wait here until dma engine stops.
+	 * In this case we can abort imiedetly, so it's just a noop.
+	 */
+
+	/* Release all active buffers */
+	while (!list_empty(&dma_q->active)) {
+		struct hdmi_buffer *buf;
+
+		buf = list_entry(dma_q->active.next, struct hdmi_buffer, list);
+		list_del(&buf->list);
+		vb2_buffer_done(&buf->vb, VB2_BUF_STATE_ERROR);
+		HDMIRX_INFO("Release[%p/%d] done", buf, buf->vb.index);
+	}
+
+	if (dma_q->hwbuf[0] != NULL) {
+		vb2_buffer_done(&dma_q->hwbuf[0]->vb, VB2_BUF_STATE_ERROR);
+		dma_q->hwbuf[0] = NULL;
+		HDMIRX_INFO("Release hwbuf[0] done");
+	}
+
+	if (dma_q->hwbuf[1] != NULL) {
+		vb2_buffer_done(&dma_q->hwbuf[1]->vb, VB2_BUF_STATE_ERROR);
+		dma_q->hwbuf[1] = NULL;
+		HDMIRX_INFO("Release hwbuf[1] done");
+	}
+
+}
+
+void hdmi_stop_streaming(struct vb2_queue *vq)
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+
+	HDMIRX_INFO("[%s]", __func__);
+
+	if (is_clock_enabled(CLK_MIPI) && hdmi_rx.rx_5v_state)
+		stop_mipi_process();
+
+	hdmi_stop_generating(dev);
+
+	deregister_mipi_ion(dev);
+}
+
+void hdmi_unlock(struct vb2_queue *vq)
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+
+	mutex_unlock(&dev->mutex);
+}
+
+void hdmi_lock(struct vb2_queue *vq)
+{
+	struct v4l2_hdmi_dev *dev = vb2_get_drv_priv(vq);
+
+	mutex_lock(&dev->mutex);
+}
+
+void  rx5v_do_task(struct v4l2_hdmi_dev *dev)
+{
+	int state;
+
+	state = gpio_get_value(hdmi_rx.gpio_5v_det);
+
+	if (!state && hdmi_rx.rx_5v_state) {
+		/* RX unplugged */
+		HDMIRX_INFO("Cable Unplugged");
+
+		stop_mipi_process();
+		/* Stop DMA */
+		set_hdmirx_wrapper_control_0(-1, 0, -1, -1, -1, -1);
+		/* Disable wrapper interrupt */
+		set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+		hdmi_release_source();
+		memset(&hdmirx_state, 0, sizeof(hdmirx_state));
+		SET_H_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+		SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		mipi_top.hdmi_rx_init = 0;
+
+		hdmi_rx.rx_5v_state = 0;
+		Hdmi_SetHPD(0);
+
+		/* Delay for RX service turn off audio, prevent AudioFW crash */
+		update_hdmirx_switch_state(dev);
+		usleep_range(280000, 300000);
+
+		/* Stop hdmirx */
+		set_hdmirx_wrapper_control_0(-1, -1, -1, -1, -1, 0);
+		/* Disable RX clock */
+		hdmirx_clock_control(CLK_HDMIRX|CLK_RXWRAP|CLK_MIPI, CTL_DISABLE);
+	} else if (state && !hdmi_rx.rx_5v_state) {
+		/* RX plugged */
+		HDMIRX_INFO("Cable Plugged");
+
+		/* Enable RX clock */
+		hdmirx_clock_control(CLK_HDMIRX|CLK_RXWRAP|CLK_MIPI, CTL_ENABLE);
+		/* Enable hdmirx */
+		set_hdmirx_wrapper_control_0(-1, -1, -1, -1, -1, 1);
+		hdmi_rx.rx_5v_state = 1;
+	}
+}
+
+void hdmi_rx_process(void)
+{
+	unsigned char ret;
+	static int state = 0;
+
+	if (mipi_top.hdmi_rx_init == 0) {
+		hdmi_related_wrapper_init();
+		HdmiRx_EnableEDID();
+		hdmi_init();
+		mipi_top.hdmi_rx_init = 1;
+		state = 0;
+		Hdmi_SetHPD(1);/* set hotplug pin high */
+	}
+
+	switch (state) {
+	case 0:
+		if (hdmirx_state.DEF_ready) {
+			if (hdmi_detect_mode() == _MODE_SUCCESS)
+				state++;
+		}
+		break;
+	case 1:
+		ret = hdmi_check_condition_change();
+		if ((ret == TRUE) && hdmirx_state.detect_done) {
+			HDMIRX_INFO("Condition_change, restart HDMI Rx wrapper detection ret(%d)\n", ret);
+			state = 0;
+			restartHdmiRxWrapperDetection();
+		} else if (hdmirx_state.detect_done == 0) {
+			HDMIRX_INFO("Check mode is fine, but detect_done=0 ret(%d)\n", ret);
+			state = 0;
+		}
+		break;
+	default:
+		state = 0;
+		break;
+	}
+}
+
+static inline void update_hdmirx_switch_state(struct v4l2_hdmi_dev *dev)
+{
+	unsigned char hdcp_state = 0;
+	static unsigned char audio_count = 0;
+
+	if (hdmirx_state.measure_ready != switch_get_state(&dev->sdev)) {
+		switch_set_state(&dev->sdev, hdmirx_state.measure_ready);
+		pr_err("\033[0;31m[HDMI RX] switch hdmi rx state to %d\033[m\n",
+			hdmirx_state.measure_ready);
+	}
+
+
+	if (!hdmirx_state.audio_detect_done)
+		audio_count = 0;
+
+	if (hdmirx_state.audio_detect_done != switch_get_state(&dev->asdev)) {
+		if (hdmirx_state.audio_detect_done)
+			audio_count++;
+
+		if ((!hdmirx_state.audio_detect_done) || (audio_count >= 10)) {
+			switch_set_state(&dev->asdev, hdmirx_state.audio_detect_done);
+			HDMIRX_INFO("switch audio detect state to %d", hdmirx_state.audio_detect_done);
+		}
+	}
+
+	if ((hdmirx_state.hdcp_state == HDCPRX_STATE_1PX_ON) ||
+		(hdmirx_state.hdcp_state == HDCPRX_STATE_2P2_ON))
+		hdcp_state = 1;
+
+	if (hdcp_state != switch_get_state(&dev->hsdev)) {
+		switch_set_state(&dev->hsdev, hdcp_state);
+		HDMIRX_INFO("switch hdcp state to %d", hdcp_state);
+	}
+
+	if (hdmirx_state.hdr_received != switch_get_state(&dev->hdr_sdev)) {
+		switch_set_state(&dev->hdr_sdev, hdmirx_state.hdr_received);
+
+		HDMIRX_INFO("switch hdr detect state to %d",
+			hdmirx_state.hdr_received);
+	}
+}
+
+static int mipi_top_thread(void *arg)
+{
+	unsigned int i;
+	struct v4l2_hdmi_dev *dev = arg;
+
+	for (;;) {
+		if (kthread_should_stop())
+			break;
+
+		rx5v_do_task(dev);
+
+		if (mipi_top.src_sel == 1) {
+			if (hdmi_rx.rx_5v_state) {
+				hdmi_rx_process();
+				for (i = 0; i < 3; i++) {
+					update_hdmirx_switch_state(dev);
+					usleep_range(70000, 75000);/* 70ms~75ms */
+					if (mipi_top.hdmi_rx_init)
+						rxphy_isr();
+				}
+			} else {
+				msleep(250);
+			}
+		}
+
+	}
+	return 0;
+}
+
+
+int hdmirx_rtk_drv_probe(struct platform_device *pdev)
+{
+	int ret, i;
+	u32 irq;
+	struct v4l2_hdmi_dev *hdmi_dev;
+	struct switch_dev *sdev;/* video switch device */
+	struct switch_dev *asdev;/* audio switch device */
+	struct switch_dev *hsdev; /* hdcp switch device */
+	struct switch_dev *hdr_sdev; /* HDR switch device */
+	const u32 *edid_table_pro;
+	int edid_cell_size;
+	HDMIRX_DTS_EDID_TBL_T dts_edid_table;
+
+	/* Get clock controller */
+	hdmirx_clock_init(pdev);
+
+	/* Release reset, enable clock */
+	hdmirx_clock_control(CLK_ALL, CTL_ENABLE);
+
+	/* Disable RX clock for saving power */
+	hdmirx_clock_control(CLK_HDMIRX | CLK_RXWRAP | CLK_MIPI, CTL_DISABLE);
+
+	if (WARN_ON(!(pdev->dev.of_node))) {
+		HDMIRX_ERROR("[%s] No device node", __func__);
+		ret = -ENODEV;
+		goto exit;
+	}
+
+	/* Initialize global variables */
+	memset(&mipi_top, 0, sizeof(mipi_top));
+	memset(&hdmi_rx, 0, sizeof(hdmi_rx));
+	memset(&hdmirx_state, 0, sizeof(hdmirx_state));
+	memset(&hdmirx_edid, 0, sizeof(hdmirx_edid));
+
+	for (i = 0; i < HDMI_RX_REG_BLOCK_NUM; i++) {
+		hdmi_rx_base[i] = of_iomap(pdev->dev.of_node, i);
+		WARN(!(hdmi_rx_base[i]), "Unable to map HDMI RX base registers\n");
+	}
+
+	/* Save EDID table */
+	edid_table_pro = of_get_property(pdev->dev.of_node, "Realtek,edid-table", &edid_cell_size);
+	if (edid_table_pro && (edid_cell_size == 1024)) {
+		edid_cell_size = edid_cell_size / 4;/*Each Read is 4bytes (1world), so divide it by 4*/
+		for (i = 0; i < edid_cell_size; i++)
+			dts_edid_table.EDID[i] = (unsigned char) of_read_number(edid_table_pro, 1 + i);
+
+		HdmiRx_Save_DTS_EDID_Table(&dts_edid_table);
+	} else {
+		HDMIRX_ERROR("[%s] Parsing EDID table content failed", __func__);
+	}
+
+	/* Save HDMI2.0 EDID table */
+	edid_table_pro = of_get_property(pdev->dev.of_node, "Realtek,edid2p0-table", &edid_cell_size);
+	if (edid_table_pro && (edid_cell_size == 1024)) {
+		/*Each Read is 4bytes (1world), so divide it by 4*/
+		edid_cell_size = edid_cell_size / 4;
+		for (i = 0; i < edid_cell_size; i++)
+			dts_edid_table.EDID[i] = (unsigned char) of_read_number(edid_table_pro, 1 + i);
+
+		HdmiRx_Save_DTS_EDID2p0_Table(&dts_edid_table);
+	} else {
+		HDMIRX_ERROR("[%s] Parsing 2.0 EDID table content failed", __func__);
+	}
+
+	/* HPD control GPIO */
+	hdmi_rx.gpio_hpd_ctrl = of_get_named_gpio(pdev->dev.of_node, "gpio-rx-hpd-ctrl", 0);
+	if (hdmi_rx.gpio_hpd_ctrl < 0) {
+		HDMIRX_ERROR("Get gpio-rx-hpd-ctrl fail");
+		ret = -ENODEV;
+		goto exit;
+	} else {
+		HDMIRX_INFO("HPD control gpio(%d)", hdmi_rx.gpio_hpd_ctrl);
+		if (gpio_request(hdmi_rx.gpio_hpd_ctrl, pdev->dev.of_node->name))
+			HDMIRX_ERROR("Request gpio %d fail", hdmi_rx.gpio_hpd_ctrl);
+	}
+	gpio_direction_output(hdmi_rx.gpio_hpd_ctrl, 1);/* HPD OFF */
+
+	/* 5V detect GPIO */
+	hdmi_rx.gpio_5v_det = of_get_named_gpio(pdev->dev.of_node, "gpio-5v-detect", 0);
+	if (hdmi_rx.gpio_5v_det < 0) {
+		HDMIRX_ERROR("Get gpio-5v-detect fail");
+		ret = -ENODEV;
+		goto exit;
+	} else {
+		HDMIRX_INFO("5V detect gpio(%d)", hdmi_rx.gpio_5v_det);
+		if (gpio_request(hdmi_rx.gpio_5v_det, pdev->dev.of_node->name))
+			HDMIRX_ERROR("Request gpio %d fail", hdmi_rx.gpio_5v_det);
+
+		gpio_direction_input(hdmi_rx.gpio_5v_det);
+	}
+
+	/* Register v4l2 device */
+	hdmi_dev = kzalloc(sizeof(*hdmi_dev), GFP_KERNEL);
+	if (!hdmi_dev) {
+		HDMIRX_ERROR("[%s] kzalloc fail", __func__);
+		ret = -ENOMEM;
+		goto exit;
+	}
+	snprintf(hdmi_dev->v4l2_dev.name, sizeof(hdmi_dev->v4l2_dev.name), "v4l2_mipi_top");
+	ret = v4l2_device_register(NULL, &hdmi_dev->v4l2_dev);
+	if (ret < 0) {
+		HDMIRX_ERROR("[%s] Register v4l2 device fail", __func__);
+		goto free_dev;
+	}
+	if (ret)
+		goto free_dev;
+
+	pdev->dev.platform_data = hdmi_dev;
+
+	/* Set default value */
+	hdmi_dev->width = 1920;
+	hdmi_dev->height = 1080;
+	hdmi_dev->bpp = 12;/* OUT_YUV420 */
+
+	mipi_top.src_sel = 1;
+
+	/* Initialize locks */
+	spin_lock_init(&hdmi_dev->slock);
+	mutex_init(&hdmi_dev->mutex);
+
+	/* Init video dma queues */
+	INIT_LIST_HEAD(&hdmi_dev->hdmidq.active);
+
+	if (register_video_device(hdmi_dev) < 0) {
+		HDMIRX_ERROR("[%s] Register video device fail", __func__);
+		goto free_dev;
+	}
+
+	/* Register interrupt handle */
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	WARN(!(irq), "[HDMI RX] irq map fail\n");
+	if (request_irq(irq, hdmirx_mipi_isr, IRQF_SHARED, "mipi", hdmi_dev))
+		HDMIRX_ERROR("Cannot register IRQ %d", irq);
+	else
+		HDMIRX_INFO("mipi irq(%d)", irq);
+
+	/* Register switch device */
+	sdev = &hdmi_dev->sdev;
+	memset(sdev, 0, sizeof(*sdev));
+	sdev->name = "rx_video";
+	ret = switch_dev_register(sdev);
+	if (ret < 0)
+		goto unreg_vdev;
+	switch_set_state(&hdmi_dev->sdev, 0);
+
+	/* Register audio switch device */
+	asdev = &hdmi_dev->asdev;
+	memset(asdev, 0, sizeof(*asdev));
+	asdev->name = "rx_audio";
+	ret = switch_dev_register(asdev);
+	if (ret < 0)
+		goto unreg_vdev;
+	switch_set_state(&hdmi_dev->asdev, 0);
+
+	/* Register hdcp switch device */
+	hsdev = &hdmi_dev->hsdev;
+	hsdev->name = "rx_hdcp";
+	ret = switch_dev_register(hsdev);
+	if (ret < 0)
+		goto unreg_vdev;
+	switch_set_state(&hdmi_dev->hsdev, 0);
+
+	/* Register hdr switch device */
+	hdr_sdev = &hdmi_dev->hdr_sdev;
+	hdr_sdev->name = "rx_hdr";
+	ret = switch_dev_register(hdr_sdev);
+	if (ret < 0)
+		goto unreg_vdev;
+	switch_set_state(&hdmi_dev->hdr_sdev, 0);
+
+	/* Register sysfs */
+	register_hdmirx_sysfs(pdev);
+
+#ifdef CONFIG_RTK_HDCPRX_2P2
+	register_hdcp2p2_device();
+#endif
+
+	/* Init reset MIPI clock work function */
+	INIT_WORK(&mipi_top.mipi_reset_work, mipi_reset_work_func);
+
+	/* HDMI RX thread */
+	hdmi_hw_tsk = kthread_create(mipi_top_thread, hdmi_dev, "mipi_hw_thread");
+	if (IS_ERR(hdmi_hw_tsk)) {
+		ret = PTR_ERR(hdmi_hw_tsk);
+		hdmi_hw_tsk = NULL;
+		goto unreg_vdev;
+	}
+	wake_up_process(hdmi_hw_tsk);
+
+	return 0;
+
+unreg_vdev:
+	video_unregister_device(&hdmi_dev->vdev);
+free_dev:
+	kfree(hdmi_dev);
+exit:
+	return ret;
+}
+
+int hdmirx_rtk_drv_remove(struct platform_device *pdev)
+{
+	struct fb_info *info = platform_get_drvdata(pdev);
+
+	HDMIRX_INFO("driver remove\n");
+	if (info) {
+		unregister_framebuffer(info);
+		framebuffer_release(info);
+	}
+	return 0;
+}
+
+#ifdef CONFIG_SUSPEND
+static int hdmirx_rtk_drv_suspend(struct device *dev)
+{
+	struct platform_device *pdev;
+	struct v4l2_hdmi_dev *hdmi_dev;
+
+	HDMIRX_INFO(" Enter %s", __func__);
+
+	kthread_stop(hdmi_hw_tsk);
+
+	/* Switch rx state to 0 */
+	pdev = to_platform_device(dev);
+	hdmi_dev = pdev->dev.platform_data;
+	if (switch_get_state(&hdmi_dev->sdev)) {
+		pr_err("\033[0;31m[HDMI RX] switch hdmi rx state to %d\033[m\n", 0);
+		switch_set_state(&hdmi_dev->sdev, 0);
+	}
+
+	if (hdmi_rx.rx_5v_state) {
+		stop_mipi_process();
+		/* Stop DMA */
+		set_hdmirx_wrapper_control_0(-1, 0, -1, -1, -1, -1);
+		/* Disable wrapper interrupt */
+		set_hdmirx_wrapper_interrupt_en(0, 0, 0);
+		hdmi_release_source();
+		memset(&hdmirx_state, 0, sizeof(hdmirx_state));
+		SET_H_VIDEO_FSM(MAIN_FSM_HDMI_SETUP_VEDIO_PLL);
+		SET_H_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
+		mipi_top.hdmi_rx_init = 0;
+		hdmi_rx.rx_5v_state = 0;
+
+		/* Stop hdmirx */
+		set_hdmirx_wrapper_control_0(-1, -1, -1, -1, -1, 0);
+		/* Disable  RX clock */
+		hdmirx_clock_control(CLK_HDMIRX | CLK_RXWRAP | CLK_MIPI, CTL_DISABLE);
+	}
+
+	Hdmi_SetHPD(0);
+#if 0 // TODO: Need to fix
+	if (rtk_suspend_wakeup_flags_get()&(0x1U << 5))
+		HDMIRX_INFO("CEC wakeup is enabled, skip turn off cbus clock");
+	else
+		hdmirx_clock_control(CLK_CBUS, CTL_DISABLE);/* Disable  Cbus clock */
+#else
+	hdmirx_clock_control(CLK_CBUS, CTL_DISABLE);/* Disable  Cbus clock */
+#endif
+
+	HDMIRX_INFO(" Exit %s", __func__);
+	return 0;
+}
+
+static int hdmirx_rtk_drv_resume(struct device *dev)
+{
+	struct platform_device *pdev;
+	struct v4l2_hdmi_dev *hdmi_dev;
+
+	HDMIRX_INFO("Enter %s", __func__);
+
+	pdev = to_platform_device(dev);
+	hdmi_dev = pdev->dev.platform_data;
+
+	/* Release reset, enable clock */
+#if 0// TODO: Need to fix
+	if (rtk_suspend_wakeup_flags_get()&(0x1U << 5)) {
+		hdmirx_clock_control(CLK_HDMIRX | CLK_RXWRAP | CLK_MIPI, CTL_ENABLE);
+		HDMIRX_INFO("CEC wakeup is enabled, only turn on hdmirx clock");
+	} else {
+		hdmirx_clock_control(CLK_ALL, CTL_ENABLE);
+	}
+#else
+	hdmirx_clock_control(CLK_ALL, CTL_ENABLE);
+#endif
+
+	Hdmi_SetHPD(0);
+
+	/* Disable RX clock for saving power */
+	hdmirx_clock_control(CLK_HDMIRX | CLK_RXWRAP | CLK_MIPI, CTL_DISABLE);
+
+	hdmi_hw_tsk = kthread_run(mipi_top_thread, hdmi_dev, "mipi_hw_thread");
+
+	HDMIRX_INFO("Exit %s", __func__);
+	return 0;
+}
+
+static int hdmirx_rtk_runtime_suspend(struct device *dev)
+{
+	HDMIRX_DEBUG("Enter %s", __func__);
+
+	HDMIRX_DEBUG("Exit %s", __func__);
+	return 0;
+}
+
+static int hdmirx_rtk_runtime_resume(struct device *dev)
+{
+	HDMIRX_DEBUG("Enter %s", __func__);
+
+	HDMIRX_DEBUG("Exit %s", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_hdmirx_pm_ops = {
+	.suspend    = hdmirx_rtk_drv_suspend,
+	.resume     = hdmirx_rtk_drv_resume,
+	.runtime_suspend = hdmirx_rtk_runtime_suspend,
+	.runtime_resume  = hdmirx_rtk_runtime_resume,
+};
+#endif /* CONFIG_SUSPEND */
+
+static const struct of_device_id hdmirx_rtk_dt_ids[] = {
+	{ .compatible = "realtek,rtd161x-hdmirx", },
+	{},
+};
+
+struct platform_driver hdmirx_rtk_driver = {
+	.probe  = hdmirx_rtk_drv_probe,
+	.remove = hdmirx_rtk_drv_remove,
+	.driver = {
+		.name   = "rtk-mipi-top",
+		.owner  = THIS_MODULE,
+		.of_match_table = of_match_ptr(hdmirx_rtk_dt_ids),
+#ifdef CONFIG_SUSPEND
+		.pm = &rtk_hdmirx_pm_ops,
+#endif /* CONFIG_SUSPEND */
+	},
+};
+
+static int __init hdmirx_init(void)
+{
+	int retval = 0;
+
+	HDMIRX_INFO("driver init");
+	retval = platform_driver_register(&hdmirx_rtk_driver);
+	HDMIRX_INFO("driver init done");
+
+	return retval;
+}
+
+static void __exit hdmi_exit(void)
+{
+	HDMIRX_INFO("driver exit");
+	// TODO:
+	platform_driver_unregister(&hdmirx_rtk_driver);
+}
+
+module_init(hdmirx_init);
+module_exit(hdmi_exit);
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Realtek HDMI RX kernel module");
diff --git a/drivers/media/platform/rtk_hdmirx/rtd161x/v4l2_hdmi_dev.h b/drivers/media/platform/rtk_hdmirx/rtd161x/v4l2_hdmi_dev.h
new file mode 100755
index 00000000..e7c01fc9
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmirx/rtd161x/v4l2_hdmi_dev.h
@@ -0,0 +1,159 @@
+/*
+ * v4l2_hdmi_dev.h - RTK hdmi rx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef V4L2_HDMI_DEV_H
+#define V4L2_HDMI_DEV_H
+
+#include <linux/module.h>
+#include <linux/errno.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/font.h>
+#include <linux/mutex.h>
+#include <linux/videodev2.h>
+#include <linux/kthread.h>
+#include <linux/freezer.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/interrupt.h>
+#include <linux/of.h>
+#include <linux/platform_device.h>
+#include <linux/dma-contiguous.h>
+#include <linux/device.h>
+#include <linux/fb.h>
+#include <linux/switch.h>
+
+#include <media/videobuf2-vmalloc.h>
+#include <media/videobuf2-dma-contig.h>
+#include <media/videobuf2-core.h>
+#include <media/v4l2-device.h>
+#include <media/v4l2-ioctl.h>
+#include <media/v4l2-ctrls.h>
+#include <media/v4l2-fh.h>
+#include <media/v4l2-event.h>
+#include <media/v4l2-common.h>
+#include <media/videobuf2-memops.h>
+
+#include <asm/page.h>
+#include <asm/memory.h>
+
+#include "ion/ion.h"
+#include "uapi/ion.h"
+#include "uapi/ion_rtk.h"
+
+
+#define __RTK_HDMI_RX_DEBUG__	0
+
+#if __RTK_HDMI_RX_DEBUG__
+#define HDMIRX_DEBUG(format, ...) pr_err("[HDMI RX DBG]" format "\n", ## __VA_ARGS__)
+#else
+#define HDMIRX_DEBUG(format, ...)
+#endif
+
+#define HDMIRX_ERROR(format, ...) printk(KERN_ERR "[HDMI RX ERR]" format "\n", ## __VA_ARGS__)
+#define HDMIRX_INFO(format, ...) printk(KERN_WARNING "[HDMI RX]" format "\n", ## __VA_ARGS__)
+
+
+#define roundup16(x)	roundup(x, 16)
+
+
+/* buffer for one video frame */
+struct hdmi_buffer {
+	/* common vb2_v4l2_buffer stuff -- must be first */
+	struct vb2_buffer vb;
+	__u32 flags;
+	__u32 field;
+	struct v4l2_timecode timecode;
+	__u32 sequence;
+	/* Private data */
+	u32		phys;
+	struct list_head	list;
+};
+
+struct hdmi_dmaqueue {
+	atomic_t			rcnt;/* Number of buffers already processed by hw */
+	atomic_t			qcnt;/* Number of buffers waiting for hw process */
+	struct list_head	active;
+	struct hdmi_buffer	*hwbuf[2];
+	unsigned char skip_frame[2];
+};
+
+struct mipi_ion_buf {
+	struct ion_client *client;
+	struct ion_handle *handle;
+	ion_phys_addr_t phys_addr;
+};
+
+struct v4l2_hdmi_dev {
+	struct v4l2_device		v4l2_dev;
+	struct video_device		vdev;
+	struct switch_dev		sdev;/* Video switch device */
+	struct switch_dev		asdev;/* Audio switch device */
+	struct switch_dev		hsdev;/* HDCP switch device */
+	struct switch_dev		hdr_sdev;/* HDR switch device */
+
+	spinlock_t		slock;
+	struct mutex	mutex; /* Protects queue */
+
+	struct hdmi_dmaqueue	   hdmidq;
+
+	/* video capture */
+	unsigned int		   width;
+	unsigned int		   height;
+	unsigned int		   outfmt;
+	unsigned int		   bpp;
+	struct vb2_queue	   vb_hdmidq;
+
+	struct mipi_ion_buf ion_buf;
+};
+
+int hdmi_queue_setup(struct vb2_queue *vq,
+		unsigned int *nbuffers, unsigned int *nplanes,
+		unsigned int sizes[], struct device *alloc_devs[]);
+int hdmi_buffer_prepare(struct vb2_buffer *vb);
+void hdmi_buffer_finish(struct vb2_buffer *vb);
+void hdmi_buffer_queue(struct vb2_buffer *vb);
+int hdmi_start_streaming(struct vb2_queue *vq, unsigned int count);
+void hdmi_stop_streaming(struct vb2_queue *vq);
+void hdmi_unlock(struct vb2_queue *vq);
+void hdmi_lock(struct vb2_queue *vq);
+
+static const struct vb2_ops hdmi_qops = {
+	.queue_setup     = hdmi_queue_setup,
+	.buf_prepare     = hdmi_buffer_prepare,
+	.buf_finish      = hdmi_buffer_finish,
+	.buf_queue       = hdmi_buffer_queue,
+	.start_streaming = hdmi_start_streaming,
+	.stop_streaming  = hdmi_stop_streaming,
+	.wait_prepare    = hdmi_unlock,
+	.wait_finish     = hdmi_lock,
+};
+
+struct mipi_vb2_vmalloc_buf {
+	void *vaddr;
+	struct page **pages;
+	struct vm_area_struct *vma;
+	int write;
+	u32 size;
+	unsigned int n_pages;
+	atomic_t refcount;
+	struct vb2_vmarea_handler handler;
+	struct dma_buf *dbuf;
+};
+
+int hdmirx_queue_init(struct v4l2_hdmi_dev *dev, struct vb2_queue *q, enum v4l2_memory memory);
+int hdmirx_rtk_drv_probe(struct platform_device *pdev);
+int hdmirx_rtk_drv_remove(struct platform_device *pdev);
+
+#endif/* V4L2_HDMI_DEV_H */
+
diff --git a/drivers/media/platform/rtk_hdmitx/Kconfig b/drivers/media/platform/rtk_hdmitx/Kconfig
new file mode 100644
index 00000000..5da225f
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/Kconfig
@@ -0,0 +1,11 @@
+#Copyright (C) 2017 Realtek Semiconductor Corporation
+
+config RTK_HDMITX
+	tristate "HDMITX for Realtek RTD1295 platform"
+	select I2C
+	select SWITCH
+    select RTK_RPC
+	default n
+	help
+	  Say Y, if you want to enable HDMITX feature on Realtek RTD1295 platform.
+
diff --git a/drivers/media/platform/rtk_hdmitx/Makefile b/drivers/media/platform/rtk_hdmitx/Makefile
new file mode 100755
index 00000000..d46f8fd
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/Makefile
@@ -0,0 +1,13 @@
+#
+# Makefile for HDMITX linux kernel module.
+#
+ccflags-y += -I$(srctree)/drivers/video/fbdev/rtk
+ccflags-y += -I$(srctree)/drivers/staging/android
+
+hdmitx-$(CONFIG_RTK_HDMITX):= hdmitx_core.o switch_hdmitx.o hdmitx_api.o rtk_edid.o compat_hdmitx.o hdmitx_info.o \
+	hdmitx_scdc.o rtk_edid_filter.o rtk_mute_gpio.o
+
+hdmitx-$(CONFIG_RTK_HDMITX) += hdmitx_config.o
+
+obj-$(CONFIG_RTK_HDMITX)+= hdmitx.o
+
diff --git a/drivers/media/platform/rtk_hdmitx/compat_hdmitx.c b/drivers/media/platform/rtk_hdmitx/compat_hdmitx.c
new file mode 100644
index 00000000..43be677
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/compat_hdmitx.c
@@ -0,0 +1,268 @@
+/*
+ * compat_hdmitx.c - RTK hdmitx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/uaccess.h>
+#include <linux/kernel.h>
+#include <linux/types.h>
+#include <linux/compat.h>
+#include <linux/fs.h>
+
+#include "compat_hdmitx.h"
+
+#if defined(CONFIG_CPU_V7)
+/**
+ * compat_hdmitx_ioctl - ioctl function of hdmitx miscdev
+ * @file: hdmitx miscdev to be registered
+ * @cmd: control command
+ * @arg: arguments
+ *
+ * Return: 0 on success, -E* on failure
+ */
+long compat_hdmitx_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	long ret_value = -EFAULT;
+
+	if (!file->f_op->unlocked_ioctl) {
+		ret_value = -ENOTTY;
+		goto exit;
+	}
+
+	switch (cmd) {
+	case HDMI_GET_SINK_CAPABILITY:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_GET_RAW_EDID:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_CHECK_LINK_STATUS:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_GET_VIDEO_CONFIG:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_SEND_AVMUTE:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_CONFIG_TV_SYSTEM:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_CONFIG_AVI_INFO:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_SET_FREQUNCY:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_SEND_AUDIO_MUTE:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_SEND_AUDIO_VSDB_DATA:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_SEND_AUDIO_EDID2:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_CHECK_TMDS_SRC:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_CHECK_Rx_Sense:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_GET_EXT_BLK_COUNT:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_GET_EXTENDED_EDID:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_QUERY_DISPLAY_STANDARD:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_SEND_VOUT_EDID_DATA:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_GET_EDID_SUPPORT_LIST:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_SET_OUTPUT_FORMAT:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_GET_OUTPUT_FORMAT:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+	case HDMI_SET_VO_INTERFACE_TYPE:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	case HDMI_GET_CONFIG_TV_SYSTEM:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd, arg);
+		break;
+
+	default:
+		ret_value = -EFAULT;
+	}
+
+exit:
+	return ret_value;
+}
+#else
+/**
+ * compat_hdmitx_ioctl - ioctl function of hdmitx miscdev
+ * @file: hdmitx miscdev to be registered
+ * @cmd: control command
+ * @arg: arguments
+ *
+ * Return: 0 on success, -E* on failure
+ */
+long compat_hdmitx_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	long ret_value = -EFAULT;
+
+	if (!file->f_op->unlocked_ioctl) {
+		ret_value = -ENOTTY;
+		goto exit;
+	}
+
+	switch (cmd) {
+	case HDMI_GET_SINK_CAPABILITY:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_GET_RAW_EDID:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_CHECK_LINK_STATUS:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_GET_VIDEO_CONFIG:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_SEND_AVMUTE:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_CONFIG_TV_SYSTEM:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_CONFIG_AVI_INFO:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_SET_FREQUNCY:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_SEND_AUDIO_MUTE:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_SEND_AUDIO_VSDB_DATA:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_SEND_AUDIO_EDID2:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_CHECK_TMDS_SRC:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_CHECK_Rx_Sense:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_GET_EXT_BLK_COUNT:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_GET_EXTENDED_EDID:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_QUERY_DISPLAY_STANDARD:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_SEND_VOUT_EDID_DATA:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_GET_EDID_SUPPORT_LIST:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_SET_OUTPUT_FORMAT:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+
+	case HDMI_GET_OUTPUT_FORMAT:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+	case HDMI_SET_VO_INTERFACE_TYPE:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+	case HDMI_GET_CONFIG_TV_SYSTEM:
+		ret_value = file->f_op->unlocked_ioctl(file, cmd,
+						(unsigned long)compat_ptr(arg));
+		break;
+	default:
+		ret_value = -EFAULT;
+	}
+
+exit:
+	return ret_value;
+}
+#endif /* CONFIG_CPU_V7 */
+
diff --git a/drivers/media/platform/rtk_hdmitx/compat_hdmitx.h b/drivers/media/platform/rtk_hdmitx/compat_hdmitx.h
new file mode 100644
index 00000000..559d98f
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/compat_hdmitx.h
@@ -0,0 +1,22 @@
+/*
+ * compat_hdmitx.h - RTK hdmitx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _LINUX_COMPAT_HDMITX_H
+#define _LINUX_COMPAT_HDMITX_H
+
+#include "hdmitx.h"
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+long compat_hdmitx_ioctl(struct file *file, unsigned int cmd, unsigned long arg);
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_HDMITX_H */
diff --git a/drivers/media/platform/rtk_hdmitx/crt_reg.h b/drivers/media/platform/rtk_hdmitx/crt_reg.h
new file mode 100644
index 00000000..ec43529
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/crt_reg.h
@@ -0,0 +1,7141 @@
+/*
+ * crt_reg.h - RTK hdmitx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _SYS_REG_H_INCLUDED_
+#define _SYS_REG_H_INCLUDED_
+
+#define SYS_SOFT_RESET1                                                              0x000
+#define SYS_SOFT_RESET1_reg_addr                                                     "0x98000000"
+#define SYS_SOFT_RESET1_reg                                                          0x98000000
+#define set_SYS_SOFT_RESET1_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET1_reg)=data)
+#define get_SYS_SOFT_RESET1_reg   (*((volatile unsigned int*) SYS_SOFT_RESET1_reg))
+#define SYS_SOFT_RESET1_inst_adr                                                     "0x0000"
+#define SYS_SOFT_RESET1_inst                                                         0x0000
+#define SYS_SOFT_RESET1_rstn_rsa_shift                                               (31)
+#define SYS_SOFT_RESET1_rstn_rsa_mask                                                (0x80000000)
+#define SYS_SOFT_RESET1_rstn_rsa(data)                                               (0x80000000&((data)<<31))
+#define SYS_SOFT_RESET1_rstn_rsa_src(data)                                           ((0x80000000&(data))>>31)
+#define SYS_SOFT_RESET1_get_rstn_rsa(data)                                           ((0x80000000&(data))>>31)
+#define SYS_SOFT_RESET1_rstn_mipi_shift                                              (30)
+#define SYS_SOFT_RESET1_rstn_mipi_mask                                               (0x40000000)
+#define SYS_SOFT_RESET1_rstn_mipi(data)                                              (0x40000000&((data)<<30))
+#define SYS_SOFT_RESET1_rstn_mipi_src(data)                                          ((0x40000000&(data))>>30)
+#define SYS_SOFT_RESET1_get_rstn_mipi(data)                                          ((0x40000000&(data))>>30)
+#define SYS_SOFT_RESET1_rstn_nf_shift                                                (29)
+#define SYS_SOFT_RESET1_rstn_nf_mask                                                 (0x20000000)
+#define SYS_SOFT_RESET1_rstn_nf(data)                                                (0x20000000&((data)<<29))
+#define SYS_SOFT_RESET1_rstn_nf_src(data)                                            ((0x20000000&(data))>>29)
+#define SYS_SOFT_RESET1_get_rstn_nf(data)                                            ((0x20000000&(data))>>29)
+#define SYS_SOFT_RESET1_rstn_ae_shift                                                (28)
+#define SYS_SOFT_RESET1_rstn_ae_mask                                                 (0x10000000)
+#define SYS_SOFT_RESET1_rstn_ae(data)                                                (0x10000000&((data)<<28))
+#define SYS_SOFT_RESET1_rstn_ae_src(data)                                            ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET1_get_rstn_ae(data)                                            ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET1_rstn_tp_shift                                                (27)
+#define SYS_SOFT_RESET1_rstn_tp_mask                                                 (0x08000000)
+#define SYS_SOFT_RESET1_rstn_tp(data)                                                (0x08000000&((data)<<27))
+#define SYS_SOFT_RESET1_rstn_tp_src(data)                                            ((0x08000000&(data))>>27)
+#define SYS_SOFT_RESET1_get_rstn_tp(data)                                            ((0x08000000&(data))>>27)
+#define SYS_SOFT_RESET1_rstn_md_shift                                                (26)
+#define SYS_SOFT_RESET1_rstn_md_mask                                                 (0x04000000)
+#define SYS_SOFT_RESET1_rstn_md(data)                                                (0x04000000&((data)<<26))
+#define SYS_SOFT_RESET1_rstn_md_src(data)                                            ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET1_get_rstn_md(data)                                            ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET1_rstn_cp_shift                                                (25)
+#define SYS_SOFT_RESET1_rstn_cp_mask                                                 (0x02000000)
+#define SYS_SOFT_RESET1_rstn_cp(data)                                                (0x02000000&((data)<<25))
+#define SYS_SOFT_RESET1_rstn_cp_src(data)                                            ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET1_get_rstn_cp(data)                                            ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET1_rstn_dc_phy_shift                                            (24)
+#define SYS_SOFT_RESET1_rstn_dc_phy_mask                                             (0x01000000)
+#define SYS_SOFT_RESET1_rstn_dc_phy(data)                                            (0x01000000&((data)<<24))
+#define SYS_SOFT_RESET1_rstn_dc_phy_src(data)                                        ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET1_get_rstn_dc_phy(data)                                        ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET1_rstn_dcu_shift                                               (23)
+#define SYS_SOFT_RESET1_rstn_dcu_mask                                                (0x00800000)
+#define SYS_SOFT_RESET1_rstn_dcu(data)                                               (0x00800000&((data)<<23))
+#define SYS_SOFT_RESET1_rstn_dcu_src(data)                                           ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET1_get_rstn_dcu(data)                                           ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET1_rstn_se_shift                                                (22)
+#define SYS_SOFT_RESET1_rstn_se_mask                                                 (0x00400000)
+#define SYS_SOFT_RESET1_rstn_se(data)                                                (0x00400000&((data)<<22))
+#define SYS_SOFT_RESET1_rstn_se_src(data)                                            ((0x00400000&(data))>>22)
+#define SYS_SOFT_RESET1_get_rstn_se(data)                                            ((0x00400000&(data))>>22)
+#define SYS_SOFT_RESET1_rstn_lvds_shift                                              (21)
+#define SYS_SOFT_RESET1_rstn_lvds_mask                                               (0x00200000)
+#define SYS_SOFT_RESET1_rstn_lvds(data)                                              (0x00200000&((data)<<21))
+#define SYS_SOFT_RESET1_rstn_lvds_src(data)                                          ((0x00200000&(data))>>21)
+#define SYS_SOFT_RESET1_get_rstn_lvds(data)                                          ((0x00200000&(data))>>21)
+#define SYS_SOFT_RESET1_rstn_vo_shift                                                (20)
+#define SYS_SOFT_RESET1_rstn_vo_mask                                                 (0x00100000)
+#define SYS_SOFT_RESET1_rstn_vo(data)                                                (0x00100000&((data)<<20))
+#define SYS_SOFT_RESET1_rstn_vo_src(data)                                            ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET1_get_rstn_vo(data)                                            ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET1_rstn_tve_shift                                               (19)
+#define SYS_SOFT_RESET1_rstn_tve_mask                                                (0x00080000)
+#define SYS_SOFT_RESET1_rstn_tve(data)                                               (0x00080000&((data)<<19))
+#define SYS_SOFT_RESET1_rstn_tve_src(data)                                           ((0x00080000&(data))>>19)
+#define SYS_SOFT_RESET1_get_rstn_tve(data)                                           ((0x00080000&(data))>>19)
+#define SYS_SOFT_RESET1_rstn_gpu_shift                                               (18)
+#define SYS_SOFT_RESET1_rstn_gpu_mask                                                (0x00040000)
+#define SYS_SOFT_RESET1_rstn_gpu(data)                                               (0x00040000&((data)<<18))
+#define SYS_SOFT_RESET1_rstn_gpu_src(data)                                           ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET1_get_rstn_gpu(data)                                           ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET1_rstn_aio_shift                                               (17)
+#define SYS_SOFT_RESET1_rstn_aio_mask                                                (0x00020000)
+#define SYS_SOFT_RESET1_rstn_aio(data)                                               (0x00020000&((data)<<17))
+#define SYS_SOFT_RESET1_rstn_aio_src(data)                                           ((0x00020000&(data))>>17)
+#define SYS_SOFT_RESET1_get_rstn_aio(data)                                           ((0x00020000&(data))>>17)
+#define SYS_SOFT_RESET1_rstn_etn_shift                                               (16)
+#define SYS_SOFT_RESET1_rstn_etn_mask                                                (0x00010000)
+#define SYS_SOFT_RESET1_rstn_etn(data)                                               (0x00010000&((data)<<16))
+#define SYS_SOFT_RESET1_rstn_etn_src(data)                                           ((0x00010000&(data))>>16)
+#define SYS_SOFT_RESET1_get_rstn_etn(data)                                           ((0x00010000&(data))>>16)
+#define SYS_SOFT_RESET1_rstn_ve3_shift                                               (15)
+#define SYS_SOFT_RESET1_rstn_ve3_mask                                                (0x00008000)
+#define SYS_SOFT_RESET1_rstn_ve3(data)                                               (0x00008000&((data)<<15))
+#define SYS_SOFT_RESET1_rstn_ve3_src(data)                                           ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET1_get_rstn_ve3(data)                                           ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET1_rstn_ve2_shift                                               (14)
+#define SYS_SOFT_RESET1_rstn_ve2_mask                                                (0x00004000)
+#define SYS_SOFT_RESET1_rstn_ve2(data)                                               (0x00004000&((data)<<14))
+#define SYS_SOFT_RESET1_rstn_ve2_src(data)                                           ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET1_get_rstn_ve2(data)                                           ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET1_rstn_ve1_shift                                               (13)
+#define SYS_SOFT_RESET1_rstn_ve1_mask                                                (0x00002000)
+#define SYS_SOFT_RESET1_rstn_ve1(data)                                               (0x00002000&((data)<<13))
+#define SYS_SOFT_RESET1_rstn_ve1_src(data)                                           ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET1_get_rstn_ve1(data)                                           ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET1_rstn_hdmi_shift                                              (12)
+#define SYS_SOFT_RESET1_rstn_hdmi_mask                                               (0x00001000)
+#define SYS_SOFT_RESET1_rstn_hdmi(data)                                              (0x00001000&((data)<<12))
+#define SYS_SOFT_RESET1_rstn_hdmi_src(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET1_get_rstn_hdmi(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET1_sata_func_exist_0_shift                                      (11)
+#define SYS_SOFT_RESET1_sata_func_exist_0_mask                                       (0x00000800)
+#define SYS_SOFT_RESET1_sata_func_exist_0(data)                                      (0x00000800&((data)<<11))
+#define SYS_SOFT_RESET1_sata_func_exist_0_src(data)                                  ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET1_get_sata_func_exist_0(data)                                  ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET1_rstn_sata_phy_pow_0_shift                                    (10)
+#define SYS_SOFT_RESET1_rstn_sata_phy_pow_0_mask                                     (0x00000400)
+#define SYS_SOFT_RESET1_rstn_sata_phy_pow_0(data)                                    (0x00000400&((data)<<10))
+#define SYS_SOFT_RESET1_rstn_sata_phy_pow_0_src(data)                                ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET1_get_rstn_sata_phy_pow_0(data)                                ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET1_rstn_usb_phy1_shift                                          (9)
+#define SYS_SOFT_RESET1_rstn_usb_phy1_mask                                           (0x00000200)
+#define SYS_SOFT_RESET1_rstn_usb_phy1(data)                                          (0x00000200&((data)<<9))
+#define SYS_SOFT_RESET1_rstn_usb_phy1_src(data)                                      ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET1_get_rstn_usb_phy1(data)                                      ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET1_rstn_usb_phy0_shift                                          (8)
+#define SYS_SOFT_RESET1_rstn_usb_phy0_mask                                           (0x00000100)
+#define SYS_SOFT_RESET1_rstn_usb_phy0(data)                                          (0x00000100&((data)<<8))
+#define SYS_SOFT_RESET1_rstn_usb_phy0_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET1_get_rstn_usb_phy0(data)                                      ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET1_rstn_sata_phy_0_shift                                        (7)
+#define SYS_SOFT_RESET1_rstn_sata_phy_0_mask                                         (0x00000080)
+#define SYS_SOFT_RESET1_rstn_sata_phy_0(data)                                        (0x00000080&((data)<<7))
+#define SYS_SOFT_RESET1_rstn_sata_phy_0_src(data)                                    ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET1_get_rstn_sata_phy_0(data)                                    ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET1_rstn_usb_shift                                               (6)
+#define SYS_SOFT_RESET1_rstn_usb_mask                                                (0x00000040)
+#define SYS_SOFT_RESET1_rstn_usb(data)                                               (0x00000040&((data)<<6))
+#define SYS_SOFT_RESET1_rstn_usb_src(data)                                           ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET1_get_rstn_usb(data)                                           ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET1_rstn_sata_0_shift                                            (5)
+#define SYS_SOFT_RESET1_rstn_sata_0_mask                                             (0x00000020)
+#define SYS_SOFT_RESET1_rstn_sata_0(data)                                            (0x00000020&((data)<<5))
+#define SYS_SOFT_RESET1_rstn_sata_0_src(data)                                        ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET1_get_rstn_sata_0(data)                                        ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio_shift                                      (4)
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio_mask                                       (0x00000010)
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio(data)                                      (0x00000010&((data)<<4))
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio_src(data)                                  ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET1_get_rstn_usb3_p0_mdio(data)                                  ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET1_rstn_gspi_shift                                              (3)
+#define SYS_SOFT_RESET1_rstn_gspi_mask                                               (0x00000008)
+#define SYS_SOFT_RESET1_rstn_gspi(data)                                              (0x00000008&((data)<<3))
+#define SYS_SOFT_RESET1_rstn_gspi_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET1_get_rstn_gspi(data)                                          ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET1_rstn_usb3_phy0_pow_shift                                     (2)
+#define SYS_SOFT_RESET1_rstn_usb3_phy0_pow_mask                                      (0x00000004)
+#define SYS_SOFT_RESET1_rstn_usb3_phy0_pow(data)                                     (0x00000004&((data)<<2))
+#define SYS_SOFT_RESET1_rstn_usb3_phy0_pow_src(data)                                 ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET1_get_rstn_usb3_phy0_pow(data)                                 ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET1_rstn_nat_shift                                               (1)
+#define SYS_SOFT_RESET1_rstn_nat_mask                                                (0x00000002)
+#define SYS_SOFT_RESET1_rstn_nat(data)                                               (0x00000002&((data)<<1))
+#define SYS_SOFT_RESET1_rstn_nat_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET1_get_rstn_nat(data)                                           ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET1_rstn_misc_shift                                              (0)
+#define SYS_SOFT_RESET1_rstn_misc_mask                                               (0x00000001)
+#define SYS_SOFT_RESET1_rstn_misc(data)                                              (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET1_rstn_misc_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET1_get_rstn_misc(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_SOFT_RESET2                                                              0x004
+#define SYS_SOFT_RESET2_reg_addr                                                     "0x98000004"
+#define SYS_SOFT_RESET2_reg                                                          0x98000004
+#define set_SYS_SOFT_RESET2_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET2_reg)=data)
+#define get_SYS_SOFT_RESET2_reg   (*((volatile unsigned int*) SYS_SOFT_RESET2_reg))
+#define SYS_SOFT_RESET2_inst_adr                                                     "0x0001"
+#define SYS_SOFT_RESET2_inst                                                         0x0001
+#define SYS_SOFT_RESET2_rstn_sds_phy_shift                                           (31)
+#define SYS_SOFT_RESET2_rstn_sds_phy_mask                                            (0x80000000)
+#define SYS_SOFT_RESET2_rstn_sds_phy(data)                                           (0x80000000&((data)<<31))
+#define SYS_SOFT_RESET2_rstn_sds_phy_src(data)                                       ((0x80000000&(data))>>31)
+#define SYS_SOFT_RESET2_get_rstn_sds_phy(data)                                       ((0x80000000&(data))>>31)
+#define SYS_SOFT_RESET2_rstn_cbus_tx_shift                                           (30)
+#define SYS_SOFT_RESET2_rstn_cbus_tx_mask                                            (0x40000000)
+#define SYS_SOFT_RESET2_rstn_cbus_tx(data)                                           (0x40000000&((data)<<30))
+#define SYS_SOFT_RESET2_rstn_cbus_tx_src(data)                                       ((0x40000000&(data))>>30)
+#define SYS_SOFT_RESET2_get_rstn_cbus_tx(data)                                       ((0x40000000&(data))>>30)
+#define SYS_SOFT_RESET2_rstn_misc_sc_shift                                           (29)
+#define SYS_SOFT_RESET2_rstn_misc_sc_mask                                            (0x20000000)
+#define SYS_SOFT_RESET2_rstn_misc_sc(data)                                           (0x20000000&((data)<<29))
+#define SYS_SOFT_RESET2_rstn_misc_sc_src(data)                                       ((0x20000000&(data))>>29)
+#define SYS_SOFT_RESET2_get_rstn_misc_sc(data)                                       ((0x20000000&(data))>>29)
+#define SYS_SOFT_RESET2_rstn_ur1_shift                                               (28)
+#define SYS_SOFT_RESET2_rstn_ur1_mask                                                (0x10000000)
+#define SYS_SOFT_RESET2_rstn_ur1(data)                                               (0x10000000&((data)<<28))
+#define SYS_SOFT_RESET2_rstn_ur1_src(data)                                           ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET2_get_rstn_ur1(data)                                           ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET2_rstn_ur2_shift                                               (27)
+#define SYS_SOFT_RESET2_rstn_ur2_mask                                                (0x08000000)
+#define SYS_SOFT_RESET2_rstn_ur2(data)                                               (0x08000000&((data)<<27))
+#define SYS_SOFT_RESET2_rstn_ur2_src(data)                                           ((0x08000000&(data))>>27)
+#define SYS_SOFT_RESET2_get_rstn_ur2(data)                                           ((0x08000000&(data))>>27)
+#define SYS_SOFT_RESET2_rstn_i2c_1_shift                                             (26)
+#define SYS_SOFT_RESET2_rstn_i2c_1_mask                                              (0x04000000)
+#define SYS_SOFT_RESET2_rstn_i2c_1(data)                                             (0x04000000&((data)<<26))
+#define SYS_SOFT_RESET2_rstn_i2c_1_src(data)                                         ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET2_get_rstn_i2c_1(data)                                         ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET2_rstn_i2c_2_shift                                             (25)
+#define SYS_SOFT_RESET2_rstn_i2c_2_mask                                              (0x02000000)
+#define SYS_SOFT_RESET2_rstn_i2c_2(data)                                             (0x02000000&((data)<<25))
+#define SYS_SOFT_RESET2_rstn_i2c_2_src(data)                                         ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET2_get_rstn_i2c_2(data)                                         ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET2_rstn_i2c_3_shift                                             (24)
+#define SYS_SOFT_RESET2_rstn_i2c_3_mask                                              (0x01000000)
+#define SYS_SOFT_RESET2_rstn_i2c_3(data)                                             (0x01000000&((data)<<24))
+#define SYS_SOFT_RESET2_rstn_i2c_3_src(data)                                         ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET2_get_rstn_i2c_3(data)                                         ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET2_rstn_i2c_4_shift                                             (23)
+#define SYS_SOFT_RESET2_rstn_i2c_4_mask                                              (0x00800000)
+#define SYS_SOFT_RESET2_rstn_i2c_4(data)                                             (0x00800000&((data)<<23))
+#define SYS_SOFT_RESET2_rstn_i2c_4_src(data)                                         ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET2_get_rstn_i2c_4(data)                                         ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET2_rstn_pcie1_nonstich_shift                                    (22)
+#define SYS_SOFT_RESET2_rstn_pcie1_nonstich_mask                                     (0x00400000)
+#define SYS_SOFT_RESET2_rstn_pcie1_nonstich(data)                                    (0x00400000&((data)<<22))
+#define SYS_SOFT_RESET2_rstn_pcie1_nonstich_src(data)                                ((0x00400000&(data))>>22)
+#define SYS_SOFT_RESET2_get_rstn_pcie1_nonstich(data)                                ((0x00400000&(data))>>22)
+#define SYS_SOFT_RESET2_rstn_pcie1_power_shift                                       (21)
+#define SYS_SOFT_RESET2_rstn_pcie1_power_mask                                        (0x00200000)
+#define SYS_SOFT_RESET2_rstn_pcie1_power(data)                                       (0x00200000&((data)<<21))
+#define SYS_SOFT_RESET2_rstn_pcie1_power_src(data)                                   ((0x00200000&(data))>>21)
+#define SYS_SOFT_RESET2_get_rstn_pcie1_power(data)                                   ((0x00200000&(data))>>21)
+#define SYS_SOFT_RESET2_rstn_pcie1_core_shift                                        (20)
+#define SYS_SOFT_RESET2_rstn_pcie1_core_mask                                         (0x00100000)
+#define SYS_SOFT_RESET2_rstn_pcie1_core(data)                                        (0x00100000&((data)<<20))
+#define SYS_SOFT_RESET2_rstn_pcie1_core_src(data)                                    ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET2_get_rstn_pcie1_core(data)                                    ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET2_rstn_pcie1_stitch_shift                                      (19)
+#define SYS_SOFT_RESET2_rstn_pcie1_stitch_mask                                       (0x00080000)
+#define SYS_SOFT_RESET2_rstn_pcie1_stitch(data)                                      (0x00080000&((data)<<19))
+#define SYS_SOFT_RESET2_rstn_pcie1_stitch_src(data)                                  ((0x00080000&(data))>>19)
+#define SYS_SOFT_RESET2_get_rstn_pcie1_stitch(data)                                  ((0x00080000&(data))>>19)
+#define SYS_SOFT_RESET2_rstn_i2c_5_shift                                             (18)
+#define SYS_SOFT_RESET2_rstn_i2c_5_mask                                              (0x00040000)
+#define SYS_SOFT_RESET2_rstn_i2c_5(data)                                             (0x00040000&((data)<<18))
+#define SYS_SOFT_RESET2_rstn_i2c_5_src(data)                                         ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET2_get_rstn_i2c_5(data)                                         ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET2_rstn_pcie1_shift                                             (17)
+#define SYS_SOFT_RESET2_rstn_pcie1_mask                                              (0x00020000)
+#define SYS_SOFT_RESET2_rstn_pcie1(data)                                             (0x00020000&((data)<<17))
+#define SYS_SOFT_RESET2_rstn_pcie1_src(data)                                         ((0x00020000&(data))>>17)
+#define SYS_SOFT_RESET2_get_rstn_pcie1(data)                                         ((0x00020000&(data))>>17)
+#define SYS_SOFT_RESET2_rstn_pcie1_phy_shift                                         (16)
+#define SYS_SOFT_RESET2_rstn_pcie1_phy_mask                                          (0x00010000)
+#define SYS_SOFT_RESET2_rstn_pcie1_phy(data)                                         (0x00010000&((data)<<16))
+#define SYS_SOFT_RESET2_rstn_pcie1_phy_src(data)                                     ((0x00010000&(data))>>16)
+#define SYS_SOFT_RESET2_get_rstn_pcie1_phy(data)                                     ((0x00010000&(data))>>16)
+#define SYS_SOFT_RESET2_rstn_pcie0_nonstich_shift                                    (15)
+#define SYS_SOFT_RESET2_rstn_pcie0_nonstich_mask                                     (0x00008000)
+#define SYS_SOFT_RESET2_rstn_pcie0_nonstich(data)                                    (0x00008000&((data)<<15))
+#define SYS_SOFT_RESET2_rstn_pcie0_nonstich_src(data)                                ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET2_get_rstn_pcie0_nonstich(data)                                ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET2_rstn_pcie0_power_shift                                       (14)
+#define SYS_SOFT_RESET2_rstn_pcie0_power_mask                                        (0x00004000)
+#define SYS_SOFT_RESET2_rstn_pcie0_power(data)                                       (0x00004000&((data)<<14))
+#define SYS_SOFT_RESET2_rstn_pcie0_power_src(data)                                   ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET2_get_rstn_pcie0_power(data)                                   ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET2_rstn_pcie0_core_shift                                        (13)
+#define SYS_SOFT_RESET2_rstn_pcie0_core_mask                                         (0x00002000)
+#define SYS_SOFT_RESET2_rstn_pcie0_core(data)                                        (0x00002000&((data)<<13))
+#define SYS_SOFT_RESET2_rstn_pcie0_core_src(data)                                    ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET2_get_rstn_pcie0_core(data)                                    ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET2_rstn_sdio_shift                                              (12)
+#define SYS_SOFT_RESET2_rstn_sdio_mask                                               (0x00001000)
+#define SYS_SOFT_RESET2_rstn_sdio(data)                                              (0x00001000&((data)<<12))
+#define SYS_SOFT_RESET2_rstn_sdio_src(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET2_get_rstn_sdio(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET2_rstn_emmc_shift                                              (11)
+#define SYS_SOFT_RESET2_rstn_emmc_mask                                               (0x00000800)
+#define SYS_SOFT_RESET2_rstn_emmc(data)                                              (0x00000800&((data)<<11))
+#define SYS_SOFT_RESET2_rstn_emmc_src(data)                                          ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET2_get_rstn_emmc(data)                                          ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET2_rstn_cr_shift                                                (10)
+#define SYS_SOFT_RESET2_rstn_cr_mask                                                 (0x00000400)
+#define SYS_SOFT_RESET2_rstn_cr(data)                                                (0x00000400&((data)<<10))
+#define SYS_SOFT_RESET2_rstn_cr_src(data)                                            ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET2_get_rstn_cr(data)                                            ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET2_rstn_pcr_cnt_shift                                           (9)
+#define SYS_SOFT_RESET2_rstn_pcr_cnt_mask                                            (0x00000200)
+#define SYS_SOFT_RESET2_rstn_pcr_cnt(data)                                           (0x00000200&((data)<<9))
+#define SYS_SOFT_RESET2_rstn_pcr_cnt_src(data)                                       ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET2_get_rstn_pcr_cnt(data)                                       ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET2_rstn_pcie0_shift                                             (8)
+#define SYS_SOFT_RESET2_rstn_pcie0_mask                                              (0x00000100)
+#define SYS_SOFT_RESET2_rstn_pcie0(data)                                             (0x00000100&((data)<<8))
+#define SYS_SOFT_RESET2_rstn_pcie0_src(data)                                         ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET2_get_rstn_pcie0(data)                                         ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET2_rstn_pcie0_phy_shift                                         (7)
+#define SYS_SOFT_RESET2_rstn_pcie0_phy_mask                                          (0x00000080)
+#define SYS_SOFT_RESET2_rstn_pcie0_phy(data)                                         (0x00000080&((data)<<7))
+#define SYS_SOFT_RESET2_rstn_pcie0_phy_src(data)                                     ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET2_get_rstn_pcie0_phy(data)                                     ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET2_rstn_pcie0_stitch_shift                                      (6)
+#define SYS_SOFT_RESET2_rstn_pcie0_stitch_mask                                       (0x00000040)
+#define SYS_SOFT_RESET2_rstn_pcie0_stitch(data)                                      (0x00000040&((data)<<6))
+#define SYS_SOFT_RESET2_rstn_pcie0_stitch_src(data)                                  ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET2_get_rstn_pcie0_stitch(data)                                  ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET2_rstn_usb3_p1_mdio_shift                                      (5)
+#define SYS_SOFT_RESET2_rstn_usb3_p1_mdio_mask                                       (0x00000020)
+#define SYS_SOFT_RESET2_rstn_usb3_p1_mdio(data)                                      (0x00000020&((data)<<5))
+#define SYS_SOFT_RESET2_rstn_usb3_p1_mdio_src(data)                                  ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET2_get_rstn_usb3_p1_mdio(data)                                  ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET2_rstn_usb3_phy1_pow_shift                                     (4)
+#define SYS_SOFT_RESET2_rstn_usb3_phy1_pow_mask                                      (0x00000010)
+#define SYS_SOFT_RESET2_rstn_usb3_phy1_pow(data)                                     (0x00000010&((data)<<4))
+#define SYS_SOFT_RESET2_rstn_usb3_phy1_pow_src(data)                                 ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET2_get_rstn_usb3_phy1_pow(data)                                 ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET2_rstn_usb_phy2_shift                                          (3)
+#define SYS_SOFT_RESET2_rstn_usb_phy2_mask                                           (0x00000008)
+#define SYS_SOFT_RESET2_rstn_usb_phy2(data)                                          (0x00000008&((data)<<3))
+#define SYS_SOFT_RESET2_rstn_usb_phy2_src(data)                                      ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET2_get_rstn_usb_phy2(data)                                      ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET2_rstn_usb_phy3_shift                                          (2)
+#define SYS_SOFT_RESET2_rstn_usb_phy3_mask                                           (0x00000004)
+#define SYS_SOFT_RESET2_rstn_usb_phy3(data)                                          (0x00000004&((data)<<2))
+#define SYS_SOFT_RESET2_rstn_usb_phy3_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET2_get_rstn_usb_phy3(data)                                      ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET2_rstn_jpeg_shift                                              (1)
+#define SYS_SOFT_RESET2_rstn_jpeg_mask                                               (0x00000002)
+#define SYS_SOFT_RESET2_rstn_jpeg(data)                                              (0x00000002&((data)<<1))
+#define SYS_SOFT_RESET2_rstn_jpeg_src(data)                                          ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET2_get_rstn_jpeg(data)                                          ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET2_rstn_acpu_shift                                              (0)
+#define SYS_SOFT_RESET2_rstn_acpu_mask                                               (0x00000001)
+#define SYS_SOFT_RESET2_rstn_acpu(data)                                              (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET2_rstn_acpu_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET2_get_rstn_acpu(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_SOFT_RESET3                                                              0x008
+#define SYS_SOFT_RESET3_reg_addr                                                     "0x98000008"
+#define SYS_SOFT_RESET3_reg                                                          0x98000008
+#define set_SYS_SOFT_RESET3_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET3_reg)=data)
+#define get_SYS_SOFT_RESET3_reg   (*((volatile unsigned int*) SYS_SOFT_RESET3_reg))
+#define SYS_SOFT_RESET3_inst_adr                                                     "0x0002"
+#define SYS_SOFT_RESET3_inst                                                         0x0002
+#define SYS_SOFT_RESET3_rstn_sb2_shift                                               (0)
+#define SYS_SOFT_RESET3_rstn_sb2_mask                                                (0x00000001)
+#define SYS_SOFT_RESET3_rstn_sb2(data)                                               (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET3_rstn_sb2_src(data)                                           ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET3_get_rstn_sb2(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SYS_CLOCK_ENABLE1                                                            0x00C
+#define SYS_CLOCK_ENABLE1_reg_addr                                                   "0x9800000C"
+#define SYS_CLOCK_ENABLE1_reg                                                        0x9800000C
+#define set_SYS_CLOCK_ENABLE1_reg(data)   (*((volatile unsigned int*) SYS_CLOCK_ENABLE1_reg)=data)
+#define get_SYS_CLOCK_ENABLE1_reg   (*((volatile unsigned int*) SYS_CLOCK_ENABLE1_reg))
+#define SYS_CLOCK_ENABLE1_inst_adr                                                   "0x0003"
+#define SYS_CLOCK_ENABLE1_inst                                                       0x0003
+#define SYS_CLOCK_ENABLE1_clk_en_sd_ip_shift                                         (31)
+#define SYS_CLOCK_ENABLE1_clk_en_sd_ip_mask                                          (0x80000000)
+#define SYS_CLOCK_ENABLE1_clk_en_sd_ip(data)                                         (0x80000000&((data)<<31))
+#define SYS_CLOCK_ENABLE1_clk_en_sd_ip_src(data)                                     ((0x80000000&(data))>>31)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sd_ip(data)                                     ((0x80000000&(data))>>31)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_shift                                          (30)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_mask                                           (0x40000000)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio(data)                                          (0x40000000&((data)<<30))
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_src(data)                                      ((0x40000000&(data))>>30)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sdio(data)                                      ((0x40000000&(data))>>30)
+#define SYS_CLOCK_ENABLE1_clk_en_ve3_shift                                           (29)
+#define SYS_CLOCK_ENABLE1_clk_en_ve3_mask                                            (0x20000000)
+#define SYS_CLOCK_ENABLE1_clk_en_ve3(data)                                           (0x20000000&((data)<<29))
+#define SYS_CLOCK_ENABLE1_clk_en_ve3_src(data)                                       ((0x20000000&(data))>>29)
+#define SYS_CLOCK_ENABLE1_get_clk_en_ve3(data)                                       ((0x20000000&(data))>>29)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_ip_shift                                       (28)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_ip_mask                                        (0x10000000)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_ip(data)                                       (0x10000000&((data)<<28))
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_ip_src(data)                                   ((0x10000000&(data))>>28)
+#define SYS_CLOCK_ENABLE1_get_clk_en_emmc_ip(data)                                   ((0x10000000&(data))>>28)
+#define SYS_CLOCK_ENABLE1_clk_en_mipi_shift                                          (27)
+#define SYS_CLOCK_ENABLE1_clk_en_mipi_mask                                           (0x08000000)
+#define SYS_CLOCK_ENABLE1_clk_en_mipi(data)                                          (0x08000000&((data)<<27))
+#define SYS_CLOCK_ENABLE1_clk_en_mipi_src(data)                                      ((0x08000000&(data))>>27)
+#define SYS_CLOCK_ENABLE1_get_clk_en_mipi(data)                                      ((0x08000000&(data))>>27)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_ip_shift                                       (26)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_ip_mask                                        (0x04000000)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_ip(data)                                       (0x04000000&((data)<<26))
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_ip_src(data)                                   ((0x04000000&(data))>>26)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sdio_ip(data)                                   ((0x04000000&(data))>>26)
+#define SYS_CLOCK_ENABLE1_clk_en_cr_shift                                            (25)
+#define SYS_CLOCK_ENABLE1_clk_en_cr_mask                                             (0x02000000)
+#define SYS_CLOCK_ENABLE1_clk_en_cr(data)                                            (0x02000000&((data)<<25))
+#define SYS_CLOCK_ENABLE1_clk_en_cr_src(data)                                        ((0x02000000&(data))>>25)
+#define SYS_CLOCK_ENABLE1_get_clk_en_cr(data)                                        ((0x02000000&(data))>>25)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_shift                                          (24)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_mask                                           (0x01000000)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc(data)                                          (0x01000000&((data)<<24))
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_src(data)                                      ((0x01000000&(data))>>24)
+#define SYS_CLOCK_ENABLE1_get_clk_en_emmc(data)                                      ((0x01000000&(data))>>24)
+#define SYS_CLOCK_ENABLE1_clk_en_nf_shift                                            (23)
+#define SYS_CLOCK_ENABLE1_clk_en_nf_mask                                             (0x00800000)
+#define SYS_CLOCK_ENABLE1_clk_en_nf(data)                                            (0x00800000&((data)<<23))
+#define SYS_CLOCK_ENABLE1_clk_en_nf_src(data)                                        ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE1_get_clk_en_nf(data)                                        ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE1_clk_en_rsa_shift                                           (22)
+#define SYS_CLOCK_ENABLE1_clk_en_rsa_mask                                            (0x00400000)
+#define SYS_CLOCK_ENABLE1_clk_en_rsa(data)                                           (0x00400000&((data)<<22))
+#define SYS_CLOCK_ENABLE1_clk_en_rsa_src(data)                                       ((0x00400000&(data))>>22)
+#define SYS_CLOCK_ENABLE1_get_clk_en_rsa(data)                                       ((0x00400000&(data))>>22)
+#define SYS_CLOCK_ENABLE1_clk_en_tp_shift                                            (21)
+#define SYS_CLOCK_ENABLE1_clk_en_tp_mask                                             (0x00200000)
+#define SYS_CLOCK_ENABLE1_clk_en_tp(data)                                            (0x00200000&((data)<<21))
+#define SYS_CLOCK_ENABLE1_clk_en_tp_src(data)                                        ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE1_get_clk_en_tp(data)                                        ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE1_clk_en_md_shift                                            (20)
+#define SYS_CLOCK_ENABLE1_clk_en_md_mask                                             (0x00100000)
+#define SYS_CLOCK_ENABLE1_clk_en_md(data)                                            (0x00100000&((data)<<20))
+#define SYS_CLOCK_ENABLE1_clk_en_md_src(data)                                        ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE1_get_clk_en_md(data)                                        ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE1_clk_en_cp_shift                                            (19)
+#define SYS_CLOCK_ENABLE1_clk_en_cp_mask                                             (0x00080000)
+#define SYS_CLOCK_ENABLE1_clk_en_cp(data)                                            (0x00080000&((data)<<19))
+#define SYS_CLOCK_ENABLE1_clk_en_cp_src(data)                                        ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE1_get_clk_en_cp(data)                                        ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE1_clk_en_dcu_shift                                           (18)
+#define SYS_CLOCK_ENABLE1_clk_en_dcu_mask                                            (0x00040000)
+#define SYS_CLOCK_ENABLE1_clk_en_dcu(data)                                           (0x00040000&((data)<<18))
+#define SYS_CLOCK_ENABLE1_clk_en_dcu_src(data)                                       ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE1_get_clk_en_dcu(data)                                       ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE1_clk_en_se_shift                                            (17)
+#define SYS_CLOCK_ENABLE1_clk_en_se_mask                                             (0x00020000)
+#define SYS_CLOCK_ENABLE1_clk_en_se(data)                                            (0x00020000&((data)<<17))
+#define SYS_CLOCK_ENABLE1_clk_en_se_src(data)                                        ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE1_get_clk_en_se(data)                                        ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE1_clk_en_lvds_shift                                          (16)
+#define SYS_CLOCK_ENABLE1_clk_en_lvds_mask                                           (0x00010000)
+#define SYS_CLOCK_ENABLE1_clk_en_lvds(data)                                          (0x00010000&((data)<<16))
+#define SYS_CLOCK_ENABLE1_clk_en_lvds_src(data)                                      ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE1_get_clk_en_lvds(data)                                      ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE1_clk_en_vo_shift                                            (15)
+#define SYS_CLOCK_ENABLE1_clk_en_vo_mask                                             (0x00008000)
+#define SYS_CLOCK_ENABLE1_clk_en_vo(data)                                            (0x00008000&((data)<<15))
+#define SYS_CLOCK_ENABLE1_clk_en_vo_src(data)                                        ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE1_get_clk_en_vo(data)                                        ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE1_clk_en_tve_shift                                           (14)
+#define SYS_CLOCK_ENABLE1_clk_en_tve_mask                                            (0x00004000)
+#define SYS_CLOCK_ENABLE1_clk_en_tve(data)                                           (0x00004000&((data)<<14))
+#define SYS_CLOCK_ENABLE1_clk_en_tve_src(data)                                       ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE1_get_clk_en_tve(data)                                       ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE1_clk_en_ve2_shift                                           (13)
+#define SYS_CLOCK_ENABLE1_clk_en_ve2_mask                                            (0x00002000)
+#define SYS_CLOCK_ENABLE1_clk_en_ve2(data)                                           (0x00002000&((data)<<13))
+#define SYS_CLOCK_ENABLE1_clk_en_ve2_src(data)                                       ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE1_get_clk_en_ve2(data)                                       ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE1_clk_en_ve1_shift                                           (12)
+#define SYS_CLOCK_ENABLE1_clk_en_ve1_mask                                            (0x00001000)
+#define SYS_CLOCK_ENABLE1_clk_en_ve1(data)                                           (0x00001000&((data)<<12))
+#define SYS_CLOCK_ENABLE1_clk_en_ve1_src(data)                                       ((0x00001000&(data))>>12)
+#define SYS_CLOCK_ENABLE1_get_clk_en_ve1(data)                                       ((0x00001000&(data))>>12)
+#define SYS_CLOCK_ENABLE1_clk_en_gpu_shift                                           (11)
+#define SYS_CLOCK_ENABLE1_clk_en_gpu_mask                                            (0x00000800)
+#define SYS_CLOCK_ENABLE1_clk_en_gpu(data)                                           (0x00000800&((data)<<11))
+#define SYS_CLOCK_ENABLE1_clk_en_gpu_src(data)                                       ((0x00000800&(data))>>11)
+#define SYS_CLOCK_ENABLE1_get_clk_en_gpu(data)                                       ((0x00000800&(data))>>11)
+#define SYS_CLOCK_ENABLE1_clk_en_aio_shift                                           (10)
+#define SYS_CLOCK_ENABLE1_clk_en_aio_mask                                            (0x00000400)
+#define SYS_CLOCK_ENABLE1_clk_en_aio(data)                                           (0x00000400&((data)<<10))
+#define SYS_CLOCK_ENABLE1_clk_en_aio_src(data)                                       ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE1_get_clk_en_aio(data)                                       ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE1_clk_en_etn_shift                                           (9)
+#define SYS_CLOCK_ENABLE1_clk_en_etn_mask                                            (0x00000200)
+#define SYS_CLOCK_ENABLE1_clk_en_etn(data)                                           (0x00000200&((data)<<9))
+#define SYS_CLOCK_ENABLE1_clk_en_etn_src(data)                                       ((0x00000200&(data))>>9)
+#define SYS_CLOCK_ENABLE1_get_clk_en_etn(data)                                       ((0x00000200&(data))>>9)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi_shift                                          (8)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi_mask                                           (0x00000100)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi(data)                                          (0x00000100&((data)<<8))
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_CLOCK_ENABLE1_get_clk_en_hdmi(data)                                      ((0x00000100&(data))>>8)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_alive_0_shift                                  (7)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_alive_0_mask                                   (0x00000080)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_alive_0(data)                                  (0x00000080&((data)<<7))
+#define SYS_CLOCK_ENABLE1_clk_en_sata_alive_0_src(data)                              ((0x00000080&(data))>>7)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sata_alive_0(data)                              ((0x00000080&(data))>>7)
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc_shift                                      (6)
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc_mask                                       (0x00000040)
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc(data)                                      (0x00000040&((data)<<6))
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc_src(data)                                  ((0x00000040&(data))>>6)
+#define SYS_CLOCK_ENABLE1_get_clk_en_iso_misc(data)                                  ((0x00000040&(data))>>6)
+#define SYS_CLOCK_ENABLE1_clk_en_pcr_shift                                           (5)
+#define SYS_CLOCK_ENABLE1_clk_en_pcr_mask                                            (0x00000020)
+#define SYS_CLOCK_ENABLE1_clk_en_pcr(data)                                           (0x00000020&((data)<<5))
+#define SYS_CLOCK_ENABLE1_clk_en_pcr_src(data)                                       ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE1_get_clk_en_pcr(data)                                       ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE1_clk_en_usb_shift                                           (4)
+#define SYS_CLOCK_ENABLE1_clk_en_usb_mask                                            (0x00000010)
+#define SYS_CLOCK_ENABLE1_clk_en_usb(data)                                           (0x00000010&((data)<<4))
+#define SYS_CLOCK_ENABLE1_clk_en_usb_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE1_get_clk_en_usb(data)                                       ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE1_clk_en_gspi_shift                                          (3)
+#define SYS_CLOCK_ENABLE1_clk_en_gspi_mask                                           (0x00000008)
+#define SYS_CLOCK_ENABLE1_clk_en_gspi(data)                                          (0x00000008&((data)<<3))
+#define SYS_CLOCK_ENABLE1_clk_en_gspi_src(data)                                      ((0x00000008&(data))>>3)
+#define SYS_CLOCK_ENABLE1_get_clk_en_gspi(data)                                      ((0x00000008&(data))>>3)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_0_shift                                        (2)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_0_mask                                         (0x00000004)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_0(data)                                        (0x00000004&((data)<<2))
+#define SYS_CLOCK_ENABLE1_clk_en_sata_0_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sata_0(data)                                    ((0x00000004&(data))>>2)
+#define SYS_CLOCK_ENABLE1_clk_en_pcie0_shift                                         (1)
+#define SYS_CLOCK_ENABLE1_clk_en_pcie0_mask                                          (0x00000002)
+#define SYS_CLOCK_ENABLE1_clk_en_pcie0(data)                                         (0x00000002&((data)<<1))
+#define SYS_CLOCK_ENABLE1_clk_en_pcie0_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE1_get_clk_en_pcie0(data)                                     ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE1_clk_en_misc_shift                                          (0)
+#define SYS_CLOCK_ENABLE1_clk_en_misc_mask                                           (0x00000001)
+#define SYS_CLOCK_ENABLE1_clk_en_misc(data)                                          (0x00000001&((data)<<0))
+#define SYS_CLOCK_ENABLE1_clk_en_misc_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_CLOCK_ENABLE1_get_clk_en_misc(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_CLOCK_ENABLE2                                                            0x010
+#define SYS_CLOCK_ENABLE2_reg_addr                                                   "0x98000010"
+#define SYS_CLOCK_ENABLE2_reg                                                        0x98000010
+#define set_SYS_CLOCK_ENABLE2_reg(data)   (*((volatile unsigned int*) SYS_CLOCK_ENABLE2_reg)=data)
+#define get_SYS_CLOCK_ENABLE2_reg   (*((volatile unsigned int*) SYS_CLOCK_ENABLE2_reg))
+#define SYS_CLOCK_ENABLE2_inst_adr                                                   "0x0004"
+#define SYS_CLOCK_ENABLE2_inst                                                       0x0004
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_1_shift                                       (31)
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_1_mask                                        (0x80000000)
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_1(data)                                       (0x80000000&((data)<<31))
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_1_src(data)                                   ((0x80000000&(data))>>31)
+#define SYS_CLOCK_ENABLE2_get_clk_en_dcphy_1(data)                                   ((0x80000000&(data))>>31)
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_0_shift                                       (30)
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_0_mask                                        (0x40000000)
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_0(data)                                       (0x40000000&((data)<<30))
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_0_src(data)                                   ((0x40000000&(data))>>30)
+#define SYS_CLOCK_ENABLE2_get_clk_en_dcphy_0(data)                                   ((0x40000000&(data))>>30)
+#define SYS_CLOCK_ENABLE2_clk_en_fan_shift                                           (29)
+#define SYS_CLOCK_ENABLE2_clk_en_fan_mask                                            (0x20000000)
+#define SYS_CLOCK_ENABLE2_clk_en_fan(data)                                           (0x20000000&((data)<<29))
+#define SYS_CLOCK_ENABLE2_clk_en_fan_src(data)                                       ((0x20000000&(data))>>29)
+#define SYS_CLOCK_ENABLE2_get_clk_en_fan(data)                                       ((0x20000000&(data))>>29)
+#define SYS_CLOCK_ENABLE2_clk_en_ur1_shift                                           (28)
+#define SYS_CLOCK_ENABLE2_clk_en_ur1_mask                                            (0x10000000)
+#define SYS_CLOCK_ENABLE2_clk_en_ur1(data)                                           (0x10000000&((data)<<28))
+#define SYS_CLOCK_ENABLE2_clk_en_ur1_src(data)                                       ((0x10000000&(data))>>28)
+#define SYS_CLOCK_ENABLE2_get_clk_en_ur1(data)                                       ((0x10000000&(data))>>28)
+#define SYS_CLOCK_ENABLE2_clk_en_ur2_shift                                           (27)
+#define SYS_CLOCK_ENABLE2_clk_en_ur2_mask                                            (0x08000000)
+#define SYS_CLOCK_ENABLE2_clk_en_ur2(data)                                           (0x08000000&((data)<<27))
+#define SYS_CLOCK_ENABLE2_clk_en_ur2_src(data)                                       ((0x08000000&(data))>>27)
+#define SYS_CLOCK_ENABLE2_get_clk_en_ur2(data)                                       ((0x08000000&(data))>>27)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_alive_1_shift                                  (26)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_alive_1_mask                                   (0x04000000)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_alive_1(data)                                  (0x04000000&((data)<<26))
+#define SYS_CLOCK_ENABLE2_clk_en_sata_alive_1_src(data)                              ((0x04000000&(data))>>26)
+#define SYS_CLOCK_ENABLE2_get_clk_en_sata_alive_1(data)                              ((0x04000000&(data))>>26)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_1_shift                                        (25)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_1_mask                                         (0x02000000)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_1(data)                                        (0x02000000&((data)<<25))
+#define SYS_CLOCK_ENABLE2_clk_en_sata_1_src(data)                                    ((0x02000000&(data))>>25)
+#define SYS_CLOCK_ENABLE2_get_clk_en_sata_1(data)                                    ((0x02000000&(data))>>25)
+#define SYS_CLOCK_ENABLE2_clk_en_hdmirx_shift                                        (24)
+#define SYS_CLOCK_ENABLE2_clk_en_hdmirx_mask                                         (0x01000000)
+#define SYS_CLOCK_ENABLE2_clk_en_hdmirx(data)                                        (0x01000000&((data)<<24))
+#define SYS_CLOCK_ENABLE2_clk_en_hdmirx_src(data)                                    ((0x01000000&(data))>>24)
+#define SYS_CLOCK_ENABLE2_get_clk_en_hdmirx(data)                                    ((0x01000000&(data))>>24)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk_shift                                      (23)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk_mask                                       (0x00800000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk(data)                                      (0x00800000&((data)<<23))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk_src(data)                                  ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_mclk(data)                                  ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s_shift                                       (22)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s_mask                                        (0x00400000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s(data)                                       (0x00400000&((data)<<22))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s_src(data)                                   ((0x00400000&(data))>>22)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_i2s(data)                                   ((0x00400000&(data))>>22)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif_shift                                     (21)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif_mask                                      (0x00200000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif(data)                                     (0x00200000&((data)<<21))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif_src(data)                                 ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_spdif(data)                                 ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi_shift                                      (20)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi_mask                                       (0x00100000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi(data)                                      (0x00100000&((data)<<20))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi_src(data)                                  ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_hdmi(data)                                  ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da_shift                                        (19)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da_mask                                         (0x00080000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da(data)                                        (0x00080000&((data)<<19))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da_src(data)                                    ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_da(data)                                    ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod_shift                                       (18)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod_mask                                        (0x00040000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod(data)                                       (0x00040000&((data)<<18))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod_src(data)                                   ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_mod(data)                                   ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec_shift                                  (17)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec_mask                                   (0x00020000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec(data)                                  (0x00020000&((data)<<17))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec_src(data)                              ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_au_codec(data)                              ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1_shift                                    (16)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1_mask                                     (0x00010000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1(data)                                    (0x00010000&((data)<<16))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1_src(data)                                ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_1(data)                                ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2_shift                                    (15)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2_mask                                     (0x00008000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2(data)                                    (0x00008000&((data)<<15))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2_src(data)                                ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_2(data)                                ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3_shift                                    (14)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3_mask                                     (0x00004000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3(data)                                    (0x00004000&((data)<<14))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3_src(data)                                ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_3(data)                                ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4_shift                                    (13)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4_mask                                     (0x00002000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4(data)                                    (0x00002000&((data)<<13))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4_src(data)                                ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_4(data)                                ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc_shift                                      (10)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc_mask                                       (0x00000400)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc(data)                                      (0x00000400&((data)<<10))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc_src(data)                                  ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_rtc(data)                                  ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE2_clk_en_cbus_tx_shift                                       (7)
+#define SYS_CLOCK_ENABLE2_clk_en_cbus_tx_mask                                        (0x00000080)
+#define SYS_CLOCK_ENABLE2_clk_en_cbus_tx(data)                                       (0x00000080&((data)<<7))
+#define SYS_CLOCK_ENABLE2_clk_en_cbus_tx_src(data)                                   ((0x00000080&(data))>>7)
+#define SYS_CLOCK_ENABLE2_get_clk_en_cbus_tx(data)                                   ((0x00000080&(data))>>7)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_sc_shift                                       (6)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_sc_mask                                        (0x00000040)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_sc(data)                                       (0x00000040&((data)<<6))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_sc_src(data)                                   ((0x00000040&(data))>>6)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_sc(data)                                   ((0x00000040&(data))>>6)
+#define SYS_CLOCK_ENABLE2_clk_en_pcie1_shift                                         (5)
+#define SYS_CLOCK_ENABLE2_clk_en_pcie1_mask                                          (0x00000020)
+#define SYS_CLOCK_ENABLE2_clk_en_pcie1(data)                                         (0x00000020&((data)<<5))
+#define SYS_CLOCK_ENABLE2_clk_en_pcie1_src(data)                                     ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE2_get_clk_en_pcie1(data)                                     ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE2_clk_en_acpu_shift                                          (4)
+#define SYS_CLOCK_ENABLE2_clk_en_acpu_mask                                           (0x00000010)
+#define SYS_CLOCK_ENABLE2_clk_en_acpu(data)                                          (0x00000010&((data)<<4))
+#define SYS_CLOCK_ENABLE2_clk_en_acpu_src(data)                                      ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE2_get_clk_en_acpu(data)                                      ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE2_clk_en_jpeg_shift                                          (3)
+#define SYS_CLOCK_ENABLE2_clk_en_jpeg_mask                                           (0x00000008)
+#define SYS_CLOCK_ENABLE2_clk_en_jpeg(data)                                          (0x00000008&((data)<<3))
+#define SYS_CLOCK_ENABLE2_clk_en_jpeg_src(data)                                      ((0x00000008&(data))>>3)
+#define SYS_CLOCK_ENABLE2_get_clk_en_jpeg(data)                                      ((0x00000008&(data))>>3)
+#define SYS_CLOCK_ENABLE2_clk_en_scpu_shift                                          (2)
+#define SYS_CLOCK_ENABLE2_clk_en_scpu_mask                                           (0x00000004)
+#define SYS_CLOCK_ENABLE2_clk_en_scpu(data)                                          (0x00000004&((data)<<2))
+#define SYS_CLOCK_ENABLE2_clk_en_scpu_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_CLOCK_ENABLE2_get_clk_en_scpu(data)                                      ((0x00000004&(data))>>2)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5_shift                                    (1)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5_mask                                     (0x00000002)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5(data)                                    (0x00000002&((data)<<1))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5_src(data)                                ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_5(data)                                ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE2_clk_en_nat_shift                                           (0)
+#define SYS_CLOCK_ENABLE2_clk_en_nat_mask                                            (0x00000001)
+#define SYS_CLOCK_ENABLE2_clk_en_nat(data)                                           (0x00000001&((data)<<0))
+#define SYS_CLOCK_ENABLE2_clk_en_nat_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_CLOCK_ENABLE2_get_clk_en_nat(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_GROUP1_CK_EN                                                             0x014
+#define SYS_GROUP1_CK_EN_reg_addr                                                    "0x98000014"
+#define SYS_GROUP1_CK_EN_reg                                                         0x98000014
+#define set_SYS_GROUP1_CK_EN_reg(data)   (*((volatile unsigned int*) SYS_GROUP1_CK_EN_reg)=data)
+#define get_SYS_GROUP1_CK_EN_reg   (*((volatile unsigned int*) SYS_GROUP1_CK_EN_reg))
+#define SYS_GROUP1_CK_EN_inst_adr                                                    "0x0005"
+#define SYS_GROUP1_CK_EN_inst                                                        0x0005
+#define SYS_GROUP1_CK_EN_reserved_group1_ck_en_shift                                 (0)
+#define SYS_GROUP1_CK_EN_reserved_group1_ck_en_mask                                  (0x00000001)
+#define SYS_GROUP1_CK_EN_reserved_group1_ck_en(data)                                 (0x00000001&((data)<<0))
+#define SYS_GROUP1_CK_EN_reserved_group1_ck_en_src(data)                             ((0x00000001&(data))>>0)
+#define SYS_GROUP1_CK_EN_get_reserved_group1_ck_en(data)                             ((0x00000001&(data))>>0)
+
+
+#define SYS_GROUP1_CK_SEL                                                            0x018
+#define SYS_GROUP1_CK_SEL_reg_addr                                                   "0x98000018"
+#define SYS_GROUP1_CK_SEL_reg                                                        0x98000018
+#define set_SYS_GROUP1_CK_SEL_reg(data)   (*((volatile unsigned int*) SYS_GROUP1_CK_SEL_reg)=data)
+#define get_SYS_GROUP1_CK_SEL_reg   (*((volatile unsigned int*) SYS_GROUP1_CK_SEL_reg))
+#define SYS_GROUP1_CK_SEL_inst_adr                                                   "0x0006"
+#define SYS_GROUP1_CK_SEL_inst                                                       0x0006
+#define SYS_GROUP1_CK_SEL_scpu_sclk_sel_shift                                        (2)
+#define SYS_GROUP1_CK_SEL_scpu_sclk_sel_mask                                         (0x00000004)
+#define SYS_GROUP1_CK_SEL_scpu_sclk_sel(data)                                        (0x00000004&((data)<<2))
+#define SYS_GROUP1_CK_SEL_scpu_sclk_sel_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_GROUP1_CK_SEL_get_scpu_sclk_sel(data)                                    ((0x00000004&(data))>>2)
+#define SYS_GROUP1_CK_SEL_sclk_sel_sysh_shift                                        (1)
+#define SYS_GROUP1_CK_SEL_sclk_sel_sysh_mask                                         (0x00000002)
+#define SYS_GROUP1_CK_SEL_sclk_sel_sysh(data)                                        (0x00000002&((data)<<1))
+#define SYS_GROUP1_CK_SEL_sclk_sel_sysh_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_GROUP1_CK_SEL_get_sclk_sel_sysh(data)                                    ((0x00000002&(data))>>1)
+#define SYS_GROUP1_CK_SEL_sclk_sel_shift                                             (0)
+#define SYS_GROUP1_CK_SEL_sclk_sel_mask                                              (0x00000001)
+#define SYS_GROUP1_CK_SEL_sclk_sel(data)                                             (0x00000001&((data)<<0))
+#define SYS_GROUP1_CK_SEL_sclk_sel_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_GROUP1_CK_SEL_get_sclk_sel(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_TVE_CK_SEL                                                               0x01C
+#define SYS_TVE_CK_SEL_reg_addr                                                      "0x9800001C"
+#define SYS_TVE_CK_SEL_reg                                                           0x9800001C
+#define set_SYS_TVE_CK_SEL_reg(data)   (*((volatile unsigned int*) SYS_TVE_CK_SEL_reg)=data)
+#define get_SYS_TVE_CK_SEL_reg   (*((volatile unsigned int*) SYS_TVE_CK_SEL_reg))
+#define SYS_TVE_CK_SEL_inst_adr                                                      "0x0007"
+#define SYS_TVE_CK_SEL_inst                                                          0x0007
+#define SYS_TVE_CK_SEL_write_en5_shift                                               (12)
+#define SYS_TVE_CK_SEL_write_en5_mask                                                (0x00001000)
+#define SYS_TVE_CK_SEL_write_en5(data)                                               (0x00001000&((data)<<12))
+#define SYS_TVE_CK_SEL_write_en5_src(data)                                           ((0x00001000&(data))>>12)
+#define SYS_TVE_CK_SEL_get_write_en5(data)                                           ((0x00001000&(data))>>12)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2_shift                                   (11)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2_mask                                    (0x00000800)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2(data)                                   (0x00000800&((data)<<11))
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2_src(data)                               ((0x00000800&(data))>>11)
+#define SYS_TVE_CK_SEL_get_clk_tve_p_vo_clk_sel2(data)                               ((0x00000800&(data))>>11)
+#define SYS_TVE_CK_SEL_write_en4_shift                                               (10)
+#define SYS_TVE_CK_SEL_write_en4_mask                                                (0x00000400)
+#define SYS_TVE_CK_SEL_write_en4(data)                                               (0x00000400&((data)<<10))
+#define SYS_TVE_CK_SEL_write_en4_src(data)                                           ((0x00000400&(data))>>10)
+#define SYS_TVE_CK_SEL_get_write_en4(data)                                           ((0x00000400&(data))>>10)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel_shift                                    (9)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel_mask                                     (0x00000200)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel(data)                                    (0x00000200&((data)<<9))
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel_src(data)                                ((0x00000200&(data))>>9)
+#define SYS_TVE_CK_SEL_get_clk_tve_p_vo_clk_sel(data)                                ((0x00000200&(data))>>9)
+#define SYS_TVE_CK_SEL_write_en3_shift                                               (8)
+#define SYS_TVE_CK_SEL_write_en3_mask                                                (0x00000100)
+#define SYS_TVE_CK_SEL_write_en3(data)                                               (0x00000100&((data)<<8))
+#define SYS_TVE_CK_SEL_write_en3_src(data)                                           ((0x00000100&(data))>>8)
+#define SYS_TVE_CK_SEL_get_write_en3(data)                                           ((0x00000100&(data))>>8)
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv_shift                                          (7)
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv_mask                                           (0x00000080)
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv(data)                                          (0x00000080&((data)<<7))
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv_src(data)                                      ((0x00000080&(data))>>7)
+#define SYS_TVE_CK_SEL_get_hdmi_phy_ckinv(data)                                      ((0x00000080&(data))>>7)
+#define SYS_TVE_CK_SEL_write_en2_shift                                               (6)
+#define SYS_TVE_CK_SEL_write_en2_mask                                                (0x00000040)
+#define SYS_TVE_CK_SEL_write_en2(data)                                               (0x00000040&((data)<<6))
+#define SYS_TVE_CK_SEL_write_en2_src(data)                                           ((0x00000040&(data))>>6)
+#define SYS_TVE_CK_SEL_get_write_en2(data)                                           ((0x00000040&(data))>>6)
+#define SYS_TVE_CK_SEL_dac2_ckinv_shift                                              (3)
+#define SYS_TVE_CK_SEL_dac2_ckinv_mask                                               (0x00000008)
+#define SYS_TVE_CK_SEL_dac2_ckinv(data)                                              (0x00000008&((data)<<3))
+#define SYS_TVE_CK_SEL_dac2_ckinv_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_TVE_CK_SEL_get_dac2_ckinv(data)                                          ((0x00000008&(data))>>3)
+#define SYS_TVE_CK_SEL_dac1_ckinv_shift                                              (2)
+#define SYS_TVE_CK_SEL_dac1_ckinv_mask                                               (0x00000004)
+#define SYS_TVE_CK_SEL_dac1_ckinv(data)                                              (0x00000004&((data)<<2))
+#define SYS_TVE_CK_SEL_dac1_ckinv_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_TVE_CK_SEL_get_dac1_ckinv(data)                                          ((0x00000004&(data))>>2)
+#define SYS_TVE_CK_SEL_write_en1_shift                                               (1)
+#define SYS_TVE_CK_SEL_write_en1_mask                                                (0x00000002)
+#define SYS_TVE_CK_SEL_write_en1(data)                                               (0x00000002&((data)<<1))
+#define SYS_TVE_CK_SEL_write_en1_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_TVE_CK_SEL_get_write_en1(data)                                           ((0x00000002&(data))>>1)
+#define SYS_TVE_CK_SEL_tveck_mix_sel_shift                                           (0)
+#define SYS_TVE_CK_SEL_tveck_mix_sel_mask                                            (0x00000001)
+#define SYS_TVE_CK_SEL_tveck_mix_sel(data)                                           (0x00000001&((data)<<0))
+#define SYS_TVE_CK_SEL_tveck_mix_sel_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_TVE_CK_SEL_get_tveck_mix_sel(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_DISP_PLL_DIV                                                             0x020
+#define SYS_DISP_PLL_DIV_reg_addr                                                    "0x98000020"
+#define SYS_DISP_PLL_DIV_reg                                                         0x98000020
+#define set_SYS_DISP_PLL_DIV_reg(data)   (*((volatile unsigned int*) SYS_DISP_PLL_DIV_reg)=data)
+#define get_SYS_DISP_PLL_DIV_reg   (*((volatile unsigned int*) SYS_DISP_PLL_DIV_reg))
+#define SYS_DISP_PLL_DIV_inst_adr                                                    "0x0008"
+#define SYS_DISP_PLL_DIV_inst                                                        0x0008
+#define SYS_DISP_PLL_DIV_write_en2_shift                                             (11)
+#define SYS_DISP_PLL_DIV_write_en2_mask                                              (0x00000800)
+#define SYS_DISP_PLL_DIV_write_en2(data)                                             (0x00000800&((data)<<11))
+#define SYS_DISP_PLL_DIV_write_en2_src(data)                                         ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV_get_write_en2(data)                                         ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV_dac2_div_shift                                              (6)
+#define SYS_DISP_PLL_DIV_dac2_div_mask                                               (0x000007C0)
+#define SYS_DISP_PLL_DIV_dac2_div(data)                                              (0x000007C0&((data)<<6))
+#define SYS_DISP_PLL_DIV_dac2_div_src(data)                                          ((0x000007C0&(data))>>6)
+#define SYS_DISP_PLL_DIV_get_dac2_div(data)                                          ((0x000007C0&(data))>>6)
+#define SYS_DISP_PLL_DIV_write_en1_shift                                             (5)
+#define SYS_DISP_PLL_DIV_write_en1_mask                                              (0x00000020)
+#define SYS_DISP_PLL_DIV_write_en1(data)                                             (0x00000020&((data)<<5))
+#define SYS_DISP_PLL_DIV_write_en1_src(data)                                         ((0x00000020&(data))>>5)
+#define SYS_DISP_PLL_DIV_get_write_en1(data)                                         ((0x00000020&(data))>>5)
+#define SYS_DISP_PLL_DIV_dac1_div_shift                                              (0)
+#define SYS_DISP_PLL_DIV_dac1_div_mask                                               (0x0000001F)
+#define SYS_DISP_PLL_DIV_dac1_div(data)                                              (0x0000001F&((data)<<0))
+#define SYS_DISP_PLL_DIV_dac1_div_src(data)                                          ((0x0000001F&(data))>>0)
+#define SYS_DISP_PLL_DIV_get_dac1_div(data)                                          ((0x0000001F&(data))>>0)
+
+
+#define SYS_DISP_PLL_DIV2                                                            0x024
+#define SYS_DISP_PLL_DIV2_reg_addr                                                   "0x98000024"
+#define SYS_DISP_PLL_DIV2_reg                                                        0x98000024
+#define set_SYS_DISP_PLL_DIV2_reg(data)   (*((volatile unsigned int*) SYS_DISP_PLL_DIV2_reg)=data)
+#define get_SYS_DISP_PLL_DIV2_reg   (*((volatile unsigned int*) SYS_DISP_PLL_DIV2_reg))
+#define SYS_DISP_PLL_DIV2_inst_adr                                                   "0x0009"
+#define SYS_DISP_PLL_DIV2_inst                                                       0x0009
+#define SYS_DISP_PLL_DIV2_write_en11_shift                                           (26)
+#define SYS_DISP_PLL_DIV2_write_en11_mask                                            (0x04000000)
+#define SYS_DISP_PLL_DIV2_write_en11(data)                                           (0x04000000&((data)<<26))
+#define SYS_DISP_PLL_DIV2_write_en11_src(data)                                       ((0x04000000&(data))>>26)
+#define SYS_DISP_PLL_DIV2_get_write_en11(data)                                       ((0x04000000&(data))>>26)
+#define SYS_DISP_PLL_DIV2_sel_prefifo_din_shift                                      (25)
+#define SYS_DISP_PLL_DIV2_sel_prefifo_din_mask                                       (0x02000000)
+#define SYS_DISP_PLL_DIV2_sel_prefifo_din(data)                                      (0x02000000&((data)<<25))
+#define SYS_DISP_PLL_DIV2_sel_prefifo_din_src(data)                                  ((0x02000000&(data))>>25)
+#define SYS_DISP_PLL_DIV2_get_sel_prefifo_din(data)                                  ((0x02000000&(data))>>25)
+#define SYS_DISP_PLL_DIV2_write_en10_shift                                           (24)
+#define SYS_DISP_PLL_DIV2_write_en10_mask                                            (0x01000000)
+#define SYS_DISP_PLL_DIV2_write_en10(data)                                           (0x01000000&((data)<<24))
+#define SYS_DISP_PLL_DIV2_write_en10_src(data)                                       ((0x01000000&(data))>>24)
+#define SYS_DISP_PLL_DIV2_get_write_en10(data)                                       ((0x01000000&(data))>>24)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl_shift                                      (23)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl_mask                                       (0x00800000)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl(data)                                      (0x00800000&((data)<<23))
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl_src(data)                                  ((0x00800000&(data))>>23)
+#define SYS_DISP_PLL_DIV2_get_sel_pllhdmi_mhl(data)                                  ((0x00800000&(data))>>23)
+#define SYS_DISP_PLL_DIV2_write_en9_shift                                            (22)
+#define SYS_DISP_PLL_DIV2_write_en9_mask                                             (0x00400000)
+#define SYS_DISP_PLL_DIV2_write_en9(data)                                            (0x00400000&((data)<<22))
+#define SYS_DISP_PLL_DIV2_write_en9_src(data)                                        ((0x00400000&(data))>>22)
+#define SYS_DISP_PLL_DIV2_get_write_en9(data)                                        ((0x00400000&(data))>>22)
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel_shift                                         (17)
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel_mask                                          (0x003E0000)
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel(data)                                         (0x003E0000&((data)<<17))
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel_src(data)                                     ((0x003E0000&(data))>>17)
+#define SYS_DISP_PLL_DIV2_get_clk_lvds_sel(data)                                     ((0x003E0000&(data))>>17)
+#define SYS_DISP_PLL_DIV2_write_en8_shift                                            (16)
+#define SYS_DISP_PLL_DIV2_write_en8_mask                                             (0x00010000)
+#define SYS_DISP_PLL_DIV2_write_en8(data)                                            (0x00010000&((data)<<16))
+#define SYS_DISP_PLL_DIV2_write_en8_src(data)                                        ((0x00010000&(data))>>16)
+#define SYS_DISP_PLL_DIV2_get_write_en8(data)                                        ((0x00010000&(data))>>16)
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2_shift                                     (15)
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2_mask                                      (0x00008000)
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2(data)                                     (0x00008000&((data)<<15))
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2_src(data)                                 ((0x00008000&(data))>>15)
+#define SYS_DISP_PLL_DIV2_get_sel_plldisp_clk2(data)                                 ((0x00008000&(data))>>15)
+#define SYS_DISP_PLL_DIV2_write_en7_shift                                            (14)
+#define SYS_DISP_PLL_DIV2_write_en7_mask                                             (0x00004000)
+#define SYS_DISP_PLL_DIV2_write_en7(data)                                            (0x00004000&((data)<<14))
+#define SYS_DISP_PLL_DIV2_write_en7_src(data)                                        ((0x00004000&(data))>>14)
+#define SYS_DISP_PLL_DIV2_get_write_en7(data)                                        ((0x00004000&(data))>>14)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk_shift                                      (13)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk_mask                                       (0x00002000)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk(data)                                      (0x00002000&((data)<<13))
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk_src(data)                                  ((0x00002000&(data))>>13)
+#define SYS_DISP_PLL_DIV2_get_sel_pllhdmi_clk(data)                                  ((0x00002000&(data))>>13)
+#define SYS_DISP_PLL_DIV2_write_en6_shift                                            (12)
+#define SYS_DISP_PLL_DIV2_write_en6_mask                                             (0x00001000)
+#define SYS_DISP_PLL_DIV2_write_en6(data)                                            (0x00001000&((data)<<12))
+#define SYS_DISP_PLL_DIV2_write_en6_src(data)                                        ((0x00001000&(data))>>12)
+#define SYS_DISP_PLL_DIV2_get_write_en6(data)                                        ((0x00001000&(data))>>12)
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat_shift                                      (11)
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat_mask                                       (0x00000800)
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat(data)                                      (0x00000800&((data)<<11))
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat_src(data)                                  ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV2_get_hdmi_pxl_repeat(data)                                  ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV2_write_en5_shift                                            (10)
+#define SYS_DISP_PLL_DIV2_write_en5_mask                                             (0x00000400)
+#define SYS_DISP_PLL_DIV2_write_en5(data)                                            (0x00000400&((data)<<10))
+#define SYS_DISP_PLL_DIV2_write_en5_src(data)                                        ((0x00000400&(data))>>10)
+#define SYS_DISP_PLL_DIV2_get_write_en5(data)                                        ((0x00000400&(data))>>10)
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel_shift                                     (9)
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel_mask                                      (0x00000200)
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel(data)                                     (0x00000200&((data)<<9))
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel_src(data)                                 ((0x00000200&(data))>>9)
+#define SYS_DISP_PLL_DIV2_get_hdmi_phy_clk_sel(data)                                 ((0x00000200&(data))>>9)
+#define SYS_DISP_PLL_DIV2_write_en4_shift                                            (8)
+#define SYS_DISP_PLL_DIV2_write_en4_mask                                             (0x00000100)
+#define SYS_DISP_PLL_DIV2_write_en4(data)                                            (0x00000100&((data)<<8))
+#define SYS_DISP_PLL_DIV2_write_en4_src(data)                                        ((0x00000100&(data))>>8)
+#define SYS_DISP_PLL_DIV2_get_write_en4(data)                                        ((0x00000100&(data))>>8)
+#define SYS_DISP_PLL_DIV2_hdmi_div_shift                                             (5)
+#define SYS_DISP_PLL_DIV2_hdmi_div_mask                                              (0x000000E0)
+#define SYS_DISP_PLL_DIV2_hdmi_div(data)                                             (0x000000E0&((data)<<5))
+#define SYS_DISP_PLL_DIV2_hdmi_div_src(data)                                         ((0x000000E0&(data))>>5)
+#define SYS_DISP_PLL_DIV2_get_hdmi_div(data)                                         ((0x000000E0&(data))>>5)
+#define SYS_DISP_PLL_DIV2_write_en3_shift                                            (4)
+#define SYS_DISP_PLL_DIV2_write_en3_mask                                             (0x00000010)
+#define SYS_DISP_PLL_DIV2_write_en3(data)                                            (0x00000010&((data)<<4))
+#define SYS_DISP_PLL_DIV2_write_en3_src(data)                                        ((0x00000010&(data))>>4)
+#define SYS_DISP_PLL_DIV2_get_write_en3(data)                                        ((0x00000010&(data))>>4)
+#define SYS_DISP_PLL_DIV2_tve_div_shift                                              (0)
+#define SYS_DISP_PLL_DIV2_tve_div_mask                                               (0x0000000F)
+#define SYS_DISP_PLL_DIV2_tve_div(data)                                              (0x0000000F&((data)<<0))
+#define SYS_DISP_PLL_DIV2_tve_div_src(data)                                          ((0x0000000F&(data))>>0)
+#define SYS_DISP_PLL_DIV2_get_tve_div(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define SYS_DDS_VIDEO_CK_SEL                                                         0x028
+#define SYS_DDS_VIDEO_CK_SEL_reg_addr                                                "0x98000028"
+#define SYS_DDS_VIDEO_CK_SEL_reg                                                     0x98000028
+#define set_SYS_DDS_VIDEO_CK_SEL_reg(data)   (*((volatile unsigned int*) SYS_DDS_VIDEO_CK_SEL_reg)=data)
+#define get_SYS_DDS_VIDEO_CK_SEL_reg   (*((volatile unsigned int*) SYS_DDS_VIDEO_CK_SEL_reg))
+#define SYS_DDS_VIDEO_CK_SEL_inst_adr                                                "0x000A"
+#define SYS_DDS_VIDEO_CK_SEL_inst                                                    0x000A
+#define SYS_DDS_VIDEO_CK_SEL_nat_clk_sel_shift                                       (1)
+#define SYS_DDS_VIDEO_CK_SEL_nat_clk_sel_mask                                        (0x00000002)
+#define SYS_DDS_VIDEO_CK_SEL_nat_clk_sel(data)                                       (0x00000002&((data)<<1))
+#define SYS_DDS_VIDEO_CK_SEL_nat_clk_sel_src(data)                                   ((0x00000002&(data))>>1)
+#define SYS_DDS_VIDEO_CK_SEL_get_nat_clk_sel(data)                                   ((0x00000002&(data))>>1)
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel_shift                                       (0)
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel_mask                                        (0x00000001)
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel(data)                                       (0x00000001&((data)<<0))
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_DDS_VIDEO_CK_SEL_get_dds_clk_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_AUDIO_CLK_CTL                                                            0x02C
+#define SYS_AUDIO_CLK_CTL_reg_addr                                                   "0x9800002C"
+#define SYS_AUDIO_CLK_CTL_reg                                                        0x9800002C
+#define set_SYS_AUDIO_CLK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AUDIO_CLK_CTL_reg)=data)
+#define get_SYS_AUDIO_CLK_CTL_reg   (*((volatile unsigned int*) SYS_AUDIO_CLK_CTL_reg))
+#define SYS_AUDIO_CLK_CTL_inst_adr                                                   "0x000B"
+#define SYS_AUDIO_CLK_CTL_inst                                                       0x000B
+#define SYS_AUDIO_CLK_CTL_mipi_div_shift                                             (4)
+#define SYS_AUDIO_CLK_CTL_mipi_div_mask                                              (0x00000030)
+#define SYS_AUDIO_CLK_CTL_mipi_div(data)                                             (0x00000030&((data)<<4))
+#define SYS_AUDIO_CLK_CTL_mipi_div_src(data)                                         ((0x00000030&(data))>>4)
+#define SYS_AUDIO_CLK_CTL_get_mipi_div(data)                                         ((0x00000030&(data))>>4)
+#define SYS_AUDIO_CLK_CTL_vo_div_shift                                               (2)
+#define SYS_AUDIO_CLK_CTL_vo_div_mask                                                (0x0000000C)
+#define SYS_AUDIO_CLK_CTL_vo_div(data)                                               (0x0000000C&((data)<<2))
+#define SYS_AUDIO_CLK_CTL_vo_div_src(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_AUDIO_CLK_CTL_get_vo_div(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk_shift                                     (0)
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk_mask                                      (0x00000001)
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk(data)                                     (0x00000001&((data)<<0))
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk_src(data)                                 ((0x00000001&(data))>>0)
+#define SYS_AUDIO_CLK_CTL_get_audio_use_sysclk(data)                                 ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DIV                                                                  0x030
+#define SYS_PLL_DIV_reg_addr                                                         "0x98000030"
+#define SYS_PLL_DIV_reg                                                              0x98000030
+#define set_SYS_PLL_DIV_reg(data)   (*((volatile unsigned int*) SYS_PLL_DIV_reg)=data)
+#define get_SYS_PLL_DIV_reg   (*((volatile unsigned int*) SYS_PLL_DIV_reg))
+#define SYS_PLL_DIV_inst_adr                                                         "0x000C"
+#define SYS_PLL_DIV_inst                                                             0x000C
+#define SYS_PLL_DIV_scpu_freq_sel_shift                                              (7)
+#define SYS_PLL_DIV_scpu_freq_sel_mask                                               (0x00000180)
+#define SYS_PLL_DIV_scpu_freq_sel(data)                                              (0x00000180&((data)<<7))
+#define SYS_PLL_DIV_scpu_freq_sel_src(data)                                          ((0x00000180&(data))>>7)
+#define SYS_PLL_DIV_get_scpu_freq_sel(data)                                          ((0x00000180&(data))>>7)
+#define SYS_PLL_DIV_acpu_freq_sel_shift                                              (3)
+#define SYS_PLL_DIV_acpu_freq_sel_mask                                               (0x00000018)
+#define SYS_PLL_DIV_acpu_freq_sel(data)                                              (0x00000018&((data)<<3))
+#define SYS_PLL_DIV_acpu_freq_sel_src(data)                                          ((0x00000018&(data))>>3)
+#define SYS_PLL_DIV_get_acpu_freq_sel(data)                                          ((0x00000018&(data))>>3)
+#define SYS_PLL_DIV_bus_freq_sel_shift                                               (0)
+#define SYS_PLL_DIV_bus_freq_sel_mask                                                (0x00000001)
+#define SYS_PLL_DIV_bus_freq_sel(data)                                               (0x00000001&((data)<<0))
+#define SYS_PLL_DIV_bus_freq_sel_src(data)                                           ((0x00000001&(data))>>0)
+#define SYS_PLL_DIV_get_bus_freq_sel(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SYS_NF_CKSEL                                                                 0x038
+#define SYS_NF_CKSEL_reg_addr                                                        "0x98000038"
+#define SYS_NF_CKSEL_reg                                                             0x98000038
+#define set_SYS_NF_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_NF_CKSEL_reg)=data)
+#define get_SYS_NF_CKSEL_reg   (*((volatile unsigned int*) SYS_NF_CKSEL_reg))
+#define SYS_NF_CKSEL_inst_adr                                                        "0x000E"
+#define SYS_NF_CKSEL_inst                                                            0x000E
+#define SYS_NF_CKSEL_emmc_div_sel_shift                                              (24)
+#define SYS_NF_CKSEL_emmc_div_sel_mask                                               (0x03000000)
+#define SYS_NF_CKSEL_emmc_div_sel(data)                                              (0x03000000&((data)<<24))
+#define SYS_NF_CKSEL_emmc_div_sel_src(data)                                          ((0x03000000&(data))>>24)
+#define SYS_NF_CKSEL_get_emmc_div_sel(data)                                          ((0x03000000&(data))>>24)
+#define SYS_NF_CKSEL_cr_div_sel_shift                                                (16)
+#define SYS_NF_CKSEL_cr_div_sel_mask                                                 (0x00030000)
+#define SYS_NF_CKSEL_cr_div_sel(data)                                                (0x00030000&((data)<<16))
+#define SYS_NF_CKSEL_cr_div_sel_src(data)                                            ((0x00030000&(data))>>16)
+#define SYS_NF_CKSEL_get_cr_div_sel(data)                                            ((0x00030000&(data))>>16)
+#define SYS_NF_CKSEL_sdio_div_sel_shift                                              (8)
+#define SYS_NF_CKSEL_sdio_div_sel_mask                                               (0x00000300)
+#define SYS_NF_CKSEL_sdio_div_sel(data)                                              (0x00000300&((data)<<8))
+#define SYS_NF_CKSEL_sdio_div_sel_src(data)                                          ((0x00000300&(data))>>8)
+#define SYS_NF_CKSEL_get_sdio_div_sel(data)                                          ((0x00000300&(data))>>8)
+#define SYS_NF_CKSEL_nf_div_sel_shift                                                (0)
+#define SYS_NF_CKSEL_nf_div_sel_mask                                                 (0x0000000F)
+#define SYS_NF_CKSEL_nf_div_sel(data)                                                (0x0000000F&((data)<<0))
+#define SYS_NF_CKSEL_nf_div_sel_src(data)                                            ((0x0000000F&(data))>>0)
+#define SYS_NF_CKSEL_get_nf_div_sel(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define SYS_NDS_SC_CKSEL                                                             0x03C
+#define SYS_NDS_SC_CKSEL_reg_addr                                                    "0x9800003C"
+#define SYS_NDS_SC_CKSEL_reg                                                         0x9800003C
+#define set_SYS_NDS_SC_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_NDS_SC_CKSEL_reg)=data)
+#define get_SYS_NDS_SC_CKSEL_reg   (*((volatile unsigned int*) SYS_NDS_SC_CKSEL_reg))
+#define SYS_NDS_SC_CKSEL_inst_adr                                                    "0x000F"
+#define SYS_NDS_SC_CKSEL_inst                                                        0x000F
+#define SYS_NDS_SC_CKSEL_nds_sc_div_shift                                            (0)
+#define SYS_NDS_SC_CKSEL_nds_sc_div_mask                                             (0x00000007)
+#define SYS_NDS_SC_CKSEL_nds_sc_div(data)                                            (0x00000007&((data)<<0))
+#define SYS_NDS_SC_CKSEL_nds_sc_div_src(data)                                        ((0x00000007&(data))>>0)
+#define SYS_NDS_SC_CKSEL_get_nds_sc_div(data)                                        ((0x00000007&(data))>>0)
+
+
+#define SYS_DCPHY_CKSEL                                                              0x040
+#define SYS_DCPHY_CKSEL_reg_addr                                                     "0x98000040"
+#define SYS_DCPHY_CKSEL_reg                                                          0x98000040
+#define set_SYS_DCPHY_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_DCPHY_CKSEL_reg)=data)
+#define get_SYS_DCPHY_CKSEL_reg   (*((volatile unsigned int*) SYS_DCPHY_CKSEL_reg))
+#define SYS_DCPHY_CKSEL_inst_adr                                                     "0x0010"
+#define SYS_DCPHY_CKSEL_inst                                                         0x0010
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_1_shift                                (1)
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_1_mask                                 (0x00000002)
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_1(data)                                (0x00000002&((data)<<1))
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_1_src(data)                            ((0x00000002&(data))>>1)
+#define SYS_DCPHY_CKSEL_get_ref_bypass_mode_dcphy_1(data)                            ((0x00000002&(data))>>1)
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_0_shift                                (0)
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_0_mask                                 (0x00000001)
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_0(data)                                (0x00000001&((data)<<0))
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_0_src(data)                            ((0x00000001&(data))>>0)
+#define SYS_DCPHY_CKSEL_get_ref_bypass_mode_dcphy_0(data)                            ((0x00000001&(data))>>0)
+
+
+#define SYS_MISC_CKSEL                                                               0x044
+#define SYS_MISC_CKSEL_reg_addr                                                      "0x98000044"
+#define SYS_MISC_CKSEL_reg                                                           0x98000044
+#define set_SYS_MISC_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_MISC_CKSEL_reg)=data)
+#define get_SYS_MISC_CKSEL_reg   (*((volatile unsigned int*) SYS_MISC_CKSEL_reg))
+#define SYS_MISC_CKSEL_inst_adr                                                      "0x0011"
+#define SYS_MISC_CKSEL_inst                                                          0x0011
+#define SYS_MISC_CKSEL_clk_camera1_sel_shift                                         (2)
+#define SYS_MISC_CKSEL_clk_camera1_sel_mask                                          (0x0000000C)
+#define SYS_MISC_CKSEL_clk_camera1_sel(data)                                         (0x0000000C&((data)<<2))
+#define SYS_MISC_CKSEL_clk_camera1_sel_src(data)                                     ((0x0000000C&(data))>>2)
+#define SYS_MISC_CKSEL_get_clk_camera1_sel(data)                                     ((0x0000000C&(data))>>2)
+#define SYS_MISC_CKSEL_clk_camera0_sel_shift                                         (0)
+#define SYS_MISC_CKSEL_clk_camera0_sel_mask                                          (0x00000003)
+#define SYS_MISC_CKSEL_clk_camera0_sel(data)                                         (0x00000003&((data)<<0))
+#define SYS_MISC_CKSEL_clk_camera0_sel_src(data)                                     ((0x00000003&(data))>>0)
+#define SYS_MISC_CKSEL_get_clk_camera0_sel(data)                                     ((0x00000003&(data))>>0)
+
+
+#define SYS_SCPU_CKSEL                                                               0x048
+#define SYS_SCPU_CKSEL_reg_addr                                                      "0x98000048"
+#define SYS_SCPU_CKSEL_reg                                                           0x98000048
+#define set_SYS_SCPU_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_SCPU_CKSEL_reg)=data)
+#define get_SYS_SCPU_CKSEL_reg   (*((volatile unsigned int*) SYS_SCPU_CKSEL_reg))
+#define SYS_SCPU_CKSEL_inst_adr                                                      "0x0012"
+#define SYS_SCPU_CKSEL_inst                                                          0x0012
+#define SYS_SCPU_CKSEL_CLKTRC_SEL_shift                                              (0)
+#define SYS_SCPU_CKSEL_CLKTRC_SEL_mask                                               (0x00000003)
+#define SYS_SCPU_CKSEL_CLKTRC_SEL(data)                                              (0x00000003&((data)<<0))
+#define SYS_SCPU_CKSEL_CLKTRC_SEL_src(data)                                          ((0x00000003&(data))>>0)
+#define SYS_SCPU_CKSEL_get_CLKTRC_SEL(data)                                          ((0x00000003&(data))>>0)
+
+
+#define SYS_VE_CKSEL                                                                 0x04C
+#define SYS_VE_CKSEL_reg_addr                                                        "0x9800004C"
+#define SYS_VE_CKSEL_reg                                                             0x9800004C
+#define set_SYS_VE_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_VE_CKSEL_reg)=data)
+#define get_SYS_VE_CKSEL_reg   (*((volatile unsigned int*) SYS_VE_CKSEL_reg))
+#define SYS_VE_CKSEL_inst_adr                                                        "0x0013"
+#define SYS_VE_CKSEL_inst                                                            0x0013
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel_shift                                           (6)
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel_mask                                            (0x000001C0)
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel(data)                                           (0x000001C0&((data)<<6))
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel_src(data)                                       ((0x000001C0&(data))>>6)
+#define SYS_VE_CKSEL_get_clk_ve2_bpu_sel(data)                                       ((0x000001C0&(data))>>6)
+#define SYS_VE_CKSEL_clk_ve3_sel_shift                                               (4)
+#define SYS_VE_CKSEL_clk_ve3_sel_mask                                                (0x00000030)
+#define SYS_VE_CKSEL_clk_ve3_sel(data)                                               (0x00000030&((data)<<4))
+#define SYS_VE_CKSEL_clk_ve3_sel_src(data)                                           ((0x00000030&(data))>>4)
+#define SYS_VE_CKSEL_get_clk_ve3_sel(data)                                           ((0x00000030&(data))>>4)
+#define SYS_VE_CKSEL_clk_ve2_sel_shift                                               (2)
+#define SYS_VE_CKSEL_clk_ve2_sel_mask                                                (0x0000000C)
+#define SYS_VE_CKSEL_clk_ve2_sel(data)                                               (0x0000000C&((data)<<2))
+#define SYS_VE_CKSEL_clk_ve2_sel_src(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_VE_CKSEL_get_clk_ve2_sel(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_VE_CKSEL_clk_ve1_sel_shift                                               (0)
+#define SYS_VE_CKSEL_clk_ve1_sel_mask                                                (0x00000003)
+#define SYS_VE_CKSEL_clk_ve1_sel(data)                                               (0x00000003&((data)<<0))
+#define SYS_VE_CKSEL_clk_ve1_sel_src(data)                                           ((0x00000003&(data))>>0)
+#define SYS_VE_CKSEL_get_clk_ve1_sel(data)                                           ((0x00000003&(data))>>0)
+
+
+#define SYS_SOFT_RESET4                                                              0x050
+#define SYS_SOFT_RESET4_reg_addr                                                     "0x98000050"
+#define SYS_SOFT_RESET4_reg                                                          0x98000050
+#define set_SYS_SOFT_RESET4_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET4_reg)=data)
+#define get_SYS_SOFT_RESET4_reg   (*((volatile unsigned int*) SYS_SOFT_RESET4_reg))
+#define SYS_SOFT_RESET4_inst_adr                                                     "0x0014"
+#define SYS_SOFT_RESET4_inst                                                         0x0014
+#define SYS_SOFT_RESET4_rstn_disp_shift                                              (15)
+#define SYS_SOFT_RESET4_rstn_disp_mask                                               (0x00008000)
+#define SYS_SOFT_RESET4_rstn_disp(data)                                              (0x00008000&((data)<<15))
+#define SYS_SOFT_RESET4_rstn_disp_src(data)                                          ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET4_get_rstn_disp(data)                                          ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET4_rstn_pcie1_phy_mdio_shift                                    (14)
+#define SYS_SOFT_RESET4_rstn_pcie1_phy_mdio_mask                                     (0x00004000)
+#define SYS_SOFT_RESET4_rstn_pcie1_phy_mdio(data)                                    (0x00004000&((data)<<14))
+#define SYS_SOFT_RESET4_rstn_pcie1_phy_mdio_src(data)                                ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET4_get_rstn_pcie1_phy_mdio(data)                                ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET4_rstn_pcie0_phy_mdio_shift                                    (13)
+#define SYS_SOFT_RESET4_rstn_pcie0_phy_mdio_mask                                     (0x00002000)
+#define SYS_SOFT_RESET4_rstn_pcie0_phy_mdio(data)                                    (0x00002000&((data)<<13))
+#define SYS_SOFT_RESET4_rstn_pcie0_phy_mdio_src(data)                                ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET4_get_rstn_pcie0_phy_mdio(data)                                ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET4_rstn_hdmirx_wrap_shift                                       (12)
+#define SYS_SOFT_RESET4_rstn_hdmirx_wrap_mask                                        (0x00001000)
+#define SYS_SOFT_RESET4_rstn_hdmirx_wrap(data)                                       (0x00001000&((data)<<12))
+#define SYS_SOFT_RESET4_rstn_hdmirx_wrap_src(data)                                   ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET4_get_rstn_hdmirx_wrap(data)                                   ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET4_rstn_fan_shift                                               (11)
+#define SYS_SOFT_RESET4_rstn_fan_mask                                                (0x00000800)
+#define SYS_SOFT_RESET4_rstn_fan(data)                                               (0x00000800&((data)<<11))
+#define SYS_SOFT_RESET4_rstn_fan_src(data)                                           ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET4_get_rstn_fan(data)                                           ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET4_rstn_sata_1_shift                                            (10)
+#define SYS_SOFT_RESET4_rstn_sata_1_mask                                             (0x00000400)
+#define SYS_SOFT_RESET4_rstn_sata_1(data)                                            (0x00000400&((data)<<10))
+#define SYS_SOFT_RESET4_rstn_sata_1_src(data)                                        ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET4_get_rstn_sata_1(data)                                        ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET4_rstn_sata_phy_1_shift                                        (9)
+#define SYS_SOFT_RESET4_rstn_sata_phy_1_mask                                         (0x00000200)
+#define SYS_SOFT_RESET4_rstn_sata_phy_1(data)                                        (0x00000200&((data)<<9))
+#define SYS_SOFT_RESET4_rstn_sata_phy_1_src(data)                                    ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET4_get_rstn_sata_phy_1(data)                                    ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET4_sata_func_exist_1_shift                                      (8)
+#define SYS_SOFT_RESET4_sata_func_exist_1_mask                                       (0x00000100)
+#define SYS_SOFT_RESET4_sata_func_exist_1(data)                                      (0x00000100&((data)<<8))
+#define SYS_SOFT_RESET4_sata_func_exist_1_src(data)                                  ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET4_get_sata_func_exist_1(data)                                  ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET4_rstn_sata_phy_pow_1_shift                                    (7)
+#define SYS_SOFT_RESET4_rstn_sata_phy_pow_1_mask                                     (0x00000080)
+#define SYS_SOFT_RESET4_rstn_sata_phy_pow_1(data)                                    (0x00000080&((data)<<7))
+#define SYS_SOFT_RESET4_rstn_sata_phy_pow_1_src(data)                                ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET4_get_rstn_sata_phy_pow_1(data)                                ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET4_rstn_cbusrx_shift                                            (6)
+#define SYS_SOFT_RESET4_rstn_cbusrx_mask                                             (0x00000040)
+#define SYS_SOFT_RESET4_rstn_cbusrx(data)                                            (0x00000040&((data)<<6))
+#define SYS_SOFT_RESET4_rstn_cbusrx_src(data)                                        ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET4_get_rstn_cbusrx(data)                                        ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET4_rstn_hdmirx_shift                                            (5)
+#define SYS_SOFT_RESET4_rstn_hdmirx_mask                                             (0x00000020)
+#define SYS_SOFT_RESET4_rstn_hdmirx(data)                                            (0x00000020&((data)<<5))
+#define SYS_SOFT_RESET4_rstn_hdmirx_src(data)                                        ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET4_get_rstn_hdmirx(data)                                        ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET4_rstn_dcphy_ssc_dig_shift                                     (4)
+#define SYS_SOFT_RESET4_rstn_dcphy_ssc_dig_mask                                      (0x00000010)
+#define SYS_SOFT_RESET4_rstn_dcphy_ssc_dig(data)                                     (0x00000010&((data)<<4))
+#define SYS_SOFT_RESET4_rstn_dcphy_ssc_dig_src(data)                                 ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET4_get_rstn_dcphy_ssc_dig(data)                                 ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET4_rstn_dcphy_ldo_shift                                         (3)
+#define SYS_SOFT_RESET4_rstn_dcphy_ldo_mask                                          (0x00000008)
+#define SYS_SOFT_RESET4_rstn_dcphy_ldo(data)                                         (0x00000008&((data)<<3))
+#define SYS_SOFT_RESET4_rstn_dcphy_ldo_src(data)                                     ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET4_get_rstn_dcphy_ldo(data)                                     ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET4_rstn_dcphy_ptr_shift                                         (2)
+#define SYS_SOFT_RESET4_rstn_dcphy_ptr_mask                                          (0x00000004)
+#define SYS_SOFT_RESET4_rstn_dcphy_ptr(data)                                         (0x00000004&((data)<<2))
+#define SYS_SOFT_RESET4_rstn_dcphy_ptr_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET4_get_rstn_dcphy_ptr(data)                                     ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET4_rstn_dcphy_alert_rx_shift                                    (1)
+#define SYS_SOFT_RESET4_rstn_dcphy_alert_rx_mask                                     (0x00000002)
+#define SYS_SOFT_RESET4_rstn_dcphy_alert_rx(data)                                    (0x00000002&((data)<<1))
+#define SYS_SOFT_RESET4_rstn_dcphy_alert_rx_src(data)                                ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET4_get_rstn_dcphy_alert_rx(data)                                ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET4_rstn_dcphy_crt_shift                                         (0)
+#define SYS_SOFT_RESET4_rstn_dcphy_crt_mask                                          (0x00000001)
+#define SYS_SOFT_RESET4_rstn_dcphy_crt(data)                                         (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET4_rstn_dcphy_crt_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET4_get_rstn_dcphy_crt(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_O_PCM_CK_CTL                                                         0x070
+#define SYS_AIO_O_PCM_CK_CTL_reg_addr                                                "0x98000070"
+#define SYS_AIO_O_PCM_CK_CTL_reg                                                     0x98000070
+#define set_SYS_AIO_O_PCM_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_O_PCM_CK_CTL_reg)=data)
+#define get_SYS_AIO_O_PCM_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_O_PCM_CK_CTL_reg))
+#define SYS_AIO_O_PCM_CK_CTL_inst_adr                                                "0x001C"
+#define SYS_AIO_O_PCM_CK_CTL_inst                                                    0x001C
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel_shift                                          (5)
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel_mask                                           (0x000000E0)
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel(data)                                          (0x000000E0&((data)<<5))
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel_src(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_O_PCM_CK_CTL_get_mclk_sel(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_O_PCM_CK_CTL_fs_shift                                                (1)
+#define SYS_AIO_O_PCM_CK_CTL_fs_mask                                                 (0x0000001E)
+#define SYS_AIO_O_PCM_CK_CTL_fs(data)                                                (0x0000001E&((data)<<1))
+#define SYS_AIO_O_PCM_CK_CTL_fs_src(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_PCM_CK_CTL_get_fs(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_PCM_CK_CTL_clken_shift                                             (0)
+#define SYS_AIO_O_PCM_CK_CTL_clken_mask                                              (0x00000001)
+#define SYS_AIO_O_PCM_CK_CTL_clken(data)                                             (0x00000001&((data)<<0))
+#define SYS_AIO_O_PCM_CK_CTL_clken_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_AIO_O_PCM_CK_CTL_get_clken(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_O_RAW_CK_CTL                                                         0x074
+#define SYS_AIO_O_RAW_CK_CTL_reg_addr                                                "0x98000074"
+#define SYS_AIO_O_RAW_CK_CTL_reg                                                     0x98000074
+#define set_SYS_AIO_O_RAW_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_O_RAW_CK_CTL_reg)=data)
+#define get_SYS_AIO_O_RAW_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_O_RAW_CK_CTL_reg))
+#define SYS_AIO_O_RAW_CK_CTL_inst_adr                                                "0x001D"
+#define SYS_AIO_O_RAW_CK_CTL_inst                                                    0x001D
+#define SYS_AIO_O_RAW_CK_CTL_fs_shift                                                (1)
+#define SYS_AIO_O_RAW_CK_CTL_fs_mask                                                 (0x0000001E)
+#define SYS_AIO_O_RAW_CK_CTL_fs(data)                                                (0x0000001E&((data)<<1))
+#define SYS_AIO_O_RAW_CK_CTL_fs_src(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW_CK_CTL_get_fs(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW_CK_CTL_clken_shift                                             (0)
+#define SYS_AIO_O_RAW_CK_CTL_clken_mask                                              (0x00000001)
+#define SYS_AIO_O_RAW_CK_CTL_clken(data)                                             (0x00000001&((data)<<0))
+#define SYS_AIO_O_RAW_CK_CTL_clken_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_AIO_O_RAW_CK_CTL_get_clken(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_O_RAW2_CK_CTL                                                        0x078
+#define SYS_AIO_O_RAW2_CK_CTL_reg_addr                                               "0x98000078"
+#define SYS_AIO_O_RAW2_CK_CTL_reg                                                    0x98000078
+#define set_SYS_AIO_O_RAW2_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_O_RAW2_CK_CTL_reg)=data)
+#define get_SYS_AIO_O_RAW2_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_O_RAW2_CK_CTL_reg))
+#define SYS_AIO_O_RAW2_CK_CTL_inst_adr                                               "0x001E"
+#define SYS_AIO_O_RAW2_CK_CTL_inst                                                   0x001E
+#define SYS_AIO_O_RAW2_CK_CTL_fs_shift                                               (1)
+#define SYS_AIO_O_RAW2_CK_CTL_fs_mask                                                (0x0000001E)
+#define SYS_AIO_O_RAW2_CK_CTL_fs(data)                                               (0x0000001E&((data)<<1))
+#define SYS_AIO_O_RAW2_CK_CTL_fs_src(data)                                           ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW2_CK_CTL_get_fs(data)                                           ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW2_CK_CTL_clken_shift                                            (0)
+#define SYS_AIO_O_RAW2_CK_CTL_clken_mask                                             (0x00000001)
+#define SYS_AIO_O_RAW2_CK_CTL_clken(data)                                            (0x00000001&((data)<<0))
+#define SYS_AIO_O_RAW2_CK_CTL_clken_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_AIO_O_RAW2_CK_CTL_get_clken(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_APS_CTL                                                                  0x07C
+#define SYS_APS_CTL_reg_addr                                                         "0x9800007C"
+#define SYS_APS_CTL_reg                                                              0x9800007C
+#define set_SYS_APS_CTL_reg(data)   (*((volatile unsigned int*) SYS_APS_CTL_reg)=data)
+#define get_SYS_APS_CTL_reg   (*((volatile unsigned int*) SYS_APS_CTL_reg))
+#define SYS_APS_CTL_inst_adr                                                         "0x001F"
+#define SYS_APS_CTL_inst                                                             0x001F
+#define SYS_APS_CTL_write_en2_shift                                                  (1)
+#define SYS_APS_CTL_write_en2_mask                                                   (0x00000002)
+#define SYS_APS_CTL_write_en2(data)                                                  (0x00000002&((data)<<1))
+#define SYS_APS_CTL_write_en2_src(data)                                              ((0x00000002&(data))>>1)
+#define SYS_APS_CTL_get_write_en2(data)                                              ((0x00000002&(data))>>1)
+#define SYS_APS_CTL_dds_rstn_shift                                                   (0)
+#define SYS_APS_CTL_dds_rstn_mask                                                    (0x00000001)
+#define SYS_APS_CTL_dds_rstn(data)                                                   (0x00000001&((data)<<0))
+#define SYS_APS_CTL_dds_rstn_src(data)                                               ((0x00000001&(data))>>0)
+#define SYS_APS_CTL_get_dds_rstn(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_I_PCM_CK_CTL                                                         0x080
+#define SYS_AIO_I_PCM_CK_CTL_reg_addr                                                "0x98000080"
+#define SYS_AIO_I_PCM_CK_CTL_reg                                                     0x98000080
+#define set_SYS_AIO_I_PCM_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_I_PCM_CK_CTL_reg)=data)
+#define get_SYS_AIO_I_PCM_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_I_PCM_CK_CTL_reg))
+#define SYS_AIO_I_PCM_CK_CTL_inst_adr                                                "0x0020"
+#define SYS_AIO_I_PCM_CK_CTL_inst                                                    0x0020
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel_shift                                          (5)
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel_mask                                           (0x000000E0)
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel(data)                                          (0x000000E0&((data)<<5))
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel_src(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_I_PCM_CK_CTL_get_mclk_sel(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_I_PCM_CK_CTL_fs_shift                                                (1)
+#define SYS_AIO_I_PCM_CK_CTL_fs_mask                                                 (0x0000001E)
+#define SYS_AIO_I_PCM_CK_CTL_fs(data)                                                (0x0000001E&((data)<<1))
+#define SYS_AIO_I_PCM_CK_CTL_fs_src(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_I_PCM_CK_CTL_get_fs(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_I_PCM_CK_CTL_clken_shift                                             (0)
+#define SYS_AIO_I_PCM_CK_CTL_clken_mask                                              (0x00000001)
+#define SYS_AIO_I_PCM_CK_CTL_clken(data)                                             (0x00000001&((data)<<0))
+#define SYS_AIO_I_PCM_CK_CTL_clken_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_AIO_I_PCM_CK_CTL_get_clken(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SCPU0                                                                0x100
+#define SYS_PLL_SCPU0_reg_addr                                                       "0x98000100"
+#define SYS_PLL_SCPU0_reg                                                            0x98000100
+#define set_SYS_PLL_SCPU0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SCPU0_reg)=data)
+#define get_SYS_PLL_SCPU0_reg   (*((volatile unsigned int*) SYS_PLL_SCPU0_reg))
+#define SYS_PLL_SCPU0_inst_adr                                                       "0x0040"
+#define SYS_PLL_SCPU0_inst                                                           0x0040
+#define SYS_PLL_SCPU0_REG_LDO18V_SEL_shift                                           (19)
+#define SYS_PLL_SCPU0_REG_LDO18V_SEL_mask                                            (0x00180000)
+#define SYS_PLL_SCPU0_REG_LDO18V_SEL(data)                                           (0x00180000&((data)<<19))
+#define SYS_PLL_SCPU0_REG_LDO18V_SEL_src(data)                                       ((0x00180000&(data))>>19)
+#define SYS_PLL_SCPU0_get_REG_LDO18V_SEL(data)                                       ((0x00180000&(data))>>19)
+#define SYS_PLL_SCPU0_REG_LDO10V_SEL_shift                                           (17)
+#define SYS_PLL_SCPU0_REG_LDO10V_SEL_mask                                            (0x00060000)
+#define SYS_PLL_SCPU0_REG_LDO10V_SEL(data)                                           (0x00060000&((data)<<17))
+#define SYS_PLL_SCPU0_REG_LDO10V_SEL_src(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_SCPU0_get_REG_LDO10V_SEL(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_SCPU0_REG_TESTSEL_PLLA_shift                                         (16)
+#define SYS_PLL_SCPU0_REG_TESTSEL_PLLA_mask                                          (0x00010000)
+#define SYS_PLL_SCPU0_REG_TESTSEL_PLLA(data)                                         (0x00010000&((data)<<16))
+#define SYS_PLL_SCPU0_REG_TESTSEL_PLLA_src(data)                                     ((0x00010000&(data))>>16)
+#define SYS_PLL_SCPU0_get_REG_TESTSEL_PLLA(data)                                     ((0x00010000&(data))>>16)
+#define SYS_PLL_SCPU0_REG_WD_SET_PLLA_shift                                          (14)
+#define SYS_PLL_SCPU0_REG_WD_SET_PLLA_mask                                           (0x00004000)
+#define SYS_PLL_SCPU0_REG_WD_SET_PLLA(data)                                          (0x00004000&((data)<<14))
+#define SYS_PLL_SCPU0_REG_WD_SET_PLLA_src(data)                                      ((0x00004000&(data))>>14)
+#define SYS_PLL_SCPU0_get_REG_WD_SET_PLLA(data)                                      ((0x00004000&(data))>>14)
+#define SYS_PLL_SCPU0_REG_WD_RST_PLLA_shift                                          (13)
+#define SYS_PLL_SCPU0_REG_WD_RST_PLLA_mask                                           (0x00002000)
+#define SYS_PLL_SCPU0_REG_WD_RST_PLLA(data)                                          (0x00002000&((data)<<13))
+#define SYS_PLL_SCPU0_REG_WD_RST_PLLA_src(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PLL_SCPU0_get_REG_WD_RST_PLLA(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PLL_SCPU0_REG_SEL_CCO_PLLA_shift                                         (12)
+#define SYS_PLL_SCPU0_REG_SEL_CCO_PLLA_mask                                          (0x00001000)
+#define SYS_PLL_SCPU0_REG_SEL_CCO_PLLA(data)                                         (0x00001000&((data)<<12))
+#define SYS_PLL_SCPU0_REG_SEL_CCO_PLLA_src(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PLL_SCPU0_get_REG_SEL_CCO_PLLA(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PLL_SCPU0_REG_SCPU_DBUG_EN_PLLA_shift                                    (11)
+#define SYS_PLL_SCPU0_REG_SCPU_DBUG_EN_PLLA_mask                                     (0x00000800)
+#define SYS_PLL_SCPU0_REG_SCPU_DBUG_EN_PLLA(data)                                    (0x00000800&((data)<<11))
+#define SYS_PLL_SCPU0_REG_SCPU_DBUG_EN_PLLA_src(data)                                ((0x00000800&(data))>>11)
+#define SYS_PLL_SCPU0_get_REG_SCPU_DBUG_EN_PLLA(data)                                ((0x00000800&(data))>>11)
+#define SYS_PLL_SCPU0_REG_LPF_RS_PLLA_shift                                          (8)
+#define SYS_PLL_SCPU0_REG_LPF_RS_PLLA_mask                                           (0x00000700)
+#define SYS_PLL_SCPU0_REG_LPF_RS_PLLA(data)                                          (0x00000700&((data)<<8))
+#define SYS_PLL_SCPU0_REG_LPF_RS_PLLA_src(data)                                      ((0x00000700&(data))>>8)
+#define SYS_PLL_SCPU0_get_REG_LPF_RS_PLLA(data)                                      ((0x00000700&(data))>>8)
+#define SYS_PLL_SCPU0_REG_LPF_CS_PLLA_shift                                          (6)
+#define SYS_PLL_SCPU0_REG_LPF_CS_PLLA_mask                                           (0x000000C0)
+#define SYS_PLL_SCPU0_REG_LPF_CS_PLLA(data)                                          (0x000000C0&((data)<<6))
+#define SYS_PLL_SCPU0_REG_LPF_CS_PLLA_src(data)                                      ((0x000000C0&(data))>>6)
+#define SYS_PLL_SCPU0_get_REG_LPF_CS_PLLA(data)                                      ((0x000000C0&(data))>>6)
+#define SYS_PLL_SCPU0_REG_ICP_PLLA_shift                                             (3)
+#define SYS_PLL_SCPU0_REG_ICP_PLLA_mask                                              (0x00000038)
+#define SYS_PLL_SCPU0_REG_ICP_PLLA(data)                                             (0x00000038&((data)<<3))
+#define SYS_PLL_SCPU0_REG_ICP_PLLA_src(data)                                         ((0x00000038&(data))>>3)
+#define SYS_PLL_SCPU0_get_REG_ICP_PLLA(data)                                         ((0x00000038&(data))>>3)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_BPS_PLLA_shift                                  (2)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_BPS_PLLA_mask                                   (0x00000004)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_BPS_PLLA(data)                                  (0x00000004&((data)<<2))
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_BPS_PLLA_src(data)                              ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU0_get_REG_DIV_PREDIV_BPS_PLLA(data)                              ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_SEL_PLLA_shift                                  (0)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_SEL_PLLA_mask                                   (0x00000003)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_SEL_PLLA(data)                                  (0x00000003&((data)<<0))
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_SEL_PLLA_src(data)                              ((0x00000003&(data))>>0)
+#define SYS_PLL_SCPU0_get_REG_DIV_PREDIV_SEL_PLLA(data)                              ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_SCPU1                                                                0x104
+#define SYS_PLL_SCPU1_reg_addr                                                       "0x98000104"
+#define SYS_PLL_SCPU1_reg                                                            0x98000104
+#define set_SYS_PLL_SCPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SCPU1_reg)=data)
+#define get_SYS_PLL_SCPU1_reg   (*((volatile unsigned int*) SYS_PLL_SCPU1_reg))
+#define SYS_PLL_SCPU1_inst_adr                                                       "0x0041"
+#define SYS_PLL_SCPU1_inst                                                           0x0041
+#define SYS_PLL_SCPU1_REG_OEB_PLLA_shift                                             (2)
+#define SYS_PLL_SCPU1_REG_OEB_PLLA_mask                                              (0x00000004)
+#define SYS_PLL_SCPU1_REG_OEB_PLLA(data)                                             (0x00000004&((data)<<2))
+#define SYS_PLL_SCPU1_REG_OEB_PLLA_src(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU1_get_REG_OEB_PLLA(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU1_SCPU_RSTB_PLLA_shift                                           (1)
+#define SYS_PLL_SCPU1_SCPU_RSTB_PLLA_mask                                            (0x00000002)
+#define SYS_PLL_SCPU1_SCPU_RSTB_PLLA(data)                                           (0x00000002&((data)<<1))
+#define SYS_PLL_SCPU1_SCPU_RSTB_PLLA_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_SCPU1_get_SCPU_RSTB_PLLA(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_SCPU1_SCPU_POW_PLLA_shift                                            (0)
+#define SYS_PLL_SCPU1_SCPU_POW_PLLA_mask                                             (0x00000001)
+#define SYS_PLL_SCPU1_SCPU_POW_PLLA(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_SCPU1_SCPU_POW_PLLA_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_SCPU1_get_SCPU_POW_PLLA(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_ACPU1                                                                0x10C
+#define SYS_PLL_ACPU1_reg_addr                                                       "0x9800010C"
+#define SYS_PLL_ACPU1_reg                                                            0x9800010C
+#define set_SYS_PLL_ACPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_ACPU1_reg)=data)
+#define get_SYS_PLL_ACPU1_reg   (*((volatile unsigned int*) SYS_PLL_ACPU1_reg))
+#define SYS_PLL_ACPU1_inst_adr                                                       "0x0043"
+#define SYS_PLL_ACPU1_inst                                                           0x0043
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_shift                                         (17)
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_mask                                          (0x00060000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV(data)                                         (0x00060000&((data)<<17))
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_src(data)                                     ((0x00060000&(data))>>17)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_PDIV(data)                                     ((0x00060000&(data))>>17)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_RS_shift                                       (14)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_RS_mask                                        (0x0001C000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_RS(data)                                       (0x0001C000&((data)<<14))
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_RS_src(data)                                   ((0x0001C000&(data))>>14)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_LPF_RS(data)                                   ((0x0001C000&(data))>>14)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_CS_shift                                       (12)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_CS_mask                                        (0x00003000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_CS(data)                                       (0x00003000&((data)<<12))
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_CS_src(data)                                   ((0x00003000&(data))>>12)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_LPF_CS(data)                                   ((0x00003000&(data))>>12)
+#define SYS_PLL_ACPU1_REG_PLLACPU_ICP_shift                                          (9)
+#define SYS_PLL_ACPU1_REG_PLLACPU_ICP_mask                                           (0x00000E00)
+#define SYS_PLL_ACPU1_REG_PLLACPU_ICP(data)                                          (0x00000E00&((data)<<9))
+#define SYS_PLL_ACPU1_REG_PLLACPU_ICP_src(data)                                      ((0x00000E00&(data))>>9)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_ICP(data)                                      ((0x00000E00&(data))>>9)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST_shift                                        (8)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST_mask                                         (0x00000100)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST(data)                                        (0x00000100&((data)<<8))
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_WDRST(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET_shift                                        (7)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET_mask                                         (0x00000080)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET(data)                                        (0x00000080&((data)<<7))
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET_src(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_WDSET(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_ACPU1_REG_PLLACPU_TESTSEL_shift                                      (6)
+#define SYS_PLL_ACPU1_REG_PLLACPU_TESTSEL_mask                                       (0x00000040)
+#define SYS_PLL_ACPU1_REG_PLLACPU_TESTSEL(data)                                      (0x00000040&((data)<<6))
+#define SYS_PLL_ACPU1_REG_PLLACPU_TESTSEL_src(data)                                  ((0x00000040&(data))>>6)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_TESTSEL(data)                                  ((0x00000040&(data))>>6)
+#define SYS_PLL_ACPU1_REG_PLLACPU_SEL_CCO_shift                                      (5)
+#define SYS_PLL_ACPU1_REG_PLLACPU_SEL_CCO_mask                                       (0x00000020)
+#define SYS_PLL_ACPU1_REG_PLLACPU_SEL_CCO(data)                                      (0x00000020&((data)<<5))
+#define SYS_PLL_ACPU1_REG_PLLACPU_SEL_CCO_src(data)                                  ((0x00000020&(data))>>5)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_SEL_CCO(data)                                  ((0x00000020&(data))>>5)
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_BPS_shift                                     (4)
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_BPS_mask                                      (0x00000010)
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_BPS(data)                                     (0x00000010&((data)<<4))
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_BPS_src(data)                                 ((0x00000010&(data))>>4)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_PDIV_BPS(data)                                 ((0x00000010&(data))>>4)
+#define SYS_PLL_ACPU1_REG_PLLACPU_DBUG_EN_shift                                      (3)
+#define SYS_PLL_ACPU1_REG_PLLACPU_DBUG_EN_mask                                       (0x00000008)
+#define SYS_PLL_ACPU1_REG_PLLACPU_DBUG_EN(data)                                      (0x00000008&((data)<<3))
+#define SYS_PLL_ACPU1_REG_PLLACPU_DBUG_EN_src(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_DBUG_EN(data)                                  ((0x00000008&(data))>>3)
+
+
+#define SYS_PLL_ACPU2                                                                0x110
+#define SYS_PLL_ACPU2_reg_addr                                                       "0x98000110"
+#define SYS_PLL_ACPU2_reg                                                            0x98000110
+#define set_SYS_PLL_ACPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_ACPU2_reg)=data)
+#define get_SYS_PLL_ACPU2_reg   (*((volatile unsigned int*) SYS_PLL_ACPU2_reg))
+#define SYS_PLL_ACPU2_inst_adr                                                       "0x0044"
+#define SYS_PLL_ACPU2_inst                                                           0x0044
+#define SYS_PLL_ACPU2_REG_PLLACPU_OEB_shift                                          (2)
+#define SYS_PLL_ACPU2_REG_PLLACPU_OEB_mask                                           (0x00000004)
+#define SYS_PLL_ACPU2_REG_PLLACPU_OEB(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_ACPU2_REG_PLLACPU_OEB_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_ACPU2_get_REG_PLLACPU_OEB(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_ACPU2_REG_PLLACPU_RSTB_shift                                         (1)
+#define SYS_PLL_ACPU2_REG_PLLACPU_RSTB_mask                                          (0x00000002)
+#define SYS_PLL_ACPU2_REG_PLLACPU_RSTB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_ACPU2_REG_PLLACPU_RSTB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_ACPU2_get_REG_PLLACPU_RSTB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_ACPU2_REG_PLLACPU_POW_shift                                          (0)
+#define SYS_PLL_ACPU2_REG_PLLACPU_POW_mask                                           (0x00000001)
+#define SYS_PLL_ACPU2_REG_PLLACPU_POW(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_ACPU2_REG_PLLACPU_POW_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_ACPU2_get_REG_PLLACPU_POW(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VE1_1                                                                0x114
+#define SYS_PLL_VE1_1_reg_addr                                                       "0x98000114"
+#define SYS_PLL_VE1_1_reg                                                            0x98000114
+#define set_SYS_PLL_VE1_1_reg(data)   (*((volatile unsigned int*) SYS_PLL_VE1_1_reg)=data)
+#define get_SYS_PLL_VE1_1_reg   (*((volatile unsigned int*) SYS_PLL_VE1_1_reg))
+#define SYS_PLL_VE1_1_inst_adr                                                       "0x0045"
+#define SYS_PLL_VE1_1_inst                                                           0x0045
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDRST_shift                                        (22)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDRST_mask                                         (0x00400000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDRST(data)                                        (0x00400000&((data)<<22))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDRST_src(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_WDRST(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDSET_shift                                        (21)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDSET_mask                                         (0x00200000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDSET(data)                                        (0x00200000&((data)<<21))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDSET_src(data)                                    ((0x00200000&(data))>>21)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_WDSET(data)                                    ((0x00200000&(data))>>21)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_CS_shift                                           (19)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_CS_mask                                            (0x00180000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_CS(data)                                           (0x00180000&((data)<<19))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_CS_src(data)                                       ((0x00180000&(data))>>19)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_CS(data)                                       ((0x00180000&(data))>>19)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_O_shift                                            (17)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_O_mask                                             (0x00060000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_O(data)                                            (0x00060000&((data)<<17))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_O_src(data)                                        ((0x00060000&(data))>>17)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_O(data)                                        ((0x00060000&(data))>>17)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_RS_shift                                           (14)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_RS_mask                                            (0x0001C000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_RS(data)                                           (0x0001C000&((data)<<14))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_RS_src(data)                                       ((0x0001C000&(data))>>14)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_RS(data)                                       ((0x0001C000&(data))>>14)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_N_shift                                            (12)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_N_mask                                             (0x00003000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_N(data)                                            (0x00003000&((data)<<12))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_N_src(data)                                        ((0x00003000&(data))>>12)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_N(data)                                        ((0x00003000&(data))>>12)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_M_shift                                            (4)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_M_mask                                             (0x00000FF0)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_M(data)                                            (0x00000FF0&((data)<<4))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_M_src(data)                                        ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_M(data)                                        ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_IP_shift                                           (1)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_IP_mask                                            (0x0000000E)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_IP(data)                                           (0x0000000E&((data)<<1))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_IP_src(data)                                       ((0x0000000E&(data))>>1)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_IP(data)                                       ((0x0000000E&(data))>>1)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_TST_shift                                          (0)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_TST_mask                                           (0x00000001)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_TST(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_TST_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_TST(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VE1_2                                                                0x118
+#define SYS_PLL_VE1_2_reg_addr                                                       "0x98000118"
+#define SYS_PLL_VE1_2_reg                                                            0x98000118
+#define set_SYS_PLL_VE1_2_reg(data)   (*((volatile unsigned int*) SYS_PLL_VE1_2_reg)=data)
+#define get_SYS_PLL_VE1_2_reg   (*((volatile unsigned int*) SYS_PLL_VE1_2_reg))
+#define SYS_PLL_VE1_2_inst_adr                                                       "0x0046"
+#define SYS_PLL_VE1_2_inst                                                           0x0046
+#define SYS_PLL_VE1_2_REG_PLLVCPU_OEB_shift                                          (2)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_OEB_mask                                           (0x00000004)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_OEB(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_VE1_2_REG_PLLVCPU_OEB_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_VE1_2_get_REG_PLLVCPU_OEB(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_RSTB_shift                                         (1)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_RSTB_mask                                          (0x00000002)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_RSTB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_VE1_2_REG_PLLVCPU_RSTB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_VE1_2_get_REG_PLLVCPU_RSTB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_POW_shift                                          (0)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_POW_mask                                           (0x00000001)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_POW(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_VE1_2_REG_PLLVCPU_POW_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_VE1_2_get_REG_PLLVCPU_POW(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DDSA1                                                                0x120
+#define SYS_PLL_DDSA1_reg_addr                                                       "0x98000120"
+#define SYS_PLL_DDSA1_reg                                                            0x98000120
+#define set_SYS_PLL_DDSA1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDSA1_reg)=data)
+#define get_SYS_PLL_DDSA1_reg   (*((volatile unsigned int*) SYS_PLL_DDSA1_reg))
+#define SYS_PLL_DDSA1_inst_adr                                                       "0x0048"
+#define SYS_PLL_DDSA1_inst                                                           0x0048
+#define SYS_PLL_DDSA1_REG_PLLDDSA_WDMODE_shift                                       (23)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_WDMODE_mask                                        (0x01800000)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_WDMODE(data)                                       (0x01800000&((data)<<23))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_WDMODE_src(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_WDMODE(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_RS_shift                                           (20)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_RS_mask                                            (0x00700000)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_RS(data)                                           (0x00700000&((data)<<20))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_RS_src(data)                                       ((0x00700000&(data))>>20)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_RS(data)                                       ((0x00700000&(data))>>20)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_O_shift                                            (18)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_O_mask                                             (0x000C0000)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_O(data)                                            (0x000C0000&((data)<<18))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_O_src(data)                                        ((0x000C0000&(data))>>18)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_O(data)                                        ((0x000C0000&(data))>>18)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_N_shift                                            (16)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_N_mask                                             (0x00030000)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_N(data)                                            (0x00030000&((data)<<16))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_N_src(data)                                        ((0x00030000&(data))>>16)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_N(data)                                        ((0x00030000&(data))>>16)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_IP_shift                                           (12)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_IP_mask                                            (0x0000F000)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_IP(data)                                           (0x0000F000&((data)<<12))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_IP_src(data)                                       ((0x0000F000&(data))>>12)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_IP(data)                                       ((0x0000F000&(data))>>12)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CS_shift                                           (10)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CS_mask                                            (0x00000C00)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CS(data)                                           (0x00000C00&((data)<<10))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CS_src(data)                                       ((0x00000C00&(data))>>10)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_CS(data)                                       ((0x00000C00&(data))>>10)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CP_shift                                           (8)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CP_mask                                            (0x00000300)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CP(data)                                           (0x00000300&((data)<<8))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CP_src(data)                                       ((0x00000300&(data))>>8)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_CP(data)                                       ((0x00000300&(data))>>8)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_VCORB_shift                                        (7)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_VCORB_mask                                         (0x00000080)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_VCORB(data)                                        (0x00000080&((data)<<7))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_VCORB_src(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_VCORB(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_TST_shift                                          (6)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_TST_mask                                           (0x00000040)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_TST(data)                                          (0x00000040&((data)<<6))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_TST_src(data)                                      ((0x00000040&(data))>>6)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_TST(data)                                      ((0x00000040&(data))>>6)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_PSTST_shift                                        (5)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_PSTST_mask                                         (0x00000020)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_PSTST(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_PSTST_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_PSTST(data)                                    ((0x00000020&(data))>>5)
+
+
+#define SYS_PLL_DDSA2                                                                0x128
+#define SYS_PLL_DDSA2_reg_addr                                                       "0x98000128"
+#define SYS_PLL_DDSA2_reg                                                            0x98000128
+#define set_SYS_PLL_DDSA2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDSA2_reg)=data)
+#define get_SYS_PLL_DDSA2_reg   (*((volatile unsigned int*) SYS_PLL_DDSA2_reg))
+#define SYS_PLL_DDSA2_inst_adr                                                       "0x004A"
+#define SYS_PLL_DDSA2_inst                                                           0x004A
+#define SYS_PLL_DDSA2_REG_PLLDDSA_OEB_shift                                          (2)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_OEB_mask                                           (0x00000004)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_OEB(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_DDSA2_REG_PLLDDSA_OEB_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DDSA2_get_REG_PLLDDSA_OEB(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_RSTB_shift                                         (1)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_RSTB_mask                                          (0x00000002)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_RSTB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_DDSA2_REG_PLLDDSA_RSTB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DDSA2_get_REG_PLLDDSA_RSTB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_POW_shift                                          (0)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_POW_mask                                           (0x00000001)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_POW(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_DDSA2_REG_PLLDDSA_POW_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_DDSA2_get_REG_PLLDDSA_POW(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PSAUDA1                                                              0x130
+#define SYS_PLL_PSAUDA1_reg_addr                                                     "0x98000130"
+#define SYS_PLL_PSAUDA1_reg                                                          0x98000130
+#define set_SYS_PLL_PSAUDA1_reg(data)   (*((volatile unsigned int*) SYS_PLL_PSAUDA1_reg)=data)
+#define get_SYS_PLL_PSAUDA1_reg   (*((volatile unsigned int*) SYS_PLL_PSAUDA1_reg))
+#define SYS_PLL_PSAUDA1_inst_adr                                                     "0x004C"
+#define SYS_PLL_PSAUDA1_inst                                                         0x004C
+#define SYS_PLL_PSAUDA1_write_en11_shift                                             (28)
+#define SYS_PLL_PSAUDA1_write_en11_mask                                              (0x10000000)
+#define SYS_PLL_PSAUDA1_write_en11(data)                                             (0x10000000&((data)<<28))
+#define SYS_PLL_PSAUDA1_write_en11_src(data)                                         ((0x10000000&(data))>>28)
+#define SYS_PLL_PSAUDA1_get_write_en11(data)                                         ((0x10000000&(data))>>28)
+#define SYS_PLL_PSAUDA1_psaud_1a_phase_sel_shift                                     (27)
+#define SYS_PLL_PSAUDA1_psaud_1a_phase_sel_mask                                      (0x08000000)
+#define SYS_PLL_PSAUDA1_psaud_1a_phase_sel(data)                                     (0x08000000&((data)<<27))
+#define SYS_PLL_PSAUDA1_psaud_1a_phase_sel_src(data)                                 ((0x08000000&(data))>>27)
+#define SYS_PLL_PSAUDA1_get_psaud_1a_phase_sel(data)                                 ((0x08000000&(data))>>27)
+#define SYS_PLL_PSAUDA1_psaud_2a_phase_sel_shift                                     (26)
+#define SYS_PLL_PSAUDA1_psaud_2a_phase_sel_mask                                      (0x04000000)
+#define SYS_PLL_PSAUDA1_psaud_2a_phase_sel(data)                                     (0x04000000&((data)<<26))
+#define SYS_PLL_PSAUDA1_psaud_2a_phase_sel_src(data)                                 ((0x04000000&(data))>>26)
+#define SYS_PLL_PSAUDA1_get_psaud_2a_phase_sel(data)                                 ((0x04000000&(data))>>26)
+#define SYS_PLL_PSAUDA1_write_en10_shift                                             (25)
+#define SYS_PLL_PSAUDA1_write_en10_mask                                              (0x02000000)
+#define SYS_PLL_PSAUDA1_write_en10(data)                                             (0x02000000&((data)<<25))
+#define SYS_PLL_PSAUDA1_write_en10_src(data)                                         ((0x02000000&(data))>>25)
+#define SYS_PLL_PSAUDA1_get_write_en10(data)                                         ((0x02000000&(data))>>25)
+#define SYS_PLL_PSAUDA1_pcr_a_smooth_en_shift                                        (24)
+#define SYS_PLL_PSAUDA1_pcr_a_smooth_en_mask                                         (0x01000000)
+#define SYS_PLL_PSAUDA1_pcr_a_smooth_en(data)                                        (0x01000000&((data)<<24))
+#define SYS_PLL_PSAUDA1_pcr_a_smooth_en_src(data)                                    ((0x01000000&(data))>>24)
+#define SYS_PLL_PSAUDA1_get_pcr_a_smooth_en(data)                                    ((0x01000000&(data))>>24)
+#define SYS_PLL_PSAUDA1_write_en9_shift                                              (23)
+#define SYS_PLL_PSAUDA1_write_en9_mask                                               (0x00800000)
+#define SYS_PLL_PSAUDA1_write_en9(data)                                              (0x00800000&((data)<<23))
+#define SYS_PLL_PSAUDA1_write_en9_src(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PLL_PSAUDA1_get_write_en9(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PLL_PSAUDA1_pcr_a_phase_sel_shift                                        (22)
+#define SYS_PLL_PSAUDA1_pcr_a_phase_sel_mask                                         (0x00400000)
+#define SYS_PLL_PSAUDA1_pcr_a_phase_sel(data)                                        (0x00400000&((data)<<22))
+#define SYS_PLL_PSAUDA1_pcr_a_phase_sel_src(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_PSAUDA1_get_pcr_a_phase_sel(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_PSAUDA1_write_en8_shift                                              (21)
+#define SYS_PLL_PSAUDA1_write_en8_mask                                               (0x00200000)
+#define SYS_PLL_PSAUDA1_write_en8(data)                                              (0x00200000&((data)<<21))
+#define SYS_PLL_PSAUDA1_write_en8_src(data)                                          ((0x00200000&(data))>>21)
+#define SYS_PLL_PSAUDA1_get_write_en8(data)                                          ((0x00200000&(data))>>21)
+#define SYS_PLL_PSAUDA1_pcr_a_ctl_en_shift                                           (20)
+#define SYS_PLL_PSAUDA1_pcr_a_ctl_en_mask                                            (0x00100000)
+#define SYS_PLL_PSAUDA1_pcr_a_ctl_en(data)                                           (0x00100000&((data)<<20))
+#define SYS_PLL_PSAUDA1_pcr_a_ctl_en_src(data)                                       ((0x00100000&(data))>>20)
+#define SYS_PLL_PSAUDA1_get_pcr_a_ctl_en(data)                                       ((0x00100000&(data))>>20)
+#define SYS_PLL_PSAUDA1_write_en3_shift                                              (10)
+#define SYS_PLL_PSAUDA1_write_en3_mask                                               (0x00000400)
+#define SYS_PLL_PSAUDA1_write_en3(data)                                              (0x00000400&((data)<<10))
+#define SYS_PLL_PSAUDA1_write_en3_src(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PLL_PSAUDA1_get_write_en3(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_FUPDN_shift                                      (9)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_FUPDN_mask                                       (0x00000200)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_FUPDN(data)                                      (0x00000200&((data)<<9))
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_FUPDN_src(data)                                  ((0x00000200&(data))>>9)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD1A_FUPDN(data)                                  ((0x00000200&(data))>>9)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_DIV_shift                                        (8)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_DIV_mask                                         (0x00000100)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_DIV(data)                                        (0x00000100&((data)<<8))
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_DIV_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD1A_DIV(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_PSAUDA1_write_en2_shift                                              (7)
+#define SYS_PLL_PSAUDA1_write_en2_mask                                               (0x00000080)
+#define SYS_PLL_PSAUDA1_write_en2(data)                                              (0x00000080&((data)<<7))
+#define SYS_PLL_PSAUDA1_write_en2_src(data)                                          ((0x00000080&(data))>>7)
+#define SYS_PLL_PSAUDA1_get_write_en2(data)                                          ((0x00000080&(data))>>7)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_TST_shift                                        (6)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_TST_mask                                         (0x00000040)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_TST(data)                                        (0x00000040&((data)<<6))
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_TST_src(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD1A_TST(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_PSEN_shift                                       (5)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_PSEN_mask                                        (0x00000020)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_PSEN(data)                                       (0x00000020&((data)<<5))
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_PSEN_src(data)                                   ((0x00000020&(data))>>5)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD1A_PSEN(data)                                   ((0x00000020&(data))>>5)
+#define SYS_PLL_PSAUDA1_write_en1_shift                                              (4)
+#define SYS_PLL_PSAUDA1_write_en1_mask                                               (0x00000010)
+#define SYS_PLL_PSAUDA1_write_en1(data)                                              (0x00000010&((data)<<4))
+#define SYS_PLL_PSAUDA1_write_en1_src(data)                                          ((0x00000010&(data))>>4)
+#define SYS_PLL_PSAUDA1_get_write_en1(data)                                          ((0x00000010&(data))>>4)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_FUPDN_shift                                      (3)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_FUPDN_mask                                       (0x00000008)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_FUPDN(data)                                      (0x00000008&((data)<<3))
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_FUPDN_src(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD2A_FUPDN(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_DIV_shift                                        (2)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_DIV_mask                                         (0x00000004)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_DIV(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_DIV_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD2A_DIV(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_TST_shift                                        (1)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_TST_mask                                         (0x00000002)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_TST(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_TST_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD2A_TST(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_PSEN_shift                                       (0)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_PSEN_mask                                        (0x00000001)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_PSEN(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_PSEN_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD2A_PSEN(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PSAUDA2                                                              0x134
+#define SYS_PLL_PSAUDA2_reg_addr                                                     "0x98000134"
+#define SYS_PLL_PSAUDA2_reg                                                          0x98000134
+#define set_SYS_PLL_PSAUDA2_reg(data)   (*((volatile unsigned int*) SYS_PLL_PSAUDA2_reg)=data)
+#define get_SYS_PLL_PSAUDA2_reg   (*((volatile unsigned int*) SYS_PLL_PSAUDA2_reg))
+#define SYS_PLL_PSAUDA2_inst_adr                                                     "0x004D"
+#define SYS_PLL_PSAUDA2_inst                                                         0x004D
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_OEB_shift                                        (3)
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_OEB_mask                                         (0x00000008)
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_OEB(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_OEB_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDA2_get_REG_PSAUD1A_OEB(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_RSTB_shift                                       (2)
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_RSTB_mask                                        (0x00000004)
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_RSTB(data)                                       (0x00000004&((data)<<2))
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_RSTB_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDA2_get_REG_PSAUD1A_RSTB(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_OEB_shift                                        (1)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_OEB_mask                                         (0x00000002)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_OEB(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_OEB_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDA2_get_REG_PSAUD2A_OEB(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_RSTB_shift                                       (0)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_RSTB_mask                                        (0x00000001)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_RSTB(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_RSTB_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_PSAUDA2_get_REG_PSAUD2A_RSTB(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_HD1                                                             0x138
+#define SYS_PLL_DISP_HD1_reg_addr                                                    "0x98000138"
+#define SYS_PLL_DISP_HD1_reg                                                         0x98000138
+#define set_SYS_PLL_DISP_HD1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_HD1_reg)=data)
+#define get_SYS_PLL_DISP_HD1_reg   (*((volatile unsigned int*) SYS_PLL_DISP_HD1_reg))
+#define SYS_PLL_DISP_HD1_inst_adr                                                    "0x004E"
+#define SYS_PLL_DISP_HD1_inst                                                        0x004E
+#define SYS_PLL_DISP_HD1_reserved_pll_disp_hd1_shift                                 (0)
+#define SYS_PLL_DISP_HD1_reserved_pll_disp_hd1_mask                                  (0x00000001)
+#define SYS_PLL_DISP_HD1_reserved_pll_disp_hd1(data)                                 (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_HD1_reserved_pll_disp_hd1_src(data)                             ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_HD1_get_reserved_pll_disp_hd1(data)                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_HD2                                                             0x13c
+#define SYS_PLL_DISP_HD2_reg_addr                                                    "0x9800013C"
+#define SYS_PLL_DISP_HD2_reg                                                         0x9800013C
+#define set_SYS_PLL_DISP_HD2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_HD2_reg)=data)
+#define get_SYS_PLL_DISP_HD2_reg   (*((volatile unsigned int*) SYS_PLL_DISP_HD2_reg))
+#define SYS_PLL_DISP_HD2_inst_adr                                                    "0x004F"
+#define SYS_PLL_DISP_HD2_inst                                                        0x004F
+#define SYS_PLL_DISP_HD2_reserved_pll_disp_hd2_shift                                 (0)
+#define SYS_PLL_DISP_HD2_reserved_pll_disp_hd2_mask                                  (0x00000001)
+#define SYS_PLL_DISP_HD2_reserved_pll_disp_hd2(data)                                 (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_HD2_reserved_pll_disp_hd2_src(data)                             ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_HD2_get_reserved_pll_disp_hd2(data)                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL1_TEST                                                                0x140
+#define SYS_PLL1_TEST_reg_addr                                                       "0x98000140"
+#define SYS_PLL1_TEST_reg                                                            0x98000140
+#define set_SYS_PLL1_TEST_reg(data)   (*((volatile unsigned int*) SYS_PLL1_TEST_reg)=data)
+#define get_SYS_PLL1_TEST_reg   (*((volatile unsigned int*) SYS_PLL1_TEST_reg))
+#define SYS_PLL1_TEST_inst_adr                                                       "0x0050"
+#define SYS_PLL1_TEST_inst                                                           0x0050
+#define SYS_PLL1_TEST_REG_PLLTST_POW_shift                                           (4)
+#define SYS_PLL1_TEST_REG_PLLTST_POW_mask                                            (0x00000010)
+#define SYS_PLL1_TEST_REG_PLLTST_POW(data)                                           (0x00000010&((data)<<4))
+#define SYS_PLL1_TEST_REG_PLLTST_POW_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PLL1_TEST_get_REG_PLLTST_POW(data)                                       ((0x00000010&(data))>>4)
+
+
+#define SYS_PLL_BUS1                                                                 0x164
+#define SYS_PLL_BUS1_reg_addr                                                        "0x98000164"
+#define SYS_PLL_BUS1_reg                                                             0x98000164
+#define set_SYS_PLL_BUS1_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUS1_reg)=data)
+#define get_SYS_PLL_BUS1_reg   (*((volatile unsigned int*) SYS_PLL_BUS1_reg))
+#define SYS_PLL_BUS1_inst_adr                                                        "0x0059"
+#define SYS_PLL_BUS1_inst                                                            0x0059
+#define SYS_PLL_BUS1_REG_PLLBUS_RESER_shift                                          (19)
+#define SYS_PLL_BUS1_REG_PLLBUS_RESER_mask                                           (0x07F80000)
+#define SYS_PLL_BUS1_REG_PLLBUS_RESER(data)                                          (0x07F80000&((data)<<19))
+#define SYS_PLL_BUS1_REG_PLLBUS_RESER_src(data)                                      ((0x07F80000&(data))>>19)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_RESER(data)                                      ((0x07F80000&(data))>>19)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_shift                                           (17)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_mask                                            (0x00060000)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV(data)                                           (0x00060000&((data)<<17))
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_src(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_PDIV(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_RS_shift                                         (14)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_RS_mask                                          (0x0001C000)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_RS(data)                                         (0x0001C000&((data)<<14))
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_RS_src(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_LPF_RS(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_CS_shift                                         (12)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_CS_mask                                          (0x00003000)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_CS(data)                                         (0x00003000&((data)<<12))
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_CS_src(data)                                     ((0x00003000&(data))>>12)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_LPF_CS(data)                                     ((0x00003000&(data))>>12)
+#define SYS_PLL_BUS1_REG_PLLBUS_ICP_shift                                            (9)
+#define SYS_PLL_BUS1_REG_PLLBUS_ICP_mask                                             (0x00000E00)
+#define SYS_PLL_BUS1_REG_PLLBUS_ICP(data)                                            (0x00000E00&((data)<<9))
+#define SYS_PLL_BUS1_REG_PLLBUS_ICP_src(data)                                        ((0x00000E00&(data))>>9)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_ICP(data)                                        ((0x00000E00&(data))>>9)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDSET_shift                                          (8)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDSET_mask                                           (0x00000100)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDSET(data)                                          (0x00000100&((data)<<8))
+#define SYS_PLL_BUS1_REG_PLLBUS_WDSET_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_WDSET(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDRST_shift                                          (7)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDRST_mask                                           (0x00000080)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDRST(data)                                          (0x00000080&((data)<<7))
+#define SYS_PLL_BUS1_REG_PLLBUS_WDRST_src(data)                                      ((0x00000080&(data))>>7)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_WDRST(data)                                      ((0x00000080&(data))>>7)
+#define SYS_PLL_BUS1_REG_PLLBUS_TESTSEL_shift                                        (6)
+#define SYS_PLL_BUS1_REG_PLLBUS_TESTSEL_mask                                         (0x00000040)
+#define SYS_PLL_BUS1_REG_PLLBUS_TESTSEL(data)                                        (0x00000040&((data)<<6))
+#define SYS_PLL_BUS1_REG_PLLBUS_TESTSEL_src(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_TESTSEL(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_BUS1_REG_PLLBUS_SEL_CCO_shift                                        (5)
+#define SYS_PLL_BUS1_REG_PLLBUS_SEL_CCO_mask                                         (0x00000020)
+#define SYS_PLL_BUS1_REG_PLLBUS_SEL_CCO(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_BUS1_REG_PLLBUS_SEL_CCO_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_SEL_CCO(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_BPS_shift                                       (4)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_BPS_mask                                        (0x00000010)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_BPS(data)                                       (0x00000010&((data)<<4))
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_BPS_src(data)                                   ((0x00000010&(data))>>4)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_PDIV_BPS(data)                                   ((0x00000010&(data))>>4)
+#define SYS_PLL_BUS1_REG_PLLBUS_DBUG_EN_shift                                        (3)
+#define SYS_PLL_BUS1_REG_PLLBUS_DBUG_EN_mask                                         (0x00000008)
+#define SYS_PLL_BUS1_REG_PLLBUS_DBUG_EN(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_BUS1_REG_PLLBUS_DBUG_EN_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_DBUG_EN(data)                                    ((0x00000008&(data))>>3)
+
+
+#define SYS_PLL_BUS2                                                                 0x16C
+#define SYS_PLL_BUS2_reg_addr                                                        "0x9800016C"
+#define SYS_PLL_BUS2_reg                                                             0x9800016C
+#define set_SYS_PLL_BUS2_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUS2_reg)=data)
+#define get_SYS_PLL_BUS2_reg   (*((volatile unsigned int*) SYS_PLL_BUS2_reg))
+#define SYS_PLL_BUS2_inst_adr                                                        "0x005B"
+#define SYS_PLL_BUS2_inst                                                            0x005B
+#define SYS_PLL_BUS2_REG_PLLBUS_OEB_shift                                            (2)
+#define SYS_PLL_BUS2_REG_PLLBUS_OEB_mask                                             (0x00000004)
+#define SYS_PLL_BUS2_REG_PLLBUS_OEB(data)                                            (0x00000004&((data)<<2))
+#define SYS_PLL_BUS2_REG_PLLBUS_OEB_src(data)                                        ((0x00000004&(data))>>2)
+#define SYS_PLL_BUS2_get_REG_PLLBUS_OEB(data)                                        ((0x00000004&(data))>>2)
+#define SYS_PLL_BUS2_REG_PLLBUS_RSTB_shift                                           (1)
+#define SYS_PLL_BUS2_REG_PLLBUS_RSTB_mask                                            (0x00000002)
+#define SYS_PLL_BUS2_REG_PLLBUS_RSTB(data)                                           (0x00000002&((data)<<1))
+#define SYS_PLL_BUS2_REG_PLLBUS_RSTB_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_BUS2_get_REG_PLLBUS_RSTB(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_BUS2_REG_PLLBUS_POW_shift                                            (0)
+#define SYS_PLL_BUS2_REG_PLLBUS_POW_mask                                             (0x00000001)
+#define SYS_PLL_BUS2_REG_PLLBUS_POW(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_BUS2_REG_PLLBUS_POW_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_BUS2_get_REG_PLLBUS_POW(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_WDOUT                                                                0x170
+#define SYS_PLL_WDOUT_reg_addr                                                       "0x98000170"
+#define SYS_PLL_WDOUT_reg                                                            0x98000170
+#define set_SYS_PLL_WDOUT_reg(data)   (*((volatile unsigned int*) SYS_PLL_WDOUT_reg)=data)
+#define get_SYS_PLL_WDOUT_reg   (*((volatile unsigned int*) SYS_PLL_WDOUT_reg))
+#define SYS_PLL_WDOUT_inst_adr                                                       "0x005C"
+#define SYS_PLL_WDOUT_inst                                                           0x005C
+#define SYS_PLL_WDOUT_REG_EDPPLL_WDO_shift                                           (14)
+#define SYS_PLL_WDOUT_REG_EDPPLL_WDO_mask                                            (0x00004000)
+#define SYS_PLL_WDOUT_REG_EDPPLL_WDO(data)                                           (0x00004000&((data)<<14))
+#define SYS_PLL_WDOUT_REG_EDPPLL_WDO_src(data)                                       ((0x00004000&(data))>>14)
+#define SYS_PLL_WDOUT_get_REG_EDPPLL_WDO(data)                                       ((0x00004000&(data))>>14)
+#define SYS_PLL_WDOUT_REG_PIXELPLL_WDO_shift                                         (13)
+#define SYS_PLL_WDOUT_REG_PIXELPLL_WDO_mask                                          (0x00002000)
+#define SYS_PLL_WDOUT_REG_PIXELPLL_WDO(data)                                         (0x00002000&((data)<<13))
+#define SYS_PLL_WDOUT_REG_PIXELPLL_WDO_src(data)                                     ((0x00002000&(data))>>13)
+#define SYS_PLL_WDOUT_get_REG_PIXELPLL_WDO(data)                                     ((0x00002000&(data))>>13)
+#define SYS_PLL_WDOUT_REG_PLLGPU_WDOUT_shift                                         (12)
+#define SYS_PLL_WDOUT_REG_PLLGPU_WDOUT_mask                                          (0x00001000)
+#define SYS_PLL_WDOUT_REG_PLLGPU_WDOUT(data)                                         (0x00001000&((data)<<12))
+#define SYS_PLL_WDOUT_REG_PLLGPU_WDOUT_src(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PLL_WDOUT_get_REG_PLLGPU_WDOUT(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_H_shift                                       (10)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_H_mask                                        (0x00000400)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_H(data)                                       (0x00000400&((data)<<10))
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_H_src(data)                                   ((0x00000400&(data))>>10)
+#define SYS_PLL_WDOUT_get_REG_PLLBUS_WDOUT_H(data)                                   ((0x00000400&(data))>>10)
+#define SYS_PLL_WDOUT_REG_PLLVODMA_WDOUT_shift                                       (8)
+#define SYS_PLL_WDOUT_REG_PLLVODMA_WDOUT_mask                                        (0x00000100)
+#define SYS_PLL_WDOUT_REG_PLLVODMA_WDOUT(data)                                       (0x00000100&((data)<<8))
+#define SYS_PLL_WDOUT_REG_PLLVODMA_WDOUT_src(data)                                   ((0x00000100&(data))>>8)
+#define SYS_PLL_WDOUT_get_REG_PLLVODMA_WDOUT(data)                                   ((0x00000100&(data))>>8)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_2_shift                                      (7)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_2_mask                                       (0x00000080)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_2(data)                                      (0x00000080&((data)<<7))
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_2_src(data)                                  ((0x00000080&(data))>>7)
+#define SYS_PLL_WDOUT_get_REG_PLLVCPU_WDOUT_2(data)                                  ((0x00000080&(data))>>7)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_shift                                         (6)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_mask                                          (0x00000040)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT(data)                                         (0x00000040&((data)<<6))
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_src(data)                                     ((0x00000040&(data))>>6)
+#define SYS_PLL_WDOUT_get_REG_PLLBUS_WDOUT(data)                                     ((0x00000040&(data))>>6)
+#define SYS_PLL_WDOUT_REG_PLLDDSB_WDOUT_shift                                        (4)
+#define SYS_PLL_WDOUT_REG_PLLDDSB_WDOUT_mask                                         (0x00000010)
+#define SYS_PLL_WDOUT_REG_PLLDDSB_WDOUT(data)                                        (0x00000010&((data)<<4))
+#define SYS_PLL_WDOUT_REG_PLLDDSB_WDOUT_src(data)                                    ((0x00000010&(data))>>4)
+#define SYS_PLL_WDOUT_get_REG_PLLDDSB_WDOUT(data)                                    ((0x00000010&(data))>>4)
+#define SYS_PLL_WDOUT_REG_PLLDDSA_WDOUT_shift                                        (3)
+#define SYS_PLL_WDOUT_REG_PLLDDSA_WDOUT_mask                                         (0x00000008)
+#define SYS_PLL_WDOUT_REG_PLLDDSA_WDOUT(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_WDOUT_REG_PLLDDSA_WDOUT_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_WDOUT_get_REG_PLLDDSA_WDOUT(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_shift                                        (2)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_mask                                         (0x00000004)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_WDOUT_get_REG_PLLVCPU_WDOUT(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_WDOUT_REG_PLLACPU_WDOUT_shift                                        (1)
+#define SYS_PLL_WDOUT_REG_PLLACPU_WDOUT_mask                                         (0x00000002)
+#define SYS_PLL_WDOUT_REG_PLLACPU_WDOUT(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_WDOUT_REG_PLLACPU_WDOUT_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_WDOUT_get_REG_PLLACPU_WDOUT(data)                                    ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_DDSB1                                                                0x174
+#define SYS_PLL_DDSB1_reg_addr                                                       "0x98000174"
+#define SYS_PLL_DDSB1_reg                                                            0x98000174
+#define set_SYS_PLL_DDSB1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDSB1_reg)=data)
+#define get_SYS_PLL_DDSB1_reg   (*((volatile unsigned int*) SYS_PLL_DDSB1_reg))
+#define SYS_PLL_DDSB1_inst_adr                                                       "0x005D"
+#define SYS_PLL_DDSB1_inst                                                           0x005D
+#define SYS_PLL_DDSB1_REG_PLLDDSB_WDMODE_shift                                       (23)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_WDMODE_mask                                        (0x01800000)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_WDMODE(data)                                       (0x01800000&((data)<<23))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_WDMODE_src(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_WDMODE(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_RS_shift                                           (20)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_RS_mask                                            (0x00700000)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_RS(data)                                           (0x00700000&((data)<<20))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_RS_src(data)                                       ((0x00700000&(data))>>20)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_RS(data)                                       ((0x00700000&(data))>>20)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_O_shift                                            (18)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_O_mask                                             (0x000C0000)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_O(data)                                            (0x000C0000&((data)<<18))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_O_src(data)                                        ((0x000C0000&(data))>>18)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_O(data)                                        ((0x000C0000&(data))>>18)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_N_shift                                            (16)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_N_mask                                             (0x00030000)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_N(data)                                            (0x00030000&((data)<<16))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_N_src(data)                                        ((0x00030000&(data))>>16)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_N(data)                                        ((0x00030000&(data))>>16)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_IP_shift                                           (12)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_IP_mask                                            (0x0000F000)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_IP(data)                                           (0x0000F000&((data)<<12))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_IP_src(data)                                       ((0x0000F000&(data))>>12)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_IP(data)                                       ((0x0000F000&(data))>>12)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CS_shift                                           (10)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CS_mask                                            (0x00000C00)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CS(data)                                           (0x00000C00&((data)<<10))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CS_src(data)                                       ((0x00000C00&(data))>>10)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_CS(data)                                       ((0x00000C00&(data))>>10)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CP_shift                                           (8)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CP_mask                                            (0x00000300)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CP(data)                                           (0x00000300&((data)<<8))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CP_src(data)                                       ((0x00000300&(data))>>8)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_CP(data)                                       ((0x00000300&(data))>>8)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_VCORB_shift                                        (7)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_VCORB_mask                                         (0x00000080)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_VCORB(data)                                        (0x00000080&((data)<<7))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_VCORB_src(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_VCORB(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_TST_shift                                          (6)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_TST_mask                                           (0x00000040)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_TST(data)                                          (0x00000040&((data)<<6))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_TST_src(data)                                      ((0x00000040&(data))>>6)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_TST(data)                                      ((0x00000040&(data))>>6)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_PSTST_shift                                        (5)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_PSTST_mask                                         (0x00000020)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_PSTST(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_PSTST_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_PSTST(data)                                    ((0x00000020&(data))>>5)
+
+
+#define SYS_PLL_DDSB2                                                                0x178
+#define SYS_PLL_DDSB2_reg_addr                                                       "0x98000178"
+#define SYS_PLL_DDSB2_reg                                                            0x98000178
+#define set_SYS_PLL_DDSB2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDSB2_reg)=data)
+#define get_SYS_PLL_DDSB2_reg   (*((volatile unsigned int*) SYS_PLL_DDSB2_reg))
+#define SYS_PLL_DDSB2_inst_adr                                                       "0x005E"
+#define SYS_PLL_DDSB2_inst                                                           0x005E
+#define SYS_PLL_DDSB2_REG_PLLDDSB_OEB_shift                                          (2)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_OEB_mask                                           (0x00000004)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_OEB(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_DDSB2_REG_PLLDDSB_OEB_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DDSB2_get_REG_PLLDDSB_OEB(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_RSTB_shift                                         (1)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_RSTB_mask                                          (0x00000002)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_RSTB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_DDSB2_REG_PLLDDSB_RSTB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DDSB2_get_REG_PLLDDSB_RSTB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_POW_shift                                          (0)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_POW_mask                                           (0x00000001)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_POW(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_DDSB2_REG_PLLDDSB_POW_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_DDSB2_get_REG_PLLDDSB_POW(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PSAUDB1                                                              0x188
+#define SYS_PLL_PSAUDB1_reg_addr                                                     "0x98000188"
+#define SYS_PLL_PSAUDB1_reg                                                          0x98000188
+#define set_SYS_PLL_PSAUDB1_reg(data)   (*((volatile unsigned int*) SYS_PLL_PSAUDB1_reg)=data)
+#define get_SYS_PLL_PSAUDB1_reg   (*((volatile unsigned int*) SYS_PLL_PSAUDB1_reg))
+#define SYS_PLL_PSAUDB1_inst_adr                                                     "0x0062"
+#define SYS_PLL_PSAUDB1_inst                                                         0x0062
+#define SYS_PLL_PSAUDB1_write_en10_shift                                             (25)
+#define SYS_PLL_PSAUDB1_write_en10_mask                                              (0x02000000)
+#define SYS_PLL_PSAUDB1_write_en10(data)                                             (0x02000000&((data)<<25))
+#define SYS_PLL_PSAUDB1_write_en10_src(data)                                         ((0x02000000&(data))>>25)
+#define SYS_PLL_PSAUDB1_get_write_en10(data)                                         ((0x02000000&(data))>>25)
+#define SYS_PLL_PSAUDB1_pcr_b_smooth_en_shift                                        (24)
+#define SYS_PLL_PSAUDB1_pcr_b_smooth_en_mask                                         (0x01000000)
+#define SYS_PLL_PSAUDB1_pcr_b_smooth_en(data)                                        (0x01000000&((data)<<24))
+#define SYS_PLL_PSAUDB1_pcr_b_smooth_en_src(data)                                    ((0x01000000&(data))>>24)
+#define SYS_PLL_PSAUDB1_get_pcr_b_smooth_en(data)                                    ((0x01000000&(data))>>24)
+#define SYS_PLL_PSAUDB1_write_en9_shift                                              (23)
+#define SYS_PLL_PSAUDB1_write_en9_mask                                               (0x00800000)
+#define SYS_PLL_PSAUDB1_write_en9(data)                                              (0x00800000&((data)<<23))
+#define SYS_PLL_PSAUDB1_write_en9_src(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PLL_PSAUDB1_get_write_en9(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PLL_PSAUDB1_pcr_b_phase_sel_shift                                        (22)
+#define SYS_PLL_PSAUDB1_pcr_b_phase_sel_mask                                         (0x00400000)
+#define SYS_PLL_PSAUDB1_pcr_b_phase_sel(data)                                        (0x00400000&((data)<<22))
+#define SYS_PLL_PSAUDB1_pcr_b_phase_sel_src(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_PSAUDB1_get_pcr_b_phase_sel(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_PSAUDB1_write_en8_shift                                              (21)
+#define SYS_PLL_PSAUDB1_write_en8_mask                                               (0x00200000)
+#define SYS_PLL_PSAUDB1_write_en8(data)                                              (0x00200000&((data)<<21))
+#define SYS_PLL_PSAUDB1_write_en8_src(data)                                          ((0x00200000&(data))>>21)
+#define SYS_PLL_PSAUDB1_get_write_en8(data)                                          ((0x00200000&(data))>>21)
+#define SYS_PLL_PSAUDB1_pcr_b_ctl_en_shift                                           (20)
+#define SYS_PLL_PSAUDB1_pcr_b_ctl_en_mask                                            (0x00100000)
+#define SYS_PLL_PSAUDB1_pcr_b_ctl_en(data)                                           (0x00100000&((data)<<20))
+#define SYS_PLL_PSAUDB1_pcr_b_ctl_en_src(data)                                       ((0x00100000&(data))>>20)
+#define SYS_PLL_PSAUDB1_get_pcr_b_ctl_en(data)                                       ((0x00100000&(data))>>20)
+#define SYS_PLL_PSAUDB1_write_en3_shift                                              (10)
+#define SYS_PLL_PSAUDB1_write_en3_mask                                               (0x00000400)
+#define SYS_PLL_PSAUDB1_write_en3(data)                                              (0x00000400&((data)<<10))
+#define SYS_PLL_PSAUDB1_write_en3_src(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PLL_PSAUDB1_get_write_en3(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_FUPDN_shift                                      (9)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_FUPDN_mask                                       (0x00000200)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_FUPDN(data)                                      (0x00000200&((data)<<9))
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_FUPDN_src(data)                                  ((0x00000200&(data))>>9)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD1B_FUPDN(data)                                  ((0x00000200&(data))>>9)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_DIV_shift                                        (8)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_DIV_mask                                         (0x00000100)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_DIV(data)                                        (0x00000100&((data)<<8))
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_DIV_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD1B_DIV(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_PSAUDB1_write_en2_shift                                              (7)
+#define SYS_PLL_PSAUDB1_write_en2_mask                                               (0x00000080)
+#define SYS_PLL_PSAUDB1_write_en2(data)                                              (0x00000080&((data)<<7))
+#define SYS_PLL_PSAUDB1_write_en2_src(data)                                          ((0x00000080&(data))>>7)
+#define SYS_PLL_PSAUDB1_get_write_en2(data)                                          ((0x00000080&(data))>>7)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_TST_shift                                        (6)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_TST_mask                                         (0x00000040)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_TST(data)                                        (0x00000040&((data)<<6))
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_TST_src(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD1B_TST(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_PSEN_shift                                       (5)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_PSEN_mask                                        (0x00000020)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_PSEN(data)                                       (0x00000020&((data)<<5))
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_PSEN_src(data)                                   ((0x00000020&(data))>>5)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD1B_PSEN(data)                                   ((0x00000020&(data))>>5)
+#define SYS_PLL_PSAUDB1_write_en1_shift                                              (4)
+#define SYS_PLL_PSAUDB1_write_en1_mask                                               (0x00000010)
+#define SYS_PLL_PSAUDB1_write_en1(data)                                              (0x00000010&((data)<<4))
+#define SYS_PLL_PSAUDB1_write_en1_src(data)                                          ((0x00000010&(data))>>4)
+#define SYS_PLL_PSAUDB1_get_write_en1(data)                                          ((0x00000010&(data))>>4)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_FUPDN_shift                                      (3)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_FUPDN_mask                                       (0x00000008)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_FUPDN(data)                                      (0x00000008&((data)<<3))
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_FUPDN_src(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD2B_FUPDN(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_DIV_shift                                        (2)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_DIV_mask                                         (0x00000004)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_DIV(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_DIV_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD2B_DIV(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_TST_shift                                        (1)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_TST_mask                                         (0x00000002)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_TST(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_TST_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD2B_TST(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_PSEN_shift                                       (0)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_PSEN_mask                                        (0x00000001)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_PSEN(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_PSEN_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD2B_PSEN(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PSAUDB2                                                              0x18C
+#define SYS_PLL_PSAUDB2_reg_addr                                                     "0x9800018C"
+#define SYS_PLL_PSAUDB2_reg                                                          0x9800018C
+#define set_SYS_PLL_PSAUDB2_reg(data)   (*((volatile unsigned int*) SYS_PLL_PSAUDB2_reg)=data)
+#define get_SYS_PLL_PSAUDB2_reg   (*((volatile unsigned int*) SYS_PLL_PSAUDB2_reg))
+#define SYS_PLL_PSAUDB2_inst_adr                                                     "0x0063"
+#define SYS_PLL_PSAUDB2_inst                                                         0x0063
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_OEB_shift                                        (3)
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_OEB_mask                                         (0x00000008)
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_OEB(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_OEB_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDB2_get_REG_PSAUD1B_OEB(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_RSTB_shift                                       (2)
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_RSTB_mask                                        (0x00000004)
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_RSTB(data)                                       (0x00000004&((data)<<2))
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_RSTB_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDB2_get_REG_PSAUD1B_RSTB(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_OEB_shift                                        (1)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_OEB_mask                                         (0x00000002)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_OEB(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_OEB_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDB2_get_REG_PSAUD2B_OEB(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_RSTB_shift                                       (0)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_RSTB_mask                                        (0x00000001)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_RSTB(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_RSTB_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_PSAUDB2_get_REG_PSAUD2B_RSTB(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI                                                                 0x190
+#define SYS_PLL_HDMI_reg_addr                                                        "0x98000190"
+#define SYS_PLL_HDMI_reg                                                             0x98000190
+#define set_SYS_PLL_HDMI_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_reg)=data)
+#define get_SYS_PLL_HDMI_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_reg))
+#define SYS_PLL_HDMI_inst_adr                                                        "0x0064"
+#define SYS_PLL_HDMI_inst                                                            0x0064
+#define SYS_PLL_HDMI_PLLDISP_OEB_shift                                               (8)
+#define SYS_PLL_HDMI_PLLDISP_OEB_mask                                                (0x00000100)
+#define SYS_PLL_HDMI_PLLDISP_OEB(data)                                               (0x00000100&((data)<<8))
+#define SYS_PLL_HDMI_PLLDISP_OEB_src(data)                                           ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_get_PLLDISP_OEB(data)                                           ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_PLLDISP_VCORSTB_shift                                           (7)
+#define SYS_PLL_HDMI_PLLDISP_VCORSTB_mask                                            (0x00000080)
+#define SYS_PLL_HDMI_PLLDISP_VCORSTB(data)                                           (0x00000080&((data)<<7))
+#define SYS_PLL_HDMI_PLLDISP_VCORSTB_src(data)                                       ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_get_PLLDISP_VCORSTB(data)                                       ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_REG_PLL_MHL3_DIV_EN_shift                                       (6)
+#define SYS_PLL_HDMI_REG_PLL_MHL3_DIV_EN_mask                                        (0x00000040)
+#define SYS_PLL_HDMI_REG_PLL_MHL3_DIV_EN(data)                                       (0x00000040&((data)<<6))
+#define SYS_PLL_HDMI_REG_PLL_MHL3_DIV_EN_src(data)                                   ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_get_REG_PLL_MHL3_DIV_EN(data)                                   ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_REG_PLLDISP_RSTB_shift                                          (5)
+#define SYS_PLL_HDMI_REG_PLLDISP_RSTB_mask                                           (0x00000020)
+#define SYS_PLL_HDMI_REG_PLLDISP_RSTB(data)                                          (0x00000020&((data)<<5))
+#define SYS_PLL_HDMI_REG_PLLDISP_RSTB_src(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PLL_HDMI_get_REG_PLLDISP_RSTB(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PLL_HDMI_REG_PLLDISP_POW_shift                                           (4)
+#define SYS_PLL_HDMI_REG_PLLDISP_POW_mask                                            (0x00000010)
+#define SYS_PLL_HDMI_REG_PLLDISP_POW(data)                                           (0x00000010&((data)<<4))
+#define SYS_PLL_HDMI_REG_PLLDISP_POW_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_get_REG_PLLDISP_POW(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_REG_TMDS_POW_shift                                              (3)
+#define SYS_PLL_HDMI_REG_TMDS_POW_mask                                               (0x00000008)
+#define SYS_PLL_HDMI_REG_TMDS_POW(data)                                              (0x00000008&((data)<<3))
+#define SYS_PLL_HDMI_REG_TMDS_POW_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI_get_REG_TMDS_POW(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI_REG_PLL_RSTB_shift                                              (2)
+#define SYS_PLL_HDMI_REG_PLL_RSTB_mask                                               (0x00000004)
+#define SYS_PLL_HDMI_REG_PLL_RSTB(data)                                              (0x00000004&((data)<<2))
+#define SYS_PLL_HDMI_REG_PLL_RSTB_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_HDMI_get_REG_PLL_RSTB(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_HDMI_REG_PLL_POW_shift                                               (1)
+#define SYS_PLL_HDMI_REG_PLL_POW_mask                                                (0x00000002)
+#define SYS_PLL_HDMI_REG_PLL_POW(data)                                               (0x00000002&((data)<<1))
+#define SYS_PLL_HDMI_REG_PLL_POW_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_get_REG_PLL_POW(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN_shift                                            (0)
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN_mask                                             (0x00000001)
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_HDMI_get_REG_HDMI_CK_EN(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI2                                                                0x194
+#define SYS_PLL_HDMI2_reg_addr                                                       "0x98000194"
+#define SYS_PLL_HDMI2_reg                                                            0x98000194
+#define set_SYS_PLL_HDMI2_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI2_reg)=data)
+#define get_SYS_PLL_HDMI2_reg   (*((volatile unsigned int*) SYS_PLL_HDMI2_reg))
+#define SYS_PLL_HDMI2_inst_adr                                                       "0x0065"
+#define SYS_PLL_HDMI2_inst                                                           0x0065
+#define SYS_PLL_HDMI2_REG_ICO_PDIV2_shift                                            (20)
+#define SYS_PLL_HDMI2_REG_ICO_PDIV2_mask                                             (0x00700000)
+#define SYS_PLL_HDMI2_REG_ICO_PDIV2(data)                                            (0x00700000&((data)<<20))
+#define SYS_PLL_HDMI2_REG_ICO_PDIV2_src(data)                                        ((0x00700000&(data))>>20)
+#define SYS_PLL_HDMI2_get_REG_ICO_PDIV2(data)                                        ((0x00700000&(data))>>20)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV_shift                                             (16)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV_mask                                              (0x000F0000)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV(data)                                             (0x000F0000&((data)<<16))
+#define SYS_PLL_HDMI2_REG_TMDS_DIV_src(data)                                         ((0x000F0000&(data))>>16)
+#define SYS_PLL_HDMI2_get_REG_TMDS_DIV(data)                                         ((0x000F0000&(data))>>16)
+#define SYS_PLL_HDMI2_REG_PLLDISP_N_shift                                            (14)
+#define SYS_PLL_HDMI2_REG_PLLDISP_N_mask                                             (0x0000C000)
+#define SYS_PLL_HDMI2_REG_PLLDISP_N(data)                                            (0x0000C000&((data)<<14))
+#define SYS_PLL_HDMI2_REG_PLLDISP_N_src(data)                                        ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI2_get_REG_PLLDISP_N(data)                                        ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI2_REG_PLLDISP_K_shift                                            (12)
+#define SYS_PLL_HDMI2_REG_PLLDISP_K_mask                                             (0x00003000)
+#define SYS_PLL_HDMI2_REG_PLLDISP_K(data)                                            (0x00003000&((data)<<12))
+#define SYS_PLL_HDMI2_REG_PLLDISP_K_src(data)                                        ((0x00003000&(data))>>12)
+#define SYS_PLL_HDMI2_get_REG_PLLDISP_K(data)                                        ((0x00003000&(data))>>12)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV_shift                                            (4)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV_mask                                             (0x00000FF0)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV(data)                                            (0x00000FF0&((data)<<4))
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV_src(data)                                        ((0x00000FF0&(data))>>4)
+#define SYS_PLL_HDMI2_get_REG_PIXEL_DIV(data)                                        ((0x00000FF0&(data))>>4)
+#define SYS_PLL_HDMI2_REG_PLL_M2_shift                                               (2)
+#define SYS_PLL_HDMI2_REG_PLL_M2_mask                                                (0x0000000C)
+#define SYS_PLL_HDMI2_REG_PLL_M2(data)                                               (0x0000000C&((data)<<2))
+#define SYS_PLL_HDMI2_REG_PLL_M2_src(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI2_get_REG_PLL_M2(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI2_REG_PLL_M1_shift                                               (0)
+#define SYS_PLL_HDMI2_REG_PLL_M1_mask                                                (0x00000003)
+#define SYS_PLL_HDMI2_REG_PLL_M1(data)                                               (0x00000003&((data)<<0))
+#define SYS_PLL_HDMI2_REG_PLL_M1_src(data)                                           ((0x00000003&(data))>>0)
+#define SYS_PLL_HDMI2_get_REG_PLL_M1(data)                                           ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_SDIO1                                                                0x1A0
+#define SYS_PLL_SDIO1_reg_addr                                                       "0x980001A0"
+#define SYS_PLL_SDIO1_reg                                                            0x980001A0
+#define set_SYS_PLL_SDIO1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SDIO1_reg)=data)
+#define get_SYS_PLL_SDIO1_reg   (*((volatile unsigned int*) SYS_PLL_SDIO1_reg))
+#define SYS_PLL_SDIO1_inst_adr                                                       "0x0068"
+#define SYS_PLL_SDIO1_inst                                                           0x0068
+#define SYS_PLL_SDIO1_phsel1_shift                                                   (8)
+#define SYS_PLL_SDIO1_phsel1_mask                                                    (0x00001F00)
+#define SYS_PLL_SDIO1_phsel1(data)                                                   (0x00001F00&((data)<<8))
+#define SYS_PLL_SDIO1_phsel1_src(data)                                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SDIO1_get_phsel1(data)                                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SDIO1_phsel0_shift                                                   (3)
+#define SYS_PLL_SDIO1_phsel0_mask                                                    (0x000000F8)
+#define SYS_PLL_SDIO1_phsel0(data)                                                   (0x000000F8&((data)<<3))
+#define SYS_PLL_SDIO1_phsel0_src(data)                                               ((0x000000F8&(data))>>3)
+#define SYS_PLL_SDIO1_get_phsel0(data)                                               ((0x000000F8&(data))>>3)
+#define SYS_PLL_SDIO1_phrstb_dly_sel_shift                                           (2)
+#define SYS_PLL_SDIO1_phrstb_dly_sel_mask                                            (0x00000004)
+#define SYS_PLL_SDIO1_phrstb_dly_sel(data)                                           (0x00000004&((data)<<2))
+#define SYS_PLL_SDIO1_phrstb_dly_sel_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_SDIO1_get_phrstb_dly_sel(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_SDIO1_phrt0_shift                                                    (1)
+#define SYS_PLL_SDIO1_phrt0_mask                                                     (0x00000002)
+#define SYS_PLL_SDIO1_phrt0(data)                                                    (0x00000002&((data)<<1))
+#define SYS_PLL_SDIO1_phrt0_src(data)                                                ((0x00000002&(data))>>1)
+#define SYS_PLL_SDIO1_get_phrt0(data)                                                ((0x00000002&(data))>>1)
+#define SYS_PLL_SDIO1_bias_en_shift                                                  (0)
+#define SYS_PLL_SDIO1_bias_en_mask                                                   (0x00000001)
+#define SYS_PLL_SDIO1_bias_en(data)                                                  (0x00000001&((data)<<0))
+#define SYS_PLL_SDIO1_bias_en_src(data)                                              ((0x00000001&(data))>>0)
+#define SYS_PLL_SDIO1_get_bias_en(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SDIO2                                                                0x1A4
+#define SYS_PLL_SDIO2_reg_addr                                                       "0x980001A4"
+#define SYS_PLL_SDIO2_reg                                                            0x980001A4
+#define set_SYS_PLL_SDIO2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SDIO2_reg)=data)
+#define get_SYS_PLL_SDIO2_reg   (*((volatile unsigned int*) SYS_PLL_SDIO2_reg))
+#define SYS_PLL_SDIO2_inst_adr                                                       "0x0069"
+#define SYS_PLL_SDIO2_inst                                                           0x0069
+#define SYS_PLL_SDIO2_en_cpnew_shift                                                 (26)
+#define SYS_PLL_SDIO2_en_cpnew_mask                                                  (0x04000000)
+#define SYS_PLL_SDIO2_en_cpnew(data)                                                 (0x04000000&((data)<<26))
+#define SYS_PLL_SDIO2_en_cpnew_src(data)                                             ((0x04000000&(data))>>26)
+#define SYS_PLL_SDIO2_get_en_cpnew(data)                                             ((0x04000000&(data))>>26)
+#define SYS_PLL_SDIO2_ssc_div_ext_f_shift                                            (18)
+#define SYS_PLL_SDIO2_ssc_div_ext_f_mask                                             (0x03FC0000)
+#define SYS_PLL_SDIO2_ssc_div_ext_f(data)                                            (0x03FC0000&((data)<<18))
+#define SYS_PLL_SDIO2_ssc_div_ext_f_src(data)                                        ((0x03FC0000&(data))>>18)
+#define SYS_PLL_SDIO2_get_ssc_div_ext_f(data)                                        ((0x03FC0000&(data))>>18)
+#define SYS_PLL_SDIO2_ssc_div_f_sel_shift                                            (17)
+#define SYS_PLL_SDIO2_ssc_div_f_sel_mask                                             (0x00020000)
+#define SYS_PLL_SDIO2_ssc_div_f_sel(data)                                            (0x00020000&((data)<<17))
+#define SYS_PLL_SDIO2_ssc_div_f_sel_src(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PLL_SDIO2_get_ssc_div_f_sel(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PLL_SDIO2_ssc_8x_en_shift                                                (16)
+#define SYS_PLL_SDIO2_ssc_8x_en_mask                                                 (0x00010000)
+#define SYS_PLL_SDIO2_ssc_8x_en(data)                                                (0x00010000&((data)<<16))
+#define SYS_PLL_SDIO2_ssc_8x_en_src(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_SDIO2_get_ssc_8x_en(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_SDIO2_ssc_depth_shift                                                (13)
+#define SYS_PLL_SDIO2_ssc_depth_mask                                                 (0x0000E000)
+#define SYS_PLL_SDIO2_ssc_depth(data)                                                (0x0000E000&((data)<<13))
+#define SYS_PLL_SDIO2_ssc_depth_src(data)                                            ((0x0000E000&(data))>>13)
+#define SYS_PLL_SDIO2_get_ssc_depth(data)                                            ((0x0000E000&(data))>>13)
+#define SYS_PLL_SDIO2_sscpll_rs_shift                                                (10)
+#define SYS_PLL_SDIO2_sscpll_rs_mask                                                 (0x00001C00)
+#define SYS_PLL_SDIO2_sscpll_rs(data)                                                (0x00001C00&((data)<<10))
+#define SYS_PLL_SDIO2_sscpll_rs_src(data)                                            ((0x00001C00&(data))>>10)
+#define SYS_PLL_SDIO2_get_sscpll_rs(data)                                            ((0x00001C00&(data))>>10)
+#define SYS_PLL_SDIO2_sscpll_icp_shift                                               (5)
+#define SYS_PLL_SDIO2_sscpll_icp_mask                                                (0x000003E0)
+#define SYS_PLL_SDIO2_sscpll_icp(data)                                               (0x000003E0&((data)<<5))
+#define SYS_PLL_SDIO2_sscpll_icp_src(data)                                           ((0x000003E0&(data))>>5)
+#define SYS_PLL_SDIO2_get_sscpll_icp(data)                                           ((0x000003E0&(data))>>5)
+#define SYS_PLL_SDIO2_sscpll_cs1_shift                                               (3)
+#define SYS_PLL_SDIO2_sscpll_cs1_mask                                                (0x00000018)
+#define SYS_PLL_SDIO2_sscpll_cs1(data)                                               (0x00000018&((data)<<3))
+#define SYS_PLL_SDIO2_sscpll_cs1_src(data)                                           ((0x00000018&(data))>>3)
+#define SYS_PLL_SDIO2_get_sscpll_cs1(data)                                           ((0x00000018&(data))>>3)
+#define SYS_PLL_SDIO2_reg_tune11_shift                                               (1)
+#define SYS_PLL_SDIO2_reg_tune11_mask                                                (0x00000006)
+#define SYS_PLL_SDIO2_reg_tune11(data)                                               (0x00000006&((data)<<1))
+#define SYS_PLL_SDIO2_reg_tune11_src(data)                                           ((0x00000006&(data))>>1)
+#define SYS_PLL_SDIO2_get_reg_tune11(data)                                           ((0x00000006&(data))>>1)
+#define SYS_PLL_SDIO2_sscldo_en_shift                                                (0)
+#define SYS_PLL_SDIO2_sscldo_en_mask                                                 (0x00000001)
+#define SYS_PLL_SDIO2_sscldo_en(data)                                                (0x00000001&((data)<<0))
+#define SYS_PLL_SDIO2_sscldo_en_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_PLL_SDIO2_get_sscldo_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SDIO3                                                                0x1A8
+#define SYS_PLL_SDIO3_reg_addr                                                       "0x980001A8"
+#define SYS_PLL_SDIO3_reg                                                            0x980001A8
+#define set_SYS_PLL_SDIO3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SDIO3_reg)=data)
+#define get_SYS_PLL_SDIO3_reg   (*((volatile unsigned int*) SYS_PLL_SDIO3_reg))
+#define SYS_PLL_SDIO3_inst_adr                                                       "0x006A"
+#define SYS_PLL_SDIO3_inst                                                           0x006A
+#define SYS_PLL_SDIO3_ssc_div_n_shift                                                (16)
+#define SYS_PLL_SDIO3_ssc_div_n_mask                                                 (0x03FF0000)
+#define SYS_PLL_SDIO3_ssc_div_n(data)                                                (0x03FF0000&((data)<<16))
+#define SYS_PLL_SDIO3_ssc_div_n_src(data)                                            ((0x03FF0000&(data))>>16)
+#define SYS_PLL_SDIO3_get_ssc_div_n(data)                                            ((0x03FF0000&(data))>>16)
+#define SYS_PLL_SDIO3_ssc_step_in_shift                                              (8)
+#define SYS_PLL_SDIO3_ssc_step_in_mask                                               (0x00007F00)
+#define SYS_PLL_SDIO3_ssc_step_in(data)                                              (0x00007F00&((data)<<8))
+#define SYS_PLL_SDIO3_ssc_step_in_src(data)                                          ((0x00007F00&(data))>>8)
+#define SYS_PLL_SDIO3_get_ssc_step_in(data)                                          ((0x00007F00&(data))>>8)
+#define SYS_PLL_SDIO3_ssc_tbase_shift                                                (0)
+#define SYS_PLL_SDIO3_ssc_tbase_mask                                                 (0x000000FF)
+#define SYS_PLL_SDIO3_ssc_tbase(data)                                                (0x000000FF&((data)<<0))
+#define SYS_PLL_SDIO3_ssc_tbase_src(data)                                            ((0x000000FF&(data))>>0)
+#define SYS_PLL_SDIO3_get_ssc_tbase(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SDIO4                                                                0x1AC
+#define SYS_PLL_SDIO4_reg_addr                                                       "0x980001AC"
+#define SYS_PLL_SDIO4_reg                                                            0x980001AC
+#define set_SYS_PLL_SDIO4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SDIO4_reg)=data)
+#define get_SYS_PLL_SDIO4_reg   (*((volatile unsigned int*) SYS_PLL_SDIO4_reg))
+#define SYS_PLL_SDIO4_inst_adr                                                       "0x006B"
+#define SYS_PLL_SDIO4_inst                                                           0x006B
+#define SYS_PLL_SDIO4_ssc_pll_pow_shift                                              (2)
+#define SYS_PLL_SDIO4_ssc_pll_pow_mask                                               (0x00000004)
+#define SYS_PLL_SDIO4_ssc_pll_pow(data)                                              (0x00000004&((data)<<2))
+#define SYS_PLL_SDIO4_ssc_pll_pow_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_SDIO4_get_ssc_pll_pow(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_SDIO4_ssc_pll_rstb_shift                                             (1)
+#define SYS_PLL_SDIO4_ssc_pll_rstb_mask                                              (0x00000002)
+#define SYS_PLL_SDIO4_ssc_pll_rstb(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_SDIO4_ssc_pll_rstb_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SDIO4_get_ssc_pll_rstb(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SDIO4_ssc_rstb_shift                                                 (0)
+#define SYS_PLL_SDIO4_ssc_rstb_mask                                                  (0x00000001)
+#define SYS_PLL_SDIO4_ssc_rstb(data)                                                 (0x00000001&((data)<<0))
+#define SYS_PLL_SDIO4_ssc_rstb_src(data)                                             ((0x00000001&(data))>>0)
+#define SYS_PLL_SDIO4_get_ssc_rstb(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_BUSH1                                                                0x1B0
+#define SYS_PLL_BUSH1_reg_addr                                                       "0x980001B0"
+#define SYS_PLL_BUSH1_reg                                                            0x980001B0
+#define set_SYS_PLL_BUSH1_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUSH1_reg)=data)
+#define get_SYS_PLL_BUSH1_reg   (*((volatile unsigned int*) SYS_PLL_BUSH1_reg))
+#define SYS_PLL_BUSH1_inst_adr                                                       "0x006C"
+#define SYS_PLL_BUSH1_inst                                                           0x006C
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_H_shift                                        (17)
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_H_mask                                         (0x00060000)
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_H(data)                                        (0x00060000&((data)<<17))
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_H_src(data)                                    ((0x00060000&(data))>>17)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_PDIV_H(data)                                    ((0x00060000&(data))>>17)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_RS_H_shift                                      (14)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_RS_H_mask                                       (0x0001C000)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_RS_H(data)                                      (0x0001C000&((data)<<14))
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_RS_H_src(data)                                  ((0x0001C000&(data))>>14)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_LPF_RS_H(data)                                  ((0x0001C000&(data))>>14)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_CS_H_shift                                      (12)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_CS_H_mask                                       (0x00003000)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_CS_H(data)                                      (0x00003000&((data)<<12))
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_CS_H_src(data)                                  ((0x00003000&(data))>>12)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_LPF_CS_H(data)                                  ((0x00003000&(data))>>12)
+#define SYS_PLL_BUSH1_REG_PLLBUS_ICP_H_shift                                         (9)
+#define SYS_PLL_BUSH1_REG_PLLBUS_ICP_H_mask                                          (0x00000E00)
+#define SYS_PLL_BUSH1_REG_PLLBUS_ICP_H(data)                                         (0x00000E00&((data)<<9))
+#define SYS_PLL_BUSH1_REG_PLLBUS_ICP_H_src(data)                                     ((0x00000E00&(data))>>9)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_ICP_H(data)                                     ((0x00000E00&(data))>>9)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDSET_H_shift                                       (8)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDSET_H_mask                                        (0x00000100)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDSET_H(data)                                       (0x00000100&((data)<<8))
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDSET_H_src(data)                                   ((0x00000100&(data))>>8)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_WDSET_H(data)                                   ((0x00000100&(data))>>8)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDRST_H_shift                                       (7)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDRST_H_mask                                        (0x00000080)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDRST_H(data)                                       (0x00000080&((data)<<7))
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDRST_H_src(data)                                   ((0x00000080&(data))>>7)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_WDRST_H(data)                                   ((0x00000080&(data))>>7)
+#define SYS_PLL_BUSH1_REG_PLLBUS_TESTSEL_H_shift                                     (6)
+#define SYS_PLL_BUSH1_REG_PLLBUS_TESTSEL_H_mask                                      (0x00000040)
+#define SYS_PLL_BUSH1_REG_PLLBUS_TESTSEL_H(data)                                     (0x00000040&((data)<<6))
+#define SYS_PLL_BUSH1_REG_PLLBUS_TESTSEL_H_src(data)                                 ((0x00000040&(data))>>6)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_TESTSEL_H(data)                                 ((0x00000040&(data))>>6)
+#define SYS_PLL_BUSH1_REG_PLLBUS_SEL_CCO_H_shift                                     (5)
+#define SYS_PLL_BUSH1_REG_PLLBUS_SEL_CCO_H_mask                                      (0x00000020)
+#define SYS_PLL_BUSH1_REG_PLLBUS_SEL_CCO_H(data)                                     (0x00000020&((data)<<5))
+#define SYS_PLL_BUSH1_REG_PLLBUS_SEL_CCO_H_src(data)                                 ((0x00000020&(data))>>5)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_SEL_CCO_H(data)                                 ((0x00000020&(data))>>5)
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_BPS_H_shift                                    (4)
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_BPS_H_mask                                     (0x00000010)
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_BPS_H(data)                                    (0x00000010&((data)<<4))
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_BPS_H_src(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_PDIV_BPS_H(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_BUSH1_REG_PLLBUS_DBUG_EN_H_shift                                     (3)
+#define SYS_PLL_BUSH1_REG_PLLBUS_DBUG_EN_H_mask                                      (0x00000008)
+#define SYS_PLL_BUSH1_REG_PLLBUS_DBUG_EN_H(data)                                     (0x00000008&((data)<<3))
+#define SYS_PLL_BUSH1_REG_PLLBUS_DBUG_EN_H_src(data)                                 ((0x00000008&(data))>>3)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_DBUG_EN_H(data)                                 ((0x00000008&(data))>>3)
+
+
+#define SYS_PLL_BUSH2                                                                0x1B8
+#define SYS_PLL_BUSH2_reg_addr                                                       "0x980001B8"
+#define SYS_PLL_BUSH2_reg                                                            0x980001B8
+#define set_SYS_PLL_BUSH2_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUSH2_reg)=data)
+#define get_SYS_PLL_BUSH2_reg   (*((volatile unsigned int*) SYS_PLL_BUSH2_reg))
+#define SYS_PLL_BUSH2_inst_adr                                                       "0x006E"
+#define SYS_PLL_BUSH2_inst                                                           0x006E
+#define SYS_PLL_BUSH2_REG_PLLBUS_OEB_H_shift                                         (2)
+#define SYS_PLL_BUSH2_REG_PLLBUS_OEB_H_mask                                          (0x00000004)
+#define SYS_PLL_BUSH2_REG_PLLBUS_OEB_H(data)                                         (0x00000004&((data)<<2))
+#define SYS_PLL_BUSH2_REG_PLLBUS_OEB_H_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_BUSH2_get_REG_PLLBUS_OEB_H(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_BUSH2_REG_PLLBUS_RSTB_H_shift                                        (1)
+#define SYS_PLL_BUSH2_REG_PLLBUS_RSTB_H_mask                                         (0x00000002)
+#define SYS_PLL_BUSH2_REG_PLLBUS_RSTB_H(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_BUSH2_REG_PLLBUS_RSTB_H_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_BUSH2_get_REG_PLLBUS_RSTB_H(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_BUSH2_REG_PLLBUS_POW_H_shift                                         (0)
+#define SYS_PLL_BUSH2_REG_PLLBUS_POW_H_mask                                          (0x00000001)
+#define SYS_PLL_BUSH2_REG_PLLBUS_POW_H(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_BUSH2_REG_PLLBUS_POW_H_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_BUSH2_get_REG_PLLBUS_POW_H(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_GPU1                                                                 0x1C0
+#define SYS_PLL_GPU1_reg_addr                                                        "0x980001C0"
+#define SYS_PLL_GPU1_reg                                                             0x980001C0
+#define set_SYS_PLL_GPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_GPU1_reg)=data)
+#define get_SYS_PLL_GPU1_reg   (*((volatile unsigned int*) SYS_PLL_GPU1_reg))
+#define SYS_PLL_GPU1_inst_adr                                                        "0x0070"
+#define SYS_PLL_GPU1_inst                                                            0x0070
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_shift                                           (17)
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_mask                                            (0x00060000)
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV(data)                                           (0x00060000&((data)<<17))
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_src(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_PDIV(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_RS_shift                                         (14)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_RS_mask                                          (0x0001C000)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_RS(data)                                         (0x0001C000&((data)<<14))
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_RS_src(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_LPF_RS(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_CS_shift                                         (12)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_CS_mask                                          (0x00003000)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_CS(data)                                         (0x00003000&((data)<<12))
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_CS_src(data)                                     ((0x00003000&(data))>>12)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_LPF_CS(data)                                     ((0x00003000&(data))>>12)
+#define SYS_PLL_GPU1_REG_PLLGPU_ICP_shift                                            (9)
+#define SYS_PLL_GPU1_REG_PLLGPU_ICP_mask                                             (0x00000E00)
+#define SYS_PLL_GPU1_REG_PLLGPU_ICP(data)                                            (0x00000E00&((data)<<9))
+#define SYS_PLL_GPU1_REG_PLLGPU_ICP_src(data)                                        ((0x00000E00&(data))>>9)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_ICP(data)                                        ((0x00000E00&(data))>>9)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST_shift                                          (8)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST_mask                                           (0x00000100)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST(data)                                          (0x00000100&((data)<<8))
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_WDRST(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET_shift                                          (7)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET_mask                                           (0x00000080)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET(data)                                          (0x00000080&((data)<<7))
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET_src(data)                                      ((0x00000080&(data))>>7)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_WDSET(data)                                      ((0x00000080&(data))>>7)
+#define SYS_PLL_GPU1_REG_PLLGPU_TESTSEL_shift                                        (6)
+#define SYS_PLL_GPU1_REG_PLLGPU_TESTSEL_mask                                         (0x00000040)
+#define SYS_PLL_GPU1_REG_PLLGPU_TESTSEL(data)                                        (0x00000040&((data)<<6))
+#define SYS_PLL_GPU1_REG_PLLGPU_TESTSEL_src(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_TESTSEL(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_GPU1_REG_PLLGPU_SEL_CCO_shift                                        (5)
+#define SYS_PLL_GPU1_REG_PLLGPU_SEL_CCO_mask                                         (0x00000020)
+#define SYS_PLL_GPU1_REG_PLLGPU_SEL_CCO(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_GPU1_REG_PLLGPU_SEL_CCO_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_SEL_CCO(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_BPS_shift                                       (4)
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_BPS_mask                                        (0x00000010)
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_BPS(data)                                       (0x00000010&((data)<<4))
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_BPS_src(data)                                   ((0x00000010&(data))>>4)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_PDIV_BPS(data)                                   ((0x00000010&(data))>>4)
+#define SYS_PLL_GPU1_REG_PLLGPU_DBUG_EN_shift                                        (3)
+#define SYS_PLL_GPU1_REG_PLLGPU_DBUG_EN_mask                                         (0x00000008)
+#define SYS_PLL_GPU1_REG_PLLGPU_DBUG_EN(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_GPU1_REG_PLLGPU_DBUG_EN_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_DBUG_EN(data)                                    ((0x00000008&(data))>>3)
+
+
+#define SYS_PLL_GPU2                                                                 0x1C4
+#define SYS_PLL_GPU2_reg_addr                                                        "0x980001C4"
+#define SYS_PLL_GPU2_reg                                                             0x980001C4
+#define set_SYS_PLL_GPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_GPU2_reg)=data)
+#define get_SYS_PLL_GPU2_reg   (*((volatile unsigned int*) SYS_PLL_GPU2_reg))
+#define SYS_PLL_GPU2_inst_adr                                                        "0x0071"
+#define SYS_PLL_GPU2_inst                                                            0x0071
+#define SYS_PLL_GPU2_REG_PLLGPU_OEB_shift                                            (2)
+#define SYS_PLL_GPU2_REG_PLLGPU_OEB_mask                                             (0x00000004)
+#define SYS_PLL_GPU2_REG_PLLGPU_OEB(data)                                            (0x00000004&((data)<<2))
+#define SYS_PLL_GPU2_REG_PLLGPU_OEB_src(data)                                        ((0x00000004&(data))>>2)
+#define SYS_PLL_GPU2_get_REG_PLLGPU_OEB(data)                                        ((0x00000004&(data))>>2)
+#define SYS_PLL_GPU2_REG_PLLGPU_RSTB_shift                                           (1)
+#define SYS_PLL_GPU2_REG_PLLGPU_RSTB_mask                                            (0x00000002)
+#define SYS_PLL_GPU2_REG_PLLGPU_RSTB(data)                                           (0x00000002&((data)<<1))
+#define SYS_PLL_GPU2_REG_PLLGPU_RSTB_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_GPU2_get_REG_PLLGPU_RSTB(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_GPU2_REG_PLLGPU_POW_shift                                            (0)
+#define SYS_PLL_GPU2_REG_PLLGPU_POW_mask                                             (0x00000001)
+#define SYS_PLL_GPU2_REG_PLLGPU_POW(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_GPU2_REG_PLLGPU_POW_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_GPU2_get_REG_PLLGPU_POW(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VE2_1                                                                0x1D0
+#define SYS_PLL_VE2_1_reg_addr                                                       "0x980001D0"
+#define SYS_PLL_VE2_1_reg                                                            0x980001D0
+#define set_SYS_PLL_VE2_1_reg(data)   (*((volatile unsigned int*) SYS_PLL_VE2_1_reg)=data)
+#define get_SYS_PLL_VE2_1_reg   (*((volatile unsigned int*) SYS_PLL_VE2_1_reg))
+#define SYS_PLL_VE2_1_inst_adr                                                       "0x0074"
+#define SYS_PLL_VE2_1_inst                                                           0x0074
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDRST_2_shift                                      (22)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDRST_2_mask                                       (0x00400000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDRST_2(data)                                      (0x00400000&((data)<<22))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDRST_2_src(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_WDRST_2(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDSET_2_shift                                      (21)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDSET_2_mask                                       (0x00200000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDSET_2(data)                                      (0x00200000&((data)<<21))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDSET_2_src(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_WDSET_2(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_CS_2_shift                                         (19)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_CS_2_mask                                          (0x00180000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_CS_2(data)                                         (0x00180000&((data)<<19))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_CS_2_src(data)                                     ((0x00180000&(data))>>19)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_CS_2(data)                                     ((0x00180000&(data))>>19)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_O_2_shift                                          (17)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_O_2_mask                                           (0x00060000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_O_2(data)                                          (0x00060000&((data)<<17))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_O_2_src(data)                                      ((0x00060000&(data))>>17)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_O_2(data)                                      ((0x00060000&(data))>>17)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_RS_2_shift                                         (14)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_RS_2_mask                                          (0x0001C000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_RS_2(data)                                         (0x0001C000&((data)<<14))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_RS_2_src(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_RS_2(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_N_2_shift                                          (12)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_N_2_mask                                           (0x00003000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_N_2(data)                                          (0x00003000&((data)<<12))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_N_2_src(data)                                      ((0x00003000&(data))>>12)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_N_2(data)                                      ((0x00003000&(data))>>12)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_M_2_shift                                          (4)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_M_2_mask                                           (0x00000FF0)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_M_2(data)                                          (0x00000FF0&((data)<<4))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_M_2_src(data)                                      ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_M_2(data)                                      ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_IP_2_shift                                         (1)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_IP_2_mask                                          (0x0000000E)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_IP_2(data)                                         (0x0000000E&((data)<<1))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_IP_2_src(data)                                     ((0x0000000E&(data))>>1)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_IP_2(data)                                     ((0x0000000E&(data))>>1)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_TST_2_shift                                        (0)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_TST_2_mask                                         (0x00000001)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_TST_2(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_TST_2_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_TST_2(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VE2_2                                                                0x1D4
+#define SYS_PLL_VE2_2_reg_addr                                                       "0x980001D4"
+#define SYS_PLL_VE2_2_reg                                                            0x980001D4
+#define set_SYS_PLL_VE2_2_reg(data)   (*((volatile unsigned int*) SYS_PLL_VE2_2_reg)=data)
+#define get_SYS_PLL_VE2_2_reg   (*((volatile unsigned int*) SYS_PLL_VE2_2_reg))
+#define SYS_PLL_VE2_2_inst_adr                                                       "0x0075"
+#define SYS_PLL_VE2_2_inst                                                           0x0075
+#define SYS_PLL_VE2_2_REG_PLLVCPU_OEB_2_shift                                        (2)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_OEB_2_mask                                         (0x00000004)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_OEB_2(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_VE2_2_REG_PLLVCPU_OEB_2_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_VE2_2_get_REG_PLLVCPU_OEB_2(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_RSTB_2_shift                                       (1)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_RSTB_2_mask                                        (0x00000002)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_RSTB_2(data)                                       (0x00000002&((data)<<1))
+#define SYS_PLL_VE2_2_REG_PLLVCPU_RSTB_2_src(data)                                   ((0x00000002&(data))>>1)
+#define SYS_PLL_VE2_2_get_REG_PLLVCPU_RSTB_2(data)                                   ((0x00000002&(data))>>1)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_POW_2_shift                                        (0)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_POW_2_mask                                         (0x00000001)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_POW_2(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_VE2_2_REG_PLLVCPU_POW_2_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_VE2_2_get_REG_PLLVCPU_POW_2(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SD1                                                                  0x1E0
+#define SYS_PLL_SD1_reg_addr                                                         "0x980001E0"
+#define SYS_PLL_SD1_reg                                                              0x980001E0
+#define set_SYS_PLL_SD1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD1_reg)=data)
+#define get_SYS_PLL_SD1_reg   (*((volatile unsigned int*) SYS_PLL_SD1_reg))
+#define SYS_PLL_SD1_inst_adr                                                         "0x0078"
+#define SYS_PLL_SD1_inst                                                             0x0078
+#define SYS_PLL_SD1_reg_sel3318_shift                                                (13)
+#define SYS_PLL_SD1_reg_sel3318_mask                                                 (0x00006000)
+#define SYS_PLL_SD1_reg_sel3318(data)                                                (0x00006000&((data)<<13))
+#define SYS_PLL_SD1_reg_sel3318_src(data)                                            ((0x00006000&(data))>>13)
+#define SYS_PLL_SD1_get_reg_sel3318(data)                                            ((0x00006000&(data))>>13)
+#define SYS_PLL_SD1_phsel1_shift                                                     (8)
+#define SYS_PLL_SD1_phsel1_mask                                                      (0x00001F00)
+#define SYS_PLL_SD1_phsel1(data)                                                     (0x00001F00&((data)<<8))
+#define SYS_PLL_SD1_phsel1_src(data)                                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SD1_get_phsel1(data)                                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SD1_phsel0_shift                                                     (3)
+#define SYS_PLL_SD1_phsel0_mask                                                      (0x000000F8)
+#define SYS_PLL_SD1_phsel0(data)                                                     (0x000000F8&((data)<<3))
+#define SYS_PLL_SD1_phsel0_src(data)                                                 ((0x000000F8&(data))>>3)
+#define SYS_PLL_SD1_get_phsel0(data)                                                 ((0x000000F8&(data))>>3)
+#define SYS_PLL_SD1_phrstb_dly_sel_shift                                             (2)
+#define SYS_PLL_SD1_phrstb_dly_sel_mask                                              (0x00000004)
+#define SYS_PLL_SD1_phrstb_dly_sel(data)                                             (0x00000004&((data)<<2))
+#define SYS_PLL_SD1_phrstb_dly_sel_src(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SD1_get_phrstb_dly_sel(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SD1_phrt0_shift                                                      (1)
+#define SYS_PLL_SD1_phrt0_mask                                                       (0x00000002)
+#define SYS_PLL_SD1_phrt0(data)                                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SD1_phrt0_src(data)                                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SD1_get_phrt0(data)                                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SD1_bias_en_shift                                                    (0)
+#define SYS_PLL_SD1_bias_en_mask                                                     (0x00000001)
+#define SYS_PLL_SD1_bias_en(data)                                                    (0x00000001&((data)<<0))
+#define SYS_PLL_SD1_bias_en_src(data)                                                ((0x00000001&(data))>>0)
+#define SYS_PLL_SD1_get_bias_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SD2                                                                  0x1E4
+#define SYS_PLL_SD2_reg_addr                                                         "0x980001E4"
+#define SYS_PLL_SD2_reg                                                              0x980001E4
+#define set_SYS_PLL_SD2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD2_reg)=data)
+#define get_SYS_PLL_SD2_reg   (*((volatile unsigned int*) SYS_PLL_SD2_reg))
+#define SYS_PLL_SD2_inst_adr                                                         "0x0079"
+#define SYS_PLL_SD2_inst                                                             0x0079
+#define SYS_PLL_SD2_en_cpnew_shift                                                   (26)
+#define SYS_PLL_SD2_en_cpnew_mask                                                    (0x04000000)
+#define SYS_PLL_SD2_en_cpnew(data)                                                   (0x04000000&((data)<<26))
+#define SYS_PLL_SD2_en_cpnew_src(data)                                               ((0x04000000&(data))>>26)
+#define SYS_PLL_SD2_get_en_cpnew(data)                                               ((0x04000000&(data))>>26)
+#define SYS_PLL_SD2_ssc_div_ext_f_shift                                              (18)
+#define SYS_PLL_SD2_ssc_div_ext_f_mask                                               (0x03FC0000)
+#define SYS_PLL_SD2_ssc_div_ext_f(data)                                              (0x03FC0000&((data)<<18))
+#define SYS_PLL_SD2_ssc_div_ext_f_src(data)                                          ((0x03FC0000&(data))>>18)
+#define SYS_PLL_SD2_get_ssc_div_ext_f(data)                                          ((0x03FC0000&(data))>>18)
+#define SYS_PLL_SD2_ssc_div_f_sel_shift                                              (17)
+#define SYS_PLL_SD2_ssc_div_f_sel_mask                                               (0x00020000)
+#define SYS_PLL_SD2_ssc_div_f_sel(data)                                              (0x00020000&((data)<<17))
+#define SYS_PLL_SD2_ssc_div_f_sel_src(data)                                          ((0x00020000&(data))>>17)
+#define SYS_PLL_SD2_get_ssc_div_f_sel(data)                                          ((0x00020000&(data))>>17)
+#define SYS_PLL_SD2_ssc_8x_en_shift                                                  (16)
+#define SYS_PLL_SD2_ssc_8x_en_mask                                                   (0x00010000)
+#define SYS_PLL_SD2_ssc_8x_en(data)                                                  (0x00010000&((data)<<16))
+#define SYS_PLL_SD2_ssc_8x_en_src(data)                                              ((0x00010000&(data))>>16)
+#define SYS_PLL_SD2_get_ssc_8x_en(data)                                              ((0x00010000&(data))>>16)
+#define SYS_PLL_SD2_ssc_depth_shift                                                  (13)
+#define SYS_PLL_SD2_ssc_depth_mask                                                   (0x0000E000)
+#define SYS_PLL_SD2_ssc_depth(data)                                                  (0x0000E000&((data)<<13))
+#define SYS_PLL_SD2_ssc_depth_src(data)                                              ((0x0000E000&(data))>>13)
+#define SYS_PLL_SD2_get_ssc_depth(data)                                              ((0x0000E000&(data))>>13)
+#define SYS_PLL_SD2_sscpll_rs_shift                                                  (10)
+#define SYS_PLL_SD2_sscpll_rs_mask                                                   (0x00001C00)
+#define SYS_PLL_SD2_sscpll_rs(data)                                                  (0x00001C00&((data)<<10))
+#define SYS_PLL_SD2_sscpll_rs_src(data)                                              ((0x00001C00&(data))>>10)
+#define SYS_PLL_SD2_get_sscpll_rs(data)                                              ((0x00001C00&(data))>>10)
+#define SYS_PLL_SD2_sscpll_icp_shift                                                 (5)
+#define SYS_PLL_SD2_sscpll_icp_mask                                                  (0x000003E0)
+#define SYS_PLL_SD2_sscpll_icp(data)                                                 (0x000003E0&((data)<<5))
+#define SYS_PLL_SD2_sscpll_icp_src(data)                                             ((0x000003E0&(data))>>5)
+#define SYS_PLL_SD2_get_sscpll_icp(data)                                             ((0x000003E0&(data))>>5)
+#define SYS_PLL_SD2_sscpll_cs1_shift                                                 (3)
+#define SYS_PLL_SD2_sscpll_cs1_mask                                                  (0x00000018)
+#define SYS_PLL_SD2_sscpll_cs1(data)                                                 (0x00000018&((data)<<3))
+#define SYS_PLL_SD2_sscpll_cs1_src(data)                                             ((0x00000018&(data))>>3)
+#define SYS_PLL_SD2_get_sscpll_cs1(data)                                             ((0x00000018&(data))>>3)
+#define SYS_PLL_SD2_reg_tune11_shift                                                 (1)
+#define SYS_PLL_SD2_reg_tune11_mask                                                  (0x00000006)
+#define SYS_PLL_SD2_reg_tune11(data)                                                 (0x00000006&((data)<<1))
+#define SYS_PLL_SD2_reg_tune11_src(data)                                             ((0x00000006&(data))>>1)
+#define SYS_PLL_SD2_get_reg_tune11(data)                                             ((0x00000006&(data))>>1)
+#define SYS_PLL_SD2_sscldo_en_shift                                                  (0)
+#define SYS_PLL_SD2_sscldo_en_mask                                                   (0x00000001)
+#define SYS_PLL_SD2_sscldo_en(data)                                                  (0x00000001&((data)<<0))
+#define SYS_PLL_SD2_sscldo_en_src(data)                                              ((0x00000001&(data))>>0)
+#define SYS_PLL_SD2_get_sscldo_en(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SD3                                                                  0x1E8
+#define SYS_PLL_SD3_reg_addr                                                         "0x980001E8"
+#define SYS_PLL_SD3_reg                                                              0x980001E8
+#define set_SYS_PLL_SD3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD3_reg)=data)
+#define get_SYS_PLL_SD3_reg   (*((volatile unsigned int*) SYS_PLL_SD3_reg))
+#define SYS_PLL_SD3_inst_adr                                                         "0x007A"
+#define SYS_PLL_SD3_inst                                                             0x007A
+#define SYS_PLL_SD3_ssc_div_n_shift                                                  (16)
+#define SYS_PLL_SD3_ssc_div_n_mask                                                   (0x03FF0000)
+#define SYS_PLL_SD3_ssc_div_n(data)                                                  (0x03FF0000&((data)<<16))
+#define SYS_PLL_SD3_ssc_div_n_src(data)                                              ((0x03FF0000&(data))>>16)
+#define SYS_PLL_SD3_get_ssc_div_n(data)                                              ((0x03FF0000&(data))>>16)
+#define SYS_PLL_SD3_ssc_step_in_shift                                                (8)
+#define SYS_PLL_SD3_ssc_step_in_mask                                                 (0x00007F00)
+#define SYS_PLL_SD3_ssc_step_in(data)                                                (0x00007F00&((data)<<8))
+#define SYS_PLL_SD3_ssc_step_in_src(data)                                            ((0x00007F00&(data))>>8)
+#define SYS_PLL_SD3_get_ssc_step_in(data)                                            ((0x00007F00&(data))>>8)
+#define SYS_PLL_SD3_ssc_tbase_shift                                                  (0)
+#define SYS_PLL_SD3_ssc_tbase_mask                                                   (0x000000FF)
+#define SYS_PLL_SD3_ssc_tbase(data)                                                  (0x000000FF&((data)<<0))
+#define SYS_PLL_SD3_ssc_tbase_src(data)                                              ((0x000000FF&(data))>>0)
+#define SYS_PLL_SD3_get_ssc_tbase(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SD4                                                                  0x1EC
+#define SYS_PLL_SD4_reg_addr                                                         "0x980001EC"
+#define SYS_PLL_SD4_reg                                                              0x980001EC
+#define set_SYS_PLL_SD4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD4_reg)=data)
+#define get_SYS_PLL_SD4_reg   (*((volatile unsigned int*) SYS_PLL_SD4_reg))
+#define SYS_PLL_SD4_inst_adr                                                         "0x007B"
+#define SYS_PLL_SD4_inst                                                             0x007B
+#define SYS_PLL_SD4_ssc_pll_pow_shift                                                (2)
+#define SYS_PLL_SD4_ssc_pll_pow_mask                                                 (0x00000004)
+#define SYS_PLL_SD4_ssc_pll_pow(data)                                                (0x00000004&((data)<<2))
+#define SYS_PLL_SD4_ssc_pll_pow_src(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_SD4_get_ssc_pll_pow(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_SD4_ssc_pll_rstb_shift                                               (1)
+#define SYS_PLL_SD4_ssc_pll_rstb_mask                                                (0x00000002)
+#define SYS_PLL_SD4_ssc_pll_rstb(data)                                               (0x00000002&((data)<<1))
+#define SYS_PLL_SD4_ssc_pll_rstb_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_SD4_get_ssc_pll_rstb(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_SD4_ssc_rstb_shift                                                   (0)
+#define SYS_PLL_SD4_ssc_rstb_mask                                                    (0x00000001)
+#define SYS_PLL_SD4_ssc_rstb(data)                                                   (0x00000001&((data)<<0))
+#define SYS_PLL_SD4_ssc_rstb_src(data)                                               ((0x00000001&(data))>>0)
+#define SYS_PLL_SD4_get_ssc_rstb(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EMMC1                                                                0x1F0
+#define SYS_PLL_EMMC1_reg_addr                                                       "0x980001F0"
+#define SYS_PLL_EMMC1_reg                                                            0x980001F0
+#define set_SYS_PLL_EMMC1_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC1_reg)=data)
+#define get_SYS_PLL_EMMC1_reg   (*((volatile unsigned int*) SYS_PLL_EMMC1_reg))
+#define SYS_PLL_EMMC1_inst_adr                                                       "0x007C"
+#define SYS_PLL_EMMC1_inst                                                           0x007C
+#define SYS_PLL_EMMC1_phsel1_shift                                                   (8)
+#define SYS_PLL_EMMC1_phsel1_mask                                                    (0x00001F00)
+#define SYS_PLL_EMMC1_phsel1(data)                                                   (0x00001F00&((data)<<8))
+#define SYS_PLL_EMMC1_phsel1_src(data)                                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_EMMC1_get_phsel1(data)                                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_EMMC1_phsel0_shift                                                   (3)
+#define SYS_PLL_EMMC1_phsel0_mask                                                    (0x000000F8)
+#define SYS_PLL_EMMC1_phsel0(data)                                                   (0x000000F8&((data)<<3))
+#define SYS_PLL_EMMC1_phsel0_src(data)                                               ((0x000000F8&(data))>>3)
+#define SYS_PLL_EMMC1_get_phsel0(data)                                               ((0x000000F8&(data))>>3)
+#define SYS_PLL_EMMC1_phrstb_dly_sel_shift                                           (2)
+#define SYS_PLL_EMMC1_phrstb_dly_sel_mask                                            (0x00000004)
+#define SYS_PLL_EMMC1_phrstb_dly_sel(data)                                           (0x00000004&((data)<<2))
+#define SYS_PLL_EMMC1_phrstb_dly_sel_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC1_get_phrstb_dly_sel(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC1_phrt0_shift                                                    (1)
+#define SYS_PLL_EMMC1_phrt0_mask                                                     (0x00000002)
+#define SYS_PLL_EMMC1_phrt0(data)                                                    (0x00000002&((data)<<1))
+#define SYS_PLL_EMMC1_phrt0_src(data)                                                ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC1_get_phrt0(data)                                                ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC1_bias_en_shift                                                  (0)
+#define SYS_PLL_EMMC1_bias_en_mask                                                   (0x00000001)
+#define SYS_PLL_EMMC1_bias_en(data)                                                  (0x00000001&((data)<<0))
+#define SYS_PLL_EMMC1_bias_en_src(data)                                              ((0x00000001&(data))>>0)
+#define SYS_PLL_EMMC1_get_bias_en(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EMMC2                                                                0x1F4
+#define SYS_PLL_EMMC2_reg_addr                                                       "0x980001F4"
+#define SYS_PLL_EMMC2_reg                                                            0x980001F4
+#define set_SYS_PLL_EMMC2_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC2_reg)=data)
+#define get_SYS_PLL_EMMC2_reg   (*((volatile unsigned int*) SYS_PLL_EMMC2_reg))
+#define SYS_PLL_EMMC2_inst_adr                                                       "0x007D"
+#define SYS_PLL_EMMC2_inst                                                           0x007D
+#define SYS_PLL_EMMC2_en_cpnew_shift                                                 (26)
+#define SYS_PLL_EMMC2_en_cpnew_mask                                                  (0x04000000)
+#define SYS_PLL_EMMC2_en_cpnew(data)                                                 (0x04000000&((data)<<26))
+#define SYS_PLL_EMMC2_en_cpnew_src(data)                                             ((0x04000000&(data))>>26)
+#define SYS_PLL_EMMC2_get_en_cpnew(data)                                             ((0x04000000&(data))>>26)
+#define SYS_PLL_EMMC2_ssc_div_ext_f_shift                                            (18)
+#define SYS_PLL_EMMC2_ssc_div_ext_f_mask                                             (0x03FC0000)
+#define SYS_PLL_EMMC2_ssc_div_ext_f(data)                                            (0x03FC0000&((data)<<18))
+#define SYS_PLL_EMMC2_ssc_div_ext_f_src(data)                                        ((0x03FC0000&(data))>>18)
+#define SYS_PLL_EMMC2_get_ssc_div_ext_f(data)                                        ((0x03FC0000&(data))>>18)
+#define SYS_PLL_EMMC2_ssc_div_f_sel_shift                                            (17)
+#define SYS_PLL_EMMC2_ssc_div_f_sel_mask                                             (0x00020000)
+#define SYS_PLL_EMMC2_ssc_div_f_sel(data)                                            (0x00020000&((data)<<17))
+#define SYS_PLL_EMMC2_ssc_div_f_sel_src(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PLL_EMMC2_get_ssc_div_f_sel(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PLL_EMMC2_ssc_8x_en_shift                                                (16)
+#define SYS_PLL_EMMC2_ssc_8x_en_mask                                                 (0x00010000)
+#define SYS_PLL_EMMC2_ssc_8x_en(data)                                                (0x00010000&((data)<<16))
+#define SYS_PLL_EMMC2_ssc_8x_en_src(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_EMMC2_get_ssc_8x_en(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_EMMC2_ssc_depth_shift                                                (13)
+#define SYS_PLL_EMMC2_ssc_depth_mask                                                 (0x0000E000)
+#define SYS_PLL_EMMC2_ssc_depth(data)                                                (0x0000E000&((data)<<13))
+#define SYS_PLL_EMMC2_ssc_depth_src(data)                                            ((0x0000E000&(data))>>13)
+#define SYS_PLL_EMMC2_get_ssc_depth(data)                                            ((0x0000E000&(data))>>13)
+#define SYS_PLL_EMMC2_sscpll_rs_shift                                                (10)
+#define SYS_PLL_EMMC2_sscpll_rs_mask                                                 (0x00001C00)
+#define SYS_PLL_EMMC2_sscpll_rs(data)                                                (0x00001C00&((data)<<10))
+#define SYS_PLL_EMMC2_sscpll_rs_src(data)                                            ((0x00001C00&(data))>>10)
+#define SYS_PLL_EMMC2_get_sscpll_rs(data)                                            ((0x00001C00&(data))>>10)
+#define SYS_PLL_EMMC2_sscpll_icp_shift                                               (5)
+#define SYS_PLL_EMMC2_sscpll_icp_mask                                                (0x000003E0)
+#define SYS_PLL_EMMC2_sscpll_icp(data)                                               (0x000003E0&((data)<<5))
+#define SYS_PLL_EMMC2_sscpll_icp_src(data)                                           ((0x000003E0&(data))>>5)
+#define SYS_PLL_EMMC2_get_sscpll_icp(data)                                           ((0x000003E0&(data))>>5)
+#define SYS_PLL_EMMC2_sscpll_cs1_shift                                               (3)
+#define SYS_PLL_EMMC2_sscpll_cs1_mask                                                (0x00000018)
+#define SYS_PLL_EMMC2_sscpll_cs1(data)                                               (0x00000018&((data)<<3))
+#define SYS_PLL_EMMC2_sscpll_cs1_src(data)                                           ((0x00000018&(data))>>3)
+#define SYS_PLL_EMMC2_get_sscpll_cs1(data)                                           ((0x00000018&(data))>>3)
+#define SYS_PLL_EMMC2_reg_tune11_shift                                               (1)
+#define SYS_PLL_EMMC2_reg_tune11_mask                                                (0x00000006)
+#define SYS_PLL_EMMC2_reg_tune11(data)                                               (0x00000006&((data)<<1))
+#define SYS_PLL_EMMC2_reg_tune11_src(data)                                           ((0x00000006&(data))>>1)
+#define SYS_PLL_EMMC2_get_reg_tune11(data)                                           ((0x00000006&(data))>>1)
+#define SYS_PLL_EMMC2_sscldo_en_shift                                                (0)
+#define SYS_PLL_EMMC2_sscldo_en_mask                                                 (0x00000001)
+#define SYS_PLL_EMMC2_sscldo_en(data)                                                (0x00000001&((data)<<0))
+#define SYS_PLL_EMMC2_sscldo_en_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_PLL_EMMC2_get_sscldo_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EMMC3                                                                0x1F8
+#define SYS_PLL_EMMC3_reg_addr                                                       "0x980001F8"
+#define SYS_PLL_EMMC3_reg                                                            0x980001F8
+#define set_SYS_PLL_EMMC3_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC3_reg)=data)
+#define get_SYS_PLL_EMMC3_reg   (*((volatile unsigned int*) SYS_PLL_EMMC3_reg))
+#define SYS_PLL_EMMC3_inst_adr                                                       "0x007E"
+#define SYS_PLL_EMMC3_inst                                                           0x007E
+#define SYS_PLL_EMMC3_ssc_div_n_shift                                                (16)
+#define SYS_PLL_EMMC3_ssc_div_n_mask                                                 (0x03FF0000)
+#define SYS_PLL_EMMC3_ssc_div_n(data)                                                (0x03FF0000&((data)<<16))
+#define SYS_PLL_EMMC3_ssc_div_n_src(data)                                            ((0x03FF0000&(data))>>16)
+#define SYS_PLL_EMMC3_get_ssc_div_n(data)                                            ((0x03FF0000&(data))>>16)
+#define SYS_PLL_EMMC3_ssc_step_in_shift                                              (8)
+#define SYS_PLL_EMMC3_ssc_step_in_mask                                               (0x00007F00)
+#define SYS_PLL_EMMC3_ssc_step_in(data)                                              (0x00007F00&((data)<<8))
+#define SYS_PLL_EMMC3_ssc_step_in_src(data)                                          ((0x00007F00&(data))>>8)
+#define SYS_PLL_EMMC3_get_ssc_step_in(data)                                          ((0x00007F00&(data))>>8)
+#define SYS_PLL_EMMC3_ssc_tbase_shift                                                (0)
+#define SYS_PLL_EMMC3_ssc_tbase_mask                                                 (0x000000FF)
+#define SYS_PLL_EMMC3_ssc_tbase(data)                                                (0x000000FF&((data)<<0))
+#define SYS_PLL_EMMC3_ssc_tbase_src(data)                                            ((0x000000FF&(data))>>0)
+#define SYS_PLL_EMMC3_get_ssc_tbase(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_EMMC4                                                                0x1FC
+#define SYS_PLL_EMMC4_reg_addr                                                       "0x980001FC"
+#define SYS_PLL_EMMC4_reg                                                            0x980001FC
+#define set_SYS_PLL_EMMC4_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC4_reg)=data)
+#define get_SYS_PLL_EMMC4_reg   (*((volatile unsigned int*) SYS_PLL_EMMC4_reg))
+#define SYS_PLL_EMMC4_inst_adr                                                       "0x007F"
+#define SYS_PLL_EMMC4_inst                                                           0x007F
+#define SYS_PLL_EMMC4_ssc_pll_pow_shift                                              (2)
+#define SYS_PLL_EMMC4_ssc_pll_pow_mask                                               (0x00000004)
+#define SYS_PLL_EMMC4_ssc_pll_pow(data)                                              (0x00000004&((data)<<2))
+#define SYS_PLL_EMMC4_ssc_pll_pow_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC4_get_ssc_pll_pow(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC4_ssc_pll_rstb_shift                                             (1)
+#define SYS_PLL_EMMC4_ssc_pll_rstb_mask                                              (0x00000002)
+#define SYS_PLL_EMMC4_ssc_pll_rstb(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_EMMC4_ssc_pll_rstb_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC4_get_ssc_pll_rstb(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC4_ssc_rstb_shift                                                 (0)
+#define SYS_PLL_EMMC4_ssc_rstb_mask                                                  (0x00000001)
+#define SYS_PLL_EMMC4_ssc_rstb(data)                                                 (0x00000001&((data)<<0))
+#define SYS_PLL_EMMC4_ssc_rstb_src(data)                                             ((0x00000001&(data))>>0)
+#define SYS_PLL_EMMC4_get_ssc_rstb(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_OTHER                                                                0x200
+#define SYS_PLL_OTHER_reg_addr                                                       "0x98000200"
+#define SYS_PLL_OTHER_reg                                                            0x98000200
+#define set_SYS_PLL_OTHER_reg(data)   (*((volatile unsigned int*) SYS_PLL_OTHER_reg)=data)
+#define get_SYS_PLL_OTHER_reg   (*((volatile unsigned int*) SYS_PLL_OTHER_reg))
+#define SYS_PLL_OTHER_inst_adr                                                       "0x0080"
+#define SYS_PLL_OTHER_inst                                                           0x0080
+#define SYS_PLL_OTHER_REG_TEST_SEL_shift                                             (12)
+#define SYS_PLL_OTHER_REG_TEST_SEL_mask                                              (0x00003000)
+#define SYS_PLL_OTHER_REG_TEST_SEL(data)                                             (0x00003000&((data)<<12))
+#define SYS_PLL_OTHER_REG_TEST_SEL_src(data)                                         ((0x00003000&(data))>>12)
+#define SYS_PLL_OTHER_get_REG_TEST_SEL(data)                                         ((0x00003000&(data))>>12)
+#define SYS_PLL_OTHER_POR_VSET_shift                                                 (11)
+#define SYS_PLL_OTHER_POR_VSET_mask                                                  (0x00000800)
+#define SYS_PLL_OTHER_POR_VSET(data)                                                 (0x00000800&((data)<<11))
+#define SYS_PLL_OTHER_POR_VSET_src(data)                                             ((0x00000800&(data))>>11)
+#define SYS_PLL_OTHER_get_POR_VSET(data)                                             ((0x00000800&(data))>>11)
+#define SYS_PLL_OTHER_REG_PLLDDSB_CKIN_SEL_shift                                     (10)
+#define SYS_PLL_OTHER_REG_PLLDDSB_CKIN_SEL_mask                                      (0x00000400)
+#define SYS_PLL_OTHER_REG_PLLDDSB_CKIN_SEL(data)                                     (0x00000400&((data)<<10))
+#define SYS_PLL_OTHER_REG_PLLDDSB_CKIN_SEL_src(data)                                 ((0x00000400&(data))>>10)
+#define SYS_PLL_OTHER_get_REG_PLLDDSB_CKIN_SEL(data)                                 ((0x00000400&(data))>>10)
+#define SYS_PLL_OTHER_REG_PLLDISP_SEL_shift                                          (8)
+#define SYS_PLL_OTHER_REG_PLLDISP_SEL_mask                                           (0x00000300)
+#define SYS_PLL_OTHER_REG_PLLDISP_SEL(data)                                          (0x00000300&((data)<<8))
+#define SYS_PLL_OTHER_REG_PLLDISP_SEL_src(data)                                      ((0x00000300&(data))>>8)
+#define SYS_PLL_OTHER_get_REG_PLLDISP_SEL(data)                                      ((0x00000300&(data))>>8)
+#define SYS_PLL_OTHER_REG_HDMITX_27M_SEL_shift                                       (6)
+#define SYS_PLL_OTHER_REG_HDMITX_27M_SEL_mask                                        (0x000000C0)
+#define SYS_PLL_OTHER_REG_HDMITX_27M_SEL(data)                                       (0x000000C0&((data)<<6))
+#define SYS_PLL_OTHER_REG_HDMITX_27M_SEL_src(data)                                   ((0x000000C0&(data))>>6)
+#define SYS_PLL_OTHER_get_REG_HDMITX_27M_SEL(data)                                   ((0x000000C0&(data))>>6)
+#define SYS_PLL_OTHER_REG_PLLGPU_BYPASS_PI_shift                                     (5)
+#define SYS_PLL_OTHER_REG_PLLGPU_BYPASS_PI_mask                                      (0x00000020)
+#define SYS_PLL_OTHER_REG_PLLGPU_BYPASS_PI(data)                                     (0x00000020&((data)<<5))
+#define SYS_PLL_OTHER_REG_PLLGPU_BYPASS_PI_src(data)                                 ((0x00000020&(data))>>5)
+#define SYS_PLL_OTHER_get_REG_PLLGPU_BYPASS_PI(data)                                 ((0x00000020&(data))>>5)
+#define SYS_PLL_OTHER_REG_PLLDDSB_BYPASS_PI_shift                                    (4)
+#define SYS_PLL_OTHER_REG_PLLDDSB_BYPASS_PI_mask                                     (0x00000010)
+#define SYS_PLL_OTHER_REG_PLLDDSB_BYPASS_PI(data)                                    (0x00000010&((data)<<4))
+#define SYS_PLL_OTHER_REG_PLLDDSB_BYPASS_PI_src(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_OTHER_get_REG_PLLDDSB_BYPASS_PI(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_OTHER_REG_PLLDDSA_BYPASS_PI_shift                                    (3)
+#define SYS_PLL_OTHER_REG_PLLDDSA_BYPASS_PI_mask                                     (0x00000008)
+#define SYS_PLL_OTHER_REG_PLLDDSA_BYPASS_PI(data)                                    (0x00000008&((data)<<3))
+#define SYS_PLL_OTHER_REG_PLLDDSA_BYPASS_PI_src(data)                                ((0x00000008&(data))>>3)
+#define SYS_PLL_OTHER_get_REG_PLLDDSA_BYPASS_PI(data)                                ((0x00000008&(data))>>3)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_H_shift                                   (2)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_H_mask                                    (0x00000004)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_H(data)                                   (0x00000004&((data)<<2))
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_H_src(data)                               ((0x00000004&(data))>>2)
+#define SYS_PLL_OTHER_get_REG_PLLBUS_BYPASS_PI_H(data)                               ((0x00000004&(data))>>2)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_shift                                     (1)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_mask                                      (0x00000002)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI(data)                                     (0x00000002&((data)<<1))
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_src(data)                                 ((0x00000002&(data))>>1)
+#define SYS_PLL_OTHER_get_REG_PLLBUS_BYPASS_PI(data)                                 ((0x00000002&(data))>>1)
+#define SYS_PLL_OTHER_REG_PLLACPU_BYPASS_PI_shift                                    (0)
+#define SYS_PLL_OTHER_REG_PLLACPU_BYPASS_PI_mask                                     (0x00000001)
+#define SYS_PLL_OTHER_REG_PLLACPU_BYPASS_PI(data)                                    (0x00000001&((data)<<0))
+#define SYS_PLL_OTHER_REG_PLLACPU_BYPASS_PI_src(data)                                ((0x00000001&(data))>>0)
+#define SYS_PLL_OTHER_get_REG_PLLACPU_BYPASS_PI(data)                                ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD1                                                             0x204
+#define SYS_PLL_HDMI_SD1_reg_addr                                                    "0x98000204"
+#define SYS_PLL_HDMI_SD1_reg                                                         0x98000204
+#define set_SYS_PLL_HDMI_SD1_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD1_reg)=data)
+#define get_SYS_PLL_HDMI_SD1_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD1_reg))
+#define SYS_PLL_HDMI_SD1_inst_adr                                                    "0x0081"
+#define SYS_PLL_HDMI_SD1_inst                                                        0x0081
+#define SYS_PLL_HDMI_SD1_time_rdy_ckout_shift                                        (30)
+#define SYS_PLL_HDMI_SD1_time_rdy_ckout_mask                                         (0xC0000000)
+#define SYS_PLL_HDMI_SD1_time_rdy_ckout(data)                                        (0xC0000000&((data)<<30))
+#define SYS_PLL_HDMI_SD1_time_rdy_ckout_src(data)                                    ((0xC0000000&(data))>>30)
+#define SYS_PLL_HDMI_SD1_get_time_rdy_ckout(data)                                    ((0xC0000000&(data))>>30)
+#define SYS_PLL_HDMI_SD1_time2_rst_width_shift                                       (28)
+#define SYS_PLL_HDMI_SD1_time2_rst_width_mask                                        (0x30000000)
+#define SYS_PLL_HDMI_SD1_time2_rst_width(data)                                       (0x30000000&((data)<<28))
+#define SYS_PLL_HDMI_SD1_time2_rst_width_src(data)                                   ((0x30000000&(data))>>28)
+#define SYS_PLL_HDMI_SD1_get_time2_rst_width(data)                                   ((0x30000000&(data))>>28)
+#define SYS_PLL_HDMI_SD1_pcr_rst_n_shift                                             (27)
+#define SYS_PLL_HDMI_SD1_pcr_rst_n_mask                                              (0x08000000)
+#define SYS_PLL_HDMI_SD1_pcr_rst_n(data)                                             (0x08000000&((data)<<27))
+#define SYS_PLL_HDMI_SD1_pcr_rst_n_src(data)                                         ((0x08000000&(data))>>27)
+#define SYS_PLL_HDMI_SD1_get_pcr_rst_n(data)                                         ((0x08000000&(data))>>27)
+#define SYS_PLL_HDMI_SD1_time0_ck_shift                                              (24)
+#define SYS_PLL_HDMI_SD1_time0_ck_mask                                               (0x07000000)
+#define SYS_PLL_HDMI_SD1_time0_ck(data)                                              (0x07000000&((data)<<24))
+#define SYS_PLL_HDMI_SD1_time0_ck_src(data)                                          ((0x07000000&(data))>>24)
+#define SYS_PLL_HDMI_SD1_get_time0_ck(data)                                          ((0x07000000&(data))>>24)
+#define SYS_PLL_HDMI_SD1_f390k_shift                                                 (22)
+#define SYS_PLL_HDMI_SD1_f390k_mask                                                  (0x00C00000)
+#define SYS_PLL_HDMI_SD1_f390k(data)                                                 (0x00C00000&((data)<<22))
+#define SYS_PLL_HDMI_SD1_f390k_src(data)                                             ((0x00C00000&(data))>>22)
+#define SYS_PLL_HDMI_SD1_get_f390k(data)                                             ((0x00C00000&(data))>>22)
+#define SYS_PLL_HDMI_SD1_pll_en_shift                                                (21)
+#define SYS_PLL_HDMI_SD1_pll_en_mask                                                 (0x00200000)
+#define SYS_PLL_HDMI_SD1_pll_en(data)                                                (0x00200000&((data)<<21))
+#define SYS_PLL_HDMI_SD1_pll_en_src(data)                                            ((0x00200000&(data))>>21)
+#define SYS_PLL_HDMI_SD1_get_pll_en(data)                                            ((0x00200000&(data))>>21)
+#define SYS_PLL_HDMI_SD1_en_wdog_shift                                               (20)
+#define SYS_PLL_HDMI_SD1_en_wdog_mask                                                (0x00100000)
+#define SYS_PLL_HDMI_SD1_en_wdog(data)                                               (0x00100000&((data)<<20))
+#define SYS_PLL_HDMI_SD1_en_wdog_src(data)                                           ((0x00100000&(data))>>20)
+#define SYS_PLL_HDMI_SD1_get_en_wdog(data)                                           ((0x00100000&(data))>>20)
+#define SYS_PLL_HDMI_SD1_ssc_ckinv_shift                                             (19)
+#define SYS_PLL_HDMI_SD1_ssc_ckinv_mask                                              (0x00080000)
+#define SYS_PLL_HDMI_SD1_ssc_ckinv(data)                                             (0x00080000&((data)<<19))
+#define SYS_PLL_HDMI_SD1_ssc_ckinv_src(data)                                         ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD1_get_ssc_ckinv(data)                                         ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD1_fcode_shift                                                 (8)
+#define SYS_PLL_HDMI_SD1_fcode_mask                                                  (0x0007FF00)
+#define SYS_PLL_HDMI_SD1_fcode(data)                                                 (0x0007FF00&((data)<<8))
+#define SYS_PLL_HDMI_SD1_fcode_src(data)                                             ((0x0007FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD1_get_fcode(data)                                             ((0x0007FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD1_ncode_shift                                                 (0)
+#define SYS_PLL_HDMI_SD1_ncode_mask                                                  (0x000000FF)
+#define SYS_PLL_HDMI_SD1_ncode(data)                                                 (0x000000FF&((data)<<0))
+#define SYS_PLL_HDMI_SD1_ncode_src(data)                                             ((0x000000FF&(data))>>0)
+#define SYS_PLL_HDMI_SD1_get_ncode(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD2                                                             0x208
+#define SYS_PLL_HDMI_SD2_reg_addr                                                    "0x98000208"
+#define SYS_PLL_HDMI_SD2_reg                                                         0x98000208
+#define set_SYS_PLL_HDMI_SD2_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD2_reg)=data)
+#define get_SYS_PLL_HDMI_SD2_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD2_reg))
+#define SYS_PLL_HDMI_SD2_inst_adr                                                    "0x0082"
+#define SYS_PLL_HDMI_SD2_inst                                                        0x0082
+#define SYS_PLL_HDMI_SD2_bypass_pi_shift                                             (31)
+#define SYS_PLL_HDMI_SD2_bypass_pi_mask                                              (0x80000000)
+#define SYS_PLL_HDMI_SD2_bypass_pi(data)                                             (0x80000000&((data)<<31))
+#define SYS_PLL_HDMI_SD2_bypass_pi_src(data)                                         ((0x80000000&(data))>>31)
+#define SYS_PLL_HDMI_SD2_get_bypass_pi(data)                                         ((0x80000000&(data))>>31)
+#define SYS_PLL_HDMI_SD2_en_pi_debug_shift                                           (30)
+#define SYS_PLL_HDMI_SD2_en_pi_debug_mask                                            (0x40000000)
+#define SYS_PLL_HDMI_SD2_en_pi_debug(data)                                           (0x40000000&((data)<<30))
+#define SYS_PLL_HDMI_SD2_en_pi_debug_src(data)                                       ((0x40000000&(data))>>30)
+#define SYS_PLL_HDMI_SD2_get_en_pi_debug(data)                                       ((0x40000000&(data))>>30)
+#define SYS_PLL_HDMI_SD2_hs_oc_stop_diff_shift                                       (28)
+#define SYS_PLL_HDMI_SD2_hs_oc_stop_diff_mask                                        (0x30000000)
+#define SYS_PLL_HDMI_SD2_hs_oc_stop_diff(data)                                       (0x30000000&((data)<<28))
+#define SYS_PLL_HDMI_SD2_hs_oc_stop_diff_src(data)                                   ((0x30000000&(data))>>28)
+#define SYS_PLL_HDMI_SD2_get_hs_oc_stop_diff(data)                                   ((0x30000000&(data))>>28)
+#define SYS_PLL_HDMI_SD2_sel_oc_mode_shift                                           (24)
+#define SYS_PLL_HDMI_SD2_sel_oc_mode_mask                                            (0x03000000)
+#define SYS_PLL_HDMI_SD2_sel_oc_mode(data)                                           (0x03000000&((data)<<24))
+#define SYS_PLL_HDMI_SD2_sel_oc_mode_src(data)                                       ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_SD2_get_sel_oc_mode(data)                                       ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_SD2_oc_done_delay_shift                                         (16)
+#define SYS_PLL_HDMI_SD2_oc_done_delay_mask                                          (0x003F0000)
+#define SYS_PLL_HDMI_SD2_oc_done_delay(data)                                         (0x003F0000&((data)<<16))
+#define SYS_PLL_HDMI_SD2_oc_done_delay_src(data)                                     ((0x003F0000&(data))>>16)
+#define SYS_PLL_HDMI_SD2_get_oc_done_delay(data)                                     ((0x003F0000&(data))>>16)
+#define SYS_PLL_HDMI_SD2_pi_cur_sel_shift                                            (12)
+#define SYS_PLL_HDMI_SD2_pi_cur_sel_mask                                             (0x00007000)
+#define SYS_PLL_HDMI_SD2_pi_cur_sel(data)                                            (0x00007000&((data)<<12))
+#define SYS_PLL_HDMI_SD2_pi_cur_sel_src(data)                                        ((0x00007000&(data))>>12)
+#define SYS_PLL_HDMI_SD2_get_pi_cur_sel(data)                                        ((0x00007000&(data))>>12)
+#define SYS_PLL_HDMI_SD2_oc_step_set_shift                                           (2)
+#define SYS_PLL_HDMI_SD2_oc_step_set_mask                                            (0x00000FFC)
+#define SYS_PLL_HDMI_SD2_oc_step_set(data)                                           (0x00000FFC&((data)<<2))
+#define SYS_PLL_HDMI_SD2_oc_step_set_src(data)                                       ((0x00000FFC&(data))>>2)
+#define SYS_PLL_HDMI_SD2_get_oc_step_set(data)                                       ((0x00000FFC&(data))>>2)
+#define SYS_PLL_HDMI_SD2_sdm_order_shift                                             (1)
+#define SYS_PLL_HDMI_SD2_sdm_order_mask                                              (0x00000002)
+#define SYS_PLL_HDMI_SD2_sdm_order(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_HDMI_SD2_sdm_order_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_SD2_get_sdm_order(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_SD2_oc_en_shift                                                 (0)
+#define SYS_PLL_HDMI_SD2_oc_en_mask                                                  (0x00000001)
+#define SYS_PLL_HDMI_SD2_oc_en(data)                                                 (0x00000001&((data)<<0))
+#define SYS_PLL_HDMI_SD2_oc_en_src(data)                                             ((0x00000001&(data))>>0)
+#define SYS_PLL_HDMI_SD2_get_oc_en(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD3                                                             0x210
+#define SYS_PLL_HDMI_SD3_reg_addr                                                    "0x98000210"
+#define SYS_PLL_HDMI_SD3_reg                                                         0x98000210
+#define set_SYS_PLL_HDMI_SD3_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD3_reg)=data)
+#define get_SYS_PLL_HDMI_SD3_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD3_reg))
+#define SYS_PLL_HDMI_SD3_inst_adr                                                    "0x0084"
+#define SYS_PLL_HDMI_SD3_inst                                                        0x0084
+#define SYS_PLL_HDMI_SD3_load_fcw_shift                                              (31)
+#define SYS_PLL_HDMI_SD3_load_fcw_mask                                               (0x80000000)
+#define SYS_PLL_HDMI_SD3_load_fcw(data)                                              (0x80000000&((data)<<31))
+#define SYS_PLL_HDMI_SD3_load_fcw_src(data)                                          ((0x80000000&(data))>>31)
+#define SYS_PLL_HDMI_SD3_get_load_fcw(data)                                          ((0x80000000&(data))>>31)
+#define SYS_PLL_HDMI_SD3_fmod_shift                                                  (27)
+#define SYS_PLL_HDMI_SD3_fmod_mask                                                   (0x08000000)
+#define SYS_PLL_HDMI_SD3_fmod(data)                                                  (0x08000000&((data)<<27))
+#define SYS_PLL_HDMI_SD3_fmod_src(data)                                              ((0x08000000&(data))>>27)
+#define SYS_PLL_HDMI_SD3_get_fmod(data)                                              ((0x08000000&(data))>>27)
+#define SYS_PLL_HDMI_SD3_fcode_debug_shift                                           (16)
+#define SYS_PLL_HDMI_SD3_fcode_debug_mask                                            (0x07FF0000)
+#define SYS_PLL_HDMI_SD3_fcode_debug(data)                                           (0x07FF0000&((data)<<16))
+#define SYS_PLL_HDMI_SD3_fcode_debug_src(data)                                       ((0x07FF0000&(data))>>16)
+#define SYS_PLL_HDMI_SD3_get_fcode_debug(data)                                       ((0x07FF0000&(data))>>16)
+#define SYS_PLL_HDMI_SD3_ncode_debug_shift                                           (8)
+#define SYS_PLL_HDMI_SD3_ncode_debug_mask                                            (0x0000FF00)
+#define SYS_PLL_HDMI_SD3_ncode_debug(data)                                           (0x0000FF00&((data)<<8))
+#define SYS_PLL_HDMI_SD3_ncode_debug_src(data)                                       ((0x0000FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD3_get_ncode_debug(data)                                       ((0x0000FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD3_clkrdy_shift                                                (1)
+#define SYS_PLL_HDMI_SD3_clkrdy_mask                                                 (0x00000002)
+#define SYS_PLL_HDMI_SD3_clkrdy(data)                                                (0x00000002&((data)<<1))
+#define SYS_PLL_HDMI_SD3_clkrdy_src(data)                                            ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_SD3_get_clkrdy(data)                                            ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_SD3_oc_done_shift                                               (0)
+#define SYS_PLL_HDMI_SD3_oc_done_mask                                                (0x00000001)
+#define SYS_PLL_HDMI_SD3_oc_done(data)                                               (0x00000001&((data)<<0))
+#define SYS_PLL_HDMI_SD3_oc_done_src(data)                                           ((0x00000001&(data))>>0)
+#define SYS_PLL_HDMI_SD3_get_oc_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD4                                                             0x21c
+#define SYS_PLL_HDMI_SD4_reg_addr                                                    "0x9800021C"
+#define SYS_PLL_HDMI_SD4_reg                                                         0x9800021C
+#define set_SYS_PLL_HDMI_SD4_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD4_reg)=data)
+#define get_SYS_PLL_HDMI_SD4_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD4_reg))
+#define SYS_PLL_HDMI_SD4_inst_adr                                                    "0x0087"
+#define SYS_PLL_HDMI_SD4_inst                                                        0x0087
+#define SYS_PLL_HDMI_SD4_ssc_en_shift                                                (19)
+#define SYS_PLL_HDMI_SD4_ssc_en_mask                                                 (0x00080000)
+#define SYS_PLL_HDMI_SD4_ssc_en(data)                                                (0x00080000&((data)<<19))
+#define SYS_PLL_HDMI_SD4_ssc_en_src(data)                                            ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD4_get_ssc_en(data)                                            ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD4_fcode_ssc_shift                                             (8)
+#define SYS_PLL_HDMI_SD4_fcode_ssc_mask                                              (0x0007FF00)
+#define SYS_PLL_HDMI_SD4_fcode_ssc(data)                                             (0x0007FF00&((data)<<8))
+#define SYS_PLL_HDMI_SD4_fcode_ssc_src(data)                                         ((0x0007FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD4_get_fcode_ssc(data)                                         ((0x0007FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD4_ncode_ssc_shift                                             (0)
+#define SYS_PLL_HDMI_SD4_ncode_ssc_mask                                              (0x000000FF)
+#define SYS_PLL_HDMI_SD4_ncode_ssc(data)                                             (0x000000FF&((data)<<0))
+#define SYS_PLL_HDMI_SD4_ncode_ssc_src(data)                                         ((0x000000FF&(data))>>0)
+#define SYS_PLL_HDMI_SD4_get_ncode_ssc(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD5                                                             0x220
+#define SYS_PLL_HDMI_SD5_reg_addr                                                    "0x98000220"
+#define SYS_PLL_HDMI_SD5_reg                                                         0x98000220
+#define set_SYS_PLL_HDMI_SD5_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD5_reg)=data)
+#define get_SYS_PLL_HDMI_SD5_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD5_reg))
+#define SYS_PLL_HDMI_SD5_inst_adr                                                    "0x0088"
+#define SYS_PLL_HDMI_SD5_inst                                                        0x0088
+#define SYS_PLL_HDMI_SD5_RSTB_HDMITX_shift                                           (23)
+#define SYS_PLL_HDMI_SD5_RSTB_HDMITX_mask                                            (0x00800000)
+#define SYS_PLL_HDMI_SD5_RSTB_HDMITX(data)                                           (0x00800000&((data)<<23))
+#define SYS_PLL_HDMI_SD5_RSTB_HDMITX_src(data)                                       ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_SD5_get_RSTB_HDMITX(data)                                       ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_SD5_gran_auto_rst_shift                                         (22)
+#define SYS_PLL_HDMI_SD5_gran_auto_rst_mask                                          (0x00400000)
+#define SYS_PLL_HDMI_SD5_gran_auto_rst(data)                                         (0x00400000&((data)<<22))
+#define SYS_PLL_HDMI_SD5_gran_auto_rst_src(data)                                     ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_SD5_get_gran_auto_rst(data)                                     ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_SD5_dot_gran_shift                                              (19)
+#define SYS_PLL_HDMI_SD5_dot_gran_mask                                               (0x00380000)
+#define SYS_PLL_HDMI_SD5_dot_gran(data)                                              (0x00380000&((data)<<19))
+#define SYS_PLL_HDMI_SD5_dot_gran_src(data)                                          ((0x00380000&(data))>>19)
+#define SYS_PLL_HDMI_SD5_get_dot_gran(data)                                          ((0x00380000&(data))>>19)
+#define SYS_PLL_HDMI_SD5_gran_est_shift                                              (0)
+#define SYS_PLL_HDMI_SD5_gran_est_mask                                               (0x0007FFFF)
+#define SYS_PLL_HDMI_SD5_gran_est(data)                                              (0x0007FFFF&((data)<<0))
+#define SYS_PLL_HDMI_SD5_gran_est_src(data)                                          ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_HDMI_SD5_get_gran_est(data)                                          ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_BG_CTL                                                                   0x224
+#define SYS_BG_CTL_reg_addr                                                          "0x98000224"
+#define SYS_BG_CTL_reg                                                               0x98000224
+#define set_SYS_BG_CTL_reg(data)   (*((volatile unsigned int*) SYS_BG_CTL_reg)=data)
+#define get_SYS_BG_CTL_reg   (*((volatile unsigned int*) SYS_BG_CTL_reg))
+#define SYS_BG_CTL_inst_adr                                                          "0x0089"
+#define SYS_BG_CTL_inst                                                              0x0089
+#define SYS_BG_CTL_REG_PLL_RESERVED_shift                                            (24)
+#define SYS_BG_CTL_REG_PLL_RESERVED_mask                                             (0xFF000000)
+#define SYS_BG_CTL_REG_PLL_RESERVED(data)                                            (0xFF000000&((data)<<24))
+#define SYS_BG_CTL_REG_PLL_RESERVED_src(data)                                        ((0xFF000000&(data))>>24)
+#define SYS_BG_CTL_get_REG_PLL_RESERVED(data)                                        ((0xFF000000&(data))>>24)
+#define SYS_BG_CTL_REG_LDO2V_SEL_shift                                               (9)
+#define SYS_BG_CTL_REG_LDO2V_SEL_mask                                                (0x00000600)
+#define SYS_BG_CTL_REG_LDO2V_SEL(data)                                               (0x00000600&((data)<<9))
+#define SYS_BG_CTL_REG_LDO2V_SEL_src(data)                                           ((0x00000600&(data))>>9)
+#define SYS_BG_CTL_get_REG_LDO2V_SEL(data)                                           ((0x00000600&(data))>>9)
+#define SYS_BG_CTL_REG_LDO2V_POW_shift                                               (8)
+#define SYS_BG_CTL_REG_LDO2V_POW_mask                                                (0x00000100)
+#define SYS_BG_CTL_REG_LDO2V_POW(data)                                               (0x00000100&((data)<<8))
+#define SYS_BG_CTL_REG_LDO2V_POW_src(data)                                           ((0x00000100&(data))>>8)
+#define SYS_BG_CTL_get_REG_LDO2V_POW(data)                                           ((0x00000100&(data))>>8)
+
+
+#define SYS_POR_DET                                                                  0x228
+#define SYS_POR_DET_reg_addr                                                         "0x98000228"
+#define SYS_POR_DET_reg                                                              0x98000228
+#define set_SYS_POR_DET_reg(data)   (*((volatile unsigned int*) SYS_POR_DET_reg)=data)
+#define get_SYS_POR_DET_reg   (*((volatile unsigned int*) SYS_POR_DET_reg))
+#define SYS_POR_DET_inst_adr                                                         "0x008A"
+#define SYS_POR_DET_inst                                                             0x008A
+#define SYS_POR_DET_POR_VDD_D10_OVER_shift                                           (0)
+#define SYS_POR_DET_POR_VDD_D10_OVER_mask                                            (0x00000001)
+#define SYS_POR_DET_POR_VDD_D10_OVER(data)                                           (0x00000001&((data)<<0))
+#define SYS_POR_DET_POR_VDD_D10_OVER_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_POR_DET_get_POR_VDD_D10_OVER(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI_LDO1                                                            0x230
+#define SYS_PLL_HDMI_LDO1_reg_addr                                                   "0x98000230"
+#define SYS_PLL_HDMI_LDO1_reg                                                        0x98000230
+#define set_SYS_PLL_HDMI_LDO1_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO1_reg)=data)
+#define get_SYS_PLL_HDMI_LDO1_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO1_reg))
+#define SYS_PLL_HDMI_LDO1_inst_adr                                                   "0x008C"
+#define SYS_PLL_HDMI_LDO1_inst                                                       0x008C
+#define SYS_PLL_HDMI_LDO1_REG_BYPASS_PI_shift                                        (29)
+#define SYS_PLL_HDMI_LDO1_REG_BYPASS_PI_mask                                         (0x20000000)
+#define SYS_PLL_HDMI_LDO1_REG_BYPASS_PI(data)                                        (0x20000000&((data)<<29))
+#define SYS_PLL_HDMI_LDO1_REG_BYPASS_PI_src(data)                                    ((0x20000000&(data))>>29)
+#define SYS_PLL_HDMI_LDO1_get_REG_BYPASS_PI(data)                                    ((0x20000000&(data))>>29)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_LDO_SEL_shift                                      (27)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_LDO_SEL_mask                                       (0x18000000)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_LDO_SEL(data)                                      (0x18000000&((data)<<27))
+#define SYS_PLL_HDMI_LDO1_REG_P2S_LDO_SEL_src(data)                                  ((0x18000000&(data))>>27)
+#define SYS_PLL_HDMI_LDO1_get_REG_P2S_LDO_SEL(data)                                  ((0x18000000&(data))>>27)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_MODE_shift                                         (25)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_MODE_mask                                          (0x06000000)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_MODE(data)                                         (0x06000000&((data)<<25))
+#define SYS_PLL_HDMI_LDO1_REG_P2S_MODE_src(data)                                     ((0x06000000&(data))>>25)
+#define SYS_PLL_HDMI_LDO1_get_REG_P2S_MODE(data)                                     ((0x06000000&(data))>>25)
+#define SYS_PLL_HDMI_LDO1_REG_TSPC_SEL_shift                                         (24)
+#define SYS_PLL_HDMI_LDO1_REG_TSPC_SEL_mask                                          (0x01000000)
+#define SYS_PLL_HDMI_LDO1_REG_TSPC_SEL(data)                                         (0x01000000&((data)<<24))
+#define SYS_PLL_HDMI_LDO1_REG_TSPC_SEL_src(data)                                     ((0x01000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO1_get_REG_TSPC_SEL(data)                                     ((0x01000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO1_REG_MHL_MODE_shift                                         (23)
+#define SYS_PLL_HDMI_LDO1_REG_MHL_MODE_mask                                          (0x00800000)
+#define SYS_PLL_HDMI_LDO1_REG_MHL_MODE(data)                                         (0x00800000&((data)<<23))
+#define SYS_PLL_HDMI_LDO1_REG_MHL_MODE_src(data)                                     ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO1_get_REG_MHL_MODE(data)                                     ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO1_REG_HDMI_MODE_shift                                        (22)
+#define SYS_PLL_HDMI_LDO1_REG_HDMI_MODE_mask                                         (0x00400000)
+#define SYS_PLL_HDMI_LDO1_REG_HDMI_MODE(data)                                        (0x00400000&((data)<<22))
+#define SYS_PLL_HDMI_LDO1_REG_HDMI_MODE_src(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_LDO1_get_REG_HDMI_MODE(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_LDO1_REG_HDMICK_SEL_shift                                       (21)
+#define SYS_PLL_HDMI_LDO1_REG_HDMICK_SEL_mask                                        (0x00200000)
+#define SYS_PLL_HDMI_LDO1_REG_HDMICK_SEL(data)                                       (0x00200000&((data)<<21))
+#define SYS_PLL_HDMI_LDO1_REG_HDMICK_SEL_src(data)                                   ((0x00200000&(data))>>21)
+#define SYS_PLL_HDMI_LDO1_get_REG_HDMICK_SEL(data)                                   ((0x00200000&(data))>>21)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_TST_POW_shift                                      (20)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_TST_POW_mask                                       (0x00100000)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_TST_POW(data)                                      (0x00100000&((data)<<20))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_TST_POW_src(data)                                  ((0x00100000&(data))>>20)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_TST_POW(data)                                  ((0x00100000&(data))>>20)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_V18_SEL_shift                                  (18)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_V18_SEL_mask                                   (0x000C0000)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_V18_SEL(data)                                  (0x000C0000&((data)<<18))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_V18_SEL_src(data)                              ((0x000C0000&(data))>>18)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_LDO_V18_SEL(data)                              ((0x000C0000&(data))>>18)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_LV_SEL_shift                                   (16)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_LV_SEL_mask                                    (0x00030000)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_LV_SEL(data)                                   (0x00030000&((data)<<16))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_LV_SEL_src(data)                               ((0x00030000&(data))>>16)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_LDO_LV_SEL(data)                               ((0x00030000&(data))>>16)
+#define SYS_PLL_HDMI_LDO1_REG_TST_DIV_shift                                          (13)
+#define SYS_PLL_HDMI_LDO1_REG_TST_DIV_mask                                           (0x0000E000)
+#define SYS_PLL_HDMI_LDO1_REG_TST_DIV(data)                                          (0x0000E000&((data)<<13))
+#define SYS_PLL_HDMI_LDO1_REG_TST_DIV_src(data)                                      ((0x0000E000&(data))>>13)
+#define SYS_PLL_HDMI_LDO1_get_REG_TST_DIV(data)                                      ((0x0000E000&(data))>>13)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_RS_shift                                           (10)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_RS_mask                                            (0x00001C00)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_RS(data)                                           (0x00001C00&((data)<<10))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_RS_src(data)                                       ((0x00001C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_RS(data)                                       ((0x00001C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDSET_shift                                        (9)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDSET_mask                                         (0x00000200)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDSET(data)                                        (0x00000200&((data)<<9))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDSET_src(data)                                    ((0x00000200&(data))>>9)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_WDSET(data)                                    ((0x00000200&(data))>>9)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDRST_shift                                        (8)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDRST_mask                                         (0x00000100)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDRST(data)                                        (0x00000100&((data)<<8))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDRST_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_WDRST(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_VCOGAIN_shift                                      (7)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_VCOGAIN_mask                                       (0x00000080)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_VCOGAIN(data)                                      (0x00000080&((data)<<7))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_VCOGAIN_src(data)                                  ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_VCOGAIN(data)                                  ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_EXT_LDO_LV_shift                                   (6)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_EXT_LDO_LV_mask                                    (0x00000040)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_EXT_LDO_LV(data)                                   (0x00000040&((data)<<6))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_EXT_LDO_LV_src(data)                               ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_EXT_LDO_LV(data)                               ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CKSEL_shift                                        (4)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CKSEL_mask                                         (0x00000030)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CKSEL(data)                                        (0x00000030&((data)<<4))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CKSEL_src(data)                                    ((0x00000030&(data))>>4)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_CKSEL(data)                                    ((0x00000030&(data))>>4)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CS_shift                                           (2)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CS_mask                                            (0x0000000C)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CS(data)                                           (0x0000000C&((data)<<2))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CS_src(data)                                       ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_CS(data)                                       ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CP_shift                                           (0)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CP_mask                                            (0x00000003)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CP(data)                                           (0x00000003&((data)<<0))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CP_src(data)                                       ((0x00000003&(data))>>0)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_CP(data)                                       ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_HDMI_LDO2                                                            0x234
+#define SYS_PLL_HDMI_LDO2_reg_addr                                                   "0x98000234"
+#define SYS_PLL_HDMI_LDO2_reg                                                        0x98000234
+#define set_SYS_PLL_HDMI_LDO2_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO2_reg)=data)
+#define get_SYS_PLL_HDMI_LDO2_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO2_reg))
+#define SYS_PLL_HDMI_LDO2_inst_adr                                                   "0x008D"
+#define SYS_PLL_HDMI_LDO2_inst                                                       0x008D
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELCK_shift                                      (24)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELCK_mask                                       (0x03000000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELCK(data)                                      (0x03000000&((data)<<24))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELCK_src(data)                                  ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_RSELCK(data)                                  ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELC_shift                                       (22)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELC_mask                                        (0x00C00000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELC(data)                                       (0x00C00000&((data)<<22))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELC_src(data)                                   ((0x00C00000&(data))>>22)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_RSELC(data)                                   ((0x00C00000&(data))>>22)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELB_shift                                       (20)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELB_mask                                        (0x00300000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELB(data)                                       (0x00300000&((data)<<20))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELB_src(data)                                   ((0x00300000&(data))>>20)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_RSELB(data)                                   ((0x00300000&(data))>>20)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELA_shift                                       (18)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELA_mask                                        (0x000C0000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELA(data)                                       (0x000C0000&((data)<<18))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELA_src(data)                                   ((0x000C0000&(data))>>18)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_RSELA(data)                                   ((0x000C0000&(data))>>18)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELCK_shift                                      (16)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELCK_mask                                       (0x00030000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELCK(data)                                      (0x00030000&((data)<<16))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELCK_src(data)                                  ((0x00030000&(data))>>16)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_CSELCK(data)                                  ((0x00030000&(data))>>16)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELC_shift                                       (14)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELC_mask                                        (0x0000C000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELC(data)                                       (0x0000C000&((data)<<14))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELC_src(data)                                   ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_CSELC(data)                                   ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELB_shift                                       (12)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELB_mask                                        (0x00003000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELB(data)                                       (0x00003000&((data)<<12))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELB_src(data)                                   ((0x00003000&(data))>>12)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_CSELB(data)                                   ((0x00003000&(data))>>12)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELA_shift                                       (10)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELA_mask                                        (0x00000C00)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELA(data)                                       (0x00000C00&((data)<<10))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELA_src(data)                                   ((0x00000C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_CSELA(data)                                   ((0x00000C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_B_shift                                  (9)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_B_mask                                   (0x00000200)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_B(data)                                  (0x00000200&((data)<<9))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_B_src(data)                              ((0x00000200&(data))>>9)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWMHLCK_B(data)                              ((0x00000200&(data))>>9)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_A_shift                                  (8)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_A_mask                                   (0x00000100)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_A(data)                                  (0x00000100&((data)<<8))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_A_src(data)                              ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWMHLCK_A(data)                              ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWCK_shift                                       (7)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWCK_mask                                        (0x00000080)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWCK(data)                                       (0x00000080&((data)<<7))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWCK_src(data)                                   ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWCK(data)                                   ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWC_shift                                        (6)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWC_mask                                         (0x00000040)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWC(data)                                        (0x00000040&((data)<<6))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWC_src(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWC(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWB_shift                                        (5)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWB_mask                                         (0x00000020)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWB(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWB_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWB(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWA_shift                                        (4)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWA_mask                                         (0x00000010)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWA(data)                                        (0x00000010&((data)<<4))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWA_src(data)                                    ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWA(data)                                    ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMCK_shift                                        (3)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMCK_mask                                         (0x00000008)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMCK(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMCK_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_EMCK(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMC_shift                                         (2)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMC_mask                                          (0x00000004)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMC(data)                                         (0x00000004&((data)<<2))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMC_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_EMC(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMB_shift                                         (1)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMB_mask                                          (0x00000002)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_EMB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMA_shift                                         (0)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMA_mask                                          (0x00000001)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMA(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMA_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_EMA(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI_LDO3                                                            0x238
+#define SYS_PLL_HDMI_LDO3_reg_addr                                                   "0x98000238"
+#define SYS_PLL_HDMI_LDO3_reg                                                        0x98000238
+#define set_SYS_PLL_HDMI_LDO3_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO3_reg)=data)
+#define get_SYS_PLL_HDMI_LDO3_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO3_reg))
+#define SYS_PLL_HDMI_LDO3_inst_adr                                                   "0x008E"
+#define SYS_PLL_HDMI_LDO3_inst                                                       0x008E
+#define SYS_PLL_HDMI_LDO3_REG_PLL_CKIN_SEL_shift                                     (24)
+#define SYS_PLL_HDMI_LDO3_REG_PLL_CKIN_SEL_mask                                      (0x03000000)
+#define SYS_PLL_HDMI_LDO3_REG_PLL_CKIN_SEL(data)                                     (0x03000000&((data)<<24))
+#define SYS_PLL_HDMI_LDO3_REG_PLL_CKIN_SEL_src(data)                                 ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO3_get_REG_PLL_CKIN_SEL(data)                                 ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO3_REG_PLL_TSPC_SEL_shift                                     (23)
+#define SYS_PLL_HDMI_LDO3_REG_PLL_TSPC_SEL_mask                                      (0x00800000)
+#define SYS_PLL_HDMI_LDO3_REG_PLL_TSPC_SEL(data)                                     (0x00800000&((data)<<23))
+#define SYS_PLL_HDMI_LDO3_REG_PLL_TSPC_SEL_src(data)                                 ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO3_get_REG_PLL_TSPC_SEL(data)                                 ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO3_REG_PCR_27M_SEL_shift                                      (22)
+#define SYS_PLL_HDMI_LDO3_REG_PCR_27M_SEL_mask                                       (0x00400000)
+#define SYS_PLL_HDMI_LDO3_REG_PCR_27M_SEL(data)                                      (0x00400000&((data)<<22))
+#define SYS_PLL_HDMI_LDO3_REG_PCR_27M_SEL_src(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_LDO3_get_REG_PCR_27M_SEL(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVCK_shift                                      (19)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVCK_mask                                       (0x00380000)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVCK(data)                                      (0x00380000&((data)<<19))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVCK_src(data)                                  ((0x00380000&(data))>>19)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_IDRVCK(data)                                  ((0x00380000&(data))>>19)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVC_shift                                       (16)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVC_mask                                        (0x00070000)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVC(data)                                       (0x00070000&((data)<<16))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVC_src(data)                                   ((0x00070000&(data))>>16)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_IDRVC(data)                                   ((0x00070000&(data))>>16)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVB_shift                                       (13)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVB_mask                                        (0x0000E000)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVB(data)                                       (0x0000E000&((data)<<13))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVB_src(data)                                   ((0x0000E000&(data))>>13)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_IDRVB(data)                                   ((0x0000E000&(data))>>13)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVA_shift                                       (10)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVA_mask                                        (0x00001C00)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVA(data)                                       (0x00001C00&((data)<<10))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVA_src(data)                                   ((0x00001C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_IDRVA(data)                                   ((0x00001C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRMHLCK_shift                                     (8)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRMHLCK_mask                                      (0x00000300)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRMHLCK(data)                                     (0x00000300&((data)<<8))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRMHLCK_src(data)                                 ((0x00000300&(data))>>8)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_SRMHLCK(data)                                 ((0x00000300&(data))>>8)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRCK_shift                                        (6)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRCK_mask                                         (0x000000C0)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRCK(data)                                        (0x000000C0&((data)<<6))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRCK_src(data)                                    ((0x000000C0&(data))>>6)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_SRCK(data)                                    ((0x000000C0&(data))>>6)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRC_shift                                         (4)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRC_mask                                          (0x00000030)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRC(data)                                         (0x00000030&((data)<<4))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRC_src(data)                                     ((0x00000030&(data))>>4)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_SRC(data)                                     ((0x00000030&(data))>>4)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRB_shift                                         (2)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRB_mask                                          (0x0000000C)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRB(data)                                         (0x0000000C&((data)<<2))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRB_src(data)                                     ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_SRB(data)                                     ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRA_shift                                         (0)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRA_mask                                          (0x00000003)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRA(data)                                         (0x00000003&((data)<<0))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRA_src(data)                                     ((0x00000003&(data))>>0)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_SRA(data)                                     ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_HDMI_LDO4                                                            0x23c
+#define SYS_PLL_HDMI_LDO4_reg_addr                                                   "0x9800023C"
+#define SYS_PLL_HDMI_LDO4_reg                                                        0x9800023C
+#define set_SYS_PLL_HDMI_LDO4_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO4_reg)=data)
+#define get_SYS_PLL_HDMI_LDO4_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO4_reg))
+#define SYS_PLL_HDMI_LDO4_inst_adr                                                   "0x008F"
+#define SYS_PLL_HDMI_LDO4_inst                                                       0x008F
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_DDSEN_shift                                    (29)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_DDSEN_mask                                     (0x20000000)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_DDSEN(data)                                    (0x20000000&((data)<<29))
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_DDSEN_src(data)                                ((0x20000000&(data))>>29)
+#define SYS_PLL_HDMI_LDO4_get_REG_PLLDISP_DDSEN(data)                                ((0x20000000&(data))>>29)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CS_shift                                       (27)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CS_mask                                        (0x18000000)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CS(data)                                       (0x18000000&((data)<<27))
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CS_src(data)                                   ((0x18000000&(data))>>27)
+#define SYS_PLL_HDMI_LDO4_get_REG_PLLDISP_CS(data)                                   ((0x18000000&(data))>>27)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CP_shift                                       (25)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CP_mask                                        (0x06000000)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CP(data)                                       (0x06000000&((data)<<25))
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CP_src(data)                                   ((0x06000000&(data))>>25)
+#define SYS_PLL_HDMI_LDO4_get_REG_PLLDISP_CP(data)                                   ((0x06000000&(data))>>25)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_C3_shift                                       (23)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_C3_mask                                        (0x01800000)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_C3(data)                                       (0x01800000&((data)<<23))
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_C3_src(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO4_get_REG_PLLDISP_C3(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO4_REG_TEST_LDO_SEL_shift                                     (21)
+#define SYS_PLL_HDMI_LDO4_REG_TEST_LDO_SEL_mask                                      (0x00600000)
+#define SYS_PLL_HDMI_LDO4_REG_TEST_LDO_SEL(data)                                     (0x00600000&((data)<<21))
+#define SYS_PLL_HDMI_LDO4_REG_TEST_LDO_SEL_src(data)                                 ((0x00600000&(data))>>21)
+#define SYS_PLL_HDMI_LDO4_get_REG_TEST_LDO_SEL(data)                                 ((0x00600000&(data))>>21)
+#define SYS_PLL_HDMI_LDO4_REG_TESTSIG_SEL_shift                                      (19)
+#define SYS_PLL_HDMI_LDO4_REG_TESTSIG_SEL_mask                                       (0x00180000)
+#define SYS_PLL_HDMI_LDO4_REG_TESTSIG_SEL(data)                                      (0x00180000&((data)<<19))
+#define SYS_PLL_HDMI_LDO4_REG_TESTSIG_SEL_src(data)                                  ((0x00180000&(data))>>19)
+#define SYS_PLL_HDMI_LDO4_get_REG_TESTSIG_SEL(data)                                  ((0x00180000&(data))>>19)
+#define SYS_PLL_HDMI_LDO4_REG_PLL_IP_shift                                           (15)
+#define SYS_PLL_HDMI_LDO4_REG_PLL_IP_mask                                            (0x00078000)
+#define SYS_PLL_HDMI_LDO4_REG_PLL_IP(data)                                           (0x00078000&((data)<<15))
+#define SYS_PLL_HDMI_LDO4_REG_PLL_IP_src(data)                                       ((0x00078000&(data))>>15)
+#define SYS_PLL_HDMI_LDO4_get_REG_PLL_IP(data)                                       ((0x00078000&(data))>>15)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IMHLCK_shift                                      (12)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IMHLCK_mask                                       (0x00007000)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IMHLCK(data)                                      (0x00007000&((data)<<12))
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IMHLCK_src(data)                                  ((0x00007000&(data))>>12)
+#define SYS_PLL_HDMI_LDO4_get_REG_TMDS_IMHLCK(data)                                  ((0x00007000&(data))>>12)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMCK_shift                                       (9)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMCK_mask                                        (0x00000E00)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMCK(data)                                       (0x00000E00&((data)<<9))
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMCK_src(data)                                   ((0x00000E00&(data))>>9)
+#define SYS_PLL_HDMI_LDO4_get_REG_TMDS_IEMCK(data)                                   ((0x00000E00&(data))>>9)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMC_shift                                        (6)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMC_mask                                         (0x000001C0)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMC(data)                                        (0x000001C0&((data)<<6))
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMC_src(data)                                    ((0x000001C0&(data))>>6)
+#define SYS_PLL_HDMI_LDO4_get_REG_TMDS_IEMC(data)                                    ((0x000001C0&(data))>>6)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMB_shift                                        (3)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMB_mask                                         (0x00000038)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMB(data)                                        (0x00000038&((data)<<3))
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMB_src(data)                                    ((0x00000038&(data))>>3)
+#define SYS_PLL_HDMI_LDO4_get_REG_TMDS_IEMB(data)                                    ((0x00000038&(data))>>3)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMA_shift                                        (0)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMA_mask                                         (0x00000007)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMA(data)                                        (0x00000007&((data)<<0))
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMA_src(data)                                    ((0x00000007&(data))>>0)
+#define SYS_PLL_HDMI_LDO4_get_REG_TMDS_IEMA(data)                                    ((0x00000007&(data))>>0)
+
+
+#define SYS_PLL_HDMI_LDO5                                                            0x240
+#define SYS_PLL_HDMI_LDO5_reg_addr                                                   "0x98000240"
+#define SYS_PLL_HDMI_LDO5_reg                                                        0x98000240
+#define set_SYS_PLL_HDMI_LDO5_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO5_reg)=data)
+#define get_SYS_PLL_HDMI_LDO5_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO5_reg))
+#define SYS_PLL_HDMI_LDO5_inst_adr                                                   "0x0090"
+#define SYS_PLL_HDMI_LDO5_inst                                                       0x0090
+#define SYS_PLL_HDMI_LDO5_REG_HDMITX_RESERVE_shift                                   (16)
+#define SYS_PLL_HDMI_LDO5_REG_HDMITX_RESERVE_mask                                    (0xFFFF0000)
+#define SYS_PLL_HDMI_LDO5_REG_HDMITX_RESERVE(data)                                   (0xFFFF0000&((data)<<16))
+#define SYS_PLL_HDMI_LDO5_REG_HDMITX_RESERVE_src(data)                               ((0xFFFF0000&(data))>>16)
+#define SYS_PLL_HDMI_LDO5_get_REG_HDMITX_RESERVE(data)                               ((0xFFFF0000&(data))>>16)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_LDOSEL_shift                                   (14)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_LDOSEL_mask                                    (0x0000C000)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_LDOSEL(data)                                   (0x0000C000&((data)<<14))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_LDOSEL_src(data)                               ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_LDOSEL(data)                               ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_SSC_ENL_shift                                  (13)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_SSC_ENL_mask                                   (0x00002000)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_SSC_ENL(data)                                  (0x00002000&((data)<<13))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_SSC_ENL_src(data)                              ((0x00002000&(data))>>13)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_SSC_ENL(data)                              ((0x00002000&(data))>>13)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_WDMODE_shift                                   (11)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_WDMODE_mask                                    (0x00001800)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_WDMODE(data)                                   (0x00001800&((data)<<11))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_WDMODE_src(data)                               ((0x00001800&(data))>>11)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_WDMODE(data)                               ((0x00001800&(data))>>11)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_RS_shift                                       (8)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_RS_mask                                        (0x00000700)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_RS(data)                                       (0x00000700&((data)<<8))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_RS_src(data)                                   ((0x00000700&(data))>>8)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_RS(data)                                   ((0x00000700&(data))>>8)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_R3_shift                                       (5)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_R3_mask                                        (0x000000E0)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_R3(data)                                       (0x000000E0&((data)<<5))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_R3_src(data)                                   ((0x000000E0&(data))>>5)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_R3(data)                                   ((0x000000E0&(data))>>5)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_PSTST_shift                                    (4)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_PSTST_mask                                     (0x00000010)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_PSTST(data)                                    (0x00000010&((data)<<4))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_PSTST_src(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_PSTST(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_IP_shift                                       (0)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_IP_mask                                        (0x0000000F)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_IP(data)                                       (0x0000000F&((data)<<0))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_IP_src(data)                                   ((0x0000000F&(data))>>0)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_IP(data)                                   ((0x0000000F&(data))>>0)
+
+
+#define SYS_PLL_EDP1                                                                 0x248
+#define SYS_PLL_EDP1_reg_addr                                                        "0x98000248"
+#define SYS_PLL_EDP1_reg                                                             0x98000248
+#define set_SYS_PLL_EDP1_reg(data)   (*((volatile unsigned int*) SYS_PLL_EDP1_reg)=data)
+#define get_SYS_PLL_EDP1_reg   (*((volatile unsigned int*) SYS_PLL_EDP1_reg))
+#define SYS_PLL_EDP1_inst_adr                                                        "0x0092"
+#define SYS_PLL_EDP1_inst                                                            0x0092
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOPOW_shift                                         (31)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOPOW_mask                                          (0x80000000)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOPOW(data)                                         (0x80000000&((data)<<31))
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOPOW_src(data)                                     ((0x80000000&(data))>>31)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_LDOPOW(data)                                     ((0x80000000&(data))>>31)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOSEL_shift                                         (28)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOSEL_mask                                          (0x30000000)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOSEL(data)                                         (0x30000000&((data)<<28))
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOSEL_src(data)                                     ((0x30000000&(data))>>28)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_LDOSEL(data)                                     ((0x30000000&(data))>>28)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10POW_shift                                      (27)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10POW_mask                                       (0x08000000)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10POW(data)                                      (0x08000000&((data)<<27))
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10POW_src(data)                                  ((0x08000000&(data))>>27)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_LDOV10POW(data)                                  ((0x08000000&(data))>>27)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10SEL_shift                                      (24)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10SEL_mask                                       (0x03000000)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10SEL(data)                                      (0x03000000&((data)<<24))
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10SEL_src(data)                                  ((0x03000000&(data))>>24)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_LDOV10SEL(data)                                  ((0x03000000&(data))>>24)
+#define SYS_PLL_EDP1_REG_EDPPLL_CS_shift                                             (20)
+#define SYS_PLL_EDP1_REG_EDPPLL_CS_mask                                              (0x00300000)
+#define SYS_PLL_EDP1_REG_EDPPLL_CS(data)                                             (0x00300000&((data)<<20))
+#define SYS_PLL_EDP1_REG_EDPPLL_CS_src(data)                                         ((0x00300000&(data))>>20)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_CS(data)                                         ((0x00300000&(data))>>20)
+#define SYS_PLL_EDP1_REG_EDPPLL_RS_shift                                             (16)
+#define SYS_PLL_EDP1_REG_EDPPLL_RS_mask                                              (0x00070000)
+#define SYS_PLL_EDP1_REG_EDPPLL_RS(data)                                             (0x00070000&((data)<<16))
+#define SYS_PLL_EDP1_REG_EDPPLL_RS_src(data)                                         ((0x00070000&(data))>>16)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_RS(data)                                         ((0x00070000&(data))>>16)
+#define SYS_PLL_EDP1_REG_EDPPLL_CP_shift                                             (15)
+#define SYS_PLL_EDP1_REG_EDPPLL_CP_mask                                              (0x00008000)
+#define SYS_PLL_EDP1_REG_EDPPLL_CP(data)                                             (0x00008000&((data)<<15))
+#define SYS_PLL_EDP1_REG_EDPPLL_CP_src(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_CP(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PLL_EDP1_REG_EDPPLL_IP_shift                                             (12)
+#define SYS_PLL_EDP1_REG_EDPPLL_IP_mask                                              (0x00007000)
+#define SYS_PLL_EDP1_REG_EDPPLL_IP(data)                                             (0x00007000&((data)<<12))
+#define SYS_PLL_EDP1_REG_EDPPLL_IP_src(data)                                         ((0x00007000&(data))>>12)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_IP(data)                                         ((0x00007000&(data))>>12)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV10X_shift                                         (11)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV10X_mask                                          (0x00000800)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV10X(data)                                         (0x00000800&((data)<<11))
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV10X_src(data)                                     ((0x00000800&(data))>>11)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_DIV10X(data)                                     ((0x00000800&(data))>>11)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDRST_shift                                          (9)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDRST_mask                                           (0x00000200)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDRST(data)                                          (0x00000200&((data)<<9))
+#define SYS_PLL_EDP1_REG_EDPPLL_WDRST_src(data)                                      ((0x00000200&(data))>>9)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_WDRST(data)                                      ((0x00000200&(data))>>9)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDSET_shift                                          (8)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDSET_mask                                           (0x00000100)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDSET(data)                                          (0x00000100&((data)<<8))
+#define SYS_PLL_EDP1_REG_EDPPLL_WDSET_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_WDSET(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_EDP1_REG_EDPPLL_N_shift                                              (6)
+#define SYS_PLL_EDP1_REG_EDPPLL_N_mask                                               (0x000000C0)
+#define SYS_PLL_EDP1_REG_EDPPLL_N(data)                                              (0x000000C0&((data)<<6))
+#define SYS_PLL_EDP1_REG_EDPPLL_N_src(data)                                          ((0x000000C0&(data))>>6)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_N(data)                                          ((0x000000C0&(data))>>6)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV_P_shift                                          (4)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV_P_mask                                           (0x00000030)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV_P(data)                                          (0x00000030&((data)<<4))
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV_P_src(data)                                      ((0x00000030&(data))>>4)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_DIV_P(data)                                      ((0x00000030&(data))>>4)
+#define SYS_PLL_EDP1_REG_EDPPLL_TEST_shift                                           (3)
+#define SYS_PLL_EDP1_REG_EDPPLL_TEST_mask                                            (0x00000008)
+#define SYS_PLL_EDP1_REG_EDPPLL_TEST(data)                                           (0x00000008&((data)<<3))
+#define SYS_PLL_EDP1_REG_EDPPLL_TEST_src(data)                                       ((0x00000008&(data))>>3)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_TEST(data)                                       ((0x00000008&(data))>>3)
+#define SYS_PLL_EDP1_REG_EDPPLL_INCF_shift                                           (2)
+#define SYS_PLL_EDP1_REG_EDPPLL_INCF_mask                                            (0x00000004)
+#define SYS_PLL_EDP1_REG_EDPPLL_INCF(data)                                           (0x00000004&((data)<<2))
+#define SYS_PLL_EDP1_REG_EDPPLL_INCF_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_INCF(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_EDP1_REG_EDPPLL_PI_BPS_shift                                         (1)
+#define SYS_PLL_EDP1_REG_EDPPLL_PI_BPS_mask                                          (0x00000002)
+#define SYS_PLL_EDP1_REG_EDPPLL_PI_BPS(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_EDP1_REG_EDPPLL_PI_BPS_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_PI_BPS(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_EDP1_REG_BIAS_POW_shift                                              (0)
+#define SYS_PLL_EDP1_REG_BIAS_POW_mask                                               (0x00000001)
+#define SYS_PLL_EDP1_REG_BIAS_POW(data)                                              (0x00000001&((data)<<0))
+#define SYS_PLL_EDP1_REG_BIAS_POW_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_PLL_EDP1_get_REG_BIAS_POW(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EDP2                                                                 0x24C
+#define SYS_PLL_EDP2_reg_addr                                                        "0x9800024C"
+#define SYS_PLL_EDP2_reg                                                             0x9800024C
+#define set_SYS_PLL_EDP2_reg(data)   (*((volatile unsigned int*) SYS_PLL_EDP2_reg)=data)
+#define get_SYS_PLL_EDP2_reg   (*((volatile unsigned int*) SYS_PLL_EDP2_reg))
+#define SYS_PLL_EDP2_inst_adr                                                        "0x0093"
+#define SYS_PLL_EDP2_inst                                                            0x0093
+#define SYS_PLL_EDP2_REG_EDPPLL_RESERVED_shift                                       (2)
+#define SYS_PLL_EDP2_REG_EDPPLL_RESERVED_mask                                        (0x000003FC)
+#define SYS_PLL_EDP2_REG_EDPPLL_RESERVED(data)                                       (0x000003FC&((data)<<2))
+#define SYS_PLL_EDP2_REG_EDPPLL_RESERVED_src(data)                                   ((0x000003FC&(data))>>2)
+#define SYS_PLL_EDP2_get_REG_EDPPLL_RESERVED(data)                                   ((0x000003FC&(data))>>2)
+#define SYS_PLL_EDP2_REG_EDPPLL_RSTB_shift                                           (1)
+#define SYS_PLL_EDP2_REG_EDPPLL_RSTB_mask                                            (0x00000002)
+#define SYS_PLL_EDP2_REG_EDPPLL_RSTB(data)                                           (0x00000002&((data)<<1))
+#define SYS_PLL_EDP2_REG_EDPPLL_RSTB_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_EDP2_get_REG_EDPPLL_RSTB(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_EDP2_REG_EDPPLL_POW_shift                                            (0)
+#define SYS_PLL_EDP2_REG_EDPPLL_POW_mask                                             (0x00000001)
+#define SYS_PLL_EDP2_REG_EDPPLL_POW(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_EDP2_REG_EDPPLL_POW_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_EDP2_get_REG_EDPPLL_POW(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PIXEL1                                                               0x250
+#define SYS_PLL_PIXEL1_reg_addr                                                      "0x98000250"
+#define SYS_PLL_PIXEL1_reg                                                           0x98000250
+#define set_SYS_PLL_PIXEL1_reg(data)   (*((volatile unsigned int*) SYS_PLL_PIXEL1_reg)=data)
+#define get_SYS_PLL_PIXEL1_reg   (*((volatile unsigned int*) SYS_PLL_PIXEL1_reg))
+#define SYS_PLL_PIXEL1_inst_adr                                                      "0x0094"
+#define SYS_PLL_PIXEL1_inst                                                          0x0094
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOPOW_shift                                     (31)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOPOW_mask                                      (0x80000000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOPOW(data)                                     (0x80000000&((data)<<31))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOPOW_src(data)                                 ((0x80000000&(data))>>31)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_LDOPOW(data)                                 ((0x80000000&(data))>>31)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOSEL_shift                                     (28)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOSEL_mask                                      (0x30000000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOSEL(data)                                     (0x30000000&((data)<<28))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOSEL_src(data)                                 ((0x30000000&(data))>>28)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_LDOSEL(data)                                 ((0x30000000&(data))>>28)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RS_shift                                         (24)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RS_mask                                          (0x07000000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RS(data)                                         (0x07000000&((data)<<24))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RS_src(data)                                     ((0x07000000&(data))>>24)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_RS(data)                                     ((0x07000000&(data))>>24)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_IP_shift                                         (20)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_IP_mask                                          (0x00700000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_IP(data)                                         (0x00700000&((data)<<20))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_IP_src(data)                                     ((0x00700000&(data))>>20)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_IP(data)                                     ((0x00700000&(data))>>20)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CP_shift                                         (18)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CP_mask                                          (0x000C0000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CP(data)                                         (0x000C0000&((data)<<18))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CP_src(data)                                     ((0x000C0000&(data))>>18)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_CP(data)                                     ((0x000C0000&(data))>>18)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CS_shift                                         (16)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CS_mask                                          (0x00030000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CS(data)                                         (0x00030000&((data)<<16))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CS_src(data)                                     ((0x00030000&(data))>>16)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_CS(data)                                     ((0x00030000&(data))>>16)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RSTB_shift                                       (14)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RSTB_mask                                        (0x00004000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RSTB(data)                                       (0x00004000&((data)<<14))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RSTB_src(data)                                   ((0x00004000&(data))>>14)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_RSTB(data)                                   ((0x00004000&(data))>>14)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDRST_shift                                      (13)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDRST_mask                                       (0x00002000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDRST(data)                                      (0x00002000&((data)<<13))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDRST_src(data)                                  ((0x00002000&(data))>>13)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_WDRST(data)                                  ((0x00002000&(data))>>13)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDSET_shift                                      (12)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDSET_mask                                       (0x00001000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDSET(data)                                      (0x00001000&((data)<<12))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDSET_src(data)                                  ((0x00001000&(data))>>12)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_WDSET(data)                                  ((0x00001000&(data))>>12)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSIN_shift                                      (11)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSIN_mask                                       (0x00000800)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSIN(data)                                      (0x00000800&((data)<<11))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSIN_src(data)                                  ((0x00000800&(data))>>11)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_BPSIN(data)                                  ((0x00000800&(data))>>11)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_N_shift                                          (8)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_N_mask                                           (0x00000700)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_N(data)                                          (0x00000700&((data)<<8))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_N_src(data)                                      ((0x00000700&(data))>>8)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_N(data)                                      ((0x00000700&(data))>>8)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_VCORSTB_shift                                    (7)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_VCORSTB_mask                                     (0x00000080)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_VCORSTB(data)                                    (0x00000080&((data)<<7))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_VCORSTB_src(data)                                ((0x00000080&(data))>>7)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_VCORSTB(data)                                ((0x00000080&(data))>>7)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_O_shift                                          (4)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_O_mask                                           (0x00000030)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_O(data)                                          (0x00000030&((data)<<4))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_O_src(data)                                      ((0x00000030&(data))>>4)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_O(data)                                      ((0x00000030&(data))>>4)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_TEST_shift                                       (3)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_TEST_mask                                        (0x00000008)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_TEST(data)                                       (0x00000008&((data)<<3))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_TEST_src(data)                                   ((0x00000008&(data))>>3)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_TEST(data)                                   ((0x00000008&(data))>>3)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_FREEZE_shift                                     (2)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_FREEZE_mask                                      (0x00000004)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_FREEZE(data)                                     (0x00000004&((data)<<2))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_FREEZE_src(data)                                 ((0x00000004&(data))>>2)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_FREEZE(data)                                 ((0x00000004&(data))>>2)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSPI_shift                                      (1)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSPI_mask                                       (0x00000002)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSPI(data)                                      (0x00000002&((data)<<1))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSPI_src(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_BPSPI(data)                                  ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_PIXEL2                                                               0x254
+#define SYS_PLL_PIXEL2_reg_addr                                                      "0x98000254"
+#define SYS_PLL_PIXEL2_reg                                                           0x98000254
+#define set_SYS_PLL_PIXEL2_reg(data)   (*((volatile unsigned int*) SYS_PLL_PIXEL2_reg)=data)
+#define get_SYS_PLL_PIXEL2_reg   (*((volatile unsigned int*) SYS_PLL_PIXEL2_reg))
+#define SYS_PLL_PIXEL2_inst_adr                                                      "0x0095"
+#define SYS_PLL_PIXEL2_inst                                                          0x0095
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESER_shift                                      (9)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESER_mask                                       (0x00001E00)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESER(data)                                      (0x00001E00&((data)<<9))
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESER_src(data)                                  ((0x00001E00&(data))>>9)
+#define SYS_PLL_PIXEL2_get_REG_PIXELPLL_RESER(data)                                  ((0x00001E00&(data))>>9)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESERVED_shift                                   (1)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESERVED_mask                                    (0x000001FE)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESERVED(data)                                   (0x000001FE&((data)<<1))
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESERVED_src(data)                               ((0x000001FE&(data))>>1)
+#define SYS_PLL_PIXEL2_get_REG_PIXELPLL_RESERVED(data)                               ((0x000001FE&(data))>>1)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_POW_shift                                        (0)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_POW_mask                                         (0x00000001)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_POW(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_POW_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_PIXEL2_get_REG_PIXELPLL_POW(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VODMA1                                                               0x260
+#define SYS_PLL_VODMA1_reg_addr                                                      "0x98000260"
+#define SYS_PLL_VODMA1_reg                                                           0x98000260
+#define set_SYS_PLL_VODMA1_reg(data)   (*((volatile unsigned int*) SYS_PLL_VODMA1_reg)=data)
+#define get_SYS_PLL_VODMA1_reg   (*((volatile unsigned int*) SYS_PLL_VODMA1_reg))
+#define SYS_PLL_VODMA1_inst_adr                                                      "0x0098"
+#define SYS_PLL_VODMA1_inst                                                          0x0098
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDRST_shift                                      (22)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDRST_mask                                       (0x00400000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDRST(data)                                      (0x00400000&((data)<<22))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDRST_src(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_WDRST(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDSET_shift                                      (21)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDSET_mask                                       (0x00200000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDSET(data)                                      (0x00200000&((data)<<21))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDSET_src(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_WDSET(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_CS_shift                                         (19)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_CS_mask                                          (0x00180000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_CS(data)                                         (0x00180000&((data)<<19))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_CS_src(data)                                     ((0x00180000&(data))>>19)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_CS(data)                                     ((0x00180000&(data))>>19)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_O_shift                                          (17)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_O_mask                                           (0x00060000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_O(data)                                          (0x00060000&((data)<<17))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_O_src(data)                                      ((0x00060000&(data))>>17)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_O(data)                                      ((0x00060000&(data))>>17)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_RS_shift                                         (14)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_RS_mask                                          (0x0001C000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_RS(data)                                         (0x0001C000&((data)<<14))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_RS_src(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_RS(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_N_shift                                          (12)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_N_mask                                           (0x00003000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_N(data)                                          (0x00003000&((data)<<12))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_N_src(data)                                      ((0x00003000&(data))>>12)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_N(data)                                      ((0x00003000&(data))>>12)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_M_shift                                          (4)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_M_mask                                           (0x00000FF0)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_M(data)                                          (0x00000FF0&((data)<<4))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_M_src(data)                                      ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_M(data)                                      ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_IP_shift                                         (1)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_IP_mask                                          (0x0000000E)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_IP(data)                                         (0x0000000E&((data)<<1))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_IP_src(data)                                     ((0x0000000E&(data))>>1)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_IP(data)                                     ((0x0000000E&(data))>>1)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_TST_shift                                        (0)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_TST_mask                                         (0x00000001)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_TST(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_TST_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_TST(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VODMA2                                                               0x264
+#define SYS_PLL_VODMA2_reg_addr                                                      "0x98000264"
+#define SYS_PLL_VODMA2_reg                                                           0x98000264
+#define set_SYS_PLL_VODMA2_reg(data)   (*((volatile unsigned int*) SYS_PLL_VODMA2_reg)=data)
+#define get_SYS_PLL_VODMA2_reg   (*((volatile unsigned int*) SYS_PLL_VODMA2_reg))
+#define SYS_PLL_VODMA2_inst_adr                                                      "0x0099"
+#define SYS_PLL_VODMA2_inst                                                          0x0099
+#define SYS_PLL_VODMA2_REG_PLLVODMA_OEB_shift                                        (2)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_OEB_mask                                         (0x00000004)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_OEB(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_VODMA2_REG_PLLVODMA_OEB_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_VODMA2_get_REG_PLLVODMA_OEB(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_RSTB_shift                                       (1)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_RSTB_mask                                        (0x00000002)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_RSTB(data)                                       (0x00000002&((data)<<1))
+#define SYS_PLL_VODMA2_REG_PLLVODMA_RSTB_src(data)                                   ((0x00000002&(data))>>1)
+#define SYS_PLL_VODMA2_get_REG_PLLVODMA_RSTB(data)                                   ((0x00000002&(data))>>1)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_POW_shift                                        (0)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_POW_mask                                         (0x00000001)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_POW(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_VODMA2_REG_PLLVODMA_POW_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_VODMA2_get_REG_PLLVODMA_POW(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_CHIP_INFO2                                                               0x308
+#define SYS_CHIP_INFO2_reg_addr                                                      "0x98000308"
+#define SYS_CHIP_INFO2_reg                                                           0x98000308
+#define set_SYS_CHIP_INFO2_reg(data)   (*((volatile unsigned int*) SYS_CHIP_INFO2_reg)=data)
+#define get_SYS_CHIP_INFO2_reg   (*((volatile unsigned int*) SYS_CHIP_INFO2_reg))
+#define SYS_CHIP_INFO2_inst_adr                                                      "0x00C2"
+#define SYS_CHIP_INFO2_inst                                                          0x00C2
+#define SYS_CHIP_INFO2_testmode_shift                                                (2)
+#define SYS_CHIP_INFO2_testmode_mask                                                 (0x00000004)
+#define SYS_CHIP_INFO2_testmode(data)                                                (0x00000004&((data)<<2))
+#define SYS_CHIP_INFO2_testmode_src(data)                                            ((0x00000004&(data))>>2)
+#define SYS_CHIP_INFO2_get_testmode(data)                                            ((0x00000004&(data))>>2)
+#define SYS_CHIP_INFO2_nf_sel_shift                                                  (1)
+#define SYS_CHIP_INFO2_nf_sel_mask                                                   (0x00000002)
+#define SYS_CHIP_INFO2_nf_sel(data)                                                  (0x00000002&((data)<<1))
+#define SYS_CHIP_INFO2_nf_sel_src(data)                                              ((0x00000002&(data))>>1)
+#define SYS_CHIP_INFO2_get_nf_sel(data)                                              ((0x00000002&(data))>>1)
+#define SYS_CHIP_INFO2_boot_sel_shift                                                (0)
+#define SYS_CHIP_INFO2_boot_sel_mask                                                 (0x00000001)
+#define SYS_CHIP_INFO2_boot_sel(data)                                                (0x00000001&((data)<<0))
+#define SYS_CHIP_INFO2_boot_sel_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_CHIP_INFO2_get_boot_sel(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_SCPU_L2                                                                  0x30C
+#define SYS_SCPU_L2_reg_addr                                                         "0x9800030C"
+#define SYS_SCPU_L2_reg                                                              0x9800030C
+#define set_SYS_SCPU_L2_reg(data)   (*((volatile unsigned int*) SYS_SCPU_L2_reg)=data)
+#define get_SYS_SCPU_L2_reg   (*((volatile unsigned int*) SYS_SCPU_L2_reg))
+#define SYS_SCPU_L2_inst_adr                                                         "0x00C3"
+#define SYS_SCPU_L2_inst                                                             0x00C3
+#define SYS_SCPU_L2_reserved_scpu_l2_shift                                           (0)
+#define SYS_SCPU_L2_reserved_scpu_l2_mask                                            (0x00000001)
+#define SYS_SCPU_L2_reserved_scpu_l2(data)                                           (0x00000001&((data)<<0))
+#define SYS_SCPU_L2_reserved_scpu_l2_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_SCPU_L2_get_reserved_scpu_l2(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_PWDN_CTRL                                                                0x320
+#define SYS_PWDN_CTRL_reg_addr                                                       "0x98000320"
+#define SYS_PWDN_CTRL_reg                                                            0x98000320
+#define set_SYS_PWDN_CTRL_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL_reg)=data)
+#define get_SYS_PWDN_CTRL_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL_reg))
+#define SYS_PWDN_CTRL_inst_adr                                                       "0x00C8"
+#define SYS_PWDN_CTRL_inst                                                           0x00C8
+#define SYS_PWDN_CTRL_scpu_boot_info_shift                                           (0)
+#define SYS_PWDN_CTRL_scpu_boot_info_mask                                            (0xFFFFFFFF)
+#define SYS_PWDN_CTRL_scpu_boot_info(data)                                           (0xFFFFFFFF&((data)<<0))
+#define SYS_PWDN_CTRL_scpu_boot_info_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define SYS_PWDN_CTRL_get_scpu_boot_info(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_PWDN_CTRL2                                                               0x324
+#define SYS_PWDN_CTRL2_reg_addr                                                      "0x98000324"
+#define SYS_PWDN_CTRL2_reg                                                           0x98000324
+#define set_SYS_PWDN_CTRL2_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL2_reg)=data)
+#define get_SYS_PWDN_CTRL2_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL2_reg))
+#define SYS_PWDN_CTRL2_inst_adr                                                      "0x00C9"
+#define SYS_PWDN_CTRL2_inst                                                          0x00C9
+#define SYS_PWDN_CTRL2_acpu_boot_info_shift                                          (0)
+#define SYS_PWDN_CTRL2_acpu_boot_info_mask                                           (0xFFFFFFFF)
+#define SYS_PWDN_CTRL2_acpu_boot_info(data)                                          (0xFFFFFFFF&((data)<<0))
+#define SYS_PWDN_CTRL2_acpu_boot_info_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define SYS_PWDN_CTRL2_get_acpu_boot_info(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_PWDN_CTRL3                                                               0x328
+#define SYS_PWDN_CTRL3_reg_addr                                                      "0x98000328"
+#define SYS_PWDN_CTRL3_reg                                                           0x98000328
+#define set_SYS_PWDN_CTRL3_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL3_reg)=data)
+#define get_SYS_PWDN_CTRL3_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL3_reg))
+#define SYS_PWDN_CTRL3_inst_adr                                                      "0x00CA"
+#define SYS_PWDN_CTRL3_inst                                                          0x00CA
+#define SYS_PWDN_CTRL3_write_en2_shift                                               (3)
+#define SYS_PWDN_CTRL3_write_en2_mask                                                (0x00000008)
+#define SYS_PWDN_CTRL3_write_en2(data)                                               (0x00000008&((data)<<3))
+#define SYS_PWDN_CTRL3_write_en2_src(data)                                           ((0x00000008&(data))>>3)
+#define SYS_PWDN_CTRL3_get_write_en2(data)                                           ((0x00000008&(data))>>3)
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid_shift                                    (2)
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid_mask                                     (0x00000004)
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid(data)                                    (0x00000004&((data)<<2))
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid_src(data)                                ((0x00000004&(data))>>2)
+#define SYS_PWDN_CTRL3_get_scpu_boot_info_valid(data)                                ((0x00000004&(data))>>2)
+#define SYS_PWDN_CTRL3_write_en1_shift                                               (1)
+#define SYS_PWDN_CTRL3_write_en1_mask                                                (0x00000002)
+#define SYS_PWDN_CTRL3_write_en1(data)                                               (0x00000002&((data)<<1))
+#define SYS_PWDN_CTRL3_write_en1_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PWDN_CTRL3_get_write_en1(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PWDN_CTRL3_scpu_sw_rst_shift                                             (0)
+#define SYS_PWDN_CTRL3_scpu_sw_rst_mask                                              (0x00000001)
+#define SYS_PWDN_CTRL3_scpu_sw_rst(data)                                             (0x00000001&((data)<<0))
+#define SYS_PWDN_CTRL3_scpu_sw_rst_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_PWDN_CTRL3_get_scpu_sw_rst(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_PWDN_CTRL4                                                               0x32C
+#define SYS_PWDN_CTRL4_reg_addr                                                      "0x9800032C"
+#define SYS_PWDN_CTRL4_reg                                                           0x9800032C
+#define set_SYS_PWDN_CTRL4_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL4_reg)=data)
+#define get_SYS_PWDN_CTRL4_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL4_reg))
+#define SYS_PWDN_CTRL4_inst_adr                                                      "0x00CB"
+#define SYS_PWDN_CTRL4_inst                                                          0x00CB
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid_shift                                    (0)
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid_mask                                     (0x00000001)
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid(data)                                    (0x00000001&((data)<<0))
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid_src(data)                                ((0x00000001&(data))>>0)
+#define SYS_PWDN_CTRL4_get_acpu_boot_info_valid(data)                                ((0x00000001&(data))>>0)
+
+
+#define SYS_AT_SPEED                                                                 0x330
+#define SYS_AT_SPEED_reg_addr                                                        "0x98000330"
+#define SYS_AT_SPEED_reg                                                             0x98000330
+#define set_SYS_AT_SPEED_reg(data)   (*((volatile unsigned int*) SYS_AT_SPEED_reg)=data)
+#define get_SYS_AT_SPEED_reg   (*((volatile unsigned int*) SYS_AT_SPEED_reg))
+#define SYS_AT_SPEED_inst_adr                                                        "0x00CC"
+#define SYS_AT_SPEED_inst                                                            0x00CC
+#define SYS_AT_SPEED_write_en3_shift                                                 (5)
+#define SYS_AT_SPEED_write_en3_mask                                                  (0x00000020)
+#define SYS_AT_SPEED_write_en3(data)                                                 (0x00000020&((data)<<5))
+#define SYS_AT_SPEED_write_en3_src(data)                                             ((0x00000020&(data))>>5)
+#define SYS_AT_SPEED_get_write_en3(data)                                             ((0x00000020&(data))>>5)
+#define SYS_AT_SPEED_hdmirx_at_speed_pll_done_shift                                  (4)
+#define SYS_AT_SPEED_hdmirx_at_speed_pll_done_mask                                   (0x00000010)
+#define SYS_AT_SPEED_hdmirx_at_speed_pll_done(data)                                  (0x00000010&((data)<<4))
+#define SYS_AT_SPEED_hdmirx_at_speed_pll_done_src(data)                              ((0x00000010&(data))>>4)
+#define SYS_AT_SPEED_get_hdmirx_at_speed_pll_done(data)                              ((0x00000010&(data))>>4)
+#define SYS_AT_SPEED_write_en2_shift                                                 (3)
+#define SYS_AT_SPEED_write_en2_mask                                                  (0x00000008)
+#define SYS_AT_SPEED_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define SYS_AT_SPEED_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define SYS_AT_SPEED_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define SYS_AT_SPEED_dac_test_shift                                                  (2)
+#define SYS_AT_SPEED_dac_test_mask                                                   (0x00000004)
+#define SYS_AT_SPEED_dac_test(data)                                                  (0x00000004&((data)<<2))
+#define SYS_AT_SPEED_dac_test_src(data)                                              ((0x00000004&(data))>>2)
+#define SYS_AT_SPEED_get_dac_test(data)                                              ((0x00000004&(data))>>2)
+#define SYS_AT_SPEED_write_en1_shift                                                 (1)
+#define SYS_AT_SPEED_write_en1_mask                                                  (0x00000002)
+#define SYS_AT_SPEED_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define SYS_AT_SPEED_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define SYS_AT_SPEED_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define SYS_AT_SPEED_scpu_config_done_shift                                          (0)
+#define SYS_AT_SPEED_scpu_config_done_mask                                           (0x00000001)
+#define SYS_AT_SPEED_scpu_config_done(data)                                          (0x00000001&((data)<<0))
+#define SYS_AT_SPEED_scpu_config_done_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_AT_SPEED_get_scpu_config_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_ANA_CTRL                                                                 0x334
+#define SYS_ANA_CTRL_reg_addr                                                        "0x98000334"
+#define SYS_ANA_CTRL_reg                                                             0x98000334
+#define set_SYS_ANA_CTRL_reg(data)   (*((volatile unsigned int*) SYS_ANA_CTRL_reg)=data)
+#define get_SYS_ANA_CTRL_reg   (*((volatile unsigned int*) SYS_ANA_CTRL_reg))
+#define SYS_ANA_CTRL_inst_adr                                                        "0x00CD"
+#define SYS_ANA_CTRL_inst                                                            0x00CD
+#define SYS_ANA_CTRL_reserved_ana_ctrl_shift                                         (0)
+#define SYS_ANA_CTRL_reserved_ana_ctrl_mask                                          (0x00000001)
+#define SYS_ANA_CTRL_reserved_ana_ctrl(data)                                         (0x00000001&((data)<<0))
+#define SYS_ANA_CTRL_reserved_ana_ctrl_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_ANA_CTRL_get_reserved_ana_ctrl(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_TP_DEMOD_CTRL                                                            0x338
+#define SYS_TP_DEMOD_CTRL_reg_addr                                                   "0x98000338"
+#define SYS_TP_DEMOD_CTRL_reg                                                        0x98000338
+#define set_SYS_TP_DEMOD_CTRL_reg(data)   (*((volatile unsigned int*) SYS_TP_DEMOD_CTRL_reg)=data)
+#define get_SYS_TP_DEMOD_CTRL_reg   (*((volatile unsigned int*) SYS_TP_DEMOD_CTRL_reg))
+#define SYS_TP_DEMOD_CTRL_inst_adr                                                   "0x00CE"
+#define SYS_TP_DEMOD_CTRL_inst                                                       0x00CE
+#define SYS_TP_DEMOD_CTRL_reserved_tp_demod_ctrl_shift                               (0)
+#define SYS_TP_DEMOD_CTRL_reserved_tp_demod_ctrl_mask                                (0x00000001)
+#define SYS_TP_DEMOD_CTRL_reserved_tp_demod_ctrl(data)                               (0x00000001&((data)<<0))
+#define SYS_TP_DEMOD_CTRL_reserved_tp_demod_ctrl_src(data)                           ((0x00000001&(data))>>0)
+#define SYS_TP_DEMOD_CTRL_get_reserved_tp_demod_ctrl(data)                           ((0x00000001&(data))>>0)
+
+
+#define SYS_PHY_FUNC                                                                 0x340
+#define SYS_PHY_FUNC_reg_addr                                                        "0x98000340"
+#define SYS_PHY_FUNC_reg                                                             0x98000340
+#define set_SYS_PHY_FUNC_reg(data)   (*((volatile unsigned int*) SYS_PHY_FUNC_reg)=data)
+#define get_SYS_PHY_FUNC_reg   (*((volatile unsigned int*) SYS_PHY_FUNC_reg))
+#define SYS_PHY_FUNC_inst_adr                                                        "0x00D0"
+#define SYS_PHY_FUNC_inst                                                            0x00D0
+#define SYS_PHY_FUNC_reserved_phy_func_shift                                         (0)
+#define SYS_PHY_FUNC_reserved_phy_func_mask                                          (0x00000001)
+#define SYS_PHY_FUNC_reserved_phy_func(data)                                         (0x00000001&((data)<<0))
+#define SYS_PHY_FUNC_reserved_phy_func_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PHY_FUNC_get_reserved_phy_func(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_ANLG                                                                     0x344
+#define SYS_ANLG_reg_addr                                                            "0x98000344"
+#define SYS_ANLG_reg                                                                 0x98000344
+#define set_SYS_ANLG_reg(data)   (*((volatile unsigned int*) SYS_ANLG_reg)=data)
+#define get_SYS_ANLG_reg   (*((volatile unsigned int*) SYS_ANLG_reg))
+#define SYS_ANLG_inst_adr                                                            "0x00D1"
+#define SYS_ANLG_inst                                                                0x00D1
+#define SYS_ANLG_analogy_mode_sel_shift                                              (0)
+#define SYS_ANLG_analogy_mode_sel_mask                                               (0x0000000F)
+#define SYS_ANLG_analogy_mode_sel(data)                                              (0x0000000F&((data)<<0))
+#define SYS_ANLG_analogy_mode_sel_src(data)                                          ((0x0000000F&(data))>>0)
+#define SYS_ANLG_get_analogy_mode_sel(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define SYS_PLL_TEST1                                                                0x348
+#define SYS_PLL_TEST1_reg_addr                                                       "0x98000348"
+#define SYS_PLL_TEST1_reg                                                            0x98000348
+#define set_SYS_PLL_TEST1_reg(data)   (*((volatile unsigned int*) SYS_PLL_TEST1_reg)=data)
+#define get_SYS_PLL_TEST1_reg   (*((volatile unsigned int*) SYS_PLL_TEST1_reg))
+#define SYS_PLL_TEST1_inst_adr                                                       "0x00D2"
+#define SYS_PLL_TEST1_inst                                                           0x00D2
+#define SYS_PLL_TEST1_REG_TEST_EN_shift                                              (9)
+#define SYS_PLL_TEST1_REG_TEST_EN_mask                                               (0x00000200)
+#define SYS_PLL_TEST1_REG_TEST_EN(data)                                              (0x00000200&((data)<<9))
+#define SYS_PLL_TEST1_REG_TEST_EN_src(data)                                          ((0x00000200&(data))>>9)
+#define SYS_PLL_TEST1_get_REG_TEST_EN(data)                                          ((0x00000200&(data))>>9)
+#define SYS_PLL_TEST1_REG_PLLTST_EN_shift                                            (8)
+#define SYS_PLL_TEST1_REG_PLLTST_EN_mask                                             (0x00000100)
+#define SYS_PLL_TEST1_REG_PLLTST_EN(data)                                            (0x00000100&((data)<<8))
+#define SYS_PLL_TEST1_REG_PLLTST_EN_src(data)                                        ((0x00000100&(data))>>8)
+#define SYS_PLL_TEST1_get_REG_PLLTST_EN(data)                                        ((0x00000100&(data))>>8)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV32_shift                                         (7)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV32_mask                                          (0x00000080)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV32(data)                                         (0x00000080&((data)<<7))
+#define SYS_PLL_TEST1_REG_PLLTST_DIV32_src(data)                                     ((0x00000080&(data))>>7)
+#define SYS_PLL_TEST1_get_REG_PLLTST_DIV32(data)                                     ((0x00000080&(data))>>7)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV16_shift                                         (6)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV16_mask                                          (0x00000040)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV16(data)                                         (0x00000040&((data)<<6))
+#define SYS_PLL_TEST1_REG_PLLTST_DIV16_src(data)                                     ((0x00000040&(data))>>6)
+#define SYS_PLL_TEST1_get_REG_PLLTST_DIV16(data)                                     ((0x00000040&(data))>>6)
+#define SYS_PLL_TEST1_REG_PLLTST_SEL_shift                                           (2)
+#define SYS_PLL_TEST1_REG_PLLTST_SEL_mask                                            (0x0000003C)
+#define SYS_PLL_TEST1_REG_PLLTST_SEL(data)                                           (0x0000003C&((data)<<2))
+#define SYS_PLL_TEST1_REG_PLLTST_SEL_src(data)                                       ((0x0000003C&(data))>>2)
+#define SYS_PLL_TEST1_get_REG_PLLTST_SEL(data)                                       ((0x0000003C&(data))>>2)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV_shift                                           (0)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV_mask                                            (0x00000003)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV(data)                                           (0x00000003&((data)<<0))
+#define SYS_PLL_TEST1_REG_PLLTST_DIV_src(data)                                       ((0x00000003&(data))>>0)
+#define SYS_PLL_TEST1_get_REG_PLLTST_DIV(data)                                       ((0x00000003&(data))>>0)
+
+
+#define SYS_LSADC_PG                                                                 0x34c
+#define SYS_LSADC_PG_reg_addr                                                        "0x9800034C"
+#define SYS_LSADC_PG_reg                                                             0x9800034C
+#define set_SYS_LSADC_PG_reg(data)   (*((volatile unsigned int*) SYS_LSADC_PG_reg)=data)
+#define get_SYS_LSADC_PG_reg   (*((volatile unsigned int*) SYS_LSADC_PG_reg))
+#define SYS_LSADC_PG_inst_adr                                                        "0x00D3"
+#define SYS_LSADC_PG_inst                                                            0x00D3
+#define SYS_LSADC_PG_REG_VDDMUX_SEL_shift                                            (10)
+#define SYS_LSADC_PG_REG_VDDMUX_SEL_mask                                             (0x00000400)
+#define SYS_LSADC_PG_REG_VDDMUX_SEL(data)                                            (0x00000400&((data)<<10))
+#define SYS_LSADC_PG_REG_VDDMUX_SEL_src(data)                                        ((0x00000400&(data))>>10)
+#define SYS_LSADC_PG_get_REG_VDDMUX_SEL(data)                                        ((0x00000400&(data))>>10)
+#define SYS_LSADC_PG_REG_VDD_MUX1_shift                                              (6)
+#define SYS_LSADC_PG_REG_VDD_MUX1_mask                                               (0x000003C0)
+#define SYS_LSADC_PG_REG_VDD_MUX1(data)                                              (0x000003C0&((data)<<6))
+#define SYS_LSADC_PG_REG_VDD_MUX1_src(data)                                          ((0x000003C0&(data))>>6)
+#define SYS_LSADC_PG_get_REG_VDD_MUX1(data)                                          ((0x000003C0&(data))>>6)
+#define SYS_LSADC_PG_REG_VDD_MUX2_shift                                              (2)
+#define SYS_LSADC_PG_REG_VDD_MUX2_mask                                               (0x0000003C)
+#define SYS_LSADC_PG_REG_VDD_MUX2(data)                                              (0x0000003C&((data)<<2))
+#define SYS_LSADC_PG_REG_VDD_MUX2_src(data)                                          ((0x0000003C&(data))>>2)
+#define SYS_LSADC_PG_get_REG_VDD_MUX2(data)                                          ((0x0000003C&(data))>>2)
+#define SYS_LSADC_PG_REG_VDDMUX_EN_shift                                             (1)
+#define SYS_LSADC_PG_REG_VDDMUX_EN_mask                                              (0x00000002)
+#define SYS_LSADC_PG_REG_VDDMUX_EN(data)                                             (0x00000002&((data)<<1))
+#define SYS_LSADC_PG_REG_VDDMUX_EN_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_LSADC_PG_get_REG_VDDMUX_EN(data)                                         ((0x00000002&(data))>>1)
+#define SYS_LSADC_PG_REG_TEST_OUT_EN_shift                                           (0)
+#define SYS_LSADC_PG_REG_TEST_OUT_EN_mask                                            (0x00000001)
+#define SYS_LSADC_PG_REG_TEST_OUT_EN(data)                                           (0x00000001&((data)<<0))
+#define SYS_LSADC_PG_REG_TEST_OUT_EN_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_LSADC_PG_get_REG_TEST_OUT_EN(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_SCAN_CTRL                                                                0x350
+#define SYS_SCAN_CTRL_reg_addr                                                       "0x98000350"
+#define SYS_SCAN_CTRL_reg                                                            0x98000350
+#define set_SYS_SCAN_CTRL_reg(data)   (*((volatile unsigned int*) SYS_SCAN_CTRL_reg)=data)
+#define get_SYS_SCAN_CTRL_reg   (*((volatile unsigned int*) SYS_SCAN_CTRL_reg))
+#define SYS_SCAN_CTRL_inst_adr                                                       "0x00D4"
+#define SYS_SCAN_CTRL_inst                                                           0x00D4
+#define SYS_SCAN_CTRL_scan_occ_chain_sel_shift                                       (0)
+#define SYS_SCAN_CTRL_scan_occ_chain_sel_mask                                        (0x00000001)
+#define SYS_SCAN_CTRL_scan_occ_chain_sel(data)                                       (0x00000001&((data)<<0))
+#define SYS_SCAN_CTRL_scan_occ_chain_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_SCAN_CTRL_get_scan_occ_chain_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR0                                                           0x360
+#define SYS_DISP_SRAM_PWR0_reg_addr                                                  "0x98000360"
+#define SYS_DISP_SRAM_PWR0_reg                                                       0x98000360
+#define set_SYS_DISP_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR0_reg)=data)
+#define get_SYS_DISP_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR0_reg))
+#define SYS_DISP_SRAM_PWR0_inst_adr                                                  "0x00D8"
+#define SYS_DISP_SRAM_PWR0_inst                                                      0x00D8
+#define SYS_DISP_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                     (0)
+#define SYS_DISP_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                      (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR1                                                           0x364
+#define SYS_DISP_SRAM_PWR1_reg_addr                                                  "0x98000364"
+#define SYS_DISP_SRAM_PWR1_reg                                                       0x98000364
+#define set_SYS_DISP_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR1_reg)=data)
+#define get_SYS_DISP_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR1_reg))
+#define SYS_DISP_SRAM_PWR1_inst_adr                                                  "0x00D9"
+#define SYS_DISP_SRAM_PWR1_inst                                                      0x00D9
+#define SYS_DISP_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                     (0)
+#define SYS_DISP_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                      (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR2                                                           0x368
+#define SYS_DISP_SRAM_PWR2_reg_addr                                                  "0x98000368"
+#define SYS_DISP_SRAM_PWR2_reg                                                       0x98000368
+#define set_SYS_DISP_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR2_reg)=data)
+#define get_SYS_DISP_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR2_reg))
+#define SYS_DISP_SRAM_PWR2_inst_adr                                                  "0x00DA"
+#define SYS_DISP_SRAM_PWR2_inst                                                      0x00DA
+#define SYS_DISP_SRAM_PWR2_SD_REG_shift                                              (0)
+#define SYS_DISP_SRAM_PWR2_SD_REG_mask                                               (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR2_SD_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR2_SD_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR2_get_SD_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR3                                                           0x36c
+#define SYS_DISP_SRAM_PWR3_reg_addr                                                  "0x9800036C"
+#define SYS_DISP_SRAM_PWR3_reg                                                       0x9800036C
+#define set_SYS_DISP_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR3_reg)=data)
+#define get_SYS_DISP_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR3_reg))
+#define SYS_DISP_SRAM_PWR3_inst_adr                                                  "0x00DB"
+#define SYS_DISP_SRAM_PWR3_inst                                                      0x00DB
+#define SYS_DISP_SRAM_PWR3_MUX_REG_shift                                             (0)
+#define SYS_DISP_SRAM_PWR3_MUX_REG_mask                                              (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR3_MUX_REG(data)                                             (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR3_MUX_REG_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR3_get_MUX_REG(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR4                                                           0x370
+#define SYS_DISP_SRAM_PWR4_reg_addr                                                  "0x98000370"
+#define SYS_DISP_SRAM_PWR4_reg                                                       0x98000370
+#define set_SYS_DISP_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR4_reg)=data)
+#define get_SYS_DISP_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR4_reg))
+#define SYS_DISP_SRAM_PWR4_inst_adr                                                  "0x00DC"
+#define SYS_DISP_SRAM_PWR4_inst                                                      0x00DC
+#define SYS_DISP_SRAM_PWR4_CTRL_shift                                                (0)
+#define SYS_DISP_SRAM_PWR4_CTRL_mask                                                 (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR4_CTRL(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR4_CTRL_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR4_get_CTRL(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR5                                                           0x374
+#define SYS_DISP_SRAM_PWR5_reg_addr                                                  "0x98000374"
+#define SYS_DISP_SRAM_PWR5_reg                                                       0x98000374
+#define set_SYS_DISP_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR5_reg)=data)
+#define get_SYS_DISP_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR5_reg))
+#define SYS_DISP_SRAM_PWR5_inst_adr                                                  "0x00DD"
+#define SYS_DISP_SRAM_PWR5_inst                                                      0x00DD
+#define SYS_DISP_SRAM_PWR5_disp_sram_int_shift                                       (2)
+#define SYS_DISP_SRAM_PWR5_disp_sram_int_mask                                        (0x00000004)
+#define SYS_DISP_SRAM_PWR5_disp_sram_int(data)                                       (0x00000004&((data)<<2))
+#define SYS_DISP_SRAM_PWR5_disp_sram_int_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_DISP_SRAM_PWR5_get_disp_sram_int(data)                                   ((0x00000004&(data))>>2)
+#define SYS_DISP_SRAM_PWR5_write_data_shift                                          (0)
+#define SYS_DISP_SRAM_PWR5_write_data_mask                                           (0x00000001)
+#define SYS_DISP_SRAM_PWR5_write_data(data)                                          (0x00000001&((data)<<0))
+#define SYS_DISP_SRAM_PWR5_write_data_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_DISP_SRAM_PWR5_get_write_data(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR6                                                           0x378
+#define SYS_DISP_SRAM_PWR6_reg_addr                                                  "0x98000378"
+#define SYS_DISP_SRAM_PWR6_reg                                                       0x98000378
+#define set_SYS_DISP_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR6_reg)=data)
+#define get_SYS_DISP_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR6_reg))
+#define SYS_DISP_SRAM_PWR6_inst_adr                                                  "0x00DE"
+#define SYS_DISP_SRAM_PWR6_inst                                                      0x00DE
+#define SYS_DISP_SRAM_PWR6_last_delay_cycle_shift                                    (0)
+#define SYS_DISP_SRAM_PWR6_last_delay_cycle_mask                                     (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR6_last_delay_cycle(data)                                    (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR6_last_delay_cycle_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR6_get_last_delay_cycle(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR7                                                           0x37c
+#define SYS_DISP_SRAM_PWR7_reg_addr                                                  "0x9800037C"
+#define SYS_DISP_SRAM_PWR7_reg                                                       0x9800037C
+#define set_SYS_DISP_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR7_reg)=data)
+#define get_SYS_DISP_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR7_reg))
+#define SYS_DISP_SRAM_PWR7_inst_adr                                                  "0x00DF"
+#define SYS_DISP_SRAM_PWR7_inst                                                      0x00DF
+#define SYS_DISP_SRAM_PWR7_pg_switch_info_shift                                      (0)
+#define SYS_DISP_SRAM_PWR7_pg_switch_info_mask                                       (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR7_pg_switch_info(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR7_pg_switch_info_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR7_get_pg_switch_info(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR0                                                            0x380
+#define SYS_VE1_SRAM_PWR0_reg_addr                                                   "0x98000380"
+#define SYS_VE1_SRAM_PWR0_reg                                                        0x98000380
+#define set_SYS_VE1_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR0_reg)=data)
+#define get_SYS_VE1_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR0_reg))
+#define SYS_VE1_SRAM_PWR0_inst_adr                                                   "0x00E0"
+#define SYS_VE1_SRAM_PWR0_inst                                                       0x00E0
+#define SYS_VE1_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE1_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR1                                                            0x384
+#define SYS_VE1_SRAM_PWR1_reg_addr                                                   "0x98000384"
+#define SYS_VE1_SRAM_PWR1_reg                                                        0x98000384
+#define set_SYS_VE1_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR1_reg)=data)
+#define get_SYS_VE1_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR1_reg))
+#define SYS_VE1_SRAM_PWR1_inst_adr                                                   "0x00E1"
+#define SYS_VE1_SRAM_PWR1_inst                                                       0x00E1
+#define SYS_VE1_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE1_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR2                                                            0x388
+#define SYS_VE1_SRAM_PWR2_reg_addr                                                   "0x98000388"
+#define SYS_VE1_SRAM_PWR2_reg                                                        0x98000388
+#define set_SYS_VE1_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR2_reg)=data)
+#define get_SYS_VE1_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR2_reg))
+#define SYS_VE1_SRAM_PWR2_inst_adr                                                   "0x00E2"
+#define SYS_VE1_SRAM_PWR2_inst                                                       0x00E2
+#define SYS_VE1_SRAM_PWR2_SD_REG_shift                                               (0)
+#define SYS_VE1_SRAM_PWR2_SD_REG_mask                                                (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR2_SD_REG(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR2_SD_REG_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR2_get_SD_REG(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR3                                                            0x38c
+#define SYS_VE1_SRAM_PWR3_reg_addr                                                   "0x9800038C"
+#define SYS_VE1_SRAM_PWR3_reg                                                        0x9800038C
+#define set_SYS_VE1_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR3_reg)=data)
+#define get_SYS_VE1_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR3_reg))
+#define SYS_VE1_SRAM_PWR3_inst_adr                                                   "0x00E3"
+#define SYS_VE1_SRAM_PWR3_inst                                                       0x00E3
+#define SYS_VE1_SRAM_PWR3_MUX_REG_shift                                              (0)
+#define SYS_VE1_SRAM_PWR3_MUX_REG_mask                                               (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR3_MUX_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR3_MUX_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR3_get_MUX_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR4                                                            0x390
+#define SYS_VE1_SRAM_PWR4_reg_addr                                                   "0x98000390"
+#define SYS_VE1_SRAM_PWR4_reg                                                        0x98000390
+#define set_SYS_VE1_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR4_reg)=data)
+#define get_SYS_VE1_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR4_reg))
+#define SYS_VE1_SRAM_PWR4_inst_adr                                                   "0x00E4"
+#define SYS_VE1_SRAM_PWR4_inst                                                       0x00E4
+#define SYS_VE1_SRAM_PWR4_CTRL_shift                                                 (0)
+#define SYS_VE1_SRAM_PWR4_CTRL_mask                                                  (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR4_CTRL(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR4_CTRL_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR4_get_CTRL(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR0                                                            0x394
+#define SYS_GPU_SRAM_PWR0_reg_addr                                                   "0x98000394"
+#define SYS_GPU_SRAM_PWR0_reg                                                        0x98000394
+#define set_SYS_GPU_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR0_reg)=data)
+#define get_SYS_GPU_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR0_reg))
+#define SYS_GPU_SRAM_PWR0_inst_adr                                                   "0x00E5"
+#define SYS_GPU_SRAM_PWR0_inst                                                       0x00E5
+#define SYS_GPU_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                      (0)
+#define SYS_GPU_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR1                                                            0x398
+#define SYS_GPU_SRAM_PWR1_reg_addr                                                   "0x98000398"
+#define SYS_GPU_SRAM_PWR1_reg                                                        0x98000398
+#define set_SYS_GPU_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR1_reg)=data)
+#define get_SYS_GPU_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR1_reg))
+#define SYS_GPU_SRAM_PWR1_inst_adr                                                   "0x00E6"
+#define SYS_GPU_SRAM_PWR1_inst                                                       0x00E6
+#define SYS_GPU_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                      (0)
+#define SYS_GPU_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR2                                                            0x39c
+#define SYS_GPU_SRAM_PWR2_reg_addr                                                   "0x9800039C"
+#define SYS_GPU_SRAM_PWR2_reg                                                        0x9800039C
+#define set_SYS_GPU_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR2_reg)=data)
+#define get_SYS_GPU_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR2_reg))
+#define SYS_GPU_SRAM_PWR2_inst_adr                                                   "0x00E7"
+#define SYS_GPU_SRAM_PWR2_inst                                                       0x00E7
+#define SYS_GPU_SRAM_PWR2_SD_REG_shift                                               (0)
+#define SYS_GPU_SRAM_PWR2_SD_REG_mask                                                (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR2_SD_REG(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR2_SD_REG_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR2_get_SD_REG(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR3                                                            0x3a0
+#define SYS_GPU_SRAM_PWR3_reg_addr                                                   "0x980003A0"
+#define SYS_GPU_SRAM_PWR3_reg                                                        0x980003A0
+#define set_SYS_GPU_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR3_reg)=data)
+#define get_SYS_GPU_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR3_reg))
+#define SYS_GPU_SRAM_PWR3_inst_adr                                                   "0x00E8"
+#define SYS_GPU_SRAM_PWR3_inst                                                       0x00E8
+#define SYS_GPU_SRAM_PWR3_MUX_REG_shift                                              (0)
+#define SYS_GPU_SRAM_PWR3_MUX_REG_mask                                               (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR3_MUX_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR3_MUX_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR3_get_MUX_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR4                                                            0x3a4
+#define SYS_GPU_SRAM_PWR4_reg_addr                                                   "0x980003A4"
+#define SYS_GPU_SRAM_PWR4_reg                                                        0x980003A4
+#define set_SYS_GPU_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR4_reg)=data)
+#define get_SYS_GPU_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR4_reg))
+#define SYS_GPU_SRAM_PWR4_inst_adr                                                   "0x00E9"
+#define SYS_GPU_SRAM_PWR4_inst                                                       0x00E9
+#define SYS_GPU_SRAM_PWR4_CTRL_shift                                                 (0)
+#define SYS_GPU_SRAM_PWR4_CTRL_mask                                                  (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR4_CTRL(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR4_CTRL_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR4_get_CTRL(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR5                                                            0x3a8
+#define SYS_VE1_SRAM_PWR5_reg_addr                                                   "0x980003A8"
+#define SYS_VE1_SRAM_PWR5_reg                                                        0x980003A8
+#define set_SYS_VE1_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR5_reg)=data)
+#define get_SYS_VE1_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR5_reg))
+#define SYS_VE1_SRAM_PWR5_inst_adr                                                   "0x00EA"
+#define SYS_VE1_SRAM_PWR5_inst                                                       0x00EA
+#define SYS_VE1_SRAM_PWR5_ve1_sram_int_shift                                         (2)
+#define SYS_VE1_SRAM_PWR5_ve1_sram_int_mask                                          (0x00000004)
+#define SYS_VE1_SRAM_PWR5_ve1_sram_int(data)                                         (0x00000004&((data)<<2))
+#define SYS_VE1_SRAM_PWR5_ve1_sram_int_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE1_SRAM_PWR5_get_ve1_sram_int(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE1_SRAM_PWR5_write_data_shift                                           (0)
+#define SYS_VE1_SRAM_PWR5_write_data_mask                                            (0x00000001)
+#define SYS_VE1_SRAM_PWR5_write_data(data)                                           (0x00000001&((data)<<0))
+#define SYS_VE1_SRAM_PWR5_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_VE1_SRAM_PWR5_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR5                                                            0x3ac
+#define SYS_GPU_SRAM_PWR5_reg_addr                                                   "0x980003AC"
+#define SYS_GPU_SRAM_PWR5_reg                                                        0x980003AC
+#define set_SYS_GPU_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR5_reg)=data)
+#define get_SYS_GPU_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR5_reg))
+#define SYS_GPU_SRAM_PWR5_inst_adr                                                   "0x00EB"
+#define SYS_GPU_SRAM_PWR5_inst                                                       0x00EB
+#define SYS_GPU_SRAM_PWR5_gpu_sram_int_shift                                         (2)
+#define SYS_GPU_SRAM_PWR5_gpu_sram_int_mask                                          (0x00000004)
+#define SYS_GPU_SRAM_PWR5_gpu_sram_int(data)                                         (0x00000004&((data)<<2))
+#define SYS_GPU_SRAM_PWR5_gpu_sram_int_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_GPU_SRAM_PWR5_get_gpu_sram_int(data)                                     ((0x00000004&(data))>>2)
+#define SYS_GPU_SRAM_PWR5_write_data_shift                                           (0)
+#define SYS_GPU_SRAM_PWR5_write_data_mask                                            (0x00000001)
+#define SYS_GPU_SRAM_PWR5_write_data(data)                                           (0x00000001&((data)<<0))
+#define SYS_GPU_SRAM_PWR5_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_GPU_SRAM_PWR5_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR6                                                            0x3b0
+#define SYS_VE1_SRAM_PWR6_reg_addr                                                   "0x980003B0"
+#define SYS_VE1_SRAM_PWR6_reg                                                        0x980003B0
+#define set_SYS_VE1_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR6_reg)=data)
+#define get_SYS_VE1_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR6_reg))
+#define SYS_VE1_SRAM_PWR6_inst_adr                                                   "0x00EC"
+#define SYS_VE1_SRAM_PWR6_inst                                                       0x00EC
+#define SYS_VE1_SRAM_PWR6_last_delay_cycle_shift                                     (0)
+#define SYS_VE1_SRAM_PWR6_last_delay_cycle_mask                                      (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR6_last_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR6_last_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR6_get_last_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR6                                                            0x3b4
+#define SYS_GPU_SRAM_PWR6_reg_addr                                                   "0x980003B4"
+#define SYS_GPU_SRAM_PWR6_reg                                                        0x980003B4
+#define set_SYS_GPU_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR6_reg)=data)
+#define get_SYS_GPU_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR6_reg))
+#define SYS_GPU_SRAM_PWR6_inst_adr                                                   "0x00ED"
+#define SYS_GPU_SRAM_PWR6_inst                                                       0x00ED
+#define SYS_GPU_SRAM_PWR6_last_delay_cycle_shift                                     (0)
+#define SYS_GPU_SRAM_PWR6_last_delay_cycle_mask                                      (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR6_last_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR6_last_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR6_get_last_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR7                                                            0x3b8
+#define SYS_VE1_SRAM_PWR7_reg_addr                                                   "0x980003B8"
+#define SYS_VE1_SRAM_PWR7_reg                                                        0x980003B8
+#define set_SYS_VE1_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR7_reg)=data)
+#define get_SYS_VE1_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR7_reg))
+#define SYS_VE1_SRAM_PWR7_inst_adr                                                   "0x00EE"
+#define SYS_VE1_SRAM_PWR7_inst                                                       0x00EE
+#define SYS_VE1_SRAM_PWR7_pg_switch_info_shift                                       (0)
+#define SYS_VE1_SRAM_PWR7_pg_switch_info_mask                                        (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR7_pg_switch_info(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR7_pg_switch_info_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR7_get_pg_switch_info(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR7                                                            0x3bc
+#define SYS_GPU_SRAM_PWR7_reg_addr                                                   "0x980003BC"
+#define SYS_GPU_SRAM_PWR7_reg                                                        0x980003BC
+#define set_SYS_GPU_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR7_reg)=data)
+#define get_SYS_GPU_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR7_reg))
+#define SYS_GPU_SRAM_PWR7_inst_adr                                                   "0x00EF"
+#define SYS_GPU_SRAM_PWR7_inst                                                       0x00EF
+#define SYS_GPU_SRAM_PWR7_pg_switch_info_shift                                       (0)
+#define SYS_GPU_SRAM_PWR7_pg_switch_info_mask                                        (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR7_pg_switch_info(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR7_pg_switch_info_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR7_get_pg_switch_info(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR0                                                            0x3c0
+#define SYS_VE2_SRAM_PWR0_reg_addr                                                   "0x980003C0"
+#define SYS_VE2_SRAM_PWR0_reg                                                        0x980003C0
+#define set_SYS_VE2_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR0_reg)=data)
+#define get_SYS_VE2_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR0_reg))
+#define SYS_VE2_SRAM_PWR0_inst_adr                                                   "0x00F0"
+#define SYS_VE2_SRAM_PWR0_inst                                                       0x00F0
+#define SYS_VE2_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE2_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR1                                                            0x3c4
+#define SYS_VE2_SRAM_PWR1_reg_addr                                                   "0x980003C4"
+#define SYS_VE2_SRAM_PWR1_reg                                                        0x980003C4
+#define set_SYS_VE2_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR1_reg)=data)
+#define get_SYS_VE2_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR1_reg))
+#define SYS_VE2_SRAM_PWR1_inst_adr                                                   "0x00F1"
+#define SYS_VE2_SRAM_PWR1_inst                                                       0x00F1
+#define SYS_VE2_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE2_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR2                                                            0x3c8
+#define SYS_VE2_SRAM_PWR2_reg_addr                                                   "0x980003C8"
+#define SYS_VE2_SRAM_PWR2_reg                                                        0x980003C8
+#define set_SYS_VE2_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR2_reg)=data)
+#define get_SYS_VE2_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR2_reg))
+#define SYS_VE2_SRAM_PWR2_inst_adr                                                   "0x00F2"
+#define SYS_VE2_SRAM_PWR2_inst                                                       0x00F2
+#define SYS_VE2_SRAM_PWR2_SD_REG_shift                                               (0)
+#define SYS_VE2_SRAM_PWR2_SD_REG_mask                                                (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR2_SD_REG(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR2_SD_REG_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR2_get_SD_REG(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR3                                                            0x3cc
+#define SYS_VE2_SRAM_PWR3_reg_addr                                                   "0x980003CC"
+#define SYS_VE2_SRAM_PWR3_reg                                                        0x980003CC
+#define set_SYS_VE2_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR3_reg)=data)
+#define get_SYS_VE2_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR3_reg))
+#define SYS_VE2_SRAM_PWR3_inst_adr                                                   "0x00F3"
+#define SYS_VE2_SRAM_PWR3_inst                                                       0x00F3
+#define SYS_VE2_SRAM_PWR3_MUX_REG_shift                                              (0)
+#define SYS_VE2_SRAM_PWR3_MUX_REG_mask                                               (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR3_MUX_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR3_MUX_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR3_get_MUX_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR4                                                            0x3d0
+#define SYS_VE2_SRAM_PWR4_reg_addr                                                   "0x980003D0"
+#define SYS_VE2_SRAM_PWR4_reg                                                        0x980003D0
+#define set_SYS_VE2_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR4_reg)=data)
+#define get_SYS_VE2_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR4_reg))
+#define SYS_VE2_SRAM_PWR4_inst_adr                                                   "0x00F4"
+#define SYS_VE2_SRAM_PWR4_inst                                                       0x00F4
+#define SYS_VE2_SRAM_PWR4_CTRL_shift                                                 (0)
+#define SYS_VE2_SRAM_PWR4_CTRL_mask                                                  (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR4_CTRL(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR4_CTRL_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR4_get_CTRL(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR5                                                            0x3d4
+#define SYS_VE2_SRAM_PWR5_reg_addr                                                   "0x980003D4"
+#define SYS_VE2_SRAM_PWR5_reg                                                        0x980003D4
+#define set_SYS_VE2_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR5_reg)=data)
+#define get_SYS_VE2_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR5_reg))
+#define SYS_VE2_SRAM_PWR5_inst_adr                                                   "0x00F5"
+#define SYS_VE2_SRAM_PWR5_inst                                                       0x00F5
+#define SYS_VE2_SRAM_PWR5_ve2_sram_int_shift                                         (2)
+#define SYS_VE2_SRAM_PWR5_ve2_sram_int_mask                                          (0x00000004)
+#define SYS_VE2_SRAM_PWR5_ve2_sram_int(data)                                         (0x00000004&((data)<<2))
+#define SYS_VE2_SRAM_PWR5_ve2_sram_int_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE2_SRAM_PWR5_get_ve2_sram_int(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE2_SRAM_PWR5_write_data_shift                                           (0)
+#define SYS_VE2_SRAM_PWR5_write_data_mask                                            (0x00000001)
+#define SYS_VE2_SRAM_PWR5_write_data(data)                                           (0x00000001&((data)<<0))
+#define SYS_VE2_SRAM_PWR5_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_VE2_SRAM_PWR5_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR6                                                            0x3d8
+#define SYS_VE2_SRAM_PWR6_reg_addr                                                   "0x980003D8"
+#define SYS_VE2_SRAM_PWR6_reg                                                        0x980003D8
+#define set_SYS_VE2_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR6_reg)=data)
+#define get_SYS_VE2_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR6_reg))
+#define SYS_VE2_SRAM_PWR6_inst_adr                                                   "0x00F6"
+#define SYS_VE2_SRAM_PWR6_inst                                                       0x00F6
+#define SYS_VE2_SRAM_PWR6_last_delay_cycle_shift                                     (0)
+#define SYS_VE2_SRAM_PWR6_last_delay_cycle_mask                                      (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR6_last_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR6_last_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR6_get_last_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR7                                                            0x3dc
+#define SYS_VE2_SRAM_PWR7_reg_addr                                                   "0x980003DC"
+#define SYS_VE2_SRAM_PWR7_reg                                                        0x980003DC
+#define set_SYS_VE2_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR7_reg)=data)
+#define get_SYS_VE2_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR7_reg))
+#define SYS_VE2_SRAM_PWR7_inst_adr                                                   "0x00F7"
+#define SYS_VE2_SRAM_PWR7_inst                                                       0x00F7
+#define SYS_VE2_SRAM_PWR7_pg_switch_info_shift                                       (0)
+#define SYS_VE2_SRAM_PWR7_pg_switch_info_mask                                        (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR7_pg_switch_info(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR7_pg_switch_info_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR7_get_pg_switch_info(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR0                                                            0x3e0
+#define SYS_VE3_SRAM_PWR0_reg_addr                                                   "0x980003E0"
+#define SYS_VE3_SRAM_PWR0_reg                                                        0x980003E0
+#define set_SYS_VE3_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR0_reg)=data)
+#define get_SYS_VE3_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR0_reg))
+#define SYS_VE3_SRAM_PWR0_inst_adr                                                   "0x00F8"
+#define SYS_VE3_SRAM_PWR0_inst                                                       0x00F8
+#define SYS_VE3_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE3_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR1                                                            0x3e4
+#define SYS_VE3_SRAM_PWR1_reg_addr                                                   "0x980003E4"
+#define SYS_VE3_SRAM_PWR1_reg                                                        0x980003E4
+#define set_SYS_VE3_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR1_reg)=data)
+#define get_SYS_VE3_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR1_reg))
+#define SYS_VE3_SRAM_PWR1_inst_adr                                                   "0x00F9"
+#define SYS_VE3_SRAM_PWR1_inst                                                       0x00F9
+#define SYS_VE3_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE3_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR2                                                            0x3e8
+#define SYS_VE3_SRAM_PWR2_reg_addr                                                   "0x980003E8"
+#define SYS_VE3_SRAM_PWR2_reg                                                        0x980003E8
+#define set_SYS_VE3_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR2_reg)=data)
+#define get_SYS_VE3_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR2_reg))
+#define SYS_VE3_SRAM_PWR2_inst_adr                                                   "0x00FA"
+#define SYS_VE3_SRAM_PWR2_inst                                                       0x00FA
+#define SYS_VE3_SRAM_PWR2_SD_REG_shift                                               (0)
+#define SYS_VE3_SRAM_PWR2_SD_REG_mask                                                (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR2_SD_REG(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR2_SD_REG_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR2_get_SD_REG(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR3                                                            0x3ec
+#define SYS_VE3_SRAM_PWR3_reg_addr                                                   "0x980003EC"
+#define SYS_VE3_SRAM_PWR3_reg                                                        0x980003EC
+#define set_SYS_VE3_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR3_reg)=data)
+#define get_SYS_VE3_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR3_reg))
+#define SYS_VE3_SRAM_PWR3_inst_adr                                                   "0x00FB"
+#define SYS_VE3_SRAM_PWR3_inst                                                       0x00FB
+#define SYS_VE3_SRAM_PWR3_MUX_REG_shift                                              (0)
+#define SYS_VE3_SRAM_PWR3_MUX_REG_mask                                               (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR3_MUX_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR3_MUX_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR3_get_MUX_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR4                                                            0x3f0
+#define SYS_VE3_SRAM_PWR4_reg_addr                                                   "0x980003F0"
+#define SYS_VE3_SRAM_PWR4_reg                                                        0x980003F0
+#define set_SYS_VE3_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR4_reg)=data)
+#define get_SYS_VE3_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR4_reg))
+#define SYS_VE3_SRAM_PWR4_inst_adr                                                   "0x00FC"
+#define SYS_VE3_SRAM_PWR4_inst                                                       0x00FC
+#define SYS_VE3_SRAM_PWR4_CTRL_shift                                                 (0)
+#define SYS_VE3_SRAM_PWR4_CTRL_mask                                                  (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR4_CTRL(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR4_CTRL_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR4_get_CTRL(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR5                                                            0x3f4
+#define SYS_VE3_SRAM_PWR5_reg_addr                                                   "0x980003F4"
+#define SYS_VE3_SRAM_PWR5_reg                                                        0x980003F4
+#define set_SYS_VE3_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR5_reg)=data)
+#define get_SYS_VE3_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR5_reg))
+#define SYS_VE3_SRAM_PWR5_inst_adr                                                   "0x00FD"
+#define SYS_VE3_SRAM_PWR5_inst                                                       0x00FD
+#define SYS_VE3_SRAM_PWR5_ve3_sram_int_shift                                         (2)
+#define SYS_VE3_SRAM_PWR5_ve3_sram_int_mask                                          (0x00000004)
+#define SYS_VE3_SRAM_PWR5_ve3_sram_int(data)                                         (0x00000004&((data)<<2))
+#define SYS_VE3_SRAM_PWR5_ve3_sram_int_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE3_SRAM_PWR5_get_ve3_sram_int(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE3_SRAM_PWR5_write_data_shift                                           (0)
+#define SYS_VE3_SRAM_PWR5_write_data_mask                                            (0x00000001)
+#define SYS_VE3_SRAM_PWR5_write_data(data)                                           (0x00000001&((data)<<0))
+#define SYS_VE3_SRAM_PWR5_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_VE3_SRAM_PWR5_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR6                                                            0x3f8
+#define SYS_VE3_SRAM_PWR6_reg_addr                                                   "0x980003F8"
+#define SYS_VE3_SRAM_PWR6_reg                                                        0x980003F8
+#define set_SYS_VE3_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR6_reg)=data)
+#define get_SYS_VE3_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR6_reg))
+#define SYS_VE3_SRAM_PWR6_inst_adr                                                   "0x00FE"
+#define SYS_VE3_SRAM_PWR6_inst                                                       0x00FE
+#define SYS_VE3_SRAM_PWR6_last_delay_cycle_shift                                     (0)
+#define SYS_VE3_SRAM_PWR6_last_delay_cycle_mask                                      (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR6_last_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR6_last_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR6_get_last_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR7                                                            0x3fc
+#define SYS_VE3_SRAM_PWR7_reg_addr                                                   "0x980003FC"
+#define SYS_VE3_SRAM_PWR7_reg                                                        0x980003FC
+#define set_SYS_VE3_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR7_reg)=data)
+#define get_SYS_VE3_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR7_reg))
+#define SYS_VE3_SRAM_PWR7_inst_adr                                                   "0x00FF"
+#define SYS_VE3_SRAM_PWR7_inst                                                       0x00FF
+#define SYS_VE3_SRAM_PWR7_pg_switch_info_shift                                       (0)
+#define SYS_VE3_SRAM_PWR7_pg_switch_info_mask                                        (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR7_pg_switch_info(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR7_pg_switch_info_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR7_get_pg_switch_info(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_POWER_CTRL                                                               0x400
+#define SYS_POWER_CTRL_reg_addr                                                      "0x98000400"
+#define SYS_POWER_CTRL_reg                                                           0x98000400
+#define set_SYS_POWER_CTRL_reg(data)   (*((volatile unsigned int*) SYS_POWER_CTRL_reg)=data)
+#define get_SYS_POWER_CTRL_reg   (*((volatile unsigned int*) SYS_POWER_CTRL_reg))
+#define SYS_POWER_CTRL_inst_adr                                                      "0x0000"
+#define SYS_POWER_CTRL_inst                                                          0x0000
+#define SYS_POWER_CTRL_nat_sram_int_mask_shift                                       (19)
+#define SYS_POWER_CTRL_nat_sram_int_mask_mask                                        (0x00080000)
+#define SYS_POWER_CTRL_nat_sram_int_mask(data)                                       (0x00080000&((data)<<19))
+#define SYS_POWER_CTRL_nat_sram_int_mask_src(data)                                   ((0x00080000&(data))>>19)
+#define SYS_POWER_CTRL_get_nat_sram_int_mask(data)                                   ((0x00080000&(data))>>19)
+#define SYS_POWER_CTRL_iso_nat_shift                                                 (18)
+#define SYS_POWER_CTRL_iso_nat_mask                                                  (0x00040000)
+#define SYS_POWER_CTRL_iso_nat(data)                                                 (0x00040000&((data)<<18))
+#define SYS_POWER_CTRL_iso_nat_src(data)                                             ((0x00040000&(data))>>18)
+#define SYS_POWER_CTRL_get_iso_nat(data)                                             ((0x00040000&(data))>>18)
+#define SYS_POWER_CTRL_vetop_rm_shift                                                (14)
+#define SYS_POWER_CTRL_vetop_rm_mask                                                 (0x0003C000)
+#define SYS_POWER_CTRL_vetop_rm(data)                                                (0x0003C000&((data)<<14))
+#define SYS_POWER_CTRL_vetop_rm_src(data)                                            ((0x0003C000&(data))>>14)
+#define SYS_POWER_CTRL_get_vetop_rm(data)                                            ((0x0003C000&(data))>>14)
+#define SYS_POWER_CTRL_vetop_rme_shift                                               (13)
+#define SYS_POWER_CTRL_vetop_rme_mask                                                (0x00002000)
+#define SYS_POWER_CTRL_vetop_rme(data)                                               (0x00002000&((data)<<13))
+#define SYS_POWER_CTRL_vetop_rme_src(data)                                           ((0x00002000&(data))>>13)
+#define SYS_POWER_CTRL_get_vetop_rme(data)                                           ((0x00002000&(data))>>13)
+#define SYS_POWER_CTRL_vetop_sd_shift                                                (12)
+#define SYS_POWER_CTRL_vetop_sd_mask                                                 (0x00001000)
+#define SYS_POWER_CTRL_vetop_sd(data)                                                (0x00001000&((data)<<12))
+#define SYS_POWER_CTRL_vetop_sd_src(data)                                            ((0x00001000&(data))>>12)
+#define SYS_POWER_CTRL_get_vetop_sd(data)                                            ((0x00001000&(data))>>12)
+#define SYS_POWER_CTRL_vetop_ds_shift                                                (11)
+#define SYS_POWER_CTRL_vetop_ds_mask                                                 (0x00000800)
+#define SYS_POWER_CTRL_vetop_ds(data)                                                (0x00000800&((data)<<11))
+#define SYS_POWER_CTRL_vetop_ds_src(data)                                            ((0x00000800&(data))>>11)
+#define SYS_POWER_CTRL_get_vetop_ds(data)                                            ((0x00000800&(data))>>11)
+#define SYS_POWER_CTRL_vetop_ls_shift                                                (10)
+#define SYS_POWER_CTRL_vetop_ls_mask                                                 (0x00000400)
+#define SYS_POWER_CTRL_vetop_ls(data)                                                (0x00000400&((data)<<10))
+#define SYS_POWER_CTRL_vetop_ls_src(data)                                            ((0x00000400&(data))>>10)
+#define SYS_POWER_CTRL_get_vetop_ls(data)                                            ((0x00000400&(data))>>10)
+#define SYS_POWER_CTRL_disp_sram_int_mask_shift                                      (9)
+#define SYS_POWER_CTRL_disp_sram_int_mask_mask                                       (0x00000200)
+#define SYS_POWER_CTRL_disp_sram_int_mask(data)                                      (0x00000200&((data)<<9))
+#define SYS_POWER_CTRL_disp_sram_int_mask_src(data)                                  ((0x00000200&(data))>>9)
+#define SYS_POWER_CTRL_get_disp_sram_int_mask(data)                                  ((0x00000200&(data))>>9)
+#define SYS_POWER_CTRL_iso_disp_shift                                                (8)
+#define SYS_POWER_CTRL_iso_disp_mask                                                 (0x00000100)
+#define SYS_POWER_CTRL_iso_disp(data)                                                (0x00000100&((data)<<8))
+#define SYS_POWER_CTRL_iso_disp_src(data)                                            ((0x00000100&(data))>>8)
+#define SYS_POWER_CTRL_get_iso_disp(data)                                            ((0x00000100&(data))>>8)
+#define SYS_POWER_CTRL_ve3_sram_int_mask_shift                                       (7)
+#define SYS_POWER_CTRL_ve3_sram_int_mask_mask                                        (0x00000080)
+#define SYS_POWER_CTRL_ve3_sram_int_mask(data)                                       (0x00000080&((data)<<7))
+#define SYS_POWER_CTRL_ve3_sram_int_mask_src(data)                                   ((0x00000080&(data))>>7)
+#define SYS_POWER_CTRL_get_ve3_sram_int_mask(data)                                   ((0x00000080&(data))>>7)
+#define SYS_POWER_CTRL_iso_ve3_shift                                                 (6)
+#define SYS_POWER_CTRL_iso_ve3_mask                                                  (0x00000040)
+#define SYS_POWER_CTRL_iso_ve3(data)                                                 (0x00000040&((data)<<6))
+#define SYS_POWER_CTRL_iso_ve3_src(data)                                             ((0x00000040&(data))>>6)
+#define SYS_POWER_CTRL_get_iso_ve3(data)                                             ((0x00000040&(data))>>6)
+#define SYS_POWER_CTRL_ve2_sram_int_mask_shift                                       (5)
+#define SYS_POWER_CTRL_ve2_sram_int_mask_mask                                        (0x00000020)
+#define SYS_POWER_CTRL_ve2_sram_int_mask(data)                                       (0x00000020&((data)<<5))
+#define SYS_POWER_CTRL_ve2_sram_int_mask_src(data)                                   ((0x00000020&(data))>>5)
+#define SYS_POWER_CTRL_get_ve2_sram_int_mask(data)                                   ((0x00000020&(data))>>5)
+#define SYS_POWER_CTRL_iso_ve2_shift                                                 (4)
+#define SYS_POWER_CTRL_iso_ve2_mask                                                  (0x00000010)
+#define SYS_POWER_CTRL_iso_ve2(data)                                                 (0x00000010&((data)<<4))
+#define SYS_POWER_CTRL_iso_ve2_src(data)                                             ((0x00000010&(data))>>4)
+#define SYS_POWER_CTRL_get_iso_ve2(data)                                             ((0x00000010&(data))>>4)
+#define SYS_POWER_CTRL_ve1_sram_int_mask_shift                                       (3)
+#define SYS_POWER_CTRL_ve1_sram_int_mask_mask                                        (0x00000008)
+#define SYS_POWER_CTRL_ve1_sram_int_mask(data)                                       (0x00000008&((data)<<3))
+#define SYS_POWER_CTRL_ve1_sram_int_mask_src(data)                                   ((0x00000008&(data))>>3)
+#define SYS_POWER_CTRL_get_ve1_sram_int_mask(data)                                   ((0x00000008&(data))>>3)
+#define SYS_POWER_CTRL_gpu_sram_int_mask_shift                                       (2)
+#define SYS_POWER_CTRL_gpu_sram_int_mask_mask                                        (0x00000004)
+#define SYS_POWER_CTRL_gpu_sram_int_mask(data)                                       (0x00000004&((data)<<2))
+#define SYS_POWER_CTRL_gpu_sram_int_mask_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_POWER_CTRL_get_gpu_sram_int_mask(data)                                   ((0x00000004&(data))>>2)
+#define SYS_POWER_CTRL_iso_gpu_shift                                                 (1)
+#define SYS_POWER_CTRL_iso_gpu_mask                                                  (0x00000002)
+#define SYS_POWER_CTRL_iso_gpu(data)                                                 (0x00000002&((data)<<1))
+#define SYS_POWER_CTRL_iso_gpu_src(data)                                             ((0x00000002&(data))>>1)
+#define SYS_POWER_CTRL_get_iso_gpu(data)                                             ((0x00000002&(data))>>1)
+#define SYS_POWER_CTRL_iso_ve1_shift                                                 (0)
+#define SYS_POWER_CTRL_iso_ve1_mask                                                  (0x00000001)
+#define SYS_POWER_CTRL_iso_ve1(data)                                                 (0x00000001&((data)<<0))
+#define SYS_POWER_CTRL_iso_ve1_src(data)                                             ((0x00000001&(data))>>0)
+#define SYS_POWER_CTRL_get_iso_ve1(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PROB                                                                 0x408
+#define SYS_PLL_PROB_reg_addr                                                        "0x98000408"
+#define SYS_PLL_PROB_reg                                                             0x98000408
+#define set_SYS_PLL_PROB_reg(data)   (*((volatile unsigned int*) SYS_PLL_PROB_reg)=data)
+#define get_SYS_PLL_PROB_reg   (*((volatile unsigned int*) SYS_PLL_PROB_reg))
+#define SYS_PLL_PROB_inst_adr                                                        "0x0002"
+#define SYS_PLL_PROB_inst                                                            0x0002
+#define SYS_PLL_PROB_vprob_plltest_sel_loc1_shift                                    (10)
+#define SYS_PLL_PROB_vprob_plltest_sel_loc1_mask                                     (0x00007C00)
+#define SYS_PLL_PROB_vprob_plltest_sel_loc1(data)                                    (0x00007C00&((data)<<10))
+#define SYS_PLL_PROB_vprob_plltest_sel_loc1_src(data)                                ((0x00007C00&(data))>>10)
+#define SYS_PLL_PROB_get_vprob_plltest_sel_loc1(data)                                ((0x00007C00&(data))>>10)
+#define SYS_PLL_PROB_vprob_plltest_sel_loc0_shift                                    (5)
+#define SYS_PLL_PROB_vprob_plltest_sel_loc0_mask                                     (0x000003E0)
+#define SYS_PLL_PROB_vprob_plltest_sel_loc0(data)                                    (0x000003E0&((data)<<5))
+#define SYS_PLL_PROB_vprob_plltest_sel_loc0_src(data)                                ((0x000003E0&(data))>>5)
+#define SYS_PLL_PROB_get_vprob_plltest_sel_loc0(data)                                ((0x000003E0&(data))>>5)
+#define SYS_PLL_PROB_vprob_ea_loc1_shift                                             (4)
+#define SYS_PLL_PROB_vprob_ea_loc1_mask                                              (0x00000010)
+#define SYS_PLL_PROB_vprob_ea_loc1(data)                                             (0x00000010&((data)<<4))
+#define SYS_PLL_PROB_vprob_ea_loc1_src(data)                                         ((0x00000010&(data))>>4)
+#define SYS_PLL_PROB_get_vprob_ea_loc1(data)                                         ((0x00000010&(data))>>4)
+#define SYS_PLL_PROB_vprob_ea_loc0_shift                                             (3)
+#define SYS_PLL_PROB_vprob_ea_loc0_mask                                              (0x00000008)
+#define SYS_PLL_PROB_vprob_ea_loc0(data)                                             (0x00000008&((data)<<3))
+#define SYS_PLL_PROB_vprob_ea_loc0_src(data)                                         ((0x00000008&(data))>>3)
+#define SYS_PLL_PROB_get_vprob_ea_loc0(data)                                         ((0x00000008&(data))>>3)
+
+
+#define SYS_CRT_DEBUG                                                                0x410
+#define SYS_CRT_DEBUG_reg_addr                                                       "0x98000410"
+#define SYS_CRT_DEBUG_reg                                                            0x98000410
+#define set_SYS_CRT_DEBUG_reg(data)   (*((volatile unsigned int*) SYS_CRT_DEBUG_reg)=data)
+#define get_SYS_CRT_DEBUG_reg   (*((volatile unsigned int*) SYS_CRT_DEBUG_reg))
+#define SYS_CRT_DEBUG_inst_adr                                                       "0x0004"
+#define SYS_CRT_DEBUG_inst                                                           0x0004
+#define SYS_CRT_DEBUG_crt_dbg_en_shift                                               (8)
+#define SYS_CRT_DEBUG_crt_dbg_en_mask                                                (0x00000100)
+#define SYS_CRT_DEBUG_crt_dbg_en(data)                                               (0x00000100&((data)<<8))
+#define SYS_CRT_DEBUG_crt_dbg_en_src(data)                                           ((0x00000100&(data))>>8)
+#define SYS_CRT_DEBUG_get_crt_dbg_en(data)                                           ((0x00000100&(data))>>8)
+#define SYS_CRT_DEBUG_crt_dbg_sel0_shift                                             (4)
+#define SYS_CRT_DEBUG_crt_dbg_sel0_mask                                              (0x000000F0)
+#define SYS_CRT_DEBUG_crt_dbg_sel0(data)                                             (0x000000F0&((data)<<4))
+#define SYS_CRT_DEBUG_crt_dbg_sel0_src(data)                                         ((0x000000F0&(data))>>4)
+#define SYS_CRT_DEBUG_get_crt_dbg_sel0(data)                                         ((0x000000F0&(data))>>4)
+#define SYS_CRT_DEBUG_crt_dbg_sel1_shift                                             (0)
+#define SYS_CRT_DEBUG_crt_dbg_sel1_mask                                              (0x0000000F)
+#define SYS_CRT_DEBUG_crt_dbg_sel1(data)                                             (0x0000000F&((data)<<0))
+#define SYS_CRT_DEBUG_crt_dbg_sel1_src(data)                                         ((0x0000000F&(data))>>0)
+#define SYS_CRT_DEBUG_get_crt_dbg_sel1(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define SYS_DEBUG                                                                    0x414
+#define SYS_DEBUG_reg_addr                                                           "0x98000414"
+#define SYS_DEBUG_reg                                                                0x98000414
+#define set_SYS_DEBUG_reg(data)   (*((volatile unsigned int*) SYS_DEBUG_reg)=data)
+#define get_SYS_DEBUG_reg   (*((volatile unsigned int*) SYS_DEBUG_reg))
+#define SYS_DEBUG_inst_adr                                                           "0x0005"
+#define SYS_DEBUG_inst                                                               0x0005
+#define SYS_DEBUG_reserved_debug_shift                                               (0)
+#define SYS_DEBUG_reserved_debug_mask                                                (0x00000001)
+#define SYS_DEBUG_reserved_debug(data)                                               (0x00000001&((data)<<0))
+#define SYS_DEBUG_reserved_debug_src(data)                                           ((0x00000001&(data))>>0)
+#define SYS_DEBUG_get_reserved_debug(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SYS_MBIST                                                                    0x418
+#define SYS_MBIST_reg_addr                                                           "0x98000418"
+#define SYS_MBIST_reg                                                                0x98000418
+#define set_SYS_MBIST_reg(data)   (*((volatile unsigned int*) SYS_MBIST_reg)=data)
+#define get_SYS_MBIST_reg   (*((volatile unsigned int*) SYS_MBIST_reg))
+#define SYS_MBIST_inst_adr                                                           "0x0006"
+#define SYS_MBIST_inst                                                               0x0006
+#define SYS_MBIST_rbus_protect_shift                                                 (0)
+#define SYS_MBIST_rbus_protect_mask                                                  (0xFFFFFFFF)
+#define SYS_MBIST_rbus_protect(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_MBIST_rbus_protect_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_MBIST_get_rbus_protect(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_PLLDIV                                                                   0x41c
+#define SYS_PLLDIV_reg_addr                                                          "0x9800041C"
+#define SYS_PLLDIV_reg                                                               0x9800041C
+#define set_SYS_PLLDIV_reg(data)   (*((volatile unsigned int*) SYS_PLLDIV_reg)=data)
+#define get_SYS_PLLDIV_reg   (*((volatile unsigned int*) SYS_PLLDIV_reg))
+#define SYS_PLLDIV_inst_adr                                                          "0x0007"
+#define SYS_PLLDIV_inst                                                              0x0007
+#define SYS_PLLDIV_dvsorting_shift                                                   (6)
+#define SYS_PLLDIV_dvsorting_mask                                                    (0x00000040)
+#define SYS_PLLDIV_dvsorting(data)                                                   (0x00000040&((data)<<6))
+#define SYS_PLLDIV_dvsorting_src(data)                                               ((0x00000040&(data))>>6)
+#define SYS_PLLDIV_get_dvsorting(data)                                               ((0x00000040&(data))>>6)
+#define SYS_PLLDIV_pcie1_bak_sel_shift                                               (5)
+#define SYS_PLLDIV_pcie1_bak_sel_mask                                                (0x00000020)
+#define SYS_PLLDIV_pcie1_bak_sel(data)                                               (0x00000020&((data)<<5))
+#define SYS_PLLDIV_pcie1_bak_sel_src(data)                                           ((0x00000020&(data))>>5)
+#define SYS_PLLDIV_get_pcie1_bak_sel(data)                                           ((0x00000020&(data))>>5)
+#define SYS_PLLDIV_pcie0_bak_sel_shift                                               (4)
+#define SYS_PLLDIV_pcie0_bak_sel_mask                                                (0x00000010)
+#define SYS_PLLDIV_pcie0_bak_sel(data)                                               (0x00000010&((data)<<4))
+#define SYS_PLLDIV_pcie0_bak_sel_src(data)                                           ((0x00000010&(data))>>4)
+#define SYS_PLLDIV_get_pcie0_bak_sel(data)                                           ((0x00000010&(data))>>4)
+#define SYS_PLLDIV_plldiv_sel_shift                                                  (0)
+#define SYS_PLLDIV_plldiv_sel_mask                                                   (0x0000000F)
+#define SYS_PLLDIV_plldiv_sel(data)                                                  (0x0000000F&((data)<<0))
+#define SYS_PLLDIV_plldiv_sel_src(data)                                              ((0x0000000F&(data))>>0)
+#define SYS_PLLDIV_get_plldiv_sel(data)                                              ((0x0000000F&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR0                                                            0x420
+#define SYS_NAT_SRAM_PWR0_reg_addr                                                   "0x98000420"
+#define SYS_NAT_SRAM_PWR0_reg                                                        0x98000420
+#define set_SYS_NAT_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR0_reg)=data)
+#define get_SYS_NAT_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR0_reg))
+#define SYS_NAT_SRAM_PWR0_inst_adr                                                   "0x0008"
+#define SYS_NAT_SRAM_PWR0_inst                                                       0x0008
+#define SYS_NAT_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                      (0)
+#define SYS_NAT_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR1                                                            0x424
+#define SYS_NAT_SRAM_PWR1_reg_addr                                                   "0x98000424"
+#define SYS_NAT_SRAM_PWR1_reg                                                        0x98000424
+#define set_SYS_NAT_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR1_reg)=data)
+#define get_SYS_NAT_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR1_reg))
+#define SYS_NAT_SRAM_PWR1_inst_adr                                                   "0x0009"
+#define SYS_NAT_SRAM_PWR1_inst                                                       0x0009
+#define SYS_NAT_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                      (0)
+#define SYS_NAT_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR2                                                            0x428
+#define SYS_NAT_SRAM_PWR2_reg_addr                                                   "0x98000428"
+#define SYS_NAT_SRAM_PWR2_reg                                                        0x98000428
+#define set_SYS_NAT_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR2_reg)=data)
+#define get_SYS_NAT_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR2_reg))
+#define SYS_NAT_SRAM_PWR2_inst_adr                                                   "0x000A"
+#define SYS_NAT_SRAM_PWR2_inst                                                       0x000A
+#define SYS_NAT_SRAM_PWR2_SD_REG_shift                                               (0)
+#define SYS_NAT_SRAM_PWR2_SD_REG_mask                                                (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR2_SD_REG(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR2_SD_REG_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR2_get_SD_REG(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR3                                                            0x42c
+#define SYS_NAT_SRAM_PWR3_reg_addr                                                   "0x9800042C"
+#define SYS_NAT_SRAM_PWR3_reg                                                        0x9800042C
+#define set_SYS_NAT_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR3_reg)=data)
+#define get_SYS_NAT_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR3_reg))
+#define SYS_NAT_SRAM_PWR3_inst_adr                                                   "0x000B"
+#define SYS_NAT_SRAM_PWR3_inst                                                       0x000B
+#define SYS_NAT_SRAM_PWR3_MUX_REG_shift                                              (0)
+#define SYS_NAT_SRAM_PWR3_MUX_REG_mask                                               (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR3_MUX_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR3_MUX_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR3_get_MUX_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR4                                                            0x430
+#define SYS_NAT_SRAM_PWR4_reg_addr                                                   "0x98000430"
+#define SYS_NAT_SRAM_PWR4_reg                                                        0x98000430
+#define set_SYS_NAT_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR4_reg)=data)
+#define get_SYS_NAT_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR4_reg))
+#define SYS_NAT_SRAM_PWR4_inst_adr                                                   "0x000C"
+#define SYS_NAT_SRAM_PWR4_inst                                                       0x000C
+#define SYS_NAT_SRAM_PWR4_CTRL_shift                                                 (0)
+#define SYS_NAT_SRAM_PWR4_CTRL_mask                                                  (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR4_CTRL(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR4_CTRL_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR4_get_CTRL(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR5                                                            0x434
+#define SYS_NAT_SRAM_PWR5_reg_addr                                                   "0x98000434"
+#define SYS_NAT_SRAM_PWR5_reg                                                        0x98000434
+#define set_SYS_NAT_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR5_reg)=data)
+#define get_SYS_NAT_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR5_reg))
+#define SYS_NAT_SRAM_PWR5_inst_adr                                                   "0x000D"
+#define SYS_NAT_SRAM_PWR5_inst                                                       0x000D
+#define SYS_NAT_SRAM_PWR5_nat_sram_int_shift                                         (2)
+#define SYS_NAT_SRAM_PWR5_nat_sram_int_mask                                          (0x00000004)
+#define SYS_NAT_SRAM_PWR5_nat_sram_int(data)                                         (0x00000004&((data)<<2))
+#define SYS_NAT_SRAM_PWR5_nat_sram_int_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_NAT_SRAM_PWR5_get_nat_sram_int(data)                                     ((0x00000004&(data))>>2)
+#define SYS_NAT_SRAM_PWR5_write_data_shift                                           (0)
+#define SYS_NAT_SRAM_PWR5_write_data_mask                                            (0x00000001)
+#define SYS_NAT_SRAM_PWR5_write_data(data)                                           (0x00000001&((data)<<0))
+#define SYS_NAT_SRAM_PWR5_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_NAT_SRAM_PWR5_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR6                                                            0x438
+#define SYS_NAT_SRAM_PWR6_reg_addr                                                   "0x98000438"
+#define SYS_NAT_SRAM_PWR6_reg                                                        0x98000438
+#define set_SYS_NAT_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR6_reg)=data)
+#define get_SYS_NAT_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR6_reg))
+#define SYS_NAT_SRAM_PWR6_inst_adr                                                   "0x000E"
+#define SYS_NAT_SRAM_PWR6_inst                                                       0x000E
+#define SYS_NAT_SRAM_PWR6_last_delay_cycle_shift                                     (0)
+#define SYS_NAT_SRAM_PWR6_last_delay_cycle_mask                                      (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR6_last_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR6_last_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR6_get_last_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR7                                                            0x43c
+#define SYS_NAT_SRAM_PWR7_reg_addr                                                   "0x9800043C"
+#define SYS_NAT_SRAM_PWR7_reg                                                        0x9800043C
+#define set_SYS_NAT_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR7_reg)=data)
+#define get_SYS_NAT_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR7_reg))
+#define SYS_NAT_SRAM_PWR7_inst_adr                                                   "0x000F"
+#define SYS_NAT_SRAM_PWR7_inst                                                       0x000F
+#define SYS_NAT_SRAM_PWR7_pg_switch_info_shift                                       (0)
+#define SYS_NAT_SRAM_PWR7_pg_switch_info_mask                                        (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR7_pg_switch_info(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR7_pg_switch_info_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR7_get_pg_switch_info(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DUMMY0                                                                   0x450
+#define SYS_DUMMY0_reg_addr                                                          "0x98000450"
+#define SYS_DUMMY0_reg                                                               0x98000450
+#define set_SYS_DUMMY0_reg(data)   (*((volatile unsigned int*) SYS_DUMMY0_reg)=data)
+#define get_SYS_DUMMY0_reg   (*((volatile unsigned int*) SYS_DUMMY0_reg))
+#define SYS_DUMMY0_inst_adr                                                          "0x0014"
+#define SYS_DUMMY0_inst                                                              0x0014
+#define SYS_DUMMY0_dmyreg0_rst0_shift                                                (0)
+#define SYS_DUMMY0_dmyreg0_rst0_mask                                                 (0xFFFFFFFF)
+#define SYS_DUMMY0_dmyreg0_rst0(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SYS_DUMMY0_dmyreg0_rst0_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SYS_DUMMY0_get_dmyreg0_rst0(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DUMMY1                                                                   0x454
+#define SYS_DUMMY1_reg_addr                                                          "0x98000454"
+#define SYS_DUMMY1_reg                                                               0x98000454
+#define set_SYS_DUMMY1_reg(data)   (*((volatile unsigned int*) SYS_DUMMY1_reg)=data)
+#define get_SYS_DUMMY1_reg   (*((volatile unsigned int*) SYS_DUMMY1_reg))
+#define SYS_DUMMY1_inst_adr                                                          "0x0015"
+#define SYS_DUMMY1_inst                                                              0x0015
+#define SYS_DUMMY1_dmyreg1_rst0_shift                                                (0)
+#define SYS_DUMMY1_dmyreg1_rst0_mask                                                 (0xFFFFFFFF)
+#define SYS_DUMMY1_dmyreg1_rst0(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SYS_DUMMY1_dmyreg1_rst0_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SYS_DUMMY1_get_dmyreg1_rst0(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DUMMY2                                                                   0x458
+#define SYS_DUMMY2_reg_addr                                                          "0x98000458"
+#define SYS_DUMMY2_reg                                                               0x98000458
+#define set_SYS_DUMMY2_reg(data)   (*((volatile unsigned int*) SYS_DUMMY2_reg)=data)
+#define get_SYS_DUMMY2_reg   (*((volatile unsigned int*) SYS_DUMMY2_reg))
+#define SYS_DUMMY2_inst_adr                                                          "0x0016"
+#define SYS_DUMMY2_inst                                                              0x0016
+#define SYS_DUMMY2_dmyreg2_rst1_shift                                                (0)
+#define SYS_DUMMY2_dmyreg2_rst1_mask                                                 (0xFFFFFFFF)
+#define SYS_DUMMY2_dmyreg2_rst1(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SYS_DUMMY2_dmyreg2_rst1_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SYS_DUMMY2_get_dmyreg2_rst1(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DUMMY3                                                                   0x45c
+#define SYS_DUMMY3_reg_addr                                                          "0x9800045C"
+#define SYS_DUMMY3_reg                                                               0x9800045C
+#define set_SYS_DUMMY3_reg(data)   (*((volatile unsigned int*) SYS_DUMMY3_reg)=data)
+#define get_SYS_DUMMY3_reg   (*((volatile unsigned int*) SYS_DUMMY3_reg))
+#define SYS_DUMMY3_inst_adr                                                          "0x0017"
+#define SYS_DUMMY3_inst                                                              0x0017
+#define SYS_DUMMY3_dmyreg3_rst1_shift                                                (0)
+#define SYS_DUMMY3_dmyreg3_rst1_mask                                                 (0xFFFFFFFF)
+#define SYS_DUMMY3_dmyreg3_rst1(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SYS_DUMMY3_dmyreg3_rst1_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SYS_DUMMY3_get_dmyreg3_rst1(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU0                                                        0x500
+#define SYS_PLL_SSC_DIG_SCPU0_reg_addr                                               "0x98000500"
+#define SYS_PLL_SSC_DIG_SCPU0_reg                                                    0x98000500
+#define set_SYS_PLL_SSC_DIG_SCPU0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU0_reg))
+#define SYS_PLL_SSC_DIG_SCPU0_inst_adr                                               "0x0040"
+#define SYS_PLL_SSC_DIG_SCPU0_inst                                                   0x0040
+#define SYS_PLL_SSC_DIG_SCPU0_REG_CKSSC_INV_SCPU_shift                               (4)
+#define SYS_PLL_SSC_DIG_SCPU0_REG_CKSSC_INV_SCPU_mask                                (0x00000010)
+#define SYS_PLL_SSC_DIG_SCPU0_REG_CKSSC_INV_SCPU(data)                               (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_SCPU0_REG_CKSSC_INV_SCPU_src(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_SCPU0_get_REG_CKSSC_INV_SCPU(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_SCPU0_REG_GRAN_AUTO_RST_SCPU_shift                           (3)
+#define SYS_PLL_SSC_DIG_SCPU0_REG_GRAN_AUTO_RST_SCPU_mask                            (0x00000008)
+#define SYS_PLL_SSC_DIG_SCPU0_REG_GRAN_AUTO_RST_SCPU(data)                           (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_SCPU0_REG_GRAN_AUTO_RST_SCPU_src(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_SCPU0_get_REG_GRAN_AUTO_RST_SCPU(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_SCPU0_RSTB_SCPU_shift                                        (2)
+#define SYS_PLL_SSC_DIG_SCPU0_RSTB_SCPU_mask                                         (0x00000004)
+#define SYS_PLL_SSC_DIG_SCPU0_RSTB_SCPU(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_SCPU0_RSTB_SCPU_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_SCPU0_get_RSTB_SCPU(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_SCPU0_EN_SSC_SCPU_shift                                      (1)
+#define SYS_PLL_SSC_DIG_SCPU0_EN_SSC_SCPU_mask                                       (0x00000002)
+#define SYS_PLL_SSC_DIG_SCPU0_EN_SSC_SCPU(data)                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_SCPU0_EN_SSC_SCPU_src(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_SCPU0_get_EN_SSC_SCPU(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_SCPU0_OC_EN_SCPU_shift                                       (0)
+#define SYS_PLL_SSC_DIG_SCPU0_OC_EN_SCPU_mask                                        (0x00000001)
+#define SYS_PLL_SSC_DIG_SCPU0_OC_EN_SCPU(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU0_OC_EN_SCPU_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU0_get_OC_EN_SCPU(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU1                                                        0x504
+#define SYS_PLL_SSC_DIG_SCPU1_reg_addr                                               "0x98000504"
+#define SYS_PLL_SSC_DIG_SCPU1_reg                                                    0x98000504
+#define set_SYS_PLL_SSC_DIG_SCPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU1_reg))
+#define SYS_PLL_SSC_DIG_SCPU1_inst_adr                                               "0x0041"
+#define SYS_PLL_SSC_DIG_SCPU1_inst                                                   0x0041
+#define SYS_PLL_SSC_DIG_SCPU1_NCODE_T_SCPU_shift                                     (11)
+#define SYS_PLL_SSC_DIG_SCPU1_NCODE_T_SCPU_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_SCPU1_NCODE_T_SCPU(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_SCPU1_NCODE_T_SCPU_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU1_get_NCODE_T_SCPU(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU1_FCODE_T_SCPU_shift                                     (0)
+#define SYS_PLL_SSC_DIG_SCPU1_FCODE_T_SCPU_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_SCPU1_FCODE_T_SCPU(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU1_FCODE_T_SCPU_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU1_get_FCODE_T_SCPU(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU2                                                        0x508
+#define SYS_PLL_SSC_DIG_SCPU2_reg_addr                                               "0x98000508"
+#define SYS_PLL_SSC_DIG_SCPU2_reg                                                    0x98000508
+#define set_SYS_PLL_SSC_DIG_SCPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU2_reg))
+#define SYS_PLL_SSC_DIG_SCPU2_inst_adr                                               "0x0042"
+#define SYS_PLL_SSC_DIG_SCPU2_inst                                                   0x0042
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_DIVN_shift                                  (27)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_DIVN_mask                                   (0x08000000)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_DIVN(data)                                  (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_DIVN_src(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_BYPASS_DIVN(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_STEP_SET_SCPU_shift                             (17)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_STEP_SET_SCPU_mask                              (0x07FE0000)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_STEP_SET_SCPU(data)                             (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_STEP_SET_SCPU_src(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_OC_STEP_SET_SCPU(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SEL_OC_MODE_SCPU_shift                             (15)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SEL_OC_MODE_SCPU_mask                              (0x00018000)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SEL_OC_MODE_SCPU(data)                             (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SEL_OC_MODE_SCPU_src(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_SEL_OC_MODE_SCPU(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_HS_OC_STOP_DIFF_SCPU_shift                         (13)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_HS_OC_STOP_DIFF_SCPU_mask                          (0x00006000)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_HS_OC_STOP_DIFF_SCPU(data)                         (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_HS_OC_STOP_DIFF_SCPU_src(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_HS_OC_STOP_DIFF_SCPU(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_DONE_DELAY_SCPU_shift                           (7)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_DONE_DELAY_SCPU_mask                            (0x00001F80)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_DONE_DELAY_SCPU(data)                           (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_DONE_DELAY_SCPU_src(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_OC_DONE_DELAY_SCPU(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_PI_CUR_SEL_SCPU_shift                              (5)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_PI_CUR_SEL_SCPU_mask                               (0x00000060)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_PI_CUR_SEL_SCPU(data)                              (0x00000060&((data)<<5))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_PI_CUR_SEL_SCPU_src(data)                          ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_PI_CUR_SEL_SCPU(data)                          ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_PI_SCPU_shift                               (4)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_PI_SCPU_mask                                (0x00000010)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_PI_SCPU(data)                               (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_PI_SCPU_src(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_BYPASS_PI_SCPU(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SDM_ORDER_SCPU_shift                               (3)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SDM_ORDER_SCPU_mask                                (0x00000008)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SDM_ORDER_SCPU(data)                               (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SDM_ORDER_SCPU_src(data)                           ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_SDM_ORDER_SCPU(data)                           ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_EN_PI_DEBUG_SCPU_shift                             (2)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_EN_PI_DEBUG_SCPU_mask                              (0x00000004)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_EN_PI_DEBUG_SCPU(data)                             (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_EN_PI_DEBUG_SCPU_src(data)                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_EN_PI_DEBUG_SCPU(data)                         ((0x00000004&(data))>>2)
+
+
+#define SYS_PLL_SSC_DIG_SCPU3                                                        0x50C
+#define SYS_PLL_SSC_DIG_SCPU3_reg_addr                                               "0x9800050C"
+#define SYS_PLL_SSC_DIG_SCPU3_reg                                                    0x9800050C
+#define set_SYS_PLL_SSC_DIG_SCPU3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU3_reg))
+#define SYS_PLL_SSC_DIG_SCPU3_inst_adr                                               "0x0043"
+#define SYS_PLL_SSC_DIG_SCPU3_inst                                                   0x0043
+#define SYS_PLL_SSC_DIG_SCPU3_NCODE_SSC_SCPU_shift                                   (11)
+#define SYS_PLL_SSC_DIG_SCPU3_NCODE_SSC_SCPU_mask                                    (0x0007F800)
+#define SYS_PLL_SSC_DIG_SCPU3_NCODE_SSC_SCPU(data)                                   (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_SCPU3_NCODE_SSC_SCPU_src(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU3_get_NCODE_SSC_SCPU(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU3_FCODE_SSC_SCPU_shift                                   (0)
+#define SYS_PLL_SSC_DIG_SCPU3_FCODE_SSC_SCPU_mask                                    (0x000007FF)
+#define SYS_PLL_SSC_DIG_SCPU3_FCODE_SSC_SCPU(data)                                   (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU3_FCODE_SSC_SCPU_src(data)                               ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU3_get_FCODE_SSC_SCPU(data)                               ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU4                                                        0x510
+#define SYS_PLL_SSC_DIG_SCPU4_reg_addr                                               "0x98000510"
+#define SYS_PLL_SSC_DIG_SCPU4_reg                                                    0x98000510
+#define set_SYS_PLL_SSC_DIG_SCPU4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU4_reg))
+#define SYS_PLL_SSC_DIG_SCPU4_inst_adr                                               "0x0044"
+#define SYS_PLL_SSC_DIG_SCPU4_inst                                                   0x0044
+#define SYS_PLL_SSC_DIG_SCPU4_GRAN_EST_SCPU_shift                                    (0)
+#define SYS_PLL_SSC_DIG_SCPU4_GRAN_EST_SCPU_mask                                     (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_SCPU4_GRAN_EST_SCPU(data)                                    (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU4_GRAN_EST_SCPU_src(data)                                ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU4_get_GRAN_EST_SCPU(data)                                ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU5                                                        0x514
+#define SYS_PLL_SSC_DIG_SCPU5_reg_addr                                               "0x98000514"
+#define SYS_PLL_SSC_DIG_SCPU5_reg                                                    0x98000514
+#define set_SYS_PLL_SSC_DIG_SCPU5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU5_reg))
+#define SYS_PLL_SSC_DIG_SCPU5_inst_adr                                               "0x0045"
+#define SYS_PLL_SSC_DIG_SCPU5_inst                                                   0x0045
+#define SYS_PLL_SSC_DIG_SCPU5_FCW_SSC_DEFAULT_SCPU_shift                             (0)
+#define SYS_PLL_SSC_DIG_SCPU5_FCW_SSC_DEFAULT_SCPU_mask                              (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_SCPU5_FCW_SSC_DEFAULT_SCPU(data)                             (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU5_FCW_SSC_DEFAULT_SCPU_src(data)                         ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU5_get_FCW_SSC_DEFAULT_SCPU(data)                         ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU_DBG1                                                    0x518
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_reg_addr                                           "0x98000518"
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_reg                                                0x98000518
+#define set_SYS_PLL_SSC_DIG_SCPU_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU_DBG1_reg))
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_inst_adr                                           "0x0046"
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_inst                                               0x0046
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_LOOP_PI_ISEL_SCPU_shift                            (13)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_LOOP_PI_ISEL_SCPU_mask                             (0x00006000)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_LOOP_PI_ISEL_SCPU(data)                            (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_LOOP_PI_ISEL_SCPU_src(data)                        ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_get_LOOP_PI_ISEL_SCPU(data)                        ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_PHSEL_SCPU_shift                                   (8)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_PHSEL_SCPU_mask                                    (0x00001F00)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_PHSEL_SCPU(data)                                   (0x00001F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_PHSEL_SCPU_src(data)                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_get_PHSEL_SCPU(data)                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_DIVN_SCPU_shift                                    (0)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_DIVN_SCPU_mask                                     (0x000000FF)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_DIVN_SCPU(data)                                    (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_DIVN_SCPU_src(data)                                ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_get_DIVN_SCPU(data)                                ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU_DBG2                                                    0x51C
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_reg_addr                                           "0x9800051C"
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_reg                                                0x9800051C
+#define set_SYS_PLL_SSC_DIG_SCPU_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU_DBG2_reg))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_inst_adr                                           "0x0047"
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_inst                                               0x0047
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_load_FCW_SCPU_shift                                (21)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_load_FCW_SCPU_mask                                 (0x00200000)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_load_FCW_SCPU(data)                                (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_load_FCW_SCPU_src(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_get_load_FCW_SCPU(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_OC_DONE_SCPU_shift                                 (20)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_OC_DONE_SCPU_mask                                  (0x00100000)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_OC_DONE_SCPU(data)                                 (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_OC_DONE_SCPU_src(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_get_OC_DONE_SCPU(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FMOD_SCPU_shift                                    (19)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FMOD_SCPU_mask                                     (0x00080000)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FMOD_SCPU(data)                                    (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FMOD_SCPU_src(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_get_FMOD_SCPU(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_NCODE_DEBUG_SCPU_shift                             (11)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_NCODE_DEBUG_SCPU_mask                              (0x0007F800)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_NCODE_DEBUG_SCPU(data)                             (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_NCODE_DEBUG_SCPU_src(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_get_NCODE_DEBUG_SCPU(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FCODE_DEBUG_SCPU_shift                             (0)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FCODE_DEBUG_SCPU_mask                              (0x000007FF)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FCODE_DEBUG_SCPU(data)                             (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FCODE_DEBUG_SCPU_src(data)                         ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_get_FCODE_DEBUG_SCPU(data)                         ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS0                                                         0x520
+#define SYS_PLL_SSC_DIG_BUS0_reg_addr                                                "0x98000520"
+#define SYS_PLL_SSC_DIG_BUS0_reg                                                     0x98000520
+#define set_SYS_PLL_SSC_DIG_BUS0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS0_reg))
+#define SYS_PLL_SSC_DIG_BUS0_inst_adr                                                "0x0048"
+#define SYS_PLL_SSC_DIG_BUS0_inst                                                    0x0048
+#define SYS_PLL_SSC_DIG_BUS0_REG_CKSSC_INV_BUS_shift                                 (4)
+#define SYS_PLL_SSC_DIG_BUS0_REG_CKSSC_INV_BUS_mask                                  (0x00000010)
+#define SYS_PLL_SSC_DIG_BUS0_REG_CKSSC_INV_BUS(data)                                 (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_BUS0_REG_CKSSC_INV_BUS_src(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_BUS0_get_REG_CKSSC_INV_BUS(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_BUS0_REG_GRAN_AUTO_RST_BUS_shift                             (3)
+#define SYS_PLL_SSC_DIG_BUS0_REG_GRAN_AUTO_RST_BUS_mask                              (0x00000008)
+#define SYS_PLL_SSC_DIG_BUS0_REG_GRAN_AUTO_RST_BUS(data)                             (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_BUS0_REG_GRAN_AUTO_RST_BUS_src(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_BUS0_get_REG_GRAN_AUTO_RST_BUS(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_BUS0_RSTB_BUS_shift                                          (2)
+#define SYS_PLL_SSC_DIG_BUS0_RSTB_BUS_mask                                           (0x00000004)
+#define SYS_PLL_SSC_DIG_BUS0_RSTB_BUS(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_BUS0_RSTB_BUS_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUS0_get_RSTB_BUS(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUS0_EN_SSC_BUS_shift                                        (1)
+#define SYS_PLL_SSC_DIG_BUS0_EN_SSC_BUS_mask                                         (0x00000002)
+#define SYS_PLL_SSC_DIG_BUS0_EN_SSC_BUS(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_BUS0_EN_SSC_BUS_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUS0_get_EN_SSC_BUS(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUS0_OC_EN_BUS_shift                                         (0)
+#define SYS_PLL_SSC_DIG_BUS0_OC_EN_BUS_mask                                          (0x00000001)
+#define SYS_PLL_SSC_DIG_BUS0_OC_EN_BUS(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS0_OC_EN_BUS_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS0_get_OC_EN_BUS(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS1                                                         0x524
+#define SYS_PLL_SSC_DIG_BUS1_reg_addr                                                "0x98000524"
+#define SYS_PLL_SSC_DIG_BUS1_reg                                                     0x98000524
+#define set_SYS_PLL_SSC_DIG_BUS1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS1_reg))
+#define SYS_PLL_SSC_DIG_BUS1_inst_adr                                                "0x0049"
+#define SYS_PLL_SSC_DIG_BUS1_inst                                                    0x0049
+#define SYS_PLL_SSC_DIG_BUS1_NCODE_T_BUS_shift                                       (11)
+#define SYS_PLL_SSC_DIG_BUS1_NCODE_T_BUS_mask                                        (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUS1_NCODE_T_BUS(data)                                       (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUS1_NCODE_T_BUS_src(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS1_get_NCODE_T_BUS(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS1_FCODE_T_BUS_shift                                       (0)
+#define SYS_PLL_SSC_DIG_BUS1_FCODE_T_BUS_mask                                        (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUS1_FCODE_T_BUS(data)                                       (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS1_FCODE_T_BUS_src(data)                                   ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS1_get_FCODE_T_BUS(data)                                   ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS2                                                         0x528
+#define SYS_PLL_SSC_DIG_BUS2_reg_addr                                                "0x98000528"
+#define SYS_PLL_SSC_DIG_BUS2_reg                                                     0x98000528
+#define set_SYS_PLL_SSC_DIG_BUS2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS2_reg))
+#define SYS_PLL_SSC_DIG_BUS2_inst_adr                                                "0x004A"
+#define SYS_PLL_SSC_DIG_BUS2_inst                                                    0x004A
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_DIVN_shift                                   (27)
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_DIVN_mask                                    (0x08000000)
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_DIVN(data)                                   (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_DIVN_src(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_BYPASS_DIVN(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_STEP_SET_BUS_shift                               (17)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_STEP_SET_BUS_mask                                (0x07FE0000)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_STEP_SET_BUS(data)                               (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_STEP_SET_BUS_src(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_OC_STEP_SET_BUS(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SEL_OC_MODE_BUS_shift                               (15)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SEL_OC_MODE_BUS_mask                                (0x00018000)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SEL_OC_MODE_BUS(data)                               (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_BUS2_REG_SEL_OC_MODE_BUS_src(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_SEL_OC_MODE_BUS(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_BUS2_REG_HS_OC_STOP_DIFF_BUS_shift                           (13)
+#define SYS_PLL_SSC_DIG_BUS2_REG_HS_OC_STOP_DIFF_BUS_mask                            (0x00006000)
+#define SYS_PLL_SSC_DIG_BUS2_REG_HS_OC_STOP_DIFF_BUS(data)                           (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_BUS2_REG_HS_OC_STOP_DIFF_BUS_src(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_HS_OC_STOP_DIFF_BUS(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_DONE_DELAY_BUS_shift                             (7)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_DONE_DELAY_BUS_mask                              (0x00001F80)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_DONE_DELAY_BUS(data)                             (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_DONE_DELAY_BUS_src(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_OC_DONE_DELAY_BUS(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_PI_BUS_shift                                 (6)
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_PI_BUS_mask                                  (0x00000040)
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_PI_BUS(data)                                 (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_PI_BUS_src(data)                             ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_BYPASS_PI_BUS(data)                             ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SDM_ORDER_BUS_shift                                 (5)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SDM_ORDER_BUS_mask                                  (0x00000020)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SDM_ORDER_BUS(data)                                 (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_BUS2_REG_SDM_ORDER_BUS_src(data)                             ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_SDM_ORDER_BUS(data)                             ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_BUS2_REG_PI_CUR_SEL_BUS_shift                                (2)
+#define SYS_PLL_SSC_DIG_BUS2_REG_PI_CUR_SEL_BUS_mask                                 (0x0000001C)
+#define SYS_PLL_SSC_DIG_BUS2_REG_PI_CUR_SEL_BUS(data)                                (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_BUS2_REG_PI_CUR_SEL_BUS_src(data)                            ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_PI_CUR_SEL_BUS(data)                            ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUS2_REG_EN_PI_DEBUG_BUS_shift                               (1)
+#define SYS_PLL_SSC_DIG_BUS2_REG_EN_PI_DEBUG_BUS_mask                                (0x00000002)
+#define SYS_PLL_SSC_DIG_BUS2_REG_EN_PI_DEBUG_BUS(data)                               (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_BUS2_REG_EN_PI_DEBUG_BUS_src(data)                           ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_EN_PI_DEBUG_BUS(data)                           ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_BUS3                                                         0x52C
+#define SYS_PLL_SSC_DIG_BUS3_reg_addr                                                "0x9800052C"
+#define SYS_PLL_SSC_DIG_BUS3_reg                                                     0x9800052C
+#define set_SYS_PLL_SSC_DIG_BUS3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS3_reg))
+#define SYS_PLL_SSC_DIG_BUS3_inst_adr                                                "0x004B"
+#define SYS_PLL_SSC_DIG_BUS3_inst                                                    0x004B
+#define SYS_PLL_SSC_DIG_BUS3_NCODE_SSC_BUS_shift                                     (11)
+#define SYS_PLL_SSC_DIG_BUS3_NCODE_SSC_BUS_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUS3_NCODE_SSC_BUS(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUS3_NCODE_SSC_BUS_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS3_get_NCODE_SSC_BUS(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS3_FCODE_SSC_BUS_shift                                     (0)
+#define SYS_PLL_SSC_DIG_BUS3_FCODE_SSC_BUS_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUS3_FCODE_SSC_BUS(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS3_FCODE_SSC_BUS_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS3_get_FCODE_SSC_BUS(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS4                                                         0x530
+#define SYS_PLL_SSC_DIG_BUS4_reg_addr                                                "0x98000530"
+#define SYS_PLL_SSC_DIG_BUS4_reg                                                     0x98000530
+#define set_SYS_PLL_SSC_DIG_BUS4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS4_reg))
+#define SYS_PLL_SSC_DIG_BUS4_inst_adr                                                "0x004C"
+#define SYS_PLL_SSC_DIG_BUS4_inst                                                    0x004C
+#define SYS_PLL_SSC_DIG_BUS4_GRAN_EST_BUS_shift                                      (0)
+#define SYS_PLL_SSC_DIG_BUS4_GRAN_EST_BUS_mask                                       (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_BUS4_GRAN_EST_BUS(data)                                      (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS4_GRAN_EST_BUS_src(data)                                  ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS4_get_GRAN_EST_BUS(data)                                  ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS5                                                         0x534
+#define SYS_PLL_SSC_DIG_BUS5_reg_addr                                                "0x98000534"
+#define SYS_PLL_SSC_DIG_BUS5_reg                                                     0x98000534
+#define set_SYS_PLL_SSC_DIG_BUS5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS5_reg))
+#define SYS_PLL_SSC_DIG_BUS5_inst_adr                                                "0x004D"
+#define SYS_PLL_SSC_DIG_BUS5_inst                                                    0x004D
+#define SYS_PLL_SSC_DIG_BUS5_FCW_SSC_DEFAULT_BUS_shift                               (0)
+#define SYS_PLL_SSC_DIG_BUS5_FCW_SSC_DEFAULT_BUS_mask                                (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_BUS5_FCW_SSC_DEFAULT_BUS(data)                               (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS5_FCW_SSC_DEFAULT_BUS_src(data)                           ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS5_get_FCW_SSC_DEFAULT_BUS(data)                           ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS_DBG1                                                     0x538
+#define SYS_PLL_SSC_DIG_BUS_DBG1_reg_addr                                            "0x98000538"
+#define SYS_PLL_SSC_DIG_BUS_DBG1_reg                                                 0x98000538
+#define set_SYS_PLL_SSC_DIG_BUS_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS_DBG1_reg))
+#define SYS_PLL_SSC_DIG_BUS_DBG1_inst_adr                                            "0x004E"
+#define SYS_PLL_SSC_DIG_BUS_DBG1_inst                                                0x004E
+#define SYS_PLL_SSC_DIG_BUS_DBG1_LOOP_PI_ISEL_BUS_shift                              (13)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_LOOP_PI_ISEL_BUS_mask                               (0x0000E000)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_LOOP_PI_ISEL_BUS(data)                              (0x0000E000&((data)<<13))
+#define SYS_PLL_SSC_DIG_BUS_DBG1_LOOP_PI_ISEL_BUS_src(data)                          ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_get_LOOP_PI_ISEL_BUS(data)                          ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_PHSEL_BUS_shift                                     (8)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_PHSEL_BUS_mask                                      (0x00001F00)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_PHSEL_BUS(data)                                     (0x00001F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_BUS_DBG1_PHSEL_BUS_src(data)                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_get_PHSEL_BUS(data)                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_DIVN_BUS_shift                                      (0)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_DIVN_BUS_mask                                       (0x000000FF)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_DIVN_BUS(data)                                      (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS_DBG1_DIVN_BUS_src(data)                                  ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_get_DIVN_BUS(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS_DBG2                                                     0x53C
+#define SYS_PLL_SSC_DIG_BUS_DBG2_reg_addr                                            "0x9800053C"
+#define SYS_PLL_SSC_DIG_BUS_DBG2_reg                                                 0x9800053C
+#define set_SYS_PLL_SSC_DIG_BUS_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS_DBG2_reg))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_inst_adr                                            "0x004F"
+#define SYS_PLL_SSC_DIG_BUS_DBG2_inst                                                0x004F
+#define SYS_PLL_SSC_DIG_BUS_DBG2_load_FCW_BUS_shift                                  (21)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_load_FCW_BUS_mask                                   (0x00200000)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_load_FCW_BUS(data)                                  (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_load_FCW_BUS_src(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_get_load_FCW_BUS(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_OC_DONE_BUS_shift                                   (20)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_OC_DONE_BUS_mask                                    (0x00100000)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_OC_DONE_BUS(data)                                   (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_OC_DONE_BUS_src(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_get_OC_DONE_BUS(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FMOD_BUS_shift                                      (19)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FMOD_BUS_mask                                       (0x00080000)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FMOD_BUS(data)                                      (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FMOD_BUS_src(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_get_FMOD_BUS(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_NCODE_DEBUG_BUS_shift                               (11)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_NCODE_DEBUG_BUS_mask                                (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_NCODE_DEBUG_BUS(data)                               (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_NCODE_DEBUG_BUS_src(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_get_NCODE_DEBUG_BUS(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FCODE_DEBUG_BUS_shift                               (0)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FCODE_DEBUG_BUS_mask                                (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FCODE_DEBUG_BUS(data)                               (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FCODE_DEBUG_BUS_src(data)                           ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_get_FCODE_DEBUG_BUS(data)                           ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH0                                                        0x540
+#define SYS_PLL_SSC_DIG_BUSH0_reg_addr                                               "0x98000540"
+#define SYS_PLL_SSC_DIG_BUSH0_reg                                                    0x98000540
+#define set_SYS_PLL_SSC_DIG_BUSH0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH0_reg))
+#define SYS_PLL_SSC_DIG_BUSH0_inst_adr                                               "0x0050"
+#define SYS_PLL_SSC_DIG_BUSH0_inst                                                   0x0050
+#define SYS_PLL_SSC_DIG_BUSH0_REG_CKSSC_INV_BUS_H_shift                              (4)
+#define SYS_PLL_SSC_DIG_BUSH0_REG_CKSSC_INV_BUS_H_mask                               (0x00000010)
+#define SYS_PLL_SSC_DIG_BUSH0_REG_CKSSC_INV_BUS_H(data)                              (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_BUSH0_REG_CKSSC_INV_BUS_H_src(data)                          ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_BUSH0_get_REG_CKSSC_INV_BUS_H(data)                          ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_BUSH0_REG_GRAN_AUTO_RST_BUS_H_shift                          (3)
+#define SYS_PLL_SSC_DIG_BUSH0_REG_GRAN_AUTO_RST_BUS_H_mask                           (0x00000008)
+#define SYS_PLL_SSC_DIG_BUSH0_REG_GRAN_AUTO_RST_BUS_H(data)                          (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_BUSH0_REG_GRAN_AUTO_RST_BUS_H_src(data)                      ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_BUSH0_get_REG_GRAN_AUTO_RST_BUS_H(data)                      ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_BUSH0_RSTB_BUS_H_shift                                       (2)
+#define SYS_PLL_SSC_DIG_BUSH0_RSTB_BUS_H_mask                                        (0x00000004)
+#define SYS_PLL_SSC_DIG_BUSH0_RSTB_BUS_H(data)                                       (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_BUSH0_RSTB_BUS_H_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUSH0_get_RSTB_BUS_H(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUSH0_EN_SSC_BUS_H_shift                                     (1)
+#define SYS_PLL_SSC_DIG_BUSH0_EN_SSC_BUS_H_mask                                      (0x00000002)
+#define SYS_PLL_SSC_DIG_BUSH0_EN_SSC_BUS_H(data)                                     (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_BUSH0_EN_SSC_BUS_H_src(data)                                 ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUSH0_get_EN_SSC_BUS_H(data)                                 ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUSH0_OC_EN_BUS_H_shift                                      (0)
+#define SYS_PLL_SSC_DIG_BUSH0_OC_EN_BUS_H_mask                                       (0x00000001)
+#define SYS_PLL_SSC_DIG_BUSH0_OC_EN_BUS_H(data)                                      (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH0_OC_EN_BUS_H_src(data)                                  ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH0_get_OC_EN_BUS_H(data)                                  ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH1                                                        0x544
+#define SYS_PLL_SSC_DIG_BUSH1_reg_addr                                               "0x98000544"
+#define SYS_PLL_SSC_DIG_BUSH1_reg                                                    0x98000544
+#define set_SYS_PLL_SSC_DIG_BUSH1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH1_reg))
+#define SYS_PLL_SSC_DIG_BUSH1_inst_adr                                               "0x0051"
+#define SYS_PLL_SSC_DIG_BUSH1_inst                                                   0x0051
+#define SYS_PLL_SSC_DIG_BUSH1_NCODE_T_BUS_H_shift                                    (11)
+#define SYS_PLL_SSC_DIG_BUSH1_NCODE_T_BUS_H_mask                                     (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUSH1_NCODE_T_BUS_H(data)                                    (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUSH1_NCODE_T_BUS_H_src(data)                                ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH1_get_NCODE_T_BUS_H(data)                                ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH1_FCODE_T_BUS_H_shift                                    (0)
+#define SYS_PLL_SSC_DIG_BUSH1_FCODE_T_BUS_H_mask                                     (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUSH1_FCODE_T_BUS_H(data)                                    (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH1_FCODE_T_BUS_H_src(data)                                ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH1_get_FCODE_T_BUS_H(data)                                ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH2                                                        0x548
+#define SYS_PLL_SSC_DIG_BUSH2_reg_addr                                               "0x98000548"
+#define SYS_PLL_SSC_DIG_BUSH2_reg                                                    0x98000548
+#define set_SYS_PLL_SSC_DIG_BUSH2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH2_reg))
+#define SYS_PLL_SSC_DIG_BUSH2_inst_adr                                               "0x0052"
+#define SYS_PLL_SSC_DIG_BUSH2_inst                                                   0x0052
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_DIVN_shift                                  (27)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_DIVN_mask                                   (0x08000000)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_DIVN(data)                                  (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_DIVN_src(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_BYPASS_DIVN(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_STEP_SET_BUS_H_shift                            (17)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_STEP_SET_BUS_H_mask                             (0x07FE0000)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_STEP_SET_BUS_H(data)                            (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_STEP_SET_BUS_H_src(data)                        ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_OC_STEP_SET_BUS_H(data)                        ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SEL_OC_MODE_BUS_H_shift                            (15)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SEL_OC_MODE_BUS_H_mask                             (0x00018000)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SEL_OC_MODE_BUS_H(data)                            (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SEL_OC_MODE_BUS_H_src(data)                        ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_SEL_OC_MODE_BUS_H(data)                        ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_HS_OC_STOP_DIFF_BUS_H_shift                        (13)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_HS_OC_STOP_DIFF_BUS_H_mask                         (0x00006000)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_HS_OC_STOP_DIFF_BUS_H(data)                        (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_HS_OC_STOP_DIFF_BUS_H_src(data)                    ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_HS_OC_STOP_DIFF_BUS_H(data)                    ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_DONE_DELAY_BUS_H_shift                          (7)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_DONE_DELAY_BUS_H_mask                           (0x00001F80)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_DONE_DELAY_BUS_H(data)                          (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_DONE_DELAY_BUS_H_src(data)                      ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_OC_DONE_DELAY_BUS_H(data)                      ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_PI_BUS_H_shift                              (6)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_PI_BUS_H_mask                               (0x00000040)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_PI_BUS_H(data)                              (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_PI_BUS_H_src(data)                          ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_BYPASS_PI_BUS_H(data)                          ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SDM_ORDER_BUS_H_shift                              (5)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SDM_ORDER_BUS_H_mask                               (0x00000020)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SDM_ORDER_BUS_H(data)                              (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SDM_ORDER_BUS_H_src(data)                          ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_SDM_ORDER_BUS_H(data)                          ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_PI_CUR_SEL_BUS_H_shift                             (2)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_PI_CUR_SEL_BUS_H_mask                              (0x0000001C)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_PI_CUR_SEL_BUS_H(data)                             (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_PI_CUR_SEL_BUS_H_src(data)                         ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_PI_CUR_SEL_BUS_H(data)                         ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_EN_PI_DEBUG_BUS_H_shift                            (1)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_EN_PI_DEBUG_BUS_H_mask                             (0x00000002)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_EN_PI_DEBUG_BUS_H(data)                            (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_EN_PI_DEBUG_BUS_H_src(data)                        ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_EN_PI_DEBUG_BUS_H(data)                        ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_BUSH3                                                        0x54C
+#define SYS_PLL_SSC_DIG_BUSH3_reg_addr                                               "0x9800054C"
+#define SYS_PLL_SSC_DIG_BUSH3_reg                                                    0x9800054C
+#define set_SYS_PLL_SSC_DIG_BUSH3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH3_reg))
+#define SYS_PLL_SSC_DIG_BUSH3_inst_adr                                               "0x0053"
+#define SYS_PLL_SSC_DIG_BUSH3_inst                                                   0x0053
+#define SYS_PLL_SSC_DIG_BUSH3_NCODE_SSC_BUS_H_shift                                  (11)
+#define SYS_PLL_SSC_DIG_BUSH3_NCODE_SSC_BUS_H_mask                                   (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUSH3_NCODE_SSC_BUS_H(data)                                  (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUSH3_NCODE_SSC_BUS_H_src(data)                              ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH3_get_NCODE_SSC_BUS_H(data)                              ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH3_FCODE_SSC_BUS_H_shift                                  (0)
+#define SYS_PLL_SSC_DIG_BUSH3_FCODE_SSC_BUS_H_mask                                   (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUSH3_FCODE_SSC_BUS_H(data)                                  (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH3_FCODE_SSC_BUS_H_src(data)                              ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH3_get_FCODE_SSC_BUS_H(data)                              ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH4                                                        0x550
+#define SYS_PLL_SSC_DIG_BUSH4_reg_addr                                               "0x98000550"
+#define SYS_PLL_SSC_DIG_BUSH4_reg                                                    0x98000550
+#define set_SYS_PLL_SSC_DIG_BUSH4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH4_reg))
+#define SYS_PLL_SSC_DIG_BUSH4_inst_adr                                               "0x0054"
+#define SYS_PLL_SSC_DIG_BUSH4_inst                                                   0x0054
+#define SYS_PLL_SSC_DIG_BUSH4_GRAN_EST_BUS_H_shift                                   (0)
+#define SYS_PLL_SSC_DIG_BUSH4_GRAN_EST_BUS_H_mask                                    (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_BUSH4_GRAN_EST_BUS_H(data)                                   (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH4_GRAN_EST_BUS_H_src(data)                               ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH4_get_GRAN_EST_BUS_H(data)                               ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH5                                                        0x554
+#define SYS_PLL_SSC_DIG_BUSH5_reg_addr                                               "0x98000554"
+#define SYS_PLL_SSC_DIG_BUSH5_reg                                                    0x98000554
+#define set_SYS_PLL_SSC_DIG_BUSH5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH5_reg))
+#define SYS_PLL_SSC_DIG_BUSH5_inst_adr                                               "0x0055"
+#define SYS_PLL_SSC_DIG_BUSH5_inst                                                   0x0055
+#define SYS_PLL_SSC_DIG_BUSH5_FCW_SSC_DEFAULT_BUS_H_shift                            (0)
+#define SYS_PLL_SSC_DIG_BUSH5_FCW_SSC_DEFAULT_BUS_H_mask                             (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_BUSH5_FCW_SSC_DEFAULT_BUS_H(data)                            (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH5_FCW_SSC_DEFAULT_BUS_H_src(data)                        ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH5_get_FCW_SSC_DEFAULT_BUS_H(data)                        ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH_DBG1                                                    0x558
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_reg_addr                                           "0x98000558"
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_reg                                                0x98000558
+#define set_SYS_PLL_SSC_DIG_BUSH_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH_DBG1_reg))
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_inst_adr                                           "0x0056"
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_inst                                               0x0056
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_LOOP_PI_ISEL_BUS_H_shift                           (13)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_LOOP_PI_ISEL_BUS_H_mask                            (0x0000E000)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_LOOP_PI_ISEL_BUS_H(data)                           (0x0000E000&((data)<<13))
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_LOOP_PI_ISEL_BUS_H_src(data)                       ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_get_LOOP_PI_ISEL_BUS_H(data)                       ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_PHSEL_BUS_H_shift                                  (8)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_PHSEL_BUS_H_mask                                   (0x00001F00)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_PHSEL_BUS_H(data)                                  (0x00001F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_PHSEL_BUS_H_src(data)                              ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_get_PHSEL_BUS_H(data)                              ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_DIVN_BUS_H_shift                                   (0)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_DIVN_BUS_H_mask                                    (0x000000FF)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_DIVN_BUS_H(data)                                   (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_DIVN_BUS_H_src(data)                               ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_get_DIVN_BUS_H(data)                               ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH_DBG2                                                    0x55C
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_reg_addr                                           "0x9800055C"
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_reg                                                0x9800055C
+#define set_SYS_PLL_SSC_DIG_BUSH_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH_DBG2_reg))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_inst_adr                                           "0x0057"
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_inst                                               0x0057
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_load_FCW_BUS_H_shift                               (21)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_load_FCW_BUS_H_mask                                (0x00200000)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_load_FCW_BUS_H(data)                               (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_load_FCW_BUS_H_src(data)                           ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_get_load_FCW_BUS_H(data)                           ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_OC_DONE_BUS_H_shift                                (20)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_OC_DONE_BUS_H_mask                                 (0x00100000)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_OC_DONE_BUS_H(data)                                (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_OC_DONE_BUS_H_src(data)                            ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_get_OC_DONE_BUS_H(data)                            ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FMOD_BUS_H_shift                                   (19)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FMOD_BUS_H_mask                                    (0x00080000)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FMOD_BUS_H(data)                                   (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FMOD_BUS_H_src(data)                               ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_get_FMOD_BUS_H(data)                               ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_NCODE_DEBUG_BUS_H_shift                            (11)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_NCODE_DEBUG_BUS_H_mask                             (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_NCODE_DEBUG_BUS_H(data)                            (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_NCODE_DEBUG_BUS_H_src(data)                        ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_get_NCODE_DEBUG_BUS_H(data)                        ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FCODE_DEBUG_BUS_H_shift                            (0)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FCODE_DEBUG_BUS_H_mask                             (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FCODE_DEBUG_BUS_H(data)                            (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FCODE_DEBUG_BUS_H_src(data)                        ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_get_FCODE_DEBUG_BUS_H(data)                        ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA0                                                        0x560
+#define SYS_PLL_SSC_DIG_DDSA0_reg_addr                                               "0x98000560"
+#define SYS_PLL_SSC_DIG_DDSA0_reg                                                    0x98000560
+#define set_SYS_PLL_SSC_DIG_DDSA0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA0_reg))
+#define SYS_PLL_SSC_DIG_DDSA0_inst_adr                                               "0x0058"
+#define SYS_PLL_SSC_DIG_DDSA0_inst                                                   0x0058
+#define SYS_PLL_SSC_DIG_DDSA0_REG_CKSSC_INV_DDSA_shift                               (4)
+#define SYS_PLL_SSC_DIG_DDSA0_REG_CKSSC_INV_DDSA_mask                                (0x00000010)
+#define SYS_PLL_SSC_DIG_DDSA0_REG_CKSSC_INV_DDSA(data)                               (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_DDSA0_REG_CKSSC_INV_DDSA_src(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_DDSA0_get_REG_CKSSC_INV_DDSA(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_DDSA0_REG_GRAN_AUTO_RST_DDSA_shift                           (3)
+#define SYS_PLL_SSC_DIG_DDSA0_REG_GRAN_AUTO_RST_DDSA_mask                            (0x00000008)
+#define SYS_PLL_SSC_DIG_DDSA0_REG_GRAN_AUTO_RST_DDSA(data)                           (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_DDSA0_REG_GRAN_AUTO_RST_DDSA_src(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_DDSA0_get_REG_GRAN_AUTO_RST_DDSA(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_DDSA0_RSTB_DDSA_shift                                        (2)
+#define SYS_PLL_SSC_DIG_DDSA0_RSTB_DDSA_mask                                         (0x00000004)
+#define SYS_PLL_SSC_DIG_DDSA0_RSTB_DDSA(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_DDSA0_RSTB_DDSA_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSA0_get_RSTB_DDSA(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSA0_EN_SSC_DDSA_shift                                      (1)
+#define SYS_PLL_SSC_DIG_DDSA0_EN_SSC_DDSA_mask                                       (0x00000002)
+#define SYS_PLL_SSC_DIG_DDSA0_EN_SSC_DDSA(data)                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_DDSA0_EN_SSC_DDSA_src(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSA0_get_EN_SSC_DDSA(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSA0_OC_EN_DDSA_shift                                       (0)
+#define SYS_PLL_SSC_DIG_DDSA0_OC_EN_DDSA_mask                                        (0x00000001)
+#define SYS_PLL_SSC_DIG_DDSA0_OC_EN_DDSA(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA0_OC_EN_DDSA_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA0_get_OC_EN_DDSA(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA1                                                        0x564
+#define SYS_PLL_SSC_DIG_DDSA1_reg_addr                                               "0x98000564"
+#define SYS_PLL_SSC_DIG_DDSA1_reg                                                    0x98000564
+#define set_SYS_PLL_SSC_DIG_DDSA1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA1_reg))
+#define SYS_PLL_SSC_DIG_DDSA1_inst_adr                                               "0x0059"
+#define SYS_PLL_SSC_DIG_DDSA1_inst                                                   0x0059
+#define SYS_PLL_SSC_DIG_DDSA1_REG_PLLDDSA_ICO_PDIV2_shift                            (19)
+#define SYS_PLL_SSC_DIG_DDSA1_REG_PLLDDSA_ICO_PDIV2_mask                             (0x00380000)
+#define SYS_PLL_SSC_DIG_DDSA1_REG_PLLDDSA_ICO_PDIV2(data)                            (0x00380000&((data)<<19))
+#define SYS_PLL_SSC_DIG_DDSA1_REG_PLLDDSA_ICO_PDIV2_src(data)                        ((0x00380000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSA1_get_REG_PLLDDSA_ICO_PDIV2(data)                        ((0x00380000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSA1_NCODE_T_DDSA_shift                                     (11)
+#define SYS_PLL_SSC_DIG_DDSA1_NCODE_T_DDSA_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSA1_NCODE_T_DDSA(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSA1_NCODE_T_DDSA_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA1_get_NCODE_T_DDSA(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA1_FCODE_T_DDSA_shift                                     (0)
+#define SYS_PLL_SSC_DIG_DDSA1_FCODE_T_DDSA_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSA1_FCODE_T_DDSA(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA1_FCODE_T_DDSA_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA1_get_FCODE_T_DDSA(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA2                                                        0x568
+#define SYS_PLL_SSC_DIG_DDSA2_reg_addr                                               "0x98000568"
+#define SYS_PLL_SSC_DIG_DDSA2_reg                                                    0x98000568
+#define set_SYS_PLL_SSC_DIG_DDSA2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA2_reg))
+#define SYS_PLL_SSC_DIG_DDSA2_inst_adr                                               "0x005A"
+#define SYS_PLL_SSC_DIG_DDSA2_inst                                                   0x005A
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_DIVN_shift                                  (27)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_DIVN_mask                                   (0x08000000)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_DIVN(data)                                  (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_DIVN_src(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_BYPASS_DIVN(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_STEP_SET_DDSA_shift                             (17)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_STEP_SET_DDSA_mask                              (0x07FE0000)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_STEP_SET_DDSA(data)                             (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_STEP_SET_DDSA_src(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_OC_STEP_SET_DDSA(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SEL_OC_MODE_DDSA_shift                             (15)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SEL_OC_MODE_DDSA_mask                              (0x00018000)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SEL_OC_MODE_DDSA(data)                             (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SEL_OC_MODE_DDSA_src(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_SEL_OC_MODE_DDSA(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_HS_OC_STOP_DIFF_DDSA_shift                         (13)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_HS_OC_STOP_DIFF_DDSA_mask                          (0x00006000)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_HS_OC_STOP_DIFF_DDSA(data)                         (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_HS_OC_STOP_DIFF_DDSA_src(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_HS_OC_STOP_DIFF_DDSA(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_DONE_DELAY_DDSA_shift                           (7)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_DONE_DELAY_DDSA_mask                            (0x00001F80)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_DONE_DELAY_DDSA(data)                           (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_DONE_DELAY_DDSA_src(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_OC_DONE_DELAY_DDSA(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_PI_DDSA_shift                               (6)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_PI_DDSA_mask                                (0x00000040)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_PI_DDSA(data)                               (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_PI_DDSA_src(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_BYPASS_PI_DDSA(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SDM_ORDER_DDSA_shift                               (5)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SDM_ORDER_DDSA_mask                                (0x00000020)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SDM_ORDER_DDSA(data)                               (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SDM_ORDER_DDSA_src(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_SDM_ORDER_DDSA(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_PI_CUR_SEL_DDSA_shift                              (2)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_PI_CUR_SEL_DDSA_mask                               (0x0000001C)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_PI_CUR_SEL_DDSA(data)                              (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_PI_CUR_SEL_DDSA_src(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_PI_CUR_SEL_DDSA(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_EN_PI_DEBUG_DDSA_shift                             (1)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_EN_PI_DEBUG_DDSA_mask                              (0x00000002)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_EN_PI_DEBUG_DDSA(data)                             (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_EN_PI_DEBUG_DDSA_src(data)                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_EN_PI_DEBUG_DDSA(data)                         ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_DDSA3                                                        0x56C
+#define SYS_PLL_SSC_DIG_DDSA3_reg_addr                                               "0x9800056C"
+#define SYS_PLL_SSC_DIG_DDSA3_reg                                                    0x9800056C
+#define set_SYS_PLL_SSC_DIG_DDSA3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA3_reg))
+#define SYS_PLL_SSC_DIG_DDSA3_inst_adr                                               "0x005B"
+#define SYS_PLL_SSC_DIG_DDSA3_inst                                                   0x005B
+#define SYS_PLL_SSC_DIG_DDSA3_NCODE_SSC_DDSA_shift                                   (11)
+#define SYS_PLL_SSC_DIG_DDSA3_NCODE_SSC_DDSA_mask                                    (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSA3_NCODE_SSC_DDSA(data)                                   (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSA3_NCODE_SSC_DDSA_src(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA3_get_NCODE_SSC_DDSA(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA3_FCODE_SSC_DDSA_shift                                   (0)
+#define SYS_PLL_SSC_DIG_DDSA3_FCODE_SSC_DDSA_mask                                    (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSA3_FCODE_SSC_DDSA(data)                                   (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA3_FCODE_SSC_DDSA_src(data)                               ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA3_get_FCODE_SSC_DDSA(data)                               ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA4                                                        0x570
+#define SYS_PLL_SSC_DIG_DDSA4_reg_addr                                               "0x98000570"
+#define SYS_PLL_SSC_DIG_DDSA4_reg                                                    0x98000570
+#define set_SYS_PLL_SSC_DIG_DDSA4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA4_reg))
+#define SYS_PLL_SSC_DIG_DDSA4_inst_adr                                               "0x005C"
+#define SYS_PLL_SSC_DIG_DDSA4_inst                                                   0x005C
+#define SYS_PLL_SSC_DIG_DDSA4_GRAN_EST_DDSA_shift                                    (0)
+#define SYS_PLL_SSC_DIG_DDSA4_GRAN_EST_DDSA_mask                                     (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_DDSA4_GRAN_EST_DDSA(data)                                    (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA4_GRAN_EST_DDSA_src(data)                                ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA4_get_GRAN_EST_DDSA(data)                                ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA5                                                        0x574
+#define SYS_PLL_SSC_DIG_DDSA5_reg_addr                                               "0x98000574"
+#define SYS_PLL_SSC_DIG_DDSA5_reg                                                    0x98000574
+#define set_SYS_PLL_SSC_DIG_DDSA5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA5_reg))
+#define SYS_PLL_SSC_DIG_DDSA5_inst_adr                                               "0x005D"
+#define SYS_PLL_SSC_DIG_DDSA5_inst                                                   0x005D
+#define SYS_PLL_SSC_DIG_DDSA5_FCW_SSC_DEFAULT_DDSA_shift                             (0)
+#define SYS_PLL_SSC_DIG_DDSA5_FCW_SSC_DEFAULT_DDSA_mask                              (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_DDSA5_FCW_SSC_DEFAULT_DDSA(data)                             (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA5_FCW_SSC_DEFAULT_DDSA_src(data)                         ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA5_get_FCW_SSC_DEFAULT_DDSA(data)                         ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA_DBG1                                                    0x578
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_reg_addr                                           "0x98000578"
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_reg                                                0x98000578
+#define set_SYS_PLL_SSC_DIG_DDSA_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA_DBG1_reg))
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_inst_adr                                           "0x005E"
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_inst                                               0x005E
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_LOOP_PI_ISEL_DDSA_shift                            (14)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_LOOP_PI_ISEL_DDSA_mask                             (0x0001C000)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_LOOP_PI_ISEL_DDSA(data)                            (0x0001C000&((data)<<14))
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_LOOP_PI_ISEL_DDSA_src(data)                        ((0x0001C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_get_LOOP_PI_ISEL_DDSA(data)                        ((0x0001C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_PHSEL_DDSA_shift                                   (8)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_PHSEL_DDSA_mask                                    (0x00003F00)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_PHSEL_DDSA(data)                                   (0x00003F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_PHSEL_DDSA_src(data)                               ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_get_PHSEL_DDSA(data)                               ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_DIVN_DDSA_shift                                    (0)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_DIVN_DDSA_mask                                     (0x000000FF)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_DIVN_DDSA(data)                                    (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_DIVN_DDSA_src(data)                                ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_get_DIVN_DDSA(data)                                ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA_DBG2                                                    0x57C
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_reg_addr                                           "0x9800057C"
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_reg                                                0x9800057C
+#define set_SYS_PLL_SSC_DIG_DDSA_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA_DBG2_reg))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_inst_adr                                           "0x005F"
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_inst                                               0x005F
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_load_FCW_DDSA_shift                                (21)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_load_FCW_DDSA_mask                                 (0x00200000)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_load_FCW_DDSA(data)                                (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_load_FCW_DDSA_src(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_get_load_FCW_DDSA(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_OC_DONE_DDSA_shift                                 (20)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_OC_DONE_DDSA_mask                                  (0x00100000)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_OC_DONE_DDSA(data)                                 (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_OC_DONE_DDSA_src(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_get_OC_DONE_DDSA(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FMOD_DDSA_shift                                    (19)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FMOD_DDSA_mask                                     (0x00080000)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FMOD_DDSA(data)                                    (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FMOD_DDSA_src(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_get_FMOD_DDSA(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_NCODE_DEBUG_DDSA_shift                             (11)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_NCODE_DEBUG_DDSA_mask                              (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_NCODE_DEBUG_DDSA(data)                             (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_NCODE_DEBUG_DDSA_src(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_get_NCODE_DEBUG_DDSA(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FCODE_DEBUG_DDSA_shift                             (0)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FCODE_DEBUG_DDSA_mask                              (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FCODE_DEBUG_DDSA(data)                             (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FCODE_DEBUG_DDSA_src(data)                         ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_get_FCODE_DEBUG_DDSA(data)                         ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB0                                                        0x580
+#define SYS_PLL_SSC_DIG_DDSB0_reg_addr                                               "0x98000580"
+#define SYS_PLL_SSC_DIG_DDSB0_reg                                                    0x98000580
+#define set_SYS_PLL_SSC_DIG_DDSB0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB0_reg))
+#define SYS_PLL_SSC_DIG_DDSB0_inst_adr                                               "0x0060"
+#define SYS_PLL_SSC_DIG_DDSB0_inst                                                   0x0060
+#define SYS_PLL_SSC_DIG_DDSB0_REG_CKSSC_INV_DDSB_shift                               (4)
+#define SYS_PLL_SSC_DIG_DDSB0_REG_CKSSC_INV_DDSB_mask                                (0x00000010)
+#define SYS_PLL_SSC_DIG_DDSB0_REG_CKSSC_INV_DDSB(data)                               (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_DDSB0_REG_CKSSC_INV_DDSB_src(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_DDSB0_get_REG_CKSSC_INV_DDSB(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_DDSB0_REG_GRAN_AUTO_RST_DDSB_shift                           (3)
+#define SYS_PLL_SSC_DIG_DDSB0_REG_GRAN_AUTO_RST_DDSB_mask                            (0x00000008)
+#define SYS_PLL_SSC_DIG_DDSB0_REG_GRAN_AUTO_RST_DDSB(data)                           (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_DDSB0_REG_GRAN_AUTO_RST_DDSB_src(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_DDSB0_get_REG_GRAN_AUTO_RST_DDSB(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_DDSB0_RSTB_DDSB_shift                                        (2)
+#define SYS_PLL_SSC_DIG_DDSB0_RSTB_DDSB_mask                                         (0x00000004)
+#define SYS_PLL_SSC_DIG_DDSB0_RSTB_DDSB(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_DDSB0_RSTB_DDSB_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSB0_get_RSTB_DDSB(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSB0_EN_SSC_DDSB_shift                                      (1)
+#define SYS_PLL_SSC_DIG_DDSB0_EN_SSC_DDSB_mask                                       (0x00000002)
+#define SYS_PLL_SSC_DIG_DDSB0_EN_SSC_DDSB(data)                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_DDSB0_EN_SSC_DDSB_src(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSB0_get_EN_SSC_DDSB(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSB0_OC_EN_DDSB_shift                                       (0)
+#define SYS_PLL_SSC_DIG_DDSB0_OC_EN_DDSB_mask                                        (0x00000001)
+#define SYS_PLL_SSC_DIG_DDSB0_OC_EN_DDSB(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB0_OC_EN_DDSB_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB0_get_OC_EN_DDSB(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB1                                                        0x584
+#define SYS_PLL_SSC_DIG_DDSB1_reg_addr                                               "0x98000584"
+#define SYS_PLL_SSC_DIG_DDSB1_reg                                                    0x98000584
+#define set_SYS_PLL_SSC_DIG_DDSB1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB1_reg))
+#define SYS_PLL_SSC_DIG_DDSB1_inst_adr                                               "0x0061"
+#define SYS_PLL_SSC_DIG_DDSB1_inst                                                   0x0061
+#define SYS_PLL_SSC_DIG_DDSB1_REG_PLLDDSB_ICO_PDIV2_shift                            (19)
+#define SYS_PLL_SSC_DIG_DDSB1_REG_PLLDDSB_ICO_PDIV2_mask                             (0x00380000)
+#define SYS_PLL_SSC_DIG_DDSB1_REG_PLLDDSB_ICO_PDIV2(data)                            (0x00380000&((data)<<19))
+#define SYS_PLL_SSC_DIG_DDSB1_REG_PLLDDSB_ICO_PDIV2_src(data)                        ((0x00380000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSB1_get_REG_PLLDDSB_ICO_PDIV2(data)                        ((0x00380000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSB1_NCODE_T_DDSB_shift                                     (11)
+#define SYS_PLL_SSC_DIG_DDSB1_NCODE_T_DDSB_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSB1_NCODE_T_DDSB(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSB1_NCODE_T_DDSB_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB1_get_NCODE_T_DDSB(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB1_FCODE_T_DDSB_shift                                     (0)
+#define SYS_PLL_SSC_DIG_DDSB1_FCODE_T_DDSB_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSB1_FCODE_T_DDSB(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB1_FCODE_T_DDSB_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB1_get_FCODE_T_DDSB(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB2                                                        0x588
+#define SYS_PLL_SSC_DIG_DDSB2_reg_addr                                               "0x98000588"
+#define SYS_PLL_SSC_DIG_DDSB2_reg                                                    0x98000588
+#define set_SYS_PLL_SSC_DIG_DDSB2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB2_reg))
+#define SYS_PLL_SSC_DIG_DDSB2_inst_adr                                               "0x0062"
+#define SYS_PLL_SSC_DIG_DDSB2_inst                                                   0x0062
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_DIVN_shift                                  (27)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_DIVN_mask                                   (0x08000000)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_DIVN(data)                                  (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_DIVN_src(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_BYPASS_DIVN(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_STEP_SET_DDSB_shift                             (17)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_STEP_SET_DDSB_mask                              (0x07FE0000)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_STEP_SET_DDSB(data)                             (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_STEP_SET_DDSB_src(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_OC_STEP_SET_DDSB(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SEL_OC_MODE_DDSB_shift                             (15)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SEL_OC_MODE_DDSB_mask                              (0x00018000)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SEL_OC_MODE_DDSB(data)                             (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SEL_OC_MODE_DDSB_src(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_SEL_OC_MODE_DDSB(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_HS_OC_STOP_DIFF_DDSB_shift                         (13)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_HS_OC_STOP_DIFF_DDSB_mask                          (0x00006000)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_HS_OC_STOP_DIFF_DDSB(data)                         (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_HS_OC_STOP_DIFF_DDSB_src(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_HS_OC_STOP_DIFF_DDSB(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_DONE_DELAY_DDSB_shift                           (7)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_DONE_DELAY_DDSB_mask                            (0x00001F80)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_DONE_DELAY_DDSB(data)                           (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_DONE_DELAY_DDSB_src(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_OC_DONE_DELAY_DDSB(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_PI_DDSB_shift                               (6)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_PI_DDSB_mask                                (0x00000040)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_PI_DDSB(data)                               (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_PI_DDSB_src(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_BYPASS_PI_DDSB(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SDM_ORDER_DDSB_shift                               (5)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SDM_ORDER_DDSB_mask                                (0x00000020)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SDM_ORDER_DDSB(data)                               (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SDM_ORDER_DDSB_src(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_SDM_ORDER_DDSB(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_PI_CUR_SEL_DDSB_shift                              (2)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_PI_CUR_SEL_DDSB_mask                               (0x0000001C)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_PI_CUR_SEL_DDSB(data)                              (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_PI_CUR_SEL_DDSB_src(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_PI_CUR_SEL_DDSB(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_EN_PI_DEBUG_DDSB_shift                             (1)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_EN_PI_DEBUG_DDSB_mask                              (0x00000002)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_EN_PI_DEBUG_DDSB(data)                             (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_EN_PI_DEBUG_DDSB_src(data)                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_EN_PI_DEBUG_DDSB(data)                         ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_DDSB3                                                        0x58C
+#define SYS_PLL_SSC_DIG_DDSB3_reg_addr                                               "0x9800058C"
+#define SYS_PLL_SSC_DIG_DDSB3_reg                                                    0x9800058C
+#define set_SYS_PLL_SSC_DIG_DDSB3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB3_reg))
+#define SYS_PLL_SSC_DIG_DDSB3_inst_adr                                               "0x0063"
+#define SYS_PLL_SSC_DIG_DDSB3_inst                                                   0x0063
+#define SYS_PLL_SSC_DIG_DDSB3_NCODE_SSC_DDSB_shift                                   (11)
+#define SYS_PLL_SSC_DIG_DDSB3_NCODE_SSC_DDSB_mask                                    (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSB3_NCODE_SSC_DDSB(data)                                   (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSB3_NCODE_SSC_DDSB_src(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB3_get_NCODE_SSC_DDSB(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB3_FCODE_SSC_DDSB_shift                                   (0)
+#define SYS_PLL_SSC_DIG_DDSB3_FCODE_SSC_DDSB_mask                                    (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSB3_FCODE_SSC_DDSB(data)                                   (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB3_FCODE_SSC_DDSB_src(data)                               ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB3_get_FCODE_SSC_DDSB(data)                               ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB4                                                        0x590
+#define SYS_PLL_SSC_DIG_DDSB4_reg_addr                                               "0x98000590"
+#define SYS_PLL_SSC_DIG_DDSB4_reg                                                    0x98000590
+#define set_SYS_PLL_SSC_DIG_DDSB4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB4_reg))
+#define SYS_PLL_SSC_DIG_DDSB4_inst_adr                                               "0x0064"
+#define SYS_PLL_SSC_DIG_DDSB4_inst                                                   0x0064
+#define SYS_PLL_SSC_DIG_DDSB4_GRAN_EST_DDSB_shift                                    (0)
+#define SYS_PLL_SSC_DIG_DDSB4_GRAN_EST_DDSB_mask                                     (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_DDSB4_GRAN_EST_DDSB(data)                                    (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB4_GRAN_EST_DDSB_src(data)                                ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB4_get_GRAN_EST_DDSB(data)                                ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB5                                                        0x594
+#define SYS_PLL_SSC_DIG_DDSB5_reg_addr                                               "0x98000594"
+#define SYS_PLL_SSC_DIG_DDSB5_reg                                                    0x98000594
+#define set_SYS_PLL_SSC_DIG_DDSB5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB5_reg))
+#define SYS_PLL_SSC_DIG_DDSB5_inst_adr                                               "0x0065"
+#define SYS_PLL_SSC_DIG_DDSB5_inst                                                   0x0065
+#define SYS_PLL_SSC_DIG_DDSB5_FCW_SSC_DEFAULT_DDSB_shift                             (0)
+#define SYS_PLL_SSC_DIG_DDSB5_FCW_SSC_DEFAULT_DDSB_mask                              (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_DDSB5_FCW_SSC_DEFAULT_DDSB(data)                             (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB5_FCW_SSC_DEFAULT_DDSB_src(data)                         ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB5_get_FCW_SSC_DEFAULT_DDSB(data)                         ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB_DBG1                                                    0x598
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_reg_addr                                           "0x98000598"
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_reg                                                0x98000598
+#define set_SYS_PLL_SSC_DIG_DDSB_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB_DBG1_reg))
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_inst_adr                                           "0x0066"
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_inst                                               0x0066
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_LOOP_PI_ISEL_DDSB_shift                            (14)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_LOOP_PI_ISEL_DDSB_mask                             (0x0001C000)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_LOOP_PI_ISEL_DDSB(data)                            (0x0001C000&((data)<<14))
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_LOOP_PI_ISEL_DDSB_src(data)                        ((0x0001C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_get_LOOP_PI_ISEL_DDSB(data)                        ((0x0001C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_PHSEL_DDSB_shift                                   (8)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_PHSEL_DDSB_mask                                    (0x00003F00)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_PHSEL_DDSB(data)                                   (0x00003F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_PHSEL_DDSB_src(data)                               ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_get_PHSEL_DDSB(data)                               ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_DIVN_DDSB_shift                                    (0)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_DIVN_DDSB_mask                                     (0x000000FF)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_DIVN_DDSB(data)                                    (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_DIVN_DDSB_src(data)                                ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_get_DIVN_DDSB(data)                                ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB_DBG2                                                    0x59C
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_reg_addr                                           "0x9800059C"
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_reg                                                0x9800059C
+#define set_SYS_PLL_SSC_DIG_DDSB_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB_DBG2_reg))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_inst_adr                                           "0x0067"
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_inst                                               0x0067
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_load_FCW_DDSB_shift                                (21)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_load_FCW_DDSB_mask                                 (0x00200000)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_load_FCW_DDSB(data)                                (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_load_FCW_DDSB_src(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_get_load_FCW_DDSB(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_OC_DONE_DDSB_shift                                 (20)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_OC_DONE_DDSB_mask                                  (0x00100000)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_OC_DONE_DDSB(data)                                 (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_OC_DONE_DDSB_src(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_get_OC_DONE_DDSB(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FMOD_DDSB_shift                                    (19)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FMOD_DDSB_mask                                     (0x00080000)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FMOD_DDSB(data)                                    (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FMOD_DDSB_src(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_get_FMOD_DDSB(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_NCODE_DEBUG_DDSB_shift                             (11)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_NCODE_DEBUG_DDSB_mask                              (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_NCODE_DEBUG_DDSB(data)                             (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_NCODE_DEBUG_DDSB_src(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_get_NCODE_DEBUG_DDSB(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FCODE_DEBUG_DDSB_shift                             (0)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FCODE_DEBUG_DDSB_mask                              (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FCODE_DEBUG_DDSB(data)                             (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FCODE_DEBUG_DDSB_src(data)                         ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_get_FCODE_DEBUG_DDSB(data)                         ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU0                                                         0x5A0
+#define SYS_PLL_SSC_DIG_GPU0_reg_addr                                                "0x980005A0"
+#define SYS_PLL_SSC_DIG_GPU0_reg                                                     0x980005A0
+#define set_SYS_PLL_SSC_DIG_GPU0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU0_reg))
+#define SYS_PLL_SSC_DIG_GPU0_inst_adr                                                "0x0068"
+#define SYS_PLL_SSC_DIG_GPU0_inst                                                    0x0068
+#define SYS_PLL_SSC_DIG_GPU0_REG_CKSSC_INV_GPU_shift                                 (4)
+#define SYS_PLL_SSC_DIG_GPU0_REG_CKSSC_INV_GPU_mask                                  (0x00000010)
+#define SYS_PLL_SSC_DIG_GPU0_REG_CKSSC_INV_GPU(data)                                 (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_GPU0_REG_CKSSC_INV_GPU_src(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_GPU0_get_REG_CKSSC_INV_GPU(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_GPU0_REG_GRAN_AUTO_RST_GPU_shift                             (3)
+#define SYS_PLL_SSC_DIG_GPU0_REG_GRAN_AUTO_RST_GPU_mask                              (0x00000008)
+#define SYS_PLL_SSC_DIG_GPU0_REG_GRAN_AUTO_RST_GPU(data)                             (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_GPU0_REG_GRAN_AUTO_RST_GPU_src(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_GPU0_get_REG_GRAN_AUTO_RST_GPU(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_GPU0_RSTB_GPU_shift                                          (2)
+#define SYS_PLL_SSC_DIG_GPU0_RSTB_GPU_mask                                           (0x00000004)
+#define SYS_PLL_SSC_DIG_GPU0_RSTB_GPU(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_GPU0_RSTB_GPU_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_GPU0_get_RSTB_GPU(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_GPU0_EN_SSC_GPU_shift                                        (1)
+#define SYS_PLL_SSC_DIG_GPU0_EN_SSC_GPU_mask                                         (0x00000002)
+#define SYS_PLL_SSC_DIG_GPU0_EN_SSC_GPU(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_GPU0_EN_SSC_GPU_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_GPU0_get_EN_SSC_GPU(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_GPU0_OC_EN_GPU_shift                                         (0)
+#define SYS_PLL_SSC_DIG_GPU0_OC_EN_GPU_mask                                          (0x00000001)
+#define SYS_PLL_SSC_DIG_GPU0_OC_EN_GPU(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU0_OC_EN_GPU_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU0_get_OC_EN_GPU(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU1                                                         0x5A4
+#define SYS_PLL_SSC_DIG_GPU1_reg_addr                                                "0x980005A4"
+#define SYS_PLL_SSC_DIG_GPU1_reg                                                     0x980005A4
+#define set_SYS_PLL_SSC_DIG_GPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU1_reg))
+#define SYS_PLL_SSC_DIG_GPU1_inst_adr                                                "0x0069"
+#define SYS_PLL_SSC_DIG_GPU1_inst                                                    0x0069
+#define SYS_PLL_SSC_DIG_GPU1_NCODE_T_GPU_shift                                       (11)
+#define SYS_PLL_SSC_DIG_GPU1_NCODE_T_GPU_mask                                        (0x0007F800)
+#define SYS_PLL_SSC_DIG_GPU1_NCODE_T_GPU(data)                                       (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_GPU1_NCODE_T_GPU_src(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU1_get_NCODE_T_GPU(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU1_FCODE_T_GPU_shift                                       (0)
+#define SYS_PLL_SSC_DIG_GPU1_FCODE_T_GPU_mask                                        (0x000007FF)
+#define SYS_PLL_SSC_DIG_GPU1_FCODE_T_GPU(data)                                       (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU1_FCODE_T_GPU_src(data)                                   ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU1_get_FCODE_T_GPU(data)                                   ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU2                                                         0x5A8
+#define SYS_PLL_SSC_DIG_GPU2_reg_addr                                                "0x980005A8"
+#define SYS_PLL_SSC_DIG_GPU2_reg                                                     0x980005A8
+#define set_SYS_PLL_SSC_DIG_GPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU2_reg))
+#define SYS_PLL_SSC_DIG_GPU2_inst_adr                                                "0x006A"
+#define SYS_PLL_SSC_DIG_GPU2_inst                                                    0x006A
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_DIVN_shift                                   (27)
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_DIVN_mask                                    (0x08000000)
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_DIVN(data)                                   (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_DIVN_src(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_BYPASS_DIVN(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_STEP_SET_GPU_shift                               (17)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_STEP_SET_GPU_mask                                (0x07FE0000)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_STEP_SET_GPU(data)                               (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_STEP_SET_GPU_src(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_OC_STEP_SET_GPU(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SEL_OC_MODE_GPU_shift                               (15)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SEL_OC_MODE_GPU_mask                                (0x00018000)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SEL_OC_MODE_GPU(data)                               (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_GPU2_REG_SEL_OC_MODE_GPU_src(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_SEL_OC_MODE_GPU(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_GPU2_REG_HS_OC_STOP_DIFF_GPU_shift                           (13)
+#define SYS_PLL_SSC_DIG_GPU2_REG_HS_OC_STOP_DIFF_GPU_mask                            (0x00006000)
+#define SYS_PLL_SSC_DIG_GPU2_REG_HS_OC_STOP_DIFF_GPU(data)                           (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_GPU2_REG_HS_OC_STOP_DIFF_GPU_src(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_HS_OC_STOP_DIFF_GPU(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_DONE_DELAY_GPU_shift                             (7)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_DONE_DELAY_GPU_mask                              (0x00001F80)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_DONE_DELAY_GPU(data)                             (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_DONE_DELAY_GPU_src(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_OC_DONE_DELAY_GPU(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_PI_GPU_shift                                 (6)
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_PI_GPU_mask                                  (0x00000040)
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_PI_GPU(data)                                 (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_PI_GPU_src(data)                             ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_BYPASS_PI_GPU(data)                             ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SDM_ORDER_GPU_shift                                 (5)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SDM_ORDER_GPU_mask                                  (0x00000020)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SDM_ORDER_GPU(data)                                 (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_GPU2_REG_SDM_ORDER_GPU_src(data)                             ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_SDM_ORDER_GPU(data)                             ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_GPU2_REG_PI_CUR_SEL_GPU_shift                                (2)
+#define SYS_PLL_SSC_DIG_GPU2_REG_PI_CUR_SEL_GPU_mask                                 (0x0000001C)
+#define SYS_PLL_SSC_DIG_GPU2_REG_PI_CUR_SEL_GPU(data)                                (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_GPU2_REG_PI_CUR_SEL_GPU_src(data)                            ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_PI_CUR_SEL_GPU(data)                            ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_GPU2_REG_EN_PI_DEBUG_GPU_shift                               (1)
+#define SYS_PLL_SSC_DIG_GPU2_REG_EN_PI_DEBUG_GPU_mask                                (0x00000002)
+#define SYS_PLL_SSC_DIG_GPU2_REG_EN_PI_DEBUG_GPU(data)                               (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_GPU2_REG_EN_PI_DEBUG_GPU_src(data)                           ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_EN_PI_DEBUG_GPU(data)                           ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_GPU3                                                         0x5AC
+#define SYS_PLL_SSC_DIG_GPU3_reg_addr                                                "0x980005AC"
+#define SYS_PLL_SSC_DIG_GPU3_reg                                                     0x980005AC
+#define set_SYS_PLL_SSC_DIG_GPU3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU3_reg))
+#define SYS_PLL_SSC_DIG_GPU3_inst_adr                                                "0x006B"
+#define SYS_PLL_SSC_DIG_GPU3_inst                                                    0x006B
+#define SYS_PLL_SSC_DIG_GPU3_NCODE_SSC_GPU_shift                                     (11)
+#define SYS_PLL_SSC_DIG_GPU3_NCODE_SSC_GPU_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_GPU3_NCODE_SSC_GPU(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_GPU3_NCODE_SSC_GPU_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU3_get_NCODE_SSC_GPU(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU3_FCODE_SSC_GPU_shift                                     (0)
+#define SYS_PLL_SSC_DIG_GPU3_FCODE_SSC_GPU_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_GPU3_FCODE_SSC_GPU(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU3_FCODE_SSC_GPU_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU3_get_FCODE_SSC_GPU(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU4                                                         0x5B0
+#define SYS_PLL_SSC_DIG_GPU4_reg_addr                                                "0x980005B0"
+#define SYS_PLL_SSC_DIG_GPU4_reg                                                     0x980005B0
+#define set_SYS_PLL_SSC_DIG_GPU4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU4_reg))
+#define SYS_PLL_SSC_DIG_GPU4_inst_adr                                                "0x006C"
+#define SYS_PLL_SSC_DIG_GPU4_inst                                                    0x006C
+#define SYS_PLL_SSC_DIG_GPU4_GRAN_EST_GPU_shift                                      (0)
+#define SYS_PLL_SSC_DIG_GPU4_GRAN_EST_GPU_mask                                       (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_GPU4_GRAN_EST_GPU(data)                                      (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU4_GRAN_EST_GPU_src(data)                                  ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU4_get_GRAN_EST_GPU(data)                                  ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU5                                                         0x5B4
+#define SYS_PLL_SSC_DIG_GPU5_reg_addr                                                "0x980005B4"
+#define SYS_PLL_SSC_DIG_GPU5_reg                                                     0x980005B4
+#define set_SYS_PLL_SSC_DIG_GPU5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU5_reg))
+#define SYS_PLL_SSC_DIG_GPU5_inst_adr                                                "0x006D"
+#define SYS_PLL_SSC_DIG_GPU5_inst                                                    0x006D
+#define SYS_PLL_SSC_DIG_GPU5_FCW_SSC_DEFAULT_GPU_shift                               (0)
+#define SYS_PLL_SSC_DIG_GPU5_FCW_SSC_DEFAULT_GPU_mask                                (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_GPU5_FCW_SSC_DEFAULT_GPU(data)                               (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU5_FCW_SSC_DEFAULT_GPU_src(data)                           ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU5_get_FCW_SSC_DEFAULT_GPU(data)                           ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU_DBG1                                                     0x5B8
+#define SYS_PLL_SSC_DIG_GPU_DBG1_reg_addr                                            "0x980005B8"
+#define SYS_PLL_SSC_DIG_GPU_DBG1_reg                                                 0x980005B8
+#define set_SYS_PLL_SSC_DIG_GPU_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU_DBG1_reg))
+#define SYS_PLL_SSC_DIG_GPU_DBG1_inst_adr                                            "0x006E"
+#define SYS_PLL_SSC_DIG_GPU_DBG1_inst                                                0x006E
+#define SYS_PLL_SSC_DIG_GPU_DBG1_LOOP_PI_ISEL_GPU_shift                              (13)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_LOOP_PI_ISEL_GPU_mask                               (0x0000E000)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_LOOP_PI_ISEL_GPU(data)                              (0x0000E000&((data)<<13))
+#define SYS_PLL_SSC_DIG_GPU_DBG1_LOOP_PI_ISEL_GPU_src(data)                          ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_get_LOOP_PI_ISEL_GPU(data)                          ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_PHSEL_GPU_shift                                     (8)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_PHSEL_GPU_mask                                      (0x00001F00)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_PHSEL_GPU(data)                                     (0x00001F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_GPU_DBG1_PHSEL_GPU_src(data)                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_get_PHSEL_GPU(data)                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_DIVN_GPU_shift                                      (0)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_DIVN_GPU_mask                                       (0x000000FF)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_DIVN_GPU(data)                                      (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU_DBG1_DIVN_GPU_src(data)                                  ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_get_DIVN_GPU(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU_DBG2                                                     0x5BC
+#define SYS_PLL_SSC_DIG_GPU_DBG2_reg_addr                                            "0x980005BC"
+#define SYS_PLL_SSC_DIG_GPU_DBG2_reg                                                 0x980005BC
+#define set_SYS_PLL_SSC_DIG_GPU_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU_DBG2_reg))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_inst_adr                                            "0x006F"
+#define SYS_PLL_SSC_DIG_GPU_DBG2_inst                                                0x006F
+#define SYS_PLL_SSC_DIG_GPU_DBG2_load_FCW_GPU_shift                                  (21)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_load_FCW_GPU_mask                                   (0x00200000)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_load_FCW_GPU(data)                                  (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_load_FCW_GPU_src(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_get_load_FCW_GPU(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_OC_DONE_GPU_shift                                   (20)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_OC_DONE_GPU_mask                                    (0x00100000)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_OC_DONE_GPU(data)                                   (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_OC_DONE_GPU_src(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_get_OC_DONE_GPU(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FMOD_GPU_shift                                      (19)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FMOD_GPU_mask                                       (0x00080000)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FMOD_GPU(data)                                      (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FMOD_GPU_src(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_get_FMOD_GPU(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_NCODE_DEBUG_GPU_shift                               (11)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_NCODE_DEBUG_GPU_mask                                (0x0007F800)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_NCODE_DEBUG_GPU(data)                               (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_NCODE_DEBUG_GPU_src(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_get_NCODE_DEBUG_GPU(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FCODE_DEBUG_GPU_shift                               (0)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FCODE_DEBUG_GPU_mask                                (0x000007FF)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FCODE_DEBUG_GPU(data)                               (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FCODE_DEBUG_GPU_src(data)                           ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_get_FCODE_DEBUG_GPU(data)                           ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU0                                                        0x5C0
+#define SYS_PLL_SSC_DIG_ACPU0_reg_addr                                               "0x980005C0"
+#define SYS_PLL_SSC_DIG_ACPU0_reg                                                    0x980005C0
+#define set_SYS_PLL_SSC_DIG_ACPU0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU0_reg))
+#define SYS_PLL_SSC_DIG_ACPU0_inst_adr                                               "0x0070"
+#define SYS_PLL_SSC_DIG_ACPU0_inst                                                   0x0070
+#define SYS_PLL_SSC_DIG_ACPU0_REG_CKSSC_INV_ACPU_shift                               (4)
+#define SYS_PLL_SSC_DIG_ACPU0_REG_CKSSC_INV_ACPU_mask                                (0x00000010)
+#define SYS_PLL_SSC_DIG_ACPU0_REG_CKSSC_INV_ACPU(data)                               (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_ACPU0_REG_CKSSC_INV_ACPU_src(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_ACPU0_get_REG_CKSSC_INV_ACPU(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_ACPU0_REG_GRAN_AUTO_RST_ACPU_shift                           (3)
+#define SYS_PLL_SSC_DIG_ACPU0_REG_GRAN_AUTO_RST_ACPU_mask                            (0x00000008)
+#define SYS_PLL_SSC_DIG_ACPU0_REG_GRAN_AUTO_RST_ACPU(data)                           (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_ACPU0_REG_GRAN_AUTO_RST_ACPU_src(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_ACPU0_get_REG_GRAN_AUTO_RST_ACPU(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_ACPU0_RSTB_ACPU_shift                                        (2)
+#define SYS_PLL_SSC_DIG_ACPU0_RSTB_ACPU_mask                                         (0x00000004)
+#define SYS_PLL_SSC_DIG_ACPU0_RSTB_ACPU(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_ACPU0_RSTB_ACPU_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_ACPU0_get_RSTB_ACPU(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_ACPU0_EN_SSC_ACPU_shift                                      (1)
+#define SYS_PLL_SSC_DIG_ACPU0_EN_SSC_ACPU_mask                                       (0x00000002)
+#define SYS_PLL_SSC_DIG_ACPU0_EN_SSC_ACPU(data)                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_ACPU0_EN_SSC_ACPU_src(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_ACPU0_get_EN_SSC_ACPU(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_ACPU0_OC_EN_ACPU_shift                                       (0)
+#define SYS_PLL_SSC_DIG_ACPU0_OC_EN_ACPU_mask                                        (0x00000001)
+#define SYS_PLL_SSC_DIG_ACPU0_OC_EN_ACPU(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU0_OC_EN_ACPU_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU0_get_OC_EN_ACPU(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU1                                                        0x5C4
+#define SYS_PLL_SSC_DIG_ACPU1_reg_addr                                               "0x980005C4"
+#define SYS_PLL_SSC_DIG_ACPU1_reg                                                    0x980005C4
+#define set_SYS_PLL_SSC_DIG_ACPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU1_reg))
+#define SYS_PLL_SSC_DIG_ACPU1_inst_adr                                               "0x0071"
+#define SYS_PLL_SSC_DIG_ACPU1_inst                                                   0x0071
+#define SYS_PLL_SSC_DIG_ACPU1_NCODE_T_ACPU_shift                                     (11)
+#define SYS_PLL_SSC_DIG_ACPU1_NCODE_T_ACPU_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_ACPU1_NCODE_T_ACPU(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_ACPU1_NCODE_T_ACPU_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU1_get_NCODE_T_ACPU(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU1_FCODE_T_ACPU_shift                                     (0)
+#define SYS_PLL_SSC_DIG_ACPU1_FCODE_T_ACPU_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_ACPU1_FCODE_T_ACPU(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU1_FCODE_T_ACPU_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU1_get_FCODE_T_ACPU(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU2                                                        0x5C8
+#define SYS_PLL_SSC_DIG_ACPU2_reg_addr                                               "0x980005C8"
+#define SYS_PLL_SSC_DIG_ACPU2_reg                                                    0x980005C8
+#define set_SYS_PLL_SSC_DIG_ACPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU2_reg))
+#define SYS_PLL_SSC_DIG_ACPU2_inst_adr                                               "0x0072"
+#define SYS_PLL_SSC_DIG_ACPU2_inst                                                   0x0072
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_DIVN_shift                                  (27)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_DIVN_mask                                   (0x08000000)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_DIVN(data)                                  (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_DIVN_src(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_BYPASS_DIVN(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_STEP_SET_ACPU_shift                             (17)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_STEP_SET_ACPU_mask                              (0x07FE0000)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_STEP_SET_ACPU(data)                             (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_STEP_SET_ACPU_src(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_OC_STEP_SET_ACPU(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SEL_OC_MODE_ACPU_shift                             (15)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SEL_OC_MODE_ACPU_mask                              (0x00018000)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SEL_OC_MODE_ACPU(data)                             (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SEL_OC_MODE_ACPU_src(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_SEL_OC_MODE_ACPU(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_HS_OC_STOP_DIFF_ACPU_shift                         (13)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_HS_OC_STOP_DIFF_ACPU_mask                          (0x00006000)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_HS_OC_STOP_DIFF_ACPU(data)                         (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_HS_OC_STOP_DIFF_ACPU_src(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_HS_OC_STOP_DIFF_ACPU(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_DONE_DELAY_ACPU_shift                           (7)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_DONE_DELAY_ACPU_mask                            (0x00001F80)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_DONE_DELAY_ACPU(data)                           (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_DONE_DELAY_ACPU_src(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_OC_DONE_DELAY_ACPU(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_PI_ACPU_shift                               (6)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_PI_ACPU_mask                                (0x00000040)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_PI_ACPU(data)                               (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_PI_ACPU_src(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_BYPASS_PI_ACPU(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SDM_ORDER_ACPU_shift                               (5)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SDM_ORDER_ACPU_mask                                (0x00000020)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SDM_ORDER_ACPU(data)                               (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SDM_ORDER_ACPU_src(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_SDM_ORDER_ACPU(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_PI_CUR_SEL_ACPU_shift                              (2)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_PI_CUR_SEL_ACPU_mask                               (0x0000001C)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_PI_CUR_SEL_ACPU(data)                              (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_PI_CUR_SEL_ACPU_src(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_PI_CUR_SEL_ACPU(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_EN_PI_DEBUG_ACPU_shift                             (1)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_EN_PI_DEBUG_ACPU_mask                              (0x00000002)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_EN_PI_DEBUG_ACPU(data)                             (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_EN_PI_DEBUG_ACPU_src(data)                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_EN_PI_DEBUG_ACPU(data)                         ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_ACPU3                                                        0x5CC
+#define SYS_PLL_SSC_DIG_ACPU3_reg_addr                                               "0x980005CC"
+#define SYS_PLL_SSC_DIG_ACPU3_reg                                                    0x980005CC
+#define set_SYS_PLL_SSC_DIG_ACPU3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU3_reg))
+#define SYS_PLL_SSC_DIG_ACPU3_inst_adr                                               "0x0073"
+#define SYS_PLL_SSC_DIG_ACPU3_inst                                                   0x0073
+#define SYS_PLL_SSC_DIG_ACPU3_NCODE_SSC_ACPU_shift                                   (11)
+#define SYS_PLL_SSC_DIG_ACPU3_NCODE_SSC_ACPU_mask                                    (0x0007F800)
+#define SYS_PLL_SSC_DIG_ACPU3_NCODE_SSC_ACPU(data)                                   (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_ACPU3_NCODE_SSC_ACPU_src(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU3_get_NCODE_SSC_ACPU(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU3_FCODE_SSC_ACPU_shift                                   (0)
+#define SYS_PLL_SSC_DIG_ACPU3_FCODE_SSC_ACPU_mask                                    (0x000007FF)
+#define SYS_PLL_SSC_DIG_ACPU3_FCODE_SSC_ACPU(data)                                   (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU3_FCODE_SSC_ACPU_src(data)                               ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU3_get_FCODE_SSC_ACPU(data)                               ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU4                                                        0x5D0
+#define SYS_PLL_SSC_DIG_ACPU4_reg_addr                                               "0x980005D0"
+#define SYS_PLL_SSC_DIG_ACPU4_reg                                                    0x980005D0
+#define set_SYS_PLL_SSC_DIG_ACPU4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU4_reg))
+#define SYS_PLL_SSC_DIG_ACPU4_inst_adr                                               "0x0074"
+#define SYS_PLL_SSC_DIG_ACPU4_inst                                                   0x0074
+#define SYS_PLL_SSC_DIG_ACPU4_GRAN_EST_ACPU_shift                                    (0)
+#define SYS_PLL_SSC_DIG_ACPU4_GRAN_EST_ACPU_mask                                     (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_ACPU4_GRAN_EST_ACPU(data)                                    (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU4_GRAN_EST_ACPU_src(data)                                ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU4_get_GRAN_EST_ACPU(data)                                ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU5                                                        0x5D4
+#define SYS_PLL_SSC_DIG_ACPU5_reg_addr                                               "0x980005D4"
+#define SYS_PLL_SSC_DIG_ACPU5_reg                                                    0x980005D4
+#define set_SYS_PLL_SSC_DIG_ACPU5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU5_reg))
+#define SYS_PLL_SSC_DIG_ACPU5_inst_adr                                               "0x0075"
+#define SYS_PLL_SSC_DIG_ACPU5_inst                                                   0x0075
+#define SYS_PLL_SSC_DIG_ACPU5_FCW_SSC_DEFAULT_ACPU_shift                             (0)
+#define SYS_PLL_SSC_DIG_ACPU5_FCW_SSC_DEFAULT_ACPU_mask                              (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_ACPU5_FCW_SSC_DEFAULT_ACPU(data)                             (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU5_FCW_SSC_DEFAULT_ACPU_src(data)                         ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU5_get_FCW_SSC_DEFAULT_ACPU(data)                         ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU_DBG1                                                    0x5D8
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_reg_addr                                           "0x980005D8"
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_reg                                                0x980005D8
+#define set_SYS_PLL_SSC_DIG_ACPU_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU_DBG1_reg))
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_inst_adr                                           "0x0076"
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_inst                                               0x0076
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_LOOP_PI_ISEL_ACPU_shift                            (13)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_LOOP_PI_ISEL_ACPU_mask                             (0x0000E000)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_LOOP_PI_ISEL_ACPU(data)                            (0x0000E000&((data)<<13))
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_LOOP_PI_ISEL_ACPU_src(data)                        ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_get_LOOP_PI_ISEL_ACPU(data)                        ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_PHSEL_ACPU_shift                                   (8)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_PHSEL_ACPU_mask                                    (0x00001F00)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_PHSEL_ACPU(data)                                   (0x00001F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_PHSEL_ACPU_src(data)                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_get_PHSEL_ACPU(data)                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_DIVN_ACPU_shift                                    (0)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_DIVN_ACPU_mask                                     (0x000000FF)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_DIVN_ACPU(data)                                    (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_DIVN_ACPU_src(data)                                ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_get_DIVN_ACPU(data)                                ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU_DBG2                                                    0x5DC
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_reg_addr                                           "0x980005DC"
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_reg                                                0x980005DC
+#define set_SYS_PLL_SSC_DIG_ACPU_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU_DBG2_reg))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_inst_adr                                           "0x0077"
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_inst                                               0x0077
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_load_FCW_ACPU_shift                                (21)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_load_FCW_ACPU_mask                                 (0x00200000)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_load_FCW_ACPU(data)                                (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_load_FCW_ACPU_src(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_get_load_FCW_ACPU(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_OC_DONE_ACPU_shift                                 (20)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_OC_DONE_ACPU_mask                                  (0x00100000)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_OC_DONE_ACPU(data)                                 (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_OC_DONE_ACPU_src(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_get_OC_DONE_ACPU(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FMOD_ACPU_shift                                    (19)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FMOD_ACPU_mask                                     (0x00080000)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FMOD_ACPU(data)                                    (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FMOD_ACPU_src(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_get_FMOD_ACPU(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_NCODE_DEBUG_ACPU_shift                             (11)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_NCODE_DEBUG_ACPU_mask                              (0x0007F800)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_NCODE_DEBUG_ACPU(data)                             (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_NCODE_DEBUG_ACPU_src(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_get_NCODE_DEBUG_ACPU(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FCODE_DEBUG_ACPU_shift                             (0)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FCODE_DEBUG_ACPU_mask                              (0x000007FF)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FCODE_DEBUG_ACPU(data)                             (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FCODE_DEBUG_ACPU_src(data)                         ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_get_FCODE_DEBUG_ACPU(data)                         ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP0                                                         0x5E0
+#define SYS_PLL_SSC_DIG_EDP0_reg_addr                                                "0x980005E0"
+#define SYS_PLL_SSC_DIG_EDP0_reg                                                     0x980005E0
+#define set_SYS_PLL_SSC_DIG_EDP0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP0_reg))
+#define SYS_PLL_SSC_DIG_EDP0_inst_adr                                                "0x0078"
+#define SYS_PLL_SSC_DIG_EDP0_inst                                                    0x0078
+#define SYS_PLL_SSC_DIG_EDP0_REG_CKSSC_INV_EDP_shift                                 (4)
+#define SYS_PLL_SSC_DIG_EDP0_REG_CKSSC_INV_EDP_mask                                  (0x00000010)
+#define SYS_PLL_SSC_DIG_EDP0_REG_CKSSC_INV_EDP(data)                                 (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_EDP0_REG_CKSSC_INV_EDP_src(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_EDP0_get_REG_CKSSC_INV_EDP(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_EDP0_REG_GRAN_AUTO_RST_EDP_shift                             (3)
+#define SYS_PLL_SSC_DIG_EDP0_REG_GRAN_AUTO_RST_EDP_mask                              (0x00000008)
+#define SYS_PLL_SSC_DIG_EDP0_REG_GRAN_AUTO_RST_EDP(data)                             (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_EDP0_REG_GRAN_AUTO_RST_EDP_src(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_EDP0_get_REG_GRAN_AUTO_RST_EDP(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_EDP0_RSTB_EDP_shift                                          (2)
+#define SYS_PLL_SSC_DIG_EDP0_RSTB_EDP_mask                                           (0x00000004)
+#define SYS_PLL_SSC_DIG_EDP0_RSTB_EDP(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_EDP0_RSTB_EDP_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_EDP0_get_RSTB_EDP(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_EDP0_EN_SSC_EDP_shift                                        (1)
+#define SYS_PLL_SSC_DIG_EDP0_EN_SSC_EDP_mask                                         (0x00000002)
+#define SYS_PLL_SSC_DIG_EDP0_EN_SSC_EDP(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_EDP0_EN_SSC_EDP_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_EDP0_get_EN_SSC_EDP(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_EDP0_OC_EN_EDP_shift                                         (0)
+#define SYS_PLL_SSC_DIG_EDP0_OC_EN_EDP_mask                                          (0x00000001)
+#define SYS_PLL_SSC_DIG_EDP0_OC_EN_EDP(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP0_OC_EN_EDP_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP0_get_OC_EN_EDP(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP1                                                         0x5E4
+#define SYS_PLL_SSC_DIG_EDP1_reg_addr                                                "0x980005E4"
+#define SYS_PLL_SSC_DIG_EDP1_reg                                                     0x980005E4
+#define set_SYS_PLL_SSC_DIG_EDP1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP1_reg))
+#define SYS_PLL_SSC_DIG_EDP1_inst_adr                                                "0x0079"
+#define SYS_PLL_SSC_DIG_EDP1_inst                                                    0x0079
+#define SYS_PLL_SSC_DIG_EDP1_NCODE_T_EDP_shift                                       (11)
+#define SYS_PLL_SSC_DIG_EDP1_NCODE_T_EDP_mask                                        (0x0007F800)
+#define SYS_PLL_SSC_DIG_EDP1_NCODE_T_EDP(data)                                       (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_EDP1_NCODE_T_EDP_src(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP1_get_NCODE_T_EDP(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP1_FCODE_T_EDP_shift                                       (0)
+#define SYS_PLL_SSC_DIG_EDP1_FCODE_T_EDP_mask                                        (0x000007FF)
+#define SYS_PLL_SSC_DIG_EDP1_FCODE_T_EDP(data)                                       (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP1_FCODE_T_EDP_src(data)                                   ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP1_get_FCODE_T_EDP(data)                                   ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP2                                                         0x5E8
+#define SYS_PLL_SSC_DIG_EDP2_reg_addr                                                "0x980005E8"
+#define SYS_PLL_SSC_DIG_EDP2_reg                                                     0x980005E8
+#define set_SYS_PLL_SSC_DIG_EDP2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP2_reg))
+#define SYS_PLL_SSC_DIG_EDP2_inst_adr                                                "0x007A"
+#define SYS_PLL_SSC_DIG_EDP2_inst                                                    0x007A
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_DIVN_shift                                   (27)
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_DIVN_mask                                    (0x08000000)
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_DIVN(data)                                   (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_DIVN_src(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_BYPASS_DIVN(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_STEP_SET_EDP_shift                               (17)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_STEP_SET_EDP_mask                                (0x07FE0000)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_STEP_SET_EDP(data)                               (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_STEP_SET_EDP_src(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_OC_STEP_SET_EDP(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SEL_OC_MODE_EDP_shift                               (15)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SEL_OC_MODE_EDP_mask                                (0x00018000)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SEL_OC_MODE_EDP(data)                               (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_EDP2_REG_SEL_OC_MODE_EDP_src(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_SEL_OC_MODE_EDP(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_EDP2_REG_HS_OC_STOP_DIFF_EDP_shift                           (13)
+#define SYS_PLL_SSC_DIG_EDP2_REG_HS_OC_STOP_DIFF_EDP_mask                            (0x00006000)
+#define SYS_PLL_SSC_DIG_EDP2_REG_HS_OC_STOP_DIFF_EDP(data)                           (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_EDP2_REG_HS_OC_STOP_DIFF_EDP_src(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_HS_OC_STOP_DIFF_EDP(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_DONE_DELAY_EDP_shift                             (7)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_DONE_DELAY_EDP_mask                              (0x00001F80)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_DONE_DELAY_EDP(data)                             (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_DONE_DELAY_EDP_src(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_OC_DONE_DELAY_EDP(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_EDP2_REG_PI_CUR_SEL_EDP_shift                                (5)
+#define SYS_PLL_SSC_DIG_EDP2_REG_PI_CUR_SEL_EDP_mask                                 (0x00000060)
+#define SYS_PLL_SSC_DIG_EDP2_REG_PI_CUR_SEL_EDP(data)                                (0x00000060&((data)<<5))
+#define SYS_PLL_SSC_DIG_EDP2_REG_PI_CUR_SEL_EDP_src(data)                            ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_PI_CUR_SEL_EDP(data)                            ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_PI_EDP_shift                                 (4)
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_PI_EDP_mask                                  (0x00000010)
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_PI_EDP(data)                                 (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_PI_EDP_src(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_BYPASS_PI_EDP(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SDM_ORDER_EDP_shift                                 (3)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SDM_ORDER_EDP_mask                                  (0x00000008)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SDM_ORDER_EDP(data)                                 (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_EDP2_REG_SDM_ORDER_EDP_src(data)                             ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_SDM_ORDER_EDP(data)                             ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_EDP2_REG_EN_PI_DEBUG_EDP_shift                               (2)
+#define SYS_PLL_SSC_DIG_EDP2_REG_EN_PI_DEBUG_EDP_mask                                (0x00000004)
+#define SYS_PLL_SSC_DIG_EDP2_REG_EN_PI_DEBUG_EDP(data)                               (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_EDP2_REG_EN_PI_DEBUG_EDP_src(data)                           ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_EN_PI_DEBUG_EDP(data)                           ((0x00000004&(data))>>2)
+
+
+#define SYS_PLL_SSC_DIG_EDP3                                                         0x5EC
+#define SYS_PLL_SSC_DIG_EDP3_reg_addr                                                "0x980005EC"
+#define SYS_PLL_SSC_DIG_EDP3_reg                                                     0x980005EC
+#define set_SYS_PLL_SSC_DIG_EDP3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP3_reg))
+#define SYS_PLL_SSC_DIG_EDP3_inst_adr                                                "0x007B"
+#define SYS_PLL_SSC_DIG_EDP3_inst                                                    0x007B
+#define SYS_PLL_SSC_DIG_EDP3_NCODE_SSC_EDP_shift                                     (11)
+#define SYS_PLL_SSC_DIG_EDP3_NCODE_SSC_EDP_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_EDP3_NCODE_SSC_EDP(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_EDP3_NCODE_SSC_EDP_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP3_get_NCODE_SSC_EDP(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP3_FCODE_SSC_EDP_shift                                     (0)
+#define SYS_PLL_SSC_DIG_EDP3_FCODE_SSC_EDP_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_EDP3_FCODE_SSC_EDP(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP3_FCODE_SSC_EDP_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP3_get_FCODE_SSC_EDP(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP4                                                         0x5F0
+#define SYS_PLL_SSC_DIG_EDP4_reg_addr                                                "0x980005F0"
+#define SYS_PLL_SSC_DIG_EDP4_reg                                                     0x980005F0
+#define set_SYS_PLL_SSC_DIG_EDP4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP4_reg))
+#define SYS_PLL_SSC_DIG_EDP4_inst_adr                                                "0x007C"
+#define SYS_PLL_SSC_DIG_EDP4_inst                                                    0x007C
+#define SYS_PLL_SSC_DIG_EDP4_GRAN_EST_EDP_shift                                      (0)
+#define SYS_PLL_SSC_DIG_EDP4_GRAN_EST_EDP_mask                                       (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_EDP4_GRAN_EST_EDP(data)                                      (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP4_GRAN_EST_EDP_src(data)                                  ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP4_get_GRAN_EST_EDP(data)                                  ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP5                                                         0x5F4
+#define SYS_PLL_SSC_DIG_EDP5_reg_addr                                                "0x980005F4"
+#define SYS_PLL_SSC_DIG_EDP5_reg                                                     0x980005F4
+#define set_SYS_PLL_SSC_DIG_EDP5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP5_reg))
+#define SYS_PLL_SSC_DIG_EDP5_inst_adr                                                "0x007D"
+#define SYS_PLL_SSC_DIG_EDP5_inst                                                    0x007D
+#define SYS_PLL_SSC_DIG_EDP5_FCW_SSC_DEFAULT_EDP_shift                               (0)
+#define SYS_PLL_SSC_DIG_EDP5_FCW_SSC_DEFAULT_EDP_mask                                (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_EDP5_FCW_SSC_DEFAULT_EDP(data)                               (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP5_FCW_SSC_DEFAULT_EDP_src(data)                           ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP5_get_FCW_SSC_DEFAULT_EDP(data)                           ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP_DBG1                                                     0x5F8
+#define SYS_PLL_SSC_DIG_EDP_DBG1_reg_addr                                            "0x980005F8"
+#define SYS_PLL_SSC_DIG_EDP_DBG1_reg                                                 0x980005F8
+#define set_SYS_PLL_SSC_DIG_EDP_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP_DBG1_reg))
+#define SYS_PLL_SSC_DIG_EDP_DBG1_inst_adr                                            "0x007E"
+#define SYS_PLL_SSC_DIG_EDP_DBG1_inst                                                0x007E
+#define SYS_PLL_SSC_DIG_EDP_DBG1_LOOP_PI_ISEL_EDP_shift                              (14)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_LOOP_PI_ISEL_EDP_mask                               (0x0000C000)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_LOOP_PI_ISEL_EDP(data)                              (0x0000C000&((data)<<14))
+#define SYS_PLL_SSC_DIG_EDP_DBG1_LOOP_PI_ISEL_EDP_src(data)                          ((0x0000C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_get_LOOP_PI_ISEL_EDP(data)                          ((0x0000C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_PHSEL_EDP_shift                                     (8)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_PHSEL_EDP_mask                                      (0x00003F00)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_PHSEL_EDP(data)                                     (0x00003F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_EDP_DBG1_PHSEL_EDP_src(data)                                 ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_get_PHSEL_EDP(data)                                 ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_DIVN_EDP_shift                                      (0)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_DIVN_EDP_mask                                       (0x000000FF)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_DIVN_EDP(data)                                      (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP_DBG1_DIVN_EDP_src(data)                                  ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_get_DIVN_EDP(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP_DBG2                                                     0x5FC
+#define SYS_PLL_SSC_DIG_EDP_DBG2_reg_addr                                            "0x980005FC"
+#define SYS_PLL_SSC_DIG_EDP_DBG2_reg                                                 0x980005FC
+#define set_SYS_PLL_SSC_DIG_EDP_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP_DBG2_reg))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_inst_adr                                            "0x007F"
+#define SYS_PLL_SSC_DIG_EDP_DBG2_inst                                                0x007F
+#define SYS_PLL_SSC_DIG_EDP_DBG2_load_FCW_EDP_shift                                  (21)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_load_FCW_EDP_mask                                   (0x00200000)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_load_FCW_EDP(data)                                  (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_load_FCW_EDP_src(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_get_load_FCW_EDP(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_OC_DONE_EDP_shift                                   (20)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_OC_DONE_EDP_mask                                    (0x00100000)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_OC_DONE_EDP(data)                                   (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_OC_DONE_EDP_src(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_get_OC_DONE_EDP(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FMOD_EDP_shift                                      (19)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FMOD_EDP_mask                                       (0x00080000)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FMOD_EDP(data)                                      (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FMOD_EDP_src(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_get_FMOD_EDP(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_NCODE_DEBUG_EDP_shift                               (11)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_NCODE_DEBUG_EDP_mask                                (0x0007F800)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_NCODE_DEBUG_EDP(data)                               (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_NCODE_DEBUG_EDP_src(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_get_NCODE_DEBUG_EDP(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FCODE_DEBUG_EDP_shift                               (0)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FCODE_DEBUG_EDP_mask                                (0x000007FF)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FCODE_DEBUG_EDP(data)                               (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FCODE_DEBUG_EDP_src(data)                           ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_get_FCODE_DEBUG_EDP(data)                           ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL0                                                       0x600
+#define SYS_PLL_SSC_DIG_PIXEL0_reg_addr                                              "0x98000600"
+#define SYS_PLL_SSC_DIG_PIXEL0_reg                                                   0x98000600
+#define set_SYS_PLL_SSC_DIG_PIXEL0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL0_reg))
+#define SYS_PLL_SSC_DIG_PIXEL0_inst_adr                                              "0x0080"
+#define SYS_PLL_SSC_DIG_PIXEL0_inst                                                  0x0080
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_CKSSC_INV_PIXEL_shift                             (4)
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_CKSSC_INV_PIXEL_mask                              (0x00000010)
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_CKSSC_INV_PIXEL(data)                             (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_CKSSC_INV_PIXEL_src(data)                         ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_PIXEL0_get_REG_CKSSC_INV_PIXEL(data)                         ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_GRAN_AUTO_RST_PIXEL_shift                         (3)
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_GRAN_AUTO_RST_PIXEL_mask                          (0x00000008)
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_GRAN_AUTO_RST_PIXEL(data)                         (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_GRAN_AUTO_RST_PIXEL_src(data)                     ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_PIXEL0_get_REG_GRAN_AUTO_RST_PIXEL(data)                     ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_PIXEL0_RSTB_PIXEL_shift                                      (2)
+#define SYS_PLL_SSC_DIG_PIXEL0_RSTB_PIXEL_mask                                       (0x00000004)
+#define SYS_PLL_SSC_DIG_PIXEL0_RSTB_PIXEL(data)                                      (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_PIXEL0_RSTB_PIXEL_src(data)                                  ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_PIXEL0_get_RSTB_PIXEL(data)                                  ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_PIXEL0_EN_SSC_PIXEL_shift                                    (1)
+#define SYS_PLL_SSC_DIG_PIXEL0_EN_SSC_PIXEL_mask                                     (0x00000002)
+#define SYS_PLL_SSC_DIG_PIXEL0_EN_SSC_PIXEL(data)                                    (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_PIXEL0_EN_SSC_PIXEL_src(data)                                ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_PIXEL0_get_EN_SSC_PIXEL(data)                                ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_PIXEL0_OC_EN_PIXEL_shift                                     (0)
+#define SYS_PLL_SSC_DIG_PIXEL0_OC_EN_PIXEL_mask                                      (0x00000001)
+#define SYS_PLL_SSC_DIG_PIXEL0_OC_EN_PIXEL(data)                                     (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL0_OC_EN_PIXEL_src(data)                                 ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL0_get_OC_EN_PIXEL(data)                                 ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL1                                                       0x604
+#define SYS_PLL_SSC_DIG_PIXEL1_reg_addr                                              "0x98000604"
+#define SYS_PLL_SSC_DIG_PIXEL1_reg                                                   0x98000604
+#define set_SYS_PLL_SSC_DIG_PIXEL1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL1_reg))
+#define SYS_PLL_SSC_DIG_PIXEL1_inst_adr                                              "0x0081"
+#define SYS_PLL_SSC_DIG_PIXEL1_inst                                                  0x0081
+#define SYS_PLL_SSC_DIG_PIXEL1_NCODE_T_PIXEL_shift                                   (11)
+#define SYS_PLL_SSC_DIG_PIXEL1_NCODE_T_PIXEL_mask                                    (0x0007F800)
+#define SYS_PLL_SSC_DIG_PIXEL1_NCODE_T_PIXEL(data)                                   (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_PIXEL1_NCODE_T_PIXEL_src(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL1_get_NCODE_T_PIXEL(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL1_FCODE_T_PIXEL_shift                                   (0)
+#define SYS_PLL_SSC_DIG_PIXEL1_FCODE_T_PIXEL_mask                                    (0x000007FF)
+#define SYS_PLL_SSC_DIG_PIXEL1_FCODE_T_PIXEL(data)                                   (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL1_FCODE_T_PIXEL_src(data)                               ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL1_get_FCODE_T_PIXEL(data)                               ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL2                                                       0x608
+#define SYS_PLL_SSC_DIG_PIXEL2_reg_addr                                              "0x98000608"
+#define SYS_PLL_SSC_DIG_PIXEL2_reg                                                   0x98000608
+#define set_SYS_PLL_SSC_DIG_PIXEL2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL2_reg))
+#define SYS_PLL_SSC_DIG_PIXEL2_inst_adr                                              "0x0082"
+#define SYS_PLL_SSC_DIG_PIXEL2_inst                                                  0x0082
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_DIVN_shift                                 (27)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_DIVN_mask                                  (0x08000000)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_DIVN(data)                                 (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_DIVN_src(data)                             ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_BYPASS_DIVN(data)                             ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_STEP_SET_PIXEL_shift                           (17)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_STEP_SET_PIXEL_mask                            (0x07FE0000)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_STEP_SET_PIXEL(data)                           (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_STEP_SET_PIXEL_src(data)                       ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_OC_STEP_SET_PIXEL(data)                       ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SEL_OC_MODE_PIXEL_shift                           (15)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SEL_OC_MODE_PIXEL_mask                            (0x00018000)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SEL_OC_MODE_PIXEL(data)                           (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SEL_OC_MODE_PIXEL_src(data)                       ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_SEL_OC_MODE_PIXEL(data)                       ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_HS_OC_STOP_DIFF_PIXEL_shift                       (13)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_HS_OC_STOP_DIFF_PIXEL_mask                        (0x00006000)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_HS_OC_STOP_DIFF_PIXEL(data)                       (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_HS_OC_STOP_DIFF_PIXEL_src(data)                   ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_HS_OC_STOP_DIFF_PIXEL(data)                   ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_DONE_DELAY_PIXEL_shift                         (7)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_DONE_DELAY_PIXEL_mask                          (0x00001F80)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_DONE_DELAY_PIXEL(data)                         (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_DONE_DELAY_PIXEL_src(data)                     ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_OC_DONE_DELAY_PIXEL(data)                     ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_PI_CUR_SEL_PIXEL_shift                            (5)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_PI_CUR_SEL_PIXEL_mask                             (0x00000060)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_PI_CUR_SEL_PIXEL(data)                            (0x00000060&((data)<<5))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_PI_CUR_SEL_PIXEL_src(data)                        ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_PI_CUR_SEL_PIXEL(data)                        ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_PI_PIXEL_shift                             (4)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_PI_PIXEL_mask                              (0x00000010)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_PI_PIXEL(data)                             (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_PI_PIXEL_src(data)                         ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_BYPASS_PI_PIXEL(data)                         ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SDM_ORDER_PIXEL_shift                             (3)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SDM_ORDER_PIXEL_mask                              (0x00000008)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SDM_ORDER_PIXEL(data)                             (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SDM_ORDER_PIXEL_src(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_SDM_ORDER_PIXEL(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_EN_PI_DEBUG_PIXEL_shift                           (2)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_EN_PI_DEBUG_PIXEL_mask                            (0x00000004)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_EN_PI_DEBUG_PIXEL(data)                           (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_EN_PI_DEBUG_PIXEL_src(data)                       ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_EN_PI_DEBUG_PIXEL(data)                       ((0x00000004&(data))>>2)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL3                                                       0x60C
+#define SYS_PLL_SSC_DIG_PIXEL3_reg_addr                                              "0x9800060C"
+#define SYS_PLL_SSC_DIG_PIXEL3_reg                                                   0x9800060C
+#define set_SYS_PLL_SSC_DIG_PIXEL3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL3_reg))
+#define SYS_PLL_SSC_DIG_PIXEL3_inst_adr                                              "0x0083"
+#define SYS_PLL_SSC_DIG_PIXEL3_inst                                                  0x0083
+#define SYS_PLL_SSC_DIG_PIXEL3_NCODE_SSC_PIXEL_shift                                 (11)
+#define SYS_PLL_SSC_DIG_PIXEL3_NCODE_SSC_PIXEL_mask                                  (0x0007F800)
+#define SYS_PLL_SSC_DIG_PIXEL3_NCODE_SSC_PIXEL(data)                                 (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_PIXEL3_NCODE_SSC_PIXEL_src(data)                             ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL3_get_NCODE_SSC_PIXEL(data)                             ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL3_FCODE_SSC_PIXEL_shift                                 (0)
+#define SYS_PLL_SSC_DIG_PIXEL3_FCODE_SSC_PIXEL_mask                                  (0x000007FF)
+#define SYS_PLL_SSC_DIG_PIXEL3_FCODE_SSC_PIXEL(data)                                 (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL3_FCODE_SSC_PIXEL_src(data)                             ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL3_get_FCODE_SSC_PIXEL(data)                             ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL4                                                       0x610
+#define SYS_PLL_SSC_DIG_PIXEL4_reg_addr                                              "0x98000610"
+#define SYS_PLL_SSC_DIG_PIXEL4_reg                                                   0x98000610
+#define set_SYS_PLL_SSC_DIG_PIXEL4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL4_reg))
+#define SYS_PLL_SSC_DIG_PIXEL4_inst_adr                                              "0x0084"
+#define SYS_PLL_SSC_DIG_PIXEL4_inst                                                  0x0084
+#define SYS_PLL_SSC_DIG_PIXEL4_GRAN_EST_PIXEL_shift                                  (0)
+#define SYS_PLL_SSC_DIG_PIXEL4_GRAN_EST_PIXEL_mask                                   (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_PIXEL4_GRAN_EST_PIXEL(data)                                  (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL4_GRAN_EST_PIXEL_src(data)                              ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL4_get_GRAN_EST_PIXEL(data)                              ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL5                                                       0x614
+#define SYS_PLL_SSC_DIG_PIXEL5_reg_addr                                              "0x98000614"
+#define SYS_PLL_SSC_DIG_PIXEL5_reg                                                   0x98000614
+#define set_SYS_PLL_SSC_DIG_PIXEL5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL5_reg))
+#define SYS_PLL_SSC_DIG_PIXEL5_inst_adr                                              "0x0085"
+#define SYS_PLL_SSC_DIG_PIXEL5_inst                                                  0x0085
+#define SYS_PLL_SSC_DIG_PIXEL5_FCW_SSC_DEFAULT_PIXEL_shift                           (0)
+#define SYS_PLL_SSC_DIG_PIXEL5_FCW_SSC_DEFAULT_PIXEL_mask                            (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_PIXEL5_FCW_SSC_DEFAULT_PIXEL(data)                           (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL5_FCW_SSC_DEFAULT_PIXEL_src(data)                       ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL5_get_FCW_SSC_DEFAULT_PIXEL(data)                       ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1                                                   0x618
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_reg_addr                                          "0x98000618"
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_reg                                               0x98000618
+#define set_SYS_PLL_SSC_DIG_PIXEL_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL_DBG1_reg))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_inst_adr                                          "0x0086"
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_inst                                              0x0086
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_LOOP_PI_ISEL_PIXEL_shift                          (14)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_LOOP_PI_ISEL_PIXEL_mask                           (0x0000C000)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_LOOP_PI_ISEL_PIXEL(data)                          (0x0000C000&((data)<<14))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_LOOP_PI_ISEL_PIXEL_src(data)                      ((0x0000C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_get_LOOP_PI_ISEL_PIXEL(data)                      ((0x0000C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_PHSEL_PIXEL_shift                                 (8)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_PHSEL_PIXEL_mask                                  (0x00003F00)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_PHSEL_PIXEL(data)                                 (0x00003F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_PHSEL_PIXEL_src(data)                             ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_get_PHSEL_PIXEL(data)                             ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_DIVN_PIXEL_shift                                  (0)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_DIVN_PIXEL_mask                                   (0x000000FF)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_DIVN_PIXEL(data)                                  (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_DIVN_PIXEL_src(data)                              ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_get_DIVN_PIXEL(data)                              ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2                                                   0x61C
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_reg_addr                                          "0x9800061C"
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_reg                                               0x9800061C
+#define set_SYS_PLL_SSC_DIG_PIXEL_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL_DBG2_reg))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_inst_adr                                          "0x0087"
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_inst                                              0x0087
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_load_FCW_PIXEL_shift                              (21)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_load_FCW_PIXEL_mask                               (0x00200000)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_load_FCW_PIXEL(data)                              (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_load_FCW_PIXEL_src(data)                          ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_get_load_FCW_PIXEL(data)                          ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_OC_DONE_PIXEL_shift                               (20)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_OC_DONE_PIXEL_mask                                (0x00100000)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_OC_DONE_PIXEL(data)                               (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_OC_DONE_PIXEL_src(data)                           ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_get_OC_DONE_PIXEL(data)                           ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FMOD_PIXEL_shift                                  (19)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FMOD_PIXEL_mask                                   (0x00080000)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FMOD_PIXEL(data)                                  (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FMOD_PIXEL_src(data)                              ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_get_FMOD_PIXEL(data)                              ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_NCODE_DEBUG_PIXEL_shift                           (11)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_NCODE_DEBUG_PIXEL_mask                            (0x0007F800)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_NCODE_DEBUG_PIXEL(data)                           (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_NCODE_DEBUG_PIXEL_src(data)                       ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_get_NCODE_DEBUG_PIXEL(data)                       ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FCODE_DEBUG_PIXEL_shift                           (0)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FCODE_DEBUG_PIXEL_mask                            (0x000007FF)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FCODE_DEBUG_PIXEL(data)                           (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FCODE_DEBUG_PIXEL_src(data)                       ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_get_FCODE_DEBUG_PIXEL(data)                       ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD6                                                             0x620
+#define SYS_PLL_HDMI_SD6_reg_addr                                                    "0x98000620"
+#define SYS_PLL_HDMI_SD6_reg                                                         0x98000620
+#define set_SYS_PLL_HDMI_SD6_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD6_reg)=data)
+#define get_SYS_PLL_HDMI_SD6_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD6_reg))
+#define SYS_PLL_HDMI_SD6_inst_adr                                                    "0x0088"
+#define SYS_PLL_HDMI_SD6_inst                                                        0x0088
+#define SYS_PLL_HDMI_SD6_REG_BYPASS_DIVN_shift                                       (19)
+#define SYS_PLL_HDMI_SD6_REG_BYPASS_DIVN_mask                                        (0x00080000)
+#define SYS_PLL_HDMI_SD6_REG_BYPASS_DIVN(data)                                       (0x00080000&((data)<<19))
+#define SYS_PLL_HDMI_SD6_REG_BYPASS_DIVN_src(data)                                   ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD6_get_REG_BYPASS_DIVN(data)                                   ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD6_FCW_SSC_DEFAULT_HDMITX_shift                                (0)
+#define SYS_PLL_HDMI_SD6_FCW_SSC_DEFAULT_HDMITX_mask                                 (0x0007FFFF)
+#define SYS_PLL_HDMI_SD6_FCW_SSC_DEFAULT_HDMITX(data)                                (0x0007FFFF&((data)<<0))
+#define SYS_PLL_HDMI_SD6_FCW_SSC_DEFAULT_HDMITX_src(data)                            ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_HDMI_SD6_get_FCW_SSC_DEFAULT_HDMITX(data)                            ((0x0007FFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx.h b/drivers/media/platform/rtk_hdmitx/hdmitx.h
new file mode 100644
index 00000000..a20f91f
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx.h
@@ -0,0 +1,472 @@
+/*
+ * hdmitx.h - RTK hdmitx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDMITX_H_
+#define _HDMITX_H_
+
+#include <drm/drm_edid.h>
+#include <drm/drm_crtc.h>
+#include <linux/types.h>
+#include <linux/workqueue.h>
+
+#include "hdmitx_rpc.h"
+
+#define __RTK_HDMI_GENERIC_DEBUG__  0
+#define HDMI_RX_SENSE_SUPPORT 0
+
+#if __RTK_HDMI_GENERIC_DEBUG__
+#define HDMI_DEBUG(format, ...) printk("[HDMITx_DBG] " format "\n", ## __VA_ARGS__)
+#else
+#define HDMI_DEBUG(format, ...)
+#endif
+
+#define HDMI_ERROR(format, ...) printk(KERN_ERR "[HDMITx_ERR] " format "\n", ## __VA_ARGS__)
+#define HDMI_INFO(format, ...) printk(KERN_WARNING "[HDMITx] " format "\n", ## __VA_ARGS__)
+
+#define wr_reg(x, y)                    writel(y, (volatile unsigned int*)(x))
+#define rd_reg(x)                       readl((volatile unsigned int*)(x))
+
+#define field_get(val, start, end) 		(((val) & field_mask(start, end)) >> (end))
+#define field_mask(start, end)          (((1 << (start - end + 1)) - 1) << (end))
+#define setbits(base, offset, Mask)     wr_reg((base+offset), (rd_reg(base+offset) | Mask))
+#define readbits(value, Mask)           ((value >> (Mask)) & 0x1)
+#define clearbits(base, offset, Mask)	wr_reg((base+offset), (rd_reg(base+offset) & ~(Mask)))
+
+#define WR_REG_32(base, offset, val)    writel(val, (volatile unsigned int*)(base + offset))
+#define RD_REG_32(base, offset)         readl((volatile unsigned int*)(base + offset))
+
+#define FLD_GET(val, start, end) (((val) & FLD_MASK(start, end)) >> (end))
+#define FLD_MASK(start, end)    (((1 << (start - end + 1)) - 1) << (end))
+#define SETBITS(base, offset, Mask) WR_REG_32(base, offset, (RD_REG_32(base, offset) | Mask))
+#define READBITS(value, Mask) ((value >> (Mask)) & 0x1)
+#define CLEARBITS(base, offset, Mask) WR_REG_32(base, offset, ((RD_REG_32(base, offset) & ~(Mask))))
+#define MASK_REG_32(base, offset, andMask, orMask) WR_REG_32(base, offset, ((RD_REG_32(base, offset) & (andMask)) | (orMask)))
+
+
+#define MAX_ELD_BYTES	128
+
+#define MAX_3D_VIC	16
+#define MAX_SPEC_3D	18
+
+
+enum HDMI_MODE {
+	HDMI_MODE_UNDEF = 0,
+	HDMI_MODE_HDMI = 1,
+	HDMI_MODE_DVI = 2,
+	HDMI_MODE_MHL = 3,
+	HDMI_MODE_MAX
+};
+
+enum TMDS_MODE {
+	TMDS_MODE_UNKNOW = 0,
+	TMDS_HDMI_DISABLED = 1,
+	TMDS_HDMI_ENABLED = 2,
+	TMDS_MHL_ENABLED = 3,
+	TMDS_MODE_MAX
+};
+
+enum HDMI_EXTENDED_MODE {
+	EXTENDED_MODE_RESERVED = 0,
+	EXTENDED_MODE_3840_2160_30HZ = 1,
+	EXTENDED_MODE_3840_2160_25HZ = 2,
+	EXTENDED_MODE_3840_2160_24HZ = 3,
+	EXTENDED_MODE_4096_2160_24HZ = 4,
+	EXTENDED_MODE_MAX
+};
+
+/* HDMI Forum Vendor Specific Data Block Byte6 */
+enum SCDC_CAPABLES {
+	SCDC_PRESENT = 0x80, /* Bit7 */
+	SCDC_RR_CAPABLE = 0x40, /* Bit6*/
+	SCDC_340M_SCRAMBLE = 0x08, /* Bit3 */
+};
+
+#define RTK_EDID_DIGITAL_DEPTH_6       (1 << 0)
+#define RTK_EDID_DIGITAL_DEPTH_8       (1 << 1)
+#define RTK_EDID_DIGITAL_DEPTH_10      (1 << 2)
+#define RTK_EDID_DIGITAL_DEPTH_12      (1 << 3)
+#define RTK_EDID_DIGITAL_DEPTH_14      (1 << 4)
+#define RTK_EDID_DIGITAL_DEPTH_16      (1 << 5)
+
+struct raw_edid {
+	unsigned char edid_data[256];
+};
+
+/**
+ * struct Audio_desc - Audio descriptor for audio format
+ * @coding_type: Audio format code
+ * @channel_count: Max number of channels
+ * @sample_freq_all: Bit6[192KHz]/[176.4KHz]/[96KHz]/[88.2KHz]/[48KHz]/[44.1KHz]/Bit0[32KHz]
+ * @sample_size_all: For Audio Format Code 1(L-PCM)
+ * @max_bit_rate_divided_by_8KHz: For Audio Format Code 2 to 8
+ */
+struct Audio_desc {
+	unsigned char	coding_type;
+	unsigned char	channel_count;
+	unsigned char	sample_freq_all;
+	unsigned char	sample_size_all;
+	unsigned char	max_bit_rate_divided_by_8KHz;
+} __attribute__ ((packed));
+
+struct Audio_Data {
+	/* Audio Data Block */
+	char ADB_length;
+	struct Audio_desc ADB[10];
+	/* Speaker Allocation Data Block */
+	char SADB_length;
+	unsigned char SADB[3];
+} __attribute__ ((packed));
+
+struct Specific_3D {
+	unsigned char vic;
+	unsigned char format;// 0:Frame packing, 6:Top-and-Bottom, 8:Side-by-Side(Half)
+} __attribute__ ((packed));
+
+struct Video_Display_Info {
+	/* Physical size */
+	unsigned int width_mm;
+	unsigned int height_mm;
+	unsigned int pixel_clock;
+	unsigned int bpc;
+	u32 color_formats;
+	u8 cea_rev;
+} __attribute__ ((packed));
+
+struct sink_capabilities_t {
+	unsigned int hdmi_mode;
+	unsigned int est_modes;
+
+	/* Audio */
+	unsigned char eld[MAX_ELD_BYTES];
+	struct Audio_Data audio_data;
+
+	/* Vendor-Specific Data Block(VSDB) */
+	unsigned char cec_phy_addr[2];
+	bool support_AI; /* needs info from ACP or ISRC packets */
+	bool DC_Y444; /* 4:4:4 in deep color modes */
+	unsigned char color_space;
+	bool dvi_dual; /* DVI Dual Link Operation */
+	int max_tmds_clock;	/* in MHz */
+	bool latency_present[2];
+	unsigned char video_latency[2];	/* [0]: progressive, [1]: interlaced */
+	unsigned char audio_latency[2];
+
+	/* 3D */
+	bool _3D_present;
+	__u16 structure_all;
+	unsigned char _3D_vic[MAX_3D_VIC];
+	struct Specific_3D spec_3d[MAX_SPEC_3D];
+
+	/* Video */
+	struct Video_Display_Info display_info;
+	__u64 vic;/* VIC 1~64, BIT0=VIC1 */
+	unsigned char extended_vic;
+	__u64 vic2;//VIC 65~128, BIT0=VIC65
+	__u64 vic2_420;//YCbCr420 format, VIC 65~128, BIT0=VIC65
+	struct VIDEO_RPC_VOUT_EDID_DATA vout_edid_data;
+} __attribute__ ((packed));
+
+struct edid_information {
+	/* ----- Base Block 128 Bytes Begin ----- */
+	u8 header[8];
+	/* Vendor & product info */
+	u8 mfg_id[2];
+	u8 prod_code[2];
+	u32 serial; /* FIXME: byte order */
+	u8 mfg_week;
+	u8 mfg_year;
+	/* EDID version */
+	u8 version;
+	u8 revision;
+	/* Display info: */
+	u8 input;
+	u8 width_cm;
+	u8 height_cm;
+	u8 gamma;
+	u8 features;
+	/* Color characteristics */
+	u8 red_green_lo;
+	u8 black_white_lo;
+	u8 red_x;
+	u8 red_y;
+	u8 green_x;
+	u8 green_y;
+	u8 blue_x;
+	u8 blue_y;
+	u8 white_x;
+	u8 white_y;
+	/* Est. timings and mfg rsvd timings*/
+	struct est_timings established_timings;
+	/* Standard timings 1-8*/
+	struct std_timing standard_timings[8];
+	/* Detailing timings 1-4 */
+	struct detailed_timing detailed_timings[4];
+	/* Number of 128 byte ext. blocks */
+	u8 extensions;
+	/* Checksum */
+	u8 checksum;
+	/* ----- Base Block 128 Bytes End ---- */
+
+	u32 hdmi_id;
+	u32 max_tmds_char_rate;
+	u8 colorimetry;
+	u8 scdc_capable;
+	u8 dc_420;/* Deep Color420, [Bit2]DC_48bit_420;[Bit1]DC_36bit_420;[Bit0]:DC_30bit_420 */
+} __attribute__((packed));
+
+/**
+ * struct hdmi_format_support - Color format and 3D support for specific VIC
+ * @vic: Video ID Code
+ * @rgb444: b'0-Support RGB444, b'1-RGB444/8bit, b'2-RGB444/10bit, b'3-RGB444/12bit
+ * @yuv422: b'0-Support YUV422, b'1-YUV422/8bit, b'2-YUV422/10bit, b'3-YUV422/12bit
+ * @yuv444: b'0-Support YUV444, b'1-YUV444/8bit, b'2-YUV444/10bit, b'3-YUV444/12bit
+ * @yuv420: b'0-Support YUV420, b'1-YUV420/8bit, b'2-YUV420/10bit, b'3-YUV420/12bit
+ * @support_3d: b'0-Support 3D, b'1-FramePacking, b'2-TopAndBottom, b'3-SideBySideHalf
+ * @support_fs: b'0-Support Frequency-Shift, b'1-Support FS 3D
+ */
+struct hdmi_format_support {
+	unsigned char vic;
+	unsigned char rgb444;
+	unsigned char yuv422;
+	unsigned char yuv444;
+	unsigned char yuv420;
+	unsigned char support_3d;
+	unsigned char support_fs;
+	unsigned char reserved;
+};
+
+struct hdmi_support_list {
+	struct hdmi_format_support tx_support[25];
+	unsigned int tx_support_size;
+};
+
+extern struct hdmi_format_support tx_support[25];
+extern unsigned char tx_support_size;
+
+enum HDMI_FORMAT_MODE {
+	FORMAT_MODE_OFF = 0,
+	FORMAT_MODE_DVI = 1,
+	FORMAT_MODE_HDMI = 2,
+};
+
+enum HDMI_VIDEO_ID_CODE {
+	VIC_720X480P60 = 2,
+	VIC_1280X720P60 = 4,
+	VIC_1920X1080I60 = 5,
+	VIC_720X480I60 = 6,
+	VIC_1920X1080P60 = 16,
+	VIC_720X576P50 = 17,
+	VIC_1280X720P50 = 19,
+	VIC_1920X1080I50 = 20,
+	VIC_720X576I50 = 21,
+	VIC_1920X1080P50 = 31,
+	VIC_1920X1080P24 = 32,
+	VIC_1920X1080P25 = 33,
+	VIC_1920X1080P30 = 34,
+	VIC_3840X2160P24 = 93,
+	VIC_3840X2160P25 = 94,
+	VIC_3840X2160P30 = 95,
+	VIC_3840X2160P50 = 96,
+	VIC_3840X2160P60 = 97,
+	VIC_4096X2160P24 = 98,
+	VIC_4096X2160P25 = 99,
+	VIC_4096X2160P30 = 100,
+	VIC_4096X2160P50 = 101,
+	VIC_4096X2160P60 = 102,
+};
+
+enum HDMI_COLOR_MODE {
+	COLOR_RGB = 0,
+	COLOR_YUV422 = 1,
+	COLOR_YUV444 = 2,
+	COLOR_YUV420 =3,
+};
+
+enum HDMI_3D_MODE {
+	FORMAT_3D_OFF = 0,
+	/* RTK player Frame Packing */
+	FORMAT_RTK_3D_FP = 1,
+	/* RTK player Side by side half */
+	FORMAT_RTK_3D_SS = 2,
+	/* RTK player Top and Buttom */
+	FORMAT_RTK_3D_TB = 3,
+	/* Frame Packing */
+	FORMAT_3D_FP = 4,
+	/* Side by side half */
+	FORMAT_3D_SS = 5,
+	/* Top and Buttom */
+	FORMAT_3D_TB = 6,
+};
+
+enum HDMI_HDR_MODE {
+	/* Control by AudioFW */
+	HDR_MODE_AUTO = 0,
+	/* Dolby Vision */
+	HDR_MODE_DV = 1,
+	/* HDR OFF */
+	HDR_MODE_SDR = 2,
+	HDR_MODE_GAMMA = 3,
+	/* HDR10 */
+	HDR_MODE_HDR10 = 4,
+	/* reserved future */
+	HDR_MODE_FUTURE = 5,
+	/* SDR/HDR by video */
+	HDR_MODE_INPUT = 6,
+	/* Dolby Vision, low latency */
+	HDR_MODE_DV_12B_YUV422 = 7,
+	HDR_MODE_DV_10B_YUV444 = 8,
+	HDR_MODE_DV_10B_RGB444 = 9,
+	HDR_MODE_DV_12B_YUV444 = 10,
+	HDR_MODE_DV_12B_RGB444 = 11,
+	/* Dolby Vision, RGB 8bit */
+	HDR_MODE_DV_ON_INPUT = 12,
+	HDR_MODE_DV_ON_LOW_LATENCY_12b422_INPUT = 13,
+};
+
+/**
+ * struct hdmi_format_setting - HDMI output format setting
+ * @mode: 0-OFF; 1-DVI; 2-HDMI
+ * @vic: Video ID code
+ * @freq_shift: 0-No freq shift, 1-set freq shift
+ * @color: enum HDMI_COLOR_MODE
+ * @color_depth: 8-8bit, 10-10bit, 12-12bit
+ * @_3d_format: enum HDMI_3D_MODE
+ * @hdr: enum HDMI_HDR_MODE
+ */
+struct hdmi_format_setting {
+	unsigned char mode;
+	unsigned char vic;
+	unsigned char freq_shift;
+	unsigned char color;
+	unsigned char color_depth;
+	unsigned char _3d_format;
+	unsigned char hdr;
+	unsigned char reserved;
+};
+
+typedef struct {
+	struct sink_capabilities_t sink_cap;
+	bool sink_cap_available;
+	unsigned char *edid_ptr;
+} asoc_hdmi_t;
+
+
+struct hdmitx_switch_data {
+	int	state;
+#if HDMI_RX_SENSE_SUPPORT
+	int hpd_state;
+#endif
+	unsigned int irq;
+	int pin;
+	struct work_struct work;
+};
+
+struct ext_edid {
+	int	extension;
+	int current_blk;
+	unsigned char data[2*EDID_LENGTH];
+};
+
+#define HDMI_IOCTL_MAGIC 0xf1
+#define HDMI_CHECK_LINK_STATUS			_IOR(HDMI_IOCTL_MAGIC, 2, int)
+#define HDMI_CHECK_Rx_Sense				_IOR(HDMI_IOCTL_MAGIC, 11, int)
+#define HDMI_GET_EXT_BLK_COUNT			_IOR(HDMI_IOCTL_MAGIC, 12, int)
+#define HDMI_GET_EXTENDED_EDID			_IOWR(HDMI_IOCTL_MAGIC, 13, struct ext_edid)
+#define HDMI_QUERY_DISPLAY_STANDARD		_IOR(HDMI_IOCTL_MAGIC, 14, int)
+#define HDMI_SEND_VOUT_EDID_DATA		_IOWR(HDMI_IOCTL_MAGIC, 15, struct VIDEO_RPC_VOUT_EDID_DATA)
+#define HDMI_GET_EDID_SUPPORT_LIST		_IOWR(HDMI_IOCTL_MAGIC, 16, struct hdmi_support_list)
+#define HDMI_SET_OUTPUT_FORMAT			_IOWR(HDMI_IOCTL_MAGIC, 17, struct hdmi_format_setting)
+#define HDMI_GET_OUTPUT_FORMAT			_IOWR(HDMI_IOCTL_MAGIC, 18, struct hdmi_format_setting)
+#define HDMI_SET_VO_INTERFACE_TYPE		_IOW(HDMI_IOCTL_MAGIC, 19, int)
+#define HDMI_GET_CONFIG_TV_SYSTEM		_IOR(HDMI_IOCTL_MAGIC, 20, struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM)
+
+
+#define HDMI_HOTPLUG_DETECTION			_IOWR(HDMI_IOCTL_MAGIC,21, int)
+#define HDMI_WAIT_HOTPLUG				_IOWR(HDMI_IOCTL_MAGIC,22, int)
+
+
+/* HDMI ioctl */
+enum {
+	HDMI_GET_SINK_CAPABILITY,
+	HDMI_GET_RAW_EDID,
+	HDMI_GET_LINK_STATUS,
+	HDMI_GET_VIDEO_CONFIG,
+	HDMI_SEND_AVMUTE,
+	HDMI_CONFIG_TV_SYSTEM,
+	HDMI_CONFIG_AVI_INFO,
+	HDMI_SET_FREQUNCY,
+	HDMI_SEND_AUDIO_MUTE,
+	HDMI_SEND_AUDIO_VSDB_DATA,
+	HDMI_SEND_AUDIO_EDID2,
+	HDMI_CHECK_TMDS_SRC,
+};
+
+enum HDMI_ERROR_CODE {
+	HDMI_ERROR_RESERVED = 0,
+	HDMI_ERROR_NO_MEMORY = 1,
+	HDMI_ERROR_I2C_ERROR = 2,
+	HDMI_ERROR_HPD = 3,
+	HDMI_ERROR_INVALID_EDID = 4,
+	HDMI_ERROR_MAX
+};
+
+enum HDMI_RX_SENSE_STATUS {
+	HDMI_RX_SENSE_OFF = 0,
+	HDMI_RX_SENSE_ON = 1,
+	HDMI_RX_SENSE_MAX
+};
+
+#define USE_ION_AUDIO_HEAP
+
+/* switch_hdmitx */
+int hdmitx_switch_get_state(void);
+#if HDMI_RX_SENSE_SUPPORT
+int hdmitx_switch_get_hpd(void);
+#endif
+
+/* hdmitx_info */
+ssize_t show_hdmitx_info(struct device *cd, struct device_attribute *attr, char *buf);
+ssize_t show_edid_info(struct device *cd, struct device_attribute *attr, char *buf);
+void register_hdmitx_sysfs(struct device *dev);
+unsigned char get_hpd_interlock(void);
+
+/* rtk_mute_gpio */
+void set_mute_gpio_pulse(void);
+#define I2S_OUT_ON 1
+#define I2S_OUT_OFF 0
+void set_i2s_output(int gpio_value);
+void setup_mute_gpio(struct device_node *dev);
+
+/* hdmitx_config */
+unsigned int gen_hdmi_format_support(struct hdmi_format_support *tx_support,
+	struct sink_capabilities_t *sink_cap,
+	struct edid_information *info);
+int tv_system_to_hdmi_format(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *tv_system,
+	struct hdmi_format_setting *format);
+int set_hdmitx_format(struct hdmi_format_setting *format);
+int get_hdmitx_format(struct hdmi_format_setting *format);
+void set_vo_interface_type(int type);
+
+
+#ifndef CONFIG_RTK_HDCP_1x
+void register_config_tv_system_sysfs(struct device *dev);
+#else
+#define register_config_tv_system_sysfs(...) (void)0
+#endif
+
+void register_support_list_sysfs(struct device *dev);
+
+#ifdef CONFIG_RTK_HDCP_1x_TEE
+extern void ta_hdcp14_init(void);
+extern int ta_hdcp_fix480p(void);
+#endif
+
+#endif /* _HDMITX_H_ */
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx_api.c b/drivers/media/platform/rtk_hdmitx/hdmitx_api.c
new file mode 100644
index 00000000..cfe0b26
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx_api.c
@@ -0,0 +1,1423 @@
+/*
+ * hdmitx_api.c - RTK hdmitx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/kernel.h>
+#include <linux/mutex.h>
+#include <linux/ioctl.h> /* needed for the _IOW etc stuff used later */
+#include <linux/syscalls.h> /* needed for the _IOW etc stuff used later */
+#include <linux/mpage.h>
+#include <linux/dcache.h>
+#include <linux/timer.h>
+#include <linux/workqueue.h>
+#include <sound/asound.h>
+#include <asm/cacheflush.h>
+#include <linux/slab.h>
+#include <linux/delay.h>
+
+#include <soc/realtek/power-control.h>
+#include <linux/reset.h>
+#include <linux/clk.h> /* clk_get */
+#include <linux/clk-provider.h>
+
+#include <soc/realtek/kernel-rpc.h>
+#include <linux/dma-mapping.h>
+#include "hdmitx_rpc.h"
+#include <dc2vo/dc_rpc.h>
+#include "hdmitx.h"
+#include "hdmitx_dev.h"
+#include "hdmitx_reg.h"
+#include "rtk_edid.h"
+#include "crt_reg.h"
+#include "hdmitx_scdc.h"
+
+
+#ifdef USE_ION_AUDIO_HEAP
+#include "uapi/ion.h"
+#include "ion/ion.h"
+#include "uapi/ion_rtk.h"
+
+struct ion_client *rpc_ion_client;
+extern struct ion_device *rtk_phoenix_ion_device;
+#endif
+
+extern hdmitx_device_t tx_dev;
+
+enum HDMI_AVMUTE {
+	HDMI_CLRAVM = 0,
+	HDMI_SETAVM
+};
+
+enum HDMI_CLK_STATE {
+	HDMI_CLK_OFF = 0,
+	HDMI_CLK_ON,
+	HDMI_CLK_PLL_ON
+};
+
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+#define CONVERT_FOR_AVCPU(x)		((unsigned int)(x) | 0xA0000000)
+#else
+#define CONVERT_FOR_AVCPU(x)		(x)
+#endif
+
+static int hdmi_error;
+unsigned int tmds_en = 0;
+unsigned int hdmi_clk_always_on = 0;
+unsigned int displayport_exist = 0;
+#if 1//__LINUX_MEDIA_NAS__
+static int hpdDetect = 0;
+#endif
+
+void hdmitx_print_sink_info(asoc_hdmi_t *p_this);
+
+int is_hdmi_clock_on(void)
+{
+	int ret_value;
+	void __iomem *vaddr;
+	unsigned char pll_hdmi;
+	struct clk *clk_hdmitx;
+	struct reset_control *reset_hdmitx;
+
+	vaddr = ioremap(0x98000190, 0x4);/* PLL_HDMI */
+	pll_hdmi = rd_reg(vaddr)&0xBF;
+	iounmap(vaddr);
+
+	clk_hdmitx = tx_dev.clk_hdmi;
+	reset_hdmitx = tx_dev.reset_hdmi;
+
+	if (__clk_is_enabled(clk_hdmitx) &&
+		(!reset_control_status(reset_hdmitx))) {
+
+		if (pll_hdmi == 0xBF)
+			ret_value = HDMI_CLK_PLL_ON;
+		else
+			ret_value = HDMI_CLK_ON;
+	} else {
+		ret_value = HDMI_CLK_OFF;
+	}
+
+	return ret_value;
+}
+
+u32 check_hdmi_mhl_mode(void)
+{
+	void __iomem *vaddr;
+	u32 ret;
+
+	vaddr = ioremap(SYS_DISP_PLL_DIV2_reg, 0x4);
+
+	/* 0: HDMI mode , 1:  MHL mode */
+	ret = SYS_DISP_PLL_DIV2_get_sel_pllhdmi_mhl(rd_reg(vaddr));
+	HDMI_INFO("Mode = %s", ret?"MHL":"HDMI");
+
+	iounmap(vaddr);
+	return ret;
+}
+
+int hdmitx_check_rx_sense(void __iomem *reg_base)
+{
+	u32 val;
+
+	val = HDMI_PHY_STATUS_get_Rxstatus(rd_reg(reg_base + HDMI_PHY_STATUS));
+
+	HDMI_DEBUG("RX status=%u", val);
+
+	if (val)
+		return HDMI_RX_SENSE_ON;
+	else
+		return HDMI_RX_SENSE_OFF;
+}
+
+int hdmitx_check_tmds_src(void __iomem *reg_base)
+{
+	u32 val;
+
+	if (tmds_en == 1) {
+		val = rd_reg(reg_base + HDMI_CR);
+		HDMI_INFO("CR=%x", val);
+
+		if (val == 0x15)
+			return TMDS_HDMI_ENABLED;
+		else if (val == 0x0)
+			return TMDS_HDMI_DISABLED;
+		else if (val == 0x11)
+			return TMDS_MHL_ENABLED;
+		else
+			return TMDS_MODE_UNKNOW;
+
+	} else {
+		return TMDS_HDMI_ENABLED;
+	}
+
+}
+
+void hdmitx_turn_off_tmds(int vo_mode)
+{
+	void __iomem *vaddr;
+
+	if (!tmds_en) {
+		HDMI_INFO("skip %s", __func__);
+		return;
+	}
+
+	vaddr = ioremap(HDMI_CR_reg, 0x4);
+
+	wr_reg(vaddr, 0x2A);
+	HDMI_INFO("CR OFF = %x", rd_reg(vaddr));
+	iounmap(vaddr);
+}
+
+int hdmitx_send_AVmute(void __iomem *reg_base, int flag)
+{
+	if ((flag == HDMI_SETAVM) || (flag == HDMI_CLRAVM))
+		set_mute_gpio_pulse();
+
+	/*  Skip AV mute if HDMI clock not enable */
+	if (is_hdmi_clock_on() != HDMI_CLK_PLL_ON) {
+		HDMI_DEBUG("Skip av mute, HDMI clock not enable");
+		return 1;
+	}
+
+	if (flag == HDMI_SETAVM) {
+
+		HDMI_DEBUG("set av mute");
+
+		wr_reg((reg_base + HDMI_GCPCR), HDMI_GCPCR_enablegcp(1) |
+									HDMI_GCPCR_gcp_clearavmute(1) |
+									HDMI_GCPCR_gcp_setavmute(1) |
+									HDMI_GCPCR_write_data(0));
+		wr_reg((reg_base + HDMI_GCPCR), HDMI_GCPCR_enablegcp(1) |
+									HDMI_GCPCR_gcp_clearavmute(0) |
+									HDMI_GCPCR_gcp_setavmute(1) |
+									HDMI_GCPCR_write_data(1));
+
+		msleep(50);/* Makes sure sink device can receive mute */
+		return 0;
+	} else if (flag == HDMI_CLRAVM) {
+
+		HDMI_DEBUG("clear av mute");
+
+		wr_reg((reg_base + HDMI_GCPCR), HDMI_GCPCR_enablegcp(1) |
+									HDMI_GCPCR_gcp_clearavmute(1) |
+									HDMI_GCPCR_gcp_setavmute(1) |
+									HDMI_GCPCR_write_data(0));
+		wr_reg((reg_base + HDMI_GCPCR), HDMI_GCPCR_enablegcp(1) |
+									HDMI_GCPCR_gcp_clearavmute(1) |
+									HDMI_GCPCR_gcp_setavmute(0) |
+									HDMI_GCPCR_write_data(1));
+		return 0;
+	} else {
+
+		HDMI_DEBUG("unknown av mute parameter");
+		return 1;
+	}
+}
+
+
+/* Need ION_AUDIO_HEAP */
+void register_ion_client(const char *name)
+{
+	rpc_ion_client = ion_client_create(rtk_phoenix_ion_device, name);
+}
+
+void deregister_ion_client(const char *name)
+{
+	if (rpc_ion_client != NULL) {
+		HDMI_INFO("%s :%s", __func__, name);
+		ion_client_destroy(rpc_ion_client);
+	}
+}
+
+#if __RTK_HDMI_GENERIC_DEBUG__
+void hdmitx_dump_VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *arg, char *str)
+{
+	HDMI_DEBUG("%s", __func__);
+	HDMI_INFO("interfaceType       =0x%x", arg->interfaceType);
+
+	HDMI_INFO("videoInfo.standard  =0x%x", arg->videoInfo.standard);
+	HDMI_INFO("videoInfo.enProg    =0x%x", arg->videoInfo.enProg);
+	HDMI_INFO("videoInfo.enDIF     =0x%x", arg->videoInfo.enDIF);
+	HDMI_INFO("videoInfo.enCompRGB =0x%x", arg->videoInfo.enCompRGB);
+	HDMI_INFO("videoInfo.pedType   =0x%x", arg->videoInfo.pedType);
+	HDMI_INFO("videoInfo.dataInt0  =0x%x", arg->videoInfo.dataInt0);
+	HDMI_INFO("videoInfo.dataInt1  =0x%x", arg->videoInfo.dataInt1);
+
+	HDMI_INFO("hdmiInfo.hdmiMode   =0x%x", arg->hdmiInfo.hdmiMode);
+    HDMI_INFO("hdmiInfo.audioSampleFreq    =0x%x", arg->hdmiInfo.audioSampleFreq);
+	HDMI_INFO("hdmiInfo.audioChannelCount  =0x%x", arg->hdmiInfo.audioChannelCount);
+	HDMI_INFO("hdmiInfo.dataByte1  =0x%x", arg->hdmiInfo.dataByte1);
+	HDMI_INFO("hdmiInfo.dataByte2  =0x%x", arg->hdmiInfo.dataByte2);
+	HDMI_INFO("hdmiInfo.dataByte3  =0x%x", arg->hdmiInfo.dataByte3);
+	HDMI_INFO("hdmiInfo.dataByte4  =0x%x", arg->hdmiInfo.dataByte4);
+	HDMI_INFO("hdmiInfo.dataByte5  =0x%x", arg->hdmiInfo.dataByte5);
+	HDMI_INFO("hdmiInfo.dataInt0   =0x%x", arg->hdmiInfo.dataInt0);
+	HDMI_INFO("hdmiInfo.hdmi2p0_feature   =0x%x", arg->hdmiInfo.hdmi2p0_feature);
+	HDMI_INFO("hdmiInfo.hdmi_off_mode     =0x%x", arg->hdmiInfo.hdmi_off_mode);
+	HDMI_INFO("hdmiInfo.hdr_ctrl_mode     =0x%x", arg->hdmiInfo.hdr_ctrl_mode);
+	HDMI_INFO("hdmiInfo.reserved4         =0x%x", arg->hdmiInfo.reserved4);
+
+}
+
+void hdmitx_dump_AUDIO_HDMI_OUT_EDID_DATA2(struct AUDIO_HDMI_OUT_EDID_DATA2 *arg, char *str)
+{
+	HDMI_DEBUG("%s", __func__);
+	HDMI_INFO("Version         =0x%x", arg->Version);
+	HDMI_INFO("HDMI_output_enable  =0x%x", arg->HDMI_output_enable);
+	HDMI_INFO("EDID_DATA_addr  =0x%x", arg->EDID_DATA_addr);
+}
+#endif
+
+int RPC_TOAGENT_HDMI_Config_TV_System(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *arg)
+{
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *rpc = NULL;
+	int ret = -1;
+	u32 RPC_ret;
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t dat;
+	size_t len;
+
+	handle = ion_alloc(rpc_ion_client, 4096, 1024,
+		RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+		ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+	if (IS_ERR(handle)) {
+		HDMI_ERROR("[%s %d ion_alloc fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	if (ion_phys(rpc_ion_client, handle, &dat, &len) != 0) {
+		HDMI_ERROR("[%s %d fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	rpc = ion_map_kernel(rpc_ion_client, handle);
+
+	memcpy(rpc, arg, sizeof(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM));
+
+	rpc->interfaceType = htonl(arg->interfaceType);
+
+	rpc->videoInfo.standard = htonl(arg->videoInfo.standard);
+	rpc->videoInfo.pedType  = htonl(arg->videoInfo.pedType);
+	rpc->videoInfo.dataInt0 = htonl(arg->videoInfo.dataInt0);
+	rpc->videoInfo.dataInt1 = htonl(arg->videoInfo.dataInt1);
+
+	rpc->hdmiInfo.hdmiMode  = htonl(arg->hdmiInfo.hdmiMode);
+	rpc->hdmiInfo.audioSampleFreq = htonl(arg->hdmiInfo.audioSampleFreq);
+	rpc->hdmiInfo.dataInt0  = htonl(arg->hdmiInfo.dataInt0);
+	rpc->hdmiInfo.hdmi2p0_feature = htonl(arg->hdmiInfo.hdmi2p0_feature);
+	rpc->hdmiInfo.hdmi_off_mode = htonl(arg->hdmiInfo.hdmi_off_mode);
+	rpc->hdmiInfo.hdr_ctrl_mode = htonl(arg->hdmiInfo.hdr_ctrl_mode);
+	rpc->hdmiInfo.reserved4 = htonl(arg->hdmiInfo.reserved4);
+
+	if (send_rpc_command(RPC_AUDIO, ENUM_VIDEO_KERNEL_RPC_CONFIG_TV_SYSTEM,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM))),
+		&RPC_ret)) {
+
+		HDMI_ERROR("[%s %d RPC fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	ret = 0;
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(rpc_ion_client, handle);
+		ion_free(rpc_ion_client, handle);
+	}
+	return ret;
+}
+
+int RPC_TOAGENT_HDMI_Config_AVI_Info(struct VIDEO_RPC_VOUT_CONFIG_HDMI_INFO_FRAME *arg)
+{
+	struct VIDEO_RPC_VOUT_CONFIG_HDMI_INFO_FRAME *rpc = NULL;
+	int ret = -1;
+	u32 RPC_ret;
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t dat;
+	size_t len;
+
+	handle = ion_alloc(rpc_ion_client, 4096, 1024,
+		RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+		ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+	if (IS_ERR(handle)) {
+		HDMI_ERROR("[%s %d ion_alloc fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	if (ion_phys(rpc_ion_client, handle, &dat, &len) != 0) {
+		HDMI_ERROR("[%s %d fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	rpc = ion_map_kernel(rpc_ion_client, handle);
+
+	memcpy(rpc, arg, sizeof(struct VIDEO_RPC_VOUT_CONFIG_HDMI_INFO_FRAME));
+
+	rpc->hdmiMode  = htonl(arg->hdmiMode);
+	rpc->audioSampleFreq = htonl(arg->audioSampleFreq);
+	rpc->dataInt0 =  htonl(arg->dataInt0);
+	rpc->hdmi2p0_feature = htonl(arg->hdmi2p0_feature);
+	rpc->hdmi_off_mode = htonl(arg->hdmi_off_mode);
+	rpc->hdr_ctrl_mode = htonl(arg->hdr_ctrl_mode);
+	rpc->reserved4 = htonl(arg->reserved4);
+
+	if (send_rpc_command(RPC_AUDIO, ENUM_VIDEO_KERNEL_RPC_CONFIG_HDMI_INFO_FRAME,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(struct VIDEO_RPC_VOUT_CONFIG_HDMI_INFO_FRAME))),
+		&RPC_ret)) {
+
+		HDMI_ERROR("[%s %d RPC fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	ret = 0;
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(rpc_ion_client, handle);
+		ion_free(rpc_ion_client, handle);
+	}
+	return ret;
+}
+
+int RPC_TOAGENT_HDMI_Set(struct AUDIO_HDMI_SET *arg)
+{
+	struct AUDIO_HDMI_SET *rpc = NULL;
+	int ret = -1;
+	u32 RPC_ret;
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t dat;
+	size_t len;
+
+	handle = ion_alloc(rpc_ion_client, 4096, 1024,
+		RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+		ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+	if (IS_ERR(handle)) {
+		HDMI_ERROR("[%s %d ion_alloc fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	if (ion_phys(rpc_ion_client, handle, &dat, &len) != 0) {
+		HDMI_ERROR("[%s %d fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	rpc = ion_map_kernel(rpc_ion_client, handle);
+
+	pli_ipcCopyMemory((unsigned char *)rpc, (unsigned char *)arg,
+		sizeof(struct AUDIO_HDMI_SET));
+
+	if (send_rpc_command(RPC_AUDIO, ENUM_KERNEL_RPC_HDMI_SET,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(struct AUDIO_HDMI_SET))),
+		&RPC_ret)) {
+
+		HDMI_ERROR("[%s %d RPC fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	ret = 0;
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(rpc_ion_client, handle);
+		ion_free(rpc_ion_client, handle);
+	}
+	return ret;
+}
+
+
+int RPC_TOAGENT_HDMI_Mute(struct AUDIO_HDMI_MUTE_INFO *arg)
+{
+	struct AUDIO_HDMI_MUTE_INFO *rpc = NULL;
+	int ret = -1;
+	u32 RPC_ret;
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t dat;
+	size_t len;
+
+	handle = ion_alloc(rpc_ion_client, 4096, 1024,
+		RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+		ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+	if (IS_ERR(handle)) {
+	    HDMI_ERROR("[%s %d ion_alloc fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	if (ion_phys(rpc_ion_client, handle, &dat, &len) != 0) {
+	    HDMI_ERROR("[%s %d fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	rpc = ion_map_kernel(rpc_ion_client, handle);
+
+	rpc->instanceID = htonl(arg->instanceID);
+	rpc->hdmi_mute = arg->hdmi_mute;
+
+	if (send_rpc_command(RPC_AUDIO, ENUM_KERNEL_RPC_HDMI_MUTE,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(struct AUDIO_HDMI_MUTE_INFO))),
+		&RPC_ret)) {
+
+		HDMI_ERROR("[%s %d RPC fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	ret = 0;
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(rpc_ion_client, handle);
+		ion_free(rpc_ion_client, handle);
+	}
+	return ret;
+}
+
+int RPC_TOAGENT_HDMI_OUT_VSDB(struct AUDIO_HDMI_OUT_VSDB_DATA *arg)
+{
+	struct AUDIO_HDMI_OUT_VSDB_DATA *rpc = NULL;
+	int ret = -1;
+	u32 RPC_ret;
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t dat;
+	size_t len;
+
+	handle = ion_alloc(rpc_ion_client, 4096, 1024,
+		RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+		ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+	if (IS_ERR(handle)) {
+	    HDMI_ERROR("[%s %d ion_alloc fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	if (ion_phys(rpc_ion_client, handle, &dat, &len) != 0) {
+	    HDMI_ERROR("[%s %d fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	rpc = ion_map_kernel(rpc_ion_client, handle);
+
+	pli_ipcCopyMemory((unsigned char *)rpc, (unsigned char *)arg,
+		sizeof(struct AUDIO_HDMI_OUT_VSDB_DATA));
+
+	if (send_rpc_command(RPC_AUDIO, ENUM_KERNEL_RPC_HDMI_OUT_VSDB,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(struct AUDIO_HDMI_OUT_VSDB_DATA))),
+		&RPC_ret)) {
+
+		HDMI_ERROR("[%s %d RPC fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	ret = 0;
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(rpc_ion_client, handle);
+		ion_free(rpc_ion_client, handle);
+	}
+	return ret;
+}
+
+int RPC_ToAgent_HDMI_OUT_EDID_0(struct AUDIO_HDMI_OUT_EDID_DATA2 *arg)
+{
+	struct AUDIO_HDMI_OUT_EDID_DATA2 *rpc = NULL;
+	int ret = -1;
+	u32 RPC_ret;
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t dat;
+	size_t len;
+
+	handle = ion_alloc(rpc_ion_client, 4096, 1024,
+				RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+				ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+	if (IS_ERR(handle)) {
+	    HDMI_ERROR("[%s %d ion_alloc fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	if (ion_phys(rpc_ion_client, handle, &dat, &len) != 0) {
+	    HDMI_ERROR("[%s %d fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	rpc = ion_map_kernel(rpc_ion_client, handle);
+
+	pli_ipcCopyMemory((unsigned char *)rpc, (unsigned char *)arg,
+		sizeof(struct AUDIO_HDMI_OUT_EDID_DATA2));
+
+	if (send_rpc_command(RPC_AUDIO, ENUM_KERNEL_RPC_HDMI_OUT_EDID2,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(struct AUDIO_HDMI_OUT_EDID_DATA2))),
+		&RPC_ret)) {
+
+		HDMI_ERROR("[%s %d RPC fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	ret = 0;
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(rpc_ion_client, handle);
+		ion_free(rpc_ion_client, handle);
+	}
+	return ret;
+}
+
+int RPC_ToAgent_QueryDisplayWin_0(struct VIDEO_RPC_VOUT_QUERY_DISP_WIN_OUT *arg)
+{
+	struct VIDEO_RPC_VOUT_QUERY_DISP_WIN_IN *i_rpc = NULL;
+	struct VIDEO_RPC_VOUT_QUERY_DISP_WIN_OUT *o_rpc = NULL;
+	int ret = -1;
+	u32 RPC_ret;
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t dat;
+	size_t len;
+	unsigned int offset;
+
+	handle = ion_alloc(rpc_ion_client, 4096, 1024,
+		RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+		ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+	if (IS_ERR(handle)) {
+	    HDMI_ERROR("[%s %d ion_alloc fail]", __func__, __LINE__);
+	    goto exit;
+	}
+
+	if (ion_phys(rpc_ion_client, handle, &dat, &len) != 0) {
+	    HDMI_ERROR("[%s %d fail]", __func__, __LINE__);
+	    goto exit;
+	}
+
+	i_rpc = ion_map_kernel(rpc_ion_client, handle);
+	offset = get_rpc_alignment_offset(sizeof(struct VIDEO_RPC_VOUT_QUERY_DISP_WIN_IN));
+	o_rpc = (struct VIDEO_RPC_VOUT_QUERY_DISP_WIN_OUT *)((unsigned long)i_rpc + offset);
+
+	HDMI_DEBUG("i_rpc=%p ,o_rpc=%p\n", i_rpc, o_rpc);
+
+    if (send_rpc_command(RPC_AUDIO, ENUM_VIDEO_KERNEL_RPC_QUERY_DISPLAY_WIN,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + offset),
+		&RPC_ret)) {
+
+		HDMI_ERROR("[%s %d RPC fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	if (RPC_ret != S_OK) {
+		HDMI_ERROR("[%s %d RPC fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	arg->standard = htonl(o_rpc->standard);
+	HDMI_DEBUG("%s: standard=%d\n", __func__, arg->standard);
+
+	ret = 0;
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(rpc_ion_client, handle);
+		ion_free(rpc_ion_client, handle);
+	}
+	return ret;
+}
+
+int RPC_ToAgent_Vout_EDIDdata(struct VIDEO_RPC_VOUT_EDID_DATA *arg)
+{
+	struct VIDEO_RPC_VOUT_EDID_DATA *rpc = NULL;
+	int ret = -1;
+	u32 RPC_ret;
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t dat;
+	size_t len;
+
+	handle = ion_alloc(rpc_ion_client, 4096, 1024,
+		RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+		ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+	if (IS_ERR(handle)) {
+		HDMI_ERROR("[%s %d ion_alloc fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	if (ion_phys(rpc_ion_client, handle, &dat, &len) != 0) {
+		HDMI_ERROR("[%s %d fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	rpc = ion_map_kernel(rpc_ion_client, handle);
+
+	memcpy(rpc, arg, sizeof(struct VIDEO_RPC_VOUT_EDID_DATA));
+
+	if (send_rpc_command(RPC_AUDIO, ENUM_VIDEO_KERNEL_RPC_VOUT_EDID_DATA,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(struct VIDEO_RPC_VOUT_EDID_DATA))),
+		&RPC_ret)) {
+
+		HDMI_ERROR("[%s %d RPC fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	ret = 0;
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(rpc_ion_client, handle);
+		ion_free(rpc_ion_client, handle);
+	}
+	return ret;
+}
+
+int RPC_ToAgent_QueryConfigTvSystem(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *arg)
+{
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *i_rpc = NULL;
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *o_rpc = NULL;
+	int ret = -1;
+	u32 RPC_ret;
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t dat;
+	size_t len;
+	unsigned int offset;
+
+	handle = ion_alloc(rpc_ion_client, 4096, 1024,
+		RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+		ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+	if (IS_ERR(handle)) {
+		HDMI_ERROR("[%s %d ion_alloc fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	if (ion_phys(rpc_ion_client, handle, &dat, &len) != 0) {
+	    HDMI_ERROR("[%s %d fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	i_rpc = ion_map_kernel(rpc_ion_client, handle);
+	offset = get_rpc_alignment_offset(sizeof(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM));
+	o_rpc = (struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *)((unsigned long)i_rpc + offset);
+
+	if (send_rpc_command(RPC_AUDIO, ENUM_VIDEO_KERNEL_RPC_QUERY_CONFIG_TV_SYSTEM,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + offset),
+		&RPC_ret)) {
+
+		HDMI_ERROR("[%s %d RPC fail]", __func__, __LINE__);
+		goto exit;
+	}
+
+	memcpy(arg, o_rpc, sizeof(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM));
+
+	arg->interfaceType				= htonl(arg->interfaceType);
+	arg->videoInfo.standard			= htonl(arg->videoInfo.standard);
+	arg->videoInfo.pedType			= htonl(arg->videoInfo.pedType);
+	arg->videoInfo.dataInt0			= htonl(arg->videoInfo.dataInt0);
+	arg->videoInfo.dataInt1			= htonl(arg->videoInfo.dataInt1);
+	arg->hdmiInfo.hdmiMode          = htonl(arg->hdmiInfo.hdmiMode);
+	arg->hdmiInfo.audioSampleFreq	= htonl(arg->hdmiInfo.audioSampleFreq);
+	arg->hdmiInfo.dataInt0			= htonl(arg->hdmiInfo.dataInt0);
+	arg->hdmiInfo.hdmi2p0_feature	= htonl(arg->hdmiInfo.hdmi2p0_feature);
+	arg->hdmiInfo.hdmi_off_mode		= htonl(arg->hdmiInfo.hdmi_off_mode);
+	arg->hdmiInfo.hdr_ctrl_mode		= htonl(arg->hdmiInfo.hdr_ctrl_mode);
+
+	ret = 0;
+exit:
+	if (handle != NULL) {
+		ion_unmap_kernel(rpc_ion_client, handle);
+		ion_free(rpc_ion_client, handle);
+	}
+	return ret;
+}
+
+int hdmitx_reset_sink_capability(asoc_hdmi_t *p_this)
+{
+	p_this->sink_cap_available = false;
+	memset(&p_this->sink_cap, 0x0, sizeof(p_this->sink_cap));
+	memset(&p_this->sink_cap.cec_phy_addr, 0xff, sizeof(p_this->sink_cap.cec_phy_addr));
+	memset(&hdmitx_edid_info, 0x0, sizeof(hdmitx_edid_info));
+
+	if (p_this->edid_ptr != NULL) {
+		kfree(p_this->edid_ptr);
+		p_this->edid_ptr = NULL;
+	}
+
+	return 0;
+}
+
+void hdmitx_set_error_code(int error_code)
+{
+	hdmi_error = error_code;
+}
+
+void hdmitx_dump_error_code(void)
+{
+	switch (hdmi_error) {
+	case HDMI_ERROR_NO_MEMORY:
+		HDMI_ERROR("get EDID failed, no memory");
+		break;
+	case HDMI_ERROR_I2C_ERROR:
+		HDMI_ERROR("get EDID failed, I2C error");
+		break;
+	case HDMI_ERROR_HPD:
+		HDMI_ERROR("get EDID failed, cable pulled out");
+		break;
+	case HDMI_ERROR_INVALID_EDID:
+		HDMI_ERROR("get EDID failed, invalid EDID");
+		break;
+	default:
+		break;
+	}
+}
+
+int hdmitx_check_same_edid(asoc_hdmi_t *p_this)
+{
+	int ret_val;
+	struct edid *base_edid;
+	struct edid *new_base_edid;
+
+	ret_val = 0;
+
+	if (p_this->sink_cap_available != true)
+		goto out;
+
+	new_base_edid = rtk_get_base_edid();
+	if (new_base_edid == NULL)
+		goto out;
+
+	base_edid = (struct edid *) p_this->edid_ptr;
+
+	if ((new_base_edid->mfg_id[0] == base_edid->mfg_id[0]) &&
+		(new_base_edid->mfg_id[1] == base_edid->mfg_id[1]) &&
+		(new_base_edid->checksum == base_edid->checksum)) {
+
+		HDMI_INFO("Same EDID mfg_id=%02x %02x checksum=%02x",
+			new_base_edid->mfg_id[0], new_base_edid->mfg_id[1],
+			new_base_edid->checksum);
+
+		ret_val = 1;
+	}
+
+	kfree(new_base_edid);
+out:
+	return ret_val;
+}
+
+int hdmitx_get_sink_capability(asoc_hdmi_t *p_this)
+{
+	struct edid *edid = NULL;
+
+	if (p_this->sink_cap_available == true)
+		return 0;
+
+	hdmitx_set_error_code(HDMI_ERROR_RESERVED);
+
+	edid = rtk_get_edid(p_this);
+	if (edid == NULL)
+		return -1;
+
+	p_this->sink_cap_available = true;
+
+	if (rtk_detect_hdmi_monitor(edid))
+		p_this->sink_cap.hdmi_mode = HDMI_MODE_HDMI;
+	else
+		p_this->sink_cap.hdmi_mode = HDMI_MODE_DVI;
+
+	rtk_add_edid_modes(edid, &p_this->sink_cap);
+	rtk_edid_to_eld(edid, &p_this->sink_cap);
+
+	hdmitx_print_sink_info(p_this);
+
+	/* VIC filter for specific sink device */
+	rtk_filter_specific_profuct_vic(edid, &p_this->sink_cap);
+
+	tx_support_size = gen_hdmi_format_support(&tx_support[0],
+		&p_this->sink_cap, &hdmitx_edid_info);
+
+	return 0;
+}
+
+#if __RTK_HDMI_GENERIC_DEBUG__
+void hdmitx_print_sink_capability(asoc_hdmi_t *p_this)
+{
+	HDMI_INFO("\n=================== sink_capabilities ========================");
+	HDMI_INFO("hdmi_mode=%u ", p_this->sink_cap.hdmi_mode);
+	HDMI_INFO("est_modes=%u ", p_this->sink_cap.est_modes);
+	HDMI_INFO("\n");
+	//VSBD
+	HDMI_INFO("cec_phy_addr=0x%02x 0x%02x ", p_this->sink_cap.cec_phy_addr[0], p_this->sink_cap.cec_phy_addr[1]);
+	HDMI_INFO("support_AI=%d ", p_this->sink_cap.support_AI);
+	HDMI_INFO("DC_Y444=%d ", p_this->sink_cap.DC_Y444);
+	HDMI_INFO("color_space=%u ", p_this->sink_cap.color_space);
+	HDMI_INFO("dvi_dual=%u ", p_this->sink_cap.dvi_dual);
+	HDMI_INFO("max_tmds_clock=%d ", p_this->sink_cap.max_tmds_clock);
+	HDMI_INFO("latency_present=%d %d ", p_this->sink_cap.latency_present[0], p_this->sink_cap.latency_present[1]);
+	HDMI_INFO("video_latency=%u %u ", p_this->sink_cap.video_latency[0], p_this->sink_cap.video_latency[1]);
+	HDMI_INFO("audio_latency=%u %u ", p_this->sink_cap.audio_latency[0], p_this->sink_cap.audio_latency[1]);
+	HDMI_INFO("\n");
+
+	HDMI_INFO("structure_all=0x%x\n", p_this->sink_cap.structure_all);
+
+	//Video
+	HDMI_INFO("display_info.width_mm=%u ", p_this->sink_cap.display_info.width_mm);
+	HDMI_INFO("display_info.height_mm=%u ", p_this->sink_cap.display_info.height_mm);
+	HDMI_INFO("display_info.bpc=%u ", p_this->sink_cap.display_info.bpc);
+	HDMI_INFO("display_info.color_formats=%u ", p_this->sink_cap.display_info.color_formats);
+	HDMI_INFO("display_info.cea_rev=%u ", p_this->sink_cap.display_info.cea_rev);
+	HDMI_INFO("vic=0x%llx ", p_this->sink_cap.vic);
+	HDMI_INFO("extended_vic=%u ", p_this->sink_cap.extended_vic);
+	HDMI_INFO("vic2=0x%llx ", p_this->sink_cap.vic2);
+	HDMI_INFO("vic2_420=0x%llx ", p_this->sink_cap.vic2_420);
+	HDMI_INFO("HDR metadata: et(0x%02x) sm(0x%02x) max_luminace(0x%02x) max_frame_avg(0x%02x) min_luminace(0x%02x) ",
+		p_this->sink_cap.vout_edid_data.et, p_this->sink_cap.vout_edid_data.sm,
+		p_this->sink_cap.vout_edid_data.max_luminace, p_this->sink_cap.vout_edid_data.max_frame_avg,
+		p_this->sink_cap.vout_edid_data.min_luminace);
+	HDMI_INFO("Color characteristics: red_green_lo(0x%02x) black_white_lo(0x%02x) ",
+		p_this->sink_cap.vout_edid_data.red_green_lo, p_this->sink_cap.vout_edid_data.black_white_lo);
+	HDMI_INFO("Color characteristics: red_x(0x%02x) red_y(0x%02x) ",
+		p_this->sink_cap.vout_edid_data.red_x, p_this->sink_cap.vout_edid_data.red_y);
+	HDMI_INFO("Color characteristics: green_x(0x%02x) green_y(0x%02x) ",
+		p_this->sink_cap.vout_edid_data.green_x, p_this->sink_cap.vout_edid_data.green_y);
+	HDMI_INFO("Color characteristics: blue_x(0x%02x) blue_y(0x%02x) ",
+		p_this->sink_cap.vout_edid_data.blue_x, p_this->sink_cap.vout_edid_data.blue_y);
+	HDMI_INFO("Color characteristics: white_x(0x%02x) white_y(0x%02x) ",
+		p_this->sink_cap.vout_edid_data.white_x, p_this->sink_cap.vout_edid_data.white_y);
+
+	HDMI_INFO("=================================================================\n");
+}
+#endif
+
+void hdmitx_print_sink_info(asoc_hdmi_t *p_this)
+{
+	HDMI_INFO("Dump EDID\n");
+
+	print_color_formats(p_this->sink_cap.display_info.color_formats);
+
+	if (p_this->sink_cap.hdmi_mode == HDMI_MODE_HDMI)
+		HDMI_INFO("DEVICE MODE: HDMI Mode ");
+	else if (p_this->sink_cap.hdmi_mode == HDMI_MODE_DVI)
+		HDMI_INFO("DEVICE MODE: DVI Mode ");
+	else if (p_this->sink_cap.hdmi_mode == HDMI_MODE_MHL)
+		HDMI_INFO("DEVICE MODE: MHL Mode ");
+
+	print_cea_modes(p_this->sink_cap.vic, p_this->sink_cap.vic2, p_this->sink_cap.vic2_420);
+
+	HDMI_INFO("CEC Address: 0x%x%02x ", p_this->sink_cap.cec_phy_addr[0],
+										p_this->sink_cap.cec_phy_addr[1]);
+
+	print_deep_color(p_this->sink_cap.display_info.bpc);
+
+	if (p_this->sink_cap.DC_Y444)
+		HDMI_INFO("Support Deep Color in YCbCr444 ");
+
+	if (p_this->sink_cap.max_tmds_clock)
+		HDMI_INFO("Max TMDS clock: %d", p_this->sink_cap.max_tmds_clock);
+
+	HDMI_INFO("Video Latency: %d %d ", p_this->sink_cap.video_latency[0],
+										p_this->sink_cap.video_latency[1]);
+
+	HDMI_INFO("Audio Latency: %d %d ", p_this->sink_cap.audio_latency[0],
+										p_this->sink_cap.audio_latency[1]);
+
+	print_color_space(p_this->sink_cap.color_space);
+
+	hdmi_print_raw_edid(p_this->edid_ptr);
+}
+
+int ops_config_tv_system(void __user *arg)
+{
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM tv_system;
+	unsigned char scramble;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&tv_system, arg, sizeof(tv_system))) {
+		HDMI_ERROR("%s:failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+
+	HDMI_INFO("TV system: hdmiMode(%u) standard(%u) dataByte1(0x%02x) dataInt0(0x%02x)",
+				tv_system.hdmiInfo.hdmiMode,
+				tv_system.videoInfo.standard,
+				tv_system.hdmiInfo.dataByte1,
+				tv_system.hdmiInfo.dataInt0);
+
+	if (tv_system.hdmiInfo.hdmiMode == VO_HDMI_ON) {
+		if (hdmitx_edid_info.hdmi_id == HDMI_2P0_IDENTIFIER)
+			tv_system.hdmiInfo.hdmi2p0_feature |= 0x1;/* [Bit0] HDMI2.0 */
+
+		scramble = hdmitx_send_scdc_TmdsConfig(tv_system.videoInfo.standard,
+			tv_system.hdmiInfo.dataInt0, tv_system.hdmiInfo.dataByte1);
+
+		if (scramble != 0)
+			tv_system.hdmiInfo.hdmi2p0_feature |= 0x2;/* [Bit1]Scrabmle */
+	} else if (tv_system.hdmiInfo.hdmiMode == VO_HDMI_OFF) {
+		if (hdmi_clk_always_on) {
+			HDMI_INFO("Keep clock always on");
+			tv_system.hdmiInfo.hdmi_off_mode = VO_HDMI_OFF_CLOCK_ON;
+		} else {
+#if HDMI_RX_SENSE_SUPPORT
+			if (hdmitx_switch_get_hpd()) {
+				HDMI_INFO("Keep clock on when cable still connected");
+				tv_system.hdmiInfo.hdmi_off_mode = VO_HDMI_OFF_CLOCK_ON;
+			}
+#endif
+		}
+	}
+
+#if __RTK_HDMI_GENERIC_DEBUG__
+	hdmitx_dump_VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM(&tv_system, NULL);
+#endif
+	return RPC_TOAGENT_HDMI_Config_TV_System(&tv_system);
+}
+
+int ops_config_avi_info(void __user *arg)
+{
+	struct VIDEO_RPC_VOUT_CONFIG_HDMI_INFO_FRAME info_frame;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&info_frame, arg, sizeof(info_frame))) {
+		HDMI_ERROR("%s:failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+
+	return RPC_TOAGENT_HDMI_Config_AVI_Info(&info_frame);
+}
+
+int ops_set_frequency(void __user *arg)
+{
+	struct AUDIO_HDMI_SET set;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&set, arg, sizeof(set))) {
+		HDMI_ERROR("%s:failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+
+	return RPC_TOAGENT_HDMI_Set(&set);
+}
+
+int ops_set_audio_mute(void __user *arg)
+{
+	struct AUDIO_HDMI_MUTE_INFO mute_info;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&mute_info, arg, sizeof(mute_info))) {
+		HDMI_ERROR("%s:failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+
+	return RPC_TOAGENT_HDMI_Mute(&mute_info);
+}
+
+int ops_send_audio_vsdb_data(void __user *arg)
+{
+	struct AUDIO_HDMI_OUT_VSDB_DATA vsdb_data;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&vsdb_data, arg, sizeof(vsdb_data))) {
+		HDMI_ERROR("%s:failed to copy from user ! ", __func__);
+		return -EFAULT;
+	}
+
+	return RPC_TOAGENT_HDMI_OUT_VSDB(&vsdb_data);
+}
+
+int ops_send_audio_edid2(void __user *arg)
+{
+	struct AUDIO_HDMI_OUT_EDID_DATA2 edid2;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&edid2, arg, sizeof(edid2))) {
+		HDMI_ERROR("%s:failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+
+	return RPC_ToAgent_HDMI_OUT_EDID_0(&edid2);
+}
+
+int ops_query_display_standard(void __user *arg)
+{
+	int ret = 0;
+	int standard = 0;
+	struct VIDEO_RPC_VOUT_QUERY_DISP_WIN_OUT display_win;
+
+	HDMI_DEBUG("%s", __func__);
+
+	ret = RPC_ToAgent_QueryDisplayWin_0(&display_win);
+	standard = (int)display_win.standard;
+
+	if (copy_to_user(arg, &standard, sizeof(standard))) {
+		HDMI_ERROR("%s:failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+	return ret;
+}
+
+int ops_get_sink_cap(void __user *arg, asoc_hdmi_t *data)
+{
+	int ret = 0;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (!(data->sink_cap_available)) {
+		HDMI_ERROR("[%s]sink cap is not available", __func__);
+		return -ENOMSG;
+	}
+
+	if (copy_to_user(arg, &data->sink_cap, sizeof(data->sink_cap))) {
+		HDMI_ERROR("%s:failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+#if __RTK_HDMI_GENERIC_DEBUG__
+	hdmitx_print_sink_capability(data);
+#endif
+	return ret;
+}
+
+int ops_get_raw_edid(void __user *arg, asoc_hdmi_t *data)
+{
+	int ret = 0;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (!(data->sink_cap_available)) {
+		HDMI_ERROR("[%s]sink cap is not available", __func__);
+		return -ENOMSG;
+	}
+
+	if (copy_to_user(arg, data->edid_ptr, sizeof(struct raw_edid))) {
+		HDMI_ERROR("%s:failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+	return ret;
+}
+
+int ops_get_link_status(void __user *arg)
+{
+	int ret = 0;
+	int status = 0;
+
+	HDMI_DEBUG("%s", __func__);
+
+	status = show_hpd_status(false);
+
+	if (copy_to_user(arg, &status, sizeof(status))) {
+		HDMI_ERROR("%s:failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+	return ret;
+}
+
+int ops_get_video_config(void __user *arg, asoc_hdmi_t *data)
+{
+	int ret = 0;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_to_user(arg, &data->sink_cap.vic,
+		sizeof(data->sink_cap.vic))) {
+
+		HDMI_ERROR("%s:failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+	return ret;
+}
+
+int ops_send_AVmute(void __user *arg, void __iomem *base)
+{
+	int flag;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&flag, arg, sizeof(flag))) {
+		HDMI_ERROR("%s:failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+
+	return hdmitx_send_AVmute(base, flag);
+}
+
+int ops_check_tmds_src(void __user *arg, void __iomem *base)
+{
+	int tmds_mode = hdmitx_check_tmds_src(base);
+	int ret = 0;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_to_user(arg, &tmds_mode, sizeof(tmds_mode))) {
+		HDMI_ERROR("%s:failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+	return ret;
+}
+
+int ops_check_rx_sense(void __user *arg, void __iomem *base)
+{
+	int rx_sense;
+	int ret = 0;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (is_hdmi_clock_on() != HDMI_CLK_OFF) {
+		rx_sense = hdmitx_check_rx_sense(base);
+	} else {
+		HDMI_DEBUG("Skip check_rx_sense, HDMI clock not enable");
+		rx_sense = HDMI_RX_SENSE_OFF;
+	}
+
+	if (copy_to_user(arg, &rx_sense, sizeof(rx_sense))) {
+		HDMI_ERROR("%s:failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+	return ret;
+}
+
+int ops_get_extension_blk_count(void __user *arg, asoc_hdmi_t *data)
+{
+	int ret = 0;
+	int count = 0;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (!(data->sink_cap_available)) {
+		HDMI_ERROR("[%s]sink cap is not available", __func__);
+		return -ENOMSG;
+	}
+
+	count = (int) data->edid_ptr[0x7e];
+
+	if (copy_to_user(arg, &count, sizeof(int))) {
+		HDMI_ERROR("%s:failed to copy to user !", __func__);
+		return -EFAULT;
+	}
+
+	return ret;
+}
+
+
+int ops_get_extended_edid(void __user *arg, asoc_hdmi_t *data)
+{
+	int ret = 0;
+	unsigned char number;
+	struct ext_edid ext = {0};
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (!(data->sink_cap_available)) {
+		HDMI_ERROR("[%s]sink cap is not available", __func__);
+		return -ENOMSG;
+	}
+
+	if (copy_from_user(&ext, arg, sizeof(struct ext_edid))) {
+		HDMI_ERROR("%s:failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+
+	if (ext.current_blk > ext.extension) {
+		HDMI_ERROR("[%s] out of range !", __func__);
+		return -EFAULT;
+	}
+
+	HDMI_DEBUG("ext.extension=%d ext.current_blk=%d",
+		ext.extension, ext.current_blk);
+
+	number = ext.extension - ext.current_blk + 1;
+	if (number > 2)
+		number = 2;
+
+	memcpy(ext.data, data->edid_ptr + EDID_LENGTH*(ext.current_blk),
+		EDID_LENGTH*number);
+
+	if (copy_to_user(arg, &ext, sizeof(struct ext_edid))) {
+		HDMI_ERROR("%s:failed to copy to user ! ", __func__);
+		return -EFAULT;
+	}
+
+	return ret;
+}
+
+
+int ops_send_vout_edid_data(void __user *arg)
+{
+	struct VIDEO_RPC_VOUT_EDID_DATA vout_edid_data;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&vout_edid_data, arg, sizeof(vout_edid_data))) {
+		HDMI_ERROR("%s:failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+	return RPC_ToAgent_Vout_EDIDdata(&vout_edid_data);
+}
+
+int ops_get_edid_support_list(void __user *arg, asoc_hdmi_t *data)
+{
+	int ret = 0;
+	struct hdmi_support_list support_list;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (!(data->sink_cap_available)) {
+		HDMI_ERROR("[%s]sink cap is not available", __func__);
+		ret = -ENOMSG;
+		goto exit;
+	}
+
+	memcpy(&support_list.tx_support[0], &tx_support[0], sizeof(tx_support));
+	support_list.tx_support_size = tx_support_size;
+
+	if (copy_to_user(arg, &support_list, sizeof(struct hdmi_support_list))) {
+		HDMI_ERROR("%s:failed to copy to user ! ", __func__);
+		ret = -EFAULT;
+		goto exit;
+	}
+
+exit:
+	return ret;
+}
+
+int ops_set_output_format(void __user *arg)
+{
+	int ret = 0;
+	struct hdmi_format_setting format_setting;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&format_setting, arg, sizeof(format_setting))) {
+			HDMI_ERROR("%s:failed to copy from user !", __func__);
+			return -EFAULT;
+	}
+
+	ret = set_hdmitx_format(&format_setting);
+
+#ifdef CONFIG_ARCH_RTD139x
+#ifdef CONFIG_RTK_HDCP_1x_TEE
+	if ((format_setting.mode != FORMAT_MODE_OFF) &&
+		(format_setting.vic == VIC_720X480P60)) {
+		ta_hdcp14_init();
+		ta_hdcp_fix480p();
+	}
+#endif
+#endif
+
+	return ret;
+}
+
+int ops_get_output_format(void __user *arg)
+{
+	int ret = 0;
+	struct hdmi_format_setting format_setting;
+
+	HDMI_DEBUG("%s", __func__);
+
+	ret = get_hdmitx_format(&format_setting);
+
+	if (ret != 0)
+		goto exit;
+
+	if (copy_to_user(arg, &format_setting, sizeof(struct hdmi_format_setting))) {
+		HDMI_ERROR("%s:failed to copy to user ! ", __func__);
+		ret =  -EFAULT;
+	}
+
+exit:
+	return ret;
+}
+
+int ops_set_interface_type(void __user *arg)
+{
+	int ret = 0;
+	int type;
+
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&type, arg, sizeof(type))) {
+		HDMI_ERROR("%s:failed to copy from user !", __func__);
+		ret = -EFAULT;
+	}
+
+	set_vo_interface_type(type);
+
+	return ret;
+}
+
+int ops_get_config_tv_system(void __user *arg)
+{
+	int ret;
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM tv_system;
+
+	ret = RPC_ToAgent_QueryConfigTvSystem(&tv_system);
+
+	if (ret != 0) {
+		ret =  -EFAULT;
+		goto exit;
+	}
+
+	if (copy_to_user(arg, &tv_system, sizeof(tv_system))) {
+		HDMI_ERROR("%s:failed to copy to user ! ", __func__);
+		ret =  -EFAULT;
+	}
+
+	ret = 0;
+
+exit:
+	return ret;
+}
+
+#if 1//def __LINUX_MEDIA_NAS__
+int ops_wait_hotplug(void __user *arg, hdmitx_device_t * dev)
+{
+	int ret= 0;
+	int status = 0;
+	HDMI_DEBUG("%s", __func__);
+
+	status = show_hpd_status(false);
+
+	wait_event_interruptible(dev->hpd_wait, ((status!=show_hpd_status(false)) || (!hpdDetect)));
+
+	status = show_hpd_status(false);
+
+	if (copy_to_user(arg,&status,sizeof(int))) {
+		HDMI_ERROR("%s:failed to copy to user ! ", __func__);
+		return -EFAULT;
+	}
+
+	return ret;
+}
+
+int ops_set_hotplug_detection(void __user *arg, hdmitx_device_t * dev)
+{
+	int ret= 0;
+	int fEn = 0;
+	HDMI_DEBUG("%s", __func__);
+
+	if (copy_from_user(&fEn, arg, sizeof(fEn))) {
+		HDMI_ERROR("%s:failed to copy from user !", __func__);
+		return -EFAULT;
+	}
+
+	hpdDetect = fEn;
+	if(fEn == 0)
+		wake_up_interruptible(&dev->hpd_wait);
+
+	return ret;
+}
+#endif
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx_api.h b/drivers/media/platform/rtk_hdmitx/hdmitx_api.h
new file mode 100644
index 00000000..7b3aab3
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx_api.h
@@ -0,0 +1,77 @@
+/*
+ * hdmitx_api.h - RTK hdmitx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDMITX_API_H__
+#define __HDMITX_API_H__
+
+#include "hdmitx_dev.h"
+#include "hdmitx.h"
+#include "hdmitx_rpc.h"
+
+extern unsigned int hdmi_clk_always_on;
+extern unsigned int displayport_exist;
+
+int check_hdmi_mhl_mode(void);
+
+int hdmitx_send_AVmute(void __iomem *base, int flag);
+int hdmitx_check_tmds_src(void __iomem *base);
+int hdmitx_turn_off_tmds(int vo_mode);
+
+void register_ion_client(const char *name);
+void deregister_ion_client(const char *name);
+int RPC_TOAGENT_HDMI_Config_TV_System(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *arg);
+int RPC_TOAGENT_HDMI_Config_AVI_Info(struct VIDEO_RPC_VOUT_CONFIG_HDMI_INFO_FRAME *arg);
+int RPC_TOAGENT_HDMI_Set(struct AUDIO_HDMI_SET *arg);
+int RPC_TOAGENT_HDMI_Mute(struct AUDIO_HDMI_MUTE_INFO *arg);
+int RPC_TOAGENT_HDMI_OUT_VSDB(struct AUDIO_HDMI_OUT_VSDB_DATA *arg);
+int RPC_ToAgent_HDMI_OUT_EDID_0(struct AUDIO_HDMI_OUT_EDID_DATA2 *arg);
+int RPC_ToAgent_Vout_EDIDdata(struct VIDEO_RPC_VOUT_EDID_DATA *arg);
+int RPC_ToAgent_QueryConfigTvSystem(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *arg);
+
+int hdmitx_check_same_edid(asoc_hdmi_t *p_this);
+int hdmitx_reset_sink_capability(asoc_hdmi_t *p_this);
+int hdmitx_get_sink_capability(asoc_hdmi_t *p_this);
+void hdmitx_print_sink_capability(asoc_hdmi_t *p_this);
+void hdmitx_print_sink_info(asoc_hdmi_t *p_this);
+int hdmitx_check_rx_sense(void __iomem *reg_base);
+void hdmitx_set_error_code(int hdmi_error);
+void hdmitx_dump_error_code(void);
+
+int ops_get_sink_cap(void __user *arg, asoc_hdmi_t *data);
+int ops_get_raw_edid(void __user *arg, asoc_hdmi_t *data);
+int ops_get_extension_blk_count(void __user *arg, asoc_hdmi_t *data);
+int ops_get_extended_edid(void __user *arg, asoc_hdmi_t *data);
+int ops_get_link_status(void __user *arg);
+int ops_get_video_config(void __user *arg, asoc_hdmi_t *data);
+int ops_config_tv_system(void __user *arg);
+int ops_config_avi_info(void __user *arg);
+int ops_set_frequency(void __user *arg);
+int ops_set_audio_mute(void __user *arg);
+int ops_send_audio_vsdb_data(void __user *arg);
+int ops_send_audio_edid2(void __user *arg);
+int ops_query_display_standard(void __user *arg);
+
+int ops_send_AVmute(void __user *arg, void __iomem *base);
+int ops_check_tmds_src(void __user *arg, void __iomem *base);
+int ops_check_rx_sense(void __user *arg, void __iomem *base);
+int ops_send_vout_edid_data(void __user *arg);
+int ops_get_edid_support_list(void __user *arg, asoc_hdmi_t *data);
+int ops_set_output_format(void __user *arg);
+int ops_get_output_format(void __user *arg);
+int ops_set_interface_type(void __user *arg);
+int ops_get_config_tv_system(void __user *arg);
+
+#if 1//def __LINUX_MEDIA_NAS__
+int ops_set_hotplug_detection(void __user *arg, hdmitx_device_t * dev);
+int ops_wait_hotplug(void __user *arg, hdmitx_device_t * dev);
+#endif
+
+#endif  //__HDMITX_API_H__
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx_config.c b/drivers/media/platform/rtk_hdmitx/hdmitx_config.c
new file mode 100644
index 00000000..e141bf7
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx_config.c
@@ -0,0 +1,1517 @@
+/*
+ * hdmitx_config.c - RTK hdmitx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "hdmitx.h"
+#include "hdmitx_dev.h"
+#include "hdmitx_api.h"
+#include "hdmitx_rpc.h"
+#include "rtk_edid.h"
+#include "hdmitx_scdc.h"
+
+
+#define xvYCC601 0x01
+#define xvYCC709 0x02
+#define BT2020_YCC 0x40
+#define BT2020_RGB 0x80
+
+int vo_interface_type = -1;
+struct hdmi_format_support tx_support[25];
+unsigned char tx_support_size;
+
+static const char * const string_list[] = {
+	"0  - HDMI OFF",
+	"6  - 1440x480i/59.94Hz 4:3",
+	"2  - 720x480p/59.94Hz 4:3",
+	"21 - 1440x576i/50Hz 4:3",
+	"17 - 720x576p/50Hz 4:3",
+	"19 - 1280x720p/50Hz 16:9",
+	"4  - 1280x720p/59.94Hz/60Hz 16:9",
+	"20 - 1920x1080i/50Hz 16:9",
+	"5  - 1920x1080i/59.94Hz/60Hz 16:9",
+	"32 - 1920x1080p/23.98Hz/24Hz 16:9",
+	"33 - 1920x1080p/25Hz 16:9",
+	"34 - 1920x1080p/30Hz 16:9",
+	"31 - 1920x1080p/50Hz 16:9",
+	"16 - 1920x1080p/59.94Hz/60Hz 16:9",
+	"93 - 3840x2160p/23.98Hz/24Hz",
+	"94 - 3840x2160p/25Hz",
+	"95 - 3840x2160p/29.97Hz/30Hz",
+	"96 - 3840x2160p/50Hz",
+	"97 - 3840x2160p/59.94Hz/60Hz",
+	"98 - 4096x2160p/24Hz",
+	"99 - 4096x2160p/25Hz",
+	"100- 4096x2160p/30Hz",
+	"101- 4096x2160p/50Hz",
+	"102- 4096x2160p/60Hz"
+};
+
+#define SUPPORT_VIC_SIZE 23
+const char support_vic[SUPPORT_VIC_SIZE] = {
+	VIC_720X480P60,
+	VIC_1280X720P60,
+	VIC_1920X1080I60,
+	VIC_720X480I60,
+	VIC_1920X1080P60,
+	VIC_720X576P50,
+	VIC_1280X720P50,
+	VIC_1920X1080I50,
+	VIC_720X576I50,
+	VIC_1920X1080P50,
+	VIC_1920X1080P24,
+	VIC_1920X1080P25,
+	VIC_1920X1080P30,
+	VIC_3840X2160P24,
+	VIC_3840X2160P25,
+	VIC_3840X2160P30,
+	VIC_3840X2160P50,
+	VIC_3840X2160P60,
+	VIC_4096X2160P24,
+	VIC_4096X2160P25,
+	VIC_4096X2160P30,
+	VIC_4096X2160P50,
+	VIC_4096X2160P60,
+};
+
+unsigned char get_rgb444_support(unsigned char vic,
+	struct sink_capabilities_t *sink_cap,
+	struct edid_information *info,
+	unsigned int max_tmds)
+{
+	unsigned int depth;
+	unsigned char rgb444_support;
+	unsigned char need_check_tmds;
+
+	rgb444_support = BIT(1)|BIT(0);
+
+	if ((vic == VIC_3840X2160P50) || (vic == VIC_3840X2160P60) ||
+		(vic == VIC_4096X2160P50) || (vic == VIC_4096X2160P60))
+		goto exit;
+
+	if ((vic == VIC_3840X2160P24) || (vic == VIC_3840X2160P25) ||
+		(vic == VIC_3840X2160P30) || (vic == VIC_4096X2160P24) ||
+		(vic == VIC_4096X2160P25) || (vic == VIC_4096X2160P30))
+		need_check_tmds = 1;
+	else
+		need_check_tmds = 0;
+
+	/* Check deep color */
+	depth = sink_cap->display_info.bpc;
+	if (depth & RTK_EDID_DIGITAL_DEPTH_10) {
+		if ((!need_check_tmds) || (need_check_tmds && (max_tmds > 371)))
+			rgb444_support |= BIT(2);
+	}
+
+	if (depth & RTK_EDID_DIGITAL_DEPTH_12) {
+		if ((!need_check_tmds) || (need_check_tmds && (max_tmds > 445)))
+			rgb444_support |= BIT(3);
+	}
+exit:
+	return rgb444_support;
+}
+
+unsigned char get_yuv422_support(unsigned char vic,
+	struct sink_capabilities_t *sink_cap,
+	struct edid_information *info,
+	unsigned int max_tmds)
+{
+	unsigned int color_formats;
+	unsigned char yuv422_support;
+
+	yuv422_support = 0;
+	color_formats = sink_cap->display_info.color_formats;
+
+	if (color_formats & DRM_COLOR_FORMAT_YCRCB422)
+		yuv422_support |= (BIT(1)|BIT(0));
+
+	return yuv422_support;
+}
+
+unsigned char get_yuv444_support(unsigned char vic,
+	struct sink_capabilities_t *sink_cap,
+	struct edid_information *info,
+	unsigned int max_tmds)
+{
+	unsigned int color_formats;
+	unsigned int depth;
+	unsigned char yuv444_support;
+	unsigned char need_check_tmds;
+
+	yuv444_support = 0;
+	color_formats = sink_cap->display_info.color_formats;
+
+	if (color_formats & DRM_COLOR_FORMAT_YCRCB444)
+		yuv444_support |= (BIT(1)|BIT(0));
+	else
+		goto exit;
+
+	if ((vic == VIC_3840X2160P50) || (vic == VIC_3840X2160P60) ||
+		(vic == VIC_4096X2160P50) || (vic == VIC_4096X2160P60) ||
+		(sink_cap->DC_Y444 == 0))
+		goto exit;
+
+	if ((vic == VIC_3840X2160P24) || (vic == VIC_3840X2160P25) ||
+		(vic == VIC_3840X2160P30) || (vic == VIC_4096X2160P24) ||
+		(vic == VIC_4096X2160P25) || (vic == VIC_4096X2160P30))
+		need_check_tmds = 1;
+	else
+		need_check_tmds = 0;
+
+	/* Check deep color */
+	depth = sink_cap->display_info.bpc;
+	if (depth & RTK_EDID_DIGITAL_DEPTH_10) {
+		if ((!need_check_tmds) || (need_check_tmds && (max_tmds > 371)))
+			yuv444_support |= BIT(2);
+	}
+
+	if (depth & RTK_EDID_DIGITAL_DEPTH_12) {
+		if ((!need_check_tmds) || (need_check_tmds && (max_tmds > 445)))
+			yuv444_support |= BIT(3);
+	}
+exit:
+	return yuv444_support;
+}
+
+unsigned char get_yuv420_support(unsigned char vic,
+	struct sink_capabilities_t *sink_cap,
+	struct edid_information *info,
+	unsigned int max_tmds)
+{
+	unsigned char yuv420_support;
+
+	yuv420_support = BIT(1)|BIT(0);
+
+	/* Check deep color */
+	if ((info->dc_420&BIT(0)) && (max_tmds > 371))
+		yuv420_support |= BIT(2);
+
+	if ((info->dc_420&BIT(1)) && (max_tmds > 445))
+		yuv420_support |= BIT(3);
+
+	return yuv420_support;
+}
+
+unsigned char get_3d_support(unsigned char vic,
+	struct sink_capabilities_t *sink_cap,
+	struct edid_information *info,
+	unsigned int max_tmds)
+{
+	unsigned char _3d_support;
+	unsigned char i;
+
+	_3d_support = 0;
+	if (sink_cap->_3D_present == 0)
+		goto exit;
+
+	for (i = 0; i < MAX_3D_VIC; i++) {
+		if (sink_cap->_3D_vic[i] == vic) {
+			/* frame packing */
+			if ((sink_cap->structure_all & BIT(0)) &&
+				(vic != 96) && (vic != 97) &&
+				(vic != 101) && (vic != 102))
+				_3d_support |= BIT(0)|BIT(1);
+
+			/* top-and-bottom */
+			if (sink_cap->structure_all & BIT(6))
+				_3d_support |= BIT(0)|BIT(2);
+
+			/* side-by-side half*/
+			if (sink_cap->structure_all & BIT(8))
+				_3d_support |= BIT(0)|BIT(3);
+
+			break;
+		}
+	}
+
+	for (i = 0; i < MAX_SPEC_3D; i++) {
+		if (sink_cap->spec_3d[i].vic == vic) {
+			switch (sink_cap->spec_3d[i].format) {
+			case 0:
+				_3d_support |= BIT(0)|BIT(1);
+				break;
+			case 6:
+				_3d_support |= BIT(0)|BIT(2);
+				break;
+			case 8:
+				_3d_support |= BIT(0)|BIT(3);
+				break;
+			default:
+				break;
+			}
+			break;
+		}
+	}
+
+exit:
+	return _3d_support;
+}
+
+unsigned char get_fs_support(unsigned char vic, unsigned char support_3d)
+{
+	unsigned char fs_support;
+
+	switch (vic) {
+	case VIC_1280X720P60:
+	case VIC_1920X1080I60:
+	case VIC_1920X1080P24:
+	case VIC_1920X1080P60:
+	case VIC_3840X2160P24:
+	case VIC_3840X2160P30:
+	case VIC_3840X2160P60:
+		fs_support = BIT(0);
+		break;
+	default:
+		fs_support = 0;
+		break;
+	}
+
+	if (support_3d == 0)
+		goto exit;
+
+	/* freq shift 3d */
+	switch (vic) {
+	case VIC_1280X720P60:
+	case VIC_1920X1080I60:
+	case VIC_1920X1080P24:
+	case VIC_3840X2160P24:
+		fs_support |= BIT(1);
+		break;
+	default:
+		break;
+	}
+
+exit:
+	return fs_support;
+}
+
+unsigned int gen_hdmi_format_support(struct hdmi_format_support *tx_support,
+	struct sink_capabilities_t *sink_cap,
+	struct edid_information *info)
+{
+	__u64 vic;
+	unsigned char extended_vic;
+	__u64 vic2;
+	__u64 vic2_420;
+	unsigned int max_tmds;
+	unsigned int offset;
+	unsigned int i;
+
+	memset(tx_support, 0, sizeof(struct hdmi_format_support)*25);
+
+	vic = sink_cap->vic;
+	extended_vic = sink_cap->extended_vic;
+	vic2 = sink_cap->vic2;
+	vic2_420 = sink_cap->vic2_420;
+
+	/* SD 16:9->4:3 */
+	if (vic & BIT(2))
+		vic |= BIT(1);
+	if (vic & BIT(6))
+		vic |= BIT(5);
+	if (vic & BIT(17))
+		vic |= BIT(16);
+	if (vic & BIT(21))
+		vic |= BIT(20);
+
+	/* Merge extended_vic to vic2 */
+	if (extended_vic & BIT(1))
+		vic2 |= BIT(30);
+	if (extended_vic & BIT(2))
+		vic2 |= BIT(29);
+	if (extended_vic & BIT(3))
+		vic2 |= BIT(28);
+	if (extended_vic & BIT(4))
+		vic2 |= BIT_ULL(33);
+
+	max_tmds = sink_cap->max_tmds_clock;
+	if (info->max_tmds_char_rate > max_tmds)
+		max_tmds = info->max_tmds_char_rate;
+
+	offset = 0;
+	for (i = 0; i < SUPPORT_VIC_SIZE; i++) {
+		if (support_vic[i] <= 64) {
+
+			if (vic & BIT_ULL(support_vic[i]-1)) {
+				tx_support[offset].vic = support_vic[i];
+				tx_support[offset].rgb444 = get_rgb444_support(support_vic[i], sink_cap, info, max_tmds);
+				tx_support[offset].yuv422 = get_yuv422_support(support_vic[i], sink_cap, info, max_tmds);
+				tx_support[offset].yuv444 = get_yuv444_support(support_vic[i], sink_cap, info, max_tmds);
+				tx_support[offset].support_3d = get_3d_support(support_vic[i], sink_cap, info, max_tmds);
+				tx_support[offset].support_fs = get_fs_support(support_vic[i], tx_support[offset].support_3d);
+				offset++;
+			}
+
+		} else {
+
+			if (vic2 & BIT_ULL(support_vic[i]-65)) {
+				tx_support[offset].vic = support_vic[i];
+				tx_support[offset].rgb444 = get_rgb444_support(support_vic[i], sink_cap, info, max_tmds);
+				tx_support[offset].yuv422 = get_yuv422_support(support_vic[i], sink_cap, info, max_tmds);
+				tx_support[offset].yuv444 = get_yuv444_support(support_vic[i], sink_cap, info, max_tmds);
+				tx_support[offset].support_3d = get_3d_support(support_vic[i], sink_cap, info, max_tmds);
+				tx_support[offset].support_fs = get_fs_support(support_vic[i], tx_support[offset].support_3d);
+
+				if (vic2_420 & BIT_ULL(support_vic[i]-65))
+					tx_support[offset].yuv420 = get_yuv420_support(support_vic[i], sink_cap, info, max_tmds);
+
+				offset++;
+			} else if (vic2_420 & BIT_ULL(support_vic[i]-65)) {
+				/* Only support 420*/
+				tx_support[offset].vic = support_vic[i];
+				tx_support[offset].yuv420 = get_yuv420_support(support_vic[i], sink_cap, info, max_tmds);
+				tx_support[offset].support_fs = get_fs_support(support_vic[i], 0);
+				offset++;
+			}
+
+		}
+	}
+
+	return offset;
+}
+
+unsigned int
+vic_to_vo_standard(unsigned char vic, unsigned char freq_shift,
+	unsigned char color, unsigned char color_depth, unsigned char en_3d)
+{
+	unsigned int ret_val;
+
+	switch (vic) {
+	case VIC_720X480P60:
+		if (en_3d)
+			ret_val = VO_STANDARD_ERROR;
+		else
+			ret_val = VO_STANDARD_NTSC_J;
+		break;
+	case VIC_1280X720P60:
+		if (freq_shift) {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_720P_59_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_720P_59;
+		} else {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_720P_60_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_720P_60;
+		}
+		break;
+	case VIC_1920X1080I60:
+		if (freq_shift) {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_1080I_59_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_1080I_59;
+		} else {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_1080I_60_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_1080I_60;
+		}
+		break;
+	case VIC_720X480I60:
+		if (en_3d)
+			ret_val = VO_STANDARD_ERROR;
+		else
+			ret_val = VO_STANDARD_NTSC_J;
+		break;
+	case VIC_1920X1080P60:
+		if (freq_shift) {
+			if (en_3d)
+				ret_val = VO_STANDARD_ERROR;
+			else
+				ret_val = VO_STANDARD_HDTV_1080P_59;
+		} else {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_1080P_60_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_1080P_60;
+		}
+		break;
+	case VIC_720X576P50:
+		if (en_3d)
+			ret_val = VO_STANDARD_ERROR;
+		else
+			ret_val = VO_STANDARD_PAL_I;
+		break;
+	case VIC_1280X720P50:
+		if (freq_shift) {
+			ret_val = VO_STANDARD_ERROR;
+		} else {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_720P_50_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_720P_50;
+		}
+		break;
+	case VIC_1920X1080I50:
+		if (freq_shift)
+			ret_val = VO_STANDARD_ERROR;
+		else if (en_3d)
+			ret_val = VO_STANDARD_HDTV_1080I_50_3D;
+		else
+			ret_val = VO_STANDARD_HDTV_1080I_50;
+		break;
+	case VIC_720X576I50:
+		if (en_3d)
+			ret_val = VO_STANDARD_ERROR;
+		else
+			ret_val = VO_STANDARD_PAL_I;
+		break;
+	case VIC_1920X1080P50:
+		if (freq_shift)
+			ret_val = VO_STANDARD_ERROR;
+		else if (en_3d)
+			ret_val = VO_STANDARD_HDTV_1080P_50_3D;
+		else
+			ret_val = VO_STANDARD_HDTV_1080P_50;
+		break;
+	case VIC_1920X1080P24:
+		if (freq_shift) {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_1080P_23_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_1080P_23;
+		} else {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_1080P_24_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_1080P_24;
+		}
+		break;
+	case VIC_1920X1080P25:
+		if (freq_shift || en_3d)
+			ret_val = VO_STANDARD_ERROR;
+		else
+			ret_val = VO_STANDARD_HDTV_1080P_25;
+		break;
+	case VIC_1920X1080P30:
+		if (freq_shift)
+			ret_val = VO_STANDARD_ERROR;
+		else if (en_3d)
+			ret_val = VO_STANDARD_HDTV_1080P_30_3D;
+		else
+			ret_val = VO_STANDARD_HDTV_1080P_30;
+		break;
+	case VIC_3840X2160P24:
+		if (freq_shift) {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_2160P_23_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_2160P_23;
+		} else {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_2160P_24_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_2160P_24;
+		}
+		break;
+	case VIC_3840X2160P25:
+		if (freq_shift)
+			ret_val = VO_STANDARD_ERROR;
+		else if (en_3d)
+			ret_val = VO_STANDARD_HDTV_2160P_25_3D;
+		else
+			ret_val = VO_STANDARD_HDTV_2160P_25;
+		break;
+	case VIC_3840X2160P30:
+		if (freq_shift) {
+			if (en_3d)
+				ret_val = VO_STANDARD_ERROR;
+			else
+				ret_val = VO_STANDARD_HDTV_2160P_29;
+		} else {
+			if (en_3d)
+				ret_val = VO_STANDARD_HDTV_2160P_30_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_2160P_30;
+		}
+		break;
+	case VIC_3840X2160P50:
+		if (color == COLOR_YUV420) {
+			if (freq_shift || en_3d)
+				ret_val = VO_STANDARD_ERROR;
+			else
+				ret_val = VO_STANDARD_HDTV_2160P_50_420;
+		} else if ((color == COLOR_YUV422) && (color_depth == 12)) {
+			ret_val = VO_STANDARD_HDTV_2160P_50_422_12bit;
+		} else {
+			if (freq_shift) {
+				ret_val = VO_STANDARD_ERROR;
+			} else {
+				if (en_3d)
+					ret_val = VO_STANDARD_HDTV_2160P_50_3D;
+				else
+					ret_val = VO_STANDARD_HDTV_2160P_50;
+			}
+		}
+		break;
+	case VIC_3840X2160P60:
+		if (color == COLOR_YUV420) {
+			if (en_3d)
+				ret_val = VO_STANDARD_ERROR;
+			else if (freq_shift)
+				ret_val = VO_STANDARD_HDTV_2160P_59_420;
+			else
+				ret_val = VO_STANDARD_HDTV_2160P_60_420;
+		} else if ((color == COLOR_YUV422) && (color_depth == 12)) {
+			ret_val = VO_STANDARD_HDTV_2160P_60_422_12bit;
+		} else {
+			if (freq_shift && en_3d)
+				ret_val = VO_STANDARD_ERROR;
+			else if (freq_shift)
+				ret_val = VO_STANDARD_HDTV_2160P_59;
+			else if (en_3d)
+				ret_val = VO_STANDARD_HDTV_2160P_60_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_2160P_60;
+		}
+		break;
+	case VIC_4096X2160P24:
+		if (freq_shift)
+			ret_val = VO_STANDARD_ERROR;
+		else if (en_3d)
+			ret_val = VO_STANDARD_HDTV_4096_2160P_24_3D;
+		else
+			ret_val = VO_STANDARD_HDTV_4096_2160P_24;
+		break;
+	case VIC_4096X2160P25:
+		if (freq_shift)
+			ret_val = VO_STANDARD_ERROR;
+		else if (en_3d)
+			ret_val = VO_STANDARD_HDTV_4096_2160P_25_3D;
+		else
+			ret_val = VO_STANDARD_HDTV_4096_2160P_25;
+		break;
+	case VIC_4096X2160P30:
+		if (freq_shift)
+			ret_val = VO_STANDARD_ERROR;
+		else if (en_3d)
+			ret_val = VO_STANDARD_HDTV_4096_2160P_30_3D;
+		else
+			ret_val = VO_STANDARD_HDTV_4096_2160P_30;
+		break;
+	case VIC_4096X2160P50:
+		if (color == COLOR_YUV420) {
+			if (freq_shift || en_3d)
+				ret_val = VO_STANDARD_ERROR;
+			else
+				ret_val = VO_STANDARD_HDTV_4096_2160P_50_420;
+		} else {
+			if (freq_shift)
+				ret_val = VO_STANDARD_ERROR;
+			else if (en_3d)
+				ret_val = VO_STANDARD_HDTV_4096_2160P_50_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_4096_2160P_50;
+		}
+		break;
+	case VIC_4096X2160P60:
+		if (color == COLOR_YUV420) {
+			if (freq_shift || en_3d)
+				ret_val = VO_STANDARD_ERROR;
+			else
+				ret_val = VO_STANDARD_HDTV_4096_2160P_60_420;
+		} else {
+			if (freq_shift)
+				ret_val = VO_STANDARD_ERROR;
+			else if (en_3d)
+				ret_val = VO_STANDARD_HDTV_4096_2160P_60_3D;
+			else
+				ret_val = VO_STANDARD_HDTV_4096_2160P_60;
+		}
+		break;
+	default:
+		ret_val = VO_STANDARD_ERROR;
+		break;
+	} /* end of switch (vic) */
+
+	if (ret_val >= VO_STANDARD_ERROR)
+		HDMI_ERROR("Convert VO_STANDARD fail, vic(%u) freq_shift(%u) color(%u) 3d(%u)",
+			vic, freq_shift, color, en_3d);
+
+	return ret_val;
+}
+
+unsigned char vo_standard_to_vic(unsigned int vo_standard, unsigned char is_interlace)
+{
+	unsigned char vic;
+
+	switch (vo_standard) {
+	case VO_STANDARD_NTSC_J:
+		if (is_interlace)
+			vic = VIC_720X480I60;
+		else
+			vic = VIC_720X480P60;
+		break;
+	case VO_STANDARD_PAL_I:
+		if (is_interlace)
+			vic = VIC_720X576I50;
+		else
+			vic = VIC_720X576P50;
+		break;
+	case VO_STANDARD_HDTV_720P_50:
+	case VO_STANDARD_HDTV_720P_50_3D:
+		vic = VIC_1280X720P50;
+		break;
+	case VO_STANDARD_HDTV_720P_59:
+	case VO_STANDARD_HDTV_720P_60:
+	case VO_STANDARD_HDTV_720P_59_3D:
+	case VO_STANDARD_HDTV_720P_60_3D:
+		vic = VIC_1280X720P60;
+		break;
+	case VO_STANDARD_HDTV_1080I_50:
+	case VO_STANDARD_HDTV_1080I_50_3D:
+		vic = VIC_1920X1080I50;
+		break;
+	case VO_STANDARD_HDTV_1080P_23:
+	case VO_STANDARD_HDTV_1080P_24:
+	case VO_STANDARD_HDTV_1080P_23_3D:
+	case VO_STANDARD_HDTV_1080P_24_3D:
+		vic = VIC_1920X1080P24;
+		break;
+	case VO_STANDARD_HDTV_1080P_25:
+		vic = VIC_1920X1080P25;
+		break;
+	case VO_STANDARD_HDTV_1080P_30:
+	case VO_STANDARD_HDTV_1080P_30_3D:
+		vic = VIC_1920X1080P30;
+		break;
+	case VO_STANDARD_HDTV_1080P_50:
+	case VO_STANDARD_HDTV_1080P_50_3D:
+		vic = VIC_1920X1080P50;
+		break;
+	case VO_STANDARD_HDTV_1080I_59:
+	case VO_STANDARD_HDTV_1080I_60:
+	case VO_STANDARD_HDTV_1080I_59_3D:
+	case VO_STANDARD_HDTV_1080I_60_3D:
+		vic = VIC_1920X1080I60;
+		break;
+	case VO_STANDARD_HDTV_1080P_59:
+	case VO_STANDARD_HDTV_1080P_60:
+	case VO_STANDARD_HDTV_1080P_60_3D:
+		vic = VIC_1920X1080P60;
+		break;
+	case VO_STANDARD_HDTV_2160P_23:
+	case VO_STANDARD_HDTV_2160P_24:
+	case VO_STANDARD_HDTV_2160P_23_3D:
+	case VO_STANDARD_HDTV_2160P_24_3D:
+		vic = VIC_3840X2160P24;
+		break;
+	case VO_STANDARD_HDTV_2160P_25:
+	case VO_STANDARD_HDTV_2160P_25_3D:
+		vic = VIC_3840X2160P25;
+		break;
+	case VO_STANDARD_HDTV_2160P_29:
+	case VO_STANDARD_HDTV_2160P_30:
+	case VO_STANDARD_HDTV_2160P_30_3D:
+		vic = VIC_3840X2160P30;
+		break;
+	case VO_STANDARD_HDTV_2160P_50:
+	case VO_STANDARD_HDTV_2160P_50_420:
+	case VO_STANDARD_HDTV_2160P_50_3D:
+	case VO_STANDARD_HDTV_2160P_50_422_12bit:
+		vic = VIC_3840X2160P50;
+		break;
+	case VO_STANDARD_HDTV_2160P_59:
+	case VO_STANDARD_HDTV_2160P_60:
+	case VO_STANDARD_HDTV_2160P_59_420:
+	case VO_STANDARD_HDTV_2160P_60_420:
+	case VO_STANDARD_HDTV_2160P_60_3D:
+	case VO_STANDARD_HDTV_2160P_60_422_12bit:
+		vic = VIC_3840X2160P60;
+		break;
+	case VO_STANDARD_HDTV_4096_2160P_24:
+	case VO_STANDARD_HDTV_4096_2160P_24_3D:
+		vic = VIC_4096X2160P24;
+		break;
+	case VO_STANDARD_HDTV_4096_2160P_25:
+	case VO_STANDARD_HDTV_4096_2160P_25_3D:
+		vic = VIC_4096X2160P25;
+		break;
+	case VO_STANDARD_HDTV_4096_2160P_30:
+	case VO_STANDARD_HDTV_4096_2160P_30_3D:
+		vic = VIC_4096X2160P30;
+		break;
+	case VO_STANDARD_HDTV_4096_2160P_50:
+	case VO_STANDARD_HDTV_4096_2160P_50_420:
+	case VO_STANDARD_HDTV_4096_2160P_50_3D:
+		vic = VIC_4096X2160P50;
+		break;
+	case VO_STANDARD_HDTV_4096_2160P_60:
+	case VO_STANDARD_HDTV_4096_2160P_60_420:
+	case VO_STANDARD_HDTV_4096_2160P_60_3D:
+		vic = VIC_4096X2160P60;
+		break;
+	default:
+		vic = 0;
+		HDMI_ERROR("%s fail", __func__);
+	}
+
+	return vic;
+}
+
+unsigned char is_freq_shift(unsigned int vo_standard)
+{
+	unsigned int ret_val;
+
+	switch (vo_standard) {
+	case VO_STANDARD_HDTV_720P_59:
+	case VO_STANDARD_HDTV_720P_59_3D:
+	case VO_STANDARD_HDTV_1080I_59:
+	case VO_STANDARD_HDTV_1080I_59_3D:
+	case VO_STANDARD_HDTV_1080P_23:
+	case VO_STANDARD_HDTV_1080P_23_3D:
+	case VO_STANDARD_HDTV_1080P_59:
+	case VO_STANDARD_HDTV_2160P_23:
+	case VO_STANDARD_HDTV_2160P_23_3D:
+	case VO_STANDARD_HDTV_2160P_29:
+	case VO_STANDARD_HDTV_2160P_59:
+	case VO_STANDARD_HDTV_2160P_59_420:
+		ret_val = 1;
+		break;
+	default:
+		ret_val = 0;
+	}
+
+	return ret_val;
+}
+
+unsigned int is_interlace_mode(unsigned int vic)
+{
+	unsigned int ret_val;
+
+	switch (vic) {
+	case VIC_1920X1080I60:
+	case VIC_720X480I60:
+	case VIC_1920X1080I50:
+	case VIC_720X576I50:
+		ret_val = 1;
+		break;
+	default:
+		ret_val = 0;
+		break;
+	}
+
+	return ret_val;
+}
+
+void set_colorimetry(unsigned int color_mode, struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *tv_system)
+{
+	unsigned int standard;
+	unsigned char data_byte2;
+	unsigned char data_byte3;
+	unsigned char colorimetry;
+
+	standard = tv_system->videoInfo.standard;
+	/* mask out C1:C0 */
+	data_byte2 = tv_system->hdmiInfo.dataByte2&0x3F;
+	/* mask out EC2:EC1:EC0 */
+	data_byte3 = tv_system->hdmiInfo.dataByte3&0x8F;
+
+	colorimetry = hdmitx_edid_info.colorimetry;
+
+	if (color_mode == COLOR_RGB) {
+
+		if (colorimetry&BT2020_RGB) {
+			data_byte2 |= 0xC0;
+			data_byte3 |= 0x60;
+		} else if (standard >= VO_STANDARD_HDTV_720P_60) {
+			data_byte2 |= 0x80;/* BT.709 */
+		} else {
+			data_byte2 |= 0x40;/* SMPTE170M */
+		}
+
+	} else {
+
+		if (colorimetry&BT2020_YCC) {
+			data_byte2 |= 0xC0;
+			data_byte3 |= 0x60;
+		} else if ((colorimetry&xvYCC709) &&
+			(standard >= VO_STANDARD_HDTV_720P_60)) {
+			data_byte2 |= 0xC0;
+			data_byte3 |= 0x10;
+		} else if ((colorimetry&xvYCC601) &&
+			(standard < VO_STANDARD_HDTV_720P_60)) {
+			data_byte2 |= 0xC0;
+			data_byte3 |= 0x00;
+		} else if (standard >= VO_STANDARD_HDTV_720P_60) {
+			data_byte2 |= 0x80;
+		} else {
+			data_byte2 |= 0x40;
+		}
+
+	}
+
+	tv_system->hdmiInfo.dataByte2 = data_byte2;
+	tv_system->hdmiInfo.dataByte3 = data_byte3;
+
+}
+
+void set_aspect_ratio(unsigned int vic, struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *tv_system)
+{
+	unsigned char data_byte2;
+
+	/* mask out M1:R0 */
+	data_byte2 = tv_system->hdmiInfo.dataByte2&0xC0;
+
+	switch (vic) {
+	case 2:
+	case 6:
+	case 17:
+	case 21:
+		data_byte2 |= 0x18;
+		break;
+	default:
+		data_byte2 |= 0x28;
+		break;
+	}
+
+	tv_system->hdmiInfo.dataByte2 = data_byte2;
+}
+
+void config_avi_infoframe(unsigned int vic, unsigned int color_mode, struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *tv_system)
+{
+	unsigned char data_byte1;
+	unsigned char data_byte4;
+
+	/* Data Byte1 */
+	switch (color_mode) {
+	case COLOR_RGB:
+		data_byte1 = 0x0;
+		break;
+	case COLOR_YUV422:
+		data_byte1 = 0x20;
+		break;
+	case COLOR_YUV444:
+		data_byte1 = 0x40;
+		break;
+	case COLOR_YUV420:
+		data_byte1 = 0x60;
+		break;
+	default:
+		data_byte1 = 0x0;
+		HDMI_ERROR("Unknown color_mode");
+		break;
+	}
+
+	tv_system->hdmiInfo.dataByte1 = data_byte1;
+
+	/* Data Byte2, Data Byte3 */
+	set_colorimetry(color_mode, tv_system);
+	set_aspect_ratio(vic, tv_system);
+
+	/* Data Byte4 */
+	data_byte4 = (unsigned char)vic;
+	tv_system->hdmiInfo.dataByte4 = data_byte4;
+
+}
+
+void config_video_dataint0(unsigned char _3d_format, unsigned int vic,
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *tv_system)
+{
+	unsigned int video_dataint0;
+
+	video_dataint0 = 0;
+
+	/*
+	 * videoInfo.dataInt0: [BIT15:12]=3d_src [BIT11:8]=3d_dest
+	 * RTK DVD player, 3d_dest always set to 1
+	 * Other player, 3d_src always set to 0
+	 */
+	switch (_3d_format) {
+	case FORMAT_RTK_3D_FP:
+		video_dataint0 |= 0x1100;
+		break;
+	case FORMAT_RTK_3D_SS:
+		video_dataint0 |= 0x2100;
+		break;
+	case FORMAT_RTK_3D_TB:
+		video_dataint0 |= 0x3100;
+		break;
+	case FORMAT_3D_FP:
+		video_dataint0 |= 0x0100;
+		break;
+	case FORMAT_3D_SS:
+		video_dataint0 |= 0x0200;
+		break;
+	case FORMAT_3D_TB:
+		video_dataint0 |= 0x0300;
+		break;
+	default:
+		break;
+	}
+
+	switch (vic) {
+	case VIC_720X576P50:
+	case VIC_1280X720P50:
+	case VIC_1920X1080I50:
+	case VIC_720X576I50:
+	case VIC_1920X1080P50:
+	case VIC_1920X1080P25:
+	case VIC_3840X2160P25:
+	case VIC_3840X2160P50:
+	case VIC_4096X2160P25:
+	case VIC_4096X2160P50:
+		/* CVBS PAL */
+		video_dataint0 |= 0x2;
+		break;
+	default:
+		/* CVBS NTSC */
+		video_dataint0 |= 0x4;
+		break;
+	}
+
+	tv_system->videoInfo.dataInt0 = video_dataint0;
+}
+
+void config_hdr_mode(unsigned char hdr_mode, struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *tv_system)
+{
+	switch (hdr_mode) {
+	case HDR_MODE_AUTO:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_AUTO;
+		break;
+	case HDR_MODE_DV:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_DV_ON;
+		break;
+	case HDR_MODE_SDR:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_SDR;
+		break;
+	case HDR_MODE_GAMMA:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_HDR_GAMMA;
+		break;
+	case HDR_MODE_HDR10:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_PQHDR;
+		break;
+	case HDR_MODE_FUTURE:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_FUTURE;
+		break;
+	case HDR_MODE_INPUT:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_INPUT;
+		break;
+	case HDR_MODE_DV_12B_YUV422:
+		tv_system->hdmiInfo.hdr_ctrl_mode =	VO_HDR_CTRL_DV_LOW_LATENCY_12b_YUV422;
+		break;
+	case HDR_MODE_DV_10B_YUV444:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_DV_LOW_LATENCY_10b_YUV444;
+		break;
+	case HDR_MODE_DV_10B_RGB444:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_DV_LOW_LATENCY_10b_RGB444;
+		break;
+	case HDR_MODE_DV_12B_YUV444:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_DV_LOW_LATENCY_12b_YUV444;
+		break;
+	case HDR_MODE_DV_12B_RGB444:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_DV_LOW_LATENCY_12b_RGB444;
+		break;
+	case HDR_MODE_DV_ON_INPUT:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_DV_ON_INPUT;
+		break;
+	case HDR_MODE_DV_ON_LOW_LATENCY_12b422_INPUT:
+		tv_system->hdmiInfo.hdr_ctrl_mode = VO_HDR_CTRL_DV_ON_LOW_LATENCY_12b422_INPUT;
+		break;
+	default:
+		HDMI_ERROR("Unknown HDR mode %u", hdr_mode);
+		break;
+	}
+
+}
+
+void config_dp_related(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *tv_system)
+{
+	int ret;
+	unsigned int hdmiMode;
+	unsigned int interfaceType;
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM cur_tv_system;
+
+	if (!displayport_exist) {
+		HDMI_INFO("Skip config dp related");
+		goto exit;
+	}
+
+	ret = RPC_ToAgent_QueryConfigTvSystem(&cur_tv_system);
+
+	if (ret != 0)
+		goto fail;
+
+	if (vo_interface_type >= 0) {
+		interfaceType = vo_interface_type;
+		goto config;
+	}
+
+	HDMI_INFO("Auto select interface type");
+	hdmiMode = tv_system->hdmiInfo.hdmiMode;
+
+	switch (cur_tv_system.interfaceType) {
+	case VO_ANALOG_AND_DIGITAL:
+	case VO_ANALOG_ONLY:
+	case VO_DIGITAL_ONLY:
+		interfaceType = cur_tv_system.interfaceType;
+		break;
+	case VO_DISPLAY_PORT_ONLY:
+		if (hdmiMode != VO_HDMI_OFF)
+			interfaceType = VO_HDMI_AND_DISPLAY_PORT_SAME_SOURCE;
+		else
+			interfaceType = VO_DISPLAY_PORT_ONLY;
+		break;
+	case VO_HDMI_AND_DISPLAY_PORT_SAME_SOURCE:
+		if (hdmiMode != VO_HDMI_OFF)
+			interfaceType = VO_HDMI_AND_DISPLAY_PORT_SAME_SOURCE;
+		else
+			interfaceType = VO_DISPLAY_PORT_ONLY;
+		break;
+	case VO_HDMI_AND_DISPLAY_PORT_DIFF_SOURCE:
+			interfaceType = VO_HDMI_AND_DISPLAY_PORT_DIFF_SOURCE;
+		break;
+	case VO_DISPLAY_PORT_AND_CVBS_SAME_SOURCE:
+		if (hdmiMode != VO_HDMI_OFF)
+			interfaceType = VO_HDMI_AND_DISPLAY_PORT_SAME_SOURCE;
+		else
+			interfaceType = VO_DISPLAY_PORT_AND_CVBS_SAME_SOURCE;
+		break;
+	case VO_HDMI_AND_DP_DIFF_SOURCE_WITH_CVBS:
+	case VO_FORCE_DP_OFF:
+		interfaceType = cur_tv_system.interfaceType;
+		break;
+	default:
+		HDMI_INFO("%s, unknown interfaceType %u", __func__,
+			cur_tv_system.interfaceType);
+		break;
+	}
+
+config:
+	tv_system->interfaceType = interfaceType;
+	tv_system->videoInfo.pedType = cur_tv_system.videoInfo.pedType;
+
+	HDMI_INFO("interfaceType %u -> %u, pedType %u",
+		cur_tv_system.interfaceType, tv_system->interfaceType, tv_system->videoInfo.pedType);
+exit:
+	return;
+fail:
+	HDMI_ERROR("%s fail", __func__);
+}
+
+/**
+ * tv_system_to_hdmi_format - Convert struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM to
+ *                                             struct hdmi_format_setting
+ * @tv_system: Input struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM
+ * @format: Output struct hdmi_format_setting
+ *
+ * Return: 0 on success, other on failure
+ */
+int tv_system_to_hdmi_format(struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM *tv_system,
+	struct hdmi_format_setting *format)
+{
+	int ret;
+	unsigned char is_interlace;
+	unsigned char dataInt0_depth;
+	unsigned char dataInt0_3d;
+
+	ret = 0;
+	memset(format, 0, sizeof(struct hdmi_format_setting));
+
+	switch (tv_system->hdmiInfo.hdmiMode) {
+	case VO_HDMI_OFF:
+		format->mode = FORMAT_MODE_OFF;
+		break;
+	case VO_DVI_ON:
+		format->mode = FORMAT_MODE_DVI;
+		break;
+	case VO_HDMI_ON:
+		format->mode = FORMAT_MODE_HDMI;
+		break;
+	default:
+		ret = -1;
+		HDMI_ERROR("Convert fail, unknown hdmiMode");
+	}
+
+	if (tv_system->videoInfo.enProg)
+		is_interlace = 0;
+	else
+		is_interlace = 1;
+
+	format->vic = vo_standard_to_vic(tv_system->videoInfo.standard, is_interlace);
+
+	format->freq_shift = is_freq_shift(tv_system->videoInfo.standard);
+
+	format->color = (tv_system->hdmiInfo.dataByte1>>5)&0x3;
+
+	dataInt0_depth = (tv_system->hdmiInfo.dataInt0>>2)&0xF;
+	switch (dataInt0_depth) {
+	case 5:
+		format->color_depth = 10;
+		break;
+	case 6:
+		format->color_depth = 12;
+		break;
+	default:
+		format->color_depth = 8;
+	}
+
+	dataInt0_3d = (tv_system->videoInfo.dataInt0>>8)&0xFF;
+	switch (dataInt0_3d) {
+	case 0x0:
+		format->_3d_format = FORMAT_3D_OFF;
+		break;
+	case 0x11:
+		format->_3d_format = FORMAT_RTK_3D_FP;
+		break;
+	case 0x21:
+		format->_3d_format = FORMAT_RTK_3D_SS;
+		break;
+	case 0x31:
+		format->_3d_format = FORMAT_RTK_3D_TB;
+		break;
+	case 0x10:
+		format->_3d_format = FORMAT_3D_FP;
+		break;
+	case 0x20:
+		format->_3d_format = FORMAT_3D_SS;
+		break;
+	case 0x30:
+		format->_3d_format = FORMAT_3D_TB;
+		break;
+	default:
+		format->_3d_format = FORMAT_3D_OFF;
+		HDMI_ERROR("Unknown 3D mode");
+	}
+
+	format->hdr = tv_system->hdmiInfo.hdr_ctrl_mode;
+
+	return ret;
+}
+
+int set_hdmitx_format(struct hdmi_format_setting *format)
+{
+	int ret = 0;
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM tv_system;
+	unsigned int standard;
+	unsigned int interlace;
+	unsigned int dataint0;
+	unsigned char en_3d;
+	unsigned char scramble;
+
+	HDMI_INFO("Set format: vic=%u color_mode=%u color_depth=%u 3D=%u HDR=%u",
+		format->vic, format->color, format->color_depth,
+		format->_3d_format, format->hdr);
+
+	memset(&tv_system, 0, sizeof(tv_system));
+
+	if ((format->vic == 0) || (format->mode == FORMAT_MODE_OFF)) {
+		/* HDMI OFF */
+		tv_system.videoInfo.standard = VO_STANDARD_NTSC_J;
+		tv_system.videoInfo.enProg = 0x1;
+		tv_system.videoInfo.pedType = 0x1;
+		tv_system.videoInfo.dataInt0 = 0x4;
+		tv_system.hdmiInfo.hdmiMode = VO_HDMI_OFF;
+
+		if (hdmi_clk_always_on) {
+			HDMI_INFO("Keep clock always on");
+			tv_system.hdmiInfo.hdmi_off_mode = VO_HDMI_OFF_CLOCK_ON;
+		} else {
+#if HDMI_RX_SENSE_SUPPORT
+			if (hdmitx_switch_get_hpd()) {
+				HDMI_INFO("Keep clock on when cable still connected");
+				tv_system.hdmiInfo.hdmi_off_mode = VO_HDMI_OFF_CLOCK_ON;
+			}
+#endif
+		}
+		goto config;
+	}
+
+	if (format->_3d_format != FORMAT_3D_OFF)
+		en_3d = 1;
+	else
+		en_3d = 0;
+
+	standard =  vic_to_vo_standard(format->vic, format->freq_shift,
+		format->color, format->color_depth, en_3d);
+
+	if (standard < VO_STANDARD_ERROR)
+		tv_system.videoInfo.standard = standard;
+	else
+		ret = -EFAULT;
+
+	if (format->mode == FORMAT_MODE_DVI)
+		tv_system.hdmiInfo.hdmiMode = VO_DVI_ON;
+	else
+		tv_system.hdmiInfo.hdmiMode = VO_HDMI_ON;
+
+	tv_system.videoInfo.enDIF = 0x1;
+	tv_system.videoInfo.enCompRGB = 0;
+	tv_system.videoInfo.pedType = 0x1;
+	tv_system.hdmiInfo.audioSampleFreq = 0x3;
+	tv_system.hdmiInfo.audioChannelCount = 0x1;
+
+	interlace = is_interlace_mode(format->vic);
+	if (interlace != 0)
+		tv_system.videoInfo.enProg = 0;
+	else
+		tv_system.videoInfo.enProg = 1;
+
+	config_avi_infoframe(format->vic, format->color, &tv_system);
+
+	/* mask out  color_depth */
+	dataint0 = tv_system.hdmiInfo.dataInt0&(~0x3E);
+
+	switch (format->color_depth) {
+	case 8:
+		dataint0 |= 0x0;
+		break;
+	case 10:
+		dataint0 |= 0x16;
+		break;
+	case 12:
+		dataint0 |= 0x1A;
+		break;
+	default:
+		HDMI_ERROR("Unknown color_depth");
+		break;
+	}
+
+	tv_system.hdmiInfo.dataInt0 = dataint0;
+
+	/* 3D format, CVBS format */
+	config_video_dataint0(format->_3d_format, format->vic, &tv_system);
+
+	/* HDR mode */
+	config_hdr_mode(format->hdr, &tv_system);
+
+	if (tv_system.hdmiInfo.hdmiMode == VO_HDMI_ON) {
+		if (hdmitx_edid_info.hdmi_id == HDMI_2P0_IDENTIFIER)
+			tv_system.hdmiInfo.hdmi2p0_feature |= 0x1;
+
+		scramble = hdmitx_send_scdc_TmdsConfig(tv_system.videoInfo.standard,
+			tv_system.hdmiInfo.dataInt0, tv_system.hdmiInfo.dataByte1);
+
+		if (scramble != 0)
+			tv_system.hdmiInfo.hdmi2p0_feature |= 0x2;
+	}
+
+config:
+	/* For DisplayPort */
+	config_dp_related(&tv_system);
+
+	/* Send RPC */
+	RPC_TOAGENT_HDMI_Config_TV_System(&tv_system);
+
+	return ret;
+}
+
+int get_hdmitx_format(struct hdmi_format_setting *format)
+{
+	int ret;
+
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM hdmitx_tv_system;
+
+	ret = RPC_ToAgent_QueryConfigTvSystem(&hdmitx_tv_system);
+
+	tv_system_to_hdmi_format(&hdmitx_tv_system, format);
+
+	return ret;
+}
+
+/**
+ * set_vo_interfaceType - store service dp setting
+ * @type: enum VO_INTERFACE_TYPE
+ */
+void set_vo_interface_type(int type)
+{
+	vo_interface_type = type;
+}
+
+ssize_t config_tv_system_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count;
+	int i;
+
+	ret_count = 0;
+	ret_count += sprintf(buf + ret_count, "===== Command format =====\n");
+	ret_count += sprintf(buf + ret_count,
+		"echo \"Arg1 Arg2 Arg3\" > config_tv_system\n");
+	ret_count += sprintf(buf + ret_count,
+		"echo \"Arg1 Arg2 Arg3 Arg4 Arg5\" > config_tv_system\n");
+
+	ret_count += sprintf(buf + ret_count, "@Arg1:\n");
+	for (i = 0; i < 24; i++)
+		ret_count += sprintf(buf + ret_count, "%s\n", string_list[i]);
+
+	ret_count += sprintf(buf + ret_count, "@Arg2:\n");
+	ret_count += sprintf(buf + ret_count, "0 - RGB444\n");
+	ret_count += sprintf(buf + ret_count, "1 - YUV422\n");
+	ret_count += sprintf(buf + ret_count, "2 - YUV444\n");
+	ret_count += sprintf(buf + ret_count, "3 - YUV420(4Kp50/60)\n");
+
+	ret_count += sprintf(buf + ret_count, "@Arg3:\n");
+	ret_count += sprintf(buf + ret_count, "8 - 8Bit\n");
+	ret_count += sprintf(buf + ret_count, "10 - 10Bit\n");
+	ret_count += sprintf(buf + ret_count, "12 - 12Bit\n");
+
+	ret_count += sprintf(buf + ret_count, "@Arg4:\n");
+	ret_count += sprintf(buf + ret_count, "0 - No freq shift\n");
+	ret_count += sprintf(buf + ret_count, "1 - Freq shift\n");
+
+	ret_count += sprintf(buf + ret_count, "@Arg5:\n");
+	ret_count += sprintf(buf + ret_count, "0 - No 3D\n");
+	ret_count += sprintf(buf + ret_count, "1 - RTK Frame Packing\n");
+	ret_count += sprintf(buf + ret_count, "2 - RTK Side by side half\n");
+	ret_count += sprintf(buf + ret_count, "3 - RTK Top and Buttom\n");
+	ret_count += sprintf(buf + ret_count, "4 - Frame Packing\n");
+	ret_count += sprintf(buf + ret_count, "5 - Side by side half\n");
+	ret_count += sprintf(buf + ret_count, "6 - Top and Buttom\n");
+
+	return ret_count;
+}
+
+ssize_t config_tv_system_store(struct device *dev, struct device_attribute *attr, const char *buf, size_t size)
+{
+	int ret = -ENOMEM;
+	char *cur;
+	char *token1;
+	char *token2;
+	char *token3;
+	char *token4;
+	char *token5;
+	unsigned int val1;
+	unsigned int val2;
+	unsigned int val3;
+	unsigned int val4;
+	unsigned int val5;
+	struct hdmi_format_setting format;
+	void __iomem *vaddr;
+
+	HDMI_DEBUG("[%s] Enter", __func__);
+
+	val4 = 0;
+	val5 = 0;
+
+	cur = (char *)buf;
+	/* VIC */
+	token1 = strsep(&cur, " ");
+
+	/* Color mode */
+	if (token1 != NULL)
+		token2 = strsep(&cur, " ");
+	else
+		goto ret_error;
+
+	/* Color depth */
+	if (token2 != NULL)
+		token3 = strsep(&cur, " ");
+	else
+		goto ret_error;
+
+	/* freq shift */
+	if (token3 != NULL)
+		token4 = strsep(&cur, " ");
+	else
+		goto ret_error;
+
+	/* 3D */
+	if (token4 != NULL)
+		token5 = strsep(&cur, " ");
+	else
+		goto skip_fs;
+
+	if (token5 == NULL)
+		goto skip_fs;
+
+	ret = kstrtouint(token4, 0, &val4);
+	if (ret < 0)
+		goto ret_error;
+
+	ret = kstrtouint(token5, 0, &val5);
+	if (ret < 0)
+		goto ret_error;
+
+skip_fs:
+	ret = kstrtouint(token1, 0, &val1);
+	if (ret < 0)
+		goto ret_error;
+
+	ret = kstrtouint(token2, 0, &val2);
+	if (ret < 0)
+		goto ret_error;
+
+	ret = kstrtouint(token3, 0, &val3);
+	if (ret < 0)
+		goto ret_error;
+
+	memset(&format, 0, sizeof(format));
+	format.mode = FORMAT_MODE_HDMI;
+	format.vic = val1;
+	format.color = val2;
+	format.color_depth = val3;
+	format.freq_shift = val4;
+	format._3d_format = val5;
+	format.hdr = HDR_MODE_SDR;
+
+	if ((format.vic <= 102) && (format.color <= 3)) {
+		vaddr = ioremap(0x9800d000, 0x560);
+		hdmitx_send_AVmute(vaddr, 1);
+
+		set_hdmitx_format(&format);
+
+		hdmitx_send_AVmute(vaddr, 0);
+		iounmap(vaddr);
+	}
+
+	return size;
+ret_error:
+	HDMI_ERROR("[%s] Wrong argumet", __func__);
+	return -ENOMEM;
+}
+
+ssize_t edid_support_list_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count;
+	int i;
+
+	ret_count = sprintf(buf, "VIC: RGB444  YUV422  YUV444  YUV420  3D FS\n");
+
+	for (i = 0; i < tx_support_size; i++) {
+		ret_count += sprintf(buf + ret_count,
+			"%03u  %s/%s/%s %s/%s/%s %s/%s/%s %s/%s/%s  %s  %s\n",
+			tx_support[i].vic,
+			tx_support[i].rgb444&BIT(1)?"8":"-",
+			tx_support[i].rgb444&BIT(2)?"10":"--",
+			tx_support[i].rgb444&BIT(3)?"12":"--",
+			tx_support[i].yuv422&BIT(1)?"8":"-",
+			tx_support[i].yuv422&BIT(2)?"10":"--",
+			tx_support[i].yuv422&BIT(3)?"12":"--",
+			tx_support[i].yuv444&BIT(1)?"8":"-",
+			tx_support[i].yuv444&BIT(2)?"10":"--",
+			tx_support[i].yuv444&BIT(3)?"12":"--",
+			tx_support[i].yuv420&BIT(1)?"8":"-",
+			tx_support[i].yuv420&BIT(2)?"10":"--",
+			tx_support[i].yuv420&BIT(3)?"12":"--",
+			tx_support[i].support_3d&BIT(0)?"Y":"N",
+			tx_support[i].support_fs&BIT(0)?"Y":"N");
+	}
+
+	return ret_count;
+}
+
+/* /sys/devices/platform/9800d000.hdmitx/config_tv_system */
+DEVICE_ATTR(config_tv_system, 0644, config_tv_system_show, config_tv_system_store);
+/* /sys/devices/platform/9800d000.hdmitx/edid_support_list */
+DEVICE_ATTR(edid_support_list, 0444, edid_support_list_show, NULL);
+
+#ifndef CONFIG_RTK_HDCP_1x
+void register_config_tv_system_sysfs(struct device *dev)
+{
+	device_create_file(dev, &dev_attr_config_tv_system);
+}
+#endif
+
+void register_support_list_sysfs(struct device *dev)
+{
+	device_create_file(dev, &dev_attr_edid_support_list);
+}
+
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx_core.c b/drivers/media/platform/rtk_hdmitx/hdmitx_core.c
new file mode 100644
index 00000000..e356188
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx_core.c
@@ -0,0 +1,416 @@
+/*
+ * hdmitx_core.c - RTK hdmitx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/uaccess.h>
+#include <linux/kernel.h>
+#include <linux/types.h>
+
+#include <linux/miscdevice.h>
+#include <linux/platform_device.h>
+#include <linux/device.h>
+
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_gpio.h>
+
+#include <linux/reset.h>
+#include <linux/clk.h> /* clk_get */
+#include <linux/clk-provider.h>
+
+#include "hdmitx.h"
+#include "hdmitx_dev.h"
+#include "hdmitx_api.h"
+#include "hdmitx_rpc.h"
+#include "hdmitx_scdc.h"
+
+#include "compat_hdmitx.h"
+
+
+static int __init rtk_hdmi_init(void);
+static void __exit rtk_hdmi_exit(void);
+
+static asoc_hdmi_t hdmi_data;
+hdmitx_device_t tx_dev;
+
+/**
+ * hdmitx_get_raw_edid - get raw data of sink device EDID
+ * @edid: output data buffer
+ *
+ * Return:  0 on success, -E* on failure
+ */
+int hdmitx_get_raw_edid(unsigned char *edid)
+{
+	HDMI_DEBUG("%s", __func__);
+
+	if (!(hdmi_data.sink_cap_available)) {
+		HDMI_INFO("%s:EDID not ready", __func__);
+		return -ENOMSG;
+	}
+
+	if (memcpy(edid, hdmi_data.edid_ptr, sizeof(struct raw_edid)) == NULL) {
+		HDMI_INFO("%s:failed to copy EDID", __func__);
+		return -EFAULT;
+	}
+
+	return 0;
+}
+EXPORT_SYMBOL(hdmitx_get_raw_edid);
+
+int hdmitx_open(struct inode *inode, struct file *filp)
+{
+	if (nonseekable_open(inode, filp))
+		return -ENODEV;
+
+	filp->private_data = &tx_dev;
+
+	return 0;
+}
+
+/**
+ * hdmitx_ioctl -  ioctl function of hdmitx miscdev
+ * @file: my argument
+ * @cmd: control command
+ * @arg: arguments
+ *
+ * Return: 0 on success, -E* on failure
+ */
+static long hdmitx_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	hdmitx_device_t *dev = (hdmitx_device_t *) file->private_data;
+	asoc_hdmi_t *tx_data;
+
+	if (!dev)
+		return -ENODEV;
+
+	tx_data = hdmitx_get_drvdata(dev);
+
+	switch (cmd) {
+	case HDMI_GET_SINK_CAPABILITY:
+		return ops_get_sink_cap((void __user *)arg, tx_data);
+
+	case HDMI_GET_RAW_EDID:
+		return ops_get_raw_edid((void __user *)arg, tx_data);
+
+	case HDMI_CHECK_LINK_STATUS:
+		return ops_get_link_status((void __user *)arg);
+
+	case HDMI_GET_VIDEO_CONFIG:
+		return ops_get_video_config((void __user *)arg, tx_data);
+
+	case HDMI_SEND_AVMUTE:
+		return ops_send_AVmute((void __user *)arg, dev->reg_base);
+
+	case HDMI_CONFIG_TV_SYSTEM:
+		return ops_config_tv_system((void __user *)arg);
+
+	case HDMI_CONFIG_AVI_INFO:
+		return ops_config_avi_info((void __user *)arg);
+
+	case HDMI_SET_FREQUNCY:
+		return ops_set_frequency((void __user *)arg);
+
+	case HDMI_SEND_AUDIO_MUTE:
+		return ops_set_audio_mute((void __user *)arg);
+
+	case HDMI_SEND_AUDIO_VSDB_DATA:
+		return ops_send_audio_vsdb_data((void __user *)arg);
+
+	case HDMI_SEND_AUDIO_EDID2:
+		return ops_send_audio_edid2((void __user *)arg);
+
+	case HDMI_CHECK_TMDS_SRC:
+		return ops_check_tmds_src((void __user *)arg, dev->reg_base);
+
+	case HDMI_CHECK_Rx_Sense:
+		return ops_check_rx_sense((void __user *)arg, dev->reg_base);
+
+	case HDMI_GET_EXT_BLK_COUNT:
+		return ops_get_extension_blk_count((void __user *)arg, tx_data);
+
+	case HDMI_GET_EXTENDED_EDID:
+		return ops_get_extended_edid((void __user *)arg, tx_data);
+
+	case HDMI_QUERY_DISPLAY_STANDARD:
+		return ops_query_display_standard((void __user *)arg);
+
+	case HDMI_SEND_VOUT_EDID_DATA:
+		return ops_send_vout_edid_data((void __user *)arg);
+
+	case HDMI_GET_EDID_SUPPORT_LIST:
+		return ops_get_edid_support_list((void __user *)arg, tx_data);
+
+	case HDMI_SET_OUTPUT_FORMAT:
+		return ops_set_output_format((void __user *)arg);
+
+	case HDMI_GET_OUTPUT_FORMAT:
+		return ops_get_output_format((void __user *)arg);
+
+	case HDMI_SET_VO_INTERFACE_TYPE:
+		return ops_set_interface_type((void __user *)arg);
+
+	case HDMI_GET_CONFIG_TV_SYSTEM:
+		return ops_get_config_tv_system((void __user *)arg);
+
+#if 1//def __LINUX_MEDIA_NAS__
+	case HDMI_HOTPLUG_DETECTION:
+		return ops_set_hotplug_detection((void __user *)arg, dev);
+
+	case HDMI_WAIT_HOTPLUG:
+		return ops_wait_hotplug((void __user *)arg, dev);
+#endif
+	default:
+		HDMI_DEBUG(" Unknown ioctl cmd %08x", cmd);
+		return -EFAULT;
+	}
+}
+
+const struct file_operations hdmitx_fops = {
+	.owner			= THIS_MODULE,
+	.open			= hdmitx_open,
+	.unlocked_ioctl	= hdmitx_ioctl,
+#if !defined(CONFIG_COMPAT)
+	.compat_ioctl	= NULL,
+#else
+	.compat_ioctl	= compat_hdmitx_ioctl,
+#endif
+	.poll			= NULL,
+};
+
+/**
+ * register_hdmitx_miscdev - register hdmitx miscdev
+ * @device: hdmitx miscdev to be registered
+ *
+ * Return: 0 on success, -E* on failure
+ */
+int register_hdmitx_miscdev(hdmitx_device_t *device)
+{
+	struct miscdevice *miscdev = &device->miscdev;
+
+	miscdev->minor = MISC_DYNAMIC_MINOR;
+	miscdev->name = "hdmitx";
+	miscdev->mode = 0666;
+	miscdev->fops = &hdmitx_fops;
+
+	return misc_register(miscdev);
+}
+
+void deregister_hdmitx_miscdev(hdmitx_device_t *device)
+{
+	misc_deregister(&device->miscdev);
+}
+
+static int rtk_hdmitx_suspend(struct device *dev)
+{
+	int ret_val;
+	int hpd_state;
+
+	HDMI_INFO("Enter %s", __func__);
+
+	ret_val = rtk_hdmitx_switch_suspend();
+	hdmitx_scdcrr_suspend();
+
+	/* Send no scramble for prevent HDMI 5V still exist after suspend */
+	hpd_state = hdmitx_switch_get_state();
+	if (hpd_state == 1)
+		hdmitx_send_scdc_TmdsConfig(0, 0, 0);
+
+	HDMI_INFO("Exit %s", __func__);
+	return ret_val;
+}
+
+static int rtk_hdmitx_resume(struct device *dev)
+{
+	int ret_val;
+
+	HDMI_INFO("Enter %s", __func__);
+
+	hdmitx_scdcrr_resume();
+	ret_val = rtk_hdmitx_switch_resume();
+
+	HDMI_INFO("Exit %s", __func__);
+	return ret_val;
+}
+
+static void rtk_hdmitx_shutdown(struct platform_device *pdev)
+{
+	int hpd_state;
+
+	HDMI_INFO("Enter %s", __func__);
+
+	/* Send no scramble for prevent HDMI 5V still exist */
+	hpd_state = hdmitx_switch_get_state();
+	if (hpd_state == 1)
+		hdmitx_send_scdc_TmdsConfig(0, 0, 0);
+
+	HDMI_INFO("Exit %s", __func__);
+}
+
+static int rtk_hdmi_probe(struct platform_device *pdev)
+{
+	struct device_node *dptx_np;
+
+	HDMI_INFO("Driver init");
+
+	if (check_hdmi_mhl_mode())
+		goto end;
+
+	tx_dev.reg_base = of_iomap(pdev->dev.of_node, 0);
+
+	if (!tx_dev.reg_base) {
+		HDMI_ERROR("Can't map HDMI Tx registers");
+		goto end;
+	}
+
+	tx_dev.reset_hdmi = reset_control_get(&pdev->dev, "rstn_hdmi");
+	if (IS_ERR(tx_dev.reset_hdmi)) {
+		HDMI_ERROR("Can't get reset_control reset_hdmi");
+		goto end;
+	}
+
+	tx_dev.clk_hdmi = clk_get(&pdev->dev, "clk_en_hdmi");
+	if (IS_ERR(tx_dev.clk_hdmi)) {
+		HDMI_ERROR("Can't get clk clk_hdmi");
+		goto end;
+	}
+
+	if (register_hdmitx_miscdev(&tx_dev)) {
+		HDMI_ERROR("Could not register_hdmitx_miscdev");
+		goto end;
+	}
+
+	hdmi_data.edid_ptr = NULL;
+	hdmitx_reset_sink_capability(&hdmi_data);
+	hdmitx_set_drvdata(&tx_dev, &hdmi_data);
+
+	/* Initial hotplug gpio */
+	tx_dev.hpd_gpio = of_get_named_gpio(pdev->dev.of_node,
+		"gpio-hpd-detect", 0);
+
+	if (tx_dev.hpd_gpio < 0) {
+		HDMI_ERROR("Could not get gpio from of");
+		goto end;
+	} else {
+		HDMI_INFO("hotplug gpio(%d)", tx_dev.hpd_gpio);
+	}
+
+	if (gpio_request(tx_dev.hpd_gpio, pdev->dev.of_node->name))
+		HDMI_ERROR("Request gpio(%d) fail", tx_dev.hpd_gpio);
+
+	/* Get hotplug gpio irq */
+	tx_dev.hpd_irq = gpio_to_irq(tx_dev.hpd_gpio);
+	if (!tx_dev.hpd_irq) {
+		HDMI_ERROR("Fail to get hpd_irq");
+		goto end;
+	} else {
+		HDMI_DEBUG("irq_num(%u)\n", tx_dev.hpd_irq);
+	}
+
+	if (register_hdmitx_switchdev(&tx_dev)) {
+		HDMI_ERROR("Could not register_hdmitx_switchdev");
+		goto err_register;
+	}
+#if 1//__LINUX_MEDIA_NAS__
+	init_waitqueue_head(&tx_dev.hpd_wait);
+#endif
+	setup_mute_gpio(pdev->dev.of_node);
+
+	/* Initial SCDC read request */
+	register_hdmitx_scdcrr(pdev->dev.of_node);
+
+	/* Register ION client for RPC */
+#ifdef USE_ION_AUDIO_HEAP
+	register_ion_client("hdmitx_driver");
+#endif
+
+	/* Register sysfs */
+	register_hdmitx_sysfs(&pdev->dev);
+	register_config_tv_system_sysfs(&pdev->dev);
+	register_support_list_sysfs(&pdev->dev);
+
+	/* HDMI clock always on if DisplayPort exist */
+	dptx_np = of_find_compatible_node(NULL, NULL, "Realtek,rtk-dptx");
+	if (dptx_np) {
+		if (of_device_is_available(dptx_np)) {
+			HDMI_INFO("Found DP TX node");
+			displayport_exist = 1;
+		}
+	}
+
+	HDMI_INFO("Driver init done");
+	return 0;
+
+err_register:
+	deregister_hdmitx_miscdev(&tx_dev);
+end:
+	return -EFAULT;
+
+}
+
+static const struct of_device_id rtk_hdmitx_dt_ids[] = {
+	{ .compatible = "realtek,rtd119x-hdmitx", },
+	{ .compatible = "realtek,rtd129x-hdmitx", },
+	{ .compatible = "realtek,rtd161x-hdmitx", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_hdmitx_dt_ids);
+
+static const struct dev_pm_ops rtk_hdmitx_pm_ops = {
+	.suspend    = rtk_hdmitx_suspend,
+	.resume     = rtk_hdmitx_resume,
+	.freeze     = rtk_hdmitx_suspend,
+	.thaw       = rtk_hdmitx_resume,
+};
+
+static struct platform_driver rtk_hdmi_driver = {
+	.probe = rtk_hdmi_probe,
+	.driver = {
+		.name = "rtk_hdmi",
+		.owner = THIS_MODULE,
+		.of_match_table = of_match_ptr(rtk_hdmitx_dt_ids),
+#ifdef CONFIG_PM
+		.pm = &rtk_hdmitx_pm_ops,
+#endif
+	},
+	.shutdown = rtk_hdmitx_shutdown,
+};
+
+static int __init rtk_hdmi_init(void)
+{
+	if (platform_driver_register(&rtk_hdmi_driver)) {
+		HDMI_ERROR("Could not add character driver");
+		goto err_register;
+	}
+
+	return 0;
+
+err_register:
+	platform_driver_unregister(&rtk_hdmi_driver);
+
+	return -EFAULT;
+}
+
+static void __exit rtk_hdmi_exit(void)
+{
+#ifdef USE_ION_AUDIO_HEAP
+	deregister_ion_client("hdmitx_driver");
+#endif
+	deregister_hdmitx_switchdev(&tx_dev);
+	deregister_hdmitx_miscdev(&tx_dev);
+	platform_driver_unregister(&rtk_hdmi_driver);
+}
+
+module_init(rtk_hdmi_init);
+module_exit(rtk_hdmi_exit);
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Realtek HDMI kernel module");
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx_dev.h b/drivers/media/platform/rtk_hdmitx/hdmitx_dev.h
new file mode 100644
index 00000000..528c4dd
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx_dev.h
@@ -0,0 +1,60 @@
+/*
+ * hdmitx_dev.h - RTK hdmitx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __HDMITX_DEV_H__
+#define __HDMITX_DEV_H__
+
+#include <linux/kernel.h>
+#include <linux/device.h>
+#include <linux/switch.h>
+#include <linux/miscdevice.h>
+
+
+typedef struct {
+	char *name;
+	struct miscdevice miscdev;
+	struct switch_dev sdev;
+	struct device dev;
+	void __iomem *reg_base;
+	struct reset_control *reset_hdmi;
+	struct clk *clk_hdmi;
+	int hpd_gpio;
+	unsigned int hpd_irq;
+#if 1//def __LINUX_MEDIA_NAS__
+	wait_queue_head_t hpd_wait;
+#endif
+} hdmitx_device_t;
+
+
+#define to_hdmitx_device(x)  container_of(x, hdmitx_device_t, dev)
+
+static inline void *hdmitx_get_drvdata(hdmitx_device_t *device)
+{
+	return dev_get_drvdata(&device->dev);
+}
+
+static inline void hdmitx_set_drvdata(hdmitx_device_t *device, void *data)
+{
+	struct device *dev = &device->dev;
+
+	dev_set_drvdata(dev, data);
+}
+
+extern int register_hdmitx_switchdev(hdmitx_device_t *device);
+extern void deregister_hdmitx_switchdev(hdmitx_device_t *device);
+extern int show_hpd_status(bool real_time);
+extern int rtk_hdmitx_switch_suspend(void);
+extern int rtk_hdmitx_switch_resume(void);
+
+int hdmitx_get_raw_edid(unsigned char *edid);
+
+#endif /* __HDMITX_DEV__H__ */
+
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx_info.c b/drivers/media/platform/rtk_hdmitx/hdmitx_info.c
new file mode 100644
index 00000000..6ac41cf
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx_info.c
@@ -0,0 +1,317 @@
+/*
+ * hdmitx_info.c - RTK hdmitx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/platform_device.h>
+
+#include <drm/drm_edid.h>
+#include <drm/drm_crtc.h>
+
+#include "hdmitx.h"
+#include "hdmitx_api.h"
+#include "hdmitx_rpc.h"
+#include "rtk_edid.h"
+
+struct vic_format_info {
+	unsigned char vic;
+	unsigned int width;
+	unsigned int height;
+	unsigned char fps;
+	unsigned char interlace;
+};
+
+static unsigned char hpd_interlock = 1;
+
+const struct vic_format_info vic_format_table[] = {
+	{  0,    0,    0,  0, 0},
+	{  2,  720,  480, 60, 0},
+	{  4, 1280,  720, 60, 0},
+	{  5, 1920, 1080, 60, 1},
+	{  6,  720,  480, 60, 1},
+	{ 16, 1920, 1080, 60, 0},
+	{ 17,  720,  576, 50, 0},
+	{ 19, 1280,  720, 50, 0},
+	{ 20, 1920, 1080, 50, 1},
+	{ 21,  720,  576, 50, 1},
+	{ 31, 1920, 1080, 50, 0},
+	{ 32, 1920, 1080, 24, 0},
+	{ 33, 1920, 1080, 25, 0},
+	{ 34, 1920, 1080, 30, 0},
+	{ 93, 3840, 2160, 24, 0},
+	{ 94, 3840, 2160, 25, 0},
+	{ 95, 3840, 2160, 30, 0},
+	{ 96, 3840, 2160, 50, 0},
+	{ 97, 3840, 2160, 60, 0},
+	{ 98, 4096, 2160, 24, 0},
+	{ 99, 4096, 2160, 25, 0},
+	{100, 4096, 2160, 30, 0},
+	{101, 4096, 2160, 50, 0},
+	{102, 4096, 2160, 60, 0},
+};
+const unsigned int vic_format_number = sizeof(vic_format_table)/sizeof(vic_format_table[0]);
+
+/* EISA ID is based upon compressed ASCII */
+const unsigned char eisa_id[] = {
+	' ', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
+	'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
+	'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
+	'X', 'Y', 'Z', ' ', ' ', ' ', ' ', ' '
+};
+
+static const char * const mode[] = {
+	"OFF", "DVI", "HDMI", "Unknow"
+};
+
+static const char * const pixel_format[] = {
+	"RGB", "YUV422", "YUV444", "YUV420"
+};
+
+static const char * const colorimetry[] = {
+	"No Data", "SMPTE 170M", "ITU 709", "Extend"
+};
+
+static const char * const extended_colorimetry[] = {
+	"xvYCC601", "xvYCC709", "sYCC601", "AdobeYCC601",
+	"AdobeRGB", "BT2020YcCbcCrx", "BT2020RGB", "Reserved"
+};
+
+static const char * const format3d[] = {
+	"N/A", "FramePacking", "Side-by-Side", "Top-and-Bottom",
+	"FramePacking", "Side-by-Side", "Top-and-Bottom", "N/A"
+};
+
+static const char * const hdr_mode[] = {
+	"AUTO", "DV", "SDR", "GAMMA",
+	"HDR10", "FUTURE", "INPUT", "12B_YUV422",
+	"10B_YUV444", "10B_RGB444", "12B_YUV444", "12B_RGB444",
+	"DV_ON_INPUT", "DV_ON_LOW_LATENCY_12B422", "Unknow", "Unknow"
+};
+
+static const char * const vo_type[] = {
+	"ANALOG_AND_DIGITAL",
+	"ANALOG_ONLY",
+	"DIGITAL_ONLY",
+	"DISPLAY_PORT_ONLY",
+	"HDMI_AND_DISPLAY_PORT_SAME_SOURCE",
+	"HDMI_AND_DISPLAY_PORT_DIFF_SOURCE",
+	"DISPLAY_PORT_AND_CVBS_SAME_SOURCE",
+	"HDMI_AND_DP_DIFF_SOURCE_WITH_CVBS",
+	"FORCE_DP_OFF"
+};
+
+static const char * const yes_no[] = {
+	"No", "Yes"
+};
+
+unsigned char get_vic_format_table_index(unsigned char vic)
+{
+	int i;
+	unsigned char index;
+
+	index = 0;
+	for (i = 0; i < vic_format_number; i++) {
+		if (vic == vic_format_table[i].vic) {
+			index = i;
+			break;
+		}
+	}
+
+	return index;
+}
+
+ssize_t show_hdmitx_info(struct device *cd, struct device_attribute *attr, char *buf)
+{
+	unsigned int ret_count;
+	unsigned int vo_standard;
+	unsigned char vic_index;
+	unsigned char fps;
+	unsigned char color_index;
+	unsigned char vo_type_index;
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM hdmitx_tv_system;
+	struct hdmi_format_setting format;
+
+	RPC_ToAgent_QueryConfigTvSystem(&hdmitx_tv_system);
+
+	tv_system_to_hdmi_format(&hdmitx_tv_system, &format);
+
+	ret_count = sprintf(buf, "------ HDMI Info -----\n");
+
+	vo_standard = hdmitx_tv_system.videoInfo.standard;
+
+	/* Mode:DVI/HDMI/OFF */
+	ret_count += sprintf(buf+ret_count, "Mode: %s\n", mode[format.mode&0x3]);
+
+	/* RTK VO_STANDARD */
+	ret_count += sprintf(buf+ret_count, "RTK VO_STANDARD: %u\n",
+		vo_standard);
+
+	/* VO interface type */
+	vo_type_index = (unsigned char)hdmitx_tv_system.interfaceType;
+	if (vo_type_index <= 9)
+		ret_count += sprintf(buf+ret_count, "VO type: %s\n", vo_type[vo_type_index]);
+	else
+		ret_count += sprintf(buf+ret_count, "VO type: Unknow\n");
+
+	if (format.mode == FORMAT_MODE_OFF)
+		return ret_count;
+
+	/* VIC */
+	ret_count += sprintf(buf+ret_count, "VIC: %u\n",
+		format.vic);
+
+	/* Resolution: Width x Height I/P fps */
+	vic_index = get_vic_format_table_index(format.vic);
+
+	if (format.freq_shift)
+		fps = vic_format_table[vic_index].fps - 1;
+	else
+		fps = vic_format_table[vic_index].fps;
+
+	ret_count += sprintf(buf+ret_count, "Resolution: %ux%u%s @ %uHz\n",
+		vic_format_table[vic_index].width,
+		vic_format_table[vic_index].height,
+		(hdmitx_tv_system.videoInfo.enProg&0x1)?"P":"I",
+		fps);
+
+	/* Pixel format:RGB/YUV422/YUV444/YUV420 */
+	ret_count += sprintf(buf+ret_count, "Pixel format: %s\n",
+		pixel_format[format.color&0x3]);
+
+	/* Color depth:8 Bits/10 Bits/12 Bits */
+	ret_count += sprintf(buf+ret_count, "Color depth: %u Bits\n",
+		format.color_depth);
+
+	/* Colorimetry */
+	color_index = (hdmitx_tv_system.hdmiInfo.dataByte2>>6)&0x3;
+	if (color_index != 0x3) {
+		/* Colorimetry C1:C0 */
+		ret_count += sprintf(buf+ret_count, "Colorimetry: %s\n",
+				colorimetry[color_index]);
+	} else {
+		/* Extended Colorimetry EC2:EC1:EC0 */
+		color_index = (hdmitx_tv_system.hdmiInfo.dataByte3>>4)&0x7;
+
+		ret_count += sprintf(buf+ret_count, "Colorimetry: %s\n",
+				extended_colorimetry[color_index]);
+	}
+
+	/* 3D:"N/A"/FramePacking/Side-by-Side/Top-and-Bottom */
+	ret_count += sprintf(buf+ret_count, "3D: %s\n",
+		format3d[format._3d_format&0x7]);
+
+	/* HDR mode */
+	ret_count += sprintf(buf+ret_count, "HDR mode: %s\n",
+		hdr_mode[format.hdr&0xF]);
+
+	/* HDMI2.0:YES/NO */
+	ret_count += sprintf(buf+ret_count, "HDMI2.0: %s\n",
+		yes_no[hdmitx_tv_system.hdmiInfo.hdmi2p0_feature&0x1]);
+
+	/* Scramble:YES/NO */
+	ret_count += sprintf(buf+ret_count, "Scramble: %s\n",
+		yes_no[(hdmitx_tv_system.hdmiInfo.hdmi2p0_feature>>1)&0x1]);
+
+	return ret_count;
+}
+
+ssize_t show_edid_info(struct device *cd, struct device_attribute *attr, char *buf)
+{
+	unsigned int ret_count;
+	unsigned int vendor_id;
+	unsigned char id_index[3];
+
+	ret_count = sprintf(buf, "------ EDID Info -----\n");
+
+	vendor_id = hdmitx_edid_info.mfg_id[0];
+	vendor_id = (vendor_id<<8) | hdmitx_edid_info.mfg_id[1];
+	ret_count += sprintf(buf+ret_count, "Vendor ID:%04x\n", vendor_id);
+
+	if (hdmitx_edid_info.hdmi_id == HDMI_2P0_IDENTIFIER)
+		ret_count += sprintf(buf+ret_count, "HDMI version:2.0\n");
+	else
+		ret_count += sprintf(buf+ret_count, "HDMI version:1.x\n");
+
+	/* EISA ID for manufacturer name, using five-bit codes */
+	id_index[0] = (vendor_id>>10)&0x1F;
+	id_index[1] = (vendor_id>>5)&0x1F;
+	id_index[2] = vendor_id&0x1F;
+	ret_count += sprintf(buf+ret_count, "TV name:%c%c%c\n",
+					eisa_id[id_index[0]],
+					eisa_id[id_index[1]],
+					eisa_id[id_index[2]]);
+
+	ret_count += sprintf(buf+ret_count, "ProductCode:%02x%02x\n",
+					hdmitx_edid_info.prod_code[1],
+					hdmitx_edid_info.prod_code[0]);
+
+	ret_count += sprintf(buf+ret_count, "SerialNumber:%08x\n",
+					hdmitx_edid_info.serial);
+
+	ret_count += sprintf(buf+ret_count, "ManufactureYear:%u\n",
+					1990+hdmitx_edid_info.mfg_year);
+
+	ret_count += sprintf(buf+ret_count, "ManufactureWeek:%u\n",
+					hdmitx_edid_info.mfg_week);
+
+	if (hdmitx_edid_info.hdmi_id == HDMI_2P0_IDENTIFIER) {
+		ret_count += sprintf(buf+ret_count,
+			"Max TMDS character rate:%u\n",
+			hdmitx_edid_info.max_tmds_char_rate);
+
+		ret_count += sprintf(buf+ret_count, "Deep Color 420:0x%x\n",
+			hdmitx_edid_info.dc_420);
+	}
+	return ret_count;
+}
+
+unsigned char get_hpd_interlock(void)
+{
+	return hpd_interlock;
+}
+
+static ssize_t hpd_interlock_show(struct device *dev,
+	struct device_attribute *attr, char *buf)
+{
+	ssize_t ret_count = 0;
+
+	ret_count = sprintf(buf, "%s\n", hpd_interlock?"Yes":"No");
+
+	return ret_count;
+}
+
+static ssize_t hpd_interlock_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t size)
+{
+
+	if (sysfs_streq(buf, "YES") || sysfs_streq(buf, "Yes") ||
+		sysfs_streq(buf, "yes"))
+		hpd_interlock = 1;
+	else if (sysfs_streq(buf, "NO") || sysfs_streq(buf, "No") ||
+		sysfs_streq(buf, "no"))
+		hpd_interlock = 0;
+
+	return size;
+}
+
+/* /sys/devices/platform/9800d000.hdmitx/hdmitx_info */
+static DEVICE_ATTR(hdmitx_info, 0444, show_hdmitx_info, NULL);
+/* /sys/devices/platform/9800d000.hdmitx/edid_info */
+static DEVICE_ATTR(edid_info, 0444, show_edid_info, NULL);
+/* /sys/devices/platform/9800d000.hdmitx/hpd_interlock */
+static DEVICE_ATTR(hpd_interlock, 0644,
+	hpd_interlock_show, hpd_interlock_store);
+
+void register_hdmitx_sysfs(struct device *dev)
+{
+	device_create_file(dev, &dev_attr_hdmitx_info);
+	device_create_file(dev, &dev_attr_edid_info);
+	device_create_file(dev, &dev_attr_hpd_interlock);
+}
+
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx_reg.h b/drivers/media/platform/rtk_hdmitx/hdmitx_reg.h
new file mode 100644
index 00000000..ba4473c
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx_reg.h
@@ -0,0 +1,4312 @@
+/*
+ * hdmitx_reg.h - RTK hdmitx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDMI_REG_H_INCLUDED_
+#define _HDMI_REG_H_INCLUDED_
+
+#define HDMI_INTEN                                                                   0x000
+#define HDMI_INTEN_reg_addr                                                          "0x9800D000"
+#define HDMI_INTEN_reg                                                               0x9800D000
+#define set_HDMI_INTEN_reg(data)   (*((volatile unsigned int*) HDMI_INTEN_reg)=data)
+#define get_HDMI_INTEN_reg   (*((volatile unsigned int*) HDMI_INTEN_reg))
+#define HDMI_INTEN_inst_adr                                                          "0x0000"
+#define HDMI_INTEN_inst                                                              0x0000
+#define HDMI_INTEN_rxsenseint_shift                                                  (3)
+#define HDMI_INTEN_rxsenseint_mask                                                   (0x00000008)
+#define HDMI_INTEN_rxsenseint(data)                                                  (0x00000008&((data)<<3))
+#define HDMI_INTEN_rxsenseint_src(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_INTEN_get_rxsenseint(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_INTEN_enriupdint_shift                                                  (2)
+#define HDMI_INTEN_enriupdint_mask                                                   (0x00000004)
+#define HDMI_INTEN_enriupdint(data)                                                  (0x00000004&((data)<<2))
+#define HDMI_INTEN_enriupdint_src(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_INTEN_get_enriupdint(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_INTEN_enpjupdint_shift                                                  (1)
+#define HDMI_INTEN_enpjupdint_mask                                                   (0x00000002)
+#define HDMI_INTEN_enpjupdint(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_INTEN_enpjupdint_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_INTEN_get_enpjupdint(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_INTEN_write_data_shift                                                  (0)
+#define HDMI_INTEN_write_data_mask                                                   (0x00000001)
+#define HDMI_INTEN_write_data(data)                                                  (0x00000001&((data)<<0))
+#define HDMI_INTEN_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define HDMI_INTEN_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define HDMI_INTENV                                                                  0x274
+#define HDMI_INTENV_reg_addr                                                         "0x9800D274"
+#define HDMI_INTENV_reg                                                              0x9800D274
+#define set_HDMI_INTENV_reg(data)   (*((volatile unsigned int*) HDMI_INTENV_reg)=data)
+#define get_HDMI_INTENV_reg   (*((volatile unsigned int*) HDMI_INTENV_reg))
+#define HDMI_INTENV_inst_adr                                                         "0x009D"
+#define HDMI_INTENV_inst                                                             0x009D
+#define HDMI_INTENV_vendint_shift                                                    (2)
+#define HDMI_INTENV_vendint_mask                                                     (0x00000004)
+#define HDMI_INTENV_vendint(data)                                                    (0x00000004&((data)<<2))
+#define HDMI_INTENV_vendint_src(data)                                                ((0x00000004&(data))>>2)
+#define HDMI_INTENV_get_vendint(data)                                                ((0x00000004&(data))>>2)
+#define HDMI_INTENV_vsyncint_shift                                                   (1)
+#define HDMI_INTENV_vsyncint_mask                                                    (0x00000002)
+#define HDMI_INTENV_vsyncint(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_INTENV_vsyncint_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTENV_get_vsyncint(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTENV_write_data_shift                                                 (0)
+#define HDMI_INTENV_write_data_mask                                                  (0x00000001)
+#define HDMI_INTENV_write_data(data)                                                 (0x00000001&((data)<<0))
+#define HDMI_INTENV_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define HDMI_INTENV_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define HDMI_AUDIO_ST                                                                0x004
+#define HDMI_AUDIO_ST_reg_addr                                                       "0x9800D004"
+#define HDMI_AUDIO_ST_reg                                                            0x9800D004
+#define set_HDMI_AUDIO_ST_reg(data)   (*((volatile unsigned int*) HDMI_AUDIO_ST_reg)=data)
+#define get_HDMI_AUDIO_ST_reg   (*((volatile unsigned int*) HDMI_AUDIO_ST_reg))
+#define HDMI_AUDIO_ST_inst_adr                                                       "0x0001"
+#define HDMI_AUDIO_ST_inst                                                           0x0001
+#define HDMI_AUDIO_ST_asfifo_empty_shift                                             (4)
+#define HDMI_AUDIO_ST_asfifo_empty_mask                                              (0x00000010)
+#define HDMI_AUDIO_ST_asfifo_empty(data)                                             (0x00000010&((data)<<4))
+#define HDMI_AUDIO_ST_asfifo_empty_src(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_AUDIO_ST_get_asfifo_empty(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_AUDIO_ST_asfifo_full_shift                                              (3)
+#define HDMI_AUDIO_ST_asfifo_full_mask                                               (0x00000008)
+#define HDMI_AUDIO_ST_asfifo_full(data)                                              (0x00000008&((data)<<3))
+#define HDMI_AUDIO_ST_asfifo_full_src(data)                                          ((0x00000008&(data))>>3)
+#define HDMI_AUDIO_ST_get_asfifo_full(data)                                          ((0x00000008&(data))>>3)
+#define HDMI_AUDIO_ST_owctshw_shift                                                  (2)
+#define HDMI_AUDIO_ST_owctshw_mask                                                   (0x00000004)
+#define HDMI_AUDIO_ST_owctshw(data)                                                  (0x00000004&((data)<<2))
+#define HDMI_AUDIO_ST_owctshw_src(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_AUDIO_ST_get_owctshw(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_AUDIO_ST_asfifoow_shift                                                 (1)
+#define HDMI_AUDIO_ST_asfifoow_mask                                                  (0x00000002)
+#define HDMI_AUDIO_ST_asfifoow(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_AUDIO_ST_asfifoow_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_AUDIO_ST_get_asfifoow(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_AUDIO_ST_write_data_shift                                               (0)
+#define HDMI_AUDIO_ST_write_data_mask                                                (0x00000001)
+#define HDMI_AUDIO_ST_write_data(data)                                               (0x00000001&((data)<<0))
+#define HDMI_AUDIO_ST_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_AUDIO_ST_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_INTST                                                                   0x008
+#define HDMI_INTST_reg_addr                                                          "0x9800D008"
+#define HDMI_INTST_reg                                                               0x9800D008
+#define set_HDMI_INTST_reg(data)   (*((volatile unsigned int*) HDMI_INTST_reg)=data)
+#define get_HDMI_INTST_reg   (*((volatile unsigned int*) HDMI_INTST_reg))
+#define HDMI_INTST_inst_adr                                                          "0x0002"
+#define HDMI_INTST_inst                                                              0x0002
+#define HDMI_INTST_rxupdated_shift                                                   (2)
+#define HDMI_INTST_rxupdated_mask                                                    (0x00000004)
+#define HDMI_INTST_rxupdated(data)                                                   (0x00000004&((data)<<2))
+#define HDMI_INTST_rxupdated_src(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_INTST_get_rxupdated(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_INTST_riupdated_shift                                                   (1)
+#define HDMI_INTST_riupdated_mask                                                    (0x00000002)
+#define HDMI_INTST_riupdated(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_INTST_riupdated_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTST_get_riupdated(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTST_pjupdated_shift                                                   (0)
+#define HDMI_INTST_pjupdated_mask                                                    (0x00000001)
+#define HDMI_INTST_pjupdated(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_INTST_pjupdated_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_INTST_get_pjupdated(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_INTSTV                                                                  0x278
+#define HDMI_INTSTV_reg_addr                                                         "0x9800D278"
+#define HDMI_INTSTV_reg                                                              0x9800D278
+#define set_HDMI_INTSTV_reg(data)   (*((volatile unsigned int*) HDMI_INTSTV_reg)=data)
+#define get_HDMI_INTSTV_reg   (*((volatile unsigned int*) HDMI_INTSTV_reg))
+#define HDMI_INTSTV_inst_adr                                                         "0x009E"
+#define HDMI_INTSTV_inst                                                             0x009E
+#define HDMI_INTSTV_vendupdated_shift                                                (1)
+#define HDMI_INTSTV_vendupdated_mask                                                 (0x00000002)
+#define HDMI_INTSTV_vendupdated(data)                                                (0x00000002&((data)<<1))
+#define HDMI_INTSTV_vendupdated_src(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_INTSTV_get_vendupdated(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_INTSTV_vsyncupdated_shift                                               (0)
+#define HDMI_INTSTV_vsyncupdated_mask                                                (0x00000001)
+#define HDMI_INTSTV_vsyncupdated(data)                                               (0x00000001&((data)<<0))
+#define HDMI_INTSTV_vsyncupdated_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_INTSTV_get_vsyncupdated(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_PHY_STATUS                                                              0x15c
+#define HDMI_PHY_STATUS_reg_addr                                                     "0x9800D15C"
+#define HDMI_PHY_STATUS_reg                                                          0x9800D15C
+#define set_HDMI_PHY_STATUS_reg(data)   (*((volatile unsigned int*) HDMI_PHY_STATUS_reg)=data)
+#define get_HDMI_PHY_STATUS_reg   (*((volatile unsigned int*) HDMI_PHY_STATUS_reg))
+#define HDMI_PHY_STATUS_inst_adr                                                     "0x0057"
+#define HDMI_PHY_STATUS_inst                                                         0x0057
+#define HDMI_PHY_STATUS_wdout_shift                                                  (1)
+#define HDMI_PHY_STATUS_wdout_mask                                                   (0x00000002)
+#define HDMI_PHY_STATUS_wdout(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_PHY_STATUS_wdout_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_PHY_STATUS_get_wdout(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_PHY_STATUS_Rxstatus_shift                                               (0)
+#define HDMI_PHY_STATUS_Rxstatus_mask                                                (0x00000001)
+#define HDMI_PHY_STATUS_Rxstatus(data)                                               (0x00000001&((data)<<0))
+#define HDMI_PHY_STATUS_Rxstatus_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_PHY_STATUS_get_Rxstatus(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_UPDATE_ST                                                               0x00c
+#define HDMI_UPDATE_ST_reg_addr                                                      "0x9800D00C"
+#define HDMI_UPDATE_ST_reg                                                           0x9800D00C
+#define set_HDMI_UPDATE_ST_reg(data)   (*((volatile unsigned int*) HDMI_UPDATE_ST_reg)=data)
+#define get_HDMI_UPDATE_ST_reg   (*((volatile unsigned int*) HDMI_UPDATE_ST_reg))
+#define HDMI_UPDATE_ST_inst_adr                                                      "0x0003"
+#define HDMI_UPDATE_ST_inst                                                          0x0003
+#define HDMI_UPDATE_ST_write_en2_shift                                               (17)
+#define HDMI_UPDATE_ST_write_en2_mask                                                (0x00020000)
+#define HDMI_UPDATE_ST_write_en2(data)                                               (0x00020000&((data)<<17))
+#define HDMI_UPDATE_ST_write_en2_src(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_UPDATE_ST_get_write_en2(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_UPDATE_ST_rirate_shift                                                  (9)
+#define HDMI_UPDATE_ST_rirate_mask                                                   (0x0001FE00)
+#define HDMI_UPDATE_ST_rirate(data)                                                  (0x0001FE00&((data)<<9))
+#define HDMI_UPDATE_ST_rirate_src(data)                                              ((0x0001FE00&(data))>>9)
+#define HDMI_UPDATE_ST_get_rirate(data)                                              ((0x0001FE00&(data))>>9)
+#define HDMI_UPDATE_ST_write_en1_shift                                               (8)
+#define HDMI_UPDATE_ST_write_en1_mask                                                (0x00000100)
+#define HDMI_UPDATE_ST_write_en1(data)                                               (0x00000100&((data)<<8))
+#define HDMI_UPDATE_ST_write_en1_src(data)                                           ((0x00000100&(data))>>8)
+#define HDMI_UPDATE_ST_get_write_en1(data)                                           ((0x00000100&(data))>>8)
+#define HDMI_UPDATE_ST_pjrate_shift                                                  (0)
+#define HDMI_UPDATE_ST_pjrate_mask                                                   (0x000000FF)
+#define HDMI_UPDATE_ST_pjrate(data)                                                  (0x000000FF&((data)<<0))
+#define HDMI_UPDATE_ST_pjrate_src(data)                                              ((0x000000FF&(data))>>0)
+#define HDMI_UPDATE_ST_get_pjrate(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define HDMI_CHNL_SEL                                                                0x020
+#define HDMI_CHNL_SEL_reg_addr                                                       "0x9800D020"
+#define HDMI_CHNL_SEL_reg                                                            0x9800D020
+#define set_HDMI_CHNL_SEL_reg(data)   (*((volatile unsigned int*) HDMI_CHNL_SEL_reg)=data)
+#define get_HDMI_CHNL_SEL_reg   (*((volatile unsigned int*) HDMI_CHNL_SEL_reg))
+#define HDMI_CHNL_SEL_inst_adr                                                       "0x0008"
+#define HDMI_CHNL_SEL_inst                                                           0x0008
+#define HDMI_CHNL_SEL_sram_shut_down_en_shift                                        (11)
+#define HDMI_CHNL_SEL_sram_shut_down_en_mask                                         (0x00000800)
+#define HDMI_CHNL_SEL_sram_shut_down_en(data)                                        (0x00000800&((data)<<11))
+#define HDMI_CHNL_SEL_sram_shut_down_en_src(data)                                    ((0x00000800&(data))>>11)
+#define HDMI_CHNL_SEL_get_sram_shut_down_en(data)                                    ((0x00000800&(data))>>11)
+#define HDMI_CHNL_SEL_sram_sleep_en_shift                                            (10)
+#define HDMI_CHNL_SEL_sram_sleep_en_mask                                             (0x00000400)
+#define HDMI_CHNL_SEL_sram_sleep_en(data)                                            (0x00000400&((data)<<10))
+#define HDMI_CHNL_SEL_sram_sleep_en_src(data)                                        ((0x00000400&(data))>>10)
+#define HDMI_CHNL_SEL_get_sram_sleep_en(data)                                        ((0x00000400&(data))>>10)
+#define HDMI_CHNL_SEL_video_sd_shift                                                 (9)
+#define HDMI_CHNL_SEL_video_sd_mask                                                  (0x00000200)
+#define HDMI_CHNL_SEL_video_sd(data)                                                 (0x00000200&((data)<<9))
+#define HDMI_CHNL_SEL_video_sd_src(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_CHNL_SEL_get_video_sd(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_CHNL_SEL_Interlaced_vfmt_shift                                          (8)
+#define HDMI_CHNL_SEL_Interlaced_vfmt_mask                                           (0x00000100)
+#define HDMI_CHNL_SEL_Interlaced_vfmt(data)                                          (0x00000100&((data)<<8))
+#define HDMI_CHNL_SEL_Interlaced_vfmt_src(data)                                      ((0x00000100&(data))>>8)
+#define HDMI_CHNL_SEL_get_Interlaced_vfmt(data)                                      ((0x00000100&(data))>>8)
+#define HDMI_CHNL_SEL_3D_video_format_shift                                          (4)
+#define HDMI_CHNL_SEL_3D_video_format_mask                                           (0x000000F0)
+#define HDMI_CHNL_SEL_3D_video_format(data)                                          (0x000000F0&((data)<<4))
+#define HDMI_CHNL_SEL_3D_video_format_src(data)                                      ((0x000000F0&(data))>>4)
+#define HDMI_CHNL_SEL_get_3D_video_format(data)                                      ((0x000000F0&(data))>>4)
+#define HDMI_CHNL_SEL_En_3D_shift                                                    (3)
+#define HDMI_CHNL_SEL_En_3D_mask                                                     (0x00000008)
+#define HDMI_CHNL_SEL_En_3D(data)                                                    (0x00000008&((data)<<3))
+#define HDMI_CHNL_SEL_En_3D_src(data)                                                ((0x00000008&(data))>>3)
+#define HDMI_CHNL_SEL_get_En_3D(data)                                                ((0x00000008&(data))>>3)
+#define HDMI_CHNL_SEL_timing_gen_en_shift                                            (2)
+#define HDMI_CHNL_SEL_timing_gen_en_mask                                             (0x00000004)
+#define HDMI_CHNL_SEL_timing_gen_en(data)                                            (0x00000004&((data)<<2))
+#define HDMI_CHNL_SEL_timing_gen_en_src(data)                                        ((0x00000004&(data))>>2)
+#define HDMI_CHNL_SEL_get_timing_gen_en(data)                                        ((0x00000004&(data))>>2)
+#define HDMI_CHNL_SEL_chl_sel_shift                                                  (0)
+#define HDMI_CHNL_SEL_chl_sel_mask                                                   (0x00000003)
+#define HDMI_CHNL_SEL_chl_sel(data)                                                  (0x00000003&((data)<<0))
+#define HDMI_CHNL_SEL_chl_sel_src(data)                                              ((0x00000003&(data))>>0)
+#define HDMI_CHNL_SEL_get_chl_sel(data)                                              ((0x00000003&(data))>>0)
+
+
+#define HDMI_CS_TRANS0                                                               0x024
+#define HDMI_CS_TRANS0_reg_addr                                                      "0x9800D024"
+#define HDMI_CS_TRANS0_reg                                                           0x9800D024
+#define set_HDMI_CS_TRANS0_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS0_reg)=data)
+#define get_HDMI_CS_TRANS0_reg   (*((volatile unsigned int*) HDMI_CS_TRANS0_reg))
+#define HDMI_CS_TRANS0_inst_adr                                                      "0x0009"
+#define HDMI_CS_TRANS0_inst                                                          0x0009
+#define HDMI_CS_TRANS0_c1_shift                                                      (0)
+#define HDMI_CS_TRANS0_c1_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS0_c1(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS0_c1_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS0_get_c1(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS1                                                               0x028
+#define HDMI_CS_TRANS1_reg_addr                                                      "0x9800D028"
+#define HDMI_CS_TRANS1_reg                                                           0x9800D028
+#define set_HDMI_CS_TRANS1_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS1_reg)=data)
+#define get_HDMI_CS_TRANS1_reg   (*((volatile unsigned int*) HDMI_CS_TRANS1_reg))
+#define HDMI_CS_TRANS1_inst_adr                                                      "0x000A"
+#define HDMI_CS_TRANS1_inst                                                          0x000A
+#define HDMI_CS_TRANS1_c2_shift                                                      (0)
+#define HDMI_CS_TRANS1_c2_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS1_c2(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS1_c2_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS1_get_c2(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS2                                                               0x02c
+#define HDMI_CS_TRANS2_reg_addr                                                      "0x9800D02C"
+#define HDMI_CS_TRANS2_reg                                                           0x9800D02C
+#define set_HDMI_CS_TRANS2_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS2_reg)=data)
+#define get_HDMI_CS_TRANS2_reg   (*((volatile unsigned int*) HDMI_CS_TRANS2_reg))
+#define HDMI_CS_TRANS2_inst_adr                                                      "0x000B"
+#define HDMI_CS_TRANS2_inst                                                          0x000B
+#define HDMI_CS_TRANS2_c3_shift                                                      (0)
+#define HDMI_CS_TRANS2_c3_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS2_c3(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS2_c3_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS2_get_c3(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS3                                                               0x200
+#define HDMI_CS_TRANS3_reg_addr                                                      "0x9800D200"
+#define HDMI_CS_TRANS3_reg                                                           0x9800D200
+#define set_HDMI_CS_TRANS3_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS3_reg)=data)
+#define get_HDMI_CS_TRANS3_reg   (*((volatile unsigned int*) HDMI_CS_TRANS3_reg))
+#define HDMI_CS_TRANS3_inst_adr                                                      "0x0080"
+#define HDMI_CS_TRANS3_inst                                                          0x0080
+#define HDMI_CS_TRANS3_c4_shift                                                      (0)
+#define HDMI_CS_TRANS3_c4_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS3_c4(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS3_c4_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS3_get_c4(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS4                                                               0x204
+#define HDMI_CS_TRANS4_reg_addr                                                      "0x9800D204"
+#define HDMI_CS_TRANS4_reg                                                           0x9800D204
+#define set_HDMI_CS_TRANS4_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS4_reg)=data)
+#define get_HDMI_CS_TRANS4_reg   (*((volatile unsigned int*) HDMI_CS_TRANS4_reg))
+#define HDMI_CS_TRANS4_inst_adr                                                      "0x0081"
+#define HDMI_CS_TRANS4_inst                                                          0x0081
+#define HDMI_CS_TRANS4_c5_shift                                                      (0)
+#define HDMI_CS_TRANS4_c5_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS4_c5(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS4_c5_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS4_get_c5(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS5                                                               0x208
+#define HDMI_CS_TRANS5_reg_addr                                                      "0x9800D208"
+#define HDMI_CS_TRANS5_reg                                                           0x9800D208
+#define set_HDMI_CS_TRANS5_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS5_reg)=data)
+#define get_HDMI_CS_TRANS5_reg   (*((volatile unsigned int*) HDMI_CS_TRANS5_reg))
+#define HDMI_CS_TRANS5_inst_adr                                                      "0x0082"
+#define HDMI_CS_TRANS5_inst                                                          0x0082
+#define HDMI_CS_TRANS5_c6_shift                                                      (0)
+#define HDMI_CS_TRANS5_c6_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS5_c6(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS5_c6_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS5_get_c6(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS6                                                               0x20c
+#define HDMI_CS_TRANS6_reg_addr                                                      "0x9800D20C"
+#define HDMI_CS_TRANS6_reg                                                           0x9800D20C
+#define set_HDMI_CS_TRANS6_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS6_reg)=data)
+#define get_HDMI_CS_TRANS6_reg   (*((volatile unsigned int*) HDMI_CS_TRANS6_reg))
+#define HDMI_CS_TRANS6_inst_adr                                                      "0x0083"
+#define HDMI_CS_TRANS6_inst                                                          0x0083
+#define HDMI_CS_TRANS6_c7_shift                                                      (0)
+#define HDMI_CS_TRANS6_c7_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS6_c7(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS6_c7_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS6_get_c7(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS7                                                               0x210
+#define HDMI_CS_TRANS7_reg_addr                                                      "0x9800D210"
+#define HDMI_CS_TRANS7_reg                                                           0x9800D210
+#define set_HDMI_CS_TRANS7_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS7_reg)=data)
+#define get_HDMI_CS_TRANS7_reg   (*((volatile unsigned int*) HDMI_CS_TRANS7_reg))
+#define HDMI_CS_TRANS7_inst_adr                                                      "0x0084"
+#define HDMI_CS_TRANS7_inst                                                          0x0084
+#define HDMI_CS_TRANS7_c8_shift                                                      (0)
+#define HDMI_CS_TRANS7_c8_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS7_c8(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS7_c8_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS7_get_c8(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS8                                                               0x214
+#define HDMI_CS_TRANS8_reg_addr                                                      "0x9800D214"
+#define HDMI_CS_TRANS8_reg                                                           0x9800D214
+#define set_HDMI_CS_TRANS8_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS8_reg)=data)
+#define get_HDMI_CS_TRANS8_reg   (*((volatile unsigned int*) HDMI_CS_TRANS8_reg))
+#define HDMI_CS_TRANS8_inst_adr                                                      "0x0085"
+#define HDMI_CS_TRANS8_inst                                                          0x0085
+#define HDMI_CS_TRANS8_c9_shift                                                      (0)
+#define HDMI_CS_TRANS8_c9_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS8_c9(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS8_c9_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS8_get_c9(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS9                                                               0x218
+#define HDMI_CS_TRANS9_reg_addr                                                      "0x9800D218"
+#define HDMI_CS_TRANS9_reg                                                           0x9800D218
+#define set_HDMI_CS_TRANS9_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS9_reg)=data)
+#define get_HDMI_CS_TRANS9_reg   (*((volatile unsigned int*) HDMI_CS_TRANS9_reg))
+#define HDMI_CS_TRANS9_inst_adr                                                      "0x0086"
+#define HDMI_CS_TRANS9_inst                                                          0x0086
+#define HDMI_CS_TRANS9_k1_shift                                                      (0)
+#define HDMI_CS_TRANS9_k1_mask                                                       (0x0000FFFF)
+#define HDMI_CS_TRANS9_k1(data)                                                      (0x0000FFFF&((data)<<0))
+#define HDMI_CS_TRANS9_k1_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define HDMI_CS_TRANS9_get_k1(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS10                                                              0x21c
+#define HDMI_CS_TRANS10_reg_addr                                                     "0x9800D21C"
+#define HDMI_CS_TRANS10_reg                                                          0x9800D21C
+#define set_HDMI_CS_TRANS10_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS10_reg)=data)
+#define get_HDMI_CS_TRANS10_reg   (*((volatile unsigned int*) HDMI_CS_TRANS10_reg))
+#define HDMI_CS_TRANS10_inst_adr                                                     "0x0087"
+#define HDMI_CS_TRANS10_inst                                                         0x0087
+#define HDMI_CS_TRANS10_k2_shift                                                     (0)
+#define HDMI_CS_TRANS10_k2_mask                                                      (0x0000FFFF)
+#define HDMI_CS_TRANS10_k2(data)                                                     (0x0000FFFF&((data)<<0))
+#define HDMI_CS_TRANS10_k2_src(data)                                                 ((0x0000FFFF&(data))>>0)
+#define HDMI_CS_TRANS10_get_k2(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS11                                                              0x220
+#define HDMI_CS_TRANS11_reg_addr                                                     "0x9800D220"
+#define HDMI_CS_TRANS11_reg                                                          0x9800D220
+#define set_HDMI_CS_TRANS11_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS11_reg)=data)
+#define get_HDMI_CS_TRANS11_reg   (*((volatile unsigned int*) HDMI_CS_TRANS11_reg))
+#define HDMI_CS_TRANS11_inst_adr                                                     "0x0088"
+#define HDMI_CS_TRANS11_inst                                                         0x0088
+#define HDMI_CS_TRANS11_k3_shift                                                     (0)
+#define HDMI_CS_TRANS11_k3_mask                                                      (0x0000FFFF)
+#define HDMI_CS_TRANS11_k3(data)                                                     (0x0000FFFF&((data)<<0))
+#define HDMI_CS_TRANS11_k3_src(data)                                                 ((0x0000FFFF&(data))>>0)
+#define HDMI_CS_TRANS11_get_k3(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS12                                                              0x224
+#define HDMI_CS_TRANS12_reg_addr                                                     "0x9800D224"
+#define HDMI_CS_TRANS12_reg                                                          0x9800D224
+#define set_HDMI_CS_TRANS12_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS12_reg)=data)
+#define get_HDMI_CS_TRANS12_reg   (*((volatile unsigned int*) HDMI_CS_TRANS12_reg))
+#define HDMI_CS_TRANS12_inst_adr                                                     "0x0089"
+#define HDMI_CS_TRANS12_inst                                                         0x0089
+#define HDMI_CS_TRANS12_write_en2_shift                                              (28)
+#define HDMI_CS_TRANS12_write_en2_mask                                               (0x10000000)
+#define HDMI_CS_TRANS12_write_en2(data)                                              (0x10000000&((data)<<28))
+#define HDMI_CS_TRANS12_write_en2_src(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS12_get_write_en2(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS12_ygmax_shift                                                  (16)
+#define HDMI_CS_TRANS12_ygmax_mask                                                   (0x0FFF0000)
+#define HDMI_CS_TRANS12_ygmax(data)                                                  (0x0FFF0000&((data)<<16))
+#define HDMI_CS_TRANS12_ygmax_src(data)                                              ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS12_get_ygmax(data)                                              ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS12_write_en1_shift                                              (12)
+#define HDMI_CS_TRANS12_write_en1_mask                                               (0x00001000)
+#define HDMI_CS_TRANS12_write_en1(data)                                              (0x00001000&((data)<<12))
+#define HDMI_CS_TRANS12_write_en1_src(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS12_get_write_en1(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS12_ygmin_shift                                                  (0)
+#define HDMI_CS_TRANS12_ygmin_mask                                                   (0x00000FFF)
+#define HDMI_CS_TRANS12_ygmin(data)                                                  (0x00000FFF&((data)<<0))
+#define HDMI_CS_TRANS12_ygmin_src(data)                                              ((0x00000FFF&(data))>>0)
+#define HDMI_CS_TRANS12_get_ygmin(data)                                              ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS13                                                              0x228
+#define HDMI_CS_TRANS13_reg_addr                                                     "0x9800D228"
+#define HDMI_CS_TRANS13_reg                                                          0x9800D228
+#define set_HDMI_CS_TRANS13_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS13_reg)=data)
+#define get_HDMI_CS_TRANS13_reg   (*((volatile unsigned int*) HDMI_CS_TRANS13_reg))
+#define HDMI_CS_TRANS13_inst_adr                                                     "0x008A"
+#define HDMI_CS_TRANS13_inst                                                         0x008A
+#define HDMI_CS_TRANS13_write_en2_shift                                              (28)
+#define HDMI_CS_TRANS13_write_en2_mask                                               (0x10000000)
+#define HDMI_CS_TRANS13_write_en2(data)                                              (0x10000000&((data)<<28))
+#define HDMI_CS_TRANS13_write_en2_src(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS13_get_write_en2(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS13_cbbmax_shift                                                 (16)
+#define HDMI_CS_TRANS13_cbbmax_mask                                                  (0x0FFF0000)
+#define HDMI_CS_TRANS13_cbbmax(data)                                                 (0x0FFF0000&((data)<<16))
+#define HDMI_CS_TRANS13_cbbmax_src(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS13_get_cbbmax(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS13_write_en1_shift                                              (12)
+#define HDMI_CS_TRANS13_write_en1_mask                                               (0x00001000)
+#define HDMI_CS_TRANS13_write_en1(data)                                              (0x00001000&((data)<<12))
+#define HDMI_CS_TRANS13_write_en1_src(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS13_get_write_en1(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS13_cbbmin_shift                                                 (0)
+#define HDMI_CS_TRANS13_cbbmin_mask                                                  (0x00000FFF)
+#define HDMI_CS_TRANS13_cbbmin(data)                                                 (0x00000FFF&((data)<<0))
+#define HDMI_CS_TRANS13_cbbmin_src(data)                                             ((0x00000FFF&(data))>>0)
+#define HDMI_CS_TRANS13_get_cbbmin(data)                                             ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS14                                                              0x22c
+#define HDMI_CS_TRANS14_reg_addr                                                     "0x9800D22C"
+#define HDMI_CS_TRANS14_reg                                                          0x9800D22C
+#define set_HDMI_CS_TRANS14_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS14_reg)=data)
+#define get_HDMI_CS_TRANS14_reg   (*((volatile unsigned int*) HDMI_CS_TRANS14_reg))
+#define HDMI_CS_TRANS14_inst_adr                                                     "0x008B"
+#define HDMI_CS_TRANS14_inst                                                         0x008B
+#define HDMI_CS_TRANS14_write_en2_shift                                              (28)
+#define HDMI_CS_TRANS14_write_en2_mask                                               (0x10000000)
+#define HDMI_CS_TRANS14_write_en2(data)                                              (0x10000000&((data)<<28))
+#define HDMI_CS_TRANS14_write_en2_src(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS14_get_write_en2(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS14_crrmax_shift                                                 (16)
+#define HDMI_CS_TRANS14_crrmax_mask                                                  (0x0FFF0000)
+#define HDMI_CS_TRANS14_crrmax(data)                                                 (0x0FFF0000&((data)<<16))
+#define HDMI_CS_TRANS14_crrmax_src(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS14_get_crrmax(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS14_write_en1_shift                                              (12)
+#define HDMI_CS_TRANS14_write_en1_mask                                               (0x00001000)
+#define HDMI_CS_TRANS14_write_en1(data)                                              (0x00001000&((data)<<12))
+#define HDMI_CS_TRANS14_write_en1_src(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS14_get_write_en1(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS14_crrmin_shift                                                 (0)
+#define HDMI_CS_TRANS14_crrmin_mask                                                  (0x00000FFF)
+#define HDMI_CS_TRANS14_crrmin(data)                                                 (0x00000FFF&((data)<<0))
+#define HDMI_CS_TRANS14_crrmin_src(data)                                             ((0x00000FFF&(data))>>0)
+#define HDMI_CS_TRANS14_get_crrmin(data)                                             ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_SYNC_DLY                                                                0x030
+#define HDMI_SYNC_DLY_reg_addr                                                       "0x9800D030"
+#define HDMI_SYNC_DLY_reg                                                            0x9800D030
+#define set_HDMI_SYNC_DLY_reg(data)   (*((volatile unsigned int*) HDMI_SYNC_DLY_reg)=data)
+#define get_HDMI_SYNC_DLY_reg   (*((volatile unsigned int*) HDMI_SYNC_DLY_reg))
+#define HDMI_SYNC_DLY_inst_adr                                                       "0x000C"
+#define HDMI_SYNC_DLY_inst                                                           0x000C
+#define HDMI_SYNC_DLY_write_en4_shift                                                (11)
+#define HDMI_SYNC_DLY_write_en4_mask                                                 (0x00000800)
+#define HDMI_SYNC_DLY_write_en4(data)                                                (0x00000800&((data)<<11))
+#define HDMI_SYNC_DLY_write_en4_src(data)                                            ((0x00000800&(data))>>11)
+#define HDMI_SYNC_DLY_get_write_en4(data)                                            ((0x00000800&(data))>>11)
+#define HDMI_SYNC_DLY_nor_v_shift                                                    (9)
+#define HDMI_SYNC_DLY_nor_v_mask                                                     (0x00000600)
+#define HDMI_SYNC_DLY_nor_v(data)                                                    (0x00000600&((data)<<9))
+#define HDMI_SYNC_DLY_nor_v_src(data)                                                ((0x00000600&(data))>>9)
+#define HDMI_SYNC_DLY_get_nor_v(data)                                                ((0x00000600&(data))>>9)
+#define HDMI_SYNC_DLY_write_en3_shift                                                (8)
+#define HDMI_SYNC_DLY_write_en3_mask                                                 (0x00000100)
+#define HDMI_SYNC_DLY_write_en3(data)                                                (0x00000100&((data)<<8))
+#define HDMI_SYNC_DLY_write_en3_src(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_SYNC_DLY_get_write_en3(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_SYNC_DLY_nor_h_shift                                                    (6)
+#define HDMI_SYNC_DLY_nor_h_mask                                                     (0x000000C0)
+#define HDMI_SYNC_DLY_nor_h(data)                                                    (0x000000C0&((data)<<6))
+#define HDMI_SYNC_DLY_nor_h_src(data)                                                ((0x000000C0&(data))>>6)
+#define HDMI_SYNC_DLY_get_nor_h(data)                                                ((0x000000C0&(data))>>6)
+#define HDMI_SYNC_DLY_write_en2_shift                                                (5)
+#define HDMI_SYNC_DLY_write_en2_mask                                                 (0x00000020)
+#define HDMI_SYNC_DLY_write_en2(data)                                                (0x00000020&((data)<<5))
+#define HDMI_SYNC_DLY_write_en2_src(data)                                            ((0x00000020&(data))>>5)
+#define HDMI_SYNC_DLY_get_write_en2(data)                                            ((0x00000020&(data))>>5)
+#define HDMI_SYNC_DLY_disp_v_shift                                                   (3)
+#define HDMI_SYNC_DLY_disp_v_mask                                                    (0x00000018)
+#define HDMI_SYNC_DLY_disp_v(data)                                                   (0x00000018&((data)<<3))
+#define HDMI_SYNC_DLY_disp_v_src(data)                                               ((0x00000018&(data))>>3)
+#define HDMI_SYNC_DLY_get_disp_v(data)                                               ((0x00000018&(data))>>3)
+#define HDMI_SYNC_DLY_write_en1_shift                                                (2)
+#define HDMI_SYNC_DLY_write_en1_mask                                                 (0x00000004)
+#define HDMI_SYNC_DLY_write_en1(data)                                                (0x00000004&((data)<<2))
+#define HDMI_SYNC_DLY_write_en1_src(data)                                            ((0x00000004&(data))>>2)
+#define HDMI_SYNC_DLY_get_write_en1(data)                                            ((0x00000004&(data))>>2)
+#define HDMI_SYNC_DLY_disp_h_shift                                                   (0)
+#define HDMI_SYNC_DLY_disp_h_mask                                                    (0x00000003)
+#define HDMI_SYNC_DLY_disp_h(data)                                                   (0x00000003&((data)<<0))
+#define HDMI_SYNC_DLY_disp_h_src(data)                                               ((0x00000003&(data))>>0)
+#define HDMI_SYNC_DLY_get_disp_h(data)                                               ((0x00000003&(data))>>0)
+
+
+#define HDMI_CR                                                                      0x034
+#define HDMI_CR_reg_addr                                                             "0x9800D034"
+#define HDMI_CR_reg                                                                  0x9800D034
+#define set_HDMI_CR_reg(data)   (*((volatile unsigned int*) HDMI_CR_reg)=data)
+#define get_HDMI_CR_reg   (*((volatile unsigned int*) HDMI_CR_reg))
+#define HDMI_CR_inst_adr                                                             "0x000D"
+#define HDMI_CR_inst                                                                 0x000D
+#define HDMI_CR_write_en3_shift                                                      (5)
+#define HDMI_CR_write_en3_mask                                                       (0x00000020)
+#define HDMI_CR_write_en3(data)                                                      (0x00000020&((data)<<5))
+#define HDMI_CR_write_en3_src(data)                                                  ((0x00000020&(data))>>5)
+#define HDMI_CR_get_write_en3(data)                                                  ((0x00000020&(data))>>5)
+#define HDMI_CR_tmds_encen_shift                                                     (4)
+#define HDMI_CR_tmds_encen_mask                                                      (0x00000010)
+#define HDMI_CR_tmds_encen(data)                                                     (0x00000010&((data)<<4))
+#define HDMI_CR_tmds_encen_src(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_CR_get_tmds_encen(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_CR_write_en1_shift                                                      (1)
+#define HDMI_CR_write_en1_mask                                                       (0x00000002)
+#define HDMI_CR_write_en1(data)                                                      (0x00000002&((data)<<1))
+#define HDMI_CR_write_en1_src(data)                                                  ((0x00000002&(data))>>1)
+#define HDMI_CR_get_write_en1(data)                                                  ((0x00000002&(data))>>1)
+#define HDMI_CR_enablehdmi_shift                                                     (0)
+#define HDMI_CR_enablehdmi_mask                                                      (0x00000001)
+#define HDMI_CR_enablehdmi(data)                                                     (0x00000001&((data)<<0))
+#define HDMI_CR_enablehdmi_src(data)                                                 ((0x00000001&(data))>>0)
+#define HDMI_CR_get_enablehdmi(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define HDMI_DPC                                                                     0x154
+#define HDMI_DPC_reg_addr                                                            "0x9800D154"
+#define HDMI_DPC_reg                                                                 0x9800D154
+#define set_HDMI_DPC_reg(data)   (*((volatile unsigned int*) HDMI_DPC_reg)=data)
+#define get_HDMI_DPC_reg   (*((volatile unsigned int*) HDMI_DPC_reg))
+#define HDMI_DPC_inst_adr                                                            "0x0055"
+#define HDMI_DPC_inst                                                                0x0055
+#define HDMI_DPC_write_en9_shift                                                     (30)
+#define HDMI_DPC_write_en9_mask                                                      (0x40000000)
+#define HDMI_DPC_write_en9(data)                                                     (0x40000000&((data)<<30))
+#define HDMI_DPC_write_en9_src(data)                                                 ((0x40000000&(data))>>30)
+#define HDMI_DPC_get_write_en9(data)                                                 ((0x40000000&(data))>>30)
+#define HDMI_DPC_dp_vfch_num_shift                                                   (28)
+#define HDMI_DPC_dp_vfch_num_mask                                                    (0x30000000)
+#define HDMI_DPC_dp_vfch_num(data)                                                   (0x30000000&((data)<<28))
+#define HDMI_DPC_dp_vfch_num_src(data)                                               ((0x30000000&(data))>>28)
+#define HDMI_DPC_get_dp_vfch_num(data)                                               ((0x30000000&(data))>>28)
+#define HDMI_DPC_write_en8_shift                                                     (25)
+#define HDMI_DPC_write_en8_mask                                                      (0x02000000)
+#define HDMI_DPC_write_en8(data)                                                     (0x02000000&((data)<<25))
+#define HDMI_DPC_write_en8_src(data)                                                 ((0x02000000&(data))>>25)
+#define HDMI_DPC_get_write_en8(data)                                                 ((0x02000000&(data))>>25)
+#define HDMI_DPC_fp_swen_shift                                                       (24)
+#define HDMI_DPC_fp_swen_mask                                                        (0x01000000)
+#define HDMI_DPC_fp_swen(data)                                                       (0x01000000&((data)<<24))
+#define HDMI_DPC_fp_swen_src(data)                                                   ((0x01000000&(data))>>24)
+#define HDMI_DPC_get_fp_swen(data)                                                   ((0x01000000&(data))>>24)
+#define HDMI_DPC_write_en7_shift                                                     (23)
+#define HDMI_DPC_write_en7_mask                                                      (0x00800000)
+#define HDMI_DPC_write_en7(data)                                                     (0x00800000&((data)<<23))
+#define HDMI_DPC_write_en7_src(data)                                                 ((0x00800000&(data))>>23)
+#define HDMI_DPC_get_write_en7(data)                                                 ((0x00800000&(data))>>23)
+#define HDMI_DPC_fp_shift                                                            (20)
+#define HDMI_DPC_fp_mask                                                             (0x00700000)
+#define HDMI_DPC_fp(data)                                                            (0x00700000&((data)<<20))
+#define HDMI_DPC_fp_src(data)                                                        ((0x00700000&(data))>>20)
+#define HDMI_DPC_get_fp(data)                                                        ((0x00700000&(data))>>20)
+#define HDMI_DPC_write_en6_shift                                                     (19)
+#define HDMI_DPC_write_en6_mask                                                      (0x00080000)
+#define HDMI_DPC_write_en6(data)                                                     (0x00080000&((data)<<19))
+#define HDMI_DPC_write_en6_src(data)                                                 ((0x00080000&(data))>>19)
+#define HDMI_DPC_get_write_en6(data)                                                 ((0x00080000&(data))>>19)
+#define HDMI_DPC_pp_swen_shift                                                       (18)
+#define HDMI_DPC_pp_swen_mask                                                        (0x00040000)
+#define HDMI_DPC_pp_swen(data)                                                       (0x00040000&((data)<<18))
+#define HDMI_DPC_pp_swen_src(data)                                                   ((0x00040000&(data))>>18)
+#define HDMI_DPC_get_pp_swen(data)                                                   ((0x00040000&(data))>>18)
+#define HDMI_DPC_write_en4_shift                                                     (15)
+#define HDMI_DPC_write_en4_mask                                                      (0x00008000)
+#define HDMI_DPC_write_en4(data)                                                     (0x00008000&((data)<<15))
+#define HDMI_DPC_write_en4_src(data)                                                 ((0x00008000&(data))>>15)
+#define HDMI_DPC_get_write_en4(data)                                                 ((0x00008000&(data))>>15)
+#define HDMI_DPC_dp_swen_shift                                                       (14)
+#define HDMI_DPC_dp_swen_mask                                                        (0x00004000)
+#define HDMI_DPC_dp_swen(data)                                                       (0x00004000&((data)<<14))
+#define HDMI_DPC_dp_swen_src(data)                                                   ((0x00004000&(data))>>14)
+#define HDMI_DPC_get_dp_swen(data)                                                   ((0x00004000&(data))>>14)
+#define HDMI_DPC_write_en3_shift                                                     (13)
+#define HDMI_DPC_write_en3_mask                                                      (0x00002000)
+#define HDMI_DPC_write_en3(data)                                                     (0x00002000&((data)<<13))
+#define HDMI_DPC_write_en3_src(data)                                                 ((0x00002000&(data))>>13)
+#define HDMI_DPC_get_write_en3(data)                                                 ((0x00002000&(data))>>13)
+#define HDMI_DPC_default_phase_shift                                                 (12)
+#define HDMI_DPC_default_phase_mask                                                  (0x00001000)
+#define HDMI_DPC_default_phase(data)                                                 (0x00001000&((data)<<12))
+#define HDMI_DPC_default_phase_src(data)                                             ((0x00001000&(data))>>12)
+#define HDMI_DPC_get_default_phase(data)                                             ((0x00001000&(data))>>12)
+#define HDMI_DPC_write_en2_shift                                                     (8)
+#define HDMI_DPC_write_en2_mask                                                      (0x00000100)
+#define HDMI_DPC_write_en2(data)                                                     (0x00000100&((data)<<8))
+#define HDMI_DPC_write_en2_src(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_DPC_get_write_en2(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_DPC_color_depth_shift                                                   (4)
+#define HDMI_DPC_color_depth_mask                                                    (0x000000F0)
+#define HDMI_DPC_color_depth(data)                                                   (0x000000F0&((data)<<4))
+#define HDMI_DPC_color_depth_src(data)                                               ((0x000000F0&(data))>>4)
+#define HDMI_DPC_get_color_depth(data)                                               ((0x000000F0&(data))>>4)
+#define HDMI_DPC_write_en1_shift                                                     (1)
+#define HDMI_DPC_write_en1_mask                                                      (0x00000002)
+#define HDMI_DPC_write_en1(data)                                                     (0x00000002&((data)<<1))
+#define HDMI_DPC_write_en1_src(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_DPC_get_write_en1(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_DPC_dpc_enable_shift                                                    (0)
+#define HDMI_DPC_dpc_enable_mask                                                     (0x00000001)
+#define HDMI_DPC_dpc_enable(data)                                                    (0x00000001&((data)<<0))
+#define HDMI_DPC_dpc_enable_src(data)                                                ((0x00000001&(data))>>0)
+#define HDMI_DPC_get_dpc_enable(data)                                                ((0x00000001&(data))>>0)
+
+
+#define HDMI_DPC1                                                                    0x158
+#define HDMI_DPC1_reg_addr                                                           "0x9800D158"
+#define HDMI_DPC1_reg                                                                0x9800D158
+#define set_HDMI_DPC1_reg(data)   (*((volatile unsigned int*) HDMI_DPC1_reg)=data)
+#define get_HDMI_DPC1_reg   (*((volatile unsigned int*) HDMI_DPC1_reg))
+#define HDMI_DPC1_inst_adr                                                           "0x0056"
+#define HDMI_DPC1_inst                                                               0x0056
+#define HDMI_DPC1_write_en2_shift                                                    (9)
+#define HDMI_DPC1_write_en2_mask                                                     (0x00000200)
+#define HDMI_DPC1_write_en2(data)                                                    (0x00000200&((data)<<9))
+#define HDMI_DPC1_write_en2_src(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_DPC1_get_write_en2(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_DPC1_dp_vfch_shift                                                      (8)
+#define HDMI_DPC1_dp_vfch_mask                                                       (0x00000100)
+#define HDMI_DPC1_dp_vfch(data)                                                      (0x00000100&((data)<<8))
+#define HDMI_DPC1_dp_vfch_src(data)                                                  ((0x00000100&(data))>>8)
+#define HDMI_DPC1_get_dp_vfch(data)                                                  ((0x00000100&(data))>>8)
+#define HDMI_DPC1_write_en1_shift                                                    (4)
+#define HDMI_DPC1_write_en1_mask                                                     (0x00000010)
+#define HDMI_DPC1_write_en1(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_DPC1_write_en1_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_DPC1_get_write_en1(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_DPC1_pp_shift                                                           (0)
+#define HDMI_DPC1_pp_mask                                                            (0x0000000F)
+#define HDMI_DPC1_pp(data)                                                           (0x0000000F&((data)<<0))
+#define HDMI_DPC1_pp_src(data)                                                       ((0x0000000F&(data))>>0)
+#define HDMI_DPC1_get_pp(data)                                                       ((0x0000000F&(data))>>0)
+
+
+#define HDMI_TMDS_EODR0                                                              0x038
+#define HDMI_TMDS_EODR0_reg_addr                                                     "0x9800D038"
+#define HDMI_TMDS_EODR0_reg                                                          0x9800D038
+#define set_HDMI_TMDS_EODR0_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_EODR0_reg)=data)
+#define get_HDMI_TMDS_EODR0_reg   (*((volatile unsigned int*) HDMI_TMDS_EODR0_reg))
+#define HDMI_TMDS_EODR0_inst_adr                                                     "0x000E"
+#define HDMI_TMDS_EODR0_inst                                                         0x000E
+#define HDMI_TMDS_EODR0_tmds_ch2_out_shift                                           (20)
+#define HDMI_TMDS_EODR0_tmds_ch2_out_mask                                            (0x3FF00000)
+#define HDMI_TMDS_EODR0_tmds_ch2_out(data)                                           (0x3FF00000&((data)<<20))
+#define HDMI_TMDS_EODR0_tmds_ch2_out_src(data)                                       ((0x3FF00000&(data))>>20)
+#define HDMI_TMDS_EODR0_get_tmds_ch2_out(data)                                       ((0x3FF00000&(data))>>20)
+#define HDMI_TMDS_EODR0_tmds_ch1_out_shift                                           (10)
+#define HDMI_TMDS_EODR0_tmds_ch1_out_mask                                            (0x000FFC00)
+#define HDMI_TMDS_EODR0_tmds_ch1_out(data)                                           (0x000FFC00&((data)<<10))
+#define HDMI_TMDS_EODR0_tmds_ch1_out_src(data)                                       ((0x000FFC00&(data))>>10)
+#define HDMI_TMDS_EODR0_get_tmds_ch1_out(data)                                       ((0x000FFC00&(data))>>10)
+#define HDMI_TMDS_EODR0_tmds_ch0_out_shift                                           (0)
+#define HDMI_TMDS_EODR0_tmds_ch0_out_mask                                            (0x000003FF)
+#define HDMI_TMDS_EODR0_tmds_ch0_out(data)                                           (0x000003FF&((data)<<0))
+#define HDMI_TMDS_EODR0_tmds_ch0_out_src(data)                                       ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_EODR0_get_tmds_ch0_out(data)                                       ((0x000003FF&(data))>>0)
+
+
+#define HDMI_TMDS_EODR1                                                              0x03c
+#define HDMI_TMDS_EODR1_reg_addr                                                     "0x9800D03C"
+#define HDMI_TMDS_EODR1_reg                                                          0x9800D03C
+#define set_HDMI_TMDS_EODR1_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_EODR1_reg)=data)
+#define get_HDMI_TMDS_EODR1_reg   (*((volatile unsigned int*) HDMI_TMDS_EODR1_reg))
+#define HDMI_TMDS_EODR1_inst_adr                                                     "0x000F"
+#define HDMI_TMDS_EODR1_inst                                                         0x000F
+#define HDMI_TMDS_EODR1_default_phase_st_shift                                       (12)
+#define HDMI_TMDS_EODR1_default_phase_st_mask                                        (0x00001000)
+#define HDMI_TMDS_EODR1_default_phase_st(data)                                       (0x00001000&((data)<<12))
+#define HDMI_TMDS_EODR1_default_phase_st_src(data)                                   ((0x00001000&(data))>>12)
+#define HDMI_TMDS_EODR1_get_default_phase_st(data)                                   ((0x00001000&(data))>>12)
+#define HDMI_TMDS_EODR1_tmds_clk_out_shift                                           (0)
+#define HDMI_TMDS_EODR1_tmds_clk_out_mask                                            (0x000003FF)
+#define HDMI_TMDS_EODR1_tmds_clk_out(data)                                           (0x000003FF&((data)<<0))
+#define HDMI_TMDS_EODR1_tmds_clk_out_src(data)                                       ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_EODR1_get_tmds_clk_out(data)                                       ((0x000003FF&(data))>>0)
+
+
+#define HDMI_TMDS_STR0                                                               0x048
+#define HDMI_TMDS_STR0_reg_addr                                                      "0x9800D048"
+#define HDMI_TMDS_STR0_reg                                                           0x9800D048
+#define set_HDMI_TMDS_STR0_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_STR0_reg)=data)
+#define get_HDMI_TMDS_STR0_reg   (*((volatile unsigned int*) HDMI_TMDS_STR0_reg))
+#define HDMI_TMDS_STR0_inst_adr                                                      "0x0012"
+#define HDMI_TMDS_STR0_inst                                                          0x0012
+#define HDMI_TMDS_STR0_tmds1ten_shift                                                (31)
+#define HDMI_TMDS_STR0_tmds1ten_mask                                                 (0x80000000)
+#define HDMI_TMDS_STR0_tmds1ten(data)                                                (0x80000000&((data)<<31))
+#define HDMI_TMDS_STR0_tmds1ten_src(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR0_get_tmds1ten(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR0_td1src_shift                                                  (30)
+#define HDMI_TMDS_STR0_td1src_mask                                                   (0x40000000)
+#define HDMI_TMDS_STR0_td1src(data)                                                  (0x40000000&((data)<<30))
+#define HDMI_TMDS_STR0_td1src_src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR0_get_td1src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR0_tmds1td_shift                                                 (16)
+#define HDMI_TMDS_STR0_tmds1td_mask                                                  (0x03FF0000)
+#define HDMI_TMDS_STR0_tmds1td(data)                                                 (0x03FF0000&((data)<<16))
+#define HDMI_TMDS_STR0_tmds1td_src(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR0_get_tmds1td(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR0_tmds0ten_shift                                                (15)
+#define HDMI_TMDS_STR0_tmds0ten_mask                                                 (0x00008000)
+#define HDMI_TMDS_STR0_tmds0ten(data)                                                (0x00008000&((data)<<15))
+#define HDMI_TMDS_STR0_tmds0ten_src(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR0_get_tmds0ten(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR0_td0src_shift                                                  (14)
+#define HDMI_TMDS_STR0_td0src_mask                                                   (0x00004000)
+#define HDMI_TMDS_STR0_td0src(data)                                                  (0x00004000&((data)<<14))
+#define HDMI_TMDS_STR0_td0src_src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR0_get_td0src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR0_tmds0td_shift                                                 (0)
+#define HDMI_TMDS_STR0_tmds0td_mask                                                  (0x000003FF)
+#define HDMI_TMDS_STR0_tmds0td(data)                                                 (0x000003FF&((data)<<0))
+#define HDMI_TMDS_STR0_tmds0td_src(data)                                             ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_STR0_get_tmds0td(data)                                             ((0x000003FF&(data))>>0)
+
+
+#define HDMI_TMDS_STR1                                                               0x04c
+#define HDMI_TMDS_STR1_reg_addr                                                      "0x9800D04C"
+#define HDMI_TMDS_STR1_reg                                                           0x9800D04C
+#define set_HDMI_TMDS_STR1_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_STR1_reg)=data)
+#define get_HDMI_TMDS_STR1_reg   (*((volatile unsigned int*) HDMI_TMDS_STR1_reg))
+#define HDMI_TMDS_STR1_inst_adr                                                      "0x0013"
+#define HDMI_TMDS_STR1_inst                                                          0x0013
+#define HDMI_TMDS_STR1_tmdscten_shift                                                (31)
+#define HDMI_TMDS_STR1_tmdscten_mask                                                 (0x80000000)
+#define HDMI_TMDS_STR1_tmdscten(data)                                                (0x80000000&((data)<<31))
+#define HDMI_TMDS_STR1_tmdscten_src(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR1_get_tmdscten(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR1_tdcsrc_shift                                                  (30)
+#define HDMI_TMDS_STR1_tdcsrc_mask                                                   (0x40000000)
+#define HDMI_TMDS_STR1_tdcsrc(data)                                                  (0x40000000&((data)<<30))
+#define HDMI_TMDS_STR1_tdcsrc_src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR1_get_tdcsrc(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR1_tmdsctd_shift                                                 (16)
+#define HDMI_TMDS_STR1_tmdsctd_mask                                                  (0x03FF0000)
+#define HDMI_TMDS_STR1_tmdsctd(data)                                                 (0x03FF0000&((data)<<16))
+#define HDMI_TMDS_STR1_tmdsctd_src(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR1_get_tmdsctd(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR1_tmds2ten_shift                                                (15)
+#define HDMI_TMDS_STR1_tmds2ten_mask                                                 (0x00008000)
+#define HDMI_TMDS_STR1_tmds2ten(data)                                                (0x00008000&((data)<<15))
+#define HDMI_TMDS_STR1_tmds2ten_src(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR1_get_tmds2ten(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR1_td2src_shift                                                  (14)
+#define HDMI_TMDS_STR1_td2src_mask                                                   (0x00004000)
+#define HDMI_TMDS_STR1_td2src(data)                                                  (0x00004000&((data)<<14))
+#define HDMI_TMDS_STR1_td2src_src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR1_get_td2src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR1_tmds2td_shift                                                 (0)
+#define HDMI_TMDS_STR1_tmds2td_mask                                                  (0x000003FF)
+#define HDMI_TMDS_STR1_tmds2td(data)                                                 (0x000003FF&((data)<<0))
+#define HDMI_TMDS_STR1_tmds2td_src(data)                                             ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_STR1_get_tmds2td(data)                                             ((0x000003FF&(data))>>0)
+
+
+#define HDMI_ASPCR1                                                                  0x054
+#define HDMI_ASPCR1_reg_addr                                                         "0x9800D054"
+#define HDMI_ASPCR1_reg                                                              0x9800D054
+#define set_HDMI_ASPCR1_reg(data)   (*((volatile unsigned int*) HDMI_ASPCR1_reg)=data)
+#define get_HDMI_ASPCR1_reg   (*((volatile unsigned int*) HDMI_ASPCR1_reg))
+#define HDMI_ASPCR1_inst_adr                                                         "0x0015"
+#define HDMI_ASPCR1_inst                                                             0x0015
+#define HDMI_ASPCR1_write_en8_shift                                                  (28)
+#define HDMI_ASPCR1_write_en8_mask                                                   (0x10000000)
+#define HDMI_ASPCR1_write_en8(data)                                                  (0x10000000&((data)<<28))
+#define HDMI_ASPCR1_write_en8_src(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ASPCR1_get_write_en8(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ASPCR1_ycbcr422_8bits_shift                                             (27)
+#define HDMI_ASPCR1_ycbcr422_8bits_mask                                              (0x08000000)
+#define HDMI_ASPCR1_ycbcr422_8bits(data)                                             (0x08000000&((data)<<27))
+#define HDMI_ASPCR1_ycbcr422_8bits_src(data)                                         ((0x08000000&(data))>>27)
+#define HDMI_ASPCR1_get_ycbcr422_8bits(data)                                         ((0x08000000&(data))>>27)
+#define HDMI_ASPCR1_write_en7_shift                                                  (26)
+#define HDMI_ASPCR1_write_en7_mask                                                   (0x04000000)
+#define HDMI_ASPCR1_write_en7(data)                                                  (0x04000000&((data)<<26))
+#define HDMI_ASPCR1_write_en7_src(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ASPCR1_get_write_en7(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ASPCR1_cts_pkt_hp_shift                                                 (25)
+#define HDMI_ASPCR1_cts_pkt_hp_mask                                                  (0x02000000)
+#define HDMI_ASPCR1_cts_pkt_hp(data)                                                 (0x02000000&((data)<<25))
+#define HDMI_ASPCR1_cts_pkt_hp_src(data)                                             ((0x02000000&(data))>>25)
+#define HDMI_ASPCR1_get_cts_pkt_hp(data)                                             ((0x02000000&(data))>>25)
+#define HDMI_ASPCR1_write_en6_shift                                                  (24)
+#define HDMI_ASPCR1_write_en6_mask                                                   (0x01000000)
+#define HDMI_ASPCR1_write_en6(data)                                                  (0x01000000&((data)<<24))
+#define HDMI_ASPCR1_write_en6_src(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ASPCR1_get_write_en6(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ASPCR1_Audioheader0_shift                                               (16)
+#define HDMI_ASPCR1_Audioheader0_mask                                                (0x00FF0000)
+#define HDMI_ASPCR1_Audioheader0(data)                                               (0x00FF0000&((data)<<16))
+#define HDMI_ASPCR1_Audioheader0_src(data)                                           ((0x00FF0000&(data))>>16)
+#define HDMI_ASPCR1_get_Audioheader0(data)                                           ((0x00FF0000&(data))>>16)
+#define HDMI_ASPCR1_write_en5_shift                                                  (15)
+#define HDMI_ASPCR1_write_en5_mask                                                   (0x00008000)
+#define HDMI_ASPCR1_write_en5(data)                                                  (0x00008000&((data)<<15))
+#define HDMI_ASPCR1_write_en5_src(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_ASPCR1_get_write_en5(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_ASPCR1_samplepresent_shift                                              (11)
+#define HDMI_ASPCR1_samplepresent_mask                                               (0x00007800)
+#define HDMI_ASPCR1_samplepresent(data)                                              (0x00007800&((data)<<11))
+#define HDMI_ASPCR1_samplepresent_src(data)                                          ((0x00007800&(data))>>11)
+#define HDMI_ASPCR1_get_samplepresent(data)                                          ((0x00007800&(data))>>11)
+#define HDMI_ASPCR1_write_en4_shift                                                  (10)
+#define HDMI_ASPCR1_write_en4_mask                                                   (0x00000400)
+#define HDMI_ASPCR1_write_en4(data)                                                  (0x00000400&((data)<<10))
+#define HDMI_ASPCR1_write_en4_src(data)                                              ((0x00000400&(data))>>10)
+#define HDMI_ASPCR1_get_write_en4(data)                                              ((0x00000400&(data))>>10)
+#define HDMI_ASPCR1_forcesamplepresent_shift                                         (9)
+#define HDMI_ASPCR1_forcesamplepresent_mask                                          (0x00000200)
+#define HDMI_ASPCR1_forcesamplepresent(data)                                         (0x00000200&((data)<<9))
+#define HDMI_ASPCR1_forcesamplepresent_src(data)                                     ((0x00000200&(data))>>9)
+#define HDMI_ASPCR1_get_forcesamplepresent(data)                                     ((0x00000200&(data))>>9)
+#define HDMI_ASPCR1_write_en3_shift                                                  (8)
+#define HDMI_ASPCR1_write_en3_mask                                                   (0x00000100)
+#define HDMI_ASPCR1_write_en3(data)                                                  (0x00000100&((data)<<8))
+#define HDMI_ASPCR1_write_en3_src(data)                                              ((0x00000100&(data))>>8)
+#define HDMI_ASPCR1_get_write_en3(data)                                              ((0x00000100&(data))>>8)
+#define HDMI_ASPCR1_b_frame_shift                                                    (4)
+#define HDMI_ASPCR1_b_frame_mask                                                     (0x000000F0)
+#define HDMI_ASPCR1_b_frame(data)                                                    (0x000000F0&((data)<<4))
+#define HDMI_ASPCR1_b_frame_src(data)                                                ((0x000000F0&(data))>>4)
+#define HDMI_ASPCR1_get_b_frame(data)                                                ((0x000000F0&(data))>>4)
+#define HDMI_ASPCR1_write_en2_shift                                                  (3)
+#define HDMI_ASPCR1_write_en2_mask                                                   (0x00000008)
+#define HDMI_ASPCR1_write_en2(data)                                                  (0x00000008&((data)<<3))
+#define HDMI_ASPCR1_write_en2_src(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_ASPCR1_get_write_en2(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_ASPCR1_forceb_frame_shift                                               (2)
+#define HDMI_ASPCR1_forceb_frame_mask                                                (0x00000004)
+#define HDMI_ASPCR1_forceb_frame(data)                                               (0x00000004&((data)<<2))
+#define HDMI_ASPCR1_forceb_frame_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_ASPCR1_get_forceb_frame(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_ASPCR1_write_en1_shift                                                  (1)
+#define HDMI_ASPCR1_write_en1_mask                                                   (0x00000002)
+#define HDMI_ASPCR1_write_en1(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_ASPCR1_write_en1_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_ASPCR1_get_write_en1(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_ASPCR1_audiolayout_shift                                                (0)
+#define HDMI_ASPCR1_audiolayout_mask                                                 (0x00000001)
+#define HDMI_ASPCR1_audiolayout(data)                                                (0x00000001&((data)<<0))
+#define HDMI_ASPCR1_audiolayout_src(data)                                            ((0x00000001&(data))>>0)
+#define HDMI_ASPCR1_get_audiolayout(data)                                            ((0x00000001&(data))>>0)
+
+
+#define HDMI_ACACR                                                                   0x058
+#define HDMI_ACACR_reg_addr                                                          "0x9800D058"
+#define HDMI_ACACR_reg                                                               0x9800D058
+#define set_HDMI_ACACR_reg(data)   (*((volatile unsigned int*) HDMI_ACACR_reg)=data)
+#define get_HDMI_ACACR_reg   (*((volatile unsigned int*) HDMI_ACACR_reg))
+#define HDMI_ACACR_inst_adr                                                          "0x0016"
+#define HDMI_ACACR_inst                                                              0x0016
+#define HDMI_ACACR_write_en4_shift                                                   (15)
+#define HDMI_ACACR_write_en4_mask                                                    (0x00008000)
+#define HDMI_ACACR_write_en4(data)                                                   (0x00008000&((data)<<15))
+#define HDMI_ACACR_write_en4_src(data)                                               ((0x00008000&(data))>>15)
+#define HDMI_ACACR_get_write_en4(data)                                               ((0x00008000&(data))>>15)
+#define HDMI_ACACR_hdmi_pk3map_shift                                                 (12)
+#define HDMI_ACACR_hdmi_pk3map_mask                                                  (0x00007000)
+#define HDMI_ACACR_hdmi_pk3map(data)                                                 (0x00007000&((data)<<12))
+#define HDMI_ACACR_hdmi_pk3map_src(data)                                             ((0x00007000&(data))>>12)
+#define HDMI_ACACR_get_hdmi_pk3map(data)                                             ((0x00007000&(data))>>12)
+#define HDMI_ACACR_write_en3_shift                                                   (11)
+#define HDMI_ACACR_write_en3_mask                                                    (0x00000800)
+#define HDMI_ACACR_write_en3(data)                                                   (0x00000800&((data)<<11))
+#define HDMI_ACACR_write_en3_src(data)                                               ((0x00000800&(data))>>11)
+#define HDMI_ACACR_get_write_en3(data)                                               ((0x00000800&(data))>>11)
+#define HDMI_ACACR_hdmi_pk2map_shift                                                 (8)
+#define HDMI_ACACR_hdmi_pk2map_mask                                                  (0x00000700)
+#define HDMI_ACACR_hdmi_pk2map(data)                                                 (0x00000700&((data)<<8))
+#define HDMI_ACACR_hdmi_pk2map_src(data)                                             ((0x00000700&(data))>>8)
+#define HDMI_ACACR_get_hdmi_pk2map(data)                                             ((0x00000700&(data))>>8)
+#define HDMI_ACACR_write_en2_shift                                                   (7)
+#define HDMI_ACACR_write_en2_mask                                                    (0x00000080)
+#define HDMI_ACACR_write_en2(data)                                                   (0x00000080&((data)<<7))
+#define HDMI_ACACR_write_en2_src(data)                                               ((0x00000080&(data))>>7)
+#define HDMI_ACACR_get_write_en2(data)                                               ((0x00000080&(data))>>7)
+#define HDMI_ACACR_hdmi_pk1map_shift                                                 (4)
+#define HDMI_ACACR_hdmi_pk1map_mask                                                  (0x00000070)
+#define HDMI_ACACR_hdmi_pk1map(data)                                                 (0x00000070&((data)<<4))
+#define HDMI_ACACR_hdmi_pk1map_src(data)                                             ((0x00000070&(data))>>4)
+#define HDMI_ACACR_get_hdmi_pk1map(data)                                             ((0x00000070&(data))>>4)
+#define HDMI_ACACR_write_en1_shift                                                   (3)
+#define HDMI_ACACR_write_en1_mask                                                    (0x00000008)
+#define HDMI_ACACR_write_en1(data)                                                   (0x00000008&((data)<<3))
+#define HDMI_ACACR_write_en1_src(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_ACACR_get_write_en1(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_ACACR_hdmi_pk0map_shift                                                 (0)
+#define HDMI_ACACR_hdmi_pk0map_mask                                                  (0x00000007)
+#define HDMI_ACACR_hdmi_pk0map(data)                                                 (0x00000007&((data)<<0))
+#define HDMI_ACACR_hdmi_pk0map_src(data)                                             ((0x00000007&(data))>>0)
+#define HDMI_ACACR_get_hdmi_pk0map(data)                                             ((0x00000007&(data))>>0)
+
+
+#define HDMI_ACRPCR                                                                  0x06c
+#define HDMI_ACRPCR_reg_addr                                                         "0x9800D06C"
+#define HDMI_ACRPCR_reg                                                              0x9800D06C
+#define set_HDMI_ACRPCR_reg(data)   (*((volatile unsigned int*) HDMI_ACRPCR_reg)=data)
+#define get_HDMI_ACRPCR_reg   (*((volatile unsigned int*) HDMI_ACRPCR_reg))
+#define HDMI_ACRPCR_inst_adr                                                         "0x001B"
+#define HDMI_ACRPCR_inst                                                             0x001B
+#define HDMI_ACRPCR_write_en6_shift                                                  (30)
+#define HDMI_ACRPCR_write_en6_mask                                                   (0x40000000)
+#define HDMI_ACRPCR_write_en6(data)                                                  (0x40000000&((data)<<30))
+#define HDMI_ACRPCR_write_en6_src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_ACRPCR_get_write_en6(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_ACRPCR_Audio_info_hp_shift                                              (29)
+#define HDMI_ACRPCR_Audio_info_hp_mask                                               (0x20000000)
+#define HDMI_ACRPCR_Audio_info_hp(data)                                              (0x20000000&((data)<<29))
+#define HDMI_ACRPCR_Audio_info_hp_src(data)                                          ((0x20000000&(data))>>29)
+#define HDMI_ACRPCR_get_Audio_info_hp(data)                                          ((0x20000000&(data))>>29)
+#define HDMI_ACRPCR_write_en5_shift                                                  (28)
+#define HDMI_ACRPCR_write_en5_mask                                                   (0x10000000)
+#define HDMI_ACRPCR_write_en5(data)                                                  (0x10000000&((data)<<28))
+#define HDMI_ACRPCR_write_en5_src(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ACRPCR_get_write_en5(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ACRPCR_ac_hw_ctrl_en_shift                                              (27)
+#define HDMI_ACRPCR_ac_hw_ctrl_en_mask                                               (0x08000000)
+#define HDMI_ACRPCR_ac_hw_ctrl_en(data)                                              (0x08000000&((data)<<27))
+#define HDMI_ACRPCR_ac_hw_ctrl_en_src(data)                                          ((0x08000000&(data))>>27)
+#define HDMI_ACRPCR_get_ac_hw_ctrl_en(data)                                          ((0x08000000&(data))>>27)
+#define HDMI_ACRPCR_write_en4_shift                                                  (26)
+#define HDMI_ACRPCR_write_en4_mask                                                   (0x04000000)
+#define HDMI_ACRPCR_write_en4(data)                                                  (0x04000000&((data)<<26))
+#define HDMI_ACRPCR_write_en4_src(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ACRPCR_get_write_en4(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ACRPCR_fs_div4_shift                                                    (25)
+#define HDMI_ACRPCR_fs_div4_mask                                                     (0x02000000)
+#define HDMI_ACRPCR_fs_div4(data)                                                    (0x02000000&((data)<<25))
+#define HDMI_ACRPCR_fs_div4_src(data)                                                ((0x02000000&(data))>>25)
+#define HDMI_ACRPCR_get_fs_div4(data)                                                ((0x02000000&(data))>>25)
+#define HDMI_ACRPCR_write_en3_shift                                                  (24)
+#define HDMI_ACRPCR_write_en3_mask                                                   (0x01000000)
+#define HDMI_ACRPCR_write_en3(data)                                                  (0x01000000&((data)<<24))
+#define HDMI_ACRPCR_write_en3_src(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ACRPCR_get_write_en3(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ACRPCR_disablecrp_shift                                                 (23)
+#define HDMI_ACRPCR_disablecrp_mask                                                  (0x00800000)
+#define HDMI_ACRPCR_disablecrp(data)                                                 (0x00800000&((data)<<23))
+#define HDMI_ACRPCR_disablecrp_src(data)                                             ((0x00800000&(data))>>23)
+#define HDMI_ACRPCR_get_disablecrp(data)                                             ((0x00800000&(data))>>23)
+#define HDMI_ACRPCR_write_en2_shift                                                  (22)
+#define HDMI_ACRPCR_write_en2_mask                                                   (0x00400000)
+#define HDMI_ACRPCR_write_en2(data)                                                  (0x00400000&((data)<<22))
+#define HDMI_ACRPCR_write_en2_src(data)                                              ((0x00400000&(data))>>22)
+#define HDMI_ACRPCR_get_write_en2(data)                                              ((0x00400000&(data))>>22)
+#define HDMI_ACRPCR_cts_source_shift                                                 (21)
+#define HDMI_ACRPCR_cts_source_mask                                                  (0x00200000)
+#define HDMI_ACRPCR_cts_source(data)                                                 (0x00200000&((data)<<21))
+#define HDMI_ACRPCR_cts_source_src(data)                                             ((0x00200000&(data))>>21)
+#define HDMI_ACRPCR_get_cts_source(data)                                             ((0x00200000&(data))>>21)
+#define HDMI_ACRPCR_write_en1_shift                                                  (20)
+#define HDMI_ACRPCR_write_en1_mask                                                   (0x00100000)
+#define HDMI_ACRPCR_write_en1(data)                                                  (0x00100000&((data)<<20))
+#define HDMI_ACRPCR_write_en1_src(data)                                              ((0x00100000&(data))>>20)
+#define HDMI_ACRPCR_get_write_en1(data)                                              ((0x00100000&(data))>>20)
+#define HDMI_ACRPCR_n_value_shift                                                    (0)
+#define HDMI_ACRPCR_n_value_mask                                                     (0x000FFFFF)
+#define HDMI_ACRPCR_n_value(data)                                                    (0x000FFFFF&((data)<<0))
+#define HDMI_ACRPCR_n_value_src(data)                                                ((0x000FFFFF&(data))>>0)
+#define HDMI_ACRPCR_get_n_value(data)                                                ((0x000FFFFF&(data))>>0)
+
+
+#define HDMI_ACRPCTSR                                                                0x070
+#define HDMI_ACRPCTSR_reg_addr                                                       "0x9800D070"
+#define HDMI_ACRPCTSR_reg                                                            0x9800D070
+#define set_HDMI_ACRPCTSR_reg(data)   (*((volatile unsigned int*) HDMI_ACRPCTSR_reg)=data)
+#define get_HDMI_ACRPCTSR_reg   (*((volatile unsigned int*) HDMI_ACRPCTSR_reg))
+#define HDMI_ACRPCTSR_inst_adr                                                       "0x001C"
+#define HDMI_ACRPCTSR_inst                                                           0x001C
+#define HDMI_ACRPCTSR_ctssw_shift                                                    (0)
+#define HDMI_ACRPCTSR_ctssw_mask                                                     (0x000FFFFF)
+#define HDMI_ACRPCTSR_ctssw(data)                                                    (0x000FFFFF&((data)<<0))
+#define HDMI_ACRPCTSR_ctssw_src(data)                                                ((0x000FFFFF&(data))>>0)
+#define HDMI_ACRPCTSR_get_ctssw(data)                                                ((0x000FFFFF&(data))>>0)
+
+
+#define HDMI_ACRPPR                                                                  0x074
+#define HDMI_ACRPPR_reg_addr                                                         "0x9800D074"
+#define HDMI_ACRPPR_reg                                                              0x9800D074
+#define set_HDMI_ACRPPR_reg(data)   (*((volatile unsigned int*) HDMI_ACRPPR_reg)=data)
+#define get_HDMI_ACRPPR_reg   (*((volatile unsigned int*) HDMI_ACRPPR_reg))
+#define HDMI_ACRPPR_inst_adr                                                         "0x001D"
+#define HDMI_ACRPPR_inst                                                             0x001D
+#define HDMI_ACRPPR_ctshw_shift                                                      (0)
+#define HDMI_ACRPPR_ctshw_mask                                                       (0x000FFFFF)
+#define HDMI_ACRPPR_ctshw(data)                                                      (0x000FFFFF&((data)<<0))
+#define HDMI_ACRPPR_ctshw_src(data)                                                  ((0x000FFFFF&(data))>>0)
+#define HDMI_ACRPPR_get_ctshw(data)                                                  ((0x000FFFFF&(data))>>0)
+
+
+#define HDMI_GCPCR                                                                   0x078
+#define HDMI_GCPCR_reg_addr                                                          "0x9800D078"
+#define HDMI_GCPCR_reg                                                               0x9800D078
+#define set_HDMI_GCPCR_reg(data)   (*((volatile unsigned int*) HDMI_GCPCR_reg)=data)
+#define get_HDMI_GCPCR_reg   (*((volatile unsigned int*) HDMI_GCPCR_reg))
+#define HDMI_GCPCR_inst_adr                                                          "0x001E"
+#define HDMI_GCPCR_inst                                                              0x001E
+#define HDMI_GCPCR_enablegcp_shift                                                   (3)
+#define HDMI_GCPCR_enablegcp_mask                                                    (0x00000008)
+#define HDMI_GCPCR_enablegcp(data)                                                   (0x00000008&((data)<<3))
+#define HDMI_GCPCR_enablegcp_src(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_GCPCR_get_enablegcp(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_GCPCR_gcp_clearavmute_shift                                             (2)
+#define HDMI_GCPCR_gcp_clearavmute_mask                                              (0x00000004)
+#define HDMI_GCPCR_gcp_clearavmute(data)                                             (0x00000004&((data)<<2))
+#define HDMI_GCPCR_gcp_clearavmute_src(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_GCPCR_get_gcp_clearavmute(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_GCPCR_gcp_setavmute_shift                                               (1)
+#define HDMI_GCPCR_gcp_setavmute_mask                                                (0x00000002)
+#define HDMI_GCPCR_gcp_setavmute(data)                                               (0x00000002&((data)<<1))
+#define HDMI_GCPCR_gcp_setavmute_src(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_GCPCR_get_gcp_setavmute(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_GCPCR_write_data_shift                                                  (0)
+#define HDMI_GCPCR_write_data_mask                                                   (0x00000001)
+#define HDMI_GCPCR_write_data(data)                                                  (0x00000001&((data)<<0))
+#define HDMI_GCPCR_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define HDMI_GCPCR_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define HDMI_ORP6PH                                                                  0x07c
+#define HDMI_ORP6PH_reg_addr                                                         "0x9800D07C"
+#define HDMI_ORP6PH_reg                                                              0x9800D07C
+#define set_HDMI_ORP6PH_reg(data)   (*((volatile unsigned int*) HDMI_ORP6PH_reg)=data)
+#define get_HDMI_ORP6PH_reg   (*((volatile unsigned int*) HDMI_ORP6PH_reg))
+#define HDMI_ORP6PH_inst_adr                                                         "0x001F"
+#define HDMI_ORP6PH_inst                                                             0x001F
+#define HDMI_ORP6PH_once_pkt_shift                                                   (0)
+#define HDMI_ORP6PH_once_pkt_mask                                                    (0xFFFFFFFF)
+#define HDMI_ORP6PH_once_pkt(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_ORP6PH_once_pkt_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_ORP6PH_get_once_pkt(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_ORP6W_0                                                                 0x080
+#define HDMI_ORP6W_1                                                                 0x084
+#define HDMI_ORP6W_2                                                                 0x088
+#define HDMI_ORP6W_3                                                                 0x08C
+#define HDMI_ORP6W_4                                                                 0x090
+#define HDMI_ORP6W_5                                                                 0x094
+#define HDMI_ORP6W_6                                                                 0x098
+#define HDMI_ORP6W_7                                                                 0x09C
+#define HDMI_ORP6W_0_reg_addr                                                        "0x9800D080"
+#define HDMI_ORP6W_1_reg_addr                                                        "0x9800D084"
+#define HDMI_ORP6W_2_reg_addr                                                        "0x9800D088"
+#define HDMI_ORP6W_3_reg_addr                                                        "0x9800D08C"
+#define HDMI_ORP6W_4_reg_addr                                                        "0x9800D090"
+#define HDMI_ORP6W_5_reg_addr                                                        "0x9800D094"
+#define HDMI_ORP6W_6_reg_addr                                                        "0x9800D098"
+#define HDMI_ORP6W_7_reg_addr                                                        "0x9800D09C"
+#define HDMI_ORP6W_0_reg                                                             0x9800D080
+#define HDMI_ORP6W_1_reg                                                             0x9800D084
+#define HDMI_ORP6W_2_reg                                                             0x9800D088
+#define HDMI_ORP6W_3_reg                                                             0x9800D08C
+#define HDMI_ORP6W_4_reg                                                             0x9800D090
+#define HDMI_ORP6W_5_reg                                                             0x9800D094
+#define HDMI_ORP6W_6_reg                                                             0x9800D098
+#define HDMI_ORP6W_7_reg                                                             0x9800D09C
+#define set_HDMI_ORP6W_0_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_0_reg)=data)
+#define set_HDMI_ORP6W_1_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_1_reg)=data)
+#define set_HDMI_ORP6W_2_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_2_reg)=data)
+#define set_HDMI_ORP6W_3_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_3_reg)=data)
+#define set_HDMI_ORP6W_4_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_4_reg)=data)
+#define set_HDMI_ORP6W_5_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_5_reg)=data)
+#define set_HDMI_ORP6W_6_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_6_reg)=data)
+#define set_HDMI_ORP6W_7_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_7_reg)=data)
+#define get_HDMI_ORP6W_0_reg   (*((volatile unsigned int*) HDMI_ORP6W_0_reg))
+#define get_HDMI_ORP6W_1_reg   (*((volatile unsigned int*) HDMI_ORP6W_1_reg))
+#define get_HDMI_ORP6W_2_reg   (*((volatile unsigned int*) HDMI_ORP6W_2_reg))
+#define get_HDMI_ORP6W_3_reg   (*((volatile unsigned int*) HDMI_ORP6W_3_reg))
+#define get_HDMI_ORP6W_4_reg   (*((volatile unsigned int*) HDMI_ORP6W_4_reg))
+#define get_HDMI_ORP6W_5_reg   (*((volatile unsigned int*) HDMI_ORP6W_5_reg))
+#define get_HDMI_ORP6W_6_reg   (*((volatile unsigned int*) HDMI_ORP6W_6_reg))
+#define get_HDMI_ORP6W_7_reg   (*((volatile unsigned int*) HDMI_ORP6W_7_reg))
+#define HDMI_ORP6W_0_inst_adr                                                        "0x0020"
+#define HDMI_ORP6W_1_inst_adr                                                        "0x0021"
+#define HDMI_ORP6W_2_inst_adr                                                        "0x0022"
+#define HDMI_ORP6W_3_inst_adr                                                        "0x0023"
+#define HDMI_ORP6W_4_inst_adr                                                        "0x0024"
+#define HDMI_ORP6W_5_inst_adr                                                        "0x0025"
+#define HDMI_ORP6W_6_inst_adr                                                        "0x0026"
+#define HDMI_ORP6W_7_inst_adr                                                        "0x0027"
+#define HDMI_ORP6W_0_inst                                                            0x0020
+#define HDMI_ORP6W_1_inst                                                            0x0021
+#define HDMI_ORP6W_2_inst                                                            0x0022
+#define HDMI_ORP6W_3_inst                                                            0x0023
+#define HDMI_ORP6W_4_inst                                                            0x0024
+#define HDMI_ORP6W_5_inst                                                            0x0025
+#define HDMI_ORP6W_6_inst                                                            0x0026
+#define HDMI_ORP6W_7_inst                                                            0x0027
+#define HDMI_ORP6W_once_pkt_shift                                                    (0)
+#define HDMI_ORP6W_once_pkt_mask                                                     (0xFFFFFFFF)
+#define HDMI_ORP6W_once_pkt(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_ORP6W_once_pkt_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_ORP6W_get_once_pkt(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_RPCR                                                                    0x0a0
+#define HDMI_RPCR_reg_addr                                                           "0x9800D0A0"
+#define HDMI_RPCR_reg                                                                0x9800D0A0
+#define set_HDMI_RPCR_reg(data)   (*((volatile unsigned int*) HDMI_RPCR_reg)=data)
+#define get_HDMI_RPCR_reg   (*((volatile unsigned int*) HDMI_RPCR_reg))
+#define HDMI_RPCR_inst_adr                                                           "0x0028"
+#define HDMI_RPCR_inst                                                               0x0028
+#define HDMI_RPCR_write_en6_shift                                                    (29)
+#define HDMI_RPCR_write_en6_mask                                                     (0x20000000)
+#define HDMI_RPCR_write_en6(data)                                                    (0x20000000&((data)<<29))
+#define HDMI_RPCR_write_en6_src(data)                                                ((0x20000000&(data))>>29)
+#define HDMI_RPCR_get_write_en6(data)                                                ((0x20000000&(data))>>29)
+#define HDMI_RPCR_prp5period_shift                                                   (25)
+#define HDMI_RPCR_prp5period_mask                                                    (0x1E000000)
+#define HDMI_RPCR_prp5period(data)                                                   (0x1E000000&((data)<<25))
+#define HDMI_RPCR_prp5period_src(data)                                               ((0x1E000000&(data))>>25)
+#define HDMI_RPCR_get_prp5period(data)                                               ((0x1E000000&(data))>>25)
+#define HDMI_RPCR_write_en5_shift                                                    (24)
+#define HDMI_RPCR_write_en5_mask                                                     (0x01000000)
+#define HDMI_RPCR_write_en5(data)                                                    (0x01000000&((data)<<24))
+#define HDMI_RPCR_write_en5_src(data)                                                ((0x01000000&(data))>>24)
+#define HDMI_RPCR_get_write_en5(data)                                                ((0x01000000&(data))>>24)
+#define HDMI_RPCR_prp4period_shift                                                   (20)
+#define HDMI_RPCR_prp4period_mask                                                    (0x00F00000)
+#define HDMI_RPCR_prp4period(data)                                                   (0x00F00000&((data)<<20))
+#define HDMI_RPCR_prp4period_src(data)                                               ((0x00F00000&(data))>>20)
+#define HDMI_RPCR_get_prp4period(data)                                               ((0x00F00000&(data))>>20)
+#define HDMI_RPCR_write_en4_shift                                                    (19)
+#define HDMI_RPCR_write_en4_mask                                                     (0x00080000)
+#define HDMI_RPCR_write_en4(data)                                                    (0x00080000&((data)<<19))
+#define HDMI_RPCR_write_en4_src(data)                                                ((0x00080000&(data))>>19)
+#define HDMI_RPCR_get_write_en4(data)                                                ((0x00080000&(data))>>19)
+#define HDMI_RPCR_prp3period_shift                                                   (15)
+#define HDMI_RPCR_prp3period_mask                                                    (0x00078000)
+#define HDMI_RPCR_prp3period(data)                                                   (0x00078000&((data)<<15))
+#define HDMI_RPCR_prp3period_src(data)                                               ((0x00078000&(data))>>15)
+#define HDMI_RPCR_get_prp3period(data)                                               ((0x00078000&(data))>>15)
+#define HDMI_RPCR_write_en3_shift                                                    (14)
+#define HDMI_RPCR_write_en3_mask                                                     (0x00004000)
+#define HDMI_RPCR_write_en3(data)                                                    (0x00004000&((data)<<14))
+#define HDMI_RPCR_write_en3_src(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_RPCR_get_write_en3(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_RPCR_prp2period_shift                                                   (10)
+#define HDMI_RPCR_prp2period_mask                                                    (0x00003C00)
+#define HDMI_RPCR_prp2period(data)                                                   (0x00003C00&((data)<<10))
+#define HDMI_RPCR_prp2period_src(data)                                               ((0x00003C00&(data))>>10)
+#define HDMI_RPCR_get_prp2period(data)                                               ((0x00003C00&(data))>>10)
+#define HDMI_RPCR_write_en2_shift                                                    (9)
+#define HDMI_RPCR_write_en2_mask                                                     (0x00000200)
+#define HDMI_RPCR_write_en2(data)                                                    (0x00000200&((data)<<9))
+#define HDMI_RPCR_write_en2_src(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_RPCR_get_write_en2(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_RPCR_prp1period_shift                                                   (5)
+#define HDMI_RPCR_prp1period_mask                                                    (0x000001E0)
+#define HDMI_RPCR_prp1period(data)                                                   (0x000001E0&((data)<<5))
+#define HDMI_RPCR_prp1period_src(data)                                               ((0x000001E0&(data))>>5)
+#define HDMI_RPCR_get_prp1period(data)                                               ((0x000001E0&(data))>>5)
+#define HDMI_RPCR_write_en1_shift                                                    (4)
+#define HDMI_RPCR_write_en1_mask                                                     (0x00000010)
+#define HDMI_RPCR_write_en1(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_RPCR_write_en1_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_RPCR_get_write_en1(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_RPCR_prp0period_shift                                                   (0)
+#define HDMI_RPCR_prp0period_mask                                                    (0x0000000F)
+#define HDMI_RPCR_prp0period(data)                                                   (0x0000000F&((data)<<0))
+#define HDMI_RPCR_prp0period_src(data)                                               ((0x0000000F&(data))>>0)
+#define HDMI_RPCR_get_prp0period(data)                                               ((0x0000000F&(data))>>0)
+
+
+#define HDMI_RPEN                                                                    0x0a4
+#define HDMI_RPEN_reg_addr                                                           "0x9800D0A4"
+#define HDMI_RPEN_reg                                                                0x9800D0A4
+#define set_HDMI_RPEN_reg(data)   (*((volatile unsigned int*) HDMI_RPEN_reg)=data)
+#define get_HDMI_RPEN_reg   (*((volatile unsigned int*) HDMI_RPEN_reg))
+#define HDMI_RPEN_inst_adr                                                           "0x0029"
+#define HDMI_RPEN_inst                                                               0x0029
+#define HDMI_RPEN_enprpkt5_shift                                                     (6)
+#define HDMI_RPEN_enprpkt5_mask                                                      (0x00000040)
+#define HDMI_RPEN_enprpkt5(data)                                                     (0x00000040&((data)<<6))
+#define HDMI_RPEN_enprpkt5_src(data)                                                 ((0x00000040&(data))>>6)
+#define HDMI_RPEN_get_enprpkt5(data)                                                 ((0x00000040&(data))>>6)
+#define HDMI_RPEN_enprpkt4_shift                                                     (5)
+#define HDMI_RPEN_enprpkt4_mask                                                      (0x00000020)
+#define HDMI_RPEN_enprpkt4(data)                                                     (0x00000020&((data)<<5))
+#define HDMI_RPEN_enprpkt4_src(data)                                                 ((0x00000020&(data))>>5)
+#define HDMI_RPEN_get_enprpkt4(data)                                                 ((0x00000020&(data))>>5)
+#define HDMI_RPEN_enprpkt3_shift                                                     (4)
+#define HDMI_RPEN_enprpkt3_mask                                                      (0x00000010)
+#define HDMI_RPEN_enprpkt3(data)                                                     (0x00000010&((data)<<4))
+#define HDMI_RPEN_enprpkt3_src(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_RPEN_get_enprpkt3(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_RPEN_enprpkt2_shift                                                     (3)
+#define HDMI_RPEN_enprpkt2_mask                                                      (0x00000008)
+#define HDMI_RPEN_enprpkt2(data)                                                     (0x00000008&((data)<<3))
+#define HDMI_RPEN_enprpkt2_src(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_RPEN_get_enprpkt2(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_RPEN_enprpkt1_shift                                                     (2)
+#define HDMI_RPEN_enprpkt1_mask                                                      (0x00000004)
+#define HDMI_RPEN_enprpkt1(data)                                                     (0x00000004&((data)<<2))
+#define HDMI_RPEN_enprpkt1_src(data)                                                 ((0x00000004&(data))>>2)
+#define HDMI_RPEN_get_enprpkt1(data)                                                 ((0x00000004&(data))>>2)
+#define HDMI_RPEN_enprpkt0_shift                                                     (1)
+#define HDMI_RPEN_enprpkt0_mask                                                      (0x00000002)
+#define HDMI_RPEN_enprpkt0(data)                                                     (0x00000002&((data)<<1))
+#define HDMI_RPEN_enprpkt0_src(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_RPEN_get_enprpkt0(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_RPEN_write_data_shift                                                   (0)
+#define HDMI_RPEN_write_data_mask                                                    (0x00000001)
+#define HDMI_RPEN_write_data(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_RPEN_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_RPEN_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_RPRBDR                                                                  0x0a8
+#define HDMI_RPRBDR_reg_addr                                                         "0x9800D0A8"
+#define HDMI_RPRBDR_reg                                                              0x9800D0A8
+#define set_HDMI_RPRBDR_reg(data)   (*((volatile unsigned int*) HDMI_RPRBDR_reg)=data)
+#define get_HDMI_RPRBDR_reg   (*((volatile unsigned int*) HDMI_RPRBDR_reg))
+#define HDMI_RPRBDR_inst_adr                                                         "0x002A"
+#define HDMI_RPRBDR_inst                                                             0x002A
+#define HDMI_RPRBDR_isramrbd_shift                                                   (0)
+#define HDMI_RPRBDR_isramrbd_mask                                                    (0x0003FFFF)
+#define HDMI_RPRBDR_isramrbd(data)                                                   (0x0003FFFF&((data)<<0))
+#define HDMI_RPRBDR_isramrbd_src(data)                                               ((0x0003FFFF&(data))>>0)
+#define HDMI_RPRBDR_get_isramrbd(data)                                               ((0x0003FFFF&(data))>>0)
+
+
+#define HDMI_OPCR                                                                    0x0b0
+#define HDMI_OPCR_reg_addr                                                           "0x9800D0B0"
+#define HDMI_OPCR_reg                                                                0x9800D0B0
+#define set_HDMI_OPCR_reg(data)   (*((volatile unsigned int*) HDMI_OPCR_reg)=data)
+#define get_HDMI_OPCR_reg   (*((volatile unsigned int*) HDMI_OPCR_reg))
+#define HDMI_OPCR_inst_adr                                                           "0x002C"
+#define HDMI_OPCR_inst                                                               0x002C
+#define HDMI_OPCR_write_en4_shift                                                    (14)
+#define HDMI_OPCR_write_en4_mask                                                     (0x00004000)
+#define HDMI_OPCR_write_en4(data)                                                    (0x00004000&((data)<<14))
+#define HDMI_OPCR_write_en4_src(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_OPCR_get_write_en4(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_OPCR_enrbpktsram_shift                                                  (13)
+#define HDMI_OPCR_enrbpktsram_mask                                                   (0x00002000)
+#define HDMI_OPCR_enrbpktsram(data)                                                  (0x00002000&((data)<<13))
+#define HDMI_OPCR_enrbpktsram_src(data)                                              ((0x00002000&(data))>>13)
+#define HDMI_OPCR_get_enrbpktsram(data)                                              ((0x00002000&(data))>>13)
+#define HDMI_OPCR_write_en3_shift                                                    (12)
+#define HDMI_OPCR_write_en3_mask                                                     (0x00001000)
+#define HDMI_OPCR_write_en3(data)                                                    (0x00001000&((data)<<12))
+#define HDMI_OPCR_write_en3_src(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_OPCR_get_write_en3(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_OPCR_wrdes_shift                                                        (11)
+#define HDMI_OPCR_wrdes_mask                                                         (0x00000800)
+#define HDMI_OPCR_wrdes(data)                                                        (0x00000800&((data)<<11))
+#define HDMI_OPCR_wrdes_src(data)                                                    ((0x00000800&(data))>>11)
+#define HDMI_OPCR_get_wrdes(data)                                                    ((0x00000800&(data))>>11)
+#define HDMI_OPCR_write_en2_shift                                                    (10)
+#define HDMI_OPCR_write_en2_mask                                                     (0x00000400)
+#define HDMI_OPCR_write_en2(data)                                                    (0x00000400&((data)<<10))
+#define HDMI_OPCR_write_en2_src(data)                                                ((0x00000400&(data))>>10)
+#define HDMI_OPCR_get_write_en2(data)                                                ((0x00000400&(data))>>10)
+#define HDMI_OPCR_rprwcmd_shift                                                      (9)
+#define HDMI_OPCR_rprwcmd_mask                                                       (0x00000200)
+#define HDMI_OPCR_rprwcmd(data)                                                      (0x00000200&((data)<<9))
+#define HDMI_OPCR_rprwcmd_src(data)                                                  ((0x00000200&(data))>>9)
+#define HDMI_OPCR_get_rprwcmd(data)                                                  ((0x00000200&(data))>>9)
+#define HDMI_OPCR_write_en1_shift                                                    (8)
+#define HDMI_OPCR_write_en1_mask                                                     (0x00000100)
+#define HDMI_OPCR_write_en1(data)                                                    (0x00000100&((data)<<8))
+#define HDMI_OPCR_write_en1_src(data)                                                ((0x00000100&(data))>>8)
+#define HDMI_OPCR_get_write_en1(data)                                                ((0x00000100&(data))>>8)
+#define HDMI_OPCR_rpadd_shift                                                        (0)
+#define HDMI_OPCR_rpadd_mask                                                         (0x000000FF)
+#define HDMI_OPCR_rpadd(data)                                                        (0x000000FF&((data)<<0))
+#define HDMI_OPCR_rpadd_src(data)                                                    ((0x000000FF&(data))>>0)
+#define HDMI_OPCR_get_rpadd(data)                                                    ((0x000000FF&(data))>>0)
+
+
+#define HDMI_DIPCCR                                                                  0x0b4
+#define HDMI_DIPCCR_reg_addr                                                         "0x9800D0B4"
+#define HDMI_DIPCCR_reg                                                              0x9800D0B4
+#define set_HDMI_DIPCCR_reg(data)   (*((volatile unsigned int*) HDMI_DIPCCR_reg)=data)
+#define get_HDMI_DIPCCR_reg   (*((volatile unsigned int*) HDMI_DIPCCR_reg))
+#define HDMI_DIPCCR_inst_adr                                                         "0x002D"
+#define HDMI_DIPCCR_inst                                                             0x002D
+#define HDMI_DIPCCR_write_en2_shift                                                  (15)
+#define HDMI_DIPCCR_write_en2_mask                                                   (0x00008000)
+#define HDMI_DIPCCR_write_en2(data)                                                  (0x00008000&((data)<<15))
+#define HDMI_DIPCCR_write_en2_src(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_DIPCCR_get_write_en2(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_DIPCCR_vbidipcnt_shift                                                  (8)
+#define HDMI_DIPCCR_vbidipcnt_mask                                                   (0x00007F00)
+#define HDMI_DIPCCR_vbidipcnt(data)                                                  (0x00007F00&((data)<<8))
+#define HDMI_DIPCCR_vbidipcnt_src(data)                                              ((0x00007F00&(data))>>8)
+#define HDMI_DIPCCR_get_vbidipcnt(data)                                              ((0x00007F00&(data))>>8)
+#define HDMI_DIPCCR_write_en1_shift                                                  (7)
+#define HDMI_DIPCCR_write_en1_mask                                                   (0x00000080)
+#define HDMI_DIPCCR_write_en1(data)                                                  (0x00000080&((data)<<7))
+#define HDMI_DIPCCR_write_en1_src(data)                                              ((0x00000080&(data))>>7)
+#define HDMI_DIPCCR_get_write_en1(data)                                              ((0x00000080&(data))>>7)
+#define HDMI_DIPCCR_hbidipcnt_shift                                                  (0)
+#define HDMI_DIPCCR_hbidipcnt_mask                                                   (0x0000007F)
+#define HDMI_DIPCCR_hbidipcnt(data)                                                  (0x0000007F&((data)<<0))
+#define HDMI_DIPCCR_hbidipcnt_src(data)                                              ((0x0000007F&(data))>>0)
+#define HDMI_DIPCCR_get_hbidipcnt(data)                                              ((0x0000007F&(data))>>0)
+
+
+#define HDMI_DIPCCR_2                                                                0x2b0
+#define HDMI_DIPCCR_2_reg_addr                                                       "0x9800D2B0"
+#define HDMI_DIPCCR_2_reg                                                            0x9800D2B0
+#define set_HDMI_DIPCCR_2_reg(data)   (*((volatile unsigned int*) HDMI_DIPCCR_2_reg)=data)
+#define get_HDMI_DIPCCR_2_reg   (*((volatile unsigned int*) HDMI_DIPCCR_2_reg))
+#define HDMI_DIPCCR_2_inst_adr                                                       "0x00AC"
+#define HDMI_DIPCCR_2_inst                                                           0x00AC
+#define HDMI_DIPCCR_2_write_en2_shift                                                (16)
+#define HDMI_DIPCCR_2_write_en2_mask                                                 (0x00010000)
+#define HDMI_DIPCCR_2_write_en2(data)                                                (0x00010000&((data)<<16))
+#define HDMI_DIPCCR_2_write_en2_src(data)                                            ((0x00010000&(data))>>16)
+#define HDMI_DIPCCR_2_get_write_en2(data)                                            ((0x00010000&(data))>>16)
+#define HDMI_DIPCCR_2_FSM_mod_shift                                                  (15)
+#define HDMI_DIPCCR_2_FSM_mod_mask                                                   (0x00008000)
+#define HDMI_DIPCCR_2_FSM_mod(data)                                                  (0x00008000&((data)<<15))
+#define HDMI_DIPCCR_2_FSM_mod_src(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_DIPCCR_2_get_FSM_mod(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_DIPCCR_2_write_en1_shift                                                (14)
+#define HDMI_DIPCCR_2_write_en1_mask                                                 (0x00004000)
+#define HDMI_DIPCCR_2_write_en1(data)                                                (0x00004000&((data)<<14))
+#define HDMI_DIPCCR_2_write_en1_src(data)                                            ((0x00004000&(data))>>14)
+#define HDMI_DIPCCR_2_get_write_en1(data)                                            ((0x00004000&(data))>>14)
+#define HDMI_DIPCCR_2_hblank_pixel2tmds_shift                                        (0)
+#define HDMI_DIPCCR_2_hblank_pixel2tmds_mask                                         (0x00003FFF)
+#define HDMI_DIPCCR_2_hblank_pixel2tmds(data)                                        (0x00003FFF&((data)<<0))
+#define HDMI_DIPCCR_2_hblank_pixel2tmds_src(data)                                    ((0x00003FFF&(data))>>0)
+#define HDMI_DIPCCR_2_get_hblank_pixel2tmds(data)                                    ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_DIPCCR_3                                                                0x2b4
+#define HDMI_DIPCCR_3_reg_addr                                                       "0x9800D2B4"
+#define HDMI_DIPCCR_3_reg                                                            0x9800D2B4
+#define set_HDMI_DIPCCR_3_reg(data)   (*((volatile unsigned int*) HDMI_DIPCCR_3_reg)=data)
+#define get_HDMI_DIPCCR_3_reg   (*((volatile unsigned int*) HDMI_DIPCCR_3_reg))
+#define HDMI_DIPCCR_3_inst_adr                                                       "0x00AD"
+#define HDMI_DIPCCR_3_inst                                                           0x00AD
+#define HDMI_DIPCCR_3_write_en2_shift                                                (29)
+#define HDMI_DIPCCR_3_write_en2_mask                                                 (0x20000000)
+#define HDMI_DIPCCR_3_write_en2(data)                                                (0x20000000&((data)<<29))
+#define HDMI_DIPCCR_3_write_en2_src(data)                                            ((0x20000000&(data))>>29)
+#define HDMI_DIPCCR_3_get_write_en2(data)                                            ((0x20000000&(data))>>29)
+#define HDMI_DIPCCR_3_hblank_cnt_wait_st_shift                                       (15)
+#define HDMI_DIPCCR_3_hblank_cnt_wait_st_mask                                        (0x1FFF8000)
+#define HDMI_DIPCCR_3_hblank_cnt_wait_st(data)                                       (0x1FFF8000&((data)<<15))
+#define HDMI_DIPCCR_3_hblank_cnt_wait_st_src(data)                                   ((0x1FFF8000&(data))>>15)
+#define HDMI_DIPCCR_3_get_hblank_cnt_wait_st(data)                                   ((0x1FFF8000&(data))>>15)
+#define HDMI_DIPCCR_3_write_en1_shift                                                (14)
+#define HDMI_DIPCCR_3_write_en1_mask                                                 (0x00004000)
+#define HDMI_DIPCCR_3_write_en1(data)                                                (0x00004000&((data)<<14))
+#define HDMI_DIPCCR_3_write_en1_src(data)                                            ((0x00004000&(data))>>14)
+#define HDMI_DIPCCR_3_get_write_en1(data)                                            ((0x00004000&(data))>>14)
+#define HDMI_DIPCCR_3_hblank_cnt_island_st_shift                                     (0)
+#define HDMI_DIPCCR_3_hblank_cnt_island_st_mask                                      (0x00003FFF)
+#define HDMI_DIPCCR_3_hblank_cnt_island_st(data)                                     (0x00003FFF&((data)<<0))
+#define HDMI_DIPCCR_3_hblank_cnt_island_st_src(data)                                 ((0x00003FFF&(data))>>0)
+#define HDMI_DIPCCR_3_get_hblank_cnt_island_st(data)                                 ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_SCHCR                                                                   0x0b8
+#define HDMI_SCHCR_reg_addr                                                          "0x9800D0B8"
+#define HDMI_SCHCR_reg                                                               0x9800D0B8
+#define set_HDMI_SCHCR_reg(data)   (*((volatile unsigned int*) HDMI_SCHCR_reg)=data)
+#define get_HDMI_SCHCR_reg   (*((volatile unsigned int*) HDMI_SCHCR_reg))
+#define HDMI_SCHCR_inst_adr                                                          "0x002E"
+#define HDMI_SCHCR_inst                                                              0x002E
+#define HDMI_SCHCR_write_en12_shift                                                  (28)
+#define HDMI_SCHCR_write_en12_mask                                                   (0x10000000)
+#define HDMI_SCHCR_write_en12(data)                                                  (0x10000000&((data)<<28))
+#define HDMI_SCHCR_write_en12_src(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_SCHCR_get_write_en12(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_SCHCR_color_transform_en_shift                                          (27)
+#define HDMI_SCHCR_color_transform_en_mask                                           (0x08000000)
+#define HDMI_SCHCR_color_transform_en(data)                                          (0x08000000&((data)<<27))
+#define HDMI_SCHCR_color_transform_en_src(data)                                      ((0x08000000&(data))>>27)
+#define HDMI_SCHCR_get_color_transform_en(data)                                      ((0x08000000&(data))>>27)
+#define HDMI_SCHCR_write_en11_shift                                                  (26)
+#define HDMI_SCHCR_write_en11_mask                                                   (0x04000000)
+#define HDMI_SCHCR_write_en11(data)                                                  (0x04000000&((data)<<26))
+#define HDMI_SCHCR_write_en11_src(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_SCHCR_get_write_en11(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_SCHCR_ycbcr422_algo_shift                                               (25)
+#define HDMI_SCHCR_ycbcr422_algo_mask                                                (0x02000000)
+#define HDMI_SCHCR_ycbcr422_algo(data)                                               (0x02000000&((data)<<25))
+#define HDMI_SCHCR_ycbcr422_algo_src(data)                                           ((0x02000000&(data))>>25)
+#define HDMI_SCHCR_get_ycbcr422_algo(data)                                           ((0x02000000&(data))>>25)
+#define HDMI_SCHCR_write_en10_shift                                                  (24)
+#define HDMI_SCHCR_write_en10_mask                                                   (0x01000000)
+#define HDMI_SCHCR_write_en10(data)                                                  (0x01000000&((data)<<24))
+#define HDMI_SCHCR_write_en10_src(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_SCHCR_get_write_en10(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_SCHCR_422_pixel_repeat_shift                                            (23)
+#define HDMI_SCHCR_422_pixel_repeat_mask                                             (0x00800000)
+#define HDMI_SCHCR_422_pixel_repeat(data)                                            (0x00800000&((data)<<23))
+#define HDMI_SCHCR_422_pixel_repeat_src(data)                                        ((0x00800000&(data))>>23)
+#define HDMI_SCHCR_get_422_pixel_repeat(data)                                        ((0x00800000&(data))>>23)
+#define HDMI_SCHCR_write_en9_shift                                                   (22)
+#define HDMI_SCHCR_write_en9_mask                                                    (0x00400000)
+#define HDMI_SCHCR_write_en9(data)                                                   (0x00400000&((data)<<22))
+#define HDMI_SCHCR_write_en9_src(data)                                               ((0x00400000&(data))>>22)
+#define HDMI_SCHCR_get_write_en9(data)                                               ((0x00400000&(data))>>22)
+#define HDMI_SCHCR_vsyncpolin_shift                                                  (21)
+#define HDMI_SCHCR_vsyncpolin_mask                                                   (0x00200000)
+#define HDMI_SCHCR_vsyncpolin(data)                                                  (0x00200000&((data)<<21))
+#define HDMI_SCHCR_vsyncpolin_src(data)                                              ((0x00200000&(data))>>21)
+#define HDMI_SCHCR_get_vsyncpolin(data)                                              ((0x00200000&(data))>>21)
+#define HDMI_SCHCR_write_en8_shift                                                   (20)
+#define HDMI_SCHCR_write_en8_mask                                                    (0x00100000)
+#define HDMI_SCHCR_write_en8(data)                                                   (0x00100000&((data)<<20))
+#define HDMI_SCHCR_write_en8_src(data)                                               ((0x00100000&(data))>>20)
+#define HDMI_SCHCR_get_write_en8(data)                                               ((0x00100000&(data))>>20)
+#define HDMI_SCHCR_hsyncpolin_shift                                                  (19)
+#define HDMI_SCHCR_hsyncpolin_mask                                                   (0x00080000)
+#define HDMI_SCHCR_hsyncpolin(data)                                                  (0x00080000&((data)<<19))
+#define HDMI_SCHCR_hsyncpolin_src(data)                                              ((0x00080000&(data))>>19)
+#define HDMI_SCHCR_get_hsyncpolin(data)                                              ((0x00080000&(data))>>19)
+#define HDMI_SCHCR_write_en7_shift                                                   (18)
+#define HDMI_SCHCR_write_en7_mask                                                    (0x00040000)
+#define HDMI_SCHCR_write_en7(data)                                                   (0x00040000&((data)<<18))
+#define HDMI_SCHCR_write_en7_src(data)                                               ((0x00040000&(data))>>18)
+#define HDMI_SCHCR_get_write_en7(data)                                               ((0x00040000&(data))>>18)
+#define HDMI_SCHCR_vsyncpolinv_shift                                                 (17)
+#define HDMI_SCHCR_vsyncpolinv_mask                                                  (0x00020000)
+#define HDMI_SCHCR_vsyncpolinv(data)                                                 (0x00020000&((data)<<17))
+#define HDMI_SCHCR_vsyncpolinv_src(data)                                             ((0x00020000&(data))>>17)
+#define HDMI_SCHCR_get_vsyncpolinv(data)                                             ((0x00020000&(data))>>17)
+#define HDMI_SCHCR_write_en6_shift                                                   (16)
+#define HDMI_SCHCR_write_en6_mask                                                    (0x00010000)
+#define HDMI_SCHCR_write_en6(data)                                                   (0x00010000&((data)<<16))
+#define HDMI_SCHCR_write_en6_src(data)                                               ((0x00010000&(data))>>16)
+#define HDMI_SCHCR_get_write_en6(data)                                               ((0x00010000&(data))>>16)
+#define HDMI_SCHCR_hsyncpolinv_shift                                                 (15)
+#define HDMI_SCHCR_hsyncpolinv_mask                                                  (0x00008000)
+#define HDMI_SCHCR_hsyncpolinv(data)                                                 (0x00008000&((data)<<15))
+#define HDMI_SCHCR_hsyncpolinv_src(data)                                             ((0x00008000&(data))>>15)
+#define HDMI_SCHCR_get_hsyncpolinv(data)                                             ((0x00008000&(data))>>15)
+#define HDMI_SCHCR_write_en5_shift                                                   (14)
+#define HDMI_SCHCR_write_en5_mask                                                    (0x00004000)
+#define HDMI_SCHCR_write_en5(data)                                                   (0x00004000&((data)<<14))
+#define HDMI_SCHCR_write_en5_src(data)                                               ((0x00004000&(data))>>14)
+#define HDMI_SCHCR_get_write_en5(data)                                               ((0x00004000&(data))>>14)
+#define HDMI_SCHCR_pixelencycbcr422_shift                                            (13)
+#define HDMI_SCHCR_pixelencycbcr422_mask                                             (0x00002000)
+#define HDMI_SCHCR_pixelencycbcr422(data)                                            (0x00002000&((data)<<13))
+#define HDMI_SCHCR_pixelencycbcr422_src(data)                                        ((0x00002000&(data))>>13)
+#define HDMI_SCHCR_get_pixelencycbcr422(data)                                        ((0x00002000&(data))>>13)
+#define HDMI_SCHCR_write_en4_shift                                                   (12)
+#define HDMI_SCHCR_write_en4_mask                                                    (0x00001000)
+#define HDMI_SCHCR_write_en4(data)                                                   (0x00001000&((data)<<12))
+#define HDMI_SCHCR_write_en4_src(data)                                               ((0x00001000&(data))>>12)
+#define HDMI_SCHCR_get_write_en4(data)                                               ((0x00001000&(data))>>12)
+#define HDMI_SCHCR_hdmi_videoxs_shift                                                (7)
+#define HDMI_SCHCR_hdmi_videoxs_mask                                                 (0x00000F80)
+#define HDMI_SCHCR_hdmi_videoxs(data)                                                (0x00000F80&((data)<<7))
+#define HDMI_SCHCR_hdmi_videoxs_src(data)                                            ((0x00000F80&(data))>>7)
+#define HDMI_SCHCR_get_hdmi_videoxs(data)                                            ((0x00000F80&(data))>>7)
+#define HDMI_SCHCR_write_en3_shift                                                   (6)
+#define HDMI_SCHCR_write_en3_mask                                                    (0x00000040)
+#define HDMI_SCHCR_write_en3(data)                                                   (0x00000040&((data)<<6))
+#define HDMI_SCHCR_write_en3_src(data)                                               ((0x00000040&(data))>>6)
+#define HDMI_SCHCR_get_write_en3(data)                                               ((0x00000040&(data))>>6)
+#define HDMI_SCHCR_pixelencfmt_shift                                                 (4)
+#define HDMI_SCHCR_pixelencfmt_mask                                                  (0x00000030)
+#define HDMI_SCHCR_pixelencfmt(data)                                                 (0x00000030&((data)<<4))
+#define HDMI_SCHCR_pixelencfmt_src(data)                                             ((0x00000030&(data))>>4)
+#define HDMI_SCHCR_get_pixelencfmt(data)                                             ((0x00000030&(data))>>4)
+#define HDMI_SCHCR_write_en2_shift                                                   (3)
+#define HDMI_SCHCR_write_en2_mask                                                    (0x00000008)
+#define HDMI_SCHCR_write_en2(data)                                                   (0x00000008&((data)<<3))
+#define HDMI_SCHCR_write_en2_src(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_SCHCR_get_write_en2(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_SCHCR_pixelrepeat_shift                                                 (2)
+#define HDMI_SCHCR_pixelrepeat_mask                                                  (0x00000004)
+#define HDMI_SCHCR_pixelrepeat(data)                                                 (0x00000004&((data)<<2))
+#define HDMI_SCHCR_pixelrepeat_src(data)                                             ((0x00000004&(data))>>2)
+#define HDMI_SCHCR_get_pixelrepeat(data)                                             ((0x00000004&(data))>>2)
+#define HDMI_SCHCR_write_en1_shift                                                   (1)
+#define HDMI_SCHCR_write_en1_mask                                                    (0x00000002)
+#define HDMI_SCHCR_write_en1(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_SCHCR_write_en1_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_SCHCR_get_write_en1(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_SCHCR_hdmi_modesel_shift                                                (0)
+#define HDMI_SCHCR_hdmi_modesel_mask                                                 (0x00000001)
+#define HDMI_SCHCR_hdmi_modesel(data)                                                (0x00000001&((data)<<0))
+#define HDMI_SCHCR_hdmi_modesel_src(data)                                            ((0x00000001&(data))>>0)
+#define HDMI_SCHCR_get_hdmi_modesel(data)                                            ((0x00000001&(data))>>0)
+
+
+#define HDMI_ICR                                                                     0x0bc
+#define HDMI_ICR_reg_addr                                                            "0x9800D0BC"
+#define HDMI_ICR_reg                                                                 0x9800D0BC
+#define set_HDMI_ICR_reg(data)   (*((volatile unsigned int*) HDMI_ICR_reg)=data)
+#define get_HDMI_ICR_reg   (*((volatile unsigned int*) HDMI_ICR_reg))
+#define HDMI_ICR_inst_adr                                                            "0x002F"
+#define HDMI_ICR_inst                                                                0x002F
+#define HDMI_ICR_write_en3_shift                                                     (28)
+#define HDMI_ICR_write_en3_mask                                                      (0x10000000)
+#define HDMI_ICR_write_en3(data)                                                     (0x10000000&((data)<<28))
+#define HDMI_ICR_write_en3_src(data)                                                 ((0x10000000&(data))>>28)
+#define HDMI_ICR_get_write_en3(data)                                                 ((0x10000000&(data))>>28)
+#define HDMI_ICR_enaudio_shift                                                       (27)
+#define HDMI_ICR_enaudio_mask                                                        (0x08000000)
+#define HDMI_ICR_enaudio(data)                                                       (0x08000000&((data)<<27))
+#define HDMI_ICR_enaudio_src(data)                                                   ((0x08000000&(data))>>27)
+#define HDMI_ICR_get_enaudio(data)                                                   ((0x08000000&(data))>>27)
+#define HDMI_ICR_write_en2_shift                                                     (26)
+#define HDMI_ICR_write_en2_mask                                                      (0x04000000)
+#define HDMI_ICR_write_en2(data)                                                     (0x04000000&((data)<<26))
+#define HDMI_ICR_write_en2_src(data)                                                 ((0x04000000&(data))>>26)
+#define HDMI_ICR_get_write_en2(data)                                                 ((0x04000000&(data))>>26)
+#define HDMI_ICR_envitd_shift                                                        (25)
+#define HDMI_ICR_envitd_mask                                                         (0x02000000)
+#define HDMI_ICR_envitd(data)                                                        (0x02000000&((data)<<25))
+#define HDMI_ICR_envitd_src(data)                                                    ((0x02000000&(data))>>25)
+#define HDMI_ICR_get_envitd(data)                                                    ((0x02000000&(data))>>25)
+#define HDMI_ICR_write_en1_shift                                                     (24)
+#define HDMI_ICR_write_en1_mask                                                      (0x01000000)
+#define HDMI_ICR_write_en1(data)                                                     (0x01000000&((data)<<24))
+#define HDMI_ICR_write_en1_src(data)                                                 ((0x01000000&(data))>>24)
+#define HDMI_ICR_get_write_en1(data)                                                 ((0x01000000&(data))>>24)
+#define HDMI_ICR_vitd_shift                                                          (0)
+#define HDMI_ICR_vitd_mask                                                           (0x00FFFFFF)
+#define HDMI_ICR_vitd(data)                                                          (0x00FFFFFF&((data)<<0))
+#define HDMI_ICR_vitd_src(data)                                                      ((0x00FFFFFF&(data))>>0)
+#define HDMI_ICR_get_vitd(data)                                                      ((0x00FFFFFF&(data))>>0)
+
+
+#define HDMI_ICR1                                                                    0x150
+#define HDMI_ICR1_reg_addr                                                           "0x9800D150"
+#define HDMI_ICR1_reg                                                                0x9800D150
+#define set_HDMI_ICR1_reg(data)   (*((volatile unsigned int*) HDMI_ICR1_reg)=data)
+#define get_HDMI_ICR1_reg   (*((volatile unsigned int*) HDMI_ICR1_reg))
+#define HDMI_ICR1_inst_adr                                                           "0x0054"
+#define HDMI_ICR1_inst                                                               0x0054
+#define HDMI_ICR1_write_en1_shift                                                    (12)
+#define HDMI_ICR1_write_en1_mask                                                     (0x00001000)
+#define HDMI_ICR1_write_en1(data)                                                    (0x00001000&((data)<<12))
+#define HDMI_ICR1_write_en1_src(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_ICR1_get_write_en1(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_ICR1_vitd_shift                                                         (0)
+#define HDMI_ICR1_vitd_mask                                                          (0x00000FFF)
+#define HDMI_ICR1_vitd(data)                                                         (0x00000FFF&((data)<<0))
+#define HDMI_ICR1_vitd_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define HDMI_ICR1_get_vitd(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_CRCCR                                                                   0x0c0
+#define HDMI_CRCCR_reg_addr                                                          "0x9800D0C0"
+#define HDMI_CRCCR_reg                                                               0x9800D0C0
+#define set_HDMI_CRCCR_reg(data)   (*((volatile unsigned int*) HDMI_CRCCR_reg)=data)
+#define get_HDMI_CRCCR_reg   (*((volatile unsigned int*) HDMI_CRCCR_reg))
+#define HDMI_CRCCR_inst_adr                                                          "0x0030"
+#define HDMI_CRCCR_inst                                                              0x0030
+#define HDMI_CRCCR_write_en2_shift                                                   (4)
+#define HDMI_CRCCR_write_en2_mask                                                    (0x00000010)
+#define HDMI_CRCCR_write_en2(data)                                                   (0x00000010&((data)<<4))
+#define HDMI_CRCCR_write_en2_src(data)                                               ((0x00000010&(data))>>4)
+#define HDMI_CRCCR_get_write_en2(data)                                               ((0x00000010&(data))>>4)
+#define HDMI_CRCCR_crcmode_shift                                                     (3)
+#define HDMI_CRCCR_crcmode_mask                                                      (0x00000008)
+#define HDMI_CRCCR_crcmode(data)                                                     (0x00000008&((data)<<3))
+#define HDMI_CRCCR_crcmode_src(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_CRCCR_get_crcmode(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_CRCCR_write_en1_shift                                                   (2)
+#define HDMI_CRCCR_write_en1_mask                                                    (0x00000004)
+#define HDMI_CRCCR_write_en1(data)                                                   (0x00000004&((data)<<2))
+#define HDMI_CRCCR_write_en1_src(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_CRCCR_get_write_en1(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_CRCCR_crcchsel_shift                                                    (0)
+#define HDMI_CRCCR_crcchsel_mask                                                     (0x00000003)
+#define HDMI_CRCCR_crcchsel(data)                                                    (0x00000003&((data)<<0))
+#define HDMI_CRCCR_crcchsel_src(data)                                                ((0x00000003&(data))>>0)
+#define HDMI_CRCCR_get_crcchsel(data)                                                ((0x00000003&(data))>>0)
+
+
+#define HDMI_CRCDOR                                                                  0x0c4
+#define HDMI_CRCDOR_reg_addr                                                         "0x9800D0C4"
+#define HDMI_CRCDOR_reg                                                              0x9800D0C4
+#define set_HDMI_CRCDOR_reg(data)   (*((volatile unsigned int*) HDMI_CRCDOR_reg)=data)
+#define get_HDMI_CRCDOR_reg   (*((volatile unsigned int*) HDMI_CRCDOR_reg))
+#define HDMI_CRCDOR_inst_adr                                                         "0x0031"
+#define HDMI_CRCDOR_inst                                                             0x0031
+#define HDMI_CRCDOR_crcvalue_shift                                                   (0)
+#define HDMI_CRCDOR_crcvalue_mask                                                    (0xFFFFFFFF)
+#define HDMI_CRCDOR_crcvalue(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_CRCDOR_crcvalue_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_CRCDOR_get_crcvalue(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_KOWR                                                               0x300
+#define HDMI_HDCP_KOWR_reg_addr                                                      "0x9800D300"
+#define HDMI_HDCP_KOWR_reg                                                           0x9800D300
+#define set_HDMI_HDCP_KOWR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KOWR_reg)=data)
+#define get_HDMI_HDCP_KOWR_reg   (*((volatile unsigned int*) HDMI_HDCP_KOWR_reg))
+#define HDMI_HDCP_KOWR_inst_adr                                                      "0x00C0"
+#define HDMI_HDCP_KOWR_inst                                                          0x00C0
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin_shift                                     (0)
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin_mask                                      (0x000000FF)
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin(data)                                     (0x000000FF&((data)<<0))
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin_src(data)                                 ((0x000000FF&(data))>>0)
+#define HDMI_HDCP_KOWR_get_hdcprekeykeepoutwin(data)                                 ((0x000000FF&(data))>>0)
+
+
+#define HDMI_HDCP_KOWRSE                                                             0x304
+#define HDMI_HDCP_KOWRSE_reg_addr                                                    "0x9800D304"
+#define HDMI_HDCP_KOWRSE_reg                                                         0x9800D304
+#define set_HDMI_HDCP_KOWRSE_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KOWRSE_reg)=data)
+#define get_HDMI_HDCP_KOWRSE_reg   (*((volatile unsigned int*) HDMI_HDCP_KOWRSE_reg))
+#define HDMI_HDCP_KOWRSE_inst_adr                                                    "0x00C1"
+#define HDMI_HDCP_KOWRSE_inst                                                        0x00C1
+#define HDMI_HDCP_KOWRSE_write_en2_shift                                             (25)
+#define HDMI_HDCP_KOWRSE_write_en2_mask                                              (0x02000000)
+#define HDMI_HDCP_KOWRSE_write_en2(data)                                             (0x02000000&((data)<<25))
+#define HDMI_HDCP_KOWRSE_write_en2_src(data)                                         ((0x02000000&(data))>>25)
+#define HDMI_HDCP_KOWRSE_get_write_en2(data)                                         ((0x02000000&(data))>>25)
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend_shift                                  (13)
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend_mask                                   (0x01FFE000)
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend(data)                                  (0x01FFE000&((data)<<13))
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend_src(data)                              ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_KOWRSE_get_hdcpverkeepoutwinend(data)                              ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_KOWRSE_write_en1_shift                                             (12)
+#define HDMI_HDCP_KOWRSE_write_en1_mask                                              (0x00001000)
+#define HDMI_HDCP_KOWRSE_write_en1(data)                                             (0x00001000&((data)<<12))
+#define HDMI_HDCP_KOWRSE_write_en1_src(data)                                         ((0x00001000&(data))>>12)
+#define HDMI_HDCP_KOWRSE_get_write_en1(data)                                         ((0x00001000&(data))>>12)
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart_shift                               (0)
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart_mask                                (0x00000FFF)
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart(data)                               (0x00000FFF&((data)<<0))
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart_src(data)                           ((0x00000FFF&(data))>>0)
+#define HDMI_HDCP_KOWRSE_get_hdcpvertkeepoutwinstart(data)                           ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_HDCP_OWR                                                                0x308
+#define HDMI_HDCP_OWR_reg_addr                                                       "0x9800D308"
+#define HDMI_HDCP_OWR_reg                                                            0x9800D308
+#define set_HDMI_HDCP_OWR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_OWR_reg)=data)
+#define get_HDMI_HDCP_OWR_reg   (*((volatile unsigned int*) HDMI_HDCP_OWR_reg))
+#define HDMI_HDCP_OWR_inst_adr                                                       "0x00C2"
+#define HDMI_HDCP_OWR_inst                                                           0x00C2
+#define HDMI_HDCP_OWR_write_en2_shift                                                (25)
+#define HDMI_HDCP_OWR_write_en2_mask                                                 (0x02000000)
+#define HDMI_HDCP_OWR_write_en2(data)                                                (0x02000000&((data)<<25))
+#define HDMI_HDCP_OWR_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define HDMI_HDCP_OWR_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define HDMI_HDCP_OWR_hdcpoppwinend_shift                                            (13)
+#define HDMI_HDCP_OWR_hdcpoppwinend_mask                                             (0x01FFE000)
+#define HDMI_HDCP_OWR_hdcpoppwinend(data)                                            (0x01FFE000&((data)<<13))
+#define HDMI_HDCP_OWR_hdcpoppwinend_src(data)                                        ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_OWR_get_hdcpoppwinend(data)                                        ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_OWR_write_en1_shift                                                (12)
+#define HDMI_HDCP_OWR_write_en1_mask                                                 (0x00001000)
+#define HDMI_HDCP_OWR_write_en1(data)                                                (0x00001000&((data)<<12))
+#define HDMI_HDCP_OWR_write_en1_src(data)                                            ((0x00001000&(data))>>12)
+#define HDMI_HDCP_OWR_get_write_en1(data)                                            ((0x00001000&(data))>>12)
+#define HDMI_HDCP_OWR_hdcpoppwinstart_shift                                          (0)
+#define HDMI_HDCP_OWR_hdcpoppwinstart_mask                                           (0x00000FFF)
+#define HDMI_HDCP_OWR_hdcpoppwinstart(data)                                          (0x00000FFF&((data)<<0))
+#define HDMI_HDCP_OWR_hdcpoppwinstart_src(data)                                      ((0x00000FFF&(data))>>0)
+#define HDMI_HDCP_OWR_get_hdcpoppwinstart(data)                                      ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_HDCP_CR                                                                 0x30c
+#define HDMI_HDCP_CR_reg_addr                                                        "0x9800D30C"
+#define HDMI_HDCP_CR_reg                                                             0x9800D30C
+#define set_HDMI_HDCP_CR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_CR_reg)=data)
+#define get_HDMI_HDCP_CR_reg   (*((volatile unsigned int*) HDMI_HDCP_CR_reg))
+#define HDMI_HDCP_CR_inst_adr                                                        "0x00C3"
+#define HDMI_HDCP_CR_inst                                                            0x00C3
+#define HDMI_HDCP_CR_write_en6_shift                                                 (11)
+#define HDMI_HDCP_CR_write_en6_mask                                                  (0x00000800)
+#define HDMI_HDCP_CR_write_en6(data)                                                 (0x00000800&((data)<<11))
+#define HDMI_HDCP_CR_write_en6_src(data)                                             ((0x00000800&(data))>>11)
+#define HDMI_HDCP_CR_get_write_en6(data)                                             ((0x00000800&(data))>>11)
+#define HDMI_HDCP_CR_avmute_sel_shift                                                (10)
+#define HDMI_HDCP_CR_avmute_sel_mask                                                 (0x00000400)
+#define HDMI_HDCP_CR_avmute_sel(data)                                                (0x00000400&((data)<<10))
+#define HDMI_HDCP_CR_avmute_sel_src(data)                                            ((0x00000400&(data))>>10)
+#define HDMI_HDCP_CR_get_avmute_sel(data)                                            ((0x00000400&(data))>>10)
+#define HDMI_HDCP_CR_write_en5_shift                                                 (9)
+#define HDMI_HDCP_CR_write_en5_mask                                                  (0x00000200)
+#define HDMI_HDCP_CR_write_en5(data)                                                 (0x00000200&((data)<<9))
+#define HDMI_HDCP_CR_write_en5_src(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_HDCP_CR_get_write_en5(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_HDCP_CR_enablehdcp_shift                                                (8)
+#define HDMI_HDCP_CR_enablehdcp_mask                                                 (0x00000100)
+#define HDMI_HDCP_CR_enablehdcp(data)                                                (0x00000100&((data)<<8))
+#define HDMI_HDCP_CR_enablehdcp_src(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_HDCP_CR_get_enablehdcp(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_HDCP_CR_write_en4_shift                                                 (7)
+#define HDMI_HDCP_CR_write_en4_mask                                                  (0x00000080)
+#define HDMI_HDCP_CR_write_en4(data)                                                 (0x00000080&((data)<<7))
+#define HDMI_HDCP_CR_write_en4_src(data)                                             ((0x00000080&(data))>>7)
+#define HDMI_HDCP_CR_get_write_en4(data)                                             ((0x00000080&(data))>>7)
+#define HDMI_HDCP_CR_en1_1_feature_shift                                             (6)
+#define HDMI_HDCP_CR_en1_1_feature_mask                                              (0x00000040)
+#define HDMI_HDCP_CR_en1_1_feature(data)                                             (0x00000040&((data)<<6))
+#define HDMI_HDCP_CR_en1_1_feature_src(data)                                         ((0x00000040&(data))>>6)
+#define HDMI_HDCP_CR_get_en1_1_feature(data)                                         ((0x00000040&(data))>>6)
+#define HDMI_HDCP_CR_write_en3_shift                                                 (5)
+#define HDMI_HDCP_CR_write_en3_mask                                                  (0x00000020)
+#define HDMI_HDCP_CR_write_en3(data)                                                 (0x00000020&((data)<<5))
+#define HDMI_HDCP_CR_write_en3_src(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_HDCP_CR_get_write_en3(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_HDCP_CR_downstrisrepeater_shift                                         (4)
+#define HDMI_HDCP_CR_downstrisrepeater_mask                                          (0x00000010)
+#define HDMI_HDCP_CR_downstrisrepeater(data)                                         (0x00000010&((data)<<4))
+#define HDMI_HDCP_CR_downstrisrepeater_src(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_HDCP_CR_get_downstrisrepeater(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_HDCP_CR_write_en2_shift                                                 (3)
+#define HDMI_HDCP_CR_write_en2_mask                                                  (0x00000008)
+#define HDMI_HDCP_CR_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define HDMI_HDCP_CR_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_HDCP_CR_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_HDCP_CR_aninfluencemode_shift                                           (2)
+#define HDMI_HDCP_CR_aninfluencemode_mask                                            (0x00000004)
+#define HDMI_HDCP_CR_aninfluencemode(data)                                           (0x00000004&((data)<<2))
+#define HDMI_HDCP_CR_aninfluencemode_src(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_HDCP_CR_get_aninfluencemode(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_HDCP_CR_write_en1_shift                                                 (1)
+#define HDMI_HDCP_CR_write_en1_mask                                                  (0x00000002)
+#define HDMI_HDCP_CR_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_HDCP_CR_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_CR_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_CR_hdcp_encryptenable_shift                                        (0)
+#define HDMI_HDCP_CR_hdcp_encryptenable_mask                                         (0x00000001)
+#define HDMI_HDCP_CR_hdcp_encryptenable(data)                                        (0x00000001&((data)<<0))
+#define HDMI_HDCP_CR_hdcp_encryptenable_src(data)                                    ((0x00000001&(data))>>0)
+#define HDMI_HDCP_CR_get_hdcp_encryptenable(data)                                    ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_AUTH                                                               0x310
+#define HDMI_HDCP_AUTH_reg_addr                                                      "0x9800D310"
+#define HDMI_HDCP_AUTH_reg                                                           0x9800D310
+#define set_HDMI_HDCP_AUTH_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_AUTH_reg)=data)
+#define get_HDMI_HDCP_AUTH_reg   (*((volatile unsigned int*) HDMI_HDCP_AUTH_reg))
+#define HDMI_HDCP_AUTH_inst_adr                                                      "0x00C4"
+#define HDMI_HDCP_AUTH_inst                                                          0x00C4
+#define HDMI_HDCP_AUTH_write_en9_shift                                               (17)
+#define HDMI_HDCP_AUTH_write_en9_mask                                                (0x00020000)
+#define HDMI_HDCP_AUTH_write_en9(data)                                               (0x00020000&((data)<<17))
+#define HDMI_HDCP_AUTH_write_en9_src(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_HDCP_AUTH_get_write_en9(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_HDCP_AUTH_ddpken_shift                                                  (16)
+#define HDMI_HDCP_AUTH_ddpken_mask                                                   (0x00010000)
+#define HDMI_HDCP_AUTH_ddpken(data)                                                  (0x00010000&((data)<<16))
+#define HDMI_HDCP_AUTH_ddpken_src(data)                                              ((0x00010000&(data))>>16)
+#define HDMI_HDCP_AUTH_get_ddpken(data)                                              ((0x00010000&(data))>>16)
+#define HDMI_HDCP_AUTH_write_en8_shift                                               (15)
+#define HDMI_HDCP_AUTH_write_en8_mask                                                (0x00008000)
+#define HDMI_HDCP_AUTH_write_en8(data)                                               (0x00008000&((data)<<15))
+#define HDMI_HDCP_AUTH_write_en8_src(data)                                           ((0x00008000&(data))>>15)
+#define HDMI_HDCP_AUTH_get_write_en8(data)                                           ((0x00008000&(data))>>15)
+#define HDMI_HDCP_AUTH_resetkmacc_shift                                              (14)
+#define HDMI_HDCP_AUTH_resetkmacc_mask                                               (0x00004000)
+#define HDMI_HDCP_AUTH_resetkmacc(data)                                              (0x00004000&((data)<<14))
+#define HDMI_HDCP_AUTH_resetkmacc_src(data)                                          ((0x00004000&(data))>>14)
+#define HDMI_HDCP_AUTH_get_resetkmacc(data)                                          ((0x00004000&(data))>>14)
+#define HDMI_HDCP_AUTH_write_en7_shift                                               (13)
+#define HDMI_HDCP_AUTH_write_en7_mask                                                (0x00002000)
+#define HDMI_HDCP_AUTH_write_en7(data)                                               (0x00002000&((data)<<13))
+#define HDMI_HDCP_AUTH_write_en7_src(data)                                           ((0x00002000&(data))>>13)
+#define HDMI_HDCP_AUTH_get_write_en7(data)                                           ((0x00002000&(data))>>13)
+#define HDMI_HDCP_AUTH_update_an_shift                                               (12)
+#define HDMI_HDCP_AUTH_update_an_mask                                                (0x00001000)
+#define HDMI_HDCP_AUTH_update_an(data)                                               (0x00001000&((data)<<12))
+#define HDMI_HDCP_AUTH_update_an_src(data)                                           ((0x00001000&(data))>>12)
+#define HDMI_HDCP_AUTH_get_update_an(data)                                           ((0x00001000&(data))>>12)
+#define HDMI_HDCP_AUTH_write_en6_shift                                               (11)
+#define HDMI_HDCP_AUTH_write_en6_mask                                                (0x00000800)
+#define HDMI_HDCP_AUTH_write_en6(data)                                               (0x00000800&((data)<<11))
+#define HDMI_HDCP_AUTH_write_en6_src(data)                                           ((0x00000800&(data))>>11)
+#define HDMI_HDCP_AUTH_get_write_en6(data)                                           ((0x00000800&(data))>>11)
+#define HDMI_HDCP_AUTH_aninfreq_shift                                                (10)
+#define HDMI_HDCP_AUTH_aninfreq_mask                                                 (0x00000400)
+#define HDMI_HDCP_AUTH_aninfreq(data)                                                (0x00000400&((data)<<10))
+#define HDMI_HDCP_AUTH_aninfreq_src(data)                                            ((0x00000400&(data))>>10)
+#define HDMI_HDCP_AUTH_get_aninfreq(data)                                            ((0x00000400&(data))>>10)
+#define HDMI_HDCP_AUTH_write_en5_shift                                               (9)
+#define HDMI_HDCP_AUTH_write_en5_mask                                                (0x00000200)
+#define HDMI_HDCP_AUTH_write_en5(data)                                               (0x00000200&((data)<<9))
+#define HDMI_HDCP_AUTH_write_en5_src(data)                                           ((0x00000200&(data))>>9)
+#define HDMI_HDCP_AUTH_get_write_en5(data)                                           ((0x00000200&(data))>>9)
+#define HDMI_HDCP_AUTH_seedload_shift                                                (8)
+#define HDMI_HDCP_AUTH_seedload_mask                                                 (0x00000100)
+#define HDMI_HDCP_AUTH_seedload(data)                                                (0x00000100&((data)<<8))
+#define HDMI_HDCP_AUTH_seedload_src(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_HDCP_AUTH_get_seedload(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_HDCP_AUTH_write_en4_shift                                               (7)
+#define HDMI_HDCP_AUTH_write_en4_mask                                                (0x00000080)
+#define HDMI_HDCP_AUTH_write_en4(data)                                               (0x00000080&((data)<<7))
+#define HDMI_HDCP_AUTH_write_en4_src(data)                                           ((0x00000080&(data))>>7)
+#define HDMI_HDCP_AUTH_get_write_en4(data)                                           ((0x00000080&(data))>>7)
+#define HDMI_HDCP_AUTH_deviceauthenticated_shift                                     (6)
+#define HDMI_HDCP_AUTH_deviceauthenticated_mask                                      (0x00000040)
+#define HDMI_HDCP_AUTH_deviceauthenticated(data)                                     (0x00000040&((data)<<6))
+#define HDMI_HDCP_AUTH_deviceauthenticated_src(data)                                 ((0x00000040&(data))>>6)
+#define HDMI_HDCP_AUTH_get_deviceauthenticated(data)                                 ((0x00000040&(data))>>6)
+#define HDMI_HDCP_AUTH_write_en3_shift                                               (5)
+#define HDMI_HDCP_AUTH_write_en3_mask                                                (0x00000020)
+#define HDMI_HDCP_AUTH_write_en3(data)                                               (0x00000020&((data)<<5))
+#define HDMI_HDCP_AUTH_write_en3_src(data)                                           ((0x00000020&(data))>>5)
+#define HDMI_HDCP_AUTH_get_write_en3(data)                                           ((0x00000020&(data))>>5)
+#define HDMI_HDCP_AUTH_forcetounauthenticated_shift                                  (4)
+#define HDMI_HDCP_AUTH_forcetounauthenticated_mask                                   (0x00000010)
+#define HDMI_HDCP_AUTH_forcetounauthenticated(data)                                  (0x00000010&((data)<<4))
+#define HDMI_HDCP_AUTH_forcetounauthenticated_src(data)                              ((0x00000010&(data))>>4)
+#define HDMI_HDCP_AUTH_get_forcetounauthenticated(data)                              ((0x00000010&(data))>>4)
+#define HDMI_HDCP_AUTH_write_en2_shift                                               (3)
+#define HDMI_HDCP_AUTH_write_en2_mask                                                (0x00000008)
+#define HDMI_HDCP_AUTH_write_en2(data)                                               (0x00000008&((data)<<3))
+#define HDMI_HDCP_AUTH_write_en2_src(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_AUTH_get_write_en2(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_AUTH_authcompute_shift                                             (2)
+#define HDMI_HDCP_AUTH_authcompute_mask                                              (0x00000004)
+#define HDMI_HDCP_AUTH_authcompute(data)                                             (0x00000004&((data)<<2))
+#define HDMI_HDCP_AUTH_authcompute_src(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_HDCP_AUTH_get_authcompute(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_HDCP_AUTH_write_en1_shift                                               (1)
+#define HDMI_HDCP_AUTH_write_en1_mask                                                (0x00000002)
+#define HDMI_HDCP_AUTH_write_en1(data)                                               (0x00000002&((data)<<1))
+#define HDMI_HDCP_AUTH_write_en1_src(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_HDCP_AUTH_get_write_en1(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_HDCP_AUTH_authrequest_shift                                             (0)
+#define HDMI_HDCP_AUTH_authrequest_mask                                              (0x00000001)
+#define HDMI_HDCP_AUTH_authrequest(data)                                             (0x00000001&((data)<<0))
+#define HDMI_HDCP_AUTH_authrequest_src(data)                                         ((0x00000001&(data))>>0)
+#define HDMI_HDCP_AUTH_get_authrequest(data)                                         ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_SR                                                                 0x314
+#define HDMI_HDCP_SR_reg_addr                                                        "0x9800D314"
+#define HDMI_HDCP_SR_reg                                                             0x9800D314
+#define set_HDMI_HDCP_SR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SR_reg)=data)
+#define get_HDMI_HDCP_SR_reg   (*((volatile unsigned int*) HDMI_HDCP_SR_reg))
+#define HDMI_HDCP_SR_inst_adr                                                        "0x00C5"
+#define HDMI_HDCP_SR_inst                                                            0x00C5
+#define HDMI_HDCP_SR_hdcpcipherstate_shift                                           (24)
+#define HDMI_HDCP_SR_hdcpcipherstate_mask                                            (0xFF000000)
+#define HDMI_HDCP_SR_hdcpcipherstate(data)                                           (0xFF000000&((data)<<24))
+#define HDMI_HDCP_SR_hdcpcipherstate_src(data)                                       ((0xFF000000&(data))>>24)
+#define HDMI_HDCP_SR_get_hdcpcipherstate(data)                                       ((0xFF000000&(data))>>24)
+#define HDMI_HDCP_SR_curdpkaccdone_shift                                             (3)
+#define HDMI_HDCP_SR_curdpkaccdone_mask                                              (0x00000008)
+#define HDMI_HDCP_SR_curdpkaccdone(data)                                             (0x00000008&((data)<<3))
+#define HDMI_HDCP_SR_curdpkaccdone_src(data)                                         ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SR_get_curdpkaccdone(data)                                         ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SR_hdcp_encrypt_status_shift                                       (2)
+#define HDMI_HDCP_SR_hdcp_encrypt_status_mask                                        (0x00000004)
+#define HDMI_HDCP_SR_hdcp_encrypt_status(data)                                       (0x00000004&((data)<<2))
+#define HDMI_HDCP_SR_hdcp_encrypt_status_src(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SR_get_hdcp_encrypt_status(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SR_authenticatedok_shift                                           (1)
+#define HDMI_HDCP_SR_authenticatedok_mask                                            (0x00000002)
+#define HDMI_HDCP_SR_authenticatedok(data)                                           (0x00000002&((data)<<1))
+#define HDMI_HDCP_SR_authenticatedok_src(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SR_get_authenticatedok(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SR_anready_shift                                                   (0)
+#define HDMI_HDCP_SR_anready_mask                                                    (0x00000001)
+#define HDMI_HDCP_SR_anready(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_HDCP_SR_anready_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_HDCP_SR_get_anready(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_ANLR                                                               0x318
+#define HDMI_HDCP_ANLR_reg_addr                                                      "0x9800D318"
+#define HDMI_HDCP_ANLR_reg                                                           0x9800D318
+#define set_HDMI_HDCP_ANLR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANLR_reg)=data)
+#define get_HDMI_HDCP_ANLR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANLR_reg))
+#define HDMI_HDCP_ANLR_inst_adr                                                      "0x00C6"
+#define HDMI_HDCP_ANLR_inst                                                          0x00C6
+#define HDMI_HDCP_ANLR_anlsw_shift                                                   (0)
+#define HDMI_HDCP_ANLR_anlsw_mask                                                    (0xFFFFFFFF)
+#define HDMI_HDCP_ANLR_anlsw(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANLR_anlsw_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANLR_get_anlsw(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_ANMR                                                               0x31c
+#define HDMI_HDCP_ANMR_reg_addr                                                      "0x9800D31C"
+#define HDMI_HDCP_ANMR_reg                                                           0x9800D31C
+#define set_HDMI_HDCP_ANMR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANMR_reg)=data)
+#define get_HDMI_HDCP_ANMR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANMR_reg))
+#define HDMI_HDCP_ANMR_inst_adr                                                      "0x00C7"
+#define HDMI_HDCP_ANMR_inst                                                          0x00C7
+#define HDMI_HDCP_ANMR_anmsw_shift                                                   (0)
+#define HDMI_HDCP_ANMR_anmsw_mask                                                    (0xFFFFFFFF)
+#define HDMI_HDCP_ANMR_anmsw(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANMR_anmsw_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANMR_get_anmsw(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_ANILR                                                              0x320
+#define HDMI_HDCP_ANILR_reg_addr                                                     "0x9800D320"
+#define HDMI_HDCP_ANILR_reg                                                          0x9800D320
+#define set_HDMI_HDCP_ANILR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANILR_reg)=data)
+#define get_HDMI_HDCP_ANILR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANILR_reg))
+#define HDMI_HDCP_ANILR_inst_adr                                                     "0x00C8"
+#define HDMI_HDCP_ANILR_inst                                                         0x00C8
+#define HDMI_HDCP_ANILR_aninfluencelsw_shift                                         (0)
+#define HDMI_HDCP_ANILR_aninfluencelsw_mask                                          (0xFFFFFFFF)
+#define HDMI_HDCP_ANILR_aninfluencelsw(data)                                         (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANILR_aninfluencelsw_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANILR_get_aninfluencelsw(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_ANIMR                                                              0x324
+#define HDMI_HDCP_ANIMR_reg_addr                                                     "0x9800D324"
+#define HDMI_HDCP_ANIMR_reg                                                          0x9800D324
+#define set_HDMI_HDCP_ANIMR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANIMR_reg)=data)
+#define get_HDMI_HDCP_ANIMR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANIMR_reg))
+#define HDMI_HDCP_ANIMR_inst_adr                                                     "0x00C9"
+#define HDMI_HDCP_ANIMR_inst                                                         0x00C9
+#define HDMI_HDCP_ANIMR_aninfluencemsw_shift                                         (0)
+#define HDMI_HDCP_ANIMR_aninfluencemsw_mask                                          (0xFFFFFFFF)
+#define HDMI_HDCP_ANIMR_aninfluencemsw(data)                                         (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANIMR_aninfluencemsw_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANIMR_get_aninfluencemsw(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_DPKLR                                                              0x328
+#define HDMI_HDCP_DPKLR_reg_addr                                                     "0x9800D328"
+#define HDMI_HDCP_DPKLR_reg                                                          0x9800D328
+#define set_HDMI_HDCP_DPKLR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_DPKLR_reg)=data)
+#define get_HDMI_HDCP_DPKLR_reg   (*((volatile unsigned int*) HDMI_HDCP_DPKLR_reg))
+#define HDMI_HDCP_DPKLR_inst_adr                                                     "0x00CA"
+#define HDMI_HDCP_DPKLR_inst                                                         0x00CA
+#define HDMI_HDCP_DPKLR_ddpklsb24_shift                                              (8)
+#define HDMI_HDCP_DPKLR_ddpklsb24_mask                                               (0xFFFFFF00)
+#define HDMI_HDCP_DPKLR_ddpklsb24(data)                                              (0xFFFFFF00&((data)<<8))
+#define HDMI_HDCP_DPKLR_ddpklsb24_src(data)                                          ((0xFFFFFF00&(data))>>8)
+#define HDMI_HDCP_DPKLR_get_ddpklsb24(data)                                          ((0xFFFFFF00&(data))>>8)
+#define HDMI_HDCP_DPKLR_dpkencpnt_shift                                              (0)
+#define HDMI_HDCP_DPKLR_dpkencpnt_mask                                               (0x000000FF)
+#define HDMI_HDCP_DPKLR_dpkencpnt(data)                                              (0x000000FF&((data)<<0))
+#define HDMI_HDCP_DPKLR_dpkencpnt_src(data)                                          ((0x000000FF&(data))>>0)
+#define HDMI_HDCP_DPKLR_get_dpkencpnt(data)                                          ((0x000000FF&(data))>>0)
+
+
+#define HDMI_HDCP_DPKMR                                                              0x32c
+#define HDMI_HDCP_DPKMR_reg_addr                                                     "0x9800D32C"
+#define HDMI_HDCP_DPKMR_reg                                                          0x9800D32C
+#define set_HDMI_HDCP_DPKMR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_DPKMR_reg)=data)
+#define get_HDMI_HDCP_DPKMR_reg   (*((volatile unsigned int*) HDMI_HDCP_DPKMR_reg))
+#define HDMI_HDCP_DPKMR_inst_adr                                                     "0x00CB"
+#define HDMI_HDCP_DPKMR_inst                                                         0x00CB
+#define HDMI_HDCP_DPKMR_ddpkmsw_shift                                                (0)
+#define HDMI_HDCP_DPKMR_ddpkmsw_mask                                                 (0xFFFFFFFF)
+#define HDMI_HDCP_DPKMR_ddpkmsw(data)                                                (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_DPKMR_ddpkmsw_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_DPKMR_get_ddpkmsw(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_LIR                                                                0x330
+#define HDMI_HDCP_LIR_reg_addr                                                       "0x9800D330"
+#define HDMI_HDCP_LIR_reg                                                            0x9800D330
+#define set_HDMI_HDCP_LIR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_LIR_reg)=data)
+#define get_HDMI_HDCP_LIR_reg   (*((volatile unsigned int*) HDMI_HDCP_LIR_reg))
+#define HDMI_HDCP_LIR_inst_adr                                                       "0x00CC"
+#define HDMI_HDCP_LIR_inst                                                           0x00CC
+#define HDMI_HDCP_LIR_ri_shift                                                       (8)
+#define HDMI_HDCP_LIR_ri_mask                                                        (0x00FFFF00)
+#define HDMI_HDCP_LIR_ri(data)                                                       (0x00FFFF00&((data)<<8))
+#define HDMI_HDCP_LIR_ri_src(data)                                                   ((0x00FFFF00&(data))>>8)
+#define HDMI_HDCP_LIR_get_ri(data)                                                   ((0x00FFFF00&(data))>>8)
+#define HDMI_HDCP_LIR_pj_shift                                                       (0)
+#define HDMI_HDCP_LIR_pj_mask                                                        (0x000000FF)
+#define HDMI_HDCP_LIR_pj(data)                                                       (0x000000FF&((data)<<0))
+#define HDMI_HDCP_LIR_pj_src(data)                                                   ((0x000000FF&(data))>>0)
+#define HDMI_HDCP_LIR_get_pj(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define HDMI_HDCP_SHACR                                                              0x334
+#define HDMI_HDCP_SHACR_reg_addr                                                     "0x9800D334"
+#define HDMI_HDCP_SHACR_reg                                                          0x9800D334
+#define set_HDMI_HDCP_SHACR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SHACR_reg)=data)
+#define get_HDMI_HDCP_SHACR_reg   (*((volatile unsigned int*) HDMI_HDCP_SHACR_reg))
+#define HDMI_HDCP_SHACR_inst_adr                                                     "0x00CD"
+#define HDMI_HDCP_SHACR_inst                                                         0x00CD
+#define HDMI_HDCP_SHACR_shastart_shift                                               (3)
+#define HDMI_HDCP_SHACR_shastart_mask                                                (0x00000008)
+#define HDMI_HDCP_SHACR_shastart(data)                                               (0x00000008&((data)<<3))
+#define HDMI_HDCP_SHACR_shastart_src(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SHACR_get_shastart(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SHACR_shafirst_shift                                               (2)
+#define HDMI_HDCP_SHACR_shafirst_mask                                                (0x00000004)
+#define HDMI_HDCP_SHACR_shafirst(data)                                               (0x00000004&((data)<<2))
+#define HDMI_HDCP_SHACR_shafirst_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SHACR_get_shafirst(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SHACR_rstshaptr_shift                                              (1)
+#define HDMI_HDCP_SHACR_rstshaptr_mask                                               (0x00000002)
+#define HDMI_HDCP_SHACR_rstshaptr(data)                                              (0x00000002&((data)<<1))
+#define HDMI_HDCP_SHACR_rstshaptr_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHACR_get_rstshaptr(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHACR_write_data_shift                                             (0)
+#define HDMI_HDCP_SHACR_write_data_mask                                              (0x00000001)
+#define HDMI_HDCP_SHACR_write_data(data)                                             (0x00000001&((data)<<0))
+#define HDMI_HDCP_SHACR_write_data_src(data)                                         ((0x00000001&(data))>>0)
+#define HDMI_HDCP_SHACR_get_write_data(data)                                         ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_SHARR                                                              0x338
+#define HDMI_HDCP_SHARR_reg_addr                                                     "0x9800D338"
+#define HDMI_HDCP_SHARR_reg                                                          0x9800D338
+#define set_HDMI_HDCP_SHARR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SHARR_reg)=data)
+#define get_HDMI_HDCP_SHARR_reg   (*((volatile unsigned int*) HDMI_HDCP_SHARR_reg))
+#define HDMI_HDCP_SHARR_inst_adr                                                     "0x00CE"
+#define HDMI_HDCP_SHARR_inst                                                         0x00CE
+#define HDMI_HDCP_SHARR_vmatch_shift                                                 (1)
+#define HDMI_HDCP_SHARR_vmatch_mask                                                  (0x00000002)
+#define HDMI_HDCP_SHARR_vmatch(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_HDCP_SHARR_vmatch_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHARR_get_vmatch(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHARR_shaready_shift                                               (0)
+#define HDMI_HDCP_SHARR_shaready_mask                                                (0x00000001)
+#define HDMI_HDCP_SHARR_shaready(data)                                               (0x00000001&((data)<<0))
+#define HDMI_HDCP_SHARR_shaready_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_HDCP_SHARR_get_shaready(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_SHADR                                                              0x33c
+#define HDMI_HDCP_SHADR_reg_addr                                                     "0x9800D33C"
+#define HDMI_HDCP_SHADR_reg                                                          0x9800D33C
+#define set_HDMI_HDCP_SHADR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SHADR_reg)=data)
+#define get_HDMI_HDCP_SHADR_reg   (*((volatile unsigned int*) HDMI_HDCP_SHADR_reg))
+#define HDMI_HDCP_SHADR_inst_adr                                                     "0x00CF"
+#define HDMI_HDCP_SHADR_inst                                                         0x00CF
+#define HDMI_HDCP_SHADR_sha_data_shift                                               (0)
+#define HDMI_HDCP_SHADR_sha_data_mask                                                (0xFFFFFFFF)
+#define HDMI_HDCP_SHADR_sha_data(data)                                               (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_SHADR_sha_data_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_SHADR_get_sha_data(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_MILSW                                                              0x340
+#define HDMI_HDCP_MILSW_reg_addr                                                     "0x9800D340"
+#define HDMI_HDCP_MILSW_reg                                                          0x9800D340
+#define set_HDMI_HDCP_MILSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_MILSW_reg)=data)
+#define get_HDMI_HDCP_MILSW_reg   (*((volatile unsigned int*) HDMI_HDCP_MILSW_reg))
+#define HDMI_HDCP_MILSW_inst_adr                                                     "0x00D0"
+#define HDMI_HDCP_MILSW_inst                                                         0x00D0
+#define HDMI_HDCP_MILSW_milsw_shift                                                  (0)
+#define HDMI_HDCP_MILSW_milsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_MILSW_milsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_MILSW_milsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_MILSW_get_milsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_MIMSW                                                              0x344
+#define HDMI_HDCP_MIMSW_reg_addr                                                     "0x9800D344"
+#define HDMI_HDCP_MIMSW_reg                                                          0x9800D344
+#define set_HDMI_HDCP_MIMSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_MIMSW_reg)=data)
+#define get_HDMI_HDCP_MIMSW_reg   (*((volatile unsigned int*) HDMI_HDCP_MIMSW_reg))
+#define HDMI_HDCP_MIMSW_inst_adr                                                     "0x00D1"
+#define HDMI_HDCP_MIMSW_inst                                                         0x00D1
+#define HDMI_HDCP_MIMSW_mimsw_shift                                                  (0)
+#define HDMI_HDCP_MIMSW_mimsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_MIMSW_mimsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_MIMSW_mimsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_MIMSW_get_mimsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_KMLSW                                                              0x348
+#define HDMI_HDCP_KMLSW_reg_addr                                                     "0x9800D348"
+#define HDMI_HDCP_KMLSW_reg                                                          0x9800D348
+#define set_HDMI_HDCP_KMLSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KMLSW_reg)=data)
+#define get_HDMI_HDCP_KMLSW_reg   (*((volatile unsigned int*) HDMI_HDCP_KMLSW_reg))
+#define HDMI_HDCP_KMLSW_inst_adr                                                     "0x00D2"
+#define HDMI_HDCP_KMLSW_inst                                                         0x00D2
+#define HDMI_HDCP_KMLSW_kmlsw_shift                                                  (0)
+#define HDMI_HDCP_KMLSW_kmlsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_KMLSW_kmlsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_KMLSW_kmlsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_KMLSW_get_kmlsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_KMMSW                                                              0x34c
+#define HDMI_HDCP_KMMSW_reg_addr                                                     "0x9800D34C"
+#define HDMI_HDCP_KMMSW_reg                                                          0x9800D34C
+#define set_HDMI_HDCP_KMMSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KMMSW_reg)=data)
+#define get_HDMI_HDCP_KMMSW_reg   (*((volatile unsigned int*) HDMI_HDCP_KMMSW_reg))
+#define HDMI_HDCP_KMMSW_inst_adr                                                     "0x00D3"
+#define HDMI_HDCP_KMMSW_inst                                                         0x00D3
+#define HDMI_HDCP_KMMSW_kmmsw_shift                                                  (0)
+#define HDMI_HDCP_KMMSW_kmmsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_KMMSW_kmmsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_KMMSW_kmmsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_KMMSW_get_kmmsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_CTRL                                                           0x350
+#define HDMI_HDCP_2_2_CTRL_reg_addr                                                  "0x9800D350"
+#define HDMI_HDCP_2_2_CTRL_reg                                                       0x9800D350
+#define set_HDMI_HDCP_2_2_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_CTRL_reg)=data)
+#define get_HDMI_HDCP_2_2_CTRL_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_CTRL_reg))
+#define HDMI_HDCP_2_2_CTRL_inst_adr                                                  "0x00D4"
+#define HDMI_HDCP_2_2_CTRL_inst                                                      0x00D4
+#define HDMI_HDCP_2_2_CTRL_write_en5_shift                                           (9)
+#define HDMI_HDCP_2_2_CTRL_write_en5_mask                                            (0x00000200)
+#define HDMI_HDCP_2_2_CTRL_write_en5(data)                                           (0x00000200&((data)<<9))
+#define HDMI_HDCP_2_2_CTRL_write_en5_src(data)                                       ((0x00000200&(data))>>9)
+#define HDMI_HDCP_2_2_CTRL_get_write_en5(data)                                       ((0x00000200&(data))>>9)
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add_shift                                     (8)
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add_mask                                      (0x00000100)
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add(data)                                     (0x00000100&((data)<<8))
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add_src(data)                                 ((0x00000100&(data))>>8)
+#define HDMI_HDCP_2_2_CTRL_get_pkt_vdo_cnt_add(data)                                 ((0x00000100&(data))>>8)
+#define HDMI_HDCP_2_2_CTRL_write_en4_shift                                           (7)
+#define HDMI_HDCP_2_2_CTRL_write_en4_mask                                            (0x00000080)
+#define HDMI_HDCP_2_2_CTRL_write_en4(data)                                           (0x00000080&((data)<<7))
+#define HDMI_HDCP_2_2_CTRL_write_en4_src(data)                                       ((0x00000080&(data))>>7)
+#define HDMI_HDCP_2_2_CTRL_get_write_en4(data)                                       ((0x00000080&(data))>>7)
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en_shift                                         (6)
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en_mask                                          (0x00000040)
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en(data)                                         (0x00000040&((data)<<6))
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en_src(data)                                     ((0x00000040&(data))>>6)
+#define HDMI_HDCP_2_2_CTRL_get_hdcp_2_2_en(data)                                     ((0x00000040&(data))>>6)
+#define HDMI_HDCP_2_2_CTRL_write_en3_shift                                           (5)
+#define HDMI_HDCP_2_2_CTRL_write_en3_mask                                            (0x00000020)
+#define HDMI_HDCP_2_2_CTRL_write_en3(data)                                           (0x00000020&((data)<<5))
+#define HDMI_HDCP_2_2_CTRL_write_en3_src(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_HDCP_2_2_CTRL_get_write_en3(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en_shift                                           (4)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en_mask                                            (0x00000010)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en(data)                                           (0x00000010&((data)<<4))
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en_src(data)                                       ((0x00000010&(data))>>4)
+#define HDMI_HDCP_2_2_CTRL_get_aes_sw_en(data)                                       ((0x00000010&(data))>>4)
+#define HDMI_HDCP_2_2_CTRL_write_en2_shift                                           (3)
+#define HDMI_HDCP_2_2_CTRL_write_en2_mask                                            (0x00000008)
+#define HDMI_HDCP_2_2_CTRL_write_en2(data)                                           (0x00000008&((data)<<3))
+#define HDMI_HDCP_2_2_CTRL_write_en2_src(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_HDCP_2_2_CTRL_get_write_en2(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1_shift                                       (2)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1_mask                                        (0x00000004)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1(data)                                       (0x00000004&((data)<<2))
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1_src(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_2_2_CTRL_get_aes_sw_start1(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_2_2_CTRL_write_en1_shift                                           (1)
+#define HDMI_HDCP_2_2_CTRL_write_en1_mask                                            (0x00000002)
+#define HDMI_HDCP_2_2_CTRL_write_en1(data)                                           (0x00000002&((data)<<1))
+#define HDMI_HDCP_2_2_CTRL_write_en1_src(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_CTRL_get_write_en1(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2_shift                                       (0)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2_mask                                        (0x00000001)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2(data)                                       (0x00000001&((data)<<0))
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_HDCP_2_2_CTRL_get_aes_sw_start2(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_STATUS                                                         0x354
+#define HDMI_HDCP_2_2_STATUS_reg_addr                                                "0x9800D354"
+#define HDMI_HDCP_2_2_STATUS_reg                                                     0x9800D354
+#define set_HDMI_HDCP_2_2_STATUS_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_STATUS_reg)=data)
+#define get_HDMI_HDCP_2_2_STATUS_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_STATUS_reg))
+#define HDMI_HDCP_2_2_STATUS_inst_adr                                                "0x00D5"
+#define HDMI_HDCP_2_2_STATUS_inst                                                    0x00D5
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1_shift                                     (1)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1_mask                                      (0x00000002)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1(data)                                     (0x00000002&((data)<<1))
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1_src(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_STATUS_get_rgs_sw_done_1(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2_shift                                     (0)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2_mask                                      (0x00000001)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2(data)                                     (0x00000001&((data)<<0))
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2_src(data)                                 ((0x00000001&(data))>>0)
+#define HDMI_HDCP_2_2_STATUS_get_rgs_sw_done_2(data)                                 ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_1                                                    0x358
+#define HDMI_HDCP_2_2_SW_DATA_1_1_reg_addr                                           "0x9800D358"
+#define HDMI_HDCP_2_2_SW_DATA_1_1_reg                                                0x9800D358
+#define set_HDMI_HDCP_2_2_SW_DATA_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_1_inst_adr                                           "0x00D6"
+#define HDMI_HDCP_2_2_SW_DATA_1_1_inst                                               0x00D6
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_1_get_sw_data_1_1(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_2                                                    0x35c
+#define HDMI_HDCP_2_2_SW_DATA_1_2_reg_addr                                           "0x9800D35C"
+#define HDMI_HDCP_2_2_SW_DATA_1_2_reg                                                0x9800D35C
+#define set_HDMI_HDCP_2_2_SW_DATA_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_2_inst_adr                                           "0x00D7"
+#define HDMI_HDCP_2_2_SW_DATA_1_2_inst                                               0x00D7
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_2_get_sw_data_1_2(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_3                                                    0x360
+#define HDMI_HDCP_2_2_SW_DATA_1_3_reg_addr                                           "0x9800D360"
+#define HDMI_HDCP_2_2_SW_DATA_1_3_reg                                                0x9800D360
+#define set_HDMI_HDCP_2_2_SW_DATA_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_3_inst_adr                                           "0x00D8"
+#define HDMI_HDCP_2_2_SW_DATA_1_3_inst                                               0x00D8
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_3_get_sw_data_1_3(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_4                                                    0x364
+#define HDMI_HDCP_2_2_SW_DATA_1_4_reg_addr                                           "0x9800D364"
+#define HDMI_HDCP_2_2_SW_DATA_1_4_reg                                                0x9800D364
+#define set_HDMI_HDCP_2_2_SW_DATA_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_4_inst_adr                                           "0x00D9"
+#define HDMI_HDCP_2_2_SW_DATA_1_4_inst                                               0x00D9
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_4_get_sw_data_1_4(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_1                                                    0x368
+#define HDMI_HDCP_2_2_SW_DATA_2_1_reg_addr                                           "0x9800D368"
+#define HDMI_HDCP_2_2_SW_DATA_2_1_reg                                                0x9800D368
+#define set_HDMI_HDCP_2_2_SW_DATA_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_1_inst_adr                                           "0x00DA"
+#define HDMI_HDCP_2_2_SW_DATA_2_1_inst                                               0x00DA
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_1_get_sw_data_2_1(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_2                                                    0x36c
+#define HDMI_HDCP_2_2_SW_DATA_2_2_reg_addr                                           "0x9800D36C"
+#define HDMI_HDCP_2_2_SW_DATA_2_2_reg                                                0x9800D36C
+#define set_HDMI_HDCP_2_2_SW_DATA_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_2_inst_adr                                           "0x00DB"
+#define HDMI_HDCP_2_2_SW_DATA_2_2_inst                                               0x00DB
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_2_get_sw_data_2_2(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_3                                                    0x370
+#define HDMI_HDCP_2_2_SW_DATA_2_3_reg_addr                                           "0x9800D370"
+#define HDMI_HDCP_2_2_SW_DATA_2_3_reg                                                0x9800D370
+#define set_HDMI_HDCP_2_2_SW_DATA_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_3_inst_adr                                           "0x00DC"
+#define HDMI_HDCP_2_2_SW_DATA_2_3_inst                                               0x00DC
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_3_get_sw_data_2_3(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_4                                                    0x374
+#define HDMI_HDCP_2_2_SW_DATA_2_4_reg_addr                                           "0x9800D374"
+#define HDMI_HDCP_2_2_SW_DATA_2_4_reg                                                0x9800D374
+#define set_HDMI_HDCP_2_2_SW_DATA_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_4_inst_adr                                           "0x00DD"
+#define HDMI_HDCP_2_2_SW_DATA_2_4_inst                                               0x00DD
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_4_get_sw_data_2_4(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_1                                                     0x378
+#define HDMI_HDCP_2_2_SW_KEY_1_1_reg_addr                                            "0x9800D378"
+#define HDMI_HDCP_2_2_SW_KEY_1_1_reg                                                 0x9800D378
+#define set_HDMI_HDCP_2_2_SW_KEY_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_1_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_1_inst_adr                                            "0x00DE"
+#define HDMI_HDCP_2_2_SW_KEY_1_1_inst                                                0x00DE
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_1_get_sw_key_1_1(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_2                                                     0x37c
+#define HDMI_HDCP_2_2_SW_KEY_1_2_reg_addr                                            "0x9800D37C"
+#define HDMI_HDCP_2_2_SW_KEY_1_2_reg                                                 0x9800D37C
+#define set_HDMI_HDCP_2_2_SW_KEY_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_2_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_2_inst_adr                                            "0x00DF"
+#define HDMI_HDCP_2_2_SW_KEY_1_2_inst                                                0x00DF
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_2_get_sw_key_1_2(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_3                                                     0x380
+#define HDMI_HDCP_2_2_SW_KEY_1_3_reg_addr                                            "0x9800D380"
+#define HDMI_HDCP_2_2_SW_KEY_1_3_reg                                                 0x9800D380
+#define set_HDMI_HDCP_2_2_SW_KEY_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_3_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_3_inst_adr                                            "0x00E0"
+#define HDMI_HDCP_2_2_SW_KEY_1_3_inst                                                0x00E0
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_3_get_sw_key_1_3(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_4                                                     0x384
+#define HDMI_HDCP_2_2_SW_KEY_1_4_reg_addr                                            "0x9800D384"
+#define HDMI_HDCP_2_2_SW_KEY_1_4_reg                                                 0x9800D384
+#define set_HDMI_HDCP_2_2_SW_KEY_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_4_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_4_inst_adr                                            "0x00E1"
+#define HDMI_HDCP_2_2_SW_KEY_1_4_inst                                                0x00E1
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_4_get_sw_key_1_4(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_1                                                     0x388
+#define HDMI_HDCP_2_2_SW_KEY_2_1_reg_addr                                            "0x9800D388"
+#define HDMI_HDCP_2_2_SW_KEY_2_1_reg                                                 0x9800D388
+#define set_HDMI_HDCP_2_2_SW_KEY_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_1_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_1_inst_adr                                            "0x00E2"
+#define HDMI_HDCP_2_2_SW_KEY_2_1_inst                                                0x00E2
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_1_get_sw_key_2_1(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_2                                                     0x38c
+#define HDMI_HDCP_2_2_SW_KEY_2_2_reg_addr                                            "0x9800D38C"
+#define HDMI_HDCP_2_2_SW_KEY_2_2_reg                                                 0x9800D38C
+#define set_HDMI_HDCP_2_2_SW_KEY_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_2_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_2_inst_adr                                            "0x00E3"
+#define HDMI_HDCP_2_2_SW_KEY_2_2_inst                                                0x00E3
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_2_get_sw_key_2_2(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_3                                                     0x390
+#define HDMI_HDCP_2_2_SW_KEY_2_3_reg_addr                                            "0x9800D390"
+#define HDMI_HDCP_2_2_SW_KEY_2_3_reg                                                 0x9800D390
+#define set_HDMI_HDCP_2_2_SW_KEY_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_3_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_3_inst_adr                                            "0x00E4"
+#define HDMI_HDCP_2_2_SW_KEY_2_3_inst                                                0x00E4
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_3_get_sw_key_2_3(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_4                                                     0x394
+#define HDMI_HDCP_2_2_SW_KEY_2_4_reg_addr                                            "0x9800D394"
+#define HDMI_HDCP_2_2_SW_KEY_2_4_reg                                                 0x9800D394
+#define set_HDMI_HDCP_2_2_SW_KEY_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_4_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_4_inst_adr                                            "0x00E5"
+#define HDMI_HDCP_2_2_SW_KEY_2_4_inst                                                0x00E5
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_4_get_sw_key_2_4(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1                                                0x398
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg_addr                                       "0x9800D398"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg                                            0x9800D398
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_inst_adr                                       "0x00E6"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_inst                                           0x00E6
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_get_sw_data_xor_1_1(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2                                                0x39c
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg_addr                                       "0x9800D39C"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg                                            0x9800D39C
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_inst_adr                                       "0x00E7"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_inst                                           0x00E7
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_get_sw_data_xor_1_2(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3                                                0x3a0
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg_addr                                       "0x9800D3A0"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg                                            0x9800D3A0
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_inst_adr                                       "0x00E8"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_inst                                           0x00E8
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_get_sw_data_xor_1_3(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4                                                0x3a4
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg_addr                                       "0x9800D3A4"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg                                            0x9800D3A4
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_inst_adr                                       "0x00E9"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_inst                                           0x00E9
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_get_sw_data_xor_1_4(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1                                                0x3a8
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg_addr                                       "0x9800D3A8"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg                                            0x9800D3A8
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_inst_adr                                       "0x00EA"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_inst                                           0x00EA
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_get_sw_data_xor_2_1(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2                                                0x3ac
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg_addr                                       "0x9800D3AC"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg                                            0x9800D3AC
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_inst_adr                                       "0x00EB"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_inst                                           0x00EB
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_get_sw_data_xor_2_2(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3                                                0x3b0
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg_addr                                       "0x9800D3B0"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg                                            0x9800D3B0
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_inst_adr                                       "0x00EC"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_inst                                           0x00EC
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_get_sw_data_xor_2_3(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4                                                0x3b4
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg_addr                                       "0x9800D3B4"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg                                            0x9800D3B4
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_inst_adr                                       "0x00ED"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_inst                                           0x00ED
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_get_sw_data_xor_2_4(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1                                                0x3b8
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg_addr                                       "0x9800D3B8"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg                                            0x9800D3B8
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_inst_adr                                       "0x00EE"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_inst                                           0x00EE
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_get_data_out_1_1(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2                                                0x3bc
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg_addr                                       "0x9800D3BC"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg                                            0x9800D3BC
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_inst_adr                                       "0x00EF"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_inst                                           0x00EF
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_get_data_out_1_2(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3                                                0x3c0
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg_addr                                       "0x9800D3C0"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg                                            0x9800D3C0
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_inst_adr                                       "0x00F0"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_inst                                           0x00F0
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_get_data_out_1_3(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4                                                0x3c4
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg_addr                                       "0x9800D3C4"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg                                            0x9800D3C4
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_inst_adr                                       "0x00F1"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_inst                                           0x00F1
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_get_data_out_1_4(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1                                                0x3c8
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg_addr                                       "0x9800D3C8"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg                                            0x9800D3C8
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_inst_adr                                       "0x00F2"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_inst                                           0x00F2
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_get_data_out_2_1(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2                                                0x3cc
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg_addr                                       "0x9800D3CC"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg                                            0x9800D3CC
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_inst_adr                                       "0x00F3"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_inst                                           0x00F3
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_get_data_out_2_2(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3                                                0x3d0
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg_addr                                       "0x9800D3D0"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg                                            0x9800D3D0
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_inst_adr                                       "0x00F4"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_inst                                           0x00F4
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_get_data_out_2_3(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4                                                0x3d4
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg_addr                                       "0x9800D3D4"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg                                            0x9800D3D4
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_inst_adr                                       "0x00F5"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_inst                                           0x00F5
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_get_data_out_2_4(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_RIV_1                                                       0x3d8
+#define HDMI_HDCP_2_2_HW_RIV_1_reg_addr                                              "0x9800D3D8"
+#define HDMI_HDCP_2_2_HW_RIV_1_reg                                                   0x9800D3D8
+#define set_HDMI_HDCP_2_2_HW_RIV_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_1_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_RIV_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_1_reg))
+#define HDMI_HDCP_2_2_HW_RIV_1_inst_adr                                              "0x00F6"
+#define HDMI_HDCP_2_2_HW_RIV_1_inst                                                  0x00F6
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1_shift                                      (0)
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1_mask                                       (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1(data)                                      (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_RIV_1_get_hw_riv_1_1(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_RIV_2                                                       0x3dc
+#define HDMI_HDCP_2_2_HW_RIV_2_reg_addr                                              "0x9800D3DC"
+#define HDMI_HDCP_2_2_HW_RIV_2_reg                                                   0x9800D3DC
+#define set_HDMI_HDCP_2_2_HW_RIV_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_2_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_RIV_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_2_reg))
+#define HDMI_HDCP_2_2_HW_RIV_2_inst_adr                                              "0x00F7"
+#define HDMI_HDCP_2_2_HW_RIV_2_inst                                                  0x00F7
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2_shift                                      (0)
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2_mask                                       (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2(data)                                      (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_RIV_2_get_hw_riv_1_2(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1                                                 0x3e0
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg_addr                                        "0x9800D3E0"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg                                             0x9800D3E0
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_inst_adr                                        "0x00F8"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_inst                                            0x00F8
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1_shift                               (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1_mask                                (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1(data)                               (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1_src(data)                           ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_get_frame_num_1(data)                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2                                                 0x3e4
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg_addr                                        "0x9800D3E4"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg                                             0x9800D3E4
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_inst_adr                                        "0x00F9"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_inst                                            0x00F9
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2_shift                               (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2_mask                                (0x0000003F)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2(data)                               (0x0000003F&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2_src(data)                           ((0x0000003F&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_get_frame_num_2(data)                           ((0x0000003F&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1                                             0x3e8
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg_addr                                    "0x9800D3E8"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg                                         0x9800D3E8
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_inst_adr                                    "0x00FA"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_inst                                        0x00FA
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1_shift                       (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1_mask                        (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1(data)                       (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1_src(data)                   ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_get_frame_num_add_1(data)                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2                                             0x3ec
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg_addr                                    "0x9800D3EC"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg                                         0x9800D3EC
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_inst_adr                                    "0x00FB"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_inst                                        0x00FB
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2_shift                       (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2_mask                        (0x0000003F)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2(data)                       (0x0000003F&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2_src(data)                   ((0x0000003F&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_get_frame_num_add_2(data)                   ((0x0000003F&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_DATA_NUM                                                    0x3f0
+#define HDMI_HDCP_2_2_HW_DATA_NUM_reg_addr                                           "0x9800D3F0"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_reg                                                0x9800D3F0
+#define set_HDMI_HDCP_2_2_HW_DATA_NUM_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_DATA_NUM_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_reg))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_inst_adr                                           "0x00FC"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_inst                                               0x00FC
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num_shift                                     (0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num_mask                                      (0x03FFFFFF)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num(data)                                     (0x03FFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num_src(data)                                 ((0x03FFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_get_data_num(data)                                 ((0x03FFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD                                                0x3f4
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg_addr                                       "0x9800D3F4"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg                                            0x9800D3F4
+#define set_HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_inst_adr                                       "0x00FD"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_inst                                           0x00FD
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add_shift                             (0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add_mask                              (0x03FFFFFF)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add(data)                             (0x03FFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add_src(data)                         ((0x03FFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_get_data_num_add(data)                         ((0x03FFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FREE_RUN                                                    0x3f8
+#define HDMI_HDCP_2_2_HW_FREE_RUN_reg_addr                                           "0x9800D3F8"
+#define HDMI_HDCP_2_2_HW_FREE_RUN_reg                                                0x9800D3F8
+#define set_HDMI_HDCP_2_2_HW_FREE_RUN_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FREE_RUN_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FREE_RUN_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FREE_RUN_reg))
+#define HDMI_HDCP_2_2_HW_FREE_RUN_inst_adr                                           "0x00FE"
+#define HDMI_HDCP_2_2_HW_FREE_RUN_inst                                               0x00FE
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en2_shift                                    (28)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en2_mask                                     (0x10000000)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en2(data)                                    (0x10000000&((data)<<28))
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en2_src(data)                                ((0x10000000&(data))>>28)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_get_write_en2(data)                                ((0x10000000&(data))>>28)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_free_run_mod_en_shift                              (27)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_free_run_mod_en_mask                               (0x08000000)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_free_run_mod_en(data)                              (0x08000000&((data)<<27))
+#define HDMI_HDCP_2_2_HW_FREE_RUN_free_run_mod_en_src(data)                          ((0x08000000&(data))>>27)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_get_free_run_mod_en(data)                          ((0x08000000&(data))>>27)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en1_shift                                    (26)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en1_mask                                     (0x04000000)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en1(data)                                    (0x04000000&((data)<<26))
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en1_src(data)                                ((0x04000000&(data))>>26)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_get_write_en1(data)                                ((0x04000000&(data))>>26)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_keep_out_win_shift                                 (0)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_keep_out_win_mask                                  (0x03FFFFFF)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_keep_out_win(data)                                 (0x03FFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FREE_RUN_keep_out_win_src(data)                             ((0x03FFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_get_keep_out_win(data)                             ((0x03FFFFFF&(data))>>0)
+
+
+#define HDMI_DBG                                                                     0x140
+#define HDMI_DBG_reg_addr                                                            "0x9800D140"
+#define HDMI_DBG_reg                                                                 0x9800D140
+#define set_HDMI_DBG_reg(data)   (*((volatile unsigned int*) HDMI_DBG_reg)=data)
+#define get_HDMI_DBG_reg   (*((volatile unsigned int*) HDMI_DBG_reg))
+#define HDMI_DBG_inst_adr                                                            "0x0050"
+#define HDMI_DBG_inst                                                                0x0050
+#define HDMI_DBG_chsel0_shift                                                        (5)
+#define HDMI_DBG_chsel0_mask                                                         (0x000003E0)
+#define HDMI_DBG_chsel0(data)                                                        (0x000003E0&((data)<<5))
+#define HDMI_DBG_chsel0_src(data)                                                    ((0x000003E0&(data))>>5)
+#define HDMI_DBG_get_chsel0(data)                                                    ((0x000003E0&(data))>>5)
+#define HDMI_DBG_chsel1_shift                                                        (0)
+#define HDMI_DBG_chsel1_mask                                                         (0x0000001F)
+#define HDMI_DBG_chsel1(data)                                                        (0x0000001F&((data)<<0))
+#define HDMI_DBG_chsel1_src(data)                                                    ((0x0000001F&(data))>>0)
+#define HDMI_DBG_get_chsel1(data)                                                    ((0x0000001F&(data))>>0)
+
+
+#define HDMI_DUMMY_0                                                                 0x144
+#define HDMI_DUMMY_1                                                                 0x148
+#define HDMI_DUMMY_0_reg_addr                                                        "0x9800D144"
+#define HDMI_DUMMY_1_reg_addr                                                        "0x9800D148"
+#define HDMI_DUMMY_0_reg                                                             0x9800D144
+#define HDMI_DUMMY_1_reg                                                             0x9800D148
+#define set_HDMI_DUMMY_0_reg(data)   (*((volatile unsigned int*) HDMI_DUMMY_0_reg)=data)
+#define set_HDMI_DUMMY_1_reg(data)   (*((volatile unsigned int*) HDMI_DUMMY_1_reg)=data)
+#define get_HDMI_DUMMY_0_reg   (*((volatile unsigned int*) HDMI_DUMMY_0_reg))
+#define get_HDMI_DUMMY_1_reg   (*((volatile unsigned int*) HDMI_DUMMY_1_reg))
+#define HDMI_DUMMY_0_inst_adr                                                        "0x0051"
+#define HDMI_DUMMY_1_inst_adr                                                        "0x0052"
+#define HDMI_DUMMY_0_inst                                                            0x0051
+#define HDMI_DUMMY_1_inst                                                            0x0052
+#define HDMI_DUMMY_dummy_shift                                                       (0)
+#define HDMI_DUMMY_dummy_mask                                                        (0xFFFFFFFF)
+#define HDMI_DUMMY_dummy(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define HDMI_DUMMY_dummy_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define HDMI_DUMMY_get_dummy(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_PHY                                                                     0x14C
+#define HDMI_PHY_reg_addr                                                            "0x9800D14C"
+#define HDMI_PHY_reg                                                                 0x9800D14C
+#define set_HDMI_PHY_reg(data)   (*((volatile unsigned int*) HDMI_PHY_reg)=data)
+#define get_HDMI_PHY_reg   (*((volatile unsigned int*) HDMI_PHY_reg))
+#define HDMI_PHY_inst_adr                                                            "0x0053"
+#define HDMI_PHY_inst                                                                0x0053
+#define HDMI_PHY_test_mode_shift                                                     (1)
+#define HDMI_PHY_test_mode_mask                                                      (0x00000002)
+#define HDMI_PHY_test_mode(data)                                                     (0x00000002&((data)<<1))
+#define HDMI_PHY_test_mode_src(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_PHY_get_test_mode(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_PHY_data_realign_shift                                                  (0)
+#define HDMI_PHY_data_realign_mask                                                   (0x00000001)
+#define HDMI_PHY_data_realign(data)                                                  (0x00000001&((data)<<0))
+#define HDMI_PHY_data_realign_src(data)                                              ((0x00000001&(data))>>0)
+#define HDMI_PHY_get_data_realign(data)                                              ((0x00000001&(data))>>0)
+
+
+#define HDMI_H_PARA1                                                                 0x234
+#define HDMI_H_PARA1_reg_addr                                                        "0x9800D234"
+#define HDMI_H_PARA1_reg                                                             0x9800D234
+#define set_HDMI_H_PARA1_reg(data)   (*((volatile unsigned int*) HDMI_H_PARA1_reg)=data)
+#define get_HDMI_H_PARA1_reg   (*((volatile unsigned int*) HDMI_H_PARA1_reg))
+#define HDMI_H_PARA1_inst_adr                                                        "0x008D"
+#define HDMI_H_PARA1_inst                                                            0x008D
+#define HDMI_H_PARA1_hblank_shift                                                    (16)
+#define HDMI_H_PARA1_hblank_mask                                                     (0x3FFF0000)
+#define HDMI_H_PARA1_hblank(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_H_PARA1_hblank_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA1_get_hblank(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA1_hactive_shift                                                   (0)
+#define HDMI_H_PARA1_hactive_mask                                                    (0x00003FFF)
+#define HDMI_H_PARA1_hactive(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_H_PARA1_hactive_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_H_PARA1_get_hactive(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_H_PARA2                                                                 0x238
+#define HDMI_H_PARA2_reg_addr                                                        "0x9800D238"
+#define HDMI_H_PARA2_reg                                                             0x9800D238
+#define set_HDMI_H_PARA2_reg(data)   (*((volatile unsigned int*) HDMI_H_PARA2_reg)=data)
+#define get_HDMI_H_PARA2_reg   (*((volatile unsigned int*) HDMI_H_PARA2_reg))
+#define HDMI_H_PARA2_inst_adr                                                        "0x008E"
+#define HDMI_H_PARA2_inst                                                            0x008E
+#define HDMI_H_PARA2_hsync_shift                                                     (16)
+#define HDMI_H_PARA2_hsync_mask                                                      (0x3FFF0000)
+#define HDMI_H_PARA2_hsync(data)                                                     (0x3FFF0000&((data)<<16))
+#define HDMI_H_PARA2_hsync_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA2_get_hsync(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA2_hfront_shift                                                    (0)
+#define HDMI_H_PARA2_hfront_mask                                                     (0x00003FFF)
+#define HDMI_H_PARA2_hfront(data)                                                    (0x00003FFF&((data)<<0))
+#define HDMI_H_PARA2_hfront_src(data)                                                ((0x00003FFF&(data))>>0)
+#define HDMI_H_PARA2_get_hfront(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_H_PARA3                                                                 0x23c
+#define HDMI_H_PARA3_reg_addr                                                        "0x9800D23C"
+#define HDMI_H_PARA3_reg                                                             0x9800D23C
+#define set_HDMI_H_PARA3_reg(data)   (*((volatile unsigned int*) HDMI_H_PARA3_reg)=data)
+#define get_HDMI_H_PARA3_reg   (*((volatile unsigned int*) HDMI_H_PARA3_reg))
+#define HDMI_H_PARA3_inst_adr                                                        "0x008F"
+#define HDMI_H_PARA3_inst                                                            0x008F
+#define HDMI_H_PARA3_hback_shift                                                     (0)
+#define HDMI_H_PARA3_hback_mask                                                      (0x00003FFF)
+#define HDMI_H_PARA3_hback(data)                                                     (0x00003FFF&((data)<<0))
+#define HDMI_H_PARA3_hback_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define HDMI_H_PARA3_get_hback(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA1                                                                 0x240
+#define HDMI_V_PARA1_reg_addr                                                        "0x9800D240"
+#define HDMI_V_PARA1_reg                                                             0x9800D240
+#define set_HDMI_V_PARA1_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA1_reg)=data)
+#define get_HDMI_V_PARA1_reg   (*((volatile unsigned int*) HDMI_V_PARA1_reg))
+#define HDMI_V_PARA1_inst_adr                                                        "0x0090"
+#define HDMI_V_PARA1_inst                                                            0x0090
+#define HDMI_V_PARA1_Vact_video_shift                                                (16)
+#define HDMI_V_PARA1_Vact_video_mask                                                 (0x3FFF0000)
+#define HDMI_V_PARA1_Vact_video(data)                                                (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA1_Vact_video_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA1_get_Vact_video(data)                                            ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA1_vactive_shift                                                   (0)
+#define HDMI_V_PARA1_vactive_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA1_vactive(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA1_vactive_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA1_get_vactive(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA2                                                                 0x244
+#define HDMI_V_PARA2_reg_addr                                                        "0x9800D244"
+#define HDMI_V_PARA2_reg                                                             0x9800D244
+#define set_HDMI_V_PARA2_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA2_reg)=data)
+#define get_HDMI_V_PARA2_reg   (*((volatile unsigned int*) HDMI_V_PARA2_reg))
+#define HDMI_V_PARA2_inst_adr                                                        "0x0091"
+#define HDMI_V_PARA2_inst                                                            0x0091
+#define HDMI_V_PARA2_Vact_space1_shift                                               (16)
+#define HDMI_V_PARA2_Vact_space1_mask                                                (0x3FFF0000)
+#define HDMI_V_PARA2_Vact_space1(data)                                               (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA2_Vact_space1_src(data)                                           ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA2_get_Vact_space1(data)                                           ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA2_Vact_space_shift                                                (0)
+#define HDMI_V_PARA2_Vact_space_mask                                                 (0x00003FFF)
+#define HDMI_V_PARA2_Vact_space(data)                                                (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA2_Vact_space_src(data)                                            ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA2_get_Vact_space(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA3                                                                 0x248
+#define HDMI_V_PARA3_reg_addr                                                        "0x9800D248"
+#define HDMI_V_PARA3_reg                                                             0x9800D248
+#define set_HDMI_V_PARA3_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA3_reg)=data)
+#define get_HDMI_V_PARA3_reg   (*((volatile unsigned int*) HDMI_V_PARA3_reg))
+#define HDMI_V_PARA3_inst_adr                                                        "0x0092"
+#define HDMI_V_PARA3_inst                                                            0x0092
+#define HDMI_V_PARA3_Vblank3_shift                                                   (16)
+#define HDMI_V_PARA3_Vblank3_mask                                                    (0x3FFF0000)
+#define HDMI_V_PARA3_Vblank3(data)                                                   (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA3_Vblank3_src(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA3_get_Vblank3(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA3_Vact_space2_shift                                               (0)
+#define HDMI_V_PARA3_Vact_space2_mask                                                (0x00003FFF)
+#define HDMI_V_PARA3_Vact_space2(data)                                               (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA3_Vact_space2_src(data)                                           ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA3_get_Vact_space2(data)                                           ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA4                                                                 0x24C
+#define HDMI_V_PARA4_reg_addr                                                        "0x9800D24C"
+#define HDMI_V_PARA4_reg                                                             0x9800D24C
+#define set_HDMI_V_PARA4_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA4_reg)=data)
+#define get_HDMI_V_PARA4_reg   (*((volatile unsigned int*) HDMI_V_PARA4_reg))
+#define HDMI_V_PARA4_inst_adr                                                        "0x0093"
+#define HDMI_V_PARA4_inst                                                            0x0093
+#define HDMI_V_PARA4_vsync_shift                                                     (16)
+#define HDMI_V_PARA4_vsync_mask                                                      (0x3FFF0000)
+#define HDMI_V_PARA4_vsync(data)                                                     (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA4_vsync_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA4_get_vsync(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA4_vblank_shift                                                    (0)
+#define HDMI_V_PARA4_vblank_mask                                                     (0x00003FFF)
+#define HDMI_V_PARA4_vblank(data)                                                    (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA4_vblank_src(data)                                                ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA4_get_vblank(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA5                                                                 0x250
+#define HDMI_V_PARA5_reg_addr                                                        "0x9800D250"
+#define HDMI_V_PARA5_reg                                                             0x9800D250
+#define set_HDMI_V_PARA5_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA5_reg)=data)
+#define get_HDMI_V_PARA5_reg   (*((volatile unsigned int*) HDMI_V_PARA5_reg))
+#define HDMI_V_PARA5_inst_adr                                                        "0x0094"
+#define HDMI_V_PARA5_inst                                                            0x0094
+#define HDMI_V_PARA5_vback_shift                                                     (16)
+#define HDMI_V_PARA5_vback_mask                                                      (0x3FFF0000)
+#define HDMI_V_PARA5_vback(data)                                                     (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA5_vback_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA5_get_vback(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA5_vfront_shift                                                    (0)
+#define HDMI_V_PARA5_vfront_mask                                                     (0x00003FFF)
+#define HDMI_V_PARA5_vfront(data)                                                    (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA5_vfront_src(data)                                                ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA5_get_vfront(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA6                                                                 0x254
+#define HDMI_V_PARA6_reg_addr                                                        "0x9800D254"
+#define HDMI_V_PARA6_reg                                                             0x9800D254
+#define set_HDMI_V_PARA6_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA6_reg)=data)
+#define get_HDMI_V_PARA6_reg   (*((volatile unsigned int*) HDMI_V_PARA6_reg))
+#define HDMI_V_PARA6_inst_adr                                                        "0x0095"
+#define HDMI_V_PARA6_inst                                                            0x0095
+#define HDMI_V_PARA6_Vsync1_shift                                                    (16)
+#define HDMI_V_PARA6_Vsync1_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA6_Vsync1(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA6_Vsync1_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA6_get_Vsync1(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA6_Vblank1_shift                                                   (0)
+#define HDMI_V_PARA6_Vblank1_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA6_Vblank1(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA6_Vblank1_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA6_get_Vblank1(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA7                                                                 0x258
+#define HDMI_V_PARA7_reg_addr                                                        "0x9800D258"
+#define HDMI_V_PARA7_reg                                                             0x9800D258
+#define set_HDMI_V_PARA7_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA7_reg)=data)
+#define get_HDMI_V_PARA7_reg   (*((volatile unsigned int*) HDMI_V_PARA7_reg))
+#define HDMI_V_PARA7_inst_adr                                                        "0x0096"
+#define HDMI_V_PARA7_inst                                                            0x0096
+#define HDMI_V_PARA7_Vback1_shift                                                    (16)
+#define HDMI_V_PARA7_Vback1_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA7_Vback1(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA7_Vback1_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA7_get_Vback1(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA7_Vfront1_shift                                                   (0)
+#define HDMI_V_PARA7_Vfront1_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA7_Vfront1(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA7_Vfront1_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA7_get_Vfront1(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA8                                                                 0x25C
+#define HDMI_V_PARA8_reg_addr                                                        "0x9800D25C"
+#define HDMI_V_PARA8_reg                                                             0x9800D25C
+#define set_HDMI_V_PARA8_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA8_reg)=data)
+#define get_HDMI_V_PARA8_reg   (*((volatile unsigned int*) HDMI_V_PARA8_reg))
+#define HDMI_V_PARA8_inst_adr                                                        "0x0097"
+#define HDMI_V_PARA8_inst                                                            0x0097
+#define HDMI_V_PARA8_Vsync2_shift                                                    (16)
+#define HDMI_V_PARA8_Vsync2_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA8_Vsync2(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA8_Vsync2_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA8_get_Vsync2(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA8_Vblank2_shift                                                   (0)
+#define HDMI_V_PARA8_Vblank2_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA8_Vblank2(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA8_Vblank2_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA8_get_Vblank2(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA9                                                                 0x260
+#define HDMI_V_PARA9_reg_addr                                                        "0x9800D260"
+#define HDMI_V_PARA9_reg                                                             0x9800D260
+#define set_HDMI_V_PARA9_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA9_reg)=data)
+#define get_HDMI_V_PARA9_reg   (*((volatile unsigned int*) HDMI_V_PARA9_reg))
+#define HDMI_V_PARA9_inst_adr                                                        "0x0098"
+#define HDMI_V_PARA9_inst                                                            0x0098
+#define HDMI_V_PARA9_Vback2_shift                                                    (16)
+#define HDMI_V_PARA9_Vback2_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA9_Vback2(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA9_Vback2_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA9_get_Vback2(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA9_Vfront2_shift                                                   (0)
+#define HDMI_V_PARA9_Vfront2_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA9_Vfront2(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA9_Vfront2_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA9_get_Vfront2(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA12                                                                0x264
+#define HDMI_V_PARA12_reg_addr                                                       "0x9800D264"
+#define HDMI_V_PARA12_reg                                                            0x9800D264
+#define set_HDMI_V_PARA12_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA12_reg)=data)
+#define get_HDMI_V_PARA12_reg   (*((volatile unsigned int*) HDMI_V_PARA12_reg))
+#define HDMI_V_PARA12_inst_adr                                                       "0x0099"
+#define HDMI_V_PARA12_inst                                                           0x0099
+#define HDMI_V_PARA12_vsynci_shift                                                   (16)
+#define HDMI_V_PARA12_vsynci_mask                                                    (0x3FFF0000)
+#define HDMI_V_PARA12_vsynci(data)                                                   (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA12_vsynci_src(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA12_get_vsynci(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA12_vblanki_shift                                                  (0)
+#define HDMI_V_PARA12_vblanki_mask                                                   (0x00003FFF)
+#define HDMI_V_PARA12_vblanki(data)                                                  (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA12_vblanki_src(data)                                              ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA12_get_vblanki(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA13                                                                0x268
+#define HDMI_V_PARA13_reg_addr                                                       "0x9800D268"
+#define HDMI_V_PARA13_reg                                                            0x9800D268
+#define set_HDMI_V_PARA13_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA13_reg)=data)
+#define get_HDMI_V_PARA13_reg   (*((volatile unsigned int*) HDMI_V_PARA13_reg))
+#define HDMI_V_PARA13_inst_adr                                                       "0x009A"
+#define HDMI_V_PARA13_inst                                                           0x009A
+#define HDMI_V_PARA13_vbacki_shift                                                   (16)
+#define HDMI_V_PARA13_vbacki_mask                                                    (0x3FFF0000)
+#define HDMI_V_PARA13_vbacki(data)                                                   (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA13_vbacki_src(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA13_get_vbacki(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA13_vfronti_shift                                                  (0)
+#define HDMI_V_PARA13_vfronti_mask                                                   (0x00003FFF)
+#define HDMI_V_PARA13_vfronti(data)                                                  (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA13_vfronti_src(data)                                              ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA13_get_vfronti(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA10                                                                0x26C
+#define HDMI_V_PARA10_reg_addr                                                       "0x9800D26C"
+#define HDMI_V_PARA10_reg                                                            0x9800D26C
+#define set_HDMI_V_PARA10_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA10_reg)=data)
+#define get_HDMI_V_PARA10_reg   (*((volatile unsigned int*) HDMI_V_PARA10_reg))
+#define HDMI_V_PARA10_inst_adr                                                       "0x009B"
+#define HDMI_V_PARA10_inst                                                           0x009B
+#define HDMI_V_PARA10_G_shift                                                        (0)
+#define HDMI_V_PARA10_G_mask                                                         (0x00000FFF)
+#define HDMI_V_PARA10_G(data)                                                        (0x00000FFF&((data)<<0))
+#define HDMI_V_PARA10_G_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define HDMI_V_PARA10_get_G(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_V_PARA11                                                                0x270
+#define HDMI_V_PARA11_reg_addr                                                       "0x9800D270"
+#define HDMI_V_PARA11_reg                                                            0x9800D270
+#define set_HDMI_V_PARA11_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA11_reg)=data)
+#define get_HDMI_V_PARA11_reg   (*((volatile unsigned int*) HDMI_V_PARA11_reg))
+#define HDMI_V_PARA11_inst_adr                                                       "0x009C"
+#define HDMI_V_PARA11_inst                                                           0x009C
+#define HDMI_V_PARA11_B_shift                                                        (16)
+#define HDMI_V_PARA11_B_mask                                                         (0x0FFF0000)
+#define HDMI_V_PARA11_B(data)                                                        (0x0FFF0000&((data)<<16))
+#define HDMI_V_PARA11_B_src(data)                                                    ((0x0FFF0000&(data))>>16)
+#define HDMI_V_PARA11_get_B(data)                                                    ((0x0FFF0000&(data))>>16)
+#define HDMI_V_PARA11_R_shift                                                        (0)
+#define HDMI_V_PARA11_R_mask                                                         (0x00000FFF)
+#define HDMI_V_PARA11_R(data)                                                        (0x00000FFF&((data)<<0))
+#define HDMI_V_PARA11_R_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define HDMI_V_PARA11_get_R(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_TIMING_GEN_STATUS                                                       0x2A4
+#define HDMI_TIMING_GEN_STATUS_reg_addr                                              "0x9800D2A4"
+#define HDMI_TIMING_GEN_STATUS_reg                                                   0x9800D2A4
+#define set_HDMI_TIMING_GEN_STATUS_reg(data)   (*((volatile unsigned int*) HDMI_TIMING_GEN_STATUS_reg)=data)
+#define get_HDMI_TIMING_GEN_STATUS_reg   (*((volatile unsigned int*) HDMI_TIMING_GEN_STATUS_reg))
+#define HDMI_TIMING_GEN_STATUS_inst_adr                                              "0x00A9"
+#define HDMI_TIMING_GEN_STATUS_inst                                                  0x00A9
+#define HDMI_TIMING_GEN_STATUS_interlace_field_shift                                 (0)
+#define HDMI_TIMING_GEN_STATUS_interlace_field_mask                                  (0x00000001)
+#define HDMI_TIMING_GEN_STATUS_interlace_field(data)                                 (0x00000001&((data)<<0))
+#define HDMI_TIMING_GEN_STATUS_interlace_field_src(data)                             ((0x00000001&(data))>>0)
+#define HDMI_TIMING_GEN_STATUS_get_interlace_field(data)                             ((0x00000001&(data))>>0)
+
+
+#define HDMI_BIST1_CTRL                                                              0x280
+#define HDMI_BIST1_CTRL_reg_addr                                                     "0x9800D280"
+#define HDMI_BIST1_CTRL_reg                                                          0x9800D280
+#define set_HDMI_BIST1_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_BIST1_CTRL_reg)=data)
+#define get_HDMI_BIST1_CTRL_reg   (*((volatile unsigned int*) HDMI_BIST1_CTRL_reg))
+#define HDMI_BIST1_CTRL_inst_adr                                                     "0x00A0"
+#define HDMI_BIST1_CTRL_inst                                                         0x00A0
+#define HDMI_BIST1_CTRL_ls_shift                                                     (8)
+#define HDMI_BIST1_CTRL_ls_mask                                                      (0x00000100)
+#define HDMI_BIST1_CTRL_ls(data)                                                     (0x00000100&((data)<<8))
+#define HDMI_BIST1_CTRL_ls_src(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST1_CTRL_get_ls(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST1_CTRL_dft_test_resume_shift                                        (7)
+#define HDMI_BIST1_CTRL_dft_test_resume_mask                                         (0x00000080)
+#define HDMI_BIST1_CTRL_dft_test_resume(data)                                        (0x00000080&((data)<<7))
+#define HDMI_BIST1_CTRL_dft_test_resume_src(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST1_CTRL_get_dft_test_resume(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST1_CTRL_dft_bist_mode_shift                                          (6)
+#define HDMI_BIST1_CTRL_dft_bist_mode_mask                                           (0x00000040)
+#define HDMI_BIST1_CTRL_dft_bist_mode(data)                                          (0x00000040&((data)<<6))
+#define HDMI_BIST1_CTRL_dft_bist_mode_src(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST1_CTRL_get_dft_bist_mode(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST1_CTRL_bist_mode_shift                                              (5)
+#define HDMI_BIST1_CTRL_bist_mode_mask                                               (0x00000020)
+#define HDMI_BIST1_CTRL_bist_mode(data)                                              (0x00000020&((data)<<5))
+#define HDMI_BIST1_CTRL_bist_mode_src(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST1_CTRL_get_bist_mode(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST1_CTRL_rme_shift                                                    (4)
+#define HDMI_BIST1_CTRL_rme_mask                                                     (0x00000010)
+#define HDMI_BIST1_CTRL_rme(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_BIST1_CTRL_rme_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST1_CTRL_get_rme(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST1_CTRL_rm_shift                                                     (0)
+#define HDMI_BIST1_CTRL_rm_mask                                                      (0x0000000F)
+#define HDMI_BIST1_CTRL_rm(data)                                                     (0x0000000F&((data)<<0))
+#define HDMI_BIST1_CTRL_rm_src(data)                                                 ((0x0000000F&(data))>>0)
+#define HDMI_BIST1_CTRL_get_rm(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define HDMI_BIST2_CTRL                                                              0x29C
+#define HDMI_BIST2_CTRL_reg_addr                                                     "0x9800D29C"
+#define HDMI_BIST2_CTRL_reg                                                          0x9800D29C
+#define set_HDMI_BIST2_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_BIST2_CTRL_reg)=data)
+#define get_HDMI_BIST2_CTRL_reg   (*((volatile unsigned int*) HDMI_BIST2_CTRL_reg))
+#define HDMI_BIST2_CTRL_inst_adr                                                     "0x00A7"
+#define HDMI_BIST2_CTRL_inst                                                         0x00A7
+#define HDMI_BIST2_CTRL_ls_shift                                                     (8)
+#define HDMI_BIST2_CTRL_ls_mask                                                      (0x00000100)
+#define HDMI_BIST2_CTRL_ls(data)                                                     (0x00000100&((data)<<8))
+#define HDMI_BIST2_CTRL_ls_src(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST2_CTRL_get_ls(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST2_CTRL_dft_test_resume_shift                                        (7)
+#define HDMI_BIST2_CTRL_dft_test_resume_mask                                         (0x00000080)
+#define HDMI_BIST2_CTRL_dft_test_resume(data)                                        (0x00000080&((data)<<7))
+#define HDMI_BIST2_CTRL_dft_test_resume_src(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST2_CTRL_get_dft_test_resume(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST2_CTRL_dft_bist_mode_shift                                          (6)
+#define HDMI_BIST2_CTRL_dft_bist_mode_mask                                           (0x00000040)
+#define HDMI_BIST2_CTRL_dft_bist_mode(data)                                          (0x00000040&((data)<<6))
+#define HDMI_BIST2_CTRL_dft_bist_mode_src(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST2_CTRL_get_dft_bist_mode(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST2_CTRL_bist_mode_shift                                              (5)
+#define HDMI_BIST2_CTRL_bist_mode_mask                                               (0x00000020)
+#define HDMI_BIST2_CTRL_bist_mode(data)                                              (0x00000020&((data)<<5))
+#define HDMI_BIST2_CTRL_bist_mode_src(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST2_CTRL_get_bist_mode(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST2_CTRL_rme_shift                                                    (4)
+#define HDMI_BIST2_CTRL_rme_mask                                                     (0x00000010)
+#define HDMI_BIST2_CTRL_rme(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_BIST2_CTRL_rme_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST2_CTRL_get_rme(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST2_CTRL_rm_shift                                                     (0)
+#define HDMI_BIST2_CTRL_rm_mask                                                      (0x0000000F)
+#define HDMI_BIST2_CTRL_rm(data)                                                     (0x0000000F&((data)<<0))
+#define HDMI_BIST2_CTRL_rm_src(data)                                                 ((0x0000000F&(data))>>0)
+#define HDMI_BIST2_CTRL_get_rm(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define HDMI_BIST1_ST                                                                0x284
+#define HDMI_BIST1_ST_reg_addr                                                       "0x9800D284"
+#define HDMI_BIST1_ST_reg                                                            0x9800D284
+#define set_HDMI_BIST1_ST_reg(data)   (*((volatile unsigned int*) HDMI_BIST1_ST_reg)=data)
+#define get_HDMI_BIST1_ST_reg   (*((volatile unsigned int*) HDMI_BIST1_ST_reg))
+#define HDMI_BIST1_ST_inst_adr                                                       "0x00A1"
+#define HDMI_BIST1_ST_inst                                                           0x00A1
+#define HDMI_BIST1_ST_bist1_fail0_shift                                              (1)
+#define HDMI_BIST1_ST_bist1_fail0_mask                                               (0x00000002)
+#define HDMI_BIST1_ST_bist1_fail0(data)                                              (0x00000002&((data)<<1))
+#define HDMI_BIST1_ST_bist1_fail0_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST1_ST_get_bist1_fail0(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST1_ST_bist1_done_shift                                               (0)
+#define HDMI_BIST1_ST_bist1_done_mask                                                (0x00000001)
+#define HDMI_BIST1_ST_bist1_done(data)                                               (0x00000001&((data)<<0))
+#define HDMI_BIST1_ST_bist1_done_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_BIST1_ST_get_bist1_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_DRF_BIST1_ST                                                            0x288
+#define HDMI_DRF_BIST1_ST_reg_addr                                                   "0x9800D288"
+#define HDMI_DRF_BIST1_ST_reg                                                        0x9800D288
+#define set_HDMI_DRF_BIST1_ST_reg(data)   (*((volatile unsigned int*) HDMI_DRF_BIST1_ST_reg)=data)
+#define get_HDMI_DRF_BIST1_ST_reg   (*((volatile unsigned int*) HDMI_DRF_BIST1_ST_reg))
+#define HDMI_DRF_BIST1_ST_inst_adr                                                   "0x00A2"
+#define HDMI_DRF_BIST1_ST_inst                                                       0x00A2
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause_shift                                (16)
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause_mask                                 (0x00010000)
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause(data)                                (0x00010000&((data)<<16))
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause_src(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST1_ST_get_drf_bist1_start_pause(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0_shift                                      (1)
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0_mask                                       (0x00000002)
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0(data)                                      (0x00000002&((data)<<1))
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0_src(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST1_ST_get_drf_bist1_fail0(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST1_ST_drf_bist1_done_shift                                       (0)
+#define HDMI_DRF_BIST1_ST_drf_bist1_done_mask                                        (0x00000001)
+#define HDMI_DRF_BIST1_ST_drf_bist1_done(data)                                       (0x00000001&((data)<<0))
+#define HDMI_DRF_BIST1_ST_drf_bist1_done_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_DRF_BIST1_ST_get_drf_bist1_done(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_BIST2_ST                                                                0x28C
+#define HDMI_BIST2_ST_reg_addr                                                       "0x9800D28C"
+#define HDMI_BIST2_ST_reg                                                            0x9800D28C
+#define set_HDMI_BIST2_ST_reg(data)   (*((volatile unsigned int*) HDMI_BIST2_ST_reg)=data)
+#define get_HDMI_BIST2_ST_reg   (*((volatile unsigned int*) HDMI_BIST2_ST_reg))
+#define HDMI_BIST2_ST_inst_adr                                                       "0x00A3"
+#define HDMI_BIST2_ST_inst                                                           0x00A3
+#define HDMI_BIST2_ST_bist2_fail0_shift                                              (1)
+#define HDMI_BIST2_ST_bist2_fail0_mask                                               (0x00000002)
+#define HDMI_BIST2_ST_bist2_fail0(data)                                              (0x00000002&((data)<<1))
+#define HDMI_BIST2_ST_bist2_fail0_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST2_ST_get_bist2_fail0(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST2_ST_bist2_done_shift                                               (0)
+#define HDMI_BIST2_ST_bist2_done_mask                                                (0x00000001)
+#define HDMI_BIST2_ST_bist2_done(data)                                               (0x00000001&((data)<<0))
+#define HDMI_BIST2_ST_bist2_done_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_BIST2_ST_get_bist2_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_DRF_BIST2_ST                                                            0x290
+#define HDMI_DRF_BIST2_ST_reg_addr                                                   "0x9800D290"
+#define HDMI_DRF_BIST2_ST_reg                                                        0x9800D290
+#define set_HDMI_DRF_BIST2_ST_reg(data)   (*((volatile unsigned int*) HDMI_DRF_BIST2_ST_reg)=data)
+#define get_HDMI_DRF_BIST2_ST_reg   (*((volatile unsigned int*) HDMI_DRF_BIST2_ST_reg))
+#define HDMI_DRF_BIST2_ST_inst_adr                                                   "0x00A4"
+#define HDMI_DRF_BIST2_ST_inst                                                       0x00A4
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause_shift                                (16)
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause_mask                                 (0x00010000)
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause(data)                                (0x00010000&((data)<<16))
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause_src(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST2_ST_get_drf_bist2_start_pause(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0_shift                                      (1)
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0_mask                                       (0x00000002)
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0(data)                                      (0x00000002&((data)<<1))
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0_src(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST2_ST_get_drf_bist2_fail0(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST2_ST_drf_bist2_done_shift                                       (0)
+#define HDMI_DRF_BIST2_ST_drf_bist2_done_mask                                        (0x00000001)
+#define HDMI_DRF_BIST2_ST_drf_bist2_done(data)                                       (0x00000001&((data)<<0))
+#define HDMI_DRF_BIST2_ST_drf_bist2_done_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_DRF_BIST2_ST_get_drf_bist2_done(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_BIST3_CTRL                                                              0x0f0
+#define HDMI_BIST3_CTRL_reg_addr                                                     "0x9800D0F0"
+#define HDMI_BIST3_CTRL_reg                                                          0x9800D0F0
+#define set_HDMI_BIST3_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_BIST3_CTRL_reg)=data)
+#define get_HDMI_BIST3_CTRL_reg   (*((volatile unsigned int*) HDMI_BIST3_CTRL_reg))
+#define HDMI_BIST3_CTRL_inst_adr                                                     "0x003C"
+#define HDMI_BIST3_CTRL_inst                                                         0x003C
+#define HDMI_BIST3_CTRL_ls_shift                                                     (8)
+#define HDMI_BIST3_CTRL_ls_mask                                                      (0x00000100)
+#define HDMI_BIST3_CTRL_ls(data)                                                     (0x00000100&((data)<<8))
+#define HDMI_BIST3_CTRL_ls_src(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST3_CTRL_get_ls(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST3_CTRL_dft_test_resume_shift                                        (7)
+#define HDMI_BIST3_CTRL_dft_test_resume_mask                                         (0x00000080)
+#define HDMI_BIST3_CTRL_dft_test_resume(data)                                        (0x00000080&((data)<<7))
+#define HDMI_BIST3_CTRL_dft_test_resume_src(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST3_CTRL_get_dft_test_resume(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST3_CTRL_dft_bist_mode_shift                                          (6)
+#define HDMI_BIST3_CTRL_dft_bist_mode_mask                                           (0x00000040)
+#define HDMI_BIST3_CTRL_dft_bist_mode(data)                                          (0x00000040&((data)<<6))
+#define HDMI_BIST3_CTRL_dft_bist_mode_src(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST3_CTRL_get_dft_bist_mode(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST3_CTRL_bist_mode_shift                                              (5)
+#define HDMI_BIST3_CTRL_bist_mode_mask                                               (0x00000020)
+#define HDMI_BIST3_CTRL_bist_mode(data)                                              (0x00000020&((data)<<5))
+#define HDMI_BIST3_CTRL_bist_mode_src(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST3_CTRL_get_bist_mode(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST3_CTRL_rme_shift                                                    (4)
+#define HDMI_BIST3_CTRL_rme_mask                                                     (0x00000010)
+#define HDMI_BIST3_CTRL_rme(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_BIST3_CTRL_rme_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST3_CTRL_get_rme(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST3_CTRL_rm_shift                                                     (0)
+#define HDMI_BIST3_CTRL_rm_mask                                                      (0x0000000F)
+#define HDMI_BIST3_CTRL_rm(data)                                                     (0x0000000F&((data)<<0))
+#define HDMI_BIST3_CTRL_rm_src(data)                                                 ((0x0000000F&(data))>>0)
+#define HDMI_BIST3_CTRL_get_rm(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define HDMI_BIST3_ST                                                                0x0f4
+#define HDMI_BIST3_ST_reg_addr                                                       "0x9800D0F4"
+#define HDMI_BIST3_ST_reg                                                            0x9800D0F4
+#define set_HDMI_BIST3_ST_reg(data)   (*((volatile unsigned int*) HDMI_BIST3_ST_reg)=data)
+#define get_HDMI_BIST3_ST_reg   (*((volatile unsigned int*) HDMI_BIST3_ST_reg))
+#define HDMI_BIST3_ST_inst_adr                                                       "0x003D"
+#define HDMI_BIST3_ST_inst                                                           0x003D
+#define HDMI_BIST3_ST_bist3_fail0_shift                                              (1)
+#define HDMI_BIST3_ST_bist3_fail0_mask                                               (0x00000002)
+#define HDMI_BIST3_ST_bist3_fail0(data)                                              (0x00000002&((data)<<1))
+#define HDMI_BIST3_ST_bist3_fail0_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST3_ST_get_bist3_fail0(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST3_ST_bist3_done_shift                                               (0)
+#define HDMI_BIST3_ST_bist3_done_mask                                                (0x00000001)
+#define HDMI_BIST3_ST_bist3_done(data)                                               (0x00000001&((data)<<0))
+#define HDMI_BIST3_ST_bist3_done_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_BIST3_ST_get_bist3_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_DRF_BIST3_ST                                                            0x0f8
+#define HDMI_DRF_BIST3_ST_reg_addr                                                   "0x9800D0F8"
+#define HDMI_DRF_BIST3_ST_reg                                                        0x9800D0F8
+#define set_HDMI_DRF_BIST3_ST_reg(data)   (*((volatile unsigned int*) HDMI_DRF_BIST3_ST_reg)=data)
+#define get_HDMI_DRF_BIST3_ST_reg   (*((volatile unsigned int*) HDMI_DRF_BIST3_ST_reg))
+#define HDMI_DRF_BIST3_ST_inst_adr                                                   "0x003E"
+#define HDMI_DRF_BIST3_ST_inst                                                       0x003E
+#define HDMI_DRF_BIST3_ST_drf_bist3_start_pause_shift                                (16)
+#define HDMI_DRF_BIST3_ST_drf_bist3_start_pause_mask                                 (0x00010000)
+#define HDMI_DRF_BIST3_ST_drf_bist3_start_pause(data)                                (0x00010000&((data)<<16))
+#define HDMI_DRF_BIST3_ST_drf_bist3_start_pause_src(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST3_ST_get_drf_bist3_start_pause(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST3_ST_drf_bist3_fail0_shift                                      (1)
+#define HDMI_DRF_BIST3_ST_drf_bist3_fail0_mask                                       (0x00000002)
+#define HDMI_DRF_BIST3_ST_drf_bist3_fail0(data)                                      (0x00000002&((data)<<1))
+#define HDMI_DRF_BIST3_ST_drf_bist3_fail0_src(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST3_ST_get_drf_bist3_fail0(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST3_ST_drf_bist3_done_shift                                       (0)
+#define HDMI_DRF_BIST3_ST_drf_bist3_done_mask                                        (0x00000001)
+#define HDMI_DRF_BIST3_ST_drf_bist3_done(data)                                       (0x00000001&((data)<<0))
+#define HDMI_DRF_BIST3_ST_drf_bist3_done_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_DRF_BIST3_ST_get_drf_bist3_done(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHLCTRL                                                                 0x298
+#define HDMI_MHLCTRL_reg_addr                                                        "0x9800D298"
+#define HDMI_MHLCTRL_reg                                                             0x9800D298
+#define set_HDMI_MHLCTRL_reg(data)   (*((volatile unsigned int*) HDMI_MHLCTRL_reg)=data)
+#define get_HDMI_MHLCTRL_reg   (*((volatile unsigned int*) HDMI_MHLCTRL_reg))
+#define HDMI_MHLCTRL_inst_adr                                                        "0x00A6"
+#define HDMI_MHLCTRL_inst                                                            0x00A6
+#define HDMI_MHLCTRL_write_en7_shift                                                 (17)
+#define HDMI_MHLCTRL_write_en7_mask                                                  (0x00020000)
+#define HDMI_MHLCTRL_write_en7(data)                                                 (0x00020000&((data)<<17))
+#define HDMI_MHLCTRL_write_en7_src(data)                                             ((0x00020000&(data))>>17)
+#define HDMI_MHLCTRL_get_write_en7(data)                                             ((0x00020000&(data))>>17)
+#define HDMI_MHLCTRL_xor_pixel_sel_di_shift                                          (14)
+#define HDMI_MHLCTRL_xor_pixel_sel_di_mask                                           (0x0001C000)
+#define HDMI_MHLCTRL_xor_pixel_sel_di(data)                                          (0x0001C000&((data)<<14))
+#define HDMI_MHLCTRL_xor_pixel_sel_di_src(data)                                      ((0x0001C000&(data))>>14)
+#define HDMI_MHLCTRL_get_xor_pixel_sel_di(data)                                      ((0x0001C000&(data))>>14)
+#define HDMI_MHLCTRL_write_en6_shift                                                 (13)
+#define HDMI_MHLCTRL_write_en6_mask                                                  (0x00002000)
+#define HDMI_MHLCTRL_write_en6(data)                                                 (0x00002000&((data)<<13))
+#define HDMI_MHLCTRL_write_en6_src(data)                                             ((0x00002000&(data))>>13)
+#define HDMI_MHLCTRL_get_write_en6(data)                                             ((0x00002000&(data))>>13)
+#define HDMI_MHLCTRL_mhl_pp_ch1sel_shift                                             (12)
+#define HDMI_MHLCTRL_mhl_pp_ch1sel_mask                                              (0x00001000)
+#define HDMI_MHLCTRL_mhl_pp_ch1sel(data)                                             (0x00001000&((data)<<12))
+#define HDMI_MHLCTRL_mhl_pp_ch1sel_src(data)                                         ((0x00001000&(data))>>12)
+#define HDMI_MHLCTRL_get_mhl_pp_ch1sel(data)                                         ((0x00001000&(data))>>12)
+#define HDMI_MHLCTRL_write_en5_shift                                                 (11)
+#define HDMI_MHLCTRL_write_en5_mask                                                  (0x00000800)
+#define HDMI_MHLCTRL_write_en5(data)                                                 (0x00000800&((data)<<11))
+#define HDMI_MHLCTRL_write_en5_src(data)                                             ((0x00000800&(data))>>11)
+#define HDMI_MHLCTRL_get_write_en5(data)                                             ((0x00000800&(data))>>11)
+#define HDMI_MHLCTRL_mhl_phy_test_mode_shift                                         (10)
+#define HDMI_MHLCTRL_mhl_phy_test_mode_mask                                          (0x00000400)
+#define HDMI_MHLCTRL_mhl_phy_test_mode(data)                                         (0x00000400&((data)<<10))
+#define HDMI_MHLCTRL_mhl_phy_test_mode_src(data)                                     ((0x00000400&(data))>>10)
+#define HDMI_MHLCTRL_get_mhl_phy_test_mode(data)                                     ((0x00000400&(data))>>10)
+#define HDMI_MHLCTRL_write_en4_shift                                                 (9)
+#define HDMI_MHLCTRL_write_en4_mask                                                  (0x00000200)
+#define HDMI_MHLCTRL_write_en4(data)                                                 (0x00000200&((data)<<9))
+#define HDMI_MHLCTRL_write_en4_src(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_MHLCTRL_get_write_en4(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_MHLCTRL_xor_pixel_sel_shift                                             (6)
+#define HDMI_MHLCTRL_xor_pixel_sel_mask                                              (0x000001C0)
+#define HDMI_MHLCTRL_xor_pixel_sel(data)                                             (0x000001C0&((data)<<6))
+#define HDMI_MHLCTRL_xor_pixel_sel_src(data)                                         ((0x000001C0&(data))>>6)
+#define HDMI_MHLCTRL_get_xor_pixel_sel(data)                                         ((0x000001C0&(data))>>6)
+#define HDMI_MHLCTRL_write_en3_shift                                                 (5)
+#define HDMI_MHLCTRL_write_en3_mask                                                  (0x00000020)
+#define HDMI_MHLCTRL_write_en3(data)                                                 (0x00000020&((data)<<5))
+#define HDMI_MHLCTRL_write_en3_src(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_MHLCTRL_get_write_en3(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_MHLCTRL_mhl_enc_sel_shift                                               (4)
+#define HDMI_MHLCTRL_mhl_enc_sel_mask                                                (0x00000010)
+#define HDMI_MHLCTRL_mhl_enc_sel(data)                                               (0x00000010&((data)<<4))
+#define HDMI_MHLCTRL_mhl_enc_sel_src(data)                                           ((0x00000010&(data))>>4)
+#define HDMI_MHLCTRL_get_mhl_enc_sel(data)                                           ((0x00000010&(data))>>4)
+#define HDMI_MHLCTRL_write_en2_shift                                                 (3)
+#define HDMI_MHLCTRL_write_en2_mask                                                  (0x00000008)
+#define HDMI_MHLCTRL_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define HDMI_MHLCTRL_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_MHLCTRL_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_MHLCTRL_mhl_pp_mode_shift                                               (2)
+#define HDMI_MHLCTRL_mhl_pp_mode_mask                                                (0x00000004)
+#define HDMI_MHLCTRL_mhl_pp_mode(data)                                               (0x00000004&((data)<<2))
+#define HDMI_MHLCTRL_mhl_pp_mode_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_MHLCTRL_get_mhl_pp_mode(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_MHLCTRL_write_en1_shift                                                 (1)
+#define HDMI_MHLCTRL_write_en1_mask                                                  (0x00000002)
+#define HDMI_MHLCTRL_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_MHLCTRL_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_MHLCTRL_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_MHLCTRL_mhl_enable_shift                                                (0)
+#define HDMI_MHLCTRL_mhl_enable_mask                                                 (0x00000001)
+#define HDMI_MHLCTRL_mhl_enable(data)                                                (0x00000001&((data)<<0))
+#define HDMI_MHLCTRL_mhl_enable_src(data)                                            ((0x00000001&(data))>>0)
+#define HDMI_MHLCTRL_get_mhl_enable(data)                                            ((0x00000001&(data))>>0)
+
+
+#define HDMI_CHSWAP                                                                  0x2A0
+#define HDMI_CHSWAP_reg_addr                                                         "0x9800D2A0"
+#define HDMI_CHSWAP_reg                                                              0x9800D2A0
+#define set_HDMI_CHSWAP_reg(data)   (*((volatile unsigned int*) HDMI_CHSWAP_reg)=data)
+#define get_HDMI_CHSWAP_reg   (*((volatile unsigned int*) HDMI_CHSWAP_reg))
+#define HDMI_CHSWAP_inst_adr                                                         "0x00A8"
+#define HDMI_CHSWAP_inst                                                             0x00A8
+#define HDMI_CHSWAP_write_en3_shift                                                  (5)
+#define HDMI_CHSWAP_write_en3_mask                                                   (0x00000020)
+#define HDMI_CHSWAP_write_en3(data)                                                  (0x00000020&((data)<<5))
+#define HDMI_CHSWAP_write_en3_src(data)                                              ((0x00000020&(data))>>5)
+#define HDMI_CHSWAP_get_write_en3(data)                                              ((0x00000020&(data))>>5)
+#define HDMI_CHSWAP_mhl_ch_sel_shift                                                 (4)
+#define HDMI_CHSWAP_mhl_ch_sel_mask                                                  (0x00000010)
+#define HDMI_CHSWAP_mhl_ch_sel(data)                                                 (0x00000010&((data)<<4))
+#define HDMI_CHSWAP_mhl_ch_sel_src(data)                                             ((0x00000010&(data))>>4)
+#define HDMI_CHSWAP_get_mhl_ch_sel(data)                                             ((0x00000010&(data))>>4)
+#define HDMI_CHSWAP_write_en2_shift                                                  (3)
+#define HDMI_CHSWAP_write_en2_mask                                                   (0x00000008)
+#define HDMI_CHSWAP_write_en2(data)                                                  (0x00000008&((data)<<3))
+#define HDMI_CHSWAP_write_en2_src(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_CHSWAP_get_write_en2(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_CHSWAP_hdmi_chcclk_swap_shift                                           (2)
+#define HDMI_CHSWAP_hdmi_chcclk_swap_mask                                            (0x00000004)
+#define HDMI_CHSWAP_hdmi_chcclk_swap(data)                                           (0x00000004&((data)<<2))
+#define HDMI_CHSWAP_hdmi_chcclk_swap_src(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_CHSWAP_get_hdmi_chcclk_swap(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_CHSWAP_write_en1_shift                                                  (1)
+#define HDMI_CHSWAP_write_en1_mask                                                   (0x00000002)
+#define HDMI_CHSWAP_write_en1(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_CHSWAP_write_en1_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_CHSWAP_get_write_en1(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_CHSWAP_hdmi_chab_swap_shift                                             (0)
+#define HDMI_CHSWAP_hdmi_chab_swap_mask                                              (0x00000001)
+#define HDMI_CHSWAP_hdmi_chab_swap(data)                                             (0x00000001&((data)<<0))
+#define HDMI_CHSWAP_hdmi_chab_swap_src(data)                                         ((0x00000001&(data))>>0)
+#define HDMI_CHSWAP_get_hdmi_chab_swap(data)                                         ((0x00000001&(data))>>0)
+
+
+#define HDMI_PREFIFO_CTRL                                                            0x294
+#define HDMI_PREFIFO_CTRL_reg_addr                                                   "0x9800D294"
+#define HDMI_PREFIFO_CTRL_reg                                                        0x9800D294
+#define set_HDMI_PREFIFO_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_PREFIFO_CTRL_reg)=data)
+#define get_HDMI_PREFIFO_CTRL_reg   (*((volatile unsigned int*) HDMI_PREFIFO_CTRL_reg))
+#define HDMI_PREFIFO_CTRL_inst_adr                                                   "0x00A5"
+#define HDMI_PREFIFO_CTRL_inst                                                       0x00A5
+#define HDMI_PREFIFO_CTRL_write_en2_shift                                            (3)
+#define HDMI_PREFIFO_CTRL_write_en2_mask                                             (0x00000008)
+#define HDMI_PREFIFO_CTRL_write_en2(data)                                            (0x00000008&((data)<<3))
+#define HDMI_PREFIFO_CTRL_write_en2_src(data)                                        ((0x00000008&(data))>>3)
+#define HDMI_PREFIFO_CTRL_get_write_en2(data)                                        ((0x00000008&(data))>>3)
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv_shift                                     (2)
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv_mask                                      (0x00000004)
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv(data)                                     (0x00000004&((data)<<2))
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv_src(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_PREFIFO_CTRL_get_hdmi_prefifo_inv(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_PREFIFO_CTRL_write_en1_shift                                            (1)
+#define HDMI_PREFIFO_CTRL_write_en1_mask                                             (0x00000002)
+#define HDMI_PREFIFO_CTRL_write_en1(data)                                            (0x00000002&((data)<<1))
+#define HDMI_PREFIFO_CTRL_write_en1_src(data)                                        ((0x00000002&(data))>>1)
+#define HDMI_PREFIFO_CTRL_get_write_en1(data)                                        ((0x00000002&(data))>>1)
+#define HDMI_PREFIFO_CTRL_async_update_shift                                         (0)
+#define HDMI_PREFIFO_CTRL_async_update_mask                                          (0x00000001)
+#define HDMI_PREFIFO_CTRL_async_update(data)                                         (0x00000001&((data)<<0))
+#define HDMI_PREFIFO_CTRL_async_update_src(data)                                     ((0x00000001&(data))>>0)
+#define HDMI_PREFIFO_CTRL_get_async_update(data)                                     ((0x00000001&(data))>>0)
+
+
+#define HDMI_PHYCHCRTL                                                               0x2AC
+#define HDMI_PHYCHCRTL_reg_addr                                                      "0x9800D2AC"
+#define HDMI_PHYCHCRTL_reg                                                           0x9800D2AC
+#define set_HDMI_PHYCHCRTL_reg(data)   (*((volatile unsigned int*) HDMI_PHYCHCRTL_reg)=data)
+#define get_HDMI_PHYCHCRTL_reg   (*((volatile unsigned int*) HDMI_PHYCHCRTL_reg))
+#define HDMI_PHYCHCRTL_inst_adr                                                      "0x00AB"
+#define HDMI_PHYCHCRTL_inst                                                          0x00AB
+#define HDMI_PHYCHCRTL_write_en5_shift                                               (13)
+#define HDMI_PHYCHCRTL_write_en5_mask                                                (0x00002000)
+#define HDMI_PHYCHCRTL_write_en5(data)                                               (0x00002000&((data)<<13))
+#define HDMI_PHYCHCRTL_write_en5_src(data)                                           ((0x00002000&(data))>>13)
+#define HDMI_PHYCHCRTL_get_write_en5(data)                                           ((0x00002000&(data))>>13)
+#define HDMI_PHYCHCRTL_data_pola_inv_shift                                           (12)
+#define HDMI_PHYCHCRTL_data_pola_inv_mask                                            (0x00001000)
+#define HDMI_PHYCHCRTL_data_pola_inv(data)                                           (0x00001000&((data)<<12))
+#define HDMI_PHYCHCRTL_data_pola_inv_src(data)                                       ((0x00001000&(data))>>12)
+#define HDMI_PHYCHCRTL_get_data_pola_inv(data)                                       ((0x00001000&(data))>>12)
+#define HDMI_PHYCHCRTL_write_en4_shift                                               (11)
+#define HDMI_PHYCHCRTL_write_en4_mask                                                (0x00000800)
+#define HDMI_PHYCHCRTL_write_en4(data)                                               (0x00000800&((data)<<11))
+#define HDMI_PHYCHCRTL_write_en4_src(data)                                           ((0x00000800&(data))>>11)
+#define HDMI_PHYCHCRTL_get_write_en4(data)                                           ((0x00000800&(data))>>11)
+#define HDMI_PHYCHCRTL_hdmi_chclk_data_swap_shift                                    (9)
+#define HDMI_PHYCHCRTL_hdmi_chclk_data_swap_mask                                     (0x00000600)
+#define HDMI_PHYCHCRTL_hdmi_chclk_data_swap(data)                                    (0x00000600&((data)<<9))
+#define HDMI_PHYCHCRTL_hdmi_chclk_data_swap_src(data)                                ((0x00000600&(data))>>9)
+#define HDMI_PHYCHCRTL_get_hdmi_chclk_data_swap(data)                                ((0x00000600&(data))>>9)
+#define HDMI_PHYCHCRTL_write_en3_shift                                               (8)
+#define HDMI_PHYCHCRTL_write_en3_mask                                                (0x00000100)
+#define HDMI_PHYCHCRTL_write_en3(data)                                               (0x00000100&((data)<<8))
+#define HDMI_PHYCHCRTL_write_en3_src(data)                                           ((0x00000100&(data))>>8)
+#define HDMI_PHYCHCRTL_get_write_en3(data)                                           ((0x00000100&(data))>>8)
+#define HDMI_PHYCHCRTL_hdmi_chc_data_swap_shift                                      (6)
+#define HDMI_PHYCHCRTL_hdmi_chc_data_swap_mask                                       (0x000000C0)
+#define HDMI_PHYCHCRTL_hdmi_chc_data_swap(data)                                      (0x000000C0&((data)<<6))
+#define HDMI_PHYCHCRTL_hdmi_chc_data_swap_src(data)                                  ((0x000000C0&(data))>>6)
+#define HDMI_PHYCHCRTL_get_hdmi_chc_data_swap(data)                                  ((0x000000C0&(data))>>6)
+#define HDMI_PHYCHCRTL_write_en2_shift                                               (5)
+#define HDMI_PHYCHCRTL_write_en2_mask                                                (0x00000020)
+#define HDMI_PHYCHCRTL_write_en2(data)                                               (0x00000020&((data)<<5))
+#define HDMI_PHYCHCRTL_write_en2_src(data)                                           ((0x00000020&(data))>>5)
+#define HDMI_PHYCHCRTL_get_write_en2(data)                                           ((0x00000020&(data))>>5)
+#define HDMI_PHYCHCRTL_hdmi_chb_data_swap_shift                                      (3)
+#define HDMI_PHYCHCRTL_hdmi_chb_data_swap_mask                                       (0x00000018)
+#define HDMI_PHYCHCRTL_hdmi_chb_data_swap(data)                                      (0x00000018&((data)<<3))
+#define HDMI_PHYCHCRTL_hdmi_chb_data_swap_src(data)                                  ((0x00000018&(data))>>3)
+#define HDMI_PHYCHCRTL_get_hdmi_chb_data_swap(data)                                  ((0x00000018&(data))>>3)
+#define HDMI_PHYCHCRTL_write_en1_shift                                               (2)
+#define HDMI_PHYCHCRTL_write_en1_mask                                                (0x00000004)
+#define HDMI_PHYCHCRTL_write_en1(data)                                               (0x00000004&((data)<<2))
+#define HDMI_PHYCHCRTL_write_en1_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_PHYCHCRTL_get_write_en1(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_PHYCHCRTL_hdmi_cha_data_swap_shift                                      (0)
+#define HDMI_PHYCHCRTL_hdmi_cha_data_swap_mask                                       (0x00000003)
+#define HDMI_PHYCHCRTL_hdmi_cha_data_swap(data)                                      (0x00000003&((data)<<0))
+#define HDMI_PHYCHCRTL_hdmi_cha_data_swap_src(data)                                  ((0x00000003&(data))>>0)
+#define HDMI_PHYCHCRTL_get_hdmi_cha_data_swap(data)                                  ((0x00000003&(data))>>0)
+
+
+#define HDMI_HDMI_2_0_CTRL1                                                          0x040
+#define HDMI_HDMI_2_0_CTRL1_reg_addr                                                 "0x9800D040"
+#define HDMI_HDMI_2_0_CTRL1_reg                                                      0x9800D040
+#define set_HDMI_HDMI_2_0_CTRL1_reg(data)   (*((volatile unsigned int*) HDMI_HDMI_2_0_CTRL1_reg)=data)
+#define get_HDMI_HDMI_2_0_CTRL1_reg   (*((volatile unsigned int*) HDMI_HDMI_2_0_CTRL1_reg))
+#define HDMI_HDMI_2_0_CTRL1_inst_adr                                                 "0x0010"
+#define HDMI_HDMI_2_0_CTRL1_inst                                                     0x0010
+#define HDMI_HDMI_2_0_CTRL1_write_en4_shift                                          (7)
+#define HDMI_HDMI_2_0_CTRL1_write_en4_mask                                           (0x00000080)
+#define HDMI_HDMI_2_0_CTRL1_write_en4(data)                                          (0x00000080&((data)<<7))
+#define HDMI_HDMI_2_0_CTRL1_write_en4_src(data)                                      ((0x00000080&(data))>>7)
+#define HDMI_HDMI_2_0_CTRL1_get_write_en4(data)                                      ((0x00000080&(data))>>7)
+#define HDMI_HDMI_2_0_CTRL1_chclk_div4_en_shift                                      (6)
+#define HDMI_HDMI_2_0_CTRL1_chclk_div4_en_mask                                       (0x00000040)
+#define HDMI_HDMI_2_0_CTRL1_chclk_div4_en(data)                                      (0x00000040&((data)<<6))
+#define HDMI_HDMI_2_0_CTRL1_chclk_div4_en_src(data)                                  ((0x00000040&(data))>>6)
+#define HDMI_HDMI_2_0_CTRL1_get_chclk_div4_en(data)                                  ((0x00000040&(data))>>6)
+#define HDMI_HDMI_2_0_CTRL1_write_en3_shift                                          (5)
+#define HDMI_HDMI_2_0_CTRL1_write_en3_mask                                           (0x00000020)
+#define HDMI_HDMI_2_0_CTRL1_write_en3(data)                                          (0x00000020&((data)<<5))
+#define HDMI_HDMI_2_0_CTRL1_write_en3_src(data)                                      ((0x00000020&(data))>>5)
+#define HDMI_HDMI_2_0_CTRL1_get_write_en3(data)                                      ((0x00000020&(data))>>5)
+#define HDMI_HDMI_2_0_CTRL1_scrmbl_en_shift                                          (4)
+#define HDMI_HDMI_2_0_CTRL1_scrmbl_en_mask                                           (0x00000010)
+#define HDMI_HDMI_2_0_CTRL1_scrmbl_en(data)                                          (0x00000010&((data)<<4))
+#define HDMI_HDMI_2_0_CTRL1_scrmbl_en_src(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_HDMI_2_0_CTRL1_get_scrmbl_en(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_HDMI_2_0_CTRL1_write_en2_shift                                          (3)
+#define HDMI_HDMI_2_0_CTRL1_write_en2_mask                                           (0x00000008)
+#define HDMI_HDMI_2_0_CTRL1_write_en2(data)                                          (0x00000008&((data)<<3))
+#define HDMI_HDMI_2_0_CTRL1_write_en2_src(data)                                      ((0x00000008&(data))>>3)
+#define HDMI_HDMI_2_0_CTRL1_get_write_en2(data)                                      ((0x00000008&(data))>>3)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_hlfp_shift                                      (2)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_hlfp_mask                                       (0x00000004)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_hlfp(data)                                      (0x00000004&((data)<<2))
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_hlfp_src(data)                                  ((0x00000004&(data))>>2)
+#define HDMI_HDMI_2_0_CTRL1_get_ycbcr420_hlfp(data)                                  ((0x00000004&(data))>>2)
+#define HDMI_HDMI_2_0_CTRL1_write_en1_shift                                          (1)
+#define HDMI_HDMI_2_0_CTRL1_write_en1_mask                                           (0x00000002)
+#define HDMI_HDMI_2_0_CTRL1_write_en1(data)                                          (0x00000002&((data)<<1))
+#define HDMI_HDMI_2_0_CTRL1_write_en1_src(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_HDMI_2_0_CTRL1_get_write_en1(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_shift                                           (0)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_mask                                            (0x00000001)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420(data)                                           (0x00000001&((data)<<0))
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_src(data)                                       ((0x00000001&(data))>>0)
+#define HDMI_HDMI_2_0_CTRL1_get_ycbcr420(data)                                       ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDMI_2_0_CTRL2                                                          0x044
+#define HDMI_HDMI_2_0_CTRL2_reg_addr                                                 "0x9800D044"
+#define HDMI_HDMI_2_0_CTRL2_reg                                                      0x9800D044
+#define set_HDMI_HDMI_2_0_CTRL2_reg(data)   (*((volatile unsigned int*) HDMI_HDMI_2_0_CTRL2_reg)=data)
+#define get_HDMI_HDMI_2_0_CTRL2_reg   (*((volatile unsigned int*) HDMI_HDMI_2_0_CTRL2_reg))
+#define HDMI_HDMI_2_0_CTRL2_inst_adr                                                 "0x0011"
+#define HDMI_HDMI_2_0_CTRL2_inst                                                     0x0011
+#define HDMI_HDMI_2_0_CTRL2_write_en2_shift                                          (30)
+#define HDMI_HDMI_2_0_CTRL2_write_en2_mask                                           (0x40000000)
+#define HDMI_HDMI_2_0_CTRL2_write_en2(data)                                          (0x40000000&((data)<<30))
+#define HDMI_HDMI_2_0_CTRL2_write_en2_src(data)                                      ((0x40000000&(data))>>30)
+#define HDMI_HDMI_2_0_CTRL2_get_write_en2(data)                                      ((0x40000000&(data))>>30)
+#define HDMI_HDMI_2_0_CTRL2_sscp_hpxl_shift                                          (16)
+#define HDMI_HDMI_2_0_CTRL2_sscp_hpxl_mask                                           (0x3FFF0000)
+#define HDMI_HDMI_2_0_CTRL2_sscp_hpxl(data)                                          (0x3FFF0000&((data)<<16))
+#define HDMI_HDMI_2_0_CTRL2_sscp_hpxl_src(data)                                      ((0x3FFF0000&(data))>>16)
+#define HDMI_HDMI_2_0_CTRL2_get_sscp_hpxl(data)                                      ((0x3FFF0000&(data))>>16)
+#define HDMI_HDMI_2_0_CTRL2_write_en1_shift                                          (14)
+#define HDMI_HDMI_2_0_CTRL2_write_en1_mask                                           (0x00004000)
+#define HDMI_HDMI_2_0_CTRL2_write_en1(data)                                          (0x00004000&((data)<<14))
+#define HDMI_HDMI_2_0_CTRL2_write_en1_src(data)                                      ((0x00004000&(data))>>14)
+#define HDMI_HDMI_2_0_CTRL2_get_write_en1(data)                                      ((0x00004000&(data))>>14)
+#define HDMI_HDMI_2_0_CTRL2_sscp_vline_shift                                         (0)
+#define HDMI_HDMI_2_0_CTRL2_sscp_vline_mask                                          (0x00003FFF)
+#define HDMI_HDMI_2_0_CTRL2_sscp_vline(data)                                         (0x00003FFF&((data)<<0))
+#define HDMI_HDMI_2_0_CTRL2_sscp_vline_src(data)                                     ((0x00003FFF&(data))>>0)
+#define HDMI_HDMI_2_0_CTRL2_get_sscp_vline(data)                                     ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG1                                                               0x500
+#define HDMI_MHL3_REG1_reg_addr                                                      "0x9800D500"
+#define HDMI_MHL3_REG1_reg                                                           0x9800D500
+#define set_HDMI_MHL3_REG1_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG1_reg)=data)
+#define get_HDMI_MHL3_REG1_reg   (*((volatile unsigned int*) HDMI_MHL3_REG1_reg))
+#define HDMI_MHL3_REG1_inst_adr                                                      "0x0040"
+#define HDMI_MHL3_REG1_inst                                                          0x0040
+#define HDMI_MHL3_REG1_sync_polarity_shift                                           (5)
+#define HDMI_MHL3_REG1_sync_polarity_mask                                            (0x00000020)
+#define HDMI_MHL3_REG1_sync_polarity(data)                                           (0x00000020&((data)<<5))
+#define HDMI_MHL3_REG1_sync_polarity_src(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_MHL3_REG1_get_sync_polarity(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_MHL3_REG1_sync_source_shift                                             (4)
+#define HDMI_MHL3_REG1_sync_source_mask                                              (0x00000010)
+#define HDMI_MHL3_REG1_sync_source(data)                                             (0x00000010&((data)<<4))
+#define HDMI_MHL3_REG1_sync_source_src(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_MHL3_REG1_get_sync_source(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_MHL3_REG1_extend_mode_shift                                             (2)
+#define HDMI_MHL3_REG1_extend_mode_mask                                              (0x00000004)
+#define HDMI_MHL3_REG1_extend_mode(data)                                             (0x00000004&((data)<<2))
+#define HDMI_MHL3_REG1_extend_mode_src(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG1_get_extend_mode(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG1_24bit_en_shift                                                (1)
+#define HDMI_MHL3_REG1_24bit_en_mask                                                 (0x00000002)
+#define HDMI_MHL3_REG1_24bit_en(data)                                                (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG1_24bit_en_src(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG1_get_24bit_en(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG1_mhl3_en_shift                                                 (0)
+#define HDMI_MHL3_REG1_mhl3_en_mask                                                  (0x00000001)
+#define HDMI_MHL3_REG1_mhl3_en(data)                                                 (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG1_mhl3_en_src(data)                                             ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG1_get_mhl3_en(data)                                             ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG2                                                               0x504
+#define HDMI_MHL3_REG2_reg_addr                                                      "0x9800D504"
+#define HDMI_MHL3_REG2_reg                                                           0x9800D504
+#define set_HDMI_MHL3_REG2_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG2_reg)=data)
+#define get_HDMI_MHL3_REG2_reg   (*((volatile unsigned int*) HDMI_MHL3_REG2_reg))
+#define HDMI_MHL3_REG2_inst_adr                                                      "0x0041"
+#define HDMI_MHL3_REG2_inst                                                          0x0041
+#define HDMI_MHL3_REG2_fifo_cnt_shift                                                (0)
+#define HDMI_MHL3_REG2_fifo_cnt_mask                                                 (0x0000007F)
+#define HDMI_MHL3_REG2_fifo_cnt(data)                                                (0x0000007F&((data)<<0))
+#define HDMI_MHL3_REG2_fifo_cnt_src(data)                                            ((0x0000007F&(data))>>0)
+#define HDMI_MHL3_REG2_get_fifo_cnt(data)                                            ((0x0000007F&(data))>>0)
+
+
+#define HDMI_MHL3_REG3                                                               0x508
+#define HDMI_MHL3_REG3_reg_addr                                                      "0x9800D508"
+#define HDMI_MHL3_REG3_reg                                                           0x9800D508
+#define set_HDMI_MHL3_REG3_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG3_reg)=data)
+#define get_HDMI_MHL3_REG3_reg   (*((volatile unsigned int*) HDMI_MHL3_REG3_reg))
+#define HDMI_MHL3_REG3_inst_adr                                                      "0x0042"
+#define HDMI_MHL3_REG3_inst                                                          0x0042
+#define HDMI_MHL3_REG3_cp_fifo_reach_size_shift                                      (24)
+#define HDMI_MHL3_REG3_cp_fifo_reach_size_mask                                       (0x7F000000)
+#define HDMI_MHL3_REG3_cp_fifo_reach_size(data)                                      (0x7F000000&((data)<<24))
+#define HDMI_MHL3_REG3_cp_fifo_reach_size_src(data)                                  ((0x7F000000&(data))>>24)
+#define HDMI_MHL3_REG3_get_cp_fifo_reach_size(data)                                  ((0x7F000000&(data))>>24)
+#define HDMI_MHL3_REG3_htotal_fifo_reach_size_shift                                  (16)
+#define HDMI_MHL3_REG3_htotal_fifo_reach_size_mask                                   (0x007F0000)
+#define HDMI_MHL3_REG3_htotal_fifo_reach_size(data)                                  (0x007F0000&((data)<<16))
+#define HDMI_MHL3_REG3_htotal_fifo_reach_size_src(data)                              ((0x007F0000&(data))>>16)
+#define HDMI_MHL3_REG3_get_htotal_fifo_reach_size(data)                              ((0x007F0000&(data))>>16)
+#define HDMI_MHL3_REG3_blank_fifo_reach_size_shift                                   (8)
+#define HDMI_MHL3_REG3_blank_fifo_reach_size_mask                                    (0x00007F00)
+#define HDMI_MHL3_REG3_blank_fifo_reach_size(data)                                   (0x00007F00&((data)<<8))
+#define HDMI_MHL3_REG3_blank_fifo_reach_size_src(data)                               ((0x00007F00&(data))>>8)
+#define HDMI_MHL3_REG3_get_blank_fifo_reach_size(data)                               ((0x00007F00&(data))>>8)
+#define HDMI_MHL3_REG3_video_fifo_reach_size_shift                                   (0)
+#define HDMI_MHL3_REG3_video_fifo_reach_size_mask                                    (0x0000007F)
+#define HDMI_MHL3_REG3_video_fifo_reach_size(data)                                   (0x0000007F&((data)<<0))
+#define HDMI_MHL3_REG3_video_fifo_reach_size_src(data)                               ((0x0000007F&(data))>>0)
+#define HDMI_MHL3_REG3_get_video_fifo_reach_size(data)                               ((0x0000007F&(data))>>0)
+
+
+#define HDMI_MHL3_REG4                                                               0x50C
+#define HDMI_MHL3_REG4_reg_addr                                                      "0x9800D50C"
+#define HDMI_MHL3_REG4_reg                                                           0x9800D50C
+#define set_HDMI_MHL3_REG4_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG4_reg)=data)
+#define get_HDMI_MHL3_REG4_reg   (*((volatile unsigned int*) HDMI_MHL3_REG4_reg))
+#define HDMI_MHL3_REG4_inst_adr                                                      "0x0043"
+#define HDMI_MHL3_REG4_inst                                                          0x0043
+#define HDMI_MHL3_REG4_payload_blank_16bit_shift                                     (24)
+#define HDMI_MHL3_REG4_payload_blank_16bit_mask                                      (0xFF000000)
+#define HDMI_MHL3_REG4_payload_blank_16bit(data)                                     (0xFF000000&((data)<<24))
+#define HDMI_MHL3_REG4_payload_blank_16bit_src(data)                                 ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG4_get_payload_blank_16bit(data)                                 ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG4_payload_blank_24bit_shift                                     (16)
+#define HDMI_MHL3_REG4_payload_blank_24bit_mask                                      (0x00FF0000)
+#define HDMI_MHL3_REG4_payload_blank_24bit(data)                                     (0x00FF0000&((data)<<16))
+#define HDMI_MHL3_REG4_payload_blank_24bit_src(data)                                 ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG4_get_payload_blank_24bit(data)                                 ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG4_payload_video_16bit_shift                                     (8)
+#define HDMI_MHL3_REG4_payload_video_16bit_mask                                      (0x0000FF00)
+#define HDMI_MHL3_REG4_payload_video_16bit(data)                                     (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG4_payload_video_16bit_src(data)                                 ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG4_get_payload_video_16bit(data)                                 ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG4_payload_video_24bit_shift                                     (0)
+#define HDMI_MHL3_REG4_payload_video_24bit_mask                                      (0x000000FF)
+#define HDMI_MHL3_REG4_payload_video_24bit(data)                                     (0x000000FF&((data)<<0))
+#define HDMI_MHL3_REG4_payload_video_24bit_src(data)                                 ((0x000000FF&(data))>>0)
+#define HDMI_MHL3_REG4_get_payload_video_24bit(data)                                 ((0x000000FF&(data))>>0)
+
+
+#define HDMI_MHL3_REG5                                                               0x510
+#define HDMI_MHL3_REG5_reg_addr                                                      "0x9800D510"
+#define HDMI_MHL3_REG5_reg                                                           0x9800D510
+#define set_HDMI_MHL3_REG5_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG5_reg)=data)
+#define get_HDMI_MHL3_REG5_reg   (*((volatile unsigned int*) HDMI_MHL3_REG5_reg))
+#define HDMI_MHL3_REG5_inst_adr                                                      "0x0044"
+#define HDMI_MHL3_REG5_inst                                                          0x0044
+#define HDMI_MHL3_REG5_payload_cp_16bit_shift                                        (24)
+#define HDMI_MHL3_REG5_payload_cp_16bit_mask                                         (0xFF000000)
+#define HDMI_MHL3_REG5_payload_cp_16bit(data)                                        (0xFF000000&((data)<<24))
+#define HDMI_MHL3_REG5_payload_cp_16bit_src(data)                                    ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG5_get_payload_cp_16bit(data)                                    ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG5_payload_cp_24bit_shift                                        (16)
+#define HDMI_MHL3_REG5_payload_cp_24bit_mask                                         (0x00FF0000)
+#define HDMI_MHL3_REG5_payload_cp_24bit(data)                                        (0x00FF0000&((data)<<16))
+#define HDMI_MHL3_REG5_payload_cp_24bit_src(data)                                    ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG5_get_payload_cp_24bit(data)                                    ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG5_payload_htotal_16bit_shift                                    (8)
+#define HDMI_MHL3_REG5_payload_htotal_16bit_mask                                     (0x0000FF00)
+#define HDMI_MHL3_REG5_payload_htotal_16bit(data)                                    (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG5_payload_htotal_16bit_src(data)                                ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG5_get_payload_htotal_16bit(data)                                ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG5_payload_htotal_24bit_shift                                    (0)
+#define HDMI_MHL3_REG5_payload_htotal_24bit_mask                                     (0x000000FF)
+#define HDMI_MHL3_REG5_payload_htotal_24bit(data)                                    (0x000000FF&((data)<<0))
+#define HDMI_MHL3_REG5_payload_htotal_24bit_src(data)                                ((0x000000FF&(data))>>0)
+#define HDMI_MHL3_REG5_get_payload_htotal_24bit(data)                                ((0x000000FF&(data))>>0)
+
+
+#define HDMI_MHL3_REG6                                                               0x514
+#define HDMI_MHL3_REG6_reg_addr                                                      "0x9800D514"
+#define HDMI_MHL3_REG6_reg                                                           0x9800D514
+#define set_HDMI_MHL3_REG6_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG6_reg)=data)
+#define get_HDMI_MHL3_REG6_reg   (*((volatile unsigned int*) HDMI_MHL3_REG6_reg))
+#define HDMI_MHL3_REG6_inst_adr                                                      "0x0045"
+#define HDMI_MHL3_REG6_inst                                                          0x0045
+#define HDMI_MHL3_REG6_gap_blank_16bit_shift                                         (24)
+#define HDMI_MHL3_REG6_gap_blank_16bit_mask                                          (0xFF000000)
+#define HDMI_MHL3_REG6_gap_blank_16bit(data)                                         (0xFF000000&((data)<<24))
+#define HDMI_MHL3_REG6_gap_blank_16bit_src(data)                                     ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG6_get_gap_blank_16bit(data)                                     ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG6_gap_blank_24bit_shift                                         (16)
+#define HDMI_MHL3_REG6_gap_blank_24bit_mask                                          (0x00FF0000)
+#define HDMI_MHL3_REG6_gap_blank_24bit(data)                                         (0x00FF0000&((data)<<16))
+#define HDMI_MHL3_REG6_gap_blank_24bit_src(data)                                     ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG6_get_gap_blank_24bit(data)                                     ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG6_gap_video_16bit_shift                                         (8)
+#define HDMI_MHL3_REG6_gap_video_16bit_mask                                          (0x0000FF00)
+#define HDMI_MHL3_REG6_gap_video_16bit(data)                                         (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG6_gap_video_16bit_src(data)                                     ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG6_get_gap_video_16bit(data)                                     ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG6_gap_video_24bit_shift                                         (0)
+#define HDMI_MHL3_REG6_gap_video_24bit_mask                                          (0x000000FF)
+#define HDMI_MHL3_REG6_gap_video_24bit(data)                                         (0x000000FF&((data)<<0))
+#define HDMI_MHL3_REG6_gap_video_24bit_src(data)                                     ((0x000000FF&(data))>>0)
+#define HDMI_MHL3_REG6_get_gap_video_24bit(data)                                     ((0x000000FF&(data))>>0)
+
+
+#define HDMI_MHL3_REG7                                                               0x518
+#define HDMI_MHL3_REG7_reg_addr                                                      "0x9800D518"
+#define HDMI_MHL3_REG7_reg                                                           0x9800D518
+#define set_HDMI_MHL3_REG7_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG7_reg)=data)
+#define get_HDMI_MHL3_REG7_reg   (*((volatile unsigned int*) HDMI_MHL3_REG7_reg))
+#define HDMI_MHL3_REG7_inst_adr                                                      "0x0046"
+#define HDMI_MHL3_REG7_inst                                                          0x0046
+#define HDMI_MHL3_REG7_gap_cp_16bit_shift                                            (24)
+#define HDMI_MHL3_REG7_gap_cp_16bit_mask                                             (0xFF000000)
+#define HDMI_MHL3_REG7_gap_cp_16bit(data)                                            (0xFF000000&((data)<<24))
+#define HDMI_MHL3_REG7_gap_cp_16bit_src(data)                                        ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG7_get_gap_cp_16bit(data)                                        ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG7_gap_cp_24bit_shift                                            (16)
+#define HDMI_MHL3_REG7_gap_cp_24bit_mask                                             (0x00FF0000)
+#define HDMI_MHL3_REG7_gap_cp_24bit(data)                                            (0x00FF0000&((data)<<16))
+#define HDMI_MHL3_REG7_gap_cp_24bit_src(data)                                        ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG7_get_gap_cp_24bit(data)                                        ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG7_gap_htotal_16bit_shift                                        (8)
+#define HDMI_MHL3_REG7_gap_htotal_16bit_mask                                         (0x0000FF00)
+#define HDMI_MHL3_REG7_gap_htotal_16bit(data)                                        (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG7_gap_htotal_16bit_src(data)                                    ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG7_get_gap_htotal_16bit(data)                                    ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG7_gap_htotal_24bit_shift                                        (0)
+#define HDMI_MHL3_REG7_gap_htotal_24bit_mask                                         (0x000000FF)
+#define HDMI_MHL3_REG7_gap_htotal_24bit(data)                                        (0x000000FF&((data)<<0))
+#define HDMI_MHL3_REG7_gap_htotal_24bit_src(data)                                    ((0x000000FF&(data))>>0)
+#define HDMI_MHL3_REG7_get_gap_htotal_24bit(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define HDMI_MHL3_REG8                                                               0x51C
+#define HDMI_MHL3_REG8_reg_addr                                                      "0x9800D51C"
+#define HDMI_MHL3_REG8_reg                                                           0x9800D51C
+#define set_HDMI_MHL3_REG8_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG8_reg)=data)
+#define get_HDMI_MHL3_REG8_reg   (*((volatile unsigned int*) HDMI_MHL3_REG8_reg))
+#define HDMI_MHL3_REG8_inst_adr                                                      "0x0047"
+#define HDMI_MHL3_REG8_inst                                                          0x0047
+#define HDMI_MHL3_REG8_tmds_en_shift                                                 (2)
+#define HDMI_MHL3_REG8_tmds_en_mask                                                  (0x00000004)
+#define HDMI_MHL3_REG8_tmds_en(data)                                                 (0x00000004&((data)<<2))
+#define HDMI_MHL3_REG8_tmds_en_src(data)                                             ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG8_get_tmds_en(data)                                             ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG8_cp_en_shift                                                   (1)
+#define HDMI_MHL3_REG8_cp_en_mask                                                    (0x00000002)
+#define HDMI_MHL3_REG8_cp_en(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG8_cp_en_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG8_get_cp_en(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG8_rr_en_shift                                                   (0)
+#define HDMI_MHL3_REG8_rr_en_mask                                                    (0x00000001)
+#define HDMI_MHL3_REG8_rr_en(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG8_rr_en_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG8_get_rr_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG9                                                               0x520
+#define HDMI_MHL3_REG9_reg_addr                                                      "0x9800D520"
+#define HDMI_MHL3_REG9_reg                                                           0x9800D520
+#define set_HDMI_MHL3_REG9_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG9_reg)=data)
+#define get_HDMI_MHL3_REG9_reg   (*((volatile unsigned int*) HDMI_MHL3_REG9_reg))
+#define HDMI_MHL3_REG9_inst_adr                                                      "0x0048"
+#define HDMI_MHL3_REG9_inst                                                          0x0048
+#define HDMI_MHL3_REG9_avlink_data_shift                                             (16)
+#define HDMI_MHL3_REG9_avlink_data_mask                                              (0x03FF0000)
+#define HDMI_MHL3_REG9_avlink_data(data)                                             (0x03FF0000&((data)<<16))
+#define HDMI_MHL3_REG9_avlink_data_src(data)                                         ((0x03FF0000&(data))>>16)
+#define HDMI_MHL3_REG9_get_avlink_data(data)                                         ((0x03FF0000&(data))>>16)
+#define HDMI_MHL3_REG9_avlink_duration_shift                                         (8)
+#define HDMI_MHL3_REG9_avlink_duration_mask                                          (0x0000FF00)
+#define HDMI_MHL3_REG9_avlink_duration(data)                                         (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG9_avlink_duration_src(data)                                     ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG9_get_avlink_duration(data)                                     ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG9_avlink_fixed8_alg_shift                                       (5)
+#define HDMI_MHL3_REG9_avlink_fixed8_alg_mask                                        (0x00000020)
+#define HDMI_MHL3_REG9_avlink_fixed8_alg(data)                                       (0x00000020&((data)<<5))
+#define HDMI_MHL3_REG9_avlink_fixed8_alg_src(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_MHL3_REG9_get_avlink_fixed8_alg(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_MHL3_REG9_avlink_bitwise_inv_shift                                      (3)
+#define HDMI_MHL3_REG9_avlink_bitwise_inv_mask                                       (0x00000018)
+#define HDMI_MHL3_REG9_avlink_bitwise_inv(data)                                      (0x00000018&((data)<<3))
+#define HDMI_MHL3_REG9_avlink_bitwise_inv_src(data)                                  ((0x00000018&(data))>>3)
+#define HDMI_MHL3_REG9_get_avlink_bitwise_inv(data)                                  ((0x00000018&(data))>>3)
+#define HDMI_MHL3_REG9_avlink_pattern_shift                                          (1)
+#define HDMI_MHL3_REG9_avlink_pattern_mask                                           (0x00000006)
+#define HDMI_MHL3_REG9_avlink_pattern(data)                                          (0x00000006&((data)<<1))
+#define HDMI_MHL3_REG9_avlink_pattern_src(data)                                      ((0x00000006&(data))>>1)
+#define HDMI_MHL3_REG9_get_avlink_pattern(data)                                      ((0x00000006&(data))>>1)
+#define HDMI_MHL3_REG9_avlink_bist_en_shift                                          (0)
+#define HDMI_MHL3_REG9_avlink_bist_en_mask                                           (0x00000001)
+#define HDMI_MHL3_REG9_avlink_bist_en(data)                                          (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG9_avlink_bist_en_src(data)                                      ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG9_get_avlink_bist_en(data)                                      ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG10                                                              0x524
+#define HDMI_MHL3_REG10_reg_addr                                                     "0x9800D524"
+#define HDMI_MHL3_REG10_reg                                                          0x9800D524
+#define set_HDMI_MHL3_REG10_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG10_reg)=data)
+#define get_HDMI_MHL3_REG10_reg   (*((volatile unsigned int*) HDMI_MHL3_REG10_reg))
+#define HDMI_MHL3_REG10_inst_adr                                                     "0x0049"
+#define HDMI_MHL3_REG10_inst                                                         0x0049
+#define HDMI_MHL3_REG10_rme_shift                                                    (12)
+#define HDMI_MHL3_REG10_rme_mask                                                     (0x00001000)
+#define HDMI_MHL3_REG10_rme(data)                                                    (0x00001000&((data)<<12))
+#define HDMI_MHL3_REG10_rme_src(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_MHL3_REG10_get_rme(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_MHL3_REG10_rm_shift                                                     (8)
+#define HDMI_MHL3_REG10_rm_mask                                                      (0x00000F00)
+#define HDMI_MHL3_REG10_rm(data)                                                     (0x00000F00&((data)<<8))
+#define HDMI_MHL3_REG10_rm_src(data)                                                 ((0x00000F00&(data))>>8)
+#define HDMI_MHL3_REG10_get_rm(data)                                                 ((0x00000F00&(data))>>8)
+#define HDMI_MHL3_REG10_ls_shift                                                     (3)
+#define HDMI_MHL3_REG10_ls_mask                                                      (0x00000008)
+#define HDMI_MHL3_REG10_ls(data)                                                     (0x00000008&((data)<<3))
+#define HDMI_MHL3_REG10_ls_src(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG10_get_ls(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG10_drf_resume_shift                                             (2)
+#define HDMI_MHL3_REG10_drf_resume_mask                                              (0x00000004)
+#define HDMI_MHL3_REG10_drf_resume(data)                                             (0x00000004&((data)<<2))
+#define HDMI_MHL3_REG10_drf_resume_src(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG10_get_drf_resume(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG10_drf_bist_mode_shift                                          (1)
+#define HDMI_MHL3_REG10_drf_bist_mode_mask                                           (0x00000002)
+#define HDMI_MHL3_REG10_drf_bist_mode(data)                                          (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG10_drf_bist_mode_src(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG10_get_drf_bist_mode(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG10_bist_mode_shift                                              (0)
+#define HDMI_MHL3_REG10_bist_mode_mask                                               (0x00000001)
+#define HDMI_MHL3_REG10_bist_mode(data)                                              (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG10_bist_mode_src(data)                                          ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG10_get_bist_mode(data)                                          ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG11                                                              0x528
+#define HDMI_MHL3_REG11_reg_addr                                                     "0x9800D528"
+#define HDMI_MHL3_REG11_reg                                                          0x9800D528
+#define set_HDMI_MHL3_REG11_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG11_reg)=data)
+#define get_HDMI_MHL3_REG11_reg   (*((volatile unsigned int*) HDMI_MHL3_REG11_reg))
+#define HDMI_MHL3_REG11_inst_adr                                                     "0x004A"
+#define HDMI_MHL3_REG11_inst                                                         0x004A
+#define HDMI_MHL3_REG11_bist_fail_shift                                              (1)
+#define HDMI_MHL3_REG11_bist_fail_mask                                               (0x00000002)
+#define HDMI_MHL3_REG11_bist_fail(data)                                              (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG11_bist_fail_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG11_get_bist_fail(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG11_bist_done_shift                                              (0)
+#define HDMI_MHL3_REG11_bist_done_mask                                               (0x00000001)
+#define HDMI_MHL3_REG11_bist_done(data)                                              (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG11_bist_done_src(data)                                          ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG11_get_bist_done(data)                                          ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG12                                                              0x52C
+#define HDMI_MHL3_REG12_reg_addr                                                     "0x9800D52C"
+#define HDMI_MHL3_REG12_reg                                                          0x9800D52C
+#define set_HDMI_MHL3_REG12_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG12_reg)=data)
+#define get_HDMI_MHL3_REG12_reg   (*((volatile unsigned int*) HDMI_MHL3_REG12_reg))
+#define HDMI_MHL3_REG12_inst_adr                                                     "0x004B"
+#define HDMI_MHL3_REG12_inst                                                         0x004B
+#define HDMI_MHL3_REG12_drf_start_pause_shift                                        (16)
+#define HDMI_MHL3_REG12_drf_start_pause_mask                                         (0x00010000)
+#define HDMI_MHL3_REG12_drf_start_pause(data)                                        (0x00010000&((data)<<16))
+#define HDMI_MHL3_REG12_drf_start_pause_src(data)                                    ((0x00010000&(data))>>16)
+#define HDMI_MHL3_REG12_get_drf_start_pause(data)                                    ((0x00010000&(data))>>16)
+#define HDMI_MHL3_REG12_drf_bist_fail_shift                                          (1)
+#define HDMI_MHL3_REG12_drf_bist_fail_mask                                           (0x00000002)
+#define HDMI_MHL3_REG12_drf_bist_fail(data)                                          (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG12_drf_bist_fail_src(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG12_get_drf_bist_fail(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG12_drf_bist_done_shift                                          (0)
+#define HDMI_MHL3_REG12_drf_bist_done_mask                                           (0x00000001)
+#define HDMI_MHL3_REG12_drf_bist_done(data)                                          (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG12_drf_bist_done_src(data)                                      ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG12_get_drf_bist_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG13                                                              0x530
+#define HDMI_MHL3_REG13_reg_addr                                                     "0x9800D530"
+#define HDMI_MHL3_REG13_reg                                                          0x9800D530
+#define set_HDMI_MHL3_REG13_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG13_reg)=data)
+#define get_HDMI_MHL3_REG13_reg   (*((volatile unsigned int*) HDMI_MHL3_REG13_reg))
+#define HDMI_MHL3_REG13_inst_adr                                                     "0x004C"
+#define HDMI_MHL3_REG13_inst                                                         0x004C
+#define HDMI_MHL3_REG13_built_in_b_shift                                             (24)
+#define HDMI_MHL3_REG13_built_in_b_mask                                              (0xFF000000)
+#define HDMI_MHL3_REG13_built_in_b(data)                                             (0xFF000000&((data)<<24))
+#define HDMI_MHL3_REG13_built_in_b_src(data)                                         ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG13_get_built_in_b(data)                                         ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG13_built_in_g_shift                                             (16)
+#define HDMI_MHL3_REG13_built_in_g_mask                                              (0x00FF0000)
+#define HDMI_MHL3_REG13_built_in_g(data)                                             (0x00FF0000&((data)<<16))
+#define HDMI_MHL3_REG13_built_in_g_src(data)                                         ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG13_get_built_in_g(data)                                         ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG13_built_in_r_shift                                             (8)
+#define HDMI_MHL3_REG13_built_in_r_mask                                              (0x0000FF00)
+#define HDMI_MHL3_REG13_built_in_r(data)                                             (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG13_built_in_r_src(data)                                         ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG13_get_built_in_r(data)                                         ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG13_built_in_video_type_shift                                    (1)
+#define HDMI_MHL3_REG13_built_in_video_type_mask                                     (0x0000000E)
+#define HDMI_MHL3_REG13_built_in_video_type(data)                                    (0x0000000E&((data)<<1))
+#define HDMI_MHL3_REG13_built_in_video_type_src(data)                                ((0x0000000E&(data))>>1)
+#define HDMI_MHL3_REG13_get_built_in_video_type(data)                                ((0x0000000E&(data))>>1)
+#define HDMI_MHL3_REG13_built_in_video_en_shift                                      (0)
+#define HDMI_MHL3_REG13_built_in_video_en_mask                                       (0x00000001)
+#define HDMI_MHL3_REG13_built_in_video_en(data)                                      (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG13_built_in_video_en_src(data)                                  ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG13_get_built_in_video_en(data)                                  ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG14                                                              0x534
+#define HDMI_MHL3_REG14_reg_addr                                                     "0x9800D534"
+#define HDMI_MHL3_REG14_reg                                                          0x9800D534
+#define set_HDMI_MHL3_REG14_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG14_reg)=data)
+#define get_HDMI_MHL3_REG14_reg   (*((volatile unsigned int*) HDMI_MHL3_REG14_reg))
+#define HDMI_MHL3_REG14_inst_adr                                                     "0x004D"
+#define HDMI_MHL3_REG14_inst                                                         0x004D
+#define HDMI_MHL3_REG14_vactive_front_shift                                          (0)
+#define HDMI_MHL3_REG14_vactive_front_mask                                           (0x00003FFF)
+#define HDMI_MHL3_REG14_vactive_front(data)                                          (0x00003FFF&((data)<<0))
+#define HDMI_MHL3_REG14_vactive_front_src(data)                                      ((0x00003FFF&(data))>>0)
+#define HDMI_MHL3_REG14_get_vactive_front(data)                                      ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG15                                                              0x538
+#define HDMI_MHL3_REG15_reg_addr                                                     "0x9800D538"
+#define HDMI_MHL3_REG15_reg                                                          0x9800D538
+#define set_HDMI_MHL3_REG15_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG15_reg)=data)
+#define get_HDMI_MHL3_REG15_reg   (*((volatile unsigned int*) HDMI_MHL3_REG15_reg))
+#define HDMI_MHL3_REG15_inst_adr                                                     "0x004E"
+#define HDMI_MHL3_REG15_inst                                                         0x004E
+#define HDMI_MHL3_REG15_vactive_back_shift                                           (0)
+#define HDMI_MHL3_REG15_vactive_back_mask                                            (0x00003FFF)
+#define HDMI_MHL3_REG15_vactive_back(data)                                           (0x00003FFF&((data)<<0))
+#define HDMI_MHL3_REG15_vactive_back_src(data)                                       ((0x00003FFF&(data))>>0)
+#define HDMI_MHL3_REG15_get_vactive_back(data)                                       ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG16                                                              0x53C
+#define HDMI_MHL3_REG16_reg_addr                                                     "0x9800D53C"
+#define HDMI_MHL3_REG16_reg                                                          0x9800D53C
+#define set_HDMI_MHL3_REG16_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG16_reg)=data)
+#define get_HDMI_MHL3_REG16_reg   (*((volatile unsigned int*) HDMI_MHL3_REG16_reg))
+#define HDMI_MHL3_REG16_inst_adr                                                     "0x004F"
+#define HDMI_MHL3_REG16_inst                                                         0x004F
+#define HDMI_MHL3_REG16_dummy_shift                                                  (0)
+#define HDMI_MHL3_REG16_dummy_mask                                                   (0xFFFFFFFF)
+#define HDMI_MHL3_REG16_dummy(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_MHL3_REG16_dummy_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_MHL3_REG16_get_dummy(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG17                                                              0x540
+#define HDMI_MHL3_REG17_reg_addr                                                     "0x9800D540"
+#define HDMI_MHL3_REG17_reg                                                          0x9800D540
+#define set_HDMI_MHL3_REG17_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG17_reg)=data)
+#define get_HDMI_MHL3_REG17_reg   (*((volatile unsigned int*) HDMI_MHL3_REG17_reg))
+#define HDMI_MHL3_REG17_inst_adr                                                     "0x0050"
+#define HDMI_MHL3_REG17_inst                                                         0x0050
+#define HDMI_MHL3_REG17_dummy_shift                                                  (16)
+#define HDMI_MHL3_REG17_dummy_mask                                                   (0xFFFF0000)
+#define HDMI_MHL3_REG17_dummy(data)                                                  (0xFFFF0000&((data)<<16))
+#define HDMI_MHL3_REG17_dummy_src(data)                                              ((0xFFFF0000&(data))>>16)
+#define HDMI_MHL3_REG17_get_dummy(data)                                              ((0xFFFF0000&(data))>>16)
+#define HDMI_MHL3_REG17_dbg1_sel_shift                                               (12)
+#define HDMI_MHL3_REG17_dbg1_sel_mask                                                (0x0000F000)
+#define HDMI_MHL3_REG17_dbg1_sel(data)                                               (0x0000F000&((data)<<12))
+#define HDMI_MHL3_REG17_dbg1_sel_src(data)                                           ((0x0000F000&(data))>>12)
+#define HDMI_MHL3_REG17_get_dbg1_sel(data)                                           ((0x0000F000&(data))>>12)
+#define HDMI_MHL3_REG17_dbg0_sel_shift                                               (8)
+#define HDMI_MHL3_REG17_dbg0_sel_mask                                                (0x00000F00)
+#define HDMI_MHL3_REG17_dbg0_sel(data)                                               (0x00000F00&((data)<<8))
+#define HDMI_MHL3_REG17_dbg0_sel_src(data)                                           ((0x00000F00&(data))>>8)
+#define HDMI_MHL3_REG17_get_dbg0_sel(data)                                           ((0x00000F00&(data))>>8)
+#define HDMI_MHL3_REG17_pwr_dis_shift                                                (1)
+#define HDMI_MHL3_REG17_pwr_dis_mask                                                 (0x00000002)
+#define HDMI_MHL3_REG17_pwr_dis(data)                                                (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG17_pwr_dis_src(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG17_get_pwr_dis(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG17_dbg_en_shift                                                 (0)
+#define HDMI_MHL3_REG17_dbg_en_mask                                                  (0x00000001)
+#define HDMI_MHL3_REG17_dbg_en(data)                                                 (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG17_dbg_en_src(data)                                             ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG17_get_dbg_en(data)                                             ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG18                                                              0x544
+#define HDMI_MHL3_REG18_reg_addr                                                     "0x9800D544"
+#define HDMI_MHL3_REG18_reg                                                          0x9800D544
+#define set_HDMI_MHL3_REG18_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG18_reg)=data)
+#define get_HDMI_MHL3_REG18_reg   (*((volatile unsigned int*) HDMI_MHL3_REG18_reg))
+#define HDMI_MHL3_REG18_inst_adr                                                     "0x0051"
+#define HDMI_MHL3_REG18_inst                                                         0x0051
+#define HDMI_MHL3_REG18_start_en_shift                                               (16)
+#define HDMI_MHL3_REG18_start_en_mask                                                (0x00010000)
+#define HDMI_MHL3_REG18_start_en(data)                                               (0x00010000&((data)<<16))
+#define HDMI_MHL3_REG18_start_en_src(data)                                           ((0x00010000&(data))>>16)
+#define HDMI_MHL3_REG18_get_start_en(data)                                           ((0x00010000&(data))>>16)
+#define HDMI_MHL3_REG18_start_line_shift                                             (0)
+#define HDMI_MHL3_REG18_start_line_mask                                              (0x00003FFF)
+#define HDMI_MHL3_REG18_start_line(data)                                             (0x00003FFF&((data)<<0))
+#define HDMI_MHL3_REG18_start_line_src(data)                                         ((0x00003FFF&(data))>>0)
+#define HDMI_MHL3_REG18_get_start_line(data)                                         ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG19                                                              0x548
+#define HDMI_MHL3_REG19_reg_addr                                                     "0x9800D548"
+#define HDMI_MHL3_REG19_reg                                                          0x9800D548
+#define set_HDMI_MHL3_REG19_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG19_reg)=data)
+#define get_HDMI_MHL3_REG19_reg   (*((volatile unsigned int*) HDMI_MHL3_REG19_reg))
+#define HDMI_MHL3_REG19_inst_adr                                                     "0x0052"
+#define HDMI_MHL3_REG19_inst                                                         0x0052
+#define HDMI_MHL3_REG19_hdcp2p2_streamctr_shift                                      (0)
+#define HDMI_MHL3_REG19_hdcp2p2_streamctr_mask                                       (0xFFFFFFFF)
+#define HDMI_MHL3_REG19_hdcp2p2_streamctr(data)                                      (0xFFFFFFFF&((data)<<0))
+#define HDMI_MHL3_REG19_hdcp2p2_streamctr_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define HDMI_MHL3_REG19_get_hdcp2p2_streamctr(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG20                                                              0x54C
+#define HDMI_MHL3_REG20_reg_addr                                                     "0x9800D54C"
+#define HDMI_MHL3_REG20_reg                                                          0x9800D54C
+#define set_HDMI_MHL3_REG20_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG20_reg)=data)
+#define get_HDMI_MHL3_REG20_reg   (*((volatile unsigned int*) HDMI_MHL3_REG20_reg))
+#define HDMI_MHL3_REG20_inst_adr                                                     "0x0053"
+#define HDMI_MHL3_REG20_inst                                                         0x0053
+#define HDMI_MHL3_REG20_hdcp2p2_stream_id_shift                                      (0)
+#define HDMI_MHL3_REG20_hdcp2p2_stream_id_mask                                       (0x000000FF)
+#define HDMI_MHL3_REG20_hdcp2p2_stream_id(data)                                      (0x000000FF&((data)<<0))
+#define HDMI_MHL3_REG20_hdcp2p2_stream_id_src(data)                                  ((0x000000FF&(data))>>0)
+#define HDMI_MHL3_REG20_get_hdcp2p2_stream_id(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define HDMI_MHL3_REG21                                                              0x550
+#define HDMI_MHL3_REG21_reg_addr                                                     "0x9800D550"
+#define HDMI_MHL3_REG21_reg                                                          0x9800D550
+#define set_HDMI_MHL3_REG21_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG21_reg)=data)
+#define get_HDMI_MHL3_REG21_reg   (*((volatile unsigned int*) HDMI_MHL3_REG21_reg))
+#define HDMI_MHL3_REG21_inst_adr                                                     "0x0054"
+#define HDMI_MHL3_REG21_inst                                                         0x0054
+#define HDMI_MHL3_REG21_hdcp2p2_mhl3_sel_shift                                       (0)
+#define HDMI_MHL3_REG21_hdcp2p2_mhl3_sel_mask                                        (0x00000001)
+#define HDMI_MHL3_REG21_hdcp2p2_mhl3_sel(data)                                       (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG21_hdcp2p2_mhl3_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG21_get_hdcp2p2_mhl3_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG22                                                              0x554
+#define HDMI_MHL3_REG22_reg_addr                                                     "0x9800D554"
+#define HDMI_MHL3_REG22_reg                                                          0x9800D554
+#define set_HDMI_MHL3_REG22_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG22_reg)=data)
+#define get_HDMI_MHL3_REG22_reg   (*((volatile unsigned int*) HDMI_MHL3_REG22_reg))
+#define HDMI_MHL3_REG22_inst_adr                                                     "0x0055"
+#define HDMI_MHL3_REG22_inst                                                         0x0055
+#define HDMI_MHL3_REG22_hdcp2p2_header_ext_shift                                     (0)
+#define HDMI_MHL3_REG22_hdcp2p2_header_ext_mask                                      (0xFFFFFFFF)
+#define HDMI_MHL3_REG22_hdcp2p2_header_ext(data)                                     (0xFFFFFFFF&((data)<<0))
+#define HDMI_MHL3_REG22_hdcp2p2_header_ext_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define HDMI_MHL3_REG22_get_hdcp2p2_header_ext(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG23                                                              0x558
+#define HDMI_MHL3_REG23_reg_addr                                                     "0x9800D558"
+#define HDMI_MHL3_REG23_reg                                                          0x9800D558
+#define set_HDMI_MHL3_REG23_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG23_reg)=data)
+#define get_HDMI_MHL3_REG23_reg   (*((volatile unsigned int*) HDMI_MHL3_REG23_reg))
+#define HDMI_MHL3_REG23_inst_adr                                                     "0x0056"
+#define HDMI_MHL3_REG23_inst                                                         0x0056
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_method_shift                                  (3)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_method_mask                                   (0x00000008)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_method(data)                                  (0x00000008&((data)<<3))
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_method_src(data)                              ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG23_get_hdcp2p2_cp_crc_method(data)                              ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev_shift                                     (2)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev_mask                                      (0x00000004)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev(data)                                     (0x00000004&((data)<<2))
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev_src(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG23_get_hdcp2p2_cp_crc_rev(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_inv_shift                                     (1)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_inv_mask                                      (0x00000002)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_inv(data)                                     (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_inv_src(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG23_get_hdcp2p2_cp_crc_inv(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev2_shift                                    (0)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev2_mask                                     (0x00000001)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev2(data)                                    (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev2_src(data)                                ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG23_get_hdcp2p2_cp_crc_rev2(data)                                ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG24                                                              0x55C
+#define HDMI_MHL3_REG24_reg_addr                                                     "0x9800D55C"
+#define HDMI_MHL3_REG24_reg                                                          0x9800D55C
+#define set_HDMI_MHL3_REG24_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG24_reg)=data)
+#define get_HDMI_MHL3_REG24_reg   (*((volatile unsigned int*) HDMI_MHL3_REG24_reg))
+#define HDMI_MHL3_REG24_inst_adr                                                     "0x0057"
+#define HDMI_MHL3_REG24_inst                                                         0x0057
+#define HDMI_MHL3_REG24_link_st_shift                                                (16)
+#define HDMI_MHL3_REG24_link_st_mask                                                 (0x0FFF0000)
+#define HDMI_MHL3_REG24_link_st(data)                                                (0x0FFF0000&((data)<<16))
+#define HDMI_MHL3_REG24_link_st_src(data)                                            ((0x0FFF0000&(data))>>16)
+#define HDMI_MHL3_REG24_get_link_st(data)                                            ((0x0FFF0000&(data))>>16)
+#define HDMI_MHL3_REG24_bist_fixed8_status_shift                                     (3)
+#define HDMI_MHL3_REG24_bist_fixed8_status_mask                                      (0x00000008)
+#define HDMI_MHL3_REG24_bist_fixed8_status(data)                                     (0x00000008&((data)<<3))
+#define HDMI_MHL3_REG24_bist_fixed8_status_src(data)                                 ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG24_get_bist_fixed8_status(data)                                 ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG24_bist_prbs_status_shift                                       (2)
+#define HDMI_MHL3_REG24_bist_prbs_status_mask                                        (0x00000004)
+#define HDMI_MHL3_REG24_bist_prbs_status(data)                                       (0x00000004&((data)<<2))
+#define HDMI_MHL3_REG24_bist_prbs_status_src(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG24_get_bist_prbs_status(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG24_fifo_full_status_shift                                       (1)
+#define HDMI_MHL3_REG24_fifo_full_status_mask                                        (0x00000002)
+#define HDMI_MHL3_REG24_fifo_full_status(data)                                       (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG24_fifo_full_status_src(data)                                   ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG24_get_fifo_full_status(data)                                   ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG24_fifo_full_clr_shift                                          (0)
+#define HDMI_MHL3_REG24_fifo_full_clr_mask                                           (0x00000001)
+#define HDMI_MHL3_REG24_fifo_full_clr(data)                                          (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG24_fifo_full_clr_src(data)                                      ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG24_get_fifo_full_clr(data)                                      ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG25                                                              0x560
+#define HDMI_MHL3_REG25_reg_addr                                                     "0x9800D560"
+#define HDMI_MHL3_REG25_reg                                                          0x9800D560
+#define set_HDMI_MHL3_REG25_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG25_reg)=data)
+#define get_HDMI_MHL3_REG25_reg   (*((volatile unsigned int*) HDMI_MHL3_REG25_reg))
+#define HDMI_MHL3_REG25_inst_adr                                                     "0x0058"
+#define HDMI_MHL3_REG25_inst                                                         0x0058
+#define HDMI_MHL3_REG25_cp_pos_adj_shift                                             (0)
+#define HDMI_MHL3_REG25_cp_pos_adj_mask                                              (0x00003FFF)
+#define HDMI_MHL3_REG25_cp_pos_adj(data)                                             (0x00003FFF&((data)<<0))
+#define HDMI_MHL3_REG25_cp_pos_adj_src(data)                                         ((0x00003FFF&(data))>>0)
+#define HDMI_MHL3_REG25_get_cp_pos_adj(data)                                         ((0x00003FFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx_rpc.h b/drivers/media/platform/rtk_hdmitx/hdmitx_rpc.h
new file mode 100644
index 00000000..55fa8c0
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx_rpc.h
@@ -0,0 +1,447 @@
+/*
+ * hdmitx_rpc.h - RTK hdmitx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDMITX_RPC_H_
+#define _HDMITX_RPC_H_
+
+#define S_OK        0x10000000
+
+typedef struct RPCRES_LONG {
+	u_int result;
+	u_int data;
+} RPCRES_LONG;
+
+typedef struct {
+	u_int  info;
+	RPCRES_LONG retval;
+	u_int ret;
+} RPC_DEFAULT_INPUT_T;
+
+struct AUDIO_HDMI_SET {
+	u_int HDMI_Frequency;
+};
+
+struct AUDIO_HDMI_MUTE_INFO {
+	u_int instanceID;
+	char hdmi_mute;
+};
+
+struct AUDIO_HDMI_OUT_VSDB_DATA {
+	u_int HDMI_VSDB_delay;
+};
+
+struct HDMI_INFO {
+	u_int video_type;
+};
+
+/* From FW amw_kernel_rpc.h */
+typedef enum {
+	ENUM_KERNEL_RPC_CREATE_AGENT,
+	ENUM_KERNEL_RPC_INIT_RINGBUF,
+	ENUM_KERNEL_RPC_PRIVATEINFO,
+	ENUM_KERNEL_RPC_RUN,
+	ENUM_KERNEL_RPC_PAUSE,
+	ENUM_KERNEL_RPC_SWITCH_FOCUS,
+	ENUM_KERNEL_RPC_MALLOC_ADDR,
+	ENUM_KERNEL_RPC_VOLUME_CONTROL,
+	ENUM_KERNEL_RPC_FLUSH,
+	ENUM_KERNEL_RPC_CONNECT,
+	ENUM_KERNEL_RPC_SETREFCLOCK,
+	ENUM_KERNEL_RPC_DAC_I2S_CONFIG,
+	ENUM_KERNEL_RPC_DAC_SPDIF_CONFIG,
+	ENUM_KERNEL_RPC_HDMI_OUT_EDID,
+	ENUM_KERNEL_RPC_HDMI_OUT_EDID2,
+	ENUM_KERNEL_RPC_HDMI_SET,
+	ENUM_KERNEL_RPC_HDMI_MUTE,
+	ENUM_KERNEL_RPC_ASK_DBG_MEM_ADDR,
+	ENUM_KERNEL_RPC_DESTROY,
+	ENUM_KERNEL_RPC_STOP,
+	ENUM_KERNEL_RPC_CHECK_READY,   // check if Audio get memory pool from AP
+	ENUM_KERNEL_RPC_GET_MUTE_N_VOLUME,	 // get mute and volume level
+	ENUM_KERNEL_RPC_EOS,
+	ENUM_KERNEL_RPC_ADC0_CONFIG,
+	ENUM_KERNEL_RPC_ADC1_CONFIG,
+	ENUM_KERNEL_RPC_ADC2_CONFIG,
+#if defined(AUDIO_TV_PLATFORM)
+	ENUM_KERNEL_RPC_BBADC_CONFIG,
+	ENUM_KERNEL_RPC_I2SI_CONFIG,
+	ENUM_KERNEL_RPC_SPDIFI_CONFIG,
+#endif // AUDIO_TV_PLATFORM
+	ENUM_KERNEL_RPC_HDMI_OUT_VSDB,
+	ENUM_VIDEO_KERNEL_RPC_CONFIG_TV_SYSTEM,
+	ENUM_VIDEO_KERNEL_RPC_CONFIG_HDMI_INFO_FRAME,
+	ENUM_VIDEO_KERNEL_RPC_QUERY_DISPLAY_WIN,
+	ENUM_VIDEO_KERNEL_RPC_PP_INIT_PIN,
+	ENUM_KERNEL_RPC_INIT_RINGBUF_AO,
+	ENUM_VIDEO_KERNEL_RPC_VOUT_EDID_DATA,
+	ENUM_KERNEL_RPC_AUDIO_POWER_SET,
+	ENUM_VIDEO_KERNEL_RPC_VOUT_VDAC_SET,
+	ENUM_VIDEO_KERNEL_RPC_QUERY_CONFIG_TV_SYSTEM
+} ENUM_AUDIO_KERNEL_RPC_CMD;
+
+
+/* Video */
+enum VO_HDMI_MODE {
+	VO_DVI_ON = 0,
+	VO_HDMI_ON = 1,
+	VO_HDMI_OFF = 2,
+	VO_MHL_ON = 3,
+	VO_MHL_OFF = 4,
+};
+
+enum VO_HDMI_OFF_MODE {
+	VO_HDMI_OFF_CLOCK_OFF = 0,
+	VO_HDMI_OFF_CLOCK_ON = 1,
+};
+
+enum VO_HDMI_AUDIO_SAMPLE_FREQ {
+	VO_HDMI_AUDIO_NULL = 0,
+	VO_HDMI_AUDIO_32K = 1,
+	VO_HDMI_AUDIO_44_1K = 2,
+	VO_HDMI_AUDIO_48K = 3,
+	VO_HDMI_AUDIO_88_2K = 4,
+	VO_HDMI_AUDIO_96K = 5,
+	VO_HDMI_AUDIO_176_4K = 6,
+	VO_HDMI_AUDIO_192K = 7,
+};
+
+enum VO_HDR_CTRL_MODE {
+	VO_HDR_CTRL_AUTO = 0,
+	VO_HDR_CTRL_DV_ON = 1,
+	VO_HDR_CTRL_SDR = 2,
+	VO_HDR_CTRL_HDR_GAMMA = 3,
+	VO_HDR_CTRL_PQHDR = 4,
+	VO_HDR_CTRL_FUTURE = 5,
+	VO_HDR_CTRL_INPUT = 6,
+	VO_HDR_CTRL_DV_LOW_LATENCY_12b_YUV422 = 7,
+	VO_HDR_CTRL_DV_LOW_LATENCY_10b_YUV444 = 8,
+	VO_HDR_CTRL_DV_LOW_LATENCY_10b_RGB444 = 9,
+	VO_HDR_CTRL_DV_LOW_LATENCY_12b_YUV444 = 10,
+	VO_HDR_CTRL_DV_LOW_LATENCY_12b_RGB444 = 11,
+	VO_HDR_CTRL_DV_ON_INPUT = 12,
+	VO_HDR_CTRL_DV_ON_LOW_LATENCY_12b422_INPUT = 13,
+};
+
+struct VIDEO_RPC_VOUT_CONFIG_HDMI_INFO_FRAME {
+	enum VO_HDMI_MODE hdmiMode;
+	enum VO_HDMI_AUDIO_SAMPLE_FREQ audioSampleFreq;
+	u_char audioChannelCount;
+	u_char dataByte1;
+	u_char dataByte2;
+	u_char dataByte3;
+	u_char dataByte4;
+	u_char dataByte5;
+	u_int dataInt0;
+	u_int hdmi2p0_feature;/* [Bit0]HDMI 2.0 [Bit1]Scramble */
+	enum VO_HDMI_OFF_MODE hdmi_off_mode;
+	enum VO_HDR_CTRL_MODE hdr_ctrl_mode;
+	u_int reserved4;
+};
+
+/**
+ * VO_INTERFACE_TYPE
+ * --------------------
+ *     | CVBS  HDMI  DP
+ * --------------------
+ * 0  |    O       O       X
+ * 1  |    O       X       X
+ * 2  |    X       O       X
+ * 3  |    X       X       O
+ * 4  |    X       O       O
+ * 5  |    U       O       O
+ * 6  |    O       X       O
+ * 7  |    O       O       O
+ * 8  |    U       O       X
+ * --------------------
+ * O: Enable, X: Disable, U: Enable or Disable
+ */
+enum VO_INTERFACE_TYPE {
+	VO_ANALOG_AND_DIGITAL = 0,
+	VO_ANALOG_ONLY = 1,
+	VO_DIGITAL_ONLY = 2,
+	VO_DISPLAY_PORT_ONLY = 3,
+	VO_HDMI_AND_DISPLAY_PORT_SAME_SOURCE = 4,
+	VO_HDMI_AND_DISPLAY_PORT_DIFF_SOURCE = 5,
+	VO_DISPLAY_PORT_AND_CVBS_SAME_SOURCE = 6,
+	VO_HDMI_AND_DP_DIFF_SOURCE_WITH_CVBS = 7,
+	VO_FORCE_DP_OFF = 8,
+};
+
+
+enum VO_PEDESTAL_TYPE {
+	VO_PEDESTAL_TYPE_300_700_ON = 0,
+	VO_PEDESTAL_TYPE_300_700_OFF = 1,
+	VO_PEDESTAL_TYPE_286_714_ON = 2,
+	VO_PEDESTAL_TYPE_286_714_OFF = 3,
+};
+
+
+enum VO_STANDARD {
+	VO_STANDARD_NTSC_M = 0,
+	VO_STANDARD_NTSC_J = 1,
+	VO_STANDARD_NTSC_443 = 2,
+	VO_STANDARD_PAL_B = 3,
+	VO_STANDARD_PAL_D = 4,
+	VO_STANDARD_PAL_G = 5,
+	VO_STANDARD_PAL_H = 6,
+	VO_STANDARD_PAL_I = 7,
+	VO_STANDARD_PAL_N = 8,
+	VO_STANDARD_PAL_NC = 9,
+	VO_STANDARD_PAL_M = 10,
+	VO_STANDARD_PAL_60 = 11,
+	VO_STANDARD_SECAM = 12,
+	VO_STANDARD_HDTV_720P_60 = 13,
+	VO_STANDARD_HDTV_720P_50 = 14,
+	VO_STANDARD_HDTV_720P_30 = 15,
+	VO_STANDARD_HDTV_720P_25 = 16,
+	VO_STANDARD_HDTV_720P_24 = 17,
+	VO_STANDARD_HDTV_1080I_60 = 18,
+	VO_STANDARD_HDTV_1080I_50 = 19,
+	VO_STANDARD_HDTV_1080P_30 = 20,
+	VO_STANDARD_HDTV_1080P_25 = 21,
+	VO_STANDARD_HDTV_1080P_24 = 22,
+	VO_STANDARD_VGA = 23,
+	VO_STANDARD_SVGA = 24,
+	VO_STANDARD_HDTV_1080P_60 = 25,
+	VO_STANDARD_HDTV_1080P_50 = 26,
+	VO_STANDARD_HDTV_1080I_59 = 27,
+	VO_STANDARD_HDTV_720P_59 = 28,
+	VO_STANDARD_HDTV_1080P_23 = 29,
+	VO_STANDARD_HDTV_1080P_59 = 30,
+	VO_STANDARD_HDTV_1080P_60_3D = 31,
+	VO_STANDARD_HDTV_1080P_50_3D = 32,
+	VO_STANDARD_HDTV_1080P_30_3D = 33,
+	VO_STANDARD_HDTV_1080P_24_3D = 34,
+	VO_STANDARD_HDTV_720P_60_3D = 35,
+	VO_STANDARD_HDTV_720P_50_3D = 36,
+	VO_STANDARD_HDTV_720P_30_3D = 37,
+	VO_STANDARD_HDTV_720P_24_3D = 38,
+	VO_STANDARD_HDTV_720P_59_3D = 39,
+	VO_STANDARD_HDTV_1080I_60_3D = 40,
+	VO_STANDARD_HDTV_1080I_59_3D = 41,
+	VO_STANDARD_HDTV_1080I_50_3D = 42,
+	VO_STANDARD_HDTV_1080P_23_3D = 43,
+	VO_STANDARD_HDTV_2160P_30 = 44,
+	VO_STANDARD_HDTV_2160P_29 = 45,
+	VO_STANDARD_HDTV_2160P_25 = 46,
+	VO_STANDARD_HDTV_2160P_24 = 47,
+	VO_STANDARD_HDTV_2160P_23 = 48,
+	VO_STANDARD_HDTV_4096_2160P_24 = 49,
+	VO_STANDARD_HDTV_2160P_60 = 50,
+	VO_STANDARD_HDTV_2160P_50 = 51,
+	VO_STANDARD_HDTV_4096_2160P_25 = 52,
+	VO_STANDARD_HDTV_4096_2160P_30 = 53,
+	VO_STANDARD_HDTV_4096_2160P_50 = 54,
+	VO_STANDARD_HDTV_4096_2160P_60 = 55,
+	VO_STANDARD_HDTV_2160P_60_420 = 56,
+	VO_STANDARD_HDTV_2160P_50_420 = 57,
+	VO_STANDARD_HDTV_4096_2160P_60_420 = 58,
+	VO_STANDARD_HDTV_4096_2160P_50_420 = 59,
+	VO_STANDARD_DP_FORMAT_1920_1080P_60 = 60,
+	VO_STANDARD_DP_FORMAT_2160P_30 = 61,
+	VO_STANDARD_HDTV_2160P_24_3D = 62,
+	VO_STANDARD_HDTV_2160P_23_3D = 63,
+	VO_STANDARD_HDTV_2160P_59 = 64,
+	VO_STANDARD_HDTV_2160P_59_420 = 65,
+	VO_STANDARD_HDTV_2160P_25_3D = 66,
+	VO_STANDARD_HDTV_2160P_30_3D = 67,
+	VO_STANDARD_HDTV_2160P_50_3D = 68,
+	VO_STANDARD_HDTV_2160P_60_3D = 69,
+	VO_STANDARD_HDTV_4096_2160P_24_3D = 70,
+	VO_STANDARD_HDTV_4096_2160P_25_3D = 71,
+	VO_STANDARD_HDTV_4096_2160P_30_3D = 72,
+	VO_STANDARD_HDTV_4096_2160P_50_3D = 73,
+	VO_STANDARD_HDTV_4096_2160P_60_3D = 74,
+	VO_STANDARD_DP_FORMAT_1280_720P_60 = 75,
+	VO_STANDARD_DP_FORMAT_3840_2160P_60 = 76,
+	VO_STANDARD_DP_FORMAT_1024_768P_60 = 77,
+	VO_STANDARD_HDTV_2160P_50_422_12bit = 78,
+	VO_STANDARD_HDTV_2160P_60_422_12bit = 79,
+	VO_STANDARD_ERROR = 80,
+};
+
+
+struct VIDEO_RPC_VOUT_CONFIG_VIDEO_STANDARD {
+	enum VO_STANDARD standard;
+	u_char enProg;
+	u_char enDIF;
+	u_char enCompRGB;
+	enum VO_PEDESTAL_TYPE pedType;
+	u_int dataInt0;
+	u_int dataInt1;
+};
+
+
+struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM {
+	enum VO_INTERFACE_TYPE interfaceType;
+	struct VIDEO_RPC_VOUT_CONFIG_VIDEO_STANDARD videoInfo;
+	struct VIDEO_RPC_VOUT_CONFIG_HDMI_INFO_FRAME hdmiInfo;
+};
+
+
+struct AUDIO_HDMI_OUT_EDID_DATA2 {
+	u_int Version;
+	u_int HDMI_output_enable;
+	u_int EDID_DATA_addr;
+};
+
+
+enum VO_VIDEO_PLANE {
+	VO_VIDEO_PLANE_V1 = 0,
+	VO_VIDEO_PLANE_V2 = 1,
+	VO_VIDEO_PLANE_SUB1 = 2,
+	VO_VIDEO_PLANE_OSD1 = 3,
+	VO_VIDEO_PLANE_OSD2 = 4,
+	VO_VIDEO_PLANE_WIN1 = 5,
+	VO_VIDEO_PLANE_WIN2 = 6,
+	VO_VIDEO_PLANE_WIN3 = 7,
+	VO_VIDEO_PLANE_WIN4 = 8,
+	VO_VIDEO_PLANE_WIN5 = 9,
+	VO_VIDEO_PLANE_WIN6 = 10,
+	VO_VIDEO_PLANE_WIN7 = 11,
+	VO_VIDEO_PLANE_WIN8 = 12,
+	VO_VIDEO_PLANE_NONE = 255,
+};
+
+
+enum VO_OSD_COLOR_FORMAT {
+	VO_OSD_COLOR_FORMAT_2BIT = 0,
+	VO_OSD_COLOR_FORMAT_4BIT = 1,
+	VO_OSD_COLOR_FORMAT_8BIT = 2,
+	VO_OSD_COLOR_FORMAT_RGB332 = 3,
+	VO_OSD_COLOR_FORMAT_RGB565 = 4,
+	VO_OSD_COLOR_FORMAT_ARGB1555 = 5,
+	VO_OSD_COLOR_FORMAT_ARGB4444 = 6,
+	VO_OSD_COLOR_FORMAT_ARGB8888 = 7,
+	VO_OSD_COLOR_FORMAT_Reserved0 = 8,
+	VO_OSD_COLOR_FORMAT_Reserved1 = 9,
+	VO_OSD_COLOR_FORMAT_Reserved2 = 10,
+	VO_OSD_COLOR_FORMAT_YCBCRA4444 = 11,
+	VO_OSD_COLOR_FORMAT_YCBCRA8888 = 12,
+	VO_OSD_COLOR_FORMAT_RGBA5551 = 13,
+	VO_OSD_COLOR_FORMAT_RGBA4444 = 14,
+	VO_OSD_COLOR_FORMAT_RGBA8888 = 15,
+	VO_OSD_COLOR_FORMAT_420 = 16,
+	VO_OSD_COLOR_FORMAT_422 = 17,
+	VO_OSD_COLOR_FORMAT_RGB323 = 18,
+	VO_OSD_COLOR_FORMAT_RGB233 = 19,
+	VO_OSD_COLOR_FORMAT_RGB556 = 20,
+	VO_OSD_COLOR_FORMAT_RGB655 = 21,
+	VO_OSD_COLOR_FORMAT_RGB888 = 22,
+	VO_OSD_COLOR_FORMAT_RGB565_LITTLE = 36,
+	VO_OSD_COLOR_FORMAT_ARGB1555_LITTLE = 37,
+	VO_OSD_COLOR_FORMAT_ARGB4444_LITTLE = 38,
+	VO_OSD_COLOR_FORMAT_ARGB8888_LITTLE = 39,
+	VO_OSD_COLOR_FORMAT_YCBCRA4444_LITTLE = 43,
+	VO_OSD_COLOR_FORMAT_YCBCRA8888_LITTLE = 44,
+	VO_OSD_COLOR_FORMAT_RGBA5551_LITTLE = 45,
+	VO_OSD_COLOR_FORMAT_RGBA4444_LITTLE = 46,
+	VO_OSD_COLOR_FORMAT_RGBA8888_LITTLE = 47,
+	VO_OSD_COLOR_FORMAT_RGB556_LITTLE = 52,
+	VO_OSD_COLOR_FORMAT_RGB655_LITTLE = 53,
+	VO_OSD_COLOR_FORMAT_RGB888_LITTLE = 54,
+};
+
+
+enum VO_OSD_RGB_ORDER {
+	VO_OSD_COLOR_RGB = 0,
+	VO_OSD_COLOR_BGR = 1,
+	VO_OSD_COLOR_GRB = 2,
+	VO_OSD_COLOR_GBR = 3,
+	VO_OSD_COLOR_RBG = 4,
+	VO_OSD_COLOR_BRG = 5,
+};
+
+
+enum VO_3D_MODE_TYPE {
+	VO_2D_MODE = 0,
+	VO_3D_SIDE_BY_SIDE_HALF = 1,
+	VO_3D_TOP_AND_BOTTOM = 2,
+	VO_3D_FRAME_PACKING = 3,
+};
+
+
+struct VIDEO_RPC_VOUT_QUERY_DISP_WIN_IN {
+	enum VO_VIDEO_PLANE plane;
+};
+
+
+struct VO_RECTANGLE {
+	short x;
+	short y;
+	u_short width;
+	u_short height;
+};
+
+
+struct VO_SIZE {
+	u_short w;
+	u_short h;
+};
+
+
+struct VIDEO_RPC_VOUT_QUERY_DISP_WIN_OUT {
+	short result;
+	enum VO_VIDEO_PLANE plane;
+	u_short numWin;
+	u_short zOrder;
+	struct VO_RECTANGLE configWin;
+	struct VO_RECTANGLE contentWin;
+	short deintMode;
+	u_short pitch;
+	enum VO_OSD_COLOR_FORMAT colorType;
+	enum VO_OSD_RGB_ORDER RGBOrder;
+	enum VO_3D_MODE_TYPE format3D;
+	struct VO_SIZE mix1_size;
+	enum VO_STANDARD standard;
+	u_char enProg;
+	u_char reserved1;
+	u_short reserved2;
+	u_int reserved3;
+};
+
+struct VIDEO_RPC_VOUT_EDID_DATA {
+	/* HDR metadata */
+	u_char et;
+	u_char sm;
+	u_char max_luminace;
+	u_char max_frame_avg;
+	u_char min_luminace;
+	/* Color characteristics */
+	u_char red_green_lo;
+	u_char black_white_lo;
+	u_char red_x;
+	u_char red_y;
+	u_char green_x;
+	u_char green_y;
+	u_char blue_x;
+	u_char blue_y;
+	u_char white_x;
+	u_char white_y;
+	/* Colorimetry Data */
+	u_char color_space;
+	/* Video Capability Data Block */
+	u_char vcdb;/* Bit7:QY,Bit6:QS */
+	/* HDR metadata length */
+	u_char metadata_len;
+	/* Dolby Vision data length */
+	u_char dolby_len;
+	/* Dolby Vision VSVDB additional payload */
+	u_char dolby_data[22];
+	/* HDR10+ support */
+	u_char hdr10_plus;
+	/* Reserved */
+	u_char reserved[6];
+};
+
+
+#endif//_HDMITX_RPC_H_
+
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx_scdc.c b/drivers/media/platform/rtk_hdmitx/hdmitx_scdc.c
new file mode 100644
index 00000000..f61ddaa
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx_scdc.c
@@ -0,0 +1,372 @@
+/*
+ * hdmitx_scdc.c - RTK hdmitx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/i2c.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/interrupt.h>
+
+#include "hdmitx_scdc.h"
+#include "hdmitx.h"
+#include "hdmitx_dev.h"
+#include "hdmitx_rpc.h"
+#include "rtk_edid.h"
+
+
+static struct hdmitx_scdc_data tx_scdc;
+
+void hdmitx_scdc_work_func(struct work_struct *work);
+
+int hdmitx_write_scdc_port(unsigned char offset, unsigned char value)
+{
+	struct i2c_adapter *p_adap;
+	unsigned char bus_id = 1;
+	unsigned char data[2];
+	struct i2c_msg msgs;
+
+	data[0] = offset;
+	data[1] = value;
+
+	msgs.addr = SCDC_I2C_ADDR;
+	msgs.flags = 0;
+	msgs.len = 2;
+	msgs.buf = data;
+
+	p_adap = i2c_get_adapter(bus_id);
+	if (p_adap == NULL) {
+		HDMI_ERROR("[%s] get i2c adapter %d failed\n", __func__, bus_id);
+		goto scdc_write_fal;
+	}
+
+	if (i2c_transfer(p_adap, &msgs, 1) != 1) {
+		HDMI_ERROR("Write SCDC port fail, offset(0x%02x) value(0x%02x)", offset, value);
+		goto scdc_write_fal;
+	} else {
+		HDMI_DEBUG("Write SCDC port, offset(0x%02x) value(0x%02x)", offset, value);
+	}
+
+	return SCDC_I2C_OK;
+scdc_write_fal:
+	return SCDC_I2C_FAIL;
+}
+
+int hdmitx_read_scdc_port(unsigned char offset, unsigned char *buf, unsigned char len)
+{
+	struct i2c_adapter *p_adap;
+	unsigned char bus_id = 1;
+	unsigned char data;
+	struct i2c_msg msgs[2];
+
+	data = offset;
+
+	msgs[0].addr = SCDC_I2C_ADDR;
+	msgs[0].flags = 0;
+	msgs[0].len = 1;
+	msgs[0].buf = &data;
+
+	msgs[1].addr = SCDC_I2C_ADDR;
+	msgs[1].flags = I2C_M_RD;
+	msgs[1].len = len;
+	msgs[1].buf = buf;
+
+
+	p_adap = i2c_get_adapter(bus_id);
+	if (p_adap == NULL) {
+		HDMI_ERROR("[%s] get i2c adapter %d failed\n", __func__, bus_id);
+		goto scdc_read_fail;
+	}
+
+	if (i2c_transfer(p_adap, &msgs[0], 2) != 2) {
+		HDMI_ERROR("Read SCDC port fail, offset(0x%02x) len(%u)",
+			offset, len);
+		goto scdc_read_fail;
+	} else {
+		HDMI_DEBUG("Read SCDC port, offset(0x%02x) len(%u)",
+			offset, len);
+	}
+
+	return SCDC_I2C_OK;
+scdc_read_fail:
+	return SCDC_I2C_FAIL;
+}
+
+/**
+ * hdmitx_send_scdc_TmdsConfig - SCDC TMDS Configuration
+ * @standard: VO_STANDARD
+ * @dataInt0:  VIDEO_RPC_VOUT_CONFIG_HDMI_INFO_FRAME dataInt0
+ * @data_byte1: VIDEO_RPC_VOUT_CONFIG_HDMI_INFO_FRAME dataByte1
+ *
+ * Return: SCDC TMDS_Config value
+ */
+unsigned char hdmitx_send_scdc_TmdsConfig(unsigned int standard,
+	unsigned int dataInt0, unsigned char data_byte1)
+{
+	unsigned char config_data;
+	unsigned char color;
+	unsigned char deep_color;
+	unsigned char depp_depth;
+	unsigned char format_3D;
+	int ret_val;
+
+	color = data_byte1>>5;
+
+	deep_color = (dataInt0>>1)&0x1;
+	depp_depth = (dataInt0>>2)&0xF;
+	format_3D = (dataInt0>>8)&0xF;
+
+	if ((depp_depth != 5) && (depp_depth != 6))
+		deep_color = 0;
+
+	switch (standard) {
+	/* Scramble, 1/40 data rate */
+	case VO_STANDARD_HDTV_2160P_50:
+	case VO_STANDARD_HDTV_2160P_50_422_12bit:
+	case VO_STANDARD_HDTV_2160P_59:
+	case VO_STANDARD_HDTV_2160P_60:
+	case VO_STANDARD_HDTV_2160P_60_422_12bit:
+	case VO_STANDARD_HDTV_4096_2160P_50:
+	case VO_STANDARD_HDTV_4096_2160P_60:
+		config_data = 0x3;
+
+		break;
+	/* Scramble, 1/40 data rate */
+	case VO_STANDARD_HDTV_2160P_23:
+	case VO_STANDARD_HDTV_2160P_24:
+	case VO_STANDARD_HDTV_2160P_25:
+	case VO_STANDARD_HDTV_2160P_29:
+	case VO_STANDARD_HDTV_2160P_30:
+	case VO_STANDARD_HDTV_4096_2160P_24:
+	case VO_STANDARD_HDTV_4096_2160P_25:
+	case VO_STANDARD_HDTV_4096_2160P_30:
+		if (color == COLOR_YUV422)
+			config_data = 0x0;
+		else if (deep_color)
+			config_data = 0x3;
+		else
+			config_data = 0x0;
+
+		break;
+	/* Depends on 340M_SCRAMBLE support */
+	case VO_STANDARD_HDTV_2160P_50_420:
+	case VO_STANDARD_HDTV_2160P_59_420:
+	case VO_STANDARD_HDTV_2160P_60_420:
+	case VO_STANDARD_HDTV_4096_2160P_50_420:
+	case VO_STANDARD_HDTV_4096_2160P_60_420:
+		if (deep_color)
+			config_data = 0x3;
+		else if (hdmitx_edid_info.scdc_capable&SCDC_340M_SCRAMBLE)
+			config_data = 0x1;// Scramble, 1/10
+		else
+			config_data = 0x0;
+
+		break;
+	/* 3D frame packing, pixel freq*2 */
+	case VO_STANDARD_HDTV_2160P_23_3D:
+	case VO_STANDARD_HDTV_2160P_24_3D:
+	case VO_STANDARD_HDTV_2160P_25_3D:
+	case VO_STANDARD_HDTV_2160P_30_3D:
+	case VO_STANDARD_HDTV_2160P_50_3D:
+	case VO_STANDARD_HDTV_2160P_60_3D:
+	case VO_STANDARD_HDTV_4096_2160P_24_3D:
+	case VO_STANDARD_HDTV_4096_2160P_25_3D:
+	case VO_STANDARD_HDTV_4096_2160P_30_3D:
+	case VO_STANDARD_HDTV_4096_2160P_50_3D:
+	case VO_STANDARD_HDTV_4096_2160P_60_3D:
+		switch (format_3D) {
+		case 0:/* Auto(Frame packing) */
+		case 1:/* Frame packing */
+			if ((standard == VO_STANDARD_HDTV_2160P_50_3D) ||
+				(standard == VO_STANDARD_HDTV_2160P_60_3D) ||
+				(standard == VO_STANDARD_HDTV_4096_2160P_50_3D) ||
+				(standard == VO_STANDARD_HDTV_4096_2160P_60_3D))
+				HDMI_ERROR("4KP50/60 NOT support 3D Frame packing");
+
+			format_3D = 1;
+			config_data = 0x3;
+			break;
+		case 2:/* Side by side half */
+		case 3:/* Top and buttom */
+			if (deep_color)
+				config_data = 0x3;
+			else
+				config_data = 0x0;
+			break;
+		default:
+			config_data = 0x0;
+			HDMI_ERROR("Unknow 3D format");
+		} /* end of switch (format_3D) */
+		break;
+	/* No Scramble, 1/10 data rate */
+	default:
+		config_data = 0x0;
+	} /* end of switch (standard)*/
+
+	if (hdmitx_edid_info.scdc_capable&SCDC_PRESENT) {
+		hdmitx_write_scdc_port(SCDCS_TMDS_Config, config_data);
+		HDMI_INFO("Send SCDC TMDS_Config(0x%02x), deep_color(%u) 3D(%u)",
+			config_data, deep_color, format_3D);
+	} else if (config_data != 0) {
+		HDMI_ERROR("Sink not support SCDC_PRESENT, but need scramble");
+		ret_val = hdmitx_write_scdc_port(SCDCS_TMDS_Config, config_data);
+		if (ret_val == SCDC_I2C_OK)
+			hdmitx_edid_info.scdc_capable |= SCDC_PRESENT;
+		HDMI_INFO("Send SCDC TMDS_Config(0x%02x), deep_color(%u) 3D(%u)",
+			config_data, deep_color, format_3D);
+	} else if ((standard >= VO_STANDARD_HDTV_2160P_60_420) &&
+		(standard <= VO_STANDARD_HDTV_4096_2160P_50_420)) {
+		/* 4K YUV420 */
+		HDMI_ERROR("Sink not support SCDC_PRESENT, but YUV420 format should need");
+		ret_val = hdmitx_write_scdc_port(SCDCS_TMDS_Config, config_data);
+		if (ret_val == SCDC_I2C_OK)
+			hdmitx_edid_info.scdc_capable |= SCDC_PRESENT;
+		HDMI_INFO("Send SCDC TMDS_Config(0x%02x), deep_color(%u) 3D(%u)",
+			config_data, deep_color, format_3D);
+	}
+
+	return config_data;
+}
+
+void hdmitx_scdc_work_func(struct work_struct *work)
+{
+	unsigned char update_flags[2], status_flags[2], err_det[7];
+	unsigned int i;
+	unsigned int sum = 0;
+
+	if (hdmitx_read_scdc_port(SCDCS_Update_0, update_flags, 2))
+		return;
+
+	HDMI_DEBUG("SCDC: Update(0x%02x)", update_flags[0]);
+
+	/* Status_Update */
+	if (update_flags[0]&0x1) {
+		hdmitx_read_scdc_port(SCDCS_Status_Flag_0, status_flags, 2);
+		HDMI_DEBUG("SCDC: Status(0x%02x)", status_flags[0]);
+	}
+
+	/* CED_Update */
+	if (update_flags[0]&0x2) {
+		hdmitx_read_scdc_port(SCDCS_Err_Det_0_L, err_det, 7);
+
+		for (i = 0; i < 6; i++)
+			sum += err_det[i];
+
+		sum = (0x100-(sum&0xFF))&0xFF;
+
+		if (sum != err_det[6])
+			HDMI_ERROR("Wrong CED checksum");
+		else
+			HDMI_DEBUG("SCDC: CED checksum ok");
+	}
+
+	/* Write clear */
+	hdmitx_write_scdc_port(SCDCS_Update_0, update_flags[0]);
+}
+
+
+static irqreturn_t hdmitx_scdc_isr(int irq, void *dev_id)
+{
+	HDMI_DEBUG("Get SCDC read request");
+	schedule_work(&tx_scdc.rr_work);
+	return IRQ_HANDLED;
+}
+
+void enable_hdmitx_scdcrr(unsigned char enable)
+{
+	if (!tx_scdc.enable_rr)
+		return;
+
+	HDMI_INFO("%s SCDC read request", enable?"Enable":"Disable");
+
+	if ((!tx_scdc.i2c1_req_reg) || (!tx_scdc.dev_nd)) {
+		HDMI_ERROR("[%s] No control reg or no device node\n", __func__);
+		return;
+	}
+
+	if (enable) {
+		wr_reg(tx_scdc.i2c1_req_reg, 0x3);
+		hdmitx_write_scdc_port(SCDCS_Config_0, 0x1);/* Send RR_Enable */
+	} else {
+		wr_reg(tx_scdc.i2c1_req_reg, 0x0);
+	}
+}
+
+void register_hdmitx_scdcrr(struct device_node *dev)
+{
+	int ret_value;
+
+	HDMI_INFO("[%s]", __func__);
+
+	memset(&tx_scdc, 0x0, sizeof(tx_scdc));
+
+	tx_scdc.i2c1_req_reg = of_iomap(dev, 1);
+
+	if (tx_scdc.i2c1_req_reg == NULL) {
+		HDMI_ERROR("[%s] Unable to map I2C1_REQ registers\n", __func__);
+		return;
+	}
+
+	/* Default disable SCDC read request function for CTS 8-9 */
+	wr_reg(tx_scdc.i2c1_req_reg, 0x0);
+
+	/* Get SCDC read request device node */
+	tx_scdc.dev_nd = of_get_child_by_name(dev, "scdc_rr");
+	if (!tx_scdc.dev_nd) {
+		HDMI_ERROR("[%s] Get SCDC read request node fail!\n", __func__);
+		return;
+	}
+
+	ret_value = of_property_read_u32(tx_scdc.dev_nd, "enable-scdc-rr",
+		&tx_scdc.enable_rr);
+	if (ret_value)
+		tx_scdc.enable_rr = 0;
+
+	if (!tx_scdc.enable_rr) {
+		HDMI_INFO("Skip SCDC RR init");
+		return;
+	}
+
+	/* Init interrupt work function */
+	INIT_WORK(&tx_scdc.rr_work, hdmitx_scdc_work_func);
+
+	/* Register read request interrupt */
+	tx_scdc.i2c1_irq = irq_of_parse_and_map(tx_scdc.dev_nd, 0);
+	ret_value = request_irq(tx_scdc.i2c1_irq, hdmitx_scdc_isr,
+		IRQF_SHARED, "hdmitx_scdc", tx_scdc.dev_nd);
+	if (ret_value)
+		HDMI_ERROR("[%s] Request irq fail\n", __func__);
+
+}
+
+void hdmitx_scdcrr_suspend(void)
+{
+	if (!tx_scdc.enable_rr)
+		return;
+
+	enable_hdmitx_scdcrr(0);
+	free_irq(tx_scdc.i2c1_irq, tx_scdc.dev_nd);
+	cancel_work_sync(&tx_scdc.rr_work);
+}
+
+void hdmitx_scdcrr_resume(void)
+{
+	int ret_value;
+
+	if (!tx_scdc.enable_rr)
+		return;
+
+	/* Register read request interrupt */
+	ret_value = request_irq(tx_scdc.i2c1_irq, hdmitx_scdc_isr,
+		IRQF_SHARED, "hdmitx_scdc", tx_scdc.dev_nd);
+	if (ret_value)
+		HDMI_ERROR("[%s] Request irq fail\n", __func__);
+
+}
+
diff --git a/drivers/media/platform/rtk_hdmitx/hdmitx_scdc.h b/drivers/media/platform/rtk_hdmitx/hdmitx_scdc.h
new file mode 100644
index 00000000..7c45a01
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/hdmitx_scdc.h
@@ -0,0 +1,59 @@
+/*
+ * hdmitx_scdc.h - RTK hdmitx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _HDMITX_SCDC_H_
+#define _HDMITX_SCDC_H_
+
+#define SCDC_I2C_ADDR	0x54
+
+#define SCDC_I2C_OK		0
+#define SCDC_I2C_FAIL	1
+
+/* Status and Control Data Channel Structure */
+#define SCDCS_Update_0		0x10
+#define SCDCS_Update_1		0x11
+#define SCDCS_TMDS_Config	0x20
+#define SCDCS_Config_0		0x30
+#define SCDCS_Status_Flag_0	0x40
+#define SCDCS_Status_Flag_1	0x41
+#define SCDCS_Err_Det_0_L	0x50
+#define SCDCS_Err_Det_0_H	0x51
+#define SCDCS_Err_Det_1_L	0x52
+#define SCDCS_Err_Det_1_H	0x53
+#define SCDCS_Err_Det_2_L	0x54
+#define SCDCS_Err_Det_2_H	0x55
+#define SCDCS_Err_Det_sum	0x56
+#define SCDCS_Test_Config_0	0xC0
+
+/**
+ * struct hdmitx_scdc_data
+ * @*dev_nd: scdc_rr node
+ * @enable_rr: flag of enable SCDC read request function
+ * @i2c1_req_reg: I2C1 read request control registers
+ * @i2c1_irq: I2C1 read request interrupt number
+ * @rr_work: struct work_struct
+ */
+struct hdmitx_scdc_data {
+	struct device_node *dev_nd;
+	unsigned int enable_rr;
+	void __iomem *i2c1_req_reg;
+	unsigned int i2c1_irq;
+	struct work_struct rr_work;
+};
+
+unsigned char hdmitx_send_scdc_TmdsConfig(unsigned int standard,
+	unsigned int dataInt0, unsigned char data_byte1);
+void enable_hdmitx_scdcrr(unsigned char enable);
+void register_hdmitx_scdcrr(struct device_node *dev);
+void hdmitx_scdcrr_suspend(void);
+void hdmitx_scdcrr_resume(void);
+
+#endif /* _HDMITX_SCDC_H_ */
diff --git a/drivers/media/platform/rtk_hdmitx/rtk_edid.c b/drivers/media/platform/rtk_hdmitx/rtk_edid.c
new file mode 100644
index 00000000..60c8b0a
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/rtk_edid.c
@@ -0,0 +1,2290 @@
+/*
+ * rtk_edid.c - RTK hdmitx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * Based on linux/drivers/gpu/drm/drm_edid.c
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/kernel.h>
+#include <linux/slab.h>
+#include <linux/i2c.h>
+#include <linux/delay.h>
+#include <sound/pcm.h>
+#include <drm/drm_edid.h>
+#include <drm/drm_crtc.h>
+
+#include "rtk_edid.h"
+#include "hdmitx.h"
+#include "hdmitx_api.h"
+#include "hdmitx_rpc.h"
+
+#define EDID_EST_TIMINGS 16
+#define EDID_STD_TIMINGS 8
+#define EDID_DETAILED_TIMINGS 4
+
+struct edid_information hdmitx_edid_info;
+
+static const char default_edid[] = {/* 1080P */
+	0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x4A, 0x8B, 0x95, 0x12, 0x00, 0x00, 0x00, 0x00,
+	0xFF, 0x1A, 0x01, 0x03, 0x81, 0x46, 0x27, 0x78, 0x8A, 0xA5, 0x8E, 0xA6, 0x54, 0x4A, 0x9C, 0x26,
+	0x12, 0x45, 0x46, 0x21, 0x08, 0x00, 0xD1, 0xC0, 0x81, 0xC0, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
+	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x02, 0x3A, 0x80, 0x18, 0x71, 0x38, 0x2D, 0x40, 0x58, 0x2C,
+	0x45, 0x00, 0x20, 0xC2, 0x31, 0x00, 0x00, 0x1E, 0x01, 0x1D, 0x00, 0x72, 0x51, 0xD0, 0x1E, 0x20,
+	0x6E, 0x28, 0x55, 0x00, 0x20, 0xC2, 0x31, 0x00, 0x00, 0x1E, 0x00, 0x00, 0x00, 0xFD, 0x00, 0x32,
+	0x4B, 0x18, 0x3C, 0x0B, 0x00, 0x0A, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x00, 0x00, 0x00, 0xFC,
+	0x00, 0x52, 0x54, 0x44, 0x31, 0x32, 0x39, 0x35, 0x0A, 0x20, 0x20, 0x20, 0x20, 0x20, 0x01, 0xAC,
+	0x02, 0x03, 0x20, 0x71, 0x83, 0x01, 0x00, 0x00, 0x67, 0x03, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x3C,
+	0x47, 0x90, 0x1F, 0x05, 0x14, 0x04, 0x11, 0x02, 0x23, 0x09, 0x7F, 0x07, 0xE3, 0x05, 0x03, 0x00,
+	0x02, 0x3A, 0x80, 0x18, 0x71, 0x38, 0x2D, 0x40, 0x58, 0x2C, 0x45, 0x00, 0x20, 0xC2, 0x31, 0x00,
+	0x00, 0x1E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7D
+};
+
+
+static const struct drm_display_mode edid_est_modes[] = {
+	{ DRM_MODE("800x600", DRM_MODE_TYPE_DRIVER, 40000, 800, 840,
+		   968, 1056, 0, 600, 601, 605, 628, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC) }, /* 800x600@60Hz */
+	{ DRM_MODE("800x600", DRM_MODE_TYPE_DRIVER, 36000, 800, 824,
+		   896, 1024, 0, 600, 601, 603,  625, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC) }, /* 800x600@56Hz */
+	{ DRM_MODE("640x480", DRM_MODE_TYPE_DRIVER, 31500, 640, 656,
+		   720, 840, 0, 480, 481, 484, 500, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC) }, /* 640x480@75Hz */
+	{ DRM_MODE("640x480", DRM_MODE_TYPE_DRIVER, 31500, 640, 664,
+		   704,  832, 0, 480, 489, 491, 520, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC) }, /* 640x480@72Hz */
+	{ DRM_MODE("640x480", DRM_MODE_TYPE_DRIVER, 30240, 640, 704,
+		   768,  864, 0, 480, 483, 486, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC) }, /* 640x480@67Hz */
+	{ DRM_MODE("640x480", DRM_MODE_TYPE_DRIVER, 25200, 640, 656,
+		   752, 800, 0, 480, 490, 492, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC) }, /* 640x480@60Hz */
+	{ DRM_MODE("720x400", DRM_MODE_TYPE_DRIVER, 35500, 720, 738,
+		   846, 900, 0, 400, 421, 423,  449, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC) }, /* 720x400@88Hz */
+	{ DRM_MODE("720x400", DRM_MODE_TYPE_DRIVER, 28320, 720, 738,
+		   846,  900, 0, 400, 412, 414, 449, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_PVSYNC) }, /* 720x400@70Hz */
+	{ DRM_MODE("1280x1024", DRM_MODE_TYPE_DRIVER, 135000, 1280, 1296,
+		   1440, 1688, 0, 1024, 1025, 1028, 1066, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC) }, /* 1280x1024@75Hz */
+	{ DRM_MODE("1024x768", DRM_MODE_TYPE_DRIVER, 78800, 1024, 1040,
+		   1136, 1312, 0,  768, 769, 772, 800, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC) }, /* 1024x768@75Hz */
+	{ DRM_MODE("1024x768", DRM_MODE_TYPE_DRIVER, 75000, 1024, 1048,
+		   1184, 1328, 0,  768, 771, 777, 806, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC) }, /* 1024x768@70Hz */
+	{ DRM_MODE("1024x768", DRM_MODE_TYPE_DRIVER, 65000, 1024, 1048,
+		   1184, 1344, 0,  768, 771, 777, 806, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC) }, /* 1024x768@60Hz */
+	{ DRM_MODE("1024x768i", DRM_MODE_TYPE_DRIVER, 44900, 1024, 1032,
+		   1208, 1264, 0, 768, 768, 776, 817, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC | DRM_MODE_FLAG_INTERLACE) }, /* 1024x768@43Hz */
+	{ DRM_MODE("832x624", DRM_MODE_TYPE_DRIVER, 57284, 832, 864,
+		   928, 1152, 0, 624, 625, 628, 667, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC) }, /* 832x624@75Hz */
+	{ DRM_MODE("800x600", DRM_MODE_TYPE_DRIVER, 49500, 800, 816,
+		   896, 1056, 0, 600, 601, 604,  625, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC) }, /* 800x600@75Hz */
+	{ DRM_MODE("800x600", DRM_MODE_TYPE_DRIVER, 50000, 800, 856,
+		   976, 1040, 0, 600, 637, 643, 666, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC) }, /* 800x600@72Hz */
+	{ DRM_MODE("1152x864", DRM_MODE_TYPE_DRIVER, 108000, 1152, 1216,
+		   1344, 1600, 0,  864, 865, 868, 900, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC) }, /* 1152x864@75Hz */
+};
+
+/*
+ * Probably taken from CEA-861 spec.
+ * This table is converted from xorg's hw/xfree86/modes/xf86EdidModes.c.
+ */
+static const struct drm_display_mode edid_cea_modes[] = {
+	/* 1 - 640x480@60Hz */
+	{ DRM_MODE("640x480", DRM_MODE_TYPE_DRIVER, 25175, 640, 656,
+		   752, 800, 0, 480, 490, 492, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 2 - 720x480@60Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 27000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 3 - 720x480@60Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 27000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 4 - 1280x720@60Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 1390,
+		   1430, 1650, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 60, },
+	/* 5 - 1920x1080i@60Hz */
+	{ DRM_MODE("1920x1080i", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 60, },
+	/* 6 - 1440x480i@60Hz */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 60, },
+	/* 7 - 1440x480i@60Hz */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 60, },
+	/* 8 - 1440x240@60Hz */
+	{ DRM_MODE("1440x240", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1478,
+		   1602, 1716, 0, 240, 244, 247, 262, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 60, },
+	/* 9 - 1440x240@60Hz */
+	{ DRM_MODE("1440x240", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1478,
+		   1602, 1716, 0, 240, 244, 247, 262, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 60, },
+	/* 10 - 2880x480i@60Hz */
+	{ DRM_MODE("2880x480i", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2956,
+		   3204, 3432, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 60, },
+	/* 11 - 2880x480i@60Hz */
+	{ DRM_MODE("2880x480i", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2956,
+		   3204, 3432, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 60, },
+	/* 12 - 2880x240@60Hz */
+	{ DRM_MODE("2880x240", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2956,
+		   3204, 3432, 0, 240, 244, 247, 262, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 13 - 2880x240@60Hz */
+	{ DRM_MODE("2880x240", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2956,
+		   3204, 3432, 0, 240, 244, 247, 262, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 14 - 1440x480@60Hz */
+	{ DRM_MODE("1440x480", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1472,
+		   1596, 1716, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 15 - 1440x480@60Hz */
+	{ DRM_MODE("1440x480", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1472,
+		   1596, 1716, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 16 - 1920x1080@60Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 60, },
+	/* 17 - 720x576@50Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 27000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 18 - 720x576@50Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 27000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 19 - 1280x720@50Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 1720,
+		   1760, 1980, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 50, },
+	/* 20 - 1920x1080i@50Hz */
+	{ DRM_MODE("1920x1080i", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 50, },
+	/* 21 - 1440x576i@50Hz */
+	{ DRM_MODE("1440x576i", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 50, },
+	/* 22 - 1440x576i@50Hz */
+	{ DRM_MODE("1440x576i", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 50, },
+	/* 23 - 1440x288@50Hz */
+	{ DRM_MODE("1440x288", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1464,
+		   1590, 1728, 0, 288, 290, 293, 312, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 50, },
+	/* 24 - 1440x288@50Hz */
+	{ DRM_MODE("1440x288", DRM_MODE_TYPE_DRIVER, 27000, 1440, 1464,
+		   1590, 1728, 0, 288, 290, 293, 312, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 50, },
+	/* 25 - 2880x576i@50Hz */
+	{ DRM_MODE("2880x576i", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2928,
+		   3180, 3456, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 50, },
+	/* 26 - 2880x576i@50Hz */
+	{ DRM_MODE("2880x576i", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2928,
+		   3180, 3456, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 50, },
+	/* 27 - 2880x288@50Hz */
+	{ DRM_MODE("2880x288", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2928,
+		   3180, 3456, 0, 288, 290, 293, 312, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 28 - 2880x288@50Hz */
+	{ DRM_MODE("2880x288", DRM_MODE_TYPE_DRIVER, 54000, 2880, 2928,
+		   3180, 3456, 0, 288, 290, 293, 312, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 29 - 1440x576@50Hz */
+	{ DRM_MODE("1440x576", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1464,
+		   1592, 1728, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 30 - 1440x576@50Hz */
+	{ DRM_MODE("1440x576", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1464,
+		   1592, 1728, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 31 - 1920x1080@50Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 50, },
+	/* 32 - 1920x1080@24Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2558,
+		   2602, 2750, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 24, },
+	/* 33 - 1920x1080@25Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 25, },
+	/* 34 - 1920x1080@30Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 30, },
+	/* 35 - 2880x480@60Hz */
+	{ DRM_MODE("2880x480", DRM_MODE_TYPE_DRIVER, 108000, 2880, 2944,
+		   3192, 3432, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 36 - 2880x480@60Hz */
+	{ DRM_MODE("2880x480", DRM_MODE_TYPE_DRIVER, 108000, 2880, 2944,
+		   3192, 3432, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 60, },
+	/* 37 - 2880x576@50Hz */
+	{ DRM_MODE("2880x576", DRM_MODE_TYPE_DRIVER, 108000, 2880, 2928,
+		   3184, 3456, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 38 - 2880x576@50Hz */
+	{ DRM_MODE("2880x576", DRM_MODE_TYPE_DRIVER, 108000, 2880, 2928,
+		   3184, 3456, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 50, },
+	/* 39 - 1920x1080i@50Hz */
+	{ DRM_MODE("1920x1080i", DRM_MODE_TYPE_DRIVER, 72000, 1920, 1952,
+		   2120, 2304, 0, 1080, 1126, 1136, 1250, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 50, },
+	/* 40 - 1920x1080i@100Hz */
+	{ DRM_MODE("1920x1080i", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 100, },
+	/* 41 - 1280x720@100Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 148500, 1280, 1720,
+		   1760, 1980, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 100, },
+	/* 42 - 720x576@100Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 54000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 100, },
+	/* 43 - 720x576@100Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 54000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 100, },
+	/* 44 - 1440x576i@100Hz */
+	{ DRM_MODE("1440x576", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 100, },
+	/* 45 - 1440x576i@100Hz */
+	{ DRM_MODE("1440x576", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 100, },
+	/* 46 - 1920x1080i@120Hz */
+	{ DRM_MODE("1920x1080i", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC |
+			DRM_MODE_FLAG_INTERLACE),
+	  .vrefresh = 120, },
+	/* 47 - 1280x720@120Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 148500, 1280, 1390,
+		   1430, 1650, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 120, },
+	/* 48 - 720x480@120Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 54000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 120, },
+	/* 49 - 720x480@120Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 54000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 120, },
+	/* 50 - 1440x480i@120Hz */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 120, },
+	/* 51 - 1440x480i@120Hz */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 54000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 120, },
+	/* 52 - 720x576@200Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 108000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 200, },
+	/* 53 - 720x576@200Hz */
+	{ DRM_MODE("720x576", DRM_MODE_TYPE_DRIVER, 108000, 720, 732,
+		   796, 864, 0, 576, 581, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 200, },
+	/* 54 - 1440x576i@200Hz */
+	{ DRM_MODE("1440x576i", DRM_MODE_TYPE_DRIVER, 108000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 200, },
+	/* 55 - 1440x576i@200Hz */
+	{ DRM_MODE("1440x576i", DRM_MODE_TYPE_DRIVER, 108000, 1440, 1464,
+		   1590, 1728, 0, 576, 580, 586, 625, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 200, },
+	/* 56 - 720x480@240Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 108000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 240, },
+	/* 57 - 720x480@240Hz */
+	{ DRM_MODE("720x480", DRM_MODE_TYPE_DRIVER, 108000, 720, 736,
+		   798, 858, 0, 480, 489, 495, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC),
+	  .vrefresh = 240, },
+	/* 58 - 1440x480i@240 */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 108000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 240, },
+	/* 59 - 1440x480i@240 */
+	{ DRM_MODE("1440x480i", DRM_MODE_TYPE_DRIVER, 108000, 1440, 1478,
+		   1602, 1716, 0, 480, 488, 494, 525, 0,
+		   DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC |
+			DRM_MODE_FLAG_INTERLACE | DRM_MODE_FLAG_DBLCLK),
+	  .vrefresh = 240, },
+	/* 60 - 1280x720@24Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 59400, 1280, 3040,
+		   3080, 3300, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 24, },
+	/* 61 - 1280x720@25Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 3700,
+		   3740, 3960, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 25, },
+	/* 62 - 1280x720@30Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 3040,
+		   3080, 3300, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 30, },
+	/* 63 - 1920x1080@120Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 297000, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 120, },
+	/* 64 - 1920x1080@100Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 297000, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 100, },
+	/* 65 - 1280x720@24Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 59400, 1280, 3040,
+			3080, 3300, 0, 720, 725, 730, 750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 66 - 1280x720@25Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 3700,
+			3740, 3960, 0, 720, 725, 730, 750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 67 - 1280x720@30Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 3040,
+			3080, 3300, 0, 720, 725, 730, 750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 68 - 1280x720@50Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 1720,
+		   1760, 1980, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 50, },
+	/* 69 - 1280x720@60Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 74250, 1280, 1390,
+		   1430, 1650, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 60, },
+	/* 70 - 1280x720@100Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 148500, 1280, 1720,
+		   1760, 1980, 0, 720, 725, 730, 750, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 100, },
+	/* 71 - 1280x720@120Hz */
+	{ DRM_MODE("1280x720", DRM_MODE_TYPE_DRIVER, 148500, 1280, 1390,
+			1430, 1650, 0, 720, 725, 730, 750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 120, },
+	/* 72 - 1920x1080@24Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2558,
+		   2602, 2750, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 24, },
+	/* 73 - 1920x1080@25Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 25, },
+	/* 74 - 1920x1080@30Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 74250, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 30, },
+	/* 75 - 1920x1080@50Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 50, },
+	/* 76 - 1920x1080@60Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 148500, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	  .vrefresh = 60, },
+	/* 77 - 1920x1080@100Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 297000, 1920, 2448,
+		   2492, 2640, 0, 1080, 1084, 1094, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 100, },
+	/* 78 - 1920x1080@120Hz */
+	{ DRM_MODE("1920x1080", DRM_MODE_TYPE_DRIVER, 297000, 1920, 2008,
+		   2052, 2200, 0, 1080, 1084, 1089, 1125, 0,
+		   DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 120, },
+	/* 79 - 1680x720@24Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 59400,
+			1680, 0, 0, 3300, 0,
+			 720, 0, 0,  750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 80 - 1680x720@25Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 59400,
+			1680, 0, 0, 3168, 0,
+			 720, 0, 0,  750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 81 - 1680x720@30Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 59400,
+			1680, 0, 0, 2640, 0,
+			 720, 0, 0,  750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 82 - 1680x720@50Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 82500,
+			1680, 0, 0, 2200, 0,
+			 720, 0, 0,  750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 50, },
+	/* 83 - 1680x720@60Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 99000,
+			1680, 0, 0, 2200, 0,
+			 720, 0, 0,  750, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 60, },
+	/* 84 - 1680x720@100Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 165000,
+			1680, 0, 0, 2000, 0,
+			 720, 0, 0,  825, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 100, },
+	/* 85 - 1680x720@120Hz */
+	{ DRM_MODE("1680x720", DRM_MODE_TYPE_DRIVER, 198000,
+			1680, 0, 0, 2000, 0,
+			 720, 0, 0,  825, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 120, },
+	/* 86 - 2560x1080@24Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 99000,
+			2560, 0, 0, 3750, 0,
+			1080, 0, 0, 1100, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 87 - 2560x1080@25Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 90000,
+			2560, 0, 0, 3200, 0,
+			1080, 0, 0, 1125, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 88 - 2560x1080@30Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 118800,
+			2560, 0, 0, 3520, 0,
+			1080, 0, 0, 1125, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 89 - 2560x1080@50Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 185625,
+			2560, 0, 0, 3300, 0,
+			1080, 0, 0, 1125, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 50, },
+	/* 90 - 2560x1080@60Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 198000,
+			2560, 0, 0, 3000, 0,
+			1080, 0, 0, 1100, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 60, },
+	/* 91 - 2560x1080@100Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 371250,
+			2560, 0, 0, 2970, 0,
+			1080, 0, 0, 1250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 100, },
+	/* 92 - 2560x1080@120Hz */
+	{ DRM_MODE("2560x1080", DRM_MODE_TYPE_DRIVER, 495000,
+			2560, 0, 0, 3300, 0,
+			1080, 0, 0, 1250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 120, },
+	/* 93 - 3840x2160@24Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 5116, 5204, 5500, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 94 - 3840x2160@25Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 4896, 4984, 5280, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 95 - 3840x2160@30Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 4016, 4104, 4400, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 96 - 3840x2160@50Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			3840, 0, 0, 5280, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 50, },
+	/* 97 - 3840x2160@60Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			3840, 0, 0, 4400, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 60, },
+	/* 98 - 4096x2160@24Hz */
+	{ DRM_MODE("4096x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			4096, 0, 0, 5500, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 99 - 4096x2160@25Hz */
+	{ DRM_MODE("4096x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			4096, 0, 0, 5280, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 100 - 4096x2160@30Hz */
+	{ DRM_MODE("4096x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			4096, 0, 0, 4400, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 101 - 4096x2160@50Hz */
+	{ DRM_MODE("4096x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			4096, 0, 0, 5280, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 50, },
+	/* 102 - 4096x2160@60Hz */
+	{ DRM_MODE("4096x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			4096, 0, 0, 4400, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 60, },
+	/* 103 - 3840x2160@24Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 5116, 5204, 5500, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 24, },
+	/* 104 - 3840x2160@25Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 4896, 4984, 5280, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 25, },
+	/* 105 - 3840x2160@30Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 297000,
+			3840, 4016, 4104, 4400, 0,
+			2160, 2168, 2178, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 30, },
+	/* 106 - 3840x2160@50Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			3840, 0, 0, 5280, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 50, },
+	/* 107 - 3840x2160@60Hz */
+	{ DRM_MODE("3840x2160", DRM_MODE_TYPE_DRIVER, 594000,
+			3840, 0, 0, 4400, 0,
+			2160, 0, 0, 2250, 0,
+			DRM_MODE_FLAG_PHSYNC | DRM_MODE_FLAG_PVSYNC),
+	 .vrefresh = 60, },
+};
+
+
+static const u8 edid_header[] = {
+	0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00
+};
+
+static u8 svds[32] = {0x00};//Short Video Descriptors
+
+
+struct detailed_mode_closure {
+	struct sink_capabilities_t *cap;
+	struct edid *edid;
+	bool preferred;
+	u32 quirks;
+	int modes;
+};
+
+typedef void detailed_cb(struct detailed_timing *timing, void *closure);
+void hdmi_print_raw_edid(unsigned char *edid);
+
+int rtk_edid_header_is_valid(const u8 *raw_edid)
+{
+	int i, score = 0;
+
+	for (i = 0; i < sizeof(edid_header); i++)
+		if (raw_edid[i] == edid_header[i])
+			score++;
+
+	return score;
+}
+
+bool rtk_edid_block_valid(u8 *raw_edid, int block)
+{
+	int i;
+	u8 csum = 0;
+	struct edid *edid = (struct edid *)raw_edid;
+
+	if (block == 0) {
+		int score = rtk_edid_header_is_valid(raw_edid);
+
+		if (score != 8)
+			goto bad;
+	}
+
+	for (i = 0; i < EDID_LENGTH; i++)
+		csum += raw_edid[i];
+	if (csum) {
+		HDMI_ERROR("EDID checksum is invalid, remainder is %d", csum);
+
+		/* allow CEA to slide through, switches mangle this */
+		if (raw_edid[0] != 0x02)
+			goto bad;
+	}
+
+	/* per-block-type checks */
+	switch (raw_edid[0]) {
+	case 0: /* base */
+		if (edid->version != 1) {
+			HDMI_ERROR("EDID has major version %d, instead of 1", edid->version);
+			goto bad;
+		}
+
+		if (edid->revision > 4)
+			HDMI_DEBUG("EDID minor > 4, assuming backward compatibility");
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+
+bad:
+    hdmitx_set_error_code(HDMI_ERROR_INVALID_EDID);
+	if (raw_edid) {
+		HDMI_ERROR("Raw EDID:");
+		print_hex_dump(KERN_ERR, " \t", DUMP_PREFIX_NONE, 16, 1, raw_edid, EDID_LENGTH, false);
+	}
+	return 0;
+}
+
+bool rtk_edid_is_valid(struct edid *edid)
+{
+	int i;
+	u8 *raw = (u8 *)edid;
+
+	if (!edid)
+		return false;
+
+	for (i = 0; i <= edid->extensions; i++)
+		if (!rtk_edid_block_valid(raw + i * EDID_LENGTH, i))
+			return false;
+
+	return true;
+}
+
+void print_established_modes(u32 est_format)
+{
+	int i, freq;
+
+	printk("\n%12s : \n", "EST TIMEINGS");
+
+	for (i = 0; i <= EDID_EST_TIMINGS; i++) {
+		if ((est_format >> i) & 1) {
+			freq = ((edid_est_modes[i].clock*1000)/(edid_est_modes[i].htotal*edid_est_modes[i].vtotal));
+			printk("%12s   [%d]%s @%d Hz\n", " ", i, edid_est_modes[i].name, freq);
+		}
+	}
+
+}
+
+static int add_established_modes(struct edid *edid, u32 *est_format)
+{
+	unsigned long est_bits = edid->established_timings.t1 |
+		(edid->established_timings.t2 << 8) |
+		((edid->established_timings.mfg_rsvd & 0x80) << 9);
+	int i, modes = 0;
+
+	for (i = 0; i <= EDID_EST_TIMINGS; i++) {
+		if (est_bits & (1<<i))
+			modes++;
+	}
+
+	*est_format = est_bits;
+
+	return modes;
+}
+
+void print_cea_modes(u64 cea_format, u64 cea_format2, u64 cea_format2_420)
+{
+	int i, freq;
+
+	if (cea_format == 0) {
+		HDMI_INFO("no matching video format found");
+		return;
+	}
+
+	HDMI_INFO(" VIDEO DATA: ");
+
+	for (i = 0; i < ARRAY_SIZE(edid_cea_modes); i++) {
+
+		if (i < 64) {
+			if ((cea_format >> i) & 1ULL) {
+				if (edid_cea_modes[i].flags & DRM_MODE_FLAG_INTERLACE)
+					freq = ((edid_cea_modes[i].clock*1000)/((edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal)/2));
+				else
+					freq = ((edid_cea_modes[i].clock*1000)/(edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal));
+				HDMI_INFO("[%02d]%-10s @%d Hz", i+1, edid_cea_modes[i].name, freq);
+			}
+		} else if (i < 128) {
+			if ((cea_format2 >> (i-64)) & 1ULL) {
+				if (edid_cea_modes[i].flags & DRM_MODE_FLAG_INTERLACE)
+					freq = ((edid_cea_modes[i].clock*1000)/((edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal)/2));
+				else
+					freq = ((edid_cea_modes[i].clock*1000)/(edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal));
+				HDMI_INFO("[%02d]%-10s @%d Hz", i+1, edid_cea_modes[i].name, freq);
+			}
+		}
+	}
+
+	for (i = 64; i < ARRAY_SIZE(edid_cea_modes); i++) {
+		if (i < 128) {
+			if ((cea_format2_420 >> (i-64)) & 1ULL) {
+				if (edid_cea_modes[i].flags & DRM_MODE_FLAG_INTERLACE)
+					freq = ((edid_cea_modes[i].clock*1000)/((edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal)/2));
+				else
+					freq = ((edid_cea_modes[i].clock*1000)/(edid_cea_modes[i].htotal*edid_cea_modes[i].vtotal));
+				HDMI_INFO("[%02d]%-10s @%d Hz(YCbCr420)", i+1, edid_cea_modes[i].name, freq);
+			}
+		}
+	}
+
+}
+
+/* Tag Code */
+#define AUDIO_BLOCK	0x01
+#define VIDEO_BLOCK     0x02
+#define VENDOR_BLOCK    0x03
+#define SPEAKER_BLOCK	0x04
+#define VESA_DISPLAY_TRANSFER_BLOCK	0x05
+#define USE_EXTENDED_TAG	0x07
+
+/* Extended Tag Codes */
+#define VIDEO_CAPABILITY_DATA_BLOCK			0x00
+#define VENDOR_SPECIFIC_VIDEO_DATA_BLOCK	0x01
+#define VESA_DISPLAY_DEVICE_DATA_BLOCK		0x02
+#define VESA_VIDEO_TIMING_BLOCK_EXTENSION	0x03
+#define COLORIMETRY_DATA_BLOCK				0x05
+#define HDR_STATIC_METADATA_DATA_BLOCK		0x06
+#define HDR_DYNAMIC_METADATA_DATA_BLOCK		0x07
+#define VIDEO_FORMAT_PERFERENCE_DATA_BLOCK	0x0D
+#define YCBCR420_VIDEO_DATA_BLOCK			0x0E
+#define YCBCR420_CAPABILITY_MAP_DATA_BLOCK	0x0F
+#define VENDOR_SPECIFIC_AUDIO_DATA_BLOCK	0x11
+#define ROOM_CONFIGURATION_DATA_BLOCK		0x13
+#define SPEAKER_LOCATION_DATA_BLOCK			0x14
+#define INFOFRAME_DATA_BLOCK				0x20
+
+#define EDID_BASIC_AUDIO	(1 << 6)
+#define EDID_CEA_YCRCB444	(1 << 5)
+#define EDID_CEA_YCRCB422	(1 << 4)
+#define EDID_CEA_VCDB_QS	(1 << 6)
+
+/**
+ * Search EDID for CEA extension block.
+ */
+u8 *rtk_find_cea_extension(struct edid *edid)
+{
+	u8 *edid_ext = NULL;
+	int i;
+
+	/* No EDID or EDID extensions */
+	if (edid == NULL || edid->extensions == 0)
+		return NULL;
+
+	/* Find CEA extension */
+	for (i = 0; i < edid->extensions; i++) {
+		edid_ext = (u8 *)edid + EDID_LENGTH * (i + 1);
+		if (edid_ext[0] == CEA_EXT)
+			break;
+	}
+
+	if (i == edid->extensions)
+		return NULL;
+
+	return edid_ext;
+}
+
+static int do_cea_modes(u8 *db, u8 len, u64 *cea_format, u64 *cea_format2)
+{
+	u8 *mode;
+	u64 cea_mode = 0;
+	int modes = 0;
+
+	memset(&svds, 0, sizeof(svds));/* Clear svds */
+
+	for (mode = db; mode < db + len; mode++) {
+
+		cea_mode = (*mode & 127) - 1; /* CEA modes are numbered 1..127 */
+		if (cea_mode < ARRAY_SIZE(edid_cea_modes)) {
+
+			if (cea_mode <= 63)
+				*cea_format |= 1ULL<<cea_mode;
+			else if (cea_mode <= 127)
+				*cea_format2 |= 1ULL<<(cea_mode-64);
+
+			if ((mode-db) < 32)
+				svds[mode-db] = (*mode & 127);
+
+			modes++;
+		}
+	}
+
+	return modes;
+}
+
+static void do_cea_420modes(u8 *db, u8 len, u64 *cea_420format)
+{
+	u8 *mode;
+	u64 cea_mode = 0;
+
+	for (mode = db; mode < db + len; mode++) {
+		cea_mode = (*mode & 127) - 1; /* CEA modes are numbered 1..127 */
+		if (cea_mode < ARRAY_SIZE(edid_cea_modes)) {
+			if (cea_mode >= 64)
+				*cea_420format |= 1ULL<<(cea_mode-64);
+		}
+	}
+}
+
+static int cea_db_payload_len(const u8 *db)
+{
+	return db[0] & 0x1f;
+}
+
+static int cea_db_tag(const u8 *db)
+{
+	return db[0] >> 5;
+}
+
+static int cea_revision(const u8 *cea)
+{
+	return cea[1];
+}
+
+static int cea_db_offsets(const u8 *cea, int *start, int *end)
+{
+	/* Data block offset in CEA extension block */
+	*start = 4;
+	*end = cea[2];
+	if (*end == 0)
+		*end = 127;
+	if (*end < 4 || *end > 127)
+		return -ERANGE;
+	return 0;
+}
+
+#define for_each_cea_db(cea, i, start, end) \
+	for ((i) = (start); (i) < (end) && (i) + cea_db_payload_len(&(cea)[(i)]) < (end); (i) += cea_db_payload_len(&(cea)[(i)]) + 1)
+
+static int add_cea_modes(struct edid *edid, u64 *video_format, u64 *video_format2)
+{
+	u8 *cea = rtk_find_cea_extension(edid);
+	u8 *db;
+	u8 dbl;
+	int modes = 0;
+
+	if (cea && cea_revision(cea) >= 3) {
+		int i, start, end;
+
+		if (cea_db_offsets(cea, &start, &end))
+			return 0;
+
+		for_each_cea_db(cea, i, start, end) {
+			db = &cea[i];
+			dbl = cea_db_payload_len(db);
+
+			if (cea_db_tag(db) == VIDEO_BLOCK)
+				modes += do_cea_modes(db+1, dbl, video_format, video_format2);
+		}
+	}
+
+	return modes;
+}
+static bool cea_db_is_hdmi_vsdb(const u8 *db)
+{
+	int hdmi_id;
+
+	if (cea_db_tag(db) != VENDOR_BLOCK)
+		return false;
+
+	if (cea_db_payload_len(db) < 5)
+		return false;
+
+	hdmi_id = db[1] | (db[2] << 8) | (db[3] << 16);
+
+	/* Prevent overwrite 2.0 ID */
+	if (hdmitx_edid_info.hdmi_id != HDMI_2P0_IDENTIFIER)
+		hdmitx_edid_info.hdmi_id = hdmi_id;
+
+	return hdmi_id == HDMI_1PX_IDENTIFIER;
+}
+
+static bool cea_db_is_hdmi_forum_vsdb(const u8 *db)
+{
+	int hdmi_id;
+
+	if (cea_db_tag(db) != VENDOR_BLOCK)
+		return false;
+
+	if (cea_db_payload_len(db) < 7)
+		return false;
+
+	hdmi_id = db[1] | (db[2] << 8) | (db[3] << 16);
+
+	hdmitx_edid_info.hdmi_id = hdmi_id;
+
+	return hdmi_id == HDMI_2P0_IDENTIFIER;
+}
+
+static const char * const dpc_str[] = {
+	"6 bit", "8 bit", "10 bit", "12 bit",
+	"14 bit", "16 bit"
+};
+void print_deep_color(u32 var)
+{
+	int i;
+
+	printk("[HDMITx]Color Bit Depth: ");
+	for (i = 0; i < 6; i++) {
+		if ((var >> i) & 1)
+			printk("%s,", dpc_str[i]);
+	}
+	printk("\n");
+}
+
+static const char * const color_format_str[] = {
+	"RGB444", "YCrCb444", "YCrCb422"
+};
+void print_color_formats(u32 var)
+{
+	int i;
+
+	printk("[HDMITx]COLOR FORMAT: ");
+	for (i = 0; i < 3; i++) {
+		if ((var >> i) & 1)
+			printk("%s,", color_format_str[i]);
+	}
+	printk("\n");
+}
+
+static const char * const color_space_str[] = {
+	"xyYCC601", "xvYCC709", "sYCC601", "AdobeYCC601",
+	"AdobeRGB", "BT2020_cYCC", "BT2020_YCC", "BT2020_RGB"
+};
+void print_color_space(u8 var)
+{
+	int i;
+
+	printk("[HDMITx]COLORIMETRY: ");
+	for (i = 0; i < 8; i++) {
+		if ((var >> i) & 1)
+			printk("%s, ", color_space_str[i]);
+	}
+	printk("\n");
+}
+
+static void rtk_add_display_info(struct edid *edid, struct Video_Display_Info *info)
+{
+	u8 *edid_ext;
+
+	info->width_mm = edid->width_cm * 10;
+	info->height_mm = edid->height_cm * 10;
+
+	/* driver figures it out in this case */
+	info->bpc = 0;
+	info->color_formats = 0;
+
+	if (edid->revision < 3)
+		return;
+
+	if (!(edid->input & DRM_EDID_INPUT_DIGITAL))
+		return;
+
+	/* Get data from CEA blocks if present */
+	edid_ext = rtk_find_cea_extension(edid);
+	if (edid_ext) {
+		info->cea_rev = edid_ext[1];
+
+		/* The existence of a CEA block should imply RGB support */
+		info->color_formats = DRM_COLOR_FORMAT_RGB444;
+		if (edid_ext[3] & EDID_CEA_YCRCB444)
+			info->color_formats |= DRM_COLOR_FORMAT_YCRCB444;
+		if (edid_ext[3] & EDID_CEA_YCRCB422)
+			info->color_formats |= DRM_COLOR_FORMAT_YCRCB422;
+
+	}
+
+	/* Only defined for 1.4 with digital displays */
+	if (edid->revision < 4)
+		return;
+
+	switch (edid->input & DRM_EDID_DIGITAL_DEPTH_MASK) {
+	case DRM_EDID_DIGITAL_DEPTH_6:
+		/* info->bpc |= RTK_EDID_DIGITAL_DEPTH_6; */
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_8:
+		info->bpc |= RTK_EDID_DIGITAL_DEPTH_8;
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_10:
+		info->bpc |= RTK_EDID_DIGITAL_DEPTH_10;
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_12:
+		info->bpc |= RTK_EDID_DIGITAL_DEPTH_12;
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_14:
+		/* info->bpc |= RTK_EDID_DIGITAL_DEPTH_14; */
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_16:
+		/* info->bpc |= RTK_EDID_DIGITAL_DEPTH_16; */
+		break;
+	case DRM_EDID_DIGITAL_DEPTH_UNDEF:
+	default:
+		info->bpc = 0;
+		break;
+	}
+
+	info->color_formats |= DRM_COLOR_FORMAT_RGB444;
+	if (edid->features & DRM_EDID_FEATURE_RGB_YCRCB444)
+		info->color_formats |= DRM_COLOR_FORMAT_YCRCB444;
+	if (edid->features & DRM_EDID_FEATURE_RGB_YCRCB422)
+		info->color_formats |= DRM_COLOR_FORMAT_YCRCB422;
+
+}
+
+static void cea_for_each_detailed_block(u8 *ext, detailed_cb *cb, void *closure)
+{
+	int i, n = 0;
+	u8 d = ext[0x02];
+	u8 *det_base = ext + d;
+
+	n = (127 - d) / 18;
+	for (i = 0; i < n; i++)
+		cb((struct detailed_timing *)(det_base + 18 * i), closure);
+}
+
+static void vtb_for_each_detailed_block(u8 *ext, detailed_cb *cb, void *closure)
+{
+	unsigned int i, n;
+	u8 *det_base = ext + 5;
+
+	if (ext[0x01] != 1)
+		return; /* unknown version */
+
+	n = min_t(unsigned int, ext[0x02], 6);
+	for (i = 0; i < n; i++)
+		cb((struct detailed_timing *)(det_base + 18 * i), closure);
+}
+
+static void rtk_for_each_detailed_block(u8 *raw_edid, detailed_cb *cb, void *closure)
+{
+	int i;
+	struct edid *edid = (struct edid *)raw_edid;
+
+	if (edid == NULL)
+		return;
+
+	/* Parsing No.1-4 Detailed Timing Descriptor of basic edid, start from 0x36 */
+	for (i = 0; i < EDID_DETAILED_TIMINGS; i++)
+		cb(&(edid->detailed_timings[i]), closure);
+
+	/* Parsing Detailed Timing Descriptor of extension blk */
+	for (i = 1; i <= raw_edid[0x7e]; i++) {
+		u8 *ext = raw_edid + (i * EDID_LENGTH);
+
+		switch (*ext) {
+		case CEA_EXT:
+			cea_for_each_detailed_block(ext, cb, closure);
+			break;
+		case VTB_EXT:
+			vtb_for_each_detailed_block(ext, cb, closure);
+			break;
+		default:
+			break;
+		}
+	}
+}
+
+/*
+ * EDID is delightfully ambiguous about how interlaced modes are to be
+ * encoded.  Our internal representation is of frame height, but some
+ * HDTV detailed timings are encoded as field height.
+ *
+ * The format list here is from CEA, in frame size.  Technically we
+ * should be checking refresh rate too.  Whatever.
+ */
+static void rtk_drm_mode_do_interlace_quirk(struct drm_display_mode *mode, struct detailed_pixel_timing *pt)
+{
+	int i;
+
+	static const struct {
+		int w, h;
+	} cea_interlaced[] = {
+		{ 1920, 1080 },
+		{  720,  480 },
+		{ 1440,  480 },
+		{ 2880,  480 },
+		{  720,  576 },
+		{ 1440,  576 },
+		{ 2880,  576 },
+	};
+
+	if (!(pt->misc & DRM_EDID_PT_INTERLACED))
+		return;
+
+	for (i = 0; i < ARRAY_SIZE(cea_interlaced); i++) {
+		if ((mode->hdisplay == cea_interlaced[i].w) &&
+			(mode->vdisplay == cea_interlaced[i].h / 2)) {
+
+			mode->vdisplay *= 2;
+			mode->vsync_start *= 2;
+			mode->vsync_end *= 2;
+			mode->vtotal *= 2;
+			mode->vtotal |= 1;
+		}
+	}
+
+	mode->flags |= DRM_MODE_FLAG_INTERLACE;
+}
+
+int rtk_drm_mode_vrefresh(const struct drm_display_mode *mode)
+{
+	int refresh = 0;
+	unsigned int calc_val;
+
+	if (mode->vrefresh > 0) {
+		refresh = mode->vrefresh;
+	} else if (mode->htotal > 0 && mode->vtotal > 0) {
+		int vtotal;
+
+		vtotal = mode->vtotal;
+		/* work out vrefresh the value will be x1000 */
+		calc_val = (mode->clock * 1000);
+		calc_val /= mode->htotal;
+		refresh = (calc_val + vtotal / 2) / vtotal;
+
+		if (mode->flags & DRM_MODE_FLAG_INTERLACE)
+			refresh *= 2;
+		if (mode->flags & DRM_MODE_FLAG_DBLSCAN)
+			refresh /= 2;
+		if (mode->vscan > 1)
+			refresh /= mode->vscan;
+	}
+	return refresh;
+}
+
+/**
+ * drm_mode_detailed - create a new mode from an EDID detailed timing section
+ * @edid: EDID block
+ * @timing: EDID detailed timing info
+ * @quirks: quirks to apply
+ *
+ * An EDID detailed timing block contains enough info for us to create and
+ * return a new struct drm_display_mode.
+ */
+static struct drm_display_mode *rtk_drm_mode_detailed(struct edid *edid, struct detailed_timing *timing, u32 quirks)
+{
+	struct drm_display_mode *mode;
+
+	struct detailed_pixel_timing *pt = &timing->data.pixel_data;
+	unsigned int hactive = (pt->hactive_hblank_hi & 0xf0) << 4 | pt->hactive_lo;
+	unsigned int vactive = (pt->vactive_vblank_hi & 0xf0) << 4 | pt->vactive_lo;
+	unsigned int hblank = (pt->hactive_hblank_hi & 0xf) << 8 | pt->hblank_lo;
+	unsigned int vblank = (pt->vactive_vblank_hi & 0xf) << 8 | pt->vblank_lo;
+	unsigned int hsync_offset = (pt->hsync_vsync_offset_pulse_width_hi & 0xc0) << 2 | pt->hsync_offset_lo;
+	unsigned int hsync_pulse_width = (pt->hsync_vsync_offset_pulse_width_hi & 0x30) << 4 | pt->hsync_pulse_width_lo;
+	unsigned int vsync_offset = (pt->hsync_vsync_offset_pulse_width_hi & 0xc) << 2 | pt->vsync_offset_pulse_width_lo >> 4;
+	unsigned int vsync_pulse_width = (pt->hsync_vsync_offset_pulse_width_hi & 0x3) << 4 | (pt->vsync_offset_pulse_width_lo & 0xf);
+
+	/* ignore tiny modes */
+	if (hactive < 64 || vactive < 64)
+		return NULL;
+
+	mode = kzalloc(sizeof(struct drm_display_mode), GFP_KERNEL);
+	if (!mode)
+		return NULL;
+
+	mode->clock = le16_to_cpu(timing->pixel_clock) * 10;
+
+	mode->hdisplay = hactive;
+	mode->hsync_start = mode->hdisplay + hsync_offset;
+	mode->hsync_end = mode->hsync_start + hsync_pulse_width;
+	mode->htotal = mode->hdisplay + hblank;
+
+	mode->vdisplay = vactive;
+	mode->vsync_start = mode->vdisplay + vsync_offset;
+	mode->vsync_end = mode->vsync_start + vsync_pulse_width;
+	mode->vtotal = mode->vdisplay + vblank;
+
+	/* Some EDIDs have bogus h/vtotal values */
+	if (mode->hsync_end > mode->htotal)
+		mode->htotal = mode->hsync_end + 1;
+	if (mode->vsync_end > mode->vtotal)
+		mode->vtotal = mode->vsync_end + 1;
+
+	rtk_drm_mode_do_interlace_quirk(mode, pt);
+
+	mode->vscan = (mode->flags & DRM_MODE_FLAG_DBLSCAN) ? 2 : 1;
+
+	mode->vrefresh = rtk_drm_mode_vrefresh(mode);
+
+//	mode->type = DRM_MODE_TYPE_DRIVER;
+
+	return mode;
+
+}
+
+static void rtk_do_detailed_mode(struct detailed_timing *timing, void *c)
+{
+	struct detailed_mode_closure *closure = c;
+	struct drm_display_mode *newmode;
+	int j;
+
+	if (timing->pixel_clock) {
+
+		newmode = rtk_drm_mode_detailed(closure->edid, timing, closure->quirks);
+
+		if (!newmode) {
+			return;
+		} else {
+			HDMI_DEBUG("[%s] Detailied Timing: Hdisplay(%u), Vdisplay(%u), Clock(%u), vrefresh(%u), flags(0x%x)", __func__,
+				newmode->hdisplay, newmode->vdisplay, newmode->clock, newmode->vrefresh, newmode->flags);
+
+			for (j = 0; j < ARRAY_SIZE(edid_cea_modes); j++) {
+				if (newmode->hdisplay == edid_cea_modes[j].hdisplay &&
+					newmode->vdisplay == edid_cea_modes[j].vdisplay &&
+					newmode->clock == edid_cea_modes[j].clock &&
+					newmode->vrefresh == edid_cea_modes[j].vrefresh &&
+				  ((newmode->flags & DRM_MODE_FLAG_INTERLACE) == (edid_cea_modes[j].flags & DRM_MODE_FLAG_INTERLACE))) {
+					HDMI_DEBUG("[%s] vic=%d", __func__, j+1);
+					if (j < 64)
+						closure->cap->vic |= 1ULL << j;
+					else if (j < 128)
+						closure->cap->vic2 |= 1ULL << (j-64);
+
+					closure->modes++;
+				}
+			}
+		}
+		kfree(newmode);
+	}
+}
+
+int rtk_add_detailed_modes(struct sink_capabilities_t *sink_cap, struct edid *edid, u32 quirks)
+{
+	struct detailed_mode_closure closure = {
+		sink_cap,
+		edid,
+		1,
+		quirks,
+		0
+	};
+
+	//if (closure.preferred && !version_greater(edid, 1, 3))
+	//	closure.preferred =(edid->features & DRM_EDID_FEATURE_PREFERRED_TIMING);
+
+	rtk_for_each_detailed_block((u8 *)edid, rtk_do_detailed_mode, &closure);
+
+	return closure.modes;
+
+}
+
+
+int rtk_add_edid_modes(struct edid *edid, struct sink_capabilities_t *sink_cap)
+{
+	int num_modes = 0;
+	u32 quirks = 0;
+
+	if (edid == NULL)
+		return 0;
+
+	if (!rtk_edid_is_valid(edid))
+		return 0;
+
+	/*
+	 * EDID spec says modes should be preferred in this order:
+	 * - preferred detailed mode
+	 * - other detailed modes from base block
+	 * - detailed modes from extension blocks
+	 * - CVT 3-byte code modes
+	 * - standard timing codes
+	 * - established timing codes
+	 * - modes inferred from GTF or CVT range information
+	 *
+	 * We get this pretty much right.
+	 *
+	 * XXX order for additional mode types in extension blocks?
+	 */
+
+	num_modes += rtk_add_detailed_modes(sink_cap, edid, quirks);
+	HDMI_INFO("Detailed Timing Descriptor");
+	print_cea_modes(sink_cap->vic, sink_cap->vic2, sink_cap->vic2_420);
+
+	//num_modes += add_cvt_modes(connector, edid);
+	//num_modes += add_standard_modes(connector, edid);
+	num_modes += add_established_modes(edid, &sink_cap->est_modes);
+	//if (edid->features & DRM_EDID_FEATURE_DEFAULT_GTF)
+		//num_modes += add_inferred_modes(connector, edid);
+
+	num_modes += add_cea_modes(edid, &sink_cap->vic, &sink_cap->vic2);
+	rtk_add_display_info(edid, &sink_cap->display_info);
+
+	return num_modes;
+}
+
+static void monitor_name(struct detailed_timing *t, void *data)
+{
+	if (t->data.other_data.type == EDID_DETAIL_MONITOR_NAME)
+		*(u8 **)data = t->data.other_data.data.str.str;
+}
+
+/**
+ * parse_hdmi_VideoCapability_db - parse video capability data block
+ * @sink_cap: sink_capabilities_t
+ * @db: video capability data block
+ *
+ * bit   7   6      5         4        3         2         1          0
+ *      QY/QS/S_PT1/S_PT0/S_IT1/S_IT0/S_CE1/S_CE0
+ */
+static void parse_hdmi_VideoCapability_db(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	sink_cap->vout_edid_data.vcdb = db[2];
+	HDMI_DEBUG("[%s] vcdb(0x%02x)", __func__, sink_cap->vout_edid_data.vcdb);
+}
+
+/**
+ * parse_VendorSpecificVideo_db - parse vendor specific video data block
+ * @sink_cap: sink_capabilities_t
+ * @db: vendor specific video data block
+ *
+ * Only store dolby vision/HDR10+ information
+ */
+static void parse_VendorSpecificVideo_db(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	struct VIDEO_RPC_VOUT_EDID_DATA *hdr_data;
+	unsigned int i;
+	unsigned char length;
+	unsigned char oui[3];
+
+	length = db[0]&0x1F;
+	if (length < 4) {
+		HDMI_ERROR("Wrong length in VENDOR_SPECIFIC_VIDEO_DATA_BLOCK");
+		goto exit;
+	}
+
+	oui[0] = db[2];
+	oui[1] = db[3];
+	oui[2] = db[4];
+
+	if (length < 5) {
+		HDMI_ERROR("No additional payload in VENDOR_SPECIFIC_VIDEO_DATA_BLOCK");
+		goto exit;
+	}
+
+	hdr_data = &sink_cap->vout_edid_data;
+
+	if ((oui[0] == 0x46) && (oui[1] == 0xD0) && (oui[2] == 0x00)) {
+		/* Get Dolby Vision VSVDB payload */
+		if (length > 25) {
+			HDMI_ERROR("Unknow Dolby Vision version");
+			goto exit;
+		}
+		hdr_data->dolby_len = length-4;
+		for (i = 5; i <= length; i++)
+			hdr_data->dolby_data[i-5] = db[i];
+	} else if ((oui[0] == 0x8B) && (oui[1] == 0x84) && (oui[2] == 0x90)) {
+		/* Get HDR10+ */
+		hdr_data->hdr10_plus = db[5];
+		HDMI_INFO("Found HDR10+ in EDID");
+	}
+
+exit:
+	return;
+}
+
+/**
+ * parse_hdmi_colorimetry_db - parse colorimetry data block
+ * @sink_cap: sink_capabilities_t
+ * @db: colorimetry data block
+ *
+ * bit         7                   6                    5                4                   3                2             1             0
+ *     BT2020_RGB/BT2020_YCC/BT2020_cYCC/AdobeRGB/AdobeYCC601/sYCC601/xvYCC709/xvYCC601
+ */
+static void parse_hdmi_colorimetry_db(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	sink_cap->color_space = db[2];
+	sink_cap->vout_edid_data.color_space = db[2];
+	hdmitx_edid_info.colorimetry = db[2];
+	HDMI_DEBUG("[%s] color_space(0x%02x)", __func__, sink_cap->color_space);
+}
+
+/**
+ * parse_hdmi_hdr_db - parse hdr static metadata data block
+ * @sink_cap: sink_capabilities_t
+ * @db: video capability data block
+ */
+static void parse_hdmi_hdr_db(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	unsigned char length;
+
+	length = db[0]&0x1F;
+	if (length >= 3)
+		sink_cap->vout_edid_data.metadata_len = length-1;
+	else
+		sink_cap->vout_edid_data.metadata_len = 2;
+
+	sink_cap->vout_edid_data.et = db[2];
+	sink_cap->vout_edid_data.sm = db[3];
+
+	if (length >= 4)
+		sink_cap->vout_edid_data.max_luminace = db[4];
+
+	if (length >= 5)
+		sink_cap->vout_edid_data.max_frame_avg = db[5];
+
+	if (length >= 6)
+		sink_cap->vout_edid_data.min_luminace = db[6];
+
+	HDMI_DEBUG("[%s] et(0x%02x) db(0x%02x) max_lum(0x%02x) max_frame_avg(0x%02x), min_lum(0x%02x)", __func__,
+						sink_cap->vout_edid_data.et,
+						sink_cap->vout_edid_data.sm,
+						sink_cap->vout_edid_data.max_luminace,
+						sink_cap->vout_edid_data.max_frame_avg,
+						sink_cap->vout_edid_data.min_luminace);
+
+}
+
+/* YCbCr 4:2:0 Video Data Block */
+static void parse_hdmi_ycbcr420_video_db(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	int dbl;
+
+	dbl = cea_db_payload_len(db);
+	do_cea_420modes((u8 *)(db+2), dbl-1, &sink_cap->vic2_420);
+	HDMI_DEBUG("[%s] vic2_420(0x%08x%08x)", __func__,
+		(u32)(sink_cap->vic2_420>>32),
+		(u32)(sink_cap->vic2_420&0xFFFFFFFF));
+}
+
+/* YCbCr 4:2:0 Capability Map Data Block(Y420CMDB) */
+static void parse_hdmi_ycbcr420_cm_db(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	int dbl;
+	u8 *bit_map;
+	u8 map_size, byte_count, bit_count;
+	u64 vic;
+
+	dbl = cea_db_payload_len(db);
+
+	map_size = dbl-1;
+	bit_map = (u8 *)(db+2);
+
+	if (map_size == 0) {
+		/* Empty-CapMap, all SVDs support Y420 */
+		HDMI_DEBUG("Y420CMDB does not include Capability Bit Map");
+		byte_count = 0;
+		while ((svds[byte_count] != 0) && (byte_count < 32)) {
+			vic = svds[byte_count];
+			if (vic >= 65)
+				sink_cap->vic2_420 |= 1ULL<<(vic-65);
+			byte_count++;
+		}
+	}
+
+	for (byte_count = 0; byte_count < map_size; byte_count++) {
+		for (bit_count = 0; bit_count < 8; bit_count++) {
+			if (*bit_map & (0x1 << bit_count)) {
+				vic = svds[byte_count*8+bit_count];
+				if (vic >= 65)
+					sink_cap->vic2_420 |= 1ULL<<(vic-65);
+			}
+		}
+		bit_map++;/* next bit map */
+	}
+
+	HDMI_DEBUG("[%s] vic2_420(0x%08x%08x)", __func__,
+		(u32)(sink_cap->vic2_420>>32),
+		(u32)(sink_cap->vic2_420&0xFFFFFFFF));
+}
+
+static bool parse_hdmi_extdb(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	int dbl;
+
+	if (cea_db_tag(db) != USE_EXTENDED_TAG)
+		return false;
+
+	dbl = cea_db_payload_len(db);
+
+	switch (*(db+1)) {
+	case VIDEO_CAPABILITY_DATA_BLOCK:
+		HDMI_DEBUG("[%s] VIDEO_CAPABILITY_DATA_BLOCK (%u bytes)", __func__, dbl);
+		parse_hdmi_VideoCapability_db(sink_cap, db);
+		break;
+	case VENDOR_SPECIFIC_VIDEO_DATA_BLOCK:
+		HDMI_DEBUG("[%s] VENDOR_SPECIFIC_VIDEO_DATA_BLOCK (%u bytes)", __func__, dbl);
+		parse_VendorSpecificVideo_db(sink_cap, db);
+		break;
+	case VESA_DISPLAY_DEVICE_DATA_BLOCK:
+		HDMI_DEBUG("[%s] VESA_DISPLAY_DEVICE_DATA_BLOCK (%u bytes)", __func__, dbl);
+		break;
+	case VESA_VIDEO_TIMING_BLOCK_EXTENSION:
+		HDMI_DEBUG("[%s] VESA_VIDEO_TIMING_BLOCK_EXTENSION (%u bytes)", __func__, dbl);
+		break;
+	case COLORIMETRY_DATA_BLOCK:
+		HDMI_DEBUG("[%s] COLORIMETRY_DATA_BLOCK (%u bytes)", __func__, dbl);
+		parse_hdmi_colorimetry_db(sink_cap, db);
+		break;
+	case HDR_STATIC_METADATA_DATA_BLOCK:
+		HDMI_DEBUG("[%s] HDR_STATIC_METADATA_DATA_BLOCK (%u bytes)", __func__, dbl);
+		parse_hdmi_hdr_db(sink_cap, db);
+		break;
+	case YCBCR420_VIDEO_DATA_BLOCK:
+		HDMI_DEBUG("[%s] YCBCR420_VIDEO_DATA_BLOCK (%u bytes)", __func__, dbl);
+		parse_hdmi_ycbcr420_video_db(sink_cap, db);
+		break;
+	case YCBCR420_CAPABILITY_MAP_DATA_BLOCK:
+		HDMI_DEBUG("[%s] YCBCR420_CAPABILITY_MAP_DATA_BLOCK (%u bytes)", __func__, dbl);
+		parse_hdmi_ycbcr420_cm_db(sink_cap, db);
+		break;
+	case VENDOR_SPECIFIC_AUDIO_DATA_BLOCK:
+		HDMI_DEBUG("[%s] VENDOR_SPECIFIC_AUDIO_DATA_BLOCK (%u bytes)", __func__, dbl);
+		break;
+	case INFOFRAME_DATA_BLOCK:
+		HDMI_DEBUG("[%s] INFOFRAME_DATA_BLOCK (%u bytes)", __func__, dbl);
+		break;
+	default:
+		HDMI_INFO("[%s] Unknow Extend Tag(%u) (%u bytes)", __func__, *(db+1), dbl);
+		break;
+	} /* end of switch (*(db+1)) */
+
+	return true;
+}
+
+static void parse_hdmi_vsdb(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	u8 len = cea_db_payload_len(db);
+	u8 HDMI_Video_present = 0;
+	int offset = 0;
+
+	int multi_present = 0;
+	int i;
+	u8 vic_len = 0, hdmi_3d_len = 0;
+	u8 specific_3d_len, specific_3d_index, specific_3d_format, index;
+	u16 mask = 0;
+
+	if (len >= 4) {
+		sink_cap->cec_phy_addr[0] = db[4];
+		sink_cap->cec_phy_addr[1] = db[5];
+	}
+
+	if (len >= 6) {
+		sink_cap->eld[5] |= (db[6] >> 7) & 1;  /* Supports_AI */
+		sink_cap->DC_Y444 = (db[6] >> 3) & 1;  /* Supports 4:4:4 in deep color modes */
+		if ((db[6] >> 4) & 1)
+			sink_cap->display_info.bpc |= RTK_EDID_DIGITAL_DEPTH_10;
+		if ((db[6] >> 5) & 1)
+			sink_cap->display_info.bpc |= RTK_EDID_DIGITAL_DEPTH_12;
+		sink_cap->dvi_dual = db[6] & 1;
+	}
+	if (len >= 7)
+		sink_cap->max_tmds_clock = db[7] * 5;
+	if (len >= 8) {
+		sink_cap->latency_present[0] = db[8] >> 7; /* Latency_Fields_Present */
+		sink_cap->latency_present[1] = (db[8] >> 6) & 1; /* I_Latency_Fields_Present */
+		HDMI_Video_present = (db[8] >> 5) & 1; /* HDMI_Video_Present */
+	}
+
+	if (db[8] & (1 << 7)) {
+		offset += 2;
+		if (len >= 9)
+			sink_cap->video_latency[0] = db[9];
+		if (len >= 10)
+			sink_cap->audio_latency[0] = db[10];
+	}
+
+	/* I_Latency_Fields_Present */
+	if (db[8] & (1 << 6)) {
+		offset += 2;
+		if (len >= 11)
+			sink_cap->video_latency[1] = db[11];
+		if (len >= 12)
+			sink_cap->audio_latency[1] = db[12];
+	}
+
+	if (HDMI_Video_present) {
+		offset++;
+		if (len >= 8+offset) {
+			sink_cap->_3D_present = (db[8+offset] >> 7) & 1;
+			multi_present = (db[8+offset] & 0x60) >> 5;
+			/* printk("present offset=%d db[8+offset]=0x%x\n",offset,db[8+offset]); */
+		}
+
+		offset++;
+		if (len >= 8+offset) {
+			vic_len = db[8+offset] >> 5;
+			hdmi_3d_len = db[8+offset] & 0x1f;
+		}
+
+		for (i = 1; i <= vic_len; i++) {
+			sink_cap->extended_vic |= (1 << db[8+offset+i]);
+			HDMI_DEBUG("sink_cap-> extended_vic = %x db[8+%d+%d]=%x",
+				sink_cap->extended_vic, offset, i, db[8+offset+i]);
+		}
+
+		for (i = 0; i < vic_len && len >= (9 + offset + i); i++) {
+			u8 vic;
+
+			vic = db[9 + offset + i];
+		}
+		offset += 1 + vic_len;
+
+		/* 3D_Structure_ALL */
+		if (multi_present == 1 || multi_present == 2) {
+			sink_cap->structure_all = (db[8 + offset] << 8) | db[9 + offset];/* 3D_Structure_ALL_15..0 */
+
+			if (multi_present == 1) {
+				/* assigns 3D formats to all of the VICs listed in the first 16 entries */
+				mask = 0xffff;
+				offset += 2;
+			} else if (multi_present == 2) {
+				mask = (db[10 + offset] << 8) | db[11 + offset];
+				offset += 4;
+			} else {
+				mask = 0;
+			}
+
+			/* 3D_MASK */
+			if (mask != 0) {
+				for (i = 0; i < 16 ; i++) {
+					if ((mask >> i) & 1) {
+						sink_cap->_3D_vic[i] = svds[i];
+						HDMI_DEBUG("sink_cap->_3D_vic[%d]=%d", i, sink_cap->_3D_vic[i]);
+					}
+				}
+			}
+		}
+
+		/* Check specific 3D, 2D_VIC_order and 3D_Structure*/
+		if (hdmi_3d_len > multi_present*2) {
+
+			specific_3d_len = hdmi_3d_len-multi_present*2;
+			HDMI_DEBUG("specific_3d_len=%u", specific_3d_len);
+			index = 0;
+			for (i = 0; i < specific_3d_len; i++) {
+
+				specific_3d_format = db[8+offset+i]&0xF;
+				specific_3d_index = (db[8+offset+i]>>4)&0xF;
+				switch (specific_3d_format) {
+				case 0:/* Frame packing */
+					HDMI_DEBUG("specific_3d[%d]=VIC(%u) Frame packing", i, svds[specific_3d_index]);
+					if (index < 18) {
+						sink_cap->spec_3d[index].vic = svds[specific_3d_index];
+						sink_cap->spec_3d[index].format = 0;
+						index++;
+					}
+					break;
+				case 6:/* Top-and-Bottom */
+					HDMI_DEBUG("specific_3d[%d]=VIC(%u) Top-and-Bottom", i, svds[specific_3d_index]);
+					if (index < 18) {
+						sink_cap->spec_3d[index].vic = svds[specific_3d_index];
+						sink_cap->spec_3d[index].format = 6;
+						index++;
+					}
+					break;
+				case 8:/* Side-by-Side(Half) */
+					HDMI_DEBUG("specific_3d[%d]=VIC(%u) Side-by-Side", i, svds[specific_3d_index]);
+					if (index < 18) {
+						sink_cap->spec_3d[index].vic = svds[specific_3d_index];
+						sink_cap->spec_3d[index].format = 8;
+						index++;
+					}
+					i++;/* Skip 1byte(3D_Detail) */
+					break;
+				default:
+					break;
+				}
+			}
+		} /* end of if (hdmi_3d_len > multi_present*2) */
+	} /* end of if (HDMI_Video_present) */
+
+	HDMI_DEBUG("cec addr:0x%x 0x%x", sink_cap->cec_phy_addr[0], sink_cap->cec_phy_addr[1]);
+	HDMI_DEBUG("HDMI: DVI dual %d, max TMDS clock %d",
+			sink_cap->dvi_dual, sink_cap->max_tmds_clock);
+	HDMI_DEBUG("latency present %d %d, video latency %d %d, audio latency %d %d",
+		(int) sink_cap->latency_present[0],
+		(int) sink_cap->latency_present[1],
+		sink_cap->video_latency[0],
+		sink_cap->video_latency[1],
+		sink_cap->audio_latency[0],
+		sink_cap->audio_latency[1]);
+
+	HDMI_DEBUG("HDMI 3D: HDMI_Video_present 0x%x _3D_present 0x%x ,multi_present 0x%x",
+		HDMI_Video_present, sink_cap->_3D_present, multi_present);
+	HDMI_DEBUG("vic_len %d,hdmi_3d_len %d", vic_len, hdmi_3d_len);
+	HDMI_DEBUG("structure_all 0x%x,mask 0x%x", sink_cap->structure_all, mask);
+
+}
+
+static void parse_hdmi_forum_vsdb(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	hdmitx_edid_info.max_tmds_char_rate = db[5]*5;
+	hdmitx_edid_info.scdc_capable = db[6];
+	hdmitx_edid_info.dc_420 = db[7]&0x7;
+}
+
+static void parse_hdmi_audio_db(struct sink_capabilities_t *sink_cap, const u8 *db)
+{
+	unsigned char *sad;/* Short Audio Descriptor */
+	unsigned char sad_count;
+	unsigned char len;
+	unsigned char i;
+	unsigned char j;
+
+	unsigned char coding_type;
+	unsigned char channel_count;
+	unsigned char sample_freq_all;
+	unsigned char sample_size_all;
+	unsigned char max_bit_rate_divided_by_8KHz;
+
+	len = cea_db_payload_len(db);
+	if ((len%3) != 0) {
+		HDMI_ERROR("Invalid length in audio data block, skip parse");
+		return;
+	}
+
+	sad_count = len/3;
+	sad = &db[1];
+
+	/* Start from the basic audio settings */
+	i = sink_cap->audio_data.ADB_length/3;
+	while ((sad_count > 0) && (i < 10)) {
+
+		sample_size_all = 0;
+		max_bit_rate_divided_by_8KHz = 0;
+
+		coding_type = ((sad[0] & 0x78)>>3);
+		channel_count = max(2, ((sad[0]&7)+1));
+		sample_freq_all = sad[1];
+
+		if (coding_type == 0x01) /* PCM */
+			sample_size_all = sad[2];
+		else
+			max_bit_rate_divided_by_8KHz = sad[2];
+
+		for (j = 0; j < i; j++) {
+			if (coding_type == sink_cap->audio_data.ADB[j].coding_type) {
+				/* Merge same type */
+				sink_cap->audio_data.ADB[j].channel_count =
+					max(channel_count, sink_cap->audio_data.ADB[j].channel_count);
+
+				sink_cap->audio_data.ADB[j].sample_freq_all |= sample_freq_all;
+
+				if (coding_type == 0x01)
+					sink_cap->audio_data.ADB[j].sample_size_all |= sample_size_all;
+				else
+					sink_cap->audio_data.ADB[j].max_bit_rate_divided_by_8KHz =
+						max(max_bit_rate_divided_by_8KHz, sink_cap->audio_data.ADB[j].max_bit_rate_divided_by_8KHz);
+				break;
+			}
+		}
+
+		if (j >= i) {
+			sink_cap->audio_data.ADB[i].coding_type = coding_type;
+			sink_cap->audio_data.ADB[i].channel_count = channel_count;
+			sink_cap->audio_data.ADB[i].sample_freq_all = sample_freq_all;
+			sink_cap->audio_data.ADB[i].sample_size_all = sample_size_all;
+			sink_cap->audio_data.ADB[i].max_bit_rate_divided_by_8KHz = max_bit_rate_divided_by_8KHz;
+			sink_cap->audio_data.ADB_length += 3;
+			i++;
+		}
+
+		sad += 3;
+		sad_count -= 1;
+	}
+
+}
+
+void rtk_edid_to_eld(struct edid *edid, struct sink_capabilities_t *sink_cap)
+{
+	unsigned char *eld = sink_cap->eld;
+	u8 *cea;
+	u8 *name;
+	u8 *db;
+	int sad_count = 0;
+	int mnl;
+	int dbl;
+
+	memset(eld, 0, sizeof(sink_cap->eld));
+
+	cea = rtk_find_cea_extension(edid);
+	if (!cea) {
+		HDMI_ERROR("ELD: no CEA Extension found");
+		return;
+	}
+
+	name = NULL;
+	rtk_for_each_detailed_block((u8 *)edid, monitor_name, &name);
+	for (mnl = 0; name && mnl < 13; mnl++) {
+		if (name[mnl] == 0x0a)
+			break;
+		eld[20 + mnl] = name[mnl];
+	}
+	eld[4] = (cea[1] << 5) | mnl;
+	HDMI_DEBUG("ELD monitor %s", eld + 20);
+
+	eld[0] = 2 << 3;/* ELD version: 2 */
+
+	eld[16] = edid->mfg_id[0];
+	eld[17] = edid->mfg_id[1];
+	eld[18] = edid->prod_code[0];
+	eld[19] = edid->prod_code[1];
+
+	/* Color characteristics */
+	sink_cap->vout_edid_data.red_green_lo = edid->red_green_lo;
+	sink_cap->vout_edid_data.black_white_lo = edid->black_white_lo;
+	sink_cap->vout_edid_data.red_x = edid->red_x;
+	sink_cap->vout_edid_data.red_y = edid->red_y;
+	sink_cap->vout_edid_data.green_x = edid->green_x;
+	sink_cap->vout_edid_data.green_y = edid->green_y;
+	sink_cap->vout_edid_data.blue_x = edid->blue_x;
+	sink_cap->vout_edid_data.blue_y = edid->blue_y;
+	sink_cap->vout_edid_data.white_x = edid->white_x;
+	sink_cap->vout_edid_data.white_y = edid->white_y;
+
+	if (cea_revision(cea) >= 3) {
+		int i, start, end;
+
+		if (cea_db_offsets(cea, &start, &end)) {
+			start = 0;
+			end = 0;
+		}
+
+		for_each_cea_db(cea, i, start, end) {
+			db = &cea[i];
+			dbl = cea_db_payload_len(db);
+
+			switch (cea_db_tag(db)) {
+			case AUDIO_BLOCK:
+				/* Audio Data Block, contains SADs */
+				HDMI_DEBUG("[%s] AUDIO_BLOCK (%u bytes)", __func__, dbl);
+				parse_hdmi_audio_db(sink_cap, db);
+
+				sad_count = dbl / 3;
+				if (dbl >= 1)
+					memcpy(eld + 20 + mnl, &db[1], dbl);
+				break;
+			case VIDEO_BLOCK:
+				HDMI_DEBUG("[%s] VIDEO_BLOCK (%u bytes)", __func__, dbl);
+				break;
+			case SPEAKER_BLOCK:
+				/* Speaker Allocation Data Block */
+				HDMI_DEBUG("[%s] SPEAKER_BLOCK (%u bytes)", __func__, dbl);
+				if (dbl >= 1) {
+					eld[7] = db[1];
+					sink_cap->audio_data.SADB_length = dbl;
+					memcpy(sink_cap->audio_data.SADB, &db[1], sizeof(sink_cap->audio_data.SADB));
+				}
+				break;
+			case VENDOR_BLOCK:
+				/* HDMI Vendor-Specific Data Block */
+				HDMI_DEBUG("[%s] VENDOR_BLOCK (%u bytes)", __func__, dbl);
+				if (cea_db_is_hdmi_vsdb(db))
+					parse_hdmi_vsdb(sink_cap, db);
+
+				if (cea_db_is_hdmi_forum_vsdb(db))/* HDMI 2.0 */
+					parse_hdmi_forum_vsdb(sink_cap, db);
+				break;
+			case VESA_DISPLAY_TRANSFER_BLOCK:
+				HDMI_DEBUG("[%s] VESA_DISPLAY_TRANSFER_BLOCK (%u bytes)", __func__, dbl);
+				break;
+			case USE_EXTENDED_TAG:
+				/* HDMI USE_EXTENDED_TAG Block */
+				parse_hdmi_extdb(sink_cap, db);
+				break;
+			default:
+				HDMI_INFO("[%s] Unknow tag(0x%x)", __func__, cea_db_tag(db));
+				break;
+			}
+		} /*end of for_each_cea_db(cea, i, start, end) */
+		HDMI_INFO("HDMI version:%s", (hdmitx_edid_info.hdmi_id == HDMI_2P0_IDENTIFIER)?"2.0":"1.4");
+	}
+	eld[5] |= sad_count << 4;
+	eld[2] = (20 + mnl + sad_count * 3 + 3) / 4;
+
+	HDMI_DEBUG("ELD size %d, SAD count %d", (int)eld[2], sad_count);
+}
+
+bool rtk_detect_hdmi_monitor(struct edid *edid)
+{
+	u8 *edid_ext;
+	int i;
+	int start_offset;
+	int end_offset;
+
+	edid_ext = rtk_find_cea_extension(edid);
+	if (!edid_ext)
+		return false;
+
+	if (cea_db_offsets(edid_ext, &start_offset, &end_offset))
+		return false;
+
+	/*
+	 * Because HDMI identifier is in Vendor Specific Block,
+	 * search it from all data blocks of CEA extension.
+	 */
+	for_each_cea_db(edid_ext, i, start_offset, end_offset) {
+		if (cea_db_is_hdmi_vsdb(&edid_ext[i]))
+			return true;
+	}
+
+	return false;
+}
+
+#define DDC_SEGMENT_ADDR 0x30
+int rtk_do_probe_ddc_edid(unsigned char *buf, int block, int len)
+{
+	struct i2c_adapter *p_adap;
+	unsigned char bus_id = 1;
+	int i;
+	int retry = 5;
+	int ret;
+	struct i2c_msg msgs[3];
+	unsigned char start = block * EDID_LENGTH;
+	unsigned char segment = block >> 1;
+	unsigned char xfers = segment ? 3 : 2;
+
+	msgs[0].addr = DDC_SEGMENT_ADDR;
+	msgs[0].flags = 0;
+	msgs[0].len = 1;
+	msgs[0].buf = &segment;
+
+	msgs[1].addr = DDC_ADDR;
+	msgs[1].flags = 0;
+	msgs[1].len = 1;
+	msgs[1].buf = &start;
+
+	msgs[2].addr = DDC_ADDR;
+	msgs[2].flags = I2C_M_RD;
+	msgs[2].len = len;
+	msgs[2].buf = buf;
+
+	p_adap = i2c_get_adapter(bus_id);
+	if (p_adap == NULL) {
+		HDMI_ERROR("hdmi get adapter %d failed", bus_id);
+		hdmitx_set_error_code(HDMI_ERROR_I2C_ERROR);
+		return -ENODEV;
+	}
+
+	for (i = 0; i < retry; i++) {
+		/* Slow down I2C speed when retry */
+		switch (i) {
+		case 1:
+			HDMI_INFO("Set I2C 80 kbps");
+			msgs[0].flags = I2C_M_LOW_SPEED_80;
+			msgs[1].flags = I2C_M_LOW_SPEED_80;
+			msgs[2].flags = I2C_M_LOW_SPEED_80|I2C_M_RD;
+			break;
+		case 2:
+			HDMI_INFO("Set I2C 66 kbps");
+			msgs[0].flags = I2C_M_LOW_SPEED_66;
+			msgs[1].flags = I2C_M_LOW_SPEED_66;
+			msgs[2].flags = I2C_M_LOW_SPEED_66|I2C_M_RD;
+			break;
+		case 3:
+			HDMI_INFO("Set I2C 33 kbps");
+			msgs[0].flags = I2C_M_LOW_SPEED_33;
+			msgs[1].flags = I2C_M_LOW_SPEED_33;
+			msgs[2].flags = I2C_M_LOW_SPEED_33|I2C_M_RD;
+			break;
+		case 4:
+			HDMI_INFO("Set I2C 10 kbps");
+			msgs[0].flags = I2C_M_LOW_SPEED_10;
+			msgs[1].flags = I2C_M_LOW_SPEED_10;
+			msgs[2].flags = I2C_M_LOW_SPEED_10|I2C_M_RD;
+			break;
+		default:
+			/* Default I2C speed is 100 kbps */
+			break;
+		}
+
+		ret = i2c_transfer(p_adap, &msgs[3 - xfers], xfers);
+		if (ret == xfers)
+			return 0;
+
+		ret = show_hpd_status(true);
+		if (ret) {
+			msleep(500);
+			hdmitx_set_error_code(HDMI_ERROR_I2C_ERROR);
+			HDMI_ERROR("I2C1 retry %d time(s)", i);
+		} else {
+			hdmitx_set_error_code(HDMI_ERROR_HPD);
+			HDMI_ERROR("stop I2C1 retry %d time(s), pulled out ", i);
+			break;
+		}
+	} /* end of for(i = 0; i < retry; i++) */
+
+	return -1;
+}
+
+static u8 *rtk_do_get_edid(void)
+{
+	int i;
+	int j = 0;
+	int valid_extensions = 0;
+	u8 *block;
+	u8 *new;
+	int bad_edid_counter = 0;
+
+	block = kmalloc(EDID_LENGTH, GFP_KERNEL);
+	if (block == NULL) {
+		hdmitx_set_error_code(HDMI_ERROR_NO_MEMORY);
+		return NULL;
+	}
+
+	/* base block fetch */
+	for (i = 0; i < 4; i++) {
+		if (rtk_do_probe_ddc_edid(block, 0, EDID_LENGTH))
+			goto out;
+		if (rtk_edid_block_valid(block, 0)) {
+			/* Copy Base block(128bytes) to hdmitx_edid_info */
+			memcpy(&hdmitx_edid_info, block, EDID_LENGTH);
+			break;
+		}
+	}
+	if (i == 4)
+		goto carp;
+
+	/* if there's no extensions, we're done */
+	if (block[0x7e] == 0)
+		return block;
+
+	new = krealloc(block, (block[0x7e] + 1) * EDID_LENGTH, GFP_KERNEL);
+	if (!new) {
+		hdmitx_set_error_code(HDMI_ERROR_NO_MEMORY);
+		goto out;
+	}
+	block = new;
+
+	for (j = 1; j <= block[0x7e]; j++) {
+		for (i = 0; i < 4; i++) {
+			if (rtk_do_probe_ddc_edid(block + (valid_extensions + 1) * EDID_LENGTH, j, EDID_LENGTH))
+				goto out;
+			if (rtk_edid_block_valid(block + (valid_extensions + 1) * EDID_LENGTH, j)) {
+				valid_extensions++;
+				break;
+			}
+		}
+
+		if (i == 4)
+			bad_edid_counter++;
+	}
+
+	if (valid_extensions != block[0x7e]) {
+		block[EDID_LENGTH-1] += block[0x7e] - valid_extensions;
+		block[0x7e] = valid_extensions;
+		new = krealloc(block, (valid_extensions + 1) * EDID_LENGTH, GFP_KERNEL);
+		if (!new) {
+			hdmitx_set_error_code(HDMI_ERROR_NO_MEMORY);
+			goto out;
+		}
+		block = new;
+	}
+
+	return block;
+
+carp:
+	bad_edid_counter++;
+	HDMI_ERROR("bad_edid_counter=%d ", bad_edid_counter);
+
+out:
+	kfree(block);
+	return NULL;
+}
+
+/**
+ * rtk_get_base_edid - get base block of EDID
+ */
+struct edid *rtk_get_base_edid(void)
+{
+	struct edid *base_edid;
+	int ret_val;
+
+	base_edid = kmalloc(EDID_LENGTH, GFP_KERNEL);
+	if (base_edid == NULL) {
+		HDMI_ERROR("%s kmalloc fail", __func__);
+		goto out;
+	}
+
+	ret_val = rtk_do_probe_ddc_edid((u8 *)base_edid, 0, EDID_LENGTH);
+	if (ret_val != 0) {
+		HDMI_ERROR("%s fail", __func__);
+		kfree(base_edid);
+		base_edid = NULL;
+	}
+
+out:
+	return base_edid;
+}
+
+struct edid *rtk_get_edid(asoc_hdmi_t *hdmi)
+{
+	struct edid *edid = NULL;
+	u8 *block;
+
+	hdmi->edid_ptr = rtk_do_get_edid();
+	if (hdmi->edid_ptr == NULL) {
+
+		block = kmalloc(EDID_LENGTH*2, GFP_KERNEL);
+		if (block == NULL) {
+			hdmitx_set_error_code(HDMI_ERROR_NO_MEMORY);
+			return NULL;
+		}
+
+		HDMI_ERROR("Get EDID fail, assign default EDID");
+		memcpy(block, default_edid, EDID_LENGTH*2);
+		hdmi->edid_ptr = block;
+	}
+
+	edid = (struct edid *)hdmi->edid_ptr;
+
+	return edid;
+}
+
+void hdmi_print_raw_edid(unsigned char *edid)
+{
+	int i;
+
+	if (edid == NULL)
+		return;
+
+	HDMI_INFO("RAW EDID:");
+
+	for (i = 0; i < (edid[0x7e]+1)*EDID_LENGTH; i += 16)
+		HDMI_INFO("0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,",
+			edid[i], edid[i+1], edid[i+2], edid[i+3], edid[i+4], edid[i+5], edid[i+6], edid[i+7],
+			edid[i+8], edid[i+9], edid[i+10], edid[i+11], edid[i+12], edid[i+13], edid[i+14], edid[i+15]);
+
+}
diff --git a/drivers/media/platform/rtk_hdmitx/rtk_edid.h b/drivers/media/platform/rtk_hdmitx/rtk_edid.h
new file mode 100644
index 00000000..29a4464
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/rtk_edid.h
@@ -0,0 +1,43 @@
+/*
+ * rtk_edid.h - RTK hdmitx driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _RTK_EDID_H_
+#define _RTK_EDID_H_
+
+#include "hdmitx.h"
+
+#define HDMI_1PX_IDENTIFIER 0x000C03
+#define HDMI_2P0_IDENTIFIER 0xC45DD8
+
+extern struct edid_information hdmitx_edid_info;
+
+int rtk_edid_header_is_valid(const u8 *raw_edid);
+bool rtk_edid_block_valid(u8 *raw_edid, int block);
+bool rtk_detect_hdmi_monitor(struct edid *edid);
+struct edid *rtk_get_base_edid(void);
+struct edid *rtk_get_edid(asoc_hdmi_t *hdmi);
+int rtk_do_probe_ddc_edid(unsigned char *buf, int block, int len);
+bool rtk_edid_is_valid(struct edid *edid);
+int rtk_add_edid_modes(struct edid *edid, struct sink_capabilities_t *sink_cap);
+void rtk_edid_to_eld(struct edid *edid, struct sink_capabilities_t *sink_cap);
+
+void print_established_modes(u32 est_format);
+void print_cea_modes(u64 cea_format, u64 cea_format2, u64 cea_format2_420);
+void print_deep_color(u32 var);
+void print_color_formats(u32 var);
+void print_color_space(u8 var);
+void hdmi_print_raw_edid(unsigned char *edid);
+
+/* rtk_edid_filter.c */
+int rtk_filter_specific_profuct_vic(struct edid *edid,
+	struct sink_capabilities_t *sink_cap);
+
+#endif /* _RTK_EDID_H_*/
diff --git a/drivers/media/platform/rtk_hdmitx/rtk_edid_filter.c b/drivers/media/platform/rtk_hdmitx/rtk_edid_filter.c
new file mode 100644
index 00000000..387dfd7
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/rtk_edid_filter.c
@@ -0,0 +1,97 @@
+/*
+ * rtk_edid_filter.c - RTK hdmitx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <drm/drm_edid.h>
+#include <drm/drm_crtc.h>
+#include <linux/types.h>
+#include <soc/realtek/rtk_chip.h>
+
+#include "hdmitx.h"
+#include "rtk_edid.h"
+
+
+struct edid_product_info_t {
+	unsigned char mfg_name[2];
+	unsigned char prod_code[2];
+	unsigned int serial;
+	__u64 vic_mask;/* VIC 1~64, BIT0=VIC1 */
+	__u64 vic2_mask;/* VIC 65~128, BIT0=VIC65 */
+	unsigned char extended_vic_mask;
+	__u64 vic2_420_mask;/* YCbCr420 format, VIC 65~128, BIT0=VIC65 */
+};
+
+
+#define PRODUCT_INFO_SIZE 3
+
+static const struct edid_product_info_t product_info[] = {
+	{.mfg_name[0] = 0x2E, .mfg_name[1] = 0x83,
+	.prod_code[0] = 0x00, .prod_code[1] = 0x55,
+	.serial = 1,
+	.vic_mask = 0xFFFFFFFFFFFFFFFF,
+	.vic2_mask = 0x0,
+	.extended_vic_mask = 0x0,
+	.vic2_420_mask = 0x0},
+	/* DENON_AVR-2312CI */
+	{.mfg_name[0] = 0x11, .mfg_name[1] = 0xee,
+	.prod_code[0] = 0x28, .prod_code[1] = 0x00,
+	.serial = 0x01010101,
+	.vic_mask = 0xFFFFFFFFFFFFFFFF,
+	.vic2_mask = 0x0,
+	.extended_vic_mask = 0x0,
+	.vic2_420_mask = 0x0},
+	/* DENON_AVR-1610 */
+	{.mfg_name[0] = 0x11, .mfg_name[1] = 0xee,
+	.prod_code[0] = 0x14, .prod_code[1] = 0x00,
+	.serial = 0x01010101,
+	.vic_mask = 0xFFFFFFFFFFFFFFFF,
+	.vic2_mask = 0x0,
+	.extended_vic_mask = 0x0,
+	.vic2_420_mask = 0x0},
+};
+
+int rtk_filter_specific_profuct_vic(struct edid *edid, struct sink_capabilities_t *sink_cap)
+{
+	int i;
+
+	if (get_rtd_chip_id() == CHIP_ID_RTD1392) {
+		/* Filter 4K VIC */
+		sink_cap->vic2 = 0;
+		sink_cap->extended_vic = 0;
+		sink_cap->vic2_420 = 0;
+	} else if ((get_rtd_chip_id() == CHIP_ID_RTD1395) && (get_rtd_chip_revision() == RTD_CHIP_A02)) {
+		sink_cap->vic2 = 0;
+		sink_cap->extended_vic = 0;
+		sink_cap->vic2_420 = 0;
+	}
+
+	for (i = 0; i < PRODUCT_INFO_SIZE; i++) {
+		if ((edid->mfg_id[0] == product_info[i].mfg_name[0]) &&
+			(edid->mfg_id[1] == product_info[i].mfg_name[1]) &&
+			(edid->prod_code[0] == product_info[i].prod_code[0]) &&
+			(edid->prod_code[1] == product_info[i].prod_code[1]) &&
+			(edid->serial == product_info[i].serial)) {
+
+			sink_cap->vic = sink_cap->vic&product_info[i].vic_mask;
+			sink_cap->vic2 = sink_cap->vic2&product_info[i].vic2_mask;
+			sink_cap->extended_vic = sink_cap->extended_vic&product_info[i].extended_vic_mask;
+			sink_cap->vic2_420 = sink_cap->vic2_420&product_info[i].vic2_420_mask;
+
+			HDMI_INFO("Filter vic_mask=0x%llx", product_info[i].vic_mask);
+			HDMI_INFO("Filter extended_vic_mask=%u", product_info[i].extended_vic_mask);
+			HDMI_INFO("Filter vic2_mask=0x%llx", product_info[i].vic2_mask);
+			HDMI_INFO("Filter vic2_420_mask=0x%llx", product_info[i].vic2_420_mask);
+
+			return 1;
+		}
+	}
+	return 0;
+}
+
diff --git a/drivers/media/platform/rtk_hdmitx/rtk_mute_gpio.c b/drivers/media/platform/rtk_hdmitx/rtk_mute_gpio.c
new file mode 100644
index 00000000..6f082b7
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/rtk_mute_gpio.c
@@ -0,0 +1,117 @@
+/*
+ * rtk_mute_gpio.c - RTK hdmitx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/platform_device.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/gpio.h>
+#include <linux/timer.h>
+
+#include "hdmitx.h"
+
+#define AUDIO_MUTE_ON	0
+#define AUDIO_MUTE_OFF	1
+
+struct device_node *hdmitx_dev_node;
+static int audio_mute_gpio = -1;
+struct timer_list *mute_gpio_timer;
+static int i2s_ctrl_gpio = -1;
+
+
+void set_mute_gpio(int gpio_number, int gpio_value)
+{
+	if (gpio_request(gpio_number, hdmitx_dev_node->name)) {
+		HDMI_ERROR("[%s] Request gpio(%d) fail", __func__, gpio_number);
+	} else {
+		HDMI_INFO("Set audio mute GPIO (%u)", gpio_value);
+		gpio_direction_output(gpio_number, gpio_value);
+		gpio_free(gpio_number);
+	}
+}
+
+static void mute_gpio_timer_callback(unsigned long data)
+{
+	set_mute_gpio(audio_mute_gpio, AUDIO_MUTE_OFF);
+}
+
+void set_mute_gpio_pulse(void)
+{
+	if ((audio_mute_gpio < 0) || (mute_gpio_timer == NULL))
+		return;
+
+	set_mute_gpio(audio_mute_gpio, AUDIO_MUTE_ON);
+
+	/* Disable mute after 3 sec */
+	mod_timer(mute_gpio_timer, jiffies + msecs_to_jiffies(3000));
+}
+
+/**
+ * set_i2s_output - Control I2S audio output DAC
+ */
+void set_i2s_output(int gpio_value)
+{
+	int gpio_number;
+
+	if (i2s_ctrl_gpio < 0)
+		return;
+
+	gpio_number = i2s_ctrl_gpio;
+	if (gpio_request(gpio_number, hdmitx_dev_node->name)) {
+		HDMI_ERROR("[%s] Request gpio(%d) fail", __func__, gpio_number);
+	} else {
+		HDMI_INFO("Set i2s_ctrl_gpio=%u", gpio_value);
+		gpio_direction_output(gpio_number, gpio_value);
+		gpio_free(gpio_number);
+	}
+}
+
+/**
+ * setup_mute_gpio - Initial audio DAC mute pin control
+ */
+void setup_mute_gpio(struct device_node *dev_node)
+{
+	HDMI_INFO("[%s]", __func__);
+
+	hdmitx_dev_node = dev_node;
+
+	audio_mute_gpio = of_get_named_gpio(hdmitx_dev_node,
+						"gpio-audio-mute", 0);
+
+	if (audio_mute_gpio < 0) {
+		HDMI_INFO("Undefined gpio-audio-mute, sikp");
+		goto i2s;
+	} else {
+		HDMI_INFO("audio mute gpio(%d)", audio_mute_gpio);
+	}
+
+	set_mute_gpio(audio_mute_gpio, AUDIO_MUTE_OFF);
+
+	mute_gpio_timer = kmalloc(sizeof(struct timer_list), GFP_KERNEL);
+	if (mute_gpio_timer != NULL)
+		setup_timer(mute_gpio_timer, mute_gpio_timer_callback, 0);
+	else
+		HDMI_ERROR("[%s] kmalloc fail", __func__);
+
+i2s:
+	i2s_ctrl_gpio = of_get_named_gpio(hdmitx_dev_node,
+						"gpio-i2s-ctrl", 0);
+
+	if (i2s_ctrl_gpio < 0) {
+		HDMI_INFO("Undefined gpio-i2s-ctrl, sikp");
+		goto end;
+	} else {
+		HDMI_INFO("i2s control gpio(%d)", i2s_ctrl_gpio);
+	}
+
+end:
+	return;
+}
diff --git a/drivers/media/platform/rtk_hdmitx/switch_hdmitx.c b/drivers/media/platform/rtk_hdmitx/switch_hdmitx.c
new file mode 100644
index 00000000..6f71a69
--- /dev/null
+++ b/drivers/media/platform/rtk_hdmitx/switch_hdmitx.c
@@ -0,0 +1,361 @@
+/*
+ * switch_hdmitx.c - RTK hdmitx driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/switch.h>
+#include <linux/device.h>
+#include <linux/kthread.h>
+#include <linux/delay.h>
+
+#include <linux/platform_device.h>
+#include <linux/gpio.h>
+#include <linux/irq.h>
+#include <linux/interrupt.h>
+#include <linux/workqueue.h>
+#include <linux/slab.h>
+
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_gpio.h>
+
+#include "hdmitx.h"
+#include "hdmitx_dev.h"
+#include "hdmitx_api.h"
+#include "rtk_edid.h"
+#include "hdmitx_scdc.h"
+
+#define HDMI_SWITCH_NAME "hdmi"
+
+#ifdef CONFIG_RTK_HDMIRX
+extern void HdmiRx_save_tx_physical_addr(unsigned char byteMSB, unsigned char byteLSB);
+#ifdef CONFIG_RTK_HDCPRX_2P2
+extern void Hdmi_SetHPD(char high);
+#else
+#define Hdmi_SetHPD(format, ...)
+#endif /* CONFIG_RTK_HDCPRX_2P2 */
+#else
+#define HdmiRx_save_tx_physical_addr(format, ...)
+#define Hdmi_SetHPD(format, ...)
+#endif /* CONFIG_RTK_HDMIRX */
+
+static struct hdmitx_switch_data s_data;
+static struct switch_dev *sdev = NULL;
+
+#if HDMI_RX_SENSE_SUPPORT
+static struct task_struct *hdmitx_hpd_tsk;
+#define RX_SENSE_COUNT_MAX 2
+#endif
+
+int hdmitx_switch_get_state(void)
+{
+	return s_data.state;
+}
+
+void hdmitx_send_hdmioff(void)
+{
+	struct VIDEO_RPC_VOUT_CONFIG_TV_SYSTEM tv_system;
+
+	HDMI_INFO("[%s]", __func__);
+
+	memset(&tv_system, 0, sizeof(tv_system));
+	tv_system.videoInfo.standard = VO_STANDARD_NTSC_J;
+	tv_system.videoInfo.enProg = 0x1;
+	tv_system.videoInfo.pedType = 0x1;
+	tv_system.videoInfo.dataInt0 = 0x4;
+	tv_system.hdmiInfo.hdmiMode = VO_HDMI_OFF;
+	tv_system.hdmiInfo.hdmi_off_mode = VO_HDMI_OFF_CLOCK_OFF;
+
+	RPC_TOAGENT_HDMI_Config_TV_System(&tv_system);
+}
+
+#if HDMI_RX_SENSE_SUPPORT
+int hdmitx_switch_get_hpd(void)
+{
+	return s_data.hpd_state;
+}
+
+static int hdmitx_switch_thread(void *arg)
+{
+	int state = 0;
+	int hpd;
+	unsigned char rxsense;
+	unsigned char rxsense_count = 0;
+	hdmitx_device_t *pdev = container_of(sdev, hdmitx_device_t, sdev);
+
+	for (;;) {
+		if (kthread_should_stop())
+			break;
+
+		hpd = gpio_get_value(s_data.pin);
+
+		if (hpd) {
+			if (s_data.hpd_state == 1)
+				rxsense = hdmitx_check_rx_sense(pdev->reg_base);
+			else /* Clk is off, don't read rx sense for prevent sb2 error */
+				rxsense = 1;
+
+			if ((rxsense == 0) && (rxsense_count < RX_SENSE_COUNT_MAX)) {
+				rxsense_count++;
+				state = 1;
+			} else if ((rxsense == 0) && (rxsense_count >= RX_SENSE_COUNT_MAX)) {
+				state = 0;
+			} else {
+				state = 1;
+			}
+		} else {
+			rxsense = 0;
+			rxsense_count = 0;
+			state = 0;
+
+			/* Pulled out cable when switch state is 0, send hdmi off rpc */
+			if ((s_data.hpd_state == 1) && (s_data.state == 0)) {
+				s_data.hpd_state = 0;
+				hdmitx_send_hdmioff();
+			}
+		}
+
+		s_data.hpd_state = hpd;
+
+		if (state != s_data.state) {
+			HDMI_INFO("%s:start, HPD(%d) RX_Sense(%u)", state?"plugged in":"pulled out", hpd, rxsense);
+
+			if (state == 1) {
+				hdmitx_get_sink_capability((asoc_hdmi_t *)hdmitx_get_drvdata(pdev));
+				rxsense_count = 0;
+				set_i2s_output(I2S_OUT_OFF);
+			} else {
+				hdmitx_reset_sink_capability((asoc_hdmi_t *)hdmitx_get_drvdata(pdev));
+				set_i2s_output(I2S_OUT_ON);
+			}
+
+			s_data.state = state;
+			switch_set_state(sdev, s_data.state);
+			HDMI_INFO("%s:done", s_data.state?"plugged in":"pulled out");
+		}
+
+		msleep(700);
+	} /* end of for(;;) */
+
+	return 0;
+}
+#else
+static void hdmitx_switch_work_func(struct work_struct *work)
+{
+	int state;
+	int sink_changed = 0;
+	hdmitx_device_t *pdev = container_of(sdev, hdmitx_device_t, sdev);
+	asoc_hdmi_t *drvdata = (asoc_hdmi_t *)hdmitx_get_drvdata(pdev);
+
+	state = gpio_get_value(s_data.pin);
+
+	HDMI_INFO("%s:start", state?"plugged in":"pulled out");
+
+	if (state == 1)
+		sink_changed = hdmitx_get_sink_capability(drvdata);
+	else
+		hdmitx_reset_sink_capability(drvdata);
+
+	if (sink_changed)
+		hdmitx_dump_error_code();
+
+	HDMI_INFO("%s:done", state?"plugged in":"pulled out");
+
+	if (state != switch_get_state(sdev)) {
+		s_data.state = state;
+		switch_set_state(sdev, s_data.state);
+		HDMI_INFO("Switch state to %u", s_data.state);
+
+		if (s_data.state == 1) {
+			/* HDMI 1.4 CTS 9-5 PA increment, also include hotplug pluse for HDCP repeater CTS */
+			if (get_hpd_interlock())
+				HdmiRx_save_tx_physical_addr(
+					drvdata->sink_cap.cec_phy_addr[0],
+					drvdata->sink_cap.cec_phy_addr[1]);
+
+			if (hdmitx_edid_info.scdc_capable&SCDC_RR_CAPABLE)
+				enable_hdmitx_scdcrr(1);
+
+			set_i2s_output(I2S_OUT_OFF);
+		} else {
+			if (get_hpd_interlock())
+				Hdmi_SetHPD(0);/* Set HDMI RX HPD */
+
+			enable_hdmitx_scdcrr(0);
+			set_i2s_output(I2S_OUT_ON);
+		}
+	}
+
+#if 1//def __LINUX_MEDIA_NAS__
+	wake_up_interruptible(&pdev->hpd_wait);
+#endif
+}
+#endif /* end of #if HDMI_RX_SENSE_SUPPORT */
+
+static irqreturn_t hdmitx_switch_isr(int irq, void *data)
+{
+	schedule_work(&s_data.work);
+	HDMI_DEBUG("hdmitx_switch_isr");
+
+	return IRQ_HANDLED;
+}
+
+int register_hdmitx_switchdev(hdmitx_device_t *device)
+{
+	int ret;
+	int hpd_state;
+
+	HDMI_DEBUG("register_hdmitx_switch");
+
+	if (&device->sdev == NULL)
+		return -ENOMEM;
+
+	sdev = &device->sdev;
+	sdev->name = HDMI_SWITCH_NAME;
+
+	ret = switch_dev_register(sdev);
+	if (ret < 0) {
+		HDMI_ERROR("err_register_switch");
+		goto err_register_switch;
+	}
+
+	/* Get hotplug pin state */
+	s_data.pin  = device->hpd_gpio;
+	s_data.state = 0;
+	gpio_direction_input(s_data.pin);
+	gpio_set_debounce(s_data.pin, 30*1000); /* 30ms */
+	hpd_state = gpio_get_value(s_data.pin);
+
+#if HDMI_RX_SENSE_SUPPORT
+	/* Hotplug/Rxsense detect polling therad */
+	hdmitx_hpd_tsk = kthread_run(hdmitx_switch_thread, sdev, "hdmitx_hpd_thread");
+	if (IS_ERR(hdmitx_hpd_tsk)) {
+		HDMI_ERROR("Create hdmitx_hpd_tsk fail");
+		goto err_register_switch;
+	}
+#else
+	/* Init hotplug work function and ISR */
+	INIT_WORK(&s_data.work, hdmitx_switch_work_func);
+
+	if (hpd_state)
+		schedule_work(&s_data.work);
+
+	s_data.irq = device->hpd_irq;
+
+	irq_set_irq_type(s_data.irq, IRQ_TYPE_EDGE_BOTH);
+	ret = request_irq(s_data.irq, hdmitx_switch_isr, IRQF_SHARED, "switch_hdmitx", &device->dev);
+	if (ret)
+		HDMI_ERROR("Cannot register IRQ %d", s_data.irq);
+#endif
+
+	goto end;
+
+err_register_switch:
+	HDMI_ERROR("register_hdmitx_switch failed");
+end:
+	return ret;
+}
+EXPORT_SYMBOL(register_hdmitx_switchdev);
+
+
+void deregister_hdmitx_switchdev(hdmitx_device_t *device)
+{
+	return switch_dev_unregister(&device->sdev);
+}
+EXPORT_SYMBOL(deregister_hdmitx_switchdev);
+
+
+int show_hpd_status(bool real_time)
+{
+	if (real_time)
+		return gpio_get_value(s_data.pin);
+	else
+		return s_data.state;
+}
+EXPORT_SYMBOL(show_hpd_status);
+
+
+int rtk_hdmitx_switch_suspend(void)
+{
+	int ret;
+	hdmitx_device_t *pdev;
+
+	pdev = container_of(sdev, hdmitx_device_t, sdev);
+
+#if HDMI_RX_SENSE_SUPPORT
+	ret = kthread_stop(hdmitx_hpd_tsk);
+	if (!ret)
+		HDMI_INFO("hdmitx_hpd_tsk stopped");
+	else
+		HDMI_ERROR("Stop hdmitx_hpd_tsk fail");
+#else
+	disable_irq(s_data.irq);
+	free_irq(s_data.irq, &pdev->dev);
+	HDMI_DEBUG("%s free irq=%x ", __func__, s_data.irq);
+
+	/* Cancel work and wait for it to finish */
+	cancel_work_sync(&s_data.work);
+#endif
+
+	return 0;
+}
+EXPORT_SYMBOL(rtk_hdmitx_switch_suspend);
+
+int rtk_hdmitx_switch_resume(void)
+{
+	int ret;
+	hdmitx_device_t *pdev;
+	asoc_hdmi_t *drvdata;
+
+	pdev = container_of(sdev, hdmitx_device_t, sdev);
+	drvdata = (asoc_hdmi_t *) hdmitx_get_drvdata(pdev);
+
+	gpio_set_debounce(s_data.pin, 30*1000); /* 30ms */
+
+#if HDMI_RX_SENSE_SUPPORT
+	hdmitx_hpd_tsk = kthread_run(hdmitx_switch_thread, sdev, "hdmitx_hpd_thread");
+	if (IS_ERR(hdmitx_hpd_tsk))
+		HDMI_ERROR("Create hdmitx_hpd_tsk fail");
+	else
+		HDMI_INFO("Wake up hdmitx_hpd_tsk");
+#else
+
+	s_data.state = gpio_get_value(s_data.pin);
+
+	if (s_data.state == 0) {
+		hdmitx_reset_sink_capability(drvdata);
+		switch_set_state(sdev, 0);
+		HDMI_INFO("Switch state to 0");
+	} else {
+		if (!hdmitx_check_same_edid(drvdata)) {
+			hdmitx_reset_sink_capability(drvdata);
+			hdmitx_get_sink_capability(drvdata);
+		}
+		switch_set_state(sdev, 1);
+		HDMI_INFO("Switch state to 1");
+
+		HdmiRx_save_tx_physical_addr(drvdata->sink_cap.cec_phy_addr[0], drvdata->sink_cap.cec_phy_addr[1]);
+		if (hdmitx_edid_info.scdc_capable&SCDC_RR_CAPABLE)
+			enable_hdmitx_scdcrr(1);
+	}
+
+	irq_set_irq_type(s_data.irq, IRQ_TYPE_EDGE_BOTH);
+	ret = request_irq(s_data.irq, hdmitx_switch_isr, IRQF_SHARED, "switch_hdmitx", &pdev->dev);
+	if (ret)
+		HDMI_ERROR("Cannot register IRQ %d", s_data.irq);
+#endif
+
+	return 0;
+}
+EXPORT_SYMBOL(rtk_hdmitx_switch_resume);
+
diff --git a/drivers/media/usb/uvc/uvc_driver.c b/drivers/media/usb/uvc/uvc_driver.c
index cde43b6..fc55fa0 100644
--- a/drivers/media/usb/uvc/uvc_driver.c
+++ b/drivers/media/usb/uvc/uvc_driver.c
@@ -2184,7 +2184,7 @@ static int uvc_reset_resume(struct usb_interface *intf)
  * Module parameters
  */
 
-static int uvc_clock_param_get(char *buffer, struct kernel_param *kp)
+static int uvc_clock_param_get(char *buffer, const struct kernel_param *kp)
 {
 	if (uvc_clock_param == CLOCK_MONOTONIC)
 		return sprintf(buffer, "CLOCK_MONOTONIC");
@@ -2192,7 +2192,7 @@ static int uvc_clock_param_get(char *buffer, struct kernel_param *kp)
 		return sprintf(buffer, "CLOCK_REALTIME");
 }
 
-static int uvc_clock_param_set(const char *val, struct kernel_param *kp)
+static int uvc_clock_param_set(const char *val, const struct kernel_param *kp)
 {
 	if (strncasecmp(val, "clock_", strlen("clock_")) == 0)
 		val += strlen("clock_");
@@ -2257,7 +2257,11 @@ static int uvc_clock_param_set(const char *val, struct kernel_param *kp)
 	  .bInterfaceClass	= USB_CLASS_VIDEO,
 	  .bInterfaceSubClass	= 1,
 	  .bInterfaceProtocol	= 0,
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	  .driver_info		= UVC_QUIRK_PROBE_MINMAX | UVC_QUIRK_PROBE_DEF},
+#else
 	  .driver_info		= UVC_QUIRK_PROBE_MINMAX },
+#endif
 	/* Microsoft Lifecam NX-3000 */
 	{ .match_flags		= USB_DEVICE_ID_MATCH_DEVICE
 				| USB_DEVICE_ID_MATCH_INT_INFO,
diff --git a/drivers/media/usb/uvc/uvc_video.c b/drivers/media/usb/uvc/uvc_video.c
index b5589d5..112ac86 100644
--- a/drivers/media/usb/uvc/uvc_video.c
+++ b/drivers/media/usb/uvc/uvc_video.c
@@ -1169,8 +1169,13 @@ static void uvc_video_decode_isoc(struct urb *urb, struct uvc_streaming *stream,
 			uvc_trace(UVC_TRACE_FRAME, "USB isochronous frame "
 				"lost (%d).\n", urb->iso_frame_desc[i].status);
 			/* Mark the buffer as faulty. */
+#ifdef CONFIG_USB_PATCH_ON_RTK
+			if (buf != NULL && urb->iso_frame_desc[i].status != -EXDEV)
+				buf->error = 1;
+#else
 			if (buf != NULL)
 				buf->error = 1;
+#endif
 			continue;
 		}
 
diff --git a/drivers/media/v4l2-core/v4l2-ioctl.c b/drivers/media/v4l2-core/v4l2-ioctl.c
index 4510e8a..610caa1 100644
--- a/drivers/media/v4l2-core/v4l2-ioctl.c
+++ b/drivers/media/v4l2-core/v4l2-ioctl.c
@@ -2455,11 +2455,8 @@ struct v4l2_ioctl_info {
 	unsigned int ioctl;
 	u32 flags;
 	const char * const name;
-	union {
-		u32 offset;
-		int (*func)(const struct v4l2_ioctl_ops *ops,
-				struct file *file, void *fh, void *p);
-	} u;
+	int (*func)(const struct v4l2_ioctl_ops *ops, struct file *file,
+		    void *fh, void *p);
 	void (*debug)(const void *arg, bool write_only);
 };
 
@@ -2467,25 +2464,21 @@ struct v4l2_ioctl_info {
 #define INFO_FL_PRIO	(1 << 0)
 /* This control can be valid if the filehandle passes a control handler. */
 #define INFO_FL_CTRL	(1 << 1)
-/* This is a standard ioctl, no need for special code */
-#define INFO_FL_STD	(1 << 2)
 /* This is ioctl has its own function */
-#define INFO_FL_FUNC	(1 << 3)
+#define INFO_FL_FUNC	(1 << 2)
 /* Queuing ioctl */
-#define INFO_FL_QUEUE	(1 << 4)
+#define INFO_FL_QUEUE	(1 << 3)
 /* Zero struct from after the field to the end */
 #define INFO_FL_CLEAR(v4l2_struct, field)			\
 	((offsetof(struct v4l2_struct, field) +			\
 	  sizeof(((struct v4l2_struct *)0)->field)) << 16)
 #define INFO_FL_CLEAR_MASK (_IOC_SIZEMASK << 16)
 
-#define IOCTL_INFO_STD(_ioctl, _vidioc, _debug, _flags)			\
-	[_IOC_NR(_ioctl)] = {						\
-		.ioctl = _ioctl,					\
-		.flags = _flags | INFO_FL_STD,				\
-		.name = #_ioctl,					\
-		.u.offset = offsetof(struct v4l2_ioctl_ops, _vidioc),	\
-		.debug = _debug,					\
+#define DEFINE_IOCTL_STD_FNC(_vidioc) \
+	static int __v4l_ ## _vidioc ## _fnc(				\
+			const struct v4l2_ioctl_ops *ops, 		\
+			struct file *file, void *fh, void *p) {		\
+		return ops->_vidioc(file, fh, p); 			\
 	}
 
 #define IOCTL_INFO_FNC(_ioctl, _func, _debug, _flags)			\
@@ -2493,10 +2486,44 @@ struct v4l2_ioctl_info {
 		.ioctl = _ioctl,					\
 		.flags = _flags | INFO_FL_FUNC,				\
 		.name = #_ioctl,					\
-		.u.func = _func,					\
+		.func = _func,						\
 		.debug = _debug,					\
 	}
 
+#define IOCTL_INFO_STD(_ioctl, _vidioc, _debug, _flags)	\
+	IOCTL_INFO_FNC(_ioctl, __v4l_ ## _vidioc ## _fnc, _debug, _flags)
+
+DEFINE_IOCTL_STD_FNC(vidioc_g_fbuf)
+DEFINE_IOCTL_STD_FNC(vidioc_s_fbuf)
+DEFINE_IOCTL_STD_FNC(vidioc_expbuf)
+DEFINE_IOCTL_STD_FNC(vidioc_g_std)
+DEFINE_IOCTL_STD_FNC(vidioc_g_audio)
+DEFINE_IOCTL_STD_FNC(vidioc_s_audio)
+DEFINE_IOCTL_STD_FNC(vidioc_g_input)
+DEFINE_IOCTL_STD_FNC(vidioc_g_edid)
+DEFINE_IOCTL_STD_FNC(vidioc_s_edid)
+DEFINE_IOCTL_STD_FNC(vidioc_g_output)
+DEFINE_IOCTL_STD_FNC(vidioc_g_audout)
+DEFINE_IOCTL_STD_FNC(vidioc_s_audout)
+DEFINE_IOCTL_STD_FNC(vidioc_g_selection)
+DEFINE_IOCTL_STD_FNC(vidioc_s_selection)
+DEFINE_IOCTL_STD_FNC(vidioc_g_jpegcomp)
+DEFINE_IOCTL_STD_FNC(vidioc_s_jpegcomp)
+DEFINE_IOCTL_STD_FNC(vidioc_enumaudio)
+DEFINE_IOCTL_STD_FNC(vidioc_enumaudout)
+DEFINE_IOCTL_STD_FNC(vidioc_enum_framesizes)
+DEFINE_IOCTL_STD_FNC(vidioc_enum_frameintervals)
+DEFINE_IOCTL_STD_FNC(vidioc_g_enc_index)
+DEFINE_IOCTL_STD_FNC(vidioc_encoder_cmd)
+DEFINE_IOCTL_STD_FNC(vidioc_try_encoder_cmd)
+DEFINE_IOCTL_STD_FNC(vidioc_decoder_cmd)
+DEFINE_IOCTL_STD_FNC(vidioc_try_decoder_cmd)
+DEFINE_IOCTL_STD_FNC(vidioc_s_dv_timings)
+DEFINE_IOCTL_STD_FNC(vidioc_g_dv_timings)
+DEFINE_IOCTL_STD_FNC(vidioc_enum_dv_timings)
+DEFINE_IOCTL_STD_FNC(vidioc_query_dv_timings)
+DEFINE_IOCTL_STD_FNC(vidioc_dv_timings_cap)
+
 static struct v4l2_ioctl_info v4l2_ioctls[] = {
 	IOCTL_INFO_FNC(VIDIOC_QUERYCAP, v4l_querycap, v4l_print_querycap, 0),
 	IOCTL_INFO_FNC(VIDIOC_ENUM_FMT, v4l_enum_fmt, v4l_print_fmtdesc, INFO_FL_CLEAR(v4l2_fmtdesc, type)),
@@ -2681,14 +2708,8 @@ static long __video_do_ioctl(struct file *file,
 	}
 
 	write_only = _IOC_DIR(cmd) == _IOC_WRITE;
-	if (info->flags & INFO_FL_STD) {
-		typedef int (*vidioc_op)(struct file *file, void *fh, void *p);
-		const void *p = vfd->ioctl_ops;
-		const vidioc_op *vidioc = p + info->u.offset;
-
-		ret = (*vidioc)(file, fh, arg);
-	} else if (info->flags & INFO_FL_FUNC) {
-		ret = info->u.func(ops, file, fh, arg);
+	if (info->flags & INFO_FL_FUNC) {
+		ret = info->func(ops, file, fh, arg);
 	} else if (!ops->vidioc_default) {
 		ret = -ENOTTY;
 	} else {
diff --git a/drivers/message/fusion/mptbase.c b/drivers/message/fusion/mptbase.c
index 89c7ed1..1cdab6d 100644
--- a/drivers/message/fusion/mptbase.c
+++ b/drivers/message/fusion/mptbase.c
@@ -99,7 +99,7 @@
 MODULE_PARM_DESC(mpt_channel_mapping, " Mapping id's to channels (default=0)");
 
 static int mpt_debug_level;
-static int mpt_set_debug_level(const char *val, struct kernel_param *kp);
+static int mpt_set_debug_level(const char *val, const struct kernel_param *kp);
 module_param_call(mpt_debug_level, mpt_set_debug_level, param_get_int,
 		  &mpt_debug_level, 0600);
 MODULE_PARM_DESC(mpt_debug_level,
@@ -242,7 +242,7 @@ static int	ProcessEventNotification(MPT_ADAPTER *ioc,
 	pci_write_config_word(pdev, PCI_COMMAND, command_reg);
 }
 
-static int mpt_set_debug_level(const char *val, struct kernel_param *kp)
+static int mpt_set_debug_level(const char *val, const struct kernel_param *kp)
 {
 	int ret = param_set_int(val, kp);
 	MPT_ADAPTER *ioc;
diff --git a/drivers/mfd/Kconfig b/drivers/mfd/Kconfig
index c6df644..a91e49e 100644
--- a/drivers/mfd/Kconfig
+++ b/drivers/mfd/Kconfig
@@ -1643,5 +1643,37 @@ config MFD_VEXPRESS_SYSREG
 	  System Registers are the platform configuration block
 	  on the ARM Ltd. Versatile Express board.
 
+config MFD_G22XX
+	tristate
+	select MFD_CORE
+
+config MFD_G2227_I2C
+	tristate "Support for GMT-G2227 PMIC"
+	depends on I2C
+	select MFD_G22XX
+	select RTK_REGMAP_I2C
+
+config MFD_G2237_I2C
+	tristate "Support for GMT-G2237 PMIC"
+	depends on I2C
+	select MFD_G22XX
+	select RTK_REGMAP_I2C
+
+config MFD_APW888X
+	tristate
+	select MFD_CORE
+
+config MFD_APW8889_I2C
+	tristate "Support for Anpec-APW8889 PMIC"
+	depends on I2C
+	select MFD_APW888X
+	select RTK_REGMAP_I2C
+
+config MFD_APW8886_I2C
+	tristate "Support for Anpec-APW8886 PMIC"
+	depends on I2C
+	select MFD_APW888X
+	select RTK_REGMAP_I2C
+
 endmenu
 endif
diff --git a/drivers/mfd/Makefile b/drivers/mfd/Makefile
index 9834e66..b29928e 100644
--- a/drivers/mfd/Makefile
+++ b/drivers/mfd/Makefile
@@ -211,3 +211,12 @@ obj-$(CONFIG_INTEL_SOC_PMIC)	+= intel-soc-pmic.o
 obj-$(CONFIG_MFD_MT6397)	+= mt6397-core.o
 
 obj-$(CONFIG_MFD_ALTERA_A10SR)	+= altera-a10sr.o
+
+obj-$(CONFIG_MFD_G22XX) += g22xx-core.o
+obj-$(CONFIG_MFD_G2227_I2C) += g2227-i2c.o
+obj-$(CONFIG_MFD_G2237_I2C) += g2237-i2c.o
+
+obj-$(CONFIG_MFD_APW888X) += apw888x-core.o
+obj-$(CONFIG_MFD_APW8889_I2C) += apw8889-i2c.o
+obj-$(CONFIG_MFD_APW8886_I2C) += apw8886-i2c.o
+
diff --git a/drivers/mfd/apw8886-i2c.c b/drivers/mfd/apw8886-i2c.c
new file mode 100644
index 00000000..ab4d319
--- /dev/null
+++ b/drivers/mfd/apw8886-i2c.c
@@ -0,0 +1,173 @@
+/*
+ * apw8886-i2c.c - Anpec APW8886 PMIC I2C driver
+ *
+ * Copyright (C) 2018-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/i2c.h>
+#include <linux/module.h>
+#include <linux/regmap.h>
+#include <linux/mfd/apw888x.h>
+#include <linux/mfd/apw8886.h>
+#include <soc/realtek/rtk_regmap.h>
+
+/* regmap */
+static const struct reg_default apw8886_reg_defaults[] = {
+	{ .reg = APW8886_REG_ONOFF,        .def = 0xFD, },
+	{ .reg = APW8886_REG_DISCHG,       .def = 0xFD, },
+	{ .reg = APW8886_REG_DC1DC2_MODE,  .def = 0x22, },
+	{ .reg = APW8886_REG_DC3_MODE,     .def = 0x20, },
+	{ .reg = APW8886_REG_DC4DC5_MODE,  .def = 0x22, },
+	{ .reg = APW8886_REG_LDO1_MODE,    .def = 0x20, },
+	{ .reg = APW8886_REG_DC1_NRMVOLT,  .def = 0x2C, },
+	{ .reg = APW8886_REG_DC2_NRMVOLT,  .def = 0x1C, },
+	{ .reg = APW8886_REG_DC3_NRMVOLT,  .def = 0x24, },
+	{ .reg = APW8886_REG_DC4_NRMVOLT,  .def = 0x32, },
+	{ .reg = APW8886_REG_LDO1_NRMVOLT, .def = 0x12, },
+	{ .reg = APW8886_REG_DC1_SLPVOLT,  .def = 0x2C, },
+	{ .reg = APW8886_REG_DC2_SLPVOLT,  .def = 0x1C, },
+	{ .reg = APW8886_REG_DC3_SLPVOLT,  .def = 0x24, },
+	{ .reg = APW8886_REG_DC4_SLPVOLT,  .def = 0x32, },
+	{ .reg = APW8886_REG_LDO1_SLPVOLT, .def = 0x12, },
+	{ .reg = APW8886_REG_CLAMP,        .def = 0x00, },
+};
+
+static bool apw8886_regmap_readable_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case APW8886_REG_INTR ... APW8886_REG_PWRKEY:
+	case APW8886_REG_SYS_CONTROL ... APW8886_REG_LDO1_SLPVOLT:
+	case APW8886_REG_CLAMP:
+	case APW8886_REG_CHIP_ID:
+	case APW8886_REG_VERSION:
+		return true;
+	}
+	return false;
+}
+
+static bool apw8886_regmap_writeable_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case APW8886_REG_INTR_MASK ... APW8886_REG_PWRKEY:
+	case APW8886_REG_SYS_CONTROL ... APW8886_REG_LDO1_SLPVOLT:
+	case APW8886_REG_CLAMP:
+		return true;
+	}
+	return false;
+}
+
+static bool apw8886_regmap_volatile_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case APW8886_REG_INTR_MASK ... APW8886_REG_PWRKEY:
+	case APW8886_REG_SYS_CONTROL:
+	case APW8886_REG_CLAMP:
+	case APW8886_REG_CHIP_ID:
+	case APW8886_REG_VERSION:
+		return true;
+	}
+	return false;
+}
+
+static const struct regmap_config apw8886_regmap_config = {
+	.reg_bits         = 8,
+	.val_bits         = 8,
+	.max_register     = 0x1F,
+	.cache_type       = REGCACHE_FLAT,
+	.reg_defaults     = apw8886_reg_defaults,
+	.num_reg_defaults = ARRAY_SIZE(apw8886_reg_defaults),
+	.readable_reg     = apw8886_regmap_readable_reg,
+	.writeable_reg    = apw8886_regmap_writeable_reg,
+	.volatile_reg     = apw8886_regmap_volatile_reg,
+};
+
+static int apw8886_i2c_probe(struct i2c_client *client,
+			     const struct i2c_device_id *id)
+{
+	struct device *dev = &client->dev;
+	struct apw888x_device *adev;
+	int ret;
+	u32 chip_id, rev;
+
+	adev = devm_kzalloc(dev, sizeof(*adev), GFP_KERNEL);
+	if (!adev)
+		return -ENOMEM;
+
+	adev->regmap = devm_rtk_regmap_init_i2c(client, &apw8886_regmap_config);
+	if (IS_ERR(adev->regmap))
+		return PTR_ERR(adev->regmap);
+
+	/* show chip info */
+	ret = regmap_read(adev->regmap, APW8886_REG_CHIP_ID, &chip_id);
+	if (ret) {
+		dev_err(dev, "failed to read chip_id: %d\n", ret);
+		return ret;
+	}
+	if (chip_id != 0x5a && chip_id != 0x9a) {
+		dev_err(dev, "chip_id(%02x) not match\n", chip_id);
+		return -EINVAL;
+	}
+	regmap_read(adev->regmap, APW8886_REG_VERSION, &rev);
+	dev_info(dev, "apw8886(%02x) rev%d\n", chip_id, rev);
+
+	adev->chip_id = APW888X_DEVICE_ID_APW8886;
+	adev->chip_rev = rev;
+	adev->dev = dev;
+	i2c_set_clientdata(client, adev);
+
+	ret = apw888x_device_init(adev);
+	if (ret) {
+		dev_err(dev, "failed to add sub-devices: %d\n", ret);
+		return ret;
+	}
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static int apw8886_i2c_remove(struct i2c_client *client)
+{
+	struct device *dev = &client->dev;
+	struct apw888x_device *adev = i2c_get_clientdata(client);
+
+	apw888x_device_exit(adev);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+
+static const struct i2c_device_id apw8886_i2c_ids[] = {
+	{"apw8886", 0},
+	{}
+};
+MODULE_DEVICE_TABLE(i2c, apw8886_i2c_ids);
+
+static struct i2c_driver apw8886_i2c_driver = {
+	.driver = {
+		.name = "apw8886",
+		.owner = THIS_MODULE,
+	},
+	.id_table = apw8886_i2c_ids,
+	.probe    = apw8886_i2c_probe,
+	.remove   = apw8886_i2c_remove,
+};
+module_i2c_driver(apw8886_i2c_driver);
+
+MODULE_DESCRIPTION("Anpec APW8886 PMIC MFD Driver");
+MODULE_AUTHOR("Cheng-Yu Lee <cylee12@realtek.com>");
+MODULE_LICENSE("GPL");
diff --git a/drivers/mfd/apw8889-i2c.c b/drivers/mfd/apw8889-i2c.c
new file mode 100644
index 00000000..0df28ee
--- /dev/null
+++ b/drivers/mfd/apw8889-i2c.c
@@ -0,0 +1,176 @@
+/*
+ * apw8889-i2c.c - Anpec APW8889 PMIC I2C driver
+ *
+ * Copyright (C) 2018-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/i2c.h>
+#include <linux/module.h>
+#include <linux/regmap.h>
+#include <linux/mfd/apw888x.h>
+#include <linux/mfd/apw8889.h>
+#include <soc/realtek/rtk_regmap.h>
+
+/* regmap */
+static const struct reg_default apw8889_reg_defaults[] = {
+	{ .reg = APW8889_REG_ONOFF,        .def = 0xFD, },
+	{ .reg = APW8889_REG_DISCHG,       .def = 0xFD, },
+	{ .reg = APW8889_REG_DC1DC2_MODE,  .def = 0x22, },
+	{ .reg = APW8889_REG_DC3DC4_MODE,  .def = 0x22, },
+	{ .reg = APW8889_REG_DC5DC6_MODE,  .def = 0x22, },
+	{ .reg = APW8889_REG_LDO1_MODE,    .def = 0x20, },
+	{ .reg = APW8889_REG_DC1_NRMVOLT,  .def = 0x2C, },
+	{ .reg = APW8889_REG_DC2_NRMVOLT,  .def = 0x24, },
+	{ .reg = APW8889_REG_DC3_NRMVOLT,  .def = 0x24, },
+	{ .reg = APW8889_REG_DC4_NRMVOLT,  .def = 0x24, },
+	{ .reg = APW8889_REG_DC6_NRMVOLT,  .def = 0x32, },
+	{ .reg = APW8889_REG_LDO1_NRMVOLT, .def = 0x12, },
+	{ .reg = APW8889_REG_DC1_SLPVOLT,  .def = 0x2C, },
+	{ .reg = APW8889_REG_DC2_SLPVOLT,  .def = 0x24, },
+	{ .reg = APW8889_REG_DC3_SLPVOLT,  .def = 0x24, },
+	{ .reg = APW8889_REG_DC4_SLPVOLT,  .def = 0x24, },
+	{ .reg = APW8889_REG_DC6_SLPVOLT,  .def = 0x32, },
+	{ .reg = APW8889_REG_LDO1_SLPVOLT, .def = 0x12, },
+	{ .reg = APW8889_REG_CLAMP,        .def = 0x00, },
+};
+
+static bool apw8889_regmap_readable_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case APW8889_REG_INTR ... APW8889_REG_PWRKEY:
+	case APW8889_REG_SYS_CONTROL ... APW8889_REG_LDO1_SLPVOLT:
+	case APW8889_REG_CLAMP:
+	case APW8889_REG_CHIP_ID:
+	case APW8889_REG_VERSION:
+		return true;
+	}
+	return false;
+}
+
+static bool apw8889_regmap_writeable_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case APW8889_REG_INTR_MASK ... APW8889_REG_PWRKEY:
+	case APW8889_REG_SYS_CONTROL ... APW8889_REG_LDO1_SLPVOLT:
+	case APW8889_REG_CLAMP:
+		return true;
+	}
+	return false;
+}
+
+static bool apw8889_regmap_volatile_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case APW8889_REG_INTR_MASK ... APW8889_REG_PWRKEY:
+	case APW8889_REG_SYS_CONTROL:
+	case APW8889_REG_CLAMP:
+	case APW8889_REG_CHIP_ID:
+	case APW8889_REG_VERSION:
+		return true;
+	}
+	return false;
+}
+
+static const struct regmap_config apw8889_regmap_config = {
+	.reg_bits         = 8,
+	.val_bits         = 8,
+	.max_register     = 0x1F,
+	.cache_type       = REGCACHE_FLAT,
+	.reg_defaults     = apw8889_reg_defaults,
+	.num_reg_defaults = ARRAY_SIZE(apw8889_reg_defaults),
+	.readable_reg     = apw8889_regmap_readable_reg,
+	.writeable_reg    = apw8889_regmap_writeable_reg,
+	.volatile_reg     = apw8889_regmap_volatile_reg,
+};
+
+static int apw8889_i2c_probe(struct i2c_client *client,
+			     const struct i2c_device_id *id)
+{
+	struct device *dev = &client->dev;
+	struct apw888x_device *adev;
+	int ret;
+	u32 chip_id, rev;
+
+	adev = devm_kzalloc(dev, sizeof(*adev), GFP_KERNEL);
+	if (!adev)
+		return -ENOMEM;
+
+	adev->regmap = devm_rtk_regmap_init_i2c(client, &apw8889_regmap_config);
+	if (IS_ERR(adev->regmap))
+		return PTR_ERR(adev->regmap);
+
+	/* show chip info */
+	ret = regmap_read(adev->regmap, APW8889_REG_CHIP_ID, &chip_id);
+	if (ret) {
+		dev_err(dev, "failed to read chip_id: %d\n", ret);
+		return ret;
+	}
+	if (chip_id != 0x5a) {
+		dev_err(dev, "chip_id(%02x) not match\n", chip_id);
+		return -EINVAL;
+	}
+	regmap_read(adev->regmap, APW8889_REG_VERSION, &rev);
+	dev_info(dev, "apw8889(%02x) rev%d\n", chip_id, rev);
+
+	adev->chip_id = APW888X_DEVICE_ID_APW8889;
+	adev->chip_rev = rev;
+	adev->dev = dev;
+	i2c_set_clientdata(client, adev);
+
+	ret = apw888x_device_init(adev);
+	if (ret) {
+		dev_err(dev, "failed to add sub-devices: %d\n", ret);
+		return ret;
+	}
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static int apw8889_i2c_remove(struct i2c_client *client)
+{
+	struct device *dev = &client->dev;
+	struct apw888x_device *adev = i2c_get_clientdata(client);
+
+	apw888x_device_exit(adev);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+
+static const struct i2c_device_id apw8889_i2c_ids[] = {
+	{"apw8889", 0},
+	{}
+};
+MODULE_DEVICE_TABLE(i2c, apw8889_i2c_ids);
+
+struct i2c_driver apw8889_i2c_driver = {
+	.driver = {
+		.name = "apw8889",
+		.owner = THIS_MODULE,
+	},
+	.id_table = apw8889_i2c_ids,
+	.probe    = apw8889_i2c_probe,
+	.remove   = apw8889_i2c_remove,
+};
+EXPORT_SYMBOL_GPL(apw8889_i2c_driver);
+module_i2c_driver(apw8889_i2c_driver);
+
+MODULE_DESCRIPTION("Anpec APW8889 PMIC MFD Driver");
+MODULE_AUTHOR("Cheng-Yu Lee <cylee12@realtek.com>");
+MODULE_LICENSE("GPL");
diff --git a/drivers/mfd/apw888x-core.c b/drivers/mfd/apw888x-core.c
new file mode 100644
index 00000000..f2e92bf
--- /dev/null
+++ b/drivers/mfd/apw888x-core.c
@@ -0,0 +1,73 @@
+/*
+ * GMT-APW888X series PMIC MFD core
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/regmap.h>
+#include <linux/mfd/core.h>
+#include <linux/mfd/apw888x.h>
+
+static struct mfd_cell apw8889_devs[] = {
+	{
+		.name = "g22xx-powerkey",
+		.of_compatible = "gmt,g22xx-powerkey",
+	},
+	{
+		.name = "g22xx-poweroff",
+		.of_compatible = "gmt,g22xx-poweroff",
+	},
+	{
+		.name = "apw8889-regulator",
+		.of_compatible = "anpec,apw8889-regulator",
+	},
+};
+
+static struct mfd_cell apw8886_devs[] = {
+	{
+		.name = "g22xx-powerkey",
+		.of_compatible = "gmt,g22xx-powerkey",
+	},
+	{
+		.name = "g22xx-poweroff",
+		.of_compatible = "gmt,g22xx-poweroff",
+	},
+	{
+		.name = "apw8886-regulator",
+		.of_compatible = "anpec,apw8886-regulator",
+	},
+};
+
+int apw888x_device_init(struct apw888x_device *adev)
+{
+	switch (adev->chip_id) {
+	case APW888X_DEVICE_ID_APW8889:
+		return devm_mfd_add_devices(adev->dev, PLATFORM_DEVID_NONE,
+			apw8889_devs, ARRAY_SIZE(apw8889_devs), 0, 0, 0);
+	case APW888X_DEVICE_ID_APW8886:
+		return devm_mfd_add_devices(adev->dev, PLATFORM_DEVID_NONE,
+			apw8886_devs, ARRAY_SIZE(apw8886_devs), 0, 0, 0);
+	default:
+		return -EINVAL;
+	}
+	return 0;
+}
+
+void apw888x_device_exit(struct apw888x_device *adev)
+{}
diff --git a/drivers/mfd/g2227-i2c.c b/drivers/mfd/g2227-i2c.c
new file mode 100644
index 00000000..eee4e19
--- /dev/null
+++ b/drivers/mfd/g2227-i2c.c
@@ -0,0 +1,159 @@
+/*
+ * GMT-G2227 PMIC MFD driver
+ *
+ * Copyright (C) 2016-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *	Simon Hsu <simon_hsu@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/i2c.h>
+#include <linux/module.h>
+#include <linux/regmap.h>
+#include <linux/mfd/g2227.h>
+#include <linux/mfd/g22xx.h>
+#include <soc/realtek/rtk_regmap.h>
+
+/* regmap */
+static const struct reg_default g2227_regmap_defaults[] = {
+	{ .reg = G2227_REG_ONOFF,            .def = 0xff, },
+	{ .reg = G2227_REG_DISCHG,           .def = 0xff, },
+	{ .reg = G2227_REG_DC1DC2_MODE,      .def = 0x22, },
+	{ .reg = G2227_REG_DC3DC4_MODE,      .def = 0x22, },
+	{ .reg = G2227_REG_DC5DC6_MODE,      .def = 0x22, },
+	{ .reg = G2227_REG_LDO2LDO3_MODE,    .def = 0x22, },
+	{ .reg = G2227_REG_DC2_NRMVOLT,      .def = 0x10, },
+	{ .reg = G2227_REG_DC3_NRMVOLT,      .def = 0x10, },
+	{ .reg = G2227_REG_DC5_NRMVOLT,      .def = 0x10, },
+	{ .reg = G2227_REG_DC1DC6_NRMVOLT,   .def = 0xd0, },
+	{ .reg = G2227_REG_LDO2LDO3_NRMVOLT, .def = 0xa2, },
+	{ .reg = G2227_REG_DC2_SLPVOLT,      .def = 0x10, },
+	{ .reg = G2227_REG_DC3_SLPVOLT,      .def = 0x10, },
+	{ .reg = G2227_REG_DC5_SLPVOLT,      .def = 0x10, },
+	{ .reg = G2227_REG_DC1DC6_SLPVOLT,   .def = 0xd0, },
+	{ .reg = G2227_REG_LDO2LDO3_SLPVOLT, .def = 0xa2, },
+};
+
+static bool g2227_regmap_readable_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case G2227_REG_INTR ... G2227_REG_PWRKEY:
+	case G2227_REG_SYS_CONTROL ... G2227_REG_LDO2LDO3_MODE:
+	case G2227_REG_DC2_NRMVOLT ... G2227_REG_VERSION:
+		return true;
+	}
+	return false;
+}
+
+static bool g2227_regmap_writeable_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case G2227_REG_INTR_MASK ... G2227_REG_PWRKEY:
+	case G2227_REG_SYS_CONTROL ... G2227_REG_LDO2LDO3_MODE:
+	case G2227_REG_DC2_NRMVOLT ... G2227_REG_LDO2LDO3_SLPVOLT:
+		return true;
+	}
+	return false;
+}
+
+static bool g2227_regmap_volatile_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case G2227_REG_INTR_MASK ... G2227_REG_PWRKEY:
+	case G2227_REG_SYS_CONTROL:
+	case G2227_REG_VERSION:
+		return true;
+	}
+	return false;
+}
+
+static const struct regmap_config g2227_regmap_config = {
+	.reg_bits         = 8,
+	.val_bits         = 8,
+	.max_register     = 0x20,
+	.cache_type       = REGCACHE_FLAT,
+	.reg_defaults     = g2227_regmap_defaults,
+	.num_reg_defaults = ARRAY_SIZE(g2227_regmap_defaults),
+	.readable_reg     = g2227_regmap_readable_reg,
+	.writeable_reg    = g2227_regmap_writeable_reg,
+	.volatile_reg     = g2227_regmap_volatile_reg,
+};
+
+static int g2227_i2c_probe(struct i2c_client *client,
+	const struct i2c_device_id *id)
+{
+	struct device *dev = &client->dev;
+	struct g22xx_device *gdev;
+	int ret = 0;
+	unsigned int rev;
+
+	gdev = devm_kzalloc(dev, sizeof(*gdev), GFP_KERNEL);
+	if (gdev == NULL)
+		return -ENOMEM;
+
+	gdev->regmap = devm_rtk_regmap_init_i2c(client, &g2227_regmap_config);
+	if (IS_ERR(gdev->regmap)) {
+		ret = PTR_ERR(gdev->regmap);
+		dev_err(dev, "failed to allocate regmap: %d\n", ret);
+		return ret;
+	}
+
+	/* workaround */
+	regmap_read(gdev->regmap, G2227_REG_VERSION, &rev);
+
+	/* show version */
+	ret = regmap_read(gdev->regmap, G2227_REG_VERSION, &rev);
+	if (ret) {
+		dev_err(dev, "failed to read version: %d\n", ret);
+		return ret;
+	}
+	dev_info(dev, "g2227 rev%d\n", rev);
+	gdev->chip_id = G22XX_DEVICE_ID_G2227;
+	gdev->chip_rev = rev;
+	gdev->dev = dev;
+
+	i2c_set_clientdata(client, gdev);
+	ret = g22xx_device_init(gdev);
+	if (ret) {
+		dev_err(dev, "failed to add sub-devices: %d\n", ret);
+		return ret;
+	}
+	dev_info(dev, "initialized\n");
+	return ret;
+}
+
+static int g2227_i2c_remove(struct i2c_client *client)
+{
+	struct device *dev = &client->dev;
+	struct g22xx_device *gdev = i2c_get_clientdata(client);
+
+	g22xx_device_exit(gdev);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+static const struct i2c_device_id g2227_i2c_id[] = {
+	{ "g2227", 0 },
+	{}
+};
+MODULE_DEVICE_TABLE(i2c, g2227_i2c_id);
+
+static struct i2c_driver g2227_i2c_driver = {
+	.driver = {
+		.name = "g2227",
+	},
+	.probe = g2227_i2c_probe,
+	.remove = g2227_i2c_remove,
+	.id_table = g2227_i2c_id,
+};
+module_i2c_driver(g2227_i2c_driver);
+
+MODULE_DESCRIPTION("GMT G2227 PMIC MFD Driver");
+MODULE_AUTHOR("Simon Hsu <simon_hsu@realtek.com>");
+MODULE_AUTHOR("Cheng-Yu Lee <cylee12@realtek.com>");
+MODULE_LICENSE("GPL");
diff --git a/drivers/mfd/g2237-i2c.c b/drivers/mfd/g2237-i2c.c
new file mode 100644
index 00000000..7287027
--- /dev/null
+++ b/drivers/mfd/g2237-i2c.c
@@ -0,0 +1,169 @@
+/*
+ * GMT-G2237 PMIC MFD driver
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/module.h>
+#include <linux/i2c.h>
+#include <linux/mfd/g22xx.h>
+#include <linux/mfd/g2237.h>
+#include <linux/regmap.h>
+#include <linux/slab.h>
+#include <soc/realtek/rtk_regmap.h>
+
+/* regmap */
+static const struct reg_default g2237_reg_defaults[] = {
+	{ .reg = G2237_REG_ONOFF,        .def = 0xF9, },
+	{ .reg = G2237_REG_DISCHG,       .def = 0xF9, },
+	{ .reg = G2237_REG_DC1DC2_MODE,  .def = 0x22, },
+	{ .reg = G2237_REG_DC3DC4_MODE,  .def = 0x22, },
+	{ .reg = G2237_REG_DC5LDO1_MODE, .def = 0x22, },
+	{ .reg = G2237_REG_DC1_NRMVOLT,  .def = 0x0B, },
+	{ .reg = G2237_REG_DC2_NRMVOLT,  .def = 0x10, },
+	{ .reg = G2237_REG_DC3_NRMVOLT,  .def = 0x10, },
+	{ .reg = G2237_REG_DC5_NRMVOLT,  .def = 0x0C, },
+	{ .reg = G2237_REG_LDO1_NRMVOLT, .def = 0x03, },
+	{ .reg = G2237_REG_DC1_SLPVOLT,  .def = 0x0B, },
+	{ .reg = G2237_REG_DC2_SLPVOLT,  .def = 0x10, },
+	{ .reg = G2237_REG_DC3_SLPVOLT,  .def = 0x10, },
+	{ .reg = G2237_REG_DC5_SLPVOLT,  .def = 0x0C, },
+	{ .reg = G2237_REG_LDO1_SLPVOLT, .def = 0x03, },
+};
+
+static bool g2237_regmap_readable_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case G2237_REG_INTR ... G2237_REG_PWRKEY:
+	case G2237_REG_SYS_CONTROL ... G2237_REG_VERSION:
+		return true;
+	}
+	return false;
+}
+
+static bool g2237_regmap_writeable_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case G2237_REG_INTR_MASK ... G2237_REG_PWRKEY:
+	case G2237_REG_SYS_CONTROL ... G2237_REG_LDO1_SLPVOLT:
+		return true;
+	}
+	return false;
+}
+
+static bool g2237_regmap_volatile_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case G2237_REG_INTR ... G2237_REG_PWRKEY:
+	case G2237_REG_SYS_CONTROL:
+	case G2237_REG_CHIP_ID:
+	case G2237_REG_VERSION:
+		return true;
+	}
+	return false;
+}
+
+static const struct regmap_config g2237_regmap_config = {
+	.reg_bits         = 8,
+	.val_bits         = 8,
+	.max_register     = 0x15,
+	.cache_type       = REGCACHE_FLAT,
+	.reg_defaults     = g2237_reg_defaults,
+	.num_reg_defaults = ARRAY_SIZE(g2237_reg_defaults),
+	.readable_reg     = g2237_regmap_readable_reg,
+	.writeable_reg    = g2237_regmap_writeable_reg,
+	.volatile_reg     = g2237_regmap_volatile_reg,
+};
+
+static int g2237_i2c_probe(struct i2c_client *client,
+			   const struct i2c_device_id *id)
+{
+	struct device *dev = &client->dev;
+	struct g22xx_device *gdev;
+	int ret = 0;
+	unsigned int chip_id, rev;
+
+	gdev = devm_kzalloc(dev, sizeof(*gdev), GFP_KERNEL);
+	if (gdev == NULL)
+		return -ENOMEM;
+
+	gdev->regmap = devm_rtk_regmap_init_i2c(client, &g2237_regmap_config);
+	if (IS_ERR(gdev->regmap)) {
+		ret = PTR_ERR(gdev->regmap);
+		dev_err(dev, "failed to allocate regmap: %d\n", ret);
+		return ret;
+	}
+
+	ret = regmap_read(gdev->regmap, G2237_REG_CHIP_ID, &chip_id);
+	if (ret) {
+		dev_err(dev, "failed to read chip_id: %d\n", ret);
+		return ret;
+	}
+	if (chip_id != 0x25) {
+		dev_err(dev, "invaild chip_id(%02x)\n", chip_id);
+		return -EINVAL;
+	}
+	regmap_read(gdev->regmap, G2237_REG_VERSION, &rev);
+
+	dev_info(dev, "g2237 rev%d\n", rev);
+	gdev->chip_id = G22XX_DEVICE_ID_G2237;
+	gdev->chip_rev = rev;
+	gdev->dev = dev;
+
+	i2c_set_clientdata(client, gdev);
+	ret = g22xx_device_init(gdev);
+	if (ret) {
+		dev_err(dev, "failed to add sub-devices: %d\n", ret);
+		return ret;
+	}
+	dev_info(dev, "initialized\n");
+	return ret;
+}
+
+static int g2237_i2c_remove(struct i2c_client *client)
+{
+	struct device *dev = &client->dev;
+	struct g22xx_device *gdev = i2c_get_clientdata(client);
+
+	g22xx_device_exit(gdev);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+static const struct i2c_device_id g2237_i2c_id[] = {
+	{ "g2237", 0 },
+	{}
+};
+MODULE_DEVICE_TABLE(i2c, g2237_i2c_id);
+
+struct i2c_driver g2237_i2c_driver = {
+	.driver = {
+		.name = "g2237",
+	},
+	.probe = g2237_i2c_probe,
+	.remove = g2237_i2c_remove,
+	.id_table = g2237_i2c_id,
+};
+EXPORT_SYMBOL_GPL(g2237_i2c_driver);
+module_i2c_driver(g2237_i2c_driver);
+
+MODULE_DESCRIPTION("GMT G237 PMIC MFD Driver");
+MODULE_AUTHOR("Cheng-Yu Lee <cylee12@realtek.com>");
+MODULE_LICENSE("GPL");
+
diff --git a/drivers/mfd/g22xx-core.c b/drivers/mfd/g22xx-core.c
new file mode 100644
index 00000000..1fa26f8
--- /dev/null
+++ b/drivers/mfd/g22xx-core.c
@@ -0,0 +1,73 @@
+/*
+ * GMT-G22XX series PMIC MFD core
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/regmap.h>
+#include <linux/mfd/core.h>
+#include <linux/mfd/g22xx.h>
+
+static struct mfd_cell g2227_devs[] = {
+	{
+		.name = "g22xx-powerkey",
+		.of_compatible = "gmt,g22xx-powerkey",
+	},
+	{
+		.name = "g22xx-poweroff",
+		.of_compatible = "gmt,g22xx-poweroff",
+	},
+	{
+		.name = "g2227-regulator",
+		.of_compatible = "gmt,g2227-regulator",
+	},
+};
+
+static struct mfd_cell g2237_devs[] = {
+	{
+		.name = "g22xx-powerkey",
+		.of_compatible = "gmt,g22xx-powerkey",
+	},
+	{
+		.name = "g22xx-poweroff",
+		.of_compatible = "gmt,g22xx-poweroff",
+	},
+	{
+		.name = "g2237-regulator",
+		.of_compatible = "gmt,g2237-regulator",
+	},
+};
+
+int g22xx_device_init(struct g22xx_device *gdev)
+{
+	switch (gdev->chip_id) {
+	case G22XX_DEVICE_ID_G2227:
+		return devm_mfd_add_devices(gdev->dev, PLATFORM_DEVID_NONE,
+			g2227_devs, ARRAY_SIZE(g2227_devs), 0, 0, 0);
+	case G22XX_DEVICE_ID_G2237:
+		return devm_mfd_add_devices(gdev->dev, PLATFORM_DEVID_NONE,
+			g2237_devs, ARRAY_SIZE(g2237_devs), 0, 0, 0);
+	default:
+		return -EINVAL;
+	}
+	return 0;
+}
+
+void g22xx_device_exit(struct g22xx_device *gdev)
+{}
diff --git a/drivers/misc/Kconfig b/drivers/misc/Kconfig
index 64971ba..9360e6e 100644
--- a/drivers/misc/Kconfig
+++ b/drivers/misc/Kconfig
@@ -766,6 +766,27 @@ config PANEL_BOOT_MESSAGE
 	  An empty message will only clear the display at driver init time. Any other
 	  printf()-formatted message is valid with newline and escape codes.
 
+config UID_SYS_STATS
+	bool "Per-UID statistics"
+	depends on PROFILING && TASK_XACCT && TASK_IO_ACCOUNTING
+	help
+	  Per UID based cpu time statistics exported to /proc/uid_cputime
+	  Per UID based io statistics exported to /proc/uid_io
+	  Per UID based procstat control in /proc/uid_procstat
+
+config UID_SYS_STATS_DEBUG
+	bool "Per-TASK statistics"
+	depends on UID_SYS_STATS
+	default n
+	help
+	  Per TASK based io statistics exported to /proc/uid_io
+
+config MEMORY_STATE_TIME
+	tristate "Memory freq/bandwidth time statistics"
+	depends on PROFILING
+	help
+	  Memory time statistics exported to /sys/kernel/memory_state_time
+
 source "drivers/misc/c2port/Kconfig"
 source "drivers/misc/eeprom/Kconfig"
 source "drivers/misc/cb710/Kconfig"
diff --git a/drivers/misc/Makefile b/drivers/misc/Makefile
index 2bf79ba..564406b 100644
--- a/drivers/misc/Makefile
+++ b/drivers/misc/Makefile
@@ -54,6 +54,9 @@ obj-$(CONFIG_VEXPRESS_SYSCFG)	+= vexpress-syscfg.o
 obj-$(CONFIG_CXL_BASE)		+= cxl/
 obj-$(CONFIG_PANEL)             += panel.o
 
+obj-$(CONFIG_UID_SYS_STATS)	+= uid_sys_stats.o
+obj-$(CONFIG_MEMORY_STATE_TIME)	+= memory_state_time.o
+
 lkdtm-$(CONFIG_LKDTM)		+= lkdtm_core.o
 lkdtm-$(CONFIG_LKDTM)		+= lkdtm_bugs.o
 lkdtm-$(CONFIG_LKDTM)		+= lkdtm_heap.o
@@ -61,6 +64,7 @@ lkdtm-$(CONFIG_LKDTM)		+= lkdtm_perms.o
 lkdtm-$(CONFIG_LKDTM)		+= lkdtm_rodata_objcopy.o
 lkdtm-$(CONFIG_LKDTM)		+= lkdtm_usercopy.o
 
+CFLAGS_lkdtm_rodata.o		+= $(DISABLE_LTO)
 KCOV_INSTRUMENT_lkdtm_rodata.o	:= n
 
 OBJCOPYFLAGS :=
diff --git a/drivers/misc/kgdbts.c b/drivers/misc/kgdbts.c
index 99635dd..2290845 100644
--- a/drivers/misc/kgdbts.c
+++ b/drivers/misc/kgdbts.c
@@ -1130,7 +1130,8 @@ static void kgdbts_put_char(u8 chr)
 		ts.run_test(0, chr);
 }
 
-static int param_set_kgdbts_var(const char *kmessage, struct kernel_param *kp)
+static int param_set_kgdbts_var(const char *kmessage,
+				const struct kernel_param *kp)
 {
 	int len = strlen(kmessage);
 
diff --git a/drivers/misc/memory_state_time.c b/drivers/misc/memory_state_time.c
new file mode 100644
index 00000000..ba94dcf
--- /dev/null
+++ b/drivers/misc/memory_state_time.c
@@ -0,0 +1,462 @@
+/* drivers/misc/memory_state_time.c
+ *
+ * Copyright (C) 2016 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/device.h>
+#include <linux/err.h>
+#include <linux/errno.h>
+#include <linux/hashtable.h>
+#include <linux/kconfig.h>
+#include <linux/kernel.h>
+#include <linux/kobject.h>
+#include <linux/memory-state-time.h>
+#include <linux/module.h>
+#include <linux/mutex.h>
+#include <linux/of_platform.h>
+#include <linux/slab.h>
+#include <linux/sysfs.h>
+#include <linux/time.h>
+#include <linux/timekeeping.h>
+#include <linux/workqueue.h>
+
+#define KERNEL_ATTR_RO(_name) \
+static struct kobj_attribute _name##_attr = __ATTR_RO(_name)
+
+#define KERNEL_ATTR_RW(_name) \
+static struct kobj_attribute _name##_attr = \
+	__ATTR(_name, 0644, _name##_show, _name##_store)
+
+#define FREQ_HASH_BITS 4
+DECLARE_HASHTABLE(freq_hash_table, FREQ_HASH_BITS);
+
+static DEFINE_MUTEX(mem_lock);
+
+#define TAG "memory_state_time"
+#define BW_NODE "/soc/memory-state-time"
+#define FREQ_TBL "freq-tbl"
+#define BW_TBL "bw-buckets"
+#define NUM_SOURCES "num-sources"
+
+#define LOWEST_FREQ 2
+
+static int curr_bw;
+static int curr_freq;
+static u32 *bw_buckets;
+static u32 *freq_buckets;
+static int num_freqs;
+static int num_buckets;
+static int registered_bw_sources;
+static u64 last_update;
+static bool init_success;
+static struct workqueue_struct *memory_wq;
+static u32 num_sources = 10;
+static int *bandwidths;
+
+struct freq_entry {
+	int freq;
+	u64 *buckets; /* Bandwidth buckets. */
+	struct hlist_node hash;
+};
+
+struct queue_container {
+	struct work_struct update_state;
+	int value;
+	u64 time_now;
+	int id;
+	struct mutex *lock;
+};
+
+static int find_bucket(int bw)
+{
+	int i;
+
+	if (bw_buckets != NULL) {
+		for (i = 0; i < num_buckets; i++) {
+			if (bw_buckets[i] > bw) {
+				pr_debug("Found bucket %d for bandwidth %d\n",
+					i, bw);
+				return i;
+			}
+		}
+		return num_buckets - 1;
+	}
+	return 0;
+}
+
+static u64 get_time_diff(u64 time_now)
+{
+	u64 ms;
+
+	ms = time_now - last_update;
+	last_update = time_now;
+	return ms;
+}
+
+static ssize_t show_stat_show(struct kobject *kobj,
+		struct kobj_attribute *attr, char *buf)
+{
+	int i, j;
+	int len = 0;
+	struct freq_entry *freq_entry;
+
+	for (i = 0; i < num_freqs; i++) {
+		hash_for_each_possible(freq_hash_table, freq_entry, hash,
+				freq_buckets[i]) {
+			if (freq_entry->freq == freq_buckets[i]) {
+				len += scnprintf(buf + len, PAGE_SIZE - len,
+						"%d ", freq_buckets[i]);
+				if (len >= PAGE_SIZE)
+					break;
+				for (j = 0; j < num_buckets; j++) {
+					len += scnprintf(buf + len,
+							PAGE_SIZE - len,
+							"%llu ",
+							freq_entry->buckets[j]);
+				}
+				len += scnprintf(buf + len, PAGE_SIZE - len,
+						"\n");
+			}
+		}
+	}
+	pr_debug("Current Time: %llu\n", ktime_get_boot_ns());
+	return len;
+}
+KERNEL_ATTR_RO(show_stat);
+
+static void update_table(u64 time_now)
+{
+	struct freq_entry *freq_entry;
+
+	pr_debug("Last known bw %d freq %d\n", curr_bw, curr_freq);
+	hash_for_each_possible(freq_hash_table, freq_entry, hash, curr_freq) {
+		if (curr_freq == freq_entry->freq) {
+			freq_entry->buckets[find_bucket(curr_bw)]
+					+= get_time_diff(time_now);
+			break;
+		}
+	}
+}
+
+static bool freq_exists(int freq)
+{
+	int i;
+
+	for (i = 0; i < num_freqs; i++) {
+		if (freq == freq_buckets[i])
+			return true;
+	}
+	return false;
+}
+
+static int calculate_total_bw(int bw, int index)
+{
+	int i;
+	int total_bw = 0;
+
+	pr_debug("memory_state_time New bw %d for id %d\n", bw, index);
+	bandwidths[index] = bw;
+	for (i = 0; i < registered_bw_sources; i++)
+		total_bw += bandwidths[i];
+	return total_bw;
+}
+
+static void freq_update_do_work(struct work_struct *work)
+{
+	struct queue_container *freq_state_update
+			= container_of(work, struct queue_container,
+			update_state);
+	if (freq_state_update) {
+		mutex_lock(&mem_lock);
+		update_table(freq_state_update->time_now);
+		curr_freq = freq_state_update->value;
+		mutex_unlock(&mem_lock);
+		kfree(freq_state_update);
+	}
+}
+
+static void bw_update_do_work(struct work_struct *work)
+{
+	struct queue_container *bw_state_update
+			= container_of(work, struct queue_container,
+			update_state);
+	if (bw_state_update) {
+		mutex_lock(&mem_lock);
+		update_table(bw_state_update->time_now);
+		curr_bw = calculate_total_bw(bw_state_update->value,
+				bw_state_update->id);
+		mutex_unlock(&mem_lock);
+		kfree(bw_state_update);
+	}
+}
+
+static void memory_state_freq_update(struct memory_state_update_block *ub,
+		int value)
+{
+	if (IS_ENABLED(CONFIG_MEMORY_STATE_TIME)) {
+		if (freq_exists(value) && init_success) {
+			struct queue_container *freq_container
+				= kmalloc(sizeof(struct queue_container),
+				GFP_KERNEL);
+			if (!freq_container)
+				return;
+			INIT_WORK(&freq_container->update_state,
+					freq_update_do_work);
+			freq_container->time_now = ktime_get_boot_ns();
+			freq_container->value = value;
+			pr_debug("Scheduling freq update in work queue\n");
+			queue_work(memory_wq, &freq_container->update_state);
+		} else {
+			pr_debug("Freq does not exist.\n");
+		}
+	}
+}
+
+static void memory_state_bw_update(struct memory_state_update_block *ub,
+		int value)
+{
+	if (IS_ENABLED(CONFIG_MEMORY_STATE_TIME)) {
+		if (init_success) {
+			struct queue_container *bw_container
+				= kmalloc(sizeof(struct queue_container),
+				GFP_KERNEL);
+			if (!bw_container)
+				return;
+			INIT_WORK(&bw_container->update_state,
+					bw_update_do_work);
+			bw_container->time_now = ktime_get_boot_ns();
+			bw_container->value = value;
+			bw_container->id = ub->id;
+			pr_debug("Scheduling bandwidth update in work queue\n");
+			queue_work(memory_wq, &bw_container->update_state);
+		}
+	}
+}
+
+struct memory_state_update_block *memory_state_register_frequency_source(void)
+{
+	struct memory_state_update_block *block;
+
+	if (IS_ENABLED(CONFIG_MEMORY_STATE_TIME)) {
+		pr_debug("Allocating frequency source\n");
+		block = kmalloc(sizeof(struct memory_state_update_block),
+					GFP_KERNEL);
+		if (!block)
+			return NULL;
+		block->update_call = memory_state_freq_update;
+		return block;
+	}
+	pr_err("Config option disabled.\n");
+	return NULL;
+}
+EXPORT_SYMBOL_GPL(memory_state_register_frequency_source);
+
+struct memory_state_update_block *memory_state_register_bandwidth_source(void)
+{
+	struct memory_state_update_block *block;
+
+	if (IS_ENABLED(CONFIG_MEMORY_STATE_TIME)) {
+		pr_debug("Allocating bandwidth source %d\n",
+				registered_bw_sources);
+		block = kmalloc(sizeof(struct memory_state_update_block),
+					GFP_KERNEL);
+		if (!block)
+			return NULL;
+		block->update_call = memory_state_bw_update;
+		if (registered_bw_sources < num_sources) {
+			block->id = registered_bw_sources++;
+		} else {
+			pr_err("Unable to allocate source; max number reached\n");
+			kfree(block);
+			return NULL;
+		}
+		return block;
+	}
+	pr_err("Config option disabled.\n");
+	return NULL;
+}
+EXPORT_SYMBOL_GPL(memory_state_register_bandwidth_source);
+
+/* Buckets are designated by their maximum.
+ * Returns the buckets decided by the capability of the device.
+ */
+static int get_bw_buckets(struct device *dev)
+{
+	int ret, lenb;
+	struct device_node *node = dev->of_node;
+
+	of_property_read_u32(node, NUM_SOURCES, &num_sources);
+	if (!of_find_property(node, BW_TBL, &lenb)) {
+		pr_err("Missing %s property\n", BW_TBL);
+		return -ENODATA;
+	}
+
+	bandwidths = devm_kzalloc(dev,
+			sizeof(*bandwidths) * num_sources, GFP_KERNEL);
+	if (!bandwidths)
+		return -ENOMEM;
+	lenb /= sizeof(*bw_buckets);
+	bw_buckets = devm_kzalloc(dev, lenb * sizeof(*bw_buckets),
+			GFP_KERNEL);
+	if (!bw_buckets) {
+		devm_kfree(dev, bandwidths);
+		return -ENOMEM;
+	}
+	ret = of_property_read_u32_array(node, BW_TBL, bw_buckets,
+			lenb);
+	if (ret < 0) {
+		devm_kfree(dev, bandwidths);
+		devm_kfree(dev, bw_buckets);
+		pr_err("Unable to read bandwidth table from device tree.\n");
+		return ret;
+	}
+
+	curr_bw = 0;
+	num_buckets = lenb;
+	return 0;
+}
+
+/* Adds struct freq_entry nodes to the hashtable for each compatible frequency.
+ * Returns the supported number of frequencies.
+ */
+static int freq_buckets_init(struct device *dev)
+{
+	struct freq_entry *freq_entry;
+	int i;
+	int ret, lenf;
+	struct device_node *node = dev->of_node;
+
+	if (!of_find_property(node, FREQ_TBL, &lenf)) {
+		pr_err("Missing %s property\n", FREQ_TBL);
+		return -ENODATA;
+	}
+
+	lenf /= sizeof(*freq_buckets);
+	freq_buckets = devm_kzalloc(dev, lenf * sizeof(*freq_buckets),
+			GFP_KERNEL);
+	if (!freq_buckets)
+		return -ENOMEM;
+	pr_debug("freqs found len %d\n", lenf);
+	ret = of_property_read_u32_array(node, FREQ_TBL, freq_buckets,
+			lenf);
+	if (ret < 0) {
+		devm_kfree(dev, freq_buckets);
+		pr_err("Unable to read frequency table from device tree.\n");
+		return ret;
+	}
+	pr_debug("ret freq %d\n", ret);
+
+	num_freqs = lenf;
+	curr_freq = freq_buckets[LOWEST_FREQ];
+
+	for (i = 0; i < num_freqs; i++) {
+		freq_entry = devm_kzalloc(dev, sizeof(struct freq_entry),
+				GFP_KERNEL);
+		if (!freq_entry)
+			return -ENOMEM;
+		freq_entry->buckets = devm_kzalloc(dev, sizeof(u64)*num_buckets,
+				GFP_KERNEL);
+		if (!freq_entry->buckets) {
+			devm_kfree(dev, freq_entry);
+			return -ENOMEM;
+		}
+		pr_debug("memory_state_time Adding freq to ht %d\n",
+				freq_buckets[i]);
+		freq_entry->freq = freq_buckets[i];
+		hash_add(freq_hash_table, &freq_entry->hash, freq_buckets[i]);
+	}
+	return 0;
+}
+
+struct kobject *memory_kobj;
+EXPORT_SYMBOL_GPL(memory_kobj);
+
+static struct attribute *memory_attrs[] = {
+	&show_stat_attr.attr,
+	NULL
+};
+
+static struct attribute_group memory_attr_group = {
+	.attrs = memory_attrs,
+};
+
+static int memory_state_time_probe(struct platform_device *pdev)
+{
+	int error;
+
+	error = get_bw_buckets(&pdev->dev);
+	if (error)
+		return error;
+	error = freq_buckets_init(&pdev->dev);
+	if (error)
+		return error;
+	last_update = ktime_get_boot_ns();
+	init_success = true;
+
+	pr_debug("memory_state_time initialized with num_freqs %d\n",
+			num_freqs);
+	return 0;
+}
+
+static const struct of_device_id match_table[] = {
+	{ .compatible = "memory-state-time" },
+	{}
+};
+
+static struct platform_driver memory_state_time_driver = {
+	.probe = memory_state_time_probe,
+	.driver = {
+		.name = "memory-state-time",
+		.of_match_table = match_table,
+		.owner = THIS_MODULE,
+	},
+};
+
+static int __init memory_state_time_init(void)
+{
+	int error;
+
+	hash_init(freq_hash_table);
+	memory_wq = create_singlethread_workqueue("memory_wq");
+	if (!memory_wq) {
+		pr_err("Unable to create workqueue.\n");
+		return -EINVAL;
+	}
+	/*
+	 * Create sys/kernel directory for memory_state_time.
+	 */
+	memory_kobj = kobject_create_and_add(TAG, kernel_kobj);
+	if (!memory_kobj) {
+		pr_err("Unable to allocate memory_kobj for sysfs directory.\n");
+		error = -ENOMEM;
+		goto wq;
+	}
+	error = sysfs_create_group(memory_kobj, &memory_attr_group);
+	if (error) {
+		pr_err("Unable to create sysfs folder.\n");
+		goto kobj;
+	}
+
+	error = platform_driver_register(&memory_state_time_driver);
+	if (error) {
+		pr_err("Unable to register memory_state_time platform driver.\n");
+		goto group;
+	}
+	return 0;
+
+group:	sysfs_remove_group(memory_kobj, &memory_attr_group);
+kobj:	kobject_put(memory_kobj);
+wq:	destroy_workqueue(memory_wq);
+	return error;
+}
+module_init(memory_state_time_init);
diff --git a/drivers/misc/uid_sys_stats.c b/drivers/misc/uid_sys_stats.c
new file mode 100644
index 00000000..345f229
--- /dev/null
+++ b/drivers/misc/uid_sys_stats.c
@@ -0,0 +1,706 @@
+/* drivers/misc/uid_sys_stats.c
+ *
+ * Copyright (C) 2014 - 2015 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/atomic.h>
+#include <linux/cpufreq_times.h>
+#include <linux/err.h>
+#include <linux/hashtable.h>
+#include <linux/init.h>
+#include <linux/kernel.h>
+#include <linux/list.h>
+#include <linux/mm.h>
+#include <linux/proc_fs.h>
+#include <linux/profile.h>
+#include <linux/rtmutex.h>
+#include <linux/sched.h>
+#include <linux/seq_file.h>
+#include <linux/slab.h>
+#include <linux/uaccess.h>
+
+
+#define UID_HASH_BITS	10
+DECLARE_HASHTABLE(hash_table, UID_HASH_BITS);
+
+static DEFINE_RT_MUTEX(uid_lock);
+static struct proc_dir_entry *cpu_parent;
+static struct proc_dir_entry *io_parent;
+static struct proc_dir_entry *proc_parent;
+
+struct io_stats {
+	u64 read_bytes;
+	u64 write_bytes;
+	u64 rchar;
+	u64 wchar;
+	u64 fsync;
+};
+
+#define UID_STATE_FOREGROUND	0
+#define UID_STATE_BACKGROUND	1
+#define UID_STATE_BUCKET_SIZE	2
+
+#define UID_STATE_TOTAL_CURR	2
+#define UID_STATE_TOTAL_LAST	3
+#define UID_STATE_DEAD_TASKS	4
+#define UID_STATE_SIZE		5
+
+#define MAX_TASK_COMM_LEN 256
+
+struct task_entry {
+	char comm[MAX_TASK_COMM_LEN];
+	pid_t pid;
+	struct io_stats io[UID_STATE_SIZE];
+	struct hlist_node hash;
+};
+
+struct uid_entry {
+	uid_t uid;
+	cputime_t utime;
+	cputime_t stime;
+	cputime_t active_utime;
+	cputime_t active_stime;
+	int state;
+	struct io_stats io[UID_STATE_SIZE];
+	struct hlist_node hash;
+#ifdef CONFIG_UID_SYS_STATS_DEBUG
+	DECLARE_HASHTABLE(task_entries, UID_HASH_BITS);
+#endif
+};
+
+static u64 compute_write_bytes(struct task_struct *task)
+{
+	if (task->ioac.write_bytes <= task->ioac.cancelled_write_bytes)
+		return 0;
+
+	return task->ioac.write_bytes - task->ioac.cancelled_write_bytes;
+}
+
+static void compute_io_bucket_stats(struct io_stats *io_bucket,
+					struct io_stats *io_curr,
+					struct io_stats *io_last,
+					struct io_stats *io_dead)
+{
+	/* tasks could switch to another uid group, but its io_last in the
+	 * previous uid group could still be positive.
+	 * therefore before each update, do an overflow check first
+	 */
+	int64_t delta;
+
+	delta = io_curr->read_bytes + io_dead->read_bytes -
+		io_last->read_bytes;
+	io_bucket->read_bytes += delta > 0 ? delta : 0;
+	delta = io_curr->write_bytes + io_dead->write_bytes -
+		io_last->write_bytes;
+	io_bucket->write_bytes += delta > 0 ? delta : 0;
+	delta = io_curr->rchar + io_dead->rchar - io_last->rchar;
+	io_bucket->rchar += delta > 0 ? delta : 0;
+	delta = io_curr->wchar + io_dead->wchar - io_last->wchar;
+	io_bucket->wchar += delta > 0 ? delta : 0;
+	delta = io_curr->fsync + io_dead->fsync - io_last->fsync;
+	io_bucket->fsync += delta > 0 ? delta : 0;
+
+	io_last->read_bytes = io_curr->read_bytes;
+	io_last->write_bytes = io_curr->write_bytes;
+	io_last->rchar = io_curr->rchar;
+	io_last->wchar = io_curr->wchar;
+	io_last->fsync = io_curr->fsync;
+
+	memset(io_dead, 0, sizeof(struct io_stats));
+}
+
+#ifdef CONFIG_UID_SYS_STATS_DEBUG
+static void get_full_task_comm(struct task_entry *task_entry,
+		struct task_struct *task)
+{
+	int i = 0, offset = 0, len = 0;
+	/* save one byte for terminating null character */
+	int unused_len = MAX_TASK_COMM_LEN - TASK_COMM_LEN - 1;
+	char buf[unused_len];
+	struct mm_struct *mm = task->mm;
+
+	/* fill the first TASK_COMM_LEN bytes with thread name */
+	__get_task_comm(task_entry->comm, TASK_COMM_LEN, task);
+	i = strlen(task_entry->comm);
+	while (i < TASK_COMM_LEN)
+		task_entry->comm[i++] = ' ';
+
+	/* next the executable file name */
+	if (mm) {
+		down_read(&mm->mmap_sem);
+		if (mm->exe_file) {
+			char *pathname = d_path(&mm->exe_file->f_path, buf,
+					unused_len);
+
+			if (!IS_ERR(pathname)) {
+				len = strlcpy(task_entry->comm + i, pathname,
+						unused_len);
+				i += len;
+				task_entry->comm[i++] = ' ';
+				unused_len--;
+			}
+		}
+		up_read(&mm->mmap_sem);
+	}
+	unused_len -= len;
+
+	/* fill the rest with command line argument
+	 * replace each null or new line character
+	 * between args in argv with whitespace */
+	len = get_cmdline(task, buf, unused_len);
+	while (offset < len) {
+		if (buf[offset] != '\0' && buf[offset] != '\n')
+			task_entry->comm[i++] = buf[offset];
+		else
+			task_entry->comm[i++] = ' ';
+		offset++;
+	}
+
+	/* get rid of trailing whitespaces in case when arg is memset to
+	 * zero before being reset in userspace
+	 */
+	while (task_entry->comm[i-1] == ' ')
+		i--;
+	task_entry->comm[i] = '\0';
+}
+
+static struct task_entry *find_task_entry(struct uid_entry *uid_entry,
+		struct task_struct *task)
+{
+	struct task_entry *task_entry;
+
+	hash_for_each_possible(uid_entry->task_entries, task_entry, hash,
+			task->pid) {
+		if (task->pid == task_entry->pid) {
+			/* if thread name changed, update the entire command */
+			int len = strnchr(task_entry->comm, ' ', TASK_COMM_LEN)
+				- task_entry->comm;
+
+			if (strncmp(task_entry->comm, task->comm, len))
+				get_full_task_comm(task_entry, task);
+			return task_entry;
+		}
+	}
+	return NULL;
+}
+
+static struct task_entry *find_or_register_task(struct uid_entry *uid_entry,
+		struct task_struct *task)
+{
+	struct task_entry *task_entry;
+	pid_t pid = task->pid;
+
+	task_entry = find_task_entry(uid_entry, task);
+	if (task_entry)
+		return task_entry;
+
+	task_entry = kzalloc(sizeof(struct task_entry), GFP_ATOMIC);
+	if (!task_entry)
+		return NULL;
+
+	get_full_task_comm(task_entry, task);
+
+	task_entry->pid = pid;
+	hash_add(uid_entry->task_entries, &task_entry->hash, (unsigned int)pid);
+
+	return task_entry;
+}
+
+static void remove_uid_tasks(struct uid_entry *uid_entry)
+{
+	struct task_entry *task_entry;
+	unsigned long bkt_task;
+	struct hlist_node *tmp_task;
+
+	hash_for_each_safe(uid_entry->task_entries, bkt_task,
+			tmp_task, task_entry, hash) {
+		hash_del(&task_entry->hash);
+		kfree(task_entry);
+	}
+}
+
+static void set_io_uid_tasks_zero(struct uid_entry *uid_entry)
+{
+	struct task_entry *task_entry;
+	unsigned long bkt_task;
+
+	hash_for_each(uid_entry->task_entries, bkt_task, task_entry, hash) {
+		memset(&task_entry->io[UID_STATE_TOTAL_CURR], 0,
+			sizeof(struct io_stats));
+	}
+}
+
+static void add_uid_tasks_io_stats(struct uid_entry *uid_entry,
+		struct task_struct *task, int slot)
+{
+	struct task_entry *task_entry = find_or_register_task(uid_entry, task);
+	struct io_stats *task_io_slot = &task_entry->io[slot];
+
+	task_io_slot->read_bytes += task->ioac.read_bytes;
+	task_io_slot->write_bytes += compute_write_bytes(task);
+	task_io_slot->rchar += task->ioac.rchar;
+	task_io_slot->wchar += task->ioac.wchar;
+	task_io_slot->fsync += task->ioac.syscfs;
+}
+
+static void compute_io_uid_tasks(struct uid_entry *uid_entry)
+{
+	struct task_entry *task_entry;
+	unsigned long bkt_task;
+
+	hash_for_each(uid_entry->task_entries, bkt_task, task_entry, hash) {
+		compute_io_bucket_stats(&task_entry->io[uid_entry->state],
+					&task_entry->io[UID_STATE_TOTAL_CURR],
+					&task_entry->io[UID_STATE_TOTAL_LAST],
+					&task_entry->io[UID_STATE_DEAD_TASKS]);
+	}
+}
+
+static void show_io_uid_tasks(struct seq_file *m, struct uid_entry *uid_entry)
+{
+	struct task_entry *task_entry;
+	unsigned long bkt_task;
+
+	hash_for_each(uid_entry->task_entries, bkt_task, task_entry, hash) {
+		/* Separated by comma because space exists in task comm */
+		seq_printf(m, "task,%s,%lu,%llu,%llu,%llu,%llu,%llu,%llu,%llu,%llu,%llu,%llu\n",
+				task_entry->comm,
+				(unsigned long)task_entry->pid,
+				task_entry->io[UID_STATE_FOREGROUND].rchar,
+				task_entry->io[UID_STATE_FOREGROUND].wchar,
+				task_entry->io[UID_STATE_FOREGROUND].read_bytes,
+				task_entry->io[UID_STATE_FOREGROUND].write_bytes,
+				task_entry->io[UID_STATE_BACKGROUND].rchar,
+				task_entry->io[UID_STATE_BACKGROUND].wchar,
+				task_entry->io[UID_STATE_BACKGROUND].read_bytes,
+				task_entry->io[UID_STATE_BACKGROUND].write_bytes,
+				task_entry->io[UID_STATE_FOREGROUND].fsync,
+				task_entry->io[UID_STATE_BACKGROUND].fsync);
+	}
+}
+#else
+static void remove_uid_tasks(struct uid_entry *uid_entry) {};
+static void set_io_uid_tasks_zero(struct uid_entry *uid_entry) {};
+static void add_uid_tasks_io_stats(struct uid_entry *uid_entry,
+		struct task_struct *task, int slot) {};
+static void compute_io_uid_tasks(struct uid_entry *uid_entry) {};
+static void show_io_uid_tasks(struct seq_file *m,
+		struct uid_entry *uid_entry) {}
+#endif
+
+static struct uid_entry *find_uid_entry(uid_t uid)
+{
+	struct uid_entry *uid_entry;
+	hash_for_each_possible(hash_table, uid_entry, hash, uid) {
+		if (uid_entry->uid == uid)
+			return uid_entry;
+	}
+	return NULL;
+}
+
+static struct uid_entry *find_or_register_uid(uid_t uid)
+{
+	struct uid_entry *uid_entry;
+
+	uid_entry = find_uid_entry(uid);
+	if (uid_entry)
+		return uid_entry;
+
+	uid_entry = kzalloc(sizeof(struct uid_entry), GFP_ATOMIC);
+	if (!uid_entry)
+		return NULL;
+
+	uid_entry->uid = uid;
+#ifdef CONFIG_UID_SYS_STATS_DEBUG
+	hash_init(uid_entry->task_entries);
+#endif
+	hash_add(hash_table, &uid_entry->hash, uid);
+
+	return uid_entry;
+}
+
+static int uid_cputime_show(struct seq_file *m, void *v)
+{
+	struct uid_entry *uid_entry = NULL;
+	struct task_struct *task, *temp;
+	struct user_namespace *user_ns = current_user_ns();
+	cputime_t utime;
+	cputime_t stime;
+	unsigned long bkt;
+	uid_t uid;
+
+	rt_mutex_lock(&uid_lock);
+
+	hash_for_each(hash_table, bkt, uid_entry, hash) {
+		uid_entry->active_stime = 0;
+		uid_entry->active_utime = 0;
+	}
+
+	rcu_read_lock();
+	do_each_thread(temp, task) {
+		uid = from_kuid_munged(user_ns, task_uid(task));
+		if (!uid_entry || uid_entry->uid != uid)
+			uid_entry = find_or_register_uid(uid);
+		if (!uid_entry) {
+			rcu_read_unlock();
+			rt_mutex_unlock(&uid_lock);
+			pr_err("%s: failed to find the uid_entry for uid %d\n",
+				__func__, uid);
+			return -ENOMEM;
+		}
+		task_cputime_adjusted(task, &utime, &stime);
+		uid_entry->active_utime += utime;
+		uid_entry->active_stime += stime;
+	} while_each_thread(temp, task);
+	rcu_read_unlock();
+
+	hash_for_each(hash_table, bkt, uid_entry, hash) {
+		cputime_t total_utime = uid_entry->utime +
+							uid_entry->active_utime;
+		cputime_t total_stime = uid_entry->stime +
+							uid_entry->active_stime;
+		seq_printf(m, "%d: %llu %llu\n", uid_entry->uid,
+			(unsigned long long)jiffies_to_msecs(
+				cputime_to_jiffies(total_utime)) * USEC_PER_MSEC,
+			(unsigned long long)jiffies_to_msecs(
+				cputime_to_jiffies(total_stime)) * USEC_PER_MSEC);
+	}
+
+	rt_mutex_unlock(&uid_lock);
+	return 0;
+}
+
+static int uid_cputime_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, uid_cputime_show, PDE_DATA(inode));
+}
+
+static const struct file_operations uid_cputime_fops = {
+	.open		= uid_cputime_open,
+	.read		= seq_read,
+	.llseek		= seq_lseek,
+	.release	= single_release,
+};
+
+static int uid_remove_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, NULL, NULL);
+}
+
+static ssize_t uid_remove_write(struct file *file,
+			const char __user *buffer, size_t count, loff_t *ppos)
+{
+	struct uid_entry *uid_entry;
+	struct hlist_node *tmp;
+	char uids[128];
+	char *start_uid, *end_uid = NULL;
+	long int uid_start = 0, uid_end = 0;
+
+	if (count >= sizeof(uids))
+		count = sizeof(uids) - 1;
+
+	if (copy_from_user(uids, buffer, count))
+		return -EFAULT;
+
+	uids[count] = '\0';
+	end_uid = uids;
+	start_uid = strsep(&end_uid, "-");
+
+	if (!start_uid || !end_uid)
+		return -EINVAL;
+
+	if (kstrtol(start_uid, 10, &uid_start) != 0 ||
+		kstrtol(end_uid, 10, &uid_end) != 0) {
+		return -EINVAL;
+	}
+
+	/* Also remove uids from /proc/uid_time_in_state */
+	cpufreq_task_times_remove_uids(uid_start, uid_end);
+
+	rt_mutex_lock(&uid_lock);
+
+	for (; uid_start <= uid_end; uid_start++) {
+		hash_for_each_possible_safe(hash_table, uid_entry, tmp,
+							hash, (uid_t)uid_start) {
+			if (uid_start == uid_entry->uid) {
+				remove_uid_tasks(uid_entry);
+				hash_del(&uid_entry->hash);
+				kfree(uid_entry);
+			}
+		}
+	}
+
+	rt_mutex_unlock(&uid_lock);
+	return count;
+}
+
+static const struct file_operations uid_remove_fops = {
+	.open		= uid_remove_open,
+	.release	= single_release,
+	.write		= uid_remove_write,
+};
+
+
+static void add_uid_io_stats(struct uid_entry *uid_entry,
+			struct task_struct *task, int slot)
+{
+	struct io_stats *io_slot = &uid_entry->io[slot];
+
+	io_slot->read_bytes += task->ioac.read_bytes;
+	io_slot->write_bytes += compute_write_bytes(task);
+	io_slot->rchar += task->ioac.rchar;
+	io_slot->wchar += task->ioac.wchar;
+	io_slot->fsync += task->ioac.syscfs;
+
+	add_uid_tasks_io_stats(uid_entry, task, slot);
+}
+
+static void update_io_stats_all_locked(void)
+{
+	struct uid_entry *uid_entry = NULL;
+	struct task_struct *task, *temp;
+	struct user_namespace *user_ns = current_user_ns();
+	unsigned long bkt;
+	uid_t uid;
+
+	hash_for_each(hash_table, bkt, uid_entry, hash) {
+		memset(&uid_entry->io[UID_STATE_TOTAL_CURR], 0,
+			sizeof(struct io_stats));
+		set_io_uid_tasks_zero(uid_entry);
+	}
+
+	rcu_read_lock();
+	do_each_thread(temp, task) {
+		uid = from_kuid_munged(user_ns, task_uid(task));
+		if (!uid_entry || uid_entry->uid != uid)
+			uid_entry = find_or_register_uid(uid);
+		if (!uid_entry)
+			continue;
+		add_uid_io_stats(uid_entry, task, UID_STATE_TOTAL_CURR);
+	} while_each_thread(temp, task);
+	rcu_read_unlock();
+
+	hash_for_each(hash_table, bkt, uid_entry, hash) {
+		compute_io_bucket_stats(&uid_entry->io[uid_entry->state],
+					&uid_entry->io[UID_STATE_TOTAL_CURR],
+					&uid_entry->io[UID_STATE_TOTAL_LAST],
+					&uid_entry->io[UID_STATE_DEAD_TASKS]);
+		compute_io_uid_tasks(uid_entry);
+	}
+}
+
+static void update_io_stats_uid_locked(struct uid_entry *uid_entry)
+{
+	struct task_struct *task, *temp;
+	struct user_namespace *user_ns = current_user_ns();
+
+	memset(&uid_entry->io[UID_STATE_TOTAL_CURR], 0,
+		sizeof(struct io_stats));
+	set_io_uid_tasks_zero(uid_entry);
+
+	rcu_read_lock();
+	do_each_thread(temp, task) {
+		if (from_kuid_munged(user_ns, task_uid(task)) != uid_entry->uid)
+			continue;
+		add_uid_io_stats(uid_entry, task, UID_STATE_TOTAL_CURR);
+	} while_each_thread(temp, task);
+	rcu_read_unlock();
+
+	compute_io_bucket_stats(&uid_entry->io[uid_entry->state],
+				&uid_entry->io[UID_STATE_TOTAL_CURR],
+				&uid_entry->io[UID_STATE_TOTAL_LAST],
+				&uid_entry->io[UID_STATE_DEAD_TASKS]);
+	compute_io_uid_tasks(uid_entry);
+}
+
+
+static int uid_io_show(struct seq_file *m, void *v)
+{
+	struct uid_entry *uid_entry;
+	unsigned long bkt;
+
+	rt_mutex_lock(&uid_lock);
+
+	update_io_stats_all_locked();
+
+	hash_for_each(hash_table, bkt, uid_entry, hash) {
+		seq_printf(m, "%d %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu\n",
+				uid_entry->uid,
+				uid_entry->io[UID_STATE_FOREGROUND].rchar,
+				uid_entry->io[UID_STATE_FOREGROUND].wchar,
+				uid_entry->io[UID_STATE_FOREGROUND].read_bytes,
+				uid_entry->io[UID_STATE_FOREGROUND].write_bytes,
+				uid_entry->io[UID_STATE_BACKGROUND].rchar,
+				uid_entry->io[UID_STATE_BACKGROUND].wchar,
+				uid_entry->io[UID_STATE_BACKGROUND].read_bytes,
+				uid_entry->io[UID_STATE_BACKGROUND].write_bytes,
+				uid_entry->io[UID_STATE_FOREGROUND].fsync,
+				uid_entry->io[UID_STATE_BACKGROUND].fsync);
+
+		show_io_uid_tasks(m, uid_entry);
+	}
+
+	rt_mutex_unlock(&uid_lock);
+	return 0;
+}
+
+static int uid_io_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, uid_io_show, PDE_DATA(inode));
+}
+
+static const struct file_operations uid_io_fops = {
+	.open		= uid_io_open,
+	.read		= seq_read,
+	.llseek		= seq_lseek,
+	.release	= single_release,
+};
+
+static int uid_procstat_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, NULL, NULL);
+}
+
+static ssize_t uid_procstat_write(struct file *file,
+			const char __user *buffer, size_t count, loff_t *ppos)
+{
+	struct uid_entry *uid_entry;
+	uid_t uid;
+	int argc, state;
+	char input[128];
+
+	if (count >= sizeof(input))
+		return -EINVAL;
+
+	if (copy_from_user(input, buffer, count))
+		return -EFAULT;
+
+	input[count] = '\0';
+
+	argc = sscanf(input, "%u %d", &uid, &state);
+	if (argc != 2)
+		return -EINVAL;
+
+	if (state != UID_STATE_BACKGROUND && state != UID_STATE_FOREGROUND)
+		return -EINVAL;
+
+	rt_mutex_lock(&uid_lock);
+
+	uid_entry = find_or_register_uid(uid);
+	if (!uid_entry) {
+		rt_mutex_unlock(&uid_lock);
+		return -EINVAL;
+	}
+
+	if (uid_entry->state == state) {
+		rt_mutex_unlock(&uid_lock);
+		return count;
+	}
+
+	update_io_stats_uid_locked(uid_entry);
+
+	uid_entry->state = state;
+
+	rt_mutex_unlock(&uid_lock);
+
+	return count;
+}
+
+static const struct file_operations uid_procstat_fops = {
+	.open		= uid_procstat_open,
+	.release	= single_release,
+	.write		= uid_procstat_write,
+};
+
+static int process_notifier(struct notifier_block *self,
+			unsigned long cmd, void *v)
+{
+	struct task_struct *task = v;
+	struct uid_entry *uid_entry;
+	cputime_t utime, stime;
+	uid_t uid;
+
+	if (!task)
+		return NOTIFY_OK;
+
+	rt_mutex_lock(&uid_lock);
+	uid = from_kuid_munged(current_user_ns(), task_uid(task));
+	uid_entry = find_or_register_uid(uid);
+	if (!uid_entry) {
+		pr_err("%s: failed to find uid %d\n", __func__, uid);
+		goto exit;
+	}
+
+	task_cputime_adjusted(task, &utime, &stime);
+	uid_entry->utime += utime;
+	uid_entry->stime += stime;
+
+	add_uid_io_stats(uid_entry, task, UID_STATE_DEAD_TASKS);
+
+exit:
+	rt_mutex_unlock(&uid_lock);
+	return NOTIFY_OK;
+}
+
+static struct notifier_block process_notifier_block = {
+	.notifier_call	= process_notifier,
+};
+
+static int __init proc_uid_sys_stats_init(void)
+{
+	hash_init(hash_table);
+
+	cpu_parent = proc_mkdir("uid_cputime", NULL);
+	if (!cpu_parent) {
+		pr_err("%s: failed to create uid_cputime proc entry\n",
+			__func__);
+		goto err;
+	}
+
+	proc_create_data("remove_uid_range", 0222, cpu_parent,
+		&uid_remove_fops, NULL);
+	proc_create_data("show_uid_stat", 0444, cpu_parent,
+		&uid_cputime_fops, NULL);
+
+	io_parent = proc_mkdir("uid_io", NULL);
+	if (!io_parent) {
+		pr_err("%s: failed to create uid_io proc entry\n",
+			__func__);
+		goto err;
+	}
+
+	proc_create_data("stats", 0444, io_parent,
+		&uid_io_fops, NULL);
+
+	proc_parent = proc_mkdir("uid_procstat", NULL);
+	if (!proc_parent) {
+		pr_err("%s: failed to create uid_procstat proc entry\n",
+			__func__);
+		goto err;
+	}
+
+	proc_create_data("set", 0222, proc_parent,
+		&uid_procstat_fops, NULL);
+
+	profile_event_register(PROFILE_TASK_EXIT, &process_notifier_block);
+
+	return 0;
+
+err:
+	remove_proc_subtree("uid_cputime", NULL);
+	remove_proc_subtree("uid_io", NULL);
+	remove_proc_subtree("uid_procstat", NULL);
+	return -ENOMEM;
+}
+
+early_initcall(proc_uid_sys_stats_init);
diff --git a/drivers/mmc/card/Kconfig b/drivers/mmc/card/Kconfig
index 5562308..6142ec1 100644
--- a/drivers/mmc/card/Kconfig
+++ b/drivers/mmc/card/Kconfig
@@ -68,3 +68,15 @@ config MMC_TEST
 
 	  This driver is only of interest to those developing or
 	  testing a host driver. Most people should say N here.
+
+config MMC_SIMULATE_MAX_SPEED
+	bool "Turn on maximum speed control per block device"
+	depends on MMC_BLOCK
+	help
+	  Say Y here to enable MMC device speed limiting. Used to test and
+	  simulate the behavior of the system when confronted with a slow MMC.
+
+	  Enables max_read_speed, max_write_speed and cache_size attributes to
+	  control the write or read maximum KB/second speed behaviors.
+
+	  If unsure, say N here.
diff --git a/drivers/mmc/card/block.c b/drivers/mmc/card/block.c
index 709a872..f366e23 100644
--- a/drivers/mmc/card/block.c
+++ b/drivers/mmc/card/block.c
@@ -36,6 +36,9 @@
 #include <linux/compat.h>
 #include <linux/pm_runtime.h>
 #include <linux/idr.h>
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#include <linux/ioprio.h>
+#endif
 
 #include <linux/mmc/ioctl.h>
 #include <linux/mmc/card.h>
@@ -48,6 +51,10 @@
 #include "queue.h"
 #include "block.h"
 
+#ifdef CONFIG_RTK_PLATFORM
+#include "../../base/base.h"
+#endif /* CONFIG_RTK_PLATFORM */
+
 MODULE_ALIAS("mmc:block");
 #ifdef MODULE_PARAM_PREFIX
 #undef MODULE_PARAM_PREFIX
@@ -104,6 +111,9 @@ struct mmc_blk_data {
 #define MMC_BLK_REL_WR	(1 << 1)	/* MMC Reliable write support */
 #define MMC_BLK_PACKED_CMD	(1 << 2)	/* MMC packed command support */
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#define MMC_BLK_CMD_QUEUE	(1 << 3) /* MMC command queue support */
+#endif
 	unsigned int	usage;
 	unsigned int	read_only;
 	unsigned int	part_type;
@@ -138,6 +148,15 @@ enum {
 static inline int mmc_blk_part_switch(struct mmc_card *card,
 				      struct mmc_blk_data *md);
 static int get_card_status(struct mmc_card *card, u32 *status, int retries);
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+static int mmc_blk_cmdq_switch(struct mmc_card *card,
+			       struct mmc_blk_data *md, bool enable);
+#endif
+
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_PON)
+void rtkemmc_occupy_semaphore(void);
+void rtkemmc_release_semaphore(void);
+#endif
 
 static inline void mmc_blk_clear_packed(struct mmc_queue_req *mqrq)
 {
@@ -196,12 +215,14 @@ static ssize_t power_ro_lock_show(struct device *dev,
 	struct mmc_blk_data *md = mmc_blk_get(dev_to_disk(dev));
 	struct mmc_card *card = md->queue.card;
 	int locked = 0;
-
+#ifndef CONFIG_MMC_RTK_EMMC
 	if (card->ext_csd.boot_ro_lock & EXT_CSD_BOOT_WP_B_PERM_WP_EN)
 		locked = 2;
 	else if (card->ext_csd.boot_ro_lock & EXT_CSD_BOOT_WP_B_PWR_WP_EN)
 		locked = 1;
-
+#else
+	locked = card->ext_csd.boot_ro_lock;
+#endif
 	ret = snprintf(buf, PAGE_SIZE, "%d\n", locked);
 
 	mmc_blk_put(md);
@@ -216,18 +237,60 @@ static ssize_t power_ro_lock_store(struct device *dev,
 	struct mmc_blk_data *md, *part_md;
 	struct mmc_card *card;
 	unsigned long set;
+#ifdef CONFIG_MMC_RTK_EMMC
+	unsigned int mode=0, mode_tmp=0;
+#endif
 
 	if (kstrtoul(buf, 0, &set))
 		return -EINVAL;
 
+#ifndef CONFIG_MMC_RTK_EMMC
 	if (set != 1)
 		return count;
+#else
+	sscanf(buf,"%d",&mode);
+
+        if(mode>255 || ((mode & EXT_CSD_BOOT_WP_B_PWR_WP_EN)==0 && (mode & EXT_CSD_BOOT_WP_B_PERM_WP_EN)==0)) {
+                printk(KERN_ERR "Bad setting...\n");
+                return count;
+        }
+#endif
 
 	md = mmc_blk_get(dev_to_disk(dev));
 	card = md->queue.card;
 
 	mmc_get_card(card);
 
+#ifdef CONFIG_MMC_RTK_EMMC
+	if((mode & EXT_CSD_BOOT_WP_SEL)==0x0) {
+		if(mode & EXT_CSD_BOOT_WP_B_PERM_WP_EN) mode_tmp |= EXT_CSD_BOOT_WP_B_PERM_WP_EN;
+		else mode_tmp |= EXT_CSD_BOOT_WP_B_PWR_WP_EN;
+        }
+	else if((mode & EXT_CSD_BOOT_WP_SEL)==0x80){
+		if(mode & EXT_CSD_BOOT_WP_B_PERM_WP_EN) {
+			mode_tmp |= EXT_CSD_BOOT_WP_B_PERM_WP_EN;
+			mode_tmp |= EXT_CSD_BOOT_WP_SEL;
+			if(mode & EXT_CSD_BOOT_WP_PERM_SEL) mode_tmp |= EXT_CSD_BOOT_WP_PERM_SEL ;
+		}
+		else {
+			mode_tmp |= EXT_CSD_BOOT_WP_B_PWR_WP_EN;
+			mode_tmp |= EXT_CSD_BOOT_WP_SEL;
+			if(mode & EXT_CSD_BOOT_WP_PWR_SEL)  mode_tmp |= EXT_CSD_BOOT_WP_PWR_SEL ;
+		}
+	}
+#endif
+
+#ifdef CONFIG_MMC_RTK_EMMC
+	ret = mmc_switch(card, EXT_CSD_CMD_SET_NORMAL, EXT_CSD_BOOT_WP,
+				card->ext_csd.boot_ro_lock | mode_tmp,
+				card->ext_csd.part_time);
+	if (ret) {
+		if(mode & EXT_CSD_BOOT_WP_B_PERM_WP_EN) pr_err("%s: Locking boot partition ro permanently failed: %d\n", md->disk->disk_name, ret);
+		else pr_err("%s: Locking boot partition ro until next power on failed: %d\n", md->disk->disk_name, ret);
+	}
+	else
+		card->ext_csd.boot_ro_lock |= mode_tmp;
+#else
 	ret = mmc_switch(card, EXT_CSD_CMD_SET_NORMAL, EXT_CSD_BOOT_WP,
 				card->ext_csd.boot_ro_lock |
 				EXT_CSD_BOOT_WP_B_PWR_WP_EN,
@@ -236,10 +299,82 @@ static ssize_t power_ro_lock_store(struct device *dev,
 		pr_err("%s: Locking boot partition ro until next power on failed: %d\n", md->disk->disk_name, ret);
 	else
 		card->ext_csd.boot_ro_lock |= EXT_CSD_BOOT_WP_B_PWR_WP_EN;
-
+#endif
 	mmc_put_card(card);
 
 	if (!ret) {
+#ifdef CONFIG_MMC_RTK_EMMC
+		if((mode & EXT_CSD_BOOT_WP_SEL)==0x0) {
+			if(mode & EXT_CSD_BOOT_WP_B_PERM_WP_EN) printk(KERN_ERR "%s: [1] Locking boot partition ro permanently\n", md->disk->disk_name);
+			else printk(KERN_ERR "%s: Locking boot partition ro until next power on\n", md->disk->disk_name);
+			set_disk_ro(md->disk, 1);
+
+			list_for_each_entry(part_md, &md->part, part)
+				if (part_md->area_type == MMC_BLK_DATA_AREA_BOOT) {
+					if(mode & EXT_CSD_BOOT_WP_B_PERM_WP_EN) printk(KERN_ERR "%s: [1] Locking boot partition ro permanently\n", part_md->disk->disk_name);
+					else printk(KERN_ERR "%s: Locking boot partition ro until next power on\n", part_md->disk->disk_name);
+					set_disk_ro(part_md->disk, 1);
+				}
+		}
+		else {
+			if(mode & EXT_CSD_BOOT_WP_B_PERM_WP_EN) {
+				if((mode & EXT_CSD_BOOT_WP_PERM_SEL)==0x0) {
+					if (strcmp(md->disk->disk_name,"mmcblk0boot0")==0) {
+						printk(KERN_ERR "%s: Locking boot partition ro permanently\n", md->disk->disk_name);
+						set_disk_ro(md->disk, 1);
+					}
+					else {
+						list_for_each_entry(part_md, &md->part, part)
+							if (strcmp(part_md->disk->disk_name,"mmcblk0boot0")==0) {
+								printk(KERN_ERR "%s: Locking boot partition ro permanently\n", part_md->disk->disk_name);
+								set_disk_ro(part_md->disk, 1);
+							}
+					}
+				}
+				else {
+					if (strcmp(md->disk->disk_name,"mmcblk0boot1")==0) {
+						printk(KERN_ERR "%s: Locking boot partition ro permanently\n", md->disk->disk_name);
+						set_disk_ro(md->disk, 1);
+					}
+					else {
+						list_for_each_entry(part_md, &md->part, part)
+							if (strcmp(part_md->disk->disk_name,"mmcblk0boot1")==0) {
+								printk(KERN_ERR "%s: Locking boot partition ro permanently\n", part_md->disk->disk_name);
+								set_disk_ro(part_md->disk, 1);
+							}
+					}
+				}
+			}
+			else {
+				if((mode & EXT_CSD_BOOT_WP_PWR_SEL)==0x0) {
+					if (strcmp(md->disk->disk_name,"mmcblk0boot0")==0) {
+						printk(KERN_ERR "%s: Locking boot partition ro until next power on\n", md->disk->disk_name);
+						set_disk_ro(md->disk, 1);
+					}
+					else {
+						list_for_each_entry(part_md, &md->part, part)
+							if (strcmp(part_md->disk->disk_name,"mmcblk0boot0")==0) {
+								printk(KERN_ERR "%s: Locking boot partition ro until next power on\n", part_md->disk->disk_name);
+								set_disk_ro(part_md->disk, 1);
+							}
+					}
+				}
+				else {
+					if (strcmp(md->disk->disk_name,"mmcblk0boot1")==0) {
+						printk(KERN_ERR "%s: Locking boot partition ro until next power on\n", md->disk->disk_name);
+						set_disk_ro(md->disk, 1);
+					}
+					else {
+						list_for_each_entry(part_md, &md->part, part)
+							if (strcmp(part_md->disk->disk_name,"mmcblk0boot1")==0) {
+								printk(KERN_ERR "%s: Locking boot partition ro until next power on\n", part_md->disk->disk_name);
+								set_disk_ro(part_md->disk, 1);
+							}
+					}
+				}
+			}
+		}
+#else
 		pr_info("%s: Locking boot partition ro until next power on\n",
 			md->disk->disk_name);
 		set_disk_ro(md->disk, 1);
@@ -249,6 +384,7 @@ static ssize_t power_ro_lock_store(struct device *dev,
 				pr_info("%s: Locking boot partition ro until next power on\n", part_md->disk->disk_name);
 				set_disk_ro(part_md->disk, 1);
 			}
+#endif
 	}
 
 	mmc_blk_put(md);
@@ -287,6 +423,250 @@ static ssize_t force_ro_store(struct device *dev, struct device_attribute *attr,
 	return ret;
 }
 
+#ifdef CONFIG_MMC_SIMULATE_MAX_SPEED
+
+static int max_read_speed, max_write_speed, cache_size = 4;
+
+module_param(max_read_speed, int, S_IRUSR | S_IRGRP);
+MODULE_PARM_DESC(max_read_speed, "maximum KB/s read speed 0=off");
+module_param(max_write_speed, int, S_IRUSR | S_IRGRP);
+MODULE_PARM_DESC(max_write_speed, "maximum KB/s write speed 0=off");
+module_param(cache_size, int, S_IRUSR | S_IRGRP);
+MODULE_PARM_DESC(cache_size, "MB high speed memory or SLC cache");
+
+/*
+ * helper macros and expectations:
+ *  size    - unsigned long number of bytes
+ *  jiffies - unsigned long HZ timestamp difference
+ *  speed   - unsigned KB/s transfer rate
+ */
+#define size_and_speed_to_jiffies(size, speed) \
+		((size) * HZ / (speed) / 1024UL)
+#define jiffies_and_speed_to_size(jiffies, speed) \
+		(((speed) * (jiffies) * 1024UL) / HZ)
+#define jiffies_and_size_to_speed(jiffies, size) \
+		((size) * HZ / (jiffies) / 1024UL)
+
+/* Limits to report warning */
+/* jiffies_and_size_to_speed(10*HZ, queue_max_hw_sectors(q) * 512UL) ~ 25 */
+#define MIN_SPEED(q) 250 /* 10 times faster than a floppy disk */
+#define MAX_SPEED(q) jiffies_and_size_to_speed(1, queue_max_sectors(q) * 512UL)
+
+#define speed_valid(speed) ((speed) > 0)
+
+static const char off[] = "off\n";
+
+static int max_speed_show(int speed, char *buf)
+{
+	if (speed)
+		return scnprintf(buf, PAGE_SIZE, "%uKB/s\n", speed);
+	else
+		return scnprintf(buf, PAGE_SIZE, off);
+}
+
+static int max_speed_store(const char *buf, struct request_queue *q)
+{
+	unsigned int limit, set = 0;
+
+	if (!strncasecmp(off, buf, sizeof(off) - 2))
+		return set;
+	if (kstrtouint(buf, 0, &set) || (set > INT_MAX))
+		return -EINVAL;
+	if (set == 0)
+		return set;
+	limit = MAX_SPEED(q);
+	if (set > limit)
+		pr_warn("max speed %u ineffective above %u\n", set, limit);
+	limit = MIN_SPEED(q);
+	if (set < limit)
+		pr_warn("max speed %u painful below %u\n", set, limit);
+	return set;
+}
+
+static ssize_t max_write_speed_show(struct device *dev,
+				 struct device_attribute *attr, char *buf)
+{
+	struct mmc_blk_data *md = mmc_blk_get(dev_to_disk(dev));
+	int ret = max_speed_show(atomic_read(&md->queue.max_write_speed), buf);
+
+	mmc_blk_put(md);
+	return ret;
+}
+
+static ssize_t max_write_speed_store(struct device *dev,
+				  struct device_attribute *attr,
+				  const char *buf, size_t count)
+{
+	struct mmc_blk_data *md = mmc_blk_get(dev_to_disk(dev));
+	int set = max_speed_store(buf, md->queue.queue);
+
+	if (set < 0) {
+		mmc_blk_put(md);
+		return set;
+	}
+
+	atomic_set(&md->queue.max_write_speed, set);
+	mmc_blk_put(md);
+	return count;
+}
+
+static const DEVICE_ATTR(max_write_speed, S_IRUGO | S_IWUSR,
+	max_write_speed_show, max_write_speed_store);
+
+static ssize_t max_read_speed_show(struct device *dev,
+				 struct device_attribute *attr, char *buf)
+{
+	struct mmc_blk_data *md = mmc_blk_get(dev_to_disk(dev));
+	int ret = max_speed_show(atomic_read(&md->queue.max_read_speed), buf);
+
+	mmc_blk_put(md);
+	return ret;
+}
+
+static ssize_t max_read_speed_store(struct device *dev,
+				  struct device_attribute *attr,
+				  const char *buf, size_t count)
+{
+	struct mmc_blk_data *md = mmc_blk_get(dev_to_disk(dev));
+	int set = max_speed_store(buf, md->queue.queue);
+
+	if (set < 0) {
+		mmc_blk_put(md);
+		return set;
+	}
+
+	atomic_set(&md->queue.max_read_speed, set);
+	mmc_blk_put(md);
+	return count;
+}
+
+static const DEVICE_ATTR(max_read_speed, S_IRUGO | S_IWUSR,
+	max_read_speed_show, max_read_speed_store);
+
+static ssize_t cache_size_show(struct device *dev,
+			       struct device_attribute *attr, char *buf)
+{
+	struct mmc_blk_data *md = mmc_blk_get(dev_to_disk(dev));
+	struct mmc_queue *mq = &md->queue;
+	int cache_size = atomic_read(&mq->cache_size);
+	int ret;
+
+	if (!cache_size)
+		ret = scnprintf(buf, PAGE_SIZE, off);
+	else {
+		int speed = atomic_read(&mq->max_write_speed);
+
+		if (!speed_valid(speed))
+			ret = scnprintf(buf, PAGE_SIZE, "%uMB\n", cache_size);
+		else { /* We accept race between cache_jiffies and cache_used */
+			unsigned long size = jiffies_and_speed_to_size(
+				jiffies - mq->cache_jiffies, speed);
+			long used = atomic_long_read(&mq->cache_used);
+
+			if (size >= used)
+				size = 0;
+			else
+				size = (used - size) * 100 / cache_size
+					/ 1024UL / 1024UL;
+
+			ret = scnprintf(buf, PAGE_SIZE, "%uMB %lu%% used\n",
+				cache_size, size);
+		}
+	}
+
+	mmc_blk_put(md);
+	return ret;
+}
+
+static ssize_t cache_size_store(struct device *dev,
+				  struct device_attribute *attr,
+				  const char *buf, size_t count)
+{
+	struct mmc_blk_data *md;
+	unsigned int set = 0;
+
+	if (strncasecmp(off, buf, sizeof(off) - 2)
+	 && (kstrtouint(buf, 0, &set) || (set > INT_MAX)))
+		return -EINVAL;
+
+	md = mmc_blk_get(dev_to_disk(dev));
+	atomic_set(&md->queue.cache_size, set);
+	mmc_blk_put(md);
+	return count;
+}
+
+static const DEVICE_ATTR(cache_size, S_IRUGO | S_IWUSR,
+	cache_size_show, cache_size_store);
+
+/* correct for write-back */
+static long mmc_blk_cache_used(struct mmc_queue *mq, unsigned long waitfor)
+{
+	long used = 0;
+	int speed = atomic_read(&mq->max_write_speed);
+
+	if (speed_valid(speed)) {
+		unsigned long size = jiffies_and_speed_to_size(
+					waitfor - mq->cache_jiffies, speed);
+		used = atomic_long_read(&mq->cache_used);
+
+		if (size >= used)
+			used = 0;
+		else
+			used -= size;
+	}
+
+	atomic_long_set(&mq->cache_used, used);
+	mq->cache_jiffies = waitfor;
+
+	return used;
+}
+
+static void mmc_blk_simulate_delay(
+	struct mmc_queue *mq,
+	struct request *req,
+	unsigned long waitfor)
+{
+	int max_speed;
+
+	if (!req)
+		return;
+
+	max_speed = (rq_data_dir(req) == READ)
+		? atomic_read(&mq->max_read_speed)
+		: atomic_read(&mq->max_write_speed);
+	if (speed_valid(max_speed)) {
+		unsigned long bytes = blk_rq_bytes(req);
+
+		if (rq_data_dir(req) != READ) {
+			int cache_size = atomic_read(&mq->cache_size);
+
+			if (cache_size) {
+				unsigned long size = cache_size * 1024L * 1024L;
+				long used = mmc_blk_cache_used(mq, waitfor);
+
+				used += bytes;
+				atomic_long_set(&mq->cache_used, used);
+				bytes = 0;
+				if (used > size)
+					bytes = used - size;
+			}
+		}
+		waitfor += size_and_speed_to_jiffies(bytes, max_speed);
+		if (time_is_after_jiffies(waitfor)) {
+			long msecs = jiffies_to_msecs(waitfor - jiffies);
+
+			if (likely(msecs > 0))
+				msleep(msecs);
+		}
+	}
+}
+
+#else
+
+#define mmc_blk_simulate_delay(mq, req, waitfor)
+
+#endif
+
 static int mmc_blk_open(struct block_device *bdev, fmode_t mode)
 {
 	struct mmc_blk_data *md = mmc_blk_get(bdev->bd_disk);
@@ -746,6 +1126,51 @@ static int mmc_blk_compat_ioctl(struct block_device *bdev, fmode_t mode,
 #endif
 };
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+static int mmc_blk_cmdq_switch(struct mmc_card *card,
+			       struct mmc_blk_data *md, bool enable)
+{
+	int ret = 0;
+	bool cmdq_mode = !!mmc_card_cmdq(card);
+	if (!(card->host->caps2 & MMC_CAP2_CMD_QUEUE) ||
+	    !card->ext_csd.cmdq_support ||
+	    (enable && !(md->flags & MMC_BLK_CMD_QUEUE)) ||
+	    (cmdq_mode == enable))
+		return 0;
+
+#if 0
+	if(enable==1)
+		printk(KERN_ERR "%s: Enable command queue by command 6...\n", __func__);
+	else printk(KERN_ERR "%s: Disable command queue by command 6...\n", __func__);
+#endif
+	if (enable) {
+		ret = mmc_set_blocklen(card, MMC_CARD_CMDQ_BLK_SIZE);
+		if (ret) {
+			pr_err("%s: failed (%d) to set block-size to %d\n",
+			       __func__, ret, MMC_CARD_CMDQ_BLK_SIZE);
+			goto out;
+		}
+	}
+	ret = mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
+			 EXT_CSD_CMDQ, enable,
+			 card->ext_csd.generic_cmd6_time);
+	if (ret) {
+		pr_err("%s: cmdq mode %sable failed %d\n",
+		       md->disk->disk_name, enable ? "en" : "dis", ret);
+		goto out;
+	}
+
+	if (enable)
+		mmc_card_set_cmdq(card);
+	else
+		mmc_card_clr_cmdq(card);
+
+out:
+	return ret;
+}
+#endif
+
+
 static inline int mmc_blk_part_switch(struct mmc_card *card,
 				      struct mmc_blk_data *md)
 {
@@ -757,10 +1182,26 @@ static inline int mmc_blk_part_switch(struct mmc_card *card,
 
 	if (mmc_card_mmc(card)) {
 		u8 part_config = card->ext_csd.part_config;
-
+#ifndef CONFIG_RTK_PLATFORM
 		if (md->part_type == EXT_CSD_PART_CONFIG_ACC_RPMB)
 			mmc_retune_pause(card->host);
+#endif
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+		if (md->part_type) {
+			mmc_cmdq_halt(card->host, true);
+			card->host->cmdq_ops->disable(card->host, true);
+			/* disable CQ mode for non-user data partitions */
+			ret = mmc_blk_cmdq_switch(card, md, false);
+			if (ret)
+				return ret;
+		}
+#endif
+
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_PON)
+		if (md->part_type)	//PON cannot access rpmb and boot partition area
+			rtkemmc_occupy_semaphore();
+#endif
 		part_config &= ~EXT_CSD_PART_CONFIG_ACC_MASK;
 		part_config |= md->part_type;
 
@@ -774,9 +1215,28 @@ static inline int mmc_blk_part_switch(struct mmc_card *card,
 		}
 
 		card->ext_csd.part_config = part_config;
-
+#ifndef CONFIG_RTK_PLATFORM
 		if (main_md->part_curr == EXT_CSD_PART_CONFIG_ACC_RPMB)
 			mmc_retune_unpause(card->host);
+#endif
+
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_PON)
+		if (md->part_type==0)	//after swithing back to user data area, release the pon semaphore
+			rtkemmc_release_semaphore();
+#endif
+
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+		if (md->part_type==0) {
+                        /* disable CQ mode for non-user data partitions */
+                        ret = mmc_blk_cmdq_switch(card, md, true);
+                        if (ret)
+                                return ret;
+
+                        card->host->cmdq_ops->enable(card->host);
+
+                        mmc_cmdq_halt(card->host, false);
+		}
+#endif
 	}
 
 	main_md->part_curr = md->part_type;
@@ -1284,6 +1744,23 @@ static int mmc_blk_issue_flush(struct mmc_queue *mq, struct request *req)
 	if (ret)
 		ret = -EIO;
 
+#ifdef CONFIG_MMC_SIMULATE_MAX_SPEED
+	else if (atomic_read(&mq->cache_size)) {
+		long used = mmc_blk_cache_used(mq, jiffies);
+
+		if (used) {
+			int speed = atomic_read(&mq->max_write_speed);
+
+			if (speed_valid(speed)) {
+				unsigned long msecs = jiffies_to_msecs(
+					size_and_speed_to_jiffies(
+						used, speed));
+				if (msecs)
+					msleep(msecs);
+			}
+		}
+	}
+#endif
 	blk_end_request_all(req, ret);
 
 	return ret ? 0 : 1;
@@ -1953,6 +2430,297 @@ static void mmc_blk_revert_packed_req(struct mmc_queue *mq,
 	mmc_blk_clear_packed(mq_rq);
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+static int mmc_blk_cmdq_start_req(struct mmc_host *host,
+				  struct mmc_cmdq_req *cmdq_req)
+{
+	struct mmc_request *mrq = &cmdq_req->mrq;
+	mrq->done = mmc_blk_cmdq_req_done;
+	return mmc_cmdq_start_req(host, cmdq_req);
+}
+
+/* prepare for non-data commands */
+static struct mmc_cmdq_req *mmc_cmdq_prep_dcmd(
+		struct mmc_queue_req *mqrq, struct mmc_queue *mq)
+{
+	struct request *req = mqrq->req;
+	struct mmc_cmdq_req *cmdq_req = &mqrq->cmdq_req;
+
+	memset(&mqrq->cmdq_req, 0, sizeof(struct mmc_cmdq_req));
+
+	cmdq_req->mrq.data = NULL;
+	cmdq_req->cmd_flags = req->cmd_flags;
+	cmdq_req->mrq.req = mqrq->req;
+	req->special = mqrq;
+	cmdq_req->cmdq_req_flags |= DCMD;
+	cmdq_req->mrq.cmdq_req = cmdq_req;
+
+	return &mqrq->cmdq_req;
+}
+#define IS_RT_CLASS_REQ(x)     \
+	(IOPRIO_PRIO_CLASS(req_get_ioprio(x)) == IOPRIO_CLASS_RT)
+
+static struct mmc_cmdq_req *mmc_blk_cmdq_rw_prep(
+		struct mmc_queue_req *mqrq, struct mmc_queue *mq)
+{
+	struct mmc_card *card = mq->card;
+	struct request *req = mqrq->req;
+	struct mmc_blk_data *md = mq->data;
+	bool do_rel_wr = mmc_req_rel_wr(req) && (md->flags & MMC_BLK_REL_WR);
+	bool do_data_tag;
+	bool read_dir = (rq_data_dir(req) == READ);
+	bool prio = IS_RT_CLASS_REQ(req);
+	struct mmc_cmdq_req *cmdq_rq = &mqrq->cmdq_req;
+
+	memset(&mqrq->cmdq_req, 0, sizeof(struct mmc_cmdq_req));
+
+	cmdq_rq->tag = req->tag;
+
+	if (read_dir) {
+		cmdq_rq->cmdq_req_flags |= DIR;
+		cmdq_rq->data.flags = MMC_DATA_READ;
+	} else {
+		cmdq_rq->data.flags = MMC_DATA_WRITE;
+	}
+	if (prio)
+		cmdq_rq->cmdq_req_flags |= PRIO;
+
+	if (do_rel_wr)
+		cmdq_rq->cmdq_req_flags |= REL_WR;
+
+	cmdq_rq->data.blocks = blk_rq_sectors(req);
+	cmdq_rq->blk_addr = blk_rq_pos(req);
+	cmdq_rq->data.blksz = MMC_CARD_CMDQ_BLK_SIZE;
+
+	mmc_set_data_timeout(&cmdq_rq->data, card);
+
+	do_data_tag = (card->ext_csd.data_tag_unit_size) &&
+		(req->cmd_flags & REQ_META) &&
+		(rq_data_dir(req) == WRITE) &&
+		((cmdq_rq->data.blocks * cmdq_rq->data.blksz) >=
+		 card->ext_csd.data_tag_unit_size);
+	if (do_data_tag)
+		cmdq_rq->cmdq_req_flags |= DAT_TAG;
+	cmdq_rq->data.sg = mqrq->sg;
+	cmdq_rq->data.sg_len = mmc_queue_map_sg(mq, mqrq);
+
+	/*
+	 * Adjust the sg list so it is the same size as the
+	 * request.
+	 */
+	if (cmdq_rq->data.blocks > card->host->max_blk_count)
+		cmdq_rq->data.blocks = card->host->max_blk_count;
+
+	if (cmdq_rq->data.blocks != blk_rq_sectors(req)) {
+		int i, data_size = cmdq_rq->data.blocks << 9;
+		struct scatterlist *sg;
+
+		for_each_sg(cmdq_rq->data.sg, sg, cmdq_rq->data.sg_len, i) {
+			data_size -= sg->length;
+			if (data_size <= 0) {
+				sg->length += data_size;
+				i++;
+				break;
+			}
+		}
+		cmdq_rq->data.sg_len = i;
+	}
+
+	mqrq->cmdq_req.cmd_flags = req->cmd_flags;
+	mqrq->cmdq_req.mrq.req = mqrq->req;
+	mqrq->cmdq_req.mrq.cmdq_req = &mqrq->cmdq_req;
+	mqrq->cmdq_req.mrq.data = &mqrq->cmdq_req.data;
+	mqrq->req->special = mqrq;
+#if 0
+	printk(KERN_INFO "%s: %s: mrq: 0x%p req: 0x%p mqrq: 0x%p bytes to xf: %d mmc_cmdq_req: 0x%p card-addr: 0x%08x dir(r-1/w-0): %d\n",
+		 mmc_hostname(card->host), __func__, &mqrq->cmdq_req.mrq,
+		 mqrq->req, mqrq, (cmdq_rq->data.blocks * cmdq_rq->data.blksz),
+		 cmdq_rq, cmdq_rq->blk_addr,
+		 (cmdq_rq->cmdq_req_flags & DIR) ? 1 : 0);
+#endif
+	return &mqrq->cmdq_req;
+}
+
+static struct mmc_cmdq_req *mmc_blk_cmdq_prep_discard_req(struct mmc_queue *mq,
+						struct request *req)
+{
+	struct mmc_blk_data *md = mq->data;
+	struct mmc_card *card = md->queue.card;
+	struct mmc_host *host = card->host;
+	struct mmc_cmdq_context_info *ctx_info = &host->cmdq_ctx;
+	struct mmc_cmdq_req *cmdq_req;
+	struct mmc_queue_req *active_mqrq;
+
+	BUG_ON(req->tag > card->ext_csd.cmdq_depth);
+	BUG_ON(test_and_set_bit(req->tag, &host->cmdq_ctx.active_reqs));
+
+	set_bit(CMDQ_STATE_DCMD_ACTIVE, &ctx_info->curr_state);
+	active_mqrq = &mq->mqrq_cmdq[req->tag];
+	active_mqrq->req = req;
+	cmdq_req = mmc_cmdq_prep_dcmd(active_mqrq, mq);
+	cmdq_req->cmdq_req_flags |= QBR;
+	cmdq_req->mrq.cmd = &cmdq_req->cmd;
+	cmdq_req->tag = req->tag;
+
+	return cmdq_req;
+}
+
+int mmc_blk_cmdq_issue_rw_rq(struct mmc_queue *mq, struct request *req)
+{
+	struct mmc_queue_req *active_mqrq;
+	struct mmc_card *card = mq->card;
+	struct mmc_host *host = card->host;
+	struct mmc_cmdq_req *mc_rq;
+	int ret = 0;
+
+	BUG_ON((req->tag < 0) || (req->tag > card->ext_csd.cmdq_depth));
+	BUG_ON(test_and_set_bit(req->tag, &host->cmdq_ctx.active_reqs));
+
+	active_mqrq = &mq->mqrq_cmdq[req->tag];
+	active_mqrq->req = req;
+
+	mc_rq = mmc_blk_cmdq_rw_prep(active_mqrq, mq);
+
+	ret = mmc_blk_cmdq_start_req(card->host, mc_rq);
+	return ret;
+}
+EXPORT_SYMBOL(mmc_blk_cmdq_issue_rw_rq);
+/*
+ * Issues a flush (dcmd) request
+ */
+int mmc_blk_cmdq_issue_flush_rq(struct mmc_queue *mq, struct request *req)
+{
+	int err;
+	struct mmc_queue_req *active_mqrq;
+	struct mmc_card *card = mq->card;
+	struct mmc_host *host;
+	struct mmc_cmdq_req *cmdq_req;
+	struct mmc_cmdq_context_info *ctx_info;
+	BUG_ON(!card);
+	host = card->host;
+	BUG_ON(!host);
+	BUG_ON(req->tag > card->ext_csd.cmdq_depth);
+	BUG_ON(test_and_set_bit(req->tag, &host->cmdq_ctx.active_reqs));
+
+	ctx_info = &host->cmdq_ctx;
+
+	set_bit(CMDQ_STATE_DCMD_ACTIVE, &ctx_info->curr_state);
+
+	active_mqrq = &mq->mqrq_cmdq[req->tag];
+	active_mqrq->req = req;
+	cmdq_req = mmc_cmdq_prep_dcmd(active_mqrq, mq);
+	cmdq_req->cmdq_req_flags |= QBR;
+	cmdq_req->mrq.cmd = &cmdq_req->cmd;
+	cmdq_req->tag = req->tag;
+
+	err = mmc_cmdq_prepare_flush(cmdq_req->mrq.cmd);
+	if (err) {
+		pr_err("%s: failed (%d) preparing flush req\n",
+		       mmc_hostname(host), err);
+		return err;
+	}
+	err = mmc_blk_cmdq_start_req(card->host, cmdq_req);
+	return err;
+}
+EXPORT_SYMBOL(mmc_blk_cmdq_issue_flush_rq);
+
+int mmc_blk_cmdq_issue_discard_rq(struct mmc_queue *mq,
+					struct request *req)
+{
+	struct mmc_blk_data *md = mq->data;
+	struct mmc_card *card = md->queue.card;
+	struct mmc_cmdq_req *cmdq_req = NULL;
+	unsigned int from, nr, arg;
+	int err = 0;
+	if (!mmc_can_erase(card)) {
+		err = -EOPNOTSUPP;
+		blk_end_request(req, err, blk_rq_bytes(req));
+		goto out;
+	}
+	from = blk_rq_pos(req);
+	nr = blk_rq_sectors(req);
+
+	if (mmc_can_discard(card))
+		arg = MMC_DISCARD_ARG;
+	else if (mmc_can_trim(card))
+		arg = MMC_TRIM_ARG;
+	else
+		arg = MMC_ERASE_ARG;
+	cmdq_req = mmc_blk_cmdq_prep_discard_req(mq, req);
+	if (card->quirks & MMC_QUIRK_INAND_CMD38) {
+		__mmc_switch_cmdq_mode(cmdq_req->mrq.cmd,
+				EXT_CSD_CMD_SET_NORMAL,
+				INAND_CMD38_ARG_EXT_CSD,
+				arg == MMC_TRIM_ARG ?
+				INAND_CMD38_ARG_TRIM :
+				INAND_CMD38_ARG_ERASE,
+				0, true, false);
+		err = mmc_cmdq_wait_for_dcmd(card->host, cmdq_req);
+		if (err)
+			goto clear_dcmd;
+	}
+	err = mmc_cmdq_erase(cmdq_req, card, from, nr, arg);
+clear_dcmd:
+	blk_complete_request(req);
+out:
+	return err ? 1 : 0;
+}
+EXPORT_SYMBOL(mmc_blk_cmdq_issue_discard_rq);
+
+/* invoked by block layer in softirq context */
+static void mmc_blk_cmdq_complete_rq(struct request *rq)
+{
+	struct mmc_queue_req *mq_rq = rq->special;
+	struct mmc_request *mrq = &mq_rq->cmdq_req.mrq;
+	struct mmc_host *host = mrq->host;
+	struct mmc_cmdq_context_info *ctx_info = &host->cmdq_ctx;
+	struct mmc_cmdq_req *cmdq_req = &mq_rq->cmdq_req;
+	struct mmc_queue *mq = (struct mmc_queue *)rq->q->queuedata;
+	int err = 0;
+
+	if (mrq->cmd && mrq->cmd->error)
+		err = mrq->cmd->error;
+	else if (mrq->data && mrq->data->error)
+		err = mrq->data->error;
+
+	mmc_cmdq_post_req(host, cmdq_req->tag, err);
+	if (err) {
+		pr_err("%s: %s: txfr error: %d\n", mmc_hostname(mrq->host),
+		       __func__, err);
+		set_bit(CMDQ_STATE_ERR, &ctx_info->curr_state);
+		WARN_ON(1);
+	}
+
+	BUG_ON(!test_and_clear_bit(cmdq_req->tag,
+				   &ctx_info->active_reqs));
+
+	if (cmdq_req->cmdq_req_flags & DCMD) {
+		clear_bit(CMDQ_STATE_DCMD_ACTIVE, &ctx_info->curr_state);
+		blk_end_request_all(rq, 0);
+		goto out;
+	}
+
+	blk_end_request(rq, err, cmdq_req->data.bytes_xfered);
+out:
+	if (test_and_clear_bit(0, &ctx_info->req_starved))
+		blk_run_queue(mq->queue);
+
+	mmc_release_host(host);
+}
+/*
+ * Complete reqs from block layer softirq context
+ * Invoked in irq context
+ */
+void mmc_blk_cmdq_req_done(struct mmc_request *mrq)
+{
+	struct request *req = mrq->req;
+
+	blk_complete_request(req);
+}
+EXPORT_SYMBOL(mmc_blk_cmdq_req_done);
+#endif
+
+
 static int mmc_blk_issue_rw_rq(struct mmc_queue *mq, struct request *rqc)
 {
 	struct mmc_blk_data *md = mq->data;
@@ -1965,6 +2733,9 @@ static int mmc_blk_issue_rw_rq(struct mmc_queue *mq, struct request *rqc)
 	struct mmc_async_req *areq;
 	const u8 packed_nr = 2;
 	u8 reqs = 0;
+#ifdef CONFIG_MMC_SIMULATE_MAX_SPEED
+	unsigned long waitfor = jiffies;
+#endif
 
 	if (!rqc && !mq->mqrq_prev->req)
 		return 0;
@@ -2015,6 +2786,8 @@ static int mmc_blk_issue_rw_rq(struct mmc_queue *mq, struct request *rqc)
 			 */
 			mmc_blk_reset_success(md, type);
 
+			mmc_blk_simulate_delay(mq, rqc, waitfor);
+
 			if (mmc_packed_cmd(mq_rq->cmd_type)) {
 				ret = mmc_blk_end_packed_req(mq_rq);
 				break;
@@ -2145,6 +2918,47 @@ static int mmc_blk_issue_rw_rq(struct mmc_queue *mq, struct request *rqc)
 	return 0;
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+
+static int mmc_blk_cmdq_issue_rq(struct mmc_queue *mq, struct request *req)
+{
+	int ret;
+	struct mmc_blk_data *md = mq->data;
+	struct mmc_card *card = md->queue.card;
+
+	mmc_get_card(card);
+
+	ret = mmc_blk_part_switch(card, md);
+	if (ret) {
+		pr_err("%s: %s: partition switch failed %d\n",
+				md->disk->disk_name, __func__, ret);
+		if (req)
+			blk_end_request_all(req, ret);
+
+		mmc_release_host(card->host);
+		goto switch_failure;
+	}
+
+	if (req) {
+		if (req && req_op(req) == REQ_OP_DISCARD) {
+			ret = mmc_blk_cmdq_issue_discard_rq(mq, req);
+		}
+		else if(req && req_op(req) == REQ_OP_SECURE_ERASE) {
+			printk(KERN_ERR "REQ_OP_SECURE_ERASE is not implemented yet !!!!!!\n");
+			//TBD
+		}
+		else if (req && req_op(req) == REQ_OP_FLUSH) {
+			ret = mmc_blk_cmdq_issue_flush_rq(mq, req);
+		}
+		else {
+			ret = mmc_blk_cmdq_issue_rw_rq(mq, req);
+		}
+	}
+switch_failure:
+	return ret;
+}
+#endif
+
 int mmc_blk_issue_rq(struct mmc_queue *mq, struct request *req)
 {
 	int ret;
@@ -2210,6 +3024,21 @@ static inline int mmc_blk_readonly(struct mmc_card *card)
 	       !(card->csd.cmdclass & CCC_BLOCK_WRITE);
 }
 
+#ifdef CONFIG_RTK_PLATFORM
+void mmc_blk_set_ro(struct mmc_card *card)
+{
+	struct mmc_blk_data *md=NULL, *part_md=NULL;
+	md = card->dev.driver_data;
+	if(md!=NULL) {
+		md->read_only = mmc_blk_readonly(card);
+		set_disk_ro(md->disk, md->read_only);
+		list_for_each_entry(part_md, &md->part, part)
+			set_disk_ro(part_md->disk, md->read_only);
+	}
+}
+EXPORT_SYMBOL(mmc_blk_set_ro);
+#endif /* CONFIG_RTK_PLATFORM */
+
 static struct mmc_blk_data *mmc_blk_alloc_req(struct mmc_card *card,
 					      struct device *parent,
 					      sector_t size,
@@ -2261,8 +3090,11 @@ static struct mmc_blk_data *mmc_blk_alloc_req(struct mmc_card *card,
 	spin_lock_init(&md->lock);
 	INIT_LIST_HEAD(&md->part);
 	md->usage = 1;
-
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	ret = mmc_init_queue(&md->queue, card, &md->lock, subname, area_type);
+#else
 	ret = mmc_init_queue(&md->queue, card, &md->lock, subname);
+#endif
 	if (ret)
 		goto err_putdisk;
 
@@ -2317,11 +3149,24 @@ static struct mmc_blk_data *mmc_blk_alloc_req(struct mmc_card *card,
 		md->flags |= MMC_BLK_REL_WR;
 		blk_queue_write_cache(md->queue.queue, true, true);
 	}
-
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	if (card->cmdq_init) {
+		md->flags |= MMC_BLK_CMD_QUEUE;
+		md->queue.cmdq_complete_fn = mmc_blk_cmdq_complete_rq;
+		md->queue.cmdq_issue_fn = mmc_blk_cmdq_issue_rq;
+	}
+#endif
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	if (mmc_card_mmc(card) && !card->cmdq_init &&
+	    (area_type == MMC_BLK_DATA_AREA_MAIN) &&
+            (md->flags & MMC_BLK_CMD23) &&
+            card->ext_csd.packed_event_en) {
+#else
 	if (mmc_card_mmc(card) &&
 	    (area_type == MMC_BLK_DATA_AREA_MAIN) &&
 	    (md->flags & MMC_BLK_CMD23) &&
 	    card->ext_csd.packed_event_en) {
+#endif
 		if (!mmc_packed_init(&md->queue, card))
 			md->flags |= MMC_BLK_PACKED_CMD;
 	}
@@ -2431,12 +3276,25 @@ static void mmc_blk_remove_req(struct mmc_blk_data *md)
 		mmc_cleanup_queue(&md->queue);
 		if (md->flags & MMC_BLK_PACKED_CMD)
 			mmc_packed_clean(&md->queue);
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+		if (md->flags & MMC_BLK_CMD_QUEUE) {
+			mmc_cmdq_clean(&md->queue, card);
+		}
+#endif
 		if (md->disk->flags & GENHD_FL_UP) {
 			device_remove_file(disk_to_dev(md->disk), &md->force_ro);
 			if ((md->area_type & MMC_BLK_DATA_AREA_BOOT) &&
 					card->ext_csd.boot_ro_lockable)
 				device_remove_file(disk_to_dev(md->disk),
 					&md->power_ro_lock);
+#ifdef CONFIG_MMC_SIMULATE_MAX_SPEED
+			device_remove_file(disk_to_dev(md->disk),
+						&dev_attr_max_write_speed);
+			device_remove_file(disk_to_dev(md->disk),
+						&dev_attr_max_read_speed);
+			device_remove_file(disk_to_dev(md->disk),
+						&dev_attr_cache_size);
+#endif
 
 			del_gendisk(md->disk);
 		}
@@ -2471,6 +3329,24 @@ static int mmc_add_disk(struct mmc_blk_data *md)
 	ret = device_create_file(disk_to_dev(md->disk), &md->force_ro);
 	if (ret)
 		goto force_ro_fail;
+#ifdef CONFIG_MMC_SIMULATE_MAX_SPEED
+	atomic_set(&md->queue.max_write_speed, max_write_speed);
+	ret = device_create_file(disk_to_dev(md->disk),
+			&dev_attr_max_write_speed);
+	if (ret)
+		goto max_write_speed_fail;
+	atomic_set(&md->queue.max_read_speed, max_read_speed);
+	ret = device_create_file(disk_to_dev(md->disk),
+			&dev_attr_max_read_speed);
+	if (ret)
+		goto max_read_speed_fail;
+	atomic_set(&md->queue.cache_size, cache_size);
+	atomic_long_set(&md->queue.cache_used, 0);
+	md->queue.cache_jiffies = jiffies;
+	ret = device_create_file(disk_to_dev(md->disk), &dev_attr_cache_size);
+	if (ret)
+		goto cache_size_fail;
+#endif
 
 	if ((md->area_type & MMC_BLK_DATA_AREA_BOOT) &&
 	     card->ext_csd.boot_ro_lockable) {
@@ -2495,6 +3371,14 @@ static int mmc_add_disk(struct mmc_blk_data *md)
 	return ret;
 
 power_ro_lock_fail:
+#ifdef CONFIG_MMC_SIMULATE_MAX_SPEED
+	device_remove_file(disk_to_dev(md->disk), &dev_attr_cache_size);
+cache_size_fail:
+	device_remove_file(disk_to_dev(md->disk), &dev_attr_max_read_speed);
+max_read_speed_fail:
+	device_remove_file(disk_to_dev(md->disk), &dev_attr_max_write_speed);
+max_write_speed_fail:
+#endif
 	device_remove_file(disk_to_dev(md->disk), &md->force_ro);
 force_ro_fail:
 	del_gendisk(md->disk);
diff --git a/drivers/mmc/card/queue.c b/drivers/mmc/card/queue.c
index 8037f73..206b3b2 100644
--- a/drivers/mmc/card/queue.c
+++ b/drivers/mmc/card/queue.c
@@ -19,12 +19,16 @@
 
 #include <linux/mmc/card.h>
 #include <linux/mmc/host.h>
+#include <linux/sched/rt.h>
 
 #include "queue.h"
 #include "block.h"
 
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X) || defined(CONFIG_ARCH_RTD13xx)
+#define MMC_QUEUE_BOUNCESZ      0x200000
+#else
 #define MMC_QUEUE_BOUNCESZ	65536
-
+#endif
 /*
  * Prepare a MMC request. This just filters out odd stuff.
  */
@@ -49,10 +53,85 @@ static int mmc_prep_request(struct request_queue *q, struct request *req)
 	return BLKPREP_OK;
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+static inline bool mmc_cmdq_should_pull_reqs(struct mmc_host *host,
+					struct mmc_cmdq_context_info *ctx)
+{
+	if (test_bit(CMDQ_STATE_DCMD_ACTIVE, &ctx->curr_state) ||
+		mmc_host_halt(host) ||
+		test_bit(CMDQ_STATE_ERR, &ctx->curr_state)) {
+		pr_debug("%s: %s: skip pulling reqs: state: %lu\n",
+			 mmc_hostname(host), __func__, ctx->curr_state);
+		return false;
+	}
+	return true;
+}
+
+static int mmc_cmdq_thread(void *d)
+{
+	struct mmc_queue *mq = d;
+	struct request_queue *q = mq->queue;
+	struct mmc_card *card = mq->card;
+
+	struct request *req;
+	struct mmc_host *host = card->host;
+	struct mmc_cmdq_context_info *ctx = &host->cmdq_ctx;
+	unsigned long flags;
+
+	current->flags |= PF_MEMALLOC;
+
+	while (1) {
+		int ret = 0;
+		if (!mmc_cmdq_should_pull_reqs(host, ctx)) {
+			test_and_set_bit(0, &ctx->req_starved);
+			schedule();
+		}
+		spin_lock_irqsave(q->queue_lock, flags);
+
+		set_current_state(TASK_INTERRUPTIBLE);
+
+		req = blk_peek_request(q);
+		if (req) {
+			ret = blk_queue_start_tag(q, req);
+			spin_unlock_irqrestore(q->queue_lock, flags);
+			if (ret) {
+				test_and_set_bit(0, &ctx->req_starved);
+				schedule();
+			} else {
+				set_current_state(TASK_RUNNING);
+				ret = mq->cmdq_issue_fn(mq, req);
+				cond_resched();
+				if (ret) {
+					pr_err("%s: failed (%d) to issue req, requeue\n",
+					       mmc_hostname(host), ret);
+					spin_lock_irqsave(q->queue_lock, flags);
+					blk_requeue_request(q, req);
+					spin_unlock_irqrestore(q->queue_lock,
+							       flags);
+				}
+			}
+		} else {
+			spin_unlock_irqrestore(q->queue_lock, flags);
+			if (kthread_should_stop()) {
+				set_current_state(TASK_RUNNING);
+				break;
+			}
+			schedule();
+		}
+	} /* loop */
+	return 0;
+}
+#endif
+
 static int mmc_queue_thread(void *d)
 {
 	struct mmc_queue *mq = d;
 	struct request_queue *q = mq->queue;
+	struct sched_param scheduler_params = {0};
+
+	scheduler_params.sched_priority = 1;
+
+	sched_setscheduler(current, SCHED_FIFO, &scheduler_params);
 
 	current->flags |= PF_MEMALLOC;
 
@@ -105,6 +184,15 @@ static int mmc_queue_thread(void *d)
 	return 0;
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+
+static void mmc_cmdq_dispatch_req(struct request_queue *q)
+{
+	struct mmc_queue *mq = q->queuedata;
+	wake_up_process(mq->thread);
+}
+#endif
+
 /*
  * Generic MMC request handler.  This is called for any queue on a
  * particular host.  When the host is not busy, we look for a request
@@ -179,6 +267,90 @@ static void mmc_queue_setup_discard(struct request_queue *q,
 		queue_flag_set_unlocked(QUEUE_FLAG_SECERASE, q);
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+/**
+ * mmc_blk_cmdq_setup_queue
+ * @mq: mmc queue
+ * @card: card to attach to this queue
+ *
+ * Setup queue for CMDQ supporting MMC card
+ */
+static void mmc_cmdq_setup_queue(struct mmc_queue *mq, struct mmc_card *card)
+{
+	u64 limit = BLK_BOUNCE_HIGH;
+	struct mmc_host *host = card->host;
+	queue_flag_set_unlocked(QUEUE_FLAG_NONROT, mq->queue);
+	if (mmc_can_erase(card)) {
+		mmc_queue_setup_discard(mq->queue, card);
+	}
+	blk_queue_bounce_limit(mq->queue, limit);
+	blk_queue_max_hw_sectors(mq->queue, min(host->max_blk_count,
+						host->max_req_size / 512));
+	blk_queue_max_segment_size(mq->queue, host->max_seg_size);
+	blk_queue_max_segments(mq->queue, host->max_segs);
+}
+
+static void mmc_cmdq_softirq_done(struct request *rq)
+{
+	struct mmc_queue *mq = rq->q->queuedata;
+
+	mq->cmdq_complete_fn(rq);
+}
+
+static int mmc_cmdq_init(struct mmc_queue *mq, struct mmc_card *card)
+{
+	int i, ret = 0;
+	/* one slot is reserved for dcmd requests */
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+	int q_depth = card->ext_csd.cmdq_depth - 2;	//realtek use slot 0 for pon's usage, so the available slot minus 1
+#else
+	int q_depth = card->ext_csd.cmdq_depth - 1;
+#endif
+	card->cmdq_init = false;
+	if (!(card->host->caps2 & MMC_CAP2_CMD_QUEUE)) {
+		ret = -ENOTSUPP;
+		goto out;
+	}
+
+	mq->mqrq_cmdq = kzalloc(
+			sizeof(struct mmc_queue_req) * q_depth, GFP_KERNEL);
+	if (!mq->mqrq_cmdq) {
+		ret = -ENOMEM;
+		goto out;
+	}
+
+	/* sg is allocated for data request slots only */
+	for (i = 0; i < q_depth; i++) {
+		mq->mqrq_cmdq[i].sg = mmc_alloc_sg(card->host->max_segs, &ret);
+		if (ret) {
+			pr_warn("%s: unable to allocate cmdq sg of size %d\n",
+				mmc_card_name(card),
+				card->host->max_segs);
+			goto free_mqrq_sg;
+		}
+	}
+
+	ret = blk_queue_init_tags(mq->queue, q_depth, NULL, BLK_TAG_ALLOC_FIFO);
+	if (ret) {
+		pr_warn("%s: unable to allocate cmdq tags %d\n",
+				mmc_card_name(card), q_depth);
+		goto free_mqrq_sg;
+	}
+
+	blk_queue_softirq_done(mq->queue, mmc_cmdq_softirq_done);
+	card->cmdq_init = true;
+
+	goto out;
+
+free_mqrq_sg:
+	for (i = 0; i < q_depth; i++)
+		kfree(mq->mqrq_cmdq[i].sg);
+	kfree(mq->mqrq_cmdq);
+	mq->mqrq_cmdq = NULL;
+out:
+	return ret;
+}
+#endif
 /**
  * mmc_init_queue - initialise a queue structure.
  * @mq: mmc queue
@@ -188,8 +360,13 @@ static void mmc_queue_setup_discard(struct request_queue *q,
  *
  * Initialise a MMC card request queue.
  */
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+int mmc_init_queue(struct mmc_queue *mq, struct mmc_card *card,
+		   spinlock_t *lock, const char *subname, int area_type)
+#else
 int mmc_init_queue(struct mmc_queue *mq, struct mmc_card *card,
 		   spinlock_t *lock, const char *subname)
+#endif
 {
 	struct mmc_host *host = card->host;
 	u64 limit = BLK_BOUNCE_HIGH;
@@ -201,6 +378,30 @@ int mmc_init_queue(struct mmc_queue *mq, struct mmc_card *card,
 		limit = (u64)dma_max_pfn(mmc_dev(host)) << PAGE_SHIFT;
 
 	mq->card = card;
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+
+	if (card->ext_csd.cmdq_support &&
+	    (area_type == MMC_BLK_DATA_AREA_MAIN)) {
+		mq->queue = blk_init_queue(mmc_cmdq_dispatch_req, lock);
+		if (!mq->queue)
+			return -ENOMEM;
+		mmc_cmdq_setup_queue(mq, card);
+		ret = mmc_cmdq_init(mq, card);
+		if (ret) {
+			pr_err("%s: %d: cmdq: unable to set-up\n",
+			       mmc_hostname(card->host), ret);
+			blk_cleanup_queue(mq->queue);
+		} else {
+			mq->queue->queuedata = mq;
+			mq->thread = kthread_run(mmc_cmdq_thread, mq,
+						 "mmc-cmdqd/%d%s",
+						 host->index,
+						 subname ? subname : "");
+			return ret;
+		}
+	}
+#endif
+
 	mq->queue = blk_init_queue(mmc_request_fn, lock);
 	if (!mq->queue)
 		return -ENOMEM;
@@ -405,6 +606,23 @@ void mmc_packed_clean(struct mmc_queue *mq)
 	mqrq_prev->packed = NULL;
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+void mmc_cmdq_clean(struct mmc_queue *mq, struct mmc_card *card)
+{
+	int i;
+	int q_depth = card->ext_csd.cmdq_depth - 1;
+	blk_free_tags(mq->queue->queue_tags);
+	mq->queue->queue_tags = NULL;
+	blk_queue_free_tags(mq->queue);
+
+	for (i = 0; i < q_depth; i++)
+		kfree(mq->mqrq_cmdq[i].sg);
+	kfree(mq->mqrq_cmdq);
+	mq->mqrq_cmdq = NULL;
+}
+#endif
+
+
 /**
  * mmc_queue_suspend - suspend a MMC request queue
  * @mq: MMC queue to suspend
@@ -425,7 +643,15 @@ void mmc_queue_suspend(struct mmc_queue *mq)
 		blk_stop_queue(q);
 		spin_unlock_irqrestore(q->queue_lock, flags);
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+		if (mq->card->cmdq_init && blk_queue_tagged(q)) {
+		//	kthread_stop(mq->thread);
+		}
+		else
+			down(&mq->thread_sem);
+#else
 		down(&mq->thread_sem);
+#endif
 	}
 }
 
@@ -440,8 +666,12 @@ void mmc_queue_resume(struct mmc_queue *mq)
 
 	if (mq->flags & MMC_QUEUE_SUSPENDED) {
 		mq->flags &= ~MMC_QUEUE_SUSPENDED;
-
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+		if (!(mq->card->cmdq_init && blk_queue_tagged(q)))
+			up(&mq->thread_sem);
+#else
 		up(&mq->thread_sem);
+#endif
 
 		spin_lock_irqsave(q->queue_lock, flags);
 		blk_start_queue(q);
diff --git a/drivers/mmc/card/queue.h b/drivers/mmc/card/queue.h
index 342f1e3..8a333e6 100644
--- a/drivers/mmc/card/queue.h
+++ b/drivers/mmc/card/queue.h
@@ -48,6 +48,9 @@ struct mmc_queue_req {
 	struct mmc_async_req	mmc_active;
 	enum mmc_packed_type	cmd_type;
 	struct mmc_packed	*packed;
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	struct mmc_cmdq_req	cmdq_req;
+#endif
 };
 
 struct mmc_queue {
@@ -57,15 +60,39 @@ struct mmc_queue {
 	unsigned int		flags;
 #define MMC_QUEUE_SUSPENDED	(1 << 0)
 #define MMC_QUEUE_NEW_REQUEST	(1 << 1)
+
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	int (*cmdq_issue_fn)(struct mmc_queue *, struct request *);
+	void (*cmdq_complete_fn)(struct request *);
+#endif
+
 	void			*data;
 	struct request_queue	*queue;
 	struct mmc_queue_req	mqrq[2];
 	struct mmc_queue_req	*mqrq_cur;
 	struct mmc_queue_req	*mqrq_prev;
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	struct mmc_queue_req	*mqrq_cmdq;
+#endif
+
+#ifdef CONFIG_MMC_SIMULATE_MAX_SPEED
+	atomic_t max_write_speed;
+	atomic_t max_read_speed;
+	atomic_t cache_size;
+	/* i/o tracking */
+	atomic_long_t cache_used;
+	unsigned long cache_jiffies;
+#endif
 };
 
+
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+extern int mmc_init_queue(struct mmc_queue *, struct mmc_card *, spinlock_t *,
+			  const char *, int);
+#else
 extern int mmc_init_queue(struct mmc_queue *, struct mmc_card *, spinlock_t *,
 			  const char *);
+#endif
 extern void mmc_cleanup_queue(struct mmc_queue *);
 extern void mmc_queue_suspend(struct mmc_queue *);
 extern void mmc_queue_resume(struct mmc_queue *);
@@ -80,4 +107,8 @@ extern unsigned int mmc_queue_map_sg(struct mmc_queue *,
 
 extern int mmc_access_rpmb(struct mmc_queue *);
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+extern void mmc_cmdq_clean(struct mmc_queue *mq, struct mmc_card *card);
+#endif
+
 #endif
diff --git a/drivers/mmc/core/Kconfig b/drivers/mmc/core/Kconfig
index 250f223..daad32f 100644
--- a/drivers/mmc/core/Kconfig
+++ b/drivers/mmc/core/Kconfig
@@ -22,3 +22,18 @@ config PWRSEQ_SIMPLE
 
 	  This driver can also be built as a module. If so, the module
 	  will be called pwrseq_simple.
+
+config MMC_EMBEDDED_SDIO
+	boolean "MMC embedded SDIO device support (EXPERIMENTAL)"
+	help
+	  If you say Y here, support will be added for embedded SDIO
+	  devices which do not contain the necessary enumeration
+	  support in hardware to be properly detected.
+
+config MMC_PARANOID_SD_INIT
+	bool "Enable paranoid SD card initialization (EXPERIMENTAL)"
+	help
+	  If you say Y here, the MMC layer will be extra paranoid
+	  about re-trying SD init requests. This can be a useful
+	  work-around for buggy controllers and hardware. Enable
+	  if you are experiencing issues with SD detection.
diff --git a/drivers/mmc/core/core.c b/drivers/mmc/core/core.c
index cff58297..4494419 100644
--- a/drivers/mmc/core/core.c
+++ b/drivers/mmc/core/core.c
@@ -29,7 +29,6 @@
 #include <linux/random.h>
 #include <linux/slab.h>
 #include <linux/of.h>
-
 #include <linux/mmc/card.h>
 #include <linux/mmc/host.h>
 #include <linux/mmc/mmc.h>
@@ -49,6 +48,10 @@
 #include "sd_ops.h"
 #include "sdio_ops.h"
 
+#ifdef CONFIG_MMC_SDHCI_RTK
+#include "../host/sdhci.h"
+#endif /* CONFIG_RTK_PLATFORM */
+
 /* If the device is not responding */
 #define MMC_CORE_TIMEOUT_MS	(10 * 60 * 1000) /* 10 minute timeout */
 
@@ -70,7 +73,23 @@
  */
 bool use_spi_crc = 1;
 module_param(use_spi_crc, bool, 0);
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_MMC_SDHCI_RTK
+bool SDIO_flag = false;
+bool SDIO_fini = false;
+extern bool SDIO_card;
+#endif /* CONFIG_RTK_PLATFORM */
+#endif
+#if (!defined(CONFIG_ARCH_RTD119X)) && (!defined(CONFIG_ARCH_RTD129x))
+#ifdef CONFIG_MMC_RTK_SDMMC
+void rtk_sdmmc_close_clk(struct mmc_host *host);
+int rtk_sdmmc_clk_cls_chk(struct mmc_host *host);
+#endif
+#endif
 
+/*
+ * Internal function. Schedule delayed work in the MMC work queue.
+ */
 static int mmc_schedule_delayed_work(struct delayed_work *work,
 				     unsigned long delay)
 {
@@ -201,6 +220,20 @@ void mmc_request_done(struct mmc_host *host, struct mmc_request *mrq)
 			pr_debug("%s:     %d bytes transferred: %d\n",
 				mmc_hostname(host),
 				mrq->data->bytes_xfered, mrq->data->error);
+#ifdef CONFIG_BLOCK
+			if (mrq->lat_hist_enabled) {
+				ktime_t completion;
+				u_int64_t delta_us;
+
+				completion = ktime_get();
+				delta_us = ktime_us_delta(completion,
+							  mrq->io_start);
+				blk_update_latency_hist(
+					(mrq->data->flags & MMC_DATA_READ) ?
+					&host->io_lat_read :
+					&host->io_lat_write, delta_us);
+			}
+#endif
 		}
 
 		if (mrq->stop) {
@@ -333,6 +366,39 @@ static int mmc_start_request(struct mmc_host *host, struct mmc_request *mrq)
 	return 0;
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+
+static void mmc_start_cmdq_request(struct mmc_host *host,
+				   struct mmc_request *mrq)
+{
+	if (mrq->data) {
+		pr_debug("%s:     blksz %d blocks %d flags %08x tsac %lu ms nsac %d\n",
+			mmc_hostname(host), mrq->data->blksz,
+			mrq->data->blocks, mrq->data->flags,
+			mrq->data->timeout_ns / NSEC_PER_MSEC,
+			mrq->data->timeout_clks);
+
+		BUG_ON(mrq->data->blksz > host->max_blk_size);
+		BUG_ON(mrq->data->blocks > host->max_blk_count);
+		BUG_ON(mrq->data->blocks * mrq->data->blksz >
+			host->max_req_size);
+		mrq->data->error = 0;
+		mrq->data->mrq = mrq;
+	}
+
+	if (mrq->cmd) {
+		mrq->cmd->error = 0;
+		mrq->cmd->mrq = mrq;
+	}
+
+	if (likely(host->cmdq_ops->request))
+		host->cmdq_ops->request(host, mrq);
+	else
+		pr_err("%s: %s: issue request failed\n", mmc_hostname(host),
+				__func__);
+}
+#endif
+
 /**
  *	mmc_start_bkops - start BKOPS for supported cards
  *	@card: MMC card to start BKOPS
@@ -641,6 +707,321 @@ static void mmc_post_req(struct mmc_host *host, struct mmc_request *mrq,
 		host->ops->post_req(host, mrq, err);
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+static unsigned int mmc_erase_timeout(struct mmc_card *card,
+                                      unsigned int arg,
+                                      unsigned int qty);
+static unsigned int mmc_align_erase_size(struct mmc_card *card,
+                                         unsigned int *from,
+                                         unsigned int *to,
+                                         unsigned int nr);
+/**
+ *	mmc_cmdq_post_req - post process of a completed request
+ *	@host: host instance
+ *	@mrq: the request to be processed
+ *	@err: non-zero is error, success otherwise
+ */
+void mmc_cmdq_post_req(struct mmc_host *host, int tag, int err)
+{
+	if (likely(host->cmdq_ops->post_req))
+		host->cmdq_ops->post_req(host, tag, err);
+}
+EXPORT_SYMBOL(mmc_cmdq_post_req);
+
+/**
+ *	mmc_cmdq_halt - halt/un-halt the command queue engine
+ *	@host: host instance
+ *	@halt: true - halt, un-halt otherwise
+ *
+ *	Host halts the command queue engine. It should complete
+ *	the ongoing transfer and release the bus.
+ *	All legacy commands can be sent upon successful
+ *	completion of this function.
+ *	Returns 0 on success, negative otherwise
+ */
+int mmc_cmdq_halt(struct mmc_host *host, bool halt)
+{
+	int err = 0;
+
+	if ((halt && mmc_host_halt(host)) ||
+	    (!halt && !mmc_host_halt(host)))
+		return -EINVAL;
+
+	if (host->cmdq_ops->halt) {
+		err = host->cmdq_ops->halt(host, halt);
+		if (!err && halt)
+			mmc_host_set_halt(host);
+		else if (!err && !halt)
+			mmc_host_clr_halt(host);
+	} else {
+		err = -ENOSYS;
+	}
+
+	return err;
+}
+EXPORT_SYMBOL(mmc_cmdq_halt);
+
+int mmc_cmdq_start_req(struct mmc_host *host, struct mmc_cmdq_req *cmdq_req)
+{
+	struct mmc_request *mrq = &cmdq_req->mrq;
+
+	mrq->host = host;
+	if (mmc_card_removed(host->card)) {
+		mrq->cmd->error = -ENOMEDIUM;
+		return -ENOMEDIUM;
+	}
+	mmc_start_cmdq_request(host, mrq);
+	return 0;
+}
+EXPORT_SYMBOL(mmc_cmdq_start_req);
+
+static void mmc_cmdq_dcmd_req_done(struct mmc_request *mrq)
+{
+	complete(&mrq->completion);
+}
+
+int mmc_cmdq_wait_for_dcmd(struct mmc_host *host,
+			struct mmc_cmdq_req *cmdq_req)
+{
+	struct mmc_request *mrq = &cmdq_req->mrq;
+	struct mmc_command *cmd = mrq->cmd;
+	int err = 0;
+	init_completion(&mrq->completion);
+	mrq->done = mmc_cmdq_dcmd_req_done;
+	err = mmc_cmdq_start_req(host, cmdq_req);
+	if (err)
+		return err;
+	wait_for_completion(&mrq->completion);
+
+	if(host->cmdq_ops->getrsp)
+		host->cmdq_ops->getrsp(host, mrq);
+
+	if (cmd->error) {
+		pr_err("%s: DCMD %d failed with err %d\n",
+				mmc_hostname(host), cmd->opcode,
+				cmd->error);
+		err = cmd->error;
+		//host->cmdq_ops->dumpstate(host);
+	}
+	return err;
+}
+EXPORT_SYMBOL(mmc_cmdq_wait_for_dcmd);
+
+int mmc_cmdq_prepare_flush(struct mmc_command *cmd)
+{
+	return   __mmc_switch_cmdq_mode(cmd, EXT_CSD_CMD_SET_NORMAL,
+				     EXT_CSD_FLUSH_CACHE, 1,
+				     0, true, true);
+}
+EXPORT_SYMBOL(mmc_cmdq_prepare_flush);
+
+static int mmc_cmdq_do_erase(struct mmc_cmdq_req *cmdq_req, struct mmc_card *card, unsigned int from,
+                        unsigned int to, unsigned int arg)
+{
+        struct mmc_command *cmd = cmdq_req->mrq.cmd;
+        unsigned int qty = 0, busy_timeout = 0;
+        bool use_r1b_resp = false;
+        unsigned long timeout;
+        int err;
+
+        mmc_retune_hold(card->host);
+
+        /*
+         * qty is used to calculate the erase timeout which depends on how many
+         * erase groups (or allocation units in SD terminology) are affected.
+         * We count erasing part of an erase group as one erase group.
+         * For SD, the allocation units are always a power of 2.  For MMC, the
+         * erase group size is almost certainly also power of 2, but it does not
+         * seem to insist on that in the JEDEC standard, so we fall back to
+         * division in that case.  SD may not specify an allocation unit size,
+         * in which case the timeout is based on the number of write blocks.
+         *
+         * Note that the timeout for secure trim 2 will only be correct if the
+         * number of erase groups specified is the same as the total of all
+         * preceding secure trim 1 commands.  Since the power may have been
+         * lost since the secure trim 1 commands occurred, it is generally
+         * impossible to calculate the secure trim 2 timeout correctly.
+         */
+
+	if (card->erase_shift)
+                qty += ((to >> card->erase_shift) -
+                        (from >> card->erase_shift)) + 1;
+        else if (mmc_card_sd(card))
+                qty += to - from + 1;
+        else
+                qty += ((to / card->erase_size) -
+                        (from / card->erase_size)) + 1;
+
+        if (!mmc_card_blockaddr(card)) {
+                from <<= 9;
+                to <<= 9;
+        }
+
+	if (mmc_card_sd(card))
+		cmd->opcode = SD_ERASE_WR_BLK_START;
+	else
+		cmd->opcode = MMC_ERASE_GROUP_START;
+
+        cmd->arg = from;
+        cmd->flags = MMC_RSP_SPI_R1 | MMC_RSP_R1 | MMC_CMD_AC;
+        err = mmc_cmdq_wait_for_dcmd(card->host, cmdq_req);
+        if (err) {
+                pr_err("mmc_erase: group start error %d, "
+                       "status %#x\n", err, cmd->resp[0]);
+                err = -EIO;
+                goto out;
+        }
+
+        memset(cmd, 0, sizeof(struct mmc_command));
+
+	if (mmc_card_sd(card))
+		cmd->opcode = SD_ERASE_WR_BLK_END;
+	else
+		cmd->opcode = MMC_ERASE_GROUP_END;
+
+        cmd->arg = to;
+        cmd->flags = MMC_RSP_SPI_R1 | MMC_RSP_R1 | MMC_CMD_AC;
+        err = mmc_cmdq_wait_for_dcmd(card->host, cmdq_req);
+        if (err) {
+                pr_err("mmc_erase: group end error %d, status %#x\n",
+                       err, cmd->resp[0]);
+                err = -EIO;
+                goto out;
+        }
+
+        memset(cmd, 0, sizeof(struct mmc_command));
+        cmd->opcode = MMC_ERASE;
+        cmd->arg = arg;
+        busy_timeout = mmc_erase_timeout(card, arg, qty);
+
+	/*
+         * If the host controller supports busy signalling and the timeout for
+         * the erase operation does not exceed the max_busy_timeout, we should
+         * use R1B response. Or we need to prevent the host from doing hw busy
+         * detection, which is done by converting to a R1 response instead.
+         */
+
+        if (card->host->max_busy_timeout &&
+            busy_timeout > card->host->max_busy_timeout) {
+                cmd->flags = MMC_RSP_SPI_R1 | MMC_RSP_R1 | MMC_CMD_AC;
+        } else {
+                cmd->flags = MMC_RSP_SPI_R1B | MMC_RSP_R1B | MMC_CMD_AC;
+                cmd->busy_timeout = busy_timeout;
+                use_r1b_resp = true;
+        }
+
+        err = mmc_cmdq_wait_for_dcmd(card->host, cmdq_req);
+        if (err) {
+                pr_err("mmc_erase: erase error %d, status %#x\n",
+                       err, cmd->resp[0]);
+                err = -EIO;
+                goto out;
+        }
+
+        if (mmc_host_is_spi(card->host))
+                goto out;
+	        /*
+         * In case of when R1B + MMC_CAP_WAIT_WHILE_BUSY is used, the polling
+         * shall be avoided.
+         */
+        if ((card->host->caps & MMC_CAP_WAIT_WHILE_BUSY) && use_r1b_resp)
+                goto out;
+
+        timeout = jiffies + msecs_to_jiffies(busy_timeout);
+        do {
+                memset(cmd, 0, sizeof(struct mmc_command));
+                cmd->opcode = MMC_SEND_STATUS;
+                cmd->arg = card->rca << 16;
+                cmd->flags = MMC_RSP_R1 | MMC_CMD_AC;
+                /* Do not retry else we can't see errors */
+                err = mmc_cmdq_wait_for_dcmd(card->host, cmdq_req);
+                if (err || (cmd->resp[0] & 0xFDF92000)) {
+                        pr_err("error %d requesting status %#x\n",
+                                err, cmd->resp[0]);
+                        err = -EIO;
+                        goto out;
+                }
+                /* Timeout if the device never becomes ready for data and
+                 * never leaves the program state.
+                 */
+                if (time_after(jiffies, timeout)) {
+                        pr_err("%s: Card stuck in programming state! %s\n",
+                                mmc_hostname(card->host), __func__);
+                        err =  -EIO;
+                        goto out;
+                }
+
+        } while (!(cmd->resp[0] & R1_READY_FOR_DATA) ||
+                 (R1_CURRENT_STATE(cmd->resp[0]) == R1_STATE_PRG));
+out:
+        mmc_retune_release(card->host);
+        return err;
+}
+
+int mmc_cmdq_erase(struct mmc_cmdq_req *cmdq_req, struct mmc_card *card, unsigned int from, unsigned int nr,
+              unsigned int arg)
+{
+        unsigned int rem, to = from + nr;
+        int err;
+
+        if (!(card->host->caps & MMC_CAP_ERASE) ||
+            !(card->csd.cmdclass & CCC_ERASE))
+                return -EOPNOTSUPP;
+
+        if (!card->erase_size)
+                return -EOPNOTSUPP;
+
+        if (mmc_card_sd(card) && arg != MMC_ERASE_ARG)
+                return -EOPNOTSUPP;
+
+        if ((arg & MMC_SECURE_ARGS) &&
+            !(card->ext_csd.sec_feature_support & EXT_CSD_SEC_ER_EN))
+                return -EOPNOTSUPP;
+
+        if ((arg & MMC_TRIM_ARGS) &&
+            !(card->ext_csd.sec_feature_support & EXT_CSD_SEC_GB_CL_EN))
+                return -EOPNOTSUPP;
+
+        if (arg == MMC_SECURE_ERASE_ARG) {
+                if (from % card->erase_size || nr % card->erase_size)
+                        return -EINVAL;
+        }
+
+        if (arg == MMC_ERASE_ARG)
+                nr = mmc_align_erase_size(card, &from, &to, nr);
+
+        if (nr == 0)
+                return 0;
+
+        if (to <= from)
+                return -EINVAL;
+
+        /* 'from' and 'to' are inclusive */
+        to -= 1;
+
+        /*
+         * Special case where only one erase-group fits in the timeout budget:
+         * If the region crosses an erase-group boundary on this particular
+         * case, we will be trimming more than one erase-group which, does not
+         * fit in the timeout budget of the controller, so we need to split it
+         * and call mmc_do_erase() twice if necessary. This special case is
+         * identified by the card->eg_boundary flag.
+         */
+	rem = card->erase_size - (from % card->erase_size);
+        if ((arg & MMC_TRIM_ARGS) && (card->eg_boundary) && (nr > rem)) {
+                err = mmc_cmdq_do_erase(cmdq_req, card, from, from + rem - 1, arg);
+                from += rem;
+                if ((err) || (to <= from))
+                        return err;
+        }
+
+        return mmc_cmdq_do_erase(cmdq_req, card, from, to, arg);
+}
+EXPORT_SYMBOL(mmc_cmdq_erase);
+
+#endif
+
+
 /**
  *	mmc_start_req - start a non-blocking request
  *	@host: MMC host to start command
@@ -699,8 +1080,16 @@ struct mmc_async_req *mmc_start_req(struct mmc_host *host,
 		}
 	}
 
-	if (!err && areq)
+	if (!err && areq) {
+#ifdef CONFIG_BLOCK
+		if (host->latency_hist_enabled) {
+			areq->mrq->io_start = ktime_get();
+			areq->mrq->lat_hist_enabled = 1;
+		} else
+			areq->mrq->lat_hist_enabled = 0;
+#endif
 		start_err = __mmc_start_data_req(host, areq->mrq);
+	}
 
 	if (host->areq)
 		mmc_post_req(host, host->areq->mrq, 0);
@@ -1169,6 +1558,10 @@ int mmc_execute_tuning(struct mmc_card *card)
 	else
 		opcode = MMC_SEND_TUNING_BLOCK;
 
+#ifdef CONFIG_MMC_RTK_EMMC
+	host->card = card;
+#endif
+
 	err = host->ops->execute_tuning(host, opcode);
 
 	if (err)
@@ -2051,7 +2444,7 @@ void mmc_init_erase(struct mmc_card *card)
 }
 
 static unsigned int mmc_mmc_erase_timeout(struct mmc_card *card,
-				          unsigned int arg, unsigned int qty)
+					  unsigned int arg, unsigned int qty)
 {
 	unsigned int erase_timeout;
 
@@ -2634,6 +3027,11 @@ int mmc_hw_reset(struct mmc_host *host)
 
 static int mmc_rescan_try_freq(struct mmc_host *host, unsigned freq)
 {
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_MMC_SDHCI_RTK
+	int ret=0;
+#endif /* CONFIG_RTK_PLATFORM */
+#endif
 	host->f_init = freq;
 
 #ifdef CONFIG_MMC_DEBUG
@@ -2663,9 +3061,26 @@ static int mmc_rescan_try_freq(struct mmc_host *host, unsigned freq)
 		mmc_send_if_cond(host, host->ocr_avail);
 
 	/* Order's important: probe SDIO, then SD, then MMC */
+#ifdef CONFIG_MMC_SDHCI_RTK
+#ifndef CONFIG_ARCH_RTD119X
+	if (!(host->caps2 & MMC_CAP2_NO_SDIO)) {
+		if (!(ret = mmc_attach_sdio(host))) {
+			SDIO_flag = true;
+			return 0;
+		}
+		if(ret == -110)
+			SDIO_fini = true;
+	}
+#else
 	if (!(host->caps2 & MMC_CAP2_NO_SDIO))
 		if (!mmc_attach_sdio(host))
 			return 0;
+#endif
+#else
+	if (!(host->caps2 & MMC_CAP2_NO_SDIO))
+		if (!mmc_attach_sdio(host))
+			return 0;
+#endif /* CONFIG_RTK_PLATFORM */
 
 	if (!(host->caps2 & MMC_CAP2_NO_SD))
 		if (!mmc_attach_sd(host))
@@ -2751,6 +3166,10 @@ void mmc_rescan(struct work_struct *work)
 	struct mmc_host *host =
 		container_of(work, struct mmc_host, detect.work);
 	int i;
+	if (host->trigger_card_event && host->ops->card_event) {
+		host->ops->card_event(host);
+		host->trigger_card_event = false;
+	}
 
 	if (host->rescan_disable)
 		return;
@@ -2773,8 +3192,15 @@ void mmc_rescan(struct work_struct *work)
 	 * if there is a _removable_ card registered, check whether it is
 	 * still present
 	 */
-	if (host->bus_ops && !host->bus_dead && mmc_card_is_removable(host))
+	if (host->bus_ops && !host->bus_dead && mmc_card_is_removable(host)) {
 		host->bus_ops->detect(host);
+#if (!defined(CONFIG_ARCH_RTD119X)) && (!defined(CONFIG_ARCH_RTD129x))
+#ifdef CONFIG_MMC_RTK_SDMMC
+		//We close the SD clock for power saving if no SD card
+		if(!(host->caps2 & MMC_CAP2_NO_SD)) rtk_sdmmc_close_clk(host);
+#endif
+#endif
+	}
 
 	host->detect_change = 0;
 
@@ -2816,6 +3242,21 @@ void mmc_rescan(struct work_struct *work)
  out:
 	if (host->caps & MMC_CAP_NEEDS_POLL)
 		mmc_schedule_delayed_work(&host->detect, HZ);
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_MMC_SDHCI_RTK
+	if(SDIO_fini==true && SDIO_flag == false && SDIO_card==false) {
+		SDIO_fini= false;
+		host->caps2 |=  MMC_CAP2_NO_SDIO;
+		rtk_sdhci_close_clk();
+	}
+#endif
+#endif
+#if (!defined(CONFIG_ARCH_RTD119X)) && (!defined(CONFIG_ARCH_RTD129x))
+#ifdef CONFIG_MMC_RTK_SDMMC
+	//We close the SD clock for power saving if no SD card
+	if(!(host->caps2 & MMC_CAP2_NO_SD) && rtk_sdmmc_clk_cls_chk(host)) rtk_sdmmc_close_clk(host);
+#endif
+#endif
 }
 
 void mmc_start_host(struct mmc_host *host)
@@ -3034,6 +3475,22 @@ void mmc_init_context_info(struct mmc_host *host)
 	init_waitqueue_head(&host->context_info.wait);
 }
 
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+void mmc_set_embedded_sdio_data(struct mmc_host *host,
+				struct sdio_cis *cis,
+				struct sdio_cccr *cccr,
+				struct sdio_embedded_func *funcs,
+				int num_funcs)
+{
+	host->embedded_sdio_data.cis = cis;
+	host->embedded_sdio_data.cccr = cccr;
+	host->embedded_sdio_data.funcs = funcs;
+	host->embedded_sdio_data.num_funcs = num_funcs;
+}
+
+EXPORT_SYMBOL(mmc_set_embedded_sdio_data);
+#endif
+
 static int __init mmc_init(void)
 {
 	int ret;
@@ -3066,6 +3523,63 @@ static void __exit mmc_exit(void)
 	mmc_unregister_bus();
 }
 
+#ifdef CONFIG_BLOCK
+static ssize_t
+latency_hist_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct mmc_host *host = cls_dev_to_mmc_host(dev);
+	size_t written_bytes;
+
+	written_bytes = blk_latency_hist_show("Read", &host->io_lat_read,
+			buf, PAGE_SIZE);
+	written_bytes += blk_latency_hist_show("Write", &host->io_lat_write,
+			buf + written_bytes, PAGE_SIZE - written_bytes);
+
+	return written_bytes;
+}
+
+/*
+ * Values permitted 0, 1, 2.
+ * 0 -> Disable IO latency histograms (default)
+ * 1 -> Enable IO latency histograms
+ * 2 -> Zero out IO latency histograms
+ */
+static ssize_t
+latency_hist_store(struct device *dev, struct device_attribute *attr,
+		   const char *buf, size_t count)
+{
+	struct mmc_host *host = cls_dev_to_mmc_host(dev);
+	long value;
+
+	if (kstrtol(buf, 0, &value))
+		return -EINVAL;
+	if (value == BLK_IO_LAT_HIST_ZERO) {
+		memset(&host->io_lat_read, 0, sizeof(host->io_lat_read));
+		memset(&host->io_lat_write, 0, sizeof(host->io_lat_write));
+	} else if (value == BLK_IO_LAT_HIST_ENABLE ||
+		 value == BLK_IO_LAT_HIST_DISABLE)
+		host->latency_hist_enabled = value;
+	return count;
+}
+
+static DEVICE_ATTR(latency_hist, S_IRUGO | S_IWUSR,
+		   latency_hist_show, latency_hist_store);
+
+void
+mmc_latency_hist_sysfs_init(struct mmc_host *host)
+{
+	if (device_create_file(&host->class_dev, &dev_attr_latency_hist))
+		dev_err(&host->class_dev,
+			"Failed to create latency_hist sysfs entry\n");
+}
+
+void
+mmc_latency_hist_sysfs_exit(struct mmc_host *host)
+{
+	device_remove_file(&host->class_dev, &dev_attr_latency_hist);
+}
+#endif
+
 subsys_initcall(mmc_init);
 module_exit(mmc_exit);
 
diff --git a/drivers/mmc/core/host.c b/drivers/mmc/core/host.c
index 848b345..07f8891 100644
--- a/drivers/mmc/core/host.c
+++ b/drivers/mmc/core/host.c
@@ -31,8 +31,6 @@
 #include "slot-gpio.h"
 #include "pwrseq.h"
 
-#define cls_dev_to_mmc_host(d)	container_of(d, struct mmc_host, class_dev)
-
 static DEFINE_IDA(mmc_host_ida);
 static DEFINE_SPINLOCK(mmc_host_lock);
 
@@ -428,8 +426,13 @@ int mmc_add_host(struct mmc_host *host)
 	mmc_add_host_debugfs(host);
 #endif
 
+#ifdef CONFIG_BLOCK
+	mmc_latency_hist_sysfs_init(host);
+#endif
+
 	mmc_start_host(host);
-	mmc_register_pm_notifier(host);
+	if (!(host->pm_flags & MMC_PM_IGNORE_PM_NOTIFY))
+		mmc_register_pm_notifier(host);
 
 	return 0;
 }
@@ -446,13 +449,18 @@ int mmc_add_host(struct mmc_host *host)
  */
 void mmc_remove_host(struct mmc_host *host)
 {
-	mmc_unregister_pm_notifier(host);
+	if (!(host->pm_flags & MMC_PM_IGNORE_PM_NOTIFY))
+		mmc_unregister_pm_notifier(host);
 	mmc_stop_host(host);
 
 #ifdef CONFIG_DEBUG_FS
 	mmc_remove_host_debugfs(host);
 #endif
 
+#ifdef CONFIG_BLOCK
+	mmc_latency_hist_sysfs_exit(host);
+#endif
+
 	device_del(&host->class_dev);
 
 	led_trigger_unregister_simple(host->led);
diff --git a/drivers/mmc/core/host.h b/drivers/mmc/core/host.h
index 992bf53..bf38533 100644
--- a/drivers/mmc/core/host.h
+++ b/drivers/mmc/core/host.h
@@ -12,6 +12,8 @@
 #define _MMC_CORE_HOST_H
 #include <linux/mmc/host.h>
 
+#define cls_dev_to_mmc_host(d)	container_of(d, struct mmc_host, class_dev)
+
 int mmc_register_host_class(void);
 void mmc_unregister_host_class(void);
 
@@ -21,5 +23,8 @@
 void mmc_retune_release(struct mmc_host *host);
 int mmc_retune(struct mmc_host *host);
 
+void mmc_latency_hist_sysfs_init(struct mmc_host *host);
+void mmc_latency_hist_sysfs_exit(struct mmc_host *host);
+
 #endif
 
diff --git a/drivers/mmc/core/mmc.c b/drivers/mmc/core/mmc.c
index 0c6de9f..796ca91 100644
--- a/drivers/mmc/core/mmc.c
+++ b/drivers/mmc/core/mmc.c
@@ -26,6 +26,16 @@
 #include "mmc_ops.h"
 #include "sd_ops.h"
 
+#ifdef CONFIG_MMC_RTK_EMMC
+#if defined(CONFIG_ARCH_RTD13xx)
+#include "../host/reg_mmc_rtd13xx.h"
+#elif defined(CONFIG_ARCH_RTD119X)
+#include "../host/reg_mmc_rtd119x.h"
+#else
+#include "../host/reg_mmc.h"
+#endif
+#endif
+
 #define DEFAULT_CMD6_TIMEOUT_MS	500
 
 static const unsigned int tran_exp[] = {
@@ -258,6 +268,14 @@ static void mmc_select_card_type(struct mmc_card *card)
 	card->mmc_avail_type = avail_type;
 }
 
+#ifdef CONFIG_MMC_RTK_EMMC
+void rtkemmc_select_card_type(struct mmc_card *card)
+{
+        mmc_select_card_type(card);
+}
+EXPORT_SYMBOL(rtkemmc_select_card_type);
+#endif
+
 static void mmc_manage_enhanced_area(struct mmc_card *card, u8 *ext_csd)
 {
 	u8 hc_erase_grp_sz, hc_wp_grp_sz;
@@ -577,8 +595,12 @@ static int mmc_decode_ext_csd(struct mmc_card *card, u8 *ext_csd)
 	if (card->ext_csd.rev >= 6) {
 		card->ext_csd.feature_support |= MMC_DISCARD_FEATURE;
 
+#ifdef CONFIG_MMC_RTK_EMMC
+		card->ext_csd.generic_cmd6_time = 3000;
+#else
 		card->ext_csd.generic_cmd6_time = 10 *
 			ext_csd[EXT_CSD_GENERIC_CMD6_TIME];
+#endif
 		card->ext_csd.power_off_longtime = 10 *
 			ext_csd[EXT_CSD_POWER_OFF_LONG_TIME];
 
@@ -617,7 +639,33 @@ static int mmc_decode_ext_csd(struct mmc_card *card, u8 *ext_csd)
 		card->ext_csd.ffu_capable =
 			(ext_csd[EXT_CSD_SUPPORTED_MODE] & 0x1) &&
 			!(ext_csd[EXT_CSD_FW_CONFIG] & 0x1);
+#ifdef CONFIG_MMC_RTK_EMMC
+		card->ext_csd.pre_eol_info = ext_csd[EXT_CSD_PRE_EOL_INFO];
+		card->ext_csd.device_life_time_est_typ_a =
+			ext_csd[EXT_CSD_DEVICE_LIFE_TIME_EST_TYP_A];
+		card->ext_csd.device_life_time_est_typ_b =
+			ext_csd[EXT_CSD_DEVICE_LIFE_TIME_EST_TYP_B];
+#endif
 	}
+
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+
+	if (card->ext_csd.rev >= 8) {
+		card->ext_csd.cmdq_support = ext_csd[EXT_CSD_CMDQ_SUPPORT];
+		if (card->ext_csd.cmdq_support) {
+			/*
+			 * Queue Depth = N + 1,
+			 * see JEDEC JESD84-B51 section 7.4.19
+			 */
+			card->ext_csd.cmdq_depth =
+				ext_csd[EXT_CSD_CMDQ_DEPTH] + 1;
+			printk(KERN_ERR "%s: CMDQ supported: depth: %d\n",
+				mmc_hostname(card->host),
+				card->ext_csd.cmdq_depth);
+		}
+	}
+#endif
 out:
 	return err;
 }
@@ -746,6 +794,11 @@ static int mmc_compare_ext_csds(struct mmc_card *card, unsigned bus_width)
 MMC_DEV_ATTR(name, "%s\n", card->cid.prod_name);
 MMC_DEV_ATTR(oemid, "0x%04x\n", card->cid.oemid);
 MMC_DEV_ATTR(prv, "0x%x\n", card->cid.prv);
+MMC_DEV_ATTR(rev, "0x%x\n", card->ext_csd.rev);
+MMC_DEV_ATTR(pre_eol_info, "%02x\n", card->ext_csd.pre_eol_info);
+MMC_DEV_ATTR(life_time, "0x%02x 0x%02x\n",
+	card->ext_csd.device_life_time_est_typ_a,
+	card->ext_csd.device_life_time_est_typ_b);
 MMC_DEV_ATTR(serial, "0x%08x\n", card->cid.serial);
 MMC_DEV_ATTR(enhanced_area_offset, "%llu\n",
 		card->ext_csd.enhanced_area_offset);
@@ -799,6 +852,9 @@ static ssize_t mmc_dsr_show(struct device *dev,
 	&dev_attr_name.attr,
 	&dev_attr_oemid.attr,
 	&dev_attr_prv.attr,
+	&dev_attr_rev.attr,
+	&dev_attr_pre_eol_info.attr,
+	&dev_attr_life_time.attr,
 	&dev_attr_serial.attr,
 	&dev_attr_enhanced_area_offset.attr,
 	&dev_attr_enhanced_area_size.attr,
@@ -1022,11 +1078,17 @@ static int mmc_switch_status(struct mmc_card *card)
 static int mmc_select_hs(struct mmc_card *card)
 {
 	int err;
-
+#ifdef CONFIG_MMC_RTK_EMMC
+	err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
+				EXT_CSD_HS_TIMING, EXT_CSD_TIMING_HS,
+				card->ext_csd.generic_cmd6_time,
+				true, true, true);
+#else
 	err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
 			   EXT_CSD_HS_TIMING, EXT_CSD_TIMING_HS,
 			   card->ext_csd.generic_cmd6_time,
 			   true, false, true);
+#endif
 	if (!err) {
 		mmc_set_timing(card->host, MMC_TIMING_MMC_HS);
 		err = mmc_switch_status(card);
@@ -1110,6 +1172,33 @@ static int mmc_select_hs_ddr(struct mmc_card *card)
 	return err;
 }
 
+#ifdef CONFIG_MMC_RTK_EMMC
+static int mmc_select_ddr50(struct mmc_card *card)
+{
+	int err = 0;
+	u8 val;
+
+	err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
+				EXT_CSD_HS_TIMING, EXT_CSD_TIMING_HS,
+				card->ext_csd.generic_cmd6_time,
+				true, true, true);
+	if (!err) {
+		mmc_set_timing(card->host, MMC_TIMING_MMC_HS);
+		err = mmc_switch_status(card);
+	}
+
+	if (err)
+		pr_warn("%s: switch to high-speed failed, err:%d\n",
+			mmc_hostname(card->host), err);
+
+	err = mmc_select_bus_width(card);
+	if (err > 0 && mmc_card_hs(card)) {
+		err = mmc_select_hs_ddr(card);
+	}
+	return err;
+}
+#endif
+
 static int mmc_select_hs400(struct mmc_card *card)
 {
 	struct mmc_host *host = card->host;
@@ -1117,13 +1206,33 @@ static int mmc_select_hs400(struct mmc_card *card)
 	int err = 0;
 	u8 val;
 
+#ifdef CONFIG_MMC_RTK_EMMC
+	if(host->doing_retune==1) return 0;
+#endif
 	/*
 	 * HS400 mode requires 8-bit bus width
 	 */
 	if (!(card->mmc_avail_type & EXT_CSD_CARD_TYPE_HS400 &&
 	      host->ios.bus_width == MMC_BUS_WIDTH_8))
 		return 0;
+#ifdef CONFIG_MMC_RTK_EMMC
+	mmc_set_timing(card->host, MMC_TIMING_MMC_HS);
+
+        /* Reduce frequency to HS frequency */
+        max_dtr = card->ext_csd.hs_max_dtr;
+        mmc_set_clock(host, max_dtr);
 
+	val = EXT_CSD_TIMING_HS;
+        err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
+                           EXT_CSD_HS_TIMING, val,
+                           card->ext_csd.generic_cmd6_time,
+                           true, true, true);
+        if (err) {
+                pr_err("%s: switch to high-speed from hs200 failed, err:%d\n",
+                        mmc_hostname(host), err);
+                return err;
+        }
+#else
 	/* Switch card to HS mode */
 	val = EXT_CSD_TIMING_HS;
 	err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
@@ -1146,7 +1255,7 @@ static int mmc_select_hs400(struct mmc_card *card)
 	err = mmc_switch_status(card);
 	if (err)
 		goto out_err;
-
+#endif
 	/* Switch card to DDR */
 	err = mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
 			 EXT_CSD_BUS_WIDTH,
@@ -1158,7 +1267,28 @@ static int mmc_select_hs400(struct mmc_card *card)
 		return err;
 	}
 
+#ifdef CONFIG_MMC_RTK_EMMC
+	if(card->ext_csd.raw_driver_strength & 0x2)
+		card->drive_strength = 0x1;	//in realtek chip, some emmc need to strengthen the device ability
+	printk(KERN_ERR "mmc_select_hs400: card->ext_csd.raw_driver_strength=%x\n",card->ext_csd.raw_driver_strength);
+	val = EXT_CSD_TIMING_HS400 |
+              card->drive_strength << EXT_CSD_DRV_STR_SHIFT;
+        err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
+                           EXT_CSD_HS_TIMING, val,
+                           card->ext_csd.generic_cmd6_time,
+                           true, true, true);
+        if (err) {
+                pr_err("%s: switch to hs400 failed, err:%d\n",
+                         mmc_hostname(host), err);
+                return err;
+        }
+
+        /* Set host controller to HS400 timing and frequency */
+        mmc_set_timing(host, MMC_TIMING_MMC_HS400);
+        mmc_set_bus_speed(card);
+#else
 	/* Switch card to HS400 */
+
 	val = EXT_CSD_TIMING_HS400 |
 	      card->drive_strength << EXT_CSD_DRV_STR_SHIFT;
 	err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
@@ -1170,7 +1300,6 @@ static int mmc_select_hs400(struct mmc_card *card)
 			 mmc_hostname(host), err);
 		return err;
 	}
-
 	/* Set host controller to HS400 timing and frequency */
 	mmc_set_timing(host, MMC_TIMING_MMC_HS400);
 	mmc_set_bus_speed(card);
@@ -1178,7 +1307,12 @@ static int mmc_select_hs400(struct mmc_card *card)
 	err = mmc_switch_status(card);
 	if (err)
 		goto out_err;
+#endif
 
+#ifdef CONFIG_MMC_RTK_EMMC
+	if(host->ops->dqs_tuning)
+		host->ops->dqs_tuning(host);
+#endif
 	return 0;
 
 out_err:
@@ -1191,7 +1325,6 @@ int mmc_hs200_to_hs400(struct mmc_card *card)
 {
 	return mmc_select_hs400(card);
 }
-
 int mmc_hs400_to_hs200(struct mmc_card *card)
 {
 	struct mmc_host *host = card->host;
@@ -1199,10 +1332,40 @@ int mmc_hs400_to_hs200(struct mmc_card *card)
 	int err;
 	u8 val;
 
+#ifdef CONFIG_MMC_RTK_EMMC
+	if(host->doing_retune==1) return 0;
+#endif
 	/* Reduce frequency to HS */
 	max_dtr = card->ext_csd.hs_max_dtr;
 	mmc_set_clock(host, max_dtr);
 
+#ifdef CONFIG_MMC_RTK_EMMC
+	mmc_set_timing(host, MMC_TIMING_MMC_DDR52);
+	val = EXT_CSD_TIMING_HS;
+        err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL, EXT_CSD_HS_TIMING,
+                           val, card->ext_csd.generic_cmd6_time,
+                           true, true, true);
+        if (err)
+                goto out_err;
+
+	mmc_set_timing(host, MMC_TIMING_MMC_HS);
+
+	/* Switch HS400 to HS */
+        err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL, EXT_CSD_BUS_WIDTH,
+                           EXT_CSD_BUS_WIDTH_8, card->ext_csd.generic_cmd6_time,
+                           true, true, true);
+        if (err)
+                goto out_err;
+
+	mmc_set_timing(host, MMC_TIMING_MMC_HS200);
+	val = EXT_CSD_TIMING_HS200 |
+              card->drive_strength << EXT_CSD_DRV_STR_SHIFT;
+        err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL, EXT_CSD_HS_TIMING,
+                           val, card->ext_csd.generic_cmd6_time,
+                           true, true, true);
+        if (err)
+                goto out_err;
+#else
 	/* Switch HS400 to HS DDR */
 	val = EXT_CSD_TIMING_HS;
 	err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL, EXT_CSD_HS_TIMING,
@@ -1244,7 +1407,7 @@ int mmc_hs400_to_hs200(struct mmc_card *card)
 	err = mmc_switch_status(card);
 	if (err)
 		goto out_err;
-
+#endif
 	mmc_set_bus_speed(card);
 
 	return 0;
@@ -1254,6 +1417,7 @@ int mmc_hs400_to_hs200(struct mmc_card *card)
 	       __func__, err);
 	return err;
 }
+EXPORT_SYMBOL(mmc_hs400_to_hs200);
 
 static void mmc_select_driver_type(struct mmc_card *card)
 {
@@ -1390,15 +1554,25 @@ static int mmc_select_hs200(struct mmc_card *card)
 	if (err > 0) {
 		val = EXT_CSD_TIMING_HS200 |
 		      card->drive_strength << EXT_CSD_DRV_STR_SHIFT;
+#ifdef CONFIG_MMC_RTK_EMMC
 		err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
 				   EXT_CSD_HS_TIMING, val,
 				   card->ext_csd.generic_cmd6_time,
-				   true, false, true);
+				   true, true, true);
+#else
+		err = __mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
+                                   EXT_CSD_HS_TIMING, val,
+                                   card->ext_csd.generic_cmd6_time,
+                                   true, false, true);
+#endif
 		if (err)
 			goto err;
 		old_timing = host->ios.timing;
 		mmc_set_timing(host, MMC_TIMING_MMC_HS200);
 
+#ifdef CONFIG_MMC_RTK_EMMC
+		return err;
+#else
 		err = mmc_switch_status(card);
 		/*
 		 * mmc_select_timing() assumes timing has not changed if
@@ -1406,6 +1580,7 @@ static int mmc_select_hs200(struct mmc_card *card)
 		 */
 		if (err == -EBADMSG)
 			mmc_set_timing(host, old_timing);
+#endif
 	}
 err:
 	if (err) {
@@ -1429,10 +1604,16 @@ static int mmc_select_timing(struct mmc_card *card)
 	if (!mmc_can_ext_csd(card))
 		goto bus_speed;
 
+	printk(KERN_ERR "card->mmc_avail_type = 0x%08x \n", card->mmc_avail_type);
+
 	if (card->mmc_avail_type & EXT_CSD_CARD_TYPE_HS400ES)
 		err = mmc_select_hs400es(card);
 	else if (card->mmc_avail_type & EXT_CSD_CARD_TYPE_HS200)
 		err = mmc_select_hs200(card);
+#ifdef CONFIG_MMC_RTK_EMMC
+	else if (card->mmc_avail_type & EXT_CSD_CARD_TYPE_DDR_52)
+		err = mmc_select_ddr50(card);
+#endif
 	else if (card->mmc_avail_type & EXT_CSD_CARD_TYPE_HS)
 		err = mmc_select_hs(card);
 
@@ -1448,10 +1629,25 @@ static int mmc_select_timing(struct mmc_card *card)
 	return 0;
 }
 
+#ifdef CONFIG_MMC_RTK_EMMC
+int rtkemmc_select_timing(struct mmc_card *card)
+{
+        mmc_select_timing(card);
+}
+EXPORT_SYMBOL(rtkemmc_select_timing);
+#endif
+
 /*
  * Execute tuning sequence to seek the proper bus operating
  * conditions for HS200 and HS400, which sends CMD21 to the device.
  */
+#ifdef CONFIG_MMC_RTK_EMMC
+static int mmc_ddr50_tuning(struct mmc_card *card)
+{
+	card->host->mode = MODE_DDR;
+	return mmc_execute_tuning(card);
+}
+#endif
 static int mmc_hs200_tuning(struct mmc_card *card)
 {
 	struct mmc_host *host = card->host;
@@ -1461,12 +1657,73 @@ static int mmc_hs200_tuning(struct mmc_card *card)
 	 * operation frequency for tuning process
 	 */
 	if (card->mmc_avail_type & EXT_CSD_CARD_TYPE_HS400 &&
-	    host->ios.bus_width == MMC_BUS_WIDTH_8)
-		if (host->ops->prepare_hs400_tuning)
+	    host->ios.bus_width == MMC_BUS_WIDTH_8) {
+		if (host->ops->prepare_hs400_tuning) {
+#ifdef CONFIG_MMC_RTK_EMMC
+			card->host->mode = MODE_HS400; //execute tuning hs400
+#endif
 			host->ops->prepare_hs400_tuning(host, &host->ios);
-
+		}
+	}
+#ifdef CONFIG_MMC_RTK_EMMC
+	else
+	{
+		card->host->mode = MODE_HS200; //execute tuning hs200
+	}
+#endif
 	return mmc_execute_tuning(card);
 }
+#ifdef CONFIG_MMC_RTK_EMMC
+int rtkemmc_hs200_tuning(struct mmc_card *card)
+{
+         mmc_hs200_tuning(card);
+}
+EXPORT_SYMBOL(rtkemmc_hs200_tuning);
+#endif
+
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+static int mmc_select_cmdq(struct mmc_card *card)
+{
+	struct mmc_host *host = card->host;
+	int ret = 0;
+	if (!host->cmdq_ops) {
+		pr_err("%s: host controller doesn't support CMDQ\n",
+		       mmc_hostname(host));
+		return 0;
+	}
+
+	ret = mmc_set_blocklen(card, MMC_CARD_CMDQ_BLK_SIZE);
+	if (ret)
+		goto out;
+
+	ret = mmc_switch(card, EXT_CSD_CMD_SET_NORMAL, EXT_CSD_CMDQ, 1,
+			 card->ext_csd.generic_cmd6_time);
+	if (ret)
+		goto out;
+
+	mmc_card_set_cmdq(card);
+	if(!host->cmdq_ops->enable) {
+		printk(KERN_ERR "no cmdq enable callback function\n");
+		goto out;
+	}
+	ret = host->cmdq_ops->enable(card->host);
+	if (ret) {
+		pr_err("%s: failed (%d) enabling CMDQ on host\n",
+			mmc_hostname(host), ret);
+		mmc_card_clr_cmdq(card);
+		ret = mmc_switch(card, EXT_CSD_CMD_SET_NORMAL, EXT_CSD_CMDQ, 0,
+				 card->ext_csd.generic_cmd6_time);
+		if (ret)
+			goto out;
+	}
+
+	pr_debug("%s: CMDQ enabled on card\n", mmc_hostname(host));
+out:
+
+	return ret;
+}
+#endif
+
 
 /*
  * Handle the detection and initialisation of a card.
@@ -1496,6 +1753,9 @@ static int mmc_init_card(struct mmc_host *host, u32 ocr,
 	 * respond.
 	 * mmc_go_idle is needed for eMMC that are asleep
 	 */
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+reinit:
+#endif
 	mmc_go_idle(host);
 
 	/* The extra bit indicates that we support high capacity */
@@ -1594,6 +1854,26 @@ static int mmc_init_card(struct mmc_host *host, u32 ocr,
 			goto free_card;
 	}
 
+#ifdef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_MMC_RTK_EMMC
+	err = mmc_switch(card, EXT_CSD_CMD_SET_NORMAL, EXT_CSD_HS_TIMING, 1, 0);
+	if(err){
+#ifdef MMC_DBG
+                printk(KERN_ERR "%s:%d ......>\n",__func__,__LINE__);
+#endif
+                goto free_card;
+          }
+        if(card->host->ops->execute_tuning) {
+#ifdef MMC_DBG
+                printk(KERN_ERR "%s:%d ......>\n",__func__,__LINE__);
+#endif
+		card->host->mode = 0;	//MODE_SD20
+		card->host->card = card;// fix null pointer bug of SDR50
+                err = card->host->ops->execute_tuning(card->host, MMC_SEND_TUNING_BLOCK_HS200);
+        }
+#endif
+#endif
+
 	if (!oldcard) {
 		/* Read extended CSD. */
 		err = mmc_read_ext_csd(card);
@@ -1612,7 +1892,33 @@ static int mmc_init_card(struct mmc_host *host, u32 ocr,
 		/* Erase size depends on CSD and Extended CSD */
 		mmc_set_erase_size(card);
 	}
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_MMC_RTK_EMMC
+	if (!(card->mmc_avail_type & EXT_CSD_CARD_TYPE_HS200)) {
+		err = mmc_switch(card, EXT_CSD_CMD_SET_NORMAL,
+		EXT_CSD_HS_TIMING, EXT_CSD_TIMING_HS, 0);
+		if (err)
+		{
+#ifdef CONFIG_MMC_DEBUG
+			printk("%s:%d ......>\n",__func__,__LINE__);
+#endif
+			goto free_card;
+		}
+		if (card->host->ops->execute_tuning) {
+#ifdef CONFIG_MMC_DEBUG
+			printk("%s:%d ......>\n",__func__,__LINE__);
+#endif
+			card->host->mode = MODE_SDR; //default use high speed SDR firstly
+			card->host->card = card;// fix null pointer bug of SDR50
+			err = card->host->ops->execute_tuning(card->host, MMC_SEND_TUNING_BLOCK_HS200);
+		}
+        }
+#ifdef CONFIG_MMC_DEBUG
+        printk("%s:%d ......>\n",__func__,__LINE__);
+#endif
 
+#endif
+#endif
 	/*
 	 * If enhanced_area_en is TRUE, host needs to enable ERASE_GRP_DEF
 	 * bit.  This bit will be lost every time after a reset or power off.
@@ -1683,8 +1989,16 @@ static int mmc_init_card(struct mmc_host *host, u32 ocr,
 	err = mmc_select_timing(card);
 	if (err)
 		goto free_card;
-
+#ifdef CONFIG_MMC_RTK_EMMC
+	if (mmc_card_ddr52(card)) {
+		err = mmc_ddr50_tuning(card);
+                if (err)
+                        goto free_card;
+	}
+	else if (mmc_card_hs200(card)) {
+#else
 	if (mmc_card_hs200(card)) {
+#endif
 		err = mmc_hs200_tuning(card);
 		if (err)
 			goto free_card;
@@ -1774,7 +2088,19 @@ static int mmc_init_card(struct mmc_host *host, u32 ocr,
 
 	if (!oldcard)
 		host->card = card;
-
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	if (card->ext_csd.cmdq_support && (card->host->caps2 &
+					   MMC_CAP2_CMD_QUEUE)) {
+		err = mmc_select_cmdq(card);
+		if (err) {
+			pr_err("%s: selecting CMDQ mode: failed: %d\n",
+					   mmc_hostname(card->host), err);
+			card->ext_csd.cmdq_support = 0;
+			oldcard = card;
+			goto reinit;
+		}
+	}
+#endif
 	return 0;
 
 free_card:
@@ -1930,6 +2256,22 @@ static int _mmc_suspend(struct mmc_host *host, bool is_suspend)
 	if (mmc_card_suspended(host->card))
 		goto out;
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#ifndef CONFIG_MMC_RTK_EMMC_PON
+	if (host->card->cmdq_init) {
+		BUG_ON(host->cmdq_ctx.active_reqs);
+		err = mmc_cmdq_halt(host, true);
+		if (err) {
+			pr_err("%s: halt: failed: %d\n", __func__, err);
+			goto out;
+		}
+		host->cmdq_ops->disable(host, true);
+	}
+#else
+	host->cmdq_ops->disable(host, false);
+#endif
+#endif
+
 	if (mmc_card_doing_bkops(host->card)) {
 		err = mmc_stop_bkops(host->card);
 		if (err)
@@ -1991,6 +2333,15 @@ static int _mmc_resume(struct mmc_host *host)
 
 	mmc_power_up(host, host->card->ocr);
 	err = mmc_init_card(host, host->card->ocr, host->card);
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#ifndef CONFIG_MMC_RTK_EMMC_PON
+	if (!err && mmc_card_cmdq(host->card)) {
+		err = mmc_cmdq_halt(host, false);
+		if (err)
+			pr_err("%s: un-halt: failed: %d\n", __func__, err);
+	}
+#endif
+#endif
 	mmc_card_clr_suspended(host->card);
 
 out:
diff --git a/drivers/mmc/core/mmc_ops.c b/drivers/mmc/core/mmc_ops.c
index ad6e979..ce5ee2d 100644
--- a/drivers/mmc/core/mmc_ops.c
+++ b/drivers/mmc/core/mmc_ops.c
@@ -23,6 +23,7 @@
 #include "mmc_ops.h"
 
 #define MMC_OPS_TIMEOUT_MS	(10 * 60 * 1000) /* 10 minute timeout */
+#define MMC_MIN_OPS_TIMEOUT_MS (100)            /* minimum 100 ms timeout */
 
 static const u8 tuning_blk_pattern_4bit[] = {
 	0xff, 0x0f, 0xff, 0x00, 0xff, 0xcc, 0xc3, 0xcc,
@@ -455,6 +456,47 @@ int mmc_switch_status_error(struct mmc_host *host, u32 status)
 	return 0;
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+/**
+ *	mmc_prepare_switch - helper; prepare to modify EXT_CSD register
+ *	@card: the MMC card associated with the data transfer
+ *	@set: cmd set values
+ *	@index: EXT_CSD register index
+ *	@value: value to program into EXT_CSD register
+ *	@tout_ms: timeout (ms) for operation performed by register write,
+ *                   timeout of zero implies maximum possible timeout
+ *	@use_busy_signal: use the busy signal as response type
+ *
+ *	Helper to prepare to modify EXT_CSD register for selected card.
+ */
+
+static inline void mmc_prepare_switch(struct mmc_command *cmd, u8 index,
+				      u8 value, u8 set, unsigned int tout_ms,
+				      bool use_busy_signal)
+{
+	cmd->opcode = MMC_SWITCH;
+	cmd->arg = (MMC_SWITCH_MODE_WRITE_BYTE << 24) |
+		  (index << 16) |
+		  (value << 8) |
+		  set;
+	cmd->flags = MMC_CMD_AC;
+	cmd->busy_timeout = tout_ms;
+	if (use_busy_signal)
+		cmd->flags |= MMC_RSP_SPI_R1B | MMC_RSP_R1B;
+	else
+		cmd->flags |= MMC_RSP_SPI_R1 | MMC_RSP_R1;
+}
+
+int __mmc_switch_cmdq_mode(struct mmc_command *cmd, u8 set, u8 index, u8 value,
+			   unsigned int timeout_ms, bool use_busy_signal,
+			   bool ignore_timeout)
+{
+	mmc_prepare_switch(cmd, index, value, set, timeout_ms, use_busy_signal);
+	return 0;
+}
+EXPORT_SYMBOL(__mmc_switch_cmdq_mode);
+#endif
+
 /**
  *	__mmc_switch - modify EXT_CSD register
  *	@card: the MMC card associated with the data transfer
@@ -494,12 +536,17 @@ int __mmc_switch(struct mmc_card *card, u8 set, u8 index, u8 value,
 		(timeout_ms > host->max_busy_timeout))
 		use_r1b_resp = false;
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	mmc_prepare_switch(&cmd, index, value, set, timeout_ms,
+			   use_r1b_resp);
+#else
 	cmd.opcode = MMC_SWITCH;
 	cmd.arg = (MMC_SWITCH_MODE_WRITE_BYTE << 24) |
 		  (index << 16) |
 		  (value << 8) |
 		  set;
 	cmd.flags = MMC_CMD_AC;
+#endif
 	if (use_r1b_resp) {
 		cmd.flags |= MMC_RSP_SPI_R1B | MMC_RSP_R1B;
 		/*
@@ -532,6 +579,10 @@ int __mmc_switch(struct mmc_card *card, u8 set, u8 index, u8 value,
 	/* We have an unspecified cmd timeout, use the fallback value. */
 	if (!timeout_ms)
 		timeout_ms = MMC_OPS_TIMEOUT_MS;
+#ifdef CONFIG_MMC_RTK_EMMC
+        if (timeout_ms < MMC_MIN_OPS_TIMEOUT_MS)
+                timeout_ms = MMC_MIN_OPS_TIMEOUT_MS;
+#endif
 
 	/* Must check status to be sure of no errors. */
 	timeout = jiffies + msecs_to_jiffies(timeout_ms) + 1;
@@ -592,6 +643,25 @@ int mmc_switch(struct mmc_card *card, u8 set, u8 index, u8 value,
 }
 EXPORT_SYMBOL_GPL(mmc_switch);
 
+#ifdef CONFIG_MMC_SDHCI_RTK
+int mmc_send_tuning_tx(struct mmc_host *host, u32 opcode, int *cmd_error)
+{
+	struct mmc_command cmd = {0};
+        int err;
+
+        cmd.opcode = opcode;
+        cmd.arg = 0x2000;
+        cmd.flags = MMC_RSP_SPI_R5 | MMC_RSP_R5 | MMC_CMD_AC;
+
+        err = mmc_wait_for_cmd(host, &cmd, 0);
+        if (err)
+                return err;
+
+        return 0;
+}
+EXPORT_SYMBOL_GPL(mmc_send_tuning_tx);
+#endif
+
 int mmc_send_tuning(struct mmc_host *host, u32 opcode, int *cmd_error)
 {
 	struct mmc_request mrq = {NULL};
diff --git a/drivers/mmc/core/sd.c b/drivers/mmc/core/sd.c
index f09148a..c5413f4 100644
--- a/drivers/mmc/core/sd.c
+++ b/drivers/mmc/core/sd.c
@@ -27,6 +27,31 @@
 #include "sd.h"
 #include "sd_ops.h"
 
+#ifdef CONFIG_MMC_RTK_SDMMC
+int mmc_runtime_resume_flag=0;
+int get_mmc_runtime_resume_flag(void)
+{
+        return mmc_runtime_resume_flag;
+}
+EXPORT_SYMBOL(get_mmc_runtime_resume_flag);
+void set_mmc_runtime_resume_flag(int flag)
+{
+        mmc_runtime_resume_flag = flag;
+}
+EXPORT_SYMBOL(set_mmc_runtime_resume_flag);
+#endif
+
+#ifdef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_MMC_RTK_SDMMC
+int Menfid=0x0;
+int get_manfid(void)
+{
+        return Menfid;
+}
+EXPORT_SYMBOL(get_manfid);
+#endif
+#endif
+
 static const unsigned int tran_exp[] = {
 	10000,		100000,		1000000,	10000000,
 	0,		0,		0,		0
@@ -79,6 +104,12 @@ void mmc_decode_cid(struct mmc_card *card)
 	 * have to assume we can parse this.
 	 */
 	card->cid.manfid		= UNSTUFF_BITS(resp, 120, 8);
+#ifdef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_MMC_RTK_SDMMC
+	Menfid = card->cid.manfid;
+#endif
+#endif
+
 	card->cid.oemid			= UNSTUFF_BITS(resp, 104, 16);
 	card->cid.prod_name[0]		= UNSTUFF_BITS(resp, 96, 8);
 	card->cid.prod_name[1]		= UNSTUFF_BITS(resp, 88, 8);
@@ -847,6 +878,9 @@ int mmc_sd_setup_card(struct mmc_host *host, struct mmc_card *card,
 	bool reinit)
 {
 	int err;
+#ifdef CONFIG_MMC_PARANOID_SD_INIT
+	int retries;
+#endif
 
 	if (!reinit) {
 		/*
@@ -873,7 +907,26 @@ int mmc_sd_setup_card(struct mmc_host *host, struct mmc_card *card,
 		/*
 		 * Fetch switch information from card.
 		 */
+#ifdef CONFIG_MMC_PARANOID_SD_INIT
+		for (retries = 1; retries <= 3; retries++) {
+			err = mmc_read_switch(card);
+			if (!err) {
+				if (retries > 1) {
+					printk(KERN_WARNING
+					       "%s: recovered\n",
+					       mmc_hostname(host));
+				}
+				break;
+			} else {
+				printk(KERN_WARNING
+				       "%s: read switch failed (attempt %d)\n",
+				       mmc_hostname(host), retries);
+			}
+		}
+#else
 		err = mmc_read_switch(card);
+#endif
+
 		if (err)
 			return err;
 	}
@@ -1071,7 +1124,10 @@ static int mmc_sd_alive(struct mmc_host *host)
  */
 static void mmc_sd_detect(struct mmc_host *host)
 {
-	int err;
+	int err = 0;
+#ifdef CONFIG_MMC_PARANOID_SD_INIT
+	int retries = 5;
+#endif
 
 	BUG_ON(!host);
 	BUG_ON(!host->card);
@@ -1081,7 +1137,23 @@ static void mmc_sd_detect(struct mmc_host *host)
 	/*
 	 * Just check if our card has been removed.
 	 */
+#ifdef CONFIG_MMC_PARANOID_SD_INIT
+	while(retries) {
+		err = mmc_send_status(host->card, NULL);
+		if (err) {
+			retries--;
+			udelay(5);
+			continue;
+		}
+		break;
+	}
+	if (!retries) {
+		printk(KERN_ERR "%s(%s): Unable to re-detect card (%d)\n",
+		       __func__, mmc_hostname(host), err);
+	}
+#else
 	err = _mmc_detect_card_removed(host);
+#endif
 
 	mmc_put_card(host->card);
 
@@ -1143,6 +1215,9 @@ static int mmc_sd_suspend(struct mmc_host *host)
 static int _mmc_sd_resume(struct mmc_host *host)
 {
 	int err = 0;
+#ifdef CONFIG_MMC_PARANOID_SD_INIT
+	int retries;
+#endif
 
 	BUG_ON(!host);
 	BUG_ON(!host->card);
@@ -1153,7 +1228,23 @@ static int _mmc_sd_resume(struct mmc_host *host)
 		goto out;
 
 	mmc_power_up(host, host->card->ocr);
+#ifdef CONFIG_MMC_PARANOID_SD_INIT
+	retries = 5;
+	while (retries) {
+		err = mmc_sd_init_card(host, host->card->ocr, host->card);
+
+		if (err) {
+			printk(KERN_ERR "%s: Re-init card rc = %d (retries = %d)\n",
+			       mmc_hostname(host), err, retries);
+			mdelay(5);
+			retries--;
+			continue;
+		}
+		break;
+	}
+#else
 	err = mmc_sd_init_card(host, host->card->ocr, host->card);
+#endif
 	mmc_card_clr_suspended(host->card);
 
 out:
@@ -1196,10 +1287,14 @@ static int mmc_sd_runtime_resume(struct mmc_host *host)
 	int err;
 
 	err = _mmc_sd_resume(host);
-	if (err && err != -ENOMEDIUM)
+	if (err && err != -ENOMEDIUM) {
+#ifdef CONFIG_MMC_RTK_SDMMC
+		mmc_runtime_resume_flag=1;
+#endif
+
 		pr_err("%s: error %d doing runtime resume\n",
 			mmc_hostname(host), err);
-
+	}
 	return 0;
 }
 
@@ -1228,6 +1323,9 @@ int mmc_attach_sd(struct mmc_host *host)
 {
 	int err;
 	u32 ocr, rocr;
+#ifdef CONFIG_MMC_PARANOID_SD_INIT
+	int retries;
+#endif
 
 	BUG_ON(!host);
 	WARN_ON(!host->claimed);
@@ -1264,9 +1362,27 @@ int mmc_attach_sd(struct mmc_host *host)
 	/*
 	 * Detect and init the card.
 	 */
+#ifdef CONFIG_MMC_PARANOID_SD_INIT
+	retries = 5;
+	while (retries) {
+		err = mmc_sd_init_card(host, rocr, NULL);
+		if (err) {
+			retries--;
+			continue;
+		}
+		break;
+	}
+
+	if (!retries) {
+		printk(KERN_ERR "%s: mmc_sd_init_card() failure (err = %d)\n",
+		       mmc_hostname(host), err);
+		goto err;
+	}
+#else
 	err = mmc_sd_init_card(host, rocr, NULL);
 	if (err)
 		goto err;
+#endif
 
 	mmc_release_host(host);
 	err = mmc_add_card(host->card);
diff --git a/drivers/mmc/core/sdio.c b/drivers/mmc/core/sdio.c
index bd44ba8..268988e 100644
--- a/drivers/mmc/core/sdio.c
+++ b/drivers/mmc/core/sdio.c
@@ -10,6 +10,7 @@
  */
 
 #include <linux/err.h>
+#include <linux/module.h>
 #include <linux/pm_runtime.h>
 
 #include <linux/mmc/host.h>
@@ -21,6 +22,7 @@
 
 #include "core.h"
 #include "bus.h"
+#include "host.h"
 #include "sd.h"
 #include "sdio_bus.h"
 #include "mmc_ops.h"
@@ -28,6 +30,16 @@
 #include "sdio_ops.h"
 #include "sdio_cis.h"
 
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+#include <linux/mmc/sdio_ids.h>
+#endif
+
+#ifdef CONFIG_MMC_SDHCI_RTK
+void set_SDIO_version(int version);
+int get_SDIO_version(void);
+void rtk_register_set(void);
+#endif
+
 static int sdio_read_fbr(struct sdio_func *func)
 {
 	int ret;
@@ -155,6 +167,11 @@ static int sdio_read_cccr(struct mmc_card *card, u32 ocr)
 			if (ret)
 				goto out;
 
+#ifdef CONFIG_MMC_SDHCI_RTK
+                        set_SDIO_version(3);
+                        rtk_register_set();
+#endif
+
 			if (mmc_host_uhs(card->host)) {
 				if (data & SDIO_UHS_DDR50)
 					card->sw_caps.sd3_bus_mode
@@ -164,9 +181,16 @@ static int sdio_read_cccr(struct mmc_card *card, u32 ocr)
 					card->sw_caps.sd3_bus_mode
 						|= SD_MODE_UHS_SDR50;
 
-				if (data & SDIO_UHS_SDR104)
+				if (data & SDIO_UHS_SDR104) {
 					card->sw_caps.sd3_bus_mode
 						|= SD_MODE_UHS_SDR104;
+#ifdef CONFIG_MMC_SDHCI_RTK
+					if(card->host->caps & MMC_CAP_UHS_SDR104) {
+						set_SDIO_version(4);
+						rtk_register_set();
+					}
+#endif
+				}
 			}
 
 			ret = mmc_io_rw_direct(card, 0, 0,
@@ -184,6 +208,10 @@ static int sdio_read_cccr(struct mmc_card *card, u32 ocr)
 
 		/* if no uhs mode ensure we check for high speed */
 		if (!card->sw_caps.sd3_bus_mode) {
+#ifdef CONFIG_MMC_SDHCI_RTK
+                        set_SDIO_version(2);
+                        rtk_register_set();
+#endif
 			if (speed & SDIO_SPEED_SHS) {
 				card->cccr.high_speed = 1;
 				card->sw_caps.hs_max_dtr = 50000000;
@@ -627,8 +655,13 @@ static int mmc_sdio_init_card(struct mmc_host *host, u32 ocr,
 	 * it.
 	 */
 	if (!powered_resume && (rocr & ocr & R4_18V_PRESENT)) {
+#ifdef CONFIG_MMC_SDHCI_RTK
+                host->ios.signal_voltage = MMC_SIGNAL_VOLTAGE_180;
+                ocr |= R4_18V_PRESENT;
+#else
 		err = mmc_set_signal_voltage(host, MMC_SIGNAL_VOLTAGE_180,
 					ocr_card);
+#endif
 		if (err == -EAGAIN) {
 			sdio_reset(host);
 			mmc_go_idle(host);
@@ -697,19 +730,35 @@ static int mmc_sdio_init_card(struct mmc_host *host, u32 ocr,
 		goto finish;
 	}
 
-	/*
-	 * Read the common registers.
-	 */
-	err = sdio_read_cccr(card, ocr);
-	if (err)
-		goto remove;
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+	if (host->embedded_sdio_data.cccr)
+		memcpy(&card->cccr, host->embedded_sdio_data.cccr, sizeof(struct sdio_cccr));
+	else {
+#endif
+		/*
+		 * Read the common registers.
+		 */
+		err = sdio_read_cccr(card,  ocr);
+		if (err)
+			goto remove;
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+	}
+#endif
 
-	/*
-	 * Read the common CIS tuples.
-	 */
-	err = sdio_read_common_cis(card);
-	if (err)
-		goto remove;
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+	if (host->embedded_sdio_data.cis)
+		memcpy(&card->cis, host->embedded_sdio_data.cis, sizeof(struct sdio_cis));
+	else {
+#endif
+		/*
+		 * Read the common CIS tuples.
+		 */
+		err = sdio_read_common_cis(card);
+		if (err)
+			goto remove;
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+	}
+#endif
 
 	if (oldcard) {
 		int same = (card->cis.vendor == oldcard->cis.vendor &&
@@ -1118,14 +1167,36 @@ int mmc_attach_sdio(struct mmc_host *host)
 	funcs = (ocr & 0x70000000) >> 28;
 	card->sdio_funcs = 0;
 
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+	if (host->embedded_sdio_data.funcs)
+		card->sdio_funcs = funcs = host->embedded_sdio_data.num_funcs;
+#endif
+
 	/*
 	 * Initialize (but don't add) all present functions.
 	 */
 	for (i = 0; i < funcs; i++, card->sdio_funcs++) {
-		err = sdio_init_func(host->card, i + 1);
-		if (err)
-			goto remove;
-
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+		if (host->embedded_sdio_data.funcs) {
+			struct sdio_func *tmp;
+
+			tmp = sdio_alloc_func(host->card);
+			if (IS_ERR(tmp))
+				goto remove;
+			tmp->num = (i + 1);
+			card->sdio_func[i] = tmp;
+			tmp->class = host->embedded_sdio_data.funcs[i].f_class;
+			tmp->max_blksize = host->embedded_sdio_data.funcs[i].f_maxblksize;
+			tmp->vendor = card->cis.vendor;
+			tmp->device = card->cis.device;
+		} else {
+#endif
+			err = sdio_init_func(host->card, i + 1);
+			if (err)
+				goto remove;
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+		}
+#endif
 		/*
 		 * Enable Runtime PM for this func (if supported)
 		 */
@@ -1173,3 +1244,42 @@ int mmc_attach_sdio(struct mmc_host *host)
 	return err;
 }
 
+int sdio_reset_comm(struct mmc_card *card)
+{
+	struct mmc_host *host = card->host;
+	u32 ocr;
+	u32 rocr;
+	int err;
+
+	printk("%s():\n", __func__);
+	mmc_claim_host(host);
+
+	mmc_retune_disable(host);
+
+	mmc_go_idle(host);
+
+	mmc_set_clock(host, host->f_min);
+
+	err = mmc_send_io_op_cond(host, 0, &ocr);
+	if (err)
+		goto err;
+
+	rocr = mmc_select_voltage(host, ocr);
+	if (!rocr) {
+		err = -EINVAL;
+		goto err;
+	}
+
+	err = mmc_sdio_init_card(host, rocr, card, 0);
+	if (err)
+		goto err;
+
+	mmc_release_host(host);
+	return 0;
+err:
+	printk("%s: Error resetting SDIO communications (%d)\n",
+	       mmc_hostname(host), err);
+	mmc_release_host(host);
+	return err;
+}
+EXPORT_SYMBOL(sdio_reset_comm);
diff --git a/drivers/mmc/core/sdio_bus.c b/drivers/mmc/core/sdio_bus.c
index d56a3b6..528524a 100644
--- a/drivers/mmc/core/sdio_bus.c
+++ b/drivers/mmc/core/sdio_bus.c
@@ -28,6 +28,10 @@
 #include "sdio_cis.h"
 #include "sdio_bus.h"
 
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+#include <linux/mmc/host.h>
+#endif
+
 #define to_sdio_driver(d)	container_of(d, struct sdio_driver, drv)
 
 /* show configuration fields */
@@ -263,7 +267,14 @@ static void sdio_release_func(struct device *dev)
 {
 	struct sdio_func *func = dev_to_sdio_func(dev);
 
-	sdio_free_func_cis(func);
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+	/*
+	 * If this device is embedded then we never allocated
+	 * cis tables for this func
+	 */
+	if (!func->card->host->embedded_sdio_data.funcs)
+#endif
+		sdio_free_func_cis(func);
 
 	kfree(func->info);
 	kfree(func->tmpbuf);
diff --git a/drivers/mmc/core/sdio_io.c b/drivers/mmc/core/sdio_io.c
index 406e5f0..3734cba 100644
--- a/drivers/mmc/core/sdio_io.c
+++ b/drivers/mmc/core/sdio_io.c
@@ -390,6 +390,39 @@ u8 sdio_readb(struct sdio_func *func, unsigned int addr, int *err_ret)
 EXPORT_SYMBOL_GPL(sdio_readb);
 
 /**
+ *	sdio_readb_ext - read a single byte from a SDIO function
+ *	@func: SDIO function to access
+ *	@addr: address to read
+ *	@err_ret: optional status value from transfer
+ *	@in: value to add to argument
+ *
+ *	Reads a single byte from the address space of a given SDIO
+ *	function. If there is a problem reading the address, 0xff
+ *	is returned and @err_ret will contain the error code.
+ */
+unsigned char sdio_readb_ext(struct sdio_func *func, unsigned int addr,
+	int *err_ret, unsigned in)
+{
+	int ret;
+	unsigned char val;
+
+	BUG_ON(!func);
+
+	if (err_ret)
+		*err_ret = 0;
+
+	ret = mmc_io_rw_direct(func->card, 0, func->num, addr, (u8)in, &val);
+	if (ret) {
+		if (err_ret)
+			*err_ret = ret;
+		return 0xFF;
+	}
+
+	return val;
+}
+EXPORT_SYMBOL_GPL(sdio_readb_ext);
+
+/**
  *	sdio_writeb - write a single byte to a SDIO function
  *	@func: SDIO function to access
  *	@b: byte to write
diff --git a/drivers/mmc/host/Kconfig b/drivers/mmc/host/Kconfig
index 5274f50..371c19e 100644
--- a/drivers/mmc/host/Kconfig
+++ b/drivers/mmc/host/Kconfig
@@ -4,6 +4,47 @@
 
 comment "MMC/SD/SDIO Host Controller Drivers"
 
+menuconfig MMC_RTK_EMMC
+    tristate "Realtek EMMC host driver"
+        help
+          Support RealTek EMMC for Kylin.
+
+config MMC_RTK_EMMC_HW_SEMAPHORE
+    bool  "Enable Realtek EMMC host driver hardware semaphore."
+    depends on MMC_RTK_EMMC
+    default n
+        help
+          Enable Realtek EMMC host driver hardware semaphore.
+
+menuconfig MMC_RTK_EMMC_CMDQ
+    bool "Realtek EMMC host driver with cmdq function"
+	depends on MMC_RTK_EMMC
+	depends on ARCH_RTD13xx
+	depends on HAS_DMA
+	default n
+        help
+          Support RealTek EMMC for Hank cqe function.
+
+menuconfig MMC_RTK_EMMC_PON
+    bool "Realtek EMMC host driver with pon function"
+	depends on MMC_RTK_EMMC
+	depends on ARCH_RTD13xx
+	default n
+        help
+          Support RealTek EMMC for Hank PON function.
+
+menuconfig MMC_RTK_SDMMC
+    tristate "Realtek SD/MMC host driver"
+    help
+      Realtek SD/MMC host support.
+ 
+config MMC_RTK_SDMMC_DEBUG
+    bool  "Enable Realtek SD/MMC host driver debug message."
+    depends on MMC_RTK_SDMMC
+    default n
+        help
+          Enable Realtek SD/MMC host driver debug message.
+
 config MMC_ARMMMCI
 	tristate "ARM AMBA Multimedia Card Interface support"
 	depends on ARM_AMBA
@@ -343,6 +384,24 @@ config MMC_SDHCI_ST
 	  If you have a controller with this interface, say Y or M here.
 	  If unsure, say N.
 
+menuconfig MMC_SDHCI_RTK
+    tristate "SDHCI support for Realtek SoC"
+    depends on RTK_PLATFORM
+    depends on MMC_SDHCI_PLTFM
+    select MMC_SDHCI_IO_ACCESSORS
+    help
+      This selects the Secure Digital Host Controller Interface in
+      Realtek SoCs.
+
+      If you have a controller with this interface, say Y or M here.
+      If unsure, say N.
+      
+config RTK_SDIO_CLK_ADJUST
+    bool "Dynamic SDIO clock adjust support"
+    depends on MMC_SDHCI_RTK
+        help
+          SDIO clock adjusting API for WIFI driver
+
 config MMC_OMAP
 	tristate "TI OMAP Multimedia Card Interface support"
 	depends on ARCH_OMAP
diff --git a/drivers/mmc/host/Makefile b/drivers/mmc/host/Makefile
index e2bdaaf4..d3a84ca 100644
--- a/drivers/mmc/host/Makefile
+++ b/drivers/mmc/host/Makefile
@@ -2,6 +2,14 @@
 # Makefile for MMC/SD host controller drivers
 #
 
+ifeq ($(CONFIG_ARCH_RTD119X),y)
+obj-$(CONFIG_MMC_RTK_EMMC)              += rtkemmc_rtd119x.o
+else ifeq ($(CONFIG_ARCH_RTD13xx),y)
+obj-$(CONFIG_MMC_RTK_EMMC)              += rtkemmc_rtd13xx.o
+else
+obj-$(CONFIG_MMC_RTK_EMMC)              += rtkemmc.o
+endif
+
 obj-$(CONFIG_MMC_ARMMMCI)	+= mmci.o
 obj-$(CONFIG_MMC_QCOM_DML)	+= mmci_qcom_dml.o
 obj-$(CONFIG_MMC_PXA)		+= pxamci.o
@@ -76,7 +84,13 @@ obj-$(CONFIG_MMC_SDHCI_MSM)		+= sdhci-msm.o
 obj-$(CONFIG_MMC_SDHCI_ST)		+= sdhci-st.o
 obj-$(CONFIG_MMC_SDHCI_MICROCHIP_PIC32)	+= sdhci-pic32.o
 obj-$(CONFIG_MMC_SDHCI_BRCMSTB)		+= sdhci-brcmstb.o
+obj-$(CONFIG_MMC_SDHCI_RTK)		+= sdhci-rtk.o
 
 ifeq ($(CONFIG_CB710_DEBUG),y)
 	CFLAGS-cb710-mmc	+= -DDEBUG
 endif
+
+obj-$(CONFIG_MMC_RTK_SDMMC)		+= rtk-sdmmc.o
+obj-y					+= sdmmc_export.o
+#obj-$(CONFIG_MMC_RTK_EMMC)		+= rtkemmc.o
+#obj-$(CONFIG_MMC_RTK_EMMC)		+= rtkemmc_ops.o
diff --git a/drivers/mmc/host/mmc_debug.h b/drivers/mmc/host/mmc_debug.h
new file mode 100644
index 00000000..46308db
--- /dev/null
+++ b/drivers/mmc/host/mmc_debug.h
@@ -0,0 +1,110 @@
+#ifndef _MMC_RTK_DEBUG_H
+#define _MMC_RTK_DEBUG_H
+
+//#define MMC_DEBUG//////////////////////
+#ifdef MMC_DEBUG
+    #define mmcinfo(fmt, args...) \
+               printk(KERN_INFO "mmc:%s(%d):" fmt, __func__ ,__LINE__,## args)
+#else
+    #define mmcinfo(fmt, args...)
+#endif
+
+//#define MMC_CORE//////////////////////
+#ifdef MMC_CORE
+    #define mmcore(fmt, args...) \
+           printk(KERN_INFO "mmcore:%s(%d):" fmt, __func__ ,__LINE__,## args)
+#else
+    #define mmcore(fmt, args...)
+#endif
+
+//#define MMC_CARD//////////////////////
+#ifdef MMC_CARD
+    #define mmcard(fmt, args...) \
+           printk(KERN_INFO "mmcard:%s(%d):" fmt, __func__ ,__LINE__,## args)
+#else
+    #define mmcard(fmt, args...)
+#endif
+
+//#define MMC_RTK//////////////////////
+#ifdef MMC_RTK
+    #define mmcrtk(fmt, args...) \
+           printk(KERN_INFO "mmcrtk:%s(%d):" fmt, __func__ ,__LINE__,## args)
+#else
+    #define mmcrtk(fmt, args...)
+#endif
+
+//#define MMC_SPEC//////////////////////
+#ifdef MMC_SPEC
+    #define mmcspec(fmt, args...) \
+           printk(KERN_INFO "mmcspec:%s(%d):" fmt, __func__ ,__LINE__,## args)
+#else
+    #define mmcspec(fmt, args...)
+#endif
+
+//#define MMC_MSG1//////////////////////
+#ifdef MMC_MSG1
+    #define mmcmsg1(fmt, args...) \
+           printk(KERN_INFO "mmcmsg1:%s(%d):" fmt, __func__ ,__LINE__,## args)
+#else
+    #define mmcmsg1(fmt, args...)
+#endif
+
+//#define MMC_MSG2//////////////////////
+#ifdef MMC_MSG2
+    #define mmcmsg2(fmt, args...) \
+           printk(KERN_INFO "mmcmsg2:%s(%d):" fmt, __func__ ,__LINE__,## args)
+#else
+    #define mmcmsg2(fmt, args...)
+#endif
+
+//#define MMC_MSG3//////////////////////
+#ifdef MMC_MSG3
+    #define mmcmsg3(fmt, args...) \
+           printk(KERN_INFO "" fmt, ## args)
+           //printk(KERN_INFO "mmcmsg3:%s(%d):" fmt, __func__ ,__LINE__,## args)
+#else
+    #define mmcmsg3(fmt, args...)
+#endif
+
+//#define MMC_TRH//////////////////////
+#ifdef MMC_TRH
+    #define trhmsg(fmt, args...) \
+           printk(KERN_INFO "" fmt,## args)
+           //printk(KERN_INFO "trhmsg:%s(%d):" fmt, __func__ ,__LINE__,## args)
+#else
+    #define trhmsg(fmt, args...)
+#endif
+
+//#define SHOW_CSD
+//#define SHOW_EXT_CSD
+//#define SHOW_SWITCH_DATA
+//#define SHOW_CID
+//#define SHOW_SCR
+
+//#define SHOW_MS_PRD
+//#define SHOW_MMC_PRD
+//#define  SHOW_INT_STATUS
+
+//#define GPIO_CTL
+//#define TEST_POWER_RESCYCLE
+
+//#define OPEN_TEST_PORT
+
+//#define WR_WORK_AROUND_EN
+//#define WR_WORK_AROUND_EN_TEST
+//#define HW_ISSUE_RESET
+//#define MONI_MEM_TRASH
+//#define END_DELAY_EN
+//#define FPGA_TEST_CASE
+
+#endif
+
+
+
+
+
+
+
+
+
+
diff --git a/drivers/mmc/host/reg_iso.h b/drivers/mmc/host/reg_iso.h
new file mode 100644
index 00000000..b12457b
--- /dev/null
+++ b/drivers/mmc/host/reg_iso.h
@@ -0,0 +1,12 @@
+#ifndef _REG_ISO_H_INCLUDED_
+#define _REG_ISO_H_INCLUDED_
+
+#define ISO_OFFSET				0x00007000
+
+#define UR0RBR_THR_DLL			0x00000800
+
+#define RBUS_ISO_PHYS(pa)		(RBUS_BASE_PHYS + ISO_OFFSET + pa)
+
+#define ISO_IO_ADDR(pa)			(IOMEM(RBUS_BASE_VIRT) + ISO_OFFSET + pa)
+
+#endif	// _REG_ISO_H_INCLUDED_
diff --git a/drivers/mmc/host/reg_mmc.h b/drivers/mmc/host/reg_mmc.h
new file mode 100644
index 00000000..deff0bc
--- /dev/null
+++ b/drivers/mmc/host/reg_mmc.h
@@ -0,0 +1,315 @@
+/*
+ *  Copyright (C) 2013 Realtek Semiconductors, All Rights Reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __REG_MMC_H
+#define __REG_MMC_H
+
+/* eMMC control register definition */
+#define CR_BASE_ADDR            0x00000000  //map to 0x98012000
+
+//1295 emmc ip register
+#define EMMC_CTRL                            ( CR_BASE_ADDR)
+#define EMMC_PWREN                           ( CR_BASE_ADDR + 0x004)
+#define EMMC_CLKDIV                          ( CR_BASE_ADDR + 0x008)
+#define EMMC_CLKSRC                          ( CR_BASE_ADDR + 0x00C)
+#define EMMC_CLKENA                          ( CR_BASE_ADDR + 0x010)
+#define EMMC_TMOUT                           ( CR_BASE_ADDR + 0x014)
+#define EMMC_CTYPE                           ( CR_BASE_ADDR + 0x018)
+#define EMMC_BLKSIZE                         ( CR_BASE_ADDR + 0x01C)
+#define EMMC_BYTCNT                          ( CR_BASE_ADDR + 0x020)
+#define EMMC_INTMASK                         ( CR_BASE_ADDR + 0x024)
+#define EMMC_CMDARG                          ( CR_BASE_ADDR + 0x028)
+#define EMMC_CMD                             ( CR_BASE_ADDR + 0x02C)
+#define EMMC_RESP0                           ( CR_BASE_ADDR + 0x030)
+#define EMMC_RESP1                           ( CR_BASE_ADDR + 0x034)
+#define EMMC_RESP2                           ( CR_BASE_ADDR + 0x038)
+#define EMMC_RESP3                           ( CR_BASE_ADDR + 0x03C)
+#define EMMC_MINTSTS                         ( CR_BASE_ADDR + 0x040)
+#define EMMC_RINTSTS                         ( CR_BASE_ADDR + 0x044)
+#define EMMC_STATUS                          ( CR_BASE_ADDR + 0x048)
+#define EMMC_FIFOTH                          ( CR_BASE_ADDR + 0x04C)
+#define EMMC_TBBCNT                          ( CR_BASE_ADDR + 0x060)
+#define EMMC_UHSREG                          ( CR_BASE_ADDR + 0x074)
+#define EMMC_BMOD                            ( CR_BASE_ADDR + 0x080)
+#define EMMC_DBADDR                          ( CR_BASE_ADDR + 0x088)
+#define EMMC_IDINTEN                         ( CR_BASE_ADDR + 0x090)
+#define EMMC_IDSTS			     			 ( CR_BASE_ADDR + 0x08C)
+#define EMMC_CARD_THR_CTL			         ( CR_BASE_ADDR + 0x100)
+#define EMMC_DDR_REG			     		 ( CR_BASE_ADDR + 0x10c)
+
+
+//1295 emmc wrapper register
+#define EMMC_DESC_CTL0         ( 0x400 )
+#define EMMC_DESC_CTL1         ( 0x404 )
+#define EMMC_DESC_CTL2         ( 0x408 )
+#define EMMC_DESC_CTL3         ( 0x40C )
+#define EMMC_DESC_STS          ( 0x410 )
+#define EMMC_DESC_THD          ( 0x414 )
+#define EMMC_SYS_LOW_PWR       ( 0x418 )
+#define EMMC_CP                ( 0x41c )
+#define EMMC_OTHER1            ( 0x420 )
+#define EMMC_ISR               ( 0x424 )
+#define EMMC_DBG				(0x444)
+#define EMMC_PAD_CTL           ( 0x474 )
+#define EMMC_IP_DESC0			( 0x4a0)
+#define EMMC_IP_DESC1			( 0x4a4)
+#define EMMC_IP_DESC2			( 0x4a8)
+#define EMMC_IP_DESC3			( 0x4ac)
+#define EMMC_MAIN2_DBG			( 0x4b0)
+
+#if defined(CONFIG_ARCH_RTD129x)
+#define EMMC_muxpad0				(0x600)	//mux for nand and emmc
+#define EMMC_muxpad1				(0x604)	//mux for sdio and sd card
+#define EMMC_PFUNC_NF1				(0x60c)	
+#define EMMC_PFUNC_CR				(0x610)	
+#define EMMC_muxpad2				(0x61c)
+#define EMMC_PDRIVE_NF0        ( 0x620 )
+#define EMMC_PDRIVE_NF1        ( 0x624 )
+#define EMMC_PDRIVE_NF2        ( 0x628 )
+#define EMMC_PDRIVE_NF3        ( 0x62c )
+#define EMMC_PDRIVE_NF4        ( 0x630 )
+
+#define EMMC_PDRIVE_CR0        ( 0x634 )
+#define EMMC_PDRIVE_CR1        ( 0x638 )
+#define EMMC_PDRIVE_SDIO           ( 0x63c )
+#define EMMC_PDRIVE_SDIO1          ( 0x640 )
+
+#elif defined(CONFIG_ARCH_RTD139x)	//139x
+#define ISO_MUXPAD	( 0x00000000 )
+#define ISO_muxpad4	( ISO_MUXPAD + 0x10 )
+#define pfunc_emmc0	( ISO_MUXPAD + 0x50 )
+#define pfunc_emmc1     ( ISO_MUXPAD + 0x54 )
+#define pfunc_emmc2     ( ISO_MUXPAD + 0x58 )
+#define pfunc_emmc3     ( ISO_MUXPAD + 0x5c )
+#define pfunc_emmc4     ( ISO_MUXPAD + 0x60 )
+#define pfunc_emmc5     ( ISO_MUXPAD + 0x64 )
+
+#elif defined(CONFIG_ARCH_RTD16xx)	//16xx
+#define M2TMX      ( 0x00000000 )
+#define m2tmx_muxpad0     ( M2TMX )
+#define m2tmx_pfunc4     ( M2TMX + 0x1c )
+#define m2tmx_pfunc5     ( M2TMX + 0x20 )
+#define m2tmx_pfunc6     ( M2TMX + 0x24 )
+#define m2tmx_pfunc7     ( M2TMX + 0x28 )
+#define m2tmx_pfunc8     ( M2TMX + 0x2c )
+#endif
+
+//MISC
+#define MISC_GP2DIR 				(0x108)
+#define MISC_GP3DIR 				(0x10c)
+
+#define MISC_GP2DATO 				(0x118)
+#define MISC_GP3DATO 				(0x11c)
+
+#define MISC_DUMMY1 				(0x0e4)
+#define MISC_DUMMY2 				(0x0e8)
+
+
+
+#define ISR_WRITE_DATA	     1 //set bit
+#define ISR_DMA_DONE_INT	(1<<1)
+#define ISR_DMA_INT_MASK	(1<<2)
+#define ISR_DESC_INT_MASK	(1<<3)
+#define ISR_IP_INT_MASK	(1<<4)
+#define EMMC_ISREN             ( 0x428 )
+#define EMMC_DUMMY_SYS         ( 0x42c )
+#define EMMC_AHB               ( 0x430 )
+#define EMMC_IP_CTL            ( 0x470 )
+#define EMMC_CKGEN_CTL         ( 0x478 )
+#define EMMC_CARD_DRV1         ( 0x490 )
+#define EMMC_CARD_DRV2         ( 0x494 )
+#define EMMC_DQS_CTRL1         ( 0x498 )
+#define EMMC_SWC_SEL           ( 0x4d4 )
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+#define EMMC_SWC_SEL1          ( 0x4d8 )
+#define EMMC_SWC_SEL2          ( 0x4dc )
+#define EMMC_SWC_SEL3          ( 0x4e0 )
+#endif
+
+#define RESP_LEN64                (0x1)
+#define RESP_LEN17                (0x2)
+#define DMA_XFER                (0x00000001)
+#define DDR_WR                  (0x00000001<<1)
+#define RSP17_SEL               (0x00000001<<4)
+#define RSP64_SEL               (0x00000001<<5)
+#define DAT64_SEL               (0x00000001<<5)
+
+/*CARD_EXIST 0x1801051f */
+#if 0
+#define SD_WRITE_PROTECT		(0x00000001<<5)
+#define XD_EXISTENCE			(0x00000001<<4)
+#define MS_EXISTENCE			(0x00000001<<3)
+#define SD_EXISTENCE			(0x00000001<<2)
+#define SM_EXISTENCE			(0x00000001<<1)
+#endif
+
+/* SD_CONFIGURE1 0x18012180 */
+#define SDCLK_DIV                   (0x00000001<<7)
+#define SDCLK_NO_DIV                (0x00000000)
+#define SDCLK_DIV_128               (0x00000000)
+#define SDCLK_DIV_256               (0x00000001<<6)
+#define NO_RST_RDWR_FIFO            (0x00000000)
+#define RST_RDWR_FIFO               (0x00000001<<4)
+
+#define MASK_CLOCK_MODE         (0x00000003<<2)
+#define MASK_CLOCK_DIV          (0x00000003<<6)
+#define CLOCK_DIV_NON           (0x00000002)
+#define CLOCK_DIV_256           (0x00000001<<6)
+#define CLOCK_DIV_128           (0x00000000)
+#define EMMC_CLOCK_DIV_NON      (0x00000000)
+#define EMMC_CLOCK_DIV_2        (0x00000001)
+#define EMMC_CLOCK_DIV_8        (0x00000004)
+#define EMMC_CLOCK_DIV_128      (0x00000001<<6)
+#define EMMC_CLOCK_DIV_256      (0x00000001<<7)
+
+
+#define SPEED_MOD_HIGH          (0x00000001<<4)
+#define SPEED_MOD_NORM          (0x00000000)
+#define DELAY_PHA_MASK          (0x00000003<<2)
+#define DELAY_PHA_NORM          (0x00000001<<3)
+#define DELAY_PHA_HIGH          (0x00000001<<2)
+#define SD30_ASYNC_FIFO_RST		(0x00000001<<4)
+#define ACCESS_MODE_SDR       	(0x00000000)
+#define ACCESS_MODE_DDR        	(0x00000001)
+#define ACCESS_MODE_HS200       (0x00000002)
+#define ACCESS_MODE_HS400       (0x00000003)
+#define MODE_SEL_MASK          	(0x00000003<<2)
+#define MODE_SEL_SD20          	(ACCESS_MODE_SD20<<2)
+#define MODE_SEL_DDR          	(ACCESS_MODE_DDR<<2)
+#define MODE_SEL_SD30          	(ACCESS_MODE_SD30<<2)
+
+#define MASK_MODE_SELECT        (0x0c)
+#define MODE_SDR                (0x00) //sdr20/50
+#define MODE_DDR                (0x01<<2) //ddr50
+#define MODE_HS200              (0x02<<2) //hs-200
+#define MODE_HS400              (0x03<<2) //hs-400
+
+#define MASK_BUS_WIDTH          (0x00010001)
+#define BUS_WIDTH_1             (0x00000000)
+#define BUS_WIDTH_4             (0x00000001)
+#define BUS_WIDTH_8             (0x00010000)
+
+/* CPU_ACC_CTL 0x18012080 */
+#define CPU_MODE_EN             (0x00000001)
+#define BUF_FULL		(0x00000001<<2)
+
+/* SD_CONFIGURE2 0x18012181 */
+#define CRC7_CAL_DIS            (0x00000001<<7)
+#define CRC16_CAL_DIS           (0x00000001<<6)
+#define IGN_WR_CRC_ERR_EN	(0x00000001<<4)
+#define WAIT_BUSY_EN            (0x00000001<<3)
+#define CRC7_CHK_DIS            (0x00000001<<2)
+
+#define MASK_RESP_TYPE          (0x00000003)
+#define RESP_TYPE_NON           (0x00000000)
+#define RESP_TYPE_6B            (0x00000001)
+#define RESP_TYPE_17B           (0x00000002)
+
+/* SD_CONFIGURE3 0x18012182 */
+#define DATA_TRANS_OVER_EN      (0x00000001<<3)
+#define RESP_CHK_EN             (0x00000001<<2)
+#define ADDR_BYTE_MODE          (0x00000001<<1)
+#define SD_CMD_RSP_TO           (0x00000001<<0)
+
+/* SD_TRANSFER 0x18012193 */
+//98012044 : Raw Interrupt Status Register
+#define INT_STS_EBE		(1<<15)
+#define INT_STS_ACD		(1<<14)
+#define INT_STS_SBE_BCI		(1<<13)
+#define INT_STS_HLE		(1<<12)
+#define INT_STS_FRUN		(1<<11)
+#define INT_STS_HTO		(1<<10)
+#define INT_STS_DRTO_BDS	(1<<9)
+#define INT_STS_RTO_BAR		(1<<8)
+#define INT_STS_DCRC		(1<<7)
+#define INT_STS_RCRC		(1<<6)
+#define INT_STS_RXDR		(1<<5)
+#define INT_STS_TXDR		(1<<4)
+#define INT_STS_DTO		(1<<3)
+#define INT_STS_CD	  	(1<<2)
+#define INT_STS_RE		(1<<1)
+#define INT_STS_CRD		(1<<0)
+#define INT_STS_ERRORS		(INT_STS_RE|INT_STS_RCRC|INT_STS_DCRC|INT_STS_RTO_BAR|INT_STS_DRTO_BDS|INT_STS_HTO|INT_STS_FRUN|INT_STS_HLE|INT_STS_SBE_BCI|INT_STS_EBE)
+#define INT_STS_ERRORS2		(INT_STS_RE|INT_STS_RCRC|INT_STS_DCRC|INT_STS_DRTO_BDS|INT_STS_HTO|INT_STS_FRUN|INT_STS_HLE|INT_STS_SBE_BCI|INT_STS_EBE)
+
+
+#define INT_EN			(INT_STS_ACD|INT_STS_DTO|INT_STS_CD)
+
+//98012048 : Status Register
+#define STS_RSP_IDX_MASK       (0x3f<<11)
+#define STS_RSP_IDX            (11)
+
+#define STS_DATA_BUSY		(1<<9)
+#define STS_DATA_3_STATUS	(1<<8)
+
+//9801202c : command register
+#define CMD_IDX_MASK(x)		(x & 0x3f)
+#define CMD_IDX			(0x3f)
+#define CMD_RSP_EXP		(1<<6)
+#define CMD_RSP_LEN		(1<<7)
+#define CMD_CHK_RESP_CRC	(1<<8)
+#define CMD_DATA_EXP		(1<<9)
+#define CMD_RD_WR		(1<<10)
+#define CMD_TRANS_MODE		(1<<11)
+#define CMD_SEND_AUTO_STOP	(1<<12)
+#define CMD_WAIT_PRV_DATA_COMPLETE	(1<<13)
+#define CMD_USE_HOLD_REG	(1<<29)
+#define CMD_START_CMD		(1<<31)
+
+
+#define MASK_CMD_CODE           (0x0F)
+#define SD_NORMALWRITE          (0x00)
+#define SD_AUTOWRITE3           (0x01)
+#define SD_AUTOWRITE4           (0x02)
+#define SD_AUTOREAD3            (0x05)
+#define SD_AUTOREAD4            (0x06)
+#define SD_SENDCMDGETRSP        (0x08)
+#define SD_AUTOWRITE1           (0x09)
+#define SD_AUTOWRITE2           (0x0A)
+#define SD_NORMALREAD           (0x0C)
+#define SD_AUTOREAD1            (0x0D)
+#define SD_AUTOREAD2            (0x0E)
+#define SD_CMD_UNKNOW           (0x0F)
+
+#define EMMC_MASK_CMD_CODE        (0xFF)
+#define EMMC_NORMALWRITE          (0x00)
+#define EMMC_AUTOWRITE3           (0x01)
+#define EMMC_AUTOWRITE4           (0x02)
+#define EMMC_AUTOREAD3            (0x05)
+#define EMMC_AUTOREAD4            (0x06)
+#define EMMC_SENDCMDGETRSP        (0x08)
+#define EMMC_AUTOWRITE1           (0x09)
+#define EMMC_AUTOWRITE2           (0x0A)
+#define EMMC_NORMALREAD           (0x0C)
+#define EMMC_AUTOREAD1            (0x0D)
+#define EMMC_AUTOREAD2            (0x0E)
+#define EMMC_TUNING               (0x0F)
+#define EMMC_CMD_UNKNOW           (0x10)
+
+/* SD_CONFIGURE2 0x18012181 */
+#define CRC7_STATUS             (0x00000001<<7)
+#define CRC16_STATUS            (0x00000001<<6)
+#define WRT_ERR_BIT             (0x00000001<<5)
+#define CRC_TIMEOUT_ERR         (0x00000001<<1)
+#define PATTERN_CMP_ERR         (0x00000001<<0)
+#define WRITE_CRC_ERR_STAT(x)   ((x & (0x7<<2))>>2)
+/* SD_STATUS2 0x18012184 */
+#define SD_CMD_RESP_INVALID     (0x00000001<<1)
+#define SD_CMD_RESP_TIMEOUT     (0x00000001)
+/* SD_BUS_STATUS 0x18012185 */
+#define SD_CLK_TOG_EN     		(0x00000001<<7)
+#define SD_CLK_TOG_STOP     	(0x00000001<<6)
+#define SD_DAT3_0_LEVEL     	(0x0000000F<<1)
+#define SD_CMD_LEVEL     		(0x00000001<<0)
+
+
+#define WRITE_DATA              (0x1)
+#define CLR_WRITE_DATA          (0x0)
+#define SD_EMMC_INT_EN          (0x00000001<<2)
+#endif
diff --git a/drivers/mmc/host/reg_mmc_rtd119x.h b/drivers/mmc/host/reg_mmc_rtd119x.h
new file mode 100644
index 00000000..dfec005
--- /dev/null
+++ b/drivers/mmc/host/reg_mmc_rtd119x.h
@@ -0,0 +1,296 @@
+/*
+ *  Copyright (C) 2013 Realtek Semiconductors, All Rights Reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __REG_MMC_H
+#define __REG_MMC_H
+
+
+#define CR_BASE_ADDR            0x18010400
+#define EM_BASE_ADDR            0x18012000
+#define SDIO_BASE_ADDR          0x18010a00
+#define CR_DUMMY_SYS            0x1801042c
+
+/* ===== Realtek Card Reader Register Sets ===== */
+//System bridge2 (base = 0x1801A000)
+#define CR_SYNC                 	( 0x20	)
+
+//sd pll (base = 0x18000000)
+#define CR_SOFT_RESET2				( 0x4	)
+#define CR_PLL_SD1                 	( 0x1e0	)
+#define CR_PLL_SD2                 	( 0x1e4	)
+#define CR_PLL_SD3                 	( 0x1e8	)
+#define CR_PLL_SD4                 	( 0x1ec	)
+#define CR_PFUNC_CR                	( 0x380	)
+
+//sd wrapper (base = 0x18010400)
+#define CR_SRAM_CTL                 ( 0x0   )
+#define CR_DMA_CTL1                 ( 0x004 )
+#define CR_DMA_CTL2                 ( 0x008 )
+#define CR_DMA_CTL3                 ( 0x00C )
+#define CR_SD_ISR                   ( 0x024 )
+#define CR_SD_ISREN                 ( 0x028 )
+#define CR_SD_PAD_CTL           	( 0x074 )
+#define CR_SD_CKGEN_CTL             ( 0x078 )
+#define CR_IP_CARD_INT_EN           ( 0x120 )
+//emmc wrapper (base = 0x18012000)
+#define EMMC_SRAM_CTL               ( 0x0   )
+#define EMMC_DMA_CTL1               ( 0x004 )
+#define EMMC_DMA_CTL2               ( 0x008 )
+#define EMMC_DMA_CTL3               ( 0x00C )
+#define EMMC_SD_ISR                 ( 0x024 )
+#define EMMC_SD_ISREN               ( 0x028 )
+#define EMMC_PAD_CTL                ( 0x074 )
+#define EMMC_CKGEN_CTL              ( 0x078 )
+#define EMMC_CPU_ACC                ( 0x080 )
+#define EMMC_IP_CARD_INT_EN         ( 0x120 )
+#define EMMC_CARD_PAD_DRV           ( 0x130 )
+#define EMMC_CMD_PAD_DRV            ( 0x131 )
+#define EMMC_DATA_PAD_DRV           ( 0x132 )
+#define EMMC_SRAM_BASE_0            ( 0x200 )
+#define EMMC_SRAM_BASE_1            ( 0x300 )
+//sdio wrapper (base = 0x18010a00)
+#define SDIO_SRAM_CTL               ( 0x0   )
+#define SDIO_IP_CTL                 ( 0x010 )
+#define SDIO_SD_ISR                 ( 0x030 )
+#define SDIO_SD_ISREN               ( 0x034 )
+//sdio host standard (base = 0x18010c00)
+#define SDIO_NORML_INT_STA          ( 0x030 )
+
+//sd & emmc
+#define CR_CARD_STOP                ( 0x103 )
+#define CR_CARD_OE                	( 0x104 )
+#define CARD_SELECT                 ( 0x10e )
+#define CARD_EXIST                 	( 0x11f )
+#define CARD_INT_PEND	          	( 0x121 )
+#define CARD_CLOCK_EN_CTL          	( 0x129 )
+#define CARD_SD_CLK_PAD_DRIVE      	( 0x130 )
+#define CARD_SD_CMD_PAD_DRIVE      	( 0x131 )
+#define CARD_SD_DAT_PAD_DRIVE      	( 0x132 )
+#define SD_CONFIGURE1               ( 0x180 )
+#define SD_CONFIGURE2               ( 0x181 )
+#define SD_CONFIGURE3               ( 0x182 )
+#define SD_STATUS1                  ( 0x183 )
+#define SD_STATUS2                  ( 0x184 )
+#define SD_BUS_STATUS               ( 0x185 )
+#define SD_CMD_MODE                 ( 0x186 )
+#define SD_SAMPLE_POINT_CTL         ( 0x187 )
+#define SD_PUSH_POINT_CTL           ( 0x188 )
+#define SD_CMD0                     ( 0x189 )
+#define SD_CMD1                     ( 0x18A )
+#define SD_CMD2                     ( 0x18B )
+#define SD_CMD3                     ( 0x18C )
+#define SD_CMD4                     ( 0x18D )
+#define SD_CMD5                     ( 0x18E )
+#define SD_BYTE_CNT_L               ( 0x18F )
+#define SD_BYTE_CNT_H               ( 0x190 )
+#define SD_BLOCK_CNT_L              ( 0x191 )
+#define SD_BLOCK_CNT_H              ( 0x192 )
+#define SD_TRANSFER                 ( 0x193 )
+#define SD_DDR_DETECT_START         ( 0x194 )
+#define SD_CMD_STATE                ( 0x195 )
+#define SD_DATA_STATE               ( 0x196 )
+#define SD_BUS_TA_STATE             ( 0x197 )
+#define SD_STOP_SDCLK_CFG           ( 0x198 )
+#define SD_AUTO_RST_FIFO            ( 0x199 )
+#define SD_DAT_PAD                  ( 0x19A )
+#define SD_DUMMY_4                  ( 0x19B )
+#define SD_DUMMY_5                  ( 0x19C )
+#define SD_DUTY_CTL                 ( 0x19D )
+#define SD_SEQ_RW_CTL               ( 0x19E )
+#define SD_CONFIGURE4               ( 0x19F )
+#define SD_ADDR_L                   ( 0x1A0 )
+#define SD_ADDR_H                   ( 0x1A1 )
+#define SD_START_ADDR_0             ( 0x1A2 )
+#define SD_START_ADDR_1             ( 0x1A3 )
+#define SD_START_ADDR_2             ( 0x1A4 )
+#define SD_START_ADDR_3             ( 0x1A5 )
+#define SD_RSP_MASK_1               ( 0x1A6 )
+#define SD_RSP_MASK_2               ( 0x1A7 )
+#define SD_RSP_MASK_3               ( 0x1A8 )
+#define SD_RSP_MASK_4               ( 0x1A9 )
+#define SD_RSP_DATA_1               ( 0x1AA )
+#define SD_RSP_DATA_2               ( 0x1AB )
+#define SD_RSP_DATA_3               ( 0x1AC )
+#define SD_RSP_DATA_4               ( 0x1AD )
+#define SD_WRITE_DELAY              ( 0x1AE )
+#define SD_READ_DELAY               ( 0x1AF )
+
+#define CR_CARD_RESP6_0         SD_CMD0         //0x18012189
+#define CR_CARD_RESP6_1         SD_CMD1         //0x1801218a
+#define CR_CARD_RESP6_2         SD_CMD2         //0x1801218b
+#define CR_CARD_RESP6_3         SD_CMD3         //0x1801218c
+#define CR_CARD_RESP6_4         SD_CMD4         //0x1801218d
+#define CR_CARD_RESP6_5         SD_CMD5         //0x1801218e
+
+/* register item define */
+//for emmc pad 1.8v
+#define PLL_EMMC1		0x180001F0
+#define CR_PAD_CTL		(EM_BASE_ADDR+EMMC_PAD_CTL)
+
+/* CR_DMA_CTL3     0x18010503 */
+/* EMMC_DMA_CTL3 0x18012003 */
+
+#define RESP_LEN64                (0x1)
+#define RESP_LEN17                (0x2)
+#define DMA_XFER                (0x00000001)
+#define DDR_WR                  (0x00000001<<1)
+#define RSP17_SEL               (0x00000001<<4)
+#define RSP64_SEL               (0x00000001<<5)
+#define DAT64_SEL               (0x00000001<<5)
+
+/*CARD_EXIST 0x1801051f */
+#define SD_WRITE_PROTECT		(0x00000001<<5)
+#define XD_EXISTENCE			(0x00000001<<4)
+#define MS_EXISTENCE			(0x00000001<<3)
+#define SD_EXISTENCE			(0x00000001<<2)
+#define SM_EXISTENCE			(0x00000001<<1)
+
+
+/* SD_CONFIGURE1 0x18012180 */
+#define SDCLK_DIV                   (0x00000001<<7)
+#define SDCLK_NO_DIV                (0x00000000)
+#define SDCLK_DIV_128               (0x00000000)
+#define SDCLK_DIV_256               (0x00000001<<6)
+#define NO_RST_RDWR_FIFO            (0x00000000)
+#define RST_RDWR_FIFO               (0x00000001<<4)
+
+#define MASK_CLOCK_MODE         (0x00000003<<2)
+#define MASK_CLOCK_DIV          (0x00000003<<6)
+#define CLOCK_DIV_NON           (0x00000002)
+#define CLOCK_DIV_256           (0x00000001<<6)
+#define CLOCK_DIV_128           (0x00000000)
+#define EMMC_CLOCK_DIV_NON      (0x00000000)
+#define EMMC_CLOCK_DIV_256      (0x00000003<<6)
+#define EMMC_CLOCK_DIV_128      (0x00000002<<6)
+
+#define SPEED_MOD_HIGH          (0x00000001<<4)
+#define SPEED_MOD_NORM          (0x00000000)
+#define DELAY_PHA_MASK          (0x00000003<<2)
+#define DELAY_PHA_NORM          (0x00000001<<3)
+#define DELAY_PHA_HIGH          (0x00000001<<2)
+#define SD30_ASYNC_FIFO_RST		(0x00000001<<4)
+#define ACCESS_MODE_SD20       	(0x00000000)
+#define ACCESS_MODE_DDR        	(0x00000001)
+#define ACCESS_MODE_SD30       	(0x00000002)
+#define MODE_SEL_MASK          	(0x00000003<<2)
+#define MODE_SEL_SD20          	(ACCESS_MODE_SD20<<2)
+#define MODE_SEL_DDR          	(ACCESS_MODE_DDR<<2)
+#define MODE_SEL_SD30          	(ACCESS_MODE_SD30<<2)
+
+#define MASK_MODE_SELECT        (0x0c)
+#define MODE_SD20               (0x00) //sdr20/50
+#define MODE_DDR                (0x01<<2) //ddr50
+#define MODE_SD30               (0x02<<2) //hs-200
+
+#define MASK_BUS_WIDTH          (0x00000003)
+#define BUS_WIDTH_1             (0x00000000)
+#define BUS_WIDTH_4             (0x00000001)
+#define BUS_WIDTH_8             (0x00000002)
+#define DDR_BUS_WIDTH_4         (0x00000005)      /* Card is in 4 bit DDR mode */
+#define DDR_BUS_WIDTH_8         (0x00000006)      /* Card is in 8 bit DDR mode */
+
+/* CPU_ACC_CTL 0x18012080 */
+#define CPU_MODE_EN             (0x00000001)
+#define BUF_FULL		(0x00000001<<2)
+
+/* SD_CONFIGURE2 0x18012181 */
+#define CRC7_CAL_DIS            (0x00000001<<7)
+#define CRC16_CAL_DIS           (0x00000001<<6)
+#define IGN_WR_CRC_ERR_EN	(0x00000001<<4)
+#define WAIT_BUSY_EN            (0x00000001<<3)
+#define CRC7_CHK_DIS            (0x00000001<<2)
+
+#define MASK_RESP_TYPE          (0x00000003)
+#define RESP_TYPE_NON           (0x00000000)
+#define RESP_TYPE_6B            (0x00000001)
+#define RESP_TYPE_17B           (0x00000002)
+
+/* SD_CONFIGURE3 0x18012182 */
+#define DATA_TRANS_OVER_EN      (0x00000001<<3)
+#define RESP_CHK_EN             (0x00000001<<2)
+#define ADDR_BYTE_MODE          (0x00000001<<1)
+#define SD_CMD_RSP_TO           (0x00000001<<0)
+
+/* SD_TRANSFER 0x18012193 */
+#define START_EN                (0x00000001<<7)
+#define END_STATE               (0x00000001<<6)
+#define IDLE_STATE              (0x00000001<<5)
+#define ERR_STATUS              (0x00000001<<4)
+
+#define MASK_CMD_CODE           (0x0F)
+#define SD_NORMALWRITE          (0x00)
+#define SD_AUTOWRITE3           (0x01)
+#define SD_AUTOWRITE4           (0x02)
+#define SD_AUTOREAD3            (0x05)
+#define SD_AUTOREAD4            (0x06)
+#define SD_SENDCMDGETRSP        (0x08)
+#define SD_AUTOWRITE1           (0x09)
+#define SD_AUTOWRITE2           (0x0A)
+#define SD_NORMALREAD           (0x0C)
+#define SD_AUTOREAD1            (0x0D)
+#define SD_AUTOREAD2            (0x0E)
+#define SD_CMD_UNKNOW           (0x0F)
+
+#define EMMC_MASK_CMD_CODE        (0xFF)
+#define EMMC_NORMALWRITE          (0x00)
+#define EMMC_AUTOWRITE3           (0x01)
+#define EMMC_AUTOWRITE4           (0x02)
+#define EMMC_AUTOREAD3            (0x05)
+#define EMMC_AUTOREAD4            (0x06)
+#define EMMC_SENDCMDGETRSP        (0x08)
+#define EMMC_AUTOWRITE1           (0x09)
+#define EMMC_AUTOWRITE2           (0x0A)
+#define EMMC_NORMALREAD           (0x0C)
+#define EMMC_AUTOREAD1            (0x0D)
+#define EMMC_AUTOREAD2            (0x0E)
+#define EMMC_TUNING               (0x0F)
+#define EMMC_CMD_UNKNOW           (0x10)
+
+/* SD_CONFIGURE2 0x18012181 */
+#define CRC7_STATUS             (0x00000001<<7)
+#define CRC16_STATUS            (0x00000001<<6)
+#define WRT_ERR_BIT             (0x00000001<<5)
+#define CRC_TIMEOUT_ERR         (0x00000001<<1)
+#define PATTERN_CMP_ERR         (0x00000001<<0)
+#define WRITE_CRC_ERR_STAT(x)   ((x & (0x7<<2))>>2)
+/* SD_STATUS2 0x18012184 */
+#define SD_CMD_RESP_INVALID     (0x00000001<<1)
+#define SD_CMD_RESP_TIMEOUT     (0x00000001)
+/* SD_BUS_STATUS 0x18012185 */
+#define SD_CLK_TOG_EN     		(0x00000001<<7)
+#define SD_CLK_TOG_STOP     	(0x00000001<<6)
+#define SD_DAT3_0_LEVEL     	(0x0000000F<<1)
+#define SD_CMD_LEVEL     		(0x00000001<<0)
+
+
+#define WRITE_DATA              (0x1)
+#define CLR_WRITE_DATA          (0x0)
+/* CR_IP_CARD_INT_EN 0x18010520 */
+/* EMMC_IP_CARD_INT_EN 0x18012120 */
+#define SD_EMMC_INT_EN          (0x00000001<<2)
+
+/* CR_SD_ISR 0x18010424 */
+/* EMMC_SD_ISR 0x18012024 */
+#define ISRSTA_INT1             (0x00000001<<1) //card end
+#define ISRSTA_INT2             (0x00000001<<2) //card error
+#define ISRSTA_INT4             (0x00000001<<4) //DMA done
+/* SDIO_SD_ISR 0x18010a30 */
+#define SDIO_ISRSTA_INT1        (0x00000001<<1) //dma done
+#define SDIO_ISRSTA_INT2        (0x00000001<<2) //pre-transfer error
+#define SDIO_ISRSTA_INT3        (0x00000001<<3) //pcie crc if error
+#define SDIO_ISRSTA_INT4        (0x00000001<<4) //ip int
+
+/* CR_SD_ISREN 0x18010428 */
+/* EMMC_SD_ISREN 0x18012028 */
+#define ISRSTA_INT1EN           (0x00000001<<1) //card end
+#define ISRSTA_INT2EN           (0x00000001<<2) //card error
+#define ISRSTA_INT4EN           (0x00000001<<4) //DMA done
+/* SDIO_SD_ISREN 0x18010a34 */
+#define SDIO_ISRSTA_INT1EN      (0x00000001<<1) //sdio int1 enable
+
+#endif
diff --git a/drivers/mmc/host/reg_mmc_rtd13xx.h b/drivers/mmc/host/reg_mmc_rtd13xx.h
new file mode 100644
index 00000000..6b49705
--- /dev/null
+++ b/drivers/mmc/host/reg_mmc_rtd13xx.h
@@ -0,0 +1,379 @@
+/*
+ *  Copyright (C) 2013 Realtek Semiconductors, All Rights Reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __REG_MMC_H
+#define __REG_MMC_H
+
+/* eMMC control register definition */
+#define CR_BASE_ADDR            (0x00000000)  //map to 0x98012000
+
+//hank emmc ip register
+
+#define EMMC_SDMASA_R			     (CR_BASE_ADDR)
+#define EMMC_BLOCKSIZE_R		     (CR_BASE_ADDR + 0x004)
+#define EMMC_BLOCKCOUNT_R    		     (CR_BASE_ADDR + 0x006)
+#define EMMC_ARGUMENT_R      		     (CR_BASE_ADDR + 0x008)
+#define EMMC_XFER_MODE_R     		     (CR_BASE_ADDR + 0x00c)
+#define EMMC_CMD_R           		     (CR_BASE_ADDR + 0x00e)
+#define EMMC_RESP01_R        		     (CR_BASE_ADDR + 0x010)
+#define EMMC_RESP23_R        		     (CR_BASE_ADDR + 0x014)
+#define EMMC_RESP45_R        		     (CR_BASE_ADDR + 0x018)
+#define EMMC_RESP67_R        		     (CR_BASE_ADDR + 0x01c)
+#define EMMC_BUF_DATA_R			     (CR_BASE_ADDR + 0x020)
+#define EMMC_PSTATE_REG      		     (CR_BASE_ADDR + 0x024)
+#define EMMC_HOST_CTRL1_R		     (CR_BASE_ADDR + 0x028)
+#define EMMC_PWR_CTRL_R    		     (CR_BASE_ADDR + 0x029)
+#define EMMC_BGAP_CTRL_R		     (CR_BASE_ADDR + 0x02a)
+#define EMMC_CLK_CTRL_R			     (CR_BASE_ADDR + 0x02c)
+#define EMMC_TOUT_CTRL_R    		     (CR_BASE_ADDR + 0x02e)
+#define EMMC_SW_RST_R     		     (CR_BASE_ADDR + 0x02f)
+#define EMMC_NORMAL_INT_STAT_R		     (CR_BASE_ADDR + 0x030)
+#define EMMC_ERROR_INT_STAT_R		     (CR_BASE_ADDR + 0x032)
+#define EMMC_NORMAL_INT_STAT_EN_R    	     (CR_BASE_ADDR + 0x034)
+#define EMMC_ERROR_INT_STAT_EN_R      	     (CR_BASE_ADDR + 0x036)
+#define EMMC_NORMAL_INT_SIGNAL_EN_R  	     (CR_BASE_ADDR + 0x038)
+#define EMMC_ERROR_INT_SIGNAL_EN_R           (CR_BASE_ADDR + 0x03a)
+#define EMMC_AUTO_CMD_STAT_R           	     (CR_BASE_ADDR + 0x03c)
+#define EMMC_HOST_CTRL2_R                    (CR_BASE_ADDR + 0x03e)
+#define EMMC_ADMA_ERR_STAT_R		     (CR_BASE_ADDR + 0x054)
+#define EMMC_ADMA_SA_LOW_R                   (CR_BASE_ADDR + 0x058)
+#define EMMC_AT_CTRL_R                       (CR_BASE_ADDR + 0x240)
+
+#define EMMC_MSHC_CTRL_R                     (CR_BASE_ADDR + 0x208)
+#define EMMC_CMD_CONFLICT_CHECK              (1<<0)
+
+#define EMMC_CTRL_R			     (CR_BASE_ADDR + 0x22c)
+//hank emmc wrapper register
+#define EMMC_CP                       	(CR_BASE_ADDR + 0x41c)
+#define EMMC_OTHER1                     (CR_BASE_ADDR + 0x420)
+#define EMMC_ISR                        (CR_BASE_ADDR + 0x424)  //unused in hank
+#define EMMC_ISREN                      (CR_BASE_ADDR + 0x428)	//unused in hank
+#define EMMC_DUMMY_SYS                  (CR_BASE_ADDR + 0x42c)
+#define EMMC_AHB                  	(CR_BASE_ADDR + 0x430)
+#define EMMC_DBG                        (CR_BASE_ADDR + 0x444)
+#define EMMC_PP_BIST_CTL                (CR_BASE_ADDR + 0x460)
+#define EMMC_IP_BIST_CTL                (CR_BASE_ADDR + 0x464)
+#define EMMC_PP_BIST_STS                (CR_BASE_ADDR + 0x468)
+#define EMMC_IP_BIST_STS                (CR_BASE_ADDR + 0x46c)
+#define EMMC_CKGEN_CTL                	(CR_BASE_ADDR + 0x478)
+#define EMMC_CARD_SIG                   (CR_BASE_ADDR + 0x484)
+#define EMMC_DQS_CTRL1                  (CR_BASE_ADDR + 0x498)
+#define EMMC_DQS_CTRL2                  (CR_BASE_ADDR + 0x49c)
+#define EMMC_IP_DESC0                   (CR_BASE_ADDR + 0x4a0)
+#define EMMC_IP_DESC1                   (CR_BASE_ADDR + 0x4a4)
+#define EMMC_IP_DESC2                   (CR_BASE_ADDR + 0x4a8)
+#define EMMC_IP_DESC3                   (CR_BASE_ADDR + 0x4ac)
+#define EMMC_PROTECT0                   (CR_BASE_ADDR + 0x4c0)
+#define EMMC_PROTECT1                   (CR_BASE_ADDR + 0x4c4)
+#define EMMC_PROTECT2                   (CR_BASE_ADDR + 0x4c8)
+#define EMMC_PROTECT3                   (CR_BASE_ADDR + 0x4cc)
+#define EMMC_SWC_SEL_CHK                (CR_BASE_ADDR + 0x4e4)
+#define EMMC_DUMMY_SYS1                 (CR_BASE_ADDR + 0x500)
+#define EMMC_CLK_DET_PLLEMMC            (CR_BASE_ADDR + 0x504)
+#define EMMC_DQ_CTRL_SET                (CR_BASE_ADDR + 0x50c)
+#define EMMC_WDQ_CTRL0                  (CR_BASE_ADDR + 0x510)
+#define EMMC_WDQ_CTRL1                  (CR_BASE_ADDR + 0x514)
+#define EMMC_WDQ_CTRL2                  (CR_BASE_ADDR + 0x518)
+#define EMMC_WDQ_CTRL3                  (CR_BASE_ADDR + 0x51c)
+#define EMMC_WDQ_CTRL4                  (CR_BASE_ADDR + 0x520)
+#define EMMC_WDQ_CTRL5                  (CR_BASE_ADDR + 0x524)
+#define EMMC_WDQ_CTRL6                  (CR_BASE_ADDR + 0x528)
+#define EMMC_WDQ_CTRL7                  (CR_BASE_ADDR + 0x52c)
+#define EMMC_RDQ_CTRL0                  (CR_BASE_ADDR + 0x530)
+#define EMMC_RDQ_CTRL1                  (CR_BASE_ADDR + 0x534)
+#define EMMC_RDQ_CTRL2                  (CR_BASE_ADDR + 0x538)
+#define EMMC_RDQ_CTRL3                  (CR_BASE_ADDR + 0x53c)
+#define EMMC_RDQ_CTRL4                  (CR_BASE_ADDR + 0x540)
+#define EMMC_RDQ_CTRL5                  (CR_BASE_ADDR + 0x544)
+#define EMMC_RDQ_CTRL6                  (CR_BASE_ADDR + 0x548)
+#define EMMC_RDQ_CTRL7                  (CR_BASE_ADDR + 0x54c)
+#define EMMC_CMD_CTRL_SET		(CR_BASE_ADDR + 0x550)
+#define EMMC_WCMD_CTRL                  (CR_BASE_ADDR + 0x554)
+#define EMMC_RCMD_CTRL                  (CR_BASE_ADDR + 0x558)
+#define EMMC_PLL_STATUS                 (CR_BASE_ADDR + 0x55c)
+
+#define EMMC_PON_DES0                   (CR_BASE_ADDR + 0x800)
+#define EMMC_PON_DES1                   (CR_BASE_ADDR + 0x804)
+#define EMMC_PON_DES2                   (CR_BASE_ADDR + 0x808)
+#define EMMC_PON_CTRL                   (CR_BASE_ADDR + 0x80c)
+#define EMMC_PON_ID                     (CR_BASE_ADDR + 0x810)
+#define EMMC_PON_ADDR                   (CR_BASE_ADDR + 0x814)
+#define EMMC_PON_ST                     (CR_BASE_ADDR + 0x818)
+#define EMMC_PON_SAVE                   (CR_BASE_ADDR + 0x81c)
+#define EMMC_PON_DBUS_SLV               (CR_BASE_ADDR + 0x820)
+#define EMMC_PON_DBG_CTRL               (CR_BASE_ADDR + 0x824)
+#define EMMC_PON_DBUS_SLV_DBG           (CR_BASE_ADDR + 0x828)
+#define EMMC_PON_MEM                    (CR_BASE_ADDR + 0x82c)
+#define EMMC_PON_DBG0                   (CR_BASE_ADDR + 0x830)
+#define EMMC_PON_DBG1                   (CR_BASE_ADDR + 0x834)
+#define EMMC_PON_DBG2                   (CR_BASE_ADDR + 0x838)
+#define EMMC_PON_DBG3                   (CR_BASE_ADDR + 0x83c)
+#define EMMC_PON_DBG_CTRL1              (CR_BASE_ADDR + 0x840)
+
+#define EMMC_HD_SEM                     (CR_BASE_ADDR + 0x900)
+
+//0x98012030 status bitmap
+#define EMMC_ERR_INTERRUPT		1<<15
+#define EMMC_CQE_EVENT			1<<14
+#define EMMC_FX_EVENT			1<<13
+#define EMMC_RE_TUNE_EVENT		1<<12
+#define EMMC_INT_C			1<<11
+#define EMMC_INT_B                      1<<10
+#define EMMC_INT_A                      1<<9
+#define EMMC_CARD_INTERRUPT		1<<8
+#define EMMC_CARD_REMOVAL		1<<7
+#define EMMC_CARD_INSERTION             1<<6
+#define EMMC_BUF_RD_READY		1<<5
+#define EMMC_BUF_WR_READY               1<<4
+#define EMMC_DMA_INTERRPT		1<<3
+#define EMMC_BGAP_EVENT			1<<2
+#define EMMC_XFER_COMPLETE		1<<1
+#define EMMC_CMD_COMPLETE		1
+
+//0x98012032 error bitmap
+#define EMMC_VENDOR_ERR3		1<<15
+#define EMMC_VENDOR_ERR2                1<<14
+#define EMMC_VENDOR_ERR1                1<<13
+#define EMMC_BOOT_ACK_ERR               1<<12
+#define EMMC_RESP_ERR			1<<11
+#define EMMC_TUNING_ERR			1<<10
+#define EMMC_ADMA_ERR			1<<9
+#define EMMC_AUTO_CMD_ERR		1<<8
+#define EMMC_CUR_LMT_ERR		1<<7
+#define EMMC_DATA_END_BIT_ERR		1<<6
+#define EMMC_DATA_CRC_ERR		1<<5
+#define EMMC_DATA_TOUT_ERR		1<<4
+#define EMMC_CMD_IDX_ERR		1<<3
+#define EMMC_CMD_END_BIT_ERR		1<<2
+#define EMMC_CMD_CRC_ERR		1<<1
+#define EMMC_CMD_TOUT_ERR		1
+
+//0x98012034 status enable bitmap
+#define EMMC_CQE_EVENT_STAT_EN                  1<<14
+#define EMMC_FX_EVENT_STAT_EN                   1<<13
+#define EMMC_RE_TUNE_EVENT_STAT_EN              1<<12
+#define EMMC_INT_C_STAT_EN                      1<<11
+#define EMMC_INT_B_STAT_EN                      1<<10
+#define EMMC_INT_A_STAT_EN                      1<<9
+#define EMMC_CARD_INTERRUPT_STAT_EN             1<<8
+#define EMMC_CARD_REMOVAL_STAT_EN               1<<7
+#define EMMC_CARD_INSERTION_STAT_EN             1<<6
+#define EMMC_BUF_RD_READY_STAT_EN               1<<5
+#define EMMC_BUF_WR_READY_STAT_EN               1<<4
+#define EMMC_DMA_INTERRPT_STAT_EN               1<<3
+#define EMMC_BGAP_EVENT_STAT_EN                 1<<2
+#define EMMC_XFER_COMPLETE_STAT_EN              1<<1
+#define EMMC_CMD_COMPLETE_STAT_EN               1
+
+//0x98012036 error status enable bitmap
+#define EMMC_VENDOR_ERR_STAT_EN3                1<<15
+#define EMMC_VENDOR_ERR_STAT_EN2                1<<14
+#define EMMC_VENDOR_ERR_STAT_EN1                1<<13
+#define EMMC_BOOT_ACK_ERR_STAT_EN               1<<12
+#define EMMC_RESP_ERR_STAT_EN                   1<<11
+#define EMMC_TUNING_ERR_STAT_EN                 1<<10
+#define EMMC_ADMA_ERR_STAT_EN                   1<<9
+#define EMMC_AUTO_CMD_ERR_STAT_EN               1<<8
+#define EMMC_CUR_LMT_ERR_STAT_EN                1<<7
+#define EMMC_DATA_END_BIT_ERR_STAT_EN           1<<6
+#define EMMC_DATA_CRC_ERR_STAT_EN               1<<5
+#define EMMC_DATA_TOUT_ERR_STAT_EN              1<<4
+#define EMMC_CMD_IDX_ERR_STAT_EN                1<<3
+#define EMMC_CMD_END_BIT_ERR_STAT_EN            1<<2
+#define EMMC_CMD_CRC_ERR_STAT_EN                1<<1
+#define EMMC_CMD_TOUT_ERR_STAT_EN               1
+
+//0x98012038 signal interrupt enable
+#define EMMC_CQE_EVENT_SIGNAL_EN                  1<<14
+#define EMMC_FX_EVENT_SIGNAL_EN                   1<<13
+#define EMMC_RE_TUNE_EVENT_SIGNAL_EN              1<<12
+#define EMMC_INT_C_SIGNAL_EN                      1<<11
+#define EMMC_INT_B_SIGNAL_EN                      1<<10
+#define EMMC_INT_A_SIGNAL_EN                      1<<9
+#define EMMC_CARD_INTERRUPT_SIGNAL_EN             1<<8
+#define EMMC_CARD_REMOVAL_SIGNAL_EN               1<<7
+#define EMMC_CARD_INSERTION_SIGNAL_EN             1<<6
+#define EMMC_BUF_RD_READY_SIGNAL_EN               1<<5
+#define EMMC_BUF_WR_READY_SIGNAL_EN               1<<4
+#define EMMC_DMA_INTERRPT_SIGNAL_EN               1<<3
+#define EMMC_BGAP_EVENT_SIGNAL_EN                 1<<2
+#define EMMC_XFER_COMPLETE_SIGNAL_EN              1<<1
+#define EMMC_CMD_COMPLETE_SIGNAL_EN               1
+
+//0x9801203a error ssignal enable bitmap
+#define EMMC_VENDOR_ERR_SIGNAL_EN3                1<<15
+#define EMMC_VENDOR_ERR_SIGNAL_EN2                1<<14
+#define EMMC_VENDOR_ERR_SIGNAL_EN1                1<<13
+#define EMMC_BOOT_ACK_ERR_SIGNAL_EN               1<<12
+#define EMMC_RESP_ERR_SIGNAL_EN                   1<<11
+#define EMMC_TUNING_ERR_SIGNAL_EN                 1<<10
+#define EMMC_ADMA_ERR_SIGNAL_EN                   1<<9
+#define EMMC_AUTO_CMD_ERR_SIGNAL_EN               1<<8
+#define EMMC_CUR_LMT_ERR_SIGNAL_EN                1<<7
+#define EMMC_DATA_END_BIT_ERR_SIGNAL_EN           1<<6
+#define EMMC_DATA_CRC_ERR_SIGNAL_EN               1<<5
+#define EMMC_DATA_TOUT_ERR_SIGNAL_EN              1<<4
+#define EMMC_CMD_IDX_ERR_SIGNAL_EN                1<<3
+#define EMMC_CMD_END_BIT_ERR_SIGNAL_EN            1<<2
+#define EMMC_CMD_CRC_ERR_SIGNAL_EN                1<<1
+#define EMMC_CMD_TOUT_ERR_STAT_EN                 1
+
+#define EMMC_ALL_NORMAL_STAT_EN			  (0xfeff)
+#define EMMC_ALL_ERR_STAT_EN			  (0xffff)	//enablle all error interrupt in 0x98012036
+#define EMMC_ALL_SIGNAL_STAT_EN                   (0xfeff)
+#define EMMC_ALL_ERR_SIGNAL_EN			  (0xffff)	//enable all singal error interrupt in 0x9801203a
+
+
+#define CMD_IDX_MASK(x)         ((x >> 8)&0x3f)
+
+//0x9801200e
+#define EMMC_RESP_TYPE_SELECT	0
+#define EMMC_CMD_TYPE		6
+#define EMMC_NO_RESP		0x0
+#define EMMC_RESP_LEN_136	0x1
+#define EMMC_RESP_LEN_48	0x2
+#define EMMC_RESP_LEN_48B	0x3
+#define EMMC_CMD_CHK_RESP_CRC        	(1<<3)
+#define EMMC_CMD_IDX_CHK_ENABLE		(1<<4)
+#define EMMC_DATA			(1<<5)
+#define EMMC_ABORT_CMD		0x3
+#define EMMC_RESUME_CMD		0x2
+#define EMMC_SUSPEND_CMD	0x1
+#define EMMC_NORMAL_CMD		0x0
+
+//0x98012028
+#define EMMC_DMA_SEL		3
+#define EMMC_SDMA		0x0
+#define EMMC_ADMA2_32		0x2
+#define EMMC_ADMA2_64		0x3
+#define EMMC_EXT_DAT_XFER		(1<<5)
+#define EMMC_HIGH_SPEED_EN		(1<<2)
+#define EMMC_DAT_XFER_WIDTH		(1<<1)
+#define EMMC_BUS_WIDTH_8		EMMC_EXT_DAT_XFER
+#define EMMC_BUS_WIDTH_4		EMMC_DAT_XFER_WIDTH
+#define EMMC_BUS_WIDTH_1		0<<1
+
+//0x9801200c
+#define EMMC_MULTI_BLK_SEL		5
+#define EMMC_DATA_XFER_DIR		4
+#define EMMC_BLOCK_COUNT_ENABLE		(1<<1)
+#define EMMC_DMA_ENABLE			(1<<0)
+#define EMMC_AUTO_CMD_ENABLE		2
+#define EMMC_AUTO_CMD_DISABLED		0x0
+#define EMMC_AUTO_CMD12_ENABLED		0x1
+#define EMMC_AUTO_CMD23_ENABLED		0x2
+#define EMMC_AUTO_CMD_SEL		0x3
+
+//0x9801203e
+#define MODE_LEGACY	0x0
+#define MODE_SDR	0x1
+#define MODE_HS200	0x3
+#define MODE_DDR	0x4
+#define MODE_HS400	0x7
+
+#define EMMC_MASK_CMD_CODE        (0xFF)
+#define EMMC_NORMALWRITE          (0x00)
+#define EMMC_AUTOWRITE3           (0x01)
+#define EMMC_AUTOWRITE4           (0x02)
+#define EMMC_AUTOREAD3            (0x05)
+#define EMMC_AUTOREAD4            (0x06)
+#define EMMC_SENDCMDGETRSP        (0x08)
+#define EMMC_AUTOWRITE1           (0x09)
+#define EMMC_AUTOWRITE2           (0x0A)
+#define EMMC_NORMALREAD           (0x0C)
+#define EMMC_AUTOREAD1            (0x0D)
+#define EMMC_AUTOREAD2            (0x0E)
+#define EMMC_TUNING               (0x0F)
+#define EMMC_CMD_UNKNOW           (0x10)
+
+#define EMMC_SWC_SEL                    (0x0)
+#define EMMC_SWC_SEL1                   (0x4)
+#define EMMC_SWC_SEL2                   (0x8)
+#define EMMC_SWC_SEL3                   (0xc)
+
+#define EMMC_NAND_DMA_SEL		(0x54)
+
+#define EMMC_CLK_O_ICG_EN		(1<<3)
+#define EMMC_CARD_STOP_ENABLE		(1<<23)
+
+#define EMMC_SW_RST_DAT			(1<<2)
+
+#define EMMC_ISO_pfunc1		(0x20)
+#define EMMC_ISO_pfunc2         (0x24)
+#define EMMC_ISO_pfunc3         (0x28)
+#define EMMC_ISO_pfunc4         (0x2c)
+#define EMMC_ISO_pfunc5         (0x30)
+
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+//command queue related registers
+#define DCMD_SLOT 31
+#define NUM_SLOTS 32	//reserve slot 0 for pon
+/* 1 sec */
+#define HALT_TIMEOUT_MS 1000
+
+#define EMMC_CQCFG		(0x188)
+#define EMMC_CQCTL		(0x18c)
+#define EMMC_CQIS		(0x190)
+#define EMMC_CQIS_STAT_EN	(0x194)
+#define EMMC_CQIS_SIGNAL_EN	(0x198)
+#define EMMC_CQIC		(0x19c)
+#define EMMC_CQTDLBA		(0x1a0)
+#define EMMC_CQTDBR		(0x1a8)
+#define EMMC_CQTCN		(0x1ac)
+#define EMMC_CQDQS		(0x1b0)
+#define EMMC_CQDPT		(0x1b4)
+#define EMMC_CQTCLR		(0x1b8)
+#define EMMC_CQSSC1		(0x1c0)
+#define EMMC_CQSSC2		(0x1c4)
+#define EMMC_CQCRDCT		(0x1c8)
+#define EMMC_CQRMEM		(0x1d0)
+#define EMMC_CQTERRI		(0x1d4)
+#define EMMC_CQCRI		(0x1d8)
+#define EMMC_CQCRA		(0x1dc)
+
+#define EMMC_CQ_EN		(1<<0)
+#define EMMC_CQ_HALT		(1<<0)
+#define EMMC_TASK_DESC_SIZE	(1<<8)
+#define EMMC_DCMD_EN		(1<<12)
+
+#define VALID(x)        ((x & 1) << 0)
+#define END(x)          ((x & 1) << 1)
+#define INT(x)          ((x & 1) << 2)
+#define ACT(x)          ((x & 0x7) << 3)
+
+#define EMMC_CQIS_HAC        (1<<0)
+#define EMMC_CQIS_TCC        (1<<1)
+#define EMMC_CQIS_RED        (1<<2)
+#define EMMC_CQIS_TCL        (1<<3)
+
+/* data command task descriptor fields */
+#define FORCED_PROG(x)  ((x & 1) << 6)
+#define CONTEXT(x)      ((x & 0xF) << 7)
+#define DATA_TAG(x)     ((x & 1) << 11)
+#define DATA_DIR(x)     ((x & 1) << 12)
+#define PRIORITY(x)     ((x & 1) << 13)
+#define QBAR(x)         ((x & 1) << 14)
+#define REL_WRITE(x)    ((x & 1) << 15)
+#define BLK_COUNT(x)    ((x & 0xFFFF) << 16)
+#define BLK_ADDR(x)     ((x & 0xFFFFFFFF) << 32)
+
+/* direct command task descriptor fields */
+#define CMD_INDEX(x)    ((x & 0x3F) << 16)
+#define CMD_TIMING(x)   ((x & 1) << 22)
+#define RESP_TYPE(x)    ((x & 0x3) << 23)
+
+/* transfer descriptor fields */
+#define DAT_LENGTH(x)   ((x & 0xFFFF) << 16)
+#define DAT_ADDR_LO(x)  ((x & 0xFFFFFFFF) << 32)
+#define DAT_ADDR_HI(x)  ((x & 0xFFFFFFFF) << 0)
+
+#define EMMC_CQ_ALL_STAT_EN                   (0x3f)
+#define EMMC_CQ_ALL_SIGNAL_EN                 (0x3f)
+#endif
+
+#endif
diff --git a/drivers/mmc/host/reg_sys.h b/drivers/mmc/host/reg_sys.h
new file mode 100644
index 00000000..86b5c48
--- /dev/null
+++ b/drivers/mmc/host/reg_sys.h
@@ -0,0 +1,78 @@
+/*
+ * Realtek EMMC driver
+ *
+ * Authors:
+ * Copyright (C) 2017 Realtek Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+/************************************************************************
+ *
+ *  sys_reg.h
+ *
+ *  Defines for Phoenix CRT registers
+ *
+ ************************************************************************/
+
+#ifndef _REG_SYS_H
+#define _REG_SYS_H
+
+/* CRT */                                   
+#define SYS_REG_BASE			0x00000000    //0x98000000                               
+#define SYS_GROUP1_CK_EN		(SYS_REG_BASE + 0x014)
+#define SYS_GROUP1_CK_SEL		(SYS_REG_BASE + 0x018)
+#define SYS_SOFT_RESET1			(SYS_REG_BASE + 0x000)
+#define SYS_SOFT_RESET2			(SYS_REG_BASE + 0x004)
+#define SYS_SOFT_RESET3			(SYS_REG_BASE + 0x008)
+#define SYS_CLOCK_ENABLE1		(SYS_REG_BASE + 0x00c)
+#define SYS_CLOCK_ENABLE2		(SYS_REG_BASE + 0x010)
+#define SYS_NF_CKSEL            (SYS_REG_BASE + 0x038)
+#define	SYS_PLL_SCPU1 			(SYS_REG_BASE + 0x100)
+#define	SYS_PLL_SCPU2			(SYS_REG_BASE + 0x104)
+#define	SYS_PLL_SCPU3			(SYS_REG_BASE + 0x108)
+#define	SYS_PLL_ACPU1 			(SYS_REG_BASE + 0x10c)
+#define	SYS_PLL_ACPU2			(SYS_REG_BASE + 0x110)
+#define	SYS_PLL_VCPU1 			(SYS_REG_BASE + 0x114)
+#define	SYS_PLL_VCPU2			(SYS_REG_BASE + 0x118)
+#define	SYS_PLL_DISP_SD1		(SYS_REG_BASE + 0x11c)
+#define	SYS_PLL_DISP_SD4		(SYS_REG_BASE + 0x128)
+#define	SYS_PLL_REG_CTRL		(SYS_REG_BASE + 0x144)
+#define SYS_PLL_BUS 			(SYS_REG_BASE + 0x164)
+#define SYS_PLL_BUS2			(SYS_REG_BASE + 0x168)
+#define SYS_PLL_BUS3			(SYS_REG_BASE + 0x16c)
+#define	SYS_PLL_DISP_2_SD1		(SYS_REG_BASE + 0x174)
+#define	SYS_PLL_DCSB1    		(SYS_REG_BASE + 0x1b0)
+#define	SYS_PLL_DCSB2    		(SYS_REG_BASE + 0x1b4)
+#define	SYS_PLL_DCSB3    		(SYS_REG_BASE + 0x1b8)
+#define SYS_PLL_SD1             (SYS_REG_BASE + 0x1e0)
+#define SYS_PLL_SD2             (SYS_REG_BASE + 0x1e4)
+#define SYS_PLL_SD3             (SYS_REG_BASE + 0x1e8)
+#define SYS_PLL_SD4             (SYS_REG_BASE + 0x1ec)
+#define SYS_PLL_EMMC1           (SYS_REG_BASE + 0x1f0)
+#define SYS_PLL_EMMC2           (SYS_REG_BASE + 0x1f4)
+#define SYS_PLL_EMMC3           (SYS_REG_BASE + 0x1f8)
+#define SYS_PLL_EMMC4           (SYS_REG_BASE + 0x1fc)
+
+#define SYS_BG_CTL				(SYS_REG_BASE + 0x204)
+
+#define SYS_CHIP_INFO2			(SYS_REG_BASE + 0x308)
+#define SYS_PWDN_CTRL			(SYS_REG_BASE + 0x320)	//scpu_boot_info : scpu sent notify to acpu
+#define SYS_PWDN_CTRL2			(SYS_REG_BASE + 0x324)	//acpu_boot_info : acpu sent notify to kcpu
+#define SYS_PWDN_CTRL3			(SYS_REG_BASE + 0x328)	//scpu_boot_info_valid : b2
+#define SYS_PWDN_CTRL4			(SYS_REG_BASE + 0x32c)	//acpu_boot_info_valid : b2 
+
+#define SYS_DUMMY               (SYS_REG_BASE + 0x450)  //dummy register
+
+
+/*SB2 */                                   
+#define SB2_REG_BASE			0x00000000    //0x9801a000           
+#define SB2_muxpad2				(SB2_REG_BASE + 0x908)	//mux for arm,lextra ej-tag
+#define SB2_muxpad3				(SB2_REG_BASE + 0x90c)	//mux for arm,lextra ej-tag
+#define SB2_muxpad4				(SB2_REG_BASE + 0x910)	//mux for ej-tag
+#define SB2_muxpad5				(SB2_REG_BASE + 0x914)	//sf_en = 1, force gpio0-3 mux to spi pins
+
+
+#endif /* #ifndef _REG_SYS_H */
diff --git a/drivers/mmc/host/reg_sys_rtd119x.h b/drivers/mmc/host/reg_sys_rtd119x.h
new file mode 100644
index 00000000..67c4f50
--- /dev/null
+++ b/drivers/mmc/host/reg_sys_rtd119x.h
@@ -0,0 +1,75 @@
+/************************************************************************
+ *
+ *  sys_reg.h
+ *
+ *  Defines for Phoenix CRT registers
+ *
+ ************************************************************************/
+
+#ifndef _REG_SYS_H
+#define _REG_SYS_H
+
+/* CRT */                                   
+#define SYS_REG_BASE			0x18000000                                   
+
+#define SYS_GROUP1_CK_EN		(SYS_REG_BASE + 0x014)
+#define SYS_GROUP1_CK_SEL		(SYS_REG_BASE + 0x018)
+#define SYS_SOFT_RESET1			(SYS_REG_BASE + 0x000)
+#define SYS_SOFT_RESET2			(SYS_REG_BASE + 0x004)
+#define SYS_SOFT_RESET3			(SYS_REG_BASE + 0x008)
+#define SYS_CLOCK_ENABLE1		(SYS_REG_BASE + 0x00c)
+#define SYS_CLOCK_ENABLE2		(SYS_REG_BASE + 0x010)
+#define SYS_NF_CKSEL            (SYS_REG_BASE + 0x038)
+#define	SYS_PLL_SCPU1 			(SYS_REG_BASE + 0x100)
+#define	SYS_PLL_SCPU2			(SYS_REG_BASE + 0x104)
+#define	SYS_PLL_SCPU3			(SYS_REG_BASE + 0x108)
+#define	SYS_PLL_ACPU1 			(SYS_REG_BASE + 0x10c)
+#define	SYS_PLL_ACPU2			(SYS_REG_BASE + 0x110)
+#define	SYS_PLL_VCPU1 			(SYS_REG_BASE + 0x114)
+#define	SYS_PLL_VCPU2			(SYS_REG_BASE + 0x118)
+#define	SYS_PLL_DISP_SD1		(SYS_REG_BASE + 0x11c)
+#define	SYS_PLL_DISP_SD4		(SYS_REG_BASE + 0x128)
+#define	SYS_PLL_REG_CTRL		(SYS_REG_BASE + 0x144)
+#define SYS_PLL_BUS 			(SYS_REG_BASE + 0x164)
+#define SYS_PLL_BUS2			(SYS_REG_BASE + 0x168)
+#define SYS_PLL_BUS3			(SYS_REG_BASE + 0x16c)
+#define	SYS_PLL_DISP_2_SD1		(SYS_REG_BASE + 0x174)
+#define	SYS_PLL_DCSB1    		(SYS_REG_BASE + 0x1b0)
+#define	SYS_PLL_DCSB2    		(SYS_REG_BASE + 0x1b4)
+#define	SYS_PLL_DCSB3    		(SYS_REG_BASE + 0x1b8)
+#define SYS_PLL_SD1             (SYS_REG_BASE + 0x1e0)
+#define SYS_PLL_SD2             (SYS_REG_BASE + 0x1e4)
+#define SYS_PLL_SD3             (SYS_REG_BASE + 0x1e8)
+#define SYS_PLL_SD4             (SYS_REG_BASE + 0x1ec)
+#define SYS_PLL_EMMC1           (SYS_REG_BASE + 0x1f0)
+#define SYS_PLL_EMMC2           (SYS_REG_BASE + 0x1f4)
+#define SYS_PLL_EMMC3           (SYS_REG_BASE + 0x1f8)
+#define SYS_PLL_EMMC4           (SYS_REG_BASE + 0x1fc)
+
+#define SYS_BG_CTL				(SYS_REG_BASE + 0x204)
+
+#define SYS_CHIP_INFO2			(SYS_REG_BASE + 0x308)
+														//eg: when kcpu_boot_info is setting, then set kcpu_boot_info_valid to let ISO module to latch it
+#define SYS_PWDN_CTRL			(SYS_REG_BASE + 0x320)	//scpu_boot_info : scpu sent notify to acpu
+#define SYS_PWDN_CTRL2			(SYS_REG_BASE + 0x324)	//acpu_boot_info : acpu sent notify to kcpu
+#define SYS_PWDN_CTRL3			(SYS_REG_BASE + 0x328)	//scpu_boot_info_valid : b2
+#define SYS_PWDN_CTRL4			(SYS_REG_BASE + 0x32c)	//acpu_boot_info_valid : b2 
+
+#define SYS_muxpad0				(SYS_REG_BASE + 0x360)	//mux for nf
+#define SYS_muxpad1				(SYS_REG_BASE + 0x364)	//mux for cr
+#define SYS_muxpad2				(SYS_REG_BASE + 0x368)	//mux for arm,lextra ej-tag
+#define SYS_muxpad3				(SYS_REG_BASE + 0x36c)	//mux for arm,lextra ej-tag
+#define SYS_muxpad4				(SYS_REG_BASE + 0x370)	//mux for ej-tag
+#define SYS_muxpad5				(SYS_REG_BASE + 0x374)	//sf_en = 1, force gpio0-3 mux to spi pins
+#define SYS_DUMMY               (SYS_REG_BASE + 0x450)  //dummy register
+
+//wraper
+#define WRAP_A7_BASE            0x1801d400
+#define WRAP_L2_BIST_BISR_RSTN  (WRAP_A7_BASE)
+#define WRAP_HOLD_REMAP         (WRAP_A7_BASE+0x4)
+#define WRAP_SECOND_RUN_EN      (WRAP_A7_BASE+0x8)
+#define WRAP_DRF_BIST_BISR_MODE (WRAP_A7_BASE+0xc)
+#define WRAP_BISR_DONE          (WRAP_A7_BASE+0x18)
+#define WRAP_BISR_FAIL_GROUP    (WRAP_A7_BASE+0x24)
+
+#endif /* #ifndef _REG_SYS_H */
diff --git a/drivers/mmc/host/rtk-sdmmc-reg.h b/drivers/mmc/host/rtk-sdmmc-reg.h
new file mode 100644
index 00000000..3b1200f
--- /dev/null
+++ b/drivers/mmc/host/rtk-sdmmc-reg.h
@@ -0,0 +1,229 @@
+/*
+ * Realtek SD/MMC/mini SD card driver
+ *
+ * Authors:
+ * Copyright (C) 2017 Realtek Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+
+#ifndef DRIVERS_MMC_HOST_RTK_SDMMC_REG_H_
+#define DRIVERS_MMC_HOST_RTK_SDMMC_REG_H_
+
+// Card Reader Register Sets
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+#define GPDATI1			      (0x120)
+#endif
+
+#define SDMMC_SYNC                    (0x0020)
+
+#define CR_SOFT_RESET2                (0x0004)
+#define CR_PLL_SD1                    (0x01E0)
+#define CR_PLL_SD2                    (0x01E4)
+#define CR_PLL_SD3                    (0x01E8)
+#define CR_PLL_SD4                    (0x01EC)
+
+#ifdef CONFIG_ARCH_RTD119X
+#define CR_PFUNC_CR                   (0x0380)
+#else
+#define CR_PFUNC_CR                   (0x0610)
+#endif
+
+#define SDIO_NORML_INT_STA            (0x0030)
+#define EMMC_DMA_CTL3                 (0x000C)
+
+#define CR_SD_SRAM_CTL                (0x0000)
+#define CR_SD_DMA_CTL1                (0x0004)
+#define CR_SD_DMA_CTL2                (0x0008)
+#define CR_SD_DMA_CTL3                (0x000C)
+#define CR_SD_ISR                     (0x0024)
+#define CR_SD_ISREN                   (0x0028)
+#define CR_SD_PAD_CTL                 (0x0074)
+#define CR_SD_CKGEN_CTL               (0x0078)
+#define CR_SD_INT_EN                  (0x0120)
+
+#define CR_CARD_STOP                  (0x0103)
+#define CR_CARD_OE                    (0x0104)
+#define CARD_SELECT                   (0x010E)
+#define CARD_EXIST                    (0x011F)
+#define CARD_INT_PEND                 (0x0121)
+#define CARD_CLOCK_EN_CTL             (0x0129)
+#define CARD_SD_CLK_PAD_DRIVE         (0x0130)
+#define CARD_SD_CMD_PAD_DRIVE         (0x0131)
+#define CARD_SD_DAT_PAD_DRIVE         (0x0132)
+#define SD_CONFIGURE1                 (0x0180)
+#define SD_CONFIGURE2                 (0x0181)
+#define SD_CONFIGURE3                 (0x0182)
+#define SD_CONFIGURE4                 (0x019F)
+#define SD_STATUS1                    (0x0183)
+#define SD_STATUS2                    (0x0184)
+#define SD_BUS_STATUS                 (0x0185)
+#define SD_CMD_MODE                   (0x0186)
+#define SD_SAMPLE_POINT_CTL           (0x0187)
+#define SD_PUSH_POINT_CTL             (0x0188)
+#define SD_CMD0                       (0x0189)
+#define SD_CMD1                       (0x018A)
+#define SD_CMD2                       (0x018B)
+#define SD_CMD3                       (0x018C)
+#define SD_CMD4                       (0x018D)
+#define SD_CMD5                       (0x018E)
+#define SD_BYTE_CNT_L                 (0x018F)
+#define SD_BYTE_CNT_H                 (0x0190)
+#define SD_BLOCK_CNT_L                (0x0191)
+#define SD_BLOCK_CNT_H                (0x0192)
+#define SD_TRANSFER                   (0x0193)
+#define SD_DDR_DETECT_START           (0x0194)
+#define SD_CMD_STATE                  (0x0195)
+#define SD_DATA_STATE                 (0x0196)
+#define SD_BUS_TA_STATE               (0x0197)
+#define SD_STOP_SDCLK_CFG             (0x0198)
+#define SD_AUTO_RST_FIFO              (0x0199)
+#define SD_DAT_PAD                    (0x019A)
+#define SD_DUMMY_4                    (0x019B)
+#define SD_DUMMY_5                    (0x019C)
+#define SD_DUTY_CTL                   (0x019D)
+#define SD_SEQ_RW_CTL                 (0x019E)
+#define SD_ADDR_L                     (0x01A0)
+#define SD_ADDR_H                     (0x01A1)
+#define SD_START_ADDR0                (0x01A2)
+#define SD_START_ADDR1                (0x01A3)
+#define SD_START_ADDR2                (0x01A4)
+#define SD_START_ADDR3                (0x01A5)
+#define SD_RSP_MASK1                  (0x01A6)
+#define SD_RSP_MASK2                  (0x01A7)
+#define SD_RSP_MASK3                  (0x01A8)
+#define SD_RSP_MASK4                  (0x01A9)
+#define SD_RSP_DATA1                  (0x01AA)
+#define SD_RSP_DATA2                  (0x01AB)
+#define SD_RSP_DATA3                  (0x01AC)
+#define SD_RSP_DATA4                  (0x01AD)
+#define SD_WRITE_DELAY                (0x01AE)
+#define SD_READ_DELAY                 (0x01AF)
+
+#define CR_CARD_RESP6_0               (SD_CMD)
+#define CR_CARD_RESP6_1               (SD_CMD)
+#define CR_CARD_RESP6_2               (SD_CMD)
+#define CR_CARD_RESP6_3               (SD_CMD)
+#define CR_CARD_RESP6_4               (SD_CMD)
+#define CR_CARD_RESP6_5               (SD_CMD)
+
+#define RESP_LEN64                    (0x01)
+#define RESP_LEN17                    (0x02)
+#define DMA_XFER                      (0x01)
+#define DDR_WR                        (0x01 << 1)
+#define RSP17_SEL                     (0x01 << 4)
+#define RSP64_SEL                     (0x01 << 5)
+
+#define SD_WRITE_PROTECT              (0x01 << 5)
+#define SD_EXISTENCE                  (0x01 << 2)
+
+/* SD_CONFIGURE1 */
+#define SDCLK_DIV                     (0x01 << 7)
+#define SDCLK_NO_DIV                  (0x00)
+#define SDCLK_DIV_128                 (0x00)
+#define SDCLK_DIV_256                 (0x01 << 6)
+#define NO_RST_RDWR_FIFO              (0x00)
+#define RST_RDWR_FIFO                 (0x01 << 4)
+
+#define MASK_CLOCK_DIV                (0x03 << 6)
+#define CLOCK_DIV_NON                 (0x02)
+#define CLOCK_DIV_256                 (0x01 << 6)
+#define CLOCK_DIV_128                 (0x00)
+
+#define SPEED_HIGH                    (0x01 << 4)
+#define SPEED_NORM                    (0x00)
+#define DELAY_PHA_MASK                (0x03 << 2)
+#define DELAY_PHA_NORM                (0x01 << 3)
+#define DELAY_PHA_HIGH                (0x01 << 2)
+#define SD30_ASYNC_FIFO_RST           (0x01 << 4)
+#define ACCESS_MODE_SD20              (0x00)
+#define ACCESS_MODE_DDR               (0x01)
+#define ACCESS_MODE_SD30              (0x02)
+#define MODE_SEL_MASK                 (0x03 << 2)
+#define MODE_SEL_SD20                 (ACCESS_MODE_SD20 << 2)
+#define MODE_SEL_DDR                  (ACCESS_MODE_DDR << 2)
+#define MODE_SEL_SD30                 (ACCESS_MODE_SD30 << 2)
+
+#define MASK_BUS_WIDTH                (0x03)
+#define BUS_WIDTH_1                   (0x00)
+#define BUS_WIDTH_4                   (0x01)
+#define BUS_WIDTH_8                   (0x02)
+
+/* CPU_ACC_CTL */
+#define CPU_MODE_EN                   (0x01)
+#define BUF_FULL                      (0x01 << 2)
+
+/* SD_CONFIGURE2 */
+#define CRC7_CAL_DIS                  (0x01 << 7)
+#define CRC16_CAL_DIS                 (0x01 << 6)
+#define WAIT_BUSY_EN                  (0x01 << 3)
+#define CRC7_CHK_DIS                  (0x01 << 2)
+
+#define MASK_RESP_TYPE                (0x03)
+#define RESP_TYPE_NON                 (0x00)
+#define RESP_TYPE_6B                  (0x01)
+#define RESP_TYPE_17B                 (0x02)
+
+/* SD_CONFIGURE3 */
+#define DATA_TRANS_OVER_EN            (0x01 << 3)
+#define RESP_CHK_EN                   (0x01 << 2)
+#define ADDR_BYTE_MODE                (0x01 << 1)
+#define SD_CMD_RSP_TO                 (0x01 << 0)
+
+/* SD_TRANSFER */
+#define START_EN                      (0x01 << 7)
+#define END_STATE                     (0x01 << 6)
+#define IDLE_STATE                    (0x01 << 5)
+#define ERR_STATUS                    (0x01 << 4)
+
+#define MASK_CMD_CODE                 (0x0F)
+#define SD_NORMALWRITE                (0x00)
+#define SD_AUTOWRITE3                 (0x01)
+#define SD_AUTOWRITE4                 (0x02)
+#define SD_AUTOREAD3                  (0x05)
+#define SD_AUTOREAD4                  (0x06)
+#define SD_SENDCMDGETRSP              (0x08)
+#define SD_AUTOWRITE1                 (0x09)
+#define SD_AUTOWRITE2                 (0x0A)
+#define SD_NORMALREAD                 (0x0C)
+#define SD_AUTOREAD1                  (0x0D)
+#define SD_AUTOREAD2                  (0x0E)
+#define SD_CMD_UNKNOW                 (0x0F)
+
+/* SD_STATUS1 */
+#define CRC7_STATUS                   (0x01 << 7)
+#define CRC16_STATUS                  (0x01 << 6)
+#define WRT_ERR_BIT                   (0x01 << 5)
+#define CRC_TIMEOUT_ERR               (0x01 << 1)
+#define PATTERN_CMP_ERR               (0x01 << 0)
+#define WRITE_CRC_ERR_STAT(x)         ((x & (0x07 << 2)) >> 2)
+
+/* SD_STATUS2 */
+#define SD_CMD_RESP_INVALID           (0x01 << 1)
+#define SD_CMD_RESP_TIMEOUT           (0x01)
+
+/* SD_BUS_STATUS */
+#define SD_CLK_TOG_EN                 (0x01 << 7)
+#define SD_CLK_TOG_STOP               (0x01 << 6)
+#define SD_DAT3_0_LEVEL               (0x0F << 1)
+#define SD_CMD_LEVEL                  (0x01 << 0)
+
+#define WRITE_DATA                    (0x01)
+#define CLR_WRITE_DATA                (0x00)
+
+/* CR_IP_CARD_INT_EN */
+
+/* CR_SD_ISR */
+#define ISRSTA_INT1                   (0x01 << 1) //card end
+#define ISRSTA_INT2                   (0x01 << 2) //card error
+#define ISRSTA_INT4                   (0x01 << 4) //DMA done
+
+/* CR_SD_ISREN */
+#define ISRSTA_INT1EN                 (0x01 << 1) //card end
+#define ISRSTA_INT2EN                 (0x01 << 2) //card error
+#define ISRSTA_INT4EN                 (0x01 << 4) //DMA done
+
+#endif /* DRIVERS_MMC_HOST_RTK_SDMMC_REG_H_ */
diff --git a/drivers/mmc/host/rtk-sdmmc.c b/drivers/mmc/host/rtk-sdmmc.c
new file mode 100644
index 00000000..48b87c5
--- /dev/null
+++ b/drivers/mmc/host/rtk-sdmmc.c
@@ -0,0 +1,3996 @@
+/*
+ * Realtek SD/MMC/mini SD card driver
+ *
+ * Authors:
+ * Copyright (C) 2017 Realtek Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+
+#include <linux/blkdev.h>
+#include <linux/clk.h>
+#include <linux/debugfs.h>
+#include <linux/device.h>
+#include <linux/dma-mapping.h>
+#include <linux/err.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/seq_file.h>
+#include <linux/slab.h>
+#include <linux/stat.h>
+#include <linux/delay.h>
+#include <linux/irq.h>
+#include <linux/utsname.h>
+#include <linux/mmc/card.h>
+#include <linux/mmc/host.h>
+#include <linux/mmc/mmc.h>
+#include <linux/mmc/sd.h>
+#include <linux/mmc/sdio.h>
+#include <linux/mmc/slot-gpio.h>
+#include <linux/bitops.h>
+#include <linux/regulator/consumer.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/of.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/kthread.h>
+#include <soc/realtek/rtd129x_lockapi.h>
+#include <linux/pm_runtime.h>
+#include <linux/reset.h>
+
+#include "rtk-sdmmc-reg.h"
+#include "rtk-sdmmc.h"
+
+#define DRIVER_NAME "rtk-sdmmc"
+#define BANNER "Realtek SD/MMC Host Driver"
+
+#define SD_ALLOC_LENGTH 2048
+#define MAX_PHASE 31
+#define TUNING_CNT 3
+
+#define CMD25_WO_STOP_COMMAND
+
+#define PM_SD_SUSPEND_ON 0
+#define PM_SD_SUSPEND_FREEZE 1
+#define PM_SD_SUSPEND_STANDBY 2
+#define PM_SD_SUSPEND_MEM 3
+#define PM_SD_SUSPEND_MIN PM_SD_SUSPEND_FREEZE
+#define PM_SD_SUSPEND_MAX 4
+
+/*extern void set_gpio20_high(void);
+extern void set_gpio20_low(void);
+extern void set_gpio18_high(void);
+extern void set_gpio18_low(void);
+
+#define TOGGLE_GPIO_HIGH20	set_gpio20_high()
+#define TOGGLE_GPIO_LOW20	 set_gpio20_low()
+#define TOGGLE_GPIO_HIGH18	set_gpio18_high()
+#define TOGGLE_GPIO_LOW18	 set_gpio18_low()
+
+#ifndef TOGGLE_GPIO_HIGH20
+	#define TOGGLE_GPIO_HIGH20
+#endif
+#ifndef TOGGLE_GPIO_LOW20
+	#define TOGGLE_GPIO_LOW20
+#endif
+
+#ifndef TOGGLE_GPIO_HIGH18
+	#define TOGGLE_GPIO_HIGH18
+#endif
+#ifndef TOGGLE_GPIO_LOW18
+	#define TOGGLE_GPIO_LOW18
+#endif*/
+
+enum eINT_enable_mode {
+	CMD_RSP_ONLY = 0,
+	DATA_ONLY,
+	CMD_RSP_DATA_WRITE,
+	CMD_RSP_DATA_READ,
+	CMD_RSP_DATA_WRITE_TUNNING,
+	CMD_RSP_DATA_READ_TUNNING,
+	DATA_WRITE_ONLY,
+	DATA_READ_ONLY,
+};
+
+static volatile u32 data_xfer_mode;
+
+DECLARE_COMPLETION(rtk_sdmmc_wait);
+static int rtk_sdmmc_get_cd(struct mmc_host *host);
+static int rtk_sdmmc_send_stop_cmd(struct mmc_command *cmd, struct rtk_sdmmc_host *rtk_host,int flag);
+static int rtk_sdmmc_send_cmd_get_rsp(struct sdmmc_cmd_pkt *cmd_info);
+static int rtk_sdmmc_stream(struct sdmmc_cmd_pkt *cmd_info);
+static void rtk_sdmmc_hw_initial(struct rtk_sdmmc_host *rtk_host);
+static void rtk_sdmmc_timeout(unsigned long data);
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+static void rtk_sdmmc_plug(unsigned long data);
+#endif
+static void rtk_sdmmc_cmd12_fun(unsigned long data);
+static void rtk_sdmmc_set_access_mode(struct rtk_sdmmc_host *rtk_host,u8 level);
+void remove_sdcard(struct rtk_sdmmc_host *rtk_host);
+
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_MMC_RTK_EMMC
+int get_RTK_initial_flag(void);
+#endif
+#endif
+void rtk_sdmmc_sync(struct rtk_sdmmc_host *rtk_host);
+static void rtk_sdmmc_speed(struct rtk_sdmmc_host *rtk_host, enum sdmmc_clock_speed sd_speed);
+static unsigned int sd_in_receive_data_state; //CMD25_WO_STOP_COMMAND
+static unsigned int sd_current_blk_address; //CMD25_WO_STOP_COMMAND
+static u32 *dma_phy_addr = NULL;
+static u32 *dma_virt_addr = NULL;
+static unsigned int g_crinit = 0;
+static unsigned int sdmmc_rca = 0;
+static unsigned int mmc_detected = 0;
+static u8 g_cmd[6];
+bool suspend_SD_insert_flag=false;
+int poll = 0;
+int get_RTK_PM_STATE(void);
+int pre_cmd = 0;
+static volatile u32 wait_stop_command_irq_done;
+static volatile u32 do_stop_command_wo_complete;
+//static struct rw_semaphore cr_sd_rw_sem;
+static struct semaphore cr_sd_sem;
+
+#ifdef CMD25_WO_STOP_COMMAND
+struct task_struct *rtk_SD_task = NULL;
+struct mmc_command cmd12_stop_cmd;
+#endif
+
+#ifdef CONFIG_ARCH_RTD119X
+int get_manfid(void);
+int magic_num = 0xff;
+#endif
+
+struct rtk_sdmmc_host *rtk_global_host = NULL;
+void mmc_blk_set_ro(struct mmc_card* card);
+bool INT4_flag = false;
+bool CMD8_SD1 = false;
+bool CMD55_MMC = false;
+int driving_capacity = 0;
+bool suspend_flag = false;
+int mini_SD = 0;
+bool broken_flag = false;
+u32 g_ro = 0;
+int irq_error_bit=1;
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+int clk_disabled=0;
+bool re_initialize = false;
+void rtk_sdmmc_open_clk(struct mmc_host *host);
+void rtk_sdmmc_close_clk(struct mmc_host *host);
+#endif
+bool compatible_flag=false;
+static struct clk *clk_cr;
+static struct clk *clk_sd_ip;
+static struct reset_control *rstc_cr;
+
+int get_mmc_runtime_resume_flag(void);
+void set_mmc_runtime_resume_flag(int flag);
+//=============================================
+//static struct workqueue_struct *cmd12_qu;
+//static struct delayed_work rtk_cmd12_delayed_work;
+//=============================================
+
+void rtk_sdmmc_wait_stop_cmd_irq_done(void)
+{
+	unsigned long timeout;
+	unsigned int istimeout = 1;
+	timeout = jiffies + msecs_to_jiffies(100);
+
+	while( time_before(jiffies, timeout) ) {
+	//printk(KERN_ERR "<<%d>>(%d)\n", __LINE__, wait_stop_command_irq_done);
+		if ( wait_stop_command_irq_done == 0 ) {
+			istimeout = 0;
+			break;;
+		}
+	}
+
+	do_stop_command_wo_complete = 0;
+	if ( istimeout ) {
+		printk(KERN_ERR "****** WAIT wait_stop_command_irq_done TIMEOUT(%d,%d))\n",
+			do_stop_command_wo_complete, wait_stop_command_irq_done);\
+	}
+}
+
+void card_broken(struct rtk_sdmmc_host *rtk_host)
+{
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	printk(KERN_ERR "SD Card is broken!!!\n");
+
+	writel(0x0, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+	data_xfer_mode = CMD_RSP_ONLY;
+	writeb(0xff, sdmmc_base + CR_CARD_STOP); //SD Card module transfer stop and idle state
+	writeb(0x40, sdmmc_base + SD_BUS_STATUS);
+	mdelay(10);
+	writeb(0x3b, sdmmc_base + CARD_CLOCK_EN_CTL);
+	rtk_host->ops->card_power(rtk_host, 0);
+	rtk_sdmmc_sync(rtk_host);
+}
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+void remove_sdcard(struct rtk_sdmmc_host *rtk_host)
+{
+        void __iomem *sdmmc_base = rtk_host->sdmmc;
+        void __iomem *isopad_base = rtk_host->isopad;
+        u32 det_time = 0;
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	unsigned int tmp = 0;
+#endif
+
+	rtk_host->ins_event = EVENT_REMOV;
+	rtk_host->rtflags &= ~RTKCR_FCARD_DETECTED;
+	det_time = 1;
+
+	if(down_trylock(&cr_sd_sem)!=0);	//check if the lock is occupied, if not, then occupied
+	up(&cr_sd_sem);				//release the lock
+#if defined(CONFIG_ARCH_RTD13xx)
+	tmp = (0x003003) | (readl(isopad_base + 0x4c) & 0xff000000);
+	writel(tmp,isopad_base + 0x4c);
+
+	tmp = (0x003003<<4) | (readl(isopad_base + 0x50) & 0xf000000f);
+	writel(tmp,isopad_base + 0x50);
+
+	tmp = (0x003003) | (readl(isopad_base + 0x54) & 0xff000000);
+	writel(tmp,isopad_base + 0x54);
+#elif defined(CONFIG_ARCH_RTD16xx)
+	tmp = (0x3003003 << 4) | (readl(isopad_base + 0xc) & 0xf);
+	writel(tmp,isopad_base + 0xc);
+
+	writel(0x00300300,isopad_base + 0x10);
+
+	tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0x3;
+	writel(tmp,isopad_base + 0x14);
+#elif defined(CONFIG_ARCH_RTD139x)
+	writel(0x198CD99B,isopad_base + 0x34);
+	writel(0x000CF99F,isopad_base + 0x38);
+	writel(0x000CF99F,isopad_base + 0x3c);
+#endif
+	//mini_SD=0;
+	//broken_flag=false;
+	writel(0x0, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+	data_xfer_mode = CMD_RSP_ONLY;
+	writeb(0xff, sdmmc_base + CR_CARD_STOP); //SD Card module transfer stop and idle state
+
+	writeb(0x3b, sdmmc_base + CARD_CLOCK_EN_CTL);
+
+	rtk_host->ops->card_power(rtk_host, 0); //power off, Jim add
+	rtk_sdmmc_sync(rtk_host);
+
+	rtk_host->rtflags &= ~RTKCR_FCARD_SELECTED;
+	sdmmc_rca = 0;
+	mmc_detect_change(rtk_host->mmc, msecs_to_jiffies(det_time));
+}
+#else
+void remove_sdcard(struct rtk_sdmmc_host *rtk_host)
+{
+	u32 det_time = 0;
+#ifdef CONFIG_ARCH_RTD119X
+	unsigned long timeout = 0;
+#endif
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	rtk_host->ins_event = EVENT_REMOV;
+	rtk_host->rtflags &= ~RTKCR_FCARD_DETECTED;
+	det_time = 1;
+
+#ifdef CONFIG_ARCH_RTD119X
+	//reset
+	timeout = jiffies + msecs_to_jiffies(100);
+
+	while(time_before(jiffies, timeout)) {
+		if ((!(readl(rtk_host->emmc + EMMC_DMA_CTL3) & 0x01)) && (readb(rtk_host->sdio + SDIO_NORML_INT_STA) & 0x02)) {
+			break;
+		}
+	}
+#endif
+
+#ifndef CONFIG_ARCH_RTD119X
+	writel(readl(sdmmc_base + 0x20) & (~0x01), sdmmc_base + 0x20);	//modified by JIM 2016.9.1 for power saving, set L4 gated enabled
+	writel(readl(sdmmc_base + 0x20) | 0x00000001, sdmmc_base + 0x20);   //reset the DMA
+#endif
+
+	writel(0x0, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+	data_xfer_mode = CMD_RSP_ONLY;
+	writeb(0xff, sdmmc_base + CR_CARD_STOP); //SD Card module transfer stop and idle state
+
+	rtk_host->ops->card_power(rtk_host, 0); //power off, Jim add
+
+	rtk_sdmmc_sync(rtk_host);
+	rtk_host->rtflags &= ~RTKCR_FCARD_SELECTED;
+	sdmmc_rca = 0;
+	mmc_detect_change(rtk_host->mmc, msecs_to_jiffies(det_time));
+	rtk_host->int_status_old = 0x20;
+}
+#endif
+/*SYSCALL_DEFINE0(sdcard_unplug) {
+	printk(KERN_ERR "Simulation of  SD card unplug and plug!\n");
+	remove_sdcard(rtk_global_host);
+	return 0;
+}*/
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+static void rtk_sdmmc_shutdown(struct platform_device *pdev)
+{
+	u32 det_time = 0;
+	u32 reginfo = 0;
+	struct device *dev = &pdev->dev;
+	struct mmc_host *mmc = dev_get_drvdata(dev);
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(mmc);
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	printk(KERN_ERR "[SD] Realtek SD card reader shutdown!!\n");
+	del_timer_sync(&rtk_host->timer);
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+	del_timer_sync(&rtk_host->plug_timer);
+#endif
+	pm_runtime_force_suspend(dev);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	reginfo = readl(rtk_host->gpiodir+GPDATI1);
+	if(!(reginfo & 0x8)) {
+#else
+	reginfo = readb(sdmmc_base + CARD_EXIST);
+	if (reginfo & SD_EXISTENCE) {
+#endif
+		printk(KERN_ERR "[SD] Realtek SD turn off card power!!\n");
+		suspend_SD_insert_flag=true;
+		rtk_host->ins_event = EVENT_REMOV;
+		rtk_host->rtflags &= ~RTKCR_FCARD_DETECTED;
+		det_time = 1;
+#ifndef CONFIG_ARCH_RTD119X
+		writel(readl(sdmmc_base + 0x20) & (~0x01), sdmmc_base + 0x20);          //modified by JIM 2016.9.1 for power saving, set L4 gated enabled
+		writel(readl(sdmmc_base + 0x20) | 0x00000001, sdmmc_base + 0x20);   //reset the DMA
+#endif
+
+		writel(0x0, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+		data_xfer_mode = CMD_RSP_ONLY;
+		writeb(0xff, sdmmc_base + CR_CARD_STOP); //SD Card module transfer stop and idle state
+
+		rtk_host->ops->card_power(rtk_host, 0); //power off, Jim add
+
+		rtk_sdmmc_sync(rtk_host);
+		rtk_host->rtflags &= ~RTKCR_FCARD_SELECTED;
+		sdmmc_rca = 0;
+		mmc_detect_change(rtk_host->mmc, msecs_to_jiffies(det_time));
+	}
+}
+#endif
+
+#ifdef CONFIG_PM
+static int rtk_sdmmc_pm_suspend(struct device *dev)
+{
+	int ret = 0;
+	u32 det_time = 0;
+#ifdef CONFIG_ARCH_RTD119X
+	unsigned long timeout = 0;
+#endif
+	u32 reginfo = 0;
+	struct mmc_host *mmc = dev_get_drvdata(dev);
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(mmc);
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	suspend_flag = true;
+
+	if (get_RTK_PM_STATE() == PM_SD_SUSPEND_STANDBY)
+		printk(KERN_ERR "[SD] Realtek SD card reader idle suspend!!\n");
+	else
+		printk(KERN_ERR "[SD] Realtek SD card reader suspend to ram start!!\n");
+
+	del_timer_sync(&rtk_host->timer);
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+	del_timer_sync(&rtk_host->plug_timer);
+#endif
+#ifdef CMD25_WO_STOP_COMMAND
+	del_timer_sync(&rtk_host->rtk_sdmmc_stop_cmd);
+#endif
+
+	ret = pm_runtime_force_suspend(dev);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	reginfo = readl(rtk_host->gpiodir+GPDATI1);
+        if(!(reginfo & 0x8)) {
+#else
+	reginfo = readb(sdmmc_base + CARD_EXIST);
+	if (reginfo & SD_EXISTENCE) {
+#endif
+		printk(KERN_ERR "[SD] Realtek SD turn off card power!!\n");
+		suspend_SD_insert_flag=true;
+		rtk_host->ins_event = EVENT_REMOV;
+		rtk_host->rtflags &= ~RTKCR_FCARD_DETECTED;
+		det_time = 1;
+#ifdef CONFIG_ARCH_RTD119X
+		//reset
+		timeout = jiffies + msecs_to_jiffies(100);
+
+		while (time_before(jiffies, timeout)) {
+			if((!(readl(rtk_host->emmc + EMMC_DMA_CTL3) & 0x01)) && (readb(rtk_host->sdio + SDIO_NORML_INT_STA) & 0x02)){
+				break;
+			}
+		}
+#endif
+#ifndef CONFIG_ARCH_RTD119X
+		writel(readl(sdmmc_base + 0x20) & (~0x01), sdmmc_base + 0x20);		//modified by JIM 2016.9.1 for power saving, set L4 gated enabled
+		writel(readl(sdmmc_base + 0x20) | 0x00000001, sdmmc_base + 0x20);   //reset the DMA
+#endif
+		writel(0x0, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+		data_xfer_mode = CMD_RSP_ONLY;
+		writeb(0xff, sdmmc_base + CR_CARD_STOP); //SD Card module transfer stop and idle state
+
+		rtk_host->ops->card_power(rtk_host, 0); //power off, Jim add
+
+		rtk_sdmmc_sync(rtk_host);
+		rtk_host->rtflags &= ~RTKCR_FCARD_SELECTED;
+		sdmmc_rca = 0;
+		mmc_detect_change(rtk_host->mmc, msecs_to_jiffies(det_time));
+	} else {
+		suspend_SD_insert_flag=false;
+	}
+
+	return ret;
+}
+
+
+static int rtk_sdmmc_pm_resume(struct device *dev)
+{
+	int ret = 0;
+	u32 reginfo = 0;
+	u32 det_time = 0;
+	struct mmc_host *mmc = dev_get_drvdata(dev);
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(mmc);
+	void __iomem *pll_base = rtk_host->pll;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	if (get_RTK_PM_STATE() == PM_SD_SUSPEND_STANDBY)
+		printk(KERN_ERR "[SD] Realtek SD card reader idle resume OK!!\n");
+	else
+		printk(KERN_ERR "[SD] Realtek SD card reader resume OK!!\n");
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	re_initialize = false;
+	//in 1395 platform, system will turn off the SD clock if there is no SD card. Therefore, we must add this check for fear that invalid address access
+	reginfo = readl(rtk_host->gpiodir+GPDATI1);
+	if(reginfo & 0x8) {
+		reset_control_deassert(rstc_cr);
+		clk_prepare_enable(clk_cr);
+		clk_prepare_enable(clk_sd_ip);
+		writel(0x00000007, pll_base + CR_PLL_SD4);
+	}
+	else if(!(reginfo & 0x8) && suspend_SD_insert_flag==false) {	//this case is to handle that SD card is plugged during suspend
+		rtk_sdmmc_open_clk(mmc);
+		re_initialize = true;
+	}
+#endif
+	if (get_RTK_PM_STATE() == PM_SD_SUSPEND_STANDBY) {
+#ifdef CONFIG_ARCH_RTD119X
+		writel(0x003E0003, pll_base + CR_PLL_SD1);
+		mdelay(2);	//change 10 ms to 2ms to shorten suspend/resume timing issue
+#else
+		writel(0x0000003, pll_base + CR_PLL_SD1);
+		mdelay(2);	//change 10 ms to 2ms to shorten suspend/resume timing issue
+		writel(0x00002003, pll_base + CR_PLL_SD1); //PLL_SD1
+#endif
+	}
+	else
+		rtk_sdmmc_hw_initial(rtk_host); //suspend will cause poweroff and the SD PLL will be set as default, so we need to initial the SD PLL and clock before resume
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+        reginfo = readl(rtk_host->gpiodir+GPDATI1);
+        if(!(reginfo & 0x8) && suspend_SD_insert_flag==true) {
+#else
+	reginfo = readb(sdmmc_base + CARD_EXIST);
+	if ((reginfo & SD_EXISTENCE) && suspend_SD_insert_flag==true) {
+#endif
+		printk(KERN_ERR "[SD] Realtek SD turn on card power!!\n");
+		rtk_host->rtflags &= ~RTKCR_FCARD_DETECTED;
+		rtk_host->wp = 0;
+
+		rtk_host->ops->card_power(rtk_host, 1); //power on, Jim add
+
+		rtk_host->ins_event = EVENT_INSER;
+		rtk_host->rtflags |= RTKCR_FCARD_DETECTED;
+		det_time = 1;
+		writel(0x00000000, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+		data_xfer_mode = CMD_RSP_ONLY;
+		writeb(0x00, sdmmc_base + CR_CARD_STOP); //SD Card module transfer no stop
+		writeb(0x02, sdmmc_base + CARD_SELECT); //Specify the current active card module for the coming data transfer, bit 2:0 = 010
+		writeb(0x04, sdmmc_base + CR_CARD_OE); //arget module is SD/MMC card module, bit 2 =1
+		writeb(0x04, sdmmc_base + CARD_CLOCK_EN_CTL); //SD Card Module Clock Enable, bit 2 = 1
+		writeb(0xD0, sdmmc_base + SD_CONFIGURE1);
+
+		if (get_RTK_PM_STATE()!=PM_SD_SUSPEND_STANDBY) rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_400KHZ);
+
+		writeb(0x00, sdmmc_base + SD_STATUS2);
+		rtk_sdmmc_sync(rtk_host);
+		rtk_host->rtflags &= ~RTKCR_FCARD_SELECTED;
+		sdmmc_rca = 0;
+		mmc_detect_change(rtk_host->mmc, msecs_to_jiffies(det_time));
+	}
+
+	ret = pm_runtime_force_resume(dev);
+	setup_timer(&rtk_host->timer, rtk_sdmmc_timeout, (unsigned long)rtk_host);
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+	setup_timer(&rtk_host->plug_timer, rtk_sdmmc_plug, (unsigned long)rtk_host);
+#endif
+#ifdef CMD25_WO_STOP_COMMAND
+	setup_timer(&rtk_host->rtk_sdmmc_stop_cmd, rtk_sdmmc_cmd12_fun, (unsigned long)rtk_host);
+#endif
+	rtk_sdmmc_sync(rtk_host);
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+	mod_timer(&rtk_host->plug_timer, jiffies + 3*HZ);
+#endif
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	if(re_initialize==true) {	//this case is to handle that SD card is plugged during suspend
+		rtk_sdmmc_get_cd(mmc);
+		re_initialize = false;
+        }
+#endif
+	suspend_flag=false;
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	//in 1395 platform, we turn on the clk in the begining of resume process if no SD card, we have to close the clk after resume
+        if(reginfo & 0x8) {
+                writel(0x00000000, pll_base + CR_PLL_SD4);
+                clk_disable_unprepare(clk_cr);
+                clk_disable_unprepare(clk_sd_ip);
+		reset_control_assert(rstc_cr);
+        }
+#endif
+	return ret;
+}
+static const struct dev_pm_ops rtk_sdmmc_pm_ops = {
+        SET_SYSTEM_SLEEP_PM_OPS(rtk_sdmmc_pm_suspend, rtk_sdmmc_pm_resume)
+};
+#endif
+
+static void rtk_sdmmc_reset(struct rtk_sdmmc_host *rtk_host)
+{
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	writel(0x00000000, sdmmc_base + CR_SD_DMA_CTL3);
+	data_xfer_mode = CMD_RSP_ONLY;
+	writel(0x00000016, sdmmc_base + CR_SD_ISREN);
+	writel(0x00000007, sdmmc_base + CR_SD_ISREN);
+	writeb(0x00, sdmmc_base + SD_TRANSFER);
+	writeb(0xFF, sdmmc_base + CR_CARD_STOP); //SD Card module transfer stop and idle state.
+	writeb(0x00, sdmmc_base + CR_CARD_STOP); //SD Card module transfer start.
+}
+
+void rtk_sdmmc_sync(struct rtk_sdmmc_host *rtk_host) {
+	writel(0x00000000, rtk_host->sysbrdg + SDMMC_SYNC);
+}
+
+static u8 rtk_sdmmc_get_rsp_type(struct mmc_command* cmd)
+{
+	u32 rsp_type = 0;
+	u32 rsp_type_chk = mmc_resp_type(cmd);
+
+	if (rsp_type_chk == MMC_RSP_R1)
+		rsp_type = SD_R1;
+	else if (rsp_type_chk == MMC_RSP_R1B)
+		rsp_type = SD_R1b;
+	else if (rsp_type_chk == MMC_RSP_R2)
+		rsp_type = SD_R2;
+	else if (rsp_type_chk == MMC_RSP_R3)
+		rsp_type = SD_R3;
+	else if (rsp_type_chk == MMC_RSP_R6)
+		rsp_type = SD_R6;
+	else if (rsp_type_chk == MMC_RSP_R7)
+		rsp_type = SD_R7;
+	else
+		rsp_type = SD_R0;
+
+	return rsp_type;
+}
+
+static u8 rtk_sdmmc_get_rsp_len(u8 rsp_para)
+{
+	switch(rsp_para & 0x03) {
+	case 0:
+		return 0;
+	case 1:
+		return 6;
+	case 2:
+		return 16;
+	default:
+		return 0;
+	}
+}
+
+static u8 rtk_sdmmc_search_final_phase(struct rtk_sdmmc_host *rtk_host, u32 phase_map)
+{
+	struct timing_phase_path path[MAX_PHASE + 1];
+	struct timing_phase_path swap;
+	int i = 0;
+	int j = 0;
+	int k = 0;
+	int cont_path_cnt = 0;
+	int new_block = 1;
+	int max_len = 0;
+	int final_path_idx = 0;
+	u8 final_phase = 0xFF;
+
+	/* Parse phase_map, take it as a bit-ring */
+	for (i = 0 ; i < MAX_PHASE + 1 ; i++) {
+		if (phase_map & (1 << i)) {
+			if (new_block) {
+				new_block = 0;
+				j = cont_path_cnt++;
+				path[j].start = i;
+				path[j].end = i;
+			} else {
+				path[j].end = i;
+			}
+		} else {
+			new_block = 1;
+			if (cont_path_cnt) {
+				/* Calculate path length and middle point */
+				int idx = cont_path_cnt - 1;
+				path[idx].len = path[idx].end - path[idx].start + 1;
+				path[idx].mid = path[idx].start + path[idx].len / 2;
+			}
+		}
+	}
+
+	if (cont_path_cnt == 0) {
+		rtk_sdmmc_debug(" %s No continuous phase path\n", __func__);
+		goto finish;
+	} else {
+		/* Calculate last continuous path length and middle point */
+		int idx = cont_path_cnt - 1;
+		path[idx].len = path[idx].end - path[idx].start + 1;
+		path[idx].mid = path[idx].start + path[idx].len / 2;
+	}
+
+	/* Connect the first and last continuous paths if they are adjacent */
+	if (!path[0].start && (path[cont_path_cnt - 1].end == MAX_PHASE)) {
+		/* Using negative index */
+		path[0].start = path[cont_path_cnt - 1].start - MAX_PHASE - 1;
+		path[0].len += path[cont_path_cnt - 1].len;
+		path[0].mid = path[0].start + path[0].len / 2;
+		/* Convert negative middle point index to positive one */
+		if (path[0].mid < 0)
+			path[0].mid += MAX_PHASE + 1;
+		cont_path_cnt--;
+	}
+
+	/* Sorting path array,jamestai20141223 */
+	for (k = 0 ; k < cont_path_cnt ; ++k) {
+		for (i = 0 ; i < cont_path_cnt - 1 - k ; ++i) {
+			if (path[i].len < path[i+1].len) {
+				swap.end = path[i+1].end;
+				swap.len = path[i+1].len;
+				swap.mid = path[i+1].mid;
+				swap.start = path[i+1].start;
+
+				path[i+1].end = path[i].end;
+				path[i+1].len = path[i].len;
+				path[i+1].mid = path[i].mid;
+				path[i+1].start = path[i].start;
+
+				path[i].end = swap.end;
+				path[i].len = swap.len;
+				path[i].mid = swap.mid;
+				path[i].start = swap.start;
+			}
+		}
+	}
+
+	/* Choose the longest continuous phase path */
+	max_len = 0;
+	final_phase = 0;
+	final_path_idx = 0;
+	for (i = 0 ; i < cont_path_cnt ; i++) {
+		if (path[i].len > max_len) {
+			max_len = path[i].len;
+			if (max_len > 6)	//for compatibility issue, continue len should bigger than 6
+				final_phase = (u8)path[i].mid;
+			else
+				final_phase = 0xFF;
+			final_path_idx = i;
+		}
+
+		rtk_sdmmc_debug("%s path[%d].start = %d\n", __func__, i, path[i].start);
+		rtk_sdmmc_debug("%s path[%d].end = %d\n", __func__, i, path[i].end);
+		rtk_sdmmc_debug("%s path[%d].len = %d\n", __func__, i, path[i].len);
+		rtk_sdmmc_debug("%s path[%d].mid = %d\n", __func__, i, path[i].mid);
+	}
+
+finish:
+	rtk_sdmmc_debug("%s Final chosen phase: %d\n", __func__, final_phase);
+	return final_phase;
+}
+
+static int rtk_sdmmc_change_tx_phase(struct rtk_sdmmc_host *rtk_host, u8 sample_point)
+{
+	void __iomem *pll_base = rtk_host->pll;
+	unsigned int temp_reg = 0;
+	writel(readl(pll_base + 0x1E0)&0xfffffffd, pll_base + 0x1E0);
+	temp_reg = readl(pll_base + CR_PLL_SD1);
+	temp_reg = (temp_reg & ~0x000000F8) | (sample_point << 3);
+	writel(temp_reg,  pll_base + CR_PLL_SD1);
+	writel(readl(pll_base + 0x1E0)|0x2, pll_base + 0x1E0);
+	rtk_sdmmc_sync(rtk_host);
+	udelay(100);
+
+	return 0;
+}
+
+static int rtk_sdmmc_change_rx_phase(struct rtk_sdmmc_host *rtk_host, u8 sample_point)
+{
+	void __iomem *pll_base = rtk_host->pll;
+	unsigned int temp_reg = 0;
+	writel(readl(pll_base + 0x1E0)&0xfffffffd, pll_base + 0x1E0);
+	temp_reg = readl(pll_base + CR_PLL_SD1);
+	temp_reg = (temp_reg & ~0x00001F00) | (sample_point << 8);
+	writel(temp_reg, pll_base + CR_PLL_SD1);
+	writel(readl(pll_base + 0x1E0)|0x2, pll_base + 0x1E0);
+	rtk_sdmmc_sync(rtk_host);
+	udelay(100);
+
+	return 0;
+}
+
+static int rtk_sdmmc_tuning_tx_cmd(struct rtk_sdmmc_host *rtk_host, u8 sample_point)
+{
+	struct mmc_command cmd;
+	struct sdmmc_cmd_pkt cmd_info;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	rtk_sdmmc_change_tx_phase(rtk_host, sample_point);
+
+	memset(&cmd, 0x00, sizeof(struct mmc_command));
+	memset(&cmd_info, 0x00, sizeof(struct sdmmc_cmd_pkt));
+
+	cmd.opcode = MMC_SEND_STATUS;
+	cmd.arg = (sdmmc_rca << RCA_SHIFTER);
+	cmd_info.cmd = &cmd;
+	cmd_info.rtk_host = rtk_host;
+	cmd_info.rsp_para2 = 0x41;
+	cmd_info.rsp_len = rtk_sdmmc_get_rsp_len(0x41);
+
+	rtk_sdmmc_send_cmd_get_rsp(&cmd_info);
+	pre_cmd=cmd.opcode;
+
+	if (readb(sdmmc_base + SD_TRANSFER) & 0x10)
+		return -1;
+	return 0;
+}
+
+static int rtk_sdmmc_tuning_rx_cmd(struct rtk_sdmmc_host *rtk_host, u8 sample_point, struct scatterlist* p_sg)
+{
+	struct sdmmc_cmd_pkt cmd_info;
+	struct mmc_request mrq = {NULL};
+	struct mmc_command cmd = {0};
+	struct mmc_data data = {0};
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	rtk_sdmmc_change_rx_phase(rtk_host, sample_point);
+	mrq.cmd = &cmd;
+	mrq.data = &data;
+	mrq.cmd->data = mrq.data;
+	mrq.data->error = 0;
+	mrq.data->mrq = &mrq;
+
+	cmd.opcode = MMC_SEND_TUNING_BLOCK;
+	cmd.arg = 0;
+	cmd.flags = MMC_RSP_R1 | MMC_CMD_ADTC;
+
+	data.blksz = 64;
+	data.blocks = 1;
+	data.flags = MMC_DATA_READ;
+	data.sg = p_sg;
+	data.sg_len = 1;
+
+	mrq.cmd->error = 0;
+	mrq.cmd->mrq = &mrq;
+	mrq.cmd->data = mrq.data;
+	mrq.data->error = 0;
+	mrq.data->mrq = &mrq;
+
+	memset(&cmd_info, 0x00, sizeof(struct sdmmc_cmd_pkt));
+	cmd_info.cmd = mrq.cmd;
+	cmd_info.rtk_host = rtk_host;
+	cmd_info.rsp_para2 = rtk_sdmmc_get_rsp_type(cmd_info.cmd);
+	cmd_info.rsp_len = rtk_sdmmc_get_rsp_len(cmd_info.rsp_para2);
+	cmd_info.data = mrq.cmd->data;
+
+	rtk_sdmmc_stream(&cmd_info);
+	pre_cmd=cmd.opcode;
+
+	if (readb(sdmmc_base + SD_STATUS1) & 0x01)
+		return -1;
+
+	return 0;
+}
+
+static int rtk_sdmmc_tuning_tx(struct rtk_sdmmc_host *rtk_host)
+{
+	int sample_point;
+	int ret = 0;
+	int i = 0;
+	u32 raw_phase_map[TUNING_CNT] = {0};
+	u32 phase_map = 0;
+	u8 final_phase = 0;
+
+	for (sample_point = 0 ; sample_point <= MAX_PHASE ; sample_point++) {
+		for (i = 0 ; i < TUNING_CNT ; i++) {
+			if (!(rtk_host->rtflags & RTKCR_FCARD_DETECTED)) {
+				ret = -MMC_ERR_RMOVE;
+				goto out ;
+			}
+
+			ret = rtk_sdmmc_tuning_tx_cmd(rtk_host, (u8)sample_point);
+			if (0 == ret)
+				raw_phase_map[i] |= (1 << sample_point);
+		}
+	}
+
+	phase_map = 0xFFFFFFFF;
+	for (i = 0 ; i < TUNING_CNT ; i++) {
+		rtk_sdmmc_debug("%s TX raw_phase_map[%d] = 0x%08x\n", __func__, i, raw_phase_map[i]);
+		phase_map &= raw_phase_map[i];
+	}
+
+	printk(KERN_DEBUG "%s TX phase_map = 0x%08x\n", __func__, phase_map);
+
+	if (phase_map) {
+		final_phase = rtk_sdmmc_search_final_phase(rtk_host, phase_map);
+		rtk_sdmmc_debug("%s final phase = 0x%08x\n", __func__, final_phase);
+		if (final_phase == 0xFF) {
+			rtk_sdmmc_debug("%s final phase = 0x%08x\n", __func__, final_phase);
+			ret = -EINVAL;
+			goto out ;
+		}
+		rtk_sdmmc_change_tx_phase(rtk_host, final_phase);
+		ret = 0;
+		goto out ;
+	} else {
+		rtk_sdmmc_debug("%s  fail !phase_map\n", __func__);
+		ret = -EINVAL;
+		goto out ;
+	}
+
+out:
+	return ret;
+}
+
+static int rtk_sdmmc_tuning_rx(struct rtk_sdmmc_host *rtk_host)
+{
+	int sample_point = 0;
+	int ret = 0;
+	int i = 0;
+	u32 raw_phase_map[TUNING_CNT] = {0};
+	u32 phase_map = 0;
+	u8 final_phase = 0;
+	u8 *ssr;
+	struct scatterlist sg;
+
+	ssr = kmalloc(512, GFP_KERNEL | GFP_DMA);
+	if (!ssr)
+		return -ENOMEM;
+
+	sg_init_one(&sg, ssr, 512);
+	for (sample_point = 0 ; sample_point <= MAX_PHASE ; sample_point++) {
+		for (i = 0 ; i < TUNING_CNT ; i++) {
+			if (!(rtk_host->rtflags & RTKCR_FCARD_DETECTED)) {
+				ret = -MMC_ERR_RMOVE;
+				goto out ;
+			}
+
+			ret = rtk_sdmmc_tuning_rx_cmd(rtk_host, (u8)sample_point, &sg);
+			if (0 == ret)
+				raw_phase_map[i] |= (1 << sample_point);
+		}
+	}
+
+	phase_map = 0xFFFFFFFF;
+	for (i = 0 ; i < TUNING_CNT ; i++) {
+		rtk_sdmmc_debug("%s RX raw_phase_map[%d] = 0x%08x\n", __func__, i, raw_phase_map[i]);
+		phase_map &= raw_phase_map[i];
+	}
+	printk(KERN_DEBUG "%s RX phase_map = 0x%08x\n", __func__, phase_map);
+
+	if (phase_map) {
+		final_phase = rtk_sdmmc_search_final_phase(rtk_host, phase_map);
+		rtk_sdmmc_debug("%s final phase = 0x%08x\n", __func__, final_phase);
+		if (final_phase == 0xFF) {
+			rtk_sdmmc_debug("%s final phase = 0x%08x\n", __func__, final_phase);
+			ret = -EINVAL;
+			goto out ;
+		}
+		rtk_sdmmc_change_rx_phase(rtk_host, final_phase);
+		ret = 0;
+		goto out ;
+	} else {
+		rtk_sdmmc_debug("%s  fail !phase_map\n", __func__);
+		ret = -EINVAL;
+		goto out ;
+	}
+
+out:
+	kfree(ssr);
+	return ret;
+}
+
+static int rtk_sdmmc_wait_voltage_stable_low(struct rtk_sdmmc_host *rtk_host)
+{
+	u8 status = 0;
+	u8 i = 0;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	while(1) {
+		status = readb(sdmmc_base + SD_BUS_STATUS);
+		if ((status & (SD_DAT3_0_LEVEL | SD_CMD_LEVEL)) == 0x0)
+			break;
+		msleep(3);
+		if (i++>100)
+			break;
+	}
+
+	return 0;
+}
+
+static int rtk_sdmmc_wait_voltage_stable_high(struct rtk_sdmmc_host *rtk_host)
+{
+	u8 status = 0;
+	u8 i = 0;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	while (1) {
+		status = readb(sdmmc_base + SD_BUS_STATUS);
+		if ((status & (SD_DAT3_0_LEVEL | SD_CMD_LEVEL)) == (SD_DAT3_0_LEVEL | SD_CMD_LEVEL))
+			break;
+		msleep(3);
+		if (i++>100)
+			break;
+	}
+
+	return 0;
+}
+
+static void rtk_sdmmc_set_access_mode(struct rtk_sdmmc_host *rtk_host,u8 level)
+{
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	u32 tmp_bits = 0;
+	tmp_bits = readb(sdmmc_base + SD_CONFIGURE1) & ~MODE_SEL_MASK;
+
+	if (level == ACCESS_MODE_SD20)
+		tmp_bits |= MODE_SEL_SD20;
+	else if (level == ACCESS_MODE_DDR)
+		tmp_bits |= MODE_SEL_DDR;
+	else if (level == ACCESS_MODE_SD30)
+		tmp_bits |= (MODE_SEL_SD30 | SD30_ASYNC_FIFO_RST);
+	else
+		tmp_bits |= MODE_SEL_SD20;
+
+	writeb(tmp_bits, sdmmc_base + SD_CONFIGURE1);
+}
+
+static void rtk_sdmmc_set_bits(struct rtk_sdmmc_host *rtk_host, u8 set_bit)
+{
+	void  *sdmmc_base = rtk_host->sdmmc;
+	u32 tmp_bits = 0;
+	tmp_bits = readb(sdmmc_base + SD_CONFIGURE1);
+	if ((tmp_bits & MASK_BUS_WIDTH) != set_bit) {
+		tmp_bits &= ~MASK_BUS_WIDTH;
+		writeb(tmp_bits | set_bit, sdmmc_base + SD_CONFIGURE1);
+	}
+}
+
+static void rtk_sdmmc_set_div(struct rtk_sdmmc_host *rtk_host, u32 set_div) {
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	u8 tmp_div = 0;
+
+	rtk_sdmmc_sync(rtk_host);
+	tmp_div = readb(sdmmc_base + SD_CONFIGURE1) & ~MASK_CLOCK_DIV;
+	if (set_div != CLOCK_DIV_NON) {
+		writeb(tmp_div | set_div | SDCLK_DIV, sdmmc_base + SD_CONFIGURE1);
+	} else {
+		writeb(tmp_div, sdmmc_base + SD_CONFIGURE1);
+	}
+	rtk_sdmmc_sync(rtk_host);
+}
+
+static void rtk_sdmmc_set_speed(struct rtk_sdmmc_host *rtk_host, u8 level)
+{
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	switch (level) {
+	case 0: //ddr50 , highest speed
+		rtk_sdmmc_debug("%s: speed 2100\n", __func__);
+		writel(0x00002100, sdmmc_base + CR_SD_CKGEN_CTL);
+		break;
+	case 1:
+		rtk_sdmmc_debug("%s: speed 2101\n", __func__);
+		writel(0x00002101, sdmmc_base + CR_SD_CKGEN_CTL);
+		break;
+	case 2:
+		rtk_sdmmc_debug("%s: speed 2102\n", __func__);
+		writel(0x00002102, sdmmc_base + CR_SD_CKGEN_CTL);
+		break;
+	case 3:
+		rtk_sdmmc_debug("%s: speed 2103\n", __func__);
+		writel(0x00002103, sdmmc_base + CR_SD_CKGEN_CTL);
+		break;
+	default :
+		rtk_sdmmc_debug("%s: default speed 2102\n", __func__);
+		writel(0x00002102, sdmmc_base + CR_SD_CKGEN_CTL);
+		break;
+	}
+	rtk_sdmmc_sync(rtk_host);
+}
+
+static void rtk_sdmmc_speed(struct rtk_sdmmc_host *rtk_host, enum sdmmc_clock_speed sd_speed)
+{
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	unsigned int tmp=0;
+#endif
+
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	void __iomem *isopad_base = rtk_host->isopad;
+#elif defined(CONFIG_ARCH_RTD129x)
+	void __iomem *emmc_base = rtk_host->emmc;
+#endif
+	void __iomem *pll_base = rtk_host->pll;
+#ifdef CONFIG_ARCH_RTD129x
+	void __iomem *sysbrdg_base = rtk_host->sysbrdg;
+	unsigned long flags2;
+#endif
+
+	switch (sd_speed) {
+	case SDMMC_CLOCK_200KHZ:
+		rtk_sdmmc_debug("%s: speed SDMMC_CLOCK_200KHZ\n", __func__);
+		rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_256); //0x580 = 0xd0
+		rtk_sdmmc_set_speed(rtk_host, 1); //0x478 = 0x2101
+		break;
+	case SDMMC_CLOCK_400KHZ:
+		rtk_sdmmc_debug("%s: speed SDMMC_CLOCK_400KHZ\n", __func__);
+		rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_256); //0x580 = 0xd0
+		rtk_sdmmc_set_speed(rtk_host, 0); //0x478 = 0x2100
+		break;
+	case SDMMC_CLOCK_6200KHZ:
+		rtk_sdmmc_debug("%s: speed SDMMC_CLOCK_6200KHZ\n", __func__);
+		rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_NON); //0x580 = 0x10
+		rtk_sdmmc_set_speed(rtk_host, 3); //0x478 = 0x2103
+		break;
+	case SDMMC_CLOCK_25000KHZ:
+		rtk_sdmmc_debug("%s: speed SDMMC_CLOCK_25000KHZ\n", __func__);
+		if (rtk_host->mmc->ios.timing == MMC_TIMING_UHS_SDR12) {
+			rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_NON); //0x580 = 0x10
+			rtk_sdmmc_set_speed(rtk_host, 2); //0x478 = 0x2101
+		} else {
+			rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_NON); //0x580 = 0x10
+			rtk_sdmmc_set_speed(rtk_host, 1); //0x478 = 0x2101
+		}
+		break;
+	case SDMMC_CLOCK_50000KHZ:
+		rtk_sdmmc_debug("%s: speed SDMMC_CLOCK_50000KHZ\n", __func__);
+		if (rtk_host->mmc->ios.timing == MMC_TIMING_UHS_DDR50) {
+
+			//writel(readl(pll_base + CR_PLL_SD2) | 0x00000003, pll_base + CR_PLL_SD2); //PLL_SD2
+#ifdef CONFIG_ARCH_RTD119X
+			writeb(0X3F, sdmmc_base+CARD_SD_CLK_PAD_DRIVE);
+			writeb(0X3F, sdmmc_base+CARD_SD_CMD_PAD_DRIVE);
+			writeb(0X3F, sdmmc_base+CARD_SD_DAT_PAD_DRIVE);
+#endif
+			writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) | 0x00070000, sdmmc_base + CR_SD_CKGEN_CTL); //Switch SD source clock to 4MHz by Hsin-yin
+#ifdef CONFIG_ARCH_RTD129x
+			if (readl(sysbrdg_base+0x204)!=0x0)
+				writel(0x40000000,sdmmc_base+0x2c);
+#endif
+			writel(0x00000006, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+			writel(0x00324388,  pll_base + CR_PLL_SD3);
+			mdelay(2);
+			writel(0x00000007, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+			udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+			if (readl(sysbrdg_base+0x204)!=0x0)
+				writel(0x00000000,sdmmc_base+0x2c);
+#endif
+			writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) & 0xFFF8FFFF, sdmmc_base + CR_SD_CKGEN_CTL); //Switch SD source clock to normal clock source by Hsin-yin
+			writeb(readb(sdmmc_base + SD_CONFIGURE1) & 0xEF, sdmmc_base + SD_CONFIGURE1); //Reset FIFO pointer by Hsin-yin
+			rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_NON); //0x580 = 0x10
+			rtk_sdmmc_set_speed(rtk_host, 0); //0x478 = 0x2100
+		} else if (rtk_host->mmc->ios.timing == MMC_TIMING_UHS_SDR25) {
+			rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_NON); //0x580 = 0x10
+			rtk_sdmmc_set_speed(rtk_host, 1); //0x478 = 0x2101
+		} else {
+			rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_NON); //0x580 = 0x10
+			rtk_sdmmc_set_speed(rtk_host, 0); //0x478 = 0x2100
+		}
+		break;
+	case SDMMC_CLOCK_100000KHZ:
+		rtk_sdmmc_debug("%s: speed SDMMC_CLOCK_100000KHZ\n", __func__);
+
+#if defined(CONFIG_ARCH_RTD13xx)
+		tmp = (0x243243) | (readl(isopad_base + 0x4c) & 0xff000000);
+		writel(tmp,isopad_base + 0x4c);
+
+		tmp = (0x243243<<4) | (readl(isopad_base + 0x50) & 0xf000000f);
+		writel(tmp,isopad_base + 0x50);
+
+		tmp = (0x243243) | (readl(isopad_base + 0x54) & 0xff000000);
+		writel(tmp,isopad_base + 0x54);
+#elif defined(CONFIG_ARCH_RTD16xx)
+		tmp = (0x3483483 << 4) | (readl(isopad_base + 0xc) & 0xf);
+		writel(tmp,isopad_base + 0xc);
+
+		writel(0x48348348,isopad_base + 0x10);
+
+		tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0x483;
+		writel(tmp,isopad_base + 0x14);
+#elif defined(CONFIG_ARCH_RTD139x)
+		writel(0x198CD99B,isopad_base + 0x34);
+		writel(0x000CF99F,isopad_base + 0x38);
+		writel(0x000CF99F,isopad_base + 0x3c);
+#elif defined(CONFIG_ARCH_RTD129x)
+		rtk_lockapi_lock(flags2, __FUNCTION__);
+		writel(0x00005555, emmc_base + 0x634);
+		writel(0x55555555, emmc_base + 0x638);
+		rtk_lockapi_unlock(flags2, __FUNCTION__);
+#elif defined(CONFIG_ARCH_RTD119X)
+		writeb(0x3F, sdmmc_base+CARD_SD_CLK_PAD_DRIVE);
+		writeb(0x3F, sdmmc_base+CARD_SD_CMD_PAD_DRIVE);
+		writeb(0x3F, sdmmc_base+CARD_SD_DAT_PAD_DRIVE);
+#endif
+		rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_NON); //0x580 = 0x10
+		rtk_sdmmc_set_speed(rtk_host, 0); //0x478 = 0x2100
+		break;
+	case SDMMC_CLOCK_208000KHZ:
+		rtk_sdmmc_debug("%s: speed SDMMC_CLOCK_208000KHZ\n", __func__);
+#if defined(CONFIG_ARCH_RTD119X)
+                if(magic_num == 0x0 || magic_num == 0x1){
+			writeb(0X3F, sdmmc_base+CARD_SD_CLK_PAD_DRIVE);
+			writeb(0X3F, sdmmc_base+CARD_SD_CMD_PAD_DRIVE);
+			writeb(0X3F, sdmmc_base+CARD_SD_DAT_PAD_DRIVE);
+
+			rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_NON); //0x580 = 0x10
+			rtk_sdmmc_set_speed(rtk_host, 0);                  //0x478 = 0x2100
+		}else{
+			writeb(0Xbb, sdmmc_base+CARD_SD_CLK_PAD_DRIVE);
+			writeb(0Xbb, sdmmc_base+CARD_SD_CMD_PAD_DRIVE);
+			writeb(0Xbb, sdmmc_base+CARD_SD_DAT_PAD_DRIVE);
+			if(get_manfid()==0x3) {
+				writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) | 0x00070000, sdmmc_base + CR_SD_CKGEN_CTL); //Switch SD source clock to 4MHz by Hsin-yin
+				writel(0x00a54388, sdmmc_base + CR_PLL_SD3);      //bus clock to 208MHz jamestai20150319
+                        }
+			else{
+				writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) | 0x00070000, sdmmc_base + CR_SD_CKGEN_CTL); //Switch SD source clock to 4MHz by Hsin-yin
+                                writel( 0x00b64388, sdmmc_base + CR_PLL_SD3);      //bus clock to 208MHz jamestai20150319
+			}
+		}
+		udelay(2);
+#elif defined(CONFIG_ARCH_RTD129x)
+		rtk_lockapi_lock(flags2, __FUNCTION__);
+		switch(driving_capacity%10) {
+		case 0:
+		case 1:
+			writel(0x0000aaaa, emmc_base + 0x634);           //JIM modified this part for dyamically adjusting driving capacity
+			writel(0xaaaaaaaa, emmc_base + 0x638);
+			break;
+		case 2:
+		case 3:
+			writel(0x0000bbbb, emmc_base + 0x634);
+			writel(0xbbbbbbbb, emmc_base + 0x638);
+			break;
+		case 4:
+		case 5:
+			writel(0x0000cccc, emmc_base + 0x634);
+			writel(0xcccccccc, emmc_base + 0x638);
+			break;
+		case 6:
+		case 7:
+			writel(0x0000dddd, emmc_base + 0x634);
+			writel(0xdddddddd, emmc_base + 0x638);
+			break;
+		case 8:
+		case 9:
+			writel(0x0000eeee, emmc_base + 0x634);
+			writel(0xeeeeeeee, emmc_base + 0x638);
+			break;
+		default:
+			writel(0x0000aaaa, emmc_base + 0x634);
+			writel(0xaaaaaaaa, emmc_base + 0x638);
+		}
+
+		rtk_lockapi_unlock(flags2, __FUNCTION__);
+#elif defined(CONFIG_ARCH_RTD139x)
+		writeb(0xd,sdmmc_base + SD_BUS_TA_STATE);
+		switch(driving_capacity%10) {
+                case 0:
+                case 1:
+			writel(0x19A65CCB,isopad_base + 0x34);
+                        writel(0x00267CCF,isopad_base + 0x38);
+                        writel(0x00267CCF,isopad_base + 0x3c);
+                        break;
+                case 2:
+                case 3:
+			writel(0x19AA9D53,isopad_base + 0x34);
+                        writel(0x002ABD57,isopad_base + 0x38);
+                        writel(0x002ABD57,isopad_base + 0x3c);
+                        break;
+                case 4:
+                case 5:
+			writel(0x19AEDDDB,isopad_base + 0x34);
+                        writel(0x002EFDDF,isopad_base + 0x38);
+                        writel(0x002EFDDF,isopad_base + 0x3c);
+                        break;
+                case 6:
+                case 7:
+			writel(0x19B31E63,isopad_base + 0x34);
+                        writel(0x00333E67,isopad_base + 0x38);
+                        writel(0x00333E67,isopad_base + 0x3c);
+                        break;
+		case 8:
+                case 9:
+			writel(0x19B75EEB,isopad_base + 0x34);
+                        writel(0x00377EEF,isopad_base + 0x38);
+                        writel(0x00377EEF,isopad_base + 0x3c);
+                        break;
+                default:
+			writel(0x19A65CCB,isopad_base + 0x34);
+                        writel(0x00267CCF,isopad_base + 0x38);
+                        writel(0x00267CCF,isopad_base + 0x3c);
+                }
+#elif defined(CONFIG_ARCH_RTD16xx)
+		writeb(0xd,sdmmc_base + SD_BUS_TA_STATE);
+		switch(driving_capacity%10) {
+		case 0:
+		case 1:
+		/*	tmp = (0x3243243 << 4) | (readl(isopad_base + 0xc) & 0xf);
+			writel(tmp,isopad_base + 0xc);
+
+			writel(0x24324324,isopad_base + 0x10);
+
+			tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0x243;
+			writel(tmp,isopad_base + 0x14);
+			break;*/
+		case 2:
+		case 3:
+	/*		tmp = (0x3483483 << 4) | (readl(isopad_base + 0xc) & 0xf);
+			writel(tmp,isopad_base + 0xc);
+
+			writel(0x48348348,isopad_base + 0x10);
+
+			tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0x483;
+			writel(tmp,isopad_base + 0x14);
+			break;*/
+			tmp = (0x36c36c3 << 4) | (readl(isopad_base + 0xc) & 0xf);
+			writel(tmp,isopad_base + 0xc);
+
+			writel(0x6c36c36c,isopad_base + 0x10);
+
+			tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0x6c3;
+			writel(tmp,isopad_base + 0x14);
+			break;
+		case 4:
+		case 5:
+		case 6:
+			tmp = (0x3903903 << 4) | (readl(isopad_base + 0xc) & 0xf);
+			writel(tmp,isopad_base + 0xc);
+
+			writel(0x90390390,isopad_base + 0x10);
+
+			tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0x903;
+			writel(tmp,isopad_base + 0x14);
+			break;
+		case 7:
+		case 8:
+		case 9:
+			tmp = (0x3b43b43 << 4) | (readl(isopad_base + 0xc) & 0xf);
+			writel(tmp,isopad_base + 0xc);
+
+			writel(0xb43b43b4,isopad_base + 0x10);
+
+			tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0xb43;
+			writel(tmp,isopad_base + 0x14);
+			break;
+		default:
+			tmp = (0x3243243 << 4) | (readl(isopad_base + 0xc) & 0xf);
+			writel(tmp,isopad_base + 0xc);
+
+			writel(0x24324324,isopad_base + 0x10);
+
+			tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0x243;
+			writel(tmp,isopad_base + 0x14);
+		}
+#elif CONFIG_ARCH_RTD13xx
+                writeb(0xd,sdmmc_base + SD_BUS_TA_STATE);
+                switch(driving_capacity%10) {
+                case 0:
+                case 1:
+                case 2:
+			/*tmp = (0x243243) | (readl(isopad_base + 0x4c) & 0xff000000);
+			writel(tmp,isopad_base + 0x4c);
+
+			tmp = (0x243243<<4) | (readl(isopad_base + 0x50) & 0xf000000f);
+			writel(tmp,isopad_base + 0x50);
+
+			tmp = (0x243243) | (readl(isopad_base + 0x54) & 0xff000000);
+			writel(tmp,isopad_base + 0x54);
+			break;*/
+		case 3:
+                case 4:
+			tmp = (0x483483) | (readl(isopad_base + 0x4c) & 0xff000000);
+			writel(tmp,isopad_base + 0x4c);
+
+			tmp = (0x483483<<4) | (readl(isopad_base + 0x50) & 0xf000000f);
+			writel(tmp,isopad_base + 0x50);
+
+			tmp = (0x483483) | (readl(isopad_base + 0x54) & 0xff000000);
+			writel(tmp,isopad_base + 0x54);
+			break;
+		case 5:
+                case 6:
+		case 7:
+			tmp = (0x6c36c3) | (readl(isopad_base + 0x4c) & 0xff000000);
+			writel(tmp,isopad_base + 0x4c);
+
+			tmp = (0x6c36c3<<4) | (readl(isopad_base + 0x50) & 0xf000000f);
+			writel(tmp,isopad_base + 0x50);
+
+			tmp = (0x6c36c3) | (readl(isopad_base + 0x54) & 0xff000000);
+			writel(tmp,isopad_base + 0x54);
+			break;
+                case 8:
+                case 9:
+			tmp = (0xb43b43) | (readl(isopad_base + 0x4c) & 0xff000000);
+			writel(tmp,isopad_base + 0x4c);
+
+			tmp = (0xb43b43<<4) | (readl(isopad_base + 0x50) & 0xf000000f);
+			writel(tmp,isopad_base + 0x50);
+
+			tmp = (0xb43b43) | (readl(isopad_base + 0x54) & 0xff000000);
+			writel(tmp,isopad_base + 0x54);
+			break;
+                default:
+			tmp = (0x003003) | (readl(isopad_base + 0x4c) & 0xff000000);
+			writel(tmp,isopad_base + 0x4c);
+
+			tmp = (0x003003<<4) | (readl(isopad_base + 0x50) & 0xf000000f);
+			writel(tmp,isopad_base + 0x50);
+
+			tmp = (0x003003) | (readl(isopad_base + 0x54) & 0xff000000);
+			writel(tmp,isopad_base + 0x54);
+                }
+#endif
+
+#ifdef CONFIG_ARCH_RTD129x
+		if (readl(sysbrdg_base+0x204)!=0x0)
+			writel(0x40000000,sdmmc_base+0x2c);
+#endif
+		writel(0x00000006, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+		writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) | 0x00070000, sdmmc_base + CR_SD_CKGEN_CTL); //Switch SD source clock to 4MHz by Hsin-yin
+		mdelay(2);
+		writel(0x00000007, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+		udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+		if (readl(sysbrdg_base+0x204)!=0x0)
+			writel(0x00000000,sdmmc_base+0x2c);
+#endif
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+//		writel(0x40000000,sdmmc_base+0x2c);
+		mdelay(100);
+		writel(0x00000006, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+		writel(0x00b64388, pll_base + CR_PLL_SD3); //SD clock rate formula: (ssc_div_n +3) *4.5/4, jamestai20141222
+		mdelay(2);
+		writel(0x00000007, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+		udelay(200);
+//		writel(0x00000000,sdmmc_base+0x2c);
+#elif defined(CONFIG_ARCH_RTD129x)
+		if (readl(sysbrdg_base+0x204)!=0x0) {
+			writel(0x40000000,sdmmc_base+0x2c);
+			mdelay(100);
+			writel(0x00000006, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+			writel(0x00b64388, pll_base + CR_PLL_SD3); //SD clock rate formula: (ssc_div_n +3) *4.5/4, jamestai20141222
+			mdelay(2);
+			writel(0x00000007, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+			udelay(200);
+			writel(0x00000000,sdmmc_base+0x2c);
+		} else {
+			/*Workaround: PLL clcok 208 MHz  */
+			writel(0x00000006, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+			writel(0x00b74388, pll_base + CR_PLL_SD3); //SD clock rate formula: (ssc_div_n +3) *4.5/4, jamestai20141222
+			mdelay(2);
+			writel(0x00000007, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+			mdelay(100);
+			writel(0x00000006, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+			writel(0x00b64388, pll_base + CR_PLL_SD3); //SD clock rate formula: (ssc_div_n +3) *4.5/4, jamestai20141222
+			mdelay(2);
+			writel(0x00000007, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+			udelay(200);
+		}
+#endif
+
+#ifdef CONFIG_ARCH_RTD129x
+		if (readl(sysbrdg_base+0x204)!=0x0)
+			writel(0x40000000,sdmmc_base+0x2c);
+#endif
+		writel(0x00000006, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+		writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) & 0xFFF8FFFF, sdmmc_base + CR_SD_CKGEN_CTL); //Switch SD source clock to normal clock source by Hsin-yin
+		mdelay(2);
+		writel(0x00000007, pll_base + 0x01EC); //JIM modified, 1AC->1EC
+		udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+		if (readl(sysbrdg_base+0x204)!=0x0)
+			writel(0x00000000,sdmmc_base+0x2c);
+#endif
+		writeb(readb(sdmmc_base + SD_CONFIGURE1) & 0xEF, sdmmc_base + SD_CONFIGURE1); //Reset FIFO pointer by Hsin-yin
+
+		rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_NON); //0x580 = 0x10
+		rtk_sdmmc_set_speed(rtk_host, 0); //0x478 = 0x2100
+		break;
+	default :
+		rtk_sdmmc_debug("%s: default speed SDMMC_CLOCK_400KHZ\n", __func__);
+		rtk_sdmmc_set_div(rtk_host, CLOCK_DIV_256); //0x580 = 0xd0
+		rtk_sdmmc_set_speed(rtk_host, 0); //0x478 = 0x2100
+		break;
+	}
+
+	rtk_sdmmc_sync(rtk_host);
+}
+
+static int rtk_sdmmc_allocate_dma_buf(struct rtk_sdmmc_host *rtk_host, struct mmc_command *cmd)
+{
+	if (!dma_virt_addr) {
+		dma_virt_addr = dma_alloc_coherent(rtk_host->dev, SD_ALLOC_LENGTH, &rtk_host->paddr, GFP_KERNEL);
+		dma_phy_addr = (u32 *)rtk_host->paddr;
+	} else {
+		return 0;
+	}
+
+	if (!dma_virt_addr) {
+		WARN_ON(1);
+		printk(KERN_ERR "%s: allocate rtk sd dma buf FAIL !\n", __func__);
+		cmd->error = -ENOMEM;
+		return 0;
+	}
+
+	return 1;
+}
+
+static int rtk_sdmmc_free_dma_buf(struct rtk_sdmmc_host *rtk_host)
+{
+	if (dma_virt_addr)
+		dma_free_coherent(rtk_host->dev, SD_ALLOC_LENGTH, dma_virt_addr ,rtk_host->paddr);
+	else
+		return 0;
+
+	return 1;
+}
+
+static u32 rtk_sdmmc_swap_endian(u32 input)
+{
+	u32 output = 0;
+
+	output = (input & 0xFF000000) >> 24 |
+			(input & 0x00FF0000) >> 8 |
+			(input & 0x0000FF00) << 8 |
+			(input & 0x000000FF) << 24;
+	return output;
+}
+
+static void rtk_sdmmc_read_rsp(struct rtk_sdmmc_host *rtk_host, u32 *rsp, int reg_count)
+{
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	if (reg_count == 6) {
+		rsp[0] = readb(sdmmc_base + SD_CMD1) << 24 |
+				readb(sdmmc_base + SD_CMD2) << 16 |
+				readb(sdmmc_base + SD_CMD3) << 8 |
+				readb(sdmmc_base + SD_CMD4);
+	} else if (reg_count == 16) {
+		rsp[0] = rtk_sdmmc_swap_endian(rsp[0]);
+		rsp[1] = rtk_sdmmc_swap_endian(rsp[1]);
+		rsp[2] = rtk_sdmmc_swap_endian(rsp[2]);
+		rsp[3] = rtk_sdmmc_swap_endian(rsp[3]);
+	}
+}
+
+static u32 rtk_sdmmc_get_cmd_timeout(struct sdmmc_cmd_pkt *cmd_info)
+{
+	struct rtk_sdmmc_host *rtk_host = cmd_info->rtk_host;
+	u32 timeout = 0;
+
+	timeout += msecs_to_jiffies(1);
+	cmd_info->timeout = rtk_host->timeout = timeout;
+
+	return 0;
+}
+
+int rtk_sdmmc_cpu_wait(char* drv_name, struct rtk_sdmmc_host *rtk_host, u8 cmdcode) {
+
+	int ret = CR_TRANSFER_TO;
+	unsigned long old_jiffles = jiffies;
+	unsigned long timeout = 0;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	poll = 1;
+	writel(0x00000016, sdmmc_base + CR_SD_ISREN); //disable all
+	switch( data_xfer_mode ) {
+	case CMD_RSP_ONLY:
+	case CMD_RSP_DATA_WRITE:
+		writel(0x00000007, sdmmc_base + CR_SD_ISREN);
+		break;
+	case CMD_RSP_DATA_READ:
+	case DATA_ONLY:
+		writel(0x00000015, sdmmc_base + CR_SD_ISREN);
+		break;
+	default:
+		writel(0x00000007, sdmmc_base + CR_SD_ISREN);
+		break;
+	}
+	timeout = 300;
+	rtk_sdmmc_sync(rtk_host);
+
+	writeb((u8)(cmdcode | START_EN), sdmmc_base + SD_TRANSFER);
+
+	while (time_before(jiffies, old_jiffles + timeout)) {
+
+		rtk_sdmmc_sync(rtk_host);
+		if ((readb(sdmmc_base + SD_STATUS2) & 0x01) == 1) {
+			ret = CR_TRANSFER_FAIL;
+			break;
+		}
+
+		if (!(rtk_host->rtflags & RTKCR_FCARD_DETECTED)) {
+			ret = CR_TRANSFER_FAIL;
+			break;
+		}
+
+		if ((readb(sdmmc_base + SD_TRANSFER) & (END_STATE | IDLE_STATE)) == (END_STATE | IDLE_STATE)) {
+			ret = CR_TRANS_OK;
+			break;
+		}
+
+		if ((readb(sdmmc_base + SD_TRANSFER) & (ERR_STATUS)) == (ERR_STATUS)) {
+			ret = CR_TRANSFER_FAIL;
+			printk(KERN_ERR "%s(%d) trans error(error status) :\n trans: 0x%08x, st1: 0x%08x, st2: 0x%08x, bus: 0x%08x\n",
+					__func__,
+					__LINE__,
+					readb(sdmmc_base + SD_TRANSFER),
+					readb(sdmmc_base + SD_STATUS1),
+					readb(sdmmc_base + SD_STATUS2),
+					readb(sdmmc_base + SD_BUS_STATUS));
+
+		if (rtk_host!=NULL && rtk_host->mrq!=NULL && rtk_host->mrq->cmd!=NULL)
+			printk(KERN_ERR "%s: error opcode = %d\n", __func__, rtk_host->mrq->cmd->opcode);
+			break;
+		}
+	}
+
+	if (ret == CR_TRANSFER_TO) {
+		printk(KERN_ERR "%s(%d) trans error(timeout) :\n trans: 0x%08x, st1: 0x%08x, st2: 0x%08x, bus: 0x%08x\n",
+				__func__,
+				__LINE__,
+				readb(sdmmc_base+SD_TRANSFER),
+				readb(sdmmc_base+SD_STATUS1),
+				readb(sdmmc_base+SD_STATUS2),
+				readb(sdmmc_base+SD_BUS_STATUS));
+
+		if (rtk_host!=NULL && rtk_host->mrq!=NULL && rtk_host->mrq->cmd!=NULL)
+			printk(KERN_ERR "%s: error opcode = %d\n", __func__, rtk_host->mrq->cmd->opcode);
+
+		return ret;
+	}
+
+	return ret;
+}
+
+int rtk_sdmmc_int_wait(char* drv_name, struct rtk_sdmmc_host *rtk_host, u8 cmdcode)
+{
+	int ret = CR_TRANSFER_TO;
+	unsigned long timeout = 0;
+	unsigned int sd_trans = 0;
+	unsigned long old_jiffles = jiffies;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	int cmd_type=0;
+
+	poll=0;
+
+	if (broken_flag==true)
+		return CR_TRANSFER_FAIL;
+
+	/* timeout timer fire */
+	if (&rtk_host->timer) {
+		if (rtk_host != NULL && rtk_host->mrq != NULL && rtk_host->mrq->cmd != NULL && (rtk_host->mrq->cmd->opcode == 55 || rtk_host->mrq->cmd->opcode == 41 || rtk_host->mrq->cmd->opcode == 8 || (pre_cmd == 41 && rtk_host->mrq->cmd->opcode == 1))) {
+			timeout = msecs_to_jiffies(100) + rtk_host->timeout;
+			cmd_type=1;
+		}
+		else if (rtk_host != NULL && rtk_host->mrq != NULL && rtk_host->mrq->cmd != NULL && (rtk_host->mrq->cmd->opcode == 2 || rtk_host->mrq->cmd->opcode == 3 || rtk_host->mrq->cmd->opcode == 9)) {
+			timeout = msecs_to_jiffies(600) + rtk_host->timeout;
+			cmd_type=2;
+		}
+		else {
+			timeout = msecs_to_jiffies(3000) + rtk_host->timeout;
+			cmd_type=3;
+		}
+		mod_timer(&rtk_host->timer, (jiffies + timeout));
+	}
+
+	writel(0x00000016, sdmmc_base + CR_SD_ISREN); //disable all
+	switch( data_xfer_mode ) {
+	case CMD_RSP_ONLY:
+	case DATA_WRITE_ONLY:
+	case CMD_RSP_DATA_WRITE:
+	case CMD_RSP_DATA_READ_TUNNING:
+		writel(0x00000007, sdmmc_base + CR_SD_ISREN);
+		break;
+	case CMD_RSP_DATA_READ:
+		writel(0x00000015, sdmmc_base + CR_SD_ISREN);
+		break;
+	default:
+		writel(0x00000007, sdmmc_base + CR_SD_ISREN);
+		break;
+	}
+	rtk_sdmmc_sync(rtk_host);
+	irq_error_bit=0;
+	writeb((u8) (cmdcode | START_EN), sdmmc_base + SD_TRANSFER); //cmd fire
+
+	wait_for_completion(rtk_host->int_waiting);
+
+	rtk_sdmmc_sync(rtk_host);
+
+	sd_trans = readb(sdmmc_base + SD_TRANSFER);
+
+	if(irq_error_bit==1) {      //error handling
+		if (rtk_host->cmd_opcode==55 && CMD8_SD1==true) {
+			CMD55_MMC=true;   //MMC card
+			printk(KERN_ERR "Reject SD 1.x command\n");
+			ret = CR_TRANSFER_FAIL;
+		}
+		else {
+			if(rtk_host!=NULL)
+				printk(KERN_ERR "rtk_sdmmc_int_wait: reset the card and adjust the driving capacity, cmd=%d, SD_TRANSFER=0x%x\n",rtk_host->cmd_opcode, sd_trans);
+			driving_capacity++;
+			compatible_flag = true;
+			remove_sdcard(rtk_host);
+			ret = CR_TRANS_OK;
+		}
+	}
+	else if ((sd_trans & (END_STATE | IDLE_STATE)) == (END_STATE | IDLE_STATE)) {
+		ret = CR_TRANS_OK;
+	} else {
+		if(cmd_type==1) timeout=10;
+		else if(cmd_type==2) timeout=60;
+		else timeout = 300;
+		while(time_before(jiffies, old_jiffles + timeout)){
+			rtk_sdmmc_sync(rtk_host);
+			sd_trans = readb(sdmmc_base + SD_TRANSFER);
+
+			if ((sd_trans & (END_STATE | IDLE_STATE)) == (END_STATE | IDLE_STATE)) {
+				ret = CR_TRANS_OK;
+				break;
+			}
+			else if ((sd_trans & (ERR_STATUS)) == (ERR_STATUS)) {
+				ret = CR_TRANSFER_FAIL;
+				printk(KERN_ERR "%s(%d) trans error(error status) :\n cfg1: 0x%02x, cfg2: 0x%02x, cfg3: 0x%02x, trans: 0x%08x, st1: 0x%08x, st2: 0x%08x, bus: 0x%08x\n",
+					__func__,
+					__LINE__,
+					readb(sdmmc_base + SD_CONFIGURE1),
+					readb(sdmmc_base + SD_CONFIGURE2),
+					readb(sdmmc_base + SD_CONFIGURE3),
+					readb(sdmmc_base + SD_TRANSFER),
+					readb(sdmmc_base + SD_STATUS1),
+					readb(sdmmc_base + SD_STATUS2),
+					readb(sdmmc_base + SD_BUS_STATUS));
+
+				if (rtk_host!=NULL && rtk_host->mrq!=NULL && rtk_host->mrq->cmd!=NULL)
+					printk(KERN_ERR "%s: error opcode = %d\n", __func__, rtk_host->mrq->cmd->opcode);
+
+				if (rtk_host!=NULL && rtk_host->mrq!=NULL && rtk_host->mrq->cmd!=NULL && rtk_host->mrq->cmd->opcode!=13 && rtk_host->mrq->cmd->opcode!=19 && CMD8_SD1!=true && CMD55_MMC!=true) {
+					driving_capacity++;
+					compatible_flag = true;
+					remove_sdcard(rtk_host);
+					ret = CR_TRANS_OK;
+				}
+				break;
+			}
+			else if (rtk_host!=NULL && !(rtk_host->rtflags & RTKCR_FCARD_DETECTED)) {
+				ret = CR_TRANSFER_FAIL;
+				printk(KERN_ERR "card is being removed...\n");
+				break;
+			}
+		}
+	}
+	if (ret == CR_TRANSFER_TO) {
+		printk(KERN_ERR "%s(%d) trans error(timeout) :\n trans: 0x%08x, st1: 0x%08x, st2: 0x%08x, bus: 0x%08x\n",
+				__func__,
+				__LINE__,
+				readb(sdmmc_base + SD_TRANSFER),
+				readb(sdmmc_base + SD_STATUS1),
+				readb(sdmmc_base + SD_STATUS2),
+				readb(sdmmc_base + SD_BUS_STATUS));
+
+		if (rtk_host!=NULL && rtk_host->mrq!=NULL && rtk_host->mrq->cmd!=NULL)
+			printk(KERN_ERR "%s: error opcode = %d\n", __func__, rtk_host->mrq->cmd->opcode);
+	}
+	return ret;
+}
+
+static int rtk_sdmmc_set_rspparam(struct sdmmc_cmd_pkt *cmd_info)
+{
+	rtk_sdmmc_debug("%s: opcode = %d\n", __func__, cmd_info->cmd->opcode);
+
+	switch (cmd_info->cmd->opcode) {
+	case MMC_GO_IDLE_STATE: //cmd 0
+		cmd_info->rsp_para1 = 0xD0; //SD1_R0;
+		cmd_info->rsp_para2 = 0x74; //0x50 | SD_R0;
+		cmd_info->rsp_para3 = 0x00;
+		break;
+	case MMC_SEND_OP_COND:
+		if (mmc_detected == 1) {
+			cmd_info->rsp_para1 = SD1_R0;
+			cmd_info->rsp_para2 = 0x45;
+			cmd_info->rsp_para3 = 0x01;
+			cmd_info->cmd->arg = MMC_VDD_30_31 | MMC_VDD_31_32 | MMC_VDD_32_33 | MMC_VDD_33_34 | MMC_SECTOR_ADDR;
+		}
+		break;
+	case MMC_ALL_SEND_CID: //cmd 2
+		cmd_info->rsp_para1 = -1; //SD1_R0;
+		cmd_info->rsp_para2 = 0x42; //SD_R2;
+		cmd_info->rsp_para3 = 0x05; //SD2_R0;
+		break;
+	case MMC_SET_RELATIVE_ADDR: //cmd3
+		cmd_info->rsp_para1 = -1; //SD1_R0;
+		cmd_info->rsp_para2 = 0x41; //SD_R1 | CRC16_CAL_DIS;
+		cmd_info->rsp_para3 = 0x05;
+		break;
+	case MMC_SET_DSR: //cmd4
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case SD_APP_SET_BUS_WIDTH: //cmd6
+		if ((cmd_info->cmd->flags & (0x3 << 5)) == MMC_CMD_ADTC) { //SD_SWITCH
+			cmd_info->rsp_para1 = -1;
+			cmd_info->rsp_para2 = 0x01; //SD_R1b | CRC16_CAL_DIS;
+			cmd_info->rsp_para3 = 0x05;
+		} else {
+			cmd_info->rsp_para1 = -1;
+			if (mmc_detected == 1) {
+				cmd_info->rsp_para2 = 0x09; //SD_R1b | CRC16_CAL_DIS;
+				cmd_info->rsp_para3 = 0x05;
+			} else {
+				cmd_info->rsp_para2 = 0x61; //SD_R1b | CRC16_CAL_DIS;
+				cmd_info->rsp_para3 = 0x0D;
+			}
+		}
+		break;
+	case MMC_SELECT_CARD: //cmd7
+		if (cmd_info->cmd->flags == (MMC_RSP_R1 | MMC_CMD_AC)) { //select
+			cmd_info->rsp_para1 = -1;
+			cmd_info->rsp_para2 = 0x41; //SD_R1b|CRC16_CAL_DIS;
+			cmd_info->rsp_para3 = 0x05;
+		} else {	//deselect
+			cmd_info->rsp_para1 = -1;
+			cmd_info->rsp_para2 = 0x40; //SD_R0|CRC16_CAL_DIS;
+			cmd_info->rsp_para3 = 0x05;
+		}
+		break;
+	case SD_SEND_IF_COND: //cmd8
+		cmd_info->rsp_para1 = 0xD0;
+		cmd_info->rsp_para2 = 0x41; //SD_R1;
+		cmd_info->rsp_para3 = 0x0;
+		if (cmd_info->rtk_host->rtflags & RTKCR_FCARD_SELECTED && mmc_detected == 1) {
+			cmd_info->rsp_para1 = 0x50;
+			cmd_info->rsp_para2 = SD_R1;
+			cmd_info->rsp_para3 = 0x05;
+		}
+		break;
+	case MMC_SEND_CSD: //cmd9
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x42; //SD_R2;
+		cmd_info->rsp_para3 = 0x05;
+		break;
+	case MMC_SEND_CID://cmd10
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x42; //SD_R2;
+		cmd_info->rsp_para3 = 0x5;
+		break;
+	case SD_SWITCH_VOLTAGE: //cmd11
+		cmd_info->rsp_para1 = -1; //0;
+		cmd_info->rsp_para2 = 0x41; //don't update
+		cmd_info->rsp_para3 = 0x00; //don't update
+		break;
+	case MMC_STOP_TRANSMISSION: //cmd12
+		cmd_info->rsp_para1 = -1;
+		if (suspend_flag == false)
+			cmd_info->rsp_para2 = 0x7D; //SD_R1 | CRC16_CAL_DIS | 6 bytes response;
+		else
+			cmd_info->rsp_para2 = 0x7C;
+		cmd_info->rsp_para3 = 0x00;
+		break;
+	case SD_APP_SD_STATUS: //cmd13
+		if ((cmd_info->cmd->flags & (0x3<<5)) == MMC_CMD_ADTC) { //SD_APP_SD_STATUS
+			cmd_info->rsp_para1 = -1;
+			cmd_info->rsp_para2 = 0x01; //SD_R1 | CRC16_CAL_DIS;
+			cmd_info->rsp_para3 = 0x05;
+		} else {
+			cmd_info->rsp_para1 = -1;
+			cmd_info->rsp_para2 = 0x41; //SD_R1 | CRC16_CAL_DIS;
+			cmd_info->rsp_para3 = -1;
+		}
+		break;
+	case MMC_GO_INACTIVE_STATE: //cmd15
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case MMC_SET_BLOCKLEN: //cmd16
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x41;
+		cmd_info->rsp_para3 = 0x05;
+		break;
+	case MMC_READ_SINGLE_BLOCK: //cmd17
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x1;
+		cmd_info->rsp_para3 = -1;
+		break;
+	case MMC_READ_MULTIPLE_BLOCK: //cmd18
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x01;
+		if (mmc_detected == 1) {
+			cmd_info->rsp_para3 = 0x04; //0x04;
+		} else {
+			cmd_info->rsp_para3 = 0x00;//0x02;  ----jim
+		}
+		break;
+	case MMC_SEND_TUNING_BLOCK: //cmd19
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x01;
+		cmd_info->rsp_para3 = -1; //0x04;
+		break;
+	case MMC_WRITE_DAT_UNTIL_STOP: //cmd20
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case SD_APP_SEND_NUM_WR_BLKS: //cmd22
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case MMC_SET_BLOCK_COUNT: //cmd 23
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case MMC_WRITE_BLOCK: //cmd24
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x01;
+		cmd_info->rsp_para3 = -1;
+		break;
+	case MMC_WRITE_MULTIPLE_BLOCK: //cmd25
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x01;
+		cmd_info->rsp_para3 = 0x00;//0x02;--------jim
+		break;
+	case MMC_PROGRAM_CSD: //cmd27
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case MMC_SET_WRITE_PROT: //cmd28
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case MMC_CLR_WRITE_PROT: //cmd29
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case MMC_SEND_WRITE_PROT: //cmd30
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case SD_ERASE_WR_BLK_START: //cmd32
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case SD_ERASE_WR_BLK_END: //cmd33
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case MMC_ERASE: //cmd38
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case SD_APP_OP_COND: //cmd41
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x45;
+		cmd_info->rsp_para3 = 0x00;
+		break;
+	case MMC_LOCK_UNLOCK: //cmd42
+		if ((cmd_info->cmd->flags & (0x3<<5)) == MMC_CMD_ADTC) { //SD_APP_SD_STATUS
+			cmd_info->rsp_para1 = -1; //don't update
+			cmd_info->rsp_para3 = -1; //don't update
+		} else {
+			cmd_info->rsp_para1 = -1; //don't update
+			cmd_info->rsp_para3 = -1; //don't update
+		}
+		break;
+	case SD_APP_SEND_SCR: //cmd51
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x41;
+		cmd_info->rsp_para3 = 0x05;
+		break;
+	case MMC_APP_CMD: //cmd55
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x41;
+		cmd_info->rsp_para3 = 0x05;
+		break;
+	case MMC_GEN_CMD: //cmd56
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	case MMC_EXT_READ_SINGLE: //cmd48
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x01;
+		cmd_info->rsp_para3 = -1;
+		break;
+	case MMC_EXT_WRITE_SINGLE: //cmd49
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x01;
+		cmd_info->rsp_para3 = -1;
+		break;
+	case MMC_EXT_READ_MULTIPLE: //cmd58
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x01;
+		if (mmc_detected == 1)
+			cmd_info->rsp_para3 = 0x04;
+		else
+			cmd_info->rsp_para3 = 0x02;
+		break;
+	case MMC_EXT_WRITE_MULTIPLE: //cmd59
+		cmd_info->rsp_para1 = -1;
+		cmd_info->rsp_para2 = 0x01;
+		cmd_info->rsp_para3 = 0x02;
+		break;
+	default:
+		cmd_info->rsp_para1 = -1; //don't update
+		cmd_info->rsp_para3 = -1; //don't update
+		break;
+	}
+
+	return 0;
+}
+
+/*static int rtk_scan_fun(struct rtk_sdmmc_host *rtk_host) {
+	while (1) {
+		u32 int_status = 0;
+
+		rtk_sdmmc_sync(rtk_host);
+		int_status = readl(rtk_host->sdmmc + CR_SD_ISR);
+		if (int_status & (ISRSTA_INT1 | ISRSTA_INT2 | ISRSTA_INT4)) {
+			TOGGLE_GPIO_LOW18;
+			TOGGLE_GPIO_HIGH18;
+		}
+	}
+}*/
+
+static int rtk_sdmmc_send_stop_cmd(struct mmc_command *cmd, struct rtk_sdmmc_host *rtk_host,int flag)
+{
+	u8 cmd_idx = 0;
+	u32 sd_arg = 0;
+	s8 rsp_para1 = 0;
+	s8 rsp_para2 = 0;
+	s8 rsp_para3 = 0;
+	u8 rsp_len = 0;
+	int ret = 0;
+
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	struct mmc_command stop_cmd;
+	struct sdmmc_cmd_pkt stop_cmd_info;
+	struct sdmmc_cmd_pkt *cmd_info;
+
+	INT4_flag=false;
+
+	cmd_info = &stop_cmd_info;
+
+	memset(&stop_cmd, 0x00, sizeof(struct mmc_command));
+	memset(&stop_cmd_info, 0x00, sizeof(struct sdmmc_cmd_pkt));
+
+	stop_cmd.opcode = MMC_STOP_TRANSMISSION;
+	stop_cmd.arg = 0x00;	//cmd->arg; //card's RCA, not necessary for cmd12
+	stop_cmd_info.cmd = &stop_cmd;
+	stop_cmd_info.rtk_host = rtk_host;
+	stop_cmd_info.rsp_para2 = rtk_sdmmc_get_rsp_type(stop_cmd_info.cmd);
+	stop_cmd_info.rsp_len = rtk_sdmmc_get_rsp_len(stop_cmd_info.rsp_para2);
+	cmd_idx = cmd_info->cmd->opcode;
+	rsp_len = cmd_info->rsp_len;
+	rtk_host = cmd_info->rtk_host;
+
+	rtk_sdmmc_set_rspparam(cmd_info);
+
+	sd_arg = cmd_info->cmd->arg;
+	rsp_para1 = cmd_info->rsp_para1;
+	rsp_para2 = cmd_info->rsp_para2;
+	rsp_para3 = cmd_info->rsp_para3;
+
+	if (rsp_para1 != -1)
+		writeb(rsp_para1, sdmmc_base + SD_CONFIGURE1);
+
+	writeb(rsp_para2, sdmmc_base + SD_CONFIGURE2);
+
+	if (rsp_para3 != -1)
+		writeb(rsp_para3, sdmmc_base + SD_CONFIGURE3);
+
+	g_cmd[0] = (0x40 | cmd_idx);
+	g_cmd[1] = (sd_arg >> 24) & 0xff;
+	g_cmd[2] = (sd_arg >> 16) & 0xff;
+	g_cmd[3] = (sd_arg >> 8) & 0xff;
+	g_cmd[4] = sd_arg & 0xff;
+	g_cmd[5] = 0x00;
+
+	writeb(g_cmd[0], sdmmc_base + SD_CMD0);
+	writeb(g_cmd[1], sdmmc_base + SD_CMD1);
+	writeb(g_cmd[2], sdmmc_base + SD_CMD2);
+	writeb(g_cmd[3], sdmmc_base + SD_CMD3);
+	writeb(g_cmd[4], sdmmc_base + SD_CMD4);
+	writeb(g_cmd[5], sdmmc_base + SD_CMD5);
+	rtk_host->cmd_opcode = cmd_idx;
+	//printk(KERN_ERR "send_stop_cmd: pre_cmd=%d, cmd=%d, INT4_flag=%d\n",pre_cmd,cmd_idx,INT4_flag);
+	rtk_sdmmc_get_cmd_timeout(cmd_info);
+	data_xfer_mode = CMD_RSP_ONLY;
+	if (flag == 1)
+		ret = rtk_sdmmc_cpu_wait(DRIVER_NAME, rtk_host, SD_SENDCMDGETRSP);
+	else
+		ret = rtk_sdmmc_int_wait(DRIVER_NAME, rtk_host, SD_SENDCMDGETRSP);
+
+	rtk_sdmmc_sync(rtk_host);
+
+	return ret;
+}
+
+static int rtk_sdmmc_stream_cmd(u16 cmdcode, struct sdmmc_cmd_pkt *cmd_info, u8 data_len)
+{
+	u8 cmd_idx = cmd_info->cmd->opcode;
+	u32 sd_arg = 0;
+	s8 rsp_para1 = 0;
+	s8 rsp_para2 = 0;
+	s8 rsp_para3 = 0;
+	int rsp_len = cmd_info->rsp_len;
+	int ret = 0;
+	u32 data = cmd_info->dma_buffer;
+	u32 sa = 0;
+	u32 *rsp = (u32 *)&cmd_info->cmd->resp;
+	u16 byte_count = cmd_info->byte_count;
+	u16 block_count = cmd_info->block_count;
+	struct rtk_sdmmc_host *rtk_host = cmd_info->rtk_host;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	INT4_flag=true;
+
+	if (!data || rsp == NULL) {
+		BUG_ON(1);
+	}
+	rtk_sdmmc_set_rspparam(cmd_info);
+	sd_arg = cmd_info->cmd->arg;
+
+	//if (rsp_para1 != -1)
+	rsp_para1 = cmd_info->rsp_para1;
+
+	/* Fix CRC error for SD_AUTOWRITE3, jamestai20150325 */
+	if (cmdcode == SD_AUTOWRITE3) {
+		rsp_para2 = 0;
+	} else {
+		rsp_para2 = cmd_info->rsp_para2;
+	}
+
+	//if (rsp_para3 != -1)
+	rsp_para3 = cmd_info->rsp_para3;
+	sa = (data / 8);
+
+	if ((cmdcode == SD_NORMALWRITE)) {
+		byte_count = 512;
+	} else if (cmdcode == SD_NORMALREAD && mmc_detected == 1) {
+		byte_count = 512;
+	}
+
+	g_cmd[0] = (0x40 | cmd_idx);
+	g_cmd[1] = (sd_arg >> 24) & 0xff;
+	g_cmd[2] = (sd_arg >> 16) & 0xff;
+	g_cmd[3] = (sd_arg >> 8) & 0xff;
+	g_cmd[4] = sd_arg & 0xff;
+	g_cmd[5] = 0x00;
+
+	writeb(g_cmd[0], sdmmc_base + SD_CMD0); //0x10
+	writeb(g_cmd[1], sdmmc_base + SD_CMD1); //0x14
+	writeb(g_cmd[2], sdmmc_base + SD_CMD2); //0x18
+	writeb(g_cmd[3], sdmmc_base + SD_CMD3); //0x1C
+	writeb(g_cmd[4], sdmmc_base + SD_CMD4); //0x20
+	writeb(g_cmd[5], sdmmc_base + SD_CMD5); //0x20
+
+	if (rsp_para1 != -1) {
+		writeb(readb(sdmmc_base + SD_CONFIGURE1) | rsp_para1, sdmmc_base + SD_CONFIGURE1); //0x0C
+	}
+
+	writeb(rsp_para2, sdmmc_base + SD_CONFIGURE2); //0x0C
+
+	if (rsp_para3 != -1) {
+		writeb(readb(sdmmc_base + SD_CONFIGURE3) | rsp_para3, sdmmc_base + SD_CONFIGURE3); //0x0C
+	}
+
+	writeb(byte_count, sdmmc_base + SD_BYTE_CNT_L); //0x24
+	writeb(byte_count >> 8, sdmmc_base + SD_BYTE_CNT_H); //0x28
+	writeb(block_count, sdmmc_base + SD_BLOCK_CNT_L); //0x2C
+	writeb(block_count >> 8, sdmmc_base + SD_BLOCK_CNT_H); //0x30
+
+	if (cmd_info->cmd->data->flags & MMC_DATA_READ) {
+		writel((u32)sa, sdmmc_base + CR_SD_DMA_CTL1);
+		writel(block_count, sdmmc_base + CR_SD_DMA_CTL2);
+
+		if (data_len == RESP_LEN64) {
+			writel(RSP64_SEL | DDR_WR | DMA_XFER, sdmmc_base + CR_SD_DMA_CTL3);
+		} else if (data_len == RESP_LEN17) {
+			writel(RSP17_SEL | DDR_WR | DMA_XFER, sdmmc_base + CR_SD_DMA_CTL3);
+		} else {
+			writel(DDR_WR | DMA_XFER, sdmmc_base + CR_SD_DMA_CTL3);
+		}
+		data_xfer_mode = CMD_RSP_DATA_READ;
+		if (cmd_info->cmd->opcode == MMC_SEND_TUNING_BLOCK) {
+			INT4_flag=false;
+			data_xfer_mode = CMD_RSP_DATA_READ_TUNNING;
+		}
+
+	} else if (cmd_info->cmd->data->flags & MMC_DATA_WRITE) {
+		rtk_sdmmc_debug("%s: DMA sa = 0x%x\nDMA len = 0x%x\nDMA set = 0x%x\n", __func__, (u32)sa, block_count, DMA_XFER);
+		writel((u32)sa, sdmmc_base + CR_SD_DMA_CTL1);
+		writel(block_count, sdmmc_base + CR_SD_DMA_CTL2);
+
+		if (data_len == RESP_LEN64) {
+			writel(RSP64_SEL | DMA_XFER, sdmmc_base + CR_SD_DMA_CTL3);
+		} else if (data_len == RESP_LEN17) {
+			writel(RSP17_SEL | DMA_XFER, sdmmc_base + CR_SD_DMA_CTL3);
+		} else {
+			writel(DMA_XFER, sdmmc_base + CR_SD_DMA_CTL3);
+		}
+		data_xfer_mode = CMD_RSP_DATA_WRITE;
+		if( cmdcode == SD_AUTOWRITE3 ) {
+			data_xfer_mode = DATA_WRITE_ONLY;
+		}
+	}
+
+	rtk_host->cmd_opcode = cmd_idx;
+	rtk_sdmmc_get_cmd_timeout(cmd_info);
+	//printk(KERN_ERR "rtk_stream_cmd invoke pre_cmd=%d, cmd=%d, INT4_flag=%d\n",pre_cmd,cmd_info->cmd->opcode,INT4_flag);
+	ret = rtk_sdmmc_int_wait(DRIVER_NAME, rtk_host, cmdcode);
+	/* Reset dat64_sel and rsp17_sel, #CMD19 DMA won't be auto-cleared */
+	if (cmd_info->cmd->opcode == MMC_SEND_TUNING_BLOCK) {
+		writel(0x00000000, sdmmc_base + CR_SD_DMA_CTL3);
+		data_xfer_mode = CMD_RSP_ONLY;
+	}
+
+	if (ret == CR_TRANS_OK) {
+		if ((cmdcode == SD_AUTOREAD1) || (cmdcode == SD_AUTOWRITE1)) {
+			rtk_sdmmc_debug("%s: auto read/write 1 skip response\n", __func__);
+#ifdef CMD25_WO_STOP_COMMAND
+		} else if (cmdcode == SD_AUTOWRITE2) {
+			rtk_sdmmc_debug("%s: auto write 2 skip response\n", __func__); //CMD + DATA
+		} else if (cmdcode == SD_AUTOWRITE3) {
+			rtk_sdmmc_debug("%s: auto write 3 skip response\n", __func__); //DATA only, clear rsp
+#endif
+		} else {
+			rtk_sdmmc_read_rsp(rtk_host,rsp, rsp_len);
+			rtk_sdmmc_debug("%s: stream cmd done\n", __func__);
+		}
+	}
+
+	return ret;
+}
+
+static int rtk_sdmmc_stream(struct sdmmc_cmd_pkt *cmd_info)
+{
+	u8 cmd_idx = cmd_info->cmd->opcode;
+	int ret = 0;
+	u32 i = 0;
+	u32 dir = 0;
+	u32 dma_nents = 0;
+	u32 dma_leng = 0;
+	u32 dma_addr = 0;
+	u32 old_arg = 0;
+	u16 cmdcode = 0;
+	u8 data_len = 0;
+
+	struct scatterlist *sg;
+	struct mmc_host *host = cmd_info->rtk_host->mmc;
+	struct rtk_sdmmc_host *rtk_host = cmd_info->rtk_host;
+
+#ifdef CMD25_WO_STOP_COMMAND
+	cmd12_stop_cmd.arg=cmd_info->cmd->arg;   //send stop command only use arg info and we need to save it as global variable for fear that timer trigger stop command data corruption
+	rtk_host->rtk_sdmmc_cmd12 = &cmd12_stop_cmd;
+	//rtk_host->rtk_sdmmc_cmd12 = cmd_info->cmd;   //bad using because of local variable ,
+#endif
+
+	if (cmd_info->data->flags & MMC_DATA_READ) {
+		dir = DMA_FROM_DEVICE;
+	} else {
+		dir = DMA_TO_DEVICE;
+	}
+
+	cmd_info->data->bytes_xfered = 0;
+	dma_nents = dma_map_sg(mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len, dir);
+	sg = cmd_info->data->sg;
+
+	old_arg = cmd_info->cmd->arg;
+
+	for(i = 0 ; i < dma_nents ; i++, sg++) {
+		u32 blk_cnt = 0;
+
+		dma_leng = sg_dma_len(sg);
+		dma_addr = sg_dma_address(sg);
+
+		rtk_sdmmc_debug("%s: dma_addr: 0x%x, dma_leng: 0x%x\n", __func__, dma_addr, dma_leng);
+
+		if ((cmd_idx == SD_SWITCH) && (cmd_info->cmd->flags | MMC_CMD_ADTC)) {
+			cmd_info->byte_count = 0x40;
+			blk_cnt = dma_leng / 0x40;
+			data_len = RESP_LEN64;
+		} else if ((cmd_idx == SD_APP_SD_STATUS) && ((cmd_info->cmd->flags & (0x3<<5)) == MMC_CMD_ADTC)) {
+			cmd_info->byte_count = 0x40;
+			blk_cnt = dma_leng / 0x40;
+			data_len = RESP_LEN64;
+		} else if ((cmd_idx == MMC_SEND_TUNING_BLOCK) || (cmd_idx == SD_APP_SEND_SCR) || (cmd_idx == SD_APP_SEND_NUM_WR_BLKS)) {
+			cmd_info->byte_count = 0x40; //rtk HW limite, one trigger 512 byte pass.
+			blk_cnt = 1;
+			data_len = RESP_LEN64;
+		} else if ((cmd_idx == MMC_ALL_SEND_CID) || (cmd_idx == MMC_SEND_CSD) || (cmd_idx == MMC_SEND_CID)) {
+			cmd_info->byte_count = 0x11;
+			blk_cnt = dma_leng / 0x11;
+			data_len = RESP_LEN17;
+		} else {
+			cmd_info->byte_count = BYTE_CNT; //rtk HW limite, one trigger 512 byte pass.
+			blk_cnt = dma_leng / BYTE_CNT;
+			data_len = 0;
+		}
+
+		if (blk_cnt == 0 && dma_leng) {
+			blk_cnt = 1;
+		}
+
+		cmd_info->block_count = blk_cnt;
+		cmd_info->dma_buffer = dma_addr;
+
+		cmdcode = rtk_host->ops->chk_cmdcode(cmd_info->cmd);
+
+#ifdef CMD25_WO_STOP_COMMAND //new write method
+		if (host->card && mmc_card_blockaddr(host->card) && (
+			cmd_info->cmd->opcode == MMC_WRITE_BLOCK ||
+			cmd_info->cmd->opcode == MMC_WRITE_MULTIPLE_BLOCK ||
+			cmd_info->cmd->opcode == MMC_EXT_WRITE_MULTIPLE)) {
+
+			if (sd_in_receive_data_state) {
+				if (sd_current_blk_address == cmd_info->cmd->arg) {
+					cmdcode = SD_AUTOWRITE3; //DATA only
+				} else {
+					rtk_sdmmc_send_stop_cmd(cmd_info->cmd, rtk_host,0); //send stop command first
+					pre_cmd=12;
+					sd_in_receive_data_state = 0; //not set SD in receive-data state
+					cmdcode = SD_AUTOWRITE2; //CMD + DATA
+				}
+			} else {
+				cmdcode = SD_AUTOWRITE2; //CMD + DATA
+			}
+			//alwasy use multi-write command
+			if (cmd_info->cmd->opcode == MMC_EXT_WRITE_MULTIPLE)
+				cmd_info->cmd->opcode = MMC_EXT_WRITE_MULTIPLE;
+			else
+				cmd_info->cmd->opcode = MMC_WRITE_MULTIPLE_BLOCK;
+		} else {
+			if (cmd_info->cmd->opcode == MMC_SEND_STATUS) { //cmd13
+
+			} else {
+				if (sd_in_receive_data_state) {
+					rtk_sdmmc_send_stop_cmd(cmd_info->cmd, rtk_host,0); //send stop command first
+					pre_cmd=12;
+					/* stop trigger, not set SD in receive-data state */
+					sd_in_receive_data_state = 0;
+				}
+			}
+		}
+#endif
+		ret = rtk_sdmmc_stream_cmd(cmdcode, cmd_info, data_len);
+		if (ret == 0) {
+#ifdef CMD25_WO_STOP_COMMAND //new write method
+			if (host->card && mmc_card_blockaddr(host->card) && (
+				cmd_info->cmd->opcode == MMC_WRITE_BLOCK ||
+				cmd_info->cmd->opcode == MMC_WRITE_MULTIPLE_BLOCK ||
+				cmd_info->cmd->opcode == MMC_EXT_WRITE_MULTIPLE)) {
+				sd_current_blk_address = cmd_info->cmd->arg + blk_cnt;
+				sd_in_receive_data_state = 1;
+				mod_timer(&rtk_host->rtk_sdmmc_stop_cmd, jiffies + 20/*1*HZ*/);
+			}
+#endif
+			cmd_info->cmd->arg += dma_leng;
+			cmd_info->data->bytes_xfered += dma_leng;
+		}
+
+		if (ret) {
+			cmd_info->cmd->arg = old_arg;
+			break;
+		}
+
+	}
+
+	dma_unmap_sg(mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len, dir);
+	g_cmd[0] = 0x00;
+
+	return ret;
+}
+
+#ifndef CONFIG_ARCH_RTD119X
+static void rtk_sdmmc_swap_data(u8 *buffer, void __iomem *sdmmc_base)
+{
+	buffer[3] = buffer[2];
+	buffer[2] = buffer[1];
+	buffer[1] = buffer[0];
+	buffer[0] = buffer[3+4];
+	buffer[3+4] = buffer[3+3];
+	buffer[3+3] = buffer[3+2];
+	buffer[3+2] = buffer[3+1];
+	buffer[3+1] = buffer[7+4];
+	buffer[7+4] = buffer[7+3];
+	buffer[7+3] = buffer[7+2];
+	buffer[7+2] = buffer[7+1];
+	buffer[7+1] = buffer[11+4];
+	buffer[11+4] = buffer[11+3];
+	buffer[11+3] = buffer[11+2];
+	buffer[11+2] = buffer[11+1];
+	buffer[11+1] = readb(sdmmc_base + SD_CMD5);
+}
+#endif
+
+static int rtk_sdmmc_send_cmd_get_rsp(struct sdmmc_cmd_pkt *cmd_info)
+{
+	u8 cmd_idx = cmd_info->cmd->opcode;
+	u32 sd_arg = 0;
+	s8 rsp_para1 = 0;
+	s8 rsp_para2 = 0;
+	s8 rsp_para3 = 0;
+	u8 rsp_len = cmd_info->rsp_len;
+	u32 *rsp = (u32 *)&cmd_info->cmd->resp;
+	u32 dma_val = 0;
+	u32 byte_count = 0x200;
+	u32 block_count = 1;
+#ifdef CONFIG_ARCH_RTD119X
+	u32 sa = 0;
+	u32 buf_ptr=0;
+#else
+	u64 sa = 0;
+	u8 RESP17_buffer[16];
+#endif
+	int ret = 0;
+
+	struct rtk_sdmmc_host *rtk_host = cmd_info->rtk_host;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	INT4_flag=false;
+
+	rtk_sdmmc_set_rspparam(cmd_info);
+
+	sd_arg = cmd_info->cmd->arg;
+	rsp_para1 = cmd_info->rsp_para1;
+	rsp_para2 = cmd_info->rsp_para2;
+	rsp_para3 = cmd_info->rsp_para3;
+
+	if (rsp == NULL) {
+		BUG_ON(1);
+	}
+	if ((cmd_idx == SD_IO_SEND_OP_COND)|(cmd_idx == SD_IO_RW_DIRECT)|(cmd_idx == SD_IO_RW_EXTENDED)) {
+		printk(KERN_INFO "%s : reject SDIO commands cmd:0x%02x \n", __func__, cmd_idx);
+		return CR_TRANSFER_FAIL;
+	}
+
+	if (mini_SD==1 && cmd_idx == 8) {
+		printk(KERN_INFO "%s : reject SDIO commands cmd:0x%02x \n", __func__, cmd_idx);
+		return CR_TRANSFER_FAIL;
+	}
+
+	if (rsp_para1 != -1)
+		writeb(rsp_para1, sdmmc_base + SD_CONFIGURE1);
+
+	writeb(rsp_para2, sdmmc_base + SD_CONFIGURE2);
+
+	if (rsp_para3 != -1)
+		writeb(rsp_para3, sdmmc_base + SD_CONFIGURE3);
+
+	g_cmd[0] = (0x40 | cmd_idx);
+	g_cmd[1] = (sd_arg >> 24) & 0xff;
+	g_cmd[2] = (sd_arg >> 16) & 0xff;
+	g_cmd[3] = (sd_arg >> 8) & 0xff;
+	g_cmd[4] = sd_arg & 0x000000FF;
+	g_cmd[5] = 0x00000000;
+
+	writeb(g_cmd[0], sdmmc_base + SD_CMD0);
+	writeb(g_cmd[1], sdmmc_base + SD_CMD1);
+	writeb(g_cmd[2], sdmmc_base + SD_CMD2);
+	writeb(g_cmd[3], sdmmc_base + SD_CMD3);
+	writeb(g_cmd[4], sdmmc_base + SD_CMD4);
+	writeb(g_cmd[5], sdmmc_base + SD_CMD5);
+
+	rtk_host->cmd_opcode = cmd_idx;
+
+	rtk_sdmmc_get_cmd_timeout(cmd_info);
+	data_xfer_mode = CMD_RSP_ONLY;
+	if (RESP_TYPE_17B & rsp_para2) {
+		INT4_flag = true;
+		/*remap the resp dst buffer to un-cache*/
+#ifdef CONFIG_ARCH_RTD119X
+		buf_ptr = ((u32)dma_virt_addr&~0xff);
+		sa = buf_ptr/8;
+#else
+		sa = (u64)((void *)dma_phy_addr);
+		sa = sa / 8;
+#endif
+		dma_val = RSP17_SEL | DDR_WR | DMA_XFER;
+		writeb(byte_count, sdmmc_base + SD_BYTE_CNT_L); //0x24
+		writeb(byte_count>>8, sdmmc_base + SD_BYTE_CNT_H); //0x28
+		writeb(block_count, sdmmc_base + SD_BLOCK_CNT_L); //0x2C
+		writeb(block_count>>8, sdmmc_base + SD_BLOCK_CNT_H); //0x30
+
+		writel(sa, sdmmc_base + CR_SD_DMA_CTL1); //espeical for R2
+		writel(0x00000001, sdmmc_base + CR_SD_DMA_CTL2); //espeical for R2
+		writel(dma_val, sdmmc_base + CR_SD_DMA_CTL3); //espeical for R2
+		data_xfer_mode = CMD_RSP_DATA_READ;
+
+	} else if (RESP_TYPE_6B & rsp_para2) {
+		//do nothing
+	}
+//printk(KERN_ERR "get_rsp:  pre_cmd=%d,cmd=%d, INT4_flag=%d\n",pre_cmd,cmd_idx,INT4_flag);
+	ret = rtk_sdmmc_int_wait(DRIVER_NAME, rtk_host, SD_SENDCMDGETRSP);
+	if (ret == CR_TRANS_OK) {
+#ifdef CONFIG_ARCH_RTD119X
+		if (buf_ptr != 0) {
+			*(((unsigned int *)buf_ptr)+4) = readb(sdmmc_base + SD_CMD5);
+			buf_ptr++;
+			rtk_sdmmc_read_rsp(rtk_host, (u32*)buf_ptr, rsp_len);
+			memcpy(rsp, (u32*)buf_ptr, 16);
+#else
+		if (dma_virt_addr != 0) {
+			rtk_sdmmc_read_rsp(rtk_host, (void *)dma_virt_addr, rsp_len);
+
+			if (rsp_len == 16) {
+				memcpy(RESP17_buffer, (void *)dma_virt_addr, 16);
+				rtk_sdmmc_swap_data(RESP17_buffer, sdmmc_base);
+				memcpy(rsp, (void *)RESP17_buffer, 16);
+			} else {
+				memcpy(rsp, (void *)dma_virt_addr, 16);
+			}
+#endif
+		} else {
+			rtk_sdmmc_read_rsp(rtk_host, rsp, rsp_len);
+		}
+
+		rtk_sdmmc_sync(rtk_host);
+
+		if (cmd_idx == MMC_SET_RELATIVE_ADDR) {
+			g_crinit = 1;
+			printk(KERN_INFO "SD/MMC card init done.\n");
+		}
+	}
+
+	memset(dma_virt_addr, 0x00, SD_ALLOC_LENGTH);
+
+	return ret;
+}
+
+static void rtk_sdmmc_send_command(struct rtk_sdmmc_host *rtk_host, struct mmc_command *cmd)
+{
+	int ret = 0;
+
+	struct sdmmc_cmd_pkt cmd_info;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+
+	memset(&cmd_info, 0, sizeof(struct sdmmc_cmd_pkt));
+
+	if (!rtk_host || !cmd) {
+		printk(KERN_ERR "%s: rtk_host or cmd is null\n", __func__);
+		return;
+	}
+	if (cmd->opcode == MMC_SEND_OP_COND) {
+		mmc_detected = 1;
+	}
+
+	/*work around of bug switch voltage fail : force clock disable after cmd11*/
+	if (cmd->opcode == SD_SWITCH_VOLTAGE) {
+		writeb(0x40, sdmmc_base + SD_BUS_STATUS);
+	}
+
+	cmd_info.cmd = cmd;
+	cmd_info.rtk_host = rtk_host;
+	cmd_info.rsp_para2 = rtk_sdmmc_get_rsp_type(cmd_info.cmd);
+	cmd_info.rsp_len = rtk_sdmmc_get_rsp_len(cmd_info.rsp_para2);
+
+	if (cmd->data) {
+		cmd_info.data = cmd->data;
+
+		if (cmd->data->flags == MMC_DATA_READ) {
+			/* do nothing */
+		} else if (cmd->data->flags == MMC_DATA_WRITE) {
+			if (rtk_host->wp ==1) {
+				printk(KERN_ERR "%s: card is locked!", __func__);
+				ret = -1;
+				cmd->retries = 0;
+				goto err_out;
+			}
+		} else {
+			printk(KERN_ERR "%s: error: cmd->data->flags= %d\n", __func__, cmd->data->flags);
+			cmd->error = -MMC_ERR_INVALID;
+			cmd->retries = 0;
+			goto err_out;
+		}
+
+		if (cmd->opcode != SD_APP_SEND_SCR) {
+			ret = rtk_sdmmc_stream(&cmd_info);
+		} else {
+			struct scatterlist sg;
+			struct mmc_data data_SCR = {0};
+			void *ssr;
+
+			ssr = kmalloc(64, GFP_KERNEL | GFP_DMA);
+			if (!ssr) {
+				ret = CR_TRANSFER_FAIL;
+				goto err_out;
+			}
+
+			sg_init_one(&sg, ssr, 64);
+
+			rtk_sdmmc_debug("%s: data->blksz= %d, data->blocks= %d \n", __func__, cmd_info.data->blksz, cmd_info.data->blocks);
+
+			data_SCR.blksz = cmd_info.data->blksz;
+			data_SCR.blocks = cmd_info.data->blocks;
+			data_SCR.sg = cmd_info.data->sg;
+			data_SCR.sg_len = cmd_info.data->sg_len;
+
+			cmd_info.data->blksz = 64;
+			cmd_info.data->blocks = 1;
+			cmd_info.data->sg = &sg;
+			cmd_info.data->sg_len = 1;
+
+			ret = rtk_sdmmc_stream(&cmd_info);
+
+			if (!ret) {
+				sg_copy_from_buffer(data_SCR.sg, data_SCR.sg_len, ssr, data_SCR.blksz);
+				cmd_info.data->bytes_xfered = data_SCR.blksz;
+				rtk_sdmmc_debug("%s: SCR =\n", __func__);
+			}
+			kfree(ssr);
+		}
+	} else {
+		ret = rtk_sdmmc_send_cmd_get_rsp(&cmd_info);
+	}
+
+	if (cmd->opcode == MMC_SELECT_CARD) {
+		rtk_host->rtflags |= RTKCR_FCARD_SELECTED;
+		rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_6200KHZ);
+	} else if ((cmd->opcode == SD_SEND_RELATIVE_ADDR)&&((cmd->flags & (0x3 << 5)) == MMC_CMD_BCR)) {
+		sdmmc_rca = ((cmd->resp[0]) >> RCA_SHIFTER);
+	}
+
+err_out:
+	if (ret) {
+		if (ret == -RTK_RMOV)
+			cmd->retries = 0;
+
+		/* If SD card card no response do SD host reset, jamestai20151008 */
+		if (cmd->opcode == 49 || cmd->opcode == 59 || cmd->opcode == 48|| cmd->opcode == 58) {
+			rtk_sdmmc_reset(rtk_host);
+			cmd->error  = -110;
+		} else {
+			cmd->error = -MMC_ERR_FAILED;
+		}
+	}
+	tasklet_schedule(&rtk_host->req_end_tasklet);
+}
+static void rtk_sdmmc_request(struct mmc_host *host, struct mmc_request *mrq)
+{
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(host);
+	struct mmc_command *cmd;
+	unsigned char card_cmd = 0;
+
+	BUG_ON(rtk_host->mrq != NULL);
+	//down_write(&cr_sd_rw_sem);
+	down(&cr_sd_sem);
+	cmd = mrq->cmd;
+	rtk_host->mrq = mrq;
+	data_xfer_mode = CMD_RSP_ONLY; // init each request
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	if(cmd->opcode==2) {
+		writel(readl(rtk_host->sdmmc + 0x20) & (~0x02), rtk_host->sdmmc  + 0x20);  //Enable L4 gate
+	}
+#endif
+	/* Check SD card extension command support,jamestai20151008*/
+	if (cmd->opcode == 58 || cmd->opcode == 59) {
+		card_cmd = host->card->raw_scr[0] & 0x0F;
+		if ((card_cmd & 0x08) != 0x08) {
+			cmd->error = -110;
+			goto done;
+		}
+	}
+
+	if (cmd->opcode == 48 || cmd->opcode == 49) {
+		card_cmd = host->card->raw_scr[0] & 0xF;
+		if ((card_cmd & 0x8) != 0x8 && (card_cmd & 0x4) != 0x4) {
+			cmd->error = -110;
+			goto done;
+		}
+	}
+
+	if (!(rtk_host->rtflags & RTKCR_FCARD_DETECTED)) {
+		cmd->error = -MMC_ERR_RMOVE;
+		cmd->retries = 0;
+		goto done;
+	}
+
+	if (rtk_host && cmd) {
+		rtk_sdmmc_allocate_dma_buf(rtk_host, cmd);
+		rtk_sdmmc_send_command(rtk_host, cmd);
+	} else {
+done:
+		tasklet_schedule(&rtk_host->req_end_tasklet);
+	}
+
+	pre_cmd=cmd->opcode;
+	//up_write(&cr_sd_rw_sem);
+	//down_trylock(&cr_sd_sem);
+	if (cr_sd_sem.count==0)
+		up(&cr_sd_sem);	//unplug will release semaphore, in this case we do not need to release the semaphore
+}
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+int rtk_sdmmc_clk_cls_chk(struct mmc_host *host)
+{
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(host);
+	if(rtk_host->ins_event != EVENT_INSER && rtk_host->ins_event !=EVENT_REMOV) return 1;
+	return 0;
+}
+EXPORT_SYMBOL(rtk_sdmmc_clk_cls_chk);
+
+void rtk_sdmmc_close_clk(struct mmc_host *host)
+{
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(host);
+        void __iomem *pll_base = rtk_host->pll;
+#if defined(CONFIG_ARCH_RTD13xx)
+        void __iomem *gpiodir_base = rtk_host->gpiodir;
+#endif
+
+	int card_exist = readl(rtk_host->gpiodir+GPDATI1);
+
+	if ((card_exist & 0x8) && !clk_disabled) {
+		clk_disabled=1;
+		printk(KERN_INFO "SD card does not exist and sd clk is disabled...\n");
+		writel(readl(pll_base + CR_PLL_SD1) & 0xfffffffc ,pll_base + CR_PLL_SD1);
+		writel(readl(pll_base + CR_PLL_SD2) & 0xfffffffe ,pll_base + CR_PLL_SD2);
+		writel(0x00000000, pll_base + CR_PLL_SD4);
+		clk_disable_unprepare(clk_cr);
+		clk_disable_unprepare(clk_sd_ip);
+		reset_control_assert(rstc_cr);
+#if defined(CONFIG_ARCH_RTD13xx)
+                writel(readl(gpiodir_base+0x64)&0xfffffff3,gpiodir_base+0x64);	//close the ldo enable to power saving
+#endif
+	}
+}
+EXPORT_SYMBOL(rtk_sdmmc_close_clk);
+
+void rtk_sdmmc_open_clk(struct mmc_host *host)
+{
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(host);
+        void __iomem *pll_base = rtk_host->pll;
+#if defined(CONFIG_ARCH_RTD13xx)
+        void __iomem *gpiodir_base = rtk_host->gpiodir;
+#endif
+	int card_exist = readl(rtk_host->gpiodir+GPDATI1);
+
+	if ((card_exist & 0x8)==0 && clk_disabled) {
+		printk(KERN_INFO "SD card exists and sd clk is enabled...\n");
+		reset_control_deassert(rstc_cr);
+		clk_prepare_enable(clk_cr);
+		clk_prepare_enable(clk_sd_ip);
+
+#if defined(CONFIG_ARCH_RTD13xx)
+                writel(readl(gpiodir_base+0x64)|0xc,gpiodir_base+0x64); //open the ldo enable
+#endif
+
+		writel(0x00000007, pll_base + CR_PLL_SD4);
+		writel(0x0000003, pll_base + CR_PLL_SD1);
+		mdelay(2);
+		writel(0x00002003, pll_base + CR_PLL_SD1); //PLL_SD1
+		writel(0x00000006, pll_base + 0x01EC);   //JIM modified, 1AC->1EC
+		writel(0x04515893, pll_base + CR_PLL_SD2); //change from 4517893 to 4515893 for passing the EMI
+		writel(0x00564388, pll_base + CR_PLL_SD3); //Set PLL clock rate, default clock 100MHz
+		mdelay(2);
+		writel(0x00000007, pll_base + 0x01EC);    //JIM modified, 1AC->1EC
+		udelay(200);
+#if defined(CONFIG_ARCH_RTD13xx)
+		while((readl(rtk_host->sdmmc+0x2c)&0x1)==0) {
+                        printk(KERN_INFO "wait until clk open...\n");
+                }
+#endif
+		clk_disabled=0;
+	}
+}
+#endif
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+static int rtk_sdmmc_get_cd(struct mmc_host *host)
+{
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(host);
+        int card_exist = readl(rtk_host->gpiodir+GPDATI1);
+
+	if(clk_disabled) return 0;      //this is workaround for fear that the interrupt is triggered twice
+
+	if (!(card_exist & 0x8)) {
+		printk(KERN_ERR "%s: SD card exists, card_exist = 0x%x\n", __func__, card_exist);
+		if(compatible_flag || (rtk_host->ins_event != EVENT_INSER && rtk_host->ins_event !=EVENT_REMOV) || re_initialize==true) {	//this two flags is to detect first recognition and error handling
+			void __iomem *sdmmc_base = rtk_host->sdmmc;
+			u32 det_time = 0;
+
+			compatible_flag = false;
+			rtk_host->ops->card_power(rtk_host, 1); //power on, Jim add
+
+			rtk_host->ins_event = EVENT_INSER;
+			rtk_host->rtflags |= RTKCR_FCARD_DETECTED;
+			det_time = 1;
+			CMD8_SD1=false;
+			CMD55_MMC=false;
+			writel(0x00000000, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+			data_xfer_mode = CMD_RSP_ONLY;
+			writeb(0x00, sdmmc_base + CR_CARD_STOP); //SD Card module transfer no stop
+			writeb(0x02, sdmmc_base + CARD_SELECT); //Specify the current active card module for the coming data transfer, bit 2:0 = 010
+			writeb(0x04, sdmmc_base + CR_CARD_OE); //arget module is SD/MMC card module, bit 2 =1
+			writeb(0x04, sdmmc_base + CARD_CLOCK_EN_CTL); //SD Card Module Clock Enable, bit 2 = 1
+			writeb(0xD0, sdmmc_base + SD_CONFIGURE1);
+			rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_400KHZ);
+			writeb(0x00, sdmmc_base + SD_STATUS2);
+			printk(KERN_ERR "%s: SD card is being inserted now...!!!\n", __func__);
+			rtk_sdmmc_sync(rtk_host);
+
+			rtk_host->rtflags &= ~RTKCR_FCARD_SELECTED;
+			sdmmc_rca = 0;
+			mmc_detect_change(rtk_host->mmc, msecs_to_jiffies(det_time));
+		}
+		if(get_mmc_runtime_resume_flag()==1 && get_RTK_PM_STATE() == PM_SD_SUSPEND_STANDBY) {   //we just reset sdcard if user change the sd card during standby mode
+			compatible_flag = true;
+			set_mmc_runtime_resume_flag(0);
+			remove_sdcard(rtk_host);
+		}
+		return 1;
+        }
+
+        printk(KERN_ERR "%s: SD card does not exist, card_exist = 0x%x\n", __func__, card_exist);
+
+	return 0;
+}
+static int rtk_sdmmc_get_ro(struct mmc_host *host)
+{
+        struct rtk_sdmmc_host *rtk_host = mmc_priv(host);
+	int sd_wp = readl(rtk_host->gpiodir+GPDATI1);
+        if (sd_wp & 0x4) {
+                printk(KERN_ERR "%s: SD card is write protect\n", __func__);
+                return 1;
+        }
+
+        printk(KERN_ERR "%s: SD card is not write protect\n", __func__);
+
+        return 0;
+}
+
+#else
+static int rtk_sdmmc_get_ro(struct mmc_host *host)
+{
+        struct rtk_sdmmc_host *rtk_host = mmc_priv(host);
+        void __iomem *sdmmc_base = rtk_host->sdmmc;
+        u32 reginfo = 0;
+
+        g_ro = reginfo = readb(sdmmc_base + CARD_EXIST);
+
+        if (reginfo & SD_WRITE_PROTECT) {
+                printk(KERN_INFO "%s: SD card is write protect, regCARD_EXIST = %x\n", __func__, readb(sdmmc_base + CARD_EXIST));
+                return 1;
+        }
+
+        printk(KERN_INFO "%s: SD card is not write protect, regCARD_EXIST = %x\n", __func__, readb(sdmmc_base + CARD_EXIST));
+
+        return 0;
+}
+
+static int rtk_sdmmc_get_cd(struct mmc_host *host)
+{
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(host);
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	u32 reginfo = 0;
+
+	reginfo = readb(sdmmc_base + CARD_EXIST);
+
+	if (reginfo & SD_EXISTENCE) {
+		printk(KERN_ERR "%s: SD card exists, regCARD_EXIST = %x\n", __func__, readb(sdmmc_base + CARD_EXIST));
+		return 1;
+	}
+
+	printk(KERN_ERR "%s: SD card does not exist, regCARD_EXIST = %x\n", __func__, readb(sdmmc_base + CARD_EXIST));
+
+	return 0;
+}
+#endif
+static void rtk_sdmmc_set_ios(struct mmc_host *host, struct mmc_ios *ios)
+{
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(host);
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	u32 reginfo;
+	reginfo = readl(rtk_host->gpiodir+GPDATI1);
+#endif
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	//in 1395 platform, system will turn off the SD clock. This case is to handle that the SD card si unplugged during suspend
+	if(reginfo & 0x8) {
+		reset_control_deassert(rstc_cr);
+		clk_prepare_enable(clk_cr);
+		clk_prepare_enable(clk_sd_ip);
+		writel(0x00000007, rtk_host->pll + CR_PLL_SD4);
+	}
+#endif
+	if (ios->bus_mode == MMC_BUSMODE_PUSHPULL) {
+		rtk_sdmmc_debug("%s: ios busmode = pushpull\n", __func__);
+		if (ios->bus_width == MMC_BUS_WIDTH_8) {
+			rtk_sdmmc_debug("%s: set bus width 8\n", __func__);
+			rtk_sdmmc_set_bits(rtk_host, BUS_WIDTH_8);
+		} else if (ios->bus_width == MMC_BUS_WIDTH_4) {
+			rtk_sdmmc_debug("%s: set bus width 4\n", __func__);
+			rtk_sdmmc_set_bits(rtk_host, BUS_WIDTH_4);
+		} else {
+			rtk_sdmmc_set_bits(rtk_host, BUS_WIDTH_1);
+			rtk_sdmmc_debug("%s: set bus width 1\n", __func__);
+		}
+
+		if (ios->clock >= UHS_SDR104_MAX_DTR && ios->timing == MMC_TIMING_UHS_SDR104) {
+			rtk_sdmmc_set_access_mode(rtk_host, ACCESS_MODE_SD30);
+			rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_208000KHZ);
+			rtk_sdmmc_debug("%s: UHS SDR104 SDMMC_CLOCK_208000KHZ\n", __func__);
+		} else if (ios->clock >= UHS_SDR50_MAX_DTR && ios->timing == MMC_TIMING_UHS_SDR50) {
+			rtk_sdmmc_set_access_mode(rtk_host, ACCESS_MODE_SD30);
+			rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_100000KHZ);
+			rtk_sdmmc_debug("%s: UHS SDR50 SDMMC_CLOCK_100000KHZ\n", __func__);
+		} else if (ios->clock >= UHS_SDR25_MAX_DTR && ios->timing == MMC_TIMING_UHS_SDR25) {
+			rtk_sdmmc_set_access_mode(rtk_host, ACCESS_MODE_SD30);
+			rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_50000KHZ);
+			rtk_sdmmc_debug("%s: UHS SDR25 SDMMC_CLOCK_50000KHZ\n", __func__);
+		} else if (ios->clock >= UHS_SDR12_MAX_DTR && ios->timing == MMC_TIMING_UHS_SDR12) {
+			rtk_sdmmc_set_access_mode(rtk_host, ACCESS_MODE_SD30);
+			rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_25000KHZ);
+			rtk_sdmmc_debug("%s: UHS SDR12 SDMMC_CLOCK_25000KHZ\n", __func__);
+		} else if (ios->clock >= UHS_DDR50_MAX_DTR && ios->timing == MMC_TIMING_UHS_DDR50) {
+			rtk_sdmmc_set_access_mode(rtk_host, ACCESS_MODE_DDR);
+			rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_50000KHZ);
+			rtk_sdmmc_debug("%s: UHS DDR50 SDMMC_CLOCK_50000KHZ\n", __func__);
+		} else if (ios->clock >= HIGH_SPEED_MAX_DTR && ios->timing == MMC_TIMING_SD_HS) {
+			rtk_sdmmc_set_access_mode(rtk_host, ACCESS_MODE_SD20);
+			rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_50000KHZ);
+			rtk_sdmmc_debug("%s: High Speed SDMMC_CLOCK_50000KHZ\n", __func__);
+		} else if (ios->clock >= 25000000) {
+			rtk_sdmmc_set_access_mode(rtk_host, ACCESS_MODE_SD20);
+			rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_25000KHZ);
+		} else {
+			if (rtk_host->rtflags & RTKCR_FCARD_SELECTED) {
+				rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_6200KHZ);
+				rtk_sdmmc_debug("%s: Mid speed RTKCR_FCARD_SELECTED = 1 SDMMC_CLOCK_6200KHZ\n", __func__);
+			} else {
+				rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_400KHZ);
+				rtk_sdmmc_debug("%s: Low speed SDMMC_CLOCK_400KHZ\n", __func__);
+			}
+		}
+	} else {  //MMC_BUSMODE_OPENDRAIN
+		rtk_sdmmc_debug("%s: ios busmode != pushpull low speed SDMMC_CLOCK_400KHZ\n", __func__);
+		rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_400KHZ);
+		rtk_sdmmc_set_bits(rtk_host,BUS_WIDTH_1);
+	}
+
+	if (ios->power_mode == MMC_POWER_UP) {
+		rtk_host->ops->card_power(rtk_host, 1); //power on
+		rtk_sdmmc_debug("%s: Power on\n", __func__);
+	} else if (ios->power_mode == MMC_POWER_OFF) {
+		rtk_host->ops->card_power(rtk_host, 0); //power off
+		rtk_sdmmc_debug("%s: Power off\n", __func__);
+	}
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	//in 1395 platform, system will turn off the SD clock. This case is to handle that the SD card si unplugged during suspend
+	if(reginfo & 0x8) {
+		clk_disable_unprepare(clk_cr);
+		clk_disable_unprepare(clk_sd_ip);
+	}
+#endif
+}
+
+static void rtk_sdmmc_hw_initial(struct rtk_sdmmc_host *rtk_host)
+{
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	void __iomem *pll_base = rtk_host->pll;
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	void __iomem *isopad_base = rtk_host->isopad;
+#elif defined(CONFIG_ARCH_RTD129x)
+	void __iomem *emmc_base = rtk_host->emmc;
+#endif
+	int bErrorRetry_1 = 0;
+#ifdef CONFIG_ARCH_RTD129x
+	void __iomem *sysbrdg_base = rtk_host->sysbrdg;
+	unsigned long flags2;
+#endif
+
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	unsigned int tmp=0;
+#endif
+	/*SD PLL Initialization, jamestai20150721*/
+	writel(readl(pll_base + CR_PLL_SD4) | 0x00000004, pll_base + CR_PLL_SD4);
+	writel(readl(pll_base + CR_PLL_SD4) | 0x00000007, pll_base + CR_PLL_SD4);
+
+#ifdef CONFIG_ARCH_RTD119X
+	writel(0x003E0003, pll_base + CR_PLL_SD1);
+	mdelay(2);	//change 10 ms to 2ms to shorten suspend/resume timing issue
+#else
+	writel(0x0000003, pll_base + CR_PLL_SD1);
+	mdelay(2);	//change 10 ms to 2ms to shorten suspend/resume timing issue
+	writel(0x00002003, pll_base + CR_PLL_SD1); //PLL_SD1
+#endif
+
+#ifdef CONFIG_ARCH_RTD129x
+	if (readl(sysbrdg_base+0x204)!=0x0)
+		writel(0x40000000,sdmmc_base+0x2c);
+#endif
+	udelay(100);
+	writel(0x00000006, pll_base + 0x01EC);   //JIM modified, 1AC->1EC, we modified this part because 1AC is to change SDIO PLL instead of SD card PLL
+	writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) | 0x00070000, sdmmc_base + CR_SD_CKGEN_CTL); //Switch SD source clock to 4MHz by Hsin-yin
+	mdelay(2);
+	writel(0x00000007, pll_base + 0x01EC);	//JIM modified, 1AC->1EC
+	udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+	if (readl(sysbrdg_base+0x204)!=0x0)
+		writel(0x00000000,sdmmc_base+0x2c);
+#endif
+
+#ifdef CONFIG_ARCH_RTD129x
+	if (readl(sysbrdg_base+0x204)!=0x0)
+		writel(0x40000000,sdmmc_base+0x2c);
+#endif
+	udelay(100);
+	writel(0x00000006, pll_base + 0x01EC);	 //JIM modified, 1AC->1EC
+	writel(0x04515893, pll_base + CR_PLL_SD2); //change from 4517893 to 4515893 for passing the EMI
+	writel(0x00564388, pll_base + CR_PLL_SD3); //Set PLL clock rate, default clock 100MHz
+	//ritel(0x00324388,  pll_base + CR_PLL_SD3);
+	mdelay(2);
+	writel(0x00000007, pll_base + 0x01EC);	  //JIM modified, 1AC->1EC
+	udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+	if (readl(sysbrdg_base+0x204)!=0x0)
+		writel(0x00000000,sdmmc_base+0x2c);
+#endif
+#ifndef CONFIG_ARCH_RTD119X
+	writel(readl(sdmmc_base + 0x20) |0x02, sdmmc_base + 0x20);      //Disable L4 gate
+#endif
+	writeb(0x3,sdmmc_base + SD_BUS_TA_STATE);
+#ifndef CONFIG_RTD119X
+	writel(readl(sdmmc_base + 0x20) & (~0x01), sdmmc_base + 0x20);
+	writel(readl(sdmmc_base + 0x20) | 0x00000001, sdmmc_base + 0x20);	//reset the DMA
+#endif
+#ifdef CONFIG_ARCH_RTD129x
+	if (readl(sysbrdg_base+0x204)!=0x0)
+		writel(0x40000000,sdmmc_base+0x2c);
+#endif
+	udelay(100);
+	writel(0x00000006, pll_base + 0x01EC);	   //JIM modified, 1AC->1EC
+	writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) & 0xFFF8FFFF, sdmmc_base + CR_SD_CKGEN_CTL); //Switch SD source clock to normal clock source by Hsin-yin
+	udelay(100);
+	writel(0x00000007, pll_base + 0x01EC);		//JIM modified, 1AC->1EC
+	udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+	if (readl(sysbrdg_base+0x204)!=0x0)
+		writel(0x00000000,sdmmc_base+0x2c);
+#endif
+	writeb(readb(sdmmc_base + SD_CONFIGURE1) & 0x000000EF, sdmmc_base + SD_CONFIGURE1); //Reset FIFO pointer by Hsin-yin
+	writel(0x00000007, pll_base + CR_PLL_SD4); //PLL_SD4
+	udelay(100);
+	writeb(0xD0, sdmmc_base + SD_CONFIGURE1);
+
+	rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_400KHZ);
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	gpio_set_debounce(rtk_host->sdmmc_wp_gpio, 1000);
+	gpio_set_debounce(rtk_host->sdmmc_cd_gpio, 1000);
+#endif
+
+#if defined(CONFIG_ARCH_RTD13xx)
+	tmp = (0x003003) | (readl(isopad_base + 0x4c) & 0xff000000);
+	writel(tmp,isopad_base + 0x4c);
+
+	tmp = (0x003003<<4) | (readl(isopad_base + 0x50) & 0xf000000f);
+	writel(tmp,isopad_base + 0x50);
+
+	tmp = (0x003003) | (readl(isopad_base + 0x54) & 0xff000000);
+	writel(tmp,isopad_base + 0x54);
+#elif defined(CONFIG_ARCH_RTD16xx)
+	tmp = (0x3003003 << 4) | (readl(isopad_base + 0xc) & 0xf);
+	writel(tmp,isopad_base + 0xc);
+
+	writel(0x00300300,isopad_base + 0x10);
+
+	tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0x3;
+	writel(tmp,isopad_base + 0x14);
+#elif defined(CONFIG_ARCH_RTD139x)
+	writel(0x198CD99B,isopad_base + 0x34);
+        writel(0x000CF99F,isopad_base + 0x38);
+        writel(0x000CF99F,isopad_base + 0x3c);
+#elif defined(CONFIG_ARCH_RTD129x)
+	rtk_lockapi_lock(flags2, __FUNCTION__);
+	writel(0x00003333, emmc_base + 0x634);
+	writel(0x33333333, emmc_base + 0x638);
+	rtk_lockapi_unlock(flags2, __FUNCTION__);
+#elif defined(CONFIG_ARCH_RTD119X)
+	writeb(0X0, sdmmc_base+CARD_SD_CLK_PAD_DRIVE);
+	writeb(0X0, sdmmc_base+CARD_SD_CMD_PAD_DRIVE);
+	writeb(0X0, sdmmc_base+CARD_SD_DAT_PAD_DRIVE);
+#endif
+
+	writel(0x00000000, sdmmc_base + CR_SD_PAD_CTL); //change to 3.3v
+
+	writel(0x00000016, sdmmc_base + CR_SD_ISR); //enable interrupt
+	//writel(0x00000017, sdmmc_base + CR_SD_ISREN);
+	writel(0x00000016, sdmmc_base + CR_SD_ISREN); // disable all
+	writel(0x00000007, sdmmc_base + CR_SD_ISREN);
+	rtk_sdmmc_sync(rtk_host);
+
+	writeb(0x02, sdmmc_base + CARD_SELECT); //for emmc, select SD ip
+	if (bErrorRetry_1) {
+		writeb(0x08, sdmmc_base + SD_SAMPLE_POINT_CTL); //sample point = SDCLK / 4
+		writeb(0x10, sdmmc_base + SD_PUSH_POINT_CTL); //output ahead SDCLK /4
+	} else {
+		writeb(0x00, sdmmc_base + SD_SAMPLE_POINT_CTL); //sample point = SDCLK / 4
+		writeb(0x00, sdmmc_base + SD_PUSH_POINT_CTL); //output ahead SDCLK /4
+	}
+}
+
+static void rtk_sdmmc_hw_reset(struct mmc_host *host)
+{
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(host);
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_sdmmc_debug("%s: CARD_EXIST = %x\n", __func__, readb(sdmmc_base + CARD_EXIST));
+#endif
+	sd_in_receive_data_state = 0; //CMD25_WO_STOP_COMMAND
+	sd_current_blk_address = 0; //CMD25_WO_STOP_COMMAND
+	rtk_host->rtk_sdmmc_cmd12 = NULL; //CMD25_WO_STOP_COMMAND
+	rtk_host->rtflags &= ~RTKCR_FCARD_SELECTED;
+	sdmmc_rca = 0;
+
+	rtk_sdmmc_hw_initial(rtk_host);
+	writeb(0xFF, sdmmc_base + CR_CARD_STOP); //SD Card module transfer stop and idle state
+	writeb(0x00, sdmmc_base + CR_CARD_STOP); //SD Card module transfer no stop
+	writeb(0x02, sdmmc_base + CARD_SELECT); //Specify the current active card module for the coming data transfer, bit 2:0 = 010
+	writeb(0x04, sdmmc_base + CR_CARD_OE); //arget module is SD/MMC card module, bit 2 =1
+	writeb(0x04, sdmmc_base + CARD_CLOCK_EN_CTL); //SD Card Module Clock Enable, bit 2 = 1
+	writeb(0xD0, sdmmc_base + SD_CONFIGURE1);
+	writeb(0x00, sdmmc_base + SD_STATUS2); //SD CMD Response Timeout Error disable	//#x /b 0x18010584
+
+	rtk_host->ops->card_power(rtk_host, 0); //power off
+	rtk_host->ops->card_power(rtk_host, 1); //power on
+
+	mmc_detected = 0;
+
+	rtk_sdmmc_sync(rtk_host);
+}
+
+static int rtk_sdmmc_switch_voltage(struct mmc_host *mmc, struct mmc_ios *ios)
+{
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(mmc);
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	void __iomem *pll_base = rtk_host->pll;
+	int ret = 0;
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	u32 temp=0;
+	u32 orig=0;
+#endif
+	if (ios->signal_voltage != MMC_SIGNAL_VOLTAGE_330) {
+
+		ret = rtk_sdmmc_wait_voltage_stable_low(rtk_host); //check DAT[3:0] are at LOW level
+
+		if (ret < 0)
+			goto out;
+
+		writeb(0x3B, sdmmc_base + CARD_CLOCK_EN_CTL); //host stop clk
+		mdelay(10); //delay 5 ms to fit SD spec
+
+		/* Workaround : keep IO pad voltage at 3.3v for SD card compatibility, jamestai20141225 */
+		writel(0x00000000, sdmmc_base + CR_SD_PAD_CTL);
+
+		rtk_sdmmc_sync(rtk_host);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+		orig = readl(pll_base + CR_PLL_SD1);
+
+		temp = ((orig & 0xffffbfff) | 0x2000);
+		writel(temp, pll_base + CR_PLL_SD1);
+		mdelay(10);
+		temp = (orig & 0xffff9fff);
+                writel(temp, pll_base + CR_PLL_SD1);
+		mdelay(10);
+		temp = ((orig & 0xffffdfff) | 0x4000);
+                writel(temp, pll_base + CR_PLL_SD1);
+		mdelay(10);
+		temp = (orig | 0x6000);
+                writel(temp, pll_base + CR_PLL_SD1);
+		mdelay(10);
+#elif defined(CONFIG_ARCH_RTD129x)
+		writel(0x0000003, pll_base + CR_PLL_SD1);
+		msleep(500);
+		writel(0x0004003, pll_base + CR_PLL_SD1);
+		mdelay(10); //delay 5 ms to fit SD spec
+#elif defined(CONFIG_ARCH_RTD119X)
+		writel(0x00e0003, pll_base + CR_PLL_SD1);
+		mdelay(10);
+#endif
+		writeb(0x3F, sdmmc_base + CARD_CLOCK_EN_CTL); //force output clk
+		writeb(0x80, sdmmc_base + SD_BUS_STATUS); //force a short period 1.8v clk
+		rtk_sdmmc_sync(rtk_host);
+
+		ret = rtk_sdmmc_wait_voltage_stable_high(rtk_host); //check DAT[3:0] are at HIGH level
+		if (ret < 0)
+			goto out;
+	}
+
+	writeb(0x00, sdmmc_base + SD_BUS_STATUS); //stop 1.8v clk
+
+out:
+	return ret;
+}
+
+static int rtk_sdmmc_execute_tuning(struct mmc_host *mmc, u32 opcode)
+{
+	struct rtk_sdmmc_host *rtk_host = mmc_priv(mmc);
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	void __iomem *pll_base = rtk_host->pll;
+#if defined(CONFIG_ARCH_RTD129x)
+	void __iomem *sysbrdg_base = rtk_host->sysbrdg;
+#endif
+	int ret = 0;
+	unsigned int reg_tmp = 0;
+	unsigned int reg_tmp2 = 0;
+	unsigned int reg_tuned3318 = 0;
+
+	reg_tmp2 = readl(pll_base + CR_PLL_SD2); //disable spectrum
+	writel((reg_tmp2 & 0xFFFF1FFF), pll_base + CR_PLL_SD2); //PLL_SD2 clear [15:13]
+
+	/*if tune tx phase fail, down 8MHz and retry*/
+	do{
+		ret = rtk_sdmmc_tuning_tx(rtk_host);
+		if (ret == -MMC_ERR_RMOVE) {
+			printk(KERN_ERR "%s: Tuning TX fail.\n", __func__);
+			return ret;
+		} else if (ret) {
+			reg_tmp = readl(pll_base + CR_PLL_SD3);
+			reg_tuned3318 = (reg_tmp & 0x03FF0000) >> 16;
+			if (reg_tuned3318 <= 100) {
+				printk(KERN_ERR "%s: Tuning TX fail\n", __func__);
+				return ret;
+			}
+			writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) | 0x00070000, sdmmc_base + CR_SD_CKGEN_CTL); //Switch SD source clock to 4MHz by Hsin-yin
+			reg_tmp = ((reg_tmp & (~0x3FF0000)) | ((reg_tuned3318 - 8) << 16)); //down 8MHz
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+//			writel(0x40000000,sdmmc_base+0x2c);
+			writel(0x00000006, pll_base + 0x01EC);     //JIM modified, 1AC->1EC
+			writel(reg_tmp, pll_base + CR_PLL_SD3);
+			mdelay(2);
+			writel(0x00000007, pll_base + 0x01EC);          //JIM modified, 1AC->1EC
+			udelay(200);
+//			writel(0x00000000,sdmmc_base+0x2c);
+#elif defined(CONFIG_ARCH_RTD129x)
+			if (readl(sysbrdg_base+0x204)!=0x0)
+				writel(0x40000000,sdmmc_base+0x2c);
+			writel(0x00000006, pll_base + 0x01EC);	   //JIM modified, 1AC->1EC
+			writel(reg_tmp, pll_base + CR_PLL_SD3);
+			mdelay(2);
+			writel(0x00000007, pll_base + 0x01EC);		//JIM modified, 1AC->1EC
+			udelay(200);
+			if (readl(sysbrdg_base+0x204)!=0x0)
+				writel(0x00000000,sdmmc_base+0x2c);
+#elif defined(CONFIG_ARCH_RTD119X)
+			writel(reg_tmp, pll_base + CR_PLL_SD3);
+			mdelay(2);
+#endif
+			writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) & 0xFFF8FFFF, sdmmc_base + CR_SD_CKGEN_CTL); //Switch SD source clock to normal clock source by Hsin-yin
+			writeb(readb(sdmmc_base + SD_CONFIGURE1) & 0xEF, sdmmc_base + SD_CONFIGURE1); //Reset FIFO pointer by Hsin-yin
+		}
+	} while (ret);
+
+	if (ret) {
+		printk(KERN_ERR "%s: Tuning TX  fail\n", __func__);
+		return ret;
+	}
+
+	ret = rtk_sdmmc_tuning_rx(rtk_host);
+	writel(reg_tmp2, pll_base + CR_PLL_SD2); //enable spectrum
+
+	if (ret) {
+		printk(KERN_ERR "%s: Tuning RX fail\n", __func__);
+		return ret;
+	}
+
+	printk(KERN_INFO "%s CR_PLL_SD3: %d (0x%02x)\n", __func__, (readl(pll_base + CR_PLL_SD3) >> 16), (readl(pll_base + CR_PLL_SD3) >> 16));
+	printk(KERN_INFO "%s CLK_GEN DVI: %d\n", __func__, 1 << (readl(sdmmc_base + CR_SD_CKGEN_CTL) & 0x03));
+
+	return ret;
+}
+
+static const struct mmc_host_ops rtk_sdmmc_ops ={
+	.request = rtk_sdmmc_request,
+	.get_ro = rtk_sdmmc_get_ro,
+	.get_cd = rtk_sdmmc_get_cd,
+	.set_ios = rtk_sdmmc_set_ios,
+	.hw_reset = rtk_sdmmc_hw_reset,
+	.start_signal_voltage_switch = rtk_sdmmc_switch_voltage,
+	.execute_tuning = rtk_sdmmc_execute_tuning,
+};
+
+#ifdef CMD25_WO_STOP_COMMAND
+static void rtk_sdmmc_cmd12_fun(unsigned long data)
+{
+	struct rtk_sdmmc_host *rtk_host = (struct rtk_sdmmc_host *)data;
+
+	if (sd_in_receive_data_state && rtk_host->rtk_sdmmc_cmd12 && rtk_host) {
+
+		if ( down_trylock(&cr_sd_sem) != 0 ) {  // @rtk_sdmmc_cmd12_fun, lock fail
+			//printk(KERN_ERR "try to lock fail so that we delay the cmd12 timer 1\n");
+			mod_timer(&rtk_host->rtk_sdmmc_stop_cmd, jiffies + 20);
+		} else {
+			sd_in_receive_data_state = 0;
+
+			//printk(KERN_ERR "Timer cmd12 using polling mode!!!\n");
+			do_stop_command_wo_complete = 1;
+			wait_stop_command_irq_done = 1;
+			rtk_sdmmc_send_stop_cmd(rtk_host->rtk_sdmmc_cmd12, rtk_host,1);
+			rtk_sdmmc_wait_stop_cmd_irq_done();
+
+			pre_cmd = 12;
+			//down_trylock(&cr_sd_sem);
+			if (cr_sd_sem.count == 0)
+				up(&cr_sd_sem); // unplug will release semaphore, in this case we do not need to release the semaphore
+		}
+	}
+}
+#endif
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)//1395 card detection using interrupt mode
+static irqreturn_t rtk_sdmmc_cd_irq(int irq, void *data)
+{
+	struct rtk_sdmmc_host *rtk_host = (struct rtk_sdmmc_host *)data;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	void __iomem *isopad_base = rtk_host->isopad;
+	u32 det_time = 0;
+	int card_exist;
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	unsigned int tmp=0;
+#endif
+
+	card_exist = readl(rtk_host->gpiodir+GPDATI1);
+	rtk_host->rtflags &= ~RTKCR_FCARD_DETECTED;
+	rtk_host->wp = 0;
+	if(card_exist & 0x8) {
+		if(clk_disabled) return IRQ_HANDLED;
+
+		rtk_host->ins_event = EVENT_REMOV;
+		rtk_host->rtflags &= ~RTKCR_FCARD_DETECTED;
+		det_time = 1;
+		driving_capacity=0;
+
+		if(down_trylock(&cr_sd_sem)!=0);        //check if the lock is occupied, if not, then occupied
+		up(&cr_sd_sem);
+#if defined(CONFIG_ARCH_RTD139x)
+		writel(0x198CD99B,isopad_base + 0x34);
+		writel(0x000CF99F,isopad_base + 0x38);
+		writel(0x000CF99F,isopad_base + 0x3c);
+#elif defined(CONFIG_ARCH_RTD16xx)
+		tmp = (0x3003003 << 4) | (readl(isopad_base + 0xc) & 0xf);
+		writel(tmp,isopad_base + 0xc);
+
+		writel(0x00300300,isopad_base + 0x10);
+
+		tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0x3;
+		writel(tmp,isopad_base + 0x14);
+#elif defined(CONFIG_ARCH_RTD13xx)
+                tmp = (0x003003) | (readl(isopad_base + 0x4c) & 0xff000000);
+                writel(tmp,isopad_base + 0x4c);
+
+                tmp = (0x003003<<4) | (readl(isopad_base + 0x50) & 0xf000000f);
+                writel(tmp,isopad_base + 0x50);
+
+                tmp = (0x003003) | (readl(isopad_base + 0x54) & 0xff000000);
+                writel(tmp,isopad_base + 0x54);
+#endif
+		mini_SD=0;
+		broken_flag=false;
+		writel(0x0, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+		data_xfer_mode = CMD_RSP_ONLY;
+		writeb(0xff, sdmmc_base + CR_CARD_STOP); //SD Card module transfer stop and idle state
+
+		writeb(0x3b, sdmmc_base + CARD_CLOCK_EN_CTL);
+
+		rtk_host->ops->card_power(rtk_host, 0); //power off, Jim add
+		printk(KERN_ERR "SD card is being removed now...!!!\n");
+	}
+	else {
+		rtk_sdmmc_open_clk(rtk_host->mmc);
+		rtk_host->ops->card_power(rtk_host, 1); //power on, Jim add
+		if(clk_disabled==0) {
+			rtk_host->ins_event = EVENT_INSER;
+			rtk_host->rtflags |= RTKCR_FCARD_DETECTED;
+			det_time = 1;
+			CMD8_SD1=false;
+			CMD55_MMC=false;
+
+			writel(0x00000000, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+			data_xfer_mode = CMD_RSP_ONLY;
+			writeb(0x00, sdmmc_base + CR_CARD_STOP); //SD Card module transfer no stop
+			writeb(0x02, sdmmc_base + CARD_SELECT); //Specify the current active card module for the coming data transfer, bit 2:0 = 010
+			writeb(0x04, sdmmc_base + CR_CARD_OE); //arget module is SD/MMC card module, bit 2 =1
+			writeb(0x04, sdmmc_base + CARD_CLOCK_EN_CTL); //SD Card Module Clock Enable, bit 2 = 1
+			writeb(0xD0, sdmmc_base + SD_CONFIGURE1);
+			rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_400KHZ);
+			writeb(0x00, sdmmc_base + SD_STATUS2);
+			printk(KERN_ERR "%s: SD card is being inserted now...!!!\n", __func__);
+		}
+	}
+
+	rtk_sdmmc_sync(rtk_host);
+
+	rtk_host->rtflags &= ~RTKCR_FCARD_SELECTED;
+	sdmmc_rca = 0;
+	mmc_detect_change(rtk_host->mmc, msecs_to_jiffies(det_time));
+	return IRQ_HANDLED;
+}
+static irqreturn_t rtk_sdmmc_wp_irq(int irq, void *data)
+{
+	struct rtk_sdmmc_host *rtk_host = (struct rtk_sdmmc_host *)data;
+        int sd_wp;
+        sd_wp = readl(rtk_host->gpiodir+GPDATI1);
+	if(sd_wp & 0x4) {
+		rtk_host->wp = 1;
+	}
+	else {
+		rtk_host->wp = 0;
+	}
+	return IRQ_HANDLED;
+}
+#elif defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+static void rtk_sdmmc_plug(unsigned long data)
+{
+	u32 reginfo = 0;
+	u32 det_time = 0;
+#ifdef CONFIG_ARCH_RTD119X
+	unsigned long timeout = 0;
+#endif
+	struct rtk_sdmmc_host *rtk_host = (struct rtk_sdmmc_host *)data;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+#if defined(CONFIG_ARCH_RTD129x)
+	unsigned long flags2;
+#endif
+
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_MMC_RTK_EMMC
+	if(get_RTK_initial_flag()==0) {
+		printk(KERN_ERR "need to wait until emmc tuning done...\n");
+		return;       //we must wait for EMMC driver initial done
+	}
+#endif
+#endif
+	reginfo = readb(sdmmc_base + CARD_EXIST);
+	if ((reginfo & SD_EXISTENCE) ^ (rtk_host->int_status_old & SD_EXISTENCE)) {
+		rtk_host->rtflags &= ~RTKCR_FCARD_DETECTED;
+		rtk_host->wp = 0;
+
+		if (reginfo & SD_EXISTENCE) {
+			rtk_host->ops->card_power(rtk_host, 1); //power on, Jim add
+
+			rtk_host->ins_event = EVENT_INSER;
+			rtk_host->rtflags |= RTKCR_FCARD_DETECTED;
+			det_time = 1;
+			CMD8_SD1=false;
+			CMD55_MMC=false;
+
+			writel(0x00000000, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+			data_xfer_mode = CMD_RSP_ONLY;
+			writeb(0x00, sdmmc_base + CR_CARD_STOP); //SD Card module transfer no stop
+			writeb(0x02, sdmmc_base + CARD_SELECT); //Specify the current active card module for the coming data transfer, bit 2:0 = 010
+			writeb(0x04, sdmmc_base + CR_CARD_OE); //arget module is SD/MMC card module, bit 2 =1
+			writeb(0x04, sdmmc_base + CARD_CLOCK_EN_CTL); //SD Card Module Clock Enable, bit 2 = 1
+			writeb(0xD0, sdmmc_base + SD_CONFIGURE1);
+			rtk_sdmmc_speed(rtk_host, SDMMC_CLOCK_400KHZ);
+			writeb(0x00, sdmmc_base + SD_STATUS2);
+			printk(KERN_ERR "SD card is being inserted now...!!!\n");
+		} else {
+			rtk_host->ins_event = EVENT_REMOV;
+			rtk_host->rtflags &= ~RTKCR_FCARD_DETECTED;
+			det_time = 1;
+			driving_capacity=0;
+
+			if(down_trylock(&cr_sd_sem)!=0);        //check if the lock is occupied, if not, then occupied
+			up(&cr_sd_sem);
+#if defined(CONFIG_ARCH_RTD129x)
+			rtk_lockapi_lock(flags2, __FUNCTION__);
+			writel(0x00003333, rtk_host->emmc + 0x634);
+			writel(0x33333333, rtk_host->emmc + 0x638);
+			rtk_lockapi_unlock(flags2, __FUNCTION__);
+#elif defined(CONFIG_ARCH_RTD119X)
+			writeb(0X0, sdmmc_base+CARD_SD_CLK_PAD_DRIVE);
+			writeb(0X0, sdmmc_base+CARD_SD_CMD_PAD_DRIVE);
+			writeb(0X0, sdmmc_base+CARD_SD_DAT_PAD_DRIVE);
+#endif
+			mini_SD=0;
+			broken_flag=false;
+
+#ifdef CONFIG_ARCH_RTD119X
+			//reset, this is workaround for phoenix, phoenix 1195 DMA reset will have impact in EMMC SDIO, so we need to make sure that emmc and sdio dma is inactive now
+			timeout = jiffies + msecs_to_jiffies(100);
+
+			while(time_before(jiffies, timeout)) {
+				if ((!(readl(rtk_host->emmc + EMMC_DMA_CTL3) & 0x01)) && (readb(rtk_host->sdio + SDIO_NORML_INT_STA) & 0x02)) {
+					break;
+				}
+			}
+#endif
+			//writel(readl(pll_base + 0x0C) | (0x1 << 25) | (0x1 << 31), pll_base + 0x0C);
+			//writel(readl(sdmmc_base + 0x20) | 0x00000002, sdmmc_base + 0x20);	//add by jim for test, change the state to reset the SD IP
+			//writel(readl(sdmmc_base + 0x20) | 0x00000003, sdmmc_base + 0x20);
+
+			writel(0x0, sdmmc_base + CR_SD_DMA_CTL3); //stop dma control
+			data_xfer_mode = CMD_RSP_ONLY;
+			writeb(0xff, sdmmc_base + CR_CARD_STOP); //SD Card module transfer stop and idle state
+
+			writeb(0x3b, sdmmc_base + CARD_CLOCK_EN_CTL);
+
+			rtk_host->ops->card_power(rtk_host, 0); //power off, Jim add
+			printk(KERN_ERR "SD card is being removed now...!!!\n");
+		}
+
+		rtk_sdmmc_sync(rtk_host);
+#ifdef CONFIG_ARCH_RTD119X
+		printk(KERN_INFO "[SD] SD card power register=%x\n",readl(rtk_host->pll + CR_PFUNC_CR));
+#else
+		rtk_lockapi_lock(flags2, __FUNCTION__);
+		printk(KERN_INFO "[SD] SD card power register=%x\n",readl(rtk_host->emmc + CR_PFUNC_CR));
+		rtk_lockapi_unlock(flags2, __FUNCTION__);
+#endif
+		rtk_host->rtflags &= ~RTKCR_FCARD_SELECTED;
+		sdmmc_rca = 0;
+		mmc_detect_change(rtk_host->mmc, msecs_to_jiffies(det_time));
+	}
+
+	//workaround for some manufacture SD hardware issue that will have delay of write protection detection
+	if (rtk_host->mmc->card  && !(g_ro & SD_WRITE_PROTECT) && (reginfo & SD_WRITE_PROTECT) && (reginfo & SD_EXISTENCE)) {
+		printk(KERN_INFO "The SD card is locked!!!\n");
+		g_ro = g_ro | SD_WRITE_PROTECT;
+		mmc_card_set_readonly(rtk_host->mmc->card);
+		mmc_blk_set_ro(rtk_host->mmc->card);
+	}
+
+	rtk_host->int_status_old = reginfo;
+	mod_timer(&rtk_host->plug_timer, jiffies + HZ/10);
+}
+#endif
+static void rtk_sdmmc_req_end_tasklet(unsigned long param)
+{
+	struct rtk_sdmmc_host *rtk_host = (struct rtk_sdmmc_host *)param;
+	struct mmc_request* mrq;
+
+	mrq = rtk_host->mrq;
+	rtk_host->mrq = NULL;
+
+	mmc_request_done(rtk_host->mmc, mrq);
+}
+
+static void rtk_sdmmc_timeout(unsigned long data)
+{
+	struct rtk_sdmmc_host *rtk_host = (struct rtk_sdmmc_host *)data;
+	u32 int_status = readl(rtk_host->sdmmc+CR_SD_ISR);
+	u32 int_status_en = readl(rtk_host->sdmmc+CR_SD_ISREN);
+
+	if (poll==1)  return;	//this timeout function is for interrupt mode
+
+	if (rtk_host->ins_event ==EVENT_REMOV) {
+		printk(KERN_ERR "command timeout because the SD card is removed\n");
+		complete(rtk_host->int_waiting);
+		writel(0x00000016, rtk_host->sdmmc + CR_SD_ISR);
+		return;
+	}
+
+	if (broken_flag==true) {
+		complete(rtk_host->int_waiting);
+		writel(0x00000016, rtk_host->sdmmc + CR_SD_ISR);
+		return;
+	}
+
+	printk(KERN_ERR"%s: command/data timeout, pre_cmd=%d, cmd=%d, poll=%d, ISR=%x, ISR_EN=%x\n", __func__,pre_cmd,rtk_host->cmd_opcode,poll,int_status,int_status_en);
+
+	if (rtk_host->cmd_opcode==8 && int_status==0) {
+		CMD8_SD1=true;	//SD 1.x
+		printk(KERN_ERR "Reject SD 2.x command\n");
+	} else if (rtk_host->cmd_opcode==55 && CMD8_SD1==true && (int_status==0x0||int_status==0x6)) {
+		CMD55_MMC=true;   //MMC card
+		printk(KERN_ERR "Reject SD 1.x command\n");
+	}
+
+	complete(rtk_host->int_waiting);
+	writel(0x00000016, rtk_host->sdmmc + CR_SD_ISR);
+	rtk_sdmmc_sync(rtk_host);
+
+	if (pre_cmd==0 && rtk_host->cmd_opcode==1 && (int_status==0x0 || int_status==0x16)) {
+		if (mini_SD==0) {
+			printk(KERN_ERR "This might be mini SD card\n");
+			mini_SD=1;
+			compatible_flag = true;
+			remove_sdcard(rtk_host);
+		} else {
+			printk(KERN_ERR "SD/MMC card is broken!\n");
+			broken_flag=true;
+			card_broken(rtk_host);
+			return;
+		}
+	} else if (CMD55_MMC==false && rtk_host->cmd_opcode!=8 && (int_status==0x0 || int_status==0x16)) {
+		/* this statement is to workaround some SD card cannot be recognized and read command will return error,
+		 * tuning the driving or PLL can fix this issue but put this reset function in case
+		 */
+		compatible_flag = true;
+		printk(KERN_ERR "SD compatible issue: reset the card and adjust the driving capacity!\n");
+		driving_capacity++;
+		remove_sdcard(rtk_host);
+	}
+}
+
+static void rtk_sdmmc_card_power(struct rtk_sdmmc_host *rtk_host, u8 status)
+{
+	int res = 0;
+	u32 power_status = rtk_host->power_status;
+#if defined(CONFIG_ARCH_RTD119X) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	u32 tmp;
+#endif
+	//void __iomem *pll_base = rtk_host->pll;
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	void __iomem *isopad_base = rtk_host->isopad;
+#elif defined(CONFIG_ARCH_RTD129x)
+	void __iomem *emmc_base = rtk_host->emmc;	//Jim modified
+#endif
+
+#if defined(CONFIG_ARCH_RTD129x)
+	unsigned long flags2;
+#endif
+
+	if (status == power_status)
+		return;
+
+	if (status) {
+		res = gpio_direction_output(rtk_host->sdmmc_gpio, 0);
+#if defined(CONFIG_ARCH_RTD13xx)
+                tmp = (0x003003) | (readl(isopad_base + 0x4c) & 0xff000000);
+                writel(tmp,isopad_base + 0x4c);
+
+                tmp = (0x003003<<4) | (readl(isopad_base + 0x50) & 0xf000000f);
+                writel(tmp,isopad_base + 0x50);
+
+                tmp = (0x003003) | (readl(isopad_base + 0x54) & 0xff000000);
+                writel(tmp,isopad_base + 0x54);
+#elif defined(CONFIG_ARCH_RTD16xx)
+		tmp = (0x3003003 << 4) | (readl(isopad_base + 0xc) & 0xf);
+		writel(tmp,isopad_base + 0xc);
+
+		writel(0x00300300,isopad_base + 0x10);
+
+		tmp = (readl(isopad_base + 0x14) & 0xfffff000) | 0x3;
+		writel(tmp,isopad_base + 0x14);
+#elif defined(CONFIG_ARCH_RTD139x)
+		writel(0x198CD99B,isopad_base + 0x34);
+                writel(0x000CF99F,isopad_base + 0x38);
+                writel(0x000CF99F,isopad_base + 0x3c);
+#else
+#ifdef CONFIG_ARCH_RTD119X
+		tmp = readl(rtk_host->pll + CR_PFUNC_CR );
+		writel(0x33333223 | (tmp & 0x00000F00), rtk_host->pll + CR_PFUNC_CR);   //Jim modified
+#else
+		rtk_lockapi_lock(flags2, __FUNCTION__);
+		writel(0x33333323, emmc_base + CR_PFUNC_CR);   //Jim modified
+		rtk_lockapi_unlock(flags2, __FUNCTION__);
+#endif
+#endif
+		if (res < 0) {
+			printk(KERN_ERR "%s: can't gpio output = %d (power on)\n", __func__, rtk_host->sdmmc_gpio);
+		} else {
+			power_status = 1; //card is power on
+			mdelay(10); //delay 10 ms after power on
+		}
+	} else {
+		res = gpio_direction_input(rtk_host->sdmmc_gpio);
+
+#if defined(CONFIG_ARCH_RTD13xx)
+		writel(readl(isopad_base + 0x4c) & 0xffffeffe, isopad_base + 0x4c);
+                writel(readl(isopad_base + 0x50) & 0xfffeffef, isopad_base + 0x50);
+                writel(readl(isopad_base + 0x54) & 0xffffeffe, isopad_base + 0x54);
+#elif defined(CONFIG_ARCH_RTD16xx)
+		writel(readl(isopad_base + 0xc) & 0xdffdffdf, isopad_base + 0xc);
+		writel(readl(isopad_base + 0x10) & 0xffdffdff, isopad_base + 0x10);
+		writel(readl(isopad_base + 0x14) & 0xfffffffd, isopad_base + 0x14);
+#elif defined(CONFIG_ARCH_RTD139x)
+		writel(readl(isopad_base + 0x34) & 0xfffff7fe,isopad_base + 0x34);
+                writel(readl(isopad_base + 0x38) & 0xfffff7fe,isopad_base + 0x38);
+                writel(readl(isopad_base + 0x3c) & 0xfffff7fe,isopad_base + 0x3c);
+#else
+#ifdef CONFIG_ARCH_RTD119X
+                tmp = readl(rtk_host->pll + CR_PFUNC_CR );
+                writel(0x22223222 | (tmp & 0x00000F00), rtk_host->pll + CR_PFUNC_CR);   //Jim modified
+#else
+		/* Workaround : OS reboot SD card initial fail, jamestai20150129*/
+		rtk_lockapi_lock(flags2, __FUNCTION__);
+		writel(0x22223322, emmc_base + CR_PFUNC_CR);	//Jim modified
+		rtk_lockapi_unlock(flags2, __FUNCTION__);
+#endif
+#endif
+		if (res < 0) {
+			printk(KERN_ERR "%s: can't gpio input = %d (power off)\n", __func__, rtk_host->sdmmc_gpio);
+		} else {
+			power_status = 0; //card is power off
+			mdelay(10); //delay 10 ms after power off
+		}
+	}
+	rtk_host->power_status = power_status;
+}
+
+static u8 rtk_sdmmc_chk_cmdcode(struct mmc_command* cmd)
+{
+	u8 cmdcode = 0;
+
+	if (cmd->opcode < 59) {
+		if (cmd->opcode == 8 && mmc_detected == 1)
+			cmdcode = SD_NORMALREAD;
+		else
+			cmdcode = rtk_sdmmc_cmdcode[cmd->opcode][0];
+
+		WARN_ON(cmd->data == NULL);
+
+		if (cmd->data->flags & MMC_DATA_WRITE) {
+			if (cmd->opcode == 42)
+				cmdcode = SD_NORMALWRITE;
+			else if (cmd->opcode == 56)
+				cmdcode = SD_AUTOWRITE2;
+		}
+	} else {
+		cmdcode = SD_CMD_UNKNOW;
+	}
+
+	return cmdcode;
+}
+
+static irqreturn_t rtk_sdmmc_irq(int irq, void *data)
+{
+	struct rtk_sdmmc_host *rtk_host = (struct rtk_sdmmc_host *)data;
+	void __iomem *sdmmc_base = rtk_host->sdmmc;
+	u32 int_status = 0;
+
+	rtk_sdmmc_sync(rtk_host);
+	int_status = readl(sdmmc_base + CR_SD_ISR);
+	if((int_status & ISRSTA_INT2) && rtk_host->cmd_opcode!=13 && rtk_host->cmd_opcode!=19 ) {
+		irq_error_bit=1;
+		goto clear_irq;
+	}
+	if (INT4_flag==true) {
+#if 0
+		if (!(int_status & ISRSTA_INT1) || !(int_status & ISRSTA_INT4))
+			return IRQ_HANDLED;
+#endif
+		if(data_xfer_mode==CMD_RSP_DATA_READ || data_xfer_mode==DATA_ONLY)
+		{
+			if(!(int_status & ISRSTA_INT4)) return IRQ_HANDLED;
+		}
+		else {
+			if(!(int_status & ISRSTA_INT1)) return IRQ_HANDLED;
+		}
+	} else {
+		if (!(int_status & ISRSTA_INT1))
+			return IRQ_HANDLED;
+	}
+#if 0
+	if ((int_status & ISRSTA_INT2) && rtk_host->cmd_opcode!=13 && rtk_host->cmd_opcode!=19 )
+		return IRQ_HANDLED; //if error bit is set, return except for tuning command
+
+	if ((int_status & ISRSTA_INT2) && pre_cmd==55 && rtk_host->cmd_opcode==13)
+		return IRQ_HANDLED; //ACMD13 error, return
+#endif
+clear_irq:
+	if (poll==0) {
+		del_timer(&rtk_host->timer);
+		complete(rtk_host->int_waiting);
+	}
+
+	writel(0x00000016, sdmmc_base + CR_SD_ISR);
+	rtk_sdmmc_sync(rtk_host);
+
+	if ( wait_stop_command_irq_done ) {
+		wait_stop_command_irq_done = 0; // irq finish
+	}
+	return IRQ_HANDLED;
+}
+
+static struct rtk_sdmmc_host_ops sdmmc_ops = {
+	.card_power = rtk_sdmmc_card_power,
+	.chk_cmdcode = rtk_sdmmc_chk_cmdcode,
+};
+
+static const struct of_device_id rtk_sdmmc_match[] = {
+	{ .compatible = "Realtek,rtk1295-sdmmc", },
+	{ /* sentinel */ }
+};
+MODULE_DEVICE_TABLE(of, rtk_sdmmc_match);
+
+static void rtk_sdmmc_show_version(void)
+{
+	printk(KERN_INFO "%s: build at : %s \n", DRIVER_NAME, utsname()->version);
+
+#ifdef CONFIG_MMC_BLOCK_BOUNCE
+	printk(KERN_INFO "%s: CONFIG_MMC_BLOCK_BOUNCE enable\n", DRIVER_NAME);
+#else
+	printk(KERN_INFO "%s: CONFIG_MMC_BLOCK_BOUNCE disable\n", DRIVER_NAME);
+#endif
+}
+
+static int rtk_sdmmc_probe(struct platform_device *pdev)
+{
+	struct mmc_host *mmc = NULL;
+	struct rtk_sdmmc_host *rtk_host = NULL;
+	int ret = 0;
+	int irq = 0;
+	struct device_node *sdmmc_node = pdev->dev.of_node;
+
+	clk_cr = devm_clk_get(&pdev->dev, "sd");
+	if (IS_ERR(clk_cr)) {
+		 printk(KERN_WARNING "%s: clk_get() returns %ld\n", __func__,
+			PTR_ERR(clk_cr));
+		 clk_cr = NULL;
+	}
+	clk_sd_ip = devm_clk_get(&pdev->dev, "sd_ip");
+	if (IS_ERR(clk_sd_ip)) {
+		 printk(KERN_WARNING "%s: clk_get() returns %ld\n", __func__,
+			PTR_ERR(clk_sd_ip));
+		 clk_sd_ip = NULL;
+	}
+	rstc_cr = devm_reset_control_get(&pdev->dev, NULL);
+	if (IS_ERR(rstc_cr)) {
+		 printk(KERN_WARNING "%s: reset_control_get() returns %ld\n", __func__,
+			PTR_ERR(rstc_cr));
+		 rstc_cr = NULL;
+	}
+
+	rtk_sdmmc_show_version();
+
+	do_stop_command_wo_complete = 0; // probe stage
+	wait_stop_command_irq_done = 0; // probe stage
+
+	sema_init( &cr_sd_sem, 1 );//probe stage
+
+	irq = irq_of_parse_and_map(sdmmc_node, 0);
+	if (!irq) {
+		printk(KERN_ERR "%s: fail to parse of irq.\n", __func__);
+		return -ENXIO;
+	}
+
+	mmc = mmc_alloc_host(sizeof(struct rtk_sdmmc_host), &pdev->dev);
+	if (!mmc) {
+		ret = -ENOMEM;
+		goto out;
+	}
+
+	rtk_global_host=rtk_host = mmc_priv(mmc);
+	memset(rtk_host, 0, sizeof(struct rtk_sdmmc_host));
+
+	rtk_host->pll = of_iomap(sdmmc_node, 0);
+	rtk_host->sdmmc = of_iomap(sdmmc_node, 1);
+	rtk_host->sysbrdg = of_iomap(sdmmc_node, 2);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	rtk_host->isopad = of_iomap(sdmmc_node, 3);
+#else
+	rtk_host->emmc = of_iomap(sdmmc_node, 3);
+#endif
+#ifdef CONFIG_ARCH_RTD119X
+	rtk_host->sdio = of_iomap(sdmmc_node, 4);
+#endif
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+        rtk_host->gpiodir = of_iomap(sdmmc_node, 5);
+#endif
+	rtk_host->int_waiting = &rtk_sdmmc_wait;
+
+	rtk_host->sdmmc_gpio = of_get_gpio_flags(sdmmc_node, 0, NULL);
+	if (gpio_is_valid(rtk_host->sdmmc_gpio)) {
+		ret = gpio_request(rtk_host->sdmmc_gpio, "sdmmc_gpio");
+		if (ret < 0)
+			printk(KERN_ERR "%s: can't request gpio %d\n", __func__, rtk_host->sdmmc_gpio);
+	} else {
+		printk(KERN_ERR "%s: gpio %d is not valid\n", __func__, rtk_host->sdmmc_gpio);
+	}
+#ifdef CONFIG_ARCH_RTD119X
+	magic_num = readl(rtk_host->sysbrdg + 0x204) >> 16;
+#endif
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	rtk_host->sdmmc_wp_gpio = of_get_gpio_flags(sdmmc_node, 1, NULL);
+	if (gpio_is_valid(rtk_host->sdmmc_wp_gpio)) {
+                ret = gpio_request(rtk_host->sdmmc_wp_gpio, "sd_card_wp_gpio");
+                if (ret < 0)
+                        printk(KERN_ERR "%s: can't request gpio 34\n", __func__);
+		else gpio_direction_input(rtk_host->sdmmc_wp_gpio);
+        } else {
+                printk(KERN_ERR "%s: gpio 34 is not valid\n", __func__);
+        }
+	rtk_host->sdmmc_cd_gpio = of_get_gpio_flags(sdmmc_node, 2, NULL);
+	if (gpio_is_valid(rtk_host->sdmmc_cd_gpio)) {
+                ret = gpio_request(rtk_host->sdmmc_cd_gpio, "sd_card_cd_gpio");
+                if (ret < 0)
+                        printk(KERN_ERR "%s: can't request gpio 35\n", __func__);
+		else gpio_direction_input(rtk_host->sdmmc_cd_gpio);
+        } else {
+                printk(KERN_ERR "%s: gpio 35 is not valid\n", __func__);
+        }
+#endif
+
+	reset_control_deassert(rstc_cr);
+	clk_prepare_enable(clk_cr);
+	clk_prepare_enable(clk_sd_ip);
+#if defined(CONFIG_ARCH_RTD13xx)
+        writel(readl(rtk_host->gpiodir+0x64)|0xc, rtk_host->gpiodir+0x64);
+#endif
+	rtk_host->mmc = mmc;
+	rtk_host->dev = &pdev->dev;
+	rtk_host->ops = &sdmmc_ops;
+
+	rtk_sdmmc_hw_initial(rtk_host);
+
+	spin_lock_init(&rtk_host->lock);
+
+	mmc->ocr_avail = MMC_VDD_30_31 |
+				MMC_VDD_31_32 |
+				MMC_VDD_32_33 |
+				MMC_VDD_33_34 |
+				MMC_VDD_165_195;
+
+	mmc->caps = MMC_CAP_4_BIT_DATA |
+				MMC_CAP_SD_HIGHSPEED |
+				MMC_CAP_MMC_HIGHSPEED |
+				MMC_CAP_HW_RESET |
+				MMC_CAP_UHS_SDR104 |
+				MMC_CAP_UHS_SDR12 |
+				MMC_CAP_UHS_SDR25 |
+				MMC_CAP_UHS_SDR50;
+
+	mmc->caps2 = MMC_CAP2_NO_SDIO;
+	mmc->f_min = 10000000 >> 8; //RTK min bus clk is 10Mhz/256
+	mmc->f_max = 208000000; //RTK max bus clk is 208Mhz
+	mmc->max_segs = 1;
+	mmc->max_blk_size = 512;
+	mmc->max_blk_count = 0x1000;
+	mmc->max_seg_size = mmc->max_blk_size * mmc->max_blk_count;
+	mmc->max_req_size = mmc->max_blk_size * mmc->max_blk_count;
+
+	tasklet_init(&rtk_host->req_end_tasklet, rtk_sdmmc_req_end_tasklet, (unsigned long)rtk_host);
+
+	//cmd12_qu  = create_workqueue("rtk_cmd12_wq");
+	//INIT_DELAYED_WORK(&rtk_cmd12_delayed_work, rtk_cmd12_func);
+
+	ret = request_irq(irq, rtk_sdmmc_irq, IRQF_SHARED, DRIVER_NAME, rtk_host);
+	if (ret) {
+		printk(KERN_ERR "%s: cannot assign irq %d\n", __func__, irq);
+		goto out;
+	} else {
+		rtk_host->irq = irq;
+	}
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	rtk_host->cd_irq = gpio_to_irq(rtk_host->sdmmc_cd_gpio);
+	if(!rtk_host->cd_irq) printk(KERN_ERR "Cannot get the SD CD irq...\n");
+	else printk(KERN_INFO "SD CD irq=%d\n",rtk_host->cd_irq);
+	rtk_host->wp_irq = gpio_to_irq(rtk_host->sdmmc_wp_gpio);
+        if(!rtk_host->wp_irq) printk(KERN_ERR "Cannot get the SD WP irq...\n");
+	else printk(KERN_INFO "SD WP irq=%d\n",rtk_host->wp_irq);
+	irq_set_irq_type(rtk_host->cd_irq, IRQ_TYPE_EDGE_BOTH);
+	ret = request_irq(rtk_host->cd_irq, rtk_sdmmc_cd_irq, IRQF_SHARED, DRIVER_NAME, rtk_host);
+        if (ret) {
+                printk(KERN_ERR "%s: cannot assign irq %d\n", __func__, irq);
+		goto out;
+	}
+	irq_set_irq_type(rtk_host->wp_irq, IRQ_TYPE_EDGE_BOTH);
+	ret = request_irq(rtk_host->wp_irq, rtk_sdmmc_wp_irq, IRQF_SHARED, DRIVER_NAME, rtk_host);
+        if (ret) {
+                printk(KERN_ERR "%s: cannot assign irq %d\n", __func__, irq);
+                goto out;
+	}
+#elif defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+	setup_timer(&rtk_host->plug_timer, rtk_sdmmc_plug, (unsigned long)rtk_host);
+#endif
+	setup_timer(&rtk_host->timer, rtk_sdmmc_timeout, (unsigned long)rtk_host);
+
+#ifdef CMD25_WO_STOP_COMMAND
+	setup_timer(&rtk_host->rtk_sdmmc_stop_cmd, rtk_sdmmc_cmd12_fun, (unsigned long)rtk_host);
+#endif
+	mmc->ops = &rtk_sdmmc_ops;
+	rtk_host->rtflags &= ~(RTKCR_FCARD_DETECTED|RTKCR_FCARD_SELECTED);
+	rtk_host->int_status_old &= ~SD_EXISTENCE;
+	sdmmc_rca = 0;
+	g_crinit = 0;
+
+	platform_set_drvdata(pdev, mmc);
+
+	rtk_sdmmc_sync(rtk_host);
+
+	ret = mmc_add_host(mmc);
+	if (ret)
+		goto out;
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+	mod_timer(&rtk_host->plug_timer, jiffies + 3*HZ);
+#endif
+	return 0;
+
+out:
+	if (mmc)
+		mmc_free_host(mmc);
+	return ret;
+}
+
+static int rtk_sdmmc_remove(struct platform_device *pdev)
+{
+	struct mmc_host *mmc = platform_get_drvdata(pdev);
+	if (mmc) {
+		//kthread_stop(rtk_SD_task);
+		struct rtk_sdmmc_host *rtk_host = mmc_priv(mmc);
+
+		flush_scheduled_work();
+
+		rtk_sdmmc_free_dma_buf(rtk_host);
+
+		mmc_remove_host(mmc);
+		if (!mmc) {
+			printk(KERN_INFO "Realtek SD/MMC host have removed.\n");
+		}
+
+		free_irq(rtk_host->irq, rtk_host);
+
+		del_timer_sync(&rtk_host->timer);
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+		del_timer_sync(&rtk_host->plug_timer);
+#endif
+#ifdef CMD25_WO_STOP_COMMAND
+		del_timer_sync(&rtk_host->rtk_sdmmc_stop_cmd);
+#endif
+		if (rtk_host->sdmmc)
+			iounmap(rtk_host->sdmmc);
+
+		if (rtk_host->pll)
+			iounmap(rtk_host->pll);
+
+		mmc_free_host(mmc);
+		gpio_free(rtk_host->sdmmc_gpio);
+	}
+
+	platform_set_drvdata(pdev, NULL);
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(rtk_sdmmc_remove);
+
+static struct platform_driver rtk_sdmmc_driver = {
+	.probe = rtk_sdmmc_probe,
+	.remove = rtk_sdmmc_remove,
+	.driver = {
+		.name = DRIVER_NAME,
+#ifdef CONFIG_PM
+		.pm = &rtk_sdmmc_pm_ops,
+#endif
+		.of_match_table = rtk_sdmmc_match,
+	},
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	.shutdown = rtk_sdmmc_shutdown,
+#endif
+};
+
+module_platform_driver(rtk_sdmmc_driver);
+
+MODULE_DESCRIPTION("Realtek SD/MMC host driver");
+MODULE_AUTHOR("James Tai");
+MODULE_LICENSE("GPL");
diff --git a/drivers/mmc/host/rtk-sdmmc.h b/drivers/mmc/host/rtk-sdmmc.h
new file mode 100644
index 00000000..7226eee
--- /dev/null
+++ b/drivers/mmc/host/rtk-sdmmc.h
@@ -0,0 +1,224 @@
+/*
+ * Realtek SD/MMC/mini SD card driver
+ *
+ * Authors:
+ * Copyright (C) 2017 Realtek Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef DRIVERS_MMC_HOST_RTK_SDMMC_H_
+#define DRIVERS_MMC_HOST_RTK_SDMMC_H_
+
+
+
+#ifdef CONFIG_MMC_RTK_SDMMC_DEBUG
+#define rtk_sdmmc_debug(fmt, args...)        printk(KERN_DEBUG fmt, ##args)
+#else
+#define rtk_sdmmc_debug(fmt, args...)
+#endif
+
+struct rtk_sdmmc_host {
+
+    struct mmc_host *mmc;
+    struct mmc_request *mrq;
+    struct mmc_command *rtk_sdmmc_cmd12;
+    struct rtk_sdmmc_host_ops *ops;
+    volatile u32 rtflags;
+
+    u8 ins_event;
+    u8 cmd_opcode;
+    u8 reset_event;
+    u8 wp;
+
+    void __iomem *sdmmc;
+    void __iomem *pll;
+    void __iomem *sysbrdg;
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+    void __iomem *isopad;
+    void __iomem *gpiodir;
+    int cd_irq;
+    int wp_irq;
+    u32 sdmmc_wp_gpio;
+    u32 sdmmc_cd_gpio;
+#else
+    void __iomem *emmc;
+#endif
+
+#ifdef CONFIG_ARCH_RTD119X
+    void __iomem *sdio;
+#endif
+    spinlock_t lock;
+
+    struct tasklet_struct req_end_tasklet;
+    struct timer_list timer;
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+    struct timer_list plug_timer;
+#endif
+    struct timer_list rtk_sdmmc_stop_cmd; //CMD25_WO_STOP_COMMAND
+
+    struct completion *int_waiting;
+    struct device *dev;
+    int irq;
+
+    dma_addr_t paddr;
+
+    u32 sdmmc_gpio;
+    u32 power_status;
+    u32 int_status_old;
+    u32 timeout;
+
+    unsigned int magic_num;
+};
+
+struct sdmmc_cmd_pkt {
+    struct mmc_host *mmc; /* MMC structure */
+    struct rtk_sdmmc_host *rtk_host;
+    struct mmc_command *cmd;
+    struct mmc_data *data;
+    u32 dma_buffer;
+    u16 byte_count;
+    u16 block_count;
+
+    u32 flags;
+    s8 rsp_para1;
+    s8 rsp_para2;
+    s8 rsp_para3;
+    u8 rsp_len;
+    u32 timeout;
+};
+
+struct rtk_sdmmc_host_ops {
+    irqreturn_t (*func_irq)(int irq, void *dev);
+    int (*re_init_proc)(struct mmc_card *card);
+    int (*card_det)(struct rtk_sdmmc_host *rtk_host);
+    void (*card_power)(struct rtk_sdmmc_host *rtk_host,u8 status);
+    void (*chk_card_insert)(struct rtk_sdmmc_host *rtk_host);
+    void (*set_crt_muxpad)(struct rtk_sdmmc_host *rtk_host);
+    void (*set_clk)(struct rtk_sdmmc_host *rtk_host,u32 mmc_clk);
+    void (*reset_card)(struct rtk_sdmmc_host *rtk_host);
+    void (*reset_host)(struct rtk_sdmmc_host *rtk_host);
+    void (*bus_speed_down)(struct rtk_sdmmc_host *rtk_host);
+    u32 (*get_cmdcode)(u32 opcode );
+    u32 (*get_r1_type)(u32 opcode );
+    u8 (*chk_cmdcode)(struct mmc_command* cmd);
+    u32 (*chk_r1_type)(struct mmc_command* cmd);
+};
+
+enum sdmmc_clock_speed {
+    SDMMC_CLOCK_200KHZ = 0,
+    SDMMC_CLOCK_400KHZ = 1,
+    SDMMC_CLOCK_6200KHZ = 2,
+    SDMMC_CLOCK_20000KHZ = 3,
+    SDMMC_CLOCK_25000KHZ = 4,
+    SDMMC_CLOCK_50000KHZ = 5,
+    SDMMC_CLOCK_208000KHZ = 6,
+    SDMMC_CLOCK_100000KHZ = 7,
+};
+
+static const char *const bit_tlb[4] = {
+    "1bit",
+    "4bits",
+    "8bits",
+    "unknow"
+};
+
+struct timing_phase_path{
+    int start;
+    int end;
+    int mid;
+    int len;
+};
+
+#define MMC_SECTOR_ADDR            0x40000000
+
+#define EVENT_NON                  0x0000
+#define EVENT_INSER                0x0001
+#define EVENT_REMOV                0x0002
+#define EVENT_USER                 0x0010
+
+#define BYTE_CNT                   0x0200
+#define RTK_NORMAL_SPEED           0x0000
+#define RTK_HIGH_SPEED             0x0001
+
+#define ON                         0
+#define OFF                        1
+#define GPIO_OUT                   1
+#define GPIO_IN                    0
+#define GPIO_HIGH                  1
+#define GPIO_LOW                   0
+
+/* MMC configure1, for SD_CONFIGURE1 */
+#define SD30_FIFO_RST              (1 << 4)
+#define SD1_R0                     (SDCLK_DIV | SDCLK_DIV_256 | RST_RDWR_FIFO)
+
+/* MMC configure2, for SD_CONFIGURE2, response type */
+#define SD_R0                      (RESP_TYPE_NON | CRC7_CHK_DIS)
+#define SD_R1                      RESP_TYPE_6B
+#define SD_R1b                     RESP_TYPE_6B
+#define SD_R2                      RESP_TYPE_17B
+#define SD_R3                      (RESP_TYPE_6B | CRC7_CHK_DIS)
+#define SD_R4                      RESP_TYPE_6B
+#define SD_R5                      RESP_TYPE_6B
+#define SD_R6                      RESP_TYPE_6B
+#define SD_R7                      RESP_TYPE_6B
+#define SD_R_NO                    0xFF
+
+static const unsigned char rtk_sdmmc_cmdcode[60][2] = {
+    {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, //0~3
+    {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_NORMALREAD ,SD_R1 }, {SD_CMD_UNKNOW ,SD_R0 }, //4~7
+    {SD_CMD_UNKNOW ,SD_R1 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R1 }, //8~11
+    {SD_CMD_UNKNOW ,SD_R0 }, {SD_NORMALREAD ,SD_R1 }, {SD_CMD_UNKNOW ,SD_R1 }, {SD_CMD_UNKNOW ,SD_R0 }, //12~15
+    {SD_CMD_UNKNOW ,SD_R0 }, {SD_AUTOREAD2  ,SD_R1 }, {SD_AUTOREAD1  ,SD_R1 }, {SD_CMD_UNKNOW ,SD_R1 }, //16~19
+    {SD_AUTOWRITE1 ,SD_R1 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_NORMALREAD ,SD_R1 }, {SD_CMD_UNKNOW ,SD_R0 }, //20~23
+#ifndef CMD25_USE_SD_AUTOWRITE2
+    {SD_AUTOWRITE2 ,SD_R1 }, {SD_AUTOWRITE1 ,SD_R1 }, {SD_NORMALWRITE,SD_R1 }, {SD_NORMALWRITE,SD_R1 }, //24~27
+#else
+    {SD_AUTOWRITE2 ,SD_R1 }, {SD_AUTOWRITE2 ,SD_R1 }, {SD_NORMALWRITE,SD_R1 }, {SD_NORMALWRITE,SD_R1 }, //24~27
+#endif
+    {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_NORMALREAD ,SD_R1 }, {SD_NORMALREAD ,SD_R1 }, //28~31
+    {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, //32~35
+    {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, //36~39
+    {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_NORMALREAD ,SD_R1 }, {SD_CMD_UNKNOW ,SD_R0 }, //40~43
+    {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, //44~47
+    {SD_AUTOREAD2 ,SD_R1 }, {SD_AUTOWRITE2 ,SD_R1 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_NORMALREAD ,SD_R1 }, //48~51
+    {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_CMD_UNKNOW ,SD_R0 }, //52~55
+    {SD_AUTOREAD2 ,SD_R1 }, {SD_CMD_UNKNOW ,SD_R0 }, {SD_AUTOREAD2  ,SD_R1 }, {SD_AUTOWRITE2 ,SD_R1 }  //56~59
+};
+
+/* MMC configure3 , for SD_CONFIGURE3 */
+#define SD30_CLK_STOP              (1 << 4)
+#define SD2_R0                     (RESP_CHK_EN | ADDR_BYTE_MODE)
+
+#define RTKCR_FCARD_DETECTED       (0x01 << 0) /* Card is detected */
+#define RTKCR_FCARD_SELECTED       (0x01 << 1) /* Card is detected */
+#define RTKCR_USER_PARTITION       (0x01 << 2) /* card is working on normal partition */
+
+#define MMC_ERR_NONE               0
+#define MMC_ERR_TIMEOUT            1
+#define MMC_ERR_BADCRC             2
+#define MMC_ERR_RMOVE              3
+#define MMC_ERR_FAILED             4
+#define MMC_ERR_INVALID            5
+
+#define RCA_SHIFTER                16
+
+#define CR_TRANS_OK                0x00
+#define CR_TRANSFER_TO             0x01
+#define CR_BUF_FULL_TO             0x02
+#define CR_DMA_FAIL                0x03
+#define CR_TRANSFER_FAIL           0x04
+
+#define RTK_FAIL                   3 /* DMA error & cmd parser error */
+#define RTK_RMOV                   2 /* card removed */
+#define RTK_TOUT                   1 /* time out include DMA finish & cmd parser finish */
+#define RTK_SUCC                   0
+
+#define MMC_EXT_READ_SINGLE        48
+#define MMC_EXT_WRITE_SINGLE       49
+#define MMC_EXT_READ_MULTIPLE      58
+#define MMC_EXT_WRITE_MULTIPLE     59
+
+#endif
diff --git a/drivers/mmc/host/rtkemmc.c b/drivers/mmc/host/rtkemmc.c
new file mode 100644
index 00000000..1632ce3
--- /dev/null
+++ b/drivers/mmc/host/rtkemmc.c
@@ -0,0 +1,5655 @@
+/*
+ * Realtek EMMC driver
+ *
+ * Authors:
+ * Copyright (C) 2017 Realtek Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+/****************************************************************************************
+ * Modifications									*
+ * 1. In rtkemmc_probe, we use iomap to get device tree resource			*
+ * 2. In rtkemmc_probe, we use lockapi to protect the DBG_PORT part			*
+ * 3. Change the sg map and unmap in correct code section for reading easier		*
+ * 4. Remove shutdown_protection definition						*
+ * 5. Merge rtkemmc_ops.c to rtkemmc.c							*
+ * 6. Add EMMC HS400 mode								*
+ * 7. Add emmc down speed error handling once the HS200 tuning failed			*
+ * 8. emmc info will be save under /sys/devices/platform/98012000.emmc/emmc_info	*
+ * 9. mmc_fast_rw is for ACPU's usage							*
+ * 10.Add 139x support									*
+ ****************************************************************************************/
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/platform_device.h>
+#include <linux/mbus.h>
+#include <linux/delay.h>
+#include <linux/interrupt.h>
+#include <linux/dma-mapping.h>
+#include <linux/scatterlist.h>
+#include <linux/irq.h>
+#include <linux/gpio.h>
+#include <linux/mmc/host.h>
+#include <asm/unaligned.h>
+
+#include <linux/suspend.h>
+#include <linux/sched.h>
+#include <linux/wait.h>
+#include <linux/slab.h>
+#include <linux/semaphore.h>
+#include <linux/mmc/card.h>
+#include <linux/mmc/host.h>
+#include <linux/mmc/mmc.h>
+#include <linux/mmc/sd.h>
+#include <linux/workqueue.h>
+#include <linux/completion.h>
+#include "reg_mmc.h"
+#include "reg_iso.h"
+#include "reg_sys.h"
+#include "rtkemmc.h"
+#include "mmc_debug.h"
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_gpio.h>
+#include <asm/cacheflush.h>
+#include <linux/pm_runtime.h>
+//#include <soc/realtek/rtd129x_cpu.h>
+#include <soc/realtek/rtk_chip.h>
+#include <soc/realtek/rtd129x_lockapi.h>
+
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+#ifdef CONFIG_REALTEK_PCBMGR
+#include <mach/pcbMgr.h>
+#ifdef CONFIG_REALTEK_GPIO
+#include <mach/venus_gpio.h>
+#define EMMC_SHOUTDOWN_PROTECT
+#endif
+#endif
+
+#define DRIVER_NAME "EMMC"
+#define BANNER      "Realtek eMMC Driver"
+#define VERSION     "$Id: rtkemmc.c Kylin 2017-03-12 18:00 $"
+
+#define DMA_ALLOC_LENGTH     (0x80000)
+#define DESC_ALLOC_LENGTH   (1024*1024)
+unsigned int GLOBAL=0;
+//#define EMMC_PARAM_TEST
+//#define DBG_PORT
+//#define EMMC_DEBUG
+#define PHASE_INHERITED
+
+#define FORCE_CHECK_CMD_AND_STS
+
+#ifdef PHASE_INHERITED
+static u32 VP0_saved = 0xFF, VP1_saved =0xFF;
+#endif
+
+#define DQS_INHERITED
+#ifdef DQS_INHERITED
+static u32 dqs_saved = 0xff;
+#endif
+
+#ifdef RTK_EMMC_HEALTH_REPORT
+        int health_report_fd;
+#endif
+
+#define TIMEOUT_MS 3000
+#define TIMEOUT_DMA 50
+#define TIMEOUT_CMD 10000 //10 secs
+
+#ifdef MMC_DBG
+static unsigned sd_reg = 0;
+#endif
+
+#define UNSTUFF_BITS(resp,start,size)                                   \
+	({                                                              \
+		const int __size = size;                                \
+		const u32 __mask = (__size < 32 ? 1 << __size : 0) - 1; \
+		const int __off = 3 - ((start) / 32);                   \
+		const int __shft = (start) & 31;                        \
+		u32 __res;                                              \
+                                                                        \
+		__res = resp[__off] >> __shft;                          \
+		if (__size + __shft > 32)                               \
+			__res |= resp[__off-1] << ((32 - __shft) % 32); \
+		__res & __mask;                                         \
+	})
+
+struct mmc_host * mmc_host_local = NULL;
+static u32 rtk_emmc_bus_wid = 0;
+static volatile struct backupRegs gRegTbl;
+static volatile int g_bResuming;
+volatile int g_bTuning;
+//static int bSendCmd0=0;
+volatile unsigned int gCurrentBootMode=MODE_SDR;
+volatile unsigned int gPreventRetry=0;
+static volatile unsigned int  g_crinit=0;
+static struct rw_semaphore cr_rw_sem;
+//ip descriptor on ddr
+unsigned int* gddr_descriptor=NULL;
+static unsigned int* gddr_descriptor_org=NULL;
+//internal emmc dma buffer on ddr
+static unsigned char* gddr_dma=NULL;
+static unsigned char* gddr_dma_org=NULL;
+
+u32 rtkemmc_global_blksize;
+u32 rtkemmc_global_bytecnt;
+u32 rtkemmc_global_dbaddr;
+int cmd_resend=0;
+static u32 pddrive_nf_s0[5] = {0};
+static u32 pddrive_nf_s1[5] = {0};
+static u32 pddrive_nf_s2[5] = {0};
+static u32 pddrive_nf_s3[5] = {0};
+
+#ifndef CONFIG_ARCH_RTD16xx
+#define SHA256
+#endif
+
+#ifdef SHA256
+int MCP_SHA256(unsigned char *p_in, unsigned char *p_out, unsigned long len, unsigned int iv[8]);
+unsigned char *compare3=NULL;
+unsigned char *compare4=NULL;
+dma_addr_t          compare3_phy_addr;
+dma_addr_t          compare4_phy_addr;
+#else
+unsigned char compare1[DMA_ALLOC_LENGTH];
+unsigned char compare2[DMA_ALLOC_LENGTH];
+#endif
+
+struct reset_control *rstc_emmc;
+struct clk * clk_en_emmc;
+struct clk * clk_en_emmc_ip;
+#ifdef CONFIG_ARCH_RTD129x
+struct clk * clk_cr;
+#endif
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+#define MASK_DRTO 1
+#endif
+
+int rtkemmc_hs200_tuning(struct mmc_card *card);
+int mmc_hs400_to_hs200(struct mmc_card *card);
+int mmc_select_hs200(struct mmc_card *card);
+int mmc_select_ddr50(struct mmc_card *card);
+int rtkemmc_switch(struct mmc_card *card, u8 acc_mod, u8 index, u8 value, u8 cmd_set);
+#ifdef EMMC_DEBUG
+static void rtkemmc_dump_registers(struct rtkemmc_host *emmc_port);
+#endif
+static void rtkemmc_request(struct mmc_host *host, struct mmc_request *mrq);
+static int rtkemmc_get_ro(struct mmc_host *mmc);
+static void rtkemmc_set_ios(struct mmc_host *host, struct mmc_ios *ios);
+
+static void set_cmd_info(struct mmc_card *card,struct mmc_command * cmd,
+struct sd_cmd_pkt * cmd_info,u32 opcode,u32 arg,u8 rsp_para);
+
+static int rtkemmc_stop_transmission(struct mmc_card *card,int bIgnore);
+static int rtkemmc_send_status(struct mmc_card *card,u8 * state,u8 divider,int bIgnore);
+static int rtkemmc_wait_status(struct mmc_card *card,u8 state,u8 divider,int bIgnore);
+
+static void rtkemmc_set_wrapper_div(struct rtkemmc_host *emmc_port,u8 level);
+static int mmc_Tuning_SDR50(struct rtkemmc_host *emmc_port);
+static int mmc_Tuning_DDR50(struct rtkemmc_host *emmc_port,u32 mode);
+static int mmc_Tuning_HS200(struct rtkemmc_host *emmc_port,u32 mode);
+void set_RTK_initial_flag(int flag);
+static int rtkemmc_execute_tuning(struct mmc_host *host, u32 opcode);
+static int rtkemmc_prepare_hs400_tuning(struct mmc_host *host, struct mmc_ios *ios);
+void phase(struct rtkemmc_host *emmc_port, u32 VP0, u32 VP1);
+static void rtkemmc_chk_card_insert(struct rtkemmc_host *emmc_port);
+static void rtkemmc_set_pin_mux(struct rtkemmc_host *emmc_port);
+static u32 rtkemmc_chk_cmdcode(struct mmc_command* cmd);
+static void rtkemmc_backup_registers(struct rtkemmc_host *emmc_port);
+static void rtkemmc_restore_registers(struct rtkemmc_host *emmc_port);
+static void rtkemmc_set_ip_div(struct rtkemmc_host *emmc_port,u32 set_div);
+static void rtkemmc_set_freq(struct rtkemmc_host *emmc_port, u32 freq);
+int error_handling(struct rtkemmc_host *emmc_port, unsigned int cmd_idx, unsigned int bIgnore);
+int polling_to_tran_state(struct rtkemmc_host *emmc_port,int cmd_idx,int bIgnore);
+static int SD_SendCMDGetRSP(struct sd_cmd_pkt * cmd_info,int bIgnore);
+static int SD_SendCMDGetRSP_Cmd(struct sd_cmd_pkt *cmd_info,int bIgnore);
+void rtkemmc_set_pad_driving(struct rtkemmc_host *emmc_port, u32 clk_drv, u32 cmd_drv, u32 data_drv, u32 ds_drv);
+static int wait_done_timeout(struct rtkemmc_host *emmc_port, volatile u32 *addr, u32 mask, u32 value,const char *string);
+static void rtkemmc_set_bits(struct rtkemmc_host *emmc_port,u32 set_bit);
+static int SD_Stream_Cmd(u16 cmdcode,struct sd_cmd_pkt *cmd_info, unsigned int bIgnore);
+static void rtkemmc_dqs_tuning(struct mmc_host *host);
+int rtkemmc_select_timing(struct mmc_card *card);
+void rtkemmc_select_card_type(struct mmc_card *card);
+void down_speed_handling(struct rtkemmc_host *emmc_port);
+
+DECLARE_COMPLETION(rtk_emmc_wait);
+typedef void (*set_gpio_func_t)(u32 gpio_num,u8 dir,u8 level);
+
+
+int suspend = 0;
+int suspend_VP0=0xff, suspend_VP1=0xff;
+int HS200_RX=0xff, HS200_TX=0xff;
+int suspend_dqs=0x88;
+bool hs400_to_hs200_flag=false;
+
+static const struct mmc_host_ops rtkemmc_ops = {
+	.request        = rtkemmc_request,
+	.get_ro         = rtkemmc_get_ro,
+	.set_ios        = rtkemmc_set_ios,
+	.execute_tuning = rtkemmc_execute_tuning,
+	.prepare_hs400_tuning = rtkemmc_prepare_hs400_tuning,
+	.dqs_tuning = rtkemmc_dqs_tuning
+};
+
+static struct rtk_host_ops emmc_ops = {
+	.func_irq       = NULL,
+	.re_init_proc   = NULL,
+	.card_det       = NULL,
+	.card_power     = NULL,
+        .chk_card_insert= rtkemmc_chk_card_insert,
+        .set_crt_muxpad = rtkemmc_set_pin_mux,
+        .set_clk        = NULL,
+	.reset_card     = NULL,
+	.reset_host     = NULL,
+	.bus_speed_down = NULL,
+	.get_cmdcode    = NULL,
+	.get_r1_type    = NULL,
+	.chk_cmdcode    = rtkemmc_chk_cmdcode,
+	.chk_r1_type    = NULL,
+	.backup_regs    = rtkemmc_backup_registers,
+	.restore_regs   = rtkemmc_restore_registers,
+};
+
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+static int rtkemmc_request_hw_semaphore(void *iomem, unsigned int cnt)
+{
+	unsigned int val;
+	int i;
+
+	while (1) {
+		for (i=0; i<cnt; i++) {
+			val = readl(iomem);
+			if (val)
+				return 0;
+			msleep(100);
+		}
+		pr_err("rtk emmc get hw semaphore timeout\n");
+	}
+
+	return -1;
+}
+
+static void rtkemmc_release_hw_semaphore(void *iomem)
+{
+	writel(0, iomem);
+}
+#endif
+//---------------------------------------------------------------------------------------------------------------------------
+#ifdef CONFIG_RTK_ACPU_RELOAD
+//this part is set for avcpu.c usage
+
+static int rtkemmc_switch_user_partition(struct mmc_card *card)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	int err = 0;
+
+	MMCPRINTF("\n");
+
+	memset(&cmd, 0, sizeof(struct mmc_command));
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	set_cmd_info(card,&cmd,&cmd_info, MMC_SWITCH, 0x03b30001, 6);
+
+	err = SD_SendCMDGetRSP_Cmd(&cmd_info,0);
+
+	if(err){
+		mmcmsg3(KERN_WARNING "%s: MMC_SWITCH fail\n",DRIVER_NAME);
+	}
+	return err;
+}
+/* ========================================================
+ * blk_addr    : eMMC read/write target address, block base.
+ * data_size   : tarnsfer data size, block base.
+ * buffer      : DMA address
+ * rw_mode     : fast read or ast write
+ ========================================================== */
+#define FAST_READ   0x1278
+#define FAST_WRITE  0x3478
+static int mmc_fast_rw( unsigned int blk_addr, unsigned int data_size, unsigned char * buffer, unsigned int rw_mode )
+{
+	int err = 0;
+	struct mmc_host * mmc = mmc_host_local;
+	unsigned long flags;
+
+	if(mmc){
+		struct rtkemmc_host *emmc_port;
+		struct mmc_card *card;
+		struct mmc_request mrq = {0};
+		struct mmc_command cmd = {0};
+		struct mmc_data     data   = {0};
+		struct scatterlist sg;
+
+		emmc_port = mmc_priv(mmc);
+		mmc_claim_host(mmc);
+		spin_lock_irqsave(&emmc_port->lock,flags);
+
+		card = mmc->card;
+		if((emmc_port->rtflags & RTKCR_USER_PARTITION)==0){
+			int try_loop = 3;
+			do{
+				err = 0;
+				spin_unlock_irqrestore(&emmc_port->lock, flags);
+				err = rtkemmc_switch_user_partition(card);
+				spin_lock_irqsave(&emmc_port->lock,flags);
+
+			}while(try_loop-- && err );
+
+			if(err){
+				spin_unlock_irqrestore(&emmc_port->lock, flags);
+				mmc_release_host(mmc);
+				goto ERR_OUT;
+			}
+			else
+				emmc_port->rtflags |= RTKCR_USER_PARTITION;
+		}
+
+		if(data_size>1){
+			if(rw_mode == FAST_WRITE)
+				cmd.opcode = MMC_WRITE_MULTIPLE_BLOCK;
+			else
+				cmd.opcode = MMC_READ_MULTIPLE_BLOCK;
+		}else{
+			if(rw_mode == FAST_WRITE)
+				cmd.opcode = MMC_WRITE_BLOCK;
+			else
+				cmd.opcode = MMC_READ_SINGLE_BLOCK;
+		}
+
+		cmd.arg = blk_addr;
+		cmd.flags = MMC_RSP_R1 | MMC_CMD_ADTC;
+
+		if(data_size) {   //date info setting
+			data.sg = &sg;
+			data.sg_len = 1;
+			data.blksz = 512;
+			data.blocks = data_size;
+
+			sg_init_one(data.sg, buffer, (data_size<<9));
+
+			if(rw_mode == FAST_WRITE)
+				data.flags = MMC_DATA_WRITE;
+			else
+				data.flags = MMC_DATA_READ;
+
+			mmc_set_data_timeout(&data, card);
+		}
+
+		data.mrq = &mrq;
+		cmd.mrq = &mrq;
+		cmd.data = &data;
+		cmd.retries =5;
+CMD_RETRY:
+		mrq.data = &data;
+		mrq.cmd = &cmd;
+
+		if(emmc_port->mrq){
+			emmc_port->mrq = NULL;
+		}
+
+		cmd.error = 0;
+		data.error = 0;
+		spin_unlock_irqrestore(&emmc_port->lock, flags);
+		mmc_wait_for_req(mmc, &mrq);
+		spin_lock_irqsave(&emmc_port->lock,flags);
+		err = cmd.error;
+		if((err==0) && (rw_mode==FAST_WRITE))
+		{
+			spin_unlock_irqrestore(&emmc_port->lock, flags);
+			err = rtkemmc_wait_status(mmc->card,STATE_TRAN,0,0);
+			spin_lock_irqsave(&emmc_port->lock,flags);
+		}
+		if(err && cmd.retries){
+			printk("%s(%u)last retry %d counter.\n", __func__,__LINE__,cmd.retries);
+			cmd.retries--;
+			goto CMD_RETRY;
+		}
+		spin_unlock_irqrestore(&emmc_port->lock, flags);
+		mmc_release_host(mmc);
+	}else{
+		err = -ENODEV;
+	}
+ERR_OUT:
+	if(err)
+		printk("err=%d\n",err);
+
+	return err;
+}
+
+#define MAX_XFER_BLK_A    0x100
+#define MAX_XFER_BLK_B    0x400
+static int mmc_fast_rw_loop(unsigned int blk_addr, unsigned int data_size, unsigned char * buffer, unsigned int rw_mode )
+{
+	int err = 0;
+
+	unsigned int tmp_addr   = blk_addr;
+	unsigned int tmp_size   = data_size;
+	unsigned int org_size   = data_size;
+	unsigned char * tmp_buf = buffer;
+	unsigned int max_xfer_blk;
+	do{
+		// max 1M bytes read/write per transfer
+
+		max_xfer_blk = MAX_XFER_BLK_B;
+
+		if(data_size > max_xfer_blk){
+			tmp_size = max_xfer_blk;
+		}else{
+			tmp_size = data_size;
+		}
+
+		err = mmc_fast_rw(tmp_addr,tmp_size,tmp_buf,rw_mode);
+
+		if(err)
+			break;
+
+		if(data_size > max_xfer_blk){
+			tmp_addr    += max_xfer_blk;
+			data_size   -= max_xfer_blk;
+			tmp_buf     += (max_xfer_blk<<9);
+		}else{
+			data_size = 0;
+		}
+	}while(data_size);
+
+	if(err == 0)
+		return org_size-data_size;
+	else
+		return err;
+}
+
+int mmc_fast_read(unsigned int blk_addr, unsigned int data_size, unsigned char * buffer )
+{
+	int err = 0;
+	err = mmc_fast_rw_loop(blk_addr,data_size,buffer,FAST_READ);
+	return err;
+}
+EXPORT_SYMBOL(mmc_fast_read);
+
+int mmc_fast_write(unsigned int blk_addr, unsigned int data_size, unsigned char * buffer )
+{
+	int err = 0;
+	if(blk_addr<0x20000){
+		printk("target small then save area.\n");
+		err = -1;
+	}
+	err = mmc_fast_rw_loop(blk_addr,data_size,buffer,FAST_WRITE);
+	return err;
+}
+EXPORT_SYMBOL(mmc_fast_write);
+#endif
+//------------------------------------------------------------------------------------------------------------------------------
+void sync(struct rtkemmc_host *emmc_port)
+{
+	dmb(sy);
+    	writel(0x0, emmc_port->sb2_membase+0x20);
+    	dmb(sy);
+}
+
+static int rtkemmc_get_ro(struct mmc_host *mmc)
+{
+	return 0;
+}
+
+static int rtkemmc_prepare_hs400_tuning(struct mmc_host *host, struct mmc_ios *ios)
+{
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	if(host->doing_retune == 1) return 0;
+
+	struct rtkemmc_host *emmc_port;
+        emmc_port = mmc_priv(host);
+	printk(KERN_ERR "Prepare HS400 mode...\n");
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_lock2(flags2, _at_("rtkemmc_prepare_hs400_tuning"));
+#endif
+	rtkemmc_writel(0x88 ,emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_unlock2(flags2, _at_("rtkemmc_prepare_hs400_tuning"));
+#endif
+	return 0;
+}
+
+static void set_cmd_info(struct mmc_card *card,struct mmc_command * cmd, struct sd_cmd_pkt * cmd_info,u32 opcode,u32 arg,u8 rsp_para)
+{
+	memset(cmd, 0, sizeof(struct mmc_command));
+	memset(cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	cmd->opcode         = opcode;
+	cmd->arg            = arg;
+	cmd_info->cmd       = cmd;
+	cmd_info->emmc_port    = mmc_priv(card->host);
+	cmd_info->rsp_len   = rsp_para;
+}
+
+void print_reg_sts(u32 cmd_idx, u32 rintsts)
+{
+	printk(KERN_ERR "=====================================================\n");
+	printk(KERN_ERR "g_bTuning=%d cmd_idx 0x%08x, op_code 0x%02x(%d)\n",g_bTuning, cmd_idx, CMD_IDX_MASK(cmd_idx), CMD_IDX_MASK(cmd_idx));
+	if( rintsts & INT_STS_EBE ) {           printk(KERN_ERR "bit 15: Enb bit error(R), No CRC(W)\n");       }
+	if( rintsts & INT_STS_ACD ) {           printk(KERN_ERR "bit 14: Auto commanddone\n");  }
+	if( rintsts & INT_STS_SBE_BCI ) {       printk(KERN_ERR "bit 13: Start Bit Error, Busy Clear Int.\n");  }
+	if( rintsts & INT_STS_HLE ) {           printk(KERN_ERR "bit 12: Hardware locked write error\n");       }
+	if( rintsts & INT_STS_FRUN ) {          printk(KERN_ERR "bit 11: FIFIL underrun/overrun\n");    }
+	if( rintsts & INT_STS_HTO ) {           printk(KERN_ERR "bit 10: Data startvation by host timeout(HTO)\n");     }
+	if( rintsts & INT_STS_DRTO_BDS ) {      printk(KERN_ERR "bit  9: Data read timeout\n"); }
+	if( rintsts & INT_STS_RTO_BAR ) {       printk(KERN_ERR "bit  8: Response timeout\n");  }
+	if( rintsts & INT_STS_DCRC ) {          printk(KERN_ERR "bit  7: Data CRC error\n");    }
+	if( rintsts & INT_STS_RCRC ) {          printk(KERN_ERR "bit  6: Response CRC error\n");        }
+	if( rintsts & INT_STS_RXDR ) {          printk(KERN_ERR "bit  5: Receive FIFO data request(RXDT)\n");   }
+	if( rintsts & INT_STS_TXDR ) {          printk(KERN_ERR "bit  4: Transmit FIFO data request(TXDR)\n");  }
+	if( rintsts & INT_STS_DTO ) {           printk(KERN_ERR "bit  3: Data Transfer over(DTO)\n");   }
+	if( rintsts & INT_STS_CD ) {            printk(KERN_ERR "bit  2: Command done(CD)\n");  }
+	if( rintsts & INT_STS_RE ) {            printk(KERN_ERR "bit  1: Response error\n");    }
+	if( rintsts & INT_STS_CRD ) {           printk(KERN_ERR "bit  0: Card detect(CD)\n");   }
+	printk(KERN_ERR "=====================================================\n");
+}
+
+void print_ip_desc(struct rtkemmc_host *emmc_port)
+{ 
+	unsigned int bytecnt = 0, desc_cnt = 0, i = 0;
+	unsigned int paddr_base = emmc_port->desc_paddr;
+
+	printk(KERN_ERR "------------------------------>\n");
+	printk(KERN_ERR "EMMC IP_DESC0 = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_IP_DESC0));
+	printk(KERN_ERR "EMMC IP_DESC1 = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_IP_DESC1));
+	printk(KERN_ERR "EMMC IP_DESC2 = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_IP_DESC2));
+	printk(KERN_ERR "EMMC IP_DESC3 = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_IP_DESC3));
+
+	printk(KERN_ERR "EMMC BYTCNT = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_BYTCNT));
+	printk(KERN_ERR "EMMC CMDARG = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_CMDARG));
+	printk(KERN_ERR "EMMC DBADDR = 0x%08x\n------------------------------>\n", readl(emmc_port->emmc_membase+EMMC_DBADDR));
+
+	bytecnt = readl(emmc_port->emmc_membase+EMMC_BYTCNT);
+	desc_cnt = bytecnt / 4096;
+
+	for (i = 0 ; i < desc_cnt; i++){
+		printk(KERN_INFO "=============== %u-th set of descriptor==============\n", i);
+		printk(KERN_INFO "DESC0(0x%08x) = 0x%08x\n", paddr_base,  *(gddr_descriptor + 4*i));
+		printk(KERN_INFO"DESC1(0x%08x) = 0x%08x\n", paddr_base + 16*i + 4, *(gddr_descriptor + 4*i + 1));
+		printk(KERN_INFO "DESC2(0x%08x) = 0x%08x\n", paddr_base + 16*i + 8, *(gddr_descriptor + 4*i + 2));
+		printk(KERN_INFO "DESC3(0x%08x) = 0x%08x\n", paddr_base + 16*i + 12, *(gddr_descriptor + 4*i + 3));
+	}
+	printk(KERN_INFO "=====================================================\n");
+}
+
+void mmc_host_reset(struct rtkemmc_host *emmc_port)
+{
+//	unsigned long flags2;
+
+	MMCPRINTF("%s : \n", __func__);
+	//rtk_lockapi_lock2(flags2, _at_("mmc_host_reset"));
+	rtkemmc_writel(0x00000081, emmc_port->emmc_membase + EMMC_BMOD);
+	isb();
+	sync(emmc_port);
+	//rtkemmc_writel(0x00000001, emmc_port->emmc_membase + EMMC_CTRL);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x02000000, emmc_port->emmc_membase + EMMC_CTRL);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00000001, emmc_port->emmc_membase + EMMC_PWREN);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x0000ffce, emmc_port->emmc_membase + EMMC_INTMASK);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0xffffffff, emmc_port->emmc_membase + EMMC_RINTSTS);
+	isb();
+	sync(emmc_port);
+	//rtkemmc_writel(0x00000010, emmc_port->emmc_membase + EMMC_CTRL);
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writel(0x00000080, emmc_port->emmc_membase + EMMC_CLKDIV);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00000000, emmc_port->emmc_membase + EMMC_CLKSRC);
+	isb();
+	sync(emmc_port);
+	//rtkemmc_writel(0x0001ffff, emmc_port->emmc_membase + EMMC_CLKENA);
+	rtkemmc_writel(0x00010001, emmc_port->emmc_membase + EMMC_CLKENA);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0xa0200000, emmc_port->emmc_membase + EMMC_CMD);
+	isb();
+	sync(emmc_port);
+
+	MMCPRINTF(KERN_INFO "1 EMMC_TMOUT = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_TMOUT));
+	rtkemmc_writel(0xffffff40, (volatile void*)(emmc_port->emmc_membase + EMMC_TMOUT));
+	isb();
+	sync(emmc_port);
+	MMCPRINTF(KERN_INFO "2 EMMC_TMOUT = 0x%08x \n",  (volatile void*)readl(emmc_port->emmc_membase + EMMC_TMOUT));
+
+	rtkemmc_writel(0x00000000, emmc_port->emmc_membase + EMMC_CTYPE);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x0001007f, emmc_port->emmc_membase + EMMC_FIFOTH);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x02000010, emmc_port->emmc_membase + EMMC_CTRL);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00000080, emmc_port->emmc_membase + EMMC_BMOD);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x0000ffce, emmc_port->emmc_membase + EMMC_INTMASK);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00600000, emmc_port->emmc_membase + EMMC_DBADDR);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00000000, emmc_port->emmc_membase + EMMC_IDINTEN);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x0000ffff, emmc_port->emmc_membase + EMMC_RINTSTS);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00000001, emmc_port->emmc_membase + EMMC_UHSREG);
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x02000001, emmc_port->emmc_membase + EMMC_CARD_THR_CTL);	//boot code 0x01000001
+	isb();
+	sync(emmc_port);
+	//rtk_lockapi_unlock2(flags2, _at_("mmc_host_reset"));
+
+	MMCPRINTF("%s : \n", __func__);
+}
+static void rtkemmc_shutdown(struct platform_device *pdev)
+{
+	//struct device *dev = &pdev->dev;
+
+	printk(KERN_ERR "[eMMC] Shutdown\n");
+	pm_runtime_force_suspend(&pdev->dev);
+}
+
+#ifdef CONFIG_PM
+static int rtkemmc_suspend(struct device *dev)
+{
+	int ret = 0;
+	struct rtkemmc_host *emmc_port=NULL;
+	struct mmc_host *mmc = NULL;
+	suspend = 1;
+	mmc = mmc_host_local;
+	emmc_port = mmc_priv(mmc);
+	if(RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		printk(KERN_ERR "[%s] Enter %s Idle mode\n",DRIVER_NAME, __func__);
+		//rtkemmc_backup_registers(emmc_port);
+	}else{
+		//For suspend mode
+		printk(KERN_ERR "[%s] Enter %s Suspend mode\n",DRIVER_NAME, __func__);
+	}
+
+	ret = pm_runtime_force_suspend(dev);
+	printk(KERN_ERR "[%s] Exit %s\n",DRIVER_NAME,__func__);
+	return ret;
+}
+
+static int rtkemmc_resume(struct device *dev)
+{
+	int ret = 0;
+	struct mmc_host *mmc = NULL;
+	struct rtkemmc_host *emmc_port=NULL;
+	struct mmc_host *host = NULL;
+
+	mmc = mmc_host_local;
+	emmc_port = mmc_priv(mmc);
+	if (!emmc_port)
+		BUG();
+    
+	host = emmc_port->mmc;
+	host->card->host = mmc;
+	g_bResuming=1;
+
+	if(RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		printk(KERN_ERR "[%s] Enter %s Idle mode\n",DRIVER_NAME, __func__);
+		//rtkemmc_restore_registers(emmc_port);
+	}else{
+		//For suspend mode
+		printk(KERN_ERR "[%s] Enter %s Suspend mode\n",DRIVER_NAME, __func__);
+	}
+
+	if (!ret)
+		ret = pm_runtime_force_resume(dev);
+
+	rtkemmc_set_pin_mux(emmc_port);
+	rtkemmc_chk_card_insert(emmc_port);
+	sync(emmc_port);
+
+	g_bResuming=0;
+	init_completion(emmc_port->int_waiting);
+	printk(KERN_ERR "[%s] Exit %s\n",DRIVER_NAME,__func__);
+
+	return ret;
+}
+
+static const struct dev_pm_ops rtk_dev_pm_ops = {
+	SET_SYSTEM_SLEEP_PM_OPS(rtkemmc_suspend, rtkemmc_resume)
+};
+#endif
+
+void card_stop(struct rtkemmc_host *emmc_port)
+{
+#ifdef CONFIG_ARCH_RTD129x
+        unsigned long flags2;
+	volatile u32 reg;
+#endif
+#ifdef EMMC_DEBUG
+        printk(KERN_ERR "card_stop - start\n");
+#endif
+#ifdef CONFIG_ARCH_RTD129x
+        rtk_lockapi_lock2(flags2, _at_("card_stop2"));
+#endif
+        rtkemmc_backup_registers(emmc_port);
+	reset_control_assert(rstc_emmc);
+        sync(emmc_port);
+
+	clk_disable_unprepare(clk_en_emmc);
+	clk_disable_unprepare(clk_en_emmc_ip);
+	sync(emmc_port);
+
+#ifdef CONFIG_ARCH_RTD129x
+	//kylin A01 and HS400 mode need to reset this dummy register
+	if (get_rtd_chip_revision() >= RTD_CHIP_A01 &&
+		(get_rtd_chip_revision() < RTD_CHIP_B00 || (emmc_port->mmc->caps2 & MMC_CAP2_HS400_1_8V)==MMC_CAP2_HS400_1_8V)) {
+                reg = readl(emmc_port->crt_membase + SYS_DUMMY);
+                isb();
+                sync(emmc_port);
+                rtkemmc_writel(reg&0xfffffffd, emmc_port->crt_membase + SYS_DUMMY);
+                isb();
+                sync(emmc_port);
+        }
+#else
+	//1395 HS400 mode TBD
+#endif
+
+	reset_control_deassert(rstc_emmc);
+        sync(emmc_port);
+
+	clk_prepare_enable(clk_en_emmc);
+        clk_prepare_enable(clk_en_emmc_ip);
+        sync(emmc_port);
+
+#ifdef CONFIG_ARCH_RTD129x
+	//kylin A01 and HS400 mode need to reset this dummy register
+	if (get_rtd_chip_revision() >= RTD_CHIP_A01 &&
+		(get_rtd_chip_revision() < RTD_CHIP_B00 || (emmc_port->mmc->caps2 & MMC_CAP2_HS400_1_8V)==MMC_CAP2_HS400_1_8V)) {
+                reg = readl(emmc_port->crt_membase + SYS_DUMMY);
+                isb();
+                sync(emmc_port);
+                rtkemmc_writel(reg | 0x00000002, emmc_port->crt_membase + SYS_DUMMY);
+                isb();
+                sync(emmc_port);
+        }
+#else
+	//1395 HS400 mode TBD
+#endif
+
+#ifdef CONFIG_ARCH_RTD129x
+	//1395 does not need to toggle this register
+        if (get_rtd_chip_revision() >= RTD_CHIP_A01 ) {
+                rtkemmc_writel( readl(emmc_port->emmc_membase + EMMC_DUMMY_SYS) ^ 0x40000000, emmc_port->emmc_membase + EMMC_DUMMY_SYS);
+                isb();
+                sync(emmc_port);
+                udelay(200);
+        }
+#endif
+
+#if defined(CONFIG_ARCH_RTD129x)
+	rtkemmc_writel(gRegTbl.emmc_mux_pad0, emmc_port->emmc_membase + EMMC_muxpad0);
+        rtkemmc_writel(gRegTbl.emmc_mux_pad1, emmc_port->emmc_membase + EMMC_muxpad1);
+        rtkemmc_writel(gRegTbl.emmc_pfunc_nf1, emmc_port->emmc_membase + EMMC_PFUNC_NF1);
+        rtkemmc_writel(gRegTbl.emmc_pfunc_cr, emmc_port->emmc_membase + EMMC_PFUNC_CR);
+        rtkemmc_writel(gRegTbl.emmc_pdrive_nf1, emmc_port->emmc_membase + EMMC_PDRIVE_NF1);
+        rtkemmc_writel(gRegTbl.emmc_pdrive_nf2, emmc_port->emmc_membase + EMMC_PDRIVE_NF2);
+        rtkemmc_writel(gRegTbl.emmc_pdrive_nf3, emmc_port->emmc_membase + EMMC_PDRIVE_NF3);
+        rtkemmc_writel(gRegTbl.emmc_pdrive_nf4, emmc_port->emmc_membase + EMMC_PDRIVE_NF4);
+/*	//139x and 16xx does not need to restore the pad mux part, only 129x needs to take this action
+#elif defined(CONFIG_ARCH_RTD139x)
+	rtkemmc_writel(gRegTbl.iso_muxpad4,emmc_port->iso_muxpad + ISO_muxpad4);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc0,emmc_port->iso_muxpad + pfunc_emmc0);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc1,emmc_port->iso_muxpad + pfunc_emmc1);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc2,emmc_port->iso_muxpad + pfunc_emmc2);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc3,emmc_port->iso_muxpad + pfunc_emmc3);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc4,emmc_port->iso_muxpad + pfunc_emmc4);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc5,emmc_port->iso_muxpad + pfunc_emmc5);
+*/
+#endif
+
+#ifdef CONFIG_ARCH_RTD129x
+        rtkemmc_writel(gRegTbl.emmc_pdrive_cr0, emmc_port->emmc_membase + EMMC_PDRIVE_CR0);
+        rtkemmc_writel(gRegTbl.emmc_pdrive_cr1, emmc_port->emmc_membase + EMMC_PDRIVE_CR1);
+        rtkemmc_writel(gRegTbl.emmc_pdrive_sdio, emmc_port->emmc_membase + EMMC_PDRIVE_SDIO);
+        rtkemmc_writel(gRegTbl.emmc_pdrive_sdio1, emmc_port->emmc_membase + EMMC_PDRIVE_SDIO1);
+#endif
+        rtkemmc_writel(gRegTbl.emmc_ckgen_ctl, emmc_port->emmc_membase + EMMC_CKGEN_CTL);
+        isb();
+        sync(emmc_port);
+	mmc_host_reset(emmc_port);
+
+        rtkemmc_writel(gRegTbl.emmc_ctype, emmc_port->emmc_membase + EMMC_CTYPE);
+        rtkemmc_writel(gRegTbl.emmc_uhsreg, emmc_port->emmc_membase + EMMC_UHSREG);
+        rtkemmc_writel(gRegTbl.emmc_ddr_reg, emmc_port->emmc_membase + EMMC_DDR_REG);
+        rtkemmc_writel(gRegTbl.emmc_card_thr_ctl, emmc_port->emmc_membase + EMMC_CARD_THR_CTL);
+	if(gCurrentBootMode == MODE_HS400) {
+		rtkemmc_writel(gRegTbl.emmc_dqs_ctrl1 | 0x80, emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+#if defined(CONFIG_ARCH_RTD139x)
+		rtkemmc_writel(0x94, emmc_port->emmc_membase+0x530); //dqs dly tap
+		rtkemmc_writel(0x14, emmc_port->emmc_membase+0x534); //dqs dly tap
+		rtkemmc_writel(0x14, emmc_port->emmc_membase+0x538); //dqs dly tap
+		rtkemmc_writel(0x14, emmc_port->emmc_membase+0x53c); //dqs dly tap
+		rtkemmc_writel(0x14, emmc_port->emmc_membase+0x540); //dqs dly tap
+		rtkemmc_writel(0x14, emmc_port->emmc_membase+0x544); //dqs dly tap
+		rtkemmc_writel(0x14, emmc_port->emmc_membase+0x548 ); //dqs dly tap
+		rtkemmc_writel(0x14, emmc_port->emmc_membase+0x54c); //dqs dly tap
+		rtkemmc_writel(0xff00, emmc_port->emmc_membase+0x50c); //dqs dly tap
+		rtkemmc_writel(0x94, emmc_port->emmc_membase+0x558);
+		rtkemmc_writel(0x2, emmc_port->emmc_membase+0x550);
+#elif defined(CONFIG_ARCH_RTD16xx)
+		rtkemmc_writel(0x80, emmc_port->emmc_membase+0x530); //dqs dly tap
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+0x534); //dqs dly tap
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+0x538); //dqs dly tap
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+0x53c); //dqs dly tap
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+0x540); //dqs dly tap
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+0x544); //dqs dly tap
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+0x548 ); //dqs dly tap
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+0x54c); //dqs dly tap
+		rtkemmc_writel(0xff00, emmc_port->emmc_membase+0x50c); //dqs dly tap
+		rtkemmc_writel(0xb4, emmc_port->emmc_membase+0x554);
+		rtkemmc_writel(0xb4, emmc_port->emmc_membase+0x558);
+		rtkemmc_writel(0x3, emmc_port->emmc_membase+0x550);
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+0x554);
+#endif
+	}
+	else {
+		rtkemmc_writel(gRegTbl.emmc_dqs_ctrl1, emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+	}
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+        writel(gRegTbl.emmc_drto_mask_ori, emmc_port->emmc_membase + EMMC_DUMMY_SYS);	//emmc timeout mechanism enable/disable
+	writel(gRegTbl.emmc_other1, emmc_port->emmc_membase + EMMC_OTHER1);	//emmc L4 gated setting restored
+#endif
+        isb();
+        sync(emmc_port);
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_CLKENA); // 0x10, clk enable, disable clock
+        isb();
+        sync(emmc_port);
+
+        rtkemmc_writel(0xa0202000, emmc_port->emmc_membase + EMMC_CMD); // 0x10, clk enable, disable clock
+        isb();
+        sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+        rtk_lockapi_unlock2(flags2, _at_("card_stop"));
+#endif
+	// 0x2c, wait for CIU to take the command
+        wait_done_timeout(emmc_port, emmc_port->emmc_membase + EMMC_CMD, 0x80000000, 0, __func__);
+
+#ifdef CONFIG_ARCH_RTD129x
+        rtk_lockapi_lock2(flags2, _at_("card_stop"));
+#endif
+        rtkemmc_writel(gRegTbl.emmc_clk_div, emmc_port->emmc_membase + EMMC_CLKDIV);
+        isb();
+        sync(emmc_port);
+
+        rtkemmc_writel(0xa0202000, emmc_port->emmc_membase + EMMC_CMD);  // 0x2c = start_cmd, upd_clk_reg_only, wait_prvdata_complete
+        isb();
+        sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+        rtk_lockapi_unlock2(flags2, _at_("card_stop"));
+#endif
+	wait_done_timeout(emmc_port, emmc_port->emmc_membase + EMMC_CMD, 0x80000000,0, __func__);
+#ifdef CONFIG_ARCH_RTD129x
+        rtk_lockapi_lock2(flags2, _at_("card_stop"));
+#endif
+        rtkemmc_writel(0x10001, emmc_port->emmc_membase + EMMC_CLKENA); // 0x10, clk enable, disable clock
+        isb();
+        sync(emmc_port);
+
+        rtkemmc_writel(0xa0202000, emmc_port->emmc_membase + EMMC_CMD);  // 0x2c = start_cmd, upd_clk_reg_only, wait_prvdata_complete
+        isb();
+        sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+        rtk_lockapi_unlock2(flags2, _at_("card_stop"));
+#endif
+        // 0x2c, wait for CIU to take the command
+        wait_done_timeout(emmc_port, emmc_port->emmc_membase + EMMC_CMD, 0x80000000,0, __func__);
+#ifdef EMMC_DEBUG
+        printk(KERN_ERR "card_stop - end\n");
+#if defined(CONFIG_ARCH_RTD129x)
+        rtk_lockapi_lock2(flags2, _at_("card_stop"));
+        printk (KERN_ERR "muxpad1- 0x%08x\n", readl(emmc_port->emmc_membase + EMMC_muxpad1));
+        rtk_lockapi_unlock2(flags2, _at_("card_stop"));
+#elif defined(CONFIG_ARCH_RTD139x)
+	printk (KERN_ERR "muxpad4- 0x%08x\n", readl(emmc_port->iso_muxpad + ISO_muxpad4));
+#elif defined(CONFIG_ARCH_RTD16xx)
+	printk (KERN_ERR "m2tmx_muxpad0- 0x%08x\n", readl(emmc_port->m2tmx + m2tmx_muxpad0));
+#endif
+#endif
+}
+
+static int rtkemmc_send_cmd13(struct rtkemmc_host *emmc_port, u16 * state)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	int err=0;
+	memset(&cmd, 0, sizeof(struct mmc_command));
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	cmd.opcode         = MMC_SEND_STATUS;
+	cmd.arg            = (1<<RCA_SHIFTER);
+	cmd_info.cmd       = &cmd;
+	cmd_info.emmc_port = emmc_port;
+	cmd_info.rsp_len   = 6;
+
+	gPreventRetry=1;
+	err = SD_SendCMDGetRSP(&cmd_info,1);
+	gPreventRetry=0;
+
+	if(err)
+		mmcmsg3(KERN_WARNING "%s: MMC_SEND_STATUS fail\n",DRIVER_NAME);
+	else {
+		u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
+		*state = cur_state;
+		mmcmsg1("cur_state=%s\n",state_tlb[cur_state]);
+	}
+
+	return err;
+}
+
+int rtkemmc_send_cmd18(struct rtkemmc_host *emmc_port, int size, unsigned long addr)
+{
+	int ret_err=0;
+	struct sd_cmd_pkt cmd_info;
+	struct mmc_host *host = emmc_port->mmc;
+	unsigned char *crd_tmp_buffer=NULL;
+	struct mmc_data *data=NULL;
+	struct mmc_command *cmd=NULL;
+	int i=0;
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	memset(&cmd_info, 0x00, sizeof(struct sd_cmd_pkt));
+
+	crd_tmp_buffer = (unsigned char *)emmc_port->dma_paddr;
+//	printk(KERN_ERR "crd_tmp_buffer=%p, emmc_port->dma_paddr=%p, gddr_dma_org=%p\n",crd_tmp_buffer,emmc_port->dma_paddr,gddr_dma_org);
+	if (crd_tmp_buffer == NULL) {
+		printk(KERN_ERR "%s,%s : crd_tmp_buffer == NULL\n",DRIVER_NAME,__func__);
+		return -5;
+	}
+
+	for(i=0;i<(size/4);i++) {
+		*(u32 *)(gddr_dma_org+(i*4)) = 0xdeadbeef;
+		//isb();
+		//sync(emmc_port);
+	}
+	wmb();
+
+	if (cmd_info.cmd == NULL) {
+		cmd  = (struct mmc_command*) kmalloc(sizeof(struct mmc_command),GFP_KERNEL);
+		memset(cmd, 0x00, sizeof(struct mmc_command));
+		cmd_info.cmd  = (struct mmc_command*) cmd;
+	}
+	cmd_info.emmc_port = emmc_port;
+	cmd_info.cmd->arg = addr;
+	cmd_info.cmd->opcode = MMC_READ_MULTIPLE_BLOCK;
+	cmd_info.rsp_len         = 6;
+	cmd_info.byte_count  = 0x200;
+	cmd_info.block_count = size/cmd_info.byte_count;
+	cmd_info.dma_buffer = crd_tmp_buffer;
+
+	if (cmd_info.cmd->data == NULL) {
+		data  = (struct mmc_data*) kmalloc(sizeof(struct mmc_data),GFP_KERNEL);
+		memset(data, 0x00, sizeof(struct mmc_data));
+		cmd_info.cmd->data = data;
+		data->flags = MMC_DATA_READ;
+	}
+	else
+		cmd_info.cmd->data->flags = MMC_DATA_READ;
+	MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x -------\n",
+		__FILE__, __func__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card);
+	ret_err = SD_Stream_Cmd(EMMC_AUTOREAD1, &cmd_info, 1);
+#ifdef CONFIG_ARCH_RTD139x
+	if(get_rtd_chip_revision() < RTD_CHIP_A01) {
+		if(readl(emmc_port->emmc_membase + EMMC_BYTCNT) == readl(emmc_port->emmc_membase + EMMC_TBBCNT))
+			writel(0x2,emmc_port->emmc_membase+EMMC_ISR);
+	}
+	else {
+		if (readl(emmc_port->emmc_membase+EMMC_ISR) & ISR_DMA_DONE_INT)
+			writel(0x2,emmc_port->emmc_membase+EMMC_ISR);
+	}
+#else
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_lock2(flags2, _at_("rtkemmc_send_cmd18"));
+#endif
+	if (readl(emmc_port->emmc_membase+EMMC_ISR) & ISR_DMA_DONE_INT)
+		writel(0x2,emmc_port->emmc_membase+EMMC_ISR);
+#ifdef CONFIG_ARCH_RTD129x
+        rtk_lockapi_unlock2(flags2, _at_("rtkemmc_send_cmd18"));
+#endif
+#endif
+	if (ret_err) {
+#ifdef EMMC_DEBUG
+		printk(KERN_ERR "Tuning rx cmd 18 err: size=%d, EMMC_RINTSTS=0x%x, EMMC_STATUS=0x%x\n", size, readl(emmc_port->emmc_membase + EMMC_RINTSTS),readl(emmc_port->emmc_membase + EMMC_STATUS));
+#endif
+		if((readl(emmc_port->emmc_membase+EMMC_RINTSTS)&0x4000)==0)
+			rtkemmc_stop_transmission(host->card, 1);
+		polling_to_tran_state(emmc_port,MMC_READ_MULTIPLE_BLOCK,1);
+		wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_STATUS), 0x2f0, 0x0, __func__);          //card is not busy
+		card_stop(emmc_port);
+        }
+
+	if (cmd) {
+		kfree(cmd);
+		cmd_info.cmd = NULL;
+		cmd=NULL;
+	}
+	if (data) {
+		kfree(data);
+		//cmd_info.cmd->data = NULL;
+		data=NULL;
+	}
+	return ret_err;
+}
+
+int rtkemmc_send_cmd25(struct rtkemmc_host *emmc_port,int size, unsigned long addr, int data_src, int *hs400_data)
+{
+        int ret_err=0,i=0;
+        struct sd_cmd_pkt cmd_info;
+        struct mmc_host *host = emmc_port->mmc;
+        char *crd_tmp_buffer=NULL;
+        struct mmc_data *data=NULL;
+        struct mmc_command *cmd=NULL;
+//      unsigned long flags=0;
+//	unsigned long flags2;
+        memset(&cmd_info, 0x00, sizeof(struct sd_cmd_pkt));
+
+        crd_tmp_buffer = (unsigned char *) emmc_port->dma_paddr;
+//	printk(KERN_ERR "crd_tmp_buffer=%p, emmc_port->dma_paddr=%p, gddr_dma_org=%p\n",crd_tmp_buffer,emmc_port->dma_paddr,gddr_dma_org);
+        if (crd_tmp_buffer == NULL)
+        {
+                printk(KERN_ERR "%s,%s : crd_ext_csd == NULL\n",DRIVER_NAME,__func__);
+                return -5;
+        }
+
+	if(data_src==0) {
+		for(i=0;i<(size/4);i++)
+		{
+			if(GLOBAL==0x80000000) GLOBAL=0;
+			else GLOBAL++;
+			*(u32 *)(gddr_dma_org+(i*4)) = GLOBAL;
+		}
+	}
+	else if(data_src==1) {
+		for(i=0;i<(size/4);i++)
+                {
+                        if(GLOBAL==0x80000000) GLOBAL=0;
+                        else GLOBAL++;
+                        *(u32 *)(gddr_dma_org+(i*4)) = hs400_data[i];
+                }
+	}
+	else printk(KERN_ERR "data_source flag should be 0 or 1\n");
+
+        wmb();
+
+        if (cmd_info.cmd == NULL)
+        {
+                cmd  = (struct mmc_command*) kmalloc(sizeof(struct mmc_command),GFP_KERNEL);
+                memset(cmd, 0x00, sizeof(struct mmc_command));
+                cmd_info.cmd  = (struct mmc_command*) cmd;
+        }
+
+        cmd_info.emmc_port = emmc_port;
+        cmd_info.cmd->arg = addr;
+        cmd_info.cmd->opcode = MMC_WRITE_MULTIPLE_BLOCK;
+        cmd_info.rsp_len         = 6;
+        cmd_info.byte_count  = 0x200;
+        cmd_info.block_count = size/cmd_info.byte_count;
+        cmd_info.dma_buffer = crd_tmp_buffer;
+
+	if (cmd_info.cmd->data == NULL)
+        {
+                data  = (struct mmc_data*) kmalloc(sizeof(struct mmc_data),GFP_KERNEL);
+                memset(data, 0x00, sizeof(struct mmc_data));
+                cmd_info.cmd->data = data;
+                data->flags = MMC_DATA_WRITE;
+        }
+        else
+                cmd_info.cmd->data->flags = MMC_DATA_WRITE;
+
+        MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x , cmd=0x%08x, data=0x%08x-------\n",
+                __FILE__, __func__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card,cmd,data);
+        ret_err = SD_Stream_Cmd(EMMC_AUTOWRITE1, &cmd_info, 1);
+        if (ret_err)
+        {
+#ifdef EMMC_DEBUG
+		printk(KERN_ERR "Tuning tx cmd 25 err: size=%d, EMMC_RINTSTS=0x%x, EMMC_STATUS=0x%x\n",size, readl(emmc_port->emmc_membase + EMMC_RINTSTS),readl(emmc_port->emmc_membase + EMMC_STATUS));
+#endif
+		if((readl(emmc_port->emmc_membase+EMMC_RINTSTS)&0x4000)==0)
+			rtkemmc_stop_transmission(host->card, 1);
+		polling_to_tran_state(emmc_port,MMC_WRITE_MULTIPLE_BLOCK,1);
+		wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_STATUS), 0x2f0, 0x0, __func__);          //card is not busy
+		card_stop(emmc_port);
+        }
+        MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x , cmd=0x%08x, data=0x%08x-------\n",
+                __FILE__, __func__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card,cmd,data);
+#if 1
+        if (cmd)
+        {
+                cmd_info.cmd = NULL;
+                kfree(cmd);
+                cmd=NULL;
+        }
+        if (data)
+        {
+                //cmd_info.cmd->data = NULL;
+                kfree(data);
+                data=NULL;
+        }
+#endif
+        sync(emmc_port);
+        return ret_err;
+}
+
+int search_best(u32 window, u32 range)
+{
+        int i, j, k, max;
+        int window_temp[32];
+        int window_start[32];
+        int window_end[32];
+        int window_max=0;
+        int window_best=0;
+        int parse_end=1;
+
+        for( i=0; i<0x20; i++ ) {
+                window_temp[i]=0;
+                window_start[i]=0;
+                window_end[i]=-1;
+        }
+        j=1;
+        i=0;
+        k=0;
+        max=0;
+	while((i<(range-1)) && (k<(range-1))){
+                parse_end=0;
+                for( i=window_end[j-1]+1; i<range; i++ ){
+                        if (((window>>i)&1)==1 ){
+                                window_start[j]=i;
+                                break;
+                        }
+                }
+                if( i==range){
+                        break;
+                }
+                for( k=window_start[j]+1; k<range; k++ ){
+                        if(((window>>k)&1)==0){
+                                window_end[j]=k-1;
+                                parse_end=1;
+                                break;
+                        }
+                }
+                if(parse_end==0){
+                        window_end[j]=range-1;
+                }
+                j++;
+        }
+        for(i=1; i<j; i++){
+                window_temp[i]= window_end[i]-window_start[i]+1;
+        }
+        if((((window)&1)==1)&&(((window>>(range-1))&1)==1))
+        {
+                window_temp[1]=window_temp[1]+window_temp[j-1];
+                window_start[1]=window_start[j-1];
+        }
+        for(i=1; i<j; i++){
+                if(window_temp[i]>window_max){
+                        window_max=window_temp[i];
+                        max=i;
+                }
+        }
+	if(window==0xffffffff){
+                window_best=0x10;
+        }
+        else if((window==0xffff)&&(range==0x10)){
+                window_best=0x8;
+                }
+        else if((((window&1)==1)&&(((window>>(range-1))&1)==1))&&(max==1)){
+		window_best=(((window_start[max]+window_end[max]+range)/2)&(range-1));
+        }
+        else {
+                window_best=((window_start[max]+window_end[max])/2)&0x1f;
+        }
+        return window_best;
+}
+
+void rtkemmc_hw_reset(void)
+{
+        struct mmc_host * mmc = mmc_host_local;
+        struct rtkemmc_host *emmc_port;
+        emmc_port = mmc_priv(mmc);
+        if(emmc_port!=NULL) {
+                u32 reg_val=0;
+#if defined(CONFIG_ARCH_RTD129x)
+                printk(KERN_ERR "muxpad0=0x%x, before emmc do hw reset...\n",readl(emmc_port->emmc_membase + EMMC_muxpad0));
+                reg_val = readl(emmc_port->emmc_membase + EMMC_muxpad0);
+                reg_val &= ~0xFFFF0C3C;
+                reg_val |= 0xaaaa0828;
+                rtkemmc_writel(reg_val, emmc_port->emmc_membase+EMMC_muxpad0);
+                mdelay(1);
+                printk(KERN_ERR "muxpad0=0x%x, emmc do really hw reset...\n",readl(emmc_port->emmc_membase + EMMC_muxpad0));
+#elif defined(CONFIG_ARCH_RTD139x)
+		printk(KERN_ERR "isopad4=0x%x, before emmc do hw reset...\n",readl(emmc_port->iso_muxpad + ISO_muxpad4));
+		reg_val = readl(emmc_port->iso_muxpad + ISO_muxpad4);
+		reg_val &= ~0x3;
+		reg_val |= 0x2;
+		rtkemmc_writel(reg_val, emmc_port->iso_muxpad + ISO_muxpad4);
+		mdelay(1);
+		printk(KERN_ERR "isopad4=0x%x, emmc do really hw reset...\n",readl(emmc_port->iso_muxpad + ISO_muxpad4));
+#elif defined(CONFIG_ARCH_RTD16xx)
+		printk(KERN_ERR "m2tmx_muxpad0=0x%x, before emmc do hw reset...\n",readl(emmc_port->m2tmx + m2tmx_muxpad0));
+		reg_val = readl(emmc_port->m2tmx + m2tmx_muxpad0);
+		reg_val &= 0xfe000001;  //bit 1 - bit 24 set 0x10 0x10 0x10...0x10
+		reg_val |= 0x01555554;
+		rtkemmc_writel(reg_val, emmc_port->m2tmx + m2tmx_muxpad0);
+		mdelay(1);
+		printk(KERN_ERR "m2tmx_muxpad0=0x%x, after emmc do hw reset...\n",readl(emmc_port->m2tmx + m2tmx_muxpad0));
+#endif
+                writel(0x0, emmc_port->emmc_membase+0x78);
+                mdelay(1);
+                writel(0x1, emmc_port->emmc_membase+0x78);
+        }
+
+}
+EXPORT_SYMBOL(rtkemmc_hw_reset);
+
+void rtkemmc_phase_tuning(struct rtkemmc_host *emmc_port,u32 mode,int flag)
+{
+	u32 TX_window=0;
+        u32 RX_window=0;
+	u32 TX1_window=0;
+	int TX_best=0x0;
+	int RX_best=0x0;
+	int TX1_best=0x0;
+        int i=0;
+        u32 range=0;
+        u16 state=0;
+
+        if (mode == MODE_HS400 || mode == MODE_DDR)
+                range = 0x10;
+        else
+                range = 0x20;
+
+	if(hs400_to_hs200_flag==true && (emmc_port->tx_tuning && emmc_port->rx_tuning)) {
+		hs400_to_hs200_flag=false;
+		phase(emmc_port, HS200_TX, HS200_RX);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+	udelay(1);
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+		sync(emmc_port);
+                printk(KERN_ERR "down speed to hs200: restore tx & rx phase: TX=0x%x, RX=0x%x\n", HS200_TX, HS200_RX);
+		return;
+	}
+	if(suspend == 1 && (emmc_port->tx_tuning || emmc_port->rx_tuning) && emmc_port->mmc->card->cid.manfid != 0x13)
+	{
+		if(emmc_port->tx_tuning==0 && emmc_port->rx_tuning==1) {
+			phase(emmc_port, VP0_saved, suspend_VP1);
+		}
+		else if(emmc_port->tx_tuning==1 && emmc_port->rx_tuning==0)
+		{
+			phase(emmc_port, suspend_VP0, VP1_saved);
+		}
+		else {
+			phase(emmc_port, suspend_VP0, suspend_VP1);
+		}
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+		sync(emmc_port);
+		printk(KERN_ERR "suspend/resume: restore tx & rx phase: TX=0x%x, RX=0x%x\n", suspend_VP0, suspend_VP1);
+		if(mode == MODE_HS200) {
+			suspend = 0;
+		}
+		return;
+	}
+#ifdef PHASE_INHERITED
+	if (emmc_port->tx_tuning || emmc_port->rx_tuning){
+                phase(emmc_port, (emmc_port->tx_tuning)?0xff:VP0_saved, (emmc_port->rx_tuning)?0xff:VP1_saved);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+                sync(emmc_port);
+        }
+        else {
+                phase(emmc_port, VP0_saved, VP1_saved); //VP0, VP1 phase
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+                sync(emmc_port);
+		printk(KERN_INFO "Inherit bootcode tuning phase: TX=0x%x, RX=0x%x\n", VP0_saved, VP1_saved);
+                return;
+        }
+#else
+	phase(emmc_port, 0, 0); //VP0, VP1 phase
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+	udelay(1);
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+	mdelay(5);
+        sync(emmc_port);
+#endif
+/*	if(emmc_port->tx_tuning || emmc_port->rx_tuning)
+                card_stop(emmc_port);*/
+
+	if (emmc_port->tx_tuning) {
+		if (mode == MODE_DDR && flag==1)
+			printk(KERN_ERR "Start DDR50 TX Tuning:\n");
+		else if (mode == MODE_HS400 && flag==1)
+			printk(KERN_ERR "Start HS400 TX Tuning: \n");
+		else if(flag==1)
+			printk(KERN_ERR "Start HS200 TX Tuning:\n");
+                for(i=0;i<range;i++) {
+                        phase(emmc_port, i, 0xff);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+			writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+			udelay(1);
+			writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+#ifdef DEBUG
+                        printk("phase =0x%x \n", i);
+#endif
+
+                        if(rtkemmc_send_cmd13(emmc_port, &state) != 0)
+                                TX_window= TX_window&(~(1<<i));
+                        else
+                                TX_window= TX_window|((1<<i));
+                }
+		TX_best = search_best(TX_window, range);
+		if(flag==1)printk(KERN_ERR "TX_WINDOW = 0x%08x TX_best=0x%x\n", TX_window, TX_best);
+                phase(emmc_port, TX_best, 0xff);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+        }
+
+	if (emmc_port->rx_tuning) {
+		if (mode == MODE_DDR && flag==1)
+			printk(KERN_ERR "Start DDR50 RX Tuning:\n");
+		else if (mode == MODE_HS400 && flag==1)
+			printk(KERN_ERR "Start HS400 RX Tuning:\n");
+		else if(flag==1)
+			printk(KERN_ERR "Start HS200 RX Tuning:\n ");
+                for(i=0;i<range;i++) {
+                        phase(emmc_port, 0xff, i);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+			writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+			udelay(1);
+			writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+#ifdef DEBUG
+                        printk("phase =0x%x \n", i);
+#endif
+                        if(rtkemmc_send_cmd18(emmc_port, 1024, 0x100) != 0)
+                                RX_window= RX_window&(~(1<<i));
+                        else
+                                RX_window= RX_window|((1<<i));
+                }
+		RX_best = search_best(RX_window, range);
+                if(flag==1)printk(KERN_ERR "RX_WINDOW = 0x%08x RX_best=0x%x\n", RX_window,RX_best);
+                phase(emmc_port, 0xff, RX_best);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+		suspend_VP1 = RX_best;
+        }
+	if (emmc_port->tx_tuning) {
+		TX1_window= TX_window;
+		if (mode == MODE_DDR && flag==1)
+			printk(KERN_ERR "Start DDR50 TX Tuning2:\n");
+		else if (mode == MODE_HS400 && flag==1)
+			printk(KERN_ERR "Start HS400 TX Tuning2:\n");
+		else if(flag==1)
+			printk(KERN_ERR "Start HS200 TX Tuning2:\n");
+                for(i=0;i<range;i++) {
+			if(((TX_window>>i)&1)==1) {
+				phase(emmc_port, i, 0xff);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+				writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+				udelay(1);
+				writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+#ifdef DEBUG
+				printk("phase =0x%x \n", i);
+#endif
+				if(rtkemmc_send_cmd25(emmc_port, 1024,0xfe,0,NULL) != 0)
+					TX1_window= TX1_window&(~(1<<i));
+			}
+		}
+		TX1_best = search_best(TX1_window, range);
+		if(flag==1)printk(KERN_ERR "TX1_WINDOW = 0x%08x TX1_best=0x%x\n", TX1_window,TX1_best);
+                phase(emmc_port, TX1_best, 0xff);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+		suspend_VP0 = TX1_best;
+        }
+	sync(emmc_port);
+/*	if(emmc_port->tx_tuning || emmc_port->rx_tuning) {
+                card_stop(emmc_port);
+		polling_to_tran_state(emmc_port,MMC_WRITE_MULTIPLE_BLOCK,1);
+	}*/
+}
+
+static int mmc_Tuning_SDR50(struct rtkemmc_host *emmc_port)
+{
+
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_request_hw_semaphore(emmc_port->hw_semaphore, 5);
+#endif
+	down_write(&cr_rw_sem);
+	if (!g_bResuming)
+		gCurrentBootMode = MODE_SDR;
+	MMCPRINTF("[LY]sdr gCurrentBootMode =%d\n",gCurrentBootMode);
+
+	rtkemmc_set_freq(emmc_port, 0x57); //100Mhz
+	rtkemmc_set_ip_div(emmc_port, EMMC_CLOCK_DIV_2); // 100MHZ/2 = 50MHZ
+
+	if (pddrive_nf_s0[0] != 0 )
+		rtkemmc_set_pad_driving(emmc_port, pddrive_nf_s0[1], pddrive_nf_s0[2], pddrive_nf_s0[3], pddrive_nf_s0[4]);
+	else {
+#ifdef CONFIG_ARCH_RTD129x
+		rtkemmc_set_pad_driving(emmc_port,0x33, 0x33, 0x33, 0x33);
+#else
+		rtkemmc_set_pad_driving(emmc_port,0x0, 0x0, 0x0, 0x0);
+#endif
+	}
+	sync(emmc_port);
+	udelay(100);
+	up_write(&cr_rw_sem);
+
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_release_hw_semaphore(emmc_port->hw_semaphore);
+#endif
+	return 0;
+}
+
+static int mmc_Tuning_DDR50(struct rtkemmc_host *emmc_port, u32 mode)
+{
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_request_hw_semaphore(emmc_port->hw_semaphore, 5);
+#endif
+	down_write(&cr_rw_sem);
+	if (!g_bResuming)
+		gCurrentBootMode = MODE_DDR;
+	MMCPRINTF("[LY]sdr gCurrentBootMode =%d\n",gCurrentBootMode);
+
+	rtkemmc_set_freq(emmc_port, 0x2a);  //100MMhz
+	rtkemmc_set_ip_div(emmc_port,EMMC_CLOCK_DIV_NON);
+	sync(emmc_port);
+	udelay(100);
+	if (pddrive_nf_s1[0] != 0 )
+		rtkemmc_set_pad_driving(emmc_port, pddrive_nf_s1[1], pddrive_nf_s1[2], pddrive_nf_s1[3], pddrive_nf_s1[4]);
+        else {
+#ifdef CONFIG_ARCH_RTD129x
+		rtkemmc_set_pad_driving(emmc_port,0x33, 0x33, 0x33, 0x33);
+#else
+		rtkemmc_set_pad_driving(emmc_port,0x0, 0x0, 0x0, 0x0);
+#endif
+	}
+	if(emmc_port->tx_tuning && emmc_port->rx_tuning) {	//device tree set kernel tuning for DDR50
+		rtkemmc_phase_tuning(emmc_port,mode,1);
+		sync(emmc_port);
+		mdelay(10);
+	}
+	else {
+		phase(emmc_port, 0x8, 0x9);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+	}
+	up_write(&cr_rw_sem);
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_release_hw_semaphore(emmc_port->hw_semaphore);
+#endif
+	return 0;
+}
+
+static int mmc_Tuning_HS200(struct rtkemmc_host *emmc_port,u32 mode)
+{
+	MMCPRINTF("%s \n", __func__);
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_request_hw_semaphore(emmc_port->hw_semaphore, 5);
+#endif
+	down_write(&cr_rw_sem);
+        if (!g_bResuming)
+                gCurrentBootMode = MODE_HS200;
+        MMCPRINTF("[LY]sdr gCurrentBootMode =%d\n",gCurrentBootMode);
+
+	rtkemmc_set_freq(emmc_port, 0xa6); //200Mhz
+	rtkemmc_set_ip_div(emmc_port, EMMC_CLOCK_DIV_NON); // 200MHZ/1 = 200MHZ
+#ifdef EMMC_PARAM_TEST
+	if (readl(emmc_port->misc_membase + MISC_DUMMY2) != 0xffffffff){
+		clk_drv = (readl(emmc_port->misc_membase + MISC_DUMMY2) & 0xff000000) >> 24;
+		cmd_drv = (readl(emmc_port->misc_membase + MISC_DUMMY2) & 0x00ff0000) >> 16;
+		data_drv = (readl(emmc_port->misc_membase + MISC_DUMMY2) & 0x0000ff00) >> 8;
+		ds_drv = (readl(emmc_port->misc_membase + MISC_DUMMY2) & 0x000000ff);
+		printk(KERN_ERR RED_BOLD"clk_drv = 0x%02x, cmd_drv = 0x%02x, data_drv = 0x%02x, ds_drv = 0x%02x"RESET, clk_drv, cmd_drv, data_drv, ds_drv);
+		rtkemmc_set_pad_driving(emmc_port,clk_drv, cmd_drv, data_drv, ds_drv);
+	}
+	else {
+#endif
+		if (pddrive_nf_s2[0] != 0 )
+			rtkemmc_set_pad_driving(emmc_port, pddrive_nf_s2[1], pddrive_nf_s2[2], pddrive_nf_s2[3], pddrive_nf_s2[4]);
+		else {
+#ifdef CONFIG_ARCH_RTD129x
+			rtkemmc_set_pad_driving(emmc_port,0xbb, 0xbb, 0xbb, 0xbb);
+#else
+			rtkemmc_set_pad_driving(emmc_port,0x4, 0x4, 0x4, 0x4);
+#endif
+		}
+#ifdef EMMC_PARAM_TEST
+	}
+#endif
+
+	rtkemmc_phase_tuning(emmc_port,mode,1);
+	sync(emmc_port);
+	mdelay(10);
+	up_write(&cr_rw_sem);
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_release_hw_semaphore(emmc_port->hw_semaphore);
+#endif
+	printk(KERN_ERR "HS200: final phase=0x%x\n", readl(emmc_port->crt_membase + SYS_PLL_EMMC1));
+
+	return 0;
+}
+
+static int mmc_Tuning_HS400(struct rtkemmc_host *emmc_port,u32 mode)
+{
+        MMCPRINTF("%s \n", __func__);
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_request_hw_semaphore(emmc_port->hw_semaphore, 5);
+#endif
+	down_write(&cr_rw_sem);
+	if (!g_bResuming)
+		gCurrentBootMode = MODE_HS400;
+	MMCPRINTF("[LY]sdr gCurrentBootMode =%d\n",gCurrentBootMode);
+
+	rtkemmc_set_freq(emmc_port, 0x70); //200Mhz
+	rtkemmc_set_ip_div(emmc_port, EMMC_CLOCK_DIV_NON); // 200MHZ/1 = 200MHZ
+
+	if (pddrive_nf_s3[0] != 0 )
+		rtkemmc_set_pad_driving(emmc_port, pddrive_nf_s3[1], pddrive_nf_s3[2], pddrive_nf_s3[3], pddrive_nf_s3[4]);
+	else {
+#ifdef CONFIG_ARCH_RTD129x
+		rtkemmc_set_pad_driving(emmc_port,0xff, 0x99, 0xaa, 0x33);
+#else
+		rtkemmc_set_pad_driving(emmc_port,0x7, 0x2, 0x3, 0x0);
+#endif
+	}
+	rtkemmc_phase_tuning(emmc_port,mode,1);
+	sync(emmc_port);
+	mdelay(10);
+	up_write(&cr_rw_sem);
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_release_hw_semaphore(emmc_port->hw_semaphore);
+#endif
+	printk(KERN_ERR "HS400 first stage: final phase=0x%x\n", readl(emmc_port->crt_membase + SYS_PLL_EMMC1));
+	return 0;
+}
+
+static int rtkemmc_execute_tuning(struct mmc_host *host, u32 opcode)
+{
+	struct rtkemmc_host *emmc_port;
+	struct sd_cmd_pkt cmd_info;
+
+	if(host->doing_retune == 1) return 0;
+
+	MMCPRINTF("%s \n", __func__);
+
+	emmc_port = mmc_priv(host);
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	cmd_info.emmc_port = emmc_port;
+
+	if (host->card){
+		printk(KERN_INFO "emmc card manid = 0x%08x\n", host->card->cid.manfid);
+		if (host->card->cid.manfid == 0x13) //micron manfid
+			emmc_port->rx_tuning = 1; //micron: force to turn on rx tuning
+	}
+	else
+		printk(KERN_ERR "host->card is null! \n");
+
+	MMCPRINTF("rtkemmc_execute_tuning : opcode=0x%08x, mode=0x%08x\n",opcode,host->mode);
+	rtkemmc_set_wrapper_div(emmc_port, 0);
+
+	g_bTuning = 1;
+	switch(host->mode)
+	{
+	case MODE_SDR:
+		mmc_Tuning_SDR50(emmc_port);
+		set_RTK_initial_flag(1);
+		break;
+	case MODE_DDR:
+		mmc_Tuning_DDR50(emmc_port, host->mode);
+		set_RTK_initial_flag(1);
+		break;
+	case MODE_HS200:
+		mmc_Tuning_HS200(emmc_port,host->mode);
+		set_RTK_initial_flag(1);
+		break;
+	case MODE_HS400:
+		mmc_Tuning_HS400(emmc_port,host->mode);		//hs400 still have dqs tuning, so set flag as 1 after dqs tuning
+		break;
+	default:
+		set_RTK_initial_flag(1);        //this flag is to use for sd card check for rcu stall
+		break;
+	}
+
+	g_bTuning = 0;
+	return 0;
+}
+
+static int rw_test_tuning(struct rtkemmc_host *emmc_port,unsigned long emmc_blk_addr)
+{
+	int i;
+	rtkemmc_send_cmd25(emmc_port,DMA_ALLOC_LENGTH, emmc_blk_addr,0, NULL);
+#ifdef SHA256
+	MCP_SHA256((unsigned char *)emmc_port->dma_paddr, (unsigned char *)compare3_phy_addr, DMA_ALLOC_LENGTH, NULL);
+#else
+	memcpy(compare1, gddr_dma_org, DMA_ALLOC_LENGTH);
+#endif
+	rtkemmc_send_cmd18(emmc_port,DMA_ALLOC_LENGTH, emmc_blk_addr);
+#ifdef SHA256
+	MCP_SHA256((unsigned char *)emmc_port->dma_paddr, (unsigned char *)compare4_phy_addr, DMA_ALLOC_LENGTH, NULL);
+#else
+	memcpy(compare2, gddr_dma_org, DMA_ALLOC_LENGTH);
+#endif
+
+#ifdef SHA256
+	for(i=0;i<32;i++) {
+		if(compare3[i]!=compare4[i]) {
+			return 1;
+		}
+	}
+#else
+	for(i=0;i<DMA_ALLOC_LENGTH;i++) {
+		if(compare1[i]!=compare2[i]) {
+			return 1;
+		}
+	}
+#endif
+	return 0;
+}
+
+static void rtkemmc_dqs_tuning(struct mmc_host *host)
+{
+	int i=0, j=0;
+	struct rtkemmc_host *emmc_port;
+	unsigned long dqs_tuning_blk_addr=0;
+	int retry_count=0;
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	unsigned int bitmap=0;
+	unsigned int max=0;
+
+	int hs400_data[128]={0};        //4 bytes header, 33aa, 4 bytes for TX, 4 bytes for RX, 4 bytes for dqs
+
+        emmc_port = mmc_priv(host);
+	mdelay(2);
+
+	if(suspend == 1)
+	{
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+		if(emmc_port->dqs_tuning == 1) {
+                	writel(0x80 | suspend_dqs,emmc_port->emmc_membase + EMMC_DQS_CTRL1); //dqs dly tap
+		}
+		else {
+			writel(0x80 | dqs_saved, emmc_port->emmc_membase + EMMC_DQS_CTRL1); //dqs dly tap
+		}
+                printk(KERN_ERR "suspend/resume: restore DQS=0x%x\n", readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1));
+#ifdef CONFIG_ARCH_RTD129x
+                rtk_lockapi_unlock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+		suspend = 0;
+		return;
+	}
+
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_request_hw_semaphore(emmc_port->hw_semaphore, 5);
+#endif
+	down_write(&cr_rw_sem);
+	g_bTuning = 1;
+
+#ifdef DQS_INHERITED
+        if(emmc_port->dqs_tuning == 0) {
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+		writel(0x80 | dqs_saved, emmc_port->emmc_membase + EMMC_DQS_CTRL1); //dqs dly tap
+		printk(KERN_ERR "Inherit bootcode dqs: DQS=0x%x\n", readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1));
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+		printk(KERN_ERR "read/write test for inherit hs400 parameter...\n");
+		if( rw_test_tuning(emmc_port, (emmc_port->emmc_tuning_addr/512))==0) {
+			printk(KERN_ERR "read/write test success for hs400 parameter!!!\n");
+			g_bTuning = 0;
+			up_write(&cr_rw_sem);
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+			rtkemmc_release_hw_semaphore(emmc_port->hw_semaphore);
+#endif
+			set_RTK_initial_flag(1);
+			return;
+		}
+		else {
+			emmc_port->dqs_tuning=1;
+			emmc_port->tx_tuning = 1;
+			emmc_port->rx_tuning = 1;
+			printk(KERN_ERR "read/write test failed, retune the hs400...\n");
+		}
+	}
+#endif
+
+	dqs_tuning_blk_addr = emmc_port->emmc_tuning_addr / 512;	//convert from offset to block address
+	printk(KERN_ERR "emmc_port->emmc_tuning_addr = 0x%x, dqs_tuning_blk_addr = 0x%x\n", emmc_port->emmc_tuning_addr, dqs_tuning_blk_addr);
+
+#ifdef SHA256
+	printk(KERN_ERR "[EMMC] SHA256 is enabled for dqs comparison!!!\n");
+	if(!compare3)
+		compare3 = dma_alloc_coherent(emmc_port->dev, 32, &compare3_phy_addr ,GFP_KERNEL);
+	if(!compare4)
+		compare4 = dma_alloc_coherent(emmc_port->dev, 32, &compare4_phy_addr ,GFP_KERNEL);
+#endif
+retry:
+	for(i=0; i<0x20; i++) {
+		if(j>=5)			//must be more than 5 continuous tap sample point
+			max = j;
+		if(j==0 && max!=0)	//find the max tap length
+			break;
+#ifdef EMMC_DEBUG
+		printk(KERN_ERR "DQS windows tuning: i=0x%x\n",i<<1);
+#endif
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+		writel(0x80|(i<<1),emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+		rtkemmc_phase_tuning(emmc_port,MODE_HS400,0);
+		if( rw_test_tuning(emmc_port, dqs_tuning_blk_addr)==0) {
+			j++;
+			bitmap |= (1<<i);
+		}
+		else {
+			j=0;
+		}
+	}
+	if(max==0) {
+		if((++retry_count)<5) {
+                        printk(KERN_ERR "DQS_RETRY: dqs tap bitmap= 0x%x, retry: %d\n", bitmap, retry_count);
+                        sync(emmc_port);
+                        mdelay(10);
+                        goto retry;
+                }
+                else {
+                        printk(KERN_ERR RED_BOLD"Cannot find a proper dqs window..., dqs tap bitmap= 0x%x\n"RESET, bitmap);
+                }
+
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+		writel(0x88,emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+	}
+	else {
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+		writel(0x80|(readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1)-((max/2)*2)),emmc_port->emmc_membase + EMMC_DQS_CTRL1); //dqs dly tap
+		suspend_dqs = readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+		printk(KERN_ERR "max sample point=%d, bitmap=0x%x, DQS=0x%x\n", max, bitmap, readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1));
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+		rtkemmc_phase_tuning(emmc_port,MODE_HS400,1);
+		printk(KERN_ERR "HS400: final phase=0x%x\n", readl(emmc_port->crt_membase + SYS_PLL_EMMC1));
+	}
+#ifdef SHA256
+	if(compare3)
+		dma_free_coherent(emmc_port->dev, 32, compare3 , compare3_phy_addr);
+	if(compare4)
+		dma_free_coherent(emmc_port->dev, 32, compare4 , compare4_phy_addr);
+#endif
+        sync(emmc_port);
+        mdelay(10);
+	g_bTuning = 0;
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_lock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+	printk(KERN_ERR "rtkemmc_dqs_tuning finished!!! EMMC_UHSREG=%x\n",readl(emmc_port->emmc_membase + EMMC_UHSREG));
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_unlock2(flags2, _at_("rtkemmc_dqs_tuning"));
+#endif
+
+	printk(KERN_ERR "save eMMC hs400 parameter to emmc dqs_tuning_blk_addr 0x%x\n", dqs_tuning_blk_addr+1024);
+	hs400_data[0] = 0x33aa;
+	hs400_data[1] = (readl(emmc_port->crt_membase + SYS_PLL_EMMC1) & 0x000000f8) >> 3;
+	hs400_data[2] = (readl(emmc_port->crt_membase + SYS_PLL_EMMC1) & 0x00001f00) >> 8;
+	hs400_data[3] = readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+	printk(KERN_ERR "hs400 parameter: hs400_TX[1]=0x%x, hs400_RX[2]=0x%x,hs400_dqs[3]=0x%x\n",hs400_data[1],hs400_data[2],hs400_data[3]);
+	rtkemmc_send_cmd25(emmc_port, 512, dqs_tuning_blk_addr+1024, 1, hs400_data);
+
+	up_write(&cr_rw_sem);
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_release_hw_semaphore(emmc_port->hw_semaphore);
+#endif
+	set_RTK_initial_flag(1);        //this flag is to use for sd card check for rcu stall
+}
+
+static u32 rtkemmc_get_cmd_timeout(struct sd_cmd_pkt *cmd_info)
+{
+	struct rtkemmc_host *emmc_port = cmd_info->emmc_port;
+	u16 block_count = cmd_info->block_count;
+	u32 tmout = 0;
+
+	MMCPRINTF("\n");
+
+	if(cmd_info->cmd->data) {
+		tmout = msecs_to_jiffies(200);
+
+		if(block_count>0x100)
+			tmout = tmout + msecs_to_jiffies(block_count>>1);
+    	}
+	else
+		tmout = msecs_to_jiffies(80);
+
+#ifdef CONFIG_ANDROID
+	tmout += msecs_to_jiffies(100);
+#endif
+
+	cmd_info->timeout = emmc_port->tmout = tmout;
+
+	return 0;
+}
+
+static void rtkemmc_set_ios(struct mmc_host *host, struct mmc_ios *ios)
+{
+	struct rtkemmc_host *emmc_port;
+	u32 busmode=0;
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	u32 cur_timing = 0;
+
+	emmc_port = mmc_priv(host);
+
+	MMCPRINTF(KERN_INFO "ios->bus_mode = %u\n",ios->bus_mode);
+	MMCPRINTF(KERN_INFO "ios->clock = %u\n",ios->clock);
+	MMCPRINTF(KERN_INFO "ios->bus_width = %u\n",ios->bus_width);
+	MMCPRINTF(KERN_INFO "ios->timing = %u\n",ios->timing);
+	//down_write(&cr_rw_sem);
+	cur_timing = ios->timing;
+	if (ios->clock == MMC_HIGH_52_MAX_DTR)
+		cur_timing = MMC_TIMING_MMC_HS;
+
+	MMCPRINTF(KERN_INFO "cur_timing = %u\n",cur_timing);
+
+	if (!g_bResuming) {
+		switch(cur_timing)
+		{
+		case MMC_TIMING_MMC_HS400:
+			rtkemmc_set_freq(emmc_port,0x70);  //200MHZ
+			rtkemmc_set_ip_div(emmc_port,EMMC_CLOCK_DIV_NON);
+			isb();
+			sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_ios"));
+#endif
+			rtkemmc_writel(0x80000000 ,emmc_port->emmc_membase + EMMC_DDR_REG); //enable HS400
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_ios"));
+#endif
+			isb();
+			sync(emmc_port);
+			printk(KERN_INFO "%s - enable HS400, DDR_REG:0x%08x\n",__func__,readl(emmc_port->emmc_membase + EMMC_DDR_REG));
+			break;
+		case MMC_TIMING_MMC_HS200:
+			rtkemmc_set_freq(emmc_port,0xa6);  //200MHZ
+			rtkemmc_set_ip_div(emmc_port,EMMC_CLOCK_DIV_NON);
+			break;
+		case MMC_TIMING_MMC_DDR52:
+			rtkemmc_set_freq(emmc_port,0x2a);  //100MB
+			rtkemmc_set_ip_div(emmc_port,EMMC_CLOCK_DIV_NON); //100MHZ/2 = 50MHZ
+			break;
+		case MMC_TIMING_MMC_HS:
+			rtkemmc_set_freq(emmc_port,0x57);  //100Mhz
+			rtkemmc_set_ip_div(emmc_port,EMMC_CLOCK_DIV_2); //100MHZ/2 = 50MHZ
+			break;
+		case MMC_TIMING_LEGACY:
+			rtkemmc_set_freq(emmc_port,0x46);  //80Mhz
+			rtkemmc_set_ip_div(emmc_port,EMMC_CLOCK_DIV_256);
+			break;
+		default:
+			printk(KERN_INFO "%s: cur_timing = %u \n", __FILE__, cur_timing);
+			break;
+		}
+	}
+
+	if (ios->bus_width == MMC_BUS_WIDTH_8){
+		printk(KERN_INFO "set bus width 8\n");
+		rtkemmc_set_bits(emmc_port,BUS_WIDTH_8);
+		busmode = BUS_WIDTH_8;
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_ios"));
+#endif
+		if (cur_timing == MMC_TIMING_MMC_HS400) {
+			rtkemmc_writel(0x00010001, emmc_port->emmc_membase + EMMC_UHSREG); //DDR
+			isb();
+			sync(emmc_port);
+			rtkemmc_writel(0x88 ,emmc_port->emmc_membase + EMMC_DQS_CTRL1); //dqs dly tap
+#if defined(CONFIG_ARCH_RTD139x)
+			rtkemmc_writel(0x94, emmc_port->emmc_membase+0x530); //dqs dly tap
+			rtkemmc_writel(0x14, emmc_port->emmc_membase+0x534); //dqs dly tap
+			rtkemmc_writel(0x14, emmc_port->emmc_membase+0x538); //dqs dly tap
+			rtkemmc_writel(0x14, emmc_port->emmc_membase+0x53c); //dqs dly tap
+			rtkemmc_writel(0x14, emmc_port->emmc_membase+0x540); //dqs dly tap
+			rtkemmc_writel(0x14, emmc_port->emmc_membase+0x544); //dqs dly tap
+			rtkemmc_writel(0x14, emmc_port->emmc_membase+0x548 ); //dqs dly tap
+			rtkemmc_writel(0x14, emmc_port->emmc_membase+0x54c); //dqs dly tap
+			rtkemmc_writel(0xff00, emmc_port->emmc_membase+0x50c); //dqs dly tap
+			rtkemmc_writel(0x94, emmc_port->emmc_membase+0x558);
+			rtkemmc_writel(0x2, emmc_port->emmc_membase+0x550);
+#elif defined(CONFIG_ARCH_RTD16xx)
+			rtkemmc_writel(0x80, emmc_port->emmc_membase+0x530); //dqs dly tap
+			rtkemmc_writel(0x0, emmc_port->emmc_membase+0x534); //dqs dly tap
+			rtkemmc_writel(0x0, emmc_port->emmc_membase+0x538); //dqs dly tap
+			rtkemmc_writel(0x0, emmc_port->emmc_membase+0x53c); //dqs dly tap
+			rtkemmc_writel(0x0, emmc_port->emmc_membase+0x540); //dqs dly tap
+			rtkemmc_writel(0x0, emmc_port->emmc_membase+0x544); //dqs dly tap
+			rtkemmc_writel(0x0, emmc_port->emmc_membase+0x548 ); //dqs dly tap
+			rtkemmc_writel(0x0, emmc_port->emmc_membase+0x54c); //dqs dly tap
+			rtkemmc_writel(0xff00, emmc_port->emmc_membase+0x50c); //dqs dly tap
+			rtkemmc_writel(0xb4, emmc_port->emmc_membase+0x554);
+			rtkemmc_writel(0xb4, emmc_port->emmc_membase+0x558);
+			rtkemmc_writel(0x3, emmc_port->emmc_membase+0x550);
+			rtkemmc_writel(0x0, emmc_port->emmc_membase+0x554);
+#endif
+			isb();
+			sync(emmc_port);
+			
+			//rtkemmc_dump_registers(emmc_port);
+			sync(emmc_port);
+		}
+		else if(cur_timing == MMC_TIMING_MMC_DDR52) {
+			rtkemmc_writel(0x00010001, emmc_port->emmc_membase + EMMC_UHSREG); //DDR
+			isb();
+			sync(emmc_port);
+		}
+		else{
+			rtkemmc_writel(0x00000001, emmc_port->emmc_membase + EMMC_UHSREG); //non-DDR, such as SDR / HS200
+		}
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_ios"));
+#endif
+	} else if (ios->bus_width == MMC_BUS_WIDTH_4){
+		printk(KERN_INFO "set bus width 4\n");
+		rtkemmc_set_bits(emmc_port,BUS_WIDTH_4);
+		busmode = BUS_WIDTH_4;
+	}
+}
+
+void rtkemmc_chk_param(u32 *pparam, u32 len, u8 *ptr)
+{
+	u32 value,i;
+	mmcrtk("\n");
+
+	*pparam = 0;
+	for(i=0;i<len;i++){
+		value = ptr[i] - '0';
+		// KWarning: checked ok by alexkh@realtek.com
+		if((value >= 0) && (value <=9))
+		{
+			*pparam+=value<<(4*(len-1-i));
+			continue;
+		}
+
+		value = ptr[i] - 'a';
+		// KWarning: checked ok by alexkh@realtek.com
+		if((value >= 0) && (value <=5))
+		{
+			value+=10;
+			*pparam+=value<<(4*(len-1-i));
+			continue;
+		}
+
+		value = ptr[i] - 'A';
+		// KWarning: checked ok by alexkh@realtek.com
+		if((value >= 0) && (value <=5))
+		{
+			value+=10;
+			*pparam+=value<<(4*(len-1-i));
+			continue;
+		}
+	}
+}
+
+void rtk_op_complete(struct rtkemmc_host *emmc_port)
+{
+	struct completion *waiting = emmc_port->int_waiting;
+	if (emmc_port->int_waiting) {
+		MMCPRINTF("int wait complete 1\n");
+		MMCPRINTF("rtk_op_complete: rtk wait complete addr = %08x\n", (unsigned int) emmc_port->int_waiting);
+		//emmc_port->int_waiting = NULL;
+		complete(waiting);
+		MMCPRINTF("int wait complete 2\n");
+	}
+	else
+		MMCPRINTF("int wait not complete\n");
+}
+
+static void rtkemmc_req_end_tasklet(unsigned long param)
+{
+	struct rtkemmc_host *emmc_port;
+	struct mmc_request* mrq;
+	unsigned long flags;
+	MMCPRINTF("%s \n", __func__);
+
+	emmc_port = (struct rtkemmc_host *)param;
+	spin_lock_irqsave(&emmc_port->lock,flags);
+
+	mrq = emmc_port->mrq;
+	emmc_port->mrq = NULL;
+
+	spin_unlock_irqrestore(&emmc_port->lock, flags);
+
+	mmc_request_done(emmc_port->mmc, mrq);
+}
+
+static int rtkemmc_free_dma_buf(struct rtkemmc_host *emmc_port)
+{
+	if (gddr_descriptor_org)
+		dma_free_coherent(emmc_port->dev, DESC_ALLOC_LENGTH, gddr_descriptor_org ,emmc_port->desc_paddr);
+	MMCPRINTF("free rtk desc buf \n");
+
+	if (gddr_dma_org)
+		dma_free_coherent(emmc_port->dev, DMA_ALLOC_LENGTH, gddr_dma_org ,emmc_port->dma_paddr);
+	MMCPRINTF("free rtk dma buf \n");
+	return 1;
+}
+
+static int rtkemmc_allocate_dma_buf(struct rtkemmc_host *emmc_port, struct mmc_command *cmd)
+{
+	if (!gddr_descriptor)
+		gddr_descriptor_org = gddr_descriptor = dma_alloc_coherent(emmc_port->dev, DESC_ALLOC_LENGTH, &emmc_port->desc_paddr ,GFP_KERNEL);
+
+	if (!gddr_dma)
+		gddr_dma_org = gddr_dma = dma_alloc_coherent(emmc_port->dev, DMA_ALLOC_LENGTH, &emmc_port->dma_paddr ,GFP_KERNEL);
+
+	if(!gddr_dma || !gddr_descriptor){
+		WARN_ON(1);
+		cmd->error = -ENOMEM;
+		return 0;
+	}
+
+	MMCPRINTF("allocate rtk dma buf : dma addr=0x%016llx, phy addr=0x%08x\n", gddr_dma, emmc_port->dma_paddr);
+	MMCPRINTF("allocate rtk desc buf : desc addr=0x%016llx, phy addr=0x%08x\n", gddr_descriptor, emmc_port->desc_paddr);
+	return 1;
+}
+
+#ifdef EMMC_DEBUG
+static void rtkemmc_dump_registers(struct rtkemmc_host *emmc_port)
+{
+	printk(KERN_INFO "%s : \n", __func__);
+//	unsigned long flags2;
+
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_dump_registers"));
+#if defined(CONFIG_ARCH_RTD129x)
+	printk(KERN_ERR "EMMC_muxpad0 = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_muxpad0));
+	printk(KERN_ERR "EMMC_muxpad1 = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_muxpad1));
+	printk(KERN_ERR "EMMC_PFUNC_NF1 = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_PFUNC_NF1));
+	printk(KERN_ERR "EMMC_PFUNC_CR  = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_PFUNC_CR));
+	printk(KERN_ERR "EMMC_PDRIVE_NF1 = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_PDRIVE_NF1));
+	printk(KERN_ERR "EMMC_PDRIVE_NF2 = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_PDRIVE_NF2));
+	printk(KERN_ERR "EMMC_PDRIVE_NF3 = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_PDRIVE_NF3));
+#elif defined(CONFIG_ARCH_RTD139x)
+	printk(KERN_INFO "ISO_muxpad4 = 0x%08x \n", readl(emmc_port->iso_muxpad + ISO_muxpad4));
+	printk(KERN_INFO "pfunc_emmc0 = 0x%08x \n", readl(emmc_port->iso_muxpad + pfunc_emmc0));
+	printk(KERN_INFO "pfunc_emmc1 = 0x%08x \n", readl(emmc_port->iso_muxpad + pfunc_emmc1));
+	printk(KERN_INFO "pfunc_emmc2 = 0x%08x \n", readl(emmc_port->iso_muxpad + pfunc_emmc2));
+	printk(KERN_INFO "pfunc_emmc3 = 0x%08x \n", readl(emmc_port->iso_muxpad + pfunc_emmc3));
+	printk(KERN_INFO "pfunc_emmc4 = 0x%08x \n", readl(emmc_port->iso_muxpad + pfunc_emmc4));
+	printk(KERN_INFO "pfunc_emmc5 = 0x%08x \n", readl(emmc_port->iso_muxpad + pfunc_emmc5));
+#elif defined(CONFIG_ARCH_RTD16xx)
+	printk(KERN_INFO "m2tmx_muxpad0 = 0x%08x \n", readl(emmc_port->m2tmx + m2tmx_muxpad0));
+	printk(KERN_INFO "m2tmx_pfunc4 = 0x%08x \n", readl(emmc_port->m2tmx + m2tmx_pfunc4));
+	printk(KERN_INFO "m2tmx_pfunc5 = 0x%08x \n", readl(emmc_port->m2tmx + m2tmx_pfunc5));
+	printk(KERN_INFO "m2tmx_pfunc6 = 0x%08x \n", readl(emmc_port->m2tmx + m2tmx_pfunc6));
+	printk(KERN_INFO "m2tmx_pfunc7 = 0x%08x \n", readl(emmc_port->m2tmx + m2tmx_pfunc7));
+	printk(KERN_INFO "m2tmx_pfunc8 = 0x%08x \n", readl(emmc_port->m2tmx + m2tmx_pfunc8));
+#endif
+	printk(KERN_INFO "EMMC_CTYPE = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_CTYPE));
+	printk(KERN_INFO "EMMC_UHSREG = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_UHSREG));
+	printk(KERN_INFO "EMMC_DDR_REG = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_DDR_REG));
+	printk(KERN_INFO "EMMC_CARD_THR_CTL = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_CARD_THR_CTL));
+	printk(KERN_INFO "EMMC_CLKDIV = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_CLKDIV));
+	printk(KERN_INFO "EMMC_CKGEN_CTL = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL));
+	printk(KERN_INFO "EMMC_DQS_CTLR1 = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1));
+	printk(KERN_INFO "EMMC_PAD_CTL = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_PAD_CTL));
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+        printk(KERN_INFO "EMMC_DUMMY_SYS = 0x%08x\n", readl(emmc_port->emmc_membase + EMMC_DUMMY_SYS));
+#endif
+
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_dump_registers"));
+	isb();
+	sync(emmc_port);
+}
+#endif
+
+static void rtkemmc_restore_registers(struct rtkemmc_host *emmc_port)
+{
+//	unsigned long flags2;
+
+        //rtk_lockapi_lock2(flags2, _at_("rtkemmc_restore_registers"));
+#if defined(CONFIG_ARCH_RTD129x)
+	rtkemmc_writel(gRegTbl.emmc_mux_pad0, emmc_port->emmc_membase + EMMC_muxpad0);
+	rtkemmc_writel(gRegTbl.emmc_mux_pad1, emmc_port->emmc_membase + EMMC_muxpad1);
+	rtkemmc_writel(gRegTbl.emmc_pfunc_nf1, emmc_port->emmc_membase + EMMC_PFUNC_NF1);
+	rtkemmc_writel(gRegTbl.emmc_pfunc_cr, emmc_port->emmc_membase + EMMC_PFUNC_CR);
+	rtkemmc_writel(gRegTbl.emmc_pdrive_nf1, emmc_port->emmc_membase + EMMC_PDRIVE_NF1);
+	rtkemmc_writel(gRegTbl.emmc_pdrive_nf2, emmc_port->emmc_membase + EMMC_PDRIVE_NF2);
+	rtkemmc_writel(gRegTbl.emmc_pdrive_nf3, emmc_port->emmc_membase + EMMC_PDRIVE_NF3);
+	rtkemmc_writel(gRegTbl.emmc_pdrive_nf4, emmc_port->emmc_membase + EMMC_PDRIVE_NF4);
+/*this part for 139x and 16xx only for debugging,
+  129x & 16xx does not need to do this, onlt 129x needs to take this action*/
+/*
+#elif defined(CONFIG_ARCH_RTD139x)
+	rtkemmc_writel(gRegTbl.iso_muxpad4,emmc_port->iso_muxpad + ISO_muxpad4);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc0,emmc_port->iso_muxpad + pfunc_emmc0);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc1,emmc_port->iso_muxpad + pfunc_emmc1);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc2,emmc_port->iso_muxpad + pfunc_emmc2);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc3,emmc_port->iso_muxpad + pfunc_emmc3);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc4,emmc_port->iso_muxpad + pfunc_emmc4);
+	rtkemmc_writel(gRegTbl.Pfunc_emmc5,emmc_port->iso_muxpad + pfunc_emmc5);
+*/
+#endif
+
+#ifdef CONFIG_ARCH_RTD129x
+	rtkemmc_writel(gRegTbl.emmc_pdrive_cr0, emmc_port->emmc_membase + EMMC_PDRIVE_CR0);
+        rtkemmc_writel(gRegTbl.emmc_pdrive_cr1, emmc_port->emmc_membase + EMMC_PDRIVE_CR1);
+        rtkemmc_writel(gRegTbl.emmc_pdrive_sdio, emmc_port->emmc_membase + EMMC_PDRIVE_SDIO);
+        rtkemmc_writel(gRegTbl.emmc_pdrive_sdio1, emmc_port->emmc_membase + EMMC_PDRIVE_SDIO1);
+#endif
+	rtkemmc_writel(gRegTbl.emmc_ctype, emmc_port->emmc_membase + EMMC_CTYPE);
+	rtkemmc_writel(gRegTbl.emmc_uhsreg, emmc_port->emmc_membase + EMMC_UHSREG);
+	rtkemmc_writel(gRegTbl.emmc_ddr_reg, emmc_port->emmc_membase + EMMC_DDR_REG);
+	rtkemmc_writel(gRegTbl.emmc_card_thr_ctl, emmc_port->emmc_membase + EMMC_CARD_THR_CTL);
+	rtkemmc_writel(gRegTbl.emmc_clk_div, emmc_port->emmc_membase + EMMC_CLKDIV);
+	rtkemmc_writel(gRegTbl.emmc_ckgen_ctl, emmc_port->emmc_membase + EMMC_CKGEN_CTL);
+	if(gCurrentBootMode == MODE_HS400) {
+		rtkemmc_writel(gRegTbl.emmc_dqs_ctrl1 | 0x80, emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+	}
+	else {
+		rtkemmc_writel(gRegTbl.emmc_dqs_ctrl1, emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+	}
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	rtkemmc_writel(gRegTbl.emmc_drto_mask_ori,emmc_port->emmc_membase + EMMC_DUMMY_SYS);
+#endif
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_restore_registers"));
+	isb();
+	sync(emmc_port);
+#ifdef EMMC_DEBUG
+	rtkemmc_dump_registers(emmc_port);
+#endif
+}
+
+static void rtkemmc_backup_registers(struct rtkemmc_host *emmc_port)
+{
+//	unsigned long flags2;
+
+        //rtk_lockapi_lock2(flags2, _at_("rtkemmc_backup_registers"));
+#if defined(CONFIG_ARCH_RTD129x)
+	gRegTbl.emmc_mux_pad0 = readl(emmc_port->emmc_membase + EMMC_muxpad0);
+	gRegTbl.emmc_mux_pad1 = readl(emmc_port->emmc_membase + EMMC_muxpad1);
+	gRegTbl.emmc_pfunc_nf1 = readl(emmc_port->emmc_membase + EMMC_PFUNC_NF1);
+	gRegTbl.emmc_pfunc_cr = readl(emmc_port->emmc_membase + EMMC_PFUNC_CR);
+	gRegTbl.emmc_pdrive_nf1 = readl(emmc_port->emmc_membase + EMMC_PDRIVE_NF1);
+	gRegTbl.emmc_pdrive_nf2 = readl(emmc_port->emmc_membase + EMMC_PDRIVE_NF2);
+	gRegTbl.emmc_pdrive_nf3 = readl(emmc_port->emmc_membase + EMMC_PDRIVE_NF3);
+	gRegTbl.emmc_pdrive_nf4 = readl(emmc_port->emmc_membase + EMMC_PDRIVE_NF4);
+
+/*this part for 139x and 16xx only for debugging,
+  129x & 16xx does not need to do this, onlt 129x needs to take this action*/
+/*
+#elif defined(CONFIG_ARCH_RTD139x)
+	gRegTbl.iso_muxpad4 = readl(emmc_port->iso_muxpad + ISO_muxpad4);
+	gRegTbl.Pfunc_emmc0 = readl(emmc_port->iso_muxpad + pfunc_emmc0);
+	gRegTbl.Pfunc_emmc1 = readl(emmc_port->iso_muxpad + pfunc_emmc1);
+	gRegTbl.Pfunc_emmc2 = readl(emmc_port->iso_muxpad + pfunc_emmc2);
+	gRegTbl.Pfunc_emmc3 = readl(emmc_port->iso_muxpad + pfunc_emmc3);
+	gRegTbl.Pfunc_emmc4 = readl(emmc_port->iso_muxpad + pfunc_emmc4);
+	gRegTbl.Pfunc_emmc5 = readl(emmc_port->iso_muxpad + pfunc_emmc5);
+*/
+#endif
+
+#ifdef CONFIG_ARCH_RTD129x
+	gRegTbl.emmc_pdrive_cr0 = readl(emmc_port->emmc_membase + EMMC_PDRIVE_CR0);
+	gRegTbl.emmc_pdrive_cr1 = readl(emmc_port->emmc_membase + EMMC_PDRIVE_CR1);
+	gRegTbl.emmc_pdrive_sdio = readl(emmc_port->emmc_membase + EMMC_PDRIVE_SDIO);
+	gRegTbl.emmc_pdrive_sdio1 = readl(emmc_port->emmc_membase + EMMC_PDRIVE_SDIO1);
+#endif
+	gRegTbl.emmc_ctype = readl(emmc_port->emmc_membase + EMMC_CTYPE);
+	gRegTbl.emmc_uhsreg = readl(emmc_port->emmc_membase + EMMC_UHSREG);
+	gRegTbl.emmc_ddr_reg = readl(emmc_port->emmc_membase + EMMC_DDR_REG);
+	gRegTbl.emmc_card_thr_ctl = readl(emmc_port->emmc_membase + EMMC_CARD_THR_CTL);
+	gRegTbl.emmc_clk_div = readl(emmc_port->emmc_membase + EMMC_CLKDIV);
+	gRegTbl.emmc_ckgen_ctl = readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL);
+	gRegTbl.emmc_dqs_ctrl1 = readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	gRegTbl.emmc_drto_mask_ori = readl(emmc_port->emmc_membase + EMMC_DUMMY_SYS);
+	gRegTbl.emmc_other1 = readl(emmc_port->emmc_membase + EMMC_OTHER1);
+#endif
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_backup_registers"));
+	isb();
+	sync(emmc_port);
+#ifdef EMMC_DEBUG
+	rtkemmc_dump_registers(emmc_port);
+#endif
+}
+
+static int wait_done_timeout(struct rtkemmc_host *emmc_port, volatile u32 *addr, u32 mask, u32 value, const char *string)
+{
+	int n = 0;
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	while(1)
+	{
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("wait_done_timeout"));
+#endif
+		if (((*addr) &mask) == value){
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("wait_done_timeout"));
+#endif
+			break;
+                }
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("wait_done_timeout"));
+#endif
+		if(n++ > 3000000) {
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_lock2(flags2, _at_("wait_done_timeout"));
+#endif
+			printk(KERN_ERR "Timeout!!! cmd_opcode=%d, cmd_arg=%x, addr=%p, mask=%x, value=%x, emmc_port->emmc_membase + EMMC_STATUS=%x, pre_func=%s\n"
+				,emmc_port->cmd_opcode, readl(emmc_port->emmc_membase+EMMC_CMDARG), addr, mask, value, readl(emmc_port->emmc_membase + EMMC_STATUS), string);
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("wait_done_timeout"));
+#endif
+			return -1;
+		}
+		udelay(1);
+		sync(emmc_port);
+	}
+	return 0;
+}
+
+static void rtkemmc_set_bits(struct rtkemmc_host *emmc_port,u32 set_bit)
+{
+	unsigned long flags;
+//	unsigned long flags2;
+
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_bits"));	//spin lock only assures that one process cannot be interruptted by IRQ on one cpu, we still need to use lock_api
+								//to fix A01 IP bug 
+
+	spin_lock_irqsave(&emmc_port->lock,flags);
+	rtkemmc_writel(set_bit,emmc_port->emmc_membase + EMMC_CTYPE);
+	sync(emmc_port);
+	spin_unlock_irqrestore(&emmc_port->lock, flags);
+
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_bits"));
+
+        wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_STATUS), 0x200, 0x0, __func__);          //card is not busy
+    	sync(emmc_port);
+
+    	printk(KERN_INFO "%s: set to 0x%08x, EMMC_CTYPE=%08x\n", DRIVER_NAME, set_bit, readl(emmc_port->emmc_membase + EMMC_CTYPE));
+}
+
+void rtkemmc_set_pad_driving(struct rtkemmc_host *emmc_port, u32 clk_drv, u32 cmd_drv, u32 data_drv, u32 ds_drv)
+{
+//	unsigned long flags2;
+#ifdef CONFIG_ARCH_RTD139x
+	u32 tmp = 0;
+#endif
+
+#if defined(CONFIG_ARCH_RTD129x)
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_pad_driving"));
+
+	rtkemmc_writel(data_drv|(data_drv<<8)|(data_drv<<16)|(data_drv<<24), emmc_port->emmc_membase + EMMC_PDRIVE_NF1); //d0~d3
+	rtkemmc_writel(data_drv|(data_drv<<8)|(data_drv<<16)|(data_drv<<24), emmc_port->emmc_membase + EMMC_PDRIVE_NF2); //d4~d7
+	rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_PDRIVE_NF3)&(0x00ff00ff))|(clk_drv<<8)|(cmd_drv<<24), emmc_port->emmc_membase + EMMC_PDRIVE_NF3); //d4~d7
+	rtkemmc_writel(ds_drv, emmc_port->emmc_membase + EMMC_PDRIVE_NF4); //data strobe
+
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_pad_driving"));
+#elif defined(CONFIG_ARCH_RTD139x)
+	//data 0 - 7
+	tmp = (readl(emmc_port->iso_muxpad + pfunc_emmc2)&0xffe07e07)|(data_drv<<3)|(data_drv<<6)|(data_drv<<15)|(data_drv<<18);
+	rtkemmc_writel(tmp, emmc_port->iso_muxpad + pfunc_emmc2);
+        rtkemmc_writel(tmp, emmc_port->iso_muxpad + pfunc_emmc3);
+	rtkemmc_writel(tmp, emmc_port->iso_muxpad + pfunc_emmc4);
+	rtkemmc_writel(tmp, emmc_port->iso_muxpad + pfunc_emmc5);
+
+	tmp = (readl(emmc_port->iso_muxpad + pfunc_emmc1)&0xffe07e07)|(clk_drv<<3)|(clk_drv<<6)|(cmd_drv<<15)|(cmd_drv<<18);	//clk and cmd
+	rtkemmc_writel(tmp, emmc_port->iso_muxpad + pfunc_emmc1);
+
+	tmp = (readl(emmc_port->iso_muxpad + pfunc_emmc0)&0xffe07fff)|(ds_drv<<15)|(ds_drv<<18);	//data strobe
+	rtkemmc_writel(tmp, emmc_port->iso_muxpad + pfunc_emmc0);
+#elif defined(CONFIG_ARCH_RTD16xx)
+	rtkemmc_writel((readl(emmc_port->m2tmx + m2tmx_pfunc4)&0xf03fffff)|(clk_drv<<22)|(clk_drv<<25),emmc_port->m2tmx + m2tmx_pfunc4);
+	rtkemmc_writel((readl(emmc_port->m2tmx + m2tmx_pfunc5)&0x07e07f03)|(cmd_drv<<2)|(cmd_drv<<5)|(data_drv<<15)|(data_drv<<18)|(data_drv<<27)|((data_drv&0x3)<<30),
+				emmc_port->m2tmx + m2tmx_pfunc5);
+	rtkemmc_writel((readl(emmc_port->m2tmx + m2tmx_pfunc6)&0x7e07e07e)|(data_drv>>2)|(data_drv<<7)|(data_drv<<10)|(data_drv<<19)|(data_drv<<22)|((data_drv&0x1)<<31),
+				emmc_port->m2tmx + m2tmx_pfunc6);
+	rtkemmc_writel((readl(emmc_port->m2tmx + m2tmx_pfunc7)&0xe07e07e0)|(data_drv>>1)|(data_drv<<2)|(data_drv<<11)|(data_drv<<14)|(data_drv<<23)|(data_drv<<26),
+				emmc_port->m2tmx + m2tmx_pfunc7);
+	rtkemmc_writel((readl(emmc_port->m2tmx + m2tmx_pfunc8)&0xfffffe07)|(data_drv<<3)|(data_drv<<6),emmc_port->m2tmx + m2tmx_pfunc8);
+#endif
+	isb();
+	sync(emmc_port);
+}
+
+//wrapper clk divider
+//clk_div       [2..0]
+//000: div1
+//001: div2
+//010: div4
+//011: div8
+
+static void rtkemmc_set_wrapper_div(struct rtkemmc_host *emmc_port,u8 level)
+{
+
+	unsigned long flags;
+//	unsigned long flags2;
+
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_wrapper_div"));
+
+	spin_lock_irqsave(&emmc_port->lock,flags);
+
+	switch(level)
+    	{
+	case 0:
+		rtkemmc_writel(0x2100,emmc_port->emmc_membase + EMMC_CKGEN_CTL);
+		break;
+	case 1:
+		rtkemmc_writel(0x2010,emmc_port->emmc_membase + EMMC_CKGEN_CTL);
+		break;
+	case 2:
+		rtkemmc_writel(0x2102,emmc_port->emmc_membase + EMMC_CKGEN_CTL);
+		break;
+	case 3:
+		rtkemmc_writel(0x2103,emmc_port->emmc_membase + EMMC_CKGEN_CTL);
+		break;
+	}
+	
+	isb();
+	sync(emmc_port);
+	printk(KERN_INFO "%s: set_wrapper_div to 0x%08x\n", DRIVER_NAME, readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL));
+	
+	spin_unlock_irqrestore(&emmc_port->lock, flags);
+
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_wrapper_div"));
+}
+
+static void rtkemmc_set_ip_div(struct rtkemmc_host *emmc_port,u32 set_div)
+{
+	unsigned long flags;
+//	unsigned long flags2;
+
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_ip_div"));
+
+	u32 cur_div = readl(emmc_port->emmc_membase+EMMC_CLKDIV);
+
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_ip_div"));
+
+	if (cur_div == set_div){
+		printk(KERN_INFO "%s, set_ip_div = cur_div(0x%08x), ignored. \n", DRIVER_NAME, cur_div);
+		return;
+	}
+
+	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_STATUS), 0x200, 0x0, __func__);
+	
+	spin_lock_irqsave(&emmc_port->lock,flags);
+
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_ip_div"));
+	//disable clock
+	rtkemmc_writel(0, emmc_port->emmc_membase+EMMC_CLKENA);
+	isb();
+
+	//EMMC Cmd
+	rtkemmc_writel(0xa0202000, emmc_port->emmc_membase+EMMC_CMD);
+	isb();
+	sync(emmc_port);
+
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_ip_div"));
+
+	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase+EMMC_CMD), 0x80000000, 0x0, __func__);
+	sync(emmc_port);
+
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_ip_div"));
+	//set divider
+	rtkemmc_writel(set_div, emmc_port->emmc_membase+EMMC_CLKDIV);
+	isb();
+	sync(emmc_port);
+
+	while (readl(emmc_port->emmc_membase + EMMC_CLKDIV) != set_div){
+		printk(KERN_ERR RED_BOLD"Fail to write  EMMC_CLKDIV! EMMC_CLKDIV = 0x%08x\n"RESET, readl(emmc_port->emmc_membase+EMMC_CLKDIV));
+		rtkemmc_writel(set_div, emmc_port->emmc_membase+EMMC_CLKDIV);
+		sync(emmc_port);
+	}
+
+	//EMMC Cmd
+	rtkemmc_writel(0xa0202000, emmc_port->emmc_membase+EMMC_CMD);
+	isb();
+	sync(emmc_port);
+
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_ip_div"));
+
+	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase+EMMC_CMD), 0x80000000, 0x0, __func__);
+	isb();
+	sync(emmc_port);
+
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_ip_div"));
+
+	//enable clock
+	rtkemmc_writel(0x10001, emmc_port->emmc_membase+EMMC_CLKENA);
+	isb();
+	sync(emmc_port);
+
+	//EMMC Cmd
+	rtkemmc_writel(0xa0202000, emmc_port->emmc_membase+EMMC_CMD);
+	isb();
+	sync(emmc_port);
+
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_ip_div"));
+
+	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase+EMMC_CMD), 0x80000000, 0x0, __func__);
+	isb();
+
+	spin_unlock_irqrestore(&emmc_port->lock, flags);
+
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_ip_div"));
+	printk(KERN_INFO "%s: set div to 0x%02x, EMMC_CLKDIV=%08x\n", DRIVER_NAME, set_div, readl(emmc_port->emmc_membase + EMMC_CLKDIV));
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_ip_div"));
+}
+
+void phase(struct rtkemmc_host *emmc_port, u32 VP0, u32 VP1)
+{
+//	unsigned long flags2;
+
+	//phase selection
+	if( (VP0==0xff) & (VP1==0xff)){
+#ifdef DEBUG
+		printk("phase VP0 and VP1 no change \n");
+#endif
+	}
+	else if( (VP0!=0xff) & (VP1==0xff)) {
+#ifdef DEBUG
+		printk("phase VP0=%x, VP1 no change \n", VP0);
+#endif
+		//rtk_lockapi_lock2(flags2, _at_("phase"));
+		rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)|0x70000), emmc_port->emmc_membase + EMMC_CKGEN_CTL);    //change clock to 4MHz
+		//rtk_lockapi_unlock2(flags2, _at_("phase"));
+
+		sync(emmc_port);
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xfffffffd), emmc_port->crt_membase + SYS_PLL_EMMC1);     //reset pll
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xffffff07)|(VP0<<3), emmc_port->crt_membase + SYS_PLL_EMMC1);    //vp0 phase:0x0~0x1f
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)|0x2), emmc_port->crt_membase + SYS_PLL_EMMC1);    //release reset pll
+		sync(emmc_port);
+		udelay(200);
+
+		//rtk_lockapi_lock2(flags2, _at_("phase"));
+		rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)&0xfff8ffff), emmc_port->emmc_membase + EMMC_CKGEN_CTL); //change clock to PLL
+		//rtk_lockapi_unlock2(flags2, _at_("phase"));
+		sync(emmc_port);
+	}
+	else if( (VP0==0xff) & (VP1!=0xff)){
+#ifdef DEBUG
+		printk("phase VP0 no change, VP1=%x \n", VP1);
+#endif
+		//rtk_lockapi_lock2(flags2, _at_("phase"));
+		rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)|0x70000), emmc_port->emmc_membase + EMMC_CKGEN_CTL);    //change clock to 4MHz
+		//rtk_lockapi_unlock2(flags2, _at_("phase"));
+		sync(emmc_port);
+
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xfffffffd), emmc_port->crt_membase + SYS_PLL_EMMC1);     //reset pll
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xffffe0ff)|(VP1<<8), emmc_port->crt_membase + SYS_PLL_EMMC1);    //vp1 phase:0x0~0x1f
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)|0x2), emmc_port->crt_membase + SYS_PLL_EMMC1);    //release reset pll
+		sync(emmc_port);
+		udelay(200);
+
+		//rtk_lockapi_lock2(flags2, _at_("phase"));
+		rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)&0xfff8ffff),emmc_port->emmc_membase + EMMC_CKGEN_CTL);  //change clock to PLL
+		//rtk_lockapi_unlock2(flags2, _at_("phase"));
+		sync(emmc_port);
+	}
+        else{
+#ifdef DEBUG
+		printk("phase VP0=%x, VP1=%x \n", VP0, VP1);
+#endif
+		//rtk_lockapi_lock2(flags2, _at_("phase"));
+		rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)|0x70000),emmc_port->emmc_membase + EMMC_CKGEN_CTL);     //change clock to 4MHz
+		//rtk_lockapi_unlock2(flags2, _at_("phase"));
+		sync(emmc_port);
+
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xfffffffd),emmc_port->crt_membase + SYS_PLL_EMMC1);      //reset pll
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xffffff07)|(VP0<<3),emmc_port->crt_membase + SYS_PLL_EMMC1);     //vp0 phase:0x0~0x1f
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xffffe0ff)|(VP1<<8),emmc_port->crt_membase + SYS_PLL_EMMC1);     //vp1 phase:0x0~0x1f
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)|0x2),emmc_port->crt_membase + SYS_PLL_EMMC1);     //release reset pll
+		sync(emmc_port);
+		udelay(200);
+
+		//rtk_lockapi_lock2(flags2, _at_("phase"));
+                rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)&0xfff8ffff),emmc_port->emmc_membase + EMMC_CKGEN_CTL);  //change clock to PLL
+		//rtk_lockapi_unlock2(flags2, _at_("phase"));
+		sync(emmc_port);
+	}
+#ifdef EMMC_DEBUG
+	//rtk_lockapi_lock2(flags2, _at_("phase"));
+	printk(KERN_ERR "%s: phase adjust - EMMC_CKGEN_CTL=0x%08x, PLL_EMMC1=%08x, PLL_EMMC2=%08x, PLL_EMMC3=%08x, PLL_EMMC4=%08x\n",
+		DRIVER_NAME,
+		readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC1),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC2),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC3),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC4));
+	//rtk_lockapi_unlock2(flags2, _at_("phase"));
+#endif
+}
+
+static void rtkemmc_set_freq(struct rtkemmc_host *emmc_port, u32 freq)
+{
+	u32 tmp_val=0;
+	unsigned long flags;
+//	unsigned long flags2;
+
+	spin_lock_irqsave(&emmc_port->lock,flags);
+	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_STATUS), 0x200, 0x0, __func__);          //card is not busy
+	isb();
+	sync(emmc_port);
+
+	//disable clk_en_emmc_ip, using common clk framework`
+	//tmp_val = (readl(emmc_port->crt_membase + SYS_CLOCK_ENABLE1) & 0xefffffff);
+	//rtkemmc_writel(tmp_val, emmc_port->crt_membase + SYS_CLOCK_ENABLE1);
+
+	clk_disable_unprepare(clk_en_emmc_ip);
+	isb();
+	sync(emmc_port);
+
+	tmp_val = (readl(emmc_port->crt_membase + SYS_PLL_EMMC4) & 0x06);
+	rtkemmc_writel(tmp_val, emmc_port->crt_membase + SYS_PLL_EMMC4);
+	isb();
+	sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+	if (get_rtd_chip_revision() < RTD_CHIP_A01 ) {
+		rtkemmc_writel(1, emmc_port->crt_membase + SYS_GROUP1_CK_SEL);
+		isb();
+		sync(emmc_port);
+	}
+#endif
+	tmp_val = (readl(emmc_port->crt_membase + SYS_PLL_EMMC3) & 0xffff)|(freq<<16);
+	rtkemmc_writel(tmp_val, emmc_port->crt_membase + SYS_PLL_EMMC3);
+	isb();
+	sync(emmc_port);
+
+	tmp_val = (readl(emmc_port->crt_membase + SYS_PLL_EMMC4) | 0x01);
+	rtkemmc_writel(tmp_val, emmc_port->crt_membase + SYS_PLL_EMMC4);
+	isb();
+	sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+	if (get_rtd_chip_revision() < RTD_CHIP_A01 ) {
+		rtkemmc_writel(0, emmc_port->crt_membase + SYS_GROUP1_CK_SEL);
+		isb();
+		sync(emmc_port);
+	}
+#endif
+#ifdef CONFIG_ARCH_RTD129x	//1395 does not need to toggle this register
+	// [A01] ECO, If EMMC N/F code changed, toggle CR_EMMC_DUMMY_SYS bit 30
+	if (get_rtd_chip_revision() >= RTD_CHIP_A01 ) {
+		//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_freq"));
+		rtkemmc_writel(readl(emmc_port->emmc_membase + EMMC_DUMMY_SYS) ^ 0x40000000, emmc_port->emmc_membase + EMMC_DUMMY_SYS);
+		//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_freq"));
+		isb();
+		sync(emmc_port);
+	}
+
+	udelay(400); //delay 200us to wait PLL stable
+	isb();
+	sync(emmc_port);
+#endif
+	//enable clk_en_emmc_ip
+	//tmp_val = (readl(emmc_port->crt_membase + SYS_CLOCK_ENABLE1) | 0x10000000);
+	//rtkemmc_writel(tmp_val, emmc_port->crt_membase + SYS_CLOCK_ENABLE1);
+
+	clk_prepare_enable(clk_en_emmc_ip);
+	isb();
+	sync(emmc_port);
+
+	spin_unlock_irqrestore(&emmc_port->lock, flags);
+
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_freq"));
+	printk(KERN_INFO "%s: set_freq to 0x%02x, EMMC_CKGEN_CTL=0x%08x, PLL_EMMC1=%08x, PLL_EMMC2=%08x, PLL_EMMC3=%08x, PLL_EMMC4=%08x\n",
+		DRIVER_NAME,
+		freq, readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC1),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC2),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC3),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC4));
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_freq"));
+}
+
+void rtkemmc_speed_up(void)
+{
+	struct mmc_host * mmc = mmc_host_local;
+	struct rtkemmc_host *emmc_port;
+
+	emmc_port = mmc_priv(mmc);
+
+	rtkemmc_set_freq(emmc_port,0x46);  //80Mhz
+	rtkemmc_set_ip_div(emmc_port,EMMC_CLOCK_DIV_8);
+}
+EXPORT_SYMBOL(rtkemmc_speed_up);
+
+static u32 rtkemmc_chk_cmdcode(struct mmc_command* cmd)
+{
+	u32 cmdcode;
+
+	if(cmd->opcode < 56){
+		cmdcode = (u32)rtk_sd_cmdcode[cmd->opcode][0];
+		WARN_ON(cmd->data == NULL);
+		if(cmd->data->flags & MMC_DATA_WRITE){
+			if(cmd->opcode == 42)
+				cmdcode = EMMC_NORMALWRITE;
+			else if(cmd->opcode == 56)
+				cmdcode = EMMC_AUTOWRITE2;
+		}
+	}else
+		cmdcode = EMMC_CMD_UNKNOW;
+
+	return cmdcode;
+}
+
+static void rtkemmc_set_pin_mux(struct rtkemmc_host *emmc_port)
+{
+	u32 reg_val=0;
+//	unsigned long flags2;
+
+	MMCPRINTF("rtkemmc_set_pin_mux \n");
+
+	//1295 muxpad0 is in card reader
+	//set default i/f to emmc
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_set_pin_mux"));
+#if defined(CONFIG_ARCH_RTD129x)
+	reg_val = readl(emmc_port->emmc_membase + EMMC_muxpad0);
+	reg_val &= ~0xFFFF0C3C;
+	//reg_val |= 0xaaaa0828;    //comment by Jim
+	reg_val |= 0xaaaa0824;  //2017/1/17 modified by Jim, change pin mux to NAND flash instead of emmc rstn
+        
+	rtkemmc_writel(reg_val, emmc_port->emmc_membase+EMMC_muxpad0);
+	sync(emmc_port);
+	rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_muxpad1)&0xffffcfff)|0x2000, emmc_port->emmc_membase + EMMC_muxpad1); //kylin data strobe pad mux
+	sync(emmc_port);
+#elif defined(CONFIG_ARCH_RTD139x)
+	reg_val = readl(emmc_port->iso_muxpad + ISO_muxpad4);
+        reg_val &= ~0x3;
+        reg_val |= 0x1;
+
+        rtkemmc_writel(reg_val, emmc_port->iso_muxpad + ISO_muxpad4);
+#elif defined(CONFIG_ARCH_RTD16xx)
+	reg_val = readl(emmc_port->m2tmx + m2tmx_muxpad0);
+	reg_val &= 0xfe000001;	//bit 1 - bit 24 set 0x10 0x10 0x10...0x10
+	reg_val |= 0x01555554;
+	rtkemmc_writel(reg_val, emmc_port->m2tmx + m2tmx_muxpad0);
+#endif
+
+#ifdef CONFIG_ARCH_RTD129x
+	//emmc :pfunc_nf1
+	rtkemmc_writel(0x33333333, emmc_port->emmc_membase+EMMC_PFUNC_NF1);
+	sync(emmc_port);
+	printk(KERN_INFO "rtkemmc_set_pin_mux: EMMC_PFUNC_NF1 = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_PFUNC_NF1));
+#endif
+	rtkemmc_writel(0, emmc_port->emmc_membase+EMMC_PAD_CTL); //PAD to 1.8v
+	sync(emmc_port);
+	
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_set_pin_mux"));
+}
+
+static void rtkemmc_timeout_timer(unsigned long data)
+{
+	struct rtkemmc_host *emmc_port;
+	unsigned long flags;
+//	unsigned long flags2;
+
+	emmc_port = (struct rtkemmc_host *)data;
+	MMCPRINTF("rtkemmc_timeout_timer fired ...\n");
+	MMCPRINTF("%s - int_wait=%08x\n", __func__, emmc_port->int_waiting);
+    
+	spin_lock_irqsave(&emmc_port->lock,flags);
+	//down_write(&cr_rw_sem);
+#ifdef ENABLE_EMMC_INT_MODE
+	if(emmc_port->int_waiting)
+#else
+	if (1)
+#endif
+	{
+		MMCPRINTF("1. get sd trans \n");
+#ifdef ENABLE_EMMC_INT_MODE
+		MMCPRINTF("========== C1 ==========\n");
+		rtkemmc_hold_int_dec();
+                rtkemmc_get_int_sta(&emmc_port->rintsts, &emmc_port->mintsts, &emmc_port->dma_isr);
+		rtkemmc_get_sta(&emmc_port->status, &emmc_port->idsts);
+		rtkemmc_get_mask(&emmc_port->idinten, &emmc_port->intmask);
+		sync(emmc_port);
+#endif
+
+		MMCPRINTF("rintsts =%08x, mintsts=0x%08x, int_waiting=%08x\n", emmc_port->rintsts, emmc_port->mintsts, emmc_port->int_waiting);
+		MMCPRINTF("status=0x%08x idsts=0x%8x\n",emmc_port->status ,emmc_port->idsts);
+	}
+	else {
+		WARN_ON(1);
+	}
+
+	if(emmc_port->int_waiting)
+		rtk_op_complete(emmc_port);
+
+	spin_unlock_irqrestore(&emmc_port->lock, flags);
+	//up_write(&cr_rw_sem);
+}
+
+static irqreturn_t rtkemmc_irq(int irq, void *dev)
+{
+	struct rtkemmc_host *emmc_port = dev;
+	int irq_handled = 0;
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_lock2(flags2, _at_("rtkemmc_irq"));
+#endif
+	rtkemmc_get_int_sta(&emmc_port->rintsts, &emmc_port->mintsts, &emmc_port->dma_isr);
+	rtkemmc_get_sta(&emmc_port->status, &emmc_port->idsts);
+	rtkemmc_get_mask(&emmc_port->idinten, &emmc_port->intmask);
+	sync(emmc_port);
+
+	MMCPRINTF("rintsts =%08x, mintsts=0x%08x, int_waiting=%08x\n", emmc_port->rintsts, emmc_port->mintsts, emmc_port->int_waiting);
+	MMCPRINTF("intmask =%08x, isr=0x%08x\n", readl(emmc_port->emmc_membase+EMMC_INTMASK), emmc_port->dma_isr);
+    
+	rtkemmc_hold_int_dec();
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_unlock2(flags2, _at_("rtkemmc_irq"));
+#endif
+	MMCPRINTF("we get int end \n");
+
+#ifdef  SHOW_INT_STATUS
+	printk("status=0x%08x idsts=0x%8x\n",emmc_port->status,emmc_port->idsts);
+#endif
+	if(emmc_port->int_waiting) {
+		MMCPRINTF("int wait clear 1\n");
+		del_timer(&emmc_port->timer);
+		if (g_bResuming) //avoid to emit complete in rtkemmc_resume
+			return IRQ_HANDLED;
+
+		rtk_op_complete(emmc_port);
+		MMCPRINTF("int wait clear 2\n");
+	}else{
+		MMCPRINTF("No int_waiting!!!\n");
+	}
+
+	irq_handled = 1;
+	sync(emmc_port);
+
+	if(irq_handled)
+		return IRQ_HANDLED;
+	else
+		return IRQ_NONE;
+}
+
+static void rtkemmc_chk_card_insert(struct rtkemmc_host *emmc_port)
+{
+	struct mmc_host *host=emmc_port->mmc;
+//	unsigned long flags2;
+
+	MMCPRINTF("%s : \n", __func__);
+
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_chk_card_insert"));
+
+	rtkemmc_writel(0x00000000 ,emmc_port->emmc_membase + EMMC_DDR_REG); //restore to default   //9801210c
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_DQS_CTRL1);    //98012498
+
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_chk_card_insert"));
+
+#ifdef PHASE_INHERITED
+        if (VP0_saved == 0xFF && VP1_saved == 0xFF){
+                HS200_TX = VP0_saved = (readl(emmc_port->crt_membase + SYS_PLL_EMMC1) & 0x000000f8) >> 3;
+                HS200_RX = VP1_saved = (readl(emmc_port->crt_membase + SYS_PLL_EMMC1) & 0x00001f00) >> 8;
+        }
+
+#endif
+	if(emmc_port->tx_user_defined) {        //if we set user defined tx and rx value, then we won't use the bootcode reference value, always the first priority
+                HS200_TX = VP0_saved = emmc_port->tx_reference_phase;
+        }
+        if(emmc_port->rx_user_defined) {
+                HS200_RX = VP1_saved = emmc_port->rx_reference_phase;
+        }
+
+#ifdef DQS_INHERITED
+	if (dqs_saved == 0xff)
+		dqs_saved = readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+#endif
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_chk_card_insert"));
+	rtkemmc_writel(3, emmc_port->crt_membase + SYS_PLL_EMMC1);      //980001f0
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+	udelay(1);
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00000081, emmc_port->emmc_membase + EMMC_BMOD);    //98012080  //enable the emmc dma and do dma software reset
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x02000000, emmc_port->emmc_membase + EMMC_CTRL);        //98012000      //if we use DMA, bit 25 has to be set
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writel(0x00000001, emmc_port->emmc_membase + EMMC_PWREN);       //98012004      //we only have one emmc, so we just set bit 0 to 1 to power on
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x0000ffce, emmc_port->emmc_membase + EMMC_INTMASK);     //98012024      //in emmc IP, it can be used as SD, MMC,SDIO,emmc, but in realtek usage, we only use emmc,
+                                                                                                //so, we disable SDIO mask, but it does not matter for use to set o or 1 because they do not
+                                                                                                //use these data pin, lower 16 bit is for emmc usage, we enable it
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0xffffffff, emmc_port->emmc_membase + EMMC_RINTSTS);     //98012044      //clear SDIO interrupt status bit, lower 16 bit is for emmc interrupt check, initial
+                                                                                                //value is 0
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00000080, emmc_port->emmc_membase + EMMC_CLKDIV);      //98012008      //in emmc IP, we have 4 clock divider, in realtek chipset, we only use the first divider,
+                                                                                                //and we set the divider is 2*128=256, so initial clock rate is 80MHz/256
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00000000, emmc_port->emmc_membase + EMMC_CLKSRC);      //9801200c      //choose the clock divider source, as previosly said, we only use divider 0
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x0001ffff, emmc_port->emmc_membase + EMMC_CLKENA);      //98012010      //higher 16 bit is for low power control, do not send clock if no command, we only have
+                                                                                                //one emmc, so we set bit 16 as 1m and ffff can only be set to 1 instead of ffff
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0xa0200000, emmc_port->emmc_membase + EMMC_CMD);         //9801202c      //bit 31 is for two purposes, one is for send command, set this bit to fire a command,
+                                                                                                //the other is to update the clock register when we modify the clock related register
+                                                                                                //including clock divider, clock enable, for this usage, we must set bit 21, as for bit 29,
+                                                                                                //we decide if we need  tx ,rx normal clock or use the same clock, in realtek case, we use
+                                                                                                //different clock, so set it as 1
+	isb();
+	sync(emmc_port);
+	MMCPRINTF(KERN_INFO "1 EMMC_TMOUT = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_TMOUT));   //98012014
+	rtkemmc_writel(0xffffff40, (volatile void*)(emmc_port->emmc_membase + EMMC_TMOUT));
+	isb();
+	sync(emmc_port);
+	MMCPRINTF(KERN_INFO "2 EMMC_TMOUT = 0x%08x \n",  (volatile void*)readl(emmc_port->emmc_membase + EMMC_TMOUT));
+
+	rtkemmc_writel(0x00000000, emmc_port->emmc_membase + EMMC_CTYPE);       //98012018      //initially, we set bus width as 1 for card 0 (emmc)
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x0001007f, emmc_port->emmc_membase + EMMC_FIFOTH); // original: 0x0007f007f //9801204c, set the tx, rx threshold to decide whether we have to read/write data to/from
+                                                                                                        //FIFO
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x02000010, emmc_port->emmc_membase + EMMC_CTRL);        //98012000      //bit 4 is global interrupt enable, we have to set this bit to 1 and then
+                                                                                                //98012024 and 98012044 is meaningful, otherwise, nonsense
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00000080, emmc_port->emmc_membase + EMMC_BMOD);        //98012080      //no need for this write becasue reset the bit 0 will be reset to 0
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x0000ffce, emmc_port->emmc_membase + EMMC_INTMASK);     //98012024      //FIFO interrupt has some issues, so we disable this two bits
+	isb();
+	sync(emmc_port);
+	//rtkemmc_writel(0x00600000, emmc_port->emmc_membase + EMMC_DBADDR);
+	rtkemmc_writel(0x00000000, emmc_port->emmc_membase + EMMC_IDINTEN);     //98012090      //we do not use abnormal interrupt, so disable all
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x0000ffff, emmc_port->emmc_membase + EMMC_RINTSTS);     //98012044      //do not need this one
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x00000001, emmc_port->emmc_membase + EMMC_UHSREG);      //98012074      //in emmc, they always use 1.8V, differenct from SD card, they do not need to switch voltage
+	isb();
+	sync(emmc_port);
+	rtkemmc_writel(0x02000001, emmc_port->emmc_membase + EMMC_CARD_THR_CTL);        //98012100      //FIFO size is 128, once the FIFO size is greater than 128 bytes, we can read/write
+                                                                                                        //but in this case, we only set bit 0 as 1, we only set read threshold
+	isb();
+	sync(emmc_port);
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xa, emmc_port->emmc_membase+EMMC_OTHER1);    //Enable eMMC L4 gated
+	if(MASK_DRTO)	//enable/disable timeout mechanism
+		writel(readl(emmc_port->emmc_membase + EMMC_DUMMY_SYS) | 0x1, emmc_port->emmc_membase + EMMC_DUMMY_SYS);
+#endif
+
+
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_chk_card_insert"));
+#ifdef EMMC_LA_DEBUG_GPIO
+	//gpio 100 pin mux
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_chk_card_insert"));
+#ifdef CONFIG_ARCH_RTD129x
+	reg = readl(emmc_port->emmc_membase + EMMC_muxpad2);            //9801261c
+	reg &= (~0x00003000);
+	rtkemmc_writel(reg, emmc_port->emmc_membase + EMMC_muxpad2);
+#endif
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_chk_card_insert"));
+	//gpio 100 dir
+	reg = readl(emmc_port->misc_membase + MISC_GP3DIR);             //9801B10c
+	reg |= (0x00000010);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP3DIR);
+
+	//gpio 100  pull  high
+	reg = readl(emmc_port->misc_membase + MISC_GP3DATO);            //9801B11c
+	reg |= (0x00000010);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP3DATO);
+	isb();
+	sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_chk_card_insert"));
+
+	//gpio 90 pin mux
+	reg = readl(emmc_port->emmc_membase + EMMC_muxpad1);            //98012604
+	reg &= (~0x0000000c);
+	rtkemmc_writel(reg, emmc_port->emmc_membase + EMMC_muxpad1);
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_chk_card_insert"));
+#endif
+	//gpio 90 dir
+	reg = readl(emmc_port->misc_membase + MISC_GP2DIR);             //9801B108
+	reg |= (0x04000000);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP2DIR);
+
+	//gpio 90  pull  high
+	reg = readl(emmc_port->misc_membase + MISC_GP2DATO);            //9801B118
+	reg |= (0x04000000);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP2DATO);
+	isb();
+	sync(emmc_port);
+#endif
+	rtkemmc_set_bits(emmc_port,BUS_WIDTH_1);                    //initially, set the bus width as 1
+
+#ifdef CONFIG_ARCH_RTD129x
+	rtkemmc_set_pad_driving(emmc_port, 0x33, 0x33, 0x33, 0x33);
+#else
+	rtkemmc_set_pad_driving(emmc_port, 0x0, 0x0, 0x0, 0x0);
+#endif
+
+	rtkemmc_set_wrapper_div(emmc_port, 0);                      //in emmc, they have two clock divider, ip and wrapperm in SD case, they only have wrapper clock divider
+         	                                                    //because emmc IP clock divider can set clock precisely, we do not need to use wrapper clock divider
+
+	rtkemmc_set_ip_div(emmc_port, EMMC_CLOCK_DIV_256);
+	
+	//initially, we do not use pass tuning result from bootcode, so we need to reset the tx ,rx phase to 0 first, 
+	//and then framework call rtkemmc_tuning will set the rx tx register
+	//Now, we use the mechanism and hold this part for fear that user will use kernel tuning one day in the future
+	//if we use tuning inherit, the phase will be set to 0 and restore the tx rx from bootcode
+	phase(emmc_port, 0, 0); //VP0, VP1 phase
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+	udelay(1);
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+	rtkemmc_set_freq(emmc_port,0x46);  //80Mhz / 256 ~= 300K
+
+	sync(emmc_port);
+	host->ops = &rtkemmc_ops;
+	emmc_port->rtflags |= RTKCR_FCARD_DETECTED;
+#ifdef EMMC_DEBUG
+	rtkemmc_dump_registers(emmc_port);
+#endif
+}
+
+static int rtkemmc_set_rspparam(struct rtkemmc_host *emmc_port, struct sd_cmd_pkt *cmd_info)
+{
+	switch(cmd_info->cmd->opcode)
+	{
+	case MMC_GO_IDLE_STATE:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG);
+		cmd_info->rsp_len = 6;
+		cmd_info->cmd->arg = 0x00000000;
+		break;
+	case MMC_SEND_OP_COND:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_RSP_EXP);
+		cmd_info->cmd->arg = MMC_SECTOR_ADDR|MMC_VDD_165_195;
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_ALL_SEND_CID:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC|CMD_RSP_LEN|CMD_RSP_EXP);
+		cmd_info->rsp_len = 17;
+		cmd_info->cmd->arg = 0x00000000;
+		break;
+	case MMC_SET_RELATIVE_ADDR:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+		cmd_info->cmd->arg = (1<<RCA_SHIFTER);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SEND_CSD:
+	case MMC_SEND_CID:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC|CMD_RSP_LEN|CMD_RSP_EXP);
+		cmd_info->cmd->arg = (1<<RCA_SHIFTER);
+		cmd_info->rsp_len = 17;
+		break;
+	case MMC_SEND_EXT_CSD:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_DATA_EXP|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+		cmd_info->cmd->arg = 0;
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SLEEP_AWAKE:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+		cmd_info->rsp_len = 6;
+		printk(KERN_INFO "%s : cmd5 arg=0x%08x\n",__func__,cmd_info->cmd->arg);
+		break;
+	case MMC_SELECT_CARD:
+		printk(KERN_INFO "%s : cmd7 arg : 0x%08x\n",__func__,cmd_info->cmd->arg);
+		if (cmd_info->cmd->flags == (MMC_RSP_NONE | MMC_CMD_AC)) {
+			printk(KERN_INFO "%s : cmd7 with rsp none\n",__func__);
+			cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC);
+		}
+		else {
+			printk(KERN_INFO "%s : cmd7 with rsp\n",__func__);
+			cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC|CMD_RSP_LEN|CMD_RSP_EXP);
+		}
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SWITCH:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SEND_STATUS:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+		cmd_info->cmd->arg = (1<<RCA_SHIFTER);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_STOP_TRANSMISSION:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_READ_MULTIPLE_BLOCK:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_SEND_AUTO_STOP|CMD_DATA_EXP|CMD_CHK_RESP_CRC|CMD_RSP_EXP|CMD_WAIT_PRV_DATA_COMPLETE);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SET_BLOCK_COUNT:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_WRITE_MULTIPLE_BLOCK:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_SEND_AUTO_STOP|CMD_RD_WR|CMD_DATA_EXP|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_READ_SINGLE_BLOCK:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_DATA_EXP|CMD_CHK_RESP_CRC|CMD_RSP_EXP|CMD_WAIT_PRV_DATA_COMPLETE);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_WRITE_BLOCK:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_RD_WR|CMD_DATA_EXP|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_ERASE_GROUP_START:
+	case MMC_ERASE_GROUP_END:
+	case MMC_ERASE:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_GEN_CMD:
+		if(cmd_info->cmd->arg & 0x1) {   //read single block
+			cmd_info->cmd->arg = 0x1;
+			cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_DATA_EXP|CMD_CHK_RESP_CRC|CMD_RSP_EXP|CMD_WAIT_PRV_DATA_COMPLETE);
+			cmd_info->rsp_len = 6;
+			break;
+		}
+		else {      //write single block
+			cmd_info->cmd->arg = 0x0;
+			cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG|CMD_RD_WR|CMD_DATA_EXP|CMD_CHK_RESP_CRC|CMD_RSP_EXP);
+			cmd_info->rsp_len = 6;
+			break;
+		}
+	default:
+		cmd_info->cmd_para = (CMD_START_CMD|CMD_USE_HOLD_REG);
+		cmd_info->rsp_len = 6;
+		break;
+	}
+
+	MMCPRINTF(KERN_INFO "%s : cmd=0x%02x rsp_len=0x%02x arg=0x%08x para=0x%08x\n","rtkemmc", cmd_info->cmd->opcode, cmd_info->rsp_len,cmd_info->cmd->arg,cmd_info->cmd_para);
+	return 0;
+}
+
+static int rtkemmc_stop_transmission(struct mmc_card *card,int bIgnore)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	int err = 0;
+	int bMalloc=0;
+	struct mmc_host * mmc = mmc_host_local;
+
+	MMCPRINTF("%s : \n", __func__);
+
+	memset(&cmd, 0, sizeof(struct mmc_command));
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+	if (card == NULL) {
+		bMalloc=1;
+		card = (struct mmc_card*)kmalloc(sizeof(struct mmc_card),GFP_KERNEL);
+		card->host = mmc;
+	}
+	set_cmd_info(card,&cmd,&cmd_info, MMC_STOP_TRANSMISSION, 0x00, 6);
+	err = SD_SendCMDGetRSP_Cmd(&cmd_info,bIgnore);
+	//printk(KERN_ERR "Tuning err handling cmd 12: EMMC_RINTSTS=0x%x,  EMMC_STATUS=0x%x\n",readl(emmc_port->emmc_membase + EMMC_RINTSTS),readl(emmc_port->emmc_membase + EMMC_STATUS));
+	if (bMalloc) {
+		kfree(card);
+		card = NULL;
+	}
+
+	if(err)
+		mmcmsg3(KERN_WARNING "%s: MMC_STOP_TRANSMISSION fail\n",DRIVER_NAME);
+
+	return err;
+}
+
+static int rtkemmc_wait_status(struct mmc_card *card,u8 state,u8 divider,int bIgnore)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	unsigned long timeend;
+	int err, bMalloc=0;
+	struct mmc_host * mmc = mmc_host_local;
+
+	MMCPRINTF("\n");
+	timeend = jiffies + msecs_to_jiffies(100);    /* wait 100ms */
+
+	if (card == NULL) {
+		bMalloc=1;
+		card = (struct mmc_card*)kmalloc(sizeof(struct mmc_card),GFP_KERNEL);
+		card->host = mmc;
+	}
+
+	do {
+		memset(&cmd, 0, sizeof(struct mmc_command));
+		memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+		set_cmd_info(card,&cmd,&cmd_info, MMC_SEND_STATUS, (card->rca)<<RCA_SHIFTER, 6);
+		err = SD_SendCMDGetRSP_Cmd(&cmd_info,bIgnore);
+
+		if(err) {
+			if (!bIgnore)
+				printk(KERN_INFO "wait %s fail\n",state_tlb[state]);
+			break;
+		}
+		else {
+			u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
+			if (!bIgnore)
+				MMCPRINTF(KERN_WARNING "resp[0]=0x%08x,cur_state=%s\n",cmd.resp[0],state_tlb[cur_state]);
+			err = -1;
+			if(cur_state == state) {
+				if(cmd.resp[0] & R1_READY_FOR_DATA) {
+					err = 0;
+					break;
+				}
+			}
+		}
+	}while(time_before(jiffies, timeend));
+
+	if (bMalloc) {
+		kfree(card);
+		card = NULL;
+	}
+	return err;
+}
+
+void down_speed_handling(struct rtkemmc_host *emmc_port)
+{
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	struct mmc_host *mmc = emmc_port->mmc;
+	if(gCurrentBootMode == MODE_HS200) {
+		printk(KERN_ERR "down speed from HS200 to SDR50....\n");
+		//downgrade to SDR50 mode
+		mmc->caps &= ~(MMC_CAP_UHS_DDR50|MMC_CAP_1_8V_DDR);	//do not set emmc host capability as HS200
+		mmc->caps2 &= ~(MMC_CAP2_HS200_1_8V_SDR);
+		udelay(200);
+
+		rtkemmc_stop_transmission(mmc->card, 1);
+		wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_STATUS), 0x200, 0x0, __func__);          //card is not busy
+		isb();
+		sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("down_speed_HS200"));
+#endif
+		if (readl(emmc_port + EMMC_TBBCNT) == 1024) {
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("down_speed_HS200"));
+#endif
+			wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_ISR), ISR_DMA_DONE_INT, ISR_DMA_DONE_INT, __func__);          //card is not busy
+			isb();
+			sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_lock2(flags2, _at_("down_speed_HS200"));
+#endif
+			rtkemmc_clr_int_sta();
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("down_speed_HS200"));
+#endif
+		}
+#ifdef CONFIG_ARCH_RTD129x
+		else
+			rtk_lockapi_unlock2(flags2, _at_("down_speed_HS200"));
+#endif
+
+		card_stop(emmc_port);
+		polling_to_tran_state(emmc_port,MMC_READ_MULTIPLE_BLOCK,1);//just pick up 1 command index for parameter
+
+		if (!g_bResuming)
+			gCurrentBootMode = MODE_SDR;
+
+		rtkemmc_select_card_type(mmc->card);	//do not set the emmc card capability as HS200
+		rtkemmc_select_timing(mmc->card);	//send cmd 6 again to inform the host SDR50 mode and set the correct bus speed mode
+
+		rtkemmc_set_freq(emmc_port, 0x57); //100Mhz
+		rtkemmc_set_ip_div(emmc_port, EMMC_CLOCK_DIV_2); // 100MHZ/2 = 50MHZ
+
+#ifdef CONFIG_ARCH_RTD129x
+		rtkemmc_set_pad_driving(emmc_port,0x33, 0x33, 0x33, 0x33);
+#else
+		rtkemmc_set_pad_driving(emmc_port,0x0, 0x0, 0x0, 0x0);
+#endif
+		rtkemmc_writel(3, emmc_port->crt_membase + SYS_PLL_EMMC1);      //980001f0
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+		isb();
+	
+		sync(emmc_port);
+		udelay(100);
+	}
+	else if(gCurrentBootMode == MODE_HS400) {
+		//TBD
+		printk(KERN_ERR "down speed from HS400 to HS200....\n");
+		//downgrade to HS200 mode
+		mmc->caps2 &= ~(MMC_CAP2_HS400_1_8V);
+		if (!g_bResuming) {
+			gCurrentBootMode = MODE_HS200;
+		}
+		emmc_port->tx_tuning = emmc_port->rx_tuning = 1;
+
+		set_RTK_initial_flag(0);
+		printk(KERN_ERR "stop the emmc ...\n");
+		rtkemmc_stop_transmission(mmc->card, 1);
+		wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_STATUS), 0x200, 0x0, __func__);          //card is not busy
+		isb();
+		sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("down_speed_handling"));
+#endif
+		if (readl(emmc_port + EMMC_TBBCNT) == 1024) {
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("down_speed_handling"));
+#endif
+			wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_ISR), ISR_DMA_DONE_INT, ISR_DMA_DONE_INT, __func__);          //card is not busy
+			isb();
+			sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_lock2(flags2, _at_("down_speed_handling"));
+#endif
+			rtkemmc_clr_int_sta();
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("down_speed_handling"));
+#endif
+		}
+		else {
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("down_speed_handling"));
+#endif
+		}
+
+		card_stop(emmc_port);
+		polling_to_tran_state(emmc_port,MMC_READ_MULTIPLE_BLOCK,1);//just pick up 1 command index for parameter
+		//rtkemmc_backup_registers(emmc_port);
+		//rtkemmc_hw_reset();
+		//rtkemmc_restore_registers(emmc_port);
+		rtkemmc_writel(0x00000000 ,emmc_port->emmc_membase + EMMC_DDR_REG);
+		rtkemmc_writel(0x00000001, emmc_port->emmc_membase + EMMC_UHSREG);
+		rtkemmc_writel(0x80, emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+		printk(KERN_ERR "down speed: change emmc card capability to hs200...\n");
+                rtkemmc_select_card_type(mmc->card);    //do not set the emmc card capability as HS200
+		printk(KERN_ERR "down speed: hs400 to hs200...\n");
+		mmc_hs400_to_hs200(mmc->card);
+		printk(KERN_ERR "down speed: HS200 tuning...\n");
+		hs400_to_hs200_flag=true;
+		rtkemmc_hs200_tuning(mmc->card);
+	}
+}
+
+static int rtkemmc_wait_opt_end(char* drv_name, struct rtkemmc_host *emmc_port,u8 cmdcode,u32 cmd_idx,u8 ignore_log)
+{
+	volatile int err = RTK_SUCC;
+	volatile unsigned long timeend=0;
+	unsigned long flags;
+	int loop_threshold=0;
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	u32 reg = 0;
+	u32 reg_blksize = 0;
+	u32 reg_bytecount = 0;
+	u32 reg_cmdidx = 0;
+	u32 reg_argu = 0;
+	u32 i = 0;
+
+	unsigned long msec = TIMEOUT_MS;
+	unsigned long dma_msec = 0;
+
+	switch(CMD_IDX_MASK(cmd_idx)) {
+		case MMC_READ_SINGLE_BLOCK:
+		case MMC_READ_MULTIPLE_BLOCK:
+		case MMC_WRITE_BLOCK:
+		case MMC_WRITE_MULTIPLE_BLOCK:
+		case MMC_SEND_EXT_CSD:
+			dma_msec=TIMEOUT_DMA;
+			break;
+	}
+	MMCPRINTF("%s - data_to=%u, dma_to=0x%08x\n","rtkemmc",TIMEOUT_MS,dma_msec);
+	//err = rtk_int_enable_and_waitfor(emmc_port,cmdcode,cmd_idx,TIMEOUT_MS,dma_to,ignore_log);
+#ifndef ENABLE_EMMC_INT_MODE
+	emmc_port->int_waiting = NULL;
+#else
+	emmc_port->int_waiting = &rtk_emmc_wait;
+	MMCPRINTF("%s : msec = %u \n", __func__, msec);
+	MMCPRINTF("%s : emmc_port->tmout = %u \n", __func__, emmc_port->tmout);
+	MMCPRINTF("rtk wait complete addr = %08x\n", (unsigned int) emmc_port->int_waiting);
+	/* timeout timer fire */
+	if (&emmc_port->timer) {
+#ifndef CONFIG_MMC_RTKEMMC_JIFFY_NOT_WORK_ON_1_LAYER_FPGA
+		MMCPRINTF("now = 0x%08x\n", jiffies);
+		MMCPRINTF("timer started : ");
+		timeend = jiffies + msecs_to_jiffies(msec)+emmc_port->tmout;
+		MMCPRINTF("TO = 0x%08x\n", timeend);
+		mod_timer(&emmc_port->timer, timeend );
+#endif
+	}
+#endif
+
+#ifdef ENABLE_EMMC_INT_MODE
+	if(emmc_port->rtflags & RTKCR_FOPEN_LOG){
+		//rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+		printk(KERN_ERR "cmd_idx:%08x ------------------------------>\n",cmd_idx);
+		printk(KERN_ERR "rtkemmc - before cmd fired\n\trintsts : 0x%08x mintsts : 0x%08x, status : 0x%08x, idsts : 0x%08x\n\tcmd=0x%08x, cmd_arg=0x%08x\n",
+			readl(emmc_port->emmc_membase+EMMC_RINTSTS),readl(emmc_port->emmc_membase+EMMC_MINTSTS),readl(emmc_port->emmc_membase+EMMC_STATUS),
+			readl(emmc_port->emmc_membase+EMMC_IDSTS),cmd_idx,readl(emmc_port->emmc_membase+EMMC_CMDARG));
+		printk(KERN_ERR "\tbmod : 0x%08x ctrl : 0x%08x, pwren : 0x%08x, intmask : 0x%08x\n\tclkdiv : 0x%08x, clksrc : 0x%08x, clkena : 0x%08x, cmd : 0x%08x\n",
+			readl(emmc_port->emmc_membase+EMMC_BMOD),readl(emmc_port->emmc_membase+EMMC_CTRL),readl(emmc_port->emmc_membase+EMMC_PWREN),
+			readl(emmc_port->emmc_membase+EMMC_INTMASK),readl(emmc_port->emmc_membase+EMMC_CLKDIV),readl(emmc_port->emmc_membase+EMMC_CLKSRC),
+			readl(emmc_port->emmc_membase+EMMC_CLKENA),readl(emmc_port->emmc_membase+EMMC_CMD));
+		printk(KERN_ERR "\ttmout : 0x%08x ctype : 0x%08x, fifoth : 0x%08x, idinten : 0x%08x\n\tuhsreg : 0x%08x\n",
+			readl(emmc_port->emmc_membase+EMMC_TMOUT),readl(emmc_port->emmc_membase+EMMC_CTYPE),readl(emmc_port->emmc_membase+EMMC_FIFOTH),
+			readl(emmc_port->emmc_membase+EMMC_IDINTEN),readl(emmc_port->emmc_membase+EMMC_UHSREG));
+		printk(KERN_ERR "------------------------------>\n");
+		//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+	}
+
+	if (emmc_port->int_waiting) {
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+		rtkemmc_hold_int_dec();
+		//gpio 100 pull low
+#ifdef EMMC_LA_DEBUG_GPIO
+		reg = readl(emmc_port->misc_membase + MISC_GP3DATO);
+		reg &= (~0x00000010);
+		rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP3DATO);
+		isb();
+		sync(emmc_port);
+#endif
+		rtkemmc_clr_int_sta();
+		ClrINTState(emmc_port);
+		emmc_port->int_waiting = &rtk_emmc_wait;
+
+#ifdef EMMC_LA_DEBUG_GPIO
+		reg = readl(emmc_port->misc_membase + MISC_GP3DATO);
+		reg |= (0x00000010);
+		rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP3DATO);
+		isb();
+		sync(emmc_port);
+#endif
+
+		if (CMD_IDX_MASK(cmd_idx)==MMC_WRITE_MULTIPLE_BLOCK || CMD_IDX_MASK(cmd_idx)==MMC_WRITE_BLOCK )
+			rtkemmc_en_wr_int();//wr case
+		else if (CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK || CMD_IDX_MASK(cmd_idx)==MMC_READ_SINGLE_BLOCK
+			|| CMD_IDX_MASK(cmd_idx)==MMC_SEND_EXT_CSD)//rd case
+			rtkemmc_en_rd_int();
+                /*else if (CMD_IDX_MASK(cmd_idx)==MMC_SWITCH)
+                        rtkemmc_en_cd6_int();*/
+		else
+			rtkemmc_en_cd_int(); //command case
+
+		//EMMC_CMD bit 31 must be zero, do not need to be protected for emmc register because it is panic funciton
+		BUG_ON(readl(emmc_port->emmc_membase+EMMC_CMD) & CMD_START_CMD);
+
+		if (g_bTuning == 0){
+#ifdef EMMC_LA_DEBUG_GPIO
+			//gpio 90  pull  low
+			reg = readl(emmc_port->misc_membase + MISC_GP2DATO);
+			reg &= ~(0x04000000);
+			rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP2DATO);
+			isb();
+			sync(emmc_port);
+#endif
+			//rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+			while (readl(emmc_port->emmc_membase+EMMC_RINTSTS) & (0xfffe)){
+				printk(KERN_ERR RED_BOLD "Fail to clear EMMC_RINTSTS! EMMC_RINTSTS = 0x%08x, CMDIDX = %d \n"RESET, 
+					readl(emmc_port->emmc_membase+EMMC_RINTSTS), CMD_IDX_MASK(cmd_idx));
+				rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_RINTSTS)&0x0000fffe, emmc_port->emmc_membase+EMMC_RINTSTS);
+			}
+			//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#ifdef EMMC_LA_DEBUG_GPIO
+                        //gpio 90  pull  high
+			reg = readl(emmc_port->misc_membase + MISC_GP2DATO);
+			reg |= (0x04000000);
+			rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP2DATO);
+			isb();
+			sync(emmc_port);
+#endif
+		}
+		if (g_bTuning == 1) {		//in Tuning process, clear the error bit before cmd fire for fear that cmd 12,13 error because the previous cmd 18,25 tuning error bit
+			rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_RINTSTS)&0xb7c2, emmc_port->emmc_membase+EMMC_RINTSTS);
+			loop_threshold = 0;
+			while (readl(emmc_port->emmc_membase+EMMC_RINTSTS) & (0xb7c2)){
+				++loop_threshold;
+				if(loop_threshold > 5) {
+					printk(KERN_ERR RED_BOLD "Tuning: Fail to clear EMMC_RINTSTS! EMMC_RINTSTS = 0x%08x, CMDIDX = %d \n"RESET,
+						readl(emmc_port->emmc_membase+EMMC_RINTSTS), CMD_IDX_MASK(cmd_idx));
+				}
+				sync(emmc_port);
+				rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_RINTSTS)&0xb7c2, emmc_port->emmc_membase+EMMC_RINTSTS);
+                        }
+		}
+
+		if (CMD_IDX_MASK(cmd_idx)==MMC_WRITE_MULTIPLE_BLOCK || CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK ){
+			if (emmc_port->rpmb_cmd)
+				cmd_idx &= (~CMD_SEND_AUTO_STOP); //CMD25/18 following CMD13, never set CMD_SEND_AUTO_STOP(bit 12)
+                }
+
+		//cmd fire
+		//rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+		spin_lock_irqsave(&emmc_port->lock,flags);
+		reg_blksize = readl(emmc_port->emmc_membase+EMMC_BLKSIZE);
+		reg_bytecount = readl(emmc_port->emmc_membase+EMMC_BYTCNT);
+		reg_argu = readl(emmc_port->emmc_membase+EMMC_CMDARG);
+		rtkemmc_writel(cmd_idx,emmc_port->emmc_membase+EMMC_CMD);
+		reg_cmdidx = readl(emmc_port->emmc_membase+EMMC_CMD);
+		spin_unlock_irqrestore(&emmc_port->lock,flags);
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+		wait_for_completion(emmc_port->int_waiting);
+
+		if (emmc_port->rintsts & INT_STS_ERRORS) {
+			/*if (CMD_IDX_MASK(cmd_idx)==MMC_SWITCH && (emmc_port->rintsts & INT_STS_ERRORS2) == 0) {
+				goto chk_status;
+			}*/
+			if (!ignore_log) {
+				if (CMD_IDX_MASK(cmd_idx)!=MMC_GO_IDLE_STATE) {
+					printk(KERN_ERR "rtkemmc - INT_STS_ERRORS, cmd_idx=0x%08x, rintsts=0x%08x, idsts=0x%08x, status=0x%08x\n", 
+						cmd_idx, emmc_port->rintsts, emmc_port->idsts, emmc_port->status);
+					printk(KERN_ERR "rtkemmc - read cmd_idx = 0x%08x\n", reg_cmdidx);
+					printk(KERN_ERR "rtkemmc - read reg_argu = 0x%08x\n", reg_argu);
+					printk(KERN_ERR "rtkemmc - read byte count = 0x%08x\n", reg_bytecount);
+					printk(KERN_ERR "rtkemmc - read blk size = 0x%08x\n", reg_blksize);
+					printk(KERN_ERR "rtkemmc - read rtkemmc_global_blksize = 0x%08x\n", rtkemmc_global_blksize);
+					printk(KERN_ERR "rtkemmc - read rtkemmc_global_bytecnt = 0x%08x\n", rtkemmc_global_bytecnt);
+					printk(KERN_ERR "rtkemmc - read rtkemmc_global_dbaddr = 0x%08x\n", rtkemmc_global_dbaddr);
+					print_reg_sts(cmd_idx,emmc_port->rintsts);
+					print_ip_desc(emmc_port);
+
+					if((emmc_port->rintsts & INT_STS_DCRC) && (CMD_IDX_MASK(cmd_idx)==18 || CMD_IDX_MASK(cmd_idx)==25) )
+						cmd_resend=1;
+					else if((emmc_port->rintsts & INT_STS_RTO_BAR) && CMD_IDX_MASK(cmd_idx)==6)
+						cmd_resend=1;
+				}
+			}
+			else{ //in tuning, only print rintsts
+				if (CMD_IDX_MASK(cmd_idx)!=MMC_GO_IDLE_STATE && (emmc_port->rintsts & (INT_STS_HTO | INT_STS_HLE | INT_STS_DRTO_BDS))) {
+					printk(KERN_ERR "Tuning: HTO/HLE/DRTO - INT_STS_ERRORS, cmd_idx=0x%08x, rintsts=0x%08x, idsts=0x%08x, status=0x%08x\n",
+						CMD_IDX_MASK(cmd_idx), emmc_port->rintsts, emmc_port->idsts, emmc_port->status);
+				}
+			}
+
+			err = RTK_FAIL;
+
+			// in HS200 tuning, skip status busy check with emmc error
+			if (g_bTuning && (CMD_IDX_MASK(cmd_idx)==MMC_STOP_TRANSMISSION || CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK)) {
+			//	printk(KERN_ERR "opt_end: Tuning cmd18 error and goto bit31 check\n");
+				goto chk_cmd_bit31;
+			}
+			else
+				goto chk_status;
+		}
+		//polling ACD for multiple r/w
+		
+		if (CMD_IDX_MASK(cmd_idx)==MMC_WRITE_MULTIPLE_BLOCK || CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK ) {
+			//for rpmb rw cmd, don't need to polling ACD
+			if (emmc_port->rpmb_cmd)
+				emmc_port->rpmb_cmd = 0;
+			else {
+#ifndef CONFIG_MMC_RTKEMMC_JIFFY_NOT_WORK_ON_1_LAYER_FPGA
+				timeend = jiffies + msecs_to_jiffies(msec);
+				MMCPRINTF("[%s:%d] Start polling ACD........\n", __FILE__, __LINE__);
+				while(time_before(jiffies, timeend))
+#else
+				MMCPRINTF("[%s:%d] Start polling ACD........\n", __FILE__, __LINE__);
+				while(1)
+#endif
+				{
+#ifdef CONFIG_ARCH_RTD129x
+					rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+					reg = readl(emmc_port->emmc_membase+EMMC_RINTSTS);
+#ifdef CONFIG_ARCH_RTD129x
+					rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+
+					if (reg & INT_STS_ERRORS){
+						err = RTK_FAIL;
+						if (g_bTuning && (CMD_IDX_MASK(cmd_idx)==MMC_STOP_TRANSMISSION || CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK))
+							goto chk_cmd_bit31;
+						else
+							goto chk_status;
+					}
+
+					if ( reg & (INT_STS_ACD)) {
+						err = RTK_SUCC;
+#ifdef CONFIG_ARCH_RTD129x
+						if (get_rtd_chip_revision() < RTD_CHIP_A01 ) {
+							for (i = 0; i < 100000; i++)
+								asm volatile("nop" : : : );
+						}
+#endif
+						i=0;
+						while (1) {
+#ifdef CONFIG_ARCH_RTD129x
+							rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+							reg = readl(emmc_port->emmc_membase+EMMC_STATUS);
+							asm volatile("nop" : : : );
+#ifdef CONFIG_ARCH_RTD129x
+							rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+							if( ( (reg & STS_RSP_IDX_MASK)>>STS_RSP_IDX ) == MMC_STOP_TRANSMISSION )
+								break;
+							if ( i == 0 ) {
+#ifdef CONFIG_ARCH_RTD129x
+								rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+								printk(KERN_ERR RED_BOLD"[%s:%d] wait STOP after ACD fail ........\n"RESET, __FILE__, __LINE__);
+								printk(KERN_ERR RED_BOLD"rtkemmc - \n\trintsts : 0x%08x mintsts : 0x%08x, status : 0x%08x, \
+									idsts : 0x%08x\n\tcmd=0x%08x, cmd_arg=0x%08x\n"RESET, 
+									readl(emmc_port->emmc_membase+EMMC_RINTSTS),
+									readl(emmc_port->emmc_membase+EMMC_MINTSTS),
+									readl(emmc_port->emmc_membase+EMMC_STATUS),
+									readl(emmc_port->emmc_membase+EMMC_IDSTS),
+									cmd_idx,
+									readl(emmc_port->emmc_membase+EMMC_CMDARG));
+#ifdef CONFIG_ARCH_RTD129x
+								rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+							}
+							if (i++ > 0x100000) {
+#ifdef CONFIG_ARCH_RTD129x
+								rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+								printk(KERN_ERR RED_BOLD"[%s:%d] polling STOP after ACD fail ........\n"RESET, __FILE__, __LINE__);
+								printk(KERN_ERR RED_BOLD"rtkemmc - \n\trintsts : 0x%08x mintsts : 0x%08x, status : 0x%08x,	\
+									idsts : 0x%08x\n\tcmd=0x%08x, cmd_arg=0x%08x\n"RESET,
+									readl(emmc_port->emmc_membase+EMMC_RINTSTS),
+									readl(emmc_port->emmc_membase+EMMC_MINTSTS),
+									readl(emmc_port->emmc_membase+EMMC_STATUS),
+									readl(emmc_port->emmc_membase+EMMC_IDSTS),
+									cmd_idx,
+									readl(emmc_port->emmc_membase+EMMC_CMDARG));
+#ifdef CONFIG_ARCH_RTD129x
+								rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+								break;
+							}
+							usleep_range(10, 30);
+						}
+						break;
+					}
+					usleep_range(10, 30);
+				}
+
+				MMCPRINTF("[%s:%d] End polling ACD........\n", __FILE__, __LINE__);
+#ifndef CONFIG_MMC_RTKEMMC_JIFFY_NOT_WORK_ON_1_LAYER_FPGA
+#ifdef CONFIG_ARCH_RTD129x
+				rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+				if (!(readl(emmc_port->emmc_membase+EMMC_RINTSTS) & INT_STS_ACD) && time_after_eq(jiffies, timeend)) {
+					if (!ignore_log)
+						printk(KERN_ERR "[%s:%d] ACD Timeout!!!........, cmd_idx=%d, EMMC_RINTSTS=0x%x\n", __FILE__, __LINE__, CMD_IDX_MASK(cmd_idx), readl(emmc_port->emmc_membase+EMMC_RINTSTS));
+#ifdef CONFIG_ARCH_RTD129x
+					rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+					err = RTK_TOUT;
+					goto chk_status;
+				}
+#ifdef CONFIG_ARCH_RTD129x
+				else rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+#endif
+			}
+		}
+		//polling dma_done_int is not reliable when transaction > 4KB, i.e, more than one set of descriptor,
+		//because dma_done_int raised when one descriptor finished.
+		if (dma_msec > 0) {
+			if ((CMD_IDX_MASK(cmd_idx)==MMC_READ_SINGLE_BLOCK)||(CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK)||(CMD_IDX_MASK(cmd_idx)==MMC_SEND_EXT_CSD)) {
+#ifndef CONFIG_MMC_RTKEMMC_JIFFY_NOT_WORK_ON_1_LAYER_FPGA
+				timeend = jiffies + msecs_to_jiffies(dma_msec);
+#ifdef CONFIG_ARCH_RTD139x
+				if(CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK && (get_rtd_chip_revision() < RTD_CHIP_A01))	//139x cmd18 has bug, we polling the dma length instead of dma done
+					MMCPRINTF("[%s:%d] Start polling DMA_LENGTH........\n", __FILE__, __LINE__);
+				else
+					MMCPRINTF("[%s:%d] Start polling DMA_DONE........\n", __FILE__, __LINE__);
+#else
+				MMCPRINTF("[%s:%d] Start polling DMA_DONE........\n", __FILE__, __LINE__);
+#endif
+				while(time_before(jiffies, timeend))
+#else
+#ifdef CONFIG_ARCH_RTD139x
+				if(CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK && (get_rtd_chip_revision() < RTD_CHIP_A01))      //139x cmd18 has bug, we polling the dma length instead of dma done
+                                        MMCPRINTF("[%s:%d] Start polling DMA_LENGTH........\n", __FILE__, __LINE__);
+                                else
+                                        MMCPRINTF("[%s:%d] Start polling DMA_DONE........\n", __FILE__, __LINE__);
+#else
+				MMCPRINTF("[%s:%d] Start polling DMA_DONE........\n", __FILE__, __LINE__);
+#endif
+				while(1)
+#endif
+				{
+#ifdef CONFIG_ARCH_RTD129x
+					rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+					reg = readl(emmc_port->emmc_membase+EMMC_RINTSTS);
+#ifdef CONFIG_ARCH_RTD129x
+					rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+					if (reg & INT_STS_ERRORS){
+						err = RTK_FAIL;
+						if (g_bTuning && (CMD_IDX_MASK(cmd_idx)==MMC_STOP_TRANSMISSION || CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK))
+							goto chk_cmd_bit31;
+						else
+							goto chk_status;
+					}
+#ifdef CONFIG_ARCH_RTD139x
+					if(CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK && (get_rtd_chip_revision() < RTD_CHIP_A01)) {
+						if(readl(emmc_port->emmc_membase + EMMC_BYTCNT) == readl(emmc_port->emmc_membase + EMMC_TBBCNT)) {
+							rtkemmc_writel(ISR_DMA_DONE_INT, emmc_port->emmc_membase+EMMC_ISR);
+							usleep_range(50,100);
+							err = RTK_SUCC;
+							MMCPRINTF("RTKEMMC - rd done, rintsts : 0x%08x, isr : 0x%08x, idsts : 0x%08x\n",
+							readl(emmc_port->emmc_membase+EMMC_RINTSTS), readl(emmc_port->emmc_membase+EMMC_ISR), readl(emmc_port->emmc_membase+EMMC_IDSTS));
+							break;
+						}
+					}
+					else {
+						if (readl(emmc_port->emmc_membase+EMMC_ISR) & ISR_DMA_DONE_INT) {
+							//printk(KERN_ERR "POLLING DMA_DONE \n");
+							//clear dma_done_int
+							rtkemmc_writel(ISR_DMA_DONE_INT, emmc_port->emmc_membase+EMMC_ISR);
+							err = RTK_SUCC;
+							MMCPRINTF("RTKEMMC - rd done, rintsts : 0x%08x, isr : 0x%08x, idsts : 0x%08x\n",
+							readl(emmc_port->emmc_membase+EMMC_RINTSTS), readl(emmc_port->emmc_membase+EMMC_ISR), readl(emmc_port->emmc_membase+EMMC_IDSTS));
+							break;
+						}
+					}
+#else
+#ifdef CONFIG_ARCH_RTD129x
+					rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+					if (readl(emmc_port->emmc_membase+EMMC_ISR) & ISR_DMA_DONE_INT) {
+						//printk(KERN_ERR "POLLING DMA_DONE \n");
+						//clear dma_done_int
+						rtkemmc_writel(ISR_DMA_DONE_INT, emmc_port->emmc_membase+EMMC_ISR);
+						err = RTK_SUCC;
+						MMCPRINTF("RTKEMMC - rd done, rintsts : 0x%08x, isr : 0x%08x, idsts : 0x%08x\n", 
+							readl(emmc_port->emmc_membase+EMMC_RINTSTS), readl(emmc_port->emmc_membase+EMMC_ISR), readl(emmc_port->emmc_membase+EMMC_IDSTS));
+#ifdef CONFIG_ARCH_RTD129x
+						rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+						break;
+					}
+#ifdef CONFIG_ARCH_RTD129x
+					rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+#endif
+					MMCPRINTF("ISR = 0x%08x \n", readl(emmc_port->emmc_membase+EMMC_ISR));
+					usleep_range(10, 30);
+				}
+#ifdef CONFIG_ARCH_RTD139x
+				if(CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK && (get_rtd_chip_revision() < RTD_CHIP_A01))
+					MMCPRINTF("[%s:%d] End polling DMA_LENGTH........\n", __FILE__, __LINE__);
+				else
+					MMCPRINTF("[%s:%d] End polling DMA_DONE........\n", __FILE__, __LINE__);
+#else
+				MMCPRINTF("[%s:%d] End polling DMA_DONE........\n", __FILE__, __LINE__);
+#endif
+#ifndef CONFIG_MMC_RTKEMMC_JIFFY_NOT_WORK_ON_1_LAYER_FPGA
+#ifdef CONFIG_ARCH_RTD139x
+				if(CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK && (get_rtd_chip_revision() < RTD_CHIP_A01)) {
+					if (readl(emmc_port->emmc_membase + EMMC_BYTCNT)!=readl(emmc_port->emmc_membase + EMMC_TBBCNT) && time_after_eq(jiffies, timeend)) {
+						printk(KERN_ERR "[%s:%d] DMA_DONE length is unequal expected read bytes = %x, real read bytes = %x !!!........\n"
+							, __FILE__, __LINE__,readl(emmc_port->emmc_membase + EMMC_BYTCNT),readl(emmc_port->emmc_membase + EMMC_TBBCNT));
+						err = RTK_TOUT;
+						goto chk_status;
+					}
+				}
+				else {
+					if ((readl(emmc_port->emmc_membase+EMMC_ISR) & ISR_DMA_DONE_INT) && time_after_eq(jiffies, timeend)) {
+						printk(KERN_ERR "[%s:%d] cmd_idx=%d, EMMC_ISR=0x%x, DMA_DONE Timeout !!!........\n", __FILE__, __LINE__, CMD_IDX_MASK(cmd_idx), readl(emmc_port->emmc_membase+EMMC_ISR));
+						err = RTK_TOUT;
+						goto chk_status;
+					}
+
+				}
+#else
+#ifdef CONFIG_ARCH_RTD129x
+				rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+				if ((readl(emmc_port->emmc_membase+EMMC_ISR) & ISR_DMA_DONE_INT) && time_after_eq(jiffies, timeend)) {
+					printk(KERN_ERR "[%s:%d] cmd_idx=%d, EMMC_ISR=0x%x, DMA_DONE Timeout !!!........\n", __FILE__, __LINE__, CMD_IDX_MASK(cmd_idx), readl(emmc_port->emmc_membase+EMMC_ISR));
+#ifdef CONFIG_ARCH_RTD129x
+					rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+					err = RTK_TOUT;
+					goto chk_status;
+				}
+#ifdef CONFIG_ARCH_RTD129x
+				else rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+#endif
+#endif
+			}
+		}
+chk_status: //check status busy
+#ifndef CONFIG_MMC_RTKEMMC_JIFFY_NOT_WORK_ON_1_LAYER_FPGA
+		timeend = jiffies + msecs_to_jiffies(msec);
+		//pr_err("[%s:%d] Start polling STATUS BUSY........\n", __FILE__, __LINE__);
+		while(time_before(jiffies, timeend))
+#else
+		//pr_err("[%s:%d] Start polling STATUS BUSY........\n", __FILE__, __LINE__);
+		while(1)
+#endif
+		{
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+			if ((readl(emmc_port->emmc_membase+EMMC_STATUS) & STS_DATA_BUSY)== 0) {
+				SetINTState(emmc_port, INT_STAT_DATA_DONE);
+#ifdef CONFIG_ARCH_RTD129x
+				rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+				break;
+			}
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+			usleep_range(500, 1000);
+		}
+
+#ifndef CONFIG_MMC_RTKEMMC_JIFFY_NOT_WORK_ON_1_LAYER_FPGA
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+		if ((readl(emmc_port->emmc_membase+EMMC_STATUS) & STS_DATA_BUSY) && time_after_eq(jiffies, timeend)) {
+			printk(KERN_ERR "[%s:%d] STS_DATA_BUSY Timeout !!!........, cmd_idx=%d, EMMC_STATUS=%x EMMC_RINTSTS=%x, cmd.arg=%x\n", __FILE__, __LINE__,CMD_IDX_MASK(cmd_idx), readl(emmc_port->emmc_membase+EMMC_STATUS),readl(emmc_port->emmc_membase+EMMC_RINTSTS),readl(emmc_port->emmc_membase+EMMC_CMDARG));
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+			err = RTK_TOUT;
+		}
+#ifdef CONFIG_ARCH_RTD129x
+		else rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+#endif
+
+chk_cmd_bit31:
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+		MMCPRINTF("RTKEMMC - done: rintsts : 0x%08x, isr : 0x%08x, idsts : 0x%08x\n", emmc_port->rintsts, emmc_port->dma_isr, readl(emmc_port->emmc_membase+EMMC_IDSTS));
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+#ifndef CONFIG_MMC_RTKEMMC_JIFFY_NOT_WORK_ON_1_LAYER_FPGA
+		timeend = jiffies + msecs_to_jiffies(TIMEOUT_CMD); //timeout 10 secs
+		while(time_before(jiffies, timeend))
+#else
+		while(1)
+#endif
+		{
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+			reg = readl(emmc_port->emmc_membase+EMMC_CMD);
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+			if( (reg & CMD_START_CMD) == 0)
+				break;
+
+			usleep_range(10, 30);
+		}
+#ifndef CONFIG_MMC_RTKEMMC_JIFFY_NOT_WORK_ON_1_LAYER_FPGA
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+		if ((readl(emmc_port->emmc_membase+EMMC_CMD)&CMD_START_CMD) && time_after_eq(jiffies, timeend)) {
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+			printk(KERN_ERR "cmd_idx=%d, EMMC_CMD bit31 can't recover to 0 \n", CMD_IDX_MASK(cmd_idx));
+			BUG();
+		}
+#ifdef CONFIG_ARCH_RTD129x
+		else rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+#endif
+		//cmd 13 for tx tuning
+		if (g_bTuning && err != RTK_SUCC && CMD_IDX_MASK(cmd_idx)== MMC_SEND_STATUS){
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_lock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+			reg = readl(emmc_port->emmc_membase+EMMC_RINTSTS);
+#ifdef CONFIG_ARCH_RTD129x
+			rtk_lockapi_unlock2(flags2, _at_("rtkemmc_wait_opt_end"));
+#endif
+			if (!(reg & 0x8180)) //only 0x8180 is the real error for tx tuning
+				err = RTK_SUCC;
+		}
+                return err;
+        }
+	err = RTK_FAIL;
+	return err;
+#endif
+}
+
+#ifndef CONFIG_RTK_XEN_SUPPORT
+static void make_sg_des(struct sd_cmd_pkt *cmd_info, u32 p_des_base, struct rtkemmc_host *emmc_port)
+{
+	u32  blk_cnt;
+	u32  blk_cnt2;
+	u32  remain_blk_cnt;
+	u32  tmp_val;
+	u32* des_base = gddr_descriptor ;
+	u32  dir = 0;
+	u32  dma_nents = 0;
+	u32  dma_leng = 0;
+	u32  dma_addr;
+	u32  i;
+	struct mmc_host *host = cmd_info->emmc_port->mmc;
+	struct scatterlist *sg;
+
+	MMCPRINTF("RTKEMMC: des_base = 0x%08x\n", des_base);
+
+	if(cmd_info->data->flags & MMC_DATA_READ)
+		dir = DMA_FROM_DEVICE;
+	else
+		dir = DMA_TO_DEVICE;
+
+	dma_nents = dma_map_sg( mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len,  dir);
+	sg = cmd_info->data->sg;
+
+	for(i=0; i<dma_nents; i++,sg++) {
+		dma_leng = sg_dma_len(sg);
+		blk_cnt  = dma_leng>>9;                         /*blk_cnt must be the multiple of 512(0x200)*/
+		remain_blk_cnt  = blk_cnt;
+		dma_addr = sg_dma_address(sg);
+
+		while(remain_blk_cnt) {
+			tmp_val = 0x80000000 | 0x2 | 0x10;              /* setting des0; transfer parameter  */
+			if(i==0 && remain_blk_cnt == blk_cnt )
+				tmp_val |= 0x8;
+
+			if(i==dma_nents-1 && remain_blk_cnt <= EMMC_MAX_SCRIPT_BLK)
+				tmp_val |= 0x4;
+
+			des_base[0] = tmp_val;
+			 /* setting des1; buffer size in byte */
+			if(remain_blk_cnt > EMMC_MAX_SCRIPT_BLK)
+				blk_cnt2 = EMMC_MAX_SCRIPT_BLK;
+			else
+				blk_cnt2 = remain_blk_cnt;
+
+			des_base[1] = (blk_cnt2<<9);
+			des_base[2] = (dma_addr);               /* setting des2; Physical address to DMA to/from */
+			des_base[3] = p_des_base + 16;                  /* setting des3; next descrpter entry */
+
+			MMCPRINTF("%s - remain cnt : 0x%08x, desc[0]=0x%08x, desc[1]=0x%08x, desc[2]=0x%08x, desc[3]=0x%08x\n",
+				__func__, remain_blk_cnt,des_base[0],des_base[1],des_base[2],des_base[3]);
+
+			dma_addr = dma_addr+(blk_cnt2<<9);
+			remain_blk_cnt -= blk_cnt2;
+			des_base += 4;
+			p_des_base += 16;  // 4 * 4
+		}
+	}
+
+	//__flush_dcache_area(gddr_descriptor, DESC_ALLOC_LENGTH);
+	//isb();
+	wmb();
+	sync(emmc_port);
+}
+#endif
+
+static void make_ip_des(u32 dma_addr, u32 dma_length, u32 p_des_base, struct rtkemmc_host *emmc_port)
+{
+	u32  blk_cnt;
+	u32  blk_cnt2;
+	u32  remain_blk_cnt;
+	u32  tmp_val;
+	u32* des_base = gddr_descriptor ;
+
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(gddr_descriptor, DESC_ALLOC_LENGTH);
+#else
+	__flush_dcache_area(gddr_descriptor, DESC_ALLOC_LENGTH);
+#endif /* CONFIG_CPU_V7 */
+
+	isb();
+	sync(emmc_port);
+
+	MMCPRINTF("RTKEMMC: des_base = 0x%08x\n", des_base);
+	//blk_cnt must be the multiple of 512(0x200)
+	blk_cnt  = dma_length>>9;
+	remain_blk_cnt  = blk_cnt;
+
+	isb();
+	sync(emmc_port);
+
+	while(remain_blk_cnt) {
+		/* setting des0; transfer parameter  */
+		tmp_val = 0x80000000 | 0x2 | 0x10;
+
+		if(remain_blk_cnt == blk_cnt)
+			tmp_val |= 0x8;
+
+		if(remain_blk_cnt <= EMMC_MAX_SCRIPT_BLK)
+			tmp_val |= 0x4;
+
+		des_base[0] = tmp_val;
+
+		/* setting des1; buffer size in byte */
+		if(remain_blk_cnt > EMMC_MAX_SCRIPT_BLK)
+			blk_cnt2 = EMMC_MAX_SCRIPT_BLK;
+		else
+			blk_cnt2 = remain_blk_cnt;
+
+		des_base[1] = (blk_cnt2<<9);
+		des_base[2] = (dma_addr);	/* setting des2; Physical address to DMA to/from */
+		des_base[3] = p_des_base + 16;	/* setting des3; next descrpter entry */
+
+		isb();
+		sync(emmc_port);
+
+		MMCPRINTF("%s - remain cnt : 0x%08x, desc[0]=0x%08x, desc[1]=0x%08x, desc[2]=0x%08x, desc[3]=0x%08x\n",
+			__func__, remain_blk_cnt,des_base[0],des_base[1],des_base[2],des_base[3]);
+
+		dma_addr = dma_addr+(blk_cnt2<<9);
+		remain_blk_cnt -= blk_cnt2;
+		des_base += 4;
+		p_des_base += 16;  // 4 * 4
+		isb();
+		sync(emmc_port);
+	}
+
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(gddr_descriptor, DESC_ALLOC_LENGTH);
+#else
+	__flush_dcache_area(gddr_descriptor, DESC_ALLOC_LENGTH);
+#endif /* CONFIG_CPU_V7 */
+
+	isb();
+	sync(emmc_port);
+}
+
+static void rtkemmc_read_rsp(struct rtkemmc_host *emmc_port,u32 *rsp, int reg_count)
+{
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	MMCPRINTF("rsp addr=0x%p; rsp_count=%u\n", rsp, reg_count);
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_lock2(flags2, _at_("rtkemmc_read_rsp"));
+#endif
+	if ( reg_count==6 ){
+		rsp[0] = rsp[1] = 0;
+		rsp[0] = readl(emmc_port->emmc_membase + EMMC_RESP0);
+		MMCPRINTF(KERN_INFO "rsp[0]=0x%08x, rsp[1]=0x%08x\n",rsp[0],rsp[1]);
+	}else if(reg_count==17){
+		/*1. UNSTUFF_BITS uses the reverse order as: const int __off = 3 - ((start) / 32);
+		  2. be32_to_cpu is called in mmc_send_csd as csd[i] = be32_to_cpu(csd_tmp[i]);*/
+
+		rsp[3] = readl(emmc_port->emmc_membase + EMMC_RESP0);
+		rsp[2] = readl(emmc_port->emmc_membase + EMMC_RESP1);
+		rsp[1] = readl(emmc_port->emmc_membase + EMMC_RESP2);
+		rsp[0] = readl(emmc_port->emmc_membase + EMMC_RESP3);
+		MMCPRINTF(KERN_INFO "rsp[0]=0x%08x, rsp[1]=0x%08x, rsp[2]=0x%08x, rsp[3]=0x%08x\n",rsp[0],rsp[1],rsp[2],rsp[3]);
+	}
+	else
+		MMCPRINTF("rsp[0]=0x%08x\n",rsp[0]);
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_unlock2(flags2, _at_("rtkemmc_read_rsp"));
+#endif
+}
+
+static int rtkemmc_send_status(struct mmc_card *card,u8 * state,u8 divider,int bIgnore)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	int err=0;
+	int bMalloc=0;
+	struct mmc_host * mmc = mmc_host_local;
+
+	memset(&cmd, 0, sizeof(struct mmc_command));
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	if (card == NULL) {
+		bMalloc=1;
+		card = (struct mmc_card*)kmalloc(sizeof(struct mmc_card),GFP_KERNEL);
+		card->host = mmc;
+	}
+
+	set_cmd_info(card,&cmd,&cmd_info, MMC_SEND_STATUS, (card->rca)<<RCA_SHIFTER, 6);
+    
+	err = SD_SendCMDGetRSP(&cmd_info,bIgnore);
+
+	if (bMalloc) {
+		kfree(card);
+		card = NULL;
+	}
+
+	if(err)
+		mmcmsg3(KERN_WARNING "%s: MMC_SEND_STATUS fail\n",DRIVER_NAME);
+	else {
+		u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
+		*state = cur_state;
+		if (!bIgnore)
+		printk(KERN_INFO "cur_state=%s\n",state_tlb[cur_state]);
+	}
+
+	return err;
+}
+
+static int SD_SendCMDGetRSP_Cmd(struct sd_cmd_pkt *cmd_info,int bIgnore)
+{
+	volatile u8 cmd_idx              = cmd_info->cmd->opcode;
+	u32 *rsp                = (u32 *)&cmd_info->cmd->resp;
+	struct rtkemmc_host *emmc_port = cmd_info->emmc_port;
+	struct mmc_host *host = emmc_port->mmc;
+	int err, retry_count=0;
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	u8 state = 0;
+	int cmd1_retry_cnt = 3000;
+	MMCPRINTF("%s \n", __func__);
+
+	rtkemmc_set_rspparam(emmc_port,cmd_info);   //for 1295
+	if(rsp == NULL)
+		BUG_ON(1);
+
+	if ((g_crinit == 0)&&(cmd_idx > MMC_SET_RELATIVE_ADDR)) {
+		printk("%s : ignore cmd:0x%02x since we're still in emmc init stage\n",DRIVER_NAME,cmd_idx);
+		return CR_TRANSFER_FAIL;
+	}
+
+RET_CMD:
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_lock2(flags2, _at_("SD_SendCMDGetRSP_Cmd"));
+#endif
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+//	rtkemmc_writel(1, emmc_port->emmc_membase + EMMC_SWC_SEL);
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_SWC_SEL1);
+	rtkemmc_writel(1, emmc_port->emmc_membase + EMMC_SWC_SEL2);
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_SWC_SEL3);
+#else
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_SWC_SEL);
+#endif
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_CP);
+	//gpio 100 pull low
+#ifdef EMMC_LA_DEBUG_GPIO
+	reg = readl(emmc_port->misc_membase + MISC_GP3DATO);
+	reg &= (~0x00000010);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP3DATO);
+	isb();
+	sync(emmc_port);
+#endif
+
+	rtkemmc_writel(cmd_info->cmd->arg, emmc_port->emmc_membase + EMMC_CMDARG);
+	isb();
+	sync(emmc_port);
+	//gpio 100 pull high
+#ifdef EMMC_LA_DEBUG_GPIO
+	reg = readl(emmc_port->misc_membase + MISC_GP3DATO);
+	reg |= (0x00000010);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP3DATO);
+	isb();
+	sync(emmc_port);
+#endif
+
+#ifdef EMMC_LA_DEBUG_GPIO
+	//gpio 90  pull  low
+	reg = readl(emmc_port->misc_membase + MISC_GP2DATO);
+	reg &= ~(0x04000000);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP2DATO);
+	isb();
+	sync(emmc_port);
+#endif
+
+	//workaround, if fail to write EMMC_CMDARG, re-write
+	while(readl(emmc_port->emmc_membase + EMMC_CMDARG) != cmd_info->cmd->arg) {
+		printk(KERN_ERR RED_BOLD"SD_SendCMDGetRSP_Cmd: Fail to write EMMC_CMDARG ! \n"RESET);
+		printk(KERN_ERR "cmd_info->opcode = 0x%08x \n", cmd_info->cmd->opcode );
+		printk(KERN_ERR "cmd_info->cmd->arg = 0x%08x \n", cmd_info->cmd->arg );
+		printk(KERN_ERR "EMMC_CMDARG = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_CMDARG));
+		//BUG();
+		rtkemmc_writel(cmd_info->cmd->arg, emmc_port->emmc_membase + EMMC_CMDARG);
+		isb();
+		sync(emmc_port);
+	}
+#ifdef EMMC_LA_DEBUG_GPIO
+	//gpio 90  pull  high
+	reg = readl(emmc_port->misc_membase + MISC_GP2DATO);
+	reg |= (0x04000000);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP2DATO);
+	isb();
+	sync(emmc_port);
+#endif
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_unlock2(flags2, _at_("SD_SendCMDGetRSP_Cmd"));
+#endif
+
+	if (cmd_idx == MMC_SET_BLOCK_COUNT)
+		emmc_port->rpmb_cmd = 1;
+	else
+		emmc_port->rpmb_cmd = 0;
+	err = rtkemmc_wait_opt_end(DRIVER_NAME,emmc_port,EMMC_SENDCMDGETRSP,(cmd_idx|cmd_info->cmd_para),bIgnore);
+	if(err == RTK_SUCC){
+		sync(emmc_port);
+		rtkemmc_read_rsp(emmc_port,rsp, cmd_info->rsp_len);
+		sync(emmc_port);
+		//luis, TBC
+		while ((cmd_idx == MMC_SEND_OP_COND) && ((rsp[0]&0x80000000) != 0x80000000) && cmd1_retry_cnt--) {
+			sync(emmc_port);
+			mdelay(1);
+			goto RET_CMD;
+		}
+
+		//CMD1 timeout case
+		if ((cmd_idx == MMC_SEND_OP_COND) && ((rsp[0]&0x80000000) != 0x80000000)){
+			printk(KERN_ERR RED_BOLD"eMMC CMD1 timeout error !!\n"RESET);
+			BUG();
+		}
+
+		if (cmd_idx == MMC_SET_RELATIVE_ADDR) {
+			g_crinit = 1;
+			MMCPRINTF("emmc init done ...\n");
+		}
+		//get cmd7 status
+		if ((cmd_info->cmd->flags == (MMC_RSP_NONE | MMC_CMD_AC))&&(cmd_idx==MMC_SELECT_CARD)) {
+			printk(KERN_INFO "get status =>\n");
+			rtkemmc_send_status(host->card,&state,0,0);
+		}
+	}
+	else {
+		if (!bIgnore)
+			printk(KERN_WARNING "%s: %s cmd trans fail, err=%d, ignore=%d, gPreventRetry=%d, gCurrentBootMode=%d, cmd_idx=%d\n",
+				DRIVER_NAME,__func__, err, bIgnore,gPreventRetry,gCurrentBootMode,cmd_idx);
+		MMCPRINTF("%s: %s gCurrentBootMode =%d\n", DRIVER_NAME, __func__, gCurrentBootMode);
+
+		if (gPreventRetry) {
+			printk(KERN_WARNING "[LY]error when card in uninit state, err=%d\n",err);
+			return err;
+		}
+		if (gCurrentBootMode > MODE_SDR && cmd_idx > MMC_SEND_OP_COND)
+			return err;
+		if (cmd_idx == MMC_SEND_STATUS) //prevent dead lock looping
+			return err;
+		if (retry_count++ < MAX_CMD_RETRY_COUNT) {
+			printk(KERN_ERR RED_BOLD"cmd %d retry %d ---->\n"RESET,cmd_idx,retry_count);
+			err = error_handling(emmc_port,cmd_idx,bIgnore);
+			goto RET_CMD;
+		}
+	}
+	return err;
+}
+
+static int SD_Stream_Cmd(u16 cmdcode,struct sd_cmd_pkt *cmd_info, unsigned int bIgnore)
+{
+	u8 cmd_idx              = cmd_info->cmd->opcode;
+	u32 *rsp                = (u32 *)&cmd_info->cmd->resp;
+	struct rtkemmc_host *emmc_port = cmd_info->emmc_port;
+	u16 block_count         = cmd_info->block_count;
+	int err;
+	u8 *data              = cmd_info->dma_buffer;
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	u32 retry_count=0;
+	MMCPRINTF("%s \n", __func__);
+
+	if(rsp == NULL)
+		BUG_ON(1);
+
+#ifdef TEST_POWER_RESCYCLE
+	cmd_info->emmc_port->test_count++;
+	mmcspec("test_count=%d\n",cmd_info->emmc_port->test_count);
+#endif
+
+	if ((g_crinit == 0)&&(cmd_idx > MMC_SET_RELATIVE_ADDR)) {
+		printk("%s : ignore cmd:0x%02x since we're still in emmc init stage\n",DRIVER_NAME,cmd_idx);
+		return CR_TRANSFER_FAIL;
+	}
+
+	rtkemmc_set_rspparam(emmc_port,cmd_info);   //for 119x
+
+	/*************************************************************************/
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_lock2(flags2, _at_("SD_Stream_Cmd"));
+#endif
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+//	rtkemmc_writel(1, emmc_port->emmc_membase + EMMC_SWC_SEL);
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_SWC_SEL1);
+	rtkemmc_writel(1, emmc_port->emmc_membase + EMMC_SWC_SEL2);
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_SWC_SEL3);
+#else
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_SWC_SEL);
+#endif
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_CP);
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_unlock2(flags2, _at_("SD_Stream_Cmd"));
+#endif
+	/*************************************************************************/
+#ifndef CONFIG_RTK_XEN_SUPPORT
+	if (cmd_info->data)
+		make_sg_des(cmd_info, emmc_port->desc_paddr, emmc_port);
+	else if (data)
+		make_ip_des(data, block_count<<9, emmc_port->desc_paddr, emmc_port);
+	else
+		BUG_ON(1);
+#else
+	make_ip_des(data, block_count<<9, emmc_port->desc_paddr, emmc_port);
+#endif
+STR_CMD_RET:
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_lock2(flags2, _at_("SD_Stream_Cmd"));
+#endif
+	rtkemmc_writel(block_count<<9, emmc_port->emmc_membase + EMMC_BYTCNT);
+	rtkemmc_writel(emmc_port->desc_paddr, emmc_port->emmc_membase + EMMC_DBADDR);
+	rtkemmc_global_blksize = readl(emmc_port->emmc_membase + EMMC_BLKSIZE);
+	rtkemmc_global_bytecnt = readl(emmc_port->emmc_membase + EMMC_BYTCNT);
+	rtkemmc_global_dbaddr = readl(emmc_port->emmc_membase + EMMC_DBADDR);
+	MMCPRINTF("%s EMMC_BYTCNT=0x%x  \n", __func__, rtkemmc_global_bytecnt);
+	//gpio 100 pull low
+#ifdef EMMC_LA_DEBUG_GPIO
+	reg = readl(emmc_port->misc_membase + MISC_GP3DATO);
+	reg &= (~0x00000010);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP3DATO);
+	isb();
+	sync(emmc_port);
+#endif
+
+	rtkemmc_writel(cmd_info->cmd->arg, emmc_port->emmc_membase + EMMC_CMDARG);
+	isb();
+	sync(emmc_port);
+
+	//gpio 100 pull high
+#ifdef EMMC_LA_DEBUG_GPIO
+	reg = readl(emmc_port->misc_membase + MISC_GP3DATO);
+	reg |= (0x00000010);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP3DATO);
+	isb();
+	sync(emmc_port);
+#endif
+
+#ifdef EMMC_LA_DEBUG_GPIO
+	//gpio 90  pull  low
+	reg = readl(emmc_port->misc_membase + MISC_GP2DATO);
+	reg &= ~(0x04000000);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP2DATO);
+	isb();
+	sync(emmc_port);
+#endif
+
+	//workaround, if fail to write EMMC_CMDARG, re-write
+	while(readl(emmc_port->emmc_membase + EMMC_CMDARG) != cmd_info->cmd->arg) {
+		printk(KERN_ERR RED_BOLD"SD_Stream_Cmd: Fail to write EMMC_CMDARG ! \n"RESET);
+		printk(KERN_ERR "cmd_info->opcode = 0x%08x \n", cmd_info->cmd->opcode );
+		printk(KERN_ERR "cmd_info->cmd->arg = 0x%08x \n", cmd_info->cmd->arg );
+		printk(KERN_ERR "EMMC_CMDARG = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_CMDARG));
+		rtkemmc_writel(cmd_info->cmd->arg, emmc_port->emmc_membase + EMMC_CMDARG);
+		isb();
+		sync(emmc_port);
+	}
+
+	//gpio 90  pull  high
+#ifdef EMMC_LA_DEBUG_GPIO
+	reg = readl(emmc_port->misc_membase + MISC_GP2DATO);
+	reg |= (0x04000000);
+	rtkemmc_writel(reg, emmc_port->misc_membase + MISC_GP2DATO);
+	isb();
+	sync(emmc_port);
+#endif
+
+	emmc_port->cmd_opcode = cmd_idx;
+	MMCPRINTF(KERN_INFO "%s - cmdidx:0x%02x, byte_cnt:0x%08x, cmd_arg:0x%08x \n", __func__,
+		cmd_idx, readl(emmc_port->emmc_membase + EMMC_BYTCNT), readl(emmc_port->emmc_membase + EMMC_CMDARG));
+
+	rtkemmc_get_cmd_timeout(cmd_info);
+	isb();
+	sync(emmc_port);
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_unlock2(flags2, _at_("SD_Stream_Cmd"));
+#endif
+	err = rtkemmc_wait_opt_end(DRIVER_NAME,emmc_port,cmdcode,(cmd_idx|cmd_info->cmd_para),bIgnore);
+	//wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_CMD), 0x80000000, 0x0);
+	isb();
+	sync(emmc_port);
+
+	if(err == RTK_SUCC) {
+		if((cmdcode == EMMC_AUTOREAD1) || (cmdcode == EMMC_AUTOWRITE1))
+			MMCPRINTF("AUTO READ/WRITE 1 skip response~\n");
+		else {
+			rtkemmc_read_rsp(emmc_port,rsp, cmd_info->rsp_len);
+			MMCPRINTF("---stream cmd done---\n");
+		}
+	}
+	else {
+		if(cmd_resend==1) //down speed handling
+			return RTK_SUCC;
+
+		MMCPRINTF("strm cmd_idx=%d,ret_err=%d,bIgnore=%d\n",cmd_idx ,err,bIgnore);
+		mmcmsg3(KERN_WARNING "%s: %s fail\n",DRIVER_NAME,__func__);
+		if (bIgnore)
+			return err;
+
+		if (retry_count++ < MAX_CMD_RETRY_COUNT) {
+			err = error_handling(emmc_port,cmd_idx,bIgnore);
+			goto STR_CMD_RET;
+		}
+	}
+	return err;
+}
+
+int polling_to_tran_state(struct rtkemmc_host *emmc_port, int cmd_idx, int bIgnore)
+{
+	int err=1, retry_cnt=5;
+	u8 ret_state=0;
+	struct mmc_host *host = emmc_port->mmc;
+
+	MMCPRINTF("%s : \n", __func__);
+	sync(emmc_port);
+	while(retry_cnt-- && err)
+        	err = rtkemmc_send_status(host->card,&ret_state,0,bIgnore);
+
+	sync(emmc_port);
+
+	if ((err)||(ret_state != STATE_TRAN)) {
+#ifdef EMMC_DEBUG
+		printk("--- cmd13 fail or ret_state not tran : 0x%08x---\n", ret_state);
+#endif
+//		if ((cmd_idx != MMC_READ_SINGLE_BLOCK)&&(cmd_idx != MMC_WRITE_BLOCK))
+		rtkemmc_stop_transmission(host->card,1);
+		err = rtkemmc_wait_status(host->card,STATE_TRAN,0,bIgnore);
+	}
+	sync(emmc_port);
+	return err;
+}
+
+int error_handling(struct rtkemmc_host *emmc_port, unsigned int cmd_idx, unsigned int bIgnore)
+{
+	int err=0;
+
+	printk(KERN_INFO "%s : cmd_idx=0x%02x, gCurrentBootMode=0x%02x\n", __func__, cmd_idx, gCurrentBootMode);
+
+	card_stop(emmc_port);
+
+	if (cmd_idx > MMC_SET_RELATIVE_ADDR)
+		polling_to_tran_state(emmc_port,cmd_idx,bIgnore);
+
+	printk(KERN_INFO "%s : cmd_idx=0x%02x, gCurrentBootMode=0x%02x\n", __func__,cmd_idx,gCurrentBootMode);
+	if (bIgnore)
+		return 0;
+	return err;
+}
+
+static int rtkemmc_err_handle(u16 cmdcode,struct sd_cmd_pkt *cmd_info)
+{
+	struct mmc_host *host = cmd_info->emmc_port->mmc;
+	u8 state = 0;
+	int err = 0;
+
+	MMCPRINTF("(%s:%d) : cmd=0x%02x\n", __func__,__LINE__,cmdcode);
+
+	if(host->card) {
+		if(cmdcode == EMMC_AUTOWRITE2) {
+			if( cmd_info->cmd->opcode == 18 || cmd_info->cmd->opcode == 25 ) {
+				int stop_loop = 5;
+
+				while(stop_loop--) {
+					err = rtkemmc_stop_transmission(host->card,0);
+					if(err) {
+						//mdelay(1);
+						rtkemmc_send_status(host->card,&state,0,0);
+						if(state == STATE_TRAN)
+							break;
+					}
+					else
+						break;
+				}
+			}
+		}
+		MMCPRINTF("(%s:%d) - cmd=0x%/02x, before polling TRAN state\n", __func__,__LINE__,cmdcode);
+		err = rtkemmc_wait_status(host->card,STATE_TRAN,0,0);
+	}
+	return err;
+}
+
+static int SD_SendCMDGetRSP(struct sd_cmd_pkt * cmd_info,int bIgnore)
+{
+	int rc;
+
+	MMCPRINTF("\n");
+
+	rc = SD_SendCMDGetRSP_Cmd(cmd_info,bIgnore);
+	return rc;
+}
+
+#ifndef CONFIG_RTK_XEN_SUPPORT
+static int SD_Stream(struct sd_cmd_pkt *cmd_info)
+{
+	int err=0;
+	u32 dma_leng = 0;
+	u32 old_arg;
+	u16 cmdcode = 0;
+	u32 dir = 0;
+
+	struct mmc_host *host = cmd_info->emmc_port->mmc;
+	struct rtkemmc_host *emmc_port = cmd_info->emmc_port;
+
+	MMCPRINTF("%s \n", __func__);
+
+	rtkemmc_set_rspparam(emmc_port,cmd_info);
+	if(cmd_info->data->flags & MMC_DATA_READ){
+		dir = DMA_FROM_DEVICE;
+	}else{
+		dir = DMA_TO_DEVICE;
+	}
+
+	cmd_info->data->bytes_xfered=0;
+	//dma_nents = dma_map_sg( mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len,  dir);
+	//sg = cmd_info->data->sg;
+
+#ifdef SHOW_MMC_PRD
+	printk("sg_len:%u\n",cmd_info->data->sg_len);
+	printk("sg:0x%p; dma_nents:%u\n",sg,dma_nents);
+#endif
+	old_arg=cmd_info->cmd->arg;
+
+	//for(i=0; i<dma_nents; i++,sg++)
+		//dma_leng += sg_dma_len(sg);
+
+	//printk("%s dma_leng=0x%x \n", __func__, dma_leng);      //hcy test
+	//printk("%s cmd_info->data->blksz  =0x%x \n", __func__,    cmd_info->data->blksz );
+	//printk("%s cmd_info->data->blocks =0x%x \n", __func__,    cmd_info->data->blocks);
+	//printk("%s cmd_info->data->blksz * cmd_info->data->blocks =0x%x \n", __func__,    cmd_info->data->blksz * cmd_info->data->blocks);
+	dma_leng = cmd_info->data->blksz * cmd_info->data->blocks;
+#ifdef RTK_EMMC_HEALTH_REPORT
+	//if(host->remainder == 0) printk(KERN_INFO "cmd_info->data->blksz = %d\n", cmd_info->data->blksz);
+	//1G = 1024 x 1024 x 1024 bytes, so emmc size is from ext_csd,
+	if((cmd_info->cmd->opcode==24 || cmd_info->cmd->opcode==25) && host->card!=NULL) {
+		host->remainder += cmd_info->data->blocks;
+		if(host->remainder/host->card->ext_csd.sectors > 0) {
+			host->wr_emmc_size_cnt += (host->remainder/host->card->ext_csd.sectors);
+			host->remainder = host->remainder % host->card->ext_csd.sectors;
+		}
+	}
+	if(host->wr_emmc_size_cnt > 3000) printk(KERN_ERR "EMMC write count is larger than 3000 times of emmc size!!!\n");
+#endif
+
+#ifdef SHOW_MMC_PRD
+	printk("dma_addr:0x%x; dma_leng:0x%x\n",dma_addr,dma_leng);
+	mmcinfo("host=%p\n",host);
+	if(host->card){
+		mmcinfo("card=%p\n",host->card);
+		if(mmc_card_blockaddr(host->card))
+			printk("arg:0x%x blk\n",cmd_info->cmd->arg);
+		else
+			printk("arg:0x%x byte\n",cmd_info->cmd->arg);
+	}
+#endif
+
+	cmd_info->byte_count = BYTE_CNT;     //rtk HW limite, one trigger 512 byte pass.
+	cmd_info->block_count =  cmd_info->data->blocks; //blk_cnt;
+	cmdcode = emmc_port->ops->chk_cmdcode(cmd_info->cmd);
+
+	err = SD_Stream_Cmd(cmdcode,cmd_info,0);
+
+	if(err == 0) {
+		if(host->card){
+			if( (cmd_info->cmd->opcode == 25) && (cmdcode == EMMC_AUTOWRITE2)) {
+				int stop_err;
+
+				stop_err = rtkemmc_stop_transmission(host->card,0);
+				if(stop_err) {
+					MMCPRINTF("rtkemmc_stop_transmission fail\n");
+					goto ERR_HANDLE;
+				}
+			}
+		}
+
+		if(host->card && mmc_card_blockaddr(host->card))
+			cmd_info->cmd->arg += cmd_info->block_count;
+		else
+			cmd_info->cmd->arg += dma_leng;
+
+		cmd_info->data->bytes_xfered += dma_leng;
+	}
+	else {
+ERR_HANDLE:
+		//TBD
+		if(rtkemmc_err_handle(cmdcode,cmd_info)){
+			if(cmd_info->cmd->opcode == 18 || cmd_info->cmd->opcode == 25) {
+				if(host->card){
+					int stop_err;
+					stop_err = rtkemmc_stop_transmission(host->card,0);
+					if(stop_err)
+						MMCPRINTF("rtkemmc_stop_transmission fail\n");
+
+					rtkemmc_wait_status(host->card,STATE_TRAN,0,0);
+				}
+			}
+			else
+				mmcmsg3(KERN_INFO "%s: error recover fail 4\n", DRIVER_NAME);
+		}
+	}
+
+	if(err)
+		cmd_info->cmd->arg = old_arg;
+
+	dma_unmap_sg( mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len, dir);
+	return err;
+}
+#else
+static void duplicate_pkt(struct sd_cmd_pkt* sour,struct sd_cmd_pkt* dist)
+{
+	dist->emmc_port      = sour->emmc_port;
+	dist->cmd         = sour->cmd;
+	dist->data        = sour->data;
+
+	dist->dma_buffer  = sour->dma_buffer;
+	dist->byte_count  = sour->byte_count;
+	dist->block_count = sour->block_count;
+
+	dist->flags       = sour->flags;
+	dist->rsp_len     = sour->rsp_len;
+	dist->timeout     = sour->timeout;
+}
+
+static int SD_Stream(struct sd_cmd_pkt *cmd_info)
+{
+	int err=0;
+	u32 i;
+	struct scatterlist *sg;
+	u32 dir = 0;
+	u32 dma_nents = 0;
+	u32 dma_leng;
+	u32 dma_addr;
+	u32 dma_addr_sys = 0;
+	u32 old_arg;
+	u8 one_blk=0;
+	u8 f_in_dma = 0;
+	u16 cmdcode = 0;
+	unsigned long flags;
+
+	struct mmc_host *host = cmd_info->emmc_port->mmc;
+	struct rtkemmc_host *emmc_port = cmd_info->emmc_port;
+
+	rtkemmc_set_rspparam(emmc_port, cmd_info);   //for 119x
+
+	if(cmd_info->data->flags & MMC_DATA_READ){
+		dir = DMA_FROM_DEVICE;
+	}else{
+		dir = DMA_TO_DEVICE;
+	}
+
+	cmd_info->data->bytes_xfered=0;
+	dma_nents = dma_map_sg( mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len,  dir);
+	sg = cmd_info->data->sg;
+
+	old_arg=cmd_info->cmd->arg;
+
+	for(i=0; i<dma_nents; i++,sg++){
+		dma_leng = sg_dma_len(sg);
+
+		if(dma_leng & 0x1ff){
+			dma_addr_sys = sg_dma_address(sg);
+
+			if(emmc_port->tmp_buf){    //use tmp buffer
+				f_in_dma = 1;
+				dma_addr = emmc_port->tmp_buf_phy_addr;
+			}else{                  //use default buffer
+				dma_addr = dma_addr_sys;
+			}
+		}else{
+			dma_addr = sg_dma_address(sg);
+		}
+
+		if(one_blk){    /* occur at write case only */
+			u8 i;
+			u32 blk_cnt;
+			struct sd_cmd_pkt tmp_pkt;
+
+			blk_cnt = dma_leng/BYTE_CNT;
+			if(blk_cnt == 0){
+				WARN_ON(1);
+				blk_cnt = 1;
+			}
+			duplicate_pkt(cmd_info,&tmp_pkt);
+
+			tmp_pkt.byte_count  = BYTE_CNT;
+			tmp_pkt.block_count = 1;
+			tmp_pkt.dma_buffer  = (unsigned char *)dma_addr;
+
+			if(tmp_pkt.cmd->opcode == 25){
+				tmp_pkt.cmd->opcode = 24;
+			}
+
+			if(tmp_pkt.cmd->opcode == 18){
+				tmp_pkt.cmd->opcode = 17;
+			}
+
+			cmdcode = emmc_port->ops->chk_cmdcode(tmp_pkt.cmd);
+			for(i=0;i<blk_cnt;i++){
+				err = SD_Stream_Cmd(cmdcode,&tmp_pkt,0);
+
+				if(err == 0){
+					if(host->card && mmc_card_blockaddr(host->card))
+						tmp_pkt.cmd->arg += 1;
+					else
+						tmp_pkt.cmd->arg += BYTE_CNT;
+
+					tmp_pkt.dma_buffer += BYTE_CNT;
+					tmp_pkt.data->bytes_xfered += BYTE_CNT;
+				}else{
+					//TBD
+					mmcmsg3(KERN_INFO "%s: unknown fail 2\n", DRIVER_NAME);
+					break;
+				}
+			}
+		}
+		else {
+			u32 blk_cnt;
+			cmd_info->byte_count = BYTE_CNT;     //rtk HW limite, one trigger 512 byte pass.
+			blk_cnt = dma_leng/BYTE_CNT;
+
+			if(blk_cnt == 0 && dma_leng){
+				blk_cnt = 1;
+			}
+
+			cmd_info->block_count = blk_cnt;
+			cmd_info->dma_buffer = (unsigned char *)dma_addr;
+
+			cmdcode = emmc_port->ops->chk_cmdcode(cmd_info->cmd);
+			err = SD_Stream_Cmd(cmdcode,cmd_info,0);
+
+			if(err == 0){
+				if(host->card){
+					if( (cmd_info->cmd->opcode == 25) && (cmdcode == EMMC_AUTOWRITE2) ) {
+						int stop_err;
+
+						stop_err = rtkemmc_stop_transmission(host->card,0);
+						if(stop_err){
+							MMCPRINTF("rtkemmc_stop_transmission fail\n");
+							goto ERR_HANDLE;
+						}
+					}
+				}
+
+				if(host->card && mmc_card_blockaddr(host->card))
+					cmd_info->cmd->arg += cmd_info->block_count;
+				else
+					cmd_info->cmd->arg += dma_leng;
+
+				cmd_info->data->bytes_xfered += dma_leng;
+			}else{
+ERR_HANDLE:
+				if(rtkemmc_err_handle(cmdcode,cmd_info)){
+					if(cmd_info->cmd->opcode == 18 || cmd_info->cmd->opcode == 25) {
+						if(host->card){
+							int stop_err;
+							stop_err = rtkemmc_stop_transmission(host->card,0);
+							if(stop_err){
+								MMCPRINTF("rtkemmc_stop_transmission fail\n");
+								//goto ERR_HANDLE;
+							}
+							rtkemmc_wait_status(host->card,STATE_TRAN,0,0);
+						}
+					}else{
+						mmcmsg3(KERN_INFO "%s: error recover fail 4\n", DRIVER_NAME);
+					}
+				}
+			}
+		}
+		if(err){
+			cmd_info->cmd->arg = old_arg;
+			break;
+		}
+
+		if(f_in_dma){
+			u32 i;
+			u8 * ptr1 = phys_to_virt(dma_addr_sys);
+			u8 * ptr2 = phys_to_virt(dma_addr);
+			f_in_dma = 0;
+			for(i=0; i<dma_leng;i++)
+				*ptr1 = *ptr2;
+		}
+	}
+
+	dma_unmap_sg( mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len,  dir);
+
+	return err;
+}
+#endif
+
+static void rtkemmc_send_command(struct rtkemmc_host *emmc_port, struct mmc_command *cmd)
+{
+	int rc = 0;
+	struct sd_cmd_pkt cmd_info;
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	unsigned int reg_val;
+	unsigned long tmout;
+	unsigned long curr_jiffies;
+	int istimeout;
+	int read_reg_yet;
+	MMCPRINTF("%s \n", __func__);
+
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	if ( !emmc_port || !cmd ){
+		printk(KERN_ERR "%s: emmc_port or cmd is null\n",DRIVER_NAME);
+		return ;
+	}
+
+	cmd_info.cmd    = cmd;
+	cmd_info.emmc_port = emmc_port;
+#ifdef FORCE_CHECK_CMD_AND_STS
+	// ChiYun's comment
+	// wait_done((UINT32 *)0x9801202c, 0x80000000, 0);      //cmd done
+	// wait_done((UINT32 *)0x98012048, 0x000006f0, 0);      //idle
+	istimeout = 1;
+	read_reg_yet = 0;
+	reg_val = 0xdeadbeef;
+	curr_jiffies = tmout = jiffies + msecs_to_jiffies(1000);
+	// time_before(jiffies, tmout) = time_after(tmout, jiffies) = ((jiffies - tmout) < 0)
+	while( time_before(jiffies, tmout) ) {
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_send_command"));
+#endif
+		reg_val = readl(emmc_port->emmc_membase + EMMC_CMD);
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_send_command"));
+#endif
+		read_reg_yet = 1;
+		if( !(reg_val & 0x80000000UL) ) {
+			istimeout = 0;
+			break;
+		}
+	}
+	curr_jiffies = jiffies;
+	if( istimeout ) {
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_send_command"));
+#endif
+		reg_val = readl(emmc_port->emmc_membase + EMMC_CMD);
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_send_command"));
+#endif
+		printk(KERN_ERR "****** tmout 0x%lx, curr_jiffies 0x%lx, jiffies 0x%lx\n", tmout, curr_jiffies, jiffies);
+		printk(KERN_ERR "****** check 0x9801202c timeout!!!! (reg val 0x%08x@base_0x%p)(%d)\n", reg_val, emmc_port->emmc_membase, read_reg_yet);
+		printk(KERN_ERR "****** read  0x9801202c again!!!!!! (reg val 0x%08x@base_0x%p)\n", reg_val, emmc_port->emmc_membase);
+	}
+
+	istimeout = 1;
+	read_reg_yet = 0;
+	reg_val = 0xbeefdead;
+	curr_jiffies = tmout = jiffies + msecs_to_jiffies(1000);
+	while(time_before(jiffies, tmout)) {
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_send_command"));
+#endif
+		reg_val = readl(emmc_port->emmc_membase + EMMC_STATUS);
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_send_command"));
+#endif
+		read_reg_yet = 1;
+		if( !(reg_val & 0x000006f0UL) ) {
+			istimeout = 0;
+			break;
+		}
+	}
+	curr_jiffies = jiffies;
+	if( istimeout ) {
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_lock2(flags2, _at_("rtkemmc_send_command"));
+#endif
+		reg_val = readl(emmc_port->emmc_membase + EMMC_STATUS);
+#ifdef CONFIG_ARCH_RTD129x
+		rtk_lockapi_unlock2(flags2, _at_("rtkemmc_send_command"));
+#endif
+		printk(KERN_ERR "****** tmout 0x%lx, curr_jiffies 0x%lx, jiffies 0x%lx\n", tmout, curr_jiffies, jiffies);
+		printk(KERN_ERR "****** check 0x98012048 timeout!!!! (reg val 0x%08x@base_0x%p)(%d)\n", reg_val, emmc_port->emmc_membase, read_reg_yet);
+		printk(KERN_ERR "****** read  0x98012048 again!!!!!! (reg val 0x%08x@base_0x%p)\n", reg_val, emmc_port->emmc_membase);
+	}
+#endif // FORCE_CHECK_CMD_AND_STS
+	if (cmd->data) {
+		cmd_info.data = cmd->data;
+		if(cmd->data->flags == MMC_DATA_READ){
+			MMCPRINTF("%s MMC_DATA_READ\n", __func__);	/* do nothing */
+		}else if(cmd->data->flags == MMC_DATA_WRITE){
+			MMCPRINTF("%s MMC_DATA_WRITE\n", __func__);
+			if(emmc_port->wp ==1){
+				printk(KERN_WARNING "%s: card is locked!", DRIVER_NAME);
+				rc = -1;
+				cmd->retries = 0;
+				goto err_out;
+			}
+		}else{
+			printk(KERN_ERR "error: cmd->data->flags=%d\n", cmd->data->flags);
+			cmd->error = -MMC_BLK_CMD_ERR;
+			cmd->retries = 0;
+			goto err_out;
+		}
+		if (g_bTuning)
+			MMCPRINTF("................[%s:HS200] still tuning.............. \n",DRIVER_NAME);
+		rc = SD_Stream(&cmd_info);
+	}
+	else {
+		if (g_bTuning)
+			MMCPRINTF("................[%s:HS200] still tuning.............. \n",DRIVER_NAME);
+		rc = SD_SendCMDGetRSP(&cmd_info,0);
+	}
+
+	if(cmd->opcode == MMC_SWITCH){
+		if((cmd->arg & 0xffff00ff) == 0x03b30001) {
+			if((cmd->arg & 0x0000ff00)==0)
+				emmc_port->rtflags |= RTKCR_USER_PARTITION;
+			else
+				emmc_port->rtflags &= ~RTKCR_USER_PARTITION;
+		}
+	}
+	MMCPRINTF("%s: cmd->opcode=0x%02x finish !!\n",__func__,cmd->opcode);
+err_out:
+
+	if (rc){
+		if(rc == -RTK_RMOV)
+			cmd->retries = 0;
+		cmd->error = -MMC_BLK_CMD_ERR;
+	}
+	rtkemmc_req_end_tasklet((unsigned long)emmc_port);
+}
+
+static void rtkemmc_request(struct mmc_host *host, struct mmc_request *mrq)
+{
+	struct rtkemmc_host *emmc_port;
+	struct mmc_command *cmd;
+#ifdef USE_TMP_BUF
+	unsigned char *tmp_buf=NULL;
+#endif
+	MMCPRINTF("%s \n", __func__);
+	emmc_port = mmc_priv(host);
+	BUG_ON(emmc_port->mrq != NULL);
+
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_request_hw_semaphore(emmc_port->hw_semaphore, 5);
+#endif
+	down_write(&cr_rw_sem);
+
+	if(mrq->cmd->opcode==MMC_SEND_EXT_CSD)
+	{
+		//====we add the following program becasue we need to read HS400 parameter in specific emmc block in SDR50 mode if exists====
+		//hs400 mode case, we need to eliminate the tuning process, so we read the dqs, phase data from offset that bootcode provided
+		if((host->caps2 & MMC_CAP2_HS400_1_8V) && emmc_port->dqs_tuning==1 && emmc_port->emmc_tuning_addr!=0)    //bootcode doesn't do the hs400 tuning
+		{
+			int hs400_data[128]={0};        //4 bytes header, 33aa, 4 bytes for TX, 4 bytes for RX, 4 bytes for dqs
+
+			rtkemmc_send_cmd18(emmc_port, 512, emmc_port->emmc_tuning_addr/512+1024);       //we put the hs400 parameter data before tuning blk addr 1 block
+			memcpy(hs400_data, gddr_dma_org, 512);
+
+			printk(KERN_ERR "before cmd8, read dqs_data from emmc first for later usage: hs400_header=0x%x, hs400_TX=0x%x, hs400_RX=0x%x, hs400_dqs=0x%x\n",
+				hs400_data[0], hs400_data[1], hs400_data[2], hs400_data[3]);
+
+			if(hs400_data[0]==0x33aa) {     //inherit from emmc saved data instead of bootcode
+				emmc_port->dqs_tuning=0;
+				emmc_port->tx_tuning = 0;
+				emmc_port->rx_tuning = 0;
+
+				HS200_TX = VP0_saved = hs400_data[1];
+				HS200_RX = VP1_saved = hs400_data[2];
+				dqs_saved = hs400_data[3];
+
+				if(emmc_port->tx_user_defined) {        //if we set user defined tx and rx value, then we won't use the bootcode reference value, always the first priority
+					printk(KERN_ERR "tx_user_defined has been set, we still use user define value for usage\n");
+					HS200_TX = VP0_saved = emmc_port->tx_reference_phase;
+				}
+				if(emmc_port->rx_user_defined) {
+					printk(KERN_ERR "rx_user_defined has been set, we still use user define value for usage\n");
+					HS200_RX = VP1_saved = emmc_port->rx_reference_phase;
+				}
+			}
+		}
+	}
+
+	cmd = mrq->cmd;
+	emmc_port->mrq = mrq;
+
+	if (!(emmc_port->rtflags & RTKCR_FCARD_DETECTED)){
+		cmd->error = -MMC_BLK_NOMEDIUM;
+		cmd->retries = 0;
+		goto done;
+	}
+	/*
+	* the "tmp_buf" should used be for sg_init_one() in blksz small than 512 byte case.
+	* because RTK DMA HW issue,the samllest DMA size is 512 byte
+	*/
+#ifdef USE_TMP_BUF
+	if (cmd->data) {
+		if(cmd->data->blksz < 512){
+			WARN_ON(1);
+			printk("blksz=%d\n",cmd->data->blksz);
+			tmp_buf = dma_alloc_coherent(emmc_port->dev, 512, &emmc_port->tmp_buf_phy_addr, GFP_KERNEL);
+
+			if(!tmp_buf){
+				WARN_ON(1);
+				cmd->error = -ENOMEM;
+				goto done;
+			}
+			memset(tmp_buf,0,512);
+			emmc_port->tmp_buf = tmp_buf;
+		}else
+			emmc_port->tmp_buf = NULL;
+	}
+#endif
+	if ( emmc_port && cmd ){
+		rtkemmc_allocate_dma_buf(emmc_port, cmd);
+		rtkemmc_send_command(emmc_port, cmd);
+	}else{
+done:
+		rtkemmc_req_end_tasklet((unsigned long)emmc_port);
+	}
+	up_write(&cr_rw_sem);
+	if(cmd_resend==1) {
+		cmd_resend=0;
+		down_speed_handling(emmc_port);
+	}
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	rtkemmc_release_hw_semaphore(emmc_port->hw_semaphore);
+#endif
+}
+
+static ssize_t emmc_info_dev_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct mmc_host * host = dev_get_drvdata(dev);
+	struct rtkemmc_host *emmc_port = mmc_priv(host);
+
+	printk(KERN_INFO "%s(%u)\n",__func__,__LINE__);
+#if defined(CONFIG_ARCH_RTD129x)
+	return sprintf(buf, "EMMC_STATUS=0x%08x SYS_PLL_EMMC1=0x%08x SYS_PLL_EMMC2=0x%08x \nSYS_PLL_EMMC3=0x%08x SYS_PLL_EMMC4=0x%08x EMMC_RINTSTS=0x%08x\nEMMC_IDSTS=0x%08x muxpad0=0x%08x muxpad1=0x%08x \nEMMC_PFUNC_NF1=0x%08x EMMC_PDRIVE_NF1=0x%08x EMMC_PDRIVE_NF2=0x%08x \nEMMC_PDRIVE_NF3=0x%08x EMMC_CTYPE=0x%08x EMMC_UHSREG=0x%08x \n EMMC_DDR_REG=0x%08x EMMC_CARD_THR_CTL=0x%08x EMMC_CLKDIV=0x%08x\nEMMC_CKGEN_CTL=0x%08x EMMC_DQS_CTRL1=0x%08x \n",
+				readl(emmc_port->emmc_membase+EMMC_STATUS),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC1),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC2),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC3),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC4),
+				readl(emmc_port->emmc_membase+EMMC_RINTSTS),
+				readl(emmc_port->emmc_membase+EMMC_IDSTS),
+				readl(emmc_port->emmc_membase+EMMC_muxpad0),
+				readl(emmc_port->emmc_membase+EMMC_muxpad1),
+				readl(emmc_port->emmc_membase+EMMC_PFUNC_NF1),
+				readl(emmc_port->emmc_membase+EMMC_PDRIVE_NF1),
+				readl(emmc_port->emmc_membase+EMMC_PDRIVE_NF2),
+				readl(emmc_port->emmc_membase+EMMC_PDRIVE_NF3),
+				readl(emmc_port->emmc_membase+EMMC_CTYPE),
+				readl(emmc_port->emmc_membase+EMMC_UHSREG),
+				readl(emmc_port->emmc_membase+EMMC_DDR_REG),
+				readl(emmc_port->emmc_membase+EMMC_CARD_THR_CTL),
+				readl(emmc_port->emmc_membase+EMMC_CLKDIV),
+				readl(emmc_port->emmc_membase+EMMC_CKGEN_CTL),
+				readl(emmc_port->emmc_membase+EMMC_DQS_CTRL1));
+#elif defined(CONFIG_ARCH_RTD139x)
+	return sprintf(buf, "EMMC_STATUS=0x%08x SYS_PLL_EMMC1=0x%08x SYS_PLL_EMMC2=0x%08x \nSYS_PLL_EMMC3=0x%08x SYS_PLL_EMMC4=0x%08x EMMC_RINTSTS=0x%08x\nEMMC_IDSTS=0x%08x muxpad4=0x%08x\nPfunc_emmc0=0x%08x Pfunc_emmc1=0x%08x Pfunc_emmc2=0x%08x \nPfunc_emmc3=0x%08x Pfunc_emmc4=0x%08x Pfunc_emmc5=0x%08x EMMC_CTYPE=0x%08x EMMC_UHSREG=0x%08x \n EMMC_DDR_REG=0x%08x EMMC_CARD_THR_CTL=0x%08x EMMC_CLKDIV=0x%08x\nEMMC_CKGEN_CTL=0x%08x EMMC_DQS_CTRL1=0x%08x \n",
+                                readl(emmc_port->emmc_membase+EMMC_STATUS),
+                                readl(emmc_port->crt_membase + SYS_PLL_EMMC1),
+                                readl(emmc_port->crt_membase + SYS_PLL_EMMC2),
+                                readl(emmc_port->crt_membase + SYS_PLL_EMMC3),
+                                readl(emmc_port->crt_membase + SYS_PLL_EMMC4),
+                                readl(emmc_port->emmc_membase+EMMC_RINTSTS),
+                                readl(emmc_port->emmc_membase+EMMC_IDSTS),
+                                readl(emmc_port->iso_muxpad+ISO_muxpad4),
+				readl(emmc_port->iso_muxpad + pfunc_emmc0),
+				readl(emmc_port->iso_muxpad + pfunc_emmc1),
+				readl(emmc_port->iso_muxpad + pfunc_emmc2),
+				readl(emmc_port->iso_muxpad + pfunc_emmc3),
+				readl(emmc_port->iso_muxpad + pfunc_emmc4),
+				readl(emmc_port->iso_muxpad + pfunc_emmc5),
+                                readl(emmc_port->emmc_membase+EMMC_CTYPE),
+                                readl(emmc_port->emmc_membase+EMMC_UHSREG),
+                                readl(emmc_port->emmc_membase+EMMC_DDR_REG),
+                                readl(emmc_port->emmc_membase+EMMC_CARD_THR_CTL),
+                                readl(emmc_port->emmc_membase+EMMC_CLKDIV),
+                                readl(emmc_port->emmc_membase+EMMC_CKGEN_CTL),
+                                readl(emmc_port->emmc_membase+EMMC_DQS_CTRL1));
+#elif defined(CONFIG_ARCH_RTD16xx)
+	return sprintf(buf, "EMMC_STATUS=0x%08x SYS_PLL_EMMC1=0x%08x SYS_PLL_EMMC2=0x%08x \nSYS_PLL_EMMC3=0x%08x SYS_PLL_EMMC4=0x%08x EMMC_RINTSTS=0x%08x\nEMMC_IDSTS=0x%08x m2tmx_muxpad0=0x%08x\nm2tmx_pfunc4=0x%08x m2tmx_pfunc5=0x%08x m2tmx_pfunc6=0x%08x \nm2tmx_pfunc7=0x%08x m2tmx_pfunc8=0x%08x EMMC_CTYPE=0x%08x EMMC_UHSREG=0x%08x \n EMMC_DDR_REG=0x%08x EMMC_CARD_THR_CTL=0x%08x EMMC_CLKDIV=0x%08x\nEMMC_CKGEN_CTL=0x%08x EMMC_DQS_CTRL1=0x%08x \n",
+				readl(emmc_port->emmc_membase+EMMC_STATUS),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC1),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC2),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC3),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC4),
+				readl(emmc_port->emmc_membase+EMMC_RINTSTS),
+				readl(emmc_port->emmc_membase+EMMC_IDSTS),
+				readl(emmc_port->m2tmx + m2tmx_muxpad0),
+				readl(emmc_port->m2tmx + m2tmx_pfunc4),
+				readl(emmc_port->m2tmx + m2tmx_pfunc5),
+				readl(emmc_port->m2tmx + m2tmx_pfunc6),
+				readl(emmc_port->m2tmx + m2tmx_pfunc7),
+				readl(emmc_port->m2tmx + m2tmx_pfunc8),
+				readl(emmc_port->emmc_membase+EMMC_CTYPE),
+				readl(emmc_port->emmc_membase+EMMC_UHSREG),
+				readl(emmc_port->emmc_membase+EMMC_DDR_REG),
+				readl(emmc_port->emmc_membase+EMMC_CARD_THR_CTL),
+				readl(emmc_port->emmc_membase+EMMC_CLKDIV),
+				readl(emmc_port->emmc_membase+EMMC_CKGEN_CTL),
+				readl(emmc_port->emmc_membase+EMMC_DQS_CTRL1));
+#endif
+}
+
+static ssize_t emmc_info_dev_store(struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+	printk(KERN_ERR "%s(%u)Nothing to do\n",__func__,__LINE__);
+
+	/* return value must be equare or big then "count" to finish this attribute */
+	return count;
+}
+DEVICE_ATTR(emmc_info, S_IRUGO | S_IWUSR,
+		emmc_info_dev_show,emmc_info_dev_store);
+
+static int count_class_dev(struct device *dev, const void *data)
+{
+	int *p = (void *)data;
+
+	*p += 1;
+	return 0;
+}
+
+static void rtkemmc_wait_block_dev_ready(struct mmc_host *mmc)
+{
+	int retry = 50;
+	int cb = 0, ca = 0;
+	ktime_t tb, ta;
+
+	tb = ktime_get();
+	class_find_device(&block_class, NULL, &cb, count_class_dev);
+
+	while (--retry > 0) {
+		if (mmc->card && dev_get_drvdata(&mmc->card->dev) != NULL) {
+			break;
+		}
+		msleep(10);
+	}
+
+	class_find_device(&block_class, NULL, &ca, count_class_dev);
+	ta = ktime_get();
+	printk(KERN_INFO "%s: retry_left=%d, block_dev=[%d -> %d], time=%dms\n",
+		mmc_hostname(mmc), retry, cb, ca, (int)ktime_to_ms(ktime_sub(ta, tb)));
+
+}
+
+static int rtkemmc_probe(struct platform_device *pdev)
+{
+	struct mmc_host *mmc = NULL;
+	struct rtkemmc_host *emmc_port = NULL;
+	int ret = 0, irq = 0;
+	int att_err;
+	const u32 *prop;
+	int size,speed_step=0;
+	struct device_node *emmc_node = NULL;
+	int i;
+	int counter=0;
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	emmc_node = pdev->dev.of_node;
+
+	if (!emmc_node)
+		printk(KERN_ERR "%s : No emmc of_node found\n",DRIVER_NAME);
+	else
+		printk(KERN_ERR "%s : emmc of_node found\n",DRIVER_NAME);
+
+	mmc = mmc_alloc_host(sizeof(struct rtkemmc_host), &pdev->dev);
+
+	if (!mmc) {
+		ret = -ENOMEM;
+		goto out;
+	}
+
+	mmc_host_local = mmc;
+
+	emmc_port = mmc_priv(mmc);
+	memset(emmc_port, 0, sizeof(struct rtkemmc_host));
+	emmc_port->mmc = mmc;
+	emmc_port->dev = &pdev->dev;
+	emmc_port->ops = &emmc_ops;
+
+	sema_init(&emmc_port->sem,1);
+	sema_init(&emmc_port->sem_op_end,1);
+
+	//att_err = device_create_file(&pdev->dev, &dev_attr_cr_send_cmd0);
+	//att_err = device_create_file(&pdev->dev, &dev_attr_cr_fast_RW);
+	//att_err = device_create_file(&pdev->dev, &dev_attr_em_open_log);
+	att_err = device_create_file(&pdev->dev, &dev_attr_emmc_info);
+
+	irq = irq_of_parse_and_map(emmc_node, 0);
+	if (irq <= 0) {
+                printk(KERN_ERR "%s : fail to parse of irq.\n",DRIVER_NAME);
+                return -ENXIO;
+	}
+	MMCPRINTF(KERN_INFO "%s : IRQ = 0x%08x\n",DRIVER_NAME, irq);
+
+	emmc_port->emmc_membase = of_iomap(emmc_node, 0);
+	emmc_port->crt_membase = of_iomap(emmc_node, 1);
+	emmc_port->sb2_membase = of_iomap(emmc_node, 2);
+
+#if defined(EMMC_LA_DEBUG_GPIO) || defined(EMMC_PARAM_TEST)
+	emmc_port->misc_membase = of_iomap(emmc_node, 3);
+#endif
+
+#ifdef DBG_PORT
+	emmc_port->sb2_debug_membase = of_iomap(emmc_node, 4);
+	//rtk_lockapi_lock2(flags2, _at_("rtkemmc_probe"));
+        rtkemmc_writel(0x5, emmc_port->emmc_membase + EMMC_MAIN2_DBG);
+        rtkemmc_writel(0x7208,emmc_port->sb2_debug_membase);
+        rtkemmc_writel(0x2db7, emmc_port->emmc_membase + EMMC_DBG);
+	//rtk_lockapi_unlock2(flags2, _at_("rtkemmc_probe"));
+        isb();
+        sync(emmc_port);
+#endif
+
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+	unsigned int addr;
+	if (of_property_read_u32(pdev->dev.of_node, "hw-semaphore", &addr)) {
+		addr = 0x9801a63c;
+		pr_err("EMMC : can't find hw semaphore in dtb, use default - 0x%x\n", addr);
+	} else {
+		pr_info("EMMC : find hw semaphore in dtb, 0x%x\n", addr);
+	}
+	emmc_port->hw_semaphore = ioremap(addr, 1);
+#endif
+
+#if defined(CONFIG_ARCH_RTD139x)
+	emmc_port->iso_muxpad = of_iomap(emmc_node, 5);
+#elif defined(CONFIG_ARCH_RTD16xx)
+	emmc_port->m2tmx = of_iomap(emmc_node, 5);
+#endif
+
+	prop = of_get_property(pdev->dev.of_node, "speed-step", &size);
+	if (prop) {
+		speed_step = of_read_number(prop, 1);
+		printk(KERN_INFO "[%s] get speed-step : %d \n",__func__,speed_step);
+	} else {
+		printk(KERN_ERR "[%s] get speed-step error !!\n",__func__);
+	}
+	prop = of_get_property(pdev->dev.of_node, "pddrive_nf_s0", &size);
+	if (prop) {
+		if (size)
+			counter = size / sizeof(u32);
+
+		for (i=0; i<counter; i+=1) {
+			pddrive_nf_s0[i]= of_read_number(prop, 1 + i);
+			/* KERN_ERR to let be happy */
+			if(speed_step==0) printk(KERN_ERR "[%s] get driving s0 : 0x%x\n",__func__,pddrive_nf_s0[i]);
+		}
+	} else {
+		printk(KERN_INFO "[%s] no driving nf_s0 warning !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "pddrive_nf_s1", &size);
+	if (prop) {
+		if (size)
+			counter = size / sizeof(u32);
+
+		for (i=0; i<counter; i+=1) {
+			pddrive_nf_s1[i]= of_read_number(prop, 1 + i);
+			/* KERN_ERR to let be happy */
+			if(speed_step==1) printk(KERN_ERR "[%s] get driving s1 : 0x%x\n",__func__,pddrive_nf_s1[i]);
+		}
+	} else {
+		printk(KERN_INFO "[%s] no driving nf_s1 warning !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "pddrive_nf_s2", &size);
+	if (prop) {
+		if (size)
+			counter = size / sizeof(u32);
+
+		for (i=0; i<counter; i+=1) {
+			pddrive_nf_s2[i]= of_read_number(prop, 1 + i);
+			/* KERN_ERR to let be happy */
+			if(speed_step==2) printk(KERN_ERR "[%s] get driving s2 : 0x%x\n",__func__,pddrive_nf_s2[i]);
+		}
+	} else {
+		printk(KERN_INFO "[%s] no driving nf_s2 warning !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "pddrive_nf_s3", &size);
+        if (prop) {
+                if (size)
+                        counter = size / sizeof(u32);
+
+                for (i=0; i<counter; i+=1) {
+                        pddrive_nf_s3[i]= of_read_number(prop, 1 + i);
+                        /* KERN_ERR to let be happy */
+                        if(speed_step==3) printk(KERN_ERR "[%s] get driving s3 : 0x%x\n",__func__,pddrive_nf_s3[i]);
+                }
+        } else {
+                printk(KERN_INFO "[%s] no driving nf_s3 warning !! \n",__func__);
+        }
+
+	prop = of_get_property(pdev->dev.of_node, "phase_tuning", &size);
+	if (prop) {
+		emmc_port->tx_tuning = of_read_number(prop, 1);
+		emmc_port->rx_tuning = of_read_number(prop, 2);
+		printk(KERN_ERR "[%s] get tx tuning switch : %u\n",__func__, emmc_port->tx_tuning);
+		printk(KERN_ERR "[%s] get rx tuning switch : %u\n",__func__, emmc_port->rx_tuning);
+	} else {
+		emmc_port->tx_tuning = 1;	//if we do not get this node in device tree, we should tune phase by kernel
+		emmc_port->rx_tuning = 1;
+		printk(KERN_INFO "[%s] no phase_tuning switch node !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "dqs_tuning", &size);
+	if (prop) {
+		emmc_port->dqs_tuning = of_read_number(prop, 1);
+		printk(KERN_ERR "[%s] get dqs tuning switch : %u\n",__func__, emmc_port->dqs_tuning);
+	} else {
+		emmc_port->dqs_tuning = 1;	//if we do not get this node, we should tune dqs value by kernel
+		printk(KERN_INFO "[%s] no dqs_tuning switch node !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "reference_phase", &size);
+	if (prop) {
+		emmc_port->tx_user_defined = of_read_number(prop, 1);
+		emmc_port->tx_reference_phase = of_read_number(prop, 2);
+		emmc_port->rx_user_defined = of_read_number(prop, 3);
+		emmc_port->rx_reference_phase = of_read_number(prop, 4);
+		if(emmc_port->tx_user_defined) printk(KERN_ERR "[%s] get User defined tx reference phase: %u\n",__func__, emmc_port->tx_reference_phase);
+		if(emmc_port->rx_user_defined) printk(KERN_ERR "[%s] get User defined rx reference phase: %u\n",__func__, emmc_port->rx_reference_phase);
+	} else {
+		emmc_port->tx_user_defined = 0;
+		emmc_port->tx_reference_phase = 0x0;
+		emmc_port->rx_user_defined = 0;
+		emmc_port->rx_reference_phase = 0x0;
+		printk(KERN_INFO "[%s] no tx & rx reference phase switch node !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "emmc_tuning_addr", &size);
+	if (prop) {
+		emmc_port->emmc_tuning_addr = of_read_number(prop, 1);
+		printk(KERN_ERR "[%s] GPT format: emmc tuning offset start from 0x%x\n",__func__, emmc_port->emmc_tuning_addr);
+	} else {
+		prop = of_get_property(pdev->dev.of_node, "mbr_tuning_addr", &size);
+		if (prop) {
+			emmc_port->emmc_tuning_addr = of_read_number(prop, 1);      //if we do not get this node, we assume that the system uses MBR mode before Android O
+			printk(KERN_ERR "[%s] MBR format: emmc tuning offset start from 0x%x\n\n",__func__, emmc_port->emmc_tuning_addr);
+		}
+		else {
+			emmc_port->emmc_tuning_addr = 0x9a0e00;	//use default value in the factory partition end block addr - 1025 blocks
+			printk(KERN_ERR "[%s] Use Default tuning addr: emmc tuning offset start from 0x%x\n\n",__func__, emmc_port->emmc_tuning_addr);
+		}
+	}
+
+	rstc_emmc = devm_reset_control_get(&pdev->dev, NULL);
+	if (IS_ERR(rstc_emmc)) {
+		printk(KERN_WARNING "%s: reset_control_get() returns %ld\n", __func__,
+			PTR_ERR(rstc_emmc));
+		rstc_emmc = NULL;
+	}
+	clk_en_emmc = devm_clk_get(&pdev->dev, "emmc");
+	if (IS_ERR(clk_en_emmc)) {
+		printk(KERN_WARNING "%s: clk_get() returns %ld\n", __func__,
+			PTR_ERR(clk_en_emmc));
+		clk_en_emmc = NULL;
+	}
+	clk_en_emmc_ip = devm_clk_get(&pdev->dev, "emmc_ip");
+	if (IS_ERR(clk_en_emmc_ip)) {
+		printk(KERN_WARNING "%s: clk_get() returns %ld\n", __func__,
+			PTR_ERR(clk_en_emmc_ip));
+		clk_en_emmc_ip = NULL;
+	}
+#ifdef CONFIG_ARCH_RTD129x
+	//1295 uses the same DMA bus bwtween SD, SDIO, and EMMC, we still need to open this clk if no SD card and SDIO driver, 1395 will separare the DMA bus
+	clk_cr = devm_clk_get(&pdev->dev, "cr");
+	if (IS_ERR(clk_cr)) {
+		printk(KERN_WARNING "%s: clk_get() returns %ld\n", __func__,
+			PTR_ERR(clk_cr));
+		clk_cr = NULL;
+	}
+#endif
+	clk_prepare_enable(clk_en_emmc);
+	clk_prepare_enable(clk_en_emmc_ip);
+#ifdef CONFIG_ARCH_RTD129x
+	clk_prepare_enable(clk_cr);
+#endif
+
+	mmc->ocr_avail = MMC_VDD_30_31 
+			| MMC_VDD_31_32
+			| MMC_VDD_32_33
+			| MMC_VDD_33_34
+			| MMC_VDD_165_195;
+
+	mmc->caps = MMC_CAP_4_BIT_DATA
+		| MMC_CAP_8_BIT_DATA
+		| MMC_CAP_SD_HIGHSPEED
+		| MMC_CAP_MMC_HIGHSPEED
+		| MMC_CAP_NONREMOVABLE
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		| MMC_CAP_1_8V_DDR
+		| MMC_CAP_UHS_DDR50
+#endif
+		| MMC_CAP_CMD23
+		| MMC_CAP_ERASE;
+
+	mmc->caps2 = (MMC_CAP2_NO_SDIO | MMC_CAP2_NO_SD);
+	switch(speed_step)
+	{
+	case 0: //sdr50
+		mmc->caps &= ~(MMC_CAP_UHS_DDR50|MMC_CAP_1_8V_DDR);
+		mmc->caps2 &= ~(MMC_CAP2_HS200_1_8V_SDR);
+		break;
+	case 1: //ddr50
+		mmc->caps2 &= ~(MMC_CAP2_HS200_1_8V_SDR);
+		break;
+	case 2: //hs200
+		mmc->caps2 |= MMC_CAP2_HS200_1_8V_SDR;
+		break;
+	case 3: //hs400
+		mmc->caps2 |= (MMC_CAP2_HS200_1_8V_SDR|MMC_CAP2_HS400_1_8V);
+		break;
+	}
+
+	if(rtk_emmc_bus_wid == 4 || rtk_emmc_bus_wid == 5)
+		mmc->caps &= ~MMC_CAP_8_BIT_DATA;
+
+	mmc->caps2 |= MMC_CAP2_HC_ERASE_SZ;
+	mmc->f_min = 300000;        //300K
+	mmc->f_max = 400000000; //400M
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	mmc->max_segs = 1;
+#else
+	mmc->max_segs = 256;
+#endif
+	mmc->max_blk_size   = 512;
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	mmc->max_blk_count  = 0x400; //0x400;
+#else
+	mmc->max_blk_count  = 0x800;
+#endif
+	mmc->max_seg_size   = mmc->max_blk_size * mmc->max_blk_count;
+	mmc->max_req_size   = mmc->max_blk_size * mmc->max_blk_count;
+
+	spin_lock_init(&emmc_port->lock);
+	init_rwsem(&cr_rw_sem);
+	tasklet_init(&emmc_port->req_end_tasklet, rtkemmc_req_end_tasklet, (unsigned long)emmc_port);
+
+	//Force enable dbg log
+#ifdef MMC_DBG
+	emmc_port->rtflags |= RTKCR_FOPEN_LOG;
+#endif
+
+	if(rtk_emmc_bus_wid == 9 || rtk_emmc_bus_wid == 5)
+		emmc_port->rtflags |= RTKCR_FOPEN_LOG;
+
+	if (!emmc_port->emmc_membase) {
+		printk(KERN_INFO "---- Realtek EMMC Controller Driver probe fail - nomem ----\n\n");
+		ret = -ENOMEM;
+		goto out;
+	}
+
+#ifdef ENABLE_EMMC_INT_MODE
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_lock2(flags2, _at_("rtkemmc_probe"));
+#endif
+	rtkemmc_hold_int_dec();       /* hold status interrupt */
+	rtkemmc_clr_int_sta();
+#ifdef CONFIG_ARCH_RTD129x
+	rtk_lockapi_unlock2(flags2, _at_("rtkemmc_probe"));
+#endif
+	ret = request_irq(irq, rtkemmc_irq, IRQF_SHARED, DRIVER_NAME, emmc_port);   //rtkemmc_interrupt
+	if (ret) {
+		printk(KERN_ERR "%s: cannot assign irq %d\n", DRIVER_NAME, irq);
+		goto out;
+	} else
+		emmc_port->irq = irq;
+
+	setup_timer(&emmc_port->timer, rtkemmc_timeout_timer, (unsigned long)emmc_port);
+#endif
+	emmc_port->ops->set_crt_muxpad(emmc_port);
+
+	if (emmc_port->ops->reset_card)
+		emmc_port->ops->reset_card(emmc_port);
+
+	emmc_port->ops->chk_card_insert(emmc_port);
+
+	platform_set_drvdata(pdev, mmc);
+	
+	ret = mmc_add_host(mmc);
+	if (ret)
+		goto out;
+
+	sync(emmc_port);
+	memset((struct backupRegs*)&gRegTbl, 0x00, sizeof(struct backupRegs));
+	gCurrentBootMode = MODE_SDR;
+	g_crinit=0;
+	gPreventRetry=0;
+	g_bResuming=0;
+	g_bTuning=0;
+
+#ifdef RTK_EMMC_HEALTH_REPORT
+	mmc->wr_emmc_size_cnt = 0;
+	mmc->remainder = 0;
+#endif
+	printk(KERN_NOTICE "%s: %s driver initialized\n",
+	mmc_hostname(mmc), DRIVER_NAME);
+
+	rtkemmc_wait_block_dev_ready(mmc);
+
+	return 0;
+
+out:
+	if (emmc_port) {
+		if (emmc_port->irq)
+			free_irq(emmc_port->irq, emmc_port);
+
+		if (emmc_port->emmc_membase)
+			iounmap(emmc_port->emmc_membase);
+		if (emmc_port->crt_membase)
+			iounmap(emmc_port->crt_membase);
+	}
+
+	if (mmc)
+		mmc_free_host(mmc);
+
+	return ret;
+}
+
+static int __exit rtkemmc_remove(struct platform_device *pdev)
+{
+	struct mmc_host *mmc = platform_get_drvdata(pdev);
+	MMCPRINTF("\n");
+
+	//device_remove_file(&pdev->dev, &dev_attr_cr_send_cmd0);
+	//device_remove_file(&pdev->dev, &dev_attr_cr_fast_RW);
+	//device_remove_file(&pdev->dev, &dev_attr_em_open_log);
+	device_remove_file(&pdev->dev, &dev_attr_emmc_info);
+
+#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
+	device_remove_file(&pdev->dev, &dev_attr_emmc_hacking);
+#endif
+
+	if (mmc) {
+		struct rtkemmc_host *emmc_port = mmc_priv(mmc);
+		flush_scheduled_work();
+		rtkemmc_free_dma_buf(emmc_port);
+		mmc_remove_host(mmc);
+		if(!mmc){
+			printk("eMMC host have removed.\n");
+			mmc_host_local = NULL;
+        	}
+		free_irq(emmc_port->irq, emmc_port);
+
+		del_timer_sync(&emmc_port->timer);
+		iounmap(emmc_port->emmc_membase);
+		iounmap(emmc_port->crt_membase);
+		iounmap(emmc_port->sb2_membase);
+#if defined(EMMC_LA_DEBUG_GPIO) || defined(EMMC_PARAM_TEST)
+		iounmap(emmc_port->misc_membase);
+#endif
+#ifdef DBG_PORT
+		iounmap(emmc_port->sb2_debug_membase);
+#endif
+#if defined(CONFIG_MMC_RTK_EMMC_HW_SEMAPHORE)
+		iounmap(emmc_port->hw_semaphore);
+#endif
+		release_resource(emmc_port->res);
+		mmc_free_host(mmc);
+	}
+	platform_set_drvdata(pdev, NULL);
+
+	return 0;
+}
+
+static const struct of_device_id rtkemmc_ids[] = {
+        { .compatible = "Realtek,rtk1295-emmc" },
+        { /* Sentinel */ },
+};
+MODULE_DEVICE_TABLE(of, rtkemmc_ids);
+
+/**************************************************/
+/* driver / device attache area                   */
+/**************************************************/
+static struct platform_driver rtkemmc_driver = {
+	.probe      = rtkemmc_probe,
+	.remove     = __exit_p(rtkemmc_remove),
+	.driver     =
+	{
+		.name   = "rtkemmc",
+		.owner  = THIS_MODULE,
+		.of_match_table = of_match_ptr(rtkemmc_ids),
+#ifdef CONFIG_PM
+		.pm     = &rtk_dev_pm_ops
+#endif
+	},
+	.shutdown   = rtkemmc_shutdown,
+};
+#if 0
+static void rtkemmc_display_version (void)
+{
+	const __u8 *revision;
+	const __u8 *date;
+	const __u8 *time;
+	char *running = (__u8 *)VERSION;
+
+	strsep(&running, " ");
+	strsep(&running, " ");
+	revision = strsep(&running, " ");
+	date = strsep(&running, " ");
+	time = strsep(&running, " ");
+	printk(BANNER " Rev:%s (%s %s)\n", revision, date, time);
+
+#ifdef CONFIG_MMC_BLOCK_BOUNCE
+	printk("%s: CONFIG_MMC_BLOCK_BOUNCE enable\n",DRIVER_NAME);
+#else
+	printk("%s: CONFIG_MMC_BLOCK_BOUNCE disable\n",DRIVER_NAME);
+#endif
+
+#ifdef CONFIG_SMP
+	printk("%s: ##### CONFIG_SMP alert!! #####\n",DRIVER_NAME);
+#else
+	printk("%s: ##### CONFIG_SMP disable!! #####\n",DRIVER_NAME);
+#endif
+}
+#endif
+static int rtkemmc_set_bus_width(char * buf){
+	/*
+	get eMMC bus width setting by bootcode parameter, like below
+	bootargs=console=ttyS0,115200 earlyprintk emmc_bus=8
+	the keyword is "emmc_bus"
+	the getted parameter is hex.
+        example:
+        emmc_bus=8
+	*/
+
+	rtkemmc_chk_param(&rtk_emmc_bus_wid,1,buf+1);
+	printk("%s: setting bus width is %u-bit\n", DRIVER_NAME,rtk_emmc_bus_wid);
+	return 0;
+}
+module_platform_driver(rtkemmc_driver);
+
+MODULE_AUTHOR("Jim Tsai");
+MODULE_DESCRIPTION("Realtek EMMC Host Controller driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtkemmc");
+
+__setup("emmc_bus",rtkemmc_set_bus_width);
diff --git a/drivers/mmc/host/rtkemmc.h b/drivers/mmc/host/rtkemmc.h
new file mode 100644
index 00000000..21ed9f6
--- /dev/null
+++ b/drivers/mmc/host/rtkemmc.h
@@ -0,0 +1,614 @@
+/*
+ *  Copyright (C) 2010 Realtek Semiconductors, All Rights Reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __RTKEMMC_H
+#define __RTKEMMC_H
+
+#include "reg_mmc.h"               
+#include "mmc_debug.h"               
+
+#define MAX_DESCRIPTOR_NUM    8
+#define EMMC_MAX_SCRIPT_BLK   8   
+
+//debug
+//#define MMC_DBG
+#ifdef MMC_DBG
+#define MMCPRINTF(fmt, args...)   printk(fmt,## args)
+#else
+#define MMCPRINTF(fmt, args...)
+#endif
+
+/* cmd1 sector mode */
+#define MMC_SECTOR_ADDR		0x40000000
+/*
+ * Clock rates
+ */
+#define RTKSD_CLOCKRATE_MAX	48000000
+#define RTKSD_BASE_DIV_MAX	0x100
+
+/*
+ * pad driving
+ * */
+#define MMC_IOS_GET_PAD_DRV	0x1
+#define MMC_IOS_SET_PAD_DRV	0x2
+#define MMC_IOS_RESTORE_PAD_DRV	0x4
+#define CLEAR_CR_CARD_STATUS(reg_addr)           \
+	do {                                     \
+		writel(0xffffffff, reg_addr);    \
+	} while (0)
+
+#define CLEAR_ALL_CR_CARD_STATUS(io_base)        \
+do {                                \
+	int i = 0;  \
+	for(i=0; i<5; i++)  \
+	CLEAR_CR_CARD_STATUS(io_base+20+ (i*4));  \
+} while (0)
+
+/* MMC configure2, for SD_CONFIGURE2, response type */
+#define SD_R0                   (RESP_TYPE_NON|CRC7_CHK_DIS)
+#define SD_R1                   (RESP_TYPE_6B)
+#define SD_R1b                  (RESP_TYPE_6B|WAIT_BUSY_EN)
+#define SD_R2                   (RESP_TYPE_17B)
+#define SD_R3                   (RESP_TYPE_6B)
+#define SD_R4                   (RESP_TYPE_6B)
+#define SD_R5                   (RESP_TYPE_6B)
+#define SD_R6                   (RESP_TYPE_6B)
+#define SD_R7                   (RESP_TYPE_6B)
+#define SD_R_NO                 (0xFF)
+
+/* rtflags */
+#define RTKCR_FCARD_DETECTED    (1<<0)      /* Card is detected */
+#define RTKCR_FOPEN_LOG         (1<<1)      /* open command log */
+#define RTKCR_USER_PARTITION    (1<<2)      /* card is working on normal partition */
+
+#define RTKCR_FCARD_POWER       (1<<4)      /* Card is power on */
+#define RTKCR_FHOST_POWER       (1<<5)      /* Host is power on */
+
+#define RED_BOLD "\033[31;1m"
+#define BLU_BOLD "\033[34;1m"
+#define YEL_BOLD "\033[33;1m"
+#define GRN_BOLD "\033[32;1m"
+#define CYAN_BOLD_ITALIC "\033[36;1;3m"
+#define RESET "\033[0;m"
+
+
+struct rtkemmc_host {
+	struct mmc_host     *mmc;           /* MMC structure */
+	u32                 rtflags;        /* Driver states */
+	u8                  ins_event;
+	u8                  cmd_opcode;
+
+#define EVENT_NON		    0x00
+#define EVENT_INSER		    0x01
+#define EVENT_REMOV		    0x02
+#define EVENT_USER		    0x10
+
+	u8                  reset_event;
+	struct mmc_request  *mrq;            /* Current request */
+	u8                  wp;
+	struct rtk_host_ops *ops;
+	struct semaphore	sem;
+	struct semaphore	sem_op_end;
+
+	volatile void __iomem	*emmc_membase;
+	volatile void __iomem	*crt_membase;
+	volatile void __iomem	*sb2_membase;	
+	volatile void __iomem	*misc_membase;
+	volatile void __iomem   *sb2_debug_membase;
+	volatile void __iomem   *hw_semaphore;
+#if defined(CONFIG_ARCH_RTD139x)
+	volatile void __iomem   *iso_muxpad;
+#elif defined(CONFIG_ARCH_RTD16xx)
+	volatile void __iomem   *m2tmx;
+#endif
+	spinlock_t          lock;
+	unsigned int        ns_per_clk;
+	struct delayed_work cmd_work;
+	struct tasklet_struct req_end_tasklet;
+
+	struct timer_list   timer;
+	struct timer_list   plug_timer;
+	struct completion   *int_waiting;
+	struct device       *dev;
+	struct resource     *res;
+	int                 irq;
+	u8                  *tmp_buf;
+	dma_addr_t          tmp_buf_phy_addr;
+	dma_addr_t          dma_paddr;
+	dma_addr_t          desc_paddr;
+#ifdef MONI_MEM_TRASH
+	u8                  *cmp_buf;
+	dma_addr_t          phy_addr;
+#endif
+	u32		test_count;
+	u32		tmout;
+	u32		rintsts; //2044
+	u32 		mintsts; //2040
+	u32		status;  //2048
+	u32		idsts;	 //208c
+	u32		dma_isr; //2424
+	u32		int_stat;
+	u32		idinten; //2090
+	u32		intmask; //2024
+	u8		rpmb_cmd; // it is rpmb cmd flag. When receiving CMD23, set to 1
+	u8		tx_tuning; //flag  that tx tuning need to be performed
+	u8		rx_tuning; //flag  that rx tuning need to be performed
+	u8		dqs_tuning;
+	u8		tx_user_defined;
+	u8		rx_user_defined;
+	u8		tx_reference_phase;
+	u8		rx_reference_phase;
+	u32		emmc_tuning_addr;
+#define INT_STAT_CD		0x00000001	  //cmd done
+#define INT_STAT_DTO		0x00000002	  //data trans over
+#define INT_STAT_ACD		0x00000004    //r/w multiple blk
+#define INT_STAT_DMA_DONE	0x00000008	  //rd dma done
+#define INT_STAT_DATA_DONE	0x00000010 	  //wr data done
+#define ClrINTState(host)      		    \
+	do {                                \
+		host->int_stat = 0x00000000;     \
+	} while (0)
+#define SetINTState(host, val)  	    \
+	do {                                \
+		host->int_stat |= val;     \
+	} while (0)
+#define GetINTState(host, val)  	    (host->int_stat & val)
+
+};
+
+struct rtk_host_ops {
+	irqreturn_t (*func_irq)(int irq, void *dev);
+	int (*re_init_proc)(struct mmc_card *card);
+	int (*card_det)(struct rtkemmc_host *emmc_port);
+	void (*card_power)(struct rtkemmc_host *emmc_port,u8 status);
+	void (*chk_card_insert)(struct rtkemmc_host *rtkhost);
+	void (*set_crt_muxpad)(struct rtkemmc_host *rtkhost);
+	void (*set_clk)(struct rtkemmc_host *rtkhost,u32 mmc_clk);
+	void (*reset_card)(struct rtkemmc_host *rtkhost);
+	void (*reset_host)(struct rtkemmc_host *rtkhost);
+	void (*bus_speed_down)(struct rtkemmc_host *emmc_port);
+	u32 (*get_cmdcode)(u32 opcode );
+	u32 (*get_r1_type)(u32 opcode );
+	u32 (*chk_cmdcode)(struct mmc_command* cmd);
+	u32 (*chk_r1_type)(struct mmc_command* cmd);
+	void (*backup_regs)(struct rtkemmc_host *emmc_port);
+	void (*restore_regs)(struct rtkemmc_host *emmc_port);
+};
+
+struct ms_cmd_pkt {
+	struct rtkemmc_host   *emmc_port;
+	struct ms_command   *mscmd;
+	struct mmc_data     *data;
+
+	unsigned char       *dma_buffer;    //data transfer address
+	u16                 cmdcode;        //rtk ms operation code
+	u16                 trans_bytes;    //register transfer bytes
+	u16                 block_count;    //data block transfer count
+};
+
+struct sd_cmd_pkt {
+	struct mmc_host     *mmc;       /* MMC structure */
+	struct rtkemmc_host   *emmc_port;
+	struct mmc_command  *cmd;    /* cmd->opcode; cmd->arg; cmd->resp; cmd->data */
+	struct mmc_data     *data;
+	unsigned char       *dma_buffer;
+	u16                 byte_count;
+	u16                 block_count;
+
+	u32                 flags;
+	u32			cmd_para;
+	u8                  rsp_len;
+	u32                 timeout;
+};
+
+struct backupRegs {
+#if defined(CONFIG_ARCH_RTD129x)
+	u32			emmc_mux_pad0;
+	u32			emmc_mux_pad1;
+	u32			emmc_pfunc_nf1;
+	u32			emmc_pfunc_cr;
+	u32			emmc_pdrive_nf1;
+	u32			emmc_pdrive_nf2;
+	u32			emmc_pdrive_nf3;
+	u32			emmc_pdrive_nf4;
+//139x and 16xx does not need to restore the pad mux part, only 129x needs to take this action
+/*
+#elif defined(CONFIG_ARCH_RTD139x)
+	u32                     iso_muxpad4;
+	u32			Pfunc_emmc0;
+	u32                     Pfunc_emmc1;
+	u32                     Pfunc_emmc2;
+	u32                     Pfunc_emmc3;
+	u32                     Pfunc_emmc4;
+	u32                     Pfunc_emmc5;
+*/
+#endif
+
+#ifdef CONFIG_ARCH_RTD129x	//129x emmc reset will have impact on SD & SDIO
+	u32			emmc_pdrive_cr0;
+	u32			emmc_pdrive_cr1;
+	u32			emmc_pdrive_sdio;
+	u32			emmc_pdrive_sdio1;
+#endif
+	u32			emmc_ctype;
+	u32			emmc_uhsreg;
+	u32			emmc_ddr_reg;
+	u32			emmc_card_thr_ctl;
+	u32			emmc_clk_div;
+	u32			emmc_ckgen_ctl;
+	u32			emmc_dqs_ctrl1;
+	u32			emmc_clken;
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	u32			emmc_drto_mask_ori;
+	u32			emmc_other1;
+#endif
+};
+
+/* *** Realtek CRT register &&& */
+#define EMMC_CLKSEL_MASK        (0x07<<EMMC_CLKSEL_SHT)
+#define SD_CLKSEL_MASK          (0x07<<SD_CLKSEL_SHT)
+#define EMMC_CLOCK_SPEED_GAP    (0x03<<EMMC_CLKSEL_SHT)
+#define SD_CLOCK_SPEED_GAP      (0x03<<SD_CLKSEL_SHT)
+
+
+static const char *const clk_tlb_B[8] = {
+	"12MHz",
+	"16MHz",
+	"20MHz",
+	"25MHz",
+	"33MHz",
+	"49MHz"
+};
+
+/* Magellan_ISO_arch_spec.doc; PMM_Magellan_PinMux.doc */
+// iso gpio pinmux map
+static const u8 st_gpio_map[36] ={
+	0x34,0x34,0x34,0x34,0x30,0x30,0x30,0x30,    //0:7
+	0x2c,0x2c,0x2c,0x2c,0x28,0x28,0xff,0xff,    //8:15
+	0xff,0xff,0xff,0xff,0xff,0x28,0x28,0x24,    //16:23
+	0xff,0xff,0x24,0x24,0x24,0xff,0xff,0xff,    //24:31
+	0xff,0xff,0xff,0x20                         //32:35
+};
+
+// iso gpio pinmux bit operation map
+static const u8 st_gpio_bit_map[36] ={
+	0x04,0x0C,0x14,0x1C,0x04,0x0C,0x14,0x1C,    //0:7
+	0x04,0x0C,0x14,0x1C,0x04,0x0C,0xff,0xff,    //8:15
+	0xff,0xff,0xff,0xff,0xff,0x14,0x1C,0x04,    //16:23
+	0xff,0xff,0x0C,0x14,0x1C,0xff,0xff,0xff,    //24:31
+	0xff,0xff,0xff,0x04                         //32:35
+};
+
+#define MAX_CMD_RETRY_COUNT 4
+#define MAX_ISO_GPIO_CNT 35
+#define MAX_MIS_GPIO_CNT 169
+
+static const u8 mis_gpio_bit_map[4] ={
+	0x1C,0x14,0x0C,0x04    //0:3
+};
+
+#define CARD_SWITCHCLOCK_25MHZ_B    (0x00UL)    //(0x05)
+#define CARD_SWITCHCLOCK_33MHZ_B    (0x01UL)    //(0x06)
+#define CARD_SWITCHCLOCK_40MHZ_B    (0x02UL)    //(0x00)
+#define CARD_SWITCHCLOCK_50MHZ_B    (0x03UL)    //(0x01)
+#define CARD_SWITCHCLOCK_66MHZ_B    (0x04UL)    //(0x02)
+#define CARD_SWITCHCLOCK_98MH_B     (0x05UL)    //(0x03)
+#define CLOCK_SPEED_GAP          CARD_SWITCHCLOCK_50MHZ_B
+#define LOW_SPEED_LMT               CARD_SWITCHCLOCK_33MHZ_B
+
+static const u32 map_clk_to_reg[6] = {0x05,0x06,0x00,0x01,0x02,0x03};
+
+static const u32 map_reg_to_clk[8] = {0x02,0x03,0x04,0x05,0xFF,0x00,0x01,0xFF};
+
+#define CARD_SWITCHCLOCK_60MHZ  (0x00UL)      //(0x00<<12)
+#define CARD_SWITCHCLOCK_80MHZ  (0x01UL)      //(0x01<<12)
+#define CARD_SWITCHCLOCK_98MHZ  (0x02UL)      //(0x02<<12)
+#define CARD_SWITCHCLOCK_98MHZS (0x03UL)      //(0x03<<12)
+#define CARD_SWITCHCLOCK_30MHZ  (0x04UL)      //(0x04<<12)
+#define CARD_SWITCHCLOCK_40MHZ  (0x05UL)      //(0x05<<12)
+#define CARD_SWITCHCLOCK_49MHZ  (0x06UL)      //(0x06<<12)
+#define CARD_SWITCHCLOCK_49MHZS (0x07UL)      //(0x07<<12)
+
+/* CRT_SYS_CLKSEL setting bit &&& */
+
+/* CRT_SYS_SRST2 setting bit *** */
+#define RSTN_CR (0x01<<23)      //for eMMC
+/* CRT_SYS_SRST2 setting bit &&& */
+
+/* CRT_SYS_SRST3 setting bit *** */
+#define RSTN_SD (0x01<<16)      //for card reader
+/* CRT_SYS_SRST3 setting bit &&& */
+
+
+/* CRT_SYS_CLKEN2 setting bit *** */
+#define CLKEN_CR (0x01<<23)      //for eMMC
+/* CRT_SYS_CLKEN2 setting bit &&& */
+
+/* CRT_SYS_CLKEN3 setting bit *** */
+#define CLKEN_SD (0x01<<16)      //for card reader
+/* CRT_SYS_CLKEN3 setting bit &&& */
+
+#define CR_PINMUX_CR_MASK       0xFFFFC000
+
+#define MUX_SD_DAT2             (0x01<<26)
+#define MUX_MS_CLK              (0x02<<26)
+#define MUX_SD_DAT1             (0x01<<24)
+#define MUX_MS_BS               (0x02<<24)
+#define MUX_SD_DT               (0x01<<20)
+#define MUX_OTP_ATE_FAIL        (0x02<<20)
+#define MUX_SD_WP               (0x01<<18)
+#define MUX_MS_DT               (0x02<<18)
+#define MUX_SD_CLK              (0x01<<16)
+#define MUX_MS_DAT0             (0x02<<16)
+#define MUX_SD_CMD              (0x01<<14)
+#define MUX_MS_DAT2             (0x02<<14)
+
+#define MUX_PAD5_DEFAULT         0x15554000
+
+#define CR_PMUX_CMD_MASK        ~(0x03<<14)  //mask 15,14
+#define CR_PMUX_CLK_MASK        ~(0x03<<16)  //mask 16,17
+#define CR_PMUX_MOD_MASK        ~(0x0f<<18)  //mask 18,19,20,21
+//#define DETECT_MODE             MUX_MS_DT|MUX_SD_DT
+#define DETECT_MODE             MUX_SD_DT
+
+#define MUX_PAD5_SD_MODE        0x15554000
+
+#define RCA_SHIFTER             16
+#define NORMAL_READ_BUF_SIZE    512      //no matter FPGA & QA
+
+#define SD_CARD_WP              (1<<5)
+//#define MS_CARD_EXIST           (1<<3)
+#define SD_CARD_EXIST           (1<<2)
+
+/*======================================================== */
+
+/* move from c file *** */
+#define BYTE_CNT            0x200
+#define RTK_NORMAL_SPEED    0x00
+#define RTK_HIGH_SPEED      0x01
+#define RTK_1_BITS          0x00
+#define RTK_4_BITS          0x10
+#define RTK_BITS_MASK       0x30
+#define RTK_SPEED_MASK      0x01
+#define RTK_PHASE_MASK      0x06
+
+#define R_W_CMD             2   //read/write command
+#define INN_CMD             1   //command work chip inside
+#define UIN_CMD             0   //no interrupt rtk command
+
+#define RTK_FAIL            3  /* DMA error & cmd parser error */
+#define RTK_RMOV            2  /* card removed */
+#define RTK_TOUT            1  /* time out include DMA finish & cmd parser finish */
+#define RTK_SUCC            0
+
+#define CR_TRANS_OK         0x0
+#define CR_TRANSFER_TO      0x1
+#define CR_BUF_FULL_TO      0x2
+#define CR_DMA_FAIL         0x3
+#define CR_TRANSFER_FAIL    0x4
+
+/* send status event */
+#define STATE_IDLE          0
+#define STATE_READY         1
+#define STATE_IDENT         2
+#define STATE_STBY          3
+#define STATE_TRAN          4
+#define STATE_DATA          5
+#define STATE_RCV           6
+#define STATE_PRG           7
+#define STATE_DIS           8
+
+#define GPIO_HI             0x78
+#define GPIO_LO             0x87
+
+#define LVL_HI             0x01
+#define LVL_LO             0x00
+
+#define POW_CHECK 0
+#define POW_FORCE 1
+
+#define rtkemmc_get_int_sta(rintsts, mintsts, isr)	\
+	do {	\
+		*(u32 *)rintsts = readl(emmc_port->emmc_membase+EMMC_RINTSTS);   \
+		*(u32 *)mintsts = readl(emmc_port->emmc_membase+EMMC_MINTSTS); \
+		*(u32 *)isr = readl(emmc_port->emmc_membase+EMMC_ISR); \
+            } while (0)
+
+#define rtkemmc_get_sta(status,idsts)       \
+	do {	\
+		*(u32 *)status = readl(emmc_port->emmc_membase+EMMC_STATUS);     \
+		*(u32 *)idsts  = readl(emmc_port->emmc_membase+EMMC_IDSTS);     \
+	} while (0)
+
+#define rtkemmc_get_mask(idinten,intmask)       \
+	do {	\
+		*(u32 *)idinten = readl(emmc_port->emmc_membase+EMMC_IDINTEN);	   \
+		*(u32 *)intmask  = readl(emmc_port->emmc_membase+EMMC_INTMASK); 	\
+	} while (0)
+
+#define rtkemmc_clr_int_sta()                                                                              \
+	do {                                                                                                \
+		writel(ISR_DMA_DONE_INT, emmc_port->emmc_membase+EMMC_ISR); \
+		writel(readl(emmc_port->emmc_membase+EMMC_RINTSTS)&0x0000fffe, emmc_port->emmc_membase+EMMC_RINTSTS); \
+	} while(0)
+
+//mask all emmc interrupts
+#define rtkemmc_hold_int_dec()    \
+	do {      \
+		writel((ISR_WRITE_DATA|ISR_DMA_INT_MASK|ISR_DESC_INT_MASK|ISR_IP_INT_MASK), emmc_port->emmc_membase+EMMC_ISR); \
+		writel((readl(emmc_port->emmc_membase+EMMC_INTMASK)&0xffff0000), emmc_port->emmc_membase+EMMC_INTMASK); \
+	} while(0)
+
+//unmask all emmc interrupt			
+#define rtkemmc_en_int()  \
+	do { \
+		writel(ISR_DMA_INT_MASK|ISR_DESC_INT_MASK|ISR_IP_INT_MASK, emmc_port->emmc_membase+EMMC_ISR); \
+		writel((readl(emmc_port->emmc_membase+EMMC_INTMASK)|0x0000fffe), emmc_port->emmc_membase+EMMC_INTMASK); \
+	} while(0)
+
+//used for wr case
+#define rtkemmc_en_wr_int()  \
+	do {  \
+		writel(ISR_IP_INT_MASK, emmc_port->emmc_membase+EMMC_ISR); \
+		writel((readl(emmc_port->emmc_membase+EMMC_INTMASK)|INT_STS_ERRORS|INT_STS_DTO), emmc_port->emmc_membase+EMMC_INTMASK); \
+	} while(0)
+
+//used for rd case
+#define rtkemmc_en_rd_int()  \
+	do { \
+		writel(ISR_IP_INT_MASK, emmc_port->emmc_membase+EMMC_ISR); \
+		writel((readl(emmc_port->emmc_membase+EMMC_INTMASK)|INT_STS_ERRORS|INT_STS_DTO), emmc_port->emmc_membase+EMMC_INTMASK); \
+            } while(0)
+
+//used for none-stream case (cmd w/wo/ resp)
+#define rtkemmc_en_cd_int()  \
+	do {    \
+		writel(ISR_IP_INT_MASK, emmc_port->emmc_membase+EMMC_ISR); \
+		writel((readl(emmc_port->emmc_membase+EMMC_INTMASK)|INT_STS_ERRORS|INT_STS_CD), emmc_port->emmc_membase+EMMC_INTMASK); \
+	} while(0)	
+
+//used for cm6 case (cmd w/wo/ resp), ignore Response timeout(INT_STS_RTO_BAR)
+#define rtkemmc_en_cd6_int()  \
+	do {    \
+		writel(ISR_IP_INT_MASK, emmc_port->emmc_membase+EMMC_ISR); \
+		writel((readl(emmc_port->emmc_membase+EMMC_INTMASK)|INT_STS_ERRORS2|INT_STS_CD), emmc_port->emmc_membase+EMMC_INTMASK); \
+	} while(0)			
+
+#define  rtkemmc_mdelay(x)  \
+	do {    \
+		set_current_state(TASK_INTERRUPTIBLE); \
+		schedule_timeout(msecs_to_jiffies(x))  \
+	} while(0)
+
+#define rtkemmc_writel(val, addr) \
+	do {    \
+		sync(emmc_port);					\
+		writel(val, addr);					\
+	} while(0)
+		
+#define INT_BLOCK_R_GAP 0x200
+#define INT_BLOCK_W_GAP 5
+
+static const char *const state_tlb[9] = {
+	"STATE_IDLE",
+	"STATE_READY",
+	"STATE_IDENT",
+	"STATE_STBY",
+	"STATE_TRAN",
+	"STATE_DATA",
+	"STATE_RCV",
+	"STATE_PRG",
+	"STATE_DIS"
+};
+
+static const char *const bit_tlb[4] = {
+	"1bit",
+	"4bits",
+	"8bits",
+	"unknow"
+};
+
+static const char *const clk_tlb[8] = {
+	"30MHz",
+	"40MHz",
+	"49MHz",
+	"49MHz",
+	"15MHz",
+	"20MHz",
+	"24MHz",
+	"24MHz"
+};
+
+static const u32 const clk_2_hz[8] = {
+	10000000,
+	12000000,
+	15000000,
+	20000000,
+	24000000,
+	30000000,
+	40000000,
+	48000000
+};
+
+/* data read cmd */
+static const u8 const opcode_r_type[16] = {
+    0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,0
+};
+
+/* data write cmd */
+static const u8 const opcode_w_type[16] = {
+    1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0
+};
+
+/* data xfer cmd */
+static const u8 const opcode_d_type[16] = {
+    1,1,1,0,0,1,1,0,0,1,1,0,1,1,1,0
+};
+
+static const char *const cmdcode_tlb[16] = {
+	"N_W",      /* 0 */
+	"AW3",      /* 1 */
+	"AW4",      /* 2 */
+	"UNK",      /* 3 */
+	"UNK",      /* 4 */
+	"AR3",      /* 5 */
+	"AR4",      /* 6 */
+	"UNK",      /* 7 */
+	"SGR",      /* 8 */
+	"AW1",      /* 9 */
+	"AW2",      /* 10 */
+	"UNK",      /* 11 */
+	"N_R",      /* 12 */
+	"AR1",      /* 13 */
+	"AR2",      /* 14 */
+	"UNK",      /* 15 */
+};
+
+#define card_sta_err_mask ((1<<31)|(1<<30)|(1<<29)|(1<<28)|(1<<27)|(1<<26)|(1<<24)|(1<<23)|(1<<22)|(1<<21)|(1<<20)|(1<<19)|(1<<18)|(1<<17)|(1<<16)|(1<<15)|(1<<13)|(1<<7))
+
+/* Only ADTC type cmd use */
+static const unsigned char rtk_sd_cmdcode[64][2] = {
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //0~3
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //4~7
+	{EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_AUTOREAD1  ,SD_R1 }, //8~11
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //12~15
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_AUTOREAD2  ,SD_R1 }, {EMMC_AUTOREAD1  ,SD_R1 }, {EMMC_NORMALWRITE,SD_R1 }, //16~19
+	{EMMC_AUTOWRITE1 ,SD_R1 }, {EMMC_TUNING     ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //20~23
+	{EMMC_AUTOWRITE2 ,SD_R1 }, {EMMC_AUTOWRITE1 ,SD_R1 }, {EMMC_NORMALWRITE,SD_R1 }, {EMMC_NORMALWRITE,SD_R1 }, //24~27
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_NORMALREAD ,SD_R1 }, //28~31
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //32~35
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //36~39
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //40~43
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //44~47
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, //48~51
+	{EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //52~55
+	{EMMC_AUTOREAD2  ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //56~59
+	{EMMC_AUTOWRITE2 ,SD_R1 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }  //60~63 
+};
+
+/* remove from c file &&& */
+
+/* rtk function definition */
+#define ENABLE_EMMC_INT_MODE
+//#define EMMC_LA_DEBUG_GPIO
+
+/* rtk function definition */
+int error_handling(struct rtkemmc_host *emmc_port, unsigned int cmd_idx, unsigned int bIgnore);
+int rtkemmc_send_cmd25(struct rtkemmc_host *emmc_port,int,unsigned long, int,int*);
+int rtkemmc_send_cmd18(struct rtkemmc_host *emmc_port,int,unsigned long);
+int rtkemmc_send_cmd24(struct rtkemmc_host *emmc_port);
+int rtkemmc_send_cmd17(struct rtkemmc_host *emmc_port);
+
+
+//int rtkemmc_send_cmd8(struct rtkemmc_host *emmc_port,unsigned int bIgnore);
+int rtkemmc_send_cmd8(struct rtkemmc_host *emmc_port, unsigned int bIgnore);
+int polling_to_tran_state(struct rtkemmc_host *emmc_port,int cmd_idx, int bIgnore);
+void host_card_stop(struct rtkemmc_host *emmc_port);
+void host_card_stop2(struct rtkemmc_host *emmc_port);
+int rtkemmc_switch(struct mmc_card *card, u8 acc_mod, u8 index, u8 value, u8 cmd_set);
+#endif
diff --git a/drivers/mmc/host/rtkemmc_rtd119x.c b/drivers/mmc/host/rtkemmc_rtd119x.c
new file mode 100644
index 00000000..6e9e165
--- /dev/null
+++ b/drivers/mmc/host/rtkemmc_rtd119x.c
@@ -0,0 +1,5334 @@
+/*
+ * Realtek MMC/SD/SDIO driver
+ *
+ * Authors:
+ * Copyright (C) 2008-2009 Realtek Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/platform_device.h>
+#include <linux/mbus.h>
+#include <linux/delay.h>
+#include <linux/interrupt.h>
+#include <linux/dma-mapping.h>
+#include <linux/scatterlist.h>
+#include <linux/irq.h>
+#include <linux/gpio.h>
+#include <linux/mmc/host.h>
+#include <asm/unaligned.h>
+
+#include <linux/sched.h>                //liao
+#include <linux/wait.h>                 //liao
+#include <linux/slab.h>                 //liao
+#include <linux/semaphore.h>            //liao
+#include <linux/mmc/card.h>             //liao
+#include <linux/mmc/host.h>             //liao
+#include <linux/mmc/mmc.h>              //liao
+#include <linux/mmc/sd.h>               //liao
+#include <linux/workqueue.h>            //liao
+#include <linux/completion.h>           //liao
+#include "reg_mmc_rtd119x.h"             //liao
+#include "reg_iso.h"               //liiao
+#include "reg_sys_rtd119x.h"               //liao
+#include <mach/cpu.h>
+#include <mach/system.h>
+#include <mach/irqs.h>
+#include "rtkemmc_rtd119x.h"                  //liao
+#include "mmc_debug.h"               //liao
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_gpio.h>
+#include <linux/pm_runtime.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+#ifdef CONFIG_REALTEK_PCBMGR
+#include <mach/pcbMgr.h>
+#ifdef CONFIG_REALTEK_GPIO
+#include <mach/venus_gpio.h>
+#define EMMC_SHOUTDOWN_PROTECT
+#endif
+#endif
+
+#include <asm/system_info.h>
+
+#define DRIVER_NAME "rtkemmc"
+#define BANNER      "Realtek eMMC Driver"
+#define VERSION     "$Id: rtkemmc.c Phoenix 2014-03-26 10:00 $"
+
+#ifdef MONI_MEM_TRASH
+#define MAX_BLK_NUM 0x01
+#endif
+
+#ifndef CONFIG_MMC_RTKEMMC_HK_ATTR
+#define CONFIG_MMC_RTKEMMC_HK_ATTR
+#endif
+
+#define EXT_CSD_ENH_START_ADDR          136     /* R/W, 4 bytes */
+#define EXT_CSD_MAX_ENH_SIZE_MULT       157     /* R/W, 3 bytes */
+#define EXT_CSD_WR_REL_SET              167     /* R/W ifHS_CTRL_REL=1 */
+#define EXT_CSD_ENH_SIZE_MULT           140     /* R/W, 3 bytes */
+#define MMC_DATA_TUNING (1 << 11)
+#define MMC_MICRON_60            60
+#define mmc_card_cmd24_err(c)  ((c)->state & MMC_STATE_CMD24_ERR)
+#define MMC_STATE_CMD24_ERR    (1<<13)         /* for cmd24 error handling */
+#define mmc_card_set_cmd24_err(c)       ((c)->state |= MMC_STATE_CMD24_ERR)
+//TBD : if system & card enter suspend, resume can't wakeup correctly
+//#define REAL_SUSPEND
+struct reset_control *rstc_emmc;
+struct clk * clk_en_emmc;
+struct clk * clk_en_emmc_ip;
+struct clk * clk_cr;
+
+
+int mmc_select_hs200(struct mmc_card *card);
+int mmc_select_ddr50(struct mmc_card *card);
+static int maxfreq = RTKSD_CLOCKRATE_MAX;
+static int nodma;
+struct mmc_host * mmc_host_local = NULL;
+static u32 rtk_emmc_bus_wid = 0;
+volatile u8 g_cmd[6];
+static volatile struct backupRegs gRegTbl;
+static volatile int g_bResuming;
+int g_bTuning;
+static int bSendCmd0=0;
+volatile unsigned int gCurrentBootMode=MODE_SD20;
+volatile unsigned int gPreventRetry=0;
+static unsigned char* pRSP=NULL;
+static unsigned char* pRSP_org=NULL;
+static volatile unsigned int  g_crinit=0;
+static struct rw_semaphore cr_rw_sem;
+
+static void rtksd_request(struct mmc_host *host, struct mmc_request *mrq);
+static int rtksd_get_ro(struct mmc_host *mmc);
+static void rtksd_set_ios(struct mmc_host *host, struct mmc_ios *ios);
+
+static void set_cmd_info(struct mmc_card *card,struct mmc_command * cmd,
+struct sd_cmd_pkt * cmd_info,u32 opcode,u32 arg,u8 rsp_para);
+
+static int rtksd_stop_transmission(struct mmc_card *card,int bIgnore);
+static int rtksd_send_status(struct mmc_card *card,u16 * state,u8 divider,int bIgnore);
+static int rtksd_wait_status(struct mmc_card *card,u8 state,u8 divider,int bIgnore);
+
+static void rtkcr_set_speed(struct rtksd_host *sdport,u8 level);
+static int mmc_Tuning_DDR50(struct rtksd_host *sdport);	
+static int mmc_Tuning_HS200(struct rtksd_host *sdport);
+static int rtksd_execute_tuning(struct mmc_host *host, u32 opcode);
+
+typedef void (*set_gpio_func_t)(u32 gpio_num,u8 dir,u8 level);
+
+static struct resource rtkemmc_resources[] = {
+    [0] = {
+        .start  = GET_MAPPED_RBUS_ADDR((u32)EM_BASE_ADDR),
+        .end    = GET_MAPPED_RBUS_ADDR((u32)EM_BASE_ADDR + 0x200),
+        .flags  = IORESOURCE_MEM,
+    },
+    [1] = {
+        .start  = IRQ_CR,
+        .end    = IRQ_CR,
+        .flags  = IORESOURCE_IRQ,
+    },
+};
+static const struct mmc_host_ops rtkemmc_ops = {
+    .request        = rtksd_request,
+    .get_ro         = rtksd_get_ro,
+    .set_ios        = rtksd_set_ios,
+    .execute_tuning = rtksd_execute_tuning
+};
+
+#define UNSTUFF_BITS(resp,start,size)					\
+	({								\
+		const int __size = size;				\
+		const u32 __mask = (__size < 32 ? 1 << __size : 0) - 1;	\
+		const int __off = 3 - ((start) / 32);			\
+		const int __shft = (start) & 31;			\
+		u32 __res;						\
+									\
+		__res = resp[__off] >> __shft;				\
+		if (__size + __shft > 32)				\
+			__res |= resp[__off-1] << ((32 - __shft) % 32);	\
+		__res & __mask;						\
+	})
+//#############################################################################################################################################
+#ifdef MMC_DBG
+static unsigned sd_reg = 0;
+#endif
+//extern volatile unsigned char g_cmd[];
+//extern volatile int g_bTuning;
+
+DECLARE_COMPLETION(rtk_emmc_wait);
+
+#ifdef GPIO_DEBUG
+void trans_db_gpio(void)
+{
+    //set debug GPIO
+    u32 reginfo;
+    //1. 0xB800_0804[31:28] = F    --> pin share as gpio
+    //2. 0x1801_BC00[4] = 1  --> output mode
+    //3. 0x1801_BC18[4]   is output data
+    cr_writel(cr_readl(GP0DIR_reg)|0x10,GP0DIR_reg);
+
+    reginfo = cr_readl(GP0DATO_reg);
+    if(reginfo & 0x10){
+        mmcrtk("GP HI\n");
+        cr_writel(reginfo & ~0x10,GP0DATO_reg);
+    }else{
+        mmcrtk("GP LO\n");
+        cr_writel(reginfo | 0x10,GP0DATO_reg);
+    }
+}
+
+void trans_rst_gpio(void)
+{
+    //set rst GPIO
+    u32 reginfo;
+    cr_writel(cr_readl(GP0DIR_reg) |  0x00100000, GP0DIR_reg);
+    reginfo = cr_readl(GP0DATO_reg);
+
+    if(reginfo & 0x00100000){
+        cr_writel(reginfo & ~0x00100000, GP0DATO_reg);
+    }else{
+        cr_writel(reginfo |  0x00100000, GP0DATO_reg);
+    }
+
+}
+#else
+#define trans_db_gpio()
+#define trans_rst_gpio()
+#endif
+
+void sync(void)
+{
+    asm volatile("DMB");
+    cr_writel(0x0, 0x1801a020);
+    asm volatile("DMB");
+}
+EXPORT_SYMBOL_GPL(sync);
+
+#define TIMEOUT_MS 3000
+int rtkcr_wait_opt_end(char* drv_name, struct rtksd_host *sdport,u8 cmdcode,u8 cmd_idx,u8 cpu_mode)
+{
+    	volatile u8 sd_transfer_reg;
+    	volatile int loops=0,dma_val=0;
+    	volatile int err=CR_TRANS_OK;
+    	volatile unsigned long timeend=0;
+    	volatile unsigned int sd_trans=0;
+    	unsigned long flags;
+    	unsigned int dma_to=0;
+
+    	MMCPRINTF("\n%s - info :\ncmd0 : 0x%02x,cmd1 : 0x%02x,cmd2 : 0x%02x,cmd3 : 0x%02x,cmd4: 0x%02x\n", drv_name, g_cmd[0],g_cmd[1],g_cmd[2],g_cmd[3],g_cmd[4]);
+    	switch(cmdcode)
+    	{
+                case 0x2:
+                case 0x7:
+                case 0x8:
+                        dma_to=TIMEOUT_MS;
+                        break;
+                default:
+                        dma_to=0;
+                        break;
+            }
+            switch(cmd_idx)
+            {
+                case MMC_READ_SINGLE_BLOCK:
+                case MMC_READ_MULTIPLE_BLOCK:
+                case MMC_WRITE_BLOCK:
+                case MMC_WRITE_MULTIPLE_BLOCK:
+                        dma_to=TIMEOUT_MS;
+                        break;
+            }
+            err = rtk_int_enable_and_waitfor(sdport,cmdcode,cmd_idx,TIMEOUT_MS,dma_to);
+	    if (err != 0)
+                return err;
+            sync();
+            MMCPRINTF("\n%s - info1 :\ncmd0 : 0x%02x,cmd1 : 0x%02x,cmd2 : 0x%02x,cmd3 : 0x%02x,cmd4: 0x%02x\n", drv_name, g_cmd[0],g_cmd[1],g_cmd[2],g_cmd[3],g_cmd[4]);
+            err = CR_DMA_FAIL;
+            timeend = jiffies + msecs_to_jiffies(TIMEOUT_MS);
+            while (time_before(jiffies, timeend))
+            {
+                sync();
+                if (!(cr_readl(sdport->base_io+EMMC_DMA_CTL3) & DMA_XFER))
+                {
+                        err = 0;
+                        break;
+                }
+            }
+            if (err)
+            {
+                printk(KERN_INFO "\n%s - trans dma fail (cmd/2193/status1/status2/bus_status/cfg1/cfg2/cfg3/dma) : \n\t0x%08x 0x%08x 0x%08x 0x%08x 0x%08x 0x%02x 0x%02x 0x%02x 0x%08x\n",drv_name,g_cmd[0], cr_readb(sdport->base_io+SD_TRANSFER), cr_readb(sdport->base_io+SD_STATUS1), cr_readb(sdport->base_io+SD_STATUS2), cr_readb(sdport->base_io+SD_BUS_STATUS),cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3),cr_readl(sdport->base_io+EMMC_DMA_CTL3));
+                return err;
+            }
+            if (g_cmd[0] == 21)
+            {
+                cr_writel(DAT64_SEL|DDR_WR, sdport->base_io+EMMC_DMA_CTL3);
+                sync();
+                err = CR_TRANSFER_TO;
+                timeend = jiffies + msecs_to_jiffies(TIMEOUT_MS);
+                while(time_before(jiffies, timeend))
+                {
+                 sd_transfer_reg = cr_readb(sdport->base_io+SD_TRANSFER);
+                 sync();
+                 if ((sd_transfer_reg & (END_STATE|IDLE_STATE))==(END_STATE|IDLE_STATE))
+                 {
+                        err = 0;
+                        break;
+                 }
+                }
+                if (err)
+                {
+                        MMCPRINTF(KERN_INFO "\n%s - cmd21 dma fail0 (cmd/2193/status1/status2/bus_status/cfg1/cfg2/cfg3/dma) : \n\t0x%08x 0x%08x 0x%08x 0x%08x 0x%08x 0x%02x 0x%02x 0x%02x 0x%08x\n",drv_name,g_cmd[0], cr_readb(sdport->base_io+SD_TRANSFER), cr_readb(sdport->base_io+SD_STATUS1), cr_readb(sdport->base_io+SD_STATUS2), cr_readb(sdport->base_io+SD_BUS_STATUS),cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3),cr_readl(sdport->base_io+EMMC_DMA_CTL3));
+                        return err;
+                }
+                sync();
+		err = CR_DMA_FAIL;
+                timeend = jiffies + msecs_to_jiffies(TIMEOUT_MS);
+                while (time_before(jiffies, timeend))
+                {
+                        dma_val = cr_readl(sdport->base_io+EMMC_DMA_CTL3);
+                        sync();
+                        if ((dma_val & DMA_XFER)!=DMA_XFER)
+                        {
+                                return 0;
+                        }
+                }
+                if (err)
+                {
+                        MMCPRINTF(KERN_INFO "\n%s - cmd21 dma fail1 (cmd/2193/status1/status2/bus_status/cfg1/cfg2/cfg3/dma) : \n\t0x%08x 0x%08x 0x%08x 0x%08x 0x%08x 0x%02x 0x%02x 0x%02x 0x%08x\n",drv_name,g_cmd[0], cr_readb(sdport->base_io+SD_TRANSFER), cr_readb(sdport->base_io+SD_STATUS1), cr_readb(sdport->base_io+SD_STATUS2), cr_readb(sdport->base_io+SD_BUS_STATUS),cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3),cr_readl(sdport->base_io+EMMC_DMA_CTL3));
+                        return err;
+                }
+            }
+    return err;
+}
+EXPORT_SYMBOL_GPL(rtkcr_wait_opt_end);
+
+int rtk_int_enable_and_waitfor(struct rtksd_host *sdport, u8 cmdcode, u8 cmd_idx, unsigned long msec, unsigned long dma_msec)
+{
+    unsigned long timeend=0;
+
+    sdport->int_status  = 0;
+    sdport->sd_trans    = -1;
+    sdport->sd_status1   = 0;
+    sdport->sd_status2   = 0;
+    sdport->bus_status   = 0;
+    sdport->dma_trans   = 0;
+
+    #ifndef ENABLE_EMMC_INT_MODE
+    sdport->int_waiting = NULL;
+    #else
+    sdport->int_waiting = &rtk_emmc_wait;
+    MMCPRINTF("rtk wait complete addr = %08x\n", (unsigned int) sdport->int_waiting);
+    /* timeout timer fire */
+    if (&sdport->timer)
+    {
+        MMCPRINTF("timer started : ");
+        #if 0
+        if(sdport->tmout){
+            timeend = sdport->tmout;
+            sdport->tmout = 0;
+        }else
+        #endif
+            timeend = msecs_to_jiffies(msec)+sdport->tmout;
+
+        MMCPRINTF("TO = 0x%08x\n", timeend);
+        MMCPRINTF("remove mod_timer temply\n", timeend);
+        mod_timer(&sdport->timer, (jiffies + timeend) );
+    }
+
+    //wait for ^M
+    #endif
+
+    if ((cmdcode == 25)&&(cr_readl(sdport->base_io+EMMC_DMA_CTL3)&0x2))
+    {
+        printk("cmd=25 but read direct ..........->\n");
+    }
+
+    rtk_int_waitfor(sdport,cmdcode,cmd_idx,msec,dma_msec);
+    smp_wmb();
+    sync();
+
+    if (sdport->sd_trans & ERR_STATUS) //transfer error
+    {
+        //printk(KERN_ERR "cmd:0x%02x, bTuning:0x%02x,status1:0x%02x\n",cmd_idx,g_bTuning,cr_readb(sdport->base_io+SD_STATUS1));
+        if (g_bTuning&&(cmd_idx == MMC_WRITE_MULTIPLE_BLOCK)&&((cr_readb(sdport->base_io+SD_STATUS1)==CRC7_STATUS)||(cr_readb(sdport->base_io+SD_STATUS1)==CRC7_STATUS|0x8)))
+        {
+                printk(KERN_ERR "\nignore cmd25 crc7 error \n");
+                return CR_TRANSFER_IGN;
+        }
+        else
+        {
+                if (!g_bTuning)
+                {
+                        printk(" trans err : register settings(base=0x%08x,0x%08x,cmd=%02x)\n", sdport->base_io, sdport->base_io+SD_CMD0,cmd_idx);
+                        printk(" cmd0:0x%02x cmd1:0x%02x cmd2:0x%02x cmd3:0x%02x cmd4:0x%02x cmd5:0x%02x\n",cr_readb(sdport->base_io+SD_CMD0),cr_readb(sdport->base_io+SD_CMD1),cr_readb(sdport->base_io+SD_CMD2),cr_readb(sdport->base_io+SD_CMD3),cr_readb(sdport->base_io+SD_CMD4),cr_readb(sdport->base_io+SD_CMD5));
+                        printk(" trans:0x%02x status1:0x%02x status2:0x%02x bus_status:0x%02x\n",cr_readb(sdport->base_io+SD_TRANSFER),cr_readb(sdport->base_io+SD_STATUS1),cr_readb(sdport->base_io+SD_STATUS2),cr_readb(sdport->base_io+SD_BUS_STATUS));
+                        printk(" configure1:0x%02x configure2:0x%02x configure3:0x%02x\n",cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3));
+                        printk(" byteH:0x%02x byteL:0x%02x blkH:0x%02x blkL:0x%02x\n",cr_readb(sdport->base_io+SD_BYTE_CNT_H),cr_readb(sdport->base_io+SD_BYTE_CNT_L),cr_readb(sdport->base_io+SD_BLOCK_CNT_H),cr_readb(sdport->base_io+SD_BLOCK_CNT_L));
+                        printk(" CPU_ACC:0x%08x dma_ctl1:0x%08x dma_ctl2:0x%08x dma_ctl3:0x%08x\n",cr_readl(sdport->base_io+EMMC_CPU_ACC),cr_readl(sdport->base_io+CR_DMA_CTL1),cr_readl(sdport->base_io+CR_DMA_CTL2),cr_readl(sdport->base_io+EMMC_DMA_CTL3));
+                }
+        }
+        return CR_TRANSFER_FAIL;
+    }
+    if (((sdport->sd_trans & (END_STATE|IDLE_STATE)) != (END_STATE|IDLE_STATE))&&(g_bTuning)) //transfer error
+    {
+        if (!g_bTuning)
+        {
+        printk(" trans to : register settings(base=0x%08x,0x%08x,cmd=0x%02x)\n", sdport->base_io, sdport->base_io+SD_CMD0,cmd_idx);
+        printk(" cmd0:0x%02x cmd1:0x%02x cmd2:0x%02x cmd3:0x%02x cmd4:0x%02x cmd5:0x%02x\n",cr_readb(sdport->base_io+SD_CMD0),cr_readb(sdport->base_io+SD_CMD1),cr_readb(sdport->base_io+SD_CMD2),cr_readb(sdport->base_io+SD_CMD3),cr_readb(sdport->base_io+SD_CMD4),cr_readb(sdport->base_io+SD_CMD5));
+        printk(" trans:0x%02x status1:0x%02x status2:0x%02x bus_status:0x%02x\n",cr_readb(sdport->base_io+SD_TRANSFER),cr_readb(sdport->base_io+SD_STATUS1),cr_readb(sdport->base_io+SD_STATUS2),cr_readb(sdport->base_io+SD_BUS_STATUS));
+        printk(" configure1:0x%02x configure2:0x%02x configure3:0x%02x\n",cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3));
+        printk(" byteH:0x%02x byteL:0x%02x blkH:0x%02x blkL:0x%02x\n",cr_readb(sdport->base_io+SD_BYTE_CNT_H),cr_readb(sdport->base_io+SD_BYTE_CNT_L),cr_readb(sdport->base_io+SD_BLOCK_CNT_H),cr_readb(sdport->base_io+SD_BLOCK_CNT_L));
+        printk(" CPU_ACC:0x%08x dma_ctl1:0x%08x dma_ctl2:0x%08x dma_ctl3:0x%08x\n",cr_readl(sdport->base_io+EMMC_CPU_ACC),cr_readl(sdport->base_io+CR_DMA_CTL1),cr_readl(sdport->base_io+CR_DMA_CTL2),cr_readl(sdport->base_io+EMMC_DMA_CTL3));
+        }
+        return CR_TRANSFER_FAIL;
+    }
+    return 0;
+}
+EXPORT_SYMBOL_GPL(rtk_int_enable_and_waitfor);
+
+void rtk_int_waitfor(struct rtksd_host *sdport, u8 cmdcode, u8 cmd_idx, unsigned long msec,unsigned long dma_msec)
+{
+    #ifndef ENABLE_EMMC_INT_MODE
+    unsigned long timeend=0;
+    u32 sd_trans=0,sd_status1=0,sd_status2=0,bus_status=0,dma_trans=0;
+    unsigned long flags;
+
+    spin_lock_irqsave(&sdport->lock,flags);
+
+    if(sdport->rtflags & RTKCR_FOPEN_LOG){
+        MMCPRINTF(" rtkemmc : register settings(base=0x%08x,0x%08x)\n", sdport->base_io, sdport->base_io+SD_CMD0);
+        MMCPRINTF(" cmd0:0x%02x cmd1:0x%02x cmd2:0x%02x cmd3:0x%02x cmd4:0x%02x cmd5:0x%02x\n",cr_readb(sdport->base_io+SD_CMD0),cr_readb(sdport->base_io+SD_CMD1),cr_readb(sdport->base_io+SD_CMD2),cr_readb(sdport->base_io+SD_CMD3),cr_readb(sdport->base_io+SD_CMD4),cr_readb(sdport->base_io+SD_CMD5));
+        MMCPRINTF(" trans:0x%02x status1:0x%02x status2:0x%02x bus_status:0x%02x\n",cr_readb(sdport->base_io+SD_TRANSFER),cr_readb(sdport->base_io+SD_STATUS1),cr_readb(sdport->base_io+SD_STATUS2),cr_readb(sdport->base_io+SD_BUS_STATUS));
+        MMCPRINTF(" configure1:0x%02x configure2:0x%02x configure3:0x%02x\n",cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3));
+        MMCPRINTF(" byteH:0x%02x byteL:0x%02x blkH:0x%02x blkL:0x%02x\n",cr_readb(sdport->base_io+SD_BYTE_CNT_H),cr_readb(sdport->base_io+SD_BYTE_CNT_L),cr_readb(sdport->base_io+SD_BLOCK_CNT_H),cr_readb(sdport->base_io+SD_BLOCK_CNT_L));
+        MMCPRINTF(" CPU_ACC:0x%08x dma_ctl1:0x%08x dma_ctl2:0x%08x dma_ctl3:0x%08x\n",cr_readl(sdport->base_io+EMMC_CPU_ACC),cr_readl(sdport->base_io+CR_DMA_CTL1),cr_readl(sdport->base_io+CR_DMA_CTL2),cr_readl(sdport->base_io+EMMC_DMA_CTL3));
+        MMCPRINTF(" card_pad_drv:0x%08x cmd_pad_drv:0x%08x data_pad_drv:0x%08x EMMC_CKGEN_CTL:0x%08x, SYS_PLL_EMMC3=0x%08x\n",cr_readb(sdport->base_io+EMMC_CARD_PAD_DRV),cr_readb(sdport->base_io+EMMC_CMD_PAD_DRV),cr_readb(sdport->base_io+EMMC_DATA_PAD_DRV),cr_readl(sdport->base_io+EMMC_CKGEN_CTL),cr_readl(SYS_PLL_EMMC3));
+    }
+
+    //cmd fire
+    #ifdef MMC_DBG
+    sd_reg = cr_readb(sdport->base_io+SD_CMD0);
+    #endif
+    sync();
+    cr_writeb((u8) (cmdcode|START_EN), sdport->base_io+SD_TRANSFER );
+    sync();
+
+    timeend = jiffies + msecs_to_jiffies(msec);
+
+    while(time_before(jiffies, timeend))
+    {
+        if ((cr_readb(sdport->base_io+SD_TRANSFER) & (END_STATE|IDLE_STATE))==(END_STATE|IDLE_STATE))
+            break;
+        if ((cr_readb(sdport->base_io+SD_TRANSFER) & ERR_STATUS)==(ERR_STATUS))
+            break;
+    }
+
+    if (dma_msec>0)
+    {
+        timeend = jiffies + msecs_to_jiffies(dma_msec);
+        while(time_before(jiffies, timeend))
+        {
+                sync();
+                if ((cr_readl(sdport->base_io+EMMC_DMA_CTL3) & DMA_XFER)!=(DMA_XFER))
+                        break;
+        }
+        rtkcr_get_dma_trans(sdport->base_io,&dma_trans);
+        sync();
+        sdport->dma_trans    = dma_trans;
+    }
+    MMCPRINTF("exit from polling\n");
+
+    rtkcr_get_sd_trans(sdport->base_io,&sd_trans);
+    rtkcr_get_sd_sta(sdport->base_io,&sd_status1,&sd_status2,&bus_status);
+
+    sdport->sd_trans    = sd_trans;
+    sdport->sd_status1   = sd_status1;
+    sdport->sd_status2   = sd_status2;
+    sdport->bus_status   = bus_status;
+    MMCPRINTF("int sts : 0x%08x sd_trans : 0x%08x, sd_st1 : 0x%08x\n", sdport->int_status, sdport->sd_trans, sdport->sd_status1);
+    MMCPRINTF("int st2 : 0x%08x bus_sts : 0x%08x dma_trans : 0x%08x\n", sdport->sd_status2, sdport->bus_status, sdport->dma_trans);
+    spin_unlock_irqrestore(&sdport->lock,flags);
+    #else
+    sync();
+    if(sdport->rtflags & RTKCR_FOPEN_LOG){
+        printk(" rtkemmc : register settings(base=0x%08x,0x%02x)\n", sdport->base_io, cr_readb(sdport->base_io+SD_CMD0));
+        printk(" cmd0:0x%02x cmd1:0x%02x cmd2:0x%02x cmd3:0x%02x cmd4:0x%02x cmd5:0x%02x\n",cr_readb(sdport->base_io+SD_CMD0),cr_readb(sdport->base_io+SD_CMD1),cr_readb(sdport->base_io+SD_CMD2),cr_readb(sdport->base_io+SD_CMD3),cr_readb(sdport->base_io+SD_CMD4),cr_readb(sdport->base_io+SD_CMD5));
+        printk(" trans:0x%02x status1:0x%02x status2:0x%02x bus_status:0x%02x\n",cr_readb(sdport->base_io+SD_TRANSFER),cr_readb(sdport->base_io+SD_STATUS1),cr_readb(sdport->base_io+SD_STATUS2),cr_readb(sdport->base_io+SD_BUS_STATUS));
+        printk(" configure1:0x%02x configure2:0x%02x configure3:0x%02x\n",cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3));
+        printk(" byteH:0x%02x byteL:0x%02x blkH:0x%02x blkL:0x%02x\n",cr_readb(sdport->base_io+SD_BYTE_CNT_H),cr_readb(sdport->base_io+SD_BYTE_CNT_L),cr_readb(sdport->base_io+SD_BLOCK_CNT_H),cr_readb(sdport->base_io+SD_BLOCK_CNT_L));
+        printk(" CPU_ACC:0x%08x dma_ctl1:0x%08x dma_ctl2:0x%08x dma_ctl3:0x%08x sample_ctl:0x%08x pull_ctl:0x%08x\n",cr_readl(sdport->base_io+EMMC_CPU_ACC),cr_readl(sdport->base_io+CR_DMA_CTL1),cr_readl(sdport->base_io+CR_DMA_CTL2),cr_readl(sdport->base_io+EMMC_DMA_CTL3),cr_readb(sdport->base_io+SD_SAMPLE_POINT_CTL),cr_readb(sdport->base_io+SD_PUSH_POINT_CTL));
+        printk(" card_pad_drv:0x%08x cmd_pad_drv:0x%08x data_pad_drv:0x%08x EMMC_CKGEN_CTL:0x%08x, SYS_PLL_EMMC3=0x%08x\n",cr_readb(sdport->base_io+EMMC_CARD_PAD_DRV),cr_readb(sdport->base_io+EMMC_CMD_PAD_DRV),cr_readb(sdport->base_io+EMMC_DATA_PAD_DRV),cr_readl(sdport->base_io+EMMC_CKGEN_CTL),cr_readl(SYS_PLL_EMMC3));
+    }
+
+    #ifdef MMC_DBG
+    printk(" --> cmd:%02x status1:0x%02x status2:0x%02x bus_status:0x%02x byteH:0x%02x byteL:0x%02x blkH:0x%02x blkL:0x%02x\n",cmd_idx, cr_readb(sdport->base_io+SD_STATUS1),cr_readb(sdport->base_io+SD_STATUS2),cr_readb(sdport->base_io+SD_BUS_STATUS),cr_readb(sdport->base_io+SD_BYTE_CNT_H),cr_readb(sdport->base_io+SD_BYTE_CNT_L),cr_readb(sdport->base_io+SD_BLOCK_CNT_H),cr_readb(sdport->base_io+SD_BLOCK_CNT_L));
+    printk(" --> dma_ctl1:0x%08x dma_ctl2:0x%08x dma_ctl3:0x%08x\n",cr_readl(sdport->base_io+CR_DMA_CTL1),cr_readl(sdport->base_io+CR_DMA_CTL2),cr_readl(sdport->base_io+EMMC_DMA_CTL3));^M
+    #endif
+
+    if (sdport->int_waiting)
+    {
+        #ifdef MMC_DBG
+        sd_reg = cr_readb(sdport->base_io+SD_CMD0);
+        MMCPRINTF("========== S(0x%02x) ==========\n", sd_reg);
+        #endif
+        rtkcr_hold_int_dec(sdport->base_io);
+        rtkcr_clr_int_sta(sdport->base_io);
+        rtkcr_en_int(sdport->base_io);
+        rtkcr_clr_int_sta(sdport->base_io);
+
+        sync();
+        cr_writeb((u8) (cmdcode|START_EN), sdport->base_io+SD_TRANSFER );
+        sync();
+
+        MMCPRINTF("do wait for 1\n");
+        wait_for_completion(sdport->int_waiting);
+        sync();
+        sync();
+        MMCPRINTF("do wait for 2\n");
+    }
+    #endif
+}
+EXPORT_SYMBOL_GPL(rtk_int_waitfor);
+
+void rtk_op_complete(struct rtksd_host *sdport)
+{
+    if (sdport->int_waiting) {
+        MMCPRINTF("int wait complete 1\n");
+        MMCPRINTF("1 rtk wait complete addr = %08x\n", (unsigned int) sdport->int_waiting);
+        struct completion *waiting = sdport->int_waiting;
+        //sdport->int_waiting = NULL;
+        complete(waiting);
+        MMCPRINTF("========== D ==========\n");
+        sync();
+        MMCPRINTF("int wait complete 2\n");
+    }
+    else
+        MMCPRINTF("int wait not complete\n");
+}
+EXPORT_SYMBOL_GPL(rtk_op_complete);
+
+char *rtkcr_parse_token(const char *parsed_string, const char *token)
+{
+    const char *ptr = parsed_string;
+    const char *start, *end, *value_start, *value_end;
+    char *ret_str;
+
+    while(1) {
+        value_start = value_end = 0;
+        for(;*ptr == ' ' || *ptr == '\t'; ptr++);
+        if(*ptr == '\0')        break;
+        start = ptr;
+        for(;*ptr != ' ' && *ptr != '\t' && *ptr != '=' && *ptr != '\0'; ptr++) ;
+        end = ptr;
+        if(*ptr == '=') {
+            ptr++;
+            if(*ptr == '"') {
+                ptr++;
+                value_start = ptr;
+                for(; *ptr != '"' && *ptr != '\0'; ptr++);
+                if(*ptr != '"' || (*(ptr+1) != '\0' && *(ptr+1) != ' ' && *(ptr+1) != '\t')) {
+                    printk("system_parameters error! Check your parameters     .");
+                    break;
+                }
+            } else {
+                value_start = ptr;
+                for(;*ptr != ' ' && *ptr != '\t' && *ptr != '\0' && *ptr != '"'; ptr++) ;
+                if(*ptr == '"') {
+                    printk("system_parameters error! Check your parameters.");
+                    break;
+                }
+            }
+            value_end = ptr;
+        }
+
+        if(!strncmp(token, start, end-start)) {
+            if(value_start) {
+                ret_str = kmalloc(value_end-value_start+1, GFP_KERNEL);
+                // KWarning: checked ok by alexkh@realtek.com
+                if(ret_str){
+                    strncpy(ret_str, value_start, value_end-value_start);
+                    ret_str[value_end-value_start] = '\0';
+                }
+                return ret_str;
+            } else {
+                ret_str = kmalloc(1, GFP_KERNEL);
+                // KWarning: checked ok by alexkh@realtek.com
+                if(ret_str)
+                    strcpy(ret_str, "");
+                return ret_str;
+            }
+        }
+    }
+
+    return (char*)NULL;
+}
+EXPORT_SYMBOL_GPL(rtkcr_parse_token);
+
+void rtkcr_chk_param(u32 *pparam, u32 len, u8 *ptr)
+{
+    u32 value,i;
+    mmcrtk("\n");
+
+    *pparam = 0;
+    for(i=0;i<len;i++){
+        value = ptr[i] - '0';
+        // KWarning: checked ok by alexkh@realtek.com
+        if((value >= 0) && (value <=9))
+        {
+            *pparam+=value<<(4*(len-1-i));
+            continue;
+        }
+
+        value = ptr[i] - 'a';
+        // KWarning: checked ok by alexkh@realtek.com
+        if((value >= 0) && (value <=5))
+        {
+            value+=10;
+            *pparam+=value<<(4*(len-1-i));
+            continue;
+        }
+
+        value = ptr[i] - 'A';
+        // KWarning: checked ok by alexkh@realtek.com
+        if((value >= 0) && (value <=5))
+        {
+            value+=10;
+            *pparam+=value<<(4*(len-1-i));
+            continue;
+        }
+    }
+}
+EXPORT_SYMBOL_GPL(rtkcr_chk_param);
+
+u32 verA_magic_num = 0;
+int rtkcr_chk_VerA(void)
+{
+    mmcrtk("\n");
+//TODO : chk
+#if 0 
+    if(!verA_magic_num)
+        verA_magic_num = cr_readl(0xb8060000);
+
+    if(verA_magic_num == 0x62270000){
+        return 1;
+    }else{
+        return 0;
+    }
+#else
+    return verA_magic_num; //0: polling, 1: interrupt
+#endif
+}
+EXPORT_SYMBOL_GPL(rtkcr_chk_VerA);
+
+void emmc_show_config123(struct rtksd_host *sdport){
+    u32 reginfo;
+    u32 clksel_sht;
+    u32 iobase = sdport->base_io;
+
+    if(iobase == EM_BASE_ADDR){
+        reginfo = cr_readl(iobase+EMMC_CKGEN_CTL);
+        //clksel_sht = EMMC_CLKSEL_SHT;
+    }else if(iobase == CR_BASE_ADDR){
+        reginfo = cr_readl(iobase+CR_SD_CKGEN_CTL);
+        //clksel_sht = SD_CLKSEL_SHT;
+    }
+
+    printk("CFG1=0x%x CFG2=0x%x CFG3=0x%x bus clock CKGEN=%08x\n",
+        cr_readb(iobase+SD_CONFIGURE1),
+        cr_readb(iobase+SD_CONFIGURE2),
+        cr_readb(iobase+SD_CONFIGURE3),
+        reginfo );
+}
+EXPORT_SYMBOL_GPL(emmc_show_config123);
+//#######################################################################################################################################
+static void rtksd_hold_card(struct rtksd_host *sdport)
+{
+    u32 iobase = sdport->base_io;
+    u32 loop = 1000;
+
+    printk(KERN_ERR "%s(%u)",__func__,__LINE__);
+
+    while(loop--){
+        //printk(KERN_ERR "wait eMMC END_STATE!!!\n");
+        if (cr_readb(iobase+SD_TRANSFER) & END_STATE)
+            break;
+        rtkcr_mdelay(1);
+    }
+
+    //TBD, chk if we need to do sth related to CR GPIO
+    #if 0
+    //pull low 10us eMMC reset
+    rtkcr_set_mis_gpio(20,GPIO_OUT,GPIO_LOW);
+
+	//keep DATA[7:0] floating
+	rtkcr_set_mis_gpio(16,GPIO_IN,GPIO_LOW);
+	rtkcr_set_mis_gpio(17,GPIO_IN,GPIO_LOW);
+	rtkcr_set_mis_gpio(18,GPIO_IN,GPIO_LOW);
+	rtkcr_set_mis_gpio(21,GPIO_IN,GPIO_LOW);
+	rtkcr_set_mis_gpio(22,GPIO_IN,GPIO_LOW);
+	rtkcr_set_mis_gpio(23,GPIO_IN,GPIO_LOW);
+	rtkcr_set_mis_gpio(24,GPIO_IN,GPIO_LOW);
+	rtkcr_set_mis_gpio(25,GPIO_IN,GPIO_LOW);
+
+	//hold eMMC CMD high
+	rtkcr_set_mis_gpio(7,GPIO_OUT,GPIO_HIGH);
+
+	rtkcr_mdelay(1);
+    //hold eMMC clock high
+    rtkcr_set_mis_gpio(19,GPIO_OUT,GPIO_HIGH);
+
+	rtkcr_mdelay(1);
+    //pull high eMMC reset and keep
+    rtkcr_set_mis_gpio(20,GPIO_OUT,GPIO_HIGH);
+    #endif
+}
+
+static void rtkemmc_set_crt_muxpad(struct rtksd_host *sdport)
+{
+    u32 reg_val=0;
+    
+    MMCPRINTF("\n");
+
+    //set default i/f to cr
+    reg_val = cr_readl(SYS_muxpad0);
+    reg_val &= ~0xFFFF0FFF;
+    reg_val |= 0xaaaa0aa8;
+    cr_writel(reg_val,SYS_muxpad0);
+   
+    if (soc_is_rtk1195() && (realtek_rev() >= RTK1195_REV_B))
+    {
+	cr_writel(0xe0003, PLL_EMMC1); //LDO1.8v
+	cr_writel(0x0, CR_PAD_CTL); //PAD to 1.8v
+	printk(KERN_INFO "detect 1195 >= REV_B \n");
+    }
+}
+
+u32 swap_endian(u32 input)
+{
+        u32 output;
+        output = (input & 0xff000000)>>24|
+                         (input & 0x00ff0000)>>8|
+                         (input & 0x0000ff00)<<8|
+                         (input & 0x000000ff)<<24;
+        return output;
+}
+
+/*
+ * card power have ON/OFF item.
+ * if want to power on card,the rtksd_host is necessary.
+ * but power off is always working, no matter rtksd_host wether exist.
+ */
+//static void rtkcr_card_power(struct rtksd_host *sdport,u8 status)
+//{
+//    /* nothing to do for eMMC */
+//}
+
+static void rtksd_read_rsp(struct rtksd_host *sdport,u32 *rsp, int reg_count)
+{
+    u32 iobase = sdport->base_io;
+
+    MMCPRINTF("rsp addr=0x%p; reg_count=%u\n", rsp, reg_count);
+
+    if ( reg_count==6 ){
+	rsp[0] = rsp[1] = 0;
+        rsp[0] = cr_readb(iobase+SD_CMD1) << 24 |
+                 cr_readb(iobase+SD_CMD2) << 16 |
+                 cr_readb(iobase+SD_CMD3) << 8 |
+                 cr_readb(iobase+SD_CMD4);
+        //rsp[1] = cr_readb(iobase+SD_CMD4) << 24 |
+        //         cr_readb(iobase+SD_CMD5) << 16;
+        MMCPRINTF("rsp[0]=0x%08x, rsp[1]=0x%08x\n",rsp[0],rsp[1]);
+
+    }else if(reg_count==16){
+        rsp[0] = swap_endian(rsp[0]);
+        rsp[1] = swap_endian(rsp[1]);
+        rsp[2] = swap_endian(rsp[2]);
+        rsp[3] = swap_endian(rsp[3]);
+        MMCPRINTF("rsp[0]=0x%08x, rsp[1]=0x%08x, rsp[2]=0x%08x, rsp[3]=0x%08x\n",rsp[0],rsp[1],rsp[2],rsp[3]);
+    }
+    else
+        MMCPRINTF("rsp[0]=0x%08x\n",rsp[0]);
+}
+
+/*******************************************************
+ *  *
+ *   *******************************************************/
+static void rtkcr_set_mode_selection( struct rtksd_host *sdport, unsigned int set_bit )
+{
+	u32 iobase = sdport->base_io;
+	unsigned int tmp_bits;
+	unsigned long flags;
+	MMCPRINTF("%s - start\n", __func__);
+	MMCPRINTF("mmccr_set_mode_selection; switch to 0x%08x\n",set_bit);
+	spin_lock_irqsave(&sdport->lock,flags);
+	tmp_bits = cr_readb(iobase+SD_CONFIGURE1) & ~MASK_MODE_SELECT;
+	cr_writeb((unsigned char)(tmp_bits|set_bit),iobase+SD_CONFIGURE1);
+	sync();
+	spin_unlock_irqrestore(&sdport->lock, flags);
+	MMCPRINTF(KERN_INFO "%s: set mode to 0x%02x, 0x18012180=%02x,0x18012181=0x%02x,0x18012182=0x%02x\n",
+		DRIVER_NAME, tmp_bits|set_bit, cr_readb(iobase+SD_CONFIGURE1),cr_readb(iobase+SD_CONFIGURE2),cr_readb(iobase+SD_CONFIGURE3));
+}
+static int rtkcr_get_mode_selection(struct rtksd_host *sdport)
+{
+	u32 iobase = sdport->base_io;
+	int tmp_bits;
+	unsigned long flags;
+
+	MMCPRINTF("%s - start\n", __func__);
+	spin_lock_irqsave(&sdport->lock,flags);
+	tmp_bits = cr_readb(iobase+SD_CONFIGURE1) & MASK_MODE_SELECT;
+	sync();
+	spin_unlock_irqrestore(&sdport->lock, flags);
+	MMCPRINTF("mmccr_set_mode_selection; switch to 0x%08x\n",tmp_bits);
+	return tmp_bits;
+}
+
+static void rtkcr_set_ldo(struct rtksd_host *sdport, u32 set_ldo)
+{
+	u32 iobase = sdport->base_io;
+	u32 tmp_val=0;
+	unsigned long flags;
+
+	spin_lock_irqsave(&sdport->lock,flags);
+	tmp_val = (cr_readl(SYS_PLL_EMMC3) & 0xffff)|(set_ldo<<16);
+	cr_writel(tmp_val, SYS_PLL_EMMC3);
+	sync();
+	spin_unlock_irqrestore(&sdport->lock, flags);
+
+	MMCPRINTF(KERN_INFO "%s: set ldo to 0x%02x, PLL_EMM3 - 0x180001f8=%08x\n",
+		DRIVER_NAME, tmp_val, cr_readl(SYS_PLL_EMMC3));
+}
+
+void rtkcr_set_pad_driving(struct rtksd_host *sdport,unsigned int mode, unsigned char CLOCK_DRIVING, unsigned char CMD_DRIVING, unsigned char DATA_DRIVING)
+{
+    static unsigned char card_pad_val=0,cmd_pad_val=0,data_pad_val=0;
+
+    switch(mode)
+    {
+	case MMC_IOS_GET_PAD_DRV:
+		card_pad_val = cr_readb(sdport->base_io+EMMC_CARD_PAD_DRV);
+		cmd_pad_val = cr_readb(sdport->base_io+EMMC_CMD_PAD_DRV);
+		data_pad_val = cr_readb(sdport->base_io+EMMC_DATA_PAD_DRV);
+    		MMCPRINTF("backup card=0x%02x, cmd=0x%02x, data=0x%02x\n", card_pad_val, cmd_pad_val,data_pad_val);
+    		MMCPRINTF("read : card=0x%02x, cmd=0x%02x, data=0x%02x\n", cr_readb(sdport->base_io+EMMC_CARD_PAD_DRV), cr_readb(sdport->base_io+EMMC_CMD_PAD_DRV),cr_readb(sdport->base_io+EMMC_DATA_PAD_DRV));
+		break;
+	case MMC_IOS_SET_PAD_DRV:
+    		cr_writeb(CLOCK_DRIVING, sdport->base_io+EMMC_CARD_PAD_DRV); //clock pad driving
+    		cr_writeb(CMD_DRIVING, sdport->base_io+EMMC_CMD_PAD_DRV);   //cmd pad driving
+    		cr_writeb(DATA_DRIVING, sdport->base_io+EMMC_DATA_PAD_DRV);  //data pads driving
+    		sync();
+    		sync();
+    		sync();
+    		MMCPRINTF("set card=0x%02x, cmd=0x%02x, data=0x%02x\n", cr_readb(sdport->base_io+EMMC_CARD_PAD_DRV), cr_readb(sdport->base_io+EMMC_CMD_PAD_DRV),cr_readb(sdport->base_io+EMMC_DATA_PAD_DRV));
+		break;
+	case MMC_IOS_RESTORE_PAD_DRV:
+    		cr_writeb(card_pad_val, sdport->base_io+EMMC_CARD_PAD_DRV); //clock pad driving
+    		cr_writeb(cmd_pad_val, sdport->base_io+EMMC_CMD_PAD_DRV);   //cmd pad driving
+    		cr_writeb(data_pad_val, sdport->base_io+EMMC_DATA_PAD_DRV);  //data pads driving
+    		sync();
+    		sync();
+    		MMCPRINTF("val card=0x%02x, cmd=0x%02x, data=0x%02x\n", card_pad_val, cmd_pad_val,data_pad_val);
+    		MMCPRINTF("restore card=0x%02x, cmd=0x%02x, data=0x%02x\n", cr_readb(sdport->base_io+EMMC_CARD_PAD_DRV), cr_readb(sdport->base_io+EMMC_CMD_PAD_DRV),cr_readb(sdport->base_io+EMMC_DATA_PAD_DRV));
+		break;
+    }
+    sync();
+    sync();
+}
+
+static void rtkcr_set_div(struct rtksd_host *sdport,u32 set_div)
+{
+	u32 iobase = sdport->base_io;
+	u32 tmp_div;
+	unsigned long flags;
+
+	spin_lock_irqsave(&sdport->lock,flags);
+	tmp_div = cr_readb(iobase+SD_CONFIGURE1) & ~MASK_CLOCK_DIV;
+	cr_writeb(tmp_div|set_div, iobase+SD_CONFIGURE1);
+	sync();
+	spin_unlock_irqrestore(&sdport->lock, flags);
+
+	MMCPRINTF(KERN_INFO "%s: set div to 0x%02x, 0x18012180=%08x\n",
+		DRIVER_NAME, tmp_div|set_div, cr_readb(iobase+SD_CONFIGURE1));
+}
+
+static void rtksd_set_bits(struct rtksd_host *sdport,u8 set_bit)
+{
+	u32 iobase = sdport->base_io;
+	u32 tmp_bits;
+	unsigned long flags;
+
+	spin_lock_irqsave(&sdport->lock,flags);
+	tmp_bits = cr_readb(iobase+SD_CONFIGURE1);
+	if((tmp_bits & MASK_BUS_WIDTH) != set_bit ){
+		tmp_bits &= ~MASK_BUS_WIDTH;
+		MMCPRINTF("tmp_bits=0x%02x, set_bit=0x%02x\n",tmp_bits,set_bit);
+		cr_writeb(tmp_bits|set_bit,iobase+SD_CONFIGURE1);
+	}
+	sync();
+	spin_unlock_irqrestore(&sdport->lock, flags);
+	MMCPRINTF(KERN_INFO "%s: change to %s mode, 0x18012180=%08x\n",
+		DRIVER_NAME,bit_tlb[set_bit], cr_readb(iobase+SD_CONFIGURE1));
+}
+
+static void rtkcr_set_speed(struct rtksd_host *sdport,u8 level)
+{
+	u32 iobase = sdport->base_io;
+	u32 tmp_para;
+	unsigned long flags;
+
+	MMCPRINTF("\n");
+	spin_lock_irqsave(&sdport->lock,flags);
+//    cr_writeb(0x66,iobase+EMMC_CARD_PAD_DRV);
+//    cr_writeb(0x64,iobase+EMMC_CMD_PAD_DRV);
+//    cr_writeb(0x66,iobase+EMMC_DATA_PAD_DRV);
+
+    //cr_writel(0x40,iobase+SD_SAMPLE_POINT_CTL); //3.3v , fixed 1/4
+    
+	switch(level)
+	{
+        case 0:  //ddr52 , highest speed
+            cr_writel(0x2100,iobase+EMMC_CKGEN_CTL);
+            break;
+        case 1:
+            cr_writel(0x2101,iobase+EMMC_CKGEN_CTL);
+            break;
+        case 2:
+        default :
+            cr_writel(0x2102,iobase+EMMC_CKGEN_CTL);
+            break;          
+	}
+	sync();
+	MMCPRINTF(KERN_INFO "%s: change speed level to %d\n", DRIVER_NAME,level);
+	spin_unlock_irqrestore(&sdport->lock, flags);
+}
+
+static void rtkemmc_bus_speed_down(struct rtksd_host *sdport)
+{
+	cr_writeb( 0x8,  sdport->base_io+SD_SAMPLE_POINT_CTL );    //sample point = SDCLK / 4
+	cr_writeb( 0x10, sdport->base_io+SD_PUSH_POINT_CTL );     //output ahead SDCLK /4 
+}
+
+u8 rtksd_get_rsp_len(u8 rsp_para)
+{
+    MMCPRINTF("\n");
+    switch (rsp_para & 0x3) {
+    case 0:
+        return 0;
+    case 1:
+        return 6;
+    case 2:
+        return 16;
+    default:
+        return 0;
+    }
+}
+
+static u32 rtksd_get_cmd_timeout(struct sd_cmd_pkt *cmd_info)
+{
+    struct rtksd_host *sdport   = cmd_info->sdport;
+    u16 block_count             = cmd_info->block_count;
+    u32 tmout = 0;
+
+    MMCPRINTF("\n");
+    if(cmd_info->cmd->data)
+    {
+        tmout = msecs_to_jiffies(200);
+        if(block_count>0x100)
+        {
+            tmout = tmout + msecs_to_jiffies(block_count>>1);
+        }
+    }
+    else
+        tmout = msecs_to_jiffies(80);
+
+#ifdef CONFIG_ANDROID
+    tmout += msecs_to_jiffies(100);
+#endif
+
+    cmd_info->timeout = sdport->tmout = tmout;
+    return 0;
+}
+
+#define SD_ALLOC_LENGTH     2048
+static int rtksd_allocate_dma_buf(struct rtksd_host *sdport, struct mmc_command *cmd)
+{
+    extern unsigned char* pPSP;
+    if (!pRSP)
+        pRSP_org = pRSP = dma_alloc_coherent(sdport->dev, SD_ALLOC_LENGTH, &sdport->paddr ,GFP_KERNEL);
+    else
+        return 0;
+
+    if(!pRSP){
+        WARN_ON(1);
+        cmd->error = -ENOMEM;
+        return 0;
+    }    
+
+    MMCPRINTF("allocate rtk dma buf : dma addr=0x%08x, phy addr=0x%08x\n", pRSP, sdport->paddr);
+    return 1;
+}
+static int rtksd_free_dma_buf(struct rtksd_host *sdport)
+{    
+    if (pRSP_org)
+        dma_free_coherent(sdport->dev, SD_ALLOC_LENGTH, pRSP_org ,sdport->paddr);
+    else
+        return 0;
+
+    MMCPRINTF("free rtk dma buf \n");
+    return 1;
+}
+#if 0
+static int rtksd_get_next_block() {
+    if (pRSP_org)
+    {
+        if ((pRSP+0x200) >= (pRSP_org+SD_ALLOC_LENGTH))
+            pRSP = pRSP_org;
+        else
+            pRSP+=0x200;
+    }
+}
+#endif
+
+static int rtksd_get_buffer_start_addr(void){
+    if (pRSP_org)
+	return (int)pRSP_org;
+    else
+	return -1;
+}
+
+static int rtksd_set_rspparam(struct rtksd_host *sdport, struct sd_cmd_pkt *cmd_info)
+{
+    MMCPRINTF("rsp param reset : idx=0x%02x, sdport=0x%08x,cfg1=0x%02x,cfg2=0x%02x,cfg3=0x%02x\n", cmd_info->cmd->opcode,sdport,cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3));
+    volatile char rsp_para1=0, rsp_para2=0, rsp_para3=0;
+    unsigned char cfg3=0,cfg1=0;
+
+    rsp_para1 = 0;
+    rsp_para2 = 0;
+    rsp_para3 = 0;
+    cfg3 = cr_readb(sdport->base_io+SD_CONFIGURE3)|SD_CMD_RSP_TO;
+    cfg1 = cr_readb(sdport->base_io+SD_CONFIGURE1)&(MASK_CLOCK_DIV|MASK_BUS_WIDTH|MASK_MODE_SELECT);
+
+    //correct emmc setting for rt1195
+    switch(cmd_info->cmd->opcode)
+    {
+        case MMC_GO_IDLE_STATE:
+            cmd_info->rsp_para1 = cfg1|SD1_R0;
+            cmd_info->rsp_para2 = (IGN_WR_CRC_ERR_EN|CRC16_CAL_DIS)|SD_R0;
+            cmd_info->rsp_para3 = 0;
+            break;
+        case MMC_SEND_OP_COND:
+            cmd_info->rsp_para1 = cfg1|SD1_R0;
+            cmd_info->rsp_para2 = SD_R3|CRC7_CHK_DIS;
+            cmd_info->rsp_para3 = 0;
+	    if (soc_is_rtk1195() && (realtek_rev() >= RTK1195_REV_B))
+	    {
+            	cmd_info->cmd->arg = MMC_SECTOR_ADDR|MMC_VDD_165_195;
+	    }
+	    else
+	    {
+            	cmd_info->cmd->arg = MMC_VDD_30_31|MMC_VDD_31_32|MMC_VDD_32_33|MMC_VDD_33_34|MMC_SECTOR_ADDR; //sector mode
+	    }
+            break;
+        case MMC_ALL_SEND_CID:
+            cmd_info->rsp_para1 = cfg1|SD1_R0;
+            cmd_info->rsp_para2 = SD_R2;
+            cmd_info->rsp_para3 = SD2_R0;
+            break;
+        case MMC_SET_RELATIVE_ADDR:
+            cmd_info->rsp_para1 = cfg1|SD1_R0;
+            cmd_info->rsp_para2 = SD_R1|CRC16_CAL_DIS;
+            cmd_info->rsp_para3 = cfg3;
+            cmd_info->cmd->arg = 0x10000;
+            break;
+        case MMC_SEND_CSD:
+        case MMC_SEND_CID:
+            cmd_info->rsp_para1 = cfg1|SD1_R0;
+            cmd_info->rsp_para2 = SD_R2;
+            cmd_info->rsp_para3 = cfg3;
+            cmd_info->cmd->arg = 0x10000;
+            break;
+        case MMC_SEND_EXT_CSD:
+            cmd_info->rsp_para1 = cfg1|SD1_R0;
+            cmd_info->rsp_para2 = SD_R1;
+            cmd_info->rsp_para3 = cfg3;
+            break;
+        case MMC_SLEEP_AWAKE:
+            cmd_info->rsp_para1 = cfg1|SD1_R0;
+            cmd_info->rsp_para2 = SD_R1b;
+            cmd_info->rsp_para3 = SD_CMD_RSP_TO;
+            cmd_info->cmd->arg = cmd_info->cmd->arg;
+	    printk(KERN_INFO "%s : cmd5 arg=0x%08x\n",__func__,cmd_info->cmd->arg);
+            break;
+        case MMC_SELECT_CARD:
+            cmd_info->rsp_para1 = cfg1|SD1_R0;
+            cmd_info->cmd->arg = cmd_info->cmd->arg;
+	    if (cmd_info->cmd->flags == (MMC_RSP_NONE | MMC_CMD_AC))
+	    {
+		printk(KERN_INFO "%s : cmd7 with rsp none\n",__func__);
+            	cmd_info->rsp_para2 = RESP_TYPE_NON;
+	    }
+	    else
+	    {
+		printk(KERN_INFO "%s : cmd7 with rsp\n",__func__);
+            	cmd_info->rsp_para2 = SD_R1b|CRC16_CAL_DIS;
+	    }
+            cmd_info->rsp_para3 = -1;
+            break;
+        case MMC_SWITCH:
+            cmd_info->rsp_para1 = cfg1;
+            cmd_info->rsp_para2 = SD_R1|CRC16_CAL_DIS;
+            cmd_info->rsp_para3 = SD_CMD_RSP_TO;
+            break;
+        case MMC_SEND_STATUS:
+            cmd_info->rsp_para1 = -1;
+            cmd_info->rsp_para2 = SD_R1|CRC16_CAL_DIS;
+            cmd_info->rsp_para3 = SD_CMD_RSP_TO;
+            cmd_info->cmd->arg = 0x10000;
+            break;
+        case MMC_STOP_TRANSMISSION:
+            cmd_info->rsp_para1 = -1;
+            cmd_info->rsp_para2 = SD_R1|CRC16_CAL_DIS;
+            cmd_info->rsp_para3 = -1;
+            break;
+        case MMC_READ_MULTIPLE_BLOCK:
+            cmd_info->rsp_para1 = -1;
+            cmd_info->rsp_para3 = (SD_CMD_RSP_TO|ADDR_BYTE_MODE);
+            break;
+        case MMC_WRITE_MULTIPLE_BLOCK:
+            cmd_info->rsp_para1 = -1;
+            cmd_info->rsp_para3 = (SD_CMD_RSP_TO|ADDR_BYTE_MODE);
+            break;
+        default:
+            cmd_info->rsp_para1 = -1;     //don't update
+            cmd_info->rsp_para3 = -1;     //don't update
+            break;            
+    }    
+}
+
+static int SD_SendCMDGetRSP_Cmd(struct sd_cmd_pkt *cmd_info,int bIgnore)
+{
+    volatile u8 cmd_idx              = cmd_info->cmd->opcode;
+    volatile u32 sd_arg;
+    volatile s8 rsp_para1=0;
+    volatile s8 rsp_para2=0;
+    volatile s8 rsp_para3=0;
+    u8 rsp_len              = cmd_info->rsp_len;
+    u32 *rsp                = (u32 *)&cmd_info->cmd->resp;
+    struct rtksd_host *sdport = cmd_info->sdport;
+    struct mmc_host *host = sdport->mmc;
+    u32 iobase = sdport->base_io;
+    int err, retry_count=0;
+    unsigned long flags;
+    u32 dma_val=0;
+    u32 byte_count = 0x200, block_count = 1, cpu_mode=0, sa=0;
+    u8 tmp9_buf[1024]={0};
+    u32 buf_ptr=NULL;
+    u8 state = 0;
+
+    rtksd_set_rspparam(sdport,cmd_info);   //for 119x
+    sd_arg              = cmd_info->cmd->arg;
+    rsp_para1           = cmd_info->rsp_para1;
+    rsp_para2           = cmd_info->rsp_para2;
+    rsp_para3           = cmd_info->rsp_para3;
+
+RET_CMD:
+
+    if(rsp == NULL) {
+        BUG_ON(1);
+    }
+    if ((g_crinit == 0)&&(cmd_idx > MMC_SET_RELATIVE_ADDR))
+    {
+        printk("%s : ignore cmd:0x%02x since we're still in emmc init stage\n",DRIVER_NAME,cmd_idx);
+        return CR_TRANSFER_FAIL;
+    }
+
+    if (rsp_para1 != -1)
+        cr_writeb(rsp_para1, iobase+SD_CONFIGURE1);
+    cr_writeb(rsp_para2,     iobase+SD_CONFIGURE2);
+    if (rsp_para3 != -1)
+        cr_writeb(rsp_para3, iobase+SD_CONFIGURE3);
+    g_cmd[0] = (0x40|cmd_idx);
+    g_cmd[1] = (sd_arg>>24)&0xff;
+    g_cmd[2] = (sd_arg>>16)&0xff;
+    g_cmd[3] = (sd_arg>>8)&0xff;
+    g_cmd[4] = sd_arg&0xff;
+    g_cmd[5] = 0x00;
+   
+    cr_writeb((0x40|cmd_idx),iobase+SD_CMD0);
+    cr_writeb((sd_arg>>24)&0xff,iobase+SD_CMD1);
+    cr_writeb((sd_arg>>16)&0xff,iobase+SD_CMD2);
+    cr_writeb((sd_arg>>8)&0xff,iobase+SD_CMD3);
+    cr_writeb(sd_arg&0xff,    iobase+SD_CMD4);
+    cr_writeb(g_cmd[5],    iobase+SD_CMD5);
+    sdport->cmd_opcode = cmd_idx;
+    sync();
+    if (bSendCmd0)
+    	printk("0 cmd0:0x%02x,cmd1:0x%02x,cmd2:0x%02x,cmd3:0x%02x,cmd4:0x%02x,cmd5:0x%02x\n", cr_readb(iobase+SD_CMD0),cr_readb(iobase+SD_CMD1),cr_readb(iobase+SD_CMD2),cr_readb(iobase+SD_CMD3),cr_readb(iobase+SD_CMD4),cr_readb(iobase+SD_CMD5));
+    MMCPRINTF("0 cmd0:0x%02x,cmd1:0x%02x,cmd2:0x%02x,cmd3:0x%02x,cmd4:0x%02x,cmd5:0x%02x\n", cr_readb(iobase+SD_CMD0),cr_readb(iobase+SD_CMD1),cr_readb(iobase+SD_CMD2),cr_readb(iobase+SD_CMD3),cr_readb(iobase+SD_CMD4),cr_readb(iobase+SD_CMD5));
+    rtksd_get_cmd_timeout(cmd_info);
+    if(sdport->rtflags & RTKCR_FOPEN_LOG){
+        printk(KERN_INFO "cmd %s: cmd_idx=%u, rsp_addr=0x%08x\nsd_arg=0x%08x; rsp_para1=0x%08x rsp_para2=0x%08x rsp_para3=0x%x rsp_len=0x%x cfg1=0x%02x,cfg2=0x%02x,cfg3=0x%02x\n",
+        DRIVER_NAME,cmd_idx,rsp,sd_arg,rsp_para1,rsp_para2,rsp_para3,rsp_len,cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3));
+    }
+    cr_writel(0x00, iobase+CR_DMA_CTL1);   //espeical for R2
+    cr_writel(0x00, iobase+CR_DMA_CTL2);   //espeical for R2
+    cr_writel(0x00, iobase+CR_DMA_CTL3);   //espeical for R2
+    sync();
+    if (RESP_TYPE_17B & rsp_para2)
+    {
+        //remap the resp dst buffer to un-cache
+        #if 1
+	pRSP = rtksd_get_buffer_start_addr();
+        MMCPRINTF("cmdx tmp physical buf addr : 0x%08x\n", sdport->paddr);
+        MMCPRINTF("cmdx tmp buf addr : 0x%08x\n", pRSP);
+	buf_ptr = ((u32)sdport->paddr&~0xff);
+        MMCPRINTF("chg buf addr to : 0x%08x\n", buf_ptr);
+        sa = buf_ptr/8;
+        MMCPRINTF("final buf addr : 0x%08x\n", sa);
+        #else
+        sa = (u32)rsp/8;
+        #endif
+        
+        dma_val = RSP17_SEL|DDR_WR|DMA_XFER;
+        MMCPRINTF("-----rsp 17B-----\n DMA_sa=0x%08x DMA_len=0x%08x DMA_setting=0x%08x\n", sa,1,dma_val);
+        cr_writeb(byte_count,       iobase+SD_BYTE_CNT_L);     //0x24
+        cr_writeb(byte_count>>8,    iobase+SD_BYTE_CNT_H);     //0x28
+        cr_writeb(block_count,      iobase+SD_BLOCK_CNT_L);    //0x2C
+        cr_writeb(block_count>>8,   iobase+SD_BLOCK_CNT_H);    //0x30
+        if (cpu_mode && (iobase==EM_BASE_ADDR))
+            cr_writel( CPU_MODE_EN, iobase+EMMC_CPU_ACC); //enable cpu mode
+        else
+            cr_writel( 0, iobase+EMMC_CPU_ACC);
+        cr_writel(sa, iobase+CR_DMA_CTL1);   //espeical for R2
+        cr_writel(1, iobase+CR_DMA_CTL2);   //espeical for R2
+        cr_writel(dma_val, iobase+CR_DMA_CTL3);   //espeical for R2
+        //rtksd_get_next_block();
+    }
+    else if (RESP_TYPE_6B & rsp_para2)
+    {
+        MMCPRINTF("-----rsp 6B-----\n");
+        cr_writel( 0x00, iobase+EMMC_CPU_ACC);
+    }
+
+    MMCPRINTF("1 cmd0:0x%02x,cmd1:0x%02x,cmd2:0x%02x,cmd3:0x%02x,cmd4:0x%02x,cmd5:0x%02x\n", g_cmd[0],g_cmd[1],g_cmd[2],g_cmd[3],g_cmd[4],g_cmd[5]);
+
+    sync();
+    err = rtkcr_wait_opt_end(DRIVER_NAME,sdport,EMMC_SENDCMDGETRSP,cmd_idx,bIgnore);
+
+    if(err == CR_TRANS_OK){
+	sync();
+        if(buf_ptr != NULL)
+        {
+            //ignore start pattern
+	    pRSP = (u32)pRSP&~0xff;
+	    *(((unsigned int *)pRSP)+4) = cr_readb(iobase+SD_CMD5);
+	    pRSP++;
+            rtksd_read_rsp(sdport,(u32*)pRSP, rsp_len);
+            if (cmd_idx == MMC_SEND_EXT_CSD) {
+		printk(KERN_ERR "!!!!!!!!!!!!!!!! SD_SendCMDGetRSP_Cmd: MMC_SEND_EXT_CSD case should not be invoked !!!!!!!!!!!!!!!\n");
+                memcpy(rsp, (u32*)pRSP, 512);
+	    }
+            else
+                memcpy(rsp, (u32*)pRSP, 16);
+        }
+        else
+            rtksd_read_rsp(sdport,rsp, rsp_len);
+        sync();
+        if (cmd_idx == MMC_SET_RELATIVE_ADDR)
+        {
+            g_crinit = 1;
+            MMCPRINTF("emmc init done ...\n");
+        }
+	//get cmd7 status
+	if ((cmd_info->cmd->flags == (MMC_RSP_NONE | MMC_CMD_AC))&&(cmd_idx==MMC_SELECT_CARD))
+	{
+		printk(KERN_INFO "get status =>\n");
+        	rtksd_send_status(host->card,&state,0,0);
+	}
+    }
+    else{
+	if (!bIgnore)
+	{
+        	printk(KERN_WARNING "%s: %s cmd trans fail, err=%d, ignore=%d, gPreventRetry=%d, gCurrentBootMode=%d, cmd_idx=%d\n",DRIVER_NAME,__func__, err, bIgnore,gPreventRetry,gCurrentBootMode,cmd_idx);
+        }
+	#ifdef MMC_DEBUG
+        printk("[LY]snd gCurrentBootMode =%d\n",gCurrentBootMode);
+        #endif
+	if (gPreventRetry)
+	{
+        	printk(KERN_WARNING "[LY]ignore error when card in tuning state, gCurrentBootMode=%d, err=%d\n",gCurrentBootMode,err);
+		return err;
+	}
+        if (gCurrentBootMode >= MODE_DDR)
+        	return err;
+        if (cmd_idx == MMC_SEND_STATUS) //prevent dead lock looping
+                return err;
+        if (retry_count++ < MAX_CMD_RETRY_COUNT)
+        {
+		printk(KERN_ERR "d bIgnore=0x%02x,g_bTuning=0x%02x,gCurrentBootMode=0x%02x\n",bIgnore,g_bTuning,gCurrentBootMode);
+		if ((bIgnore==0x1)&&(cmd_idx==MMC_STOP_TRANSMISSION)&&(g_bTuning==0x1))
+			return 0;
+		
+		printk(KERN_WARNING "retry %d ---->\n",retry_count);
+                err = error_handling(sdport,cmd_idx,bIgnore);
+        	goto RET_CMD;
+        }
+    }
+    return err;
+}
+
+
+static int SD_SendCMDGetRSP(struct sd_cmd_pkt * cmd_info,int bIgnore)
+{
+    int rc;
+    MMCPRINTF("\n");
+
+
+    rc = SD_SendCMDGetRSP_Cmd(cmd_info,bIgnore);
+
+    return rc;
+}
+
+static void duplicate_pkt(struct sd_cmd_pkt* sour,struct sd_cmd_pkt* dist)
+{
+    dist->sdport      = sour->sdport;
+    dist->cmd         = sour->cmd;
+    dist->data        = sour->data;
+
+    dist->dma_buffer  = sour->dma_buffer;
+    dist->byte_count  = sour->byte_count;
+    dist->block_count = sour->block_count;
+
+    dist->flags       = sour->flags;
+    dist->rsp_para1    = sour->rsp_para1;
+    dist->rsp_para2    = sour->rsp_para2;
+    dist->rsp_para3    = sour->rsp_para3;
+    dist->rsp_len     = sour->rsp_len;
+    dist->timeout     = sour->timeout;
+}
+
+static int rtksd_err_handle(u16 cmdcode,struct sd_cmd_pkt *cmd_info)
+{
+    struct mmc_host *host       = cmd_info->sdport->mmc;
+    //struct rtksd_host *sdport   = cmd_info->sdport;
+    //u8 cmd_idx                  = cmd_info->cmd->opcode;
+    //u32 iobase                  = sdport->base_io;
+    u16 state = 0;
+    int err = 0;
+
+    MMCPRINTF("(%s:%d) : cmd=0x%02x\n", __func__,__LINE__,cmdcode);
+    if(host->card){
+        if(cmdcode == EMMC_AUTOWRITE2){
+            if( cmd_info->cmd->opcode == 18 ||
+                cmd_info->cmd->opcode == 25 )
+            {
+                int stop_loop = 5;
+                while(stop_loop--){
+
+                    err = rtksd_stop_transmission(host->card,0);
+                    if(err){
+                        //mdelay(1);
+                        rtksd_send_status(host->card,&state,0,0);
+                        if(state == STATE_TRAN)
+                            break;
+                    }else{
+                        break;
+                    }
+                }
+            }
+        }
+    	MMCPRINTF("(%s:%d) - cmd=0x%02x, before polling TRAN state\n", __func__,__LINE__,cmdcode);
+        err = rtksd_wait_status(host->card,STATE_TRAN,0,0);
+    }
+	return err;
+}
+
+static int SD_Stream_Cmd34(u16 cmdcode,struct sd_cmd_pkt *cmd_info)
+{
+    u8 cmd_idx              	= cmd_info->cmd->opcode;
+    u16 byte_count              = cmd_info->byte_count;
+    u16 block_count             = cmd_info->block_count;
+    void *data                  = cmd_info->dma_buffer;
+    struct rtksd_host *sdport   = cmd_info->sdport;
+    u32 iobase                  = sdport->base_io;
+    int err;
+    unsigned long flags;
+    u32 cpu_mode=0;
+    u32 sa=0;
+
+    if(data == NULL)
+        BUG_ON(1);
+
+    if( cmdcode != EMMC_AUTOREAD3  && cmdcode != EMMC_AUTOREAD4 &&
+        cmdcode != EMMC_AUTOWRITE3 && cmdcode != EMMC_AUTOWRITE4 ){
+        BUG_ON(1);
+    }
+
+    sa = (u32)data/8;
+
+    cr_writel(0x00, iobase+CR_DMA_CTL1);   //espeical for R2
+    cr_writel(0x00, iobase+CR_DMA_CTL2);   //espeical for R2
+    cr_writel(0x00, iobase+CR_DMA_CTL3);   //espeical for R2
+    cr_writeb(byte_count,       iobase+SD_BYTE_CNT_L);     //0x24
+    cr_writeb(byte_count>>8,    iobase+SD_BYTE_CNT_H);     //0x28
+    cr_writeb(block_count,      iobase+SD_BLOCK_CNT_L);    //0x2C
+    cr_writeb(block_count>>8,   iobase+SD_BLOCK_CNT_H);    //0x30
+    sync();
+
+    if(cmd_info->cmd->data->flags & MMC_DATA_READ){
+        MMCPRINTF("-----mmc data ddr read-----\n");
+        cr_writel( 0x00, iobase+EMMC_CPU_ACC);
+        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
+        cr_writel( block_count, iobase+CR_DMA_CTL2);
+        cr_writel( DDR_WR|DMA_XFER, iobase+CR_DMA_CTL3);
+    }else if(cmd_info->cmd->data->flags & MMC_DATA_WRITE){
+        MMCPRINTF("-----mmc data write-----\n");
+        MMCPRINTF("DMA sa = 0x%x\nDMA len = 0x%x\nDMA set = 0x%x\n", (u32)sa, block_count, DMA_XFER);
+ 
+        cr_writel( 0, iobase+EMMC_CPU_ACC);
+        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
+        cr_writel( block_count, iobase+CR_DMA_CTL2);
+    	sync();
+        cr_writel( DMA_XFER, iobase+CR_DMA_CTL3);
+    }
+    else //sram read
+    {
+        MMCPRINTF("-----mmc data sram read (cpu mode)-----\n");
+        MMCPRINTF("CR_CPU_ACC(0x18012080) = 0x%x\n", CPU_MODE_EN);
+
+        cpu_mode = 1;
+        cr_writel( 0, iobase+EMMC_CPU_ACC);
+        cr_writel( CPU_MODE_EN, iobase+EMMC_CPU_ACC);
+        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
+        cr_writel( block_count, iobase+CR_DMA_CTL2);
+    	sync();
+        cr_writel( DDR_WR|DMA_XFER, iobase+CR_DMA_CTL3);
+    }
+
+    sdport->cmd_opcode = 0xf1;
+    rtksd_get_cmd_timeout(cmd_info);
+    err = rtkcr_wait_opt_end(DRIVER_NAME,sdport,cmdcode,cmd_idx,cpu_mode);
+    if(err)
+        mmcmsg3(KERN_WARNING "%s: %s fail\n",DRIVER_NAME,__func__);
+
+    return err;
+}
+
+static int SD_Stream_Cmd(u16 cmdcode,struct sd_cmd_pkt *cmd_info, unsigned int bIgnore)
+{
+    u8 cmd_idx              = cmd_info->cmd->opcode;
+    u32 sd_arg              = cmd_info->cmd->arg;
+    s8 rsp_para1             = cmd_info->rsp_para1;
+    s8 rsp_para2             = cmd_info->rsp_para2;
+    s8 rsp_para3             = cmd_info->rsp_para3;
+    int rsp_len             = cmd_info->rsp_len;
+    u32 *rsp                = (u32 *)&cmd_info->cmd->resp;
+    u16 byte_count          = cmd_info->byte_count;
+    u16 block_count         = cmd_info->block_count;
+    struct rtksd_host *sdport = cmd_info->sdport;
+    u32 iobase = sdport->base_io;
+    struct mmc_host *host = sdport->mmc;
+    int err;
+    int stop_err;
+    u8 *data              = cmd_info->dma_buffer;
+    unsigned long flags;
+    u32 cpu_mode=0;
+    u32 sa=0,retry_count=0;
+
+    if(sdport->rtflags & RTKCR_FOPEN_LOG){
+        printk(KERN_INFO "%s strm: cmd_idx=%u, rsp_addr=0x%08x\nsd_arg=0x%08x; rsp_para1=0x%x rsp_para2=0x%x rsp_para3=0x%x rsp_len=0x,%x cfg1=0x%02x,cfg2=0x%02x,cfg3=0x%02x\n",
+                DRIVER_NAME,cmd_idx,rsp,sd_arg,rsp_para1,rsp_para2,rsp_para3,rsp_len,cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3));
+    }
+
+    if((u32)data == NULL) {
+        BUG_ON(1);
+    }
+    if(rsp == NULL) {
+        BUG_ON(1);
+    }
+    
+
+#ifdef TEST_POWER_RESCYCLE
+    cmd_info->sdport->test_count++;
+    mmcspec("test_count=%d\n",cmd_info->sdport->test_count);
+#endif
+    if ((g_crinit == 0)&&(cmd_idx > MMC_SET_RELATIVE_ADDR))
+    {
+        printk("%s : ignore cmd:0x%02x since we're still in emmc init stage\n",DRIVER_NAME,cmd_idx);
+        return CR_TRANSFER_FAIL;
+    }
+
+    rtksd_set_rspparam(sdport,cmd_info);   //for 119x
+    sd_arg              = cmd_info->cmd->arg;
+    if (rsp_para1 != -1)
+        rsp_para1           = cmd_info->rsp_para1;
+    rsp_para2           = cmd_info->rsp_para2;
+    if (rsp_para3 != -1)
+        rsp_para3           = cmd_info->rsp_para3;
+    sa = (u32)data/8;
+
+    if((cmdcode==EMMC_NORMALWRITE) || (cmdcode==EMMC_NORMALREAD))
+    {
+        //rsp_para2|=CRC16_CAL_DIS;
+        byte_count = 512;
+    }
+STR_CMD_RET:
+    g_cmd[0] = (0x40|cmd_idx);
+    g_cmd[1] = (sd_arg>>24)&0xff;
+    g_cmd[2] = (sd_arg>>16)&0xff;
+    g_cmd[3] = (sd_arg>>8)&0xff;
+    g_cmd[4] = sd_arg&0xff;
+    g_cmd[5] = 0x00;
+
+    cr_writeb(g_cmd[0],    iobase+SD_CMD0);           //0x10
+    cr_writeb(g_cmd[1],    iobase+SD_CMD1);           //0x14
+    cr_writeb(g_cmd[2],    iobase+SD_CMD2);           //0x18
+    cr_writeb(g_cmd[3],    iobase+SD_CMD3);           //0x1C
+    cr_writeb(g_cmd[4],    iobase+SD_CMD4);           //0x20
+    cr_writeb(g_cmd[5],    iobase+SD_CMD5);           //0x20
+    
+    if (rsp_para1 != -1)
+    {
+        MMCPRINTF("reset configure1 : 0x%02x\n", rsp_para1);
+        cr_writeb(rsp_para1,         iobase+SD_CONFIGURE1);     //0x0C
+        MMCPRINTF("read configure1 : 0x%02x\n", cr_readb(iobase+SD_CONFIGURE1));
+    }
+    cr_writeb(rsp_para2,         iobase+SD_CONFIGURE2);     //0x0C
+    if (rsp_para3 != -1)
+    {
+        MMCPRINTF("reset configure3 : 0x%02x\n", rsp_para3);
+        cr_writeb(rsp_para3,         iobase+SD_CONFIGURE3);     //0x0C
+        MMCPRINTF("read configure3 : 0x%02x\n", cr_readb(iobase+SD_CONFIGURE3));
+    }
+
+    cr_writel(0x00, iobase+CR_DMA_CTL1);   //espeical for R2
+    cr_writel(0x00, iobase+CR_DMA_CTL2);   //espeical for R2
+    cr_writel(0x00, iobase+CR_DMA_CTL3);   //espeical for R2
+    cr_writeb(byte_count,       iobase+SD_BYTE_CNT_L);     //0x24
+    cr_writeb(byte_count>>8,    iobase+SD_BYTE_CNT_H);     //0x28
+    cr_writeb(block_count,      iobase+SD_BLOCK_CNT_L);    //0x2C
+    cr_writeb(block_count>>8,   iobase+SD_BLOCK_CNT_H);    //0x30
+
+    sync();
+
+    if(cmd_info->cmd->data->flags & MMC_DATA_READ){
+        MMCPRINTF("-----mmc data ddr read-----\n");
+        cr_writel( 0x00, iobase+EMMC_CPU_ACC);
+        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
+        cr_writel( block_count, iobase+CR_DMA_CTL2);
+
+	sync();
+        cr_writel( DDR_WR|DMA_XFER, iobase+CR_DMA_CTL3);
+    }
+    else if(cmd_info->cmd->data->flags & MMC_DATA_TUNING)
+    {
+            MMCPRINTF("-----mmc data ddr tuning-----\n");
+            cr_writel( 0x00, iobase+EMMC_CPU_ACC);
+            cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
+            MMCPRINTF("DMA sa = 0x%x\nDMA len = 0x%x\nDMA set = 0x%x\n", sa, block_count, DAT64_SEL|DDR_WR|DMA_XFER);
+            cr_writel( block_count, iobase+CR_DMA_CTL2);
+		
+    	    sync();
+            cr_writel( DAT64_SEL|DDR_WR|DMA_XFER, iobase+CR_DMA_CTL3);
+    }
+    else if((cmd_info->cmd->data->flags & MMC_DATA_WRITE)||(cmd_info->cmd->data->flags & MMC_MICRON_60)){
+        MMCPRINTF("-----mmc data write-----\n");
+        MMCPRINTF("DMA sa = 0x%x\nDMA len = 0x%x\nDMA set = 0x%x\n", (u32)sa, block_count, DMA_XFER);
+ 
+        cr_writel( 0, iobase+EMMC_CPU_ACC);
+        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
+        cr_writel( block_count, iobase+CR_DMA_CTL2);
+    	sync();
+        cr_writel( DMA_XFER, iobase+CR_DMA_CTL3);
+    }
+    else //sram read
+    {
+        MMCPRINTF("-----mmc data sram read (cpu mode)-----\n");
+        MMCPRINTF("CR_CPU_ACC(0x18012080) = 0x%x\n", CPU_MODE_EN);
+
+        cpu_mode = 1;
+        cr_writel( 0, iobase+EMMC_CPU_ACC);
+        cr_writel( CPU_MODE_EN, iobase+EMMC_CPU_ACC);
+        cr_writel( (u32)sa, iobase+CR_DMA_CTL1);
+        cr_writel( block_count, iobase+CR_DMA_CTL2);
+    	sync();
+        cr_writel( DDR_WR|DMA_XFER, iobase+CR_DMA_CTL3);
+    }
+
+    sdport->cmd_opcode = cmd_idx;
+
+    rtksd_get_cmd_timeout(cmd_info);
+    
+    err = rtkcr_wait_opt_end(DRIVER_NAME,sdport,cmdcode,cmd_idx,bIgnore);
+    if (err == CR_TRANSFER_IGN)
+    {
+	/*printk(KERN_ERR "For tuning ignore case, stop the card\n");
+	gPreventRetry = 1;
+	err = error_handling(sdport,cmd_idx,bIgnore);
+        //stop_err = rtksd_stop_transmission(host->card,1);
+	gPreventRetry = 0;
+        if(err){
+            MMCPRINTF("error handling fail\n");
+        }*/
+        err = RTK_SUCC;
+    }
+#ifdef FORCE_CHG_SDR50_MODE
+    //printk("hacker cmd_arg=%08x\n", cmd_arg);
+    if (cmd_arg == 0x9999)
+    {
+        ret_err = -1;
+    }
+#endif
+
+    if(err == RTK_SUCC){
+        if((cmdcode == EMMC_AUTOREAD1) || (cmdcode == EMMC_AUTOWRITE1))
+        {
+            MMCPRINTF("AUTO READ/WRITE 1 skip response~\n");
+        }
+        else
+        {
+            rtksd_read_rsp(sdport,rsp, rsp_len);
+            MMCPRINTF("---stream cmd done---\n");
+        }
+#if 0
+	if ((cmd_idx > 17)&&(!bIgnore))
+		BUG();
+#endif
+    }
+    else
+    {
+        MMCPRINTF("strm cmd_idx=%d,ret_err=%d,bIgnore=%d\n",cmd_idx ,err,bIgnore);
+        mmcmsg3(KERN_WARNING "%s: %s fail\n",DRIVER_NAME,__func__);
+        if (bIgnore)
+        	return err;
+#if 0
+	BUG();
+#endif
+        if (retry_count++ < MAX_CMD_RETRY_COUNT)
+        {
+                err = error_handling(sdport,cmd_idx,bIgnore);
+                #ifdef FORCE_CHG_SDR50_MODE
+                if ((cmd_arg == 0x9999)&&(!err))
+                        return RTK_SUCC;
+                #endif
+                goto STR_CMD_RET;
+        }
+    }
+    return err;
+}
+
+static u32 rtkcr_chk_cmdcode(struct mmc_command* cmd){
+    u32 cmdcode;
+
+    if(cmd->opcode < 56){
+        cmdcode = (u32)rtk_sd_cmdcode[cmd->opcode][0];
+        WARN_ON(cmd->data == NULL);
+        if(cmd->data->flags & MMC_DATA_WRITE){
+            if(cmd->opcode == 42)
+                cmdcode = EMMC_NORMALWRITE;
+            else if(cmd->opcode == 56)
+                cmdcode = EMMC_AUTOWRITE2;
+        }
+    }else{
+        cmdcode = EMMC_CMD_UNKNOW;
+    }
+
+    return cmdcode;
+
+}
+
+static u32 rtkcr_chk_r1_type(struct mmc_command* cmd){
+    return 0;
+}
+
+static u8 rtk_get_rsp_type(struct mmc_command* cmd){
+    u32 rsp_type;
+    if ( mmc_resp_type(cmd)==MMC_RSP_R1 ){
+        rsp_type = SD_R1;
+    }else if ( mmc_resp_type(cmd)== MMC_RSP_R1B ){
+        rsp_type = SD_R1b;
+    }else if ( mmc_resp_type(cmd)== MMC_RSP_R2 ){
+        rsp_type = SD_R2;
+    }else if ( mmc_resp_type(cmd)== MMC_RSP_R3 ){
+        rsp_type = SD_R3;
+    }else if ( mmc_resp_type(cmd)== MMC_RSP_R6 ){
+        rsp_type = SD_R6;
+    }else if ( mmc_resp_type(cmd)== MMC_RSP_R7 ){
+        rsp_type = SD_R7;
+    }else{
+        rsp_type = SD_R0;
+    }
+    return rsp_type;
+}
+
+//#define USE_TMP_BUF
+static int SD_Stream(struct sd_cmd_pkt *cmd_info)
+{
+    int err=0;
+    u32 i;
+    struct scatterlist *sg;
+    u32 dir = 0;
+    u32 dma_nents = 0;
+    u32 dma_leng;
+    u32 dma_addr;
+    u32 dma_addr_sys = 0;
+    u32 old_arg;
+    u8 one_blk=0;
+    u8 f_in_dma = 0;
+    u16 cmdcode = 0;
+    unsigned long flags;
+    //enum dma_data_direction	direction;
+    //dma_addr_t		dma_addr = 0;
+
+    struct mmc_host *host = cmd_info->sdport->mmc;
+    struct rtksd_host *sdport = cmd_info->sdport;
+
+    rtksd_set_rspparam(sdport, cmd_info);   //for 119x
+
+    MMCPRINTF("\n");
+    if(cmd_info->data->flags & MMC_DATA_READ){
+        dir = DMA_FROM_DEVICE;
+    }else{
+        // KWarning: checked ok by alexkh@realtek.com
+        if(host->card && mmc_card_cmd24_err(host->card))
+        {
+            one_blk = 1;
+        }
+
+        dir = DMA_TO_DEVICE;
+    }
+
+    cmd_info->data->bytes_xfered=0;
+    dma_nents = dma_map_sg( mmc_dev(host), cmd_info->data->sg,
+                            cmd_info->data->sg_len,  dir);
+    sg = cmd_info->data->sg;
+
+#ifdef SHOW_MMC_PRD
+    printk("sg_len:%u\n",cmd_info->data->sg_len);
+    printk("sg:0x%p; dma_nents:%u\n",sg,dma_nents);
+#endif
+    old_arg=cmd_info->cmd->arg;
+
+    for(i=0; i<dma_nents; i++,sg++){
+        dma_leng = sg_dma_len(sg);
+
+        if(dma_leng & 0x1ff){
+            dma_addr_sys = sg_dma_address(sg);
+
+            if(sdport->tmp_buf){    //use tmp buffer
+                f_in_dma = 1;
+                dma_addr = sdport->tmp_buf_phy_addr;
+#ifndef USE_TMP_BUF
+                WARN_ON(1);
+#endif
+            }else{                  //use default buffer
+                dma_addr = dma_addr_sys;
+            }
+        }else{
+            dma_addr = sg_dma_address(sg);
+        }
+
+        //dma_addr = dma_map_page(host->parent, sg_page(sg), 0,
+		//				PAGE_SIZE, dir);
+#ifdef SHOW_MMC_PRD
+        printk("dma_addr:0x%x; dma_leng:0x%x\n",dma_addr,dma_leng);
+        mmcinfo("host=%p\n",host);
+        if(host->card){
+            mmcinfo("card=%p\n",host->card);
+            if(mmc_card_blockaddr(host->card))
+                printk("arg:0x%x blk\n",cmd_info->cmd->arg);
+            else
+                printk("arg:0x%x byte\n",cmd_info->cmd->arg);
+        }
+#endif
+
+        if(one_blk){    /* occur at write case only */
+            u8 i;
+            u32 blk_cnt;
+            struct sd_cmd_pkt tmp_pkt;
+
+            blk_cnt = dma_leng/BYTE_CNT;
+            if(blk_cnt == 0){
+                WARN_ON(1);
+                blk_cnt = 1;
+            }
+            duplicate_pkt(cmd_info,&tmp_pkt);
+
+            tmp_pkt.byte_count  = BYTE_CNT;
+            tmp_pkt.block_count = 1;
+            tmp_pkt.dma_buffer  = (unsigned char *)dma_addr;
+
+            if(tmp_pkt.cmd->opcode == 25){
+                tmp_pkt.cmd->opcode = 24;
+            }
+
+            if(tmp_pkt.cmd->opcode == 18){
+                tmp_pkt.cmd->opcode = 17;
+            }
+
+            cmdcode = sdport->ops->chk_cmdcode(tmp_pkt.cmd);
+            for(i=0;i<blk_cnt;i++){
+
+                err = SD_Stream_Cmd(cmdcode,&tmp_pkt,0);
+                if(err == 0){
+                    if(host->card){
+                        if(tmp_pkt.cmd->opcode == 24)
+                            host->card->state &= ~MMC_STATE_CMD24_ERR;
+                    }
+
+                    if(host->card && mmc_card_blockaddr(host->card))
+                        tmp_pkt.cmd->arg += 1;
+                    else
+                        tmp_pkt.cmd->arg += BYTE_CNT;
+
+                    tmp_pkt.dma_buffer += BYTE_CNT;
+                    tmp_pkt.data->bytes_xfered += BYTE_CNT;
+
+                }else{
+		    //TBD
+                    if(rtksd_err_handle(cmdcode,&tmp_pkt)){
+
+                        if(tmp_pkt.cmd->opcode == 24){
+                            int err34 = 0;
+
+                            err34 = SD_Stream_Cmd34(EMMC_AUTOWRITE3,&tmp_pkt);
+                            if(err34 ){
+                                if(rtksd_err_handle(EMMC_AUTOWRITE3,&tmp_pkt)){
+                                    mmcmsg3(KERN_INFO "%s: error recover fail 1\n",
+                                        DRIVER_NAME);
+                                }
+                            }else{
+                                rtksd_wait_status(host->card,STATE_TRAN,0,0);
+                            }
+
+                        }else{
+                            mmcmsg3(KERN_INFO "%s: error recover fail 2\n",
+                                DRIVER_NAME);
+                        }
+                    }
+                    break;
+                }
+            }
+//liaokh            dma_cache_wback(KSEG0ADDR(dma_addr), dma_leng);
+                //dma_unmap_page(host->parent, dma_addr, PAGE_SIZE, dir);
+        }
+        else
+        {
+            u32 blk_cnt;
+            cmd_info->byte_count = BYTE_CNT;     //rtk HW limite, one trigger 512 byte pass.
+            blk_cnt = dma_leng/BYTE_CNT;
+
+            if(blk_cnt == 0 && dma_leng){
+                blk_cnt = 1;
+            }
+
+            cmd_info->block_count = blk_cnt;
+            cmd_info->dma_buffer = (unsigned char *)dma_addr;
+
+            //if(cmd_info->data->flags & MMC_DATA_READ){
+//liaokh                dma_cache_inv(KSEG0ADDR(dma_addr), dma_leng);
+            //}
+            //else
+            //{
+                //rtksd_wait_status(host->card,STATE_TRAN,0,0);
+            //}
+
+            cmdcode = sdport->ops->chk_cmdcode(cmd_info->cmd);
+            err = SD_Stream_Cmd(cmdcode,cmd_info,0);
+            //if(cmd_info->data->flags & MMC_DATA_WRITE){
+//liaokh                dma_cache_wback(KSEG0ADDR(dma_addr), dma_leng);
+            //}
+            //dma_unmap_page(host->parent, dma_addr, PAGE_SIZE, dir);
+
+            if(err == 0){
+                if(host->card){
+                    if( (cmd_info->cmd->opcode == 25) &&
+                        (cmdcode == EMMC_AUTOWRITE2) )
+                    {
+                        int stop_err;
+
+                        stop_err = rtksd_stop_transmission(host->card,0);
+                        if(stop_err){
+                            MMCPRINTF("rtksd_stop_transmission fail\n");
+                            goto ERR_HANDLE;
+                        }
+                    }
+                }
+
+                if(host->card && mmc_card_blockaddr(host->card))
+                    cmd_info->cmd->arg += cmd_info->block_count;
+                else
+                    cmd_info->cmd->arg += dma_leng;
+
+                cmd_info->data->bytes_xfered += dma_leng;
+
+            }else{
+ERR_HANDLE:
+		//TBD
+                if(rtksd_err_handle(cmdcode,cmd_info)){
+                    if(cmd_info->cmd->opcode == 18
+                    || cmd_info->cmd->opcode == 25)
+                    {
+                        if(host->card){
+                            int stop_err;
+                            stop_err = rtksd_stop_transmission(host->card,0);
+                            if(stop_err){
+                                MMCPRINTF("rtksd_stop_transmission fail\n");
+                                //goto ERR_HANDLE;
+                            }
+                            rtksd_wait_status(host->card,STATE_TRAN,0,0);
+                        }
+
+                    }else if(cmd_info->cmd->opcode == 24){
+                        int err34 = 0;
+                        err34 = SD_Stream_Cmd34(EMMC_AUTOWRITE3,cmd_info);
+                        if(err34 ){
+                            if(rtksd_err_handle(EMMC_AUTOWRITE3,cmd_info)){
+                                mmcmsg3(KERN_INFO "%s: error recover fail 3\n",
+                                            DRIVER_NAME);
+                            }
+                        }else{
+                            if(host->card)
+                                rtksd_wait_status(host->card,STATE_TRAN,0,0);
+                        }
+
+                    }else{
+                        mmcmsg3(KERN_INFO "%s: error recover fail 4\n",
+                                            DRIVER_NAME);
+                    }
+                }
+            }
+        }
+
+        if(err){
+            cmd_info->cmd->arg = old_arg;
+            break;
+        }
+
+        if(f_in_dma){
+            u32 i;
+            u8 * ptr1 = phys_to_virt(dma_addr_sys);
+            u8 * ptr2 = phys_to_virt(dma_addr);
+            f_in_dma = 0;
+            for(i=0; i<dma_leng;i++)
+                *ptr1 = *ptr2;
+        }
+    }
+    dma_unmap_sg( mmc_dev(host), cmd_info->data->sg,
+                            cmd_info->data->sg_len,  dir);
+
+    //reset cmd0
+    g_cmd[0] = 0x00;
+
+    return err;
+
+}
+
+static void rtkcr_req_end_tasklet(unsigned long param)
+{
+    struct rtksd_host *sdport;
+    struct mmc_request* mrq;
+    unsigned long flags;
+
+    sdport = (struct rtksd_host *)param;
+    spin_lock_irqsave(&sdport->lock,flags);
+    mrq = sdport->mrq;
+    sdport->mrq = NULL;
+
+    spin_unlock_irqrestore(&sdport->lock, flags);
+    mmc_request_done(sdport->mmc, mrq);
+}
+
+static void rtksd_send_command(struct rtksd_host *sdport, struct mmc_command *cmd)
+{
+    int rc = 0;
+    struct sd_cmd_pkt cmd_info;
+    unsigned long flags;
+    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+    if ( !sdport || !cmd ){
+        printk(KERN_ERR "%s: sdport or cmd is null\n",DRIVER_NAME);
+        return ;
+    }
+    cmd_info.cmd    = cmd;
+    cmd_info.sdport = sdport;
+    cmd_info.rsp_para2 = rtk_get_rsp_type(cmd_info.cmd);
+    cmd_info.rsp_len  = rtksd_get_rsp_len(cmd_info.rsp_para2);
+    if (cmd->data){
+        cmd_info.data = cmd->data;
+        if(cmd->data->flags == MMC_DATA_READ){
+            /* do nothing */
+        }else if(cmd->data->flags == MMC_DATA_WRITE){
+            if(sdport->wp ==1){
+                printk(KERN_WARNING "%s: card is locked!",
+                            DRIVER_NAME);
+                rc = -1;
+                cmd->retries = 0;
+                goto err_out;
+            }
+        }else{
+            printk(KERN_ERR "error: cmd->data->flags=%d\n",
+                    cmd->data->flags);
+            cmd->error = -MMC_ERR_INVALID;
+            cmd->retries = 0;
+            goto err_out;
+        }
+    	if (g_bTuning)
+    		printk(KERN_INFO "................[%s:HS200] still tuning.............. \n",DRIVER_NAME);
+        rc = SD_Stream(&cmd_info);
+    }
+    else{
+        rc = SD_SendCMDGetRSP(&cmd_info,0);
+    }
+    if(cmd->opcode == MMC_SWITCH){
+         if((cmd->arg & 0xffff00ff) == 0x03b30001) {
+            if((cmd->arg & 0x0000ff00)==0){
+                sdport->rtflags |= RTKCR_USER_PARTITION;
+            }else{
+                sdport->rtflags &= ~RTKCR_USER_PARTITION;
+            }
+         }
+    }
+    MMCPRINTF("%s: cmd->opcode=0x%02x\n",__func__,cmd->opcode);
+#if 0
+    if (cmd->opcode == MMC_SELECT_CARD)
+    {
+	MMCPRINTF("to DIV_none, then tuning at this speed\n");
+       	//rtkcr_set_div(sdport,EMMC_CLOCK_DIV_NON);
+	mmc_Select_SDR50_Push_Sample(&cmd_info);
+    }
+#endif
+
+err_out:
+    if (rc){
+        if(rc == -RTK_RMOV)
+            cmd->retries = 0;
+
+        cmd->error = -MMC_ERR_FAILED;
+    }
+    tasklet_schedule(&sdport->req_end_tasklet);
+}
+
+static void rtksd_request(struct mmc_host *host, struct mmc_request *mrq)
+{
+    struct rtksd_host *sdport;
+    struct mmc_command *cmd;
+    //struct mmc_card  *card;
+    unsigned long flags;
+#ifdef USE_TMP_BUF
+    unsigned char *tmp_buf=NULL;
+#endif
+
+    MMCPRINTF("\n");
+
+    sdport = mmc_priv(host);
+    BUG_ON(sdport->mrq != NULL);
+
+    //spin_lock_irqsave(&sdport->lock,flags);
+    down_write(&cr_rw_sem);
+    cmd = mrq->cmd;
+    sdport->mrq = mrq;
+
+    if (!(sdport->rtflags & RTKCR_FCARD_DETECTED)){
+        cmd->error = -MMC_ERR_RMOVE;
+        cmd->retries = 0;
+        goto done;
+    }
+
+/*
+ * the "tmp_buf" should used for sg_init_one() in blksz small than 512 byte case.
+ * because RTK DMA HW issue,the samllest DMA size is 512 byte
+ */
+#ifdef USE_TMP_BUF
+    if (cmd->data) {
+
+        if(cmd->data->blksz < 512){
+            WARN_ON(1);
+            printk("blksz=%d\n",cmd->data->blksz);
+
+            tmp_buf = dma_alloc_coherent(sdport->dev, 512,
+                    &sdport->tmp_buf_phy_addr, GFP_KERNEL);
+
+            if(!tmp_buf){
+                WARN_ON(1);
+                cmd->error = -ENOMEM;
+                goto done;
+            }
+            memset(tmp_buf,0,512);
+            sdport->tmp_buf = tmp_buf;
+            //printk("%s(%u)buf=0x%p phy_addr=0x%x\n",
+            //        __func__,__LINE__,
+            //        sdport->tmp_buf,sdport->tmp_buf_phy_addr);
+        }else{
+            sdport->tmp_buf = NULL;
+        }
+    }
+#endif  //#ifdef USE_TMP_BUF
+
+    if ( sdport && cmd ){
+        rtksd_allocate_dma_buf(sdport, cmd);
+        rtksd_send_command(sdport, cmd);
+    }else{
+done:
+        tasklet_schedule(&sdport->req_end_tasklet);
+    }
+        up_write(&cr_rw_sem);
+    
+        //spin_unlock_irqrestore(&sdport->lock, flags);
+}
+
+static int rtksd_execute_tuning(struct mmc_host *host, u32 opcode)
+{
+	struct rtksd_host *sdport;
+	unsigned long flags;
+	struct sd_cmd_pkt cmd_info;
+
+	sdport = mmc_priv(host);
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	cmd_info.sdport = sdport;
+
+	MMCPRINTF("%s : opcode=0x%08x, mode=0x%08x\n",opcode,host->mode);
+
+	switch(host->mode)
+	{
+	case MODE_SD20:
+		mmc_Select_SDR50_Push_Sample(sdport);
+		break;
+	case MODE_DDR:
+		mmc_Tuning_DDR50(sdport);
+		break;
+	case MODE_SD30:
+		mmc_Tuning_HS200(sdport);
+		break;
+	default:
+		mmc_Select_SDR50_Push_Sample(sdport);
+	} 
+
+	return 0;
+}
+static void rtksd_set_ios(struct mmc_host *host, struct mmc_ios *ios)
+{
+	struct rtksd_host *sdport;
+	u32 tmp_clock, busmode=0;
+	unsigned long flags;
+	sdport = mmc_priv(host);
+
+	MMCPRINTF("ios->bus_mode = 0x%x\n",ios->bus_mode);
+	MMCPRINTF("ios->clock = 0x%x\n",ios->clock);
+	MMCPRINTF("ios->bus_width = 0x%x\n",ios->bus_width);
+	MMCPRINTF("ios->timing = 0x%x\n",ios->timing);
+
+	//down_write(&cr_rw_sem);
+	if (!g_bResuming)
+	{
+		switch(ios->timing)
+		{
+		case MMC_TIMING_MMC_HS200:
+			rtkcr_set_mode_selection(sdport, MODE_SD30);
+			break;
+		case MMC_TIMING_UHS_DDR50: 
+			rtkcr_set_mode_selection(sdport, MODE_DDR);
+			break;
+		case MMC_TIMING_MMC_HS:
+		default:
+			rtkcr_set_mode_selection(sdport, MODE_SD20);
+			break;
+		}
+
+		//TBD, 
+		switch(ios->timing)
+		{
+		case MMC_TIMING_MMC_HS:
+			rtkcr_set_ldo(sdport,0x57);  //50Mhz
+            		rtkcr_set_div(sdport,EMMC_CLOCK_DIV_NON);
+			break;
+		case MMC_TIMING_UHS_DDR50:
+			rtkcr_set_ldo(sdport,0x57);  //50Mhz
+			rtkcr_set_div(sdport,EMMC_CLOCK_DIV_NON);
+			break;
+		case MMC_TIMING_MMC_HS200:
+			rtkcr_set_ldo(sdport,0xaf);  //200Mhz
+			rtkcr_set_div(sdport,EMMC_CLOCK_DIV_NON);
+			break;
+		}
+	}
+
+	if (ios->bus_width == MMC_BUS_WIDTH_8){
+		//rtkcr_set_speed(sdport, 0);
+		MMCPRINTF("set bus width 8\n");
+		rtksd_set_bits(sdport,BUS_WIDTH_8);
+		busmode = BUS_WIDTH_8;
+	}else if (ios->bus_width == MMC_BUS_WIDTH_4){
+		rtksd_set_bits(sdport,BUS_WIDTH_4);
+		MMCPRINTF("set bus width 4\n");
+		busmode = BUS_WIDTH_4;
+	}else{
+		rtksd_set_bits(sdport,BUS_WIDTH_1);
+		MMCPRINTF("set bus width 1\n");
+		busmode = BUS_WIDTH_1;
+	}
+
+	if (ios->bus_mode == MMC_BUSMODE_PUSHPULL){
+		MMCPRINTF("ios busmode = pushpull\n");
+	}
+	else{  //MMC_BUSMODE_OPENDRAIN
+		MMCPRINTF("ios busmode != pushpull\n");
+		rtkcr_set_div(sdport,EMMC_CLOCK_DIV_128);
+		rtksd_set_bits(sdport,BUS_WIDTH_1);
+	}
+
+	//up_write(&cr_rw_sem);
+}
+
+static void rtkemmc_dump_registers(struct rtksd_host *sdport)
+{
+	if (g_bTuning)
+		return;
+	printk(KERN_INFO "%s : \n", __func__);
+	printk("card_select=0x%02x \n", gRegTbl.card_select);
+	printk("sample_point_ctl=0x%02x \n", gRegTbl.sample_point_ctl);
+	printk("push_point_ctl=0x%02x \n", gRegTbl.push_point_ctl);
+	printk("sys_pll_emmc3=0x%08x \n", gRegTbl.sys_pll_emmc3);
+	printk("pll_emmc1=0x%08x \n", gRegTbl.pll_emmc1);
+	printk("sd_configure1=0x%02x \n", gRegTbl.sd_configure1);
+	printk("sd_configure2=0x%02x \n", gRegTbl.sd_configure2);
+	printk("sd_configure3=0x%02x \n", gRegTbl.sd_configure3);
+	printk("EMMC_CARD_PAD_DRV=0x%02x \n", cr_readb(sdport->base_io+EMMC_CARD_PAD_DRV));
+	printk("EMMC_CMD_PAD_DRV=0x%02x \n", cr_readb(sdport->base_io+EMMC_CMD_PAD_DRV));
+	printk("EMMC_DATA_PAD_DRV=0x%02x \n", cr_readb(sdport->base_io+EMMC_DATA_PAD_DRV));
+	sync();
+}
+static void rtkemmc_restore_registers(struct rtksd_host *sdport)
+{
+    if (!g_bTuning)
+    	printk(KERN_INFO "%s : \n", __func__);
+    rtkcr_set_pad_driving(sdport,MMC_IOS_RESTORE_PAD_DRV, 0x66,0x64,0x66);
+    cr_writeb(gRegTbl.card_select, sdport->base_io+CARD_SELECT);
+    cr_writeb(gRegTbl.sample_point_ctl, sdport->base_io+SD_SAMPLE_POINT_CTL);
+    cr_writeb(gRegTbl.push_point_ctl, sdport->base_io+SD_PUSH_POINT_CTL);
+    cr_writel(gRegTbl.sys_pll_emmc3, SYS_PLL_EMMC3); 
+    cr_writel(gRegTbl.pll_emmc1, PLL_EMMC1);
+    cr_writeb(gRegTbl.sd_configure1, sdport->base_io+SD_CONFIGURE1);
+    cr_writeb(gRegTbl.sd_configure2, sdport->base_io+SD_CONFIGURE2);
+    cr_writeb(gRegTbl.sd_configure3, sdport->base_io+SD_CONFIGURE3);
+    cr_writel(gRegTbl.emmc_pad_ctl, sdport->base_io+EMMC_PAD_CTL);
+    cr_writel(gRegTbl.emmc_ckgen_ctl, sdport->base_io+EMMC_CKGEN_CTL);
+    sync();
+    rtkemmc_dump_registers(sdport);
+}
+static void rtkemmc_backup_registers(struct rtksd_host *sdport)
+{
+    if (!g_bTuning)
+    	printk(KERN_INFO "%s : \n", __func__);
+    rtkcr_set_pad_driving(sdport,MMC_IOS_GET_PAD_DRV, 0x66,0x64,0x66);
+    gRegTbl.card_select      = cr_readb(sdport->base_io+CARD_SELECT);
+    gRegTbl.sample_point_ctl = cr_readb(sdport->base_io+SD_SAMPLE_POINT_CTL);
+    gRegTbl.push_point_ctl   = cr_readb(sdport->base_io+SD_PUSH_POINT_CTL);
+    gRegTbl.sys_pll_emmc3    = cr_readl(SYS_PLL_EMMC3);
+    gRegTbl.pll_emmc1        = cr_readl(PLL_EMMC1);
+    if (!g_bTuning)
+    	printk(KERN_INFO "%s : pll_emmc1=0x%08x, reg_pll_emmc1=0x%08x\n", __func__,gRegTbl.pll_emmc1,cr_readl(PLL_EMMC1));
+
+    gRegTbl.sd_configure1    = cr_readb(sdport->base_io+SD_CONFIGURE1);
+    gRegTbl.sd_configure2    = cr_readb(sdport->base_io+SD_CONFIGURE2);
+    gRegTbl.sd_configure3    = cr_readb(sdport->base_io+SD_CONFIGURE3);
+    gRegTbl.emmc_pad_ctl     = cr_readl(sdport->base_io+EMMC_PAD_CTL);
+    gRegTbl.emmc_ckgen_ctl   = cr_readl(sdport->base_io+EMMC_CKGEN_CTL);
+    sync();
+    rtkemmc_dump_registers(sdport);
+}
+
+static void rtkemmc_chk_card_insert(struct rtksd_host *sdport)
+{
+	struct mmc_host *host=sdport->mmc;
+	MMCPRINTF("%s : \n", __func__);
+	rtksd_set_bits(sdport,BUS_WIDTH_1);
+	rtkcr_set_mode_selection(sdport, MODE_SD20);
+	rtkcr_set_speed(sdport, 2);
+	rtkcr_set_div(sdport,EMMC_CLOCK_DIV_128);
+	rtkcr_set_ldo(sdport,0x57);  //50Mhz
+	cr_writeb( 0x0,  sdport->base_io+SD_SAMPLE_POINT_CTL );   //sample point = SDCLK / 4
+	cr_writeb( 0x0, sdport->base_io+SD_PUSH_POINT_CTL );     //output ahead SDCLK /4 
+	host->card_type_pre = CR_EM;  //default flow is sd
+	host->ops = &rtkemmc_ops;
+	sdport->rtflags |= RTKCR_FCARD_DETECTED;
+	MMCPRINTF("%s : \n", __func__);
+}
+
+static void rtksd_timeout_timer(unsigned long data)
+{
+    struct rtksd_host *sdport;
+    u8 wflag = 0;
+    u32 int_status = 0;
+    u32 sd_status1 = 0, sd_status2 = 0, bus_status = 0;
+    u32 sd_trans = 0, dma_trans=0;
+    unsigned long flags;
+
+    sdport = (struct rtksd_host *)data;
+    MMCPRINTF("rtksd_timeout_timer fired ...\n");
+    MMCPRINTF("%s - int_wait=%08x\n", __func__, sdport->int_waiting);
+    spin_lock_irqsave(&sdport->lock,flags);
+    //down_write(&cr_rw_sem);
+    #ifdef ENABLE_EMMC_INT_MODE
+    if(sdport->int_waiting)
+    #else
+    if (1)
+    #endif
+    {
+        MMCPRINTF("0. get sd trans \n");
+        wflag = 0x01;
+        #ifdef ENABLE_EMMC_INT_MODE
+        MMCPRINTF("========== C1 ==========\n");
+        rtkcr_hold_int_dec(sdport->base_io);
+        rtkcr_clr_int_sta(sdport->base_io);
+        sync();
+        rtkcr_get_int_sta(sdport->base_io,&int_status);
+        sdport->int_status  = int_status;
+        #endif
+        MMCPRINTF("1. get sd trans \n");
+        MMCPRINTF("baseio=0x%08x\n",sdport->base_io);
+        rtkcr_get_sd_trans(sdport->base_io,&sd_trans);
+        rtkcr_get_dma_trans(sdport->base_io,&dma_trans);
+        
+        MMCPRINTF("2. get sd status \n");
+        rtkcr_get_sd_sta(sdport->base_io,&sd_status1,&sd_status2,&bus_status);
+
+        sdport->sd_trans    = sd_trans;
+        sdport->sd_status1   = sd_status1;
+        sdport->sd_status2   = sd_status2;
+        sdport->bus_status   = bus_status;
+        sdport->dma_trans    = dma_trans;
+        MMCPRINTF("int sts : 0x%08x sd_trans : 0x%08x, sd_st1 : 0x%08x\n", sdport->int_status, sdport->sd_trans, sdport->sd_status1);
+        MMCPRINTF("int st2 : 0x%08x bus_sts : 0x%08x dma_trans : 0x%08x\n", sdport->sd_status2, sdport->bus_status, sdport->dma_trans);        
+        #ifdef ENABLE_EMMC_INT_MODE
+        //rtkcr_en_int(sdport->base_io);
+        #endif
+    }else{
+        WARN_ON(1);
+    }
+        
+    if(sdport->int_waiting)
+        rtk_op_complete(sdport);
+
+    spin_unlock_irqrestore(&sdport->lock, flags);
+    //up_write(&cr_rw_sem);
+    #ifdef ENABLE_EMMC_INT_MODE
+    MMCPRINTF(KERN_WARNING "%s: %s %s card access time out!\n",
+            DRIVER_NAME,
+            (wflag & 0x01) ? "int error;" : "",
+            (wflag & 0x10) ? "dma error;" : "" );
+    #endif
+
+}
+
+#ifdef EMMC_SHOUTDOWN_PROTECT
+static void rtksd_gpio_isr(VENUS_GPIO_ID gid,
+                                  unsigned char assert,
+                                  void *dev)
+{
+    struct rtksd_host *sdport = dev;
+    u32 reg_tmp;
+    u32 bit_tmp;
+    u32 reginfo;
+    unsigned char assert_tmp;
+
+    printk("%s(%u) sdport=0x%p (0x%x) [assert:%x]\n",
+            __func__,__LINE__,sdport,gid,assert);
+
+    reginfo = GET_PIN_TYPE(sdport->gpio_isr_info);
+    bit_tmp = GET_PIN_INDEX(sdport->gpio_isr_info);
+
+    reg_tmp = ((bit_tmp & 0xffffffe0)>>5)<<2;
+    bit_tmp = (bit_tmp & 0x1fUL);
+
+    switch(reginfo){
+        case PCB_PIN_TYPE_GPIO:
+            reg_tmp += GP0DATI;
+            printk(KERN_ERR "PIN type is PCB_PIN_TYPE_GPIO\n");
+            break;
+        case PCB_PIN_TYPE_ISO_GPIO:
+            reg_tmp += ISO_GPDATI;
+            printk(KERN_ERR "PIN type is PCB_PIN_TYPE_ISO_GPIO\n");
+            break;
+        default:
+            printk(KERN_ERR "PIN group not match\n");
+            WARN_ON(1);
+            return;
+    }
+
+    reginfo = cr_readl(reg_tmp);
+    assert_tmp = (unsigned char)((reginfo & (0x01UL << bit_tmp))>>bit_tmp);
+    WARN_ON(assert_tmp != assert);
+
+    if((reginfo & (0x01UL <<bit_tmp)) == 0)
+    {
+        printk(KERN_ERR "%s(%u)Hold eMMC RSENT!!!\n",
+            __func__,__LINE__);
+
+        rtksd_hold_card(sdport);
+    }
+}
+
+#endif
+
+static irqreturn_t rtksd_irq(int irq, void *dev)
+{
+    struct rtksd_host *sdport = dev;
+
+    int irq_handled = 0;
+    u32 reginfo = 0;
+    u32 int_status = 0;
+    u32 sd_trans   = 0, dma_trans=0;
+    u32 sd_status1 = 0,sd_status2 = 0, bus_status = 0;
+    unsigned long flags;
+
+    MMCPRINTF("rtksd_irq interrupted ...\n");
+
+    rtkcr_hold_int_dec(sdport->base_io);
+    rtkcr_get_int_sta(sdport->base_io,&int_status);
+    rtkcr_clr_int_sta(sdport->base_io);
+    sync();
+
+    //down_write(&cr_rw_sem);
+    //spin_lock(&sdport->lock);
+
+    MMCPRINTF("int_status =%08x, int_waiting=%08x\n", int_status, sdport->int_waiting);
+    if(int_status & (ISRSTA_INT1|ISRSTA_INT2|ISRSTA_INT4)) //card_end ?
+    {
+        MMCPRINTF("========== C2 ==========\n");
+        rtkcr_get_sd_trans(sdport->base_io,&sd_trans);
+        rtkcr_get_dma_trans(sdport->base_io,&dma_trans);
+        rtkcr_get_sd_sta(sdport->base_io,&sd_status1,&sd_status2,&bus_status);
+	sync();
+
+        MMCPRINTF("we get int end \n");
+
+#ifdef  SHOW_INT_STATUS
+        printk("INT=0x%08x sdport=0x%p\n",int_status,sdport);
+#endif
+        sdport->int_status  = int_status;
+        sdport->sd_trans    = sd_trans;
+        sdport->sd_status1   = sd_status1;
+        sdport->sd_status2   = sd_status2;
+        sdport->bus_status   = bus_status;
+        sdport->dma_trans    = dma_trans;
+        if(sdport->int_waiting){
+            MMCPRINTF("int wait clear 1\n");
+            del_timer(&sdport->timer);
+            rtk_op_complete(sdport);
+            MMCPRINTF("int wait clear 2\n");
+        }else{
+            MMCPRINTF("No int_waiting!!!\n");
+        }
+        //rtkcr_en_int(sdport->base_io);
+        irq_handled = 1;
+    }
+    else
+    {
+        printk(KERN_ERR "INT no END_STATE!!!\n");
+    }
+
+    sync();
+
+    //up_write(&cr_rw_sem);
+    //spin_unlock(&sdport->lock);
+    
+    if(irq_handled)
+        return IRQ_HANDLED;      //liao
+    else
+        return IRQ_NONE;
+
+}
+
+/* liao ********************
+ * check read only func
+ *
+ *
+ ***************************/
+static int rtksd_get_ro(struct mmc_host *mmc)
+{
+    //struct rtksd_host *sdport = mmc_priv(mmc);
+    //struct mmc_card *card = mmc->card;
+
+    return 0;
+}
+
+static int rtksd_wait_status(struct mmc_card *card,u8 state,u8 divider,int bIgnore)
+{
+    struct mmc_command cmd;
+    struct sd_cmd_pkt cmd_info;
+    unsigned long timeend;
+    int err, bMalloc=0;
+    struct mmc_host * mmc = mmc_host_local;
+
+    MMCPRINTF("\n");
+    timeend = jiffies + msecs_to_jiffies(100);    /* wait 100ms */
+    
+    if (card == NULL)
+    {
+	bMalloc=1;
+	card = (struct mmc_card*)kmalloc(sizeof(struct mmc_card),GFP_KERNEL);
+	card->host = mmc;
+    }
+
+    do {
+        memset(&cmd, 0, sizeof(struct mmc_command));
+        memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+        set_cmd_info(card,&cmd,&cmd_info,
+                     MMC_SEND_STATUS,
+                     (card->rca)<<RCA_SHIFTER,
+                     SD_R1|divider);
+        err = SD_SendCMDGetRSP_Cmd(&cmd_info,bIgnore);
+
+        if(err){
+            MMCPRINTF("wait %s fail\n",state_tlb[state]);
+            break;
+        }else{
+            u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
+            MMCPRINTF("resp[0]=0x%08x,cur_state=%s\n",cmd.resp[0],state_tlb[cur_state]);
+            err = -1;
+            if(cur_state == state){
+                if(cmd.resp[0] & R1_READY_FOR_DATA){
+                    err = 0;
+                    break;
+                }
+            }
+        }
+
+    }while(time_before(jiffies, timeend));  
+
+    if (bMalloc)
+    {
+	kfree(card);
+	card = NULL;
+    }
+    return err;
+}
+
+static int rtkcr_send_cmd13(struct rtksd_host *sdport, u16 * state)
+{
+    struct mmc_command cmd;
+    struct sd_cmd_pkt cmd_info;
+    int err=0;
+    int bMalloc=0;
+    struct mmc_host * mmc = mmc_host_local;
+
+    memset(&cmd, 0, sizeof(struct mmc_command));
+    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+    cmd.opcode         = MMC_SEND_STATUS;
+    cmd.arg            = (1<<RCA_SHIFTER);
+    cmd_info.cmd       = &cmd;
+    cmd_info.sdport    = sdport;
+    cmd_info.rsp_para2  = SD_R1;
+    cmd_info.rsp_len   = rtksd_get_rsp_len(SD_R1);
+
+    gPreventRetry=1;
+    err = SD_SendCMDGetRSP(&cmd_info,0);
+    gPreventRetry=0;
+
+    if(err){
+        mmcmsg3(KERN_WARNING "%s: MMC_SEND_STATUS fail\n",DRIVER_NAME);
+    }else{
+        u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
+        *state = cur_state;
+        mmcmsg1("cur_state=%s\n",state_tlb[cur_state]);
+    }
+
+    return err;
+}
+
+static int rtksd_send_status(struct mmc_card *card,u16 * state,u8 divider,int bIgnore)
+{
+    struct mmc_command cmd;
+    struct sd_cmd_pkt cmd_info;
+    int err=0;
+    int bMalloc=0;
+    struct mmc_host * mmc = mmc_host_local;
+    struct rtksd_host *sdport = mmc_priv(mmc);
+
+    memset(&cmd, 0, sizeof(struct mmc_command));
+    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+    if (card == NULL)
+    {
+	bMalloc=1;
+	card = (struct mmc_card*)kmalloc(sizeof(struct mmc_card),GFP_KERNEL);
+	card->host = mmc;
+    }
+	
+    set_cmd_info(card,&cmd,&cmd_info,
+                 MMC_SEND_STATUS,
+                 (card->rca)<<RCA_SHIFTER,
+                 SD_R1|divider);
+    err = SD_SendCMDGetRSP(&cmd_info,bIgnore);
+
+    if (bMalloc)
+    {
+	kfree(card);
+	card = NULL;
+    }
+
+    if(err){
+        mmcmsg3(KERN_WARNING "%s: MMC_SEND_STATUS fail\n",DRIVER_NAME);
+    }else{
+        u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
+        *state = cur_state;
+	if (!bIgnore)
+        	printk(KERN_INFO "cur_state=%s\n",state_tlb[cur_state]);
+    }
+
+    return err;
+}
+
+static int rtksd_switch_user_partition(struct mmc_card *card)
+{
+    struct mmc_command cmd;
+    struct sd_cmd_pkt cmd_info;
+    int err = 0;
+
+    MMCPRINTF("\n");
+
+    memset(&cmd, 0, sizeof(struct mmc_command));
+    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+    set_cmd_info(card,&cmd,&cmd_info,
+                 MMC_SWITCH,
+                 0x03b30001,
+                 SD_R1b);
+    err = SD_SendCMDGetRSP_Cmd(&cmd_info,0);
+
+    if(err){
+        mmcmsg3(KERN_WARNING "%s: MMC_SWITCH fail\n",DRIVER_NAME);
+    }
+    return err;
+
+}
+
+#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
+//#define HACK_BOOT_PART_RW
+
+#define NORMAL_PART 0
+#define BOOT1_PART  1
+#define BOOT2_PART  2
+#define GP1_PART    3
+#define GP2_PART    4
+#define GP3_PART    5
+#define GP4_PART    6
+
+#ifdef HACK_BOOT_PART_RW
+static int rtksd_switch_partition(struct mmc_card *card,u8 acc_part)
+{
+
+    rtksd_switch(card,
+                 MMC_SWITCH_MODE_WRITE_BYTE,
+                 EXT_CSD_PART_CONFIG,
+                 acc_part,
+                 EXT_CSD_CMD_SET_NORMAL);
+
+    return 0;
+
+}
+#endif
+
+static int rtksd_switch(struct mmc_card *card,
+                        u8 acc_mod,
+                        u8 index,
+                        u8 value,
+                        u8 cmd_set)
+{
+    struct mmc_command cmd;
+    struct sd_cmd_pkt cmd_info;
+    u32 arg = 0;
+    int err = 0;
+    int bMalloc=0;
+    struct mmc_host *mmc = mmc_host_local;
+
+    memset(&cmd, 0, sizeof(struct mmc_command));
+    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+    if (card == NULL)
+    {
+	bMalloc=1;
+	card = (struct mmc_card*)kmalloc(sizeof(struct mmc_card),GFP_KERNEL);
+	card->host = mmc;
+    }
+
+    arg = (acc_mod << 24) |
+          (index <<16) |
+          (value << 8) |
+          (cmd_set);
+
+    MMCPRINTF("%s : arg=0x%08x\n",__func__,arg);
+    set_cmd_info(card,&cmd,&cmd_info,
+                 MMC_SWITCH,
+                 arg,
+                 SD_R1b);
+
+    err = SD_SendCMDGetRSP_Cmd(&cmd_info,0);
+    if (bMalloc)
+    {
+	kfree(card);
+	card = NULL;
+    }
+
+    if(err){
+        mmcmsg3(KERN_WARNING "%s: MMC_SWITCH fail\n",DRIVER_NAME);
+    }
+    return err;
+
+}
+#endif
+
+/****************************************************************
+ *  tuning area
+ * 
+****************************************************************/
+void mmc_CRT_reset(struct rtksd_host *sdport)
+{
+        u32 iobase = sdport->base_io;
+        u32 tmp32 = 0;
+
+        if (!sdport)
+                BUG();
+
+	sync();
+        rtkemmc_backup_registers(sdport);
+	sync();
+        cr_writel(cr_readl(SYS_SOFT_RESET2)&((u32)~(1<<11)), SYS_SOFT_RESET2);          //reset emmc
+	sync();
+        cr_writel(cr_readl(SYS_CLOCK_ENABLE1)&((u32)~(1<<24)), SYS_CLOCK_ENABLE1);      //disable emmc clk
+	sync();
+        cr_writel(cr_readl(SYS_CLOCK_ENABLE1)|(1<<24), SYS_CLOCK_ENABLE1);      //disable emmc clk
+	sync();
+        cr_writel(cr_readl(SYS_SOFT_RESET2)|(1<<11), SYS_SOFT_RESET2);          //reset emmc
+	sync();
+        rtkcr_set_pad_driving(sdport,MMC_IOS_SET_PAD_DRV, 0xff,0xff,0xff);
+        rtkemmc_restore_registers(sdport);
+        sync();
+}
+
+void mmc_Phase_Adjust(struct rtksd_host *sdport, u32 VP0, u32 VP1)
+{
+	u32 iobase = sdport->base_io;
+//phase selection
+	if((VP0==0xff) & (VP1==0xff)){
+		#ifdef MMC_DEBUG		
+		MMCPRINTF("Phase VP0 and VP1 no change \n");
+		#endif	
+		}
+	else if((VP0!=0xff) & (VP1==0xff)){
+		#ifdef MMC_DEBUG		
+		MMCPRINTF("Phase VP0=%x, VP1 no change \n", VP0);
+		#endif	
+		cr_writel(cr_readl(iobase+EMMC_CKGEN_CTL)|0x70000, iobase+EMMC_CKGEN_CTL); 		//change clk to 4Mhz
+		cr_writel(cr_readl(PLL_EMMC1)&0xfffffffd, PLL_EMMC1); 		 			//reset pll
+		cr_writel(((cr_readl(PLL_EMMC1)&0xffffff07)|(VP0<<3)), PLL_EMMC1); 			//vp0 phase:0x0~0x1f
+		cr_writel(cr_readl(PLL_EMMC1)|0x2, PLL_EMMC1); 		 				//release reset pll	
+		cr_writel(cr_readl(iobase+EMMC_CKGEN_CTL)&0xfff8ffff, iobase+EMMC_CKGEN_CTL); 		//change clock to PLL
+		cr_writel(cr_readl(iobase+SD_CONFIGURE1)&0xef, iobase+SD_CONFIGURE1);
+		}
+	else if((VP0==0xff) & (VP1!=0xff)){
+		#ifdef MMC_DEBUG		
+		MMCPRINTF("Phase VP0 no change, VP1=%x \n", VP1);
+		#endif	
+		cr_writel(cr_readl(iobase+EMMC_CKGEN_CTL)|0x70000, iobase+EMMC_CKGEN_CTL); 		//change clk to 4Mhz
+		cr_writel(cr_readl(PLL_EMMC1)&0xfffffffd, PLL_EMMC1); 		 			//reset pll
+		cr_writel(((cr_readl(PLL_EMMC1)&0xffffe0ff)|(VP1<<8)), PLL_EMMC1); 			//vp0 phase:0x0~0x1f
+		cr_writel(cr_readl(PLL_EMMC1)|0x2, PLL_EMMC1); 		 				//release reset pll	
+		cr_writel(cr_readl(iobase+EMMC_CKGEN_CTL)&0xfff8ffff, iobase+EMMC_CKGEN_CTL); 		//change clock to PLL
+		cr_writel(cr_readl(iobase+SD_CONFIGURE1)&0xef, iobase+SD_CONFIGURE1);
+		}
+	else{
+		#ifdef MMC_DEBUG		
+		MMCPRINTF("Phase VP0=%x, VP1=%x \n", VP0, VP1);
+		#endif	
+		cr_writel(cr_readl(iobase+EMMC_CKGEN_CTL)|0x70000, iobase+EMMC_CKGEN_CTL); 		//change clk to 4Mhz
+		cr_writel(cr_readl(PLL_EMMC1)&0xfffffffd, PLL_EMMC1); 		 			//reset pll
+		cr_writel(((cr_readl(PLL_EMMC1)&0xffffff07)|(VP0<<3)), PLL_EMMC1); 			//vp0 phase:0x0~0x1f
+		cr_writel(((cr_readl(PLL_EMMC1)&0xffffe0ff)|(VP1<<8)), PLL_EMMC1); 			//vp1 phase:0x0~0x1f
+		cr_writel(cr_readl(PLL_EMMC1)|0x2, PLL_EMMC1); 		 				//release reset pll
+		cr_writel(cr_readl(iobase+EMMC_CKGEN_CTL)&0xfff8ffff, iobase+EMMC_CKGEN_CTL); 		//change clock to PLL
+		cr_writel(cr_readl(iobase+SD_CONFIGURE1)&0xef, iobase+SD_CONFIGURE1);
+		}
+	udelay(300);
+	sync();
+	sync();
+}
+
+int SEARCH_BEST(u32 window)
+{
+	int i, j, k, max;
+	int window_temp[32];
+	int window_start[32];
+	int window_end[32];	
+	int window_max=0;	
+	int window_best=0;	
+	int parse_end=1;
+	for( i=0; i<0x20; i++ ){
+		window_temp[i]=0;	
+		window_start[i]=0;	
+		window_end[i]=-1;	
+		}
+	j=1;
+	i=0;
+	k=0;
+	max=0;
+	while((i<0x1f) && (k<0x1f)){	
+		parse_end=0;
+		for( i=window_end[j-1]+1; i<0x20; i++ ){
+			if (((window>>i)&1)==1 ){
+				window_start[j]=i;
+//				parse_end=1;
+//				printk("window_start=0x%x \n", window_start[j]);
+				break;
+				}
+			}	
+//		printk("i=0x%x \n", i);
+		if( i==0x20){			
+			break;
+			}	
+		for( k=window_start[j]+1; k<0x20; k++ ){
+			if(((window>>k)&1)==0){
+				window_end[j]=k-1;
+				parse_end=1;
+	//			printk("test \n");
+				break;			
+				}
+			}
+		if(parse_end==0){
+			window_end[j]=0x1f;
+			}				
+//			printk("window_end=0x%x \n", window_end[j]);
+			j++;
+		}	
+	for(i=1; i<j; i++){
+		window_temp[i]= window_end[i]-window_start[i]+1;
+//		printk("window temp=0x%x \n", window_temp[i]);			
+		}	
+	if(((window&1)==1)&&(((window>>0x1f)&1)==1))
+	{
+		window_temp[1]=window_temp[1]+window_temp[j-1];
+		window_start[1]=window_start[j-1];
+//		printk("merge \n");			
+		}
+	for(i=1; i<j; i++){
+		if(window_temp[i]>window_max){
+			window_max=window_temp[i];
+			max=i;
+			}
+		}
+	if((((window&1)==1)&&(((window>>0x1f)&1)==1))&&(max==1)){
+		window_best=((window_start[max]+window_end[max]+0x20)/2)&0x1f;
+		
+		}
+	else {
+		window_best=((window_start[max]+	window_end[max])/2)&0x1f;	
+		}	
+	MMCPRINTF("window start=0x%x \n", window_start[max]);	
+	MMCPRINTF("window end=0x%x \n", window_end[max]);	
+	MMCPRINTF("window best=0x%x \n", window_best);	
+	return window_best;
+}	
+
+static int mmc_Tuning_HS200(struct rtksd_host *sdport){
+	volatile u32 TX_window=0xffffffff;
+	int TX_fail_start=-1;
+	int TX_fail_end=0x20;
+	int TX_pass_start=-1;
+	int TX_pass_end=0x20;
+	volatile int TX_best=0xff;	
+	volatile u32 RX_window=0xffffffff;
+	int RX_fail_start=-1;
+	int RX_fail_end=0x20;
+	int RX_pass_start=-1;
+	int RX_pass_end=0x20;
+	u32 iobase = sdport->base_io;
+	volatile int RX_best=0xff;	
+	volatile int i=0;
+	unsigned long flags=0;
+
+    	down_write(&cr_rw_sem);
+	g_bTuning=1;
+	if (!g_bResuming)	
+		gCurrentBootMode = MODE_SD30;
+	MMCPRINTF("[LY]hs200 gCurrentBootMode =%d\n",gCurrentBootMode);
+
+	rtkcr_set_ldo(sdport,0xaf);
+        rtkcr_set_speed(sdport,0);        //no wrapper divider
+	rtkcr_set_pad_driving(sdport,MMC_IOS_SET_PAD_DRV, 0xff,0xff,0xff);
+	mmc_Phase_Adjust(sdport, 0, 0);	//VP0, VP1 phas	
+	udelay(100);
+	sync();
+	MMCPRINTF("==============Start HS200 TX Tuning ==================\n");
+	for(i=0x0; i<0x20; i++){
+		mmc_Phase_Adjust(sdport, i, 0xff);
+		#ifdef MMC_DEBUG		
+		printk("phase =0x%x \n", i);
+		#endif
+		if(rtkcr_send_cmd25(sdport) != 0)
+		{
+			TX_window= TX_window&(~(1<<i));
+		}
+	}
+	TX_best = SEARCH_BEST(TX_window);
+	MMCPRINTF("TX_WINDOW= 0x%x \n", TX_window);
+	MMCPRINTF("TX phase fail from 0x%x to=0x%x \n", TX_fail_start, TX_fail_end);
+	MMCPRINTF("TX phase pass from 0x%x to=0x%x \n", TX_pass_start, TX_pass_end);
+	MMCPRINTF("TX_best= 0x%x \n", TX_best);
+	printk(KERN_INFO "[%s:HS200] TX_WINDOW=0x%x, TX_best=0x%x \n",DRIVER_NAME,TX_window, TX_best);
+	if (TX_window == 0x0)
+	{
+		printk(KERN_WARNING "[%s:HS200] TX tuning fail \n", DRIVER_NAME);
+		g_bTuning=0;
+    		up_write(&cr_rw_sem);
+		return -1;
+	}
+	mmc_Phase_Adjust(sdport, TX_best, 0xff);
+	MMCPRINTF("++++++++++++++++++ Start HS200 RX Tuning ++++++++++++++++++\n");
+	i=0;
+	for(i=0x0; i<0x20; i++){
+		mmc_Phase_Adjust(sdport, 0xff, i);
+		#ifdef MMC_DEBUG		
+		MMCPRINTF("phase =0x%x \n", i);
+		#endif
+		if(rtkcr_send_cmd18(sdport)!=0)
+		{
+			RX_window= RX_window&(~(1<<i));
+			}
+	}
+	RX_best = SEARCH_BEST(RX_window);
+	MMCPRINTF("RX_WINDOW= 0x%x \n", RX_window);
+	MMCPRINTF("RX phase fail from 0x%x to=0x%x \n", RX_fail_start, RX_fail_end);
+	MMCPRINTF("RX phase pass from 0x%x to=0x%x \n", RX_pass_start, RX_pass_end);
+	MMCPRINTF("RX_best= 0x%x \n", RX_best);
+	printk(KERN_INFO "[%s:HS200] RX_WINDOW=0x%x, RX_best=0x%x \n",DRIVER_NAME,RX_window, RX_best);
+	if (RX_window == 0x0)
+	{
+		printk(KERN_WARNING "[%s:HS200] RX tuning fail \n", DRIVER_NAME);
+		g_bTuning=0;
+    		up_write(&cr_rw_sem);
+		return -2;
+	}
+	mmc_Phase_Adjust(sdport, 0xff, RX_best);
+	mmc_CRT_reset(sdport);
+	g_bTuning=0;
+    	up_write(&cr_rw_sem);
+	return 0;
+}
+	
+static int mmc_Tuning_DDR50(struct rtksd_host *sdport){	
+	volatile u32 TX_window=0xffffffff;
+	int TX_fail_start=-1;
+	int TX_fail_end=0x20;
+	int TX_pass_start=-1;
+	int TX_pass_end=0x20;
+	volatile int TX_best=0xff;	
+	volatile u32 RX_window=0xffffffff;
+	int RX_fail_start=-1;
+	int RX_fail_end=0x20;
+	int RX_pass_start=-1;
+	int RX_pass_end=0x20;
+	volatile int RX_best=0xff;	
+	volatile int i=0;
+	volatile int ret_state=0;
+	volatile int err = 0;
+	unsigned long flags=0;
+		
+	//set current boot mode
+    	down_write(&cr_rw_sem);
+	g_bTuning=1;
+	if (!g_bResuming)	
+		gCurrentBootMode = MODE_DDR;	
+	printk("[LY]ddr50 gCurrentBootMode =%d\n",gCurrentBootMode);
+
+	rtkcr_set_ldo(sdport, 0x57); //50Mhz
+	rtkcr_set_speed(sdport, 0);    //no wrapper divider
+	rtkcr_set_pad_driving(sdport,MMC_IOS_SET_PAD_DRV, 0x66,0x64,0x66);
+	cr_writeb(0xa8, sdport->base_io+SD_SAMPLE_POINT_CTL);	//Using phase-shift clock for DDR mode command/data sample point selection
+	cr_writeb(0x90, sdport->base_io+SD_PUSH_POINT_CTL);	//Using phase-shift clock for DDR mode command/data push point selection
+	udelay(100);
+	sync();
+	MMCPRINTF("==============Start DDR50 TX Tuning ==================\n");
+	for(i=0x0; i<0x20; i++){
+		mmc_Phase_Adjust(sdport, i, 0xff);
+		#ifdef MMC_DEBUG
+		MMCPRINTF("phase (%d) - VP=0x%08x\n", i,REG32(PLL_EMMC1));
+		#endif
+		if (rtkcr_send_cmd25(sdport)!=0)
+		{
+				TX_window= TX_window&(~(1<<i));
+		}
+	}
+	TX_best = SEARCH_BEST(TX_window);
+	MMCPRINTF("TX_WINDOW= 0x%x \n", TX_window);
+	MMCPRINTF("TX phase fail from 0x%x to=0x%x \n", TX_fail_start, TX_fail_end);
+	MMCPRINTF("TX phase pass from 0x%x to=0x%x \n", TX_pass_start, TX_pass_end);
+	MMCPRINTF("TX_best= 0x%x \n", TX_best);
+	printk(KERN_INFO "[%s:DDR50] TX_WINDOW=0x%x, TX_best=0x%x \n",DRIVER_NAME,TX_window, TX_best);
+	if (TX_window == 0x0)
+	{
+		printk(KERN_WARNING "[%s:DDR50] TX tuning fail \n", DRIVER_NAME);
+		g_bTuning=0;
+    		up_write(&cr_rw_sem);
+		return -1;
+	}
+	mmc_Phase_Adjust(sdport, TX_best, 0xff);
+
+	sync();
+	MMCPRINTF("++++++++++++++Start DDR50 RX Tuning ++++++++++++++++++\n");
+	i=0;
+	for(i=0x0; i<0x20; i++){
+		mmc_Phase_Adjust(sdport, 0xff, i);
+		#ifdef MMC_DEBUG		
+		MMCPRINTF("phase =0x%x \n", i);
+		#endif
+		if(rtkcr_send_cmd18(sdport)!=0)
+		{
+			RX_window= RX_window&(~(1<<i));
+		}
+	}
+	RX_best = SEARCH_BEST(RX_window);
+	MMCPRINTF("RX phase fail from 0x%x to=0x%x \n", RX_fail_start, RX_fail_end);
+	MMCPRINTF("RX phase pass from 0x%x to=0x%x \n", RX_pass_start, RX_pass_end);
+	MMCPRINTF("RX_best= 0x%x \n", RX_best);
+	printk(KERN_INFO "[%s:DDR50] RX_WINDOW=0x%x, RX_best=0x%x \n",DRIVER_NAME,RX_window, RX_best);
+	sync();
+	if (RX_window == 0x0)
+	{
+		printk(KERN_WARNING "[%s:DDR50] RX tuning fail \n", DRIVER_NAME);
+		g_bTuning=0;
+    		up_write(&cr_rw_sem);
+		return -2;
+	}
+	mmc_Phase_Adjust(sdport, 0xff, RX_best);
+	g_bTuning=0;
+    	up_write(&cr_rw_sem);
+	return 0;
+}
+
+static int mmc_Select_SDR50_Push_Sample(struct rtksd_host *sdport){			
+	volatile int err=0;
+	volatile int ret_state=0;
+	struct mmc_host *host = sdport->mmc;
+	struct mmc_host host_priv;
+	struct mmc_card card_priv;
+	u32 iobase = sdport->base_io;
+	unsigned long flags=0;
+
+    	down_write(&cr_rw_sem);
+	g_bTuning = 1;
+	if (!g_bResuming)	
+		gCurrentBootMode = MODE_SD20;
+	MMCPRINTF("[LY]sdr gCurrentBootMode =%d\n",gCurrentBootMode);
+    	cr_writeb( 0x0,  sdport->base_io+SD_SAMPLE_POINT_CTL );   //sample point = SDCLK / 4
+    	cr_writeb( 0x0, sdport->base_io+SD_PUSH_POINT_CTL );     //output ahead SDCLK /4 
+	rtkcr_set_ldo(sdport, 0x57); //50Mhz
+	rtkcr_set_speed(sdport, 0);    //no wrapper divider
+	//for sdr50, don't set pad driving
+	//rtkcr_set_pad_driving(sdport,MMC_IOS_SET_PAD_DRV, 0,0,0);
+      	rtkcr_set_div(sdport, EMMC_CLOCK_DIV_NON);
+	sync();	
+	udelay(100);
+	MMCPRINTF("==============Select SDR50 Push Point ==================\n");
+	if ((err = rtkcr_send_cmd25(sdport))==0)
+	{
+		MMCPRINTF("Output at FALLING edge of SDCLK \n");
+	}
+	else
+	{
+		cr_writeb(0x10, iobase+SD_PUSH_POINT_CTL);	//Push point =output at falling edge
+		sync();
+		if ((err = rtkcr_send_cmd25(sdport))==0)
+		{
+			MMCPRINTF("Output is ahead by 1/4 SDCLK period \n");		
+		}
+		else 
+		{
+			printk(KERN_ERR "sdr tuning : No good push point \n");
+			g_bTuning = 0;
+    			up_write(&cr_rw_sem);
+			return -1;			
+		}
+	}
+
+	MMCPRINTF("++++++++++++++Select SDR50 Sample Point ++++++++++++++++++\n");
+	if ((err = rtkcr_send_cmd18(sdport))==0)
+	{
+			MMCPRINTF("Sample at RISING edge of SDCLK \n");		
+	}
+	else {
+		cr_writeb(8, iobase+SD_SAMPLE_POINT_CTL);	//sample point is delayed by 1/4 SDCLK period
+		sync();
+		if ((err = rtkcr_send_cmd18(sdport))==0)
+		{
+			MMCPRINTF("sample point is delayed by 1/4 SDCLK period \n");
+		}
+		else {
+			printk(KERN_ERR "sdr tuning : No good Sample point \n");
+			g_bTuning = 0;
+    			up_write(&cr_rw_sem);
+			return -2;					
+		}
+	}
+	sync();
+	printk(KERN_INFO "SDR select (sample/push) : 0x%02x/0x%02x\n", cr_readb(sdport->base_io+SD_SAMPLE_POINT_CTL), cr_readb(sdport->base_io+SD_PUSH_POINT_CTL));
+	g_bTuning = 0;
+    	up_write(&cr_rw_sem);
+
+	return 0;
+}
+
+int sample_ctl_switch(struct rtksd_host *sdport, int cmd_idx, int bIgnore)
+{
+	int err=0;
+	u8 ret_state=0;
+	int retry_cnt=5;
+	int mode_val=0;
+	u32 iobase = sdport->base_io;
+	struct mmc_host *host = sdport->mmc;
+	static int bErrorRetry=0;
+	int sts1_val=0;
+
+	mode_val = rtkcr_get_mode_selection(sdport);
+	printk(KERN_INFO "cur point: s:0x%02x, p:0x%02x, mode=0x%02x\n",cr_readb(sdport->base_io+SD_SAMPLE_POINT_CTL),cr_readb(sdport->base_io+SD_PUSH_POINT_CTL),mode_val);
+		switch(bErrorRetry)
+		{
+			case 0:
+                    		cr_writeb( 0x0, iobase+SD_SAMPLE_POINT_CTL );    //sample point = SDCLK / 4
+                    		cr_writeb( 0x10, iobase+SD_PUSH_POINT_CTL );     //output ahead SDCLK /4 
+                    		printk(KERN_INFO "mode switch 0x0/0x10\n");
+				bErrorRetry++;
+				break;
+			case 1:
+                    		cr_writeb( 0x8, iobase+SD_SAMPLE_POINT_CTL );    //sample point = SDCLK / 4
+                    		cr_writeb( 0x10, iobase+SD_PUSH_POINT_CTL );     //output ahead SDCLK /4 
+                    		printk(KERN_INFO "mode switch 0x8/0x10\n");
+				bErrorRetry++;
+				break;
+			case 2:
+                    		cr_writeb( 0x8, iobase+SD_SAMPLE_POINT_CTL );    //sample point = SDCLK / 4
+                    		cr_writeb( 0x0, iobase+SD_PUSH_POINT_CTL );     //output ahead SDCLK /4 
+                    		printk(KERN_INFO "mode switch 0x8/0x0\n");
+				bErrorRetry++;
+				break;
+			case 3:
+                    		cr_writeb( 0x0, iobase+SD_SAMPLE_POINT_CTL );    //sample point = SDCLK / 4
+                    		cr_writeb( 0x0, iobase+SD_PUSH_POINT_CTL );     //output ahead SDCLK /4 
+                    		printk(KERN_INFO "mode switch 0x0/0x0\n");
+				bErrorRetry=0;
+				break;
+		}
+		sync();
+                udelay(100);
+                cr_writeb(0x14,iobase+CR_CARD_STOP);
+		sync();
+                udelay(100);
+
+	if((cmd_idx != MMC_SET_BLOCKLEN)&&(cmd_idx > MMC_SET_RELATIVE_ADDR))
+	{
+		err = polling_to_tran_state(sdport,bIgnore);
+		sts1_val = cr_readb(iobase+SD_STATUS1);
+		sync();
+		if ((sts1_val&WRT_ERR_BIT)||(sts1_val&CRC16_STATUS)||(sts1_val&CRC7_STATUS))
+		{
+			host_card_stop(sdport);
+			//rtksd_stop_transmission(host->card,1);
+		}
+		#if 0
+		while(retry_cnt-- && err)
+		{
+			err = rtksd_send_status(host->card,&ret_state,0,bIgnore);
+		}
+		if (ret_state == STATE_DATA)
+		{
+			#ifdef MMC_DEBUG
+			printk("before send stop\n");	
+			#endif
+			mmc_send_stop(host->card);
+			err = mmccr_wait_status(STATE_TRAN);
+			#ifdef MMC_DEBUG
+			printk("before send stop: err=%d\n",err);
+			#endif
+		}
+		else if (ret_state == STATE_RCV)
+		{
+			#ifdef MMC_DEBUG
+			printk("before send stop\n");	
+			#endif
+			mmc_send_stop(host->card);
+			err = mmccr_wait_status(STATE_TRAN);
+			#ifdef MMC_DEBUG
+			printk("before send stop: err=%d\n",err);
+			#endif
+		}
+		#endif	
+	}
+
+	return err;
+}
+/****************************************************************
+ *  error handling area
+ * 
+****************************************************************/
+int error_handling(struct rtksd_host *sdport, unsigned int cmd_idx, unsigned int bIgnore)
+{
+	u32 iobase = sdport->base_io;
+        unsigned char sts1_val=0;
+        int err=0;
+	struct mmc_host *host = sdport->mmc;
+        extern unsigned char g_ext_csd[];
+
+                printk(KERN_INFO "%s : status1 val=%02x, cmd_idx=0x%02x, gCurrentBootMode=0x%02x\n", __func__, sts1_val,cmd_idx,gCurrentBootMode);
+                host_card_stop(sdport);
+		if (cmd_idx > MMC_SET_RELATIVE_ADDR)
+		{
+                  polling_to_tran_state(sdport,bIgnore);
+                  sts1_val = cr_readb(iobase+SD_STATUS1);
+                  if ((sts1_val&WRT_ERR_BIT)||(sts1_val&CRC16_STATUS)||(sts1_val&CRC7_STATUS))
+                  {
+                        rtksd_stop_transmission(host->card,bIgnore);
+                  }
+		}
+
+                if (bIgnore)
+                        return 0;
+		//till here, we are good to go
+                if(gCurrentBootMode >= MODE_DDR)
+                {
+                        printk(KERN_INFO "change mode from %d to %d ---> \n", gCurrentBootMode,MODE_SD20);
+                        //flush_cache((unsigned long)g_ext_csd, CSD_ARRAY_SIZE);
+                        #ifdef MMC_DEBUG
+                        mmc_show_ext_csd(g_ext_csd);
+                        #endif
+			if (gCurrentBootMode == MODE_SD30)
+			{
+				//TBD, way to change to HS / SDR
+				//ddr50
+                		//err = mmc_select_ddr50(mmc,g_ext_csd);
+				//mmc->boot_caps &= ~MMC_MODE_HSDDR_52MHz;
+			}
+			else 
+			{	//sdr50
+                		//err = mmc_select_sdr50(mmc,g_ext_csd);
+				//mmc->boot_caps &= ~MMC_MODE_HS200;
+			}
+                        if (err)
+                                printk(KERN_ERR " change mode result ==> fail\n");
+                        else
+                        {
+                                printk(KERN_INFO " change mode result ==> successful\n");
+                        }
+                }
+                else
+                {
+                   MMCPRINTF("%s : gCurrentBootMode = %d\n", __func__,gCurrentBootMode);
+                   err = sample_ctl_switch(sdport,cmd_idx,bIgnore);
+                }
+                if (err)
+                        printk(KERN_ERR "[LY] error handling fail\n");
+        return err;
+}
+
+int polling_to_tran_state(struct rtksd_host *sdport,int bIgnore)
+{
+	u32 iobase = sdport->base_io;
+	int err=1, retry_cnt=5;
+	int ret_state=0;
+	struct mmc_host *host = sdport->mmc;
+    	
+	MMCPRINTF("%s : \n", __func__);
+
+                err=1;
+                retry_cnt=5;
+                while(retry_cnt-- && err)
+                {
+                        err = rtksd_send_status(host->card,&ret_state,0,bIgnore);
+                }
+		sync();
+                if (ret_state == STATE_DATA)
+                {
+                        #ifdef MMC_DEBUG
+                        printk("before send stop\n");
+                        #endif
+                        rtksd_stop_transmission(host->card,1);
+                        err = rtksd_wait_status(host->card,STATE_TRAN,0,bIgnore);
+                        #ifdef MMC_DEBUG
+                        printk("before send stop: err=%d\n",err);
+                        #endif
+                }
+                else if (ret_state == STATE_RCV)
+                {
+                        #ifdef MMC_DEBUG
+                        printk("before send stop\n");
+                        #endif
+                        rtksd_stop_transmission(host->card,1);
+                        err = rtksd_wait_status(host->card,STATE_TRAN,0,bIgnore);
+                        #ifdef MMC_DEBUG
+                        printk("before send stop: err=%d\n",err);
+                        #endif
+                }
+		sync();
+	return err;
+}
+
+//int rtkcr_send_cmd8(struct sd_cmd_pkt * cmd_info, unsigned int bIgnore)
+int rtkcr_send_cmd8(struct rtksd_host *sdport, unsigned int bIgnore)
+{
+	int ret_err=0;
+    	struct sd_cmd_pkt cmd_info;
+	struct mmc_host *host = sdport->mmc;
+	volatile int err=1,retry_cnt=5;
+	int rsp_para1, rsp_para2, rsp_para3;
+	unsigned char cfg3=0,cfg1=0;
+	int sts1_val=0;
+	unsigned char *crd_ext_csd=NULL;
+	u32 iobase = sdport->base_io;
+	struct mmc_data *data=NULL;
+    	struct mmc_command *cmd=NULL;
+
+	memset(&cmd_info, 0x00, sizeof(struct sd_cmd_pkt));
+	
+	crd_ext_csd = rtksd_get_buffer_start_addr();
+	if (crd_ext_csd == NULL)
+	{
+		printk(KERN_ERR "%s,%s : crd_ext_csd == NULL\n",DRIVER_NAME,__func__);
+		return -5;
+	}
+
+	rsp_para1 = 0;
+	rsp_para2 = 0;
+	rsp_para3 = 0;
+	cfg3 = cr_readb(iobase+SD_CONFIGURE3)|SD_CMD_RSP_TO;
+	cfg1 = cr_readb(iobase+SD_CONFIGURE1)&(MASK_CLOCK_DIV|MASK_BUS_WIDTH|MASK_MODE_SELECT);
+	rsp_para1 = cfg1|SD1_R0;
+	rsp_para2 = SD_R1;
+	rsp_para3 = cfg3;
+
+	if (cmd_info.cmd == NULL)
+	{
+		cmd  = (struct mmc_command*) kmalloc(sizeof(struct mmc_command),GFP_KERNEL);
+		memset(cmd, 0x00, sizeof(struct mmc_command));
+		cmd_info.cmd  = (struct mmc_command*) cmd;
+	}
+	cmd_info.sdport = sdport;
+	cmd_info.cmd->arg=0;
+	cmd_info.cmd->opcode = MMC_SEND_EXT_CSD;
+	cmd_info.rsp_para1	  = rsp_para1;
+	cmd_info.rsp_para2	  = rsp_para2;
+	cmd_info.rsp_para3	  = rsp_para3;
+	cmd_info.rsp_len	 = rtksd_get_rsp_len(rsp_para2);
+	cmd_info.byte_count  = 0x200;
+	cmd_info.block_count = 1;
+	cmd_info.dma_buffer = crd_ext_csd;
+	if (cmd_info.cmd->data == NULL)
+	{
+		data  = (struct mmc_data*) kmalloc(sizeof(struct mmc_data),GFP_KERNEL);
+		memset(data, 0x00, sizeof(struct mmc_data));
+		cmd_info.cmd->data = data;
+		data->flags = MMC_DATA_READ;
+	}
+	else
+		cmd_info.cmd->data->flags = MMC_DATA_READ;
+	sync();
+	MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x -------\n", __FILE__, __FUNCTION__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card);
+	ret_err = SD_Stream_Cmd( EMMC_NORMALREAD, &cmd_info, bIgnore);
+	if (ret_err)
+	{
+		if (bIgnore)
+		{
+			goto err8;
+		}
+		MMCPRINTF("[LY] status1 val=%02x\n", sts1_val);
+		host_card_stop(sdport);
+		polling_to_tran_state(sdport,1);
+		sts1_val = cr_readb(iobase+SD_STATUS1);
+		if ((sts1_val&CRC16_STATUS)||(sts1_val&CRC7_STATUS))
+		{
+			rtksd_stop_transmission(host->card,1);
+		}
+        }
+err8:
+	if (cmd)
+	{
+		cmd_info.cmd = NULL;
+		kfree(cmd);
+		cmd=NULL;
+	}
+	if (data)
+	{
+		//cmd_info->cmd->data = NULL;
+		kfree(data);
+		data=NULL;
+	}
+	sync();
+	return ret_err;
+}
+int rtkcr_send_cmd18(struct rtksd_host *sdport)
+{
+	int ret_err=0;
+    	struct sd_cmd_pkt cmd_info;
+	struct mmc_host *host = sdport->mmc;
+	int sts1_val=0;
+	unsigned char *crd_tmp_buffer=NULL;
+	u32 iobase = sdport->base_io;
+	struct mmc_data *data=NULL;
+    	struct mmc_command *cmd=NULL;
+
+	memset(&cmd_info, 0x00, sizeof(struct sd_cmd_pkt));
+
+	crd_tmp_buffer = rtksd_get_buffer_start_addr();
+	if (crd_tmp_buffer == NULL)
+	{
+		printk(KERN_ERR "%s,%s : crd_ext_csd == NULL\n",DRIVER_NAME,__func__);
+		return -5;
+	}
+
+	if (cmd_info.cmd == NULL)
+	{
+		cmd  = (struct mmc_command*) kmalloc(sizeof(struct mmc_command),GFP_KERNEL);
+		memset(cmd, 0x00, sizeof(struct mmc_command));
+		cmd_info.cmd  = (struct mmc_command*) cmd;
+	}
+	cmd_info.sdport = sdport;
+	cmd_info.cmd->arg = 0x100;
+	cmd_info.cmd->opcode = MMC_READ_MULTIPLE_BLOCK;
+	cmd_info.rsp_para1	  = -1;
+	cmd_info.rsp_para2	  = SD_R1;
+	cmd_info.rsp_para3	  = -1;
+	cmd_info.rsp_len	 = rtksd_get_rsp_len(SD_R1);
+	cmd_info.byte_count  = 0x200;
+	cmd_info.block_count = 2;
+	cmd_info.dma_buffer = crd_tmp_buffer;
+	if (cmd_info.cmd->data == NULL)
+	{
+		data  = (struct mmc_data*) kmalloc(sizeof(struct mmc_data),GFP_KERNEL);
+		memset(data, 0x00, sizeof(struct mmc_data));
+		cmd_info.cmd->data = data;
+		data->flags = MMC_DATA_READ;
+	}
+	else
+		cmd_info.cmd->data->flags = MMC_DATA_READ;
+	MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x -------\n", __FILE__, __FUNCTION__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card);
+	ret_err = SD_Stream_Cmd(EMMC_AUTOREAD1, &cmd_info, 1);
+	if (ret_err)
+	{
+		MMCPRINTF("[LY] status1 val=%02x\n", sts1_val);
+		host_card_stop(sdport);
+		polling_to_tran_state(sdport,1);
+		sts1_val = cr_readb(iobase+SD_STATUS1);
+		if ((sts1_val&WRT_ERR_BIT)||(sts1_val&CRC16_STATUS)||(sts1_val&CRC7_STATUS)||(sts1_val&CRC_TIMEOUT_ERR))
+		{
+			rtksd_stop_transmission(host->card,1);
+		}
+	}
+err18:
+	if (cmd)
+	{
+		kfree(cmd);
+		cmd_info.cmd = NULL;
+		cmd=NULL;
+	}
+	if (data)
+	{
+		kfree(data);
+		//cmd_info.cmd->data = NULL;
+		data=NULL;
+	}
+	return ret_err;
+}
+int rtkcr_send_cmd25(struct rtksd_host *sdport)
+{
+	int ret_err=0,i=0;
+    	struct sd_cmd_pkt cmd_info;
+	struct mmc_host *host = sdport->mmc;
+	int sts1_val=0;
+	char *crd_tmp_buffer=NULL;
+	u32 iobase = sdport->base_io;
+	struct mmc_data *data=NULL;
+    	struct mmc_command *cmd=NULL;
+	unsigned long flags=0;
+
+	memset(&cmd_info, 0x00, sizeof(struct sd_cmd_pkt));
+	
+	crd_tmp_buffer = rtksd_get_buffer_start_addr();
+	if (crd_tmp_buffer == NULL)
+	{
+		printk(KERN_ERR "%s,%s : crd_ext_csd == NULL\n",DRIVER_NAME,__func__);
+		return -5;
+	}
+
+	for (i=0;i<0x400;i++)
+		crd_tmp_buffer[i] = i++;
+
+        //spin_lock_irqsave(&sdport->lock,flags);
+	if (cmd_info.cmd == NULL)
+	{
+		cmd  = (struct mmc_command*) kmalloc(sizeof(struct mmc_command),GFP_KERNEL);
+		memset(cmd, 0x00, sizeof(struct mmc_command));
+		cmd_info.cmd  = (struct mmc_command*) cmd;
+	}
+    	//spin_unlock(&sdport->lock);
+	cmd_info.sdport = sdport;
+	cmd_info.cmd->arg = 0xfe;
+	cmd_info.cmd->opcode = MMC_WRITE_MULTIPLE_BLOCK;
+	cmd_info.rsp_para1	  = -1;
+	cmd_info.rsp_para2	  = SD_R1;
+	cmd_info.rsp_para3	  = -1;
+	cmd_info.rsp_len	 = rtksd_get_rsp_len(SD_R1);
+	cmd_info.byte_count  = 0x200;
+	cmd_info.block_count = 2;
+	cmd_info.dma_buffer = crd_tmp_buffer;
+        //spin_lock_irqsave(&sdport->lock,flags);
+	if (cmd_info.cmd->data == NULL)
+	{
+		data  = (struct mmc_data*) kmalloc(sizeof(struct mmc_data),GFP_KERNEL);
+		memset(data, 0x00, sizeof(struct mmc_data));
+		cmd_info.cmd->data = data;
+		data->flags = MMC_DATA_WRITE;
+	}
+	else
+		cmd_info.cmd->data->flags = MMC_DATA_WRITE;
+    	//spin_unlock(&sdport->lock);
+	MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x , cmd=0x%08x, data=0x%08x-------\n", __FILE__, __FUNCTION__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card,cmd,data);
+	ret_err = SD_Stream_Cmd(EMMC_AUTOWRITE1, &cmd_info, 1);
+	if ((ret_err)&&!((g_bTuning)&&(gCurrentBootMode == MODE_SD20)))
+	{
+		MMCPRINTF("[LY] status1 val=%02x\n", sts1_val);
+		host_card_stop(sdport);
+		polling_to_tran_state(sdport,1);
+		sts1_val = cr_readb(iobase+SD_STATUS1);
+		sync();
+		if ((sts1_val&WRT_ERR_BIT)||(sts1_val&CRC16_STATUS)||(sts1_val&CRC7_STATUS))
+		{
+			host_card_stop(sdport);
+			//rtksd_stop_transmission(host->card,1);
+		}
+	}
+err25:
+	MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x , cmd=0x%08x, data=0x%08x-------\n", __FILE__, __FUNCTION__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card,cmd,data);
+#if 1
+        //spin_lock_irqsave(&sdport->lock,flags);
+	if (cmd)
+	{
+		cmd_info.cmd = NULL;
+		kfree(cmd);
+		cmd=NULL;
+	}
+	if (data)
+	{
+		//cmd_info.cmd->data = NULL;
+		kfree(data);
+		data=NULL;
+	}
+    	//spin_unlock(&sdport->lock);
+#endif
+	sync();
+	return ret_err;
+}
+void host_card_stop(struct rtksd_host *sdport){
+	MMCPRINTF("[LY] host_card_stop \n");
+	mmc_CRT_reset(sdport);
+	sync();
+}
+
+
+/***************************************************************
+ *  
+ ***************************************************************/
+static int rtksd_go_idle(struct mmc_card *card)
+{
+    struct mmc_command cmd;
+    struct sd_cmd_pkt cmd_info;
+    int err = 0;
+
+    MMCPRINTF("\n");
+
+    memset(&cmd, 0, sizeof(struct mmc_command));
+    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+    down_write(&cr_rw_sem);
+    bSendCmd0=1;
+    set_cmd_info(card,&cmd,&cmd_info,
+                 MMC_GO_IDLE_STATE,
+                 0x00,
+                 SD_R1);
+    err = SD_SendCMDGetRSP_Cmd(&cmd_info,0);
+    bSendCmd0=0;
+    up_write(&cr_rw_sem);
+
+    if(err){
+        mmcmsg3(KERN_WARNING "%s: MMC_GO_IDLE fail\n",DRIVER_NAME);
+    }
+    return err;
+
+}
+
+static int rtksd_stop_transmission(struct mmc_card *card,int bIgnore)
+{
+    struct mmc_command cmd;
+    struct sd_cmd_pkt cmd_info;
+    int err = 0;
+    int bMalloc=0;
+    struct mmc_host * mmc = mmc_host_local;
+
+    MMCPRINTF("%s : \n", __func__);
+
+    memset(&cmd, 0, sizeof(struct mmc_command));
+    memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+    
+    if (card == NULL)
+    {
+	bMalloc=1;
+	card = (struct mmc_card*)kmalloc(sizeof(struct mmc_card),GFP_KERNEL);
+	card->host = mmc;
+    }
+
+    set_cmd_info(card,&cmd,&cmd_info,
+                 MMC_STOP_TRANSMISSION,
+                 0x00,
+                 SD_R1|CRC16_CAL_DIS);
+    err = SD_SendCMDGetRSP_Cmd(&cmd_info,bIgnore);
+
+    if (bMalloc)
+    {
+	kfree(card);
+	card = NULL;
+    }
+    if(err){
+        mmcmsg3(KERN_WARNING "%s: MMC_STOP_TRANSMISSION fail\n",DRIVER_NAME);
+    }
+    return err;
+
+}
+
+static void set_cmd_info(struct mmc_card *card,struct mmc_command * cmd,
+                         struct sd_cmd_pkt * cmd_info,u32 opcode,u32 arg,u8 rsp_para)
+{
+    memset(cmd, 0, sizeof(struct mmc_command));
+    memset(cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+    cmd->opcode         = opcode;
+    cmd->arg            = arg;
+    cmd_info->cmd       = cmd;
+    cmd_info->sdport    = mmc_priv(card->host);
+    cmd_info->rsp_para2  = rsp_para;
+    cmd_info->rsp_len   = rtksd_get_rsp_len(rsp_para);
+}
+
+static struct rtk_host_ops emmc_ops = {
+    .func_irq       = NULL,
+    .re_init_proc   = NULL,
+    .card_det       = NULL,
+    .card_power     = NULL,
+	.chk_card_insert= rtkemmc_chk_card_insert,
+	.set_crt_muxpad = rtkemmc_set_crt_muxpad,
+	.set_clk        = NULL,
+	//we don't need to do the rst
+    .reset_card     = NULL,
+    .reset_host     = NULL,
+    .bus_speed_down = rtkemmc_bus_speed_down,
+    .get_cmdcode    = NULL, //rtk_get_emmc_cmdcode,
+    .get_r1_type    = NULL, //rtk_emmc_get_r1_type,
+    .chk_cmdcode    = rtkcr_chk_cmdcode,
+    .chk_r1_type    = rtkcr_chk_r1_type,
+    .backup_regs    = rtkemmc_backup_registers,
+    .restore_regs   = rtkemmc_restore_registers,
+};
+
+#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
+static int mmc_send_data_cmd(unsigned int hc_cmd,
+                        unsigned int cmd_arg,
+                        unsigned int blk_cnt,
+                        unsigned char * buffer)
+{
+    int err = 0;
+    //unsigned int rw_mode;
+    struct mmc_host * mmc = mmc_host_local;
+    unsigned long flags;
+
+    printk(KERN_ERR "cmd=%u, arg=0x%08x, size=0x%08x, buf=0x%p\n",
+            hc_cmd,cmd_arg,blk_cnt,buffer);
+    if(mmc){
+        struct rtksd_host *sdport = mmc_priv(mmc);
+        struct mmc_card *card = mmc->card;
+        struct mmc_request mrq = {0};
+        struct mmc_command cmd = {0};
+	    struct mmc_data	data   = {0};
+	    struct scatterlist sg;
+
+        sdport = mmc_priv(mmc);
+        mmc_claim_host(mmc);
+        spin_lock_irqsave(&sdport->lock,flags);
+
+        cmd.opcode = hc_cmd;
+        cmd.arg = cmd_arg;
+	    cmd.flags = MMC_RSP_R1 | MMC_CMD_ADTC;
+
+        if(blk_cnt)
+        {   //date info setting
+    		data.sg = &sg;
+    		data.sg_len = 1;
+    		data.blksz = 512;
+    		data.blocks = blk_cnt;
+
+    		sg_init_one(data.sg, buffer, (blk_cnt<<9));
+
+            if( hc_cmd == MMC_WRITE_MULTIPLE_BLOCK ||
+                hc_cmd == MMC_WRITE_BLOCK )
+            {
+    	        data.flags = MMC_DATA_WRITE;
+            }
+            else if( hc_cmd == MMC_SEND_EXT_CSD ||
+                     hc_cmd == MMC_READ_MULTIPLE_BLOCK ||
+                     hc_cmd == MMC_READ_SINGLE_BLOCK )
+            {
+    		    data.flags = MMC_DATA_READ;
+            }else{
+                printk(KERN_ERR "not supported command");
+                spin_unlock_irqrestore(&sdport->lock, flags);
+                goto ERR_OUT;
+            }
+
+            mmc_set_data_timeout(&data, card);
+        }
+
+	    data.mrq = &mrq;
+	    cmd.mrq = &mrq;
+	    cmd.data = &data;
+	    cmd.retries =3;
+
+CMD_RETRY:
+        mrq.data = &data;
+        mrq.cmd = &cmd;
+
+        if(sdport->mrq){
+            sdport->mrq = NULL;
+        }
+
+        cmd.error = 0;
+	    data.error = 0;
+
+        spin_unlock_irqrestore(&sdport->lock, flags);
+        mmc_wait_for_req(mmc, &mrq);
+        spin_lock_irqsave(&sdport->lock,flags);
+
+        err = cmd.error;
+
+        if(err && cmd.retries){
+            printk(KERN_ERR "%s(%u)last retry %d counter.\n",
+                    __func__,__LINE__,cmd.retries);
+            cmd.retries--;
+            goto CMD_RETRY;
+        }
+        spin_unlock_irqrestore(&sdport->lock, flags);
+        mmc_release_host(mmc);
+    }else{
+        err = -ENODEV;
+    }
+
+ERR_OUT:
+    if(err)
+        printk(KERN_ERR "err=%d\n",err);
+    return err;
+}
+
+static void show_ext_csd(u8 *ext_csd)
+{
+    int i;
+    for(i=0; i<512; i+=8){
+        printk(KERN_ERR
+            "[%03u]=%02x [%03u]=%02x [%03u]=%02x [%03u]=%02x "
+            "[%03u]=%02x [%03u]=%02x [%03u]=%02x [%03u]=%02x\n",
+            i,*(ext_csd+i),i+1,*(ext_csd+i+1),i+2,*(ext_csd+i+2),i+3,*(ext_csd+i+3),
+            i+4,*(ext_csd+i+4),i+5,*(ext_csd+i+5),i+6,*(ext_csd+i+6),i+7,*(ext_csd+i+7));
+    }
+    printk(KERN_ERR "\n");
+}
+
+#define PF2_SHOW_EXT_CSD 0x01UL
+#define PF2_FULL_PARAM   0x02UL
+#define PF2_SET_EXT_CSD  0x04UL
+
+#ifdef HACK_BOOT_PART_RW
+/*
+Note : this function not complete yet.
+*/
+static void hk_fill_bp(struct device *dev,
+                       size_t p_count,
+                       unsigned char *cr_param)
+{
+    u8 *emmc_buf;
+    //u32 i;
+    u32 param1;
+    u32 param2;
+    u32 param3;
+    u32 buf_size;
+    u8 part_config;
+    struct mmc_host *host;
+    struct mmc_card *card;
+
+    printk(KERN_ERR "%s(%u)3013/08/15 17:30\n",__func__,__LINE__);
+
+    host = dev_get_drvdata(dev);
+    if(host)
+        card = host->card;
+
+    if(card == NULL){
+        printk(KERN_ERR "card is not exist.\n");
+        goto ERR_OUT;
+    }
+
+    rtkcr_chk_param(&param1,8,cr_param);
+    rtkcr_chk_param(&param2,8,cr_param+9);
+    rtkcr_chk_param(&param3,8,cr_param+18);
+
+    printk(KERN_ERR "param1=0x%x\n",param1); //enh_start_addr
+    printk(KERN_ERR "param2=0x%x\n",param2); //enh_block_cnt
+    printk(KERN_ERR "param3=0x%x\n",param3);
+
+    buf_size = 512;
+    part_config = card->ext_csd.part_config;
+
+    if(host && card){
+        int idx;
+        printk(KERN_ERR "erased byte = 0x%x\n",card->erased_byte);
+        printk(KERN_ERR "part_config=0x%x\n",part_config);
+        printk(KERN_ERR "card's partition information\n");
+        for (idx = 0; idx < card->nr_parts; idx++) {
+	        if (card->part[idx].size) {
+	            printk(KERN_ERR "\n===> \nPART %u; name:%s\n",
+	                    idx,card->part[idx].name);
+	            printk(KERN_ERR "    part_cfg = 0x%x; size:0x%x\n",
+	                    card->part[idx].part_cfg,
+	                    card->part[idx].size >> 9);
+	            printk(KERN_ERR "    force_ro = 0x%x; area_type = 0x%x\n",
+	                    card->part[idx].force_ro,
+	                    card->part[idx].area_type);
+                if(card->part[idx].part_cfg < EXT_CSD_PART_CONFIG_ACC_GP0)
+                {
+                    printk(KERN_ERR "cfg: EXT_CSD_PART_CONFIG_ACC_BOOT%x\n",
+                        (card->part[idx].part_cfg)-EXT_CSD_PART_CONFIG_ACC_BOOT0);
+                }else{
+                    printk(KERN_ERR "cfg: EXT_CSD_PART_CONFIG_ACC_GP%u\n",
+                        (card->part[idx].part_cfg)-EXT_CSD_PART_CONFIG_ACC_GP0);
+                }
+                if(card->part[idx].area_type == MMC_BLK_DATA_AREA_MAIN)
+                    printk(KERN_ERR "type: MMC_BLK_DATA_AREA_MAIN\n");
+                if(card->part[idx].area_type == MMC_BLK_DATA_AREA_BOOT)
+                    printk(KERN_ERR "type: MMC_BLK_DATA_AREA_BOOT\n");
+                if(card->part[idx].area_type == MMC_BLK_DATA_AREA_GP)
+                    printk(KERN_ERR "type: MMC_BLK_DATA_AREA_GP\n");
+	        }
+        }
+    }
+
+    buf_size = 512 * 16;
+    emmc_buf = kmalloc(buf_size, GFP_KERNEL);
+    if(!emmc_buf){
+        printk(KERN_ERR "emmc_buf is NULL\n");
+        goto ERR_OUT;
+    }
+
+    memset(emmc_buf, 0, buf_size);
+
+    printk(KERN_ERR "emmc_buf=0x%p\n",emmc_buf);
+
+    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
+                      0,1,emmc_buf);
+
+    printk(KERN_ERR "[EXT_CSD] :\n");
+    show_ext_csd(emmc_buf);
+
+    rtksd_switch_partition(card,BOOT1_PART);
+
+    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
+                      0,1,emmc_buf);
+
+    printk(KERN_ERR "{F} [EXT_CSD] :\n");
+    show_ext_csd(emmc_buf);
+
+    if(*(emmc_buf+EXT_CSD_PART_CONFIG) & 0x01){
+        u32 boot_part_blk_cnt;
+
+        boot_part_blk_cnt = (*(emmc_buf+EXT_CSD_BOOT_MULT))<<8;
+        printk(KERN_ERR "have changed to boot partition 1. [%x block]\n",
+                boot_part_blk_cnt);
+
+        //mmc_send_data_cmd(MMC_READ_MULTIPLE_BLOCK,
+        //              0,boot_part_blk_cnt,emmc_buf);
+
+    }
+
+    kfree(emmc_buf);
+
+ERR_OUT:
+    return;
+}
+#endif
+
+static void hk_set_wr_rel(struct device *dev,
+                          size_t p_count,
+                          unsigned char *cr_param)
+{
+    u8 *emmc_buf;
+    u8 acc_mod;
+    u8 index;
+    u8 value;
+    u8 i;
+    u8 idx_lop;
+    u8 cmd_set;
+    u32 param1;
+    u32 param2;
+    u32 param3;
+    u32 buf_size;
+    struct mmc_host *host;
+    struct mmc_card *card = NULL;
+
+    printk(KERN_ERR "%s(%u)3013/08/15 17:30\n",__func__,__LINE__);
+
+    if( p_count != 38){
+        printk(KERN_ERR "Command format:\n"
+               "    echo set_wr_rel=param1,param2,param3 > emmc_hacking;\n"
+               "        param1[7:0] is value in byte you want to set.\n"
+               "        param2 :\n"
+               "            [bit0] TO show all ext_csd.\n"
+               "            [bit1] Send CMD6. if this bit is set.\n"
+               "                   param1 change to 32 bits parameter of argument of AMD6.\n"
+               "        param3 must be 2379beef to make sure you want to do this.\n"
+               "ex:\n"
+               "    echo set_wr_rel=00000001,00000000,2379beef > emmc_hacking;\n"
+               "        param1=0x00000001 enable user data area write reliability\n"
+               "        param2=0x00020000 do not show all ext_csd.\n"
+               "        param3=2379beef make sure that want to do this.\n"
+               "\n"
+               "    echo set_wr_rel=03a71f01,00000002,2379beef > emmc_hacking;\n"
+               "        param1=0x03a71f01 set ext_cse[0xa7], value=0x1f, cmd_set=1\n"
+               "        param2=0x00000002 send CMD6. param1 is argument in 32 bits.\n"
+               "        param3=2379beef make sure that want to do this.\n" );
+        goto ERR_OUT;
+    }
+
+    host = dev_get_drvdata(dev);
+    if(host)
+        card = host->card;
+
+    // KWarning: checked ok by alexkh@realtek.com
+    if(card == NULL){
+        printk(KERN_ERR "card is not exist.\n");
+        goto ERR_OUT;
+    }
+
+    rtkcr_chk_param(&param1,8,cr_param);
+    rtkcr_chk_param(&param2,8,cr_param+9);
+    rtkcr_chk_param(&param3,8,cr_param+18);
+
+    printk(KERN_ERR "param1=0x%x\n",param1);
+    printk(KERN_ERR "param2=0x%x\n",param2);
+    printk(KERN_ERR "param3=0x%x\n",param3);
+
+    if(param2 & PF2_FULL_PARAM){
+        printk(KERN_ERR "Send CMD6 alert\n");
+        acc_mod = (u8)((param1>>24)&0xff);
+        index   = (u8)((param1>>16)&0xff);
+        value   = (u8)((param1>> 8)&0xff);
+        cmd_set = (u8)(param1&0xff);
+    }else{
+        printk(KERN_ERR "Enable Write Reliability\n");
+        acc_mod = MMC_SWITCH_MODE_WRITE_BYTE;
+        index   = EXT_CSD_WR_REL_SET;
+        value   = (u8)param1;
+        cmd_set = 1;
+    }
+
+    printk(KERN_ERR "acc_mod=0x%x; index=%u; value=0x%x; cmd_set=0x%x\n",
+            acc_mod,index,value,cmd_set);
+
+    buf_size = 512;
+    emmc_buf = kmalloc(buf_size, GFP_KERNEL);
+    if(!emmc_buf){
+        printk(KERN_ERR "emmc_buf is NULL\n");
+        goto ERR_OUT;
+    }
+    //printk(KERN_ERR "emmc_buf=0x%p\n",emmc_buf);
+
+    memset(emmc_buf, 0, 512);
+    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
+                      0,1,emmc_buf);
+
+    printk(KERN_ERR "[EXT_CSD] :\n");
+    if(param2){
+        if(param2 & PF2_SHOW_EXT_CSD)
+            show_ext_csd(emmc_buf);
+        if(param2 & PF2_FULL_PARAM){
+            if( index==249 || index==242 ||
+                index==212 || index==136 )
+                idx_lop = 4;
+            else if( index==157 || index==140)
+                idx_lop = 3;
+            else if( index==143)
+                idx_lop = 12;
+            else
+                idx_lop = 1;
+
+            for(i=0; i<idx_lop; i++)
+                printk(KERN_ERR "    [%03u]=%02x\n",index+i,*(emmc_buf+index+i));
+        }
+
+    }else{
+        printk(KERN_ERR "    [%03u]=%02x [%03u]=%02x\n",
+                    166,*(emmc_buf+166),
+                    167,*(emmc_buf+167));
+    }
+
+    if(index == EXT_CSD_WR_REL_SET){
+        if((*(emmc_buf+EXT_CSD_WR_REL_PARAM) & 0x05) == 0x05 ){
+            if(*(emmc_buf+EXT_CSD_PARTITION_SETTING_COMPLETED) & 0x01){
+                printk(KERN_ERR "This chip PARTITION configuration have completed\n");
+                printk(KERN_ERR "  ENH_SATRT_ADDR = 0x%08x\n",
+                          (*(emmc_buf+EXT_CSD_ENH_START_ADDR+3)<<24) |
+                          (*(emmc_buf+EXT_CSD_ENH_START_ADDR+2)<<16) |
+                          (*(emmc_buf+EXT_CSD_ENH_START_ADDR+1)<<8) |
+                          (*(emmc_buf+EXT_CSD_ENH_START_ADDR)));
+                printk(KERN_ERR "  ENH_SIZE_MULT  = 0x%06x\n",
+                          (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT+2)<<16) |
+                          (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT+1)<<8) |
+                          (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT)));
+                printk(KERN_ERR "  PARTITION_ATTRIBUTE  = 0x%06x\n",
+                        (*(emmc_buf+EXT_CSD_PARTITION_ATTRIBUTE)));
+                printk(KERN_ERR "  WR_REL_SET  = 0x%x\n",
+                        (*(emmc_buf+EXT_CSD_WR_REL_SET)));
+                goto FINISH_OUT;
+            }
+
+        }else{
+            printk(KERN_ERR "Device not support setting write reliability\n");
+            printk(KERN_ERR "  WR_REL_PARAM = 0x%x\n",
+                      *(emmc_buf+EXT_CSD_WR_REL_PARAM));
+            goto FINISH_OUT;
+        }
+    }
+
+    if(param3 == 0x2379beef)
+        rtksd_switch(card,acc_mod,index,value,cmd_set);
+    else{
+        printk(KERN_ERR "param3 != 0x2379beef skip command.\n");
+        goto FINISH_OUT;
+    }
+
+    memset(emmc_buf, 0, 512);
+    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
+                      0,1,emmc_buf);
+
+    printk(KERN_ERR "{F} [EXT_CSD] :\n");
+    if(param2){
+        if(param2 & PF2_SHOW_EXT_CSD)
+            show_ext_csd(emmc_buf);
+        if(param2 & PF2_FULL_PARAM){
+            if( index==249 || index==242 ||
+                index==212 || index==136 )
+                idx_lop = 4;
+            else if( index==157 || index==140)
+                idx_lop = 3;
+            else if( index==143)
+                idx_lop = 12;
+            else
+                idx_lop = 1;
+
+            for(i=0; i<idx_lop; i++)
+                printk(KERN_ERR "    [%03u]=%02x\n",index+i,*(emmc_buf+index+i));
+        }
+    }else{
+        printk(KERN_ERR "    [%03u]=%02x [%03u]=%02x\n",
+                    166,*(emmc_buf+166),
+                    167,*(emmc_buf+167));
+    }
+
+FINISH_OUT:
+    kfree(emmc_buf);
+
+ERR_OUT:
+    return;
+
+}
+
+static void hk_red_ext_csd(struct device *dev,
+                           size_t p_count,    //39
+                           unsigned char *cr_param)
+{
+    u8 *emmc_buf;
+    u32 param1; //target emmc address
+    u32 param2; //block number
+    u32 param3; //1: write; 0: read
+    u32 buf_size ;
+    struct mmc_host *host;
+    struct mmc_card *card = NULL;
+
+    printk(KERN_ERR "%s(%u)3013/08/15 17:30\n",__func__,__LINE__);
+    host = dev_get_drvdata(dev);
+    if(host)
+        card = host->card;
+
+    // KWarning: checked ok by alexkh@realtek.com
+    if(card == NULL){
+        printk(KERN_ERR "card is not exist.\n");
+        goto ERR_OUT;
+    }
+
+    rtkcr_chk_param(&param1,8,cr_param);
+    rtkcr_chk_param(&param2,8,cr_param+9);
+    rtkcr_chk_param(&param3,8,cr_param+18);
+
+    printk(KERN_ERR "param1=0x%x\n",param1); //enh_start_addr
+    printk(KERN_ERR "param2=0x%x\n",param2); //enh_block_cnt
+    printk(KERN_ERR "param3=0x%x\n",param3);
+
+    buf_size = 512;
+    emmc_buf = kmalloc(buf_size, GFP_KERNEL);
+    if(!emmc_buf){
+        printk(KERN_ERR "emmc_buf is NULL\n");
+        goto ERR_OUT;
+    }
+    printk(KERN_ERR "emmc_buf=0x%p\n",emmc_buf);
+
+    memset(emmc_buf, 0, 512);
+    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
+                      0,1,emmc_buf);
+
+    printk(KERN_ERR "[EXT_CSD] :\n");
+
+    if(param1 && !(param2 & PF2_SHOW_EXT_CSD)){
+        u8 i;
+        u8 item_cnt;
+        for(i=0;i<4;i++){
+            item_cnt = param1>>(i*8);
+            printk(KERN_ERR "    [%03u]=%02x ",item_cnt,*(emmc_buf+item_cnt));
+        }
+        printk(KERN_ERR "\n");
+    }else{
+        show_ext_csd(emmc_buf);
+    }
+    kfree(emmc_buf);
+
+ERR_OUT:
+    return;
+}
+
+static void hk_set_enh_user_area(struct device *dev,
+                                 size_t p_count,
+                                 unsigned char *cr_param)
+{
+    u8 *emmc_buf;
+    u32 param1;
+    u32 param2;
+    u32 param3;
+    u32 buf_size ;
+    struct mmc_host *host;
+    struct mmc_card *card = NULL;
+
+    printk(KERN_ERR "%s(%u)3013/08/15 17:30\n",__func__,__LINE__);
+    host = dev_get_drvdata(dev);
+    if(host)
+        card = host->card;
+
+    // KWarning: checked ok by alexkh@realtek.com
+    if(card == NULL){
+        printk(KERN_ERR "card is not exist.\n");
+        goto ERR_OUT;
+    }
+    rtkcr_chk_param(&param1,8,cr_param);
+    rtkcr_chk_param(&param2,8,cr_param+9);
+    rtkcr_chk_param(&param3,8,cr_param+18);
+
+    printk(KERN_ERR "param1=0x%x\n",param1); //enh_start_addr
+    printk(KERN_ERR "param2=0x%x\n",param2); //enh_block_cnt
+    printk(KERN_ERR "param3=0x%x\n",param3);
+
+    buf_size = 512;
+    emmc_buf = kmalloc(buf_size, GFP_KERNEL);
+    if(!emmc_buf){
+        printk(KERN_ERR "emmc_buf is NULL\n");
+        goto ERR_OUT;
+    }
+    printk(KERN_ERR "emmc_buf=0x%p\n",emmc_buf);
+
+    memset(emmc_buf, 0, 512);
+    mmc_send_data_cmd(MMC_SEND_EXT_CSD,
+                      0,1,emmc_buf);
+
+    printk(KERN_ERR "[EXT_CSD] :\n");
+    if((*(emmc_buf+EXT_CSD_PARTITION_SUPPORT) &0x03) == 0x03){
+        u32 i;
+        //u8 item_cnt;
+        u32 max_enh_size_mult;
+        u32 enh_size_base_blk;
+        u32 sec_cnt;
+        u8 hc_wp_grp_size;
+        u8 hc_erase_grp_size;
+
+        hc_wp_grp_size = *(emmc_buf+EXT_CSD_HC_WP_GRP_SIZE);
+        hc_erase_grp_size = *(emmc_buf+EXT_CSD_HC_ERASE_GRP_SIZE);
+
+        sec_cnt = (*(emmc_buf+EXT_CSD_SEC_CNT+3)<<24) |
+                  (*(emmc_buf+EXT_CSD_SEC_CNT+2)<<16) |
+                  (*(emmc_buf+EXT_CSD_SEC_CNT+1)<<8) |
+                  (*(emmc_buf+EXT_CSD_SEC_CNT));
+
+        max_enh_size_mult = (*(emmc_buf+EXT_CSD_MAX_ENH_SIZE_MULT+2)<<16) |
+                            (*(emmc_buf+EXT_CSD_MAX_ENH_SIZE_MULT+1)<<8) |
+                            (*(emmc_buf+EXT_CSD_MAX_ENH_SIZE_MULT));
+
+        enh_size_base_blk = (u32)hc_wp_grp_size *
+                            (u32)hc_erase_grp_size * 1024;
+
+        printk(KERN_ERR "  ERASE_GROUP_DEF = 0x%x\n",
+                *(emmc_buf+EXT_CSD_ERASE_GROUP_DEF));
+        printk(KERN_ERR "  HC_WP_GRP_SIZE = 0x%x\n",hc_wp_grp_size);
+        printk(KERN_ERR "  HC_ERASE_GRP_SIZE = 0x%x\n",hc_erase_grp_size);
+        printk(KERN_ERR "  SEC_CNT = 0x%x\n",sec_cnt);
+        printk(KERN_ERR "  MAX_ENH_SIZE_MULT = 0x%x\n",max_enh_size_mult);
+        printk(KERN_ERR "Enhanced User Data Area base=\n"
+               "            %u kBytes(0x%x block)\n",
+                (enh_size_base_blk>>1),enh_size_base_blk);
+        printk(KERN_ERR "Enhanced User Data Area x Size=\n"
+               "            ENH_SIZE_MULT x HC_WP_GRP_SIZE x\n"
+               "            HC_ERASE_GRP_SIZE x 512 kBytes\n");
+
+        if(*(emmc_buf+EXT_CSD_PARTITION_SETTING_COMPLETED) & 0x01){
+            printk(KERN_ERR "This chip PARTITION configuration have completed\n");
+            printk(KERN_ERR "  ENH_SATRT_ADDR = 0x%08x\n",
+                      (*(emmc_buf+EXT_CSD_ENH_START_ADDR+3)<<24) |
+                      (*(emmc_buf+EXT_CSD_ENH_START_ADDR+2)<<16) |
+                      (*(emmc_buf+EXT_CSD_ENH_START_ADDR+1)<<8) |
+                      (*(emmc_buf+EXT_CSD_ENH_START_ADDR)));
+            printk(KERN_ERR "  ENH_SIZE_MULT  = 0x%06x\n",
+                      (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT+2)<<16) |
+                      (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT+1)<<8) |
+                      (*(emmc_buf+EXT_CSD_ENH_SIZE_MULT)));
+            printk(KERN_ERR "  PARTITION_ATTRIBUTE  = 0x%06x\n",
+                    (*(emmc_buf+EXT_CSD_PARTITION_ATTRIBUTE)));
+
+            goto FINISH_OUT;
+        }
+
+        if(param2 > enh_size_base_blk){
+            i = param2 % enh_size_base_blk;
+            param2 = (param2/enh_size_base_blk);
+            if(i)
+                param2 += 1;
+        }else{
+            param2 = 1;
+        }
+        if(param2 > max_enh_size_mult)
+            param2 = max_enh_size_mult;
+
+        printk(KERN_ERR "ENH_SATRT_ADDR = 0x%08x\n",param1);
+        printk(KERN_ERR "ENH_SIZE_MULT  = 0x%06x\n",param2);
+
+        if(p_count == 38 && (param3 == 0x2379beef)){
+            u32 part_switch_time;
+            /* doing set enhance user data param to ext_csd */
+            /* setting ENH_SATRT_ADDR */
+            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
+                         EXT_CSD_ENH_START_ADDR,(u8)(param1&0xff),1);
+            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
+                         EXT_CSD_ENH_START_ADDR+1,(u8)((param1>>8)& 0xff),1);
+            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
+                         EXT_CSD_ENH_START_ADDR+2,(u8)((param1>>16)& 0xff),1);
+            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
+                         EXT_CSD_ENH_START_ADDR+3,(u8)((param1>>24)& 0xff),1);
+            /* setting ENH_SIZE_MULT */
+            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
+                         EXT_CSD_ENH_SIZE_MULT,(u8)(param2& 0xff),1);
+            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
+                         EXT_CSD_ENH_SIZE_MULT+1,(u8)((param2>>8)& 0xff),1);
+            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
+                         EXT_CSD_ENH_SIZE_MULT+2,(u8)((param2>>16)& 0xff),1);
+            /* settig user data area to enhance mode */
+            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
+                         EXT_CSD_PARTITION_ATTRIBUTE,0x01,1);
+            /* setting partition configuration complete */
+            rtksd_switch(card,MMC_SWITCH_MODE_WRITE_BYTE,
+                         EXT_CSD_PARTITION_SETTING_COMPLETED,0x01,1);
+
+            part_switch_time = *(emmc_buf+EXT_CSD_PART_SWITCH_TIME);
+            printk(KERN_ERR "Partition Switch Time is %u0ms.\n",part_switch_time);
+            mdelay(10*(part_switch_time+10));
+        }else{
+            printk(KERN_ERR "Command format:\n"
+                   "    echo set_ehuser=param1,param2,param3 > emmc_hacking;\n"
+                   "        param1 is enhance user data area start address in block(8 hex).\n"
+                   "        param2 is enhance user data area size in block(8 hex).\n"
+                   "        param3 must be 2379beef to make sure you want to do this.\n"
+                   "ex:\n"
+                   "    echo set_ehuser=00000000,00020000,2379beef > emmc_hacking;\n"
+                   "        param1=0x00000000 EUDA start address is 0.\n"
+                   "        param2=0x00020000 EUDA size is 0x2000.\n"
+                   "        param3=2379beef make sure that want to do this.\n" );
+        }
+
+    }else{
+        printk(KERN_ERR "device do not support enhance uaer data area.\n");
+    }
+FINISH_OUT:
+    kfree(emmc_buf);
+
+ERR_OUT:
+    return;
+}
+#endif
+
+/* ========================================================
+ * blk_addr    : eMMC read/write target address, block base.
+ * data_size   : tarnsfer data size, block base.
+ * buffer      : DMA address
+ * rw_mode     : fast read or fast write
+ ========================================================== */
+#define FAST_READ   0x1278
+#define FAST_WRITE  0x3478
+static int mmc_fast_rw( unsigned int blk_addr,
+                   unsigned int data_size,
+                   unsigned char * buffer,
+                   unsigned int rw_mode )
+{
+    int err = 0;
+    struct mmc_host * mmc = mmc_host_local;
+    unsigned long flags;
+
+    if(mmc){
+        struct rtksd_host *sdport;
+        struct mmc_card *card;
+        struct mmc_request mrq = {0};
+        struct mmc_command cmd = {0};
+	    struct mmc_data	data   = {0};
+	    struct scatterlist sg;
+
+        sdport = mmc_priv(mmc);
+        mmc_claim_host(mmc);
+        spin_lock_irqsave(&sdport->lock,flags);
+
+        card = mmc->card;
+
+        if((sdport->rtflags & RTKCR_USER_PARTITION)==0){
+            int try_loop = 3;
+            do{
+                err = 0;
+                spin_unlock_irqrestore(&sdport->lock, flags);
+                err = rtksd_switch_user_partition(card);
+                spin_lock_irqsave(&sdport->lock,flags);
+
+            }while(try_loop-- && err );
+            if(err){
+                spin_unlock_irqrestore(&sdport->lock, flags);
+                mmc_release_host(mmc);
+                goto ERR_OUT;
+            }
+            else
+                sdport->rtflags |= RTKCR_USER_PARTITION;
+        }
+
+        if(data_size>1){
+
+            if(rw_mode == FAST_WRITE)
+                cmd.opcode = MMC_WRITE_MULTIPLE_BLOCK;
+            else
+                cmd.opcode = MMC_READ_MULTIPLE_BLOCK;
+
+        }else{
+
+            if(rw_mode == FAST_WRITE)
+                cmd.opcode = MMC_WRITE_BLOCK;
+            else
+                cmd.opcode = MMC_READ_SINGLE_BLOCK;
+        }
+
+	    cmd.arg = blk_addr;
+	    cmd.flags = MMC_RSP_R1 | MMC_CMD_ADTC;
+
+        if(data_size)
+        {   //date info setting
+    		data.sg = &sg;
+    		data.sg_len = 1;
+    		data.blksz = 512;
+    		data.blocks = data_size;
+
+    		sg_init_one(data.sg, buffer, (data_size<<9));
+
+            if(rw_mode == FAST_WRITE)
+    	        data.flags = MMC_DATA_WRITE;
+            else
+    		    data.flags = MMC_DATA_READ;
+
+            mmc_set_data_timeout(&data, card);
+        }
+
+	    data.mrq = &mrq;
+	    cmd.mrq = &mrq;
+	    cmd.data = &data;
+        cmd.retries =5;
+
+CMD_RETRY:
+        mrq.data = &data;
+        mrq.cmd = &cmd;
+
+        if(sdport->mrq){
+            sdport->mrq = NULL;
+        }
+        cmd.error = 0;
+        data.error = 0;
+        spin_unlock_irqrestore(&sdport->lock, flags);
+        mmc_wait_for_req(mmc, &mrq);
+        spin_lock_irqsave(&sdport->lock,flags);
+        err = cmd.error;
+        if((err==0) && (rw_mode==FAST_WRITE))
+        {
+            spin_unlock_irqrestore(&sdport->lock, flags);
+            err = rtksd_wait_status(mmc->card,STATE_TRAN,0,0);
+            spin_lock_irqsave(&sdport->lock,flags);
+        }
+        if(err && cmd.retries){
+            printk("%s(%u)last retry %d counter.\n",
+                    __func__,__LINE__,cmd.retries);
+            cmd.retries--;
+            goto CMD_RETRY;
+        }
+        spin_unlock_irqrestore(&sdport->lock, flags);
+        mmc_release_host(mmc);
+    }else{
+        err = -ENODEV;
+    }
+
+ERR_OUT:
+    if(err)
+        printk("err=%d\n",err);
+    return err;
+}
+
+#define MAX_XFER_BLK_A    0x100
+#define MAX_XFER_BLK_B    0x400
+static int mmc_fast_rw_loop(unsigned int blk_addr,
+                            unsigned int data_size,
+                            unsigned char * buffer,
+                            unsigned int rw_mode )
+{
+    int err = 0;
+
+    unsigned int tmp_addr   = blk_addr;
+    unsigned int tmp_size   = data_size;
+    unsigned int org_size   = data_size;
+    unsigned char * tmp_buf = buffer;
+    unsigned int max_xfer_blk;
+    do{
+        /* max 1M bytes read/write per transfer */
+
+        max_xfer_blk = MAX_XFER_BLK_B;
+
+        if(data_size > max_xfer_blk){
+            tmp_size = max_xfer_blk;
+        }else{
+            tmp_size = data_size;
+        }
+
+        err = mmc_fast_rw(tmp_addr,tmp_size,tmp_buf,rw_mode);
+
+        if(err)
+            break;
+
+        if(data_size > max_xfer_blk){
+            tmp_addr    += max_xfer_blk;
+            data_size   -= max_xfer_blk;
+            tmp_buf     += (max_xfer_blk<<9);
+        }else{
+            data_size = 0;
+        }
+
+    }while(data_size);
+
+    if(err == 0)
+         return org_size-data_size;
+    else
+        return err;
+}
+
+int mmc_fast_read( unsigned int blk_addr,
+                   unsigned int data_size,
+                   unsigned char * buffer )
+{
+    int err = 0;
+    err = mmc_fast_rw_loop(blk_addr,data_size,buffer,FAST_READ);
+    return err;
+}
+EXPORT_SYMBOL(mmc_fast_read);
+
+int mmc_fast_write( unsigned int blk_addr,
+                    unsigned int data_size,
+                    unsigned char * buffer )
+{
+    int err = 0;
+    if(blk_addr<0x20000){
+        printk("target small then save area.\n");
+        err = -1;
+    }
+    err = mmc_fast_rw_loop(blk_addr,data_size,buffer,FAST_WRITE);
+    return err;
+}
+EXPORT_SYMBOL(mmc_fast_write);
+
+int mmc_send_cmd0(void){
+    int err = 0;
+    //struct mmc_host * mmc = mmc_host_local;
+    unsigned long flags;
+    struct mmc_host *host;
+    struct mmc_card *card = NULL;
+    struct mmc_host * mmc = mmc_host_local;
+
+    printk("%s(%u)\n",__func__,__LINE__);
+
+#if 1
+    if(mmc){
+        mmc_claim_host(mmc);
+        card = mmc->card;
+    }
+    else
+    {
+    	printk("%s(%u) mmc == NULL\n",__func__,__LINE__);
+	return -6; 
+    }
+#else
+    host = dev_get_drvdata(dev);
+    if(host)
+        card = host->card;
+#endif
+
+    // KWarning: checked ok by alexkh@realtek.com
+    if(card == NULL){
+        printk(KERN_ERR "card is not exist.\n");
+	err = -ENODEV;
+        goto ERR_OUT;
+    }
+    err = rtksd_go_idle(card);
+
+ERR_OUT:
+    return -5;
+}
+EXPORT_SYMBOL(mmc_send_cmd0);
+
+/* mmc device attribute *********************************************************** */
+#define TEST_BLK_SIZE 10
+void rtk_hexdump(const char *str, const void *buf, unsigned int length)
+{
+        unsigned int i;
+        char *ptr = (char *)buf;
+
+        if ((buf == NULL) || (length == 0)) {
+                printk("NULL\n");
+                return;
+        }
+        printk(str == NULL ? __FUNCTION__ : str);
+	printk(" (0x%08x)\n", (unsigned int)buf);
+
+        for (i = 0; i < length; i++) {
+		printk("0x%02x",(unsigned int)(ptr[i]));
+
+                if ((i & 0xf) == 0xf)
+                        printk("\n");
+                else
+                        printk(" ");
+        }
+        printk("\n");
+}
+EXPORT_SYMBOL(rtk_hexdump);
+
+static ssize_t
+cr_send_cmd0_dev_show(struct device *dev,
+                     struct device_attribute *attr,
+                     const char *buf,
+                     size_t count)
+{
+    struct mmc_host * host = dev_get_drvdata(dev);
+
+    printk("%s(%u)\n",__func__,__LINE__);
+    return sprintf(buf, "send cmd0\n");
+}
+static ssize_t
+cr_send_cmd0_dev_store(struct device *dev,
+                     struct device_attribute *attr,
+                     const char *buf,
+                     size_t count)
+{
+	int err=0;
+
+	//err = mmc_send_cmd0(dev);
+	err = mmc_send_cmd0();
+	return err;
+}
+DEVICE_ATTR(cr_send_cmd0, S_IRUGO | S_IWUSR,
+            cr_send_cmd0_dev_show,cr_send_cmd0_dev_store);
+
+static ssize_t
+cr_fast_RW_dev_show(struct device *dev, struct device_attribute *attr,
+        char *buf)
+{
+    struct mmc_host * host = dev_get_drvdata(dev);
+
+    printk("%s(%u)\n",__func__,__LINE__);
+
+    if(host && host->card){
+        rtksd_switch_user_partition(host->card);
+    }
+    return sprintf(buf, "send SWITCH command\n");
+}
+
+static ssize_t
+cr_fast_RW_dev_store(struct device *dev,
+                     struct device_attribute *attr,
+                     const char *buf,
+                     size_t count)
+{
+
+    unsigned char *cr_param;
+
+
+    printk("%s(%u)\n",__func__,__LINE__);
+    printk("%s\n",buf);
+    printk("count=%d\n",count);
+
+    cr_param=(char *)rtkcr_parse_token(buf,"cr_param");
+
+    if(cr_param){
+        u8 *emmc_buf;
+        u32 param1; //target emmc address
+        u32 param2; //block number
+        u32 param3; //1: write; 0: read
+
+        rtkcr_chk_param(&param1,8,cr_param);
+        rtkcr_chk_param(&param2,8,cr_param+9);
+        rtkcr_chk_param(&param3,8,cr_param+18);
+        printk("param1=0x%x param2=0x%x param3=0x%x\n",
+                param1,param2,param3);
+
+        emmc_buf = kmalloc(BYTE_CNT*param2, GFP_KERNEL);
+        if(!emmc_buf){
+            printk("emmc_buf is NULL\n");
+            goto ERR_OUT;
+        }
+
+        printk("emmc_buf=0x%p\n",emmc_buf);
+
+        if(param3 == 1){
+            mmc_fast_write(param1, param2, emmc_buf );
+        }else{
+            mmc_fast_read(param1, param2, emmc_buf );
+        }
+        kfree(emmc_buf);
+    }else{
+        printk("have no parameter searched.\n");
+    }
+
+ERR_OUT:
+    /*
+    return value must be equare or big then "count"
+    to finish this attribute
+    */
+
+    return count;
+}
+DEVICE_ATTR(cr_fast_RW, S_IRUGO | S_IWUSR,
+            cr_fast_RW_dev_show,cr_fast_RW_dev_store);
+
+static ssize_t
+em_open_log_dev_show(struct device *dev, struct device_attribute *attr,
+        char *buf)
+{
+    struct mmc_host * host = dev_get_drvdata(dev);
+    struct rtksd_host *sdport = mmc_priv(host);
+
+    if(sdport->rtflags & RTKCR_FOPEN_LOG){
+        sdport->rtflags &= ~RTKCR_FOPEN_LOG;
+    }else{
+        sdport->rtflags |=  RTKCR_FOPEN_LOG;
+    }
+
+    return sprintf(buf, "%s log %s\n",
+            DRIVER_NAME,
+            (sdport->rtflags & RTKCR_FOPEN_LOG)?"open":"close");
+}
+
+static ssize_t
+em_open_log_dev_store(struct device *dev,
+                     struct device_attribute *attr,
+                     const char *buf,
+                     size_t count)
+{
+
+    printk("%s(%u)Not thing to do.\n",__func__,__LINE__);
+
+    return count;
+}
+DEVICE_ATTR(em_open_log, S_IRUGO | S_IWUSR,
+              em_open_log_dev_show,em_open_log_dev_store);
+
+#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
+static ssize_t
+emmc_hacking_dev_show(struct device *dev, struct device_attribute *attr,
+        char *buf)
+{
+    //struct mmc_host * host = dev_get_drvdata(dev);
+    //struct mmc_card *card = host->card;
+
+    printk(KERN_ERR "%s(%u)3013/08/12 10:55\n",__func__,__LINE__);
+
+    printk(KERN_ERR "Supported hacking below:\n");
+#ifdef HACK_BOOT_PART_RW
+    printk(KERN_ERR "    fill_par    : fill data  to specific partition\n");
+#endif
+    printk(KERN_ERR "    set_wr_rel  : enable write reliability.\n");
+    printk(KERN_ERR "    red_ext_csd : show ext_csd.\n");
+    printk(KERN_ERR "    set_ehuser  : enable enhance user date area.\n");
+
+    return sprintf(buf, "emmc_hacking_dev_show\n");
+}
+
+static ssize_t
+emmc_hacking_dev_store(struct device *dev,
+                     struct device_attribute *attr,
+                     const char *buf,
+                     size_t count)
+{
+    unsigned char *cr_param;
+
+    printk(KERN_ERR "%s(%u)2013/08/15 17:30\n",__func__,__LINE__);
+    //printk("%s\n",buf);
+    printk(KERN_ERR "count=%d\n",count);
+
+#ifdef HACK_BOOT_PART_RW
+    cr_param=(char *)rtkcr_parse_token(buf,"fill_par");
+    if(cr_param){
+        hk_fill_bp(dev,count,cr_param);
+        goto FINISH_OUT;
+    }
+#endif //#ifdef HACK_BOOT_PART_RW
+
+    cr_param=(char *)rtkcr_parse_token(buf,"set_wr_rel");
+    if(cr_param){
+        hk_set_wr_rel(dev,count,cr_param);
+        goto FINISH_OUT;
+    }
+
+    cr_param=(char *)rtkcr_parse_token(buf,"red_ext_csd");
+    if(cr_param){
+        hk_red_ext_csd(dev,count,cr_param);
+        goto FINISH_OUT;
+    }
+
+    cr_param=(char *)rtkcr_parse_token(buf,"set_ehuser");
+    if(cr_param){
+        hk_set_enh_user_area(dev,count,cr_param);
+        goto FINISH_OUT;
+    }
+
+    printk(KERN_ERR "have no match command!!\n");
+
+FINISH_OUT:
+    /*
+    return value must be equare or big then "count"
+    to finish this attribute
+    */
+    return count;
+}
+DEVICE_ATTR(emmc_hacking, S_IRUGO | S_IWUSR,
+            emmc_hacking_dev_show,emmc_hacking_dev_store);
+
+#endif
+
+static ssize_t
+emmc_id_dev_show(struct device *dev, struct device_attribute *attr,
+        char *buf)
+{
+    struct mmc_host * host = dev_get_drvdata(dev);
+    struct mmc_card *card = host->card;
+    struct rtksd_host *sdport = mmc_priv(host);
+
+    printk(KERN_INFO "%s(%u)%s %s\n",__func__,__LINE__,__DATE__, __TIME__);
+    return sprintf(buf, "emmcid=0x%02x%02x\ncfg1=0x%02x,cfg2=0x%02x,cfg3=0x%02x,sts1=0x%02x,sts2=0x%02x,bus_sts=0x%02x\nsample_pnt=0x%02x,push_pnt=0x%02x,trans=0x%02x,pad_ctl=0x%02x,ckgen_ctl=0x%02x\nCARD_SELECT=0x%02x,SYS_PLL_EMMC3=0x%08x,PLL_EMMC1=0x%08x\n",
+                    (unsigned char)(card->cid.manfid),
+                    (unsigned char)(card->cid.oemid),cr_readb(sdport->base_io+SD_CONFIGURE1),cr_readb(sdport->base_io+SD_CONFIGURE2),cr_readb(sdport->base_io+SD_CONFIGURE3),cr_readb(sdport->base_io+SD_STATUS1),cr_readb(sdport->base_io+SD_STATUS2),cr_readb(sdport->base_io+SD_BUS_STATUS),cr_readb(sdport->base_io+SD_TRANSFER),cr_readb(sdport->base_io+SD_SAMPLE_POINT_CTL),cr_readb(sdport->base_io+SD_PUSH_POINT_CTL),cr_readl(sdport->base_io+EMMC_PAD_CTL),cr_readl(sdport->base_io+EMMC_CKGEN_CTL),cr_readb(sdport->base_io+CARD_SELECT),cr_readl(SYS_PLL_EMMC3),cr_readl(PLL_EMMC1));
+}
+
+static ssize_t
+emmc_id_dev_store(struct device *dev,
+                     struct device_attribute *attr,
+                     const char *buf,
+                     size_t count)
+{
+    unsigned char *cr_param;
+
+    printk(KERN_ERR "%s(%u)Nothing to do\n",__func__,__LINE__);
+
+    /*
+    return value must be equare or big then "count"
+    to finish this attribute
+    */
+    return count;
+}
+DEVICE_ATTR(emmc_id, S_IRUGO | S_IWUSR,
+            emmc_id_dev_show,emmc_id_dev_store);
+
+static const struct of_device_id rtk_rtkemmc_ids[] = {
+	{ .compatible = "Realtek,rtk119x-emmc" },
+	{ /* Sentinel */ },
+};
+
+static int rtkemmc_probe(struct platform_device *pdev)
+{
+	struct mmc_host *mmc = NULL;
+	struct rtksd_host *sdport = NULL;
+	struct resource *r;
+	int ret, irq;
+	int att_err;
+	const u32 *prop;
+	int err,size,speed_step=0;
+	struct device_node *rtk119x_emmc_node = NULL;
+
+
+	rtk119x_emmc_node = pdev->dev.of_node;
+
+	if (!rtk119x_emmc_node)
+		printk(KERN_ERR "%s : No emmc of_node found\n",DRIVER_NAME);
+	else
+		printk(KERN_ERR "%s : emmc of_node found\n",DRIVER_NAME);
+
+
+	att_err = device_create_file(&pdev->dev, &dev_attr_cr_send_cmd0);
+	att_err = device_create_file(&pdev->dev, &dev_attr_cr_fast_RW);
+	att_err = device_create_file(&pdev->dev, &dev_attr_em_open_log);
+	att_err = device_create_file(&pdev->dev, &dev_attr_emmc_id);
+#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
+	att_err = device_create_file(&pdev->dev, &dev_attr_emmc_hacking);
+#endif
+	/* Request IRQ */
+	irq = irq_of_parse_and_map(rtk119x_emmc_node, 0);
+	if (irq <= 0) {
+		printk(KERN_ERR "%s : fail to parse of irq.\n",DRIVER_NAME);
+		return -ENXIO;
+	}
+	ret = platform_device_add_resources(pdev, &rtkemmc_resources, 2);
+	if (ret)
+	{
+		printk(KERN_ERR "%s : fail to add resources.\n",DRIVER_NAME);
+		return -ENXIO;
+	}
+	r = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+
+	MMCPRINTF(KERN_INFO "%s : IRQ = %x\n",DRIVER_NAME, irq);
+
+	if (!r || irq < 0){
+		printk(KERN_ERR "%s : fail to get resources or irq\n",DRIVER_NAME);
+		return -ENXIO;
+	}	
+
+	r = request_mem_region(r->start, 0x3FF, DRIVER_NAME);
+	if (!r)
+	{
+		printk(KERN_ERR "%s : fail to request mem region\n",DRIVER_NAME);
+		return -EBUSY;
+	}
+
+	mmc = mmc_alloc_host(sizeof(struct rtksd_host), &pdev->dev);
+
+	if (!mmc) {
+		ret = -ENOMEM;
+		goto out;
+	}
+	mmc_host_local = mmc;
+
+	sdport = mmc_priv(mmc);
+	memset(sdport, 0, sizeof(struct rtksd_host));
+
+	sdport->mmc = mmc;
+	sdport->dev = &pdev->dev;
+	sdport->res = r;
+	sdport->base_io = EM_BASE_ADDR;
+	sdport->ops = &emmc_ops;
+
+	sema_init(&sdport->sem,1);
+	sema_init(&sdport->sem_op_end,1);
+
+	prop = of_get_property(pdev->dev.of_node, "speed-step", &size);
+	if (prop)
+	{
+        	speed_step = of_read_number(prop, 1);
+        	printk(KERN_INFO "[%s] get speed-step : %d \n",__func__,speed_step);
+	} else 
+	{
+        	printk(KERN_ERR "[%s] get speed-step error !! %d \n",__func__,err);
+    	}
+
+	rstc_emmc = devm_reset_control_get(&pdev->dev, NULL);
+	if (IS_ERR(rstc_emmc)) {
+		printk(KERN_ERR "%s: reset_control_get() returns %ld\n", __func__, PTR_ERR(rstc_emmc));
+		rstc_emmc = NULL;
+	}
+	clk_en_emmc = devm_clk_get(&pdev->dev, "emmc");
+	if (IS_ERR(clk_en_emmc)) {
+		printk(KERN_ERR "%s: clk_get() returns %ld\n", __func__, PTR_ERR(clk_en_emmc));
+		clk_en_emmc = NULL;
+	}
+	clk_en_emmc_ip = devm_clk_get(&pdev->dev, "emmc_ip");
+	if (IS_ERR(clk_en_emmc_ip)) {
+		printk(KERN_ERR "%s: clk_get() returns %ld\n", __func__, PTR_ERR(clk_en_emmc_ip));
+		clk_en_emmc_ip = NULL;
+	}
+        //1195 uses the same DMA bus bwtween SD, SDIO, and EMMC, we still need to open this clk if no SD card and SDIO driver, 1395 will separate the DMA bus
+	clk_cr = devm_clk_get(&pdev->dev, "cr");
+	if (IS_ERR(clk_cr)) {
+		printk(KERN_ERR "%s: clk_get() returns %ld\n", __func__, PTR_ERR(clk_cr));
+		clk_cr = NULL;
+	}
+
+	clk_prepare_enable(clk_en_emmc);
+	clk_prepare_enable(clk_en_emmc_ip);
+	clk_prepare_enable(clk_cr);
+	reset_control_deassert(rstc_emmc);
+
+	mmc->ocr_avail = MMC_VDD_30_31
+                        | MMC_VDD_31_32
+                        | MMC_VDD_32_33
+                        | MMC_VDD_33_34
+                        | MMC_VDD_165_195;
+
+        mmc->caps = MMC_CAP_4_BIT_DATA
+                | MMC_CAP_8_BIT_DATA
+                | MMC_CAP_SD_HIGHSPEED
+                | MMC_CAP_MMC_HIGHSPEED
+                | MMC_CAP_NONREMOVABLE
+                | MMC_CAP_CMD23
+                | MMC_CAP_ERASE;
+
+	mmc->caps2 = MMC_CAP2_NO_SDIO | MMC_CAP2_NO_SD | MMC_CAP2_HS200_1_8V_SDR;
+
+	switch(speed_step)
+	{
+	case 0: //sdr50
+		mmc->caps &= ~(MMC_CAP_UHS_DDR50|MMC_CAP_1_8V_DDR);
+		mmc->caps2 &= ~(MMC_CAP2_HS200_1_8V_SDR);
+   		break;
+	case 1: //ddr50
+		mmc->caps2 &= ~(MMC_CAP2_HS200_1_8V_SDR);
+		break;
+	}
+
+	if(rtk_emmc_bus_wid == 4 || rtk_emmc_bus_wid == 5){
+        	mmc->caps &= ~MMC_CAP_8_BIT_DATA;
+	}
+
+	mmc->f_min = 10000000>>8;   /* RTK min bus clk is 10Mhz/256 */
+	mmc->f_max = 48000000;      /* RTK max bus clk is 48Mhz */
+
+	mmc->max_segs = 1;
+	mmc->max_blk_size   = 512;
+
+	mmc->max_blk_count  = 0x400;
+
+	mmc->max_seg_size   = mmc->max_blk_size * mmc->max_blk_count;
+	mmc->max_req_size   = mmc->max_blk_size * mmc->max_blk_count;
+
+	spin_lock_init(&sdport->lock);
+	init_rwsem(&cr_rw_sem);
+	tasklet_init(&sdport->req_end_tasklet, rtkcr_req_end_tasklet,
+		        (unsigned long)sdport);
+
+	sdport->base = ioremap(r->start, 0x00000200);
+
+	//Force enable dbg log
+#ifdef MMC_DBG
+	sdport->rtflags |= RTKCR_FOPEN_LOG;
+#endif
+
+	if(rtk_emmc_bus_wid == 9 || rtk_emmc_bus_wid == 5){
+		sdport->rtflags |= RTKCR_FOPEN_LOG;
+	}
+
+	if (!sdport->base) {
+		printk(KERN_INFO "---- Realtek EMMC Controller Driver probe fail - nomem ----\n\n");
+		ret = -ENOMEM;
+		goto out;
+	}
+#ifdef ENABLE_EMMC_INT_MODE
+	rtkcr_hold_int_dec(sdport->base_io);       /* hold status interrupt */
+	rtkcr_clr_int_sta(sdport->base_io);
+#endif
+
+	ret = request_irq(irq, rtksd_irq, IRQF_SHARED, DRIVER_NAME, sdport);   //rtkcr_interrupt
+	if (ret) {
+		printk(KERN_ERR "%s: cannot assign irq %d\n", DRIVER_NAME, irq);
+		goto out;
+	} else{
+		sdport->irq = irq;
+	}
+#ifdef EMMC_SHOUTDOWN_PROTECT
+
+//#define FAKE_AC_DET_PIN
+#ifdef FAKE_AC_DET_PIN
+    //POWER_EN  0x101010c04
+	if(pcb_mgr_get_enum_info_byname("POWER_EN", &rtk_tmp_gpio)==0)
+#else
+	if(pcb_mgr_get_enum_info_byname("PIN_AC_DETECT", &rtk_tmp_gpio)==0)
+#endif
+	{
+		unsigned int gpio_group;
+		unsigned int rtk_gpio_num;
+		set_gpio_func_t gpio_func;;
+
+		printk("PIN_AC_DETECT got.(0x%x)\n",(u32)rtk_tmp_gpio);
+
+		gpio_group   = GET_PIN_TYPE(rtk_tmp_gpio);
+		rtk_gpio_num = GET_PIN_INDEX(rtk_tmp_gpio);
+
+#ifdef FAKE_AC_DET_PIN
+		printk("gpio_group = %x\n",gpio_group);
+		printk("rtk_gpio_num = %x\n",rtk_gpio_num);
+
+		printk("\nfor test change PIN_AC_DETECT to ISO_GPIO 3.\n");
+		rtk_tmp_gpio = 0x1010304;
+		gpio_group  = GET_PIN_TYPE(rtk_tmp_gpio);
+		rtk_gpio_num = GET_PIN_INDEX(rtk_tmp_gpio);
+		printk("gpio_group = %x\n",gpio_group);
+		printk("rtk_gpio_num = %x\n",rtk_gpio_num);
+#endif
+		sdport->gpio_isr_info = (u32)rtk_tmp_gpio;
+
+		switch(gpio_group)
+		{
+		case PCB_PIN_TYPE_GPIO:
+			printk("PIN type is PCB_PIN_TYPE_GPIO\n");
+			if(rtk_gpio_num > MAX_MIS_GPIO_CNT)
+			{
+				print("Error Pin define,Skip AC_DET function\n");
+				goto AC_DET_OUT;
+			}
+			gpio_group = MIS_GPIO;
+			gpio_func = rtkcr_set_mis_gpio;
+			break;
+		case PCB_PIN_TYPE_ISO_GPIO:
+			printk("PIN type is PCB_PIN_TYPE_ISO_GPIO\n");
+			if(st_gpio_map[rtk_gpio_num] == 0xff || rtk_gpio_num > MAX_ISO_GPIO_CNT)
+			{
+				printk("Error Pin define,Skip AC_DET function\n");
+				goto AC_DET_OUT;
+			}
+			gpio_group = ISO_GPIO;
+			gpio_func = rtkcr_set_iso_gpio;
+			break;
+		default:
+			printk("PIN group not match\n");
+			goto AC_DET_OUT;
+		}
+
+		printk("PIN_AC_DETECT is %s_GPIO %u.\n",
+			gpio_group==ISO_GPIO? "ISO":"MIS",rtk_gpio_num);
+
+		gpio_func(rtk_gpio_num,GPIO_IN,GPIO_LOW);
+		venus_gpio_set_debounce(venus_gpio_id(gpio_group, rtk_gpio_num),
+			VENUS_GPIO_DEBOUNCE_100us);
+		venus_gpio_set_dir(venus_gpio_id(gpio_group, rtk_gpio_num), 0);
+		venus_gpio_clear_isr(venus_gpio_id(gpio_group, rtk_gpio_num));
+		if(venus_gpio_request_irq( venus_gpio_id(gpio_group,rtk_gpio_num),
+						rtksd_gpio_isr,
+						DRIVER_NAME,
+						sdport))
+		{
+			printk("%s: request gpio isr fail\n",DRIVER_NAME);
+			goto AC_DET_OUT;
+		}
+		venus_gpio_set_irq_enable(venus_gpio_id(gpio_group, rtk_gpio_num), 1);
+
+	}
+AC_DET_OUT:
+
+#else   //#ifdef EMMC_SHOUTDOWN_PROTECT
+	printk(KERN_INFO"%s: EMMC_SHOUTDOWN_PROTECT  not define\n"
+		"",DRIVER_NAME);
+#endif  //#ifdef EMMC_SHOUTDOWN_PROTECT
+
+	setup_timer(&sdport->timer, rtksd_timeout_timer, (unsigned long)sdport);
+
+	sdport->ops->set_crt_muxpad(sdport);
+
+	if(sdport->ops->reset_card)
+		sdport->ops->reset_card(sdport);
+	sdport->ops->chk_card_insert(sdport);
+
+#ifdef ENABLE_EMMC_INT_MODE
+	//rtkcr_en_int(sdport->base_io);
+#endif
+
+	platform_set_drvdata(pdev, mmc);
+	ret = mmc_add_host(mmc);
+	if (ret)
+		goto out;
+
+#ifdef CONFIG_MMC_FOR_RTK_FPGA
+	cr_writel( 0x200000, CR_DUMMY_SYS );
+	cr_writel( 0xf2100, sdport->base_io+EMMC_CKGEN_CTL );
+#endif
+	cr_writeb( 0x2, sdport->base_io+CARD_SELECT );            //for emmc, select SD ip
+	rtkcr_set_pad_driving(sdport,MMC_IOS_GET_PAD_DRV, 0x66,0x64,0x66);
+	sync();
+	memset(g_cmd,0x00,6);
+	memset((struct backupRegs*)&gRegTbl, 0x00, sizeof(struct backupRegs));
+	gCurrentBootMode = MODE_SD20;
+	MMCPRINTF("\ncard sample ctl : 0x%08x\n", cr_readb(sdport->base_io+SD_SAMPLE_POINT_CTL));
+	MMCPRINTF("\ncard push point ctl : 0x%08x\n",cr_readb(sdport->base_io+SD_PUSH_POINT_CTL));
+	g_crinit=0;
+	gPreventRetry=0;
+	g_bResuming=0;
+	g_bTuning=0;
+
+	printk(KERN_INFO "%s: %s driver initialized\n",
+		mmc_hostname(mmc), DRIVER_NAME);
+
+	return 0;
+
+out:
+	if (sdport) {
+		if (sdport->irq)
+			free_irq(sdport->irq, sdport);
+
+		if (sdport->base)
+			iounmap(sdport->base);
+	}
+	if (r)
+		release_resource(r);
+	if (mmc)
+		mmc_free_host(mmc);
+	return ret;
+}
+
+static int __exit rtksd_remove(struct platform_device *pdev)
+{
+    struct mmc_host *mmc = platform_get_drvdata(pdev);
+    MMCPRINTF("\n");
+
+    device_remove_file(&pdev->dev, &dev_attr_cr_send_cmd0);
+    device_remove_file(&pdev->dev, &dev_attr_cr_fast_RW);
+    device_remove_file(&pdev->dev, &dev_attr_em_open_log);
+    device_remove_file(&pdev->dev, &dev_attr_emmc_id);
+
+#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
+    device_remove_file(&pdev->dev, &dev_attr_emmc_hacking);
+#endif
+
+    if (mmc) {
+        struct rtksd_host *sdport = mmc_priv(mmc);
+
+        flush_scheduled_work();
+
+        rtksd_free_dma_buf(sdport);
+
+        mmc_remove_host(mmc);
+        if(!mmc){
+            printk("eMMC host have removed.\n");
+            mmc_host_local = NULL;
+        }
+        free_irq(sdport->irq, sdport);
+
+        del_timer_sync(&sdport->timer);
+        iounmap(sdport->base);
+
+        release_resource(sdport->res);
+        mmc_free_host(mmc);
+    }
+    platform_set_drvdata(pdev, NULL);
+    return 0;
+}
+
+#ifdef CONFIG_PM
+static int rtksd_suspend(struct platform_device *dev, pm_message_t state)
+{
+	int ret = 0;
+        struct rtksd_host *sdport=NULL;
+        struct mmc_host *mmc = NULL;
+
+        mmc = mmc_host_local;
+        sdport = mmc_priv(mmc);
+        //For suspend mode
+        printk(KERN_ERR "[%s] Enter %s Suspend mode\n",DRIVER_NAME, __func__);
+
+        ret = pm_runtime_force_suspend(dev);
+        printk(KERN_ERR "[%s] Exit %s\n",DRIVER_NAME,__func__);
+
+        return ret;
+}
+
+static int rtksd_resume(struct platform_device *dev)
+{
+	int ret = 0;
+        struct mmc_host *mmc = NULL;
+	struct rtksd_host *sdport=NULL;
+        struct mmc_host *host = NULL;
+
+        mmc = mmc_host_local;
+        sdport = mmc_priv(mmc);
+        if (!sdport)
+                BUG();
+
+        host = sdport->mmc;
+        host->card->host = mmc;
+        g_bResuming=1;
+
+        printk(KERN_ERR "[%s] Enter %s Resume mode\n",DRIVER_NAME, __func__);
+
+        if (!ret)
+                ret = pm_runtime_force_resume(dev);
+
+	sdport->ops->set_crt_muxpad(sdport);
+        rtkemmc_chk_card_insert(sdport);
+        sync();
+
+        g_bResuming=0;
+        init_completion(sdport->int_waiting);
+        printk(KERN_ERR "[%s] Exit %s\n",DRIVER_NAME,__func__);
+
+        return ret;
+}
+static const struct dev_pm_ops rtk_dev_pm_ops = {
+        SET_SYSTEM_SLEEP_PM_OPS(rtksd_suspend, rtksd_resume)
+};
+#if 0
+const struct dev_pm_ops rtk_emmc_pm_ops = {
+        .suspend        = rtksd_suspend,
+        .resume         = rtksd_resume,
+        .poweroff       = NULL,
+        .restore        = NULL,
+};
+
+#define RTK_EMMC_PM_OPS (&rtk_emmc_pm_ops)
+#endif
+#else
+#define RTK_EMMC_PM_OPS NULL
+#endif
+
+/*****************************************************************************************/
+/* driver / device attache area                                                                                                               */
+/*****************************************************************************************/
+
+static struct platform_driver rtkemmc_driver = {
+    .probe      = rtkemmc_probe,
+    .remove     = __exit_p(rtksd_remove),
+    .driver     = 
+    {
+            .name   = "rtkemmc",
+	    //.pm	= RTK_EMMC_PM_OPS,
+            .owner  = THIS_MODULE,
+            .of_match_table = rtk_rtkemmc_ids,
+#ifdef CONFIG_PM
+                .pm     = &rtk_dev_pm_ops
+#endif
+    },
+};
+
+static void rtkcr_display_version (void)
+{
+    const __u8 *revision;
+    const __u8 *date;
+    const __u8 *time;
+    char *running = (__u8 *)VERSION;
+
+    strsep(&running, " ");
+    strsep(&running, " ");
+    revision = strsep(&running, " ");
+    date = strsep(&running, " ");
+    time = strsep(&running, " ");
+    printk(BANNER " Rev:%s (%s %s)\n", revision, date, time);
+    printk("%s: build at %s %s\n",DRIVER_NAME, __DATE__, __TIME__);
+
+#ifdef CONFIG_MMC_BLOCK_BOUNCE
+    printk("%s: CONFIG_MMC_BLOCK_BOUNCE enable\n",DRIVER_NAME);
+#else
+    printk("%s: CONFIG_MMC_BLOCK_BOUNCE disable\n",DRIVER_NAME);
+#endif
+
+#ifdef CONFIG_SMP
+    printk("%s: ##### CONFIG_SMP alert!! #####\n",DRIVER_NAME);
+#else
+    printk("%s: ##### CONFIG_SMP disable!! #####\n",DRIVER_NAME);
+#endif
+}
+
+static int rtkemmc_set_bus_width(char * buf){
+    /*
+    get eMMC bus width setting by bootcode parameter, like below
+    bootargs=console=ttyS0,115200 earlyprintk emmc_bus=8
+    the keyword is "emmc_bus"
+    the getted parameter is hex.
+    example:
+        emmc_bus=8
+    */
+
+    rtkcr_chk_param(&rtk_emmc_bus_wid,1,buf+1);
+    printk("%s: setting bus width is %u-bit\n",
+                DRIVER_NAME,rtk_emmc_bus_wid);
+    return 0;
+}
+
+static int __init rtkemmc_init(void)
+{
+    int rc = 0;
+
+    MMCPRINTF("\n");
+
+    rtkcr_display_version();
+
+#ifdef CONFIG_ANDROID
+    printk(KERN_INFO "%s: Android timming setting\n",DRIVER_NAME);
+#endif
+
+    rc = platform_driver_register(&rtkemmc_driver);
+
+    if (rc < 0){
+        printk(KERN_INFO "Realtek EMMC Controller Driver installation fails.\n\n");
+        return -ENODEV;
+    }else{
+#ifdef ENABLE_EMMC_INT_MODE
+        printk(KERN_INFO "Realtek EMMC Controller Driver is running interrupt mode.\n\n");
+#endif
+        printk(KERN_INFO "Realtek EMMC Controller Driver is successfully installing.\n\n");
+        return 0;
+    }
+
+    return rc;
+}
+
+static void __exit rtkemmc_exit(void)
+{
+    MMCPRINTF("\n");
+    platform_driver_unregister(&rtkemmc_driver);
+}
+
+// allow emmc driver initialization earlier
+module_init(rtkemmc_init);
+module_exit(rtkemmc_exit);
+
+/* maximum card clock frequency (default 50MHz) */
+module_param(maxfreq, int, 0);
+
+/* force PIO transfers all the time */
+module_param(nodma, int, 0);
+
+MODULE_AUTHOR("Elbereth");
+MODULE_DESCRIPTION("Realtek EMMC Host Controller driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtkemmc");
+
+__setup("emmc_bus",rtkemmc_set_bus_width);
+
+
+
diff --git a/drivers/mmc/host/rtkemmc_rtd119x.h b/drivers/mmc/host/rtkemmc_rtd119x.h
new file mode 100644
index 00000000..5c5c2fe
--- /dev/null
+++ b/drivers/mmc/host/rtkemmc_rtd119x.h
@@ -0,0 +1,594 @@
+/*
+ *  Copyright (C) 2010 Realtek Semiconductors, All Rights Reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __RTKEMMC_H
+#define __RTKEMMC_H
+
+#include "reg_mmc_rtd119x.h"               //liao
+#include "mmc_debug.h"               //liao
+
+//debug
+//#define MMC_DBG
+#ifdef MMC_DBG
+#define MMCPRINTF(fmt, args...)   printk(fmt,## args)
+#else
+#define MMCPRINTF(fmt, args...)
+#endif
+
+/* cmd1 sector mode */
+#define MMC_SECTOR_ADDR         0x40000000
+/*
+ * Clock rates
+ */
+#define RTKSD_CLOCKRATE_MAX			48000000
+#define RTKSD_BASE_DIV_MAX			0x100
+
+/*
+ * pad driving
+ * */
+#define MMC_IOS_GET_PAD_DRV     0x1
+#define MMC_IOS_SET_PAD_DRV     0x2
+#define MMC_IOS_RESTORE_PAD_DRV 0x4
+
+#define cr_readb(offset)        (*(volatile unsigned char *)GET_MAPPED_RBUS_ADDR(offset))
+#if 0
+#define cr_writeb(val, offset)  do { 							\
+				(*(volatile unsigned char *) (offset)) = val;\
+                                asm ("DMB");						\
+				} while(0);
+#else
+#define cr_writeb(val, offset)  do { 							\
+				(*(volatile unsigned char *) GET_MAPPED_RBUS_ADDR(offset)) = val;           \
+                                asm ("DMB");						\
+				} while(0);
+//#define cr_writeb(val, offset)  ((*(volatile unsigned char *) (offset)) = val)
+#endif
+#define cr_readl(offset)        (*(volatile unsigned int *)GET_MAPPED_RBUS_ADDR(offset))
+#define cr_writel(val, offset)  do { 							\
+				(*(volatile unsigned int *) GET_MAPPED_RBUS_ADDR(offset)) = val;            \
+                                asm ("DMB");						\
+				} while(0)
+
+#define CLEAR_CR_CARD_STATUS(reg_addr)      \
+do {                                \
+    cr_writel(0xffffffff, reg_addr);    \
+} while (0)
+
+#define CLEAR_ALL_CR_CARD_STATUS(io_base)        \
+do {                                \
+    int i = 0;  \
+    for(i=0; i<5; i++)  \
+        CLEAR_CR_CARD_STATUS(io_base+20+ (i*4));  \
+} while (0)
+
+/*  ===== macros and funcitons for Realtek CR ===== */
+/* for SD/MMC usage */
+#define ON                      0
+#define OFF                     1
+#define GPIO_OUT    1
+#define GPIO_IN     0
+#define GPIO_HIGH   1
+#define GPIO_LOW    0
+
+/* MMC configure1, for SD_CONFIGURE1 */
+#define SD30_FIFO_RST               (1<<4)
+#define SD1_R0                      (SD30_FIFO_RST)
+
+/* MMC configure3 , for SD_CONFIGURE3 */
+#define SD30_CLK_STOP               (1<<4)
+#define SD2_R0                      (RESP_CHK_EN | ADDR_BYTE_MODE)
+
+/* MMC configure2, for SD_CONFIGURE2, response type */
+#define SD_R0                   (RESP_TYPE_NON|CRC7_CHK_DIS)
+#define SD_R1                   (RESP_TYPE_6B)
+#define SD_R1b                  (RESP_TYPE_6B|WAIT_BUSY_EN)
+#define SD_R2                   (RESP_TYPE_17B)
+#define SD_R3                   (RESP_TYPE_6B)
+#define SD_R4                   (RESP_TYPE_6B)
+#define SD_R5                   (RESP_TYPE_6B)
+#define SD_R6                   (RESP_TYPE_6B)
+#define SD_R7                   (RESP_TYPE_6B)
+#define SD_R_NO                 (0xFF)
+
+/* rtflags */
+#define RTKCR_FCARD_DETECTED    (1<<0)      /* Card is detected */
+#define RTKCR_FOPEN_LOG         (1<<1)      /* open command log */
+#define RTKCR_USER_PARTITION    (1<<2)      /* card is working on normal partition */
+
+#define RTKCR_FCARD_POWER       (1<<4)      /* Card is power on */
+#define RTKCR_FHOST_POWER       (1<<5)      /* Host is power on */
+
+struct rtksd_host {
+    struct mmc_host     *mmc;           /* MMC structure */
+    u32                 rtflags;        /* Driver states */
+    u8                  ins_event;
+    u8                  cmd_opcode;
+
+#define EVENT_NON		    0x00
+#define EVENT_INSER		    0x01
+#define EVENT_REMOV		    0x02
+#define EVENT_USER		    0x10
+
+    u8                  reset_event;
+    struct mmc_request  *mrq;            /* Current request */
+    u8                  wp;
+    struct rtk_host_ops *ops;
+    struct semaphore	sem;
+    struct semaphore	sem_op_end;
+
+    void __iomem        *base;
+    u32 base_io;
+    spinlock_t          lock;
+    unsigned int        ns_per_clk;
+    struct delayed_work cmd_work;
+    struct tasklet_struct req_end_tasklet;
+
+    struct timer_list   timer;
+    struct timer_list   plug_timer;
+    struct completion   *int_waiting;
+    struct device       *dev;
+    struct resource     *res;
+    int                 irq;
+    u8                  *tmp_buf;
+    dma_addr_t          tmp_buf_phy_addr;
+    dma_addr_t          paddr;
+#ifdef MONI_MEM_TRASH
+    u8                  *cmp_buf;
+    dma_addr_t          phy_addr;
+#endif
+    //int                 gpio_card_detect;
+    //int                 gpio_write_protect;
+    u32                 test_count;
+    u32                 int_status;
+    u32                 int_status_old;
+    u32                 sd_status1;
+    u32                 sd_status2;
+    u32                 bus_status;
+    u32                 dma_trans;
+    u32                 sd_trans;
+    u32                 gpio_isr_info;
+    u32                 tmout;
+};
+
+struct rtk_host_ops {
+    irqreturn_t (*func_irq)(int irq, void *dev);
+    int (*re_init_proc)(struct mmc_card *card);
+    int (*card_det)(struct rtksd_host *sdport);
+    void (*card_power)(struct rtksd_host *sdport,u8 status);
+    void (*chk_card_insert)(struct rtksd_host *rtkhost);
+    void (*set_crt_muxpad)(struct rtksd_host *rtkhost);
+    void (*set_clk)(struct rtksd_host *rtkhost,u32 mmc_clk);
+    void (*reset_card)(struct rtksd_host *rtkhost);
+    void (*reset_host)(struct rtksd_host *rtkhost);
+    void (*bus_speed_down)(struct rtksd_host *sdport);
+    u32 (*get_cmdcode)(u32 opcode );
+    u32 (*get_r1_type)(u32 opcode );
+    u32 (*chk_cmdcode)(struct mmc_command* cmd);
+    u32 (*chk_r1_type)(struct mmc_command* cmd);
+    u32 (*backup_regs)(struct rtksd_host *sdport);
+    u32 (*restore_regs)(struct rtksd_host *sdport);
+};
+
+struct ms_cmd_pkt {
+    struct rtksd_host   *sdport;
+    struct ms_command   *mscmd;
+    struct mmc_data     *data;
+
+    unsigned char       *dma_buffer;    //data transfer address
+    u16                 cmdcode;        //rtk ms operation code
+    u16                 trans_bytes;    //register transfer bytes
+    u16                 block_count;    //data block transfer count
+};
+
+struct sd_cmd_pkt {
+    struct mmc_host     *mmc;       /* MMC structure */
+    struct rtksd_host   *sdport;
+    struct mmc_command  *cmd;    /* cmd->opcode; cmd->arg; cmd->resp; cmd->data */
+    struct mmc_data     *data;
+    unsigned char       *dma_buffer;
+    u16                 byte_count;
+    u16                 block_count;
+
+    u32                 flags;
+    s8                  rsp_para1;
+    s8                  rsp_para2;
+    s8                  rsp_para3;
+    u8                  rsp_len;
+    u32                 timeout;
+};
+
+struct backupRegs {
+    u32			emmc_pad_ctl;
+    u32			emmc_ckgen_ctl;
+    u32			sys_pll_emmc3;
+    u32			pll_emmc1;
+    u8			card_select;
+    u8			sample_point_ctl;
+    u8			push_point_ctl;
+    u8			sd_configure1;
+    u8			sd_configure2;
+    u8			sd_configure3;
+};
+
+/* *** Realtek CRT register &&& */
+
+/* CRT_SYS_CLKSEL setting bit *** */
+//#define EMMC_CLKSEL_SHT        (12)
+//#define SD_CLKSEL_SHT          (20)
+
+#define EMMC_CLKSEL_MASK        (0x07<<EMMC_CLKSEL_SHT)
+#define SD_CLKSEL_MASK          (0x07<<SD_CLKSEL_SHT)
+#define EMMC_CLOCK_SPEED_GAP    (0x03<<EMMC_CLKSEL_SHT)
+#define SD_CLOCK_SPEED_GAP      (0x03<<SD_CLKSEL_SHT)
+
+
+static const char *const clk_tlb_B[8] = {
+    "12MHz",
+    "16MHz",
+    "20MHz",
+    "25MHz",
+    "33MHz",
+    "49MHz"
+};
+
+/* Magellan_ISO_arch_spec.doc; PMM_Magellan_PinMux.doc */
+// iso gpio pinmux map
+static const u8 st_gpio_map[36] ={
+    0x34,0x34,0x34,0x34,0x30,0x30,0x30,0x30,    //0:7
+    0x2c,0x2c,0x2c,0x2c,0x28,0x28,0xff,0xff,    //8:15
+    0xff,0xff,0xff,0xff,0xff,0x28,0x28,0x24,    //16:23
+    0xff,0xff,0x24,0x24,0x24,0xff,0xff,0xff,    //24:31
+    0xff,0xff,0xff,0x20                         //32:35
+};
+
+// iso gpio pinmux bit operation map
+static const u8 st_gpio_bit_map[36] ={
+    0x04,0x0C,0x14,0x1C,0x04,0x0C,0x14,0x1C,    //0:7
+    0x04,0x0C,0x14,0x1C,0x04,0x0C,0xff,0xff,    //8:15
+    0xff,0xff,0xff,0xff,0xff,0x14,0x1C,0x04,    //16:23
+    0xff,0xff,0x0C,0x14,0x1C,0xff,0xff,0xff,    //24:31
+    0xff,0xff,0xff,0x04                         //32:35
+};
+
+#define MAX_CMD_RETRY_COUNT 4
+#define MAX_ISO_GPIO_CNT 35
+#define MAX_MIS_GPIO_CNT 169
+static const u8 mis_gpio_bit_map[4] ={
+    0x1C,0x14,0x0C,0x04    //0:3
+};
+
+#define CARD_SWITCHCLOCK_25MHZ_B    (0x00UL)    //(0x05)
+#define CARD_SWITCHCLOCK_33MHZ_B    (0x01UL)    //(0x06)
+#define CARD_SWITCHCLOCK_40MHZ_B    (0x02UL)    //(0x00)
+#define CARD_SWITCHCLOCK_50MHZ_B    (0x03UL)    //(0x01)
+#define CARD_SWITCHCLOCK_66MHZ_B    (0x04UL)    //(0x02)
+#define CARD_SWITCHCLOCK_98MH_B     (0x05UL)    //(0x03)
+#define CLOCK_SPEED_GAP          CARD_SWITCHCLOCK_50MHZ_B
+#define LOW_SPEED_LMT               CARD_SWITCHCLOCK_33MHZ_B
+
+static const u32 map_clk_to_reg[6] =
+{0x05,0x06,0x00,0x01,0x02,0x03};
+
+static const u32 map_reg_to_clk[8] =
+{0x02,0x03,0x04,0x05,0xFF,0x00,0x01,0xFF};
+
+#define CARD_SWITCHCLOCK_60MHZ  (0x00UL)      //(0x00<<12)
+#define CARD_SWITCHCLOCK_80MHZ  (0x01UL)      //(0x01<<12)
+#define CARD_SWITCHCLOCK_98MHZ  (0x02UL)      //(0x02<<12)
+#define CARD_SWITCHCLOCK_98MHZS (0x03UL)      //(0x03<<12)
+#define CARD_SWITCHCLOCK_30MHZ  (0x04UL)      //(0x04<<12)
+#define CARD_SWITCHCLOCK_40MHZ  (0x05UL)      //(0x05<<12)
+#define CARD_SWITCHCLOCK_49MHZ  (0x06UL)      //(0x06<<12)
+#define CARD_SWITCHCLOCK_49MHZS (0x07UL)      //(0x07<<12)
+
+/* CRT_SYS_CLKSEL setting bit &&& */
+
+/* CRT_SYS_SRST2 setting bit *** */
+#define RSTN_CR (0x01<<23)      //for eMMC
+/* CRT_SYS_SRST2 setting bit &&& */
+
+/* CRT_SYS_SRST3 setting bit *** */
+#define RSTN_SD (0x01<<16)      //for card reader
+/* CRT_SYS_SRST3 setting bit &&& */
+
+
+/* CRT_SYS_CLKEN2 setting bit *** */
+#define CLKEN_CR (0x01<<23)      //for eMMC
+/* CRT_SYS_CLKEN2 setting bit &&& */
+
+/* CRT_SYS_CLKEN3 setting bit *** */
+#define CLKEN_SD (0x01<<16)      //for card reader
+/* CRT_SYS_CLKEN3 setting bit &&& */
+
+#define CR_PINMUX_CR_MASK       0xFFFFC000
+
+#define MUX_SD_DAT2             (0x01<<26)
+#define MUX_MS_CLK              (0x02<<26)
+#define MUX_SD_DAT1             (0x01<<24)
+#define MUX_MS_BS               (0x02<<24)
+#define MUX_SD_DT               (0x01<<20)
+#define MUX_OTP_ATE_FAIL        (0x02<<20)
+#define MUX_SD_WP               (0x01<<18)
+#define MUX_MS_DT               (0x02<<18)
+#define MUX_SD_CLK              (0x01<<16)
+#define MUX_MS_DAT0             (0x02<<16)
+#define MUX_SD_CMD              (0x01<<14)
+#define MUX_MS_DAT2             (0x02<<14)
+
+#define MUX_PAD5_DEFAULT         0x15554000
+
+#define CR_PMUX_CMD_MASK        ~(0x03<<14)  //mask 15,14
+#define CR_PMUX_CLK_MASK        ~(0x03<<16)  //mask 16,17
+#define CR_PMUX_MOD_MASK        ~(0x0f<<18)  //mask 18,19,20,21
+//#define DETECT_MODE             MUX_MS_DT|MUX_SD_DT
+#define DETECT_MODE             MUX_SD_DT
+
+#define MUX_PAD5_SD_MODE        0x15554000
+
+#define RCA_SHIFTER             16
+#define NORMAL_READ_BUF_SIZE    512      //no matter FPGA & QA
+
+#define SD_CARD_WP              (1<<5)
+//#define MS_CARD_EXIST           (1<<3)
+#define SD_CARD_EXIST           (1<<2)
+
+/* ======================================================= */
+// see "Main_Magellan_PinMux.doc"
+#define PINMUX_REG_BASE		0xb8000800
+#define GPIO_MUXCFG_0		(PINMUX_REG_BASE + 0x00)    //0xb8000800
+#define GPIO_MUXCFG_1		(PINMUX_REG_BASE + 0x04)    //0xb8000804
+#define GPIO_MUXCFG_2		(PINMUX_REG_BASE + 0x08)    //0xb8000808
+#define GPIO_MUXCFG_3		(PINMUX_REG_BASE + 0x0c)    //0xb800080C
+#define GPIO_MUXCFG_4		(PINMUX_REG_BASE + 0x10)    //0xb8000810
+#define GPIO_MUXCFG_5		(PINMUX_REG_BASE + 0x14)    //0xb8000814
+#define GPIO_MUXCFG_6		(PINMUX_REG_BASE + 0x18)    //0xb8000818
+
+#define GPIO_MUXCFG_13		(PINMUX_REG_BASE + 0x34)    //0xb8000834
+#define GPIO_MUXCFG_14		(PINMUX_REG_BASE + 0x38)    //0xb8000838
+#define GPIO_MUXCFG_15		(PINMUX_REG_BASE + 0x3C)    //0xb800083C
+#define GPIO_MUXCFG_16		(PINMUX_REG_BASE + 0x40)    //0xb8000840
+#define GPIO_MUXCFG_17		(PINMUX_REG_BASE + 0x44)    //0xb8000844
+#define GPIO_MUXCFG_18		(PINMUX_REG_BASE + 0x48)    //0xb8000848
+
+/*======================================================== */
+
+/* move from c file *** */
+#define BYTE_CNT            0x200
+#define RTK_NORMAL_SPEED    0x00
+#define RTK_HIGH_SPEED      0x01
+#define RTK_1_BITS          0x00
+#define RTK_4_BITS          0x10
+#define RTK_BITS_MASK       0x30
+#define RTK_SPEED_MASK      0x01
+#define RTK_PHASE_MASK      0x06
+
+#define R_W_CMD             2   //read/write command
+#define INN_CMD             1   //command work chip inside
+#define UIN_CMD             0   //no interrupt rtk command
+
+#define RTK_FAIL            3  /* DMA error & cmd parser error */
+#define RTK_RMOV            2  /* card removed */
+#define RTK_TOUT            1  /* time out include DMA finish & cmd parser finish */
+#define RTK_SUCC            0
+
+#define CR_TRANS_OK         0x0
+#define CR_TRANSFER_TO      0x1
+#define CR_BUF_FULL_TO      0x2
+#define CR_DMA_FAIL         0x3
+#define CR_TRANSFER_FAIL    0x4
+#define CR_TRANSFER_IGN     0xf
+
+/* send status event */
+#define STATE_IDLE          0
+#define STATE_READY         1
+#define STATE_IDENT         2
+#define STATE_STBY          3
+#define STATE_TRAN          4
+#define STATE_DATA          5
+#define STATE_RCV           6
+#define STATE_PRG           7
+#define STATE_DIS           8
+
+#define GPIO_HI             0x78
+#define GPIO_LO             0x87
+
+#define LVL_HI             0x01
+#define LVL_LO             0x00
+
+#define POW_CHECK 0
+#define POW_FORCE 1
+
+#define rtkcr_get_int_sta(io_base,status_addr)                           \
+            do {                                                         \
+                if (io_base == CR_BASE_ADDR)                             \
+                    *(u32 *)status_addr = cr_readl(io_base+CR_SD_ISR);   \
+                else                                                     \
+                    *(u32 *)status_addr = cr_readl(io_base+EMMC_SD_ISR); \
+            } while (0);
+
+#define rtkcr_get_sd_sta(io_base,status_addr1,status_addr2,bus_status)       \
+            do {                                                             \
+                    *(u32 *)status_addr1 = cr_readb(io_base+SD_STATUS1);     \
+                    *(u32 *)status_addr2 = cr_readb(io_base+SD_STATUS2);     \
+                    *(u32 *)bus_status = cr_readb(io_base+SD_BUS_STATUS);    \
+            } while (0);
+
+#define rtkcr_get_sd_trans(io_base,status_addr) \
+            *(u32 *)status_addr = cr_readb(io_base+SD_TRANSFER)
+#define rtkcr_get_dma_trans(io_base,status_addr) \
+            *(u32 *)status_addr = cr_readb(io_base+CR_DMA_CTL3)
+
+#define rtkcr_clr_int_sta(io_base)                                                                              \
+            do {                                                                                                \
+                if (io_base == CR_BASE_ADDR)                                                                    \
+                    cr_writel( (cr_readl(io_base+CR_SD_ISR)|(ISRSTA_INT1|ISRSTA_INT2))|CLR_WRITE_DATA ,io_base+CR_SD_ISR); \
+                else if (io_base == EM_BASE_ADDR)                                                               \
+                    cr_writel( (cr_readl(io_base+EMMC_SD_ISR)|(ISRSTA_INT1|ISRSTA_INT2))|CLR_WRITE_DATA ,io_base+EMMC_SD_ISR); \
+                else                                                                                            \
+                    cr_writel( (cr_readl(io_base+SDIO_SD_ISR)|(SDIO_ISRSTA_INT1|SDIO_ISRSTA_INT2|SDIO_ISRSTA_INT3|SDIO_ISRSTA_INT4))|CLR_WRITE_DATA ,io_base+SDIO_SD_ISR); \
+            } while(0);
+
+#define rtkcr_hold_int_dec(io_base)    \
+            do {                                                                                                \
+                if (io_base == CR_BASE_ADDR)                                                                    \
+                    cr_writel( (cr_readl(io_base+CR_SD_ISREN)|(ISRSTA_INT1EN|ISRSTA_INT2EN))|CLR_WRITE_DATA ,io_base+CR_SD_ISREN); \
+                else if (io_base == EM_BASE_ADDR)                                                               \
+                    cr_writel( (cr_readl(io_base+EMMC_SD_ISREN)|(ISRSTA_INT1EN|ISRSTA_INT2EN))|CLR_WRITE_DATA ,io_base+EMMC_SD_ISREN); \
+                else                                                                                            \
+                    cr_writel( (cr_readl(io_base+SDIO_SD_ISREN)|SDIO_ISRSTA_INT1EN)|CLR_WRITE_DATA ,io_base+SDIO_SD_ISREN); \
+            } while(0);
+
+#define rtkcr_en_int(io_base)  \
+            do {                                                                                                \
+                if (io_base == CR_BASE_ADDR)                                                                    \
+                    cr_writel( (cr_readl(io_base+CR_SD_ISREN)|(ISRSTA_INT1EN|ISRSTA_INT2EN))|WRITE_DATA ,io_base+CR_SD_ISREN); \
+                else if (io_base == EM_BASE_ADDR)                                                               \
+                    cr_writel( (cr_readl(io_base+EMMC_SD_ISREN)|(ISRSTA_INT1EN|ISRSTA_INT2EN))|WRITE_DATA ,io_base+EMMC_SD_ISREN); \
+                else                                                                                            \
+                    cr_writel( (cr_readl(io_base+SDIO_SD_ISREN)|SDIO_ISRSTA_INT1EN)|WRITE_DATA ,io_base+SDIO_SD_ISREN); \
+            } while(0);
+
+#define  rtkcr_mdelay(x)  \
+            set_current_state(TASK_INTERRUPTIBLE); \
+            schedule_timeout(msecs_to_jiffies(x))
+
+#define INT_BLOCK_R_GAP 0x200
+#define INT_BLOCK_W_GAP 5
+
+static const char *const state_tlb[9] = {
+    "STATE_IDLE",
+    "STATE_READY",
+    "STATE_IDENT",
+    "STATE_STBY",
+    "STATE_TRAN",
+    "STATE_DATA",
+    "STATE_RCV",
+    "STATE_PRG",
+    "STATE_DIS"
+};
+
+static const char *const bit_tlb[4] = {
+    "1bit",
+    "4bits",
+    "8bits",
+    "unknow"
+};
+
+static const char *const clk_tlb[8] = {
+    "30MHz",
+    "40MHz",
+    "49MHz",
+    "49MHz",
+    "15MHz",
+    "20MHz",
+    "24MHz",
+    "24MHz"
+};
+
+static const u32 const clk_2_hz[8] = {
+    10000000,
+    12000000,
+    15000000,
+    20000000,
+    24000000,
+    30000000,
+    40000000,
+    48000000
+};
+
+/* data read cmd */
+static const u8 const opcode_r_type[16] = {
+    0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,0
+};
+
+/* data write cmd */
+static const u8 const opcode_w_type[16] = {
+    1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0
+};
+
+/* data xfer cmd */
+static const u8 const opcode_d_type[16] = {
+    1,1,1,0,0,1,1,0,0,1,1,0,1,1,1,0
+};
+
+static const char *const cmdcode_tlb[16] = {
+    "N_W",      /* 0 */
+    "AW3",      /* 1 */
+    "AW4",      /* 2 */
+    "UNK",      /* 3 */
+    "UNK",      /* 4 */
+    "AR3",      /* 5 */
+    "AR4",      /* 6 */
+    "UNK",      /* 7 */
+    "SGR",      /* 8 */
+    "AW1",      /* 9 */
+    "AW2",      /* 10 */
+    "UNK",      /* 11 */
+    "N_R",      /* 12 */
+    "AR1",      /* 13 */
+    "AR2",      /* 14 */
+    "UNK",      /* 15 */
+};
+
+#define card_sta_err_mask ((1<<31)|(1<<30)|(1<<29)|(1<<28)|(1<<27)|(1<<26)|(1<<24)|(1<<23)|(1<<22)|(1<<21)|(1<<20)|(1<<19)|(1<<18)|(1<<17)|(1<<16)|(1<<15)|(1<<13)|(1<<7))
+
+/* Only ADTC type cmd use */
+static const unsigned char rtk_sd_cmdcode[64][2] = {
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //0~3
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //4~7
+    {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_AUTOREAD1  ,SD_R1 }, //8~11
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //12~15
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_AUTOREAD2  ,SD_R1 }, {EMMC_AUTOREAD1  ,SD_R1 }, {EMMC_NORMALWRITE,SD_R1 }, //16~19
+    {EMMC_AUTOWRITE1 ,SD_R1 }, {EMMC_TUNING     ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //20~23
+    {EMMC_AUTOWRITE2 ,SD_R1 }, {EMMC_AUTOWRITE1 ,SD_R1 }, {EMMC_NORMALWRITE,SD_R1 }, {EMMC_NORMALWRITE,SD_R1 }, //24~27
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_NORMALREAD ,SD_R1 }, //28~31
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //32~35
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //36~39
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //40~43
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //44~47
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_NORMALREAD ,SD_R1 }, //48~51
+    {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //52~55
+    {EMMC_AUTOREAD2  ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }, //56~59
+    {EMMC_AUTOWRITE2 ,SD_R1 }, {EMMC_NORMALREAD ,SD_R1 }, {EMMC_CMD_UNKNOW ,SD_R0 }, {EMMC_CMD_UNKNOW ,SD_R0 }  //60~63 
+};
+
+//void sync();
+int rtkcr_wait_opt_end(char*,struct rtksd_host *sdport,unsigned char cmdcode,unsigned char cmd_idx,unsigned char cpu_mode);
+void rtk_op_complete(struct rtksd_host *sdport);
+char *rtkcr_parse_token(const char *parsed_string, const char *token);
+void rtkcr_chk_param(u32 *pparam, u32 len, u8 *ptr);
+int rtkcr_chk_VerA(void);
+void emmc_show_config123(struct rtksd_host *sdport);
+void rtkcr_set_mis_gpio(u32 gpio_num,u8 dir,u8 level);
+void rtkcr_set_iso_gpio(u32 gpio_num,u8 dir,u8 level);
+
+int mmc_fast_write( unsigned int blk_addr,
+                    unsigned int data_size,
+                    unsigned char * buffer );
+
+int mmc_fast_read( unsigned int blk_addr,
+                   unsigned int data_size,
+                   unsigned char * buffer );
+struct completion* rtk_int_enable(struct rtksd_host *sdport, unsigned long msec);
+int rtk_int_enable_and_waitfor(struct rtksd_host *sdport, u8 cmdcode, u8 cmd_dix, unsigned long msec, unsigned long dma_msec);
+void rtk_int_waitfor(struct rtksd_host *sdport, u8 cmdcode, u8 cmd_idx, unsigned long msec, unsigned long dma_msec);
+/* remove from c file &&& */
+
+/* rtk function definition */
+#define ENABLE_EMMC_INT_MODE
+/* rtk function definition */
+int error_handling(struct rtksd_host *sdport, unsigned int cmd_idx, unsigned int bIgnore);
+int rtkcr_send_cmd25(struct rtksd_host *sdport);
+int rtkcr_send_cmd18(struct rtksd_host *sdport);
+//int rtkcr_send_cmd8(struct rtksd_host *sdport,unsigned int bIgnore);
+int rtkcr_send_cmd8(struct rtksd_host *sdport, unsigned int bIgnore);
+int polling_to_tran_state(struct rtksd_host *sdport, int bIgnore);
+void host_card_stop(struct rtksd_host *sdport);
+static int mmc_Select_SDR50_Push_Sample(struct rtksd_host *sdport);
+
+#endif
diff --git a/drivers/mmc/host/rtkemmc_rtd13xx.c b/drivers/mmc/host/rtkemmc_rtd13xx.c
new file mode 100644
index 00000000..3e73802
--- /dev/null
+++ b/drivers/mmc/host/rtkemmc_rtd13xx.c
@@ -0,0 +1,5426 @@
+/*
+ * Realtek EMMC driver
+ *
+ * Authors:
+ * Copyright (C) 2017 Realtek Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/platform_device.h>
+#include <linux/mbus.h>
+#include <linux/delay.h>
+#include <linux/interrupt.h>
+#include <linux/dma-mapping.h>
+#include <linux/scatterlist.h>
+#include <linux/irq.h>
+#include <linux/gpio.h>
+#include <linux/mmc/host.h>
+#include <asm/unaligned.h>
+
+#include <linux/suspend.h>
+#include <linux/sched.h>
+#include <linux/wait.h>
+#include <linux/slab.h>
+#include <linux/semaphore.h>
+#include <linux/mmc/card.h>
+#include <linux/mmc/host.h>
+#include <linux/mmc/mmc.h>
+#include <linux/mmc/sd.h>
+#include <linux/workqueue.h>
+#include <linux/completion.h>
+#include "reg_iso.h"
+#include "reg_sys.h"
+#include "rtkemmc_rtd13xx.h"
+#include "mmc_debug.h"
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_gpio.h>
+#include <asm/cacheflush.h>
+#include <linux/pm_runtime.h>
+
+#include <soc/realtek/rtk_chip.h>
+
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+#ifdef CONFIG_REALTEK_PCBMGR
+#include <mach/pcbMgr.h>
+#ifdef CONFIG_REALTEK_GPIO
+#include <mach/venus_gpio.h>
+#define EMMC_SHOUTDOWN_PROTECT
+#endif
+#endif
+
+#include <linux/arm-smccc.h>
+
+#define DRIVER_NAME "EMMC"
+#define BANNER      "Realtek eMMC Driver"
+#define VERSION     "$Id: rtkemmc.c Hank 2019-1-7 19:00 $"
+
+#define DMA_ALLOC_LENGTH     (0x80000)
+#define DESC_ALLOC_LENGTH   (1024*1024)
+unsigned int GLOBAL=0;
+#define PHASE_INHERITED
+
+#define FORCE_CHECK_CMD_AND_STS
+
+#ifdef PHASE_INHERITED
+static u32 VP0_saved = 0xFF, VP1_saved =0xFF;
+#endif
+
+#define DQS_INHERITED
+#ifdef DQS_INHERITED
+static u32 dqs_saved = 0xff;
+#endif
+
+#ifdef RTK_EMMC_HEALTH_REPORT
+        int health_report_fd;
+#endif
+
+#define TIMEOUT_MS 3000
+#define TIMEOUT_DMA 50
+#define TIMEOUT_CMD 10000 //10 secs
+
+#ifdef MMC_DBG
+static unsigned sd_reg = 0;
+#endif
+
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+unsigned int emmc_pre_cmd=0;
+#endif
+
+#define TUNING_STAGE1     1
+#define TUNING_STAGE2     2
+#define TUNING_STAGE_BOTH 3
+
+//#define RTKEMMC_DEBUG
+//#define RTKMMEC_DMA_DEBUG
+#define RTKEMMC_PHASE_TRACE
+
+#ifdef RTKEMMC_PHASE_TRACE
+u32 trace_TX_window=0;
+u32 trace_RX_window=0;
+u32 trace_TX1_window=0;
+u32 trace_index=0;
+u32 trace_phase_bitmap=0;
+u32 trace_dqs_counter=0;
+u32 trace_desc_counter=0;
+#endif
+
+struct mmc_host * mmc_host_local = NULL;
+static u32 rtk_emmc_bus_wid = 0;
+static volatile int g_bResuming;
+volatile int g_bTuning;
+//static int bSendCmd0=0;
+volatile unsigned int gCurrentBootMode=MODE_SDR;
+volatile unsigned int gPreventRetry=0;
+static volatile unsigned int  g_crinit=0;
+static struct rw_semaphore cr_rw_sem;
+//ip descriptor on ddr
+unsigned int* gddr_descriptor=NULL;
+static unsigned int* gddr_descriptor_org=NULL;
+
+//internal emmc dma buffer on ddr
+static unsigned char* gddr_dma=NULL;
+static unsigned char* gddr_dma_org=NULL;
+
+int cmd_resend=0;
+static u32 pddrive_nf_s0[5] = {0};
+static u32 pddrive_nf_s1[5] = {0};
+static u32 pddrive_nf_s2[5] = {0};
+static u32 pddrive_nf_s3[5] = {0};
+
+//#ifndef CONFIG_ARCH_RTD16xx
+//#define SHA256
+//#endif
+
+#ifdef SHA256
+int MCP_SHA256(unsigned char *p_in, unsigned char *p_out, unsigned long len, unsigned int iv[8]);
+unsigned char *compare3=NULL;
+unsigned char *compare4=NULL;
+dma_addr_t          compare3_phy_addr;
+dma_addr_t          compare4_phy_addr;
+#else
+unsigned char compare1[DMA_ALLOC_LENGTH];
+unsigned char compare2[DMA_ALLOC_LENGTH];
+#endif
+
+struct reset_control *rstc_emmc;
+struct clk * clk_en_emmc;
+struct clk * clk_en_emmc_ip;
+
+int rtkemmc_hs200_tuning(struct mmc_card *card);
+int mmc_hs400_to_hs200(struct mmc_card *card);
+int mmc_select_hs200(struct mmc_card *card);
+int mmc_select_ddr50(struct mmc_card *card);
+int rtkemmc_switch(struct mmc_card *card, u8 acc_mod, u8 index, u8 value, u8 cmd_set);
+#ifdef RTKEMMC_DEBUG
+static void rtkemmc_dump_registers(struct rtkemmc_host *emmc_port);
+#endif
+static void rtkemmc_request(struct mmc_host *host, struct mmc_request *mrq);
+static int rtkemmc_get_ro(struct mmc_host *mmc);
+static void rtkemmc_set_ios(struct mmc_host *host, struct mmc_ios *ios);
+
+static void set_cmd_info(struct mmc_card *card,struct mmc_command * cmd,
+struct sd_cmd_pkt * cmd_info,u32 opcode,u32 arg,u8 rsp_para);
+
+static int rtkemmc_stop_transmission(struct mmc_card *card,int bIgnore);
+static int rtkemmc_send_status(struct mmc_card *card, u32 *status, u8 * state,u8 divider,int bIgnore);
+static int rtkemmc_wait_status(struct mmc_card *card,u8 state,u8 divider,int bIgnore);
+int rtkemmc_send_cmd6(struct rtkemmc_host *emmc_port, u32 args,u16 * state, int phase);
+static int rtkemmc_send_cmd13(struct rtkemmc_host *emmc_port, u16 * state);
+
+static int mmc_Tuning_SDR50(struct rtkemmc_host *emmc_port);
+static int mmc_Tuning_DDR50(struct rtkemmc_host *emmc_port,u32 mode);
+static int mmc_Tuning_HS200(struct rtkemmc_host *emmc_port,u32 mode);
+void set_RTK_initial_flag(int flag);
+static int rtkemmc_execute_tuning(struct mmc_host *host, u32 opcode);
+static int rtkemmc_prepare_hs400_tuning(struct mmc_host *host, struct mmc_ios *ios);
+void phase(struct rtkemmc_host *emmc_port, u32 VP0, u32 VP1);
+static void rtkemmc_chk_card_insert(struct rtkemmc_host *emmc_port);
+static void rtkemmc_set_pin_mux(struct rtkemmc_host *emmc_port);
+static u32 rtkemmc_chk_cmdcode(struct mmc_command* cmd);
+static void rtkemmc_set_freq(struct rtkemmc_host *emmc_port, u32 freq, u32 div_ip);
+void error_handling(struct rtkemmc_host *emmc_port);
+static int SD_SendCMDGetRSP(struct sd_cmd_pkt * cmd_info,int bIgnore);
+static int SD_SendCMDGetRSP_Cmd(struct sd_cmd_pkt *cmd_info,int bIgnore);
+void rtkemmc_set_pad_driving(struct rtkemmc_host *emmc_port, u32 clk_drv, u32 cmd_drv, u32 data_drv, u32 ds_drv);
+static int wait_done_timeout(struct rtkemmc_host *emmc_port, volatile u32 *addr, u32 mask, u32 value,const char *string);
+static int SD_Stream_Cmd(u16 cmdcode,struct sd_cmd_pkt *cmd_info, unsigned int bIgnore);
+static void rtkemmc_dqs_tuning(struct mmc_host *host);
+int rtkemmc_select_timing(struct mmc_card *card);
+void rtkemmc_select_card_type(struct mmc_card *card);
+void down_speed_handling(struct rtkemmc_host *emmc_port);
+u32 rtkemmc_swap_endian(u32 input);
+DECLARE_COMPLETION(rtk_emmc_wait);
+typedef void (*set_gpio_func_t)(u32 gpio_num,u8 dir,u8 level);
+
+
+int suspend = 0;
+int suspend_VP0=0xff, suspend_VP1=0xff;
+int HS200_RX=0xff, HS200_TX=0xff;
+int suspend_dqs=0x88;
+bool hs400_to_hs200_flag=false;
+
+static const struct mmc_host_ops rtkemmc_ops = {
+	.request        = rtkemmc_request,
+	.get_ro         = rtkemmc_get_ro,
+	.set_ios        = rtkemmc_set_ios,
+	.execute_tuning = rtkemmc_execute_tuning,
+	.prepare_hs400_tuning = rtkemmc_prepare_hs400_tuning,
+	.dqs_tuning = rtkemmc_dqs_tuning
+};
+
+static struct rtk_host_ops emmc_ops = {
+	.func_irq       = NULL,
+	.re_init_proc   = NULL,
+	.card_det       = NULL,
+	.card_power     = NULL,
+        .chk_card_insert= rtkemmc_chk_card_insert,
+        .set_crt_muxpad = rtkemmc_set_pin_mux,
+        .set_clk        = NULL,
+	.reset_card     = NULL,
+	.reset_host     = NULL,
+	.bus_speed_down = NULL,
+	.get_cmdcode    = NULL,
+	.get_r1_type    = NULL,
+	.chk_cmdcode    = rtkemmc_chk_cmdcode,
+	.chk_r1_type    = NULL,
+	.backup_regs    = NULL,
+	.restore_regs   = NULL,
+};
+
+// write addr with val
+void rtkemmc_write_swc(u32 addr, u32 val)
+{
+	struct arm_smccc_res res;
+
+	arm_smccc_smc(0x8400ffff, addr, val, 0, 0, 0, 0, 0, &res);
+}
+
+// read addr
+u32 rtkemmc_read_swc(u32 addr)
+{
+	struct arm_smccc_res res;
+	arm_smccc_smc(0x8400fffe, addr, 0, 0, 0, 0, 0, 0, &res);
+	return res.a0;
+}
+
+void sync(struct rtkemmc_host *emmc_port)
+{
+	dmb(sy);
+	writel(0x0, emmc_port->sb2_membase+0x20);
+	dmb(sy);
+}
+
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+bool partition_pon_sem = false;
+
+void rtkemmc_occupy_semaphore(void)
+{
+	struct mmc_host * mmc = mmc_host_local;
+	struct rtkemmc_host *emmc_port = mmc_priv(mmc);
+
+	while(1) {
+		if(readl(emmc_port->emmc_membase+EMMC_HD_SEM)==1) break;
+		else {
+			printk(KERN_INFO "%s: Pon is occupying the semaphore,\
+				pon opcode=%d, pon argument=0x%x, 0x98012030=0x%x, 0x98012032=0x%x, 0x9801203c=0x%x, 0x98012814=0x%x, 0x98012818=0x%x\n",
+				__func__, CMD_IDX_MASK(readl(emmc_port->emmc_membase+EMMC_CMD_R)), readl(emmc_port->emmc_membase+EMMC_ARGUMENT_R),
+				readw(emmc_port->emmc_membase+0x30), readw(emmc_port->emmc_membase+0x32),
+				readw(emmc_port->emmc_membase+0x3c), readl(emmc_port->emmc_membase+0x814), readl(emmc_port->emmc_membase+0x818));
+				usleep_range(10, 30);
+		}
+	}
+	partition_pon_sem = true;
+}
+EXPORT_SYMBOL(rtkemmc_occupy_semaphore);
+
+void rtkemmc_release_semaphore(void)
+{
+	struct mmc_host * mmc = mmc_host_local;
+	struct rtkemmc_host *emmc_port = mmc_priv(mmc);
+
+	rtkemmc_writel(0x0, emmc_port->emmc_membase+EMMC_HD_SEM);
+	partition_pon_sem = false;
+}
+EXPORT_SYMBOL(rtkemmc_release_semaphore);
+#endif
+
+//---------------------------------------------------------------------------------------------------------------------------
+#ifdef CONFIG_RTK_ACPU_RELOAD
+//this part is set for avcpu.c usage
+
+static int rtkemmc_switch_user_partition(struct mmc_card *card)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	int err = 0;
+
+	MMCPRINTF("\n");
+
+	memset(&cmd, 0, sizeof(struct mmc_command));
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	set_cmd_info(card,&cmd,&cmd_info, MMC_SWITCH, 0x03b30001, 6);
+
+	err = SD_SendCMDGetRSP_Cmd(&cmd_info,0);
+
+	if(err){
+		mmcmsg3(KERN_WARNING "%s: MMC_SWITCH fail\n",DRIVER_NAME);
+	}
+	return err;
+}
+/* ========================================================
+ * blk_addr    : eMMC read/write target address, block base.
+ * data_size   : tarnsfer data size, block base.
+ * buffer      : DMA address
+ * rw_mode     : fast read or ast write
+ ========================================================== */
+#define FAST_READ   0x1278
+#define FAST_WRITE  0x3478
+static int mmc_fast_rw( unsigned int blk_addr, unsigned int data_size, unsigned char * buffer, unsigned int rw_mode )
+{
+	int err = 0;
+	struct mmc_host * mmc = mmc_host_local;
+	unsigned long flags;
+
+	if(mmc){
+		struct rtkemmc_host *emmc_port;
+		struct mmc_card *card;
+		struct mmc_request mrq = {0};
+		struct mmc_command cmd = {0};
+		struct mmc_data     data   = {0};
+		struct scatterlist sg;
+
+		emmc_port = mmc_priv(mmc);
+		mmc_claim_host(mmc);
+		spin_lock_irqsave(&emmc_port->lock,flags);
+
+		card = mmc->card;
+		if((emmc_port->rtflags & RTKCR_USER_PARTITION)==0){
+			int try_loop = 3;
+			do{
+				err = 0;
+				spin_unlock_irqrestore(&emmc_port->lock, flags);
+				err = rtkemmc_switch_user_partition(card);
+				spin_lock_irqsave(&emmc_port->lock,flags);
+
+			}while(try_loop-- && err );
+
+			if(err){
+				spin_unlock_irqrestore(&emmc_port->lock, flags);
+				mmc_release_host(mmc);
+				goto ERR_OUT;
+			}
+			else
+				emmc_port->rtflags |= RTKCR_USER_PARTITION;
+		}
+
+		if(data_size>1){
+			if(rw_mode == FAST_WRITE)
+				cmd.opcode = MMC_WRITE_MULTIPLE_BLOCK;
+			else
+				cmd.opcode = MMC_READ_MULTIPLE_BLOCK;
+		}else{
+			if(rw_mode == FAST_WRITE)
+				cmd.opcode = MMC_WRITE_BLOCK;
+			else
+				cmd.opcode = MMC_READ_SINGLE_BLOCK;
+		}
+
+		cmd.arg = blk_addr;
+		cmd.flags = MMC_RSP_R1 | MMC_CMD_ADTC;
+
+		if(data_size) {   //date info setting
+			data.sg = &sg;
+			data.sg_len = 1;
+			data.blksz = 512;
+			data.blocks = data_size;
+
+			sg_init_one(data.sg, buffer, (data_size<<9));
+
+			if(rw_mode == FAST_WRITE)
+				data.flags = MMC_DATA_WRITE;
+			else
+				data.flags = MMC_DATA_READ;
+
+			mmc_set_data_timeout(&data, card);
+		}
+
+		data.mrq = &mrq;
+		cmd.mrq = &mrq;
+		cmd.data = &data;
+		cmd.retries =5;
+CMD_RETRY:
+		mrq.data = &data;
+		mrq.cmd = &cmd;
+
+		if(emmc_port->mrq){
+			emmc_port->mrq = NULL;
+		}
+
+		cmd.error = 0;
+		data.error = 0;
+		spin_unlock_irqrestore(&emmc_port->lock, flags);
+		mmc_wait_for_req(mmc, &mrq);
+		spin_lock_irqsave(&emmc_port->lock,flags);
+		err = cmd.error;
+		if((err==0) && (rw_mode==FAST_WRITE))
+		{
+			spin_unlock_irqrestore(&emmc_port->lock, flags);
+			err = rtkemmc_wait_status(mmc->card,STATE_TRAN,0,0);
+			spin_lock_irqsave(&emmc_port->lock,flags);
+		}
+		if(err && cmd.retries){
+			printk("%s(%u)last retry %d counter.\n", __func__,__LINE__,cmd.retries);
+			cmd.retries--;
+			goto CMD_RETRY;
+		}
+		spin_unlock_irqrestore(&emmc_port->lock, flags);
+		mmc_release_host(mmc);
+	}else{
+		err = -ENODEV;
+	}
+ERR_OUT:
+	if(err)
+		printk("err=%d\n",err);
+
+	return err;
+}
+
+#define MAX_XFER_BLK_A    0x100
+#define MAX_XFER_BLK_B    0x400
+static int mmc_fast_rw_loop(unsigned int blk_addr, unsigned int data_size, unsigned char * buffer, unsigned int rw_mode )
+{
+	int err = 0;
+
+	unsigned int tmp_addr   = blk_addr;
+	unsigned int tmp_size   = data_size;
+	unsigned int org_size   = data_size;
+	unsigned char * tmp_buf = buffer;
+	unsigned int max_xfer_blk;
+	do{
+		// max 1M bytes read/write per transfer
+
+		max_xfer_blk = MAX_XFER_BLK_B;
+
+		if(data_size > max_xfer_blk){
+			tmp_size = max_xfer_blk;
+		}else{
+			tmp_size = data_size;
+		}
+
+		err = mmc_fast_rw(tmp_addr,tmp_size,tmp_buf,rw_mode);
+
+		if(err)
+			break;
+
+		if(data_size > max_xfer_blk){
+			tmp_addr    += max_xfer_blk;
+			data_size   -= max_xfer_blk;
+			tmp_buf     += (max_xfer_blk<<9);
+		}else{
+			data_size = 0;
+		}
+	}while(data_size);
+
+	if(err == 0)
+		return org_size-data_size;
+	else
+		return err;
+}
+
+int mmc_fast_read(unsigned int blk_addr, unsigned int data_size, unsigned char * buffer )
+{
+	int err = 0;
+	err = mmc_fast_rw_loop(blk_addr,data_size,buffer,FAST_READ);
+	return err;
+}
+EXPORT_SYMBOL(mmc_fast_read);
+
+int mmc_fast_write(unsigned int blk_addr, unsigned int data_size, unsigned char * buffer )
+{
+	int err = 0;
+	if(blk_addr<0x20000){
+		printk("target small then save area.\n");
+		err = -1;
+	}
+	err = mmc_fast_rw_loop(blk_addr,data_size,buffer,FAST_WRITE);
+	return err;
+}
+EXPORT_SYMBOL(mmc_fast_write);
+#endif
+//------------------------------------------------------------------------------------------------------------------------------
+
+//----------------------------------------command queue related function---------- -------------------------------------------
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+
+int mmc_cmdq_halt(struct mmc_host *host, bool halt);
+static int rtkemmc_cmdq_enable(struct mmc_host *mmc);
+static int rtkemmc_cmdq_request(struct mmc_host *mmc, struct mmc_request *mrq);
+static int rtkemmc_cmdq_alloc_tdl(struct cmdq_host *cq_host);
+static void rtkemmc_cmdq_post_req(struct mmc_host *host, int tag, int err);
+static void rtkemmc_cmdq_disable(struct mmc_host *mmc, bool soft);
+static int rtkemmc_cmdq_halt(struct mmc_host *mmc, bool halt);
+static void rtkemmc_cmdq_getrsp(struct mmc_host *host, struct mmc_request *mrq);
+
+/*user should maintain a software table for cmdq to make sure the previous command task is complete.
+  Slot 0~30 is for rw task, and this tag is assigned in block layer and they have already dealt with this issue,
+  Therefore, eMMC driver does not need to protect slot 0~30. It only needs to protect slot 31 dcmd*/
+volatile bool DCMD_complete=true;
+volatile bool DCMD_wait_38=false;
+volatile int DCMD_idx=0;
+
+static const struct mmc_cmdq_host_ops cmdq_host_ops = {
+	.enable = rtkemmc_cmdq_enable,
+	.disable = rtkemmc_cmdq_disable,
+	.request = rtkemmc_cmdq_request,
+	.post_req = rtkemmc_cmdq_post_req,
+	.halt = rtkemmc_cmdq_halt,
+	.getrsp = rtkemmc_cmdq_getrsp,
+};
+
+#define DRV_NAME "rtkemmc-cmdq-host"
+
+static void rtkemmc_cmdq_dumpregs(struct rtkemmc_host *emmc_port)
+{
+	struct mmc_host *mmc = emmc_port->mmc;
+
+	pr_err(DRV_NAME ": ========== REGISTER DUMP (%s)==========\n",
+		mmc_hostname(mmc));
+
+	pr_err(DRV_NAME ": Queing config: 0x%08x | Queue Ctrl:  0x%08x\n",
+		readl(emmc_port->emmc_membase + EMMC_CQCFG),
+		readl(emmc_port->emmc_membase + EMMC_CQCTL));
+	pr_err(DRV_NAME ": Int stat: 0x%08x      | Int enab:  0x%08x\n",
+		readl(emmc_port->emmc_membase + EMMC_CQIS),
+		readl(emmc_port->emmc_membase + EMMC_CQIS_STAT_EN));
+	pr_err(DRV_NAME ": Int sig: 0x%08x       | Int Coal:  0x%08x\n",
+		readl(emmc_port->emmc_membase + EMMC_CQIS_SIGNAL_EN),
+		readl(emmc_port->emmc_membase + EMMC_CQIC));
+	pr_err(DRV_NAME ": TDL base: 0x%08x\n", readl(emmc_port->emmc_membase + EMMC_CQTDLBA));
+	pr_err(DRV_NAME ": Doorbell: 0x%08x      | Comp Notif:  0x%08x\n",
+		readl(emmc_port->emmc_membase + EMMC_CQTDBR),
+		readl(emmc_port->emmc_membase + EMMC_CQTCN));
+	pr_err(DRV_NAME ": Dev queue: 0x%08x     | Dev Pend:  0x%08x\n",
+		readl(emmc_port->emmc_membase + EMMC_CQDQS),
+		readl(emmc_port->emmc_membase + EMMC_CQDPT));
+	pr_err(DRV_NAME ": Task clr: 0x%08x      | Send stat 1:  0x%08x\n",
+		readl(emmc_port->emmc_membase + EMMC_CQTCLR),
+		readl(emmc_port->emmc_membase + EMMC_CQSSC1));
+	pr_err(DRV_NAME ": Send stat 2: 0x%08x   | DCMD resp:  0x%08x\n",
+		readl(emmc_port->emmc_membase + EMMC_CQSSC2),
+		readl(emmc_port->emmc_membase + EMMC_CQCRDCT));
+	pr_err(DRV_NAME ": Resp err mask: 0x%08x | Task err:  0x%08x\n",
+		readl(emmc_port->emmc_membase + EMMC_CQRMEM),
+		readl(emmc_port->emmc_membase + EMMC_CQTERRI));
+	pr_err(DRV_NAME ": Resp idx 0x%08x       | Resp arg:  0x%08x\n",
+		readl(emmc_port->emmc_membase + EMMC_CQCRI),
+		readl(emmc_port->emmc_membase + EMMC_CQCRA));
+	pr_err(DRV_NAME ": Cmd idx 0x%08x\n",readw(emmc_port->emmc_membase+EMMC_CMD_R));
+	pr_err(DRV_NAME ": ===========================================\n");
+}
+
+static void rtkemmc_cmdq_getrsp(struct mmc_host *host, struct mmc_request *mrq)
+{
+	struct rtkemmc_host *emmc_port = mmc_priv(host);
+	mrq->cmd->resp[0] = readl(emmc_port->emmc_membase+EMMC_CQCRDCT);
+	//printk(KERN_ERR "%s: mrq->cmd->resp[0]=0x%x\n", __func__, mrq->cmd->resp[0]);
+}
+
+#ifdef RTKMMEC_DMA_DEBUG
+struct cmdq_node {
+	u8 read;
+	unsigned int blk_addr;
+	unsigned int blk_cnt;
+	u32 *desc;
+	int dma_nent;
+};
+
+struct cmdq_node cmdq_data[32];
+
+static void rtkemmc_cmdq_dump_dma_metadata(struct mmc_cmdq_req *cmdq_rq, u32 *desc, u8 read, int  dma_nents, int tag)
+{
+	cmdq_data[tag].read = read;
+	cmdq_data[tag].blk_addr = cmdq_rq->blk_addr;
+	cmdq_data[tag].blk_cnt = cmdq_rq->data.blocks;
+	cmdq_data[tag].desc = desc;
+	cmdq_data[tag].dma_nent = dma_nents;
+
+	printk(KERN_INFO "%s: tag=%d, read=%d, blk_addr=0x%x, blk_cnt=%d, desc_addr=0x%x, dma_nent=%d\n",
+		__func__, tag, cmdq_data[tag].read, cmdq_data[tag].blk_addr, cmdq_data[tag].blk_cnt, cmdq_data[tag].desc, cmdq_data[tag].dma_nent);
+}
+
+static void rtkemmc_cmdq_dma_debug(struct mmc_host *host, int tag)
+{
+	int idx=0;
+	struct scatterlist *sg;
+	int  dma_leng = 0;
+	volatile u32  dma_addr;
+	volatile u32 virt_addr;
+	volatile u32 base_addr;
+	volatile int idx2;
+	int i=0;
+	int retry_cnt=0;
+	struct page *ret_page;
+	struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(host);
+        struct mmc_request *mrq = cq_host->mrq_slot[tag];
+        struct mmc_data *data = mrq->data;
+
+	if(tag!=31) {
+		printk(KERN_INFO "%s: tag=%d, read=%d, blk_cnt=%d, blk_addr=0x%x, desc_virt_addr=0x%x, dma_nent=%d\n",
+			__func__, tag, cmdq_data[tag].read, cmdq_data[tag].blk_cnt, cmdq_data[tag].blk_addr, cmdq_data[tag].desc, cmdq_data[tag].dma_nent);
+
+		for_each_sg(data->sg, sg, cmdq_data[tag].dma_nent, i) {
+			dma_addr = sg_dma_address(sg);
+			dma_leng = sg_dma_len(sg);
+			base_addr = kmap_atomic(sg_page(sg));
+			virt_addr = base_addr + sg->offset;
+
+			printk(KERN_INFO "%s: nent%d, dma_addr=0x%x, dma_len=%d, virt_addr=0x%x, sg->offset=0x%x\n", __func__, i, dma_addr, dma_leng, virt_addr, sg->offset);
+
+#if 0
+			//dump scatterlist dma content
+			for(idx=0;idx<dma_leng;idx+=4) {
+				int idx2 = idx % 4096;  //page size is 4096
+				if(idx2==0 && idx!=0) {
+					kunmap_atomic(virt_addr-sg->offset);
+					ret_page = phys_to_page(dma_addr+idx);
+					virt_addr = kmap_atomic(ret_page) + sg->offset;
+				}
+				printk(KERN_INFO "%s phys_addr 0x%x, virt_addr 0x%x: 0x%x\n",__func__,  dma_addr+idx, virt_addr+idx2, rtkemmc_swap_endian(*(u32*)(virt_addr+idx2)));
+			}
+#else
+			if(rtkemmc_swap_endian(*(u32*)(virt_addr+8))==0x12345678) {       //assume that input test pattern is 12345678
+				for(idx=0; idx<dma_leng; idx+=4) {
+					idx2 = idx % 4096;  //page size is 4096
+					if( idx2==0 && idx!=0) {
+						kunmap_atomic(base_addr);		//free the old page
+						ret_page = phys_to_page((dma_addr+idx));
+						base_addr = kmap_atomic(ret_page);
+						virt_addr = base_addr + sg->offset;	//create another page
+					}
+					//dump the unexpected scatterlist dma data
+					if(rtkemmc_swap_endian(*(u32*)(virt_addr+(idx2)))!=0x12345678) {
+						printk(KERN_ERR "%s: DATA error detected !!!!!!!\n", __func__);
+						printk(KERN_ERR "%s: tag=%d, read=%d, blk_cnt=%d, blk_addr=0x%x, desc_addr=0x%x, dma_nent=%d\n",
+							__func__, tag, cmdq_data[tag].read, cmdq_data[tag].blk_cnt, cmdq_data[tag].blk_addr,
+							cmdq_data[tag].desc, cmdq_data[tag].dma_nent);
+						printk(KERN_ERR "%s: nent%d, dma_addr=0x%x, dma_len=%d, virt_addr=0x%x, sg->offset=0x%x\n",
+							__func__, i, dma_addr, dma_leng, virt_addr, sg->offset);
+						printk(KERN_ERR "%s virt_addr 0x%x: 0x%x\n", __func__, virt_addr+idx2-8 , rtkemmc_swap_endian(*(u32*)(virt_addr+idx2-8)));
+						printk(KERN_ERR "%s virt_addr 0x%x: 0x%x\n", __func__, virt_addr+idx2-4 , rtkemmc_swap_endian(*(u32*)(virt_addr+idx2-4)));
+						printk(KERN_ERR "%s virt_addr 0x%x: 0x%x\n", __func__, virt_addr+idx2   ,   rtkemmc_swap_endian(*(u32*)(virt_addr+idx2)));
+						printk(KERN_ERR "%s virt_addr 0x%x: 0x%x\n", __func__, virt_addr+idx2+4 , rtkemmc_swap_endian(*(u32*)(virt_addr+idx2+4)));
+						printk(KERN_ERR "%s virt_addr 0x%x: 0x%x\n", __func__, virt_addr+idx2+8 , rtkemmc_swap_endian(*(u32*)(virt_addr+idx2+8)));
+						printk(KERN_ERR "%s virt_addr 0x%x: 0x%x\n", __func__, virt_addr+idx2+12,rtkemmc_swap_endian(*(u32*)(virt_addr+idx2+12)));
+						rtkemmc_cmdq_halt(host, true);
+						break;
+					}
+                                }
+                        }
+#endif
+			kunmap_atomic(base_addr);
+		}
+	}
+}
+#endif
+
+static void rtkemmc_cmdq_post_req(struct mmc_host *host, int tag, int err)
+{
+	struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(host);
+	struct mmc_request *mrq = cq_host->mrq_slot[tag+cq_host->start_slot];
+	struct mmc_data *data = mrq->data;
+
+	if (data) {
+		data->error = err;
+		dma_unmap_sg(mmc_dev(host), data->sg, data->sg_len,
+			     (data->flags & MMC_DATA_READ) ?
+			     DMA_FROM_DEVICE : DMA_TO_DEVICE);
+#ifdef RTKMMEC_DMA_DEBUG
+		rtkemmc_cmdq_dma_debug(host, tag+cq_host->start_slot);
+#endif
+		if (err)
+			data->bytes_xfered = 0;
+		else
+			data->bytes_xfered = blk_rq_bytes(mrq->req);
+	}
+}
+
+int rtkemmc_cmdq_init(struct cmdq_host *cq_host, struct mmc_host *mmc, bool dma64)
+{
+	int err = 0;
+
+	cq_host = kzalloc(sizeof(*cq_host), GFP_KERNEL);
+	if (!cq_host) {
+		printk(KERN_ERR "Allocate cq_host memory failed!!!\n");
+		return -ENOMEM;
+	}
+
+	cq_host->dma64 = dma64;
+	cq_host->mmc = mmc;
+	cq_host->mmc->cmdq_private = cq_host;
+
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+	cq_host->start_slot = 1;	//slot 0 is reserved for pon usage
+#else
+	cq_host->start_slot = 0;
+#endif
+	cq_host->num_slots = NUM_SLOTS;
+	cq_host->dcmd_slot = DCMD_SLOT;
+
+	mmc->cmdq_ops = &cmdq_host_ops;
+
+	cq_host->mrq_slot = kzalloc(sizeof(cq_host->mrq_slot) *
+					cq_host->num_slots, GFP_KERNEL);
+	if (!cq_host->mrq_slot)
+		return -ENOMEM;
+
+	init_completion(&cq_host->halt_comp);
+	return err;
+}
+
+static int rtkemmc_cmdq_halt(struct mmc_host *mmc, bool halt)
+{
+	struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(mmc);
+	struct rtkemmc_host *emmc_port = mmc_priv(mmc);
+	u32 val = 0;
+
+	if (halt) {
+		rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_CQCTL) | EMMC_CQ_HALT, emmc_port->emmc_membase+EMMC_CQCTL);
+		val = wait_for_completion_timeout(&cq_host->halt_comp, msecs_to_jiffies(HALT_TIMEOUT_MS));
+		/* halt done: re-enable legacy interrupts */
+		rtkemmc_writel(~EMMC_CQ_ALL_STAT_EN, emmc_port->emmc_membase+EMMC_CQIS_STAT_EN); //disable all cqe status interrupt bit
+		rtkemmc_writel(~EMMC_CQ_ALL_SIGNAL_EN, emmc_port->emmc_membase+EMMC_CQIS_SIGNAL_EN);        //disable all cqe signal interrupt bit
+
+		val = val ? 0 : -ETIMEDOUT;
+	} else {
+		rtkemmc_writel(EMMC_CQ_ALL_STAT_EN, emmc_port->emmc_membase+EMMC_CQIS_STAT_EN); //enable all cqe status interrupt bit
+		rtkemmc_writel(EMMC_CQ_ALL_SIGNAL_EN, emmc_port->emmc_membase+EMMC_CQIS_SIGNAL_EN);        //enable all cqe signal interrupt bit
+		rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_CQCTL) & (~EMMC_CQ_HALT), emmc_port->emmc_membase+EMMC_CQCTL);
+	}
+
+	return val;
+}
+
+static int rtkemmc_cmdq_enable(struct mmc_host *mmc)
+{
+	int err = 0;
+	u32 cqcfg;
+	struct cmdq_host *cq_host = mmc_cmdq_private(mmc);
+	struct rtkemmc_host *emmc_port = mmc_priv(mmc);
+
+	if (!cq_host || !mmc->card || !mmc_card_cmdq(mmc->card)) {
+		printk(KERN_ERR "cq_host or mmc->card is null!!!\n");
+		err = -EINVAL;
+		goto out;
+	}
+
+	if (cq_host->enabled) {
+		printk(KERN_ERR "cq_host->enabled flag 1, cqe has been already enabled!!!\n");
+		goto out;
+	}
+
+	cqcfg = readl(emmc_port->emmc_membase+EMMC_CQCFG);
+	if (cqcfg & EMMC_CQ_EN) {
+		printk(KERN_ERR "%s: %s: cq_host is already enabled\n", mmc_hostname(mmc), __func__);
+		WARN_ON(1);
+		goto out;
+	}
+
+	if (!cq_host->desc_base || !cq_host->trans_desc_base) {
+		//create the descriptor table, EMMC_CQTDLBA register will be filled out the descriptor address
+		err = rtkemmc_cmdq_alloc_tdl(cq_host);
+		if (err)
+			goto out;
+	}
+
+	rtkemmc_writeb(EMMC_SW_RST_DAT, emmc_port->emmc_membase+EMMC_SW_RST_R);		//clear data path SW_RST_R.SW_RST_DAT = 1
+	rtkemmc_writel(cq_host->desc_dma_base, emmc_port->emmc_membase+EMMC_CQTDLBA);		//0x980121a0, Set Task Descriptor List Base Address Register (CQTDLBA)
+	rtkemmc_writew(0x200, emmc_port->emmc_membase+EMMC_BLOCKSIZE_R); //0x98012004,Set value corresponding to executed data byte length of one block to BLOCKSIZE_R
+	rtkemmc_writew(((1<<EMMC_MULTI_BLK_SEL)|EMMC_BLOCK_COUNT_ENABLE|EMMC_DMA_ENABLE),emmc_port->emmc_membase+EMMC_XFER_MODE_R);	//0x9801200c
+	rtkemmc_writeb((readb(emmc_port->emmc_membase + EMMC_HOST_CTRL1_R)&0xe7)|(EMMC_ADMA2_32<<EMMC_DMA_SEL),
+			emmc_port->emmc_membase+EMMC_HOST_CTRL1_R);		//Set DMA_SEL to ADMA2 only mode in the HOST_CTRL1_R
+	rtkemmc_writew(0, emmc_port->emmc_membase+EMMC_BLOCKCOUNT_R);
+	rtkemmc_writel(0, emmc_port->emmc_membase+EMMC_SDMASA_R);	//Set SDMASA_R (while using 32 bits) to 0
+	//Set CQIC register to enable interrupt coalescing and to configure its timeout and threshold parameters INTC_TOUT, INTC_TH, disable by default
+	rtkemmc_writel(0, emmc_port->emmc_membase+EMMC_CQIC);
+	rtkemmc_writel(0, emmc_port->emmc_membase+EMMC_CQIS);	//Set CQIS status interrupt register to 0
+	rtkemmc_writel(EMMC_CQ_ALL_STAT_EN, emmc_port->emmc_membase+EMMC_CQIS_STAT_EN);	//enable all cqe status interrupt bit
+	rtkemmc_writel(EMMC_CQ_ALL_SIGNAL_EN, emmc_port->emmc_membase+EMMC_CQIS_SIGNAL_EN);        //enable all cqe signal interrupt bit
+	rtkemmc_writel(0x1000, emmc_port->emmc_membase+EMMC_CQSSC1);	//Set CQSSC1 register to configure device queue status fetch polling time and block count.
+	rtkemmc_writel(0x1, emmc_port->emmc_membase+EMMC_CQSSC2);	//Set CQSSC2 to configure RCA
+	rtkemmc_writel((cqcfg|EMMC_CQ_EN|EMMC_DCMD_EN), emmc_port->emmc_membase+EMMC_CQCFG);    //0x98012188, Set CQCFG register to configure DCMD_EN, TASK_DESC_SIZE and CQ_EN
+
+	//cmdq interrupt mode
+	rtkemmc_hold_int_dec();
+	rtkemmc_en_cqe_int();
+
+	isb();
+	sync(emmc_port);
+
+	cq_host->enabled = true;
+
+out:
+	return err;
+}
+
+static void rtkemmc_cmdq_disable(struct mmc_host *mmc, bool soft)
+{
+	struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(mmc);
+	struct rtkemmc_host *emmc_port = mmc_priv(mmc);
+
+        if (soft)
+                rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_CQCFG) & ~(EMMC_CQ_EN), emmc_port->emmc_membase+EMMC_CQCFG);
+        cq_host->enabled = false;
+}
+
+static int cmdq_dma_map(struct mmc_host *host, struct mmc_request *mrq)
+{
+	int sg_count;
+	struct mmc_data *data = mrq->data;
+
+	if (!data) {
+		printk(KERN_ERR "%s: mmc_data = NULL!!!\n", __func__);
+		return -EINVAL;
+	}
+
+	sg_count = dma_map_sg(mmc_dev(host), data->sg,
+			      data->sg_len,
+			      (data->flags & MMC_DATA_WRITE) ?
+			      DMA_TO_DEVICE : DMA_FROM_DEVICE);
+	if (!sg_count) {
+		pr_err("%s: sg-len: %d\n", __func__, data->sg_len);
+		return -ENOMEM;
+	}
+
+	return sg_count;
+}
+
+static inline u32 *get_desc(struct cmdq_host *cq_host, u8 tag)
+{
+	return cq_host->desc_base + (tag * cq_host->slot_sz / 4);
+}
+
+static inline u32 *get_link_desc(struct cmdq_host *cq_host, u8 tag)
+{
+	u32 *desc = get_desc(cq_host, tag);
+
+	return desc + cq_host->task_desc_len/4;
+}
+
+static inline dma_addr_t get_trans_desc_dma(struct cmdq_host *cq_host, u8 tag)
+{
+	return cq_host->trans_desc_dma_base +
+		(cq_host->mmc->max_segs * tag *
+		 cq_host->trans_desc_len);
+}
+
+static inline u32 *get_trans_desc(struct cmdq_host *cq_host, u8 tag)
+
+{
+	return cq_host->trans_desc_base +
+		(cq_host->trans_desc_len * cq_host->mmc->max_segs * tag / 4);
+}
+
+/* set the trans link structure value*/
+static void setup_link_desc(struct cmdq_host *cq_host, u8 tag)
+{
+	u32 *link_temp;
+	dma_addr_t trans_temp;
+
+	link_temp = get_link_desc(cq_host, tag);
+	trans_temp = get_trans_desc_dma(cq_host, tag);
+
+	memset(link_temp, 0, cq_host->link_desc_len);
+
+	if (tag == DCMD_SLOT) {
+		link_temp[1] = rtkemmc_swap_endian(VALID(0) | ACT(0) | END(1));
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "%s: [DEBUG] link descriptor tag=%d, link[0]=0x%x, link[1]=0x%x\n", __func__, tag, link_temp[0], link_temp[1]);
+#endif
+		return;
+	}
+	//trans link [32:63] save the trans descriptor dma sddress
+	link_temp[0] = rtkemmc_swap_endian(trans_temp);
+	link_temp[1] = rtkemmc_swap_endian((VALID(1) | ACT(0x6) | END(0)));
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_INFO "%s: [DEBUG] link descriptor tag=%d, link[0]=0x%x, link[1]=0x%x\n", __func__, tag, link_temp[0], link_temp[1]);
+#endif
+}
+/**
+ * The allocated descriptor table for task, link & transfer descritors
+ * looks like:
+ * |----------|
+ * |task desc |  |->|----------|
+ * |----------|  |  |trans desc|
+ * |link desc-|->|  |----------|
+ * |----------|          .
+ *      .                .
+ *  no. of slots      max-segs
+ *      .           |----------|
+ * |----------|
+ * The idea here is to create the [task+trans] table and mark & point the
+ * link desc to the transfer desc table on a per slot basis.
+ */
+static int rtkemmc_cmdq_alloc_tdl(struct cmdq_host *cq_host)
+{
+	size_t desc_size;
+	size_t data_size;
+	int i = 0;
+	//in realtek, we only support 32 bit ADMA2
+	cq_host->task_desc_len = 8;
+	cq_host->trans_desc_len = 8;
+	cq_host->link_desc_len = 8;
+
+	/* total size of a slot: 1 task & 1 transfer (link) */
+	cq_host->slot_sz = cq_host->task_desc_len + cq_host->link_desc_len;
+	desc_size = cq_host->slot_sz * cq_host->num_slots;
+
+	//dcmd does not need data buffer
+	data_size = cq_host->trans_desc_len * cq_host->mmc->max_segs *
+			(cq_host->num_slots - 1);
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_INFO "%s: desc_size: %d data_sz: %d slot-sz: %d\n", __func__,
+                (int)desc_size, (int)data_size, cq_host->slot_sz);
+#endif
+	/*
+         * allocate a dma-mapped chunk of memory for the descriptors
+         * allocate a dma-mapped chunk of memory for link descriptors
+         * setup each link-desc memory offset per slot-number to
+         * the descriptor table.
+         */
+	cq_host->desc_base = dmam_alloc_coherent(mmc_dev(cq_host->mmc),
+                                                 desc_size,
+                                                 &cq_host->desc_dma_base,
+                                                 GFP_KERNEL);
+	cq_host->trans_desc_base = dmam_alloc_coherent(mmc_dev(cq_host->mmc),
+                                              data_size,
+                                              &cq_host->trans_desc_dma_base,
+                                              GFP_KERNEL);
+	if (!cq_host->desc_base || !cq_host->trans_desc_base)
+		return -ENOMEM;
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_INFO "desc-base: 0x%p trans-base: 0x%p\n desc_dma 0x%llx trans_dma: 0x%llx\n",
+		cq_host->desc_base, cq_host->trans_desc_base,
+		(unsigned long long)cq_host->desc_dma_base,
+		(unsigned long long) cq_host->trans_desc_dma_base);
+#endif
+	for (i=0 ; i < (cq_host->num_slots); i++)
+		setup_link_desc(cq_host, i);
+
+	return 0;
+}
+
+static void make_cmdq_dcmd_des(u32 *des_base, struct mmc_request *mrq)
+{
+	u8 resp_type;
+	u8 timing;
+	u32 tmp_val;
+
+	if (!(mrq->cmd->flags & MMC_RSP_PRESENT)) {
+		resp_type = 0x0;
+		timing = 0x1;
+	} else {
+		if (mrq->cmd->flags & (MMC_RSP_BUSY|MMC_RSP_SPI_BUSY)) {
+			resp_type = 0x3;
+			timing = 0x0;
+		} else {
+			resp_type = 0x2;
+			timing = 0x1;
+		}
+	}
+	/*task[63:32], command argument */
+	des_base[0] = rtkemmc_swap_endian(mrq->cmd->arg);
+	/*task[31:0], resp type [24:23], cmd_idx[21:16] */
+	tmp_val = (VALID(1) |
+		   END(1) |
+		   INT(1) |
+		   QBAR(1) |
+		   ACT(0x5) |
+		   CMD_INDEX(mrq->cmd->opcode) |
+		   CMD_TIMING(timing) | RESP_TYPE(resp_type));
+	des_base[1] = rtkemmc_swap_endian(tmp_val);
+	/* tran[63:32], all 0 */
+	des_base[2] = 0;
+	/* tran[31:0], end[1] =1  */
+	des_base[3] = rtkemmc_swap_endian(3);	//end and valid bit
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_INFO "%s: [DEBUG] DCMD TASK descriptor des_base[0]=0x%x, des_base[1]=0x%x, des_base[2]=0x%x, des_base[3]=0x%x\n",
+				__func__, des_base[0], des_base[1],des_base[2],des_base[3]);
+#endif
+}
+
+static void cmdq_set_tran_desc(u32 *desc,
+                                 dma_addr_t addr, int len, bool end)
+{
+	u32 tmp_val= (VALID(1) |
+                 END(end ? 1 : 0) |
+                 INT(0) |
+                 ACT(0x4) |
+                 DAT_LENGTH(len));
+
+	desc[0] = rtkemmc_swap_endian(addr);
+	desc[1] = rtkemmc_swap_endian(tmp_val);
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_INFO "%s: [DEBUG] trans descriptor desc[0]=0x%x, desc[1]=0x%x, end=%d, len=%d, dma_addr=0x%x\n", __func__, desc[0], desc[1], end, len, addr);
+#endif
+}
+
+static int make_cmdq_rw_des(u32 *des_base, struct mmc_request *mrq, struct mmc_host *mmc, int tag)
+{
+	struct mmc_cmdq_req *cmdq_rq = mrq->cmdq_req;
+	struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(mmc);
+	struct mmc_data *data = mrq->data;
+	struct rtkemmc_host *emmc_port;
+	emmc_port = mmc_priv(mmc);
+
+	unsigned int blk_cnt = cmdq_rq->data.blocks;	//total block
+	u32 blk_cnt2, remain_blk_cnt;
+	int blk_addr = cmdq_rq->blk_addr;
+	struct scatterlist *sg;
+	u8 read=1;
+	u32 *desc;
+	int  dma_nents = 0;
+	int  dma_leng = 0;
+	int  dma_addr;
+	int tmp_val;
+	bool end = false;
+	int i=0;
+	unsigned int b1, b2;
+	u32 *link_temp;
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_INFO "%s: blk_cnt=%d, blk_addr=%d\n", __func__, blk_cnt, blk_addr);
+#endif
+
+	if(mrq->cmdq_req->data.flags == MMC_DATA_READ) {
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "[DEBUG] %s: MMC_DATA_READ\n", __func__);
+#endif
+		read = 1;
+	}
+	else {
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "[DEBUG] %s: MMC_DATA_WRITE\n", __func__);
+#endif
+		read = 0;
+	}
+
+	dma_nents = cmdq_dma_map(mrq->host, mrq);
+
+	if (dma_nents < 0) {
+		pr_err("%s: %s: unable to map sg lists, %d\n",
+				mmc_hostname(mrq->host), __func__, dma_nents);
+		return -1;
+	}
+	//fill out the transfer descriptor
+	desc = get_trans_desc(cq_host, tag);
+	memset(desc, 0, cq_host->trans_desc_len * cq_host->mmc->max_segs);
+
+#ifdef RTKMMEC_DMA_DEBUG
+        rtkemmc_cmdq_dump_dma_metadata(cmdq_rq, desc, read, dma_nents, tag);
+#endif
+
+	for_each_sg(data->sg, sg, dma_nents, i) {
+		dma_addr = sg_dma_address(sg);
+		dma_leng = sg_dma_len(sg);
+		remain_blk_cnt  = dma_leng >> 9;;
+
+		while(remain_blk_cnt) {
+			if(remain_blk_cnt > EMMC_MAX_SCRIPT_BLK)
+				blk_cnt2 = EMMC_MAX_SCRIPT_BLK;
+			else
+				blk_cnt2 = remain_blk_cnt;
+
+			//boundary check
+			b1 = dma_addr / 0x8000000;		//this eMMC ip dma transfer has 128MB limitation
+			b2 = (dma_addr+blk_cnt2*512) / 0x8000000;
+			if(b1 != b2) {
+				blk_cnt2 = (b2*0x8000000-dma_addr) / 512;
+			}
+
+			if (((i+1) == dma_nents) && (remain_blk_cnt == blk_cnt2))
+				end = true;
+
+			cmdq_set_tran_desc(desc, dma_addr, (blk_cnt2<<9), end);
+
+			dma_addr = dma_addr+(blk_cnt2<<9);
+			remain_blk_cnt -= blk_cnt2;
+			desc += (cq_host->trans_desc_len/4);
+
+			isb();
+			sync(emmc_port);
+		}
+	}
+
+#ifdef RTKEMMC_DEBUG
+        printk(KERN_INFO "%s: req: 0x%p tag: %d calc_trans_des: 0x%p sg-cnt: %d\n",
+                __func__, mrq->req, tag, desc, dma_nents);
+#endif
+	//fill out the task descriptor
+	/*task[63:32], block address */
+	des_base[0] = rtkemmc_swap_endian(blk_addr);
+	/*task[31:0], block count[31:16], task parameter[15:6], attribute[5:0] */
+	tmp_val = VALID(1) |
+		  END(1) |
+		  INT(1) |
+		  ACT(0x5) |
+		  (read <<12) |
+		  BLK_COUNT(blk_cnt);
+	des_base[1] = rtkemmc_swap_endian(tmp_val);
+
+	isb();
+	sync(emmc_port);
+	wmb();
+	sync(emmc_port);
+	/* tran[63:32], setting des2; Physical address to DMA to/from */
+	//link descriptor part is set in setup_link_desc() function
+
+	link_temp = get_link_desc(cq_host, tag);
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_INFO "%s: [DEBUG] task and link descriptor  tag=%d, des_base[0]=0x%x, des_base[1]=0x%x, link[0]=0x%x, link[1]=0x%x\n",
+				__func__, tag, des_base[0], des_base[1], link_temp[0], link_temp[1]);
+#endif
+	return 1;
+}
+
+static void rtkemmc_cmdq_finish_data(struct mmc_host *mmc, unsigned int tag)
+{
+        struct mmc_request *mrq;
+        struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(mmc);
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_INFO "[DEBUG] %s, tag=%d\n",__func__, tag);
+#endif
+        mrq = cq_host->mrq_slot[tag];
+        mrq->done(mrq);
+}
+
+static int SD_Stream_cmdq_Cmd(struct mmc_host *mmc, struct mmc_request *mrq, u32 tag)
+{
+	int err = 0;
+	struct rtkemmc_host *emmc_port;
+	struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(mmc);
+
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_ERR "[DEBUG] %s, tag=%d\n", __func__, tag);
+#endif
+	emmc_port = mmc_priv(mmc);
+
+	while(DCMD_wait_38 == true) {
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "%s: cmd 35 is fired and need to wait until cmd 38 is finished...\n", __func__);
+#endif
+		usleep_range(10, 30);
+	}
+
+	if((readl(emmc_port->emmc_membase+EMMC_CQTDBR)&(1<<tag))==0){
+//		printk(KERN_ERR "queue status = 0x%x\n", readl(emmc_port->emmc_membase+EMMC_CQTDBR));
+		int ret = make_cmdq_rw_des((u32*)cq_host->desc_base+tag*0x4, mrq, mmc, tag);
+		if(ret < 0) {
+			printk(KERN_ERR "make_cmdq_rw_des failed....\n");
+			return ret;
+		}
+		cq_host->mrq_slot[tag] = mrq;
+		rtkemmc_writel(1<<tag, emmc_port->emmc_membase+EMMC_CQTDBR);
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_ERR "[DEBUG] cpuid=%d, rtkemmc write EMMC_CQTDBR bit %d, EMMC_CQTDBR=0x%x\n",
+			raw_smp_processor_id(), tag, readl(emmc_port->emmc_membase+EMMC_CQTDBR));
+#endif
+	}
+	else{
+		printk("read/write slot %d is occupied\n", tag);
+		err = RTK_FAIL;
+	}
+	return err;
+}
+
+static int SD_SendCMDGetRSP_cmdq_Cmd(struct mmc_host *mmc, struct mmc_request *mrq, u32 tag)
+{
+	int err = RTK_SUCC;
+	struct rtkemmc_host *emmc_port;
+	struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(mmc);
+	int i=0;
+
+	emmc_port = mmc_priv(mmc);
+
+	while((readl(emmc_port->emmc_membase+EMMC_CQTDBR)&(1<<DCMD_SLOT))!=0 || DCMD_complete==false) {
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "DCMD: wait previous dcmd complete, opcode=%d, arg=0x%x, wait %d times, DBR=0x%x\n",
+			mrq->cmd->opcode, mrq->cmd->arg, ++i, readl(emmc_port->emmc_membase+EMMC_CQTDBR));
+#endif
+		usleep_range(10, 30);
+		sync(emmc_port);
+	}
+	DCMD_complete = false;
+	DCMD_idx =  mrq->cmd->opcode;   //this statement to check cmd 35 36 38 is uninterruptable
+
+	if(DCMD_idx==MMC_ERASE_GROUP_START) {
+		DCMD_wait_38 = true;	//in cmdq mode, cmd 35,36,38 must be continuous and cannot be separated by other cmdq command
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+		//printk(KERN_INFO "DCMD: cmd is %d, occupy HW semaphore\n", DCMD_idx);
+		while(1) {
+			if(readl(emmc_port->emmc_membase+EMMC_HD_SEM)==1) break;
+			else {
+				printk(KERN_INFO "%s: Pon is occupying the semaphore, 0x98012030=0x%x, 0x98012032=0x%x\n",
+					__func__, emmc_port->normal_interrupt, emmc_port->error_interrupt);
+				usleep_range(10, 30);
+			}
+		}
+#endif
+	}
+
+	if((readl(emmc_port->emmc_membase+EMMC_CQTDBR)&(1<<DCMD_SLOT))==0){
+		make_cmdq_dcmd_des((u32*)cq_host->desc_base+DCMD_SLOT*4, mrq);
+		cq_host->mrq_slot[DCMD_SLOT] = mrq;
+		rtkemmc_writel(1<<DCMD_SLOT,emmc_port->emmc_membase+EMMC_CQTDBR);
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_ERR "[DEBUG] %s, DCMD: mrq->cmd->opcode=%d, mrq->cmd->arg=%d, tag=%d DBR=0x%x\n",
+			__func__, mrq->cmd->opcode, mrq->cmd->arg, tag, readl(emmc_port->emmc_membase+EMMC_CQTDBR));
+#endif
+	}
+	else{
+		printk(KERN_ERR "dcmd slot 31 is occupied\n");
+		err = RTK_FAIL;
+	}
+
+	return err;
+}
+
+static int rtkemmc_cmdq_request(struct mmc_host *mmc, struct mmc_request *mrq)
+{
+
+	int err=-1;
+	struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(mmc);
+	u32 tag = mrq->cmdq_req->tag + cq_host->start_slot;	//if we enable the pon, slot 0 is reserved for PON
+
+	if (!cq_host->enabled) {
+		pr_err("%s: CMDQ host not enabled yet !!!\n",
+			mmc_hostname(mmc));
+		err = -EINVAL;
+		goto out;
+	}
+
+	if (mrq->cmdq_req->cmdq_req_flags & DCMD) {
+		err = SD_SendCMDGetRSP_cmdq_Cmd(mmc, mrq, DCMD_SLOT);
+	}
+	else {
+		err = SD_Stream_cmdq_Cmd(mmc, mrq, tag);
+	}
+out:
+	return err;
+}
+#endif
+//-------------------------------------------------------------------------------------------------------------------------------
+
+static int rtkemmc_get_ro(struct mmc_host *mmc)
+{
+	return 0;
+}
+
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+void pon_initial(struct rtkemmc_host *emmc_port, u32 start_addr, u32 end_addr, u32 id, u32 cmdq)
+{
+	rtkemmc_writel(readl(emmc_port->crt_membase+0x68)|0x0c000000, emmc_port->crt_membase+0x68);     //release reset of spi2emmc
+	rtkemmc_writel((readl(emmc_port->mux_mis_membase + 0x4)& 0xfffc0001) | 0x0001B6DE, emmc_port->mux_mis_membase + 0x4); // pad mux, spi nand device
+	//rtkemmc_writel(start_addr, emmc_port->emmc_membase + 0x800); // block start address, 1b
+	//rtkemmc_writel(end_addr, emmc_port->emmc_membase + 0x804); // block end address
+	rtkemmc_write_swc(0x98012800, start_addr);
+	rtkemmc_write_swc(0x98012804, end_addr);
+
+	rtkemmc_writel(0x0a000005, emmc_port->emmc_membase + 0x808); // blcok count and dma length
+	rtkemmc_writel(id, emmc_port->emmc_membase + 0x810); // flash ID
+	rtkemmc_writel(0x4|0x8|cmdq, emmc_port->emmc_membase + 0x80c);                              // data invert +cmdq enable
+
+	if(readl(emmc_port->norst_membase)!=0x1234567) {
+		gpio_direction_output(emmc_port->emmc_pon_toggle_gpio, 0);
+		mdelay(1);
+		rtkemmc_writel(0x1234567, emmc_port->norst_membase);
+	}
+	gpio_direction_output(emmc_port->emmc_pon_toggle_gpio, 1);
+	gpio_direction_output(emmc_port->emmc_pon_gpio, 0);
+
+	printk(KERN_ERR "%s: 0x98007104=0x%x, pon_start_addr=0x%x, pon_end_addr=0x%x",
+		__func__, rtkemmc_read_swc(0x98007104), rtkemmc_read_swc(0x98012800), rtkemmc_read_swc(0x98012804));
+}
+#endif
+
+void rtkemmc_dqs_delay_tap(struct rtkemmc_host *emmc_port, u32 dqs_dly)
+{
+	//this is a workaround for hank hs400 mode and will be fixed in A01
+	u16 state=0;
+	unsigned long timeout;
+	bool expired = false;
+	int err=0;
+
+	rtkemmc_send_cmd6(emmc_port, 0x03b90301, &state, dqs_dly);
+	rtkemmc_writel(0x80|dqs_dly ,emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+	rtkemmc_send_cmd6(emmc_port, 0x03b91301, &state, dqs_dly);
+
+	timeout = jiffies + msecs_to_jiffies(3000) + 1;
+	do {
+		expired = time_after(jiffies, timeout);
+		err = rtkemmc_send_cmd13(emmc_port, &state);
+		if (expired &&
+			(R1_CURRENT_STATE(state) == R1_STATE_PRG)) {
+			printk(KERN_ERR "%s: Card stuck in programming state! %s\n",
+				mmc_hostname(emmc_port->mmc), __func__);
+			break;
+		}
+	}while(R1_CURRENT_STATE(state) == R1_STATE_PRG);
+}
+
+static int rtkemmc_prepare_hs400_tuning(struct mmc_host *host, struct mmc_ios *ios)
+{
+	struct rtkemmc_host *emmc_port;
+        emmc_port = mmc_priv(host);
+	printk(KERN_ERR "Prepare HS400 mode...\n");
+	rtkemmc_writel(0x88 ,emmc_port->emmc_membase + EMMC_DQS_CTRL1);	//in hank A00, this setting will not take effect
+
+	rtkemmc_writel(0x80|0x38, emmc_port->emmc_membase + EMMC_WCMD_CTRL);
+	rtkemmc_writel(0x1, emmc_port->emmc_membase + EMMC_CMD_CTRL_SET);
+
+	return 0;
+}
+
+static void set_cmd_info(struct mmc_card *card,struct mmc_command * cmd, struct sd_cmd_pkt * cmd_info,u32 opcode,u32 arg,u8 rsp_para)
+{
+	memset(cmd, 0, sizeof(struct mmc_command));
+	memset(cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	cmd->opcode         = opcode;
+	cmd->arg            = arg;
+	cmd_info->cmd       = cmd;
+	cmd_info->emmc_port    = mmc_priv(card->host);
+	cmd_info->rsp_len   = rsp_para;
+}
+
+#ifdef RTKEMMC_PHASE_TRACE
+void print_desc_content(struct rtkemmc_host *emmc_port)
+{
+	int i =0;
+	u32* des_base = gddr_descriptor ;
+
+	printk(KERN_ERR "%s: descriptor content:\n", __func__);
+	for(i=0; i<trace_desc_counter; i+=2) {
+		printk(KERN_ERR "des_base[%d]=0x%x, des_base[%d]=0x%x\n", i, des_base[i], i+1, des_base[i+1]);
+	}
+}
+#endif
+
+void print_reg_info(struct rtkemmc_host *emmc_port)
+{
+	printk(KERN_ERR "0x98012034 NORMAL INTERRUPT EN= 0x%x\n",readw(emmc_port->emmc_membase+EMMC_NORMAL_INT_STAT_EN_R));
+	printk(KERN_ERR "0x98012036 ERROR INTERRUPT EN= 0x%x\n",readw(emmc_port->emmc_membase+EMMC_ERROR_INT_STAT_EN_R));
+	printk(KERN_ERR "0x98012038 NORMAL INTERRUPT SIGNAL EN= 0x%x\n",readw(emmc_port->emmc_membase+EMMC_NORMAL_INT_SIGNAL_EN_R));
+	printk(KERN_ERR "0x9801203a ERROR INTERRUPT SIGNAL EN = 0x%x\n",readw(emmc_port->emmc_membase+EMMC_ERROR_INT_SIGNAL_EN_R));
+	printk(KERN_ERR "0x9801203e HOST CONTROL2 REG = 0x%x\n",readw(emmc_port->emmc_membase+EMMC_HOST_CTRL2_R));
+	printk(KERN_ERR "0x98012024 PRESENT STATE REG = 0x%x\n",readl(emmc_port->emmc_membase+EMMC_PSTATE_REG));
+	printk(KERN_ERR "0x98012028 HOST CONTROL1 REG= 0x%x\n",readb(emmc_port->emmc_membase+EMMC_HOST_CTRL1_R));
+	printk(KERN_ERR "0x9801200c TRANSFER MODE REG = 0x%x\n",readw(emmc_port->emmc_membase+EMMC_XFER_MODE_R));
+	printk(KERN_ERR "0x98012004 EMMC BLOCK SIZE = 0x%x\n",readw(emmc_port->emmc_membase+EMMC_BLOCKSIZE_R));
+	printk(KERN_ERR "0x98012006 EMMC BLOCK COUNT = 0x%08x\n", readw(emmc_port->emmc_membase+EMMC_BLOCKCOUNT_R));
+	printk(KERN_ERR "0x9801200e CMD_IDX = 0x%08x\n",readw(emmc_port->emmc_membase+EMMC_CMD_R));
+        printk(KERN_ERR "0x98012008 EMMC CMDARG = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_ARGUMENT_R));
+}
+
+void print_err_reg(u32 cmd_idx, u16 normal_interrupt, u16 error_interrupt)
+{
+	printk(KERN_ERR "=====================================================\n");
+	printk(KERN_ERR "g_bTuning=%d cmd_idx 0x%08x, op_code (%d)\n",g_bTuning, cmd_idx, CMD_IDX_MASK(cmd_idx));
+	printk(KERN_ERR "0x98012030 NORMAL INTERRUPT STAT = 0x%x\n", normal_interrupt);
+	printk(KERN_ERR "0x98012032 ERROR INTERRUPT STAT = 0x%x\n", error_interrupt);
+	if( error_interrupt & EMMC_VENDOR_ERR3 ) {           printk(KERN_ERR "bit 15: EMMC_VENDOR_ERR3\n");       }
+	if( error_interrupt & EMMC_VENDOR_ERR2 ) {           printk(KERN_ERR "bit 14: EMMC_VENDOR_ERR2\n");  }
+	if( error_interrupt & EMMC_VENDOR_ERR1 ) {       printk(KERN_ERR "bit 13: EMMC_VENDOR_ERR1\n");  }
+	if( error_interrupt & EMMC_BOOT_ACK_ERR ) {           printk(KERN_ERR "bit 12: EMMC_BOOT_ACK_ERR\n");       }
+	if( error_interrupt & EMMC_RESP_ERR ) {          printk(KERN_ERR "bit 11: EMMC_RESP_ERR\n");    }
+	if( error_interrupt & EMMC_TUNING_ERR ) {           printk(KERN_ERR "bit 10: EMMC_TUNING_ERR\n");     }
+	if( error_interrupt & EMMC_ADMA_ERR ) {      printk(KERN_ERR "bit  9: EMMC_ADMA_ERR\n"); }
+	if( error_interrupt & EMMC_AUTO_CMD_ERR ) {       printk(KERN_ERR "bit  8: EMMC_AUTO_CMD_ERR\n");  }
+	if( error_interrupt & EMMC_CUR_LMT_ERR ) {          printk(KERN_ERR "bit  7: EMMC_CUR_LMT_ERR\n");    }
+	if( error_interrupt & EMMC_DATA_END_BIT_ERR ) {          printk(KERN_ERR "bit  6: EMMC_DATA_END_BIT_ERR\n");        }
+	if( error_interrupt & EMMC_DATA_CRC_ERR ) {          printk(KERN_ERR "bit  5: EMMC_DATA_CRC_ERR\n");   }
+	if( error_interrupt & EMMC_DATA_TOUT_ERR ) {          printk(KERN_ERR "bit  4: EMMC_DATA_TOUT_ERR\n");  }
+	if( error_interrupt & EMMC_CMD_IDX_ERR ) {           printk(KERN_ERR "bit  3: EMMC_CMD_IDX_ERR\n");   }
+	if( error_interrupt & EMMC_CMD_END_BIT_ERR ) {            printk(KERN_ERR "bit  2: EMMC_CMD_END_BIT_ERR\n");  }
+	if( error_interrupt & EMMC_CMD_CRC_ERR ) {            printk(KERN_ERR "bit  1: EMMC_CMD_CRC_ERR\n");    }
+	if( error_interrupt & EMMC_CMD_TOUT_ERR ) {           printk(KERN_ERR "bit  0: EMMC_CMD_TOUT_ERR\n");   }
+	printk(KERN_ERR "=====================================================\n");
+}
+
+void print_ip_desc(struct rtkemmc_host *emmc_port)
+{ 
+	//unsigned int bytecnt = 0, desc_cnt = 0, i = 0;
+	//unsigned int paddr_base = emmc_port->desc_paddr;
+
+	printk(KERN_ERR "------------------------------>\n");
+	printk(KERN_ERR "EMMC IP_DESC0 = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_IP_DESC0));
+	printk(KERN_ERR "EMMC IP_DESC1 = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_IP_DESC1));
+	printk(KERN_ERR "EMMC IP_DESC2 = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_IP_DESC2));
+	printk(KERN_ERR "EMMC IP_DESC3 = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_IP_DESC3));
+
+	printk(KERN_ERR "0x98012054 EMMC_ADMA_ERR_STAT_R = 0x%08x\n", readl(emmc_port->emmc_membase+EMMC_ADMA_ERR_STAT_R));
+	printk(KERN_ERR "0x98012058 EMMC EMMC_ADMA_SA_LOW_R = 0x%08x\n------------------------------>\n", readl(emmc_port->emmc_membase+EMMC_ADMA_SA_LOW_R));
+#if 0
+	bytecnt = readl(emmc_port->emmc_membase+EMMC_BYTCNT);
+	desc_cnt = bytecnt / 4096;
+
+	for (i = 0 ; i < desc_cnt; i++){
+		printk(KERN_INFO "=============== %u-th set of descriptor==============\n", i);
+		printk(KERN_INFO "DESC0(0x%08x) = 0x%08x\n", paddr_base,  *(gddr_descriptor + 4*i));
+		printk(KERN_INFO"DESC1(0x%08x) = 0x%08x\n", paddr_base + 16*i + 4, *(gddr_descriptor + 4*i + 1));
+		printk(KERN_INFO "DESC2(0x%08x) = 0x%08x\n", paddr_base + 16*i + 8, *(gddr_descriptor + 4*i + 2));
+		printk(KERN_INFO "DESC3(0x%08x) = 0x%08x\n", paddr_base + 16*i + 12, *(gddr_descriptor + 4*i + 3));
+	}
+	printk(KERN_INFO "=====================================================\n");
+#endif
+}
+
+void mmc_host_reset(struct rtkemmc_host *emmc_port)
+{
+
+	MMCPRINTF("%s : \n", __func__);
+
+        rtkemmc_writeb(0x07, emmc_port->emmc_membase + EMMC_SW_RST_R);      //9801202f, Software Reset Register
+        isb();
+        sync(emmc_port);
+
+        rtkemmc_writeb(0x0e, emmc_port->emmc_membase + EMMC_TOUT_CTRL_R);      //9801202e, Timeout Control register
+        isb();
+        sync(emmc_port);
+
+        rtkemmc_writew(0x200, emmc_port->emmc_membase + EMMC_BLOCKSIZE_R);      //98012004, block size = 512Byte
+        isb();
+        sync(emmc_port);
+#if 0
+        writew(0xe0b, emmc_port->emmc_membase + 0x2c);      //9801202c, clock control
+        isb();
+        sync(emmc_port);
+#endif
+
+	rtkemmc_writew(0xfeff, emmc_port->emmc_membase+EMMC_NORMAL_INT_STAT_EN_R);    //98012034, enable all Normal Interrupt Status register
+        isb();
+        sync(emmc_port);
+
+        rtkemmc_writew(EMMC_ALL_ERR_STAT_EN, emmc_port->emmc_membase+EMMC_ERROR_INT_STAT_EN_R); //98012036, enable all error Interrupt Status register
+        isb();
+        sync(emmc_port);
+
+        rtkemmc_writew(0xfeff,emmc_port->emmc_membase+EMMC_NORMAL_INT_SIGNAL_EN_R); //98012038, enable all Normal SIGNAL Interrupt  register
+        isb();
+        sync(emmc_port);
+
+        rtkemmc_writew(EMMC_ALL_ERR_SIGNAL_EN,emmc_port->emmc_membase+EMMC_ERROR_INT_SIGNAL_EN_R);      //9801203a, enable all error SIGNAL Interrupt register
+        isb();
+        sync(emmc_port);
+
+	MMCPRINTF("%s : \n", __func__);
+}
+static void rtkemmc_shutdown(struct platform_device *pdev)
+{
+	//struct device *dev = &pdev->dev;
+
+	printk(KERN_ERR "[eMMC] Shutdown\n");
+	pm_runtime_force_suspend(&pdev->dev);
+}
+
+#ifdef CONFIG_PM
+static int rtkemmc_suspend(struct device *dev)
+{
+	int ret = 0;
+	struct rtkemmc_host *emmc_port=NULL;
+	struct mmc_host *mmc = NULL;
+	suspend = 1;
+	mmc = mmc_host_local;
+	emmc_port = mmc_priv(mmc);
+#if 1	//in hank A00 version
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x1, emmc_port->emmc_membase+EMMC_OTHER1);        //disable L4 gated
+	isb();
+	sync(emmc_port);
+#endif
+	if(RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		printk(KERN_ERR "[%s] Enter %s Idle mode\n",DRIVER_NAME, __func__);
+		//rtkemmc_backup_registers(emmc_port);
+	}else{
+		//For suspend mode
+		printk(KERN_ERR "[%s] Enter %s Suspend mode\n",DRIVER_NAME, __func__);
+	}
+
+	ret = pm_runtime_force_suspend(dev);
+	printk(KERN_ERR "[%s] Exit %s\n",DRIVER_NAME,__func__);
+	return ret;
+}
+
+static int rtkemmc_resume(struct device *dev)
+{
+	int ret = 0;
+	struct mmc_host *mmc = NULL;
+	struct rtkemmc_host *emmc_port=NULL;
+	struct mmc_host *host = NULL;
+
+	mmc = mmc_host_local;
+	emmc_port = mmc_priv(mmc);
+	if (!emmc_port)
+		BUG();
+    
+	host = emmc_port->mmc;
+	host->card->host = mmc;
+	g_bResuming=1;
+
+	if(RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		printk(KERN_ERR "[%s] Enter %s Idle mode\n",DRIVER_NAME, __func__);
+		//rtkemmc_restore_registers(emmc_port);
+	}else{
+		//For suspend mode
+		printk(KERN_ERR "[%s] Enter %s Suspend mode\n",DRIVER_NAME, __func__);
+	}
+
+	if (!ret)
+		ret = pm_runtime_force_resume(dev);
+
+	rtkemmc_set_pin_mux(emmc_port);
+	rtkemmc_chk_card_insert(emmc_port);
+	sync(emmc_port);
+
+	g_bResuming=0;
+	init_completion(emmc_port->int_waiting);
+
+#ifdef CONFIG_MMC_RTK_EMMC_PON  //we just write the fix value for fpga test, we will read the input from device tree after negotiate with android team later
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+	pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 1);
+#else
+	pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 0);      //currently, we disable command queue first, offset = 256x1024x1024/512/2048x512x5
+#endif
+#endif
+	printk(KERN_ERR "[%s] Exit %s\n",DRIVER_NAME,__func__);
+
+	return ret;
+}
+
+static const struct dev_pm_ops rtk_dev_pm_ops = {
+	SET_SYSTEM_SLEEP_PM_OPS(rtkemmc_suspend, rtkemmc_resume)
+};
+#endif
+#if 0
+static int check_card_status(struct rtkemmc_host *emmc_port)
+{
+	u32 status=0;
+	u8 state=0;
+
+	rtkemmc_send_status(emmc_port->mmc->card, &status, &state, 0, 1);
+#ifdef RTKEMMC_DEBUG
+	if((status&0x80000000)==0x80000000)
+		printk(KERN_INFO "ADDRESS OUT OF RANGE \n");
+	if((status&0x40000000)==0x40000000)
+		printk(KERN_INFO "ADDRESS MISALIGN \n");
+
+	if((status&0x20000000)==0x20000000)
+		printk(KERN_INFO "BLOCK LEN ERROR \n");
+
+	if((status&0x10000000)==0x10000000)
+		printk(KERN_INFO "ERASE SEQ ERROR \n");
+
+	if((status&0x08000000)==0x08000000)
+		printk(KERN_INFO "ERASE PARAM ERROR \n");
+
+	if((status&0x04000000)==0x04000000)
+		printk(KERN_INFO "WP VIOLATION \n");
+
+	if((status&0x02000000)==0x02000000)
+		printk(KERN_INFO "DEVICE IS LOCKED \n");
+
+	if((status&0x01000000)==0x01000000)
+		printk(KERN_INFO "LOCK/UNLOCK FAILED \n");
+
+	if((status&0x00800000)==0x00800000)
+		printk(KERN_INFO "COM CRC ERROR \n");
+
+	if((status&0x00400000)==0x00400000)
+		printk(KERN_INFO "ILLEGAL COMMAND \n");
+
+	if((status&0x00200000)==0x00200000)
+		printk(KERN_INFO "DEVICE ECC FAILED \n");
+
+	if((status&0x00100000)==0x00100000)
+		printk(KERN_INFO "CC ERROR \n");
+
+	if((status&0x00080000)==0x00080000)
+		printk(KERN_INFO "ERROR RELATED TO HOST COM \n");
+
+	if((status&0x00010000)==0x00010000)
+		printk(KERN_INFO "CID/CSD OVERWRITE ERROR \n");
+
+	if((status&0x00008000)==0x00008000)
+		printk(KERN_INFO "WP ERASE SKIP \n");
+
+	if((status&0x00002000)==0x00002000)
+		printk(KERN_INFO "ERASE RESET \n");
+
+	if((status&0x00000100)==0x00000000)
+		printk(KERN_INFO "NOT READY FOR DATA \n");
+
+	if((status&0x00000080)==0x00000080)
+		printk(KERN_INFO "SWTICH ERROR \n");
+
+	if((status&0x00000040)==0x00000040)
+		printk(KERN_INFO "EXCEPTION EVENT \n");
+
+	if((status&0x00000020)==0x00000020)
+		printk(KERN_INFO "APP CMD ENABLED \n");
+#endif
+	if(state == 4) {
+#ifdef RTKEMMC_DEBUG
+		printk("tran\n");
+#endif
+		return 0;
+	}
+	else if(state <=10) {
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "cur_state=%s\n",state_tlb[state]);
+#endif
+		return -1;
+	}
+	else {
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "cur_state=reserved\n");
+#endif
+                return -1;
+	}
+}
+#endif
+void error_handling(struct rtkemmc_host *emmc_port)
+{
+	if((readw(emmc_port->emmc_membase + EMMC_ERROR_INT_STAT_R)&
+		(EMMC_AUTO_CMD_ERR|EMMC_CMD_IDX_ERR|EMMC_CMD_END_BIT_ERR|EMMC_CMD_CRC_ERR|EMMC_CMD_TOUT_ERR)) !=0){ //check cmd line
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "CMD Line error occurs \n");
+#endif
+		rtkemmc_writeb(0x2, emmc_port->emmc_membase + EMMC_SW_RST_R); //Perform a software reset
+		wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + 0x2c), (0x2<<24), 0x0, __func__);	//wait for clear 0x2f bit 1
+	}
+	if((readw(emmc_port->emmc_membase + EMMC_ERROR_INT_STAT_R)&
+		(EMMC_ADMA_ERR|EMMC_DATA_END_BIT_ERR|EMMC_DATA_CRC_ERR|EMMC_DATA_TOUT_ERR)) !=0){ //check data line
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "DAT Line error occurs \n");
+#endif
+		rtkemmc_writeb(0x4, emmc_port->emmc_membase + EMMC_SW_RST_R); //Perform a software reset
+		wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + 0x2c), (0x4<<24), 0x0, __func__); //wait for clear 0x2f bit 2
+	}
+retry_L1:
+	rtkemmc_clr_int_sta();	//clear error status, and we have saved the previous error status via rtkemmc_get_int_sta()
+
+	//synchronous abort: stop host dma
+	rtkemmc_writeb(0x1, emmc_port->emmc_membase + EMMC_BGAP_CTRL_R); //stop emmc read/write transfer
+	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_NORMAL_INT_STAT_R), 0x2, 0x2, __func__); //wait for xfer complete
+	rtkemmc_writew(0x2, emmc_port->emmc_membase+EMMC_NORMAL_INT_STAT_R); //clear transfer complete status
+
+	isb();
+	sync(emmc_port);
+
+	//synchronous abort: issue abort coomand
+	rtkemmc_stop_transmission(emmc_port->mmc->card, 1);
+
+	rtkemmc_writeb(0x6, emmc_port->emmc_membase + EMMC_SW_RST_R); //Perform a software reset
+	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + 0x2c), (0x6<<24), 0x0, __func__); //wait for clear 0x2f bit 1 & 2
+	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_PSTATE_REG), 0x3, 0x0, __func__); //wait for cmd and data lines are not in use
+#if 0
+	if(emmc_port->error_interrupt & 0xf) {
+	}
+
+	if(emmc_port->error_interrupt & 0x10) {
+	}
+#endif
+	udelay(40);
+	if((readl(emmc_port->emmc_membase + EMMC_PSTATE_REG) &0xf00000)!=0xf00000 || (readl(emmc_port->emmc_membase + EMMC_PSTATE_REG) & 0xf0)!=0xf0) {
+		printk(KERN_INFO "%s: stop command check, EMMC_PSTATE_REG=0x%x\n", __func__, readl(emmc_port->emmc_membase + EMMC_PSTATE_REG));
+		goto retry_L1;
+	}
+}
+
+static int rtkemmc_send_cmd13(struct rtkemmc_host *emmc_port, u16 * state)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	int err=0;
+	memset(&cmd, 0, sizeof(struct mmc_command));
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	cmd.opcode         = MMC_SEND_STATUS;
+	cmd.arg            = (1<<RCA_SHIFTER);
+	cmd_info.cmd       = &cmd;
+	cmd_info.emmc_port = emmc_port;
+	cmd_info.rsp_len   = 6;
+
+	gPreventRetry=1;
+	err = SD_SendCMDGetRSP(&cmd_info,1);
+	gPreventRetry=0;
+
+	if(err ) {
+		mmcmsg3(KERN_WARNING "%s: MMC_SEND_STATUS fail\n",DRIVER_NAME);
+		error_handling(emmc_port);
+	}
+	else {
+		u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
+		*state = cur_state;
+		mmcmsg1("cur_state=%s\n",state_tlb[cur_state]);
+	}
+
+	return err;
+}
+
+int rtkemmc_send_cmd6(struct rtkemmc_host *emmc_port, u32 args, u16 * state, int phase)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	int err=0;
+	memset(&cmd, 0, sizeof(struct mmc_command));
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	cmd.opcode         = MMC_SWITCH;
+	cmd.arg            = args;
+	cmd.flags	   = MMC_CMD_AC|MMC_RSP_SPI_R1B | MMC_RSP_R1B;
+	cmd_info.cmd       = &cmd;
+	cmd_info.emmc_port = emmc_port;
+	cmd_info.rsp_len   = 6;
+
+	gPreventRetry=1;
+	err = SD_SendCMDGetRSP(&cmd_info,1);
+	gPreventRetry=0;
+
+	if(err ) {
+#ifdef RTKEMMC_DEBUG
+                printk(KERN_ERR "%s error: 0x98012030=0x%x, 0x98012032=0x%x, phase=%d\n",
+			__func__, emmc_port->normal_interrupt, emmc_port->error_interrupt, phase>>1);
+#endif
+#ifdef RTKEMMC_PHASE_TRACE
+                printk(KERN_ERR "%s: trace_TX_window=0x%x, trace_RX_window=0x%x, trace_TX1_window=0x%x, trace_dqs_counter=%d\n",
+			__func__, trace_TX_window, trace_RX_window, trace_TX1_window, trace_dqs_counter);
+#endif
+		error_handling(emmc_port);
+	}
+	else {
+		u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
+		*state = cur_state;
+		mmcmsg1("cur_state=%s\n",state_tlb[cur_state]);
+	}
+
+	return err;
+}
+
+int rtkemmc_send_cmd18(struct rtkemmc_host *emmc_port, int size, unsigned long addr)
+{
+	int ret_err=0;
+	struct sd_cmd_pkt cmd_info;
+	//struct mmc_host *host = emmc_port->mmc;
+	unsigned char *crd_tmp_buffer=NULL;
+	struct mmc_data *data=NULL;
+	struct mmc_command *cmd=NULL;
+	int i=0;
+	memset(&cmd_info, 0x00, sizeof(struct sd_cmd_pkt));
+
+	crd_tmp_buffer = (unsigned char *)emmc_port->dma_paddr;
+//	printk(KERN_ERR "crd_tmp_buffer=%p, emmc_port->dma_paddr=%p, gddr_dma_org=%p\n",crd_tmp_buffer,emmc_port->dma_paddr,gddr_dma_org);
+	if (crd_tmp_buffer == NULL) {
+		printk(KERN_ERR "%s,%s : crd_tmp_buffer == NULL\n",DRIVER_NAME,__func__);
+		return -5;
+	}
+
+	for(i=0;i<(size/4);i++) {
+		*(u32 *)(gddr_dma_org+(i*4)) = 0xdeadbeef;
+		//isb();
+		//sync(emmc_port);
+	}
+	wmb();
+
+	if (cmd_info.cmd == NULL) {
+		cmd  = (struct mmc_command*) kmalloc(sizeof(struct mmc_command),GFP_KERNEL);
+		memset(cmd, 0x00, sizeof(struct mmc_command));
+		cmd_info.cmd  = (struct mmc_command*) cmd;
+	}
+	cmd_info.emmc_port = emmc_port;
+	cmd_info.cmd->arg = addr;
+	cmd_info.cmd->opcode = MMC_READ_MULTIPLE_BLOCK;
+	cmd_info.rsp_len         = 6;
+	cmd_info.byte_count  = 0x200;
+	cmd_info.block_count = size/cmd_info.byte_count;
+	cmd_info.dma_buffer = crd_tmp_buffer;
+
+	if (cmd_info.cmd->data == NULL) {
+		data  = (struct mmc_data*) kmalloc(sizeof(struct mmc_data),GFP_KERNEL);
+		memset(data, 0x00, sizeof(struct mmc_data));
+		cmd_info.cmd->data = data;
+		data->flags = MMC_DATA_READ;
+	}
+	else
+		cmd_info.cmd->data->flags = MMC_DATA_READ;
+	MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x -------\n",
+		__FILE__, __func__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card);
+	ret_err = SD_Stream_Cmd(EMMC_AUTOREAD1, &cmd_info, 1);
+	if (ret_err) {
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_ERR "%s error: 0x98012030=0x%x, 0x98012032=0x%x, cmd->arg=0x%x, block count=%d\n",
+			__func__, emmc_port->normal_interrupt, emmc_port->error_interrupt, addr, cmd_info.block_count);
+#endif
+		error_handling(emmc_port);
+        }
+
+	if (cmd) {
+		kfree(cmd);
+		cmd_info.cmd = NULL;
+		cmd=NULL;
+	}
+	if (data) {
+		kfree(data);
+		//cmd_info.cmd->data = NULL;
+		data=NULL;
+	}
+	return ret_err;
+}
+
+int rtkemmc_send_cmd25(struct rtkemmc_host *emmc_port,int size, unsigned long addr, int data_src, int *hs400_data)
+{
+        int ret_err=0,i=0;
+        struct sd_cmd_pkt cmd_info;
+//        struct mmc_host *host = emmc_port->mmc;
+        char *crd_tmp_buffer=NULL;
+        struct mmc_data *data=NULL;
+        struct mmc_command *cmd=NULL;
+//      unsigned long flags=0;
+        memset(&cmd_info, 0x00, sizeof(struct sd_cmd_pkt));
+
+        crd_tmp_buffer = (unsigned char *) emmc_port->dma_paddr;
+//	printk(KERN_ERR "crd_tmp_buffer=%p, emmc_port->dma_paddr=%p, gddr_dma_org=%p\n",crd_tmp_buffer,emmc_port->dma_paddr,gddr_dma_org);
+        if (crd_tmp_buffer == NULL)
+        {
+                printk(KERN_ERR "%s,%s : crd_ext_csd == NULL\n",DRIVER_NAME,__func__);
+                return -5;
+        }
+
+	if(data_src==0) {
+		for(i=0;i<(size/4);i++)
+		{
+			if(GLOBAL==0x80000000) GLOBAL=0;
+			else GLOBAL++;
+			*(u32 *)(gddr_dma_org+(i*4)) = GLOBAL;
+		}
+	}
+	else if(data_src==1) {
+		for(i=0;i<(size/4);i++)
+                {
+                        if(GLOBAL==0x80000000) GLOBAL=0;
+                        else GLOBAL++;
+                        *(u32 *)(gddr_dma_org+(i*4)) = hs400_data[i];
+                }
+	}
+	else printk(KERN_ERR "data_source flag should be 0 or 1\n");
+
+        wmb();
+
+        if (cmd_info.cmd == NULL)
+        {
+                cmd  = (struct mmc_command*) kmalloc(sizeof(struct mmc_command),GFP_KERNEL);
+                memset(cmd, 0x00, sizeof(struct mmc_command));
+                cmd_info.cmd  = (struct mmc_command*) cmd;
+        }
+
+        cmd_info.emmc_port = emmc_port;
+        cmd_info.cmd->arg = addr;
+        cmd_info.cmd->opcode = MMC_WRITE_MULTIPLE_BLOCK;
+        cmd_info.rsp_len         = 6;
+        cmd_info.byte_count  = 0x200;
+        cmd_info.block_count = size/cmd_info.byte_count;
+        cmd_info.dma_buffer = crd_tmp_buffer;
+
+	if (cmd_info.cmd->data == NULL)
+        {
+                data  = (struct mmc_data*) kmalloc(sizeof(struct mmc_data),GFP_KERNEL);
+                memset(data, 0x00, sizeof(struct mmc_data));
+                cmd_info.cmd->data = data;
+                data->flags = MMC_DATA_WRITE;
+        }
+        else
+                cmd_info.cmd->data->flags = MMC_DATA_WRITE;
+
+        MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x , cmd=0x%08x, data=0x%08x-------\n",
+                __FILE__, __func__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card,cmd,data);
+        ret_err = SD_Stream_Cmd(EMMC_AUTOWRITE1, &cmd_info, 1);
+        if (ret_err)
+        {
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_ERR "%s error: 0x98012030=0x%x, 0x98012032=0x%x, cmd->arg=0x%x, block count=%d\n",
+			__func__, emmc_port->normal_interrupt, emmc_port->error_interrupt, addr, cmd_info.block_count);
+#endif
+		error_handling(emmc_port);
+        }
+        MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x , cmd=0x%08x, data=0x%08x-------\n",
+                __FILE__, __func__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card,cmd,data);
+#if 1
+        if (cmd)
+        {
+                cmd_info.cmd = NULL;
+                kfree(cmd);
+                cmd=NULL;
+        }
+        if (data)
+        {
+                //cmd_info.cmd->data = NULL;
+                kfree(data);
+                data=NULL;
+        }
+#endif
+        sync(emmc_port);
+        return ret_err;
+}
+
+int rtkemmc_send_cmd21(struct rtkemmc_host *emmc_port, int size, unsigned long addr)
+{
+        int ret_err=0;
+        struct sd_cmd_pkt cmd_info;
+        //struct mmc_host *host = emmc_port->mmc;
+        unsigned char *crd_tmp_buffer=NULL;
+        struct mmc_data *data=NULL;
+        struct mmc_command *cmd=NULL;
+        int i=0;
+        memset(&cmd_info, 0x00, sizeof(struct sd_cmd_pkt));
+
+        crd_tmp_buffer = (unsigned char *)emmc_port->dma_paddr;
+//      printk(KERN_ERR "crd_tmp_buffer=%p, emmc_port->dma_paddr=%p, gddr_dma_org=%p\n",crd_tmp_buffer,emmc_port->dma_paddr,gddr_dma_org);
+        if (crd_tmp_buffer == NULL) {
+                printk(KERN_ERR "%s,%s : crd_tmp_buffer == NULL\n",DRIVER_NAME,__func__);
+                return -5;
+        }
+
+        for(i=0;i<(size/4);i++) {
+                *(u32 *)(gddr_dma_org+(i*4)) = 0xdeadbeef;
+                //isb();
+                //sync(emmc_port);
+        }
+        wmb();
+
+        if (cmd_info.cmd == NULL) {
+                cmd  = (struct mmc_command*) kmalloc(sizeof(struct mmc_command),GFP_KERNEL);
+                memset(cmd, 0x00, sizeof(struct mmc_command));
+                cmd_info.cmd  = (struct mmc_command*) cmd;
+        }
+        cmd_info.emmc_port = emmc_port;
+        cmd_info.cmd->arg = addr;
+        cmd_info.cmd->opcode = MMC_SEND_TUNING_BLOCK_HS200;
+        cmd_info.rsp_len         = 6;
+        cmd_info.byte_count  = 0x80;
+        cmd_info.block_count = 1;
+        cmd_info.dma_buffer = crd_tmp_buffer;
+
+        if (cmd_info.cmd->data == NULL) {
+                data  = (struct mmc_data*) kmalloc(sizeof(struct mmc_data),GFP_KERNEL);
+                memset(data, 0x00, sizeof(struct mmc_data));
+                cmd_info.cmd->data = data;
+                data->flags = MMC_DATA_READ;
+        }
+        else
+                cmd_info.cmd->data->flags = MMC_DATA_READ;
+        MMCPRINTF("\n*** %s %s %d, cmdidx=0x%02x(%d), resp_type=0x%08x, host=0x%08x, card=0x%08x -------\n",
+                __FILE__, __func__, __LINE__, cmd_info.cmd->opcode, cmd_info.cmd->opcode, cmd_info.cmd->flags, host, host->card);
+        ret_err = SD_Stream_Cmd(EMMC_AUTOREAD1, &cmd_info, 1);
+	if (ret_err) {
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "Tuning rx cmd 21 err and call error handling\n");
+#endif
+		error_handling(emmc_port);
+        }
+
+        if (cmd) {
+                kfree(cmd);
+                cmd_info.cmd = NULL;
+                cmd=NULL;
+        }
+        if (data) {
+                kfree(data);
+                //cmd_info.cmd->data = NULL;
+                data=NULL;
+        }
+        return ret_err;
+}
+int search_best(u32 window, u32 range)
+{
+        int i, j, k, max;
+        int window_temp[32];
+        int window_start[32];
+        int window_end[32];
+        int window_max=0;
+        int window_best=0;
+        int parse_end=1;
+
+        for( i=0; i<0x20; i++ ) {
+                window_temp[i]=0;
+                window_start[i]=0;
+                window_end[i]=-1;
+        }
+        j=1;
+        i=0;
+        k=0;
+        max=0;
+	while((i<(range-1)) && (k<(range-1))){
+                parse_end=0;
+                for( i=window_end[j-1]+1; i<range; i++ ){
+                        if (((window>>i)&1)==1 ){
+                                window_start[j]=i;
+                                break;
+                        }
+                }
+                if( i==range){
+                        break;
+                }
+                for( k=window_start[j]+1; k<range; k++ ){
+                        if(((window>>k)&1)==0){
+                                window_end[j]=k-1;
+                                parse_end=1;
+                                break;
+                        }
+                }
+                if(parse_end==0){
+                        window_end[j]=range-1;
+                }
+                j++;
+        }
+        for(i=1; i<j; i++){
+                window_temp[i]= window_end[i]-window_start[i]+1;
+        }
+        if((((window)&1)==1)&&(((window>>(range-1))&1)==1))
+        {
+                window_temp[1]=window_temp[1]+window_temp[j-1];
+                window_start[1]=window_start[j-1];
+        }
+        for(i=1; i<j; i++){
+                if(window_temp[i]>window_max){
+                        window_max=window_temp[i];
+                        max=i;
+                }
+        }
+	if(window==0xffffffff){
+                window_best=0x10;
+        }
+        else if((window==0xffff)&&(range==0x10)){
+                window_best=0x8;
+                }
+        else if((((window&1)==1)&&(((window>>(range-1))&1)==1))&&(max==1)){
+		window_best=(((window_start[max]+window_end[max]+range)/2)&(range-1));
+        }
+        else {
+                window_best=((window_start[max]+window_end[max])/2)&0x1f;
+        }
+        return window_best;
+}
+
+void rtkemmc_hw_reset(void)
+{
+        struct mmc_host * mmc = mmc_host_local;
+        struct rtkemmc_host *emmc_port;
+        emmc_port = mmc_priv(mmc);
+        if(emmc_port!=NULL) {
+#if 0
+		//hank emmc hw rest code
+#endif
+        }
+
+}
+EXPORT_SYMBOL(rtkemmc_hw_reset);
+
+void rtkemmc_phase_tuning(struct rtkemmc_host *emmc_port,u32 mode,int flag, int stage)
+{
+	u32 TX_window=0;
+        u32 RX_window=0;
+	u32 TX1_window=0;
+	int TX_best=0x0;
+	int RX_best=0x0;
+	int TX1_best=0x0;
+        int i=0;
+        u32 range=0;
+        u16 state=0;
+
+        if (mode == MODE_HS400 || mode == MODE_DDR)
+                range = 0x10;
+        else
+		range = 0x20;
+
+	if(hs400_to_hs200_flag==true && (emmc_port->tx_tuning && emmc_port->rx_tuning)) {
+		hs400_to_hs200_flag=false;
+		phase(emmc_port, HS200_TX, HS200_RX);
+
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+		sync(emmc_port);
+                printk(KERN_ERR "down speed to hs200: restore tx & rx phase: TX=0x%x, RX=0x%x\n", HS200_TX, HS200_RX);
+		return;
+	}
+	if(suspend == 1 && (emmc_port->tx_tuning || emmc_port->rx_tuning) && emmc_port->mmc->card->cid.manfid != 0x13)
+	{
+		if(emmc_port->tx_tuning==0 && emmc_port->rx_tuning==1) {
+			phase(emmc_port, VP0_saved, suspend_VP1);
+		}
+		else if(emmc_port->tx_tuning==1 && emmc_port->rx_tuning==0)
+		{
+			phase(emmc_port, suspend_VP0, VP1_saved);
+		}
+		else {
+			phase(emmc_port, suspend_VP0, suspend_VP1);
+		}
+
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+		sync(emmc_port);
+		printk(KERN_ERR "suspend/resume: restore tx & rx phase: TX=0x%x, RX=0x%x\n", suspend_VP0, suspend_VP1);
+		if(mode == MODE_HS200) {
+			suspend = 0;
+		}
+		return;
+	}
+#ifdef PHASE_INHERITED
+	if (emmc_port->tx_tuning || emmc_port->rx_tuning){
+                phase(emmc_port, (emmc_port->tx_tuning)?0xff:VP0_saved, (emmc_port->rx_tuning)?0xff:VP1_saved);
+
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+                sync(emmc_port);
+        }
+        else {
+                phase(emmc_port, VP0_saved, VP1_saved); //VP0, VP1 phase
+
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+                sync(emmc_port);
+		printk(KERN_INFO "Inherit bootcode tuning phase: TX=0x%x, RX=0x%x\n", VP0_saved, VP1_saved);
+                return;
+        }
+#else
+	phase(emmc_port, 0, 0); //VP0, VP1 phase
+
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+	udelay(1);
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+	mdelay(5);
+        sync(emmc_port);
+#endif
+
+	if ((stage==TUNING_STAGE1 || stage==TUNING_STAGE_BOTH) && emmc_port->tx_tuning) {
+		if (mode == MODE_DDR && flag==1)
+			printk(KERN_ERR "Start DDR50 TX Tuning:\n");
+		else if (mode == MODE_HS400 && flag==1)
+			printk(KERN_ERR "Start HS400 TX Tuning: \n");
+		else if(flag==1)
+			printk(KERN_ERR "Start HS200 TX Tuning:\n");
+                for(i=0;i<range;i++) {
+#ifdef RTKEMMC_PHASE_TRACE
+			trace_index = i;
+#endif
+                        phase(emmc_port, i, 0xff);
+
+			writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+			udelay(1);
+			writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+#ifdef DEBUG
+                        printk("phase =0x%x \n", i);
+#endif
+
+                        if((rtkemmc_send_cmd13(emmc_port, &state)&0x01) != 0)
+                                TX_window= TX_window&(~(1<<i));
+                        else
+                                TX_window= TX_window|((1<<i));
+#ifdef RTKEMMC_PHASE_TRACE
+			trace_phase_bitmap = TX_window;
+#endif
+                }
+#ifdef RTKEMMC_PHASE_TRACE
+		trace_TX_window = TX_window;
+#endif
+		TX_best = search_best(TX_window, range);
+		if(flag==1)printk(KERN_ERR "TX_WINDOW = 0x%08x TX_best=0x%x\n", TX_window, TX_best);
+                phase(emmc_port, TX_best, 0xff);
+
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+		suspend_VP0 = TX_best;
+        }
+
+	if ((stage==TUNING_STAGE2 || stage==TUNING_STAGE_BOTH) && emmc_port->rx_tuning) {
+		if (mode == MODE_DDR && flag==1)
+			printk(KERN_ERR "Start DDR50 RX Tuning:\n");
+		else if (mode == MODE_HS400 && flag==1)
+			printk(KERN_ERR "Start HS400 RX Tuning:\n");
+		else if(flag==1)
+			printk(KERN_ERR "Start HS200 RX Tuning:\n ");
+
+                for(i=0;i<range;i++) {
+#ifdef RTKEMMC_PHASE_TRACE
+			trace_index = i;
+#endif
+                        phase(emmc_port, 0xff, i);
+
+			writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+			udelay(1);
+			writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+#ifdef DEBUG
+                        printk("phase =0x%x \n", i);
+#endif
+			if (mode == MODE_HS200) {
+				if(rtkemmc_send_cmd21(emmc_port, 128, 0x0) != 0)
+					RX_window= RX_window&(~(1<<i));
+				else
+					RX_window= RX_window|((1<<i));
+			}
+			else {
+				if(rtkemmc_send_cmd18(emmc_port, 1024, 0x100) != 0)
+                                        RX_window= RX_window&(~(1<<i));
+                                else
+                                        RX_window= RX_window|((1<<i));
+			}
+#ifdef RTKEMMC_PHASE_TRACE
+                        trace_phase_bitmap = RX_window;
+#endif
+                }
+#ifdef RTKEMMC_PHASE_TRACE
+		trace_RX_window = RX_window;
+#endif
+		RX_best = search_best(RX_window, range);
+                if(flag==1)printk(KERN_ERR "RX_WINDOW = 0x%08x RX_best=0x%x\n", RX_window,RX_best);
+                phase(emmc_port, 0xff, RX_best);
+
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+		suspend_VP1 = RX_best;
+        }
+
+	if ((stage==TUNING_STAGE2 || stage==TUNING_STAGE_BOTH) && (mode == MODE_HS400||mode == MODE_DDR) && emmc_port->tx_tuning) {
+		TX1_window= TX_window;
+		if(flag==1 && mode == MODE_HS400) printk(KERN_ERR "Start HS400 TX Tuning2:\n");
+		else if(flag==1 && mode == MODE_DDR) printk(KERN_ERR "Start DDR50 TX Tuning2:\n");
+
+                for(i=0;i<range;i++) {
+#ifdef RTKEMMC_PHASE_TRACE
+			trace_index = i;
+#endif
+			if(((TX_window>>i)&1)==1) {
+				phase(emmc_port, i, 0xff);
+
+				writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+				udelay(1);
+				writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+#ifdef DEBUG
+				printk("phase =0x%x \n", i);
+#endif
+				if(rtkemmc_send_cmd25(emmc_port, 1024,0xfe,0,NULL) != 0)
+					TX1_window= TX1_window&(~(1<<i));
+			}
+#ifdef RTKEMMC_PHASE_TRACE
+                        trace_phase_bitmap = TX1_window;
+#endif
+		}
+#ifdef RTKEMMC_PHASE_TRACE
+		trace_TX1_window = TX1_window;
+#endif
+		TX1_best = search_best(TX1_window, range);
+		if(flag==1)printk(KERN_ERR "TX1_WINDOW = 0x%08x TX1_best=0x%x\n", TX1_window,TX1_best);
+                phase(emmc_port, TX1_best, 0xff);
+
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+		suspend_VP0 = TX1_best;
+        }
+	sync(emmc_port);
+}
+
+static int mmc_Tuning_SDR50(struct rtkemmc_host *emmc_port)
+{
+	down_write(&cr_rw_sem);
+	if (!g_bResuming)
+		gCurrentBootMode = MODE_SDR;
+	MMCPRINTF("[LY]sdr gCurrentBootMode =%d\n",gCurrentBootMode);
+
+	rtkemmc_set_freq(emmc_port, 0x57, 0x1); //50Mhz
+
+	if (pddrive_nf_s0[0] != 0 )
+		rtkemmc_set_pad_driving(emmc_port, pddrive_nf_s0[1], pddrive_nf_s0[2], pddrive_nf_s0[3], pddrive_nf_s0[4]);
+	else {
+		rtkemmc_set_pad_driving(emmc_port,0x0, 0x0, 0x0, 0x0);
+	}
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+	if(get_rtd_chip_revision()!=RTD_CHIP_A00)	//workaround in hank A00, still has read/write timeout issue, only for pon testing
+		rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xfffffffe, emmc_port->emmc_membase+EMMC_OTHER1);        //enable L4 gated after SDR50 finished
+#else
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xfffffffe, emmc_port->emmc_membase+EMMC_OTHER1);        //enable L4 gated after SDR50 finished
+#endif
+
+	sync(emmc_port);
+	udelay(100);
+	up_write(&cr_rw_sem);
+
+	return 0;
+}
+
+static int mmc_Tuning_DDR50(struct rtkemmc_host *emmc_port, u32 mode)
+{
+	down_write(&cr_rw_sem);
+	if (!g_bResuming)
+		gCurrentBootMode = MODE_DDR;
+	MMCPRINTF("[LY]sdr gCurrentBootMode =%d\n",gCurrentBootMode);
+
+	rtkemmc_set_freq(emmc_port, 0x57, 0x1);  //50MMhz
+	sync(emmc_port);
+	udelay(100);
+	if (pddrive_nf_s1[0] != 0 )
+		rtkemmc_set_pad_driving(emmc_port, pddrive_nf_s1[1], pddrive_nf_s1[2], pddrive_nf_s1[3], pddrive_nf_s1[4]);
+        else {
+		rtkemmc_set_pad_driving(emmc_port,0x0, 0x0, 0x0, 0x0);
+	}
+	if(emmc_port->tx_tuning && emmc_port->rx_tuning) {	//device tree set kernel tuning for DDR50
+		rtkemmc_phase_tuning(emmc_port,mode,1, TUNING_STAGE_BOTH);
+		sync(emmc_port);
+		mdelay(10);
+	}
+	else {
+		phase(emmc_port, 0x8, 0x9);
+
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+	}
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+	if(get_rtd_chip_revision()!=RTD_CHIP_A00)  //workaround in hank A00, still has read/write timeout issue, only for pon testing
+		rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xfffffffe, emmc_port->emmc_membase+EMMC_OTHER1);        //enable L4 gated after SDR50 finished
+#else
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xfffffffe, emmc_port->emmc_membase+EMMC_OTHER1);        //enable L4 gated after DDR50 finished
+#endif
+	up_write(&cr_rw_sem);
+#ifdef CONFIG_MMC_RTK_EMMC_PON  //we just write the fix value for fpga test, we will read the input from device tree after negotiate with android team later
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+	pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 1);
+#else
+	pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 0);      //currently, we disable command queue first, offset = 256x1024x1024/512/2048x512x5
+#endif
+#endif
+	return 0;
+}
+
+static int mmc_Tuning_HS200(struct rtkemmc_host *emmc_port,u32 mode)
+{
+	MMCPRINTF("%s \n", __func__);
+
+	down_write(&cr_rw_sem);
+        if (!g_bResuming)
+                gCurrentBootMode = MODE_HS200;
+        MMCPRINTF("[LY]sdr gCurrentBootMode =%d\n",gCurrentBootMode);
+
+	rtkemmc_set_freq(emmc_port, 0xa6, 0x0); //200Mhz
+
+	if (pddrive_nf_s2[0] != 0 )
+		rtkemmc_set_pad_driving(emmc_port, pddrive_nf_s2[1], pddrive_nf_s2[2], pddrive_nf_s2[3], pddrive_nf_s2[4]);
+	else {
+		rtkemmc_set_pad_driving(emmc_port,0x4, 0x4, 0x4, 0x4);
+	}
+
+	rtkemmc_phase_tuning(emmc_port,mode,1, TUNING_STAGE_BOTH);
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+	if(get_rtd_chip_revision()!=RTD_CHIP_A00)   //workaround in hank A00, still has read/write timeout issue, only for pon testing
+		rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xfffffffe, emmc_port->emmc_membase+EMMC_OTHER1);        //enable L4 gated after SDR50 finished
+#else
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xfffffffe, emmc_port->emmc_membase+EMMC_OTHER1);        //enable L4 gated after HS200 finished
+#endif
+	sync(emmc_port);
+	mdelay(10);
+	up_write(&cr_rw_sem);
+
+	printk(KERN_ERR "HS200: final phase=0x%x\n", readl(emmc_port->crt_membase + SYS_PLL_EMMC1));
+
+#ifdef CONFIG_MMC_RTK_EMMC_PON  //we just write the fix value for fpga test, we will read the input from device tree after negotiate with android team later
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+	pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 1);
+#else
+	pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 0);      //currently, we disable command queue first, offset = 256x1024x1024/512/2048x512x5
+#endif
+#endif
+	return 0;
+}
+
+static int mmc_Tuning_HS400(struct rtkemmc_host *emmc_port,u32 mode)
+{
+        MMCPRINTF("%s \n", __func__);
+	down_write(&cr_rw_sem);
+	if (!g_bResuming)
+		gCurrentBootMode = MODE_HS400;
+	MMCPRINTF("[LY]sdr gCurrentBootMode =%d\n",gCurrentBootMode);
+
+	rtkemmc_set_freq(emmc_port, 0xa6, 0x0); //200Mhz
+
+	if (pddrive_nf_s3[0] != 0 )
+		rtkemmc_set_pad_driving(emmc_port, pddrive_nf_s3[1], pddrive_nf_s3[2], pddrive_nf_s3[3], pddrive_nf_s3[4]);
+	else {
+		rtkemmc_set_pad_driving(emmc_port,0x7, 0x2, 0x3, 0x0);
+	}
+	rtkemmc_phase_tuning(emmc_port,mode,1, TUNING_STAGE_BOTH);
+
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+	if(get_rtd_chip_revision()!=RTD_CHIP_A00)    //workaround in hank A00, still has read/write timeout issue, only for pon testing
+		rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xfffffffe, emmc_port->emmc_membase+EMMC_OTHER1);        //enable L4 gated after SDR50 finished
+#else
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xfffffffe, emmc_port->emmc_membase+EMMC_OTHER1);        //enable L4 gated after HS400 finished
+#endif
+	sync(emmc_port);
+	mdelay(10);
+	up_write(&cr_rw_sem);
+	printk(KERN_ERR "HS400 first stage: final phase=0x%x\n", readl(emmc_port->crt_membase + SYS_PLL_EMMC1));
+
+	return 0;
+}
+
+static int rtkemmc_execute_tuning(struct mmc_host *host, u32 opcode)
+{
+	struct rtkemmc_host *emmc_port;
+	struct sd_cmd_pkt cmd_info;
+	MMCPRINTF("%s \n", __func__);
+
+	emmc_port = mmc_priv(host);
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	cmd_info.emmc_port = emmc_port;
+
+	if (host->card){
+		printk(KERN_INFO "emmc card manid = 0x%08x\n", host->card->cid.manfid);
+		if (host->card->cid.manfid == 0x13) //micron manfid
+			emmc_port->rx_tuning = 1; //micron: force to turn on rx tuning
+	}
+	else
+		printk(KERN_ERR "host->card is null! \n");
+
+	MMCPRINTF("rtkemmc_execute_tuning : opcode=0x%08x, mode=0x%08x\n",opcode,host->mode);
+
+	g_bTuning = 1;
+	switch(host->mode)
+	{
+	case MODE_SDR:
+		mmc_Tuning_SDR50(emmc_port);
+		set_RTK_initial_flag(1);
+		break;
+	case MODE_DDR:
+		mmc_Tuning_DDR50(emmc_port, host->mode);
+		set_RTK_initial_flag(1);
+		break;
+	case MODE_HS200:
+		mmc_Tuning_HS200(emmc_port,host->mode);
+		set_RTK_initial_flag(1);
+		break;
+	case MODE_HS400:
+		mmc_Tuning_HS400(emmc_port,host->mode);		//hs400 still have dqs tuning, so set flag as 1 after dqs tuning
+		break;
+	default:
+		set_RTK_initial_flag(1);        //this flag is to use for sd card check for rcu stall
+		break;
+	}
+
+	g_bTuning = 0;
+	return 0;
+}
+
+static int rw_test_tuning(struct rtkemmc_host *emmc_port,unsigned long emmc_blk_addr)
+{
+	int i;
+	rtkemmc_send_cmd25(emmc_port,DMA_ALLOC_LENGTH, emmc_blk_addr,0, NULL);
+#ifdef SHA256
+	MCP_SHA256((unsigned char *)emmc_port->dma_paddr, (unsigned char *)compare3_phy_addr, DMA_ALLOC_LENGTH, NULL);
+#else
+	memcpy(compare1, gddr_dma_org, DMA_ALLOC_LENGTH);
+#endif
+	rtkemmc_send_cmd18(emmc_port,DMA_ALLOC_LENGTH, emmc_blk_addr);
+#ifdef SHA256
+	MCP_SHA256((unsigned char *)emmc_port->dma_paddr, (unsigned char *)compare4_phy_addr, DMA_ALLOC_LENGTH, NULL);
+#else
+	memcpy(compare2, gddr_dma_org, DMA_ALLOC_LENGTH);
+#endif
+
+#ifdef SHA256
+	for(i=0;i<32;i++) {
+		if(compare3[i]!=compare4[i]) {
+			return 1;
+		}
+	}
+#else
+	for(i=0;i<DMA_ALLOC_LENGTH;i++) {
+		if(compare1[i]!=compare2[i]) {
+			return 1;
+		}
+	}
+#endif
+	return 0;
+}
+
+static void rtkemmc_dqs_tuning(struct mmc_host *host)
+{
+	int i=0, j=0;
+	struct rtkemmc_host *emmc_port;
+	unsigned long dqs_tuning_blk_addr=0;
+	int retry_count=0;
+	unsigned int bitmap=0;
+	unsigned int max=0;
+
+	int hs400_data[128]={0};        //4 bytes header, 33aa, 4 bytes for TX, 4 bytes for RX, 4 bytes for dqs
+
+        emmc_port = mmc_priv(host);
+	mdelay(2);
+
+	if(suspend == 1)
+	{
+		if(emmc_port->dqs_tuning == 1) {
+			//in hank A00, dqs setting must be followed by cmd6
+			if(get_rtd_chip_revision()!=RTD_CHIP_A00)
+				writel(0x80 | suspend_dqs,emmc_port->emmc_membase + EMMC_DQS_CTRL1); //dqs dly tap
+			else
+				rtkemmc_dqs_delay_tap(emmc_port, suspend_dqs);
+		}
+		else {
+			if(get_rtd_chip_revision()!=RTD_CHIP_A00)
+				writel(0x80 | dqs_saved, emmc_port->emmc_membase + EMMC_DQS_CTRL1); //dqs dly tap
+			else
+				rtkemmc_dqs_delay_tap(emmc_port, dqs_saved);
+		}
+                printk(KERN_ERR "suspend/resume: restore DQS=0x%x\n", readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1));
+		suspend = 0;
+		return;
+	}
+
+	down_write(&cr_rw_sem);
+	g_bTuning = 1;
+
+#ifdef DQS_INHERITED
+        if(emmc_port->dqs_tuning == 0) {
+		if(get_rtd_chip_revision()!=RTD_CHIP_A00)
+			writel(0x80 | dqs_saved, emmc_port->emmc_membase + EMMC_DQS_CTRL1); //dqs dly tap
+		else
+			rtkemmc_dqs_delay_tap(emmc_port, dqs_saved);
+		printk(KERN_ERR "Inherit bootcode dqs: DQS=0x%x\n", readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1));
+		printk(KERN_ERR "read/write test for inherit hs400 parameter...\n");
+		if( rw_test_tuning(emmc_port, (emmc_port->emmc_tuning_addr/512))==0) {
+			printk(KERN_ERR "read/write test success for hs400 parameter!!!\n");
+			g_bTuning = 0;
+			up_write(&cr_rw_sem);
+#ifdef CONFIG_MMC_RTK_EMMC_PON  //we just write the fix value for fpga test, we will read the input from device tree after negotiate with android team later
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+			pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 1);
+#else
+			//currently, we disable command queue first, offset = 256x1024x1024/512/2048x512x5
+			pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 0);
+#endif
+#endif
+			set_RTK_initial_flag(1);
+			return;
+		}
+		else {
+			emmc_port->dqs_tuning=1;
+			emmc_port->tx_tuning = 1;
+			emmc_port->rx_tuning = 1;
+			printk(KERN_ERR "read/write test failed, retune the hs400...\n");
+		}
+	}
+#endif
+
+	dqs_tuning_blk_addr = emmc_port->emmc_tuning_addr / 512;	//convert from offset to block address
+	printk(KERN_ERR "emmc_port->emmc_tuning_addr = 0x%lx, dqs_tuning_blk_addr = 0x%lx\n", emmc_port->emmc_tuning_addr, dqs_tuning_blk_addr);
+
+#ifdef SHA256
+	printk(KERN_ERR "[EMMC] SHA256 is enabled for dqs comparison!!!\n");
+	if(!compare3)
+		compare3 = dma_alloc_coherent(emmc_port->dev, 32, &compare3_phy_addr ,GFP_KERNEL);
+	if(!compare4)
+		compare4 = dma_alloc_coherent(emmc_port->dev, 32, &compare4_phy_addr ,GFP_KERNEL);
+#endif
+retry:
+	bitmap=0;
+	max=0;
+	j=0;
+#ifdef RTKEMMC_PHASE_TRACE
+	trace_dqs_counter++;
+#endif
+	for(i=0; i<0x20; i++) {
+		if(j>=5)			//must be more than 5 continuous tap sample point
+			max = j;
+		if(j==0 && max!=0)	//find the max tap length
+			break;
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_ERR "DQS windows tuning: i=0x%x\n",i<<1);
+#endif
+		if(get_rtd_chip_revision()!=RTD_CHIP_A00) {
+			writel(0x80|(i<<1),emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+			rtkemmc_phase_tuning(emmc_port, MODE_HS400, 0, TUNING_STAGE_BOTH);
+		}
+		else {
+			rtkemmc_phase_tuning(emmc_port,MODE_HS400,0, TUNING_STAGE1);
+			rtkemmc_dqs_delay_tap(emmc_port, (i<<1));
+			rtkemmc_phase_tuning(emmc_port,MODE_HS400,0, TUNING_STAGE2);
+		}
+		if( rw_test_tuning(emmc_port, dqs_tuning_blk_addr)==0) {
+			j++;
+			bitmap |= (1<<i);
+		}
+		else {
+			j=0;
+		}
+	}
+	if(max==0) {
+		if((++retry_count)<5) {
+                        printk(KERN_ERR "DQS_RETRY: dqs tap bitmap= 0x%x, retry: %d\n", bitmap, retry_count);
+                        sync(emmc_port);
+                        mdelay(10);
+                        goto retry;
+                }
+                else {
+			printk(KERN_ERR RED_BOLD"Cannot find a proper dqs window..., dqs tap bitmap= 0x%x\n"RESET, bitmap);
+                }
+
+		if(get_rtd_chip_revision()!=RTD_CHIP_A00)
+			writel(0x88,emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+		else
+			rtkemmc_dqs_delay_tap(emmc_port, 0x8);
+	}
+	else {
+		if(get_rtd_chip_revision()!=RTD_CHIP_A00)
+			writel(0x80|(readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1)-((max/2)*2)),emmc_port->emmc_membase + EMMC_DQS_CTRL1); //dqs dly tap
+		else
+			rtkemmc_dqs_delay_tap(emmc_port, (readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1)-((max/2)*2)));
+		suspend_dqs = readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+#ifdef RTKEMMC_PHASE_TRACE
+		printk(KERN_ERR "trace_dqs_counter=%d\n", trace_dqs_counter);
+#endif
+		printk(KERN_ERR "max sample point=%d, bitmap=0x%x, DQS=0x%x\n", max, bitmap, readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1));
+		rtkemmc_phase_tuning(emmc_port,MODE_HS400,1, TUNING_STAGE_BOTH);
+		printk(KERN_ERR "HS400: final phase=0x%x\n", readl(emmc_port->crt_membase + SYS_PLL_EMMC1));
+	}
+
+#ifdef SHA256
+	if(compare3)
+		dma_free_coherent(emmc_port->dev, 32, compare3 , compare3_phy_addr);
+	if(compare4)
+		dma_free_coherent(emmc_port->dev, 32, compare4 , compare4_phy_addr);
+#endif
+        sync(emmc_port);
+        mdelay(10);
+	g_bTuning = 0;
+
+	printk(KERN_ERR "save eMMC hs400 parameter to emmc dqs_tuning_blk_addr 0x%lx\n", dqs_tuning_blk_addr+1024);
+	hs400_data[0] = 0x33aa;
+	hs400_data[1] = (readl(emmc_port->crt_membase + SYS_PLL_EMMC1) & 0x000000f8) >> 3;
+	hs400_data[2] = (readl(emmc_port->crt_membase + SYS_PLL_EMMC1) & 0x00001f00) >> 8;
+	hs400_data[3] = readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+	printk(KERN_ERR "hs400 parameter: hs400_TX[1]=0x%x, hs400_RX[2]=0x%x,hs400_dqs[3]=0x%x\n",hs400_data[1],hs400_data[2],hs400_data[3]);
+	rtkemmc_send_cmd25(emmc_port, 512, dqs_tuning_blk_addr+1024, 1, hs400_data);
+
+	up_write(&cr_rw_sem);
+
+#ifdef CONFIG_MMC_RTK_EMMC_PON  //we just write the fix value for fpga test, we will read the input from device tree after negotiate with android team later
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+	pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 1);
+#else
+	pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 0);      //currently, we disable command queue first, offset = 256x1024x1024/512/2048x512x5
+#endif
+#endif
+	set_RTK_initial_flag(1);        //this flag is to use for sd card check for rcu stall
+}
+
+static u32 rtkemmc_get_cmd_timeout(struct sd_cmd_pkt *cmd_info)
+{
+	struct rtkemmc_host *emmc_port = cmd_info->emmc_port;
+	u16 block_count = cmd_info->block_count;
+	u32 tmout = 0;
+
+	MMCPRINTF("\n");
+
+	if(cmd_info->cmd->data) {
+		tmout = msecs_to_jiffies(2000);
+
+		if(block_count>0x100)
+			tmout = tmout + 1000 * msecs_to_jiffies(block_count);
+    	}
+	else
+		tmout = msecs_to_jiffies(800);
+
+#ifdef CONFIG_ANDROID
+	tmout += msecs_to_jiffies(100);
+#endif
+
+	cmd_info->timeout = emmc_port->tmout = tmout;
+
+	return 0;
+}
+
+static void rtkemmc_set_ios(struct mmc_host *host, struct mmc_ios *ios)
+{
+	struct rtkemmc_host *emmc_port;
+	u32 cur_timing = 0;
+	unsigned long flags;
+
+	emmc_port = mmc_priv(host);
+
+	MMCPRINTF(KERN_INFO "ios->bus_mode = %u\n",ios->bus_mode);
+	MMCPRINTF(KERN_INFO "ios->clock = %u\n",ios->clock);
+	MMCPRINTF(KERN_INFO "ios->bus_width = %u\n",ios->bus_width);
+	MMCPRINTF(KERN_INFO "ios->timing = %u\n",ios->timing);
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+	if(ios->bus_mode==MMC_BUSMODE_PUSHPULL && ios->bus_width == MMC_BUS_WIDTH_1 && ios->timing == MMC_TIMING_LEGACY) {
+		return;
+	}
+#endif
+	cur_timing = ios->timing;
+	if (ios->clock == MMC_HIGH_52_MAX_DTR)
+		cur_timing = MMC_TIMING_MMC_HS;
+
+	MMCPRINTF(KERN_INFO "cur_timing = %u\n",cur_timing);
+
+	if (!g_bResuming) {
+		switch(cur_timing)
+		{
+		case MMC_TIMING_MMC_HS400:
+			rtkemmc_set_freq(emmc_port,0xa6, 0x0);  //200MHZ
+			isb();
+			sync(emmc_port);
+			rtkemmc_writeb((readb(emmc_port->emmc_membase + EMMC_HOST_CTRL1_R)&0xfb)|EMMC_HIGH_SPEED_EN,emmc_port->emmc_membase + EMMC_HOST_CTRL1_R);
+			rtkemmc_writew((readw(emmc_port->emmc_membase + EMMC_HOST_CTRL2_R)&0xfff8)|MODE_HS400 ,emmc_port->emmc_membase + EMMC_HOST_CTRL2_R); //enable HS400
+			isb();
+			sync(emmc_port);
+			break;
+		case MMC_TIMING_MMC_HS200:
+			rtkemmc_set_freq(emmc_port,0xa6, 0x0);  //200MHZ
+			rtkemmc_writew((readw(emmc_port->emmc_membase + EMMC_HOST_CTRL2_R)&0xfff8)|MODE_HS200 ,emmc_port->emmc_membase + EMMC_HOST_CTRL2_R);
+			break;
+		case MMC_TIMING_MMC_DDR52:
+			rtkemmc_set_freq(emmc_port,0x57, 0x1);  //50MB
+			rtkemmc_writeb((readb(emmc_port->emmc_membase + EMMC_HOST_CTRL1_R)&0xfb)|EMMC_HIGH_SPEED_EN,emmc_port->emmc_membase + EMMC_HOST_CTRL1_R);
+			rtkemmc_writew((readw(emmc_port->emmc_membase + EMMC_HOST_CTRL2_R)&0xfff8)|MODE_DDR ,emmc_port->emmc_membase + EMMC_HOST_CTRL2_R);
+			break;
+		case MMC_TIMING_MMC_HS:
+			rtkemmc_set_freq(emmc_port,0x57, 0x1);  //50Mhz
+			rtkemmc_writew((readw(emmc_port->emmc_membase + EMMC_HOST_CTRL2_R)&0xfff8)|MODE_SDR ,emmc_port->emmc_membase + EMMC_HOST_CTRL2_R);
+			break;
+		case MMC_TIMING_LEGACY:
+			rtkemmc_set_freq(emmc_port,0x46, 0x80);  //80Mhz
+			rtkemmc_writew((readw(emmc_port->emmc_membase + EMMC_HOST_CTRL2_R)&0xfff8)|MODE_LEGACY ,emmc_port->emmc_membase + EMMC_HOST_CTRL2_R);
+			break;
+		default:
+			printk(KERN_INFO "%s: cur_timing = %u \n", __FILE__, cur_timing);
+			break;
+		}
+	}
+
+	if (ios->bus_width == MMC_BUS_WIDTH_8){
+		spin_lock_irqsave(&emmc_port->lock,flags);
+		rtkemmc_writeb((readb(emmc_port->emmc_membase + EMMC_HOST_CTRL1_R)&0xdf)|EMMC_BUS_WIDTH_8,emmc_port->emmc_membase + EMMC_HOST_CTRL1_R);
+		sync(emmc_port);
+		spin_unlock_irqrestore(&emmc_port->lock, flags);
+
+		printk(KERN_INFO "%s: set bus width 8, host->mode=%d, 0x98012028=%08x\n", DRIVER_NAME, host->mode,readb(emmc_port->emmc_membase + EMMC_HOST_CTRL1_R));
+
+#ifdef CONFIG_MMC_RTK_EMMC_PON  //we just write the fix value for fpga test, we will read the input from device tree after negotiate with android team later
+		if(host->mode == MODE_SDR) {
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+			pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 1);
+#else
+			//currently, we disable command queue first, offset = 256x1024x1024/512/2048x512x5
+			pon_initial(emmc_port, emmc_port->pon_addr, emmc_port->pon_addr+((256*2*1024)/4*5),0x00232223, 0);
+#endif
+		}
+#endif
+		if (cur_timing == MMC_TIMING_MMC_HS400) {
+			rtkemmc_writel(0x88 ,emmc_port->emmc_membase + EMMC_DQS_CTRL1); //dqs dly tap, this setting will not take effect in hank A00
+
+			rtkemmc_writel(0x80|emmc_port->dqs_dly_tape, emmc_port->emmc_membase+EMMC_RDQ_CTRL0); //dqs dly tap
+			rtkemmc_writel(emmc_port->dqs_dly_tape, emmc_port->emmc_membase+EMMC_RDQ_CTRL1); //dqs dly tap
+			rtkemmc_writel(emmc_port->dqs_dly_tape, emmc_port->emmc_membase+EMMC_RDQ_CTRL2); //dqs dly tap
+			rtkemmc_writel(emmc_port->dqs_dly_tape, emmc_port->emmc_membase+EMMC_RDQ_CTRL3); //dqs dly tap
+			rtkemmc_writel(emmc_port->dqs_dly_tape, emmc_port->emmc_membase+EMMC_RDQ_CTRL4); //dqs dly tap
+			rtkemmc_writel(emmc_port->dqs_dly_tape, emmc_port->emmc_membase+EMMC_RDQ_CTRL5); //dqs dly tap
+			rtkemmc_writel(emmc_port->dqs_dly_tape, emmc_port->emmc_membase+EMMC_RDQ_CTRL6); //dqs dly tap
+			rtkemmc_writel(emmc_port->dqs_dly_tape, emmc_port->emmc_membase+EMMC_RDQ_CTRL7); //dqs dly tap
+			rtkemmc_writel(0xff00, emmc_port->emmc_membase+EMMC_DQ_CTRL_SET); //dqs dly tap
+
+			isb();
+			sync(emmc_port);
+		}
+	} else if (ios->bus_width == MMC_BUS_WIDTH_4){
+		spin_lock_irqsave(&emmc_port->lock,flags);
+                rtkemmc_writeb((readb(emmc_port->emmc_membase + EMMC_HOST_CTRL1_R)&0xdd)|EMMC_BUS_WIDTH_4,emmc_port->emmc_membase + EMMC_HOST_CTRL1_R);
+                sync(emmc_port);
+                spin_unlock_irqrestore(&emmc_port->lock, flags);
+
+                printk(KERN_INFO "%s: set bus width 4, 0x98012028=%08x\n", DRIVER_NAME, readb(emmc_port->emmc_membase + EMMC_HOST_CTRL1_R));
+	}
+}
+
+void rtkemmc_chk_param(u32 *pparam, u32 len, u8 *ptr)
+{
+	u32 value,i;
+	mmcrtk("\n");
+
+	*pparam = 0;
+	for(i=0;i<len;i++){
+		value = ptr[i] - '0';
+		// KWarning: checked ok by alexkh@realtek.com
+		if((value >= 0) && (value <=9))
+		{
+			*pparam+=value<<(4*(len-1-i));
+			continue;
+		}
+
+		value = ptr[i] - 'a';
+		// KWarning: checked ok by alexkh@realtek.com
+		if((value >= 0) && (value <=5))
+		{
+			value+=10;
+			*pparam+=value<<(4*(len-1-i));
+			continue;
+		}
+
+		value = ptr[i] - 'A';
+		// KWarning: checked ok by alexkh@realtek.com
+		if((value >= 0) && (value <=5))
+		{
+			value+=10;
+			*pparam+=value<<(4*(len-1-i));
+			continue;
+		}
+	}
+}
+
+void rtk_op_complete(struct rtkemmc_host *emmc_port)
+{
+	struct completion *waiting = emmc_port->int_waiting;
+	if (emmc_port->int_waiting) {
+		MMCPRINTF("int wait complete 1\n");
+		MMCPRINTF("rtk_op_complete: rtk wait complete addr = %08x\n", (unsigned int) emmc_port->int_waiting);
+		//emmc_port->int_waiting = NULL;
+		complete(waiting);
+		MMCPRINTF("int wait complete 2\n");
+	}
+	else
+		MMCPRINTF("int wait not complete\n");
+}
+
+static void rtkemmc_req_end_tasklet(unsigned long param)
+{
+	struct rtkemmc_host *emmc_port;
+	struct mmc_request* mrq;
+	unsigned long flags;
+	MMCPRINTF("%s \n", __func__);
+
+	emmc_port = (struct rtkemmc_host *)param;
+	spin_lock_irqsave(&emmc_port->lock,flags);
+
+	mrq = emmc_port->mrq;
+	emmc_port->mrq = NULL;
+
+	spin_unlock_irqrestore(&emmc_port->lock, flags);
+
+	mmc_request_done(emmc_port->mmc, mrq);
+}
+
+static int rtkemmc_free_dma_buf(struct rtkemmc_host *emmc_port)
+{
+	if (gddr_descriptor_org)
+		dma_free_coherent(emmc_port->dev, DESC_ALLOC_LENGTH, gddr_descriptor_org ,emmc_port->desc_paddr);
+	MMCPRINTF("free rtk desc buf \n");
+
+	if (gddr_dma_org)
+		dma_free_coherent(emmc_port->dev, DMA_ALLOC_LENGTH, gddr_dma_org ,emmc_port->dma_paddr);
+	MMCPRINTF("free rtk dma buf \n");
+
+	return 1;
+}
+
+static int rtkemmc_allocate_dma_buf(struct rtkemmc_host *emmc_port, struct mmc_command *cmd)
+{
+	if (!gddr_descriptor)
+		gddr_descriptor_org = gddr_descriptor = dma_alloc_coherent(emmc_port->dev, DESC_ALLOC_LENGTH, &emmc_port->desc_paddr ,GFP_KERNEL);
+
+	if (!gddr_dma)
+		gddr_dma_org = gddr_dma = dma_alloc_coherent(emmc_port->dev, DMA_ALLOC_LENGTH, &emmc_port->dma_paddr ,GFP_KERNEL);
+
+	if(!gddr_dma || !gddr_descriptor){
+		WARN_ON(1);
+		cmd->error = -ENOMEM;
+		return 0;
+	}
+
+	MMCPRINTF("allocate rtk dma buf : dma addr=0x%016llx, phy addr=0x%08x\n", gddr_dma, emmc_port->dma_paddr);
+	MMCPRINTF("allocate rtk desc buf : desc addr=0x%016llx, phy addr=0x%08x\n", gddr_descriptor, emmc_port->desc_paddr);
+	return 1;
+}
+
+static int wait_done_timeout(struct rtkemmc_host *emmc_port, volatile u32 *addr, u32 mask, u32 value, const char *string)
+{
+	int n = 0;
+	while(1)
+	{
+		if (((*addr) &mask) == value){
+			break;
+                }
+
+		if((readw(emmc_port->emmc_membase + EMMC_NORMAL_INT_STAT_R) & 0x8000)!=0) {
+			break;
+		}
+
+		if(n++ > 3000000) {
+			printk(KERN_ERR "Timeout!!! cmd_opcode=%d, cmd_arg=%x, addr=%p, mask=%x, value=%x, emmc_port->emmc_membase + EMMC_NORMAL_INT_STAT_R=%x \
+					emmc_port->emmc_membase + EMMC_ERROR_INT_STA_R=%x, pre_func=%s\n",
+				emmc_port->cmd_opcode, readl(emmc_port->emmc_membase+EMMC_ARGUMENT_R), addr, mask, value,
+				readw(emmc_port->emmc_membase + EMMC_NORMAL_INT_STAT_R), readw(emmc_port->emmc_membase + EMMC_ERROR_INT_STAT_R),string);
+#ifdef RTKEMMC_PHASE_TRACE
+			printk(KERN_ERR "trace_index=%d, trace_phase_bitmap=0x%x\n", trace_index, trace_phase_bitmap);
+			printk(KERN_ERR "%s: trace_TX_window=0x%x, trace_RX_window=0x%x, trace_TX1_window=0x%x\n",
+				__func__, trace_TX_window, trace_RX_window, trace_TX1_window);
+#endif
+			printk(KERN_ERR "RESP01=0x%x, RESP23=0x%x, RESP45=0x%x, RESP67=0x%x\n",
+				readl(emmc_port->emmc_membase + EMMC_RESP01_R),
+				readl(emmc_port->emmc_membase + EMMC_RESP23_R),
+				readl(emmc_port->emmc_membase + EMMC_RESP45_R),
+				readl(emmc_port->emmc_membase + EMMC_RESP67_R));
+			print_err_reg(emmc_port->cmd_opcode, emmc_port->normal_interrupt, emmc_port->error_interrupt);
+                        print_ip_desc(emmc_port);
+                        print_reg_info(emmc_port);
+#ifdef RTKEMMC_PHASE_TRACE
+			print_desc_content(emmc_port);
+#endif
+			asm volatile("wait_done_loop:");
+			asm volatile("b wait_done_loop");
+			return -1;
+		}
+		udelay(1);
+		sync(emmc_port);
+	}
+	return 0;
+}
+
+void rtkemmc_set_pad_driving(struct rtkemmc_host *emmc_port, u32 clk_drv, u32 cmd_drv, u32 data_drv, u32 ds_drv)
+{
+	rtkemmc_writel((readl(emmc_port->mux_mis_membase + EMMC_ISO_pfunc1)&0xff03f03f)|(clk_drv<<6)|(clk_drv<<9)|(cmd_drv<<18)|(cmd_drv<<21),
+				emmc_port->mux_mis_membase + EMMC_ISO_pfunc1);
+	rtkemmc_writel((readl(emmc_port->mux_mis_membase + EMMC_ISO_pfunc2)&0xff03f03f)|(data_drv<<6)|(data_drv<<9)|(data_drv<<18)|(data_drv<<21),
+				emmc_port->mux_mis_membase + EMMC_ISO_pfunc2);
+	rtkemmc_writel((readl(emmc_port->mux_mis_membase + EMMC_ISO_pfunc3)&0xff03f03f)|(data_drv<<6)|(data_drv<<9)|(data_drv<<18)|(data_drv<<21),
+				emmc_port->mux_mis_membase + EMMC_ISO_pfunc3);
+	rtkemmc_writel((readl(emmc_port->mux_mis_membase + EMMC_ISO_pfunc4)&0xff03f03f)|(data_drv<<6)|(data_drv<<9)|(data_drv<<18)|(data_drv<<21),
+				emmc_port->mux_mis_membase + EMMC_ISO_pfunc4);
+	rtkemmc_writel((readl(emmc_port->mux_mis_membase + EMMC_ISO_pfunc5)&0xff03f03f)|(data_drv<<6)|(data_drv<<9)|(data_drv<<18)|(data_drv<<21),
+                                emmc_port->mux_mis_membase + EMMC_ISO_pfunc5);
+	isb();
+	sync(emmc_port);
+}
+
+void phase(struct rtkemmc_host *emmc_port, u32 VP0, u32 VP1)
+{
+	//phase selection
+	if( (VP0==0xff) & (VP1==0xff)){
+#ifdef DEBUG
+		printk("phase VP0 and VP1 no change \n");
+#endif
+	}
+	else if( (VP0!=0xff) & (VP1==0xff)) {
+#ifdef DEBUG
+		printk("phase VP0=%x, VP1 no change \n", VP0);
+#endif
+		rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)|0x70000), emmc_port->emmc_membase + EMMC_CKGEN_CTL);    //change clock to 4MHz
+
+		sync(emmc_port);
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xfffffffd), emmc_port->crt_membase + SYS_PLL_EMMC1);     //reset pll
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xffffff07)|(VP0<<3), emmc_port->crt_membase + SYS_PLL_EMMC1);    //vp0 phase:0x0~0x1f
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)|0x2), emmc_port->crt_membase + SYS_PLL_EMMC1);    //release reset pll
+		sync(emmc_port);
+		udelay(200);
+
+		rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)&0xfff8ffff), emmc_port->emmc_membase + EMMC_CKGEN_CTL); //change clock to PLL
+		sync(emmc_port);
+	}
+	else if( (VP0==0xff) & (VP1!=0xff)){
+#ifdef DEBUG
+		printk("phase VP0 no change, VP1=%x \n", VP1);
+#endif
+		rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)|0x70000), emmc_port->emmc_membase + EMMC_CKGEN_CTL);    //change clock to 4MHz
+		sync(emmc_port);
+
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xfffffffd), emmc_port->crt_membase + SYS_PLL_EMMC1);     //reset pll
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xffffe0ff)|(VP1<<8), emmc_port->crt_membase + SYS_PLL_EMMC1);    //vp1 phase:0x0~0x1f
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)|0x2), emmc_port->crt_membase + SYS_PLL_EMMC1);    //release reset pll
+		sync(emmc_port);
+		udelay(200);
+
+		rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)&0xfff8ffff),emmc_port->emmc_membase + EMMC_CKGEN_CTL);  //change clock to PLL
+		sync(emmc_port);
+	}
+        else{
+#ifdef DEBUG
+		printk("phase VP0=%x, VP1=%x \n", VP0, VP1);
+#endif
+		rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)|0x70000),emmc_port->emmc_membase + EMMC_CKGEN_CTL);     //change clock to 4MHz
+		sync(emmc_port);
+
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xfffffffd),emmc_port->crt_membase + SYS_PLL_EMMC1);      //reset pll
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xffffff07)|(VP0<<3),emmc_port->crt_membase + SYS_PLL_EMMC1);     //vp0 phase:0x0~0x1f
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xffffe0ff)|(VP1<<8),emmc_port->crt_membase + SYS_PLL_EMMC1);     //vp1 phase:0x0~0x1f
+		rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)|0x2),emmc_port->crt_membase + SYS_PLL_EMMC1);     //release reset pll
+		sync(emmc_port);
+		udelay(200);
+
+                rtkemmc_writel((readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL)&0xfff8ffff),emmc_port->emmc_membase + EMMC_CKGEN_CTL);  //change clock to PLL
+		sync(emmc_port);
+	}
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_ERR "%s: phase adjust - EMMC_CKGEN_CTL=0x%08x, PLL_EMMC1=%08x, PLL_EMMC2=%08x, PLL_EMMC3=%08x, PLL_EMMC4=%08x\n",
+		DRIVER_NAME,
+		readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC1),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC2),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC3),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC4));
+#endif
+}
+
+static void rtkemmc_set_freq(struct rtkemmc_host *emmc_port, u32 freq, u32 div_ip)
+{
+	u32 tmp_val=0;
+	unsigned long flags;
+
+	spin_lock_irqsave(&emmc_port->lock,flags);
+#if 0
+	clk_disable_unprepare(clk_en_emmc_ip);
+	isb();
+	sync(emmc_port);
+#endif
+	tmp_val = (readl(emmc_port->crt_membase + SYS_PLL_EMMC4) & 0x06);
+	rtkemmc_writel(tmp_val, emmc_port->crt_membase + SYS_PLL_EMMC4);
+	isb();
+	sync(emmc_port);
+
+	tmp_val = (readl(emmc_port->crt_membase + SYS_PLL_EMMC3) & 0xffff)|(freq<<16);
+	rtkemmc_writel(tmp_val, emmc_port->crt_membase + SYS_PLL_EMMC3);
+	isb();
+	sync(emmc_port);
+
+	tmp_val = (readl(emmc_port->crt_membase + SYS_PLL_EMMC4) | 0x01);
+	rtkemmc_writel(tmp_val, emmc_port->crt_membase + SYS_PLL_EMMC4);
+	isb();
+	sync(emmc_port);
+#if 0
+	clk_prepare_enable(clk_en_emmc_ip);
+	isb();
+	sync(emmc_port);
+
+	udelay(100);
+        rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_CKGEN_CTL) & 0xffff, emmc_port->emmc_membase+EMMC_CKGEN_CTL); //change to PLL
+        sync(emmc_port);
+#endif
+
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_DUMMY_SYS)|0x00400000, emmc_port->emmc_membase+EMMC_DUMMY_SYS); //reset counter
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_CKGEN_CTL)&0xfffffe00, emmc_port->emmc_membase+EMMC_CKGEN_CTL); //reset to the initial value
+	if(div_ip!=0) {
+		rtkemmc_writel((readl(emmc_port->emmc_membase+EMMC_CKGEN_CTL)&0xfffff00|div_ip|0x100), emmc_port->emmc_membase+EMMC_CKGEN_CTL); //set the enable bit
+	}
+//	phase(emmc_port, 0, 0);
+
+	rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)&0xfffffffd), emmc_port->crt_membase + SYS_PLL_EMMC1);     //reset pll
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_DUMMY_SYS)&0xffbfffff, emmc_port->emmc_membase+EMMC_DUMMY_SYS); //reset counter
+	rtkemmc_writel((readl(emmc_port->crt_membase + SYS_PLL_EMMC1)|0x2), emmc_port->crt_membase + SYS_PLL_EMMC1);    //release reset pll
+
+	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_PLL_STATUS), 0x1, 0x1, __func__);
+
+	rtkemmc_writeb(0x06, emmc_port->emmc_membase + EMMC_SW_RST_R);      //9801202f, Software Reset Register
+
+        sync(emmc_port);
+	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + 0x2c), 0x6<<24, 0x0, __func__);
+
+	printk(KERN_ERR "%s: emmc_port->emmc_membase+EMMC_CKGEN_CTL = 0x%x\n",__func__, readl(emmc_port->emmc_membase+EMMC_CKGEN_CTL));
+	spin_unlock_irqrestore(&emmc_port->lock, flags);
+
+	printk(KERN_INFO "%s: div_ip=0x%08x, PLL_EMMC1=%08x, PLL_EMMC2=%08x, PLL_EMMC3=%08x, PLL_EMMC4=%08x\n",
+		DRIVER_NAME,
+		readl(emmc_port->emmc_membase + EMMC_CKGEN_CTL),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC1),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC2),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC3),
+		readl(emmc_port->crt_membase + SYS_PLL_EMMC4));
+}
+
+void rtkemmc_speed_up(void)
+{
+	struct mmc_host * mmc = mmc_host_local;
+	struct rtkemmc_host *emmc_port;
+
+	emmc_port = mmc_priv(mmc);
+
+	rtkemmc_set_freq(emmc_port,0x46, 0x4);  //80Mhz
+}
+EXPORT_SYMBOL(rtkemmc_speed_up);
+
+static u32 rtkemmc_chk_cmdcode(struct mmc_command* cmd)
+{
+	u32 cmdcode;
+
+	if(cmd->opcode <= 56){
+		cmdcode = (u32)rtk_sd_cmdcode[cmd->opcode];
+		WARN_ON(cmd->data == NULL);
+		if(cmd->data->flags & MMC_DATA_WRITE){
+			if(cmd->opcode == 42)
+				cmdcode = EMMC_NORMALWRITE;
+			else if(cmd->opcode == 56)
+				cmdcode = EMMC_AUTOWRITE2;
+		}
+	}else
+		cmdcode = EMMC_CMD_UNKNOW;
+
+	return cmdcode;
+}
+
+static void rtkemmc_set_pin_mux(struct rtkemmc_host *emmc_port)
+{
+	MMCPRINTF("rtkemmc_set_pin_mux \n");
+	
+	rtkemmc_writel((readl(emmc_port->mux_mis_membase)&0xff000000)|0x00aaaaaa, emmc_port->mux_mis_membase); //pad mux
+	sync(emmc_port);
+}
+
+static void rtkemmc_timeout_timer(unsigned long data)
+{
+	struct rtkemmc_host *emmc_port;
+	unsigned long flags;
+
+	emmc_port = (struct rtkemmc_host *)data;
+	printk(KERN_ERR "rtkemmc_timeout_timer fired ...\n");
+	MMCPRINTF("%s - int_wait=%08x\n", __func__, emmc_port->int_waiting);
+    
+	spin_lock_irqsave(&emmc_port->lock,flags);
+	//down_write(&cr_rw_sem);
+	if(emmc_port->int_waiting)
+	{
+		MMCPRINTF("1. get sd trans \n");
+		MMCPRINTF("========== C1 ==========\n");
+		printk(KERN_ERR "%s: before clear signal interrupt\n", __func__);
+		printk(KERN_ERR "%s: 0x98012038 NORMAL INTERRUPT SIGNAL EN= 0x%x\n", __func__, readw(emmc_port->emmc_membase+EMMC_NORMAL_INT_SIGNAL_EN_R));
+		printk(KERN_ERR "%s: 0x9801203a ERROR INTERRUPT SIGNAL EN = 0x%x\n", __func__, readw(emmc_port->emmc_membase+EMMC_ERROR_INT_SIGNAL_EN_R));
+		rtkemmc_hold_int_dec();
+                rtkemmc_get_int_sta(&emmc_port->normal_interrupt, &emmc_port->error_interrupt);
+		sync(emmc_port);
+		printk(KERN_ERR "%s: normal_interrupt =%08x, error_interrupt=0x%08x\n",
+				__func__, emmc_port->normal_interrupt, emmc_port->error_interrupt);
+	}
+	else {
+		WARN_ON(1);
+	}
+
+	if(emmc_port->int_waiting)
+		rtk_op_complete(emmc_port);
+
+	spin_unlock_irqrestore(&emmc_port->lock, flags);
+	//up_write(&cr_rw_sem);
+}
+
+static irqreturn_t rtkemmc_irq(int irq, void *dev)
+{
+	struct rtkemmc_host *emmc_port = dev;
+	int irq_handled = 0;
+
+	rtkemmc_get_int_sta(&emmc_port->normal_interrupt, &emmc_port->error_interrupt);
+	sync(emmc_port);
+
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+	struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(emmc_port->mmc);
+#endif
+
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+	if(cq_host->enabled==false)	//in command queue mode, this flag will be set after cmdq mode enable
+		rtkemmc_hold_int_dec();
+#else
+	rtkemmc_hold_int_dec();
+#endif
+
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+	if(cq_host->enabled) {	//if we run the cmdq mode currently
+		u32 status;
+		unsigned long comp_status;
+		unsigned long tag = 0;
+
+		status = readl(emmc_port->emmc_membase+ EMMC_CQIS);
+
+		if(emmc_port->normal_interrupt&0x8000) {
+                                printk(KERN_ERR "%s: cmdq error case: cpuid=%d, normal_interrupt =%08x, error_interrupt=0x%08x, EMMC_CQIS=0x%x, EMMC_CQTCN=0x%x\n",
+                                        __func__, raw_smp_processor_id(), emmc_port->normal_interrupt, emmc_port->error_interrupt, status, readl(emmc_port->emmc_membase+EMMC_CQTCN));
+                                rtkemmc_cmdq_dumpregs(emmc_port);
+                }
+
+		if (status & EMMC_CQIS_TCC) {
+			/* read QCTCN and complete the request */
+			comp_status = readl(emmc_port->emmc_membase+EMMC_CQTCN);
+#ifdef RTKEMMC_DEBUG
+			printk(KERN_ERR "%s_cmdq: cpuid=%d, normal_interrupt =%08x, error_interrupt=0x%08x, EMMC_CQIS=0x%x, EMMC_CQTCN=0x%x\n",
+				__func__, raw_smp_processor_id(), emmc_port->normal_interrupt, emmc_port->error_interrupt, status, comp_status);
+#endif
+			if (!comp_status)
+				goto out;
+
+			for_each_set_bit(tag, &comp_status, cq_host->num_slots) {
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+				if(tag!=0) {
+#endif
+#ifdef RTKEMMC_DEBUG
+					/* complete the corresponding mrq */
+					printk(KERN_ERR "%s_cmdq: cpuid=%d, completing tag -> %lu\n", __func__, raw_smp_processor_id(), tag);
+#endif
+
+					rtkemmc_cmdq_finish_data(emmc_port->mmc, tag);
+
+                                        if(tag==31 && DCMD_idx==MMC_ERASE) {
+						DCMD_wait_38 = false;
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+                                                //printk(KERN_INFO "DCMD cmd is %d, release the HW semaphore\n", DCMD_idx);
+						rtkemmc_writel(0x0, emmc_port->emmc_membase+EMMC_HD_SEM);
+#endif
+                                        }
+					if(tag==31) DCMD_complete = true;
+#ifdef CONFIG_MMC_RTK_EMMC_PON
+				}
+#endif
+			}
+			rtkemmc_writel(comp_status, emmc_port->emmc_membase+EMMC_CQTCN);
+			rtkemmc_writel(status, emmc_port->emmc_membase+ EMMC_CQIS);
+			rtkemmc_clr_int_sta();	//clear 0x2030 status
+		}
+
+		if (status & EMMC_CQIS_RED) {
+			/* task response has an error */
+			printk(KERN_ERR "%s: RED error %d !!!\n", mmc_hostname(emmc_port->mmc), status);
+			rtkemmc_writel(status, emmc_port->emmc_membase+ EMMC_CQIS);
+			rtkemmc_clr_int_sta();  //clear 0x2030 status
+			rtkemmc_cmdq_dumpregs(emmc_port);
+		}
+
+		if (status & EMMC_CQIS_HAC) {
+#ifdef RTKEMMC_DEBUG
+			printk(KERN_ERR "%s: halt irq case\n", __func__);
+			printk(KERN_ERR "%s_cmdq: cpuid=%d, normal_interrupt =%08x, error_interrupt=0x%08x, EMMC_CQIS=0x%x\n",
+                                __func__, raw_smp_processor_id(), emmc_port->normal_interrupt, emmc_port->error_interrupt, status);
+#endif
+			/* halt is completed, wakeup waiting thread */
+			rtkemmc_writel(status, emmc_port->emmc_membase+ EMMC_CQIS);
+			rtkemmc_clr_int_sta();  //clear 0x2030 status
+			complete(&cq_host->halt_comp);
+		}
+
+out:
+		return IRQ_HANDLED;
+	}
+#endif
+
+#ifdef RTKEMMC_DEBUG
+	printk(KERN_ERR "%s_legacy: cpuid=%d, cmd_idx=%d, normal_interrupt =%08x, error_interrupt=0x%08x\n",
+			__func__, raw_smp_processor_id(), emmc_port->cmd_opcode, emmc_port->normal_interrupt, emmc_port->error_interrupt);
+#endif
+
+	if(emmc_port->int_waiting) {
+		MMCPRINTF("int wait clear 1\n");
+		del_timer(&emmc_port->timer);
+		if (g_bResuming) //avoid to emit complete in rtkemmc_resume
+			return IRQ_HANDLED;
+
+		rtk_op_complete(emmc_port);
+		MMCPRINTF("int wait clear 2\n");
+	}else{
+		MMCPRINTF("No int_waiting!!!\n");
+	}
+
+	irq_handled = 1;
+	sync(emmc_port);
+
+	if(irq_handled)
+		return IRQ_HANDLED;
+	else
+		return IRQ_NONE;
+}
+
+static void rtkemmc_chk_card_insert(struct rtkemmc_host *emmc_port)
+{
+	struct mmc_host *host=emmc_port->mmc;
+	unsigned long flags;
+
+	MMCPRINTF("%s : \n", __func__);
+
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_DQS_CTRL1);    //98012498, this setting will not take effect in hank A00
+
+#ifdef PHASE_INHERITED
+        if (VP0_saved == 0xFF && VP1_saved == 0xFF){
+                HS200_TX = VP0_saved = (readl(emmc_port->crt_membase + SYS_PLL_EMMC1) & 0x000000f8) >> 3;
+                HS200_RX = VP1_saved = (readl(emmc_port->crt_membase + SYS_PLL_EMMC1) & 0x00001f00) >> 8;
+        }
+
+#endif
+	if(emmc_port->tx_user_defined) {        //if we set user defined tx and rx value, then we won't use the bootcode reference value, always the first priority
+                HS200_TX = VP0_saved = emmc_port->tx_reference_phase;
+        }
+        if(emmc_port->rx_user_defined) {
+                HS200_RX = VP1_saved = emmc_port->rx_reference_phase;
+        }
+
+#ifdef DQS_INHERITED
+	if (dqs_saved == 0xff)
+		dqs_saved = readl(emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+#endif
+	rtkemmc_writel(3, emmc_port->crt_membase + SYS_PLL_EMMC1);      //980001f0
+
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+	udelay(1);
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writeb(0x07, emmc_port->emmc_membase + EMMC_SW_RST_R);      //9801202f, Software Reset Register
+	isb();
+	sync(emmc_port);
+	
+	rtkemmc_writeb(0x0e, emmc_port->emmc_membase + EMMC_TOUT_CTRL_R);      //9801202e, Timeout Control register 
+        isb();
+        sync(emmc_port);
+
+	rtkemmc_writew(0x200, emmc_port->emmc_membase + EMMC_BLOCKSIZE_R);      //98012004, block size = 512Byte
+        isb();
+        sync(emmc_port);
+
+	rtkemmc_writew(0x1008 ,emmc_port->emmc_membase + EMMC_HOST_CTRL2_R);
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writew(0xfeff, emmc_port->emmc_membase+EMMC_NORMAL_INT_STAT_EN_R);	//98012034, enable all Normal Interrupt Status register
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writew(EMMC_ALL_ERR_STAT_EN, emmc_port->emmc_membase+EMMC_ERROR_INT_STAT_EN_R);	//98012036, enable all error Interrupt Status register
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writew(0xfeff,emmc_port->emmc_membase+EMMC_NORMAL_INT_SIGNAL_EN_R);	//98012038, enable all Normal SIGNAL Interrupt  register
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writew(EMMC_ALL_ERR_SIGNAL_EN,emmc_port->emmc_membase+EMMC_ERROR_INT_SIGNAL_EN_R);	//9801203a, enable all error SIGNAL Interrupt register
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writeb(0x0d, emmc_port->emmc_membase + EMMC_CTRL_R);      //9801202f, choose is card emmc bit
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x1, emmc_port->emmc_membase+EMMC_OTHER1);        //disable L4 gated
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writel(readl(emmc_port->emmc_membase+EMMC_DUMMY_SYS)|(EMMC_CLK_O_ICG_EN|EMMC_CARD_STOP_ENABLE), emmc_port->emmc_membase+EMMC_DUMMY_SYS);	//enable eMMC command clock
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writeb((readb(emmc_port->emmc_membase + EMMC_HOST_CTRL1_R)&0xe7)|(EMMC_ADMA2_32<<EMMC_DMA_SEL),
+                        emmc_port->emmc_membase + EMMC_HOST_CTRL1_R);   //ADMA2 32 bit select
+	isb();
+        sync(emmc_port);
+
+	rtkemmc_writeb((readb(emmc_port->emmc_membase + EMMC_MSHC_CTRL_R) & (~EMMC_CMD_CONFLICT_CHECK)), emmc_port->emmc_membase + EMMC_MSHC_CTRL_R);	//disable emmc cmd conflict checkout
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writew(readw(emmc_port->emmc_membase + EMMC_CLK_CTRL_R)|0x1, emmc_port->emmc_membase + EMMC_CLK_CTRL_R);   //enable internal clock
+	isb();
+	sync(emmc_port);
+
+	rtkemmc_writel(0x1, emmc_port->m2tmx_membase+EMMC_NAND_DMA_SEL);	// #sram_ctrl, 0 for nf, 1 for emmc
+        isb();
+        sync(emmc_port);
+
+	spin_lock_irqsave(&emmc_port->lock,flags);	
+	//initially set bus width 1
+	rtkemmc_writeb((readb(emmc_port->emmc_membase + EMMC_HOST_CTRL1_R)&0xdd)|EMMC_BUS_WIDTH_1,emmc_port->emmc_membase + EMMC_HOST_CTRL1_R);
+	sync(emmc_port);
+	spin_unlock_irqrestore(&emmc_port->lock, flags);
+
+	printk(KERN_INFO "%s: set bus width 1, 0x98012028=%08x\n", DRIVER_NAME, readb(emmc_port->emmc_membase + EMMC_HOST_CTRL1_R));
+
+	rtkemmc_set_pad_driving(emmc_port, 0x0, 0x0, 0x0, 0x0);
+
+	
+	//initially, we do not use pass tuning result from bootcode, so we need to reset the tx ,rx phase to 0 first, 
+	//and then framework call rtkemmc_tuning will set the rx tx register
+	//Now, we use the mechanism and hold this part for fear that user will use kernel tuning one day in the future
+	//if we use tuning inherit, the phase will be set to 0 and restore the tx rx from bootcode
+	phase(emmc_port, 0, 0); //VP0, VP1 phase
+
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+	udelay(1);
+	writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+
+	rtkemmc_set_freq(emmc_port,0x46, 0x80);  //80Mhz / 256 ~= 300K
+
+	sync(emmc_port);
+	host->ops = &rtkemmc_ops;
+	emmc_port->rtflags |= RTKCR_FCARD_DETECTED;
+}
+
+static int rtkemmc_set_rspparam(struct rtkemmc_host *emmc_port, struct sd_cmd_pkt *cmd_info)
+{
+	switch(cmd_info->cmd->opcode)
+	{
+	case MMC_GO_IDLE_STATE:
+		cmd_info->cmd_para = (EMMC_NO_RESP);
+		cmd_info->rsp_len = 6;
+		cmd_info->cmd->arg = 0x00000000;
+		break;
+	case MMC_SEND_OP_COND:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48);
+		cmd_info->cmd->arg = MMC_SECTOR_ADDR|MMC_VDD_165_195;
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_ALL_SEND_CID:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_136|EMMC_CMD_CHK_RESP_CRC);
+		cmd_info->rsp_len = 17;
+		cmd_info->cmd->arg = 0x00000000;
+		break;
+	case MMC_SET_RELATIVE_ADDR:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE);
+		cmd_info->cmd->arg = (1<<RCA_SHIFTER);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SEND_CSD:
+	case MMC_SEND_CID:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_136|EMMC_CMD_CHK_RESP_CRC);
+		cmd_info->cmd->arg = (1<<RCA_SHIFTER);
+		cmd_info->rsp_len = 17;
+		break;
+	case MMC_SEND_EXT_CSD:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE|EMMC_DATA);
+		cmd_info->cmd->arg = 0;
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SLEEP_AWAKE:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48B|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE);
+		cmd_info->rsp_len = 6;
+		printk(KERN_INFO "%s : cmd5 arg=0x%08x\n",__func__,cmd_info->cmd->arg);
+		break;
+	case MMC_SELECT_CARD:
+		printk(KERN_INFO "%s : cmd7 arg : 0x%08x\n",__func__,cmd_info->cmd->arg);
+		if (cmd_info->cmd->flags == (MMC_RSP_NONE | MMC_CMD_AC)) {
+			printk(KERN_INFO "%s : cmd7 with rsp none\n",__func__);
+			cmd_info->cmd_para = (EMMC_NO_RESP);
+		}
+		else {
+			printk(KERN_INFO "%s : cmd7 with rsp\n",__func__);
+			cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE);
+		}
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SWITCH:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48B|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SEND_STATUS:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE);
+		cmd_info->cmd->arg = (1<<RCA_SHIFTER);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_STOP_TRANSMISSION:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE|(EMMC_ABORT_CMD<<6));
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SEND_TUNING_BLOCK_HS200:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE|EMMC_DATA);
+		cmd_info->cmd->arg = 0;
+		cmd_info->rsp_len = 6;
+	case MMC_READ_MULTIPLE_BLOCK:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE|EMMC_DATA);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_SET_BLOCK_COUNT:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_WRITE_MULTIPLE_BLOCK:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE|EMMC_DATA);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_READ_SINGLE_BLOCK:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE|EMMC_DATA);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_WRITE_BLOCK:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE|EMMC_DATA);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_ERASE_GROUP_START:
+	case MMC_ERASE_GROUP_END:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE);
+                cmd_info->rsp_len = 6;
+		break;
+	case MMC_ERASE:
+		cmd_info->cmd_para = (EMMC_RESP_LEN_48B|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE);
+		cmd_info->rsp_len = 6;
+		break;
+	case MMC_GEN_CMD:
+		if(cmd_info->cmd->arg & 0x1) {   //read single block
+			cmd_info->cmd->arg = 0x1;
+			cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE|EMMC_DATA);
+			cmd_info->rsp_len = 6;
+			break;
+		}
+		else {      //write single block
+			cmd_info->cmd->arg = 0x0;
+			cmd_info->cmd_para = (EMMC_RESP_LEN_48|EMMC_CMD_CHK_RESP_CRC|EMMC_CMD_IDX_CHK_ENABLE|EMMC_DATA);
+			cmd_info->rsp_len = 6;
+			break;
+		}
+	default:
+		printk("Realtek Unrecognized eMMC command!!!\n");
+		cmd_info->cmd_para = 0;
+		cmd_info->rsp_len = 6;
+		break;
+	}
+
+	MMCPRINTF(KERN_INFO "%s : cmd=0x%02x rsp_len=0x%02x arg=0x%08x para=0x%08x\n","rtkemmc", cmd_info->cmd->opcode, cmd_info->rsp_len,cmd_info->cmd->arg,cmd_info->cmd_para);
+	return 0;
+}
+
+static int rtkemmc_stop_transmission(struct mmc_card *card,int bIgnore)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	int err = 0;
+	int bMalloc=0;
+	struct mmc_host * mmc = mmc_host_local;
+
+	MMCPRINTF("%s : \n", __func__);
+
+	memset(&cmd, 0, sizeof(struct mmc_command));
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+	if (card == NULL) {
+		bMalloc=1;
+		card = (struct mmc_card*)kmalloc(sizeof(struct mmc_card),GFP_KERNEL);
+		card->host = mmc;
+	}
+	set_cmd_info(card,&cmd,&cmd_info, MMC_STOP_TRANSMISSION, 0x00, 6);
+	err = SD_SendCMDGetRSP_Cmd(&cmd_info,bIgnore);
+	//printk(KERN_ERR "Tuning err handling cmd 12: EMMC_RINTSTS=0x%x,  EMMC_STATUS=0x%x\n",readl(emmc_port->emmc_membase + EMMC_RINTSTS),readl(emmc_port->emmc_membase + EMMC_STATUS));
+	if (bMalloc) {
+		kfree(card);
+		card = NULL;
+	}
+
+	if(err)
+		mmcmsg3(KERN_WARNING "%s: MMC_STOP_TRANSMISSION fail\n",DRIVER_NAME);
+
+	return err;
+}
+
+static int rtkemmc_wait_status(struct mmc_card *card,u8 state,u8 divider,int bIgnore)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	unsigned long timeend;
+	int err, bMalloc=0;
+	struct mmc_host * mmc = mmc_host_local;
+
+	MMCPRINTF("\n");
+	timeend = jiffies + msecs_to_jiffies(100);    /* wait 100ms */
+
+	if (card == NULL) {
+		bMalloc=1;
+		card = (struct mmc_card*)kmalloc(sizeof(struct mmc_card),GFP_KERNEL);
+		card->host = mmc;
+	}
+
+	do {
+		memset(&cmd, 0, sizeof(struct mmc_command));
+		memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+		set_cmd_info(card,&cmd,&cmd_info, MMC_SEND_STATUS, (card->rca)<<RCA_SHIFTER, 6);
+		err = SD_SendCMDGetRSP_Cmd(&cmd_info,bIgnore);
+
+		if(err) {
+			if (!bIgnore)
+				printk(KERN_INFO "wait %s fail\n",state_tlb[state]);
+			break;
+		}
+		else {
+			u8 cur_state = R1_CURRENT_STATE(cmd.resp[0]);
+			if (!bIgnore)
+				MMCPRINTF(KERN_WARNING "resp[0]=0x%08x,cur_state=%s\n",cmd.resp[0],state_tlb[cur_state]);
+			err = -1;
+			if(cur_state == state) {
+				if(cmd.resp[0] & R1_READY_FOR_DATA) {
+					err = 0;
+					break;
+				}
+			}
+		}
+	}while(time_before(jiffies, timeend));
+
+	if (bMalloc) {
+		kfree(card);
+		card = NULL;
+	}
+	return err;
+}
+#if 0
+void down_speed_handling(struct rtkemmc_host *emmc_port)
+{
+	struct mmc_host *mmc = emmc_port->mmc;
+	if(gCurrentBootMode == MODE_HS200) {
+		printk(KERN_ERR "down speed from HS200 to SDR50....\n");
+		//downgrade to SDR50 mode
+		mmc->caps &= ~(MMC_CAP_UHS_DDR50|MMC_CAP_1_8V_DDR);	//do not set emmc host capability as HS200
+		mmc->caps2 &= ~(MMC_CAP2_HS200_1_8V_SDR);
+		udelay(200);
+
+		rtkemmc_stop_transmission(mmc->card, 1);
+		wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_STATUS), 0x200, 0x0, __func__);          //card is not busy
+		isb();
+		sync(emmc_port);
+		if (readl(emmc_port + EMMC_TBBCNT) == 1024) {
+			wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_ISR), ISR_DMA_DONE_INT, ISR_DMA_DONE_INT, __func__);          //card is not busy
+			isb();
+			sync(emmc_port);
+			rtkemmc_clr_int_sta();
+		}
+
+		card_stop(emmc_port);
+		polling_to_tran_state(emmc_port,MMC_READ_MULTIPLE_BLOCK,1);//just pick up 1 command index for parameter
+
+		if (!g_bResuming)
+			gCurrentBootMode = MODE_SDR;
+
+		rtkemmc_select_card_type(mmc->card);	//do not set the emmc card capability as HS200
+		rtkemmc_select_timing(mmc->card);	//send cmd 6 again to inform the host SDR50 mode and set the correct bus speed mode
+
+		rtkemmc_set_freq(emmc_port, 0x57, 0x1); //50Mhz
+
+		rtkemmc_set_pad_driving(emmc_port,0x0, 0x0, 0x0, 0x0);
+
+		rtkemmc_writel(3, emmc_port->crt_membase + SYS_PLL_EMMC1);      //980001f0
+#if defined(CONFIG_ARCH_RTD16xx)
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)&0xffffffff7,emmc_port->emmc_membase+EMMC_OTHER1);
+		udelay(1);
+		writel(readl(emmc_port->emmc_membase+EMMC_OTHER1)|0x8,emmc_port->emmc_membase+EMMC_OTHER1);
+#endif
+		isb();
+	
+		sync(emmc_port);
+		udelay(100);
+	}
+	else if(gCurrentBootMode == MODE_HS400) {
+		//TBD
+		printk(KERN_ERR "down speed from HS400 to HS200....\n");
+		//downgrade to HS200 mode
+		mmc->caps2 &= ~(MMC_CAP2_HS400_1_8V);
+		if (!g_bResuming) {
+			gCurrentBootMode = MODE_HS200;
+		}
+		emmc_port->tx_tuning = emmc_port->rx_tuning = 1;
+
+		set_RTK_initial_flag(0);
+		printk(KERN_ERR "stop the emmc ...\n");
+		rtkemmc_stop_transmission(mmc->card, 1);
+		wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_STATUS), 0x200, 0x0, __func__);          //card is not busy
+		isb();
+		sync(emmc_port);
+		if (readl(emmc_port + EMMC_TBBCNT) == 1024) {
+			wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_ISR), ISR_DMA_DONE_INT, ISR_DMA_DONE_INT, __func__);          //card is not busy
+			isb();
+			sync(emmc_port);
+			rtkemmc_clr_int_sta();
+		}
+
+		card_stop(emmc_port);
+		polling_to_tran_state(emmc_port,MMC_READ_MULTIPLE_BLOCK,1);//just pick up 1 command index for parameter
+		//rtkemmc_backup_registers(emmc_port);
+		//rtkemmc_hw_reset();
+		//rtkemmc_restore_registers(emmc_port);
+		rtkemmc_writel(0x00000000 ,emmc_port->emmc_membase + EMMC_DDR_REG);
+		rtkemmc_writel(0x00000001, emmc_port->emmc_membase + EMMC_UHSREG);
+		rtkemmc_writel(0x80, emmc_port->emmc_membase + EMMC_DQS_CTRL1);
+		printk(KERN_ERR "down speed: change emmc card capability to hs200...\n");
+                rtkemmc_select_card_type(mmc->card);    //do not set the emmc card capability as HS200
+		printk(KERN_ERR "down speed: hs400 to hs200...\n");
+		mmc_hs400_to_hs200(mmc->card);
+		printk(KERN_ERR "down speed: HS200 tuning...\n");
+		hs400_to_hs200_flag=true;
+		rtkemmc_hs200_tuning(mmc->card);
+	}
+}
+#endif
+static int rtkemmc_wait_opt_end(char* drv_name, struct rtkemmc_host *emmc_port,u8 cmdcode,u32 cmd_idx,u8 ignore_log)
+{
+	volatile int err = RTK_SUCC;
+	volatile unsigned long timeend=0;
+	unsigned long flags;
+	u8 XFER_flag=0;
+	u16 reg_blksize = 0;
+	u16 reg_blkcount = 0;
+	u16 reg_cmdidx = 0;
+	u32 reg_argu = 0;
+
+	unsigned long msec = TIMEOUT_MS;
+	
+	switch(CMD_IDX_MASK(cmd_idx)) {
+		case MMC_READ_SINGLE_BLOCK:
+		case MMC_READ_MULTIPLE_BLOCK:
+		case MMC_WRITE_BLOCK:
+		case MMC_WRITE_MULTIPLE_BLOCK:
+		case MMC_SEND_EXT_CSD:
+		case MMC_GEN_CMD:
+		case MMC_SLEEP_AWAKE:
+		case MMC_SWITCH:
+		case MMC_ERASE:
+		case MMC_SEND_TUNING_BLOCK_HS200:
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+		case MMC_CMDQ_TASK_MGMT:
+#endif
+			XFER_flag=1;
+			break;
+	}
+	emmc_port->int_waiting = &rtk_emmc_wait;
+	/* timeout timer fire */
+	if (&emmc_port->timer) {
+#ifndef CONFIG_MMC_RTKEMMC_JIFFY_NOT_WORK_ON_1_LAYER_FPGA
+		MMCPRINTF("now = 0x%08x\n", jiffies);
+		MMCPRINTF("timer started : ");
+		timeend = jiffies + msecs_to_jiffies(msec)+emmc_port->tmout;
+		MMCPRINTF("TO = 0x%08x\n", timeend);
+		mod_timer(&emmc_port->timer, timeend );
+#endif
+	}
+
+	if (emmc_port->int_waiting) {
+		rtkemmc_hold_int_dec();
+		rtkemmc_clr_int_sta();
+		emmc_port->int_waiting = &rtk_emmc_wait;
+
+		if (XFER_flag==1)
+			rtkemmc_en_xfer_int();	//command with data, r1b case
+		else
+			rtkemmc_en_cd_int(); //command case
+
+		if (CMD_IDX_MASK(cmd_idx)==MMC_WRITE_MULTIPLE_BLOCK || CMD_IDX_MASK(cmd_idx)==MMC_READ_MULTIPLE_BLOCK ){
+			if (emmc_port->rpmb_cmd) {
+				rtkemmc_writew(readw(emmc_port->emmc_membase + EMMC_XFER_MODE_R) & ~(1<<EMMC_AUTO_CMD_ENABLE), emmc_port->emmc_membase + EMMC_XFER_MODE_R);
+			}//CMD25/18 following CMD13, never set CMD_SEND_AUTO_STOP
+                }
+
+		if(CMD_IDX_MASK(cmd_idx)==MMC_SEND_TUNING_BLOCK_HS200) {
+			rtkemmc_writew(0x80, emmc_port->emmc_membase+EMMC_BLOCKSIZE_R);
+		}
+		else {
+			rtkemmc_writew(0x200, emmc_port->emmc_membase+EMMC_BLOCKSIZE_R);
+		}
+		//cmd fire
+		spin_lock_irqsave(&emmc_port->lock,flags);
+		reg_blksize = readw(emmc_port->emmc_membase+EMMC_BLOCKSIZE_R);
+		reg_blkcount = readw(emmc_port->emmc_membase+EMMC_BLOCKCOUNT_R);
+		reg_argu = readl(emmc_port->emmc_membase+EMMC_ARGUMENT_R);
+		rtkemmc_writew(cmd_idx,emmc_port->emmc_membase+EMMC_CMD_R);
+		reg_cmdidx = readw(emmc_port->emmc_membase+EMMC_CMD_R);
+		spin_unlock_irqrestore(&emmc_port->lock,flags);
+		wait_for_completion(emmc_port->int_waiting);
+
+		if(XFER_flag==1) {	//cmd with data
+			wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_NORMAL_INT_STAT_R), 0x2, 0x2, __func__);
+		}
+		else{
+			wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_NORMAL_INT_STAT_R), 0x1, 0x1, __func__);
+		}
+		if (emmc_port->normal_interrupt & EMMC_ERR_INTERRUPT) {
+			if (!ignore_log) {
+				if (CMD_IDX_MASK(cmd_idx)!=MMC_GO_IDLE_STATE) {
+					printk(KERN_ERR "0x98012004 EMMC BLOCK SIZE = 0x%x\n",reg_blksize);
+        				printk(KERN_ERR "0x98012006 EMMC BLOCK COUNT = 0x%08x\n", reg_blkcount);
+        				printk(KERN_ERR "0x98012008 EMMC CMDARG = 0x%08x\n", reg_argu);
+					printk(KERN_ERR "0x9801200e EMMC CMD REG = 0x%08x\n", reg_cmdidx);
+					print_err_reg(cmd_idx, emmc_port->normal_interrupt, emmc_port->error_interrupt);
+					print_ip_desc(emmc_port);
+					print_reg_info(emmc_port);
+					asm volatile("loop:");
+					asm volatile("b loop");
+				}
+			}
+			else{ //in tuning, only print rintsts
+#ifdef RTKEMMC_DEBUG
+				printk(KERN_ERR "Tuning error case!!!\n");
+#endif
+#if 0
+				if (CMD_IDX_MASK(cmd_idx)!=MMC_GO_IDLE_STATE && (emmc_port->rintsts & (INT_STS_HTO | INT_STS_HLE | INT_STS_DRTO_BDS))) {
+					printk(KERN_ERR "Tuning: HTO/HLE/DRTO - INT_STS_ERRORS, cmd_idx=0x%08x, rintsts=0x%08x, idsts=0x%08x, status=0x%08x\n",
+						CMD_IDX_MASK(cmd_idx), emmc_port->rintsts, emmc_port->idsts, emmc_port->status);
+				}
+#endif
+			}
+
+			err = RTK_FAIL;
+		}
+	}
+	return err;
+}
+
+u32 rtkemmc_swap_endian(u32 input)
+{
+        u32 output;
+        output = (input & 0xff000000)>>24|
+                 (input & 0x00ff0000)>>8|
+                 (input & 0x0000ff00)<<8|
+                 (input & 0x000000ff)<<24;
+        return output;
+}
+
+#ifdef RTKMMEC_DMA_DEBUG
+struct q_node {
+	unsigned int idx;
+	unsigned int blk_addr;
+	unsigned int blk_cnt;
+	u32 *desc;
+	unsigned int desc_cnt;
+	int dma_nent;
+};
+struct q_node q_data;
+
+static void rtkemmc_dump_dma_metadata(struct sd_cmd_pkt *cmd_info, u32* des_base, int  dma_nents)
+{
+	q_data.idx = cmd_info->cmd->opcode;
+	q_data.blk_addr = cmd_info->cmd->arg;
+	q_data.blk_cnt = cmd_info->block_count;
+	q_data.desc = des_base;
+	q_data.dma_nent = dma_nents;
+
+	printk(KERN_INFO "%s: idx=%d, blk_addr=0x%x, total_blk_cnt=%d, desc_virt_addr=0x%x, dma_nent=%d\n",
+		__func__, q_data.idx, q_data.blk_addr, q_data.blk_cnt, q_data.desc, q_data.dma_nent);
+}
+static void rtkemmc_dma_debug(struct sd_cmd_pkt *cmd_info)
+{
+	if(cmd_info->cmd->opcode==17 || cmd_info->cmd->opcode==18 || cmd_info->cmd->opcode==24 || cmd_info->cmd->opcode==25) {
+		int idx=0;
+		struct scatterlist *sg;
+		int  dma_leng = 0;
+		volatile u32  dma_addr;
+		volatile u32 virt_addr;
+		int i=0;
+		struct page *ret_page;
+		printk(KERN_INFO "%s: idx=%d, blk_addr=%d, blk_cnt=0x%x, desc_virt_addr=0x%x, dma_nent=%d\n",
+				__func__, cmd_info->cmd->opcode, cmd_info->cmd->arg, cmd_info->block_count, q_data.desc, q_data.dma_nent);
+
+		for_each_sg(cmd_info->data->sg, sg, q_data.dma_nent, i) {
+			dma_addr = sg_dma_address(sg);
+			dma_leng = sg_dma_len(sg);
+			ret_page = sg_page(sg);
+			virt_addr = kmap(ret_page) + sg->offset;
+
+			bool flag1 = false;
+			bool flag2 = false;
+
+			printk(KERN_INFO "%s: nent%d, dma_addr=0x%x, dma_len=%d, virt_addr=0x%x, sg->offset=0x%x\n", __func__, i, dma_addr, dma_leng, virt_addr, sg->offset);
+
+#if 0
+			for(idx=0;idx<dma_leng;idx+=4) {
+				int idx2 = idx % 4096;  //page size is 4096
+				if(idx2==0 && idx!=0) {
+					kunmap(ret_page);
+					ret_page = phys_to_page(dma_addr+idx);
+					virt_addr = kmap(ret_page) + sg->offset;
+				}
+				printk(KERN_INFO "%s phys_addr 0x%x virt_addr 0x%x: 0x%x\n", __func__, dma_addr+idx, virt_addr+idx2, rtkemmc_swap_endian(*(u32*)(virt_addr+idx2)));
+			}
+#else
+			//assume that input test pattern is 0x01234567 or 0x89abcdef
+			if(rtkemmc_swap_endian(*(u32*)(virt_addr+8))==0x01234567 || rtkemmc_swap_endian(*(u32*)(virt_addr+8))==0x89abcdef) {
+				for(idx=0; idx<dma_leng; idx+=4) {
+
+					int idx2 = idx % 4096;	//page size is 4096
+					if(idx2==0 && idx!=0) {
+						kunmap(ret_page);
+						ret_page = phys_to_page(dma_addr+idx);
+						virt_addr = kmap(ret_page) + sg->offset;
+						flag1 = false;
+						flag2 = false;
+					}
+					if(rtkemmc_swap_endian(*(u32*)(virt_addr+(idx2)))==0x01234567) flag1=true;
+					if(rtkemmc_swap_endian(*(u32*)(virt_addr+(idx2)))==0x89abcdef) flag2=true;
+
+					if((rtkemmc_swap_endian(*(u32*)(virt_addr+(idx2)))!=0x01234567 && rtkemmc_swap_endian(*(u32*)(virt_addr+(idx2)))!=0x89abcdef)
+						|| (flag1==true && flag2==true)) {
+						printk(KERN_ERR "%s: DATA error detected !!!!!!!\n", __func__);
+						printk(KERN_ERR "%s: idx=%d, blk_addr=0x%x, blk_cnt=0x%x, desc_virt_addr=0x%x, dma_nent=%d\n",
+								__func__, cmd_info->cmd->opcode, cmd_info->cmd->arg, cmd_info->block_count, q_data.desc, q_data.dma_nent);
+
+						int start_idx=0;
+						for(start_idx=-64; start_idx<64; start_idx+=4) {
+							if(idx2+start_idx>=sg->offset && idx2+start_idx<4096) {
+								printk(KERN_ERR "%s phys_addr 0x%x virt_addr 0x%x: 0x%x\n",
+                                                                __func__, dma_addr+idx+start_idx, virt_addr+idx2+start_idx , rtkemmc_swap_endian(*(u32*)(virt_addr+idx2+start_idx)));
+							}
+						}
+						kunmap(ret_page);
+						asm volatile("loop1:");
+						asm volatile("b loop1");
+					}
+				}
+			}
+#endif
+			kunmap(ret_page);
+		}
+	}
+}
+#endif
+
+#ifndef CONFIG_RTK_XEN_SUPPORT
+static void make_sg_des(struct sd_cmd_pkt *cmd_info, u32 p_des_base, struct rtkemmc_host *emmc_port)
+{
+	u32  blk_cnt;
+	u32  blk_cnt2;
+	u32  remain_blk_cnt;
+	u32  tmp_val;
+	u32* des_base = gddr_descriptor ;
+	u32  dir = 0;
+	u32  dma_nents = 0;
+	u32  dma_leng = 0;
+	u32  dma_addr;
+	u32  i;
+	unsigned int b1, b2;
+	struct mmc_host *host = cmd_info->emmc_port->mmc;
+	struct scatterlist *sg;
+
+	MMCPRINTF("RTKEMMC: des_base = 0x%08x\n", des_base);
+
+	if(cmd_info->data->flags & MMC_DATA_READ)
+		dir = DMA_FROM_DEVICE;
+	else
+		dir = DMA_TO_DEVICE;
+
+	dma_nents = dma_map_sg( mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len,  dir);
+	sg = cmd_info->data->sg;
+
+#ifdef RTKMMEC_DMA_DEBUG
+	rtkemmc_dump_dma_metadata(cmd_info, des_base, dma_nents);
+#endif
+#ifdef RTKEMMC_PHASE_TRACE
+	trace_desc_counter = 0;
+#endif
+	for(i=0; i<dma_nents; i++,sg++) {
+		dma_leng = sg_dma_len(sg);
+		blk_cnt  = dma_leng>>9;                         /*blk_cnt must be the multiple of 512(0x200)*/
+		remain_blk_cnt  = blk_cnt;
+		dma_addr = sg_dma_address(sg);
+
+#if 0
+		printk(KERN_INFO "%s: nent%d, dma_addr=0x%x, dma_len=%d\n", __func__, i, dma_addr, dma_leng);
+#endif
+		while(remain_blk_cnt) {
+			/* setting des1; buffer size in byte */
+                	if(remain_blk_cnt > EMMC_MAX_SCRIPT_BLK)
+                        	blk_cnt2 = EMMC_MAX_SCRIPT_BLK;
+                	else
+                        	blk_cnt2 = remain_blk_cnt;
+
+			//boundary check
+			b1 = dma_addr / 0x8000000;		//this eMMC ip dma transfer has 128MB limitation
+			b2 = (dma_addr+blk_cnt2*512) / 0x8000000;
+			if(b1 != b2) {
+				blk_cnt2 = (b2*0x8000000-dma_addr) / 512;
+			}
+			tmp_val = ((blk_cnt2&0x7f)<<25)|0x21;
+
+			if((i==(dma_nents-1)) && (remain_blk_cnt == blk_cnt2))
+				tmp_val |= 0x2;
+
+			des_base[0] = rtkemmc_swap_endian(dma_addr);       /* setting des2; Physical address to DMA to/from */
+			des_base[1] = rtkemmc_swap_endian(tmp_val);
+
+			isb();
+			sync(emmc_port);
+#if 0
+			printk(KERN_INFO "%s - blk cnt : 0x%08x, dma_addr=0x%08x, tmp_val=0x%08x, desc[0]=0x%08x, desc[1]=0x%08x\n",
+				__func__, blk_cnt2, dma_addr, tmp_val, des_base[0],des_base[1]);
+#endif
+			dma_addr = dma_addr+(blk_cnt2<<9);
+			remain_blk_cnt -= blk_cnt2;
+			des_base += 2;
+
+			isb();
+			sync(emmc_port);
+#ifdef RTKEMMC_PHASE_TRACE
+			trace_desc_counter += 2;
+#endif
+		}
+	}
+
+	wmb();
+	sync(emmc_port);
+}
+#endif
+
+static void make_ip_des(u32 dma_addr, u32 dma_length, u32 p_des_base, struct rtkemmc_host *emmc_port)
+{
+	u32  blk_cnt;
+	u32  blk_cnt2;
+	u32  remain_blk_cnt;
+	u32  tmp_val;
+	u32* des_base = gddr_descriptor ;
+	unsigned int b1, b2;
+
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(gddr_descriptor, DESC_ALLOC_LENGTH);
+#else
+	__flush_dcache_area(gddr_descriptor, DESC_ALLOC_LENGTH);
+#endif /* CONFIG_CPU_V7 */
+
+	isb();
+	sync(emmc_port);
+
+	MMCPRINTF("RTKEMMC: des_base = 0x%08x\n", des_base);
+	//blk_cnt must be the multiple of 512(0x200)
+	if(dma_length<512) {
+		blk_cnt = 1;
+	}
+	else{
+		blk_cnt  = dma_length>>9;
+	}
+	remain_blk_cnt  = blk_cnt;
+
+	isb();
+	sync(emmc_port);
+#ifdef RTKEMMC_PHASE_TRACE
+	trace_desc_counter = 0;
+#endif
+	while(remain_blk_cnt) {
+		/* setting des1; buffer size in byte */
+		if(remain_blk_cnt > EMMC_MAX_SCRIPT_BLK)
+			blk_cnt2 = EMMC_MAX_SCRIPT_BLK;
+		else
+			blk_cnt2 = remain_blk_cnt;
+
+		 //boundary check
+		b1 = dma_addr / 0x8000000;              //this eMMC ip dma transfer has 128MB limitation
+		b2 = (dma_addr+blk_cnt2*512) / 0x8000000;
+		if(b1 != b2) {
+			blk_cnt2 = (b2*0x8000000-dma_addr) / 512;
+		}
+
+		if(dma_length<512) tmp_val = ((dma_length)<<16)|0x21;
+		else tmp_val = ((blk_cnt2&0x7f)<<25)|0x21;
+
+		if(remain_blk_cnt == blk_cnt2)
+			tmp_val |= 0x2;
+
+		des_base[0] = rtkemmc_swap_endian(dma_addr);       /* setting des2; Physical address to DMA to/from */
+		des_base[1] = rtkemmc_swap_endian(tmp_val);
+
+		isb();
+		sync(emmc_port);
+
+		MMCPRINTF("%s - remain cnt : 0x%08x, desc[0]=0x%08x, desc[1]=0x%08x\n",
+			__func__, remain_blk_cnt,des_base[0],des_base[1]);
+
+		dma_addr = dma_addr+(blk_cnt2<<9);
+		remain_blk_cnt -= blk_cnt2;
+		des_base += 2;
+		isb();
+		sync(emmc_port);
+#ifdef RTKEMMC_PHASE_TRACE
+		trace_desc_counter +=2;
+#endif
+	}
+
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(gddr_descriptor, DESC_ALLOC_LENGTH);
+#else
+	__flush_dcache_area(gddr_descriptor, DESC_ALLOC_LENGTH);
+#endif /* CONFIG_CPU_V7 */
+
+	isb();
+	sync(emmc_port);
+}
+
+static void rtkemmc_read_rsp(struct rtkemmc_host *emmc_port,u32 *rsp, int reg_count)
+{
+	MMCPRINTF("rsp addr=0x%p; rsp_count=%u\n", rsp, reg_count);
+	if ( reg_count==6 ){
+		rsp[0] = rsp[1] = 0;
+		rsp[0] = readl(emmc_port->emmc_membase + EMMC_RESP01_R);
+		MMCPRINTF(KERN_INFO "rsp[0]=0x%08x, rsp[1]=0x%08x\n",rsp[0],rsp[1]);
+	}else if(reg_count==17){
+		/*1. UNSTUFF_BITS uses the reverse order as: const int __off = 3 - ((start) / 32);
+		  2. be32_to_cpu is called in mmc_send_csd as csd[i] = be32_to_cpu(csd_tmp[i]);*/
+		//in hank eMMC IP, we neeed to rearrange  response in 17 bytes case because they save 8-135 bit instead of 0-127 bit
+		u32 rsp_tmp[4]={0};
+		rsp_tmp[3] = readl(emmc_port->emmc_membase + EMMC_RESP01_R);
+		rsp_tmp[2] = readl(emmc_port->emmc_membase + EMMC_RESP23_R);
+		rsp_tmp[1] = readl(emmc_port->emmc_membase + EMMC_RESP45_R);
+		rsp_tmp[0] = readl(emmc_port->emmc_membase + EMMC_RESP67_R);
+		rsp[3] = (rsp_tmp[3]&0x00ffffff)<<8;
+		rsp[2] = ((rsp_tmp[2]&0x00ffffff)<<8) | ((rsp_tmp[3]&0xff000000)>>24);
+		rsp[1] = ((rsp_tmp[1]&0x00ffffff)<<8) | ((rsp_tmp[2]&0xff000000)>>24); 
+		rsp[0] = ((rsp_tmp[0]&0x00ffffff)<<8) | ((rsp_tmp[1]&0xff000000)>>24);
+		MMCPRINTF(KERN_INFO "rsp[0]=0x%08x, rsp[1]=0x%08x, rsp[2]=0x%08x, rsp[3]=0x%08x\n",rsp[0],rsp[1],rsp[2],rsp[3]);
+	}
+	else
+		MMCPRINTF("rsp[0]=0x%08x\n",rsp[0]);
+}
+
+static int rtkemmc_send_status(struct mmc_card *card, u32 *status, u8 *state,u8 divider,int bIgnore)
+{
+	struct mmc_command cmd;
+	struct sd_cmd_pkt cmd_info;
+	int err=0;
+	int bMalloc=0;
+	struct mmc_host * mmc = mmc_host_local;
+
+	memset(&cmd, 0, sizeof(struct mmc_command));
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	if (card == NULL) {
+		bMalloc=1;
+		card = (struct mmc_card*)kmalloc(sizeof(struct mmc_card),GFP_KERNEL);
+		card->host = mmc;
+	}
+
+	set_cmd_info(card,&cmd,&cmd_info, MMC_SEND_STATUS, (card->rca)<<RCA_SHIFTER, 6);
+    
+	err = SD_SendCMDGetRSP(&cmd_info,bIgnore);
+
+	if (bMalloc) {
+		kfree(card);
+		card = NULL;
+	}
+
+	if(err)
+		mmcmsg3(KERN_WARNING "%s: MMC_SEND_STATUS fail\n",DRIVER_NAME);
+	else {
+		(*status) = cmd.resp[0];
+		(*state) = R1_CURRENT_STATE(cmd.resp[0]);
+		if (!bIgnore)
+		printk(KERN_INFO "cur_state=%s\n",state_tlb[(*state)]);
+	}
+
+	return err;
+}
+
+static int SD_SendCMDGetRSP_Cmd(struct sd_cmd_pkt *cmd_info,int bIgnore)
+{
+	volatile u8 cmd_idx              = cmd_info->cmd->opcode;
+	u32 *rsp                = (u32 *)&cmd_info->cmd->resp;
+	struct rtkemmc_host *emmc_port = cmd_info->emmc_port;
+	struct mmc_host *host = emmc_port->mmc;
+	int err;//, retry_count=0;
+	u8 state = 0;
+	u32 status = 0;
+	int cmd1_retry_cnt = 3000;
+	MMCPRINTF("%s \n", __func__);
+
+//	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_PSTATE_REG), 0x3, 0x0, __func__);
+
+	rtkemmc_set_rspparam(emmc_port,cmd_info);   //for 1295
+	if(rsp == NULL)
+		BUG_ON(1);
+
+	if ((g_crinit == 0)&&(cmd_idx > MMC_SET_RELATIVE_ADDR)) {
+		printk("%s : ignore cmd:0x%02x since we're still in emmc init stage\n",DRIVER_NAME,cmd_idx);
+		return CR_TRANSFER_FAIL;
+	}
+RET_CMD:
+	rtkemmc_writel(cmd_info->cmd->arg, emmc_port->emmc_membase + EMMC_ARGUMENT_R);
+	isb();
+	sync(emmc_port);
+
+	emmc_port->cmd_opcode = cmd_idx;
+
+	if (cmd_idx == MMC_SET_BLOCK_COUNT)
+		emmc_port->rpmb_cmd = 1;
+	else
+		emmc_port->rpmb_cmd = 0;
+	err = rtkemmc_wait_opt_end(DRIVER_NAME,emmc_port,EMMC_SENDCMDGETRSP,((cmd_idx<<8)|cmd_info->cmd_para),bIgnore);
+	if(err == RTK_SUCC){
+		sync(emmc_port);
+		rtkemmc_read_rsp(emmc_port,rsp, cmd_info->rsp_len);
+		sync(emmc_port);
+#if 0
+		printk(KERN_INFO "%s: rsp[0]=0x%x, rsp[1]=0x%x, rsp[2]=0x%x, rsp[3]=0x%x\n",__func__, rsp[0], rsp[1], rsp[2], rsp[3]);
+#endif
+		//luis, TBC
+		while ((cmd_idx == MMC_SEND_OP_COND) && ((rsp[0]&0x80000000) != 0x80000000) && cmd1_retry_cnt--) {
+			sync(emmc_port);
+			mdelay(1);
+			goto RET_CMD;
+		}
+
+		//CMD1 timeout case
+		if ((cmd_idx == MMC_SEND_OP_COND) && ((rsp[0]&0x80000000) != 0x80000000)){
+			printk(KERN_ERR RED_BOLD"eMMC CMD1 timeout error !!\n"RESET);
+			BUG();
+		}
+
+		if (cmd_idx == MMC_SET_RELATIVE_ADDR) {
+			g_crinit = 1;
+			MMCPRINTF("emmc init done ...\n");
+		}
+
+		//get cmd7 status
+		if ((cmd_info->cmd->flags == (MMC_RSP_NONE | MMC_CMD_AC))&&(cmd_idx==MMC_SELECT_CARD)) {
+			printk(KERN_INFO "get status =>\n");
+			rtkemmc_send_status(host->card,&status, &state,0,0);
+		}
+
+	}
+	else {
+#if 0
+		if (gCurrentBootMode > MODE_SDR && cmd_idx > MMC_SEND_OP_COND)
+			return err;
+		if (cmd_idx == MMC_SEND_STATUS) //prevent dead lock looping
+			return err;
+#else
+		if(!bIgnore) {
+			printk(KERN_ERR "SD_SendCMDGetRSP_Cmd error...\n");
+			if((readw(emmc_port->emmc_membase + EMMC_ERROR_INT_STAT_R)&
+				(EMMC_AUTO_CMD_ERR|EMMC_CMD_IDX_ERR|EMMC_CMD_END_BIT_ERR|EMMC_CMD_CRC_ERR|EMMC_CMD_TOUT_ERR))!=0){ //check cmd line
+#ifdef RTKEMMC_DEBUG
+				printk(KERN_INFO "CMD Line error occurs \n");
+#endif
+				rtkemmc_writeb(0x2, emmc_port->emmc_membase + EMMC_SW_RST_R); //Perform a software reset
+				wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + 0x2c), (0x2<<24), 0x0, __func__); //wait for clear 0x2f bit 1
+			}
+			if((readw(emmc_port->emmc_membase + EMMC_ERROR_INT_STAT_R)&
+				(EMMC_ADMA_ERR|EMMC_DATA_END_BIT_ERR|EMMC_DATA_CRC_ERR|EMMC_DATA_TOUT_ERR)) !=0){ //check data line
+#ifdef RTKEMMC_DEBUG
+				printk(KERN_INFO "DAT Line error occurs \n");
+#endif
+				rtkemmc_writeb(0x4, emmc_port->emmc_membase + EMMC_SW_RST_R); //Perform a software reset
+				wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + 0x2c), (0x4<<24), 0x0, __func__); //wait for clear 0x2f bit 2
+			}
+		}
+#endif
+	}
+	return err;
+}
+
+static int SD_Stream_Cmd(u16 cmdcode,struct sd_cmd_pkt *cmd_info, unsigned int bIgnore)
+{
+	u8 cmd_idx              = cmd_info->cmd->opcode;
+	u32 *rsp                = (u32 *)&cmd_info->cmd->resp;
+	struct rtkemmc_host *emmc_port = cmd_info->emmc_port;
+	u16 block_count         = cmd_info->block_count;
+	int err;
+	u8 *data              = cmd_info->dma_buffer;
+//	u32 retry_count=0;
+
+	int read_flag=1;
+	int mul_blk_flag=0;
+	int auto_stop_flag=0;
+
+	MMCPRINTF("%s \n", __func__);
+
+	if(rsp == NULL)
+		BUG_ON(1);
+//	wait_done_timeout(emmc_port, (u32*)(emmc_port->emmc_membase + EMMC_PSTATE_REG), 0x3, 0x0,__func__);
+#ifdef TEST_POWER_RESCYCLE
+	cmd_info->emmc_port->test_count++;
+	mmcspec("test_count=%d\n",cmd_info->emmc_port->test_count);
+#endif
+
+	if ((g_crinit == 0)&&(cmd_idx > MMC_SET_RELATIVE_ADDR)) {
+		printk("%s : ignore cmd:0x%02x since we're still in emmc init stage\n",DRIVER_NAME,cmd_idx);
+		return CR_TRANSFER_FAIL;
+	}
+
+	rtkemmc_set_rspparam(emmc_port,cmd_info);   //for 119x
+
+	/*************************************************************************/
+	rtkemmc_writel(readl(emmc_port->iso_blk_membase + EMMC_SWC_SEL)|0x10, emmc_port->iso_blk_membase + EMMC_SWC_SEL);
+	rtkemmc_writel(readl(emmc_port->iso_blk_membase + EMMC_SWC_SEL1)&0xffffffef, emmc_port->iso_blk_membase + EMMC_SWC_SEL1);
+	rtkemmc_writel(readl(emmc_port->iso_blk_membase + EMMC_SWC_SEL2)|0x10, emmc_port->iso_blk_membase + EMMC_SWC_SEL2);
+	rtkemmc_writel(readl(emmc_port->iso_blk_membase + EMMC_SWC_SEL3)&0xffffffef, emmc_port->iso_blk_membase + EMMC_SWC_SEL3);
+	rtkemmc_writel(0, emmc_port->emmc_membase + EMMC_CP);
+	/*************************************************************************/
+#ifndef CONFIG_RTK_XEN_SUPPORT
+	if (cmd_info->data)
+		make_sg_des(cmd_info, emmc_port->desc_paddr, emmc_port);
+	else if (data) {
+		if(cmd_idx==MMC_SEND_TUNING_BLOCK_HS200) make_ip_des(data, 0x80, emmc_port->desc_paddr, emmc_port);
+		else make_ip_des(data, block_count<<9, emmc_port->desc_paddr, emmc_port);
+	}
+	else
+		BUG_ON(1);
+#else
+	if(cmd_idx==MMC_SEND_TUNING_BLOCK_HS200) make_ip_des(data, 0x80, emmc_port->desc_paddr, emmc_port);
+	else make_ip_des(data, block_count<<9, emmc_port->desc_paddr, emmc_port);
+#endif
+//STR_CMD_RET:
+	rtkemmc_writew(block_count, emmc_port->emmc_membase + EMMC_BLOCKCOUNT_R);
+	rtkemmc_writel(emmc_port->desc_paddr, emmc_port->emmc_membase + EMMC_ADMA_SA_LOW_R);
+
+	rtkemmc_writel(cmd_info->cmd->arg, emmc_port->emmc_membase + EMMC_ARGUMENT_R);
+
+	if(cmd_idx==MMC_WRITE_BLOCK || cmd_idx==MMC_WRITE_MULTIPLE_BLOCK || cmd_idx==MMC_LOCK_UNLOCK
+		||cmd_idx==47 || cmd_idx==49 || (cmd_idx==MMC_GEN_CMD && cmd_info->cmd->arg==0))
+		read_flag=0;
+
+	if(cmd_idx==MMC_WRITE_MULTIPLE_BLOCK || cmd_idx==MMC_READ_MULTIPLE_BLOCK) {
+		mul_blk_flag=1;
+		auto_stop_flag=1;
+	}
+
+	rtkemmc_writew((mul_blk_flag<<EMMC_MULTI_BLK_SEL)|
+		       (read_flag<<EMMC_DATA_XFER_DIR)|
+		       (auto_stop_flag<<EMMC_AUTO_CMD_ENABLE)|
+		        EMMC_BLOCK_COUNT_ENABLE|
+			EMMC_DMA_ENABLE,
+			emmc_port->emmc_membase + EMMC_XFER_MODE_R);
+	isb();
+	sync(emmc_port);
+
+#if 0
+	//workaround, if fail to write EMMC_CMDARG, re-write
+	while(readl(emmc_port->emmc_membase + EMMC_ARGUMENT_R) != cmd_info->cmd->arg) {
+		printk(KERN_ERR RED_BOLD"SD_Stream_Cmd: Fail to write EMMC_CMDARG ! \n"RESET);
+		printk(KERN_ERR "cmd_info->opcode = 0x%08x \n", cmd_info->cmd->opcode );
+		printk(KERN_ERR "cmd_info->cmd->arg = 0x%08x \n", cmd_info->cmd->arg );
+		printk(KERN_ERR "EMMC_CMDARG = 0x%08x \n", readl(emmc_port->emmc_membase + EMMC_ARGUMENT_R));
+		rtkemmc_writel(cmd_info->cmd->arg, emmc_port->emmc_membase + EMMC_ARGUMENT_R);
+		isb();
+		sync(emmc_port);
+	}
+#endif
+	emmc_port->cmd_opcode = cmd_idx;
+
+	rtkemmc_get_cmd_timeout(cmd_info);
+	isb();
+	sync(emmc_port);
+	err = rtkemmc_wait_opt_end(DRIVER_NAME,emmc_port,cmdcode,((cmd_idx<<8)|cmd_info->cmd_para),bIgnore);
+	isb();
+	sync(emmc_port);
+
+	if(err == RTK_SUCC) {
+		if((cmdcode == EMMC_AUTOREAD1) || (cmdcode == EMMC_AUTOWRITE1))
+			MMCPRINTF("AUTO READ/WRITE 1 skip response~\n");
+		else {
+			rtkemmc_read_rsp(emmc_port,rsp, cmd_info->rsp_len);
+#if 0
+			printk(KERN_INFO "%s: rsp[0]=0x%x, rsp[1]=0x%x, rsp[2]=0x%x, rsp[3]=0x%x\n",__func__, rsp[0], rsp[1], rsp[2], rsp[3]);
+#endif
+		}
+	}
+	else {
+#if 0
+		if(cmd_resend==1) //down speed handling
+			return RTK_SUCC;
+#else
+		if(!bIgnore) {
+			printk(KERN_ERR "SD_Stream_Cmd error...\n");
+			error_handling(emmc_port);
+		}
+#endif
+	}
+	return err;
+}
+
+static int SD_SendCMDGetRSP(struct sd_cmd_pkt * cmd_info,int bIgnore)
+{
+	int rc;
+
+	MMCPRINTF("\n");
+
+	rc = SD_SendCMDGetRSP_Cmd(cmd_info,bIgnore);
+	return rc;
+}
+
+#ifndef CONFIG_RTK_XEN_SUPPORT
+static int SD_Stream(struct sd_cmd_pkt *cmd_info)
+{
+	int err=0;
+	u32 dma_leng = 0;
+	u16 cmdcode = 0;
+	u32 dir = 0;
+
+	struct mmc_host *host = cmd_info->emmc_port->mmc;
+	struct rtkemmc_host *emmc_port = cmd_info->emmc_port;
+
+	MMCPRINTF("%s \n", __func__);
+
+	rtkemmc_set_rspparam(emmc_port,cmd_info);
+	if(cmd_info->data->flags & MMC_DATA_READ){
+		dir = DMA_FROM_DEVICE;
+	}else{
+		dir = DMA_TO_DEVICE;
+	}
+
+	cmd_info->data->bytes_xfered=0;
+	//dma_nents = dma_map_sg( mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len,  dir);
+	//sg = cmd_info->data->sg;
+
+#ifdef SHOW_MMC_PRD
+	printk("sg_len:%u\n",cmd_info->data->sg_len);
+	printk("sg:0x%p; dma_nents:%u\n",sg,dma_nents);
+#endif
+
+	//for(i=0; i<dma_nents; i++,sg++)
+		//dma_leng += sg_dma_len(sg);
+
+	//printk("%s dma_leng=0x%x \n", __func__, dma_leng);      //hcy test
+	//printk("%s cmd_info->data->blksz  =0x%x \n", __func__,    cmd_info->data->blksz );
+	//printk("%s cmd_info->data->blocks =0x%x \n", __func__,    cmd_info->data->blocks);
+	//printk("%s cmd_info->data->blksz * cmd_info->data->blocks =0x%x \n", __func__,    cmd_info->data->blksz * cmd_info->data->blocks);
+	dma_leng = cmd_info->data->blksz * cmd_info->data->blocks;
+#ifdef RTK_EMMC_HEALTH_REPORT
+	//if(host->remainder == 0) printk(KERN_INFO "cmd_info->data->blksz = %d\n", cmd_info->data->blksz);
+	//1G = 1024 x 1024 x 1024 bytes, so emmc size is from ext_csd,
+	if((cmd_info->cmd->opcode==24 || cmd_info->cmd->opcode==25) && host->card!=NULL) {
+		host->remainder += cmd_info->data->blocks;
+		if(host->remainder/host->card->ext_csd.sectors > 0) {
+			host->wr_emmc_size_cnt += (host->remainder/host->card->ext_csd.sectors);
+			host->remainder = host->remainder % host->card->ext_csd.sectors;
+		}
+	}
+	if(host->wr_emmc_size_cnt > 3000) printk(KERN_ERR "EMMC write count is larger than 3000 times of emmc size!!!\n");
+#endif
+
+#ifdef SHOW_MMC_PRD
+	printk("dma_addr:0x%x; dma_leng:0x%x\n",dma_addr,dma_leng);
+	mmcinfo("host=%p\n",host);
+	if(host->card){
+		mmcinfo("card=%p\n",host->card);
+		if(mmc_card_blockaddr(host->card))
+			printk("arg:0x%x blk\n",cmd_info->cmd->arg);
+		else
+			printk("arg:0x%x byte\n",cmd_info->cmd->arg);
+	}
+#endif
+
+	cmd_info->byte_count = BYTE_CNT;     //rtk HW limite, one trigger 512 byte pass.
+	cmd_info->block_count =  cmd_info->data->blocks; //blk_cnt;
+	cmdcode = emmc_port->ops->chk_cmdcode(cmd_info->cmd);
+
+	err = SD_Stream_Cmd(cmdcode,cmd_info,0);
+
+	if(err == 0) {
+		if(host->card){
+			if( (cmd_info->cmd->opcode == 25) && (cmdcode == EMMC_AUTOWRITE2)) {
+				int stop_err;
+
+				stop_err = rtkemmc_stop_transmission(host->card,0);
+				if(stop_err) {
+					MMCPRINTF("rtkemmc_stop_transmission fail\n");
+					goto ERR_HANDLE;
+				}
+			}
+		}
+
+		cmd_info->data->bytes_xfered += dma_leng;
+	}
+	else {
+ERR_HANDLE:
+#if 0
+		//TBD
+		if(rtkemmc_err_handle(cmdcode,cmd_info)){
+			if(cmd_info->cmd->opcode == 18 || cmd_info->cmd->opcode == 25) {
+				if(host->card){
+					int stop_err;
+					stop_err = rtkemmc_stop_transmission(host->card,0);
+					if(stop_err)
+						MMCPRINTF("rtkemmc_stop_transmission fail\n");
+
+					rtkemmc_wait_status(host->card,STATE_TRAN,0,0);
+				}
+			}
+			else
+				mmcmsg3(KERN_INFO "%s: error recover fail 4\n", DRIVER_NAME);
+		}
+#else
+		printk(KERN_ERR "SD_Stream error...\n");
+#endif
+	}
+
+	dma_unmap_sg( mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len, dir);
+
+#ifdef RTKMMEC_DMA_DEBUG
+	rtkemmc_dma_debug(cmd_info);
+#endif
+
+	return err;
+}
+#else
+static void duplicate_pkt(struct sd_cmd_pkt* sour,struct sd_cmd_pkt* dist)
+{
+	dist->emmc_port      = sour->emmc_port;
+	dist->cmd         = sour->cmd;
+	dist->data        = sour->data;
+
+	dist->dma_buffer  = sour->dma_buffer;
+	dist->byte_count  = sour->byte_count;
+	dist->block_count = sour->block_count;
+
+	dist->flags       = sour->flags;
+	dist->rsp_len     = sour->rsp_len;
+	dist->timeout     = sour->timeout;
+}
+
+static int SD_Stream(struct sd_cmd_pkt *cmd_info)
+{
+	int err=0;
+	u32 i;
+	struct scatterlist *sg;
+	u32 dir = 0;
+	u32 dma_nents = 0;
+	u32 dma_leng;
+	u32 dma_addr;
+	u32 dma_addr_sys = 0;
+	u32 old_arg;
+	u8 one_blk=0;
+	u8 f_in_dma = 0;
+	u16 cmdcode = 0;
+	unsigned long flags;
+
+	struct mmc_host *host = cmd_info->emmc_port->mmc;
+	struct rtkemmc_host *emmc_port = cmd_info->emmc_port;
+
+	rtkemmc_set_rspparam(emmc_port, cmd_info);   //for 119x
+
+	if(cmd_info->data->flags & MMC_DATA_READ){
+		dir = DMA_FROM_DEVICE;
+	}else{
+		dir = DMA_TO_DEVICE;
+	}
+
+	cmd_info->data->bytes_xfered=0;
+	dma_nents = dma_map_sg( mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len,  dir);
+	sg = cmd_info->data->sg;
+
+	old_arg=cmd_info->cmd->arg;
+
+	for(i=0; i<dma_nents; i++,sg++){
+		dma_leng = sg_dma_len(sg);
+
+		if(dma_leng & 0x1ff){
+			dma_addr_sys = sg_dma_address(sg);
+
+			if(emmc_port->tmp_buf){    //use tmp buffer
+				f_in_dma = 1;
+				dma_addr = emmc_port->tmp_buf_phy_addr;
+			}else{                  //use default buffer
+				dma_addr = dma_addr_sys;
+			}
+		}else{
+			dma_addr = sg_dma_address(sg);
+		}
+
+		if(one_blk){    /* occur at write case only */
+			u8 i;
+			u32 blk_cnt;
+			struct sd_cmd_pkt tmp_pkt;
+
+			blk_cnt = dma_leng/BYTE_CNT;
+			if(blk_cnt == 0){
+				WARN_ON(1);
+				blk_cnt = 1;
+			}
+			duplicate_pkt(cmd_info,&tmp_pkt);
+
+			tmp_pkt.byte_count  = BYTE_CNT;
+			tmp_pkt.block_count = 1;
+			tmp_pkt.dma_buffer  = (unsigned char *)dma_addr;
+
+			if(tmp_pkt.cmd->opcode == 25){
+				tmp_pkt.cmd->opcode = 24;
+			}
+
+			if(tmp_pkt.cmd->opcode == 18){
+				tmp_pkt.cmd->opcode = 17;
+			}
+
+			cmdcode = emmc_port->ops->chk_cmdcode(tmp_pkt.cmd);
+			for(i=0;i<blk_cnt;i++){
+				err = SD_Stream_Cmd(cmdcode,&tmp_pkt,0);
+
+				if(err == 0){
+					if(host->card && mmc_card_blockaddr(host->card))
+						tmp_pkt.cmd->arg += 1;
+					else
+						tmp_pkt.cmd->arg += BYTE_CNT;
+
+					tmp_pkt.dma_buffer += BYTE_CNT;
+					tmp_pkt.data->bytes_xfered += BYTE_CNT;
+				}else{
+					//TBD
+					mmcmsg3(KERN_INFO "%s: unknown fail 2\n", DRIVER_NAME);
+					break;
+				}
+			}
+		}
+		else {
+			u32 blk_cnt;
+			cmd_info->byte_count = BYTE_CNT;     //rtk HW limite, one trigger 512 byte pass.
+			blk_cnt = dma_leng/BYTE_CNT;
+
+			if(blk_cnt == 0 && dma_leng){
+				blk_cnt = 1;
+			}
+
+			cmd_info->block_count = blk_cnt;
+			cmd_info->dma_buffer = (unsigned char *)dma_addr;
+
+			cmdcode = emmc_port->ops->chk_cmdcode(cmd_info->cmd);
+			err = SD_Stream_Cmd(cmdcode,cmd_info,0);
+
+			if(err == 0){
+				if(host->card){
+					if( (cmd_info->cmd->opcode == 25) && (cmdcode == EMMC_AUTOWRITE2) ) {
+						int stop_err;
+
+						stop_err = rtkemmc_stop_transmission(host->card,0);
+						if(stop_err){
+							MMCPRINTF("rtkemmc_stop_transmission fail\n");
+							goto ERR_HANDLE;
+						}
+					}
+				}
+
+				if(host->card && mmc_card_blockaddr(host->card))
+					cmd_info->cmd->arg += cmd_info->block_count;
+				else
+					cmd_info->cmd->arg += dma_leng;
+
+				cmd_info->data->bytes_xfered += dma_leng;
+			}else{
+ERR_HANDLE:
+#if 0
+				if(rtkemmc_err_handle(cmdcode,cmd_info)){
+					if(cmd_info->cmd->opcode == 18 || cmd_info->cmd->opcode == 25) {
+						if(host->card){
+							int stop_err;
+							stop_err = rtkemmc_stop_transmission(host->card,0);
+							if(stop_err){
+								MMCPRINTF("rtkemmc_stop_transmission fail\n");
+								//goto ERR_HANDLE;
+							}
+							rtkemmc_wait_status(host->card,STATE_TRAN,0,0);
+						}
+					}else{
+						mmcmsg3(KERN_INFO "%s: error recover fail 4\n", DRIVER_NAME);
+					}
+				}
+#else
+				printk(KERN_ERR "SD Stream error!!!\n");
+#endif
+			}
+		}
+		if(err){
+			cmd_info->cmd->arg = old_arg;
+			break;
+		}
+
+		if(f_in_dma){
+			u32 i;
+			u8 * ptr1 = phys_to_virt(dma_addr_sys);
+			u8 * ptr2 = phys_to_virt(dma_addr);
+			f_in_dma = 0;
+			for(i=0; i<dma_leng;i++)
+				*ptr1 = *ptr2;
+		}
+	}
+
+	dma_unmap_sg( mmc_dev(host), cmd_info->data->sg, cmd_info->data->sg_len,  dir);
+
+	return err;
+}
+#endif
+
+static void rtkemmc_send_command(struct rtkemmc_host *emmc_port, struct mmc_command *cmd)
+{
+	int rc = 0;
+	struct sd_cmd_pkt cmd_info;
+	MMCPRINTF("%s \n", __func__);
+
+	memset(&cmd_info, 0, sizeof(struct sd_cmd_pkt));
+
+	if ( !emmc_port || !cmd ){
+		printk(KERN_ERR "%s: emmc_port or cmd is null\n",DRIVER_NAME);
+		return ;
+	}
+
+	cmd_info.cmd    = cmd;
+	cmd_info.emmc_port = emmc_port;
+	if (cmd->data) {
+		cmd_info.data = cmd->data;
+		if(cmd->data->flags == MMC_DATA_READ){
+			MMCPRINTF("%s MMC_DATA_READ\n", __func__);	/* do nothing */
+		}else if(cmd->data->flags == MMC_DATA_WRITE){
+			MMCPRINTF("%s MMC_DATA_WRITE\n", __func__);
+			if(emmc_port->wp ==1){
+				printk(KERN_WARNING "%s: card is locked!", DRIVER_NAME);
+				rc = -1;
+				cmd->retries = 0;
+				goto err_out;
+			}
+		}else{
+			printk(KERN_ERR "error: cmd->data->flags=%d\n", cmd->data->flags);
+			cmd->error = -MMC_BLK_CMD_ERR;
+			cmd->retries = 0;
+			goto err_out;
+		}
+		if (g_bTuning)
+			MMCPRINTF("................[%s:HS200] still tuning.............. \n",DRIVER_NAME);
+		rc = SD_Stream(&cmd_info);
+	}
+	else {
+		if (g_bTuning)
+			MMCPRINTF("................[%s:HS200] still tuning.............. \n",DRIVER_NAME);
+		rc = SD_SendCMDGetRSP(&cmd_info,0);
+	}
+
+	if(cmd->opcode == MMC_SWITCH){
+		if((cmd->arg & 0xffff00ff) == 0x03b30001) {
+			if((cmd->arg & 0x0000ff00)==0)
+				emmc_port->rtflags |= RTKCR_USER_PARTITION;
+			else
+				emmc_port->rtflags &= ~RTKCR_USER_PARTITION;
+		}
+	}
+	MMCPRINTF("%s: cmd->opcode=0x%02x finish !!\n",__func__,cmd->opcode);
+err_out:
+
+	if (rc){
+		if(rc == -RTK_RMOV)
+			cmd->retries = 0;
+		cmd->error = -MMC_BLK_CMD_ERR;
+	}
+	rtkemmc_req_end_tasklet((unsigned long)emmc_port);
+}
+
+static void rtkemmc_request(struct mmc_host *host, struct mmc_request *mrq)
+{
+	struct rtkemmc_host *emmc_port;
+	struct mmc_command *cmd;
+#if defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	int cmdq_disable=0;
+	struct cmdq_host *cq_host = (struct cmdq_host *)mmc_cmdq_private(host);
+	int retry=0;
+#endif
+#if defined(CONFIG_MMC_RTK_EMMC_PON)
+	bool cmd_continuous = false;
+#endif
+
+	MMCPRINTF("%s \n", __func__);
+	emmc_port = mmc_priv(host);
+	BUG_ON(emmc_port->mrq != NULL);
+
+#if defined(CONFIG_MMC_RTK_EMMC_PON)
+	if(mrq->cmd->opcode==MMC_GO_IDLE_STATE)		//in Hank PON environment, rom code might occuppy the semaphore, so we release the semaphore of command 0 first
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+EMMC_HD_SEM);
+
+	if(mrq->cmd->opcode==MMC_SEND_STATUS &&
+		(emmc_pre_cmd==MMC_SWITCH || emmc_pre_cmd==MMC_STOP_TRANSMISSION ||
+		emmc_pre_cmd==MMC_ERASE || emmc_pre_cmd==MMC_WRITE_MULTIPLE_BLOCK))	//force cmd13 cannot be separated with cmd 6, 12, 38, 25
+		cmd_continuous = true;
+	else if(mrq->cmd->opcode==MMC_ERASE || mrq->cmd->opcode==MMC_ERASE_GROUP_END)	//cmd 36, 38 we do not need to occupy the semaphore
+		cmd_continuous = true;
+	if(cmd_continuous == false && partition_pon_sem==false) {		//we need to occupy the semaphore
+		while(1) {
+			if(readl(emmc_port->emmc_membase+EMMC_HD_SEM)==1) break;
+			else {
+				printk(KERN_INFO "%s: Pon is occupying the semaphore, emmc opcode=%d, emmc argument=0x%x, \
+					pon opcode=%d, pon argument=0x%x, 0x98012030=0x%x, 0x98012032=0x%x, 0x9801203c=0x%x, 0x98012814=0x%x, 0x98012818=0x%x\n",
+					__func__, mrq->cmd->opcode, mrq->cmd->arg,
+					CMD_IDX_MASK(readl(emmc_port->emmc_membase+EMMC_CMD_R)), readl(emmc_port->emmc_membase+EMMC_ARGUMENT_R),
+					readw(emmc_port->emmc_membase+0x30), readw(emmc_port->emmc_membase+0x32),
+					readw(emmc_port->emmc_membase+0x3c), readl(emmc_port->emmc_membase+0x814), readl(emmc_port->emmc_membase+0x818));
+				usleep_range(10, 30);
+			}
+		}
+	}
+#endif
+
+#if defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	if(cq_host->enabled==true) {
+#ifdef RTKEMMC_DEBUG
+		printk(KERN_INFO "currently is under cqe mode and back to normal mode for the time being, mrq->cmd->opcode=%d...\n", mrq->cmd->opcode);
+#endif
+		mmc_cmdq_halt(host, true);
+
+		while(readl(emmc_port->emmc_membase+EMMC_CQTDBR)!=0 && (++retry)<=100) {
+			printk(KERN_INFO "wait until DBR register 0, current DBR= 0x%x\n", readl(emmc_port->emmc_membase+EMMC_CQTDBR));
+		}
+		if(retry>100) printk(KERN_ERR "register DBR=0x%x before disabling cmdq!!!\n", readl(emmc_port->emmc_membase+EMMC_CQTDBR));
+
+		rtkemmc_cmdq_disable(host, true);
+		cmdq_disable=1;
+	}
+#endif
+
+#if 1
+	if(mrq->cmd->opcode==MMC_SEND_EXT_CSD)
+	{
+		//====we add the following program becasue we need to read HS400 parameter in specific emmc block in SDR50 mode if exists====
+		//hs400 mode case, we need to eliminate the tuning process, so we read the dqs, phase data from offset that bootcode provided
+		if((host->caps2 & MMC_CAP2_HS400_1_8V) && emmc_port->dqs_tuning==1 && emmc_port->emmc_tuning_addr!=0)    //bootcode doesn't do the hs400 tuning
+		{
+			int hs400_data[128]={0};        //4 bytes header, 33aa, 4 bytes for TX, 4 bytes for RX, 4 bytes for dqs
+			rtkemmc_send_cmd18(emmc_port, 512, emmc_port->emmc_tuning_addr/512+1024);       //we put the hs400 parameter data before tuning blk addr 1 block
+			memcpy(hs400_data, gddr_dma_org, 512);
+
+			printk(KERN_ERR "before cmd8, read dqs_data from emmc first for later usage: hs400_header=0x%x, hs400_TX=0x%x, hs400_RX=0x%x, hs400_dqs=0x%x\n",
+				hs400_data[0], hs400_data[1], hs400_data[2], hs400_data[3]);
+
+			if(hs400_data[0]==0x33aa) {     //inherit from emmc saved data instead of bootcode
+				emmc_port->dqs_tuning=0;
+				emmc_port->tx_tuning = 0;
+				emmc_port->rx_tuning = 0;
+
+				HS200_TX = VP0_saved = hs400_data[1];
+				HS200_RX = VP1_saved = hs400_data[2];
+				dqs_saved = hs400_data[3];
+
+				if(emmc_port->tx_user_defined) {        //if we set user defined tx and rx value, then we won't use the bootcode reference value, always the first priority
+					printk(KERN_ERR "tx_user_defined has been set, we still use user define value for usage\n");
+					HS200_TX = VP0_saved = emmc_port->tx_reference_phase;
+				}
+				if(emmc_port->rx_user_defined) {
+					printk(KERN_ERR "rx_user_defined has been set, we still use user define value for usage\n");
+					HS200_RX = VP1_saved = emmc_port->rx_reference_phase;
+				}
+			}
+		}
+	}
+#endif
+	down_write(&cr_rw_sem);
+	cmd = mrq->cmd;
+	emmc_port->mrq = mrq;
+
+	if (!(emmc_port->rtflags & RTKCR_FCARD_DETECTED)){
+		cmd->error = -MMC_BLK_NOMEDIUM;
+		cmd->retries = 0;
+		goto done;
+	}
+
+#if defined(CONFIG_MMC_RTK_EMMC_PON)
+        if(mrq->cmd->opcode==MMC_SLEEP_AWAKE ||
+		(mrq->cmd->opcode==MMC_SELECT_CARD && mrq->cmd->arg==0x0) ||
+		(mrq->cmd->opcode==MMC_SWITCH && mrq->cmd->arg==0x03220301)) {
+		goto done;
+	}
+#endif
+	if ( emmc_port && cmd ){
+		rtkemmc_allocate_dma_buf(emmc_port, cmd);
+		rtkemmc_send_command(emmc_port, cmd);
+	}else{
+done:
+		rtkemmc_req_end_tasklet((unsigned long)emmc_port);
+	}
+	up_write(&cr_rw_sem);
+#if defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	if(cq_host->enabled==false && cmdq_disable==1) {
+		rtkemmc_cmdq_enable(host);
+		mmc_cmdq_halt(host, false);
+        }
+#endif
+
+#if defined(CONFIG_MMC_RTK_EMMC_PON)
+	if(mrq->cmd->opcode!=MMC_ERASE_GROUP_START && mrq->cmd->opcode!=MMC_ERASE_GROUP_END &&  mrq->cmd->opcode!=MMC_ERASE
+		&& mrq->cmd->opcode!=MMC_SWITCH && mrq->cmd->opcode!=MMC_STOP_TRANSMISSION
+		&& mrq->cmd->opcode!=MMC_WRITE_MULTIPLE_BLOCK && partition_pon_sem==false)  //cmd 35, 36, 38, 6, 12, 25 does not release the semaphore
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+EMMC_HD_SEM);
+	else if(mrq->cmd->opcode==MMC_SWITCH && mrq->cmd->arg==0x03220301 && partition_pon_sem==false) {
+		printk(KERN_ERR "S5 under PON force cmd 6 release semaphore\n");
+		rtkemmc_writel(0x0, emmc_port->emmc_membase+EMMC_HD_SEM);
+        }
+
+	emmc_pre_cmd = mrq->cmd->opcode;
+#endif
+
+#if 0
+	if(cmd_resend==1) {
+		cmd_resend=0;
+		down_speed_handling(emmc_port);
+	}
+#endif
+}
+
+static ssize_t emmc_info_dev_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct mmc_host * host = dev_get_drvdata(dev);
+	struct rtkemmc_host *emmc_port = mmc_priv(host);
+
+	printk(KERN_INFO "%s(%u)\n",__func__,__LINE__);
+
+	return sprintf(buf, "EMMC SYS_PLL_EMMC1=0x%08x SYS_PLL_EMMC2=0x%08x \nSYS_PLL_EMMC3=0x%08x SYS_PLL_EMMC4=0x%08x HOST_CONTROL2_REG=0x%08x\n \
+				PRESENT_STATE_REG=0x%08x  HOST CONTROL1 REG=0x%08x TRANSFER_MODE_REG=0x%08x \n EMMC_CKGEN_CTL=0x%08x EMMC_DQS_CTRL1=0x%08x \n",
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC1),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC2),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC3),
+				readl(emmc_port->crt_membase + SYS_PLL_EMMC4),
+				readw(emmc_port->emmc_membase+EMMC_HOST_CTRL2_R),
+				readl(emmc_port->emmc_membase+EMMC_PSTATE_REG),
+				readb(emmc_port->emmc_membase+EMMC_HOST_CTRL1_R),
+				readw(emmc_port->emmc_membase+EMMC_XFER_MODE_R),
+				readl(emmc_port->emmc_membase+EMMC_CKGEN_CTL),
+				readl(emmc_port->emmc_membase+EMMC_DQS_CTRL1));
+
+}
+
+static ssize_t emmc_info_dev_store(struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+	printk(KERN_ERR "%s(%u)Nothing to do\n",__func__,__LINE__);
+
+	/* return value must be equare or big then "count" to finish this attribute */
+	return count;
+}
+DEVICE_ATTR(emmc_info, S_IRUGO | S_IWUSR,
+		emmc_info_dev_show,emmc_info_dev_store);
+
+static int rtkemmc_probe(struct platform_device *pdev)
+{
+	struct mmc_host *mmc = NULL;
+	struct rtkemmc_host *emmc_port = NULL;
+	int ret = 0, irq = 0;
+	int att_err;
+	const u32 *prop;
+	int size,speed_step=0;
+	struct device_node *emmc_node = NULL;
+	int i;
+	int counter=0;
+	emmc_node = pdev->dev.of_node;
+
+	if (!emmc_node)
+		printk(KERN_ERR "%s : No emmc of_node found\n",DRIVER_NAME);
+	else
+		printk(KERN_ERR "%s : emmc of_node found\n",DRIVER_NAME);
+
+	mmc = mmc_alloc_host(sizeof(struct rtkemmc_host), &pdev->dev);
+
+	if (!mmc) {
+		ret = -ENOMEM;
+		goto out;
+	}
+
+	mmc_host_local = mmc;
+
+	emmc_port = mmc_priv(mmc);
+	memset(emmc_port, 0, sizeof(struct rtkemmc_host));
+	emmc_port->mmc = mmc;
+	emmc_port->dev = &pdev->dev;
+	emmc_port->ops = &emmc_ops;
+
+	sema_init(&emmc_port->sem,1);
+	sema_init(&emmc_port->sem_op_end,1);
+
+	//att_err = device_create_file(&pdev->dev, &dev_attr_cr_send_cmd0);
+	//att_err = device_create_file(&pdev->dev, &dev_attr_cr_fast_RW);
+	//att_err = device_create_file(&pdev->dev, &dev_attr_em_open_log);
+	att_err = device_create_file(&pdev->dev, &dev_attr_emmc_info);
+
+	irq = irq_of_parse_and_map(emmc_node, 0);
+	if (irq <= 0) {
+                printk(KERN_ERR "%s : fail to parse of irq.\n",DRIVER_NAME);
+                return -ENXIO;
+	}
+	MMCPRINTF(KERN_INFO "%s : IRQ = 0x%08x\n",DRIVER_NAME, irq);
+
+	emmc_port->emmc_membase = of_iomap(emmc_node, 0);
+	emmc_port->crt_membase = of_iomap(emmc_node, 1);
+	emmc_port->sb2_membase = of_iomap(emmc_node, 2);
+	emmc_port->mux_mis_membase = of_iomap(emmc_node, 3);
+	emmc_port->iso_blk_membase = of_iomap(emmc_node, 4);
+	emmc_port->m2tmx_membase = of_iomap(emmc_node, 5);
+
+#if defined(CONFIG_MMC_RTK_EMMC_PON)
+	emmc_port->norst_membase = of_iomap(emmc_node, 6);
+
+	emmc_port->emmc_pon_gpio = of_get_gpio_flags(emmc_node, 0, NULL);
+	if (gpio_is_valid(emmc_port->emmc_pon_gpio)) {
+		ret = gpio_request(emmc_port->emmc_pon_gpio, "emmc_pon_gpio");
+		if (ret < 0)
+			printk(KERN_ERR "%s: can't request emmc_pon_gpio %d\n", __func__, emmc_port->emmc_pon_gpio);
+	} else {
+		printk(KERN_ERR "%s: gpio %d is not valid\n", __func__, emmc_port->emmc_pon_gpio);
+	}
+
+	emmc_port->emmc_pon_toggle_gpio = of_get_gpio_flags(emmc_node, 1, NULL);
+	if (gpio_is_valid(emmc_port->emmc_pon_toggle_gpio)) {
+		ret = gpio_request(emmc_port->emmc_pon_toggle_gpio, "emmc_pon_toggle_gpio");
+		if (ret < 0)
+			printk(KERN_ERR "%s: can't request emmc_pon_toggle_gpio %d\n", __func__, emmc_port->emmc_pon_toggle_gpio);
+	} else {
+		printk(KERN_ERR "%s: gpio %d is not valid\n", __func__, emmc_port->emmc_pon_toggle_gpio);
+	}
+#endif
+	prop = of_get_property(pdev->dev.of_node, "speed-step", &size);
+	if (prop) {
+		speed_step = of_read_number(prop, 1);
+		printk(KERN_INFO "[%s] get speed-step : %d \n",__func__,speed_step);
+	} else {
+		printk(KERN_ERR "[%s] get speed-step error !!\n",__func__);
+	}
+	prop = of_get_property(pdev->dev.of_node, "pddrive_nf_s0", &size);
+	if (prop) {
+		if (size)
+			counter = size / sizeof(u32);
+
+		for (i=0; i<counter; i+=1) {
+			pddrive_nf_s0[i]= of_read_number(prop, 1 + i);
+			/* KERN_ERR to let be happy */
+			if(speed_step==0) printk(KERN_ERR "[%s] get driving s0 : 0x%x\n",__func__,pddrive_nf_s0[i]);
+		}
+	} else {
+		printk(KERN_INFO "[%s] no driving nf_s0 warning !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "pddrive_nf_s1", &size);
+	if (prop) {
+		if (size)
+			counter = size / sizeof(u32);
+
+		for (i=0; i<counter; i+=1) {
+			pddrive_nf_s1[i]= of_read_number(prop, 1 + i);
+			/* KERN_ERR to let be happy */
+			if(speed_step==1) printk(KERN_ERR "[%s] get driving s1 : 0x%x\n",__func__,pddrive_nf_s1[i]);
+		}
+	} else {
+		printk(KERN_INFO "[%s] no driving nf_s1 warning !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "pddrive_nf_s2", &size);
+	if (prop) {
+		if (size)
+			counter = size / sizeof(u32);
+
+		for (i=0; i<counter; i+=1) {
+			pddrive_nf_s2[i]= of_read_number(prop, 1 + i);
+			/* KERN_ERR to let be happy */
+			if(speed_step==2) printk(KERN_ERR "[%s] get driving s2 : 0x%x\n",__func__,pddrive_nf_s2[i]);
+		}
+	} else {
+		printk(KERN_INFO "[%s] no driving nf_s2 warning !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "pddrive_nf_s3", &size);
+        if (prop) {
+                if (size)
+                        counter = size / sizeof(u32);
+
+                for (i=0; i<counter; i+=1) {
+                        pddrive_nf_s3[i]= of_read_number(prop, 1 + i);
+                        /* KERN_ERR to let be happy */
+                        if(speed_step==3) printk(KERN_ERR "[%s] get driving s3 : 0x%x\n",__func__,pddrive_nf_s3[i]);
+                }
+        } else {
+                printk(KERN_INFO "[%s] no driving nf_s3 warning !! \n",__func__);
+        }
+
+	prop = of_get_property(pdev->dev.of_node, "phase_tuning", &size);
+	if (prop) {
+		emmc_port->tx_tuning = of_read_number(prop, 1);
+		emmc_port->rx_tuning = of_read_number(prop, 2);
+		printk(KERN_ERR "[%s] get tx tuning switch : %u\n",__func__, emmc_port->tx_tuning);
+		printk(KERN_ERR "[%s] get rx tuning switch : %u\n",__func__, emmc_port->rx_tuning);
+	} else {
+		emmc_port->tx_tuning = 1;	//if we do not get this node in device tree, we should tune phase by kernel
+		emmc_port->rx_tuning = 1;
+		printk(KERN_INFO "[%s] no phase_tuning switch node !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "dqs_tuning", &size);
+	if (prop) {
+		emmc_port->dqs_tuning = of_read_number(prop, 1);
+		printk(KERN_ERR "[%s] get dqs tuning switch : %u\n",__func__, emmc_port->dqs_tuning);
+	} else {
+		emmc_port->dqs_tuning = 1;	//if we do not get this node, we should tune dqs value by kernel
+		printk(KERN_INFO "[%s] no dqs_tuning switch node !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "reference_phase", &size);
+	if (prop) {
+		emmc_port->tx_user_defined = of_read_number(prop, 1);
+		emmc_port->tx_reference_phase = of_read_number(prop, 2);
+		emmc_port->rx_user_defined = of_read_number(prop, 3);
+		emmc_port->rx_reference_phase = of_read_number(prop, 4);
+		if(emmc_port->tx_user_defined) printk(KERN_ERR "[%s] get User defined tx reference phase: %u\n",__func__, emmc_port->tx_reference_phase);
+		if(emmc_port->rx_user_defined) printk(KERN_ERR "[%s] get User defined rx reference phase: %u\n",__func__, emmc_port->rx_reference_phase);
+	} else {
+		emmc_port->tx_user_defined = 0;
+		emmc_port->tx_reference_phase = 0x0;
+		emmc_port->rx_user_defined = 0;
+		emmc_port->rx_reference_phase = 0x0;
+		printk(KERN_INFO "[%s] no tx & rx reference phase switch node !! \n",__func__);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "dqs_dly_tape", &size);
+        if (prop) {
+                emmc_port->dqs_dly_tape = of_read_number(prop, 1);
+                printk(KERN_ERR "[%s] get dqs_dly_tape : %u\n",__func__, emmc_port->dqs_dly_tape);
+        } else {
+                emmc_port->dqs_dly_tape = 0x0;      //use 0x0 as default
+                printk(KERN_INFO "[%s] no dqs_dly_tape switch node, use default 0x0 !! \n",__func__);
+        }
+
+	prop = of_get_property(pdev->dev.of_node, "emmc_tuning_addr", &size);
+	if (prop) {
+		emmc_port->emmc_tuning_addr = of_read_number(prop, 1);
+		printk(KERN_ERR "[%s] GPT format: emmc tuning offset start from 0x%lx\n",__func__, emmc_port->emmc_tuning_addr);
+	} else {
+		prop = of_get_property(pdev->dev.of_node, "mbr_tuning_addr", &size);
+		if (prop) {
+			emmc_port->emmc_tuning_addr = of_read_number(prop, 1);      //if we do not get this node, we assume that the system uses MBR mode before Android O
+			printk(KERN_ERR "[%s] MBR format: emmc tuning offset start from 0x%x\n\n",__func__, emmc_port->emmc_tuning_addr);
+		}
+		else {
+			emmc_port->emmc_tuning_addr = 0x9a0e00; //use default value in the factory partition end block addr - 1025 blocks
+			printk(KERN_ERR "[%s] Use Default tuning addr: emmc tuning offset start from 0x%x\n\n",__func__, emmc_port->emmc_tuning_addr);
+		}
+	}
+#if defined(CONFIG_MMC_RTK_EMMC_PON)
+	prop = of_get_property(pdev->dev.of_node, "pon_addr", &size);
+	if (prop) {
+		emmc_port->pon_addr = of_read_number(prop, 1);
+		emmc_port->pon_addr = emmc_port->pon_addr / 0x200;
+		printk(KERN_ERR "[%s] pon address starts from 0x%lx\n",__func__, emmc_port->pon_addr);
+	} else {
+		emmc_port->pon_addr = 0;      //if we do not get this node, we assume that the system uses MBR mode before Android O
+		printk(KERN_INFO "[%s] No pon address node, emmc_port->pon_addr = 0 !! \n",__func__);
+	}
+#endif
+
+#if defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	rtkemmc_cmdq_init(emmc_port->cq_host, mmc, 0);  //allocate cq_host and realtek always uses ADMA 32 bit address
+#endif
+	rstc_emmc = devm_reset_control_get(&pdev->dev, NULL);
+	if (IS_ERR(rstc_emmc)) {
+		printk(KERN_WARNING "%s: reset_control_get() returns %ld\n", __func__,
+			PTR_ERR(rstc_emmc));
+		rstc_emmc = NULL;
+	}
+
+	clk_en_emmc = devm_clk_get(&pdev->dev, "emmc");
+	if (IS_ERR(clk_en_emmc)) {
+		printk(KERN_WARNING "%s: clk_get() returns %ld\n", __func__,
+			PTR_ERR(clk_en_emmc));
+		clk_en_emmc = NULL;
+	}
+	clk_en_emmc_ip = devm_clk_get(&pdev->dev, "emmc_ip");
+	if (IS_ERR(clk_en_emmc_ip)) {
+		printk(KERN_WARNING "%s: clk_get() returns %ld\n", __func__,
+			PTR_ERR(clk_en_emmc_ip));
+		clk_en_emmc_ip = NULL;
+	}
+	clk_prepare_enable(clk_en_emmc);
+	clk_prepare_enable(clk_en_emmc_ip);
+
+	rtkemmc_writel(readl(emmc_port->crt_membase+0x454)|0x1, emmc_port->crt_membase+0x454);
+
+	mmc->ocr_avail = MMC_VDD_30_31 
+			| MMC_VDD_31_32
+			| MMC_VDD_32_33
+			| MMC_VDD_33_34
+			| MMC_VDD_165_195;
+
+	mmc->caps = MMC_CAP_4_BIT_DATA
+		| MMC_CAP_8_BIT_DATA
+		| MMC_CAP_SD_HIGHSPEED
+		| MMC_CAP_MMC_HIGHSPEED
+		| MMC_CAP_NONREMOVABLE
+		| MMC_CAP_1_8V_DDR
+		| MMC_CAP_UHS_DDR50
+		| MMC_CAP_CMD23
+		| MMC_CAP_ERASE;
+
+	mmc->caps2 = (MMC_CAP2_NO_SDIO | MMC_CAP2_NO_SD);
+	switch(speed_step)
+	{
+	case 0: //sdr50
+		mmc->caps &= ~(MMC_CAP_UHS_DDR50|MMC_CAP_1_8V_DDR);
+		mmc->caps2 &= ~(MMC_CAP2_HS200_1_8V_SDR);
+		break;
+	case 1: //ddr50
+		mmc->caps2 &= ~(MMC_CAP2_HS200_1_8V_SDR);
+		break;
+	case 2: //hs200
+		mmc->caps2 |= MMC_CAP2_HS200_1_8V_SDR;
+		break;
+	case 3: //hs400
+		mmc->caps2 |= (MMC_CAP2_HS200_1_8V_SDR|MMC_CAP2_HS400_1_8V);
+		break;
+	}
+
+	if(rtk_emmc_bus_wid == 4 || rtk_emmc_bus_wid == 5)
+		mmc->caps &= ~MMC_CAP_8_BIT_DATA;
+
+#if defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	mmc->caps2 |= MMC_CAP2_CMD_QUEUE;
+#endif
+	mmc->caps2 |= MMC_CAP2_HC_ERASE_SZ;
+	mmc->f_min = 300000;        //300K
+	mmc->f_max = 400000000; //400M
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	mmc->max_segs = 1;
+#else
+	mmc->max_segs = 256;	//the max number of nodes in the scatterlist
+#endif
+	mmc->max_blk_size   = 512;
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	mmc->max_blk_count  = 0x400; //0x400;
+#else
+	mmc->max_blk_count  = 0x800;
+#endif
+	mmc->max_seg_size   = mmc->max_blk_size * mmc->max_blk_count;
+	mmc->max_req_size   = mmc->max_blk_size * mmc->max_blk_count;
+
+	spin_lock_init(&emmc_port->lock);
+	init_rwsem(&cr_rw_sem);
+	tasklet_init(&emmc_port->req_end_tasklet, rtkemmc_req_end_tasklet, (unsigned long)emmc_port);
+
+	//Force enable dbg log
+#ifdef MMC_DBG
+	emmc_port->rtflags |= RTKCR_FOPEN_LOG;
+#endif
+
+	if(rtk_emmc_bus_wid == 9 || rtk_emmc_bus_wid == 5)
+		emmc_port->rtflags |= RTKCR_FOPEN_LOG;
+
+	if (!emmc_port->emmc_membase) {
+		printk(KERN_INFO "---- Realtek EMMC Controller Driver probe fail - nomem ----\n\n");
+		ret = -ENOMEM;
+		goto out;
+	}
+
+	rtkemmc_hold_int_dec();       /* hold status interrupt */
+	rtkemmc_clr_int_sta();
+	ret = request_irq(irq, rtkemmc_irq, IRQF_SHARED, DRIVER_NAME, emmc_port);   //rtkemmc_interrupt
+	if (ret) {
+		printk(KERN_ERR "%s: cannot assign irq %d\n", DRIVER_NAME, irq);
+		goto out;
+	} else
+		emmc_port->irq = irq;
+
+	setup_timer(&emmc_port->timer, rtkemmc_timeout_timer, (unsigned long)emmc_port);
+	emmc_port->ops->set_crt_muxpad(emmc_port);
+
+	if (emmc_port->ops->reset_card)
+		emmc_port->ops->reset_card(emmc_port);
+
+	emmc_port->ops->chk_card_insert(emmc_port);
+
+	platform_set_drvdata(pdev, mmc);
+	
+	ret = mmc_add_host(mmc);
+	if (ret)
+		goto out;
+
+	sync(emmc_port);
+	gCurrentBootMode = MODE_SDR;
+	g_crinit=0;
+	gPreventRetry=0;
+	g_bResuming=0;
+	g_bTuning=0;
+
+#ifdef RTK_EMMC_HEALTH_REPORT
+	mmc->wr_emmc_size_cnt = 0;
+	mmc->remainder = 0;
+#endif
+	printk(KERN_NOTICE "%s: %s driver initialized\n",
+	mmc_hostname(mmc), DRIVER_NAME);
+	return 0;
+
+out:
+	if (emmc_port) {
+		if (emmc_port->irq)
+			free_irq(emmc_port->irq, emmc_port);
+
+		if (emmc_port->emmc_membase)
+			iounmap(emmc_port->emmc_membase);
+		if (emmc_port->crt_membase)
+			iounmap(emmc_port->crt_membase);
+	}
+
+	if (mmc)
+		mmc_free_host(mmc);
+
+	return ret;
+}
+
+static int __exit rtkemmc_remove(struct platform_device *pdev)
+{
+	struct mmc_host *mmc = platform_get_drvdata(pdev);
+	MMCPRINTF("\n");
+
+	//device_remove_file(&pdev->dev, &dev_attr_cr_send_cmd0);
+	//device_remove_file(&pdev->dev, &dev_attr_cr_fast_RW);
+	//device_remove_file(&pdev->dev, &dev_attr_em_open_log);
+	device_remove_file(&pdev->dev, &dev_attr_emmc_info);
+
+#ifdef CONFIG_MMC_RTKEMMC_HK_ATTR
+	device_remove_file(&pdev->dev, &dev_attr_emmc_hacking);
+#endif
+
+	if (mmc) {
+		struct rtkemmc_host *emmc_port = mmc_priv(mmc);
+		flush_scheduled_work();
+		rtkemmc_free_dma_buf(emmc_port);
+		mmc_remove_host(mmc);
+		if(!mmc){
+			printk("eMMC host have removed.\n");
+			mmc_host_local = NULL;
+        	}
+		free_irq(emmc_port->irq, emmc_port);
+
+		del_timer_sync(&emmc_port->timer);
+		iounmap(emmc_port->emmc_membase);
+		iounmap(emmc_port->crt_membase);
+		iounmap(emmc_port->sb2_membase);
+		iounmap(emmc_port->mux_mis_membase);
+                iounmap(emmc_port->iso_blk_membase);
+                iounmap(emmc_port->m2tmx_membase);
+#if defined(CONFIG_MMC_RTK_EMMC_PON)
+		gpio_free(emmc_port->emmc_pon_gpio);
+#endif
+		release_resource(emmc_port->res);
+		mmc_free_host(mmc);
+	}
+	platform_set_drvdata(pdev, NULL);
+
+	return 0;
+}
+
+static const struct of_device_id rtkemmc_ids[] = {
+        { .compatible = "Realtek,rtk13xx-emmc" },
+        { /* Sentinel */ },
+};
+MODULE_DEVICE_TABLE(of, rtkemmc_ids);
+
+/**************************************************/
+/* driver / device attache area                   */
+/**************************************************/
+static struct platform_driver rtkemmc_driver = {
+	.probe      = rtkemmc_probe,
+	.remove     = __exit_p(rtkemmc_remove),
+	.driver     =
+	{
+		.name   = "rtkemmc",
+		.owner  = THIS_MODULE,
+		.of_match_table = of_match_ptr(rtkemmc_ids),
+#ifdef CONFIG_PM
+		.pm     = &rtk_dev_pm_ops
+#endif
+	},
+	.shutdown   = rtkemmc_shutdown,
+};
+#if 0
+static void rtkemmc_display_version (void)
+{
+	const __u8 *revision;
+	const __u8 *date;
+	const __u8 *time;
+	char *running = (__u8 *)VERSION;
+
+	strsep(&running, " ");
+	strsep(&running, " ");
+	revision = strsep(&running, " ");
+	date = strsep(&running, " ");
+	time = strsep(&running, " ");
+	printk(BANNER " Rev:%s (%s %s)\n", revision, date, time);
+
+#ifdef CONFIG_MMC_BLOCK_BOUNCE
+	printk("%s: CONFIG_MMC_BLOCK_BOUNCE enable\n",DRIVER_NAME);
+#else
+	printk("%s: CONFIG_MMC_BLOCK_BOUNCE disable\n",DRIVER_NAME);
+#endif
+
+#ifdef CONFIG_SMP
+	printk("%s: ##### CONFIG_SMP alert!! #####\n",DRIVER_NAME);
+#else
+	printk("%s: ##### CONFIG_SMP disable!! #####\n",DRIVER_NAME);
+#endif
+}
+#endif
+static int rtkemmc_set_bus_width(char * buf){
+	/*
+	get eMMC bus width setting by bootcode parameter, like below
+	bootargs=console=ttyS0,115200 earlyprintk emmc_bus=8
+	the keyword is "emmc_bus"
+	the getted parameter is hex.
+        example:
+        emmc_bus=8
+	*/
+
+	rtkemmc_chk_param(&rtk_emmc_bus_wid,1,buf+1);
+	printk("%s: setting bus width is %u-bit\n", DRIVER_NAME,rtk_emmc_bus_wid);
+	return 0;
+}
+module_platform_driver(rtkemmc_driver);
+
+MODULE_AUTHOR("Jim Tsai");
+MODULE_DESCRIPTION("Realtek EMMC Host Controller driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtkemmc");
+
+__setup("emmc_bus",rtkemmc_set_bus_width);
diff --git a/drivers/mmc/host/rtkemmc_rtd13xx.h b/drivers/mmc/host/rtkemmc_rtd13xx.h
new file mode 100644
index 00000000..2f4bc1d
--- /dev/null
+++ b/drivers/mmc/host/rtkemmc_rtd13xx.h
@@ -0,0 +1,319 @@
+/*
+ *  Copyright (C) 2010 Realtek Semiconductors, All Rights Reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __RTKEMMC_H
+#define __RTKEMMC_H
+
+#include "reg_mmc_rtd13xx.h"               
+#include "mmc_debug.h"               
+
+#define EMMC_MAX_SCRIPT_BLK   128
+
+//debug
+//#define MMC_DBG
+#ifdef MMC_DBG
+#define MMCPRINTF(fmt, args...)   printk(fmt,## args)
+#else
+#define MMCPRINTF(fmt, args...)
+#endif
+
+/* cmd1 sector mode */
+#define MMC_SECTOR_ADDR		0x40000000
+
+
+/* rtflags */
+#define RTKCR_FCARD_DETECTED    (1<<0)      /* Card is detected */
+#define RTKCR_FOPEN_LOG         (1<<1)      /* open command log */
+#define RTKCR_USER_PARTITION    (1<<2)      /* card is working on normal partition */
+
+
+#define RED_BOLD "\033[31;1m"
+#define BLU_BOLD "\033[34;1m"
+#define YEL_BOLD "\033[33;1m"
+#define GRN_BOLD "\033[32;1m"
+#define CYAN_BOLD_ITALIC "\033[36;1;3m"
+#define RESET "\033[0;m"
+
+struct rtkemmc_host {
+	struct mmc_host     *mmc;           /* MMC structure */
+	u32                 rtflags;        /* Driver states */
+	u8                  ins_event;
+	u8                  cmd_opcode;
+
+	struct mmc_request  *mrq;            /* Current request */
+	u8                  wp;
+	struct rtk_host_ops *ops;
+	struct semaphore	sem;
+	struct semaphore	sem_op_end;
+
+	volatile void __iomem	*emmc_membase;
+	volatile void __iomem	*crt_membase;
+	volatile void __iomem	*sb2_membase;	
+	volatile void __iomem	*misc_membase;
+	volatile void __iomem   *sb2_debug_membase;
+	volatile void __iomem   *mux_mis_membase;
+	volatile void __iomem   *iso_blk_membase;
+	volatile void __iomem   *m2tmx_membase;
+#if defined(CONFIG_MMC_RTK_EMMC_PON)
+	volatile void __iomem   *norst_membase;
+#endif
+	spinlock_t          lock;
+	struct delayed_work cmd_work;
+	struct tasklet_struct req_end_tasklet;
+
+	struct timer_list   timer;
+	struct timer_list   plug_timer;
+	struct completion   *int_waiting;
+	struct device       *dev;
+	struct resource     *res;
+	int                 irq;
+	u8                  *tmp_buf;
+	dma_addr_t          tmp_buf_phy_addr;
+	dma_addr_t          dma_paddr;
+	dma_addr_t          desc_paddr;
+	u32		test_count;
+	u32		tmout;
+	u16		normal_interrupt; //2030
+	u16		error_interrupt;  //2032
+	u8		rpmb_cmd; // it is rpmb cmd flag. When receiving CMD23, set to 1
+	u8		tx_tuning; //flag  that tx tuning need to be performed
+	u8		rx_tuning; //flag  that rx tuning need to be performed
+	u8		dqs_tuning;
+	u8		tx_user_defined;
+	u8		rx_user_defined;
+	u8		tx_reference_phase;
+	u8		rx_reference_phase;
+	u32		dqs_dly_tape;
+	unsigned long	emmc_tuning_addr;
+#if defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	struct cmdq_host *cq_host;
+#endif
+#if defined(CONFIG_MMC_RTK_EMMC_PON)
+	unsigned long pon_addr;
+	u32 emmc_pon_gpio;
+#endif
+};
+
+struct rtk_host_ops {
+	irqreturn_t (*func_irq)(int irq, void *dev);
+	int (*re_init_proc)(struct mmc_card *card);
+	int (*card_det)(struct rtkemmc_host *emmc_port);
+	void (*card_power)(struct rtkemmc_host *emmc_port,u8 status);
+	void (*chk_card_insert)(struct rtkemmc_host *rtkhost);
+	void (*set_crt_muxpad)(struct rtkemmc_host *rtkhost);
+	void (*set_clk)(struct rtkemmc_host *rtkhost,u32 mmc_clk);
+	void (*reset_card)(struct rtkemmc_host *rtkhost);
+	void (*reset_host)(struct rtkemmc_host *rtkhost);
+	void (*bus_speed_down)(struct rtkemmc_host *emmc_port);
+	u32 (*get_cmdcode)(u32 opcode );
+	u32 (*get_r1_type)(u32 opcode );
+	u32 (*chk_cmdcode)(struct mmc_command* cmd);
+	u32 (*chk_r1_type)(struct mmc_command* cmd);
+	void (*backup_regs)(struct rtkemmc_host *emmc_port);
+	void (*restore_regs)(struct rtkemmc_host *emmc_port);
+};
+
+#ifdef CONFIG_MMC_RTK_EMMC_CMDQ
+struct cmdq_host {
+	const struct cmdq_host_ops *ops;
+	struct mmc_host *mmc;
+
+	/* 64 bit DMA */
+	bool dma64;
+
+	int num_slots;
+	int start_slot;
+	u32 dcmd_slot;
+
+	//u32 caps;
+#define CMDQ_TASK_DESC_SZ_128 0x1
+
+	//u32 quirks;
+#define CMDQ_QUIRK_SHORT_TXFR_DESC_SZ 0x1
+#define CMDQ_QUIRK_NO_DCMD      0x2
+
+	bool enabled;
+	bool halted;
+	bool init_done;
+
+	u32 *desc_base;
+
+	/* total descriptor size */
+	u8 slot_sz;
+
+
+	/* 64/128 bit depends on CQCFG */
+	u8 task_desc_len;
+
+	/* 64 bit on 32-bit arch, 128 bit on 64-bit */
+	u8 link_desc_len;
+
+	u32 *trans_desc_base;
+	/* same length as transfer descriptor */
+	u8 trans_desc_len;
+
+	dma_addr_t desc_dma_base;
+	dma_addr_t trans_desc_dma_base;
+
+	struct completion halt_comp;
+	struct mmc_request **mrq_slot;
+	void *private;
+};
+#endif
+
+struct sd_cmd_pkt {
+	struct mmc_host     *mmc;       /* MMC structure */
+	struct rtkemmc_host   *emmc_port;
+	struct mmc_command  *cmd;    /* cmd->opcode; cmd->arg; cmd->resp; cmd->data */
+	struct mmc_data     *data;
+	unsigned char       *dma_buffer;
+	u16                 byte_count;
+	u16                 block_count;
+
+	u32                 flags;
+	u32			cmd_para;
+	u8                  rsp_len;
+	u32                 timeout;
+};
+
+#define MAX_CMD_RETRY_COUNT 4
+
+#define RCA_SHIFTER             16
+
+/* move from c file *** */
+#define BYTE_CNT            0x200
+
+#define RTK_FAIL            0x3  /* DMA error & cmd parser error */
+#define RTK_RMOV            0x2  /* card removed */
+#define RTK_TOUT            0x1  /* time out include DMA finish & cmd parser finish */
+#define RTK_SUCC            0x0
+#define CR_TRANSFER_FAIL    0x4
+
+/* send status event */
+#define STATE_IDLE          0
+#define STATE_READY         1
+#define STATE_IDENT         2
+#define STATE_STBY          3
+#define STATE_TRAN          4
+#define STATE_DATA          5
+#define STATE_RCV           6
+#define STATE_PRG           7
+#define STATE_DIS           8
+
+#define rtkemmc_get_int_sta(normal_interrupt, error_interrupt)	\
+	do {	\
+		*(u16 *)normal_interrupt = readw(emmc_port->emmc_membase+EMMC_NORMAL_INT_STAT_R);   \
+		*(u16 *)error_interrupt = readw(emmc_port->emmc_membase+EMMC_ERROR_INT_STAT_R);   \
+            } while (0)
+
+//clear status register, we always keep the card interrupt, card insertion, removal status because the eMMC is unremovable
+#define rtkemmc_clr_int_sta()                                                                              \
+	do {                                                                                                \
+		rtkemmc_writew(readw(emmc_port->emmc_membase+EMMC_ERROR_INT_STAT_R)&0xffff, emmc_port->emmc_membase+EMMC_ERROR_INT_STAT_R); \
+		rtkemmc_writew(readw(emmc_port->emmc_membase+EMMC_NORMAL_INT_STAT_R)&0xfeff, emmc_port->emmc_membase+EMMC_NORMAL_INT_STAT_R); \
+	} while(0)
+
+//mask all emmc interrupts
+#define rtkemmc_hold_int_dec()    \
+	do {      \
+                writew(0x0,emmc_port->emmc_membase+EMMC_NORMAL_INT_SIGNAL_EN_R); \
+                writew(0x0,emmc_port->emmc_membase+EMMC_ERROR_INT_SIGNAL_EN_R); \
+	} while(0)
+
+//for cmdq, we do not need cmd and xfer done, only cqe event
+#define rtkemmc_en_cqe_int()  \
+	do { \
+		writew(0xfefc,emmc_port->emmc_membase+EMMC_NORMAL_INT_SIGNAL_EN_R); \
+		writew(EMMC_ALL_ERR_SIGNAL_EN,emmc_port->emmc_membase+EMMC_ERROR_INT_SIGNAL_EN_R); \
+	} while(0)
+
+//used for data, r1b case, we mask cmd done interrupt
+#define rtkemmc_en_xfer_int()  \
+	do {  \
+                writew(0xfefe,emmc_port->emmc_membase+EMMC_NORMAL_INT_SIGNAL_EN_R); \
+                writew(EMMC_ALL_ERR_SIGNAL_EN,emmc_port->emmc_membase+EMMC_ERROR_INT_SIGNAL_EN_R); \
+	} while(0)
+
+//used for none-stream case (cmd w/wo/ resp)
+#define rtkemmc_en_cd_int()  \
+	do {    \
+                writew(0xfefd,emmc_port->emmc_membase+EMMC_NORMAL_INT_SIGNAL_EN_R); \
+                writew(EMMC_ALL_ERR_SIGNAL_EN,emmc_port->emmc_membase+EMMC_ERROR_INT_SIGNAL_EN_R); \
+	} while(0)	
+
+#define rtkemmc_writel(val, addr) \
+	do {    \
+		sync(emmc_port);					\
+		writel(val, addr);					\
+	} while(0)
+
+#define rtkemmc_writew(val, addr) \
+	do {    \
+		sync(emmc_port);                                        \
+		writew(val, addr);					\
+	} while(0)
+
+#define rtkemmc_writeb(val, addr) \
+	do {    \
+		sync(emmc_port);                                        \
+		writeb(val, addr);					\
+	} while(0)
+
+static const char *const state_tlb[11] = {
+	"STATE_IDLE",
+	"STATE_READY",
+	"STATE_IDENT",
+	"STATE_STBY",
+	"STATE_TRAN",
+	"STATE_DATA",
+	"STATE_RCV",
+	"STATE_PRG",
+	"STATE_DIS",
+	"STATE_BTST",
+	"STATE_SLEEP"
+};
+
+/* Only ADTC type cmd use */
+static const unsigned char rtk_sd_cmdcode[64] = {
+	EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, //0~3
+	EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_NORMALREAD, EMMC_CMD_UNKNOW, //4~7
+	EMMC_NORMALREAD, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_AUTOREAD1 , //8~11
+	EMMC_CMD_UNKNOW, EMMC_NORMALREAD, EMMC_NORMALREAD, EMMC_CMD_UNKNOW, //12~15
+	EMMC_CMD_UNKNOW, EMMC_AUTOREAD2 , EMMC_AUTOREAD1 , EMMC_NORMALWRITE , //16~19
+	EMMC_AUTOWRITE1, EMMC_TUNING    , EMMC_NORMALREAD, EMMC_CMD_UNKNOW , //20~23
+	EMMC_AUTOWRITE2, EMMC_AUTOWRITE1, EMMC_NORMALWRITE, EMMC_NORMALWRITE, //24~27
+	EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_NORMALREAD, EMMC_NORMALREAD , //28~31
+	EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, //32~35
+	EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, //36~39
+	EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_NORMALREAD, EMMC_CMD_UNKNOW, //40~43
+	EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, //44~47
+	EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_NORMALREAD, //48~51
+	EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, //52~55
+	EMMC_AUTOREAD2, EMMC_CMD_UNKNOW , EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW, //56~59
+	EMMC_AUTOWRITE2, EMMC_NORMALREAD, EMMC_CMD_UNKNOW, EMMC_CMD_UNKNOW   //60~63 
+};
+
+/* remove from c file &&& */
+
+/* rtk function definition */
+
+/* rtk function definition */
+void error_handling(struct rtkemmc_host *emmc_port);
+int rtkemmc_send_cmd25(struct rtkemmc_host *emmc_port,int,unsigned long, int,int*);
+int rtkemmc_send_cmd18(struct rtkemmc_host *emmc_port,int,unsigned long);
+int rtkemmc_send_cmd24(struct rtkemmc_host *emmc_port);
+int rtkemmc_send_cmd17(struct rtkemmc_host *emmc_port);
+
+
+//int rtkemmc_send_cmd8(struct rtkemmc_host *emmc_port,unsigned int bIgnore);
+int rtkemmc_send_cmd8(struct rtkemmc_host *emmc_port, unsigned int bIgnore);
+int polling_to_tran_state(struct rtkemmc_host *emmc_port,int cmd_idx, int bIgnore);
+void host_card_stop(struct rtkemmc_host *emmc_port);
+void host_card_stop2(struct rtkemmc_host *emmc_port);
+int rtkemmc_switch(struct mmc_card *card, u8 acc_mod, u8 index, u8 value, u8 cmd_set);
+#endif
diff --git a/drivers/mmc/host/sdhci-pltfm.c b/drivers/mmc/host/sdhci-pltfm.c
index ad49bfa..b07a56c 100644
--- a/drivers/mmc/host/sdhci-pltfm.c
+++ b/drivers/mmc/host/sdhci-pltfm.c
@@ -36,6 +36,10 @@
 #endif
 #include "sdhci-pltfm.h"
 
+#ifdef CONFIG_MMC_SDHCI_RTK
+void rtk_sdhci_platform_init(void);
+#endif
+
 unsigned int sdhci_pltfm_clk_get_max_clock(struct sdhci_host *host)
 {
 	struct sdhci_pltfm_host *pltfm_host = sdhci_priv(host);
@@ -156,6 +160,10 @@ struct sdhci_host *sdhci_pltfm_init(struct platform_device *pdev,
 		host->quirks2 = pdata->quirks2;
 	}
 
+#ifdef CONFIG_MMC_SDHCI_RTK
+	rtk_sdhci_platform_init();
+#endif
+
 	platform_set_drvdata(pdev, host);
 
 	return host;
diff --git a/drivers/mmc/host/sdhci-rtk.c b/drivers/mmc/host/sdhci-rtk.c
new file mode 100755
index 00000000..0f0385b
--- /dev/null
+++ b/drivers/mmc/host/sdhci-rtk.c
@@ -0,0 +1,1318 @@
+/*
+ * Realtek SDIO driver
+ *
+ * Authors:
+ * Copyright (C) 2017 Realtek Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/err.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/utsname.h>
+#include <linux/platform_device.h>
+#include <linux/clk.h>
+#include <linux/io.h>
+#include <linux/gpio.h>
+#include <linux/mmc/mmc.h>
+#include <linux/mmc/card.h>
+#include <linux/mmc/sdio.h>
+#include <linux/mmc/host.h>
+#include <linux/mmc/slot-gpio.h>
+#include <linux/delay.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <soc/realtek/rtd129x_lockapi.h>
+#include <linux/reset.h>
+#include <soc/realtek/rtk_chip.h>
+
+#include "sdhci-pltfm.h"
+#include "sdhci-rtk.h"
+//#define RTK_DEBUG
+#ifdef RTK_DEBUG
+#define RTK_debug(fmt, ...) printk(fmt, ##__VA_ARGS__)
+#else
+#define RTK_debug(fmt, ...)
+#endif
+
+#define DRIVER_NAME    "rtk-sdio"
+#define BANNER    "Realtek SDIO Host Driver"
+#define SDIO_CLKEN_REGOFF    0x0C
+#define SDIO_CLKEN_REGBIT    30
+
+#define MAX_PHASE    31
+#define TUNING_CNT    3
+
+#define sdhci_tx_tuning
+
+static void __iomem *sdio_membase;
+static void __iomem *crt_membase;
+u32 sdio_gpio_23 = 0;
+bool SDIO_module = false;
+bool clock_enable = true;
+bool SDIO_card=true;
+int SDIO_version = 3;   //default run SDIO 3.0
+struct sdhci_host *G_host;
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+unsigned int drive_temp=0;
+void Disable_sdio_irq(struct sdhci_host *host);
+#endif
+
+struct reset_control *rstc_sdio;
+struct clk * clk_en_sdio;
+struct clk * clk_en_sdio_ip;
+
+struct sdhci_rtk_sdio_data {
+    const struct sdhci_pltfm_data *pdata;
+};
+
+struct timing_phase_path {
+	int start;
+	int end;
+	int mid;
+	int len;
+};
+
+void set_SDIO_version(int version)
+{
+        SDIO_version=version;
+}
+EXPORT_SYMBOL(set_SDIO_version);
+
+int get_SDIO_version(void)
+{
+        return SDIO_version;
+}
+EXPORT_SYMBOL(get_SDIO_version);
+
+#ifdef CONFIG_RTK_SDIO_CLK_ADJUST
+
+void rtk_adjust_clock_for_wifi(unsigned int channel, unsigned int offset, unsigned int bwmode)
+{
+	wifi_sdio_clk_tbl rtk_wifi_sdio_clk_tbl[] = {
+		{ 1, 1, 0, {{0x7757893, 0x554388}, {0, 0}}},
+		{ 2, 1, 0, {{0x4fd7893, 0x544388}, {0, 0}}},
+		{ 3, 1, 0, {{0x4bd7893, 0x564388}, {0, 0}}},
+		{ 4, 1, 0, {{0x57d7893, 0x564388}, {0, 0}}},
+		{ 5, 1, 1, {{0x73d7893, 0x544388}, {0x7757893, 0x554388}}},
+		{ 6, 1, 1, {{0x7fd7893, 0x544388}, {0x4fd7893, 0x544388}}},
+		{ 7, 1, 1, {{0x4757893, 0x554388}, {0x4bd7893, 0x564388}}},
+		{ 8, 1, 1, {{0x53d7893, 0x554388}, {0x57d7893, 0x564388}}},
+		{ 9, 1, 1, {{0x5f57893, 0x554388}, {0x73d7893, 0x544388}}},
+		{10, 0, 1, {{0, 0}, {0x7fd7893, 0x544388}}},
+		{11, 0, 1, {{0, 0}, {0x4757893, 0x554388}}},
+		{12, 0, 1, {{0, 0}, {0x53d7893, 0x554388}}},
+		{13, 0, 1, {{0, 0}, {0x5f57893, 0x554388}}},
+	};
+
+	int i, ret = -1, idx=0;
+	u32 value = 0;
+
+	printk("%s: channel=%d, offset=%d, bwmode=%d\n", __func__, channel, offset, bwmode);
+
+	for (i=0; i < ARRAY_SIZE(rtk_wifi_sdio_clk_tbl); i++) {
+		if (channel == rtk_wifi_sdio_clk_tbl[i].channel) {
+			if ((offset == PRI_CH_OFFSET_LOWER && rtk_wifi_sdio_clk_tbl[i].lower)
+				|| (offset == PRI_CH_OFFSET_DONT_CARE && rtk_wifi_sdio_clk_tbl[i].lower))
+				idx=0;
+			else if ((offset == PRI_CH_OFFSET_UPPER && rtk_wifi_sdio_clk_tbl[i].upper)
+				|| (offset == PRI_CH_OFFSET_DONT_CARE && rtk_wifi_sdio_clk_tbl[i].upper))
+				idx=1;
+			else
+				break;
+
+			printk("%d: 0x%08x,0x%08x\n", rtk_wifi_sdio_clk_tbl[i].channel, rtk_wifi_sdio_clk_tbl[i].map[idx].reg1a4,
+				rtk_wifi_sdio_clk_tbl[i].map[idx].reg1a8);
+
+			value = readl(crt_membase + 0x10a58);
+			if (value & 0x40000000)
+				writel(value & ~(0x40000000), crt_membase + 0x10a58);
+			else
+				writel(value | 0x40000000, crt_membase + 0x10a58);
+			writel(rtk_wifi_sdio_clk_tbl[i].map[idx].reg1a4, crt_membase + 0x01A4);
+			mdelay(2);
+			writel(rtk_wifi_sdio_clk_tbl[i].map[idx].reg1a8, crt_membase + 0x01A8);
+			mdelay(2);
+			writel(value, crt_membase + 0x10a58);
+
+			ret = 0;
+			break;
+		}
+	}
+
+	if (ret)
+		printk("invalid settings: ch=%u, offset=%u, bwmode=%u\n", channel, offset, bwmode);
+}
+EXPORT_SYMBOL_GPL(rtk_adjust_clock_for_wifi);
+#endif
+
+static void rtk_sdhci_buswidth(struct sdhci_host *host, int bus_width)
+{
+    u32 ctrl = 0;
+
+    ctrl = sdhci_readb(host, SDHCI_HOST_CONTROL);
+    if((host->mmc->caps & MMC_CAP_8_BIT_DATA) &&
+        (bus_width == MMC_BUS_WIDTH_8)){
+        ctrl &= ~SDHCI_CTRL_4BITBUS;
+        ctrl |= SDHCI_CTRL_8BITBUS;
+    }else{
+        ctrl &= ~SDHCI_CTRL_8BITBUS;
+        if (bus_width == MMC_BUS_WIDTH_4)
+            ctrl |= SDHCI_CTRL_4BITBUS;
+        else
+            ctrl &= ~SDHCI_CTRL_4BITBUS;
+    }
+    sdhci_writeb(host, ctrl, SDHCI_HOST_CONTROL);
+}
+
+static void rtk_sdhci_reset(struct sdhci_host *host, u8 mask)
+{
+    unsigned long timeout = 0;
+
+    sdhci_writeb(host, mask, SDHCI_SOFTWARE_RESET);
+    if(mask & SDHCI_RESET_ALL)
+        host->clock = 0;
+
+    /* Wait max 100 ms */
+    timeout = 100;
+
+    /* hw clears the bit when it's done */
+    while(sdhci_readb(host, SDHCI_SOFTWARE_RESET) & mask){
+        if(timeout == 0){
+            pr_err("%s: Reset 0x%x never completed.\n",
+                mmc_hostname(host->mmc), (int)mask);
+            return;
+        }
+        timeout--;
+        mdelay(1);
+    }
+}
+
+static void rtk_sdhci_uhs_signaling(struct sdhci_host *host, unsigned timing){
+
+    u16 ctrl_2 = 0;
+
+    sdhci_writew(host, sdhci_readw(host, SDHCI_CLOCK_CONTROL) | SDHCI_CLOCK_CARD_EN, SDHCI_CLOCK_CONTROL);
+
+    ctrl_2 = sdhci_readw(host, SDHCI_HOST_CONTROL2);
+    /* Select Bus Speed Mode for host */
+    ctrl_2 &= ~SDHCI_CTRL_UHS_MASK;
+    if ((timing == MMC_TIMING_MMC_HS200) ||
+        (timing == MMC_TIMING_UHS_SDR104))
+        ctrl_2 |= SDHCI_CTRL_UHS_SDR104;
+    else if (timing == MMC_TIMING_UHS_SDR12)
+        ctrl_2 |= SDHCI_CTRL_UHS_SDR12;
+    else if (timing == MMC_TIMING_UHS_SDR25)
+        ctrl_2 |= SDHCI_CTRL_UHS_SDR25;
+    else if (timing == MMC_TIMING_UHS_SDR50)
+        ctrl_2 |= SDHCI_CTRL_UHS_SDR50;
+    else if ((timing == MMC_TIMING_UHS_DDR50) ||
+         (timing == MMC_TIMING_MMC_DDR52))
+        ctrl_2 |= SDHCI_CTRL_UHS_DDR50;
+    else if (timing == MMC_TIMING_MMC_HS400)
+        ctrl_2 |= SDHCI_CTRL_HS400; /* Non-standard */
+
+    sdhci_writew(host, ctrl_2 | SDHCI_CTRL_VDD_180, SDHCI_HOST_CONTROL2);
+}
+
+static u16 rtk_sdhci_get_preset_value(struct sdhci_host *host)
+{
+    u16 preset = 0;
+
+    switch(host->timing){
+    case MMC_TIMING_UHS_SDR12:
+        preset = sdhci_readw(host, SDHCI_PRESET_FOR_SDR12);
+        break;
+    case MMC_TIMING_UHS_SDR25:
+        preset = sdhci_readw(host, SDHCI_PRESET_FOR_SDR25);
+        break;
+    case MMC_TIMING_UHS_SDR50:
+        preset = sdhci_readw(host, SDHCI_PRESET_FOR_SDR50);
+        break;
+    case MMC_TIMING_UHS_SDR104:
+    case MMC_TIMING_MMC_HS200:
+        preset = sdhci_readw(host, SDHCI_PRESET_FOR_SDR104);
+        break;
+    case MMC_TIMING_UHS_DDR50:
+        preset = sdhci_readw(host, SDHCI_PRESET_FOR_DDR50);
+        break;
+    case MMC_TIMING_MMC_HS400:
+        preset = sdhci_readw(host, SDHCI_PRESET_FOR_HS400);
+        break;
+    default:
+        pr_warn("%s: Invalid UHS-I mode selected\n",
+            mmc_hostname(host->mmc));
+        preset = sdhci_readw(host, SDHCI_PRESET_FOR_SDR12);
+        break;
+    }
+    return preset;
+}
+
+static void rtk_sdhci_set_clock(struct sdhci_host *host, unsigned int clock)
+{
+    int div = 0; /* Initialized for compiler warning */
+    int real_div = div, clk_mul = 1;
+    u16 clk = 0;
+    u16 pre_val = 0;
+    unsigned long timeout = 0;
+
+    if(clock && clock == host->clock)
+        return;
+
+    host->mmc->actual_clock = 0;
+
+    sdhci_writew(host, 0, SDHCI_CLOCK_CONTROL);
+
+    if(clock == 0)
+        goto out;
+
+    if(host->version >= SDHCI_SPEC_300){
+        if(sdhci_readw(host, SDHCI_HOST_CONTROL2) & SDHCI_CTRL_PRESET_VAL_ENABLE){
+            clk = sdhci_readw(host, SDHCI_CLOCK_CONTROL);
+            pre_val = rtk_sdhci_get_preset_value(host);
+            div = (pre_val & SDHCI_PRESET_SDCLK_FREQ_MASK)
+                >> SDHCI_PRESET_SDCLK_FREQ_SHIFT;
+            if(host->clk_mul && (pre_val & SDHCI_PRESET_CLKGEN_SEL_MASK)){
+                clk = SDHCI_PROG_CLOCK_MODE;
+                real_div = div + 1;
+                clk_mul = host->clk_mul;
+            }else{
+                real_div = max_t(int, 1, div << 1);
+            }
+            goto clock_set;
+        }
+
+        /*
+         * Check if the Host Controller supports Programmable Clock
+         * Mode.
+         */
+        if(host->clk_mul){
+            for(div = 1 ; div <= 1024 ; div++){
+                if ((host->max_clk * host->clk_mul / div)
+                    <= clock)
+                    break;
+            }
+            /*
+             * Set Programmable Clock Mode in the Clock
+             * Control register.
+             */
+            clk = SDHCI_PROG_CLOCK_MODE;
+            real_div = div;
+            clk_mul = host->clk_mul;
+            div--;
+        }else{
+            /* Version 3.00 divisors must be a multiple of 2. */
+            if (host->max_clk <= clock)
+                div = 1;
+            else{
+                for(div = 2; div < SDHCI_MAX_DIV_SPEC_300;
+                     div += 2) {
+                    if((host->max_clk / div) <= clock)
+                        break;
+                }
+            }
+            real_div = div;
+            div >>= 1;
+        }
+    }else{
+        /* Version 2.00 divisors must be a power of 2. */
+        for(div = 1 ; div < SDHCI_MAX_DIV_SPEC_200 ; div *= 2){
+            if((host->max_clk / div) <= clock)
+                break;
+        }
+        real_div = div;
+        div >>= 1;
+    }
+
+clock_set:
+    if(real_div)
+        host->mmc->actual_clock = (host->max_clk * clk_mul) / real_div;
+
+    clk |= (div & SDHCI_DIV_MASK) << SDHCI_DIVIDER_SHIFT;
+    clk |= ((div & SDHCI_DIV_HI_MASK) >> SDHCI_DIV_MASK_LEN) << SDHCI_DIVIDER_HI_SHIFT;
+    clk |= SDHCI_CLOCK_INT_EN;
+    sdhci_writew(host, clk, SDHCI_CLOCK_CONTROL);
+
+    /* Wait max 20 ms */
+    timeout = 20;
+    while(!((clk = sdhci_readw(host, SDHCI_CLOCK_CONTROL)) & SDHCI_CLOCK_INT_STABLE)){
+        if(timeout == 0){
+            pr_err("%s: Internal clock never " "stabilised.\n", mmc_hostname(host->mmc));
+            return;
+        }
+        timeout--;
+        mdelay(1);
+    }
+
+    clk |= SDHCI_CLOCK_CARD_EN;
+    sdhci_writew(host, clk, SDHCI_CLOCK_CONTROL);
+#ifdef CONFIG_ARCH_RTD119X
+	printk(KERN_ERR "[SDIO] SDHCI_SPEC_200: rtk_sdhci_set_clock end real_div=%x, div=%x, c3c=%x, CLK=%x\n",
+                real_div, div, readl(host->ioaddr + 0x3c) , readl(host->ioaddr + SDHCI_CLOCK_CONTROL));
+#else
+	printk(KERN_ERR "[SDIO] SDHCI_SPEC_300: rtk_sdhci_set_clock end real_div=%x, div=%x, c3c=%x, PLL=%x, CLK=%x\n",
+		real_div, div, readl(host->ioaddr + 0x3c) ,readl(crt_membase + 0x01A8),readl(host->ioaddr + SDHCI_CLOCK_CONTROL));
+#endif
+
+    if(readl(host->ioaddr + SDHCI_CLOCK_CONTROL)==0xe8c7) {
+	SDIO_card = false;
+    }
+out:
+    host->clock = clock;
+}
+
+void rtk_register_set(void)
+{
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	if(get_SDIO_version()==4) {
+		printk(KERN_ERR "SDIO SDR104 mode\n");
+#ifdef CONFIG_ARCH_RTD16xx
+		writel(0x1d, crt_membase + 0x10a58);	//enlarge wait time for data
+#endif
+		if(readl(crt_membase+0x1a204)==0x00) {
+#ifndef CONFIG_ARCH_RTD119X
+			writel(0x00000006, crt_membase + 0x01AC);
+			writel(0x04517893, crt_membase + 0x01A4);
+			writel(0x00ae4388, crt_membase + 0x01A8); //SDIO 3.0, 208MHz
+			mdelay(2);
+			writel(0x00000007, crt_membase + 0x01AC);
+			udelay(200);
+#endif
+		}
+		else {
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_ARCH_RTD129x
+			writel(0x40000000, crt_membase+ 0x10a58);
+#endif
+			writel(0x00000006, crt_membase + 0x01AC);
+			writel(0x04517893, crt_membase + 0x01A4);
+			writel(0x00ae4388, crt_membase + 0x01A8); //SDIO 3.0, 208MHz
+			mdelay(2);
+			writel(0x00000007, crt_membase + 0x01AC);
+			udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+			writel(0x00000000, crt_membase+ 0x10a58);
+#endif
+#endif
+		}
+	}
+	else if(get_SDIO_version()==3) {
+#ifdef CONFIG_ARCH_RTD129x
+		writel(0x0000003b, crt_membase + 0x01A0);
+#elif defined(CONFIG_ARCH_RTD139x)
+		writel(0x000000fb, crt_membase + 0x01A0);
+#elif defined(CONFIG_ARCH_RTD16xx)
+		writel((readl(crt_membase + 0x1A0)& ~0x000000F8)| (0x1d <<3), crt_membase + 0x1A0);
+#endif
+
+#if defined(CONFIG_ARCH_RTD129x)
+		rtk_lockapi_lock(flags2, __FUNCTION__);
+		writel(0x0000bbbb, crt_membase + 0x1263c);
+		writel(0xbbbbbbbb, crt_membase + 0x12640);
+		rtk_lockapi_unlock(flags2, __FUNCTION__);
+#elif defined(CONFIG_ARCH_RTD139x)
+		writel(0x375EEB, crt_membase + 0x4E040);
+                writel(0x375EEB, crt_membase + 0x4E044);
+                writel(0x375EEB, crt_membase + 0x4E048);
+#elif defined(CONFIG_ARCH_RTD16xx)
+		writel((readl(crt_membase + 0x4E024)& 0xf) | 0xAF75EEB0, crt_membase + 0x4E024);
+		writel(0x5EEBDD7B, crt_membase + 0x4E028);
+		writel((readl(crt_membase + 0x4E02c)& 0xffffffc0) | 0x37, crt_membase + 0x4E02c);
+#elif defined(CONFIG_ARCH_RTD13xx)
+		writel((readl(crt_membase + 0x4E058)& 0xff000000) | 0x006C36C3, crt_membase + 0x4E058);
+		writel((readl(crt_membase + 0x4E05c)& 0xff000000) | 0x006C36C3, crt_membase + 0x4E05c);
+		writel((readl(crt_membase + 0x4E060)& 0xff000000) | 0x006C36C3, crt_membase + 0x4E060);
+#endif
+
+#ifndef CONFIG_ARCH_RTD119X
+		writel(0x00000000, crt_membase + 0x010A40);
+#endif
+		if(readl(crt_membase+0x1a204)==0x00) {
+			printk(KERN_ERR "SDIO 3.0 A00 version\n");
+		}else{
+			printk(KERN_ERR "SDIO 3.0 A01 version\n");
+		}
+	}
+	else if(get_SDIO_version()==2){
+#ifndef CONFIG_ARCH_RTD119X
+#if defined(CONFIG_ARCH_RTD13xx)
+		writel(readl(crt_membase + 0x7064)|(0x3<<4), crt_membase + 0x7064);
+#else
+		writel(0x00000003, crt_membase + 0x01A0);
+#endif
+#endif
+		if(readl(crt_membase+0x1a204)==0x00) {
+			printk(KERN_ERR "SDIO 2.0 A00 version\n");
+		}else {
+			printk(KERN_ERR "SDIO 2.0 A01 version\n");
+		}
+	}
+}
+EXPORT_SYMBOL(rtk_register_set);
+
+void rtk_sdhci_platform_init(void)
+{
+#if defined(CONFIG_ARCH_RTD1355)
+    int i=0;
+#elif defined(SD_INTERFACE_SDIO_1619)
+    unsigned int tmp=0;
+#endif
+
+    gpio_direction_output(sdio_gpio_23, 0);
+    mdelay(50);
+    gpio_direction_output(sdio_gpio_23, 1);
+    mdelay(10);
+
+    reset_control_deassert(rstc_sdio);
+    clk_prepare_enable(clk_en_sdio);
+    clk_prepare_enable(clk_en_sdio_ip);
+
+    if(readl(crt_membase+0x1a204)==0x00) {
+#ifndef CONFIG_ARCH_RTD119X
+	writel(0x00000006, crt_membase + 0x01AC);
+	writel(0x04517893, crt_membase + 0x01A4);
+	writel(0x00ae4388, crt_membase + 0x01A8); //SDIO 3.0, 208MHz
+	mdelay(2);
+	writel(0x00000007, crt_membase + 0x01AC);
+	udelay(200);
+#endif
+    }
+    else {
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_ARCH_RTD129x
+	writel(0x40000000, crt_membase+ 0x10a58);
+#endif
+	writel(0x00000006, crt_membase + 0x01AC);
+	writel(0x04517893, crt_membase + 0x01A4);
+	writel(0x00ae4388, crt_membase + 0x01A8); //SDIO 3.0, 208MHz
+	mdelay(2);
+	writel(0x00000007, crt_membase + 0x01AC);
+	udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+	writel(0x00000000, crt_membase+ 0x10a58);
+#endif
+#endif
+    }
+    writel(0x00000011, crt_membase + 0x010A34);
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+    writel(0x00000001, crt_membase + 0x010A10);
+#else
+    writel(0x00000003, crt_membase + 0x010A10);
+#endif
+
+#if defined(CONFIG_ARCH_RTD1355)
+	writel(0x10,crt_membase + 0x4E018 );
+	writel(0x2,crt_membase + 0x4E00c );
+	writel(0x49024000,crt_membase + 0x4E008 );
+	writel(0x3,crt_membase + 0x1e0 );
+	writel(0x4003,crt_membase + 0x1e0 );
+	writel(0x6003,crt_membase + 0x1e0 );
+	writel(0x400,crt_membase + 0x4E030 );
+
+	writel(0x19B75EEB,crt_membase + 0x4e034);
+	writel(0x00377EEF,crt_membase + 0x4e038);
+	writel(0x00377EEF,crt_membase + 0x4e03c);
+
+	writel(readl(crt_membase + 0x10A00)|0x1, crt_membase + 0x10A00);
+	while((i++) < 10)
+		writel(0xd,crt_membase + 0x10B74);
+
+	writel(readl(crt_membase + 0x10A00)&(~0x1), crt_membase + 0x10A00);
+#elif defined(SD_INTERFACE_SDIO_1619)
+	writel(readl(crt_membase+0x4E004)&(~(0x1<<25)),crt_membase+0x4E004);
+	writel((readl(crt_membase+0x4E020)&0xff0fffff)|0x00600000 ,crt_membase+0x4E020);
+	mdelay(100);
+	writel(readl(crt_membase+0x4E020) & 0xffbfffff ,crt_membase+0x4E020);
+	mdelay(100);
+
+	tmp = (0x3243243 << 4) | (readl(crt_membase + 0x4f00c) & 0xf);
+	writel(tmp,crt_membase + 0x4f00c);
+	writel(0xd83d83d8,crt_membase + 0x4f010);
+	tmp = (readl(crt_membase + 0x4f014) & 0xfffff000) | 0xd83;
+	writel(tmp,crt_membase + 0x4f014);
+
+	writel(0x10,crt_membase+0x4E048);
+	writel((readl(crt_membase+0x4F004)&0xfff00000)|0x52492, crt_membase+0x4F004);
+	writel(0x3,crt_membase + 0x1e0);
+	writel(0x4003,crt_membase + 0x1e0);
+	writel(0x6003,crt_membase + 0x1e0);
+#elif defined(SD_INTERFACE_SDIO_1319)
+	writel(readl(crt_membase+0x4E00C)&(~(0x1<<2)),crt_membase+0x4E00C);
+	writel((readl(crt_membase+0x4E048)&0xfff0ffff)|0x00060000 ,crt_membase+0x4E048);
+	mdelay(100);
+	writel(readl(crt_membase+0x4E048) & 0xfffbffff ,crt_membase+0x4E048);
+	mdelay(100);
+
+	writel((readl(crt_membase+0x4E04C)&0xff000000)|0x243243 , crt_membase+0x4E04C);
+	writel((readl(crt_membase+0x4E050)&0xf000000f)|(0x243243<<4), crt_membase+0x4E050);
+	writel((readl(crt_membase+0x4E054)&0xff000000)|0x243243, crt_membase+0x4E054);
+
+	writel((readl(crt_membase+0x4E010)&0xfffffff0)|(0x1<<1), crt_membase+0x4E010);
+	writel(0x10,crt_membase+0x4E120);
+	writel((readl(crt_membase+0x4E00C)&0xf00f)|0x04440480, crt_membase+0x4E00C);
+	writel(0x3,crt_membase + 0x1e0);
+	writel(0x4003,crt_membase + 0x1e0);
+	writel(0x6003,crt_membase + 0x1e0);
+#endif
+}
+EXPORT_SYMBOL(rtk_sdhci_platform_init);
+
+#ifndef CONFIG_ARCH_RTD119X
+void rtk_sdhci_close_clk(void)
+{
+	if(SDIO_module==true) {
+		clock_enable=false;
+		G_host->mmc->caps2 |=  (MMC_CAP2_NO_SD | MMC_CAP2_NO_MMC | MMC_CAP2_NO_SDIO);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+		printk(KERN_ERR "Do not detect the SDIO card and disable sdio irq\n");
+		Disable_sdio_irq(G_host);
+		mdelay(10);
+#endif
+		printk(KERN_ERR "Do not detect the SDIO card and close the clock, mmc->caps2=0x%x\n", G_host->mmc->caps2);
+	 	writel(0x0, crt_membase + 0x01AC);
+		reset_control_assert(rstc_sdio);
+		clk_disable_unprepare(clk_en_sdio);
+                clk_disable_unprepare(clk_en_sdio_ip);
+		wmb();
+		mdelay(10);
+#if defined(CONFIG_ARCH_RTD16xx)
+    	if(get_rtd_chip_revision()==RTD_CHIP_A01) {
+		writel(readl(crt_membase + 0x1A0)&(~0x1), crt_membase + 0x1A0);
+		writel(readl(crt_membase + 0x1A4)&(~0x1), crt_membase + 0x1A4);
+		udelay(200);
+		}
+#elif defined(CONFIG_ARCH_RTD13xx)
+		writel(readl(crt_membase + 0x7064)&~(0x3<<4), crt_membase + 0x7064);
+		udelay(200);
+#endif
+		//writel(readl(crt_membase + 0x0C) & (~(1 << 30)), crt_membase + 0x0C);
+		//writel(readl(crt_membase + 0x0C) & (~(1 << 26)), crt_membase + 0x0C);
+	}
+}
+EXPORT_SYMBOL(rtk_sdhci_close_clk);
+#endif
+
+#ifndef CONFIG_ARCH_RTD119X	//119X does not support SDIO 3.0
+static int rtk_sdhci_change_rx_phase(u8 sample_point)
+{
+    unsigned int temp_reg = 0;
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+    writel(readl(crt_membase + 0x1A0)&0xfffffffd, crt_membase + 0x1A0);
+#endif
+    temp_reg = readl(crt_membase + 0x1A0);
+    temp_reg = (temp_reg & ~0x00001F00) | (sample_point << 8);
+    writel(temp_reg, crt_membase + 0x1A0);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+    writel(readl(crt_membase + 0x1A0)|0x2, crt_membase + 0x1A0);
+#endif
+    udelay(100);
+
+    return 0;
+}
+
+static int rtk_sdhci_change_tx_phase(u8 sample_point)
+{
+    unsigned int temp_reg = 0;
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+    writel(readl(crt_membase + 0x1A0)&0xfffffffd, crt_membase + 0x1A0);
+#endif
+    temp_reg = readl(crt_membase + 0x1A0);
+    temp_reg = (temp_reg & ~0x000000F8) | (sample_point << 3);
+    writel(temp_reg, crt_membase + 0x1A0);
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+    writel(readl(crt_membase + 0x1A0)|0x2, crt_membase + 0x1A0);
+#endif
+    udelay(100);
+
+    return 0;
+}
+
+static u8 rtk_sdhci_search_final_phase(u32 phase_map)
+{
+    struct timing_phase_path path[MAX_PHASE + 1];
+    struct timing_phase_path swap;
+    int i = 0;
+    int j = 0;
+    int k = 0;
+    int cont_path_cnt = 0;
+    int new_block = 1;
+    int max_len = 0;
+    int final_path_idx = 0;
+    u8 final_phase = 0xFF;
+
+    /* Parse phase_map, take it as a bit-ring */
+    for(i = 0 ; i < MAX_PHASE + 1 ; i++){
+        if(phase_map & (1 << i)){
+            if(new_block){
+                new_block = 0;
+                j = cont_path_cnt++;
+                path[j].start = i;
+                path[j].end = i;
+            }else
+                path[j].end = i;
+        }else{
+            new_block = 1;
+            if(cont_path_cnt){
+                /* Calculate path length and middle point */
+                int idx = cont_path_cnt - 1;
+                path[idx].len = path[idx].end - path[idx].start + 1;
+                path[idx].mid = path[idx].start + path[idx].len / 2;
+            }
+        }
+    }
+
+    if(cont_path_cnt == 0){
+        printk(KERN_ERR " %s No continuous phase path\n", __func__);
+        goto finish;
+    }else{
+        /* Calculate last continuous path length and middle point */
+        int idx = cont_path_cnt - 1;
+        path[idx].len = path[idx].end - path[idx].start + 1;
+        path[idx].mid = path[idx].start + path[idx].len / 2;
+    }
+
+    /* Connect the first and last continuous paths if they are adjacent */
+    if (!path[0].start && (path[cont_path_cnt - 1].end == MAX_PHASE)){
+        /* Using negative index */
+        path[0].start = path[cont_path_cnt - 1].start - MAX_PHASE - 1;
+        path[0].len += path[cont_path_cnt - 1].len;
+        path[0].mid = path[0].start + path[0].len / 2;
+        /* Convert negative middle point index to positive one */
+        if (path[0].mid < 0)
+            path[0].mid += MAX_PHASE + 1;
+        cont_path_cnt--;
+    }
+
+    /* Sorting path array,jamestai20141223 */
+    for(k = 0 ; k < cont_path_cnt ; ++k){
+        for(i = 0 ; i < cont_path_cnt - 1 - k ; ++i){
+            if(path[i].len < path[i+1].len){
+                swap.end = path[i+1].end;
+                swap.len = path[i+1].len;
+                swap.mid = path[i+1].mid;
+                swap.start = path[i+1].start;
+
+                path[i+1].end = path[i].end;
+                path[i+1].len = path[i].len;
+                path[i+1].mid = path[i].mid;
+                path[i+1].start = path[i].start;
+
+                path[i].end = swap.end;
+                path[i].len = swap.len;
+                path[i].mid = swap.mid;
+                path[i].start = swap.start;
+            }
+        }
+    }
+
+    /* Choose the longest continuous phase path */
+    max_len = 0;
+    final_phase = 0;
+    final_path_idx = 0;
+    for(i = 0 ; i < cont_path_cnt ; i++){
+        if(path[i].len > max_len){
+            max_len = path[i].len;
+            if(max_len > 6)    //for compatibility issue, continue len should bigger than 6
+                final_phase = (u8)path[i].mid;
+            else
+                final_phase = 0xFF;
+            final_path_idx = i;
+        }
+
+        //rtk_sdmmc_debug("%s path[%d].start = %d\n", __func__, i, path[i].start);
+        //rtk_sdmmc_debug("%s path[%d].end = %d\n", __func__, i, path[i].end);
+        //rtk_sdmmc_debug("%s path[%d].len = %d\n", __func__, i, path[i].len);
+        //rtk_sdmmc_debug("%s path[%d].mid = %d\n", __func__, i, path[i].mid);
+    }
+
+finish:
+    //rtk_sdmmc_debug("%s Final chosen phase: %d\n", __func__, final_phase);
+    return final_phase;
+}
+
+static int rtk_sdhci_tuning_rx(struct sdhci_host *host)
+{
+    int sample_point = 0;
+    int ret = 0;
+    int i = 0;
+    u32 raw_phase_map[TUNING_CNT] = {0};
+    u32 phase_map = 0;
+    u8 final_phase = 0;
+
+    struct mmc_host *mmc = host->mmc;
+
+    for(sample_point = 0 ; sample_point <= MAX_PHASE ; sample_point++){
+        for(i = 0 ; i < TUNING_CNT ; i++){
+            rtk_sdhci_change_rx_phase((u8)sample_point);
+            ret = mmc_send_tuning(mmc, MMC_SEND_TUNING_BLOCK, NULL);
+            if (ret==0)
+                raw_phase_map[i] |= (1 << sample_point);
+        }
+    }
+
+    phase_map = 0xFFFFFFFF;
+    for(i = 0 ; i < TUNING_CNT ; i++){
+        //rtk_sdmmc_debug("%s RX raw_phase_map[%d] = 0x%08x\n", __func__, i, raw_phase_map[i]);
+        phase_map &= raw_phase_map[i];
+    }
+    printk(KERN_ERR "%s RX phase_map = 0x%08x\n", __func__, phase_map);
+
+    if(phase_map){
+        final_phase = rtk_sdhci_search_final_phase(phase_map);
+        printk(KERN_ERR "%s final phase = 0x%08x\n", __func__, final_phase);
+        if (final_phase == 0xFF){
+            printk(KERN_ERR "%s final phase = 0x%08x\n", __func__, final_phase);
+            ret = -EINVAL;
+            goto out ;
+        }
+        rtk_sdhci_change_rx_phase(final_phase);
+        ret = 0;
+        goto out ;
+    }else{
+        printk(KERN_ERR "%s  fail !phase_map\n", __func__);
+        ret = -EINVAL;
+        goto out ;
+    }
+
+out:
+    return ret;
+}
+
+static int rtk_sdhci_tuning_tx(struct sdhci_host *host)
+{
+    int sample_point = 0;
+    int ret = 0;
+    int i = 0;
+    u32 raw_phase_map[TUNING_CNT] = {0};
+    u32 phase_map = 0;
+    u8 final_phase = 0;
+
+    struct mmc_host *mmc = host->mmc;
+
+    for(sample_point = 0 ; sample_point <= MAX_PHASE ; sample_point++){
+        for(i = 0 ; i < TUNING_CNT ; i++){
+            rtk_sdhci_change_tx_phase((u8)sample_point);
+	    writew(0x1, host->ioaddr+0x36);
+	    writew(0x1, host->ioaddr+0x3A);
+            ret = mmc_send_tuning_tx(mmc, SD_IO_RW_DIRECT, NULL);
+            if (ret==0)
+                raw_phase_map[i] |= (1 << sample_point);
+        }
+    }
+
+    phase_map = 0xFFFFFFFF;
+    for(i = 0 ; i < TUNING_CNT ; i++){
+        //rtk_sdmmc_debug("%s RX raw_phase_map[%d] = 0x%08x\n", __func__, i, raw_phase_map[i]);
+        phase_map &= raw_phase_map[i];
+    }
+    printk(KERN_ERR "%s TX phase_map = 0x%08x\n", __func__, phase_map);
+
+    if(phase_map){
+        final_phase = rtk_sdhci_search_final_phase(phase_map);
+        printk(KERN_ERR "%s final phase = 0x%08x\n", __func__, final_phase);
+        if (final_phase == 0xFF){
+            printk(KERN_ERR "%s final phase = 0x%08x\n", __func__, final_phase);
+            ret = -EINVAL;
+            goto out ;
+        }
+        rtk_sdhci_change_tx_phase(final_phase);
+        ret = 0;
+        goto out ;
+    }else{
+        printk(KERN_ERR "%s  fail !phase_map\n", __func__);
+        ret = -EINVAL;
+        goto out ;
+    }
+
+out:
+    return ret;
+}
+
+static int rtk_sdhci_execute_tuning(struct sdhci_host *host, u32 opcode)
+{
+    /* [ToDo] SDIO30 clock phase tuning, jamestai20151229 */
+    int ret = 0;
+    unsigned int reg_tmp = 0;
+    unsigned int reg_tmp2 = 0;
+    unsigned int reg_tuned3318 = 0;
+
+    printk(KERN_ERR "%s : Execute Clock Phase Tuning\n", __func__);
+    reg_tmp2 = readl(crt_membase + 0x01A4); //disable spectrum
+    writel((reg_tmp2 & 0xFFFF1FFF), crt_membase + 0x01A4); //PLL_SD2 clear [15:13]
+
+#ifdef sdhci_tx_tuning
+    ret = rtk_sdhci_tuning_tx(host);
+#endif
+
+    do{
+        ret = rtk_sdhci_tuning_rx(host);
+        if(ret){
+            reg_tmp = readl(crt_membase + 0x01A8);
+            reg_tuned3318 = (reg_tmp & 0x03FF0000) >> 16;
+            if (reg_tuned3318 <= 100){
+                printk(KERN_ERR "%s: Tuning RX fail\n", __func__);
+                return ret;
+            }
+    //        writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) | 0x00070000, sdmmc_base + CR_SD_CKGEN_CTL);
+            reg_tmp = ((reg_tmp & (~0x3FF0000)) | ((reg_tuned3318 - 8) << 16)); //down 8MHz
+#ifdef CONFIG_ARCH_RTD129x
+            if(readl(crt_membase+0x1a204)!=0x0)
+		writel(0x40000000, crt_membase+ 0x10a58);
+#endif
+
+            writel(0x00000006, crt_membase + 0x01AC);       //JIM modified, 1AC->1EC
+            writel(reg_tmp,crt_membase + 0x01A8);
+            mdelay(2);
+            writel(0x00000007, crt_membase + 0x01AC);        //JIM modified, 1AC->1EC
+	    udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+            if(readl(crt_membase+0x1a204)!=0x0)
+		writel(0x00000000, crt_membase+ 0x10a58);
+#endif
+     //       writel(readl(sdmmc_base + CR_SD_CKGEN_CTL) & 0xFFF8FFFF, sdmmc_base + CR_SD_CKGEN_CTL);
+     //       writeb(readb(sdmmc_base + SD_CONFIGURE1) & 0xEF, sdmmc_base + SD_CONFIGURE1);
+        }
+    }while(ret);
+
+    writel(reg_tmp2, crt_membase + 0x01A4);
+
+    printk(KERN_ERR "After tuning, current SDIO PLL = %x\n", (readl(crt_membase + 0x01A8)&0x03FF0000) >> 16);
+
+    return 0;
+}
+#endif
+static const struct sdhci_ops rtk_sdhci_ops = {
+    .reset = rtk_sdhci_reset,
+    .set_bus_width = rtk_sdhci_buswidth,
+    .set_uhs_signaling = rtk_sdhci_uhs_signaling,
+    .set_clock = rtk_sdhci_set_clock,
+#ifndef CONFIG_ARCH_RTD119X	//119X SDIO does not support SDIO 3.0
+    .platform_execute_tuning = rtk_sdhci_execute_tuning,
+#endif
+};
+
+static const struct sdhci_pltfm_data sdhci_rtk_sdio_pdata = {
+    .quirks = SDHCI_QUIRK_BROKEN_TIMEOUT_VAL |
+              SDHCI_QUIRK_SINGLE_POWER_WRITE |
+              SDHCI_QUIRK_NO_HISPD_BIT |
+              SDHCI_QUIRK_BROKEN_CARD_DETECTION|
+#ifdef CONFIG_ARCH_RTD119X	//it seems that 1195 phoenix has issues about ADMA
+	      SDHCI_QUIRK_BROKEN_ADMA|
+#endif
+              SDHCI_QUIRK_BROKEN_ADMA_ZEROLEN_DESC,
+    .quirks2 = SDHCI_QUIRK2_BROKEN_DDR50|
+               SDHCI_QUIRK2_PRESET_VALUE_BROKEN,
+    .ops  = &rtk_sdhci_ops,
+};
+
+static struct sdhci_rtk_sdio_data sdhci_rtk_sdio_data = {
+    .pdata = &sdhci_rtk_sdio_pdata,
+};
+
+static const struct of_device_id sdhci_rtk_dt_match[] = {
+    { .compatible = "Realtek,rtk1295-sdio", .data = &sdhci_rtk_sdio_data },
+    {}
+};
+MODULE_DEVICE_TABLE(of, sdhci_rtk_dt_match);
+
+static int sdhci_rtk_probe(struct platform_device *pdev)
+{
+    const struct of_device_id *match;
+    const struct sdhci_rtk_sdio_data *soc_data;
+    struct sdhci_host *host;
+    struct sdhci_pltfm_host *pltfm_host;
+    int rc = 0;
+
+    struct device_node *node = pdev->dev.of_node;
+
+    printk(KERN_INFO "%s: build at : %s \n", DRIVER_NAME, utsname()->version);
+
+    SDIO_module=true;
+
+    sdio_membase = of_iomap(node, 0);
+    if(!sdio_membase)
+        return -ENOMEM;
+
+    crt_membase = of_iomap(node, 1);
+    if(!crt_membase)
+        return -ENOMEM;
+
+    sdio_gpio_23 = of_get_gpio_flags(pdev->dev.of_node, 0, NULL);
+    if(gpio_is_valid(sdio_gpio_23)){
+        rc = gpio_request(sdio_gpio_23, "sdio_gpio(23)");
+        if (rc < 0)
+            printk(KERN_ERR "%s: can't request gpio %d\n", __func__, sdio_gpio_23);
+    }else
+        printk(KERN_ERR "%s: gpio %d is not valid\n", __func__, sdio_gpio_23);
+    match = of_match_device(sdhci_rtk_dt_match, &pdev->dev);
+    if(!match)
+        return -EINVAL;
+    soc_data = match->data;
+
+    rstc_sdio = devm_reset_control_get(&pdev->dev, NULL);
+    if (IS_ERR(rstc_sdio)) {
+	    printk(KERN_WARNING "%s: reset_control_get() returns %ld\n", __func__,
+		PTR_ERR(rstc_sdio));
+	    rstc_sdio = NULL;
+    }
+    clk_en_sdio = devm_clk_get(&pdev->dev, "sdio");
+    if (IS_ERR(clk_en_sdio)) {
+	    printk(KERN_WARNING "%s: clk_get() returns %ld\n", __func__,
+		PTR_ERR(clk_en_sdio));
+	    clk_en_sdio = NULL;
+    }
+    clk_en_sdio_ip = devm_clk_get(&pdev->dev, "sdio_ip");
+    if (IS_ERR(clk_en_sdio_ip)) {
+	    printk(KERN_WARNING "%s: clk_get() returns %ld\n", __func__,
+		PTR_ERR(clk_en_sdio_ip));
+	    clk_en_sdio_ip = NULL;
+    }
+#if defined(CONFIG_ARCH_RTD16xx)
+    if(get_rtd_chip_revision()==RTD_CHIP_A01) {
+	writel(readl(crt_membase + 0x1A0)|0x1, crt_membase + 0x1A0);
+	writel(readl(crt_membase + 0x1A4)|0x1, crt_membase + 0x1A4);
+	udelay(200);
+    }
+#elif defined(CONFIG_ARCH_RTD13xx)
+	writel(readl(crt_membase + 0x7064)|(0x3<<4), crt_membase + 0x7064);
+	udelay(200);
+#endif
+ 
+    host = sdhci_pltfm_init(pdev, soc_data->pdata, 0);
+    if(IS_ERR(host))
+        return PTR_ERR(host);
+    pltfm_host = sdhci_priv(host);
+
+#ifdef CONFIG_ARCH_RTD119X
+    host->mmc->caps = MMC_CAP_4_BIT_DATA |
+                      MMC_CAP_SD_HIGHSPEED |
+                      MMC_CAP_MMC_HIGHSPEED |
+                      MMC_CAP_NONREMOVABLE ;
+#else
+    host->mmc->caps = MMC_CAP_4_BIT_DATA |
+                      MMC_CAP_SD_HIGHSPEED |
+                      MMC_CAP_MMC_HIGHSPEED |
+                      MMC_CAP_UHS_SDR12 |
+                      MMC_CAP_UHS_SDR25 |
+                      MMC_CAP_UHS_SDR50 |
+                      MMC_CAP_UHS_SDR104 |
+                      MMC_CAP_NONREMOVABLE ;
+#endif
+    host->mmc->caps2 =  MMC_CAP2_NO_SD | MMC_CAP2_NO_MMC;
+    host->mmc->pm_caps = MMC_PM_KEEP_POWER | MMC_PM_WAKE_SDIO_IRQ;
+    G_host = host;
+    rc = sdhci_add_host(host);
+    if(rc)
+        goto err_add_host;
+
+    return 0;
+
+err_add_host:
+    sdhci_pltfm_free(pdev);
+    return rc;
+}
+
+static int sdhci_rtk_remove(struct platform_device *pdev)
+{
+    struct sdhci_host *host = platform_get_drvdata(pdev);
+    int dead = (readl(host->ioaddr + SDHCI_INT_STATUS) == 0xFFFFFFFF);
+
+    sdhci_remove_host(host, dead);
+    sdhci_pltfm_free(pdev);
+
+    return 0;
+}
+
+static int sdhci_rtk_suspend(struct device *dev){
+    printk(KERN_ERR "[SDIO] sdhci_rtk_suspend start\n");
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+    drive_temp = readl(crt_membase + 0x01A0);
+#endif
+    if(clock_enable==true) {
+    	struct sdhci_host *host = dev_get_drvdata(dev);
+    	sdhci_suspend_host(host);
+    }
+    printk(KERN_ERR "[SDIO] sdhci_rtk_suspend OK\n");
+    return 0;
+}
+
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+static void sdhci_rtk_shutdown(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	printk(KERN_ERR "[SDIO] sdhci_rtk_shutdown\n");
+	if(clock_enable==true) {
+		struct sdhci_host *host = dev_get_drvdata(dev);
+		sdhci_suspend_host(host);
+	}
+}
+#endif
+static int sdhci_rtk_resume(struct device *dev){
+
+    struct sdhci_host *host = dev_get_drvdata(dev);
+    //void __iomem *crt_membase;
+    void __iomem *addr;
+    unsigned int val;
+
+    //struct device_node *node = dev->of_node;
+
+    //struct clk * clk_en_sdio = clk_get(NULL, "clk_en_sdio");
+    //struct clk * clk_en_sdio_ip = clk_get(NULL, "clk_en_sdio_ip");
+
+    host->clock = 0;
+
+    printk(KERN_ERR "[SDIO] sdhci_rtk_resume start\n");
+    if(clock_enable==true) {
+    	addr = crt_membase + SDIO_CLKEN_REGOFF;
+
+    if(get_SDIO_version()==3 || get_SDIO_version()==4) {
+#ifdef CONFIG_ARCH_RTD129x
+	unsigned long flags2;
+#endif
+	if(readl(crt_membase+0x1a204)==0x00) {
+		//printk(KERN_ERR "SDIO 3.0 A00\n");
+#ifdef CONFIG_ARCH_RTD139x	//119x won't support SDIO 3.0, so we do not need to concern about this case
+		reset_control_deassert(rstc_sdio);
+#endif
+#if defined(CONFIG_ARCH_RTD129x)
+		writel(0x0000003b, crt_membase + 0x01A0);
+#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+		writel(drive_temp, crt_membase + 0x01A0);
+#endif
+
+#if defined(CONFIG_ARCH_RTD129x)
+		rtk_lockapi_lock(flags2, __FUNCTION__);
+		writel(0x0000bbbb, crt_membase + 0x1263c);
+		writel(0xbbbbbbbb, crt_membase + 0x12640);
+		rtk_lockapi_unlock(flags2, __FUNCTION__);
+#elif defined(CONFIG_ARCH_RTD139x)
+		writel(0x375EEB, crt_membase + 0x4E040);
+		writel(0x375EEB, crt_membase + 0x4E044);
+		writel(0x375EEB, crt_membase + 0x4E048);
+#elif defined(CONFIG_ARCH_RTD16xx)
+		writel((readl(crt_membase + 0x4E024)& 0xf) | 0x8F31E630, crt_membase + 0x4E024);
+		writel(0x1E63CC79, crt_membase + 0x4E028);
+		writel((readl(crt_membase + 0x4E02c)& 0xffffffc0) | 0x33, crt_membase + 0x4E02c);
+#elif defined(CONFIG_ARCH_RTD13xx)
+		writel((readl(crt_membase + 0x4E058)& 0xff000000) | 0x006C36C3, crt_membase + 0x4E058);
+		writel((readl(crt_membase + 0x4E05c)& 0xff000000) | 0x006C36C3, crt_membase + 0x4E05c);
+		writel((readl(crt_membase + 0x4E060)& 0xff000000) | 0x006C36C3, crt_membase + 0x4E060);
+#endif
+		if(get_SDIO_version()==3) {
+#ifdef CONFIG_ARCH_RTD129x
+			writel(0x00000001, crt_membase + 0x0018);
+#endif
+#ifndef CONFIG_ARCH_RTD119X	//119x does not have 1A0, 1A4, 1A8, 1AC PLL register, they use USB PLL
+			writel(0x00000006, crt_membase + 0x01AC);
+			writel(0x04517893, crt_membase + 0x01A4);
+			writel(0x00ae4388, crt_membase + 0x01A8); //SDIO 3.0, 200MHz
+			mdelay(2);
+			writel(0x00000007, crt_membase + 0x01AC);
+			udelay(200);
+#endif
+#ifdef CONFIG_ARCH_RTD129x
+			writel(0x00000000, crt_membase + 0x0018);
+#endif
+		}
+		else {
+#ifdef CONFIG_ARCH_RTD129x
+			writel(0x00000001, crt_membase + 0x0018);
+#endif
+#ifndef CONFIG_ARCH_RTD119X	//119x does not have 1A0, 1A4, 1A8, 1AC PLL register, they use USB PLL
+#ifdef CONFIG_ARCH_RTD16xx
+			writel(0x1d, crt_membase + 0x10a58);    //enlarge wait time for data
+#endif
+                        writel(0x00000006, crt_membase + 0x01AC);
+                        writel(0x04517893, crt_membase + 0x01A4);
+                        writel(0x00ae4388, crt_membase + 0x01A8); //SDIO 3.0, 200MHz
+                        mdelay(2);
+                        writel(0x00000007, crt_membase + 0x01AC);
+			udelay(200);
+#endif
+#ifdef CONFIG_ARCH_RTD129x
+                        writel(0x00000000, crt_membase + 0x0018);
+#endif
+		}
+#ifdef CONFIG_ARCH_RTD129x	//119x won't support SDIO 3.0, so we do not need to concern about this case
+		reset_control_deassert(rstc_sdio);
+#endif
+    		//writel(readl(crt_membase + 0x0C) | (1 << 30), crt_membase + 0x0C);
+    		//writel(readl(crt_membase + 0x0C) | (1 << 26), crt_membase + 0x0C);
+		//clk_prepare_enable(clk_en_sdio);	//cylee takes this action from framwork
+                //clk_prepare_enable(clk_en_sdio_ip);
+#ifndef CONFIG_ARCH_RTD119X
+    		writel(0x00000000, crt_membase + 0x010A40);
+#endif
+		writel(0x00000011, crt_membase + 0x010A34);
+	}
+	else {
+		reset_control_deassert(rstc_sdio);
+                //writel(readl(crt_membase + 0x0C) | (1 << 30), crt_membase + 0x0C);
+                //writel(readl(crt_membase + 0x0C) | (1 << 26), crt_membase + 0x0C);
+		//clk_prepare_enable(clk_en_sdio);
+                //clk_prepare_enable(clk_en_sdio_ip);
+#if defined(CONFIG_ARCH_RTD129x)
+		writel(0x0000003b, crt_membase + 0x01A0);
+#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+		writel(drive_temp, crt_membase + 0x01A0);
+#endif
+
+#if defined(CONFIG_ARCH_RTD129x)
+		rtk_lockapi_lock(flags2, __FUNCTION__);
+		writel(0x0000bbbb, crt_membase + 0x1263c);
+		writel(0xbbbbbbbb, crt_membase + 0x12640);
+		rtk_lockapi_unlock(flags2, __FUNCTION__);
+#elif defined(CONFIG_ARCH_RTD139x)
+                writel(0x375EEB, crt_membase + 0x4E040);
+                writel(0x375EEB, crt_membase + 0x4E044);
+                writel(0x375EEB, crt_membase + 0x4E048);
+#elif defined(CONFIG_ARCH_RTD16xx)
+		writel((readl(crt_membase + 0x4E024)& 0xf) | 0x8F31E630, crt_membase + 0x4E024);
+		writel(0x1E63CC79, crt_membase + 0x4E028);
+		writel((readl(crt_membase + 0x4E02c)& 0xffffffc0) | 0x33, crt_membase + 0x4E02c);
+#elif defined(CONFIG_ARCH_RTD13xx)
+		writel((readl(crt_membase + 0x4E058)& 0xff000000) | 0x006C36C3, crt_membase + 0x4E058);
+		writel((readl(crt_membase + 0x4E05c)& 0xff000000) | 0x006C36C3, crt_membase + 0x4E05c);
+		writel((readl(crt_membase + 0x4E060)& 0xff000000) | 0x006C36C3, crt_membase + 0x4E060);
+#endif
+		if(get_SDIO_version()==3) {
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_ARCH_RTD129x
+			writel(0x40000000, crt_membase+ 0x10a58);
+#endif
+			writel(0x00000006, crt_membase + 0x01AC);
+			writel(0x04517893, crt_membase + 0x01A4);
+			writel(0x00ae4388, crt_membase + 0x01A8); //SDIO 3.0, 200MHz
+			mdelay(2);
+			writel(0x00000007, crt_membase + 0x01AC);
+			udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+			writel(0x00000000, crt_membase+ 0x10a58);
+#endif
+#endif
+		}
+		else {
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_ARCH_RTD16xx
+			writel(0x1d, crt_membase + 0x10a58);    //enlarge wait time for data
+#endif
+#ifdef CONFIG_ARCH_RTD129x
+			writel(0x40000000, crt_membase+ 0x10a58);
+#endif
+                        writel(0x00000006, crt_membase + 0x01AC);
+                        writel(0x04517893, crt_membase + 0x01A4);
+                        writel(0x00ae4388, crt_membase + 0x01A8); //SDIO 3.0, 200MHz
+                        mdelay(2);
+                        writel(0x00000007, crt_membase + 0x01AC);
+			udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+                        writel(0x00000000, crt_membase+ 0x10a58);
+#endif
+#endif
+		}
+#ifndef CONFIG_ARCH_RTD119X	//119x does not have A40 register
+		writel(0x00000000, crt_membase + 0x010A40);
+#endif
+		writel(0x00000011, crt_membase + 0x010A34);
+	}
+    }
+    else {
+	if(readl(crt_membase+0x1a204)==0x00) {
+#ifdef CONFIG_ARCH_RTD129x
+    		writel(0x00000001, crt_membase + 0x0018);
+#endif
+#ifndef CONFIG_ARCH_RTD119X
+    		writel(0x00000006, crt_membase + 0x01AC);
+    		writel(0x04517893, crt_membase + 0x01A4);
+		writel(0x00ae4388, crt_membase + 0x01A8); //SDIO 2.0, 100MHz
+    		mdelay(2);
+    		writel(0x00000007, crt_membase + 0x01AC);
+		udelay(200);
+#endif
+#ifdef CONFIG_ARCH_RTD129x
+    		writel(0x00000000, crt_membase + 0x0018);
+#endif
+		reset_control_deassert(rstc_sdio);
+    		//writel(readl(crt_membase + 0x0C) | (1 << 30), crt_membase + 0x0C);
+    		//writel(readl(crt_membase + 0x0C) | (1 << 26), crt_membase + 0x0C);
+		//clk_prepare_enable(clk_en_sdio);
+                //clk_prepare_enable(clk_en_sdio_ip);
+		writel(0x00000011, crt_membase + 0x010A34);
+	}else {
+		reset_control_deassert(rstc_sdio);
+                //writel(readl(crt_membase + 0x0C) | (1 << 30), crt_membase + 0x0C);
+                //writel(readl(crt_membase + 0x0C) | (1 << 26), crt_membase + 0x0C);
+		//clk_prepare_enable(clk_en_sdio);
+                //clk_prepare_enable(clk_en_sdio_ip);
+//		writel(0x00000001, crt_membase + 0x0018);
+#ifndef CONFIG_ARCH_RTD119X
+#ifdef CONFIG_ARCH_RTD129x
+		writel(0x40000000, crt_membase+ 0x10a58);
+#endif
+                writel(0x00000006, crt_membase + 0x01AC);
+                writel(0x04517893, crt_membase + 0x01A4);
+		writel(0x00ae4388, crt_membase + 0x01A8); //SDIO 2.0, 100MHz
+                mdelay(2);
+                writel(0x00000007, crt_membase + 0x01AC);
+		udelay(200);
+#ifdef CONFIG_ARCH_RTD129x
+		writel(0x00000000, crt_membase+ 0x10a58);
+#endif
+#endif
+//              writel(0x00000000, crt_membase + 0x0018);
+		writel(0x00000011, crt_membase + 0x010A34);
+	}
+}
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	writel(0x00000001, crt_membase + 0x010A10);
+#else
+	writel(0x00000003, crt_membase + 0x010A10);
+#endif
+    //printk(KERN_INFO "crt_membase + SDIO_CLKEN_REGOFF = %llx\n", (u64)(crt_membase + SDIO_CLKEN_REGOFF));
+    	val = readl(addr);
+    	val  |=  1 << (SDIO_CLKEN_REGBIT);
+    	writel(val, addr);
+
+    	val = readl(host->ioaddr + 0x28);
+//    printk(KERN_ERR "read(host->ioaddr + 0x28) = %x\n", val);
+    	val  |=  0x0f << 8;
+    	writel(val, host->ioaddr + 0x28);
+    	val = readl(host->ioaddr + 0x28);
+//    printk(KERN_ERR "read(host->ioaddr + 0x28) = %x\n", val);
+
+    	sdhci_resume_host(host);
+    }
+    printk(KERN_ERR "[SDIO] sdhci_rtk_resume OK\n");
+    return 0;
+}
+
+const struct dev_pm_ops sdhci_rtk_pmops = {
+    .suspend = sdhci_rtk_suspend,
+    .resume = sdhci_rtk_resume,
+};
+
+static struct platform_driver sdhci_rtk_driver = {
+    .driver = {
+        .name = DRIVER_NAME,
+        .owner = THIS_MODULE,
+        .of_match_table = sdhci_rtk_dt_match,
+        //.pm    = SDHCI_PLTFM_PMOPS,
+        .pm = &sdhci_rtk_pmops,
+    },
+    .probe = sdhci_rtk_probe,
+    .remove = sdhci_rtk_remove,
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+    .shutdown = sdhci_rtk_shutdown,
+#endif
+};
+
+module_platform_driver(sdhci_rtk_driver);
+
+MODULE_DESCRIPTION("SDHCI host driver for Realtek");
diff --git a/drivers/mmc/host/sdhci-rtk.h b/drivers/mmc/host/sdhci-rtk.h
new file mode 100644
index 00000000..c0eace7
--- /dev/null
+++ b/drivers/mmc/host/sdhci-rtk.h
@@ -0,0 +1,27 @@
+#ifndef DRIVERS_CLOCK_ADJUST_RTK_WIFI_H_
+#define DRIVERS_CLOCK_ADJUST_RTK_WIFI_H_
+
+#ifdef CONFIG_RTK_SDIO_CLK_ADJUST
+extern void rtk_adjust_clock_for_wifi(unsigned int channel,unsigned int ch_offset, unsigned int bwmode);
+#define PRI_CH_OFFSET_DONT_CARE		0
+#define PRI_CH_OFFSET_LOWER		1
+#define PRI_CH_OFFSET_UPPER		2
+
+#define	CH_WIDTH_20	0
+#define	CH_WIDTH_40	1
+#define	CH_WIDTH_80	2
+
+struct _sdio_clk_reg {
+	unsigned int reg1a4;
+	unsigned int reg1a8;
+};
+
+typedef struct _wifi_sdio_clk_tbl {
+	int channel;
+	unsigned char lower;
+	unsigned char upper;
+	struct _sdio_clk_reg map[2];
+} wifi_sdio_clk_tbl;
+#endif
+
+#endif
diff --git a/drivers/mmc/host/sdhci.c b/drivers/mmc/host/sdhci.c
old mode 100644
new mode 100755
index 44ea9d8..ab7062d
--- a/drivers/mmc/host/sdhci.c
+++ b/drivers/mmc/host/sdhci.c
@@ -47,60 +47,71 @@
 
 static void sdhci_enable_preset_value(struct sdhci_host *host, bool enable);
 
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)|| defined(CONFIG_ARCH_RTD13xx)
+#ifdef CONFIG_MMC_SDHCI_RTK
+void Disable_sdio_irq(struct sdhci_host *host)
+{
+	sdhci_writel(host, 0, SDHCI_INT_ENABLE);
+	sdhci_writel(host, 0, SDHCI_SIGNAL_ENABLE);
+}
+EXPORT_SYMBOL(Disable_sdio_irq);
+#endif
+#endif
+
 static void sdhci_dumpregs(struct sdhci_host *host)
 {
-	pr_err(DRIVER_NAME ": =========== REGISTER DUMP (%s)===========\n",
+	pr_debug(DRIVER_NAME ": =========== REGISTER DUMP (%s)===========\n",
 	       mmc_hostname(host->mmc));
 
-	pr_err(DRIVER_NAME ": Sys addr: 0x%08x | Version:  0x%08x\n",
+	pr_debug(DRIVER_NAME ": Sys addr: 0x%08x | Version:  0x%08x\n",
 	       sdhci_readl(host, SDHCI_DMA_ADDRESS),
 	       sdhci_readw(host, SDHCI_HOST_VERSION));
-	pr_err(DRIVER_NAME ": Blk size: 0x%08x | Blk cnt:  0x%08x\n",
+	pr_debug(DRIVER_NAME ": Blk size: 0x%08x | Blk cnt:  0x%08x\n",
 	       sdhci_readw(host, SDHCI_BLOCK_SIZE),
 	       sdhci_readw(host, SDHCI_BLOCK_COUNT));
-	pr_err(DRIVER_NAME ": Argument: 0x%08x | Trn mode: 0x%08x\n",
+	pr_debug(DRIVER_NAME ": Argument: 0x%08x | Trn mode: 0x%08x\n",
 	       sdhci_readl(host, SDHCI_ARGUMENT),
 	       sdhci_readw(host, SDHCI_TRANSFER_MODE));
-	pr_err(DRIVER_NAME ": Present:  0x%08x | Host ctl: 0x%08x\n",
+	pr_debug(DRIVER_NAME ": Present:  0x%08x | Host ctl: 0x%08x\n",
 	       sdhci_readl(host, SDHCI_PRESENT_STATE),
 	       sdhci_readb(host, SDHCI_HOST_CONTROL));
-	pr_err(DRIVER_NAME ": Power:    0x%08x | Blk gap:  0x%08x\n",
+	pr_debug(DRIVER_NAME ": Power:    0x%08x | Blk gap:  0x%08x\n",
 	       sdhci_readb(host, SDHCI_POWER_CONTROL),
 	       sdhci_readb(host, SDHCI_BLOCK_GAP_CONTROL));
-	pr_err(DRIVER_NAME ": Wake-up:  0x%08x | Clock:    0x%08x\n",
+	pr_debug(DRIVER_NAME ": Wake-up:  0x%08x | Clock:    0x%08x\n",
 	       sdhci_readb(host, SDHCI_WAKE_UP_CONTROL),
 	       sdhci_readw(host, SDHCI_CLOCK_CONTROL));
-	pr_err(DRIVER_NAME ": Timeout:  0x%08x | Int stat: 0x%08x\n",
+	pr_debug(DRIVER_NAME ": Timeout:  0x%08x | Int stat: 0x%08x\n",
 	       sdhci_readb(host, SDHCI_TIMEOUT_CONTROL),
 	       sdhci_readl(host, SDHCI_INT_STATUS));
-	pr_err(DRIVER_NAME ": Int enab: 0x%08x | Sig enab: 0x%08x\n",
+	pr_debug(DRIVER_NAME ": Int enab: 0x%08x | Sig enab: 0x%08x\n",
 	       sdhci_readl(host, SDHCI_INT_ENABLE),
 	       sdhci_readl(host, SDHCI_SIGNAL_ENABLE));
-	pr_err(DRIVER_NAME ": AC12 err: 0x%08x | Slot int: 0x%08x\n",
+	pr_debug(DRIVER_NAME ": AC12 err: 0x%08x | Slot int: 0x%08x\n",
 	       sdhci_readw(host, SDHCI_ACMD12_ERR),
 	       sdhci_readw(host, SDHCI_SLOT_INT_STATUS));
-	pr_err(DRIVER_NAME ": Caps:     0x%08x | Caps_1:   0x%08x\n",
+	pr_debug(DRIVER_NAME ": Caps:     0x%08x | Caps_1:   0x%08x\n",
 	       sdhci_readl(host, SDHCI_CAPABILITIES),
 	       sdhci_readl(host, SDHCI_CAPABILITIES_1));
-	pr_err(DRIVER_NAME ": Cmd:      0x%08x | Max curr: 0x%08x\n",
+	pr_debug(DRIVER_NAME ": Cmd:      0x%08x | Max curr: 0x%08x\n",
 	       sdhci_readw(host, SDHCI_COMMAND),
 	       sdhci_readl(host, SDHCI_MAX_CURRENT));
-	pr_err(DRIVER_NAME ": Host ctl2: 0x%08x\n",
+	pr_debug(DRIVER_NAME ": Host ctl2: 0x%08x\n",
 	       sdhci_readw(host, SDHCI_HOST_CONTROL2));
 
 	if (host->flags & SDHCI_USE_ADMA) {
 		if (host->flags & SDHCI_USE_64_BIT_DMA)
-			pr_err(DRIVER_NAME ": ADMA Err: 0x%08x | ADMA Ptr: 0x%08x%08x\n",
+			pr_debug(DRIVER_NAME ": ADMA Err: 0x%08x | ADMA Ptr: 0x%08x%08x\n",
 			       readl(host->ioaddr + SDHCI_ADMA_ERROR),
 			       readl(host->ioaddr + SDHCI_ADMA_ADDRESS_HI),
 			       readl(host->ioaddr + SDHCI_ADMA_ADDRESS));
 		else
-			pr_err(DRIVER_NAME ": ADMA Err: 0x%08x | ADMA Ptr: 0x%08x\n",
+			pr_debug(DRIVER_NAME ": ADMA Err: 0x%08x | ADMA Ptr: 0x%08x\n",
 			       readl(host->ioaddr + SDHCI_ADMA_ERROR),
 			       readl(host->ioaddr + SDHCI_ADMA_ADDRESS));
 	}
 
-	pr_err(DRIVER_NAME ": ===========================================\n");
+	pr_debug(DRIVER_NAME ": ===========================================\n");
 }
 
 /*****************************************************************************\
@@ -234,6 +245,10 @@ static void sdhci_init(struct sdhci_host *host, int soft)
 		host->ier |= SDHCI_INT_RETUNE;
 
 	sdhci_writel(host, host->ier, SDHCI_INT_ENABLE);
+#if defined CONFIG_ARCH_RTD13xx
+	if (readl(host->ioaddr+0x9604)==0x00)
+		host->ier &= ~SDHCI_INT_CRC;
+#endif
 	sdhci_writel(host, host->ier, SDHCI_SIGNAL_ENABLE);
 
 	if (soft) {
@@ -2891,7 +2906,7 @@ int sdhci_resume_host(struct sdhci_host *host)
 	if (!device_may_wakeup(mmc_dev(host->mmc))) {
 		ret = request_threaded_irq(host->irq, sdhci_irq,
 					   sdhci_thread_irq, IRQF_SHARED,
-					   mmc_hostname(host->mmc), host);
+					   DRIVER_NAME, host);
 		if (ret)
 			return ret;
 	} else {
@@ -3064,6 +3079,14 @@ void __sdhci_read_caps(struct sdhci_host *host, u16 *ver, u32 *caps, u32 *caps1)
 
 	host->caps = caps ? *caps : sdhci_readl(host, SDHCI_CAPABILITIES);
 
+#ifdef CONFIG_MMC_SDHCI_RTK
+#ifdef CONFIG_ARCH_RTD119X
+	host->caps |= SDHCI_CAN_VDD_330;
+#else
+        host->caps |= (SDHCI_CAN_VDD_180 | SDHCI_CAN_VDD_330);
+#endif
+#endif
+
 	if (host->version < SDHCI_SPEC_300)
 		return;
 
@@ -3099,6 +3122,17 @@ int sdhci_setup_host(struct sdhci_host *host)
 	sdhci_read_caps(host);
 
 	override_timeout_clk = host->timeout_clk;
+#ifdef CONFIG_MMC_SDHCI_RTK
+#ifdef CONFIG_ARCH_RTD119X
+	host->version = SDHCI_SPEC_200;
+#else
+        host->version = SDHCI_SPEC_300;         //workaround, kylin register cannot be showed correctly, so just set host capability 3.0
+#endif
+#else
+        host->version = sdhci_readw(host, SDHCI_HOST_VERSION);
+        host->version = (host->version & SDHCI_SPEC_VER_MASK)
+                                >> SDHCI_SPEC_VER_SHIFT;
+#endif
 
 	if (host->version > SDHCI_SPEC_300) {
 		pr_err("%s: Unknown controller version (%d). You may experience problems.\n",
@@ -3209,14 +3243,19 @@ int sdhci_setup_host(struct sdhci_host *host)
 		host->dma_mask = DMA_BIT_MASK(64);
 		mmc_dev(mmc)->dma_mask = &host->dma_mask;
 	}
-
+#ifdef CONFIG_MMC_SDHCI_RTK
+        if (host->version >= SDHCI_SPEC_300)
+                host->max_clk = 200;
+        else
+                host->max_clk = 100;
+#else
 	if (host->version >= SDHCI_SPEC_300)
 		host->max_clk = (host->caps & SDHCI_CLOCK_V3_BASE_MASK)
 			>> SDHCI_CLOCK_BASE_SHIFT;
 	else
 		host->max_clk = (host->caps & SDHCI_CLOCK_BASE_MASK)
 			>> SDHCI_CLOCK_BASE_SHIFT;
-
+#endif
 	host->max_clk *= 1000000;
 	if (host->max_clk == 0 || host->quirks &
 			SDHCI_QUIRK_CAP_CLOCK_BASE_BROKEN) {
@@ -3588,7 +3627,7 @@ int __sdhci_add_host(struct sdhci_host *host)
 	sdhci_init(host, 0);
 
 	ret = request_threaded_irq(host->irq, sdhci_irq, sdhci_thread_irq,
-				   IRQF_SHARED,	mmc_hostname(mmc), host);
+				   IRQF_SHARED,	DRIVER_NAME, host);
 	if (ret) {
 		pr_err("%s: Failed to request IRQ %d: %d\n",
 		       mmc_hostname(mmc), host->irq, ret);
diff --git a/drivers/mmc/host/sdhci.h b/drivers/mmc/host/sdhci.h
index 2570455..d157605 100644
--- a/drivers/mmc/host/sdhci.h
+++ b/drivers/mmc/host/sdhci.h
@@ -690,6 +690,10 @@ void sdhci_set_power_noreg(struct sdhci_host *host, unsigned char mode,
 void sdhci_reset(struct sdhci_host *host, u8 mask);
 void sdhci_set_uhs_signaling(struct sdhci_host *host, unsigned timing);
 
+#ifdef CONFIG_RTK_PLATFORM
+void rtk_sdhci_close_clk(void);
+#endif /* CONFIG_RTK_PLATFORM */
+
 #ifdef CONFIG_PM
 extern int sdhci_suspend_host(struct sdhci_host *host);
 extern int sdhci_resume_host(struct sdhci_host *host);
diff --git a/drivers/mmc/host/sdmmc_export.c b/drivers/mmc/host/sdmmc_export.c
new file mode 100644
index 00000000..bb35a27
--- /dev/null
+++ b/drivers/mmc/host/sdmmc_export.c
@@ -0,0 +1,35 @@
+/*
+ * Realtek SD/MMC/mini SD card driver
+ *
+ * Authors:
+ * Copyright (C) 2017 Realtek Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifdef CONFIG_SUSPEND
+
+#include <linux/suspend.h>
+
+int get_RTK_PM_STATE(void) {
+	return RTK_PM_STATE;
+}
+
+EXPORT_SYMBOL(get_RTK_PM_STATE);
+
+#endif //CONFIG_SUSPEND
+
+int initial_flag2=0;
+
+int get_RTK_initial_flag(void) {
+        return initial_flag2;
+}
+
+EXPORT_SYMBOL(get_RTK_initial_flag);
+
+void set_RTK_initial_flag(int flag) {
+        initial_flag2=flag;
+}
+
+EXPORT_SYMBOL(set_RTK_initial_flag);
diff --git a/drivers/mtd/chips/Kconfig b/drivers/mtd/chips/Kconfig
index bbfa1f1..ca48b70 100644
--- a/drivers/mtd/chips/Kconfig
+++ b/drivers/mtd/chips/Kconfig
@@ -237,4 +237,48 @@ config MTD_XIP
 	  used for XIP purposes.  If you're not sure what this is all about
 	  then say N.
 
+config MTD_RTK_SFC
+        tristate "Realtek Serial Flash Controller for SPI Flash"
+        default y
+        help
+          This is used by SST/SPANSION/MXIC SPI Serial Flash with
+          Realtek Serial Flash Controller.
+
+config MTD_RTK_SFC_READ_MD
+        bool "Support MD Read"
+        depends on MTD_RTK_SFC
+        default y
+        help
+          Enable Move Data Engine(MD) to accelerate FLASH-to-DDR performance
+
+config MTD_RTK_SFC_WRITE_MD
+        bool "Support MD Write"
+        depends on MTD_RTK_SFC
+        default y
+        help
+          Enable Move Data Engine(MD) to accelerate DDR-to-FLASH performance
+
+config MTD_RTK_SFC_DEBUG
+        bool "Logging Serial Flash Controller Activities"
+        depends on MTD_RTK_SFC
+        default n
+        help
+          Enable Logging of serial flash controller activities for debug purpose
+	  
+config MTD_RTK_SFC_PSTORE
+	tristate "Realtek SPI flash backend for pstore"
+	depends on MTD_RTK_SFC
+	select PSTORE
+	default n
+	help
+	  This is used by SST/SPANSION/MXIC SPI Serial Flash with
+	  Realtek Serial Flash Controller.
+
+config NOR_AUTO_HW_POLLING
+	bool "Enable auto hardware polling for nor flash driver"
+	depends on MTD_RTK_SFC
+	default y
+	help
+	  Setting this to 'n' will disable auto hardware polling for nor flash driver.
+
 endmenu
diff --git a/drivers/mtd/chips/Makefile b/drivers/mtd/chips/Makefile
index 3658241..c34b141 100644
--- a/drivers/mtd/chips/Makefile
+++ b/drivers/mtd/chips/Makefile
@@ -13,3 +13,5 @@ obj-$(CONFIG_MTD_JEDECPROBE)	+= jedec_probe.o
 obj-$(CONFIG_MTD_RAM)		+= map_ram.o
 obj-$(CONFIG_MTD_ROM)		+= map_rom.o
 obj-$(CONFIG_MTD_ABSENT)	+= map_absent.o
+obj-$(CONFIG_MTD_RTK_SFC)   += rtk_sfc.o
+obj-$(CONFIG_MTD_RTK_SFC_PSTORE)+= rtk_sfc_pstore.o
diff --git a/drivers/mtd/chips/rtk_sfc.c b/drivers/mtd/chips/rtk_sfc.c
new file mode 100644
index 00000000..617d829
--- /dev/null
+++ b/drivers/mtd/chips/rtk_sfc.c
@@ -0,0 +1,4126 @@
+/*
+ * MTD chip driver for SPI Serial Flash 
+ * w/ Serial Flash Controller Interface
+ *
+ * Copyright 2005 Chih-pin Wu <wucp@realtek.com.tw>
+ * Copyright 2014 Louis Yang  <louis_yang@realtek.com>
+ *
+ */
+
+//#define CONFIG_MTD_RTK_MD_READ_COMPARE
+//#define CONFIG_MTD_RTK_MD_WRITE_COMPARE
+//#define DEV_DEBUG
+#define EMMC_ISSUE_LOCK
+
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/types.h>
+#include <linux/errno.h>
+#include <linux/mtd/physmap.h>
+
+#include <linux/module.h>
+#include <linux/mtd/mtd.h>
+#include <linux/mtd/map.h>
+#include <linux/mtd/cfi.h>
+#include <linux/mtd/partitions.h>
+#include <linux/slab.h>
+#include <linux/sysctl.h>
+#include <linux/sched.h>
+#include <linux/list.h>
+#include <linux/pm.h>
+#include <asm/io.h>
+#include <linux/bitops.h>
+#include <mtd/mtd-abi.h>
+#include <linux/jiffies.h>
+#include <linux/delay.h>
+#include <linux/time.h>
+#include <linux/proc_fs.h>
+#include <linux/string.h>
+#include <linux/platform_device.h>
+#include <linux/interrupt.h>
+#include <linux/dma-mapping.h>
+#include "../mtdcore.h"
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+#include <linux/slab.h>
+#endif
+#include "rtk_sfc.h"
+#ifdef EMMC_ISSUE_LOCK
+#include <soc/realtek/rtd129x_lockapi.h>
+#endif
+
+
+/*
+ * Mapping drivers for chip access
+ */
+#undef CONFIG_MTD_COMPLEX_MAPPINGS
+
+
+/*
+ * Definitions
+ */
+//#define dma_cache_sync(a,b,c,d) dma_map_single(NULL,b,c,d)
+
+#if  defined(CONFIG_REALTEK_USE_HWSEM_AS_SENTINEL)
+#define SFC_USE_DELAY   (0)
+#else
+#define SFC_USE_DELAY   (1)
+#endif
+
+#ifdef CONFIG_NOR_SUPPORT_MAX_ERASE_SIZE
+#define NOR_SUPPORT_MAX_ERASE_SIZE  (1)
+#else
+#define NOR_SUPPORT_MAX_ERASE_SIZE  (0)
+#endif
+
+#ifdef CONFIG_NOR_ENTER_4BYTES_MODE
+#define ENTER_4BYTES_MODE   (1)
+#else
+#define ENTER_4BYTES_MODE   (0)
+#endif
+
+#ifdef CONFIG_NOR_AUTO_HW_POLLING
+#define SFC_HW_POLL         (1)
+#else
+#define SFC_HW_POLL         (0)
+#endif
+
+#ifdef CONFIG_MTD_RTK_SFC_MULTI_READ
+#define SFC_MULTI_READ      (1)
+#else
+#define SFC_MULTI_READ      (0)
+#endif
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+typedef enum {
+    INVALID             = 0,
+    READ_ACCESS         = 0x10000000,
+    READ_COMPLETED      = 0x01000000,
+    WRITE_ACCESS        = 0x20000000,
+    WRITE_COMPLETED     = 0x02000000,
+    ERASE_ACCESS        = 0x40000000,
+    ERASE_COMPLETED     = 0x04000000,
+
+    READ_READY          = 0x00000001,
+    READ_STAGE_1        = 0x00000002,
+    READ_STAGE_2        = 0x00000004,
+    READ_STAGE_3        = 0x00000008,
+    WRITE_READY         = 0x00000100,
+    WRITE_STAGE_1       = 0x00000200,
+    WRITE_STAGE_2       = 0x00000400,
+    WRITE_STAGE_3       = 0x00000800,
+    WRITE_STAGE_4       = 0x00001000,
+    WRITE_STAGE_5       = 0x00002000,
+} PROGRESS_STATUS;
+
+typedef struct _tagDescriptorTable {
+    int from;
+    int to;
+    int length;
+    PROGRESS_STATUS status;
+} DESCRIPTOR_TABLE;
+
+#define DBG_ENTRY_NUM 256
+
+static int *dbg_counter = NULL;
+static DESCRIPTOR_TABLE *dbg_table = NULL;
+#endif
+
+
+/*
+ * Global Variables
+ */
+static void __iomem *rbus_base_virt = 0;
+static void __iomem *nor_base_virt = 0;
+
+static resource_size_t nor_size;
+
+struct SFC_REG_INFO {
+    unsigned int sfc_sck;
+    unsigned int sfc_ce;
+    unsigned int sfc_wp;
+    unsigned int sfc_pos_latch;
+};
+static struct SFC_REG_INFO g_sfc_reg;
+
+static volatile unsigned char *FLASH_POLL_ADDR;
+static volatile unsigned char *FLASH_BASE;
+
+static struct mtd_info descriptor;
+static rtk_sfc_info_t rtk_sfc_info;
+
+static struct rw_semaphore rw_sem;
+
+unsigned int g_isSegErase = 0;
+
+#ifdef CONFIG_MTD_RTK_SFC_READ_MD
+static void *read_dma_buf = NULL;
+static dma_addr_t read_dma_handle;
+#endif
+
+#ifdef CONFIG_MTD_RTK_SFC_WRITE_MD
+static void *write_dma_buf = NULL;
+static dma_addr_t write_dma_handle;
+#endif
+
+
+/*
+ * Function Prototype
+ */
+static int rtk_sfc_attach(struct mtd_info *mtd_info);
+#if SFC_USE_DELAY
+static inline void sfc_delay(void);
+#define delaymicro 50
+#endif
+
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+static inline void add_debug_entry(int from, int to, int length, PROGRESS_STATUS status) {
+    if(dbg_counter && dbg_table) {
+        if((*dbg_counter) < (DBG_ENTRY_NUM - 1))
+            (*dbg_counter)++;
+        else
+            (*dbg_counter) = 0;
+
+        dbg_table[*dbg_counter].from = from;
+        dbg_table[*dbg_counter].to = to;
+        dbg_table[*dbg_counter].length = length;
+        dbg_table[*dbg_counter].status = status;
+    }
+}
+
+static inline void change_status(PROGRESS_STATUS status) {
+    if(dbg_counter && dbg_table)
+        dbg_table[*dbg_counter].status |= status;
+}
+#endif
+
+
+void inline setSSTWrteStutReg(void)//Only for MXIC 256/128 MB . Add by alexchang 1217-2010
+{
+    unsigned char tmp;  
+    /* EWSR: enable write status register */
+    SFC_SYNC;
+    printk("[%s]\n",__FUNCTION__);
+
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x0000050, SFC_OPCODE);
+
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+
+    REG_WRITE_U32(0x00000000, SFC_CTL);
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;
+
+    tmp = (unsigned char)*((volatile unsigned char*)FLASH_POLL_ADDR);
+
+}
+
+static unsigned int endian_swap(unsigned int x)
+{
+    x = (x>>24) |((x<<8) & 0x00FF0000) |((x>>8) & 0x0000FF00) |(x<<24);
+    return x;
+}
+
+#if SFC_USE_DELAY
+static inline void sfc_delay(void) {
+    udelay(delaymicro);
+}
+#endif
+
+static inline void _switch_to_read_mode(rtk_sfc_info_t *sfc_info, rtk_sfc_read_mode_t mode) {
+
+    unsigned int sfc_opcode;
+    unsigned int sfc_ctl;
+    unsigned int tmp;
+
+    /* restore opcode to read */
+    sfc_opcode = 0x00000003;
+    sfc_ctl = 0x00000018;
+
+    SFC_SYNC;
+    SYS_REG_TRY_LOCK(0);
+    REG_WRITE_U32(sfc_opcode, SFC_OPCODE);
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+    REG_WRITE_U32(sfc_ctl, SFC_CTL);
+    tmp = *(volatile unsigned int*)(FLASH_BASE);
+    SYS_REG_TRY_UNLOCK;
+    SFC_SYNC;
+
+    return;
+}
+//---------------------------------------------------------------------------------------------
+
+static int read_rems(rtk_sfc_info_t *sfc_info, unsigned char *byte1, unsigned char*byte2) 
+{
+    SFC_SYNC;
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x00000090, SFC_OPCODE);  /* Read Electronic Manufacturer & Device ID */
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+
+    REG_WRITE_U32(0x0000001a, SFC_CTL); /* dataen = 1, adren = 0, dmycnt = 3 */
+    SYS_REG_TRY_UNLOCK;
+    SFC_SYNC;
+
+    *byte1 = *((volatile unsigned char*)(FLASH_POLL_ADDR + 0));
+
+    printk("*byte1=0x%x \n",*byte1);
+    SFC_SYNC;
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x00000090, SFC_OPCODE);  /* Read Electronic Manufacturer & Device ID */
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+
+    REG_WRITE_U32(0x0000001a, SFC_CTL); /* dataen = 1, adren = 0, dmycnt = 3 */
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;
+
+    *byte2 = *((volatile unsigned char*)(FLASH_POLL_ADDR + 1));
+    printk("*byte2=0x%x \n",*byte2);
+
+    return 0;
+}
+
+#if ENTER_4BYTES_MODE
+static int en_4bytes_addr_mode(void) {
+    volatile unsigned char tmp2;
+
+    SFC_SYNC;
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x000000b7, SFC_OPCODE);  /* enter 4-bytes address mode */
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+
+    REG_WRITE_U32(0x00000000, SFC_CTL);
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;   
+    tmp2 = *(volatile unsigned char *)FLASH_POLL_ADDR;
+
+    return 0;
+
+}
+
+static int exit_4bytes_addr_mode(void) {
+    volatile unsigned char tmp2;
+
+    SFC_SYNC;
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x000000e9, SFC_OPCODE);  /* exit 4-bytes address mode */
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+
+    REG_WRITE_U32(0x00000000, SFC_CTL);
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;   
+    tmp2 = *(volatile unsigned char *)FLASH_POLL_ADDR;
+
+    return 0;
+
+}
+#endif
+/*--------------------------------------------------------------------------------
+  FM serial flash information list
+  [FM 25Q64B] 64Mbit
+  erase size: 32KB / 64KB 
+  --------------------------------------------------------------------------------*/
+static int fm_init(rtk_sfc_info_t *sfc_info) {
+    switch(sfc_info->device_id1) {
+        case 0x40:
+            switch(sfc_info->device_id2) {
+                case 0x17:
+                    printk(KERN_NOTICE "RtkSFC MTD: FM 25Q64B detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x800000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: FM unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            break;
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: FM unknown id1=0x%x detected.\n",
+                    sfc_info->device_id1);
+            break;
+    }
+    if(sfc_info->erase_opcode==0xFFFFFFFF)//Set to default.
+    {
+        SFC_4KB_ERASE;
+    }
+    return 0;
+}
+/*--------------------------------------------------------------------------------
+  GD serial flash information list
+  [GD 25Q16B] 16Mbit
+  erase size: 32KB / 64KB
+
+  [GD 25Q64B] 64Mbit
+  erase size: 32KB / 64KB 
+
+  [GD 25Q128B] 128Mbit
+  erase size: 32KB / 64KB
+  --------------------------------------------------------------------------------*/
+static int gd_init(rtk_sfc_info_t *sfc_info) {
+    switch(sfc_info->device_id1) {
+        case 0x40:
+            switch(sfc_info->device_id2) {
+                case 0x14:
+                    printk(KERN_NOTICE "RtkSFC MTD: GD 25Q08B detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x00100000;
+                    break;
+                case 0x15:
+                    printk(KERN_NOTICE "RtkSFC MTD: GD 25Q16B detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x200000;
+                    break;
+                case 0x16:
+                    printk(KERN_NOTICE "RtkSFC MTD: GD 25Q32B detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;  
+                case 0x17:
+                    printk(KERN_NOTICE "RtkSFC MTD: GD 25Q64B detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x800000;
+                    break;
+                case 0x18:
+                    printk(KERN_NOTICE "RtkSFC MTD: GD 25Q128B detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: GD unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            break;
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: GD unknown id1=0x%x detected.\n",
+                    sfc_info->device_id1);
+            break;
+    }
+    if(sfc_info->erase_opcode==0xFFFFFFFF)//Set to default.
+    {
+        SFC_4KB_ERASE;
+    }
+    return 0;
+}
+
+/*--------------------------------------------------------------------------------
+  SST serial flash information list
+  [SST 25VF016B] 16Mbit
+  erase size: 4KB / 32KB / 64KB
+
+  [SST 25VF040B] 4Mbit
+  erase size: 4KB / 32KB / 64KB
+  --------------------------------------------------------------------------------*/
+static int sst_init(rtk_sfc_info_t *sfc_info) {
+    switch(sfc_info->device_id1) {
+        case 0x25:
+            switch(sfc_info->device_id2) {
+                case 0x41:
+                    printk(KERN_NOTICE "RtkSFC MTD: SST 25VF016B detected.\n");
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x200000;
+                    break;
+                case 0x8d:
+                    printk(KERN_NOTICE "RtkSFC MTD: SST 25VF040B detected.\n");
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x80000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: SST unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            break;
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: SST unknown id1=0x%x detected.\n",
+                    sfc_info->device_id1);
+            break;
+    }
+    if(sfc_info->erase_opcode==0xFFFFFFFF)//Set to default.
+    {
+        SFC_4KB_ERASE;
+    }
+    return 0;
+}
+
+/*--------------------------------------------------------------------------------
+  SPANSION serial flash information list
+  [SPANSION S25FL004A ]
+  erase size: 64KB
+
+  [SPANSION S25FL008A ]
+  erase size: 64KB
+
+  [SPANSION S25FL016A ]
+  erase size: 64KB
+
+  [SPANSION S25FL032A ]
+  erase size: 64KB
+
+  [SPANSION S25FL064A ]
+  erase size: 64KB
+
+  [SPANSION S25FL128P](256K sector)
+  erase size: 64KB / 256KB
+
+  [SPANSION S25FL129P](256K sector)
+  erase size: 64KB / 256KB
+  --------------------------------------------------------------------------------*/
+static int spansion_init(rtk_sfc_info_t *sfc_info) {
+    switch(sfc_info->device_id1) {
+        case 0x02:
+            switch(sfc_info->device_id2) {
+                case 0x12:
+                    printk(KERN_NOTICE "RtkSFC MTD: SPANSION S25FL004A detected.\n");
+                    sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x80000;
+                    break;
+                case 0x13:
+                    printk(KERN_NOTICE "RtkSFC MTD: SPANSION S25FL008A detected.\n");
+                    sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x100000;
+                    break;
+                case 0x14:
+                    printk(KERN_NOTICE "RtkSFC MTD: SPANSION S25FL016A detected.\n");
+                    sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x200000;
+                    break;
+                case 0x15:
+                    printk(KERN_NOTICE "RtkSFC MTD: SPANSION S25FL032A detected.\n");
+                    sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;
+                case 0x16:
+                    printk(KERN_NOTICE "RtkSFC MTD: SPANSION S25FL064A detected.\n");
+                    sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x800000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: SPANSION unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            break;
+        case 0x20:
+            switch(sfc_info->device_id2) {
+                case 0x18: // S25FL128P/129P has two types of erase size, must identify via extended device id
+                    {
+                        unsigned int tmp2 = 0;
+                        u8 ext_id1;
+                        u8 ext_id2;
+                        SFC_SYNC;
+                        SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+                        REG_WRITE_U32(0x0000009f, SFC_OPCODE);  /* JEDEC Read ID */
+
+#if SFC_USE_DELAY
+                        sfc_delay();
+#endif
+
+                        REG_WRITE_U32(0x00000013, SFC_CTL); /* dataen = 1, adren = 0, dmycnt = 3 */
+                        SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+                        SFC_SYNC;
+                        tmp2 = *(volatile unsigned int *)FLASH_POLL_ADDR;
+                        printk("Extension ID : 0x%x\n",tmp2);
+
+                        ext_id1 = RDID_DEVICE_EID_1(tmp2);
+                        ext_id2 = RDID_DEVICE_EID_2(tmp2);
+
+                        if(ext_id1 == 0x03 && ext_id2 == 0x00) {
+                            printk(KERN_NOTICE "RtkSFC MTD: SPANSION S25FL128P(256K sector) detected.\n");
+                            SFC_256KB_ERASE;    
+                            sfc_info->sec_256k_en = sfc_info->sec_64k_en = SUPPORTED;
+                            sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                            sfc_info->mtd_info->size = 0x1000000;
+                        }
+                        else if(ext_id1 == 0x4d && ext_id2 == 0x00) {
+                            printk(KERN_NOTICE "RtkSFC MTD: SPANSION S25FL129P(256K sector) detected.\n");
+                            SFC_256KB_ERASE;
+                            sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_DUAL_IO;
+                            sfc_info->sec_256k_en = SUPPORTED;
+                            sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                            sfc_info->mtd_info->size = 0x1000000;
+                        }
+                        else if(ext_id1 == 0x4d && ext_id2 == 0x01) {
+                            printk(KERN_NOTICE "RtkSFC MTD: SPANSION S25FL129P(64K sector) detected.\n");
+                            SFC_64KB_ERASE;
+                            sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_DUAL_IO;
+                            sfc_info->sec_64k_en = SUPPORTED;
+                            sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                            sfc_info->mtd_info->size = 0x1000000;
+                        }   
+
+                        else {
+                            printk(KERN_NOTICE "RtkSFC MTD: SPANSION S25FL128P or others (64K sector) detected.\n");
+                            SFC_64KB_ERASE;
+                            sfc_info->sec_64k_en = SUPPORTED;
+                            sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                            sfc_info->mtd_info->size = 0x1000000;
+                        }
+                    }
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: SPANSION unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            break;
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: SPANSION unknown id1=0x%x detected.\n",
+                    sfc_info->device_id1);
+            break;
+    }
+    if(sfc_info->erase_opcode==0xFFFFFFFF)//Set to default.
+    {
+        SFC_64KB_ERASE;
+    }
+
+    return 0;
+}
+
+/*--------------------------------------------------------------------------------
+  MXIC serial flash information list
+  [MXIC MX25L4005]
+  erase size: 4KB / 64KB
+
+  [MXIC MX25L8005 / MX25L8006E]
+  erase size: 4KB / 64KB
+
+  [MXIC MX25L1605]
+  erase size: 4KB / 64KB    
+
+  [MXIC MX25L3205]
+  erase size: 4KB / 64KB
+
+  [MXIC MX25L6405D]
+  erase size: 4KB / 64KB
+
+
+  [MXIC MX25L6445E]
+  erase size: 4KB / 32KB / 64KB
+
+  [MXIC MX25L12845E]
+  erase size: 4KB / 32KB / 64KB
+
+  [MXIC MX25L12805E]
+  erase size: 4KB / 64KB
+
+  [MXIC MX25L25635E]
+  erase size: 4KB / 32KB / 64KB
+
+  [MXIC MX25L6455E]
+  erase size:  4KB / 32KB / 64KB
+
+  [MXIC MX25L12855E]
+  erase size: 4KB / 32KB / 64KB
+
+  --------------------------------------------------------------------------------*/
+
+static int mxic_init(rtk_sfc_info_t *sfc_info) {
+    unsigned char manufacturer_id, device_id;
+
+    switch(sfc_info->device_id1) {
+        case 0x20:
+            switch(sfc_info->device_id2) {
+                case 0x13:
+                    printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L4005 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x80000;
+                    break;
+                case 0x14:
+                    printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L8005/MX25L8006E detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x100000;
+                    break;
+                case 0x15:
+                    printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L1605 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x200000;
+                    break;
+                case 0x16:
+                    printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L3205 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_DUAL_O;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;
+                case 0x17:
+                    read_rems(sfc_info, &manufacturer_id, &device_id);
+                    if(manufacturer_id == 0xc2 && device_id == 0x16) {
+                        printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L6445E detected....\n");
+                        SFC_4KB_ERASE;
+                        //sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_DUAL_IO;               
+                        sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                        sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    }
+                    else {
+                        printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L6405D detected.\n");
+                        SFC_4KB_ERASE;
+                        sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                        sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    }
+                    sfc_info->mtd_info->size = 0x800000;
+                    break;
+                case 0x18:
+                    read_rems(sfc_info, &manufacturer_id, &device_id);
+                    if(manufacturer_id == 0xc2 && device_id == 0x17) {
+                        printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L12845E detected.\n");
+                        SFC_4KB_ERASE;
+                        sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_DUAL_IO|RTK_SFC_ATTR_SUPPORT_DUAL_O;
+                        sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                        sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    }
+                    else {
+                        printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L12805 detected.\n");
+                        SFC_4KB_ERASE;
+                        sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                        sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    }
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+                case 0x19:
+                    read_rems(sfc_info, &manufacturer_id, &device_id);
+                    if(manufacturer_id == 0xc2 && device_id == 0x18) {
+                        printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L25635E detected.\n");
+
+
+                        SYS_REG_TRY_LOCK(0);//add by alexchang 0722-200
+
+                        REG_WRITE_U32(0x0000002b, SFC_OPCODE);  
+
+                        REG_WRITE_U32(0x00000010, SFC_CTL); /* dataen = 1, adren = 0, dmycnt = 0 */
+                        SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+                        SFC_SYNC;
+                        if ((*(volatile unsigned char *)FLASH_POLL_ADDR) 
+                                & 0x4) 
+                        {
+#if ENTER_4BYTES_MODE
+                            exit_4bytes_addr_mode();
+#else
+
+#endif
+                        }
+                        SFC_4KB_ERASE;
+                        sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_DUAL_IO;
+                        sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                        sfc_info->sec_256k_en = NOT_SUPPORTED;
+                        sfc_info->mtd_info->size = 0x2000000;
+
+                        /* enter 4-byte address mode */
+                        /* cuz watchdog reset issue , we dont 
+                           support yet */
+#if ENTER_4BYTES_MODE
+                        en_4bytes_addr_mode();
+                        sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_4BYTE_ADDR_MODE;
+#endif
+
+                    }
+                    else {
+                        printk(KERN_NOTICE "RtkSFC MTD: MXIC unknown mnftr_id=0x%x, dev_id=0x%x .\n", manufacturer_id, device_id) ;
+                        SFC_4KB_ERASE;
+                        sfc_info->sec_4k_en = SUPPORTED;
+                        sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    }
+                    break;
+
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: MXIC unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    break;
+            }
+            break;
+        case 0x26:////add by alexchang 1206-2010
+            switch(sfc_info->device_id2) {
+                case 0x17:
+                    printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L6455E detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x800000;
+                    break;
+
+                case 0x18:
+                    printk(KERN_NOTICE "RtkSFC MTD: MXIC MX25L12855E detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: MXIC unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            break;
+        case 0x23:
+            switch(sfc_info->device_id2) {
+                case 0x15:
+                    printk(KERN_NOTICE "RtkSFC MTD: MXIC MX_25V1635F_16Mbit detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: MXIC unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            break;
+
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: MXIC unknown id1=0x%x detected.\n",
+                    sfc_info->device_id1);
+            break;
+    }
+
+    if(sfc_info->erase_opcode==0xFFFFFFFF)//Set to default.
+    {
+        SFC_64KB_ERASE;
+    }
+
+    return 0;
+
+}
+/*--------------------------------------------------------------------------------
+  PMC serial flash information list
+
+  --------------------------------------------------------------------------------*/
+
+static int pmc_init(rtk_sfc_info_t *sfc_info) {
+    switch(sfc_info->device_id1) {
+        case 0x9d:
+            switch(sfc_info->device_id2) {
+                case 0x7c:
+                    printk(KERN_NOTICE "RtkSFC MTD: PMC Pm25LV010 detected.\n");
+                    sfc_info->mtd_info->size = 0x20000;
+                    break;
+                case 0x7d:
+                    printk(KERN_NOTICE "RtkSFC MTD: PMC Pm25LV020 detected.\n");
+                    sfc_info->mtd_info->size = 0x40000;
+                    break;
+                case 0x7e:
+                    printk(KERN_NOTICE "RtkSFC MTD: PMC Pm25LV040 detected.\n");
+                    sfc_info->mtd_info->size = 0x80000;
+                    break;
+                case 0x46:
+                    printk(KERN_NOTICE "RtkSFC MTD: PMC Pm25LQ032 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;      
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: PMC unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            break;
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: PMC unknown id1=0x%x detected.\n",
+                    sfc_info->device_id1);
+            break;
+    }
+    sfc_info->erase_size    = 0x1000;   //4KB
+    sfc_info->erase_opcode  = 0x000000d7;   //for 4KB erase.
+    return 0;
+}
+
+/*--------------------------------------------------------------------------------
+  STM serial flash information list
+  [ST M25P128]
+  erase size: 2MB
+
+  [ST M25Q128]
+
+  [STM N25Q032]
+  erase size: 4KB / 64KB
+
+  [STM N25Q064]
+  erase size: 4KB / 64KB
+  --------------------------------------------------------------------------------*/
+
+static int stm_init(rtk_sfc_info_t *sfc_info) {
+    switch(sfc_info->device_id1) {
+        case 0x20:
+            switch(sfc_info->device_id2) {
+                case 0x17:
+                    printk(KERN_NOTICE "RtkSFC MTD: ST M25P64 detected.\n");
+                    SFC_64KB_ERASE;
+                    sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+                case 0x18:
+                    printk(KERN_NOTICE "RtkSFC MTD: ST M25P128 detected.\n");
+                    SFC_256KB_ERASE;
+                    sfc_info->sec_256k_en = SUPPORTED;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: ST unknown id2=0x%x detected.\n",   sfc_info->device_id2);
+                    SFC_64KB_ERASE;
+                    sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    break;
+            }
+            break;
+
+        case 0xba:
+            switch(sfc_info->device_id2) {
+                case 0x16:
+                    printk(KERN_NOTICE "RtkSFC MTD: ST N25Q032 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;
+                case 0x17:
+                    printk(KERN_NOTICE "RtkSFC MTD: ST N25Q064 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x800000;
+                    break;
+                case 0x18:
+                    printk(KERN_NOTICE "RtkSFC MTD: ST N25Q128 detected.\n");
+                    SFC_64KB_ERASE;
+                    sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: ST unknown id2=0x%x detected.\n",   sfc_info->device_id2);
+                    SFC_64KB_ERASE;
+                    sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    break;
+            }
+            break;
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: ST unknown id1=0x%x detected.\n",   sfc_info->device_id1);
+            SFC_64KB_ERASE;
+            sfc_info->sec_64k_en = SUPPORTED;
+            sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+            break;
+    }
+    if(sfc_info->erase_opcode==0xFFFFFFFF)//Set to default.
+    {
+        SFC_64KB_ERASE;
+    }
+
+    return 0;
+}
+
+
+/*--------------------------------------------------------------------------------
+  EON serial flash information list
+  [EON EN25B64-100FIP]64Mbits
+  erase size: 64KB
+
+  [EON EN25F16]
+  erase size: 4KB / 64KB
+
+  [EON EN25Q64]
+  erase size: 4KB 
+
+
+  [EON EN25Q128]
+  erase size: 4KB / 64KB
+  --------------------------------------------------------------------------------*/
+static int eon_init(rtk_sfc_info_t *sfc_info) {
+    switch(sfc_info->device_id1) {
+        case 0x20:
+            switch(sfc_info->device_id2) {
+                case 0x17:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON EN25B64-100FIP detected.\n");
+                    SFC_64KB_ERASE;
+                    sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x800000;
+                    g_isSegErase = 1;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    break;
+            }
+            return 0;
+
+        case 0x31:
+            switch(sfc_info->device_id2) {
+                case 0x15:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON EN25F16 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x200000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            return 0;
+
+        case 0x30:
+            switch(sfc_info->device_id2) {
+                case 0x16:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON EN25Q32 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;          
+                case 0x17:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON EN25Q64 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x800000;
+                    break;          
+                case 0x18:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON EN25Q128 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            return 0;
+
+        case 0x70: 
+            switch(sfc_info->device_id2) {
+                case 0x15:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON EON_EN25QH16 detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+                case 0x18:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON EON_EN25QH16128A detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: EON unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    break;
+            }
+            return 0;
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: EON unknown id1=0x%x detected.\n",
+                    sfc_info->device_id1);
+            break;
+    }
+
+    // set to default.
+    if(sfc_info->erase_opcode == 0xFFFFFFFF) {
+        SFC_64KB_ERASE;
+    }
+
+    return 0;
+}
+
+/*--------------------------------------------------------------------------------
+  ATMEL serial flash information list
+  [ATMEL AT25DF641A]64Mbits
+  erase size: 64KB
+
+  [ATMEL AT25DF321A]
+  erase size: 4KB / 64KB
+  --------------------------------------------------------------------------------*/
+static int atmel_init(rtk_sfc_info_t *sfc_info) {
+    switch(sfc_info->device_id1) {
+        case 0x48:
+        case 0x86:
+            switch(sfc_info->device_id2) {
+                case 0x1:
+                case 0x0:
+                    printk(KERN_NOTICE "RtkSFC MTD: AT25DF641A detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x800000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: AT25DF641A unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    break;
+            }
+            return 0;
+
+        case 0x47:
+            switch(sfc_info->device_id2) {
+                case 0x1:
+                case 0x0:           
+                    printk(KERN_NOTICE "RtkSFC MTD: AT25DF321A detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: AT25DF321A like unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;
+            }
+            return 0;
+
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: EON unknown id1=0x%x detected.\n",
+                    sfc_info->device_id1);
+            break;
+    }
+
+    // set to default.
+    if(sfc_info->erase_opcode == 0xFFFFFFFF) {
+        SFC_4KB_ERASE;
+    }
+
+    return 0;
+}
+
+/*--------------------------------------------------------------------------------
+  WINBOND serial flash information list
+  [WINBOND 25Q128BVFG]
+  erase size: 
+
+  [WINBOND W25Q32BV]32 Mbits
+  erase size:4KB /32KB /64KB
+
+  [SPANSION S25FL064K ] 64Mbits //SPANSION brand, Winbond OEM
+  erase size: 4KB / 32KB / 64KB
+
+  --------------------------------------------------------------------------------*/
+static int winbond_init(rtk_sfc_info_t *sfc_info) {
+    switch(sfc_info->device_id1) {
+        case 0x40:
+            switch(sfc_info->device_id2) {
+                case 0x14:
+                    printk(KERN_NOTICE "RtkSFC MTD: WINBOND W25Q80BV detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_DUAL_IO|RTK_SFC_ATTR_SUPPORT_DUAL_O;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x100000;
+                    break;
+                case 0x19:
+                    printk(KERN_NOTICE "RtkSFC MTD: WINBOND S25FL256K detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = sfc_info->sec_32k_en = sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x2000000;
+                    //louis
+#if 0
+                    FLASH_BASE = (unsigned char*)0xbdc00000;    
+                    FLASH_POLL_ADDR = (unsigned char*)0xbec00000;
+#endif
+                    break;
+                case 0x16:
+                    printk(KERN_NOTICE "RtkSFC MTD: WINBOND W25Q32BV(W25Q32FV) detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_DUAL_IO|RTK_SFC_ATTR_SUPPORT_DUAL_O;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;
+                case 0x17:
+                    printk(KERN_NOTICE "RtkSFC MTD: SPANSION S25FL064K detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_DUAL_IO|RTK_SFC_ATTR_SUPPORT_DUAL_O;         
+                    sfc_info->sec_4k_en = sfc_info->sec_32k_en = sfc_info->sec_64k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x800000;
+                    break;
+                case 0x18:
+                    printk(KERN_NOTICE "RtkSFC MTD: WINBOND 25Q128BVFG(W25Q128BVFIG) detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->attr |= RTK_SFC_ATTR_SUPPORT_DUAL_IO|RTK_SFC_ATTR_SUPPORT_DUAL_O;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x1000000;
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: WINBOND unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+
+                    break;
+            }
+            return 0;
+        case 0x60:
+            switch(sfc_info->device_id2) {
+                case 0x16:
+                    printk(KERN_NOTICE "RtkSFC MTD: WINBOND W25Q32FV(Quad Mode) detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;            
+                    break;
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: WINBOND unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+
+                    break;
+            }
+            return 0;
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: WINBOND unknown id1=0x%x detected.\n",
+                    sfc_info->device_id1);
+            break;
+    }
+    SFC_4KB_ERASE;
+    return 0;
+}
+
+/*--------------------------------------------------------------------------------
+  ESMT serial flash information list
+  [ESMT F25L32PA]32 Mbits
+  erase size:4KB / 64KB
+  [ESMT F25L64QA]64 Mbits
+  erase size:4KB / 32KB / 64KB
+  --------------------------------------------------------------------------------*/
+static int esmt_init(rtk_sfc_info_t *sfc_info) {
+    switch(sfc_info->device_id1) {
+        case 0x20:
+            switch(sfc_info->device_id2) {
+                case 0x16:
+                    printk(KERN_NOTICE "RtkSFC MTD: ESMT F25L32PA detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;
+
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: ESMT unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+
+                    break;
+            }
+            break;
+        case 0x40:
+            switch(sfc_info->device_id2) {
+                case 0x16:
+                    printk(KERN_NOTICE "RtkSFC MTD: ESMT F25L32PA detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;
+
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: ESMT unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+
+                    break;
+            }
+            break;
+        case 0x41:
+            switch(sfc_info->device_id2) {
+                case 0x16:
+                    printk(KERN_NOTICE "RtkSFC MTD: ESMT F25L32QA detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x400000;
+                    break;
+
+                case 0x17:
+                    printk(KERN_NOTICE "RtkSFC MTD: ESMT F25L64QA detected.\n");
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_64k_en = sfc_info->sec_32k_en = sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = NOT_SUPPORTED;
+                    sfc_info->mtd_info->size = 0x800000;
+                    break;
+
+                default:
+                    printk(KERN_NOTICE "RtkSFC MTD: ESMT unknown id2=0x%x detected.\n",
+                            sfc_info->device_id2);
+                    SFC_4KB_ERASE;
+                    sfc_info->sec_4k_en = SUPPORTED;
+                    sfc_info->sec_256k_en = sfc_info->sec_64k_en = sfc_info->sec_32k_en = NOT_SUPPORTED;
+
+                    break;
+            }
+            break;
+        default:
+            printk(KERN_NOTICE "RtkSFC MTD: ESMT unknown id1=0x%x detected.\n",
+                    sfc_info->device_id1);
+            break;
+    }
+
+    if(sfc_info->erase_opcode == 0xFFFFFFFF)//Set to default.
+    {
+        SFC_64KB_ERASE;
+    }
+
+    return 0;
+}
+
+inline size_t sfc_memcpy(void *dst, void *src, size_t len) {    
+    int i;  
+    size_t len_align;   
+    if ((((unsigned long) dst & 0x3) == 0) && (((unsigned long) src & 0x03) == 0) ) {
+        len_align = len & ~((unsigned long) 0x03);      
+        for(i = 0; i < len_align; i += 4) {         
+            *((u32*) ((u64)dst+i) ) = *((u32*)((u64)src+i));        
+        }       
+        for(; i < len; i ++) {          
+            *((u8*) ((u64)dst+i) ) = *((u8*)((u64)src+i));      
+        }                       
+        return len; 
+    } else if ((((unsigned long) dst & 0x1) == 0) && (((unsigned long) src & 0x01) == 0)) {     
+        len_align = len & ~((unsigned long) 0x01);      
+        for(i = 0; i < len_align; i += 2) {         
+            *((u16*) ((u64)dst+i) ) = *((u16*)((u64)src+i));        
+        }
+        for(; i < len; i ++) {          
+            *((u8*) ((u64)dst+i) ) = *((u8*)((u64)src+i));      
+        }                   
+    } else {        
+        for(i=0; i < len; i ++) {           
+            *((u8*) ((u64)dst+i) ) = *((u8*)((u64)src+i));      
+        }                   
+    }   
+    return len; 
+}
+
+static void  _sfc_enable_4B_addr_mode(void)
+{
+	unsigned char tmp;
+	/*Just can read 1 byte*/
+
+#ifdef DEV_DEBUG
+	printk(KERN_WARNING "EN4B\n");
+#endif
+    SFC_SYNC;
+    REG_WRITE_U32(0x000000b7, SFC_OPCODE);
+    REG_WRITE_U32(0x00000000, SFC_CTL);
+    SFC_SYNC;
+	tmp = *(volatile unsigned char*)(FLASH_BASE);
+}
+
+static void  _sfc_disable_4B_addr_mode(void)
+{
+	unsigned char tmp;
+	/*Just can read 1 byte*/
+
+#ifdef DEV_DEBUG
+	printk(KERN_WARNING "EX4B\n");
+#endif
+    SFC_SYNC;
+    REG_WRITE_U32(0x000000e9, SFC_OPCODE);
+    REG_WRITE_U32(0x00000000, SFC_CTL);
+    SFC_SYNC;
+    tmp = *(volatile unsigned char*)(FLASH_BASE);
+}
+
+static void  _sfc_enable_host_4B_addr(void)
+{
+#ifdef DEV_DEBUG
+    printk(KERN_WARNING "enable host 4B addr\n");
+#endif
+    SFC_SYNC;
+    REG_WRITE_U32(0x00000001, 0x9801a828);
+    SFC_SYNC;
+}
+
+static void  _sfc_disable_host_4B_addr(void)
+{
+#ifdef DEV_DEBUG
+    printk(KERN_WARNING "disable host 4B addr\n");
+#endif
+    SFC_SYNC;
+    REG_WRITE_U32(0x00000000, 0x9801a828);
+    SFC_SYNC;
+}
+
+static int _sfc_read_bytes(struct mtd_info *mtd, loff_t from, size_t len,
+        size_t *retlen, const u_char *buf) {
+			
+	unsigned int curr_nor_addr = (unsigned long long)FLASH_BASE + from;
+	unsigned int nor_boundary_addr = (unsigned long long)FLASH_BASE + (16 * 1024 * 1024);
+	unsigned int byte_len_before_16MB, byte_len_after_16MB;
+	
+	if (curr_nor_addr < nor_boundary_addr) {
+        if ((curr_nor_addr + len) > nor_boundary_addr) {
+            byte_len_before_16MB = nor_boundary_addr - curr_nor_addr;
+            byte_len_after_16MB = len - byte_len_before_16MB;
+        }
+        else {
+            byte_len_before_16MB = len;
+            byte_len_after_16MB = 0;
+        }
+    }
+    else {
+        byte_len_before_16MB = 0;
+        byte_len_after_16MB = len;
+    }
+
+	/* read berfore 16MB */
+    if (byte_len_before_16MB) {
+        _switch_to_read_mode((rtk_sfc_info_t*)mtd->priv, eREAD_MODE_SINGLE_FAST_READ);
+
+        *retlen = sfc_memcpy((void *)buf, (void *)(FLASH_BASE + from), byte_len_before_16MB); 
+    }
+
+    /* read after 16MB */
+    if (byte_len_after_16MB) {
+        _sfc_enable_4B_addr_mode();
+        _sfc_enable_host_4B_addr();
+        _switch_to_read_mode((rtk_sfc_info_t*)mtd->priv, eREAD_MODE_SINGLE_FAST_READ);
+
+        *retlen = sfc_memcpy((void *)(buf + byte_len_before_16MB),
+			(void *)(FLASH_BASE + from + byte_len_before_16MB), byte_len_after_16MB); 
+
+        _sfc_disable_4B_addr_mode();
+        _sfc_disable_host_4B_addr();
+    }  
+
+    return 0;
+}
+
+#ifdef CONFIG_MTD_RTK_SFC_READ_MD
+static int _sfc_read_md(struct mtd_info *mtd, loff_t from, size_t len,
+					size_t *retlen, u_char *buf) {
+
+	volatile u8 *src = (volatile u8*)(NOR_BASE_PHYS + from);
+	
+	u32 val;
+	int ret;
+
+    u8 *dest = (u8*)buf;
+    u32 read_count = 0;
+
+    u8 *p_data_buf;
+    int i;
+	
+	unsigned int curr_nor_addr = (unsigned long long)FLASH_BASE + from;
+	unsigned int nor_boundary_addr = (unsigned long long)FLASH_BASE + (16 * 1024 * 1024);
+	unsigned int byte_len_before_16MB, byte_len_after_16MB;
+    
+#ifdef CONFIG_MTD_RTK_MD_READ_COMPARE
+	u8 *org_src = (u8*)buf;
+	unsigned int org_from = from;
+	size_t org_len = len;
+retry_mdread:
+#endif
+
+#ifdef DEV_DEBUG
+	printk(KERN_WARNING "Rtk SFC MTD: %s() $ [%08X => %08X (virt: %08X) : %08X]\n", __func__, (u32)(u64)src, (unsigned long)(virt_to_phys(buf)), (u32)(u64)buf, (int)len);
+#endif
+
+	if(unlikely((len <= RTK_SFC_SMALL_PAGE_WRITE_MASK) || (len & RTK_SFC_SMALL_PAGE_WRITE_MASK)))
+		BUG();
+	
+	if (curr_nor_addr < nor_boundary_addr) {
+		if ((curr_nor_addr + len) > nor_boundary_addr) {
+			byte_len_before_16MB = nor_boundary_addr - curr_nor_addr;
+			byte_len_after_16MB = len - byte_len_before_16MB;
+		}
+		else {
+			byte_len_before_16MB = len;
+			byte_len_after_16MB = 0;
+        }
+    }
+	else {
+		byte_len_before_16MB = 0;
+		byte_len_after_16MB = len;
+	}
+
+	if (byte_len_before_16MB) {
+		len = byte_len_before_16MB;
+		while(len > 0) {
+			size_t dma_length;
+			
+			if(len >= MD_PP_DATA_SIZE)
+				dma_length = MD_PP_DATA_SIZE;
+			else
+				dma_length = len;
+
+			p_data_buf = (u8 *)read_dma_buf;
+
+			_switch_to_read_mode((rtk_sfc_info_t*)mtd->priv, eREAD_MODE_DUAL_FAST_READ);
+
+			//setup MD DDR addr and flash addr
+			//REG_WRITE_U32(((unsigned int)dest), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)read_dma_handle), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)src), MD_FDMA_FL_SADDR);
+
+			//setup MD direction and move data length
+			val = (0x2C000000 | dma_length);        //do swap
+			REG_WRITE_U32(val, MD_FDMA_CTRL2);		//for dma_length bytes.
+
+			mb();
+			SFC_SYNC;
+
+			//go 
+			REG_WRITE_U32(0x03, MD_FDMA_CTRL1);
+
+			/* wait for MD done its operation */
+			while((ret = REG_READ_U32(MD_FDMA_CTRL1)) & 0x1);
+
+			for (i = 0; i < dma_length; i++) {
+				dest[i] = p_data_buf[i];
+			}
+
+			src += dma_length;
+			dest += dma_length;
+			read_count += dma_length;
+			len -= dma_length;
+		}
+	}
+	
+	if (byte_len_after_16MB) {
+		_sfc_enable_4B_addr_mode();
+        _sfc_enable_host_4B_addr();	
+	
+		len = byte_len_after_16MB;
+		while(len > 0) {
+			size_t dma_length;
+			
+			if(len >= MD_PP_DATA_SIZE)
+				dma_length = MD_PP_DATA_SIZE;
+			else
+				dma_length = len;
+
+			p_data_buf = (u8 *)read_dma_buf;
+
+			_switch_to_read_mode((rtk_sfc_info_t*)mtd->priv, eREAD_MODE_DUAL_FAST_READ);
+
+			//setup MD DDR addr and flash addr
+			//REG_WRITE_U32(((unsigned int)dest), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)read_dma_handle), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)src), MD_FDMA_FL_SADDR);
+
+			//setup MD direction and move data length
+			val = (0x2C000000 | dma_length);        //do swap
+			REG_WRITE_U32(val, MD_FDMA_CTRL2);		//for dma_length bytes.
+
+			mb();
+			SFC_SYNC;
+
+			//go 
+			REG_WRITE_U32(0x03, MD_FDMA_CTRL1);
+
+			/* wait for MD done its operation */
+			while((ret = REG_READ_U32(MD_FDMA_CTRL1)) & 0x1);
+
+			for (i = 0; i < dma_length; i++) {
+				dest[i] = p_data_buf[i];
+			}
+
+			src += dma_length;
+			dest += dma_length;
+			read_count += dma_length;
+			len -= dma_length;
+		}
+		_sfc_disable_4B_addr_mode();
+        _sfc_disable_host_4B_addr();
+	}
+
+    *retlen = read_count;
+
+	return 0;
+}
+//---------------------------------------------------------------------------------------------
+
+static int rtk_sfc_read_pages(struct mtd_info *mtd, loff_t from, size_t len,
+						size_t *retlen, u_char *buf) {
+	rtk_sfc_info_t *sfc_info;
+	size_t read_len = 0;
+	size_t rlen = 0;
+	size_t length_to_read;
+	unsigned long buf_addr = 0;
+#ifdef CONFIG_MTD_RTK_MD_READ_COMPARE
+	u8 *org_src = (u8*)buf;
+	unsigned int org_from = from;
+	size_t org_len = len;
+retry_read:
+#endif
+
+#ifdef DEV_DEBUG 
+    printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_read_pages(), from = %08X, length = %08X\n", (int)from, (int)len);
+#endif
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	add_debug_entry(from, buf, len, READ_ACCESS);
+#endif
+
+	if((sfc_info = (rtk_sfc_info_t*)mtd->priv) == NULL)
+		return -EINVAL;
+
+	down_write(&rw_sem);
+
+	buf_addr = (unsigned long)buf;
+	SFC_FLUSH_CACHE(buf_addr,len);
+
+	/* Set SB2 to in-order mode */
+	//_before_serial_flash_access();
+
+	*retlen = 0;
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(READ_READY);
+#endif
+
+	// 1st pass: read data 0-3 bytes 
+	if(len > 0 && (from & RTK_SFC_SMALL_PAGE_WRITE_MASK)) {
+		if(len > RTK_SFC_SMALL_PAGE_WRITE_MASK)
+			length_to_read = (RTK_SFC_SMALL_PAGE_WRITE_MASK + 1) - (from & RTK_SFC_SMALL_PAGE_WRITE_MASK);
+		else
+			length_to_read = len;
+
+		_sfc_read_bytes(mtd, from, length_to_read, &rlen, buf);
+
+#ifdef DEV_DEBUG 
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_read() $ PASS #1 $ [%08X:%08X]\n", (int)from, (int)len);
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_read() $ PASS #1 $ %d bytes read\n", (int)rlen);
+#endif
+
+		from += rlen;
+		read_len += rlen;
+		len -= rlen;
+		buf += rlen;
+	}
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(READ_STAGE_1);
+#endif
+
+	// 2rd pass: using MD to read data which aligned in 4 bytes
+	if(len > RTK_SFC_SMALL_PAGE_WRITE_MASK && ((((unsigned long)buf) & RTK_SFC_SMALL_PAGE_WRITE_MASK)==0)  && 
+		((from &  RTK_SFC_SMALL_PAGE_WRITE_MASK)==0)) 
+	{
+		length_to_read = len & (~RTK_SFC_SMALL_PAGE_WRITE_MASK);
+
+		_sfc_read_md(mtd, from, length_to_read, &rlen, buf);
+
+#ifdef DEV_DEBUG 
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_read() $ PASS #2 $ [%08X:%08X]\n", (int)from, (int)len);
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_read() $ PASS #2 $ %d bytes read\n", (int)rlen);
+#endif
+
+		from += rlen;
+		read_len += rlen;
+		len -= rlen;
+		buf += rlen;
+	}
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(READ_STAGE_2);
+#endif
+
+	// 3rd pass: read rest data (0-3 bytes)
+	if(len > 0) {
+		length_to_read = len;
+
+    	//dma_cache_sync(NULL,buf, len, DMA_FROM_DEVICE);
+		_sfc_read_bytes(mtd, from, length_to_read, &rlen, buf);
+
+#ifdef DEV_DEBUG 
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_read() $ PASS #3 $ [%08X:%08X]\n", (int)from, (int)len);
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_read() $ PASS #3 $ %d bytes read\n", (int)rlen);
+#endif
+
+		from += rlen;
+		read_len += rlen;
+		len -= rlen;
+		buf += rlen;
+	}
+
+	*retlen = read_len;
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(READ_STAGE_3);
+#endif
+	/* Restore SB2 */
+	//_after_serial_flash_access();
+#if 0
+//#ifdef CONFIG_MTD_RTK_MD_READ_COMPARE 
+	if (memcmp((void *) (FLASH_BASE + org_from), (void *) org_src, org_len)) {
+	    	printk("read error at buf=%x %x len=%x\n", org_src, (FLASH_BASE + org_from), org_len);	
+		printk("\nsrc: ");
+		int i;
+		for (i=0; i < org_len; i++) {
+			printk("%02x ", org_src[i]);
+			if (i%8 == 7) printk("\n");
+		}
+		printk("\ndest: ");
+		for (i=0; i < org_len; i++) {
+			printk("%02x ",  ((unsigned char *)(FLASH_BASE + org_from))[i]);
+			if (i%8 == 7) printk("\n");
+		}			
+		goto retry_read;
+	}
+#endif	
+
+	up_write(&rw_sem);
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(READ_COMPLETED);
+#endif
+	return 0;
+}
+#endif
+
+static int rtk_sfc_read(struct mtd_info *mtd, loff_t from, size_t len,
+        size_t *retlen, u_char *buf) {
+    rtk_sfc_info_t *sfc_info;
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+#endif
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    add_debug_entry(from, buf, len, READ_ACCESS);
+#endif
+
+    if((sfc_info = (rtk_sfc_info_t*)mtd->priv) == NULL)
+        return -EINVAL;
+    if(!buf)
+        return -EINVAL;
+
+    down_write(&rw_sem);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    SFC_FLUSH_CACHE((unsigned long) &buf,len);
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    change_status(READ_READY);
+#endif
+
+#ifdef DEV_DEBUG 
+    printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_read(), from = %08X, length = %08X\n", (int)from, (int)len);
+#endif
+
+    *retlen = 0;
+
+    _sfc_read_bytes(mtd, from, len, retlen, buf);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    up_write(&rw_sem);
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    change_status(READ_COMPLETED);
+#endif
+
+    return 0;
+}
+
+static int _sfc_write_bytes(struct mtd_info *mtd, loff_t to, size_t len,
+        size_t *retlen, const u_char *buf) {
+    u8 *src = (u8*)buf;
+    volatile u8 *dest = (volatile u8*)(FLASH_BASE + to);
+    u32 written_count = 0;
+	
+	unsigned int curr_nor_addr = (unsigned long long)FLASH_BASE + to;
+	unsigned int nor_boundary_addr = (unsigned long long)FLASH_BASE + (16 * 1024 * 1024);
+	unsigned int byte_len_before_16MB, byte_len_after_16MB;
+	
+	if (curr_nor_addr < nor_boundary_addr) {
+        if ((curr_nor_addr + len) > nor_boundary_addr) {
+            byte_len_before_16MB = nor_boundary_addr - curr_nor_addr;
+            byte_len_after_16MB = len - byte_len_before_16MB;
+        }
+        else {
+            byte_len_before_16MB = len;
+            byte_len_after_16MB = 0;
+        }
+    }
+    else {
+        byte_len_before_16MB = 0;
+        byte_len_after_16MB = len;
+    }
+
+    //rtk_sfc_info_t *sfc_info = (rtk_sfc_info_t*)mtd->priv;    
+
+    // write enable
+    REG_WRITE_U32(0x00000006,SFC_OPCODE);
+    REG_WRITE_U32(0x00000000,SFC_CTL);
+    SFC_SYNC;
+
+    // disable write protect
+    REG_WRITE_U32(0x00000000,SFC_WP);
+
+    // enable write status register
+    REG_WRITE_U32(0x00000050,SFC_OPCODE);
+    REG_WRITE_U32(0x00000000,SFC_CTL);
+    SFC_SYNC;
+
+    // write status register , no memory protection
+    REG_WRITE_U32(0x00000001,SFC_OPCODE);
+    REG_WRITE_U32(0x00000010,SFC_CTL);
+    SFC_SYNC;
+
+    REG_WRITE_U32(0x00000106,SFC_EN_WR);
+    REG_WRITE_U32(0x00000105,SFC_WAIT_WR);
+    REG_WRITE_U32(0x001A1307,SFC_CE);
+	
+	if (byte_len_before_16MB) {
+		SFC_SYNC;
+		SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+		REG_WRITE_U32(0x00000002, SFC_OPCODE);  /* Byte Programming */
+#if SFC_USE_DELAY
+		sfc_delay();
+#endif
+
+		REG_WRITE_U32(0x00000018, SFC_CTL); /* dataen = 1, adren = 1, dmycnt = 0 */
+		SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+		SFC_SYNC;
+
+		len = byte_len_before_16MB;
+		while(len--) {
+			/* send write enable first */
+			SFC_SYNC;
+			SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+			REG_WRITE_U32(0x00000006, SFC_OPCODE);  /* Write enable */
+#if SFC_USE_DELAY
+			sfc_delay();
+#endif
+			REG_WRITE_U32(0x00180000, SFC_CTL); /* dataen = 0, adren = 0, dmycnt = 0 */
+			SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+			SFC_SYNC;
+
+			SFC_SYNC;
+			SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+			REG_WRITE_U32(0x00000002, SFC_OPCODE);  /* Byte Programming */
+#if SFC_USE_DELAY
+			sfc_delay();
+#endif
+			REG_WRITE_U32(0x00000018, SFC_CTL); /* dataen = 1, adren = 1, dmycnt = 0 */
+			SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+			SFC_SYNC;
+
+			*dest++ = *src++;
+			mb();
+#if !SFC_HW_POLL
+			/* using RDSR to make sure the operation is completed. */
+			do {
+				SFC_SYNC;
+				SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+				REG_WRITE_U32(0x00000005, SFC_OPCODE);  /* RDSR */
+#if SFC_USE_DELAY 
+				sfc_delay();
+#endif
+				REG_WRITE_U32(0x00000010, SFC_CTL); /* dataen = 1, adren = 0, dmycnt = 0 */
+				SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+				SFC_SYNC;
+			} while((*(volatile unsigned char *)FLASH_POLL_ADDR) & 0x1);
+#endif
+			written_count++;
+		}
+	}
+	
+	if (byte_len_after_16MB) {
+		_sfc_enable_4B_addr_mode();
+        _sfc_enable_host_4B_addr();
+		
+		SFC_SYNC;
+		SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+		REG_WRITE_U32(0x00000002, SFC_OPCODE);  /* Byte Programming */
+#if SFC_USE_DELAY
+		sfc_delay();
+#endif
+
+		REG_WRITE_U32(0x00000018, SFC_CTL); /* dataen = 1, adren = 1, dmycnt = 0 */
+		SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+		SFC_SYNC;
+
+		len = byte_len_after_16MB;
+		while(len--) {
+			/* send write enable first */
+			SFC_SYNC;
+			SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+			REG_WRITE_U32(0x00000006, SFC_OPCODE);  /* Write enable */
+#if SFC_USE_DELAY
+			sfc_delay();
+#endif
+			REG_WRITE_U32(0x00180000, SFC_CTL); /* dataen = 0, adren = 0, dmycnt = 0 */
+			SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+			SFC_SYNC;
+
+			SFC_SYNC;
+			SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+			REG_WRITE_U32(0x00000002, SFC_OPCODE);  /* Byte Programming */
+#if SFC_USE_DELAY
+			sfc_delay();
+#endif
+			REG_WRITE_U32(0x00000018, SFC_CTL); /* dataen = 1, adren = 1, dmycnt = 0 */
+			SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+			SFC_SYNC;
+
+			*dest++ = *src++;
+			mb();
+#if !SFC_HW_POLL
+			/* using RDSR to make sure the operation is completed. */
+			do {
+				SFC_SYNC;
+				SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+				REG_WRITE_U32(0x00000005, SFC_OPCODE);  /* RDSR */
+#if SFC_USE_DELAY 
+				sfc_delay();
+#endif
+				REG_WRITE_U32(0x00000010, SFC_CTL); /* dataen = 1, adren = 0, dmycnt = 0 */
+				SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+				SFC_SYNC;
+			} while((*(volatile unsigned char *)FLASH_POLL_ADDR) & 0x1);
+#endif
+			written_count++;
+		}
+		
+		_sfc_disable_4B_addr_mode();
+        _sfc_disable_host_4B_addr();
+	}
+
+    /* send write disable then */
+    SFC_SYNC;
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x00000004, SFC_OPCODE);  /* Write disable */
+
+    REG_WRITE_U32(0x00000000, SFC_CTL); /* dataen = 0, adren = 0, dmycnt = 0 */
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;
+
+    *retlen = written_count;
+
+    return 0;
+}
+
+#ifdef CONFIG_MTD_RTK_SFC_WRITE_MD
+/*
+ * _sfc_write_small_pages()
+ * using MD to write data from DDR to FLASH which size is within a single page
+ *
+ * pass-in address must be aligned on 4-bytes, and 
+ * length must be multiples of 4-bytes
+ */
+
+static int _sfc_write_small_pages(struct mtd_info *mtd, loff_t to, size_t len,
+					size_t *retlen, const u_char *buf) {
+
+	u8 *src = (u8*)buf;
+	volatile u8 *dest = (volatile u8*)(NOR_BASE_PHYS + to);
+	u32 written_count = 0;
+	//static u8 true_data_buf[MD_PP_DATA_SIZE*2];
+	//u8 *data_buf;
+	u32 val;
+	int ret;
+	int i;
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+#endif
+
+    u8 *p_data_buf;
+	
+	unsigned int curr_nor_addr = (unsigned long long)FLASH_BASE + to;
+	unsigned int nor_boundary_addr = (unsigned long long)FLASH_BASE + (16 * 1024 * 1024);
+	unsigned int byte_len_before_16MB, byte_len_after_16MB;
+    
+	rtk_sfc_info_t *sfc_info = (rtk_sfc_info_t*)mtd->priv;
+    (void)sfc_info;
+
+	// support write fewer than 256 bytes and size must be multiples of 4-bytes
+	if(unlikely((len >= MD_PP_DATA_SIZE) || (len & RTK_SFC_SMALL_PAGE_WRITE_MASK)))
+		BUG();
+
+	if((to & RTK_SFC_SMALL_PAGE_WRITE_MASK)) // only support write onto 4-bytes aligned area
+		BUG();
+		
+	if (curr_nor_addr < nor_boundary_addr) {
+        if ((curr_nor_addr + len) > nor_boundary_addr) {
+            byte_len_before_16MB = nor_boundary_addr - curr_nor_addr;
+            byte_len_after_16MB = len - byte_len_before_16MB;
+        }
+        else {
+            byte_len_before_16MB = len;
+            byte_len_after_16MB = 0;
+        }
+    }
+    else {
+        byte_len_before_16MB = 0;
+        byte_len_after_16MB = len;
+    }
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    // write enable
+	REG_WRITE_U32(0x00000006,SFC_OPCODE);
+	REG_WRITE_U32(0x00000000,SFC_CTL);
+	SFC_SYNC;
+
+	// disable write protect
+	REG_WRITE_U32(0x00000000,SFC_WP);
+ 
+	// enable write status register
+	REG_WRITE_U32(0x00000050,SFC_OPCODE);
+	REG_WRITE_U32(0x00000000,SFC_CTL);
+	SFC_SYNC;
+
+	// write status register , no memory protection
+	REG_WRITE_U32(0x00000001,SFC_OPCODE);
+	REG_WRITE_U32(0x00000010,SFC_CTL);
+	SFC_SYNC;
+
+    REG_WRITE_U32(0x00000106,SFC_EN_WR);
+    REG_WRITE_U32(0x00000105,SFC_WAIT_WR);
+    REG_WRITE_U32(0x001A1307,SFC_CE);
+
+	if (byte_len_before_16MB) {
+		SFC_SYNC;
+		SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+		REG_WRITE_U32(0x00000002, SFC_OPCODE);	/* Byte Programming */
+#if SFC_USE_DELAY
+		sfc_delay();
+#endif
+
+		REG_WRITE_U32(0x00000018, SFC_CTL);	/* dataen = 1, adren = 1, dmycnt = 0 */
+		SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+		SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+		rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+		len = byte_len_before_16MB;
+		while(len > 0) {
+			p_data_buf = (u8 *)write_dma_buf;
+        
+			for(i = 0; i < len ; i += 4) { /* endian convert */
+#if 0
+				val = *((u32*)(src + i));
+				*((u32*)(data_buf + i)) = 
+#if 0
+							((val >> 24) |
+							((val >> 8 ) & 0x0000ff00) |
+							((val << 8 ) & 0x00ff0000) |
+							(val << 24));
+#else
+							val;
+#endif
+#endif
+				*((u32*)(p_data_buf + i)) = *((u32*)(src + i));
+			}
+
+#ifdef EMMC_ISSUE_LOCK
+			rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+			//issue write command
+			SFC_SYNC;
+			SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+			REG_WRITE_U32(0x00000002, SFC_OPCODE);
+		
+#if SFC_USE_DELAY
+			sfc_delay();
+#endif
+
+			REG_WRITE_U32(0x00000018, SFC_CTL);
+			SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+			SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+			rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+			//setup MD DDR addr and flash addr
+			//REG_WRITE_U32(((unsigned long)virt_to_phys(data_buf)), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)write_dma_handle), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)dest), MD_FDMA_FL_SADDR);
+
+
+			//setup MD direction and move data length
+			val = (0x2E000000 | len);               // do swap
+			REG_WRITE_U32(val, MD_FDMA_CTRL2);		//for dma_length bytes.
+
+			//dma_cache_sync(NULL,data_buf, len, DMA_TO_DEVICE);
+
+			mb();
+			SFC_SYNC;
+
+			//go 
+			REG_WRITE_U32(0x03, MD_FDMA_CTRL1);
+
+			/* wait for MD done its operation */
+			while((ret = REG_READ_U32(MD_FDMA_CTRL1)) & 0x1);
+
+#if !SFC_HW_POLL
+			/* wait for flash controller done its operation */
+			do {
+#ifdef EMMC_ISSUE_LOCK
+				rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+				SFC_SYNC;
+
+				SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+				REG_WRITE_U32(0x00000005, SFC_OPCODE); 
+#if SFC_USE_DELAY
+				sfc_delay();
+#endif
+				REG_WRITE_U32(0x00000010, SFC_CTL);
+				SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+				SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+				rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+			} while((*(volatile unsigned char *)FLASH_POLL_ADDR) & 0x1);
+#endif     	    
+			/* shift to next page to writing */
+			src += len;
+			dest += len;
+			written_count += len;
+			len -= len;
+		} //end of page program
+	}
+	
+	if (byte_len_after_16MB) {
+		_sfc_enable_4B_addr_mode();
+        _sfc_enable_host_4B_addr();
+		
+		SFC_SYNC;
+		SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+		REG_WRITE_U32(0x00000002, SFC_OPCODE);	/* Byte Programming */
+#if SFC_USE_DELAY
+		sfc_delay();
+#endif
+
+		REG_WRITE_U32(0x00000018, SFC_CTL);	/* dataen = 1, adren = 1, dmycnt = 0 */
+		SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+		SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+		rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+		len = byte_len_after_16MB;
+		while(len > 0) {
+			p_data_buf = (u8 *)write_dma_buf;
+        
+			for(i = 0; i < len ; i += 4) { /* endian convert */
+#if 0
+				val = *((u32*)(src + i));
+				*((u32*)(data_buf + i)) = 
+#if 0
+							((val >> 24) |
+							((val >> 8 ) & 0x0000ff00) |
+							((val << 8 ) & 0x00ff0000) |
+							(val << 24));
+#else
+							val;
+#endif
+#endif
+				*((u32*)(p_data_buf + i)) = *((u32*)(src + i));
+			}
+
+#ifdef EMMC_ISSUE_LOCK
+			rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+			//issue write command
+			SFC_SYNC;
+			SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+			REG_WRITE_U32(0x00000002, SFC_OPCODE);
+		
+#if SFC_USE_DELAY
+			sfc_delay();
+#endif
+
+			REG_WRITE_U32(0x00000018, SFC_CTL);
+			SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+			SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+			rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+			//setup MD DDR addr and flash addr
+			//REG_WRITE_U32(((unsigned long)virt_to_phys(data_buf)), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)write_dma_handle), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)dest), MD_FDMA_FL_SADDR);
+
+
+			//setup MD direction and move data length
+			val = (0x2E000000 | len);               // do swap
+			REG_WRITE_U32(val, MD_FDMA_CTRL2);		//for dma_length bytes.
+
+			//dma_cache_sync(NULL,data_buf, len, DMA_TO_DEVICE);
+
+			mb();
+			SFC_SYNC;
+
+			//go 
+			REG_WRITE_U32(0x03, MD_FDMA_CTRL1);
+
+			/* wait for MD done its operation */
+			while((ret = REG_READ_U32(MD_FDMA_CTRL1)) & 0x1);
+
+#if !SFC_HW_POLL
+			/* wait for flash controller done its operation */
+			do {
+#ifdef EMMC_ISSUE_LOCK
+				rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+				SFC_SYNC;
+
+				SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+				REG_WRITE_U32(0x00000005, SFC_OPCODE); 
+#if SFC_USE_DELAY
+				sfc_delay();
+#endif
+				REG_WRITE_U32(0x00000010, SFC_CTL);
+				SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+				SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+				rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+			} while((*(volatile unsigned char *)FLASH_POLL_ADDR) & 0x1);
+#endif     	    
+			/* shift to next page to writing */
+			src += len;
+			dest += len;
+			written_count += len;
+			len -= len;
+		} //end of page program
+		
+		_sfc_disable_4B_addr_mode();
+        _sfc_disable_host_4B_addr();
+	}
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    /* send write disable then */
+    SFC_SYNC;
+ 
+	SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+	REG_WRITE_U32(0x00000004, SFC_OPCODE);	/* Write disable */ 
+#if SFC_USE_DELAY
+	sfc_delay();
+#endif
+
+	REG_WRITE_U32(0x00000000, SFC_CTL);	/* dataen = 0, adren = 0, dmycnt = 0 */
+	SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+	SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+	*retlen = written_count;
+
+	return 0;
+}
+
+static int _sfc_write_pages(struct mtd_info *mtd, loff_t to, size_t len,
+					size_t *retlen, const u_char *buf) {
+
+	u8 *src = (u8*)buf;
+	volatile u8 *dest = (volatile u8*)(NOR_BASE_PHYS + to);
+	u32 written_count = 0;
+	//u8 data_buf[MD_PP_DATA_SIZE];
+	u32 val;
+	int ret;
+	int i;
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+#endif
+
+    u8 *p_data_buf;
+	
+	unsigned int curr_nor_addr = (unsigned long long)FLASH_BASE + to;
+	unsigned int nor_boundary_addr = (unsigned long long)FLASH_BASE + (16 * 1024 * 1024);
+	unsigned int byte_len_before_16MB, byte_len_after_16MB;
+
+	rtk_sfc_info_t *sfc_info = (rtk_sfc_info_t*)mtd->priv;
+    (void)sfc_info;
+
+	if(unlikely((len < MD_PP_DATA_SIZE))) {
+		*retlen = 0;
+		return 0;
+	}
+
+	if(unlikely(((u64)dest&(MD_PP_DATA_SIZE-1)))) {
+		BUG();
+	}
+	
+	if (curr_nor_addr < nor_boundary_addr) {
+        if ((curr_nor_addr + len) > nor_boundary_addr) {
+            byte_len_before_16MB = nor_boundary_addr - curr_nor_addr;
+            byte_len_after_16MB = len - byte_len_before_16MB;
+        }
+        else {
+            byte_len_before_16MB = len;
+            byte_len_after_16MB = 0;
+        }
+    }
+    else {
+        byte_len_before_16MB = 0;
+        byte_len_after_16MB = len;
+    }
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    // write enable
+	REG_WRITE_U32(0x00000006,SFC_OPCODE);
+	REG_WRITE_U32(0x00000000,SFC_CTL);
+	SFC_SYNC;
+
+	// disable write protect
+	REG_WRITE_U32(0x00000000,SFC_WP);
+ 
+	// enable write status register
+	REG_WRITE_U32(0x00000050,SFC_OPCODE);
+	REG_WRITE_U32(0x00000000,SFC_CTL);
+	SFC_SYNC;
+
+	// write status register , no memory protection
+	REG_WRITE_U32(0x00000001,SFC_OPCODE);
+	REG_WRITE_U32(0x00000010,SFC_CTL);
+	SFC_SYNC;
+ 
+	REG_WRITE_U32(0x00000106,SFC_EN_WR);
+    REG_WRITE_U32(0x00000105,SFC_WAIT_WR);
+    REG_WRITE_U32(0x001A1307,SFC_CE);
+
+	if (byte_len_before_16MB) {
+		SFC_SYNC;
+		SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+		REG_WRITE_U32(0x00000002, SFC_OPCODE);	/* Byte Programming */
+#if SFC_USE_DELAY
+		sfc_delay();
+#endif
+
+		REG_WRITE_U32(0x00000018, SFC_CTL);	/* dataen = 1, adren = 1, dmycnt = 0 */
+		SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+		SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+		rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif 
+		len = byte_len_before_16MB;
+		while(len >= MD_PP_DATA_SIZE) {
+			p_data_buf = (u8 *)write_dma_buf;
+			
+			/* data moved by MD module is endian inverted.
+						revert it before moved to flash */
+			for(i = 0; i < MD_PP_DATA_SIZE; i += 4) {
+#if 0
+				val = *((u32*)(src + i));
+				*((u32*)(data_buf + i)) = 
+#if 0
+							((val >> 24) |
+							((val >> 8 ) & 0x0000ff00) |
+							((val << 8 ) & 0x00ff0000) |
+							(val << 24));
+#else
+							val;
+#endif
+#endif
+				*((u32*)(p_data_buf + i)) = *((u32*)(src + i));
+			}
+
+#ifdef EMMC_ISSUE_LOCK
+			rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+			SFC_SYNC; 
+			SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+			REG_WRITE_U32(0x00000002, SFC_OPCODE);
+		
+#if SFC_USE_DELAY
+			sfc_delay();
+#endif
+
+			REG_WRITE_U32(0x00000018, SFC_CTL);
+			SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+			SFC_SYNC; 
+
+#ifdef EMMC_ISSUE_LOCK
+			rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif 
+
+			//setup MD DDR addr and flash addr
+			//REG_WRITE_U32(((unsigned long)virt_to_phys(data_buf)), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)write_dma_handle), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)dest), MD_FDMA_FL_SADDR);
+
+			//setup MD direction and move data length
+			val = (0x26000000 | MD_PP_DATA_SIZE);   // do swap
+			REG_WRITE_U32(val, MD_FDMA_CTRL2);		//for dma_length bytes.
+			
+			//dma_cache_sync(NULL, data_buf, MD_PP_DATA_SIZE, DMA_TO_DEVICE);
+
+			mb();
+			SFC_SYNC;
+
+			//go 
+			REG_WRITE_U32(0x03, MD_FDMA_CTRL1);
+
+			/* wait for MD done its operation */
+			while((ret = REG_READ_U32(MD_FDMA_CTRL1)) & 0x1);
+
+#if !SFC_HW_POLL
+			/* wait for flash controller done its operation */
+			do {
+#ifdef EMMC_ISSUE_LOCK
+				rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+				SFC_SYNC;
+	 
+				SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+				REG_WRITE_U32(0x00000005, SFC_OPCODE);
+			
+#if SFC_USE_DELAY
+				sfc_delay();
+#endif
+
+				REG_WRITE_U32(0x00000010, SFC_CTL);
+				SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+				SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+				rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif 
+			} while((*(volatile unsigned char *)FLASH_POLL_ADDR) & 0x1);
+#endif
+
+			/* shift to next page to writing */
+			src += MD_PP_DATA_SIZE;
+			dest += MD_PP_DATA_SIZE;
+			written_count += MD_PP_DATA_SIZE;
+			len -= MD_PP_DATA_SIZE;
+		}//end of page program
+	}
+	
+	if (byte_len_after_16MB) {
+		_sfc_enable_4B_addr_mode();
+        _sfc_enable_host_4B_addr();
+		
+		SFC_SYNC;
+		SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+		REG_WRITE_U32(0x00000002, SFC_OPCODE);	/* Byte Programming */
+#if SFC_USE_DELAY
+		sfc_delay();
+#endif
+
+		REG_WRITE_U32(0x00000018, SFC_CTL);	/* dataen = 1, adren = 1, dmycnt = 0 */
+		SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+		SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+		rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif 
+		len = byte_len_after_16MB;
+		while(len >= MD_PP_DATA_SIZE) {
+			p_data_buf = (u8 *)write_dma_buf;
+			
+			/* data moved by MD module is endian inverted.
+						revert it before moved to flash */
+			for(i = 0; i < MD_PP_DATA_SIZE; i += 4) {
+#if 0
+				val = *((u32*)(src + i));
+				*((u32*)(data_buf + i)) = 
+#if 0
+							((val >> 24) |
+							((val >> 8 ) & 0x0000ff00) |
+							((val << 8 ) & 0x00ff0000) |
+							(val << 24));
+#else
+							val;
+#endif
+#endif
+				*((u32*)(p_data_buf + i)) = *((u32*)(src + i));
+			}
+
+#ifdef EMMC_ISSUE_LOCK
+			rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+			SFC_SYNC; 
+			SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+			REG_WRITE_U32(0x00000002, SFC_OPCODE);
+		
+#if SFC_USE_DELAY
+			sfc_delay();
+#endif
+
+			REG_WRITE_U32(0x00000018, SFC_CTL);
+			SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+			SFC_SYNC; 
+
+#ifdef EMMC_ISSUE_LOCK
+			rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif 
+
+			//setup MD DDR addr and flash addr
+			//REG_WRITE_U32(((unsigned long)virt_to_phys(data_buf)), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)write_dma_handle), MD_FDMA_DDR_SADDR);
+			REG_WRITE_U32(((unsigned long)dest), MD_FDMA_FL_SADDR);
+
+			//setup MD direction and move data length
+			val = (0x26000000 | MD_PP_DATA_SIZE);   // do swap
+			REG_WRITE_U32(val, MD_FDMA_CTRL2);		//for dma_length bytes.
+			
+			//dma_cache_sync(NULL, data_buf, MD_PP_DATA_SIZE, DMA_TO_DEVICE);
+
+			mb();
+			SFC_SYNC;
+
+			//go 
+			REG_WRITE_U32(0x03, MD_FDMA_CTRL1);
+
+			/* wait for MD done its operation */
+			while((ret = REG_READ_U32(MD_FDMA_CTRL1)) & 0x1);
+
+#if !SFC_HW_POLL
+			/* wait for flash controller done its operation */
+			do {
+#ifdef EMMC_ISSUE_LOCK
+				rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+				SFC_SYNC;
+	 
+				SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+				REG_WRITE_U32(0x00000005, SFC_OPCODE);
+			
+#if SFC_USE_DELAY
+				sfc_delay();
+#endif
+
+				REG_WRITE_U32(0x00000010, SFC_CTL);
+				SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+				SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+				rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif 
+			} while((*(volatile unsigned char *)FLASH_POLL_ADDR) & 0x1);
+#endif
+
+			/* shift to next page to writing */
+			src += MD_PP_DATA_SIZE;
+			dest += MD_PP_DATA_SIZE;
+			written_count += MD_PP_DATA_SIZE;
+			len -= MD_PP_DATA_SIZE;
+		}//end of page program
+		
+		_sfc_disable_4B_addr_mode();
+        _sfc_disable_host_4B_addr();
+	}
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    /* send write disable then */
+    SFC_SYNC; 
+	SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+	REG_WRITE_U32(0x00000004, SFC_OPCODE);	/* Write disable */
+ 
+#if SFC_USE_DELAY
+	sfc_delay();
+#endif
+
+	REG_WRITE_U32(0x00000000, SFC_CTL);	/* dataen = 0, adren = 0, dmycnt = 0 */
+	SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+	SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+	*retlen = written_count;
+
+	return 0;
+}
+
+//---------------------------------------------------------------------------------------------
+
+/* rtk_sfc_write_pages() supports MD(move data module) page programming(PP). */
+static int rtk_sfc_write_pages(struct mtd_info *mtd, loff_t to, size_t len,
+						size_t *retlen, const u_char *buf) {
+	rtk_sfc_info_t *sfc_info;
+	u8 *src = (u8*)buf;
+#ifdef CONFIG_MTD_RTK_MD_WRITE_COMPARE
+	u8 *org_src = (u8*)buf;
+	unsigned int org_to = to;
+	size_t org_len = len;
+	u32 i;
+	u32 cmp_cnt=0, cmp_mod=0;
+	volatile u32 *ptr_flash=NULL, *ptr_src=NULL;
+#endif
+	size_t written_len = 0;
+	size_t wlen = 0;
+	size_t length_to_write;
+	int ret;
+	
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	add_debug_entry(buf, to, len, WRITE_ACCESS);
+#endif
+
+#ifdef DEV_DEBUG 
+	printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write_pages(), addr = %08X, size = %08X\n", (unsigned int)(unsigned long)to, (unsigned int)(unsigned long)len);
+#endif
+
+	if((sfc_info = (rtk_sfc_info_t*)mtd->priv) == NULL) { 
+		printk("sfc_info is NULL\n");
+		return -EINVAL;
+	}
+
+	down_write(&rw_sem);
+
+	//SFC_FLUSH_CACHE((unsigned long) buf,len);
+
+	/* Set SB2 to in-order mode */
+	//_before_serial_flash_access();
+#ifdef CONFIG_MTD_RTK_MD_WRITE_COMPARE
+retry_mdwrite:	
+#endif
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(WRITE_READY);
+#endif
+
+	// 1st pass: write data 0-3 bytes 
+	// (to make destination address within 4-bytes alignment)
+	if(len > 0 && (to & RTK_SFC_SMALL_PAGE_WRITE_MASK)) {
+		if(len > RTK_SFC_SMALL_PAGE_WRITE_MASK)
+			length_to_write = (RTK_SFC_SMALL_PAGE_WRITE_MASK + 1) - (to & RTK_SFC_SMALL_PAGE_WRITE_MASK);
+		else
+			length_to_write = len;
+
+		ret = _sfc_write_bytes(mtd, to, length_to_write, &wlen, src);
+
+		if(ret || unlikely(wlen != length_to_write)) {
+			*retlen = wlen;
+
+			/* Restore SB2 */
+			//_after_serial_flash_access();
+
+			up_write(&rw_sem);
+			return ret;
+		}
+
+#ifdef DEV_DEBUG 
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write() $ PASS #1 $ [%08X:%08X]\n", (int)to, (int)len);
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write() $ PASS #1 $ %d bytes written\n", (int)wlen);
+#endif
+
+		src += wlen;
+		written_len += wlen;
+		len -= wlen;
+		to += wlen;
+	}
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(WRITE_STAGE_1);
+#endif
+
+	// 2st pass: write data which aligned in 4 bytes but smaller than a single page (256 bytes)
+	// (to make destination address within 256-bytes alignment)
+	if(len > RTK_SFC_SMALL_PAGE_WRITE_MASK && 
+					(((to + MD_PP_DATA_SIZE - 1) & (~(MD_PP_DATA_SIZE - 1))) - to) > RTK_SFC_SMALL_PAGE_WRITE_MASK) {
+		length_to_write = ((to + MD_PP_DATA_SIZE - 1) & (~(MD_PP_DATA_SIZE - 1))) - to;
+
+		if(length_to_write > len)
+			length_to_write = len;
+
+		if(length_to_write & RTK_SFC_SMALL_PAGE_WRITE_MASK)
+			length_to_write = length_to_write & (~RTK_SFC_SMALL_PAGE_WRITE_MASK);
+
+		ret = _sfc_write_small_pages(mtd, to, length_to_write, &wlen, src);
+
+		if(ret || unlikely(wlen != length_to_write)) {
+			*retlen = wlen;
+
+			/* Restore SB2 */
+			//_after_serial_flash_access();
+
+			up_write(&rw_sem);
+
+			return ret;
+		}
+
+#ifdef DEV_DEBUG 
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write() $ PASS #2 $ [%08X:%08X]\n", (int)to, (int)len);
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write() $ PASS #2 $ %d bytes written\n", (int)wlen);
+#endif
+
+		src += wlen;
+		written_len += wlen;
+		len -= wlen;
+		to += wlen;
+	}
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(WRITE_STAGE_2);
+#endif
+
+	// 3rd pass: write data in page unit (256 bytes)
+	if(len >= MD_PP_DATA_SIZE) {
+		length_to_write = len / MD_PP_DATA_SIZE * MD_PP_DATA_SIZE;
+
+		ret = _sfc_write_pages(mtd, to, length_to_write, &wlen, src);
+
+		if(ret || unlikely(wlen != length_to_write)) {
+			*retlen = wlen;
+
+			/* Restore SB2 */
+			//_after_serial_flash_access();
+
+			up_write(&rw_sem);
+			return ret;
+		}
+
+#ifdef DEV_DEBUG 
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write() $ PASS #3 $ [%08X:%08X] (%d)\n", (int)to, (int)len, MD_PP_DATA_SIZE);
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write() $ PASS #3 $ %d bytes written\n", (int)wlen);
+#endif
+
+		src += wlen;
+		written_len += wlen;
+		len -= wlen;
+		to += wlen;
+	}
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(WRITE_STAGE_3);
+#endif
+
+	// 4th pass: write data which aligned in 4 bytes but smaller than a single page (256 bytes)
+	if(len > 0 && (len & (~RTK_SFC_SMALL_PAGE_WRITE_MASK))) {
+		length_to_write = len & (~RTK_SFC_SMALL_PAGE_WRITE_MASK);
+
+		ret = _sfc_write_small_pages(mtd, to, length_to_write, &wlen, src);
+
+		if(ret || unlikely(wlen != length_to_write)) {
+			*retlen = wlen;
+
+			/* Restore SB2 */
+			//_after_serial_flash_access();
+
+			up_write(&rw_sem);
+			return ret;
+		}
+
+#ifdef DEV_DEBUG 
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write() $ PASS #4 $ [%08X:%08X]\n", (int)to, (int)len);
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write() $ PASS #4 $ %d bytes written\n", (int)wlen);
+#endif
+
+		src += wlen;
+		written_len += wlen;
+		len -= wlen;
+		to += wlen;
+	}
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(WRITE_STAGE_4);
+#endif
+
+	// 5th pass: write data 0-3 bytes
+	if(len > 0) {
+		length_to_write = len;
+
+		ret = _sfc_write_bytes(mtd, to, length_to_write, &wlen, src);
+
+		if(ret || unlikely(wlen != length_to_write)) {
+			*retlen = wlen;
+
+			/* Restore SB2 */
+			//_after_serial_flash_access();
+
+			up_write(&rw_sem);
+			return ret;
+		}
+
+#ifdef DEV_DEBUG 
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write() $ PASS #5 $ [%08X:%08X]\n", (int)to, (int)len);
+		printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write() $ PASS #5 $ %d bytes written\n", (int)wlen);
+#endif
+
+		src += wlen;
+		written_len += wlen;
+		len -= wlen;
+		to += wlen;
+	}
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(WRITE_STAGE_5);
+#endif
+
+	*retlen = written_len;
+
+	/* restore opcode to read */
+	_switch_to_read_mode((rtk_sfc_info_t*)mtd->priv, eREAD_MODE_SINGLE_FAST_READ);
+
+	/* Restore SB2 */
+	//_after_serial_flash_access();
+#ifdef CONFIG_MTD_RTK_MD_WRITE_COMPARE 
+        //TODO : louis, cache flush issues need to take care, not correct everytime
+	ptr_flash = (volatile unsigned int*)(FLASH_BASE + org_to);
+	ptr_src = (volatile unsigned int*)(org_src);
+
+	cmp_cnt = org_len / 4;
+	cmp_mod = org_len % 4;
+	for(i=0;i<cmp_cnt;i++)
+	{
+		if (ptr_flash[i] != endian_swap(ptr_src[i]))
+		{
+	    		printk("1 write error at buf=%x %x len=%x\n", org_src, (FLASH_BASE + org_to), org_len);	
+			for (i=0; i < org_len; i++) {
+				printk("%02x ", org_src[i]);
+				if (i%8 == 7) printk("\n");
+			}
+			printk("\ndest: ");
+			for (i=0; i < org_len; i++) {
+				printk("%02x ", ((unsigned char *)(FLASH_BASE + org_to))[i]);
+				if (i%8 == 7) printk("\n");
+			}
+			while(1) {
+				msleep(3000);
+			}				
+			goto retry_mdwrite;
+		}
+	}
+	for(i=0;i<cmp_mod;i++)
+	{
+		if (org_src[cmp_cnt*4+i] != ((u8*)(FLASH_BASE + org_to))[cmp_cnt*4+i])
+		{
+	    		printk("2 write error at buf=%x %x len=%x\n", org_src, (FLASH_BASE + org_to), org_len);	
+			for (i=0; i < org_len; i++) {
+				printk("%02x ", org_src[i]);
+				if (i%8 == 7) printk("\n");
+			}
+			printk("\ndest: ");
+			for (i=0; i < org_len; i++) {
+				printk("%02x ", ((unsigned char *)(FLASH_BASE + org_to))[i]);
+				if (i%8 == 7) printk("\n");
+			}
+			while(1) {
+				msleep(3000);
+			}				
+			goto retry_mdwrite;
+		}
+	}
+#endif	
+	up_write(&rw_sem);
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+	change_status(WRITE_COMPLETED);
+#endif
+
+	return 0;
+}
+#endif
+
+
+static int rtk_sfc_write(struct mtd_info *mtd, loff_t to, size_t len,
+        size_t *retlen, const u_char *buf) {
+    int retval;
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+#endif
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    add_debug_entry(buf, to, len, WRITE_ACCESS);
+#endif
+
+    down_write(&rw_sem);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    SFC_FLUSH_CACHE((unsigned long) buf,len);
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    change_status(WRITE_READY);
+#endif
+
+#ifdef DEV_DEBUG 
+    printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_write(), to = %08X, length = %08X\n", (int)to, (int)len);
+#endif
+
+    retval = _sfc_write_bytes(mtd, to, len, retlen, buf);
+
+    /* restore opcode to read */
+    _switch_to_read_mode((rtk_sfc_info_t*)mtd->priv, eREAD_MODE_SINGLE_FAST_READ);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    up_write(&rw_sem);
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    change_status(WRITE_COMPLETED);
+#endif
+
+    return retval;
+}
+
+#ifdef EON_SEGMENT_ERASE
+static int rtk_EON_segm_erase(struct mtd_info *mtd, struct erase_info *instr) {
+    rtk_sfc_info_t *sfc_info;
+    unsigned int size;
+    volatile unsigned char *addr;
+    unsigned char tmp;
+
+    unsigned int erase_addr;
+    unsigned int erase_opcode;
+    unsigned int erase_size;
+
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+#endif
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    add_debug_entry(instr->addr, 0, instr->len, ERASE_ACCESS);
+#endif
+
+    if((sfc_info = (rtk_sfc_info_t*)mtd->priv) == NULL) {
+        return -EINVAL;
+    }
+
+    if(instr->addr + instr->len > mtd->size)
+        return -EINVAL;
+
+    down_write(&rw_sem);
+
+#ifdef DEV_DEBUG 
+    printk(KERN_WARNING "Rtk SFC MTD: rtk_sfc_erase(), addr = %08X, size = %08X\n", instr->addr, instr->len);
+#endif
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    //disable auto-prog
+    REG_WRITE_U32(0x00000005, SFC_WAIT_WR);
+    REG_WRITE_U32(0x00000006, SFC_EN_WR);
+    
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    addr = FLASH_BASE + (instr->addr);
+    size = instr->len;
+
+    erase_addr = (unsigned int)instr->addr;
+    erase_opcode = sfc_info->erase_opcode;
+    erase_size = mtd->erasesize;
+
+    for(size = instr->len ; size > 0 ; size -= erase_size) {
+
+        if((addr-FLASH_BASE)>=0 && (addr-FLASH_BASE)<0x10000)
+        {
+            erase_opcode = 0x000000d8;
+            if((addr-FLASH_BASE)>=0 && (addr-FLASH_BASE)<0x1000)
+            {
+                erase_size = 0x1000;
+            }
+            else if((addr-FLASH_BASE)>=0x1000 && (addr-FLASH_BASE)<0x2000)
+            {
+                erase_size = 0x1000;
+            }
+            else if((addr-FLASH_BASE)>=0x2000 && (addr-FLASH_BASE)<0x4000)
+            {
+                erase_size = 0x2000;
+            }
+            else if((addr-FLASH_BASE)>=0x4000 && (addr-FLASH_BASE)<0x8000)
+            {
+                erase_size = 0x4000;
+            }
+            else if((addr-FLASH_BASE)>=0x8000 && (addr-FLASH_BASE)<0x10000)
+            {
+                erase_size = 0x8000;
+            }
+
+        }
+        else
+        {
+
+            /* choose erase sector size */
+            if (((erase_addr&(0x10000-1)) == 0) && (size >= 0x10000) && (sfc_info->sec_64k_en == SUPPORTED))
+            {
+                erase_opcode = 0x000000d8;
+                erase_size = 0x10000;
+            }
+            else if (((erase_addr&(0x1000-1)) == 0) && (size >= 0x1000) && (sfc_info->sec_4k_en == SUPPORTED))
+            {
+                erase_opcode = 0x00000020;
+                erase_size = 0x1000;
+            }
+            else
+            {
+                erase_opcode = sfc_info->erase_opcode;
+                erase_size = mtd->erasesize;
+            }
+        }
+
+#ifdef EMMC_ISSUE_LOCK
+        rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+        /* prior to any write instructions, send write enable first */
+        //(write enable)
+        SFC_SYNC;
+        SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+        REG_WRITE_U32(0x00000006, SFC_OPCODE);
+
+#if SFC_USE_DELAY
+        sfc_delay();
+#endif
+
+        REG_WRITE_U32(0x00000000, SFC_CTL); /* dataen = 0, adren = 0, dmycnt = 0 */
+        SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+        SFC_SYNC;
+        tmp = *(volatile unsigned char *)FLASH_POLL_ADDR;
+        SFC_SYNC;
+        SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+        REG_WRITE_U32(erase_opcode, SFC_OPCODE);    /* Sector-Erase */
+#if SFC_USE_DELAY
+        sfc_delay();
+#endif
+
+        REG_WRITE_U32(0x00000008, SFC_CTL); /* adren = 1 */
+        SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+        SFC_SYNC;
+        tmp = *addr;
+
+#ifdef EMMC_ISSUE_LOCK
+        rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+        /* using RDSR to make sure the operation is completed. */
+        while(1) {
+#ifdef EMMC_ISSUE_LOCK
+            rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+            
+            SFC_SYNC;
+            SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+            REG_WRITE_U32(0x00000005, SFC_OPCODE);  /* Read status register */
+
+#if SFC_USE_DELAY
+            sfc_delay();
+#endif
+
+            REG_WRITE_U32(0x00000010, SFC_CTL); /* dataen = 1, adren = 0, dmycnt = 0 */
+            SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+            SFC_SYNC;
+            
+#ifdef EMMC_ISSUE_LOCK
+            rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+            if((*(volatile unsigned char *)FLASH_POLL_ADDR) & 0x1)
+                msleep(100); // erasing 256KBytes might take up to 2 seconds!
+            else
+                break;
+        }
+
+        addr += erase_size;
+        erase_addr += erase_size;
+
+    }
+    
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    /* send write disable then */
+    SFC_SYNC;
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x00000004, SFC_OPCODE);  /* Write disable */
+
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+
+    REG_WRITE_U32(0x00000000, SFC_CTL); /* dataen = 0, adren = 0, dmycnt = 0 */
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;
+    tmp = *(volatile unsigned char *)FLASH_POLL_ADDR;
+
+    /* restore opcode to read */
+    _switch_to_read_mode(sfc_info, eREAD_MODE_SINGLE_FAST_READ);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, __FUNCTION__);
+#endif
+
+    up_write(&rw_sem);
+
+    instr->state = MTD_ERASE_DONE;
+    mtd_erase_callback(instr);
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG) 
+    change_status(ERASE_COMPLETED);
+#endif
+
+    return 0;   
+
+}
+#endif
+
+static int rtk_sfc_erase(struct mtd_info *mtd, struct erase_info *instr) 
+{
+    rtk_sfc_info_t *sfc_info;
+    unsigned int size;
+    volatile unsigned char *addr;
+    unsigned char tmp;
+
+    unsigned int erase_addr;
+    unsigned int erase_opcode;
+    unsigned int erase_size;
+	//unsigned int curr_address;
+	unsigned char en4B_flag = 0;
+
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+#endif
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    add_debug_entry(instr->addr, 0, instr->len, ERASE_ACCESS);
+#endif
+
+    if((sfc_info = (rtk_sfc_info_t*)mtd->priv) == NULL) {
+        return -EINVAL;
+    }
+
+    if(instr->addr + instr->len > mtd->size)
+        return -EINVAL;
+
+    down_write(&rw_sem);
+
+#ifdef DEV_DEBUG 
+    printk("Rtk SFC MTD: rtk_sfc_erase(), addr = %08X, size = %08X\n", (unsigned int)instr->addr, (unsigned int) instr->len);
+#endif
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    //disable auto-prog
+    REG_WRITE_U32(0x00000005, SFC_WAIT_WR);
+    REG_WRITE_U32(0x00000006, SFC_EN_WR);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    addr = FLASH_BASE + (instr->addr);
+    size = instr->len;
+
+    erase_addr = (unsigned int)instr->addr;
+    erase_opcode = sfc_info->erase_opcode;
+    erase_size = mtd->erasesize;
+
+    for(size = instr->len ; size > 0 ; size -= erase_size) {
+		
+		if (en4B_flag == 0) {
+            if (((unsigned long long)addr - (unsigned long long)FLASH_BASE) >= (16 * 1024 *1024)) {
+                _sfc_enable_4B_addr_mode();
+				_sfc_enable_host_4B_addr();
+                en4B_flag = 1;
+            }
+        }
+
+        /* choose erase sector size */
+        if (((erase_addr&(0x10000-1)) == 0) && (size >= 0x10000) && (sfc_info->sec_64k_en == SUPPORTED))
+        {
+            erase_opcode = 0x000000d8;
+            erase_size = 0x10000;
+        }
+/*
+           else if (((erase_addr&(0x8000-1)) == 0) && (size >= 0x8000) && (sfc_info->sec_32k_en == SUPPORTED))
+           {
+                erase_opcode = 0x00000052;
+                erase_size = 0x8000;
+           }
+*/
+        else if (((erase_addr&(0x1000-1)) == 0) && (size >= 0x1000) && (sfc_info->sec_4k_en == SUPPORTED))
+        {
+            erase_opcode = 0x00000020;
+            erase_size = 0x1000;
+        }
+        else
+        {
+            erase_opcode = sfc_info->erase_opcode;
+            erase_size = mtd->erasesize;
+        }
+
+#ifdef EMMC_ISSUE_LOCK
+        rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif 
+
+        /* prior to any write instructions, send write enable first */
+        //(write enable)  
+        SFC_SYNC;
+
+        SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+        REG_WRITE_U32(0x00000006, SFC_OPCODE);
+
+#if SFC_USE_DELAY
+        sfc_delay();
+#endif
+
+        REG_WRITE_U32(0x00000000, SFC_CTL); /* dataen = 0, adren = 0, dmycnt = 0 */
+        SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+        SFC_SYNC;
+        tmp = *(volatile unsigned char *)FLASH_POLL_ADDR;
+        SFC_SYNC;
+        SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+        REG_WRITE_U32(erase_opcode, SFC_OPCODE);    /* Sector-Erase */
+#if SFC_USE_DELAY
+        sfc_delay();
+#endif
+
+        REG_WRITE_U32(0x00000008, SFC_CTL); /* adren = 1 */
+        SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+        SFC_SYNC;
+        tmp = *addr;
+
+#ifdef EMMC_ISSUE_LOCK
+        rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+
+        /* using RDSR to make sure the operation is completed. */
+        while(1) {
+#ifdef EMMC_ISSUE_LOCK
+            rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+            SFC_SYNC;
+
+            SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+            REG_WRITE_U32(0x00000005, SFC_OPCODE);  /* Read status register */
+
+#if SFC_USE_DELAY
+            sfc_delay();
+#endif
+
+            REG_WRITE_U32(0x00000010, SFC_CTL); /* dataen = 1, adren = 0, dmycnt = 0 */
+            SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+            SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+            rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+            if((*(volatile unsigned char *)FLASH_POLL_ADDR) & 0x1)
+                msleep(100); // erasing 256KBytes might take up to 2 seconds!
+            else
+                break;
+        }
+
+        addr += erase_size;
+        erase_addr += erase_size;
+
+		if (en4B_flag == 1) {
+			_sfc_disable_4B_addr_mode();
+			_sfc_disable_host_4B_addr();
+        }
+    }
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    /* send write disable then */
+    SFC_SYNC;
+
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x00000004, SFC_OPCODE);  /* Write disable */
+
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+
+    REG_WRITE_U32(0x00000000, SFC_CTL); /* dataen = 0, adren = 0, dmycnt = 0 */
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;
+    tmp = *(volatile unsigned char *)FLASH_POLL_ADDR;
+
+    //enable auto-prog
+    REG_WRITE_U32(0x00000105, SFC_WAIT_WR);
+    REG_WRITE_U32(0x00000106, SFC_EN_WR);
+
+    /* restore opcode to read */
+    _switch_to_read_mode(sfc_info, eREAD_MODE_SINGLE_FAST_READ);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    up_write(&rw_sem);
+
+    instr->state = MTD_ERASE_DONE;
+    mtd_erase_callback(instr);
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG) 
+    change_status(ERASE_COMPLETED);
+#endif
+
+    return 0;
+}
+
+/*
+ * Erase blocks in a panic context.
+ *
+ * This routine is very similar to rtk_sfc_erase() except that it does not sleep
+ * when checking for erase completion and the callback function is not called.
+ */
+int rtk_sfc_panic_erase(struct mtd_info *mtd, struct erase_info *instr)
+{
+    rtk_sfc_info_t *sfc_info;
+    unsigned int size;
+    volatile unsigned char *addr;
+    unsigned char tmp;
+
+    unsigned int erase_addr;
+    unsigned int erase_opcode;
+    unsigned int erase_size;
+	//unsigned int curr_address;
+	unsigned char en4B_flag = 0;
+
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+#endif
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    add_debug_entry(instr->addr, 0, instr->len, ERASE_ACCESS);
+#endif
+
+    if((sfc_info = (rtk_sfc_info_t*)mtd->priv) == NULL) {
+        return -EINVAL;
+    }
+
+    if(instr->addr + instr->len > mtd->size)
+        return -EINVAL;
+
+    down_write(&rw_sem);
+
+#ifdef DEV_DEBUG
+    printk("Rtk SFC MTD: rtk_sfc_erase(), addr = %08X, size = %08X\n", (unsigned int)instr->addr, (unsigned int) instr->len);
+#endif
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    //disable auto-prog
+    REG_WRITE_U32(0x00000005, SFC_WAIT_WR);
+    REG_WRITE_U32(0x00000006, SFC_EN_WR);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    addr = FLASH_BASE + (instr->addr);
+    size = instr->len;
+
+    erase_addr = (unsigned int)instr->addr;
+    erase_opcode = sfc_info->erase_opcode;
+    erase_size = mtd->erasesize;
+
+    for(size = instr->len ; size > 0 ; size -= erase_size) {
+
+		if (en4B_flag == 0) {
+            if (((unsigned long long)addr - (unsigned long long)FLASH_BASE) >= (16 * 1024 *1024)) {
+                _sfc_enable_4B_addr_mode();
+				_sfc_enable_host_4B_addr();
+                en4B_flag = 1;
+            }
+        }
+
+        /* choose erase sector size */
+        if (((erase_addr&(0x10000-1)) == 0) && (size >= 0x10000) && (sfc_info->sec_64k_en == SUPPORTED))
+        {
+            erase_opcode = 0x000000d8;
+            erase_size = 0x10000;
+        }
+/*
+           else if (((erase_addr&(0x8000-1)) == 0) && (size >= 0x8000) && (sfc_info->sec_32k_en == SUPPORTED))
+           {
+                erase_opcode = 0x00000052;
+                erase_size = 0x8000;
+           }
+*/
+        else if (((erase_addr&(0x1000-1)) == 0) && (size >= 0x1000) && (sfc_info->sec_4k_en == SUPPORTED))
+        {
+            erase_opcode = 0x00000020;
+            erase_size = 0x1000;
+        }
+        else
+        {
+            erase_opcode = sfc_info->erase_opcode;
+            erase_size = mtd->erasesize;
+        }
+
+#ifdef EMMC_ISSUE_LOCK
+        rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+        /* prior to any write instructions, send write enable first */
+        //(write enable)
+        SFC_SYNC;
+
+        SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+        REG_WRITE_U32(0x00000006, SFC_OPCODE);
+
+#if SFC_USE_DELAY
+        sfc_delay();
+#endif
+
+        REG_WRITE_U32(0x00000000, SFC_CTL); /* dataen = 0, adren = 0, dmycnt = 0 */
+        SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+        SFC_SYNC;
+        tmp = *(volatile unsigned char *)FLASH_POLL_ADDR;
+        SFC_SYNC;
+        SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+        REG_WRITE_U32(erase_opcode, SFC_OPCODE);    /* Sector-Erase */
+#if SFC_USE_DELAY
+        sfc_delay();
+#endif
+
+        REG_WRITE_U32(0x00000008, SFC_CTL); /* adren = 1 */
+        SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+        SFC_SYNC;
+        tmp = *addr;
+
+#ifdef EMMC_ISSUE_LOCK
+        rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+
+        /* using RDSR to make sure the operation is completed. */
+        while(1) {
+#ifdef EMMC_ISSUE_LOCK
+            rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+            SFC_SYNC;
+
+            SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+            REG_WRITE_U32(0x00000005, SFC_OPCODE);  /* Read status register */
+
+#if SFC_USE_DELAY
+            sfc_delay();
+#endif
+
+            REG_WRITE_U32(0x00000010, SFC_CTL); /* dataen = 1, adren = 0, dmycnt = 0 */
+            SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+            SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+            rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+            if((*(volatile unsigned char *)FLASH_POLL_ADDR) & 0x1)
+                ;	// don't sleep in panic context
+            else
+                break;
+        }	// while
+        addr += erase_size;
+        erase_addr += erase_size;
+
+		if (en4B_flag == 1) {
+			_sfc_disable_4B_addr_mode();
+			_sfc_disable_host_4B_addr();
+        }	// if
+    }	// for
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    /* send  write disable then */
+    SFC_SYNC;
+
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x00000004, SFC_OPCODE);  /* Write disable */
+
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+
+    REG_WRITE_U32(0x00000000, SFC_CTL); /* dataen = 0, adren = 0, dmycnt = 0 */
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;
+    tmp = *(volatile unsigned char *)FLASH_POLL_ADDR;
+
+    //enable auto-prog
+    REG_WRITE_U32(0x00000105, SFC_WAIT_WR);
+    REG_WRITE_U32(0x00000106, SFC_EN_WR);
+
+    /* restore opcode to read */
+    _switch_to_read_mode(sfc_info, eREAD_MODE_SINGLE_FAST_READ);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    up_write(&rw_sem);
+
+    instr->state = MTD_ERASE_DONE;
+//    mtd_erase_callback(instr);	// callback function is not called
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    change_status(ERASE_COMPLETED);
+#endif
+
+    return 0;
+}
+EXPORT_SYMBOL_GPL(rtk_sfc_panic_erase);
+
+static int rtk_sfc_suspend(struct mtd_info *mtd)
+{
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    // save register when suspend
+    g_sfc_reg.sfc_ce = REG_READ_U32(SFC_CE);
+    g_sfc_reg.sfc_wp = REG_READ_U32(SFC_WP);
+    g_sfc_reg.sfc_sck = REG_READ_U32(SFC_SCK);
+    g_sfc_reg.sfc_pos_latch = REG_READ_U32(SFC_POS_LATCH);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    return 0;
+}
+
+static void rtk_sfc_resume(struct mtd_info *mtd)
+{
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+
+    REG_WRITE_U32(0x00000000, SFC_WP);
+
+    // // restore register when resume
+    REG_WRITE_U32(g_sfc_reg.sfc_ce, SFC_CE);
+    REG_WRITE_U32(g_sfc_reg.sfc_wp, SFC_WP);
+    REG_WRITE_U32(g_sfc_reg.sfc_sck, SFC_SCK);
+    REG_WRITE_U32(g_sfc_reg.sfc_pos_latch, SFC_POS_LATCH);
+    SFC_SYNC;
+
+    SYS_REG_TRY_UNLOCK;
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+}
+
+void rtk_sfc_shutdown(struct mtd_info *mtd)
+{
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+#endif
+
+    down_write(&rw_sem);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    while((REG_READ_U32(MD_FDMA_CTRL1)) & 0x1);
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x00000805, SFC_OPCODE);  /* RDSR */
+#if SFC_USE_DELAY 
+    sfc_delay();
+#endif
+
+    REG_WRITE_U32(0x00000010, SFC_CTL); /* dataen = 1, adren = 0, dmycnt = 0 */
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;
+
+    while((*(volatile unsigned char *)FLASH_POLL_ADDR) & 0x1);
+
+    _switch_to_read_mode(&rtk_sfc_info, eREAD_MODE_SINGLE_FAST_READ);
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    up_write(&rw_sem);
+
+    return;
+}
+
+static int rtk_sfc_probe(struct platform_device *pdev) 
+{
+    struct mtd_info *mtd_info;
+    rtk_sfc_info_t *sfc_info;
+    unsigned int id = 0;
+    unsigned int reg_muxpad = 0;
+    int ret = 0;
+
+#if defined(CONFIG_ARCH_RTD16xx)
+    void __iomem *pinmux6_reg;
+    void __iomem *pinmux1_reg;
+#endif
+
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+#endif
+
+    mtd_info = (struct mtd_info*)&descriptor;
+
+    if((sfc_info = (rtk_sfc_info_t*)mtd_info->priv) == NULL) {
+        return -ENODEV;
+    }
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    // set spi pin mux
+    SFC_SYNC;
+    SYS_REG_TRY_LOCK(0);
+#if defined(CONFIG_ARCH_RTD16xx)
+    pinmux6_reg = ioremap(ISO_MUXPAD6, 4);
+    pinmux1_reg = ioremap(ISO_MUXPAD1, 4);
+    writel(readl(pinmux6_reg) | BIT(11), pinmux6_reg);
+    writel(readl(pinmux1_reg) | 0x002db400, pinmux1_reg);
+    iounmap(pinmux6_reg);
+    iounmap(pinmux1_reg);
+#else
+    reg_muxpad = REG_READ_U32(SYS_MUXPAD5) | 0x00000001;
+    REG_WRITE_U32(reg_muxpad, SYS_MUXPAD5);
+#endif
+    SFC_SYNC;
+
+    // configure spi flash controller register
+#if 0
+    REG_WRITE_U32(0x00000013, SFC_SCK);
+    REG_WRITE_U32(0x00000000, SFC_POS_LATCH);
+    REG_WRITE_U32(0x00071307, SFC_CE);    
+#else // same as bootcode
+	REG_WRITE_U32(0x00000013, SFC_SCK);
+    REG_WRITE_U32(0x00000001, SFC_POS_LATCH);
+    REG_WRITE_U32(0x00090101, SFC_CE);
+#endif
+    SFC_SYNC;
+
+    // read Manufacture & device ID
+    REG_WRITE_U32(0x0000009f, SFC_OPCODE);
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+    REG_WRITE_U32(0x00000010, SFC_CTL);
+    SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+#ifdef DEV_DEBUG
+    printk(KERN_INFO "Read id orginal address : %p\n", FLASH_POLL_ADDR);
+#endif
+    id = endian_swap(*(volatile unsigned int *)FLASH_POLL_ADDR);
+    id >>= 8;
+#ifdef DEV_DEBUG
+    printk(KERN_INFO "Read id orginal value : 0x%08x\n", id);
+#endif
+    sfc_info->manufacturer_id = (id & 0x00FF0000)>>16;
+    sfc_info->device_id2 = RDID_DEVICE_EID_1(id);
+    sfc_info->device_id1 = RDID_DEVICE_EID_2(id);
+    printk(KERN_ERR "--RDID Seq: 0x%x | 0x%x | 0x%x\n",sfc_info->manufacturer_id,sfc_info->device_id1,sfc_info->device_id2);
+
+    switch(sfc_info->manufacturer_id) {
+        case MANUFACTURER_ID_SST:
+            ret = sst_init(sfc_info);
+            break;
+
+        case MANUFACTURER_ID_SPANSION:
+            ret = spansion_init(sfc_info);
+            break;
+        case MANUFACTURER_ID_MXIC:
+            ret = mxic_init(sfc_info);
+            break;
+        case MANUFACTURER_ID_PMC:
+            ret = pmc_init(sfc_info);
+            break;
+        case MANUFACTURER_ID_STM:
+            ret = stm_init(sfc_info);
+            break;
+        case MANUFACTURER_ID_EON:
+            ret = eon_init(sfc_info);
+            break;
+        case MANUFACTURER_ID_ATMEL:
+            ret = atmel_init(sfc_info);
+            break;
+
+        case MANUFACTURER_ID_WINBOND:
+            ret = winbond_init(sfc_info);
+            break;
+        case MANUFACTURER_ID_ESMT:
+            ret = esmt_init(sfc_info);
+            break;
+        case MANUFACTURER_ID_GD:
+            ret = gd_init(sfc_info);
+            break;
+        case MANUFACTURER_ID_FM:
+            ret = fm_init(sfc_info);
+            break;
+
+        default:
+            printk(KERN_ERR "RtkSFC MTD: Unknown flash type.\n");
+            printk(KERN_ERR "Manufacturer's ID = %02X, Memory Type = %02X, Memory Capacity = %02X\n", sfc_info->manufacturer_id,\
+		 sfc_info->device_id1, sfc_info->device_id2);
+
+            return -ENODEV;
+            break;
+    }
+
+    mtd_info->erasesize = sfc_info->erase_size;
+    mtd_info->writesize = 0x100;
+#ifdef EON_SEGMENT_ERASE
+    if(g_isSegErase)
+    {
+        printk("Set EON segment erase.\n");
+        mtd_info->erase = rtk_EON_segm_erase;
+    }
+#endif
+
+    printk("Supported Erase Size:%s%s%s%s.\n"
+            , sfc_info->sec_256k_en ? " 256KB" : ""
+            , sfc_info->sec_64k_en ? " 64KB" : ""
+            , sfc_info->sec_32k_en ?" 32KB" : ""
+            , sfc_info->sec_4k_en ? " 4KB" : ""
+          );
+#if SFC_MULTI_READ
+    printk("Attr:%s%s%s.\n"
+            ,(sfc_info->attr & RTK_SFC_ATTR_SUPPORT_DUAL_O) ? " dualread" : ""
+            ,(sfc_info->attr & RTK_SFC_ATTR_SUPPORT_DUAL_IO) ? " dualIO" : ""
+            ,(sfc_info->attr & RTK_SFC_ATTR_SUPPORT_4BYTE_ADDR_MODE) ? " 4bytemode" : ""
+          );
+#endif
+
+#if defined(CONFIG_MTD_RTK_SFC_READ_MD) || defined(CONFIG_MTD_RTK_SFC_WRITE_MD)
+        printk("RtkSFC MTD: Enable RtkSFC MD PP callback function.\n");
+    
+	#if defined(CONFIG_MTD_RTK_SFC_READ_MD)
+        mtd_info->_read = rtk_sfc_read_pages;
+        printk("MD_READ Enable..\n");
+	#else
+        printk("MD_READ Disable..\n");
+	#endif
+	#if defined(CONFIG_MTD_RTK_SFC_WRITE_MD)
+        mtd_info->_write = rtk_sfc_write_pages;
+        printk("MD_WRITE Enable..\n");
+	#else
+        printk("MD_WRITE Disable..\n");
+	#endif
+#endif
+
+    if((ret = rtk_sfc_attach(&descriptor)) != 0) {
+        printk("[%s]Realtek SFC attach fail\n",__FUNCTION__);
+        
+        return ret;
+    }
+
+    return 0;
+}
+
+static struct resource physmap_flash_resource[] = {
+    [0] = {
+        .start  = ((unsigned int)NOR_BASE_PHYS),
+        .end    = ((unsigned int)NOR_BASE_PHYS + FLASH_SIZE - 1),
+        .flags = IORESOURCE_MEM
+    },
+#if 0
+    [1] = {
+        .start  = IRQ_SB2,
+        .end    = IRQ_SB2,
+        .flags  = IORESOURCE_IRQ,
+    },
+
+    [2] = {
+        .start  = ((unsigned int)SPI_RBUS_VIRT),
+        .end    = ((unsigned int)SPI_RBUS_VIRT+FLASH_SIZE-1),
+        .flags = IORESOURCE_MEM
+    }
+#endif
+};
+
+static u64 rtkSFC_dmamask = DMA_BIT_MASK(32); 
+static struct platform_device *rtkSFC_device;
+static struct platform_driver rtkSFC_driver = {
+    .probe      = rtk_sfc_probe,
+    .driver     =
+    {
+        .name   = "RtkSFC",
+        .owner  = THIS_MODULE,
+    },
+};
+
+static int rtk_sfc_init_1(void)
+{
+    int rc = 0;
+    struct mtd_info *mtd_info;
+    rtk_sfc_info_t *sfc_info;
+
+    mtd_info = (struct mtd_info*)&descriptor;
+
+    if((sfc_info = (rtk_sfc_info_t*)mtd_info->priv) == NULL) {
+        return -ENODEV;
+    }
+
+    init_rwsem(&rw_sem);
+
+    rc = platform_driver_register(&rtkSFC_driver);
+
+    if (!rc) {
+        rtkSFC_device = platform_device_alloc("RtkSFC", 0);
+        rtkSFC_device->num_resources = ARRAY_SIZE(physmap_flash_resource);
+        rtkSFC_device->dev.dma_mask = &rtkSFC_dmamask;
+        rtkSFC_device->dev.coherent_dma_mask = DMA_BIT_MASK(32);
+        rtkSFC_device->resource = physmap_flash_resource;
+
+        if (rtkSFC_device) {
+            rc = platform_device_add(rtkSFC_device);
+            if ((sfc_info->manufacturer_id == 0xff)&&
+                    (sfc_info->device_id2 == 0xff) &&
+                    (sfc_info->device_id1 == 0xff))
+            {
+                rc = -1;
+            }
+        }
+        else {
+            rc = -ENOMEM;
+        }
+
+        if (rc < 0) {
+            platform_device_put(rtkSFC_device);
+            platform_driver_unregister(&rtkSFC_driver);
+        }
+    }
+
+    if (rc < 0){
+        printk(KERN_INFO "Realtek SFC Driver installation fails.\n\n");
+        return -ENODEV;
+    } else {
+        printk(KERN_INFO "Realtek SFC Driver is successfully installing.\n\n");
+    }
+
+    return rc;
+}
+
+static int __init rtk_sfc_init(void) 
+{
+
+    printk("RtkSFC MTD init ...\n");
+    printk("NOR flash support list ..\n");
+
+#if  defined(CONFIG_REALTEK_USE_HWSEM_AS_SENTINEL )
+    printk("(V) HWSEMA support.\n");
+#else
+    printk("(X) HWSEMA support.\n");
+#endif
+
+#if SFC_HW_POLL
+    printk("(V) AUTO_HW_POLL support.\n");
+#else
+    printk("(X) AUTO_HW_POLL support.\n");
+#endif
+
+#if ENTER_4BYTES_MODE
+    printk("(V) 4Bytes mode support.\n");
+#else
+    printk("(X) 4Bytes mode support.\n");
+#endif
+
+#if NOR_SUPPORT_MAX_ERASE_SIZE
+    printk("(V) Max erase size support.\n");
+#else
+    printk("(X) Max erase size support.\n");
+#endif
+
+#if SFC_USE_DELAY
+    printk("(V) Sfc_delay support.\n");
+#else
+    printk("(X) Sfc_delay support.\n");
+#endif
+
+#if SFC_MULTI_READ
+    printk("(V) Multi-read support.\n");
+#else
+    printk("(X) Multi-read support.\n");
+#endif
+
+    // map rbus and nor virtual addr
+    rbus_base_virt = ioremap(RBUS_BASE_PHYS, RBUS_SIZE);
+    nor_base_virt = ioremap(NOR_BASE_PHYS, FLASH_SIZE);
+
+    // set spi flash resource
+    physmap_flash_resource[0].start = (unsigned long)nor_base_virt;
+    physmap_flash_resource[0].end = physmap_flash_resource[0].start + FLASH_SIZE - 1;
+
+    // prepare parameters
+    nor_size = FLASH_SIZE;
+    FLASH_POLL_ADDR = FLASH_BASE = (unsigned char*)(nor_base_virt);   
+
+    /* prepare mtd_info */
+    memset(&descriptor, 0, sizeof(struct mtd_info));
+    memset(&rtk_sfc_info, 0, sizeof(rtk_sfc_info_t));
+
+    rtk_sfc_info.mtd_info = &descriptor;
+
+    descriptor.priv = &rtk_sfc_info;
+    descriptor.name = "RtkSFC";
+    descriptor.size = nor_size; 
+    descriptor.flags = MTD_WRITEABLE;
+    descriptor._erase = rtk_sfc_erase;
+    descriptor._read = rtk_sfc_read;
+    descriptor._suspend = rtk_sfc_suspend;
+    descriptor._write = rtk_sfc_write;
+    descriptor._panic_write = rtk_sfc_write;
+    descriptor._resume = rtk_sfc_resume;
+    //descriptor._shutdown = rtk_sfc_shutdown;
+    descriptor.owner = THIS_MODULE;
+    descriptor.type = MTD_DATAFLASH;//MTD_DATAFLASH for general serial flash
+    descriptor.numeraseregions = 0; // uni-erasesize
+    descriptor.oobsize = 0;
+
+    /* Allocate DMA buffers */
+#ifdef CONFIG_MTD_RTK_SFC_READ_MD
+    read_dma_buf = dma_alloc_coherent(NULL, MD_PP_DATA_SIZE, &read_dma_handle, GFP_ATOMIC);
+#endif
+#ifdef CONFIG_MTD_RTK_SFC_WRITE_MD
+    write_dma_buf= dma_alloc_coherent(NULL, MD_PP_DATA_SIZE, &write_dma_handle, GFP_ATOMIC);
+#endif
+
+    rtk_sfc_init_1();
+
+    return 0;
+}
+
+static const char * const part_probes[] = { "cmdlinepart", "RedBoot", NULL };
+static int rtk_sfc_attach(struct mtd_info *mtd_info) 
+{
+    int nr_parts = 0;
+    struct mtd_partitions mtd_parts;
+    int ret = 0;
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    memset(&mtd_parts, 0, sizeof(mtd_parts));
+    /* WRSR: write status register, no memory protection */
+    SFC_SYNC;
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x00000001, SFC_OPCODE);
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+    REG_WRITE_U32(0x00000010, SFC_CTL);
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;
+    *((volatile unsigned char*)FLASH_POLL_ADDR)= 0x00;
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    /*
+     * Partition selection stuff.
+     */
+#ifdef CONFIG_MTD_CMDLINE_PARTS
+    printk("[%s]descriptor size 0x%x\n",__FUNCTION__,(unsigned int)descriptor.size);    
+    if(!parse_mtd_partitions(&descriptor, part_probes, &mtd_parts, NULL))
+        nr_parts = mtd_parts.nr_parts;
+#endif
+
+    if(nr_parts <= 0) {
+        printk(KERN_NOTICE "Rtk SFC: using single partition\n");
+        if(add_mtd_device(&descriptor)) {
+            printk(KERN_WARNING "Rtk SFC: (for SST/SPANSION/MXIC/WINBOND SPI-Flash) Failed to register new device\n");            
+            ret = -EAGAIN;
+            goto out;
+        }
+    }
+    else {
+        printk(KERN_NOTICE "Rtk SFC: using dynamic partition\n");
+        ret = add_mtd_partitions(&descriptor, mtd_parts.parts, nr_parts);
+        if(ret) goto out;
+    }
+
+    /* restore opcode to read */
+    _switch_to_read_mode(&rtk_sfc_info, eREAD_MODE_SINGLE_FAST_READ);
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    /* allocating debug information */
+    if((dbg_counter = (int *) kmalloc(sizeof(int), GFP_KERNEL)))
+        memset(dbg_counter, 0, sizeof(int));
+
+    if((dbg_table = (DESCRIPTOR_TABLE *) kmalloc(sizeof(DESCRIPTOR_TABLE) * DBG_ENTRY_NUM, GFP_KERNEL)))
+        memset(dbg_table, 0, sizeof(DESCRIPTOR_TABLE) * DBG_ENTRY_NUM);
+
+    printk("DEBUG COUNTER = %08X  /  DEBUG TABLE = %08X\n", dbg_counter, dbg_table);
+#endif
+
+    printk("Rtk SFC: (for SST/SPANSION/MXIC SPI Flash)\n");
+out:
+    /* Cleanup any parsed partitions */
+    mtd_part_parser_cleanup(&mtd_parts);
+
+    return ret;
+}
+
+
+static void __exit rtk_sfc_exit(void)
+{
+#ifdef EMMC_ISSUE_LOCK
+    unsigned long lock_flag;
+#endif
+
+#if defined(CONFIG_MTD_RTK_SFC_DEBUG)
+    if(dbg_counter)
+        kfree(dbg_counter);
+    if(dbg_table)
+        kfree(dbg_table);
+#endif
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_lock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    /* put read opcode into control register */
+    SFC_SYNC;
+    SYS_REG_TRY_LOCK(0);//add by alexchang 0722-2010
+    REG_WRITE_U32(0x00000003, SFC_OPCODE);
+
+#if SFC_USE_DELAY
+    sfc_delay();
+#endif
+
+    REG_WRITE_U32(0x00000018, SFC_CTL);
+    SYS_REG_TRY_UNLOCK;//add by alexchang 0722-2010
+    SFC_SYNC;
+
+#ifdef EMMC_ISSUE_LOCK
+    rtk_lockapi_unlock(lock_flag, (char *)__FUNCTION__);
+#endif
+
+    del_mtd_device(&descriptor);
+
+    /* Free DMA buffers */
+#ifdef CONFIG_MTD_RTK_SFC_READ_MD
+    if(read_dma_buf)
+        dma_free_coherent(NULL, MD_PP_DATA_SIZE, (void *)read_dma_buf, read_dma_handle);
+#endif
+#ifdef CONFIG_MTD_RTK_SFC_WRITE_MD
+    if(write_dma_buf)
+        dma_free_coherent(NULL, MD_PP_DATA_SIZE, (void *)write_dma_buf, write_dma_handle);
+#endif
+}
+
+
+module_init(rtk_sfc_init);
+module_exit(rtk_sfc_exit);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Chih-pin Wu <wucp@realtek.com.tw>");
+MODULE_DESCRIPTION("MTD chip driver for Realtek Rtk Serial Flash Controller");
diff --git a/drivers/mtd/chips/rtk_sfc.h b/drivers/mtd/chips/rtk_sfc.h
new file mode 100644
index 00000000..51579e6
--- /dev/null
+++ b/drivers/mtd/chips/rtk_sfc.h
@@ -0,0 +1,174 @@
+#ifndef RTK_SERIAL_FLASH_CONTROLLER
+#define RTK_SERIAL_FLASH_CONTROLLER
+/*
+   for HWSD, the serial flash address started from 0x88100000,
+   so for 16Mbit Serial Flash, the address ranges from 0x8810-0000 - 0x890f-ffff
+ */
+/* 2 MBytes */
+
+#define FLASH_SIZE                  (0x02000000)
+
+#define RBUS_BASE_PHYS              (0x98000000)
+#define RBUS_SIZE                   (0x20000)
+#define NOR_BASE_PHYS               (0x88100000)
+
+#define GET_MAPPED_RBUS_ADDR(reg)   ((unsigned long)rbus_base_virt + (reg - RBUS_BASE_PHYS))
+
+#define REG_READ_U8(register)                   (*(volatile unsigned char *)GET_MAPPED_RBUS_ADDR(register))
+#define REG_READ_U16(register)                  (*(volatile unsigned short *)GET_MAPPED_RBUS_ADDR(register))
+#define REG_READ_U32(register)                  (*(volatile unsigned int *)GET_MAPPED_RBUS_ADDR(register))
+
+#define REG_WRITE_U8(value, register)           (*(volatile unsigned char *)GET_MAPPED_RBUS_ADDR(register) = value)
+#define REG_WRITE_U16(value, register)          (*(volatile unsigned short *)GET_MAPPED_RBUS_ADDR(register) = value)
+#define REG_WRITE_U32(value, register)          (*(volatile unsigned int *)GET_MAPPED_RBUS_ADDR(register) = value)
+
+
+#define MD_PP_DATA_SIZE_SHIFT   8   /* 256 bytes */
+#define MD_PP_DATA_SIZE         (1 << MD_PP_DATA_SIZE_SHIFT)
+
+#define SFC_OPCODE          (0x9801a800)
+#define SFC_CTL             (0x9801a804)
+#define SFC_SCK             (0x9801a808)
+#define SFC_CE              (0x9801a80c)
+#define SFC_WP              (0x9801a810)
+#define SFC_POS_LATCH       (0x9801a814)
+
+#define SFC_WAIT_WR         (0x9801a818)
+#define SFC_EN_WR           (0x9801a81c)
+#define SFC_FAST_RD         (0x9801a820)
+#define SFC_SCK_TAP         (0x9801a824)
+#define SFP_OPCODE2         (0x9801a828)
+
+#if defined(CONFIG_ARCH_RTD16xx)
+#define ISO_MUXPAD1         (0x9804e004)
+#define ISO_MUXPAD6         (0x9804e048)
+#else
+// System Bridge II
+#define SB2_WRAPPER_CTRL    (0x9801a018)
+#define SYS_MUXPAD5         (0x9801a914)
+#endif
+
+// Move Data Engine
+#define MD_FDMA_DDR_SADDR   (0x9800b088)
+#define MD_FDMA_FL_SADDR    (0x9800b08c)
+#define MD_FDMA_CTRL2       (0x9800b090)
+#define MD_FDMA_CTRL1       (0x9800b094)
+
+#define RDID_MANUFACTURER_ID_MASK   0x000000FF
+#define RDID_DEVICE_ID_1_MASK       0x0000FF00
+#define RDID_DEVICE_ID_2_MASK       0x00FF0000
+#define RDID_DEVICE_EID_1_MASK      0x000000FF
+#define RDID_DEVICE_EID_2_MASK      0x0000FF00
+
+#define RDID_MANUFACTURER_ID(id)    (id & RDID_MANUFACTURER_ID_MASK)
+#define RDID_DEVICE_ID_1(id)        ((id & RDID_DEVICE_ID_1_MASK) >> 8)
+#define RDID_DEVICE_ID_2(id)        ((id & RDID_DEVICE_ID_2_MASK) >> 16)
+#define RDID_DEVICE_EID_1(id)       (id & RDID_DEVICE_EID_1_MASK)
+#define RDID_DEVICE_EID_2(id)       ((id & RDID_DEVICE_EID_2_MASK) >> 8)
+
+#define MANUFACTURER_ID_SPANSION    0x01
+#define MANUFACTURER_ID_STM         0x20
+#define MANUFACTURER_ID_PMC         0x7f
+#define MANUFACTURER_ID_SST         0xbf
+#define MANUFACTURER_ID_MXIC        0xc2
+#define MANUFACTURER_ID_EON         0x1c
+#define MANUFACTURER_ID_ATMEL       0x1f
+#define MANUFACTURER_ID_WINBOND     0xef //add by alexchang
+#define MANUFACTURER_ID_ESMT        0x8c //add by alexchang
+#define MANUFACTURER_ID_GD          0xc8 //add by alexchang
+#define MANUFACTURER_ID_FM          0xA1
+
+#define RTK_SFC_ATTR_NONE                       0x00
+#define RTK_SFC_ATTR_SUPPORT_MD_PP              0x01
+#define RTK_SFC_ATTR_SUPPORT_DUAL_IO            0x02
+#define RTK_SFC_ATTR_SUPPORT_DUAL_O             0x04
+#define RTK_SFC_ATTR_SUPPORT_4BYTE_ADDR_MODE    0x80
+
+#define RTK_SFC_SMALL_PAGE_WRITE_MASK   0x3
+
+typedef enum rtk_sfc_read_mode {
+    eREAD_MODE_NORMAL_READ,
+    eREAD_MODE_SINGLE_FAST_READ,    
+    eREAD_MODE_DUAL_FAST_READ
+        //eREAD_MODE_1I1O_FAST_READ,
+        //eREAD_MODE_1I2O_FAST_READ,
+        //eREAD_MODE_2IO_FAST_READ  
+} rtk_sfc_read_mode_t; 
+
+#define SUPPORTED       1
+#define NOT_SUPPORTED   0
+
+typedef struct rtk_sfc_info {
+    //struct semaphore rtk_sfc_lock;
+    u8 manufacturer_id;
+    u8 device_id1;
+    u8 device_id2;
+    u8 attr;
+    u32 erase_size;
+    u32 erase_opcode;
+    u8 sec_256k_en; //256KB size erase support
+    u8 sec_64k_en; //64KB size erase support
+    u8 sec_32k_en; //32KB size erase support
+    u8 sec_4k_en; //4KB size erase support
+    struct mtd_info *mtd_info;
+}rtk_sfc_info_t;
+
+
+#define ENDIAN_SWAP_U16(data)\
+    (data>>8) | (data<<8)
+
+#define ENDIAN_SWAP_U32(data)\
+    (data>>24) |\
+((data<<8) & 0x00FF0000) |\
+((data>>8) & 0x0000FF00) |\
+(data<<24)
+
+#define ENDIAN_SWAP_U64(data)\
+    (data>>56) |\
+((data<<40) & 0x00FF000000000000) |\
+((data<<24) & 0x0000FF0000000000) |\
+((data<<8)  & 0x000000FF00000000) |\
+((data>>8)  & 0x00000000FF000000) |\
+((data>>24) & 0x0000000000FF0000) |\
+((data>>40) & 0x000000000000FF00) |\
+(data<<56)
+
+#define SFC_4KB_ERASE \
+{\
+    printk("SFC_4KB_ERASE\n");\
+    sfc_info->attr      |= RTK_SFC_ATTR_SUPPORT_MD_PP;\
+    sfc_info->erase_size    = 0x1000;\
+    sfc_info->erase_opcode  = 0x00000020;\
+}
+
+#define SFC_64KB_ERASE \
+{\
+    printk("SFC_64KB_ERASE\n");\
+    sfc_info->attr      |= RTK_SFC_ATTR_SUPPORT_MD_PP;\
+    sfc_info->erase_size    = 0x10000;\
+    sfc_info->erase_opcode  = 0x000000d8;\
+}
+
+#define SFC_256KB_ERASE \
+{\
+    printk("SFC_256KB_ERASE\n");\
+    sfc_info->attr      |= RTK_SFC_ATTR_SUPPORT_MD_PP;\
+    sfc_info->erase_size    = 0x40000;\
+    sfc_info->erase_opcode  = 0x000000d8;\
+}
+
+#define SFC_SYNC \
+    do {                    \
+        asm volatile("DMB SY" : : : "memory"); \
+        REG_WRITE_U32(0x00, 0x9801a020);    \
+        asm volatile("DMB SY" : : : "memory"); \
+    }while(0)
+
+
+#define SYS_REG_TRY_LOCK(delay) 
+#define SYS_REG_TRY_UNLOCK  
+#define SFC_FLUSH_CACHE(buff, len)
+
+int rtk_sfc_panic_erase(struct mtd_info *mtd, struct erase_info *instr);
+
+#endif
diff --git a/drivers/mtd/chips/rtk_sfc_pstore.c b/drivers/mtd/chips/rtk_sfc_pstore.c
new file mode 100644
index 00000000..6a743bc
--- /dev/null
+++ b/drivers/mtd/chips/rtk_sfc_pstore.c
@@ -0,0 +1,371 @@
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/pstore.h>
+#include <linux/mtd/mtd.h>
+
+#include "rtk_sfc.h"
+
+#define RTKSFCOOPS_KERNMSG_MAGIC 0x52544b5346435053	/* 'RTKSFCPS' */
+#define RTKSFCOOPS_HEADER_SIZE 8
+
+static char mtddev[80] = "oops";
+
+static struct mtd_info *mtd = NULL;
+
+static unsigned long record_size = 32768;
+module_param(record_size, ulong, 0400);
+MODULE_PARM_DESC(record_size, "size of each dump record (default 32768)");
+
+static unsigned long mtd_size;
+module_param(mtd_size, ulong, 0400);
+MODULE_PARM_DESC(mtd_size, "size of MTD partition");
+
+static unsigned long erasesize;
+module_param(erasesize, ulong, 0400);
+MODULE_PARM_DESC(erasesize, "erasesize of MTD partition");
+
+static unsigned int records;
+module_param(records, uint, 0400);
+MODULE_PARM_DESC(records, "number of dump records");
+
+struct rtksfcoops_context {
+	int nextrcd;
+	unsigned int oops_records;
+	unsigned int oops_read_cnt;
+	void *oops_buf;
+
+	struct pstore_info pstore;
+};
+
+struct oops_log_info {
+	u64 magic;
+	enum pstore_type_id type;
+	size_t log_size;
+	__u64 timestamp;
+	bool compressed;
+};
+
+static int rtk_sfc_pstore_open(struct pstore_info *psi)
+{
+	struct rtksfcoops_context *cxt = psi->data;
+
+	cxt->oops_read_cnt = 0;
+
+	return 0;
+}
+
+static int rtk_sfc_pstore_close(struct pstore_info *psi)
+{
+	return 0;
+}
+
+static int rtk_sfc_read_hdr(uint * c, uint max, u64 * id,
+			    enum pstore_type_id *type, struct timespec *time,
+			    bool * compressed, size_t * log_size)
+{
+	struct oops_log_info oops_hdr;
+	unsigned int offset;
+	size_t retlen;
+	int i = (*c)++;
+
+	if (i >= max)
+		return -1;
+
+	offset = i * record_size;
+	mtd_read(mtd, offset, sizeof(oops_hdr), &retlen, (void *)&oops_hdr);
+	if (retlen != sizeof(oops_hdr))
+		return -1;
+
+	if (oops_hdr.magic != RTKSFCOOPS_KERNMSG_MAGIC)
+		return -1;
+
+	*type = oops_hdr.type;
+	*id = i;
+	*log_size = oops_hdr.log_size;
+	time->tv_sec = oops_hdr.timestamp;
+	time->tv_nsec = 0;
+	*compressed = oops_hdr.compressed;
+
+	return i;
+}
+
+static ssize_t rtk_sfc_pstore_read(u64 * id, enum pstore_type_id *type,
+				   int *count, struct timespec *time,
+				   char **buf, bool * compressed,  ssize_t *ecc_notice_size,
+				   struct pstore_info *psi)
+{
+	ssize_t size;
+	struct rtksfcoops_context *cxt = psi->data;
+	unsigned int offset;
+	size_t hlen = sizeof(struct oops_log_info);
+	size_t log_size;
+	size_t retlen;
+	int rcd = -1;
+
+	time->tv_sec = 0;
+	time->tv_nsec = 0;
+	*compressed = false;
+
+	/* Get oops header */
+	while ((cxt->oops_read_cnt < cxt->oops_records) && (rcd == -1)) {
+		rcd =
+		    rtk_sfc_read_hdr(&cxt->oops_read_cnt, cxt->oops_records, id,
+				     type, time, compressed, &log_size);
+
+		if (rcd == -1)
+			continue;
+	}
+
+	if (rcd == -1)
+		return 0;
+
+	/* Read oops data */
+	*buf = kmalloc(log_size, GFP_KERNEL);
+	if (*buf == NULL)
+		return -ENOMEM;
+
+	offset = rcd * record_size;
+	mtd_read(mtd, offset + hlen, log_size, &retlen, *buf);
+	size = retlen;
+
+	return size;
+}
+
+/*
+ * This structure is copied from drivers/mtd/mtdpart.c.
+ */
+struct mtd_part {
+	struct mtd_info mtd;
+	struct mtd_info *master;
+	uint64_t offset;
+	struct list_head list;
+};
+
+/*
+ * This function is copied from drivers/mtd/mtdpart.c.
+ */
+static inline struct mtd_part *mtd_to_part(const struct mtd_info *mtd)
+{
+	return container_of(mtd, struct mtd_part, mtd);
+}
+
+/*
+ * This function is modified from drivers/mtd/mtdpart.c.
+ */
+static int part_erase(struct mtd_info *mtd, struct erase_info *instr)
+{
+	struct mtd_part *part = mtd_to_part(mtd);
+	int ret;
+
+	/* Pass master MTD object and the offset from the start of flash device */
+	instr->addr += part->offset;
+	ret = rtk_sfc_panic_erase(part->master, instr);
+	if (ret) {
+		if (instr->fail_addr != MTD_FAIL_ADDR_UNKNOWN)
+			instr->fail_addr -= part->offset;
+		instr->addr -= part->offset;
+	}
+	return ret;
+}
+
+static int rtk_sfc_oops_erase(struct rtksfcoops_context *cxt, int offset,
+			      int size)
+{
+	struct erase_info erase;
+	int ret = 0;
+
+	erase.mtd = mtd;
+	erase.addr = offset;
+	erase.len = size;
+
+	/* earse blocks at address within a partition */
+	ret = part_erase(mtd, &erase);
+
+	return 0;
+}
+
+static int rtk_sfc_pstore_write(enum pstore_type_id type,
+				enum kmsg_dump_reason reason, u64 * id,
+				unsigned int part, int count, bool compressed,
+				size_t size, struct pstore_info *psi)
+{
+	struct rtksfcoops_context *cxt = psi->data;
+	struct oops_log_info *oops_hdr = (struct oops_log_info *)cxt->oops_buf;
+	size_t retlen;
+
+	if (cxt->nextrcd >= cxt->oops_records) {
+		pr_err("rtk_sfc_pstore: no storage space left\n");
+		return -ENOSPC;
+	}
+
+	pr_info
+	    ("rtk_sfc_pstore: write log to record %d in MTD partition \"%s\"\n",
+	     cxt->nextrcd, mtddev);
+
+	/* Erase record */
+	rtk_sfc_oops_erase(cxt, cxt->nextrcd * record_size, record_size);
+
+	/* Set oops header */
+	oops_hdr->magic = RTKSFCOOPS_KERNMSG_MAGIC;
+	oops_hdr->type = type;
+	oops_hdr->log_size = size;
+	oops_hdr->timestamp = get_seconds();
+	oops_hdr->compressed = compressed;
+
+	/* Write oops header and data */
+	mtd_panic_write(mtd, cxt->nextrcd * record_size,
+			sizeof(*oops_hdr) + size, &retlen, cxt->oops_buf);
+
+	cxt->nextrcd++;
+
+	return 0;
+}
+
+static void rtk_sfc_erase_callback(struct erase_info *done)
+{
+	wait_queue_head_t *wait_q = (wait_queue_head_t *) done->priv;
+	wake_up(wait_q);
+}
+
+static int rtk_sfc_erase_record(struct rtksfcoops_context *cxt, int offset,
+				int size)
+{
+	struct erase_info erase;
+	DECLARE_WAITQUEUE(wait, current);
+	wait_queue_head_t wait_q;
+	int ret;
+
+	init_waitqueue_head(&wait_q);
+	erase.mtd = mtd;
+	erase.callback = rtk_sfc_erase_callback;
+	erase.addr = offset;
+	erase.len = size;
+	erase.priv = (u_long) & wait_q;
+
+	set_current_state(TASK_INTERRUPTIBLE);
+	add_wait_queue(&wait_q, &wait);
+
+	ret = mtd_erase(mtd, &erase);
+	if (ret) {
+		set_current_state(TASK_RUNNING);
+		remove_wait_queue(&wait_q, &wait);
+		printk(KERN_WARNING
+		       "rtk_sfc_pstore: erase of region [0x%llx, 0x%llx] on \"%s\" failed\n",
+		       (unsigned long long)erase.addr,
+		       (unsigned long long)(erase.addr + erase.len), mtddev);
+		return ret;
+	}
+
+	schedule();		/* Wait for erase to finish. */
+	remove_wait_queue(&wait_q, &wait);
+
+	return 0;
+}
+
+static int rtk_sfc_pstore_erase(enum pstore_type_id type, u64 id, int count,
+				struct timespec time, struct pstore_info *psi)
+{
+	struct rtksfcoops_context *cxt = psi->data;
+
+	rtk_sfc_erase_record(cxt, id * record_size, record_size);
+
+	return 0;
+}
+
+static struct rtksfcoops_context oops_cxt = {
+	.pstore = {
+		   .owner = THIS_MODULE,
+		   .name = "rtksfc",
+		   .open = rtk_sfc_pstore_open,
+		   .close = rtk_sfc_pstore_close,
+		   .read = rtk_sfc_pstore_read,
+		   .write = rtk_sfc_pstore_write,
+		   .erase = rtk_sfc_pstore_erase,
+		   },
+};
+
+static int __init rtk_sfc_pstore_init(void)
+{
+	struct rtksfcoops_context *cxt = &oops_cxt;
+	int rc = 0;
+
+	/* Obtain a handle for an MTD device by device name */
+	mtd = get_mtd_device_nm(mtddev);
+	if (IS_ERR(mtd)) {
+		pr_err("rtk_sfc_pstore: no MTD partition \"%s\" found\n",
+		       mtddev);
+		return -ENODEV;
+	}
+
+	pr_info
+	    ("rtk_sfc_pstore: attach to MTD partition \"%s\" with size %llu and erasesize %u\n",
+	     mtddev, mtd->size, mtd->erasesize);
+	mtd_size = mtd->size;
+	erasesize = mtd->erasesize;
+
+	if ((record_size & (erasesize - 1)) != 0) {
+		pr_err
+		    ("rtk_sfc_pstore: record_size must be a multiple of erasesize %u\n",
+		     mtd->erasesize);
+		rc = -EINVAL;
+		goto fail_device;
+	}
+
+	cxt->nextrcd = 0;
+	cxt->oops_records = mtd->size / record_size;
+	records = cxt->oops_records;
+	pr_info("rtk_sfc_pstore: %d records of record_size %lu\n",
+		cxt->oops_records, record_size);
+
+	cxt->pstore.data = cxt;
+	cxt->oops_buf = kmalloc(record_size, GFP_KERNEL);
+	if (!cxt->oops_buf) {
+		pr_err("cannot allocate pstore buffer\n");
+		rc = -ENOMEM;
+		goto fail_device;
+	}
+
+	memset(cxt->oops_buf, 0xff, record_size);
+	cxt->pstore.buf = cxt->oops_buf + sizeof(struct oops_log_info);
+	cxt->pstore.bufsize = record_size - sizeof(struct oops_log_info);
+
+	spin_lock_init(&cxt->pstore.buf_lock);
+
+	rc = pstore_register(&cxt->pstore);
+	if (rc) {
+		if (rc != -EPERM)
+			pr_err("rtk_sfc_pstore: cannot register with pstore\n");
+		goto fail_buf;
+	}
+
+	return 0;
+
+ fail_buf:
+	kfree(cxt->oops_buf);
+	cxt->oops_buf = NULL;
+	cxt->pstore.buf = NULL;
+	cxt->pstore.bufsize = 0;
+ fail_device:
+	put_mtd_device(mtd);
+
+	return rc;
+}
+
+static void __exit rtk_sfc_pstore_exit(void)
+{
+	struct rtksfcoops_context *cxt = &oops_cxt;
+
+	pstore_unregister(&cxt->pstore);
+
+	kfree(cxt->oops_buf);
+	if (mtd)
+		put_mtd_device(mtd);
+}
+
+module_init(rtk_sfc_pstore_init);
+module_exit(rtk_sfc_pstore_exit);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Chien-Ming Cheng <cmcheng@realtek.com.tw>");
+MODULE_DESCRIPTION("Realtek SPI flash backend for pstore");
diff --git a/drivers/mtd/devices/block2mtd.c b/drivers/mtd/devices/block2mtd.c
index 7c887f1..62fd690 100644
--- a/drivers/mtd/devices/block2mtd.c
+++ b/drivers/mtd/devices/block2mtd.c
@@ -431,7 +431,7 @@ static int block2mtd_setup2(const char *val)
 }
 
 
-static int block2mtd_setup(const char *val, struct kernel_param *kp)
+static int block2mtd_setup(const char *val, const struct kernel_param *kp)
 {
 #ifdef MODULE
 	return block2mtd_setup2(val);
diff --git a/drivers/mtd/devices/phram.c b/drivers/mtd/devices/phram.c
index 8b66e52..7287696 100644
--- a/drivers/mtd/devices/phram.c
+++ b/drivers/mtd/devices/phram.c
@@ -266,7 +266,7 @@ static int phram_setup(const char *val)
 	return ret;
 }
 
-static int phram_param_call(const char *val, struct kernel_param *kp)
+static int phram_param_call(const char *val, const struct kernel_param *kp)
 {
 #ifdef MODULE
 	return phram_setup(val);
diff --git a/drivers/mtd/nand/Kconfig b/drivers/mtd/nand/Kconfig
index b254090..50ee1ba 100644
--- a/drivers/mtd/nand/Kconfig
+++ b/drivers/mtd/nand/Kconfig
@@ -1,3 +1,10 @@
+config MTD_NAND_IDS
+	tristate "Include chip ids for known NAND devices."
+	depends on MTD
+	help
+	  Useful for NAND drivers that do not use the NAND subsystem but
+	  still like to take advantage of the known chip information.
+
 config MTD_NAND_ECC
 	tristate
 
@@ -109,9 +116,6 @@ config MTD_NAND_OMAP_BCH
 config MTD_NAND_OMAP_BCH_BUILD
 	def_tristate MTD_NAND_OMAP2 && MTD_NAND_OMAP_BCH
 
-config MTD_NAND_IDS
-	tristate
-
 config MTD_NAND_RICOH
 	tristate "Ricoh xD card reader"
 	default n
diff --git a/drivers/mtd/nand/Makefile b/drivers/mtd/nand/Makefile
index cafde6f..389d75b 100644
--- a/drivers/mtd/nand/Makefile
+++ b/drivers/mtd/nand/Makefile
@@ -59,4 +59,5 @@ obj-$(CONFIG_MTD_NAND_BRCMNAND)		+= brcmnand/
 obj-$(CONFIG_MTD_NAND_QCOM)		+= qcom_nandc.o
 obj-$(CONFIG_MTD_NAND_MTK)		+= mtk_nand.o mtk_ecc.o
 
-nand-objs := nand_base.o nand_bbt.o nand_timings.o
+nand-objs := rtk_nand.o nand_base_rtk.o
+#nand-objs := nand_base.o nand_bbt.o nand_timings.o
diff --git a/drivers/mtd/nand/nand_base_rtk.c b/drivers/mtd/nand/nand_base_rtk.c
new file mode 100644
index 00000000..40c4666
--- /dev/null
+++ b/drivers/mtd/nand/nand_base_rtk.c
@@ -0,0 +1,1781 @@
+/*
+ * nand_base_rtk.c - nand driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/delay.h>
+#include <linux/errno.h>
+#include <linux/sched.h>
+#include <linux/types.h>
+#include <linux/mtd/mtd.h>
+#include <linux/interrupt.h>
+#include <linux/slab.h>
+#include <asm/io.h> 
+#include <linux/bitops.h>
+#include <linux/parser.h>
+#include <linux/semaphore.h>
+#include <mtd/mtd-abi.h>
+#include <linux/mtd/rtk_nand_reg.h>
+#include <linux/mtd/rtk_nand.h>
+#include <linux/mtd/rtk_nand_list.h>
+#include <asm/page.h>
+#include <linux/jiffies.h>
+#include <linux/dma-mapping.h>
+
+static DECLARE_RWSEM(rw_sem_resume);
+static DECLARE_RWSEM(rw_sem_suspend);
+static DECLARE_RWSEM(rw_sem_rd);
+static DECLARE_RWSEM(rw_sem_wte);
+static DECLARE_RWSEM(rw_sem_wte_ecc);
+static DECLARE_RWSEM(rw_sem_erase);
+static DECLARE_RWSEM(rw_sem_bbt);
+static DECLARE_RWSEM(rw_sem_markbad);
+static DECLARE_RWSEM(rw_sem_panic_write);
+static DECLARE_RWSEM(rw_sem_rd_oob);
+static DECLARE_RWSEM(rw_sem_wte_oob);
+static DEFINE_SEMAPHORE (sem_rd);
+static DEFINE_SEMAPHORE (sem_wte);
+static DEFINE_SEMAPHORE (sem_bbt);
+
+#define MAX_NR_LENGTH 1024*1024*2
+#define MAX_NW_LENGTH 1024*1024*2
+static unsigned char *nwBuffer = NULL;
+static unsigned char *nrBuffer = NULL;
+dma_addr_t nrPhys_addr;
+dma_addr_t oobPhys_addr;
+dma_addr_t nwPhys_addr;
+static unsigned char *tempBuffer = NULL;
+dma_addr_t tempPhys_addr;
+static int bEnterSuspend=0;
+
+#define NOTALIGNED(mtd, x) (x & (mtd->writesize-1)) != 0
+unsigned int g_eccbits = 0;
+static struct mtd_info *g_rtk_mtd = NULL;
+
+extern void __iomem *map_base;
+
+#define check_end(mtd, addr, len)					\
+do {									\
+	if (mtd->size == 0) 						\
+	{								\
+		up_write(&rw_sem_erase);				\
+		return -ENODEV;						\
+	}								\
+	else								\
+	if ((addr + len) > mtd->size) {					\
+		printk (						\
+			"%s: attempt access past end of device\n",	\
+			__FUNCTION__);					\
+		up_write(&rw_sem_erase);				\
+		return -EINVAL;						\
+	}								\
+} while(0)
+
+#define check_block_align(mtd, addr)					\
+do {									\
+	if (addr & (mtd->erasesize - 1)) {				\
+		printk (						\
+			"%s: attempt access non-block-aligned data\n",	\
+			__FUNCTION__);					\
+		up_write(&rw_sem_erase);				\
+		return -EINVAL;						\
+	}								\
+} while (0)
+
+unsigned int g_mtd_BootcodeSize = 0;
+
+
+/* RTK Nand Chip ID list */
+static int rtd_get_set_nand_info(void);
+extern char g_rtk_nandinfo_line[64];
+static device_type_t g_nand_device;
+
+/* NAND low-level MTD interface functions */
+static int nand_read (struct mtd_info *mtd, loff_t from, size_t len, size_t *retlen, u_char *buf);
+static int nand_read_ecc (struct mtd_info *mtd, loff_t from, size_t len, size_t *retlen, unsigned char *buf, u_char *oob_buf, struct nand_oobinfo *oobsel, unsigned char *buf_phy);
+static int nand_write (struct mtd_info *mtd, loff_t to, size_t len, size_t *retlen, const u_char *buf);
+static int nand_write_ecc (struct mtd_info *mtd, loff_t to, size_t len, size_t *retlen, const unsigned char * buf, const u_char *oob_buf, struct nand_oobinfo *oobsel, const unsigned char *buf_phy);
+static int nand_erase (struct mtd_info *mtd, struct erase_info *instr);
+static void nand_sync (struct mtd_info *mtd);
+static int nand_suspend (struct mtd_info *mtd);
+static void nand_resume (struct mtd_info *mtd);
+static int nand_read_oob (struct mtd_info *mtd, loff_t from, struct mtd_oob_ops *ops);
+static int nand_write_oob (struct mtd_info *mtd, loff_t to, struct mtd_oob_ops *ops);
+static int nand_block_isbad (struct mtd_info *mtd, loff_t ofs);
+//static int nand_block_markbad (struct mtd_info *mtd, loff_t ofs);
+
+int rtk_update_bbt (struct mtd_info *mtd, __u8 *data_buf, __u8 *oob_buf, BB_t *bbt);
+
+
+/* Global Variables */
+int RBA=0;
+static int oob_size, ppb, isLastPage;
+static int page_size = 0;
+
+#ifdef RTK_VERIFY
+extern unsigned int r_test_flag;
+extern unsigned int w_test_flag;
+extern unsigned int nomap_blk;
+static void rtk_nand_read_page_check(struct mtd_info *mtd, unsigned int page)
+{
+	struct nand_chip *this = (struct nand_chip *) mtd->priv;
+	int i = 0;
+	int rc;
+
+        for(i = 0; i < ppb; i++) {
+                rc = this->read_ecc_page (mtd, 0, page+i, tempBuffer, NULL, CP_NF_NONE, (dma_addr_t *) (&tempPhys_addr));
+                if ( rc == 1 ) {
+                        printk(KERN_ERR "page:[%d][%u] is blank\n", i, page+i);
+                }
+                else if (rc == 0) {
+                        printk(KERN_ERR "read page:[%d][%u] ok\n", i, page+i);
+                }
+                else {
+                        printk(KERN_ERR "read page:[%d][%u] fail\n", i, page+i);
+                }
+        }
+	printk(KERN_ERR "\n");
+}
+#endif
+
+static unsigned long long rtk_from_to_page(struct mtd_info *mtd, loff_t from)
+{
+        struct nand_chip *this = (struct nand_chip *) mtd->priv;
+
+        return (int)(from >> this->page_shift);
+}
+
+#ifdef RTK_NAND_SHIFTABLE
+static int rtk_in_shift_table(struct mtd_info *mtd, unsigned int blk)
+{
+	struct nand_chip *this = (struct nand_chip *) mtd->priv;
+	unsigned int i;
+
+	for ( i=0; i<100; i++) {
+                if ( this->sbt[i].chipnum != SB_INIT ) {
+                        if(blk == this->sbt[i].block) {
+                                return 1;
+                        }
+                }
+        }
+
+	return 0;
+}
+
+static unsigned int rtk_check_shift_table(struct mtd_info *mtd, unsigned int blk)
+{
+        struct nand_chip *this = (struct nand_chip *) mtd->priv;
+        unsigned int i;
+        unsigned int real_blk = blk;
+
+shift_table_recheck:
+        for ( i=0; i<100; i++) {
+                if ( this->sbt[i].chipnum != SB_INIT ) {
+			if(real_blk == this->sbt[i].block) {
+				real_blk = blk + this->sbt[i].shift;
+				break;
+			}
+
+                        if(real_blk < this->sbt[i].block) {
+                                real_blk = blk + (this->sbt[i-1].shift);
+                                break;
+                        }
+                }
+        }
+
+	if(rtk_in_shift_table(mtd, real_blk)) {
+		goto shift_table_recheck;
+	}
+
+        return real_blk;
+}
+#endif
+
+static unsigned int rtk_find_real_blk(struct mtd_info *mtd, unsigned int blk)
+{
+	struct nand_chip *this = (struct nand_chip *) mtd->priv;
+	unsigned int i = 0, match = 1, real_blk = blk;
+#ifdef RTK_VERIFY
+	if(real_blk == nomap_blk) {
+		return real_blk;
+	}
+#endif
+#ifdef RTK_NAND_SHIFTABLE
+	real_blk = rtk_check_shift_table(mtd, real_blk);
+#endif
+
+	for ( i=0; i<RBA; i++){
+		if ( this->bbt[i].bad_block != BB_INIT ){
+			if ( blk == this->bbt[i].bad_block ){
+				real_blk = this->bbt[i].remap_block;
+				//NF_INFO_PRINT("need to do remap ...... [%d] to [%d][%d]\n", blk, real_blk, match);
+				match++;
+				blk = this->bbt[i].remap_block;
+			}
+		}
+	}
+
+	return real_blk;
+}
+
+#ifdef RTK_VERIFY
+static void dump_data(const char *data, unsigned int len)
+{
+	int i;
+
+	for (i = 0; i < (len/16); i++)
+		printk(KERN_ERR "%.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x\n",
+			*(data+(16*i)),*(data+1+(16*i)),*(data+2+(16*i)),*(data+3+(16*i)),*(data+4+(16*i)),*(data+5+(16*i)),*(data+6+(16*i)),*(data+7+(16*i)),
+			*(data+8+(16*i)),*(data+9+(16*i)),*(data+10+(16*i)),*(data+11+(16*i)),*(data+12+(16*i)),*(data+13+(16*i)),*(data+14+(16*i)),*(data+15+(16*i))
+	);
+}
+#endif
+
+#ifdef RTK_NAND_SHIFTABLE
+static void dump_SBT(struct mtd_info *mtd)
+{
+        struct nand_chip *this = (struct nand_chip *) mtd->priv;
+        int i;
+
+        printk("[%s] Nand SBT Content\n", __FUNCTION__);
+
+        for ( i=0; i<100; i++){
+                        if ( i==0 && this->sbt[i].chipnum == SB_INIT ) {
+			NF_INFO_PRINT("Congratulation!! No shift block in this nand.\n");
+                        break;
+                }
+
+                if ( this->sbt[i].block != SB_INIT ){
+                        NF_INFO_PRINT("[%d] (%u, %u, %u)\n", i, this->sbt[i].chipnum, this->sbt[i].block, this->sbt[i].shift);
+                }
+        }
+}
+#endif
+
+static void dump_BBT(struct mtd_info *mtd)
+{
+	
+	struct nand_chip *this = (struct nand_chip *) mtd->priv;
+	int i;
+	int BBs=0;
+
+	NF_INFO_PRINT("[%s] Nand BBT Content\n", __FUNCTION__);
+
+	for ( i=0; i<RBA; i++){
+		if ( i==0 && this->bbt[i].BB_die == BB_DIE_INIT && this->bbt[i].bad_block == BB_INIT ){
+			NF_INFO_PRINT("Congratulation!! No BBs in this Nand.\n");
+			break;
+		}
+		if ( this->bbt[i].bad_block != BB_INIT ){
+			NF_INFO_PRINT("[%d] (%d, %u, %d, %u)\n", i, this->bbt[i].BB_die, this->bbt[i].bad_block, 
+				this->bbt[i].RB_die, this->bbt[i].remap_block);
+			BBs++;
+		}
+	}
+	this->BBs = BBs;
+}
+
+static unsigned int rtk_page_to_block(__u32 page)
+{
+        return page/ppb;
+}
+
+int rtk_update_bbt_to_flash(struct mtd_info *mtd)
+{
+	int rc = 0;
+	struct nand_chip *this = mtd->priv;
+	unsigned char active_chip = this->active_chip;
+	u_char *temp_BBT = NULL;
+	BB_t *bbt = this->bbt;
+	u_char *new_buf = NULL;
+
+	new_buf = tempBuffer;
+	if(new_buf == NULL){
+		NF_ERR_PRINT("bbtBuffer error......\n");
+		return -ENOMEM;
+	}
+
+	this->select_chip(mtd, 0);
+	this->g_oobbuf[0] = (BBT_TAG >> 8);	
+		
+	if (sizeof(BB_t)*RBA <= page_size) {
+		memcpy( new_buf, bbt, sizeof(BB_t)*RBA );
+	}else{
+		temp_BBT = kmalloc( 2 * page_size, GFP_KERNEL );
+		if ( !(temp_BBT) ){
+			NF_ERR_PRINT("%s: Error, no enough memory for temp_BBT\n",__FUNCTION__);
+			return -ENOMEM;
+		}
+		memset(temp_BBT, 0xff, 2*page_size);
+		memcpy(temp_BBT, bbt, sizeof(BB_t)*RBA );
+		memcpy(new_buf, temp_BBT, page_size);
+	}
+		
+	if (this->erase_block(mtd, 0, 64) ){
+		NF_ERR_PRINT("[%s]error: erase block 1 failure\n", __FUNCTION__);
+	}
+
+	if ( this->write_ecc_page(mtd, 0, 64, new_buf, this->g_oobbuf, (dma_addr_t *)tempPhys_addr) ){
+		NF_ERR_PRINT("[%s]update BBT B1 page 64 failure\n", __FUNCTION__);
+	}else{
+		if ( sizeof(BB_t)*RBA > page_size ) {
+			memset(new_buf, 0xff, page_size);
+			memcpy(new_buf, temp_BBT+page_size, sizeof(BB_t)*RBA - page_size );
+			if ( this->write_ecc_page(mtd, 0, 65, new_buf, this->g_oobbuf, (dma_addr_t *)tempPhys_addr) ) {
+				NF_ERR_PRINT("[%s]update BBT B1 page 1 failure\n", __FUNCTION__);
+			}
+			memcpy(new_buf, temp_BBT, page_size);
+		}	
+	}
+	
+	if ( this->erase_block(mtd, 0, 128) ){
+		NF_ERR_PRINT("[%s]error: erase block 1 failure\n", __FUNCTION__);
+		return -1;
+	}
+
+	if ( this->write_ecc_page(mtd, 0, 128, new_buf, this->g_oobbuf, (dma_addr_t *)tempPhys_addr) ){
+		NF_ERR_PRINT("[%s]update BBT B2 failure\n", __FUNCTION__);
+		return -1;
+	}else{
+		if ( sizeof(BB_t)*RBA > page_size){
+			memset(new_buf, 0xff, page_size);
+			memcpy(new_buf, temp_BBT+page_size, sizeof(BB_t)*RBA - page_size );
+			if ( this->write_ecc_page(mtd, 0, 129, new_buf, this->g_oobbuf, (dma_addr_t *)tempPhys_addr) ){
+				NF_ERR_PRINT("[%s]error: erase block 2 failure\n", __FUNCTION__);
+				return -1;
+			}
+		}		
+	}
+	
+	this->select_chip(mtd, active_chip);
+
+	if (temp_BBT)
+		kfree(temp_BBT);
+
+	return rc;
+}
+
+static int rtk_update_BBT(struct mtd_info *mtd, __u32 blk)
+{
+	struct nand_chip *this = mtd->priv;
+        unsigned int i, flag = 1;
+
+        down_write(&rw_sem_bbt);
+        for ( i=0; i<RBA; i++){
+                if (this->bbt[i].bad_block == BB_INIT && this->bbt[i].remap_block != RB_INIT)
+                {
+                        flag = 0;
+                        this->bbt[i].BB_die = 0;
+                        this->bbt[i].bad_block = blk;
+                        this->bbt[i].RB_die = 0;
+                        break;
+                }
+        }
+        up_write(&rw_sem_bbt);
+
+        if(flag == 1) {
+                NF_ERR_PRINT("[%s] RBA do not have free remap block\n", __FUNCTION__);
+                return -1;
+        }
+
+        dump_BBT(mtd);
+
+        if (rtk_update_bbt_to_flash(mtd)){
+                NF_ERR_PRINT("[%s] rtk_update_bbt_to_flash() fails.\n", __FUNCTION__);
+                return -1;
+        }
+        NF_INFO_PRINT("[%s] rtk_update_bbt() successfully.\n", __FUNCTION__);
+
+        return 0;
+}
+
+static int cmp_mem(unsigned char* data, unsigned char* data_enc,int len)
+{
+        unsigned int i;
+        int check_data = 0;
+
+        for (i=0; i<len; i++){
+                if(data[i] != data_enc[i]){
+                        check_data = 1;
+                        break;
+                }
+        }
+
+        NF_DEBUG_PRINT("check...%d\n", check_data);
+
+        return check_data;
+}
+
+static int rtk_backup_block(struct mtd_info *mtd, __u32 blk)
+{
+	struct nand_chip *this = mtd->priv;
+        __u32 backup_block = rtk_find_real_blk(mtd, blk);
+        unsigned int start_page = blk * ppb;
+        unsigned int backup_start_page = backup_block * ppb;
+        unsigned int i;
+        char *cmp_data = NULL;
+	int retry_count = 0;
+	int rc;
+
+        cmp_data = kmalloc(page_size, GFP_KERNEL);
+
+        NF_INFO_PRINT("Start to Backup block from %u to %u\n", blk, backup_block);
+
+backup_retry:
+	if (this->erase_block(mtd, 0, backup_start_page)) {
+		NF_ERR_PRINT("[%s]error: erase block %u failure\n", __FUNCTION__, backup_start_page);
+        }
+#ifdef RTK_VERIFY
+        rtk_nand_read_page_check(mtd, start_page);
+#endif
+        for(i = 0; i < ppb; i++) {
+		memset(tempBuffer, 0x0, page_size);
+
+		rc = this->read_ecc_page (mtd, this->active_chip, start_page+i, tempBuffer, this->g_oobbuf, CP_NF_NONE, (dma_addr_t *)tempPhys_addr);
+		if(rc == 1) {
+			continue;
+		}
+		rc = this->write_ecc_page(mtd, this->active_chip, backup_start_page+i, tempBuffer, this->g_oobbuf, (dma_addr_t *)tempPhys_addr);
+
+                memcpy(cmp_data, tempBuffer, page_size);
+                memset(tempBuffer, 0x0, page_size);
+		
+		rc = this->read_ecc_page (mtd, this->active_chip, backup_start_page+i, tempBuffer, this->g_oobbuf, CP_NF_NONE, (dma_addr_t *)tempPhys_addr);
+
+                if(cmp_mem(tempBuffer, cmp_data, page_size)) {
+                        NF_ERR_PRINT("check fail, goto backup_retry.\n");
+			if ( retry_count < 3 ) {
+				retry_count++;
+				goto backup_retry;
+			}
+                } else {
+                        NF_INFO_PRINT("check OK.\n");
+                }
+        }
+#if 1
+	for( i=0; i<6; i++) {
+		this->g_oobbuf[i] = 0x00;
+	}
+
+	rc = this->write_ecc_page (mtd, this->active_chip, start_page, tempBuffer, this->g_oobbuf, (dma_addr_t *)tempPhys_addr);
+#endif
+	if(cmp_data)
+		kfree(cmp_data);
+#ifdef RTK_VERIFY
+	rtk_nand_read_page_check(mtd, backup_start_page);
+#endif
+        return 1;
+}
+
+static int rtk_badblock_handle(struct mtd_info *mtd, __u32 page, uint32_t backup)
+{
+        __u32 block = rtk_page_to_block(page);
+
+        if(rtk_update_BBT(mtd, block) == -1) {
+                NF_ERR_PRINT("[%s] rtk_update_BBT fail.\n", __FUNCTION__);
+                return -1;
+        }
+
+	if(backup) {
+		/* Backup all block */
+		if(rtk_backup_block(mtd, block) == -1) {
+			NF_ERR_PRINT("[%s] rtk_backup_all_block fail.\n", __FUNCTION__);
+			return -1;
+		}
+	}
+
+        return 1;
+}
+
+#ifdef RTK_VERIFY
+static void rtk_nand_read_block_check(struct mtd_info *mtd, unsigned int page)
+{
+	__u32 block = rtk_page_to_block(page);
+	__u32 real_block = rtk_find_real_blk(mtd, block);
+        unsigned int start_page = real_block * ppb;
+
+	rtk_nand_read_page_check(mtd, start_page);
+
+	return;
+}
+#endif
+
+static int rtk_block_isbad(struct mtd_info *mtd, u16 chipnr, loff_t ofs)
+{
+	struct nand_chip *this = (struct nand_chip *)mtd->priv;
+	unsigned int page, block, page_offset;
+	unsigned char block_status_p1;
+	unsigned char block_status_p1_org;
+
+	this->active_chip=chipnr=0;		
+	page = ofs >> this->page_shift;
+	block_status_p1_org= this->g_oobbuf[0];
+	page_offset = page & (ppb-1);
+	block = page/ppb;
+
+	if ( isLastPage ) {
+		page = block*ppb + (ppb-1);	
+	}	
+
+	if ( this->read_ecc_page(mtd, this->active_chip, ppb, this->g_databuf, this->g_oobbuf, CP_NF_NONE, (dma_addr_t *)&oobPhys_addr) ) {
+		NF_ERR_PRINT("%s: read_oob page=%d failed\n", __FUNCTION__, page);
+		return 1;
+	}
+	block_status_p1 = this->g_oobbuf[0];
+
+	if ( block_status_p1 != 0xff){
+		NF_ERR_PRINT("WARNING: Die %d: block=%d is bad, block_status_p1=0x%x\n", chipnr, block, block_status_p1);
+		return -1;
+	}
+	
+	return 0;
+}
+
+static int nand_read(struct mtd_info *mtd, loff_t from, size_t len, size_t *retlen, u_char *buf)
+{
+	int rc=0;
+	size_t new_len = 0;
+	u_char *new_buf = NULL;
+	loff_t new_from = from;
+	loff_t is_over_page;
+	struct nand_chip *this = mtd->priv;
+
+	down_write(&rw_sem_rd);
+
+	if(len <= 0){
+		*retlen = 0;
+		NF_ERR_PRINT("%s:%d read non-positive len=%zu\n", __func__, __LINE__, len);
+		up_write(&rw_sem_rd);
+		return 0;
+	}
+    	
+	if(nrBuffer == NULL){
+		nrBuffer = (unsigned char *)dma_alloc_coherent(&mtd->dev, MAX_NR_LENGTH, (dma_addr_t *) (&nrPhys_addr), GFP_KERNEL);
+		NF_DEBUG_PRINT("%s:%d allocate from dma_alloc_coherent, nrBuffer=0x%.8x, nrPhys_addr=0x%.8x\n", __func__, __LINE__, nrBuffer, nrPhys_addr);
+	}
+	
+	if (NOTALIGNED(mtd, from)) {
+		new_from = from & this->page_idx_mask;
+	}
+
+	is_over_page = (from+len-1) & this->page_idx_mask;
+	if ((is_over_page-new_from) > ((len-1)&this->page_idx_mask))
+		is_over_page = 1;
+	else
+		is_over_page = 0;
+
+    	new_len = (((len-1)>>this->page_shift)+1+is_over_page)<<this->page_shift;
+	new_buf = nrBuffer;
+
+	if (new_buf) {
+		rc = nand_read_ecc(mtd, new_from, new_len, retlen, new_buf, NULL, NULL, (unsigned char *)nrPhys_addr);
+
+		if (rc == 0) {
+			*retlen = len;
+			memcpy(buf, new_buf+(from-new_from), len);
+		}
+		else {
+			*retlen = 0;
+		}
+
+		if (new_len > MAX_NR_LENGTH) {
+			kfree(new_buf);
+		}
+	}
+    	
+	up_write(&rw_sem_rd);
+
+	return rc;
+}                          
+
+static int nand_read_oob (struct mtd_info *mtd, loff_t from, struct mtd_oob_ops *ops)
+{
+	struct nand_chip *this = (struct nand_chip *)mtd->priv;
+        int rc = 0;
+        unsigned int page = 0, real_page = 0;
+        unsigned int page_offset = 0;
+        unsigned int block = 0;
+        unsigned int real_block = 0;
+        loff_t new_from = from;
+
+	from += ops->ooboffs;
+
+	if(ops->datbuf != NULL && ops->len != 0) {
+		ops->retlen = 0;
+		nand_read(mtd, from, ops->len, &ops->retlen, ops->datbuf);
+	}
+
+	down_write(&rw_sem_rd);
+
+	if(ops->oobbuf != NULL && ops->ooblen != 0) {
+		ops->oobretlen = 0;
+
+		if (NOTALIGNED(mtd, from)) {
+			new_from = from & this->page_idx_mask;
+		}
+
+		page = rtk_from_to_page(mtd, new_from);
+		page_offset =  page % ppb;
+		block = page/ppb;
+
+		real_block = rtk_find_real_blk(mtd, block);
+
+		real_page = (real_block * ppb) + page_offset;
+
+		rc = this->read_ecc_page(mtd, this->active_chip, real_page, this->g_databuf, this->g_oobbuf, CP_NF_NONE, (dma_addr_t *)&nrPhys_addr);
+
+		memcpy(ops->oobbuf, this->g_oobbuf, mtd->oobsize);
+
+		ops->oobretlen = mtd->oobsize;
+	}
+
+	up_write(&rw_sem_rd);
+
+	return rc;
+}
+
+static int nand_read_ecc (struct mtd_info *mtd, loff_t from, size_t len,
+			size_t *retlen, unsigned char *buf, unsigned char *oob_buf, struct nand_oobinfo *oobsel, unsigned char *buf_phy)
+{
+	struct nand_chip *this = mtd->priv;
+	__u32 page, realpage;
+	__u64 page_ppb;
+	int data_len, oob_len;
+	int rc;
+	__u32 old_page, page_offset, block, real_block;
+	int chipnr, chipnr_remap;
+
+	if ((from + len) > mtd->size) {
+		NF_ERR_PRINT("nand_read_ecc: Attempt read beyond end of device\n");
+		*retlen = 0;
+		return -EINVAL;
+	}
+
+	if (NOTALIGNED (mtd, from) || NOTALIGNED(mtd, len)) {
+		NF_ERR_PRINT("nand_read_ecc: Attempt to read not page aligned data\n");
+        	*retlen = 0;
+		return -EINVAL;
+	}
+
+	realpage = (int)(from >> this->page_shift);
+	this->active_chip = chipnr = chipnr_remap = (int)(from >> this->chip_shift);
+	old_page = page = realpage & this->pagemask;
+	page_offset = page & (ppb-1);
+	page_ppb = page;
+	do_div(page_ppb,ppb);
+	block = (unsigned int)page_ppb;
+
+	this->active_chip = chipnr = chipnr_remap = 0;		
+	
+	this->select_chip(mtd, chipnr);
+	
+	if ( retlen )
+		*retlen = 0;
+	
+	data_len = oob_len = 0;
+
+	while (data_len < len) {
+read_after_backup:
+        	real_block = rtk_find_real_blk(mtd, block);
+		page = real_block*ppb + page_offset;  
+        
+		rc = this->read_ecc_page(mtd, this->active_chip, page, &buf[data_len], NULL, CP_NF_NONE, (dma_addr_t *)&buf_phy[data_len]);
+#ifdef RTK_VERIFY
+                if( r_test_flag == 1 ) {
+                        NF_ERR_PRINT("test_flag is 1, block %u is going to be bad block.\n", real_block);
+                        r_test_flag = 0;
+                        rc = -2;
+                }
+#endif
+		if (rc < 0) {
+            		if (rc == -1){
+				rc = -1;
+                		NF_ERR_PRINT("rtk_read_ecc_page: Un-correctable HW ECC Error at page=%u block:[%u] real_block:[%u]\n", page, block, real_block);
+            		}
+			else if (rc == -2){
+				NF_ERR_PRINT("read_ecc_page: rc:%d read ppb:%u, page:%u failed\n", rc, ppb, page);
+				NF_ERR_PRINT("Prepare to to backup\n");
+				if(rtk_badblock_handle(mtd, page, 1)) {
+					NF_ERR_PRINT("Finish backup bad block. read after backup.......\n");
+					msleep(100);
+					goto read_after_backup;
+				} else {
+					NF_ERR_PRINT("backup bad block fail.\n");
+					return -1;
+				}
+			} else if ( rc == -WAIT_TIMEOUT ) {
+				NF_ERR_PRINT("WAIT_LOOP timeout, read after nand reset\n");
+				msleep(100);
+				goto read_after_backup;
+			}else{
+				NF_ERR_PRINT("%s: read_ecc_page:  semphore failed\n", __FUNCTION__);
+				return -1;
+			}
+		}
+
+		data_len += page_size;
+
+		if(oob_buf)
+			oob_len += oob_size;
+		
+		old_page++;
+		page_offset = old_page & (ppb-1);
+		block = old_page/ppb;
+	}
+
+	if ( retlen ){
+		if ( data_len == len )
+			*retlen = data_len;
+		else{
+			NF_ERR_PRINT("[%s] error: data_len %d != len %zu\n", __FUNCTION__, data_len, len);
+			return -1;
+		}	
+	}
+
+	return 0;
+}
+
+static int nand_write (struct mtd_info *mtd, loff_t to, size_t len, size_t *retlen, const u_char *buf)
+{
+	int rc = 0;
+	u_char *new_buf = NULL;
+
+	down_write(&rw_sem_wte);
+
+	if (bEnterSuspend){
+		NF_ERR_PRINT("[%s] - prevent cmd execute while in suspend stage\n",__func__);
+		up_write(&rw_sem_wte);
+		return 0;
+	}
+
+	if (nwBuffer == NULL){
+		nwBuffer = (unsigned char *)dma_alloc_coherent(&mtd->dev, MAX_NW_LENGTH, (dma_addr_t *) (&nwPhys_addr), GFP_DMA | GFP_KERNEL);
+	}
+
+	new_buf = nwBuffer;
+	
+	if (new_buf) {
+		memcpy(new_buf, buf, len);
+
+		rc = nand_write_ecc (mtd, to, len, retlen, new_buf, NULL, NULL, (unsigned char *)nwPhys_addr);
+		if (len > MAX_NW_LENGTH)
+		{
+			kfree(new_buf);
+		}
+	}
+
+	up_write(&rw_sem_wte);
+
+	return rc;
+}
+
+static int nand_write_ext (struct mtd_info *mtd, loff_t to, struct mtd_oob_ops *ops)
+{
+	struct nand_chip *this = mtd->priv;
+	int rc = 0;
+	u_char *new_buf = NULL;
+
+	if (bEnterSuspend){
+		NF_ERR_PRINT("[%s] - prevent cmd execute while in suspend stage\n",__func__);
+		return 0;
+	}
+
+	if (nwBuffer == NULL){
+		nwBuffer = (unsigned char *)dma_alloc_coherent(&mtd->dev, MAX_NW_LENGTH, (dma_addr_t *) (&nwPhys_addr), GFP_DMA | GFP_KERNEL);
+	}
+
+	new_buf = nwBuffer;
+	
+	if (new_buf) {
+		if(ops->datbuf != NULL && ops->len != 0) {
+			memcpy(new_buf, ops->datbuf, ops->len);
+		}
+
+		if(ops->oobbuf != NULL && ops->ooblen != 0) {
+			memcpy(this->g_oobbuf, ops->oobbuf, ops->ooblen);
+		}
+
+		if(ops->datbuf != NULL && ops->oobbuf != NULL) {
+			rc = nand_write_ecc (mtd, to, ops->len, &ops->retlen, new_buf, this->g_oobbuf, NULL, (unsigned char *)nwPhys_addr);
+		} else if(ops->datbuf != NULL && ops->oobbuf == NULL) {
+			rc = nand_write_ecc (mtd, to, ops->len, &ops->retlen, new_buf, NULL, NULL, (unsigned char *)nwPhys_addr);
+		} else if(ops->datbuf == NULL && ops->oobbuf != NULL) {
+			rc = nand_write_ecc (mtd, to, ops->len, &ops->retlen, NULL, this->g_oobbuf, NULL, (unsigned char *)nwPhys_addr);
+		}
+
+		if(rc == 0) {
+			ops->oobretlen = ops->ooblen;
+		} else {
+			NF_ERR_PRINT("nand_write_ext() FAIL\n");
+			ops->oobretlen = 0;
+		}
+	}
+
+	return rc;
+}
+
+static int nand_write_oob (struct mtd_info *mtd, loff_t to, struct mtd_oob_ops *ops)//for 2.6.34 YAFFS-->mtd
+{
+	struct nand_chip *this = mtd->priv;
+	int rc = 0;
+        u_char *new_buf = NULL;
+
+	down_write(&rw_sem_wte_oob);
+
+	rc = nand_write_ext(mtd, to, ops);
+
+	up_write(&rw_sem_wte_oob);
+
+	return rc;
+}                          
+
+static int nand_write_ecc (struct mtd_info *mtd, loff_t to, size_t len, size_t *retlen, 
+			const u_char * buf, const u_char *oob_buf, struct nand_oobinfo *oobsel, const u_char * buf_phy)
+{
+	struct nand_chip *this = mtd->priv;
+	__u32 page, realpage;
+	__u64 page_ppb;
+	int data_len, oob_len;
+	int rc = 0;
+	unsigned int old_page, page_offset, block, real_block;
+	int chipnr, chipnr_remap;
+
+	if (bEnterSuspend){
+		NF_ERR_PRINT("[%s] - prevent cmd execute while in suspend stage\n",__func__);
+		return 0;
+	}
+
+	if ((to + len) > mtd->size) {
+		NF_ERR_PRINT("nand_write_ecc: Attempt write beyond end of device\n");
+		*retlen = 0;
+		return -EINVAL;
+	}
+
+	if (NOTALIGNED (mtd, to) || NOTALIGNED(mtd, len)) {
+		NF_ERR_PRINT("nand_write_ecc: Attempt to write not page aligned data mtd size: %x\n", mtd->writesize-1);
+		*retlen = 0;
+		return -EINVAL;
+	}
+
+	realpage = (unsigned int)(to >> this->page_shift);
+	this->active_chip = chipnr = chipnr_remap = (int)(to >> this->chip_shift);
+	old_page = page = realpage & this->pagemask;
+	page_offset = page & (ppb-1);
+	page_ppb = page;
+	do_div(page_ppb,ppb);
+	block = (unsigned int)page_ppb;
+
+	NF_DEBUG_PRINT("[NAND_DBG][%s] READY write to block 0x%u, page 0x%u",__FUNCTION__, block, page);
+
+	this->active_chip = chipnr = chipnr_remap = 0;
+
+	this->select_chip(mtd, chipnr);
+	
+	if ( retlen )
+		*retlen = 0;
+	
+	data_len = oob_len = 0;
+
+	while ( data_len < len) {
+write_after_backup:
+		down_write (&rw_sem_bbt);
+		real_block = rtk_find_real_blk(mtd, block);
+		up_write (&rw_sem_bbt);
+        
+		page = real_block*ppb + page_offset;
+
+		NF_DEBUG_PRINT("Confirm to write blk:[%u] real_block:[%d], page:[%u]\n",(__u32)page/ppb, real_block, (__u32)page%ppb);
+#ifdef RTK_VERIFY
+		if( w_test_flag == 1 ) {
+			NF_ERR_PRINT("test_flag is 1, block %u is going to be bad block.\n", real_block);
+                        rc = -1;
+		} else {
+#endif
+		if (buf && oob_buf) {
+			rc = this->write_ecc_page (mtd, this->active_chip, page, &buf[data_len], &oob_buf[oob_len], (dma_addr_t *)&buf_phy[data_len]);
+		} else if (buf && !oob_buf) {
+			rc = this->write_ecc_page (mtd, this->active_chip, page, &buf[data_len], NULL, (dma_addr_t *)&buf_phy[data_len]);
+		} else if (!buf && oob_buf) {
+			rc = this->write_oob (mtd, this->active_chip, page, oob_size, &oob_buf[oob_len]);
+		} else {
+			rc = this->write_ecc_page (mtd, this->active_chip, page, &buf[data_len], NULL, (dma_addr_t *)&buf_phy[data_len]);
+		}
+#ifdef RTK_VERIFY
+		}
+
+		if (w_test_flag == 2) {
+                        w_test_flag = 0;
+                        NF_ERR_PRINT("Dump page [%u][%u] after backup. page_offset:[%d]\n", page, real_block, page_offset);
+                        rtk_nand_read_block_check(mtd, page);
+                        dump_data(&buf[data_len], page_size);
+		}
+#endif
+		if (rc < 0) {
+			if (rc == -WAIT_TIMEOUT) {
+				NF_ERR_PRINT("WAIT_LOOP timeout, write after nand reset.\n");
+                                msleep(100);
+                                goto write_after_backup;	
+			}
+			else {
+				NF_ERR_PRINT("%s: write_ecc_page:  write blk:%u, page_offset:[%u]\n", __FUNCTION__, (__u32)page/ppb, page_offset);
+				if(rtk_badblock_handle(mtd, page, 1)) {
+					NF_ERR_PRINT("Finish backup bad block, re-write ...\n");
+#ifdef RTK_VERIFY
+					w_test_flag = 2;
+#endif
+					msleep(100);
+					goto write_after_backup;
+				} else {
+					NF_ERR_PRINT("backup bad block fail.\n");
+					return -1;
+				}
+			}	
+		}
+
+		data_len += page_size;
+		oob_len += oob_size;		
+		old_page++;
+		page_offset = old_page & (ppb-1);
+		block = old_page/ppb;
+	}
+
+	if ( retlen ){
+		
+		if ( data_len == len )
+			*retlen = data_len;
+		else{
+			NF_ERR_PRINT("[%s] error: data_len %d != len %zu\n", __FUNCTION__, data_len, len);
+			return -1;
+		}	
+	}
+
+	return 0;
+}
+
+static int nand_erase (struct mtd_info *mtd, struct erase_info *instr)
+{
+	return nand_erase_nand (mtd, instr, 0);
+}
+
+int nand_erase_nand (struct mtd_info *mtd, struct erase_info *instr, int allowbbt)
+{
+	struct nand_chip *this = (struct nand_chip *)mtd->priv;
+	u_int32_t addr = instr->addr;
+	u_int32_t len = instr->len;
+	int page, chipnr;
+	int old_page, block, real_block;
+	u_int32_t elen = 0;
+	int rc = 0;
+	int realpage, chipnr_remap;
+	down_write(&rw_sem_erase);
+
+	if (bEnterSuspend)
+	{
+		NF_ERR_PRINT("[%s] - prevent cmd execute while in suspend stage\n",__func__);
+		up_write(&rw_sem_erase);
+		return 0;
+	}
+
+	check_end (mtd, addr, len);
+	check_block_align (mtd, addr);
+
+	instr->fail_addr = 0xffffffff;
+
+	realpage =  addr >> this->page_shift;
+	this->active_chip = chipnr = chipnr_remap = addr >> this->chip_shift;
+	old_page = page = realpage & this->pagemask;
+	block = page/ppb;
+
+	this->active_chip=chipnr=chipnr_remap=0;		
+	this->select_chip(mtd, chipnr);
+	
+	instr->state = MTD_ERASING;
+	while (elen < len) {
+erase_after_reset:
+		down_write (&rw_sem_bbt);
+		real_block = rtk_find_real_blk(mtd, block);
+		up_write (&rw_sem_bbt);
+		
+		page = real_block*ppb;
+		NF_DEBUG_PRINT("confirm to Erase blk[%u][%d] this->active_chip:[%d]\n", page/ppb, real_block, this->active_chip);
+		rc = this->erase_block (mtd, this->active_chip, page);
+			
+		if (rc) {
+			if (rc == -WAIT_TIMEOUT) {
+                                NF_ERR_PRINT("WAIT_LOOP timeout, erase after nand reset.\n");
+                                msleep(100);
+                                goto erase_after_reset;
+                        }
+			else {
+				NF_ERR_PRINT("%s: block erase failed at page address=%u\n", __FUNCTION__, addr);
+				instr->fail_addr = (page << this->page_shift);
+				rtk_badblock_handle(mtd, page, 0);
+			}
+		}
+		
+		if ( chipnr != chipnr_remap )
+			this->select_chip(mtd, chipnr);
+			
+		elen += mtd->erasesize;
+
+		old_page += ppb;
+		
+		if ( elen<len && !(old_page & this->pagemask)) {
+			old_page &= this->pagemask;
+			chipnr++;
+			this->active_chip = chipnr;
+			this->select_chip(mtd, chipnr);
+		}
+
+		block = old_page/ppb;
+	}
+	instr->state = MTD_ERASE_DONE;
+
+	if (!rc)
+                mtd_erase_callback(instr);
+
+	up_write(&rw_sem_erase);
+
+	return rc;
+}
+
+
+static void nand_sync (struct mtd_info *mtd)
+{
+	struct nand_chip *this = (struct nand_chip *)mtd->priv;
+	this->state = FL_READY;
+}
+
+
+static int nand_suspend (struct mtd_info *mtd)
+{
+	down_write(&rw_sem_suspend);
+	bEnterSuspend = 1;
+	up_write(&rw_sem_suspend);
+	return 0;
+}
+
+
+static void nand_resume (struct mtd_info *mtd)
+{
+	down_write(&rw_sem_resume);
+	bEnterSuspend = 0;
+	up_write(&rw_sem_resume);
+}
+
+static void nand_select_chip(struct mtd_info *mtd, int chip)
+{
+	switch(chip) {
+		case -1:
+			REG_WRITE_U32(REG_PD+map_base,0xff);
+			break;			
+		case 0:
+		case 1:
+		case 2:
+		case 3:
+			REG_WRITE_U32(REG_PD+map_base, ~(1 << chip));
+			break;
+		default:
+			REG_WRITE_U32(REG_PD+map_base, ~(1 << 0));
+	}
+}
+
+
+static int scan_last_die_BB(struct mtd_info *mtd)
+{
+	struct nand_chip *this = (struct nand_chip *)mtd->priv;
+	__u32 start_page = 0, start_block = 0;
+	uint32_t addr;
+	int block_num = this->block_num;
+	int block_size = 1 << this->phys_erase_shift;
+	int i, j;
+	int numchips = this->numchips;
+	uint32_t chip_size = this->chipsize;
+	int rc = 0;
+	int bb = 0;
+	__u8 *block_status = NULL;
+	
+	NF_ERR_PRINT("scan_last_die_BB()\n");
+
+	start_page = 0x00000000;
+	
+	this->active_chip = numchips-1;
+	this->select_chip(mtd, numchips-1);
+	
+	block_status = kmalloc( block_num, GFP_KERNEL );	
+	if ( !block_status ){
+		NF_ERR_PRINT("%s: Error, no enough memory for block_status\n",__FUNCTION__);
+		rc = -ENOMEM;
+		goto EXIT;
+	}
+	memset ( (__u32 *)block_status, 0, block_num );
+
+	start_block = (start_page >> this->page_shift) >> (this->phys_erase_shift - this->page_shift);	
+	for( addr=start_page; addr<chip_size; addr+=block_size ){
+		if ( rtk_block_isbad(mtd, numchips-1, addr) ){
+			bb = addr >> this->phys_erase_shift;
+			block_status[bb] = 0xff;
+		}
+	}
+
+        for ( i = 0 ; i < RBA; i++) {
+                this->bbt[i].bad_block = BB_INIT;
+                this->bbt[i].BB_die = BB_DIE_INIT;
+                this->bbt[i].remap_block = (block_num-1) - i;
+                this->bbt[i].RB_die = BB_DIE_INIT;
+        }
+
+        j = 0;
+        for ( i = start_block; i < block_num; i++ ) {
+                if(block_status[i] == 0xff) {
+                        this->bbt[j].BB_die      = numchips-1;
+                        this->bbt[j].bad_block   = i;
+                        this->bbt[j].RB_die      = numchips-1;
+                        j++;
+                }
+        }
+
+	RTK_FLUSH_CACHE((unsigned long) this->bbt, sizeof(BB_t)*RBA);
+	
+EXIT:
+	if (block_status)
+		kfree(block_status);	
+				
+	return 0;
+}
+
+static int rtk_create_bbt(struct mtd_info *mtd, int page)
+{
+	int rc = 0;
+	
+	if(page == 64)
+		NF_INFO_PRINT("[%s] nand driver creates B1 !!\n", __FUNCTION__);
+	else if(page == 128)
+		NF_INFO_PRINT("[%s] nand driver creates B2 !!\n", __FUNCTION__);
+	else {
+		NF_ERR_PRINT("[%s] abort creating BB on page %x !!\n", __FUNCTION__, page);
+		return -1;
+	}
+
+	if ( scan_last_die_BB(mtd) ){
+		NF_ERR_PRINT("[%s] scan_last_die_BB() error !!\n", __FUNCTION__);
+		return -1; 
+	}
+
+	dump_BBT(mtd);
+
+	if (rtk_update_bbt_to_flash(mtd)){
+                NF_ERR_PRINT("[%s] rtk_update_bbt_to_flash() fails.\n", __FUNCTION__);
+                return -1;
+        }
+        NF_INFO_PRINT("[%s] rtk_update_bbt() successfully.\n", __FUNCTION__);
+	
+	return rc;		
+}
+
+#ifdef RTK_VERIFY
+void write_oob_test(void)
+{
+	struct nand_chip *this = (struct nand_chip *)g_rtk_mtd->priv;
+	int i;
+	
+	for (i=0; i<64; i++) {
+		this->g_oobbuf[i] = (0x1 + i);
+	}
+	this->g_oobbuf[5] = 0xFF;
+
+	memset(nwBuffer, 0xFF, page_size);
+	sprintf(nwBuffer, "%s", "AABBCCDDEEFF");
+
+	if (this->erase_block(g_rtk_mtd, 0, 64*3) ){
+                NF_ERR_PRINT("[%s]error: erase block 1 failure\n", __FUNCTION__);
+        }
+
+        if ( this->write_ecc_page(g_rtk_mtd, 0, 64*3, nwBuffer, this->g_oobbuf, (dma_addr_t *)nwPhys_addr) ) {
+                NF_ERR_PRINT("[%s] write_oob_test error. \n", __FUNCTION__);
+	}
+}
+#endif
+
+#ifdef RTK_NAND_SHIFTABLE
+static int rtk_nand_get_shift_table(struct mtd_info *mtd, unsigned char *buf_phy)
+{
+	struct nand_chip *this = (struct nand_chip *)mtd->priv;
+	int rc = 0;
+	__u8 issbt_b1, issbt_b2;
+	u8 *temp_SBT=0;
+	u8 mem_page_num;
+	u_char *new_buf = NULL;
+
+	RTK_FLUSH_CACHE((unsigned long) this->sbt, sizeof(SB_t)*100);
+	mem_page_num = (sizeof(SB_t)*100 + page_size-1 )/page_size;
+
+	temp_SBT = kmalloc( mem_page_num*page_size, GFP_KERNEL );
+	if ( !temp_SBT ){
+		NF_ERR_PRINT("%s: Error, no enough memory for temp_SBT\n",__FUNCTION__);
+		return -ENOMEM;
+	}
+	memset( temp_SBT, 0xff, mem_page_num*page_size);
+
+	new_buf = nrBuffer;
+
+	rc = this->read_ecc_page(mtd, this->active_chip, ppb*4, new_buf, this->g_oobbuf, CP_NF_NONE, (dma_addr_t *)&buf_phy[0]);
+	issbt_b1 = this->g_oobbuf[0];
+	NF_DEBUG_PRINT("[%s] issbt_b1:[%x] SBT_TAG:[%x] SBT_TAG >> 8 [%x]\n", __FUNCTION__, issbt_b1, SBT_TAG, SBT_TAG >> 8);
+	if ( !rc ) {
+		if ( issbt_b1 == (SBT_TAG >> 8) ){
+			NF_INFO_PRINT("[%s] Get sbt B1, loads it !!\n", __FUNCTION__);
+			memcpy( temp_SBT, new_buf, page_size );
+			memcpy( this->sbt, temp_SBT, sizeof(SB_t)*100 );
+		}
+		else{
+			NF_INFO_PRINT("[%s] read SBT B1 tags fails, try to load SBT B2\n", __FUNCTION__);
+			rc = this->read_ecc_page(mtd, this->active_chip, ppb*5, new_buf, this->g_oobbuf, CP_NF_NONE, (dma_addr_t *)&buf_phy[0]);
+			issbt_b2 = this->g_oobbuf[0];	
+			NF_INFO_PRINT("[%s] issbt_b2:[%x]!!\n", __FUNCTION__, issbt_b2);
+			if ( !rc ){
+				if ( issbt_b2 == (SBT_TAG >> 8) ){
+					NF_INFO_PRINT("[%s] Get sbt B2, loads it !!\n", __FUNCTION__);
+					memcpy( temp_SBT, new_buf, page_size );
+					memcpy( this->sbt, temp_SBT, sizeof(SB_t)*100 );
+				}else{
+					NF_INFO_PRINT("[%s] read SBT2 fail\n", __FUNCTION__);
+				}
+			}else{
+				NF_INFO_PRINT("[%s] read SBT2 fail.\n", __FUNCTION__);
+			}
+		}
+	}else{
+		NF_INFO_PRINT("[%s] read SBT B1 with HW ECC error, try to load SBT B2\n", __FUNCTION__);
+		rc = this->read_ecc_page(mtd, this->active_chip, ppb*5, new_buf, this->g_oobbuf, CP_NF_NONE, (dma_addr_t *)&buf_phy[0]);
+		issbt_b2 = this->g_oobbuf[0];	
+		if ( !rc ){
+			if ( issbt_b2 == (SBT_TAG >> 8) ){
+				NF_INFO_PRINT("[%s] Get sbt B2, loads it !!\n", __FUNCTION__);
+				memcpy( temp_SBT, new_buf, page_size );
+				memcpy( this->bbt, temp_SBT, sizeof(SB_t)*100 );
+			}else{
+				NF_INFO_PRINT("[%s] read BBT B2 tags fails, nand driver will creat BBT B2\n", __FUNCTION__);
+			}
+		}else{
+			NF_INFO_PRINT("[%s] read SBT B1 and B2 with HW ECC fails\n", __FUNCTION__);
+		}
+	}
+
+	if(!rc) {
+		dump_SBT(mtd);
+	}
+
+	if (temp_SBT)
+		kfree(temp_SBT);
+	
+	return rc;
+}
+#endif
+
+static int rtk_nand_scan_bbt(struct mtd_info *mtd, unsigned char *buf_phy)
+{
+	struct nand_chip *this = (struct nand_chip *)mtd->priv;
+	int rc = 0;
+	__u8 isbbt_b1, isbbt_b2;
+	u8 *temp_BBT=0;
+	u8 mem_page_num;
+	u_char *new_buf = NULL;
+
+	RTK_FLUSH_CACHE((unsigned long) this->bbt, sizeof(BB_t)*RBA);
+	mem_page_num = (sizeof(BB_t)*RBA + page_size-1 )/page_size;
+    
+	NF_DEBUG_PRINT("[%s]:[%s] ppb:[%d] mem_page_num:[%d]\n", __FILE__, __func__, ppb, mem_page_num);
+
+	temp_BBT = kmalloc( mem_page_num*page_size, GFP_KERNEL );
+	if ( !temp_BBT ){
+		NF_ERR_PRINT("%s: Error, no enough memory for temp_BBT\n",__FUNCTION__);
+		return -ENOMEM;
+	}
+	memset( temp_BBT, 0xff, mem_page_num*page_size);
+
+	new_buf = nrBuffer;
+
+	rc = this->read_ecc_page(mtd, this->active_chip, 64, new_buf, this->g_oobbuf, CP_NF_NONE, (dma_addr_t *)&buf_phy[0]);
+	isbbt_b1 = this->g_oobbuf[0];
+	NF_DEBUG_PRINT("[%s] isbbt_b1:[%x] BBT_TAG:[%x] BBT_TAG >> 8 [%x]\n", __FUNCTION__, isbbt_b1, BBT_TAG, BBT_TAG >> 8);
+	if ( !rc ){
+		if ( isbbt_b1 == (BBT_TAG >> 8) ){
+			NF_INFO_PRINT("[%s] have created bbt B1, just loads it !!\n", __FUNCTION__);
+			memcpy( temp_BBT, new_buf, page_size );
+			memcpy( this->bbt, temp_BBT, sizeof(BB_t)*RBA );
+		}
+		else{
+			NF_INFO_PRINT("[%s] read BBT B1 tags fails, try to load BBT B2\n", __FUNCTION__);
+			rc = this->read_ecc_page(mtd, this->active_chip, 128, new_buf, this->g_oobbuf, CP_NF_NONE, (dma_addr_t *)&buf_phy[0]);
+			isbbt_b2 = this->g_oobbuf[0];	
+			NF_INFO_PRINT("[%s] isbbt_b2:[%x]!!\n", __FUNCTION__, isbbt_b2);
+			if ( !rc ){
+				if ( isbbt_b2 == (BBT_TAG >> 8) ){
+					NF_INFO_PRINT("[%s] have created bbt B2, just loads it !!\n", __FUNCTION__);
+					memcpy( temp_BBT, new_buf, page_size );
+					memcpy( this->bbt, temp_BBT, sizeof(BB_t)*RBA );
+				}else{
+					NF_INFO_PRINT("[%s] read BBT B2 tags fails, nand driver will creat BBT B1 and B2\n", __FUNCTION__);
+					rtk_create_bbt(mtd, 64);
+					rtk_create_bbt(mtd, 128);
+				}
+			}else{
+				NF_INFO_PRINT("[%s] read BBT B2 with HW ECC fails, nand driver will creat BBT B1\n", __FUNCTION__);
+				rtk_create_bbt(mtd, 64);
+			}
+		}
+	}else{
+		NF_INFO_PRINT("[%s] read BBT B1 with HW ECC error, try to load BBT B2\n", __FUNCTION__);
+		rc = this->read_ecc_page(mtd, this->active_chip, 128, new_buf, this->g_oobbuf, CP_NF_NONE, (dma_addr_t *)&buf_phy[0]);
+		isbbt_b2 = this->g_oobbuf[0];	
+		if ( !rc ){
+			if ( isbbt_b2 == (BBT_TAG >> 8) ){
+				NF_INFO_PRINT("[%s] have created bbt B1, just loads it !!\n", __FUNCTION__);
+				memcpy( temp_BBT, new_buf, page_size );
+				memcpy( this->bbt, temp_BBT, sizeof(BB_t)*RBA );
+			}else{
+				NF_INFO_PRINT("[%s] read BBT B2 tags fails, nand driver will creat BBT B2\n", __FUNCTION__);
+				rtk_create_bbt(mtd, 128);
+			}
+		}else{
+			NF_INFO_PRINT("[%s] read BBT B1 and B2 with HW ECC fails\n", __FUNCTION__);
+			kfree(temp_BBT);
+			return -1;
+		}
+	}
+
+	dump_BBT(mtd);
+
+	if (temp_BBT)
+		kfree(temp_BBT);
+	
+	return rc;
+}
+
+static int nand_block_isbad (struct mtd_info *mtd, loff_t ofs)
+{
+        return 0;
+}
+
+static int nand_block_markbad (struct mtd_info *mtd, loff_t to)
+{
+        struct nand_chip *this = mtd->priv;
+        unsigned int page = rtk_from_to_page(mtd, to);
+
+	printk(KERN_ERR "nand_block_markbad(), This function should not be called. page:[%d] block:[%d]\n", page ,page/ppb);
+
+        return 0;
+}
+
+static void rtd_set_nand_info(char *item)
+{
+	int ret = 0;
+	char *s = NULL;
+	unsigned int temp = 0;
+
+	if( (s = strstr(item, "ds:")) != NULL ){
+		ret = kstrtoull(s+3, 10, &g_nand_device.size);
+		g_nand_device.chipsize = g_nand_device.size;
+	}
+	else if( (s = strstr(item, "ps:")) != NULL ){
+		ret = kstrtouint(s+3, 10, &g_nand_device.PageSize);
+	}
+	else if( (s = strstr(item, "bs:")) != NULL ){
+		ret = kstrtouint(s+3, 10, &g_nand_device.BlockSize);
+	}
+	else if( (s = strstr(item, "t1:")) != NULL ){
+		ret = kstrtouint(s+3, 10, &temp);
+		g_nand_device.T1 = (unsigned char)temp;
+	}
+	else if( (s = strstr(item, "t2:")) != NULL ){
+		ret = kstrtouint(s+3, 10, &temp);
+		g_nand_device.T2 = (unsigned char)temp;
+	}
+	else if( (s = strstr(item, "t3:")) != NULL ){
+		ret = kstrtouint(s+3, 10, &temp);
+		g_nand_device.T3 = (unsigned char)temp;
+	}
+	else if( (s = strstr(item, "eb:")) != NULL ){
+		ret = kstrtouint(s+3, 10, &temp);
+		g_nand_device.eccSelect = (unsigned short)temp;
+	}
+}
+
+static int rtd_get_set_nand_info()
+{
+	const char * const delim = ",";
+	char *sepstr = g_rtk_nandinfo_line;
+	char *substr = NULL;
+
+	if(strlen(g_rtk_nandinfo_line) == 0) {
+		NF_INIT_PRINT("No nand info got from lk!!!!\n");
+		return -1;
+	}
+
+	memset(&g_nand_device, 0x0, sizeof(device_type_t));
+
+	NF_INIT_PRINT("g_rtk_nandinfo_line:[%s]\n", sepstr);
+
+	substr = strsep(&sepstr, delim);
+
+	do{
+		rtd_set_nand_info(substr);
+
+		substr = strsep(&sepstr, delim);
+	}while(substr);
+
+	g_nand_device.num_chips = 1;
+	g_nand_device.isLastPage = 0;
+
+	if(g_nand_device.eccSelect == 0x1)
+		g_nand_device.OobSize = 128;
+	else
+		g_nand_device.OobSize = 64;
+
+	NF_INFO_PRINT("total flash size:[%llu]\n", g_nand_device.size);
+	NF_INFO_PRINT("chip size:[%llu]\n", g_nand_device.chipsize);
+	NF_INFO_PRINT("page size:[%d]\n", g_nand_device.PageSize);
+	NF_INFO_PRINT("block size:[%d]\n", g_nand_device.BlockSize);
+	NF_INFO_PRINT("oob size:[%d]\n", g_nand_device.OobSize);
+	NF_INFO_PRINT("t1:[%d]\n", g_nand_device.T1);
+	NF_INFO_PRINT("t2:[%d]\n", g_nand_device.T2);
+	NF_INFO_PRINT("t3:[%d]\n", g_nand_device.T3);
+	NF_INFO_PRINT("ecc select:[%d]\n", g_nand_device.eccSelect);
+
+	return 1;
+}
+
+int rtk_nand_scan(struct mtd_info *mtd, int maxchips)
+{
+	struct nand_chip *this = (struct nand_chip *)mtd->priv;
+	unsigned char id[6];
+	unsigned int device_size=0;
+	unsigned int i;
+	unsigned int nand_type_id ;
+	int rtk_lookup_table_flag=0;
+	unsigned char maker_code;	
+	unsigned char device_code; 
+	unsigned char B5th;
+	unsigned char B6th;
+	unsigned int block_size;
+	unsigned int num_chips = 1;
+	uint32_t chip_size=0;
+	unsigned int num_chips_probe = 1;
+	uint64_t result = 0;
+	uint64_t div_res = 0;
+	unsigned int flag_size, mempage_order;
+
+	g_rtk_mtd = mtd;
+	
+	if ( !this->select_chip )
+		this->select_chip = nand_select_chip;
+	if ( !this->scan_bbt )
+		this->scan_bbt = rtk_nand_scan_bbt;
+
+	this->active_chip = 0;
+	this->select_chip(mtd, 0);
+
+	NF_INFO_PRINT("nand_base_rtk version:0815-2018\n");
+
+	mtd->name = "rtk_nand";
+
+	if(rtd_get_set_nand_info() > 0)
+	{
+		NF_INFO_PRINT("Get nand info from bootcode successfully.\n");
+		
+		REG_WRITE_U32( REG_TIME_PARA1+map_base, g_nand_device.T1);
+		REG_WRITE_U32( REG_TIME_PARA2+map_base, g_nand_device.T2);
+		REG_WRITE_U32( REG_TIME_PARA3+map_base, g_nand_device.T3);
+
+		device_size = g_nand_device.size;
+		chip_size   = g_nand_device.chipsize;
+		page_size   = g_nand_device.PageSize;
+		block_size  = g_nand_device.BlockSize;
+		oob_size    = g_nand_device.OobSize;
+		num_chips   = g_nand_device.num_chips;
+		isLastPage  = g_nand_device.isLastPage;
+
+		REG_WRITE_U32( REG_TIME_PARA1+map_base, g_nand_device.T1);
+		REG_WRITE_U32( REG_TIME_PARA2+map_base, g_nand_device.T2);
+		REG_WRITE_U32( REG_TIME_PARA3+map_base, g_nand_device.T3);
+
+		this->page_shift = __ffs(page_size); 
+		this->page_idx_mask = ~((1L << this->page_shift) -1);
+		this->phys_erase_shift = __ffs(block_size);
+		this->oob_shift = __ffs(oob_size);
+		ppb = this->ppb = block_size >> this->page_shift;
+
+		if (chip_size){
+			this->block_num = chip_size >> this->phys_erase_shift;
+			this->page_num = chip_size >> this->page_shift;
+			this->chipsize = chip_size;
+			this->device_size = device_size;
+			this->chip_shift =  __ffs(this->chipsize );
+		}
+
+		this->pagemask = (this->chipsize >> this->page_shift) - 1;
+
+		mtd->oobsize = this->oob_size = oob_size;
+
+		mtd->writesize = page_size;
+		mtd->erasesize = block_size;
+		mtd->writebufsize = page_size;
+
+		mtd->erasesize_shift = this->phys_erase_shift;
+		mtd->writesize_shift = this->page_shift;
+
+		this->ecc_select = g_nand_device.eccSelect;
+	}
+	else 
+	{
+		while (1) {
+			this->read_id(mtd, id);
+
+			this->maker_code = maker_code = id[0];
+			this->device_code = device_code = id[1];
+			nand_type_id = maker_code<<24 | device_code<<16 | id[2]<<8 | id[3];
+			B5th = id[4];
+			B6th = id[5];
+
+			NF_INFO_PRINT("READ ID:0x%x 0x%x 0x%x 0x%x 0x%x 0x%x\n",id[0],id[1],id[2],id[3],id[4],id[5]);		
+
+			NF_INFO_PRINT("NAND Flash Controller detects %d dies\n", num_chips_probe);
+
+			for (i = 0; nand_device[i].name; i++){
+
+				if ( nand_device[i].id==nand_type_id && 
+						((nand_device[i].CycleID5th==0xff)?1:(nand_device[i].CycleID5th==B5th))&&
+						((nand_device[i].CycleID6th==0xff)?1:(nand_device[i].CycleID6th==B6th))) {
+					REG_WRITE_U32( REG_TIME_PARA1+map_base,nand_device[i].T1);
+					REG_WRITE_U32( REG_TIME_PARA2+map_base,nand_device[i].T2);
+					REG_WRITE_U32( REG_TIME_PARA3+map_base,nand_device[i].T3);
+					if ( nand_type_id != HY27UT084G2M ){
+						REG_WRITE_U32( REG_MULTI_CHNL_MODE+map_base,0x20);
+					}
+					if (nand_device[i].size == num_chips_probe * nand_device[i].chipsize){
+						if ( num_chips_probe == nand_device[i].num_chips ){
+							NF_INFO_PRINT("One %s chip has %d die(s) on board\n", 
+									nand_device[i].name, nand_device[i].num_chips);
+							//mtd->PartNum = nand_device[i].name;
+							device_size = nand_device[i].size;
+							chip_size = nand_device[i].chipsize;
+							page_size = nand_device[i].PageSize;
+							block_size = nand_device[i].BlockSize;
+							oob_size = nand_device[i].OobSize;
+							num_chips = nand_device[i].num_chips;
+							isLastPage = nand_device[i].isLastPage;
+							rtk_lookup_table_flag = 1;
+							REG_WRITE_U32( REG_TIME_PARA1+map_base,nand_device[i].T1);
+							REG_WRITE_U32( REG_TIME_PARA2+map_base,nand_device[i].T2);
+							REG_WRITE_U32( REG_TIME_PARA3+map_base,nand_device[i].T3);
+							NF_INFO_PRINT("index(%d) nand part=%s, id=0x%x, device_size=%llu, page_size=0x%x, block_size=0x%x, oob_size=0x%x, num_chips=0x%x, isLastPage=0x%x, ecc_sel=0x%x \n",
+									i,
+									nand_device[i].name,
+									nand_device[i].id,
+									nand_device[i].size,
+									page_size,
+									block_size,
+									oob_size,
+									num_chips,
+									isLastPage,
+									nand_device[i].eccSelect);
+							break;
+						}				
+					}else{
+						if ( !strcmp(nand_device[i].name, "HY27UF084G2M" ) )
+							continue;
+						else{	
+							NF_INFO_PRINT("We have %d the same %s chips on board\n", 
+									num_chips_probe/nand_device[i].num_chips, nand_device[i].name);
+							//mtd->PartNum = nand_device[i].name;
+							device_size = nand_device[i].size;
+							chip_size = nand_device[i].chipsize;	
+							page_size = nand_device[i].PageSize;
+							block_size = nand_device[i].BlockSize;
+							oob_size = nand_device[i].OobSize;
+							num_chips = nand_device[i].num_chips;
+							isLastPage = nand_device[i].isLastPage;
+							rtk_lookup_table_flag = 1;
+							NF_INFO_PRINT("nand part=%s, id=%x, device_size=%llu, chip_size=%llu, num_chips=%d, isLastPage=%d, eccBits=%d\n", 
+									nand_device[i].name, nand_device[i].id, nand_device[i].size, nand_device[i].chipsize, 
+									nand_device[i].num_chips, nand_device[i].isLastPage, nand_device[i].eccSelect);
+							break;
+						}
+					}
+				}
+			}
+
+			if ( !rtk_lookup_table_flag ){
+				NF_ERR_PRINT("Warning: Lookup Table do not have this nand flash !!\n");
+				NF_ERR_PRINT("%s: Manufacture ID=0x%02x, Chip ID=0x%02x, "
+						"3thID=0x%02x, 4thID=0x%02x, 5thID=0x%02x, 6thID=0x%02x\n",
+						mtd->name, id[0], id[1], id[2], id[3], id[4], id[5]);
+				return -1;
+			}
+
+			this->page_shift = __ffs(page_size); 
+			this->page_idx_mask = ~((1L << this->page_shift) -1);
+			this->phys_erase_shift = __ffs(block_size);
+			this->oob_shift = __ffs(oob_size);
+			ppb = this->ppb = block_size >> this->page_shift;
+
+			if (chip_size){
+				this->block_num = chip_size >> this->phys_erase_shift;
+				this->page_num = chip_size >> this->page_shift;
+				this->chipsize = chip_size;
+				this->device_size = device_size;
+				this->chip_shift =  __ffs(this->chipsize );
+			}
+
+			this->pagemask = (this->chipsize >> this->page_shift) - 1;
+
+			mtd->oobsize = this->oob_size = oob_size;
+
+			mtd->writesize = page_size;//add by alexchang 0923-2010
+			mtd->erasesize = block_size;
+			mtd->writebufsize = page_size;
+
+			mtd->erasesize_shift = this->phys_erase_shift;
+			mtd->writesize_shift = this->page_shift;
+
+			this->ecc_select = nand_device[i].eccSelect;//add by alexchang 0617-2011.
+
+			break;
+		}
+	}
+
+	switch(this->ecc_select) {
+		case 0x0:
+			g_eccbits = 6;
+                        break;
+                case 0x1:
+			g_eccbits = 12;
+                        break;
+                case 0xe:
+			g_eccbits = 16;
+                        break;
+                case 0xa:
+			g_eccbits = 24;
+                        break;
+                case 0x2:
+			g_eccbits = 40;
+                        break;
+                case 0x4:
+			g_eccbits = 43;
+                        break;
+                case 0x6:
+			g_eccbits = 65;
+                        break;
+                case 0x8:
+			g_eccbits = 72;
+                        break;
+                default:
+			g_eccbits = 6;
+                        break;
+        }
+
+	 if(g_eccbits >= 0x18)
+		mtd->ecc_strength = 1024;
+        else
+		mtd->ecc_strength = 512;
+
+	this->select_chip(mtd, 0);
+			
+	if ( num_chips != num_chips_probe )
+		this->numchips = num_chips_probe;
+	else
+		this->numchips = num_chips;
+	div_res = mtd->size = this->numchips * this->chipsize;
+
+	do_div(div_res,block_size);
+	result = div_res;
+	result*=this->RBA_PERCENT;
+	do_div(result,100);
+	RBA = this->RBA = result;
+
+
+	RBA = this->RBA = ((unsigned int)mtd->size/block_size) * this->RBA_PERCENT/100;
+
+	mtd->dev.coherent_dma_mask = 0xffffffff;
+
+	this->bbt = kmalloc( sizeof(BB_t)*RBA, GFP_KERNEL );
+	if ( !this->bbt ){
+		NF_ERR_PRINT("%s: Error, no enough memory for BBT\n",__FUNCTION__);
+		return -1;
+	}
+	memset(this->bbt, 0,  sizeof(BB_t)*RBA);
+
+#ifdef RTK_NAND_SHIFTABLE
+	this->sbt = kmalloc( sizeof(SB_t)*100, GFP_KERNEL );
+	if ( !this->sbt ){
+		NF_ERR_PRINT("%s: Error, no enough memory for SBT\n",__FUNCTION__);
+		return -1;
+	}
+	memset(this->sbt, 0,  sizeof(SB_t)*100);
+#endif
+
+	nrBuffer = (unsigned char *)dma_alloc_coherent(&mtd->dev, MAX_NR_LENGTH, (dma_addr_t *) (&nrPhys_addr), GFP_DMA | GFP_KERNEL);
+	if ( !nrBuffer ) {
+		NF_ERR_PRINT("%s: Error, no enough memory for nrBuffer\n",__FUNCTION__);
+		return -ENOMEM;	
+        }
+	memset(nrBuffer, 0xff, MAX_NR_LENGTH);
+
+	this->g_oobbuf = (unsigned char  *)dma_alloc_coherent(&mtd->dev, oob_size*256, (dma_addr_t *) (&oobPhys_addr), GFP_KERNEL | GFP_DMA);
+	if ( !this->g_oobbuf ){
+		NF_ERR_PRINT("%s: Error, no enough memory for g_oobbuf\n",__FUNCTION__);
+		return -ENOMEM;
+	}
+	memset(this->g_oobbuf, 0xff, oob_size);
+
+	tempBuffer = (unsigned char  *)dma_alloc_coherent(&mtd->dev, 2048*4, (dma_addr_t *) (&tempPhys_addr), GFP_KERNEL | GFP_DMA);
+	if ( !tempBuffer ){
+                NF_ERR_PRINT("%s: Error, no enough memory for tempBuffer\n",__FUNCTION__);
+                return -ENOMEM;
+        }
+        memset(tempBuffer, 0xff, 2048*4);
+
+	flag_size =  (this->numchips * this->page_num) >> 3;
+	mempage_order = get_order(flag_size);
+#if 0	
+	this->erase_page_flag = (void *)__get_free_pages(GFP_KERNEL, mempage_order);	
+	if ( !this->erase_page_flag ){
+		NF_ERR_PRINT("%s: Error, no enough memory for erase_page_flag\n",__FUNCTION__);
+		return -ENOMEM;
+	}
+	memset ( (__u32 *)this->erase_page_flag, 0, flag_size);
+#endif
+	mtd->type		= MTD_NANDFLASH;
+	mtd->flags		= MTD_CAP_NANDFLASH;
+	mtd->_erase		= nand_erase;
+	mtd->_point		= NULL;
+	mtd->_unpoint		= NULL;
+	mtd->_read		= nand_read;
+	mtd->_write		= nand_write;
+	mtd->_read_oob		= nand_read_oob;
+	mtd->_write_oob		= nand_write_oob;
+	mtd->_sync		= nand_sync;
+	mtd->_lock		= NULL;
+	mtd->_unlock		= NULL;
+	mtd->_suspend		= nand_suspend;
+	mtd->_resume		= nand_resume;
+	mtd->owner		= THIS_MODULE;
+	mtd->_block_isbad	= nand_block_isbad;
+	mtd->_block_markbad	= nand_block_markbad;
+	mtd->_panic_write	= NULL; //panic_nand_write;
+	mtd->owner = THIS_MODULE;
+
+#ifdef RTK_NAND_SHIFTABLE
+	if(rtk_nand_get_shift_table(mtd, (unsigned char *)nrPhys_addr) < 0) {
+                return -1;
+	}
+#endif
+
+	return this->scan_bbt(mtd, (unsigned char *)nrPhys_addr);
+}
diff --git a/drivers/mtd/nand/rtk_nand.c b/drivers/mtd/nand/rtk_nand.c
new file mode 100644
index 00000000..39f11b3
--- /dev/null
+++ b/drivers/mtd/nand/rtk_nand.c
@@ -0,0 +1,1271 @@
+/*
+ * rtk_nand.c - nand driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/mtd/mtd.h>
+#include <linux/mtd/partitions.h>
+#include <linux/slab.h>
+#include <linux/sysctl.h>
+#include <linux/sched.h>
+#include <linux/list.h>
+#include <linux/pm.h>
+#include <asm/io.h>
+#include <linux/init.h>
+#include <linux/mtd/rtk_nand_reg.h>
+#include <linux/mtd/rtk_nand.h>
+#include <linux/bitops.h>
+#include <mtd/mtd-abi.h>
+#include <linux/jiffies.h>
+#include <linux/delay.h>
+#include <linux/time.h>
+#include <linux/uaccess.h>
+#include <linux/proc_fs.h>
+#include <linux/string.h>
+#include <linux/platform_device.h>
+#include <linux/interrupt.h>
+#include <linux/dma-mapping.h>
+#include <linux/of.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_platform.h>
+#include <linux/of_gpio.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+#include "../mtdcore.h"
+
+#define BANNER			"Realtek NAND Flash Driver"
+#define VERSION			"$Id: rtk_nand.c 2018-10-29 01:32:27Z aaron.lin $"
+#define MTDSIZE			(sizeof (struct mtd_info) + sizeof (struct nand_chip))
+
+#define RTKNAND_PROC_DIR_NAME           "rtknand"
+#define RTKNAND_PROC_INFO_DIR_NAME      "rtknand/info"
+#define RTKNAND_PROC_TEST_DIR_NAME	"rtknand/test"
+
+extern struct proc_dir_entry proc_root;
+static struct proc_dir_entry *rtknand_proc_dir = NULL;
+#ifdef RTK_VERIFY
+unsigned int r_test_flag = 0;
+unsigned int w_test_flag = 0;
+unsigned int w_wait_flag = 0;
+unsigned int nomap_blk = 0;
+#endif
+static int g_id_chain = 0;
+extern unsigned int g_eccbits;
+extern dma_addr_t oobPhys_addr;
+
+#ifdef RTK_TEST
+static struct mtd_partition rtk_partitions[] =
+{
+    {
+        .name   = "rtk_nand",
+	.size   = 0x10000000,
+	.offset = 0x0
+    },
+#if 0
+    {
+        .name   = "dtb",
+        //.size   = 0x400000,
+        .size   = 0x40000,
+        .offset = 0x2000000
+    },
+    {
+        .name   = "kernel",
+        .size   = 0x1C00000,
+        .offset = 0x2000000 + 0x400000
+    },
+    {
+        .name   = "rootfs",
+        .size   = 0x2000000,
+        .offset = 0x2000000 + 0x2000000
+    },
+#endif
+    {
+        .name   = "yaffs",
+        .size   = 0x2000000,
+        .offset = 0x8000000
+    },
+    {
+        .name   = "ubifs",
+        .size   = 0x2000000,
+        .offset = 0x8000000 + 4000000
+    }
+};
+#endif
+
+char g_rtk_nandinfo_line[64];
+
+void __iomem    *map_base = 0;
+void __iomem    *swc_base = 0;
+
+const char *ptypes[] = {"cmdlinepart", NULL};
+
+/* nand driver low-level functions */
+//static int rtk_read_oob(struct mtd_info *mtd, u16 chipnr, int page, int len, u_char *buf);
+static int rtk_read_ecc_page(struct mtd_info *mtd, u16 chipnr, unsigned int page,
+			u_char *data, u_char *oob_buf, u16 cp_mode, dma_addr_t *data_phy);
+static int rtk_write_oob(struct mtd_info *mtd, u16 chipnr, int page, int len, const u_char *buf);
+static int rtk_write_ecc_page(struct mtd_info *mtd, u16 chipnr, unsigned int page, const u_char *data, const u_char *oob_buf, const dma_addr_t *data_phy);
+static int rtk_erase_block(struct mtd_info *mtd, u16 chipnr, int page);
+void rtk_nand_reset(void);
+/* Global Variables */
+struct mtd_info *rtk_mtd;
+
+static int page_size, oob_size, ppb;
+static int RBA_PERCENT = 5;
+
+static struct rw_semaphore rw_sem;
+
+struct rtk_nand_host {
+	struct mtd_info		mtd;
+	struct nand_chip	nand;
+	struct mtd_partition	*parts;
+	struct device		*dev;
+	void    *spare0;
+	void    *main_area0;
+	void    *main_area1;
+	void __iomem    *base;
+	void __iomem    *regs;
+	int	    status_request;
+	struct clk  *clk;
+	int	clk_act;
+	int	irq;
+	wait_queue_head_t	irq_waitq;
+	uint8_t		*data_buf;
+	unsigned int    buf_start;
+	int		spare_len;
+};
+
+void syncPageRead(void)
+{
+	dmb(sy);
+	dmb(sy);
+}
+
+int WAIT_DONE(void *addr, u64 mask, unsigned int value)
+{
+	unsigned int test = 0x0;
+
+#ifdef RTK_VERIFY
+	if(w_wait_flag == 1) {
+		w_wait_flag = 0;
+		printk(KERN_ERR "WAIT_DONE timeout, do nand reset.\n");
+		return -WAIT_TIMEOUT;
+	}
+#endif
+
+        while ( (REG_READ_U32((volatile unsigned int*)addr) & mask) != value ) {
+                asm("nop");
+                smp_wmb();
+		test++;
+
+		if (test == 0xFFFFFFFF) {
+			printk(KERN_ERR "WAIT_DONE timeout, do nand reset.\n");
+			return -WAIT_TIMEOUT;	
+		}
+        }
+	
+	return 0;
+}
+
+void rtk_nand_reset(void)
+{
+	int rc;
+
+        //down_write(&rw_sem);
+
+        // controller init.
+        REG_WRITE_U32(REG_PD + map_base, 0x1E);
+        REG_WRITE_U32(REG_TIME_PARA3 + map_base, 0x2);
+        REG_WRITE_U32(REG_TIME_PARA2 + map_base, 0x5);
+        REG_WRITE_U32(REG_TIME_PARA1 + map_base, 0x2);
+
+        REG_WRITE_U32(REG_MULTI_CHNL_MODE+map_base, 0x0);
+        REG_WRITE_U32(REG_READ_BY_PP+map_base, 0x0);
+
+        // reset nand.
+        REG_WRITE_U32(REG_ND_CMD+map_base, CMD_RESET);
+        REG_WRITE_U32(REG_ND_CTL+map_base, 0x80);
+        rc = WAIT_DONE(REG_ND_CTL+map_base,0x80,0);
+        rc = WAIT_DONE(REG_ND_CTL+map_base,0x40,0x40);
+
+        REG_WRITE_U32(REG_NF_LOW_PWR+map_base, REG_READ_U32(REG_NF_LOW_PWR+map_base)&~0x10);
+        REG_WRITE_U32(REG_SPR_DDR_CTL+map_base, NF_SPR_DDR_CTL_spare_ddr_ena(1) | NF_SPR_DDR_CTL_per_2k_spr_ena(1)| NF_SPR_DDR_CTL_spare_dram_sa(0));
+
+	//up_write(&rw_sem);
+}
+EXPORT_SYMBOL(rtk_nand_reset);
+
+static int rtk_nand_suspend (struct device *dev)
+{
+        struct clk *clk = clk_get(dev, NULL);
+
+        clk_disable_unprepare(clk);
+
+	return 0;
+}
+
+static int rtk_nand_resume (struct device *dev)
+{
+        struct clk *clk = clk_get(dev, NULL);
+	int rc;
+
+	clk_prepare_enable(clk);
+
+        // controller init.
+        REG_WRITE_U32(REG_PD + map_base, 0x1E);
+        REG_WRITE_U32(REG_TIME_PARA3 + map_base, 0x2);
+        REG_WRITE_U32(REG_TIME_PARA2 + map_base, 0x5);
+        REG_WRITE_U32(REG_TIME_PARA1 + map_base, 0x2);
+
+        REG_WRITE_U32(REG_MULTI_CHNL_MODE+map_base, 0x0);
+        REG_WRITE_U32(REG_READ_BY_PP+map_base, 0x0);
+
+        // reset nand.
+        REG_WRITE_U32(REG_ND_CMD+map_base, 0xff);
+        REG_WRITE_U32(REG_ND_CTL+map_base, 0x80);
+
+        rc = WAIT_DONE(REG_ND_CTL+map_base,0x80,0);
+        rc = WAIT_DONE(REG_ND_CTL+map_base,0x40,0x40);
+
+        REG_WRITE_U32(REG_NF_LOW_PWR+map_base, REG_READ_U32(REG_NF_LOW_PWR+map_base)&~0x10);
+
+        REG_WRITE_U32(REG_SPR_DDR_CTL+map_base, NF_SPR_DDR_CTL_spare_ddr_ena(1) | NF_SPR_DDR_CTL_per_2k_spr_ena(1)| NF_SPR_DDR_CTL_spare_dram_sa(0));
+
+	return 0;
+}
+
+static void rtk_read_oob_from_SRAM(struct mtd_info *mtd, __u8 *oobbuf)
+{
+	struct nand_chip *this = (struct nand_chip *) mtd->priv;
+        unsigned int reg_oob;
+        void __iomem *reg = NULL;
+        int i;
+	char r_oobbuf[256];
+	int oobuse_size;
+
+        REG_WRITE_U32(REG_READ_BY_PP+map_base,0x00);
+        REG_WRITE_U32(REG_SRAM_CTL+map_base, 0x30 | 0x04);
+
+	memset(r_oobbuf, 0xFF, 256);
+	memset(oobbuf, 0xFF, mtd->oobsize);
+
+        reg = ioremap(0x98010000, 0x100);
+
+	switch(this->ecc_select) {
+                case 0x0:
+                        oobuse_size = 6 + 10;
+                        break;
+                case 0x1:
+                        oobuse_size = 6 + 20;
+                        break;
+                default:
+                        oobuse_size = 6 + 10;
+                        break;
+        }
+
+        for(i = 0; i<(mtd->oobsize/4); i++) {
+                reg_oob = REG_READ_U32(reg+(i*4));
+
+                r_oobbuf[i*4] = reg_oob & 0xff;
+                r_oobbuf[(i*4)+1] = (reg_oob >> 8) & 0xff;
+                r_oobbuf[(i*4)+2] = (reg_oob >> 16) & 0xff;
+                r_oobbuf[(i*4)+3] = (reg_oob >> 24) & 0xff;
+        }
+
+	for(i = 0; i < 4; i++) {
+		memcpy(oobbuf+(i*oobuse_size), r_oobbuf+(i*(mtd->oobsize/4)), oobuse_size);
+	}
+
+        REG_WRITE_U32(REG_SRAM_CTL+map_base, 0x00);
+        REG_WRITE_U32(REG_READ_BY_PP+map_base,0x80);
+
+	return;
+}
+
+static void rtk_nand_read_id(struct mtd_info *mtd, u_char id[6])
+{
+	int id_chain;
+	int rc;
+
+	REG_WRITE_U32(REG_DATA_TL0+map_base,NF_DATA_TL0_length0(0x06));
+	REG_WRITE_U32(REG_DATA_TL1+map_base,NF_DATA_TL1_access_mode(0x01));
+
+	//Set PP
+	REG_WRITE_U32(REG_READ_BY_PP+map_base,NF_READ_BY_PP_read_by_pp(0x0));
+
+	REG_WRITE_U32(REG_PP_CTL0+map_base,NF_PP_CTL0_pp_enable(0x01));
+	REG_WRITE_U32(REG_PP_CTL1+map_base,NF_PP_CTL1_pp_start_addr(0));
+
+	//Set command
+	REG_WRITE_U32(REG_ND_CMD+map_base,NF_ND_CMD_cmd(CMD_READ_ID));
+	REG_WRITE_U32(REG_ND_CTL+map_base,NF_ND_CTL_xfer(0x01));
+	rc = WAIT_DONE(REG_ND_CTL+map_base,0x80,0);
+
+	//Set address
+	REG_WRITE_U32(REG_ND_PA0+map_base, 0);
+	REG_WRITE_U32(REG_ND_PA1+map_base, 0);
+	REG_WRITE_U32(REG_ND_PA2+map_base,NF_ND_PA2_addr_mode(0x07));
+
+	REG_WRITE_U32(REG_ND_CTL+map_base,NF_ND_CTL_xfer(1)|NF_ND_CTL_tran_mode(1));
+	rc = WAIT_DONE(REG_ND_CTL+map_base,0x80,0);
+	//Enable XFER mode
+	REG_WRITE_U32(REG_ND_CTL+map_base,NF_ND_CTL_xfer(1)|NF_ND_CTL_tran_mode(4));
+	rc = WAIT_DONE(REG_ND_CTL+map_base,0x80,0);
+
+	//Reset PP
+	REG_WRITE_U32(REG_PP_CTL0+map_base,NF_PP_CTL0_pp_reset(1));
+
+	//Move data to DRAM from SRAM
+	REG_WRITE_U32(REG_SRAM_CTL+map_base,NF_SRAM_CTL_map_sel(1)|NF_SRAM_CTL_access_en(1)|NF_SRAM_CTL_mem_region(0));
+
+	id_chain = REG_READ_U32(REG_ND_PA0+map_base);
+        g_id_chain = id_chain;
+	NF_DEBUG_PRINT("id_chain 1 = 0x%x \n", id_chain);
+	id[0] = id_chain & 0xff;
+	id[1] = (id_chain >> 8) & 0xff;
+	id[2] = (id_chain >> 16) & 0xff;
+	id[3] = (id_chain >> 24) & 0xff;
+
+	id_chain = REG_READ_U32(REG_ND_PA1+map_base);
+	NF_DEBUG_PRINT("id_chain 2 = 0x%x \n", id_chain);
+	id[4] = id_chain & 0xff;
+	id[5] = (id_chain >> 8) & 0xff;
+
+	REG_WRITE_U32(REG_SRAM_CTL+map_base,0x0);	//# no omitted
+}
+
+static int rtk_erase_block(struct mtd_info *mtd, u16 chipnr, int page)
+{
+	struct nand_chip *this = NULL;
+	unsigned int chip_section = 0;
+	unsigned int section = 0;
+	page_size = mtd->writesize;
+	oob_size = mtd->oobsize;
+	ppb = mtd->erasesize/mtd->writesize;
+	this = (struct nand_chip *) mtd->priv;
+
+	down_write(&rw_sem);
+
+	if ( page & (ppb-1) ){
+		NF_ERR_PRINT("%s: page %d is not block alignment !!\n", __FUNCTION__, page);
+		up_write(&rw_sem);
+		return -1;
+	}
+
+	REG_WRITE_U32( REG_MULTI_CHNL_MODE+map_base,NF_MULTI_CHNL_MODE_no_wait_busy(1)|NF_MULTI_CHNL_MODE_edo(1));
+
+
+	REG_WRITE_U32( REG_ND_CMD+map_base,NF_ND_CMD_cmd(CMD_BLK_ERASE_C1) );
+	REG_WRITE_U32( REG_CMD2+map_base,NF_CMD2_cmd2(CMD_BLK_ERASE_C2) );
+	REG_WRITE_U32( REG_CMD3+map_base,NF_CMD3_cmd3(CMD_BLK_ERASE_C3) );
+
+	REG_WRITE_U32( REG_ND_PA0+map_base,NF_ND_PA0_page_addr0(page) );
+	REG_WRITE_U32( REG_ND_PA1+map_base,NF_ND_PA1_page_addr1(page>>8) );
+	REG_WRITE_U32( REG_ND_PA2+map_base,NF_ND_PA2_addr_mode(0x04)|NF_ND_PA2_page_addr2(page>>16) );
+	REG_WRITE_U32( REG_ND_PA3+map_base,NF_ND_PA3_page_addr3((page>> 21)&0x7) );
+
+	REG_WRITE_U32( REG_AUTO_TRIG+map_base,NF_AUTO_TRIG_auto_trig(1)|NF_AUTO_TRIG_spec_auto_case(1)|NF_AUTO_TRIG_auto_case(2) );
+	if(WAIT_DONE(REG_AUTO_TRIG+map_base,0x80,0)) {
+		NF_ERR_PRINT("[%s] WAIT_DONE timeout. (%d)\n", __FUNCTION__, __LINE__);
+		up_write(&rw_sem);
+		return -WAIT_TIMEOUT;
+	}
+
+	REG_WRITE_U32(REG_POLL_FSTS+map_base,NF_POLL_FSTS_bit_sel(6)|NF_POLL_FSTS_trig_poll(1) );
+	if(WAIT_DONE(REG_POLL_FSTS+map_base,0x01,0x0)) {
+		NF_ERR_PRINT("[%s] WAIT_DONE timeout. (%d)\n", __FUNCTION__, __LINE__);
+		up_write(&rw_sem);
+		return -WAIT_TIMEOUT;
+	}
+	if(WAIT_DONE(REG_ND_CTL+map_base,0x40,0x40)) {
+		NF_ERR_PRINT("[%s] WAIT_DONE timeout. (%d)\n", __FUNCTION__, __LINE__);
+		up_write(&rw_sem);
+		return -WAIT_TIMEOUT;
+	}
+
+	if ( REG_READ_U32(REG_ND_DAT+map_base) & 0x01 ){
+		up_write(&rw_sem);
+		NF_ERR_PRINT("[%s] erasure is not completed at block %d\n", __FUNCTION__, page/ppb);
+		return -1;
+	}
+
+	chip_section = (chipnr * this->page_num) >> 5;
+	section = page >> 5;
+#if 0
+	if(this->erase_page_flag)
+		memset ( (__u32 *)(this->erase_page_flag)+ chip_section + section, 0xff, ppb>>3);
+#endif
+	up_write(&rw_sem);
+	
+	return 0;
+}
+
+static int rtk_read_ecc_page (struct mtd_info *mtd, u16 chipnr, unsigned int page, u_char *data_buf, u_char *oob_buf, u16 cp_mode, dma_addr_t *data_phy)
+{
+	struct nand_chip *this = NULL;
+	int dram_sa, dma_len;
+	int page_len;
+	uint8_t	auto_trigger_mode = 2;
+	uint8_t	addr_mode = 1;
+	uint8_t	bChkAllOne = 0;
+    	volatile unsigned int data;
+    	unsigned int eccNum = 0;
+
+	this = (struct nand_chip *) mtd->priv;
+	page_size = mtd->writesize;
+	oob_size = mtd->oobsize;
+	ppb = mtd->erasesize/mtd->writesize;
+
+	syncPageRead();
+
+	down_write(&rw_sem);
+
+	if(((uintptr_t)data_buf&0x7)!=0) {
+		NF_DEBUG_PRINT("[%s]data_buf must 8 byte alignmemt!!\n", __FUNCTION__);
+		BUG();
+	}
+
+	while (1) 
+	{
+		if(this->ecc_select >= 0x18)
+		{
+			if (bChkAllOne) {
+				// enable randomizer
+				REG_WRITE_U32(REG_RMZ_CTRL+map_base, 0);
+				REG_WRITE_U32(REG_BLANK_CHK+map_base,NF_BLANK_CHK_blank_ena(1)|NF_BLANK_CHK_read_ecc_xnor_ena(1));
+			}
+			else {
+				// enable randomizer
+				REG_WRITE_U32(REG_RMZ_CTRL+map_base, 1);
+				REG_WRITE_U32(REG_BLANK_CHK+map_base,NF_BLANK_CHK_blank_ena(1)|NF_BLANK_CHK_read_ecc_xnor_ena(0));
+			}
+			
+			page_len = page_size >> 10;
+			REG_WRITE_U32(REG_DATA_TL0+map_base,NF_DATA_TL0_length0(1024));
+			REG_WRITE_U32(REG_DATA_TL1+map_base,NF_DATA_TL1_access_mode(1)|NF_DATA_TL1_length1(4));
+		}
+		else
+		{
+			// set random read
+			REG_WRITE_U32(REG_RND_EN+map_base, 1);
+			REG_WRITE_U32(REG_RND_CMD1+map_base, 0x5);
+			REG_WRITE_U32(REG_RND_CMD2+map_base, 0xe0);
+			REG_WRITE_U32(REG_RND_DATA_STR_COL_H+map_base, 0);	// data start address MSB (always 0)
+			REG_WRITE_U32(REG_RND_SPR_STR_COL_H+map_base, page_size >> 8);	// spare start address MSB
+			REG_WRITE_U32(REG_RND_SPR_STR_COL_L+map_base, page_size & 0xff);	// spare start address LSB
+			
+			page_len = page_size >> 9;
+			REG_WRITE_U32(REG_DATA_TL0+map_base,NF_DATA_TL0_length0(512));
+			REG_WRITE_U32(REG_DATA_TL1+map_base,NF_DATA_TL1_access_mode(1)|NF_DATA_TL1_length1(2));
+		}
+		REG_WRITE_U32(REG_PAGE_LEN+map_base,NF_PAGE_LEN_page_len(page_len));
+
+		//Set PP
+		REG_WRITE_U32(REG_READ_BY_PP+map_base,NF_READ_BY_PP_read_by_pp(1));
+		REG_WRITE_U32(REG_PP_CTL1+map_base,NF_PP_CTL1_pp_start_addr(0));
+		REG_WRITE_U32(REG_PP_CTL0+map_base,0);
+
+		// enable blank check
+		REG_WRITE_U32(REG_BLANK_CHK+map_base,NF_BLANK_CHK_blank_ena(1) );
+
+		if(cp_mode == CP_NF_AES_ECB_128 || cp_mode==CP_NF_AES_CBC_128) {
+			REG_WRITE_U32(CP_NF_INI_KEY_0+map_base,0x0);
+			REG_WRITE_U32(CP_NF_INI_KEY_1+map_base,0x0);
+			REG_WRITE_U32(CP_NF_INI_KEY_2+map_base,0x0);
+			REG_WRITE_U32(CP_NF_INI_KEY_3+map_base,0x0);
+
+			REG_WRITE_U32(CP_NF_KEY_0+map_base,0x8746bca3);
+			REG_WRITE_U32(CP_NF_KEY_1+map_base,0xcdef89ab);
+			REG_WRITE_U32(CP_NF_KEY_2+map_base,0x54369923);
+			REG_WRITE_U32(CP_NF_KEY_3+map_base,0xcdefbcab);
+
+			// set CP register.
+			if(cp_mode == CP_NF_AES_ECB_128)
+				REG_WRITE_U32(CP_NF_SET+map_base, 0x200);	// sel=0, cw_entry=0, bcm=1, aes_mode=0. Its ECB mode.
+			else
+				REG_WRITE_U32(CP_NF_SET+map_base, 0x0);		// sel=0, cw_entry=0, bcm=0, aes_mode=0. Its CBC mode.
+
+			REG_WRITE_U32(REG_CP_LEN+map_base, (page_size / 0x200) << 9);	// integer multiple of dma_len.
+
+		}
+
+		//Set command
+		REG_WRITE_U32(REG_ND_CMD+map_base,NF_ND_CMD_cmd(CMD_PG_READ_C1));
+		REG_WRITE_U32(REG_CMD2+map_base,NF_CMD2_cmd2(CMD_PG_READ_C2));
+		REG_WRITE_U32(REG_CMD3+map_base,NF_CMD3_cmd3(CMD_PG_READ_C3));
+		
+		//Set address
+		REG_WRITE_U32( REG_ND_PA0+map_base,NF_ND_PA0_page_addr0( 0xff&page ));
+        
+		REG_WRITE_U32( REG_ND_PA1+map_base,NF_ND_PA1_page_addr1( 0xff&(page>>8) ));
+		REG_WRITE_U32( REG_ND_PA2+map_base,NF_ND_PA2_addr_mode(addr_mode)|NF_ND_PA2_page_addr2( 0x1f&(page>>16) ));
+		REG_WRITE_U32( REG_ND_PA3+map_base,NF_ND_PA3_page_addr3( 0x7&(page>>21) ));
+
+		REG_WRITE_U32(REG_ND_CA0+map_base, 0);
+		REG_WRITE_U32(REG_ND_CA1+map_base, 0);
+
+		//Set ECC
+		REG_WRITE_U32( REG_MULTI_CHNL_MODE+map_base,NF_MULTI_CHNL_MODE_edo(1));//add by alexchang0205-2010
+		REG_WRITE_U32( REG_ECC_STOP+map_base,NF_ECC_STOP_ecc_n_stop(0x01));
+
+		REG_WRITE_U32(REG_ECC_SEL+map_base, this->ecc_select);
+
+		dram_sa = ( (uintptr_t)data_phy >> 3);
+		REG_WRITE_U32(REG_DMA_CTL1+map_base,NF_DMA_CTL1_dram_sa(dram_sa));
+		dma_len = page_size >> 9;
+		REG_WRITE_U32(REG_DMA_CTL2+map_base,NF_DMA_CTL2_dma_len(dma_len));
+
+		if(cp_mode == CP_NF_AES_ECB_128||cp_mode==CP_NF_AES_CBC_128){
+			REG_WRITE_U32(REG_DMA_CTL3+map_base,NF_DMA_CTL3_cp_enable(1)|NF_DMA_CTL3_cp_first(1)|NF_DMA_CTL3_ddr_wr(1)|NF_DMA_CTL3_dma_xfer(1));
+		}else{
+			REG_WRITE_U32(REG_DMA_CTL3+map_base,NF_DMA_CTL3_ddr_wr(1)|NF_DMA_CTL3_dma_xfer(1));
+		}
+
+		smp_wmb();
+	
+		syncPageRead();
+
+		//Enable Auto mode
+		REG_WRITE_U32( REG_AUTO_TRIG+map_base,NF_AUTO_TRIG_auto_trig(1)|NF_AUTO_TRIG_spec_auto_case(0)| NF_AUTO_TRIG_auto_case(auto_trigger_mode));
+
+		if(WAIT_DONE(REG_AUTO_TRIG+map_base,0x80,0)) {
+			NF_ERR_PRINT("[%s] WAIT_DONE timeout. (%d)\n", __FUNCTION__, __LINE__);
+			up_write(&rw_sem);
+			return -WAIT_TIMEOUT;
+		}
+
+		if(WAIT_DONE(REG_DMA_CTL3+map_base,0x01,0)) {
+			NF_ERR_PRINT("[%s] WAIT_DONE timeout. (%d)\n", __FUNCTION__, __LINE__);
+                        up_write(&rw_sem);
+                        return -WAIT_TIMEOUT;
+		}
+
+		if(1) {
+			data = (REG_READ_U32(REG_SPR_DDR_CTL+map_base) & 0x1fffffff) << 3;	// physical address
+			NF_DEBUG_PRINT("data==> 0x%x\n",data);
+			NF_DEBUG_PRINT("oob_buf[0]==> 0x%x, page=0x%x\n",this->g_oobbuf[0],page);    
+		}
+
+		if(oob_buf) {
+			rtk_read_oob_from_SRAM(mtd, oob_buf);
+		}
+
+		// return OK if all data bit is 1 (page is not written yet)
+		if ((REG_READ_U32(REG_BLANK_CHK+map_base) & 0x8)==0){
+			REG_WRITE_U32(REG_BLANK_CHK+map_base,NF_BLANK_CHK_blank_ena(1)|NF_BLANK_CHK_read_ecc_xnor_ena(0));
+			up_write(&rw_sem);
+			return 1;
+		}
+		else if (REG_READ_U32(REG_ND_ECC+map_base) & 0x8) {
+			NF_DEBUG_PRINT("[DBG][%s] page(0x%x) ecc error,  REG_BLANK_CHK reg: 0x%x\n", __FUNCTION__, page, REG_READ_U32(REG_BLANK_CHK+map_base));
+			REG_WRITE_U32(REG_BLANK_CHK+map_base,NF_BLANK_CHK_blank_ena(1)|NF_BLANK_CHK_read_ecc_xnor_ena(0));
+			up_write(&rw_sem);
+			return -1;	// ECC not correctable
+		}
+		else {
+            		//NF_DEBUG_PRINT("PK test page:%u  [0x%x]\n", page, REG_READ_U32(REG_ND_ECC+map_base));
+            		if (REG_READ_U32(REG_ND_ECC+map_base) & 0x04){
+                		eccNum = REG_READ_U32(REG_RSECC_NUM+map_base) & 0xff;
+                		NF_DEBUG_PRINT("[NAND_DBG][%s]:%d, ecc_num:%d, page:%u\n", __FUNCTION__,__LINE__, eccNum, page);
+                		if(eccNum > (g_eccbits - 2) ) {
+                    			NF_ERR_PRINT("[NAND_DBG][%s]:%d, ecc_num:%d, page:%u\n", __FUNCTION__,__LINE__, eccNum, page);
+                    			REG_WRITE_U32(REG_BLANK_CHK+map_base, NF_BLANK_CHK_blank_ena(1)|NF_BLANK_CHK_read_ecc_xnor_ena(0));
+                    			up_write(&rw_sem);
+                    			return -2;
+                		}
+            		}
+
+			REG_WRITE_U32(REG_BLANK_CHK+map_base,NF_BLANK_CHK_blank_ena(1)|NF_BLANK_CHK_read_ecc_xnor_ena(0));
+			up_write(&rw_sem);
+			return 0;
+		}
+	}
+}
+
+static int rtk_write_oob(struct mtd_info *mtd, u16 chipnr, int page, int len, const u_char *oob_buf)
+{
+        struct nand_chip *this = (struct nand_chip *) mtd->priv;
+        int rc = 0;
+        uint8_t auto_trigger_mode = 1;
+        uint8_t addr_mode = 1;
+        unsigned int page_len, dram_sa, dma_len, spare_dram_sa;
+        unsigned char oob_1stB;
+        unsigned int chip_section = 0;
+        unsigned int section =0;
+        unsigned int index =0;
+
+        memset(this->g_databuf, 0xff, page_size);
+
+        page_size = mtd->writesize;
+        oob_size = mtd->oobsize;
+        ppb = mtd->erasesize/mtd->writesize;
+
+        down_write(&rw_sem);
+
+	if ( len > oob_size || !oob_buf ){
+		NF_ERR_PRINT("[%s] error: len>oob_size OR oob_buf is NULL\n", __FUNCTION__);
+                up_write(&rw_sem);
+                return -1;
+        }
+	
+	REG_WRITE_U32(REG_SRAM_CTL+map_base,0x00);
+        REG_WRITE_U32(REG_DATA_TL0+map_base,NF_DATA_TL0_length0(0));
+        if(this->ecc_select >= 0x18) {
+                page_len = page_size >> 10;
+                REG_WRITE_U32(REG_DATA_TL1+map_base,NF_DATA_TL1_length1(4));
+        } else {
+                page_len = page_size >> 9;
+                REG_WRITE_U32(REG_DATA_TL1+map_base,NF_DATA_TL1_length1(2));
+        }
+
+	REG_WRITE_U32(REG_READ_BY_PP+map_base,NF_READ_BY_PP_read_by_pp(0));
+        REG_WRITE_U32(REG_PP_CTL1+map_base,NF_PP_CTL1_pp_start_addr(0));
+        REG_WRITE_U32(REG_PP_CTL0+map_base,0);
+
+        REG_WRITE_U32( REG_PAGE_LEN+map_base,NF_PAGE_LEN_page_len(page_len));
+
+        REG_WRITE_U32(REG_ND_CMD+map_base,NF_ND_CMD_cmd(CMD_PG_WRITE_C1));
+        REG_WRITE_U32(REG_CMD2+map_base,NF_CMD2_cmd2(CMD_PG_WRITE_C2));
+        REG_WRITE_U32(REG_CMD3+map_base,NF_CMD3_cmd3(CMD_PG_WRITE_C3));
+
+        REG_WRITE_U32( REG_ND_PA0+map_base,NF_ND_PA0_page_addr0(page));
+        REG_WRITE_U32( REG_ND_PA1+map_base,NF_ND_PA1_page_addr1(page>>8));
+        REG_WRITE_U32( REG_ND_PA2+map_base,NF_ND_PA2_addr_mode(addr_mode)|NF_ND_PA2_page_addr2(page>>16));
+        REG_WRITE_U32( REG_ND_PA3+map_base,NF_ND_PA3_page_addr3((page>>21)&0x7));
+        REG_WRITE_U32(REG_MULTI_CHNL_MODE+map_base,NF_MULTI_CHNL_MODE_edo(1));
+
+        REG_WRITE_U32(REG_ECC_SEL+map_base, this->ecc_select);
+
+	dram_sa = ((uintptr_t)this->g_databuf >> 3);
+        REG_WRITE_U32(REG_DMA_CTL1+map_base,NF_DMA_CTL1_dram_sa(dram_sa));
+        dma_len = page_size >> 9;
+        REG_WRITE_U32(REG_DMA_CTL2+map_base,NF_DMA_CTL2_dma_len(dma_len));
+        REG_WRITE_U32(REG_DMA_CTL3+map_base,NF_DMA_CTL3_ddr_wr(1)|NF_DMA_CTL3_dma_xfer(1));
+
+        spare_dram_sa = ((uintptr_t)oob_buf >> 3);
+        REG_WRITE_U32( REG_SPR_DDR_CTL+map_base,NF_SPR_DDR_CTL_spare_ddr_ena(1)|NF_SPR_DDR_CTL_per_2k_spr_ena(1)|NF_SPR_DDR_CTL_spare_dram_sa(spare_dram_sa));
+
+	REG_WRITE_U32( REG_AUTO_TRIG+map_base,NF_AUTO_TRIG_auto_trig(1)|NF_AUTO_TRIG_spec_auto_case(0)| NF_AUTO_TRIG_auto_case(auto_trigger_mode));
+
+	WAIT_DONE(REG_AUTO_TRIG+map_base,0x80,0);
+        WAIT_DONE(REG_DMA_CTL3+map_base,0x01,0);
+        REG_WRITE_U32(REG_POLL_FSTS+map_base,NF_POLL_FSTS_bit_sel(6)|NF_POLL_FSTS_trig_poll(1) );
+        WAIT_DONE(REG_POLL_FSTS+map_base,0x01,0x0);
+        WAIT_DONE(REG_ND_CTL+map_base,0x40,0x40);
+
+	if ( REG_READ_U32(REG_ND_DAT+map_base) & 0x01 ) {
+		NF_ERR_PRINT("[%s] write oob is not completed at page %d\n", __FUNCTION__, page);
+                up_write(&rw_sem);
+                return -1;
+        }
+
+	printk(KERN_ERR "[%s] write oob OK at page %d\n", __FUNCTION__, page);
+
+        up_write(&rw_sem);
+
+        return rc;
+}
+
+static int rtk_write_ecc_page (struct mtd_info *mtd, u16 chipnr, unsigned int page, const u_char *data_buf, const  u_char *oob_buf, const dma_addr_t *data_phy)
+{	
+	//unsigned int ppb = mtd->erasesize/mtd->writesize;
+	struct nand_chip *this = (struct nand_chip *) mtd->priv;
+	int rc = 0;
+	uint8_t	auto_trigger_mode = 1;
+	uint8_t	addr_mode = 1;
+	unsigned int page_len, dram_sa, dma_len, spare_dram_sa;
+	//unsigned char oob_1stB,oob_2ndB=0;
+	unsigned int chip_section = 0;
+	unsigned int section = 0;
+	unsigned int index = 0;
+
+        syncPageRead();
+
+	down_write(&rw_sem);
+
+        if(((uintptr_t)data_buf&0x7)!=0)
+        {
+                NF_ERR_PRINT("[%s]data_buf must 8 byte alignmemt!!\n",__FUNCTION__);
+                BUG();
+        }
+
+        if(((uintptr_t)oob_buf&0x7)!=0)
+        {
+                NF_ERR_PRINT("[%s]oob_buf must 8 byte alignmemt!!\n",__FUNCTION__);
+                BUG();
+        }
+
+#if 0
+	if ( page == ppb || page == ppb+1|| page == ppb*2 || page == ppb*2+1 )
+		oob_1stB = BBT_TAG >> 8;
+	else if(( page>=g_BootcodeSize/page_size )&&(page<(g_BootcodeSize+g_Factory_param_size)/page_size))
+		oob_1stB = TAG_FACTORY_PARAM;
+	else
+		oob_1stB = 0xFF;
+
+	if (oob_buf) {
+		if ((*(unsigned char*)(((unsigned char*)oob_buf)+2) == 0xbe) && (*(unsigned char*)(((unsigned char*)oob_buf)+3) == 0xef)) {
+			oob_1stB = *(unsigned char*)(((unsigned char*)oob_buf)+0);
+			oob_2ndB = *(unsigned char*)(((unsigned char*)oob_buf)+1);
+		}
+	}
+
+	this->g_oobbuf[0x0] = oob_1stB;
+	this->g_oobbuf[0x10] = oob_1stB;
+	this->g_oobbuf[0x20] = oob_1stB;
+	this->g_oobbuf[0x30] = oob_1stB;
+
+    	this->g_oobbuf[0x8] = oob_1stB;
+	this->g_oobbuf[0x18] = oob_1stB;
+	this->g_oobbuf[0x28] = oob_1stB;
+	this->g_oobbuf[0x38] = oob_1stB;
+
+	if(oob_size > 0x40){       //MLC oob size > 64 bytes
+		this->g_oobbuf[0x40] = oob_1stB;
+		this->g_oobbuf[0x50] = oob_1stB;
+		this->g_oobbuf[0x60] = oob_1stB;
+		this->g_oobbuf[0x70] = oob_1stB;
+
+		this->g_oobbuf[0x48] = oob_1stB;
+		this->g_oobbuf[0x58] = oob_1stB;
+		this->g_oobbuf[0x68] = oob_1stB;
+		this->g_oobbuf[0x78] = oob_1stB;
+	}
+
+	if (oob_buf) {
+		if ((*(unsigned char*)(((unsigned char*)oob_buf)+2) == 0xbe) && (*(unsigned char*)(((unsigned char*)oob_buf)+3) == 0xef)) {  
+			this->g_oobbuf[0x1] = oob_2ndB;
+			this->g_oobbuf[0x11] = oob_2ndB;
+			this->g_oobbuf[0x21] = oob_2ndB;
+			this->g_oobbuf[0x31] = oob_2ndB;
+		}
+	}
+#endif
+
+	REG_WRITE_U32(REG_DATA_TL0+map_base,NF_DATA_TL0_length0(0));
+ 	if(this->ecc_select >= 0x18)
+	{
+		// enable randomizer
+		REG_WRITE_U32(REG_RMZ_CTRL+map_base, 1);
+                REG_WRITE_U32(REG_RMZ_SEED_H+map_base, ((page+1) & 0xff00)>>8);
+                REG_WRITE_U32(REG_RMZ_SEED_L+map_base, (page+1) & 0xff);
+		page_len = page_size >> 10;
+		REG_WRITE_U32(REG_DATA_TL1+map_base,NF_DATA_TL1_length1(4));
+	}
+	else
+	{
+		// set random write
+		REG_WRITE_U32(REG_RND_EN+map_base, 1);
+		REG_WRITE_U32(REG_RND_CMD1+map_base, 0x85);
+		REG_WRITE_U32(REG_RND_DATA_STR_COL_H+map_base, 0);	// data start address MSB (always 0)
+		REG_WRITE_U32(REG_RND_SPR_STR_COL_H+map_base, page_size >> 8);	// spare start address MSB
+		REG_WRITE_U32(REG_RND_SPR_STR_COL_L+map_base, page_size & 0xff);	// spare start address LSB
+		page_len = page_size >> 9;
+		REG_WRITE_U32(REG_DATA_TL1+map_base,NF_DATA_TL1_length1(2));
+	}
+
+	REG_WRITE_U32( REG_PAGE_LEN+map_base,NF_PAGE_LEN_page_len(page_len));
+
+	//Set PP
+	REG_WRITE_U32(REG_READ_BY_PP+map_base,NF_READ_BY_PP_read_by_pp(0));//add by alexchang 0208-2010
+	REG_WRITE_U32(REG_PP_CTL1+map_base,NF_PP_CTL1_pp_start_addr(0));//add by alexchang 0208-2010
+	REG_WRITE_U32(REG_PP_CTL0+map_base,0);//add by alexchang 0208-2010
+
+	//Set command
+ 	REG_WRITE_U32(REG_ND_CMD+map_base,NF_ND_CMD_cmd(CMD_PG_WRITE_C1));
+	REG_WRITE_U32(REG_CMD2+map_base,NF_CMD2_cmd2(CMD_PG_WRITE_C2));
+	REG_WRITE_U32(REG_CMD3+map_base,NF_CMD3_cmd3(CMD_PG_WRITE_C3));
+
+	//Set address
+	REG_WRITE_U32( REG_ND_PA0+map_base,NF_ND_PA0_page_addr0(page));
+	REG_WRITE_U32( REG_ND_PA1+map_base,NF_ND_PA1_page_addr1(page>>8));
+	REG_WRITE_U32( REG_ND_PA2+map_base,NF_ND_PA2_addr_mode(addr_mode)|NF_ND_PA2_page_addr2(page>>16));
+	REG_WRITE_U32( REG_ND_PA3+map_base,NF_ND_PA3_page_addr3((page>>21)&0x7));
+	REG_WRITE_U32(REG_ND_CA0+map_base, 0);
+	REG_WRITE_U32(REG_ND_CA1+map_base, 0);
+
+	//Set ECC
+	REG_WRITE_U32(REG_MULTI_CHNL_MODE+map_base,NF_MULTI_CHNL_MODE_edo(1));//add by alexchang0205-2010
+	REG_WRITE_U32( REG_ECC_STOP+map_base,NF_ECC_STOP_ecc_n_stop(0x01));
+
+	REG_WRITE_U32(REG_ECC_SEL+map_base, this->ecc_select);
+
+	dram_sa = ( (uintptr_t)data_phy >> 3);
+	REG_WRITE_U32(REG_DMA_CTL1+map_base,NF_DMA_CTL1_dram_sa(dram_sa));
+	dma_len = page_size >> 9;
+	REG_WRITE_U32(REG_DMA_CTL2+map_base,NF_DMA_CTL2_dma_len(dma_len));
+
+	spare_dram_sa = ( (uintptr_t)oobPhys_addr >> 3);
+	REG_WRITE_U32(REG_SPR_DDR_CTL+map_base,0x60000000|NF_SPR_DDR_CTL_spare_dram_sa(spare_dram_sa));
+	REG_WRITE_U32(REG_DMA_CTL3+map_base,NF_DMA_CTL3_ddr_wr(0)|NF_DMA_CTL3_dma_xfer(1));
+    
+	syncPageRead();
+
+	REG_WRITE_U32( REG_AUTO_TRIG+map_base,NF_AUTO_TRIG_auto_trig(1)|NF_AUTO_TRIG_spec_auto_case(0)| NF_AUTO_TRIG_auto_case(auto_trigger_mode));
+	smp_wmb();
+
+	if(WAIT_DONE(REG_AUTO_TRIG+map_base,0x80,0)) {
+		NF_ERR_PRINT("[%s] WAIT_DONE timeout. (%d)\n", __FUNCTION__, __LINE__);
+                up_write(&rw_sem);
+                return -WAIT_TIMEOUT;
+	}
+	if(WAIT_DONE(REG_DMA_CTL3+map_base,0x01,0)) {
+		NF_ERR_PRINT("[%s] WAIT_DONE timeout. (%d)\n", __FUNCTION__, __LINE__);
+                up_write(&rw_sem);
+                return -WAIT_TIMEOUT;
+	}
+	REG_WRITE_U32(REG_POLL_FSTS+map_base,NF_POLL_FSTS_bit_sel(6)|NF_POLL_FSTS_trig_poll(1) );
+	if(WAIT_DONE(REG_POLL_FSTS+map_base,0x01,0x0)) {
+		NF_ERR_PRINT("[%s] WAIT_DONE timeout. (%d)\n", __FUNCTION__, __LINE__);
+                up_write(&rw_sem);
+                return -WAIT_TIMEOUT;
+	}
+	if(WAIT_DONE(REG_ND_CTL+map_base,0x40,0x40)) {//add by alexchang 0416-2010
+		NF_ERR_PRINT("[%s] WAIT_DONE timeout. (%d)\n", __FUNCTION__, __LINE__);
+                up_write(&rw_sem);
+                return -WAIT_TIMEOUT;
+	}
+
+	if ( REG_READ_U32(REG_ND_DAT+map_base) & 0x01 ){
+		up_write(&rw_sem);
+		NF_ERR_PRINT("[%s] write is not completed at page %d\n", __FUNCTION__, page);
+		return -1;
+	}
+#if 0	
+	chip_section = (chipnr * this->page_num) >> 5;
+	section = page >> 5;
+	index = page & (32-1);
+
+	if (this->erase_page_flag)
+		this->erase_page_flag[chip_section+section] &= ~(1 << index);
+#endif
+	up_write(&rw_sem);
+	
+	return rc;
+}
+
+static int rtk_mtd_add_partitions(struct mtd_info *mtd, struct mtd_partitions *parts)
+{
+        const struct mtd_partition *real_parts = parts->parts;
+        int nbparts = parts->nr_parts;
+        int ret;
+
+	NF_DEBUG_PRINT("%s, nbparts:[%d]\n", __FUNCTION__, nbparts);
+
+        if (nbparts > 0) {
+                ret = add_mtd_partitions(mtd, real_parts, nbparts);
+		NF_DEBUG_PRINT("%s, ret:[%d]\n", __FUNCTION__, ret);
+                return ret;
+        }
+
+        return 0;
+}
+
+
+static int rtk_nand_profile (void)
+{
+	int maxchips = 4;
+	int pnum = 0;
+	struct mtd_partitions mtd_parts;
+	struct nand_chip *this = (struct nand_chip *)rtk_mtd->priv;
+	int rc = 0;
+
+	memset(&mtd_parts, 0, sizeof(mtd_parts));
+
+	this->RBA_PERCENT = RBA_PERCENT;
+
+	if (rtk_nand_scan (rtk_mtd, maxchips) < 0 || rtk_mtd->size == 0){
+		NF_ERR_PRINT("%s: Error, cannot do nand_scan(on-board)\n", __FUNCTION__);
+		return -ENODEV;
+	}
+
+	if ( !(rtk_mtd->writesize&(0x200-1)) )
+		REG_WRITE_U32( REG_PAGE_LEN+map_base,rtk_mtd->writesize >> 9);
+	else{
+		NF_ERR_PRINT("Error: pagesize is not 512B Multiple");
+		return -1;
+	}
+#ifdef RTK_TEST
+	rc = mtd_device_register(rtk_mtd, rtk_partitions, ARRAY_SIZE(rtk_partitions));
+#else
+
+#ifdef CONFIG_MTD_CMDLINE_PARTS
+	rc = parse_mtd_partitions (rtk_mtd, ptypes, &mtd_parts, 0);
+	pnum = mtd_parts.nr_parts;
+#else
+	rc = mtd_device_parse_register(rtk_mtd, ptypes, 0, &mtd_parts, 0);
+	NF_INFO_PRINT("[%s] mtd_device_parse_register rc = 0x%x\n", __FUNCTION__, rc);
+#endif
+
+    	NF_INFO_PRINT("[%s] add mtd partition. pnum:[%d]\n", __FUNCTION__, pnum);
+
+	if (pnum <= 0) {
+		NF_INFO_PRINT("RTK: using the whole nand as a partitoin\n");
+		if(add_mtd_device(rtk_mtd)) {
+			NF_ERR_PRINT("RTK: Failed to register new nand device\n");
+			return -EAGAIN;
+		}
+	}else{
+		NF_INFO_PRINT("RTK: using dynamic nand partition\n");
+		if(rtk_mtd_add_partitions(rtk_mtd, &mtd_parts)) {
+			NF_INFO_PRINT("%s: Error, cannot add %s device\n", __FUNCTION__, rtk_mtd->name);
+			rtk_mtd->size = 0;
+			return -EAGAIN;
+		}
+
+		mtd_part_parser_cleanup(&mtd_parts);
+	}
+#endif
+	return 0;
+}
+
+static void display_version (void)
+{
+	const __u8 *revision;
+	const __u8 *date;
+	char *running = (__u8 *)VERSION;
+	strsep(&running, " ");
+	strsep(&running, " ");
+	revision = strsep(&running, " ");
+	date = strsep(&running, " ");
+	printk(BANNER " Rev:%s (%s)\n", revision, date);
+}
+
+#define CTL_ENABLE  1
+#define CTL_DISABLE 0
+
+static int rtk_nand_clk_reset_ctrl(struct device *dev, int enable)
+{
+	struct reset_control *reset = reset_control_get(dev, NULL);
+	struct clk *clk = clk_get(dev, NULL);
+
+	if(enable == CTL_ENABLE){
+		reset_control_deassert(reset);
+        	clk_prepare_enable(clk);
+    	}else{
+        	clk_disable_unprepare(clk);
+    	}
+
+    	clk_put(clk);
+    	reset_control_put(reset);
+
+	return 0;
+}
+
+static void rtk_nand_gating(void)
+{
+	REG_WRITE_U32(0x168+map_base, REG_READ_U32(0x168+map_base) | (0x1));
+	REG_WRITE_U32(0x168+map_base, REG_READ_U32(0x168+map_base) | (0x1 << 1));
+
+	REG_WRITE_U32(0x314+map_base, REG_READ_U32(0x314+map_base) | (0x1));
+	REG_WRITE_U32(0x314+map_base, REG_READ_U32(0x314+map_base) | (0x1 << 1));
+
+	//REG_WRITE_U32(0xf168+map_base, REG_READ_U32(0xf168+map_base) | (0x1));
+	//REG_WRITE_U32(0xf168+map_base, REG_READ_U32(0xf168+map_base) | (0x1 << 1));
+
+	//REG_WRITE_U32(0xf314+map_base, REG_READ_U32(0xf314+map_base) | (0x1));
+	//REG_WRITE_U32(0xf314+map_base, REG_READ_U32(0xf314+map_base) | (0x1 << 1));
+
+	REG_WRITE_U32(0x13c+map_base, REG_READ_U32(0x13c+map_base) | (0x1 << 3));
+	REG_WRITE_U32(0x13c+map_base, REG_READ_U32(0x13c+map_base) | (0x1 << 4));
+
+	REG_WRITE_U32(0x310+map_base, REG_READ_U32(0x310+map_base) | (0x1 << 5));
+	REG_WRITE_U32(0x310+map_base, REG_READ_U32(0x310+map_base) | (0x1 << 6));
+
+	//REG_WRITE_U32(0xf13c+map_base, REG_READ_U32(0xf13c+map_base) | (0x1 << 3));
+	//REG_WRITE_U32(0xf13c+map_base, REG_READ_U32(0xf13c+map_base) | (0x1 << 4));
+
+	//REG_WRITE_U32(0xf310+map_base, REG_READ_U32(0xf310+map_base) | (0x1 << 5));
+	//REG_WRITE_U32(0xf310+map_base, REG_READ_U32(0xf310+map_base) | (0x1 << 6));
+
+	REG_WRITE_U32(0x318+map_base, REG_READ_U32(0x318+map_base) | (0x1));
+
+}
+
+static int rtk_read_proc_nandinfo(struct seq_file *m, void *v) 
+{
+	struct nand_chip *this = (struct nand_chip *) rtk_mtd->priv;
+	int i;
+
+	seq_printf(m, "nand_size:%u\n", (uint32_t)this->device_size);
+	seq_printf(m, "chip_size:%u\n", (uint32_t)this->chipsize);
+	seq_printf(m, "block_size:%u\n", rtk_mtd->erasesize);
+	seq_printf(m, "page_size:%u\n", rtk_mtd->writesize);
+	seq_printf(m, "oob_size:%u\n", rtk_mtd->oobsize);
+	seq_printf(m, "ppb:%u\n", rtk_mtd->erasesize/rtk_mtd->writesize);
+	seq_printf(m, "RBA:%u\n", this->RBA);
+	seq_printf(m, "BBs:%u\n", this->BBs);
+	seq_printf(m, "ecc bits:%u\n", g_eccbits);
+	seq_printf(m, "\n");
+#ifdef RTK_NAND_SHIFTABLE
+        seq_printf(m, "Shift block table:\n");
+	for ( i=0; i<STBCOUNT; i++){
+                if ( i==0 && this->sbt[i].chipnum == SB_INIT){
+                        seq_printf(m, "Congratulation!! No shift block in this Nand.\n");
+                        break;
+                }
+
+                if ( this->sbt[i].block != SB_INIT ){
+                        seq_printf(m, "[%d] (%d, %d, %d)\n", i, this->sbt[i].chipnum, this->sbt[i].block, this->sbt[i].shift);
+                }
+        }
+        seq_printf(m, "\n");
+#endif
+        seq_printf(m, "Bad block table:\n");
+	for ( i=0; i<this->RBA; i++){
+                if ( i==0 && this->bbt[i].BB_die == BB_DIE_INIT && this->bbt[i].bad_block == BB_INIT ){
+                        seq_printf(m, "Congratulation!! No bad block in this Nand.\n");
+                        break;
+                }
+
+                if ( this->bbt[i].bad_block != BB_INIT ){
+                        seq_printf(m, "[%d] (%d, %u(0x%x), %d, %u(0x%x))\n",
+                                        i,
+                                        this->bbt[i].BB_die,
+                                        this->bbt[i].bad_block, this->bbt[i].bad_block * 131072,
+                                        this->bbt[i].RB_die,
+                                        this->bbt[i].remap_block, this->bbt[i].remap_block * 131072);
+                }
+        }
+        seq_printf(m, "\n");
+
+	return 0;
+}
+
+static int rtk_nand_proc_open(struct inode *inode, struct  file *file) {
+	return single_open(file, rtk_read_proc_nandinfo, NULL);
+}
+
+static const struct file_operations info_proc_fops = {
+	.owner = THIS_MODULE,
+	.open = rtk_nand_proc_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#ifdef RTK_VERIFY
+static int test_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "EX.\n");
+	seq_printf(s, "echo read > /proc/rtknand/test  --->  simulate read page ecc error.\n");
+	seq_printf(s, "echo write > /proc/rtknand/test  --->  simulate write page ecc error.\n");
+	seq_printf(s, "echo \"nomap 1234\" > /proc/rtknand/test  --->  set 1234 block as no map block.\n");
+	seq_printf(s, "\n");
+        seq_printf(s, "r_test_flag :[%u]\n", r_test_flag);
+        seq_printf(s, "w_test_flag :[%u]\n", w_test_flag);
+        seq_printf(s, "nomap_blk   :[%u]\n", nomap_blk);
+	seq_printf(s, "\n");
+
+        return 0;
+}
+
+static int test_proc_open(struct inode *inode, struct file *file)
+{
+        return (single_open(file, test_read, NULL));
+}
+
+extern void write_oob_test(void);
+static int test_write(struct file *filp, const char *buff, unsigned long len, void *data)
+{
+        char tmpbuf[64] = {0};
+        unsigned int num = 0;
+
+        if (buff && !copy_from_user(tmpbuf, buff, len)) {
+                tmpbuf[len - 1] = '\0';
+
+		if(strstr(tmpbuf, "nomap") != NULL) {
+			num = sscanf(tmpbuf,"nomap %u", &nomap_blk);
+			printk(KERN_ERR "nomap block:[%u]\n", nomap_blk);
+		}
+		else if(strstr(tmpbuf, "read") != NULL) {
+			r_test_flag = 1;
+		}
+		else if(strstr(tmpbuf, "write") != NULL) {
+			w_test_flag = 1;
+		}
+		else if(strstr(tmpbuf, "timeout") != NULL) {
+			w_wait_flag = 1;
+		}
+        }
+
+        return len;
+}
+
+static ssize_t test_proc_write(struct file *file, const char __user *userbuf, size_t count, loff_t *off)
+{
+        return test_write(file, userbuf, count, off);
+}
+
+static struct file_operations test_proc_fops = {
+        .open = test_proc_open,
+        .write = test_proc_write,
+        .read = seq_read,
+        .llseek = seq_lseek,
+        .release = single_release,
+};
+#endif
+
+static void rtknand_proc_init(void)
+{
+        rtknand_proc_dir = proc_mkdir(RTKNAND_PROC_DIR_NAME, &proc_root);
+        if (rtknand_proc_dir) {
+                proc_create_data("info", 0, rtknand_proc_dir, &info_proc_fops, NULL);
+#ifdef RTK_VERIFY
+                proc_create_data("test", 0, rtknand_proc_dir, &test_proc_fops, NULL);
+#endif
+        }
+}
+
+static int rtk_nand_probe(struct platform_device *pdev)
+{
+	int rc = 0;
+	struct nand_chip *this = NULL;
+	struct device_node *rtk129x_nand_node;
+	rtk129x_nand_node = pdev->dev.of_node;
+
+	init_rwsem(&rw_sem);
+
+	map_base = of_iomap(rtk129x_nand_node, 0);
+	swc_base = of_iomap(rtk129x_nand_node, 1);
+
+    	rtk_nand_clk_reset_ctrl(&pdev->dev, CTL_ENABLE);
+
+	rtk_nand_gating();
+
+	// controller init.
+	REG_WRITE_U32(REG_PD + map_base, 0x1E);
+    	REG_WRITE_U32(REG_TIME_PARA3 + map_base, 0x2);
+	REG_WRITE_U32(REG_TIME_PARA2 + map_base, 0x5);
+	REG_WRITE_U32(REG_TIME_PARA1 + map_base, 0x2);
+
+	REG_WRITE_U32(REG_MULTI_CHNL_MODE+map_base, 0x0);
+	REG_WRITE_U32(REG_READ_BY_PP+map_base, 0x0);
+	
+	// reset nand.
+	REG_WRITE_U32(REG_ND_CMD+map_base, 0xff);
+	REG_WRITE_U32(REG_ND_CTL+map_base, 0x80);
+
+	rc = WAIT_DONE(REG_ND_CTL+map_base,0x80,0);
+	rc = WAIT_DONE(REG_ND_CTL+map_base,0x40,0x40);
+	NF_DEBUG_PRINT("nand ready. \n");
+
+	REG_WRITE_U32(REG_NF_LOW_PWR+map_base, REG_READ_U32(REG_NF_LOW_PWR+map_base)&~0x10);
+	display_version();
+
+	REG_WRITE_U32(REG_SPR_DDR_CTL+map_base, NF_SPR_DDR_CTL_spare_ddr_ena(1) | NF_SPR_DDR_CTL_per_2k_spr_ena(1)| NF_SPR_DDR_CTL_spare_dram_sa(0)); //set spare2ddr func. 4=>0.5k spe2ddr_ena at A000F000
+	rtk_mtd = kmalloc (MTDSIZE, GFP_KERNEL);
+	if ( !rtk_mtd ){
+		NF_ERR_PRINT("%s: Error, no enough memory for rtk_mtd\n", __FUNCTION__);
+		rc = -ENOMEM;
+		goto EXIT;
+	}
+	memset ( (char *)rtk_mtd, 0, MTDSIZE);
+	rtk_mtd->priv = this = (struct nand_chip *)(rtk_mtd+1);
+
+	this->read_id		= rtk_nand_read_id;
+	this->read_ecc_page 	= rtk_read_ecc_page;
+	this->read_oob 		= NULL; //rtk_read_oob;
+	this->write_ecc_page	= rtk_write_ecc_page;
+	this->write_oob		= rtk_write_oob;
+	this->erase_block 	= rtk_erase_block;
+	//this->suspend		= rtk_nand_suspend;
+	//this->resume		= rtk_nand_resume;
+	this->sync		= NULL;
+
+	if( rtk_nand_profile() < 0 ){
+		rc = -1;
+		goto EXIT;
+	}
+
+	page_size = rtk_mtd->writesize;
+	oob_size = rtk_mtd->oobsize;
+	ppb = (rtk_mtd->erasesize)/(rtk_mtd->writesize);
+
+	rtknand_proc_init();
+EXIT:
+	if (rc < 0) {
+		if (rtk_mtd) {
+#if 0
+			if (this->erase_page_flag) {
+				unsigned int flag_size =  (this->numchips * this->page_num) >> 3;
+				unsigned int mempage_order = get_order(flag_size);
+				free_pages((unsigned long)this->erase_page_flag, mempage_order);
+			}
+#endif
+			kfree(rtk_mtd);
+		}
+	} else {
+		NF_INIT_PRINT("Realtek Nand Flash Driver is successfully installing.\n");
+	}
+
+	return rc;
+}
+
+static int rtk_nand_remove(struct platform_device *dev)
+{
+	struct nand_chip *this = NULL;
+
+	if (rtk_mtd){
+		//del_mtd_partitions (rtk_mtd);
+		this = (struct nand_chip *)rtk_mtd->priv;
+		if (this->g_databuf)
+			kfree(this->g_databuf);
+		if(this->g_oobbuf)
+			kfree(this->g_oobbuf);
+#if 0
+		if (this->erase_page_flag){
+			unsigned int flag_size =  (this->numchips * this->page_num) >> 3;
+			unsigned int mempage_order = get_order(flag_size);
+			free_pages((unsigned long)this->erase_page_flag, mempage_order);
+		}
+#endif
+		kfree(rtk_mtd);
+
+	}
+
+	return 0;
+}
+
+static struct of_device_id rtk129x_nand_ids[] = {
+	{ .compatible = "Realtek,rtk1395-nand" },
+	{ .compatible = "Realtek,rtk1295-nand" },
+	{ .compatible = "Realtek,rtk1195-nand" },
+	{ /* Sentinel */ },
+};
+
+static const struct dev_pm_ops rtk_nand_dev_pm_ops = {
+        SET_SYSTEM_SLEEP_PM_OPS(rtk_nand_suspend, rtk_nand_resume)
+};
+
+static struct platform_driver rtk_nand_driver = {
+	.probe      = rtk_nand_probe,
+	.remove     = rtk_nand_remove,
+	.driver     = {
+		.name = "rtk_nand_driver",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk129x_nand_ids,
+		.pm     = &rtk_nand_dev_pm_ops,
+	},
+};
+
+module_platform_driver(rtk_nand_driver);
+
+static int __init rtk_nand_info_setup(char *line)
+{
+	strlcpy(g_rtk_nandinfo_line, line, sizeof(g_rtk_nandinfo_line));
+
+	return 1;
+}
+__setup("nandinfo=", rtk_nand_info_setup);
+
+MODULE_AUTHOR("AlexChang <alexchang2131@realtek.com>");
+MODULE_DESCRIPTION("Realtek NAND Flash Controller Driver");
diff --git a/drivers/mtd/ubi/build.c b/drivers/mtd/ubi/build.c
index ad2b57c..541c179 100644
--- a/drivers/mtd/ubi/build.c
+++ b/drivers/mtd/ubi/build.c
@@ -1403,7 +1403,7 @@ static int __init bytes_str_to_int(const char *str)
  * This function returns zero in case of success and a negative error code in
  * case of error.
  */
-static int __init ubi_mtd_param_parse(const char *val, struct kernel_param *kp)
+static int __init ubi_mtd_param_parse(const char *val, const struct kernel_param *kp)
 {
 	int i, len;
 	struct mtd_dev_param *p;
diff --git a/drivers/net/ethernet/realtek/Kconfig b/drivers/net/ethernet/realtek/Kconfig
index 7c69f4c..fc6fff5 100644
--- a/drivers/net/ethernet/realtek/Kconfig
+++ b/drivers/net/ethernet/realtek/Kconfig
@@ -5,7 +5,7 @@
 config NET_VENDOR_REALTEK
 	bool "Realtek devices"
 	default y
-	depends on PCI || (PARPORT && X86)
+#	depends on PCI || (PARPORT && X86)
 	---help---
 	  If you have a network (Ethernet) card belonging to this class, say Y.
 
@@ -94,6 +94,31 @@ config 8139_OLD_RX_RESET
 	  experience problems, you can enable this option to restore the
 	  old RX-reset behavior.  If unsure, say N.
 
+
+config R8168
+	tristate "Realtek 8168 gigabit ethernet support"
+	depends on PCI
+	select FW_LOADER
+	select CRC32
+	select MII
+	---help---
+	  Say Y here if you have a Realtek 8168 PCI Gigabit Ethernet adapter.
+
+	  To compile this driver as a module, choose M here: the module
+	  will be called r8168.  This is recommended.
+
+config R8125
+	tristate "Realtek 8125 gigabit ethernet support"
+	depends on PCI
+	select FW_LOADER
+	select CRC32
+	select MII
+	---help---
+	  Say Y here if you have a Realtek 8125 PCI Gigabit Ethernet adapter.
+
+	  To compile this driver as a module, choose M here: the module
+	  will be called r8125.  This is recommended.
+
 config R8169
 	tristate "Realtek 8169 gigabit ethernet support"
 	depends on PCI
@@ -106,4 +131,25 @@ config R8169
 	  To compile this driver as a module, choose M here: the module
 	  will be called r8169.  This is recommended.
 
+config R8169SOC
+	tristate "Realtek 8169SoC gigabit ethernet support"
+	depends on RTK_PLATFORM
+	select FW_LOADER
+	select CRC32
+	select MII
+	---help---
+	  Say Y here if you have a Realtek 8169 SoC for RTK Gigabit Ethernet adapter.
+
+	  To compile this driver as a module, choose M here: the module
+	  will be called r8169.  This is recommended.
+
+config RTL_RX_NO_COPY
+	bool "Support to receive packets without memory copy"
+	default n
+	depends on R8169SOC
+	---help---
+	  This is a feature of Realtek 8169SoC gigabit ethernet driver.
+	  Say Y here to impove performance and reduce CPU loading.
+	  Say N here to save memory for packet buffers.
+
 endif # NET_VENDOR_REALTEK
diff --git a/drivers/net/ethernet/realtek/Makefile b/drivers/net/ethernet/realtek/Makefile
index 71b1da3..e274623 100644
--- a/drivers/net/ethernet/realtek/Makefile
+++ b/drivers/net/ethernet/realtek/Makefile
@@ -6,3 +6,10 @@ obj-$(CONFIG_8139CP) += 8139cp.o
 obj-$(CONFIG_8139TOO) += 8139too.o
 obj-$(CONFIG_ATP) += atp.o
 obj-$(CONFIG_R8169) += r8169.o
+obj-$(CONFIG_R8168) += r8168/
+obj-$(CONFIG_R8125) += r8125/
+ifeq ($(CONFIG_ARCH_RTD119X),y)
+obj-$(CONFIG_R8169SOC) += r8169soc_rtd119x.o
+else
+obj-$(CONFIG_R8169SOC) += r8169soc.o
+endif
diff --git a/drivers/net/ethernet/realtek/r8125/Makefile b/drivers/net/ethernet/realtek/r8125/Makefile
new file mode 100644
index 00000000..e392b83
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8125/Makefile
@@ -0,0 +1,156 @@
+################################################################################
+#
+# r8125 is the Linux device driver released for Realtek 2.5Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+
+################################################################################
+#  This product is covered by one or more of the following patents:
+#  US6,570,884, US6,115,776, and US6,327,625.
+################################################################################
+
+CONFIG_SOC_LAN = n
+ENABLE_REALWOW_SUPPORT = n
+ENABLE_DASH_SUPPORT = n
+ENABLE_DASH_PRINTER_SUPPORT = n
+CONFIG_DOWN_SPEED_100 = n
+CONFIG_ASPM = y
+ENABLE_S5WOL = y
+ENABLE_S5_KEEP_CURR_MAC = n
+ENABLE_EEE = n
+ENABLE_S0_MAGIC_PACKET = n
+
+ifneq ($(KERNELRELEASE),)
+	obj-$(CONFIG_R8125) := r8125.o
+	r8125-objs := r8125_n.o rtl_eeprom.o rtltool.o
+	ifeq ($(CONFIG_SOC_LAN), y)
+		EXTRA_CFLAGS += -DCONFIG_SOC_LAN
+	endif
+	ifeq ($(ENABLE_REALWOW_SUPPORT), y)
+	    r8125-objs += r8125_realwow.o
+		EXTRA_CFLAGS += -DENABLE_REALWOW_SUPPORT
+	endif
+	ifeq ($(ENABLE_DASH_SUPPORT), y)
+	    r8125-objs += r8125_dash.o
+		EXTRA_CFLAGS += -DENABLE_DASH_SUPPORT
+	endif
+	ifeq ($(ENABLE_DASH_PRINTER_SUPPORT), y)
+	    r8125-objs += r8125_dash.o
+		EXTRA_CFLAGS += -DENABLE_DASH_SUPPORT -DENABLE_DASH_PRINTER_SUPPORT
+	endif
+	EXTRA_CFLAGS += -DCONFIG_R8125_NAPI
+	EXTRA_CFLAGS += -DCONFIG_R8125_VLAN
+	ifeq ($(CONFIG_DOWN_SPEED_100), y)
+		EXTRA_CFLAGS += -DCONFIG_DOWN_SPEED_100
+	endif
+	ifeq ($(CONFIG_ASPM), y)
+		EXTRA_CFLAGS += -DCONFIG_ASPM
+	endif
+	ifeq ($(ENABLE_S5WOL), y)
+		EXTRA_CFLAGS += -DENABLE_S5WOL
+	endif
+	ifeq ($(ENABLE_S5_KEEP_CURR_MAC), y)
+		EXTRA_CFLAGS += -DENABLE_S5_KEEP_CURR_MAC
+	endif
+	ifeq ($(ENABLE_EEE), y)
+		EXTRA_CFLAGS += -DENABLE_EEE
+	endif
+	ifeq ($(ENABLE_S0_MAGIC_PACKET), y)
+		EXTRA_CFLAGS += -DENABLE_S0_MAGIC_PACKET
+	endif
+else
+	BASEDIR := /lib/modules/$(shell uname -r)
+	KERNELDIR ?= $(BASEDIR)/build
+	PWD :=$(shell pwd)
+	DRIVERDIR := $(shell find $(BASEDIR)/kernel/drivers/net/ethernet -name realtek -type d)
+	ifeq ($(DRIVERDIR),)
+		DRIVERDIR := $(shell find $(BASEDIR)/kernel/drivers/net -name realtek -type d)
+	endif
+	ifeq ($(DRIVERDIR),)
+		DRIVERDIR := $(BASEDIR)/kernel/drivers/net
+	endif
+	RTKDIR := $(subst $(BASEDIR)/,,$(DRIVERDIR))
+
+	KERNEL_GCC_VERSION := $(shell cat /proc/version | sed -n 's/.*gcc version \([[:digit:]]\.[[:digit:]]\.[[:digit:]]\).*/\1/p')
+	CCVERSION = $(shell $(CC) -dumpversion)
+
+	KVER = $(shell uname -r)
+	KMAJ = $(shell echo $(KVER) | \
+	sed -e 's/^\([0-9][0-9]*\)\.[0-9][0-9]*\.[0-9][0-9]*.*/\1/')
+	KMIN = $(shell echo $(KVER) | \
+	sed -e 's/^[0-9][0-9]*\.\([0-9][0-9]*\)\.[0-9][0-9]*.*/\1/')
+	KREV = $(shell echo $(KVER) | \
+	sed -e 's/^[0-9][0-9]*\.[0-9][0-9]*\.\([0-9][0-9]*\).*/\1/')
+
+	kver_ge = $(shell \
+	echo test | awk '{if($(KMAJ) < $(1)) {print 0} else { \
+	if($(KMAJ) > $(1)) {print 1} else { \
+	if($(KMIN) < $(2)) {print 0} else { \
+	if($(KMIN) > $(2)) {print 1} else { \
+	if($(KREV) < $(3)) {print 0} else { print 1 } \
+	}}}}}' \
+	)
+
+.PHONY: all
+all: print_vars clean modules install
+
+print_vars:
+	@echo
+	@echo "CC: " $(CC)
+	@echo "CCVERSION: " $(CCVERSION)
+	@echo "KERNEL_GCC_VERSION: " $(KERNEL_GCC_VERSION)
+	@echo "KVER: " $(KVER)
+	@echo "KMAJ: " $(KMAJ)
+	@echo "KMIN: " $(KMIN)
+	@echo "KREV: " $(KREV)
+	@echo "BASEDIR: " $(BASEDIR)
+	@echo "DRIVERDIR: " $(DRIVERDIR)
+	@echo "PWD: " $(PWD)
+	@echo "RTKDIR: " $(RTKDIR)
+	@echo
+
+.PHONY:modules
+modules:
+#ifeq ($(call kver_ge,5,0,0),1)
+	$(MAKE) -C $(KERNELDIR) M=$(PWD) modules
+#else
+#	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) modules
+#endif
+
+.PHONY:clean
+clean:
+#ifeq ($(call kver_ge,5,0,0),1)
+	$(MAKE) -C $(KERNELDIR) M=$(PWD) clean
+#else
+#	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) clean
+#endif
+
+.PHONY:install
+install:
+#ifeq ($(call kver_ge,5,0,0),1)
+	$(MAKE) -C $(KERNELDIR) M=$(PWD) INSTALL_MOD_DIR=$(RTKDIR) modules_install
+#else
+#	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) INSTALL_MOD_DIR=$(RTKDIR) modules_install
+#endif
+
+endif
diff --git a/drivers/net/ethernet/realtek/r8125/Makefile_linux24x b/drivers/net/ethernet/realtek/r8125/Makefile_linux24x
new file mode 100644
index 00000000..c15e49c
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8125/Makefile_linux24x
@@ -0,0 +1,74 @@
+################################################################################
+#
+# r8125 is the Linux device driver released for Realtek 2.5Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+
+################################################################################
+# This product is covered by one or more of the following patents:
+# US6,570,884, US6,115,776, and US6,327,625.
+################################################################################
+
+CC		:= gcc
+LD		:= ld
+ARCH		:= $(shell uname -m | sed 's/i.86/i386/')
+KSRC		:= /lib/modules/$(shell uname -r)/build
+CONFIG_FILE	:= $(KSRC)/include/linux/autoconf.h
+KMISC		:= /lib/modules/$(shell uname -r)/kernel/drivers/net/
+
+
+ifeq ($(ARCH),x86_64)
+   MODCFLAGS	+= -mcmodel=kernel -mno-red-zone
+endif
+
+#standard flags for module builds
+MODCFLAGS	+= -DLINUX -D__KERNEL__ -DMODULE -O2 -pipe -Wall
+MODCFLAGS	+= -I$(KSRC)/include -I.
+MODCFLAGS	+= -DMODVERSIONS -DEXPORT_SYMTAB -include $(KSRC)/include/linux/modversions.h
+SOURCE		:= r8125_n.c rtl_eeprom.c rtltool.c
+OBJS		:= $(SOURCE:.c=.o)
+
+
+SMP		:= $(shell $(CC) $(MODCFLAGS) -E -dM $(CONFIG_FILE) | \
+   grep CONFIG_SMP | awk '{print $$3}')
+
+ifneq ($(SMP),1)
+   SMP		:= 0
+endif
+
+ifeq ($(SMP),1)
+   MODCFLAGS	+= -D__SMP__
+endif
+
+modules: $(OBJS)
+	$(LD) -r $^ -o r8125.o
+	strip --strip-debug r8125.o
+
+%.o: %.c
+	$(CC) $(MODCFLAGS) -c $< -o $@
+
+clean:
+	rm *.o -f
+
+install:
+	install -m 744 -c r8125.o $(KMISC)
diff --git a/drivers/net/ethernet/realtek/r8125/r8125.h b/drivers/net/ethernet/realtek/r8125/r8125.h
new file mode 100644
index 00000000..520cb45
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8125/r8125.h
@@ -0,0 +1,1800 @@
+/*
+################################################################################
+#
+# r8125 is the Linux device driver released for Realtek 2.5Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#include <linux/ethtool.h>
+#include "r8125_dash.h"
+#include "r8125_realwow.h"
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+#define skb_transport_offset(skb) (skb->h.raw - skb->data)
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,26)
+#define device_set_wakeup_enable(dev, val)	do {} while (0)
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,14,0)
+static inline void ether_addr_copy(u8 *dst, const u8 *src)
+{
+        u16 *a = (u16 *)dst;
+        const u16 *b = (const u16 *)src;
+
+        a[0] = b[0];
+        a[1] = b[1];
+        a[2] = b[2];
+}
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,15,0)
+#define IS_ERR_OR_NULL(ptr)			(!ptr)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,13,0)
+#define reinit_completion(x)			((x)->done = 0)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,39)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,32)
+#define pm_runtime_mark_last_busy(x)
+#define pm_runtime_put_autosuspend(x)		pm_runtime_put(x)
+#define pm_runtime_put_sync_autosuspend(x)	pm_runtime_put_sync(x)
+
+static inline bool pm_runtime_suspended(struct device *dev)
+{
+        return dev->power.runtime_status == RPM_SUSPENDED
+               && !dev->power.disable_depth;
+}
+
+static inline bool pm_runtime_active(struct device *dev)
+{
+        return dev->power.runtime_status == RPM_ACTIVE
+               || dev->power.disable_depth;
+}
+#endif
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,36)
+#define queue_delayed_work(long_wq, work, delay)	schedule_delayed_work(work, delay)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,34)
+#define netif_printk(priv, type, level, netdev, fmt, args...)	\
+	do {								\
+		if (netif_msg_##type(priv))				\
+			printk(level "%s: " fmt,(netdev)->name , ##args); \
+	} while (0)
+
+#define netif_emerg(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_EMERG, netdev, fmt, ##args)
+#define netif_alert(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_ALERT, netdev, fmt, ##args)
+#define netif_crit(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_CRIT, netdev, fmt, ##args)
+#define netif_err(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_ERR, netdev, fmt, ##args)
+#define netif_warn(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_WARNING, netdev, fmt, ##args)
+#define netif_notice(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_NOTICE, netdev, fmt, ##args)
+#define netif_info(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_INFO, (netdev), fmt, ##args)
+#endif
+#endif
+#endif
+#endif
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,15)
+#define setup_timer(_timer, _function, _data) \
+do { \
+	(_timer)->function = _function; \
+	(_timer)->data = _data; \
+	init_timer(_timer); \
+} while (0)
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,15)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,0,0)
+#if defined(skb_vlan_tag_present) && !defined(vlan_tx_tag_present)
+#define vlan_tx_tag_present skb_vlan_tag_present
+#endif
+#if defined(skb_vlan_tag_get) && !defined(vlan_tx_tag_get)
+#define vlan_tx_tag_get skb_vlan_tag_get
+#endif
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(4,0,0)
+
+#define RTL_ALLOC_SKB_INTR(tp, length) dev_alloc_skb(length)
+#ifdef CONFIG_R8125_NAPI
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,19,0)
+#undef RTL_ALLOC_SKB_INTR
+#define RTL_ALLOC_SKB_INTR(tp, length) napi_alloc_skb(&tp->napi, length)
+#endif
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,0,0)
+#define netdev_features_t  u32
+#endif
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,5,0)
+#define NETIF_F_ALL_CSUM        NETIF_F_CSUM_MASK
+#else
+#ifndef NETIF_F_ALL_CSUM
+#define NETIF_F_ALL_CSUM        NETIF_F_CSUM_MASK
+#endif
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,37)
+#define ENABLE_R8125_PROCFS
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+#define NETIF_F_HW_VLAN_RX	NETIF_F_HW_VLAN_CTAG_RX
+#define NETIF_F_HW_VLAN_TX	NETIF_F_HW_VLAN_CTAG_TX
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,8,0)
+#define __devinit
+#define __devexit
+#define __devexit_p(func)   func
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
+#define CHECKSUM_PARTIAL CHECKSUM_HW
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+#define irqreturn_t void
+#define IRQ_HANDLED    1
+#define IRQ_NONE   0
+#define IRQ_RETVAL(x)
+#endif
+
+#ifndef NETIF_F_RXALL
+#define NETIF_F_RXALL  0
+#endif
+
+#ifndef NETIF_F_RXFCS
+#define NETIF_F_RXFCS  0
+#endif
+
+#ifndef HAVE_FREE_NETDEV
+#define free_netdev(x)  kfree(x)
+#endif
+
+#ifndef SET_NETDEV_DEV
+#define SET_NETDEV_DEV(net, pdev)
+#endif
+
+#ifndef SET_MODULE_OWNER
+#define SET_MODULE_OWNER(dev)
+#endif
+
+#ifndef SA_SHIRQ
+#define SA_SHIRQ IRQF_SHARED
+#endif
+
+#ifndef NETIF_F_GSO
+#define gso_size    tso_size
+#define gso_segs    tso_segs
+#endif
+
+#ifndef PCI_VENDOR_ID_DLINK
+#define PCI_VENDOR_ID_DLINK 0x1186
+#endif
+
+#ifndef dma_mapping_error
+#define dma_mapping_error(a,b) 0
+#endif
+
+#ifndef netif_err
+#define netif_err(a,b,c,d)
+#endif
+
+#ifndef AUTONEG_DISABLE
+#define AUTONEG_DISABLE   0x00
+#endif
+
+#ifndef AUTONEG_ENABLE
+#define AUTONEG_ENABLE    0x01
+#endif
+
+#ifndef BMCR_SPEED1000
+#define BMCR_SPEED1000  0x0040
+#endif
+
+#ifndef BMCR_SPEED100
+#define BMCR_SPEED100   0x2000
+#endif
+
+#ifndef BMCR_SPEED10
+#define BMCR_SPEED10    0x0000
+#endif
+
+#ifndef SPEED_UNKNOWN
+#define SPEED_UNKNOWN   -1
+#endif
+
+#ifndef DUPLEX_UNKNOWN
+#define DUPLEX_UNKNOWN  0xff
+#endif
+
+#ifndef SUPPORTED_Pause
+#define SUPPORTED_Pause  (1 << 13)
+#endif
+
+#ifndef SUPPORTED_Asym_Pause
+#define SUPPORTED_Asym_Pause  (1 << 14)
+#endif
+
+#ifndef  MDIO_EEE_100TX
+#define  MDIO_EEE_100TX  0x0002
+#endif
+
+#ifndef  MDIO_EEE_1000T
+#define  MDIO_EEE_1000T  0x0004
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+#ifdef CONFIG_NET_POLL_CONTROLLER
+#define RTL_NET_POLL_CONTROLLER dev->poll_controller=rtl8125_netpoll
+#else
+#define RTL_NET_POLL_CONTROLLER
+#endif
+
+#ifdef CONFIG_R8125_VLAN
+#define RTL_SET_VLAN dev->vlan_rx_register=rtl8125_vlan_rx_register
+#else
+#define RTL_SET_VLAN
+#endif
+
+#define RTL_NET_DEVICE_OPS(ops) dev->open=rtl8125_open; \
+                    dev->hard_start_xmit=rtl8125_start_xmit; \
+                    dev->get_stats=rtl8125_get_stats; \
+                    dev->stop=rtl8125_close; \
+                    dev->tx_timeout=rtl8125_tx_timeout; \
+                    dev->set_multicast_list=rtl8125_set_rx_mode; \
+                    dev->change_mtu=rtl8125_change_mtu; \
+                    dev->set_mac_address=rtl8125_set_mac_address; \
+                    dev->do_ioctl=rtl8125_do_ioctl; \
+                    RTL_NET_POLL_CONTROLLER; \
+                    RTL_SET_VLAN;
+#else
+#define RTL_NET_DEVICE_OPS(ops) dev->netdev_ops=&ops
+#endif
+
+#ifndef FALSE
+#define FALSE 0
+#endif
+
+#ifndef TRUE
+#define TRUE  1
+#endif
+
+#ifndef false
+#define false 0
+#endif
+
+#ifndef true
+#define true  1
+#endif
+
+//Hardware will continue interrupt 10 times after interrupt finished.
+#define RTK_KEEP_INTERRUPT_COUNT (10)
+
+//the low 32 bit address of receive buffer must be 8-byte alignment.
+#ifndef NET_IP_ALIGN
+#define NET_IP_ALIGN        2
+#endif
+#define RTK_RX_ALIGN        8
+
+#ifdef CONFIG_R8125_NAPI
+#define NAPI_SUFFIX "-NAPI"
+#else
+#define NAPI_SUFFIX ""
+#endif
+#if defined(ENABLE_DASH_PRINTER_SUPPORT)
+#define DASH_SUFFIX "-PRINTER"
+#elif defined(ENABLE_DASH_SUPPORT)
+#define DASH_SUFFIX "-DASH"
+#else
+#define DASH_SUFFIX ""
+#endif
+
+#define RTL8125_VERSION "9.003.rc7+1" NAPI_SUFFIX DASH_SUFFIX
+#define MODULENAME "r8125"
+#define PFX MODULENAME ": "
+
+#define GPL_CLAIM "\
+r8125  Copyright (C) 2019  Realtek NIC software team <nicfae@realtek.com> \n \
+This program comes with ABSOLUTELY NO WARRANTY; for details, please see <http://www.gnu.org/licenses/>. \n \
+This is free software, and you are welcome to redistribute it under certain conditions; see <http://www.gnu.org/licenses/>. \n"
+
+#ifdef RTL8125_DEBUG
+#define assert(expr) \
+        if(!(expr)) {                   \
+            printk( "Assertion failed! %s,%s,%s,line=%d\n", \
+            #expr,__FILE__,__FUNCTION__,__LINE__);      \
+        }
+#define dprintk(fmt, args...)   do { printk(PFX fmt, ## args); } while (0)
+#else
+#define assert(expr) do {} while (0)
+#define dprintk(fmt, args...)   do {} while (0)
+#endif /* RTL8125_DEBUG */
+
+#define R8125_MSG_DEFAULT \
+    (NETIF_MSG_DRV | NETIF_MSG_PROBE | NETIF_MSG_IFUP | NETIF_MSG_IFDOWN)
+
+#define TX_BUFFS_AVAIL(tp) \
+    (tp->dirty_tx + NUM_TX_DESC - tp->cur_tx - 1)
+
+#ifdef CONFIG_R8125_NAPI
+#define rtl8125_rx_hwaccel_skb      vlan_hwaccel_receive_skb
+#define rtl8125_rx_quota(count, quota)  min(count, quota)
+#else
+#define rtl8125_rx_hwaccel_skb      vlan_hwaccel_rx
+#define rtl8125_rx_quota(count, quota)  count
+#endif
+
+/* MAC address length */
+#ifndef MAC_ADDR_LEN
+#define MAC_ADDR_LEN    6
+#endif
+
+#ifndef MAC_PROTOCOL_LEN
+#define MAC_PROTOCOL_LEN    2
+#endif
+
+#ifndef ETH_FCS_LEN
+#define ETH_FCS_LEN	  4
+#endif
+
+#ifndef NETIF_F_TSO6
+#define NETIF_F_TSO6  0
+#endif
+
+#define Reserved2_data  7
+#define RX_DMA_BURST    7   /* Maximum PCI burst, '6' is 1024 */
+#define TX_DMA_BURST_unlimited  7
+#define TX_DMA_BURST_1024   6
+#define TX_DMA_BURST_512    5
+#define TX_DMA_BURST_256    4
+#define TX_DMA_BURST_128    3
+#define TX_DMA_BURST_64     2
+#define TX_DMA_BURST_32     1
+#define TX_DMA_BURST_16     0
+#define Reserved1_data  0x3F
+#define RxPacketMaxSize 0x3FE8  /* 16K - 1 - ETH_HLEN - VLAN - CRC... */
+#define Jumbo_Frame_1k  ETH_DATA_LEN
+#define Jumbo_Frame_2k  (2*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_3k  (3*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_4k  (4*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_5k  (5*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_6k  (6*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_7k  (7*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_8k  (8*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_9k  (9*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define InterFrameGap   0x03    /* 3 means InterFrameGap = the shortest one */
+#define RxEarly_off_V1 (0x07 << 11)
+#define RxEarly_off_V2 (1 << 11)
+#define Rx_Single_fetch_V2 (1 << 14)
+
+#define R8125_REGS_SIZE     (256)
+#define R8125_MAC_REGS_SIZE     (256)
+#define R8125_PHY_REGS_SIZE     (16*2)
+#define R8125_EPHY_REGS_SIZE  	(31*2)
+#define R8125_ERI_REGS_SIZE  	(0x100)
+#define R8125_REGS_DUMP_SIZE     (0x400)
+#define R8125_PCI_REGS_SIZE  	(0x100)
+#define R8125_NAPI_WEIGHT   64
+
+#define RTL8125_TX_TIMEOUT  (6 * HZ)
+#define RTL8125_LINK_TIMEOUT    (1 * HZ)
+#define RTL8125_ESD_TIMEOUT (2 * HZ)
+
+#define NUM_TX_DESC 1024    /* Number of Tx descriptor registers */
+#define NUM_RX_DESC 1024    /* Number of Rx descriptor registers */
+
+#define RX_BUF_SIZE 0x05F3  /* 0x05F3 = 1522bye + 1 */
+#define R8125_TX_RING_BYTES (NUM_TX_DESC * sizeof(struct TxDesc))
+#define R8125_RX_RING_BYTES (NUM_RX_DESC * sizeof(struct RxDesc))
+
+#define NODE_ADDRESS_SIZE 6
+
+#define RTL8125B_SHORT_PACKET_PADDING_SIZE 68
+#define SHORT_PACKET_PADDING_BUF_SIZE 256
+
+/* write/read MMIO register */
+#define RTL_W8(tp, reg, val8)	writeb((val8), tp->mmio_addr + (reg))
+#define RTL_W16(tp, reg, val16)	writew((val16), tp->mmio_addr + (reg))
+#define RTL_W32(tp, reg, val32)	writel((val32), tp->mmio_addr + (reg))
+#define RTL_R8(tp, reg)		readb(tp->mmio_addr + (reg))
+#define RTL_R16(tp, reg)		readw(tp->mmio_addr + (reg))
+#define RTL_R32(tp, reg)		((unsigned long) readl(tp->mmio_addr + (reg)))
+
+#ifndef DMA_64BIT_MASK
+#define DMA_64BIT_MASK  0xffffffffffffffffULL
+#endif
+
+#ifndef DMA_32BIT_MASK
+#define DMA_32BIT_MASK  0x00000000ffffffffULL
+#endif
+
+#ifndef NETDEV_TX_OK
+#define NETDEV_TX_OK 0      /* driver took care of packet */
+#endif
+
+#ifndef NETDEV_TX_BUSY
+#define NETDEV_TX_BUSY 1    /* driver tx path was busy*/
+#endif
+
+#ifndef NETDEV_TX_LOCKED
+#define NETDEV_TX_LOCKED -1 /* driver tx lock was already taken */
+#endif
+
+#ifndef ADVERTISED_Pause
+#define ADVERTISED_Pause    (1 << 13)
+#endif
+
+#ifndef ADVERTISED_Asym_Pause
+#define ADVERTISED_Asym_Pause   (1 << 14)
+#endif
+
+#ifndef ADVERTISE_PAUSE_CAP
+#define ADVERTISE_PAUSE_CAP 0x400
+#endif
+
+#ifndef ADVERTISE_PAUSE_ASYM
+#define ADVERTISE_PAUSE_ASYM    0x800
+#endif
+
+#ifndef MII_CTRL1000
+#define MII_CTRL1000        0x09
+#endif
+
+#ifndef ADVERTISE_1000FULL
+#define ADVERTISE_1000FULL  0x200
+#endif
+
+#ifndef ADVERTISE_1000HALF
+#define ADVERTISE_1000HALF  0x100
+#endif
+
+#ifndef ADVERTISED_2500baseX_Full
+#define ADVERTISED_2500baseX_Full  0x8000
+#endif
+
+#define RTK_ADVERTISE_2500FULL  0x80
+
+/*****************************************************************************/
+
+//#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,3)
+#if (( LINUX_VERSION_CODE < KERNEL_VERSION(2,4,27) ) || \
+     (( LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0) ) && \
+      ( LINUX_VERSION_CODE < KERNEL_VERSION(2,6,3) )))
+/* copied from linux kernel 2.6.20 include/linux/netdev.h */
+#define NETDEV_ALIGN        32
+#define NETDEV_ALIGN_CONST  (NETDEV_ALIGN - 1)
+
+static inline void *netdev_priv(struct net_device *dev)
+{
+        return (char *)dev + ((sizeof(struct net_device)
+                               + NETDEV_ALIGN_CONST)
+                              & ~NETDEV_ALIGN_CONST);
+}
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,3)
+
+/*****************************************************************************/
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+#define RTLDEV  tp
+#else
+#define RTLDEV  dev
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+/*****************************************************************************/
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+typedef struct net_device *napi_ptr;
+typedef int *napi_budget;
+
+#define napi dev
+#define RTL_NAPI_CONFIG(ndev, priv, function, weig) ndev->poll=function;    \
+                                ndev->weight=weig;
+#define RTL_NAPI_QUOTA(budget, ndev)            min(*budget, ndev->quota)
+#define RTL_GET_PRIV(stuct_ptr, priv_struct)        netdev_priv(stuct_ptr)
+#define RTL_GET_NETDEV(priv_ptr)
+#define RTL_RX_QUOTA(budget)          *budget
+#define RTL_NAPI_QUOTA_UPDATE(ndev, work_done, budget)  *budget -= work_done;   \
+                                ndev->quota -= work_done;
+#define RTL_NETIF_RX_COMPLETE(dev, napi, work_done)        netif_rx_complete(dev)
+#define RTL_NETIF_RX_SCHEDULE_PREP(dev, napi)       netif_rx_schedule_prep(dev)
+#define __RTL_NETIF_RX_SCHEDULE(dev, napi)      __netif_rx_schedule(dev)
+#define RTL_NAPI_RETURN_VALUE               work_done >= work_to_do
+#define RTL_NAPI_ENABLE(dev, napi)          netif_poll_enable(dev)
+#define RTL_NAPI_DISABLE(dev, napi)         netif_poll_disable(dev)
+#define DMA_BIT_MASK(n) (((n) == 64) ? ~0ULL : ((1ULL<<(n))-1))
+#else
+typedef struct napi_struct *napi_ptr;
+typedef int napi_budget;
+
+#define RTL_NAPI_CONFIG(ndev, priv, function, weight)   netif_napi_add(ndev, &priv->napi, function, weight)
+#define RTL_NAPI_QUOTA(budget, ndev)            min(budget, budget)
+#define RTL_GET_PRIV(stuct_ptr, priv_struct)        container_of(stuct_ptr, priv_struct, stuct_ptr)
+#define RTL_GET_NETDEV(priv_ptr)            struct net_device *dev = priv_ptr->dev;
+#define RTL_RX_QUOTA(budget)          budget
+#define RTL_NAPI_QUOTA_UPDATE(ndev, work_done, budget)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+#define RTL_NETIF_RX_COMPLETE(dev, napi, work_done)        netif_rx_complete(dev, napi)
+#define RTL_NETIF_RX_SCHEDULE_PREP(dev, napi)       netif_rx_schedule_prep(dev, napi)
+#define __RTL_NETIF_RX_SCHEDULE(dev, napi)      __netif_rx_schedule(dev, napi)
+#endif
+#if LINUX_VERSION_CODE == KERNEL_VERSION(2,6,29)
+#define RTL_NETIF_RX_COMPLETE(dev, napi, work_done)        netif_rx_complete(napi)
+#define RTL_NETIF_RX_SCHEDULE_PREP(dev, napi)       netif_rx_schedule_prep(napi)
+#define __RTL_NETIF_RX_SCHEDULE(dev, napi)      __netif_rx_schedule(napi)
+#endif
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,29)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,19,0)
+#define RTL_NETIF_RX_COMPLETE(dev, napi, work_done)        napi_complete_done(napi, work_done)
+#else
+#define RTL_NETIF_RX_COMPLETE(dev, napi, work_done)        napi_complete(napi)
+#endif
+#define RTL_NETIF_RX_SCHEDULE_PREP(dev, napi)       napi_schedule_prep(napi)
+#define __RTL_NETIF_RX_SCHEDULE(dev, napi)      __napi_schedule(napi)
+#endif
+#define RTL_NAPI_RETURN_VALUE work_done
+#define RTL_NAPI_ENABLE(dev, napi)          napi_enable(napi)
+#define RTL_NAPI_DISABLE(dev, napi)         napi_disable(napi)
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,27)
+#define RTL_NAPI_DEL(priv)
+#else
+#define RTL_NAPI_DEL(priv)   netif_napi_del(&priv->napi)
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,27)
+
+/*****************************************************************************/
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
+#ifdef __CHECKER__
+#define __iomem __attribute__((noderef, address_space(2)))
+extern void __chk_io_ptr(void __iomem *);
+#define __bitwise __attribute__((bitwise))
+#else
+#define __iomem
+#define __chk_io_ptr(x) (void)0
+#define __bitwise
+#endif
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
+
+/*****************************************************************************/
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,8)
+#ifdef __CHECKER__
+#define __force __attribute__((force))
+#else
+#define __force
+#endif
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,8)
+
+#ifndef module_param
+#define module_param(v,t,p) MODULE_PARM(v, "i");
+#endif
+
+#ifndef PCI_DEVICE
+#define PCI_DEVICE(vend,dev) \
+    .vendor = (vend), .device = (dev), \
+    .subvendor = PCI_ANY_ID, .subdevice = PCI_ANY_ID
+#endif
+
+/*****************************************************************************/
+/* 2.5.28 => 2.4.23 */
+#if ( LINUX_VERSION_CODE < KERNEL_VERSION(2,5,28) )
+
+static inline void _kc_synchronize_irq(void)
+{
+        synchronize_irq();
+}
+#undef synchronize_irq
+#define synchronize_irq(X) _kc_synchronize_irq()
+
+#include <linux/tqueue.h>
+#define work_struct tq_struct
+#undef INIT_WORK
+#define INIT_WORK(a,b,c) INIT_TQUEUE(a,(void (*)(void *))b,c)
+#undef container_of
+#define container_of list_entry
+#define schedule_work schedule_task
+#define flush_scheduled_work flush_scheduled_tasks
+#endif /* 2.5.28 => 2.4.17 */
+
+/*****************************************************************************/
+/* 2.6.4 => 2.6.0 */
+#if ( LINUX_VERSION_CODE < KERNEL_VERSION(2,6,4) )
+#define MODULE_VERSION(_version) MODULE_INFO(version, _version)
+#endif /* 2.6.4 => 2.6.0 */
+/*****************************************************************************/
+/* 2.6.0 => 2.5.28 */
+#if ( LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0) )
+#define MODULE_INFO(version, _version)
+#ifndef CONFIG_E1000_DISABLE_PACKET_SPLIT
+#define CONFIG_E1000_DISABLE_PACKET_SPLIT 1
+#endif
+
+#define pci_set_consistent_dma_mask(dev,mask) 1
+
+#undef dev_put
+#define dev_put(dev) __dev_put(dev)
+
+#ifndef skb_fill_page_desc
+#define skb_fill_page_desc _kc_skb_fill_page_desc
+extern void _kc_skb_fill_page_desc(struct sk_buff *skb, int i, struct page *page, int off, int size);
+#endif
+
+#ifndef pci_dma_mapping_error
+#define pci_dma_mapping_error _kc_pci_dma_mapping_error
+static inline int _kc_pci_dma_mapping_error(dma_addr_t dma_addr)
+{
+        return dma_addr == 0;
+}
+#endif
+
+#undef ALIGN
+#define ALIGN(x,a) (((x)+(a)-1)&~((a)-1))
+
+#endif /* 2.6.0 => 2.5.28 */
+
+/*****************************************************************************/
+/* 2.4.22 => 2.4.17 */
+#if ( LINUX_VERSION_CODE < KERNEL_VERSION(2,4,22) )
+#define pci_name(x) ((x)->slot_name)
+#endif /* 2.4.22 => 2.4.17 */
+
+/*****************************************************************************/
+/* 2.6.5 => 2.6.0 */
+#if ( LINUX_VERSION_CODE < KERNEL_VERSION(2,6,5) )
+#define pci_dma_sync_single_for_cpu pci_dma_sync_single
+#define pci_dma_sync_single_for_device  pci_dma_sync_single_for_cpu
+#endif /* 2.6.5 => 2.6.0 */
+
+/*****************************************************************************/
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+/*
+ * initialize a work-struct's func and data pointers:
+ */
+#define PREPARE_WORK(_work, _func, _data)           \
+    do {                            \
+        (_work)->func = _func;              \
+        (_work)->data = _data;              \
+    } while (0)
+
+#endif
+/*****************************************************************************/
+/* 2.6.4 => 2.6.0 */
+#if ((LINUX_VERSION_CODE < KERNEL_VERSION(2,4,25) && \
+     LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)) || \
+    (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0) && \
+      LINUX_VERSION_CODE < KERNEL_VERSION(2,6,4)))
+#define ETHTOOL_OPS_COMPAT
+#endif /* 2.6.4 => 2.6.0 */
+
+/*****************************************************************************/
+/* Installations with ethtool version without eeprom, adapter id, or statistics
+ * support */
+
+#ifndef ETH_GSTRING_LEN
+#define ETH_GSTRING_LEN 32
+#endif
+
+#ifndef ETHTOOL_GSTATS
+#define ETHTOOL_GSTATS 0x1d
+#undef ethtool_drvinfo
+#define ethtool_drvinfo k_ethtool_drvinfo
+struct k_ethtool_drvinfo {
+        u32 cmd;
+        char driver[32];
+        char version[32];
+        char fw_version[32];
+        char bus_info[32];
+        char reserved1[32];
+        char reserved2[16];
+        u32 n_stats;
+        u32 testinfo_len;
+        u32 eedump_len;
+        u32 regdump_len;
+};
+
+struct ethtool_stats {
+        u32 cmd;
+        u32 n_stats;
+        u64 data[0];
+};
+#endif /* ETHTOOL_GSTATS */
+
+#ifndef ETHTOOL_PHYS_ID
+#define ETHTOOL_PHYS_ID 0x1c
+#endif /* ETHTOOL_PHYS_ID */
+
+#ifndef ETHTOOL_GSTRINGS
+#define ETHTOOL_GSTRINGS 0x1b
+enum ethtool_stringset {
+        ETH_SS_TEST             = 0,
+        ETH_SS_STATS,
+};
+struct ethtool_gstrings {
+        u32 cmd;            /* ETHTOOL_GSTRINGS */
+        u32 string_set;     /* string set id e.c. ETH_SS_TEST, etc*/
+        u32 len;            /* number of strings in the string set */
+        u8 data[0];
+};
+#endif /* ETHTOOL_GSTRINGS */
+
+#ifndef ETHTOOL_TEST
+#define ETHTOOL_TEST 0x1a
+enum ethtool_test_flags {
+        ETH_TEST_FL_OFFLINE = (1 << 0),
+        ETH_TEST_FL_FAILED  = (1 << 1),
+};
+struct ethtool_test {
+        u32 cmd;
+        u32 flags;
+        u32 reserved;
+        u32 len;
+        u64 data[0];
+};
+#endif /* ETHTOOL_TEST */
+
+#ifndef ETHTOOL_GEEPROM
+#define ETHTOOL_GEEPROM 0xb
+#undef ETHTOOL_GREGS
+struct ethtool_eeprom {
+        u32 cmd;
+        u32 magic;
+        u32 offset;
+        u32 len;
+        u8 data[0];
+};
+
+struct ethtool_value {
+        u32 cmd;
+        u32 data;
+};
+#endif /* ETHTOOL_GEEPROM */
+
+#ifndef ETHTOOL_GLINK
+#define ETHTOOL_GLINK 0xa
+#endif /* ETHTOOL_GLINK */
+
+#ifndef ETHTOOL_GREGS
+#define ETHTOOL_GREGS       0x00000004 /* Get NIC registers */
+#define ethtool_regs _kc_ethtool_regs
+/* for passing big chunks of data */
+struct _kc_ethtool_regs {
+        u32 cmd;
+        u32 version; /* driver-specific, indicates different chips/revs */
+        u32 len; /* bytes */
+        u8 data[0];
+};
+#endif /* ETHTOOL_GREGS */
+
+#ifndef ETHTOOL_GMSGLVL
+#define ETHTOOL_GMSGLVL     0x00000007 /* Get driver message level */
+#endif
+#ifndef ETHTOOL_SMSGLVL
+#define ETHTOOL_SMSGLVL     0x00000008 /* Set driver msg level, priv. */
+#endif
+#ifndef ETHTOOL_NWAY_RST
+#define ETHTOOL_NWAY_RST    0x00000009 /* Restart autonegotiation, priv */
+#endif
+#ifndef ETHTOOL_GLINK
+#define ETHTOOL_GLINK       0x0000000a /* Get link status */
+#endif
+#ifndef ETHTOOL_GEEPROM
+#define ETHTOOL_GEEPROM     0x0000000b /* Get EEPROM data */
+#endif
+#ifndef ETHTOOL_SEEPROM
+#define ETHTOOL_SEEPROM     0x0000000c /* Set EEPROM data */
+#endif
+#ifndef ETHTOOL_GCOALESCE
+#define ETHTOOL_GCOALESCE   0x0000000e /* Get coalesce config */
+/* for configuring coalescing parameters of chip */
+#define ethtool_coalesce _kc_ethtool_coalesce
+struct _kc_ethtool_coalesce {
+        u32 cmd;    /* ETHTOOL_{G,S}COALESCE */
+
+        /* How many usecs to delay an RX interrupt after
+         * a packet arrives.  If 0, only rx_max_coalesced_frames
+         * is used.
+         */
+        u32 rx_coalesce_usecs;
+
+        /* How many packets to delay an RX interrupt after
+         * a packet arrives.  If 0, only rx_coalesce_usecs is
+         * used.  It is illegal to set both usecs and max frames
+         * to zero as this would cause RX interrupts to never be
+         * generated.
+         */
+        u32 rx_max_coalesced_frames;
+
+        /* Same as above two parameters, except that these values
+         * apply while an IRQ is being serviced by the host.  Not
+         * all cards support this feature and the values are ignored
+         * in that case.
+         */
+        u32 rx_coalesce_usecs_irq;
+        u32 rx_max_coalesced_frames_irq;
+
+        /* How many usecs to delay a TX interrupt after
+         * a packet is sent.  If 0, only tx_max_coalesced_frames
+         * is used.
+         */
+        u32 tx_coalesce_usecs;
+
+        /* How many packets to delay a TX interrupt after
+         * a packet is sent.  If 0, only tx_coalesce_usecs is
+         * used.  It is illegal to set both usecs and max frames
+         * to zero as this would cause TX interrupts to never be
+         * generated.
+         */
+        u32 tx_max_coalesced_frames;
+
+        /* Same as above two parameters, except that these values
+         * apply while an IRQ is being serviced by the host.  Not
+         * all cards support this feature and the values are ignored
+         * in that case.
+         */
+        u32 tx_coalesce_usecs_irq;
+        u32 tx_max_coalesced_frames_irq;
+
+        /* How many usecs to delay in-memory statistics
+         * block updates.  Some drivers do not have an in-memory
+         * statistic block, and in such cases this value is ignored.
+         * This value must not be zero.
+         */
+        u32 stats_block_coalesce_usecs;
+
+        /* Adaptive RX/TX coalescing is an algorithm implemented by
+         * some drivers to improve latency under low packet rates and
+         * improve throughput under high packet rates.  Some drivers
+         * only implement one of RX or TX adaptive coalescing.  Anything
+         * not implemented by the driver causes these values to be
+         * silently ignored.
+         */
+        u32 use_adaptive_rx_coalesce;
+        u32 use_adaptive_tx_coalesce;
+
+        /* When the packet rate (measured in packets per second)
+         * is below pkt_rate_low, the {rx,tx}_*_low parameters are
+         * used.
+         */
+        u32 pkt_rate_low;
+        u32 rx_coalesce_usecs_low;
+        u32 rx_max_coalesced_frames_low;
+        u32 tx_coalesce_usecs_low;
+        u32 tx_max_coalesced_frames_low;
+
+        /* When the packet rate is below pkt_rate_high but above
+         * pkt_rate_low (both measured in packets per second) the
+         * normal {rx,tx}_* coalescing parameters are used.
+         */
+
+        /* When the packet rate is (measured in packets per second)
+         * is above pkt_rate_high, the {rx,tx}_*_high parameters are
+         * used.
+         */
+        u32 pkt_rate_high;
+        u32 rx_coalesce_usecs_high;
+        u32 rx_max_coalesced_frames_high;
+        u32 tx_coalesce_usecs_high;
+        u32 tx_max_coalesced_frames_high;
+
+        /* How often to do adaptive coalescing packet rate sampling,
+         * measured in seconds.  Must not be zero.
+         */
+        u32 rate_sample_interval;
+};
+#endif /* ETHTOOL_GCOALESCE */
+
+#ifndef ETHTOOL_SCOALESCE
+#define ETHTOOL_SCOALESCE   0x0000000f /* Set coalesce config. */
+#endif
+#ifndef ETHTOOL_GRINGPARAM
+#define ETHTOOL_GRINGPARAM  0x00000010 /* Get ring parameters */
+/* for configuring RX/TX ring parameters */
+#define ethtool_ringparam _kc_ethtool_ringparam
+struct _kc_ethtool_ringparam {
+        u32 cmd;    /* ETHTOOL_{G,S}RINGPARAM */
+
+        /* Read only attributes.  These indicate the maximum number
+         * of pending RX/TX ring entries the driver will allow the
+         * user to set.
+         */
+        u32 rx_max_pending;
+        u32 rx_mini_max_pending;
+        u32 rx_jumbo_max_pending;
+        u32 tx_max_pending;
+
+        /* Values changeable by the user.  The valid values are
+         * in the range 1 to the "*_max_pending" counterpart above.
+         */
+        u32 rx_pending;
+        u32 rx_mini_pending;
+        u32 rx_jumbo_pending;
+        u32 tx_pending;
+};
+#endif /* ETHTOOL_GRINGPARAM */
+
+#ifndef ETHTOOL_SRINGPARAM
+#define ETHTOOL_SRINGPARAM  0x00000011 /* Set ring parameters, priv. */
+#endif
+#ifndef ETHTOOL_GPAUSEPARAM
+#define ETHTOOL_GPAUSEPARAM 0x00000012 /* Get pause parameters */
+/* for configuring link flow control parameters */
+#define ethtool_pauseparam _kc_ethtool_pauseparam
+struct _kc_ethtool_pauseparam {
+        u32 cmd;    /* ETHTOOL_{G,S}PAUSEPARAM */
+
+        /* If the link is being auto-negotiated (via ethtool_cmd.autoneg
+         * being true) the user may set 'autonet' here non-zero to have the
+         * pause parameters be auto-negotiated too.  In such a case, the
+         * {rx,tx}_pause values below determine what capabilities are
+         * advertised.
+         *
+         * If 'autoneg' is zero or the link is not being auto-negotiated,
+         * then {rx,tx}_pause force the driver to use/not-use pause
+         * flow control.
+         */
+        u32 autoneg;
+        u32 rx_pause;
+        u32 tx_pause;
+};
+#endif /* ETHTOOL_GPAUSEPARAM */
+
+#ifndef ETHTOOL_SPAUSEPARAM
+#define ETHTOOL_SPAUSEPARAM 0x00000013 /* Set pause parameters. */
+#endif
+#ifndef ETHTOOL_GRXCSUM
+#define ETHTOOL_GRXCSUM     0x00000014 /* Get RX hw csum enable (ethtool_value) */
+#endif
+#ifndef ETHTOOL_SRXCSUM
+#define ETHTOOL_SRXCSUM     0x00000015 /* Set RX hw csum enable (ethtool_value) */
+#endif
+#ifndef ETHTOOL_GTXCSUM
+#define ETHTOOL_GTXCSUM     0x00000016 /* Get TX hw csum enable (ethtool_value) */
+#endif
+#ifndef ETHTOOL_STXCSUM
+#define ETHTOOL_STXCSUM     0x00000017 /* Set TX hw csum enable (ethtool_value) */
+#endif
+#ifndef ETHTOOL_GSG
+#define ETHTOOL_GSG     0x00000018 /* Get scatter-gather enable
+* (ethtool_value) */
+#endif
+#ifndef ETHTOOL_SSG
+#define ETHTOOL_SSG     0x00000019 /* Set scatter-gather enable
+* (ethtool_value). */
+#endif
+#ifndef ETHTOOL_TEST
+#define ETHTOOL_TEST        0x0000001a /* execute NIC self-test, priv. */
+#endif
+#ifndef ETHTOOL_GSTRINGS
+#define ETHTOOL_GSTRINGS    0x0000001b /* get specified string set */
+#endif
+#ifndef ETHTOOL_PHYS_ID
+#define ETHTOOL_PHYS_ID     0x0000001c /* identify the NIC */
+#endif
+#ifndef ETHTOOL_GSTATS
+#define ETHTOOL_GSTATS      0x0000001d /* get NIC-specific statistics */
+#endif
+#ifndef ETHTOOL_GTSO
+#define ETHTOOL_GTSO        0x0000001e /* Get TSO enable (ethtool_value) */
+#endif
+#ifndef ETHTOOL_STSO
+#define ETHTOOL_STSO        0x0000001f /* Set TSO enable (ethtool_value) */
+#endif
+
+#ifndef ETHTOOL_BUSINFO_LEN
+#define ETHTOOL_BUSINFO_LEN 32
+#endif
+
+/*****************************************************************************/
+
+enum RTL8125_DSM_STATE {
+        DSM_MAC_INIT = 1,
+        DSM_NIC_GOTO_D3 = 2,
+        DSM_IF_DOWN = 3,
+        DSM_NIC_RESUME_D3 = 4,
+        DSM_IF_UP = 5,
+};
+
+enum RTL8125_registers {
+        MAC0            = 0x00,     /* Ethernet hardware address. */
+        MAC4            = 0x04,
+        MAR0            = 0x08,     /* Multicast filter. */
+        CounterAddrLow      = 0x10,
+        CounterAddrHigh     = 0x14,
+        CustomLED       = 0x18,
+        TxDescStartAddrLow  = 0x20,
+        TxDescStartAddrHigh = 0x24,
+        TxHDescStartAddrLow = 0x28,
+        TxHDescStartAddrHigh    = 0x2c,
+        FLASH           = 0x30,
+        ERSR            = 0x36,
+        ChipCmd         = 0x37,
+        TxPoll          = 0x38,
+        IntrMask        = 0x3C,
+        IntrStatus      = 0x3E,
+        TxConfig        = 0x40,
+        RxConfig        = 0x44,
+        TCTR            = 0x48,
+        Cfg9346         = 0x50,
+        Config0         = 0x51,
+        Config1         = 0x52,
+        Config2         = 0x53,
+        Config3         = 0x54,
+        Config4         = 0x55,
+        Config5         = 0x56,
+        TDFNR           = 0x57,
+        TimeInt0        = 0x58,
+        TimeInt1        = 0x5C,
+        PHYAR           = 0x60,
+        CSIDR           = 0x64,
+        CSIAR           = 0x68,
+        PHYstatus       = 0x6C,
+        MACDBG          = 0x6D,
+        GPIO            = 0x6E,
+        PMCH            = 0x6F,
+        ERIDR           = 0x70,
+        ERIAR           = 0x74,
+        EPHY_RXER_NUM   = 0x7C,
+        EPHYAR          = 0x80,
+        TimeInt2        = 0x8C,
+        OCPDR           = 0xB0,
+        MACOCP          = 0xB0,
+        OCPAR           = 0xB4,
+        SecMAC0         = 0xB4,
+        SecMAC4         = 0xB8,
+        PHYOCP          = 0xB8,
+        DBG_reg         = 0xD1,
+        TwiCmdReg       = 0xD2,
+        MCUCmd_reg      = 0xD3,
+        RxMaxSize       = 0xDA,
+        EFUSEAR         = 0xDC,
+        CPlusCmd        = 0xE0,
+        IntrMitigate    = 0xE2,
+        RxDescAddrLow   = 0xE4,
+        RxDescAddrHigh  = 0xE8,
+        MTPS            = 0xEC,
+        FuncEvent       = 0xF0,
+        PPSW            = 0xF2,
+        FuncEventMask   = 0xF4,
+        TimeInt3        = 0xF4,
+        FuncPresetState = 0xF8,
+        CMAC_IBCR0      = 0xF8,
+        CMAC_IBCR2      = 0xF9,
+        CMAC_IBIMR0     = 0xFA,
+        CMAC_IBISR0     = 0xFB,
+        FuncForceEvent  = 0xFC,
+        //8125
+        IMR0_8125          = 0x38,
+        ISR0_8125          = 0x3C,
+        TPPOLL_8125        = 0x90,
+        BACKUP_ADDR0_8125  = 0x19E0,
+        BACKUP_ADDR1_8125  = 0X19E4,
+        TCTR0_8125         = 0x0048,
+        TCTR1_8125         = 0x004C,
+        TCTR2_8125         = 0x0088,
+        TCTR3_8125         = 0x001C,
+        TIMER_INT0_8125    = 0x0058,
+        TIMER_INT1_8125    = 0x005C,
+        TIMER_INT2_8125    = 0x008C,
+        TIMER_INT3_8125    = 0x00F4,
+        EEE_TXIDLE_TIMER_8125   = 0x6048,
+};
+
+enum RTL8125_register_content {
+        /* InterruptStatusBits */
+        SYSErr      = 0x8000,
+        PCSTimeout  = 0x4000,
+        SWInt       = 0x0100,
+        TxDescUnavail   = 0x0080,
+        RxFIFOOver  = 0x0040,
+        LinkChg     = 0x0020,
+        RxDescUnavail   = 0x0010,
+        TxErr       = 0x0008,
+        TxOK        = 0x0004,
+        RxErr       = 0x0002,
+        RxOK        = 0x0001,
+
+        /* RxStatusDesc */
+        RxRWT = (1 << 22),
+        RxRES = (1 << 21),
+        RxRUNT = (1 << 20),
+        RxCRC = (1 << 19),
+
+        /* ChipCmdBits */
+        StopReq  = 0x80,
+        CmdReset = 0x10,
+        CmdRxEnb = 0x08,
+        CmdTxEnb = 0x04,
+        RxBufEmpty = 0x01,
+
+        /* Cfg9346Bits */
+        Cfg9346_Lock = 0x00,
+        Cfg9346_Unlock = 0xC0,
+        Cfg9346_EEDO = (1 << 0),
+        Cfg9346_EEDI = (1 << 1),
+        Cfg9346_EESK = (1 << 2),
+        Cfg9346_EECS = (1 << 3),
+        Cfg9346_EEM0 = (1 << 6),
+        Cfg9346_EEM1 = (1 << 7),
+
+        /* rx_mode_bits */
+        AcceptErr = 0x20,
+        AcceptRunt = 0x10,
+        AcceptBroadcast = 0x08,
+        AcceptMulticast = 0x04,
+        AcceptMyPhys = 0x02,
+        AcceptAllPhys = 0x01,
+
+        /* Transmit Priority Polling*/
+        HPQ = 0x80,
+        NPQ = 0x40,
+        FSWInt = 0x01,
+
+        /* RxConfigBits */
+        Reserved2_shift = 13,
+        RxCfgDMAShift = 8,
+        RxCfg_128_int_en = (1 << 15),
+        RxCfg_fet_multi_en = (1 << 14),
+        RxCfg_half_refetch = (1 << 13),
+        RxCfg_9356SEL = (1 << 6),
+
+        /* TxConfigBits */
+        TxInterFrameGapShift = 24,
+        TxDMAShift = 8, /* DMA burst value (0-7) is shift this many bits */
+        TxMACLoopBack = (1 << 17),  /* MAC loopback */
+
+        /* Config1 register */
+        LEDS1       = (1 << 7),
+        LEDS0       = (1 << 6),
+        Speed_down  = (1 << 4),
+        MEMMAP      = (1 << 3),
+        IOMAP       = (1 << 2),
+        VPD         = (1 << 1),
+        PMEnable    = (1 << 0), /* Power Management Enable */
+
+        /* Config2 register */
+        PMSTS_En    = (1 << 5),
+
+        /* Config3 register */
+        Isolate_en  = (1 << 12), /* Isolate enable */
+        MagicPacket = (1 << 5), /* Wake up when receives a Magic Packet */
+        LinkUp      = (1 << 4), /* This bit is reserved in RTL8125B.*/
+        /* Wake up when the cable connection is re-established */
+        ECRCEN      = (1 << 3), /* This bit is reserved in RTL8125B*/
+        Jumbo_En0   = (1 << 2), /* This bit is reserved in RTL8125B*/
+        RDY_TO_L23  = (1 << 1), /* This bit is reserved in RTL8125B*/
+        Beacon_en   = (1 << 0), /* This bit is reserved in RTL8125B*/
+
+        /* Config4 register */
+        Jumbo_En1   = (1 << 1), /* This bit is reserved in RTL8125B*/
+
+        /* Config5 register */
+        BWF     = (1 << 6), /* Accept Broadcast wakeup frame */
+        MWF     = (1 << 5), /* Accept Multicast wakeup frame */
+        UWF     = (1 << 4), /* Accept Unicast wakeup frame */
+        LanWake     = (1 << 1), /* LanWake enable/disable */
+        PMEStatus   = (1 << 0), /* PME status can be reset by PCI RST# */
+
+        /* CPlusCmd */
+        EnableBist  = (1 << 15),
+        Macdbgo_oe  = (1 << 14),
+        Normal_mode = (1 << 13),
+        Force_halfdup   = (1 << 12),
+        Force_rxflow_en = (1 << 11),
+        Force_txflow_en = (1 << 10),
+        Cxpl_dbg_sel    = (1 << 9),//This bit is reserved in RTL8125B
+        ASF     = (1 << 8),//This bit is reserved in RTL8125C
+        PktCntrDisable  = (1 << 7),
+        RxVlan      = (1 << 6),
+        RxChkSum    = (1 << 5),
+        Macdbgo_sel = 0x001C,
+        INTT_0      = 0x0000,
+        INTT_1      = 0x0001,
+        INTT_2      = 0x0002,
+        INTT_3      = 0x0003,
+
+        /* rtl8125_PHYstatus */
+        PowerSaveStatus = 0x80,
+        _2500bpsF = 0x400,
+        TxFlowCtrl = 0x40,
+        RxFlowCtrl = 0x20,
+        _1000bpsF = 0x10,
+        _100bps = 0x08,
+        _10bps = 0x04,
+        LinkStatus = 0x02,
+        FullDup = 0x01,
+
+        /* DBG_reg */
+        Fix_Nak_1 = (1 << 4),
+        Fix_Nak_2 = (1 << 3),
+        DBGPIN_E2 = (1 << 0),
+
+        /* ResetCounterCommand */
+        CounterReset = 0x1,
+        /* DumpCounterCommand */
+        CounterDump = 0x8,
+
+        /* PHY access */
+        PHYAR_Flag = 0x80000000,
+        PHYAR_Write = 0x80000000,
+        PHYAR_Read = 0x00000000,
+        PHYAR_Reg_Mask = 0x1f,
+        PHYAR_Reg_shift = 16,
+        PHYAR_Data_Mask = 0xffff,
+
+        /* EPHY access */
+        EPHYAR_Flag = 0x80000000,
+        EPHYAR_Write = 0x80000000,
+        EPHYAR_Read = 0x00000000,
+        EPHYAR_Reg_Mask = 0x3f,
+        EPHYAR_Reg_Mask_v2 = 0x7f,
+        EPHYAR_Reg_shift = 16,
+        EPHYAR_Data_Mask = 0xffff,
+
+        /* CSI access */
+        CSIAR_Flag = 0x80000000,
+        CSIAR_Write = 0x80000000,
+        CSIAR_Read = 0x00000000,
+        CSIAR_ByteEn = 0x0f,
+        CSIAR_ByteEn_shift = 12,
+        CSIAR_Addr_Mask = 0x0fff,
+
+        /* ERI access */
+        ERIAR_Flag = 0x80000000,
+        ERIAR_Write = 0x80000000,
+        ERIAR_Read = 0x00000000,
+        ERIAR_Addr_Align = 4, /* ERI access register address must be 4 byte alignment */
+        ERIAR_ExGMAC = 0,
+        ERIAR_MSIX = 1,
+        ERIAR_ASF = 2,
+        ERIAR_OOB = 2,
+        ERIAR_Type_shift = 16,
+        ERIAR_ByteEn = 0x0f,
+        ERIAR_ByteEn_shift = 12,
+
+        /* OCP GPHY access */
+        OCPDR_Write = 0x80000000,
+        OCPDR_Read = 0x00000000,
+        OCPDR_Reg_Mask = 0xFF,
+        OCPDR_Data_Mask = 0xFFFF,
+        OCPDR_GPHY_Reg_shift = 16,
+        OCPAR_Flag = 0x80000000,
+        OCPAR_GPHY_Write = 0x8000F060,
+        OCPAR_GPHY_Read = 0x0000F060,
+        OCPR_Write = 0x80000000,
+        OCPR_Read = 0x00000000,
+        OCPR_Addr_Reg_shift = 16,
+        OCPR_Flag = 0x80000000,
+        OCP_STD_PHY_BASE_PAGE = 0x0A40,
+
+        /* MCU Command */
+        Now_is_oob = (1 << 7),
+        Txfifo_empty = (1 << 5),
+        Rxfifo_empty = (1 << 4),
+
+        /* E-FUSE access */
+        EFUSE_WRITE = 0x80000000,
+        EFUSE_WRITE_OK  = 0x00000000,
+        EFUSE_READ  = 0x00000000,
+        EFUSE_READ_OK   = 0x80000000,
+        EFUSE_WRITE_V3 = 0x40000000,
+        EFUSE_WRITE_OK_V3  = 0x00000000,
+        EFUSE_READ_V3  = 0x80000000,
+        EFUSE_READ_OK_V3   = 0x00000000,
+        EFUSE_Reg_Mask  = 0x03FF,
+        EFUSE_Reg_Shift = 8,
+        EFUSE_Check_Cnt = 300,
+        EFUSE_READ_FAIL = 0xFF,
+        EFUSE_Data_Mask = 0x000000FF,
+
+        /* GPIO */
+        GPIO_en = (1 << 0),
+
+};
+
+enum _DescStatusBit {
+        DescOwn     = (1 << 31), /* Descriptor is owned by NIC */
+        RingEnd     = (1 << 30), /* End of descriptor ring */
+        FirstFrag   = (1 << 29), /* First segment of a packet */
+        LastFrag    = (1 << 28), /* Final segment of a packet */
+
+        /* Tx private */
+        /*------ offset 0 of tx descriptor ------*/
+        LargeSend   = (1 << 27), /* TCP Large Send Offload (TSO) */
+        GiantSendv4 = (1 << 26), /* TCP Giant Send Offload V4 (GSOv4) */
+        GiantSendv6 = (1 << 25), /* TCP Giant Send Offload V6 (GSOv6) */
+        LargeSend_DP = (1 << 16), /* TCP Large Send Offload (TSO) */
+        MSSShift    = 16,        /* MSS value position */
+        MSSMask     = 0x7FFU,    /* MSS value 11 bits */
+        TxIPCS      = (1 << 18), /* Calculate IP checksum */
+        TxUDPCS     = (1 << 17), /* Calculate UDP/IP checksum */
+        TxTCPCS     = (1 << 16), /* Calculate TCP/IP checksum */
+        TxVlanTag   = (1 << 17), /* Add VLAN tag */
+
+        /*@@@@@@ offset 4 of tx descriptor => bits for RTL8125C/CP only     begin @@@@@@*/
+        TxUDPCS_C   = (1 << 31), /* Calculate UDP/IP checksum */
+        TxTCPCS_C   = (1 << 30), /* Calculate TCP/IP checksum */
+        TxIPCS_C    = (1 << 29), /* Calculate IP checksum */
+        TxIPV6F_C   = (1 << 28), /* Indicate it is an IPv6 packet */
+        /*@@@@@@ offset 4 of tx descriptor => bits for RTL8125C/CP only     end @@@@@@*/
+
+
+        /* Rx private */
+        /*------ offset 0 of rx descriptor ------*/
+        PID1        = (1 << 18), /* Protocol ID bit 1/2 */
+        PID0        = (1 << 17), /* Protocol ID bit 2/2 */
+
+#define RxProtoUDP  (PID1)
+#define RxProtoTCP  (PID0)
+#define RxProtoIP   (PID1 | PID0)
+#define RxProtoMask RxProtoIP
+
+        RxIPF       = (1 << 16), /* IP checksum failed */
+        RxUDPF      = (1 << 15), /* UDP/IP checksum failed */
+        RxTCPF      = (1 << 14), /* TCP/IP checksum failed */
+        RxVlanTag   = (1 << 16), /* VLAN tag available */
+
+        /*@@@@@@ offset 0 of rx descriptor => bits for RTL8125C/CP only     begin @@@@@@*/
+        RxUDPT      = (1 << 18),
+        RxTCPT      = (1 << 17),
+        /*@@@@@@ offset 0 of rx descriptor => bits for RTL8125C/CP only     end @@@@@@*/
+
+        /*@@@@@@ offset 4 of rx descriptor => bits for RTL8125C/CP only     begin @@@@@@*/
+        RxV6F       = (1 << 31),
+        RxV4F       = (1 << 30),
+        /*@@@@@@ offset 4 of rx descriptor => bits for RTL8125C/CP only     end @@@@@@*/
+};
+
+enum features {
+//  RTL_FEATURE_WOL = (1 << 0),
+        RTL_FEATURE_MSI = (1 << 1),
+};
+
+enum wol_capability {
+        WOL_DISABLED = 0,
+        WOL_ENABLED = 1
+};
+
+enum bits {
+        BIT_0 = (1 << 0),
+        BIT_1 = (1 << 1),
+        BIT_2 = (1 << 2),
+        BIT_3 = (1 << 3),
+        BIT_4 = (1 << 4),
+        BIT_5 = (1 << 5),
+        BIT_6 = (1 << 6),
+        BIT_7 = (1 << 7),
+        BIT_8 = (1 << 8),
+        BIT_9 = (1 << 9),
+        BIT_10 = (1 << 10),
+        BIT_11 = (1 << 11),
+        BIT_12 = (1 << 12),
+        BIT_13 = (1 << 13),
+        BIT_14 = (1 << 14),
+        BIT_15 = (1 << 15),
+        BIT_16 = (1 << 16),
+        BIT_17 = (1 << 17),
+        BIT_18 = (1 << 18),
+        BIT_19 = (1 << 19),
+        BIT_20 = (1 << 20),
+        BIT_21 = (1 << 21),
+        BIT_22 = (1 << 22),
+        BIT_23 = (1 << 23),
+        BIT_24 = (1 << 24),
+        BIT_25 = (1 << 25),
+        BIT_26 = (1 << 26),
+        BIT_27 = (1 << 27),
+        BIT_28 = (1 << 28),
+        BIT_29 = (1 << 29),
+        BIT_30 = (1 << 30),
+        BIT_31 = (1 << 31)
+};
+
+enum effuse {
+        EFUSE_NOT_SUPPORT = 0,
+        EFUSE_SUPPORT_V1,
+        EFUSE_SUPPORT_V2,
+        EFUSE_SUPPORT_V3,
+        EFUSE_SUPPORT_V4,
+};
+#define RsvdMask    0x3fffc000
+
+struct TxDesc {
+        u32 opts1;
+        u32 opts2;
+        u64 addr;
+        u32 reserved0;
+        u32 reserved1;
+        u32 reserved2;
+        u32 reserved3;
+};
+
+struct RxDesc {
+        u32 opts1;
+        u32 opts2;
+        u64 addr;
+};
+
+struct ring_info {
+        struct sk_buff  *skb;
+        u32     len;
+        u8      __pad[sizeof(void *) - sizeof(u32)];
+};
+
+struct pci_resource {
+        u8  cmd;
+        u8  cls;
+        u16 io_base_h;
+        u16 io_base_l;
+        u16 mem_base_h;
+        u16 mem_base_l;
+        u8  ilr;
+        u16 resv_0x1c_h;
+        u16 resv_0x1c_l;
+        u16 resv_0x20_h;
+        u16 resv_0x20_l;
+        u16 resv_0x24_h;
+        u16 resv_0x24_l;
+        u16 resv_0x2c_h;
+        u16 resv_0x2c_l;
+        u32 pci_sn_l;
+        u32 pci_sn_h;
+};
+
+struct rtl8125_private {
+        void __iomem *mmio_addr;    /* memory map physical address */
+        struct pci_dev *pci_dev;    /* Index of PCI device */
+        struct net_device *dev;
+#ifdef CONFIG_R8125_NAPI
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,24)
+        struct napi_struct napi;
+#endif
+#endif
+        struct net_device_stats stats;  /* statistics of net device */
+        spinlock_t lock;        /* spin lock flag */
+        u32 msg_enable;
+        u32 tx_tcp_csum_cmd;
+        u32 tx_udp_csum_cmd;
+        u32 tx_ip_csum_cmd;
+        u32 tx_ipv6_csum_cmd;
+        int max_jumbo_frame_size;
+        int chipset;
+        u32 mcfg;
+        u32 cur_rx; /* Index into the Rx descriptor buffer of next Rx pkt. */
+        u32 cur_tx; /* Index into the Tx descriptor buffer of next Rx pkt. */
+        u32 dirty_rx;
+        u32 dirty_tx;
+        struct TxDesc *TxDescArray; /* 256-aligned Tx descriptor ring */
+        struct RxDesc *RxDescArray; /* 256-aligned Rx descriptor ring */
+        dma_addr_t TxPhyAddr;
+        dma_addr_t RxPhyAddr;
+        struct sk_buff *Rx_skbuff[NUM_RX_DESC]; /* Rx data buffers */
+        struct ring_info tx_skb[NUM_TX_DESC];   /* Tx data buffers */
+        unsigned rx_buf_sz;
+        struct timer_list esd_timer;
+        struct timer_list link_timer;
+        struct pci_resource pci_cfg_space;
+        unsigned int esd_flag;
+        unsigned int pci_cfg_is_read;
+        unsigned int rtl8125_rx_config;
+        u16 cp_cmd;
+        u32 intr_mask;
+        u32 timer_intr_mask;
+        int phy_auto_nego_reg;
+        int phy_1000_ctrl_reg;
+        int phy_2500_ctrl_reg;
+        u8 org_mac_addr[NODE_ADDRESS_SIZE];
+        struct rtl8125_counters *tally_vaddr;
+        dma_addr_t tally_paddr;
+
+#ifdef CONFIG_R8125_VLAN
+        struct vlan_group *vlgrp;
+#endif
+        u8  wol_enabled;
+        u32 wol_opts;
+        u8  efuse_ver;
+        u8  eeprom_type;
+        u8  autoneg;
+        u8  duplex;
+        u32 speed;
+        u32 advertising;
+        u16 eeprom_len;
+        u16 cur_page;
+        u32 bios_setting;
+
+        int (*set_speed)(struct net_device *, u8 autoneg, u32 speed, u8 duplex, u32 adv);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+        void (*get_settings)(struct net_device *, struct ethtool_cmd *);
+#else
+        void (*get_settings)(struct net_device *, struct ethtool_link_ksettings *);
+#endif
+        void (*phy_reset_enable)(struct net_device *);
+        unsigned int (*phy_reset_pending)(struct net_device *);
+        unsigned int (*link_ok)(struct net_device *);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+        struct work_struct task;
+#else
+        struct delayed_work task;
+#endif
+        unsigned features;
+
+        u8 org_pci_offset_99;
+        u8 org_pci_offset_180;
+        u8 issue_offset_99_event;
+
+        u8 org_pci_offset_80;
+        u8 org_pci_offset_81;
+        u8 use_timer_interrrupt;
+
+        u32 keep_intr_cnt;
+
+        u8  HwIcVerUnknown;
+        u8  NotWrRamCodeToMicroP;
+        u8  NotWrMcuPatchCode;
+        u8  HwHasWrRamCodeToMicroP;
+
+        u16 sw_ram_code_ver;
+        u16 hw_ram_code_ver;
+
+        u8 rtk_enable_diag;
+
+        u8 ShortPacketSwChecksum;
+
+        u8 UseSwPaddingShortPkt;
+        u16 SwPaddingShortPktLen;
+
+        void *ShortPacketEmptyBuffer;
+        dma_addr_t ShortPacketEmptyBufferPhy;
+
+        u8 RequireAdcBiasPatch;
+        u16 AdcBiasPatchIoffset;
+
+        u8 RequireAdjustUpsTxLinkPulseTiming;
+        u16 SwrCnt1msIni;
+
+        u8 HwSuppNowIsOobVer;
+
+        u8 RequiredSecLanDonglePatch;
+
+        u8 RequirePhyMdiSwapPatch;
+
+        u32 HwFiberModeVer;
+        u32 HwFiberStat;
+        u8 HwSwitchMdiToFiber;
+
+        u16 NicCustLedValue;
+
+        u8 HwSuppMagicPktVer;
+
+        u8 HwSuppCheckPhyDisableModeVer;
+
+        u8 random_mac;
+
+        u8 HwSuppGigaForceMode;
+
+        u16 phy_reg_anlpar;
+
+        u32 HwPcieSNOffset;
+
+        //Dash+++++++++++++++++
+        u8 HwSuppDashVer;
+        u8 DASH;
+        u8 dash_printer_enabled;
+        u8 HwPkgDet;
+        void __iomem *mapped_cmac_ioaddr; /* mapped cmac memory map physical address */
+        void __iomem *cmac_ioaddr; /* cmac memory map physical address */
+
+#ifdef ENABLE_DASH_SUPPORT
+        u16 AfterRecvFromFwBufLen;
+        u8 AfterRecvFromFwBuf[RECV_FROM_FW_BUF_SIZE];
+        u16 AfterSendToFwBufLen;
+        u8 AfterSendToFwBuf[SEND_TO_FW_BUF_SIZE];
+        u16 SendToFwBufferLen;
+        u32 SizeOfSendToFwBuffer;
+        u32 SizeOfSendToFwBufferMemAlloc;
+        u32 NumOfSendToFwBuffer;
+
+        u8 OobReq;
+        u8 OobAck;
+        u32 OobReqComplete;
+        u32 OobAckComplete;
+
+        u8 RcvFwReqSysOkEvt;
+        u8 RcvFwDashOkEvt;
+        u8 SendFwHostOkEvt;
+
+        u8 DashFwDisableRx;
+
+        void *UnalignedSendToFwBufferVa;
+        void *SendToFwBuffer;
+        u64 SendToFwBufferPhy;
+        u8 SendingToFw;
+        dma_addr_t UnalignedSendToFwBufferPa;
+        PTX_DASH_SEND_FW_DESC TxDashSendFwDesc;
+        u64 TxDashSendFwDescPhy;
+        u8 *UnalignedTxDashSendFwDescVa;
+        u32 SizeOfTxDashSendFwDescMemAlloc;
+        u32 SizeOfTxDashSendFwDesc;
+        u32 NumTxDashSendFwDesc;
+        u32 CurrNumTxDashSendFwDesc;
+        u32 LastSendNumTxDashSendFwDesc;
+        dma_addr_t UnalignedTxDashSendFwDescPa;
+
+        u32 NumRecvFromFwBuffer;
+        u32 SizeOfRecvFromFwBuffer;
+        u32 SizeOfRecvFromFwBufferMemAlloc;
+        void *RecvFromFwBuffer;
+        u64 RecvFromFwBufferPhy;
+
+        void *UnalignedRecvFromFwBufferVa;
+        dma_addr_t UnalignedRecvFromFwBufferPa;
+        PRX_DASH_FROM_FW_DESC RxDashRecvFwDesc;
+        u64 RxDashRecvFwDescPhy;
+        u8 *UnalignedRxDashRecvFwDescVa;
+        u32 SizeOfRxDashRecvFwDescMemAlloc;
+        u32 SizeOfRxDashRecvFwDesc;
+        u32 NumRxDashRecvFwDesc;
+        u32 CurrNumRxDashRecvFwDesc;
+        dma_addr_t UnalignedRxDashRecvFwDescPa;
+        u8 DashReqRegValue;
+        u16 HostReqValue;
+
+        u32 CmacResetIsrCounter;
+        u8 CmacResetIntr;
+        u8 CmacResetting;
+        u8 CmacOobIssueCmacReset;
+        u32 CmacResetbyFwCnt;
+
+#if defined(ENABLE_DASH_PRINTER_SUPPORT)
+        struct completion fw_ack;
+        struct completion fw_req;
+        struct completion fw_host_ok;
+#endif
+        //Dash-----------------
+#endif //ENABLE_DASH_SUPPORT
+
+        //Realwow++++++++++++++
+        u8 HwSuppKCPOffloadVer;
+
+        u8 EnableDhcpTimeoutWake;
+        u8 EnableTeredoOffload;
+        u8 EnableKCPOffload;
+#ifdef ENABLE_REALWOW_SUPPORT
+        u32 DhcpTimeout;
+        MP_KCP_INFO MpKCPInfo;
+        //Realwow--------------
+#endif //ENABLE_REALWOW_SUPPORT
+
+        u32 eee_adv_t;
+        u8 eee_enabled;
+
+#ifdef ENABLE_R8125_PROCFS
+        //Procfs support
+        struct proc_dir_entry *proc_dir;
+#endif
+};
+
+enum eetype {
+        EEPROM_TYPE_NONE=0,
+        EEPROM_TYPE_93C46,
+        EEPROM_TYPE_93C56,
+        EEPROM_TWSI
+};
+
+enum mcfg {
+        CFG_METHOD_2=2,
+        CFG_METHOD_3,
+        CFG_METHOD_4,
+        CFG_METHOD_5,
+        CFG_METHOD_MAX,
+        CFG_METHOD_DEFAULT = 0xFF
+};
+
+#define LSO_32K 32000
+#define LSO_64K 64000
+
+#define NIC_MIN_PHYS_BUF_COUNT          (2)
+#define NIC_MAX_PHYS_BUF_COUNT_LSO_64K  (24)
+#define NIC_MAX_PHYS_BUF_COUNT_LSO2     (16*4)
+
+#define GTTCPHO_SHIFT                   18
+#define GTTCPHO_MAX                     0x7fU
+#define GTPKTSIZE_MAX                   0x3ffffU
+#define TCPHO_SHIFT                     18
+#define TCPHO_MAX                       0x3ffU
+#define LSOPKTSIZE_MAX                  0xffffU
+#define MSS_MAX                         0x07ffu /* MSS value */
+
+#define OOB_CMD_RESET       0x00
+#define OOB_CMD_DRIVER_START    0x05
+#define OOB_CMD_DRIVER_STOP 0x06
+#define OOB_CMD_SET_IPMAC   0x41
+
+#define WAKEUP_MAGIC_PACKET_NOT_SUPPORT (0)
+#define WAKEUP_MAGIC_PACKET_V1 (1)
+#define WAKEUP_MAGIC_PACKET_V2 (2)
+#define WAKEUP_MAGIC_PACKET_V3 (3)
+
+//Ram Code Version
+#define NIC_RAMCODE_VERSION_CFG_METHOD_2 (0x0b11)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_3 (0x0b33)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_4 (0x0b17)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_5 (0x0b21)
+
+//hwoptimize
+#define HW_PATCH_SOC_LAN (BIT_0)
+#define HW_PATCH_SAMSUNG_LAN_DONGLE (BIT_2)
+
+void rtl8125_mdio_write(struct rtl8125_private *tp, u32 RegAddr, u32 value);
+void rtl8125_mdio_prot_write(struct rtl8125_private *tp, u32 RegAddr, u32 value);
+void rtl8125_mdio_prot_write_phy_ocp(struct rtl8125_private *tp, u32 RegAddr, u32 value);
+u32 rtl8125_mdio_read(struct rtl8125_private *tp, u32 RegAddr);
+u32 rtl8125_mdio_prot_read(struct rtl8125_private *tp, u32 RegAddr);
+u32 rtl8125_mdio_prot_read_phy_ocp(struct rtl8125_private *tp, u32 RegAddr);
+void rtl8125_ephy_write(struct rtl8125_private *tp, int RegAddr, int value);
+void rtl8125_mac_ocp_write(struct rtl8125_private *tp, u16 reg_addr, u16 value);
+u16 rtl8125_mac_ocp_read(struct rtl8125_private *tp, u16 reg_addr);
+void rtl8125_clear_eth_phy_bit(struct rtl8125_private *tp, u8 addr, u16 mask);
+void rtl8125_set_eth_phy_bit(struct rtl8125_private *tp,  u8  addr, u16  mask);
+void rtl8125_ocp_write(struct rtl8125_private *tp, u16 addr, u8 len, u32 data);
+void rtl8125_oob_notify(struct rtl8125_private *tp, u8 cmd);
+void rtl8125_init_ring_indexes(struct rtl8125_private *tp);
+int rtl8125_eri_write(struct rtl8125_private *tp, int addr, int len, u32 value, int type);
+void rtl8125_oob_mutex_lock(struct rtl8125_private *tp);
+u32 rtl8125_mdio_read(struct rtl8125_private *tp, u32 RegAddr);
+u32 rtl8125_ocp_read(struct rtl8125_private *tp, u16 addr, u8 len);
+u32 rtl8125_ocp_read_with_oob_base_address(struct rtl8125_private *tp, u16 addr, u8 len, u32 base_address);
+u32 rtl8125_ocp_write_with_oob_base_address(struct rtl8125_private *tp, u16 addr, u8 len, u32 value, u32 base_address);
+u32 rtl8125_eri_read(struct rtl8125_private *tp, int addr, int len, int type);
+u32 rtl8125_eri_read_with_oob_base_address(struct rtl8125_private *tp, int addr, int len, int type, u32 base_address);
+int rtl8125_eri_write_with_oob_base_address(struct rtl8125_private *tp, int addr, int len, u32 value, int type, u32 base_address);
+u16 rtl8125_ephy_read(struct rtl8125_private *tp, int RegAddr);
+void rtl8125_wait_txrx_fifo_empty(struct net_device *dev);
+void rtl8125_enable_now_is_oob(struct rtl8125_private *tp);
+void rtl8125_disable_now_is_oob(struct rtl8125_private *tp);
+void rtl8125_oob_mutex_unlock(struct rtl8125_private *tp);
+void rtl8125_dash2_disable_tx(struct rtl8125_private *tp);
+void rtl8125_dash2_enable_tx(struct rtl8125_private *tp);
+void rtl8125_dash2_disable_rx(struct rtl8125_private *tp);
+void rtl8125_dash2_enable_rx(struct rtl8125_private *tp);
+void rtl8125_hw_disable_mac_mcu_bps(struct net_device *dev);
+
+#define HW_SUPPORT_CHECK_PHY_DISABLE_MODE(_M)        ((_M)->HwSuppCheckPhyDisableModeVer > 0 )
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,34)
+#define netdev_mc_count(dev) ((dev)->mc_count)
+#define netdev_mc_empty(dev) (netdev_mc_count(dev) == 0)
+#define netdev_for_each_mc_addr(mclist, dev) \
+    for (mclist = dev->mc_list; mclist; mclist = mclist->next)
+#endif
diff --git a/drivers/net/ethernet/realtek/r8125/r8125_dash.h b/drivers/net/ethernet/realtek/r8125/r8125_dash.h
new file mode 100644
index 00000000..535faec
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8125/r8125_dash.h
@@ -0,0 +1,258 @@
+/*
+################################################################################
+#
+# r8125 is the Linux device driver released for Realtek 2.5Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#ifndef _LINUX_R8125_DASH_H
+#define _LINUX_R8125_DASH_H
+
+#define SIOCDEVPRIVATE_RTLDASH   SIOCDEVPRIVATE+2
+
+enum rtl_dash_cmd {
+        RTL_DASH_ARP_NS_OFFLOAD = 0,
+        RTL_DASH_SET_OOB_IPMAC,
+        RTL_DASH_NOTIFY_OOB,
+
+        RTL_DASH_SEND_BUFFER_DATA_TO_DASH_FW,
+        RTL_DASH_CHECK_SEND_BUFFER_TO_DASH_FW_COMPLETE,
+        RTL_DASH_GET_RCV_FROM_FW_BUFFER_DATA,
+        RTL_DASH_OOB_REQ,
+        RTL_DASH_OOB_ACK,
+        RTL_DASH_DETACH_OOB_REQ,
+        RTL_DASH_DETACH_OOB_ACK,
+
+        RTL_FW_SET_IPV4 = 0x10,
+        RTL_FW_GET_IPV4,
+        RTL_FW_SET_IPV6,
+        RTL_FW_GET_IPV6,
+        RTL_FW_SET_EXT_SNMP,
+        RTL_FW_GET_EXT_SNMP,
+        RTL_FW_SET_WAKEUP_PATTERN,
+        RTL_FW_GET_WAKEUP_PATTERN,
+        RTL_FW_DEL_WAKEUP_PATTERN,
+
+        RTLT_DASH_COMMAND_INVALID,
+};
+
+struct rtl_dash_ip_mac {
+        struct sockaddr ifru_addr;
+        struct sockaddr ifru_netmask;
+        struct sockaddr ifru_hwaddr;
+};
+
+struct rtl_dash_ioctl_struct {
+        __u32	cmd;
+        __u32	offset;
+        __u32	len;
+        union {
+                __u32	data;
+                void *data_buffer;
+        };
+};
+
+struct settings_ipv4 {
+        __u32	IPv4addr;
+        __u32	IPv4mask;
+        __u32	IPv4Gateway;
+};
+
+struct settings_ipv6 {
+        __u32	reserved;
+        __u32	prefixLen;
+        __u16	IPv6addr[8];
+        __u16	IPv6Gateway[8];
+};
+
+struct settings_ext_snmp {
+        __u16	index;
+        __u16	oid_get_len;
+        __u8	oid_for_get[24];
+        __u8	reserved0[26];
+        __u16	value_len;
+        __u8	value[256];
+        __u8	supported;
+        __u8	reserved1[27];
+};
+
+struct wakeup_pattern {
+        __u8	index;
+        __u8	valid;
+        __u8	start;
+        __u8	length;
+        __u8	name[36];
+        __u8	mask[16];
+        __u8	pattern[128];
+        __u32	reserved[2];
+};
+
+typedef struct _RX_DASH_FROM_FW_DESC {
+        u16 length;
+        u8 statusLowByte;
+        u8 statusHighByte;
+        u32 resv;
+        u64 BufferAddress;
+}
+RX_DASH_FROM_FW_DESC, *PRX_DASH_FROM_FW_DESC;
+
+typedef struct _TX_DASH_SEND_FW_DESC {
+        u16 length;
+        u8 statusLowByte;
+        u8 statusHighByte;
+        u32 resv;
+        u64 BufferAddress;
+}
+TX_DASH_SEND_FW_DESC, *PTX_DASH_SEND_FW_DESC;
+
+typedef struct _OSOOBHdr {
+        u32 len;
+        u8 type;
+        u8 flag;
+        u8 hostReqV;
+        u8 res;
+}
+OSOOBHdr, *POSOOBHdr;
+
+typedef struct _RX_DASH_BUFFER_TYPE_2 {
+        OSOOBHdr oobhdr;
+        u8 RxDataBuffer[0];
+}
+RX_DASH_BUFFER_TYPE_2, *PRX_DASH_BUFFER_TYPE_2;
+
+#define ALIGN_8                 (0x7)
+#define ALIGN_16                (0xf)
+#define ALIGN_32                (0x1f)
+#define ALIGN_64                (0x3f)
+#define ALIGN_256               (0xff)
+#define ALIGN_4096              (0xfff)
+
+#define OCP_REG_CONFIG0 (0x10)
+#define OCP_REG_CONFIG0_REV_F (0xB8)
+#define OCP_REG_DASH_POLL (0x30)
+#define OCP_REG_HOST_REQ (0x34)
+#define OCP_REG_DASH_REQ (0x35)
+#define OCP_REG_CR (0x36)
+#define OCP_REG_DMEMSTA (0x38)
+#define OCP_REG_GPHYAR (0x60)
+
+
+#define OCP_REG_CONFIG0_DASHEN           BIT_15
+#define OCP_REG_CONFIG0_OOBRESET         BIT_14
+#define OCP_REG_CONFIG0_APRDY            BIT_13
+#define OCP_REG_CONFIG0_FIRMWARERDY      BIT_12
+#define OCP_REG_CONFIG0_DRIVERRDY        BIT_11
+#define OCP_REG_CONFIG0_OOB_WDT          BIT_9
+#define OCP_REG_CONFIG0_DRV_WAIT_OOB     BIT_8
+#define OCP_REG_CONFIG0_TLSEN            BIT_7
+
+#define HW_DASH_SUPPORT_DASH(_M)        ((_M)->HwSuppDashVer > 0 )
+#define HW_DASH_SUPPORT_TYPE_1(_M)        ((_M)->HwSuppDashVer == 1 )
+#define HW_DASH_SUPPORT_TYPE_2(_M)        ((_M)->HwSuppDashVer == 2 )
+#define HW_DASH_SUPPORT_TYPE_3(_M)        ((_M)->HwSuppDashVer == 3 )
+
+#define RECV_FROM_FW_BUF_SIZE (1520)
+#define SEND_TO_FW_BUF_SIZE (1520)
+
+#define RX_DASH_FROM_FW_OWN BIT_15
+#define TX_DASH_SEND_FW_OWN BIT_15
+#define TX_DASH_SEND_FW_OWN_HIGHBYTE BIT_7
+
+#define TXS_CC3_0       (BIT_0|BIT_1|BIT_2|BIT_3)
+#define TXS_EXC         BIT_4
+#define TXS_LNKF        BIT_5
+#define TXS_OWC         BIT_6
+#define TXS_TES         BIT_7
+#define TXS_UNF         BIT_9
+#define TXS_LGSEN       BIT_11
+#define TXS_LS          BIT_12
+#define TXS_FS          BIT_13
+#define TXS_EOR         BIT_14
+#define TXS_OWN         BIT_15
+
+#define TPPool_HRDY     0x20
+
+#define HostReqReg (0xC0)
+#define SystemMasterDescStartAddrLow (0xF0)
+#define SystemMasterDescStartAddrHigh (0xF4)
+#define SystemSlaveDescStartAddrLow (0xF8)
+#define SystemSlaveDescStartAddrHigh (0xFC)
+
+//DASH Request Type
+#define WSMANREG 0x01
+#define OSPUSHDATA 0x02
+
+#define RXS_OWN      BIT_15
+#define RXS_EOR      BIT_14
+#define RXS_FS       BIT_13
+#define RXS_LS       BIT_12
+
+#define ISRIMR_DP_DASH_OK BIT_15
+#define ISRIMR_DP_HOST_OK BIT_13
+#define ISRIMR_DP_REQSYS_OK BIT_11
+
+#define ISRIMR_DASH_INTR_EN BIT_12
+#define ISRIMR_DASH_INTR_CMAC_RESET BIT_15
+
+#define ISRIMR_DASH_TYPE2_ROK BIT_0
+#define ISRIMR_DASH_TYPE2_RDU BIT_1
+#define ISRIMR_DASH_TYPE2_TOK BIT_2
+#define ISRIMR_DASH_TYPE2_TDU BIT_3
+#define ISRIMR_DASH_TYPE2_TX_FIFO_FULL BIT_4
+#define ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE BIT_5
+#define ISRIMR_DASH_TYPE2_RX_DISABLE_IDLE BIT_6
+
+#define CMAC_OOB_STOP 0x25
+#define CMAC_OOB_INIT 0x26
+#define CMAC_OOB_RESET 0x2a
+
+#define NO_BASE_ADDRESS 0x00000000
+#define RTL8168FP_OOBMAC_BASE 0xBAF70000
+#define RTL8168FP_CMAC_IOBASE 0xBAF20000
+#define RTL8168FP_KVM_BASE 0xBAF80400
+#define CMAC_SYNC_REG 0x20
+#define CMAC_RXDESC_OFFSET 0x90    //RX: 0x90 - 0x98
+#define CMAC_TXDESC_OFFSET 0x98    //TX: 0x98 - 0x9F
+
+/* cmac write/read MMIO register */
+#define RTL_CMAC_W8(tp, reg, val8)   writeb ((val8), tp->cmac_ioaddr + (reg))
+#define RTL_CMAC_W16(tp, reg, val16) writew ((val16), tp->cmac_ioaddr + (reg))
+#define RTL_CMAC_W32(tp, reg, val32) writel ((val32), tp->cmac_ioaddr + (reg))
+#define RTL_CMAC_R8(tp, reg)     readb (tp->cmac_ioaddr + (reg))
+#define RTL_CMAC_R16(tp, reg)        readw (tp->cmac_ioaddr + (reg))
+#define RTL_CMAC_R32(tp, reg)        ((unsigned long) readl (tp->cmac_ioaddr + (reg)))
+
+int rtl8125_dash_ioctl(struct net_device *dev, struct ifreq *ifr);
+void HandleDashInterrupt(struct net_device *dev);
+int AllocateDashShareMemory(struct net_device *dev);
+void FreeAllocatedDashShareMemory(struct net_device *dev);
+void DashHwInit(struct net_device *dev);
+
+
+#endif /* _LINUX_R8125_DASH_H */
diff --git a/drivers/net/ethernet/realtek/r8125/r8125_n.c b/drivers/net/ethernet/realtek/r8125/r8125_n.c
new file mode 100644
index 00000000..571e0a2
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8125/r8125_n.c
@@ -0,0 +1,12429 @@
+/*
+################################################################################
+#
+# r8125 is the Linux device driver released for Realtek 2.5Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+/*
+ * This driver is modified from r8169.c in Linux kernel 2.6.18
+ */
+
+#include <linux/module.h>
+#include <linux/version.h>
+#include <linux/pci.h>
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/delay.h>
+#include <linux/mii.h>
+#include <linux/if_vlan.h>
+#include <linux/crc32.h>
+#include <linux/interrupt.h>
+#include <linux/in.h>
+#include <linux/ip.h>
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,22)
+#include <linux/ipv6.h>
+#include <net/ip6_checksum.h>
+#endif
+#include <linux/tcp.h>
+#include <linux/init.h>
+#include <linux/rtnetlink.h>
+#include <linux/completion.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,26)
+#include <linux/pci-aspm.h>
+#endif
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,37)
+#include <linux/prefetch.h>
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+#define dev_printk(A,B,fmt,args...) printk(A fmt,##args)
+#else
+#include <linux/dma-mapping.h>
+#include <linux/moduleparam.h>
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,31)
+#include <linux/mdio.h>
+#endif
+
+#include <asm/io.h>
+#include <asm/irq.h>
+
+#include "r8125.h"
+#include "rtl_eeprom.h"
+#include "rtltool.h"
+
+#ifdef ENABLE_R8125_PROCFS
+#include <linux/proc_fs.h>
+#include <linux/seq_file.h>
+#endif
+
+/* Maximum number of multicast addresses to filter (vs. Rx-all-multicast).
+   The RTL chips use a 64 element hash table based on the Ethernet CRC. */
+static const int multicast_filter_limit = 32;
+
+#define _R(NAME,MAC,RCR,MASK, JumFrameSz) \
+    { .name = NAME, .mcfg = MAC, .RCR_Cfg = RCR, .RxConfigMask = MASK, .jumbo_frame_sz = JumFrameSz }
+
+static const struct {
+        const char *name;
+        u8 mcfg;
+        u32 RCR_Cfg;
+        u32 RxConfigMask;   /* Clears the bits supported by this chip */
+        u32 jumbo_frame_sz;
+} rtl_chip_info[] = {
+        _R("RTL8125A",
+        CFG_METHOD_2,
+        BIT_30 | BIT_22 | BIT_23 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8125A",
+        CFG_METHOD_3,
+        BIT_30 | BIT_22 | BIT_23 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8125B",
+        CFG_METHOD_4,
+        BIT_30 | BIT_22 | BIT_23 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8125B",
+        CFG_METHOD_5,
+        BIT_30 | BIT_22 | BIT_23 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("Unknown",
+        CFG_METHOD_DEFAULT,
+        (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_1k)
+};
+#undef _R
+
+#ifndef PCI_VENDOR_ID_DLINK
+#define PCI_VENDOR_ID_DLINK 0x1186
+#endif
+
+static struct pci_device_id rtl8125_pci_tbl[] = {
+        { PCI_DEVICE(PCI_VENDOR_ID_REALTEK, 0x8125), },
+        { PCI_DEVICE(PCI_VENDOR_ID_REALTEK, 0x3000), },
+        {0,},
+};
+
+MODULE_DEVICE_TABLE(pci, rtl8125_pci_tbl);
+
+static int rx_copybreak = 0;
+static int use_dac = 1;
+static int timer_count = 0x2600;
+
+static struct {
+        u32 msg_enable;
+} debug = { -1 };
+
+static unsigned int speed_mode = SPEED_2500;
+static unsigned int duplex_mode = DUPLEX_FULL;
+static unsigned int autoneg_mode = AUTONEG_ENABLE;
+static unsigned int advertising_mode =  ADVERTISED_10baseT_Half |
+                                        ADVERTISED_10baseT_Full |
+                                        ADVERTISED_100baseT_Half |
+                                        ADVERTISED_100baseT_Full |
+                                        ADVERTISED_1000baseT_Half |
+                                        ADVERTISED_1000baseT_Full |
+                                        ADVERTISED_2500baseX_Full;
+#ifdef CONFIG_ASPM
+static int aspm = 1;
+#else
+static int aspm = 0;
+#endif
+#ifdef ENABLE_S5WOL
+static int s5wol = 1;
+#else
+static int s5wol = 0;
+#endif
+#ifdef ENABLE_S5_KEEP_CURR_MAC
+static int s5_keep_curr_mac = 1;
+#else
+static int s5_keep_curr_mac = 0;
+#endif
+#ifdef ENABLE_EEE
+static int eee_enable = 1;
+#else
+static int eee_enable = 0;
+#endif
+#ifdef CONFIG_SOC_LAN
+static ulong hwoptimize = HW_PATCH_SOC_LAN;
+#else
+static ulong hwoptimize = 0;
+#endif
+#ifdef ENABLE_S0_MAGIC_PACKET
+static int s0_magic_packet = 1;
+#else
+static int s0_magic_packet = 0;
+#endif
+
+MODULE_AUTHOR("Realtek and the Linux r8125 crew <netdev@vger.kernel.org>");
+MODULE_DESCRIPTION("RealTek RTL8125 2.5Gigabit Ethernet driver");
+
+module_param(speed_mode, uint, 0);
+MODULE_PARM_DESC(speed_mode, "force phy operation. Deprecated by ethtool (8).");
+
+module_param(duplex_mode, uint, 0);
+MODULE_PARM_DESC(duplex_mode, "force phy operation. Deprecated by ethtool (8).");
+
+module_param(autoneg_mode, uint, 0);
+MODULE_PARM_DESC(autoneg_mode, "force phy operation. Deprecated by ethtool (8).");
+
+module_param(advertising_mode, uint, 0);
+MODULE_PARM_DESC(advertising_mode, "force phy operation. Deprecated by ethtool (8).");
+
+module_param(aspm, int, 0);
+MODULE_PARM_DESC(aspm, "Enable ASPM.");
+
+module_param(s5wol, int, 0);
+MODULE_PARM_DESC(s5wol, "Enable Shutdown Wake On Lan.");
+
+module_param(s5_keep_curr_mac, int, 0);
+MODULE_PARM_DESC(s5_keep_curr_mac, "Enable Shutdown Keep Current MAC Address.");
+
+module_param(rx_copybreak, int, 0);
+MODULE_PARM_DESC(rx_copybreak, "Copy breakpoint for copy-only-tiny-frames");
+
+module_param(use_dac, int, 0);
+MODULE_PARM_DESC(use_dac, "Enable PCI DAC. Unsafe on 32 bit PCI slot.");
+
+module_param(timer_count, int, 0);
+MODULE_PARM_DESC(timer_count, "Timer Interrupt Interval.");
+
+module_param(eee_enable, int, 0);
+MODULE_PARM_DESC(eee_enable, "Enable Energy Efficient Ethernet.");
+
+module_param(hwoptimize, ulong, 0);
+MODULE_PARM_DESC(hwoptimize, "Enable HW optimization function.");
+
+module_param(s0_magic_packet, int, 0);
+MODULE_PARM_DESC(s0_magic_packet, "Enable S0 Magic Packet.");
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+module_param_named(debug, debug.msg_enable, int, 0);
+MODULE_PARM_DESC(debug, "Debug verbosity level (0=none, ..., 16=all)");
+#endif//LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+
+MODULE_LICENSE("GPL");
+
+MODULE_VERSION(RTL8125_VERSION);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+static void rtl8125_esd_timer(unsigned long __opaque);
+#else
+static void rtl8125_esd_timer(struct timer_list *t);
+#endif
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+static void rtl8125_link_timer(unsigned long __opaque);
+#else
+static void rtl8125_link_timer(struct timer_list *t);
+#endif
+static void rtl8125_tx_clear(struct rtl8125_private *tp);
+static void rtl8125_rx_clear(struct rtl8125_private *tp);
+
+static int rtl8125_open(struct net_device *dev);
+static int rtl8125_start_xmit(struct sk_buff *skb, struct net_device *dev);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
+static irqreturn_t rtl8125_interrupt(int irq, void *dev_instance, struct pt_regs *regs);
+#else
+static irqreturn_t rtl8125_interrupt(int irq, void *dev_instance);
+#endif
+static int rtl8125_init_ring(struct net_device *dev);
+static void rtl8125_hw_config(struct net_device *dev);
+static void rtl8125_hw_start(struct net_device *dev);
+static int rtl8125_close(struct net_device *dev);
+static void rtl8125_set_rx_mode(struct net_device *dev);
+static void rtl8125_tx_timeout(struct net_device *dev);
+static struct net_device_stats *rtl8125_get_stats(struct net_device *dev);
+static int rtl8125_rx_interrupt(struct net_device *, struct rtl8125_private *, napi_budget);
+static int rtl8125_change_mtu(struct net_device *dev, int new_mtu);
+static void rtl8125_down(struct net_device *dev);
+
+static int rtl8125_set_mac_address(struct net_device *dev, void *p);
+static void rtl8125_rar_set(struct rtl8125_private *tp, uint8_t *addr);
+static void rtl8125_desc_addr_fill(struct rtl8125_private *);
+static void rtl8125_tx_desc_init(struct rtl8125_private *tp);
+static void rtl8125_rx_desc_init(struct rtl8125_private *tp);
+
+static void rtl8125_hw_reset(struct net_device *dev);
+
+static void rtl8125_phy_power_up(struct net_device *dev);
+static void rtl8125_phy_power_down(struct net_device *dev);
+static int rtl8125_set_speed(struct net_device *dev, u8 autoneg, u32 speed, u8 duplex, u32 adv);
+static bool rtl8125_set_phy_mcu_patch_request(struct rtl8125_private *tp);
+static bool rtl8125_clear_phy_mcu_patch_request(struct rtl8125_private *tp);
+
+#ifdef CONFIG_R8125_NAPI
+static int rtl8125_poll(napi_ptr napi, napi_budget budget);
+#endif
+
+#if ((LINUX_VERSION_CODE < KERNEL_VERSION(4,7,0) && \
+     LINUX_VERSION_CODE >= KERNEL_VERSION(4,6,00)))
+void ethtool_convert_legacy_u32_to_link_mode(unsigned long *dst,
+                u32 legacy_u32)
+{
+        bitmap_zero(dst, __ETHTOOL_LINK_MODE_MASK_NBITS);
+        dst[0] = legacy_u32;
+}
+
+bool ethtool_convert_link_mode_to_legacy_u32(u32 *legacy_u32,
+                const unsigned long *src)
+{
+        bool retval = true;
+
+        /* TODO: following test will soon always be true */
+        if (__ETHTOOL_LINK_MODE_MASK_NBITS > 32) {
+                __ETHTOOL_DECLARE_LINK_MODE_MASK(ext);
+
+                bitmap_zero(ext, __ETHTOOL_LINK_MODE_MASK_NBITS);
+                bitmap_fill(ext, 32);
+                bitmap_complement(ext, ext, __ETHTOOL_LINK_MODE_MASK_NBITS);
+                if (bitmap_intersects(ext, src,
+                                      __ETHTOOL_LINK_MODE_MASK_NBITS)) {
+                        /* src mask goes beyond bit 31 */
+                        retval = false;
+                }
+        }
+        *legacy_u32 = src[0];
+        return retval;
+}
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+
+#ifndef LPA_1000FULL
+#define LPA_1000FULL            0x0800
+#endif
+
+#ifndef LPA_1000HALF
+#define LPA_1000HALF            0x0400
+#endif
+
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,4,0)
+static inline void eth_hw_addr_random(struct net_device *dev)
+{
+        random_ether_addr(dev->dev_addr);
+}
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+#undef ethtool_ops
+#define ethtool_ops _kc_ethtool_ops
+
+struct _kc_ethtool_ops {
+        int  (*get_settings)(struct net_device *, struct ethtool_cmd *);
+        int  (*set_settings)(struct net_device *, struct ethtool_cmd *);
+        void (*get_drvinfo)(struct net_device *, struct ethtool_drvinfo *);
+        int  (*get_regs_len)(struct net_device *);
+        void (*get_regs)(struct net_device *, struct ethtool_regs *, void *);
+        void (*get_wol)(struct net_device *, struct ethtool_wolinfo *);
+        int  (*set_wol)(struct net_device *, struct ethtool_wolinfo *);
+        u32  (*get_msglevel)(struct net_device *);
+        void (*set_msglevel)(struct net_device *, u32);
+        int  (*nway_reset)(struct net_device *);
+        u32  (*get_link)(struct net_device *);
+        int  (*get_eeprom_len)(struct net_device *);
+        int  (*get_eeprom)(struct net_device *, struct ethtool_eeprom *, u8 *);
+        int  (*set_eeprom)(struct net_device *, struct ethtool_eeprom *, u8 *);
+        int  (*get_coalesce)(struct net_device *, struct ethtool_coalesce *);
+        int  (*set_coalesce)(struct net_device *, struct ethtool_coalesce *);
+        void (*get_ringparam)(struct net_device *, struct ethtool_ringparam *);
+        int  (*set_ringparam)(struct net_device *, struct ethtool_ringparam *);
+        void (*get_pauseparam)(struct net_device *,
+                               struct ethtool_pauseparam*);
+        int  (*set_pauseparam)(struct net_device *,
+                               struct ethtool_pauseparam*);
+        u32  (*get_rx_csum)(struct net_device *);
+        int  (*set_rx_csum)(struct net_device *, u32);
+        u32  (*get_tx_csum)(struct net_device *);
+        int  (*set_tx_csum)(struct net_device *, u32);
+        u32  (*get_sg)(struct net_device *);
+        int  (*set_sg)(struct net_device *, u32);
+        u32  (*get_tso)(struct net_device *);
+        int  (*set_tso)(struct net_device *, u32);
+        int  (*self_test_count)(struct net_device *);
+        void (*self_test)(struct net_device *, struct ethtool_test *, u64 *);
+        void (*get_strings)(struct net_device *, u32 stringset, u8 *);
+        int  (*phys_id)(struct net_device *, u32);
+        int  (*get_stats_count)(struct net_device *);
+        void (*get_ethtool_stats)(struct net_device *, struct ethtool_stats *,
+                                  u64 *);
+} *ethtool_ops = NULL;
+
+#undef SET_ETHTOOL_OPS
+#define SET_ETHTOOL_OPS(netdev, ops) (ethtool_ops = (ops))
+
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,16,0)
+#ifndef SET_ETHTOOL_OPS
+#define SET_ETHTOOL_OPS(netdev,ops) \
+         ( (netdev)->ethtool_ops = (ops) )
+#endif //SET_ETHTOOL_OPS
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(3,16,0)
+
+//#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,5)
+#ifndef netif_msg_init
+#define netif_msg_init _kc_netif_msg_init
+/* copied from linux kernel 2.6.20 include/linux/netdevice.h */
+static inline u32 netif_msg_init(int debug_value, int default_msg_enable_bits)
+{
+        /* use default */
+        if (debug_value < 0 || debug_value >= (sizeof(u32) * 8))
+                return default_msg_enable_bits;
+        if (debug_value == 0)   /* no output */
+                return 0;
+        /* set low N bits */
+        return (1 << debug_value) - 1;
+}
+
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,5)
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,22)
+static inline void eth_copy_and_sum (struct sk_buff *dest,
+                                     const unsigned char *src,
+                                     int len, int base)
+{
+        memcpy (dest->data, src, len);
+}
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,22)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,7)
+/* copied from linux kernel 2.6.20 /include/linux/time.h */
+/* Parameters used to convert the timespec values: */
+#define MSEC_PER_SEC    1000L
+
+/* copied from linux kernel 2.6.20 /include/linux/jiffies.h */
+/*
+ * Change timeval to jiffies, trying to avoid the
+ * most obvious overflows..
+ *
+ * And some not so obvious.
+ *
+ * Note that we don't want to return MAX_LONG, because
+ * for various timeout reasons we often end up having
+ * to wait "jiffies+1" in order to guarantee that we wait
+ * at _least_ "jiffies" - so "jiffies+1" had better still
+ * be positive.
+ */
+#define MAX_JIFFY_OFFSET ((~0UL >> 1)-1)
+
+/*
+ * Convert jiffies to milliseconds and back.
+ *
+ * Avoid unnecessary multiplications/divisions in the
+ * two most common HZ cases:
+ */
+static inline unsigned int _kc_jiffies_to_msecs(const unsigned long j)
+{
+#if HZ <= MSEC_PER_SEC && !(MSEC_PER_SEC % HZ)
+        return (MSEC_PER_SEC / HZ) * j;
+#elif HZ > MSEC_PER_SEC && !(HZ % MSEC_PER_SEC)
+        return (j + (HZ / MSEC_PER_SEC) - 1)/(HZ / MSEC_PER_SEC);
+#else
+        return (j * MSEC_PER_SEC) / HZ;
+#endif
+}
+
+static inline unsigned long _kc_msecs_to_jiffies(const unsigned int m)
+{
+        if (m > _kc_jiffies_to_msecs(MAX_JIFFY_OFFSET))
+                return MAX_JIFFY_OFFSET;
+#if HZ <= MSEC_PER_SEC && !(MSEC_PER_SEC % HZ)
+        return (m + (MSEC_PER_SEC / HZ) - 1) / (MSEC_PER_SEC / HZ);
+#elif HZ > MSEC_PER_SEC && !(HZ % MSEC_PER_SEC)
+        return m * (HZ / MSEC_PER_SEC);
+#else
+        return (m * HZ + MSEC_PER_SEC - 1) / MSEC_PER_SEC;
+#endif
+}
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,7)
+
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,11)
+
+/* copied from linux kernel 2.6.12.6 /include/linux/pm.h */
+typedef int __bitwise pci_power_t;
+
+/* copied from linux kernel 2.6.12.6 /include/linux/pci.h */
+typedef u32 __bitwise pm_message_t;
+
+#define PCI_D0  ((pci_power_t __force) 0)
+#define PCI_D1  ((pci_power_t __force) 1)
+#define PCI_D2  ((pci_power_t __force) 2)
+#define PCI_D3hot   ((pci_power_t __force) 3)
+#define PCI_D3cold  ((pci_power_t __force) 4)
+#define PCI_POWER_ERROR ((pci_power_t __force) -1)
+
+/* copied from linux kernel 2.6.12.6 /drivers/pci/pci.c */
+/**
+ * pci_choose_state - Choose the power state of a PCI device
+ * @dev: PCI device to be suspended
+ * @state: target sleep state for the whole system. This is the value
+ *  that is passed to suspend() function.
+ *
+ * Returns PCI power state suitable for given device and given system
+ * message.
+ */
+
+pci_power_t pci_choose_state(struct pci_dev *dev, pm_message_t state)
+{
+        if (!pci_find_capability(dev, PCI_CAP_ID_PM))
+                return PCI_D0;
+
+        switch (state) {
+        case 0:
+                return PCI_D0;
+        case 3:
+                return PCI_D3hot;
+        default:
+                printk("They asked me for state %d\n", state);
+//      BUG();
+        }
+        return PCI_D0;
+}
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,11)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
+/**
+ * msleep_interruptible - sleep waiting for waitqueue interruptions
+ * @msecs: Time in milliseconds to sleep for
+ */
+#define msleep_interruptible _kc_msleep_interruptible
+unsigned long _kc_msleep_interruptible(unsigned int msecs)
+{
+        unsigned long timeout = _kc_msecs_to_jiffies(msecs);
+
+        while (timeout && !signal_pending(current)) {
+                set_current_state(TASK_INTERRUPTIBLE);
+                timeout = schedule_timeout(timeout);
+        }
+        return _kc_jiffies_to_msecs(timeout);
+}
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,7)
+/* copied from linux kernel 2.6.20 include/linux/sched.h */
+#ifndef __sched
+#define __sched     __attribute__((__section__(".sched.text")))
+#endif
+
+/* copied from linux kernel 2.6.20 kernel/timer.c */
+signed long __sched schedule_timeout_uninterruptible(signed long timeout)
+{
+        __set_current_state(TASK_UNINTERRUPTIBLE);
+        return schedule_timeout(timeout);
+}
+
+/* copied from linux kernel 2.6.20 include/linux/mii.h */
+#undef if_mii
+#define if_mii _kc_if_mii
+static inline struct mii_ioctl_data *if_mii(struct ifreq *rq)
+{
+        return (struct mii_ioctl_data *) &rq->ifr_ifru;
+}
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,7)
+
+struct rtl8125_counters {
+        u64 tx_packets;
+        u64 rx_packets;
+        u64 tx_errors;
+        u32 rx_errors;
+        u16 rx_missed;
+        u16 align_errors;
+        u32 tx_one_collision;
+        u32 tx_multi_collision;
+        u64 rx_unicast;
+        u64 rx_broadcast;
+        u32 rx_multicast;
+        u16 tx_aborted;
+        u16 tx_underun;
+};
+
+#ifdef ENABLE_R8125_PROCFS
+/****************************************************************************
+*   -----------------------------PROCFS STUFF-------------------------
+*****************************************************************************
+*/
+
+static struct proc_dir_entry *rtl8125_proc;
+static int proc_init_num = 0;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+static int proc_get_driver_variable(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        seq_puts(m, "\nDump Driver Variable\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        seq_puts(m, "Variable\tValue\n----------\t-----\n");
+        seq_printf(m, "MODULENAME\t%s\n", MODULENAME);
+        seq_printf(m, "driver version\t%s\n", RTL8125_VERSION);
+        seq_printf(m, "mcfg\t%d\n", tp->mcfg);
+        seq_printf(m, "chipset\t%d\n", tp->chipset);
+        seq_printf(m, "chipset_name\t%s\n", rtl_chip_info[tp->chipset].name);
+        seq_printf(m, "mtu\t%d\n", dev->mtu);
+        seq_printf(m, "NUM_RX_DESC\t0x%x\n", NUM_RX_DESC);
+        seq_printf(m, "cur_rx\t0x%x\n", tp->cur_rx);
+        seq_printf(m, "dirty_rx\t0x%x\n", tp->dirty_rx);
+        seq_printf(m, "NUM_TX_DESC\t0x%x\n", NUM_TX_DESC);
+        seq_printf(m, "cur_tx\t0x%x\n", tp->cur_tx);
+        seq_printf(m, "dirty_tx\t0x%x\n", tp->dirty_tx);
+        seq_printf(m, "rx_buf_sz\t0x%x\n", tp->rx_buf_sz);
+        seq_printf(m, "esd_flag\t0x%x\n", tp->esd_flag);
+        seq_printf(m, "pci_cfg_is_read\t0x%x\n", tp->pci_cfg_is_read);
+        seq_printf(m, "rtl8125_rx_config\t0x%x\n", tp->rtl8125_rx_config);
+        seq_printf(m, "cp_cmd\t0x%x\n", tp->cp_cmd);
+        seq_printf(m, "intr_mask\t0x%x\n", tp->intr_mask);
+        seq_printf(m, "timer_intr_mask\t0x%x\n", tp->timer_intr_mask);
+        seq_printf(m, "wol_enabled\t0x%x\n", tp->wol_enabled);
+        seq_printf(m, "wol_opts\t0x%x\n", tp->wol_opts);
+        seq_printf(m, "efuse_ver\t0x%x\n", tp->efuse_ver);
+        seq_printf(m, "eeprom_type\t0x%x\n", tp->eeprom_type);
+        seq_printf(m, "autoneg\t0x%x\n", tp->autoneg);
+        seq_printf(m, "duplex\t0x%x\n", tp->duplex);
+        seq_printf(m, "speed\t%d\n", tp->speed);
+        seq_printf(m, "advertising\t0x%x\n", tp->advertising);
+        seq_printf(m, "eeprom_len\t0x%x\n", tp->eeprom_len);
+        seq_printf(m, "cur_page\t0x%x\n", tp->cur_page);
+        seq_printf(m, "bios_setting\t0x%x\n", tp->bios_setting);
+        seq_printf(m, "features\t0x%x\n", tp->features);
+        seq_printf(m, "org_pci_offset_99\t0x%x\n", tp->org_pci_offset_99);
+        seq_printf(m, "org_pci_offset_180\t0x%x\n", tp->org_pci_offset_180);
+        seq_printf(m, "issue_offset_99_event\t0x%x\n", tp->issue_offset_99_event);
+        seq_printf(m, "org_pci_offset_80\t0x%x\n", tp->org_pci_offset_80);
+        seq_printf(m, "org_pci_offset_81\t0x%x\n", tp->org_pci_offset_81);
+        seq_printf(m, "use_timer_interrrupt\t0x%x\n", tp->use_timer_interrrupt);
+        seq_printf(m, "HwIcVerUnknown\t0x%x\n", tp->HwIcVerUnknown);
+        seq_printf(m, "NotWrRamCodeToMicroP\t0x%x\n", tp->NotWrRamCodeToMicroP);
+        seq_printf(m, "NotWrMcuPatchCode\t0x%x\n", tp->NotWrMcuPatchCode);
+        seq_printf(m, "HwHasWrRamCodeToMicroP\t0x%x\n", tp->HwHasWrRamCodeToMicroP);
+        seq_printf(m, "sw_ram_code_ver\t0x%x\n", tp->sw_ram_code_ver);
+        seq_printf(m, "hw_ram_code_ver\t0x%x\n", tp->hw_ram_code_ver);
+        seq_printf(m, "rtk_enable_diag\t0x%x\n", tp->rtk_enable_diag);
+        seq_printf(m, "ShortPacketSwChecksum\t0x%x\n", tp->ShortPacketSwChecksum);
+        seq_printf(m, "UseSwPaddingShortPkt\t0x%x\n", tp->UseSwPaddingShortPkt);
+        seq_printf(m, "RequireAdcBiasPatch\t0x%x\n", tp->RequireAdcBiasPatch);
+        seq_printf(m, "AdcBiasPatchIoffset\t0x%x\n", tp->AdcBiasPatchIoffset);
+        seq_printf(m, "RequireAdjustUpsTxLinkPulseTiming\t0x%x\n", tp->RequireAdjustUpsTxLinkPulseTiming);
+        seq_printf(m, "SwrCnt1msIni\t0x%x\n", tp->SwrCnt1msIni);
+        seq_printf(m, "HwSuppNowIsOobVer\t0x%x\n", tp->HwSuppNowIsOobVer);
+        seq_printf(m, "HwFiberModeVer\t0x%x\n", tp->HwFiberModeVer);
+        seq_printf(m, "HwFiberStat\t0x%x\n", tp->HwFiberStat);
+        seq_printf(m, "HwSwitchMdiToFiber\t0x%x\n", tp->HwSwitchMdiToFiber);
+        seq_printf(m, "NicCustLedValue\t0x%x\n", tp->NicCustLedValue);
+        seq_printf(m, "RequiredSecLanDonglePatch\t0x%x\n", tp->RequiredSecLanDonglePatch);
+        seq_printf(m, "HwSuppDashVer\t0x%x\n", tp->HwSuppDashVer);
+        seq_printf(m, "DASH\t0x%x\n", tp->DASH);
+        seq_printf(m, "dash_printer_enabled\t0x%x\n", tp->dash_printer_enabled);
+        seq_printf(m, "HwSuppKCPOffloadVer\t0x%x\n", tp->HwSuppKCPOffloadVer);
+        seq_printf(m, "speed_mode\t0x%x\n", speed_mode);
+        seq_printf(m, "duplex_mode\t0x%x\n", duplex_mode);
+        seq_printf(m, "autoneg_mode\t0x%x\n", autoneg_mode);
+        seq_printf(m, "advertising_mode\t0x%x\n", advertising_mode);
+        seq_printf(m, "aspm\t0x%x\n", aspm);
+        seq_printf(m, "s5wol\t0x%x\n", s5wol);
+        seq_printf(m, "s5_keep_curr_mac\t0x%x\n", s5_keep_curr_mac);
+        seq_printf(m, "eee_enable\t0x%x\n", tp->eee_enabled);
+        seq_printf(m, "hwoptimize\t0x%lx\n", hwoptimize);
+        seq_printf(m, "proc_init_num\t0x%x\n", proc_init_num);
+        seq_printf(m, "s0_magic_packet\t0x%x\n", s0_magic_packet);
+        seq_printf(m, "HwSuppMagicPktVer\t0x%x\n", tp->HwSuppMagicPktVer);
+        seq_printf(m, "HwSuppCheckPhyDisableModeVer\t0x%x\n", tp->HwSuppCheckPhyDisableModeVer);
+        seq_printf(m, "HwPkgDet\t0x%x\n", tp->HwPkgDet);
+        seq_printf(m, "HwSuppGigaForceMode\t0x%x\n", tp->HwSuppGigaForceMode);
+        seq_printf(m, "random_mac\t0x%x\n", tp->random_mac);
+        seq_printf(m, "org_mac_addr\t%pM\n", tp->org_mac_addr);
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+        seq_printf(m, "perm_addr\t%pM\n", dev->perm_addr);
+#endif
+        seq_printf(m, "dev_addr\t%pM\n", dev->dev_addr);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_tally_counter(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct rtl8125_counters *counters;
+        dma_addr_t paddr;
+        u32 cmd;
+        u32 WaitCnt;
+        unsigned long flags;
+
+        seq_puts(m, "\nDump Tally Counter\n");
+
+        //ASSERT_RTNL();
+
+        counters = tp->tally_vaddr;
+        paddr = tp->tally_paddr;
+        if (!counters) {
+                seq_puts(m, "\nDump Tally Counter Fail\n");
+                return 0;
+        }
+
+        spin_lock_irqsave(&tp->lock, flags);
+        RTL_W32(tp, CounterAddrHigh, (u64)paddr >> 32);
+        cmd = (u64)paddr & DMA_BIT_MASK(32);
+        RTL_W32(tp, CounterAddrLow, cmd);
+        RTL_W32(tp, CounterAddrLow, cmd | CounterDump);
+
+        WaitCnt = 0;
+        while (RTL_R32(tp, CounterAddrLow) & CounterDump) {
+                udelay(10);
+
+                WaitCnt++;
+                if (WaitCnt > 20)
+                        break;
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_puts(m, "Statistics\tValue\n----------\t-----\n");
+        seq_printf(m, "tx_packets\t%lld\n", le64_to_cpu(counters->tx_packets));
+        seq_printf(m, "rx_packets\t%lld\n", le64_to_cpu(counters->rx_packets));
+        seq_printf(m, "tx_errors\t%lld\n", le64_to_cpu(counters->tx_errors));
+        seq_printf(m, "rx_missed\t%lld\n", le64_to_cpu(counters->rx_missed));
+        seq_printf(m, "align_errors\t%lld\n", le64_to_cpu(counters->align_errors));
+        seq_printf(m, "tx_one_collision\t%lld\n", le64_to_cpu(counters->tx_one_collision));
+        seq_printf(m, "tx_multi_collision\t%lld\n", le64_to_cpu(counters->tx_multi_collision));
+        seq_printf(m, "rx_unicast\t%lld\n", le64_to_cpu(counters->rx_unicast));
+        seq_printf(m, "rx_broadcast\t%lld\n", le64_to_cpu(counters->rx_broadcast));
+        seq_printf(m, "rx_multicast\t%lld\n", le64_to_cpu(counters->rx_multicast));
+        seq_printf(m, "tx_aborted\t%lld\n", le64_to_cpu(counters->tx_aborted));
+        seq_printf(m, "tx_underun\t%lld\n", le64_to_cpu(counters->tx_underun));
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_registers(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        int i, n, max = R8125_MAC_REGS_SIZE;
+        u8 byte_rd;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+
+        seq_puts(m, "\nDump MAC Registers\n");
+        seq_puts(m, "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                seq_printf(m, "\n0x%02x:\t", n);
+
+                for (i = 0; i < 16 && n < max; i++, n++) {
+                        byte_rd = readb(ioaddr + n);
+                        seq_printf(m, "%02x ", byte_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_pcie_phy(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        int i, n, max = R8125_EPHY_REGS_SIZE/2;
+        u16 word_rd;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        seq_puts(m, "\nDump PCIE PHY\n");
+        seq_puts(m, "\nOffset\tValue\n------\t-----\n ");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                seq_printf(m, "\n0x%02x:\t", n);
+
+                for (i = 0; i < 8 && n < max; i++, n++) {
+                        word_rd = rtl8125_ephy_read(tp, n);
+                        seq_printf(m, "%04x ", word_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_eth_phy(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        int i, n, max = R8125_PHY_REGS_SIZE/2;
+        u16 word_rd;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        seq_puts(m, "\nDump Ethernet PHY\n");
+        seq_puts(m, "\nOffset\tValue\n------\t-----\n ");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        seq_puts(m, "\n####################page 0##################\n ");
+        rtl8125_mdio_write(tp, 0x1f, 0x0000);
+        for (n = 0; n < max;) {
+                seq_printf(m, "\n0x%02x:\t", n);
+
+                for (i = 0; i < 8 && n < max; i++, n++) {
+                        word_rd = rtl8125_mdio_read(tp, n);
+                        seq_printf(m, "%04x ", word_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_extended_registers(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        int i, n, max = R8125_ERI_REGS_SIZE;
+        u32 dword_rd;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        seq_puts(m, "\nDump Extended Registers\n");
+        seq_puts(m, "\nOffset\tValue\n------\t-----\n ");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                seq_printf(m, "\n0x%02x:\t", n);
+
+                for (i = 0; i < 4 && n < max; i++, n+=4) {
+                        dword_rd = rtl8125_eri_read(tp, n, 4, ERIAR_ExGMAC);
+                        seq_printf(m, "%08x ", dword_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_pci_registers(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        int i, n, max = R8125_PCI_REGS_SIZE;
+        u32 dword_rd;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        seq_puts(m, "\nDump PCI Registers\n");
+        seq_puts(m, "\nOffset\tValue\n------\t-----\n ");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                seq_printf(m, "\n0x%03x:\t", n);
+
+                for (i = 0; i < 4 && n < max; i++, n+=4) {
+                        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+                        seq_printf(m, "%08x ", dword_rd);
+                }
+        }
+
+        n = 0x110;
+        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+        seq_printf(m, "\n0x%03x:\t%08x ", n, dword_rd);
+        n = 0x70c;
+        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+        seq_printf(m, "\n0x%03x:\t%08x ", n, dword_rd);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+#else
+
+static int proc_get_driver_variable(char *page, char **start,
+                                    off_t offset, int count,
+                                    int *eof, void *data)
+{
+        struct net_device *dev = data;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump Driver Driver\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        len += snprintf(page + len, count - len,
+                        "Variable\tValue\n----------\t-----\n");
+
+        len += snprintf(page + len, count - len,
+                        "MODULENAME\t%s\n"
+                        "driver version\t%s\n"
+                        "mcfg\t%d\n"
+                        "chipset\t%d\n"
+                        "chipset_name\t%s\n"
+                        "mtu\t%d\n"
+                        "NUM_RX_DESC\t0x%x\n"
+                        "cur_rx\t0x%x\n"
+                        "dirty_rx\t0x%x\n"
+                        "NUM_TX_DESC\t0x%x\n"
+                        "cur_tx\t0x%x\n"
+                        "dirty_tx\t0x%x\n"
+                        "rx_buf_sz\t0x%x\n"
+                        "esd_flag\t0x%x\n"
+                        "pci_cfg_is_read\t0x%x\n"
+                        "rtl8125_rx_config\t0x%x\n"
+                        "cp_cmd\t0x%x\n"
+                        "intr_mask\t0x%x\n"
+                        "timer_intr_mask\t0x%x\n"
+                        "wol_enabled\t0x%x\n"
+                        "wol_opts\t0x%x\n"
+                        "efuse_ver\t0x%x\n"
+                        "eeprom_type\t0x%x\n"
+                        "autoneg\t0x%x\n"
+                        "duplex\t0x%x\n"
+                        "speed\t%d\n"
+                        "advertising\t0x%x\n"
+                        "eeprom_len\t0x%x\n"
+                        "cur_page\t0x%x\n"
+                        "bios_setting\t0x%x\n"
+                        "features\t0x%x\n"
+                        "org_pci_offset_99\t0x%x\n"
+                        "org_pci_offset_180\t0x%x\n"
+                        "issue_offset_99_event\t0x%x\n"
+                        "org_pci_offset_80\t0x%x\n"
+                        "org_pci_offset_81\t0x%x\n"
+                        "use_timer_interrrupt\t0x%x\n"
+                        "HwIcVerUnknown\t0x%x\n"
+                        "NotWrRamCodeToMicroP\t0x%x\n"
+                        "NotWrMcuPatchCode\t0x%x\n"
+                        "HwHasWrRamCodeToMicroP\t0x%x\n"
+                        "sw_ram_code_ver\t0x%x\n"
+                        "hw_ram_code_ver\t0x%x\n"
+                        "rtk_enable_diag\t0x%x\n"
+                        "ShortPacketSwChecksum\t0x%x\n"
+                        "UseSwPaddingShortPkt\t0x%x\n"
+                        "RequireAdcBiasPatch\t0x%x\n"
+                        "AdcBiasPatchIoffset\t0x%x\n"
+                        "RequireAdjustUpsTxLinkPulseTiming\t0x%x\n"
+                        "SwrCnt1msIni\t0x%x\n"
+                        "HwSuppNowIsOobVer\t0x%x\n"
+                        "HwFiberModeVer\t0x%x\n"
+                        "HwFiberStat\t0x%x\n"
+                        "HwSwitchMdiToFiber\t0x%x\n"
+                        "NicCustLedValue\t0x%x\n"
+                        "RequiredSecLanDonglePatch\t0x%x\n"
+                        "HwSuppDashVer\t0x%x\n"
+                        "DASH\t0x%x\n"
+                        "dash_printer_enabled\t0x%x\n"
+                        "HwSuppKCPOffloadVer\t0x%x\n"
+                        "speed_mode\t0x%x\n"
+                        "duplex_mode\t0x%x\n"
+                        "autoneg_mode\t0x%x\n"
+                        "advertising_mode\t0x%x\n"
+                        "aspm\t0x%x\n"
+                        "s5wol\t0x%x\n"
+                        "s5_keep_curr_mac\t0x%x\n"
+                        "eee_enable\t0x%x\n"
+                        "hwoptimize\t0x%lx\n"
+                        "proc_init_num\t0x%x\n"
+                        "s0_magic_packet\t0x%x\n"
+                        "HwSuppMagicPktVer\t0x%x\n"
+                        "HwSuppCheckPhyDisableModeVer\t0x%x\n"
+                        "HwPkgDet\t0x%x\n"
+                        "HwSuppGigaForceMode\t0x%x\n"
+                        "random_mac\t0x%x\n"
+                        "org_mac_addr\t%pM\n"
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+                        "perm_addr\t%pM\n"
+#endif
+                        "dev_addr\t%pM\n",
+                        MODULENAME,
+                        RTL8125_VERSION,
+                        tp->mcfg,
+                        tp->chipset,
+                        rtl_chip_info[tp->chipset].name,
+                        dev->mtu,
+                        NUM_RX_DESC,
+                        tp->cur_rx,
+                        tp->dirty_rx,
+                        NUM_TX_DESC,
+                        tp->cur_tx,
+                        tp->dirty_tx,
+                        tp->rx_buf_sz,
+                        tp->esd_flag,
+                        tp->pci_cfg_is_read,
+                        tp->rtl8125_rx_config,
+                        tp->cp_cmd,
+                        tp->intr_mask,
+                        tp->timer_intr_mask,
+                        tp->wol_enabled,
+                        tp->wol_opts,
+                        tp->efuse_ver,
+                        tp->eeprom_type,
+                        tp->autoneg,
+                        tp->duplex,
+                        tp->speed,
+                        tp->advertising,
+                        tp->eeprom_len,
+                        tp->cur_page,
+                        tp->bios_setting,
+                        tp->features,
+                        tp->org_pci_offset_99,
+                        tp->org_pci_offset_180,
+                        tp->issue_offset_99_event,
+                        tp->org_pci_offset_80,
+                        tp->org_pci_offset_81,
+                        tp->use_timer_interrrupt,
+                        tp->HwIcVerUnknown,
+                        tp->NotWrRamCodeToMicroP,
+                        tp->NotWrMcuPatchCode,
+                        tp->HwHasWrRamCodeToMicroP,
+                        tp->sw_ram_code_ver,
+                        tp->hw_ram_code_ver,
+                        tp->rtk_enable_diag,
+                        tp->ShortPacketSwChecksum,
+                        tp->UseSwPaddingShortPkt,
+                        tp->RequireAdcBiasPatch,
+                        tp->AdcBiasPatchIoffset,
+                        tp->RequireAdjustUpsTxLinkPulseTiming,
+                        tp->SwrCnt1msIni,
+                        tp->HwSuppNowIsOobVer,
+                        tp->HwFiberModeVer,
+                        tp->HwFiberStat,
+                        tp->HwSwitchMdiToFiber,
+                        tp->NicCustLedValue,
+                        tp->RequiredSecLanDonglePatch,
+                        tp->HwSuppDashVer,
+                        tp->DASH,
+                        tp->dash_printer_enabled,
+                        tp->HwSuppKCPOffloadVer,
+                        speed_mode,
+                        duplex_mode,
+                        autoneg_mode,
+                        advertising_mode,
+                        aspm,
+                        s5wol,
+                        s5_keep_curr_mac,
+                        tp->eee_enabled,
+                        hwoptimize,
+                        proc_init_num,
+                        s0_magic_packet,
+                        tp->HwSuppMagicPktVer,
+                        tp->HwSuppCheckPhyDisableModeVer,
+                        tp->HwPkgDet,
+                        tp->HwSuppGigaForceMode,
+                        tp->random_mac,
+                        tp->org_mac_addr,
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+                        dev->perm_addr,
+#endif
+                        dev->dev_addr
+                       );
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_tally_counter(char *page, char **start,
+                                  off_t offset, int count,
+                                  int *eof, void *data)
+{
+        struct net_device *dev = data;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct rtl8125_counters *counters;
+        dma_addr_t paddr;
+        u32 cmd;
+        u32 WaitCnt;
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump Tally Counter\n");
+
+        //ASSERT_RTNL();
+
+        counters = tp->tally_vaddr;
+        paddr = tp->tally_paddr;
+        if (!counters) {
+                len += snprintf(page + len, count - len,
+                                "\nDump Tally Counter Fail\n");
+                goto out;
+        }
+
+        spin_lock_irqsave(&tp->lock, flags);
+        RTL_W32(tp, CounterAddrHigh, (u64)paddr >> 32);
+        cmd = (u64)paddr & DMA_BIT_MASK(32);
+        RTL_W32(tp, CounterAddrLow, cmd);
+        RTL_W32(tp, CounterAddrLow, cmd | CounterDump);
+
+        WaitCnt = 0;
+        while (RTL_R32(tp, CounterAddrLow) & CounterDump) {
+                udelay(10);
+
+                WaitCnt++;
+                if (WaitCnt > 20)
+                        break;
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len,
+                        "Statistics\tValue\n----------\t-----\n");
+
+        len += snprintf(page + len, count - len,
+                        "tx_packets\t%lld\n"
+                        "rx_packets\t%lld\n"
+                        "tx_errors\t%lld\n"
+                        "rx_missed\t%lld\n"
+                        "align_errors\t%lld\n"
+                        "tx_one_collision\t%lld\n"
+                        "tx_multi_collision\t%lld\n"
+                        "rx_unicast\t%lld\n"
+                        "rx_broadcast\t%lld\n"
+                        "rx_multicast\t%lld\n"
+                        "tx_aborted\t%lld\n"
+                        "tx_underun\t%lld\n",
+                        le64_to_cpu(counters->tx_packets),
+                        le64_to_cpu(counters->rx_packets),
+                        le64_to_cpu(counters->tx_errors),
+                        le64_to_cpu(counters->rx_missed),
+                        le64_to_cpu(counters->align_errors),
+                        le64_to_cpu(counters->tx_one_collision),
+                        le64_to_cpu(counters->tx_multi_collision),
+                        le64_to_cpu(counters->rx_unicast),
+                        le64_to_cpu(counters->rx_broadcast),
+                        le64_to_cpu(counters->rx_multicast),
+                        le64_to_cpu(counters->tx_aborted),
+                        le64_to_cpu(counters->tx_underun)
+                       );
+
+        len += snprintf(page + len, count - len, "\n");
+out:
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_registers(char *page, char **start,
+                              off_t offset, int count,
+                              int *eof, void *data)
+{
+        struct net_device *dev = data;
+        int i, n, max = R8125_MAC_REGS_SIZE;
+        u8 byte_rd;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump MAC Registers\n"
+                        "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                len += snprintf(page + len, count - len,
+                                "\n0x%02x:\t",
+                                n);
+
+                for (i = 0; i < 16 && n < max; i++, n++) {
+                        byte_rd = readb(ioaddr + n);
+                        len += snprintf(page + len, count - len,
+                                        "%02x ",
+                                        byte_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_pcie_phy(char *page, char **start,
+                             off_t offset, int count,
+                             int *eof, void *data)
+{
+        struct net_device *dev = data;
+        int i, n, max = R8125_EPHY_REGS_SIZE/2;
+        u16 word_rd;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump PCIE PHY\n"
+                        "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                len += snprintf(page + len, count - len,
+                                "\n0x%02x:\t",
+                                n);
+
+                for (i = 0; i < 8 && n < max; i++, n++) {
+                        word_rd = rtl8125_ephy_read(tp, n);
+                        len += snprintf(page + len, count - len,
+                                        "%04x ",
+                                        word_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_eth_phy(char *page, char **start,
+                            off_t offset, int count,
+                            int *eof, void *data)
+{
+        struct net_device *dev = data;
+        int i, n, max = R8125_PHY_REGS_SIZE/2;
+        u16 word_rd;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump Ethernet PHY\n"
+                        "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        len += snprintf(page + len, count - len,
+                        "\n####################page 0##################\n");
+        rtl8125_mdio_write(tp, 0x1f, 0x0000);
+        for (n = 0; n < max;) {
+                len += snprintf(page + len, count - len,
+                                "\n0x%02x:\t",
+                                n);
+
+                for (i = 0; i < 8 && n < max; i++, n++) {
+                        word_rd = rtl8125_mdio_read(tp, n);
+                        len += snprintf(page + len, count - len,
+                                        "%04x ",
+                                        word_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_extended_registers(char *page, char **start,
+                                       off_t offset, int count,
+                                       int *eof, void *data)
+{
+        struct net_device *dev = data;
+        int i, n, max = R8125_ERI_REGS_SIZE;
+        u32 dword_rd;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump Extended Registers\n"
+                        "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                len += snprintf(page + len, count - len,
+                                "\n0x%02x:\t",
+                                n);
+
+                for (i = 0; i < 4 && n < max; i++, n+=4) {
+                        dword_rd = rtl8125_eri_read(tp, n, 4, ERIAR_ExGMAC);
+                        len += snprintf(page + len, count - len,
+                                        "%08x ",
+                                        dword_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+out:
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_pci_registers(char *page, char **start,
+                                  off_t offset, int count,
+                                  int *eof, void *data)
+{
+        struct net_device *dev = data;
+        int i, n, max = R8125_PCI_REGS_SIZE;
+        u32 dword_rd;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump PCI Registers\n"
+                        "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                len += snprintf(page + len, count - len,
+                                "\n0x%03x:\t",
+                                n);
+
+                for (i = 0; i < 4 && n < max; i++, n+=4) {
+                        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+                        len += snprintf(page + len, count - len,
+                                        "%08x ",
+                                        dword_rd);
+                }
+        }
+
+        n = 0x110;
+        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+        len += snprintf(page + len, count - len,
+                        "\n0x%03x:\t%08x ",
+                        n,
+                        dword_rd);
+        n = 0x70c;
+        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+        len += snprintf(page + len, count - len,
+                        "\n0x%03x:\t%08x ",
+                        n,
+                        dword_rd);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+
+        *eof = 1;
+        return len;
+}
+#endif
+static void rtl8125_proc_module_init(void)
+{
+        //create /proc/net/r8125
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,32)
+        rtl8125_proc = proc_mkdir(MODULENAME, init_net.proc_net);
+#else
+        rtl8125_proc = proc_mkdir(MODULENAME, proc_net);
+#endif
+        if (!rtl8125_proc)
+                dprintk("cannot create %s proc entry \n", MODULENAME);
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+/*
+ * seq_file wrappers for procfile show routines.
+ */
+static int rtl8125_proc_open(struct inode *inode, struct file *file)
+{
+        struct net_device *dev = proc_get_parent_data(inode);
+        int (*show)(struct seq_file *, void *) = PDE_DATA(inode);
+
+        return single_open(file, show, dev);
+}
+
+static const struct file_operations rtl8125_proc_fops = {
+        .open           = rtl8125_proc_open,
+        .read           = seq_read,
+        .llseek         = seq_lseek,
+        .release        = single_release,
+};
+#endif
+
+/*
+ * Table of proc files we need to create.
+ */
+struct rtl8125_proc_file {
+        char name[12];
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+        int (*show)(struct seq_file *, void *);
+#else
+        int (*show)(char *, char **, off_t, int, int *, void *);
+#endif
+};
+
+static const struct rtl8125_proc_file rtl8125_proc_files[] = {
+        { "driver_var", &proc_get_driver_variable },
+        { "tally", &proc_get_tally_counter },
+        { "registers", &proc_get_registers },
+        { "pcie_phy", &proc_get_pcie_phy },
+        { "eth_phy", &proc_get_eth_phy },
+        { "ext_regs", &proc_get_extended_registers },
+        { "pci_regs", &proc_get_pci_registers },
+        { "" }
+};
+
+static void rtl8125_proc_init(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        const struct rtl8125_proc_file *f;
+        struct proc_dir_entry *dir;
+
+        if (rtl8125_proc && !tp->proc_dir) {
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+                dir = proc_mkdir_data(dev->name, 0, rtl8125_proc, dev);
+                if (!dir) {
+                        printk("Unable to initialize /proc/net/%s/%s\n",
+                               MODULENAME, dev->name);
+                        return;
+                }
+
+                tp->proc_dir = dir;
+                proc_init_num++;
+
+                for (f = rtl8125_proc_files; f->name[0]; f++) {
+                        if (!proc_create_data(f->name, S_IFREG | S_IRUGO, dir,
+                                              &rtl8125_proc_fops, f->show)) {
+                                printk("Unable to initialize "
+                                       "/proc/net/%s/%s/%s\n",
+                                       MODULENAME, dev->name, f->name);
+                                return;
+                        }
+                }
+#else
+                dir = proc_mkdir(dev->name, rtl8125_proc);
+                if (!dir) {
+                        printk("Unable to initialize /proc/net/%s/%s\n",
+                               MODULENAME, dev->name);
+                        return;
+                }
+
+                tp->proc_dir = dir;
+                proc_init_num++;
+
+                for (f = rtl8125_proc_files; f->name[0]; f++) {
+                        if (!create_proc_read_entry(f->name, S_IFREG | S_IRUGO,
+                                                    dir, f->show, dev)) {
+                                printk("Unable to initialize "
+                                       "/proc/net/%s/%s/%s\n",
+                                       MODULENAME, dev->name, f->name);
+                                return;
+                        }
+                }
+#endif
+        }
+}
+
+static void rtl8125_proc_remove(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        if (tp->proc_dir) {
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+                remove_proc_subtree(dev->name, rtl8125_proc);
+                proc_init_num--;
+
+#else
+                const struct rtl8125_proc_file *f;
+                struct rtl8125_private *tp = netdev_priv(dev);
+
+                for (f = rtl8125_proc_files; f->name[0]; f++)
+                        remove_proc_entry(f->name, tp->proc_dir);
+
+                remove_proc_entry(dev->name, rtl8125_proc);
+                proc_init_num--;
+#endif
+                tp->proc_dir = NULL;
+        }
+}
+
+#endif //ENABLE_R8125_PROCFS
+
+static inline u16 map_phy_ocp_addr(u16 PageNum, u8 RegNum)
+{
+        u16 OcpPageNum = 0;
+        u8 OcpRegNum = 0;
+        u16 OcpPhyAddress = 0;
+
+        if ( PageNum == 0 ) {
+                OcpPageNum = OCP_STD_PHY_BASE_PAGE + ( RegNum / 8 );
+                OcpRegNum = 0x10 + ( RegNum % 8 );
+        } else {
+                OcpPageNum = PageNum;
+                OcpRegNum = RegNum;
+        }
+
+        OcpPageNum <<= 4;
+
+        if ( OcpRegNum < 16 ) {
+                OcpPhyAddress = 0;
+        } else {
+                OcpRegNum -= 16;
+                OcpRegNum <<= 1;
+
+                OcpPhyAddress = OcpPageNum + OcpRegNum;
+        }
+
+
+        return OcpPhyAddress;
+}
+
+static void mdio_real_write_phy_ocp(struct rtl8125_private *tp,
+                                    u16 RegAddr,
+                                    u16 value)
+{
+        u32 data32;
+        int i;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)
+        WARN_ON_ONCE(RegAddr % 2);
+#endif
+        data32 = RegAddr/2;
+        data32 <<= OCPR_Addr_Reg_shift;
+        data32 |= OCPR_Write | value;
+
+        RTL_W32(tp, PHYOCP, data32);
+        for (i = 0; i < 100; i++) {
+                udelay(1);
+
+                if (!(RTL_R32(tp, PHYOCP) & OCPR_Flag))
+                        break;
+        }
+}
+
+static void mdio_direct_write_phy_ocp(struct rtl8125_private *tp,
+                                      u16 RegAddr,
+                                      u16 value)
+{
+        if (tp->rtk_enable_diag) return;
+
+        mdio_real_write_phy_ocp(tp, RegAddr, value);
+}
+
+static void rtl8125_mdio_write_phy_ocp(struct rtl8125_private *tp,
+                                       u16 PageNum,
+                                       u32 RegAddr,
+                                       u32 value)
+{
+        u16 ocp_addr;
+
+        ocp_addr = map_phy_ocp_addr(PageNum, RegAddr);
+
+        mdio_direct_write_phy_ocp(tp, ocp_addr, value);
+}
+
+static void mdio_real_write(struct rtl8125_private *tp,
+                            u32 RegAddr,
+                            u32 value)
+{
+        if (RegAddr == 0x1F) {
+                tp->cur_page = value;
+                return;
+        }
+        rtl8125_mdio_write_phy_ocp(tp, tp->cur_page, RegAddr, value);
+}
+
+void rtl8125_mdio_write(struct rtl8125_private *tp,
+                        u32 RegAddr,
+                        u32 value)
+{
+        if (tp->rtk_enable_diag) return;
+
+        mdio_real_write(tp, RegAddr, value);
+}
+
+void rtl8125_mdio_prot_write(struct rtl8125_private *tp,
+                             u32 RegAddr,
+                             u32 value)
+{
+        mdio_real_write(tp, RegAddr, value);
+}
+
+void rtl8125_mdio_prot_write_phy_ocp(struct rtl8125_private *tp,
+                                     u32 RegAddr,
+                                     u32 value)
+{
+        mdio_real_write_phy_ocp(tp, RegAddr, value);
+}
+
+static u32 mdio_real_read_phy_ocp(struct rtl8125_private *tp,
+                                  u16 RegAddr)
+{
+        u32 data32;
+        int i, value = 0;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)
+        WARN_ON_ONCE(RegAddr % 2);
+#endif
+        data32 = RegAddr/2;
+        data32 <<= OCPR_Addr_Reg_shift;
+
+        RTL_W32(tp, PHYOCP, data32);
+        for (i = 0; i < 100; i++) {
+                udelay(1);
+
+                if (RTL_R32(tp, PHYOCP) & OCPR_Flag)
+                        break;
+        }
+        value = RTL_R32(tp, PHYOCP) & OCPDR_Data_Mask;
+
+        return value;
+}
+
+static u32 mdio_direct_read_phy_ocp(struct rtl8125_private *tp,
+                                    u16 RegAddr)
+{
+        if (tp->rtk_enable_diag) return 0xffffffff;
+
+        return mdio_real_read_phy_ocp(tp, RegAddr);
+}
+
+static u32 rtl8125_mdio_read_phy_ocp(struct rtl8125_private *tp,
+                                     u16 PageNum,
+                                     u32 RegAddr)
+{
+        u16 ocp_addr;
+
+        ocp_addr = map_phy_ocp_addr(PageNum, RegAddr);
+
+        return mdio_direct_read_phy_ocp(tp, ocp_addr);
+}
+
+static u32 mdio_real_read(struct rtl8125_private *tp,
+                          u32 RegAddr)
+{
+        return rtl8125_mdio_read_phy_ocp(tp, tp->cur_page, RegAddr);
+}
+
+u32 rtl8125_mdio_read(struct rtl8125_private *tp,
+                      u32 RegAddr)
+{
+        if (tp->rtk_enable_diag) return 0xffffffff;
+
+        return mdio_real_read(tp, RegAddr);
+}
+
+u32 rtl8125_mdio_prot_read(struct rtl8125_private *tp,
+                           u32 RegAddr)
+{
+        return mdio_real_read(tp, RegAddr);
+}
+
+u32 rtl8125_mdio_prot_read_phy_ocp(struct rtl8125_private *tp,
+                                   u32 RegAddr)
+{
+        return mdio_real_read_phy_ocp(tp, RegAddr);
+}
+
+static void ClearAndSetEthPhyBit(struct rtl8125_private *tp, u8  addr, u16 clearmask, u16 setmask)
+{
+        u16 PhyRegValue;
+
+        PhyRegValue = rtl8125_mdio_read(tp, addr);
+        PhyRegValue &= ~clearmask;
+        PhyRegValue |= setmask;
+        rtl8125_mdio_write(tp, addr, PhyRegValue);
+}
+
+void rtl8125_clear_eth_phy_bit(struct rtl8125_private *tp, u8 addr, u16 mask)
+{
+        ClearAndSetEthPhyBit(tp,
+                             addr,
+                             mask,
+                             0
+                            );
+}
+
+void rtl8125_set_eth_phy_bit(struct rtl8125_private *tp,  u8  addr, u16  mask)
+{
+        ClearAndSetEthPhyBit(tp,
+                             addr,
+                             0,
+                             mask
+                            );
+}
+
+static void ClearAndSetEthPhyOcpBit(struct rtl8125_private *tp, u16 addr, u16 clearmask, u16 setmask)
+{
+        u16 PhyRegValue;
+
+        PhyRegValue = mdio_direct_read_phy_ocp(tp, addr);
+        PhyRegValue &= ~clearmask;
+        PhyRegValue |= setmask;
+        mdio_direct_write_phy_ocp(tp, addr, PhyRegValue);
+}
+
+void ClearEthPhyOcpBit(struct rtl8125_private *tp, u16 addr, u16 mask)
+{
+        ClearAndSetEthPhyOcpBit(tp,
+                                addr,
+                                mask,
+                                0
+                               );
+}
+
+void SetEthPhyOcpBit(struct rtl8125_private *tp,  u16 addr, u16 mask)
+{
+        ClearAndSetEthPhyOcpBit(tp,
+                                addr,
+                                0,
+                                mask
+                               );
+}
+
+void rtl8125_mac_ocp_write(struct rtl8125_private *tp, u16 reg_addr, u16 value)
+{
+        u32 data32;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)
+        WARN_ON_ONCE(reg_addr % 2);
+#endif
+
+        data32 = reg_addr/2;
+        data32 <<= OCPR_Addr_Reg_shift;
+        data32 += value;
+        data32 |= OCPR_Write;
+
+        RTL_W32(tp, MACOCP, data32);
+}
+
+u16 rtl8125_mac_ocp_read(struct rtl8125_private *tp, u16 reg_addr)
+{
+        u32 data32;
+        u16 data16 = 0;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)
+        WARN_ON_ONCE(reg_addr % 2);
+#endif
+
+        data32 = reg_addr/2;
+        data32 <<= OCPR_Addr_Reg_shift;
+
+        RTL_W32(tp, MACOCP, data32);
+        data16 = (u16)RTL_R32(tp, MACOCP);
+
+        return data16;
+}
+
+void
+ClearAndSetMcuAccessRegBit(
+        struct rtl8125_private *tp,
+        u16   addr,
+        u16   clearmask,
+        u16   setmask
+)
+{
+        u16 PhyRegValue;
+
+        PhyRegValue = rtl8125_mac_ocp_read(tp, addr);
+        PhyRegValue &= ~clearmask;
+        PhyRegValue |= setmask;
+        rtl8125_mac_ocp_write(tp, addr, PhyRegValue);
+}
+
+void
+ClearMcuAccessRegBit(
+        struct rtl8125_private *tp,
+        u16   addr,
+        u16   mask
+)
+{
+        ClearAndSetMcuAccessRegBit(tp,
+                                   addr,
+                                   mask,
+                                   0
+                                  );
+}
+
+void
+SetMcuAccessRegBit(
+        struct rtl8125_private *tp,
+        u16   addr,
+        u16   mask
+)
+{
+        ClearAndSetMcuAccessRegBit(tp,
+                                   addr,
+                                   0,
+                                   mask
+                                  );
+}
+
+u32 rtl8125_ocp_read_with_oob_base_address(struct rtl8125_private *tp, u16 addr, u8 len, const u32 base_address)
+{
+        return rtl8125_eri_read_with_oob_base_address(tp, addr, len, ERIAR_OOB, base_address);
+}
+
+u32 rtl8125_ocp_read(struct rtl8125_private *tp, u16 addr, u8 len)
+{
+        u32 value = 0;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp))
+                value = rtl8125_ocp_read_with_oob_base_address(tp, addr, len, NO_BASE_ADDRESS);
+        else if (HW_DASH_SUPPORT_TYPE_3(tp))
+                value = rtl8125_ocp_read_with_oob_base_address(tp, addr, len, RTL8168FP_OOBMAC_BASE);
+
+        return value;
+}
+
+u32 rtl8125_ocp_write_with_oob_base_address(struct rtl8125_private *tp, u16 addr, u8 len, u32 value, const u32 base_address)
+{
+        return rtl8125_eri_write_with_oob_base_address(tp, addr, len, value, ERIAR_OOB, base_address);
+}
+
+void rtl8125_ocp_write(struct rtl8125_private *tp, u16 addr, u8 len, u32 value)
+{
+        if (HW_DASH_SUPPORT_TYPE_2(tp))
+                rtl8125_ocp_write_with_oob_base_address(tp, addr, len, value, NO_BASE_ADDRESS);
+        else if (HW_DASH_SUPPORT_TYPE_3(tp))
+                rtl8125_ocp_write_with_oob_base_address(tp, addr, len, value, RTL8168FP_OOBMAC_BASE);
+}
+
+void rtl8125_oob_mutex_lock(struct rtl8125_private *tp)
+{
+        u8 reg_16, reg_a0;
+        u32 wait_cnt_0, wait_Cnt_1;
+        u16 ocp_reg_mutex_ib;
+        u16 ocp_reg_mutex_oob;
+        u16 ocp_reg_mutex_prio;
+
+        if (!tp->DASH) return;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        default:
+                ocp_reg_mutex_oob = 0x110;
+                ocp_reg_mutex_ib = 0x114;
+                ocp_reg_mutex_prio = 0x11C;
+                break;
+        }
+
+        rtl8125_ocp_write(tp, ocp_reg_mutex_ib, 1, BIT_0);
+        reg_16 = rtl8125_ocp_read(tp, ocp_reg_mutex_oob, 1);
+        wait_cnt_0 = 0;
+        while(reg_16) {
+                reg_a0 = rtl8125_ocp_read(tp, ocp_reg_mutex_prio, 1);
+                if (reg_a0) {
+                        rtl8125_ocp_write(tp, ocp_reg_mutex_ib, 1, 0x00);
+                        reg_a0 = rtl8125_ocp_read(tp, ocp_reg_mutex_prio, 1);
+                        wait_Cnt_1 = 0;
+                        while(reg_a0) {
+                                reg_a0 = rtl8125_ocp_read(tp, ocp_reg_mutex_prio, 1);
+
+                                wait_Cnt_1++;
+
+                                if (wait_Cnt_1 > 2000)
+                                        break;
+                        };
+                        rtl8125_ocp_write(tp, ocp_reg_mutex_ib, 1, BIT_0);
+
+                }
+                reg_16 = rtl8125_ocp_read(tp, ocp_reg_mutex_oob, 1);
+
+                wait_cnt_0++;
+
+                if (wait_cnt_0 > 2000)
+                        break;
+        };
+}
+
+void rtl8125_oob_mutex_unlock(struct rtl8125_private *tp)
+{
+        u16 ocp_reg_mutex_ib;
+        u16 ocp_reg_mutex_oob;
+        u16 ocp_reg_mutex_prio;
+
+        if (!tp->DASH) return;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        default:
+                ocp_reg_mutex_oob = 0x110;
+                ocp_reg_mutex_ib = 0x114;
+                ocp_reg_mutex_prio = 0x11C;
+                break;
+        }
+
+        rtl8125_ocp_write(tp, ocp_reg_mutex_prio, 1, BIT_0);
+        rtl8125_ocp_write(tp, ocp_reg_mutex_ib, 1, 0x00);
+}
+
+void rtl8125_oob_notify(struct rtl8125_private *tp, u8 cmd)
+{
+        rtl8125_eri_write(tp, 0xE8, 1, cmd, ERIAR_ExGMAC);
+
+        rtl8125_ocp_write(tp, 0x30, 1, 0x01);
+}
+
+static int rtl8125_check_dash(struct rtl8125_private *tp)
+{
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                if (rtl8125_ocp_read(tp, 0x128, 1) & BIT_0)
+                        return 1;
+        }
+
+        return 0;
+}
+
+void rtl8125_dash2_disable_tx(struct rtl8125_private *tp)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                u16 WaitCnt;
+                u8 TmpUchar;
+
+                //Disable oob Tx
+                RTL_CMAC_W8(tp, CMAC_IBCR2, RTL_CMAC_R8(tp, CMAC_IBCR2) & ~( BIT_0 ));
+                WaitCnt = 0;
+
+                //wait oob tx disable
+                do {
+                        TmpUchar = RTL_CMAC_R8(tp, CMAC_IBISR0);
+
+                        if ( TmpUchar & ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE ) {
+                                break;
+                        }
+
+                        udelay( 50 );
+                        WaitCnt++;
+                } while(WaitCnt < 2000);
+
+                //Clear ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE
+                RTL_CMAC_W8(tp, CMAC_IBISR0, RTL_CMAC_R8(tp, CMAC_IBISR0) | ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE);
+        }
+}
+
+void rtl8125_dash2_enable_tx(struct rtl8125_private *tp)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                RTL_CMAC_W8(tp, CMAC_IBCR2, RTL_CMAC_R8(tp, CMAC_IBCR2) | BIT_0);
+        }
+}
+
+void rtl8125_dash2_disable_rx(struct rtl8125_private *tp)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                RTL_CMAC_W8(tp, CMAC_IBCR0, RTL_CMAC_R8(tp, CMAC_IBCR0) & ~( BIT_0 ));
+        }
+}
+
+void rtl8125_dash2_enable_rx(struct rtl8125_private *tp)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                RTL_CMAC_W8(tp, CMAC_IBCR0, RTL_CMAC_R8(tp, CMAC_IBCR0) | BIT_0);
+        }
+}
+
+static void rtl8125_dash2_disable_txrx(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                rtl8125_dash2_disable_tx( tp );
+                rtl8125_dash2_disable_rx( tp );
+        }
+}
+
+static void rtl8125_driver_start(struct rtl8125_private *tp)
+{
+        if (!tp->DASH)
+                return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                int timeout;
+                u32 tmp_value;
+
+                rtl8125_ocp_write(tp, 0x180, 1, OOB_CMD_DRIVER_START);
+                tmp_value = rtl8125_ocp_read(tp, 0x30, 1);
+                tmp_value |= BIT_0;
+                rtl8125_ocp_write(tp, 0x30, 1, tmp_value);
+
+                for (timeout = 0; timeout < 10; timeout++) {
+                        mdelay(10);
+                        if (rtl8125_ocp_read(tp, 0x124, 1) & BIT_0)
+                                break;
+                }
+        }
+}
+
+static void rtl8125_driver_stop(struct rtl8125_private *tp)
+{
+        if (!tp->DASH)
+                return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                struct net_device *dev = tp->dev;
+                int timeout;
+                u32 tmp_value;
+
+                rtl8125_dash2_disable_txrx(dev);
+
+                rtl8125_ocp_write(tp, 0x180, 1, OOB_CMD_DRIVER_STOP);
+                tmp_value = rtl8125_ocp_read(tp, 0x30, 1);
+                tmp_value |= BIT_0;
+                rtl8125_ocp_write(tp, 0x30, 1, tmp_value);
+
+                for (timeout = 0; timeout < 10; timeout++) {
+                        mdelay(10);
+                        if (!(rtl8125_ocp_read(tp, 0x124, 1) & BIT_0))
+                                break;
+                }
+        }
+}
+
+void rtl8125_ephy_write(struct rtl8125_private *tp, int RegAddr, int value)
+{
+        int i;
+
+        RTL_W32(tp, EPHYAR,
+                EPHYAR_Write |
+                (RegAddr & EPHYAR_Reg_Mask_v2) << EPHYAR_Reg_shift |
+                (value & EPHYAR_Data_Mask));
+
+        for (i = 0; i < 10; i++) {
+                udelay(100);
+
+                /* Check if the RTL8125 has completed EPHY write */
+                if (!(RTL_R32(tp, EPHYAR) & EPHYAR_Flag))
+                        break;
+        }
+
+        udelay(20);
+}
+
+u16 rtl8125_ephy_read(struct rtl8125_private *tp, int RegAddr)
+{
+        int i;
+        u16 value = 0xffff;
+
+        RTL_W32(tp, EPHYAR,
+                EPHYAR_Read | (RegAddr & EPHYAR_Reg_Mask_v2) << EPHYAR_Reg_shift);
+
+        for (i = 0; i < 10; i++) {
+                udelay(100);
+
+                /* Check if the RTL8125 has completed EPHY read */
+                if (RTL_R32(tp, EPHYAR) & EPHYAR_Flag) {
+                        value = (u16) (RTL_R32(tp, EPHYAR) & EPHYAR_Data_Mask);
+                        break;
+                }
+        }
+
+        udelay(20);
+
+        return value;
+}
+
+static void ClearAndSetPCIePhyBit(struct rtl8125_private *tp, u8 addr, u16 clearmask, u16 setmask)
+{
+        u16 EphyValue;
+
+        EphyValue = rtl8125_ephy_read(tp, addr);
+        EphyValue &= ~clearmask;
+        EphyValue |= setmask;
+        rtl8125_ephy_write(tp, addr, EphyValue);
+}
+
+static void ClearPCIePhyBit(struct rtl8125_private *tp, u8 addr, u16 mask)
+{
+        ClearAndSetPCIePhyBit( tp,
+                               addr,
+                               mask,
+                               0
+                             );
+}
+
+static void SetPCIePhyBit( struct rtl8125_private *tp, u8 addr, u16 mask)
+{
+        ClearAndSetPCIePhyBit( tp,
+                               addr,
+                               0,
+                               mask
+                             );
+}
+
+static u32
+rtl8125_csi_other_fun_read(struct rtl8125_private *tp,
+                           u8 multi_fun_sel_bit,
+                           u32 addr)
+{
+        u32 cmd;
+        int i;
+        u32 value = 0;
+
+        cmd = CSIAR_Read | CSIAR_ByteEn << CSIAR_ByteEn_shift | (addr & CSIAR_Addr_Mask);
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                multi_fun_sel_bit = 0;
+
+        if (multi_fun_sel_bit > 7)
+                return 0xffffffff;
+
+        cmd |= multi_fun_sel_bit << 16;
+
+        RTL_W32(tp, CSIAR, cmd);
+
+        for (i = 0; i < 10; i++) {
+                udelay(100);
+
+                /* Check if the RTL8125 has completed CSI read */
+                if (RTL_R32(tp, CSIAR) & CSIAR_Flag) {
+                        value = (u32)RTL_R32(tp, CSIDR);
+                        break;
+                }
+        }
+
+        udelay(20);
+
+        return value;
+}
+
+static void
+rtl8125_csi_other_fun_write(struct rtl8125_private *tp,
+                            u8 multi_fun_sel_bit,
+                            u32 addr,
+                            u32 value)
+{
+        u32 cmd;
+        int i;
+
+        RTL_W32(tp, CSIDR, value);
+        cmd = CSIAR_Write | CSIAR_ByteEn << CSIAR_ByteEn_shift | (addr & CSIAR_Addr_Mask);
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                multi_fun_sel_bit = 0;
+
+        if ( multi_fun_sel_bit > 7 )
+                return;
+
+        cmd |= multi_fun_sel_bit << 16;
+
+        RTL_W32(tp, CSIAR, cmd);
+
+        for (i = 0; i < 10; i++) {
+                udelay(100);
+
+                /* Check if the RTL8125 has completed CSI write */
+                if (!(RTL_R32(tp, CSIAR) & CSIAR_Flag))
+                        break;
+        }
+
+        udelay(20);
+}
+
+static u32
+rtl8125_csi_read(struct rtl8125_private *tp,
+                 u32 addr)
+{
+        u8 multi_fun_sel_bit;
+
+        multi_fun_sel_bit = 0;
+
+        return rtl8125_csi_other_fun_read(tp, multi_fun_sel_bit, addr);
+}
+
+static void
+rtl8125_csi_write(struct rtl8125_private *tp,
+                  u32 addr,
+                  u32 value)
+{
+        u8 multi_fun_sel_bit;
+
+        multi_fun_sel_bit = 0;
+
+        rtl8125_csi_other_fun_write(tp, multi_fun_sel_bit, addr, value);
+}
+
+static u8
+rtl8125_csi_fun0_read_byte(struct rtl8125_private *tp,
+                           u32 addr)
+{
+        u8 RetVal = 0;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT) {
+                struct pci_dev *pdev = tp->pci_dev;
+
+                pci_read_config_byte(pdev, addr, &RetVal);
+        } else {
+                u32 TmpUlong;
+                u16 RegAlignAddr;
+                u8 ShiftByte;
+
+                RegAlignAddr = addr & ~(0x3);
+                ShiftByte = addr & (0x3);
+                TmpUlong = rtl8125_csi_other_fun_read(tp, 0, addr);
+                TmpUlong >>= (8*ShiftByte);
+                RetVal = (u8)TmpUlong;
+        }
+
+        udelay(20);
+
+        return RetVal;
+}
+
+static void
+rtl8125_csi_fun0_write_byte(struct rtl8125_private *tp,
+                            u32 addr,
+                            u8 value)
+{
+        if (tp->mcfg == CFG_METHOD_DEFAULT) {
+                struct pci_dev *pdev = tp->pci_dev;
+
+                pci_write_config_byte(pdev, addr, value);
+        } else {
+                u32 TmpUlong;
+                u16 RegAlignAddr;
+                u8 ShiftByte;
+
+                RegAlignAddr = addr & ~(0x3);
+                ShiftByte = addr & (0x3);
+                TmpUlong = rtl8125_csi_other_fun_read(tp, 0, RegAlignAddr);
+                TmpUlong &= ~(0xFF << (8*ShiftByte));
+                TmpUlong |= (value << (8*ShiftByte));
+                rtl8125_csi_other_fun_write( tp, 0, RegAlignAddr, TmpUlong );
+        }
+
+        udelay(20);
+}
+
+u32 rtl8125_eri_read_with_oob_base_address(struct rtl8125_private *tp, int addr, int len, int type, const u32 base_address)
+{
+        int i, val_shift, shift = 0;
+        u32 value1 = 0, value2 = 0, mask;
+        u32 eri_cmd;
+        const u32 transformed_base_address = ((base_address & 0x00FFF000) << 6) | (base_address & 0x000FFF);
+
+        if (len > 4 || len <= 0)
+                return -1;
+
+        while (len > 0) {
+                val_shift = addr % ERIAR_Addr_Align;
+                addr = addr & ~0x3;
+
+                eri_cmd = ERIAR_Read |
+                          transformed_base_address |
+                          type << ERIAR_Type_shift |
+                          ERIAR_ByteEn << ERIAR_ByteEn_shift |
+                          (addr & 0x0FFF);
+                if (addr & 0xF000) {
+                        u32 tmp;
+
+                        tmp = addr & 0xF000;
+                        tmp >>= 12;
+                        eri_cmd |= (tmp << 20) & 0x00F00000;
+                }
+
+                RTL_W32(tp, ERIAR, eri_cmd);
+
+                for (i = 0; i < 10; i++) {
+                        udelay(100);
+
+                        /* Check if the RTL8125 has completed ERI read */
+                        if (RTL_R32(tp, ERIAR) & ERIAR_Flag)
+                                break;
+                }
+
+                if (len == 1)       mask = (0xFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 2)  mask = (0xFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 3)  mask = (0xFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else            mask = (0xFFFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+
+                value1 = RTL_R32(tp, ERIDR) & mask;
+                value2 |= (value1 >> val_shift * 8) << shift * 8;
+
+                if (len <= 4 - val_shift) {
+                        len = 0;
+                } else {
+                        len -= (4 - val_shift);
+                        shift = 4 - val_shift;
+                        addr += 4;
+                }
+        }
+
+        udelay(20);
+
+        return value2;
+}
+
+u32 rtl8125_eri_read(struct rtl8125_private *tp, int addr, int len, int type)
+{
+        return rtl8125_eri_read_with_oob_base_address(tp, addr, len, type, 0);
+}
+
+int rtl8125_eri_write_with_oob_base_address(struct rtl8125_private *tp, int addr, int len, u32 value, int type, const u32 base_address)
+{
+        int i, val_shift, shift = 0;
+        u32 value1 = 0, mask;
+        u32 eri_cmd;
+        const u32 transformed_base_address = ((base_address & 0x00FFF000) << 6) | (base_address & 0x000FFF);
+
+        if (len > 4 || len <= 0)
+                return -1;
+
+        while (len > 0) {
+                val_shift = addr % ERIAR_Addr_Align;
+                addr = addr & ~0x3;
+
+                if (len == 1)       mask = (0xFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 2)  mask = (0xFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 3)  mask = (0xFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else            mask = (0xFFFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+
+                value1 = rtl8125_eri_read_with_oob_base_address(tp, addr, 4, type, base_address) & ~mask;
+                value1 |= ((value << val_shift * 8) >> shift * 8);
+
+                RTL_W32(tp, ERIDR, value1);
+
+                eri_cmd = ERIAR_Write |
+                          transformed_base_address |
+                          type << ERIAR_Type_shift |
+                          ERIAR_ByteEn << ERIAR_ByteEn_shift |
+                          (addr & 0x0FFF);
+                if (addr & 0xF000) {
+                        u32 tmp;
+
+                        tmp = addr & 0xF000;
+                        tmp >>= 12;
+                        eri_cmd |= (tmp << 20) & 0x00F00000;
+                }
+
+                RTL_W32(tp, ERIAR, eri_cmd);
+
+                for (i = 0; i < 10; i++) {
+                        udelay(100);
+
+                        /* Check if the RTL8125 has completed ERI write */
+                        if (!(RTL_R32(tp, ERIAR) & ERIAR_Flag))
+                                break;
+                }
+
+                if (len <= 4 - val_shift) {
+                        len = 0;
+                } else {
+                        len -= (4 - val_shift);
+                        shift = 4 - val_shift;
+                        addr += 4;
+                }
+        }
+
+        udelay(20);
+
+        return 0;
+}
+
+int rtl8125_eri_write(struct rtl8125_private *tp, int addr, int len, u32 value, int type)
+{
+        return rtl8125_eri_write_with_oob_base_address(tp, addr, len, value, type, NO_BASE_ADDRESS);
+}
+
+static void
+rtl8125_enable_rxdvgate(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                RTL_W8(tp, 0xF2, RTL_R8(tp, 0xF2) | BIT_3);
+                mdelay(2);
+                break;
+        }
+}
+
+static void
+rtl8125_disable_rxdvgate(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                RTL_W8(tp, 0xF2, RTL_R8(tp, 0xF2) & ~BIT_3);
+                mdelay(2);
+                break;
+        }
+}
+
+static u8
+rtl8125_is_gpio_low(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u8 gpio_low = FALSE;
+
+        switch (tp->HwSuppCheckPhyDisableModeVer) {
+        case 3:
+                if (!(rtl8125_mac_ocp_read(tp, 0xDC04) & BIT_13))
+                        gpio_low = TRUE;
+                break;
+        }
+
+        if (gpio_low)
+                dprintk("gpio is low.\n");
+
+        return gpio_low;
+}
+
+static u8
+rtl8125_is_phy_disable_mode_enabled(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u8 phy_disable_mode_enabled = FALSE;
+
+        switch (tp->HwSuppCheckPhyDisableModeVer) {
+        case 3:
+                if (RTL_R8(tp, 0xF2) & BIT_5)
+                        phy_disable_mode_enabled = TRUE;
+                break;
+        }
+
+        if (phy_disable_mode_enabled)
+                dprintk("phy disable mode enabled.\n");
+
+        return phy_disable_mode_enabled;
+}
+
+static u8
+rtl8125_is_in_phy_disable_mode(struct net_device *dev)
+{
+        u8 in_phy_disable_mode = FALSE;
+
+        if (rtl8125_is_phy_disable_mode_enabled(dev) && rtl8125_is_gpio_low(dev))
+                in_phy_disable_mode = TRUE;
+
+        if (in_phy_disable_mode)
+                dprintk("Hardware is in phy disable mode.\n");
+
+        return in_phy_disable_mode;
+}
+
+static void
+rtl8125_enable_phy_disable_mode(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->HwSuppCheckPhyDisableModeVer) {
+        case 3:
+                RTL_W8(tp, 0xF2, RTL_R8(tp, 0xF2) | BIT_5);
+                break;
+        }
+
+        dprintk("enable phy disable mode.\n");
+}
+
+static void
+rtl8125_disable_phy_disable_mode(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->HwSuppCheckPhyDisableModeVer) {
+        case 3:
+                RTL_W8(tp, 0xF2, RTL_R8(tp, 0xF2) & ~BIT_5);
+                break;
+        }
+
+        mdelay(1);
+
+        dprintk("disable phy disable mode.\n");
+}
+
+void
+rtl8125_wait_txrx_fifo_empty(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int i;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                for (i = 0; i < 3000; i++) {
+                        udelay(50);
+                        if ((RTL_R8(tp, MCUCmd_reg) & (Txfifo_empty | Rxfifo_empty)) == (Txfifo_empty | Rxfifo_empty))
+                                break;
+
+                }
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                for (i = 0; i < 3000; i++) {
+                        udelay(50);
+                        if ((RTL_R16(tp, IntrMitigate) & (BIT_0 | BIT_1 | BIT_8)) == (BIT_0 | BIT_1 | BIT_8))
+                                break;
+
+                }
+                break;
+        }
+}
+
+#ifdef ENABLE_DASH_SUPPORT
+
+inline void
+rtl8125_enable_dash2_interrupt(struct rtl8125_private *tp)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                RTL_CMAC_W8(tp, CMAC_IBIMR0, ( ISRIMR_DASH_TYPE2_ROK | ISRIMR_DASH_TYPE2_TOK | ISRIMR_DASH_TYPE2_TDU | ISRIMR_DASH_TYPE2_RDU | ISRIMR_DASH_TYPE2_RX_DISABLE_IDLE ));
+        }
+}
+
+static inline void
+rtl8125_disable_dash2_interrupt(struct rtl8125_private *tp)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                RTL_CMAC_W8(tp, CMAC_IBIMR0, 0);
+        }
+}
+#endif
+
+static inline void
+rtl8125_enable_hw_interrupt(struct rtl8125_private *tp)
+{
+        RTL_W32(tp, IMR0_8125, tp->intr_mask);
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH)
+                rtl8125_enable_dash2_interrupt(tp);
+#endif
+}
+
+static inline void
+rtl8125_disable_hw_interrupt(struct rtl8125_private *tp)
+{
+        RTL_W32(tp, IMR0_8125, 0x0000);
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH)
+                rtl8125_disable_dash2_interrupt(tp);
+#endif
+}
+
+
+static inline void
+rtl8125_switch_to_hw_interrupt(struct rtl8125_private *tp)
+{
+        RTL_W32(tp, TIMER_INT0_8125, 0x0000);
+
+        rtl8125_enable_hw_interrupt(tp);
+}
+
+static inline void
+rtl8125_switch_to_timer_interrupt(struct rtl8125_private *tp)
+{
+        if (tp->use_timer_interrrupt) {
+                RTL_W32(tp, TIMER_INT0_8125, timer_count);
+                RTL_W32(tp, TCTR0_8125, timer_count);
+                RTL_W32(tp, IMR0_8125, tp->timer_intr_mask);
+
+#ifdef ENABLE_DASH_SUPPORT
+                if (tp->DASH)
+                        rtl8125_enable_dash2_interrupt(tp);
+#endif
+        } else {
+                rtl8125_switch_to_hw_interrupt(tp);
+        }
+}
+
+static void
+rtl8125_irq_mask_and_ack(struct rtl8125_private *tp)
+{
+        rtl8125_disable_hw_interrupt(tp);
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH) {
+                if (tp->dash_printer_enabled) {
+                        RTL_W16(tp, IntrStatus, RTL_R16(tp, IntrStatus) &
+                                ~(ISRIMR_DASH_INTR_EN | ISRIMR_DASH_INTR_CMAC_RESET));
+                } else {
+                        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                                RTL_CMAC_W8(tp, CMAC_IBISR0, RTL_CMAC_R8(tp, CMAC_IBISR0));
+                        }
+                }
+        } else {
+                RTL_W16(tp, IntrStatus, RTL_R16(tp, IntrStatus));
+        }
+#else
+        RTL_W16(tp, IntrStatus, RTL_R16(tp, IntrStatus));
+#endif
+}
+
+static void
+rtl8125_nic_reset(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int i;
+
+        RTL_W32(tp, RxConfig, (RX_DMA_BURST << RxCfgDMAShift));
+
+        rtl8125_enable_rxdvgate(dev);
+
+        rtl8125_wait_txrx_fifo_empty(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        default:
+                mdelay(2);
+                break;
+        }
+
+        /* Soft reset the chip. */
+        RTL_W8(tp, ChipCmd, CmdReset);
+
+        /* Check that the chip has finished the reset. */
+        for (i = 100; i > 0; i--) {
+                udelay(100);
+                if ((RTL_R8(tp, ChipCmd) & CmdReset) == 0)
+                        break;
+        }
+}
+
+static void
+rtl8125_hw_clear_timer_int(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                RTL_W32(tp, TIMER_INT0_8125, 0x0000);
+                RTL_W32(tp, TIMER_INT1_8125, 0x0000);
+                RTL_W32(tp, TIMER_INT2_8125, 0x0000);
+                RTL_W32(tp, TIMER_INT3_8125, 0x0000);
+                break;
+        }
+}
+
+static void
+rtl8125_hw_clear_int_miti(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int i;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                //IntMITI_0-IntMITI_31
+                for (i=0xA00; i<0xB00; i+=4) {
+                        RTL_W32(tp, i, 0x0000);
+                }
+                break;
+        }
+}
+
+static void
+rtl8125_hw_reset(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        /* Disable interrupts */
+        rtl8125_irq_mask_and_ack(tp);
+
+        rtl8125_hw_clear_timer_int(dev);
+
+        rtl8125_nic_reset(dev);
+}
+
+static unsigned int
+rtl8125_xmii_reset_pending(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned int retval;
+
+        rtl8125_mdio_write(tp, 0x1f, 0x0000);
+        retval = rtl8125_mdio_read(tp, MII_BMCR) & BMCR_RESET;
+
+        return retval;
+}
+
+static unsigned int
+rtl8125_xmii_link_ok(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned int retval;
+
+        retval = (RTL_R16(tp, PHYstatus) & LinkStatus) ? 1 : 0;
+
+        return retval;
+}
+
+static void
+rtl8125_xmii_reset_enable(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int i, val = 0;
+
+        if (rtl8125_is_in_phy_disable_mode(dev)) {
+                return;
+        }
+
+        rtl8125_mdio_write(tp, 0x1f, 0x0000);
+        rtl8125_mdio_write(tp, MII_ADVERTISE, rtl8125_mdio_read(tp, MII_ADVERTISE) &
+                           ~(ADVERTISE_10HALF | ADVERTISE_10FULL |
+                             ADVERTISE_100HALF | ADVERTISE_100FULL));
+        rtl8125_mdio_write(tp, MII_CTRL1000, rtl8125_mdio_read(tp, MII_CTRL1000) &
+                           ~(ADVERTISE_1000HALF | ADVERTISE_1000FULL));
+        mdio_direct_write_phy_ocp(tp, 0xA5D4, mdio_direct_read_phy_ocp(tp, 0xA5D4) & ~(RTK_ADVERTISE_2500FULL));
+        rtl8125_mdio_write(tp, MII_BMCR, BMCR_RESET | BMCR_ANENABLE);
+
+        for (i = 0; i < 2500; i++) {
+                val = rtl8125_mdio_read(tp, MII_BMCR) & BMCR_RESET;
+
+                if (!val) {
+                        return;
+                }
+
+                mdelay(1);
+        }
+
+        if (netif_msg_link(tp))
+                printk(KERN_ERR "%s: PHY reset failed.\n", dev->name);
+}
+
+void rtl8125_init_ring_indexes(struct rtl8125_private *tp)
+{
+        tp->dirty_tx = 0;
+        tp->dirty_rx = 0;
+        tp->cur_tx = 0;
+        tp->cur_rx = 0;
+}
+
+static void
+rtl8125_issue_offset_99_event(struct rtl8125_private *tp)
+{
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xE09A,  rtl8125_mac_ocp_read(tp, 0xE09A) | BIT_0);
+                break;
+        }
+}
+
+#ifdef ENABLE_DASH_SUPPORT
+static void
+NICChkTypeEnableDashInterrupt(struct rtl8125_private *tp)
+{
+        if (tp->DASH) {
+                //
+                // even disconnected, enable 3 dash interrupt mask bits for in-band/out-band communication
+                //
+                if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                        rtl8125_enable_dash2_interrupt(tp);
+                        RTL_W16(tp, IntrMask, (ISRIMR_DASH_INTR_EN | ISRIMR_DASH_INTR_CMAC_RESET));
+                }
+        }
+}
+#endif
+
+static int rtl8125_enable_eee_plus(struct rtl8125_private *tp)
+{
+        int ret;
+
+        ret = 0;
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xE080, rtl8125_mac_ocp_read(tp, 0xE080)|BIT_1);
+                break;
+
+        default:
+//      dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Not Support EEEPlus\n");
+                ret = -EOPNOTSUPP;
+                break;
+        }
+
+        return ret;
+}
+
+static int rtl8125_disable_eee_plus(struct rtl8125_private *tp)
+{
+        int ret;
+
+        ret = 0;
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xE080, rtl8125_mac_ocp_read(tp, 0xE080)&~BIT_1);
+                break;
+
+        default:
+//      dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Not Support EEEPlus\n");
+                ret = -EOPNOTSUPP;
+                break;
+        }
+
+        return ret;
+}
+
+static void
+rtl8125_check_link_status(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int link_status_on;
+
+        link_status_on = tp->link_ok(dev);
+
+        if (netif_carrier_ok(dev) != link_status_on) {
+                if (link_status_on) {
+                        rtl8125_hw_config(dev);
+
+                        if ((tp->mcfg == CFG_METHOD_2) &&
+                            netif_running(dev)) {
+                                if (RTL_R16(tp, PHYstatus)&FullDup)
+                                        RTL_W32(tp, TxConfig, (RTL_R32(tp, TxConfig) | (BIT_24 | BIT_25)) & ~BIT_19);
+                                else
+                                        RTL_W32(tp, TxConfig, (RTL_R32(tp, TxConfig) | BIT_25) & ~(BIT_19 | BIT_24));
+                        }
+
+                        if ((tp->mcfg == CFG_METHOD_2 ||
+                             tp->mcfg == CFG_METHOD_3 ||
+                             tp->mcfg == CFG_METHOD_4 ||
+                             tp->mcfg == CFG_METHOD_5) &&
+                            (RTL_R8(tp, PHYstatus) & _10bps))
+                                rtl8125_enable_eee_plus(tp);
+
+                        rtl8125_hw_start(dev);
+
+                        netif_carrier_on(dev);
+
+                        netif_wake_queue(dev);
+
+                        rtl8125_mdio_write(tp, 0x1F, 0x0000);
+                        tp->phy_reg_anlpar = rtl8125_mdio_read(tp, MII_LPA);
+
+                        if (netif_msg_ifup(tp))
+                                printk(KERN_INFO PFX "%s: link up\n", dev->name);
+                } else {
+                        if (netif_msg_ifdown(tp))
+                                printk(KERN_INFO PFX "%s: link down\n", dev->name);
+
+                        tp->phy_reg_anlpar = 0;
+
+                        if (tp->mcfg == CFG_METHOD_2 ||
+                            tp->mcfg == CFG_METHOD_3 ||
+                            tp->mcfg == CFG_METHOD_4 ||
+                            tp->mcfg == CFG_METHOD_5)
+                                rtl8125_disable_eee_plus(tp);
+
+                        netif_stop_queue(dev);
+
+                        netif_carrier_off(dev);
+
+                        rtl8125_hw_reset(dev);
+
+                        rtl8125_tx_clear(tp);
+
+                        rtl8125_rx_clear(tp);
+
+                        rtl8125_init_ring(dev);
+
+                        rtl8125_set_speed(dev, tp->autoneg, tp->speed, tp->duplex, tp->advertising);
+
+#ifdef ENABLE_DASH_SUPPORT
+                        if (tp->DASH) {
+                                NICChkTypeEnableDashInterrupt(tp);
+                        }
+#endif
+                }
+        }
+}
+
+static void
+rtl8125_link_option(u8 *aut,
+                    u32 *spd,
+                    u8 *dup,
+                    u32 *adv)
+{
+        if ((*spd != SPEED_2500) && (*spd != SPEED_1000) &&
+            (*spd != SPEED_100) && (*spd != SPEED_10))
+                *spd = SPEED_2500;
+
+        if ((*dup != DUPLEX_FULL) && (*dup != DUPLEX_HALF))
+                *dup = DUPLEX_FULL;
+
+        if ((*aut != AUTONEG_ENABLE) && (*aut != AUTONEG_DISABLE))
+                *aut = AUTONEG_ENABLE;
+
+        *adv &= (ADVERTISED_10baseT_Half |
+                 ADVERTISED_10baseT_Full |
+                 ADVERTISED_100baseT_Half |
+                 ADVERTISED_100baseT_Full |
+                 ADVERTISED_1000baseT_Half |
+                 ADVERTISED_1000baseT_Full |
+                 ADVERTISED_2500baseX_Full);
+        if (*adv == 0)
+                *adv = (ADVERTISED_10baseT_Half |
+                        ADVERTISED_10baseT_Full |
+                        ADVERTISED_100baseT_Half |
+                        ADVERTISED_100baseT_Full |
+                        ADVERTISED_1000baseT_Half |
+                        ADVERTISED_1000baseT_Full |
+                        ADVERTISED_2500baseX_Full);
+}
+
+/*
+static void
+rtl8125_enable_ocp_phy_power_saving(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u16 val;
+
+         if (tp->mcfg == CFG_METHOD_2 ||
+             tp->mcfg == CFG_METHOD_3 ||
+             tp->mcfg == CFG_METHOD_4 ||
+			 tp->mcfg == CFG_METHOD_5) {
+                val = mdio_direct_read_phy_ocp(tp, 0xC416);
+                if (val != 0x0050) {
+                        rtl8125_set_phy_mcu_patch_request(tp);
+                        mdio_direct_write_phy_ocp(tp, 0xC416, 0x0000);
+                        mdio_direct_write_phy_ocp(tp, 0xC416, 0x0050);
+                        rtl8125_clear_phy_mcu_patch_request(tp);
+                }
+        }
+}
+*/
+
+static void
+rtl8125_disable_ocp_phy_power_saving(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u16 val;
+
+        if (tp->mcfg == CFG_METHOD_2 ||
+            tp->mcfg == CFG_METHOD_3 ||
+            tp->mcfg == CFG_METHOD_4 ||
+            tp->mcfg == CFG_METHOD_5) {
+                val = mdio_direct_read_phy_ocp(tp, 0xC416);
+                if (val != 0x0500) {
+                        rtl8125_set_phy_mcu_patch_request(tp);
+                        mdio_direct_write_phy_ocp(tp, 0xC416, 0x0000);
+                        mdio_direct_write_phy_ocp(tp, 0xC416, 0x0500);
+                        rtl8125_clear_phy_mcu_patch_request(tp);
+                }
+        }
+}
+
+static void
+rtl8125_wait_ll_share_fifo_ready(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int i;
+
+        for (i = 0; i < 10; i++) {
+                udelay(100);
+                if (RTL_R16(tp, 0xD2) & BIT_9)
+                        break;
+        }
+}
+
+static void
+rtl8125_disable_pci_offset_99(struct rtl8125_private *tp)
+{
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xE032,  rtl8125_mac_ocp_read(tp, 0xE032) & ~(BIT_0 | BIT_1));
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_csi_fun0_write_byte(tp, 0x99, 0x00);
+                break;
+        }
+}
+
+static void
+rtl8125_enable_pci_offset_99(struct rtl8125_private *tp)
+{
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_csi_fun0_write_byte(tp, 0x99, tp->org_pci_offset_99);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xE032);
+                csi_tmp &= ~(BIT_0 | BIT_1);
+                if (!(tp->org_pci_offset_99 & (BIT_5 | BIT_6)))
+                        csi_tmp |= BIT_1;
+                if (!(tp->org_pci_offset_99 & BIT_2))
+                        csi_tmp |= BIT_0;
+                rtl8125_mac_ocp_write(tp, 0xE032, csi_tmp);
+                break;
+        }
+}
+
+static void
+rtl8125_init_pci_offset_99(struct rtl8125_private *tp)
+{
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+                rtl8125_mac_ocp_write(tp, 0xCDD0, 0x9003);
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xE034);
+                csi_tmp |= (BIT_15|BIT_14);
+                rtl8125_mac_ocp_write(tp, 0xE034, csi_tmp);
+                rtl8125_mac_ocp_write(tp, 0xCDD8, 0x9003);
+                rtl8125_mac_ocp_write(tp, 0xCDDA, 0x9003);
+                rtl8125_mac_ocp_write(tp, 0xCDDC, 0x9003);
+                rtl8125_mac_ocp_write(tp, 0xCDD2, 0x883C);
+                rtl8125_mac_ocp_write(tp, 0xCDD4, 0x8C12);
+                rtl8125_mac_ocp_write(tp, 0xCDD6, 0x9003);
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xE032);
+                csi_tmp |= (BIT_14);
+                rtl8125_mac_ocp_write(tp, 0xE032, csi_tmp);
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xE0A2);
+                csi_tmp |= (BIT_0);
+                rtl8125_mac_ocp_write(tp, 0xE0A2, csi_tmp);
+                break;
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xCDD0, 0x9003);
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xE034);
+                csi_tmp |= (BIT_15 | BIT_14);
+                rtl8125_mac_ocp_write(tp, 0xE034, csi_tmp);
+                rtl8125_mac_ocp_write(tp, 0xCDD2, 0x889C);
+                rtl8125_mac_ocp_write(tp, 0xCDD8, 0x9003);
+                rtl8125_mac_ocp_write(tp, 0xCDD4, 0x8C30);
+                rtl8125_mac_ocp_write(tp, 0xCDDA, 0x9003);
+                rtl8125_mac_ocp_write(tp, 0xCDD6, 0x9003);
+                rtl8125_mac_ocp_write(tp, 0xCDDC, 0x9003);
+                rtl8125_mac_ocp_write(tp, 0xCDE8, 0x883E);
+                rtl8125_mac_ocp_write(tp, 0xCDEA, 0x9003);
+                rtl8125_mac_ocp_write(tp, 0xCDEC, 0x889C);
+                rtl8125_mac_ocp_write(tp, 0xCDEE, 0x9003);
+                rtl8125_mac_ocp_write(tp, 0xCDF0, 0x8C09);
+                rtl8125_mac_ocp_write(tp, 0xCDF2, 0x9003);
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xE032);
+                csi_tmp |= (BIT_14);
+                rtl8125_mac_ocp_write(tp, 0xE032, csi_tmp);
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xE0A2);
+                csi_tmp |= (BIT_0);
+                rtl8125_mac_ocp_write(tp, 0xE0A2, csi_tmp);
+                break;
+        }
+
+        rtl8125_enable_pci_offset_99(tp);
+}
+
+static void
+rtl8125_disable_pci_offset_180(struct rtl8125_private *tp)
+{
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xE092);
+                csi_tmp &= 0xFF00;
+                rtl8125_mac_ocp_write(tp, 0xE092, csi_tmp);
+                break;
+        }
+}
+
+static void
+rtl8125_enable_pci_offset_180(struct rtl8125_private *tp)
+{
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xE094);
+                csi_tmp &= 0x00FF;
+                rtl8125_mac_ocp_write(tp, 0xE094, csi_tmp);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xE092);
+                csi_tmp &= 0xFF00;
+                csi_tmp |= BIT_2;
+                rtl8125_mac_ocp_write(tp, 0xE092, csi_tmp);
+                break;
+        }
+}
+
+static void
+rtl8125_init_pci_offset_180(struct rtl8125_private *tp)
+{
+        if (tp->org_pci_offset_180 & (BIT_0|BIT_1))
+                rtl8125_enable_pci_offset_180(tp);
+        else
+                rtl8125_disable_pci_offset_180(tp);
+}
+
+static void
+rtl8125_set_pci_99_180_exit_driver_para(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_issue_offset_99_event(tp);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_disable_pci_offset_99(tp);
+                break;
+        }
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_disable_pci_offset_180(tp);
+                break;
+        }
+}
+
+static void
+rtl8125_enable_cfg9346_write(struct rtl8125_private *tp)
+{
+        RTL_W8(tp, Cfg9346, RTL_R8(tp, Cfg9346) | Cfg9346_Unlock);
+}
+
+static void
+rtl8125_disable_cfg9346_write(struct rtl8125_private *tp)
+{
+        RTL_W8(tp, Cfg9346, RTL_R8(tp, Cfg9346) & ~Cfg9346_Unlock);
+}
+
+static void
+rtl8125_hw_d3_para(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        RTL_W16(tp, RxMaxSize, RX_BUF_SIZE);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                RTL_W8(tp, 0xF1, RTL_R8(tp, 0xF1) & ~BIT_7);
+                rtl8125_enable_cfg9346_write(tp);
+                RTL_W8(tp, Config2, RTL_R8(tp, Config2) & ~BIT_7);
+                RTL_W8(tp, Config5, RTL_R8(tp, Config5) & ~BIT_0);
+                rtl8125_disable_cfg9346_write(tp);
+                break;
+        }
+
+#ifdef ENABLE_REALWOW_SUPPORT
+        rtl8125_set_realwow_d3_para(dev);
+#endif
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xEA18, 0x0064);
+                break;
+        }
+
+        rtl8125_set_pci_99_180_exit_driver_para(dev);
+
+        /*disable ocp phy power saving*/
+        if (tp->mcfg == CFG_METHOD_2 ||
+            tp->mcfg == CFG_METHOD_3 ||
+            tp->mcfg == CFG_METHOD_4 ||
+            tp->mcfg == CFG_METHOD_5)
+                rtl8125_disable_ocp_phy_power_saving(dev);
+
+        rtl8125_disable_rxdvgate(dev);
+}
+
+static void
+rtl8125_enable_magic_packet(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->HwSuppMagicPktVer) {
+        case WAKEUP_MAGIC_PACKET_V3:
+                rtl8125_mac_ocp_write(tp, 0xC0B6, rtl8125_mac_ocp_read(tp, 0xC0B6) | BIT_0);
+                break;
+        }
+}
+static void
+rtl8125_disable_magic_packet(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->HwSuppMagicPktVer) {
+        case WAKEUP_MAGIC_PACKET_V3:
+                rtl8125_mac_ocp_write(tp, 0xC0B6, rtl8125_mac_ocp_read(tp, 0xC0B6) & ~BIT_0);
+                break;
+        }
+}
+
+#define WAKE_ANY (WAKE_PHY | WAKE_MAGIC | WAKE_UCAST | WAKE_BCAST | WAKE_MCAST)
+
+static void
+rtl8125_get_hw_wol(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u8 options;
+        u32 csi_tmp;
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        tp->wol_opts = 0;
+        options = RTL_R8(tp, Config1);
+        if (!(options & PMEnable))
+                goto out_unlock;
+
+        options = RTL_R8(tp, Config3);
+        if (options & LinkUp)
+                tp->wol_opts |= WAKE_PHY;
+
+        switch (tp->HwSuppMagicPktVer) {
+        case WAKEUP_MAGIC_PACKET_V3:
+                csi_tmp = rtl8125_mac_ocp_read(tp, 0xC0B6);
+                if (csi_tmp & BIT_0)
+                        tp->wol_opts |= WAKE_MAGIC;
+                break;
+        }
+
+        options = RTL_R8(tp, Config5);
+        if (options & UWF)
+                tp->wol_opts |= WAKE_UCAST;
+        if (options & BWF)
+                tp->wol_opts |= WAKE_BCAST;
+        if (options & MWF)
+                tp->wol_opts |= WAKE_MCAST;
+
+out_unlock:
+        tp->wol_enabled = (tp->wol_opts) ? WOL_ENABLED : WOL_DISABLED;
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+static void
+rtl8125_set_hw_wol(struct net_device *dev, u32 wolopts)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int i,tmp;
+        static struct {
+                u32 opt;
+                u16 reg;
+                u8  mask;
+        } cfg[] = {
+                { WAKE_PHY,   Config3, LinkUp },
+                { WAKE_UCAST, Config5, UWF },
+                { WAKE_BCAST, Config5, BWF },
+                { WAKE_MCAST, Config5, MWF },
+                { WAKE_ANY,   Config5, LanWake },
+                { WAKE_MAGIC, Config3, MagicPacket },
+        };
+
+        switch (tp->HwSuppMagicPktVer) {
+        case WAKEUP_MAGIC_PACKET_V3:
+                tmp = ARRAY_SIZE(cfg) - 1;
+
+                if (wolopts & WAKE_MAGIC)
+                        rtl8125_enable_magic_packet(dev);
+                else
+                        rtl8125_disable_magic_packet(dev);
+                break;
+        }
+
+        rtl8125_enable_cfg9346_write(tp);
+
+        for (i = 0; i < tmp; i++) {
+                u8 options = RTL_R8(tp, cfg[i].reg) & ~cfg[i].mask;
+                if (wolopts & cfg[i].opt)
+                        options |= cfg[i].mask;
+                RTL_W8(tp, cfg[i].reg, options);
+        }
+
+        rtl8125_disable_cfg9346_write(tp);
+}
+
+static void
+rtl8125_phy_restart_nway(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        if (rtl8125_is_in_phy_disable_mode(dev)) return;
+
+        rtl8125_mdio_write(tp, 0x1F, 0x0000);
+        rtl8125_mdio_write(tp, MII_BMCR, BMCR_ANENABLE | BMCR_ANRESTART);
+}
+
+static void
+rtl8125_phy_setup_force_mode(struct net_device *dev, u32 speed, u8 duplex)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u16 bmcr_true_force = 0;
+
+        if (rtl8125_is_in_phy_disable_mode(dev)) return;
+
+        if ((speed == SPEED_10) && (duplex == DUPLEX_HALF)) {
+                bmcr_true_force = BMCR_SPEED10;
+        } else if ((speed == SPEED_10) && (duplex == DUPLEX_FULL)) {
+                bmcr_true_force = BMCR_SPEED10 | BMCR_FULLDPLX;
+        } else if ((speed == SPEED_100) && (duplex == DUPLEX_HALF)) {
+                bmcr_true_force = BMCR_SPEED100;
+        } else if ((speed == SPEED_100) && (duplex == DUPLEX_FULL)) {
+                bmcr_true_force = BMCR_SPEED100 | BMCR_FULLDPLX;
+        } else if ((speed == SPEED_1000) && (duplex == DUPLEX_FULL) &&
+                   tp->HwSuppGigaForceMode) {
+                bmcr_true_force = BMCR_SPEED1000 | BMCR_FULLDPLX;
+        } else {
+                netif_err(tp, drv, dev, "Failed to set phy force mode!\n");
+                return;
+        }
+
+        rtl8125_mdio_write(tp, 0x1F, 0x0000);
+        rtl8125_mdio_write(tp, MII_BMCR, bmcr_true_force);
+}
+
+static void
+rtl8125_powerdown_pll(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        if (tp->wol_enabled == WOL_ENABLED || tp->DASH || tp->EnableKCPOffload) {
+                int auto_nego;
+                int giga_ctrl;
+                u16 anlpar;
+
+                rtl8125_set_hw_wol(dev, tp->wol_opts);
+
+                if (tp->mcfg == CFG_METHOD_2 ||
+                    tp->mcfg == CFG_METHOD_3 ||
+                    tp->mcfg == CFG_METHOD_4 ||
+                    tp->mcfg == CFG_METHOD_5) {
+                        rtl8125_enable_cfg9346_write(tp);
+                        RTL_W8(tp, Config2, RTL_R8(tp, Config2) | PMSTS_En);
+                        rtl8125_disable_cfg9346_write(tp);
+                }
+
+                rtl8125_mdio_write(tp, 0x1F, 0x0000);
+                auto_nego = rtl8125_mdio_read(tp, MII_ADVERTISE);
+                auto_nego &= ~(ADVERTISE_10HALF | ADVERTISE_10FULL
+                               | ADVERTISE_100HALF | ADVERTISE_100FULL);
+
+                if (netif_running(dev))
+                        anlpar = tp->phy_reg_anlpar;
+                else
+                        anlpar = rtl8125_mdio_read(tp, MII_LPA);
+
+#ifdef CONFIG_DOWN_SPEED_100
+                auto_nego |= (ADVERTISE_100FULL | ADVERTISE_100HALF | ADVERTISE_10HALF | ADVERTISE_10FULL);
+#else
+                if (anlpar & (LPA_10HALF | LPA_10FULL))
+                        auto_nego |= (ADVERTISE_10HALF | ADVERTISE_10FULL);
+                else
+                        auto_nego |= (ADVERTISE_100FULL | ADVERTISE_100HALF | ADVERTISE_10HALF | ADVERTISE_10FULL);
+#endif
+
+                if (tp->DASH)
+                        auto_nego |= (ADVERTISE_100FULL | ADVERTISE_100HALF | ADVERTISE_10HALF | ADVERTISE_10FULL);
+
+                giga_ctrl = rtl8125_mdio_read(tp, MII_CTRL1000) & ~(ADVERTISE_1000HALF | ADVERTISE_1000FULL);
+                rtl8125_mdio_write(tp, MII_ADVERTISE, auto_nego);
+                rtl8125_mdio_write(tp, MII_CTRL1000, giga_ctrl);
+                if (tp->mcfg == CFG_METHOD_2 ||
+                    tp->mcfg == CFG_METHOD_3 ||
+                    tp->mcfg == CFG_METHOD_4 ||
+                    tp->mcfg == CFG_METHOD_5) {
+                        int ctrl_2500;
+
+                        ctrl_2500 = mdio_direct_read_phy_ocp(tp, 0xA5D4);
+                        ctrl_2500 &= ~(RTK_ADVERTISE_2500FULL);
+                        mdio_direct_write_phy_ocp(tp, 0xA5D4, ctrl_2500);
+                }
+                rtl8125_phy_restart_nway(dev);
+
+                RTL_W32(tp, RxConfig, RTL_R32(tp, RxConfig) | AcceptBroadcast | AcceptMulticast | AcceptMyPhys);
+
+                return;
+        }
+
+        if (tp->DASH)
+                return;
+
+        rtl8125_phy_power_down(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                RTL_W8(tp, PMCH, RTL_R8(tp, PMCH) & ~BIT_7);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                RTL_W8(tp, 0xF2, RTL_R8(tp, 0xF2) & ~BIT_6);
+                break;
+        }
+}
+
+static void rtl8125_powerup_pll(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                RTL_W8(tp, PMCH, RTL_R8(tp, PMCH) | BIT_7 | BIT_6);
+                break;
+        }
+
+        rtl8125_phy_power_up(dev);
+}
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static void
+rtl8125_get_wol(struct net_device *dev,
+                struct ethtool_wolinfo *wol)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u8 options;
+        unsigned long flags;
+
+        wol->wolopts = 0;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT) {
+                wol->supported = 0;
+                return;
+        } else {
+                wol->supported = WAKE_ANY;
+        }
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        options = RTL_R8(tp, Config1);
+        if (!(options & PMEnable))
+                goto out_unlock;
+
+        wol->wolopts = tp->wol_opts;
+
+out_unlock:
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+static int
+rtl8125_set_wol(struct net_device *dev,
+                struct ethtool_wolinfo *wol)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                return -EOPNOTSUPP;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        tp->wol_opts = wol->wolopts;
+
+        tp->wol_enabled = (tp->wol_opts) ? WOL_ENABLED : WOL_DISABLED;
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        device_set_wakeup_enable(&tp->pci_dev->dev, wol->wolopts);
+
+        return 0;
+}
+
+static void
+rtl8125_get_drvinfo(struct net_device *dev,
+                    struct ethtool_drvinfo *info)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        strcpy(info->driver, MODULENAME);
+        strcpy(info->version, RTL8125_VERSION);
+        strcpy(info->bus_info, pci_name(tp->pci_dev));
+        info->regdump_len = R8125_REGS_DUMP_SIZE;
+        info->eedump_len = tp->eeprom_len;
+}
+
+static int
+rtl8125_get_regs_len(struct net_device *dev)
+{
+        return R8125_REGS_DUMP_SIZE;
+}
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+
+static int
+rtl8125_set_speed_xmii(struct net_device *dev,
+                       u8 autoneg,
+                       u32 speed,
+                       u8 duplex,
+                       u32 adv)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int auto_nego = 0;
+        int giga_ctrl = 0;
+        int ctrl_2500 = 0;
+        int rc = -EINVAL;
+
+        //Disable Giga Lite
+        ClearEthPhyOcpBit(tp, 0xA428, BIT_9);
+        ClearEthPhyOcpBit(tp, 0xA5EA, BIT_0);
+
+        if (speed != SPEED_2500 &&
+            (speed != SPEED_1000) &&
+            (speed != SPEED_100) &&
+            (speed != SPEED_10)) {
+                speed = SPEED_2500;
+                duplex = DUPLEX_FULL;
+        }
+
+        giga_ctrl = rtl8125_mdio_read(tp, MII_CTRL1000);
+        giga_ctrl &= ~(ADVERTISE_1000HALF | ADVERTISE_1000FULL);
+        ctrl_2500 = mdio_direct_read_phy_ocp(tp, 0xA5D4);
+        ctrl_2500 &= ~(RTK_ADVERTISE_2500FULL);
+
+        if (autoneg == AUTONEG_ENABLE) {
+                /*n-way force*/
+                auto_nego = rtl8125_mdio_read(tp, MII_ADVERTISE);
+                auto_nego &= ~(ADVERTISE_10HALF | ADVERTISE_10FULL |
+                               ADVERTISE_100HALF | ADVERTISE_100FULL |
+                               ADVERTISE_PAUSE_CAP | ADVERTISE_PAUSE_ASYM);
+
+                if (adv & ADVERTISED_10baseT_Half)
+                        auto_nego |= ADVERTISE_10HALF;
+                if (adv & ADVERTISED_10baseT_Full)
+                        auto_nego |= ADVERTISE_10FULL;
+                if (adv & ADVERTISED_100baseT_Half)
+                        auto_nego |= ADVERTISE_100HALF;
+                if (adv & ADVERTISED_100baseT_Full)
+                        auto_nego |= ADVERTISE_100FULL;
+                if (adv & ADVERTISED_1000baseT_Half)
+                        giga_ctrl |= ADVERTISE_1000HALF;
+                if (adv & ADVERTISED_1000baseT_Full)
+                        giga_ctrl |= ADVERTISE_1000FULL;
+                if (adv & ADVERTISED_2500baseX_Full)
+                        ctrl_2500 |= RTK_ADVERTISE_2500FULL;
+
+                //flow control
+                if (dev->mtu <= ETH_DATA_LEN)
+                        auto_nego |= ADVERTISE_PAUSE_CAP|ADVERTISE_PAUSE_ASYM;
+
+                tp->phy_auto_nego_reg = auto_nego;
+                tp->phy_1000_ctrl_reg = giga_ctrl;
+
+                tp->phy_2500_ctrl_reg = ctrl_2500;
+
+                rtl8125_mdio_write(tp, 0x1f, 0x0000);
+                rtl8125_mdio_write(tp, MII_ADVERTISE, auto_nego);
+                rtl8125_mdio_write(tp, MII_CTRL1000, giga_ctrl);
+                mdio_direct_write_phy_ocp(tp, 0xA5D4, ctrl_2500);
+                rtl8125_phy_restart_nway(dev);
+                mdelay(20);
+        } else {
+                /*true force*/
+                if (speed == SPEED_10 || speed == SPEED_100 ||
+                    (speed == SPEED_1000 && duplex == DUPLEX_FULL &&
+                     tp->HwSuppGigaForceMode)) {
+                        rtl8125_phy_setup_force_mode(dev, speed, duplex);
+                } else
+                        goto out;
+        }
+
+        tp->autoneg = autoneg;
+        tp->speed = speed;
+        tp->duplex = duplex;
+        tp->advertising = adv;
+
+        rc = 0;
+out:
+        return rc;
+}
+
+static int
+rtl8125_set_speed(struct net_device *dev,
+                  u8 autoneg,
+                  u32 speed,
+                  u8 duplex,
+                  u32 adv)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int ret;
+
+        ret = tp->set_speed(dev, autoneg, speed, duplex, adv);
+
+        return ret;
+}
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static int
+rtl8125_set_settings(struct net_device *dev,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+                     struct ethtool_cmd *cmd
+#else
+                     const struct ethtool_link_ksettings *cmd
+#endif
+                    )
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int ret;
+        unsigned long flags;
+        u8 autoneg;
+        u32 speed;
+        u8 duplex;
+        u32 supported, advertising;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+        autoneg = cmd->autoneg;
+        speed = cmd->speed;
+        duplex = cmd->duplex;
+        supported = cmd->supported;
+        advertising = cmd->advertising;
+#else
+        const struct ethtool_link_settings *base = &cmd->base;
+        autoneg = base->autoneg;
+        speed = base->speed;
+        duplex = base->duplex;
+        ethtool_convert_link_mode_to_legacy_u32(&supported,
+                                                cmd->link_modes.supported);
+        ethtool_convert_link_mode_to_legacy_u32(&advertising,
+                                                cmd->link_modes.advertising);
+#endif
+        if (advertising & ~supported)
+                return -EINVAL;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        ret = rtl8125_set_speed(dev, autoneg, speed, duplex, advertising);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return ret;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+static u32
+rtl8125_get_tx_csum(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u32 ret;
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        ret = ((dev->features & NETIF_F_IP_CSUM) != 0);
+#else
+        ret = ((dev->features & (NETIF_F_IP_CSUM | NETIF_F_IPV6_CSUM)) != 0);
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return ret;
+}
+
+static u32
+rtl8125_get_rx_csum(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u32 ret;
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        ret = tp->cp_cmd & RxChkSum;
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return ret;
+}
+
+static int
+rtl8125_set_tx_csum(struct net_device *dev,
+                    u32 data)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                return -EOPNOTSUPP;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        if (data)
+                dev->features |= NETIF_F_IP_CSUM;
+        else
+                dev->features &= ~NETIF_F_IP_CSUM;
+#else
+        if (data)
+                dev->features |= (NETIF_F_IP_CSUM | NETIF_F_IPV6_CSUM);
+        else
+                dev->features &= ~(NETIF_F_IP_CSUM | NETIF_F_IPV6_CSUM);
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return 0;
+}
+
+static int
+rtl8125_set_rx_csum(struct net_device *dev,
+                    u32 data)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                return -EOPNOTSUPP;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        if (data)
+                tp->cp_cmd |= RxChkSum;
+        else
+                tp->cp_cmd &= ~RxChkSum;
+
+        RTL_W16(tp, CPlusCmd, tp->cp_cmd);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return 0;
+}
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+
+#ifdef CONFIG_R8125_VLAN
+
+static inline u32
+rtl8125_tx_vlan_tag(struct rtl8125_private *tp,
+                    struct sk_buff *skb)
+{
+        u32 tag;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        tag = (tp->vlgrp && vlan_tx_tag_present(skb)) ?
+              TxVlanTag | swab16(vlan_tx_tag_get(skb)) : 0x00;
+#elif LINUX_VERSION_CODE < KERNEL_VERSION(4,0,0)
+        tag = (vlan_tx_tag_present(skb)) ?
+              TxVlanTag | swab16(vlan_tx_tag_get(skb)) : 0x00;
+#else
+        tag = (skb_vlan_tag_present(skb)) ?
+              TxVlanTag | swab16(skb_vlan_tag_get(skb)) : 0x00;
+#endif
+
+        return tag;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+
+static void
+rtl8125_vlan_rx_register(struct net_device *dev,
+                         struct vlan_group *grp)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        tp->vlgrp = grp;
+        if (tp->mcfg == CFG_METHOD_2 ||
+            tp->mcfg == CFG_METHOD_3 ||
+            tp->mcfg == CFG_METHOD_4 ||
+            tp->mcfg == CFG_METHOD_5) {
+                if (tp->vlgrp) {
+                        tp->rtl8125_rx_config |= (BIT_22 | BIT_23);
+                        RTL_W32(tp, RxConfig, RTL_R32(tp, RxConfig) | (BIT_22 | BIT_23))
+                } else {
+                        tp->rtl8125_rx_config &= ~(BIT_22 | BIT_23);
+                        RTL_W32(tp, RxConfig, RTL_R32(tp, RxConfig) & ~(BIT_22 | BIT_23))
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+static void
+rtl8125_vlan_rx_kill_vid(struct net_device *dev,
+                         unsigned short vid)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,21)
+        if (tp->vlgrp)
+                tp->vlgrp->vlan_devices[vid] = NULL;
+#else
+        vlan_group_set_device(tp->vlgrp, vid, NULL);
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,21)
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+
+static int
+rtl8125_rx_vlan_skb(struct rtl8125_private *tp,
+                    struct RxDesc *desc,
+                    struct sk_buff *skb)
+{
+        u32 opts2 = le32_to_cpu(desc->opts2);
+        int ret = -1;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        if (tp->vlgrp && (opts2 & RxVlanTag)) {
+                rtl8125_rx_hwaccel_skb(skb, tp->vlgrp,
+                                       swab16(opts2 & 0xffff));
+                ret = 0;
+        }
+#elif LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0)
+        if (opts2 & RxVlanTag)
+                __vlan_hwaccel_put_tag(skb, swab16(opts2 & 0xffff));
+#else
+        if (opts2 & RxVlanTag)
+                __vlan_hwaccel_put_tag(skb, htons(ETH_P_8021Q), swab16(opts2 & 0xffff));
+#endif
+
+        desc->opts2 = 0;
+        return ret;
+}
+
+#else /* !CONFIG_R8125_VLAN */
+
+static inline u32
+rtl8125_tx_vlan_tag(struct rtl8125_private *tp,
+                    struct sk_buff *skb)
+{
+        return 0;
+}
+
+static int
+rtl8125_rx_vlan_skb(struct rtl8125_private *tp,
+                    struct RxDesc *desc,
+                    struct sk_buff *skb)
+{
+        return -1;
+}
+
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,0,0)
+
+static netdev_features_t rtl8125_fix_features(struct net_device *dev,
+                netdev_features_t features)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        if (dev->mtu > MSS_MAX)
+                features &= ~NETIF_F_ALL_TSO;
+        if (dev->mtu > ETH_DATA_LEN) {
+                features &= ~NETIF_F_ALL_TSO;
+                features &= ~NETIF_F_ALL_CSUM;
+        }
+#ifndef CONFIG_R8125_VLAN
+        features &= ~NETIF_F_ALL_CSUM;
+#endif
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return features;
+}
+
+static int rtl8125_hw_set_features(struct net_device *dev,
+                                   netdev_features_t features)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u32 rx_config;
+
+        rx_config = RTL_R32(tp, RxConfig);
+        if (features & NETIF_F_RXALL)
+                rx_config |= (AcceptErr | AcceptRunt);
+        else
+                rx_config &= ~(AcceptErr | AcceptRunt);
+
+        if (dev->features & NETIF_F_HW_VLAN_RX)
+                rx_config |= (BIT_22 | BIT_23);
+        else
+                rx_config &= ~(BIT_22 | BIT_23);
+
+        RTL_W32(tp, RxConfig, rx_config);
+
+        if (features & NETIF_F_RXCSUM)
+                tp->cp_cmd |= RxChkSum;
+        else
+                tp->cp_cmd &= ~RxChkSum;
+
+        RTL_W16(tp, CPlusCmd, tp->cp_cmd);
+        RTL_R16(tp, CPlusCmd);
+
+        return 0;
+}
+
+static int rtl8125_set_features(struct net_device *dev,
+                                netdev_features_t features)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        features &= NETIF_F_RXALL | NETIF_F_RXCSUM | NETIF_F_HW_VLAN_RX;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        if (features ^ dev->features)
+                rtl8125_hw_set_features(dev, features);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return 0;
+}
+
+#endif
+
+static void rtl8125_gset_xmii(struct net_device *dev,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+                              struct ethtool_cmd *cmd
+#else
+                              struct ethtool_link_ksettings *cmd
+#endif
+                             )
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u16 status;
+        u8 autoneg, duplex;
+        u32 speed = 0;
+        u16 bmcr;
+        u32 supported, advertising;
+        unsigned long flags;
+
+        supported = SUPPORTED_10baseT_Half |
+                    SUPPORTED_10baseT_Full |
+                    SUPPORTED_100baseT_Half |
+                    SUPPORTED_100baseT_Full |
+                    SUPPORTED_1000baseT_Full |
+                    SUPPORTED_2500baseX_Full |
+                    SUPPORTED_Autoneg |
+                    SUPPORTED_TP |
+                    SUPPORTED_Pause	|
+                    SUPPORTED_Asym_Pause;
+
+        advertising = ADVERTISED_TP;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        rtl8125_mdio_write(tp, 0x1F, 0x0000);
+        bmcr = rtl8125_mdio_read(tp, MII_BMCR);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        if (bmcr & BMCR_ANENABLE) {
+                advertising |= ADVERTISED_Autoneg;
+                autoneg = AUTONEG_ENABLE;
+
+                if (tp->phy_auto_nego_reg & ADVERTISE_10HALF)
+                        advertising |= ADVERTISED_10baseT_Half;
+                if (tp->phy_auto_nego_reg & ADVERTISE_10FULL)
+                        advertising |= ADVERTISED_10baseT_Full;
+                if (tp->phy_auto_nego_reg & ADVERTISE_100HALF)
+                        advertising |= ADVERTISED_100baseT_Half;
+                if (tp->phy_auto_nego_reg & ADVERTISE_100FULL)
+                        advertising |= ADVERTISED_100baseT_Full;
+                if (tp->phy_1000_ctrl_reg & ADVERTISE_1000FULL)
+                        advertising |= ADVERTISED_1000baseT_Full;
+                if (tp->phy_2500_ctrl_reg & RTK_ADVERTISE_2500FULL)
+                        advertising |= ADVERTISED_2500baseX_Full;
+        } else {
+                autoneg = AUTONEG_DISABLE;
+        }
+
+        status = RTL_R16(tp, PHYstatus);
+
+        if (status & LinkStatus) {
+                /*link on*/
+                if (status & _2500bpsF)
+                        speed = SPEED_2500;
+                else if (status & _1000bpsF)
+                        speed = SPEED_1000;
+                else if (status & _100bps)
+                        speed = SPEED_100;
+                else if (status & _10bps)
+                        speed = SPEED_10;
+
+                if (status & TxFlowCtrl)
+                        advertising |= ADVERTISED_Asym_Pause;
+
+                if (status & RxFlowCtrl)
+                        advertising |= ADVERTISED_Pause;
+
+                duplex = ((status & (_1000bpsF | _2500bpsF)) || (status & FullDup)) ?
+                         DUPLEX_FULL : DUPLEX_HALF;
+        } else {
+                /*link down*/
+                speed = SPEED_UNKNOWN;
+                duplex = DUPLEX_UNKNOWN;
+        }
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+        cmd->supported = supported;
+        cmd->advertising = advertising;
+        cmd->autoneg = autoneg;
+        cmd->speed = speed;
+        cmd->duplex = duplex;
+        cmd->port = PORT_TP;
+#else
+        ethtool_convert_legacy_u32_to_link_mode(cmd->link_modes.supported,
+                                                supported);
+        ethtool_convert_legacy_u32_to_link_mode(cmd->link_modes.advertising,
+                                                advertising);
+        cmd->base.autoneg = autoneg;
+        cmd->base.speed = speed;
+        cmd->base.duplex = duplex;
+        cmd->base.port = PORT_TP;
+#endif
+}
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static int
+rtl8125_get_settings(struct net_device *dev,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+                     struct ethtool_cmd *cmd
+#else
+                     struct ethtool_link_ksettings *cmd
+#endif
+                    )
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        tp->get_settings(dev, cmd);
+
+        return 0;
+}
+
+static void rtl8125_get_regs(struct net_device *dev, struct ethtool_regs *regs,
+                             void *p)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned int i;
+        u8 *data = p;
+        unsigned long flags;
+
+        if (regs->len < R8125_REGS_DUMP_SIZE)
+                return /* -EINVAL */;
+
+        memset(p, 0, regs->len);
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (i = 0; i < R8125_MAC_REGS_SIZE; i++)
+                *data++ = readb(ioaddr + i);
+        data = (u8*)p + 256;
+
+        rtl8125_mdio_write(tp, 0x1F, 0x0000);
+        for (i = 0; i < R8125_PHY_REGS_SIZE/2; i++) {
+                *(u16*)data = rtl8125_mdio_read(tp, i);
+                data += 2;
+        }
+        data = (u8*)p + 256 * 2;
+
+        for (i = 0; i < R8125_EPHY_REGS_SIZE/2; i++) {
+                *(u16*)data = rtl8125_ephy_read(tp, i);
+                data += 2;
+        }
+        data = (u8*)p + 256 * 3;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        default:
+                for (i = 0; i < R8125_ERI_REGS_SIZE; i+=4) {
+                        *(u32*)data = rtl8125_eri_read(tp, i , 4, ERIAR_ExGMAC);
+                        data += 4;
+                }
+                break;
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+static u32
+rtl8125_get_msglevel(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        return tp->msg_enable;
+}
+
+static void
+rtl8125_set_msglevel(struct net_device *dev,
+                     u32 value)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        tp->msg_enable = value;
+}
+
+static const char rtl8125_gstrings[][ETH_GSTRING_LEN] = {
+        "tx_packets",
+        "rx_packets",
+        "tx_errors",
+        "rx_errors",
+        "rx_missed",
+        "align_errors",
+        "tx_single_collisions",
+        "tx_multi_collisions",
+        "unicast",
+        "broadcast",
+        "multicast",
+        "tx_aborted",
+        "tx_underrun",
+};
+#endif //#LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,33)
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static int rtl8125_get_stats_count(struct net_device *dev)
+{
+        return ARRAY_SIZE(rtl8125_gstrings);
+}
+#endif //#LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+#else
+static int rtl8125_get_sset_count(struct net_device *dev, int sset)
+{
+        switch (sset) {
+        case ETH_SS_STATS:
+                return ARRAY_SIZE(rtl8125_gstrings);
+        default:
+                return -EOPNOTSUPP;
+        }
+}
+#endif
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static void
+rtl8125_get_ethtool_stats(struct net_device *dev,
+                          struct ethtool_stats *stats,
+                          u64 *data)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct rtl8125_counters *counters;
+        dma_addr_t paddr;
+        u32 cmd;
+        u32 WaitCnt;
+        unsigned long flags;
+
+        ASSERT_RTNL();
+
+        counters = tp->tally_vaddr;
+        paddr = tp->tally_paddr;
+        if (!counters)
+                return;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        RTL_W32(tp, CounterAddrHigh, (u64)paddr >> 32);
+        cmd = (u64)paddr & DMA_BIT_MASK(32);
+        RTL_W32(tp, CounterAddrLow, cmd);
+        RTL_W32(tp, CounterAddrLow, cmd | CounterDump);
+
+        WaitCnt = 0;
+        while (RTL_R32(tp, CounterAddrLow) & CounterDump) {
+                udelay(10);
+
+                WaitCnt++;
+                if (WaitCnt > 20)
+                        break;
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        data[0] = le64_to_cpu(counters->tx_packets);
+        data[1] = le64_to_cpu(counters->rx_packets);
+        data[2] = le64_to_cpu(counters->tx_errors);
+        data[3] = le32_to_cpu(counters->rx_errors);
+        data[4] = le16_to_cpu(counters->rx_missed);
+        data[5] = le16_to_cpu(counters->align_errors);
+        data[6] = le32_to_cpu(counters->tx_one_collision);
+        data[7] = le32_to_cpu(counters->tx_multi_collision);
+        data[8] = le64_to_cpu(counters->rx_unicast);
+        data[9] = le64_to_cpu(counters->rx_broadcast);
+        data[10] = le32_to_cpu(counters->rx_multicast);
+        data[11] = le16_to_cpu(counters->tx_aborted);
+        data[12] = le16_to_cpu(counters->tx_underun);
+}
+
+static void
+rtl8125_get_strings(struct net_device *dev,
+                    u32 stringset,
+                    u8 *data)
+{
+        switch (stringset) {
+        case ETH_SS_STATS:
+                memcpy(data, *rtl8125_gstrings, sizeof(rtl8125_gstrings));
+                break;
+        }
+}
+#endif //#LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+
+static int rtl_get_eeprom_len(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        return tp->eeprom_len;
+}
+
+static int rtl_get_eeprom(struct net_device *dev, struct ethtool_eeprom *eeprom, u8 *buf)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int i,j,ret;
+        int start_w, end_w;
+        int VPD_addr, VPD_data;
+        u32 *eeprom_buff;
+        u16 tmp;
+
+        if (tp->eeprom_type == EEPROM_TYPE_NONE) {
+                dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Detect none EEPROM\n");
+                return -EOPNOTSUPP;
+        } else if (eeprom->len == 0 || (eeprom->offset+eeprom->len) > tp->eeprom_len) {
+                dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Invalid parameter\n");
+                return -EINVAL;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        default:
+                VPD_addr = 0xD2;
+                VPD_data = 0xD4;
+                break;
+        }
+
+        start_w = eeprom->offset >> 2;
+        end_w = (eeprom->offset + eeprom->len - 1) >> 2;
+
+        eeprom_buff = kmalloc(sizeof(u32)*(end_w - start_w + 1), GFP_KERNEL);
+        if (!eeprom_buff)
+                return -ENOMEM;
+
+        rtl8125_enable_cfg9346_write(tp);
+        ret = -EFAULT;
+        for (i=start_w; i<=end_w; i++) {
+                pci_write_config_word(tp->pci_dev, VPD_addr, (u16)i*4);
+                ret = -EFAULT;
+                for (j = 0; j < 10; j++) {
+                        udelay(400);
+                        pci_read_config_word(tp->pci_dev, VPD_addr, &tmp);
+                        if (tmp&0x8000) {
+                                ret = 0;
+                                break;
+                        }
+                }
+
+                if (ret)
+                        break;
+
+                pci_read_config_dword(tp->pci_dev, VPD_data, &eeprom_buff[i-start_w]);
+        }
+        rtl8125_disable_cfg9346_write(tp);
+
+        if (!ret)
+                memcpy(buf, (u8 *)eeprom_buff + (eeprom->offset & 3), eeprom->len);
+
+        kfree(eeprom_buff);
+
+        return ret;
+}
+
+#undef ethtool_op_get_link
+#define ethtool_op_get_link _kc_ethtool_op_get_link
+static u32 _kc_ethtool_op_get_link(struct net_device *dev)
+{
+        return netif_carrier_ok(dev) ? 1 : 0;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+#undef ethtool_op_get_sg
+#define ethtool_op_get_sg _kc_ethtool_op_get_sg
+static u32 _kc_ethtool_op_get_sg(struct net_device *dev)
+{
+#ifdef NETIF_F_SG
+        return (dev->features & NETIF_F_SG) != 0;
+#else
+        return 0;
+#endif
+}
+
+#undef ethtool_op_set_sg
+#define ethtool_op_set_sg _kc_ethtool_op_set_sg
+static int _kc_ethtool_op_set_sg(struct net_device *dev, u32 data)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                return -EOPNOTSUPP;
+
+#ifdef NETIF_F_SG
+        if (data)
+                dev->features |= NETIF_F_SG;
+        else
+                dev->features &= ~NETIF_F_SG;
+#endif
+
+        return 0;
+}
+#endif
+
+static int rtl8125_enable_eee(struct rtl8125_private *tp)
+{
+        int ret;
+
+        ret = 0;
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+                SetMcuAccessRegBit(tp, 0xE040, (BIT_1|BIT_0));
+                SetMcuAccessRegBit(tp, 0xEB62, (BIT_2|BIT_1));
+
+                SetEthPhyOcpBit(tp, 0xA432, BIT_4);
+                SetEthPhyOcpBit(tp, 0xA5D0, (BIT_2 | BIT_1));
+                ClearEthPhyOcpBit(tp, 0xA6D4, BIT_0);
+
+                ClearEthPhyOcpBit(tp, 0xA6D8, BIT_4);
+                SetEthPhyOcpBit(tp, 0xA4A2, BIT_9);
+                SetEthPhyOcpBit(tp, 0xA428, BIT_7);
+                break;
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                SetMcuAccessRegBit(tp, 0xE040, (BIT_1|BIT_0));
+
+                SetEthPhyOcpBit(tp, 0xA5D0, tp->eee_adv_t);
+                ClearEthPhyOcpBit(tp, 0xA6D4, BIT_0);
+
+                ClearEthPhyOcpBit(tp, 0xA6D8, BIT_4);
+                ClearEthPhyOcpBit(tp, 0xA4A2, BIT_9);
+                ClearEthPhyOcpBit(tp, 0xA428, BIT_7);
+                break;
+        default:
+//      dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Not Support EEE\n");
+                ret = -EOPNOTSUPP;
+                break;
+        }
+
+        /*Advanced EEE*/
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_set_phy_mcu_patch_request(tp);
+                SetMcuAccessRegBit(tp, 0xE052, BIT_0);
+                ClearEthPhyOcpBit(tp, 0xA442, BIT_12 | BIT_13);
+                ClearEthPhyOcpBit(tp, 0xA430, BIT_15);
+                rtl8125_clear_phy_mcu_patch_request(tp);
+                break;
+        }
+
+        return ret;
+}
+
+static int rtl8125_disable_eee(struct rtl8125_private *tp)
+{
+        int ret;
+
+        ret = 0;
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+                ClearMcuAccessRegBit(tp, 0xE040, (BIT_1|BIT_0));
+                ClearMcuAccessRegBit(tp, 0xEB62, (BIT_2|BIT_1));
+
+                ClearEthPhyOcpBit(tp, 0xA432, BIT_4);
+                ClearEthPhyOcpBit(tp, 0xA5D0, (BIT_2 | BIT_1));
+                ClearEthPhyOcpBit(tp, 0xA6D4, BIT_0);
+
+                ClearEthPhyOcpBit(tp, 0xA6D8, BIT_4);
+                ClearEthPhyOcpBit(tp, 0xA428, BIT_7);
+                ClearEthPhyOcpBit(tp, 0xA4A2, BIT_9);
+                break;
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                ClearMcuAccessRegBit(tp, 0xE040, (BIT_1|BIT_0));
+
+                ClearEthPhyOcpBit(tp, 0xA5D0, (BIT_2 | BIT_1));
+                ClearEthPhyOcpBit(tp, 0xA6D4, BIT_0);
+
+                ClearEthPhyOcpBit(tp, 0xA6D8, BIT_4);
+                ClearEthPhyOcpBit(tp, 0xA428, BIT_7);
+                ClearEthPhyOcpBit(tp, 0xA4A2, BIT_9);
+                break;
+        default:
+//      dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Not Support EEE\n");
+                ret = -EOPNOTSUPP;
+                break;
+        }
+
+        /*Advanced EEE*/
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_set_phy_mcu_patch_request(tp);
+                ClearMcuAccessRegBit(tp, 0xE052, BIT_0);
+                ClearEthPhyOcpBit(tp, 0xA442, BIT_12 | BIT_13);
+                ClearEthPhyOcpBit(tp, 0xA430, BIT_15);
+                rtl8125_clear_phy_mcu_patch_request(tp);
+                break;
+        }
+
+        return ret;
+}
+
+static int rtl_nway_reset(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+        int ret, bmcr;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        if (unlikely(tp->rtk_enable_diag)) {
+                spin_unlock_irqrestore(&tp->lock, flags);
+                return -EBUSY;
+        }
+
+        /* if autoneg is off, it's an error */
+        rtl8125_mdio_write(tp, 0x1F, 0x0000);
+        bmcr = rtl8125_mdio_read(tp, MII_BMCR);
+
+        if (bmcr & BMCR_ANENABLE) {
+                bmcr |= BMCR_ANRESTART;
+                rtl8125_mdio_write(tp, MII_BMCR, bmcr);
+                ret = 0;
+        } else {
+                ret = -EINVAL;
+        }
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return ret;
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+static int
+rtl_ethtool_get_eee(struct net_device *net, struct ethtool_eee *eee)
+{
+        struct rtl8125_private *tp = netdev_priv(net);
+        u32 lp, adv, supported = 0;
+        unsigned long flags;
+        u16 val;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        if (unlikely(tp->rtk_enable_diag)) {
+                spin_unlock_irqrestore(&tp->lock, flags);
+                return -EBUSY;
+        }
+
+        /* Get Supported EEE */
+        val = mdio_direct_read_phy_ocp(tp, 0xA5C4);
+        supported = mmd_eee_cap_to_ethtool_sup_t(val);
+
+        /* Get advertisement EEE */
+        val = mdio_direct_read_phy_ocp(tp, 0xA5D0);
+        adv = mmd_eee_adv_to_ethtool_adv_t(val);
+
+        /* Get LP advertisement EEE */
+        val = mdio_direct_read_phy_ocp(tp, 0xA5D2);
+        lp = mmd_eee_adv_to_ethtool_adv_t(val);
+
+        val = rtl8125_mac_ocp_read(tp, 0xE040);
+        val &= BIT_1 | BIT_0;
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        eee->eee_enabled = !!val;
+        eee->eee_active = !!(supported & adv & lp);
+        eee->supported = supported;
+        eee->advertised = adv;
+        eee->lp_advertised = lp;
+
+        return 0;
+}
+
+static int
+rtl_ethtool_set_eee(struct net_device *net, struct ethtool_eee *eee)
+{
+        struct rtl8125_private *tp = netdev_priv(net);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        if (unlikely(tp->rtk_enable_diag)) {
+                spin_unlock_irqrestore(&tp->lock, flags);
+                return -EBUSY;
+        }
+
+        tp->eee_enabled = eee->eee_enabled;
+        tp->eee_adv_t = ethtool_adv_to_mmd_eee_adv_t(eee->advertised);
+
+        if (tp->eee_enabled) {
+                rtl8125_enable_eee(tp);
+        } else {
+                rtl8125_disable_eee(tp);
+        }
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        rtl_nway_reset(net);
+
+        return 0;
+}
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static const struct ethtool_ops rtl8125_ethtool_ops = {
+        .get_drvinfo        = rtl8125_get_drvinfo,
+        .get_regs_len       = rtl8125_get_regs_len,
+        .get_link       = ethtool_op_get_link,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+        .get_settings       = rtl8125_get_settings,
+        .set_settings       = rtl8125_set_settings,
+#else
+        .get_link_ksettings       = rtl8125_get_settings,
+        .set_link_ksettings       = rtl8125_set_settings,
+#endif
+        .get_msglevel       = rtl8125_get_msglevel,
+        .set_msglevel       = rtl8125_set_msglevel,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+        .get_rx_csum        = rtl8125_get_rx_csum,
+        .set_rx_csum        = rtl8125_set_rx_csum,
+        .get_tx_csum        = rtl8125_get_tx_csum,
+        .set_tx_csum        = rtl8125_set_tx_csum,
+        .get_sg         = ethtool_op_get_sg,
+        .set_sg         = ethtool_op_set_sg,
+#ifdef NETIF_F_TSO
+        .get_tso        = ethtool_op_get_tso,
+        .set_tso        = ethtool_op_set_tso,
+#endif
+#endif
+        .get_regs       = rtl8125_get_regs,
+        .get_wol        = rtl8125_get_wol,
+        .set_wol        = rtl8125_set_wol,
+        .get_strings        = rtl8125_get_strings,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,33)
+        .get_stats_count    = rtl8125_get_stats_count,
+#else
+        .get_sset_count     = rtl8125_get_sset_count,
+#endif
+        .get_ethtool_stats  = rtl8125_get_ethtool_stats,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,23)
+#ifdef ETHTOOL_GPERMADDR
+        .get_perm_addr      = ethtool_op_get_perm_addr,
+#endif
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,23)
+        .get_eeprom     = rtl_get_eeprom,
+        .get_eeprom_len     = rtl_get_eeprom_len,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,5,0)
+        .get_ts_info        = ethtool_op_get_ts_info,
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(3,5,0)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+        .get_eee = rtl_ethtool_get_eee,
+        .set_eee = rtl_ethtool_set_eee,
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+        .nway_reset = rtl_nway_reset,
+};
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+
+#if 0
+
+static int rtl8125_enable_green_feature(struct rtl8125_private *tp)
+{
+        u16 gphy_val;
+        unsigned long flags;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                mdio_direct_write_phy_ocp(tp, 0xA436, 0x8011);
+                SetEthPhyOcpBit(tp, 0xA438, BIT_15);
+                rtl8125_mdio_write(tp, 0x00, 0x9200);
+                break;
+        default:
+                dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Not Support Green Feature\n");
+                break;
+        }
+
+        return 0;
+}
+
+static int rtl8125_disable_green_feature(struct rtl8125_private *tp)
+{
+        u16 gphy_val;
+        unsigned long flags;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                mdio_direct_write_phy_ocp(tp, 0xA436, 0x8011);
+                ClearEthPhyOcpBit(tp, 0xA438, BIT_15);
+                rtl8125_mdio_write(tp, 0x00, 0x9200);
+                break;
+        default:
+                dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Not Support Green Feature\n");
+                break;
+        }
+
+        return 0;
+}
+
+#endif
+
+static void rtl8125_get_mac_version(struct rtl8125_private *tp)
+{
+        u32 reg,val32;
+        u32 ICVerID;
+
+        val32 = RTL_R32(tp, TxConfig);
+        reg = val32 & 0x7c800000;
+        ICVerID = val32 & 0x00700000;
+
+        switch (reg) {
+        case 0x60800000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_2;
+                } else if (ICVerID == 0x100000) {
+                        tp->mcfg = CFG_METHOD_3;
+                } else {
+                        tp->mcfg = CFG_METHOD_3;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+
+                tp->efuse_ver = EFUSE_SUPPORT_V4;
+                break;
+        case 0x64000000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_4;
+                } else if (ICVerID == 0x100000) {
+                        tp->mcfg = CFG_METHOD_5;
+                } else {
+                        tp->mcfg = CFG_METHOD_5;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+
+                tp->efuse_ver = EFUSE_SUPPORT_V4;
+                break;
+        default:
+                printk("unknown chip version (%x)\n",reg);
+                tp->mcfg = CFG_METHOD_DEFAULT;
+                tp->HwIcVerUnknown = TRUE;
+                tp->efuse_ver = EFUSE_NOT_SUPPORT;
+                break;
+        }
+}
+
+static void
+rtl8125_print_mac_version(struct rtl8125_private *tp)
+{
+        int i;
+        for (i = ARRAY_SIZE(rtl_chip_info) - 1; i >= 0; i--) {
+                if (tp->mcfg == rtl_chip_info[i].mcfg) {
+                        dprintk("Realtek PCIe 2.5GbE Family Controller mcfg = %04d\n",
+                                rtl_chip_info[i].mcfg);
+                        return;
+                }
+        }
+
+        dprintk("mac_version == Unknown\n");
+}
+
+static void
+rtl8125_tally_counter_addr_fill(struct rtl8125_private *tp)
+{
+        if (!tp->tally_paddr)
+                return;
+
+        RTL_W32(tp, CounterAddrHigh, (u64)tp->tally_paddr >> 32);
+        RTL_W32(tp, CounterAddrLow, (u64)tp->tally_paddr & (DMA_BIT_MASK(32)));
+}
+
+static void
+rtl8125_tally_counter_clear(struct rtl8125_private *tp)
+{
+        if (!tp->tally_paddr)
+                return;
+
+        RTL_W32(tp, CounterAddrHigh, (u64)tp->tally_paddr >> 32);
+        RTL_W32(tp, CounterAddrLow, ((u64)tp->tally_paddr & (DMA_BIT_MASK(32))) | CounterReset);
+}
+
+static void
+rtl8125_clear_phy_ups_reg(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                ClearEthPhyOcpBit(tp, 0xA466, BIT_0);
+                break;
+        };
+        ClearEthPhyOcpBit(tp, 0xA468, BIT_3 | BIT_1);
+}
+
+static int
+rtl8125_is_ups_resume(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        if (tp->mcfg == CFG_METHOD_2 ||
+            tp->mcfg == CFG_METHOD_3 ||
+            tp->mcfg == CFG_METHOD_4 ||
+            tp->mcfg == CFG_METHOD_5)
+                return (rtl8125_mac_ocp_read(tp, 0xD42C) & BIT_8);
+
+        return 0;
+}
+
+static void
+rtl8125_clear_ups_resume_bit(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        if (tp->mcfg == CFG_METHOD_2 ||
+            tp->mcfg == CFG_METHOD_3 ||
+            tp->mcfg == CFG_METHOD_4 ||
+            tp->mcfg == CFG_METHOD_5)
+                rtl8125_mac_ocp_write(tp, 0xD408, rtl8125_mac_ocp_read(tp, 0xD408) & ~(BIT_8));
+}
+
+static void
+rtl8125_wait_phy_ups_resume(struct net_device *dev, u16 PhyState)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u16 TmpPhyState;
+        int i=0;
+
+        if (tp->mcfg == CFG_METHOD_2 ||
+            tp->mcfg == CFG_METHOD_3 ||
+            tp->mcfg == CFG_METHOD_4 ||
+            tp->mcfg == CFG_METHOD_5) {
+                do {
+                        TmpPhyState = mdio_direct_read_phy_ocp(tp, 0xA420);
+                        TmpPhyState &= 0x7;
+                        mdelay(1);
+                        i++;
+                } while ((i < 100) && (TmpPhyState != PhyState));
+        }
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)
+        WARN_ON_ONCE(i == 100);
+#endif
+}
+
+void
+rtl8125_enable_now_is_oob(struct rtl8125_private *tp)
+{
+        if ( tp->HwSuppNowIsOobVer == 1 ) {
+                RTL_W8(tp, MCUCmd_reg, RTL_R8(tp, MCUCmd_reg) | Now_is_oob);
+        }
+}
+
+void
+rtl8125_disable_now_is_oob(struct rtl8125_private *tp)
+{
+        if ( tp->HwSuppNowIsOobVer == 1 ) {
+                RTL_W8(tp, MCUCmd_reg, RTL_R8(tp, MCUCmd_reg) & ~Now_is_oob);
+        }
+}
+
+static void
+rtl8125_exit_oob(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u16 data16;
+
+        RTL_W32(tp, RxConfig, RTL_R32(tp, RxConfig) & ~(AcceptErr | AcceptRunt | AcceptBroadcast | AcceptMulticast | AcceptMyPhys |  AcceptAllPhys));
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_dash2_disable_txrx(dev);
+                break;
+        }
+
+        if (tp->DASH) {
+                rtl8125_driver_stop(tp);
+                rtl8125_driver_start(tp);
+#ifdef ENABLE_DASH_SUPPORT
+                DashHwInit(dev);
+#endif
+        }
+
+#ifdef ENABLE_REALWOW_SUPPORT
+        rtl8125_realwow_hw_init(dev);
+#else
+        //Disable realwow  function
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xC0BC, 0x00FF);
+                break;
+        }
+#endif //ENABLE_REALWOW_SUPPORT
+
+        rtl8125_nic_reset(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_disable_now_is_oob(tp);
+
+                data16 = rtl8125_mac_ocp_read(tp, 0xE8DE) & ~BIT_14;
+                rtl8125_mac_ocp_write(tp, 0xE8DE, data16);
+                rtl8125_wait_ll_share_fifo_ready(dev);
+
+                rtl8125_mac_ocp_write(tp, 0xC0AA, 0x07D0);
+                rtl8125_mac_ocp_write(tp, 0xC0A6, 0x01B5);
+                rtl8125_mac_ocp_write(tp, 0xC01E, 0x5555);
+
+                rtl8125_wait_ll_share_fifo_ready(dev);
+                break;
+        }
+
+        //wait ups resume (phy state 2)
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                if (rtl8125_is_ups_resume(dev)) {
+                        rtl8125_wait_phy_ups_resume(dev, 2);
+                        rtl8125_clear_ups_resume_bit(dev);
+                        rtl8125_clear_phy_ups_reg(dev);
+                }
+                break;
+        };
+
+        tp->phy_reg_anlpar = 0;
+}
+
+void
+rtl8125_hw_disable_mac_mcu_bps(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_enable_cfg9346_write(tp);
+                RTL_W8(tp, Config5, RTL_R8(tp, Config5) & ~BIT_0);
+                RTL_W8(tp, Config2, RTL_R8(tp, Config2) & ~BIT_7);
+                rtl8125_disable_cfg9346_write(tp);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xFC38, 0x0000);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xFC28, 0x0000);
+                rtl8125_mac_ocp_write(tp, 0xFC2A, 0x0000);
+                rtl8125_mac_ocp_write(tp, 0xFC2C, 0x0000);
+                rtl8125_mac_ocp_write(tp, 0xFC2E, 0x0000);
+                rtl8125_mac_ocp_write(tp, 0xFC30, 0x0000);
+                rtl8125_mac_ocp_write(tp, 0xFC32, 0x0000);
+                rtl8125_mac_ocp_write(tp, 0xFC34, 0x0000);
+                rtl8125_mac_ocp_write(tp, 0xFC36, 0x0000);
+                mdelay(3);
+                rtl8125_mac_ocp_write(tp, 0xFC26, 0x0000);
+                break;
+        }
+}
+
+static void
+rtl8125_set_mac_mcu_8125a_1(struct net_device *dev)
+{
+        rtl8125_hw_disable_mac_mcu_bps(dev);
+}
+
+static void
+rtl8125_set_mac_mcu_8125a_2(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u16 i;
+        static const u16 mcu_patch_code_8125a_2[] =  {
+                0xE008, 0xE01E, 0xE02E, 0xE054, 0xE057, 0xE059, 0xE0C2, 0xE0CB, 0x9996,
+                0x49D1, 0xF005, 0x49D4, 0xF10A, 0x49D8, 0xF108, 0xC00F, 0x7100, 0x209C,
+                0x249C, 0xC009, 0x9900, 0xE004, 0xC006, 0x1900, 0x9900, 0xC602, 0xBE00,
+                0x5A48, 0xE0C2, 0x0004, 0xE10A, 0xC60F, 0x73C4, 0x49B3, 0xF106, 0x73C2,
+                0xC608, 0xB406, 0xC609, 0xFF80, 0xC605, 0xB406, 0xC605, 0xFF80, 0x0544,
+                0x0568, 0xE906, 0xCDE8, 0xC724, 0xC624, 0x9EE2, 0x1E01, 0x9EE0, 0x76E0,
+                0x49E0, 0xF1FE, 0x76E6, 0x486D, 0x4868, 0x9EE4, 0x1E03, 0x9EE0, 0x76E0,
+                0x49E0, 0xF1FE, 0xC615, 0x9EE2, 0x1E01, 0x9EE0, 0x76E0, 0x49E0, 0xF1FE,
+                0x76E6, 0x486F, 0x9EE4, 0x1E03, 0x9EE0, 0x76E0, 0x49E0, 0xF1FE, 0x7196,
+                0xC702, 0xBF00, 0x5A44, 0xEB0E, 0x0070, 0x00C3, 0x1BC0, 0xC602, 0xBE00,
+                0x0E26, 0xC602, 0xBE00, 0x0EBA, 0x1501, 0xF02A, 0x1500, 0xF15D, 0xC661,
+                0x75C8, 0x49D5, 0xF00A, 0x49D6, 0xF008, 0x49D7, 0xF006, 0x49D8, 0xF004,
+                0x75D2, 0x49D9, 0xF150, 0xC553, 0x77A0, 0x75C8, 0x4855, 0x4856, 0x4857,
+                0x4858, 0x48DA, 0x48DB, 0x49FE, 0xF002, 0x485A, 0x49FF, 0xF002, 0x485B,
+                0x9DC8, 0x75D2, 0x4859, 0x9DD2, 0xC643, 0x75C0, 0x49D4, 0xF033, 0x49D0,
+                0xF137, 0xE030, 0xC63A, 0x75C8, 0x49D5, 0xF00E, 0x49D6, 0xF00C, 0x49D7,
+                0xF00A, 0x49D8, 0xF008, 0x75D2, 0x49D9, 0xF005, 0xC62E, 0x75C0, 0x49D7,
+                0xF125, 0xC528, 0x77A0, 0xC627, 0x75C8, 0x4855, 0x4856, 0x4857, 0x4858,
+                0x48DA, 0x48DB, 0x49FE, 0xF002, 0x485A, 0x49FF, 0xF002, 0x485B, 0x9DC8,
+                0x75D2, 0x4859, 0x9DD2, 0xC616, 0x75C0, 0x4857, 0x9DC0, 0xC613, 0x75C0,
+                0x49DA, 0xF003, 0x49D0, 0xF107, 0xC60B, 0xC50E, 0x48D9, 0x9DC0, 0x4859,
+                0x9DC0, 0xC608, 0xC702, 0xBF00, 0x3AE0, 0xE860, 0xB400, 0xB5D4, 0xE908,
+                0xE86C, 0x1200, 0xC409, 0x6780, 0x48F1, 0x8F80, 0xC404, 0xC602, 0xBE00,
+                0x10AA, 0xC010, 0xEA7C, 0xC602, 0xBE00, 0x0000
+        };
+
+        rtl8125_hw_disable_mac_mcu_bps(dev);
+
+        for (i = 0; i < ARRAY_SIZE(mcu_patch_code_8125a_2); i++) {
+                rtl8125_mac_ocp_write(tp, 0xF800 + i * 2, mcu_patch_code_8125a_2[i]);
+        }
+
+        rtl8125_mac_ocp_write(tp, 0xFC26, 0x8000);
+
+        rtl8125_mac_ocp_write(tp, 0xFC2A, 0x0540);
+        rtl8125_mac_ocp_write(tp, 0xFC2E, 0x0E24);
+        rtl8125_mac_ocp_write(tp, 0xFC30, 0x0EB8);
+        rtl8125_mac_ocp_write(tp, 0xFC32, 0x3A5C);
+        rtl8125_mac_ocp_write(tp, 0xFC34, 0x10A8);
+
+        rtl8125_mac_ocp_write(tp, 0xFC48, 0x007A);
+}
+
+static void
+rtl8125_set_mac_mcu_8125b_1(struct net_device *dev)
+{
+        rtl8125_hw_disable_mac_mcu_bps(dev);
+}
+
+static void
+rtl8125_hw_mac_mcu_config(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        if (tp->NotWrMcuPatchCode == TRUE) return;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+                rtl8125_set_mac_mcu_8125a_1(dev);
+                break;
+        case CFG_METHOD_3:
+                rtl8125_set_mac_mcu_8125a_2(dev);
+                break;
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_set_mac_mcu_8125b_1(dev);
+                break;
+        }
+}
+
+static void
+rtl8125_hw_init(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_enable_cfg9346_write(tp);
+                RTL_W8(tp, Config5, RTL_R8(tp, Config5) & ~BIT_0);
+                RTL_W8(tp, Config2, RTL_R8(tp, Config2) & ~BIT_7);
+                rtl8125_disable_cfg9346_write(tp);
+                RTL_W8(tp, 0xF1, RTL_R8(tp, 0xF1) & ~BIT_7);
+                break;
+        }
+
+        //Disable UPS
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xD40A, rtl8125_mac_ocp_read( tp, 0xD40A) & ~(BIT_4));
+                break;
+        }
+
+        rtl8125_hw_mac_mcu_config(dev);
+
+        /*disable ocp phy power saving*/
+        if (tp->mcfg == CFG_METHOD_2 ||
+            tp->mcfg == CFG_METHOD_3 ||
+            tp->mcfg == CFG_METHOD_4 ||
+            tp->mcfg == CFG_METHOD_5)
+                rtl8125_disable_ocp_phy_power_saving(dev);
+
+        //Set PCIE uncorrectable error status mask pcie 0x108
+        csi_tmp = rtl8125_csi_read(tp, 0x108);
+        csi_tmp |= BIT_20;
+        rtl8125_csi_write(tp, 0x108, csi_tmp);
+
+        if (s0_magic_packet == 1)
+                rtl8125_enable_magic_packet(dev);
+}
+
+static void
+rtl8125_hw_ephy_config(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+                rtl8125_ephy_write(tp, 0x01, 0xA812);
+                rtl8125_ephy_write(tp, 0x09, 0x520C);
+                rtl8125_ephy_write(tp, 0x04, 0xD000);
+                rtl8125_ephy_write(tp, 0x0D, 0xF702);
+                rtl8125_ephy_write(tp, 0x0A, 0x8653);
+                rtl8125_ephy_write(tp, 0x06, 0x001E);
+                rtl8125_ephy_write(tp, 0x08, 0x3595);
+                rtl8125_ephy_write(tp, 0x20, 0x9455);
+                rtl8125_ephy_write(tp, 0x21, 0x99FF);
+                rtl8125_ephy_write(tp, 0x02, 0x6046);
+                rtl8125_ephy_write(tp, 0x29, 0xFE00);
+                rtl8125_ephy_write(tp, 0x23, 0xAB62);
+
+                rtl8125_ephy_write(tp, 0x41, 0xA80C);
+                rtl8125_ephy_write(tp, 0x49, 0x520C);
+                rtl8125_ephy_write(tp, 0x44, 0xD000);
+                rtl8125_ephy_write(tp, 0x4D, 0xF702);
+                rtl8125_ephy_write(tp, 0x4A, 0x8653);
+                rtl8125_ephy_write(tp, 0x46, 0x001E);
+                rtl8125_ephy_write(tp, 0x48, 0x3595);
+                rtl8125_ephy_write(tp, 0x60, 0x9455);
+                rtl8125_ephy_write(tp, 0x61, 0x99FF);
+                rtl8125_ephy_write(tp, 0x42, 0x6046);
+                rtl8125_ephy_write(tp, 0x69, 0xFE00);
+                rtl8125_ephy_write(tp, 0x63, 0xAB62);
+                break;
+        case CFG_METHOD_3:
+                rtl8125_ephy_write(tp, 0x04, 0xD000);
+                rtl8125_ephy_write(tp, 0x0A, 0x8653);
+                rtl8125_ephy_write(tp, 0x23, 0xAB66);
+                rtl8125_ephy_write(tp, 0x20, 0x9455);
+                rtl8125_ephy_write(tp, 0x21, 0x99FF);
+                rtl8125_ephy_write(tp, 0x29, 0xFE04);
+
+                rtl8125_ephy_write(tp, 0x44, 0xD000);
+                rtl8125_ephy_write(tp, 0x4A, 0x8653);
+                rtl8125_ephy_write(tp, 0x63, 0xAB66);
+                rtl8125_ephy_write(tp, 0x60, 0x9455);
+                rtl8125_ephy_write(tp, 0x61, 0x99FF);
+                rtl8125_ephy_write(tp, 0x69, 0xFE04);
+
+                ClearAndSetPCIePhyBit(tp,
+                                      0x2A,
+                                      (BIT_14 | BIT_13 | BIT_12),
+                                      (BIT_13 | BIT_12)
+                                     );
+                ClearPCIePhyBit(tp, 0x19, BIT_6);
+                SetPCIePhyBit(tp, 0x1B, (BIT_11 | BIT_10 | BIT_9));
+                ClearPCIePhyBit(tp, 0x1B, (BIT_14 | BIT_13 | BIT_12));
+                rtl8125_ephy_write(tp, 0x02, 0x6042);
+                rtl8125_ephy_write(tp, 0x06, 0x0014);
+
+                ClearAndSetPCIePhyBit(tp,
+                                      0x6A,
+                                      (BIT_14 | BIT_13 | BIT_12),
+                                      (BIT_13 | BIT_12)
+                                     );
+                ClearPCIePhyBit(tp, 0x59, BIT_6);
+                SetPCIePhyBit(tp, 0x5B, (BIT_11 | BIT_10 | BIT_9));
+                ClearPCIePhyBit(tp, 0x5B, (BIT_14 | BIT_13 | BIT_12));
+                rtl8125_ephy_write(tp, 0x42, 0x6042);
+                rtl8125_ephy_write(tp, 0x46, 0x0014);
+                break;
+        case CFG_METHOD_4:
+                rtl8125_ephy_write(tp, 0x06, 0x001F);
+                rtl8125_ephy_write(tp, 0x0A, 0xB66B);
+                rtl8125_ephy_write(tp, 0x01, 0xA852);
+                rtl8125_ephy_write(tp, 0x24, 0x0008);
+                rtl8125_ephy_write(tp, 0x2F, 0x6052);
+                rtl8125_ephy_write(tp, 0x0D, 0xF716);
+                rtl8125_ephy_write(tp, 0x20, 0xD477);
+                rtl8125_ephy_write(tp, 0x21, 0x4477);
+                rtl8125_ephy_write(tp, 0x22, 0x0013);
+                rtl8125_ephy_write(tp, 0x23, 0xBB66);
+                rtl8125_ephy_write(tp, 0x0B, 0xA909);
+                rtl8125_ephy_write(tp, 0x29, 0xFF04);
+                rtl8125_ephy_write(tp, 0x1B, 0x1EA0);
+
+                rtl8125_ephy_write(tp, 0x46, 0x001F);
+                rtl8125_ephy_write(tp, 0x4A, 0xB66B);
+                rtl8125_ephy_write(tp, 0x41, 0xA84A);
+                rtl8125_ephy_write(tp, 0x64, 0x000C);
+                rtl8125_ephy_write(tp, 0x6F, 0x604A);
+                rtl8125_ephy_write(tp, 0x4D, 0xF716);
+                rtl8125_ephy_write(tp, 0x60, 0xD477);
+                rtl8125_ephy_write(tp, 0x61, 0x4477);
+                rtl8125_ephy_write(tp, 0x62, 0x0013);
+                rtl8125_ephy_write(tp, 0x63, 0xBB66);
+                rtl8125_ephy_write(tp, 0x4B, 0xA909);
+                rtl8125_ephy_write(tp, 0x69, 0xFF04);
+                rtl8125_ephy_write(tp, 0x5B, 0x1EA0);
+                break;
+        case CFG_METHOD_5:
+                rtl8125_ephy_write(tp, 0x0B, 0xA908);
+                rtl8125_ephy_write(tp, 0x1B, 0x0EA0);
+                rtl8125_ephy_write(tp, 0x1E, 0x20EB);
+
+                rtl8125_ephy_write(tp, 0x4B, 0xA908);
+                rtl8125_ephy_write(tp, 0x5B, 0x0EA0);
+                rtl8125_ephy_write(tp, 0x5E, 0x20EB);
+                break;
+        }
+}
+
+static int
+rtl8125_check_hw_phy_mcu_code_ver(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int ram_code_ver_match = 0;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                mdio_direct_write_phy_ocp(tp, 0xA436, 0x801E);
+                tp->hw_ram_code_ver = mdio_direct_read_phy_ocp(tp, 0xA438);
+                break;
+        default:
+                tp->hw_ram_code_ver = ~0;
+                break;
+        }
+
+        if ( tp->hw_ram_code_ver == tp->sw_ram_code_ver) {
+                ram_code_ver_match = 1;
+                tp->HwHasWrRamCodeToMicroP = TRUE;
+        }
+
+        return ram_code_ver_match;
+}
+
+static void
+rtl8125_write_hw_phy_mcu_code_ver(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                mdio_direct_write_phy_ocp(tp, 0xA436, 0x801E);
+                mdio_direct_write_phy_ocp(tp, 0xA438, tp->sw_ram_code_ver);
+                tp->hw_ram_code_ver = tp->sw_ram_code_ver;
+                break;
+        }
+}
+
+static void
+rtl8125_acquire_phy_mcu_patch_key_lock(struct rtl8125_private *tp)
+{
+        u16 PatchKey;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+                PatchKey = 0x8600;
+                break;
+        case CFG_METHOD_3:
+                PatchKey = 0x8601;
+                break;
+        case CFG_METHOD_4:
+                PatchKey = 0x3700;
+                break;
+        case CFG_METHOD_5:
+                PatchKey = 0x3701;
+                break;
+        default:
+                return;
+        }
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8024);
+        mdio_direct_write_phy_ocp(tp, 0xA438, PatchKey);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xB82E);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0001);
+}
+
+static void
+rtl8125_release_phy_mcu_patch_key_lock(struct rtl8125_private *tp)
+{
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                mdio_direct_write_phy_ocp(tp, 0xA436, 0x0000);
+                mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+                ClearEthPhyOcpBit(tp, 0xB82E, BIT_0);
+                mdio_direct_write_phy_ocp(tp, 0xA436, 0x8024);
+                mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+                break;
+        default:
+                break;
+        }
+}
+
+bool
+rtl8125_set_phy_mcu_patch_request(struct rtl8125_private *tp)
+{
+        u16 gphy_val;
+        u16 WaitCount = 0;
+        int i;
+        bool bSuccess = TRUE;
+
+        SetEthPhyOcpBit(tp, 0xB820, BIT_4);
+
+        i = 0;
+        do {
+                gphy_val = mdio_direct_read_phy_ocp(tp, 0xB800);
+                gphy_val &= BIT_6;
+                udelay(50);
+                udelay(50);
+                i++;
+        } while(gphy_val != BIT_6 && i < 1000);
+
+        if (gphy_val != BIT_6 && WaitCount == 1000) bSuccess = FALSE;
+
+        return bSuccess;
+}
+
+bool
+rtl8125_clear_phy_mcu_patch_request(struct rtl8125_private *tp)
+{
+        u16 gphy_val;
+        u16 WaitCount = 0;
+        int i;
+        bool bSuccess = TRUE;
+
+        ClearEthPhyOcpBit(tp, 0xB820, BIT_4);
+
+        i = 0;
+        do {
+                gphy_val = mdio_direct_read_phy_ocp(tp, 0xB800);
+                gphy_val &= BIT_6;
+                udelay(50);
+                udelay(50);
+                i++;
+        } while(gphy_val != BIT_6 && i < 1000);
+
+        if (gphy_val != BIT_6 && WaitCount == 1000) bSuccess = FALSE;
+
+        return bSuccess;
+}
+
+static void
+rtl8125_set_phy_mcu_ram_code(struct net_device *dev, const u16 *ramcode, u16 codesize)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u16 i;
+        u16 addr;
+        u16 val;
+
+        if (ramcode == NULL || codesize % 2) {
+                goto out;
+        }
+
+        for (i = 0; i < codesize; i += 2) {
+                addr = ramcode[i];
+                val = ramcode[i + 1];
+                if (addr == 0xFFFF && val == 0xFFFF) {
+                        break;
+                }
+                mdio_direct_write_phy_ocp(tp, addr, val);
+        }
+
+out:
+        return;
+}
+
+static void
+rtl8125_real_set_phy_mcu_8125a_1(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        rtl8125_acquire_phy_mcu_patch_key_lock(tp);
+
+
+        SetEthPhyOcpBit(tp, 0xB820, BIT_7);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA016);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA012);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA014);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8013);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8021);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x802f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x803d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8042);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8051);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8051);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa088);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a50);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8008);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd014);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd1a3);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x401a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd707);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x40c2);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60a6);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5f8b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a86);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a6c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8080);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd019);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd1a2);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x401a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd707);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x40c4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60a6);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5f8b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a86);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a84);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd503);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8970);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c07);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0901);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xcf09);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd705);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xceff);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaf0a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1213);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8401);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8580);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1253);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd064);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd181);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4018);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xc50f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd706);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2c59);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x804d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xc60f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xc605);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xae02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x10fd);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA026);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA024);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA022);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x10f4);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA020);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1252);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA006);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1206);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA004);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a78);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a60);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a4f);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA008);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x3f00);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA016);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0010);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA012);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA014);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8066);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x807c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8089);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x808e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x80a0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x80b2);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x80c2);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x62db);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x655c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd73e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60e9);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x614a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x61ab);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0503);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0505);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0509);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x653c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd73e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60e9);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x614a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x61ab);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0503);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0502);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0506);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x050a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd73e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60e9);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x614a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x61ab);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0505);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0506);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x050c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd73e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60e9);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x614a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x61ab);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0509);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x050a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x050c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0508);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0304);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd73e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60e9);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x614a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x61ab);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0321);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0502);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0321);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0321);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0508);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0321);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0346);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8208);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x609d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa50f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x001a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0503);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x001a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x607d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00ab);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00ab);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60fd);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa50f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaa0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x017b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0503);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a05);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x017b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60fd);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa50f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaa0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x01e0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0503);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a05);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x01e0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60fd);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa50f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaa0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0231);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0503);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a05);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0231);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA08E);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA08C);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0221);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA08A);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x01ce);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA088);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0169);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA086);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00a6);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA084);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x000d);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA082);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0308);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA080);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x029f);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA090);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x007f);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA016);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0020);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA012);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA014);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8017);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x801b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8029);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8054);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x805a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8064);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x80a7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x9430);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x9480);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb408);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd120);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd057);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x064b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xcb80);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x9906);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0567);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xcb94);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8190);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x82a0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x800a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8406);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8dff);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07e4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa840);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0773);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xcb91);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4063);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd139);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd140);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd040);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07dc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa610);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa110);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa2a0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4045);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa180);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x405d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa720);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0742);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07ec);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5f74);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0742);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd702);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7fb6);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8190);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x82a0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8610);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07dc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x064b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07c0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5fa7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0481);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x94bc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x870c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa190);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa00a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa280);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8220);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x078e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xcb92);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa840);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4063);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd140);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd150);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd040);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd703);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60a0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6121);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x61a2);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6223);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf02f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d10);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf00f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d20);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf00a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d30);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf005);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d40);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07e4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa610);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa008);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4046);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x405d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa720);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0742);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07f7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5f74);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0742);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd702);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7fb5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x800a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07e4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x3ad4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0537);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8610);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8840);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x064b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8301);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x800a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8190);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x82a0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa70c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x9402);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x890c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8840);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x064b);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA10E);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0642);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA10C);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0686);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA10A);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0788);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA108);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x047b);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA106);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x065c);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA104);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0769);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA102);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0565);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA100);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x06f9);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA110);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00ff);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb87c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8530);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb87e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaf85);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x3caf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8593);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaf85);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x9caf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x85a5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf86);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd702);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5afb);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xe083);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfb0c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x020d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x021b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x10bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86d7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86da);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfbe0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x83fc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1b10);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf86);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xda02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf86);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xdd02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5afb);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xe083);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfd0c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x020d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x021b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x10bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86dd);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86e0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfbe0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x83fe);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1b10);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf86);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xe002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaf2f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbd02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2cac);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0286);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x65af);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x212b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x022c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86b6);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaf21);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cd1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x03bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8710);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x870d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8719);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8716);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x871f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x871c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8728);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8725);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8707);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfbad);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x281c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd100);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1302);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2202);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2b02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xae1a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd101);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1302);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2202);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2b02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd101);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x3402);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x3102);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x3d02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x3a02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4302);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4c02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4902);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd100);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2e02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x3702);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4602);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf87);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4f02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ab7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaf35);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7ff8);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfaef);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x69bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86e3);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfbbf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86fb);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86e6);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfbbf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86fe);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86e9);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfbbf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86ec);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfbbf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x025a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7bf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86ef);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0262);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7cbf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86f2);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0262);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7cbf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86f5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0262);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7cbf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x86f8);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0262);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7cef);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x96fe);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfc04);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf8fa);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xef69);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf86);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xef02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6273);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf86);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf202);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6273);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf86);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf502);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6273);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbf86);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf802);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6273);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xef96);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfefc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0420);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb540);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x53b5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4086);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb540);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb9b5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x40c8);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb03a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xc8b0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbac8);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb13a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xc8b1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xba77);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbd26);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffbd);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2677);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbd28);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffbd);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2840);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbd26);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xc8bd);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2640);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbd28);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xc8bd);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x28bb);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa430);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x98b0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1eba);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb01e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xdcb0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1e98);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb09e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbab0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x9edc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb09e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x98b1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1eba);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb11e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xdcb1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1e98);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb19e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbab1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x9edc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb19e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x11b0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1e22);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb01e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x33b0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1e11);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb09e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x22b0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x9e33);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb09e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x11b1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1e22);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb11e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x33b1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1e11);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb19e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x22b1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x9e33);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb19e);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb85e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2f71);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb860);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x20d9);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb862);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2109);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb864);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x34e7);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb878);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x000f);
+
+
+        ClearEthPhyOcpBit(tp, 0xB820, BIT_7);
+
+
+        rtl8125_release_phy_mcu_patch_key_lock(tp);
+}
+
+static void
+rtl8125_set_phy_mcu_8125a_1(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        rtl8125_set_phy_mcu_patch_request(tp);
+
+        rtl8125_real_set_phy_mcu_8125a_1(dev);
+
+        rtl8125_clear_phy_mcu_patch_request(tp);
+}
+
+static void
+rtl8125_real_set_phy_mcu_8125a_2(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        rtl8125_acquire_phy_mcu_patch_key_lock(tp);
+
+
+        SetEthPhyOcpBit(tp, 0xB820, BIT_7);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA016);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA012);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA014);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x808b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x808f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8093);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8097);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x809d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x80a1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x80aa);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd718);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x607b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x40da);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf00e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x42da);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf01e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd718);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x615b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1456);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x14a4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x14bc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd718);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5f2e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf01c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1456);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x14a4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x14bc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd718);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5f2e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf024);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1456);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x14a4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x14bc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd718);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5f2e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf02c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1456);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x14a4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x14bc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd718);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5f2e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf034);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd719);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4118);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xac11);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa410);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4779);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xac0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xae01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1444);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf034);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd719);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4118);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xac22);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa420);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4559);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xac0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xae01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1444);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf023);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd719);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4118);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xac44);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa440);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4339);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xac0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xae01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1444);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf012);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd719);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4118);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xac88);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa480);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xce00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4119);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xac0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xae01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1444);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf001);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1456);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd718);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5fac);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xc48f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x141b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd504);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x121a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd0b4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd1bb);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0898);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd0b4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd1bb);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a0e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd064);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd18a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0b7e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x401c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd501);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa804);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8804);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x053b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd500);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa301);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0648);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xc520);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa201);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x252d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1646);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd708);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4006);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1646);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0308);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA026);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0307);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA024);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1645);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA022);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0647);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA020);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x053a);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA006);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0b7c);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA004);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0a0c);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0896);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x11a1);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA008);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xff00);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA016);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0010);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA012);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA014);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8015);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x801a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x801a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x801a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x801a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x801a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x801a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xad02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x02d7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00ed);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0509);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xc100);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x008f);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA08E);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA08C);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA08A);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA088);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA086);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA084);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA082);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x008d);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA080);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00eb);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA090);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0103);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA016);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0020);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA012);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA014);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8014);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8018);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8024);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8051);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8055);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8072);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x80dc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfffd);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfffd);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8301);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x800a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8190);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x82a0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa70c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x9402);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x890c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8840);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa380);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x066e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xcb91);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4063);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd139);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd140);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd040);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07e0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa610);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa110);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa2a0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4085);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa180);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8280);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x405d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa720);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0743);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07f0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5f74);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0743);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd702);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7fb6);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8190);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x82a0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8610);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0c0f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07e0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x066e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd158);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd04d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x03d4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x94bc);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x870c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8380);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd10d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd040);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07c4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5fb4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa190);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa00a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa280);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa404);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa220);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd130);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd040);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07c4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5fb4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xbb80);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd1c4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd074);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa301);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x604b);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa90c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0556);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xcb92);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4063);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd116);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd119);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd040);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd703);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x60a0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6241);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x63e2);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6583);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf054);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x611e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x40da);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d10);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf02f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d50);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf02a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x611e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x40da);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d20);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf021);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d60);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf01c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x611e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x40da);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d30);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf013);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d70);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf00e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x611e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x40da);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d40);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf005);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d80);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07e8);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa610);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x405d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa720);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd700);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x5ff4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa008);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd704);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x4046);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0743);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07fb);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd703);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7f6f);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7f4e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7f2d);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7f0c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x800a);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0cf0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0d00);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07e8);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8010);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa740);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0743);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd702);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7fb5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd701);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x3ad4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0556);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8610);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x066e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd1f5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xd049);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x1800);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x01ec);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA10E);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x01ea);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA10C);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x06a9);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA10A);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x078a);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA108);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x03d2);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA106);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x067f);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA104);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0665);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA102);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA100);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xA110);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00fc);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb87c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8530);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb87e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaf85);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x3caf);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8545);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaf85);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x45af);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8545);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xee82);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf900);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0103);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xaf03);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb7f8);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xe0a6);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00e1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa601);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xef01);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x58f0);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa080);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x37a1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8402);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xae16);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa185);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x02ae);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x11a1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8702);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xae0c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xa188);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x02ae);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x07a1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8902);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xae02);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xae1c);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xe0b4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x62e1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb463);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6901);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xe4b4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x62e5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb463);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xe0b4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x62e1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb463);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6901);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xe4b4);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x62e5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xb463);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xfc04);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb85e);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x03b3);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb860);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb862);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb864);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xffff);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0xb878);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0001);
+
+
+        ClearEthPhyOcpBit(tp, 0xB820, BIT_7);
+
+
+        rtl8125_release_phy_mcu_patch_key_lock(tp);
+}
+
+static void
+rtl8125_set_phy_mcu_8125a_2(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        rtl8125_set_phy_mcu_patch_request(tp);
+
+        rtl8125_real_set_phy_mcu_8125a_2(dev);
+
+        rtl8125_clear_phy_mcu_patch_request(tp);
+}
+
+static const u16 phy_mcu_ram_code_8125b_1[] = {
+        0xa436, 0x8024, 0xa438, 0x3700, 0xa436, 0xB82E, 0xa438, 0x0001,
+        0xb820, 0x0090, 0xa436, 0xA016, 0xa438, 0x0000, 0xa436, 0xA012,
+        0xa438, 0x0000, 0xa436, 0xA014, 0xa438, 0x1800, 0xa438, 0x8010,
+        0xa438, 0x1800, 0xa438, 0x8025, 0xa438, 0x1800, 0xa438, 0x803a,
+        0xa438, 0x1800, 0xa438, 0x8044, 0xa438, 0x1800, 0xa438, 0x8083,
+        0xa438, 0x1800, 0xa438, 0x808d, 0xa438, 0x1800, 0xa438, 0x808d,
+        0xa438, 0x1800, 0xa438, 0x808d, 0xa438, 0xd712, 0xa438, 0x4077,
+        0xa438, 0xd71e, 0xa438, 0x4159, 0xa438, 0xd71e, 0xa438, 0x6099,
+        0xa438, 0x7f44, 0xa438, 0x1800, 0xa438, 0x1a14, 0xa438, 0x9040,
+        0xa438, 0x9201, 0xa438, 0x1800, 0xa438, 0x1b1a, 0xa438, 0xd71e,
+        0xa438, 0x2425, 0xa438, 0x1a14, 0xa438, 0xd71f, 0xa438, 0x3ce5,
+        0xa438, 0x1afb, 0xa438, 0x1800, 0xa438, 0x1b00, 0xa438, 0xd712,
+        0xa438, 0x4077, 0xa438, 0xd71e, 0xa438, 0x4159, 0xa438, 0xd71e,
+        0xa438, 0x60b9, 0xa438, 0x2421, 0xa438, 0x1c17, 0xa438, 0x1800,
+        0xa438, 0x1a14, 0xa438, 0x9040, 0xa438, 0x1800, 0xa438, 0x1c2c,
+        0xa438, 0xd71e, 0xa438, 0x2425, 0xa438, 0x1a14, 0xa438, 0xd71f,
+        0xa438, 0x3ce5, 0xa438, 0x1c0f, 0xa438, 0x1800, 0xa438, 0x1c13,
+        0xa438, 0xd702, 0xa438, 0xd501, 0xa438, 0x6072, 0xa438, 0x8401,
+        0xa438, 0xf002, 0xa438, 0xa401, 0xa438, 0x1000, 0xa438, 0x146e,
+        0xa438, 0x1800, 0xa438, 0x0b77, 0xa438, 0xd703, 0xa438, 0x665d,
+        0xa438, 0x653e, 0xa438, 0x641f, 0xa438, 0xd700, 0xa438, 0x62c4,
+        0xa438, 0x6185, 0xa438, 0x6066, 0xa438, 0x1800, 0xa438, 0x165a,
+        0xa438, 0xc101, 0xa438, 0xcb00, 0xa438, 0x1000, 0xa438, 0x1945,
+        0xa438, 0xd700, 0xa438, 0x7fa6, 0xa438, 0x1800, 0xa438, 0x807d,
+        0xa438, 0xc102, 0xa438, 0xcb00, 0xa438, 0x1000, 0xa438, 0x1945,
+        0xa438, 0xd700, 0xa438, 0x2569, 0xa438, 0x8058, 0xa438, 0x1800,
+        0xa438, 0x807d, 0xa438, 0xc104, 0xa438, 0xcb00, 0xa438, 0x1000,
+        0xa438, 0x1945, 0xa438, 0xd700, 0xa438, 0x7fa4, 0xa438, 0x1800,
+        0xa438, 0x807d, 0xa438, 0xc120, 0xa438, 0xcb00, 0xa438, 0x1000,
+        0xa438, 0x1945, 0xa438, 0xd703, 0xa438, 0x7fbf, 0xa438, 0x1800,
+        0xa438, 0x807d, 0xa438, 0xc140, 0xa438, 0xcb00, 0xa438, 0x1000,
+        0xa438, 0x1945, 0xa438, 0xd703, 0xa438, 0x7fbe, 0xa438, 0x1800,
+        0xa438, 0x807d, 0xa438, 0xc180, 0xa438, 0xcb00, 0xa438, 0x1000,
+        0xa438, 0x1945, 0xa438, 0xd703, 0xa438, 0x7fbd, 0xa438, 0xc100,
+        0xa438, 0xcb00, 0xa438, 0xd708, 0xa438, 0x6018, 0xa438, 0x1800,
+        0xa438, 0x165a, 0xa438, 0x1000, 0xa438, 0x14f6, 0xa438, 0xd014,
+        0xa438, 0xd1e3, 0xa438, 0x1000, 0xa438, 0x1356, 0xa438, 0xd705,
+        0xa438, 0x5fbe, 0xa438, 0x1800, 0xa438, 0x1559, 0xa436, 0xA026,
+        0xa438, 0xffff, 0xa436, 0xA024, 0xa438, 0xffff, 0xa436, 0xA022,
+        0xa438, 0xffff, 0xa436, 0xA020, 0xa438, 0x1557, 0xa436, 0xA006,
+        0xa438, 0x1677, 0xa436, 0xA004, 0xa438, 0x0b75, 0xa436, 0xA002,
+        0xa438, 0x1c17, 0xa436, 0xA000, 0xa438, 0x1b04, 0xa436, 0xA008,
+        0xa438, 0x1f00, 0xa436, 0xA016, 0xa438, 0x0020, 0xa436, 0xA012,
+        0xa438, 0x0000, 0xa436, 0xA014, 0xa438, 0x1800, 0xa438, 0x8010,
+        0xa438, 0x1800, 0xa438, 0x817f, 0xa438, 0x1800, 0xa438, 0x82ab,
+        0xa438, 0x1800, 0xa438, 0x83f8, 0xa438, 0x1800, 0xa438, 0x8444,
+        0xa438, 0x1800, 0xa438, 0x8454, 0xa438, 0x1800, 0xa438, 0x8459,
+        0xa438, 0x1800, 0xa438, 0x8465, 0xa438, 0xcb11, 0xa438, 0xa50c,
+        0xa438, 0x8310, 0xa438, 0xd701, 0xa438, 0x4076, 0xa438, 0x0c03,
+        0xa438, 0x0903, 0xa438, 0xd700, 0xa438, 0x6083, 0xa438, 0x0c1f,
+        0xa438, 0x0d00, 0xa438, 0xf003, 0xa438, 0x0c1f, 0xa438, 0x0d00,
+        0xa438, 0x1000, 0xa438, 0x0a7d, 0xa438, 0x1000, 0xa438, 0x0a4d,
+        0xa438, 0xcb12, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x5f84, 0xa438, 0xd102, 0xa438, 0xd040, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fb4, 0xa438, 0xd701,
+        0xa438, 0x60f3, 0xa438, 0xd413, 0xa438, 0x1000, 0xa438, 0x0a37,
+        0xa438, 0xd410, 0xa438, 0x1000, 0xa438, 0x0a37, 0xa438, 0xcb13,
+        0xa438, 0xa108, 0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8108,
+        0xa438, 0xa00a, 0xa438, 0xa910, 0xa438, 0xa780, 0xa438, 0xd14a,
+        0xa438, 0xd048, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd701,
+        0xa438, 0x6255, 0xa438, 0xd700, 0xa438, 0x5f74, 0xa438, 0x6326,
+        0xa438, 0xd702, 0xa438, 0x5f07, 0xa438, 0x800a, 0xa438, 0xa004,
+        0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8004, 0xa438, 0xa001,
+        0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8001, 0xa438, 0x0c03,
+        0xa438, 0x0902, 0xa438, 0xffe2, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd71f, 0xa438, 0x5fab, 0xa438, 0xba08, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x7f8b, 0xa438, 0x9a08,
+        0xa438, 0x800a, 0xa438, 0xd702, 0xa438, 0x6535, 0xa438, 0xd40d,
+        0xa438, 0x1000, 0xa438, 0x0a37, 0xa438, 0xcb14, 0xa438, 0xa004,
+        0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8004, 0xa438, 0xa001,
+        0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8001, 0xa438, 0xa00a,
+        0xa438, 0xa780, 0xa438, 0xd14a, 0xa438, 0xd048, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fb4, 0xa438, 0x6206,
+        0xa438, 0xd702, 0xa438, 0x5f47, 0xa438, 0x800a, 0xa438, 0xa004,
+        0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8004, 0xa438, 0xa001,
+        0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8001, 0xa438, 0x0c03,
+        0xa438, 0x0902, 0xa438, 0x1800, 0xa438, 0x8064, 0xa438, 0x800a,
+        0xa438, 0xd40e, 0xa438, 0x1000, 0xa438, 0x0a37, 0xa438, 0xb920,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5fac,
+        0xa438, 0x9920, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x7f8c, 0xa438, 0xd701, 0xa438, 0x6073, 0xa438, 0xd701,
+        0xa438, 0x4216, 0xa438, 0xa004, 0xa438, 0x1000, 0xa438, 0x0a42,
+        0xa438, 0x8004, 0xa438, 0xa001, 0xa438, 0x1000, 0xa438, 0x0a42,
+        0xa438, 0x8001, 0xa438, 0xd120, 0xa438, 0xd040, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fb4, 0xa438, 0x8504,
+        0xa438, 0xcb21, 0xa438, 0xa301, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd700, 0xa438, 0x5f9f, 0xa438, 0x8301, 0xa438, 0xd704,
+        0xa438, 0x40e0, 0xa438, 0xd196, 0xa438, 0xd04d, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fb4, 0xa438, 0xcb22,
+        0xa438, 0x1000, 0xa438, 0x0a6d, 0xa438, 0x0c03, 0xa438, 0x1502,
+        0xa438, 0xa640, 0xa438, 0x9503, 0xa438, 0x8910, 0xa438, 0x8720,
+        0xa438, 0xd700, 0xa438, 0x6083, 0xa438, 0x0c1f, 0xa438, 0x0d01,
+        0xa438, 0xf003, 0xa438, 0x0c1f, 0xa438, 0x0d01, 0xa438, 0x1000,
+        0xa438, 0x0a7d, 0xa438, 0x0c1f, 0xa438, 0x0f14, 0xa438, 0xcb23,
+        0xa438, 0x8fc0, 0xa438, 0x1000, 0xa438, 0x0a25, 0xa438, 0xaf40,
+        0xa438, 0x1000, 0xa438, 0x0a25, 0xa438, 0x0cc0, 0xa438, 0x0f80,
+        0xa438, 0x1000, 0xa438, 0x0a25, 0xa438, 0xafc0, 0xa438, 0x1000,
+        0xa438, 0x0a25, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd701,
+        0xa438, 0x5dee, 0xa438, 0xcb24, 0xa438, 0x8f1f, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd701, 0xa438, 0x7f6e, 0xa438, 0xa111,
+        0xa438, 0xa215, 0xa438, 0xa401, 0xa438, 0x8404, 0xa438, 0xa720,
+        0xa438, 0xcb25, 0xa438, 0x0c03, 0xa438, 0x1502, 0xa438, 0x8640,
+        0xa438, 0x9503, 0xa438, 0x1000, 0xa438, 0x0b43, 0xa438, 0x1000,
+        0xa438, 0x0b86, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xb920,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5fac,
+        0xa438, 0x9920, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x7f8c, 0xa438, 0xcb26, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd71f, 0xa438, 0x5f82, 0xa438, 0x8111, 0xa438, 0x8205,
+        0xa438, 0x8404, 0xa438, 0xcb27, 0xa438, 0xd404, 0xa438, 0x1000,
+        0xa438, 0x0a37, 0xa438, 0xd700, 0xa438, 0x6083, 0xa438, 0x0c1f,
+        0xa438, 0x0d02, 0xa438, 0xf003, 0xa438, 0x0c1f, 0xa438, 0x0d02,
+        0xa438, 0x1000, 0xa438, 0x0a7d, 0xa438, 0xa710, 0xa438, 0xa104,
+        0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8104, 0xa438, 0xa001,
+        0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8001, 0xa438, 0xa120,
+        0xa438, 0xaa0f, 0xa438, 0x8110, 0xa438, 0xa284, 0xa438, 0xa404,
+        0xa438, 0xa00a, 0xa438, 0xd193, 0xa438, 0xd046, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fb4, 0xa438, 0xcb28,
+        0xa438, 0xa110, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700,
+        0xa438, 0x5fa8, 0xa438, 0x8110, 0xa438, 0x8284, 0xa438, 0xa404,
+        0xa438, 0x800a, 0xa438, 0x8710, 0xa438, 0xb804, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x7f82, 0xa438, 0x9804,
+        0xa438, 0xcb29, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x5f85, 0xa438, 0xa710, 0xa438, 0xb820, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x7f65, 0xa438, 0x9820,
+        0xa438, 0xcb2a, 0xa438, 0xa190, 0xa438, 0xa284, 0xa438, 0xa404,
+        0xa438, 0xa00a, 0xa438, 0xd13d, 0xa438, 0xd04a, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x3444, 0xa438, 0x8149,
+        0xa438, 0xa220, 0xa438, 0xd1a0, 0xa438, 0xd040, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x3444, 0xa438, 0x8151,
+        0xa438, 0xd702, 0xa438, 0x5f51, 0xa438, 0xcb2f, 0xa438, 0xa302,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd708, 0xa438, 0x5f63,
+        0xa438, 0xd411, 0xa438, 0x1000, 0xa438, 0x0a37, 0xa438, 0x8302,
+        0xa438, 0xd409, 0xa438, 0x1000, 0xa438, 0x0a37, 0xa438, 0xb920,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5fac,
+        0xa438, 0x9920, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x7f8c, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x5fa3, 0xa438, 0x8190, 0xa438, 0x82a4, 0xa438, 0x8404,
+        0xa438, 0x800a, 0xa438, 0xb808, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd71f, 0xa438, 0x7fa3, 0xa438, 0x9808, 0xa438, 0x1800,
+        0xa438, 0x0433, 0xa438, 0xcb15, 0xa438, 0xa508, 0xa438, 0xd700,
+        0xa438, 0x6083, 0xa438, 0x0c1f, 0xa438, 0x0d01, 0xa438, 0xf003,
+        0xa438, 0x0c1f, 0xa438, 0x0d01, 0xa438, 0x1000, 0xa438, 0x0a7d,
+        0xa438, 0x1000, 0xa438, 0x0a4d, 0xa438, 0xa301, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5f9f, 0xa438, 0x8301,
+        0xa438, 0xd704, 0xa438, 0x40e0, 0xa438, 0xd115, 0xa438, 0xd04f,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fb4,
+        0xa438, 0xd413, 0xa438, 0x1000, 0xa438, 0x0a37, 0xa438, 0xcb16,
+        0xa438, 0x1000, 0xa438, 0x0a6d, 0xa438, 0x0c03, 0xa438, 0x1502,
+        0xa438, 0xa640, 0xa438, 0x9503, 0xa438, 0x8720, 0xa438, 0xd17a,
+        0xa438, 0xd04c, 0xa438, 0x0c1f, 0xa438, 0x0f14, 0xa438, 0xcb17,
+        0xa438, 0x8fc0, 0xa438, 0x1000, 0xa438, 0x0a25, 0xa438, 0xaf40,
+        0xa438, 0x1000, 0xa438, 0x0a25, 0xa438, 0x0cc0, 0xa438, 0x0f80,
+        0xa438, 0x1000, 0xa438, 0x0a25, 0xa438, 0xafc0, 0xa438, 0x1000,
+        0xa438, 0x0a25, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd701,
+        0xa438, 0x61ce, 0xa438, 0xd700, 0xa438, 0x5db4, 0xa438, 0xcb18,
+        0xa438, 0x0c03, 0xa438, 0x1502, 0xa438, 0x8640, 0xa438, 0x9503,
+        0xa438, 0xa720, 0xa438, 0x1000, 0xa438, 0x0b43, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xffd6, 0xa438, 0x8f1f, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd701, 0xa438, 0x7f8e, 0xa438, 0xa131,
+        0xa438, 0xaa0f, 0xa438, 0xa2d5, 0xa438, 0xa407, 0xa438, 0xa720,
+        0xa438, 0x8310, 0xa438, 0xa308, 0xa438, 0x8308, 0xa438, 0xcb19,
+        0xa438, 0x0c03, 0xa438, 0x1502, 0xa438, 0x8640, 0xa438, 0x9503,
+        0xa438, 0x1000, 0xa438, 0x0b43, 0xa438, 0x1000, 0xa438, 0x0b86,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xb920, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5fac, 0xa438, 0x9920,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x7f8c,
+        0xa438, 0xcb1a, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x5f82, 0xa438, 0x8111, 0xa438, 0x82c5, 0xa438, 0xa404,
+        0xa438, 0x8402, 0xa438, 0xb804, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd71f, 0xa438, 0x7f82, 0xa438, 0x9804, 0xa438, 0xcb1b,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5f85,
+        0xa438, 0xa710, 0xa438, 0xb820, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd71f, 0xa438, 0x7f65, 0xa438, 0x9820, 0xa438, 0xcb1c,
+        0xa438, 0xd700, 0xa438, 0x6083, 0xa438, 0x0c1f, 0xa438, 0x0d02,
+        0xa438, 0xf003, 0xa438, 0x0c1f, 0xa438, 0x0d02, 0xa438, 0x1000,
+        0xa438, 0x0a7d, 0xa438, 0xa110, 0xa438, 0xa284, 0xa438, 0xa404,
+        0xa438, 0x8402, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700,
+        0xa438, 0x5fa8, 0xa438, 0xcb1d, 0xa438, 0xa180, 0xa438, 0xa402,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fa8,
+        0xa438, 0xa220, 0xa438, 0xd1f5, 0xa438, 0xd049, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x3444, 0xa438, 0x8221,
+        0xa438, 0xd702, 0xa438, 0x5f51, 0xa438, 0xb920, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5fac, 0xa438, 0x9920,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x7f8c,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5fa3,
+        0xa438, 0xa504, 0xa438, 0xd700, 0xa438, 0x6083, 0xa438, 0x0c1f,
+        0xa438, 0x0d00, 0xa438, 0xf003, 0xa438, 0x0c1f, 0xa438, 0x0d00,
+        0xa438, 0x1000, 0xa438, 0x0a7d, 0xa438, 0xa00a, 0xa438, 0x8190,
+        0xa438, 0x82a4, 0xa438, 0x8402, 0xa438, 0xa404, 0xa438, 0xb808,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x7fa3,
+        0xa438, 0x9808, 0xa438, 0xcb2b, 0xa438, 0xcb2c, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5f84, 0xa438, 0xd14a,
+        0xa438, 0xd048, 0xa438, 0xa780, 0xa438, 0xcb2d, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5f94, 0xa438, 0x6208,
+        0xa438, 0xd702, 0xa438, 0x5f27, 0xa438, 0x800a, 0xa438, 0xa004,
+        0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8004, 0xa438, 0xa001,
+        0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8001, 0xa438, 0x0c03,
+        0xa438, 0x0902, 0xa438, 0xa00a, 0xa438, 0xffe9, 0xa438, 0xcb2e,
+        0xa438, 0xd700, 0xa438, 0x6083, 0xa438, 0x0c1f, 0xa438, 0x0d02,
+        0xa438, 0xf003, 0xa438, 0x0c1f, 0xa438, 0x0d02, 0xa438, 0x1000,
+        0xa438, 0x0a7d, 0xa438, 0xa190, 0xa438, 0xa284, 0xa438, 0xa406,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fa8,
+        0xa438, 0xa220, 0xa438, 0xd1a0, 0xa438, 0xd040, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x3444, 0xa438, 0x827d,
+        0xa438, 0xd702, 0xa438, 0x5f51, 0xa438, 0xcb2f, 0xa438, 0xa302,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd708, 0xa438, 0x5f63,
+        0xa438, 0xd411, 0xa438, 0x1000, 0xa438, 0x0a37, 0xa438, 0x8302,
+        0xa438, 0xd409, 0xa438, 0x1000, 0xa438, 0x0a37, 0xa438, 0xb920,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5fac,
+        0xa438, 0x9920, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x7f8c, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x5fa3, 0xa438, 0x8190, 0xa438, 0x82a4, 0xa438, 0x8406,
+        0xa438, 0x800a, 0xa438, 0xb808, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd71f, 0xa438, 0x7fa3, 0xa438, 0x9808, 0xa438, 0x1800,
+        0xa438, 0x0433, 0xa438, 0xcb30, 0xa438, 0x8380, 0xa438, 0xcb31,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5f86,
+        0xa438, 0x9308, 0xa438, 0xb204, 0xa438, 0xb301, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd701, 0xa438, 0x5fa2, 0xa438, 0xb302,
+        0xa438, 0x9204, 0xa438, 0xcb32, 0xa438, 0xd408, 0xa438, 0x1000,
+        0xa438, 0x0a37, 0xa438, 0xd141, 0xa438, 0xd043, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fb4, 0xa438, 0xd704,
+        0xa438, 0x4ccc, 0xa438, 0xd700, 0xa438, 0x4c81, 0xa438, 0xd702,
+        0xa438, 0x609e, 0xa438, 0xd1e5, 0xa438, 0xd04d, 0xa438, 0xf003,
+        0xa438, 0xd1e5, 0xa438, 0xd04d, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd700, 0xa438, 0x5fb4, 0xa438, 0xd700, 0xa438, 0x6083,
+        0xa438, 0x0c1f, 0xa438, 0x0d01, 0xa438, 0xf003, 0xa438, 0x0c1f,
+        0xa438, 0x0d01, 0xa438, 0x1000, 0xa438, 0x0a7d, 0xa438, 0x8710,
+        0xa438, 0xa108, 0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8108,
+        0xa438, 0xa203, 0xa438, 0x8120, 0xa438, 0x8a0f, 0xa438, 0xa111,
+        0xa438, 0x8204, 0xa438, 0xa140, 0xa438, 0x1000, 0xa438, 0x0a42,
+        0xa438, 0x8140, 0xa438, 0xd17a, 0xa438, 0xd04b, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fb4, 0xa438, 0xa204,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fa7,
+        0xa438, 0xb920, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x5fac, 0xa438, 0x9920, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd71f, 0xa438, 0x7f8c, 0xa438, 0xd404, 0xa438, 0x1000,
+        0xa438, 0x0a37, 0xa438, 0xd700, 0xa438, 0x6083, 0xa438, 0x0c1f,
+        0xa438, 0x0d02, 0xa438, 0xf003, 0xa438, 0x0c1f, 0xa438, 0x0d02,
+        0xa438, 0x1000, 0xa438, 0x0a7d, 0xa438, 0xa710, 0xa438, 0x8101,
+        0xa438, 0x8201, 0xa438, 0xa104, 0xa438, 0x1000, 0xa438, 0x0a42,
+        0xa438, 0x8104, 0xa438, 0xa120, 0xa438, 0xaa0f, 0xa438, 0x8110,
+        0xa438, 0xa284, 0xa438, 0xa404, 0xa438, 0xa00a, 0xa438, 0xd193,
+        0xa438, 0xd047, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700,
+        0xa438, 0x5fb4, 0xa438, 0xa110, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd700, 0xa438, 0x5fa8, 0xa438, 0xa180, 0xa438, 0xd13d,
+        0xa438, 0xd04a, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700,
+        0xa438, 0x5fb4, 0xa438, 0xf024, 0xa438, 0xa710, 0xa438, 0xa00a,
+        0xa438, 0x8190, 0xa438, 0x8204, 0xa438, 0xa280, 0xa438, 0xa404,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fa7,
+        0xa438, 0x8710, 0xa438, 0xb920, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd71f, 0xa438, 0x5fac, 0xa438, 0x9920, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x7f8c, 0xa438, 0x800a,
+        0xa438, 0x8190, 0xa438, 0x8284, 0xa438, 0x8406, 0xa438, 0xd700,
+        0xa438, 0x4121, 0xa438, 0xd701, 0xa438, 0x60f3, 0xa438, 0xd1e5,
+        0xa438, 0xd04d, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700,
+        0xa438, 0x5fb4, 0xa438, 0x8710, 0xa438, 0xa00a, 0xa438, 0x8190,
+        0xa438, 0x8204, 0xa438, 0xa280, 0xa438, 0xa404, 0xa438, 0xb920,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x5fac,
+        0xa438, 0x9920, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f,
+        0xa438, 0x7f8c, 0xa438, 0xcb33, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd71f, 0xa438, 0x5f85, 0xa438, 0xa710, 0xa438, 0xb820,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd71f, 0xa438, 0x7f65,
+        0xa438, 0x9820, 0xa438, 0xcb34, 0xa438, 0xa00a, 0xa438, 0xa190,
+        0xa438, 0xa284, 0xa438, 0xa404, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd700, 0xa438, 0x5fa9, 0xa438, 0xd701, 0xa438, 0x6853,
+        0xa438, 0xd700, 0xa438, 0x6083, 0xa438, 0x0c1f, 0xa438, 0x0d00,
+        0xa438, 0xf003, 0xa438, 0x0c1f, 0xa438, 0x0d00, 0xa438, 0x1000,
+        0xa438, 0x0a7d, 0xa438, 0x8190, 0xa438, 0x8284, 0xa438, 0xcb35,
+        0xa438, 0xd407, 0xa438, 0x1000, 0xa438, 0x0a37, 0xa438, 0x8110,
+        0xa438, 0x8204, 0xa438, 0xa280, 0xa438, 0xa00a, 0xa438, 0xd704,
+        0xa438, 0x4215, 0xa438, 0xa304, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd700, 0xa438, 0x5fb8, 0xa438, 0xd1c3, 0xa438, 0xd043,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fb4,
+        0xa438, 0x8304, 0xa438, 0xd700, 0xa438, 0x4109, 0xa438, 0xf01e,
+        0xa438, 0xcb36, 0xa438, 0xd412, 0xa438, 0x1000, 0xa438, 0x0a37,
+        0xa438, 0xd700, 0xa438, 0x6309, 0xa438, 0xd702, 0xa438, 0x42c7,
+        0xa438, 0x800a, 0xa438, 0x8180, 0xa438, 0x8280, 0xa438, 0x8404,
+        0xa438, 0xa004, 0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8004,
+        0xa438, 0xa001, 0xa438, 0x1000, 0xa438, 0x0a42, 0xa438, 0x8001,
+        0xa438, 0x0c03, 0xa438, 0x0902, 0xa438, 0xa00a, 0xa438, 0xd14a,
+        0xa438, 0xd048, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700,
+        0xa438, 0x5fb4, 0xa438, 0xd700, 0xa438, 0x6083, 0xa438, 0x0c1f,
+        0xa438, 0x0d02, 0xa438, 0xf003, 0xa438, 0x0c1f, 0xa438, 0x0d02,
+        0xa438, 0x1000, 0xa438, 0x0a7d, 0xa438, 0xcc55, 0xa438, 0xcb37,
+        0xa438, 0xa00a, 0xa438, 0xa190, 0xa438, 0xa2a4, 0xa438, 0xa404,
+        0xa438, 0xd700, 0xa438, 0x6041, 0xa438, 0xa402, 0xa438, 0xd13d,
+        0xa438, 0xd04a, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700,
+        0xa438, 0x5fb4, 0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700,
+        0xa438, 0x5fa9, 0xa438, 0xd702, 0xa438, 0x5f71, 0xa438, 0xcb38,
+        0xa438, 0x8224, 0xa438, 0xa288, 0xa438, 0x8180, 0xa438, 0xa110,
+        0xa438, 0xa404, 0xa438, 0x800a, 0xa438, 0xd700, 0xa438, 0x6041,
+        0xa438, 0x8402, 0xa438, 0xd415, 0xa438, 0x1000, 0xa438, 0x0a37,
+        0xa438, 0xd13d, 0xa438, 0xd04a, 0xa438, 0x1000, 0xa438, 0x0a5e,
+        0xa438, 0xd700, 0xa438, 0x5fb4, 0xa438, 0xcb39, 0xa438, 0xa00a,
+        0xa438, 0xa190, 0xa438, 0xa2a0, 0xa438, 0xa404, 0xa438, 0xd700,
+        0xa438, 0x6041, 0xa438, 0xa402, 0xa438, 0xd17a, 0xa438, 0xd047,
+        0xa438, 0x1000, 0xa438, 0x0a5e, 0xa438, 0xd700, 0xa438, 0x5fb4,
+        0xa438, 0x1800, 0xa438, 0x0560, 0xa438, 0xa111, 0xa438, 0x0000,
+        0xa438, 0x0000, 0xa438, 0x0000, 0xa438, 0x0000, 0xa438, 0xd3f5,
+        0xa438, 0xd219, 0xa438, 0x1000, 0xa438, 0x0c31, 0xa438, 0xd708,
+        0xa438, 0x5fa5, 0xa438, 0xa215, 0xa438, 0xd30e, 0xa438, 0xd21a,
+        0xa438, 0x1000, 0xa438, 0x0c31, 0xa438, 0xd708, 0xa438, 0x63e9,
+        0xa438, 0xd708, 0xa438, 0x5f65, 0xa438, 0xd708, 0xa438, 0x7f36,
+        0xa438, 0xa004, 0xa438, 0x1000, 0xa438, 0x0c35, 0xa438, 0x8004,
+        0xa438, 0xa001, 0xa438, 0x1000, 0xa438, 0x0c35, 0xa438, 0x8001,
+        0xa438, 0xd708, 0xa438, 0x4098, 0xa438, 0xd102, 0xa438, 0x9401,
+        0xa438, 0xf003, 0xa438, 0xd103, 0xa438, 0xb401, 0xa438, 0x1000,
+        0xa438, 0x0c27, 0xa438, 0xa108, 0xa438, 0x1000, 0xa438, 0x0c35,
+        0xa438, 0x8108, 0xa438, 0x8110, 0xa438, 0x8294, 0xa438, 0xa202,
+        0xa438, 0x1800, 0xa438, 0x0bdb, 0xa438, 0xd39c, 0xa438, 0xd210,
+        0xa438, 0x1000, 0xa438, 0x0c31, 0xa438, 0xd708, 0xa438, 0x5fa5,
+        0xa438, 0xd39c, 0xa438, 0xd210, 0xa438, 0x1000, 0xa438, 0x0c31,
+        0xa438, 0xd708, 0xa438, 0x5fa5, 0xa438, 0x1000, 0xa438, 0x0c31,
+        0xa438, 0xd708, 0xa438, 0x29b5, 0xa438, 0x840e, 0xa438, 0xd708,
+        0xa438, 0x5f4a, 0xa438, 0x0c1f, 0xa438, 0x1014, 0xa438, 0x1000,
+        0xa438, 0x0c31, 0xa438, 0xd709, 0xa438, 0x7fa4, 0xa438, 0x901f,
+        0xa438, 0x1800, 0xa438, 0x0c23, 0xa438, 0xcb43, 0xa438, 0xa508,
+        0xa438, 0xd701, 0xa438, 0x3699, 0xa438, 0x844a, 0xa438, 0xa504,
+        0xa438, 0xa190, 0xa438, 0xa2a0, 0xa438, 0xa404, 0xa438, 0xa00a,
+        0xa438, 0xd700, 0xa438, 0x2109, 0xa438, 0x05ea, 0xa438, 0xa402,
+        0xa438, 0x1800, 0xa438, 0x05ea, 0xa438, 0xcb90, 0xa438, 0x0cf0,
+        0xa438, 0x0ca0, 0xa438, 0x1800, 0xa438, 0x06db, 0xa438, 0xd1ff,
+        0xa438, 0xd052, 0xa438, 0xa508, 0xa438, 0x8718, 0xa438, 0xa00a,
+        0xa438, 0xa190, 0xa438, 0xa2a0, 0xa438, 0xa404, 0xa438, 0x0cf0,
+        0xa438, 0x0c50, 0xa438, 0x1800, 0xa438, 0x09ef, 0xa438, 0x1000,
+        0xa438, 0x0a5e, 0xa438, 0xd704, 0xa438, 0x2e70, 0xa438, 0x06da,
+        0xa438, 0xd700, 0xa438, 0x5f55, 0xa438, 0xa90c, 0xa438, 0x1800,
+        0xa438, 0x0645, 0xa436, 0xA10E, 0xa438, 0x0644, 0xa436, 0xA10C,
+        0xa438, 0x09e9, 0xa436, 0xA10A, 0xa438, 0x06da, 0xa436, 0xA108,
+        0xa438, 0x05e1, 0xa436, 0xA106, 0xa438, 0x0be4, 0xa436, 0xA104,
+        0xa438, 0x0435, 0xa436, 0xA102, 0xa438, 0x0141, 0xa436, 0xA100,
+        0xa438, 0x026d, 0xa436, 0xA110, 0xa438, 0x00ff, 0xa436, 0xb87c,
+        0xa438, 0x85fe, 0xa436, 0xb87e, 0xa438, 0xaf86, 0xa438, 0x16af,
+        0xa438, 0x8699, 0xa438, 0xaf86, 0xa438, 0xe5af, 0xa438, 0x86f9,
+        0xa438, 0xaf87, 0xa438, 0x7aaf, 0xa438, 0x883a, 0xa438, 0xaf88,
+        0xa438, 0x58af, 0xa438, 0x8b6c, 0xa438, 0xd48b, 0xa438, 0x7c02,
+        0xa438, 0x8644, 0xa438, 0x2c00, 0xa438, 0x503c, 0xa438, 0xffd6,
+        0xa438, 0xac27, 0xa438, 0x18e1, 0xa438, 0x82fe, 0xa438, 0xad28,
+        0xa438, 0x0cd4, 0xa438, 0x8b84, 0xa438, 0x0286, 0xa438, 0x442c,
+        0xa438, 0x003c, 0xa438, 0xac27, 0xa438, 0x06ee, 0xa438, 0x8299,
+        0xa438, 0x01ae, 0xa438, 0x04ee, 0xa438, 0x8299, 0xa438, 0x00af,
+        0xa438, 0x23dc, 0xa438, 0xf9fa, 0xa438, 0xcefa, 0xa438, 0xfbef,
+        0xa438, 0x79fb, 0xa438, 0xc4bf, 0xa438, 0x8b76, 0xa438, 0x026c,
+        0xa438, 0x6dac, 0xa438, 0x2804, 0xa438, 0xd203, 0xa438, 0xae02,
+        0xa438, 0xd201, 0xa438, 0xbdd8, 0xa438, 0x19d9, 0xa438, 0xef94,
+        0xa438, 0x026c, 0xa438, 0x6d78, 0xa438, 0x03ef, 0xa438, 0x648a,
+        0xa438, 0x0002, 0xa438, 0xbdd8, 0xa438, 0x19d9, 0xa438, 0xef94,
+        0xa438, 0x026c, 0xa438, 0x6d78, 0xa438, 0x03ef, 0xa438, 0x7402,
+        0xa438, 0x72cd, 0xa438, 0xac50, 0xa438, 0x02ef, 0xa438, 0x643a,
+        0xa438, 0x019f, 0xa438, 0xe4ef, 0xa438, 0x4678, 0xa438, 0x03ac,
+        0xa438, 0x2002, 0xa438, 0xae02, 0xa438, 0xd0ff, 0xa438, 0xffef,
+        0xa438, 0x97ff, 0xa438, 0xfec6, 0xa438, 0xfefd, 0xa438, 0x041f,
+        0xa438, 0x771f, 0xa438, 0x221c, 0xa438, 0x450d, 0xa438, 0x481f,
+        0xa438, 0x00ac, 0xa438, 0x7f04, 0xa438, 0x1a94, 0xa438, 0xae08,
+        0xa438, 0x1a94, 0xa438, 0xac7f, 0xa438, 0x03d7, 0xa438, 0x0100,
+        0xa438, 0xef46, 0xa438, 0x0d48, 0xa438, 0x1f00, 0xa438, 0x1c45,
+        0xa438, 0xef69, 0xa438, 0xef57, 0xa438, 0xef74, 0xa438, 0x0272,
+        0xa438, 0xe8a7, 0xa438, 0xffff, 0xa438, 0x0d1a, 0xa438, 0x941b,
+        0xa438, 0x979e, 0xa438, 0x072d, 0xa438, 0x0100, 0xa438, 0x1a64,
+        0xa438, 0xef76, 0xa438, 0xef97, 0xa438, 0x0d98, 0xa438, 0xd400,
+        0xa438, 0xff1d, 0xa438, 0x941a, 0xa438, 0x89cf, 0xa438, 0x1a75,
+        0xa438, 0xaf74, 0xa438, 0xf9bf, 0xa438, 0x8b79, 0xa438, 0x026c,
+        0xa438, 0x6da1, 0xa438, 0x0005, 0xa438, 0xe180, 0xa438, 0xa0ae,
+        0xa438, 0x03e1, 0xa438, 0x80a1, 0xa438, 0xaf26, 0xa438, 0x9aac,
+        0xa438, 0x284d, 0xa438, 0xe08f, 0xa438, 0xffef, 0xa438, 0x10c0,
+        0xa438, 0xe08f, 0xa438, 0xfe10, 0xa438, 0x1b08, 0xa438, 0xa000,
+        0xa438, 0x04c8, 0xa438, 0xaf40, 0xa438, 0x67c8, 0xa438, 0xbf8b,
+        0xa438, 0x8c02, 0xa438, 0x6c4e, 0xa438, 0xc4bf, 0xa438, 0x8b8f,
+        0xa438, 0x026c, 0xa438, 0x6def, 0xa438, 0x74e0, 0xa438, 0x830c,
+        0xa438, 0xad20, 0xa438, 0x0302, 0xa438, 0x74ac, 0xa438, 0xccef,
+        0xa438, 0x971b, 0xa438, 0x76ad, 0xa438, 0x5f02, 0xa438, 0xae13,
+        0xa438, 0xef69, 0xa438, 0xef30, 0xa438, 0x1b32, 0xa438, 0xc4ef,
+        0xa438, 0x46e4, 0xa438, 0x8ffb, 0xa438, 0xe58f, 0xa438, 0xfce7,
+        0xa438, 0x8ffd, 0xa438, 0xcc10, 0xa438, 0x11ae, 0xa438, 0xb8d1,
+        0xa438, 0x00a1, 0xa438, 0x1f03, 0xa438, 0xaf40, 0xa438, 0x4fbf,
+        0xa438, 0x8b8c, 0xa438, 0x026c, 0xa438, 0x4ec4, 0xa438, 0xbf8b,
+        0xa438, 0x8f02, 0xa438, 0x6c6d, 0xa438, 0xef74, 0xa438, 0xe083,
+        0xa438, 0x0cad, 0xa438, 0x2003, 0xa438, 0x0274, 0xa438, 0xaccc,
+        0xa438, 0xef97, 0xa438, 0x1b76, 0xa438, 0xad5f, 0xa438, 0x02ae,
+        0xa438, 0x04ef, 0xa438, 0x69ef, 0xa438, 0x3111, 0xa438, 0xaed1,
+        0xa438, 0x0287, 0xa438, 0x80af, 0xa438, 0x2293, 0xa438, 0xf8f9,
+        0xa438, 0xfafb, 0xa438, 0xef59, 0xa438, 0xe080, 0xa438, 0x13ad,
+        0xa438, 0x252f, 0xa438, 0xbf88, 0xa438, 0x2802, 0xa438, 0x6c6d,
+        0xa438, 0xef64, 0xa438, 0x1f44, 0xa438, 0xe18f, 0xa438, 0xb91b,
+        0xa438, 0x64ad, 0xa438, 0x4f1d, 0xa438, 0xd688, 0xa438, 0x2bd7,
+        0xa438, 0x882e, 0xa438, 0x0274, 0xa438, 0x73ad, 0xa438, 0x5008,
+        0xa438, 0xbf88, 0xa438, 0x3102, 0xa438, 0x737c, 0xa438, 0xae03,
+        0xa438, 0x0287, 0xa438, 0xd0bf, 0xa438, 0x882b, 0xa438, 0x0273,
+        0xa438, 0x73e0, 0xa438, 0x824c, 0xa438, 0xf621, 0xa438, 0xe482,
+        0xa438, 0x4cbf, 0xa438, 0x8834, 0xa438, 0x0273, 0xa438, 0x7cef,
+        0xa438, 0x95ff, 0xa438, 0xfefd, 0xa438, 0xfc04, 0xa438, 0xf8f9,
+        0xa438, 0xfafb, 0xa438, 0xef79, 0xa438, 0xbf88, 0xa438, 0x1f02,
+        0xa438, 0x737c, 0xa438, 0x1f22, 0xa438, 0xac32, 0xa438, 0x31ef,
+        0xa438, 0x12bf, 0xa438, 0x8822, 0xa438, 0x026c, 0xa438, 0x4ed6,
+        0xa438, 0x8fba, 0xa438, 0x1f33, 0xa438, 0xac3c, 0xa438, 0x1eef,
+        0xa438, 0x13bf, 0xa438, 0x8837, 0xa438, 0x026c, 0xa438, 0x4eef,
+        0xa438, 0x96d8, 0xa438, 0x19d9, 0xa438, 0xbf88, 0xa438, 0x2502,
+        0xa438, 0x6c4e, 0xa438, 0xbf88, 0xa438, 0x2502, 0xa438, 0x6c4e,
+        0xa438, 0x1616, 0xa438, 0x13ae, 0xa438, 0xdf12, 0xa438, 0xaecc,
+        0xa438, 0xbf88, 0xa438, 0x1f02, 0xa438, 0x7373, 0xa438, 0xef97,
+        0xa438, 0xfffe, 0xa438, 0xfdfc, 0xa438, 0x0466, 0xa438, 0xac88,
+        0xa438, 0x54ac, 0xa438, 0x88f0, 0xa438, 0xac8a, 0xa438, 0x92ac,
+        0xa438, 0xbadd, 0xa438, 0xac6c, 0xa438, 0xeeac, 0xa438, 0x6cff,
+        0xa438, 0xad02, 0xa438, 0x99ac, 0xa438, 0x0030, 0xa438, 0xac88,
+        0xa438, 0xd4c3, 0xa438, 0x5000, 0xa438, 0x0000, 0xa438, 0x0000,
+        0xa438, 0x0000, 0xa438, 0x0000, 0xa438, 0x0000, 0xa438, 0x0000,
+        0xa438, 0x0000, 0xa438, 0x0000, 0xa438, 0x00b4, 0xa438, 0xecee,
+        0xa438, 0x8298, 0xa438, 0x00af, 0xa438, 0x1412, 0xa438, 0xf8bf,
+        0xa438, 0x8b5d, 0xa438, 0x026c, 0xa438, 0x6d58, 0xa438, 0x03e1,
+        0xa438, 0x8fb8, 0xa438, 0x2901, 0xa438, 0xe58f, 0xa438, 0xb8a0,
+        0xa438, 0x0049, 0xa438, 0xef47, 0xa438, 0xe483, 0xa438, 0x02e5,
+        0xa438, 0x8303, 0xa438, 0xbfc2, 0xa438, 0x5f1a, 0xa438, 0x95f7,
+        0xa438, 0x05ee, 0xa438, 0xffd2, 0xa438, 0x00d8, 0xa438, 0xf605,
+        0xa438, 0x1f11, 0xa438, 0xef60, 0xa438, 0xbf8b, 0xa438, 0x3002,
+        0xa438, 0x6c4e, 0xa438, 0xbf8b, 0xa438, 0x3302, 0xa438, 0x6c6d,
+        0xa438, 0xf728, 0xa438, 0xbf8b, 0xa438, 0x3302, 0xa438, 0x6c4e,
+        0xa438, 0xf628, 0xa438, 0xbf8b, 0xa438, 0x3302, 0xa438, 0x6c4e,
+        0xa438, 0x0c64, 0xa438, 0xef46, 0xa438, 0xbf8b, 0xa438, 0x6002,
+        0xa438, 0x6c4e, 0xa438, 0x0289, 0xa438, 0x9902, 0xa438, 0x3920,
+        0xa438, 0xaf89, 0xa438, 0x96a0, 0xa438, 0x0149, 0xa438, 0xef47,
+        0xa438, 0xe483, 0xa438, 0x04e5, 0xa438, 0x8305, 0xa438, 0xbfc2,
+        0xa438, 0x5f1a, 0xa438, 0x95f7, 0xa438, 0x05ee, 0xa438, 0xffd2,
+        0xa438, 0x00d8, 0xa438, 0xf605, 0xa438, 0x1f11, 0xa438, 0xef60,
+        0xa438, 0xbf8b, 0xa438, 0x3002, 0xa438, 0x6c4e, 0xa438, 0xbf8b,
+        0xa438, 0x3302, 0xa438, 0x6c6d, 0xa438, 0xf729, 0xa438, 0xbf8b,
+        0xa438, 0x3302, 0xa438, 0x6c4e, 0xa438, 0xf629, 0xa438, 0xbf8b,
+        0xa438, 0x3302, 0xa438, 0x6c4e, 0xa438, 0x0c64, 0xa438, 0xef46,
+        0xa438, 0xbf8b, 0xa438, 0x6302, 0xa438, 0x6c4e, 0xa438, 0x0289,
+        0xa438, 0x9902, 0xa438, 0x3920, 0xa438, 0xaf89, 0xa438, 0x96a0,
+        0xa438, 0x0249, 0xa438, 0xef47, 0xa438, 0xe483, 0xa438, 0x06e5,
+        0xa438, 0x8307, 0xa438, 0xbfc2, 0xa438, 0x5f1a, 0xa438, 0x95f7,
+        0xa438, 0x05ee, 0xa438, 0xffd2, 0xa438, 0x00d8, 0xa438, 0xf605,
+        0xa438, 0x1f11, 0xa438, 0xef60, 0xa438, 0xbf8b, 0xa438, 0x3002,
+        0xa438, 0x6c4e, 0xa438, 0xbf8b, 0xa438, 0x3302, 0xa438, 0x6c6d,
+        0xa438, 0xf72a, 0xa438, 0xbf8b, 0xa438, 0x3302, 0xa438, 0x6c4e,
+        0xa438, 0xf62a, 0xa438, 0xbf8b, 0xa438, 0x3302, 0xa438, 0x6c4e,
+        0xa438, 0x0c64, 0xa438, 0xef46, 0xa438, 0xbf8b, 0xa438, 0x6602,
+        0xa438, 0x6c4e, 0xa438, 0x0289, 0xa438, 0x9902, 0xa438, 0x3920,
+        0xa438, 0xaf89, 0xa438, 0x96ef, 0xa438, 0x47e4, 0xa438, 0x8308,
+        0xa438, 0xe583, 0xa438, 0x09bf, 0xa438, 0xc25f, 0xa438, 0x1a95,
+        0xa438, 0xf705, 0xa438, 0xeeff, 0xa438, 0xd200, 0xa438, 0xd8f6,
+        0xa438, 0x051f, 0xa438, 0x11ef, 0xa438, 0x60bf, 0xa438, 0x8b30,
+        0xa438, 0x026c, 0xa438, 0x4ebf, 0xa438, 0x8b33, 0xa438, 0x026c,
+        0xa438, 0x6df7, 0xa438, 0x2bbf, 0xa438, 0x8b33, 0xa438, 0x026c,
+        0xa438, 0x4ef6, 0xa438, 0x2bbf, 0xa438, 0x8b33, 0xa438, 0x026c,
+        0xa438, 0x4e0c, 0xa438, 0x64ef, 0xa438, 0x46bf, 0xa438, 0x8b69,
+        0xa438, 0x026c, 0xa438, 0x4e02, 0xa438, 0x8999, 0xa438, 0x0239,
+        0xa438, 0x20af, 0xa438, 0x8996, 0xa438, 0xaf39, 0xa438, 0x1ef8,
+        0xa438, 0xf9fa, 0xa438, 0xe08f, 0xa438, 0xb838, 0xa438, 0x02ad,
+        0xa438, 0x2702, 0xa438, 0xae03, 0xa438, 0xaf8b, 0xa438, 0x201f,
+        0xa438, 0x66ef, 0xa438, 0x65bf, 0xa438, 0xc21f, 0xa438, 0x1a96,
+        0xa438, 0xf705, 0xa438, 0xeeff, 0xa438, 0xd200, 0xa438, 0xdaf6,
+        0xa438, 0x05bf, 0xa438, 0xc22f, 0xa438, 0x1a96, 0xa438, 0xf705,
+        0xa438, 0xeeff, 0xa438, 0xd200, 0xa438, 0xdbf6, 0xa438, 0x05ef,
+        0xa438, 0x021f, 0xa438, 0x110d, 0xa438, 0x42bf, 0xa438, 0x8b3c,
+        0xa438, 0x026c, 0xa438, 0x4eef, 0xa438, 0x021b, 0xa438, 0x031f,
+        0xa438, 0x110d, 0xa438, 0x42bf, 0xa438, 0x8b36, 0xa438, 0x026c,
+        0xa438, 0x4eef, 0xa438, 0x021a, 0xa438, 0x031f, 0xa438, 0x110d,
+        0xa438, 0x42bf, 0xa438, 0x8b39, 0xa438, 0x026c, 0xa438, 0x4ebf,
+        0xa438, 0xc23f, 0xa438, 0x1a96, 0xa438, 0xf705, 0xa438, 0xeeff,
+        0xa438, 0xd200, 0xa438, 0xdaf6, 0xa438, 0x05bf, 0xa438, 0xc24f,
+        0xa438, 0x1a96, 0xa438, 0xf705, 0xa438, 0xeeff, 0xa438, 0xd200,
+        0xa438, 0xdbf6, 0xa438, 0x05ef, 0xa438, 0x021f, 0xa438, 0x110d,
+        0xa438, 0x42bf, 0xa438, 0x8b45, 0xa438, 0x026c, 0xa438, 0x4eef,
+        0xa438, 0x021b, 0xa438, 0x031f, 0xa438, 0x110d, 0xa438, 0x42bf,
+        0xa438, 0x8b3f, 0xa438, 0x026c, 0xa438, 0x4eef, 0xa438, 0x021a,
+        0xa438, 0x031f, 0xa438, 0x110d, 0xa438, 0x42bf, 0xa438, 0x8b42,
+        0xa438, 0x026c, 0xa438, 0x4eef, 0xa438, 0x56d0, 0xa438, 0x201f,
+        0xa438, 0x11bf, 0xa438, 0x8b4e, 0xa438, 0x026c, 0xa438, 0x4ebf,
+        0xa438, 0x8b48, 0xa438, 0x026c, 0xa438, 0x4ebf, 0xa438, 0x8b4b,
+        0xa438, 0x026c, 0xa438, 0x4ee1, 0xa438, 0x8578, 0xa438, 0xef03,
+        0xa438, 0x480a, 0xa438, 0x2805, 0xa438, 0xef20, 0xa438, 0x1b01,
+        0xa438, 0xad27, 0xa438, 0x3f1f, 0xa438, 0x44e0, 0xa438, 0x8560,
+        0xa438, 0xe185, 0xa438, 0x61bf, 0xa438, 0x8b51, 0xa438, 0x026c,
+        0xa438, 0x4ee0, 0xa438, 0x8566, 0xa438, 0xe185, 0xa438, 0x67bf,
+        0xa438, 0x8b54, 0xa438, 0x026c, 0xa438, 0x4ee0, 0xa438, 0x856c,
+        0xa438, 0xe185, 0xa438, 0x6dbf, 0xa438, 0x8b57, 0xa438, 0x026c,
+        0xa438, 0x4ee0, 0xa438, 0x8572, 0xa438, 0xe185, 0xa438, 0x73bf,
+        0xa438, 0x8b5a, 0xa438, 0x026c, 0xa438, 0x4ee1, 0xa438, 0x8fb8,
+        0xa438, 0x5900, 0xa438, 0xf728, 0xa438, 0xe58f, 0xa438, 0xb8af,
+        0xa438, 0x8b2c, 0xa438, 0xe185, 0xa438, 0x791b, 0xa438, 0x21ad,
+        0xa438, 0x373e, 0xa438, 0x1f44, 0xa438, 0xe085, 0xa438, 0x62e1,
+        0xa438, 0x8563, 0xa438, 0xbf8b, 0xa438, 0x5102, 0xa438, 0x6c4e,
+        0xa438, 0xe085, 0xa438, 0x68e1, 0xa438, 0x8569, 0xa438, 0xbf8b,
+        0xa438, 0x5402, 0xa438, 0x6c4e, 0xa438, 0xe085, 0xa438, 0x6ee1,
+        0xa438, 0x856f, 0xa438, 0xbf8b, 0xa438, 0x5702, 0xa438, 0x6c4e,
+        0xa438, 0xe085, 0xa438, 0x74e1, 0xa438, 0x8575, 0xa438, 0xbf8b,
+        0xa438, 0x5a02, 0xa438, 0x6c4e, 0xa438, 0xe18f, 0xa438, 0xb859,
+        0xa438, 0x00f7, 0xa438, 0x28e5, 0xa438, 0x8fb8, 0xa438, 0xae4a,
+        0xa438, 0x1f44, 0xa438, 0xe085, 0xa438, 0x64e1, 0xa438, 0x8565,
+        0xa438, 0xbf8b, 0xa438, 0x5102, 0xa438, 0x6c4e, 0xa438, 0xe085,
+        0xa438, 0x6ae1, 0xa438, 0x856b, 0xa438, 0xbf8b, 0xa438, 0x5402,
+        0xa438, 0x6c4e, 0xa438, 0xe085, 0xa438, 0x70e1, 0xa438, 0x8571,
+        0xa438, 0xbf8b, 0xa438, 0x5702, 0xa438, 0x6c4e, 0xa438, 0xe085,
+        0xa438, 0x76e1, 0xa438, 0x8577, 0xa438, 0xbf8b, 0xa438, 0x5a02,
+        0xa438, 0x6c4e, 0xa438, 0xe18f, 0xa438, 0xb859, 0xa438, 0x00f7,
+        0xa438, 0x28e5, 0xa438, 0x8fb8, 0xa438, 0xae0c, 0xa438, 0xe18f,
+        0xa438, 0xb839, 0xa438, 0x04ac, 0xa438, 0x2f04, 0xa438, 0xee8f,
+        0xa438, 0xb800, 0xa438, 0xfefd, 0xa438, 0xfc04, 0xa438, 0xf0ac,
+        0xa438, 0x8efc, 0xa438, 0xac8c, 0xa438, 0xf0ac, 0xa438, 0xfaf0,
+        0xa438, 0xacf8, 0xa438, 0xf0ac, 0xa438, 0xf6f0, 0xa438, 0xad00,
+        0xa438, 0xf0ac, 0xa438, 0xfef0, 0xa438, 0xacfc, 0xa438, 0xf0ac,
+        0xa438, 0xf4f0, 0xa438, 0xacf2, 0xa438, 0xf0ac, 0xa438, 0xf0f0,
+        0xa438, 0xacb0, 0xa438, 0xf0ac, 0xa438, 0xaef0, 0xa438, 0xacac,
+        0xa438, 0xf0ac, 0xa438, 0xaaf0, 0xa438, 0xacee, 0xa438, 0xf0b0,
+        0xa438, 0x24f0, 0xa438, 0xb0a4, 0xa438, 0xf0b1, 0xa438, 0x24f0,
+        0xa438, 0xb1a4, 0xa438, 0xee8f, 0xa438, 0xb800, 0xa438, 0xd400,
+        0xa438, 0x00af, 0xa438, 0x3976, 0xa438, 0x66ac, 0xa438, 0xeabb,
+        0xa438, 0xa430, 0xa438, 0x6e50, 0xa438, 0x6e53, 0xa438, 0x6e56,
+        0xa438, 0x6e59, 0xa438, 0x6e5c, 0xa438, 0x6e5f, 0xa438, 0x6e62,
+        0xa438, 0x6e65, 0xa438, 0xd9ac, 0xa438, 0x70f0, 0xa438, 0xac6a,
+        0xa436, 0xb85e, 0xa438, 0x23b7, 0xa436, 0xb860, 0xa438, 0x74db,
+        0xa436, 0xb862, 0xa438, 0x268c, 0xa436, 0xb864, 0xa438, 0x3FE5,
+        0xa436, 0xb886, 0xa438, 0x2250, 0xa436, 0xb888, 0xa438, 0x140e,
+        0xa436, 0xb88a, 0xa438, 0x3696, 0xa436, 0xb88c, 0xa438, 0x3973,
+        0xa436, 0xb838, 0xa438, 0x00ff, 0xb820, 0x0010, 0xa436, 0x8464,
+        0xa438, 0xaf84, 0xa438, 0x7caf, 0xa438, 0x8485, 0xa438, 0xaf85,
+        0xa438, 0x13af, 0xa438, 0x851e, 0xa438, 0xaf85, 0xa438, 0xb9af,
+        0xa438, 0x8684, 0xa438, 0xaf87, 0xa438, 0x01af, 0xa438, 0x8701,
+        0xa438, 0xac38, 0xa438, 0x03af, 0xa438, 0x38bb, 0xa438, 0xaf38,
+        0xa438, 0xc302, 0xa438, 0x4618, 0xa438, 0xbf85, 0xa438, 0x0a02,
+        0xa438, 0x54b7, 0xa438, 0xbf85, 0xa438, 0x1002, 0xa438, 0x54c0,
+        0xa438, 0xd400, 0xa438, 0x0fbf, 0xa438, 0x8507, 0xa438, 0x024f,
+        0xa438, 0x48bf, 0xa438, 0x8504, 0xa438, 0x024f, 0xa438, 0x6759,
+        0xa438, 0xf0a1, 0xa438, 0x3008, 0xa438, 0xbf85, 0xa438, 0x0d02,
+        0xa438, 0x54c0, 0xa438, 0xae06, 0xa438, 0xbf85, 0xa438, 0x0d02,
+        0xa438, 0x54b7, 0xa438, 0xbf85, 0xa438, 0x0402, 0xa438, 0x4f67,
+        0xa438, 0xa183, 0xa438, 0x02ae, 0xa438, 0x15a1, 0xa438, 0x8502,
+        0xa438, 0xae10, 0xa438, 0x59f0, 0xa438, 0xa180, 0xa438, 0x16bf,
+        0xa438, 0x8501, 0xa438, 0x024f, 0xa438, 0x67a1, 0xa438, 0x381b,
+        0xa438, 0xae0b, 0xa438, 0xe18f, 0xa438, 0xffbf, 0xa438, 0x84fe,
+        0xa438, 0x024f, 0xa438, 0x48ae, 0xa438, 0x17bf, 0xa438, 0x84fe,
+        0xa438, 0x0254, 0xa438, 0xb7bf, 0xa438, 0x84fb, 0xa438, 0x0254,
+        0xa438, 0xb7ae, 0xa438, 0x09a1, 0xa438, 0x5006, 0xa438, 0xbf84,
+        0xa438, 0xfb02, 0xa438, 0x54c0, 0xa438, 0xaf04, 0xa438, 0x4700,
+        0xa438, 0xad34, 0xa438, 0xfdad, 0xa438, 0x0670, 0xa438, 0xae14,
+        0xa438, 0xf0a6, 0xa438, 0x00b8, 0xa438, 0xbd32, 0xa438, 0x30bd,
+        0xa438, 0x30aa, 0xa438, 0xbd2c, 0xa438, 0xccbd, 0xa438, 0x2ca1,
+        0xa438, 0x0705, 0xa438, 0xec80, 0xa438, 0xaf40, 0xa438, 0xf7af,
+        0xa438, 0x40f5, 0xa438, 0xd101, 0xa438, 0xbf85, 0xa438, 0xa402,
+        0xa438, 0x4f48, 0xa438, 0xbf85, 0xa438, 0xa702, 0xa438, 0x54c0,
+        0xa438, 0xd10f, 0xa438, 0xbf85, 0xa438, 0xaa02, 0xa438, 0x4f48,
+        0xa438, 0x024d, 0xa438, 0x6abf, 0xa438, 0x85ad, 0xa438, 0x024f,
+        0xa438, 0x67bf, 0xa438, 0x8ff7, 0xa438, 0xddbf, 0xa438, 0x85b0,
+        0xa438, 0x024f, 0xa438, 0x67bf, 0xa438, 0x8ff8, 0xa438, 0xddbf,
+        0xa438, 0x85b3, 0xa438, 0x024f, 0xa438, 0x67bf, 0xa438, 0x8ff9,
+        0xa438, 0xddbf, 0xa438, 0x85b6, 0xa438, 0x024f, 0xa438, 0x67bf,
+        0xa438, 0x8ffa, 0xa438, 0xddd1, 0xa438, 0x00bf, 0xa438, 0x85aa,
+        0xa438, 0x024f, 0xa438, 0x4802, 0xa438, 0x4d6a, 0xa438, 0xbf85,
+        0xa438, 0xad02, 0xa438, 0x4f67, 0xa438, 0xbf8f, 0xa438, 0xfbdd,
+        0xa438, 0xbf85, 0xa438, 0xb002, 0xa438, 0x4f67, 0xa438, 0xbf8f,
+        0xa438, 0xfcdd, 0xa438, 0xbf85, 0xa438, 0xb302, 0xa438, 0x4f67,
+        0xa438, 0xbf8f, 0xa438, 0xfddd, 0xa438, 0xbf85, 0xa438, 0xb602,
+        0xa438, 0x4f67, 0xa438, 0xbf8f, 0xa438, 0xfedd, 0xa438, 0xbf85,
+        0xa438, 0xa702, 0xa438, 0x54b7, 0xa438, 0xbf85, 0xa438, 0xa102,
+        0xa438, 0x54b7, 0xa438, 0xaf3c, 0xa438, 0x2066, 0xa438, 0xb800,
+        0xa438, 0xb8bd, 0xa438, 0x30ee, 0xa438, 0xbd2c, 0xa438, 0xb8bd,
+        0xa438, 0x7040, 0xa438, 0xbd86, 0xa438, 0xc8bd, 0xa438, 0x8640,
+        0xa438, 0xbd88, 0xa438, 0xc8bd, 0xa438, 0x8802, 0xa438, 0x1929,
+        0xa438, 0xa202, 0xa438, 0x02ae, 0xa438, 0x03a2, 0xa438, 0x032e,
+        0xa438, 0xd10f, 0xa438, 0xbf85, 0xa438, 0xaa02, 0xa438, 0x4f48,
+        0xa438, 0xe18f, 0xa438, 0xf7bf, 0xa438, 0x85ad, 0xa438, 0x024f,
+        0xa438, 0x48e1, 0xa438, 0x8ff8, 0xa438, 0xbf85, 0xa438, 0xb002,
+        0xa438, 0x4f48, 0xa438, 0xe18f, 0xa438, 0xf9bf, 0xa438, 0x85b3,
+        0xa438, 0x024f, 0xa438, 0x48e1, 0xa438, 0x8ffa, 0xa438, 0xbf85,
+        0xa438, 0xb602, 0xa438, 0x4f48, 0xa438, 0xae2c, 0xa438, 0xd100,
+        0xa438, 0xbf85, 0xa438, 0xaa02, 0xa438, 0x4f48, 0xa438, 0xe18f,
+        0xa438, 0xfbbf, 0xa438, 0x85ad, 0xa438, 0x024f, 0xa438, 0x48e1,
+        0xa438, 0x8ffc, 0xa438, 0xbf85, 0xa438, 0xb002, 0xa438, 0x4f48,
+        0xa438, 0xe18f, 0xa438, 0xfdbf, 0xa438, 0x85b3, 0xa438, 0x024f,
+        0xa438, 0x48e1, 0xa438, 0x8ffe, 0xa438, 0xbf85, 0xa438, 0xb602,
+        0xa438, 0x4f48, 0xa438, 0xbf86, 0xa438, 0x7e02, 0xa438, 0x4f67,
+        0xa438, 0xa100, 0xa438, 0x02ae, 0xa438, 0x25a1, 0xa438, 0x041d,
+        0xa438, 0xe18f, 0xa438, 0xf1bf, 0xa438, 0x8675, 0xa438, 0x024f,
+        0xa438, 0x48e1, 0xa438, 0x8ff2, 0xa438, 0xbf86, 0xa438, 0x7802,
+        0xa438, 0x4f48, 0xa438, 0xe18f, 0xa438, 0xf3bf, 0xa438, 0x867b,
+        0xa438, 0x024f, 0xa438, 0x48ae, 0xa438, 0x29a1, 0xa438, 0x070b,
+        0xa438, 0xae24, 0xa438, 0xbf86, 0xa438, 0x8102, 0xa438, 0x4f67,
+        0xa438, 0xad28, 0xa438, 0x1be1, 0xa438, 0x8ff4, 0xa438, 0xbf86,
+        0xa438, 0x7502, 0xa438, 0x4f48, 0xa438, 0xe18f, 0xa438, 0xf5bf,
+        0xa438, 0x8678, 0xa438, 0x024f, 0xa438, 0x48e1, 0xa438, 0x8ff6,
+        0xa438, 0xbf86, 0xa438, 0x7b02, 0xa438, 0x4f48, 0xa438, 0xaf09,
+        0xa438, 0x8420, 0xa438, 0xbc32, 0xa438, 0x20bc, 0xa438, 0x3e76,
+        0xa438, 0xbc08, 0xa438, 0xfda6, 0xa438, 0x1a00, 0xa438, 0xb64e,
+        0xa438, 0xd101, 0xa438, 0xbf85, 0xa438, 0xa402, 0xa438, 0x4f48,
+        0xa438, 0xbf85, 0xa438, 0xa702, 0xa438, 0x54c0, 0xa438, 0xd10f,
+        0xa438, 0xbf85, 0xa438, 0xaa02, 0xa438, 0x4f48, 0xa438, 0x024d,
+        0xa438, 0x6abf, 0xa438, 0x85ad, 0xa438, 0x024f, 0xa438, 0x67bf,
+        0xa438, 0x8ff7, 0xa438, 0xddbf, 0xa438, 0x85b0, 0xa438, 0x024f,
+        0xa438, 0x67bf, 0xa438, 0x8ff8, 0xa438, 0xddbf, 0xa438, 0x85b3,
+        0xa438, 0x024f, 0xa438, 0x67bf, 0xa438, 0x8ff9, 0xa438, 0xddbf,
+        0xa438, 0x85b6, 0xa438, 0x024f, 0xa438, 0x67bf, 0xa438, 0x8ffa,
+        0xa438, 0xddd1, 0xa438, 0x00bf, 0xa438, 0x85aa, 0xa438, 0x024f,
+        0xa438, 0x4802, 0xa438, 0x4d6a, 0xa438, 0xbf85, 0xa438, 0xad02,
+        0xa438, 0x4f67, 0xa438, 0xbf8f, 0xa438, 0xfbdd, 0xa438, 0xbf85,
+        0xa438, 0xb002, 0xa438, 0x4f67, 0xa438, 0xbf8f, 0xa438, 0xfcdd,
+        0xa438, 0xbf85, 0xa438, 0xb302, 0xa438, 0x4f67, 0xa438, 0xbf8f,
+        0xa438, 0xfddd, 0xa438, 0xbf85, 0xa438, 0xb602, 0xa438, 0x4f67,
+        0xa438, 0xbf8f, 0xa438, 0xfedd, 0xa438, 0xbf85, 0xa438, 0xa702,
+        0xa438, 0x54b7, 0xa438, 0xaf00, 0xa438, 0x8800, 0xa436, 0xb818,
+        0xa438, 0x38b8, 0xa436, 0xb81a, 0xa438, 0x0444, 0xa436, 0xb81c,
+        0xa438, 0x40ee, 0xa436, 0xb81e, 0xa438, 0x3C1A, 0xa436, 0xb850,
+        0xa438, 0x0981, 0xa436, 0xb852, 0xa438, 0x0085, 0xa436, 0xb878,
+        0xa438, 0xffff, 0xa436, 0xb884, 0xa438, 0xffff, 0xa436, 0xb832,
+        0xa438, 0x003f, 0xa436, 0x0000, 0xa438, 0x0000, 0xa436, 0xB82E,
+        0xa438, 0x0000, 0xa436, 0x8024, 0xa438, 0x0000, 0xb820, 0x0000,
+        0xa436, 0x801E, 0xa438, 0x0021, 0xFFFF, 0xFFFF
+};
+
+static const u16 phy_mcu_ram_code_8125b_2[] = {
+        0xa436, 0x8024, 0xa438, 0x3701, 0xa436, 0xB82E, 0xa438, 0x0001,
+        0xb820, 0x0090, 0xa436, 0xb87c, 0xa438, 0x8625, 0xa436, 0xb87e,
+        0xa438, 0xaf86, 0xa438, 0x3daf, 0xa438, 0x8689, 0xa438, 0xaf86,
+        0xa438, 0x89af, 0xa438, 0x8689, 0xa438, 0xaf86, 0xa438, 0x89af,
+        0xa438, 0x8689, 0xa438, 0xaf86, 0xa438, 0x89af, 0xa438, 0x8689,
+        0xa438, 0xbf86, 0xa438, 0x49d7, 0xa438, 0x0040, 0xa438, 0x0277,
+        0xa438, 0x7daf, 0xa438, 0x2727, 0xa438, 0x0000, 0xa438, 0x7205,
+        0xa438, 0x0000, 0xa438, 0x7208, 0xa438, 0x0000, 0xa438, 0x71f3,
+        0xa438, 0x0000, 0xa438, 0x71f6, 0xa438, 0x0000, 0xa438, 0x7229,
+        0xa438, 0x0000, 0xa438, 0x722c, 0xa438, 0x0000, 0xa438, 0x7217,
+        0xa438, 0x0000, 0xa438, 0x721a, 0xa438, 0x0000, 0xa438, 0x721d,
+        0xa438, 0x0000, 0xa438, 0x7211, 0xa438, 0x0000, 0xa438, 0x7220,
+        0xa438, 0x0000, 0xa438, 0x7214, 0xa438, 0x0000, 0xa438, 0x722f,
+        0xa438, 0x0000, 0xa438, 0x7223, 0xa438, 0x0000, 0xa438, 0x7232,
+        0xa438, 0x0000, 0xa438, 0x7226, 0xa436, 0xb85e, 0xa438, 0x271E,
+        0xa436, 0xb860, 0xa438, 0xffff, 0xa436, 0xb862, 0xa438, 0xffff,
+        0xa436, 0xb864, 0xa438, 0xffff, 0xa436, 0xb886, 0xa438, 0xffff,
+        0xa436, 0xb888, 0xa438, 0xffff, 0xa436, 0xb88a, 0xa438, 0xffff,
+        0xa436, 0xb88c, 0xa438, 0xffff, 0xa436, 0xb838, 0xa438, 0x0001,
+        0xb820, 0x0010, 0xa436, 0x0000, 0xa438, 0x0000, 0xa436, 0xB82E,
+        0xa438, 0x0000, 0xa436, 0x8024, 0xa438, 0x0000, 0xb820, 0x0000,
+        0xa436, 0x801E, 0xa438, 0x0003, 0xFFFF, 0xFFFF
+};
+
+static void
+rtl8125_real_set_phy_mcu_8125b_1(struct net_device *dev)
+{
+        rtl8125_set_phy_mcu_ram_code(dev,
+                                     phy_mcu_ram_code_8125b_1,
+                                     ARRAY_SIZE(phy_mcu_ram_code_8125b_1)
+                                    );
+}
+
+static void
+rtl8125_set_phy_mcu_8125b_1(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        rtl8125_set_phy_mcu_patch_request(tp);
+
+        rtl8125_real_set_phy_mcu_8125b_1(dev);
+
+        rtl8125_clear_phy_mcu_patch_request(tp);
+}
+
+static void
+rtl8125_real_set_phy_mcu_8125b_2(struct net_device *dev)
+{
+        rtl8125_set_phy_mcu_ram_code(dev,
+                                     phy_mcu_ram_code_8125b_2,
+                                     ARRAY_SIZE(phy_mcu_ram_code_8125b_2)
+                                    );
+}
+
+static void
+rtl8125_set_phy_mcu_8125b_2(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        rtl8125_set_phy_mcu_patch_request(tp);
+
+        rtl8125_real_set_phy_mcu_8125b_2(dev);
+
+        rtl8125_clear_phy_mcu_patch_request(tp);
+}
+
+static void
+rtl8125_init_hw_phy_mcu(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u8 require_disable_phy_disable_mode = FALSE;
+
+        if (tp->NotWrRamCodeToMicroP == TRUE) return;
+        if (rtl8125_check_hw_phy_mcu_code_ver(dev)) return;
+
+        if (HW_SUPPORT_CHECK_PHY_DISABLE_MODE(tp) && rtl8125_is_in_phy_disable_mode(dev))
+                require_disable_phy_disable_mode = TRUE;
+
+        if (require_disable_phy_disable_mode)
+                rtl8125_disable_phy_disable_mode(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+                rtl8125_set_phy_mcu_8125a_1(dev);
+                break;
+        case CFG_METHOD_3:
+                rtl8125_set_phy_mcu_8125a_2(dev);
+                break;
+        case CFG_METHOD_4:
+                rtl8125_set_phy_mcu_8125b_1(dev);
+                break;
+        case CFG_METHOD_5:
+                rtl8125_set_phy_mcu_8125b_2(dev);
+                break;
+        }
+
+        if (require_disable_phy_disable_mode)
+                rtl8125_enable_phy_disable_mode(dev);
+
+        rtl8125_write_hw_phy_mcu_code_ver(dev);
+
+        rtl8125_mdio_write(tp,0x1F, 0x0000);
+
+        tp->HwHasWrRamCodeToMicroP = TRUE;
+}
+
+static void
+rtl8125_enable_phy_aldps(struct rtl8125_private *tp)
+{
+        //enable aldps
+        //GPHY OCP 0xA430 bit[2] = 0x1 (en_aldps)
+        SetEthPhyOcpBit(tp, 0xA430, BIT_2);
+}
+
+static void
+rtl8125_hw_phy_config_8125a_1(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAD40,
+                                0x03FF,
+                                0x84
+                               );
+
+        SetEthPhyOcpBit(tp, 0xAD4E, BIT_4);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAD16,
+                                0x03FF,
+                                0x0006
+                               );
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAD32,
+                                0x003F,
+                                0x0006
+                               );
+        ClearEthPhyOcpBit(tp, 0xAC08, BIT_12);
+        ClearEthPhyOcpBit(tp, 0xAC08, BIT_8);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAC8A,
+                                BIT_15|BIT_14|BIT_13|BIT_12,
+                                BIT_14|BIT_13|BIT_12
+                               );
+        SetEthPhyOcpBit(tp, 0xAD18, BIT_10);
+        SetEthPhyOcpBit(tp, 0xAD1A, 0x3FF);
+        SetEthPhyOcpBit(tp, 0xAD1C, 0x3FF);
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80EA);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0xC400
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80EB);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0x0700,
+                                0x0300
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80F8);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x1C00
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80F1);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x3000
+                               );
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80FE);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0xA500
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8102);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x5000
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8105);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x3300
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8100);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x7000
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8104);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0xF000
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8106);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x6500
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80DC);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0xED00
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80DF);
+        SetEthPhyOcpBit(tp, 0xA438, BIT_8);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80E1);
+        ClearEthPhyOcpBit(tp, 0xA438, BIT_8);
+
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xBF06,
+                                0x003F,
+                                0x38
+                               );
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x819F);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xD0B6);
+
+        mdio_direct_write_phy_ocp(tp, 0xBC34, 0x5555);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xBF0A,
+                                BIT_11|BIT_10|BIT_9,
+                                BIT_11|BIT_9
+                               );
+
+        ClearEthPhyOcpBit(tp, 0xA5C0, BIT_10);
+
+        SetEthPhyOcpBit(tp, 0xA442, BIT_11);
+
+        //enable aldps
+        //GPHY OCP 0xA430 bit[2] = 0x1 (en_aldps)
+        if (aspm) {
+                if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                        rtl8125_enable_phy_aldps(tp);
+                }
+        }
+}
+
+static void
+rtl8125_hw_phy_config_8125a_2(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        SetEthPhyOcpBit(tp, 0xAD4E, BIT_4);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAD16,
+                                0x03FF,
+                                0x03FF
+                               );
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAD32,
+                                0x003F,
+                                0x0006
+                               );
+        ClearEthPhyOcpBit(tp, 0xAC08, BIT_12);
+        ClearEthPhyOcpBit(tp, 0xAC08, BIT_8);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xACC0,
+                                BIT_1|BIT_0,
+                                BIT_1
+                               );
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAD40,
+                                BIT_7|BIT_6|BIT_5,
+                                BIT_6
+                               );
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAD40,
+                                BIT_2|BIT_1|BIT_0,
+                                BIT_2
+                               );
+        ClearEthPhyOcpBit(tp, 0xAC14, BIT_7);
+        ClearEthPhyOcpBit(tp, 0xAC80, BIT_9|BIT_8);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAC5E,
+                                BIT_2|BIT_1|BIT_0,
+                                BIT_1
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xAD4C, 0x00A8);
+        mdio_direct_write_phy_ocp(tp, 0xAC5C, 0x01FF);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAC8A,
+                                BIT_7|BIT_6|BIT_5|BIT_4,
+                                BIT_5|BIT_4
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8157);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xB87E,
+                                0xFF00,
+                                0x0500
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8159);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xB87E,
+                                0xFF00,
+                                0x0700
+                               );
+
+
+        RTL_W16(tp, EEE_TXIDLE_TIMER_8125, 0x2400 + 0x20);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x80A2);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0153);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x809C);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0153);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x81B3);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0043);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00A7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00D6);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00EC);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00F6);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00FB);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00FD);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00FF);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x00BB);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0058);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0029);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0013);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0009);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0004);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0002);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0000);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8257);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x020F);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80EA);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x7843);
+
+
+        rtl8125_set_phy_mcu_patch_request(tp);
+
+        ClearEthPhyOcpBit(tp, 0xB896, BIT_0);
+        ClearEthPhyOcpBit(tp, 0xB892, 0xFF00);
+
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC091);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x6E12);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC092);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x1214);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC094);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x1516);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC096);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x171B);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC098);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x1B1C);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC09A);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x1F1F);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC09C);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x2021);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC09E);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x2224);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC0A0);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x2424);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC0A2);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x2424);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC0A4);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x2424);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC018);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x0AF2);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC01A);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x0D4A);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC01C);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x0F26);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC01E);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x118D);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC020);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x14F3);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC022);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x175A);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC024);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x19C0);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC026);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x1C26);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC089);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x6050);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC08A);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x5F6E);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC08C);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x6E6E);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC08E);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x6E6E);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC090);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x6E12);
+
+        SetEthPhyOcpBit(tp, 0xB896, BIT_0);
+
+        rtl8125_clear_phy_mcu_patch_request(tp);
+
+
+        SetEthPhyOcpBit(tp, 0xD068, BIT_13);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x81A2);
+        SetEthPhyOcpBit(tp, 0xA438, BIT_8);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xB54C,
+                                0xFF00,
+                                0xDB00);
+
+
+        ClearEthPhyOcpBit(tp, 0xA454, BIT_0);
+
+
+        SetEthPhyOcpBit(tp, 0xA5D4, BIT_5);
+        ClearEthPhyOcpBit(tp, 0xAD4E, BIT_4);
+        ClearEthPhyOcpBit(tp, 0xA86A, BIT_0);
+
+
+        SetEthPhyOcpBit(tp, 0xA442, BIT_11);
+
+
+        if (tp->RequirePhyMdiSwapPatch) {
+                u16 adccal_offset_p0;
+                u16 adccal_offset_p1;
+                u16 adccal_offset_p2;
+                u16 adccal_offset_p3;
+                u16 rg_lpf_cap_xg_p0;
+                u16 rg_lpf_cap_xg_p1;
+                u16 rg_lpf_cap_xg_p2;
+                u16 rg_lpf_cap_xg_p3;
+                u16 rg_lpf_cap_p0;
+                u16 rg_lpf_cap_p1;
+                u16 rg_lpf_cap_p2;
+                u16 rg_lpf_cap_p3;
+
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD068,
+                                        0x0007,
+                                        0x0001
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD068,
+                                        0x0018,
+                                        0x0000
+                                       );
+                adccal_offset_p0 = mdio_direct_read_phy_ocp(tp, 0xD06A);
+                adccal_offset_p0 &= 0x07FF;
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD068,
+                                        0x0018,
+                                        0x0008
+                                       );
+                adccal_offset_p1 = mdio_direct_read_phy_ocp(tp, 0xD06A);
+                adccal_offset_p1 &= 0x07FF;
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD068,
+                                        0x0018,
+                                        0x0010
+                                       );
+                adccal_offset_p2 = mdio_direct_read_phy_ocp(tp, 0xD06A);
+                adccal_offset_p2 &= 0x07FF;
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD068,
+                                        0x0018,
+                                        0x0018
+                                       );
+                adccal_offset_p3 = mdio_direct_read_phy_ocp(tp, 0xD06A);
+                adccal_offset_p3 &= 0x07FF;
+
+
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD068,
+                                        0x0018,
+                                        0x0000
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD06A,
+                                        0x07FF,
+                                        adccal_offset_p3
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD068,
+                                        0x0018,
+                                        0x0008
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD06A,
+                                        0x07FF,
+                                        adccal_offset_p2
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD068,
+                                        0x0018,
+                                        0x0010
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD06A,
+                                        0x07FF,
+                                        adccal_offset_p1
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD068,
+                                        0x0018,
+                                        0x0018
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xD06A,
+                                        0x07FF,
+                                        adccal_offset_p0
+                                       );
+
+
+                rg_lpf_cap_xg_p0 = mdio_direct_read_phy_ocp(tp, 0xBD5A);
+                rg_lpf_cap_xg_p0 &= 0x001F;
+                rg_lpf_cap_xg_p1 = mdio_direct_read_phy_ocp(tp, 0xBD5A);
+                rg_lpf_cap_xg_p1 &= 0x1F00;
+                rg_lpf_cap_xg_p2 = mdio_direct_read_phy_ocp(tp, 0xBD5C);
+                rg_lpf_cap_xg_p2 &= 0x001F;
+                rg_lpf_cap_xg_p3 = mdio_direct_read_phy_ocp(tp, 0xBD5C);
+                rg_lpf_cap_xg_p3 &= 0x1F00;
+                rg_lpf_cap_p0 = mdio_direct_read_phy_ocp(tp, 0xBC18);
+                rg_lpf_cap_p0 &= 0x001F;
+                rg_lpf_cap_p1 = mdio_direct_read_phy_ocp(tp, 0xBC18);
+                rg_lpf_cap_p1 &= 0x1F00;
+                rg_lpf_cap_p2 = mdio_direct_read_phy_ocp(tp, 0xBC1A);
+                rg_lpf_cap_p2 &= 0x001F;
+                rg_lpf_cap_p3 = mdio_direct_read_phy_ocp(tp, 0xBC1A);
+                rg_lpf_cap_p3 &= 0x1F00;
+
+
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xBD5A,
+                                        0x001F,
+                                        rg_lpf_cap_xg_p3 >> 8
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xBD5A,
+                                        0x1F00,
+                                        rg_lpf_cap_xg_p2 << 8
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xBD5C,
+                                        0x001F,
+                                        rg_lpf_cap_xg_p1 >> 8
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xBD5C,
+                                        0x1F00,
+                                        rg_lpf_cap_xg_p0 << 8
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xBC18,
+                                        0x001F,
+                                        rg_lpf_cap_p3 >> 8
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xBC18,
+                                        0x1F00,
+                                        rg_lpf_cap_p2 << 8
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xBC1A,
+                                        0x001F,
+                                        rg_lpf_cap_p1 >> 8
+                                       );
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xBC1A,
+                                        0x1F00,
+                                        rg_lpf_cap_p0 << 8
+                                       );
+        }
+
+
+        if (aspm) {
+                if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                        rtl8125_enable_phy_aldps(tp);
+                }
+        }
+}
+
+static void
+rtl8125_hw_phy_config_8125b_1(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        SetEthPhyOcpBit(tp, 0xA442, BIT_11);
+
+
+        SetEthPhyOcpBit(tp, 0xBC08, (BIT_3 | BIT_2));
+
+
+        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                mdio_direct_write_phy_ocp(tp, 0xA436, 0x8FFF);
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xA438,
+                                        0xFF00,
+                                        0x0400
+                                       );
+        }
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8560);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x19CC);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8562);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x19CC);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8564);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x19CC);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8566);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x147D);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8568);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x147D);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x856A);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x147D);
+        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FFE);
+                mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0907);
+        }
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xACDA,
+                                0xFF00,
+                                0xFF00
+                               );
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xACDE,
+                                0xF000,
+                                0xF000
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x80D6);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x2801);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x80F2);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x2801);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x80F4);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x6077);
+        mdio_direct_write_phy_ocp(tp, 0xB506, 0x01E7);
+        mdio_direct_write_phy_ocp(tp, 0xAC8C, 0x0FFC);
+        mdio_direct_write_phy_ocp(tp, 0xAC46, 0xB7B4);
+        mdio_direct_write_phy_ocp(tp, 0xAC50, 0x0FBC);
+        mdio_direct_write_phy_ocp(tp, 0xAC3C, 0x9240);
+        mdio_direct_write_phy_ocp(tp, 0xAC4E, 0x0DB4);
+        mdio_direct_write_phy_ocp(tp, 0xACC6, 0x0707);
+        mdio_direct_write_phy_ocp(tp, 0xACC8, 0xA0D3);
+        mdio_direct_write_phy_ocp(tp, 0xAD08, 0x0007);
+
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8013);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0700);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FB9);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x2801);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FBA);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0100);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FBC);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x1900);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FBE);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xE100);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FC0);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0800);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FC2);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xE500);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FC4);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0F00);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FC6);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xF100);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FC8);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0400);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FCa);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xF300);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FCc);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xFD00);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FCe);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xFF00);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FD0);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xFB00);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FD2);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0100);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FD4);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xF400);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FD6);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xFF00);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8FD8);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xF600);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x813D);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x390E);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x814F);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x790E);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x80B0);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0F31);
+        SetEthPhyOcpBit(tp, 0xBF4C, BIT_1);
+        SetEthPhyOcpBit(tp, 0xBCCA, (BIT_9 | BIT_8));
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8141);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x320E);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8153);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x720E);
+        ClearEthPhyOcpBit(tp, 0xA432, BIT_6);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8529);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x050E);
+
+
+        RTL_W16(tp, EEE_TXIDLE_TIMER_8125, 0x2400 + 0x20);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x816C);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xC4A0);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8170);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xC4A0);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8174);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x04A0);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8178);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x04A0);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x817C);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0719);
+        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                mdio_direct_write_phy_ocp(tp, 0xA436, 0x8FF4);
+                mdio_direct_write_phy_ocp(tp, 0xA438, 0x0400);
+                mdio_direct_write_phy_ocp(tp, 0xA436, 0x8FF1);
+                mdio_direct_write_phy_ocp(tp, 0xA438, 0x0404);
+        }
+        mdio_direct_write_phy_ocp(tp, 0xBF4A, 0x001B);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8033);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x7C13);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8037);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x7C13);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x803B);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0xFC32);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x803F);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x7C13);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8043);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x7C13);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8047);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x7C13);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8145);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x370E);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8157);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x770E);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x8169);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x0D0A);
+        mdio_direct_write_phy_ocp(tp, 0xB87C, 0x817B);
+        mdio_direct_write_phy_ocp(tp, 0xB87E, 0x1D0A);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x8217);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x5000
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x821A);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x5000
+                               );
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80DA);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0403);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80DC);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x1000
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80B3);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x0384);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80B7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2007);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80BA);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x6C00
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80B5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xF009);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80BD);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x9F00
+                               );
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80C7);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xf083);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80DD);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x03f0);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80DF);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x1000
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80CB);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x2007);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80CE);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x6C00
+                               );
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80C9);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x8009);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80D1);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0x8000
+                               );
+
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80A3);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x200A);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80A5);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0xF0AD);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x809F);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x6073);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80A1);
+        mdio_direct_write_phy_ocp(tp, 0xA438, 0x000B);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x80A9);
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xA438,
+                                0xFF00,
+                                0xC000
+                               );
+
+        rtl8125_set_phy_mcu_patch_request(tp);
+
+        ClearEthPhyOcpBit(tp, 0xB896, BIT_0);
+        ClearEthPhyOcpBit(tp, 0xB892, 0xFF00);
+
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC23E);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x0000);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC240);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x0103);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC242);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x0507);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC244);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x090B);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC246);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x0C0E);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC248);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x1012);
+        mdio_direct_write_phy_ocp(tp, 0xB88E, 0xC24A);
+        mdio_direct_write_phy_ocp(tp, 0xB890, 0x1416);
+
+        SetEthPhyOcpBit(tp, 0xB896, BIT_0);
+
+        rtl8125_clear_phy_mcu_patch_request(tp);
+
+
+        SetEthPhyOcpBit(tp, 0xA86A, BIT_0);
+        SetEthPhyOcpBit(tp, 0xA6F0, BIT_0);
+
+
+        mdio_direct_write_phy_ocp(tp, 0xBFA0, 0xD70D);
+        mdio_direct_write_phy_ocp(tp, 0xBFA2, 0x4100);
+        mdio_direct_write_phy_ocp(tp, 0xBFA4, 0xE868);
+        mdio_direct_write_phy_ocp(tp, 0xBFA6, 0xDC59);
+        mdio_direct_write_phy_ocp(tp, 0xB54C, 0x3C18);
+        ClearEthPhyOcpBit(tp, 0xBFA4, BIT_5);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x817D);
+        SetEthPhyOcpBit(tp, 0xA438, BIT_12);
+
+
+        if (aspm) {
+                if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                        rtl8125_enable_phy_aldps(tp);
+                }
+        }
+}
+
+static void
+rtl8125_hw_phy_config_8125b_2(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        SetEthPhyOcpBit(tp, 0xA442, BIT_11);
+
+
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAC46,
+                                0x00F0,
+                                0x0090
+                               );
+        ClearAndSetEthPhyOcpBit(tp,
+                                0xAD30,
+                                0x0003,
+                                0x0001
+                               );
+
+
+        RTL_W16(tp, EEE_TXIDLE_TIMER_8125, 0x2400 + 0x20);
+
+
+        /*
+        mdio_direct_write_phy_ocp(tp, 0xBFA0, 0xD70D);
+        mdio_direct_write_phy_ocp(tp, 0xBFA2, 0x4100);
+        mdio_direct_write_phy_ocp(tp, 0xBFA4, 0xE868);
+        mdio_direct_write_phy_ocp(tp, 0xBFA6, 0xDC59);
+        mdio_direct_write_phy_ocp(tp, 0xB54C, 0x3C18);
+        ClearEthPhyOcpBit(tp, 0xBFA4, BIT_5);
+        mdio_direct_write_phy_ocp(tp, 0xA436, 0x817D);
+        SetEthPhyOcpBit(tp, 0xA438, BIT_12);
+        */
+
+
+        if (aspm) {
+                if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                        rtl8125_enable_phy_aldps(tp);
+                }
+        }
+}
+
+static void
+rtl8125_set_hw_phy_before_init_phy_mcu(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                mdio_direct_write_phy_ocp(tp, 0xBF86, 0x9000);
+
+
+                SetEthPhyOcpBit(tp, 0xC402, BIT_10);
+                ClearEthPhyOcpBit(tp, 0xC402, BIT_10);
+
+
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xBD4E,
+                                        BIT_11 | BIT_10,
+                                        BIT_11);
+                ClearAndSetEthPhyOcpBit(tp,
+                                        0xBF46,
+                                        BIT_11 | BIT_10 | BIT_9 | BIT_8,
+                                        BIT_10 | BIT_9 | BIT_8);
+                break;
+        }
+}
+
+static void
+rtl8125_hw_phy_config(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        tp->phy_reset_enable(dev);
+
+        if (HW_DASH_SUPPORT_TYPE_3(tp) && tp->HwPkgDet == 0x06) return;
+
+        rtl8125_set_hw_phy_before_init_phy_mcu(dev);
+
+        rtl8125_init_hw_phy_mcu(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+                rtl8125_hw_phy_config_8125a_1(dev);
+                break;
+        case CFG_METHOD_3:
+                rtl8125_hw_phy_config_8125a_2(dev);
+                break;
+        case CFG_METHOD_4:
+                rtl8125_hw_phy_config_8125b_1(dev);
+                break;
+        case CFG_METHOD_5:
+                rtl8125_hw_phy_config_8125b_2(dev);
+                break;
+        }
+
+        /*ocp phy power saving*/
+        /*
+        if (aspm) {
+        if (tp->mcfg == CFG_METHOD_2 || tp->mcfg == CFG_METHOD_3)
+                rtl8125_enable_ocp_phy_power_saving(dev);
+        }
+        */
+
+        rtl8125_mdio_write(tp, 0x1F, 0x0000);
+
+        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                if (tp->eee_enabled == 1)
+                        rtl8125_enable_eee(tp);
+                else
+                        rtl8125_disable_eee(tp);
+        }
+}
+
+static inline void rtl8125_delete_esd_timer(struct net_device *dev, struct timer_list *timer)
+{
+        del_timer_sync(timer);
+}
+
+static inline void rtl8125_request_esd_timer(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct timer_list *timer = &tp->esd_timer;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+        setup_timer(timer, rtl8125_esd_timer, (unsigned long)dev);
+#else
+        timer_setup(timer, rtl8125_esd_timer, 0);
+#endif
+        mod_timer(timer, jiffies + RTL8125_ESD_TIMEOUT);
+}
+
+static inline void rtl8125_delete_link_timer(struct net_device *dev, struct timer_list *timer)
+{
+        del_timer_sync(timer);
+}
+
+static inline void rtl8125_request_link_timer(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct timer_list *timer = &tp->link_timer;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+        setup_timer(timer, rtl8125_link_timer, (unsigned long)dev);
+#else
+        timer_setup(timer, rtl8125_link_timer, 0);
+#endif
+        mod_timer(timer, jiffies + RTL8125_LINK_TIMEOUT);
+}
+
+#ifdef CONFIG_NET_POLL_CONTROLLER
+/*
+ * Polling 'interrupt' - used by things like netconsole to send skbs
+ * without having to re-enable interrupts. It's not called while
+ * the interrupt routine is executing.
+ */
+static void
+rtl8125_netpoll(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+
+        disable_irq(pdev->irq);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
+        rtl8125_interrupt(pdev->irq, dev, NULL);
+#else
+        rtl8125_interrupt(pdev->irq, dev);
+#endif
+        enable_irq(pdev->irq);
+}
+#endif
+
+static void
+rtl8125_get_bios_setting(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                tp->bios_setting = RTL_R32(tp, TimeInt2);
+                break;
+        }
+}
+
+static void
+rtl8125_set_bios_setting(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                RTL_W32(tp, TimeInt2, tp->bios_setting);
+                break;
+        }
+}
+
+static void
+rtl8125_init_software_variable(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+
+        rtl8125_get_bios_setting(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                //tp->HwSuppDashVer = 3;
+                break;
+        default:
+                tp->HwSuppDashVer = 0;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                tp->HwPkgDet = rtl8125_mac_ocp_read(tp, 0xDC00);
+                tp->HwPkgDet = (tp->HwPkgDet >> 3) & 0x07;
+                break;
+        }
+
+        if (HW_DASH_SUPPORT_TYPE_3(tp) && tp->HwPkgDet == 0x06)
+                eee_enable = 0;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                tp->HwSuppNowIsOobVer = 1;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                tp->HwPcieSNOffset = 0x16C;
+                break;
+        }
+
+#ifdef ENABLE_REALWOW_SUPPORT
+        rtl8125_get_realwow_hw_version(dev);
+#endif //ENABLE_REALWOW_SUPPORT
+
+        if (HW_DASH_SUPPORT_DASH(tp) && rtl8125_check_dash(tp))
+                tp->DASH = 1;
+        else
+                tp->DASH = 0;
+
+        if (tp->DASH) {
+                if (HW_DASH_SUPPORT_TYPE_3(tp)) {
+                        u64 CmacMemPhysAddress;
+                        void __iomem *cmac_ioaddr = NULL;
+
+                        //map CMAC IO space
+                        CmacMemPhysAddress = rtl8125_csi_other_fun_read(tp, 0, 0x18);
+                        if (!(CmacMemPhysAddress & BIT_0)) {
+                                if (CmacMemPhysAddress & BIT_2)
+                                        CmacMemPhysAddress |=  (u64)rtl8125_csi_other_fun_read(tp, 0, 0x1C) << 32;
+
+                                CmacMemPhysAddress &=  0xFFFFFFF0;
+                                /* ioremap MMIO region */
+                                cmac_ioaddr = ioremap(CmacMemPhysAddress, R8125_REGS_SIZE);
+                        }
+
+                        if (cmac_ioaddr == NULL) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                                if (netif_msg_probe(tp))
+                                        dev_err(&pdev->dev, "cannot remap CMAC MMIO, aborting\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                        }
+
+                        if (cmac_ioaddr == NULL) {
+                                tp->DASH = 0;
+                        } else {
+                                tp->mapped_cmac_ioaddr = cmac_ioaddr;
+                        }
+                }
+        }
+
+        if	(HW_DASH_SUPPORT_TYPE_3(tp))
+                tp->cmac_ioaddr = tp->mapped_cmac_ioaddr;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        default:
+                tp->intr_mask = RxDescUnavail | TxOK | RxOK | SWInt;
+                tp->timer_intr_mask = PCSTimeout;
+                break;
+        }
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH) {
+                if (HW_DASH_SUPPORT_TYPE_3(tp)) {
+                        tp->timer_intr_mask |= ( ISRIMR_DASH_INTR_EN | ISRIMR_DASH_INTR_CMAC_RESET);
+                        tp->intr_mask |= ( ISRIMR_DASH_INTR_EN | ISRIMR_DASH_INTR_CMAC_RESET);
+                }
+        }
+#endif
+        if (aspm) {
+                switch (tp->mcfg) {
+                case CFG_METHOD_2:
+                case CFG_METHOD_3:
+                case CFG_METHOD_4:
+                case CFG_METHOD_5:
+                        tp->org_pci_offset_99 = rtl8125_csi_fun0_read_byte(tp, 0x99);
+                        tp->org_pci_offset_99 &= ~(BIT_5|BIT_6);
+                        break;
+                }
+
+                switch (tp->mcfg) {
+                case CFG_METHOD_2:
+                case CFG_METHOD_3:
+                        tp->org_pci_offset_180 = rtl8125_csi_fun0_read_byte(tp, 0x264);
+                        break;
+                case CFG_METHOD_4:
+                case CFG_METHOD_5:
+                        tp->org_pci_offset_180 = rtl8125_csi_fun0_read_byte(tp, 0x214);
+                        break;
+                }
+        }
+
+        pci_read_config_byte(pdev, 0x80, &tp->org_pci_offset_80);
+        pci_read_config_byte(pdev, 0x81, &tp->org_pci_offset_81);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        default:
+                tp->use_timer_interrrupt = TRUE;
+                break;
+        }
+
+        if (timer_count == 0 || tp->mcfg == CFG_METHOD_DEFAULT)
+                tp->use_timer_interrrupt = FALSE;
+
+#ifdef CONFIG_R8125_VLAN
+        switch (tp->mcfg) {
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                tp->ShortPacketSwChecksum = TRUE;
+                tp->UseSwPaddingShortPkt = TRUE;
+                break;
+        }
+#endif
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                tp->SwPaddingShortPktLen = RTL8125B_SHORT_PACKET_PADDING_SIZE;
+                break;
+        default:
+                tp->SwPaddingShortPktLen = ETH_ZLEN;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                tp->HwSuppMagicPktVer = WAKEUP_MAGIC_PACKET_V3;
+                break;
+        default:
+                tp->HwSuppMagicPktVer = WAKEUP_MAGIC_PACKET_NOT_SUPPORT;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                tp->HwSuppCheckPhyDisableModeVer = 3;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                tp->HwSuppGigaForceMode = TRUE;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_2;
+                break;
+        case CFG_METHOD_3:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_3;
+                break;
+        case CFG_METHOD_4:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_4;
+                break;
+        case CFG_METHOD_5:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_5;
+                break;
+        }
+
+        if (tp->HwIcVerUnknown) {
+                tp->NotWrRamCodeToMicroP = TRUE;
+                tp->NotWrMcuPatchCode = TRUE;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_3:
+                if ((rtl8125_mac_ocp_read(tp, 0xD442) & BIT_5) &&
+                    (mdio_direct_read_phy_ocp(tp, 0xD068) & BIT_1)
+                   ) {
+                        tp->RequirePhyMdiSwapPatch = TRUE;
+                }
+                break;
+        }
+
+        tp->NicCustLedValue = RTL_R16(tp, CustomLED);
+
+        rtl8125_get_hw_wol(dev);
+
+        rtl8125_link_option((u8*)&autoneg_mode, (u32*)&speed_mode, (u8*)&duplex_mode, (u32*)&advertising_mode);
+
+        tp->autoneg = autoneg_mode;
+        tp->speed = speed_mode;
+        tp->duplex = duplex_mode;
+        tp->advertising = advertising_mode;
+
+        tp->max_jumbo_frame_size = rtl_chip_info[tp->chipset].jumbo_frame_sz;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,10,0)
+        /* MTU range: 60 - hw-specific max */
+        dev->min_mtu = ETH_ZLEN;
+        dev->max_mtu = tp->max_jumbo_frame_size;
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(4,10,0)
+        tp->eee_enabled = eee_enable;
+        tp->eee_adv_t = MDIO_EEE_1000T | MDIO_EEE_100TX;
+}
+
+static void
+rtl8125_release_board(struct pci_dev *pdev,
+                      struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        rtl8125_set_bios_setting(dev);
+        rtl8125_rar_set(tp, tp->org_mac_addr);
+        tp->wol_enabled = WOL_DISABLED;
+
+        if (!tp->DASH)
+                rtl8125_phy_power_down(dev);
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH)
+                FreeAllocatedDashShareMemory(dev);
+#endif
+
+        if (tp->mapped_cmac_ioaddr != NULL)
+                iounmap(tp->mapped_cmac_ioaddr);
+
+        iounmap(ioaddr);
+        pci_release_regions(pdev);
+        pci_disable_device(pdev);
+        free_netdev(dev);
+}
+
+static int
+rtl8125_get_mac_address(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int i;
+        u8 mac_addr[MAC_ADDR_LEN];
+
+        for (i = 0; i < MAC_ADDR_LEN; i++)
+                mac_addr[i] = RTL_R8(tp, MAC0 + i);
+
+        if(tp->mcfg == CFG_METHOD_2 ||
+            tp->mcfg == CFG_METHOD_3 ||
+            tp->mcfg == CFG_METHOD_4 ||
+            tp->mcfg == CFG_METHOD_5) {
+                *(u32*)&mac_addr[0] = RTL_R32(tp, BACKUP_ADDR0_8125);
+                *(u16*)&mac_addr[4] = RTL_R16(tp, BACKUP_ADDR1_8125);
+        }
+
+        if (!is_valid_ether_addr(mac_addr)) {
+                netif_err(tp, probe, dev, "Invalid ether addr %pM\n",
+                          mac_addr);
+                eth_hw_addr_random(dev);
+                ether_addr_copy(mac_addr, dev->dev_addr);
+                netif_info(tp, probe, dev, "Random ether addr %pM\n",
+                           mac_addr);
+                tp->random_mac = 1;
+        }
+
+        rtl8125_rar_set(tp, mac_addr);
+
+        for (i = 0; i < MAC_ADDR_LEN; i++) {
+                dev->dev_addr[i] = RTL_R8(tp, MAC0 + i);
+                tp->org_mac_addr[i] = dev->dev_addr[i]; /* keep the original MAC address */
+        }
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+        memcpy(dev->perm_addr, dev->dev_addr, dev->addr_len);
+#endif
+//  memcpy(dev->dev_addr, dev->dev_addr, dev->addr_len);
+
+        return 0;
+}
+
+/**
+ * rtl8125_set_mac_address - Change the Ethernet Address of the NIC
+ * @dev: network interface device structure
+ * @p:   pointer to an address structure
+ *
+ * Return 0 on success, negative on failure
+ **/
+static int
+rtl8125_set_mac_address(struct net_device *dev,
+                        void *p)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct sockaddr *addr = p;
+        unsigned long flags;
+
+        if (!is_valid_ether_addr(addr->sa_data))
+                return -EADDRNOTAVAIL;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        memcpy(dev->dev_addr, addr->sa_data, dev->addr_len);
+
+        rtl8125_rar_set(tp, dev->dev_addr);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return 0;
+}
+
+/******************************************************************************
+ * rtl8125_rar_set - Puts an ethernet address into a receive address register.
+ *
+ * tp - The private data structure for driver
+ * addr - Address to put into receive address register
+ *****************************************************************************/
+void
+rtl8125_rar_set(struct rtl8125_private *tp,
+                uint8_t *addr)
+{
+        uint32_t rar_low = 0;
+        uint32_t rar_high = 0;
+
+        rar_low = ((uint32_t) addr[0] |
+                   ((uint32_t) addr[1] << 8) |
+                   ((uint32_t) addr[2] << 16) |
+                   ((uint32_t) addr[3] << 24));
+
+        rar_high = ((uint32_t) addr[4] |
+                    ((uint32_t) addr[5] << 8));
+
+        rtl8125_enable_cfg9346_write(tp);
+        RTL_W32(tp, MAC0, rar_low);
+        RTL_W32(tp, MAC4, rar_high);
+
+        rtl8125_disable_cfg9346_write(tp);
+}
+
+#ifdef ETHTOOL_OPS_COMPAT
+static int ethtool_get_settings(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_cmd cmd = { ETHTOOL_GSET };
+        int err;
+
+        if (!ethtool_ops->get_settings)
+                return -EOPNOTSUPP;
+
+        err = ethtool_ops->get_settings(dev, &cmd);
+        if (err < 0)
+                return err;
+
+        if (copy_to_user(useraddr, &cmd, sizeof(cmd)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_settings(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_cmd cmd;
+
+        if (!ethtool_ops->set_settings)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&cmd, useraddr, sizeof(cmd)))
+                return -EFAULT;
+
+        return ethtool_ops->set_settings(dev, &cmd);
+}
+
+static int ethtool_get_drvinfo(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_drvinfo info;
+        struct ethtool_ops *ops = ethtool_ops;
+
+        if (!ops->get_drvinfo)
+                return -EOPNOTSUPP;
+
+        memset(&info, 0, sizeof(info));
+        info.cmd = ETHTOOL_GDRVINFO;
+        ops->get_drvinfo(dev, &info);
+
+        if (ops->self_test_count)
+                info.testinfo_len = ops->self_test_count(dev);
+        if (ops->get_stats_count)
+                info.n_stats = ops->get_stats_count(dev);
+        if (ops->get_regs_len)
+                info.regdump_len = ops->get_regs_len(dev);
+        if (ops->get_eeprom_len)
+                info.eedump_len = ops->get_eeprom_len(dev);
+
+        if (copy_to_user(useraddr, &info, sizeof(info)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_get_regs(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_regs regs;
+        struct ethtool_ops *ops = ethtool_ops;
+        void *regbuf;
+        int reglen, ret;
+
+        if (!ops->get_regs || !ops->get_regs_len)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&regs, useraddr, sizeof(regs)))
+                return -EFAULT;
+
+        reglen = ops->get_regs_len(dev);
+        if (regs.len > reglen)
+                regs.len = reglen;
+
+        regbuf = kmalloc(reglen, GFP_USER);
+        if (!regbuf)
+                return -ENOMEM;
+
+        ops->get_regs(dev, &regs, regbuf);
+
+        ret = -EFAULT;
+        if (copy_to_user(useraddr, &regs, sizeof(regs)))
+                goto out;
+        useraddr += offsetof(struct ethtool_regs, data);
+        if (copy_to_user(useraddr, regbuf, reglen))
+                goto out;
+        ret = 0;
+
+out:
+        kfree(regbuf);
+        return ret;
+}
+
+static int ethtool_get_wol(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_wolinfo wol = { ETHTOOL_GWOL };
+
+        if (!ethtool_ops->get_wol)
+                return -EOPNOTSUPP;
+
+        ethtool_ops->get_wol(dev, &wol);
+
+        if (copy_to_user(useraddr, &wol, sizeof(wol)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_wol(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_wolinfo wol;
+
+        if (!ethtool_ops->set_wol)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&wol, useraddr, sizeof(wol)))
+                return -EFAULT;
+
+        return ethtool_ops->set_wol(dev, &wol);
+}
+
+static int ethtool_get_msglevel(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GMSGLVL };
+
+        if (!ethtool_ops->get_msglevel)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_msglevel(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_msglevel(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata;
+
+        if (!ethtool_ops->set_msglevel)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&edata, useraddr, sizeof(edata)))
+                return -EFAULT;
+
+        ethtool_ops->set_msglevel(dev, edata.data);
+        return 0;
+}
+
+static int ethtool_nway_reset(struct net_device *dev)
+{
+        if (!ethtool_ops->nway_reset)
+                return -EOPNOTSUPP;
+
+        return ethtool_ops->nway_reset(dev);
+}
+
+static int ethtool_get_link(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GLINK };
+
+        if (!ethtool_ops->get_link)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_link(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_get_eeprom(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_eeprom eeprom;
+        struct ethtool_ops *ops = ethtool_ops;
+        u8 *data;
+        int ret;
+
+        if (!ops->get_eeprom || !ops->get_eeprom_len)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&eeprom, useraddr, sizeof(eeprom)))
+                return -EFAULT;
+
+        /* Check for wrap and zero */
+        if (eeprom.offset + eeprom.len <= eeprom.offset)
+                return -EINVAL;
+
+        /* Check for exceeding total eeprom len */
+        if (eeprom.offset + eeprom.len > ops->get_eeprom_len(dev))
+                return -EINVAL;
+
+        data = kmalloc(eeprom.len, GFP_USER);
+        if (!data)
+                return -ENOMEM;
+
+        ret = -EFAULT;
+        if (copy_from_user(data, useraddr + sizeof(eeprom), eeprom.len))
+                goto out;
+
+        ret = ops->get_eeprom(dev, &eeprom, data);
+        if (ret)
+                goto out;
+
+        ret = -EFAULT;
+        if (copy_to_user(useraddr, &eeprom, sizeof(eeprom)))
+                goto out;
+        if (copy_to_user(useraddr + sizeof(eeprom), data, eeprom.len))
+                goto out;
+        ret = 0;
+
+out:
+        kfree(data);
+        return ret;
+}
+
+static int ethtool_set_eeprom(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_eeprom eeprom;
+        struct ethtool_ops *ops = ethtool_ops;
+        u8 *data;
+        int ret;
+
+        if (!ops->set_eeprom || !ops->get_eeprom_len)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&eeprom, useraddr, sizeof(eeprom)))
+                return -EFAULT;
+
+        /* Check for wrap and zero */
+        if (eeprom.offset + eeprom.len <= eeprom.offset)
+                return -EINVAL;
+
+        /* Check for exceeding total eeprom len */
+        if (eeprom.offset + eeprom.len > ops->get_eeprom_len(dev))
+                return -EINVAL;
+
+        data = kmalloc(eeprom.len, GFP_USER);
+        if (!data)
+                return -ENOMEM;
+
+        ret = -EFAULT;
+        if (copy_from_user(data, useraddr + sizeof(eeprom), eeprom.len))
+                goto out;
+
+        ret = ops->set_eeprom(dev, &eeprom, data);
+        if (ret)
+                goto out;
+
+        if (copy_to_user(useraddr + sizeof(eeprom), data, eeprom.len))
+                ret = -EFAULT;
+
+out:
+        kfree(data);
+        return ret;
+}
+
+static int ethtool_get_coalesce(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_coalesce coalesce = { ETHTOOL_GCOALESCE };
+
+        if (!ethtool_ops->get_coalesce)
+                return -EOPNOTSUPP;
+
+        ethtool_ops->get_coalesce(dev, &coalesce);
+
+        if (copy_to_user(useraddr, &coalesce, sizeof(coalesce)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_coalesce(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_coalesce coalesce;
+
+        if (!ethtool_ops->get_coalesce)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&coalesce, useraddr, sizeof(coalesce)))
+                return -EFAULT;
+
+        return ethtool_ops->set_coalesce(dev, &coalesce);
+}
+
+static int ethtool_get_ringparam(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_ringparam ringparam = { ETHTOOL_GRINGPARAM };
+
+        if (!ethtool_ops->get_ringparam)
+                return -EOPNOTSUPP;
+
+        ethtool_ops->get_ringparam(dev, &ringparam);
+
+        if (copy_to_user(useraddr, &ringparam, sizeof(ringparam)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_ringparam(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_ringparam ringparam;
+
+        if (!ethtool_ops->get_ringparam)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&ringparam, useraddr, sizeof(ringparam)))
+                return -EFAULT;
+
+        return ethtool_ops->set_ringparam(dev, &ringparam);
+}
+
+static int ethtool_get_pauseparam(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_pauseparam pauseparam = { ETHTOOL_GPAUSEPARAM };
+
+        if (!ethtool_ops->get_pauseparam)
+                return -EOPNOTSUPP;
+
+        ethtool_ops->get_pauseparam(dev, &pauseparam);
+
+        if (copy_to_user(useraddr, &pauseparam, sizeof(pauseparam)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_pauseparam(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_pauseparam pauseparam;
+
+        if (!ethtool_ops->get_pauseparam)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&pauseparam, useraddr, sizeof(pauseparam)))
+                return -EFAULT;
+
+        return ethtool_ops->set_pauseparam(dev, &pauseparam);
+}
+
+static int ethtool_get_rx_csum(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GRXCSUM };
+
+        if (!ethtool_ops->get_rx_csum)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_rx_csum(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_rx_csum(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata;
+
+        if (!ethtool_ops->set_rx_csum)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&edata, useraddr, sizeof(edata)))
+                return -EFAULT;
+
+        ethtool_ops->set_rx_csum(dev, edata.data);
+        return 0;
+}
+
+static int ethtool_get_tx_csum(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GTXCSUM };
+
+        if (!ethtool_ops->get_tx_csum)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_tx_csum(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_tx_csum(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata;
+
+        if (!ethtool_ops->set_tx_csum)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&edata, useraddr, sizeof(edata)))
+                return -EFAULT;
+
+        return ethtool_ops->set_tx_csum(dev, edata.data);
+}
+
+static int ethtool_get_sg(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GSG };
+
+        if (!ethtool_ops->get_sg)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_sg(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_sg(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata;
+
+        if (!ethtool_ops->set_sg)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&edata, useraddr, sizeof(edata)))
+                return -EFAULT;
+
+        return ethtool_ops->set_sg(dev, edata.data);
+}
+
+static int ethtool_get_tso(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GTSO };
+
+        if (!ethtool_ops->get_tso)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_tso(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_tso(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata;
+
+        if (!ethtool_ops->set_tso)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&edata, useraddr, sizeof(edata)))
+                return -EFAULT;
+
+        return ethtool_ops->set_tso(dev, edata.data);
+}
+
+static int ethtool_self_test(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_test test;
+        struct ethtool_ops *ops = ethtool_ops;
+        u64 *data;
+        int ret;
+
+        if (!ops->self_test || !ops->self_test_count)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&test, useraddr, sizeof(test)))
+                return -EFAULT;
+
+        test.len = ops->self_test_count(dev);
+        data = kmalloc(test.len * sizeof(u64), GFP_USER);
+        if (!data)
+                return -ENOMEM;
+
+        ops->self_test(dev, &test, data);
+
+        ret = -EFAULT;
+        if (copy_to_user(useraddr, &test, sizeof(test)))
+                goto out;
+        useraddr += sizeof(test);
+        if (copy_to_user(useraddr, data, test.len * sizeof(u64)))
+                goto out;
+        ret = 0;
+
+out:
+        kfree(data);
+        return ret;
+}
+
+static int ethtool_get_strings(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_gstrings gstrings;
+        struct ethtool_ops *ops = ethtool_ops;
+        u8 *data;
+        int ret;
+
+        if (!ops->get_strings)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&gstrings, useraddr, sizeof(gstrings)))
+                return -EFAULT;
+
+        switch (gstrings.string_set) {
+        case ETH_SS_TEST:
+                if (!ops->self_test_count)
+                        return -EOPNOTSUPP;
+                gstrings.len = ops->self_test_count(dev);
+                break;
+        case ETH_SS_STATS:
+                if (!ops->get_stats_count)
+                        return -EOPNOTSUPP;
+                gstrings.len = ops->get_stats_count(dev);
+                break;
+        default:
+                return -EINVAL;
+        }
+
+        data = kmalloc(gstrings.len * ETH_GSTRING_LEN, GFP_USER);
+        if (!data)
+                return -ENOMEM;
+
+        ops->get_strings(dev, gstrings.string_set, data);
+
+        ret = -EFAULT;
+        if (copy_to_user(useraddr, &gstrings, sizeof(gstrings)))
+                goto out;
+        useraddr += sizeof(gstrings);
+        if (copy_to_user(useraddr, data, gstrings.len * ETH_GSTRING_LEN))
+                goto out;
+        ret = 0;
+
+out:
+        kfree(data);
+        return ret;
+}
+
+static int ethtool_phys_id(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_value id;
+
+        if (!ethtool_ops->phys_id)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&id, useraddr, sizeof(id)))
+                return -EFAULT;
+
+        return ethtool_ops->phys_id(dev, id.data);
+}
+
+static int ethtool_get_stats(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_stats stats;
+        struct ethtool_ops *ops = ethtool_ops;
+        u64 *data;
+        int ret;
+
+        if (!ops->get_ethtool_stats || !ops->get_stats_count)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&stats, useraddr, sizeof(stats)))
+                return -EFAULT;
+
+        stats.n_stats = ops->get_stats_count(dev);
+        data = kmalloc(stats.n_stats * sizeof(u64), GFP_USER);
+        if (!data)
+                return -ENOMEM;
+
+        ops->get_ethtool_stats(dev, &stats, data);
+
+        ret = -EFAULT;
+        if (copy_to_user(useraddr, &stats, sizeof(stats)))
+                goto out;
+        useraddr += sizeof(stats);
+        if (copy_to_user(useraddr, data, stats.n_stats * sizeof(u64)))
+                goto out;
+        ret = 0;
+
+out:
+        kfree(data);
+        return ret;
+}
+
+static int ethtool_ioctl(struct ifreq *ifr)
+{
+        struct net_device *dev = __dev_get_by_name(ifr->ifr_name);
+        void *useraddr = (void *) ifr->ifr_data;
+        u32 ethcmd;
+
+        /*
+         * XXX: This can be pushed down into the ethtool_* handlers that
+         * need it.  Keep existing behaviour for the moment.
+         */
+        if (!capable(CAP_NET_ADMIN))
+                return -EPERM;
+
+        if (!dev || !netif_device_present(dev))
+                return -ENODEV;
+
+        if (copy_from_user(&ethcmd, useraddr, sizeof (ethcmd)))
+                return -EFAULT;
+
+        switch (ethcmd) {
+        case ETHTOOL_GSET:
+                return ethtool_get_settings(dev, useraddr);
+        case ETHTOOL_SSET:
+                return ethtool_set_settings(dev, useraddr);
+        case ETHTOOL_GDRVINFO:
+                return ethtool_get_drvinfo(dev, useraddr);
+        case ETHTOOL_GREGS:
+                return ethtool_get_regs(dev, useraddr);
+        case ETHTOOL_GWOL:
+                return ethtool_get_wol(dev, useraddr);
+        case ETHTOOL_SWOL:
+                return ethtool_set_wol(dev, useraddr);
+        case ETHTOOL_GMSGLVL:
+                return ethtool_get_msglevel(dev, useraddr);
+        case ETHTOOL_SMSGLVL:
+                return ethtool_set_msglevel(dev, useraddr);
+        case ETHTOOL_NWAY_RST:
+                return ethtool_nway_reset(dev);
+        case ETHTOOL_GLINK:
+                return ethtool_get_link(dev, useraddr);
+        case ETHTOOL_GEEPROM:
+                return ethtool_get_eeprom(dev, useraddr);
+        case ETHTOOL_SEEPROM:
+                return ethtool_set_eeprom(dev, useraddr);
+        case ETHTOOL_GCOALESCE:
+                return ethtool_get_coalesce(dev, useraddr);
+        case ETHTOOL_SCOALESCE:
+                return ethtool_set_coalesce(dev, useraddr);
+        case ETHTOOL_GRINGPARAM:
+                return ethtool_get_ringparam(dev, useraddr);
+        case ETHTOOL_SRINGPARAM:
+                return ethtool_set_ringparam(dev, useraddr);
+        case ETHTOOL_GPAUSEPARAM:
+                return ethtool_get_pauseparam(dev, useraddr);
+        case ETHTOOL_SPAUSEPARAM:
+                return ethtool_set_pauseparam(dev, useraddr);
+        case ETHTOOL_GRXCSUM:
+                return ethtool_get_rx_csum(dev, useraddr);
+        case ETHTOOL_SRXCSUM:
+                return ethtool_set_rx_csum(dev, useraddr);
+        case ETHTOOL_GTXCSUM:
+                return ethtool_get_tx_csum(dev, useraddr);
+        case ETHTOOL_STXCSUM:
+                return ethtool_set_tx_csum(dev, useraddr);
+        case ETHTOOL_GSG:
+                return ethtool_get_sg(dev, useraddr);
+        case ETHTOOL_SSG:
+                return ethtool_set_sg(dev, useraddr);
+        case ETHTOOL_GTSO:
+                return ethtool_get_tso(dev, useraddr);
+        case ETHTOOL_STSO:
+                return ethtool_set_tso(dev, useraddr);
+        case ETHTOOL_TEST:
+                return ethtool_self_test(dev, useraddr);
+        case ETHTOOL_GSTRINGS:
+                return ethtool_get_strings(dev, useraddr);
+        case ETHTOOL_PHYS_ID:
+                return ethtool_phys_id(dev, useraddr);
+        case ETHTOOL_GSTATS:
+                return ethtool_get_stats(dev, useraddr);
+        default:
+                return -EOPNOTSUPP;
+        }
+
+        return -EOPNOTSUPP;
+}
+#endif //ETHTOOL_OPS_COMPAT
+
+static int
+rtl8125_do_ioctl(struct net_device *dev,
+                 struct ifreq *ifr,
+                 int cmd)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct mii_ioctl_data *data = if_mii(ifr);
+        int ret;
+        unsigned long flags;
+
+        ret = 0;
+        switch (cmd) {
+        case SIOCGMIIPHY:
+                data->phy_id = 32; /* Internal PHY */
+                break;
+
+        case SIOCGMIIREG:
+                spin_lock_irqsave(&tp->lock, flags);
+                rtl8125_mdio_write(tp, 0x1F, 0x0000);
+                data->val_out = rtl8125_mdio_read(tp, data->reg_num);
+                spin_unlock_irqrestore(&tp->lock, flags);
+                break;
+
+        case SIOCSMIIREG:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+                spin_lock_irqsave(&tp->lock, flags);
+                rtl8125_mdio_write(tp, 0x1F, 0x0000);
+                rtl8125_mdio_write(tp, data->reg_num, data->val_in);
+                spin_unlock_irqrestore(&tp->lock, flags);
+                break;
+
+#ifdef ETHTOOL_OPS_COMPAT
+        case SIOCETHTOOL:
+                ret = ethtool_ioctl(ifr);
+                break;
+#endif
+
+#ifdef ENABLE_DASH_SUPPORT
+        case SIOCDEVPRIVATE_RTLDASH:
+                if (!netif_running(dev)) {
+                        ret = -ENODEV;
+                        break;
+                }
+                if (!capable(CAP_NET_ADMIN)) {
+                        ret = -EPERM;
+                        break;
+                }
+
+                ret = rtl8125_dash_ioctl(dev, ifr);
+                break;
+#endif
+
+#ifdef ENABLE_REALWOW_SUPPORT
+        case SIOCDEVPRIVATE_RTLREALWOW:
+                if (!netif_running(dev)) {
+                        ret = -ENODEV;
+                        break;
+                }
+
+                ret = rtl8125_realwow_ioctl(dev, ifr);
+                break;
+#endif
+
+        case SIOCRTLTOOL:
+                ret = rtl8125_tool_ioctl(tp, ifr);
+                break;
+
+        default:
+                ret = -EOPNOTSUPP;
+                break;
+        }
+
+        return ret;
+}
+
+static void
+rtl8125_phy_power_up(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        if (rtl8125_is_in_phy_disable_mode(dev)) {
+                return;
+        }
+
+        rtl8125_mdio_write(tp, 0x1F, 0x0000);
+        rtl8125_mdio_write(tp, MII_BMCR, BMCR_ANENABLE);
+
+        //wait ups resume (phy state 3)
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_wait_phy_ups_resume(dev, 3);
+                break;
+        };
+}
+
+static void
+rtl8125_phy_power_down(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        rtl8125_mdio_write(tp, 0x1F, 0x0000);
+        rtl8125_mdio_write(tp, MII_BMCR, BMCR_ANENABLE | BMCR_PDOWN);
+}
+
+static int __devinit
+rtl8125_init_board(struct pci_dev *pdev,
+                   struct net_device **dev_out,
+                   void __iomem **ioaddr_out)
+{
+        void __iomem *ioaddr;
+        struct net_device *dev;
+        struct rtl8125_private *tp;
+        int rc = -ENOMEM, i, pm_cap;
+
+        assert(ioaddr_out != NULL);
+
+        /* dev zeroed in alloc_etherdev */
+        dev = alloc_etherdev(sizeof (*tp));
+        if (dev == NULL) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_drv(&debug))
+                        dev_err(&pdev->dev, "unable to alloc new ethernet\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                goto err_out;
+        }
+
+        SET_MODULE_OWNER(dev);
+        SET_NETDEV_DEV(dev, &pdev->dev);
+        tp = netdev_priv(dev);
+        tp->dev = dev;
+        tp->msg_enable = netif_msg_init(debug.msg_enable, R8125_MSG_DEFAULT);
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,26)
+        if (!aspm)
+                pci_disable_link_state(pdev, PCIE_LINK_STATE_L0S | PCIE_LINK_STATE_L1 |
+                                       PCIE_LINK_STATE_CLKPM);
+#endif
+
+        /* enable device (incl. PCI PM wakeup and hotplug setup) */
+        rc = pci_enable_device(pdev);
+        if (rc < 0) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_err(&pdev->dev, "enable failure\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                goto err_out_free_dev;
+        }
+
+        rc = pci_set_mwi(pdev);
+        if (rc < 0)
+                goto err_out_disable;
+
+        /* save power state before pci_enable_device overwrites it */
+        pm_cap = pci_find_capability(pdev, PCI_CAP_ID_PM);
+        if (pm_cap) {
+                u16 pwr_command;
+
+                pci_read_config_word(pdev, pm_cap + PCI_PM_CTRL, &pwr_command);
+        } else {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp)) {
+                        dev_err(&pdev->dev, "PowerManagement capability not found.\n");
+                }
+#else
+                printk("PowerManagement capability not found.\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+
+        }
+
+        /* make sure PCI base addr 1 is MMIO */
+        if (!(pci_resource_flags(pdev, 2) & IORESOURCE_MEM)) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_err(&pdev->dev, "region #1 not an MMIO resource, aborting\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                rc = -ENODEV;
+                goto err_out_mwi;
+        }
+        /* check for weird/broken PCI region reporting */
+        if (pci_resource_len(pdev, 2) < R8125_REGS_SIZE) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_err(&pdev->dev, "Invalid PCI region size(s), aborting\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                rc = -ENODEV;
+                goto err_out_mwi;
+        }
+
+        rc = pci_request_regions(pdev, MODULENAME);
+        if (rc < 0) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_err(&pdev->dev, "could not request regions.\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                goto err_out_mwi;
+        }
+
+        if ((sizeof(dma_addr_t) > 4) &&
+            use_dac &&
+            !pci_set_dma_mask(pdev, DMA_BIT_MASK(64)) &&
+            !pci_set_consistent_dma_mask(pdev, DMA_BIT_MASK(64))) {
+                dev->features |= NETIF_F_HIGHDMA;
+        } else {
+                rc = pci_set_dma_mask(pdev, DMA_BIT_MASK(32));
+                if (rc < 0) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                        if (netif_msg_probe(tp))
+                                dev_err(&pdev->dev, "DMA configuration failed.\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                        goto err_out_free_res;
+                }
+        }
+
+        pci_set_master(pdev);
+
+        /* ioremap MMIO region */
+        ioaddr = ioremap(pci_resource_start(pdev, 2), pci_resource_len(pdev, 2));
+        if (ioaddr == NULL) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_err(&pdev->dev, "cannot remap MMIO, aborting\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                rc = -EIO;
+                goto err_out_free_res;
+        }
+
+        tp->mmio_addr = ioaddr;
+
+        /* Identify chip attached to board */
+        rtl8125_get_mac_version(tp);
+
+        rtl8125_print_mac_version(tp);
+
+        for (i = ARRAY_SIZE(rtl_chip_info) - 1; i >= 0; i--) {
+                if (tp->mcfg == rtl_chip_info[i].mcfg)
+                        break;
+        }
+
+        if (i < 0) {
+                /* Unknown chip: assume array element #0, original RTL-8125 */
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_printk(KERN_DEBUG, &pdev->dev, "unknown chip version, assuming %s\n", rtl_chip_info[0].name);
+#else
+                printk("Realtek unknown chip version, assuming %s\n", rtl_chip_info[0].name);
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+                i++;
+        }
+
+        tp->chipset = i;
+
+        *ioaddr_out = ioaddr;
+        *dev_out = dev;
+out:
+        return rc;
+
+err_out_free_res:
+        pci_release_regions(pdev);
+
+err_out_mwi:
+        pci_clear_mwi(pdev);
+
+err_out_disable:
+        pci_disable_device(pdev);
+
+err_out_free_dev:
+        free_netdev(dev);
+err_out:
+        *ioaddr_out = NULL;
+        *dev_out = NULL;
+        goto out;
+}
+
+static void
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+rtl8125_esd_timer(unsigned long __opaque)
+#else
+rtl8125_esd_timer(struct timer_list *t)
+#endif
+{
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+        struct net_device *dev = (struct net_device *)__opaque;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct timer_list *timer = &tp->esd_timer;
+#else
+        struct rtl8125_private *tp = from_timer(tp, t, esd_timer);
+        struct net_device *dev = tp->dev;
+        struct timer_list *timer = t;
+#endif
+        struct pci_dev *pdev = tp->pci_dev;
+        unsigned long timeout = RTL8125_ESD_TIMEOUT;
+        unsigned long flags;
+        u8 cmd;
+        u16 io_base_l;
+        u16 mem_base_l;
+        u16 mem_base_h;
+        u8 ilr;
+        u16 resv_0x1c_h;
+        u16 resv_0x1c_l;
+        u16 resv_0x20_l;
+        u16 resv_0x20_h;
+        u16 resv_0x24_l;
+        u16 resv_0x24_h;
+        u16 resv_0x2c_h;
+        u16 resv_0x2c_l;
+        u32 pci_sn_l;
+        u32 pci_sn_h;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        tp->esd_flag = 0;
+
+        pci_read_config_byte(pdev, PCI_COMMAND, &cmd);
+        if (cmd != tp->pci_cfg_space.cmd) {
+                printk(KERN_ERR "%s: cmd = 0x%02x, should be 0x%02x \n.", dev->name, cmd, tp->pci_cfg_space.cmd);
+                pci_write_config_byte(pdev, PCI_COMMAND, tp->pci_cfg_space.cmd);
+                tp->esd_flag |= BIT_0;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_0, &io_base_l);
+        if (io_base_l != tp->pci_cfg_space.io_base_l) {
+                printk(KERN_ERR "%s: io_base_l = 0x%04x, should be 0x%04x \n.", dev->name, io_base_l, tp->pci_cfg_space.io_base_l);
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_0, tp->pci_cfg_space.io_base_l);
+                tp->esd_flag |= BIT_1;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_2, &mem_base_l);
+        if (mem_base_l != tp->pci_cfg_space.mem_base_l) {
+                printk(KERN_ERR "%s: mem_base_l = 0x%04x, should be 0x%04x \n.", dev->name, mem_base_l, tp->pci_cfg_space.mem_base_l);
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_2, tp->pci_cfg_space.mem_base_l);
+                tp->esd_flag |= BIT_2;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_2 + 2, &mem_base_h);
+        if (mem_base_h!= tp->pci_cfg_space.mem_base_h) {
+                printk(KERN_ERR "%s: mem_base_h = 0x%04x, should be 0x%04x \n.", dev->name, mem_base_h, tp->pci_cfg_space.mem_base_h);
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_2 + 2, tp->pci_cfg_space.mem_base_h);
+                tp->esd_flag |= BIT_3;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_3, &resv_0x1c_l);
+        if (resv_0x1c_l != tp->pci_cfg_space.resv_0x1c_l) {
+                printk(KERN_ERR "%s: resv_0x1c_l = 0x%04x, should be 0x%04x \n.", dev->name, resv_0x1c_l, tp->pci_cfg_space.resv_0x1c_l);
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_3, tp->pci_cfg_space.resv_0x1c_l);
+                tp->esd_flag |= BIT_4;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_3 + 2, &resv_0x1c_h);
+        if (resv_0x1c_h != tp->pci_cfg_space.resv_0x1c_h) {
+                printk(KERN_ERR "%s: resv_0x1c_h = 0x%04x, should be 0x%04x \n.", dev->name, resv_0x1c_h, tp->pci_cfg_space.resv_0x1c_h);
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_3 + 2, tp->pci_cfg_space.resv_0x1c_h);
+                tp->esd_flag |= BIT_5;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_4, &resv_0x20_l);
+        if (resv_0x20_l != tp->pci_cfg_space.resv_0x20_l) {
+                printk(KERN_ERR "%s: resv_0x20_l = 0x%04x, should be 0x%04x \n.", dev->name, resv_0x20_l, tp->pci_cfg_space.resv_0x20_l);
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_4, tp->pci_cfg_space.resv_0x20_l);
+                tp->esd_flag |= BIT_6;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_4 + 2, &resv_0x20_h);
+        if (resv_0x20_h != tp->pci_cfg_space.resv_0x20_h) {
+                printk(KERN_ERR "%s: resv_0x20_h = 0x%04x, should be 0x%04x \n.", dev->name, resv_0x20_h, tp->pci_cfg_space.resv_0x20_h);
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_4 + 2, tp->pci_cfg_space.resv_0x20_h);
+                tp->esd_flag |= BIT_7;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_5, &resv_0x24_l);
+        if (resv_0x24_l != tp->pci_cfg_space.resv_0x24_l) {
+                printk(KERN_ERR "%s: resv_0x24_l = 0x%04x, should be 0x%04x \n.", dev->name, resv_0x24_l, tp->pci_cfg_space.resv_0x24_l);
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_5, tp->pci_cfg_space.resv_0x24_l);
+                tp->esd_flag |= BIT_8;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_5 + 2, &resv_0x24_h);
+        if (resv_0x24_h != tp->pci_cfg_space.resv_0x24_h) {
+                printk(KERN_ERR "%s: resv_0x24_h = 0x%04x, should be 0x%04x \n.", dev->name, resv_0x24_h, tp->pci_cfg_space.resv_0x24_h);
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_5 + 2, tp->pci_cfg_space.resv_0x24_h);
+                tp->esd_flag |= BIT_9;
+        }
+
+        pci_read_config_byte(pdev, PCI_INTERRUPT_LINE, &ilr);
+        if (ilr != tp->pci_cfg_space.ilr) {
+                printk(KERN_ERR "%s: ilr = 0x%02x, should be 0x%02x \n.", dev->name, ilr, tp->pci_cfg_space.ilr);
+                pci_write_config_byte(pdev, PCI_INTERRUPT_LINE, tp->pci_cfg_space.ilr);
+                tp->esd_flag |= BIT_10;
+        }
+
+        pci_read_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID, &resv_0x2c_l);
+        if (resv_0x2c_l != tp->pci_cfg_space.resv_0x2c_l) {
+                printk(KERN_ERR "%s: resv_0x2c_l = 0x%04x, should be 0x%04x \n.", dev->name, resv_0x2c_l, tp->pci_cfg_space.resv_0x2c_l);
+                pci_write_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID, tp->pci_cfg_space.resv_0x2c_l);
+                tp->esd_flag |= BIT_11;
+        }
+
+        pci_read_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID + 2, &resv_0x2c_h);
+        if (resv_0x2c_h != tp->pci_cfg_space.resv_0x2c_h) {
+                printk(KERN_ERR "%s: resv_0x2c_h = 0x%04x, should be 0x%04x \n.", dev->name, resv_0x2c_h, tp->pci_cfg_space.resv_0x2c_h);
+                pci_write_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID + 2, tp->pci_cfg_space.resv_0x2c_h);
+                tp->esd_flag |= BIT_12;
+        }
+
+        if (tp->HwPcieSNOffset > 0) {
+                pci_sn_l = rtl8125_csi_read(tp, tp->HwPcieSNOffset);
+                if (pci_sn_l != tp->pci_cfg_space.pci_sn_l) {
+                        printk(KERN_ERR "%s: pci_sn_l = 0x%08x, should be 0x%08x \n.", dev->name, pci_sn_l, tp->pci_cfg_space.pci_sn_l);
+                        rtl8125_csi_write(tp, tp->HwPcieSNOffset, tp->pci_cfg_space.pci_sn_l);
+                        tp->esd_flag |= BIT_13;
+                }
+
+                pci_sn_h = rtl8125_csi_read(tp, tp->HwPcieSNOffset + 4);
+                if (pci_sn_h != tp->pci_cfg_space.pci_sn_h) {
+                        printk(KERN_ERR "%s: pci_sn_h = 0x%08x, should be 0x%08x \n.", dev->name, pci_sn_h, tp->pci_cfg_space.pci_sn_h);
+                        rtl8125_csi_write(tp, tp->HwPcieSNOffset + 4, tp->pci_cfg_space.pci_sn_h);
+                        tp->esd_flag |= BIT_14;
+                }
+        }
+
+        if (tp->esd_flag != 0) {
+                printk(KERN_ERR "%s: esd_flag = 0x%04x\n.\n", dev->name, tp->esd_flag);
+                netif_stop_queue(dev);
+                netif_carrier_off(dev);
+                rtl8125_hw_reset(dev);
+                rtl8125_tx_clear(tp);
+                rtl8125_rx_clear(tp);
+                rtl8125_init_ring(dev);
+                rtl8125_hw_init(dev);
+                rtl8125_powerup_pll(dev);
+                rtl8125_hw_ephy_config(dev);
+                rtl8125_hw_phy_config(dev);
+                rtl8125_hw_config(dev);
+                rtl8125_set_speed(dev, tp->autoneg, tp->speed, tp->duplex, tp->advertising);
+                tp->esd_flag = 0;
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        mod_timer(timer, jiffies + timeout);
+}
+
+static void
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+rtl8125_link_timer(unsigned long __opaque)
+#else
+rtl8125_link_timer(struct timer_list *t)
+#endif
+{
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+        struct net_device *dev = (struct net_device *)__opaque;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct timer_list *timer = &tp->link_timer;
+#else
+        struct rtl8125_private *tp = from_timer(tp, t, link_timer);
+        struct net_device *dev = tp->dev;
+        struct timer_list *timer = t;
+#endif
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        rtl8125_check_link_status(dev);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        mod_timer(timer, jiffies + RTL8125_LINK_TIMEOUT);
+}
+
+/* Cfg9346_Unlock assumed. */
+static unsigned rtl8125_try_msi(struct pci_dev *pdev, struct rtl8125_private *tp)
+{
+        unsigned msi = 0;
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+        if (pci_enable_msi(pdev))
+                dev_info(&pdev->dev, "no MSI. Back to INTx.\n");
+        else
+                msi |= RTL_FEATURE_MSI;
+#endif
+
+        return msi;
+}
+
+static void rtl8125_disable_msi(struct pci_dev *pdev, struct rtl8125_private *tp)
+{
+        if (tp->features & RTL_FEATURE_MSI) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+                pci_disable_msi(pdev);
+#endif
+                tp->features &= ~RTL_FEATURE_MSI;
+        }
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,29)
+static const struct net_device_ops rtl8125_netdev_ops = {
+        .ndo_open       = rtl8125_open,
+        .ndo_stop       = rtl8125_close,
+        .ndo_get_stats      = rtl8125_get_stats,
+        .ndo_start_xmit     = rtl8125_start_xmit,
+        .ndo_tx_timeout     = rtl8125_tx_timeout,
+        .ndo_change_mtu     = rtl8125_change_mtu,
+        .ndo_set_mac_address    = rtl8125_set_mac_address,
+        .ndo_do_ioctl       = rtl8125_do_ioctl,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,1,0)
+        .ndo_set_multicast_list = rtl8125_set_rx_mode,
+#else
+        .ndo_set_rx_mode    = rtl8125_set_rx_mode,
+#endif
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+#ifdef CONFIG_R8125_VLAN
+        .ndo_vlan_rx_register   = rtl8125_vlan_rx_register,
+#endif
+#else
+        .ndo_fix_features   = rtl8125_fix_features,
+        .ndo_set_features   = rtl8125_set_features,
+#endif
+#ifdef CONFIG_NET_POLL_CONTROLLER
+        .ndo_poll_controller    = rtl8125_netpoll,
+#endif
+};
+#endif
+
+static int __devinit
+rtl8125_init_one(struct pci_dev *pdev,
+                 const struct pci_device_id *ent)
+{
+        struct net_device *dev = NULL;
+        struct rtl8125_private *tp;
+        void __iomem *ioaddr = NULL;
+        static int board_idx = -1;
+
+        int rc;
+
+        assert(pdev != NULL);
+        assert(ent != NULL);
+
+        board_idx++;
+
+        if (netif_msg_drv(&debug))
+                printk(KERN_INFO "%s 2.5Gigabit Ethernet driver %s loaded\n",
+                       MODULENAME, RTL8125_VERSION);
+
+        rc = rtl8125_init_board(pdev, &dev, &ioaddr);
+        if (rc)
+                goto out;
+
+        tp = netdev_priv(dev);
+        assert(ioaddr != NULL);
+
+        tp->set_speed = rtl8125_set_speed_xmii;
+        tp->get_settings = rtl8125_gset_xmii;
+        tp->phy_reset_enable = rtl8125_xmii_reset_enable;
+        tp->phy_reset_pending = rtl8125_xmii_reset_pending;
+        tp->link_ok = rtl8125_xmii_link_ok;
+
+        tp->features |= rtl8125_try_msi(pdev, tp);
+
+        RTL_NET_DEVICE_OPS(rtl8125_netdev_ops);
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+        SET_ETHTOOL_OPS(dev, &rtl8125_ethtool_ops);
+#endif
+
+        dev->watchdog_timeo = RTL8125_TX_TIMEOUT;
+        dev->irq = pdev->irq;
+        dev->base_addr = (unsigned long) ioaddr;
+
+#ifdef CONFIG_R8125_NAPI
+        RTL_NAPI_CONFIG(dev, tp, rtl8125_poll, R8125_NAPI_WEIGHT);
+#endif
+
+#ifdef CONFIG_R8125_VLAN
+        if (tp->mcfg != CFG_METHOD_DEFAULT) {
+                dev->features |= NETIF_F_HW_VLAN_TX | NETIF_F_HW_VLAN_RX;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+                dev->vlan_rx_kill_vid = rtl8125_vlan_rx_kill_vid;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+        }
+#endif
+
+        tp->cp_cmd |= RTL_R16(tp, CPlusCmd);
+        if (tp->mcfg != CFG_METHOD_DEFAULT) {
+                dev->features |= NETIF_F_IP_CSUM;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+                tp->cp_cmd |= RxChkSum;
+#else
+                dev->features |= NETIF_F_RXCSUM | NETIF_F_SG | NETIF_F_TSO;
+                dev->hw_features = NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |
+                                   NETIF_F_RXCSUM | NETIF_F_HW_VLAN_TX | NETIF_F_HW_VLAN_RX;
+                dev->vlan_features = NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |
+                                     NETIF_F_HIGHDMA;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,15,0)
+                dev->priv_flags |= IFF_LIVE_ADDR_CHANGE;
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(3,15,0)
+                dev->hw_features |= NETIF_F_RXALL;
+                dev->hw_features |= NETIF_F_RXFCS;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,22)
+                dev->hw_features |= NETIF_F_IPV6_CSUM | NETIF_F_TSO6;
+                dev->features |=  NETIF_F_IPV6_CSUM | NETIF_F_TSO6;
+                netif_set_gso_max_size(dev, LSO_64K);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,18,0)
+                dev->gso_max_segs = NIC_MAX_PHYS_BUF_COUNT_LSO2;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,7,0)
+                dev->gso_min_segs = NIC_MIN_PHYS_BUF_COUNT;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(4,7,0)
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(3,18,0)
+
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,22)
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        }
+
+        tp->pci_dev = pdev;
+
+        spin_lock_init(&tp->lock);
+
+        rtl8125_init_software_variable(dev);
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH)
+                AllocateDashShareMemory(dev);
+#endif
+
+        rtl8125_exit_oob(dev);
+
+        rtl8125_hw_init(dev);
+
+        rtl8125_hw_reset(dev);
+
+        /* Get production from EEPROM */
+        rtl8125_eeprom_type(tp);
+
+        if (tp->eeprom_type == EEPROM_TYPE_93C46 || tp->eeprom_type == EEPROM_TYPE_93C56)
+                rtl8125_set_eeprom_sel_low(tp);
+
+        rtl8125_get_mac_address(dev);
+
+        tp->tally_vaddr = dma_alloc_coherent(&pdev->dev, sizeof(*tp->tally_vaddr),
+                                             &tp->tally_paddr, GFP_KERNEL);
+        if (!tp->tally_vaddr) {
+                rc = -ENOMEM;
+                goto err_out;
+        }
+
+        rtl8125_tally_counter_clear(tp);
+
+        pci_set_drvdata(pdev, dev);
+
+        rc = register_netdev(dev);
+        if (rc)
+                goto err_out;
+
+        printk(KERN_INFO "%s: This product is covered by one or more of the following patents: US6,570,884, US6,115,776, and US6,327,625.\n", MODULENAME);
+
+        rtl8125_disable_rxdvgate(dev);
+
+        device_set_wakeup_enable(&pdev->dev, tp->wol_enabled);
+
+        netif_carrier_off(dev);
+
+        printk("%s", GPL_CLAIM);
+
+out:
+        return rc;
+
+err_out:
+        if (tp->tally_vaddr != NULL) {
+                dma_free_coherent(&pdev->dev, sizeof(*tp->tally_vaddr), tp->tally_vaddr,
+                                  tp->tally_paddr);
+
+                tp->tally_vaddr = NULL;
+        }
+#ifdef  CONFIG_R8125_NAPI
+        RTL_NAPI_DEL(tp);
+#endif
+        rtl8125_disable_msi(pdev, tp);
+        rtl8125_release_board(pdev, dev);
+
+        goto out;
+}
+
+static void __devexit
+rtl8125_remove_one(struct pci_dev *pdev)
+{
+        struct net_device *dev = pci_get_drvdata(pdev);
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        assert(dev != NULL);
+        assert(tp != NULL);
+
+#ifdef  CONFIG_R8125_NAPI
+        RTL_NAPI_DEL(tp);
+#endif
+        if (tp->DASH)
+                rtl8125_driver_stop(tp);
+
+        unregister_netdev(dev);
+        rtl8125_disable_msi(pdev, tp);
+#ifdef ENABLE_R8125_PROCFS
+        rtl8125_proc_remove(dev);
+#endif
+        if (tp->tally_vaddr != NULL) {
+                dma_free_coherent(&pdev->dev, sizeof(*tp->tally_vaddr), tp->tally_vaddr, tp->tally_paddr);
+                tp->tally_vaddr = NULL;
+        }
+
+        rtl8125_release_board(pdev, dev);
+        pci_set_drvdata(pdev, NULL);
+}
+
+static void
+rtl8125_set_rxbufsize(struct rtl8125_private *tp,
+                      struct net_device *dev)
+{
+        unsigned int mtu = dev->mtu;
+
+        tp->rx_buf_sz = (mtu > ETH_DATA_LEN) ? mtu + ETH_HLEN + 8 + 1 : RX_BUF_SIZE;
+}
+
+static int rtl8125_open(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+        unsigned long flags;
+        int retval;
+
+        retval = -ENOMEM;
+
+#ifdef ENABLE_R8125_PROCFS
+        rtl8125_proc_init(dev);
+#endif
+        rtl8125_set_rxbufsize(tp, dev);
+        /*
+         * Rx and Tx descriptors needs 256 bytes alignment.
+         * pci_alloc_consistent provides more.
+         */
+        tp->TxDescArray = dma_alloc_coherent(&pdev->dev, R8125_TX_RING_BYTES,
+                                             &tp->TxPhyAddr, GFP_KERNEL);
+        if (!tp->TxDescArray)
+                goto err_free_all_allocated_mem;
+
+        tp->RxDescArray = dma_alloc_coherent(&pdev->dev, R8125_RX_RING_BYTES,
+                                             &tp->RxPhyAddr, GFP_KERNEL);
+        if (!tp->RxDescArray)
+                goto err_free_all_allocated_mem;
+
+        if (tp->UseSwPaddingShortPkt) {
+                tp->ShortPacketEmptyBuffer = dma_alloc_coherent(&pdev->dev, SHORT_PACKET_PADDING_BUF_SIZE,
+                                             &tp->ShortPacketEmptyBufferPhy, GFP_KERNEL);
+                if (!tp->ShortPacketEmptyBuffer)
+                        goto err_free_all_allocated_mem;
+
+                memset(tp->ShortPacketEmptyBuffer, 0x0, SHORT_PACKET_PADDING_BUF_SIZE);
+        }
+
+        retval = rtl8125_init_ring(dev);
+        if (retval < 0)
+                goto err_free_all_allocated_mem;
+
+        if (netif_msg_probe(tp)) {
+                printk(KERN_INFO "%s: 0x%lx, "
+                       "%2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x, "
+                       "IRQ %d\n",
+                       dev->name,
+                       dev->base_addr,
+                       dev->dev_addr[0], dev->dev_addr[1],
+                       dev->dev_addr[2], dev->dev_addr[3],
+                       dev->dev_addr[4], dev->dev_addr[5], dev->irq);
+        }
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+        INIT_WORK(&tp->task, NULL, dev);
+#else
+        INIT_DELAYED_WORK(&tp->task, NULL);
+#endif
+
+#ifdef  CONFIG_R8125_NAPI
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        RTL_NAPI_ENABLE(dev, &tp->napi);
+#endif
+#endif
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8125_exit_oob(dev);
+
+        rtl8125_hw_init(dev);
+
+        rtl8125_hw_reset(dev);
+
+        rtl8125_powerup_pll(dev);
+
+        rtl8125_hw_ephy_config(dev);
+
+        rtl8125_hw_phy_config(dev);
+
+        rtl8125_hw_config(dev);
+
+        rtl8125_set_speed(dev, tp->autoneg, tp->speed, tp->duplex, tp->advertising);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        retval = request_irq(dev->irq, rtl8125_interrupt, (tp->features & RTL_FEATURE_MSI) ? 0 : SA_SHIRQ, dev->name, dev);
+        if (retval<0)
+                goto err_free_all_allocated_mem;
+
+        if (tp->esd_flag == 0)
+                rtl8125_request_esd_timer(dev);
+
+        rtl8125_request_link_timer(dev);
+
+out:
+
+        return retval;
+
+err_free_all_allocated_mem:
+        if (tp->RxDescArray != NULL) {
+                dma_free_coherent(&pdev->dev, R8125_RX_RING_BYTES, tp->RxDescArray,
+                                  tp->RxPhyAddr);
+                tp->RxDescArray = NULL;
+        }
+
+        if (tp->TxDescArray != NULL) {
+                dma_free_coherent(&pdev->dev, R8125_TX_RING_BYTES, tp->TxDescArray,
+                                  tp->TxPhyAddr);
+                tp->TxDescArray = NULL;
+        }
+
+        if (tp->ShortPacketEmptyBuffer != NULL) {
+                dma_free_coherent(&pdev->dev, ETH_ZLEN, tp->ShortPacketEmptyBuffer,
+                                  tp->ShortPacketEmptyBufferPhy);
+                tp->ShortPacketEmptyBuffer = NULL;
+        }
+
+        goto out;
+}
+
+static void
+set_offset70F(struct rtl8125_private *tp, u8 setting)
+{
+        u32 csi_tmp;
+        u32 temp = (u32)setting;
+        temp = temp << 24;
+        /*set PCI configuration space offset 0x70F to setting*/
+        /*When the register offset of PCI configuration space larger than 0xff, use CSI to access it.*/
+
+        csi_tmp = rtl8125_csi_read(tp, 0x70c) & 0x00ffffff;
+        rtl8125_csi_write(tp, 0x70c, csi_tmp | temp);
+}
+
+static void
+set_offset79(struct rtl8125_private *tp, u8 setting)
+{
+        //Set PCI configuration space offset 0x79 to setting
+
+        struct pci_dev *pdev = tp->pci_dev;
+        u8 device_control;
+
+        if (hwoptimize & HW_PATCH_SOC_LAN) return;
+
+        pci_read_config_byte(pdev, 0x79, &device_control);
+        device_control &= ~0x70;
+        device_control |= setting;
+        pci_write_config_byte(pdev, 0x79, device_control);
+}
+
+static void
+rtl8125_hw_set_rx_packet_filter(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u32 mc_filter[2];   /* Multicast hash filter */
+        int rx_mode;
+        u32 tmp = 0;
+
+        if (dev->flags & IFF_PROMISC) {
+                /* Unconditionally log net taps. */
+                if (netif_msg_link(tp))
+                        printk(KERN_NOTICE "%s: Promiscuous mode enabled.\n",
+                               dev->name);
+
+                rx_mode =
+                        AcceptBroadcast | AcceptMulticast | AcceptMyPhys |
+                        AcceptAllPhys;
+                mc_filter[1] = mc_filter[0] = 0xffffffff;
+        } else if ((netdev_mc_count(dev) > multicast_filter_limit)
+                   || (dev->flags & IFF_ALLMULTI)) {
+                /* Too many to filter perfectly -- accept all multicasts. */
+                rx_mode = AcceptBroadcast | AcceptMulticast | AcceptMyPhys;
+                mc_filter[1] = mc_filter[0] = 0xffffffff;
+        } else {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,35)
+                struct dev_mc_list *mclist;
+                unsigned int i;
+
+                rx_mode = AcceptBroadcast | AcceptMyPhys;
+                mc_filter[1] = mc_filter[0] = 0;
+                for (i = 0, mclist = dev->mc_list; mclist && i < dev->mc_count;
+                     i++, mclist = mclist->next) {
+                        int bit_nr = ether_crc(ETH_ALEN, mclist->dmi_addr) >> 26;
+                        mc_filter[bit_nr >> 5] |= 1 << (bit_nr & 31);
+                        rx_mode |= AcceptMulticast;
+                }
+#else
+                struct netdev_hw_addr *ha;
+
+                rx_mode = AcceptBroadcast | AcceptMyPhys;
+                mc_filter[1] = mc_filter[0] = 0;
+                netdev_for_each_mc_addr(ha, dev) {
+                        int bit_nr = ether_crc(ETH_ALEN, ha->addr) >> 26;
+                        mc_filter[bit_nr >> 5] |= 1 << (bit_nr & 31);
+                        rx_mode |= AcceptMulticast;
+                }
+#endif
+        }
+
+        if (dev->features & NETIF_F_RXALL)
+                rx_mode |= (AcceptErr | AcceptRunt);
+
+        tmp = mc_filter[0];
+        mc_filter[0] = swab32(mc_filter[1]);
+        mc_filter[1] = swab32(tmp);
+
+        tp->rtl8125_rx_config = rtl_chip_info[tp->chipset].RCR_Cfg;
+        tmp = tp->rtl8125_rx_config | rx_mode | (RTL_R32(tp, RxConfig) & rtl_chip_info[tp->chipset].RxConfigMask);
+
+        RTL_W32(tp, RxConfig, tmp);
+        RTL_W32(tp, MAR0 + 0, mc_filter[0]);
+        RTL_W32(tp, MAR0 + 4, mc_filter[1]);
+}
+
+static void
+rtl8125_set_rx_mode(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8125_hw_set_rx_packet_filter(dev);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+static void
+rtl8125_hw_config(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+        u16 mac_ocp_data;
+        int i;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        if (dev->mtu > ETH_DATA_LEN) {
+                dev->features &= ~(NETIF_F_IP_CSUM);
+        } else {
+                dev->features |= NETIF_F_IP_CSUM;
+        }
+#endif
+
+        RTL_W32(tp, RxConfig, (RX_DMA_BURST << RxCfgDMAShift));
+
+        rtl8125_hw_reset(dev);
+
+        rtl8125_enable_cfg9346_write(tp);
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                RTL_W8(tp, 0xF1, RTL_R8(tp, 0xF1) & ~BIT_7);
+                RTL_W8(tp, Config2, RTL_R8(tp, Config2) & ~BIT_7);
+                RTL_W8(tp, Config5, RTL_R8(tp, Config5) & ~BIT_0);
+                break;
+        }
+
+        //clear io_rdy_l23
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                RTL_W8(tp, Config3, RTL_R8(tp, Config3) & ~BIT_1);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                //IntMITI_0-IntMITI_31
+                for (i=0xA00; i<0xB00; i+=4)
+                        RTL_W32(tp, i, 0x00000000);
+                break;
+        }
+
+        //keep magic packet only
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xC0B6);
+                mac_ocp_data &= ~(BIT_0);
+                rtl8125_mac_ocp_write(tp, 0xC0B6, mac_ocp_data);
+                break;
+        }
+
+        rtl8125_tally_counter_addr_fill(tp);
+
+        rtl8125_desc_addr_fill(tp);
+
+        /* Set DMA burst size and Interframe Gap Time */
+        RTL_W32(tp, TxConfig, (TX_DMA_BURST_unlimited << TxDMAShift) |
+                (InterFrameGap << TxInterFrameGapShift));
+
+        if (tp->mcfg == CFG_METHOD_2 ||
+            tp->mcfg == CFG_METHOD_3 ||
+            tp->mcfg == CFG_METHOD_4 ||
+            tp->mcfg == CFG_METHOD_5) {
+                set_offset70F(tp, 0x27);
+                set_offset79(tp, 0x50);
+
+                RTL_W16(tp, 0x382, 0x221B);
+
+                RTL_W8(tp, 0x4500, 0x00);
+                RTL_W16(tp, 0x4800, 0x0000);
+
+                RTL_W8(tp, Config1, RTL_R8(tp, Config1) & ~0x10);
+
+                rtl8125_mac_ocp_write(tp, 0xC140, 0xFFFF);
+                rtl8125_mac_ocp_write(tp, 0xC142, 0xFFFF);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xD3E2);
+                mac_ocp_data &= 0xF000;
+                mac_ocp_data |= 0x3A9;
+                rtl8125_mac_ocp_write(tp, 0xD3E2, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xD3E4);
+                mac_ocp_data &= 0xFF00;
+                rtl8125_mac_ocp_write(tp, 0xD3E4, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xE860);
+                mac_ocp_data |= (BIT_7);
+                rtl8125_mac_ocp_write(tp, 0xE860, mac_ocp_data);
+
+                //new tx desc format
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xEB58);
+                mac_ocp_data |= (BIT_0);
+                rtl8125_mac_ocp_write(tp, 0xEB58, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xE614);
+                mac_ocp_data &= ~( BIT_10 | BIT_9 | BIT_8);
+                if (tp->mcfg == CFG_METHOD_4 || tp->mcfg == CFG_METHOD_5) {
+                        mac_ocp_data |= ((2 & 0x07) << 8);
+                } else {
+                        if (tp->DASH && !(rtl8125_csi_fun0_read_byte(tp, 0x79) & BIT_0))
+                                mac_ocp_data |= ((3 & 0x07) << 8);
+                        else
+                                mac_ocp_data |= ((4 & 0x07) << 8);
+                }
+                rtl8125_mac_ocp_write(tp, 0xE614, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xE63E);
+                mac_ocp_data &= ~(BIT_11 | BIT_10);
+                mac_ocp_data |= ((0 & 0x03) << 10);
+                rtl8125_mac_ocp_write(tp, 0xE63E, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xE63E);
+                mac_ocp_data &= ~(BIT_5 | BIT_4);
+                if (tp->mcfg == CFG_METHOD_2 || tp->mcfg == CFG_METHOD_3)
+                        mac_ocp_data |= ((0x02 & 0x03) << 4);
+                rtl8125_mac_ocp_write(tp, 0xE63E, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xC0B4);
+                mac_ocp_data |= (BIT_3|BIT_2);
+                rtl8125_mac_ocp_write(tp, 0xC0B4, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xEB6A);
+                mac_ocp_data &= ~(BIT_7 | BIT_6 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
+                mac_ocp_data |= (BIT_5 | BIT_4 | BIT_1 | BIT_0);
+                rtl8125_mac_ocp_write(tp, 0xEB6A, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xEB50);
+                mac_ocp_data &= ~(BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5);
+                mac_ocp_data |= (BIT_6);
+                rtl8125_mac_ocp_write(tp, 0xEB50, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xE056);
+                mac_ocp_data &= ~(BIT_7 | BIT_6 | BIT_5 | BIT_4);
+                mac_ocp_data |= (BIT_4 | BIT_5);
+                rtl8125_mac_ocp_write(tp, 0xE056, mac_ocp_data);
+
+                RTL_W8(tp, TDFNR, 0x10);
+
+                //RTL_W8(tp, 0xD0, RTL_R8(tp, 0xD0) | BIT_7);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xE040);
+                mac_ocp_data &= ~(BIT_12);
+                rtl8125_mac_ocp_write(tp, 0xE040, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xE0C0);
+                mac_ocp_data &= ~(BIT_14 | BIT_11 | BIT_10 | BIT_9 | BIT_8 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
+                mac_ocp_data |= (BIT_14 | BIT_10 | BIT_1 | BIT_0);
+                rtl8125_mac_ocp_write(tp, 0xE0C0, mac_ocp_data);
+
+                SetMcuAccessRegBit(tp, 0xE052, (BIT_6|BIT_5|BIT_3));
+                ClearMcuAccessRegBit(tp, 0xE052, BIT_7);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xC0AC);
+                mac_ocp_data &= ~(BIT_7);
+                mac_ocp_data |= (BIT_8|BIT_9|BIT_10|BIT_11|BIT_12);
+                rtl8125_mac_ocp_write(tp, 0xC0AC, mac_ocp_data);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xD430);
+                mac_ocp_data &= ~(BIT_11 | BIT_10 | BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
+                mac_ocp_data |= 0x47F;
+                rtl8125_mac_ocp_write(tp, 0xD430, mac_ocp_data);
+
+                //rtl8125_mac_ocp_write(tp, 0xE0C0, 0x4F87);
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xE84C);
+                mac_ocp_data |= (BIT_7 | BIT_6);
+                rtl8125_mac_ocp_write(tp, 0xE84C, mac_ocp_data);
+
+                RTL_W8(tp, 0xD0, RTL_R8(tp, 0xD0) | BIT_6);
+
+                rtl8125_disable_eee_plus(tp);
+
+                mac_ocp_data = rtl8125_mac_ocp_read(tp, 0xEA1C);
+                mac_ocp_data &= ~(BIT_2);
+                rtl8125_mac_ocp_write(tp, 0xEA1C, mac_ocp_data);
+
+                SetMcuAccessRegBit(tp, 0xEB54, BIT_0);
+                udelay(1);
+                ClearMcuAccessRegBit(tp, 0xEB54, BIT_0);
+                RTL_W16(tp, 0x1880, RTL_R16(tp, 0x1880)&~(BIT_4 | BIT_5));
+        }
+
+        /* csum offload command for RTL8125 */
+        tp->tx_tcp_csum_cmd = TxTCPCS_C;
+        tp->tx_udp_csum_cmd = TxUDPCS_C;
+        tp->tx_ip_csum_cmd = TxIPCS_C;
+        tp->tx_ipv6_csum_cmd = TxIPV6F_C;
+
+
+        //other hw parameters
+        rtl8125_hw_clear_timer_int(dev);
+
+        rtl8125_hw_clear_int_miti(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                rtl8125_mac_ocp_write(tp, 0xE098, 0xC302);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                if (aspm) {
+                        rtl8125_init_pci_offset_99(tp);
+                }
+                break;
+        }
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                if (aspm) {
+                        rtl8125_init_pci_offset_180(tp);
+                }
+                break;
+        }
+
+        tp->cp_cmd &= ~(EnableBist | Macdbgo_oe | Force_halfdup |
+                        Force_rxflow_en | Force_txflow_en | Cxpl_dbg_sel |
+                        ASF | Macdbgo_sel);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        RTL_W16(tp, CPlusCmd, tp->cp_cmd);
+#else
+        rtl8125_hw_set_features(dev, dev->features);
+#endif
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5: {
+                int timeout;
+                for (timeout = 0; timeout < 10; timeout++) {
+                        if ((rtl8125_mac_ocp_read(tp, 0xE00E) & BIT_13)==0)
+                                break;
+                        mdelay(1);
+                }
+        }
+        break;
+        }
+
+        RTL_W16(tp, RxMaxSize, tp->rx_buf_sz);
+
+        rtl8125_disable_rxdvgate(dev);
+
+        if (!tp->pci_cfg_is_read) {
+                pci_read_config_byte(pdev, PCI_COMMAND, &tp->pci_cfg_space.cmd);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_0, &tp->pci_cfg_space.io_base_l);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_0 + 2, &tp->pci_cfg_space.io_base_h);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_2, &tp->pci_cfg_space.mem_base_l);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_2 + 2, &tp->pci_cfg_space.mem_base_h);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_3, &tp->pci_cfg_space.resv_0x1c_l);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_3 + 2, &tp->pci_cfg_space.resv_0x1c_h);
+                pci_read_config_byte(pdev, PCI_INTERRUPT_LINE, &tp->pci_cfg_space.ilr);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_4, &tp->pci_cfg_space.resv_0x20_l);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_4 + 2, &tp->pci_cfg_space.resv_0x20_h);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_5, &tp->pci_cfg_space.resv_0x24_l);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_5 + 2, &tp->pci_cfg_space.resv_0x24_h);
+                pci_read_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID, &tp->pci_cfg_space.resv_0x2c_l);
+                pci_read_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID + 2, &tp->pci_cfg_space.resv_0x2c_h);
+                if (tp->HwPcieSNOffset > 0) {
+                        tp->pci_cfg_space.pci_sn_l = rtl8125_csi_read(tp, tp->HwPcieSNOffset);
+                        tp->pci_cfg_space.pci_sn_h = rtl8125_csi_read(tp, tp->HwPcieSNOffset + 4);
+                }
+
+                tp->pci_cfg_is_read = 1;
+        }
+
+        /* Set Rx packet filter */
+        rtl8125_hw_set_rx_packet_filter(dev);
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH && !tp->dash_printer_enabled)
+                NICChkTypeEnableDashInterrupt(tp);
+#endif
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+                if (aspm) {
+                        RTL_W8(tp, Config5, RTL_R8(tp, Config5) | BIT_0);
+                        RTL_W8(tp, Config2, RTL_R8(tp, Config2) | BIT_7);
+                } else {
+                        RTL_W8(tp, Config2, RTL_R8(tp, Config2) & ~BIT_7);
+                        RTL_W8(tp, Config5, RTL_R8(tp, Config5) & ~BIT_0);
+                }
+                break;
+        }
+
+        rtl8125_disable_cfg9346_write(tp);
+
+        udelay(10);
+}
+
+static void
+rtl8125_hw_start(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        RTL_W8(tp, ChipCmd, CmdTxEnb | CmdRxEnb);
+
+        rtl8125_enable_hw_interrupt(tp);
+}
+
+
+static int
+rtl8125_change_mtu(struct net_device *dev,
+                   int new_mtu)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        int ret = 0;
+        unsigned long flags;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,10,0)
+        if (new_mtu < ETH_ZLEN)
+                return -EINVAL;
+        else if (new_mtu > tp->max_jumbo_frame_size)
+                new_mtu = tp->max_jumbo_frame_size;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(4,10,0)
+
+        spin_lock_irqsave(&tp->lock, flags);
+        dev->mtu = new_mtu;
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        if (!netif_running(dev))
+                goto out;
+
+        rtl8125_down(dev);
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8125_set_rxbufsize(tp, dev);
+
+        ret = rtl8125_init_ring(dev);
+
+        if (ret < 0) {
+                spin_unlock_irqrestore(&tp->lock, flags);
+                goto err_out;
+        }
+
+#ifdef CONFIG_R8125_NAPI
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        RTL_NAPI_ENABLE(dev, &tp->napi);
+#endif
+#endif//CONFIG_R8125_NAPI
+
+        netif_stop_queue(dev);
+        netif_carrier_off(dev);
+        rtl8125_hw_config(dev);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        rtl8125_set_speed(dev, tp->autoneg, tp->speed, tp->duplex, tp->advertising);
+
+        mod_timer(&tp->esd_timer, jiffies + RTL8125_ESD_TIMEOUT);
+        mod_timer(&tp->link_timer, jiffies + RTL8125_LINK_TIMEOUT);
+out:
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,0,0)
+        netdev_update_features(dev);
+#endif
+
+err_out:
+        return ret;
+}
+
+static inline void
+rtl8125_make_unusable_by_asic(struct RxDesc *desc)
+{
+        desc->addr = 0x0badbadbadbadbadull;
+        desc->opts1 &= ~cpu_to_le32(DescOwn | RsvdMask);
+}
+
+static void
+rtl8125_free_rx_skb(struct rtl8125_private *tp,
+                    struct sk_buff **sk_buff,
+                    struct RxDesc *desc)
+{
+        struct pci_dev *pdev = tp->pci_dev;
+
+        pci_unmap_single(pdev, le64_to_cpu(desc->addr), tp->rx_buf_sz,
+                         PCI_DMA_FROMDEVICE);
+        dev_kfree_skb(*sk_buff);
+        *sk_buff = NULL;
+        rtl8125_make_unusable_by_asic(desc);
+}
+
+static inline void
+rtl8125_mark_to_asic(struct RxDesc *desc,
+                     u32 rx_buf_sz)
+{
+        u32 eor = le32_to_cpu(desc->opts1) & RingEnd;
+
+        desc->opts1 = cpu_to_le32(DescOwn | eor | rx_buf_sz);
+}
+
+static inline void
+rtl8125_map_to_asic(struct RxDesc *desc,
+                    dma_addr_t mapping,
+                    u32 rx_buf_sz)
+{
+        desc->addr = cpu_to_le64(mapping);
+        wmb();
+        rtl8125_mark_to_asic(desc, rx_buf_sz);
+}
+
+static int
+rtl8125_alloc_rx_skb(struct rtl8125_private *tp,
+                     struct sk_buff **sk_buff,
+                     struct RxDesc *desc,
+                     int rx_buf_sz,
+                     u8 in_intr)
+{
+        struct sk_buff *skb;
+        dma_addr_t mapping;
+        int ret = 0;
+
+        if (in_intr)
+                skb = RTL_ALLOC_SKB_INTR(tp, rx_buf_sz + RTK_RX_ALIGN);
+        else
+                skb = dev_alloc_skb(rx_buf_sz + RTK_RX_ALIGN);
+
+        if (unlikely(!skb))
+                goto err_out;
+
+        skb_reserve(skb, RTK_RX_ALIGN);
+
+        mapping = pci_map_single(tp->pci_dev, skb->data, rx_buf_sz,
+                                 PCI_DMA_FROMDEVICE);
+        if (unlikely(dma_mapping_error(&tp->pci_dev->dev, mapping))) {
+                if (unlikely(net_ratelimit()))
+                        netif_err(tp, drv, tp->dev, "Failed to map RX DMA!\n");
+                goto err_out;
+        }
+
+        *sk_buff = skb;
+        rtl8125_map_to_asic(desc, mapping, rx_buf_sz);
+out:
+        return ret;
+
+err_out:
+        if (skb)
+                dev_kfree_skb(skb);
+        ret = -ENOMEM;
+        rtl8125_make_unusable_by_asic(desc);
+        goto out;
+}
+
+static void
+rtl8125_rx_clear(struct rtl8125_private *tp)
+{
+        int i;
+
+        for (i = 0; i < NUM_RX_DESC; i++) {
+                if (tp->Rx_skbuff[i])
+                        rtl8125_free_rx_skb(tp, tp->Rx_skbuff + i,
+                                            tp->RxDescArray + i);
+        }
+}
+
+static u32
+rtl8125_rx_fill(struct rtl8125_private *tp,
+                struct net_device *dev,
+                u32 start,
+                u32 end,
+                u8 in_intr)
+{
+        u32 cur;
+
+        for (cur = start; end - cur > 0; cur++) {
+                int ret, i = cur % NUM_RX_DESC;
+
+                if (tp->Rx_skbuff[i])
+                        continue;
+
+                ret = rtl8125_alloc_rx_skb(tp, tp->Rx_skbuff + i,
+                                           tp->RxDescArray + i,
+                                           tp->rx_buf_sz,
+                                           in_intr);
+                if (ret < 0)
+                        break;
+        }
+        return cur - start;
+}
+
+static inline void
+rtl8125_mark_as_last_descriptor(struct RxDesc *desc)
+{
+        desc->opts1 |= cpu_to_le32(RingEnd);
+}
+
+static void
+rtl8125_desc_addr_fill(struct rtl8125_private *tp)
+{
+        if (!tp->TxPhyAddr || !tp->RxPhyAddr)
+                return;
+
+        RTL_W32(tp, TxDescStartAddrLow, ((u64) tp->TxPhyAddr & DMA_BIT_MASK(32)));
+        RTL_W32(tp, TxDescStartAddrHigh, ((u64) tp->TxPhyAddr >> 32));
+        RTL_W32(tp, RxDescAddrLow, ((u64) tp->RxPhyAddr & DMA_BIT_MASK(32)));
+        RTL_W32(tp, RxDescAddrHigh, ((u64) tp->RxPhyAddr >> 32));
+}
+
+static void
+rtl8125_tx_desc_init(struct rtl8125_private *tp)
+{
+        int i = 0;
+
+        memset(tp->TxDescArray, 0x0, NUM_TX_DESC * sizeof(struct TxDesc));
+
+        for (i = 0; i < NUM_TX_DESC; i++) {
+                if (i == (NUM_TX_DESC - 1))
+                        tp->TxDescArray[i].opts1 = cpu_to_le32(RingEnd);
+        }
+}
+
+static void
+rtl8125_rx_desc_init(struct rtl8125_private *tp)
+{
+        memset(tp->RxDescArray, 0x0, NUM_RX_DESC * sizeof(struct RxDesc));
+}
+
+static int
+rtl8125_init_ring(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        rtl8125_init_ring_indexes(tp);
+
+        memset(tp->tx_skb, 0x0, NUM_TX_DESC * sizeof(struct ring_info));
+        memset(tp->Rx_skbuff, 0x0, NUM_RX_DESC * sizeof(struct sk_buff *));
+
+        rtl8125_tx_desc_init(tp);
+        rtl8125_rx_desc_init(tp);
+
+        if (rtl8125_rx_fill(tp, dev, 0, NUM_RX_DESC, 0) != NUM_RX_DESC)
+                goto err_out;
+
+        rtl8125_mark_as_last_descriptor(tp->RxDescArray + NUM_RX_DESC - 1);
+
+        return 0;
+
+err_out:
+        rtl8125_rx_clear(tp);
+        return -ENOMEM;
+}
+
+static void
+rtl8125_unmap_tx_skb(struct pci_dev *pdev,
+                     struct ring_info *tx_skb,
+                     struct TxDesc *desc)
+{
+        unsigned int len = tx_skb->len;
+
+        pci_unmap_single(pdev, le64_to_cpu(desc->addr), len, PCI_DMA_TODEVICE);
+        desc->opts1 = 0x00;
+        desc->opts2 = 0x00;
+        desc->addr = 0x00;
+        tx_skb->len = 0;
+}
+
+static void rtl8125_tx_clear_range(struct rtl8125_private *tp, u32 start,
+                                   unsigned int n)
+{
+        unsigned int i;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,22)
+        struct net_device *dev = tp->dev;
+#endif
+
+        for (i = 0; i < n; i++) {
+                unsigned int entry = (start + i) % NUM_TX_DESC;
+                struct ring_info *tx_skb = tp->tx_skb + entry;
+                unsigned int len = tx_skb->len;
+
+                if (len) {
+                        struct sk_buff *skb = tx_skb->skb;
+
+                        rtl8125_unmap_tx_skb(tp->pci_dev, tx_skb,
+                                             tp->TxDescArray + entry);
+                        if (skb) {
+                                RTLDEV->stats.tx_dropped++;
+                                dev_kfree_skb_any(skb);
+                                tx_skb->skb = NULL;
+                        }
+                }
+        }
+}
+
+static void
+rtl8125_tx_clear(struct rtl8125_private *tp)
+{
+        rtl8125_tx_clear_range(tp, tp->dirty_tx, NUM_TX_DESC);
+        tp->cur_tx = tp->dirty_tx = 0;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+static void rtl8125_schedule_work(struct net_device *dev, void (*task)(void *))
+{
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        INIT_WORK(&tp->task, task, dev);
+        schedule_delayed_work(&tp->task, 4);
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+}
+
+#define rtl8125_cancel_schedule_work(a)
+
+#else
+static void rtl8125_schedule_work(struct net_device *dev, work_func_t task)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        INIT_DELAYED_WORK(&tp->task, task);
+        schedule_delayed_work(&tp->task, 4);
+}
+
+static void rtl8125_cancel_schedule_work(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct work_struct *work = &tp->task.work;
+
+        if (!work->func) return;
+
+        cancel_delayed_work_sync(&tp->task);
+}
+#endif
+
+static void
+rtl8125_wait_for_quiescence(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        synchronize_irq(dev->irq);
+
+        /* Wait for any pending NAPI task to complete */
+#ifdef CONFIG_R8125_NAPI
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        RTL_NAPI_DISABLE(dev, &tp->napi);
+#endif
+#endif//CONFIG_R8125_NAPI
+
+        rtl8125_irq_mask_and_ack(tp);
+
+#ifdef CONFIG_R8125_NAPI
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        RTL_NAPI_ENABLE(dev, &tp->napi);
+#endif
+#endif//CONFIG_R8125_NAPI
+}
+
+#if 0
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+static void rtl8125_reinit_task(void *_data)
+#else
+static void rtl8125_reinit_task(struct work_struct *work)
+#endif
+{
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+        struct net_device *dev = _data;
+#else
+        struct rtl8125_private *tp =
+                container_of(work, struct rtl8125_private, task.work);
+        struct net_device *dev = tp->dev;
+#endif
+        int ret;
+
+        if (netif_running(dev)) {
+                rtl8125_wait_for_quiescence(dev);
+                rtl8125_close(dev);
+        }
+
+        ret = rtl8125_open(dev);
+        if (unlikely(ret < 0)) {
+                if (unlikely(net_ratelimit())) {
+                        struct rtl8125_private *tp = netdev_priv(dev);
+
+                        if (netif_msg_drv(tp)) {
+                                printk(PFX KERN_ERR
+                                       "%s: reinit failure (status = %d)."
+                                       " Rescheduling.\n", dev->name, ret);
+                        }
+                }
+                rtl8125_schedule_work(dev, rtl8125_reinit_task);
+        }
+}
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+static void rtl8125_reset_task(void *_data)
+{
+        struct net_device *dev = _data;
+        struct rtl8125_private *tp = netdev_priv(dev);
+#else
+static void rtl8125_reset_task(struct work_struct *work)
+{
+        struct rtl8125_private *tp =
+                container_of(work, struct rtl8125_private, task.work);
+        struct net_device *dev = tp->dev;
+#endif
+        u32 budget = ~(u32)0;
+        unsigned long flags;
+
+        if (!netif_running(dev))
+                return;
+
+        rtl8125_wait_for_quiescence(dev);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+        rtl8125_rx_interrupt(dev, tp, &budget);
+#else
+        rtl8125_rx_interrupt(dev, tp, budget);
+#endif	//LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8125_tx_clear(tp);
+
+        if (tp->dirty_rx == tp->cur_rx) {
+                rtl8125_rx_clear(tp);
+                rtl8125_init_ring(dev);
+                rtl8125_set_speed(dev, tp->autoneg, tp->speed, tp->duplex, tp->advertising);
+                spin_unlock_irqrestore(&tp->lock, flags);
+        } else {
+                spin_unlock_irqrestore(&tp->lock, flags);
+                if (unlikely(net_ratelimit())) {
+                        struct rtl8125_private *tp = netdev_priv(dev);
+
+                        if (netif_msg_intr(tp)) {
+                                printk(PFX KERN_EMERG
+                                       "%s: Rx buffers shortage\n", dev->name);
+                        }
+                }
+                rtl8125_schedule_work(dev, rtl8125_reset_task);
+        }
+}
+
+static void
+rtl8125_tx_timeout(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        netif_stop_queue(dev);
+        netif_carrier_off(dev);
+        rtl8125_hw_reset(dev);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        /* Let's wait a bit while any (async) irq lands on */
+        rtl8125_schedule_work(dev, rtl8125_reset_task);
+}
+
+static int
+rtl8125_xmit_frags(struct rtl8125_private *tp,
+                   struct sk_buff *skb,
+                   u32 opts1,
+                   u32 opts2)
+{
+        struct skb_shared_info *info = skb_shinfo(skb);
+        unsigned int cur_frag, entry;
+        struct TxDesc *txd = NULL;
+        const unsigned char nr_frags = info->nr_frags;
+        unsigned long PktLenCnt = 0;
+
+        entry = tp->cur_tx;
+        for (cur_frag = 0; cur_frag < nr_frags; cur_frag++) {
+                skb_frag_t *frag = info->frags + cur_frag;
+                dma_addr_t mapping;
+                u32 status, len;
+                void *addr;
+
+                entry = (entry + 1) % NUM_TX_DESC;
+
+                txd = tp->TxDescArray + entry;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
+                len = frag->size;
+                addr = ((void *) page_address(frag->page)) + frag->page_offset;
+#else
+                len = skb_frag_size(frag);
+                addr = skb_frag_address(frag);
+#endif
+                if ((cur_frag == nr_frags - 1) &&
+                    (opts1 & (GiantSendv4|GiantSendv6)) &&
+                    PktLenCnt < ETH_FRAME_LEN &&
+                    len > 1) {
+                        len -= 1;
+                        mapping = pci_map_single(tp->pci_dev, addr, len, PCI_DMA_TODEVICE);
+
+                        if (unlikely(dma_mapping_error(&tp->pci_dev->dev, mapping))) {
+                                if (unlikely(net_ratelimit()))
+                                        netif_err(tp, drv, tp->dev,
+                                                  "Failed to map TX fragments DMA!\n");
+                                goto err_out;
+                        }
+
+                        /* anti gcc 2.95.3 bugware (sic) */
+                        status = opts1 | len | (RingEnd * !((entry + 1) % NUM_TX_DESC));
+
+                        txd->addr = cpu_to_le64(mapping);
+
+                        tp->tx_skb[entry].len = len;
+
+                        txd->opts1 = cpu_to_le32(status);
+                        txd->opts2 = cpu_to_le32(opts2);
+
+                        //second txd
+                        addr += len;
+                        len = 1;
+                        entry = (entry + 1) % NUM_TX_DESC;
+                        txd = tp->TxDescArray + entry;
+                        cur_frag += 1;
+                }
+
+                mapping = pci_map_single(tp->pci_dev, addr, len, PCI_DMA_TODEVICE);
+
+                if (unlikely(dma_mapping_error(&tp->pci_dev->dev, mapping))) {
+                        if (unlikely(net_ratelimit()))
+                                netif_err(tp, drv, tp->dev,
+                                          "Failed to map TX fragments DMA!\n");
+                        goto err_out;
+                }
+
+                /* anti gcc 2.95.3 bugware (sic) */
+                status = opts1 | len | (RingEnd * !((entry + 1) % NUM_TX_DESC));
+
+                txd->addr = cpu_to_le64(mapping);
+
+                tp->tx_skb[entry].len = len;
+
+                txd->opts1 = cpu_to_le32(status);
+                txd->opts2 = cpu_to_le32(opts2);
+
+                PktLenCnt += len;
+        }
+
+        if (cur_frag) {
+                tp->tx_skb[entry].skb = skb;
+                wmb();
+                txd->opts1 |= cpu_to_le32(LastFrag);
+        }
+
+        return cur_frag;
+
+err_out:
+        rtl8125_tx_clear_range(tp, tp->cur_tx + 1, cur_frag);
+        return -EIO;
+}
+
+static inline
+__be16 get_protocol(struct sk_buff *skb)
+{
+        __be16 protocol;
+
+        if (skb->protocol == htons(ETH_P_8021Q))
+                protocol = vlan_eth_hdr(skb)->h_vlan_encapsulated_proto;
+        else
+                protocol = skb->protocol;
+
+        return protocol;
+}
+
+static inline u32
+rtl8125_tx_csum(struct sk_buff *skb,
+                struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u32 csum_cmd = 0;
+        u8 sw_calc_csum = FALSE;
+
+        if (skb->ip_summed == CHECKSUM_PARTIAL) {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+                const struct iphdr *ip = skb->nh.iph;
+
+                if (dev->features & NETIF_F_IP_CSUM) {
+                        if (ip->protocol == IPPROTO_TCP)
+                                csum_cmd = tp->tx_ip_csum_cmd | tp->tx_tcp_csum_cmd;
+                        else if (ip->protocol == IPPROTO_UDP)
+                                csum_cmd = tp->tx_ip_csum_cmd | tp->tx_udp_csum_cmd;
+                        else if (ip->protocol == IPPROTO_IP)
+                                csum_cmd = tp->tx_ip_csum_cmd;
+                }
+#else
+                u8 ip_protocol = IPPROTO_RAW;
+
+                switch (get_protocol(skb)) {
+                case  __constant_htons(ETH_P_IP):
+                        if (dev->features & NETIF_F_IP_CSUM) {
+                                ip_protocol = ip_hdr(skb)->protocol;
+                                csum_cmd = tp->tx_ip_csum_cmd;
+                        }
+                        break;
+                case  __constant_htons(ETH_P_IPV6):
+                        if (dev->features & NETIF_F_IPV6_CSUM) {
+                                u32 transport_offset = (u32)skb_transport_offset(skb);
+                                if (transport_offset > 0 && transport_offset <= TCPHO_MAX) {
+                                        ip_protocol = ipv6_hdr(skb)->nexthdr;
+                                        csum_cmd = tp->tx_ipv6_csum_cmd;
+                                        csum_cmd |= transport_offset << TCPHO_SHIFT;
+                                }
+                        }
+                        break;
+                default:
+                        if (unlikely(net_ratelimit()))
+                                dprintk("checksum_partial proto=%x!\n", skb->protocol);
+                        break;
+                }
+
+                if (ip_protocol == IPPROTO_TCP)
+                        csum_cmd |= tp->tx_tcp_csum_cmd;
+                else if (ip_protocol == IPPROTO_UDP)
+                        csum_cmd |= tp->tx_udp_csum_cmd;
+#endif
+                if (csum_cmd == 0) {
+                        sw_calc_csum = TRUE;
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                        WARN_ON(1); /* we need a WARN() */
+#endif
+                }
+        }
+
+        if (tp->ShortPacketSwChecksum &&
+            skb->len < tp->SwPaddingShortPktLen &&
+            csum_cmd != 0)
+                sw_calc_csum = TRUE;
+
+        if (sw_calc_csum) {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10) && LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,7)
+                skb_checksum_help(&skb, 0);
+#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19) && LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,10)
+                skb_checksum_help(skb, 0);
+#else
+                skb_checksum_help(skb);
+#endif
+                csum_cmd = 0;
+        }
+
+        return csum_cmd;
+}
+
+static int
+rtl8125_sw_padding_short_pkt(struct rtl8125_private *tp,
+                             struct sk_buff *skb,
+                             u32 opts1,
+                             u32 opts2)
+{
+        unsigned int entry;
+        dma_addr_t mapping;
+        u32 status, len;
+        void *addr;
+        struct TxDesc *txd = NULL;
+        int ret = 0;
+
+        if (skb->len >= tp->SwPaddingShortPktLen)
+                goto out;
+
+        entry = tp->cur_tx;
+
+        entry = (entry + 1) % NUM_TX_DESC;
+
+        txd = tp->TxDescArray + entry;
+        len = tp->SwPaddingShortPktLen - skb->len;
+        addr = tp->ShortPacketEmptyBuffer;
+        mapping = pci_map_single(tp->pci_dev, addr, len, PCI_DMA_TODEVICE);
+        if (unlikely(dma_mapping_error(&tp->pci_dev->dev, mapping))) {
+                if (unlikely(net_ratelimit()))
+                        netif_err(tp, drv, tp->dev,
+                                  "Failed to map Short Packet Buffer DMA!\n");
+                ret = -ENOMEM;
+                goto out;
+        }
+        status = opts1 | len | (RingEnd * !((entry + 1) % NUM_TX_DESC));
+
+        txd->addr = cpu_to_le64(mapping);
+
+        txd->opts1 = cpu_to_le32(status);
+        txd->opts2 = cpu_to_le32(opts2);
+
+        wmb();
+        txd->opts1 |= cpu_to_le32(LastFrag);
+out:
+        return ret;
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,14,0)
+/* r8169_csum_workaround()
+  * The hw limites the value the transport offset. When the offset is out of the
+  * range, calculate the checksum by sw.
+  */
+static void r8125_csum_workaround(struct rtl8125_private *tp,
+                                  struct sk_buff *skb)
+{
+        if (skb_shinfo(skb)->gso_size) {
+                netdev_features_t features = tp->dev->features;
+                struct sk_buff *segs, *nskb;
+
+                features &= ~(NETIF_F_SG | NETIF_F_IPV6_CSUM | NETIF_F_TSO6);
+                segs = skb_gso_segment(skb, features);
+                if (IS_ERR(segs) || !segs)
+                        goto drop;
+
+                do {
+                        nskb = segs;
+                        segs = segs->next;
+                        nskb->next = NULL;
+                        rtl8125_start_xmit(nskb, tp->dev);
+                } while (segs);
+
+                dev_consume_skb_any(skb);
+        } else if (skb->ip_summed == CHECKSUM_PARTIAL) {
+                if (skb_checksum_help(skb) < 0)
+                        goto drop;
+
+                rtl8125_start_xmit(skb, tp->dev);
+        } else {
+                struct net_device_stats *stats;
+
+drop:
+                stats = &tp->dev->stats;
+                stats->tx_dropped++;
+                dev_kfree_skb_any(skb);
+        }
+}
+
+/* msdn_giant_send_check()
+ * According to the document of microsoft, the TCP Pseudo Header excludes the
+ * packet length for IPv6 TCP large packets.
+ */
+static int msdn_giant_send_check(struct sk_buff *skb)
+{
+        const struct ipv6hdr *ipv6h;
+        struct tcphdr *th;
+        int ret;
+
+        ret = skb_cow_head(skb, 0);
+        if (ret)
+                return ret;
+
+        ipv6h = ipv6_hdr(skb);
+        th = tcp_hdr(skb);
+
+        th->check = 0;
+        th->check = ~tcp_v6_check(0, &ipv6h->saddr, &ipv6h->daddr, 0);
+
+        return ret;
+}
+#endif
+
+static int
+rtl8125_start_xmit(struct sk_buff *skb,
+                   struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned int entry;
+        struct TxDesc *txd;
+        dma_addr_t mapping;
+        u32 len;
+        u32 opts1;
+        u32 opts2;
+        int ret = NETDEV_TX_OK;
+        unsigned long flags, large_send;
+        int frags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        if (unlikely(TX_BUFFS_AVAIL(tp) < skb_shinfo(skb)->nr_frags)) {
+                if (netif_msg_drv(tp)) {
+                        printk(KERN_ERR
+                               "%s: BUG! Tx Ring full when queue awake!\n",
+                               dev->name);
+                }
+                goto err_stop;
+        }
+
+        entry = tp->cur_tx % NUM_TX_DESC;
+        txd = tp->TxDescArray + entry;
+
+        if (unlikely(le32_to_cpu(txd->opts1) & DescOwn))
+                goto err_stop;
+
+        opts1 = DescOwn;
+        opts2 = rtl8125_tx_vlan_tag(tp, skb);
+
+        large_send = 0;
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        if (dev->features & (NETIF_F_TSO | NETIF_F_TSO6)) {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18)
+                u32 mss = skb_shinfo(skb)->tso_size;
+#else
+                u32 mss = skb_shinfo(skb)->gso_size;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18)
+
+                /* TCP Segmentation Offload (or TCP Large Send) */
+                if (mss) {
+                        u32 transport_offset = (u32)skb_transport_offset(skb);
+                        assert((transport_offset%2) == 0);
+                        switch (get_protocol(skb)) {
+                        case __constant_htons(ETH_P_IP):
+                                if (transport_offset <= 128) {
+                                        opts1 |= GiantSendv4;
+                                        opts1 |= transport_offset << GTTCPHO_SHIFT;
+                                        opts2 |= min(mss, MSS_MAX) << 18;
+                                        large_send = 1;
+                                }
+                                break;
+                        case __constant_htons(ETH_P_IPV6):
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,14,0)
+                                if (msdn_giant_send_check(skb)) {
+                                        spin_unlock_irqrestore(&tp->lock, flags);
+                                        r8125_csum_workaround(tp, skb);
+                                        goto out;
+                                }
+#endif
+                                if (transport_offset <= 128) {
+                                        opts1 |= GiantSendv6;
+                                        opts1 |= transport_offset << GTTCPHO_SHIFT;
+                                        opts2 |= min(mss, MSS_MAX) << 18;
+                                        large_send = 1;
+                                }
+                                break;
+                        default:
+                                if (unlikely(net_ratelimit()))
+                                        dprintk("tso proto=%x!\n", skb->protocol);
+                                break;
+                        }
+
+                        if (large_send == 0)
+                                goto err_dma_0;
+                }
+        }
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+
+        if (large_send == 0) {
+                if (skb->ip_summed == CHECKSUM_PARTIAL) {
+                        opts2 |= rtl8125_tx_csum(skb, dev);
+                }
+        }
+
+        frags = rtl8125_xmit_frags(tp, skb, opts1, opts2);
+        if (unlikely(frags < 0))
+                goto err_dma_0;
+        if (frags) {
+                len = skb_headlen(skb);
+                opts1 |= FirstFrag;
+        } else {
+                len = skb->len;
+
+                tp->tx_skb[entry].skb = skb;
+
+                if (tp->UseSwPaddingShortPkt && len < tp->SwPaddingShortPktLen) {
+                        if (unlikely(rtl8125_sw_padding_short_pkt(tp, skb, opts1, opts2)))
+                                goto err_dma_1;
+                        opts1 |= FirstFrag;
+                        frags++;
+                } else {
+                        opts1 |= FirstFrag | LastFrag;
+                }
+        }
+
+        opts1 |= len | (RingEnd * !((entry + 1) % NUM_TX_DESC));
+        mapping = pci_map_single(tp->pci_dev, skb->data, len, PCI_DMA_TODEVICE);
+        if (unlikely(dma_mapping_error(&tp->pci_dev->dev, mapping))) {
+                if (unlikely(net_ratelimit()))
+                        netif_err(tp, drv, dev, "Failed to map TX DMA!\n");
+                goto err_dma_1;
+        }
+        tp->tx_skb[entry].len = len;
+        txd->addr = cpu_to_le64(mapping);
+        txd->opts2 = cpu_to_le32(opts2);
+        txd->opts1 = cpu_to_le32(opts1&~DescOwn);
+        wmb();
+        txd->opts1 = cpu_to_le32(opts1);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,5,0)
+        dev->trans_start = jiffies;
+#else
+        skb_tx_timestamp(skb);
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,5,0)
+
+        tp->cur_tx += frags + 1;
+
+        wmb();
+
+        RTL_W16(tp, TPPOLL_8125, BIT_0);    /* set polling bit */
+
+        if (TX_BUFFS_AVAIL(tp) < MAX_SKB_FRAGS) {
+                netif_stop_queue(dev);
+                smp_rmb();
+                if (TX_BUFFS_AVAIL(tp) >= MAX_SKB_FRAGS)
+                        netif_wake_queue(dev);
+        }
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+out:
+        return ret;
+err_dma_1:
+        tp->tx_skb[entry].skb = NULL;
+        rtl8125_tx_clear_range(tp, tp->cur_tx + 1, frags);
+err_dma_0:
+        RTLDEV->stats.tx_dropped++;
+        spin_unlock_irqrestore(&tp->lock, flags);
+        dev_kfree_skb_any(skb);
+        ret = NETDEV_TX_OK;
+        goto out;
+err_stop:
+        netif_stop_queue(dev);
+        ret = NETDEV_TX_BUSY;
+        RTLDEV->stats.tx_dropped++;
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+        goto out;
+}
+
+static void
+rtl8125_tx_interrupt(struct net_device *dev,
+                     struct rtl8125_private *tp)
+{
+        unsigned int dirty_tx, tx_left;
+
+        assert(dev != NULL);
+        assert(tp != NULL);
+
+        dirty_tx = tp->dirty_tx;
+        smp_rmb();
+        tx_left = tp->cur_tx - dirty_tx;
+
+        while (tx_left > 0) {
+                unsigned int entry = dirty_tx % NUM_TX_DESC;
+                struct ring_info *tx_skb = tp->tx_skb + entry;
+                u32 len = tx_skb->len;
+                u32 status;
+
+                rmb();
+                status = le32_to_cpu(tp->TxDescArray[entry].opts1);
+                if (status & DescOwn)
+                        break;
+
+                RTLDEV->stats.tx_bytes += len;
+                RTLDEV->stats.tx_packets++;
+
+                rtl8125_unmap_tx_skb(tp->pci_dev,
+                                     tx_skb,
+                                     tp->TxDescArray + entry);
+
+                if (tx_skb->skb!=NULL) {
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,14,0)
+                        dev_consume_skb_any(tx_skb->skb);
+#else
+                        dev_kfree_skb_any(tx_skb->skb);
+#endif
+                        tx_skb->skb = NULL;
+                }
+                dirty_tx++;
+                tx_left--;
+        }
+
+        if (tp->dirty_tx != dirty_tx) {
+                tp->dirty_tx = dirty_tx;
+                smp_wmb();
+                if (netif_queue_stopped(dev) &&
+                    (TX_BUFFS_AVAIL(tp) >= MAX_SKB_FRAGS)) {
+                        netif_wake_queue(dev);
+                }
+                smp_rmb();
+                if (tp->cur_tx != dirty_tx) {
+                        RTL_W16(tp, TPPOLL_8125, BIT_0);
+                }
+        }
+}
+
+static inline int
+rtl8125_fragmented_frame(u32 status)
+{
+        return (status & (FirstFrag | LastFrag)) != (FirstFrag | LastFrag);
+}
+
+static inline void
+rtl8125_rx_csum(struct rtl8125_private *tp,
+                struct sk_buff *skb,
+                struct RxDesc *desc)
+{
+        u32 opts1 = le32_to_cpu(desc->opts1);
+        u32 opts2 = le32_to_cpu(desc->opts2);
+
+        /* rx csum offload for RTL8125 */
+        if (((opts2 & RxV4F) && !(opts1 & RxIPF)) || (opts2 & RxV6F)) {
+                if (((opts1 & RxTCPT) && !(opts1 & RxTCPF)) ||
+                    ((opts1 & RxUDPT) && !(opts1 & RxUDPF)))
+                        skb->ip_summed = CHECKSUM_UNNECESSARY;
+                else
+                        skb->ip_summed = CHECKSUM_NONE;
+        } else
+                skb->ip_summed = CHECKSUM_NONE;
+}
+
+static inline int
+rtl8125_try_rx_copy(struct rtl8125_private *tp,
+                    struct sk_buff **sk_buff,
+                    int pkt_size,
+                    struct RxDesc *desc,
+                    int rx_buf_sz)
+{
+        int ret = -1;
+
+        if (pkt_size < rx_copybreak) {
+                struct sk_buff *skb;
+
+                skb = RTL_ALLOC_SKB_INTR(tp, pkt_size + RTK_RX_ALIGN);
+                if (skb) {
+                        u8 *data;
+
+                        data = sk_buff[0]->data;
+                        skb_reserve(skb, RTK_RX_ALIGN);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,37)
+                        prefetch(data - RTK_RX_ALIGN);
+#endif
+                        eth_copy_and_sum(skb, data, pkt_size, 0);
+                        *sk_buff = skb;
+                        rtl8125_mark_to_asic(desc, rx_buf_sz);
+                        ret = 0;
+                }
+        }
+        return ret;
+}
+
+static inline void
+rtl8125_rx_skb(struct rtl8125_private *tp,
+               struct sk_buff *skb)
+{
+#ifdef CONFIG_R8125_NAPI
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+        netif_receive_skb(skb);
+#else
+        napi_gro_receive(&tp->napi, skb);
+#endif
+#else
+        netif_rx(skb);
+#endif
+}
+
+static int
+rtl8125_rx_interrupt(struct net_device *dev,
+                     struct rtl8125_private *tp,
+                     napi_budget budget)
+{
+        unsigned int cur_rx, rx_left;
+        unsigned int delta, count = 0;
+        unsigned int entry;
+        struct RxDesc *desc;
+        u32 status;
+        u32 rx_quota;
+
+        assert(dev != NULL);
+        assert(tp != NULL);
+
+        if ((tp->RxDescArray == NULL) || (tp->Rx_skbuff == NULL))
+                goto rx_out;
+
+        rx_quota = RTL_RX_QUOTA(budget);
+        cur_rx = tp->cur_rx;
+        entry = cur_rx % NUM_RX_DESC;
+        desc = tp->RxDescArray + entry;
+        rx_left = NUM_RX_DESC + tp->dirty_rx - cur_rx;
+        rx_left = rtl8125_rx_quota(rx_left, (u32)rx_quota);
+
+        for (; rx_left > 0; rx_left--) {
+                rmb();
+                status = le32_to_cpu(desc->opts1);
+                if (status & DescOwn)
+                        break;
+                if (unlikely(status & RxRES)) {
+                        if (netif_msg_rx_err(tp)) {
+                                printk(KERN_INFO
+                                       "%s: Rx ERROR. status = %08x\n",
+                                       dev->name, status);
+                        }
+
+                        RTLDEV->stats.rx_errors++;
+
+                        if (status & (RxRWT | RxRUNT))
+                                RTLDEV->stats.rx_length_errors++;
+                        if (status & RxCRC)
+                                RTLDEV->stats.rx_crc_errors++;
+                        if (dev->features & NETIF_F_RXALL)
+                                goto process_pkt;
+
+                        rtl8125_mark_to_asic(desc, tp->rx_buf_sz);
+                } else {
+                        struct sk_buff *skb;
+                        int pkt_size;
+                        void (*pci_action)(struct pci_dev *, dma_addr_t,
+                                           size_t, int);
+
+process_pkt:
+                        if (likely(!(dev->features & NETIF_F_RXFCS)))
+                                pkt_size = (status & 0x00003fff) - 4;
+                        else
+                                pkt_size = status & 0x00003fff;
+
+                        /*
+                         * The driver does not support incoming fragmented
+                         * frames. They are seen as a symptom of over-mtu
+                         * sized frames.
+                         */
+                        if (unlikely(rtl8125_fragmented_frame(status))) {
+                                RTLDEV->stats.rx_dropped++;
+                                RTLDEV->stats.rx_length_errors++;
+                                rtl8125_mark_to_asic(desc, tp->rx_buf_sz);
+                                continue;
+                        }
+
+                        skb = tp->Rx_skbuff[entry];
+
+                        pci_dma_sync_single_for_cpu(tp->pci_dev,
+                                                    le64_to_cpu(desc->addr), tp->rx_buf_sz,
+                                                    PCI_DMA_FROMDEVICE);
+
+                        pci_action = pci_dma_sync_single_for_device;
+                        if (rtl8125_try_rx_copy(tp, &skb, pkt_size,
+                                                desc, tp->rx_buf_sz)) {
+                                pci_action = pci_unmap_single;
+                                tp->Rx_skbuff[entry] = NULL;
+                        }
+
+                        pci_action(tp->pci_dev, le64_to_cpu(desc->addr),
+                                   tp->rx_buf_sz, PCI_DMA_FROMDEVICE);
+
+                        if (tp->cp_cmd & RxChkSum)
+                                rtl8125_rx_csum(tp, skb, desc);
+
+                        skb->dev = dev;
+                        skb_put(skb, pkt_size);
+                        skb->protocol = eth_type_trans(skb, dev);
+
+                        if (skb->pkt_type == PACKET_MULTICAST)
+                                RTLDEV->stats.multicast++;
+
+                        if (rtl8125_rx_vlan_skb(tp, desc, skb) < 0)
+                                rtl8125_rx_skb(tp, skb);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,11,0)
+                        dev->last_rx = jiffies;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(4,11,0)
+                        RTLDEV->stats.rx_bytes += pkt_size;
+                        RTLDEV->stats.rx_packets++;
+                }
+
+                cur_rx++;
+                entry = cur_rx % NUM_RX_DESC;
+                desc = tp->RxDescArray + entry;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,37)
+                prefetch(desc);
+#endif
+        }
+
+        count = cur_rx - tp->cur_rx;
+        tp->cur_rx = cur_rx;
+
+        delta = rtl8125_rx_fill(tp, dev, tp->dirty_rx, tp->cur_rx, 1);
+        if (!delta && count && netif_msg_intr(tp))
+                printk(KERN_INFO "%s: no Rx buffer allocated\n", dev->name);
+        tp->dirty_rx += delta;
+
+        /*
+         * FIXME: until there is periodic timer to try and refill the ring,
+         * a temporary shortage may definitely kill the Rx process.
+         * - disable the asic to try and avoid an overflow and kick it again
+         *   after refill ?
+         * - how do others driver handle this condition (Uh oh...).
+         */
+        if ((tp->dirty_rx + NUM_RX_DESC == tp->cur_rx) && netif_msg_intr(tp))
+                printk(KERN_EMERG "%s: Rx buffers exhausted\n", dev->name);
+
+rx_out:
+        return count;
+}
+
+/*
+ *The interrupt handler does all of the Rx thread work and cleans up after
+ *the Tx thread.
+ */
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
+static irqreturn_t rtl8125_interrupt(int irq, void *dev_instance, struct pt_regs *regs)
+#else
+static irqreturn_t rtl8125_interrupt(int irq, void *dev_instance)
+#endif
+{
+        struct net_device *dev = (struct net_device *) dev_instance;
+        struct rtl8125_private *tp = netdev_priv(dev);
+        u32 status;
+        int handled = 0;
+
+        do {
+                status = RTL_R32(tp, ISR0_8125);
+
+                if (!(tp->features & RTL_FEATURE_MSI)) {
+                        /* hotplug/major error/no more work/shared irq */
+                        if (!status)
+                                break;
+
+                        if ((status == 0xFFFFFFFF))
+                                break;
+
+                        if (!(status & (tp->intr_mask | tp->timer_intr_mask)))
+                                break;
+                }
+
+                handled = 1;
+
+                rtl8125_disable_hw_interrupt(tp);
+
+                RTL_W32(tp, ISR0_8125, status&~RxFIFOOver);
+
+#ifdef ENABLE_DASH_SUPPORT
+                if (tp->DASH) {
+                        if (HW_DASH_SUPPORT_TYPE_3(tp)) {
+                                u8 DashIntType2Status;
+
+                                if (status & ISRIMR_DASH_INTR_CMAC_RESET)
+                                        tp->CmacResetIntr = TRUE;
+
+                                DashIntType2Status = RTL_CMAC_R8(tp, CMAC_IBISR0);
+                                if (DashIntType2Status & ISRIMR_DASH_TYPE2_ROK) {
+                                        tp->RcvFwDashOkEvt = TRUE;
+                                }
+                                if (DashIntType2Status & ISRIMR_DASH_TYPE2_TOK) {
+                                        tp->SendFwHostOkEvt = TRUE;
+                                }
+                                if (DashIntType2Status & ISRIMR_DASH_TYPE2_RX_DISABLE_IDLE) {
+                                        tp->DashFwDisableRx = TRUE;
+                                }
+
+                                RTL_CMAC_W8(tp, CMAC_IBISR0, DashIntType2Status);
+                        }
+                }
+#endif
+
+#ifdef CONFIG_R8125_NAPI
+                if (status & tp->intr_mask || tp->keep_intr_cnt-- > 0) {
+                        if (status & tp->intr_mask)
+                                tp->keep_intr_cnt = RTK_KEEP_INTERRUPT_COUNT;
+
+                        if (likely(RTL_NETIF_RX_SCHEDULE_PREP(dev, &tp->napi)))
+                                __RTL_NETIF_RX_SCHEDULE(dev, &tp->napi);
+                        else if (netif_msg_intr(tp))
+                                printk(KERN_INFO "%s: interrupt %04x in poll\n",
+                                       dev->name, status);
+                } else {
+                        tp->keep_intr_cnt = RTK_KEEP_INTERRUPT_COUNT;
+                        rtl8125_switch_to_hw_interrupt(tp);
+                }
+#else
+                if (status & tp->intr_mask || tp->keep_intr_cnt-- > 0) {
+                        u32 budget = ~(u32)0;
+
+                        if (status & tp->intr_mask)
+                                tp->keep_intr_cnt = RTK_KEEP_INTERRUPT_COUNT;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+                        rtl8125_rx_interrupt(dev, tp, &budget);
+#else
+                        rtl8125_rx_interrupt(dev, tp, budget);
+#endif	//LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+                        rtl8125_tx_interrupt(dev, tp);
+
+#ifdef ENABLE_DASH_SUPPORT
+                        if (tp->DASH) {
+                                struct net_device *dev = tp->dev;
+
+                                HandleDashInterrupt(dev);
+                        }
+#endif
+
+                        rtl8125_switch_to_timer_interrupt(tp);
+                } else {
+                        tp->keep_intr_cnt = RTK_KEEP_INTERRUPT_COUNT;
+                        rtl8125_switch_to_hw_interrupt(tp);
+                }
+#endif
+
+        } while (false);
+
+        return IRQ_RETVAL(handled);
+}
+
+#ifdef CONFIG_R8125_NAPI
+static int rtl8125_poll(napi_ptr napi, napi_budget budget)
+{
+        struct rtl8125_private *tp = RTL_GET_PRIV(napi, struct rtl8125_private);
+        RTL_GET_NETDEV(tp)
+        unsigned int work_to_do = RTL_NAPI_QUOTA(budget, dev);
+        unsigned int work_done;
+        unsigned long flags;
+
+        work_done = rtl8125_rx_interrupt(dev, tp, budget);
+
+        spin_lock_irqsave(&tp->lock, flags);
+        rtl8125_tx_interrupt(dev, tp);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        RTL_NAPI_QUOTA_UPDATE(dev, work_done, budget);
+
+        if (work_done < work_to_do) {
+#ifdef ENABLE_DASH_SUPPORT
+                if (tp->DASH) {
+                        struct net_device *dev = tp->dev;
+
+                        spin_lock_irqsave(&tp->lock, flags);
+                        HandleDashInterrupt(dev);
+                        spin_unlock_irqrestore(&tp->lock, flags);
+                }
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,10,0)
+                if (RTL_NETIF_RX_COMPLETE(dev, napi, work_done) == FALSE) return RTL_NAPI_RETURN_VALUE;
+#else
+                RTL_NETIF_RX_COMPLETE(dev, napi, work_done);
+#endif
+                /*
+                 * 20040426: the barrier is not strictly required but the
+                 * behavior of the irq handler could be less predictable
+                 * without it. Btw, the lack of flush for the posted pci
+                 * write is safe - FR
+                 */
+                smp_wmb();
+
+                rtl8125_switch_to_timer_interrupt(tp);
+        }
+
+        return RTL_NAPI_RETURN_VALUE;
+}
+#endif//CONFIG_R8125_NAPI
+
+static void rtl8125_down(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        rtl8125_delete_esd_timer(dev, &tp->esd_timer);
+
+        rtl8125_delete_link_timer(dev, &tp->link_timer);
+
+#ifdef CONFIG_R8125_NAPI
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        RTL_NAPI_DISABLE(dev, &tp->napi);
+#endif
+#endif//CONFIG_R8125_NAPI
+
+        netif_stop_queue(dev);
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,11)
+        /* Give a racing hard_start_xmit a few cycles to complete. */
+        synchronize_rcu();  /* FIXME: should this be synchronize_irq()? */
+#endif
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        netif_carrier_off(dev);
+
+        rtl8125_hw_reset(dev);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        synchronize_irq(dev->irq);
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8125_tx_clear(tp);
+
+        rtl8125_rx_clear(tp);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+static int rtl8125_close(struct net_device *dev)
+{
+        struct rtl8125_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+        unsigned long flags;
+
+        if (tp->TxDescArray!=NULL && tp->RxDescArray!=NULL) {
+                rtl8125_cancel_schedule_work(dev);
+
+                rtl8125_down(dev);
+
+                spin_lock_irqsave(&tp->lock, flags);
+
+                rtl8125_hw_d3_para(dev);
+
+                rtl8125_powerdown_pll(dev);
+
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                free_irq(dev->irq, dev);
+
+                dma_free_coherent(&pdev->dev, R8125_RX_RING_BYTES, tp->RxDescArray,
+                                  tp->RxPhyAddr);
+                dma_free_coherent(&pdev->dev, R8125_TX_RING_BYTES, tp->TxDescArray,
+                                  tp->TxPhyAddr);
+                tp->TxDescArray = NULL;
+                tp->RxDescArray = NULL;
+
+                if (tp->ShortPacketEmptyBuffer != NULL) {
+                        dma_free_coherent(&pdev->dev, SHORT_PACKET_PADDING_BUF_SIZE, tp->ShortPacketEmptyBuffer,
+                                          tp->ShortPacketEmptyBufferPhy);
+                        tp->ShortPacketEmptyBuffer = NULL;
+                }
+        } else {
+                spin_lock_irqsave(&tp->lock, flags);
+
+                rtl8125_hw_d3_para(dev);
+
+                rtl8125_powerdown_pll(dev);
+
+                spin_unlock_irqrestore(&tp->lock, flags);
+        }
+
+        return 0;
+}
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,11)
+static void rtl8125_shutdown(struct pci_dev *pdev)
+{
+        struct net_device *dev = pci_get_drvdata(pdev);
+        struct rtl8125_private *tp = netdev_priv(dev);
+
+        if (tp->DASH)
+                rtl8125_driver_stop(tp);
+
+        rtl8125_set_bios_setting(dev);
+        if (s5_keep_curr_mac == 0 && tp->random_mac == 0)
+                rtl8125_rar_set(tp, tp->org_mac_addr);
+
+        if (s5wol == 0)
+                tp->wol_enabled = WOL_DISABLED;
+
+        rtl8125_close(dev);
+        rtl8125_disable_msi(pdev, tp);
+}
+#endif
+
+/**
+ *  rtl8125_get_stats - Get rtl8125 read/write statistics
+ *  @dev: The Ethernet Device to get statistics for
+ *
+ *  Get TX/RX statistics for rtl8125
+ */
+static struct
+net_device_stats *rtl8125_get_stats(struct net_device *dev)
+{
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+        struct rtl8125_private *tp = netdev_priv(dev);
+#endif
+        if (netif_running(dev)) {
+//      spin_lock_irqsave(&tp->lock, flags);
+//      spin_unlock_irqrestore(&tp->lock, flags);
+        }
+
+        return &RTLDEV->stats;
+}
+
+#ifdef CONFIG_PM
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,11)
+static int
+rtl8125_suspend(struct pci_dev *pdev, u32 state)
+#else
+static int
+rtl8125_suspend(struct pci_dev *pdev, pm_message_t state)
+#endif
+{
+        struct net_device *dev = pci_get_drvdata(pdev);
+        struct rtl8125_private *tp = netdev_priv(dev);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
+        u32 pci_pm_state = pci_choose_state(pdev, state);
+#endif
+        unsigned long flags;
+
+        if (!netif_running(dev))
+                goto out;
+
+        rtl8125_cancel_schedule_work(dev);
+
+        rtl8125_delete_esd_timer(dev, &tp->esd_timer);
+
+        rtl8125_delete_link_timer(dev, &tp->link_timer);
+
+        netif_stop_queue(dev);
+
+        netif_carrier_off(dev);
+
+        netif_device_detach(dev);
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8125_hw_reset(dev);
+
+        rtl8125_hw_d3_para(dev);
+
+        rtl8125_powerdown_pll(dev);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        if (tp->DASH)
+                rtl8125_driver_stop(tp);
+out:
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
+        pci_save_state(pdev, &pci_pm_state);
+#else
+        pci_save_state(pdev);
+#endif
+        pci_enable_wake(pdev, pci_choose_state(pdev, state), tp->wol_enabled);
+//  pci_set_power_state(pdev, pci_choose_state(pdev, state));
+
+        return 0;
+}
+
+static int
+rtl8125_resume(struct pci_dev *pdev)
+{
+        struct net_device *dev = pci_get_drvdata(pdev);
+        struct rtl8125_private *tp = netdev_priv(dev);
+        unsigned long flags;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
+        u32 pci_pm_state = PCI_D0;
+#endif
+
+        pci_set_power_state(pdev, PCI_D0);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
+        pci_restore_state(pdev, &pci_pm_state);
+#else
+        pci_restore_state(pdev);
+#endif
+        pci_enable_wake(pdev, PCI_D0, 0);
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        /* restore last modified mac address */
+        rtl8125_rar_set(tp, dev->dev_addr);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        if (!netif_running(dev))
+                goto out;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8125_exit_oob(dev);
+
+        rtl8125_hw_init(dev);
+
+        rtl8125_powerup_pll(dev);
+
+        rtl8125_hw_ephy_config(dev);
+
+        rtl8125_hw_phy_config(dev);
+
+        rtl8125_schedule_work(dev, rtl8125_reset_task);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        netif_device_attach(dev);
+
+        mod_timer(&tp->esd_timer, jiffies + RTL8125_ESD_TIMEOUT);
+        mod_timer(&tp->link_timer, jiffies + RTL8125_LINK_TIMEOUT);
+out:
+        return 0;
+}
+
+#endif /* CONFIG_PM */
+
+static struct pci_driver rtl8125_pci_driver = {
+        .name       = MODULENAME,
+        .id_table   = rtl8125_pci_tbl,
+        .probe      = rtl8125_init_one,
+        .remove     = __devexit_p(rtl8125_remove_one),
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,11)
+        .shutdown   = rtl8125_shutdown,
+#endif
+#ifdef CONFIG_PM
+        .suspend    = rtl8125_suspend,
+        .resume     = rtl8125_resume,
+#endif
+};
+
+static int __init
+rtl8125_init_module(void)
+{
+#ifdef ENABLE_R8125_PROCFS
+        rtl8125_proc_module_init();
+#endif
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        return pci_register_driver(&rtl8125_pci_driver);
+#else
+        return pci_module_init(&rtl8125_pci_driver);
+#endif
+}
+
+static void __exit
+rtl8125_cleanup_module(void)
+{
+        pci_unregister_driver(&rtl8125_pci_driver);
+#ifdef ENABLE_R8125_PROCFS
+        if (rtl8125_proc) {
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+                remove_proc_subtree(MODULENAME, init_net.proc_net);
+#else
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,32)
+                remove_proc_entry(MODULENAME, init_net.proc_net);
+#else
+                remove_proc_entry(MODULENAME, proc_net);
+#endif  //LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,32)
+#endif  //LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+                rtl8125_proc = NULL;
+        }
+#endif
+}
+
+module_init(rtl8125_init_module);
+module_exit(rtl8125_cleanup_module);
diff --git a/drivers/net/ethernet/realtek/r8125/r8125_realwow.h b/drivers/net/ethernet/realtek/r8125/r8125_realwow.h
new file mode 100644
index 00000000..9825300
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8125/r8125_realwow.h
@@ -0,0 +1,117 @@
+/*
+################################################################################
+#
+# r8125 is the Linux device driver released for Realtek 2.5Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#ifndef _LINUX_R8125_REALWOW_H
+#define _LINUX_R8125_REALWOW_H
+
+#define SIOCDEVPRIVATE_RTLREALWOW   SIOCDEVPRIVATE+3
+
+#define MAX_RealWoW_KCP_SIZE (100)
+#define MAX_RealWoW_Payload (64)
+
+#define KA_TX_PACKET_SIZE (100)
+#define KA_WAKEUP_PATTERN_SIZE (120)
+
+//HwSuppKeepAliveOffloadVer
+#define HW_SUPPORT_KCP_OFFLOAD(_M)        ((_M)->HwSuppKCPOffloadVer > 0)
+
+enum rtl_realwow_cmd {
+
+        RTL_REALWOW_SET_KCP_DISABLE=0,
+        RTL_REALWOW_SET_KCP_INFO,
+        RTL_REALWOW_SET_KCP_CONTENT,
+
+        RTL_REALWOW_SET_KCP_ACKPKTINFO,
+        RTL_REALWOW_SET_KCP_WPINFO,
+        RTL_REALWOW_SET_KCPDHCP_TIMEOUT,
+
+        RTLT_REALWOW_COMMAND_INVALID
+};
+
+struct rtl_realwow_ioctl_struct {
+        __u32	cmd;
+        __u32	offset;
+        __u32	len;
+        union {
+                __u32	data;
+                void *data_buffer;
+        };
+};
+
+typedef struct _MP_KCPInfo {
+        u8 DIPv4[4];
+        u8 MacID[6];
+        u16 UdpPort[2];
+        u8 PKTLEN[2];
+
+        u16 ackLostCnt;
+        u8 KCP_WakePattern[MAX_RealWoW_Payload];
+        u8 KCP_AckPacket[MAX_RealWoW_Payload];
+        u32 KCP_interval;
+        u8 KCP_WakePattern_Len;
+        u8 KCP_AckPacket_Len;
+        u8 KCP_TxPacket[2][KA_TX_PACKET_SIZE];
+} MP_KCP_INFO, *PMP_KCP_INFO;
+
+typedef struct _KCPInfo {
+        u32 nId; // = id
+        u8 DIPv4[4];
+        u8 MacID[6];
+        u16 UdpPort;
+        u16 PKTLEN;
+} KCPInfo, *PKCPInfo;
+
+typedef struct _KCPContent {
+        u32 id; // = id
+        u32 mSec; // = msec
+        u32 size; // =size
+        u8 bPacket[MAX_RealWoW_KCP_SIZE]; // put packet here
+} KCPContent, *PKCPContent;
+
+typedef struct _RealWoWAckPktInfo {
+        u16 ackLostCnt;
+        u16 patterntSize;
+        u8 pattern[MAX_RealWoW_Payload];
+} RealWoWAckPktInfo,*PRealWoWAckPktInfo;
+
+typedef struct _RealWoWWPInfo {
+        u16 patterntSize;
+        u8 pattern[MAX_RealWoW_Payload];
+} RealWoWWPInfo,*PRealWoWWPInfo;
+
+int rtl8125_realwow_ioctl(struct net_device *dev, struct ifreq *ifr);
+void rtl8125_realwow_hw_init(struct net_device *dev);
+void rtl8125_get_realwow_hw_version(struct net_device *dev);
+void rtl8125_set_realwow_d3_para(struct net_device *dev);
+
+#endif /* _LINUX_R8125_REALWOW_H */
diff --git a/drivers/net/ethernet/realtek/r8125/rtl_eeprom.c b/drivers/net/ethernet/realtek/r8125/rtl_eeprom.c
new file mode 100644
index 00000000..aaed764
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8125/rtl_eeprom.c
@@ -0,0 +1,288 @@
+/*
+################################################################################
+#
+# r8125 is the Linux device driver released for Realtek 2.5Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/version.h>
+#include <linux/ethtool.h>
+#include <linux/netdevice.h>
+#include <linux/delay.h>
+
+#include <asm/io.h>
+
+#include "r8125.h"
+#include "rtl_eeprom.h"
+
+//-------------------------------------------------------------------
+//rtl8125_eeprom_type():
+//  tell the eeprom type
+//return value:
+//  0: the eeprom type is 93C46
+//  1: the eeprom type is 93C56 or 93C66
+//-------------------------------------------------------------------
+void rtl8125_eeprom_type(struct rtl8125_private *tp)
+{
+        u16 magic = 0;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                goto out_no_eeprom;
+
+        if(RTL_R8(tp, 0xD2)&0x04) {
+                //not support
+                //tp->eeprom_type = EEPROM_TWSI;
+                //tp->eeprom_len = 256;
+                goto out_no_eeprom;
+        } else if(RTL_R32(tp, RxConfig) & RxCfg_9356SEL) {
+                tp->eeprom_type = EEPROM_TYPE_93C56;
+                tp->eeprom_len = 256;
+        } else {
+                tp->eeprom_type = EEPROM_TYPE_93C46;
+                tp->eeprom_len = 128;
+        }
+
+        magic = rtl8125_eeprom_read_sc(tp, 0);
+
+out_no_eeprom:
+        if ((magic != 0x8129) && (magic != 0x8128)) {
+                tp->eeprom_type = EEPROM_TYPE_NONE;
+                tp->eeprom_len = 0;
+        }
+}
+
+void rtl8125_eeprom_cleanup(struct rtl8125_private *tp)
+{
+        u8 x;
+
+        x = RTL_R8(tp, Cfg9346);
+        x &= ~(Cfg9346_EEDI | Cfg9346_EECS);
+
+        RTL_W8(tp, Cfg9346, x);
+
+        rtl8125_raise_clock(tp, &x);
+        rtl8125_lower_clock(tp, &x);
+}
+
+int rtl8125_eeprom_cmd_done(struct rtl8125_private *tp)
+{
+        u8 x;
+        int i;
+
+        rtl8125_stand_by(tp);
+
+        for (i = 0; i < 50000; i++) {
+                x = RTL_R8(tp, Cfg9346);
+
+                if (x & Cfg9346_EEDO) {
+                        udelay(RTL_CLOCK_RATE * 2 * 3);
+                        return 0;
+                }
+                udelay(1);
+        }
+
+        return -1;
+}
+
+//-------------------------------------------------------------------
+//rtl8125_eeprom_read_sc():
+//  read one word from eeprom
+//-------------------------------------------------------------------
+u16 rtl8125_eeprom_read_sc(struct rtl8125_private *tp, u16 reg)
+{
+        int addr_sz = 6;
+        u8 x;
+        u16 data;
+
+        if(tp->eeprom_type == EEPROM_TYPE_NONE) {
+                return -1;
+        }
+
+        if (tp->eeprom_type==EEPROM_TYPE_93C46)
+                addr_sz = 6;
+        else if (tp->eeprom_type==EEPROM_TYPE_93C56)
+                addr_sz = 8;
+
+        x = Cfg9346_EEM1 | Cfg9346_EECS;
+        RTL_W8(tp, Cfg9346, x);
+
+        rtl8125_shift_out_bits(tp, RTL_EEPROM_READ_OPCODE, 3);
+        rtl8125_shift_out_bits(tp, reg, addr_sz);
+
+        data = rtl8125_shift_in_bits(tp);
+
+        rtl8125_eeprom_cleanup(tp);
+
+        RTL_W8(tp, Cfg9346, 0);
+
+        return data;
+}
+
+//-------------------------------------------------------------------
+//rtl8125_eeprom_write_sc():
+//  write one word to a specific address in the eeprom
+//-------------------------------------------------------------------
+void rtl8125_eeprom_write_sc(struct rtl8125_private *tp, u16 reg, u16 data)
+{
+        u8 x;
+        int addr_sz = 6;
+        int w_dummy_addr = 4;
+
+        if(tp->eeprom_type == EEPROM_TYPE_NONE) {
+                return ;
+        }
+
+        if (tp->eeprom_type==EEPROM_TYPE_93C46) {
+                addr_sz = 6;
+                w_dummy_addr = 4;
+        } else if (tp->eeprom_type==EEPROM_TYPE_93C56) {
+                addr_sz = 8;
+                w_dummy_addr = 6;
+        }
+
+        x = Cfg9346_EEM1 | Cfg9346_EECS;
+        RTL_W8(tp, Cfg9346, x);
+
+        rtl8125_shift_out_bits(tp, RTL_EEPROM_EWEN_OPCODE, 5);
+        rtl8125_shift_out_bits(tp, reg, w_dummy_addr);
+        rtl8125_stand_by(tp);
+
+        rtl8125_shift_out_bits(tp, RTL_EEPROM_ERASE_OPCODE, 3);
+        rtl8125_shift_out_bits(tp, reg, addr_sz);
+        if (rtl8125_eeprom_cmd_done(tp) < 0) {
+                return;
+        }
+        rtl8125_stand_by(tp);
+
+        rtl8125_shift_out_bits(tp, RTL_EEPROM_WRITE_OPCODE, 3);
+        rtl8125_shift_out_bits(tp, reg, addr_sz);
+        rtl8125_shift_out_bits(tp, data, 16);
+        if (rtl8125_eeprom_cmd_done(tp) < 0) {
+                return;
+        }
+        rtl8125_stand_by(tp);
+
+        rtl8125_shift_out_bits(tp, RTL_EEPROM_EWDS_OPCODE, 5);
+        rtl8125_shift_out_bits(tp, reg, w_dummy_addr);
+
+        rtl8125_eeprom_cleanup(tp);
+        RTL_W8(tp, Cfg9346, 0);
+}
+
+void rtl8125_raise_clock(struct rtl8125_private *tp, u8 *x)
+{
+        *x = *x | Cfg9346_EESK;
+        RTL_W8(tp, Cfg9346, *x);
+        udelay(RTL_CLOCK_RATE);
+}
+
+void rtl8125_lower_clock(struct rtl8125_private *tp, u8 *x)
+{
+
+        *x = *x & ~Cfg9346_EESK;
+        RTL_W8(tp, Cfg9346, *x);
+        udelay(RTL_CLOCK_RATE);
+}
+
+void rtl8125_shift_out_bits(struct rtl8125_private *tp, int data, int count)
+{
+        u8 x;
+        int  mask;
+
+        mask = 0x01 << (count - 1);
+        x = RTL_R8(tp, Cfg9346);
+        x &= ~(Cfg9346_EEDI | Cfg9346_EEDO);
+
+        do {
+                if (data & mask)
+                        x |= Cfg9346_EEDI;
+                else
+                        x &= ~Cfg9346_EEDI;
+
+                RTL_W8(tp, Cfg9346, x);
+                udelay(RTL_CLOCK_RATE);
+                rtl8125_raise_clock(tp, &x);
+                rtl8125_lower_clock(tp, &x);
+                mask = mask >> 1;
+        } while(mask);
+
+        x &= ~Cfg9346_EEDI;
+        RTL_W8(tp, Cfg9346, x);
+}
+
+u16 rtl8125_shift_in_bits(struct rtl8125_private *tp)
+{
+        u8 x;
+        u16 d, i;
+
+        x = RTL_R8(tp, Cfg9346);
+        x &= ~(Cfg9346_EEDI | Cfg9346_EEDO);
+
+        d = 0;
+
+        for (i = 0; i < 16; i++) {
+                d = d << 1;
+                rtl8125_raise_clock(tp, &x);
+
+                x = RTL_R8(tp, Cfg9346);
+                x &= ~Cfg9346_EEDI;
+
+                if (x & Cfg9346_EEDO)
+                        d |= 1;
+
+                rtl8125_lower_clock(tp, &x);
+        }
+
+        return d;
+}
+
+void rtl8125_stand_by(struct rtl8125_private *tp)
+{
+        u8 x;
+
+        x = RTL_R8(tp, Cfg9346);
+        x &= ~(Cfg9346_EECS | Cfg9346_EESK);
+        RTL_W8(tp, Cfg9346, x);
+        udelay(RTL_CLOCK_RATE);
+
+        x |= Cfg9346_EECS;
+        RTL_W8(tp, Cfg9346, x);
+}
+
+void rtl8125_set_eeprom_sel_low(struct rtl8125_private *tp)
+{
+        RTL_W8(tp, Cfg9346, Cfg9346_EEM1);
+        RTL_W8(tp, Cfg9346, Cfg9346_EEM1 | Cfg9346_EESK);
+
+        udelay(20);
+
+        RTL_W8(tp, Cfg9346, Cfg9346_EEM1);
+}
diff --git a/drivers/net/ethernet/realtek/r8125/rtl_eeprom.h b/drivers/net/ethernet/realtek/r8125/rtl_eeprom.h
new file mode 100644
index 00000000..81ba88b
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8125/rtl_eeprom.h
@@ -0,0 +1,52 @@
+/*
+################################################################################
+#
+# r8125 is the Linux device driver released for Realtek 2.5Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+//EEPROM opcodes
+#define RTL_EEPROM_READ_OPCODE      06
+#define RTL_EEPROM_WRITE_OPCODE     05
+#define RTL_EEPROM_ERASE_OPCODE     07
+#define RTL_EEPROM_EWEN_OPCODE      19
+#define RTL_EEPROM_EWDS_OPCODE      16
+
+#define RTL_CLOCK_RATE  3
+
+void rtl8125_eeprom_type(struct rtl8125_private *tp);
+void rtl8125_eeprom_cleanup(struct rtl8125_private *tp);
+u16 rtl8125_eeprom_read_sc(struct rtl8125_private *tp, u16 reg);
+void rtl8125_eeprom_write_sc(struct rtl8125_private *tp, u16 reg, u16 data);
+void rtl8125_shift_out_bits(struct rtl8125_private *tp, int data, int count);
+u16 rtl8125_shift_in_bits(struct rtl8125_private *tp);
+void rtl8125_raise_clock(struct rtl8125_private *tp, u8 *x);
+void rtl8125_lower_clock(struct rtl8125_private *tp, u8 *x);
+void rtl8125_stand_by(struct rtl8125_private *tp);
+void rtl8125_set_eeprom_sel_low(struct rtl8125_private *tp);
diff --git a/drivers/net/ethernet/realtek/r8125/rtltool.c b/drivers/net/ethernet/realtek/r8125/rtltool.c
new file mode 100644
index 00000000..a9bb401
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8125/rtltool.c
@@ -0,0 +1,358 @@
+/*
+################################################################################
+#
+# r8125 is the Linux device driver released for Realtek 2.5Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#include <linux/module.h>
+#include <linux/version.h>
+#include <linux/pci.h>
+#include <linux/netdevice.h>
+#include <linux/delay.h>
+#include <linux/in.h>
+#include <linux/ethtool.h>
+#include <asm/uaccess.h>
+#include "r8125.h"
+#include "rtl_eeprom.h"
+#include "rtltool.h"
+
+int rtl8125_tool_ioctl(struct rtl8125_private *tp, struct ifreq *ifr)
+{
+        struct rtltool_cmd my_cmd;
+        unsigned long flags;
+        int ret;
+
+        if (copy_from_user(&my_cmd, ifr->ifr_data, sizeof(my_cmd)))
+                return -EFAULT;
+
+        ret = 0;
+        switch (my_cmd.cmd) {
+        case RTLTOOL_READ_MAC:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.len==1)
+                        my_cmd.data = readb(tp->mmio_addr+my_cmd.offset);
+                else if (my_cmd.len==2)
+                        my_cmd.data = readw(tp->mmio_addr+(my_cmd.offset&~1));
+                else if (my_cmd.len==4)
+                        my_cmd.data = readl(tp->mmio_addr+(my_cmd.offset&~3));
+                else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+                break;
+
+        case RTLTOOL_WRITE_MAC:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.len==1)
+                        writeb(my_cmd.data, tp->mmio_addr+my_cmd.offset);
+                else if (my_cmd.len==2)
+                        writew(my_cmd.data, tp->mmio_addr+(my_cmd.offset&~1));
+                else if (my_cmd.len==4)
+                        writel(my_cmd.data, tp->mmio_addr+(my_cmd.offset&~3));
+                else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_READ_PHY:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                my_cmd.data = rtl8125_mdio_prot_read(tp, my_cmd.offset);
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_WRITE_PHY:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                rtl8125_mdio_prot_write(tp, my_cmd.offset, my_cmd.data);
+                spin_unlock_irqrestore(&tp->lock, flags);
+                break;
+
+        case RTLTOOL_READ_EPHY:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                my_cmd.data = rtl8125_ephy_read(tp, my_cmd.offset);
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_WRITE_EPHY:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                rtl8125_ephy_write(tp, my_cmd.offset, my_cmd.data);
+                spin_unlock_irqrestore(&tp->lock, flags);
+                break;
+
+        case RTLTOOL_READ_ERI:
+                my_cmd.data = 0;
+                if (my_cmd.len==1 || my_cmd.len==2 || my_cmd.len==4) {
+                        spin_lock_irqsave(&tp->lock, flags);
+                        my_cmd.data = rtl8125_eri_read(tp, my_cmd.offset, my_cmd.len, ERIAR_ExGMAC);
+                        spin_unlock_irqrestore(&tp->lock, flags);
+                } else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_WRITE_ERI:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.len==1 || my_cmd.len==2 || my_cmd.len==4) {
+                        spin_lock_irqsave(&tp->lock, flags);
+                        rtl8125_eri_write(tp, my_cmd.offset, my_cmd.len, my_cmd.data, ERIAR_ExGMAC);
+                        spin_unlock_irqrestore(&tp->lock, flags);
+                } else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+                break;
+
+        case RTLTOOL_READ_PCI:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                my_cmd.data = 0;
+                if (my_cmd.len==1)
+                        pci_read_config_byte(tp->pci_dev, my_cmd.offset,
+                                             (u8 *)&my_cmd.data);
+                else if (my_cmd.len==2)
+                        pci_read_config_word(tp->pci_dev, my_cmd.offset,
+                                             (u16 *)&my_cmd.data);
+                else if (my_cmd.len==4)
+                        pci_read_config_dword(tp->pci_dev, my_cmd.offset,
+                                              &my_cmd.data);
+                else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+                break;
+
+        case RTLTOOL_WRITE_PCI:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.len==1)
+                        pci_write_config_byte(tp->pci_dev, my_cmd.offset,
+                                              my_cmd.data);
+                else if (my_cmd.len==2)
+                        pci_write_config_word(tp->pci_dev, my_cmd.offset,
+                                              my_cmd.data);
+                else if (my_cmd.len==4)
+                        pci_write_config_dword(tp->pci_dev, my_cmd.offset,
+                                               my_cmd.data);
+                else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_READ_EEPROM:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                my_cmd.data = rtl8125_eeprom_read_sc(tp, my_cmd.offset);
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_WRITE_EEPROM:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                rtl8125_eeprom_write_sc(tp, my_cmd.offset, my_cmd.data);
+                spin_unlock_irqrestore(&tp->lock, flags);
+                break;
+
+        case RTL_READ_OOB_MAC:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                rtl8125_oob_mutex_lock(tp);
+                my_cmd.data = rtl8125_ocp_read(tp, my_cmd.offset, 4);
+                rtl8125_oob_mutex_unlock(tp);
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+                break;
+
+        case RTL_WRITE_OOB_MAC:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.len == 0 || my_cmd.len > 4)
+                        return -EOPNOTSUPP;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                rtl8125_oob_mutex_lock(tp);
+                rtl8125_ocp_write(tp, my_cmd.offset, my_cmd.len, my_cmd.data);
+                rtl8125_oob_mutex_unlock(tp);
+                spin_unlock_irqrestore(&tp->lock, flags);
+                break;
+
+        case RTL_ENABLE_PCI_DIAG:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                tp->rtk_enable_diag = 1;
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                dprintk("enable rtk diag\n");
+                break;
+
+        case RTL_DISABLE_PCI_DIAG:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                tp->rtk_enable_diag = 0;
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                dprintk("disable rtk diag\n");
+                break;
+
+        case RTL_READ_MAC_OCP:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.offset % 2)
+                        return -EOPNOTSUPP;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                my_cmd.data = rtl8125_mac_ocp_read(tp, my_cmd.offset);
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+                break;
+
+        case RTL_WRITE_MAC_OCP:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if ((my_cmd.offset % 2) || (my_cmd.len != 2))
+                        return -EOPNOTSUPP;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                rtl8125_mac_ocp_write(tp, my_cmd.offset, (u16)my_cmd.data);
+                spin_unlock_irqrestore(&tp->lock, flags);
+                break;
+
+        case RTL_DIRECT_READ_PHY_OCP:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                my_cmd.data = rtl8125_mdio_prot_read_phy_ocp(tp, my_cmd.offset);
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+
+                break;
+
+        case RTL_DIRECT_WRITE_PHY_OCP:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                rtl8125_mdio_prot_write_phy_ocp(tp, my_cmd.offset, my_cmd.data);
+                spin_unlock_irqrestore(&tp->lock, flags);
+                break;
+
+        default:
+                ret = -EOPNOTSUPP;
+                break;
+        }
+
+        return ret;
+}
diff --git a/drivers/net/ethernet/realtek/r8125/rtltool.h b/drivers/net/ethernet/realtek/r8125/rtltool.h
new file mode 100644
index 00000000..c70594e
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8125/rtltool.h
@@ -0,0 +1,85 @@
+/*
+################################################################################
+#
+# r8125 is the Linux device driver released for Realtek 2.5Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#ifndef _LINUX_RTLTOOL_H
+#define _LINUX_RTLTOOL_H
+
+#define SIOCRTLTOOL		SIOCDEVPRIVATE+1
+
+enum rtl_cmd {
+        RTLTOOL_READ_MAC=0,
+        RTLTOOL_WRITE_MAC,
+        RTLTOOL_READ_PHY,
+        RTLTOOL_WRITE_PHY,
+        RTLTOOL_READ_EPHY,
+        RTLTOOL_WRITE_EPHY,
+        RTLTOOL_READ_ERI,
+        RTLTOOL_WRITE_ERI,
+        RTLTOOL_READ_PCI,
+        RTLTOOL_WRITE_PCI,
+        RTLTOOL_READ_EEPROM,
+        RTLTOOL_WRITE_EEPROM,
+
+        RTL_READ_OOB_MAC,
+        RTL_WRITE_OOB_MAC,
+
+        RTL_ENABLE_PCI_DIAG,
+        RTL_DISABLE_PCI_DIAG,
+
+        RTL_READ_MAC_OCP,
+        RTL_WRITE_MAC_OCP,
+
+        RTL_DIRECT_READ_PHY_OCP,
+        RTL_DIRECT_WRITE_PHY_OCP,
+
+        RTLTOOL_INVALID
+};
+
+struct rtltool_cmd {
+        __u32	cmd;
+        __u32	offset;
+        __u32	len;
+        __u32	data;
+};
+
+enum mode_access {
+        MODE_NONE=0,
+        MODE_READ,
+        MODE_WRITE
+};
+
+#ifdef __KERNEL__
+int rtl8125_tool_ioctl(struct rtl8125_private *tp, struct ifreq *ifr);
+#endif
+
+#endif /* _LINUX_RTLTOOL_H */
diff --git a/drivers/net/ethernet/realtek/r8168/Makefile b/drivers/net/ethernet/realtek/r8168/Makefile
new file mode 100644
index 00000000..9665f8f
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/Makefile
@@ -0,0 +1,115 @@
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+
+################################################################################
+#  This product is covered by one or more of the following patents:
+#  US6,570,884, US6,115,776, and US6,327,625.
+################################################################################
+
+CONFIG_SOC_LAN = n
+ENABLE_FIBER_SUPPORT = n
+ENABLE_REALWOW_SUPPORT = n
+ENABLE_DASH_SUPPORT = n
+ENABLE_DASH_PRINTER_SUPPORT = n
+CONFIG_DOWN_SPEED_100 = n
+CONFIG_ASPM = y
+ENABLE_S5WOL = y
+ENABLE_S5_KEEP_CURR_MAC = n
+ENABLE_EEE = n
+ENABLE_S0_MAGIC_PACKET = n
+
+ifneq ($(KERNELRELEASE),)
+	obj-$(CONFIG_R8168) := r8168.o
+	r8168-objs := r8168_n.o r8168_asf.o rtl_eeprom.o rtltool.o
+	ifeq ($(CONFIG_SOC_LAN), y)
+		EXTRA_CFLAGS += -DCONFIG_SOC_LAN
+	endif
+	ifeq ($(ENABLE_FIBER_SUPPORT), y)
+	    r8168-objs += r8168_fiber.o
+		EXTRA_CFLAGS += -DENABLE_FIBER_SUPPORT
+	endif
+	ifeq ($(ENABLE_REALWOW_SUPPORT), y)
+	    r8168-objs += r8168_realwow.o
+		EXTRA_CFLAGS += -DENABLE_REALWOW_SUPPORT
+	endif
+	ifeq ($(ENABLE_DASH_SUPPORT), y)
+	    r8168-objs += r8168_dash.o
+		EXTRA_CFLAGS += -DENABLE_DASH_SUPPORT
+	endif
+	ifeq ($(ENABLE_DASH_PRINTER_SUPPORT), y)
+	    r8168-objs += r8168_dash.o
+		EXTRA_CFLAGS += -DENABLE_DASH_SUPPORT -DENABLE_DASH_PRINTER_SUPPORT
+	endif
+	EXTRA_CFLAGS += -DCONFIG_R8168_NAPI
+	EXTRA_CFLAGS += -DCONFIG_R8168_VLAN
+	ifeq ($(CONFIG_DOWN_SPEED_100), y)
+		EXTRA_CFLAGS += -DCONFIG_DOWN_SPEED_100
+	endif
+	ifeq ($(CONFIG_ASPM), y)
+		EXTRA_CFLAGS += -DCONFIG_ASPM
+	endif
+	ifeq ($(ENABLE_S5WOL), y)
+		EXTRA_CFLAGS += -DENABLE_S5WOL
+	endif
+	ifeq ($(ENABLE_S5_KEEP_CURR_MAC), y)
+		EXTRA_CFLAGS += -DENABLE_S5_KEEP_CURR_MAC
+	endif
+	ifeq ($(ENABLE_EEE), y)
+		EXTRA_CFLAGS += -DENABLE_EEE
+	endif
+	ifeq ($(ENABLE_S0_MAGIC_PACKET), y)
+		EXTRA_CFLAGS += -DENABLE_S0_MAGIC_PACKET
+	endif
+else
+	BASEDIR := /lib/modules/$(shell uname -r)
+	KERNELDIR ?= $(BASEDIR)/build
+	PWD :=$(shell pwd)
+	DRIVERDIR := $(shell find $(BASEDIR)/kernel/drivers/net/ethernet -name realtek -type d)
+	ifeq ($(DRIVERDIR),)
+		DRIVERDIR := $(shell find $(BASEDIR)/kernel/drivers/net -name realtek -type d)
+	endif
+	ifeq ($(DRIVERDIR),)
+		DRIVERDIR := $(BASEDIR)/kernel/drivers/net
+	endif
+	RTKDIR := $(subst $(BASEDIR)/,,$(DRIVERDIR))
+
+.PHONY: all
+all: clean modules install
+
+.PHONY:modules
+modules:
+	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) modules
+
+.PHONY:clean
+clean:
+	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) clean
+
+.PHONY:install
+install:
+	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) INSTALL_MOD_DIR=$(RTKDIR) modules_install
+
+endif
+
diff --git a/drivers/net/ethernet/realtek/r8168/Makefile_linux24x b/drivers/net/ethernet/realtek/r8168/Makefile_linux24x
new file mode 100644
index 00000000..4eeba05
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/Makefile_linux24x
@@ -0,0 +1,74 @@
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+
+################################################################################
+# This product is covered by one or more of the following patents:
+# US6,570,884, US6,115,776, and US6,327,625.
+################################################################################
+
+CC		:= gcc
+LD		:= ld
+ARCH		:= $(shell uname -m | sed 's/i.86/i386/')
+KSRC		:= /lib/modules/$(shell uname -r)/build
+CONFIG_FILE	:= $(KSRC)/include/linux/autoconf.h
+KMISC		:= /lib/modules/$(shell uname -r)/kernel/drivers/net/
+
+
+ifeq ($(ARCH),x86_64)
+   MODCFLAGS	+= -mcmodel=kernel -mno-red-zone
+endif
+
+#standard flags for module builds
+MODCFLAGS	+= -DLINUX -D__KERNEL__ -DMODULE -O2 -pipe -Wall
+MODCFLAGS	+= -I$(KSRC)/include -I.
+MODCFLAGS	+= -DMODVERSIONS -DEXPORT_SYMTAB -include $(KSRC)/include/linux/modversions.h
+SOURCE		:= r8168_n.c r8168_asf.c rtl_eeprom.c rtltool.c
+OBJS		:= $(SOURCE:.c=.o)
+
+
+SMP		:= $(shell $(CC) $(MODCFLAGS) -E -dM $(CONFIG_FILE) | \
+   grep CONFIG_SMP | awk '{print $$3}')
+
+ifneq ($(SMP),1)
+   SMP		:= 0
+endif
+
+ifeq ($(SMP),1)
+   MODCFLAGS	+= -D__SMP__
+endif
+
+modules: $(OBJS)
+	$(LD) -r $^ -o r8168.o
+	strip --strip-debug r8168.o
+
+%.o: %.c
+	$(CC) $(MODCFLAGS) -c $< -o $@
+
+clean:
+	rm *.o -f
+
+install:
+	install -m 744 -c r8168.o $(KMISC)
diff --git a/drivers/net/ethernet/realtek/r8168/r8168.h b/drivers/net/ethernet/realtek/r8168/r8168.h
new file mode 100644
index 00000000..b7f807b
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/r8168.h
@@ -0,0 +1,1796 @@
+/*
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#include <linux/ethtool.h>
+#include "r8168_dash.h"
+#include "r8168_realwow.h"
+#include "r8168_fiber.h"
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+#define skb_transport_offset(skb) (skb->h.raw - skb->data)
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,26)
+#define device_set_wakeup_enable(dev, val)	do {} while (0)
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,14,0)
+static inline void ether_addr_copy(u8 *dst, const u8 *src)
+{
+        u16 *a = (u16 *)dst;
+        const u16 *b = (const u16 *)src;
+
+        a[0] = b[0];
+        a[1] = b[1];
+        a[2] = b[2];
+}
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,15,0)
+#define IS_ERR_OR_NULL(ptr)			(!ptr)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,13,0)
+#define reinit_completion(x)			((x)->done = 0)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,39)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,32)
+#define pm_runtime_mark_last_busy(x)
+#define pm_runtime_put_autosuspend(x)		pm_runtime_put(x)
+#define pm_runtime_put_sync_autosuspend(x)	pm_runtime_put_sync(x)
+
+static inline bool pm_runtime_suspended(struct device *dev)
+{
+        return dev->power.runtime_status == RPM_SUSPENDED
+               && !dev->power.disable_depth;
+}
+
+static inline bool pm_runtime_active(struct device *dev)
+{
+        return dev->power.runtime_status == RPM_ACTIVE
+               || dev->power.disable_depth;
+}
+#endif
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,36)
+#define queue_delayed_work(long_wq, work, delay)	schedule_delayed_work(work, delay)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,34)
+#define netif_printk(priv, type, level, netdev, fmt, args...)	\
+	do {								\
+		if (netif_msg_##type(priv))				\
+			printk(level "%s: " fmt,(netdev)->name , ##args); \
+	} while (0)
+
+#define netif_emerg(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_EMERG, netdev, fmt, ##args)
+#define netif_alert(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_ALERT, netdev, fmt, ##args)
+#define netif_crit(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_CRIT, netdev, fmt, ##args)
+#define netif_err(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_ERR, netdev, fmt, ##args)
+#define netif_warn(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_WARNING, netdev, fmt, ##args)
+#define netif_notice(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_NOTICE, netdev, fmt, ##args)
+#define netif_info(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_INFO, (netdev), fmt, ##args)
+#endif
+#endif
+#endif
+#endif
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,15)
+#define setup_timer(_timer, _function, _data) \
+do { \
+	(_timer)->function = _function; \
+	(_timer)->data = _data; \
+	init_timer(_timer); \
+} while (0)
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,15)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,0,0)
+#if defined(skb_vlan_tag_present) && !defined(vlan_tx_tag_present)
+#define vlan_tx_tag_present skb_vlan_tag_present
+#endif
+#if defined(skb_vlan_tag_get) && !defined(vlan_tx_tag_get)
+#define vlan_tx_tag_get skb_vlan_tag_get
+#endif
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(4,0,0)
+
+#define RTL_ALLOC_SKB_INTR(tp, length) dev_alloc_skb(length)
+#ifdef CONFIG_R8168_NAPI
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,19,0)
+#undef RTL_ALLOC_SKB_INTR
+#define RTL_ALLOC_SKB_INTR(tp, length) napi_alloc_skb(&tp->napi, length)
+#endif
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,0,0)
+#define netdev_features_t  u32
+#endif
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,5,0)
+#define NETIF_F_ALL_CSUM        NETIF_F_CSUM_MASK
+#else
+#ifndef NETIF_F_ALL_CSUM
+#define NETIF_F_ALL_CSUM        NETIF_F_CSUM_MASK
+#endif
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,37)
+#define ENABLE_R8168_PROCFS
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+#define NETIF_F_HW_VLAN_RX	NETIF_F_HW_VLAN_CTAG_RX
+#define NETIF_F_HW_VLAN_TX	NETIF_F_HW_VLAN_CTAG_TX
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,8,0)
+#define __devinit
+#define __devexit
+#define __devexit_p(func)   func
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
+#define CHECKSUM_PARTIAL CHECKSUM_HW
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+#define irqreturn_t void
+#define IRQ_HANDLED    1
+#define IRQ_NONE   0
+#define IRQ_RETVAL(x)
+#endif
+
+#ifndef NETIF_F_RXALL
+#define NETIF_F_RXALL  0
+#endif
+
+#ifndef NETIF_F_RXFCS
+#define NETIF_F_RXFCS  0
+#endif
+
+#ifndef HAVE_FREE_NETDEV
+#define free_netdev(x)  kfree(x)
+#endif
+
+#ifndef SET_NETDEV_DEV
+#define SET_NETDEV_DEV(net, pdev)
+#endif
+
+#ifndef SET_MODULE_OWNER
+#define SET_MODULE_OWNER(dev)
+#endif
+
+#ifndef SA_SHIRQ
+#define SA_SHIRQ IRQF_SHARED
+#endif
+
+#ifndef NETIF_F_GSO
+#define gso_size    tso_size
+#define gso_segs    tso_segs
+#endif
+
+#ifndef PCI_VENDOR_ID_DLINK
+#define PCI_VENDOR_ID_DLINK 0x1186
+#endif
+
+#ifndef dma_mapping_error
+#define dma_mapping_error(a,b) 0
+#endif
+
+#ifndef netif_err
+#define netif_err(a,b,c,d)
+#endif
+
+#ifndef AUTONEG_DISABLE
+#define AUTONEG_DISABLE   0x00
+#endif
+
+#ifndef AUTONEG_ENABLE
+#define AUTONEG_ENABLE    0x01
+#endif
+
+#ifndef BMCR_SPEED1000
+#define BMCR_SPEED1000  0x0040
+#endif
+
+#ifndef BMCR_SPEED100
+#define BMCR_SPEED100   0x2000
+#endif
+
+#ifndef BMCR_SPEED10
+#define BMCR_SPEED10    0x0000
+#endif
+
+#ifndef SPEED_UNKNOWN
+#define SPEED_UNKNOWN   -1
+#endif
+
+#ifndef DUPLEX_UNKNOWN
+#define DUPLEX_UNKNOWN  0xff
+#endif
+
+#ifndef SUPPORTED_Pause
+#define SUPPORTED_Pause  (1 << 13)
+#endif
+
+#ifndef SUPPORTED_Asym_Pause
+#define SUPPORTED_Asym_Pause  (1 << 14)
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+#ifdef CONFIG_NET_POLL_CONTROLLER
+#define RTL_NET_POLL_CONTROLLER dev->poll_controller=rtl8168_netpoll
+#else
+#define RTL_NET_POLL_CONTROLLER
+#endif
+
+#ifdef CONFIG_R8168_VLAN
+#define RTL_SET_VLAN dev->vlan_rx_register=rtl8168_vlan_rx_register
+#else
+#define RTL_SET_VLAN
+#endif
+
+#define RTL_NET_DEVICE_OPS(ops) dev->open=rtl8168_open; \
+                    dev->hard_start_xmit=rtl8168_start_xmit; \
+                    dev->get_stats=rtl8168_get_stats; \
+                    dev->stop=rtl8168_close; \
+                    dev->tx_timeout=rtl8168_tx_timeout; \
+                    dev->set_multicast_list=rtl8168_set_rx_mode; \
+                    dev->change_mtu=rtl8168_change_mtu; \
+                    dev->set_mac_address=rtl8168_set_mac_address; \
+                    dev->do_ioctl=rtl8168_do_ioctl; \
+                    RTL_NET_POLL_CONTROLLER; \
+                    RTL_SET_VLAN;
+#else
+#define RTL_NET_DEVICE_OPS(ops) dev->netdev_ops=&ops
+#endif
+
+#ifndef FALSE
+#define FALSE 0
+#endif
+
+#ifndef TRUE
+#define TRUE  1
+#endif
+
+#ifndef false
+#define false 0
+#endif
+
+#ifndef true
+#define true  1
+#endif
+
+//Hardware will continue interrupt 10 times after interrupt finished.
+#define RTK_KEEP_INTERRUPT_COUNT (10)
+
+//Due to the hardware design of RTL8111B, the low 32 bit address of receive
+//buffer must be 8-byte alignment.
+#ifndef NET_IP_ALIGN
+#define NET_IP_ALIGN        2
+#endif
+#define RTK_RX_ALIGN        8
+
+#ifdef CONFIG_R8168_NAPI
+#define NAPI_SUFFIX "-NAPI"
+#else
+#define NAPI_SUFFIX ""
+#endif
+#ifdef ENABLE_FIBER_SUPPORT
+#define FIBER_SUFFIX "-FIBER"
+#else
+#define FIBER_SUFFIX ""
+#endif
+#ifdef ENABLE_REALWOW_SUPPORT
+#define REALWOW_SUFFIX "-REALWOW"
+#else
+#define REALWOW_SUFFIX ""
+#endif
+#if defined(ENABLE_DASH_PRINTER_SUPPORT)
+#define DASH_SUFFIX "-PRINTER"
+#elif defined(ENABLE_DASH_SUPPORT)
+#define DASH_SUFFIX "-DASH"
+#else
+#define DASH_SUFFIX ""
+#endif
+
+#define RTL8168_VERSION "8.046.00" NAPI_SUFFIX FIBER_SUFFIX REALWOW_SUFFIX DASH_SUFFIX
+#define MODULENAME "r8168"
+#define PFX MODULENAME ": "
+
+#define GPL_CLAIM "\
+r8168  Copyright (C) 2018  Realtek NIC software team <nicfae@realtek.com> \n \
+This program comes with ABSOLUTELY NO WARRANTY; for details, please see <http://www.gnu.org/licenses/>. \n \
+This is free software, and you are welcome to redistribute it under certain conditions; see <http://www.gnu.org/licenses/>. \n"
+
+#ifdef RTL8168_DEBUG
+#define assert(expr) \
+        if(!(expr)) {                   \
+            printk( "Assertion failed! %s,%s,%s,line=%d\n", \
+            #expr,__FILE__,__FUNCTION__,__LINE__);      \
+        }
+#define dprintk(fmt, args...)   do { printk(PFX fmt, ## args); } while (0)
+#else
+#define assert(expr) do {} while (0)
+#define dprintk(fmt, args...)   do {} while (0)
+#endif /* RTL8168_DEBUG */
+
+#define R8168_MSG_DEFAULT \
+    (NETIF_MSG_DRV | NETIF_MSG_PROBE | NETIF_MSG_IFUP | NETIF_MSG_IFDOWN)
+
+#define TX_BUFFS_AVAIL(tp) \
+    (tp->dirty_tx + NUM_TX_DESC - tp->cur_tx - 1)
+
+#ifdef CONFIG_R8168_NAPI
+#define rtl8168_rx_hwaccel_skb      vlan_hwaccel_receive_skb
+#define rtl8168_rx_quota(count, quota)  min(count, quota)
+#else
+#define rtl8168_rx_hwaccel_skb      vlan_hwaccel_rx
+#define rtl8168_rx_quota(count, quota)  count
+#endif
+
+/* MAC address length */
+#ifndef MAC_ADDR_LEN
+#define MAC_ADDR_LEN    6
+#endif
+
+#ifndef MAC_PROTOCOL_LEN
+#define MAC_PROTOCOL_LEN    2
+#endif
+
+#ifndef ETH_FCS_LEN
+#define ETH_FCS_LEN	  4
+#endif
+
+#ifndef NETIF_F_TSO6
+#define NETIF_F_TSO6  0
+#endif
+
+#define Reserved2_data  7
+#define RX_DMA_BURST    7   /* Maximum PCI burst, '6' is 1024 */
+#define TX_DMA_BURST_unlimited  7
+#define TX_DMA_BURST_1024   6
+#define TX_DMA_BURST_512    5
+#define TX_DMA_BURST_256    4
+#define TX_DMA_BURST_128    3
+#define TX_DMA_BURST_64     2
+#define TX_DMA_BURST_32     1
+#define TX_DMA_BURST_16     0
+#define Reserved1_data  0x3F
+#define RxPacketMaxSize 0x3FE8  /* 16K - 1 - ETH_HLEN - VLAN - CRC... */
+#define Jumbo_Frame_1k  ETH_DATA_LEN
+#define Jumbo_Frame_2k  (2*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_3k  (3*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_4k  (4*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_5k  (5*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_6k  (6*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_7k  (7*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_8k  (8*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define Jumbo_Frame_9k  (9*1024 - ETH_HLEN - VLAN_HLEN - ETH_FCS_LEN)
+#define InterFrameGap   0x03    /* 3 means InterFrameGap = the shortest one */
+#define RxEarly_off_V1 (0x07 << 11)
+#define RxEarly_off_V2 (1 << 11)
+#define Rx_Single_fetch_V2 (1 << 14)
+
+#define R8168_REGS_SIZE     (256)
+#define R8168_MAC_REGS_SIZE     (256)
+#define R8168_PHY_REGS_SIZE     (16*2)
+#define R8168_EPHY_REGS_SIZE  	(31*2)
+#define R8168_ERI_REGS_SIZE  	(0x100)
+#define R8168_REGS_DUMP_SIZE     (0x400)
+#define R8168_PCI_REGS_SIZE  	(0x100)
+#define R8168_NAPI_WEIGHT   64
+
+#define RTL8168_TX_TIMEOUT  (6 * HZ)
+#define RTL8168_LINK_TIMEOUT    (1 * HZ)
+#define RTL8168_ESD_TIMEOUT (2 * HZ)
+
+#define NUM_TX_DESC 1024    /* Number of Tx descriptor registers */
+#define NUM_RX_DESC 1024    /* Number of Rx descriptor registers */
+
+#define RX_BUF_SIZE 0x05F3  /* 0x05F3 = 1522bye + 1 */
+#define R8168_TX_RING_BYTES (NUM_TX_DESC * sizeof(struct TxDesc))
+#define R8168_RX_RING_BYTES (NUM_RX_DESC * sizeof(struct RxDesc))
+
+#define NODE_ADDRESS_SIZE 6
+
+#define SHORT_PACKET_PADDING_BUF_SIZE 256
+
+/* write/read MMIO register */
+#define RTL_W8(reg, val8)   writeb ((val8), ioaddr + (reg))
+#define RTL_W16(reg, val16) writew ((val16), ioaddr + (reg))
+#define RTL_W32(reg, val32) writel ((val32), ioaddr + (reg))
+#define RTL_R8(reg)     readb (ioaddr + (reg))
+#define RTL_R16(reg)        readw (ioaddr + (reg))
+#define RTL_R32(reg)        ((unsigned long) readl (ioaddr + (reg)))
+
+#ifndef DMA_64BIT_MASK
+#define DMA_64BIT_MASK  0xffffffffffffffffULL
+#endif
+
+#ifndef DMA_32BIT_MASK
+#define DMA_32BIT_MASK  0x00000000ffffffffULL
+#endif
+
+#ifndef NETDEV_TX_OK
+#define NETDEV_TX_OK 0      /* driver took care of packet */
+#endif
+
+#ifndef NETDEV_TX_BUSY
+#define NETDEV_TX_BUSY 1    /* driver tx path was busy*/
+#endif
+
+#ifndef NETDEV_TX_LOCKED
+#define NETDEV_TX_LOCKED -1 /* driver tx lock was already taken */
+#endif
+
+#ifndef ADVERTISED_Pause
+#define ADVERTISED_Pause    (1 << 13)
+#endif
+
+#ifndef ADVERTISED_Asym_Pause
+#define ADVERTISED_Asym_Pause   (1 << 14)
+#endif
+
+#ifndef ADVERTISE_PAUSE_CAP
+#define ADVERTISE_PAUSE_CAP 0x400
+#endif
+
+#ifndef ADVERTISE_PAUSE_ASYM
+#define ADVERTISE_PAUSE_ASYM    0x800
+#endif
+
+#ifndef MII_CTRL1000
+#define MII_CTRL1000        0x09
+#endif
+
+#ifndef ADVERTISE_1000FULL
+#define ADVERTISE_1000FULL  0x200
+#endif
+
+#ifndef ADVERTISE_1000HALF
+#define ADVERTISE_1000HALF  0x100
+#endif
+
+/*****************************************************************************/
+
+//#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,3)
+#if (( LINUX_VERSION_CODE < KERNEL_VERSION(2,4,27) ) || \
+     (( LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0) ) && \
+      ( LINUX_VERSION_CODE < KERNEL_VERSION(2,6,3) )))
+/* copied from linux kernel 2.6.20 include/linux/netdev.h */
+#define NETDEV_ALIGN        32
+#define NETDEV_ALIGN_CONST  (NETDEV_ALIGN - 1)
+
+static inline void *netdev_priv(struct net_device *dev)
+{
+        return (char *)dev + ((sizeof(struct net_device)
+                               + NETDEV_ALIGN_CONST)
+                              & ~NETDEV_ALIGN_CONST);
+}
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,3)
+
+/*****************************************************************************/
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+#define RTLDEV  tp
+#else
+#define RTLDEV  dev
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+/*****************************************************************************/
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+typedef struct net_device *napi_ptr;
+typedef int *napi_budget;
+
+#define napi dev
+#define RTL_NAPI_CONFIG(ndev, priv, function, weig) ndev->poll=function;    \
+                                ndev->weight=weig;
+#define RTL_NAPI_QUOTA(budget, ndev)            min(*budget, ndev->quota)
+#define RTL_GET_PRIV(stuct_ptr, priv_struct)        netdev_priv(stuct_ptr)
+#define RTL_GET_NETDEV(priv_ptr)
+#define RTL_RX_QUOTA(budget)          *budget
+#define RTL_NAPI_QUOTA_UPDATE(ndev, work_done, budget)  *budget -= work_done;   \
+                                ndev->quota -= work_done;
+#define RTL_NETIF_RX_COMPLETE(dev, napi, work_done)        netif_rx_complete(dev)
+#define RTL_NETIF_RX_SCHEDULE_PREP(dev, napi)       netif_rx_schedule_prep(dev)
+#define __RTL_NETIF_RX_SCHEDULE(dev, napi)      __netif_rx_schedule(dev)
+#define RTL_NAPI_RETURN_VALUE               work_done >= work_to_do
+#define RTL_NAPI_ENABLE(dev, napi)          netif_poll_enable(dev)
+#define RTL_NAPI_DISABLE(dev, napi)         netif_poll_disable(dev)
+#define DMA_BIT_MASK(n) (((n) == 64) ? ~0ULL : ((1ULL<<(n))-1))
+#else
+typedef struct napi_struct *napi_ptr;
+typedef int napi_budget;
+
+#define RTL_NAPI_CONFIG(ndev, priv, function, weight)   netif_napi_add(ndev, &priv->napi, function, weight)
+#define RTL_NAPI_QUOTA(budget, ndev)            min(budget, budget)
+#define RTL_GET_PRIV(stuct_ptr, priv_struct)        container_of(stuct_ptr, priv_struct, stuct_ptr)
+#define RTL_GET_NETDEV(priv_ptr)            struct net_device *dev = priv_ptr->dev;
+#define RTL_RX_QUOTA(budget)          budget
+#define RTL_NAPI_QUOTA_UPDATE(ndev, work_done, budget)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+#define RTL_NETIF_RX_COMPLETE(dev, napi, work_done)        netif_rx_complete(dev, napi)
+#define RTL_NETIF_RX_SCHEDULE_PREP(dev, napi)       netif_rx_schedule_prep(dev, napi)
+#define __RTL_NETIF_RX_SCHEDULE(dev, napi)      __netif_rx_schedule(dev, napi)
+#endif
+#if LINUX_VERSION_CODE == KERNEL_VERSION(2,6,29)
+#define RTL_NETIF_RX_COMPLETE(dev, napi, work_done)        netif_rx_complete(napi)
+#define RTL_NETIF_RX_SCHEDULE_PREP(dev, napi)       netif_rx_schedule_prep(napi)
+#define __RTL_NETIF_RX_SCHEDULE(dev, napi)      __netif_rx_schedule(napi)
+#endif
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,29)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,19,0)
+#define RTL_NETIF_RX_COMPLETE(dev, napi, work_done)        napi_complete_done(napi, work_done)
+#else
+#define RTL_NETIF_RX_COMPLETE(dev, napi, work_done)        napi_complete(napi)
+#endif
+#define RTL_NETIF_RX_SCHEDULE_PREP(dev, napi)       napi_schedule_prep(napi)
+#define __RTL_NETIF_RX_SCHEDULE(dev, napi)      __napi_schedule(napi)
+#endif
+#define RTL_NAPI_RETURN_VALUE work_done
+#define RTL_NAPI_ENABLE(dev, napi)          napi_enable(napi)
+#define RTL_NAPI_DISABLE(dev, napi)         napi_disable(napi)
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,27)
+#define RTL_NAPI_DEL(priv)
+#else
+#define RTL_NAPI_DEL(priv)   netif_napi_del(&priv->napi)
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,27)
+
+/*****************************************************************************/
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
+#ifdef __CHECKER__
+#define __iomem __attribute__((noderef, address_space(2)))
+extern void __chk_io_ptr(void __iomem *);
+#define __bitwise __attribute__((bitwise))
+#else
+#define __iomem
+#define __chk_io_ptr(x) (void)0
+#define __bitwise
+#endif
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
+
+/*****************************************************************************/
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,8)
+#ifdef __CHECKER__
+#define __force __attribute__((force))
+#else
+#define __force
+#endif
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,8)
+
+#ifndef module_param
+#define module_param(v,t,p) MODULE_PARM(v, "i");
+#endif
+
+#ifndef PCI_DEVICE
+#define PCI_DEVICE(vend,dev) \
+    .vendor = (vend), .device = (dev), \
+    .subvendor = PCI_ANY_ID, .subdevice = PCI_ANY_ID
+#endif
+
+/*****************************************************************************/
+/* 2.5.28 => 2.4.23 */
+#if ( LINUX_VERSION_CODE < KERNEL_VERSION(2,5,28) )
+
+static inline void _kc_synchronize_irq(void)
+{
+        synchronize_irq();
+}
+#undef synchronize_irq
+#define synchronize_irq(X) _kc_synchronize_irq()
+
+#include <linux/tqueue.h>
+#define work_struct tq_struct
+#undef INIT_WORK
+#define INIT_WORK(a,b,c) INIT_TQUEUE(a,(void (*)(void *))b,c)
+#undef container_of
+#define container_of list_entry
+#define schedule_work schedule_task
+#define flush_scheduled_work flush_scheduled_tasks
+#endif /* 2.5.28 => 2.4.17 */
+
+/*****************************************************************************/
+/* 2.6.4 => 2.6.0 */
+#if ( LINUX_VERSION_CODE < KERNEL_VERSION(2,6,4) )
+#define MODULE_VERSION(_version) MODULE_INFO(version, _version)
+#endif /* 2.6.4 => 2.6.0 */
+/*****************************************************************************/
+/* 2.6.0 => 2.5.28 */
+#if ( LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0) )
+#define MODULE_INFO(version, _version)
+#ifndef CONFIG_E1000_DISABLE_PACKET_SPLIT
+#define CONFIG_E1000_DISABLE_PACKET_SPLIT 1
+#endif
+
+#define pci_set_consistent_dma_mask(dev,mask) 1
+
+#undef dev_put
+#define dev_put(dev) __dev_put(dev)
+
+#ifndef skb_fill_page_desc
+#define skb_fill_page_desc _kc_skb_fill_page_desc
+extern void _kc_skb_fill_page_desc(struct sk_buff *skb, int i, struct page *page, int off, int size);
+#endif
+
+#ifndef pci_dma_mapping_error
+#define pci_dma_mapping_error _kc_pci_dma_mapping_error
+static inline int _kc_pci_dma_mapping_error(dma_addr_t dma_addr)
+{
+        return dma_addr == 0;
+}
+#endif
+
+#undef ALIGN
+#define ALIGN(x,a) (((x)+(a)-1)&~((a)-1))
+
+#endif /* 2.6.0 => 2.5.28 */
+
+/*****************************************************************************/
+/* 2.4.22 => 2.4.17 */
+#if ( LINUX_VERSION_CODE < KERNEL_VERSION(2,4,22) )
+#define pci_name(x) ((x)->slot_name)
+#endif /* 2.4.22 => 2.4.17 */
+
+/*****************************************************************************/
+/* 2.6.5 => 2.6.0 */
+#if ( LINUX_VERSION_CODE < KERNEL_VERSION(2,6,5) )
+#define pci_dma_sync_single_for_cpu pci_dma_sync_single
+#define pci_dma_sync_single_for_device  pci_dma_sync_single_for_cpu
+#endif /* 2.6.5 => 2.6.0 */
+
+/*****************************************************************************/
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+/*
+ * initialize a work-struct's func and data pointers:
+ */
+#define PREPARE_WORK(_work, _func, _data)           \
+    do {                            \
+        (_work)->func = _func;              \
+        (_work)->data = _data;              \
+    } while (0)
+
+#endif
+/*****************************************************************************/
+/* 2.6.4 => 2.6.0 */
+#if ((LINUX_VERSION_CODE < KERNEL_VERSION(2,4,25) && \
+     LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)) || \
+    (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0) && \
+      LINUX_VERSION_CODE < KERNEL_VERSION(2,6,4)))
+#define ETHTOOL_OPS_COMPAT
+#endif /* 2.6.4 => 2.6.0 */
+
+/*****************************************************************************/
+/* Installations with ethtool version without eeprom, adapter id, or statistics
+ * support */
+
+#ifndef ETH_GSTRING_LEN
+#define ETH_GSTRING_LEN 32
+#endif
+
+#ifndef ETHTOOL_GSTATS
+#define ETHTOOL_GSTATS 0x1d
+#undef ethtool_drvinfo
+#define ethtool_drvinfo k_ethtool_drvinfo
+struct k_ethtool_drvinfo {
+        u32 cmd;
+        char driver[32];
+        char version[32];
+        char fw_version[32];
+        char bus_info[32];
+        char reserved1[32];
+        char reserved2[16];
+        u32 n_stats;
+        u32 testinfo_len;
+        u32 eedump_len;
+        u32 regdump_len;
+};
+
+struct ethtool_stats {
+        u32 cmd;
+        u32 n_stats;
+        u64 data[0];
+};
+#endif /* ETHTOOL_GSTATS */
+
+#ifndef ETHTOOL_PHYS_ID
+#define ETHTOOL_PHYS_ID 0x1c
+#endif /* ETHTOOL_PHYS_ID */
+
+#ifndef ETHTOOL_GSTRINGS
+#define ETHTOOL_GSTRINGS 0x1b
+enum ethtool_stringset {
+        ETH_SS_TEST             = 0,
+        ETH_SS_STATS,
+};
+struct ethtool_gstrings {
+        u32 cmd;            /* ETHTOOL_GSTRINGS */
+        u32 string_set;     /* string set id e.c. ETH_SS_TEST, etc*/
+        u32 len;            /* number of strings in the string set */
+        u8 data[0];
+};
+#endif /* ETHTOOL_GSTRINGS */
+
+#ifndef ETHTOOL_TEST
+#define ETHTOOL_TEST 0x1a
+enum ethtool_test_flags {
+        ETH_TEST_FL_OFFLINE = (1 << 0),
+        ETH_TEST_FL_FAILED  = (1 << 1),
+};
+struct ethtool_test {
+        u32 cmd;
+        u32 flags;
+        u32 reserved;
+        u32 len;
+        u64 data[0];
+};
+#endif /* ETHTOOL_TEST */
+
+#ifndef ETHTOOL_GEEPROM
+#define ETHTOOL_GEEPROM 0xb
+#undef ETHTOOL_GREGS
+struct ethtool_eeprom {
+        u32 cmd;
+        u32 magic;
+        u32 offset;
+        u32 len;
+        u8 data[0];
+};
+
+struct ethtool_value {
+        u32 cmd;
+        u32 data;
+};
+#endif /* ETHTOOL_GEEPROM */
+
+#ifndef ETHTOOL_GLINK
+#define ETHTOOL_GLINK 0xa
+#endif /* ETHTOOL_GLINK */
+
+#ifndef ETHTOOL_GREGS
+#define ETHTOOL_GREGS       0x00000004 /* Get NIC registers */
+#define ethtool_regs _kc_ethtool_regs
+/* for passing big chunks of data */
+struct _kc_ethtool_regs {
+        u32 cmd;
+        u32 version; /* driver-specific, indicates different chips/revs */
+        u32 len; /* bytes */
+        u8 data[0];
+};
+#endif /* ETHTOOL_GREGS */
+
+#ifndef ETHTOOL_GMSGLVL
+#define ETHTOOL_GMSGLVL     0x00000007 /* Get driver message level */
+#endif
+#ifndef ETHTOOL_SMSGLVL
+#define ETHTOOL_SMSGLVL     0x00000008 /* Set driver msg level, priv. */
+#endif
+#ifndef ETHTOOL_NWAY_RST
+#define ETHTOOL_NWAY_RST    0x00000009 /* Restart autonegotiation, priv */
+#endif
+#ifndef ETHTOOL_GLINK
+#define ETHTOOL_GLINK       0x0000000a /* Get link status */
+#endif
+#ifndef ETHTOOL_GEEPROM
+#define ETHTOOL_GEEPROM     0x0000000b /* Get EEPROM data */
+#endif
+#ifndef ETHTOOL_SEEPROM
+#define ETHTOOL_SEEPROM     0x0000000c /* Set EEPROM data */
+#endif
+#ifndef ETHTOOL_GCOALESCE
+#define ETHTOOL_GCOALESCE   0x0000000e /* Get coalesce config */
+/* for configuring coalescing parameters of chip */
+#define ethtool_coalesce _kc_ethtool_coalesce
+struct _kc_ethtool_coalesce {
+        u32 cmd;    /* ETHTOOL_{G,S}COALESCE */
+
+        /* How many usecs to delay an RX interrupt after
+         * a packet arrives.  If 0, only rx_max_coalesced_frames
+         * is used.
+         */
+        u32 rx_coalesce_usecs;
+
+        /* How many packets to delay an RX interrupt after
+         * a packet arrives.  If 0, only rx_coalesce_usecs is
+         * used.  It is illegal to set both usecs and max frames
+         * to zero as this would cause RX interrupts to never be
+         * generated.
+         */
+        u32 rx_max_coalesced_frames;
+
+        /* Same as above two parameters, except that these values
+         * apply while an IRQ is being serviced by the host.  Not
+         * all cards support this feature and the values are ignored
+         * in that case.
+         */
+        u32 rx_coalesce_usecs_irq;
+        u32 rx_max_coalesced_frames_irq;
+
+        /* How many usecs to delay a TX interrupt after
+         * a packet is sent.  If 0, only tx_max_coalesced_frames
+         * is used.
+         */
+        u32 tx_coalesce_usecs;
+
+        /* How many packets to delay a TX interrupt after
+         * a packet is sent.  If 0, only tx_coalesce_usecs is
+         * used.  It is illegal to set both usecs and max frames
+         * to zero as this would cause TX interrupts to never be
+         * generated.
+         */
+        u32 tx_max_coalesced_frames;
+
+        /* Same as above two parameters, except that these values
+         * apply while an IRQ is being serviced by the host.  Not
+         * all cards support this feature and the values are ignored
+         * in that case.
+         */
+        u32 tx_coalesce_usecs_irq;
+        u32 tx_max_coalesced_frames_irq;
+
+        /* How many usecs to delay in-memory statistics
+         * block updates.  Some drivers do not have an in-memory
+         * statistic block, and in such cases this value is ignored.
+         * This value must not be zero.
+         */
+        u32 stats_block_coalesce_usecs;
+
+        /* Adaptive RX/TX coalescing is an algorithm implemented by
+         * some drivers to improve latency under low packet rates and
+         * improve throughput under high packet rates.  Some drivers
+         * only implement one of RX or TX adaptive coalescing.  Anything
+         * not implemented by the driver causes these values to be
+         * silently ignored.
+         */
+        u32 use_adaptive_rx_coalesce;
+        u32 use_adaptive_tx_coalesce;
+
+        /* When the packet rate (measured in packets per second)
+         * is below pkt_rate_low, the {rx,tx}_*_low parameters are
+         * used.
+         */
+        u32 pkt_rate_low;
+        u32 rx_coalesce_usecs_low;
+        u32 rx_max_coalesced_frames_low;
+        u32 tx_coalesce_usecs_low;
+        u32 tx_max_coalesced_frames_low;
+
+        /* When the packet rate is below pkt_rate_high but above
+         * pkt_rate_low (both measured in packets per second) the
+         * normal {rx,tx}_* coalescing parameters are used.
+         */
+
+        /* When the packet rate is (measured in packets per second)
+         * is above pkt_rate_high, the {rx,tx}_*_high parameters are
+         * used.
+         */
+        u32 pkt_rate_high;
+        u32 rx_coalesce_usecs_high;
+        u32 rx_max_coalesced_frames_high;
+        u32 tx_coalesce_usecs_high;
+        u32 tx_max_coalesced_frames_high;
+
+        /* How often to do adaptive coalescing packet rate sampling,
+         * measured in seconds.  Must not be zero.
+         */
+        u32 rate_sample_interval;
+};
+#endif /* ETHTOOL_GCOALESCE */
+
+#ifndef ETHTOOL_SCOALESCE
+#define ETHTOOL_SCOALESCE   0x0000000f /* Set coalesce config. */
+#endif
+#ifndef ETHTOOL_GRINGPARAM
+#define ETHTOOL_GRINGPARAM  0x00000010 /* Get ring parameters */
+/* for configuring RX/TX ring parameters */
+#define ethtool_ringparam _kc_ethtool_ringparam
+struct _kc_ethtool_ringparam {
+        u32 cmd;    /* ETHTOOL_{G,S}RINGPARAM */
+
+        /* Read only attributes.  These indicate the maximum number
+         * of pending RX/TX ring entries the driver will allow the
+         * user to set.
+         */
+        u32 rx_max_pending;
+        u32 rx_mini_max_pending;
+        u32 rx_jumbo_max_pending;
+        u32 tx_max_pending;
+
+        /* Values changeable by the user.  The valid values are
+         * in the range 1 to the "*_max_pending" counterpart above.
+         */
+        u32 rx_pending;
+        u32 rx_mini_pending;
+        u32 rx_jumbo_pending;
+        u32 tx_pending;
+};
+#endif /* ETHTOOL_GRINGPARAM */
+
+#ifndef ETHTOOL_SRINGPARAM
+#define ETHTOOL_SRINGPARAM  0x00000011 /* Set ring parameters, priv. */
+#endif
+#ifndef ETHTOOL_GPAUSEPARAM
+#define ETHTOOL_GPAUSEPARAM 0x00000012 /* Get pause parameters */
+/* for configuring link flow control parameters */
+#define ethtool_pauseparam _kc_ethtool_pauseparam
+struct _kc_ethtool_pauseparam {
+        u32 cmd;    /* ETHTOOL_{G,S}PAUSEPARAM */
+
+        /* If the link is being auto-negotiated (via ethtool_cmd.autoneg
+         * being true) the user may set 'autonet' here non-zero to have the
+         * pause parameters be auto-negotiated too.  In such a case, the
+         * {rx,tx}_pause values below determine what capabilities are
+         * advertised.
+         *
+         * If 'autoneg' is zero or the link is not being auto-negotiated,
+         * then {rx,tx}_pause force the driver to use/not-use pause
+         * flow control.
+         */
+        u32 autoneg;
+        u32 rx_pause;
+        u32 tx_pause;
+};
+#endif /* ETHTOOL_GPAUSEPARAM */
+
+#ifndef ETHTOOL_SPAUSEPARAM
+#define ETHTOOL_SPAUSEPARAM 0x00000013 /* Set pause parameters. */
+#endif
+#ifndef ETHTOOL_GRXCSUM
+#define ETHTOOL_GRXCSUM     0x00000014 /* Get RX hw csum enable (ethtool_value) */
+#endif
+#ifndef ETHTOOL_SRXCSUM
+#define ETHTOOL_SRXCSUM     0x00000015 /* Set RX hw csum enable (ethtool_value) */
+#endif
+#ifndef ETHTOOL_GTXCSUM
+#define ETHTOOL_GTXCSUM     0x00000016 /* Get TX hw csum enable (ethtool_value) */
+#endif
+#ifndef ETHTOOL_STXCSUM
+#define ETHTOOL_STXCSUM     0x00000017 /* Set TX hw csum enable (ethtool_value) */
+#endif
+#ifndef ETHTOOL_GSG
+#define ETHTOOL_GSG     0x00000018 /* Get scatter-gather enable
+* (ethtool_value) */
+#endif
+#ifndef ETHTOOL_SSG
+#define ETHTOOL_SSG     0x00000019 /* Set scatter-gather enable
+* (ethtool_value). */
+#endif
+#ifndef ETHTOOL_TEST
+#define ETHTOOL_TEST        0x0000001a /* execute NIC self-test, priv. */
+#endif
+#ifndef ETHTOOL_GSTRINGS
+#define ETHTOOL_GSTRINGS    0x0000001b /* get specified string set */
+#endif
+#ifndef ETHTOOL_PHYS_ID
+#define ETHTOOL_PHYS_ID     0x0000001c /* identify the NIC */
+#endif
+#ifndef ETHTOOL_GSTATS
+#define ETHTOOL_GSTATS      0x0000001d /* get NIC-specific statistics */
+#endif
+#ifndef ETHTOOL_GTSO
+#define ETHTOOL_GTSO        0x0000001e /* Get TSO enable (ethtool_value) */
+#endif
+#ifndef ETHTOOL_STSO
+#define ETHTOOL_STSO        0x0000001f /* Set TSO enable (ethtool_value) */
+#endif
+
+#ifndef ETHTOOL_BUSINFO_LEN
+#define ETHTOOL_BUSINFO_LEN 32
+#endif
+
+/*****************************************************************************/
+
+enum RTL8168_DSM_STATE {
+        DSM_MAC_INIT = 1,
+        DSM_NIC_GOTO_D3 = 2,
+        DSM_IF_DOWN = 3,
+        DSM_NIC_RESUME_D3 = 4,
+        DSM_IF_UP = 5,
+};
+
+enum RTL8168_registers {
+        MAC0            = 0x00,     /* Ethernet hardware address. */
+        MAC4            = 0x04,
+        MAR0            = 0x08,     /* Multicast filter. */
+        CounterAddrLow      = 0x10,
+        CounterAddrHigh     = 0x14,
+        CustomLED       = 0x18,
+        TxDescStartAddrLow  = 0x20,
+        TxDescStartAddrHigh = 0x24,
+        TxHDescStartAddrLow = 0x28,
+        TxHDescStartAddrHigh    = 0x2c,
+        FLASH           = 0x30,
+        ERSR            = 0x36,
+        ChipCmd         = 0x37,
+        TxPoll          = 0x38,
+        IntrMask        = 0x3C,
+        IntrStatus      = 0x3E,
+        TxConfig        = 0x40,
+        RxConfig        = 0x44,
+        TCTR            = 0x48,
+        Cfg9346         = 0x50,
+        Config0         = 0x51,
+        Config1         = 0x52,
+        Config2         = 0x53,
+        Config3         = 0x54,
+        Config4         = 0x55,
+        Config5         = 0x56,
+        TDFNR           = 0x57,
+        TimeInt0        = 0x58,
+        TimeInt1        = 0x5C,
+        PHYAR           = 0x60,
+        CSIDR           = 0x64,
+        CSIAR           = 0x68,
+        PHYstatus       = 0x6C,
+        MACDBG          = 0x6D,
+        GPIO            = 0x6E,
+        PMCH            = 0x6F,
+        ERIDR           = 0x70,
+        ERIAR           = 0x74,
+        EPHY_RXER_NUM   = 0x7C,
+        EPHYAR          = 0x80,
+        TimeInt2        = 0x8C,
+        OCPDR           = 0xB0,
+        MACOCP          = 0xB0,
+        OCPAR           = 0xB4,
+        SecMAC0         = 0xB4,
+        SecMAC4         = 0xB8,
+        PHYOCP          = 0xB8,
+        DBG_reg         = 0xD1,
+        TwiCmdReg       = 0xD2,
+        MCUCmd_reg      = 0xD3,
+        RxMaxSize       = 0xDA,
+        EFUSEAR         = 0xDC,
+        CPlusCmd        = 0xE0,
+        IntrMitigate    = 0xE2,
+        RxDescAddrLow   = 0xE4,
+        RxDescAddrHigh  = 0xE8,
+        MTPS            = 0xEC,
+        FuncEvent       = 0xF0,
+        PPSW            = 0xF2,
+        FuncEventMask   = 0xF4,
+        TimeInt3        = 0xF4,
+        FuncPresetState = 0xF8,
+        CMAC_IBCR0      = 0xF8,
+        CMAC_IBCR2      = 0xF9,
+        CMAC_IBIMR0     = 0xFA,
+        CMAC_IBISR0     = 0xFB,
+        FuncForceEvent  = 0xFC,
+};
+
+enum RTL8168_register_content {
+        /* InterruptStatusBits */
+        SYSErr      = 0x8000,
+        PCSTimeout  = 0x4000,
+        SWInt       = 0x0100,
+        TxDescUnavail   = 0x0080,
+        RxFIFOOver  = 0x0040,
+        LinkChg     = 0x0020,
+        RxDescUnavail   = 0x0010,
+        TxErr       = 0x0008,
+        TxOK        = 0x0004,
+        RxErr       = 0x0002,
+        RxOK        = 0x0001,
+
+        /* RxStatusDesc */
+        RxRWT = (1 << 22),
+        RxRES = (1 << 21),
+        RxRUNT = (1 << 20),
+        RxCRC = (1 << 19),
+
+        /* ChipCmdBits */
+        StopReq  = 0x80,
+        CmdReset = 0x10,
+        CmdRxEnb = 0x08,
+        CmdTxEnb = 0x04,
+        RxBufEmpty = 0x01,
+
+        /* Cfg9346Bits */
+        Cfg9346_Lock = 0x00,
+        Cfg9346_Unlock = 0xC0,
+        Cfg9346_EEDO = (1 << 0),
+        Cfg9346_EEDI = (1 << 1),
+        Cfg9346_EESK = (1 << 2),
+        Cfg9346_EECS = (1 << 3),
+        Cfg9346_EEM0 = (1 << 6),
+        Cfg9346_EEM1 = (1 << 7),
+
+        /* rx_mode_bits */
+        AcceptErr = 0x20,
+        AcceptRunt = 0x10,
+        AcceptBroadcast = 0x08,
+        AcceptMulticast = 0x04,
+        AcceptMyPhys = 0x02,
+        AcceptAllPhys = 0x01,
+
+        /* Transmit Priority Polling*/
+        HPQ = 0x80,
+        NPQ = 0x40,
+        FSWInt = 0x01,
+
+        /* RxConfigBits */
+        Reserved2_shift = 13,
+        RxCfgDMAShift = 8,
+        RxCfg_128_int_en = (1 << 15),
+        RxCfg_fet_multi_en = (1 << 14),
+        RxCfg_half_refetch = (1 << 13),
+        RxCfg_9356SEL = (1 << 6),
+
+        /* TxConfigBits */
+        TxInterFrameGapShift = 24,
+        TxDMAShift = 8, /* DMA burst value (0-7) is shift this many bits */
+        TxMACLoopBack = (1 << 17),  /* MAC loopback */
+
+        /* Config1 register */
+        LEDS1       = (1 << 7),
+        LEDS0       = (1 << 6),
+        Speed_down  = (1 << 4),
+        MEMMAP      = (1 << 3),
+        IOMAP       = (1 << 2),
+        VPD         = (1 << 1),
+        PMEnable    = (1 << 0), /* Power Management Enable */
+
+        /* Config2 register */
+        PMSTS_En    = (1 << 5),
+
+        /* Config3 register */
+        Isolate_en  = (1 << 12), /* Isolate enable */
+        MagicPacket = (1 << 5), /* Wake up when receives a Magic Packet */
+        LinkUp      = (1 << 4), /* This bit is reserved in RTL8168B.*/
+        /* Wake up when the cable connection is re-established */
+        ECRCEN      = (1 << 3), /* This bit is reserved in RTL8168B*/
+        Jumbo_En0   = (1 << 2), /* This bit is reserved in RTL8168B*/
+        RDY_TO_L23  = (1 << 1), /* This bit is reserved in RTL8168B*/
+        Beacon_en   = (1 << 0), /* This bit is reserved in RTL8168B*/
+
+        /* Config4 register */
+        Jumbo_En1   = (1 << 1), /* This bit is reserved in RTL8168B*/
+
+        /* Config5 register */
+        BWF     = (1 << 6), /* Accept Broadcast wakeup frame */
+        MWF     = (1 << 5), /* Accept Multicast wakeup frame */
+        UWF     = (1 << 4), /* Accept Unicast wakeup frame */
+        LanWake     = (1 << 1), /* LanWake enable/disable */
+        PMEStatus   = (1 << 0), /* PME status can be reset by PCI RST# */
+
+        /* CPlusCmd */
+        EnableBist  = (1 << 15),
+        Macdbgo_oe  = (1 << 14),
+        Normal_mode = (1 << 13),
+        Force_halfdup   = (1 << 12),
+        Force_rxflow_en = (1 << 11),
+        Force_txflow_en = (1 << 10),
+        Cxpl_dbg_sel    = (1 << 9),//This bit is reserved in RTL8168B
+        ASF     = (1 << 8),//This bit is reserved in RTL8168C
+        PktCntrDisable  = (1 << 7),
+        RxVlan      = (1 << 6),
+        RxChkSum    = (1 << 5),
+        Macdbgo_sel = 0x001C,
+        INTT_0      = 0x0000,
+        INTT_1      = 0x0001,
+        INTT_2      = 0x0002,
+        INTT_3      = 0x0003,
+
+        /* rtl8168_PHYstatus */
+        PowerSaveStatus = 0x80,
+        TxFlowCtrl = 0x40,
+        RxFlowCtrl = 0x20,
+        _1000bpsF = 0x10,
+        _100bps = 0x08,
+        _10bps = 0x04,
+        LinkStatus = 0x02,
+        FullDup = 0x01,
+
+        /* DBG_reg */
+        Fix_Nak_1 = (1 << 4),
+        Fix_Nak_2 = (1 << 3),
+        DBGPIN_E2 = (1 << 0),
+
+        /* ResetCounterCommand */
+        CounterReset = 0x1,
+        /* DumpCounterCommand */
+        CounterDump = 0x8,
+
+        /* PHY access */
+        PHYAR_Flag = 0x80000000,
+        PHYAR_Write = 0x80000000,
+        PHYAR_Read = 0x00000000,
+        PHYAR_Reg_Mask = 0x1f,
+        PHYAR_Reg_shift = 16,
+        PHYAR_Data_Mask = 0xffff,
+
+        /* EPHY access */
+        EPHYAR_Flag = 0x80000000,
+        EPHYAR_Write = 0x80000000,
+        EPHYAR_Read = 0x00000000,
+        EPHYAR_Reg_Mask = 0x3f,
+        EPHYAR_Reg_shift = 16,
+        EPHYAR_Data_Mask = 0xffff,
+
+        /* CSI access */
+        CSIAR_Flag = 0x80000000,
+        CSIAR_Write = 0x80000000,
+        CSIAR_Read = 0x00000000,
+        CSIAR_ByteEn = 0x0f,
+        CSIAR_ByteEn_shift = 12,
+        CSIAR_Addr_Mask = 0x0fff,
+
+        /* ERI access */
+        ERIAR_Flag = 0x80000000,
+        ERIAR_Write = 0x80000000,
+        ERIAR_Read = 0x00000000,
+        ERIAR_Addr_Align = 4, /* ERI access register address must be 4 byte alignment */
+        ERIAR_ExGMAC = 0,
+        ERIAR_MSIX = 1,
+        ERIAR_ASF = 2,
+        ERIAR_OOB = 2,
+        ERIAR_Type_shift = 16,
+        ERIAR_ByteEn = 0x0f,
+        ERIAR_ByteEn_shift = 12,
+
+        /* OCP GPHY access */
+        OCPDR_Write = 0x80000000,
+        OCPDR_Read = 0x00000000,
+        OCPDR_Reg_Mask = 0xFF,
+        OCPDR_Data_Mask = 0xFFFF,
+        OCPDR_GPHY_Reg_shift = 16,
+        OCPAR_Flag = 0x80000000,
+        OCPAR_GPHY_Write = 0x8000F060,
+        OCPAR_GPHY_Read = 0x0000F060,
+        OCPR_Write = 0x80000000,
+        OCPR_Read = 0x00000000,
+        OCPR_Addr_Reg_shift = 16,
+        OCPR_Flag = 0x80000000,
+        OCP_STD_PHY_BASE_PAGE = 0x0A40,
+
+        /* MCU Command */
+        Now_is_oob = (1 << 7),
+        Txfifo_empty = (1 << 5),
+        Rxfifo_empty = (1 << 4),
+
+        /* E-FUSE access */
+        EFUSE_WRITE = 0x80000000,
+        EFUSE_WRITE_OK  = 0x00000000,
+        EFUSE_READ  = 0x00000000,
+        EFUSE_READ_OK   = 0x80000000,
+        EFUSE_WRITE_V3 = 0x40000000,
+        EFUSE_WRITE_OK_V3  = 0x00000000,
+        EFUSE_READ_V3  = 0x80000000,
+        EFUSE_READ_OK_V3   = 0x00000000,
+        EFUSE_Reg_Mask  = 0x03FF,
+        EFUSE_Reg_Shift = 8,
+        EFUSE_Check_Cnt = 300,
+        EFUSE_READ_FAIL = 0xFF,
+        EFUSE_Data_Mask = 0x000000FF,
+
+        /* GPIO */
+        GPIO_en = (1 << 0),
+
+};
+
+enum _DescStatusBit {
+        DescOwn     = (1 << 31), /* Descriptor is owned by NIC */
+        RingEnd     = (1 << 30), /* End of descriptor ring */
+        FirstFrag   = (1 << 29), /* First segment of a packet */
+        LastFrag    = (1 << 28), /* Final segment of a packet */
+
+        /* Tx private */
+        /*------ offset 0 of tx descriptor ------*/
+        LargeSend   = (1 << 27), /* TCP Large Send Offload (TSO) */
+        GiantSendv4 = (1 << 26), /* TCP Giant Send Offload V4 (GSOv4) */
+        GiantSendv6 = (1 << 25), /* TCP Giant Send Offload V6 (GSOv6) */
+        LargeSend_DP = (1 << 16), /* TCP Large Send Offload (TSO) */
+        MSSShift    = 16,        /* MSS value position */
+        MSSMask     = 0x7FFU,    /* MSS value 11 bits */
+        TxIPCS      = (1 << 18), /* Calculate IP checksum */
+        TxUDPCS     = (1 << 17), /* Calculate UDP/IP checksum */
+        TxTCPCS     = (1 << 16), /* Calculate TCP/IP checksum */
+        TxVlanTag   = (1 << 17), /* Add VLAN tag */
+
+        /*@@@@@@ offset 4 of tx descriptor => bits for RTL8168C/CP only     begin @@@@@@*/
+        TxUDPCS_C   = (1 << 31), /* Calculate UDP/IP checksum */
+        TxTCPCS_C   = (1 << 30), /* Calculate TCP/IP checksum */
+        TxIPCS_C    = (1 << 29), /* Calculate IP checksum */
+        TxIPV6F_C   = (1 << 28), /* Indicate it is an IPv6 packet */
+        /*@@@@@@ offset 4 of tx descriptor => bits for RTL8168C/CP only     end @@@@@@*/
+
+
+        /* Rx private */
+        /*------ offset 0 of rx descriptor ------*/
+        PID1        = (1 << 18), /* Protocol ID bit 1/2 */
+        PID0        = (1 << 17), /* Protocol ID bit 2/2 */
+
+#define RxProtoUDP  (PID1)
+#define RxProtoTCP  (PID0)
+#define RxProtoIP   (PID1 | PID0)
+#define RxProtoMask RxProtoIP
+
+        RxIPF       = (1 << 16), /* IP checksum failed */
+        RxUDPF      = (1 << 15), /* UDP/IP checksum failed */
+        RxTCPF      = (1 << 14), /* TCP/IP checksum failed */
+        RxVlanTag   = (1 << 16), /* VLAN tag available */
+
+        /*@@@@@@ offset 0 of rx descriptor => bits for RTL8168C/CP only     begin @@@@@@*/
+        RxUDPT      = (1 << 18),
+        RxTCPT      = (1 << 17),
+        /*@@@@@@ offset 0 of rx descriptor => bits for RTL8168C/CP only     end @@@@@@*/
+
+        /*@@@@@@ offset 4 of rx descriptor => bits for RTL8168C/CP only     begin @@@@@@*/
+        RxV6F       = (1 << 31),
+        RxV4F       = (1 << 30),
+        /*@@@@@@ offset 4 of rx descriptor => bits for RTL8168C/CP only     end @@@@@@*/
+};
+
+enum features {
+//  RTL_FEATURE_WOL = (1 << 0),
+        RTL_FEATURE_MSI = (1 << 1),
+};
+
+enum wol_capability {
+        WOL_DISABLED = 0,
+        WOL_ENABLED = 1
+};
+
+enum bits {
+        BIT_0 = (1 << 0),
+        BIT_1 = (1 << 1),
+        BIT_2 = (1 << 2),
+        BIT_3 = (1 << 3),
+        BIT_4 = (1 << 4),
+        BIT_5 = (1 << 5),
+        BIT_6 = (1 << 6),
+        BIT_7 = (1 << 7),
+        BIT_8 = (1 << 8),
+        BIT_9 = (1 << 9),
+        BIT_10 = (1 << 10),
+        BIT_11 = (1 << 11),
+        BIT_12 = (1 << 12),
+        BIT_13 = (1 << 13),
+        BIT_14 = (1 << 14),
+        BIT_15 = (1 << 15),
+        BIT_16 = (1 << 16),
+        BIT_17 = (1 << 17),
+        BIT_18 = (1 << 18),
+        BIT_19 = (1 << 19),
+        BIT_20 = (1 << 20),
+        BIT_21 = (1 << 21),
+        BIT_22 = (1 << 22),
+        BIT_23 = (1 << 23),
+        BIT_24 = (1 << 24),
+        BIT_25 = (1 << 25),
+        BIT_26 = (1 << 26),
+        BIT_27 = (1 << 27),
+        BIT_28 = (1 << 28),
+        BIT_29 = (1 << 29),
+        BIT_30 = (1 << 30),
+        BIT_31 = (1 << 31)
+};
+
+enum effuse {
+        EFUSE_NOT_SUPPORT = 0,
+        EFUSE_SUPPORT_V1,
+        EFUSE_SUPPORT_V2,
+        EFUSE_SUPPORT_V3,
+};
+#define RsvdMask    0x3fffc000
+
+struct TxDesc {
+        u32 opts1;
+        u32 opts2;
+        u64 addr;
+};
+
+struct RxDesc {
+        u32 opts1;
+        u32 opts2;
+        u64 addr;
+};
+
+struct ring_info {
+        struct sk_buff  *skb;
+        u32     len;
+        u8      __pad[sizeof(void *) - sizeof(u32)];
+};
+
+struct pci_resource {
+        u8  cmd;
+        u8  cls;
+        u16 io_base_h;
+        u16 io_base_l;
+        u16 mem_base_h;
+        u16 mem_base_l;
+        u8  ilr;
+        u16 resv_0x1c_h;
+        u16 resv_0x1c_l;
+        u16 resv_0x20_h;
+        u16 resv_0x20_l;
+        u16 resv_0x24_h;
+        u16 resv_0x24_l;
+        u16 resv_0x2c_h;
+        u16 resv_0x2c_l;
+        u32 pci_sn_l;
+        u32 pci_sn_h;
+};
+
+struct rtl8168_private {
+        void __iomem *mmio_addr;    /* memory map physical address */
+        struct pci_dev *pci_dev;    /* Index of PCI device */
+        struct net_device *dev;
+#ifdef CONFIG_R8168_NAPI
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,24)
+        struct napi_struct napi;
+#endif
+#endif
+        struct net_device_stats stats;  /* statistics of net device */
+        spinlock_t lock;        /* spin lock flag */
+        spinlock_t phy_lock;        /* spin lock flag for GPHY */
+        u32 msg_enable;
+        u32 tx_tcp_csum_cmd;
+        u32 tx_udp_csum_cmd;
+        u32 tx_ip_csum_cmd;
+        u32 tx_ipv6_csum_cmd;
+        int max_jumbo_frame_size;
+        int chipset;
+        u32 mcfg;
+        u32 cur_rx; /* Index into the Rx descriptor buffer of next Rx pkt. */
+        u32 cur_tx; /* Index into the Tx descriptor buffer of next Rx pkt. */
+        u32 dirty_rx;
+        u32 dirty_tx;
+        struct TxDesc *TxDescArray; /* 256-aligned Tx descriptor ring */
+        struct RxDesc *RxDescArray; /* 256-aligned Rx descriptor ring */
+        dma_addr_t TxPhyAddr;
+        dma_addr_t RxPhyAddr;
+        struct sk_buff *Rx_skbuff[NUM_RX_DESC]; /* Rx data buffers */
+        struct ring_info tx_skb[NUM_TX_DESC];   /* Tx data buffers */
+        unsigned rx_buf_sz;
+        struct timer_list esd_timer;
+        struct timer_list link_timer;
+        struct pci_resource pci_cfg_space;
+        unsigned int esd_flag;
+        unsigned int pci_cfg_is_read;
+        unsigned int rtl8168_rx_config;
+        u16 cp_cmd;
+        u16 intr_mask;
+        u16 timer_intr_mask;
+        int phy_auto_nego_reg;
+        int phy_1000_ctrl_reg;
+        u8 org_mac_addr[NODE_ADDRESS_SIZE];
+        struct rtl8168_counters *tally_vaddr;
+        dma_addr_t tally_paddr;
+
+#ifdef CONFIG_R8168_VLAN
+        struct vlan_group *vlgrp;
+#endif
+        u8  wol_enabled;
+        u32 wol_opts;
+        u8  efuse_ver;
+        u8  eeprom_type;
+        u8  autoneg;
+        u8  duplex;
+        u32 speed;
+        u32 advertising;
+        u16 eeprom_len;
+        u16 cur_page;
+        u32 bios_setting;
+
+        int (*set_speed)(struct net_device *, u8 autoneg, u32 speed, u8 duplex, u32 adv);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+        void (*get_settings)(struct net_device *, struct ethtool_cmd *);
+#else
+        void (*get_settings)(struct net_device *, struct ethtool_link_ksettings *);
+#endif
+        void (*phy_reset_enable)(struct net_device *);
+        unsigned int (*phy_reset_pending)(struct net_device *);
+        unsigned int (*link_ok)(struct net_device *);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+        struct work_struct task;
+#else
+        struct delayed_work task;
+#endif
+        unsigned features;
+
+        u8 org_pci_offset_99;
+        u8 org_pci_offset_180;
+        u8 issue_offset_99_event;
+
+        u8 org_pci_offset_80;
+        u8 org_pci_offset_81;
+        u8 use_timer_interrrupt;
+
+        u32 keep_intr_cnt;
+
+        u8  HwIcVerUnknown;
+        u8  NotWrRamCodeToMicroP;
+        u8  NotWrMcuPatchCode;
+        u8  HwHasWrRamCodeToMicroP;
+
+        u16 sw_ram_code_ver;
+        u16 hw_ram_code_ver;
+
+        u8 rtk_enable_diag;
+
+        u8 ShortPacketSwChecksum;
+
+        u8 UseSwPaddingShortPkt;
+
+        void *ShortPacketEmptyBuffer;
+        dma_addr_t ShortPacketEmptyBufferPhy;
+
+        u8 RequireAdcBiasPatch;
+        u16 AdcBiasPatchIoffset;
+
+        u8 RequireAdjustUpsTxLinkPulseTiming;
+        u16 SwrCnt1msIni;
+
+        u8 HwSuppNowIsOobVer;
+
+        u8 RequiredSecLanDonglePatch;
+
+        u32 HwFiberModeVer;
+        u32 HwFiberStat;
+        u8 HwSwitchMdiToFiber;
+
+        u16 NicCustLedValue;
+
+        u8 HwSuppMagicPktVer;
+
+        u8 HwSuppCheckPhyDisableModeVer;
+
+        u8 random_mac;
+
+        u8 HwSuppGigaForceMode;
+
+        //Dash+++++++++++++++++
+        u8 HwSuppDashVer;
+        u8 DASH;
+        u8 dash_printer_enabled;
+        u8 HwPkgDet;
+        void __iomem *mapped_cmac_ioaddr; /* mapped cmac memory map physical address */
+        void __iomem *cmac_ioaddr; /* cmac memory map physical address */
+
+#ifdef ENABLE_DASH_SUPPORT
+        u16 AfterRecvFromFwBufLen;
+        u8 AfterRecvFromFwBuf[RECV_FROM_FW_BUF_SIZE];
+        u16 AfterSendToFwBufLen;
+        u8 AfterSendToFwBuf[SEND_TO_FW_BUF_SIZE];
+        u16 SendToFwBufferLen;
+        u32 SizeOfSendToFwBuffer ;
+        u32 SizeOfSendToFwBufferMemAlloc ;
+        u32 NumOfSendToFwBuffer ;
+
+        u8 OobReq;
+        u8 OobAck;
+        u32 OobReqComplete;
+        u32 OobAckComplete;
+
+        u8 RcvFwReqSysOkEvt;
+        u8 RcvFwDashOkEvt;
+        u8 SendFwHostOkEvt;
+
+        u8 DashFwDisableRx;
+
+        void *UnalignedSendToFwBufferVa;
+        void *SendToFwBuffer ;
+        u64 SendToFwBufferPhy ;
+        u8 SendingToFw;
+        dma_addr_t UnalignedSendToFwBufferPa;
+        PTX_DASH_SEND_FW_DESC TxDashSendFwDesc;
+        u64 TxDashSendFwDescPhy;
+        u8 *UnalignedTxDashSendFwDescVa;
+        u32 SizeOfTxDashSendFwDescMemAlloc;
+        u32 SizeOfTxDashSendFwDesc ;
+        u32 NumTxDashSendFwDesc ;
+        u32 CurrNumTxDashSendFwDesc ;
+        u32 LastSendNumTxDashSendFwDesc ;
+        dma_addr_t UnalignedTxDashSendFwDescPa;
+
+        u32 NumRecvFromFwBuffer ;
+        u32 SizeOfRecvFromFwBuffer ;
+        u32 SizeOfRecvFromFwBufferMemAlloc ;
+        void *RecvFromFwBuffer ;
+        u64 RecvFromFwBufferPhy ;
+
+        void *UnalignedRecvFromFwBufferVa;
+        dma_addr_t UnalignedRecvFromFwBufferPa;
+        PRX_DASH_FROM_FW_DESC RxDashRecvFwDesc;
+        u64 RxDashRecvFwDescPhy;
+        u8 *UnalignedRxDashRecvFwDescVa;
+        u32 SizeOfRxDashRecvFwDescMemAlloc;
+        u32 SizeOfRxDashRecvFwDesc ;
+        u32 NumRxDashRecvFwDesc ;
+        u32 CurrNumRxDashRecvFwDesc ;
+        dma_addr_t UnalignedRxDashRecvFwDescPa;
+        u8 DashReqRegValue;
+        u16 HostReqValue;
+
+        u32 CmacResetIsrCounter;
+        u8 CmacResetIntr ;
+        u8 CmacResetting ;
+        u8 CmacOobIssueCmacReset ;
+        u32 CmacResetbyFwCnt;
+
+#if defined(ENABLE_DASH_PRINTER_SUPPORT)
+        struct completion fw_ack;
+        struct completion fw_req;
+        struct completion fw_host_ok;
+#endif
+        //Dash-----------------
+#endif //ENABLE_DASH_SUPPORT
+
+        //Realwow++++++++++++++
+        u8 HwSuppKCPOffloadVer;
+
+        u8 EnableDhcpTimeoutWake;
+        u8 EnableTeredoOffload;
+        u8 EnableKCPOffload;
+#ifdef ENABLE_REALWOW_SUPPORT
+        u32 DhcpTimeout;
+        MP_KCP_INFO MpKCPInfo;
+        //Realwow--------------
+#endif //ENABLE_REALWOW_SUPPORT
+
+#ifdef ENABLE_R8168_PROCFS
+        //Procfs support
+        struct proc_dir_entry *proc_dir;
+#endif
+};
+
+enum eetype {
+        EEPROM_TYPE_NONE=0,
+        EEPROM_TYPE_93C46,
+        EEPROM_TYPE_93C56,
+        EEPROM_TWSI
+};
+
+enum mcfg {
+        CFG_METHOD_1=0,
+        CFG_METHOD_2,
+        CFG_METHOD_3,
+        CFG_METHOD_4,
+        CFG_METHOD_5,
+        CFG_METHOD_6,
+        CFG_METHOD_7,
+        CFG_METHOD_8,
+        CFG_METHOD_9 ,
+        CFG_METHOD_10,
+        CFG_METHOD_11,
+        CFG_METHOD_12,
+        CFG_METHOD_13,
+        CFG_METHOD_14,
+        CFG_METHOD_15,
+        CFG_METHOD_16,
+        CFG_METHOD_17,
+        CFG_METHOD_18,
+        CFG_METHOD_19,
+        CFG_METHOD_20,
+        CFG_METHOD_21,
+        CFG_METHOD_22,
+        CFG_METHOD_23,
+        CFG_METHOD_24,
+        CFG_METHOD_25,
+        CFG_METHOD_26,
+        CFG_METHOD_27,
+        CFG_METHOD_28,
+        CFG_METHOD_29,
+        CFG_METHOD_30,
+        CFG_METHOD_31,
+        CFG_METHOD_32,
+        CFG_METHOD_MAX,
+        CFG_METHOD_DEFAULT = 0xFF
+};
+
+#define LSO_32K 32000
+#define LSO_64K 64000
+
+#define NIC_MIN_PHYS_BUF_COUNT          (2)
+#define NIC_MAX_PHYS_BUF_COUNT_LSO_64K  (24)
+#define NIC_MAX_PHYS_BUF_COUNT_LSO2     (16*4)
+
+#define GTTCPHO_SHIFT                   18
+#define GTTCPHO_MAX                     0x7fU
+#define GTPKTSIZE_MAX                   0x3ffffU
+#define TCPHO_SHIFT                     18
+#define TCPHO_MAX                       0x3ffU
+#define LSOPKTSIZE_MAX                  0xffffU
+#define MSS_MAX                         0x07ffu /* MSS value */
+
+#define OOB_CMD_RESET       0x00
+#define OOB_CMD_DRIVER_START    0x05
+#define OOB_CMD_DRIVER_STOP 0x06
+#define OOB_CMD_SET_IPMAC   0x41
+
+#define WAKEUP_MAGIC_PACKET_NOT_SUPPORT (0)
+#define WAKEUP_MAGIC_PACKET_V1 (1)
+#define WAKEUP_MAGIC_PACKET_V2 (2)
+
+//Ram Code Version
+#define NIC_RAMCODE_VERSION_CFG_METHOD_14 (0x0057)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_16 (0x0055)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_18 (0x0052)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_20 (0x0044)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_21 (0x0042)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_24 (0x0001)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_23 (0x0015)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_26 (0x0012)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_28 (0x0019)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_29 (0x0018)
+#define NIC_RAMCODE_VERSION_CFG_METHOD_31 (0x0003)
+
+//hwoptimize
+#define HW_PATCH_SOC_LAN (BIT_0)
+#define HW_PATCH_SAMSUNG_LAN_DONGLE (BIT_2)
+
+void mdio_write(struct rtl8168_private *tp, u32 RegAddr, u32 value);
+void mdio_prot_write(struct rtl8168_private *tp, u32 RegAddr, u32 value);
+void rtl8168_ephy_write(void __iomem *ioaddr, int RegAddr, int value);
+void mac_ocp_write(struct rtl8168_private *tp, u16 reg_addr, u16 value);
+u16 mac_ocp_read(struct rtl8168_private *tp, u16 reg_addr);
+void ClearEthPhyBit(struct rtl8168_private *tp, u8 addr, u16 mask);
+void SetEthPhyBit(struct rtl8168_private *tp,  u8  addr, u16  mask);
+void OCP_write(struct rtl8168_private *tp, u16 addr, u8 len, u32 data);
+void OOB_notify(struct rtl8168_private *tp, u8 cmd);
+void rtl8168_init_ring_indexes(struct rtl8168_private *tp);
+void rtl8168_wait_ll_share_fifo_ready(struct net_device *dev);
+int rtl8168_eri_write(void __iomem *ioaddr, int addr, int len, u32 value, int type);
+void OOB_mutex_lock(struct rtl8168_private *tp);
+u32 mdio_read(struct rtl8168_private *tp, u32 RegAddr);
+u32 OCP_read(struct rtl8168_private *tp, u16 addr, u8 len);
+u32 OCP_read_with_oob_base_address(struct rtl8168_private *tp, u16 addr, u8 len, u32 base_address);
+u32 OCP_write_with_oob_base_address(struct rtl8168_private *tp, u16 addr, u8 len, u32 value, u32 base_address);
+u32 rtl8168_eri_read(void __iomem *ioaddr, int addr, int len, int type);
+u32 rtl8168_eri_read_with_oob_base_address(void __iomem *ioaddr, int addr, int len, int type, u32 base_address);
+int rtl8168_eri_write_with_oob_base_address(void __iomem *ioaddr, int addr, int len, u32 value, int type, u32 base_address);
+u16 rtl8168_ephy_read(void __iomem *ioaddr, int RegAddr);
+void rtl8168_wait_txrx_fifo_empty(struct net_device *dev);
+void EnableNowIsOob(struct rtl8168_private *tp);
+void DisableNowIsOob(struct rtl8168_private *tp);
+void OOB_mutex_unlock(struct rtl8168_private *tp);
+void Dash2DisableTx(struct rtl8168_private *tp);
+void Dash2EnableTx(struct rtl8168_private *tp);
+void Dash2DisableRx(struct rtl8168_private *tp);
+void Dash2EnableRx(struct rtl8168_private *tp);
+void rtl8168_hw_disable_mac_mcu_bps(struct net_device *dev);
+
+#define HW_SUPPORT_CHECK_PHY_DISABLE_MODE(_M)        ((_M)->HwSuppCheckPhyDisableModeVer > 0 )
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,34)
+#define netdev_mc_count(dev) ((dev)->mc_count)
+#define netdev_mc_empty(dev) (netdev_mc_count(dev) == 0)
+#define netdev_for_each_mc_addr(mclist, dev) \
+    for (mclist = dev->mc_list; mclist; mclist = mclist->next)
+#endif
diff --git a/drivers/net/ethernet/realtek/r8168/r8168_asf.c b/drivers/net/ethernet/realtek/r8168/r8168_asf.c
new file mode 100644
index 00000000..373d7cc
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/r8168_asf.c
@@ -0,0 +1,419 @@
+/*
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#include <linux/module.h>
+#include <linux/version.h>
+#include <linux/pci.h>
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/delay.h>
+#include <linux/ethtool.h>
+#include <linux/mii.h>
+#include <linux/if_vlan.h>
+#include <linux/crc32.h>
+#include <linux/in.h>
+#include <linux/ip.h>
+#include <linux/tcp.h>
+#include <linux/init.h>
+#include <linux/rtnetlink.h>
+
+#include <asm/uaccess.h>
+
+#include "r8168.h"
+#include "r8168_asf.h"
+#include "rtl_eeprom.h"
+
+int rtl8168_asf_ioctl(struct net_device *dev,
+                      struct ifreq *ifr)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        void *user_data = ifr->ifr_data;
+        struct asf_ioctl_struct asf_usrdata;
+
+        if (tp->mcfg != CFG_METHOD_7 && tp->mcfg != CFG_METHOD_8)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&asf_usrdata, user_data, sizeof(struct asf_ioctl_struct)))
+                return -EFAULT;
+
+        switch (asf_usrdata.offset) {
+        case HBPeriod:
+                rtl8168_asf_hbperiod(ioaddr, asf_usrdata.arg, asf_usrdata.u.data);
+                break;
+        case WD8Timer:
+                break;
+        case WD16Rst:
+                rtl8168_asf_wd16rst(ioaddr, asf_usrdata.arg, asf_usrdata.u.data);
+                break;
+        case WD8Rst:
+                rtl8168_asf_time_period(ioaddr, asf_usrdata.arg, WD8Rst, asf_usrdata.u.data);
+                break;
+        case LSnsrPollCycle:
+                rtl8168_asf_time_period(ioaddr, asf_usrdata.arg, LSnsrPollCycle, asf_usrdata.u.data);
+                break;
+        case ASFSnsrPollPrd:
+                rtl8168_asf_time_period(ioaddr, asf_usrdata.arg, ASFSnsrPollPrd, asf_usrdata.u.data);
+                break;
+        case AlertReSendItvl:
+                rtl8168_asf_time_period(ioaddr, asf_usrdata.arg, AlertReSendItvl, asf_usrdata.u.data);
+                break;
+        case SMBAddr:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, SMBAddr, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case ASFConfigR0:
+                rtl8168_asf_config_regs(ioaddr, asf_usrdata.arg, ASFConfigR0, asf_usrdata.u.data);
+                break;
+        case ASFConfigR1:
+                rtl8168_asf_config_regs(ioaddr, asf_usrdata.arg, ASFConfigR1, asf_usrdata.u.data);
+                break;
+        case ConsoleMA:
+                rtl8168_asf_console_mac(tp, asf_usrdata.arg, asf_usrdata.u.data);
+                break;
+        case ConsoleIP:
+                rtl8168_asf_ip_address(ioaddr, asf_usrdata.arg, ConsoleIP, asf_usrdata.u.data);
+                break;
+        case IPAddr:
+                rtl8168_asf_ip_address(tp, asf_usrdata.arg, IPAddr, asf_usrdata.u.data);
+                break;
+        case UUID:
+                rtl8168_asf_rw_uuid(ioaddr, asf_usrdata.arg, asf_usrdata.u.data);
+                break;
+        case IANA:
+                rtl8168_asf_rw_iana(ioaddr, asf_usrdata.arg, asf_usrdata.u.data);
+                break;
+        case SysID:
+                rtl8168_asf_rw_systemid(ioaddr, asf_usrdata.arg, asf_usrdata.u.data);
+                break;
+        case Community:
+                rtl8168_asf_community_string(ioaddr, asf_usrdata.arg, asf_usrdata.u.string);
+                break;
+        case StringLength:
+                rtl8168_asf_community_string_len(ioaddr, asf_usrdata.arg, asf_usrdata.u.data);
+                break;
+        case FmCapMsk:
+                rtl8168_asf_capability_masks(ioaddr, asf_usrdata.arg, FmCapMsk, asf_usrdata.u.data);
+                break;
+        case SpCMDMsk:
+                rtl8168_asf_capability_masks(ioaddr, asf_usrdata.arg, SpCMDMsk, asf_usrdata.u.data);
+                break;
+        case SysCapMsk:
+                rtl8168_asf_capability_masks(ioaddr, asf_usrdata.arg, SysCapMsk, asf_usrdata.u.data);
+                break;
+        case RmtRstAddr:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtRstAddr, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtRstCmd:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtRstCmd, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtRstData:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtRstData, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtPwrOffAddr:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtPwrOffAddr, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtPwrOffCmd:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtPwrOffCmd, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtPwrOffData:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtPwrOffData, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtPwrOnAddr:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtPwrOnAddr, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtPwrOnCmd:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtPwrOnCmd, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtPwrOnData:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtPwrOnData, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtPCRAddr:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtPCRAddr, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtPCRCmd:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtPCRCmd, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case RmtPCRData:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, RmtPCRData, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case ASFSnsr0Addr:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, ASFSnsr0Addr, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case LSnsrAddr0:
+                rtl8168_asf_rw_hexadecimal(ioaddr, asf_usrdata.arg, LSnsrAddr0, RW_ONE_BYTE, asf_usrdata.u.data);
+                break;
+        case KO:
+                /* Get/Set Key Operation */
+                rtl8168_asf_key_access(ioaddr, asf_usrdata.arg, KO, asf_usrdata.u.data);
+                break;
+        case KA:
+                /* Get/Set Key Administrator */
+                rtl8168_asf_key_access(ioaddr, asf_usrdata.arg, KA, asf_usrdata.u.data);
+                break;
+        case KG:
+                /* Get/Set Key Generation */
+                rtl8168_asf_key_access(ioaddr, asf_usrdata.arg, KG, asf_usrdata.u.data);
+                break;
+        case KR:
+                /* Get/Set Key Random */
+                rtl8168_asf_key_access(tp, asf_usrdata.arg, KR, asf_usrdata.u.data);
+                break;
+        default:
+                return -EOPNOTSUPP;
+        }
+
+        if (copy_to_user(user_data, &asf_usrdata, sizeof(struct asf_ioctl_struct)))
+                return -EFAULT;
+
+        return 0;
+}
+
+void rtl8168_asf_hbperiod(void __iomem *ioaddr, int arg, unsigned int *data)
+{
+        if (arg == ASF_GET)
+                data[ASFHBPERIOD] = rtl8168_eri_read(ioaddr, HBPeriod, RW_TWO_BYTES, ERIAR_ASF);
+        else if (arg == ASF_SET) {
+                rtl8168_eri_write(ioaddr, HBPeriod, RW_TWO_BYTES, data[ASFHBPERIOD], ERIAR_ASF);
+                rtl8168_eri_write(ioaddr, 0x1EC, RW_ONE_BYTE, 0x07, ERIAR_ASF);
+        }
+}
+
+void rtl8168_asf_wd16rst(void __iomem *ioaddr, int arg, unsigned int *data)
+{
+        data[ASFWD16RST] = rtl8168_eri_read(ioaddr, WD16Rst, RW_TWO_BYTES, ERIAR_ASF);
+}
+
+void rtl8168_asf_console_mac(struct rtl8168_private *tp, int arg, unsigned int *data)
+{
+        void __iomem *ioaddr=tp->mmio_addr;
+        int i;
+
+        if (arg == ASF_GET) {
+                for (i = 0; i < 6; i++)
+                        data[i] = rtl8168_eri_read(ioaddr, ConsoleMA + i, RW_ONE_BYTE, ERIAR_ASF);
+        } else if (arg == ASF_SET) {
+                for (i = 0; i < 6; i++)
+                        rtl8168_eri_write(ioaddr, ConsoleMA + i, RW_ONE_BYTE, data[i], ERIAR_ASF);
+
+                /* write the new console MAC address to EEPROM */
+                rtl_eeprom_write_sc(tp, 70, (data[1] << 8) | data[0]);
+                rtl_eeprom_write_sc(tp, 71, (data[3] << 8) | data[2]);
+                rtl_eeprom_write_sc(tp, 72, (data[5] << 8) | data[4]);
+        }
+}
+
+void rtl8168_asf_ip_address(struct rtl8168_private *tp, int arg, int offset, unsigned int *data)
+{
+        void __iomem *ioaddr=tp->mmio_addr;
+        int i;
+        int eeprom_off = 0;
+
+        if (arg == ASF_GET) {
+                for (i = 0; i < 4; i++)
+                        data[i] = rtl8168_eri_read(ioaddr, offset + i, RW_ONE_BYTE, ERIAR_ASF);
+        } else if (arg == ASF_SET) {
+                for (i = 0; i < 4; i++)
+                        rtl8168_eri_write(ioaddr, offset + i, RW_ONE_BYTE, data[i], ERIAR_ASF);
+
+                if (offset == ConsoleIP)
+                        eeprom_off = 73;
+                else if (offset == IPAddr)
+                        eeprom_off = 75;
+
+                /* write the new IP address to EEPROM */
+                rtl_eeprom_write_sc(tp, eeprom_off, (data[1] << 8) | data[0]);
+                rtl_eeprom_write_sc(tp, eeprom_off + 1, (data[3] << 8) | data[2]);
+
+        }
+}
+
+void rtl8168_asf_config_regs(void __iomem *ioaddr, int arg, int offset, unsigned int *data)
+{
+        unsigned int value;
+
+        if (arg == ASF_GET) {
+                data[ASFCAPABILITY] = (rtl8168_eri_read(ioaddr, offset, RW_ONE_BYTE, ERIAR_ASF) & data[ASFCONFIG]) ? FUNCTION_ENABLE : FUNCTION_DISABLE;
+        } else if (arg == ASF_SET) {
+                value = rtl8168_eri_read(ioaddr, offset, RW_ONE_BYTE, ERIAR_ASF);
+
+                if (data[ASFCAPABILITY] == FUNCTION_ENABLE)
+                        value |= data[ASFCONFIG];
+                else if (data[ASFCAPABILITY] == FUNCTION_DISABLE)
+                        value &= ~data[ASFCONFIG];
+
+                rtl8168_eri_write(ioaddr, offset, RW_ONE_BYTE, value, ERIAR_ASF);
+        }
+}
+
+void rtl8168_asf_capability_masks(void __iomem *ioaddr, int arg, int offset, unsigned int *data)
+{
+        unsigned int len, bit_mask;
+
+        bit_mask = DISABLE_MASK;
+
+        if (offset == FmCapMsk) {
+                /* System firmware capabilities */
+                len = RW_FOUR_BYTES;
+                if (data[ASFCAPMASK] == FUNCTION_ENABLE)
+                        bit_mask = FMW_CAP_MASK;
+        } else if (offset == SpCMDMsk) {
+                /* Special commands */
+                len = RW_TWO_BYTES;
+                if (data[ASFCAPMASK] == FUNCTION_ENABLE)
+                        bit_mask = SPC_CMD_MASK;
+        } else {
+                /* System capability (offset == SysCapMsk)*/
+                len = RW_ONE_BYTE;
+                if (data[ASFCAPMASK] == FUNCTION_ENABLE)
+                        bit_mask = SYS_CAP_MASK;
+        }
+
+        if (arg == ASF_GET)
+                data[ASFCAPMASK] = rtl8168_eri_read(ioaddr, offset, len, ERIAR_ASF) ? FUNCTION_ENABLE : FUNCTION_DISABLE;
+        else /* arg == ASF_SET */
+                rtl8168_eri_write(ioaddr, offset, len, bit_mask, ERIAR_ASF);
+}
+
+void rtl8168_asf_community_string(void __iomem *ioaddr, int arg, char *string)
+{
+        int i;
+
+        if (arg == ASF_GET) {
+                for (i = 0; i < COMMU_STR_MAX_LEN; i++)
+                        string[i] = rtl8168_eri_read(ioaddr, Community + i, RW_ONE_BYTE, ERIAR_ASF);
+        } else { /* arg == ASF_SET */
+                for (i = 0; i < COMMU_STR_MAX_LEN; i++)
+                        rtl8168_eri_write(ioaddr, Community + i, RW_ONE_BYTE, string[i], ERIAR_ASF);
+        }
+}
+
+void rtl8168_asf_community_string_len(void __iomem *ioaddr, int arg, unsigned int *data)
+{
+        if (arg == ASF_GET)
+                data[ASFCOMMULEN] = rtl8168_eri_read(ioaddr, StringLength, RW_ONE_BYTE, ERIAR_ASF);
+        else /* arg == ASF_SET */
+                rtl8168_eri_write(ioaddr, StringLength, RW_ONE_BYTE, data[ASFCOMMULEN], ERIAR_ASF);
+}
+
+void rtl8168_asf_time_period(void __iomem *ioaddr, int arg, int offset, unsigned int *data)
+{
+        int pos = 0;
+
+        if (offset == WD8Rst)
+                pos = ASFWD8RESET;
+        else if (offset == LSnsrPollCycle)
+                pos = ASFLSNRPOLLCYC;
+        else if (offset == ASFSnsrPollPrd)
+                pos = ASFSNRPOLLCYC;
+        else if (offset == AlertReSendItvl)
+                pos = ASFALERTRESND;
+
+        if (arg == ASF_GET)
+                data[pos] = rtl8168_eri_read(ioaddr, offset, RW_ONE_BYTE, ERIAR_ASF);
+        else /* arg == ASF_SET */
+                rtl8168_eri_write(ioaddr, offset, RW_ONE_BYTE, data[pos], ERIAR_ASF);
+
+}
+
+void rtl8168_asf_key_access(struct rtl8168_private *tp, int arg, int offset, unsigned int *data)
+{
+        void __iomem *ioaddr=tp->mmio_addr;
+        int i, j;
+        int key_off = 0;
+
+        if (arg == ASF_GET) {
+                for (i = 0; i < KEY_LEN; i++)
+                        data[i] = rtl8168_eri_read(ioaddr, offset + KEY_LEN - (i + 1), RW_ONE_BYTE, ERIAR_ASF);
+        } else {
+                if (offset == KO)
+                        key_off = 162;
+                else if (offset == KA)
+                        key_off = 172;
+                else if (offset == KG)
+                        key_off = 182;
+                else if (offset == KR)
+                        key_off = 192;
+
+                /* arg == ASF_SET */
+                for (i = 0; i < KEY_LEN; i++)
+                        rtl8168_eri_write(ioaddr, offset + KEY_LEN - (i + 1), RW_ONE_BYTE, data[i], ERIAR_ASF);
+
+                /* write the new key to EEPROM */
+                for (i = 0, j = 19; i < 10; i++, j = j - 2)
+                        rtl_eeprom_write_sc(tp, key_off + i, (data[j - 1] << 8) | data[j]);
+        }
+}
+
+void rtl8168_asf_rw_hexadecimal(void __iomem *ioaddr, int arg, int offset, int len, unsigned int *data)
+{
+        if (arg == ASF_GET)
+                data[ASFRWHEXNUM] = rtl8168_eri_read(ioaddr, offset, len, ERIAR_ASF);
+        else /* arg == ASF_SET */
+                rtl8168_eri_write(ioaddr, offset, len, data[ASFRWHEXNUM], ERIAR_ASF);
+}
+
+void rtl8168_asf_rw_systemid(void __iomem *ioaddr, int arg, unsigned int *data)
+{
+        int i;
+
+        if (arg == ASF_GET)
+                for (i = 0; i < SYSID_LEN ; i++)
+                        data[i] = rtl8168_eri_read(ioaddr, SysID + i, RW_ONE_BYTE, ERIAR_ASF);
+        else /* arg == ASF_SET */
+                for (i = 0; i < SYSID_LEN ; i++)
+                        rtl8168_eri_write(ioaddr, SysID + i, RW_ONE_BYTE, data[i], ERIAR_ASF);
+}
+
+void rtl8168_asf_rw_iana(void __iomem *ioaddr, int arg, unsigned int *data)
+{
+        int i;
+
+        if (arg == ASF_GET)
+                for (i = 0; i < RW_FOUR_BYTES; i++)
+                        data[i] = rtl8168_eri_read(ioaddr, IANA + i, RW_ONE_BYTE, ERIAR_ASF);
+        else /* arg == ASF_SET */
+                for (i = 0; i < RW_FOUR_BYTES; i++)
+                        rtl8168_eri_write(ioaddr, IANA + i, RW_ONE_BYTE, data[i], ERIAR_ASF);
+}
+
+void rtl8168_asf_rw_uuid(void __iomem *ioaddr, int arg, unsigned int *data)
+{
+        int i, j;
+
+        if (arg == ASF_GET)
+                for (i = UUID_LEN - 1, j = 0; i >= 0 ; i--, j++)
+                        data[j] = rtl8168_eri_read(ioaddr, UUID + i, RW_ONE_BYTE, ERIAR_ASF);
+        else /* arg == ASF_SET */
+                for (i = UUID_LEN - 1, j = 0; i >= 0 ; i--, j++)
+                        rtl8168_eri_write(ioaddr, UUID + i, RW_ONE_BYTE, data[j], ERIAR_ASF);
+}
diff --git a/drivers/net/ethernet/realtek/r8168/r8168_asf.h b/drivers/net/ethernet/realtek/r8168/r8168_asf.h
new file mode 100644
index 00000000..449e1ab
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/r8168_asf.h
@@ -0,0 +1,294 @@
+/*
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#define SIOCDEVPRIVATE_RTLASF   SIOCDEVPRIVATE
+
+#define FUNCTION_ENABLE		1
+#define FUNCTION_DISABLE	0
+
+#define ASFCONFIG	0
+#define ASFCAPABILITY	1
+#define ASFCOMMULEN	0
+#define ASFHBPERIOD	0
+#define ASFWD16RST	0
+#define ASFCAPMASK	0
+#define ASFALERTRESND	0
+#define ASFLSNRPOLLCYC	0
+#define ASFSNRPOLLCYC	0
+#define ASFWD8RESET	0
+#define ASFRWHEXNUM	0
+
+#define FMW_CAP_MASK	0x0000F867
+#define SPC_CMD_MASK	0x1F00
+#define SYS_CAP_MASK	0xFF
+#define DISABLE_MASK	0x00
+
+#define MAX_DATA_LEN	200
+#define MAX_STR_LEN	200
+
+#define COMMU_STR_MAX_LEN	23
+
+#define KEY_LEN		20
+#define UUID_LEN	16
+#define SYSID_LEN	2
+
+#define RW_ONE_BYTE	1
+#define RW_TWO_BYTES	2
+#define RW_FOUR_BYTES	4
+
+enum asf_registers {
+        HBPeriod	= 0x0000,
+        WD8Rst		= 0x0002,
+        WD8Timer	= 0x0003,
+        WD16Rst		= 0x0004,
+        LSnsrPollCycle	= 0x0006,
+        ASFSnsrPollPrd	= 0x0007,
+        AlertReSendCnt	= 0x0008,
+        AlertReSendItvl	= 0x0009,
+        SMBAddr		= 0x000A,
+        SMBCap		= 0x000B,
+        ASFConfigR0	= 0x000C,
+        ASFConfigR1	= 0x000D,
+        WD16Timer	= 0x000E,
+        ConsoleMA	= 0x0010,
+        ConsoleIP	= 0x0016,
+        IPAddr		= 0x001A,
+
+        UUID		= 0x0020,
+        IANA		= 0x0030,
+        SysID		= 0x0034,
+        Community	= 0x0036,
+        StringLength	= 0x004D,
+        LC		= 0x004E,
+        EntityInst	= 0x004F,
+        FmCapMsk	= 0x0050,
+        SpCMDMsk	= 0x0054,
+        SysCapMsk	= 0x0056,
+        WDSysSt		= 0x0057,
+        RxMsgType	= 0x0058,
+        RxSpCMD		= 0x0059,
+        RxSpCMDPa	= 0x005A,
+        RxBtOpMsk	= 0x005C,
+        RmtRstAddr	= 0x005E,
+        RmtRstCmd	= 0x005F,
+        RmtRstData	= 0x0060,
+        RmtPwrOffAddr	= 0x0061,
+        RmtPwrOffCmd	= 0x0062,
+        RmtPwrOffData	= 0x0063,
+        RmtPwrOnAddr	= 0x0064,
+        RmtPwrOnCmd	= 0x0065,
+        RmtPwrOnData	= 0x0066,
+        RmtPCRAddr	= 0x0067,
+        RmtPCRCmd	= 0x0068,
+        RmtPCRData	= 0x0069,
+        RMCP_IANA	= 0x006A,
+        RMCP_OEM	= 0x006E,
+        ASFSnsr0Addr	= 0x0070,
+
+        ASFSnsrEvSt	= 0x0073,
+        ASFSnsrEvAlert	= 0x0081,
+
+        LSnsrNo		= 0x00AD,
+        AssrtEvntMsk	= 0x00AE,
+        DeAssrtEvntMsk	= 0x00AF,
+
+        LSnsrAddr0	= 0x00B0,
+        LAlertCMD0	= 0x00B1,
+        LAlertDataMsk0	= 0x00B2,
+        LAlertCmp0	= 0x00B3,
+        LAlertESnsrT0	= 0x00B4,
+        LAlertET0	= 0x00B5,
+        LAlertEOffset0	= 0x00B6,
+        LAlertES0	= 0x00B7,
+        LAlertSN0	= 0x00B8,
+        LAlertEntity0	= 0x00B9,
+        LAlertEI0	= 0x00BA,
+        LSnsrState0	= 0x00BB,
+
+        LSnsrAddr1	= 0x00BD,
+        LAlertCMD1	= 0x00BE,
+        LAlertDataMsk1	= 0x00BF,
+        LAlertCmp1	= 0x00C0,
+        LAlertESnsrT1	= 0x00C1,
+        LAlertET1	= 0x00C2,
+        LAlertEOffset1	= 0x00C3,
+        LAlertES1	= 0x00C4,
+        LAlertSN1	= 0x00C5,
+        LAlertEntity1	= 0x00C6,
+        LAlertEI1	= 0x00C7,
+        LSnsrState1	= 0x00C8,
+
+        LSnsrAddr2	= 0x00CA,
+        LAlertCMD2	= 0x00CB,
+        LAlertDataMsk2	= 0x00CC,
+        LAlertCmp2	= 0x00CD,
+        LAlertESnsrT2	= 0x00CE,
+        LAlertET2	= 0x00CF,
+        LAlertEOffset2	= 0x00D0,
+        LAlertES2	= 0x00D1,
+        LAlertSN2	= 0x00D2,
+        LAlertEntity2	= 0x00D3,
+        LAlertEI2	= 0x00D4,
+        LSnsrState2	= 0x00D5,
+
+        LSnsrAddr3	= 0x00D7,
+        LAlertCMD3	= 0x00D8,
+        LAlertDataMsk3	= 0x00D9,
+        LAlertCmp3	= 0x00DA,
+        LAlertESnsrT3	= 0x00DB,
+        LAlertET3	= 0x00DC,
+        LAlertEOffset3	= 0x00DD,
+        LAlertES3	= 0x00DE,
+        LAlertSN3	= 0x00DF,
+        LAlertEntity3	= 0x00E0,
+        LAlertEI3	= 0x00E1,
+        LSnsrState3	= 0x00E2,
+
+        LSnsrAddr4	= 0x00E4,
+        LAlertCMD4	= 0x00E5,
+        LAlertDataMsk4	= 0x00E6,
+        LAlertCmp4	= 0x00E7,
+        LAlertESnsrT4	= 0x00E8,
+        LAlertET4	= 0x00E9,
+        LAlertEOffset4	= 0x00EA,
+        LAlertES4	= 0x00EB,
+        LAlertSN4	= 0x00EC,
+        LAlertEntity4	= 0x00ED,
+        LAlertEI4	= 0x00EE,
+        LSnsrState4	= 0x00EF,
+
+        LSnsrAddr5	= 0x00F1,
+        LAlertCMD5	= 0x00F2,
+        LAlertDataMsk5	= 0x00F3,
+        LAlertCmp5	= 0x00F4,
+        LAlertESnsrT5	= 0x00F5,
+        LAlertET5	= 0x00F6,
+        LAlertEOffset5	= 0x00F7,
+        LAlertES5	= 0x00F8,
+        LAlertSN5	= 0x00F9,
+        LAlertEntity5	= 0x00FA,
+        LAlertEI5	= 0x00FB,
+        LSnsrState5	= 0x00FC,
+
+        LSnsrAddr6	= 0x00FE,
+        LAlertCMD6	= 0x00FF,
+        LAlertDataMsk6	= 0x0100,
+        LAlertCmp6	= 0x0101,
+        LAlertESnsrT6	= 0x0102,
+        LAlertET6	= 0x0103,
+        LAlertEOffset6	= 0x0104,
+        LAlertES6	= 0x0105,
+        LAlertSN6	= 0x0106,
+        LAlertEntity6	= 0x0107,
+        LAlertEI6	= 0x0108,
+        LSnsrState6	= 0x0109,
+
+        LSnsrAddr7	= 0x010B,
+        LAlertCMD7	= 0x010C,
+        LAlertDataMsk7	= 0x010D,
+        LAlertCmp7	= 0x010E,
+        LAlertESnsrT7	= 0x010F,
+        LAlertET7	= 0x0110,
+        LAlertEOffset7	= 0x0111,
+        LAlertES7	= 0x0112,
+        LAlertSN7	= 0x0113,
+        LAlertEntity7	= 0x0114,
+        LAlertEI7	= 0x0115,
+        LSnsrState7	= 0x0116,
+        LAssert		= 0x0117,
+        LDAssert	= 0x0118,
+        IPServiceType	= 0x0119,
+        IPIdfr		= 0x011A,
+        FlagFOffset	= 0x011C,
+        TTL		= 0x011E,
+        HbtEI		= 0x011F,
+        MgtConSID1	= 0x0120,
+        MgtConSID2	= 0x0124,
+        MgdCltSID	= 0x0128,
+        StCd		= 0x012C,
+        MgtConUR	= 0x012D,
+        MgtConUNL	= 0x012E,
+
+        AuthPd		= 0x0130,
+        IntyPd		= 0x0138,
+        MgtConRN	= 0x0140,
+        MgdCtlRN	= 0x0150,
+        MgtConUN	= 0x0160,
+        Rakp2IntCk	= 0x0170,
+        KO		= 0x017C,
+        KA		= 0x0190,
+        KG		= 0x01A4,
+        KR		= 0x01B8,
+        CP		= 0x01CC,
+        CQ		= 0x01D0,
+        KC		= 0x01D4,
+        ConsoleSid	= 0x01E8,
+
+        SIK1		= 0x01FC,
+        SIK2		= 0x0210,
+        Udpsrc_port	= 0x0224,
+        Udpdes_port	= 0x0226,
+        Asf_debug_mux	= 0x0228
+};
+
+enum asf_cmdln_opt {
+        ASF_GET,
+        ASF_SET,
+        ASF_HELP
+};
+
+struct asf_ioctl_struct {
+        unsigned int arg;
+        unsigned int offset;
+        union {
+                unsigned int data[MAX_DATA_LEN];
+                char string[MAX_STR_LEN];
+        } u;
+};
+
+int rtl8168_asf_ioctl(struct net_device *dev, struct ifreq *ifr);
+void rtl8168_asf_hbperiod(void __iomem *ioaddr, int arg, unsigned int *data);
+void rtl8168_asf_wd16rst(void __iomem *ioaddr, int arg, unsigned int *data);
+void rtl8168_asf_console_mac(struct rtl8168_private *, int arg, unsigned int *data);
+void rtl8168_asf_ip_address(struct rtl8168_private *, int arg, int offset, unsigned int *data);
+void rtl8168_asf_config_regs(void __iomem *ioaddr, int arg, int offset, unsigned int *data);
+void rtl8168_asf_capability_masks(void __iomem *ioaddr, int arg, int offset, unsigned int *data);
+void rtl8168_asf_community_string(void __iomem *ioaddr, int arg, char *string);
+void rtl8168_asf_community_string_len(void __iomem *ioaddr, int arg, unsigned int *data);
+void rtl8168_asf_alert_resend_interval(void __iomem *ioaddr, int arg, unsigned int *data);
+void rtl8168_asf_time_period(void __iomem *ioaddr, int arg, int offset, unsigned int *data);
+void rtl8168_asf_key_access(struct rtl8168_private *, int arg, int offset, unsigned int *data);
+void rtl8168_asf_rw_hexadecimal(void __iomem *ioaddr, int arg, int offset, int len, unsigned int *data);
+void rtl8168_asf_rw_iana(void __iomem *ioaddr, int arg, unsigned int *data);
+void rtl8168_asf_rw_uuid(void __iomem *ioaddr, int arg, unsigned int *data);
+void rtl8168_asf_rw_systemid(void __iomem *ioaddr, int arg, unsigned int *data);
diff --git a/drivers/net/ethernet/realtek/r8168/r8168_dash.h b/drivers/net/ethernet/realtek/r8168/r8168_dash.h
new file mode 100644
index 00000000..e4b1af2
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/r8168_dash.h
@@ -0,0 +1,258 @@
+/*
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#ifndef _LINUX_R8168_DASH_H
+#define _LINUX_R8168_DASH_H
+
+#define SIOCDEVPRIVATE_RTLDASH   SIOCDEVPRIVATE+2
+
+enum rtl_dash_cmd {
+        RTL_DASH_ARP_NS_OFFLOAD = 0,
+        RTL_DASH_SET_OOB_IPMAC,
+        RTL_DASH_NOTIFY_OOB,
+
+        RTL_DASH_SEND_BUFFER_DATA_TO_DASH_FW,
+        RTL_DASH_CHECK_SEND_BUFFER_TO_DASH_FW_COMPLETE,
+        RTL_DASH_GET_RCV_FROM_FW_BUFFER_DATA,
+        RTL_DASH_OOB_REQ,
+        RTL_DASH_OOB_ACK,
+        RTL_DASH_DETACH_OOB_REQ,
+        RTL_DASH_DETACH_OOB_ACK,
+
+        RTL_FW_SET_IPV4 = 0x10,
+        RTL_FW_GET_IPV4,
+        RTL_FW_SET_IPV6,
+        RTL_FW_GET_IPV6,
+        RTL_FW_SET_EXT_SNMP,
+        RTL_FW_GET_EXT_SNMP,
+        RTL_FW_SET_WAKEUP_PATTERN,
+        RTL_FW_GET_WAKEUP_PATTERN,
+        RTL_FW_DEL_WAKEUP_PATTERN,
+
+        RTLT_DASH_COMMAND_INVALID,
+};
+
+struct rtl_dash_ip_mac {
+        struct sockaddr ifru_addr;
+        struct sockaddr ifru_netmask;
+        struct sockaddr ifru_hwaddr;
+};
+
+struct rtl_dash_ioctl_struct {
+        __u32	cmd;
+        __u32	offset;
+        __u32	len;
+        union {
+                __u32	data;
+                void *data_buffer;
+        };
+};
+
+struct settings_ipv4 {
+        __u32	IPv4addr;
+        __u32	IPv4mask;
+        __u32	IPv4Gateway;
+};
+
+struct settings_ipv6 {
+        __u32	reserved;
+        __u32	prefixLen;
+        __u16	IPv6addr[8];
+        __u16	IPv6Gateway[8];
+};
+
+struct settings_ext_snmp {
+        __u16	index;
+        __u16	oid_get_len;
+        __u8	oid_for_get[24];
+        __u8	reserved0[26];
+        __u16	value_len;
+        __u8	value[256];
+        __u8	supported;
+        __u8	reserved1[27];
+};
+
+struct wakeup_pattern {
+        __u8	index;
+        __u8	valid;
+        __u8	start;
+        __u8	length;
+        __u8	name[36];
+        __u8	mask[16];
+        __u8	pattern[128];
+        __u32	reserved[2];
+};
+
+typedef struct _RX_DASH_FROM_FW_DESC {
+        u16 length;
+        u8 statusLowByte;
+        u8 statusHighByte;
+        u32 resv;
+        u64 BufferAddress;
+}
+RX_DASH_FROM_FW_DESC, *PRX_DASH_FROM_FW_DESC;
+
+typedef struct _TX_DASH_SEND_FW_DESC {
+        u16 length;
+        u8 statusLowByte;
+        u8 statusHighByte;
+        u32 resv;
+        u64 BufferAddress;
+}
+TX_DASH_SEND_FW_DESC, *PTX_DASH_SEND_FW_DESC;
+
+typedef struct _OSOOBHdr {
+        u32 len;
+        u8 type;
+        u8 flag;
+        u8 hostReqV;
+        u8 res;
+}
+OSOOBHdr, *POSOOBHdr;
+
+typedef struct _RX_DASH_BUFFER_TYPE_2 {
+        OSOOBHdr oobhdr;
+        u8 RxDataBuffer[0];
+}
+RX_DASH_BUFFER_TYPE_2, *PRX_DASH_BUFFER_TYPE_2;
+
+#define ALIGN_8                 (0x7)
+#define ALIGN_16                (0xf)
+#define ALIGN_32                (0x1f)
+#define ALIGN_64                (0x3f)
+#define ALIGN_256               (0xff)
+#define ALIGN_4096              (0xfff)
+
+#define OCP_REG_CONFIG0 (0x10)
+#define OCP_REG_CONFIG0_REV_F (0xB8)
+#define OCP_REG_DASH_POLL (0x30)
+#define OCP_REG_HOST_REQ (0x34)
+#define OCP_REG_DASH_REQ (0x35)
+#define OCP_REG_CR (0x36)
+#define OCP_REG_DMEMSTA (0x38)
+#define OCP_REG_GPHYAR (0x60)
+
+
+#define OCP_REG_CONFIG0_DASHEN           BIT_15
+#define OCP_REG_CONFIG0_OOBRESET         BIT_14
+#define OCP_REG_CONFIG0_APRDY            BIT_13
+#define OCP_REG_CONFIG0_FIRMWARERDY      BIT_12
+#define OCP_REG_CONFIG0_DRIVERRDY        BIT_11
+#define OCP_REG_CONFIG0_OOB_WDT          BIT_9
+#define OCP_REG_CONFIG0_DRV_WAIT_OOB     BIT_8
+#define OCP_REG_CONFIG0_TLSEN            BIT_7
+
+#define HW_DASH_SUPPORT_DASH(_M)        ((_M)->HwSuppDashVer > 0 )
+#define HW_DASH_SUPPORT_TYPE_1(_M)        ((_M)->HwSuppDashVer == 1 )
+#define HW_DASH_SUPPORT_TYPE_2(_M)        ((_M)->HwSuppDashVer == 2 )
+#define HW_DASH_SUPPORT_TYPE_3(_M)        ((_M)->HwSuppDashVer == 3 )
+
+#define RECV_FROM_FW_BUF_SIZE (1520)
+#define SEND_TO_FW_BUF_SIZE (1520)
+
+#define RX_DASH_FROM_FW_OWN BIT_15
+#define TX_DASH_SEND_FW_OWN BIT_15
+#define TX_DASH_SEND_FW_OWN_HIGHBYTE BIT_7
+
+#define TXS_CC3_0       (BIT_0|BIT_1|BIT_2|BIT_3)
+#define TXS_EXC         BIT_4
+#define TXS_LNKF        BIT_5
+#define TXS_OWC         BIT_6
+#define TXS_TES         BIT_7
+#define TXS_UNF         BIT_9
+#define TXS_LGSEN       BIT_11
+#define TXS_LS          BIT_12
+#define TXS_FS          BIT_13
+#define TXS_EOR         BIT_14
+#define TXS_OWN         BIT_15
+
+#define TPPool_HRDY     0x20
+
+#define HostReqReg (0xC0)
+#define SystemMasterDescStartAddrLow (0xF0)
+#define SystemMasterDescStartAddrHigh (0xF4)
+#define SystemSlaveDescStartAddrLow (0xF8)
+#define SystemSlaveDescStartAddrHigh (0xFC)
+
+//DASH Request Type
+#define WSMANREG 0x01
+#define OSPUSHDATA 0x02
+
+#define RXS_OWN      BIT_15
+#define RXS_EOR      BIT_14
+#define RXS_FS       BIT_13
+#define RXS_LS       BIT_12
+
+#define ISRIMR_DP_DASH_OK BIT_15
+#define ISRIMR_DP_HOST_OK BIT_13
+#define ISRIMR_DP_REQSYS_OK BIT_11
+
+#define ISRIMR_DASH_INTR_EN BIT_12
+#define ISRIMR_DASH_INTR_CMAC_RESET BIT_15
+
+#define ISRIMR_DASH_TYPE2_ROK BIT_0
+#define ISRIMR_DASH_TYPE2_RDU BIT_1
+#define ISRIMR_DASH_TYPE2_TOK BIT_2
+#define ISRIMR_DASH_TYPE2_TDU BIT_3
+#define ISRIMR_DASH_TYPE2_TX_FIFO_FULL BIT_4
+#define ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE BIT_5
+#define ISRIMR_DASH_TYPE2_RX_DISABLE_IDLE BIT_6
+
+#define CMAC_OOB_STOP 0x25
+#define CMAC_OOB_INIT 0x26
+#define CMAC_OOB_RESET 0x2a
+
+#define NO_BASE_ADDRESS 0x00000000
+#define RTL8168FP_OOBMAC_BASE 0xBAF70000
+#define RTL8168FP_CMAC_IOBASE 0xBAF20000
+#define RTL8168FP_KVM_BASE 0xBAF80400
+#define CMAC_SYNC_REG 0x20
+#define CMAC_RXDESC_OFFSET 0x90    //RX: 0x90 - 0x98
+#define CMAC_TXDESC_OFFSET 0x98    //TX: 0x98 - 0x9F
+
+/* cmac write/read MMIO register */
+#define RTL_CMAC_W8(reg, val8)   writeb ((val8), tp->cmac_ioaddr + (reg))
+#define RTL_CMAC_W16(reg, val16) writew ((val16), tp->cmac_ioaddr + (reg))
+#define RTL_CMAC_W32(reg, val32) writel ((val32), tp->cmac_ioaddr + (reg))
+#define RTL_CMAC_R8(reg)     readb (tp->cmac_ioaddr + (reg))
+#define RTL_CMAC_R16(reg)        readw (tp->cmac_ioaddr + (reg))
+#define RTL_CMAC_R32(reg)        ((unsigned long) readl (tp->cmac_ioaddr + (reg)))
+
+int rtl8168_dash_ioctl(struct net_device *dev, struct ifreq *ifr);
+void HandleDashInterrupt(struct net_device *dev);
+int AllocateDashShareMemory(struct net_device *dev);
+void FreeAllocatedDashShareMemory(struct net_device *dev);
+void DashHwInit(struct net_device *dev);
+
+
+#endif /* _LINUX_R8168_DASH_H */
diff --git a/drivers/net/ethernet/realtek/r8168/r8168_fiber.h b/drivers/net/ethernet/realtek/r8168/r8168_fiber.h
new file mode 100644
index 00000000..cc7e974
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/r8168_fiber.h
@@ -0,0 +1,65 @@
+/*
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#ifndef _LINUX_R8168_FIBER_H
+#define _LINUX_R8168_FIBER_H
+
+enum {
+        FIBER_MODE_NIC_ONLY = 0,
+        FIBER_MODE_RTL8168H_RTL8211FS,
+        FIBER_MODE_RTL8168H_MDI_SWITCH_RTL8211FS,
+        FIBER_MODE_MAX
+};
+
+enum {
+        FIBER_STAT_NOT_CHECKED = 0,
+        FIBER_STAT_CONNECT,
+        FIBER_STAT_DISCONNECT,
+        FIBER_STAT_MAX
+};
+
+#define HW_FIBER_MODE_ENABLED(_M)        ((_M)->HwFiberModeVer > 0)
+
+
+
+void rtl8168_hw_init_fiber_nic(struct net_device *dev);
+void rtl8168_hw_fiber_nic_d3_para(struct net_device *dev);
+void rtl8168_hw_fiber_phy_config(struct net_device *dev);
+u32 rtl8168_hw_fiber_get_connect_status(struct net_device *dev);
+void rtl8168_hw_switch_mdi_to_fiber(struct net_device *dev);
+void rtl8168_hw_switch_mdi_to_nic(struct net_device *dev);
+unsigned int rtl8168_hw_fiber_link_ok(struct net_device *dev);
+void rtl8168_check_fiber_link_status(struct net_device *dev);
+
+
+#endif /* _LINUX_R8168_FIBER_H */
diff --git a/drivers/net/ethernet/realtek/r8168/r8168_n.c b/drivers/net/ethernet/realtek/r8168/r8168_n.c
new file mode 100644
index 00000000..1f8f5b4
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/r8168_n.c
@@ -0,0 +1,28706 @@
+/*
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+/*
+ * This driver is modified from r8169.c in Linux kernel 2.6.18
+ */
+
+#include <linux/module.h>
+#include <linux/version.h>
+#include <linux/pci.h>
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/delay.h>
+#include <linux/mii.h>
+#include <linux/if_vlan.h>
+#include <linux/crc32.h>
+#include <linux/interrupt.h>
+#include <linux/in.h>
+#include <linux/ip.h>
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,22)
+#include <linux/ipv6.h>
+#include <net/ip6_checksum.h>
+#endif
+#include <linux/tcp.h>
+#include <linux/init.h>
+#include <linux/rtnetlink.h>
+#include <linux/completion.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,26)
+#include <linux/pci-aspm.h>
+#endif
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,37)
+#include <linux/prefetch.h>
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+#define dev_printk(A,B,fmt,args...) printk(A fmt,##args)
+#else
+#include <linux/dma-mapping.h>
+#include <linux/moduleparam.h>
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,31)
+#include <linux/mdio.h>
+#endif
+
+#include <asm/io.h>
+#include <asm/irq.h>
+
+#include "r8168.h"
+#include "r8168_asf.h"
+#include "rtl_eeprom.h"
+#include "rtltool.h"
+
+#ifdef ENABLE_R8168_PROCFS
+#include <linux/proc_fs.h>
+#include <linux/seq_file.h>
+#endif
+
+/* Maximum number of multicast addresses to filter (vs. Rx-all-multicast).
+   The RTL chips use a 64 element hash table based on the Ethernet CRC. */
+static const int multicast_filter_limit = 32;
+
+#define _R(NAME,MAC,RCR,MASK, JumFrameSz) \
+    { .name = NAME, .mcfg = MAC, .RCR_Cfg = RCR, .RxConfigMask = MASK, .jumbo_frame_sz = JumFrameSz }
+
+static const struct {
+        const char *name;
+        u8 mcfg;
+        u32 RCR_Cfg;
+        u32 RxConfigMask;   /* Clears the bits supported by this chip */
+        u32 jumbo_frame_sz;
+} rtl_chip_info[] = {
+        _R("RTL8168B/8111B",
+        CFG_METHOD_1,
+        (Reserved2_data << Reserved2_shift) | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_4k),
+
+        _R("RTL8168B/8111B",
+        CFG_METHOD_2,
+        (Reserved2_data << Reserved2_shift) | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_4k),
+
+        _R("RTL8168B/8111B",
+        CFG_METHOD_3,
+        (Reserved2_data << Reserved2_shift) | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_4k),
+
+        _R("RTL8168C/8111C",
+        CFG_METHOD_4,
+        RxCfg_128_int_en | RxCfg_fet_multi_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_6k),
+
+        _R("RTL8168C/8111C",
+        CFG_METHOD_5,
+        RxCfg_128_int_en | RxCfg_fet_multi_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_6k),
+
+        _R("RTL8168C/8111C",
+        CFG_METHOD_6,
+        RxCfg_128_int_en | RxCfg_fet_multi_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_6k),
+
+        _R("RTL8168CP/8111CP",
+        CFG_METHOD_7,
+        RxCfg_128_int_en | RxCfg_fet_multi_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_6k),
+
+        _R("RTL8168CP/8111CP",
+        CFG_METHOD_8,
+        RxCfg_128_int_en | RxCfg_fet_multi_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_6k),
+
+        _R("RTL8168D/8111D",
+        CFG_METHOD_9,
+        RxCfg_128_int_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168D/8111D",
+        CFG_METHOD_10,
+        RxCfg_128_int_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168DP/8111DP",
+        CFG_METHOD_11,
+        RxCfg_128_int_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168DP/8111DP",
+        CFG_METHOD_12,
+        RxCfg_128_int_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168DP/8111DP",
+        CFG_METHOD_13,
+        RxCfg_128_int_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168E/8111E",
+        CFG_METHOD_14,
+        RxCfg_128_int_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168E/8111E",
+        CFG_METHOD_15,
+        RxCfg_128_int_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168E-VL/8111E-VL",
+        CFG_METHOD_16,
+        RxCfg_128_int_en | RxEarly_off_V1 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e0080,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168E-VL/8111E-VL",
+        CFG_METHOD_17,
+        RxCfg_128_int_en | RxEarly_off_V1 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168F/8111F",
+        CFG_METHOD_18,
+        RxCfg_128_int_en | RxEarly_off_V1 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168F/8111F",
+        CFG_METHOD_19,
+        RxCfg_128_int_en | RxEarly_off_V1 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8411",
+        CFG_METHOD_20,
+        RxCfg_128_int_en | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e1880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168G/8111G",
+        CFG_METHOD_21,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168G/8111G",
+        CFG_METHOD_22,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168EP/8111EP",
+        CFG_METHOD_23,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168GU/8111GU",
+        CFG_METHOD_24,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168GU/8111GU",
+        CFG_METHOD_25,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("8411B",
+        CFG_METHOD_26,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168EP/8111EP",
+        CFG_METHOD_27,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168EP/8111EP",
+        CFG_METHOD_28,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168H/8111H",
+        CFG_METHOD_29,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168H/8111H",
+        CFG_METHOD_30,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168FP/8111FP",
+        CFG_METHOD_31,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("RTL8168FP/8111FP",
+        CFG_METHOD_32,
+        RxCfg_128_int_en | RxEarly_off_V2 | Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_9k),
+
+        _R("Unknown",
+        CFG_METHOD_DEFAULT,
+        (RX_DMA_BURST << RxCfgDMAShift),
+        0xff7e5880,
+        Jumbo_Frame_1k)
+};
+#undef _R
+
+#ifndef PCI_VENDOR_ID_DLINK
+#define PCI_VENDOR_ID_DLINK 0x1186
+#endif
+
+static struct pci_device_id rtl8168_pci_tbl[] = {
+        { PCI_DEVICE(PCI_VENDOR_ID_REALTEK, 0x8168), },
+        { PCI_DEVICE(PCI_VENDOR_ID_REALTEK, 0x8161), },
+        { PCI_VENDOR_ID_DLINK, 0x4300, 0x1186, 0x4b10,},
+        {0,},
+};
+
+MODULE_DEVICE_TABLE(pci, rtl8168_pci_tbl);
+
+static int rx_copybreak = 0;
+static int use_dac = 1;
+static int timer_count = 0x2600;
+
+static struct {
+        u32 msg_enable;
+} debug = { -1 };
+
+static unsigned int speed_mode = SPEED_1000;
+static unsigned int duplex_mode = DUPLEX_FULL;
+static unsigned int autoneg_mode = AUTONEG_ENABLE;
+static unsigned int advertising_mode =  ADVERTISED_10baseT_Half |
+                                        ADVERTISED_10baseT_Full |
+                                        ADVERTISED_100baseT_Half |
+                                        ADVERTISED_100baseT_Full |
+                                        ADVERTISED_1000baseT_Half |
+                                        ADVERTISED_1000baseT_Full;
+#ifdef CONFIG_ASPM
+static int aspm = 1;
+#else
+static int aspm = 0;
+#endif
+#ifdef ENABLE_S5WOL
+static int s5wol = 1;
+#else
+static int s5wol = 0;
+#endif
+#ifdef ENABLE_S5_KEEP_CURR_MAC
+static int s5_keep_curr_mac = 1;
+#else
+static int s5_keep_curr_mac = 0;
+#endif
+#ifdef ENABLE_EEE
+static int eee_enable = 1;
+#else
+static int eee_enable = 0;
+#endif
+#ifdef CONFIG_SOC_LAN
+static ulong hwoptimize = HW_PATCH_SOC_LAN;
+#else
+static ulong hwoptimize = 0;
+#endif
+#ifdef ENABLE_S0_MAGIC_PACKET
+static int s0_magic_packet = 1;
+#else
+static int s0_magic_packet = 0;
+#endif
+
+MODULE_AUTHOR("Realtek and the Linux r8168 crew <netdev@vger.kernel.org>");
+MODULE_DESCRIPTION("RealTek RTL-8168 Gigabit Ethernet driver");
+
+module_param(speed_mode, uint, 0);
+MODULE_PARM_DESC(speed_mode, "force phy operation. Deprecated by ethtool (8).");
+
+module_param(duplex_mode, uint, 0);
+MODULE_PARM_DESC(duplex_mode, "force phy operation. Deprecated by ethtool (8).");
+
+module_param(autoneg_mode, uint, 0);
+MODULE_PARM_DESC(autoneg_mode, "force phy operation. Deprecated by ethtool (8).");
+
+module_param(advertising_mode, uint, 0);
+MODULE_PARM_DESC(advertising_mode, "force phy operation. Deprecated by ethtool (8).");
+
+module_param(aspm, int, 0);
+MODULE_PARM_DESC(aspm, "Enable ASPM.");
+
+module_param(s5wol, int, 0);
+MODULE_PARM_DESC(s5wol, "Enable Shutdown Wake On Lan.");
+
+module_param(s5_keep_curr_mac, int, 0);
+MODULE_PARM_DESC(s5_keep_curr_mac, "Enable Shutdown Keep Current MAC Address.");
+
+module_param(rx_copybreak, int, 0);
+MODULE_PARM_DESC(rx_copybreak, "Copy breakpoint for copy-only-tiny-frames");
+
+module_param(use_dac, int, 0);
+MODULE_PARM_DESC(use_dac, "Enable PCI DAC. Unsafe on 32 bit PCI slot.");
+
+module_param(timer_count, int, 0);
+MODULE_PARM_DESC(timer_count, "Timer Interrupt Interval.");
+
+module_param(eee_enable, int, 0);
+MODULE_PARM_DESC(eee_enable, "Enable Energy Efficient Ethernet.");
+
+module_param(hwoptimize, ulong, 0);
+MODULE_PARM_DESC(hwoptimize, "Enable HW optimization function.");
+
+module_param(s0_magic_packet, int, 0);
+MODULE_PARM_DESC(s0_magic_packet, "Enable S0 Magic Packet.");
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+module_param_named(debug, debug.msg_enable, int, 0);
+MODULE_PARM_DESC(debug, "Debug verbosity level (0=none, ..., 16=all)");
+#endif//LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+
+MODULE_LICENSE("GPL");
+
+MODULE_VERSION(RTL8168_VERSION);
+
+static void rtl8168_sleep_rx_enable(struct net_device *dev);
+static void rtl8168_dsm(struct net_device *dev, int dev_state);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+static void rtl8168_esd_timer(unsigned long __opaque);
+#else
+static void rtl8168_esd_timer(struct timer_list *t);
+#endif
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+static void rtl8168_link_timer(unsigned long __opaque);
+#else
+static void rtl8168_link_timer(struct timer_list *t);
+#endif
+static void rtl8168_tx_clear(struct rtl8168_private *tp);
+static void rtl8168_rx_clear(struct rtl8168_private *tp);
+
+static int rtl8168_open(struct net_device *dev);
+static int rtl8168_start_xmit(struct sk_buff *skb, struct net_device *dev);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
+static irqreturn_t rtl8168_interrupt(int irq, void *dev_instance, struct pt_regs *regs);
+#else
+static irqreturn_t rtl8168_interrupt(int irq, void *dev_instance);
+#endif
+static void rtl8168_rx_desc_offset0_init(struct rtl8168_private *, int);
+static int rtl8168_init_ring(struct net_device *dev);
+static void rtl8168_hw_config(struct net_device *dev);
+static void rtl8168_hw_start(struct net_device *dev);
+static int rtl8168_close(struct net_device *dev);
+static void rtl8168_set_rx_mode(struct net_device *dev);
+static void rtl8168_tx_timeout(struct net_device *dev);
+static struct net_device_stats *rtl8168_get_stats(struct net_device *dev);
+static int rtl8168_rx_interrupt(struct net_device *, struct rtl8168_private *, void __iomem *, napi_budget);
+static int rtl8168_change_mtu(struct net_device *dev, int new_mtu);
+static void rtl8168_down(struct net_device *dev);
+
+static int rtl8168_set_mac_address(struct net_device *dev, void *p);
+void rtl8168_rar_set(struct rtl8168_private *tp, uint8_t *addr);
+static void rtl8168_desc_addr_fill(struct rtl8168_private *);
+static void rtl8168_tx_desc_init(struct rtl8168_private *tp);
+static void rtl8168_rx_desc_init(struct rtl8168_private *tp);
+
+static void rtl8168_hw_reset(struct net_device *dev);
+
+static void rtl8168_phy_power_up(struct net_device *dev);
+static void rtl8168_phy_power_down(struct net_device *dev);
+static int rtl8168_set_speed(struct net_device *dev, u8 autoneg, u32 speed, u8 duplex, u32 adv);
+
+#ifdef CONFIG_R8168_NAPI
+static int rtl8168_poll(napi_ptr napi, napi_budget budget);
+#endif
+
+#if ((LINUX_VERSION_CODE < KERNEL_VERSION(4,7,0) && \
+     LINUX_VERSION_CODE >= KERNEL_VERSION(4,6,00)))
+void ethtool_convert_legacy_u32_to_link_mode(unsigned long *dst,
+                u32 legacy_u32)
+{
+        bitmap_zero(dst, __ETHTOOL_LINK_MODE_MASK_NBITS);
+        dst[0] = legacy_u32;
+}
+
+bool ethtool_convert_link_mode_to_legacy_u32(u32 *legacy_u32,
+                const unsigned long *src)
+{
+        bool retval = true;
+
+        /* TODO: following test will soon always be true */
+        if (__ETHTOOL_LINK_MODE_MASK_NBITS > 32) {
+                __ETHTOOL_DECLARE_LINK_MODE_MASK(ext);
+
+                bitmap_zero(ext, __ETHTOOL_LINK_MODE_MASK_NBITS);
+                bitmap_fill(ext, 32);
+                bitmap_complement(ext, ext, __ETHTOOL_LINK_MODE_MASK_NBITS);
+                if (bitmap_intersects(ext, src,
+                                      __ETHTOOL_LINK_MODE_MASK_NBITS)) {
+                        /* src mask goes beyond bit 31 */
+                        retval = false;
+                }
+        }
+        *legacy_u32 = src[0];
+        return retval;
+}
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+
+#ifndef LPA_1000FULL
+#define LPA_1000FULL            0x0800
+#endif
+
+#ifndef LPA_1000HALF
+#define LPA_1000HALF            0x0400
+#endif
+
+static inline u32 mii_adv_to_ethtool_adv_t(u32 adv)
+{
+        u32 result = 0;
+
+        if (adv & ADVERTISE_10HALF)
+                result |= ADVERTISED_10baseT_Half;
+        if (adv & ADVERTISE_10FULL)
+                result |= ADVERTISED_10baseT_Full;
+        if (adv & ADVERTISE_100HALF)
+                result |= ADVERTISED_100baseT_Half;
+        if (adv & ADVERTISE_100FULL)
+                result |= ADVERTISED_100baseT_Full;
+        if (adv & ADVERTISE_PAUSE_CAP)
+                result |= ADVERTISED_Pause;
+        if (adv & ADVERTISE_PAUSE_ASYM)
+                result |= ADVERTISED_Asym_Pause;
+
+        return result;
+}
+
+static inline u32 mii_lpa_to_ethtool_lpa_t(u32 lpa)
+{
+        u32 result = 0;
+
+        if (lpa & LPA_LPACK)
+                result |= ADVERTISED_Autoneg;
+
+        return result | mii_adv_to_ethtool_adv_t(lpa);
+}
+
+static inline u32 mii_stat1000_to_ethtool_lpa_t(u32 lpa)
+{
+        u32 result = 0;
+
+        if (lpa & LPA_1000HALF)
+                result |= ADVERTISED_1000baseT_Half;
+        if (lpa & LPA_1000FULL)
+                result |= ADVERTISED_1000baseT_Full;
+
+        return result;
+}
+
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,4,0)
+static inline void eth_hw_addr_random(struct net_device *dev)
+{
+        random_ether_addr(dev->dev_addr);
+}
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+#undef ethtool_ops
+#define ethtool_ops _kc_ethtool_ops
+
+struct _kc_ethtool_ops {
+        int  (*get_settings)(struct net_device *, struct ethtool_cmd *);
+        int  (*set_settings)(struct net_device *, struct ethtool_cmd *);
+        void (*get_drvinfo)(struct net_device *, struct ethtool_drvinfo *);
+        int  (*get_regs_len)(struct net_device *);
+        void (*get_regs)(struct net_device *, struct ethtool_regs *, void *);
+        void (*get_wol)(struct net_device *, struct ethtool_wolinfo *);
+        int  (*set_wol)(struct net_device *, struct ethtool_wolinfo *);
+        u32  (*get_msglevel)(struct net_device *);
+        void (*set_msglevel)(struct net_device *, u32);
+        int  (*nway_reset)(struct net_device *);
+        u32  (*get_link)(struct net_device *);
+        int  (*get_eeprom_len)(struct net_device *);
+        int  (*get_eeprom)(struct net_device *, struct ethtool_eeprom *, u8 *);
+        int  (*set_eeprom)(struct net_device *, struct ethtool_eeprom *, u8 *);
+        int  (*get_coalesce)(struct net_device *, struct ethtool_coalesce *);
+        int  (*set_coalesce)(struct net_device *, struct ethtool_coalesce *);
+        void (*get_ringparam)(struct net_device *, struct ethtool_ringparam *);
+        int  (*set_ringparam)(struct net_device *, struct ethtool_ringparam *);
+        void (*get_pauseparam)(struct net_device *,
+                               struct ethtool_pauseparam*);
+        int  (*set_pauseparam)(struct net_device *,
+                               struct ethtool_pauseparam*);
+        u32  (*get_rx_csum)(struct net_device *);
+        int  (*set_rx_csum)(struct net_device *, u32);
+        u32  (*get_tx_csum)(struct net_device *);
+        int  (*set_tx_csum)(struct net_device *, u32);
+        u32  (*get_sg)(struct net_device *);
+        int  (*set_sg)(struct net_device *, u32);
+        u32  (*get_tso)(struct net_device *);
+        int  (*set_tso)(struct net_device *, u32);
+        int  (*self_test_count)(struct net_device *);
+        void (*self_test)(struct net_device *, struct ethtool_test *, u64 *);
+        void (*get_strings)(struct net_device *, u32 stringset, u8 *);
+        int  (*phys_id)(struct net_device *, u32);
+        int  (*get_stats_count)(struct net_device *);
+        void (*get_ethtool_stats)(struct net_device *, struct ethtool_stats *,
+                                  u64 *);
+} *ethtool_ops = NULL;
+
+#undef SET_ETHTOOL_OPS
+#define SET_ETHTOOL_OPS(netdev, ops) (ethtool_ops = (ops))
+
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,16,0)
+#ifndef SET_ETHTOOL_OPS
+#define SET_ETHTOOL_OPS(netdev,ops) \
+         ( (netdev)->ethtool_ops = (ops) )
+#endif //SET_ETHTOOL_OPS
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(3,16,0)
+
+//#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,5)
+#ifndef netif_msg_init
+#define netif_msg_init _kc_netif_msg_init
+/* copied from linux kernel 2.6.20 include/linux/netdevice.h */
+static inline u32 netif_msg_init(int debug_value, int default_msg_enable_bits)
+{
+        /* use default */
+        if (debug_value < 0 || debug_value >= (sizeof(u32) * 8))
+                return default_msg_enable_bits;
+        if (debug_value == 0)   /* no output */
+                return 0;
+        /* set low N bits */
+        return (1 << debug_value) - 1;
+}
+
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,5)
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,22)
+static inline void eth_copy_and_sum (struct sk_buff *dest,
+                                     const unsigned char *src,
+                                     int len, int base)
+{
+        memcpy (dest->data, src, len);
+}
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,22)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,7)
+/* copied from linux kernel 2.6.20 /include/linux/time.h */
+/* Parameters used to convert the timespec values: */
+#define MSEC_PER_SEC    1000L
+
+/* copied from linux kernel 2.6.20 /include/linux/jiffies.h */
+/*
+ * Change timeval to jiffies, trying to avoid the
+ * most obvious overflows..
+ *
+ * And some not so obvious.
+ *
+ * Note that we don't want to return MAX_LONG, because
+ * for various timeout reasons we often end up having
+ * to wait "jiffies+1" in order to guarantee that we wait
+ * at _least_ "jiffies" - so "jiffies+1" had better still
+ * be positive.
+ */
+#define MAX_JIFFY_OFFSET ((~0UL >> 1)-1)
+
+/*
+ * Convert jiffies to milliseconds and back.
+ *
+ * Avoid unnecessary multiplications/divisions in the
+ * two most common HZ cases:
+ */
+static inline unsigned int _kc_jiffies_to_msecs(const unsigned long j)
+{
+#if HZ <= MSEC_PER_SEC && !(MSEC_PER_SEC % HZ)
+        return (MSEC_PER_SEC / HZ) * j;
+#elif HZ > MSEC_PER_SEC && !(HZ % MSEC_PER_SEC)
+        return (j + (HZ / MSEC_PER_SEC) - 1)/(HZ / MSEC_PER_SEC);
+#else
+        return (j * MSEC_PER_SEC) / HZ;
+#endif
+}
+
+static inline unsigned long _kc_msecs_to_jiffies(const unsigned int m)
+{
+        if (m > _kc_jiffies_to_msecs(MAX_JIFFY_OFFSET))
+                return MAX_JIFFY_OFFSET;
+#if HZ <= MSEC_PER_SEC && !(MSEC_PER_SEC % HZ)
+        return (m + (MSEC_PER_SEC / HZ) - 1) / (MSEC_PER_SEC / HZ);
+#elif HZ > MSEC_PER_SEC && !(HZ % MSEC_PER_SEC)
+        return m * (HZ / MSEC_PER_SEC);
+#else
+        return (m * HZ + MSEC_PER_SEC - 1) / MSEC_PER_SEC;
+#endif
+}
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,7)
+
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,11)
+
+/* copied from linux kernel 2.6.12.6 /include/linux/pm.h */
+typedef int __bitwise pci_power_t;
+
+/* copied from linux kernel 2.6.12.6 /include/linux/pci.h */
+typedef u32 __bitwise pm_message_t;
+
+#define PCI_D0  ((pci_power_t __force) 0)
+#define PCI_D1  ((pci_power_t __force) 1)
+#define PCI_D2  ((pci_power_t __force) 2)
+#define PCI_D3hot   ((pci_power_t __force) 3)
+#define PCI_D3cold  ((pci_power_t __force) 4)
+#define PCI_POWER_ERROR ((pci_power_t __force) -1)
+
+/* copied from linux kernel 2.6.12.6 /drivers/pci/pci.c */
+/**
+ * pci_choose_state - Choose the power state of a PCI device
+ * @dev: PCI device to be suspended
+ * @state: target sleep state for the whole system. This is the value
+ *  that is passed to suspend() function.
+ *
+ * Returns PCI power state suitable for given device and given system
+ * message.
+ */
+
+pci_power_t pci_choose_state(struct pci_dev *dev, pm_message_t state)
+{
+        if (!pci_find_capability(dev, PCI_CAP_ID_PM))
+                return PCI_D0;
+
+        switch (state) {
+        case 0:
+                return PCI_D0;
+        case 3:
+                return PCI_D3hot;
+        default:
+                printk("They asked me for state %d\n", state);
+//      BUG();
+        }
+        return PCI_D0;
+}
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,11)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
+/**
+ * msleep_interruptible - sleep waiting for waitqueue interruptions
+ * @msecs: Time in milliseconds to sleep for
+ */
+#define msleep_interruptible _kc_msleep_interruptible
+unsigned long _kc_msleep_interruptible(unsigned int msecs)
+{
+        unsigned long timeout = _kc_msecs_to_jiffies(msecs);
+
+        while (timeout && !signal_pending(current)) {
+                set_current_state(TASK_INTERRUPTIBLE);
+                timeout = schedule_timeout(timeout);
+        }
+        return _kc_jiffies_to_msecs(timeout);
+}
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,7)
+/* copied from linux kernel 2.6.20 include/linux/sched.h */
+#ifndef __sched
+#define __sched     __attribute__((__section__(".sched.text")))
+#endif
+
+/* copied from linux kernel 2.6.20 kernel/timer.c */
+signed long __sched schedule_timeout_uninterruptible(signed long timeout)
+{
+        __set_current_state(TASK_UNINTERRUPTIBLE);
+        return schedule_timeout(timeout);
+}
+
+/* copied from linux kernel 2.6.20 include/linux/mii.h */
+#undef if_mii
+#define if_mii _kc_if_mii
+static inline struct mii_ioctl_data *if_mii(struct ifreq *rq)
+{
+        return (struct mii_ioctl_data *) &rq->ifr_ifru;
+}
+#endif  //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,7)
+
+struct rtl8168_counters {
+        u64 tx_packets;
+        u64 rx_packets;
+        u64 tx_errors;
+        u32 rx_errors;
+        u16 rx_missed;
+        u16 align_errors;
+        u32 tx_one_collision;
+        u32 tx_multi_collision;
+        u64 rx_unicast;
+        u64 rx_broadcast;
+        u32 rx_multicast;
+        u16 tx_aborted;
+        u16 tx_underun;
+};
+
+#ifdef ENABLE_R8168_PROCFS
+/****************************************************************************
+*   -----------------------------PROCFS STUFF-------------------------
+*****************************************************************************
+*/
+
+static struct proc_dir_entry *rtl8168_proc;
+static int proc_init_num = 0;
+static u8 wol_enable = 0;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+static int proc_get_driver_variable(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        seq_puts(m, "\nDump Driver Variable\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        seq_puts(m, "Variable\tValue\n----------\t-----\n");
+        seq_printf(m, "MODULENAME\t%s\n", MODULENAME);
+        seq_printf(m, "driver version\t%s\n", RTL8168_VERSION);
+        seq_printf(m, "chipset\t%d\n", tp->chipset);
+        seq_printf(m, "chipset_name\t%s\n", rtl_chip_info[tp->chipset].name);
+        seq_printf(m, "mtu\t%d\n", dev->mtu);
+        seq_printf(m, "NUM_RX_DESC\t0x%x\n", NUM_RX_DESC);
+        seq_printf(m, "cur_rx\t0x%x\n", tp->cur_rx);
+        seq_printf(m, "dirty_rx\t0x%x\n", tp->dirty_rx);
+        seq_printf(m, "NUM_TX_DESC\t0x%x\n", NUM_TX_DESC);
+        seq_printf(m, "cur_tx\t0x%x\n", tp->cur_tx);
+        seq_printf(m, "dirty_tx\t0x%x\n", tp->dirty_tx);
+        seq_printf(m, "rx_buf_sz\t0x%x\n", tp->rx_buf_sz);
+        seq_printf(m, "esd_flag\t0x%x\n", tp->esd_flag);
+        seq_printf(m, "pci_cfg_is_read\t0x%x\n", tp->pci_cfg_is_read);
+        seq_printf(m, "rtl8168_rx_config\t0x%x\n", tp->rtl8168_rx_config);
+        seq_printf(m, "cp_cmd\t0x%x\n", tp->cp_cmd);
+        seq_printf(m, "intr_mask\t0x%x\n", tp->intr_mask);
+        seq_printf(m, "timer_intr_mask\t0x%x\n", tp->timer_intr_mask);
+        seq_printf(m, "wol_enabled\t0x%x\n", tp->wol_enabled);
+        seq_printf(m, "wol_opts\t0x%x\n", tp->wol_opts);
+        seq_printf(m, "efuse_ver\t0x%x\n", tp->efuse_ver);
+        seq_printf(m, "eeprom_type\t0x%x\n", tp->eeprom_type);
+        seq_printf(m, "autoneg\t0x%x\n", tp->autoneg);
+        seq_printf(m, "duplex\t0x%x\n", tp->duplex);
+        seq_printf(m, "speed\t%d\n", tp->speed);
+        seq_printf(m, "advertising\t0x%x\n", tp->advertising);
+        seq_printf(m, "eeprom_len\t0x%x\n", tp->eeprom_len);
+        seq_printf(m, "cur_page\t0x%x\n", tp->cur_page);
+        seq_printf(m, "bios_setting\t0x%x\n", tp->bios_setting);
+        seq_printf(m, "features\t0x%x\n", tp->features);
+        seq_printf(m, "org_pci_offset_99\t0x%x\n", tp->org_pci_offset_99);
+        seq_printf(m, "org_pci_offset_180\t0x%x\n", tp->org_pci_offset_180);
+        seq_printf(m, "issue_offset_99_event\t0x%x\n", tp->issue_offset_99_event);
+        seq_printf(m, "org_pci_offset_80\t0x%x\n", tp->org_pci_offset_80);
+        seq_printf(m, "org_pci_offset_81\t0x%x\n", tp->org_pci_offset_81);
+        seq_printf(m, "use_timer_interrrupt\t0x%x\n", tp->use_timer_interrrupt);
+        seq_printf(m, "HwIcVerUnknown\t0x%x\n", tp->HwIcVerUnknown);
+        seq_printf(m, "NotWrRamCodeToMicroP\t0x%x\n", tp->NotWrRamCodeToMicroP);
+        seq_printf(m, "NotWrMcuPatchCode\t0x%x\n", tp->NotWrMcuPatchCode);
+        seq_printf(m, "HwHasWrRamCodeToMicroP\t0x%x\n", tp->HwHasWrRamCodeToMicroP);
+        seq_printf(m, "sw_ram_code_ver\t0x%x\n", tp->sw_ram_code_ver);
+        seq_printf(m, "hw_ram_code_ver\t0x%x\n", tp->hw_ram_code_ver);
+        seq_printf(m, "rtk_enable_diag\t0x%x\n", tp->rtk_enable_diag);
+        seq_printf(m, "ShortPacketSwChecksum\t0x%x\n", tp->ShortPacketSwChecksum);
+        seq_printf(m, "UseSwPaddingShortPkt\t0x%x\n", tp->UseSwPaddingShortPkt);
+        seq_printf(m, "RequireAdcBiasPatch\t0x%x\n", tp->RequireAdcBiasPatch);
+        seq_printf(m, "AdcBiasPatchIoffset\t0x%x\n", tp->AdcBiasPatchIoffset);
+        seq_printf(m, "RequireAdjustUpsTxLinkPulseTiming\t0x%x\n", tp->RequireAdjustUpsTxLinkPulseTiming);
+        seq_printf(m, "SwrCnt1msIni\t0x%x\n", tp->SwrCnt1msIni);
+        seq_printf(m, "HwSuppNowIsOobVer\t0x%x\n", tp->HwSuppNowIsOobVer);
+        seq_printf(m, "HwFiberModeVer\t0x%x\n", tp->HwFiberModeVer);
+        seq_printf(m, "HwFiberStat\t0x%x\n", tp->HwFiberStat);
+        seq_printf(m, "HwSwitchMdiToFiber\t0x%x\n", tp->HwSwitchMdiToFiber);
+        seq_printf(m, "NicCustLedValue\t0x%x\n", tp->NicCustLedValue);
+        seq_printf(m, "RequiredSecLanDonglePatch\t0x%x\n", tp->RequiredSecLanDonglePatch);
+        seq_printf(m, "HwSuppDashVer\t0x%x\n", tp->HwSuppDashVer);
+        seq_printf(m, "DASH\t0x%x\n", tp->DASH);
+        seq_printf(m, "dash_printer_enabled\t0x%x\n", tp->dash_printer_enabled);
+        seq_printf(m, "HwSuppKCPOffloadVer\t0x%x\n", tp->HwSuppKCPOffloadVer);
+        seq_printf(m, "speed_mode\t0x%x\n", speed_mode);
+        seq_printf(m, "duplex_mode\t0x%x\n", duplex_mode);
+        seq_printf(m, "autoneg_mode\t0x%x\n", autoneg_mode);
+        seq_printf(m, "advertising_mode\t0x%x\n", advertising_mode);
+        seq_printf(m, "aspm\t0x%x\n", aspm);
+        seq_printf(m, "s5wol\t0x%x\n", s5wol);
+        seq_printf(m, "s5_keep_curr_mac\t0x%x\n", s5_keep_curr_mac);
+        seq_printf(m, "eee_enable\t0x%x\n", eee_enable);
+        seq_printf(m, "hwoptimize\t0x%lx\n", hwoptimize);
+        seq_printf(m, "proc_init_num\t0x%x\n", proc_init_num);
+        seq_printf(m, "s0_magic_packet\t0x%x\n", s0_magic_packet);
+        seq_printf(m, "HwSuppMagicPktVer\t0x%x\n", tp->HwSuppMagicPktVer);
+        seq_printf(m, "HwSuppCheckPhyDisableModeVer\t0x%x\n", tp->HwSuppCheckPhyDisableModeVer);
+        seq_printf(m, "HwPkgDet\t0x%x\n", tp->HwPkgDet);
+        seq_printf(m, "HwSuppGigaForceMode\t0x%x\n", tp->HwSuppGigaForceMode);
+        seq_printf(m, "random_mac\t0x%x\n", tp->random_mac);
+        seq_printf(m, "org_mac_addr\t%pM\n", tp->org_mac_addr);
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+        seq_printf(m, "perm_addr\t%pM\n", dev->perm_addr);
+#endif
+        seq_printf(m, "dev_addr\t%pM\n", dev->dev_addr);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_tally_counter(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        struct rtl8168_counters *counters;
+        dma_addr_t paddr;
+        u32 cmd;
+        u32 WaitCnt;
+        unsigned long flags;
+
+        seq_puts(m, "\nDump Tally Counter\n");
+
+        //ASSERT_RTNL();
+
+        counters = tp->tally_vaddr;
+        paddr = tp->tally_paddr;
+        if (!counters) {
+                seq_puts(m, "\nDump Tally Counter Fail\n");
+                return 0;
+        }
+
+        spin_lock_irqsave(&tp->lock, flags);
+        RTL_W32(CounterAddrHigh, (u64)paddr >> 32);
+        cmd = (u64)paddr & DMA_BIT_MASK(32);
+        RTL_W32(CounterAddrLow, cmd);
+        RTL_W32(CounterAddrLow, cmd | CounterDump);
+
+        WaitCnt = 0;
+        while (RTL_R32(CounterAddrLow) & CounterDump) {
+                udelay(10);
+
+                WaitCnt++;
+                if (WaitCnt > 20)
+                        break;
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_puts(m, "Statistics\tValue\n----------\t-----\n");
+        seq_printf(m, "tx_packets\t%lld\n", le64_to_cpu(counters->tx_packets));
+        seq_printf(m, "rx_packets\t%lld\n", le64_to_cpu(counters->rx_packets));
+        seq_printf(m, "tx_errors\t%lld\n", le64_to_cpu(counters->tx_errors));
+        seq_printf(m, "rx_missed\t%lld\n", le64_to_cpu(counters->rx_missed));
+        seq_printf(m, "align_errors\t%lld\n", le64_to_cpu(counters->align_errors));
+        seq_printf(m, "tx_one_collision\t%lld\n", le64_to_cpu(counters->tx_one_collision));
+        seq_printf(m, "tx_multi_collision\t%lld\n", le64_to_cpu(counters->tx_multi_collision));
+        seq_printf(m, "rx_unicast\t%lld\n", le64_to_cpu(counters->rx_unicast));
+        seq_printf(m, "rx_broadcast\t%lld\n", le64_to_cpu(counters->rx_broadcast));
+        seq_printf(m, "rx_multicast\t%lld\n", le64_to_cpu(counters->rx_multicast));
+        seq_printf(m, "tx_aborted\t%lld\n", le64_to_cpu(counters->tx_aborted));
+        seq_printf(m, "tx_underun\t%lld\n", le64_to_cpu(counters->tx_underun));
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_registers(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        int i, n, max = R8168_MAC_REGS_SIZE;
+        u8 byte_rd;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+
+        seq_puts(m, "\nDump MAC Registers\n");
+        seq_puts(m, "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                seq_printf(m, "\n0x%02x:\t", n);
+
+                for (i = 0; i < 16 && n < max; i++, n++) {
+                        byte_rd = readb(ioaddr + n);
+                        seq_printf(m, "%02x ", byte_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_pcie_phy(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        int i, n, max = R8168_EPHY_REGS_SIZE/2;
+        u16 word_rd;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+
+        seq_puts(m, "\nDump PCIE PHY\n");
+        seq_puts(m, "\nOffset\tValue\n------\t-----\n ");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                seq_printf(m, "\n0x%02x:\t", n);
+
+                for (i = 0; i < 8 && n < max; i++, n++) {
+                        word_rd = rtl8168_ephy_read(ioaddr, n);
+                        seq_printf(m, "%04x ", word_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_eth_phy(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        int i, n, max = R8168_PHY_REGS_SIZE/2;
+        u16 word_rd;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        seq_puts(m, "\nDump Ethernet PHY\n");
+        seq_puts(m, "\nOffset\tValue\n------\t-----\n ");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        seq_puts(m, "\n####################page 0##################\n ");
+        mdio_write(tp, 0x1f, 0x0000);
+        for (n = 0; n < max;) {
+                seq_printf(m, "\n0x%02x:\t", n);
+
+                for (i = 0; i < 8 && n < max; i++, n++) {
+                        word_rd = mdio_read(tp, n);
+                        seq_printf(m, "%04x ", word_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_extended_registers(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        int i, n, max = R8168_ERI_REGS_SIZE;
+        u32 dword_rd;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_1:
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+                /* RTL8168B does not support Extend GMAC */
+                seq_puts(m, "\nNot Support Dump Extended Registers\n");
+                return 0;
+        }
+
+        seq_puts(m, "\nDump Extended Registers\n");
+        seq_puts(m, "\nOffset\tValue\n------\t-----\n ");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                seq_printf(m, "\n0x%02x:\t", n);
+
+                for (i = 0; i < 4 && n < max; i++, n+=4) {
+                        dword_rd = rtl8168_eri_read(ioaddr, n, 4, ERIAR_ExGMAC);
+                        seq_printf(m, "%08x ", dword_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+
+static int proc_get_pci_registers(struct seq_file *m, void *v)
+{
+        struct net_device *dev = m->private;
+        int i, n, max = R8168_PCI_REGS_SIZE;
+        u32 dword_rd;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        seq_puts(m, "\nDump PCI Registers\n");
+        seq_puts(m, "\nOffset\tValue\n------\t-----\n ");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                seq_printf(m, "\n0x%03x:\t", n);
+
+                for (i = 0; i < 4 && n < max; i++, n+=4) {
+                        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+                        seq_printf(m, "%08x ", dword_rd);
+                }
+        }
+
+        n = 0x110;
+        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+        seq_printf(m, "\n0x%03x:\t%08x ", n, dword_rd);
+        n = 0x70c;
+        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+        seq_printf(m, "\n0x%03x:\t%08x ", n, dword_rd);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        seq_putc(m, '\n');
+        return 0;
+}
+#else
+
+static int proc_get_driver_variable(char *page, char **start,
+                                    off_t offset, int count,
+                                    int *eof, void *data)
+{
+        struct net_device *dev = data;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump Driver Driver\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        len += snprintf(page + len, count - len,
+                        "Variable\tValue\n----------\t-----\n");
+
+        len += snprintf(page + len, count - len,
+                        "MODULENAME\t%s\n"
+                        "driver version\t%s\n"
+                        "chipset\t%d\n"
+                        "chipset_name\t%s\n"
+                        "mtu\t%d\n"
+                        "NUM_RX_DESC\t0x%x\n"
+                        "cur_rx\t0x%x\n"
+                        "dirty_rx\t0x%x\n"
+                        "NUM_TX_DESC\t0x%x\n"
+                        "cur_tx\t0x%x\n"
+                        "dirty_tx\t0x%x\n"
+                        "rx_buf_sz\t0x%x\n"
+                        "esd_flag\t0x%x\n"
+                        "pci_cfg_is_read\t0x%x\n"
+                        "rtl8168_rx_config\t0x%x\n"
+                        "cp_cmd\t0x%x\n"
+                        "intr_mask\t0x%x\n"
+                        "timer_intr_mask\t0x%x\n"
+                        "wol_enabled\t0x%x\n"
+                        "wol_opts\t0x%x\n"
+                        "efuse_ver\t0x%x\n"
+                        "eeprom_type\t0x%x\n"
+                        "autoneg\t0x%x\n"
+                        "duplex\t0x%x\n"
+                        "speed\t%d\n"
+                        "advertising\t0x%x\n"
+                        "eeprom_len\t0x%x\n"
+                        "cur_page\t0x%x\n"
+                        "bios_setting\t0x%x\n"
+                        "features\t0x%x\n"
+                        "org_pci_offset_99\t0x%x\n"
+                        "org_pci_offset_180\t0x%x\n"
+                        "issue_offset_99_event\t0x%x\n"
+                        "org_pci_offset_80\t0x%x\n"
+                        "org_pci_offset_81\t0x%x\n"
+                        "use_timer_interrrupt\t0x%x\n"
+                        "HwIcVerUnknown\t0x%x\n"
+                        "NotWrRamCodeToMicroP\t0x%x\n"
+                        "NotWrMcuPatchCode\t0x%x\n"
+                        "HwHasWrRamCodeToMicroP\t0x%x\n"
+                        "sw_ram_code_ver\t0x%x\n"
+                        "hw_ram_code_ver\t0x%x\n"
+                        "rtk_enable_diag\t0x%x\n"
+                        "ShortPacketSwChecksum\t0x%x\n"
+                        "UseSwPaddingShortPkt\t0x%x\n"
+                        "RequireAdcBiasPatch\t0x%x\n"
+                        "AdcBiasPatchIoffset\t0x%x\n"
+                        "RequireAdjustUpsTxLinkPulseTiming\t0x%x\n"
+                        "SwrCnt1msIni\t0x%x\n"
+                        "HwSuppNowIsOobVer\t0x%x\n"
+                        "HwFiberModeVer\t0x%x\n"
+                        "HwFiberStat\t0x%x\n"
+                        "HwSwitchMdiToFiber\t0x%x\n"
+                        "NicCustLedValue\t0x%x\n"
+                        "RequiredSecLanDonglePatch\t0x%x\n"
+                        "HwSuppDashVer\t0x%x\n"
+                        "DASH\t0x%x\n"
+                        "dash_printer_enabled\t0x%x\n"
+                        "HwSuppKCPOffloadVer\t0x%x\n"
+                        "speed_mode\t0x%x\n"
+                        "duplex_mode\t0x%x\n"
+                        "autoneg_mode\t0x%x\n"
+                        "advertising_mode\t0x%x\n"
+                        "aspm\t0x%x\n"
+                        "s5wol\t0x%x\n"
+                        "s5_keep_curr_mac\t0x%x\n"
+                        "eee_enable\t0x%x\n"
+                        "hwoptimize\t0x%lx\n"
+                        "proc_init_num\t0x%x\n"
+                        "s0_magic_packet\t0x%x\n"
+                        "HwSuppMagicPktVer\t0x%x\n"
+                        "HwSuppCheckPhyDisableModeVer\t0x%x\n"
+                        "HwPkgDet\t0x%x\n"
+                        "HwSuppGigaForceMode\t0x%x\n"
+                        "random_mac\t0x%x\n"
+                        "org_mac_addr\t%pM\n"
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+                        "perm_addr\t%pM\n"
+#endif
+                        "dev_addr\t%pM\n",
+                        MODULENAME,
+                        RTL8168_VERSION,
+                        tp->chipset,
+                        rtl_chip_info[tp->chipset].name,
+                        dev->mtu,
+                        NUM_RX_DESC,
+                        tp->cur_rx,
+                        tp->dirty_rx,
+                        NUM_TX_DESC,
+                        tp->cur_tx,
+                        tp->dirty_tx,
+                        tp->rx_buf_sz,
+                        tp->esd_flag,
+                        tp->pci_cfg_is_read,
+                        tp->rtl8168_rx_config,
+                        tp->cp_cmd,
+                        tp->intr_mask,
+                        tp->timer_intr_mask,
+                        tp->wol_enabled,
+                        tp->wol_opts,
+                        tp->efuse_ver,
+                        tp->eeprom_type,
+                        tp->autoneg,
+                        tp->duplex,
+                        tp->speed,
+                        tp->advertising,
+                        tp->eeprom_len,
+                        tp->cur_page,
+                        tp->bios_setting,
+                        tp->features,
+                        tp->org_pci_offset_99,
+                        tp->org_pci_offset_180,
+                        tp->issue_offset_99_event,
+                        tp->org_pci_offset_80,
+                        tp->org_pci_offset_81,
+                        tp->use_timer_interrrupt,
+                        tp->HwIcVerUnknown,
+                        tp->NotWrRamCodeToMicroP,
+                        tp->NotWrMcuPatchCode,
+                        tp->HwHasWrRamCodeToMicroP,
+                        tp->sw_ram_code_ver,
+                        tp->hw_ram_code_ver,
+                        tp->rtk_enable_diag,
+                        tp->ShortPacketSwChecksum,
+                        tp->UseSwPaddingShortPkt,
+                        tp->RequireAdcBiasPatch,
+                        tp->AdcBiasPatchIoffset,
+                        tp->RequireAdjustUpsTxLinkPulseTiming,
+                        tp->SwrCnt1msIni,
+                        tp->HwSuppNowIsOobVer,
+                        tp->HwFiberModeVer,
+                        tp->HwFiberStat,
+                        tp->HwSwitchMdiToFiber,
+                        tp->NicCustLedValue,
+                        tp->RequiredSecLanDonglePatch,
+                        tp->HwSuppDashVer,
+                        tp->DASH,
+                        tp->dash_printer_enabled,
+                        tp->HwSuppKCPOffloadVer,
+                        speed_mode,
+                        duplex_mode,
+                        autoneg_mode,
+                        advertising_mode,
+                        aspm,
+                        s5wol,
+                        s5_keep_curr_mac,
+                        eee_enable,
+                        hwoptimize,
+                        proc_init_num,
+                        s0_magic_packet,
+                        tp->HwSuppMagicPktVer,
+                        tp->HwSuppCheckPhyDisableModeVer,
+                        tp->HwPkgDet,
+                        tp->HwSuppGigaForceMode,
+                        tp->random_mac,
+                        tp->org_mac_addr,
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+                        dev->perm_addr,
+#endif
+                        dev->dev_addr
+                       );
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_tally_counter(char *page, char **start,
+                                  off_t offset, int count,
+                                  int *eof, void *data)
+{
+        struct net_device *dev = data;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        struct rtl8168_counters *counters;
+        dma_addr_t paddr;
+        u32 cmd;
+        u32 WaitCnt;
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump Tally Counter\n");
+
+        //ASSERT_RTNL();
+
+        counters = tp->tally_vaddr;
+        paddr = tp->tally_paddr;
+        if (!counters) {
+                len += snprintf(page + len, count - len,
+                                "\nDump Tally Counter Fail\n");
+                goto out;
+        }
+
+        spin_lock_irqsave(&tp->lock, flags);
+        RTL_W32(CounterAddrHigh, (u64)paddr >> 32);
+        cmd = (u64)paddr & DMA_BIT_MASK(32);
+        RTL_W32(CounterAddrLow, cmd);
+        RTL_W32(CounterAddrLow, cmd | CounterDump);
+
+        WaitCnt = 0;
+        while (RTL_R32(CounterAddrLow) & CounterDump) {
+                udelay(10);
+
+                WaitCnt++;
+                if (WaitCnt > 20)
+                        break;
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len,
+                        "Statistics\tValue\n----------\t-----\n");
+
+        len += snprintf(page + len, count - len,
+                        "tx_packets\t%lld\n"
+                        "rx_packets\t%lld\n"
+                        "tx_errors\t%lld\n"
+                        "rx_missed\t%lld\n"
+                        "align_errors\t%lld\n"
+                        "tx_one_collision\t%lld\n"
+                        "tx_multi_collision\t%lld\n"
+                        "rx_unicast\t%lld\n"
+                        "rx_broadcast\t%lld\n"
+                        "rx_multicast\t%lld\n"
+                        "tx_aborted\t%lld\n"
+                        "tx_underun\t%lld\n",
+                        le64_to_cpu(counters->tx_packets),
+                        le64_to_cpu(counters->rx_packets),
+                        le64_to_cpu(counters->tx_errors),
+                        le64_to_cpu(counters->rx_missed),
+                        le64_to_cpu(counters->align_errors),
+                        le64_to_cpu(counters->tx_one_collision),
+                        le64_to_cpu(counters->tx_multi_collision),
+                        le64_to_cpu(counters->rx_unicast),
+                        le64_to_cpu(counters->rx_broadcast),
+                        le64_to_cpu(counters->rx_multicast),
+                        le64_to_cpu(counters->tx_aborted),
+                        le64_to_cpu(counters->tx_underun)
+                       );
+
+        len += snprintf(page + len, count - len, "\n");
+out:
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_registers(char *page, char **start,
+                              off_t offset, int count,
+                              int *eof, void *data)
+{
+        struct net_device *dev = data;
+        int i, n, max = R8168_MAC_REGS_SIZE;
+        u8 byte_rd;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump MAC Registers\n"
+                        "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                len += snprintf(page + len, count - len,
+                                "\n0x%02x:\t",
+                                n);
+
+                for (i = 0; i < 16 && n < max; i++, n++) {
+                        byte_rd = readb(ioaddr + n);
+                        len += snprintf(page + len, count - len,
+                                        "%02x ",
+                                        byte_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_pcie_phy(char *page, char **start,
+                             off_t offset, int count,
+                             int *eof, void *data)
+{
+        struct net_device *dev = data;
+        int i, n, max = R8168_EPHY_REGS_SIZE/2;
+        u16 word_rd;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump PCIE PHY\n"
+                        "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                len += snprintf(page + len, count - len,
+                                "\n0x%02x:\t",
+                                n);
+
+                for (i = 0; i < 8 && n < max; i++, n++) {
+                        word_rd = rtl8168_ephy_read(ioaddr, n);
+                        len += snprintf(page + len, count - len,
+                                        "%04x ",
+                                        word_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_eth_phy(char *page, char **start,
+                            off_t offset, int count,
+                            int *eof, void *data)
+{
+        struct net_device *dev = data;
+        int i, n, max = R8168_PHY_REGS_SIZE/2;
+        u16 word_rd;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump Ethernet PHY\n"
+                        "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        len += snprintf(page + len, count - len,
+                        "\n####################page 0##################\n");
+        mdio_write(tp, 0x1f, 0x0000);
+        for (n = 0; n < max;) {
+                len += snprintf(page + len, count - len,
+                                "\n0x%02x:\t",
+                                n);
+
+                for (i = 0; i < 8 && n < max; i++, n++) {
+                        word_rd = mdio_read(tp, n);
+                        len += snprintf(page + len, count - len,
+                                        "%04x ",
+                                        word_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_extended_registers(char *page, char **start,
+                                       off_t offset, int count,
+                                       int *eof, void *data)
+{
+        struct net_device *dev = data;
+        int i, n, max = R8168_ERI_REGS_SIZE;
+        u32 dword_rd;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+        int len = 0;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_1:
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+                /* RTL8168B does not support Extend GMAC */
+                len += snprintf(page + len, count - len,
+                                "\nNot Support Dump Extended Registers\n");
+
+                goto out;
+        }
+
+        len += snprintf(page + len, count - len,
+                        "\nDump Extended Registers\n"
+                        "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                len += snprintf(page + len, count - len,
+                                "\n0x%02x:\t",
+                                n);
+
+                for (i = 0; i < 4 && n < max; i++, n+=4) {
+                        dword_rd = rtl8168_eri_read(ioaddr, n, 4, ERIAR_ExGMAC);
+                        len += snprintf(page + len, count - len,
+                                        "%08x ",
+                                        dword_rd);
+                }
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+out:
+        *eof = 1;
+        return len;
+}
+
+static int proc_get_pci_registers(char *page, char **start,
+                                  off_t offset, int count,
+                                  int *eof, void *data)
+{
+        struct net_device *dev = data;
+        int i, n, max = R8168_PCI_REGS_SIZE;
+        u32 dword_rd;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+        int len = 0;
+
+        len += snprintf(page + len, count - len,
+                        "\nDump PCI Registers\n"
+                        "Offset\tValue\n------\t-----\n");
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (n = 0; n < max;) {
+                len += snprintf(page + len, count - len,
+                                "\n0x%03x:\t",
+                                n);
+
+                for (i = 0; i < 4 && n < max; i++, n+=4) {
+                        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+                        len += snprintf(page + len, count - len,
+                                        "%08x ",
+                                        dword_rd);
+                }
+        }
+
+        n = 0x110;
+        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+        len += snprintf(page + len, count - len,
+                        "\n0x%03x:\t%08x ",
+                        n,
+                        dword_rd);
+        n = 0x70c;
+        pci_read_config_dword(tp->pci_dev, n, &dword_rd);
+        len += snprintf(page + len, count - len,
+                        "\n0x%03x:\t%08x ",
+                        n,
+                        dword_rd);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        len += snprintf(page + len, count - len, "\n");
+
+        *eof = 1;
+        return len;
+}
+#endif
+static void rtl8168_proc_module_init(void)
+{
+        //create /proc/net/r8168
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,32)
+        rtl8168_proc = proc_mkdir(MODULENAME, init_net.proc_net);
+#else
+        rtl8168_proc = proc_mkdir(MODULENAME, proc_net);
+#endif
+        if (!rtl8168_proc)
+                dprintk("cannot create %s proc entry \n", MODULENAME);
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+/*
+ * seq_file wrappers for procfile show routines.
+ */
+static int rtl8168_proc_open(struct inode *inode, struct file *file)
+{
+        struct net_device *dev = proc_get_parent_data(inode);
+        int (*show)(struct seq_file *, void *) = PDE_DATA(inode);
+
+        return single_open(file, show, dev);
+}
+
+static const struct file_operations rtl8168_proc_fops = {
+        .open           = rtl8168_proc_open,
+        .read           = seq_read,
+        .llseek         = seq_lseek,
+        .release        = single_release,
+};
+#endif
+
+/*
+ * Table of proc files we need to create.
+ */
+struct rtl8168_proc_file {
+        char name[12];
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+        int (*show)(struct seq_file *, void *);
+#else
+        int (*show)(char *, char **, off_t, int, int *, void *);
+#endif
+};
+
+static ssize_t read_proc(struct file *filp,char *buf,size_t count,loff_t *offp )
+{
+
+	ssize_t len = 0;
+
+	if(*offp > 0){
+		//printk(KERN_INFO "procfs_read: END\n");
+		return 0;
+	}
+
+	printk(KERN_INFO "read procfs ethernet(r8168) wol_enable = %x \n",wol_enable);
+
+	len = sprintf(buf,"%d\n", wol_enable);
+
+	*offp++;
+	return len;
+}
+
+static ssize_t write_proc(struct file *file, const char __user *buffer, size_t count, loff_t *pos)
+{
+	char tmp[32];
+	u32 val,num;
+
+	if (buffer && !copy_from_user(tmp, buffer, sizeof(tmp))) {
+		num = sscanf(tmp, "%x", &val);
+		wol_enable=val;
+		printk(KERN_INFO "write procfs ethernet(r8168) wol_enable = %x \n",wol_enable);
+	}
+	return count;
+}
+
+static const struct file_operations proc_fops = {
+	.read= read_proc,
+	.write= write_proc,
+};
+
+
+static const struct rtl8168_proc_file rtl8168_proc_files[] = {
+        { "driver_var", &proc_get_driver_variable },
+        { "tally", &proc_get_tally_counter },
+        { "registers", &proc_get_registers },
+        { "pcie_phy", &proc_get_pcie_phy },
+        { "eth_phy", &proc_get_eth_phy },
+        { "ext_regs", &proc_get_extended_registers },
+        { "pci_regs", &proc_get_pci_registers },
+        { "" }
+};
+
+static void rtl8168_proc_init(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        const struct rtl8168_proc_file *f;
+        struct proc_dir_entry *dir;
+
+        if (rtl8168_proc && !tp->proc_dir) {
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+                dir = proc_mkdir_data(dev->name, 0, rtl8168_proc, dev);
+                if (!dir) {
+                        printk("Unable to initialize /proc/net/%s/%s\n",
+                               MODULENAME, dev->name);
+                        return;
+                }
+
+                tp->proc_dir = dir;
+                proc_init_num++;
+
+                for (f = rtl8168_proc_files; f->name[0]; f++) {
+                        if (!proc_create_data(f->name, S_IFREG | S_IRUGO, dir,
+                                              &rtl8168_proc_fops, f->show)) {
+                                printk("Unable to initialize "
+                                       "/proc/net/%s/%s/%s\n",
+                                       MODULENAME, dev->name, f->name);
+                                return;
+                        }
+                }
+
+		if (!proc_create_data("wol_enable", S_IFREG | S_IRUGO, dir, &proc_fops, NULL)) {
+			printk("Unable to initialize /proc/net/%s/%s/wol_enable\n",MODULENAME, dev->name);
+			return;
+		}
+#else
+                dir = proc_mkdir(dev->name, rtl8168_proc);
+                if (!dir) {
+                        printk("Unable to initialize /proc/net/%s/%s\n",
+                               MODULENAME, dev->name);
+                        return;
+                }
+
+                tp->proc_dir = dir;
+                proc_init_num++;
+
+                for (f = rtl8168_proc_files; f->name[0]; f++) {
+                        if (!create_proc_read_entry(f->name, S_IFREG | S_IRUGO,
+                                                    dir, f->show, dev)) {
+                                printk("Unable to initialize "
+                                       "/proc/net/%s/%s/%s\n",
+                                       MODULENAME, dev->name, f->name);
+                                return;
+                        }
+                }
+#endif
+        }
+}
+
+static void rtl8168_proc_remove(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        if (tp->proc_dir) {
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+                remove_proc_subtree(dev->name, rtl8168_proc);
+                proc_init_num--;
+
+#else
+                const struct rtl8168_proc_file *f;
+                struct rtl8168_private *tp = netdev_priv(dev);
+
+                for (f = rtl8168_proc_files; f->name[0]; f++)
+                        remove_proc_entry(f->name, tp->proc_dir);
+
+                remove_proc_entry(dev->name, rtl8168_proc);
+                proc_init_num--;
+#endif
+                tp->proc_dir = NULL;
+        }
+}
+
+#endif //ENABLE_R8168_PROCFS
+
+static inline u16 map_phy_ocp_addr(u16 PageNum, u8 RegNum)
+{
+        u16 OcpPageNum = 0;
+        u8 OcpRegNum = 0;
+        u16 OcpPhyAddress = 0;
+
+        if ( PageNum == 0 ) {
+                OcpPageNum = OCP_STD_PHY_BASE_PAGE + ( RegNum / 8 );
+                OcpRegNum = 0x10 + ( RegNum % 8 );
+        } else {
+                OcpPageNum = PageNum;
+                OcpRegNum = RegNum;
+        }
+
+        OcpPageNum <<= 4;
+
+        if ( OcpRegNum < 16 ) {
+                OcpPhyAddress = 0;
+        } else {
+                OcpRegNum -= 16;
+                OcpRegNum <<= 1;
+
+                OcpPhyAddress = OcpPageNum + OcpRegNum;
+        }
+
+
+        return OcpPhyAddress;
+}
+
+static void mdio_write_phy_ocp(struct rtl8168_private *tp,
+                               u16 PageNum,
+                               u32 RegAddr,
+                               u32 value)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 data32;
+        u16 ocp_addr;
+        int i;
+
+        ocp_addr = map_phy_ocp_addr(PageNum, RegAddr);
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)
+        WARN_ON_ONCE(ocp_addr % 2);
+#endif
+        data32 = ocp_addr/2;
+        data32 <<= OCPR_Addr_Reg_shift;
+        data32 |= OCPR_Write | value;
+
+        RTL_W32(PHYOCP, data32);
+        for (i = 0; i < 100; i++) {
+                udelay(1);
+
+                if (!(RTL_R32(PHYOCP) & OCPR_Flag))
+                        break;
+        }
+}
+
+static void mdio_real_write(struct rtl8168_private *tp,
+                            u32 RegAddr,
+                            u32 value)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        int i;
+
+        if (RegAddr == 0x1F) {
+                tp->cur_page = value;
+        }
+
+        if (tp->mcfg == CFG_METHOD_11) {
+                RTL_W32(OCPDR, OCPDR_Write |
+                        (RegAddr & OCPDR_Reg_Mask) << OCPDR_GPHY_Reg_shift |
+                        (value & OCPDR_Data_Mask));
+                RTL_W32(OCPAR, OCPAR_GPHY_Write);
+                RTL_W32(EPHY_RXER_NUM, 0);
+
+                for (i = 0; i < 100; i++) {
+                        mdelay(1);
+                        if (!(RTL_R32(OCPAR) & OCPAR_Flag))
+                                break;
+                }
+        } else if (tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+                   tp->mcfg == CFG_METHOD_23 || tp->mcfg == CFG_METHOD_24 ||
+                   tp->mcfg == CFG_METHOD_25 || tp->mcfg == CFG_METHOD_26 ||
+                   tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28 ||
+                   tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30 ||
+                   tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                if (RegAddr == 0x1F) {
+                        return;
+                }
+                mdio_write_phy_ocp(tp, tp->cur_page, RegAddr, value);
+        } else {
+                if (tp->mcfg == CFG_METHOD_12 || tp->mcfg == CFG_METHOD_13)
+                        RTL_W32(0xD0, RTL_R32(0xD0) & ~0x00020000);
+
+                RTL_W32(PHYAR, PHYAR_Write |
+                        (RegAddr & PHYAR_Reg_Mask) << PHYAR_Reg_shift |
+                        (value & PHYAR_Data_Mask));
+
+                for (i = 0; i < 10; i++) {
+                        udelay(100);
+
+                        /* Check if the RTL8168 has completed writing to the specified MII register */
+                        if (!(RTL_R32(PHYAR) & PHYAR_Flag)) {
+                                udelay(20);
+                                break;
+                        }
+                }
+
+                if (tp->mcfg == CFG_METHOD_12 || tp->mcfg == CFG_METHOD_13)
+                        RTL_W32(0xD0, RTL_R32(0xD0) | 0x00020000);
+        }
+}
+
+void mdio_write(struct rtl8168_private *tp,
+                u32 RegAddr,
+                u32 value)
+{
+        if (tp->rtk_enable_diag) return;
+
+        mdio_real_write(tp, RegAddr, value);
+}
+
+void mdio_prot_write(struct rtl8168_private *tp,
+                     u32 RegAddr,
+                     u32 value)
+{
+        mdio_real_write(tp, RegAddr, value);
+}
+
+static u32 mdio_read_phy_ocp(struct rtl8168_private *tp,
+                             u16 PageNum,
+                             u32 RegAddr)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 data32;
+        u16 ocp_addr;
+        int i, value = 0;
+
+        ocp_addr = map_phy_ocp_addr(PageNum, RegAddr);
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)
+        WARN_ON_ONCE(ocp_addr % 2);
+#endif
+        data32 = ocp_addr/2;
+        data32 <<= OCPR_Addr_Reg_shift;
+
+        RTL_W32(PHYOCP, data32);
+        for (i = 0; i < 100; i++) {
+                udelay(1);
+
+                if (RTL_R32(PHYOCP) & OCPR_Flag)
+                        break;
+        }
+        value = RTL_R32(PHYOCP) & OCPDR_Data_Mask;
+
+        return value;
+}
+
+u32 mdio_read(struct rtl8168_private *tp,
+              u32 RegAddr)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        int i, value = 0;
+
+        if (tp->mcfg==CFG_METHOD_11) {
+                RTL_W32(OCPDR, OCPDR_Read |
+                        (RegAddr & OCPDR_Reg_Mask) << OCPDR_GPHY_Reg_shift);
+                RTL_W32(OCPAR, OCPAR_GPHY_Write);
+                RTL_W32(EPHY_RXER_NUM, 0);
+
+                for (i = 0; i < 100; i++) {
+                        mdelay(1);
+                        if (!(RTL_R32(OCPAR) & OCPAR_Flag))
+                                break;
+                }
+
+                mdelay(1);
+                RTL_W32(OCPAR, OCPAR_GPHY_Read);
+                RTL_W32(EPHY_RXER_NUM, 0);
+
+                for (i = 0; i < 100; i++) {
+                        mdelay(1);
+                        if (RTL_R32(OCPAR) & OCPAR_Flag)
+                                break;
+                }
+
+                value = RTL_R32(OCPDR) & OCPDR_Data_Mask;
+        } else if (tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+                   tp->mcfg == CFG_METHOD_23 || tp->mcfg == CFG_METHOD_24 ||
+                   tp->mcfg == CFG_METHOD_25 || tp->mcfg == CFG_METHOD_26 ||
+                   tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28 ||
+                   tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30 ||
+                   tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                value = mdio_read_phy_ocp(tp, tp->cur_page, RegAddr);
+        } else {
+                if (tp->mcfg == CFG_METHOD_12 || tp->mcfg == CFG_METHOD_13)
+                        RTL_W32(0xD0, RTL_R32(0xD0) & ~0x00020000);
+
+                RTL_W32(PHYAR,
+                        PHYAR_Read | (RegAddr & PHYAR_Reg_Mask) << PHYAR_Reg_shift);
+
+                for (i = 0; i < 10; i++) {
+                        udelay(100);
+
+                        /* Check if the RTL8168 has completed retrieving data from the specified MII register */
+                        if (RTL_R32(PHYAR) & PHYAR_Flag) {
+                                value = RTL_R32(PHYAR) & PHYAR_Data_Mask;
+                                udelay(20);
+                                break;
+                        }
+                }
+
+                if (tp->mcfg == CFG_METHOD_12 || tp->mcfg == CFG_METHOD_13)
+                        RTL_W32(0xD0, RTL_R32(0xD0) | 0x00020000);
+        }
+
+        return value;
+}
+
+static void ClearAndSetEthPhyBit(struct rtl8168_private *tp, u8  addr, u16 clearmask, u16 setmask)
+{
+        u16 PhyRegValue;
+
+
+        PhyRegValue = mdio_read( tp, addr );
+        PhyRegValue &= ~clearmask;
+        PhyRegValue |= setmask;
+        mdio_write( tp, addr, PhyRegValue);
+}
+
+void ClearEthPhyBit(struct rtl8168_private *tp, u8 addr, u16 mask)
+{
+        ClearAndSetEthPhyBit( tp,
+                              addr,
+                              mask,
+                              0
+                            );
+}
+
+void SetEthPhyBit(struct rtl8168_private *tp,  u8  addr, u16  mask)
+{
+        ClearAndSetEthPhyBit( tp,
+                              addr,
+                              0,
+                              mask
+                            );
+}
+
+void mac_ocp_write(struct rtl8168_private *tp, u16 reg_addr, u16 value)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 data32;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)
+        WARN_ON_ONCE(reg_addr % 2);
+#endif
+
+        data32 = reg_addr/2;
+        data32 <<= OCPR_Addr_Reg_shift;
+        data32 += value;
+        data32 |= OCPR_Write;
+
+        RTL_W32(MACOCP, data32);
+}
+
+u16 mac_ocp_read(struct rtl8168_private *tp, u16 reg_addr)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 data32;
+        u16 data16 = 0;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)
+        WARN_ON_ONCE(reg_addr % 2);
+#endif
+
+        data32 = reg_addr/2;
+        data32 <<= OCPR_Addr_Reg_shift;
+
+        RTL_W32(MACOCP, data32);
+        data16 = (u16)RTL_R32(MACOCP);
+
+        return data16;
+}
+
+static u32 real_ocp_read(struct rtl8168_private *tp, u16 addr, u8 len)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        int i, val_shift, shift = 0;
+        u32 value1 = 0, value2 = 0, mask;
+
+        if (len > 4 || len <= 0)
+                return -1;
+
+        while (len > 0) {
+                val_shift = addr % 4;
+                addr = addr & ~0x3;
+
+                RTL_W32(OCPAR, (0x0F<<12) | (addr&0xFFF));
+
+                for (i = 0; i < 20; i++) {
+                        udelay(100);
+                        if (RTL_R32(OCPAR) & OCPAR_Flag)
+                                break;
+                }
+
+                if (len == 1)       mask = (0xFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 2)  mask = (0xFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 3)  mask = (0xFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else            mask = (0xFFFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+
+                value1 = RTL_R32(OCPDR) & mask;
+                value2 |= (value1 >> val_shift * 8) << shift * 8;
+
+                if (len <= 4 - val_shift) {
+                        len = 0;
+                } else {
+                        len -= (4 - val_shift);
+                        shift = 4 - val_shift;
+                        addr += 4;
+                }
+        }
+
+        udelay(20);
+
+        return value2;
+}
+
+u32 OCP_read_with_oob_base_address(struct rtl8168_private *tp, u16 addr, u8 len, const u32 base_address)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        return rtl8168_eri_read_with_oob_base_address(ioaddr, addr, len, ERIAR_OOB, base_address);
+}
+
+u32 OCP_read(struct rtl8168_private *tp, u16 addr, u8 len)
+{
+        u32 value = 0;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp))
+                value = OCP_read_with_oob_base_address(tp, addr, len, NO_BASE_ADDRESS);
+        else if (HW_DASH_SUPPORT_TYPE_3(tp))
+                value = OCP_read_with_oob_base_address(tp, addr, len, RTL8168FP_OOBMAC_BASE);
+        else
+                value = real_ocp_read(tp, addr, len);
+
+        return value;
+}
+
+static int real_ocp_write(struct rtl8168_private *tp, u16 addr, u8 len, u32 value)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        int i, val_shift, shift = 0;
+        u32 value1 = 0, mask;
+
+        if (len > 4 || len <= 0)
+                return -1;
+
+        while (len > 0) {
+                val_shift = addr % 4;
+                addr = addr & ~0x3;
+
+                if (len == 1)       mask = (0xFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 2)  mask = (0xFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 3)  mask = (0xFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else            mask = (0xFFFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+
+                value1 = OCP_read(tp, addr, 4) & ~mask;
+                value1 |= ((value << val_shift * 8) >> shift * 8);
+
+                RTL_W32(OCPDR, value1);
+                RTL_W32(OCPAR, OCPAR_Flag | (0x0F<<12) | (addr&0xFFF));
+
+                for (i = 0; i < 10; i++) {
+                        udelay(100);
+
+                        /* Check if the RTL8168 has completed ERI write */
+                        if (!(RTL_R32(OCPAR) & OCPAR_Flag))
+                                break;
+                }
+
+                if (len <= 4 - val_shift) {
+                        len = 0;
+                } else {
+                        len -= (4 - val_shift);
+                        shift = 4 - val_shift;
+                        addr += 4;
+                }
+        }
+
+        udelay(20);
+
+        return 0;
+}
+
+u32 OCP_write_with_oob_base_address(struct rtl8168_private *tp, u16 addr, u8 len, u32 value, const u32 base_address)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        return rtl8168_eri_write_with_oob_base_address(ioaddr, addr, len, value, ERIAR_OOB, base_address);
+}
+
+void OCP_write(struct rtl8168_private *tp, u16 addr, u8 len, u32 value)
+{
+        if (HW_DASH_SUPPORT_TYPE_2(tp))
+                OCP_write_with_oob_base_address(tp, addr, len, value, NO_BASE_ADDRESS);
+        else if (HW_DASH_SUPPORT_TYPE_3(tp))
+                OCP_write_with_oob_base_address(tp, addr, len, value, RTL8168FP_OOBMAC_BASE);
+        else
+                real_ocp_write(tp, addr, len, value);
+}
+
+void OOB_mutex_lock(struct rtl8168_private *tp)
+{
+        u8 reg_16, reg_a0;
+        u32 wait_cnt_0, wait_Cnt_1;
+        u16 ocp_reg_mutex_ib;
+        u16 ocp_reg_mutex_oob;
+        u16 ocp_reg_mutex_prio;
+
+        if (!tp->DASH) return;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+                ocp_reg_mutex_oob = 0x16;
+                ocp_reg_mutex_ib = 0x17;
+                ocp_reg_mutex_prio = 0x9C;
+                break;
+        case CFG_METHOD_13:
+                ocp_reg_mutex_oob = 0x06;
+                ocp_reg_mutex_ib = 0x07;
+                ocp_reg_mutex_prio = 0x9C;
+                break;
+        case CFG_METHOD_23:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+        default:
+                ocp_reg_mutex_oob = 0x110;
+                ocp_reg_mutex_ib = 0x114;
+                ocp_reg_mutex_prio = 0x11C;
+                break;
+        }
+
+        OCP_write(tp, ocp_reg_mutex_ib, 1, BIT_0);
+        reg_16 = OCP_read(tp, ocp_reg_mutex_oob, 1);
+        wait_cnt_0 = 0;
+        while(reg_16) {
+                reg_a0 = OCP_read(tp, ocp_reg_mutex_prio, 1);
+                if (reg_a0) {
+                        OCP_write(tp, ocp_reg_mutex_ib, 1, 0x00);
+                        reg_a0 = OCP_read(tp, ocp_reg_mutex_prio, 1);
+                        wait_Cnt_1 = 0;
+                        while(reg_a0) {
+                                reg_a0 = OCP_read(tp, ocp_reg_mutex_prio, 1);
+
+                                wait_Cnt_1++;
+
+                                if (wait_Cnt_1 > 2000)
+                                        break;
+                        };
+                        OCP_write(tp, ocp_reg_mutex_ib, 1, BIT_0);
+
+                }
+                reg_16 = OCP_read(tp, ocp_reg_mutex_oob, 1);
+
+                wait_cnt_0++;
+
+                if (wait_cnt_0 > 2000)
+                        break;
+        };
+}
+
+void OOB_mutex_unlock(struct rtl8168_private *tp)
+{
+        u16 ocp_reg_mutex_ib;
+        u16 ocp_reg_mutex_oob;
+        u16 ocp_reg_mutex_prio;
+
+        if (!tp->DASH) return;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+                ocp_reg_mutex_oob = 0x16;
+                ocp_reg_mutex_ib = 0x17;
+                ocp_reg_mutex_prio = 0x9C;
+                break;
+        case CFG_METHOD_13:
+                ocp_reg_mutex_oob = 0x06;
+                ocp_reg_mutex_ib = 0x07;
+                ocp_reg_mutex_prio = 0x9C;
+                break;
+        case CFG_METHOD_23:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+        default:
+                ocp_reg_mutex_oob = 0x110;
+                ocp_reg_mutex_ib = 0x114;
+                ocp_reg_mutex_prio = 0x11C;
+                break;
+        }
+
+        OCP_write(tp, ocp_reg_mutex_prio, 1, BIT_0);
+        OCP_write(tp, ocp_reg_mutex_ib, 1, 0x00);
+}
+
+void OOB_notify(struct rtl8168_private *tp, u8 cmd)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        rtl8168_eri_write(ioaddr, 0xE8, 1, cmd, ERIAR_ExGMAC);
+
+        OCP_write(tp, 0x30, 1, 0x01);
+}
+
+static int rtl8168_check_dash(struct rtl8168_private *tp)
+{
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                if (OCP_read(tp, 0x128, 1) & BIT_0)
+                        return 1;
+                else
+                        return 0;
+        } else {
+                u32 reg;
+
+                if (tp->mcfg == CFG_METHOD_13)
+                        reg = 0xb8;
+                else
+                        reg = 0x10;
+
+                if (OCP_read(tp, reg, 2) & 0x00008000)
+                        return 1;
+                else
+                        return 0;
+        }
+}
+
+void Dash2DisableTx(struct rtl8168_private *tp)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                u16 WaitCnt;
+                u8 TmpUchar;
+
+                //Disable oob Tx
+                RTL_CMAC_W8(CMAC_IBCR2, RTL_CMAC_R8(CMAC_IBCR2) & ~( BIT_0 ));
+                WaitCnt = 0;
+
+                //wait oob tx disable
+                do {
+                        TmpUchar = RTL_CMAC_R8(CMAC_IBISR0);
+
+                        if ( TmpUchar & ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE ) {
+                                break;
+                        }
+
+                        udelay( 50 );
+                        WaitCnt++;
+                } while(WaitCnt < 2000);
+
+                //Clear ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE
+                RTL_CMAC_W8(CMAC_IBISR0, RTL_CMAC_R8(CMAC_IBISR0) | ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE);
+        }
+}
+
+void Dash2EnableTx(struct rtl8168_private *tp)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                RTL_CMAC_W8(CMAC_IBCR2, RTL_CMAC_R8(CMAC_IBCR2) | BIT_0);
+        }
+}
+
+void Dash2DisableRx(struct rtl8168_private *tp)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                RTL_CMAC_W8(CMAC_IBCR0, RTL_CMAC_R8(CMAC_IBCR0) & ~( BIT_0 ));
+        }
+}
+
+void Dash2EnableRx(struct rtl8168_private *tp)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                RTL_CMAC_W8(CMAC_IBCR0, RTL_CMAC_R8(CMAC_IBCR0) | BIT_0);
+        }
+}
+
+static void Dash2DisableTxRx(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                Dash2DisableTx( tp );
+                Dash2DisableRx( tp );
+        }
+}
+
+static void rtl8168_driver_start(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        if (!tp->DASH)
+                return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                int timeout;
+                u32 tmp_value;
+
+                OCP_write(tp, 0x180, 1, OOB_CMD_DRIVER_START);
+                tmp_value = OCP_read(tp, 0x30, 1);
+                tmp_value |= BIT_0;
+                OCP_write(tp, 0x30, 1, tmp_value);
+
+                for (timeout = 0; timeout < 10; timeout++) {
+                        mdelay(10);
+                        if (OCP_read(tp, 0x124, 1) & BIT_0)
+                                break;
+                }
+        } else {
+                int timeout;
+                u32 reg;
+
+                if (tp->mcfg == CFG_METHOD_13) {
+                        RTL_W8(TwiCmdReg, RTL_R8(TwiCmdReg) | ( BIT_7 ));
+                }
+
+                OOB_notify(tp, OOB_CMD_DRIVER_START);
+
+                if (tp->mcfg == CFG_METHOD_13)
+                        reg = 0xB8;
+                else
+                        reg = 0x10;
+
+                for (timeout = 0; timeout < 10; timeout++) {
+                        mdelay(10);
+                        if (OCP_read(tp, reg, 2) & BIT_11)
+                                break;
+                }
+        }
+}
+
+static void rtl8168_driver_stop(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        if (!tp->DASH)
+                return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                struct net_device *dev = tp->dev;
+                int timeout;
+                u32 tmp_value;
+
+                Dash2DisableTxRx(dev);
+
+                OCP_write(tp, 0x180, 1, OOB_CMD_DRIVER_STOP);
+                tmp_value = OCP_read(tp, 0x30, 1);
+                tmp_value |= BIT_0;
+                OCP_write(tp, 0x30, 1, tmp_value);
+
+                for (timeout = 0; timeout < 10; timeout++) {
+                        mdelay(10);
+                        if (!(OCP_read(tp, 0x124, 1) & BIT_0))
+                                break;
+                }
+        } else {
+                int timeout;
+                u32 reg;
+
+                OOB_notify(tp, OOB_CMD_DRIVER_STOP);
+
+                if (tp->mcfg == CFG_METHOD_13)
+                        reg = 0xB8;
+                else
+                        reg = 0x10;
+
+                for (timeout = 0; timeout < 10; timeout++) {
+                        mdelay(10);
+                        if ((OCP_read(tp, reg, 2) & BIT_11) == 0)
+                                break;
+                }
+
+                if (tp->mcfg == CFG_METHOD_13) {
+                        RTL_W8(TwiCmdReg, RTL_R8(TwiCmdReg) & ~( BIT_7 ));
+                }
+        }
+}
+
+void rtl8168_ephy_write(void __iomem *ioaddr, int RegAddr, int value)
+{
+        int i;
+
+        RTL_W32(EPHYAR,
+                EPHYAR_Write |
+                (RegAddr & EPHYAR_Reg_Mask) << EPHYAR_Reg_shift |
+                (value & EPHYAR_Data_Mask));
+
+        for (i = 0; i < 10; i++) {
+                udelay(100);
+
+                /* Check if the RTL8168 has completed EPHY write */
+                if (!(RTL_R32(EPHYAR) & EPHYAR_Flag))
+                        break;
+        }
+
+        udelay(20);
+}
+
+u16 rtl8168_ephy_read(void __iomem *ioaddr, int RegAddr)
+{
+        int i;
+        u16 value = 0xffff;
+
+        RTL_W32(EPHYAR,
+                EPHYAR_Read | (RegAddr & EPHYAR_Reg_Mask) << EPHYAR_Reg_shift);
+
+        for (i = 0; i < 10; i++) {
+                udelay(100);
+
+                /* Check if the RTL8168 has completed EPHY read */
+                if (RTL_R32(EPHYAR) & EPHYAR_Flag) {
+                        value = (u16) (RTL_R32(EPHYAR) & EPHYAR_Data_Mask);
+                        break;
+                }
+        }
+
+        udelay(20);
+
+        return value;
+}
+
+static void ClearAndSetPCIePhyBit(struct rtl8168_private *tp, u8 addr, u16 clearmask, u16 setmask)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u16 EphyValue;
+
+        EphyValue = rtl8168_ephy_read( ioaddr, addr );
+        EphyValue &= ~clearmask;
+        EphyValue |= setmask;
+        rtl8168_ephy_write( ioaddr, addr, EphyValue);
+}
+
+static void ClearPCIePhyBit(struct rtl8168_private *tp, u8 addr, u16 mask)
+{
+        ClearAndSetPCIePhyBit( tp,
+                               addr,
+                               mask,
+                               0
+                             );
+}
+
+static void SetPCIePhyBit( struct rtl8168_private *tp, u8 addr, u16 mask)
+{
+        ClearAndSetPCIePhyBit( tp,
+                               addr,
+                               0,
+                               mask
+                             );
+}
+
+static u32
+rtl8168_csi_other_fun_read(struct rtl8168_private *tp,
+                           u8 multi_fun_sel_bit,
+                           u32 addr)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 cmd;
+        int i;
+        u32 value = 0;
+
+        cmd = CSIAR_Read | CSIAR_ByteEn << CSIAR_ByteEn_shift | (addr & CSIAR_Addr_Mask);
+
+        if (tp->mcfg != CFG_METHOD_20 && tp->mcfg != CFG_METHOD_23 &&
+            tp->mcfg != CFG_METHOD_26 && tp->mcfg != CFG_METHOD_27 &&
+            tp->mcfg != CFG_METHOD_28 && tp->mcfg != CFG_METHOD_31 &&
+            tp->mcfg != CFG_METHOD_32) {
+                multi_fun_sel_bit = 0;
+        }
+
+        if ( multi_fun_sel_bit > 7 ) {
+                return 0xffffffff;
+        }
+
+        cmd |= multi_fun_sel_bit << 16;
+
+        RTL_W32(CSIAR, cmd);
+
+        for (i = 0; i < 10; i++) {
+                udelay(100);
+
+                /* Check if the RTL8168 has completed CSI read */
+                if (RTL_R32(CSIAR) & CSIAR_Flag) {
+                        value = (u32)RTL_R32(CSIDR);
+                        break;
+                }
+        }
+
+        udelay(20);
+
+        return value;
+}
+
+static void
+rtl8168_csi_other_fun_write(struct rtl8168_private *tp,
+                            u8 multi_fun_sel_bit,
+                            u32 addr,
+                            u32 value)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 cmd;
+        int i;
+
+        RTL_W32(CSIDR, value);
+        cmd = CSIAR_Write | CSIAR_ByteEn << CSIAR_ByteEn_shift | (addr & CSIAR_Addr_Mask);
+        if (tp->mcfg != CFG_METHOD_20 && tp->mcfg != CFG_METHOD_23 &&
+            tp->mcfg != CFG_METHOD_26 && tp->mcfg != CFG_METHOD_27 &&
+            tp->mcfg != CFG_METHOD_28 && tp->mcfg != CFG_METHOD_31 &&
+            tp->mcfg != CFG_METHOD_32) {
+                multi_fun_sel_bit = 0;
+        }
+
+        if ( multi_fun_sel_bit > 7 ) {
+                return;
+        }
+
+        cmd |= multi_fun_sel_bit << 16;
+
+        RTL_W32(CSIAR, cmd);
+
+        for (i = 0; i < 10; i++) {
+                udelay(100);
+
+                /* Check if the RTL8168 has completed CSI write */
+                if (!(RTL_R32(CSIAR) & CSIAR_Flag))
+                        break;
+        }
+
+        udelay(20);
+}
+
+static u32
+rtl8168_csi_read(struct rtl8168_private *tp,
+                 u32 addr)
+{
+        u8 multi_fun_sel_bit;
+
+        if (tp->mcfg == CFG_METHOD_20)
+                multi_fun_sel_bit = 2;
+        else if (tp->mcfg == CFG_METHOD_26 || tp->mcfg == CFG_METHOD_31 ||
+                 tp->mcfg == CFG_METHOD_32)
+                multi_fun_sel_bit = 1;
+        else
+                multi_fun_sel_bit = 0;
+
+        return rtl8168_csi_other_fun_read(tp, multi_fun_sel_bit, addr);
+}
+
+static void
+rtl8168_csi_write(struct rtl8168_private *tp,
+                  u32 addr,
+                  u32 value)
+{
+        u8 multi_fun_sel_bit;
+
+        if (tp->mcfg == CFG_METHOD_20)
+                multi_fun_sel_bit = 2;
+        else if (tp->mcfg == CFG_METHOD_26 || tp->mcfg == CFG_METHOD_31 ||
+                 tp->mcfg == CFG_METHOD_32)
+                multi_fun_sel_bit = 1;
+        else
+                multi_fun_sel_bit = 0;
+
+        rtl8168_csi_other_fun_write(tp, multi_fun_sel_bit, addr, value);
+}
+
+static u8
+rtl8168_csi_fun0_read_byte(struct rtl8168_private *tp,
+                           u32 addr)
+{
+        u8 RetVal = 0;
+
+        if (tp->mcfg == CFG_METHOD_20 || tp->mcfg == CFG_METHOD_26 ||
+            tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                u32 TmpUlong;
+                u16 RegAlignAddr;
+                u8 ShiftByte;
+
+                RegAlignAddr = addr & ~(0x3);
+                ShiftByte = addr & (0x3);
+                TmpUlong = rtl8168_csi_other_fun_read(tp, 0, addr);
+                TmpUlong >>= (8*ShiftByte);
+                RetVal = (u8)TmpUlong;
+        } else {
+                struct pci_dev *pdev = tp->pci_dev;
+
+                pci_read_config_byte(pdev, addr, &RetVal);
+        }
+
+        udelay(20);
+
+        return RetVal;
+}
+
+static void
+rtl8168_csi_fun0_write_byte(struct rtl8168_private *tp,
+                            u32 addr,
+                            u8 value)
+{
+        if (tp->mcfg == CFG_METHOD_20 || tp->mcfg == CFG_METHOD_26 ||
+            tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                u32 TmpUlong;
+                u16 RegAlignAddr;
+                u8 ShiftByte;
+
+                RegAlignAddr = addr & ~(0x3);
+                ShiftByte = addr & (0x3);
+                TmpUlong = rtl8168_csi_other_fun_read(tp, 0, RegAlignAddr);
+                TmpUlong &= ~(0xFF << (8*ShiftByte));
+                TmpUlong |= (value << (8*ShiftByte));
+                rtl8168_csi_other_fun_write( tp, 0, RegAlignAddr, TmpUlong );
+        } else {
+                struct pci_dev *pdev = tp->pci_dev;
+
+                pci_write_config_byte(pdev, addr, value);
+        }
+
+        udelay(20);
+}
+
+static void
+rtl8168_clear_and_aet_other_fun_pci_bit(struct rtl8168_private *tp,
+                                        u8 multi_fun_sel_bit,
+                                        u32 addr,
+                                        u32 clearmask,
+                                        u32 setmask)
+{
+        u32 TmpUlong;
+
+        TmpUlong = rtl8168_csi_other_fun_read(tp, multi_fun_sel_bit, addr);
+        TmpUlong &= ~clearmask;
+        TmpUlong |= setmask;
+        rtl8168_csi_other_fun_write(tp, multi_fun_sel_bit, addr, TmpUlong);
+}
+
+static void
+rtl8168_other_fun_dev_pci_setting(struct rtl8168_private *tp,
+                                  u32 addr,
+                                  u32 clearmask,
+                                  u32 setmask,
+                                  u8 multi_fun_sel_bit)
+{
+        u32 TmpUlong;
+        u8 i;
+        u8 FunBit;
+
+        switch(tp->mcfg) {
+        case CFG_METHOD_23:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                FunBit = 1;
+                //0: UMAC, 1: TCR1, 2: TCR2, 3: KCS, 4: EHCI(Control by EHCI Driver)
+                for (i = 0; i < 8; i++) {
+                        if (FunBit & multi_fun_sel_bit)
+                                rtl8168_clear_and_aet_other_fun_pci_bit(tp, i, addr, clearmask, setmask);
+
+                        FunBit <<= 1;
+                }
+                break;
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                FunBit = 1;
+                for (i = 0; i < 8; i++) {
+                        if (FunBit & multi_fun_sel_bit) {
+                                u8 set_other_fun = TRUE;
+
+                                if (i == 3 || i == 4) {
+                                        TmpUlong = rtl8168_csi_other_fun_read(tp, i, 0x00);
+
+                                        if (TmpUlong == 0xFFFFFFFF)
+                                                set_other_fun = TRUE;
+                                        else
+                                                set_other_fun = FALSE;
+                                } else if (i == 5 || i == 6) {
+                                        if (tp->DASH) {
+                                                TmpUlong = mac_ocp_read(tp, 0x184);
+
+                                                if (TmpUlong & BIT_26)
+                                                        set_other_fun = FALSE;
+                                                else
+                                                        set_other_fun = TRUE;
+                                        }
+                                }
+
+                                if (set_other_fun)
+                                        rtl8168_clear_and_aet_other_fun_pci_bit(tp, i, addr, clearmask, setmask);
+                        }
+
+                        FunBit <<= 1;
+                }
+                break;
+        }
+}
+
+static void
+rtl8168_set_dash_other_fun_dev_state_change(struct rtl8168_private *tp,
+                u8 dev_state,
+                u8 multi_fun_sel_bit)
+{
+        u32 clearmask;
+        u32 setmask;
+
+        if (dev_state == 0) {
+                //
+                // goto D0
+                //
+                clearmask = (BIT_0 | BIT_1);
+                setmask = 0;
+
+                rtl8168_other_fun_dev_pci_setting(tp, 0x44, clearmask, setmask, multi_fun_sel_bit);
+        } else {
+                //
+                // goto D3
+                //
+                clearmask = 0;
+                setmask = (BIT_0 | BIT_1);
+
+                rtl8168_other_fun_dev_pci_setting(tp, 0x44, clearmask, setmask, multi_fun_sel_bit);
+        }
+}
+
+static void
+rtl8168_set_dash_other_fun_dev_aspm_clkreq(struct rtl8168_private *tp,
+                u8 aspm_val,
+                u8 clkreq_en,
+                u8 multi_fun_sel_bit)
+{
+        u32 clearmask;
+        u32 setmask;
+
+        aspm_val &= (BIT_0 | BIT_1);
+        clearmask = (BIT_0 | BIT_1 | BIT_8);
+        setmask = aspm_val;
+        if (clkreq_en)
+                setmask |= BIT_8;
+
+        rtl8168_other_fun_dev_pci_setting(tp, 0x80, clearmask, setmask, multi_fun_sel_bit);
+}
+
+static void
+rtl8168_set_dash_other_fun_dev_pci_cmd_register(struct rtl8168_private *tp,
+                u8 pci_cmd_reg,
+                u8 multi_fun_sel_bit)
+{
+        u32 clearmask;
+        u32 setmask;
+
+        pci_cmd_reg &= (BIT_0 | BIT_1 | BIT_2);
+
+        clearmask = (BIT_0 | BIT_1 | BIT_2);
+        setmask = pci_cmd_reg;
+
+        rtl8168_other_fun_dev_pci_setting(tp, 0x04, clearmask, setmask, multi_fun_sel_bit);
+}
+
+u32 rtl8168_eri_read_with_oob_base_address(void __iomem *ioaddr, int addr, int len, int type, const u32 base_address)
+{
+        int i, val_shift, shift = 0;
+        u32 value1 = 0, value2 = 0, mask;
+        u32 eri_cmd;
+        const u32 transformed_base_address = ((base_address & 0x00FFF000) << 6) | (base_address & 0x000FFF);
+
+        if (len > 4 || len <= 0)
+                return -1;
+
+        while (len > 0) {
+                val_shift = addr % ERIAR_Addr_Align;
+                addr = addr & ~0x3;
+
+                eri_cmd = ERIAR_Read |
+                          transformed_base_address |
+                          type << ERIAR_Type_shift |
+                          ERIAR_ByteEn << ERIAR_ByteEn_shift |
+                          (addr & 0x0FFF);
+                if (addr & 0xF000) {
+                        u32 tmp;
+
+                        tmp = addr & 0xF000;
+                        tmp >>= 12;
+                        eri_cmd |= (tmp << 20) & 0x00F00000;
+                }
+
+                RTL_W32(ERIAR, eri_cmd);
+
+                for (i = 0; i < 10; i++) {
+                        udelay(100);
+
+                        /* Check if the RTL8168 has completed ERI read */
+                        if (RTL_R32(ERIAR) & ERIAR_Flag)
+                                break;
+                }
+
+                if (len == 1)       mask = (0xFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 2)  mask = (0xFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 3)  mask = (0xFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else            mask = (0xFFFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+
+                value1 = RTL_R32(ERIDR) & mask;
+                value2 |= (value1 >> val_shift * 8) << shift * 8;
+
+                if (len <= 4 - val_shift) {
+                        len = 0;
+                } else {
+                        len -= (4 - val_shift);
+                        shift = 4 - val_shift;
+                        addr += 4;
+                }
+        }
+
+        udelay(20);
+
+        return value2;
+}
+
+u32 rtl8168_eri_read(void __iomem *ioaddr, int addr, int len, int type)
+{
+        return rtl8168_eri_read_with_oob_base_address(ioaddr, addr, len, type, 0);
+}
+
+int rtl8168_eri_write_with_oob_base_address(void __iomem *ioaddr, int addr, int len, u32 value, int type, const u32 base_address)
+{
+        int i, val_shift, shift = 0;
+        u32 value1 = 0, mask;
+        u32 eri_cmd;
+        const u32 transformed_base_address = ((base_address & 0x00FFF000) << 6) | (base_address & 0x000FFF);
+
+        if (len > 4 || len <= 0)
+                return -1;
+
+        while (len > 0) {
+                val_shift = addr % ERIAR_Addr_Align;
+                addr = addr & ~0x3;
+
+                if (len == 1)       mask = (0xFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 2)  mask = (0xFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else if (len == 3)  mask = (0xFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+                else            mask = (0xFFFFFFFF << (val_shift * 8)) & 0xFFFFFFFF;
+
+                value1 = rtl8168_eri_read_with_oob_base_address(ioaddr, addr, 4, type, base_address) & ~mask;
+                value1 |= ((value << val_shift * 8) >> shift * 8);
+
+                RTL_W32(ERIDR, value1);
+
+                eri_cmd = ERIAR_Write |
+                          transformed_base_address |
+                          type << ERIAR_Type_shift |
+                          ERIAR_ByteEn << ERIAR_ByteEn_shift |
+                          (addr & 0x0FFF);
+                if (addr & 0xF000) {
+                        u32 tmp;
+
+                        tmp = addr & 0xF000;
+                        tmp >>= 12;
+                        eri_cmd |= (tmp << 20) & 0x00F00000;
+                }
+
+                RTL_W32(ERIAR, eri_cmd);
+
+                for (i = 0; i < 10; i++) {
+                        udelay(100);
+
+                        /* Check if the RTL8168 has completed ERI write */
+                        if (!(RTL_R32(ERIAR) & ERIAR_Flag))
+                                break;
+                }
+
+                if (len <= 4 - val_shift) {
+                        len = 0;
+                } else {
+                        len -= (4 - val_shift);
+                        shift = 4 - val_shift;
+                        addr += 4;
+                }
+        }
+
+        udelay(20);
+
+        return 0;
+}
+
+int rtl8168_eri_write(void __iomem *ioaddr, int addr, int len, u32 value, int type)
+{
+        return rtl8168_eri_write_with_oob_base_address(ioaddr, addr, len, value, type, NO_BASE_ADDRESS);
+}
+
+static void
+rtl8168_enable_rxdvgate(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                RTL_W8(0xF2, RTL_R8(0xF2) | BIT_3);
+                mdelay(2);
+                break;
+        }
+}
+
+static void
+rtl8168_disable_rxdvgate(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                RTL_W8(0xF2, RTL_R8(0xF2) & ~BIT_3);
+                mdelay(2);
+                break;
+        }
+}
+
+static u8
+rtl8168_is_gpio_low(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        u8 gpio_low = FALSE;
+
+        switch (tp->HwSuppCheckPhyDisableModeVer) {
+        case 1:
+        case 2:
+                if (!(mac_ocp_read(tp, 0xDC04) & BIT_9))
+                        gpio_low = TRUE;
+                break;
+        case 3:
+                if (!(mac_ocp_read(tp, 0xDC04) & BIT_13))
+                        gpio_low = TRUE;
+                break;
+        }
+
+        if (gpio_low)
+                dprintk("gpio is low.\n");
+
+        return gpio_low;
+}
+
+static u8
+rtl8168_is_phy_disable_mode_enabled(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u8 phy_disable_mode_enabled = FALSE;
+
+        switch (tp->HwSuppCheckPhyDisableModeVer) {
+        case 1:
+                if (mac_ocp_read(tp, 0xDC20) & BIT_1)
+                        phy_disable_mode_enabled = TRUE;
+                break;
+        case 2:
+        case 3:
+                if (RTL_R8(0xF2) & BIT_5)
+                        phy_disable_mode_enabled = TRUE;
+                break;
+        }
+
+        if (phy_disable_mode_enabled)
+                dprintk("phy disable mode enabled.\n");
+
+        return phy_disable_mode_enabled;
+}
+
+static u8
+rtl8168_is_in_phy_disable_mode(struct net_device *dev)
+{
+        u8 in_phy_disable_mode = FALSE;
+
+        if (rtl8168_is_phy_disable_mode_enabled(dev) && rtl8168_is_gpio_low(dev))
+                in_phy_disable_mode = TRUE;
+
+        if (in_phy_disable_mode)
+                dprintk("Hardware is in phy disable mode.\n");
+
+        return in_phy_disable_mode;
+}
+
+static void
+rtl8168_enable_phy_disable_mode(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        switch (tp->HwSuppCheckPhyDisableModeVer) {
+        case 1:
+                mac_ocp_write(tp, 0xDC20, mac_ocp_read(tp, 0xDC20) | BIT_1);
+                break;
+        case 2:
+        case 3:
+                RTL_W8(0xF2, RTL_R8(0xF2) | BIT_5);
+                break;
+        }
+
+        dprintk("enable phy disable mode.\n");
+}
+
+static void
+rtl8168_disable_phy_disable_mode(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        switch (tp->HwSuppCheckPhyDisableModeVer) {
+        case 1:
+                mac_ocp_write(tp, 0xDC20, mac_ocp_read(tp, 0xDC20) & ~BIT_1);
+                break;
+        case 2:
+        case 3:
+                RTL_W8(0xF2, RTL_R8(0xF2) & ~BIT_5);
+                break;
+        }
+
+        mdelay(1);
+
+        dprintk("disable phy disable mode.\n");
+}
+
+void
+rtl8168_wait_txrx_fifo_empty(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        int i;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                for (i = 0; i < 10; i++) {
+                        udelay(100);
+                        if (RTL_R32(TxConfig) & BIT_11)
+                                break;
+                }
+
+                for (i = 0; i < 10; i++) {
+                        udelay(100);
+                        if ((RTL_R8(MCUCmd_reg) & (Txfifo_empty | Rxfifo_empty)) == (Txfifo_empty | Rxfifo_empty))
+                                break;
+
+                }
+                break;
+        }
+}
+
+#ifdef ENABLE_DASH_SUPPORT
+
+inline void
+rtl8168_enable_dash2_interrupt(struct rtl8168_private *tp, void __iomem *ioaddr)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                RTL_CMAC_W8(CMAC_IBIMR0, ( ISRIMR_DASH_TYPE2_ROK | ISRIMR_DASH_TYPE2_TOK | ISRIMR_DASH_TYPE2_TDU | ISRIMR_DASH_TYPE2_RDU | ISRIMR_DASH_TYPE2_RX_DISABLE_IDLE ));
+        }
+}
+
+static inline void
+rtl8168_disable_dash2_interrupt(struct rtl8168_private *tp, void __iomem *ioaddr)
+{
+        if (!tp->DASH) return;
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                RTL_CMAC_W8(CMAC_IBIMR0, 0);
+        }
+}
+#endif
+
+static inline void
+rtl8168_enable_hw_interrupt(struct rtl8168_private *tp, void __iomem *ioaddr)
+{
+        RTL_W16(IntrMask, tp->intr_mask);
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH)
+                rtl8168_enable_dash2_interrupt(tp, ioaddr);
+#endif
+}
+
+static inline void
+rtl8168_disable_hw_interrupt(struct rtl8168_private *tp, void __iomem *ioaddr)
+{
+        RTL_W16(IntrMask, 0x0000);
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH)
+                rtl8168_disable_dash2_interrupt(tp, ioaddr);
+#endif
+}
+
+
+static inline void
+rtl8168_switch_to_hw_interrupt(struct rtl8168_private *tp, void __iomem *ioaddr)
+{
+        RTL_W32(TimeInt0, 0x0000);
+
+        rtl8168_enable_hw_interrupt(tp, ioaddr);
+}
+
+static inline void
+rtl8168_switch_to_timer_interrupt(struct rtl8168_private *tp, void __iomem *ioaddr)
+{
+        if (tp->use_timer_interrrupt) {
+                RTL_W32(TCTR, timer_count);
+                RTL_W32(TimeInt0, timer_count);
+                RTL_W16(IntrMask, tp->timer_intr_mask);
+
+#ifdef ENABLE_DASH_SUPPORT
+                if (tp->DASH)
+                        rtl8168_enable_dash2_interrupt(tp, ioaddr);
+#endif
+        } else {
+                rtl8168_switch_to_hw_interrupt(tp, ioaddr);
+        }
+}
+
+static void
+rtl8168_irq_mask_and_ack(struct rtl8168_private *tp, void __iomem *ioaddr)
+{
+        rtl8168_disable_hw_interrupt(tp, ioaddr);
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH) {
+                if (tp->dash_printer_enabled) {
+                        RTL_W16(IntrStatus, RTL_R16(IntrStatus) &
+                                ~(ISRIMR_DASH_INTR_EN | ISRIMR_DASH_INTR_CMAC_RESET));
+                } else {
+                        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                                RTL_CMAC_W8(CMAC_IBISR0, RTL_CMAC_R8(CMAC_IBISR0));
+                        }
+                }
+        } else {
+                RTL_W16(IntrStatus, RTL_R16(IntrStatus));
+        }
+#else
+        RTL_W16(IntrStatus, RTL_R16(IntrStatus));
+#endif
+}
+
+static void
+rtl8168_nic_reset(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        int i;
+
+        RTL_W32(RxConfig, (RX_DMA_BURST << RxCfgDMAShift));
+
+        rtl8168_enable_rxdvgate(dev);
+
+        rtl8168_wait_txrx_fifo_empty(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_1:
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+                mdelay(10);
+                break;
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        case CFG_METHOD_6:
+        case CFG_METHOD_7:
+        case CFG_METHOD_8:
+        case CFG_METHOD_9:
+        case CFG_METHOD_10:
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+                RTL_W8(ChipCmd, StopReq | CmdRxEnb | CmdTxEnb);
+                udelay(100);
+                break;
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+        case CFG_METHOD_13:
+                while (RTL_R8(TxPoll) & NPQ)
+                        udelay(20);
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                mdelay(2);
+                break;
+        default:
+                mdelay(10);
+                break;
+        }
+
+        /* Soft reset the chip. */
+        RTL_W8(ChipCmd, CmdReset);
+
+        /* Check that the chip has finished the reset. */
+        for (i = 100; i > 0; i--) {
+                udelay(100);
+                if ((RTL_R8(ChipCmd) & CmdReset) == 0)
+                        break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_11:
+                OOB_mutex_lock(tp);
+                OCP_write(tp, 0x10, 2, OCP_read(tp, 0x010, 2)&~0x00004000);
+                OOB_mutex_unlock(tp);
+
+                OOB_notify(tp, OOB_CMD_RESET);
+
+                for (i = 0; i < 10; i++) {
+                        mdelay(10);
+                        if (OCP_read(tp, 0x010, 2)&0x00004000)
+                                break;
+                }
+
+                for (i = 0; i < 5; i++) {
+                        if ( OCP_read(tp, 0x034, 1) == 0)
+                                break;
+                }
+                break;
+        }
+}
+
+static void
+rtl8168_hw_clear_timer_int(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        RTL_W32(TimeInt0, 0x0000);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        case CFG_METHOD_6:
+        case CFG_METHOD_7:
+        case CFG_METHOD_8:
+                RTL_W32(TimeInt1, 0x0000);
+                break;
+        case CFG_METHOD_9:
+        case CFG_METHOD_10:
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+        case CFG_METHOD_13:
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                RTL_W32(TimeInt1, 0x0000);
+                RTL_W32(TimeInt2, 0x0000);
+                RTL_W32(TimeInt3, 0x0000);
+                break;
+        }
+}
+
+static void
+rtl8168_hw_reset(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        /* Disable interrupts */
+        rtl8168_irq_mask_and_ack(tp, ioaddr);
+
+        rtl8168_hw_clear_timer_int(dev);
+
+        rtl8168_nic_reset(dev);
+}
+
+static void rtl8168_mac_loopback_test(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        struct net_device *dev = tp->dev;
+        struct sk_buff *skb, *rx_skb;
+        dma_addr_t mapping;
+        struct TxDesc *txd;
+        struct RxDesc *rxd;
+        void *tmpAddr;
+        u32 len, rx_len, rx_cmd = 0;
+        u16 type;
+        u8 pattern;
+        int i;
+
+        if (tp->DASH)
+                return;
+
+        pattern = 0x5A;
+        len = 60;
+        type = htons(ETH_P_IP);
+        txd = tp->TxDescArray;
+        rxd = tp->RxDescArray;
+        rx_skb = tp->Rx_skbuff[0];
+        RTL_W32(TxConfig, (RTL_R32(TxConfig) & ~0x00060000) | 0x00020000);
+
+        do {
+                skb = dev_alloc_skb(len + RTK_RX_ALIGN);
+                if (unlikely(!skb))
+                        dev_printk(KERN_NOTICE, &tp->pci_dev->dev, "-ENOMEM;\n");
+        } while (unlikely(skb == NULL));
+        skb_reserve(skb, RTK_RX_ALIGN);
+
+        memcpy(skb_put(skb, dev->addr_len), dev->dev_addr, dev->addr_len);
+        memcpy(skb_put(skb, dev->addr_len), dev->dev_addr, dev->addr_len);
+        memcpy(skb_put(skb, sizeof(type)), &type, sizeof(type));
+        tmpAddr = skb_put(skb, len - 14);
+
+        mapping = pci_map_single(tp->pci_dev, skb->data, len, PCI_DMA_TODEVICE);
+        pci_dma_sync_single_for_cpu(tp->pci_dev, le64_to_cpu(mapping),
+                                    len, PCI_DMA_TODEVICE);
+        txd->addr = cpu_to_le64(mapping);
+        txd->opts2 = 0;
+        while (1) {
+                memset(tmpAddr, pattern++, len - 14);
+                pci_dma_sync_single_for_device(tp->pci_dev,
+                                               le64_to_cpu(mapping),
+                                               len, PCI_DMA_TODEVICE);
+                txd->opts1 = cpu_to_le32(DescOwn | FirstFrag | LastFrag | len);
+
+                RTL_W32(RxConfig, RTL_R32(RxConfig)  | AcceptMyPhys);
+
+                smp_wmb();
+                RTL_W8(TxPoll, NPQ);    /* set polling bit */
+
+                for (i = 0; i < 50; i++) {
+                        udelay(200);
+                        rx_cmd = le32_to_cpu(rxd->opts1);
+                        if ((rx_cmd & DescOwn) == 0)
+                                break;
+                }
+
+                RTL_W32(RxConfig, RTL_R32(RxConfig) & ~(AcceptErr | AcceptRunt | AcceptBroadcast | AcceptMulticast | AcceptMyPhys |  AcceptAllPhys));
+
+                rx_len = rx_cmd & 0x3FFF;
+                rx_len -= 4;
+                rxd->opts1 = cpu_to_le32(DescOwn | tp->rx_buf_sz);
+
+                pci_dma_sync_single_for_cpu(tp->pci_dev, le64_to_cpu(mapping), len, PCI_DMA_TODEVICE);
+
+                if (rx_len == len) {
+                        pci_dma_sync_single_for_cpu(tp->pci_dev, le64_to_cpu(rxd->addr), tp->rx_buf_sz, PCI_DMA_FROMDEVICE);
+                        i = memcmp(skb->data, rx_skb->data, rx_len);
+                        pci_dma_sync_single_for_device(tp->pci_dev, le64_to_cpu(rxd->addr), tp->rx_buf_sz, PCI_DMA_FROMDEVICE);
+                        if (i == 0) {
+//              dev_printk(KERN_INFO, &tp->pci_dev->dev, "loopback test finished\n",rx_len,len);
+                                break;
+                        }
+                }
+
+                rtl8168_hw_reset(dev);
+                rtl8168_disable_rxdvgate(dev);
+                RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+        }
+        tp->dirty_tx++;
+        tp->dirty_rx++;
+        tp->cur_tx++;
+        tp->cur_rx++;
+        pci_unmap_single(tp->pci_dev, le64_to_cpu(mapping),
+                         len, PCI_DMA_TODEVICE);
+        RTL_W32(TxConfig, RTL_R32(TxConfig) & ~0x00060000);
+        dev_kfree_skb_any(skb);
+        RTL_W16(IntrStatus, 0xFFBF);
+}
+
+static unsigned int
+rtl8168_xmii_reset_pending(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int retval;
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+        mdio_write(tp, 0x1f, 0x0000);
+        retval = mdio_read(tp, MII_BMCR) & BMCR_RESET;
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+        return retval;
+}
+
+static unsigned int
+rtl8168_xmii_link_ok(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned int retval;
+
+        retval = (RTL_R8(PHYstatus) & LinkStatus) ? 1 : 0;
+
+        return retval;
+}
+
+static void
+rtl8168_xmii_reset_enable(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        int i, val = 0;
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+        if (rtl8168_is_in_phy_disable_mode(dev)) {
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                return;
+        }
+
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, MII_ADVERTISE, mdio_read(tp, MII_ADVERTISE) &
+                   ~(ADVERTISE_10HALF | ADVERTISE_10FULL |
+                     ADVERTISE_100HALF | ADVERTISE_100FULL));
+        mdio_write(tp, MII_CTRL1000, mdio_read(tp, MII_CTRL1000) &
+                   ~(ADVERTISE_1000HALF | ADVERTISE_1000FULL));
+        mdio_write(tp, MII_BMCR, BMCR_RESET | BMCR_ANENABLE);
+
+        for (i = 0; i < 2500; i++) {
+                val = mdio_read(tp, MII_BMCR) & BMCR_RESET;
+
+                if (!val) {
+                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                        return;
+                }
+
+                mdelay(1);
+        }
+
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+        if (netif_msg_link(tp))
+                printk(KERN_ERR "%s: PHY reset failed.\n", dev->name);
+}
+
+static void
+rtl8168dp_10mbps_gphy_para(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u8 status = RTL_R8(PHYstatus);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+        if ((status & LinkStatus) && (status & _10bps)) {
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, 0x10, 0x04EE);
+        } else {
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, 0x10, 0x01EE);
+        }
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+}
+
+void rtl8168_init_ring_indexes(struct rtl8168_private *tp)
+{
+        tp->dirty_tx = 0;
+        tp->dirty_rx = 0;
+        tp->cur_tx = 0;
+        tp->cur_rx = 0;
+}
+
+static void
+rtl8168_issue_offset_99_event(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                if (tp->mcfg == CFG_METHOD_24 || tp->mcfg == CFG_METHOD_25 ||
+                    tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28) {
+                        rtl8168_eri_write(ioaddr, 0x3FC, 4, 0x00000000, ERIAR_ExGMAC);
+                } else {
+                        rtl8168_eri_write(ioaddr, 0x3FC, 4, 0x083C083C, ERIAR_ExGMAC);
+                }
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x3F8, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0x3F8, 1, csi_tmp, ERIAR_ExGMAC);
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1EA, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0x1EA, 1, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+}
+
+#ifdef ENABLE_DASH_SUPPORT
+static void
+NICChkTypeEnableDashInterrupt(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        if (tp->DASH) {
+                //
+                // even disconnected, enable 3 dash interrupt mask bits for in-band/out-band communication
+                //
+                if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                        rtl8168_enable_dash2_interrupt(tp, ioaddr);
+                        RTL_W16(IntrMask, (ISRIMR_DASH_INTR_EN | ISRIMR_DASH_INTR_CMAC_RESET));
+                } else {
+                        RTL_W16(IntrMask, (ISRIMR_DP_DASH_OK | ISRIMR_DP_HOST_OK | ISRIMR_DP_REQSYS_OK));
+                }
+        }
+}
+#endif
+
+static void
+rtl8168_check_link_status(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        int link_status_on;
+        unsigned long flags;
+
+#ifdef ENABLE_FIBER_SUPPORT
+        rtl8168_check_fiber_link_status(dev);
+#endif //ENABLE_FIBER_SUPPORT
+
+        link_status_on = tp->link_ok(dev);
+
+        if (tp->mcfg == CFG_METHOD_11)
+                rtl8168dp_10mbps_gphy_para(dev);
+
+        if (netif_carrier_ok(dev) != link_status_on) {
+                if (link_status_on) {
+                        rtl8168_hw_config(dev);
+
+                        if (tp->mcfg == CFG_METHOD_18 || tp->mcfg == CFG_METHOD_19 || tp->mcfg == CFG_METHOD_20) {
+                                if (RTL_R8(PHYstatus) & _1000bpsF) {
+                                        rtl8168_eri_write(ioaddr, 0x1bc, 4, 0x00000011, ERIAR_ExGMAC);
+                                        rtl8168_eri_write(ioaddr, 0x1dc, 4, 0x0000001f, ERIAR_ExGMAC);
+                                } else if (RTL_R8(PHYstatus) & _100bps) {
+                                        rtl8168_eri_write(ioaddr, 0x1bc, 4, 0x0000001f, ERIAR_ExGMAC);
+                                        rtl8168_eri_write(ioaddr, 0x1dc, 4, 0x0000001f, ERIAR_ExGMAC);
+                                } else {
+                                        rtl8168_eri_write(ioaddr, 0x1bc, 4, 0x0000001f, ERIAR_ExGMAC);
+                                        rtl8168_eri_write(ioaddr, 0x1dc, 4, 0x0000002d, ERIAR_ExGMAC);
+                                }
+                        } else if ((tp->mcfg == CFG_METHOD_16 || tp->mcfg == CFG_METHOD_17) && netif_running(dev)) {
+                                if (tp->mcfg == CFG_METHOD_16 && (RTL_R8(PHYstatus) & _10bps)) {
+                                        RTL_W32(RxConfig, RTL_R32(RxConfig) | AcceptAllPhys);
+                                } else if (tp->mcfg == CFG_METHOD_17) {
+                                        if (RTL_R8(PHYstatus) & _1000bpsF) {
+                                                rtl8168_eri_write(ioaddr, 0x1bc, 4, 0x00000011, ERIAR_ExGMAC);
+                                                rtl8168_eri_write(ioaddr, 0x1dc, 4, 0x00000005, ERIAR_ExGMAC);
+                                        } else if (RTL_R8(PHYstatus) & _100bps) {
+                                                rtl8168_eri_write(ioaddr, 0x1bc, 4, 0x0000001f, ERIAR_ExGMAC);
+                                                rtl8168_eri_write(ioaddr, 0x1dc, 4, 0x00000005, ERIAR_ExGMAC);
+                                        } else {
+                                                rtl8168_eri_write(ioaddr, 0x1bc, 4, 0x0000001f, ERIAR_ExGMAC);
+                                                rtl8168_eri_write(ioaddr, 0x1dc, 4, 0x0000003f, ERIAR_ExGMAC);
+                                        }
+                                }
+                        } else if ((tp->mcfg == CFG_METHOD_14 || tp->mcfg == CFG_METHOD_15) && eee_enable ==1) {
+                                /*Full -Duplex  mode*/
+                                if (RTL_R8(PHYstatus)&FullDup) {
+                                        spin_lock_irqsave(&tp->phy_lock, flags);
+                                        mdio_write(tp, 0x1F, 0x0006);
+                                        mdio_write(tp, 0x00, 0x5a30);
+                                        mdio_write(tp, 0x1F, 0x0000);
+                                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                                        if (RTL_R8(PHYstatus) & (_10bps | _100bps))
+                                                RTL_W32(TxConfig, (RTL_R32(TxConfig) & ~BIT_19) | BIT_25);
+
+                                } else {
+                                        spin_lock_irqsave(&tp->phy_lock, flags);
+                                        mdio_write(tp, 0x1F, 0x0006);
+                                        mdio_write(tp, 0x00, 0x5a00);
+                                        mdio_write(tp, 0x1F, 0x0000);
+                                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                                        if (RTL_R8(PHYstatus) & (_10bps | _100bps))
+                                                RTL_W32(TxConfig, (RTL_R32(TxConfig) & ~BIT_19) | (InterFrameGap << TxInterFrameGapShift));
+                                }
+                        } else if ((tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+                                    tp->mcfg == CFG_METHOD_23 || tp->mcfg == CFG_METHOD_24 ||
+                                    tp->mcfg == CFG_METHOD_25 || tp->mcfg == CFG_METHOD_26 ||
+                                    tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28 ||
+                                    tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30 ||
+                                    tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) &&
+                                   netif_running(dev)) {
+                                if (RTL_R8(PHYstatus)&FullDup)
+                                        RTL_W32(TxConfig, (RTL_R32(TxConfig) | (BIT_24 | BIT_25)) & ~BIT_19);
+                                else
+                                        RTL_W32(TxConfig, (RTL_R32(TxConfig) | BIT_25) & ~(BIT_19 | BIT_24));
+                        }
+
+                        if (tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+                            tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28 ||
+                            tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                                /*half mode*/
+                                if (!(RTL_R8(PHYstatus)&FullDup)) {
+                                        spin_lock_irqsave(&tp->phy_lock, flags);
+                                        mdio_write(tp, 0x1F, 0x0000);
+                                        mdio_write(tp, MII_ADVERTISE, mdio_read(tp, MII_ADVERTISE)&~(ADVERTISE_PAUSE_CAP|ADVERTISE_PAUSE_ASYM));
+                                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                                }
+                        }
+
+                        if ((tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) && (RTL_R8(PHYstatus) & _10bps)) {
+                                u32 csi_tmp;
+
+                                csi_tmp = rtl8168_eri_read(ioaddr, 0x1D0, 1, ERIAR_ExGMAC);
+                                csi_tmp |= BIT_1;
+                                rtl8168_eri_write(ioaddr, 0x1D0, 1, csi_tmp, ERIAR_ExGMAC);
+                        }
+
+                        rtl8168_hw_start(dev);
+
+                        netif_carrier_on(dev);
+
+                        netif_wake_queue(dev);
+
+                        if (netif_msg_ifup(tp))
+                                printk(KERN_INFO PFX "%s: link up\n", dev->name);
+                } else {
+                        if (netif_msg_ifdown(tp))
+                                printk(KERN_INFO PFX "%s: link down\n", dev->name);
+
+                        netif_stop_queue(dev);
+
+                        netif_carrier_off(dev);
+
+                        rtl8168_hw_reset(dev);
+
+                        rtl8168_tx_clear(tp);
+
+                        rtl8168_rx_clear(tp);
+
+                        rtl8168_init_ring(dev);
+
+                        rtl8168_set_speed(dev, tp->autoneg, tp->speed, tp->duplex, tp->advertising);
+
+                        switch (tp->mcfg) {
+                        case CFG_METHOD_21:
+                        case CFG_METHOD_22:
+                        case CFG_METHOD_23:
+                        case CFG_METHOD_24:
+                        case CFG_METHOD_25:
+                        case CFG_METHOD_27:
+                        case CFG_METHOD_28:
+                                if (tp->org_pci_offset_99 & BIT_2)
+                                        tp->issue_offset_99_event = TRUE;
+                                break;
+                        }
+
+#ifdef ENABLE_DASH_SUPPORT
+                        if (tp->DASH) {
+                                NICChkTypeEnableDashInterrupt(tp);
+                        }
+#endif
+                }
+        }
+
+        if (!link_status_on) {
+                switch (tp->mcfg) {
+                case CFG_METHOD_21:
+                case CFG_METHOD_22:
+                case CFG_METHOD_23:
+                case CFG_METHOD_24:
+                case CFG_METHOD_25:
+                case CFG_METHOD_27:
+                case CFG_METHOD_28:
+                        if (tp->issue_offset_99_event) {
+                                if (!(RTL_R8(PHYstatus) & PowerSaveStatus)) {
+                                        tp->issue_offset_99_event = FALSE;
+                                        rtl8168_issue_offset_99_event(tp);
+                                }
+                        }
+                        break;
+                }
+        }
+}
+
+static void
+rtl8168_link_option(u8 *aut,
+                    u32 *spd,
+                    u8 *dup,
+                    u32 *adv)
+{
+        if ((*spd != SPEED_1000) && (*spd != SPEED_100) && (*spd != SPEED_10))
+                *spd = SPEED_1000;
+
+        if ((*dup != DUPLEX_FULL) && (*dup != DUPLEX_HALF))
+                *dup = DUPLEX_FULL;
+
+        if ((*aut != AUTONEG_ENABLE) && (*aut != AUTONEG_DISABLE))
+                *aut = AUTONEG_ENABLE;
+
+        *adv &= (ADVERTISED_10baseT_Half |
+                 ADVERTISED_10baseT_Full |
+                 ADVERTISED_100baseT_Half |
+                 ADVERTISED_100baseT_Full |
+                 ADVERTISED_1000baseT_Half |
+                 ADVERTISED_1000baseT_Full);
+        if (*adv == 0)
+                *adv = (ADVERTISED_10baseT_Half |
+                        ADVERTISED_10baseT_Full |
+                        ADVERTISED_100baseT_Half |
+                        ADVERTISED_100baseT_Full |
+                        ADVERTISED_1000baseT_Half |
+                        ADVERTISED_1000baseT_Full);
+}
+
+void
+rtl8168_wait_ll_share_fifo_ready(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        int i;
+
+        for (i = 0; i < 10; i++) {
+                udelay(100);
+                if (RTL_R16(0xD2) & BIT_9)
+                        break;
+        }
+}
+
+static void
+rtl8168_disable_pci_offset_99(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x3F2, 2, ERIAR_ExGMAC);
+                csi_tmp &= ~(BIT_0 | BIT_1);
+                rtl8168_eri_write(ioaddr, 0x3F2, 2, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_26:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                rtl8168_csi_fun0_write_byte(tp, 0x99, 0x00);
+                break;
+        }
+}
+
+static void
+rtl8168_enable_pci_offset_99(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_26:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                rtl8168_csi_fun0_write_byte(tp, 0x99, tp->org_pci_offset_99);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x3F2, 2, ERIAR_ExGMAC);
+                csi_tmp &= ~(BIT_0 | BIT_1);
+                if (!(tp->org_pci_offset_99 & (BIT_5 | BIT_6)))
+                        csi_tmp |= BIT_1;
+                if (!(tp->org_pci_offset_99 & BIT_2))
+                        csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0x3F2, 2, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+}
+
+static void
+rtl8168_init_pci_offset_99(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_26:
+                if (tp->org_pci_offset_99 & BIT_2) {
+                        csi_tmp = rtl8168_eri_read(ioaddr, 0x5C2, 1, ERIAR_ExGMAC);
+                        csi_tmp &= ~BIT_1;
+                        rtl8168_eri_write(ioaddr, 0x5C2, 1, csi_tmp, ERIAR_ExGMAC);
+                }
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x3F2, 2, ERIAR_ExGMAC);
+                csi_tmp &= ~( BIT_8 | BIT_9  | BIT_10 | BIT_11  | BIT_12  | BIT_13  | BIT_14 | BIT_15 );
+                csi_tmp |= ( BIT_9 | BIT_10 | BIT_13  | BIT_14 | BIT_15 );
+                rtl8168_eri_write(ioaddr, 0x3F2, 2, csi_tmp, ERIAR_ExGMAC);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x3F5, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_6 | BIT_7;
+                rtl8168_eri_write(ioaddr, 0x3F5, 1, csi_tmp, ERIAR_ExGMAC);
+                mac_ocp_write(tp, 0xE02C, 0x1880);
+                mac_ocp_write(tp, 0xE02E, 0x4880);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_26:
+                rtl8168_eri_write(ioaddr, 0x5C0, 1, 0xFA, ERIAR_ExGMAC);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_26:
+                if (tp->org_pci_offset_99 & BIT_2) {
+                        csi_tmp = rtl8168_eri_read(ioaddr, 0x5C8, 1, ERIAR_ExGMAC);
+                        csi_tmp |= BIT_0;
+                        rtl8168_eri_write(ioaddr, 0x5C8, 1, csi_tmp, ERIAR_ExGMAC);
+                }
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                if (tp->org_pci_offset_99 & BIT_2)
+                        mac_ocp_write(tp, 0xE0A2,  mac_ocp_read(tp, 0xE0A2) | BIT_0);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_23:
+                rtl8168_eri_write(ioaddr, 0x2E8, 2, 0x883C, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x2EA, 2, 0x8C12, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x2EC, 2, 0x9003, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x2E2, 2, 0x883C, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x2E4, 2, 0x8C12, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x2E6, 2, 0x9003, ERIAR_ExGMAC);
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                rtl8168_eri_write(ioaddr, 0x2E8, 2, 0x9003, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x2EA, 2, 0x9003, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x2EC, 2, 0x9003, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x2E2, 2, 0x883C, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x2E4, 2, 0x8C12, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x2E6, 2, 0x9003, ERIAR_ExGMAC);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x3FA, 2, ERIAR_ExGMAC);
+                csi_tmp |= BIT_14;
+                rtl8168_eri_write(ioaddr, 0x3FA, 2, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_26:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                if (tp->org_pci_offset_99 & BIT_2)
+                        RTL_W8(0xB6, RTL_R8(0xB6) | BIT_0);
+                break;
+        }
+
+        rtl8168_enable_pci_offset_99(tp);
+}
+
+static void
+rtl8168_disable_pci_offset_180(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1E2, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_2;
+                rtl8168_eri_write(ioaddr, 0x1E2, 1, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_26:
+                rtl8168_eri_write(ioaddr, 0x1E9, 1, 0x0A, ERIAR_ExGMAC);
+                break;
+        }
+}
+
+static void
+rtl8168_enable_pci_offset_180(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_25:
+        case CFG_METHOD_28:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1E8, 4, ERIAR_ExGMAC);
+                csi_tmp &= ~(0x0000FF00);
+                csi_tmp |= (0x00006400);
+                rtl8168_eri_write(ioaddr, 0x1E8, 4, csi_tmp, ERIAR_ExGMAC);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1E4, 4, ERIAR_ExGMAC);
+                csi_tmp &= ~(0x0000FF00);
+                rtl8168_eri_write(ioaddr, 0x1E4, 4, csi_tmp, ERIAR_ExGMAC);
+                break;
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1E8, 4, ERIAR_ExGMAC);
+                csi_tmp &= ~(0x0000FFF0);
+                csi_tmp |= (0x00000640);
+                rtl8168_eri_write(ioaddr, 0x1E8, 4, csi_tmp, ERIAR_ExGMAC);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1E4, 4, ERIAR_ExGMAC);
+                csi_tmp &= ~(0x0000FF00);
+                rtl8168_eri_write(ioaddr, 0x1E4, 4, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1E2, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_2;
+                rtl8168_eri_write(ioaddr, 0x1E2, 1, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_26:
+                rtl8168_eri_write(ioaddr, 0x1E9, 1, 0x64, ERIAR_ExGMAC);
+                break;
+        }
+
+        mac_ocp_write(tp, 0xE094, 0x0000);
+}
+
+static void
+rtl8168_init_pci_offset_180(struct rtl8168_private *tp)
+{
+        if (tp->org_pci_offset_180 & (BIT_0|BIT_1))
+                rtl8168_enable_pci_offset_180(tp);
+        else
+                rtl8168_disable_pci_offset_180(tp);
+}
+
+static void
+rtl8168_set_pci_99_180_exit_driver_para(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                rtl8168_issue_offset_99_event(tp);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                rtl8168_disable_pci_offset_99(tp);
+                break;
+        }
+        switch (tp->mcfg) {
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                rtl8168_disable_pci_offset_180(tp);
+                break;
+        }
+}
+
+static void
+rtl8168_enable_cfg9346_write(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        RTL_W8(Cfg9346, RTL_R8(Cfg9346) | Cfg9346_Unlock);
+}
+
+static void
+rtl8168_disable_cfg9346_write(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        RTL_W8(Cfg9346, RTL_R8(Cfg9346) & ~Cfg9346_Unlock);
+}
+
+static void
+rtl8168_hw_d3_para(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+
+        RTL_W16(RxMaxSize, RX_BUF_SIZE);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                RTL_W8(0xF1, RTL_R8(0xF1) & ~BIT_7);
+                rtl8168_enable_cfg9346_write(tp);
+                RTL_W8(Config2, RTL_R8(Config2) & ~BIT_7);
+                RTL_W8(Config5, RTL_R8(Config5) & ~BIT_0);
+                rtl8168_disable_cfg9346_write(tp);
+                break;
+        }
+
+        if (tp->mcfg == CFG_METHOD_18 || tp->mcfg == CFG_METHOD_19 || tp->mcfg == CFG_METHOD_20) {
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                rtl8168_eri_write(ioaddr, 0x1bc, 4, 0x0000001f, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x1dc, 4, 0x0000002d, ERIAR_ExGMAC);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+        } else if (tp->mcfg == CFG_METHOD_16) {
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                rtl8168_eri_write(ioaddr, 0x1bc, 4, 0x0000001f, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0x1dc, 4, 0x0000003f, ERIAR_ExGMAC);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+        }
+
+        if (tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+            tp->mcfg == CFG_METHOD_23 || tp->mcfg == CFG_METHOD_24 ||
+            tp->mcfg == CFG_METHOD_25 || tp->mcfg == CFG_METHOD_26 ||
+            tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28 ||
+            tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                rtl8168_eri_write(ioaddr, 0x2F8, 2, 0x0064, ERIAR_ExGMAC);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+        }
+
+        if (tp->bios_setting & BIT_28) {
+                if (tp->mcfg == CFG_METHOD_18 || tp->mcfg == CFG_METHOD_19 ||
+                    tp->mcfg == CFG_METHOD_20) {
+                        u32 gphy_val;
+
+                        spin_lock_irqsave(&tp->phy_lock, flags);
+                        mdio_write(tp, 0x1F, 0x0000);
+                        mdio_write(tp, 0x04, 0x0061);
+                        mdio_write(tp, 0x09, 0x0000);
+                        mdio_write(tp, 0x00, 0x9200);
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8B80);
+                        gphy_val = mdio_read(tp, 0x06);
+                        gphy_val &= ~BIT_7;
+                        mdio_write(tp, 0x06, gphy_val);
+                        mdelay(1);
+                        mdio_write(tp, 0x1F, 0x0007);
+                        mdio_write(tp, 0x1E, 0x002C);
+                        gphy_val = mdio_read(tp, 0x16);
+                        gphy_val &= ~BIT_10;
+                        mdio_write(tp, 0x16, gphy_val);
+                        mdio_write(tp, 0x1F, 0x0000);
+                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                }
+        }
+        if (tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                rtl8168_set_dash_other_fun_dev_state_change(tp, 3, 0xFD);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+        }
+
+        rtl8168_set_pci_99_180_exit_driver_para(dev);
+
+        /*disable ocp phy power saving*/
+        if (tp->mcfg == CFG_METHOD_25 || tp->mcfg == CFG_METHOD_26 ||
+            tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28 ||
+            tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30 ||
+            tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write_phy_ocp(tp, 0x0C41, 0x13, 0x0000);
+                mdio_write_phy_ocp(tp, 0x0C41, 0x13, 0x0500);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+        }
+
+        rtl8168_disable_rxdvgate(dev);
+}
+
+static void
+rtl8168_enable_magic_packet(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 csi_tmp;
+
+        switch (tp->HwSuppMagicPktVer) {
+        case WAKEUP_MAGIC_PACKET_V1:
+                rtl8168_enable_cfg9346_write(tp);
+                RTL_W8(Config3, RTL_R8(Config3) | MagicPacket);
+                rtl8168_disable_cfg9346_write(tp);
+                break;
+        case WAKEUP_MAGIC_PACKET_V2:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xDE, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDE, 1, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+}
+static void
+rtl8168_disable_magic_packet(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 csi_tmp;
+
+        switch (tp->HwSuppMagicPktVer) {
+        case WAKEUP_MAGIC_PACKET_V1:
+                rtl8168_enable_cfg9346_write(tp);
+                RTL_W8(Config3, RTL_R8(Config3) & ~MagicPacket);
+                rtl8168_disable_cfg9346_write(tp);
+                break;
+        case WAKEUP_MAGIC_PACKET_V2:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xDE, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDE, 1, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+}
+
+#define WAKE_ANY (WAKE_PHY | WAKE_MAGIC | WAKE_UCAST | WAKE_BCAST | WAKE_MCAST)
+
+static void
+rtl8168_get_hw_wol(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u8 options;
+        u32 csi_tmp;
+        unsigned long flags;
+
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        tp->wol_opts = 0;
+        options = RTL_R8(Config1);
+        if (!(options & PMEnable))
+                goto out_unlock;
+
+        options = RTL_R8(Config3);
+        if (options & LinkUp)
+                tp->wol_opts |= WAKE_PHY;
+
+        switch (tp->HwSuppMagicPktVer) {
+        case WAKEUP_MAGIC_PACKET_V2:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xDE, 1, ERIAR_ExGMAC);
+                if (csi_tmp & BIT_0)
+                        tp->wol_opts |= WAKE_MAGIC;
+                break;
+        default:
+                if (options & MagicPacket)
+                        tp->wol_opts |= WAKE_MAGIC;
+                break;
+        }
+
+        options = RTL_R8(Config5);
+        if (options & UWF)
+                tp->wol_opts |= WAKE_UCAST;
+        if (options & BWF)
+                tp->wol_opts |= WAKE_BCAST;
+        if (options & MWF)
+                tp->wol_opts |= WAKE_MCAST;
+
+out_unlock:
+        tp->wol_enabled = (tp->wol_opts) ? WOL_ENABLED : WOL_DISABLED;
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+static void
+rtl8168_set_hw_wol(struct net_device *dev, u32 wolopts)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        int i,tmp;
+        static struct {
+                u32 opt;
+                u16 reg;
+                u8  mask;
+        } cfg[] = {
+                { WAKE_PHY,   Config3, LinkUp },
+                { WAKE_UCAST, Config5, UWF },
+                { WAKE_BCAST, Config5, BWF },
+                { WAKE_MCAST, Config5, MWF },
+                { WAKE_ANY,   Config5, LanWake },
+                { WAKE_MAGIC, Config3, MagicPacket },
+        };
+
+        switch (tp->HwSuppMagicPktVer) {
+        case WAKEUP_MAGIC_PACKET_V2:
+                tmp = ARRAY_SIZE(cfg) - 1;
+
+                if (wolopts & WAKE_MAGIC)
+                        rtl8168_enable_magic_packet(dev);
+                else
+                        rtl8168_disable_magic_packet(dev);
+                break;
+        default:
+                tmp = ARRAY_SIZE(cfg);
+                break;
+        }
+
+        rtl8168_enable_cfg9346_write(tp);
+
+        for (i = 0; i < tmp; i++) {
+                u8 options = RTL_R8(cfg[i].reg) & ~cfg[i].mask;
+                if (wolopts & cfg[i].opt)
+                        options |= cfg[i].mask;
+                RTL_W8(cfg[i].reg, options);
+        }
+
+        rtl8168_disable_cfg9346_write(tp);
+}
+
+static void
+rtl8168_phy_restart_nway(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        if (rtl8168_is_in_phy_disable_mode(dev)) return;
+
+        mdio_write(tp, 0x1F, 0x0000);
+        mdio_write(tp, MII_BMCR, BMCR_RESET | BMCR_ANENABLE | BMCR_ANRESTART);
+}
+
+static void
+rtl8168_phy_setup_force_mode(struct net_device *dev, u32 speed, u8 duplex)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        u16 bmcr_true_force = 0;
+
+        if (rtl8168_is_in_phy_disable_mode(dev)) return;
+
+        if ((speed == SPEED_10) && (duplex == DUPLEX_HALF)) {
+                bmcr_true_force = BMCR_SPEED10;
+        } else if ((speed == SPEED_10) && (duplex == DUPLEX_FULL)) {
+                bmcr_true_force = BMCR_SPEED10 | BMCR_FULLDPLX;
+        } else if ((speed == SPEED_100) && (duplex == DUPLEX_HALF)) {
+                bmcr_true_force = BMCR_SPEED100;
+        } else if ((speed == SPEED_100) && (duplex == DUPLEX_FULL)) {
+                bmcr_true_force = BMCR_SPEED100 | BMCR_FULLDPLX;
+        } else if ((speed == SPEED_1000) && (duplex == DUPLEX_FULL) &&
+                   tp->HwSuppGigaForceMode) {
+                bmcr_true_force = BMCR_SPEED1000 | BMCR_FULLDPLX;
+        } else {
+                netif_err(tp, drv, dev, "Failed to set phy force mode!\n");
+                return;
+        }
+
+        mdio_write(tp, 0x1F, 0x0000);
+        mdio_write(tp, MII_BMCR, bmcr_true_force);
+}
+
+static void
+rtl8168_powerdown_pll(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        if (tp->wol_enabled == WOL_ENABLED || tp->DASH || tp->EnableKCPOffload) {
+                int auto_nego;
+                int giga_ctrl;
+                u16 val;
+                unsigned long flags;
+
+                rtl8168_set_hw_wol(dev, tp->wol_opts);
+
+                if (tp->mcfg == CFG_METHOD_16 || tp->mcfg == CFG_METHOD_17 ||
+                    tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+                    tp->mcfg == CFG_METHOD_24 || tp->mcfg == CFG_METHOD_25 ||
+                    tp->mcfg == CFG_METHOD_26 || tp->mcfg == CFG_METHOD_23 ||
+                    tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28 ||
+                    tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30 ||
+                    tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                        rtl8168_enable_cfg9346_write(tp);
+                        RTL_W8(Config2, RTL_R8(Config2) | PMSTS_En);
+                        rtl8168_disable_cfg9346_write(tp);
+                }
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0000);
+                auto_nego = mdio_read(tp, MII_ADVERTISE);
+                auto_nego &= ~(ADVERTISE_10HALF | ADVERTISE_10FULL
+                               | ADVERTISE_100HALF | ADVERTISE_100FULL);
+
+                val = mdio_read(tp, MII_LPA);
+
+#ifdef CONFIG_DOWN_SPEED_100
+                auto_nego |= (ADVERTISE_100FULL | ADVERTISE_100HALF | ADVERTISE_10HALF | ADVERTISE_10FULL);
+#else
+                if (val & (LPA_10HALF | LPA_10FULL))
+                        auto_nego |= (ADVERTISE_10HALF | ADVERTISE_10FULL);
+                else
+                        auto_nego |= (ADVERTISE_100FULL | ADVERTISE_100HALF | ADVERTISE_10HALF | ADVERTISE_10FULL);
+#endif
+
+                if (tp->DASH)
+                        auto_nego |= (ADVERTISE_100FULL | ADVERTISE_100HALF | ADVERTISE_10HALF | ADVERTISE_10FULL);
+
+                if (((tp->mcfg == CFG_METHOD_7) || (tp->mcfg == CFG_METHOD_8)) && (RTL_R16(CPlusCmd) & ASF))
+                        auto_nego |= (ADVERTISE_100FULL | ADVERTISE_100HALF | ADVERTISE_10HALF | ADVERTISE_10FULL);
+
+                giga_ctrl = mdio_read(tp, MII_CTRL1000) & ~(ADVERTISE_1000HALF | ADVERTISE_1000FULL);
+                mdio_write(tp, MII_ADVERTISE, auto_nego);
+                mdio_write(tp, MII_CTRL1000, giga_ctrl);
+                rtl8168_phy_restart_nway(dev);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+                RTL_W32(RxConfig, RTL_R32(RxConfig) | AcceptBroadcast | AcceptMulticast | AcceptMyPhys);
+
+                return;
+        }
+
+        if (tp->DASH)
+                return;
+
+        if (((tp->mcfg == CFG_METHOD_7) || (tp->mcfg == CFG_METHOD_8)) && (RTL_R16(CPlusCmd) & ASF))
+                return;
+
+        rtl8168_phy_power_down(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_9:
+        case CFG_METHOD_10:
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+        case CFG_METHOD_13:
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                RTL_W8(PMCH, RTL_R8(PMCH) & ~BIT_7);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                RTL_W8(0xD0, RTL_R8(0xD0) & ~BIT_6);
+                RTL_W8(0xF2, RTL_R8(0xF2) & ~BIT_6);
+                break;
+        }
+}
+
+static void rtl8168_powerup_pll(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_9:
+        case CFG_METHOD_10:
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+        case CFG_METHOD_13:
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                RTL_W8(PMCH, RTL_R8(PMCH) | BIT_7 | BIT_6);
+                break;
+        }
+
+        rtl8168_phy_power_up(dev);
+}
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static void
+rtl8168_get_wol(struct net_device *dev,
+                struct ethtool_wolinfo *wol)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u8 options;
+        unsigned long flags;
+
+        wol->wolopts = 0;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT) {
+                wol->supported = 0;
+                return;
+        } else {
+                wol->supported = WAKE_ANY;
+        }
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        options = RTL_R8(Config1);
+        if (!(options & PMEnable))
+                goto out_unlock;
+
+        wol->wolopts = tp->wol_opts;
+
+out_unlock:
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+static int
+rtl8168_set_wol(struct net_device *dev,
+                struct ethtool_wolinfo *wol)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                return -EOPNOTSUPP;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        tp->wol_opts = wol->wolopts;
+
+        tp->wol_enabled = (tp->wol_opts) ? WOL_ENABLED : WOL_DISABLED;
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        device_set_wakeup_enable(&tp->pci_dev->dev, wol->wolopts);
+
+        return 0;
+}
+
+static void
+rtl8168_get_drvinfo(struct net_device *dev,
+                    struct ethtool_drvinfo *info)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        strcpy(info->driver, MODULENAME);
+        strcpy(info->version, RTL8168_VERSION);
+        strcpy(info->bus_info, pci_name(tp->pci_dev));
+        info->regdump_len = R8168_REGS_DUMP_SIZE;
+        info->eedump_len = tp->eeprom_len;
+}
+
+static int
+rtl8168_get_regs_len(struct net_device *dev)
+{
+        return R8168_REGS_DUMP_SIZE;
+}
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+
+static int
+rtl8168_set_speed_xmii(struct net_device *dev,
+                       u8 autoneg,
+                       u32 speed,
+                       u8 duplex,
+                       u32 adv)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        int auto_nego = 0;
+        int giga_ctrl = 0;
+        unsigned long flags;
+        int rc = -EINVAL;
+
+        if (tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30 ||
+            tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                //Disable Giga Lite
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A42);
+                ClearEthPhyBit(tp, 0x14, BIT_9);
+                if (tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32)
+                        ClearEthPhyBit(tp, 0x14, BIT_7);
+                mdio_write(tp, 0x1F, 0x0A40);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+        }
+
+        if ((speed != SPEED_1000) &&
+            (speed != SPEED_100) &&
+            (speed != SPEED_10)) {
+                speed = SPEED_1000;
+                duplex = DUPLEX_FULL;
+        }
+
+        giga_ctrl = mdio_read(tp, MII_CTRL1000);
+        giga_ctrl &= ~(ADVERTISE_1000HALF | ADVERTISE_1000FULL);
+
+        if (autoneg == AUTONEG_ENABLE) {
+                /*n-way force*/
+                auto_nego = mdio_read(tp, MII_ADVERTISE);
+                auto_nego &= ~(ADVERTISE_10HALF | ADVERTISE_10FULL |
+                               ADVERTISE_100HALF | ADVERTISE_100FULL |
+                               ADVERTISE_PAUSE_CAP | ADVERTISE_PAUSE_ASYM);
+
+                if (adv & ADVERTISED_10baseT_Half)
+                        auto_nego |= ADVERTISE_10HALF;
+                if (adv & ADVERTISED_10baseT_Full)
+                        auto_nego |= ADVERTISE_10FULL;
+                if (adv & ADVERTISED_100baseT_Half)
+                        auto_nego |= ADVERTISE_100HALF;
+                if (adv & ADVERTISED_100baseT_Full)
+                        auto_nego |= ADVERTISE_100FULL;
+                if (adv & ADVERTISED_1000baseT_Half)
+                        giga_ctrl |= ADVERTISE_1000HALF;
+                if (adv & ADVERTISED_1000baseT_Full)
+                        giga_ctrl |= ADVERTISE_1000FULL;
+
+                //flow control
+                if (dev->mtu <= ETH_DATA_LEN)
+                        auto_nego |= ADVERTISE_PAUSE_CAP|ADVERTISE_PAUSE_ASYM;
+
+                tp->phy_auto_nego_reg = auto_nego;
+                tp->phy_1000_ctrl_reg = giga_ctrl;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, MII_ADVERTISE, auto_nego);
+                mdio_write(tp, MII_CTRL1000, giga_ctrl);
+                rtl8168_phy_restart_nway(dev);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                mdelay(20);
+        } else {
+                /*true force*/
+                if (speed == SPEED_10 || speed == SPEED_100 ||
+                    (speed == SPEED_1000 && duplex == DUPLEX_FULL &&
+                     tp->HwSuppGigaForceMode)) {
+                        spin_lock_irqsave(&tp->phy_lock, flags);
+                        rtl8168_phy_setup_force_mode(dev, speed, duplex);
+                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                } else
+                        goto out;
+        }
+
+        tp->autoneg = autoneg;
+        tp->speed = speed;
+        tp->duplex = duplex;
+        tp->advertising = adv;
+
+        if (tp->mcfg == CFG_METHOD_11)
+                rtl8168dp_10mbps_gphy_para(dev);
+
+        rc = 0;
+out:
+        return rc;
+}
+
+static int
+rtl8168_set_speed(struct net_device *dev,
+                  u8 autoneg,
+                  u32 speed,
+                  u8 duplex,
+                  u32 adv)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        int ret;
+
+        ret = tp->set_speed(dev, autoneg, speed, duplex, adv);
+
+        return ret;
+}
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static int
+rtl8168_set_settings(struct net_device *dev,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+                     struct ethtool_cmd *cmd
+#else
+                     const struct ethtool_link_ksettings *cmd
+#endif
+                    )
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        int ret;
+        unsigned long flags;
+        u8 autoneg;
+        u32 speed;
+        u8 duplex;
+        u32 supported, advertising;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+        autoneg = cmd->autoneg;
+        speed = cmd->speed;
+        duplex = cmd->duplex;
+        supported = cmd->supported;
+        advertising = cmd->advertising;
+#else
+        const struct ethtool_link_settings *base = &cmd->base;
+        autoneg = base->autoneg;
+        speed = base->speed;
+        duplex = base->duplex;
+        ethtool_convert_link_mode_to_legacy_u32(&supported,
+                                                cmd->link_modes.supported);
+        ethtool_convert_link_mode_to_legacy_u32(&advertising,
+                                                cmd->link_modes.advertising);
+#endif
+        if (advertising & ~supported)
+                return -EINVAL;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        ret = rtl8168_set_speed(dev, autoneg, speed, duplex, advertising);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return ret;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+static u32
+rtl8168_get_tx_csum(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        u32 ret;
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        ret = ((dev->features & NETIF_F_IP_CSUM) != 0);
+#else
+        ret = ((dev->features & (NETIF_F_IP_CSUM | NETIF_F_IPV6_CSUM)) != 0);
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return ret;
+}
+
+static u32
+rtl8168_get_rx_csum(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        u32 ret;
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        ret = tp->cp_cmd & RxChkSum;
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return ret;
+}
+
+static int
+rtl8168_set_tx_csum(struct net_device *dev,
+                    u32 data)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                return -EOPNOTSUPP;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        if (data)
+                dev->features |= NETIF_F_IP_CSUM;
+        else
+                dev->features &= ~NETIF_F_IP_CSUM;
+#else
+        if (data)
+                if ((tp->mcfg == CFG_METHOD_1) || (tp->mcfg == CFG_METHOD_2) || (tp->mcfg == CFG_METHOD_3))
+                        dev->features |= NETIF_F_IP_CSUM;
+                else
+                        dev->features |= (NETIF_F_IP_CSUM | NETIF_F_IPV6_CSUM);
+        else
+                dev->features &= ~(NETIF_F_IP_CSUM | NETIF_F_IPV6_CSUM);
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return 0;
+}
+
+static int
+rtl8168_set_rx_csum(struct net_device *dev,
+                    u32 data)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                return -EOPNOTSUPP;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        if (data)
+                tp->cp_cmd |= RxChkSum;
+        else
+                tp->cp_cmd &= ~RxChkSum;
+
+        RTL_W16(CPlusCmd, tp->cp_cmd);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return 0;
+}
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+
+#ifdef CONFIG_R8168_VLAN
+
+static inline u32
+rtl8168_tx_vlan_tag(struct rtl8168_private *tp,
+                    struct sk_buff *skb)
+{
+        u32 tag;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        tag = (tp->vlgrp && vlan_tx_tag_present(skb)) ?
+              TxVlanTag | swab16(vlan_tx_tag_get(skb)) : 0x00;
+#elif LINUX_VERSION_CODE < KERNEL_VERSION(4,0,0)
+        tag = (vlan_tx_tag_present(skb)) ?
+              TxVlanTag | swab16(vlan_tx_tag_get(skb)) : 0x00;
+#else
+        tag = (skb_vlan_tag_present(skb)) ?
+              TxVlanTag | swab16(skb_vlan_tag_get(skb)) : 0x00;
+#endif
+
+        return tag;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+
+static void
+rtl8168_vlan_rx_register(struct net_device *dev,
+                         struct vlan_group *grp)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        tp->vlgrp = grp;
+        if (tp->vlgrp)
+                tp->cp_cmd |= RxVlan;
+        else
+                tp->cp_cmd &= ~RxVlan;
+        RTL_W16(CPlusCmd, tp->cp_cmd);
+        RTL_R16(CPlusCmd);
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+static void
+rtl8168_vlan_rx_kill_vid(struct net_device *dev,
+                         unsigned short vid)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,21)
+        if (tp->vlgrp)
+                tp->vlgrp->vlan_devices[vid] = NULL;
+#else
+        vlan_group_set_device(tp->vlgrp, vid, NULL);
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,21)
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+
+static int
+rtl8168_rx_vlan_skb(struct rtl8168_private *tp,
+                    struct RxDesc *desc,
+                    struct sk_buff *skb)
+{
+        u32 opts2 = le32_to_cpu(desc->opts2);
+        int ret = -1;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        if (tp->vlgrp && (opts2 & RxVlanTag)) {
+                rtl8168_rx_hwaccel_skb(skb, tp->vlgrp,
+                                       swab16(opts2 & 0xffff));
+                ret = 0;
+        }
+#elif LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0)
+        if (opts2 & RxVlanTag)
+                __vlan_hwaccel_put_tag(skb, swab16(opts2 & 0xffff));
+#else
+        if (opts2 & RxVlanTag)
+                __vlan_hwaccel_put_tag(skb, htons(ETH_P_8021Q), swab16(opts2 & 0xffff));
+#endif
+
+        desc->opts2 = 0;
+        return ret;
+}
+
+#else /* !CONFIG_R8168_VLAN */
+
+static inline u32
+rtl8168_tx_vlan_tag(struct rtl8168_private *tp,
+                    struct sk_buff *skb)
+{
+        return 0;
+}
+
+static int
+rtl8168_rx_vlan_skb(struct rtl8168_private *tp,
+                    struct RxDesc *desc,
+                    struct sk_buff *skb)
+{
+        return -1;
+}
+
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,0,0)
+
+static netdev_features_t rtl8168_fix_features(struct net_device *dev,
+                netdev_features_t features)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        if (dev->mtu > MSS_MAX)
+                features &= ~NETIF_F_ALL_TSO;
+        if (dev->mtu > ETH_DATA_LEN) {
+                features &= ~NETIF_F_ALL_TSO;
+                features &= ~NETIF_F_ALL_CSUM;
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return features;
+}
+
+static int rtl8168_hw_set_features(struct net_device *dev,
+                                   netdev_features_t features)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 rx_config;
+
+        rx_config = RTL_R32(RxConfig);
+        if (features & NETIF_F_RXALL)
+                rx_config |= (AcceptErr | AcceptRunt);
+        else
+                rx_config &= ~(AcceptErr | AcceptRunt);
+
+        RTL_W32(RxConfig, rx_config);
+
+        if (features & NETIF_F_RXCSUM)
+                tp->cp_cmd |= RxChkSum;
+        else
+                tp->cp_cmd &= ~RxChkSum;
+
+        if (dev->features & NETIF_F_HW_VLAN_RX)
+                tp->cp_cmd |= RxVlan;
+        else
+                tp->cp_cmd &= ~RxVlan;
+
+        RTL_W16(CPlusCmd, tp->cp_cmd);
+        RTL_R16(CPlusCmd);
+
+        return 0;
+}
+
+static int rtl8168_set_features(struct net_device *dev,
+                                netdev_features_t features)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        features &= NETIF_F_RXALL | NETIF_F_RXCSUM | NETIF_F_HW_VLAN_RX;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        if (features ^ dev->features)
+                rtl8168_hw_set_features(dev, features);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return 0;
+}
+
+#endif
+
+static void rtl8168_gset_xmii(struct net_device *dev,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+                              struct ethtool_cmd *cmd
+#else
+                              struct ethtool_link_ksettings *cmd
+#endif
+                             )
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u8 status;
+        u8 autoneg, duplex;
+        u32 speed = 0;
+        u16 bmcr, bmsr, anlpar, ctrl1000 = 0, stat1000 = 0;
+        u32 supported, advertising, lp_advertising;
+        unsigned long flags;
+
+        supported = SUPPORTED_10baseT_Half |
+                    SUPPORTED_10baseT_Full |
+                    SUPPORTED_100baseT_Half |
+                    SUPPORTED_100baseT_Full |
+                    SUPPORTED_1000baseT_Full |
+                    SUPPORTED_Autoneg |
+                    SUPPORTED_TP |
+                    SUPPORTED_Pause	|
+                    SUPPORTED_Asym_Pause;
+
+        advertising = ADVERTISED_TP;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+        mdio_write(tp, 0x1F, 0x0000);
+        bmcr = mdio_read(tp, MII_BMCR);
+        bmsr = mdio_read(tp, MII_BMSR);
+        anlpar = mdio_read(tp, MII_LPA);
+        ctrl1000 = mdio_read(tp, MII_CTRL1000);
+        stat1000 = mdio_read(tp, MII_STAT1000);
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+        if (bmcr & BMCR_ANENABLE) {
+                advertising |= ADVERTISED_Autoneg;
+                autoneg = AUTONEG_ENABLE;
+
+                if (bmsr & BMSR_ANEGCOMPLETE) {
+                        lp_advertising = mii_lpa_to_ethtool_lpa_t(anlpar);
+                        lp_advertising |=
+                                mii_stat1000_to_ethtool_lpa_t(stat1000);
+                } else {
+                        lp_advertising = 0;
+                }
+
+                if (tp->phy_auto_nego_reg & ADVERTISE_10HALF)
+                        advertising |= ADVERTISED_10baseT_Half;
+                if (tp->phy_auto_nego_reg & ADVERTISE_10FULL)
+                        advertising |= ADVERTISED_10baseT_Full;
+                if (tp->phy_auto_nego_reg & ADVERTISE_100HALF)
+                        advertising |= ADVERTISED_100baseT_Half;
+                if (tp->phy_auto_nego_reg & ADVERTISE_100FULL)
+                        advertising |= ADVERTISED_100baseT_Full;
+                if (tp->phy_1000_ctrl_reg & ADVERTISE_1000FULL)
+                        advertising |= ADVERTISED_1000baseT_Full;
+        } else {
+                autoneg = AUTONEG_DISABLE;
+                lp_advertising = 0;
+        }
+
+        status = RTL_R8(PHYstatus);
+
+        if (status & LinkStatus) {
+                /*link on*/
+                if (status & _1000bpsF)
+                        speed = SPEED_1000;
+                else if (status & _100bps)
+                        speed = SPEED_100;
+                else if (status & _10bps)
+                        speed = SPEED_10;
+
+                if (status & TxFlowCtrl)
+                        advertising |= ADVERTISED_Asym_Pause;
+
+                if (status & RxFlowCtrl)
+                        advertising |= ADVERTISED_Pause;
+
+                duplex = ((status & _1000bpsF) || (status & FullDup)) ?
+                         DUPLEX_FULL : DUPLEX_HALF;
+        } else {
+                /*link down*/
+                speed = SPEED_UNKNOWN;
+                duplex = DUPLEX_UNKNOWN;
+        }
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+        cmd->supported = supported;
+        cmd->advertising = advertising;
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,30)
+        cmd->lp_advertising = lp_advertising;
+#endif
+        cmd->autoneg = autoneg;
+        cmd->speed = speed;
+        cmd->duplex = duplex;
+        cmd->port = PORT_TP;
+#else
+        ethtool_convert_legacy_u32_to_link_mode(cmd->link_modes.supported,
+                                                supported);
+        ethtool_convert_legacy_u32_to_link_mode(cmd->link_modes.advertising,
+                                                advertising);
+        ethtool_convert_legacy_u32_to_link_mode(cmd->link_modes.lp_advertising,
+                                                lp_advertising);
+        cmd->base.autoneg = autoneg;
+        cmd->base.speed = speed;
+        cmd->base.duplex = duplex;
+        cmd->base.port = PORT_TP;
+#endif
+}
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static int
+rtl8168_get_settings(struct net_device *dev,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+                     struct ethtool_cmd *cmd
+#else
+                     struct ethtool_link_ksettings *cmd
+#endif
+                    )
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        tp->get_settings(dev, cmd);
+
+        return 0;
+}
+
+static void rtl8168_get_regs(struct net_device *dev, struct ethtool_regs *regs,
+                             void *p)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned int i;
+        u8 *data = p;
+        unsigned long flags;
+
+        if (regs->len < R8168_REGS_DUMP_SIZE)
+                return /* -EINVAL */;
+
+        memset(p, 0, regs->len);
+
+        spin_lock_irqsave(&tp->lock, flags);
+        for (i = 0; i < R8168_MAC_REGS_SIZE; i++)
+                *data++ = readb(ioaddr + i);
+        spin_unlock_irqrestore(&tp->lock, flags);
+        data = (u8*)p + 256;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+        mdio_write(tp, 0x1F, 0x0000);
+        for (i = 0; i < R8168_PHY_REGS_SIZE/2; i++) {
+                *(u16*)data = mdio_read(tp, i);
+                data += 2;
+        }
+        data = (u8*)p + 256 * 2;
+
+        for (i = 0; i < R8168_EPHY_REGS_SIZE/2; i++) {
+                *(u16*)data = rtl8168_ephy_read(ioaddr, i);
+                data += 2;
+        }
+        data = (u8*)p + 256 * 3;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_1:
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+                /* RTL8168B does not support Extend GMAC */
+                break;
+        default:
+                for (i = 0; i < R8168_ERI_REGS_SIZE; i+=4) {
+                        *(u32*)data = rtl8168_eri_read(ioaddr, i , 4, ERIAR_ExGMAC);
+                        data += 4;
+                }
+                break;
+        }
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+}
+
+static u32
+rtl8168_get_msglevel(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        return tp->msg_enable;
+}
+
+static void
+rtl8168_set_msglevel(struct net_device *dev,
+                     u32 value)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        tp->msg_enable = value;
+}
+
+static const char rtl8168_gstrings[][ETH_GSTRING_LEN] = {
+        "tx_packets",
+        "rx_packets",
+        "tx_errors",
+        "rx_errors",
+        "rx_missed",
+        "align_errors",
+        "tx_single_collisions",
+        "tx_multi_collisions",
+        "unicast",
+        "broadcast",
+        "multicast",
+        "tx_aborted",
+        "tx_underrun",
+};
+#endif //#LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,33)
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static int rtl8168_get_stats_count(struct net_device *dev)
+{
+        return ARRAY_SIZE(rtl8168_gstrings);
+}
+#endif //#LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+#else
+static int rtl8168_get_sset_count(struct net_device *dev, int sset)
+{
+        switch (sset) {
+        case ETH_SS_STATS:
+                return ARRAY_SIZE(rtl8168_gstrings);
+        default:
+                return -EOPNOTSUPP;
+        }
+}
+#endif
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static void
+rtl8168_get_ethtool_stats(struct net_device *dev,
+                          struct ethtool_stats *stats,
+                          u64 *data)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        struct rtl8168_counters *counters;
+        dma_addr_t paddr;
+        u32 cmd;
+        u32 WaitCnt;
+        unsigned long flags;
+
+        ASSERT_RTNL();
+
+        counters = tp->tally_vaddr;
+        paddr = tp->tally_paddr;
+        if (!counters)
+                return;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        RTL_W32(CounterAddrHigh, (u64)paddr >> 32);
+        cmd = (u64)paddr & DMA_BIT_MASK(32);
+        RTL_W32(CounterAddrLow, cmd);
+        RTL_W32(CounterAddrLow, cmd | CounterDump);
+
+        WaitCnt = 0;
+        while (RTL_R32(CounterAddrLow) & CounterDump) {
+                udelay(10);
+
+                WaitCnt++;
+                if (WaitCnt > 20)
+                        break;
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        data[0] = le64_to_cpu(counters->tx_packets);
+        data[1] = le64_to_cpu(counters->rx_packets);
+        data[2] = le64_to_cpu(counters->tx_errors);
+        data[3] = le32_to_cpu(counters->rx_errors);
+        data[4] = le16_to_cpu(counters->rx_missed);
+        data[5] = le16_to_cpu(counters->align_errors);
+        data[6] = le32_to_cpu(counters->tx_one_collision);
+        data[7] = le32_to_cpu(counters->tx_multi_collision);
+        data[8] = le64_to_cpu(counters->rx_unicast);
+        data[9] = le64_to_cpu(counters->rx_broadcast);
+        data[10] = le32_to_cpu(counters->rx_multicast);
+        data[11] = le16_to_cpu(counters->tx_aborted);
+        data[12] = le16_to_cpu(counters->tx_underun);
+}
+
+static void
+rtl8168_get_strings(struct net_device *dev,
+                    u32 stringset,
+                    u8 *data)
+{
+        switch (stringset) {
+        case ETH_SS_STATS:
+                memcpy(data, *rtl8168_gstrings, sizeof(rtl8168_gstrings));
+                break;
+        }
+}
+#endif //#LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+
+static int rtl_get_eeprom_len(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        return tp->eeprom_len;
+}
+
+static int rtl_get_eeprom(struct net_device *dev, struct ethtool_eeprom *eeprom, u8 *buf)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        int i,j,ret;
+        int start_w, end_w;
+        int VPD_addr, VPD_data;
+        u32 *eeprom_buff;
+        u16 tmp;
+
+        if (tp->eeprom_type == EEPROM_TYPE_NONE) {
+                dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Detect none EEPROM\n");
+                return -EOPNOTSUPP;
+        } else if (eeprom->len == 0 || (eeprom->offset+eeprom->len) > tp->eeprom_len) {
+                dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Invalid parameter\n");
+                return -EINVAL;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_9:
+        case CFG_METHOD_10:
+                VPD_addr = 0xCE;
+                VPD_data = 0xD0;
+                break;
+
+        case CFG_METHOD_1:
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+        case CFG_METHOD_13:
+                return -EOPNOTSUPP;
+        default:
+                VPD_addr = 0xD2;
+                VPD_data = 0xD4;
+                break;
+        }
+
+        start_w = eeprom->offset >> 2;
+        end_w = (eeprom->offset + eeprom->len - 1) >> 2;
+
+        eeprom_buff = kmalloc(sizeof(u32)*(end_w - start_w + 1), GFP_KERNEL);
+        if (!eeprom_buff)
+                return -ENOMEM;
+
+        rtl8168_enable_cfg9346_write(tp);
+        ret = -EFAULT;
+        for (i=start_w; i<=end_w; i++) {
+                pci_write_config_word(tp->pci_dev, VPD_addr, (u16)i*4);
+                ret = -EFAULT;
+                for (j = 0; j < 10; j++) {
+                        udelay(400);
+                        pci_read_config_word(tp->pci_dev, VPD_addr, &tmp);
+                        if (tmp&0x8000) {
+                                ret = 0;
+                                break;
+                        }
+                }
+
+                if (ret)
+                        break;
+
+                pci_read_config_dword(tp->pci_dev, VPD_data, &eeprom_buff[i-start_w]);
+        }
+        rtl8168_disable_cfg9346_write(tp);
+
+        if (!ret)
+                memcpy(buf, (u8 *)eeprom_buff + (eeprom->offset & 3), eeprom->len);
+
+        kfree(eeprom_buff);
+
+        return ret;
+}
+
+#undef ethtool_op_get_link
+#define ethtool_op_get_link _kc_ethtool_op_get_link
+u32 _kc_ethtool_op_get_link(struct net_device *dev)
+{
+        return netif_carrier_ok(dev) ? 1 : 0;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+#undef ethtool_op_get_sg
+#define ethtool_op_get_sg _kc_ethtool_op_get_sg
+u32 _kc_ethtool_op_get_sg(struct net_device *dev)
+{
+#ifdef NETIF_F_SG
+        return (dev->features & NETIF_F_SG) != 0;
+#else
+        return 0;
+#endif
+}
+
+#undef ethtool_op_set_sg
+#define ethtool_op_set_sg _kc_ethtool_op_set_sg
+int _kc_ethtool_op_set_sg(struct net_device *dev, u32 data)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                return -EOPNOTSUPP;
+
+#ifdef NETIF_F_SG
+        if (data)
+                dev->features |= NETIF_F_SG;
+        else
+                dev->features &= ~NETIF_F_SG;
+#endif
+
+        return 0;
+}
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+static int
+rtl_ethtool_get_eee(struct net_device *net, struct ethtool_eee *eee)
+{
+        struct rtl8168_private *tp = netdev_priv(net);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 lp, adv, supported = 0;
+        unsigned long flags;
+        u16 val;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                break;
+        default:
+                return -EOPNOTSUPP;
+        }
+
+        if (unlikely(tp->rtk_enable_diag))
+                return -EBUSY;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+
+        mdio_write(tp, 0x1F, 0x0A5C);
+        val = mdio_read(tp, 0x12);
+        supported = mmd_eee_cap_to_ethtool_sup_t(val);
+
+        mdio_write(tp, 0x1F, 0x0A5D);
+        val = mdio_read(tp, 0x10);
+        adv = mmd_eee_adv_to_ethtool_adv_t(val);
+
+        val = mdio_read(tp, 0x11);
+        lp = mmd_eee_adv_to_ethtool_adv_t(val);
+
+        val = rtl8168_eri_read(ioaddr, 0x1B0, 2, ERIAR_ExGMAC);
+        val &= BIT_1 | BIT_0;
+
+        mdio_write(tp, 0x1F, 0x0000);
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+        eee->eee_enabled = !!val;
+        eee->eee_active = !!(supported & adv & lp);
+        eee->supported = supported;
+        eee->advertised = adv;
+        eee->lp_advertised = lp;
+
+        return 0;
+}
+
+static int
+rtl_ethtool_set_eee(struct net_device *net, struct ethtool_eee *eee)
+{
+        struct rtl8168_private *tp = netdev_priv(net);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+        u32 data;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                break;
+        default:
+                return -EOPNOTSUPP;
+        }
+
+        if (unlikely(tp->rtk_enable_diag))
+                return -EBUSY;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+
+        data = rtl8168_eri_read(ioaddr, 0x1B0, 4, ERIAR_ExGMAC);
+        if (eee->eee_enabled) {
+                data |= BIT_1 | BIT_0;
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, data, ERIAR_ExGMAC);
+                mdio_write(tp, 0x1F, 0x0A43);
+                data = mdio_read(tp, 0x11);
+                mdio_write(tp, 0x11, data | BIT_4);
+                data = ethtool_adv_to_mmd_eee_adv_t(eee->advertised);
+                mdio_write(tp, 0x1F, 0x0A5D);
+                mdio_write(tp, 0x10, data);
+        } else {
+                data &= ~(BIT_1 | BIT_0);
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, data, ERIAR_ExGMAC);
+                mdio_write(tp, 0x1F, 0x0A43);
+                data = mdio_read(tp, 0x11);
+                mdio_write(tp, 0x11, data & ~BIT_4);
+                mdio_write(tp, 0x1F, 0x0A5D);
+                mdio_write(tp, 0x10, 0x0000);
+        }
+
+        mdio_write(tp, 0x1F, 0x0000);
+        data = mdio_read(tp, MII_BMCR);
+        data |= BMCR_RESET;
+        mdio_write(tp, MII_BMCR, data);
+
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+        return 0;
+}
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+
+static int rtl_nway_reset(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+        int ret, bmcr;
+
+        if (unlikely(tp->rtk_enable_diag))
+                return -EBUSY;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+
+        /* if autoneg is off, it's an error */
+        mdio_write(tp, 0x1F, 0x0000);
+        bmcr = mdio_read(tp, MII_BMCR);
+
+        if (bmcr & BMCR_ANENABLE) {
+                bmcr |= BMCR_ANRESTART;
+                mdio_write(tp, MII_BMCR, bmcr);
+                ret = 0;
+        } else {
+                ret = -EINVAL;
+        }
+
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+        return ret;
+}
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+static const struct ethtool_ops rtl8168_ethtool_ops = {
+        .get_drvinfo        = rtl8168_get_drvinfo,
+        .get_regs_len       = rtl8168_get_regs_len,
+        .get_link       = ethtool_op_get_link,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,6,0)
+        .get_settings       = rtl8168_get_settings,
+        .set_settings       = rtl8168_set_settings,
+#else
+        .get_link_ksettings       = rtl8168_get_settings,
+        .set_link_ksettings       = rtl8168_set_settings,
+#endif
+        .get_msglevel       = rtl8168_get_msglevel,
+        .set_msglevel       = rtl8168_set_msglevel,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+        .get_rx_csum        = rtl8168_get_rx_csum,
+        .set_rx_csum        = rtl8168_set_rx_csum,
+        .get_tx_csum        = rtl8168_get_tx_csum,
+        .set_tx_csum        = rtl8168_set_tx_csum,
+        .get_sg         = ethtool_op_get_sg,
+        .set_sg         = ethtool_op_set_sg,
+#ifdef NETIF_F_TSO
+        .get_tso        = ethtool_op_get_tso,
+        .set_tso        = ethtool_op_set_tso,
+#endif
+#endif
+        .get_regs       = rtl8168_get_regs,
+        .get_wol        = rtl8168_get_wol,
+        .set_wol        = rtl8168_set_wol,
+        .get_strings        = rtl8168_get_strings,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,33)
+        .get_stats_count    = rtl8168_get_stats_count,
+#else
+        .get_sset_count     = rtl8168_get_sset_count,
+#endif
+        .get_ethtool_stats  = rtl8168_get_ethtool_stats,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,23)
+#ifdef ETHTOOL_GPERMADDR
+        .get_perm_addr      = ethtool_op_get_perm_addr,
+#endif
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,23)
+        .get_eeprom     = rtl_get_eeprom,
+        .get_eeprom_len     = rtl_get_eeprom_len,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,5,0)
+        .get_ts_info        = ethtool_op_get_ts_info,
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(3,5,0)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+        .get_eee = rtl_ethtool_get_eee,
+        .set_eee = rtl_ethtool_set_eee,
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+        .nway_reset = rtl_nway_reset,
+};
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+
+static int rtl8168_enable_EEE(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        int ret;
+        u16 data;
+        u16 PhyRegValue;
+        u32 csi_tmp;
+        u32 WaitCnt;
+        unsigned long flags;
+
+        ret = 0;
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x0020);
+                data = mdio_read(tp, 0x15) | 0x0100;
+                mdio_write(tp, 0x15, data);
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B85);
+                data = mdio_read(tp, 0x06) | 0x2000;
+                mdio_write(tp, 0x06, data);
+                mdio_write(tp, 0x1F, 0x0006);
+                mdio_write(tp, 0x00, 0x5A30);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x0D, 0x0007);
+                mdio_write(tp, 0x0E, 0x003C);
+                mdio_write(tp, 0x0D, 0x4007);
+                mdio_write(tp, 0x0E, 0x0006);
+                mdio_write(tp, 0x0D, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                if ((RTL_R8(Config4)&0x40) && (RTL_R8(0x6D) & BIT_7)) {
+                        spin_lock_irqsave(&tp->phy_lock, flags);
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8AC8);
+                        mdio_write(tp, 0x06, RTL_R16(tp->NicCustLedValue));
+                        mdio_write(tp, 0x05, 0x8B82);
+                        data = mdio_read(tp, 0x06) | 0x0010;
+                        mdio_write(tp, 0x05, 0x8B82);
+                        mdio_write(tp, 0x06, data);
+                        mdio_write(tp, 0x1F, 0x0000);
+                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                }
+                break;
+
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 4, ERIAR_ExGMAC) | 0x0003;
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, csi_tmp, ERIAR_ExGMAC);
+                mdio_write(tp,0x1F , 0x0004);
+                mdio_write(tp,0x1F , 0x0007);
+                mdio_write(tp,0x1E , 0x0020);
+                data = mdio_read(tp, 0x15)|0x0100;
+                mdio_write(tp,0x15 , data);
+                mdio_write(tp,0x1F , 0x0002);
+                mdio_write(tp,0x1F , 0x0005);
+                mdio_write(tp,0x05 , 0x8B85);
+                data = mdio_read(tp, 0x06)|0x2000;
+                mdio_write(tp,0x06 , data);
+                mdio_write(tp,0x1F , 0x0000);
+                mdio_write(tp,0x0D , 0x0007);
+                mdio_write(tp,0x0E , 0x003C);
+                mdio_write(tp,0x0D , 0x4007);
+                mdio_write(tp,0x0E , 0x0006);
+                mdio_write(tp,0x0D , 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 4, ERIAR_ExGMAC);
+                csi_tmp |= BIT_1 | BIT_0;
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, csi_tmp, ERIAR_ExGMAC);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1e, 0x0020);
+                data = mdio_read(tp, 0x15);
+                data |= BIT_8;
+                mdio_write(tp, 0x15, data);
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B85);
+                data = mdio_read(tp, 0x06);
+                data |= BIT_13;
+                mdio_write(tp, 0x06, data);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x0D, 0x0007);
+                mdio_write(tp, 0x0E, 0x003C);
+                mdio_write(tp, 0x0D, 0x4007);
+                mdio_write(tp, 0x0E, 0x0006);
+                mdio_write(tp, 0x0D, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 4, ERIAR_ExGMAC);
+                csi_tmp |= BIT_1 | BIT_0;
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, csi_tmp, ERIAR_ExGMAC);
+                mdio_write(tp, 0x1F, 0x0A43);
+                data = mdio_read(tp, 0x11);
+                mdio_write(tp, 0x11, data | BIT_4);
+                mdio_write(tp, 0x1F, 0x0A5D);
+                mdio_write(tp, 0x10, 0x0006);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        default:
+//      dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Not Support EEE\n");
+                ret = -EOPNOTSUPP;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A4A);
+                SetEthPhyBit(tp, 0x11, BIT_9);
+                mdio_write(tp, 0x1F, 0x0A42);
+                SetEthPhyBit(tp, 0x14, BIT_7);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        }
+
+        /*Advanced EEE*/
+        switch (tp->mcfg) {
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp,0x1F, 0x0B82);
+                SetEthPhyBit(tp, 0x10, BIT_4);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp,0x1F, 0x0B80);
+                WaitCnt = 0;
+                do {
+                        PhyRegValue = mdio_read(tp, 0x10);
+                        PhyRegValue &= 0x0040;
+                        udelay(100);
+                        WaitCnt++;
+                } while(PhyRegValue != 0x0040 && WaitCnt <1000);
+
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_25:
+                rtl8168_eri_write(ioaddr, 0x1EA, 1, 0xFA, ERIAR_ExGMAC);
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A43);
+                data = mdio_read(tp, 0x10);
+                if (data & BIT_10) {
+                        mdio_write(tp, 0x1F, 0x0A42);
+                        data = mdio_read(tp, 0x16);
+                        data &= ~(BIT_1);
+                        mdio_write(tp, 0x16, data);
+                } else {
+                        mdio_write(tp, 0x1F, 0x0A42);
+                        data = mdio_read(tp, 0x16);
+                        data |= BIT_1;
+                        mdio_write(tp, 0x16, data);
+                }
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        case CFG_METHOD_26:
+                data = mac_ocp_read(tp, 0xE052);
+                data |= BIT_0;
+                mac_ocp_write(tp, 0xE052, data);
+                data = mac_ocp_read(tp, 0xE056);
+                data &= 0xFF0F;
+                data |= (BIT_4 | BIT_5 | BIT_6);
+                mac_ocp_write(tp, 0xE056, data);
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A43);
+                data = mdio_read(tp, 0x10);
+                if (data & BIT_10) {
+                        mdio_write(tp, 0x1F, 0x0A42);
+                        data = mdio_read(tp, 0x16);
+                        data &= ~(BIT_1);
+                        mdio_write(tp, 0x16, data);
+                } else {
+                        mdio_write(tp, 0x1F, 0x0A42);
+                        data = mdio_read(tp, 0x16);
+                        data |= BIT_1;
+                        mdio_write(tp, 0x16, data);
+                }
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                OOB_mutex_lock(tp);
+                data = mac_ocp_read(tp, 0xE052);
+                data &= ~BIT_0;
+                mac_ocp_write(tp, 0xE052, data);
+                OOB_mutex_unlock(tp);
+                data = mac_ocp_read(tp, 0xE056);
+                data &= 0xFF0F;
+                data |= (BIT_4 | BIT_5 | BIT_6);
+                mac_ocp_write(tp, 0xE056, data);
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                data = mac_ocp_read(tp, 0xE052);
+                data |= BIT_0;
+                mac_ocp_write(tp, 0xE052, data);
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A43);
+                data = mdio_read(tp, 0x10) | BIT_15;
+                mdio_write(tp, 0x10, data);
+
+                mdio_write(tp, 0x1F, 0x0A44);
+                data = mdio_read(tp, 0x11) | BIT_13 | BIT_14;
+                data &= ~(BIT_12);
+                mdio_write(tp, 0x11, data);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                OOB_mutex_lock(tp);
+                data = mac_ocp_read(tp, 0xE052);
+                data |= BIT_0;
+                mac_ocp_write(tp, 0xE052, data);
+                OOB_mutex_unlock(tp);
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A43);
+                data = mdio_read(tp, 0x10) | BIT_15;
+                mdio_write(tp, 0x10, data);
+
+                mdio_write(tp, 0x1F, 0x0A44);
+                data = mdio_read(tp, 0x11) | BIT_13 | BIT_14;
+                data &= ~(BIT_12);
+                mdio_write(tp, 0x11, data);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0B82);
+                ClearEthPhyBit(tp, 0x10, BIT_4);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        }
+
+        return ret;
+}
+
+static int rtl8168_disable_EEE(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        int ret;
+        u16 data;
+        u16 PhyRegValue;
+        u32 csi_tmp;
+        u32 WaitCnt;
+        unsigned long flags;
+
+        ret = 0;
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B85);
+                data = mdio_read(tp, 0x06) & ~0x2000;
+                mdio_write(tp, 0x06, data);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x0020);
+                data = mdio_read(tp, 0x15) & ~0x0100;
+                mdio_write(tp, 0x15, data);
+                mdio_write(tp, 0x1F, 0x0006);
+                mdio_write(tp, 0x00, 0x5A00);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x0D, 0x0007);
+                mdio_write(tp, 0x0E, 0x003C);
+                mdio_write(tp, 0x0D, 0x4007);
+                mdio_write(tp, 0x0E, 0x0000);
+                mdio_write(tp, 0x0D, 0x0000);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                if (RTL_R8(Config4) & 0x40) {
+                        spin_lock_irqsave(&tp->phy_lock, flags);
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8B82);
+                        data = mdio_read(tp, 0x06) & ~0x0010;
+                        mdio_write(tp, 0x05, 0x8B82);
+                        mdio_write(tp, 0x06, data);
+                        mdio_write(tp, 0x1F, 0x0000);
+                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                }
+                break;
+
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0,4, ERIAR_ExGMAC)& ~0x0003;
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, csi_tmp, ERIAR_ExGMAC);
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B85);
+                data = mdio_read(tp, 0x06) & ~0x2000;
+                mdio_write(tp, 0x06, data);
+                mdio_write(tp, 0x1F, 0x0004);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x0020);
+                data = mdio_read(tp, 0x15) & ~0x0100;
+                mdio_write(tp,0x15 , data);
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x0D, 0x0007);
+                mdio_write(tp, 0x0E, 0x003C);
+                mdio_write(tp, 0x0D, 0x4007);
+                mdio_write(tp, 0x0E, 0x0000);
+                mdio_write(tp, 0x0D, 0x0000);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 4, ERIAR_ExGMAC);
+                csi_tmp &= ~(BIT_1 | BIT_0);
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, csi_tmp, ERIAR_ExGMAC);
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B85);
+                data = mdio_read(tp, 0x06);
+                data &= ~BIT_13;
+                mdio_write(tp, 0x06, data);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1e, 0x0020);
+                data = mdio_read(tp, 0x15);
+                data &= ~BIT_8;
+                mdio_write(tp, 0x15, data);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x0D, 0x0007);
+                mdio_write(tp, 0x0E, 0x003C);
+                mdio_write(tp, 0x0D, 0x4007);
+                mdio_write(tp, 0x0E, 0x0000);
+                mdio_write(tp, 0x0D, 0x0000);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 4, ERIAR_ExGMAC);
+                csi_tmp &= ~(BIT_1 | BIT_0);
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, csi_tmp, ERIAR_ExGMAC);
+                mdio_write(tp, 0x1F, 0x0A43);
+                data = mdio_read(tp, 0x11);
+                mdio_write(tp, 0x11, data & ~BIT_4);
+                mdio_write(tp, 0x1F, 0x0A5D);
+                mdio_write(tp, 0x10, 0x0000);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        default:
+//      dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Not Support EEE\n");
+                ret = -EOPNOTSUPP;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A42);
+                ClearEthPhyBit(tp, 0x14, BIT_7);
+                mdio_write(tp, 0x1F, 0x0A4A);
+                ClearEthPhyBit(tp, 0x11, BIT_9);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        }
+
+        /*Advanced EEE*/
+        switch (tp->mcfg) {
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp,0x1F, 0x0B82);
+                SetEthPhyBit(tp, 0x10, BIT_4);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp,0x1F, 0x0B80);
+                WaitCnt = 0;
+                do {
+                        PhyRegValue = mdio_read(tp, 0x10);
+                        PhyRegValue &= 0x0040;
+                        udelay(100);
+                        WaitCnt++;
+                } while(PhyRegValue != 0x0040 && WaitCnt <1000);
+
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_25:
+                rtl8168_eri_write(ioaddr, 0x1EA, 1, 0x00, ERIAR_ExGMAC);
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A42);
+                data = mdio_read(tp, 0x16);
+                data &= ~(BIT_1);
+                mdio_write(tp, 0x16, data);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        case CFG_METHOD_26:
+                data = mac_ocp_read(tp, 0xE052);
+                data &= ~(BIT_0);
+                mac_ocp_write(tp, 0xE052, data);
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A42);
+                data = mdio_read(tp, 0x16);
+                data &= ~(BIT_1);
+                mdio_write(tp, 0x16, data);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                data = mac_ocp_read(tp, 0xE052);
+                data &= ~(BIT_0);
+                mac_ocp_write(tp, 0xE052, data);
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                data = mac_ocp_read(tp, 0xE052);
+                data &= ~(BIT_0);
+                mac_ocp_write(tp, 0xE052, data);
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A43);
+                data = mdio_read(tp, 0x10) & ~(BIT_15);
+                mdio_write(tp, 0x10, data);
+
+                mdio_write(tp, 0x1F, 0x0A44);
+                data = mdio_read(tp, 0x11) & ~(BIT_12 | BIT_13 | BIT_14);
+                mdio_write(tp, 0x11, data);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0B82);
+                ClearEthPhyBit(tp, 0x10, BIT_4);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        }
+
+        return ret;
+}
+
+#if 0
+
+static int rtl8168_enable_green_feature(struct rtl8168_private *tp)
+{
+        u16 gphy_val;
+        unsigned long flags;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0003);
+                gphy_val = mdio_read(tp, 0x10) | 0x0400;
+                mdio_write(tp, 0x10, gphy_val);
+                gphy_val = mdio_read(tp, 0x19) | 0x0001;
+                mdio_write(tp, 0x19, gphy_val);
+                mdio_write(tp, 0x1F, 0x0005);
+                gphy_val = mdio_read(tp, 0x01) & ~0x0100;
+                mdio_write(tp, 0x01, gphy_val);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x00, 0x9200);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                mdelay(20);
+                break;
+
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1f, 0x0003);
+                gphy_val = mdio_read(tp, 0x10);
+                gphy_val |= BIT_10;
+                mdio_write(tp, 0x10, gphy_val);
+                gphy_val = mdio_read(tp, 0x19);
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x19, gphy_val);
+                mdio_write(tp, 0x1F, 0x0005);
+                gphy_val = mdio_read(tp, 0x01);
+                gphy_val |= BIT_8;
+                mdio_write(tp, 0x01, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, 0x00, 0x9200);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8011);
+                SetEthPhyBit( tp, 0x14, BIT_14 );
+                mdio_write(tp, 0x1F, 0x0A40);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x00, 0x9200);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8045);
+                mdio_write(tp, 0x14, 0x0000);
+                mdio_write(tp, 0x13, 0x804d);
+                mdio_write(tp, 0x14, 0x1222);
+                mdio_write(tp, 0x13, 0x805d);
+                mdio_write(tp, 0x14, 0x0022);
+                mdio_write(tp, 0x13, 0x8011);
+                SetEthPhyBit( tp, 0x14, BIT_15 );
+                mdio_write(tp, 0x1F, 0x0A40);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x00, 0x9200);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        default:
+                dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Not Support Green Feature\n");
+                break;
+        }
+
+        return 0;
+}
+
+static int rtl8168_disable_green_feature(struct rtl8168_private *tp)
+{
+        u16 gphy_val;
+        unsigned long flags;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0005);
+                gphy_val = mdio_read(tp, 0x01) | 0x0100;
+                mdio_write(tp, 0x01, gphy_val);
+                mdio_write(tp, 0x1F, 0x0003);
+                gphy_val = mdio_read(tp, 0x10) & ~0x0400;
+                mdio_write(tp, 0x10, gphy_val);
+                gphy_val = mdio_read(tp, 0x19) & ~0x0001;
+                mdio_write(tp, 0x19, gphy_val);
+                mdio_write(tp, 0x1F, 0x0002);
+                gphy_val = mdio_read(tp, 0x06) & ~0x7000;
+                gphy_val |= 0x3000;
+                mdio_write(tp, 0x06, gphy_val);
+                gphy_val = mdio_read(tp, 0x0D) & 0x0700;
+                gphy_val |= 0x0500;
+                mdio_write(tp, 0x0D, gphy_val);
+                mdio_write(tp, 0x1F, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1f, 0x0003);
+                gphy_val = mdio_read(tp, 0x19);
+                gphy_val &= ~BIT_0;
+                mdio_write(tp, 0x19, gphy_val);
+                gphy_val = mdio_read(tp, 0x10);
+                gphy_val &= ~BIT_10;
+                mdio_write(tp, 0x10, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8011);
+                ClearEthPhyBit( tp, 0x14, BIT_14 );
+                mdio_write(tp, 0x1F, 0x0A40);
+                mdio_write(tp, 0x00, 0x9200);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8045);
+                mdio_write(tp, 0x14, 0x2444);
+                mdio_write(tp, 0x13, 0x804d);
+                mdio_write(tp, 0x14, 0x2444);
+                mdio_write(tp, 0x13, 0x805d);
+                mdio_write(tp, 0x14, 0x2444);
+                mdio_write(tp, 0x13, 0x8011);
+                SetEthPhyBit( tp, 0x14, BIT_15 );
+                mdio_write(tp, 0x1F, 0x0A40);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x00, 0x9200);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+        default:
+                dev_printk(KERN_DEBUG, &tp->pci_dev->dev, "Not Support Green Feature\n");
+                break;
+        }
+
+        return 0;
+}
+
+#endif
+
+static void rtl8168_get_mac_version(struct rtl8168_private *tp, void __iomem *ioaddr)
+{
+        u32 reg,val32;
+        u32 ICVerID;
+
+        val32 = RTL_R32(TxConfig);
+        reg = val32 & 0x7c800000;
+        ICVerID = val32 & 0x00700000;
+
+        switch (reg) {
+        case 0x30000000:
+                tp->mcfg = CFG_METHOD_1;
+                tp->efuse_ver = EFUSE_NOT_SUPPORT;
+                break;
+        case 0x38000000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_2;
+                } else if (ICVerID == 0x00500000) {
+                        tp->mcfg = CFG_METHOD_3;
+                } else {
+                        tp->mcfg = CFG_METHOD_3;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_NOT_SUPPORT;
+                break;
+        case 0x3C000000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_4;
+                } else if (ICVerID == 0x00200000) {
+                        tp->mcfg = CFG_METHOD_5;
+                } else if (ICVerID == 0x00400000) {
+                        tp->mcfg = CFG_METHOD_6;
+                } else {
+                        tp->mcfg = CFG_METHOD_6;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_NOT_SUPPORT;
+                break;
+        case 0x3C800000:
+                if (ICVerID == 0x00100000) {
+                        tp->mcfg = CFG_METHOD_7;
+                } else if (ICVerID == 0x00300000) {
+                        tp->mcfg = CFG_METHOD_8;
+                } else {
+                        tp->mcfg = CFG_METHOD_8;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_NOT_SUPPORT;
+                break;
+        case 0x28000000:
+                if (ICVerID == 0x00100000) {
+                        tp->mcfg = CFG_METHOD_9;
+                } else if (ICVerID == 0x00300000) {
+                        tp->mcfg = CFG_METHOD_10;
+                } else {
+                        tp->mcfg = CFG_METHOD_10;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_SUPPORT_V1;
+                break;
+        case 0x28800000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_11;
+                } else if (ICVerID == 0x00200000) {
+                        tp->mcfg = CFG_METHOD_12;
+                        RTL_W32(0xD0, RTL_R32(0xD0) | 0x00020000);
+                } else if (ICVerID == 0x00300000) {
+                        tp->mcfg = CFG_METHOD_13;
+                } else {
+                        tp->mcfg = CFG_METHOD_13;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_SUPPORT_V1;
+                break;
+        case 0x2C000000:
+                if (ICVerID == 0x00100000) {
+                        tp->mcfg = CFG_METHOD_14;
+                } else if (ICVerID == 0x00200000) {
+                        tp->mcfg = CFG_METHOD_15;
+                } else {
+                        tp->mcfg = CFG_METHOD_15;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_SUPPORT_V2;
+                break;
+        case 0x2C800000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_16;
+                } else if (ICVerID == 0x00100000) {
+                        tp->mcfg = CFG_METHOD_17;
+                } else {
+                        tp->mcfg = CFG_METHOD_17;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_SUPPORT_V3;
+                break;
+        case 0x48000000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_18;
+                } else if (ICVerID == 0x00100000) {
+                        tp->mcfg = CFG_METHOD_19;
+                } else {
+                        tp->mcfg = CFG_METHOD_19;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_SUPPORT_V3;
+                break;
+        case 0x48800000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_20;
+                } else {
+                        tp->mcfg = CFG_METHOD_20;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+
+                tp->efuse_ver = EFUSE_SUPPORT_V3;
+                break;
+        case 0x4C000000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_21;
+                } else if (ICVerID == 0x00100000) {
+                        tp->mcfg = CFG_METHOD_22;
+                } else {
+                        tp->mcfg = CFG_METHOD_22;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_SUPPORT_V3;
+                break;
+        case 0x50000000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_23;
+                } else if (ICVerID == 0x00100000) {
+                        tp->mcfg = CFG_METHOD_27;
+                } else if (ICVerID == 0x00200000) {
+                        tp->mcfg = CFG_METHOD_28;
+                } else {
+                        tp->mcfg = CFG_METHOD_28;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_SUPPORT_V3;
+                break;
+        case 0x50800000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_24;
+                } else if (ICVerID == 0x00100000) {
+                        tp->mcfg = CFG_METHOD_25;
+                } else {
+                        tp->mcfg = CFG_METHOD_25;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+                tp->efuse_ver = EFUSE_SUPPORT_V3;
+                break;
+        case 0x5C800000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_26;
+                } else {
+                        tp->mcfg = CFG_METHOD_26;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+
+                tp->efuse_ver = EFUSE_SUPPORT_V3;
+                break;
+        case 0x54000000:
+                if (ICVerID == 0x00000000) {
+                        tp->mcfg = CFG_METHOD_29;
+                } else if (ICVerID == 0x00100000) {
+                        tp->mcfg = CFG_METHOD_30;
+                } else {
+                        tp->mcfg = CFG_METHOD_30;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+
+                tp->efuse_ver = EFUSE_SUPPORT_V3;
+                break;
+        case 0x54800000:
+                if (ICVerID == 0x00100000) {
+                        tp->mcfg = CFG_METHOD_31;
+                } else if (ICVerID == 0x00200000) {
+                        tp->mcfg = CFG_METHOD_32;
+                } else {
+                        tp->mcfg = CFG_METHOD_32;
+                        tp->HwIcVerUnknown = TRUE;
+                }
+
+                tp->efuse_ver = EFUSE_SUPPORT_V3;
+                break;
+        default:
+                printk("unknown chip version (%x)\n",reg);
+                tp->mcfg = CFG_METHOD_DEFAULT;
+                tp->HwIcVerUnknown = TRUE;
+                tp->efuse_ver = EFUSE_NOT_SUPPORT;
+                break;
+        }
+}
+
+static void
+rtl8168_print_mac_version(struct rtl8168_private *tp)
+{
+        int i;
+        for (i = ARRAY_SIZE(rtl_chip_info) - 1; i >= 0; i--) {
+                if (tp->mcfg == rtl_chip_info[i].mcfg) {
+                        dprintk("Realtek PCIe GBE Family Controller mcfg = %04d\n",
+                                rtl_chip_info[i].mcfg);
+                        return;
+                }
+        }
+
+        dprintk("mac_version == Unknown\n");
+}
+
+static u8 rtl8168_calc_efuse_dummy_bit(u16 reg)
+{
+        int s,a,b;
+        u8 dummyBitPos = 0;
+
+
+        s=reg% 32;
+        a=s % 16;
+        b=s/16;
+
+        if (s/16) {
+                dummyBitPos = (u8)(16-a);
+        } else {
+                dummyBitPos = (u8)a;
+        }
+
+        return dummyBitPos;
+}
+
+static u32 rtl8168_decode_efuse_cmd(struct rtl8168_private *tp, u32 DwCmd)
+{
+        u16 reg = (u16)((DwCmd & 0x00FE0000) >> 17);
+        u32 DummyPos = rtl8168_calc_efuse_dummy_bit(reg);
+        u32 DeCodeDwCmd = DwCmd;
+        u32 Dw17BitData;
+
+
+        if (tp->efuse_ver < 3) {
+                DeCodeDwCmd = (DwCmd>>(DummyPos+1))<<DummyPos;
+                if (DummyPos > 0) {
+                        DeCodeDwCmd |= ((DwCmd<<(32-DummyPos))>>(32-DummyPos));
+                }
+        } else {
+                reg = (u16)((DwCmd & 0x007F0000) >> 16);
+                DummyPos = rtl8168_calc_efuse_dummy_bit(reg);
+                Dw17BitData = ((DwCmd & BIT_23) >> 23);
+                Dw17BitData <<= 16;
+                Dw17BitData |= (DwCmd & 0x0000FFFF);
+                DeCodeDwCmd = (Dw17BitData>>(DummyPos+1))<<DummyPos;
+                if (DummyPos > 0) {
+                        DeCodeDwCmd |= ((Dw17BitData<<(32-DummyPos))>>(32-DummyPos));
+                }
+        }
+
+        return DeCodeDwCmd;
+}
+
+static u8 rtl8168_efuse_read(struct rtl8168_private *tp, u16 reg)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        u8 efuse_data = 0;
+        u32 temp;
+        int cnt;
+
+        if (tp->efuse_ver == EFUSE_NOT_SUPPORT)
+                return EFUSE_READ_FAIL;
+
+        if (tp->efuse_ver == EFUSE_SUPPORT_V1) {
+                temp = EFUSE_READ | ((reg & EFUSE_Reg_Mask) << EFUSE_Reg_Shift);
+                RTL_W32(EFUSEAR, temp);
+
+                cnt = 0;
+                do {
+                        udelay(100);
+                        temp = RTL_R32(EFUSEAR);
+                        cnt++;
+                } while (!(temp & EFUSE_READ_OK) && (cnt < EFUSE_Check_Cnt));
+
+                if (cnt == EFUSE_Check_Cnt)
+                        efuse_data = EFUSE_READ_FAIL;
+                else
+                        efuse_data = (u8)(RTL_R32(EFUSEAR) & EFUSE_Data_Mask);
+        } else  if (tp->efuse_ver == EFUSE_SUPPORT_V2) {
+                temp = (reg/2) & 0x03ff;
+                temp <<= 17;
+                temp |= EFUSE_READ;
+                RTL_W32(EFUSEAR, temp);
+
+                cnt = 0;
+                do {
+                        udelay(100);
+                        temp = RTL_R32(EFUSEAR);
+                        cnt++;
+                } while (!(temp & EFUSE_READ_OK) && (cnt < EFUSE_Check_Cnt));
+
+                if (cnt == EFUSE_Check_Cnt) {
+                        efuse_data = EFUSE_READ_FAIL;
+                } else {
+                        temp = RTL_R32(EFUSEAR);
+                        temp = rtl8168_decode_efuse_cmd(tp, temp);
+
+                        if (reg%2) {
+                                temp >>= 8;
+                                efuse_data = (u8)temp;
+                        } else {
+                                efuse_data = (u8)temp;
+                        }
+                }
+        } else  if (tp->efuse_ver == EFUSE_SUPPORT_V3) {
+                temp = (reg/2) & 0x03ff;
+                temp <<= 16;
+                temp |= EFUSE_READ_V3;
+                RTL_W32(EFUSEAR, temp);
+
+                cnt = 0;
+                do {
+                        udelay(100);
+                        temp = RTL_R32(EFUSEAR);
+                        cnt++;
+                } while ((temp & BIT_31) && (cnt < EFUSE_Check_Cnt));
+
+                if (cnt == EFUSE_Check_Cnt) {
+                        efuse_data = EFUSE_READ_FAIL;
+                } else {
+                        temp = RTL_R32(EFUSEAR);
+                        temp = rtl8168_decode_efuse_cmd(tp, temp);
+
+                        if (reg%2) {
+                                temp >>= 8;
+                                efuse_data = (u8)temp;
+                        } else {
+                                efuse_data = (u8)temp;
+                        }
+                }
+        }
+
+        udelay(20);
+
+        return efuse_data;
+}
+
+static void
+rtl8168_tally_counter_addr_fill(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        if (!tp->tally_paddr)
+                return;
+
+        RTL_W32(CounterAddrHigh, (u64)tp->tally_paddr >> 32);
+        RTL_W32(CounterAddrLow, (u64)tp->tally_paddr & (DMA_BIT_MASK(32)));
+}
+
+static void
+rtl8168_tally_counter_clear(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        if (tp->mcfg == CFG_METHOD_1 || tp->mcfg == CFG_METHOD_2 ||
+            tp->mcfg == CFG_METHOD_3 )
+                return;
+
+        if (!tp->tally_paddr)
+                return;
+
+        RTL_W32(CounterAddrHigh, (u64)tp->tally_paddr >> 32);
+        RTL_W32(CounterAddrLow, ((u64)tp->tally_paddr & (DMA_BIT_MASK(32))) | CounterReset);
+}
+
+static int
+rtl8168_is_ups_resume(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        return (mac_ocp_read(tp, 0xD408) & BIT_0);
+}
+
+static void
+rtl8168_clear_ups_resume_bit(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        mac_ocp_write(tp, 0xD408, mac_ocp_read(tp, 0xD408) & ~(BIT_0));
+}
+
+static void
+rtl8168_wait_phy_ups_resume(struct net_device *dev, u16 PhyState)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        u16 TmpPhyState;
+        int i=0;
+
+        do {
+                TmpPhyState = mdio_read_phy_ocp(tp, 0x0A42, 0x10);
+                TmpPhyState &= 0x7;
+                mdelay(1);
+                i++;
+        } while ((i < 100) && (TmpPhyState != PhyState));
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)
+        WARN_ON_ONCE(i == 100);
+#endif
+}
+
+void
+EnableNowIsOob(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        if ( tp->HwSuppNowIsOobVer == 1 ) {
+                RTL_W8(MCUCmd_reg, RTL_R8(MCUCmd_reg) | Now_is_oob);
+        }
+}
+
+void
+DisableNowIsOob(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        if ( tp->HwSuppNowIsOobVer == 1 ) {
+                RTL_W8(MCUCmd_reg, RTL_R8(MCUCmd_reg) & ~Now_is_oob);
+        }
+}
+
+static void
+rtl8168_exit_oob(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u16 data16;
+
+        RTL_W32(RxConfig, RTL_R32(RxConfig) & ~(AcceptErr | AcceptRunt | AcceptBroadcast | AcceptMulticast | AcceptMyPhys |  AcceptAllPhys));
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_23:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                Dash2DisableTxRx(dev);
+                break;
+        }
+
+        if (tp->DASH) {
+                rtl8168_driver_stop(tp);
+                rtl8168_driver_start(tp);
+#ifdef ENABLE_DASH_SUPPORT
+                DashHwInit(dev);
+#endif
+        }
+
+        //Disable realwow  function
+        switch (tp->mcfg) {
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+                RTL_W32(MACOCP, 0xE5A90000);
+                RTL_W32(MACOCP, 0xF2100010);
+                break;
+        case CFG_METHOD_20:
+                RTL_W32(MACOCP, 0xE5A90000);
+                RTL_W32(MACOCP, 0xE4640000);
+                RTL_W32(MACOCP, 0xF2100010);
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+                RTL_W32(MACOCP, 0x605E0000);
+                RTL_W32(MACOCP, (0xE05E << 16) | (RTL_R32(MACOCP) & 0xFFFE));
+                RTL_W32(MACOCP, 0xE9720000);
+                RTL_W32(MACOCP, 0xF2140010);
+                break;
+        case CFG_METHOD_26:
+                RTL_W32(MACOCP, 0xE05E00FF);
+                RTL_W32(MACOCP, 0xE9720000);
+                mac_ocp_write(tp, 0xE428, 0x0010);
+                break;
+        }
+
+#ifndef ENABLE_REALWOW_SUPPORT
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+                rtl8168_eri_write(ioaddr, 0x174, 2, 0x0000, ERIAR_ExGMAC);
+                mac_ocp_write(tp, 0xE428, 0x0010);
+                break;
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_28:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                rtl8168_eri_write(ioaddr, 0x174, 2, 0x00FF, ERIAR_ExGMAC);
+                mac_ocp_write(tp, 0xE428, 0x0010);
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30: {
+                u32 csi_tmp;
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x174, 2, ERIAR_ExGMAC);
+                csi_tmp &= ~(BIT_8);
+                csi_tmp |= (BIT_15);
+                rtl8168_eri_write(ioaddr, 0x174, 2, csi_tmp, ERIAR_ExGMAC);
+                mac_ocp_write(tp, 0xE428, 0x0010);
+        }
+        break;
+        }
+#endif //ENABLE_REALWOW_SUPPORT
+
+#ifdef ENABLE_REALWOW_SUPPORT
+        realwow_hw_init(dev);
+#endif
+
+        rtl8168_nic_reset(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_20:
+                rtl8168_wait_ll_share_fifo_ready(dev);
+
+                data16 = mac_ocp_read(tp, 0xD4DE) | BIT_15;
+                mac_ocp_write(tp, 0xD4DE, data16);
+
+                rtl8168_wait_ll_share_fifo_ready(dev);
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                DisableNowIsOob(tp);
+
+                data16 = mac_ocp_read(tp, 0xE8DE) & ~BIT_14;
+                mac_ocp_write(tp, 0xE8DE, data16);
+                rtl8168_wait_ll_share_fifo_ready(dev);
+
+                data16 = mac_ocp_read(tp, 0xE8DE) | BIT_15;
+                mac_ocp_write(tp, 0xE8DE, data16);
+
+                rtl8168_wait_ll_share_fifo_ready(dev);
+                break;
+        }
+
+        //wait ups resume (phy state 2)
+        switch (tp->mcfg) {
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                if (rtl8168_is_ups_resume(dev)) {
+                        unsigned long flags;
+
+                        spin_lock_irqsave(&tp->phy_lock, flags);
+
+                        rtl8168_wait_phy_ups_resume(dev, 2);
+
+                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+                        rtl8168_clear_ups_resume_bit(dev);
+                }
+                break;
+        };
+
+#ifdef ENABLE_FIBER_SUPPORT
+        if (HW_FIBER_MODE_ENABLED(tp))
+                rtl8168_hw_init_fiber_nic(dev);
+#endif //ENABLE_FIBER_SUPPORT
+}
+
+void
+rtl8168_hw_disable_mac_mcu_bps(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                rtl8168_enable_cfg9346_write(tp);
+                RTL_W8(Config5, RTL_R8(Config5) & ~BIT_0);
+                RTL_W8(Config2, RTL_R8(Config2) & ~BIT_7);
+                rtl8168_disable_cfg9346_write(tp);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                mac_ocp_write(tp, 0xFC38, 0x0000);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                mac_ocp_write(tp, 0xFC28, 0x0000);
+                mac_ocp_write(tp, 0xFC2A, 0x0000);
+                mac_ocp_write(tp, 0xFC2C, 0x0000);
+                mac_ocp_write(tp, 0xFC2E, 0x0000);
+                mac_ocp_write(tp, 0xFC30, 0x0000);
+                mac_ocp_write(tp, 0xFC32, 0x0000);
+                mac_ocp_write(tp, 0xFC34, 0x0000);
+                mac_ocp_write(tp, 0xFC36, 0x0000);
+                mdelay(3);
+                mac_ocp_write(tp, 0xFC26, 0x0000);
+                break;
+        }
+}
+
+static void
+rtl8168_set_mac_mcu_8168g_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        mac_ocp_write(tp, 0xE43C, 0x0000);
+        mac_ocp_write(tp, 0xE43E, 0x0000);
+
+        mac_ocp_write(tp, 0xE434, 0x0004);
+        mac_ocp_write(tp, 0xE43C, 0x0004);
+
+        rtl8168_hw_disable_mac_mcu_bps(dev);
+
+        mac_ocp_write( tp, 0xF800, 0xE008 );
+        mac_ocp_write( tp, 0xF802, 0xE01B );
+        mac_ocp_write( tp, 0xF804, 0xE022 );
+        mac_ocp_write( tp, 0xF806, 0xE094 );
+        mac_ocp_write( tp, 0xF808, 0xE097 );
+        mac_ocp_write( tp, 0xF80A, 0xE09A );
+        mac_ocp_write( tp, 0xF80C, 0xE0B3 );
+        mac_ocp_write( tp, 0xF80E, 0xE0BA );
+        mac_ocp_write( tp, 0xF810, 0x49D2 );
+        mac_ocp_write( tp, 0xF812, 0xF10D );
+        mac_ocp_write( tp, 0xF814, 0x766C );
+        mac_ocp_write( tp, 0xF816, 0x49E2 );
+        mac_ocp_write( tp, 0xF818, 0xF00A );
+        mac_ocp_write( tp, 0xF81A, 0x1EC0 );
+        mac_ocp_write( tp, 0xF81C, 0x8EE1 );
+        mac_ocp_write( tp, 0xF81E, 0xC60A );
+        mac_ocp_write( tp, 0xF820, 0x77C0 );
+        mac_ocp_write( tp, 0xF822, 0x4870 );
+        mac_ocp_write( tp, 0xF824, 0x9FC0 );
+        mac_ocp_write( tp, 0xF826, 0x1EA0 );
+        mac_ocp_write( tp, 0xF828, 0xC707 );
+        mac_ocp_write( tp, 0xF82A, 0x8EE1 );
+        mac_ocp_write( tp, 0xF82C, 0x9D6C );
+        mac_ocp_write( tp, 0xF82E, 0xC603 );
+        mac_ocp_write( tp, 0xF830, 0xBE00 );
+        mac_ocp_write( tp, 0xF832, 0xB416 );
+        mac_ocp_write( tp, 0xF834, 0x0076 );
+        mac_ocp_write( tp, 0xF836, 0xE86C );
+        mac_ocp_write( tp, 0xF838, 0xC406 );
+        mac_ocp_write( tp, 0xF83A, 0x7580 );
+        mac_ocp_write( tp, 0xF83C, 0x4852 );
+        mac_ocp_write( tp, 0xF83E, 0x8D80 );
+        mac_ocp_write( tp, 0xF840, 0xC403 );
+        mac_ocp_write( tp, 0xF842, 0xBC00 );
+        mac_ocp_write( tp, 0xF844, 0xD3E0 );
+        mac_ocp_write( tp, 0xF846, 0x02C8 );
+        mac_ocp_write( tp, 0xF848, 0x8918 );
+        mac_ocp_write( tp, 0xF84A, 0xE815 );
+        mac_ocp_write( tp, 0xF84C, 0x1100 );
+        mac_ocp_write( tp, 0xF84E, 0xF011 );
+        mac_ocp_write( tp, 0xF850, 0xE812 );
+        mac_ocp_write( tp, 0xF852, 0x4990 );
+        mac_ocp_write( tp, 0xF854, 0xF002 );
+        mac_ocp_write( tp, 0xF856, 0xE817 );
+        mac_ocp_write( tp, 0xF858, 0xE80E );
+        mac_ocp_write( tp, 0xF85A, 0x4992 );
+        mac_ocp_write( tp, 0xF85C, 0xF002 );
+        mac_ocp_write( tp, 0xF85E, 0xE80E );
+        mac_ocp_write( tp, 0xF860, 0xE80A );
+        mac_ocp_write( tp, 0xF862, 0x4993 );
+        mac_ocp_write( tp, 0xF864, 0xF002 );
+        mac_ocp_write( tp, 0xF866, 0xE818 );
+        mac_ocp_write( tp, 0xF868, 0xE806 );
+        mac_ocp_write( tp, 0xF86A, 0x4991 );
+        mac_ocp_write( tp, 0xF86C, 0xF002 );
+        mac_ocp_write( tp, 0xF86E, 0xE838 );
+        mac_ocp_write( tp, 0xF870, 0xC25E );
+        mac_ocp_write( tp, 0xF872, 0xBA00 );
+        mac_ocp_write( tp, 0xF874, 0xC056 );
+        mac_ocp_write( tp, 0xF876, 0x7100 );
+        mac_ocp_write( tp, 0xF878, 0xFF80 );
+        mac_ocp_write( tp, 0xF87A, 0x7100 );
+        mac_ocp_write( tp, 0xF87C, 0x4892 );
+        mac_ocp_write( tp, 0xF87E, 0x4813 );
+        mac_ocp_write( tp, 0xF880, 0x8900 );
+        mac_ocp_write( tp, 0xF882, 0xE00A );
+        mac_ocp_write( tp, 0xF884, 0x7100 );
+        mac_ocp_write( tp, 0xF886, 0x4890 );
+        mac_ocp_write( tp, 0xF888, 0x4813 );
+        mac_ocp_write( tp, 0xF88A, 0x8900 );
+        mac_ocp_write( tp, 0xF88C, 0xC74B );
+        mac_ocp_write( tp, 0xF88E, 0x74F8 );
+        mac_ocp_write( tp, 0xF890, 0x48C2 );
+        mac_ocp_write( tp, 0xF892, 0x4841 );
+        mac_ocp_write( tp, 0xF894, 0x8CF8 );
+        mac_ocp_write( tp, 0xF896, 0xC746 );
+        mac_ocp_write( tp, 0xF898, 0x74FC );
+        mac_ocp_write( tp, 0xF89A, 0x49C0 );
+        mac_ocp_write( tp, 0xF89C, 0xF120 );
+        mac_ocp_write( tp, 0xF89E, 0x49C1 );
+        mac_ocp_write( tp, 0xF8A0, 0xF11E );
+        mac_ocp_write( tp, 0xF8A2, 0x74F8 );
+        mac_ocp_write( tp, 0xF8A4, 0x49C0 );
+        mac_ocp_write( tp, 0xF8A6, 0xF01B );
+        mac_ocp_write( tp, 0xF8A8, 0x49C6 );
+        mac_ocp_write( tp, 0xF8AA, 0xF119 );
+        mac_ocp_write( tp, 0xF8AC, 0x74F8 );
+        mac_ocp_write( tp, 0xF8AE, 0x49C4 );
+        mac_ocp_write( tp, 0xF8B0, 0xF013 );
+        mac_ocp_write( tp, 0xF8B2, 0xC536 );
+        mac_ocp_write( tp, 0xF8B4, 0x74B0 );
+        mac_ocp_write( tp, 0xF8B6, 0x49C1 );
+        mac_ocp_write( tp, 0xF8B8, 0xF1FD );
+        mac_ocp_write( tp, 0xF8BA, 0xC537 );
+        mac_ocp_write( tp, 0xF8BC, 0xC434 );
+        mac_ocp_write( tp, 0xF8BE, 0x9CA0 );
+        mac_ocp_write( tp, 0xF8C0, 0xC435 );
+        mac_ocp_write( tp, 0xF8C2, 0x1C13 );
+        mac_ocp_write( tp, 0xF8C4, 0x484F );
+        mac_ocp_write( tp, 0xF8C6, 0x9CA2 );
+        mac_ocp_write( tp, 0xF8C8, 0xC52B );
+        mac_ocp_write( tp, 0xF8CA, 0x74B0 );
+        mac_ocp_write( tp, 0xF8CC, 0x49C1 );
+        mac_ocp_write( tp, 0xF8CE, 0xF1FD );
+        mac_ocp_write( tp, 0xF8D0, 0x74F8 );
+        mac_ocp_write( tp, 0xF8D2, 0x48C4 );
+        mac_ocp_write( tp, 0xF8D4, 0x8CF8 );
+        mac_ocp_write( tp, 0xF8D6, 0x7100 );
+        mac_ocp_write( tp, 0xF8D8, 0x4893 );
+        mac_ocp_write( tp, 0xF8DA, 0x8900 );
+        mac_ocp_write( tp, 0xF8DC, 0xFF80 );
+        mac_ocp_write( tp, 0xF8DE, 0xC520 );
+        mac_ocp_write( tp, 0xF8E0, 0x74B0 );
+        mac_ocp_write( tp, 0xF8E2, 0x49C1 );
+        mac_ocp_write( tp, 0xF8E4, 0xF11C );
+        mac_ocp_write( tp, 0xF8E6, 0xC71E );
+        mac_ocp_write( tp, 0xF8E8, 0x74FC );
+        mac_ocp_write( tp, 0xF8EA, 0x49C1 );
+        mac_ocp_write( tp, 0xF8EC, 0xF118 );
+        mac_ocp_write( tp, 0xF8EE, 0x49C0 );
+        mac_ocp_write( tp, 0xF8F0, 0xF116 );
+        mac_ocp_write( tp, 0xF8F2, 0x74F8 );
+        mac_ocp_write( tp, 0xF8F4, 0x49C0 );
+        mac_ocp_write( tp, 0xF8F6, 0xF013 );
+        mac_ocp_write( tp, 0xF8F8, 0x48C3 );
+        mac_ocp_write( tp, 0xF8FA, 0x8CF8 );
+        mac_ocp_write( tp, 0xF8FC, 0xC516 );
+        mac_ocp_write( tp, 0xF8FE, 0x74A2 );
+        mac_ocp_write( tp, 0xF900, 0x49CE );
+        mac_ocp_write( tp, 0xF902, 0xF1FE );
+        mac_ocp_write( tp, 0xF904, 0xC411 );
+        mac_ocp_write( tp, 0xF906, 0x9CA0 );
+        mac_ocp_write( tp, 0xF908, 0xC411 );
+        mac_ocp_write( tp, 0xF90A, 0x1C13 );
+        mac_ocp_write( tp, 0xF90C, 0x484F );
+        mac_ocp_write( tp, 0xF90E, 0x9CA2 );
+        mac_ocp_write( tp, 0xF910, 0x74A2 );
+        mac_ocp_write( tp, 0xF912, 0x49CF );
+        mac_ocp_write( tp, 0xF914, 0xF1FE );
+        mac_ocp_write( tp, 0xF916, 0x7100 );
+        mac_ocp_write( tp, 0xF918, 0x4891 );
+        mac_ocp_write( tp, 0xF91A, 0x8900 );
+        mac_ocp_write( tp, 0xF91C, 0xFF80 );
+        mac_ocp_write( tp, 0xF91E, 0xE400 );
+        mac_ocp_write( tp, 0xF920, 0xD3E0 );
+        mac_ocp_write( tp, 0xF922, 0xE000 );
+        mac_ocp_write( tp, 0xF924, 0x0481 );
+        mac_ocp_write( tp, 0xF926, 0x0C81 );
+        mac_ocp_write( tp, 0xF928, 0xDE20 );
+        mac_ocp_write( tp, 0xF92A, 0x0000 );
+        mac_ocp_write( tp, 0xF92C, 0x0992 );
+        mac_ocp_write( tp, 0xF92E, 0x1B76 );
+        mac_ocp_write( tp, 0xF930, 0xC602 );
+        mac_ocp_write( tp, 0xF932, 0xBE00 );
+        mac_ocp_write( tp, 0xF934, 0x059C );
+        mac_ocp_write( tp, 0xF936, 0x1B76 );
+        mac_ocp_write( tp, 0xF938, 0xC602 );
+        mac_ocp_write( tp, 0xF93A, 0xBE00 );
+        mac_ocp_write( tp, 0xF93C, 0x065A );
+        mac_ocp_write( tp, 0xF93E, 0xB400 );
+        mac_ocp_write( tp, 0xF940, 0x18DE );
+        mac_ocp_write( tp, 0xF942, 0x2008 );
+        mac_ocp_write( tp, 0xF944, 0x4001 );
+        mac_ocp_write( tp, 0xF946, 0xF10F );
+        mac_ocp_write( tp, 0xF948, 0x7342 );
+        mac_ocp_write( tp, 0xF94A, 0x1880 );
+        mac_ocp_write( tp, 0xF94C, 0x2008 );
+        mac_ocp_write( tp, 0xF94E, 0x0009 );
+        mac_ocp_write( tp, 0xF950, 0x4018 );
+        mac_ocp_write( tp, 0xF952, 0xF109 );
+        mac_ocp_write( tp, 0xF954, 0x7340 );
+        mac_ocp_write( tp, 0xF956, 0x25BC );
+        mac_ocp_write( tp, 0xF958, 0x130F );
+        mac_ocp_write( tp, 0xF95A, 0xF105 );
+        mac_ocp_write( tp, 0xF95C, 0xC00A );
+        mac_ocp_write( tp, 0xF95E, 0x7300 );
+        mac_ocp_write( tp, 0xF960, 0x4831 );
+        mac_ocp_write( tp, 0xF962, 0x9B00 );
+        mac_ocp_write( tp, 0xF964, 0xB000 );
+        mac_ocp_write( tp, 0xF966, 0x7340 );
+        mac_ocp_write( tp, 0xF968, 0x8320 );
+        mac_ocp_write( tp, 0xF96A, 0xC302 );
+        mac_ocp_write( tp, 0xF96C, 0xBB00 );
+        mac_ocp_write( tp, 0xF96E, 0x0C12 );
+        mac_ocp_write( tp, 0xF970, 0xE860 );
+        mac_ocp_write( tp, 0xF972, 0xC406 );
+        mac_ocp_write( tp, 0xF974, 0x7580 );
+        mac_ocp_write( tp, 0xF976, 0x4851 );
+        mac_ocp_write( tp, 0xF978, 0x8D80 );
+        mac_ocp_write( tp, 0xF97A, 0xC403 );
+        mac_ocp_write( tp, 0xF97C, 0xBC00 );
+        mac_ocp_write( tp, 0xF97E, 0xD3E0 );
+        mac_ocp_write( tp, 0xF980, 0x02C8 );
+        mac_ocp_write( tp, 0xF982, 0xC406 );
+        mac_ocp_write( tp, 0xF984, 0x7580 );
+        mac_ocp_write( tp, 0xF986, 0x4850 );
+        mac_ocp_write( tp, 0xF988, 0x8D80 );
+        mac_ocp_write( tp, 0xF98A, 0xC403 );
+        mac_ocp_write( tp, 0xF98C, 0xBC00 );
+        mac_ocp_write( tp, 0xF98E, 0xD3E0 );
+        mac_ocp_write( tp, 0xF990, 0x0298 );
+
+        mac_ocp_write( tp, 0xDE30, 0x0080 );
+
+        mac_ocp_write( tp, 0xFC26, 0x8000 );
+
+        mac_ocp_write( tp, 0xFC28, 0x0075 );
+        mac_ocp_write( tp, 0xFC2A, 0x02B1 );
+        mac_ocp_write( tp, 0xFC2C, 0x0991 );
+        mac_ocp_write( tp, 0xFC2E, 0x059B );
+        mac_ocp_write( tp, 0xFC30, 0x0659 );
+        mac_ocp_write( tp, 0xFC32, 0x0000 );
+        mac_ocp_write( tp, 0xFC34, 0x02C7 );
+        mac_ocp_write( tp, 0xFC36, 0x0279 );
+}
+
+static void
+rtl8168_set_mac_mcu_8168gu_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        rtl8168_hw_disable_mac_mcu_bps(dev);
+
+        mac_ocp_write( tp, 0xF800, 0xE008 );
+        mac_ocp_write( tp, 0xF802, 0xE011 );
+        mac_ocp_write( tp, 0xF804, 0xE015 );
+        mac_ocp_write( tp, 0xF806, 0xE018 );
+        mac_ocp_write( tp, 0xF808, 0xE01B );
+        mac_ocp_write( tp, 0xF80A, 0xE027 );
+        mac_ocp_write( tp, 0xF80C, 0xE043 );
+        mac_ocp_write( tp, 0xF80E, 0xE065 );
+        mac_ocp_write( tp, 0xF810, 0x49E2 );
+        mac_ocp_write( tp, 0xF812, 0xF005 );
+        mac_ocp_write( tp, 0xF814, 0x49EA );
+        mac_ocp_write( tp, 0xF816, 0xF003 );
+        mac_ocp_write( tp, 0xF818, 0xC404 );
+        mac_ocp_write( tp, 0xF81A, 0xBC00 );
+        mac_ocp_write( tp, 0xF81C, 0xC403 );
+        mac_ocp_write( tp, 0xF81E, 0xBC00 );
+        mac_ocp_write( tp, 0xF820, 0x0496 );
+        mac_ocp_write( tp, 0xF822, 0x051A );
+        mac_ocp_write( tp, 0xF824, 0x1D01 );
+        mac_ocp_write( tp, 0xF826, 0x8DE8 );
+        mac_ocp_write( tp, 0xF828, 0xC602 );
+        mac_ocp_write( tp, 0xF82A, 0xBE00 );
+        mac_ocp_write( tp, 0xF82C, 0x0206 );
+        mac_ocp_write( tp, 0xF82E, 0x1B76 );
+        mac_ocp_write( tp, 0xF830, 0xC202 );
+        mac_ocp_write( tp, 0xF832, 0xBA00 );
+        mac_ocp_write( tp, 0xF834, 0x058A );
+        mac_ocp_write( tp, 0xF836, 0x1B76 );
+        mac_ocp_write( tp, 0xF838, 0xC602 );
+        mac_ocp_write( tp, 0xF83A, 0xBE00 );
+        mac_ocp_write( tp, 0xF83C, 0x0648 );
+        mac_ocp_write( tp, 0xF83E, 0x74E6 );
+        mac_ocp_write( tp, 0xF840, 0x1B78 );
+        mac_ocp_write( tp, 0xF842, 0x46DC );
+        mac_ocp_write( tp, 0xF844, 0x1300 );
+        mac_ocp_write( tp, 0xF846, 0xF005 );
+        mac_ocp_write( tp, 0xF848, 0x74F8 );
+        mac_ocp_write( tp, 0xF84A, 0x48C3 );
+        mac_ocp_write( tp, 0xF84C, 0x48C4 );
+        mac_ocp_write( tp, 0xF84E, 0x8CF8 );
+        mac_ocp_write( tp, 0xF850, 0x64E7 );
+        mac_ocp_write( tp, 0xF852, 0xC302 );
+        mac_ocp_write( tp, 0xF854, 0xBB00 );
+        mac_ocp_write( tp, 0xF856, 0x068E );
+        mac_ocp_write( tp, 0xF858, 0x74E4 );
+        mac_ocp_write( tp, 0xF85A, 0x49C5 );
+        mac_ocp_write( tp, 0xF85C, 0xF106 );
+        mac_ocp_write( tp, 0xF85E, 0x49C6 );
+        mac_ocp_write( tp, 0xF860, 0xF107 );
+        mac_ocp_write( tp, 0xF862, 0x48C8 );
+        mac_ocp_write( tp, 0xF864, 0x48C9 );
+        mac_ocp_write( tp, 0xF866, 0xE011 );
+        mac_ocp_write( tp, 0xF868, 0x48C9 );
+        mac_ocp_write( tp, 0xF86A, 0x4848 );
+        mac_ocp_write( tp, 0xF86C, 0xE00E );
+        mac_ocp_write( tp, 0xF86E, 0x4848 );
+        mac_ocp_write( tp, 0xF870, 0x49C7 );
+        mac_ocp_write( tp, 0xF872, 0xF00A );
+        mac_ocp_write( tp, 0xF874, 0x48C9 );
+        mac_ocp_write( tp, 0xF876, 0xC60D );
+        mac_ocp_write( tp, 0xF878, 0x1D1F );
+        mac_ocp_write( tp, 0xF87A, 0x8DC2 );
+        mac_ocp_write( tp, 0xF87C, 0x1D00 );
+        mac_ocp_write( tp, 0xF87E, 0x8DC3 );
+        mac_ocp_write( tp, 0xF880, 0x1D11 );
+        mac_ocp_write( tp, 0xF882, 0x8DC0 );
+        mac_ocp_write( tp, 0xF884, 0xE002 );
+        mac_ocp_write( tp, 0xF886, 0x4849 );
+        mac_ocp_write( tp, 0xF888, 0x94E5 );
+        mac_ocp_write( tp, 0xF88A, 0xC602 );
+        mac_ocp_write( tp, 0xF88C, 0xBE00 );
+        mac_ocp_write( tp, 0xF88E, 0x0238 );
+        mac_ocp_write( tp, 0xF890, 0xE434 );
+        mac_ocp_write( tp, 0xF892, 0x49D9 );
+        mac_ocp_write( tp, 0xF894, 0xF01B );
+        mac_ocp_write( tp, 0xF896, 0xC31E );
+        mac_ocp_write( tp, 0xF898, 0x7464 );
+        mac_ocp_write( tp, 0xF89A, 0x49C4 );
+        mac_ocp_write( tp, 0xF89C, 0xF114 );
+        mac_ocp_write( tp, 0xF89E, 0xC31B );
+        mac_ocp_write( tp, 0xF8A0, 0x6460 );
+        mac_ocp_write( tp, 0xF8A2, 0x14FA );
+        mac_ocp_write( tp, 0xF8A4, 0xFA02 );
+        mac_ocp_write( tp, 0xF8A6, 0xE00F );
+        mac_ocp_write( tp, 0xF8A8, 0xC317 );
+        mac_ocp_write( tp, 0xF8AA, 0x7460 );
+        mac_ocp_write( tp, 0xF8AC, 0x49C0 );
+        mac_ocp_write( tp, 0xF8AE, 0xF10B );
+        mac_ocp_write( tp, 0xF8B0, 0xC311 );
+        mac_ocp_write( tp, 0xF8B2, 0x7462 );
+        mac_ocp_write( tp, 0xF8B4, 0x48C1 );
+        mac_ocp_write( tp, 0xF8B6, 0x9C62 );
+        mac_ocp_write( tp, 0xF8B8, 0x4841 );
+        mac_ocp_write( tp, 0xF8BA, 0x9C62 );
+        mac_ocp_write( tp, 0xF8BC, 0xC30A );
+        mac_ocp_write( tp, 0xF8BE, 0x1C04 );
+        mac_ocp_write( tp, 0xF8C0, 0x8C60 );
+        mac_ocp_write( tp, 0xF8C2, 0xE004 );
+        mac_ocp_write( tp, 0xF8C4, 0x1C15 );
+        mac_ocp_write( tp, 0xF8C6, 0xC305 );
+        mac_ocp_write( tp, 0xF8C8, 0x8C60 );
+        mac_ocp_write( tp, 0xF8CA, 0xC602 );
+        mac_ocp_write( tp, 0xF8CC, 0xBE00 );
+        mac_ocp_write( tp, 0xF8CE, 0x0374 );
+        mac_ocp_write( tp, 0xF8D0, 0xE434 );
+        mac_ocp_write( tp, 0xF8D2, 0xE030 );
+        mac_ocp_write( tp, 0xF8D4, 0xE61C );
+        mac_ocp_write( tp, 0xF8D6, 0xE906 );
+        mac_ocp_write( tp, 0xF8D8, 0xC602 );
+        mac_ocp_write( tp, 0xF8DA, 0xBE00 );
+        mac_ocp_write( tp, 0xF8DC, 0x0000 );
+
+        mac_ocp_write( tp, 0xFC26, 0x8000 );
+
+        mac_ocp_write( tp, 0xFC28, 0x0493 );
+        mac_ocp_write( tp, 0xFC2A, 0x0205 );
+        mac_ocp_write( tp, 0xFC2C, 0x0589 );
+        mac_ocp_write( tp, 0xFC2E, 0x0647 );
+        mac_ocp_write( tp, 0xFC30, 0x0000 );
+        mac_ocp_write( tp, 0xFC32, 0x0215 );
+        mac_ocp_write( tp, 0xFC34, 0x0285 );
+}
+
+static void
+rtl8168_set_mac_mcu_8168gu_2(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        rtl8168_hw_disable_mac_mcu_bps(dev);
+
+        mac_ocp_write( tp, 0xF800, 0xE008 );
+        mac_ocp_write( tp, 0xF802, 0xE00A );
+        mac_ocp_write( tp, 0xF804, 0xE00D );
+        mac_ocp_write( tp, 0xF806, 0xE02F );
+        mac_ocp_write( tp, 0xF808, 0xE031 );
+        mac_ocp_write( tp, 0xF80A, 0xE038 );
+        mac_ocp_write( tp, 0xF80C, 0xE03A );
+        mac_ocp_write( tp, 0xF80E, 0xE051 );
+        mac_ocp_write( tp, 0xF810, 0xC202 );
+        mac_ocp_write( tp, 0xF812, 0xBA00 );
+        mac_ocp_write( tp, 0xF814, 0x0DFC );
+        mac_ocp_write( tp, 0xF816, 0x7444 );
+        mac_ocp_write( tp, 0xF818, 0xC502 );
+        mac_ocp_write( tp, 0xF81A, 0xBD00 );
+        mac_ocp_write( tp, 0xF81C, 0x0A30 );
+        mac_ocp_write( tp, 0xF81E, 0x49D9 );
+        mac_ocp_write( tp, 0xF820, 0xF019 );
+        mac_ocp_write( tp, 0xF822, 0xC520 );
+        mac_ocp_write( tp, 0xF824, 0x64A5 );
+        mac_ocp_write( tp, 0xF826, 0x1400 );
+        mac_ocp_write( tp, 0xF828, 0xF007 );
+        mac_ocp_write( tp, 0xF82A, 0x0C01 );
+        mac_ocp_write( tp, 0xF82C, 0x8CA5 );
+        mac_ocp_write( tp, 0xF82E, 0x1C15 );
+        mac_ocp_write( tp, 0xF830, 0xC515 );
+        mac_ocp_write( tp, 0xF832, 0x9CA0 );
+        mac_ocp_write( tp, 0xF834, 0xE00F );
+        mac_ocp_write( tp, 0xF836, 0xC513 );
+        mac_ocp_write( tp, 0xF838, 0x74A0 );
+        mac_ocp_write( tp, 0xF83A, 0x48C8 );
+        mac_ocp_write( tp, 0xF83C, 0x48CA );
+        mac_ocp_write( tp, 0xF83E, 0x9CA0 );
+        mac_ocp_write( tp, 0xF840, 0xC510 );
+        mac_ocp_write( tp, 0xF842, 0x1B00 );
+        mac_ocp_write( tp, 0xF844, 0x9BA0 );
+        mac_ocp_write( tp, 0xF846, 0x1B1C );
+        mac_ocp_write( tp, 0xF848, 0x483F );
+        mac_ocp_write( tp, 0xF84A, 0x9BA2 );
+        mac_ocp_write( tp, 0xF84C, 0x1B04 );
+        mac_ocp_write( tp, 0xF84E, 0xC506 );
+        mac_ocp_write( tp, 0xF850, 0x9BA0 );
+        mac_ocp_write( tp, 0xF852, 0xC603 );
+        mac_ocp_write( tp, 0xF854, 0xBE00 );
+        mac_ocp_write( tp, 0xF856, 0x0298 );
+        mac_ocp_write( tp, 0xF858, 0x03DE );
+        mac_ocp_write( tp, 0xF85A, 0xE434 );
+        mac_ocp_write( tp, 0xF85C, 0xE096 );
+        mac_ocp_write( tp, 0xF85E, 0xE860 );
+        mac_ocp_write( tp, 0xF860, 0xDE20 );
+        mac_ocp_write( tp, 0xF862, 0xD3C0 );
+        mac_ocp_write( tp, 0xF864, 0xC602 );
+        mac_ocp_write( tp, 0xF866, 0xBE00 );
+        mac_ocp_write( tp, 0xF868, 0x0A64 );
+        mac_ocp_write( tp, 0xF86A, 0xC707 );
+        mac_ocp_write( tp, 0xF86C, 0x1D00 );
+        mac_ocp_write( tp, 0xF86E, 0x8DE2 );
+        mac_ocp_write( tp, 0xF870, 0x48C1 );
+        mac_ocp_write( tp, 0xF872, 0xC502 );
+        mac_ocp_write( tp, 0xF874, 0xBD00 );
+        mac_ocp_write( tp, 0xF876, 0x00AA );
+        mac_ocp_write( tp, 0xF878, 0xE0C0 );
+        mac_ocp_write( tp, 0xF87A, 0xC502 );
+        mac_ocp_write( tp, 0xF87C, 0xBD00 );
+        mac_ocp_write( tp, 0xF87E, 0x0132 );
+        mac_ocp_write( tp, 0xF880, 0xC50C );
+        mac_ocp_write( tp, 0xF882, 0x74A2 );
+        mac_ocp_write( tp, 0xF884, 0x49CE );
+        mac_ocp_write( tp, 0xF886, 0xF1FE );
+        mac_ocp_write( tp, 0xF888, 0x1C00 );
+        mac_ocp_write( tp, 0xF88A, 0x9EA0 );
+        mac_ocp_write( tp, 0xF88C, 0x1C1C );
+        mac_ocp_write( tp, 0xF88E, 0x484F );
+        mac_ocp_write( tp, 0xF890, 0x9CA2 );
+        mac_ocp_write( tp, 0xF892, 0xC402 );
+        mac_ocp_write( tp, 0xF894, 0xBC00 );
+        mac_ocp_write( tp, 0xF896, 0x0AFA );
+        mac_ocp_write( tp, 0xF898, 0xDE20 );
+        mac_ocp_write( tp, 0xF89A, 0xE000 );
+        mac_ocp_write( tp, 0xF89C, 0xE092 );
+        mac_ocp_write( tp, 0xF89E, 0xE430 );
+        mac_ocp_write( tp, 0xF8A0, 0xDE20 );
+        mac_ocp_write( tp, 0xF8A2, 0xE0C0 );
+        mac_ocp_write( tp, 0xF8A4, 0xE860 );
+        mac_ocp_write( tp, 0xF8A6, 0xE84C );
+        mac_ocp_write( tp, 0xF8A8, 0xB400 );
+        mac_ocp_write( tp, 0xF8AA, 0xB430 );
+        mac_ocp_write( tp, 0xF8AC, 0xE410 );
+        mac_ocp_write( tp, 0xF8AE, 0xC0AE );
+        mac_ocp_write( tp, 0xF8B0, 0xB407 );
+        mac_ocp_write( tp, 0xF8B2, 0xB406 );
+        mac_ocp_write( tp, 0xF8B4, 0xB405 );
+        mac_ocp_write( tp, 0xF8B6, 0xB404 );
+        mac_ocp_write( tp, 0xF8B8, 0xB403 );
+        mac_ocp_write( tp, 0xF8BA, 0xB402 );
+        mac_ocp_write( tp, 0xF8BC, 0xB401 );
+        mac_ocp_write( tp, 0xF8BE, 0xC7EE );
+        mac_ocp_write( tp, 0xF8C0, 0x76F4 );
+        mac_ocp_write( tp, 0xF8C2, 0xC2ED );
+        mac_ocp_write( tp, 0xF8C4, 0xC3ED );
+        mac_ocp_write( tp, 0xF8C6, 0xC1EF );
+        mac_ocp_write( tp, 0xF8C8, 0xC5F3 );
+        mac_ocp_write( tp, 0xF8CA, 0x74A0 );
+        mac_ocp_write( tp, 0xF8CC, 0x49CD );
+        mac_ocp_write( tp, 0xF8CE, 0xF001 );
+        mac_ocp_write( tp, 0xF8D0, 0xC5EE );
+        mac_ocp_write( tp, 0xF8D2, 0x74A0 );
+        mac_ocp_write( tp, 0xF8D4, 0x49C1 );
+        mac_ocp_write( tp, 0xF8D6, 0xF105 );
+        mac_ocp_write( tp, 0xF8D8, 0xC5E4 );
+        mac_ocp_write( tp, 0xF8DA, 0x74A2 );
+        mac_ocp_write( tp, 0xF8DC, 0x49CE );
+        mac_ocp_write( tp, 0xF8DE, 0xF00B );
+        mac_ocp_write( tp, 0xF8E0, 0x7444 );
+        mac_ocp_write( tp, 0xF8E2, 0x484B );
+        mac_ocp_write( tp, 0xF8E4, 0x9C44 );
+        mac_ocp_write( tp, 0xF8E6, 0x1C10 );
+        mac_ocp_write( tp, 0xF8E8, 0x9C62 );
+        mac_ocp_write( tp, 0xF8EA, 0x1C11 );
+        mac_ocp_write( tp, 0xF8EC, 0x8C60 );
+        mac_ocp_write( tp, 0xF8EE, 0x1C00 );
+        mac_ocp_write( tp, 0xF8F0, 0x9CF6 );
+        mac_ocp_write( tp, 0xF8F2, 0xE0EC );
+        mac_ocp_write( tp, 0xF8F4, 0x49E7 );
+        mac_ocp_write( tp, 0xF8F6, 0xF016 );
+        mac_ocp_write( tp, 0xF8F8, 0x1D80 );
+        mac_ocp_write( tp, 0xF8FA, 0x8DF4 );
+        mac_ocp_write( tp, 0xF8FC, 0x74F8 );
+        mac_ocp_write( tp, 0xF8FE, 0x4843 );
+        mac_ocp_write( tp, 0xF900, 0x8CF8 );
+        mac_ocp_write( tp, 0xF902, 0x74F8 );
+        mac_ocp_write( tp, 0xF904, 0x74F8 );
+        mac_ocp_write( tp, 0xF906, 0x7444 );
+        mac_ocp_write( tp, 0xF908, 0x48C8 );
+        mac_ocp_write( tp, 0xF90A, 0x48C9 );
+        mac_ocp_write( tp, 0xF90C, 0x48CA );
+        mac_ocp_write( tp, 0xF90E, 0x9C44 );
+        mac_ocp_write( tp, 0xF910, 0x74F8 );
+        mac_ocp_write( tp, 0xF912, 0x4844 );
+        mac_ocp_write( tp, 0xF914, 0x8CF8 );
+        mac_ocp_write( tp, 0xF916, 0x1E01 );
+        mac_ocp_write( tp, 0xF918, 0xE8DB );
+        mac_ocp_write( tp, 0xF91A, 0x7420 );
+        mac_ocp_write( tp, 0xF91C, 0x48C1 );
+        mac_ocp_write( tp, 0xF91E, 0x9C20 );
+        mac_ocp_write( tp, 0xF920, 0xE0D5 );
+        mac_ocp_write( tp, 0xF922, 0x49E6 );
+        mac_ocp_write( tp, 0xF924, 0xF02A );
+        mac_ocp_write( tp, 0xF926, 0x1D40 );
+        mac_ocp_write( tp, 0xF928, 0x8DF4 );
+        mac_ocp_write( tp, 0xF92A, 0x74FC );
+        mac_ocp_write( tp, 0xF92C, 0x49C0 );
+        mac_ocp_write( tp, 0xF92E, 0xF124 );
+        mac_ocp_write( tp, 0xF930, 0x49C1 );
+        mac_ocp_write( tp, 0xF932, 0xF122 );
+        mac_ocp_write( tp, 0xF934, 0x74F8 );
+        mac_ocp_write( tp, 0xF936, 0x49C0 );
+        mac_ocp_write( tp, 0xF938, 0xF01F );
+        mac_ocp_write( tp, 0xF93A, 0xE8D3 );
+        mac_ocp_write( tp, 0xF93C, 0x48C4 );
+        mac_ocp_write( tp, 0xF93E, 0x8CF8 );
+        mac_ocp_write( tp, 0xF940, 0x1E00 );
+        mac_ocp_write( tp, 0xF942, 0xE8C6 );
+        mac_ocp_write( tp, 0xF944, 0xC5B1 );
+        mac_ocp_write( tp, 0xF946, 0x74A0 );
+        mac_ocp_write( tp, 0xF948, 0x49C3 );
+        mac_ocp_write( tp, 0xF94A, 0xF016 );
+        mac_ocp_write( tp, 0xF94C, 0xC5AF );
+        mac_ocp_write( tp, 0xF94E, 0x74A4 );
+        mac_ocp_write( tp, 0xF950, 0x49C2 );
+        mac_ocp_write( tp, 0xF952, 0xF005 );
+        mac_ocp_write( tp, 0xF954, 0xC5AA );
+        mac_ocp_write( tp, 0xF956, 0x74B2 );
+        mac_ocp_write( tp, 0xF958, 0x49C9 );
+        mac_ocp_write( tp, 0xF95A, 0xF10E );
+        mac_ocp_write( tp, 0xF95C, 0xC5A6 );
+        mac_ocp_write( tp, 0xF95E, 0x74A8 );
+        mac_ocp_write( tp, 0xF960, 0x4845 );
+        mac_ocp_write( tp, 0xF962, 0x4846 );
+        mac_ocp_write( tp, 0xF964, 0x4847 );
+        mac_ocp_write( tp, 0xF966, 0x4848 );
+        mac_ocp_write( tp, 0xF968, 0x9CA8 );
+        mac_ocp_write( tp, 0xF96A, 0x74B2 );
+        mac_ocp_write( tp, 0xF96C, 0x4849 );
+        mac_ocp_write( tp, 0xF96E, 0x9CB2 );
+        mac_ocp_write( tp, 0xF970, 0x74A0 );
+        mac_ocp_write( tp, 0xF972, 0x484F );
+        mac_ocp_write( tp, 0xF974, 0x9CA0 );
+        mac_ocp_write( tp, 0xF976, 0xE0AA );
+        mac_ocp_write( tp, 0xF978, 0x49E4 );
+        mac_ocp_write( tp, 0xF97A, 0xF018 );
+        mac_ocp_write( tp, 0xF97C, 0x1D10 );
+        mac_ocp_write( tp, 0xF97E, 0x8DF4 );
+        mac_ocp_write( tp, 0xF980, 0x74F8 );
+        mac_ocp_write( tp, 0xF982, 0x74F8 );
+        mac_ocp_write( tp, 0xF984, 0x74F8 );
+        mac_ocp_write( tp, 0xF986, 0x4843 );
+        mac_ocp_write( tp, 0xF988, 0x8CF8 );
+        mac_ocp_write( tp, 0xF98A, 0x74F8 );
+        mac_ocp_write( tp, 0xF98C, 0x74F8 );
+        mac_ocp_write( tp, 0xF98E, 0x74F8 );
+        mac_ocp_write( tp, 0xF990, 0x4844 );
+        mac_ocp_write( tp, 0xF992, 0x4842 );
+        mac_ocp_write( tp, 0xF994, 0x4841 );
+        mac_ocp_write( tp, 0xF996, 0x8CF8 );
+        mac_ocp_write( tp, 0xF998, 0x1E01 );
+        mac_ocp_write( tp, 0xF99A, 0xE89A );
+        mac_ocp_write( tp, 0xF99C, 0x7420 );
+        mac_ocp_write( tp, 0xF99E, 0x4841 );
+        mac_ocp_write( tp, 0xF9A0, 0x9C20 );
+        mac_ocp_write( tp, 0xF9A2, 0x7444 );
+        mac_ocp_write( tp, 0xF9A4, 0x4848 );
+        mac_ocp_write( tp, 0xF9A6, 0x9C44 );
+        mac_ocp_write( tp, 0xF9A8, 0xE091 );
+        mac_ocp_write( tp, 0xF9AA, 0x49E5 );
+        mac_ocp_write( tp, 0xF9AC, 0xF03E );
+        mac_ocp_write( tp, 0xF9AE, 0x1D20 );
+        mac_ocp_write( tp, 0xF9B0, 0x8DF4 );
+        mac_ocp_write( tp, 0xF9B2, 0x74F8 );
+        mac_ocp_write( tp, 0xF9B4, 0x48C2 );
+        mac_ocp_write( tp, 0xF9B6, 0x4841 );
+        mac_ocp_write( tp, 0xF9B8, 0x8CF8 );
+        mac_ocp_write( tp, 0xF9BA, 0x1E01 );
+        mac_ocp_write( tp, 0xF9BC, 0x7444 );
+        mac_ocp_write( tp, 0xF9BE, 0x49CA );
+        mac_ocp_write( tp, 0xF9C0, 0xF103 );
+        mac_ocp_write( tp, 0xF9C2, 0x49C2 );
+        mac_ocp_write( tp, 0xF9C4, 0xF00C );
+        mac_ocp_write( tp, 0xF9C6, 0x49C1 );
+        mac_ocp_write( tp, 0xF9C8, 0xF004 );
+        mac_ocp_write( tp, 0xF9CA, 0x6447 );
+        mac_ocp_write( tp, 0xF9CC, 0x2244 );
+        mac_ocp_write( tp, 0xF9CE, 0xE002 );
+        mac_ocp_write( tp, 0xF9D0, 0x1C01 );
+        mac_ocp_write( tp, 0xF9D2, 0x9C62 );
+        mac_ocp_write( tp, 0xF9D4, 0x1C11 );
+        mac_ocp_write( tp, 0xF9D6, 0x8C60 );
+        mac_ocp_write( tp, 0xF9D8, 0x1C00 );
+        mac_ocp_write( tp, 0xF9DA, 0x9CF6 );
+        mac_ocp_write( tp, 0xF9DC, 0x7444 );
+        mac_ocp_write( tp, 0xF9DE, 0x49C8 );
+        mac_ocp_write( tp, 0xF9E0, 0xF01D );
+        mac_ocp_write( tp, 0xF9E2, 0x74FC );
+        mac_ocp_write( tp, 0xF9E4, 0x49C0 );
+        mac_ocp_write( tp, 0xF9E6, 0xF11A );
+        mac_ocp_write( tp, 0xF9E8, 0x49C1 );
+        mac_ocp_write( tp, 0xF9EA, 0xF118 );
+        mac_ocp_write( tp, 0xF9EC, 0x74F8 );
+        mac_ocp_write( tp, 0xF9EE, 0x49C0 );
+        mac_ocp_write( tp, 0xF9F0, 0xF015 );
+        mac_ocp_write( tp, 0xF9F2, 0x49C6 );
+        mac_ocp_write( tp, 0xF9F4, 0xF113 );
+        mac_ocp_write( tp, 0xF9F6, 0xE875 );
+        mac_ocp_write( tp, 0xF9F8, 0x48C4 );
+        mac_ocp_write( tp, 0xF9FA, 0x8CF8 );
+        mac_ocp_write( tp, 0xF9FC, 0x7420 );
+        mac_ocp_write( tp, 0xF9FE, 0x48C1 );
+        mac_ocp_write( tp, 0xFA00, 0x9C20 );
+        mac_ocp_write( tp, 0xFA02, 0xC50A );
+        mac_ocp_write( tp, 0xFA04, 0x74A2 );
+        mac_ocp_write( tp, 0xFA06, 0x8CA5 );
+        mac_ocp_write( tp, 0xFA08, 0x74A0 );
+        mac_ocp_write( tp, 0xFA0A, 0xC505 );
+        mac_ocp_write( tp, 0xFA0C, 0x9CA2 );
+        mac_ocp_write( tp, 0xFA0E, 0x1C11 );
+        mac_ocp_write( tp, 0xFA10, 0x9CA0 );
+        mac_ocp_write( tp, 0xFA12, 0xE00A );
+        mac_ocp_write( tp, 0xFA14, 0xE434 );
+        mac_ocp_write( tp, 0xFA16, 0xD3C0 );
+        mac_ocp_write( tp, 0xFA18, 0xDC00 );
+        mac_ocp_write( tp, 0xFA1A, 0x7444 );
+        mac_ocp_write( tp, 0xFA1C, 0x49CA );
+        mac_ocp_write( tp, 0xFA1E, 0xF004 );
+        mac_ocp_write( tp, 0xFA20, 0x48CA );
+        mac_ocp_write( tp, 0xFA22, 0x9C44 );
+        mac_ocp_write( tp, 0xFA24, 0xE855 );
+        mac_ocp_write( tp, 0xFA26, 0xE052 );
+        mac_ocp_write( tp, 0xFA28, 0x49E8 );
+        mac_ocp_write( tp, 0xFA2A, 0xF024 );
+        mac_ocp_write( tp, 0xFA2C, 0x1D01 );
+        mac_ocp_write( tp, 0xFA2E, 0x8DF5 );
+        mac_ocp_write( tp, 0xFA30, 0x7440 );
+        mac_ocp_write( tp, 0xFA32, 0x49C0 );
+        mac_ocp_write( tp, 0xFA34, 0xF11E );
+        mac_ocp_write( tp, 0xFA36, 0x7444 );
+        mac_ocp_write( tp, 0xFA38, 0x49C8 );
+        mac_ocp_write( tp, 0xFA3A, 0xF01B );
+        mac_ocp_write( tp, 0xFA3C, 0x49CA );
+        mac_ocp_write( tp, 0xFA3E, 0xF119 );
+        mac_ocp_write( tp, 0xFA40, 0xC5EC );
+        mac_ocp_write( tp, 0xFA42, 0x76A4 );
+        mac_ocp_write( tp, 0xFA44, 0x49E3 );
+        mac_ocp_write( tp, 0xFA46, 0xF015 );
+        mac_ocp_write( tp, 0xFA48, 0x49C0 );
+        mac_ocp_write( tp, 0xFA4A, 0xF103 );
+        mac_ocp_write( tp, 0xFA4C, 0x49C1 );
+        mac_ocp_write( tp, 0xFA4E, 0xF011 );
+        mac_ocp_write( tp, 0xFA50, 0x4849 );
+        mac_ocp_write( tp, 0xFA52, 0x9C44 );
+        mac_ocp_write( tp, 0xFA54, 0x1C00 );
+        mac_ocp_write( tp, 0xFA56, 0x9CF6 );
+        mac_ocp_write( tp, 0xFA58, 0x7444 );
+        mac_ocp_write( tp, 0xFA5A, 0x49C1 );
+        mac_ocp_write( tp, 0xFA5C, 0xF004 );
+        mac_ocp_write( tp, 0xFA5E, 0x6446 );
+        mac_ocp_write( tp, 0xFA60, 0x1E07 );
+        mac_ocp_write( tp, 0xFA62, 0xE003 );
+        mac_ocp_write( tp, 0xFA64, 0x1C01 );
+        mac_ocp_write( tp, 0xFA66, 0x1E03 );
+        mac_ocp_write( tp, 0xFA68, 0x9C62 );
+        mac_ocp_write( tp, 0xFA6A, 0x1C11 );
+        mac_ocp_write( tp, 0xFA6C, 0x8C60 );
+        mac_ocp_write( tp, 0xFA6E, 0xE830 );
+        mac_ocp_write( tp, 0xFA70, 0xE02D );
+        mac_ocp_write( tp, 0xFA72, 0x49E9 );
+        mac_ocp_write( tp, 0xFA74, 0xF004 );
+        mac_ocp_write( tp, 0xFA76, 0x1D02 );
+        mac_ocp_write( tp, 0xFA78, 0x8DF5 );
+        mac_ocp_write( tp, 0xFA7A, 0xE79C );
+        mac_ocp_write( tp, 0xFA7C, 0x49E3 );
+        mac_ocp_write( tp, 0xFA7E, 0xF006 );
+        mac_ocp_write( tp, 0xFA80, 0x1D08 );
+        mac_ocp_write( tp, 0xFA82, 0x8DF4 );
+        mac_ocp_write( tp, 0xFA84, 0x74F8 );
+        mac_ocp_write( tp, 0xFA86, 0x74F8 );
+        mac_ocp_write( tp, 0xFA88, 0xE73A );
+        mac_ocp_write( tp, 0xFA8A, 0x49E1 );
+        mac_ocp_write( tp, 0xFA8C, 0xF007 );
+        mac_ocp_write( tp, 0xFA8E, 0x1D02 );
+        mac_ocp_write( tp, 0xFA90, 0x8DF4 );
+        mac_ocp_write( tp, 0xFA92, 0x1E01 );
+        mac_ocp_write( tp, 0xFA94, 0xE7A7 );
+        mac_ocp_write( tp, 0xFA96, 0xDE20 );
+        mac_ocp_write( tp, 0xFA98, 0xE410 );
+        mac_ocp_write( tp, 0xFA9A, 0x49E0 );
+        mac_ocp_write( tp, 0xFA9C, 0xF017 );
+        mac_ocp_write( tp, 0xFA9E, 0x1D01 );
+        mac_ocp_write( tp, 0xFAA0, 0x8DF4 );
+        mac_ocp_write( tp, 0xFAA2, 0xC5FA );
+        mac_ocp_write( tp, 0xFAA4, 0x1C00 );
+        mac_ocp_write( tp, 0xFAA6, 0x8CA0 );
+        mac_ocp_write( tp, 0xFAA8, 0x1C1B );
+        mac_ocp_write( tp, 0xFAAA, 0x9CA2 );
+        mac_ocp_write( tp, 0xFAAC, 0x74A2 );
+        mac_ocp_write( tp, 0xFAAE, 0x49CF );
+        mac_ocp_write( tp, 0xFAB0, 0xF0FE );
+        mac_ocp_write( tp, 0xFAB2, 0xC5F3 );
+        mac_ocp_write( tp, 0xFAB4, 0x74A0 );
+        mac_ocp_write( tp, 0xFAB6, 0x4849 );
+        mac_ocp_write( tp, 0xFAB8, 0x9CA0 );
+        mac_ocp_write( tp, 0xFABA, 0x74F8 );
+        mac_ocp_write( tp, 0xFABC, 0x49C0 );
+        mac_ocp_write( tp, 0xFABE, 0xF006 );
+        mac_ocp_write( tp, 0xFAC0, 0x48C3 );
+        mac_ocp_write( tp, 0xFAC2, 0x8CF8 );
+        mac_ocp_write( tp, 0xFAC4, 0xE820 );
+        mac_ocp_write( tp, 0xFAC6, 0x74F8 );
+        mac_ocp_write( tp, 0xFAC8, 0x74F8 );
+        mac_ocp_write( tp, 0xFACA, 0xC432 );
+        mac_ocp_write( tp, 0xFACC, 0xBC00 );
+        mac_ocp_write( tp, 0xFACE, 0xC5E4 );
+        mac_ocp_write( tp, 0xFAD0, 0x74A2 );
+        mac_ocp_write( tp, 0xFAD2, 0x49CE );
+        mac_ocp_write( tp, 0xFAD4, 0xF1FE );
+        mac_ocp_write( tp, 0xFAD6, 0x9EA0 );
+        mac_ocp_write( tp, 0xFAD8, 0x1C1C );
+        mac_ocp_write( tp, 0xFADA, 0x484F );
+        mac_ocp_write( tp, 0xFADC, 0x9CA2 );
+        mac_ocp_write( tp, 0xFADE, 0xFF80 );
+        mac_ocp_write( tp, 0xFAE0, 0xB404 );
+        mac_ocp_write( tp, 0xFAE2, 0xB405 );
+        mac_ocp_write( tp, 0xFAE4, 0xC5D9 );
+        mac_ocp_write( tp, 0xFAE6, 0x74A2 );
+        mac_ocp_write( tp, 0xFAE8, 0x49CE );
+        mac_ocp_write( tp, 0xFAEA, 0xF1FE );
+        mac_ocp_write( tp, 0xFAEC, 0xC41F );
+        mac_ocp_write( tp, 0xFAEE, 0x9CA0 );
+        mac_ocp_write( tp, 0xFAF0, 0xC41C );
+        mac_ocp_write( tp, 0xFAF2, 0x1C13 );
+        mac_ocp_write( tp, 0xFAF4, 0x484F );
+        mac_ocp_write( tp, 0xFAF6, 0x9CA2 );
+        mac_ocp_write( tp, 0xFAF8, 0x74A2 );
+        mac_ocp_write( tp, 0xFAFA, 0x49CF );
+        mac_ocp_write( tp, 0xFAFC, 0xF1FE );
+        mac_ocp_write( tp, 0xFAFE, 0xB005 );
+        mac_ocp_write( tp, 0xFB00, 0xB004 );
+        mac_ocp_write( tp, 0xFB02, 0xFF80 );
+        mac_ocp_write( tp, 0xFB04, 0xB404 );
+        mac_ocp_write( tp, 0xFB06, 0xB405 );
+        mac_ocp_write( tp, 0xFB08, 0xC5C7 );
+        mac_ocp_write( tp, 0xFB0A, 0x74A2 );
+        mac_ocp_write( tp, 0xFB0C, 0x49CE );
+        mac_ocp_write( tp, 0xFB0E, 0xF1FE );
+        mac_ocp_write( tp, 0xFB10, 0xC40E );
+        mac_ocp_write( tp, 0xFB12, 0x9CA0 );
+        mac_ocp_write( tp, 0xFB14, 0xC40A );
+        mac_ocp_write( tp, 0xFB16, 0x1C13 );
+        mac_ocp_write( tp, 0xFB18, 0x484F );
+        mac_ocp_write( tp, 0xFB1A, 0x9CA2 );
+        mac_ocp_write( tp, 0xFB1C, 0x74A2 );
+        mac_ocp_write( tp, 0xFB1E, 0x49CF );
+        mac_ocp_write( tp, 0xFB20, 0xF1FE );
+        mac_ocp_write( tp, 0xFB22, 0xB005 );
+        mac_ocp_write( tp, 0xFB24, 0xB004 );
+        mac_ocp_write( tp, 0xFB26, 0xFF80 );
+        mac_ocp_write( tp, 0xFB28, 0x0000 );
+        mac_ocp_write( tp, 0xFB2A, 0x0481 );
+        mac_ocp_write( tp, 0xFB2C, 0x0C81 );
+        mac_ocp_write( tp, 0xFB2E, 0x0AE0 );
+
+
+        mac_ocp_write( tp, 0xFC26, 0x8000 );
+
+        mac_ocp_write( tp, 0xFC28, 0x0000 );
+        mac_ocp_write( tp, 0xFC2A, 0x0000 );
+        mac_ocp_write( tp, 0xFC2C, 0x0297 );
+        mac_ocp_write( tp, 0xFC2E, 0x0000 );
+        mac_ocp_write( tp, 0xFC30, 0x00A9 );
+        mac_ocp_write( tp, 0xFC32, 0x012D );
+        mac_ocp_write( tp, 0xFC34, 0x0000 );
+        mac_ocp_write( tp, 0xFC36, 0x08DF );
+}
+
+static void
+rtl8168_set_mac_mcu_8411b_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        rtl8168_hw_disable_mac_mcu_bps(dev);
+
+        mac_ocp_write( tp, 0xF800, 0xE008 );
+        mac_ocp_write( tp, 0xF802, 0xE00A );
+        mac_ocp_write( tp, 0xF804, 0xE00C );
+        mac_ocp_write( tp, 0xF806, 0xE00E );
+        mac_ocp_write( tp, 0xF808, 0xE027 );
+        mac_ocp_write( tp, 0xF80A, 0xE04F );
+        mac_ocp_write( tp, 0xF80C, 0xE05E );
+        mac_ocp_write( tp, 0xF80E, 0xE065 );
+        mac_ocp_write( tp, 0xF810, 0xC602 );
+        mac_ocp_write( tp, 0xF812, 0xBE00 );
+        mac_ocp_write( tp, 0xF814, 0x0000 );
+        mac_ocp_write( tp, 0xF816, 0xC502 );
+        mac_ocp_write( tp, 0xF818, 0xBD00 );
+        mac_ocp_write( tp, 0xF81A, 0x074C );
+        mac_ocp_write( tp, 0xF81C, 0xC302 );
+        mac_ocp_write( tp, 0xF81E, 0xBB00 );
+        mac_ocp_write( tp, 0xF820, 0x080A );
+        mac_ocp_write( tp, 0xF822, 0x6420 );
+        mac_ocp_write( tp, 0xF824, 0x48C2 );
+        mac_ocp_write( tp, 0xF826, 0x8C20 );
+        mac_ocp_write( tp, 0xF828, 0xC516 );
+        mac_ocp_write( tp, 0xF82A, 0x64A4 );
+        mac_ocp_write( tp, 0xF82C, 0x49C0 );
+        mac_ocp_write( tp, 0xF82E, 0xF009 );
+        mac_ocp_write( tp, 0xF830, 0x74A2 );
+        mac_ocp_write( tp, 0xF832, 0x8CA5 );
+        mac_ocp_write( tp, 0xF834, 0x74A0 );
+        mac_ocp_write( tp, 0xF836, 0xC50E );
+        mac_ocp_write( tp, 0xF838, 0x9CA2 );
+        mac_ocp_write( tp, 0xF83A, 0x1C11 );
+        mac_ocp_write( tp, 0xF83C, 0x9CA0 );
+        mac_ocp_write( tp, 0xF83E, 0xE006 );
+        mac_ocp_write( tp, 0xF840, 0x74F8 );
+        mac_ocp_write( tp, 0xF842, 0x48C4 );
+        mac_ocp_write( tp, 0xF844, 0x8CF8 );
+        mac_ocp_write( tp, 0xF846, 0xC404 );
+        mac_ocp_write( tp, 0xF848, 0xBC00 );
+        mac_ocp_write( tp, 0xF84A, 0xC403 );
+        mac_ocp_write( tp, 0xF84C, 0xBC00 );
+        mac_ocp_write( tp, 0xF84E, 0x0BF2 );
+        mac_ocp_write( tp, 0xF850, 0x0C0A );
+        mac_ocp_write( tp, 0xF852, 0xE434 );
+        mac_ocp_write( tp, 0xF854, 0xD3C0 );
+        mac_ocp_write( tp, 0xF856, 0x49D9 );
+        mac_ocp_write( tp, 0xF858, 0xF01F );
+        mac_ocp_write( tp, 0xF85A, 0xC526 );
+        mac_ocp_write( tp, 0xF85C, 0x64A5 );
+        mac_ocp_write( tp, 0xF85E, 0x1400 );
+        mac_ocp_write( tp, 0xF860, 0xF007 );
+        mac_ocp_write( tp, 0xF862, 0x0C01 );
+        mac_ocp_write( tp, 0xF864, 0x8CA5 );
+        mac_ocp_write( tp, 0xF866, 0x1C15 );
+        mac_ocp_write( tp, 0xF868, 0xC51B );
+        mac_ocp_write( tp, 0xF86A, 0x9CA0 );
+        mac_ocp_write( tp, 0xF86C, 0xE013 );
+        mac_ocp_write( tp, 0xF86E, 0xC519 );
+        mac_ocp_write( tp, 0xF870, 0x74A0 );
+        mac_ocp_write( tp, 0xF872, 0x48C4 );
+        mac_ocp_write( tp, 0xF874, 0x8CA0 );
+        mac_ocp_write( tp, 0xF876, 0xC516 );
+        mac_ocp_write( tp, 0xF878, 0x74A4 );
+        mac_ocp_write( tp, 0xF87A, 0x48C8 );
+        mac_ocp_write( tp, 0xF87C, 0x48CA );
+        mac_ocp_write( tp, 0xF87E, 0x9CA4 );
+        mac_ocp_write( tp, 0xF880, 0xC512 );
+        mac_ocp_write( tp, 0xF882, 0x1B00 );
+        mac_ocp_write( tp, 0xF884, 0x9BA0 );
+        mac_ocp_write( tp, 0xF886, 0x1B1C );
+        mac_ocp_write( tp, 0xF888, 0x483F );
+        mac_ocp_write( tp, 0xF88A, 0x9BA2 );
+        mac_ocp_write( tp, 0xF88C, 0x1B04 );
+        mac_ocp_write( tp, 0xF88E, 0xC508 );
+        mac_ocp_write( tp, 0xF890, 0x9BA0 );
+        mac_ocp_write( tp, 0xF892, 0xC505 );
+        mac_ocp_write( tp, 0xF894, 0xBD00 );
+        mac_ocp_write( tp, 0xF896, 0xC502 );
+        mac_ocp_write( tp, 0xF898, 0xBD00 );
+        mac_ocp_write( tp, 0xF89A, 0x0300 );
+        mac_ocp_write( tp, 0xF89C, 0x051E );
+        mac_ocp_write( tp, 0xF89E, 0xE434 );
+        mac_ocp_write( tp, 0xF8A0, 0xE018 );
+        mac_ocp_write( tp, 0xF8A2, 0xE092 );
+        mac_ocp_write( tp, 0xF8A4, 0xDE20 );
+        mac_ocp_write( tp, 0xF8A6, 0xD3C0 );
+        mac_ocp_write( tp, 0xF8A8, 0xC50F );
+        mac_ocp_write( tp, 0xF8AA, 0x76A4 );
+        mac_ocp_write( tp, 0xF8AC, 0x49E3 );
+        mac_ocp_write( tp, 0xF8AE, 0xF007 );
+        mac_ocp_write( tp, 0xF8B0, 0x49C0 );
+        mac_ocp_write( tp, 0xF8B2, 0xF103 );
+        mac_ocp_write( tp, 0xF8B4, 0xC607 );
+        mac_ocp_write( tp, 0xF8B6, 0xBE00 );
+        mac_ocp_write( tp, 0xF8B8, 0xC606 );
+        mac_ocp_write( tp, 0xF8BA, 0xBE00 );
+        mac_ocp_write( tp, 0xF8BC, 0xC602 );
+        mac_ocp_write( tp, 0xF8BE, 0xBE00 );
+        mac_ocp_write( tp, 0xF8C0, 0x0C4C );
+        mac_ocp_write( tp, 0xF8C2, 0x0C28 );
+        mac_ocp_write( tp, 0xF8C4, 0x0C2C );
+        mac_ocp_write( tp, 0xF8C6, 0xDC00 );
+        mac_ocp_write( tp, 0xF8C8, 0xC707 );
+        mac_ocp_write( tp, 0xF8CA, 0x1D00 );
+        mac_ocp_write( tp, 0xF8CC, 0x8DE2 );
+        mac_ocp_write( tp, 0xF8CE, 0x48C1 );
+        mac_ocp_write( tp, 0xF8D0, 0xC502 );
+        mac_ocp_write( tp, 0xF8D2, 0xBD00 );
+        mac_ocp_write( tp, 0xF8D4, 0x00AA );
+        mac_ocp_write( tp, 0xF8D6, 0xE0C0 );
+        mac_ocp_write( tp, 0xF8D8, 0xC502 );
+        mac_ocp_write( tp, 0xF8DA, 0xBD00 );
+        mac_ocp_write( tp, 0xF8DC, 0x0132 );
+
+        mac_ocp_write( tp, 0xFC26, 0x8000 );
+
+        mac_ocp_write( tp, 0xFC2A, 0x0743 );
+        mac_ocp_write( tp, 0xFC2C, 0x0801 );
+        mac_ocp_write( tp, 0xFC2E, 0x0BE9 );
+        mac_ocp_write( tp, 0xFC30, 0x02FD );
+        mac_ocp_write( tp, 0xFC32, 0x0C25 );
+        mac_ocp_write( tp, 0xFC34, 0x00A9 );
+        mac_ocp_write( tp, 0xFC36, 0x012D );
+}
+
+static void
+rtl8168_set_mac_mcu_8168ep_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        rtl8168_hw_disable_mac_mcu_bps(dev);
+
+        mac_ocp_write( tp, 0xF800, 0xE008 );
+        mac_ocp_write( tp, 0xF802, 0xE0D3 );
+        mac_ocp_write( tp, 0xF804, 0xE0D6 );
+        mac_ocp_write( tp, 0xF806, 0xE0D9 );
+        mac_ocp_write( tp, 0xF808, 0xE0DB );
+        mac_ocp_write( tp, 0xF80A, 0xE0DD );
+        mac_ocp_write( tp, 0xF80C, 0xE0DF );
+        mac_ocp_write( tp, 0xF80E, 0xE0E1 );
+        mac_ocp_write( tp, 0xF810, 0xC251 );
+        mac_ocp_write( tp, 0xF812, 0x7340 );
+        mac_ocp_write( tp, 0xF814, 0x49B1 );
+        mac_ocp_write( tp, 0xF816, 0xF010 );
+        mac_ocp_write( tp, 0xF818, 0x1D02 );
+        mac_ocp_write( tp, 0xF81A, 0x8D40 );
+        mac_ocp_write( tp, 0xF81C, 0xC202 );
+        mac_ocp_write( tp, 0xF81E, 0xBA00 );
+        mac_ocp_write( tp, 0xF820, 0x2C3A );
+        mac_ocp_write( tp, 0xF822, 0xC0F0 );
+        mac_ocp_write( tp, 0xF824, 0xE8DE );
+        mac_ocp_write( tp, 0xF826, 0x2000 );
+        mac_ocp_write( tp, 0xF828, 0x8000 );
+        mac_ocp_write( tp, 0xF82A, 0xC0B6 );
+        mac_ocp_write( tp, 0xF82C, 0x268C );
+        mac_ocp_write( tp, 0xF82E, 0x752C );
+        mac_ocp_write( tp, 0xF830, 0x49D4 );
+        mac_ocp_write( tp, 0xF832, 0xF112 );
+        mac_ocp_write( tp, 0xF834, 0xE025 );
+        mac_ocp_write( tp, 0xF836, 0xC2F6 );
+        mac_ocp_write( tp, 0xF838, 0x7146 );
+        mac_ocp_write( tp, 0xF83A, 0xC2F5 );
+        mac_ocp_write( tp, 0xF83C, 0x7340 );
+        mac_ocp_write( tp, 0xF83E, 0x49BE );
+        mac_ocp_write( tp, 0xF840, 0xF103 );
+        mac_ocp_write( tp, 0xF842, 0xC7F2 );
+        mac_ocp_write( tp, 0xF844, 0xE002 );
+        mac_ocp_write( tp, 0xF846, 0xC7F1 );
+        mac_ocp_write( tp, 0xF848, 0x304F );
+        mac_ocp_write( tp, 0xF84A, 0x6226 );
+        mac_ocp_write( tp, 0xF84C, 0x49A1 );
+        mac_ocp_write( tp, 0xF84E, 0xF1F0 );
+        mac_ocp_write( tp, 0xF850, 0x7222 );
+        mac_ocp_write( tp, 0xF852, 0x49A0 );
+        mac_ocp_write( tp, 0xF854, 0xF1ED );
+        mac_ocp_write( tp, 0xF856, 0x2525 );
+        mac_ocp_write( tp, 0xF858, 0x1F28 );
+        mac_ocp_write( tp, 0xF85A, 0x3097 );
+        mac_ocp_write( tp, 0xF85C, 0x3091 );
+        mac_ocp_write( tp, 0xF85E, 0x9A36 );
+        mac_ocp_write( tp, 0xF860, 0x752C );
+        mac_ocp_write( tp, 0xF862, 0x21DC );
+        mac_ocp_write( tp, 0xF864, 0x25BC );
+        mac_ocp_write( tp, 0xF866, 0xC6E2 );
+        mac_ocp_write( tp, 0xF868, 0x77C0 );
+        mac_ocp_write( tp, 0xF86A, 0x1304 );
+        mac_ocp_write( tp, 0xF86C, 0xF014 );
+        mac_ocp_write( tp, 0xF86E, 0x1303 );
+        mac_ocp_write( tp, 0xF870, 0xF014 );
+        mac_ocp_write( tp, 0xF872, 0x1302 );
+        mac_ocp_write( tp, 0xF874, 0xF014 );
+        mac_ocp_write( tp, 0xF876, 0x1301 );
+        mac_ocp_write( tp, 0xF878, 0xF014 );
+        mac_ocp_write( tp, 0xF87A, 0x49D4 );
+        mac_ocp_write( tp, 0xF87C, 0xF103 );
+        mac_ocp_write( tp, 0xF87E, 0xC3D7 );
+        mac_ocp_write( tp, 0xF880, 0xBB00 );
+        mac_ocp_write( tp, 0xF882, 0xC618 );
+        mac_ocp_write( tp, 0xF884, 0x67C6 );
+        mac_ocp_write( tp, 0xF886, 0x752E );
+        mac_ocp_write( tp, 0xF888, 0x22D7 );
+        mac_ocp_write( tp, 0xF88A, 0x26DD );
+        mac_ocp_write( tp, 0xF88C, 0x1505 );
+        mac_ocp_write( tp, 0xF88E, 0xF013 );
+        mac_ocp_write( tp, 0xF890, 0xC60A );
+        mac_ocp_write( tp, 0xF892, 0xBE00 );
+        mac_ocp_write( tp, 0xF894, 0xC309 );
+        mac_ocp_write( tp, 0xF896, 0xBB00 );
+        mac_ocp_write( tp, 0xF898, 0xC308 );
+        mac_ocp_write( tp, 0xF89A, 0xBB00 );
+        mac_ocp_write( tp, 0xF89C, 0xC307 );
+        mac_ocp_write( tp, 0xF89E, 0xBB00 );
+        mac_ocp_write( tp, 0xF8A0, 0xC306 );
+        mac_ocp_write( tp, 0xF8A2, 0xBB00 );
+        mac_ocp_write( tp, 0xF8A4, 0x25C8 );
+        mac_ocp_write( tp, 0xF8A6, 0x25A6 );
+        mac_ocp_write( tp, 0xF8A8, 0x25AC );
+        mac_ocp_write( tp, 0xF8AA, 0x25B2 );
+        mac_ocp_write( tp, 0xF8AC, 0x25B8 );
+        mac_ocp_write( tp, 0xF8AE, 0xCD08 );
+        mac_ocp_write( tp, 0xF8B0, 0x0000 );
+        mac_ocp_write( tp, 0xF8B2, 0xC0BC );
+        mac_ocp_write( tp, 0xF8B4, 0xC2FF );
+        mac_ocp_write( tp, 0xF8B6, 0x7340 );
+        mac_ocp_write( tp, 0xF8B8, 0x49B0 );
+        mac_ocp_write( tp, 0xF8BA, 0xF04E );
+        mac_ocp_write( tp, 0xF8BC, 0x1F46 );
+        mac_ocp_write( tp, 0xF8BE, 0x308F );
+        mac_ocp_write( tp, 0xF8C0, 0xC3F7 );
+        mac_ocp_write( tp, 0xF8C2, 0x1C04 );
+        mac_ocp_write( tp, 0xF8C4, 0xE84D );
+        mac_ocp_write( tp, 0xF8C6, 0x1401 );
+        mac_ocp_write( tp, 0xF8C8, 0xF147 );
+        mac_ocp_write( tp, 0xF8CA, 0x7226 );
+        mac_ocp_write( tp, 0xF8CC, 0x49A7 );
+        mac_ocp_write( tp, 0xF8CE, 0xF044 );
+        mac_ocp_write( tp, 0xF8D0, 0x7222 );
+        mac_ocp_write( tp, 0xF8D2, 0x2525 );
+        mac_ocp_write( tp, 0xF8D4, 0x1F30 );
+        mac_ocp_write( tp, 0xF8D6, 0x3097 );
+        mac_ocp_write( tp, 0xF8D8, 0x3091 );
+        mac_ocp_write( tp, 0xF8DA, 0x7340 );
+        mac_ocp_write( tp, 0xF8DC, 0xC4EA );
+        mac_ocp_write( tp, 0xF8DE, 0x401C );
+        mac_ocp_write( tp, 0xF8E0, 0xF006 );
+        mac_ocp_write( tp, 0xF8E2, 0xC6E8 );
+        mac_ocp_write( tp, 0xF8E4, 0x75C0 );
+        mac_ocp_write( tp, 0xF8E6, 0x49D7 );
+        mac_ocp_write( tp, 0xF8E8, 0xF105 );
+        mac_ocp_write( tp, 0xF8EA, 0xE036 );
+        mac_ocp_write( tp, 0xF8EC, 0x1D08 );
+        mac_ocp_write( tp, 0xF8EE, 0x8DC1 );
+        mac_ocp_write( tp, 0xF8F0, 0x0208 );
+        mac_ocp_write( tp, 0xF8F2, 0x6640 );
+        mac_ocp_write( tp, 0xF8F4, 0x2764 );
+        mac_ocp_write( tp, 0xF8F6, 0x1606 );
+        mac_ocp_write( tp, 0xF8F8, 0xF12F );
+        mac_ocp_write( tp, 0xF8FA, 0x6346 );
+        mac_ocp_write( tp, 0xF8FC, 0x133B );
+        mac_ocp_write( tp, 0xF8FE, 0xF12C );
+        mac_ocp_write( tp, 0xF900, 0x9B34 );
+        mac_ocp_write( tp, 0xF902, 0x1B18 );
+        mac_ocp_write( tp, 0xF904, 0x3093 );
+        mac_ocp_write( tp, 0xF906, 0xC32A );
+        mac_ocp_write( tp, 0xF908, 0x1C10 );
+        mac_ocp_write( tp, 0xF90A, 0xE82A );
+        mac_ocp_write( tp, 0xF90C, 0x1401 );
+        mac_ocp_write( tp, 0xF90E, 0xF124 );
+        mac_ocp_write( tp, 0xF910, 0x1A36 );
+        mac_ocp_write( tp, 0xF912, 0x308A );
+        mac_ocp_write( tp, 0xF914, 0x7322 );
+        mac_ocp_write( tp, 0xF916, 0x25B5 );
+        mac_ocp_write( tp, 0xF918, 0x0B0E );
+        mac_ocp_write( tp, 0xF91A, 0x1C00 );
+        mac_ocp_write( tp, 0xF91C, 0xE82C );
+        mac_ocp_write( tp, 0xF91E, 0xC71F );
+        mac_ocp_write( tp, 0xF920, 0x4027 );
+        mac_ocp_write( tp, 0xF922, 0xF11A );
+        mac_ocp_write( tp, 0xF924, 0xE838 );
+        mac_ocp_write( tp, 0xF926, 0x1F42 );
+        mac_ocp_write( tp, 0xF928, 0x308F );
+        mac_ocp_write( tp, 0xF92A, 0x1B08 );
+        mac_ocp_write( tp, 0xF92C, 0xE824 );
+        mac_ocp_write( tp, 0xF92E, 0x7236 );
+        mac_ocp_write( tp, 0xF930, 0x7746 );
+        mac_ocp_write( tp, 0xF932, 0x1700 );
+        mac_ocp_write( tp, 0xF934, 0xF00D );
+        mac_ocp_write( tp, 0xF936, 0xC313 );
+        mac_ocp_write( tp, 0xF938, 0x401F );
+        mac_ocp_write( tp, 0xF93A, 0xF103 );
+        mac_ocp_write( tp, 0xF93C, 0x1F00 );
+        mac_ocp_write( tp, 0xF93E, 0x9F46 );
+        mac_ocp_write( tp, 0xF940, 0x7744 );
+        mac_ocp_write( tp, 0xF942, 0x449F );
+        mac_ocp_write( tp, 0xF944, 0x445F );
+        mac_ocp_write( tp, 0xF946, 0xE817 );
+        mac_ocp_write( tp, 0xF948, 0xC70A );
+        mac_ocp_write( tp, 0xF94A, 0x4027 );
+        mac_ocp_write( tp, 0xF94C, 0xF105 );
+        mac_ocp_write( tp, 0xF94E, 0xC302 );
+        mac_ocp_write( tp, 0xF950, 0xBB00 );
+        mac_ocp_write( tp, 0xF952, 0x2E08 );
+        mac_ocp_write( tp, 0xF954, 0x2DC2 );
+        mac_ocp_write( tp, 0xF956, 0xC7FF );
+        mac_ocp_write( tp, 0xF958, 0xBF00 );
+        mac_ocp_write( tp, 0xF95A, 0xCDB8 );
+        mac_ocp_write( tp, 0xF95C, 0xFFFF );
+        mac_ocp_write( tp, 0xF95E, 0x0C02 );
+        mac_ocp_write( tp, 0xF960, 0xA554 );
+        mac_ocp_write( tp, 0xF962, 0xA5DC );
+        mac_ocp_write( tp, 0xF964, 0x402F );
+        mac_ocp_write( tp, 0xF966, 0xF105 );
+        mac_ocp_write( tp, 0xF968, 0x1400 );
+        mac_ocp_write( tp, 0xF96A, 0xF1FA );
+        mac_ocp_write( tp, 0xF96C, 0x1C01 );
+        mac_ocp_write( tp, 0xF96E, 0xE002 );
+        mac_ocp_write( tp, 0xF970, 0x1C00 );
+        mac_ocp_write( tp, 0xF972, 0xFF80 );
+        mac_ocp_write( tp, 0xF974, 0x49B0 );
+        mac_ocp_write( tp, 0xF976, 0xF004 );
+        mac_ocp_write( tp, 0xF978, 0x0B01 );
+        mac_ocp_write( tp, 0xF97A, 0xA1D3 );
+        mac_ocp_write( tp, 0xF97C, 0xE003 );
+        mac_ocp_write( tp, 0xF97E, 0x0B02 );
+        mac_ocp_write( tp, 0xF980, 0xA5D3 );
+        mac_ocp_write( tp, 0xF982, 0x3127 );
+        mac_ocp_write( tp, 0xF984, 0x3720 );
+        mac_ocp_write( tp, 0xF986, 0x0B02 );
+        mac_ocp_write( tp, 0xF988, 0xA5D3 );
+        mac_ocp_write( tp, 0xF98A, 0x3127 );
+        mac_ocp_write( tp, 0xF98C, 0x3720 );
+        mac_ocp_write( tp, 0xF98E, 0x1300 );
+        mac_ocp_write( tp, 0xF990, 0xF1FB );
+        mac_ocp_write( tp, 0xF992, 0xFF80 );
+        mac_ocp_write( tp, 0xF994, 0x7322 );
+        mac_ocp_write( tp, 0xF996, 0x25B5 );
+        mac_ocp_write( tp, 0xF998, 0x1E28 );
+        mac_ocp_write( tp, 0xF99A, 0x30DE );
+        mac_ocp_write( tp, 0xF99C, 0x30D9 );
+        mac_ocp_write( tp, 0xF99E, 0x7264 );
+        mac_ocp_write( tp, 0xF9A0, 0x1E11 );
+        mac_ocp_write( tp, 0xF9A2, 0x2368 );
+        mac_ocp_write( tp, 0xF9A4, 0x3116 );
+        mac_ocp_write( tp, 0xF9A6, 0xFF80 );
+        mac_ocp_write( tp, 0xF9A8, 0x1B7E );
+        mac_ocp_write( tp, 0xF9AA, 0xC602 );
+        mac_ocp_write( tp, 0xF9AC, 0xBE00 );
+        mac_ocp_write( tp, 0xF9AE, 0x06A6 );
+        mac_ocp_write( tp, 0xF9B0, 0x1B7E );
+        mac_ocp_write( tp, 0xF9B2, 0xC602 );
+        mac_ocp_write( tp, 0xF9B4, 0xBE00 );
+        mac_ocp_write( tp, 0xF9B6, 0x0764 );
+        mac_ocp_write( tp, 0xF9B8, 0xC602 );
+        mac_ocp_write( tp, 0xF9BA, 0xBE00 );
+        mac_ocp_write( tp, 0xF9BC, 0x0000 );
+        mac_ocp_write( tp, 0xF9BE, 0xC602 );
+        mac_ocp_write( tp, 0xF9C0, 0xBE00 );
+        mac_ocp_write( tp, 0xF9C2, 0x0000 );
+        mac_ocp_write( tp, 0xF9C4, 0xC602 );
+        mac_ocp_write( tp, 0xF9C6, 0xBE00 );
+        mac_ocp_write( tp, 0xF9C8, 0x0000 );
+        mac_ocp_write( tp, 0xF9CA, 0xC602 );
+        mac_ocp_write( tp, 0xF9CC, 0xBE00 );
+        mac_ocp_write( tp, 0xF9CE, 0x0000 );
+        mac_ocp_write( tp, 0xF9D0, 0xC602 );
+        mac_ocp_write( tp, 0xF9D2, 0xBE00 );
+        mac_ocp_write( tp, 0xF9D4, 0x0000 );
+
+        mac_ocp_write( tp, 0xFC26, 0x8000 );
+
+        mac_ocp_write( tp, 0xFC28, 0x2549 );
+        mac_ocp_write( tp, 0xFC2A, 0x06A5 );
+        mac_ocp_write( tp, 0xFC2C, 0x0763 );
+}
+
+static void
+rtl8168_set_mac_mcu_8168ep_2(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        rtl8168_hw_disable_mac_mcu_bps(dev);
+
+        mac_ocp_write( tp, 0xF800, 0xE008 );
+        mac_ocp_write( tp, 0xF802, 0xE017 );
+        mac_ocp_write( tp, 0xF804, 0xE019 );
+        mac_ocp_write( tp, 0xF806, 0xE01B );
+        mac_ocp_write( tp, 0xF808, 0xE01D );
+        mac_ocp_write( tp, 0xF80A, 0xE01F );
+        mac_ocp_write( tp, 0xF80C, 0xE021 );
+        mac_ocp_write( tp, 0xF80E, 0xE023 );
+        mac_ocp_write( tp, 0xF810, 0xC50F );
+        mac_ocp_write( tp, 0xF812, 0x76A4 );
+        mac_ocp_write( tp, 0xF814, 0x49E3 );
+        mac_ocp_write( tp, 0xF816, 0xF007 );
+        mac_ocp_write( tp, 0xF818, 0x49C0 );
+        mac_ocp_write( tp, 0xF81A, 0xF103 );
+        mac_ocp_write( tp, 0xF81C, 0xC607 );
+        mac_ocp_write( tp, 0xF81E, 0xBE00 );
+        mac_ocp_write( tp, 0xF820, 0xC606 );
+        mac_ocp_write( tp, 0xF822, 0xBE00 );
+        mac_ocp_write( tp, 0xF824, 0xC602 );
+        mac_ocp_write( tp, 0xF826, 0xBE00 );
+        mac_ocp_write( tp, 0xF828, 0x0BDA );
+        mac_ocp_write( tp, 0xF82A, 0x0BB0 );
+        mac_ocp_write( tp, 0xF82C, 0x0BBA );
+        mac_ocp_write( tp, 0xF82E, 0xDC00 );
+        mac_ocp_write( tp, 0xF830, 0xC602 );
+        mac_ocp_write( tp, 0xF832, 0xBE00 );
+        mac_ocp_write( tp, 0xF834, 0x0000 );
+        mac_ocp_write( tp, 0xF836, 0xC602 );
+        mac_ocp_write( tp, 0xF838, 0xBE00 );
+        mac_ocp_write( tp, 0xF83A, 0x0000 );
+        mac_ocp_write( tp, 0xF83C, 0xC602 );
+        mac_ocp_write( tp, 0xF83E, 0xBE00 );
+        mac_ocp_write( tp, 0xF840, 0x0000 );
+        mac_ocp_write( tp, 0xF842, 0xC602 );
+        mac_ocp_write( tp, 0xF844, 0xBE00 );
+        mac_ocp_write( tp, 0xF846, 0x0000 );
+        mac_ocp_write( tp, 0xF848, 0xC602 );
+        mac_ocp_write( tp, 0xF84A, 0xBE00 );
+        mac_ocp_write( tp, 0xF84C, 0x0000 );
+        mac_ocp_write( tp, 0xF84E, 0xC602 );
+        mac_ocp_write( tp, 0xF850, 0xBE00 );
+        mac_ocp_write( tp, 0xF852, 0x0000 );
+        mac_ocp_write( tp, 0xF854, 0xC602 );
+        mac_ocp_write( tp, 0xF856, 0xBE00 );
+        mac_ocp_write( tp, 0xF858, 0x0000 );
+
+        mac_ocp_write( tp, 0xFC26, 0x8000 );
+
+        mac_ocp_write( tp, 0xFC28, 0x0BB3 );
+}
+
+static void
+rtl8168_set_mac_mcu_8168h_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        rtl8168_hw_disable_mac_mcu_bps(dev);
+
+        mac_ocp_write(tp, 0xF800, 0xE008);
+        mac_ocp_write(tp, 0xF802, 0xE00F);
+        mac_ocp_write(tp, 0xF804, 0xE011);
+        mac_ocp_write(tp, 0xF806, 0xE047);
+        mac_ocp_write(tp, 0xF808, 0xE049);
+        mac_ocp_write(tp, 0xF80A, 0xE073);
+        mac_ocp_write(tp, 0xF80C, 0xE075);
+        mac_ocp_write(tp, 0xF80E, 0xE077);
+        mac_ocp_write(tp, 0xF810, 0xC707);
+        mac_ocp_write(tp, 0xF812, 0x1D00);
+        mac_ocp_write(tp, 0xF814, 0x8DE2);
+        mac_ocp_write(tp, 0xF816, 0x48C1);
+        mac_ocp_write(tp, 0xF818, 0xC502);
+        mac_ocp_write(tp, 0xF81A, 0xBD00);
+        mac_ocp_write(tp, 0xF81C, 0x00E4);
+        mac_ocp_write(tp, 0xF81E, 0xE0C0);
+        mac_ocp_write(tp, 0xF820, 0xC502);
+        mac_ocp_write(tp, 0xF822, 0xBD00);
+        mac_ocp_write(tp, 0xF824, 0x0216);
+        mac_ocp_write(tp, 0xF826, 0xC634);
+        mac_ocp_write(tp, 0xF828, 0x75C0);
+        mac_ocp_write(tp, 0xF82A, 0x49D3);
+        mac_ocp_write(tp, 0xF82C, 0xF027);
+        mac_ocp_write(tp, 0xF82E, 0xC631);
+        mac_ocp_write(tp, 0xF830, 0x75C0);
+        mac_ocp_write(tp, 0xF832, 0x49D3);
+        mac_ocp_write(tp, 0xF834, 0xF123);
+        mac_ocp_write(tp, 0xF836, 0xC627);
+        mac_ocp_write(tp, 0xF838, 0x75C0);
+        mac_ocp_write(tp, 0xF83A, 0xB405);
+        mac_ocp_write(tp, 0xF83C, 0xC525);
+        mac_ocp_write(tp, 0xF83E, 0x9DC0);
+        mac_ocp_write(tp, 0xF840, 0xC621);
+        mac_ocp_write(tp, 0xF842, 0x75C8);
+        mac_ocp_write(tp, 0xF844, 0x49D5);
+        mac_ocp_write(tp, 0xF846, 0xF00A);
+        mac_ocp_write(tp, 0xF848, 0x49D6);
+        mac_ocp_write(tp, 0xF84A, 0xF008);
+        mac_ocp_write(tp, 0xF84C, 0x49D7);
+        mac_ocp_write(tp, 0xF84E, 0xF006);
+        mac_ocp_write(tp, 0xF850, 0x49D8);
+        mac_ocp_write(tp, 0xF852, 0xF004);
+        mac_ocp_write(tp, 0xF854, 0x75D2);
+        mac_ocp_write(tp, 0xF856, 0x49D9);
+        mac_ocp_write(tp, 0xF858, 0xF111);
+        mac_ocp_write(tp, 0xF85A, 0xC517);
+        mac_ocp_write(tp, 0xF85C, 0x9DC8);
+        mac_ocp_write(tp, 0xF85E, 0xC516);
+        mac_ocp_write(tp, 0xF860, 0x9DD2);
+        mac_ocp_write(tp, 0xF862, 0xC618);
+        mac_ocp_write(tp, 0xF864, 0x75C0);
+        mac_ocp_write(tp, 0xF866, 0x49D4);
+        mac_ocp_write(tp, 0xF868, 0xF003);
+        mac_ocp_write(tp, 0xF86A, 0x49D0);
+        mac_ocp_write(tp, 0xF86C, 0xF104);
+        mac_ocp_write(tp, 0xF86E, 0xC60A);
+        mac_ocp_write(tp, 0xF870, 0xC50E);
+        mac_ocp_write(tp, 0xF872, 0x9DC0);
+        mac_ocp_write(tp, 0xF874, 0xB005);
+        mac_ocp_write(tp, 0xF876, 0xC607);
+        mac_ocp_write(tp, 0xF878, 0x9DC0);
+        mac_ocp_write(tp, 0xF87A, 0xB007);
+        mac_ocp_write(tp, 0xF87C, 0xC602);
+        mac_ocp_write(tp, 0xF87E, 0xBE00);
+        mac_ocp_write(tp, 0xF880, 0x1A06);
+        mac_ocp_write(tp, 0xF882, 0xB400);
+        mac_ocp_write(tp, 0xF884, 0xE86C);
+        mac_ocp_write(tp, 0xF886, 0xA000);
+        mac_ocp_write(tp, 0xF888, 0x01E1);
+        mac_ocp_write(tp, 0xF88A, 0x0200);
+        mac_ocp_write(tp, 0xF88C, 0x9200);
+        mac_ocp_write(tp, 0xF88E, 0xE84C);
+        mac_ocp_write(tp, 0xF890, 0xE004);
+        mac_ocp_write(tp, 0xF892, 0xE908);
+        mac_ocp_write(tp, 0xF894, 0xC502);
+        mac_ocp_write(tp, 0xF896, 0xBD00);
+        mac_ocp_write(tp, 0xF898, 0x0B58);
+        mac_ocp_write(tp, 0xF89A, 0xB407);
+        mac_ocp_write(tp, 0xF89C, 0xB404);
+        mac_ocp_write(tp, 0xF89E, 0x2195);
+        mac_ocp_write(tp, 0xF8A0, 0x25BD);
+        mac_ocp_write(tp, 0xF8A2, 0x9BE0);
+        mac_ocp_write(tp, 0xF8A4, 0x1C1C);
+        mac_ocp_write(tp, 0xF8A6, 0x484F);
+        mac_ocp_write(tp, 0xF8A8, 0x9CE2);
+        mac_ocp_write(tp, 0xF8AA, 0x72E2);
+        mac_ocp_write(tp, 0xF8AC, 0x49AE);
+        mac_ocp_write(tp, 0xF8AE, 0xF1FE);
+        mac_ocp_write(tp, 0xF8B0, 0x0B00);
+        mac_ocp_write(tp, 0xF8B2, 0xF116);
+        mac_ocp_write(tp, 0xF8B4, 0xC71C);
+        mac_ocp_write(tp, 0xF8B6, 0xC419);
+        mac_ocp_write(tp, 0xF8B8, 0x9CE0);
+        mac_ocp_write(tp, 0xF8BA, 0x1C13);
+        mac_ocp_write(tp, 0xF8BC, 0x484F);
+        mac_ocp_write(tp, 0xF8BE, 0x9CE2);
+        mac_ocp_write(tp, 0xF8C0, 0x74E2);
+        mac_ocp_write(tp, 0xF8C2, 0x49CE);
+        mac_ocp_write(tp, 0xF8C4, 0xF1FE);
+        mac_ocp_write(tp, 0xF8C6, 0xC412);
+        mac_ocp_write(tp, 0xF8C8, 0x9CE0);
+        mac_ocp_write(tp, 0xF8CA, 0x1C13);
+        mac_ocp_write(tp, 0xF8CC, 0x484F);
+        mac_ocp_write(tp, 0xF8CE, 0x9CE2);
+        mac_ocp_write(tp, 0xF8D0, 0x74E2);
+        mac_ocp_write(tp, 0xF8D2, 0x49CE);
+        mac_ocp_write(tp, 0xF8D4, 0xF1FE);
+        mac_ocp_write(tp, 0xF8D6, 0xC70C);
+        mac_ocp_write(tp, 0xF8D8, 0x74F8);
+        mac_ocp_write(tp, 0xF8DA, 0x48C3);
+        mac_ocp_write(tp, 0xF8DC, 0x8CF8);
+        mac_ocp_write(tp, 0xF8DE, 0xB004);
+        mac_ocp_write(tp, 0xF8E0, 0xB007);
+        mac_ocp_write(tp, 0xF8E2, 0xC502);
+        mac_ocp_write(tp, 0xF8E4, 0xBD00);
+        mac_ocp_write(tp, 0xF8E6, 0x0F24);
+        mac_ocp_write(tp, 0xF8E8, 0x0481);
+        mac_ocp_write(tp, 0xF8EA, 0x0C81);
+        mac_ocp_write(tp, 0xF8EC, 0xDE24);
+        mac_ocp_write(tp, 0xF8EE, 0xE000);
+        mac_ocp_write(tp, 0xF8F0, 0xC602);
+        mac_ocp_write(tp, 0xF8F2, 0xBE00);
+        mac_ocp_write(tp, 0xF8F4, 0x0CA4);
+        mac_ocp_write(tp, 0xF8F6, 0xC502);
+        mac_ocp_write(tp, 0xF8F8, 0xBD00);
+        mac_ocp_write(tp, 0xF8FA, 0x0000);
+        mac_ocp_write(tp, 0xF8FC, 0xC602);
+        mac_ocp_write(tp, 0xF8FE, 0xBE00);
+        mac_ocp_write(tp, 0xF900, 0x0000);
+
+        mac_ocp_write(tp, 0xFC26, 0x8000);
+
+        mac_ocp_write(tp, 0xFC28, 0x00E2);
+        mac_ocp_write(tp, 0xFC2A, 0x0210);
+        mac_ocp_write(tp, 0xFC2C, 0x1A04);
+        mac_ocp_write(tp, 0xFC2E, 0x0B26);
+        mac_ocp_write(tp, 0xFC30, 0x0F02);
+        mac_ocp_write(tp, 0xFC32, 0x0CA0);
+
+        mac_ocp_write(tp, 0xFC38, 0x003F);
+}
+
+static void
+rtl8168_set_mac_mcu_8168fp_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        rtl8168_hw_disable_mac_mcu_bps(dev);
+
+        mac_ocp_write(tp, 0xF800, 0xE00A);
+        mac_ocp_write(tp, 0xF802, 0xE0C1);
+        mac_ocp_write(tp, 0xF804, 0xE104);
+        mac_ocp_write(tp, 0xF806, 0xE108);
+        mac_ocp_write(tp, 0xF808, 0xE10D);
+        mac_ocp_write(tp, 0xF80A, 0xE112);
+        mac_ocp_write(tp, 0xF80C, 0xE11C);
+        mac_ocp_write(tp, 0xF80E, 0xE121);
+        mac_ocp_write(tp, 0xF810, 0xE000);
+        mac_ocp_write(tp, 0xF812, 0xE0C8);
+        mac_ocp_write(tp, 0xF814, 0xB400);
+        mac_ocp_write(tp, 0xF816, 0xC1FE);
+        mac_ocp_write(tp, 0xF818, 0x49E2);
+        mac_ocp_write(tp, 0xF81A, 0xF04C);
+        mac_ocp_write(tp, 0xF81C, 0x49EA);
+        mac_ocp_write(tp, 0xF81E, 0xF04A);
+        mac_ocp_write(tp, 0xF820, 0x74E6);
+        mac_ocp_write(tp, 0xF822, 0xC246);
+        mac_ocp_write(tp, 0xF824, 0x7542);
+        mac_ocp_write(tp, 0xF826, 0x73EC);
+        mac_ocp_write(tp, 0xF828, 0x1800);
+        mac_ocp_write(tp, 0xF82A, 0x49C0);
+        mac_ocp_write(tp, 0xF82C, 0xF10D);
+        mac_ocp_write(tp, 0xF82E, 0x49C1);
+        mac_ocp_write(tp, 0xF830, 0xF10B);
+        mac_ocp_write(tp, 0xF832, 0x49C2);
+        mac_ocp_write(tp, 0xF834, 0xF109);
+        mac_ocp_write(tp, 0xF836, 0x49B0);
+        mac_ocp_write(tp, 0xF838, 0xF107);
+        mac_ocp_write(tp, 0xF83A, 0x49B1);
+        mac_ocp_write(tp, 0xF83C, 0xF105);
+        mac_ocp_write(tp, 0xF83E, 0x7220);
+        mac_ocp_write(tp, 0xF840, 0x49A2);
+        mac_ocp_write(tp, 0xF842, 0xF102);
+        mac_ocp_write(tp, 0xF844, 0xE002);
+        mac_ocp_write(tp, 0xF846, 0x4800);
+        mac_ocp_write(tp, 0xF848, 0x49D0);
+        mac_ocp_write(tp, 0xF84A, 0xF10A);
+        mac_ocp_write(tp, 0xF84C, 0x49D1);
+        mac_ocp_write(tp, 0xF84E, 0xF108);
+        mac_ocp_write(tp, 0xF850, 0x49D2);
+        mac_ocp_write(tp, 0xF852, 0xF106);
+        mac_ocp_write(tp, 0xF854, 0x49D3);
+        mac_ocp_write(tp, 0xF856, 0xF104);
+        mac_ocp_write(tp, 0xF858, 0x49DF);
+        mac_ocp_write(tp, 0xF85A, 0xF102);
+        mac_ocp_write(tp, 0xF85C, 0xE00C);
+        mac_ocp_write(tp, 0xF85E, 0x4801);
+        mac_ocp_write(tp, 0xF860, 0x72E4);
+        mac_ocp_write(tp, 0xF862, 0x49AD);
+        mac_ocp_write(tp, 0xF864, 0xF108);
+        mac_ocp_write(tp, 0xF866, 0xC225);
+        mac_ocp_write(tp, 0xF868, 0x6741);
+        mac_ocp_write(tp, 0xF86A, 0x48F0);
+        mac_ocp_write(tp, 0xF86C, 0x8F41);
+        mac_ocp_write(tp, 0xF86E, 0x4870);
+        mac_ocp_write(tp, 0xF870, 0x8F41);
+        mac_ocp_write(tp, 0xF872, 0xC7CF);
+        mac_ocp_write(tp, 0xF874, 0x49B5);
+        mac_ocp_write(tp, 0xF876, 0xF01F);
+        mac_ocp_write(tp, 0xF878, 0x49B2);
+        mac_ocp_write(tp, 0xF87A, 0xF00B);
+        mac_ocp_write(tp, 0xF87C, 0x4980);
+        mac_ocp_write(tp, 0xF87E, 0xF003);
+        mac_ocp_write(tp, 0xF880, 0x484E);
+        mac_ocp_write(tp, 0xF882, 0x94E7);
+        mac_ocp_write(tp, 0xF884, 0x4981);
+        mac_ocp_write(tp, 0xF886, 0xF004);
+        mac_ocp_write(tp, 0xF888, 0x485E);
+        mac_ocp_write(tp, 0xF88A, 0xC212);
+        mac_ocp_write(tp, 0xF88C, 0x9543);
+        mac_ocp_write(tp, 0xF88E, 0xE071);
+        mac_ocp_write(tp, 0xF890, 0x49B6);
+        mac_ocp_write(tp, 0xF892, 0xF003);
+        mac_ocp_write(tp, 0xF894, 0x49B3);
+        mac_ocp_write(tp, 0xF896, 0xF10F);
+        mac_ocp_write(tp, 0xF898, 0x4980);
+        mac_ocp_write(tp, 0xF89A, 0xF003);
+        mac_ocp_write(tp, 0xF89C, 0x484E);
+        mac_ocp_write(tp, 0xF89E, 0x94E7);
+        mac_ocp_write(tp, 0xF8A0, 0x4981);
+        mac_ocp_write(tp, 0xF8A2, 0xF004);
+        mac_ocp_write(tp, 0xF8A4, 0x485E);
+        mac_ocp_write(tp, 0xF8A6, 0xC204);
+        mac_ocp_write(tp, 0xF8A8, 0x9543);
+        mac_ocp_write(tp, 0xF8AA, 0xE005);
+        mac_ocp_write(tp, 0xF8AC, 0xE000);
+        mac_ocp_write(tp, 0xF8AE, 0xE0FC);
+        mac_ocp_write(tp, 0xF8B0, 0xE0FA);
+        mac_ocp_write(tp, 0xF8B2, 0xE065);
+        mac_ocp_write(tp, 0xF8B4, 0x49B7);
+        mac_ocp_write(tp, 0xF8B6, 0xF007);
+        mac_ocp_write(tp, 0xF8B8, 0x4980);
+        mac_ocp_write(tp, 0xF8BA, 0xF005);
+        mac_ocp_write(tp, 0xF8BC, 0x1A38);
+        mac_ocp_write(tp, 0xF8BE, 0x46D4);
+        mac_ocp_write(tp, 0xF8C0, 0x1200);
+        mac_ocp_write(tp, 0xF8C2, 0xF109);
+        mac_ocp_write(tp, 0xF8C4, 0x4981);
+        mac_ocp_write(tp, 0xF8C6, 0xF055);
+        mac_ocp_write(tp, 0xF8C8, 0x49C3);
+        mac_ocp_write(tp, 0xF8CA, 0xF105);
+        mac_ocp_write(tp, 0xF8CC, 0x1A30);
+        mac_ocp_write(tp, 0xF8CE, 0x46D5);
+        mac_ocp_write(tp, 0xF8D0, 0x1200);
+        mac_ocp_write(tp, 0xF8D2, 0xF04F);
+        mac_ocp_write(tp, 0xF8D4, 0x7220);
+        mac_ocp_write(tp, 0xF8D6, 0x49A2);
+        mac_ocp_write(tp, 0xF8D8, 0xF130);
+        mac_ocp_write(tp, 0xF8DA, 0x49C1);
+        mac_ocp_write(tp, 0xF8DC, 0xF12E);
+        mac_ocp_write(tp, 0xF8DE, 0x49B0);
+        mac_ocp_write(tp, 0xF8E0, 0xF12C);
+        mac_ocp_write(tp, 0xF8E2, 0xC2E6);
+        mac_ocp_write(tp, 0xF8E4, 0x7240);
+        mac_ocp_write(tp, 0xF8E6, 0x49A8);
+        mac_ocp_write(tp, 0xF8E8, 0xF003);
+        mac_ocp_write(tp, 0xF8EA, 0x49D0);
+        mac_ocp_write(tp, 0xF8EC, 0xF126);
+        mac_ocp_write(tp, 0xF8EE, 0x49A9);
+        mac_ocp_write(tp, 0xF8F0, 0xF003);
+        mac_ocp_write(tp, 0xF8F2, 0x49D1);
+        mac_ocp_write(tp, 0xF8F4, 0xF122);
+        mac_ocp_write(tp, 0xF8F6, 0x49AA);
+        mac_ocp_write(tp, 0xF8F8, 0xF003);
+        mac_ocp_write(tp, 0xF8FA, 0x49D2);
+        mac_ocp_write(tp, 0xF8FC, 0xF11E);
+        mac_ocp_write(tp, 0xF8FE, 0x49AB);
+        mac_ocp_write(tp, 0xF900, 0xF003);
+        mac_ocp_write(tp, 0xF902, 0x49DF);
+        mac_ocp_write(tp, 0xF904, 0xF11A);
+        mac_ocp_write(tp, 0xF906, 0x49AC);
+        mac_ocp_write(tp, 0xF908, 0xF003);
+        mac_ocp_write(tp, 0xF90A, 0x49D3);
+        mac_ocp_write(tp, 0xF90C, 0xF116);
+        mac_ocp_write(tp, 0xF90E, 0x4980);
+        mac_ocp_write(tp, 0xF910, 0xF003);
+        mac_ocp_write(tp, 0xF912, 0x49C7);
+        mac_ocp_write(tp, 0xF914, 0xF105);
+        mac_ocp_write(tp, 0xF916, 0x4981);
+        mac_ocp_write(tp, 0xF918, 0xF02C);
+        mac_ocp_write(tp, 0xF91A, 0x49D7);
+        mac_ocp_write(tp, 0xF91C, 0xF02A);
+        mac_ocp_write(tp, 0xF91E, 0x49C0);
+        mac_ocp_write(tp, 0xF920, 0xF00C);
+        mac_ocp_write(tp, 0xF922, 0xC721);
+        mac_ocp_write(tp, 0xF924, 0x62F4);
+        mac_ocp_write(tp, 0xF926, 0x49A0);
+        mac_ocp_write(tp, 0xF928, 0xF008);
+        mac_ocp_write(tp, 0xF92A, 0x49A4);
+        mac_ocp_write(tp, 0xF92C, 0xF106);
+        mac_ocp_write(tp, 0xF92E, 0x4824);
+        mac_ocp_write(tp, 0xF930, 0x8AF4);
+        mac_ocp_write(tp, 0xF932, 0xC71A);
+        mac_ocp_write(tp, 0xF934, 0x1A40);
+        mac_ocp_write(tp, 0xF936, 0x9AE0);
+        mac_ocp_write(tp, 0xF938, 0x49B6);
+        mac_ocp_write(tp, 0xF93A, 0xF017);
+        mac_ocp_write(tp, 0xF93C, 0x200E);
+        mac_ocp_write(tp, 0xF93E, 0xC7B8);
+        mac_ocp_write(tp, 0xF940, 0x72E0);
+        mac_ocp_write(tp, 0xF942, 0x4710);
+        mac_ocp_write(tp, 0xF944, 0x92E1);
+        mac_ocp_write(tp, 0xF946, 0xC70E);
+        mac_ocp_write(tp, 0xF948, 0x77E0);
+        mac_ocp_write(tp, 0xF94A, 0x49F0);
+        mac_ocp_write(tp, 0xF94C, 0xF112);
+        mac_ocp_write(tp, 0xF94E, 0xC70B);
+        mac_ocp_write(tp, 0xF950, 0x77E0);
+        mac_ocp_write(tp, 0xF952, 0x27FE);
+        mac_ocp_write(tp, 0xF954, 0x1AFA);
+        mac_ocp_write(tp, 0xF956, 0x4317);
+        mac_ocp_write(tp, 0xF958, 0xC705);
+        mac_ocp_write(tp, 0xF95A, 0x9AE2);
+        mac_ocp_write(tp, 0xF95C, 0x1A11);
+        mac_ocp_write(tp, 0xF95E, 0x8AE0);
+        mac_ocp_write(tp, 0xF960, 0xE008);
+        mac_ocp_write(tp, 0xF962, 0xE41C);
+        mac_ocp_write(tp, 0xF964, 0xC0AE);
+        mac_ocp_write(tp, 0xF966, 0xD23A);
+        mac_ocp_write(tp, 0xF968, 0xC7A2);
+        mac_ocp_write(tp, 0xF96A, 0x74E6);
+        mac_ocp_write(tp, 0xF96C, 0x484F);
+        mac_ocp_write(tp, 0xF96E, 0x94E7);
+        mac_ocp_write(tp, 0xF970, 0xC79E);
+        mac_ocp_write(tp, 0xF972, 0x8CE6);
+        mac_ocp_write(tp, 0xF974, 0x8BEC);
+        mac_ocp_write(tp, 0xF976, 0xC29C);
+        mac_ocp_write(tp, 0xF978, 0x8D42);
+        mac_ocp_write(tp, 0xF97A, 0x7220);
+        mac_ocp_write(tp, 0xF97C, 0xB000);
+        mac_ocp_write(tp, 0xF97E, 0xC502);
+        mac_ocp_write(tp, 0xF980, 0xBD00);
+        mac_ocp_write(tp, 0xF982, 0x0932);
+        mac_ocp_write(tp, 0xF984, 0xB400);
+        mac_ocp_write(tp, 0xF986, 0xC240);
+        mac_ocp_write(tp, 0xF988, 0xC340);
+        mac_ocp_write(tp, 0xF98A, 0x7060);
+        mac_ocp_write(tp, 0xF98C, 0x498F);
+        mac_ocp_write(tp, 0xF98E, 0xF014);
+        mac_ocp_write(tp, 0xF990, 0x488F);
+        mac_ocp_write(tp, 0xF992, 0x9061);
+        mac_ocp_write(tp, 0xF994, 0x744C);
+        mac_ocp_write(tp, 0xF996, 0x49C3);
+        mac_ocp_write(tp, 0xF998, 0xF004);
+        mac_ocp_write(tp, 0xF99A, 0x7562);
+        mac_ocp_write(tp, 0xF99C, 0x485E);
+        mac_ocp_write(tp, 0xF99E, 0x9563);
+        mac_ocp_write(tp, 0xF9A0, 0x7446);
+        mac_ocp_write(tp, 0xF9A2, 0x49C3);
+        mac_ocp_write(tp, 0xF9A4, 0xF106);
+        mac_ocp_write(tp, 0xF9A6, 0x7562);
+        mac_ocp_write(tp, 0xF9A8, 0x1C30);
+        mac_ocp_write(tp, 0xF9AA, 0x46E5);
+        mac_ocp_write(tp, 0xF9AC, 0x1200);
+        mac_ocp_write(tp, 0xF9AE, 0xF004);
+        mac_ocp_write(tp, 0xF9B0, 0x7446);
+        mac_ocp_write(tp, 0xF9B2, 0x484F);
+        mac_ocp_write(tp, 0xF9B4, 0x9447);
+        mac_ocp_write(tp, 0xF9B6, 0xC32A);
+        mac_ocp_write(tp, 0xF9B8, 0x7466);
+        mac_ocp_write(tp, 0xF9BA, 0x49C0);
+        mac_ocp_write(tp, 0xF9BC, 0xF00F);
+        mac_ocp_write(tp, 0xF9BE, 0x48C0);
+        mac_ocp_write(tp, 0xF9C0, 0x9C66);
+        mac_ocp_write(tp, 0xF9C2, 0x7446);
+        mac_ocp_write(tp, 0xF9C4, 0x4840);
+        mac_ocp_write(tp, 0xF9C6, 0x4841);
+        mac_ocp_write(tp, 0xF9C8, 0x4842);
+        mac_ocp_write(tp, 0xF9CA, 0x9C46);
+        mac_ocp_write(tp, 0xF9CC, 0x744C);
+        mac_ocp_write(tp, 0xF9CE, 0x4840);
+        mac_ocp_write(tp, 0xF9D0, 0x9C4C);
+        mac_ocp_write(tp, 0xF9D2, 0x744A);
+        mac_ocp_write(tp, 0xF9D4, 0x484A);
+        mac_ocp_write(tp, 0xF9D6, 0x9C4A);
+        mac_ocp_write(tp, 0xF9D8, 0xE013);
+        mac_ocp_write(tp, 0xF9DA, 0x498E);
+        mac_ocp_write(tp, 0xF9DC, 0xF011);
+        mac_ocp_write(tp, 0xF9DE, 0x488E);
+        mac_ocp_write(tp, 0xF9E0, 0x9061);
+        mac_ocp_write(tp, 0xF9E2, 0x744C);
+        mac_ocp_write(tp, 0xF9E4, 0x49C3);
+        mac_ocp_write(tp, 0xF9E6, 0xF004);
+        mac_ocp_write(tp, 0xF9E8, 0x7446);
+        mac_ocp_write(tp, 0xF9EA, 0x484E);
+        mac_ocp_write(tp, 0xF9EC, 0x9447);
+        mac_ocp_write(tp, 0xF9EE, 0x7446);
+        mac_ocp_write(tp, 0xF9F0, 0x1D38);
+        mac_ocp_write(tp, 0xF9F2, 0x46EC);
+        mac_ocp_write(tp, 0xF9F4, 0x1500);
+        mac_ocp_write(tp, 0xF9F6, 0xF004);
+        mac_ocp_write(tp, 0xF9F8, 0x7446);
+        mac_ocp_write(tp, 0xF9FA, 0x484F);
+        mac_ocp_write(tp, 0xF9FC, 0x9447);
+        mac_ocp_write(tp, 0xF9FE, 0xB000);
+        mac_ocp_write(tp, 0xFA00, 0xC502);
+        mac_ocp_write(tp, 0xFA02, 0xBD00);
+        mac_ocp_write(tp, 0xFA04, 0x074C);
+        mac_ocp_write(tp, 0xFA06, 0xE000);
+        mac_ocp_write(tp, 0xFA08, 0xE0FC);
+        mac_ocp_write(tp, 0xFA0A, 0xE0C0);
+        mac_ocp_write(tp, 0xFA0C, 0x4830);
+        mac_ocp_write(tp, 0xFA0E, 0x4837);
+        mac_ocp_write(tp, 0xFA10, 0xC502);
+        mac_ocp_write(tp, 0xFA12, 0xBD00);
+        mac_ocp_write(tp, 0xFA14, 0x0978);
+        mac_ocp_write(tp, 0xFA16, 0x63E2);
+        mac_ocp_write(tp, 0xFA18, 0x4830);
+        mac_ocp_write(tp, 0xFA1A, 0x4837);
+        mac_ocp_write(tp, 0xFA1C, 0xC502);
+        mac_ocp_write(tp, 0xFA1E, 0xBD00);
+        mac_ocp_write(tp, 0xFA20, 0x09FE);
+        mac_ocp_write(tp, 0xFA22, 0x73E2);
+        mac_ocp_write(tp, 0xFA24, 0x4830);
+        mac_ocp_write(tp, 0xFA26, 0x8BE2);
+        mac_ocp_write(tp, 0xFA28, 0xC302);
+        mac_ocp_write(tp, 0xFA2A, 0xBB00);
+        mac_ocp_write(tp, 0xFA2C, 0x0A12);
+        mac_ocp_write(tp, 0xFA2E, 0x73E2);
+        mac_ocp_write(tp, 0xFA30, 0x48B0);
+        mac_ocp_write(tp, 0xFA32, 0x48B3);
+        mac_ocp_write(tp, 0xFA34, 0x48B4);
+        mac_ocp_write(tp, 0xFA36, 0x48B5);
+        mac_ocp_write(tp, 0xFA38, 0x48B6);
+        mac_ocp_write(tp, 0xFA3A, 0x48B7);
+        mac_ocp_write(tp, 0xFA3C, 0x8BE2);
+        mac_ocp_write(tp, 0xFA3E, 0xC302);
+        mac_ocp_write(tp, 0xFA40, 0xBB00);
+        mac_ocp_write(tp, 0xFA42, 0x0A5A);
+        mac_ocp_write(tp, 0xFA44, 0x73E2);
+        mac_ocp_write(tp, 0xFA46, 0x4830);
+        mac_ocp_write(tp, 0xFA48, 0x8BE2);
+        mac_ocp_write(tp, 0xFA4A, 0xC302);
+        mac_ocp_write(tp, 0xFA4C, 0xBB00);
+        mac_ocp_write(tp, 0xFA4E, 0x0A6C);
+        mac_ocp_write(tp, 0xFA50, 0x73E2);
+        mac_ocp_write(tp, 0xFA52, 0x4830);
+        mac_ocp_write(tp, 0xFA54, 0x4837);
+        mac_ocp_write(tp, 0xFA56, 0xC502);
+        mac_ocp_write(tp, 0xFA58, 0xBD00);
+        mac_ocp_write(tp, 0xFA5A, 0x0A86);
+
+        mac_ocp_write(tp, 0xFC26, 0x8000);
+
+        mac_ocp_write(tp, 0xFC28, 0x0890);
+        mac_ocp_write(tp, 0xFC2A, 0x0712);
+        mac_ocp_write(tp, 0xFC2C, 0x0974);
+        mac_ocp_write(tp, 0xFC2E, 0x09FC);
+        mac_ocp_write(tp, 0xFC30, 0x0A0E);
+        mac_ocp_write(tp, 0xFC32, 0x0A56);
+        mac_ocp_write(tp, 0xFC34, 0x0A68);
+        mac_ocp_write(tp, 0xFC36, 0x0A84);
+
+        if (tp->HwPkgDet == 0x0)
+                mac_ocp_write(tp, 0xFC38, 0x00FC);
+        else if(tp->HwPkgDet == 0xF)
+                mac_ocp_write(tp, 0xFC38, 0x00FF);
+}
+
+static void
+rtl8168_set_mac_mcu_8168fp_2(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        rtl8168_hw_disable_mac_mcu_bps(dev);
+
+        mac_ocp_write(tp, 0xF800, 0xE008);
+        mac_ocp_write(tp, 0xF802, 0xE00A);
+        mac_ocp_write(tp, 0xF804, 0xE031);
+        mac_ocp_write(tp, 0xF806, 0xE033);
+        mac_ocp_write(tp, 0xF808, 0xE035);
+        mac_ocp_write(tp, 0xF80A, 0xE144);
+        mac_ocp_write(tp, 0xF80C, 0xE166);
+        mac_ocp_write(tp, 0xF80E, 0xE168);
+        mac_ocp_write(tp, 0xF810, 0xC502);
+        mac_ocp_write(tp, 0xF812, 0xBD00);
+        mac_ocp_write(tp, 0xF814, 0x0000);
+        mac_ocp_write(tp, 0xF816, 0xC725);
+        mac_ocp_write(tp, 0xF818, 0x75E0);
+        mac_ocp_write(tp, 0xF81A, 0x48D0);
+        mac_ocp_write(tp, 0xF81C, 0x9DE0);
+        mac_ocp_write(tp, 0xF81E, 0xC722);
+        mac_ocp_write(tp, 0xF820, 0x75E0);
+        mac_ocp_write(tp, 0xF822, 0x1C78);
+        mac_ocp_write(tp, 0xF824, 0x416C);
+        mac_ocp_write(tp, 0xF826, 0x1530);
+        mac_ocp_write(tp, 0xF828, 0xF111);
+        mac_ocp_write(tp, 0xF82A, 0xC71D);
+        mac_ocp_write(tp, 0xF82C, 0x75F6);
+        mac_ocp_write(tp, 0xF82E, 0x49D1);
+        mac_ocp_write(tp, 0xF830, 0xF00D);
+        mac_ocp_write(tp, 0xF832, 0x75E0);
+        mac_ocp_write(tp, 0xF834, 0x1C1F);
+        mac_ocp_write(tp, 0xF836, 0x416C);
+        mac_ocp_write(tp, 0xF838, 0x1502);
+        mac_ocp_write(tp, 0xF83A, 0xF108);
+        mac_ocp_write(tp, 0xF83C, 0x75FA);
+        mac_ocp_write(tp, 0xF83E, 0x49D3);
+        mac_ocp_write(tp, 0xF840, 0xF005);
+        mac_ocp_write(tp, 0xF842, 0x75EC);
+        mac_ocp_write(tp, 0xF844, 0x9DE4);
+        mac_ocp_write(tp, 0xF846, 0x4853);
+        mac_ocp_write(tp, 0xF848, 0x9DFA);
+        mac_ocp_write(tp, 0xF84A, 0xC70B);
+        mac_ocp_write(tp, 0xF84C, 0x75E0);
+        mac_ocp_write(tp, 0xF84E, 0x4852);
+        mac_ocp_write(tp, 0xF850, 0x4850);
+        mac_ocp_write(tp, 0xF852, 0x9DE0);
+        mac_ocp_write(tp, 0xF854, 0xC602);
+        mac_ocp_write(tp, 0xF856, 0xBE00);
+        mac_ocp_write(tp, 0xF858, 0x04B8);
+        mac_ocp_write(tp, 0xF85A, 0xE420);
+        mac_ocp_write(tp, 0xF85C, 0xE000);
+        mac_ocp_write(tp, 0xF85E, 0xE0FC);
+        mac_ocp_write(tp, 0xF860, 0xE43C);
+        mac_ocp_write(tp, 0xF862, 0xDC00);
+        mac_ocp_write(tp, 0xF864, 0xEB00);
+        mac_ocp_write(tp, 0xF866, 0xC202);
+        mac_ocp_write(tp, 0xF868, 0xBA00);
+        mac_ocp_write(tp, 0xF86A, 0x0000);
+        mac_ocp_write(tp, 0xF86C, 0xC002);
+        mac_ocp_write(tp, 0xF86E, 0xB800);
+        mac_ocp_write(tp, 0xF870, 0x0000);
+        mac_ocp_write(tp, 0xF872, 0xB401);
+        mac_ocp_write(tp, 0xF874, 0xB402);
+        mac_ocp_write(tp, 0xF876, 0xB403);
+        mac_ocp_write(tp, 0xF878, 0xB404);
+        mac_ocp_write(tp, 0xF87A, 0xB405);
+        mac_ocp_write(tp, 0xF87C, 0xB406);
+        mac_ocp_write(tp, 0xF87E, 0xC44D);
+        mac_ocp_write(tp, 0xF880, 0xC54D);
+        mac_ocp_write(tp, 0xF882, 0x1867);
+        mac_ocp_write(tp, 0xF884, 0xE8A2);
+        mac_ocp_write(tp, 0xF886, 0x2318);
+        mac_ocp_write(tp, 0xF888, 0x276E);
+        mac_ocp_write(tp, 0xF88A, 0x1601);
+        mac_ocp_write(tp, 0xF88C, 0xF106);
+        mac_ocp_write(tp, 0xF88E, 0x1A07);
+        mac_ocp_write(tp, 0xF890, 0xE861);
+        mac_ocp_write(tp, 0xF892, 0xE86B);
+        mac_ocp_write(tp, 0xF894, 0xE873);
+        mac_ocp_write(tp, 0xF896, 0xE037);
+        mac_ocp_write(tp, 0xF898, 0x231E);
+        mac_ocp_write(tp, 0xF89A, 0x276E);
+        mac_ocp_write(tp, 0xF89C, 0x1602);
+        mac_ocp_write(tp, 0xF89E, 0xF10B);
+        mac_ocp_write(tp, 0xF8A0, 0x1A07);
+        mac_ocp_write(tp, 0xF8A2, 0xE858);
+        mac_ocp_write(tp, 0xF8A4, 0xE862);
+        mac_ocp_write(tp, 0xF8A6, 0xC247);
+        mac_ocp_write(tp, 0xF8A8, 0xC344);
+        mac_ocp_write(tp, 0xF8AA, 0xE8E3);
+        mac_ocp_write(tp, 0xF8AC, 0xC73B);
+        mac_ocp_write(tp, 0xF8AE, 0x66E0);
+        mac_ocp_write(tp, 0xF8B0, 0xE8B5);
+        mac_ocp_write(tp, 0xF8B2, 0xE029);
+        mac_ocp_write(tp, 0xF8B4, 0x231A);
+        mac_ocp_write(tp, 0xF8B6, 0x276C);
+        mac_ocp_write(tp, 0xF8B8, 0xC733);
+        mac_ocp_write(tp, 0xF8BA, 0x9EE0);
+        mac_ocp_write(tp, 0xF8BC, 0x1866);
+        mac_ocp_write(tp, 0xF8BE, 0xE885);
+        mac_ocp_write(tp, 0xF8C0, 0x251C);
+        mac_ocp_write(tp, 0xF8C2, 0x120F);
+        mac_ocp_write(tp, 0xF8C4, 0xF011);
+        mac_ocp_write(tp, 0xF8C6, 0x1209);
+        mac_ocp_write(tp, 0xF8C8, 0xF011);
+        mac_ocp_write(tp, 0xF8CA, 0x2014);
+        mac_ocp_write(tp, 0xF8CC, 0x240E);
+        mac_ocp_write(tp, 0xF8CE, 0x1000);
+        mac_ocp_write(tp, 0xF8D0, 0xF007);
+        mac_ocp_write(tp, 0xF8D2, 0x120C);
+        mac_ocp_write(tp, 0xF8D4, 0xF00D);
+        mac_ocp_write(tp, 0xF8D6, 0x1203);
+        mac_ocp_write(tp, 0xF8D8, 0xF00D);
+        mac_ocp_write(tp, 0xF8DA, 0x1200);
+        mac_ocp_write(tp, 0xF8DC, 0xF00D);
+        mac_ocp_write(tp, 0xF8DE, 0x120C);
+        mac_ocp_write(tp, 0xF8E0, 0xF00D);
+        mac_ocp_write(tp, 0xF8E2, 0x1203);
+        mac_ocp_write(tp, 0xF8E4, 0xF00D);
+        mac_ocp_write(tp, 0xF8E6, 0x1A03);
+        mac_ocp_write(tp, 0xF8E8, 0xE00C);
+        mac_ocp_write(tp, 0xF8EA, 0x1A07);
+        mac_ocp_write(tp, 0xF8EC, 0xE00A);
+        mac_ocp_write(tp, 0xF8EE, 0x1A00);
+        mac_ocp_write(tp, 0xF8F0, 0xE008);
+        mac_ocp_write(tp, 0xF8F2, 0x1A01);
+        mac_ocp_write(tp, 0xF8F4, 0xE006);
+        mac_ocp_write(tp, 0xF8F6, 0x1A02);
+        mac_ocp_write(tp, 0xF8F8, 0xE004);
+        mac_ocp_write(tp, 0xF8FA, 0x1A04);
+        mac_ocp_write(tp, 0xF8FC, 0xE002);
+        mac_ocp_write(tp, 0xF8FE, 0x1A05);
+        mac_ocp_write(tp, 0xF900, 0xE829);
+        mac_ocp_write(tp, 0xF902, 0xE833);
+        mac_ocp_write(tp, 0xF904, 0xB006);
+        mac_ocp_write(tp, 0xF906, 0xB005);
+        mac_ocp_write(tp, 0xF908, 0xB004);
+        mac_ocp_write(tp, 0xF90A, 0xB003);
+        mac_ocp_write(tp, 0xF90C, 0xB002);
+        mac_ocp_write(tp, 0xF90E, 0xB001);
+        mac_ocp_write(tp, 0xF910, 0x60C4);
+        mac_ocp_write(tp, 0xF912, 0xC702);
+        mac_ocp_write(tp, 0xF914, 0xBF00);
+        mac_ocp_write(tp, 0xF916, 0x2786);
+        mac_ocp_write(tp, 0xF918, 0xDD00);
+        mac_ocp_write(tp, 0xF91A, 0xD030);
+        mac_ocp_write(tp, 0xF91C, 0xE0C4);
+        mac_ocp_write(tp, 0xF91E, 0xE0F8);
+        mac_ocp_write(tp, 0xF920, 0xDC42);
+        mac_ocp_write(tp, 0xF922, 0xD3F0);
+        mac_ocp_write(tp, 0xF924, 0x0000);
+        mac_ocp_write(tp, 0xF926, 0x0004);
+        mac_ocp_write(tp, 0xF928, 0x0007);
+        mac_ocp_write(tp, 0xF92A, 0x0014);
+        mac_ocp_write(tp, 0xF92C, 0x0090);
+        mac_ocp_write(tp, 0xF92E, 0x1000);
+        mac_ocp_write(tp, 0xF930, 0x0F00);
+        mac_ocp_write(tp, 0xF932, 0x1004);
+        mac_ocp_write(tp, 0xF934, 0x1008);
+        mac_ocp_write(tp, 0xF936, 0x3000);
+        mac_ocp_write(tp, 0xF938, 0x3004);
+        mac_ocp_write(tp, 0xF93A, 0x3008);
+        mac_ocp_write(tp, 0xF93C, 0x4000);
+        mac_ocp_write(tp, 0xF93E, 0x7777);
+        mac_ocp_write(tp, 0xF940, 0x8000);
+        mac_ocp_write(tp, 0xF942, 0x8001);
+        mac_ocp_write(tp, 0xF944, 0x8008);
+        mac_ocp_write(tp, 0xF946, 0x8003);
+        mac_ocp_write(tp, 0xF948, 0x8004);
+        mac_ocp_write(tp, 0xF94A, 0xC000);
+        mac_ocp_write(tp, 0xF94C, 0xC004);
+        mac_ocp_write(tp, 0xF94E, 0xF004);
+        mac_ocp_write(tp, 0xF950, 0xFFFF);
+        mac_ocp_write(tp, 0xF952, 0xB406);
+        mac_ocp_write(tp, 0xF954, 0xB407);
+        mac_ocp_write(tp, 0xF956, 0xC6E5);
+        mac_ocp_write(tp, 0xF958, 0x77C0);
+        mac_ocp_write(tp, 0xF95A, 0x27F3);
+        mac_ocp_write(tp, 0xF95C, 0x23F3);
+        mac_ocp_write(tp, 0xF95E, 0x47FA);
+        mac_ocp_write(tp, 0xF960, 0x9FC0);
+        mac_ocp_write(tp, 0xF962, 0xB007);
+        mac_ocp_write(tp, 0xF964, 0xB006);
+        mac_ocp_write(tp, 0xF966, 0xFF80);
+        mac_ocp_write(tp, 0xF968, 0xB405);
+        mac_ocp_write(tp, 0xF96A, 0xB407);
+        mac_ocp_write(tp, 0xF96C, 0xC7D8);
+        mac_ocp_write(tp, 0xF96E, 0x75E0);
+        mac_ocp_write(tp, 0xF970, 0x48D0);
+        mac_ocp_write(tp, 0xF972, 0x9DE0);
+        mac_ocp_write(tp, 0xF974, 0xB007);
+        mac_ocp_write(tp, 0xF976, 0xB005);
+        mac_ocp_write(tp, 0xF978, 0xFF80);
+        mac_ocp_write(tp, 0xF97A, 0xB401);
+        mac_ocp_write(tp, 0xF97C, 0xC0EA);
+        mac_ocp_write(tp, 0xF97E, 0xC2DC);
+        mac_ocp_write(tp, 0xF980, 0xC3D8);
+        mac_ocp_write(tp, 0xF982, 0xE865);
+        mac_ocp_write(tp, 0xF984, 0xC0D3);
+        mac_ocp_write(tp, 0xF986, 0xC1E0);
+        mac_ocp_write(tp, 0xF988, 0xC2E3);
+        mac_ocp_write(tp, 0xF98A, 0xE861);
+        mac_ocp_write(tp, 0xF98C, 0xE817);
+        mac_ocp_write(tp, 0xF98E, 0xC0CD);
+        mac_ocp_write(tp, 0xF990, 0xC2CF);
+        mac_ocp_write(tp, 0xF992, 0xE85D);
+        mac_ocp_write(tp, 0xF994, 0xC0C9);
+        mac_ocp_write(tp, 0xF996, 0xC1D6);
+        mac_ocp_write(tp, 0xF998, 0xC2DB);
+        mac_ocp_write(tp, 0xF99A, 0xE859);
+        mac_ocp_write(tp, 0xF99C, 0xE80F);
+        mac_ocp_write(tp, 0xF99E, 0xC1C7);
+        mac_ocp_write(tp, 0xF9A0, 0xC2CE);
+        mac_ocp_write(tp, 0xF9A2, 0xE855);
+        mac_ocp_write(tp, 0xF9A4, 0xC0C0);
+        mac_ocp_write(tp, 0xF9A6, 0xC1D1);
+        mac_ocp_write(tp, 0xF9A8, 0xC2D3);
+        mac_ocp_write(tp, 0xF9AA, 0xE851);
+        mac_ocp_write(tp, 0xF9AC, 0xE807);
+        mac_ocp_write(tp, 0xF9AE, 0xC0BE);
+        mac_ocp_write(tp, 0xF9B0, 0xC2C2);
+        mac_ocp_write(tp, 0xF9B2, 0xE84D);
+        mac_ocp_write(tp, 0xF9B4, 0xE803);
+        mac_ocp_write(tp, 0xF9B6, 0xB001);
+        mac_ocp_write(tp, 0xF9B8, 0xFF80);
+        mac_ocp_write(tp, 0xF9BA, 0xB402);
+        mac_ocp_write(tp, 0xF9BC, 0xC2C6);
+        mac_ocp_write(tp, 0xF9BE, 0xE859);
+        mac_ocp_write(tp, 0xF9C0, 0x499F);
+        mac_ocp_write(tp, 0xF9C2, 0xF1FE);
+        mac_ocp_write(tp, 0xF9C4, 0xB002);
+        mac_ocp_write(tp, 0xF9C6, 0xFF80);
+        mac_ocp_write(tp, 0xF9C8, 0xB402);
+        mac_ocp_write(tp, 0xF9CA, 0xB403);
+        mac_ocp_write(tp, 0xF9CC, 0xB407);
+        mac_ocp_write(tp, 0xF9CE, 0xE821);
+        mac_ocp_write(tp, 0xF9D0, 0x8882);
+        mac_ocp_write(tp, 0xF9D2, 0x1980);
+        mac_ocp_write(tp, 0xF9D4, 0x8983);
+        mac_ocp_write(tp, 0xF9D6, 0xE81D);
+        mac_ocp_write(tp, 0xF9D8, 0x7180);
+        mac_ocp_write(tp, 0xF9DA, 0x218B);
+        mac_ocp_write(tp, 0xF9DC, 0x25BB);
+        mac_ocp_write(tp, 0xF9DE, 0x1310);
+        mac_ocp_write(tp, 0xF9E0, 0xF014);
+        mac_ocp_write(tp, 0xF9E2, 0x1310);
+        mac_ocp_write(tp, 0xF9E4, 0xFB03);
+        mac_ocp_write(tp, 0xF9E6, 0x1F20);
+        mac_ocp_write(tp, 0xF9E8, 0x38FB);
+        mac_ocp_write(tp, 0xF9EA, 0x3288);
+        mac_ocp_write(tp, 0xF9EC, 0x434B);
+        mac_ocp_write(tp, 0xF9EE, 0x2491);
+        mac_ocp_write(tp, 0xF9F0, 0x430B);
+        mac_ocp_write(tp, 0xF9F2, 0x1F0F);
+        mac_ocp_write(tp, 0xF9F4, 0x38FB);
+        mac_ocp_write(tp, 0xF9F6, 0x4313);
+        mac_ocp_write(tp, 0xF9F8, 0x2121);
+        mac_ocp_write(tp, 0xF9FA, 0x4353);
+        mac_ocp_write(tp, 0xF9FC, 0x2521);
+        mac_ocp_write(tp, 0xF9FE, 0x418A);
+        mac_ocp_write(tp, 0xFA00, 0x6282);
+        mac_ocp_write(tp, 0xFA02, 0x2527);
+        mac_ocp_write(tp, 0xFA04, 0x212F);
+        mac_ocp_write(tp, 0xFA06, 0x418A);
+        mac_ocp_write(tp, 0xFA08, 0xB007);
+        mac_ocp_write(tp, 0xFA0A, 0xB003);
+        mac_ocp_write(tp, 0xFA0C, 0xB002);
+        mac_ocp_write(tp, 0xFA0E, 0xFF80);
+        mac_ocp_write(tp, 0xFA10, 0x6183);
+        mac_ocp_write(tp, 0xFA12, 0x2496);
+        mac_ocp_write(tp, 0xFA14, 0x1100);
+        mac_ocp_write(tp, 0xFA16, 0xF1FD);
+        mac_ocp_write(tp, 0xFA18, 0xFF80);
+        mac_ocp_write(tp, 0xFA1A, 0x4800);
+        mac_ocp_write(tp, 0xFA1C, 0x4801);
+        mac_ocp_write(tp, 0xFA1E, 0xC213);
+        mac_ocp_write(tp, 0xFA20, 0xC313);
+        mac_ocp_write(tp, 0xFA22, 0xE815);
+        mac_ocp_write(tp, 0xFA24, 0x4860);
+        mac_ocp_write(tp, 0xFA26, 0x8EE0);
+        mac_ocp_write(tp, 0xFA28, 0xC210);
+        mac_ocp_write(tp, 0xFA2A, 0xC310);
+        mac_ocp_write(tp, 0xFA2C, 0xE822);
+        mac_ocp_write(tp, 0xFA2E, 0x481E);
+        mac_ocp_write(tp, 0xFA30, 0xC20C);
+        mac_ocp_write(tp, 0xFA32, 0xC30C);
+        mac_ocp_write(tp, 0xFA34, 0xE80C);
+        mac_ocp_write(tp, 0xFA36, 0xC206);
+        mac_ocp_write(tp, 0xFA38, 0x7358);
+        mac_ocp_write(tp, 0xFA3A, 0x483A);
+        mac_ocp_write(tp, 0xFA3C, 0x9B58);
+        mac_ocp_write(tp, 0xFA3E, 0xFF80);
+        mac_ocp_write(tp, 0xFA40, 0xE8E0);
+        mac_ocp_write(tp, 0xFA42, 0xE000);
+        mac_ocp_write(tp, 0xFA44, 0x1008);
+        mac_ocp_write(tp, 0xFA46, 0x0F00);
+        mac_ocp_write(tp, 0xFA48, 0x800C);
+        mac_ocp_write(tp, 0xFA4A, 0x0F00);
+        mac_ocp_write(tp, 0xFA4C, 0xB407);
+        mac_ocp_write(tp, 0xFA4E, 0xB406);
+        mac_ocp_write(tp, 0xFA50, 0xB403);
+        mac_ocp_write(tp, 0xFA52, 0xC7F7);
+        mac_ocp_write(tp, 0xFA54, 0x98E0);
+        mac_ocp_write(tp, 0xFA56, 0x99E2);
+        mac_ocp_write(tp, 0xFA58, 0x9AE4);
+        mac_ocp_write(tp, 0xFA5A, 0x21B2);
+        mac_ocp_write(tp, 0xFA5C, 0x4831);
+        mac_ocp_write(tp, 0xFA5E, 0x483F);
+        mac_ocp_write(tp, 0xFA60, 0x9BE6);
+        mac_ocp_write(tp, 0xFA62, 0x66E7);
+        mac_ocp_write(tp, 0xFA64, 0x49E6);
+        mac_ocp_write(tp, 0xFA66, 0xF1FE);
+        mac_ocp_write(tp, 0xFA68, 0xB003);
+        mac_ocp_write(tp, 0xFA6A, 0xB006);
+        mac_ocp_write(tp, 0xFA6C, 0xB007);
+        mac_ocp_write(tp, 0xFA6E, 0xFF80);
+        mac_ocp_write(tp, 0xFA70, 0xB407);
+        mac_ocp_write(tp, 0xFA72, 0xB406);
+        mac_ocp_write(tp, 0xFA74, 0xB403);
+        mac_ocp_write(tp, 0xFA76, 0xC7E5);
+        mac_ocp_write(tp, 0xFA78, 0x9AE4);
+        mac_ocp_write(tp, 0xFA7A, 0x21B2);
+        mac_ocp_write(tp, 0xFA7C, 0x4831);
+        mac_ocp_write(tp, 0xFA7E, 0x9BE6);
+        mac_ocp_write(tp, 0xFA80, 0x66E7);
+        mac_ocp_write(tp, 0xFA82, 0x49E6);
+        mac_ocp_write(tp, 0xFA84, 0xF1FE);
+        mac_ocp_write(tp, 0xFA86, 0x70E0);
+        mac_ocp_write(tp, 0xFA88, 0x71E2);
+        mac_ocp_write(tp, 0xFA8A, 0xB003);
+        mac_ocp_write(tp, 0xFA8C, 0xB006);
+        mac_ocp_write(tp, 0xFA8E, 0xB007);
+        mac_ocp_write(tp, 0xFA90, 0xFF80);
+        mac_ocp_write(tp, 0xFA92, 0x4882);
+        mac_ocp_write(tp, 0xFA94, 0xB406);
+        mac_ocp_write(tp, 0xFA96, 0xB405);
+        mac_ocp_write(tp, 0xFA98, 0xC71E);
+        mac_ocp_write(tp, 0xFA9A, 0x76E0);
+        mac_ocp_write(tp, 0xFA9C, 0x1D78);
+        mac_ocp_write(tp, 0xFA9E, 0x4175);
+        mac_ocp_write(tp, 0xFAA0, 0x1630);
+        mac_ocp_write(tp, 0xFAA2, 0xF10C);
+        mac_ocp_write(tp, 0xFAA4, 0xC715);
+        mac_ocp_write(tp, 0xFAA6, 0x76E0);
+        mac_ocp_write(tp, 0xFAA8, 0x4861);
+        mac_ocp_write(tp, 0xFAAA, 0x9EE0);
+        mac_ocp_write(tp, 0xFAAC, 0xC713);
+        mac_ocp_write(tp, 0xFAAE, 0x1EFF);
+        mac_ocp_write(tp, 0xFAB0, 0x9EE2);
+        mac_ocp_write(tp, 0xFAB2, 0x75E0);
+        mac_ocp_write(tp, 0xFAB4, 0x4850);
+        mac_ocp_write(tp, 0xFAB6, 0x9DE0);
+        mac_ocp_write(tp, 0xFAB8, 0xE005);
+        mac_ocp_write(tp, 0xFABA, 0xC70B);
+        mac_ocp_write(tp, 0xFABC, 0x76E0);
+        mac_ocp_write(tp, 0xFABE, 0x4865);
+        mac_ocp_write(tp, 0xFAC0, 0x9EE0);
+        mac_ocp_write(tp, 0xFAC2, 0xB005);
+        mac_ocp_write(tp, 0xFAC4, 0xB006);
+        mac_ocp_write(tp, 0xFAC6, 0xC708);
+        mac_ocp_write(tp, 0xFAC8, 0xC102);
+        mac_ocp_write(tp, 0xFACA, 0xB900);
+        mac_ocp_write(tp, 0xFACC, 0x279E);
+        mac_ocp_write(tp, 0xFACE, 0xEB16);
+        mac_ocp_write(tp, 0xFAD0, 0xEB00);
+        mac_ocp_write(tp, 0xFAD2, 0xE43C);
+        mac_ocp_write(tp, 0xFAD4, 0xDC00);
+        mac_ocp_write(tp, 0xFAD6, 0xD3EC);
+        mac_ocp_write(tp, 0xFAD8, 0xC602);
+        mac_ocp_write(tp, 0xFADA, 0xBE00);
+        mac_ocp_write(tp, 0xFADC, 0x0000);
+        mac_ocp_write(tp, 0xFADE, 0xC602);
+        mac_ocp_write(tp, 0xFAE0, 0xBE00);
+        mac_ocp_write(tp, 0xFAE2, 0x0000);
+
+        mac_ocp_write(tp, 0xFC26, 0x8000);
+
+        mac_ocp_write(tp, 0xFC28, 0x0000);
+        mac_ocp_write(tp, 0xFC2A, 0x04B4);
+        mac_ocp_write(tp, 0xFC2C, 0x0000);
+        mac_ocp_write(tp, 0xFC2E, 0x0000);
+        mac_ocp_write(tp, 0xFC30, 0x0000);
+        mac_ocp_write(tp, 0xFC32, 0x279C);
+        mac_ocp_write(tp, 0xFC34, 0x0000);
+        mac_ocp_write(tp, 0xFC36, 0x0000);
+
+        mac_ocp_write(tp, 0xFC38, 0x0022);
+}
+
+static void
+rtl8168_hw_mac_mcu_config(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        if (tp->NotWrMcuPatchCode == TRUE) return;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+                rtl8168_set_mac_mcu_8168g_1(dev);
+                break;
+        case CFG_METHOD_24:
+                rtl8168_set_mac_mcu_8168gu_1(dev);
+                break;
+        case CFG_METHOD_25:
+                rtl8168_set_mac_mcu_8168gu_2(dev);
+                break;
+        case CFG_METHOD_26:
+                rtl8168_set_mac_mcu_8411b_1(dev);
+                break;
+        case CFG_METHOD_27:
+                rtl8168_set_mac_mcu_8168ep_1(dev);
+                break;
+        case CFG_METHOD_28:
+                rtl8168_set_mac_mcu_8168ep_2(dev);
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                rtl8168_set_mac_mcu_8168h_1(dev);
+                break;
+        case CFG_METHOD_31:
+                if (tp->HwPkgDet == 0x00 || tp->HwPkgDet == 0x0F)
+                        rtl8168_set_mac_mcu_8168fp_1(dev);
+                else if (tp->HwPkgDet == 0x06)
+                        rtl8168_set_mac_mcu_8168fp_2(dev);
+                break;
+        case CFG_METHOD_32:
+                rtl8168_hw_disable_mac_mcu_bps(dev);
+                break;
+        }
+}
+
+static void
+rtl8168_hw_init(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        unsigned long flags;
+        u32 csi_tmp;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                rtl8168_enable_cfg9346_write(tp);
+                RTL_W8(Config5, RTL_R8(Config5) & ~BIT_0);
+                RTL_W8(Config2, RTL_R8(Config2) & ~BIT_7);
+                rtl8168_disable_cfg9346_write(tp);
+                RTL_W8(0xF1, RTL_R8(0xF1) & ~BIT_7);
+                break;
+        }
+
+        //Disable UPS
+        switch (tp->mcfg) {
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                mac_ocp_write(tp, 0xD400, mac_ocp_read( tp, 0xD400) & ~(BIT_0));
+                break;
+        }
+
+        //Disable DMA Aggregation
+        switch (tp->mcfg) {
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                mac_ocp_write(tp, 0xE63E, mac_ocp_read( tp, 0xE63E) & ~(BIT_3 | BIT_2 | BIT_1));
+                mac_ocp_write(tp, 0xE63E, mac_ocp_read( tp, 0xE63E) | (BIT_0));
+                mac_ocp_write(tp, 0xE63E, mac_ocp_read( tp, 0xE63E) & ~(BIT_0));
+                mac_ocp_write(tp, 0xC094, 0x0);
+                mac_ocp_write(tp, 0xC09E, 0x0);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_9:
+        case CFG_METHOD_10:
+                RTL_W8(DBG_reg, RTL_R8(DBG_reg) | BIT_1 | BIT_7);
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+                RTL_W8(0xF2, (RTL_R8(0xF2) & ~(BIT_2 | BIT_1 | BIT_0)));
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+                if (aspm) {
+                        RTL_W8(0x6E, RTL_R8(0x6E) | BIT_6);
+                        rtl8168_eri_write(ioaddr, 0x1AE, 2, 0x0403, ERIAR_ExGMAC);
+                }
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                if (aspm) {
+                        if ((mac_ocp_read(tp, 0xDC00) & BIT_3) || (RTL_R8(Config0) & 0x07)) {
+                                RTL_W8(0x6E, RTL_R8(0x6E) | BIT_6);
+                                rtl8168_eri_write(ioaddr, 0x1AE, 2, 0x0403, ERIAR_ExGMAC);
+                        }
+                }
+                break;
+        }
+
+        if (tp->mcfg == CFG_METHOD_10 || tp->mcfg == CFG_METHOD_14 || tp->mcfg == CFG_METHOD_15)
+                RTL_W8(0xF3, RTL_R8(0xF3) | BIT_2);
+
+        rtl8168_hw_mac_mcu_config(dev);
+
+        /*disable ocp phy power saving*/
+        if (tp->mcfg == CFG_METHOD_25 || tp->mcfg == CFG_METHOD_26 ||
+            tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28 ||
+            tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30 ||
+            tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write_phy_ocp(tp, 0x0C41, 0x13, 0x0000);
+                mdio_write_phy_ocp(tp, 0x0C41, 0x13, 0x0500);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+        }
+
+        //Set PCIE uncorrectable error status mask pcie 0x108
+        csi_tmp = rtl8168_csi_read(tp, 0x108);
+        csi_tmp |= BIT_20;
+        rtl8168_csi_write(tp, 0x108, csi_tmp);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1AB, 1, ERIAR_ExGMAC);
+                csi_tmp |= ( BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
+                rtl8168_eri_write(ioaddr, 0x1AB, 1, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+
+        if (s0_magic_packet == 1)
+                rtl8168_enable_magic_packet(dev);
+}
+
+static void
+rtl8168_hw_ephy_config(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u16 ephy_data;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_4:
+                /*Set EPHY registers    begin*/
+                /*Set EPHY register offset 0x02 bit 11 to 0 and bit 12 to 1*/
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x02);
+                ephy_data &= ~BIT_11;
+                ephy_data |= BIT_12;
+                rtl8168_ephy_write(ioaddr, 0x02, ephy_data);
+
+                /*Set EPHY register offset 0x03 bit 1 to 1*/
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x03);
+                ephy_data |= (1 << 1);
+                rtl8168_ephy_write(ioaddr, 0x03, ephy_data);
+
+                /*Set EPHY register offset 0x06 bit 7 to 0*/
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x06);
+                ephy_data &= ~(1 << 7);
+                rtl8168_ephy_write(ioaddr, 0x06, ephy_data);
+                /*Set EPHY registers    end*/
+
+                break;
+        case CFG_METHOD_5:
+                /* set EPHY registers */
+                SetPCIePhyBit(tp, 0x01, BIT_0);
+
+                ClearAndSetPCIePhyBit(tp,
+                                      0x03,
+                                      BIT_10,
+                                      BIT_5
+                                     );
+
+                break;
+        case CFG_METHOD_9:
+                /* set EPHY registers */
+                rtl8168_ephy_write(ioaddr, 0x01, 0x7C7F);
+                rtl8168_ephy_write(ioaddr, 0x02, 0x011F);
+                if (tp->eeprom_type != EEPROM_TYPE_NONE) {
+                        ClearAndSetPCIePhyBit(tp,
+                                              0x03,
+                                              0xFFB0,
+                                              0x05B0
+                                             );
+                } else {
+                        ClearAndSetPCIePhyBit(tp,
+                                              0x03,
+                                              0xFFF0,
+                                              0x05F0
+                                             );
+                }
+                rtl8168_ephy_write(ioaddr, 0x06, 0xB271);
+                rtl8168_ephy_write(ioaddr, 0x07, 0xCE00);
+
+                break;
+        case CFG_METHOD_10:
+                /* set EPHY registers */
+                rtl8168_ephy_write(ioaddr, 0x01, 0x6C7F);
+                rtl8168_ephy_write(ioaddr, 0x02, 0x011F);
+                ClearAndSetPCIePhyBit(tp,
+                                      0x03,
+                                      0xFFF0,
+                                      0x01B0
+                                     );
+                rtl8168_ephy_write(ioaddr, 0x1A, 0x0546);
+                rtl8168_ephy_write(ioaddr, 0x1C, 0x80C4);
+                rtl8168_ephy_write(ioaddr, 0x1D, 0x78E5);
+                rtl8168_ephy_write(ioaddr, 0x0A, 0x8100);
+
+                break;
+        case CFG_METHOD_12:
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x0B);
+                rtl8168_ephy_write(ioaddr, 0x0B, ephy_data|0x48);
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x19);
+                ephy_data &= ~0x20;
+                rtl8168_ephy_write(ioaddr, 0x19, ephy_data|0x50);
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x0C);
+                ephy_data &= ~0x100;
+                rtl8168_ephy_write(ioaddr, 0x0C, ephy_data|0x20);
+
+                break;
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+                /* set EPHY registers */
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x00) & ~0x0200;
+                ephy_data |= 0x0100;
+                rtl8168_ephy_write(ioaddr, 0x00, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x00);
+                ephy_data |= 0x0004;
+                rtl8168_ephy_write(ioaddr, 0x00, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x06) & ~0x0002;
+                ephy_data |= 0x0001;
+                rtl8168_ephy_write(ioaddr, 0x06, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x06);
+                ephy_data |= 0x0030;
+                rtl8168_ephy_write(ioaddr, 0x06, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x07);
+                ephy_data |= 0x2000;
+                rtl8168_ephy_write(ioaddr, 0x07, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x00);
+                ephy_data |= 0x0020;
+                rtl8168_ephy_write(ioaddr, 0x00, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x03) & ~0x5800;
+                ephy_data |= 0x2000;
+                rtl8168_ephy_write(ioaddr, 0x03, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x03);
+                ephy_data |= 0x0001;
+                rtl8168_ephy_write(ioaddr, 0x03, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x01) & ~0x0800;
+                ephy_data |= 0x1000;
+                rtl8168_ephy_write(ioaddr, 0x01, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x07);
+                ephy_data |= 0x4000;
+                rtl8168_ephy_write(ioaddr, 0x07, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x1E);
+                ephy_data |= 0x2000;
+                rtl8168_ephy_write(ioaddr, 0x1E, ephy_data);
+
+                rtl8168_ephy_write(ioaddr, 0x19, 0xFE6C);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x0A);
+                ephy_data |= 0x0040;
+                rtl8168_ephy_write(ioaddr, 0x0A, ephy_data);
+
+                break;
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+                if (tp->mcfg == CFG_METHOD_16) {
+                        rtl8168_ephy_write(ioaddr, 0x06, 0xF020);
+                        rtl8168_ephy_write(ioaddr, 0x07, 0x01FF);
+                        rtl8168_ephy_write(ioaddr, 0x00, 0x5027);
+                        rtl8168_ephy_write(ioaddr, 0x01, 0x0003);
+                        rtl8168_ephy_write(ioaddr, 0x02, 0x2D16);
+                        rtl8168_ephy_write(ioaddr, 0x03, 0x6D49);
+                        rtl8168_ephy_write(ioaddr, 0x08, 0x0006);
+                        rtl8168_ephy_write(ioaddr, 0x0A, 0x00C8);
+                }
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x09);
+                ephy_data |= BIT_7;
+                rtl8168_ephy_write(ioaddr, 0x09, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x19);
+                ephy_data |= (BIT_2 | BIT_5 | BIT_9);
+                rtl8168_ephy_write(ioaddr, 0x19, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x00);
+                ephy_data |= BIT_3;
+                rtl8168_ephy_write(ioaddr, 0x00, ephy_data);
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x0C);
+                ephy_data &= ~(BIT_13 | BIT_12 | BIT_11 | BIT_10 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4);
+                ephy_data |= BIT_9;
+                rtl8168_ephy_write(ioaddr, 0x0C, ephy_data);
+
+                break;
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+                if (tp->mcfg == CFG_METHOD_18) {
+                        ephy_data = rtl8168_ephy_read(ioaddr, 0x06);
+                        ephy_data |= BIT_5;
+                        ephy_data &= ~(BIT_7 | BIT_6);
+                        rtl8168_ephy_write(ioaddr, 0x06, ephy_data);
+
+                        ephy_data = rtl8168_ephy_read(ioaddr, 0x08);
+                        ephy_data |= BIT_1;
+                        ephy_data &= ~BIT_0;
+                        rtl8168_ephy_write(ioaddr, 0x08, ephy_data);
+                }
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x09);
+                ephy_data |= BIT_7;
+                rtl8168_ephy_write(ioaddr, 0x09, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x19);
+                ephy_data |= (BIT_2 | BIT_5 | BIT_9);
+                rtl8168_ephy_write(ioaddr, 0x19, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x00);
+                ephy_data |= BIT_3;
+                rtl8168_ephy_write(ioaddr, 0x00, ephy_data);
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x0C);
+                ephy_data &= ~(BIT_13 | BIT_12 | BIT_11 | BIT_10 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4);
+                ephy_data |= BIT_9;
+                rtl8168_ephy_write(ioaddr, 0x0C, ephy_data);
+
+                break;
+        case CFG_METHOD_20:
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x06);
+                ephy_data |= BIT_5;
+                ephy_data &= ~(BIT_7 | BIT_6);
+                rtl8168_ephy_write(ioaddr, 0x06, ephy_data);
+
+                rtl8168_ephy_write(ioaddr, 0x0f, 0x5200);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x19);
+                ephy_data |= (BIT_2 | BIT_5 | BIT_9);
+                rtl8168_ephy_write(ioaddr, 0x19, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x00);
+                ephy_data |= BIT_3;
+                rtl8168_ephy_write(ioaddr, 0x00, ephy_data);
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x0C);
+                ephy_data &= ~(BIT_13 | BIT_12 | BIT_11 | BIT_10 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4);
+                ephy_data |= BIT_9;
+                rtl8168_ephy_write(ioaddr, 0x0C, ephy_data);
+
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x00);
+                ephy_data &= ~(BIT_3);
+                rtl8168_ephy_write(ioaddr, 0x00, ephy_data);
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x0C);
+                ephy_data &= ~(BIT_13 | BIT_12 | BIT_11 | BIT_10 | BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4);
+                ephy_data |= (BIT_5 | BIT_11);
+                rtl8168_ephy_write(ioaddr, 0x0C, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x1E);
+                ephy_data |= (BIT_0);
+                rtl8168_ephy_write(ioaddr, 0x1E, ephy_data);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x19);
+                ephy_data &= ~(BIT_15);
+                rtl8168_ephy_write(ioaddr, 0x19, ephy_data);
+
+                break;
+        case CFG_METHOD_25:
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x00);
+                ephy_data &= ~BIT_3;
+                rtl8168_ephy_write(ioaddr, 0x00, ephy_data);
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x0C);
+                ephy_data &= ~(BIT_13 | BIT_12 | BIT_11 | BIT_10| BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4);
+                ephy_data |= (BIT_5 | BIT_11);
+                rtl8168_ephy_write(ioaddr, 0x0C, ephy_data);
+
+                rtl8168_ephy_write(ioaddr, 0x19, 0x7C00);
+                rtl8168_ephy_write(ioaddr, 0x1E, 0x20EB);
+                rtl8168_ephy_write(ioaddr, 0x0D, 0x1666);
+                rtl8168_ephy_write(ioaddr, 0x00, 0x10A3);
+                rtl8168_ephy_write(ioaddr, 0x06, 0xF050);
+
+                SetPCIePhyBit(tp, 0x04, BIT_4);
+                ClearPCIePhyBit(tp, 0x1D, BIT_14);
+
+                break;
+        case CFG_METHOD_26:
+                ClearPCIePhyBit(tp, 0x00, BIT_3);
+                ClearAndSetPCIePhyBit( tp,
+                                       0x0C,
+                                       (BIT_13 | BIT_12 | BIT_10 | BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_4),
+                                       (BIT_5 | BIT_11)
+                                     );
+                SetPCIePhyBit(tp, 0x1E, BIT_0);
+                ClearPCIePhyBit(tp, 0x19, BIT_15);
+
+                ClearPCIePhyBit(tp, 0x19, (BIT_5 | BIT_0));
+
+                SetPCIePhyBit(tp, 0x1E, BIT_13);
+                ClearPCIePhyBit(tp, 0x0D, BIT_8);
+                SetPCIePhyBit(tp, 0x0D, BIT_9);
+                SetPCIePhyBit(tp, 0x00, BIT_7);
+
+                SetPCIePhyBit(tp, 0x06, BIT_4);
+
+                SetPCIePhyBit(tp, 0x04, BIT_4);
+                SetPCIePhyBit(tp, 0x1D, BIT_14);
+
+                break;
+        case CFG_METHOD_23:
+                rtl8168_ephy_write(ioaddr, 0x00, 0x10AB);
+                rtl8168_ephy_write(ioaddr, 0x06, 0xf030);
+                rtl8168_ephy_write(ioaddr, 0x08, 0x2006);
+                rtl8168_ephy_write(ioaddr, 0x0D, 0x1666);
+
+                ephy_data = rtl8168_ephy_read(ioaddr, 0x0C);
+                ephy_data &= ~(BIT_13 | BIT_12 | BIT_11 | BIT_10 | BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4);
+                rtl8168_ephy_write(ioaddr, 0x0C, ephy_data);
+
+                break;
+        case CFG_METHOD_27:
+                rtl8168_ephy_write(ioaddr, 0x00, 0x10A3);
+                rtl8168_ephy_write(ioaddr, 0x19, 0xFC00);
+                rtl8168_ephy_write(ioaddr, 0x1E, 0x20EA);
+
+                break;
+        case CFG_METHOD_28:
+                SetPCIePhyBit(tp, 0x00, BIT_7);
+                ClearAndSetPCIePhyBit(tp,
+                                      0x0D,
+                                      BIT_8,
+                                      BIT_9
+                                     );
+                ClearPCIePhyBit(tp, 0x19, (BIT_15 | BIT_5 | BIT_0));
+                SetPCIePhyBit(tp, 0x1E, BIT_13);
+
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                ClearPCIePhyBit(tp, 0x1E, BIT_11);
+
+                SetPCIePhyBit(tp, 0x1E, BIT_0);
+                SetPCIePhyBit(tp, 0x1D, BIT_11);
+
+                rtl8168_ephy_write(ioaddr, 0x05, 0x2089);
+                rtl8168_ephy_write(ioaddr, 0x06, 0x5881);
+
+                rtl8168_ephy_write(ioaddr, 0x04, 0x854A);
+                rtl8168_ephy_write(ioaddr, 0x01, 0x068B);
+
+                break;
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                ClearAndSetPCIePhyBit(tp,
+                                      0x19,
+                                      BIT_6,
+                                      (BIT_12| BIT_8)
+                                     );
+                ClearAndSetPCIePhyBit(tp,
+                                      0x59,
+                                      BIT_6,
+                                      (BIT_12| BIT_8)
+                                     );
+
+                break;
+        }
+}
+
+static int
+rtl8168_check_hw_phy_mcu_code_ver(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        int ram_code_ver_match = 0;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B60);
+                tp->hw_ram_code_ver = mdio_read(tp, 0x06);
+                mdio_write(tp, 0x1F, 0x0000);
+                break;
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B30);
+                tp->hw_ram_code_ver = mdio_read(tp, 0x06);
+                mdio_write(tp, 0x1F, 0x0000);
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x801E);
+                tp->hw_ram_code_ver = mdio_read(tp, 0x14);
+                mdio_write(tp, 0x1F, 0x0000);
+                break;
+        default:
+                tp->hw_ram_code_ver = ~0;
+                break;
+        }
+
+        if ( tp->hw_ram_code_ver == tp->sw_ram_code_ver) {
+                ram_code_ver_match = 1;
+                tp->HwHasWrRamCodeToMicroP = TRUE;
+        }
+
+        return ram_code_ver_match;
+}
+
+static void
+rtl8168_write_hw_phy_mcu_code_ver(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B60);
+                mdio_write(tp, 0x06, tp->sw_ram_code_ver);
+                mdio_write(tp, 0x1F, 0x0000);
+                tp->hw_ram_code_ver = tp->sw_ram_code_ver;
+                break;
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B30);
+                mdio_write(tp, 0x06, tp->sw_ram_code_ver);
+                mdio_write(tp, 0x1F, 0x0000);
+                tp->hw_ram_code_ver = tp->sw_ram_code_ver;
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x801E);
+                mdio_write(tp, 0x14, tp->sw_ram_code_ver);
+                mdio_write(tp, 0x1F, 0x0000);
+                tp->hw_ram_code_ver = tp->sw_ram_code_ver;
+                break;
+        }
+}
+static int
+rtl8168_phy_ram_code_check(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        u16 PhyRegValue;
+        u32 WaitCnt;
+        int retval = TRUE;
+
+        switch(tp->mcfg) {
+        case CFG_METHOD_21:
+                mdio_write(tp, 0x1f, 0x0A40);
+                PhyRegValue = mdio_read(tp, 0x10);
+                PhyRegValue &= ~(BIT_11);
+                mdio_write(tp, 0x10, PhyRegValue);
+
+
+                mdio_write(tp, 0x1f, 0x0A00);
+                PhyRegValue = mdio_read(tp, 0x10);
+                PhyRegValue &= ~(BIT_12 | BIT_13 | BIT_14 | BIT_15);
+                mdio_write(tp, 0x10, PhyRegValue);
+
+                mdio_write(tp, 0x1f, 0x0A43);
+                mdio_write(tp, 0x13, 0x8010);
+                PhyRegValue = mdio_read(tp, 0x14);
+                PhyRegValue &= ~(BIT_11);
+                mdio_write(tp, 0x14, PhyRegValue);
+
+                mdio_write(tp,0x1f, 0x0B82);
+                PhyRegValue = mdio_read(tp, 0x10);
+                PhyRegValue |= BIT_4;
+                mdio_write(tp,0x10, PhyRegValue);
+
+                mdio_write(tp,0x1f, 0x0B80);
+                WaitCnt = 0;
+                do {
+                        PhyRegValue = mdio_read(tp, 0x10);
+                        PhyRegValue &= 0x0040;
+                        udelay(100);
+                        WaitCnt++;
+                } while(PhyRegValue != 0x0040 && WaitCnt <1000);
+
+                if (WaitCnt == 1000) {
+                        retval = FALSE;
+                }
+
+                mdio_write(tp, 0x1f, 0x0A40);
+                mdio_write(tp, 0x10, 0x0140);
+
+                mdio_write(tp, 0x1f, 0x0A4A);
+                PhyRegValue = mdio_read(tp, 0x13);
+                PhyRegValue &= ~(BIT_6);
+                PhyRegValue |= (BIT_7);
+                mdio_write(tp, 0x13, PhyRegValue);
+
+                mdio_write(tp, 0x1f, 0x0A44);
+                PhyRegValue = mdio_read(tp, 0x14);
+                PhyRegValue |= (BIT_2);
+                mdio_write(tp, 0x14, PhyRegValue);
+
+                mdio_write(tp, 0x1f, 0x0A50);
+                PhyRegValue = mdio_read(tp, 0x11);
+                PhyRegValue |= (BIT_11|BIT_12);
+                mdio_write(tp, 0x11, PhyRegValue);
+
+                mdio_write(tp, 0x1f, 0x0B82);
+                PhyRegValue = mdio_read(tp, 0x10);
+                PhyRegValue &= ~(BIT_4);
+                mdio_write(tp, 0x10, PhyRegValue);
+
+                mdio_write(tp,0x1f, 0x0A22);
+                WaitCnt = 0;
+                do {
+                        PhyRegValue = mdio_read(tp, 0x12);
+                        PhyRegValue &= 0x0010;
+                        udelay(100);
+                        WaitCnt++;
+                } while(PhyRegValue != 0x0010 && WaitCnt <1000);
+
+                if (WaitCnt == 1000) {
+                        retval = FALSE;
+                }
+
+                mdio_write(tp, 0x1f, 0x0A40);
+                mdio_write(tp, 0x10, 0x1040);
+
+                mdio_write(tp, 0x1f, 0x0A4A);
+                PhyRegValue = mdio_read(tp, 0x13);
+                PhyRegValue &= ~(BIT_6|BIT_7);
+                mdio_write(tp, 0x13, PhyRegValue);
+
+                mdio_write(tp, 0x1f, 0x0A44);
+                PhyRegValue = mdio_read(tp, 0x14);
+                PhyRegValue &= ~(BIT_2);
+                mdio_write(tp, 0x14, PhyRegValue);
+
+                mdio_write(tp, 0x1f, 0x0A50);
+                PhyRegValue = mdio_read(tp, 0x11);
+                PhyRegValue &= ~(BIT_11|BIT_12);
+                mdio_write(tp, 0x11, PhyRegValue);
+
+                mdio_write(tp, 0x1f, 0x0A43);
+                mdio_write(tp, 0x13, 0x8010);
+                PhyRegValue = mdio_read(tp, 0x14);
+                PhyRegValue |= (BIT_11);
+                mdio_write(tp, 0x14, PhyRegValue);
+
+                mdio_write(tp,0x1f, 0x0B82);
+                PhyRegValue = mdio_read(tp, 0x10);
+                PhyRegValue |= BIT_4;
+                mdio_write(tp,0x10, PhyRegValue);
+
+                mdio_write(tp,0x1f, 0x0B80);
+                WaitCnt = 0;
+                do {
+                        PhyRegValue = mdio_read(tp, 0x10);
+                        PhyRegValue &= 0x0040;
+                        udelay(100);
+                        WaitCnt++;
+                } while(PhyRegValue != 0x0040 && WaitCnt <1000);
+
+                if ( WaitCnt == 1000) {
+                        retval = FALSE;
+                }
+
+                mdio_write(tp, 0x1f, 0x0A20);
+                PhyRegValue = mdio_read(tp, 0x13);
+                if (PhyRegValue & BIT_11) {
+                        if (PhyRegValue & BIT_10) {
+                                retval = FALSE;
+                        }
+                }
+
+                mdio_write(tp, 0x1f, 0x0B82);
+                PhyRegValue = mdio_read(tp, 0x10);
+                PhyRegValue &= ~(BIT_4);
+                mdio_write(tp, 0x10, PhyRegValue);
+
+                mdelay(2);
+                break;
+        default:
+                break;
+        }
+
+        mdio_write(tp, 0x1F, 0x0000);
+
+        return retval;
+}
+
+static void
+rtl8168_set_phy_ram_code_check_fail_flag(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        u16 TmpUshort;
+
+        switch(tp->mcfg) {
+        case CFG_METHOD_21:
+                TmpUshort = mac_ocp_read(tp, 0xD3C0);
+                TmpUshort |= BIT_0;
+                mac_ocp_write(tp, 0xD3C0, TmpUshort);
+                break;
+        }
+}
+
+static void
+rtl8168_set_phy_mcu_8168e_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x00, 0x1800);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        mdio_write(tp, 0x17, 0x0117);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1E, 0x002C);
+        mdio_write(tp, 0x1B, 0x5000);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x16, 0x4104);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x1E);
+                gphy_val &= 0x03FF;
+                if (gphy_val == 0x000C)
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0005);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x07);
+                if ((gphy_val & BIT_5) == 0)
+                        break;
+        }
+        gphy_val = mdio_read(tp, 0x07);
+        if (gphy_val & BIT_5) {
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x00a1);
+                mdio_write(tp, 0x17, 0x1000);
+                mdio_write(tp, 0x17, 0x0000);
+                mdio_write(tp, 0x17, 0x2000);
+                mdio_write(tp, 0x1e, 0x002f);
+                mdio_write(tp, 0x18, 0x9bfb);
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x07, 0x0000);
+                mdio_write(tp, 0x1f, 0x0000);
+        }
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        gphy_val = mdio_read(tp, 0x00);
+        gphy_val &= ~(BIT_7);
+        mdio_write(tp, 0x00, gphy_val);
+        mdio_write(tp, 0x1f, 0x0002);
+        gphy_val = mdio_read(tp, 0x08);
+        gphy_val &= ~(BIT_7);
+        mdio_write(tp, 0x08, gphy_val);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0307);
+        mdio_write(tp, 0x15, 0x000e);
+        mdio_write(tp, 0x19, 0x000a);
+        mdio_write(tp, 0x15, 0x0010);
+        mdio_write(tp, 0x19, 0x0008);
+        mdio_write(tp, 0x15, 0x0018);
+        mdio_write(tp, 0x19, 0x4801);
+        mdio_write(tp, 0x15, 0x0019);
+        mdio_write(tp, 0x19, 0x6801);
+        mdio_write(tp, 0x15, 0x001a);
+        mdio_write(tp, 0x19, 0x66a1);
+        mdio_write(tp, 0x15, 0x001f);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0020);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0021);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0022);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0023);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0024);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0025);
+        mdio_write(tp, 0x19, 0x64a1);
+        mdio_write(tp, 0x15, 0x0026);
+        mdio_write(tp, 0x19, 0x40ea);
+        mdio_write(tp, 0x15, 0x0027);
+        mdio_write(tp, 0x19, 0x4503);
+        mdio_write(tp, 0x15, 0x0028);
+        mdio_write(tp, 0x19, 0x9f00);
+        mdio_write(tp, 0x15, 0x0029);
+        mdio_write(tp, 0x19, 0xa631);
+        mdio_write(tp, 0x15, 0x002a);
+        mdio_write(tp, 0x19, 0x9717);
+        mdio_write(tp, 0x15, 0x002b);
+        mdio_write(tp, 0x19, 0x302c);
+        mdio_write(tp, 0x15, 0x002c);
+        mdio_write(tp, 0x19, 0x4802);
+        mdio_write(tp, 0x15, 0x002d);
+        mdio_write(tp, 0x19, 0x58da);
+        mdio_write(tp, 0x15, 0x002e);
+        mdio_write(tp, 0x19, 0x400d);
+        mdio_write(tp, 0x15, 0x002f);
+        mdio_write(tp, 0x19, 0x4488);
+        mdio_write(tp, 0x15, 0x0030);
+        mdio_write(tp, 0x19, 0x9e00);
+        mdio_write(tp, 0x15, 0x0031);
+        mdio_write(tp, 0x19, 0x63c8);
+        mdio_write(tp, 0x15, 0x0032);
+        mdio_write(tp, 0x19, 0x6481);
+        mdio_write(tp, 0x15, 0x0033);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0034);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0035);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0036);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0037);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0038);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0039);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x003a);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x003b);
+        mdio_write(tp, 0x19, 0x63e8);
+        mdio_write(tp, 0x15, 0x003c);
+        mdio_write(tp, 0x19, 0x7d00);
+        mdio_write(tp, 0x15, 0x003d);
+        mdio_write(tp, 0x19, 0x59d4);
+        mdio_write(tp, 0x15, 0x003e);
+        mdio_write(tp, 0x19, 0x63f8);
+        mdio_write(tp, 0x15, 0x0040);
+        mdio_write(tp, 0x19, 0x64a1);
+        mdio_write(tp, 0x15, 0x0041);
+        mdio_write(tp, 0x19, 0x30de);
+        mdio_write(tp, 0x15, 0x0044);
+        mdio_write(tp, 0x19, 0x480f);
+        mdio_write(tp, 0x15, 0x0045);
+        mdio_write(tp, 0x19, 0x6800);
+        mdio_write(tp, 0x15, 0x0046);
+        mdio_write(tp, 0x19, 0x6680);
+        mdio_write(tp, 0x15, 0x0047);
+        mdio_write(tp, 0x19, 0x7c10);
+        mdio_write(tp, 0x15, 0x0048);
+        mdio_write(tp, 0x19, 0x63c8);
+        mdio_write(tp, 0x15, 0x0049);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x004a);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x004b);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x004c);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x004d);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x004e);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x004f);
+        mdio_write(tp, 0x19, 0x40ea);
+        mdio_write(tp, 0x15, 0x0050);
+        mdio_write(tp, 0x19, 0x4503);
+        mdio_write(tp, 0x15, 0x0051);
+        mdio_write(tp, 0x19, 0x58ca);
+        mdio_write(tp, 0x15, 0x0052);
+        mdio_write(tp, 0x19, 0x63c8);
+        mdio_write(tp, 0x15, 0x0053);
+        mdio_write(tp, 0x19, 0x63d8);
+        mdio_write(tp, 0x15, 0x0054);
+        mdio_write(tp, 0x19, 0x66a0);
+        mdio_write(tp, 0x15, 0x0055);
+        mdio_write(tp, 0x19, 0x9f00);
+        mdio_write(tp, 0x15, 0x0056);
+        mdio_write(tp, 0x19, 0x3000);
+        mdio_write(tp, 0x15, 0x006E);
+        mdio_write(tp, 0x19, 0x9afa);
+        mdio_write(tp, 0x15, 0x00a1);
+        mdio_write(tp, 0x19, 0x3044);
+        mdio_write(tp, 0x15, 0x00ab);
+        mdio_write(tp, 0x19, 0x5820);
+        mdio_write(tp, 0x15, 0x00ac);
+        mdio_write(tp, 0x19, 0x5e04);
+        mdio_write(tp, 0x15, 0x00ad);
+        mdio_write(tp, 0x19, 0xb60c);
+        mdio_write(tp, 0x15, 0x00af);
+        mdio_write(tp, 0x19, 0x000a);
+        mdio_write(tp, 0x15, 0x00b2);
+        mdio_write(tp, 0x19, 0x30b9);
+        mdio_write(tp, 0x15, 0x00b9);
+        mdio_write(tp, 0x19, 0x4408);
+        mdio_write(tp, 0x15, 0x00ba);
+        mdio_write(tp, 0x19, 0x480b);
+        mdio_write(tp, 0x15, 0x00bb);
+        mdio_write(tp, 0x19, 0x5e00);
+        mdio_write(tp, 0x15, 0x00bc);
+        mdio_write(tp, 0x19, 0x405f);
+        mdio_write(tp, 0x15, 0x00bd);
+        mdio_write(tp, 0x19, 0x4448);
+        mdio_write(tp, 0x15, 0x00be);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x00bf);
+        mdio_write(tp, 0x19, 0x4468);
+        mdio_write(tp, 0x15, 0x00c0);
+        mdio_write(tp, 0x19, 0x9c02);
+        mdio_write(tp, 0x15, 0x00c1);
+        mdio_write(tp, 0x19, 0x58a0);
+        mdio_write(tp, 0x15, 0x00c2);
+        mdio_write(tp, 0x19, 0xb605);
+        mdio_write(tp, 0x15, 0x00c3);
+        mdio_write(tp, 0x19, 0xc0d3);
+        mdio_write(tp, 0x15, 0x00c4);
+        mdio_write(tp, 0x19, 0x00e6);
+        mdio_write(tp, 0x15, 0x00c5);
+        mdio_write(tp, 0x19, 0xdaec);
+        mdio_write(tp, 0x15, 0x00c6);
+        mdio_write(tp, 0x19, 0x00fa);
+        mdio_write(tp, 0x15, 0x00c7);
+        mdio_write(tp, 0x19, 0x9df9);
+        mdio_write(tp, 0x15, 0x00c8);
+        mdio_write(tp, 0x19, 0x307a);
+        mdio_write(tp, 0x15, 0x0112);
+        mdio_write(tp, 0x19, 0x6421);
+        mdio_write(tp, 0x15, 0x0113);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x0114);
+        mdio_write(tp, 0x19, 0x63f0);
+        mdio_write(tp, 0x15, 0x0115);
+        mdio_write(tp, 0x19, 0x4003);
+        mdio_write(tp, 0x15, 0x0116);
+        mdio_write(tp, 0x19, 0x4418);
+        mdio_write(tp, 0x15, 0x0117);
+        mdio_write(tp, 0x19, 0x9b00);
+        mdio_write(tp, 0x15, 0x0118);
+        mdio_write(tp, 0x19, 0x6461);
+        mdio_write(tp, 0x15, 0x0119);
+        mdio_write(tp, 0x19, 0x64e1);
+        mdio_write(tp, 0x15, 0x011a);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0150);
+        mdio_write(tp, 0x19, 0x7c80);
+        mdio_write(tp, 0x15, 0x0151);
+        mdio_write(tp, 0x19, 0x6461);
+        mdio_write(tp, 0x15, 0x0152);
+        mdio_write(tp, 0x19, 0x4003);
+        mdio_write(tp, 0x15, 0x0153);
+        mdio_write(tp, 0x19, 0x4540);
+        mdio_write(tp, 0x15, 0x0154);
+        mdio_write(tp, 0x19, 0x9f00);
+        mdio_write(tp, 0x15, 0x0155);
+        mdio_write(tp, 0x19, 0x9d00);
+        mdio_write(tp, 0x15, 0x0156);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x0157);
+        mdio_write(tp, 0x19, 0x6421);
+        mdio_write(tp, 0x15, 0x0158);
+        mdio_write(tp, 0x19, 0x7c80);
+        mdio_write(tp, 0x15, 0x0159);
+        mdio_write(tp, 0x19, 0x64a1);
+        mdio_write(tp, 0x15, 0x015a);
+        mdio_write(tp, 0x19, 0x30fe);
+        mdio_write(tp, 0x15, 0x021e);
+        mdio_write(tp, 0x19, 0x5410);
+        mdio_write(tp, 0x15, 0x0225);
+        mdio_write(tp, 0x19, 0x5400);
+        mdio_write(tp, 0x15, 0x023D);
+        mdio_write(tp, 0x19, 0x4050);
+        mdio_write(tp, 0x15, 0x0295);
+        mdio_write(tp, 0x19, 0x6c08);
+        mdio_write(tp, 0x15, 0x02bd);
+        mdio_write(tp, 0x19, 0xa523);
+        mdio_write(tp, 0x15, 0x02be);
+        mdio_write(tp, 0x19, 0x32ca);
+        mdio_write(tp, 0x15, 0x02ca);
+        mdio_write(tp, 0x19, 0x48b3);
+        mdio_write(tp, 0x15, 0x02cb);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x02cc);
+        mdio_write(tp, 0x19, 0x4823);
+        mdio_write(tp, 0x15, 0x02cd);
+        mdio_write(tp, 0x19, 0x4510);
+        mdio_write(tp, 0x15, 0x02ce);
+        mdio_write(tp, 0x19, 0xb63a);
+        mdio_write(tp, 0x15, 0x02cf);
+        mdio_write(tp, 0x19, 0x7dc8);
+        mdio_write(tp, 0x15, 0x02d6);
+        mdio_write(tp, 0x19, 0x9bf8);
+        mdio_write(tp, 0x15, 0x02d8);
+        mdio_write(tp, 0x19, 0x85f6);
+        mdio_write(tp, 0x15, 0x02d9);
+        mdio_write(tp, 0x19, 0x32e0);
+        mdio_write(tp, 0x15, 0x02e0);
+        mdio_write(tp, 0x19, 0x4834);
+        mdio_write(tp, 0x15, 0x02e1);
+        mdio_write(tp, 0x19, 0x6c08);
+        mdio_write(tp, 0x15, 0x02e2);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x02e3);
+        mdio_write(tp, 0x19, 0x4824);
+        mdio_write(tp, 0x15, 0x02e4);
+        mdio_write(tp, 0x19, 0x4520);
+        mdio_write(tp, 0x15, 0x02e5);
+        mdio_write(tp, 0x19, 0x4008);
+        mdio_write(tp, 0x15, 0x02e6);
+        mdio_write(tp, 0x19, 0x4560);
+        mdio_write(tp, 0x15, 0x02e7);
+        mdio_write(tp, 0x19, 0x9d04);
+        mdio_write(tp, 0x15, 0x02e8);
+        mdio_write(tp, 0x19, 0x48c4);
+        mdio_write(tp, 0x15, 0x02e9);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02ea);
+        mdio_write(tp, 0x19, 0x4844);
+        mdio_write(tp, 0x15, 0x02eb);
+        mdio_write(tp, 0x19, 0x7dc8);
+        mdio_write(tp, 0x15, 0x02f0);
+        mdio_write(tp, 0x19, 0x9cf7);
+        mdio_write(tp, 0x15, 0x02f1);
+        mdio_write(tp, 0x19, 0xdf94);
+        mdio_write(tp, 0x15, 0x02f2);
+        mdio_write(tp, 0x19, 0x0002);
+        mdio_write(tp, 0x15, 0x02f3);
+        mdio_write(tp, 0x19, 0x6810);
+        mdio_write(tp, 0x15, 0x02f4);
+        mdio_write(tp, 0x19, 0xb614);
+        mdio_write(tp, 0x15, 0x02f5);
+        mdio_write(tp, 0x19, 0xc42b);
+        mdio_write(tp, 0x15, 0x02f6);
+        mdio_write(tp, 0x19, 0x00d4);
+        mdio_write(tp, 0x15, 0x02f7);
+        mdio_write(tp, 0x19, 0xc455);
+        mdio_write(tp, 0x15, 0x02f8);
+        mdio_write(tp, 0x19, 0x0093);
+        mdio_write(tp, 0x15, 0x02f9);
+        mdio_write(tp, 0x19, 0x92ee);
+        mdio_write(tp, 0x15, 0x02fa);
+        mdio_write(tp, 0x19, 0xefed);
+        mdio_write(tp, 0x15, 0x02fb);
+        mdio_write(tp, 0x19, 0x3312);
+        mdio_write(tp, 0x15, 0x0312);
+        mdio_write(tp, 0x19, 0x49b5);
+        mdio_write(tp, 0x15, 0x0313);
+        mdio_write(tp, 0x19, 0x7d00);
+        mdio_write(tp, 0x15, 0x0314);
+        mdio_write(tp, 0x19, 0x4d00);
+        mdio_write(tp, 0x15, 0x0315);
+        mdio_write(tp, 0x19, 0x6810);
+        mdio_write(tp, 0x15, 0x031e);
+        mdio_write(tp, 0x19, 0x404f);
+        mdio_write(tp, 0x15, 0x031f);
+        mdio_write(tp, 0x19, 0x44c8);
+        mdio_write(tp, 0x15, 0x0320);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x0321);
+        mdio_write(tp, 0x19, 0x00e7);
+        mdio_write(tp, 0x15, 0x0322);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x0323);
+        mdio_write(tp, 0x19, 0x8203);
+        mdio_write(tp, 0x15, 0x0324);
+        mdio_write(tp, 0x19, 0x4d48);
+        mdio_write(tp, 0x15, 0x0325);
+        mdio_write(tp, 0x19, 0x3327);
+        mdio_write(tp, 0x15, 0x0326);
+        mdio_write(tp, 0x19, 0x4d40);
+        mdio_write(tp, 0x15, 0x0327);
+        mdio_write(tp, 0x19, 0xc8d7);
+        mdio_write(tp, 0x15, 0x0328);
+        mdio_write(tp, 0x19, 0x0003);
+        mdio_write(tp, 0x15, 0x0329);
+        mdio_write(tp, 0x19, 0x7c20);
+        mdio_write(tp, 0x15, 0x032a);
+        mdio_write(tp, 0x19, 0x4c20);
+        mdio_write(tp, 0x15, 0x032b);
+        mdio_write(tp, 0x19, 0xc8ed);
+        mdio_write(tp, 0x15, 0x032c);
+        mdio_write(tp, 0x19, 0x00f4);
+        mdio_write(tp, 0x15, 0x032d);
+        mdio_write(tp, 0x19, 0x82b3);
+        mdio_write(tp, 0x15, 0x032e);
+        mdio_write(tp, 0x19, 0xd11d);
+        mdio_write(tp, 0x15, 0x032f);
+        mdio_write(tp, 0x19, 0x00b1);
+        mdio_write(tp, 0x15, 0x0330);
+        mdio_write(tp, 0x19, 0xde18);
+        mdio_write(tp, 0x15, 0x0331);
+        mdio_write(tp, 0x19, 0x0008);
+        mdio_write(tp, 0x15, 0x0332);
+        mdio_write(tp, 0x19, 0x91ee);
+        mdio_write(tp, 0x15, 0x0333);
+        mdio_write(tp, 0x19, 0x3339);
+        mdio_write(tp, 0x15, 0x033a);
+        mdio_write(tp, 0x19, 0x4064);
+        mdio_write(tp, 0x15, 0x0340);
+        mdio_write(tp, 0x19, 0x9e06);
+        mdio_write(tp, 0x15, 0x0341);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x0342);
+        mdio_write(tp, 0x19, 0x8203);
+        mdio_write(tp, 0x15, 0x0343);
+        mdio_write(tp, 0x19, 0x4d48);
+        mdio_write(tp, 0x15, 0x0344);
+        mdio_write(tp, 0x19, 0x3346);
+        mdio_write(tp, 0x15, 0x0345);
+        mdio_write(tp, 0x19, 0x4d40);
+        mdio_write(tp, 0x15, 0x0346);
+        mdio_write(tp, 0x19, 0xd11d);
+        mdio_write(tp, 0x15, 0x0347);
+        mdio_write(tp, 0x19, 0x0099);
+        mdio_write(tp, 0x15, 0x0348);
+        mdio_write(tp, 0x19, 0xbb17);
+        mdio_write(tp, 0x15, 0x0349);
+        mdio_write(tp, 0x19, 0x8102);
+        mdio_write(tp, 0x15, 0x034a);
+        mdio_write(tp, 0x19, 0x334d);
+        mdio_write(tp, 0x15, 0x034b);
+        mdio_write(tp, 0x19, 0xa22c);
+        mdio_write(tp, 0x15, 0x034c);
+        mdio_write(tp, 0x19, 0x3397);
+        mdio_write(tp, 0x15, 0x034d);
+        mdio_write(tp, 0x19, 0x91f2);
+        mdio_write(tp, 0x15, 0x034e);
+        mdio_write(tp, 0x19, 0xc218);
+        mdio_write(tp, 0x15, 0x034f);
+        mdio_write(tp, 0x19, 0x00f0);
+        mdio_write(tp, 0x15, 0x0350);
+        mdio_write(tp, 0x19, 0x3397);
+        mdio_write(tp, 0x15, 0x0351);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0364);
+        mdio_write(tp, 0x19, 0xbc05);
+        mdio_write(tp, 0x15, 0x0367);
+        mdio_write(tp, 0x19, 0xa1fc);
+        mdio_write(tp, 0x15, 0x0368);
+        mdio_write(tp, 0x19, 0x3377);
+        mdio_write(tp, 0x15, 0x0369);
+        mdio_write(tp, 0x19, 0x328b);
+        mdio_write(tp, 0x15, 0x036a);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0377);
+        mdio_write(tp, 0x19, 0x4b97);
+        mdio_write(tp, 0x15, 0x0378);
+        mdio_write(tp, 0x19, 0x6818);
+        mdio_write(tp, 0x15, 0x0379);
+        mdio_write(tp, 0x19, 0x4b07);
+        mdio_write(tp, 0x15, 0x037a);
+        mdio_write(tp, 0x19, 0x40ac);
+        mdio_write(tp, 0x15, 0x037b);
+        mdio_write(tp, 0x19, 0x4445);
+        mdio_write(tp, 0x15, 0x037c);
+        mdio_write(tp, 0x19, 0x404e);
+        mdio_write(tp, 0x15, 0x037d);
+        mdio_write(tp, 0x19, 0x4461);
+        mdio_write(tp, 0x15, 0x037e);
+        mdio_write(tp, 0x19, 0x9c09);
+        mdio_write(tp, 0x15, 0x037f);
+        mdio_write(tp, 0x19, 0x63da);
+        mdio_write(tp, 0x15, 0x0380);
+        mdio_write(tp, 0x19, 0x5440);
+        mdio_write(tp, 0x15, 0x0381);
+        mdio_write(tp, 0x19, 0x4b98);
+        mdio_write(tp, 0x15, 0x0382);
+        mdio_write(tp, 0x19, 0x7c60);
+        mdio_write(tp, 0x15, 0x0383);
+        mdio_write(tp, 0x19, 0x4c00);
+        mdio_write(tp, 0x15, 0x0384);
+        mdio_write(tp, 0x19, 0x4b08);
+        mdio_write(tp, 0x15, 0x0385);
+        mdio_write(tp, 0x19, 0x63d8);
+        mdio_write(tp, 0x15, 0x0386);
+        mdio_write(tp, 0x19, 0x338d);
+        mdio_write(tp, 0x15, 0x0387);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x0388);
+        mdio_write(tp, 0x19, 0x0080);
+        mdio_write(tp, 0x15, 0x0389);
+        mdio_write(tp, 0x19, 0x820c);
+        mdio_write(tp, 0x15, 0x038a);
+        mdio_write(tp, 0x19, 0xa10b);
+        mdio_write(tp, 0x15, 0x038b);
+        mdio_write(tp, 0x19, 0x9df3);
+        mdio_write(tp, 0x15, 0x038c);
+        mdio_write(tp, 0x19, 0x3395);
+        mdio_write(tp, 0x15, 0x038d);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x038e);
+        mdio_write(tp, 0x19, 0x00f9);
+        mdio_write(tp, 0x15, 0x038f);
+        mdio_write(tp, 0x19, 0xc017);
+        mdio_write(tp, 0x15, 0x0390);
+        mdio_write(tp, 0x19, 0x0005);
+        mdio_write(tp, 0x15, 0x0391);
+        mdio_write(tp, 0x19, 0x6c0b);
+        mdio_write(tp, 0x15, 0x0392);
+        mdio_write(tp, 0x19, 0xa103);
+        mdio_write(tp, 0x15, 0x0393);
+        mdio_write(tp, 0x19, 0x6c08);
+        mdio_write(tp, 0x15, 0x0394);
+        mdio_write(tp, 0x19, 0x9df9);
+        mdio_write(tp, 0x15, 0x0395);
+        mdio_write(tp, 0x19, 0x6c08);
+        mdio_write(tp, 0x15, 0x0396);
+        mdio_write(tp, 0x19, 0x3397);
+        mdio_write(tp, 0x15, 0x0399);
+        mdio_write(tp, 0x19, 0x6810);
+        mdio_write(tp, 0x15, 0x03a4);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x03a5);
+        mdio_write(tp, 0x19, 0x8203);
+        mdio_write(tp, 0x15, 0x03a6);
+        mdio_write(tp, 0x19, 0x4d08);
+        mdio_write(tp, 0x15, 0x03a7);
+        mdio_write(tp, 0x19, 0x33a9);
+        mdio_write(tp, 0x15, 0x03a8);
+        mdio_write(tp, 0x19, 0x4d00);
+        mdio_write(tp, 0x15, 0x03a9);
+        mdio_write(tp, 0x19, 0x9bfa);
+        mdio_write(tp, 0x15, 0x03aa);
+        mdio_write(tp, 0x19, 0x33b6);
+        mdio_write(tp, 0x15, 0x03bb);
+        mdio_write(tp, 0x19, 0x4056);
+        mdio_write(tp, 0x15, 0x03bc);
+        mdio_write(tp, 0x19, 0x44e9);
+        mdio_write(tp, 0x15, 0x03bd);
+        mdio_write(tp, 0x19, 0x405e);
+        mdio_write(tp, 0x15, 0x03be);
+        mdio_write(tp, 0x19, 0x44f8);
+        mdio_write(tp, 0x15, 0x03bf);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x03c0);
+        mdio_write(tp, 0x19, 0x0037);
+        mdio_write(tp, 0x15, 0x03c1);
+        mdio_write(tp, 0x19, 0xbd37);
+        mdio_write(tp, 0x15, 0x03c2);
+        mdio_write(tp, 0x19, 0x9cfd);
+        mdio_write(tp, 0x15, 0x03c3);
+        mdio_write(tp, 0x19, 0xc639);
+        mdio_write(tp, 0x15, 0x03c4);
+        mdio_write(tp, 0x19, 0x0011);
+        mdio_write(tp, 0x15, 0x03c5);
+        mdio_write(tp, 0x19, 0x9b03);
+        mdio_write(tp, 0x15, 0x03c6);
+        mdio_write(tp, 0x19, 0x7c01);
+        mdio_write(tp, 0x15, 0x03c7);
+        mdio_write(tp, 0x19, 0x4c01);
+        mdio_write(tp, 0x15, 0x03c8);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x03c9);
+        mdio_write(tp, 0x19, 0x7c20);
+        mdio_write(tp, 0x15, 0x03ca);
+        mdio_write(tp, 0x19, 0x4c20);
+        mdio_write(tp, 0x15, 0x03cb);
+        mdio_write(tp, 0x19, 0x9af4);
+        mdio_write(tp, 0x15, 0x03cc);
+        mdio_write(tp, 0x19, 0x7c12);
+        mdio_write(tp, 0x15, 0x03cd);
+        mdio_write(tp, 0x19, 0x4c52);
+        mdio_write(tp, 0x15, 0x03ce);
+        mdio_write(tp, 0x19, 0x4470);
+        mdio_write(tp, 0x15, 0x03cf);
+        mdio_write(tp, 0x19, 0x7c12);
+        mdio_write(tp, 0x15, 0x03d0);
+        mdio_write(tp, 0x19, 0x4c40);
+        mdio_write(tp, 0x15, 0x03d1);
+        mdio_write(tp, 0x19, 0x33bf);
+        mdio_write(tp, 0x15, 0x03d6);
+        mdio_write(tp, 0x19, 0x4047);
+        mdio_write(tp, 0x15, 0x03d7);
+        mdio_write(tp, 0x19, 0x4469);
+        mdio_write(tp, 0x15, 0x03d8);
+        mdio_write(tp, 0x19, 0x492b);
+        mdio_write(tp, 0x15, 0x03d9);
+        mdio_write(tp, 0x19, 0x4479);
+        mdio_write(tp, 0x15, 0x03da);
+        mdio_write(tp, 0x19, 0x7c09);
+        mdio_write(tp, 0x15, 0x03db);
+        mdio_write(tp, 0x19, 0x8203);
+        mdio_write(tp, 0x15, 0x03dc);
+        mdio_write(tp, 0x19, 0x4d48);
+        mdio_write(tp, 0x15, 0x03dd);
+        mdio_write(tp, 0x19, 0x33df);
+        mdio_write(tp, 0x15, 0x03de);
+        mdio_write(tp, 0x19, 0x4d40);
+        mdio_write(tp, 0x15, 0x03df);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x03e0);
+        mdio_write(tp, 0x19, 0x0017);
+        mdio_write(tp, 0x15, 0x03e1);
+        mdio_write(tp, 0x19, 0xbd17);
+        mdio_write(tp, 0x15, 0x03e2);
+        mdio_write(tp, 0x19, 0x9b03);
+        mdio_write(tp, 0x15, 0x03e3);
+        mdio_write(tp, 0x19, 0x7c20);
+        mdio_write(tp, 0x15, 0x03e4);
+        mdio_write(tp, 0x19, 0x4c20);
+        mdio_write(tp, 0x15, 0x03e5);
+        mdio_write(tp, 0x19, 0x88f5);
+        mdio_write(tp, 0x15, 0x03e6);
+        mdio_write(tp, 0x19, 0xc428);
+        mdio_write(tp, 0x15, 0x03e7);
+        mdio_write(tp, 0x19, 0x0008);
+        mdio_write(tp, 0x15, 0x03e8);
+        mdio_write(tp, 0x19, 0x9af2);
+        mdio_write(tp, 0x15, 0x03e9);
+        mdio_write(tp, 0x19, 0x7c12);
+        mdio_write(tp, 0x15, 0x03ea);
+        mdio_write(tp, 0x19, 0x4c52);
+        mdio_write(tp, 0x15, 0x03eb);
+        mdio_write(tp, 0x19, 0x4470);
+        mdio_write(tp, 0x15, 0x03ec);
+        mdio_write(tp, 0x19, 0x7c12);
+        mdio_write(tp, 0x15, 0x03ed);
+        mdio_write(tp, 0x19, 0x4c40);
+        mdio_write(tp, 0x15, 0x03ee);
+        mdio_write(tp, 0x19, 0x33da);
+        mdio_write(tp, 0x15, 0x03ef);
+        mdio_write(tp, 0x19, 0x3312);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0300);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x17, 0x2179);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0040);
+        mdio_write(tp, 0x18, 0x0645);
+        mdio_write(tp, 0x19, 0xe200);
+        mdio_write(tp, 0x18, 0x0655);
+        mdio_write(tp, 0x19, 0x9000);
+        mdio_write(tp, 0x18, 0x0d05);
+        mdio_write(tp, 0x19, 0xbe00);
+        mdio_write(tp, 0x18, 0x0d15);
+        mdio_write(tp, 0x19, 0xd300);
+        mdio_write(tp, 0x18, 0x0d25);
+        mdio_write(tp, 0x19, 0xfe00);
+        mdio_write(tp, 0x18, 0x0d35);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x0d45);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x18, 0x0d55);
+        mdio_write(tp, 0x19, 0x1000);
+        mdio_write(tp, 0x18, 0x0d65);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x0d75);
+        mdio_write(tp, 0x19, 0x8200);
+        mdio_write(tp, 0x18, 0x0d85);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x0d95);
+        mdio_write(tp, 0x19, 0x7000);
+        mdio_write(tp, 0x18, 0x0da5);
+        mdio_write(tp, 0x19, 0x0f00);
+        mdio_write(tp, 0x18, 0x0db5);
+        mdio_write(tp, 0x19, 0x0100);
+        mdio_write(tp, 0x18, 0x0dc5);
+        mdio_write(tp, 0x19, 0x9b00);
+        mdio_write(tp, 0x18, 0x0dd5);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x18, 0x0de5);
+        mdio_write(tp, 0x19, 0xe000);
+        mdio_write(tp, 0x18, 0x0df5);
+        mdio_write(tp, 0x19, 0xef00);
+        mdio_write(tp, 0x18, 0x16d5);
+        mdio_write(tp, 0x19, 0xe200);
+        mdio_write(tp, 0x18, 0x16e5);
+        mdio_write(tp, 0x19, 0xab00);
+        mdio_write(tp, 0x18, 0x2904);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x2914);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x18, 0x2924);
+        mdio_write(tp, 0x19, 0x0100);
+        mdio_write(tp, 0x18, 0x2934);
+        mdio_write(tp, 0x19, 0x2000);
+        mdio_write(tp, 0x18, 0x2944);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x2954);
+        mdio_write(tp, 0x19, 0x4600);
+        mdio_write(tp, 0x18, 0x2964);
+        mdio_write(tp, 0x19, 0xfc00);
+        mdio_write(tp, 0x18, 0x2974);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x2984);
+        mdio_write(tp, 0x19, 0x5000);
+        mdio_write(tp, 0x18, 0x2994);
+        mdio_write(tp, 0x19, 0x9d00);
+        mdio_write(tp, 0x18, 0x29a4);
+        mdio_write(tp, 0x19, 0xff00);
+        mdio_write(tp, 0x18, 0x29b4);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x29c4);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x18, 0x29d4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x29e4);
+        mdio_write(tp, 0x19, 0x2000);
+        mdio_write(tp, 0x18, 0x29f4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x2a04);
+        mdio_write(tp, 0x19, 0xe600);
+        mdio_write(tp, 0x18, 0x2a14);
+        mdio_write(tp, 0x19, 0xff00);
+        mdio_write(tp, 0x18, 0x2a24);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x2a34);
+        mdio_write(tp, 0x19, 0x5000);
+        mdio_write(tp, 0x18, 0x2a44);
+        mdio_write(tp, 0x19, 0x8500);
+        mdio_write(tp, 0x18, 0x2a54);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x18, 0x2a64);
+        mdio_write(tp, 0x19, 0xac00);
+        mdio_write(tp, 0x18, 0x2a74);
+        mdio_write(tp, 0x19, 0x0800);
+        mdio_write(tp, 0x18, 0x2a84);
+        mdio_write(tp, 0x19, 0xfc00);
+        mdio_write(tp, 0x18, 0x2a94);
+        mdio_write(tp, 0x19, 0xe000);
+        mdio_write(tp, 0x18, 0x2aa4);
+        mdio_write(tp, 0x19, 0x7400);
+        mdio_write(tp, 0x18, 0x2ab4);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x2ac4);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x18, 0x2ad4);
+        mdio_write(tp, 0x19, 0x0100);
+        mdio_write(tp, 0x18, 0x2ae4);
+        mdio_write(tp, 0x19, 0xff00);
+        mdio_write(tp, 0x18, 0x2af4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x2b04);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x18, 0x2b14);
+        mdio_write(tp, 0x19, 0xfc00);
+        mdio_write(tp, 0x18, 0x2b24);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x2b34);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x2b44);
+        mdio_write(tp, 0x19, 0x9d00);
+        mdio_write(tp, 0x18, 0x2b54);
+        mdio_write(tp, 0x19, 0xff00);
+        mdio_write(tp, 0x18, 0x2b64);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x2b74);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x18, 0x2b84);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x2b94);
+        mdio_write(tp, 0x19, 0xff00);
+        mdio_write(tp, 0x18, 0x2ba4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x2bb4);
+        mdio_write(tp, 0x19, 0xfc00);
+        mdio_write(tp, 0x18, 0x2bc4);
+        mdio_write(tp, 0x19, 0xff00);
+        mdio_write(tp, 0x18, 0x2bd4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x2be4);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x2bf4);
+        mdio_write(tp, 0x19, 0x8900);
+        mdio_write(tp, 0x18, 0x2c04);
+        mdio_write(tp, 0x19, 0x8300);
+        mdio_write(tp, 0x18, 0x2c14);
+        mdio_write(tp, 0x19, 0xe000);
+        mdio_write(tp, 0x18, 0x2c24);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x18, 0x2c34);
+        mdio_write(tp, 0x19, 0xac00);
+        mdio_write(tp, 0x18, 0x2c44);
+        mdio_write(tp, 0x19, 0x0800);
+        mdio_write(tp, 0x18, 0x2c54);
+        mdio_write(tp, 0x19, 0xfa00);
+        mdio_write(tp, 0x18, 0x2c64);
+        mdio_write(tp, 0x19, 0xe100);
+        mdio_write(tp, 0x18, 0x2c74);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x18, 0x0001);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x17, 0x2100);
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x05, 0x8b88);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x05, 0x8000);
+        mdio_write(tp, 0x06, 0xd480);
+        mdio_write(tp, 0x06, 0xc1e4);
+        mdio_write(tp, 0x06, 0x8b9a);
+        mdio_write(tp, 0x06, 0xe58b);
+        mdio_write(tp, 0x06, 0x9bee);
+        mdio_write(tp, 0x06, 0x8b83);
+        mdio_write(tp, 0x06, 0x41bf);
+        mdio_write(tp, 0x06, 0x8b88);
+        mdio_write(tp, 0x06, 0xec00);
+        mdio_write(tp, 0x06, 0x19a9);
+        mdio_write(tp, 0x06, 0x8b90);
+        mdio_write(tp, 0x06, 0xf9ee);
+        mdio_write(tp, 0x06, 0xfff6);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0xfff7);
+        mdio_write(tp, 0x06, 0xffe0);
+        mdio_write(tp, 0x06, 0xe140);
+        mdio_write(tp, 0x06, 0xe1e1);
+        mdio_write(tp, 0x06, 0x41f7);
+        mdio_write(tp, 0x06, 0x2ff6);
+        mdio_write(tp, 0x06, 0x28e4);
+        mdio_write(tp, 0x06, 0xe140);
+        mdio_write(tp, 0x06, 0xe5e1);
+        mdio_write(tp, 0x06, 0x41f7);
+        mdio_write(tp, 0x06, 0x0002);
+        mdio_write(tp, 0x06, 0x020c);
+        mdio_write(tp, 0x06, 0x0202);
+        mdio_write(tp, 0x06, 0x1d02);
+        mdio_write(tp, 0x06, 0x0230);
+        mdio_write(tp, 0x06, 0x0202);
+        mdio_write(tp, 0x06, 0x4002);
+        mdio_write(tp, 0x06, 0x028b);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0x6c02);
+        mdio_write(tp, 0x06, 0x8085);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x88e1);
+        mdio_write(tp, 0x06, 0x8b89);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8a1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8b);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8c1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8e1e);
+        mdio_write(tp, 0x06, 0x01a0);
+        mdio_write(tp, 0x06, 0x00c7);
+        mdio_write(tp, 0x06, 0xaec3);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x10ee);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0x0002);
+        mdio_write(tp, 0x06, 0x1310);
+        mdio_write(tp, 0x06, 0x021f);
+        mdio_write(tp, 0x06, 0x9d02);
+        mdio_write(tp, 0x06, 0x1f0c);
+        mdio_write(tp, 0x06, 0x0227);
+        mdio_write(tp, 0x06, 0x49fc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x200b);
+        mdio_write(tp, 0x06, 0xf620);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x830e);
+        mdio_write(tp, 0x06, 0x021b);
+        mdio_write(tp, 0x06, 0x67ad);
+        mdio_write(tp, 0x06, 0x2211);
+        mdio_write(tp, 0x06, 0xf622);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x2ba5);
+        mdio_write(tp, 0x06, 0x022a);
+        mdio_write(tp, 0x06, 0x2402);
+        mdio_write(tp, 0x06, 0x80c6);
+        mdio_write(tp, 0x06, 0x022a);
+        mdio_write(tp, 0x06, 0xf0ad);
+        mdio_write(tp, 0x06, 0x2511);
+        mdio_write(tp, 0x06, 0xf625);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x8226);
+        mdio_write(tp, 0x06, 0x0204);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0x19cc);
+        mdio_write(tp, 0x06, 0x022b);
+        mdio_write(tp, 0x06, 0x5bfc);
+        mdio_write(tp, 0x06, 0x04ee);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0x0105);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b83);
+        mdio_write(tp, 0x06, 0xad24);
+        mdio_write(tp, 0x06, 0x44e0);
+        mdio_write(tp, 0x06, 0xe022);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0x23ad);
+        mdio_write(tp, 0x06, 0x223b);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xbea0);
+        mdio_write(tp, 0x06, 0x0005);
+        mdio_write(tp, 0x06, 0x0228);
+        mdio_write(tp, 0x06, 0xdeae);
+        mdio_write(tp, 0x06, 0x42a0);
+        mdio_write(tp, 0x06, 0x0105);
+        mdio_write(tp, 0x06, 0x0228);
+        mdio_write(tp, 0x06, 0xf1ae);
+        mdio_write(tp, 0x06, 0x3aa0);
+        mdio_write(tp, 0x06, 0x0205);
+        mdio_write(tp, 0x06, 0x0281);
+        mdio_write(tp, 0x06, 0x25ae);
+        mdio_write(tp, 0x06, 0x32a0);
+        mdio_write(tp, 0x06, 0x0305);
+        mdio_write(tp, 0x06, 0x0229);
+        mdio_write(tp, 0x06, 0x9aae);
+        mdio_write(tp, 0x06, 0x2aa0);
+        mdio_write(tp, 0x06, 0x0405);
+        mdio_write(tp, 0x06, 0x0229);
+        mdio_write(tp, 0x06, 0xaeae);
+        mdio_write(tp, 0x06, 0x22a0);
+        mdio_write(tp, 0x06, 0x0505);
+        mdio_write(tp, 0x06, 0x0229);
+        mdio_write(tp, 0x06, 0xd7ae);
+        mdio_write(tp, 0x06, 0x1aa0);
+        mdio_write(tp, 0x06, 0x0605);
+        mdio_write(tp, 0x06, 0x0229);
+        mdio_write(tp, 0x06, 0xfeae);
+        mdio_write(tp, 0x06, 0x12ee);
+        mdio_write(tp, 0x06, 0x8ac0);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8ac1);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8ac6);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8abe);
+        mdio_write(tp, 0x06, 0x00ae);
+        mdio_write(tp, 0x06, 0x00fc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0x022a);
+        mdio_write(tp, 0x06, 0x67e0);
+        mdio_write(tp, 0x06, 0xe022);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0x230d);
+        mdio_write(tp, 0x06, 0x0658);
+        mdio_write(tp, 0x06, 0x03a0);
+        mdio_write(tp, 0x06, 0x0202);
+        mdio_write(tp, 0x06, 0xae2d);
+        mdio_write(tp, 0x06, 0xa001);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x2da0);
+        mdio_write(tp, 0x06, 0x004d);
+        mdio_write(tp, 0x06, 0xe0e2);
+        mdio_write(tp, 0x06, 0x00e1);
+        mdio_write(tp, 0x06, 0xe201);
+        mdio_write(tp, 0x06, 0xad24);
+        mdio_write(tp, 0x06, 0x44e0);
+        mdio_write(tp, 0x06, 0x8ac2);
+        mdio_write(tp, 0x06, 0xe48a);
+        mdio_write(tp, 0x06, 0xc4e0);
+        mdio_write(tp, 0x06, 0x8ac3);
+        mdio_write(tp, 0x06, 0xe48a);
+        mdio_write(tp, 0x06, 0xc5ee);
+        mdio_write(tp, 0x06, 0x8abe);
+        mdio_write(tp, 0x06, 0x03e0);
+        mdio_write(tp, 0x06, 0x8b83);
+        mdio_write(tp, 0x06, 0xad25);
+        mdio_write(tp, 0x06, 0x3aee);
+        mdio_write(tp, 0x06, 0x8abe);
+        mdio_write(tp, 0x06, 0x05ae);
+        mdio_write(tp, 0x06, 0x34e0);
+        mdio_write(tp, 0x06, 0x8ace);
+        mdio_write(tp, 0x06, 0xae03);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xcfe1);
+        mdio_write(tp, 0x06, 0x8ac2);
+        mdio_write(tp, 0x06, 0x4905);
+        mdio_write(tp, 0x06, 0xe58a);
+        mdio_write(tp, 0x06, 0xc4e1);
+        mdio_write(tp, 0x06, 0x8ac3);
+        mdio_write(tp, 0x06, 0x4905);
+        mdio_write(tp, 0x06, 0xe58a);
+        mdio_write(tp, 0x06, 0xc5ee);
+        mdio_write(tp, 0x06, 0x8abe);
+        mdio_write(tp, 0x06, 0x0502);
+        mdio_write(tp, 0x06, 0x2ab6);
+        mdio_write(tp, 0x06, 0xac20);
+        mdio_write(tp, 0x06, 0x1202);
+        mdio_write(tp, 0x06, 0x819b);
+        mdio_write(tp, 0x06, 0xac20);
+        mdio_write(tp, 0x06, 0x0cee);
+        mdio_write(tp, 0x06, 0x8ac1);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8ac6);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8abe);
+        mdio_write(tp, 0x06, 0x02fc);
+        mdio_write(tp, 0x06, 0x04d0);
+        mdio_write(tp, 0x06, 0x0002);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x590f);
+        mdio_write(tp, 0x06, 0x3902);
+        mdio_write(tp, 0x06, 0xaa04);
+        mdio_write(tp, 0x06, 0xd001);
+        mdio_write(tp, 0x06, 0xae02);
+        mdio_write(tp, 0x06, 0xd000);
+        mdio_write(tp, 0x06, 0x04f9);
+        mdio_write(tp, 0x06, 0xfae2);
+        mdio_write(tp, 0x06, 0xe2d2);
+        mdio_write(tp, 0x06, 0xe3e2);
+        mdio_write(tp, 0x06, 0xd3f9);
+        mdio_write(tp, 0x06, 0x5af7);
+        mdio_write(tp, 0x06, 0xe6e2);
+        mdio_write(tp, 0x06, 0xd2e7);
+        mdio_write(tp, 0x06, 0xe2d3);
+        mdio_write(tp, 0x06, 0xe2e0);
+        mdio_write(tp, 0x06, 0x2ce3);
+        mdio_write(tp, 0x06, 0xe02d);
+        mdio_write(tp, 0x06, 0xf95b);
+        mdio_write(tp, 0x06, 0xe01e);
+        mdio_write(tp, 0x06, 0x30e6);
+        mdio_write(tp, 0x06, 0xe02c);
+        mdio_write(tp, 0x06, 0xe7e0);
+        mdio_write(tp, 0x06, 0x2de2);
+        mdio_write(tp, 0x06, 0xe2cc);
+        mdio_write(tp, 0x06, 0xe3e2);
+        mdio_write(tp, 0x06, 0xcdf9);
+        mdio_write(tp, 0x06, 0x5a0f);
+        mdio_write(tp, 0x06, 0x6a50);
+        mdio_write(tp, 0x06, 0xe6e2);
+        mdio_write(tp, 0x06, 0xcce7);
+        mdio_write(tp, 0x06, 0xe2cd);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x3ce1);
+        mdio_write(tp, 0x06, 0xe03d);
+        mdio_write(tp, 0x06, 0xef64);
+        mdio_write(tp, 0x06, 0xfde0);
+        mdio_write(tp, 0x06, 0xe2cc);
+        mdio_write(tp, 0x06, 0xe1e2);
+        mdio_write(tp, 0x06, 0xcd58);
+        mdio_write(tp, 0x06, 0x0f5a);
+        mdio_write(tp, 0x06, 0xf01e);
+        mdio_write(tp, 0x06, 0x02e4);
+        mdio_write(tp, 0x06, 0xe2cc);
+        mdio_write(tp, 0x06, 0xe5e2);
+        mdio_write(tp, 0x06, 0xcdfd);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x2ce1);
+        mdio_write(tp, 0x06, 0xe02d);
+        mdio_write(tp, 0x06, 0x59e0);
+        mdio_write(tp, 0x06, 0x5b1f);
+        mdio_write(tp, 0x06, 0x1e13);
+        mdio_write(tp, 0x06, 0xe4e0);
+        mdio_write(tp, 0x06, 0x2ce5);
+        mdio_write(tp, 0x06, 0xe02d);
+        mdio_write(tp, 0x06, 0xfde0);
+        mdio_write(tp, 0x06, 0xe2d2);
+        mdio_write(tp, 0x06, 0xe1e2);
+        mdio_write(tp, 0x06, 0xd358);
+        mdio_write(tp, 0x06, 0xf75a);
+        mdio_write(tp, 0x06, 0x081e);
+        mdio_write(tp, 0x06, 0x02e4);
+        mdio_write(tp, 0x06, 0xe2d2);
+        mdio_write(tp, 0x06, 0xe5e2);
+        mdio_write(tp, 0x06, 0xd3ef);
+        mdio_write(tp, 0x06, 0x46fe);
+        mdio_write(tp, 0x06, 0xfd04);
+        mdio_write(tp, 0x06, 0xf8f9);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69e0);
+        mdio_write(tp, 0x06, 0xe022);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0x2358);
+        mdio_write(tp, 0x06, 0xc4e1);
+        mdio_write(tp, 0x06, 0x8b6e);
+        mdio_write(tp, 0x06, 0x1f10);
+        mdio_write(tp, 0x06, 0x9e58);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x6ead);
+        mdio_write(tp, 0x06, 0x2222);
+        mdio_write(tp, 0x06, 0xac27);
+        mdio_write(tp, 0x06, 0x55ac);
+        mdio_write(tp, 0x06, 0x2602);
+        mdio_write(tp, 0x06, 0xae1a);
+        mdio_write(tp, 0x06, 0xd106);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0xba02);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xd107);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0xbd02);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xd107);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0xc002);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xae30);
+        mdio_write(tp, 0x06, 0xd103);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0xc302);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0xc602);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xca02);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xd10f);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0xba02);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0xbd02);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0xc002);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xef96);
+        mdio_write(tp, 0x06, 0xfefd);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0xc302);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xd011);
+        mdio_write(tp, 0x06, 0x022b);
+        mdio_write(tp, 0x06, 0xfb59);
+        mdio_write(tp, 0x06, 0x03ef);
+        mdio_write(tp, 0x06, 0x01d1);
+        mdio_write(tp, 0x06, 0x00a0);
+        mdio_write(tp, 0x06, 0x0002);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0xc602);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xd111);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x020c);
+        mdio_write(tp, 0x06, 0x11ad);
+        mdio_write(tp, 0x06, 0x2102);
+        mdio_write(tp, 0x06, 0x0c12);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xca02);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xaec8);
+        mdio_write(tp, 0x06, 0x70e4);
+        mdio_write(tp, 0x06, 0x2602);
+        mdio_write(tp, 0x06, 0x82d1);
+        mdio_write(tp, 0x06, 0x05f8);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69e0);
+        mdio_write(tp, 0x06, 0xe2fe);
+        mdio_write(tp, 0x06, 0xe1e2);
+        mdio_write(tp, 0x06, 0xffad);
+        mdio_write(tp, 0x06, 0x2d1a);
+        mdio_write(tp, 0x06, 0xe0e1);
+        mdio_write(tp, 0x06, 0x4ee1);
+        mdio_write(tp, 0x06, 0xe14f);
+        mdio_write(tp, 0x06, 0xac2d);
+        mdio_write(tp, 0x06, 0x22f6);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0x033b);
+        mdio_write(tp, 0x06, 0xf703);
+        mdio_write(tp, 0x06, 0xf706);
+        mdio_write(tp, 0x06, 0xbf84);
+        mdio_write(tp, 0x06, 0x4402);
+        mdio_write(tp, 0x06, 0x2d21);
+        mdio_write(tp, 0x06, 0xae11);
+        mdio_write(tp, 0x06, 0xe0e1);
+        mdio_write(tp, 0x06, 0x4ee1);
+        mdio_write(tp, 0x06, 0xe14f);
+        mdio_write(tp, 0x06, 0xad2d);
+        mdio_write(tp, 0x06, 0x08bf);
+        mdio_write(tp, 0x06, 0x844f);
+        mdio_write(tp, 0x06, 0x022d);
+        mdio_write(tp, 0x06, 0x21f6);
+        mdio_write(tp, 0x06, 0x06ef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0x0283);
+        mdio_write(tp, 0x06, 0x4502);
+        mdio_write(tp, 0x06, 0x83a2);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x00e1);
+        mdio_write(tp, 0x06, 0xe001);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x1fd1);
+        mdio_write(tp, 0x06, 0x01bf);
+        mdio_write(tp, 0x06, 0x843b);
+        mdio_write(tp, 0x06, 0x022d);
+        mdio_write(tp, 0x06, 0xc1e0);
+        mdio_write(tp, 0x06, 0xe020);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0x21ad);
+        mdio_write(tp, 0x06, 0x200e);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf84);
+        mdio_write(tp, 0x06, 0x3b02);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xbf3b);
+        mdio_write(tp, 0x06, 0x9602);
+        mdio_write(tp, 0x06, 0x2d21);
+        mdio_write(tp, 0x06, 0xef96);
+        mdio_write(tp, 0x06, 0xfefc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x87ad);
+        mdio_write(tp, 0x06, 0x204c);
+        mdio_write(tp, 0x06, 0xd200);
+        mdio_write(tp, 0x06, 0xe0e2);
+        mdio_write(tp, 0x06, 0x0058);
+        mdio_write(tp, 0x06, 0x010c);
+        mdio_write(tp, 0x06, 0x021e);
+        mdio_write(tp, 0x06, 0x20e0);
+        mdio_write(tp, 0x06, 0xe000);
+        mdio_write(tp, 0x06, 0x5810);
+        mdio_write(tp, 0x06, 0x1e20);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x3658);
+        mdio_write(tp, 0x06, 0x031e);
+        mdio_write(tp, 0x06, 0x20e0);
+        mdio_write(tp, 0x06, 0xe022);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0x2358);
+        mdio_write(tp, 0x06, 0xe01e);
+        mdio_write(tp, 0x06, 0x20e0);
+        mdio_write(tp, 0x06, 0x8b64);
+        mdio_write(tp, 0x06, 0x1f02);
+        mdio_write(tp, 0x06, 0x9e22);
+        mdio_write(tp, 0x06, 0xe68b);
+        mdio_write(tp, 0x06, 0x64ad);
+        mdio_write(tp, 0x06, 0x3214);
+        mdio_write(tp, 0x06, 0xad34);
+        mdio_write(tp, 0x06, 0x11ef);
+        mdio_write(tp, 0x06, 0x0258);
+        mdio_write(tp, 0x06, 0x039e);
+        mdio_write(tp, 0x06, 0x07ad);
+        mdio_write(tp, 0x06, 0x3508);
+        mdio_write(tp, 0x06, 0x5ac0);
+        mdio_write(tp, 0x06, 0x9f04);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xae02);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf84);
+        mdio_write(tp, 0x06, 0x3e02);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xef96);
+        mdio_write(tp, 0x06, 0xfefd);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8f9);
+        mdio_write(tp, 0x06, 0xfbe0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad25);
+        mdio_write(tp, 0x06, 0x22e0);
+        mdio_write(tp, 0x06, 0xe022);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0x23e2);
+        mdio_write(tp, 0x06, 0xe036);
+        mdio_write(tp, 0x06, 0xe3e0);
+        mdio_write(tp, 0x06, 0x375a);
+        mdio_write(tp, 0x06, 0xc40d);
+        mdio_write(tp, 0x06, 0x0158);
+        mdio_write(tp, 0x06, 0x021e);
+        mdio_write(tp, 0x06, 0x20e3);
+        mdio_write(tp, 0x06, 0x8ae7);
+        mdio_write(tp, 0x06, 0xac31);
+        mdio_write(tp, 0x06, 0x60ac);
+        mdio_write(tp, 0x06, 0x3a08);
+        mdio_write(tp, 0x06, 0xac3e);
+        mdio_write(tp, 0x06, 0x26ae);
+        mdio_write(tp, 0x06, 0x67af);
+        mdio_write(tp, 0x06, 0x8437);
+        mdio_write(tp, 0x06, 0xad37);
+        mdio_write(tp, 0x06, 0x61e0);
+        mdio_write(tp, 0x06, 0x8ae8);
+        mdio_write(tp, 0x06, 0x10e4);
+        mdio_write(tp, 0x06, 0x8ae8);
+        mdio_write(tp, 0x06, 0xe18a);
+        mdio_write(tp, 0x06, 0xe91b);
+        mdio_write(tp, 0x06, 0x109e);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x51d1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x8441);
+        mdio_write(tp, 0x06, 0x022d);
+        mdio_write(tp, 0x06, 0xc1ee);
+        mdio_write(tp, 0x06, 0x8ae8);
+        mdio_write(tp, 0x06, 0x00ae);
+        mdio_write(tp, 0x06, 0x43ad);
+        mdio_write(tp, 0x06, 0x3627);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xeee1);
+        mdio_write(tp, 0x06, 0x8aef);
+        mdio_write(tp, 0x06, 0xef74);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xeae1);
+        mdio_write(tp, 0x06, 0x8aeb);
+        mdio_write(tp, 0x06, 0x1b74);
+        mdio_write(tp, 0x06, 0x9e2e);
+        mdio_write(tp, 0x06, 0x14e4);
+        mdio_write(tp, 0x06, 0x8aea);
+        mdio_write(tp, 0x06, 0xe58a);
+        mdio_write(tp, 0x06, 0xebef);
+        mdio_write(tp, 0x06, 0x74e0);
+        mdio_write(tp, 0x06, 0x8aee);
+        mdio_write(tp, 0x06, 0xe18a);
+        mdio_write(tp, 0x06, 0xef1b);
+        mdio_write(tp, 0x06, 0x479e);
+        mdio_write(tp, 0x06, 0x0fae);
+        mdio_write(tp, 0x06, 0x19ee);
+        mdio_write(tp, 0x06, 0x8aea);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8aeb);
+        mdio_write(tp, 0x06, 0x00ae);
+        mdio_write(tp, 0x06, 0x0fac);
+        mdio_write(tp, 0x06, 0x390c);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf84);
+        mdio_write(tp, 0x06, 0x4102);
+        mdio_write(tp, 0x06, 0x2dc1);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0xe800);
+        mdio_write(tp, 0x06, 0xe68a);
+        mdio_write(tp, 0x06, 0xe7ff);
+        mdio_write(tp, 0x06, 0xfdfc);
+        mdio_write(tp, 0x06, 0x0400);
+        mdio_write(tp, 0x06, 0xe234);
+        mdio_write(tp, 0x06, 0xcce2);
+        mdio_write(tp, 0x06, 0x0088);
+        mdio_write(tp, 0x06, 0xe200);
+        mdio_write(tp, 0x06, 0xa725);
+        mdio_write(tp, 0x06, 0xe50a);
+        mdio_write(tp, 0x06, 0x1de5);
+        mdio_write(tp, 0x06, 0x0a2c);
+        mdio_write(tp, 0x06, 0xe50a);
+        mdio_write(tp, 0x06, 0x6de5);
+        mdio_write(tp, 0x06, 0x0a1d);
+        mdio_write(tp, 0x06, 0xe50a);
+        mdio_write(tp, 0x06, 0x1ce5);
+        mdio_write(tp, 0x06, 0x0a2d);
+        mdio_write(tp, 0x06, 0xa755);
+        mdio_write(tp, 0x05, 0x8b64);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x05, 0x8b94);
+        mdio_write(tp, 0x06, 0x82cd);
+        mdio_write(tp, 0x05, 0x8b85);
+        mdio_write(tp, 0x06, 0x2000);
+        mdio_write(tp, 0x05, 0x8aee);
+        mdio_write(tp, 0x06, 0x03b8);
+        mdio_write(tp, 0x05, 0x8ae8);
+        mdio_write(tp, 0x06, 0x0002);
+        gphy_val = mdio_read(tp, 0x01);
+        gphy_val |= BIT_0;
+        mdio_write(tp, 0x01, gphy_val);
+        gphy_val = mdio_read(tp, 0x00);
+        gphy_val |= BIT_0;
+        mdio_write(tp, 0x00, gphy_val);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0005);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x00);
+                if (gphy_val & BIT_7)
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        gphy_val = mdio_read(tp, 0x17);
+        gphy_val &= ~(BIT_0);
+        if (tp->RequiredSecLanDonglePatch)
+                gphy_val &= ~(BIT_2);
+        mdio_write(tp, 0x17, gphy_val);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0028);
+        mdio_write(tp, 0x15, 0x0010);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0041);
+        mdio_write(tp, 0x15, 0x0802);
+        mdio_write(tp, 0x16, 0x2185);
+        mdio_write(tp, 0x1f, 0x0000);
+}
+
+static void
+rtl8168_set_phy_mcu_8168e_2(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        if (rtl8168_efuse_read(tp, 0x22) == 0x0c) {
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, 0x00, 0x1800);
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x0023);
+                mdio_write(tp, 0x17, 0x0117);
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1E, 0x002C);
+                mdio_write(tp, 0x1B, 0x5000);
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, 0x16, 0x4104);
+                for (i = 0; i < 200; i++) {
+                        udelay(100);
+                        gphy_val = mdio_read(tp, 0x1E);
+                        gphy_val &= 0x03FF;
+                        if (gphy_val==0x000C)
+                                break;
+                }
+                mdio_write(tp, 0x1f, 0x0005);
+                for (i = 0; i < 200; i++) {
+                        udelay(100);
+                        gphy_val = mdio_read(tp, 0x07);
+                        if ((gphy_val & BIT_5) == 0)
+                                break;
+                }
+                gphy_val = mdio_read(tp, 0x07);
+                if (gphy_val & BIT_5) {
+                        mdio_write(tp, 0x1f, 0x0007);
+                        mdio_write(tp, 0x1e, 0x00a1);
+                        mdio_write(tp, 0x17, 0x1000);
+                        mdio_write(tp, 0x17, 0x0000);
+                        mdio_write(tp, 0x17, 0x2000);
+                        mdio_write(tp, 0x1e, 0x002f);
+                        mdio_write(tp, 0x18, 0x9bfb);
+                        mdio_write(tp, 0x1f, 0x0005);
+                        mdio_write(tp, 0x07, 0x0000);
+                        mdio_write(tp, 0x1f, 0x0000);
+                }
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x05, 0xfff6);
+                mdio_write(tp, 0x06, 0x0080);
+                gphy_val = mdio_read(tp, 0x00);
+                gphy_val &= ~(BIT_7);
+                mdio_write(tp, 0x00, gphy_val);
+                mdio_write(tp, 0x1f, 0x0002);
+                gphy_val = mdio_read(tp, 0x08);
+                gphy_val &= ~(BIT_7);
+                mdio_write(tp, 0x08, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x0023);
+                mdio_write(tp, 0x16, 0x0306);
+                mdio_write(tp, 0x16, 0x0307);
+                mdio_write(tp, 0x15, 0x000e);
+                mdio_write(tp, 0x19, 0x000a);
+                mdio_write(tp, 0x15, 0x0010);
+                mdio_write(tp, 0x19, 0x0008);
+                mdio_write(tp, 0x15, 0x0018);
+                mdio_write(tp, 0x19, 0x4801);
+                mdio_write(tp, 0x15, 0x0019);
+                mdio_write(tp, 0x19, 0x6801);
+                mdio_write(tp, 0x15, 0x001a);
+                mdio_write(tp, 0x19, 0x66a1);
+                mdio_write(tp, 0x15, 0x001f);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0020);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0021);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0022);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0023);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0024);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0025);
+                mdio_write(tp, 0x19, 0x64a1);
+                mdio_write(tp, 0x15, 0x0026);
+                mdio_write(tp, 0x19, 0x40ea);
+                mdio_write(tp, 0x15, 0x0027);
+                mdio_write(tp, 0x19, 0x4503);
+                mdio_write(tp, 0x15, 0x0028);
+                mdio_write(tp, 0x19, 0x9f00);
+                mdio_write(tp, 0x15, 0x0029);
+                mdio_write(tp, 0x19, 0xa631);
+                mdio_write(tp, 0x15, 0x002a);
+                mdio_write(tp, 0x19, 0x9717);
+                mdio_write(tp, 0x15, 0x002b);
+                mdio_write(tp, 0x19, 0x302c);
+                mdio_write(tp, 0x15, 0x002c);
+                mdio_write(tp, 0x19, 0x4802);
+                mdio_write(tp, 0x15, 0x002d);
+                mdio_write(tp, 0x19, 0x58da);
+                mdio_write(tp, 0x15, 0x002e);
+                mdio_write(tp, 0x19, 0x400d);
+                mdio_write(tp, 0x15, 0x002f);
+                mdio_write(tp, 0x19, 0x4488);
+                mdio_write(tp, 0x15, 0x0030);
+                mdio_write(tp, 0x19, 0x9e00);
+                mdio_write(tp, 0x15, 0x0031);
+                mdio_write(tp, 0x19, 0x63c8);
+                mdio_write(tp, 0x15, 0x0032);
+                mdio_write(tp, 0x19, 0x6481);
+                mdio_write(tp, 0x15, 0x0033);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0034);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0035);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0036);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0037);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0038);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0039);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x003a);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x003b);
+                mdio_write(tp, 0x19, 0x63e8);
+                mdio_write(tp, 0x15, 0x003c);
+                mdio_write(tp, 0x19, 0x7d00);
+                mdio_write(tp, 0x15, 0x003d);
+                mdio_write(tp, 0x19, 0x59d4);
+                mdio_write(tp, 0x15, 0x003e);
+                mdio_write(tp, 0x19, 0x63f8);
+                mdio_write(tp, 0x15, 0x0040);
+                mdio_write(tp, 0x19, 0x64a1);
+                mdio_write(tp, 0x15, 0x0041);
+                mdio_write(tp, 0x19, 0x30de);
+                mdio_write(tp, 0x15, 0x0044);
+                mdio_write(tp, 0x19, 0x480f);
+                mdio_write(tp, 0x15, 0x0045);
+                mdio_write(tp, 0x19, 0x6800);
+                mdio_write(tp, 0x15, 0x0046);
+                mdio_write(tp, 0x19, 0x6680);
+                mdio_write(tp, 0x15, 0x0047);
+                mdio_write(tp, 0x19, 0x7c10);
+                mdio_write(tp, 0x15, 0x0048);
+                mdio_write(tp, 0x19, 0x63c8);
+                mdio_write(tp, 0x15, 0x0049);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004a);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004b);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004c);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004d);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004e);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004f);
+                mdio_write(tp, 0x19, 0x40ea);
+                mdio_write(tp, 0x15, 0x0050);
+                mdio_write(tp, 0x19, 0x4503);
+                mdio_write(tp, 0x15, 0x0051);
+                mdio_write(tp, 0x19, 0x58ca);
+                mdio_write(tp, 0x15, 0x0052);
+                mdio_write(tp, 0x19, 0x63c8);
+                mdio_write(tp, 0x15, 0x0053);
+                mdio_write(tp, 0x19, 0x63d8);
+                mdio_write(tp, 0x15, 0x0054);
+                mdio_write(tp, 0x19, 0x66a0);
+                mdio_write(tp, 0x15, 0x0055);
+                mdio_write(tp, 0x19, 0x9f00);
+                mdio_write(tp, 0x15, 0x0056);
+                mdio_write(tp, 0x19, 0x3000);
+                mdio_write(tp, 0x15, 0x00a1);
+                mdio_write(tp, 0x19, 0x3044);
+                mdio_write(tp, 0x15, 0x00ab);
+                mdio_write(tp, 0x19, 0x5820);
+                mdio_write(tp, 0x15, 0x00ac);
+                mdio_write(tp, 0x19, 0x5e04);
+                mdio_write(tp, 0x15, 0x00ad);
+                mdio_write(tp, 0x19, 0xb60c);
+                mdio_write(tp, 0x15, 0x00af);
+                mdio_write(tp, 0x19, 0x000a);
+                mdio_write(tp, 0x15, 0x00b2);
+                mdio_write(tp, 0x19, 0x30b9);
+                mdio_write(tp, 0x15, 0x00b9);
+                mdio_write(tp, 0x19, 0x4408);
+                mdio_write(tp, 0x15, 0x00ba);
+                mdio_write(tp, 0x19, 0x480b);
+                mdio_write(tp, 0x15, 0x00bb);
+                mdio_write(tp, 0x19, 0x5e00);
+                mdio_write(tp, 0x15, 0x00bc);
+                mdio_write(tp, 0x19, 0x405f);
+                mdio_write(tp, 0x15, 0x00bd);
+                mdio_write(tp, 0x19, 0x4448);
+                mdio_write(tp, 0x15, 0x00be);
+                mdio_write(tp, 0x19, 0x4020);
+                mdio_write(tp, 0x15, 0x00bf);
+                mdio_write(tp, 0x19, 0x4468);
+                mdio_write(tp, 0x15, 0x00c0);
+                mdio_write(tp, 0x19, 0x9c02);
+                mdio_write(tp, 0x15, 0x00c1);
+                mdio_write(tp, 0x19, 0x58a0);
+                mdio_write(tp, 0x15, 0x00c2);
+                mdio_write(tp, 0x19, 0xb605);
+                mdio_write(tp, 0x15, 0x00c3);
+                mdio_write(tp, 0x19, 0xc0d3);
+                mdio_write(tp, 0x15, 0x00c4);
+                mdio_write(tp, 0x19, 0x00e6);
+                mdio_write(tp, 0x15, 0x00c5);
+                mdio_write(tp, 0x19, 0xdaec);
+                mdio_write(tp, 0x15, 0x00c6);
+                mdio_write(tp, 0x19, 0x00fa);
+                mdio_write(tp, 0x15, 0x00c7);
+                mdio_write(tp, 0x19, 0x9df9);
+                mdio_write(tp, 0x15, 0x0112);
+                mdio_write(tp, 0x19, 0x6421);
+                mdio_write(tp, 0x15, 0x0113);
+                mdio_write(tp, 0x19, 0x7c08);
+                mdio_write(tp, 0x15, 0x0114);
+                mdio_write(tp, 0x19, 0x63f0);
+                mdio_write(tp, 0x15, 0x0115);
+                mdio_write(tp, 0x19, 0x4003);
+                mdio_write(tp, 0x15, 0x0116);
+                mdio_write(tp, 0x19, 0x4418);
+                mdio_write(tp, 0x15, 0x0117);
+                mdio_write(tp, 0x19, 0x9b00);
+                mdio_write(tp, 0x15, 0x0118);
+                mdio_write(tp, 0x19, 0x6461);
+                mdio_write(tp, 0x15, 0x0119);
+                mdio_write(tp, 0x19, 0x64e1);
+                mdio_write(tp, 0x15, 0x011a);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0150);
+                mdio_write(tp, 0x19, 0x7c80);
+                mdio_write(tp, 0x15, 0x0151);
+                mdio_write(tp, 0x19, 0x6461);
+                mdio_write(tp, 0x15, 0x0152);
+                mdio_write(tp, 0x19, 0x4003);
+                mdio_write(tp, 0x15, 0x0153);
+                mdio_write(tp, 0x19, 0x4540);
+                mdio_write(tp, 0x15, 0x0154);
+                mdio_write(tp, 0x19, 0x9f00);
+                mdio_write(tp, 0x15, 0x0155);
+                mdio_write(tp, 0x19, 0x9d00);
+                mdio_write(tp, 0x15, 0x0156);
+                mdio_write(tp, 0x19, 0x7c40);
+                mdio_write(tp, 0x15, 0x0157);
+                mdio_write(tp, 0x19, 0x6421);
+                mdio_write(tp, 0x15, 0x0158);
+                mdio_write(tp, 0x19, 0x7c80);
+                mdio_write(tp, 0x15, 0x0159);
+                mdio_write(tp, 0x19, 0x64a1);
+                mdio_write(tp, 0x15, 0x015a);
+                mdio_write(tp, 0x19, 0x30fe);
+                mdio_write(tp, 0x15, 0x029c);
+                mdio_write(tp, 0x19, 0x0070);
+                mdio_write(tp, 0x15, 0x02b2);
+                mdio_write(tp, 0x19, 0x005a);
+                mdio_write(tp, 0x15, 0x02bd);
+                mdio_write(tp, 0x19, 0xa522);
+                mdio_write(tp, 0x15, 0x02ce);
+                mdio_write(tp, 0x19, 0xb63e);
+                mdio_write(tp, 0x15, 0x02d9);
+                mdio_write(tp, 0x19, 0x32df);
+                mdio_write(tp, 0x15, 0x02df);
+                mdio_write(tp, 0x19, 0x4500);
+                mdio_write(tp, 0x15, 0x02e7);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x02f4);
+                mdio_write(tp, 0x19, 0xb618);
+                mdio_write(tp, 0x15, 0x02fb);
+                mdio_write(tp, 0x19, 0xb900);
+                mdio_write(tp, 0x15, 0x02fc);
+                mdio_write(tp, 0x19, 0x49b5);
+                mdio_write(tp, 0x15, 0x02fd);
+                mdio_write(tp, 0x19, 0x6812);
+                mdio_write(tp, 0x15, 0x02fe);
+                mdio_write(tp, 0x19, 0x66a0);
+                mdio_write(tp, 0x15, 0x02ff);
+                mdio_write(tp, 0x19, 0x9900);
+                mdio_write(tp, 0x15, 0x0300);
+                mdio_write(tp, 0x19, 0x64a0);
+                mdio_write(tp, 0x15, 0x0301);
+                mdio_write(tp, 0x19, 0x3316);
+                mdio_write(tp, 0x15, 0x0308);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x030c);
+                mdio_write(tp, 0x19, 0x3000);
+                mdio_write(tp, 0x15, 0x0312);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0313);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0314);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0315);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0316);
+                mdio_write(tp, 0x19, 0x49b5);
+                mdio_write(tp, 0x15, 0x0317);
+                mdio_write(tp, 0x19, 0x7d00);
+                mdio_write(tp, 0x15, 0x0318);
+                mdio_write(tp, 0x19, 0x4d00);
+                mdio_write(tp, 0x15, 0x0319);
+                mdio_write(tp, 0x19, 0x6810);
+                mdio_write(tp, 0x15, 0x031a);
+                mdio_write(tp, 0x19, 0x6c08);
+                mdio_write(tp, 0x15, 0x031b);
+                mdio_write(tp, 0x19, 0x4925);
+                mdio_write(tp, 0x15, 0x031c);
+                mdio_write(tp, 0x19, 0x403b);
+                mdio_write(tp, 0x15, 0x031d);
+                mdio_write(tp, 0x19, 0xa602);
+                mdio_write(tp, 0x15, 0x031e);
+                mdio_write(tp, 0x19, 0x402f);
+                mdio_write(tp, 0x15, 0x031f);
+                mdio_write(tp, 0x19, 0x4484);
+                mdio_write(tp, 0x15, 0x0320);
+                mdio_write(tp, 0x19, 0x40c8);
+                mdio_write(tp, 0x15, 0x0321);
+                mdio_write(tp, 0x19, 0x44c4);
+                mdio_write(tp, 0x15, 0x0322);
+                mdio_write(tp, 0x19, 0x404f);
+                mdio_write(tp, 0x15, 0x0323);
+                mdio_write(tp, 0x19, 0x44c8);
+                mdio_write(tp, 0x15, 0x0324);
+                mdio_write(tp, 0x19, 0xd64f);
+                mdio_write(tp, 0x15, 0x0325);
+                mdio_write(tp, 0x19, 0x00e7);
+                mdio_write(tp, 0x15, 0x0326);
+                mdio_write(tp, 0x19, 0x7c08);
+                mdio_write(tp, 0x15, 0x0327);
+                mdio_write(tp, 0x19, 0x8203);
+                mdio_write(tp, 0x15, 0x0328);
+                mdio_write(tp, 0x19, 0x4d48);
+                mdio_write(tp, 0x15, 0x0329);
+                mdio_write(tp, 0x19, 0x332b);
+                mdio_write(tp, 0x15, 0x032a);
+                mdio_write(tp, 0x19, 0x4d40);
+                mdio_write(tp, 0x15, 0x032c);
+                mdio_write(tp, 0x19, 0x00f8);
+                mdio_write(tp, 0x15, 0x032d);
+                mdio_write(tp, 0x19, 0x82b2);
+                mdio_write(tp, 0x15, 0x032f);
+                mdio_write(tp, 0x19, 0x00b0);
+                mdio_write(tp, 0x15, 0x0332);
+                mdio_write(tp, 0x19, 0x91f2);
+                mdio_write(tp, 0x15, 0x033f);
+                mdio_write(tp, 0x19, 0xb6cd);
+                mdio_write(tp, 0x15, 0x0340);
+                mdio_write(tp, 0x19, 0x9e01);
+                mdio_write(tp, 0x15, 0x0341);
+                mdio_write(tp, 0x19, 0xd11d);
+                mdio_write(tp, 0x15, 0x0342);
+                mdio_write(tp, 0x19, 0x009d);
+                mdio_write(tp, 0x15, 0x0343);
+                mdio_write(tp, 0x19, 0xbb1c);
+                mdio_write(tp, 0x15, 0x0344);
+                mdio_write(tp, 0x19, 0x8102);
+                mdio_write(tp, 0x15, 0x0345);
+                mdio_write(tp, 0x19, 0x3348);
+                mdio_write(tp, 0x15, 0x0346);
+                mdio_write(tp, 0x19, 0xa231);
+                mdio_write(tp, 0x15, 0x0347);
+                mdio_write(tp, 0x19, 0x335b);
+                mdio_write(tp, 0x15, 0x0348);
+                mdio_write(tp, 0x19, 0x91f7);
+                mdio_write(tp, 0x15, 0x0349);
+                mdio_write(tp, 0x19, 0xc218);
+                mdio_write(tp, 0x15, 0x034a);
+                mdio_write(tp, 0x19, 0x00f5);
+                mdio_write(tp, 0x15, 0x034b);
+                mdio_write(tp, 0x19, 0x335b);
+                mdio_write(tp, 0x15, 0x034c);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x034d);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x034e);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x034f);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0350);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x035b);
+                mdio_write(tp, 0x19, 0xa23c);
+                mdio_write(tp, 0x15, 0x035c);
+                mdio_write(tp, 0x19, 0x7c08);
+                mdio_write(tp, 0x15, 0x035d);
+                mdio_write(tp, 0x19, 0x4c00);
+                mdio_write(tp, 0x15, 0x035e);
+                mdio_write(tp, 0x19, 0x3397);
+                mdio_write(tp, 0x15, 0x0363);
+                mdio_write(tp, 0x19, 0xb6a9);
+                mdio_write(tp, 0x15, 0x0366);
+                mdio_write(tp, 0x19, 0x00f5);
+                mdio_write(tp, 0x15, 0x0382);
+                mdio_write(tp, 0x19, 0x7c40);
+                mdio_write(tp, 0x15, 0x0388);
+                mdio_write(tp, 0x19, 0x0084);
+                mdio_write(tp, 0x15, 0x0389);
+                mdio_write(tp, 0x19, 0xdd17);
+                mdio_write(tp, 0x15, 0x038a);
+                mdio_write(tp, 0x19, 0x000b);
+                mdio_write(tp, 0x15, 0x038b);
+                mdio_write(tp, 0x19, 0xa10a);
+                mdio_write(tp, 0x15, 0x038c);
+                mdio_write(tp, 0x19, 0x337e);
+                mdio_write(tp, 0x15, 0x038d);
+                mdio_write(tp, 0x19, 0x6c0b);
+                mdio_write(tp, 0x15, 0x038e);
+                mdio_write(tp, 0x19, 0xa107);
+                mdio_write(tp, 0x15, 0x038f);
+                mdio_write(tp, 0x19, 0x6c08);
+                mdio_write(tp, 0x15, 0x0390);
+                mdio_write(tp, 0x19, 0xc017);
+                mdio_write(tp, 0x15, 0x0391);
+                mdio_write(tp, 0x19, 0x0004);
+                mdio_write(tp, 0x15, 0x0392);
+                mdio_write(tp, 0x19, 0xd64f);
+                mdio_write(tp, 0x15, 0x0393);
+                mdio_write(tp, 0x19, 0x00f4);
+                mdio_write(tp, 0x15, 0x0397);
+                mdio_write(tp, 0x19, 0x4098);
+                mdio_write(tp, 0x15, 0x0398);
+                mdio_write(tp, 0x19, 0x4408);
+                mdio_write(tp, 0x15, 0x0399);
+                mdio_write(tp, 0x19, 0x55bf);
+                mdio_write(tp, 0x15, 0x039a);
+                mdio_write(tp, 0x19, 0x4bb9);
+                mdio_write(tp, 0x15, 0x039b);
+                mdio_write(tp, 0x19, 0x6810);
+                mdio_write(tp, 0x15, 0x039c);
+                mdio_write(tp, 0x19, 0x4b29);
+                mdio_write(tp, 0x15, 0x039d);
+                mdio_write(tp, 0x19, 0x4041);
+                mdio_write(tp, 0x15, 0x039e);
+                mdio_write(tp, 0x19, 0x442a);
+                mdio_write(tp, 0x15, 0x039f);
+                mdio_write(tp, 0x19, 0x4029);
+                mdio_write(tp, 0x15, 0x03aa);
+                mdio_write(tp, 0x19, 0x33b8);
+                mdio_write(tp, 0x15, 0x03b6);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03b7);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03b8);
+                mdio_write(tp, 0x19, 0x543f);
+                mdio_write(tp, 0x15, 0x03b9);
+                mdio_write(tp, 0x19, 0x499a);
+                mdio_write(tp, 0x15, 0x03ba);
+                mdio_write(tp, 0x19, 0x7c40);
+                mdio_write(tp, 0x15, 0x03bb);
+                mdio_write(tp, 0x19, 0x4c40);
+                mdio_write(tp, 0x15, 0x03bc);
+                mdio_write(tp, 0x19, 0x490a);
+                mdio_write(tp, 0x15, 0x03bd);
+                mdio_write(tp, 0x19, 0x405e);
+                mdio_write(tp, 0x15, 0x03c2);
+                mdio_write(tp, 0x19, 0x9a03);
+                mdio_write(tp, 0x15, 0x03c4);
+                mdio_write(tp, 0x19, 0x0015);
+                mdio_write(tp, 0x15, 0x03c5);
+                mdio_write(tp, 0x19, 0x9e03);
+                mdio_write(tp, 0x15, 0x03c8);
+                mdio_write(tp, 0x19, 0x9cf7);
+                mdio_write(tp, 0x15, 0x03c9);
+                mdio_write(tp, 0x19, 0x7c12);
+                mdio_write(tp, 0x15, 0x03ca);
+                mdio_write(tp, 0x19, 0x4c52);
+                mdio_write(tp, 0x15, 0x03cb);
+                mdio_write(tp, 0x19, 0x4458);
+                mdio_write(tp, 0x15, 0x03cd);
+                mdio_write(tp, 0x19, 0x4c40);
+                mdio_write(tp, 0x15, 0x03ce);
+                mdio_write(tp, 0x19, 0x33bf);
+                mdio_write(tp, 0x15, 0x03cf);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d0);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d1);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d5);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d6);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d7);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d8);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d9);
+                mdio_write(tp, 0x19, 0x49bb);
+                mdio_write(tp, 0x15, 0x03da);
+                mdio_write(tp, 0x19, 0x4478);
+                mdio_write(tp, 0x15, 0x03db);
+                mdio_write(tp, 0x19, 0x492b);
+                mdio_write(tp, 0x15, 0x03dc);
+                mdio_write(tp, 0x19, 0x7c01);
+                mdio_write(tp, 0x15, 0x03dd);
+                mdio_write(tp, 0x19, 0x4c00);
+                mdio_write(tp, 0x15, 0x03de);
+                mdio_write(tp, 0x19, 0xbd1a);
+                mdio_write(tp, 0x15, 0x03df);
+                mdio_write(tp, 0x19, 0xc428);
+                mdio_write(tp, 0x15, 0x03e0);
+                mdio_write(tp, 0x19, 0x0008);
+                mdio_write(tp, 0x15, 0x03e1);
+                mdio_write(tp, 0x19, 0x9cfd);
+                mdio_write(tp, 0x15, 0x03e2);
+                mdio_write(tp, 0x19, 0x7c12);
+                mdio_write(tp, 0x15, 0x03e3);
+                mdio_write(tp, 0x19, 0x4c52);
+                mdio_write(tp, 0x15, 0x03e4);
+                mdio_write(tp, 0x19, 0x4458);
+                mdio_write(tp, 0x15, 0x03e5);
+                mdio_write(tp, 0x19, 0x7c12);
+                mdio_write(tp, 0x15, 0x03e6);
+                mdio_write(tp, 0x19, 0x4c40);
+                mdio_write(tp, 0x15, 0x03e7);
+                mdio_write(tp, 0x19, 0x33de);
+                mdio_write(tp, 0x15, 0x03e8);
+                mdio_write(tp, 0x19, 0xc218);
+                mdio_write(tp, 0x15, 0x03e9);
+                mdio_write(tp, 0x19, 0x0002);
+                mdio_write(tp, 0x15, 0x03ea);
+                mdio_write(tp, 0x19, 0x32df);
+                mdio_write(tp, 0x15, 0x03eb);
+                mdio_write(tp, 0x19, 0x3316);
+                mdio_write(tp, 0x15, 0x03ec);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03ed);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03ee);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03ef);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03f7);
+                mdio_write(tp, 0x19, 0x330c);
+                mdio_write(tp, 0x16, 0x0306);
+                mdio_write(tp, 0x16, 0x0300);
+
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x05, 0xfff6);
+                mdio_write(tp, 0x06, 0x0080);
+                mdio_write(tp, 0x05, 0x8000);
+                mdio_write(tp, 0x06, 0x0280);
+                mdio_write(tp, 0x06, 0x48f7);
+                mdio_write(tp, 0x06, 0x00e0);
+                mdio_write(tp, 0x06, 0xfff7);
+                mdio_write(tp, 0x06, 0xa080);
+                mdio_write(tp, 0x06, 0x02ae);
+                mdio_write(tp, 0x06, 0xf602);
+                mdio_write(tp, 0x06, 0x0200);
+                mdio_write(tp, 0x06, 0x0280);
+                mdio_write(tp, 0x06, 0x9002);
+                mdio_write(tp, 0x06, 0x0224);
+                mdio_write(tp, 0x06, 0x0202);
+                mdio_write(tp, 0x06, 0x3402);
+                mdio_write(tp, 0x06, 0x027f);
+                mdio_write(tp, 0x06, 0x0280);
+                mdio_write(tp, 0x06, 0xa602);
+                mdio_write(tp, 0x06, 0x80bf);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x88e1);
+                mdio_write(tp, 0x06, 0x8b89);
+                mdio_write(tp, 0x06, 0x1e01);
+                mdio_write(tp, 0x06, 0xe18b);
+                mdio_write(tp, 0x06, 0x8a1e);
+                mdio_write(tp, 0x06, 0x01e1);
+                mdio_write(tp, 0x06, 0x8b8b);
+                mdio_write(tp, 0x06, 0x1e01);
+                mdio_write(tp, 0x06, 0xe18b);
+                mdio_write(tp, 0x06, 0x8c1e);
+                mdio_write(tp, 0x06, 0x01e1);
+                mdio_write(tp, 0x06, 0x8b8d);
+                mdio_write(tp, 0x06, 0x1e01);
+                mdio_write(tp, 0x06, 0xe18b);
+                mdio_write(tp, 0x06, 0x8e1e);
+                mdio_write(tp, 0x06, 0x01a0);
+                mdio_write(tp, 0x06, 0x00c7);
+                mdio_write(tp, 0x06, 0xaebb);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xe600);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xee03);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xefb8);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xe902);
+                mdio_write(tp, 0x06, 0xee8b);
+                mdio_write(tp, 0x06, 0x8285);
+                mdio_write(tp, 0x06, 0xee8b);
+                mdio_write(tp, 0x06, 0x8520);
+                mdio_write(tp, 0x06, 0xee8b);
+                mdio_write(tp, 0x06, 0x8701);
+                mdio_write(tp, 0x06, 0xd481);
+                mdio_write(tp, 0x06, 0x35e4);
+                mdio_write(tp, 0x06, 0x8b94);
+                mdio_write(tp, 0x06, 0xe58b);
+                mdio_write(tp, 0x06, 0x95bf);
+                mdio_write(tp, 0x06, 0x8b88);
+                mdio_write(tp, 0x06, 0xec00);
+                mdio_write(tp, 0x06, 0x19a9);
+                mdio_write(tp, 0x06, 0x8b90);
+                mdio_write(tp, 0x06, 0xf9ee);
+                mdio_write(tp, 0x06, 0xfff6);
+                mdio_write(tp, 0x06, 0x00ee);
+                mdio_write(tp, 0x06, 0xfff7);
+                mdio_write(tp, 0x06, 0xffe0);
+                mdio_write(tp, 0x06, 0xe140);
+                mdio_write(tp, 0x06, 0xe1e1);
+                mdio_write(tp, 0x06, 0x41f7);
+                mdio_write(tp, 0x06, 0x2ff6);
+                mdio_write(tp, 0x06, 0x28e4);
+                mdio_write(tp, 0x06, 0xe140);
+                mdio_write(tp, 0x06, 0xe5e1);
+                mdio_write(tp, 0x06, 0x4104);
+                mdio_write(tp, 0x06, 0xf8e0);
+                mdio_write(tp, 0x06, 0x8b89);
+                mdio_write(tp, 0x06, 0xad20);
+                mdio_write(tp, 0x06, 0x0dee);
+                mdio_write(tp, 0x06, 0x8b89);
+                mdio_write(tp, 0x06, 0x0002);
+                mdio_write(tp, 0x06, 0x82f4);
+                mdio_write(tp, 0x06, 0x021f);
+                mdio_write(tp, 0x06, 0x4102);
+                mdio_write(tp, 0x06, 0x2812);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8e0);
+                mdio_write(tp, 0x06, 0x8b8d);
+                mdio_write(tp, 0x06, 0xad20);
+                mdio_write(tp, 0x06, 0x10ee);
+                mdio_write(tp, 0x06, 0x8b8d);
+                mdio_write(tp, 0x06, 0x0002);
+                mdio_write(tp, 0x06, 0x139d);
+                mdio_write(tp, 0x06, 0x0281);
+                mdio_write(tp, 0x06, 0xd602);
+                mdio_write(tp, 0x06, 0x1f99);
+                mdio_write(tp, 0x06, 0x0227);
+                mdio_write(tp, 0x06, 0xeafc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x8ead);
+                mdio_write(tp, 0x06, 0x2014);
+                mdio_write(tp, 0x06, 0xf620);
+                mdio_write(tp, 0x06, 0xe48b);
+                mdio_write(tp, 0x06, 0x8e02);
+                mdio_write(tp, 0x06, 0x8104);
+                mdio_write(tp, 0x06, 0x021b);
+                mdio_write(tp, 0x06, 0xf402);
+                mdio_write(tp, 0x06, 0x2c9c);
+                mdio_write(tp, 0x06, 0x0281);
+                mdio_write(tp, 0x06, 0x7902);
+                mdio_write(tp, 0x06, 0x8443);
+                mdio_write(tp, 0x06, 0xad22);
+                mdio_write(tp, 0x06, 0x11f6);
+                mdio_write(tp, 0x06, 0x22e4);
+                mdio_write(tp, 0x06, 0x8b8e);
+                mdio_write(tp, 0x06, 0x022c);
+                mdio_write(tp, 0x06, 0x4602);
+                mdio_write(tp, 0x06, 0x2ac5);
+                mdio_write(tp, 0x06, 0x0229);
+                mdio_write(tp, 0x06, 0x2002);
+                mdio_write(tp, 0x06, 0x2b91);
+                mdio_write(tp, 0x06, 0xad25);
+                mdio_write(tp, 0x06, 0x11f6);
+                mdio_write(tp, 0x06, 0x25e4);
+                mdio_write(tp, 0x06, 0x8b8e);
+                mdio_write(tp, 0x06, 0x0284);
+                mdio_write(tp, 0x06, 0xe202);
+                mdio_write(tp, 0x06, 0x043a);
+                mdio_write(tp, 0x06, 0x021a);
+                mdio_write(tp, 0x06, 0x5902);
+                mdio_write(tp, 0x06, 0x2bfc);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x00e1);
+                mdio_write(tp, 0x06, 0xe001);
+                mdio_write(tp, 0x06, 0xad27);
+                mdio_write(tp, 0x06, 0x1fd1);
+                mdio_write(tp, 0x06, 0x01bf);
+                mdio_write(tp, 0x06, 0x8638);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50e0);
+                mdio_write(tp, 0x06, 0xe020);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x21ad);
+                mdio_write(tp, 0x06, 0x200e);
+                mdio_write(tp, 0x06, 0xd100);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x3802);
+                mdio_write(tp, 0x06, 0x2f50);
+                mdio_write(tp, 0x06, 0xbf3d);
+                mdio_write(tp, 0x06, 0x3902);
+                mdio_write(tp, 0x06, 0x2eb0);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefc);
+                mdio_write(tp, 0x06, 0x0402);
+                mdio_write(tp, 0x06, 0x8591);
+                mdio_write(tp, 0x06, 0x0281);
+                mdio_write(tp, 0x06, 0x3c05);
+                mdio_write(tp, 0x06, 0xf8fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0xfee1);
+                mdio_write(tp, 0x06, 0xe2ff);
+                mdio_write(tp, 0x06, 0xad2d);
+                mdio_write(tp, 0x06, 0x1ae0);
+                mdio_write(tp, 0x06, 0xe14e);
+                mdio_write(tp, 0x06, 0xe1e1);
+                mdio_write(tp, 0x06, 0x4fac);
+                mdio_write(tp, 0x06, 0x2d22);
+                mdio_write(tp, 0x06, 0xf603);
+                mdio_write(tp, 0x06, 0x0203);
+                mdio_write(tp, 0x06, 0x36f7);
+                mdio_write(tp, 0x06, 0x03f7);
+                mdio_write(tp, 0x06, 0x06bf);
+                mdio_write(tp, 0x06, 0x8622);
+                mdio_write(tp, 0x06, 0x022e);
+                mdio_write(tp, 0x06, 0xb0ae);
+                mdio_write(tp, 0x06, 0x11e0);
+                mdio_write(tp, 0x06, 0xe14e);
+                mdio_write(tp, 0x06, 0xe1e1);
+                mdio_write(tp, 0x06, 0x4fad);
+                mdio_write(tp, 0x06, 0x2d08);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x2d02);
+                mdio_write(tp, 0x06, 0x2eb0);
+                mdio_write(tp, 0x06, 0xf606);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xf9fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x87ad);
+                mdio_write(tp, 0x06, 0x204c);
+                mdio_write(tp, 0x06, 0xd200);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0x0058);
+                mdio_write(tp, 0x06, 0x010c);
+                mdio_write(tp, 0x06, 0x021e);
+                mdio_write(tp, 0x06, 0x20e0);
+                mdio_write(tp, 0x06, 0xe000);
+                mdio_write(tp, 0x06, 0x5810);
+                mdio_write(tp, 0x06, 0x1e20);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x3658);
+                mdio_write(tp, 0x06, 0x031e);
+                mdio_write(tp, 0x06, 0x20e0);
+                mdio_write(tp, 0x06, 0xe022);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x2358);
+                mdio_write(tp, 0x06, 0xe01e);
+                mdio_write(tp, 0x06, 0x20e0);
+                mdio_write(tp, 0x06, 0x8ae6);
+                mdio_write(tp, 0x06, 0x1f02);
+                mdio_write(tp, 0x06, 0x9e22);
+                mdio_write(tp, 0x06, 0xe68a);
+                mdio_write(tp, 0x06, 0xe6ad);
+                mdio_write(tp, 0x06, 0x3214);
+                mdio_write(tp, 0x06, 0xad34);
+                mdio_write(tp, 0x06, 0x11ef);
+                mdio_write(tp, 0x06, 0x0258);
+                mdio_write(tp, 0x06, 0x039e);
+                mdio_write(tp, 0x06, 0x07ad);
+                mdio_write(tp, 0x06, 0x3508);
+                mdio_write(tp, 0x06, 0x5ac0);
+                mdio_write(tp, 0x06, 0x9f04);
+                mdio_write(tp, 0x06, 0xd101);
+                mdio_write(tp, 0x06, 0xae02);
+                mdio_write(tp, 0x06, 0xd100);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x3e02);
+                mdio_write(tp, 0x06, 0x2f50);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefd);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8f9);
+                mdio_write(tp, 0x06, 0xfae0);
+                mdio_write(tp, 0x06, 0x8b81);
+                mdio_write(tp, 0x06, 0xac26);
+                mdio_write(tp, 0x06, 0x0ee0);
+                mdio_write(tp, 0x06, 0x8b81);
+                mdio_write(tp, 0x06, 0xac21);
+                mdio_write(tp, 0x06, 0x08e0);
+                mdio_write(tp, 0x06, 0x8b87);
+                mdio_write(tp, 0x06, 0xac24);
+                mdio_write(tp, 0x06, 0x02ae);
+                mdio_write(tp, 0x06, 0x6bee);
+                mdio_write(tp, 0x06, 0xe0ea);
+                mdio_write(tp, 0x06, 0x00ee);
+                mdio_write(tp, 0x06, 0xe0eb);
+                mdio_write(tp, 0x06, 0x00e2);
+                mdio_write(tp, 0x06, 0xe07c);
+                mdio_write(tp, 0x06, 0xe3e0);
+                mdio_write(tp, 0x06, 0x7da5);
+                mdio_write(tp, 0x06, 0x1111);
+                mdio_write(tp, 0x06, 0x15d2);
+                mdio_write(tp, 0x06, 0x60d6);
+                mdio_write(tp, 0x06, 0x6666);
+                mdio_write(tp, 0x06, 0x0207);
+                mdio_write(tp, 0x06, 0xf9d2);
+                mdio_write(tp, 0x06, 0xa0d6);
+                mdio_write(tp, 0x06, 0xaaaa);
+                mdio_write(tp, 0x06, 0x0207);
+                mdio_write(tp, 0x06, 0xf902);
+                mdio_write(tp, 0x06, 0x825c);
+                mdio_write(tp, 0x06, 0xae44);
+                mdio_write(tp, 0x06, 0xa566);
+                mdio_write(tp, 0x06, 0x6602);
+                mdio_write(tp, 0x06, 0xae38);
+                mdio_write(tp, 0x06, 0xa5aa);
+                mdio_write(tp, 0x06, 0xaa02);
+                mdio_write(tp, 0x06, 0xae32);
+                mdio_write(tp, 0x06, 0xeee0);
+                mdio_write(tp, 0x06, 0xea04);
+                mdio_write(tp, 0x06, 0xeee0);
+                mdio_write(tp, 0x06, 0xeb06);
+                mdio_write(tp, 0x06, 0xe2e0);
+                mdio_write(tp, 0x06, 0x7ce3);
+                mdio_write(tp, 0x06, 0xe07d);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x38e1);
+                mdio_write(tp, 0x06, 0xe039);
+                mdio_write(tp, 0x06, 0xad2e);
+                mdio_write(tp, 0x06, 0x21ad);
+                mdio_write(tp, 0x06, 0x3f13);
+                mdio_write(tp, 0x06, 0xe0e4);
+                mdio_write(tp, 0x06, 0x14e1);
+                mdio_write(tp, 0x06, 0xe415);
+                mdio_write(tp, 0x06, 0x6880);
+                mdio_write(tp, 0x06, 0xe4e4);
+                mdio_write(tp, 0x06, 0x14e5);
+                mdio_write(tp, 0x06, 0xe415);
+                mdio_write(tp, 0x06, 0x0282);
+                mdio_write(tp, 0x06, 0x5cae);
+                mdio_write(tp, 0x06, 0x0bac);
+                mdio_write(tp, 0x06, 0x3e02);
+                mdio_write(tp, 0x06, 0xae06);
+                mdio_write(tp, 0x06, 0x0282);
+                mdio_write(tp, 0x06, 0x8602);
+                mdio_write(tp, 0x06, 0x82b0);
+                mdio_write(tp, 0x06, 0xfefd);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8e1);
+                mdio_write(tp, 0x06, 0x8b2e);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x81ad);
+                mdio_write(tp, 0x06, 0x2605);
+                mdio_write(tp, 0x06, 0x0221);
+                mdio_write(tp, 0x06, 0xf3f7);
+                mdio_write(tp, 0x06, 0x28e0);
+                mdio_write(tp, 0x06, 0x8b81);
+                mdio_write(tp, 0x06, 0xad21);
+                mdio_write(tp, 0x06, 0x0502);
+                mdio_write(tp, 0x06, 0x22f8);
+                mdio_write(tp, 0x06, 0xf729);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x87ad);
+                mdio_write(tp, 0x06, 0x2405);
+                mdio_write(tp, 0x06, 0x0282);
+                mdio_write(tp, 0x06, 0xebf7);
+                mdio_write(tp, 0x06, 0x2ae5);
+                mdio_write(tp, 0x06, 0x8b2e);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8e0);
+                mdio_write(tp, 0x06, 0x8b81);
+                mdio_write(tp, 0x06, 0xad26);
+                mdio_write(tp, 0x06, 0x0302);
+                mdio_write(tp, 0x06, 0x2134);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x81ad);
+                mdio_write(tp, 0x06, 0x2109);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x2eac);
+                mdio_write(tp, 0x06, 0x2003);
+                mdio_write(tp, 0x06, 0x0283);
+                mdio_write(tp, 0x06, 0x52e0);
+                mdio_write(tp, 0x06, 0x8b87);
+                mdio_write(tp, 0x06, 0xad24);
+                mdio_write(tp, 0x06, 0x09e0);
+                mdio_write(tp, 0x06, 0x8b2e);
+                mdio_write(tp, 0x06, 0xac21);
+                mdio_write(tp, 0x06, 0x0302);
+                mdio_write(tp, 0x06, 0x8337);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8e1);
+                mdio_write(tp, 0x06, 0x8b2e);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x81ad);
+                mdio_write(tp, 0x06, 0x2608);
+                mdio_write(tp, 0x06, 0xe085);
+                mdio_write(tp, 0x06, 0xd2ad);
+                mdio_write(tp, 0x06, 0x2502);
+                mdio_write(tp, 0x06, 0xf628);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x81ad);
+                mdio_write(tp, 0x06, 0x210a);
+                mdio_write(tp, 0x06, 0xe086);
+                mdio_write(tp, 0x06, 0x0af6);
+                mdio_write(tp, 0x06, 0x27a0);
+                mdio_write(tp, 0x06, 0x0502);
+                mdio_write(tp, 0x06, 0xf629);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x87ad);
+                mdio_write(tp, 0x06, 0x2408);
+                mdio_write(tp, 0x06, 0xe08a);
+                mdio_write(tp, 0x06, 0xedad);
+                mdio_write(tp, 0x06, 0x2002);
+                mdio_write(tp, 0x06, 0xf62a);
+                mdio_write(tp, 0x06, 0xe58b);
+                mdio_write(tp, 0x06, 0x2ea1);
+                mdio_write(tp, 0x06, 0x0003);
+                mdio_write(tp, 0x06, 0x0221);
+                mdio_write(tp, 0x06, 0x11fc);
+                mdio_write(tp, 0x06, 0x04ee);
+                mdio_write(tp, 0x06, 0x8aed);
+                mdio_write(tp, 0x06, 0x00ee);
+                mdio_write(tp, 0x06, 0x8aec);
+                mdio_write(tp, 0x06, 0x0004);
+                mdio_write(tp, 0x06, 0xf8e0);
+                mdio_write(tp, 0x06, 0x8b87);
+                mdio_write(tp, 0x06, 0xad24);
+                mdio_write(tp, 0x06, 0x3ae0);
+                mdio_write(tp, 0x06, 0xe0ea);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0xeb58);
+                mdio_write(tp, 0x06, 0xf8d1);
+                mdio_write(tp, 0x06, 0x01e4);
+                mdio_write(tp, 0x06, 0xe0ea);
+                mdio_write(tp, 0x06, 0xe5e0);
+                mdio_write(tp, 0x06, 0xebe0);
+                mdio_write(tp, 0x06, 0xe07c);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x7d5c);
+                mdio_write(tp, 0x06, 0x00ff);
+                mdio_write(tp, 0x06, 0x3c00);
+                mdio_write(tp, 0x06, 0x1eab);
+                mdio_write(tp, 0x06, 0x1ce0);
+                mdio_write(tp, 0x06, 0xe04c);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x4d58);
+                mdio_write(tp, 0x06, 0xc1e4);
+                mdio_write(tp, 0x06, 0xe04c);
+                mdio_write(tp, 0x06, 0xe5e0);
+                mdio_write(tp, 0x06, 0x4de0);
+                mdio_write(tp, 0x06, 0xe0ee);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0x3ce4);
+                mdio_write(tp, 0x06, 0xe0ee);
+                mdio_write(tp, 0x06, 0xe5e0);
+                mdio_write(tp, 0x06, 0xeffc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x87ad);
+                mdio_write(tp, 0x06, 0x2412);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0xeee1);
+                mdio_write(tp, 0x06, 0xe0ef);
+                mdio_write(tp, 0x06, 0x59c3);
+                mdio_write(tp, 0x06, 0xe4e0);
+                mdio_write(tp, 0x06, 0xeee5);
+                mdio_write(tp, 0x06, 0xe0ef);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xed01);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8e0);
+                mdio_write(tp, 0x06, 0x8b81);
+                mdio_write(tp, 0x06, 0xac25);
+                mdio_write(tp, 0x06, 0x0502);
+                mdio_write(tp, 0x06, 0x8363);
+                mdio_write(tp, 0x06, 0xae03);
+                mdio_write(tp, 0x06, 0x0225);
+                mdio_write(tp, 0x06, 0x16fc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xf9fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xfae0);
+                mdio_write(tp, 0x06, 0x860a);
+                mdio_write(tp, 0x06, 0xa000);
+                mdio_write(tp, 0x06, 0x19e0);
+                mdio_write(tp, 0x06, 0x860b);
+                mdio_write(tp, 0x06, 0xe18b);
+                mdio_write(tp, 0x06, 0x331b);
+                mdio_write(tp, 0x06, 0x109e);
+                mdio_write(tp, 0x06, 0x04aa);
+                mdio_write(tp, 0x06, 0x02ae);
+                mdio_write(tp, 0x06, 0x06ee);
+                mdio_write(tp, 0x06, 0x860a);
+                mdio_write(tp, 0x06, 0x01ae);
+                mdio_write(tp, 0x06, 0xe602);
+                mdio_write(tp, 0x06, 0x241e);
+                mdio_write(tp, 0x06, 0xae14);
+                mdio_write(tp, 0x06, 0xa001);
+                mdio_write(tp, 0x06, 0x1402);
+                mdio_write(tp, 0x06, 0x2426);
+                mdio_write(tp, 0x06, 0xbf26);
+                mdio_write(tp, 0x06, 0x6d02);
+                mdio_write(tp, 0x06, 0x2eb0);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0b00);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0a02);
+                mdio_write(tp, 0x06, 0xaf84);
+                mdio_write(tp, 0x06, 0x3ca0);
+                mdio_write(tp, 0x06, 0x0252);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0400);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0500);
+                mdio_write(tp, 0x06, 0xe086);
+                mdio_write(tp, 0x06, 0x0be1);
+                mdio_write(tp, 0x06, 0x8b32);
+                mdio_write(tp, 0x06, 0x1b10);
+                mdio_write(tp, 0x06, 0x9e04);
+                mdio_write(tp, 0x06, 0xaa02);
+                mdio_write(tp, 0x06, 0xaecb);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0b00);
+                mdio_write(tp, 0x06, 0x0224);
+                mdio_write(tp, 0x06, 0x3ae2);
+                mdio_write(tp, 0x06, 0x8604);
+                mdio_write(tp, 0x06, 0xe386);
+                mdio_write(tp, 0x06, 0x05ef);
+                mdio_write(tp, 0x06, 0x65e2);
+                mdio_write(tp, 0x06, 0x8606);
+                mdio_write(tp, 0x06, 0xe386);
+                mdio_write(tp, 0x06, 0x071b);
+                mdio_write(tp, 0x06, 0x56aa);
+                mdio_write(tp, 0x06, 0x0eef);
+                mdio_write(tp, 0x06, 0x56e6);
+                mdio_write(tp, 0x06, 0x8606);
+                mdio_write(tp, 0x06, 0xe786);
+                mdio_write(tp, 0x06, 0x07e2);
+                mdio_write(tp, 0x06, 0x8609);
+                mdio_write(tp, 0x06, 0xe686);
+                mdio_write(tp, 0x06, 0x08e0);
+                mdio_write(tp, 0x06, 0x8609);
+                mdio_write(tp, 0x06, 0xa000);
+                mdio_write(tp, 0x06, 0x07ee);
+                mdio_write(tp, 0x06, 0x860a);
+                mdio_write(tp, 0x06, 0x03af);
+                mdio_write(tp, 0x06, 0x8369);
+                mdio_write(tp, 0x06, 0x0224);
+                mdio_write(tp, 0x06, 0x8e02);
+                mdio_write(tp, 0x06, 0x2426);
+                mdio_write(tp, 0x06, 0xae48);
+                mdio_write(tp, 0x06, 0xa003);
+                mdio_write(tp, 0x06, 0x21e0);
+                mdio_write(tp, 0x06, 0x8608);
+                mdio_write(tp, 0x06, 0xe186);
+                mdio_write(tp, 0x06, 0x091b);
+                mdio_write(tp, 0x06, 0x019e);
+                mdio_write(tp, 0x06, 0x0caa);
+                mdio_write(tp, 0x06, 0x0502);
+                mdio_write(tp, 0x06, 0x249d);
+                mdio_write(tp, 0x06, 0xaee7);
+                mdio_write(tp, 0x06, 0x0224);
+                mdio_write(tp, 0x06, 0x8eae);
+                mdio_write(tp, 0x06, 0xe2ee);
+                mdio_write(tp, 0x06, 0x860a);
+                mdio_write(tp, 0x06, 0x04ee);
+                mdio_write(tp, 0x06, 0x860b);
+                mdio_write(tp, 0x06, 0x00af);
+                mdio_write(tp, 0x06, 0x8369);
+                mdio_write(tp, 0x06, 0xa004);
+                mdio_write(tp, 0x06, 0x15e0);
+                mdio_write(tp, 0x06, 0x860b);
+                mdio_write(tp, 0x06, 0xe18b);
+                mdio_write(tp, 0x06, 0x341b);
+                mdio_write(tp, 0x06, 0x109e);
+                mdio_write(tp, 0x06, 0x05aa);
+                mdio_write(tp, 0x06, 0x03af);
+                mdio_write(tp, 0x06, 0x8383);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0a05);
+                mdio_write(tp, 0x06, 0xae0c);
+                mdio_write(tp, 0x06, 0xa005);
+                mdio_write(tp, 0x06, 0x02ae);
+                mdio_write(tp, 0x06, 0x0702);
+                mdio_write(tp, 0x06, 0x2309);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0a00);
+                mdio_write(tp, 0x06, 0xfeef);
+                mdio_write(tp, 0x06, 0x96fe);
+                mdio_write(tp, 0x06, 0xfdfc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xf9fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xfbe0);
+                mdio_write(tp, 0x06, 0x8b85);
+                mdio_write(tp, 0x06, 0xad25);
+                mdio_write(tp, 0x06, 0x22e0);
+                mdio_write(tp, 0x06, 0xe022);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x23e2);
+                mdio_write(tp, 0x06, 0xe036);
+                mdio_write(tp, 0x06, 0xe3e0);
+                mdio_write(tp, 0x06, 0x375a);
+                mdio_write(tp, 0x06, 0xc40d);
+                mdio_write(tp, 0x06, 0x0158);
+                mdio_write(tp, 0x06, 0x021e);
+                mdio_write(tp, 0x06, 0x20e3);
+                mdio_write(tp, 0x06, 0x8ae7);
+                mdio_write(tp, 0x06, 0xac31);
+                mdio_write(tp, 0x06, 0x60ac);
+                mdio_write(tp, 0x06, 0x3a08);
+                mdio_write(tp, 0x06, 0xac3e);
+                mdio_write(tp, 0x06, 0x26ae);
+                mdio_write(tp, 0x06, 0x67af);
+                mdio_write(tp, 0x06, 0x84db);
+                mdio_write(tp, 0x06, 0xad37);
+                mdio_write(tp, 0x06, 0x61e0);
+                mdio_write(tp, 0x06, 0x8ae8);
+                mdio_write(tp, 0x06, 0x10e4);
+                mdio_write(tp, 0x06, 0x8ae8);
+                mdio_write(tp, 0x06, 0xe18a);
+                mdio_write(tp, 0x06, 0xe91b);
+                mdio_write(tp, 0x06, 0x109e);
+                mdio_write(tp, 0x06, 0x02ae);
+                mdio_write(tp, 0x06, 0x51d1);
+                mdio_write(tp, 0x06, 0x00bf);
+                mdio_write(tp, 0x06, 0x863b);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50ee);
+                mdio_write(tp, 0x06, 0x8ae8);
+                mdio_write(tp, 0x06, 0x00ae);
+                mdio_write(tp, 0x06, 0x43ad);
+                mdio_write(tp, 0x06, 0x3627);
+                mdio_write(tp, 0x06, 0xe08a);
+                mdio_write(tp, 0x06, 0xeee1);
+                mdio_write(tp, 0x06, 0x8aef);
+                mdio_write(tp, 0x06, 0xef74);
+                mdio_write(tp, 0x06, 0xe08a);
+                mdio_write(tp, 0x06, 0xeae1);
+                mdio_write(tp, 0x06, 0x8aeb);
+                mdio_write(tp, 0x06, 0x1b74);
+                mdio_write(tp, 0x06, 0x9e2e);
+                mdio_write(tp, 0x06, 0x14e4);
+                mdio_write(tp, 0x06, 0x8aea);
+                mdio_write(tp, 0x06, 0xe58a);
+                mdio_write(tp, 0x06, 0xebef);
+                mdio_write(tp, 0x06, 0x74e0);
+                mdio_write(tp, 0x06, 0x8aee);
+                mdio_write(tp, 0x06, 0xe18a);
+                mdio_write(tp, 0x06, 0xef1b);
+                mdio_write(tp, 0x06, 0x479e);
+                mdio_write(tp, 0x06, 0x0fae);
+                mdio_write(tp, 0x06, 0x19ee);
+                mdio_write(tp, 0x06, 0x8aea);
+                mdio_write(tp, 0x06, 0x00ee);
+                mdio_write(tp, 0x06, 0x8aeb);
+                mdio_write(tp, 0x06, 0x00ae);
+                mdio_write(tp, 0x06, 0x0fac);
+                mdio_write(tp, 0x06, 0x390c);
+                mdio_write(tp, 0x06, 0xd101);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x3b02);
+                mdio_write(tp, 0x06, 0x2f50);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xe800);
+                mdio_write(tp, 0x06, 0xe68a);
+                mdio_write(tp, 0x06, 0xe7ff);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefd);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8f9);
+                mdio_write(tp, 0x06, 0xfaef);
+                mdio_write(tp, 0x06, 0x69e0);
+                mdio_write(tp, 0x06, 0xe022);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x2358);
+                mdio_write(tp, 0x06, 0xc4e1);
+                mdio_write(tp, 0x06, 0x8b6e);
+                mdio_write(tp, 0x06, 0x1f10);
+                mdio_write(tp, 0x06, 0x9e24);
+                mdio_write(tp, 0x06, 0xe48b);
+                mdio_write(tp, 0x06, 0x6ead);
+                mdio_write(tp, 0x06, 0x2218);
+                mdio_write(tp, 0x06, 0xac27);
+                mdio_write(tp, 0x06, 0x0dac);
+                mdio_write(tp, 0x06, 0x2605);
+                mdio_write(tp, 0x06, 0x0203);
+                mdio_write(tp, 0x06, 0x8fae);
+                mdio_write(tp, 0x06, 0x1302);
+                mdio_write(tp, 0x06, 0x03c8);
+                mdio_write(tp, 0x06, 0xae0e);
+                mdio_write(tp, 0x06, 0x0203);
+                mdio_write(tp, 0x06, 0xe102);
+                mdio_write(tp, 0x06, 0x8520);
+                mdio_write(tp, 0x06, 0xae06);
+                mdio_write(tp, 0x06, 0x0203);
+                mdio_write(tp, 0x06, 0x8f02);
+                mdio_write(tp, 0x06, 0x8566);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefd);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x82ad);
+                mdio_write(tp, 0x06, 0x2737);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x4402);
+                mdio_write(tp, 0x06, 0x2f23);
+                mdio_write(tp, 0x06, 0xac28);
+                mdio_write(tp, 0x06, 0x2ed1);
+                mdio_write(tp, 0x06, 0x01bf);
+                mdio_write(tp, 0x06, 0x8647);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50bf);
+                mdio_write(tp, 0x06, 0x8641);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x23e5);
+                mdio_write(tp, 0x06, 0x8af0);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x22e1);
+                mdio_write(tp, 0x06, 0xe023);
+                mdio_write(tp, 0x06, 0xac2e);
+                mdio_write(tp, 0x06, 0x04d1);
+                mdio_write(tp, 0x06, 0x01ae);
+                mdio_write(tp, 0x06, 0x02d1);
+                mdio_write(tp, 0x06, 0x00bf);
+                mdio_write(tp, 0x06, 0x8641);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50d1);
+                mdio_write(tp, 0x06, 0x01bf);
+                mdio_write(tp, 0x06, 0x8644);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50ef);
+                mdio_write(tp, 0x06, 0x96fe);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x4702);
+                mdio_write(tp, 0x06, 0x2f23);
+                mdio_write(tp, 0x06, 0xad28);
+                mdio_write(tp, 0x06, 0x19d1);
+                mdio_write(tp, 0x06, 0x00bf);
+                mdio_write(tp, 0x06, 0x8644);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50e1);
+                mdio_write(tp, 0x06, 0x8af0);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x4102);
+                mdio_write(tp, 0x06, 0x2f50);
+                mdio_write(tp, 0x06, 0xd100);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x4702);
+                mdio_write(tp, 0x06, 0x2f50);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0xfee1);
+                mdio_write(tp, 0x06, 0xe2ff);
+                mdio_write(tp, 0x06, 0xad2e);
+                mdio_write(tp, 0x06, 0x63e0);
+                mdio_write(tp, 0x06, 0xe038);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x39ad);
+                mdio_write(tp, 0x06, 0x2f10);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x34e1);
+                mdio_write(tp, 0x06, 0xe035);
+                mdio_write(tp, 0x06, 0xf726);
+                mdio_write(tp, 0x06, 0xe4e0);
+                mdio_write(tp, 0x06, 0x34e5);
+                mdio_write(tp, 0x06, 0xe035);
+                mdio_write(tp, 0x06, 0xae0e);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0xd6e1);
+                mdio_write(tp, 0x06, 0xe2d7);
+                mdio_write(tp, 0x06, 0xf728);
+                mdio_write(tp, 0x06, 0xe4e2);
+                mdio_write(tp, 0x06, 0xd6e5);
+                mdio_write(tp, 0x06, 0xe2d7);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0x34e1);
+                mdio_write(tp, 0x06, 0xe235);
+                mdio_write(tp, 0x06, 0xf72b);
+                mdio_write(tp, 0x06, 0xe4e2);
+                mdio_write(tp, 0x06, 0x34e5);
+                mdio_write(tp, 0x06, 0xe235);
+                mdio_write(tp, 0x06, 0xd07d);
+                mdio_write(tp, 0x06, 0xb0fe);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0x34e1);
+                mdio_write(tp, 0x06, 0xe235);
+                mdio_write(tp, 0x06, 0xf62b);
+                mdio_write(tp, 0x06, 0xe4e2);
+                mdio_write(tp, 0x06, 0x34e5);
+                mdio_write(tp, 0x06, 0xe235);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x34e1);
+                mdio_write(tp, 0x06, 0xe035);
+                mdio_write(tp, 0x06, 0xf626);
+                mdio_write(tp, 0x06, 0xe4e0);
+                mdio_write(tp, 0x06, 0x34e5);
+                mdio_write(tp, 0x06, 0xe035);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0xd6e1);
+                mdio_write(tp, 0x06, 0xe2d7);
+                mdio_write(tp, 0x06, 0xf628);
+                mdio_write(tp, 0x06, 0xe4e2);
+                mdio_write(tp, 0x06, 0xd6e5);
+                mdio_write(tp, 0x06, 0xe2d7);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xae20);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0xa725);
+                mdio_write(tp, 0x06, 0xe50a);
+                mdio_write(tp, 0x06, 0x1de5);
+                mdio_write(tp, 0x06, 0x0a2c);
+                mdio_write(tp, 0x06, 0xe50a);
+                mdio_write(tp, 0x06, 0x6de5);
+                mdio_write(tp, 0x06, 0x0a1d);
+                mdio_write(tp, 0x06, 0xe50a);
+                mdio_write(tp, 0x06, 0x1ce5);
+                mdio_write(tp, 0x06, 0x0a2d);
+                mdio_write(tp, 0x06, 0xa755);
+                mdio_write(tp, 0x06, 0x00e2);
+                mdio_write(tp, 0x06, 0x3488);
+                mdio_write(tp, 0x06, 0xe200);
+                mdio_write(tp, 0x06, 0xcce2);
+                mdio_write(tp, 0x06, 0x0055);
+                mdio_write(tp, 0x06, 0xe020);
+                mdio_write(tp, 0x06, 0x55e2);
+                mdio_write(tp, 0x06, 0xd600);
+                mdio_write(tp, 0x06, 0xe24a);
+                gphy_val = mdio_read(tp, 0x01);
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x01, gphy_val);
+                gphy_val = mdio_read(tp, 0x00);
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x00, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, 0x17, 0x2179);
+                mdio_write(tp, 0x1f, 0x0001);
+                mdio_write(tp, 0x10, 0xf274);
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x0042);
+                mdio_write(tp, 0x15, 0x0f00);
+                mdio_write(tp, 0x15, 0x0f00);
+                mdio_write(tp, 0x16, 0x7408);
+                mdio_write(tp, 0x15, 0x0e00);
+                mdio_write(tp, 0x15, 0x0f00);
+                mdio_write(tp, 0x15, 0x0f01);
+                mdio_write(tp, 0x16, 0x4000);
+                mdio_write(tp, 0x15, 0x0e01);
+                mdio_write(tp, 0x15, 0x0f01);
+                mdio_write(tp, 0x15, 0x0f02);
+                mdio_write(tp, 0x16, 0x9400);
+                mdio_write(tp, 0x15, 0x0e02);
+                mdio_write(tp, 0x15, 0x0f02);
+                mdio_write(tp, 0x15, 0x0f03);
+                mdio_write(tp, 0x16, 0x7408);
+                mdio_write(tp, 0x15, 0x0e03);
+                mdio_write(tp, 0x15, 0x0f03);
+                mdio_write(tp, 0x15, 0x0f04);
+                mdio_write(tp, 0x16, 0x4008);
+                mdio_write(tp, 0x15, 0x0e04);
+                mdio_write(tp, 0x15, 0x0f04);
+                mdio_write(tp, 0x15, 0x0f05);
+                mdio_write(tp, 0x16, 0x9400);
+                mdio_write(tp, 0x15, 0x0e05);
+                mdio_write(tp, 0x15, 0x0f05);
+                mdio_write(tp, 0x15, 0x0f06);
+                mdio_write(tp, 0x16, 0x0803);
+                mdio_write(tp, 0x15, 0x0e06);
+                mdio_write(tp, 0x15, 0x0f06);
+                mdio_write(tp, 0x15, 0x0d00);
+                mdio_write(tp, 0x15, 0x0100);
+                mdio_write(tp, 0x1f, 0x0001);
+                mdio_write(tp, 0x10, 0xf074);
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, 0x17, 0x2149);
+
+                mdio_write(tp, 0x1f, 0x0005);
+                for (i = 0; i < 200; i++) {
+                        udelay(100);
+                        gphy_val = mdio_read(tp, 0x00);
+                        if (gphy_val & BIT_7)
+                                break;
+                }
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x0023);
+                gphy_val = mdio_read(tp, 0x17);
+                gphy_val &= ~(BIT_0);
+                if (tp->RequiredSecLanDonglePatch)
+                        gphy_val &= ~(BIT_2);
+                mdio_write(tp, 0x17, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x0023);
+                gphy_val = mdio_read(tp, 0x17);
+                gphy_val |= BIT_14;
+                mdio_write(tp, 0x17, gphy_val);
+                mdio_write(tp, 0x1e, 0x0020);
+                gphy_val = mdio_read(tp, 0x1b);
+                gphy_val |= BIT_7;
+                mdio_write(tp, 0x1b, gphy_val);
+                mdio_write(tp, 0x1e, 0x0041);
+                mdio_write(tp, 0x15, 0x0e02);
+                mdio_write(tp, 0x1e, 0x0028);
+                gphy_val = mdio_read(tp, 0x19);
+                gphy_val |= BIT_15;
+                mdio_write(tp, 0x19, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+        } else {
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, 0x00, 0x1800);
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x0023);
+                mdio_write(tp, 0x17, 0x0117);
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1E, 0x002C);
+                mdio_write(tp, 0x1B, 0x5000);
+                mdio_write(tp, 0x1f, 0x0000);
+                mdio_write(tp, 0x16, 0x4104);
+                for (i = 0; i < 200; i++) {
+                        udelay(100);
+                        gphy_val = mdio_read(tp, 0x1E);
+                        gphy_val &= 0x03FF;
+                        if (gphy_val==0x000C)
+                                break;
+                }
+                mdio_write(tp, 0x1f, 0x0005);
+                for (i = 0; i < 200; i++) {
+                        udelay(100);
+                        gphy_val = mdio_read(tp, 0x07);
+                        if ((gphy_val & BIT_5) == 0)
+                                break;
+                }
+                gphy_val = mdio_read(tp, 0x07);
+                if (gphy_val & BIT_5) {
+                        mdio_write(tp, 0x1f, 0x0007);
+                        mdio_write(tp, 0x1e, 0x00a1);
+                        mdio_write(tp, 0x17, 0x1000);
+                        mdio_write(tp, 0x17, 0x0000);
+                        mdio_write(tp, 0x17, 0x2000);
+                        mdio_write(tp, 0x1e, 0x002f);
+                        mdio_write(tp, 0x18, 0x9bfb);
+                        mdio_write(tp, 0x1f, 0x0005);
+                        mdio_write(tp, 0x07, 0x0000);
+                        mdio_write(tp, 0x1f, 0x0000);
+                }
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x05, 0xfff6);
+                mdio_write(tp, 0x06, 0x0080);
+                gphy_val = mdio_read(tp, 0x00);
+                gphy_val &= ~(BIT_7);
+                mdio_write(tp, 0x00, gphy_val);
+                mdio_write(tp, 0x1f, 0x0002);
+                gphy_val = mdio_read(tp, 0x08);
+                gphy_val &= ~(BIT_7);
+                mdio_write(tp, 0x08, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x0023);
+                mdio_write(tp, 0x16, 0x0306);
+                mdio_write(tp, 0x16, 0x0307);
+                mdio_write(tp, 0x15, 0x000e);
+                mdio_write(tp, 0x19, 0x000a);
+                mdio_write(tp, 0x15, 0x0010);
+                mdio_write(tp, 0x19, 0x0008);
+                mdio_write(tp, 0x15, 0x0018);
+                mdio_write(tp, 0x19, 0x4801);
+                mdio_write(tp, 0x15, 0x0019);
+                mdio_write(tp, 0x19, 0x6801);
+                mdio_write(tp, 0x15, 0x001a);
+                mdio_write(tp, 0x19, 0x66a1);
+                mdio_write(tp, 0x15, 0x001f);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0020);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0021);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0022);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0023);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0024);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0025);
+                mdio_write(tp, 0x19, 0x64a1);
+                mdio_write(tp, 0x15, 0x0026);
+                mdio_write(tp, 0x19, 0x40ea);
+                mdio_write(tp, 0x15, 0x0027);
+                mdio_write(tp, 0x19, 0x4503);
+                mdio_write(tp, 0x15, 0x0028);
+                mdio_write(tp, 0x19, 0x9f00);
+                mdio_write(tp, 0x15, 0x0029);
+                mdio_write(tp, 0x19, 0xa631);
+                mdio_write(tp, 0x15, 0x002a);
+                mdio_write(tp, 0x19, 0x9717);
+                mdio_write(tp, 0x15, 0x002b);
+                mdio_write(tp, 0x19, 0x302c);
+                mdio_write(tp, 0x15, 0x002c);
+                mdio_write(tp, 0x19, 0x4802);
+                mdio_write(tp, 0x15, 0x002d);
+                mdio_write(tp, 0x19, 0x58da);
+                mdio_write(tp, 0x15, 0x002e);
+                mdio_write(tp, 0x19, 0x400d);
+                mdio_write(tp, 0x15, 0x002f);
+                mdio_write(tp, 0x19, 0x4488);
+                mdio_write(tp, 0x15, 0x0030);
+                mdio_write(tp, 0x19, 0x9e00);
+                mdio_write(tp, 0x15, 0x0031);
+                mdio_write(tp, 0x19, 0x63c8);
+                mdio_write(tp, 0x15, 0x0032);
+                mdio_write(tp, 0x19, 0x6481);
+                mdio_write(tp, 0x15, 0x0033);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0034);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0035);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0036);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0037);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0038);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0039);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x003a);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x003b);
+                mdio_write(tp, 0x19, 0x63e8);
+                mdio_write(tp, 0x15, 0x003c);
+                mdio_write(tp, 0x19, 0x7d00);
+                mdio_write(tp, 0x15, 0x003d);
+                mdio_write(tp, 0x19, 0x59d4);
+                mdio_write(tp, 0x15, 0x003e);
+                mdio_write(tp, 0x19, 0x63f8);
+                mdio_write(tp, 0x15, 0x0040);
+                mdio_write(tp, 0x19, 0x64a1);
+                mdio_write(tp, 0x15, 0x0041);
+                mdio_write(tp, 0x19, 0x30de);
+                mdio_write(tp, 0x15, 0x0044);
+                mdio_write(tp, 0x19, 0x480f);
+                mdio_write(tp, 0x15, 0x0045);
+                mdio_write(tp, 0x19, 0x6800);
+                mdio_write(tp, 0x15, 0x0046);
+                mdio_write(tp, 0x19, 0x6680);
+                mdio_write(tp, 0x15, 0x0047);
+                mdio_write(tp, 0x19, 0x7c10);
+                mdio_write(tp, 0x15, 0x0048);
+                mdio_write(tp, 0x19, 0x63c8);
+                mdio_write(tp, 0x15, 0x0049);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004a);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004b);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004c);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004d);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004e);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x004f);
+                mdio_write(tp, 0x19, 0x40ea);
+                mdio_write(tp, 0x15, 0x0050);
+                mdio_write(tp, 0x19, 0x4503);
+                mdio_write(tp, 0x15, 0x0051);
+                mdio_write(tp, 0x19, 0x58ca);
+                mdio_write(tp, 0x15, 0x0052);
+                mdio_write(tp, 0x19, 0x63c8);
+                mdio_write(tp, 0x15, 0x0053);
+                mdio_write(tp, 0x19, 0x63d8);
+                mdio_write(tp, 0x15, 0x0054);
+                mdio_write(tp, 0x19, 0x66a0);
+                mdio_write(tp, 0x15, 0x0055);
+                mdio_write(tp, 0x19, 0x9f00);
+                mdio_write(tp, 0x15, 0x0056);
+                mdio_write(tp, 0x19, 0x3000);
+                mdio_write(tp, 0x15, 0x00a1);
+                mdio_write(tp, 0x19, 0x3044);
+                mdio_write(tp, 0x15, 0x00ab);
+                mdio_write(tp, 0x19, 0x5820);
+                mdio_write(tp, 0x15, 0x00ac);
+                mdio_write(tp, 0x19, 0x5e04);
+                mdio_write(tp, 0x15, 0x00ad);
+                mdio_write(tp, 0x19, 0xb60c);
+                mdio_write(tp, 0x15, 0x00af);
+                mdio_write(tp, 0x19, 0x000a);
+                mdio_write(tp, 0x15, 0x00b2);
+                mdio_write(tp, 0x19, 0x30b9);
+                mdio_write(tp, 0x15, 0x00b9);
+                mdio_write(tp, 0x19, 0x4408);
+                mdio_write(tp, 0x15, 0x00ba);
+                mdio_write(tp, 0x19, 0x480b);
+                mdio_write(tp, 0x15, 0x00bb);
+                mdio_write(tp, 0x19, 0x5e00);
+                mdio_write(tp, 0x15, 0x00bc);
+                mdio_write(tp, 0x19, 0x405f);
+                mdio_write(tp, 0x15, 0x00bd);
+                mdio_write(tp, 0x19, 0x4448);
+                mdio_write(tp, 0x15, 0x00be);
+                mdio_write(tp, 0x19, 0x4020);
+                mdio_write(tp, 0x15, 0x00bf);
+                mdio_write(tp, 0x19, 0x4468);
+                mdio_write(tp, 0x15, 0x00c0);
+                mdio_write(tp, 0x19, 0x9c02);
+                mdio_write(tp, 0x15, 0x00c1);
+                mdio_write(tp, 0x19, 0x58a0);
+                mdio_write(tp, 0x15, 0x00c2);
+                mdio_write(tp, 0x19, 0xb605);
+                mdio_write(tp, 0x15, 0x00c3);
+                mdio_write(tp, 0x19, 0xc0d3);
+                mdio_write(tp, 0x15, 0x00c4);
+                mdio_write(tp, 0x19, 0x00e6);
+                mdio_write(tp, 0x15, 0x00c5);
+                mdio_write(tp, 0x19, 0xdaec);
+                mdio_write(tp, 0x15, 0x00c6);
+                mdio_write(tp, 0x19, 0x00fa);
+                mdio_write(tp, 0x15, 0x00c7);
+                mdio_write(tp, 0x19, 0x9df9);
+                mdio_write(tp, 0x15, 0x0112);
+                mdio_write(tp, 0x19, 0x6421);
+                mdio_write(tp, 0x15, 0x0113);
+                mdio_write(tp, 0x19, 0x7c08);
+                mdio_write(tp, 0x15, 0x0114);
+                mdio_write(tp, 0x19, 0x63f0);
+                mdio_write(tp, 0x15, 0x0115);
+                mdio_write(tp, 0x19, 0x4003);
+                mdio_write(tp, 0x15, 0x0116);
+                mdio_write(tp, 0x19, 0x4418);
+                mdio_write(tp, 0x15, 0x0117);
+                mdio_write(tp, 0x19, 0x9b00);
+                mdio_write(tp, 0x15, 0x0118);
+                mdio_write(tp, 0x19, 0x6461);
+                mdio_write(tp, 0x15, 0x0119);
+                mdio_write(tp, 0x19, 0x64e1);
+                mdio_write(tp, 0x15, 0x011a);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0150);
+                mdio_write(tp, 0x19, 0x7c80);
+                mdio_write(tp, 0x15, 0x0151);
+                mdio_write(tp, 0x19, 0x6461);
+                mdio_write(tp, 0x15, 0x0152);
+                mdio_write(tp, 0x19, 0x4003);
+                mdio_write(tp, 0x15, 0x0153);
+                mdio_write(tp, 0x19, 0x4540);
+                mdio_write(tp, 0x15, 0x0154);
+                mdio_write(tp, 0x19, 0x9f00);
+                mdio_write(tp, 0x15, 0x0155);
+                mdio_write(tp, 0x19, 0x9d00);
+                mdio_write(tp, 0x15, 0x0156);
+                mdio_write(tp, 0x19, 0x7c40);
+                mdio_write(tp, 0x15, 0x0157);
+                mdio_write(tp, 0x19, 0x6421);
+                mdio_write(tp, 0x15, 0x0158);
+                mdio_write(tp, 0x19, 0x7c80);
+                mdio_write(tp, 0x15, 0x0159);
+                mdio_write(tp, 0x19, 0x64a1);
+                mdio_write(tp, 0x15, 0x015a);
+                mdio_write(tp, 0x19, 0x30fe);
+                mdio_write(tp, 0x15, 0x029c);
+                mdio_write(tp, 0x19, 0x0070);
+                mdio_write(tp, 0x15, 0x02b2);
+                mdio_write(tp, 0x19, 0x005a);
+                mdio_write(tp, 0x15, 0x02bd);
+                mdio_write(tp, 0x19, 0xa522);
+                mdio_write(tp, 0x15, 0x02ce);
+                mdio_write(tp, 0x19, 0xb63e);
+                mdio_write(tp, 0x15, 0x02d9);
+                mdio_write(tp, 0x19, 0x32df);
+                mdio_write(tp, 0x15, 0x02df);
+                mdio_write(tp, 0x19, 0x4500);
+                mdio_write(tp, 0x15, 0x02f4);
+                mdio_write(tp, 0x19, 0xb618);
+                mdio_write(tp, 0x15, 0x02fb);
+                mdio_write(tp, 0x19, 0xb900);
+                mdio_write(tp, 0x15, 0x02fc);
+                mdio_write(tp, 0x19, 0x49b5);
+                mdio_write(tp, 0x15, 0x02fd);
+                mdio_write(tp, 0x19, 0x6812);
+                mdio_write(tp, 0x15, 0x02fe);
+                mdio_write(tp, 0x19, 0x66a0);
+                mdio_write(tp, 0x15, 0x02ff);
+                mdio_write(tp, 0x19, 0x9900);
+                mdio_write(tp, 0x15, 0x0300);
+                mdio_write(tp, 0x19, 0x64a0);
+                mdio_write(tp, 0x15, 0x0301);
+                mdio_write(tp, 0x19, 0x3316);
+                mdio_write(tp, 0x15, 0x0308);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x030c);
+                mdio_write(tp, 0x19, 0x3000);
+                mdio_write(tp, 0x15, 0x0312);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0313);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0314);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0315);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0316);
+                mdio_write(tp, 0x19, 0x49b5);
+                mdio_write(tp, 0x15, 0x0317);
+                mdio_write(tp, 0x19, 0x7d00);
+                mdio_write(tp, 0x15, 0x0318);
+                mdio_write(tp, 0x19, 0x4d00);
+                mdio_write(tp, 0x15, 0x0319);
+                mdio_write(tp, 0x19, 0x6810);
+                mdio_write(tp, 0x15, 0x031a);
+                mdio_write(tp, 0x19, 0x6c08);
+                mdio_write(tp, 0x15, 0x031b);
+                mdio_write(tp, 0x19, 0x4925);
+                mdio_write(tp, 0x15, 0x031c);
+                mdio_write(tp, 0x19, 0x403b);
+                mdio_write(tp, 0x15, 0x031d);
+                mdio_write(tp, 0x19, 0xa602);
+                mdio_write(tp, 0x15, 0x031e);
+                mdio_write(tp, 0x19, 0x402f);
+                mdio_write(tp, 0x15, 0x031f);
+                mdio_write(tp, 0x19, 0x4484);
+                mdio_write(tp, 0x15, 0x0320);
+                mdio_write(tp, 0x19, 0x40c8);
+                mdio_write(tp, 0x15, 0x0321);
+                mdio_write(tp, 0x19, 0x44c4);
+                mdio_write(tp, 0x15, 0x0322);
+                mdio_write(tp, 0x19, 0x404f);
+                mdio_write(tp, 0x15, 0x0323);
+                mdio_write(tp, 0x19, 0x44c8);
+                mdio_write(tp, 0x15, 0x0324);
+                mdio_write(tp, 0x19, 0xd64f);
+                mdio_write(tp, 0x15, 0x0325);
+                mdio_write(tp, 0x19, 0x00e7);
+                mdio_write(tp, 0x15, 0x0326);
+                mdio_write(tp, 0x19, 0x7c08);
+                mdio_write(tp, 0x15, 0x0327);
+                mdio_write(tp, 0x19, 0x8203);
+                mdio_write(tp, 0x15, 0x0328);
+                mdio_write(tp, 0x19, 0x4d48);
+                mdio_write(tp, 0x15, 0x0329);
+                mdio_write(tp, 0x19, 0x332b);
+                mdio_write(tp, 0x15, 0x032a);
+                mdio_write(tp, 0x19, 0x4d40);
+                mdio_write(tp, 0x15, 0x032c);
+                mdio_write(tp, 0x19, 0x00f8);
+                mdio_write(tp, 0x15, 0x032d);
+                mdio_write(tp, 0x19, 0x82b2);
+                mdio_write(tp, 0x15, 0x032f);
+                mdio_write(tp, 0x19, 0x00b0);
+                mdio_write(tp, 0x15, 0x0332);
+                mdio_write(tp, 0x19, 0x91f2);
+                mdio_write(tp, 0x15, 0x033f);
+                mdio_write(tp, 0x19, 0xb6cd);
+                mdio_write(tp, 0x15, 0x0340);
+                mdio_write(tp, 0x19, 0x9e01);
+                mdio_write(tp, 0x15, 0x0341);
+                mdio_write(tp, 0x19, 0xd11d);
+                mdio_write(tp, 0x15, 0x0342);
+                mdio_write(tp, 0x19, 0x009d);
+                mdio_write(tp, 0x15, 0x0343);
+                mdio_write(tp, 0x19, 0xbb1c);
+                mdio_write(tp, 0x15, 0x0344);
+                mdio_write(tp, 0x19, 0x8102);
+                mdio_write(tp, 0x15, 0x0345);
+                mdio_write(tp, 0x19, 0x3348);
+                mdio_write(tp, 0x15, 0x0346);
+                mdio_write(tp, 0x19, 0xa231);
+                mdio_write(tp, 0x15, 0x0347);
+                mdio_write(tp, 0x19, 0x335b);
+                mdio_write(tp, 0x15, 0x0348);
+                mdio_write(tp, 0x19, 0x91f7);
+                mdio_write(tp, 0x15, 0x0349);
+                mdio_write(tp, 0x19, 0xc218);
+                mdio_write(tp, 0x15, 0x034a);
+                mdio_write(tp, 0x19, 0x00f5);
+                mdio_write(tp, 0x15, 0x034b);
+                mdio_write(tp, 0x19, 0x335b);
+                mdio_write(tp, 0x15, 0x034c);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x034d);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x034e);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x034f);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x0350);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x035b);
+                mdio_write(tp, 0x19, 0xa23c);
+                mdio_write(tp, 0x15, 0x035c);
+                mdio_write(tp, 0x19, 0x7c08);
+                mdio_write(tp, 0x15, 0x035d);
+                mdio_write(tp, 0x19, 0x4c00);
+                mdio_write(tp, 0x15, 0x035e);
+                mdio_write(tp, 0x19, 0x3397);
+                mdio_write(tp, 0x15, 0x0363);
+                mdio_write(tp, 0x19, 0xb6a9);
+                mdio_write(tp, 0x15, 0x0366);
+                mdio_write(tp, 0x19, 0x00f5);
+                mdio_write(tp, 0x15, 0x0382);
+                mdio_write(tp, 0x19, 0x7c40);
+                mdio_write(tp, 0x15, 0x0388);
+                mdio_write(tp, 0x19, 0x0084);
+                mdio_write(tp, 0x15, 0x0389);
+                mdio_write(tp, 0x19, 0xdd17);
+                mdio_write(tp, 0x15, 0x038a);
+                mdio_write(tp, 0x19, 0x000b);
+                mdio_write(tp, 0x15, 0x038b);
+                mdio_write(tp, 0x19, 0xa10a);
+                mdio_write(tp, 0x15, 0x038c);
+                mdio_write(tp, 0x19, 0x337e);
+                mdio_write(tp, 0x15, 0x038d);
+                mdio_write(tp, 0x19, 0x6c0b);
+                mdio_write(tp, 0x15, 0x038e);
+                mdio_write(tp, 0x19, 0xa107);
+                mdio_write(tp, 0x15, 0x038f);
+                mdio_write(tp, 0x19, 0x6c08);
+                mdio_write(tp, 0x15, 0x0390);
+                mdio_write(tp, 0x19, 0xc017);
+                mdio_write(tp, 0x15, 0x0391);
+                mdio_write(tp, 0x19, 0x0004);
+                mdio_write(tp, 0x15, 0x0392);
+                mdio_write(tp, 0x19, 0xd64f);
+                mdio_write(tp, 0x15, 0x0393);
+                mdio_write(tp, 0x19, 0x00f4);
+                mdio_write(tp, 0x15, 0x0397);
+                mdio_write(tp, 0x19, 0x4098);
+                mdio_write(tp, 0x15, 0x0398);
+                mdio_write(tp, 0x19, 0x4408);
+                mdio_write(tp, 0x15, 0x0399);
+                mdio_write(tp, 0x19, 0x55bf);
+                mdio_write(tp, 0x15, 0x039a);
+                mdio_write(tp, 0x19, 0x4bb9);
+                mdio_write(tp, 0x15, 0x039b);
+                mdio_write(tp, 0x19, 0x6810);
+                mdio_write(tp, 0x15, 0x039c);
+                mdio_write(tp, 0x19, 0x4b29);
+                mdio_write(tp, 0x15, 0x039d);
+                mdio_write(tp, 0x19, 0x4041);
+                mdio_write(tp, 0x15, 0x039e);
+                mdio_write(tp, 0x19, 0x442a);
+                mdio_write(tp, 0x15, 0x039f);
+                mdio_write(tp, 0x19, 0x4029);
+                mdio_write(tp, 0x15, 0x03aa);
+                mdio_write(tp, 0x19, 0x33b8);
+                mdio_write(tp, 0x15, 0x03b6);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03b7);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03b8);
+                mdio_write(tp, 0x19, 0x543f);
+                mdio_write(tp, 0x15, 0x03b9);
+                mdio_write(tp, 0x19, 0x499a);
+                mdio_write(tp, 0x15, 0x03ba);
+                mdio_write(tp, 0x19, 0x7c40);
+                mdio_write(tp, 0x15, 0x03bb);
+                mdio_write(tp, 0x19, 0x4c40);
+                mdio_write(tp, 0x15, 0x03bc);
+                mdio_write(tp, 0x19, 0x490a);
+                mdio_write(tp, 0x15, 0x03bd);
+                mdio_write(tp, 0x19, 0x405e);
+                mdio_write(tp, 0x15, 0x03c2);
+                mdio_write(tp, 0x19, 0x9a03);
+                mdio_write(tp, 0x15, 0x03c4);
+                mdio_write(tp, 0x19, 0x0015);
+                mdio_write(tp, 0x15, 0x03c5);
+                mdio_write(tp, 0x19, 0x9e03);
+                mdio_write(tp, 0x15, 0x03c8);
+                mdio_write(tp, 0x19, 0x9cf7);
+                mdio_write(tp, 0x15, 0x03c9);
+                mdio_write(tp, 0x19, 0x7c12);
+                mdio_write(tp, 0x15, 0x03ca);
+                mdio_write(tp, 0x19, 0x4c52);
+                mdio_write(tp, 0x15, 0x03cb);
+                mdio_write(tp, 0x19, 0x4458);
+                mdio_write(tp, 0x15, 0x03cd);
+                mdio_write(tp, 0x19, 0x4c40);
+                mdio_write(tp, 0x15, 0x03ce);
+                mdio_write(tp, 0x19, 0x33bf);
+                mdio_write(tp, 0x15, 0x03cf);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d0);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d1);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d5);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d6);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d7);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d8);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03d9);
+                mdio_write(tp, 0x19, 0x49bb);
+                mdio_write(tp, 0x15, 0x03da);
+                mdio_write(tp, 0x19, 0x4478);
+                mdio_write(tp, 0x15, 0x03db);
+                mdio_write(tp, 0x19, 0x492b);
+                mdio_write(tp, 0x15, 0x03dc);
+                mdio_write(tp, 0x19, 0x7c01);
+                mdio_write(tp, 0x15, 0x03dd);
+                mdio_write(tp, 0x19, 0x4c00);
+                mdio_write(tp, 0x15, 0x03de);
+                mdio_write(tp, 0x19, 0xbd1a);
+                mdio_write(tp, 0x15, 0x03df);
+                mdio_write(tp, 0x19, 0xc428);
+                mdio_write(tp, 0x15, 0x03e0);
+                mdio_write(tp, 0x19, 0x0008);
+                mdio_write(tp, 0x15, 0x03e1);
+                mdio_write(tp, 0x19, 0x9cfd);
+                mdio_write(tp, 0x15, 0x03e2);
+                mdio_write(tp, 0x19, 0x7c12);
+                mdio_write(tp, 0x15, 0x03e3);
+                mdio_write(tp, 0x19, 0x4c52);
+                mdio_write(tp, 0x15, 0x03e4);
+                mdio_write(tp, 0x19, 0x4458);
+                mdio_write(tp, 0x15, 0x03e5);
+                mdio_write(tp, 0x19, 0x7c12);
+                mdio_write(tp, 0x15, 0x03e6);
+                mdio_write(tp, 0x19, 0x4c40);
+                mdio_write(tp, 0x15, 0x03e7);
+                mdio_write(tp, 0x19, 0x33de);
+                mdio_write(tp, 0x15, 0x03e8);
+                mdio_write(tp, 0x19, 0xc218);
+                mdio_write(tp, 0x15, 0x03e9);
+                mdio_write(tp, 0x19, 0x0002);
+                mdio_write(tp, 0x15, 0x03ea);
+                mdio_write(tp, 0x19, 0x32df);
+                mdio_write(tp, 0x15, 0x03eb);
+                mdio_write(tp, 0x19, 0x3316);
+                mdio_write(tp, 0x15, 0x03ec);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03ed);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03ee);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03ef);
+                mdio_write(tp, 0x19, 0x0000);
+                mdio_write(tp, 0x15, 0x03f7);
+                mdio_write(tp, 0x19, 0x330c);
+                mdio_write(tp, 0x16, 0x0306);
+                mdio_write(tp, 0x16, 0x0300);
+
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x05, 0xfff6);
+                mdio_write(tp, 0x06, 0x0080);
+                mdio_write(tp, 0x05, 0x8000);
+                mdio_write(tp, 0x06, 0x0280);
+                mdio_write(tp, 0x06, 0x48f7);
+                mdio_write(tp, 0x06, 0x00e0);
+                mdio_write(tp, 0x06, 0xfff7);
+                mdio_write(tp, 0x06, 0xa080);
+                mdio_write(tp, 0x06, 0x02ae);
+                mdio_write(tp, 0x06, 0xf602);
+                mdio_write(tp, 0x06, 0x0200);
+                mdio_write(tp, 0x06, 0x0280);
+                mdio_write(tp, 0x06, 0x9002);
+                mdio_write(tp, 0x06, 0x0224);
+                mdio_write(tp, 0x06, 0x0202);
+                mdio_write(tp, 0x06, 0x3402);
+                mdio_write(tp, 0x06, 0x027f);
+                mdio_write(tp, 0x06, 0x0280);
+                mdio_write(tp, 0x06, 0xa602);
+                mdio_write(tp, 0x06, 0x80bf);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x88e1);
+                mdio_write(tp, 0x06, 0x8b89);
+                mdio_write(tp, 0x06, 0x1e01);
+                mdio_write(tp, 0x06, 0xe18b);
+                mdio_write(tp, 0x06, 0x8a1e);
+                mdio_write(tp, 0x06, 0x01e1);
+                mdio_write(tp, 0x06, 0x8b8b);
+                mdio_write(tp, 0x06, 0x1e01);
+                mdio_write(tp, 0x06, 0xe18b);
+                mdio_write(tp, 0x06, 0x8c1e);
+                mdio_write(tp, 0x06, 0x01e1);
+                mdio_write(tp, 0x06, 0x8b8d);
+                mdio_write(tp, 0x06, 0x1e01);
+                mdio_write(tp, 0x06, 0xe18b);
+                mdio_write(tp, 0x06, 0x8e1e);
+                mdio_write(tp, 0x06, 0x01a0);
+                mdio_write(tp, 0x06, 0x00c7);
+                mdio_write(tp, 0x06, 0xaebb);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xe600);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xee03);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xefb8);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xe902);
+                mdio_write(tp, 0x06, 0xee8b);
+                mdio_write(tp, 0x06, 0x8285);
+                mdio_write(tp, 0x06, 0xee8b);
+                mdio_write(tp, 0x06, 0x8520);
+                mdio_write(tp, 0x06, 0xee8b);
+                mdio_write(tp, 0x06, 0x8701);
+                mdio_write(tp, 0x06, 0xd481);
+                mdio_write(tp, 0x06, 0x35e4);
+                mdio_write(tp, 0x06, 0x8b94);
+                mdio_write(tp, 0x06, 0xe58b);
+                mdio_write(tp, 0x06, 0x95bf);
+                mdio_write(tp, 0x06, 0x8b88);
+                mdio_write(tp, 0x06, 0xec00);
+                mdio_write(tp, 0x06, 0x19a9);
+                mdio_write(tp, 0x06, 0x8b90);
+                mdio_write(tp, 0x06, 0xf9ee);
+                mdio_write(tp, 0x06, 0xfff6);
+                mdio_write(tp, 0x06, 0x00ee);
+                mdio_write(tp, 0x06, 0xfff7);
+                mdio_write(tp, 0x06, 0xffe0);
+                mdio_write(tp, 0x06, 0xe140);
+                mdio_write(tp, 0x06, 0xe1e1);
+                mdio_write(tp, 0x06, 0x41f7);
+                mdio_write(tp, 0x06, 0x2ff6);
+                mdio_write(tp, 0x06, 0x28e4);
+                mdio_write(tp, 0x06, 0xe140);
+                mdio_write(tp, 0x06, 0xe5e1);
+                mdio_write(tp, 0x06, 0x4104);
+                mdio_write(tp, 0x06, 0xf8e0);
+                mdio_write(tp, 0x06, 0x8b89);
+                mdio_write(tp, 0x06, 0xad20);
+                mdio_write(tp, 0x06, 0x0dee);
+                mdio_write(tp, 0x06, 0x8b89);
+                mdio_write(tp, 0x06, 0x0002);
+                mdio_write(tp, 0x06, 0x82f4);
+                mdio_write(tp, 0x06, 0x021f);
+                mdio_write(tp, 0x06, 0x4102);
+                mdio_write(tp, 0x06, 0x2812);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8e0);
+                mdio_write(tp, 0x06, 0x8b8d);
+                mdio_write(tp, 0x06, 0xad20);
+                mdio_write(tp, 0x06, 0x10ee);
+                mdio_write(tp, 0x06, 0x8b8d);
+                mdio_write(tp, 0x06, 0x0002);
+                mdio_write(tp, 0x06, 0x139d);
+                mdio_write(tp, 0x06, 0x0281);
+                mdio_write(tp, 0x06, 0xd602);
+                mdio_write(tp, 0x06, 0x1f99);
+                mdio_write(tp, 0x06, 0x0227);
+                mdio_write(tp, 0x06, 0xeafc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x8ead);
+                mdio_write(tp, 0x06, 0x2014);
+                mdio_write(tp, 0x06, 0xf620);
+                mdio_write(tp, 0x06, 0xe48b);
+                mdio_write(tp, 0x06, 0x8e02);
+                mdio_write(tp, 0x06, 0x8104);
+                mdio_write(tp, 0x06, 0x021b);
+                mdio_write(tp, 0x06, 0xf402);
+                mdio_write(tp, 0x06, 0x2c9c);
+                mdio_write(tp, 0x06, 0x0281);
+                mdio_write(tp, 0x06, 0x7902);
+                mdio_write(tp, 0x06, 0x8443);
+                mdio_write(tp, 0x06, 0xad22);
+                mdio_write(tp, 0x06, 0x11f6);
+                mdio_write(tp, 0x06, 0x22e4);
+                mdio_write(tp, 0x06, 0x8b8e);
+                mdio_write(tp, 0x06, 0x022c);
+                mdio_write(tp, 0x06, 0x4602);
+                mdio_write(tp, 0x06, 0x2ac5);
+                mdio_write(tp, 0x06, 0x0229);
+                mdio_write(tp, 0x06, 0x2002);
+                mdio_write(tp, 0x06, 0x2b91);
+                mdio_write(tp, 0x06, 0xad25);
+                mdio_write(tp, 0x06, 0x11f6);
+                mdio_write(tp, 0x06, 0x25e4);
+                mdio_write(tp, 0x06, 0x8b8e);
+                mdio_write(tp, 0x06, 0x0284);
+                mdio_write(tp, 0x06, 0xe202);
+                mdio_write(tp, 0x06, 0x043a);
+                mdio_write(tp, 0x06, 0x021a);
+                mdio_write(tp, 0x06, 0x5902);
+                mdio_write(tp, 0x06, 0x2bfc);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x00e1);
+                mdio_write(tp, 0x06, 0xe001);
+                mdio_write(tp, 0x06, 0xad27);
+                mdio_write(tp, 0x06, 0x1fd1);
+                mdio_write(tp, 0x06, 0x01bf);
+                mdio_write(tp, 0x06, 0x8638);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50e0);
+                mdio_write(tp, 0x06, 0xe020);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x21ad);
+                mdio_write(tp, 0x06, 0x200e);
+                mdio_write(tp, 0x06, 0xd100);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x3802);
+                mdio_write(tp, 0x06, 0x2f50);
+                mdio_write(tp, 0x06, 0xbf3d);
+                mdio_write(tp, 0x06, 0x3902);
+                mdio_write(tp, 0x06, 0x2eb0);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefc);
+                mdio_write(tp, 0x06, 0x0402);
+                mdio_write(tp, 0x06, 0x8591);
+                mdio_write(tp, 0x06, 0x0281);
+                mdio_write(tp, 0x06, 0x3c05);
+                mdio_write(tp, 0x06, 0xf8fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0xfee1);
+                mdio_write(tp, 0x06, 0xe2ff);
+                mdio_write(tp, 0x06, 0xad2d);
+                mdio_write(tp, 0x06, 0x1ae0);
+                mdio_write(tp, 0x06, 0xe14e);
+                mdio_write(tp, 0x06, 0xe1e1);
+                mdio_write(tp, 0x06, 0x4fac);
+                mdio_write(tp, 0x06, 0x2d22);
+                mdio_write(tp, 0x06, 0xf603);
+                mdio_write(tp, 0x06, 0x0203);
+                mdio_write(tp, 0x06, 0x36f7);
+                mdio_write(tp, 0x06, 0x03f7);
+                mdio_write(tp, 0x06, 0x06bf);
+                mdio_write(tp, 0x06, 0x8622);
+                mdio_write(tp, 0x06, 0x022e);
+                mdio_write(tp, 0x06, 0xb0ae);
+                mdio_write(tp, 0x06, 0x11e0);
+                mdio_write(tp, 0x06, 0xe14e);
+                mdio_write(tp, 0x06, 0xe1e1);
+                mdio_write(tp, 0x06, 0x4fad);
+                mdio_write(tp, 0x06, 0x2d08);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x2d02);
+                mdio_write(tp, 0x06, 0x2eb0);
+                mdio_write(tp, 0x06, 0xf606);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xf9fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x87ad);
+                mdio_write(tp, 0x06, 0x204c);
+                mdio_write(tp, 0x06, 0xd200);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0x0058);
+                mdio_write(tp, 0x06, 0x010c);
+                mdio_write(tp, 0x06, 0x021e);
+                mdio_write(tp, 0x06, 0x20e0);
+                mdio_write(tp, 0x06, 0xe000);
+                mdio_write(tp, 0x06, 0x5810);
+                mdio_write(tp, 0x06, 0x1e20);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x3658);
+                mdio_write(tp, 0x06, 0x031e);
+                mdio_write(tp, 0x06, 0x20e0);
+                mdio_write(tp, 0x06, 0xe022);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x2358);
+                mdio_write(tp, 0x06, 0xe01e);
+                mdio_write(tp, 0x06, 0x20e0);
+                mdio_write(tp, 0x06, 0x8ae6);
+                mdio_write(tp, 0x06, 0x1f02);
+                mdio_write(tp, 0x06, 0x9e22);
+                mdio_write(tp, 0x06, 0xe68a);
+                mdio_write(tp, 0x06, 0xe6ad);
+                mdio_write(tp, 0x06, 0x3214);
+                mdio_write(tp, 0x06, 0xad34);
+                mdio_write(tp, 0x06, 0x11ef);
+                mdio_write(tp, 0x06, 0x0258);
+                mdio_write(tp, 0x06, 0x039e);
+                mdio_write(tp, 0x06, 0x07ad);
+                mdio_write(tp, 0x06, 0x3508);
+                mdio_write(tp, 0x06, 0x5ac0);
+                mdio_write(tp, 0x06, 0x9f04);
+                mdio_write(tp, 0x06, 0xd101);
+                mdio_write(tp, 0x06, 0xae02);
+                mdio_write(tp, 0x06, 0xd100);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x3e02);
+                mdio_write(tp, 0x06, 0x2f50);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefd);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8f9);
+                mdio_write(tp, 0x06, 0xfae0);
+                mdio_write(tp, 0x06, 0x8b81);
+                mdio_write(tp, 0x06, 0xac26);
+                mdio_write(tp, 0x06, 0x0ee0);
+                mdio_write(tp, 0x06, 0x8b81);
+                mdio_write(tp, 0x06, 0xac21);
+                mdio_write(tp, 0x06, 0x08e0);
+                mdio_write(tp, 0x06, 0x8b87);
+                mdio_write(tp, 0x06, 0xac24);
+                mdio_write(tp, 0x06, 0x02ae);
+                mdio_write(tp, 0x06, 0x6bee);
+                mdio_write(tp, 0x06, 0xe0ea);
+                mdio_write(tp, 0x06, 0x00ee);
+                mdio_write(tp, 0x06, 0xe0eb);
+                mdio_write(tp, 0x06, 0x00e2);
+                mdio_write(tp, 0x06, 0xe07c);
+                mdio_write(tp, 0x06, 0xe3e0);
+                mdio_write(tp, 0x06, 0x7da5);
+                mdio_write(tp, 0x06, 0x1111);
+                mdio_write(tp, 0x06, 0x15d2);
+                mdio_write(tp, 0x06, 0x60d6);
+                mdio_write(tp, 0x06, 0x6666);
+                mdio_write(tp, 0x06, 0x0207);
+                mdio_write(tp, 0x06, 0xf9d2);
+                mdio_write(tp, 0x06, 0xa0d6);
+                mdio_write(tp, 0x06, 0xaaaa);
+                mdio_write(tp, 0x06, 0x0207);
+                mdio_write(tp, 0x06, 0xf902);
+                mdio_write(tp, 0x06, 0x825c);
+                mdio_write(tp, 0x06, 0xae44);
+                mdio_write(tp, 0x06, 0xa566);
+                mdio_write(tp, 0x06, 0x6602);
+                mdio_write(tp, 0x06, 0xae38);
+                mdio_write(tp, 0x06, 0xa5aa);
+                mdio_write(tp, 0x06, 0xaa02);
+                mdio_write(tp, 0x06, 0xae32);
+                mdio_write(tp, 0x06, 0xeee0);
+                mdio_write(tp, 0x06, 0xea04);
+                mdio_write(tp, 0x06, 0xeee0);
+                mdio_write(tp, 0x06, 0xeb06);
+                mdio_write(tp, 0x06, 0xe2e0);
+                mdio_write(tp, 0x06, 0x7ce3);
+                mdio_write(tp, 0x06, 0xe07d);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x38e1);
+                mdio_write(tp, 0x06, 0xe039);
+                mdio_write(tp, 0x06, 0xad2e);
+                mdio_write(tp, 0x06, 0x21ad);
+                mdio_write(tp, 0x06, 0x3f13);
+                mdio_write(tp, 0x06, 0xe0e4);
+                mdio_write(tp, 0x06, 0x14e1);
+                mdio_write(tp, 0x06, 0xe415);
+                mdio_write(tp, 0x06, 0x6880);
+                mdio_write(tp, 0x06, 0xe4e4);
+                mdio_write(tp, 0x06, 0x14e5);
+                mdio_write(tp, 0x06, 0xe415);
+                mdio_write(tp, 0x06, 0x0282);
+                mdio_write(tp, 0x06, 0x5cae);
+                mdio_write(tp, 0x06, 0x0bac);
+                mdio_write(tp, 0x06, 0x3e02);
+                mdio_write(tp, 0x06, 0xae06);
+                mdio_write(tp, 0x06, 0x0282);
+                mdio_write(tp, 0x06, 0x8602);
+                mdio_write(tp, 0x06, 0x82b0);
+                mdio_write(tp, 0x06, 0xfefd);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8e1);
+                mdio_write(tp, 0x06, 0x8b2e);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x81ad);
+                mdio_write(tp, 0x06, 0x2605);
+                mdio_write(tp, 0x06, 0x0221);
+                mdio_write(tp, 0x06, 0xf3f7);
+                mdio_write(tp, 0x06, 0x28e0);
+                mdio_write(tp, 0x06, 0x8b81);
+                mdio_write(tp, 0x06, 0xad21);
+                mdio_write(tp, 0x06, 0x0502);
+                mdio_write(tp, 0x06, 0x22f8);
+                mdio_write(tp, 0x06, 0xf729);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x87ad);
+                mdio_write(tp, 0x06, 0x2405);
+                mdio_write(tp, 0x06, 0x0282);
+                mdio_write(tp, 0x06, 0xebf7);
+                mdio_write(tp, 0x06, 0x2ae5);
+                mdio_write(tp, 0x06, 0x8b2e);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8e0);
+                mdio_write(tp, 0x06, 0x8b81);
+                mdio_write(tp, 0x06, 0xad26);
+                mdio_write(tp, 0x06, 0x0302);
+                mdio_write(tp, 0x06, 0x2134);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x81ad);
+                mdio_write(tp, 0x06, 0x2109);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x2eac);
+                mdio_write(tp, 0x06, 0x2003);
+                mdio_write(tp, 0x06, 0x0283);
+                mdio_write(tp, 0x06, 0x52e0);
+                mdio_write(tp, 0x06, 0x8b87);
+                mdio_write(tp, 0x06, 0xad24);
+                mdio_write(tp, 0x06, 0x09e0);
+                mdio_write(tp, 0x06, 0x8b2e);
+                mdio_write(tp, 0x06, 0xac21);
+                mdio_write(tp, 0x06, 0x0302);
+                mdio_write(tp, 0x06, 0x8337);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8e1);
+                mdio_write(tp, 0x06, 0x8b2e);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x81ad);
+                mdio_write(tp, 0x06, 0x2608);
+                mdio_write(tp, 0x06, 0xe085);
+                mdio_write(tp, 0x06, 0xd2ad);
+                mdio_write(tp, 0x06, 0x2502);
+                mdio_write(tp, 0x06, 0xf628);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x81ad);
+                mdio_write(tp, 0x06, 0x210a);
+                mdio_write(tp, 0x06, 0xe086);
+                mdio_write(tp, 0x06, 0x0af6);
+                mdio_write(tp, 0x06, 0x27a0);
+                mdio_write(tp, 0x06, 0x0502);
+                mdio_write(tp, 0x06, 0xf629);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x87ad);
+                mdio_write(tp, 0x06, 0x2408);
+                mdio_write(tp, 0x06, 0xe08a);
+                mdio_write(tp, 0x06, 0xedad);
+                mdio_write(tp, 0x06, 0x2002);
+                mdio_write(tp, 0x06, 0xf62a);
+                mdio_write(tp, 0x06, 0xe58b);
+                mdio_write(tp, 0x06, 0x2ea1);
+                mdio_write(tp, 0x06, 0x0003);
+                mdio_write(tp, 0x06, 0x0221);
+                mdio_write(tp, 0x06, 0x11fc);
+                mdio_write(tp, 0x06, 0x04ee);
+                mdio_write(tp, 0x06, 0x8aed);
+                mdio_write(tp, 0x06, 0x00ee);
+                mdio_write(tp, 0x06, 0x8aec);
+                mdio_write(tp, 0x06, 0x0004);
+                mdio_write(tp, 0x06, 0xf8e0);
+                mdio_write(tp, 0x06, 0x8b87);
+                mdio_write(tp, 0x06, 0xad24);
+                mdio_write(tp, 0x06, 0x3ae0);
+                mdio_write(tp, 0x06, 0xe0ea);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0xeb58);
+                mdio_write(tp, 0x06, 0xf8d1);
+                mdio_write(tp, 0x06, 0x01e4);
+                mdio_write(tp, 0x06, 0xe0ea);
+                mdio_write(tp, 0x06, 0xe5e0);
+                mdio_write(tp, 0x06, 0xebe0);
+                mdio_write(tp, 0x06, 0xe07c);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x7d5c);
+                mdio_write(tp, 0x06, 0x00ff);
+                mdio_write(tp, 0x06, 0x3c00);
+                mdio_write(tp, 0x06, 0x1eab);
+                mdio_write(tp, 0x06, 0x1ce0);
+                mdio_write(tp, 0x06, 0xe04c);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x4d58);
+                mdio_write(tp, 0x06, 0xc1e4);
+                mdio_write(tp, 0x06, 0xe04c);
+                mdio_write(tp, 0x06, 0xe5e0);
+                mdio_write(tp, 0x06, 0x4de0);
+                mdio_write(tp, 0x06, 0xe0ee);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0x3ce4);
+                mdio_write(tp, 0x06, 0xe0ee);
+                mdio_write(tp, 0x06, 0xe5e0);
+                mdio_write(tp, 0x06, 0xeffc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x87ad);
+                mdio_write(tp, 0x06, 0x2412);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0xeee1);
+                mdio_write(tp, 0x06, 0xe0ef);
+                mdio_write(tp, 0x06, 0x59c3);
+                mdio_write(tp, 0x06, 0xe4e0);
+                mdio_write(tp, 0x06, 0xeee5);
+                mdio_write(tp, 0x06, 0xe0ef);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xed01);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8e0);
+                mdio_write(tp, 0x06, 0x8b81);
+                mdio_write(tp, 0x06, 0xac25);
+                mdio_write(tp, 0x06, 0x0502);
+                mdio_write(tp, 0x06, 0x8363);
+                mdio_write(tp, 0x06, 0xae03);
+                mdio_write(tp, 0x06, 0x0225);
+                mdio_write(tp, 0x06, 0x16fc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xf9fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xfae0);
+                mdio_write(tp, 0x06, 0x860a);
+                mdio_write(tp, 0x06, 0xa000);
+                mdio_write(tp, 0x06, 0x19e0);
+                mdio_write(tp, 0x06, 0x860b);
+                mdio_write(tp, 0x06, 0xe18b);
+                mdio_write(tp, 0x06, 0x331b);
+                mdio_write(tp, 0x06, 0x109e);
+                mdio_write(tp, 0x06, 0x04aa);
+                mdio_write(tp, 0x06, 0x02ae);
+                mdio_write(tp, 0x06, 0x06ee);
+                mdio_write(tp, 0x06, 0x860a);
+                mdio_write(tp, 0x06, 0x01ae);
+                mdio_write(tp, 0x06, 0xe602);
+                mdio_write(tp, 0x06, 0x241e);
+                mdio_write(tp, 0x06, 0xae14);
+                mdio_write(tp, 0x06, 0xa001);
+                mdio_write(tp, 0x06, 0x1402);
+                mdio_write(tp, 0x06, 0x2426);
+                mdio_write(tp, 0x06, 0xbf26);
+                mdio_write(tp, 0x06, 0x6d02);
+                mdio_write(tp, 0x06, 0x2eb0);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0b00);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0a02);
+                mdio_write(tp, 0x06, 0xaf84);
+                mdio_write(tp, 0x06, 0x3ca0);
+                mdio_write(tp, 0x06, 0x0252);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0400);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0500);
+                mdio_write(tp, 0x06, 0xe086);
+                mdio_write(tp, 0x06, 0x0be1);
+                mdio_write(tp, 0x06, 0x8b32);
+                mdio_write(tp, 0x06, 0x1b10);
+                mdio_write(tp, 0x06, 0x9e04);
+                mdio_write(tp, 0x06, 0xaa02);
+                mdio_write(tp, 0x06, 0xaecb);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0b00);
+                mdio_write(tp, 0x06, 0x0224);
+                mdio_write(tp, 0x06, 0x3ae2);
+                mdio_write(tp, 0x06, 0x8604);
+                mdio_write(tp, 0x06, 0xe386);
+                mdio_write(tp, 0x06, 0x05ef);
+                mdio_write(tp, 0x06, 0x65e2);
+                mdio_write(tp, 0x06, 0x8606);
+                mdio_write(tp, 0x06, 0xe386);
+                mdio_write(tp, 0x06, 0x071b);
+                mdio_write(tp, 0x06, 0x56aa);
+                mdio_write(tp, 0x06, 0x0eef);
+                mdio_write(tp, 0x06, 0x56e6);
+                mdio_write(tp, 0x06, 0x8606);
+                mdio_write(tp, 0x06, 0xe786);
+                mdio_write(tp, 0x06, 0x07e2);
+                mdio_write(tp, 0x06, 0x8609);
+                mdio_write(tp, 0x06, 0xe686);
+                mdio_write(tp, 0x06, 0x08e0);
+                mdio_write(tp, 0x06, 0x8609);
+                mdio_write(tp, 0x06, 0xa000);
+                mdio_write(tp, 0x06, 0x07ee);
+                mdio_write(tp, 0x06, 0x860a);
+                mdio_write(tp, 0x06, 0x03af);
+                mdio_write(tp, 0x06, 0x8369);
+                mdio_write(tp, 0x06, 0x0224);
+                mdio_write(tp, 0x06, 0x8e02);
+                mdio_write(tp, 0x06, 0x2426);
+                mdio_write(tp, 0x06, 0xae48);
+                mdio_write(tp, 0x06, 0xa003);
+                mdio_write(tp, 0x06, 0x21e0);
+                mdio_write(tp, 0x06, 0x8608);
+                mdio_write(tp, 0x06, 0xe186);
+                mdio_write(tp, 0x06, 0x091b);
+                mdio_write(tp, 0x06, 0x019e);
+                mdio_write(tp, 0x06, 0x0caa);
+                mdio_write(tp, 0x06, 0x0502);
+                mdio_write(tp, 0x06, 0x249d);
+                mdio_write(tp, 0x06, 0xaee7);
+                mdio_write(tp, 0x06, 0x0224);
+                mdio_write(tp, 0x06, 0x8eae);
+                mdio_write(tp, 0x06, 0xe2ee);
+                mdio_write(tp, 0x06, 0x860a);
+                mdio_write(tp, 0x06, 0x04ee);
+                mdio_write(tp, 0x06, 0x860b);
+                mdio_write(tp, 0x06, 0x00af);
+                mdio_write(tp, 0x06, 0x8369);
+                mdio_write(tp, 0x06, 0xa004);
+                mdio_write(tp, 0x06, 0x15e0);
+                mdio_write(tp, 0x06, 0x860b);
+                mdio_write(tp, 0x06, 0xe18b);
+                mdio_write(tp, 0x06, 0x341b);
+                mdio_write(tp, 0x06, 0x109e);
+                mdio_write(tp, 0x06, 0x05aa);
+                mdio_write(tp, 0x06, 0x03af);
+                mdio_write(tp, 0x06, 0x8383);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0a05);
+                mdio_write(tp, 0x06, 0xae0c);
+                mdio_write(tp, 0x06, 0xa005);
+                mdio_write(tp, 0x06, 0x02ae);
+                mdio_write(tp, 0x06, 0x0702);
+                mdio_write(tp, 0x06, 0x2309);
+                mdio_write(tp, 0x06, 0xee86);
+                mdio_write(tp, 0x06, 0x0a00);
+                mdio_write(tp, 0x06, 0xfeef);
+                mdio_write(tp, 0x06, 0x96fe);
+                mdio_write(tp, 0x06, 0xfdfc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xf9fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xfbe0);
+                mdio_write(tp, 0x06, 0x8b85);
+                mdio_write(tp, 0x06, 0xad25);
+                mdio_write(tp, 0x06, 0x22e0);
+                mdio_write(tp, 0x06, 0xe022);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x23e2);
+                mdio_write(tp, 0x06, 0xe036);
+                mdio_write(tp, 0x06, 0xe3e0);
+                mdio_write(tp, 0x06, 0x375a);
+                mdio_write(tp, 0x06, 0xc40d);
+                mdio_write(tp, 0x06, 0x0158);
+                mdio_write(tp, 0x06, 0x021e);
+                mdio_write(tp, 0x06, 0x20e3);
+                mdio_write(tp, 0x06, 0x8ae7);
+                mdio_write(tp, 0x06, 0xac31);
+                mdio_write(tp, 0x06, 0x60ac);
+                mdio_write(tp, 0x06, 0x3a08);
+                mdio_write(tp, 0x06, 0xac3e);
+                mdio_write(tp, 0x06, 0x26ae);
+                mdio_write(tp, 0x06, 0x67af);
+                mdio_write(tp, 0x06, 0x84db);
+                mdio_write(tp, 0x06, 0xad37);
+                mdio_write(tp, 0x06, 0x61e0);
+                mdio_write(tp, 0x06, 0x8ae8);
+                mdio_write(tp, 0x06, 0x10e4);
+                mdio_write(tp, 0x06, 0x8ae8);
+                mdio_write(tp, 0x06, 0xe18a);
+                mdio_write(tp, 0x06, 0xe91b);
+                mdio_write(tp, 0x06, 0x109e);
+                mdio_write(tp, 0x06, 0x02ae);
+                mdio_write(tp, 0x06, 0x51d1);
+                mdio_write(tp, 0x06, 0x00bf);
+                mdio_write(tp, 0x06, 0x863b);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50ee);
+                mdio_write(tp, 0x06, 0x8ae8);
+                mdio_write(tp, 0x06, 0x00ae);
+                mdio_write(tp, 0x06, 0x43ad);
+                mdio_write(tp, 0x06, 0x3627);
+                mdio_write(tp, 0x06, 0xe08a);
+                mdio_write(tp, 0x06, 0xeee1);
+                mdio_write(tp, 0x06, 0x8aef);
+                mdio_write(tp, 0x06, 0xef74);
+                mdio_write(tp, 0x06, 0xe08a);
+                mdio_write(tp, 0x06, 0xeae1);
+                mdio_write(tp, 0x06, 0x8aeb);
+                mdio_write(tp, 0x06, 0x1b74);
+                mdio_write(tp, 0x06, 0x9e2e);
+                mdio_write(tp, 0x06, 0x14e4);
+                mdio_write(tp, 0x06, 0x8aea);
+                mdio_write(tp, 0x06, 0xe58a);
+                mdio_write(tp, 0x06, 0xebef);
+                mdio_write(tp, 0x06, 0x74e0);
+                mdio_write(tp, 0x06, 0x8aee);
+                mdio_write(tp, 0x06, 0xe18a);
+                mdio_write(tp, 0x06, 0xef1b);
+                mdio_write(tp, 0x06, 0x479e);
+                mdio_write(tp, 0x06, 0x0fae);
+                mdio_write(tp, 0x06, 0x19ee);
+                mdio_write(tp, 0x06, 0x8aea);
+                mdio_write(tp, 0x06, 0x00ee);
+                mdio_write(tp, 0x06, 0x8aeb);
+                mdio_write(tp, 0x06, 0x00ae);
+                mdio_write(tp, 0x06, 0x0fac);
+                mdio_write(tp, 0x06, 0x390c);
+                mdio_write(tp, 0x06, 0xd101);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x3b02);
+                mdio_write(tp, 0x06, 0x2f50);
+                mdio_write(tp, 0x06, 0xee8a);
+                mdio_write(tp, 0x06, 0xe800);
+                mdio_write(tp, 0x06, 0xe68a);
+                mdio_write(tp, 0x06, 0xe7ff);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefd);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8f9);
+                mdio_write(tp, 0x06, 0xfaef);
+                mdio_write(tp, 0x06, 0x69e0);
+                mdio_write(tp, 0x06, 0xe022);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x2358);
+                mdio_write(tp, 0x06, 0xc4e1);
+                mdio_write(tp, 0x06, 0x8b6e);
+                mdio_write(tp, 0x06, 0x1f10);
+                mdio_write(tp, 0x06, 0x9e24);
+                mdio_write(tp, 0x06, 0xe48b);
+                mdio_write(tp, 0x06, 0x6ead);
+                mdio_write(tp, 0x06, 0x2218);
+                mdio_write(tp, 0x06, 0xac27);
+                mdio_write(tp, 0x06, 0x0dac);
+                mdio_write(tp, 0x06, 0x2605);
+                mdio_write(tp, 0x06, 0x0203);
+                mdio_write(tp, 0x06, 0x8fae);
+                mdio_write(tp, 0x06, 0x1302);
+                mdio_write(tp, 0x06, 0x03c8);
+                mdio_write(tp, 0x06, 0xae0e);
+                mdio_write(tp, 0x06, 0x0203);
+                mdio_write(tp, 0x06, 0xe102);
+                mdio_write(tp, 0x06, 0x8520);
+                mdio_write(tp, 0x06, 0xae06);
+                mdio_write(tp, 0x06, 0x0203);
+                mdio_write(tp, 0x06, 0x8f02);
+                mdio_write(tp, 0x06, 0x8566);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefd);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xe08b);
+                mdio_write(tp, 0x06, 0x82ad);
+                mdio_write(tp, 0x06, 0x2737);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x4402);
+                mdio_write(tp, 0x06, 0x2f23);
+                mdio_write(tp, 0x06, 0xac28);
+                mdio_write(tp, 0x06, 0x2ed1);
+                mdio_write(tp, 0x06, 0x01bf);
+                mdio_write(tp, 0x06, 0x8647);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50bf);
+                mdio_write(tp, 0x06, 0x8641);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x23e5);
+                mdio_write(tp, 0x06, 0x8af0);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x22e1);
+                mdio_write(tp, 0x06, 0xe023);
+                mdio_write(tp, 0x06, 0xac2e);
+                mdio_write(tp, 0x06, 0x04d1);
+                mdio_write(tp, 0x06, 0x01ae);
+                mdio_write(tp, 0x06, 0x02d1);
+                mdio_write(tp, 0x06, 0x00bf);
+                mdio_write(tp, 0x06, 0x8641);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50d1);
+                mdio_write(tp, 0x06, 0x01bf);
+                mdio_write(tp, 0x06, 0x8644);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50ef);
+                mdio_write(tp, 0x06, 0x96fe);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xf8fa);
+                mdio_write(tp, 0x06, 0xef69);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x4702);
+                mdio_write(tp, 0x06, 0x2f23);
+                mdio_write(tp, 0x06, 0xad28);
+                mdio_write(tp, 0x06, 0x19d1);
+                mdio_write(tp, 0x06, 0x00bf);
+                mdio_write(tp, 0x06, 0x8644);
+                mdio_write(tp, 0x06, 0x022f);
+                mdio_write(tp, 0x06, 0x50e1);
+                mdio_write(tp, 0x06, 0x8af0);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x4102);
+                mdio_write(tp, 0x06, 0x2f50);
+                mdio_write(tp, 0x06, 0xd100);
+                mdio_write(tp, 0x06, 0xbf86);
+                mdio_write(tp, 0x06, 0x4702);
+                mdio_write(tp, 0x06, 0x2f50);
+                mdio_write(tp, 0x06, 0xef96);
+                mdio_write(tp, 0x06, 0xfefc);
+                mdio_write(tp, 0x06, 0x04f8);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0xfee1);
+                mdio_write(tp, 0x06, 0xe2ff);
+                mdio_write(tp, 0x06, 0xad2e);
+                mdio_write(tp, 0x06, 0x63e0);
+                mdio_write(tp, 0x06, 0xe038);
+                mdio_write(tp, 0x06, 0xe1e0);
+                mdio_write(tp, 0x06, 0x39ad);
+                mdio_write(tp, 0x06, 0x2f10);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x34e1);
+                mdio_write(tp, 0x06, 0xe035);
+                mdio_write(tp, 0x06, 0xf726);
+                mdio_write(tp, 0x06, 0xe4e0);
+                mdio_write(tp, 0x06, 0x34e5);
+                mdio_write(tp, 0x06, 0xe035);
+                mdio_write(tp, 0x06, 0xae0e);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0xd6e1);
+                mdio_write(tp, 0x06, 0xe2d7);
+                mdio_write(tp, 0x06, 0xf728);
+                mdio_write(tp, 0x06, 0xe4e2);
+                mdio_write(tp, 0x06, 0xd6e5);
+                mdio_write(tp, 0x06, 0xe2d7);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0x34e1);
+                mdio_write(tp, 0x06, 0xe235);
+                mdio_write(tp, 0x06, 0xf72b);
+                mdio_write(tp, 0x06, 0xe4e2);
+                mdio_write(tp, 0x06, 0x34e5);
+                mdio_write(tp, 0x06, 0xe235);
+                mdio_write(tp, 0x06, 0xd07d);
+                mdio_write(tp, 0x06, 0xb0fe);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0x34e1);
+                mdio_write(tp, 0x06, 0xe235);
+                mdio_write(tp, 0x06, 0xf62b);
+                mdio_write(tp, 0x06, 0xe4e2);
+                mdio_write(tp, 0x06, 0x34e5);
+                mdio_write(tp, 0x06, 0xe235);
+                mdio_write(tp, 0x06, 0xe0e0);
+                mdio_write(tp, 0x06, 0x34e1);
+                mdio_write(tp, 0x06, 0xe035);
+                mdio_write(tp, 0x06, 0xf626);
+                mdio_write(tp, 0x06, 0xe4e0);
+                mdio_write(tp, 0x06, 0x34e5);
+                mdio_write(tp, 0x06, 0xe035);
+                mdio_write(tp, 0x06, 0xe0e2);
+                mdio_write(tp, 0x06, 0xd6e1);
+                mdio_write(tp, 0x06, 0xe2d7);
+                mdio_write(tp, 0x06, 0xf628);
+                mdio_write(tp, 0x06, 0xe4e2);
+                mdio_write(tp, 0x06, 0xd6e5);
+                mdio_write(tp, 0x06, 0xe2d7);
+                mdio_write(tp, 0x06, 0xfc04);
+                mdio_write(tp, 0x06, 0xae20);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x06, 0xa725);
+                mdio_write(tp, 0x06, 0xe50a);
+                mdio_write(tp, 0x06, 0x1de5);
+                mdio_write(tp, 0x06, 0x0a2c);
+                mdio_write(tp, 0x06, 0xe50a);
+                mdio_write(tp, 0x06, 0x6de5);
+                mdio_write(tp, 0x06, 0x0a1d);
+                mdio_write(tp, 0x06, 0xe50a);
+                mdio_write(tp, 0x06, 0x1ce5);
+                mdio_write(tp, 0x06, 0x0a2d);
+                mdio_write(tp, 0x06, 0xa755);
+                mdio_write(tp, 0x06, 0x00e2);
+                mdio_write(tp, 0x06, 0x3488);
+                mdio_write(tp, 0x06, 0xe200);
+                mdio_write(tp, 0x06, 0xcce2);
+                mdio_write(tp, 0x06, 0x0055);
+                mdio_write(tp, 0x06, 0xe020);
+                mdio_write(tp, 0x06, 0x55e2);
+                mdio_write(tp, 0x06, 0xd600);
+                mdio_write(tp, 0x06, 0xe24a);
+                gphy_val = mdio_read(tp, 0x01);
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x01, gphy_val);
+                gphy_val = mdio_read(tp, 0x00);
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x00, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0005);
+                for (i = 0; i < 200; i++) {
+                        udelay(100);
+                        gphy_val = mdio_read(tp, 0x00);
+                        if (gphy_val & BIT_7)
+                                break;
+                }
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x0023);
+                gphy_val = mdio_read(tp, 0x17);
+                gphy_val &= ~(BIT_0);
+                if (tp->RequiredSecLanDonglePatch)
+                        gphy_val &= ~(BIT_2);
+                mdio_write(tp, 0x17, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+        }
+}
+
+static void
+rtl8168_set_phy_mcu_8168evl_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x00, 0x1800);
+        gphy_val = mdio_read(tp, 0x15);
+        gphy_val &= ~(BIT_12);
+        mdio_write(tp, 0x15, gphy_val);
+        mdelay(20);
+        mdio_write(tp, 0x1f, 0x0004);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        gphy_val = mdio_read(tp, 0x17);
+        if ((gphy_val & BIT_11) == 0x0000) {
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x17, gphy_val);
+                for (i = 0; i < 200; i++) {
+                        udelay(100);
+                        gphy_val = mdio_read(tp, 0x17);
+                        if (gphy_val & BIT_11)
+                                break;
+                }
+        }
+        gphy_val = mdio_read(tp, 0x17);
+        gphy_val |= BIT_0;
+        mdio_write(tp, 0x17, gphy_val);
+        mdio_write(tp, 0x1f, 0x0004);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1E, 0x002C);
+        mdio_write(tp, 0x1B, 0x5000);
+        mdio_write(tp, 0x1E, 0x002d);
+        mdio_write(tp, 0x19, 0x0004);
+        mdio_write(tp, 0x1f, 0x0002);
+        mdio_write(tp, 0x1f, 0x0000);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x1E);
+                if ((gphy_val & 0x03FF) == 0x0014)
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0005);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x07);
+                if ((gphy_val & BIT_5) == 0)
+                        break;
+        }
+        gphy_val = mdio_read(tp, 0x07);
+        if (gphy_val & BIT_5) {
+                mdio_write(tp, 0x1f, 0x0004);
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x00a1);
+                mdio_write(tp, 0x17, 0x1000);
+                mdio_write(tp, 0x17, 0x0000);
+                mdio_write(tp, 0x17, 0x2000);
+                mdio_write(tp, 0x1e, 0x002f);
+                mdio_write(tp, 0x18, 0x9bfb);
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x07, 0x0000);
+                mdio_write(tp, 0x1f, 0x0002);
+                mdio_write(tp, 0x1f, 0x0000);
+        }
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        gphy_val = mdio_read(tp, 0x00);
+        gphy_val &= ~(BIT_7);
+        mdio_write(tp, 0x00, gphy_val);
+        mdio_write(tp, 0x1f, 0x0004);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0307);
+        mdio_write(tp, 0x15, 0x0000);
+        mdio_write(tp, 0x19, 0x407d);
+        mdio_write(tp, 0x15, 0x0001);
+        mdio_write(tp, 0x19, 0x440f);
+        mdio_write(tp, 0x15, 0x0002);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0003);
+        mdio_write(tp, 0x19, 0x6c03);
+        mdio_write(tp, 0x15, 0x0004);
+        mdio_write(tp, 0x19, 0xc4d5);
+        mdio_write(tp, 0x15, 0x0005);
+        mdio_write(tp, 0x19, 0x00ff);
+        mdio_write(tp, 0x15, 0x0006);
+        mdio_write(tp, 0x19, 0x74f0);
+        mdio_write(tp, 0x15, 0x0007);
+        mdio_write(tp, 0x19, 0x4880);
+        mdio_write(tp, 0x15, 0x0008);
+        mdio_write(tp, 0x19, 0x4c00);
+        mdio_write(tp, 0x15, 0x0009);
+        mdio_write(tp, 0x19, 0x4800);
+        mdio_write(tp, 0x15, 0x000a);
+        mdio_write(tp, 0x19, 0x5000);
+        mdio_write(tp, 0x15, 0x000b);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x000c);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x000d);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x15, 0x000e);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x000f);
+        mdio_write(tp, 0x19, 0x7010);
+        mdio_write(tp, 0x15, 0x0010);
+        mdio_write(tp, 0x19, 0x6804);
+        mdio_write(tp, 0x15, 0x0011);
+        mdio_write(tp, 0x19, 0x64a0);
+        mdio_write(tp, 0x15, 0x0012);
+        mdio_write(tp, 0x19, 0x63da);
+        mdio_write(tp, 0x15, 0x0013);
+        mdio_write(tp, 0x19, 0x63d8);
+        mdio_write(tp, 0x15, 0x0014);
+        mdio_write(tp, 0x19, 0x6f05);
+        mdio_write(tp, 0x15, 0x0015);
+        mdio_write(tp, 0x19, 0x5420);
+        mdio_write(tp, 0x15, 0x0016);
+        mdio_write(tp, 0x19, 0x58ce);
+        mdio_write(tp, 0x15, 0x0017);
+        mdio_write(tp, 0x19, 0x5cf3);
+        mdio_write(tp, 0x15, 0x0018);
+        mdio_write(tp, 0x19, 0xb600);
+        mdio_write(tp, 0x15, 0x0019);
+        mdio_write(tp, 0x19, 0xc659);
+        mdio_write(tp, 0x15, 0x001a);
+        mdio_write(tp, 0x19, 0x0018);
+        mdio_write(tp, 0x15, 0x001b);
+        mdio_write(tp, 0x19, 0xc403);
+        mdio_write(tp, 0x15, 0x001c);
+        mdio_write(tp, 0x19, 0x0016);
+        mdio_write(tp, 0x15, 0x001d);
+        mdio_write(tp, 0x19, 0xaa05);
+        mdio_write(tp, 0x15, 0x001e);
+        mdio_write(tp, 0x19, 0xc503);
+        mdio_write(tp, 0x15, 0x001f);
+        mdio_write(tp, 0x19, 0x0003);
+        mdio_write(tp, 0x15, 0x0020);
+        mdio_write(tp, 0x19, 0x89f8);
+        mdio_write(tp, 0x15, 0x0021);
+        mdio_write(tp, 0x19, 0x32ae);
+        mdio_write(tp, 0x15, 0x0022);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0023);
+        mdio_write(tp, 0x19, 0x6c03);
+        mdio_write(tp, 0x15, 0x0024);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0025);
+        mdio_write(tp, 0x19, 0x6801);
+        mdio_write(tp, 0x15, 0x0026);
+        mdio_write(tp, 0x19, 0x66a0);
+        mdio_write(tp, 0x15, 0x0027);
+        mdio_write(tp, 0x19, 0xa300);
+        mdio_write(tp, 0x15, 0x0028);
+        mdio_write(tp, 0x19, 0x64a0);
+        mdio_write(tp, 0x15, 0x0029);
+        mdio_write(tp, 0x19, 0x76f0);
+        mdio_write(tp, 0x15, 0x002a);
+        mdio_write(tp, 0x19, 0x7670);
+        mdio_write(tp, 0x15, 0x002b);
+        mdio_write(tp, 0x19, 0x7630);
+        mdio_write(tp, 0x15, 0x002c);
+        mdio_write(tp, 0x19, 0x31a6);
+        mdio_write(tp, 0x15, 0x002d);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x002e);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x002f);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0030);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0031);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0032);
+        mdio_write(tp, 0x19, 0x4801);
+        mdio_write(tp, 0x15, 0x0033);
+        mdio_write(tp, 0x19, 0x6803);
+        mdio_write(tp, 0x15, 0x0034);
+        mdio_write(tp, 0x19, 0x66a1);
+        mdio_write(tp, 0x15, 0x0035);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0036);
+        mdio_write(tp, 0x19, 0x6c03);
+        mdio_write(tp, 0x15, 0x0037);
+        mdio_write(tp, 0x19, 0xa300);
+        mdio_write(tp, 0x15, 0x0038);
+        mdio_write(tp, 0x19, 0x64a1);
+        mdio_write(tp, 0x15, 0x0039);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x003a);
+        mdio_write(tp, 0x19, 0x74f8);
+        mdio_write(tp, 0x15, 0x003b);
+        mdio_write(tp, 0x19, 0x63d0);
+        mdio_write(tp, 0x15, 0x003c);
+        mdio_write(tp, 0x19, 0x7ff0);
+        mdio_write(tp, 0x15, 0x003d);
+        mdio_write(tp, 0x19, 0x77f0);
+        mdio_write(tp, 0x15, 0x003e);
+        mdio_write(tp, 0x19, 0x7ff0);
+        mdio_write(tp, 0x15, 0x003f);
+        mdio_write(tp, 0x19, 0x7750);
+        mdio_write(tp, 0x15, 0x0040);
+        mdio_write(tp, 0x19, 0x63d8);
+        mdio_write(tp, 0x15, 0x0041);
+        mdio_write(tp, 0x19, 0x7cf0);
+        mdio_write(tp, 0x15, 0x0042);
+        mdio_write(tp, 0x19, 0x7708);
+        mdio_write(tp, 0x15, 0x0043);
+        mdio_write(tp, 0x19, 0xa654);
+        mdio_write(tp, 0x15, 0x0044);
+        mdio_write(tp, 0x19, 0x304a);
+        mdio_write(tp, 0x15, 0x0045);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0046);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0047);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0048);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0049);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x004a);
+        mdio_write(tp, 0x19, 0x4802);
+        mdio_write(tp, 0x15, 0x004b);
+        mdio_write(tp, 0x19, 0x4003);
+        mdio_write(tp, 0x15, 0x004c);
+        mdio_write(tp, 0x19, 0x4440);
+        mdio_write(tp, 0x15, 0x004d);
+        mdio_write(tp, 0x19, 0x63c8);
+        mdio_write(tp, 0x15, 0x004e);
+        mdio_write(tp, 0x19, 0x6481);
+        mdio_write(tp, 0x15, 0x004f);
+        mdio_write(tp, 0x19, 0x9d00);
+        mdio_write(tp, 0x15, 0x0050);
+        mdio_write(tp, 0x19, 0x63e8);
+        mdio_write(tp, 0x15, 0x0051);
+        mdio_write(tp, 0x19, 0x7d00);
+        mdio_write(tp, 0x15, 0x0052);
+        mdio_write(tp, 0x19, 0x5900);
+        mdio_write(tp, 0x15, 0x0053);
+        mdio_write(tp, 0x19, 0x63f8);
+        mdio_write(tp, 0x15, 0x0054);
+        mdio_write(tp, 0x19, 0x64a1);
+        mdio_write(tp, 0x15, 0x0055);
+        mdio_write(tp, 0x19, 0x3116);
+        mdio_write(tp, 0x15, 0x0056);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0057);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0058);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0059);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x005a);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x005b);
+        mdio_write(tp, 0x19, 0x6c03);
+        mdio_write(tp, 0x15, 0x005c);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x005d);
+        mdio_write(tp, 0x19, 0x6000);
+        mdio_write(tp, 0x15, 0x005e);
+        mdio_write(tp, 0x19, 0x59ce);
+        mdio_write(tp, 0x15, 0x005f);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x0060);
+        mdio_write(tp, 0x19, 0x7d00);
+        mdio_write(tp, 0x15, 0x0061);
+        mdio_write(tp, 0x19, 0x72b0);
+        mdio_write(tp, 0x15, 0x0062);
+        mdio_write(tp, 0x19, 0x400e);
+        mdio_write(tp, 0x15, 0x0063);
+        mdio_write(tp, 0x19, 0x4440);
+        mdio_write(tp, 0x15, 0x0064);
+        mdio_write(tp, 0x19, 0x9d00);
+        mdio_write(tp, 0x15, 0x0065);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x15, 0x0066);
+        mdio_write(tp, 0x19, 0x70b0);
+        mdio_write(tp, 0x15, 0x0067);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x0068);
+        mdio_write(tp, 0x19, 0x6008);
+        mdio_write(tp, 0x15, 0x0069);
+        mdio_write(tp, 0x19, 0x7cf0);
+        mdio_write(tp, 0x15, 0x006a);
+        mdio_write(tp, 0x19, 0x7750);
+        mdio_write(tp, 0x15, 0x006b);
+        mdio_write(tp, 0x19, 0x4007);
+        mdio_write(tp, 0x15, 0x006c);
+        mdio_write(tp, 0x19, 0x4500);
+        mdio_write(tp, 0x15, 0x006d);
+        mdio_write(tp, 0x19, 0x4023);
+        mdio_write(tp, 0x15, 0x006e);
+        mdio_write(tp, 0x19, 0x4580);
+        mdio_write(tp, 0x15, 0x006f);
+        mdio_write(tp, 0x19, 0x9f00);
+        mdio_write(tp, 0x15, 0x0070);
+        mdio_write(tp, 0x19, 0xcd78);
+        mdio_write(tp, 0x15, 0x0071);
+        mdio_write(tp, 0x19, 0x0003);
+        mdio_write(tp, 0x15, 0x0072);
+        mdio_write(tp, 0x19, 0xbe02);
+        mdio_write(tp, 0x15, 0x0073);
+        mdio_write(tp, 0x19, 0x3070);
+        mdio_write(tp, 0x15, 0x0074);
+        mdio_write(tp, 0x19, 0x7cf0);
+        mdio_write(tp, 0x15, 0x0075);
+        mdio_write(tp, 0x19, 0x77f0);
+        mdio_write(tp, 0x15, 0x0076);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x0077);
+        mdio_write(tp, 0x19, 0x4007);
+        mdio_write(tp, 0x15, 0x0078);
+        mdio_write(tp, 0x19, 0x4500);
+        mdio_write(tp, 0x15, 0x0079);
+        mdio_write(tp, 0x19, 0x4023);
+        mdio_write(tp, 0x15, 0x007a);
+        mdio_write(tp, 0x19, 0x4580);
+        mdio_write(tp, 0x15, 0x007b);
+        mdio_write(tp, 0x19, 0x9f00);
+        mdio_write(tp, 0x15, 0x007c);
+        mdio_write(tp, 0x19, 0xce80);
+        mdio_write(tp, 0x15, 0x007d);
+        mdio_write(tp, 0x19, 0x0004);
+        mdio_write(tp, 0x15, 0x007e);
+        mdio_write(tp, 0x19, 0xce80);
+        mdio_write(tp, 0x15, 0x007f);
+        mdio_write(tp, 0x19, 0x0002);
+        mdio_write(tp, 0x15, 0x0080);
+        mdio_write(tp, 0x19, 0x307c);
+        mdio_write(tp, 0x15, 0x0081);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x0082);
+        mdio_write(tp, 0x19, 0x480f);
+        mdio_write(tp, 0x15, 0x0083);
+        mdio_write(tp, 0x19, 0x6802);
+        mdio_write(tp, 0x15, 0x0084);
+        mdio_write(tp, 0x19, 0x6680);
+        mdio_write(tp, 0x15, 0x0085);
+        mdio_write(tp, 0x19, 0x7c10);
+        mdio_write(tp, 0x15, 0x0086);
+        mdio_write(tp, 0x19, 0x6010);
+        mdio_write(tp, 0x15, 0x0087);
+        mdio_write(tp, 0x19, 0x400a);
+        mdio_write(tp, 0x15, 0x0088);
+        mdio_write(tp, 0x19, 0x4580);
+        mdio_write(tp, 0x15, 0x0089);
+        mdio_write(tp, 0x19, 0x9e00);
+        mdio_write(tp, 0x15, 0x008a);
+        mdio_write(tp, 0x19, 0x7d00);
+        mdio_write(tp, 0x15, 0x008b);
+        mdio_write(tp, 0x19, 0x5800);
+        mdio_write(tp, 0x15, 0x008c);
+        mdio_write(tp, 0x19, 0x63c8);
+        mdio_write(tp, 0x15, 0x008d);
+        mdio_write(tp, 0x19, 0x63d8);
+        mdio_write(tp, 0x15, 0x008e);
+        mdio_write(tp, 0x19, 0x66a0);
+        mdio_write(tp, 0x15, 0x008f);
+        mdio_write(tp, 0x19, 0x8300);
+        mdio_write(tp, 0x15, 0x0090);
+        mdio_write(tp, 0x19, 0x7ff0);
+        mdio_write(tp, 0x15, 0x0091);
+        mdio_write(tp, 0x19, 0x74f0);
+        mdio_write(tp, 0x15, 0x0092);
+        mdio_write(tp, 0x19, 0x3006);
+        mdio_write(tp, 0x15, 0x0093);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0094);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0095);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0096);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0097);
+        mdio_write(tp, 0x19, 0x4803);
+        mdio_write(tp, 0x15, 0x0098);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0099);
+        mdio_write(tp, 0x19, 0x6c03);
+        mdio_write(tp, 0x15, 0x009a);
+        mdio_write(tp, 0x19, 0xa203);
+        mdio_write(tp, 0x15, 0x009b);
+        mdio_write(tp, 0x19, 0x64b1);
+        mdio_write(tp, 0x15, 0x009c);
+        mdio_write(tp, 0x19, 0x309e);
+        mdio_write(tp, 0x15, 0x009d);
+        mdio_write(tp, 0x19, 0x64b3);
+        mdio_write(tp, 0x15, 0x009e);
+        mdio_write(tp, 0x19, 0x4030);
+        mdio_write(tp, 0x15, 0x009f);
+        mdio_write(tp, 0x19, 0x440e);
+        mdio_write(tp, 0x15, 0x00a0);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x00a1);
+        mdio_write(tp, 0x19, 0x4419);
+        mdio_write(tp, 0x15, 0x00a2);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x00a3);
+        mdio_write(tp, 0x19, 0xc520);
+        mdio_write(tp, 0x15, 0x00a4);
+        mdio_write(tp, 0x19, 0x000b);
+        mdio_write(tp, 0x15, 0x00a5);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x00a6);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x00a7);
+        mdio_write(tp, 0x19, 0x58a4);
+        mdio_write(tp, 0x15, 0x00a8);
+        mdio_write(tp, 0x19, 0x63da);
+        mdio_write(tp, 0x15, 0x00a9);
+        mdio_write(tp, 0x19, 0x5cb0);
+        mdio_write(tp, 0x15, 0x00aa);
+        mdio_write(tp, 0x19, 0x7d00);
+        mdio_write(tp, 0x15, 0x00ab);
+        mdio_write(tp, 0x19, 0x72b0);
+        mdio_write(tp, 0x15, 0x00ac);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x15, 0x00ad);
+        mdio_write(tp, 0x19, 0x70b0);
+        mdio_write(tp, 0x15, 0x00ae);
+        mdio_write(tp, 0x19, 0x30b8);
+        mdio_write(tp, 0x15, 0x00AF);
+        mdio_write(tp, 0x19, 0x4060);
+        mdio_write(tp, 0x15, 0x00B0);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x00B1);
+        mdio_write(tp, 0x19, 0x7e00);
+        mdio_write(tp, 0x15, 0x00B2);
+        mdio_write(tp, 0x19, 0x72B0);
+        mdio_write(tp, 0x15, 0x00B3);
+        mdio_write(tp, 0x19, 0x7F00);
+        mdio_write(tp, 0x15, 0x00B4);
+        mdio_write(tp, 0x19, 0x73B0);
+        mdio_write(tp, 0x15, 0x00b5);
+        mdio_write(tp, 0x19, 0x58a0);
+        mdio_write(tp, 0x15, 0x00b6);
+        mdio_write(tp, 0x19, 0x63d2);
+        mdio_write(tp, 0x15, 0x00b7);
+        mdio_write(tp, 0x19, 0x5c00);
+        mdio_write(tp, 0x15, 0x00b8);
+        mdio_write(tp, 0x19, 0x5780);
+        mdio_write(tp, 0x15, 0x00b9);
+        mdio_write(tp, 0x19, 0xb60d);
+        mdio_write(tp, 0x15, 0x00ba);
+        mdio_write(tp, 0x19, 0x9bff);
+        mdio_write(tp, 0x15, 0x00bb);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x00bc);
+        mdio_write(tp, 0x19, 0x6001);
+        mdio_write(tp, 0x15, 0x00bd);
+        mdio_write(tp, 0x19, 0xc020);
+        mdio_write(tp, 0x15, 0x00be);
+        mdio_write(tp, 0x19, 0x002b);
+        mdio_write(tp, 0x15, 0x00bf);
+        mdio_write(tp, 0x19, 0xc137);
+        mdio_write(tp, 0x15, 0x00c0);
+        mdio_write(tp, 0x19, 0x0006);
+        mdio_write(tp, 0x15, 0x00c1);
+        mdio_write(tp, 0x19, 0x9af8);
+        mdio_write(tp, 0x15, 0x00c2);
+        mdio_write(tp, 0x19, 0x30c6);
+        mdio_write(tp, 0x15, 0x00c3);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00c4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00c5);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00c6);
+        mdio_write(tp, 0x19, 0x7d00);
+        mdio_write(tp, 0x15, 0x00c7);
+        mdio_write(tp, 0x19, 0x70b0);
+        mdio_write(tp, 0x15, 0x00c8);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x00c9);
+        mdio_write(tp, 0x19, 0x4804);
+        mdio_write(tp, 0x15, 0x00ca);
+        mdio_write(tp, 0x19, 0x7c80);
+        mdio_write(tp, 0x15, 0x00cb);
+        mdio_write(tp, 0x19, 0x5c80);
+        mdio_write(tp, 0x15, 0x00cc);
+        mdio_write(tp, 0x19, 0x4010);
+        mdio_write(tp, 0x15, 0x00cd);
+        mdio_write(tp, 0x19, 0x4415);
+        mdio_write(tp, 0x15, 0x00ce);
+        mdio_write(tp, 0x19, 0x9b00);
+        mdio_write(tp, 0x15, 0x00cf);
+        mdio_write(tp, 0x19, 0x7f00);
+        mdio_write(tp, 0x15, 0x00d0);
+        mdio_write(tp, 0x19, 0x70b0);
+        mdio_write(tp, 0x15, 0x00d1);
+        mdio_write(tp, 0x19, 0x3177);
+        mdio_write(tp, 0x15, 0x00d2);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00d3);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00d4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00d5);
+        mdio_write(tp, 0x19, 0x4808);
+        mdio_write(tp, 0x15, 0x00d6);
+        mdio_write(tp, 0x19, 0x4007);
+        mdio_write(tp, 0x15, 0x00d7);
+        mdio_write(tp, 0x19, 0x4420);
+        mdio_write(tp, 0x15, 0x00d8);
+        mdio_write(tp, 0x19, 0x63d8);
+        mdio_write(tp, 0x15, 0x00d9);
+        mdio_write(tp, 0x19, 0xb608);
+        mdio_write(tp, 0x15, 0x00da);
+        mdio_write(tp, 0x19, 0xbcbd);
+        mdio_write(tp, 0x15, 0x00db);
+        mdio_write(tp, 0x19, 0xc60b);
+        mdio_write(tp, 0x15, 0x00dc);
+        mdio_write(tp, 0x19, 0x00fd);
+        mdio_write(tp, 0x15, 0x00dd);
+        mdio_write(tp, 0x19, 0x30e1);
+        mdio_write(tp, 0x15, 0x00de);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00df);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00e0);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00e1);
+        mdio_write(tp, 0x19, 0x4809);
+        mdio_write(tp, 0x15, 0x00e2);
+        mdio_write(tp, 0x19, 0x7e40);
+        mdio_write(tp, 0x15, 0x00e3);
+        mdio_write(tp, 0x19, 0x5a40);
+        mdio_write(tp, 0x15, 0x00e4);
+        mdio_write(tp, 0x19, 0x305a);
+        mdio_write(tp, 0x15, 0x00e5);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00e6);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00e7);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00e8);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00e9);
+        mdio_write(tp, 0x19, 0x480a);
+        mdio_write(tp, 0x15, 0x00ea);
+        mdio_write(tp, 0x19, 0x5820);
+        mdio_write(tp, 0x15, 0x00eb);
+        mdio_write(tp, 0x19, 0x6c03);
+        mdio_write(tp, 0x15, 0x00ec);
+        mdio_write(tp, 0x19, 0xb60a);
+        mdio_write(tp, 0x15, 0x00ed);
+        mdio_write(tp, 0x19, 0xda07);
+        mdio_write(tp, 0x15, 0x00ee);
+        mdio_write(tp, 0x19, 0x0008);
+        mdio_write(tp, 0x15, 0x00ef);
+        mdio_write(tp, 0x19, 0xc60b);
+        mdio_write(tp, 0x15, 0x00f0);
+        mdio_write(tp, 0x19, 0x00fc);
+        mdio_write(tp, 0x15, 0x00f1);
+        mdio_write(tp, 0x19, 0x30f6);
+        mdio_write(tp, 0x15, 0x00f2);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00f3);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00f4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00f5);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x00f6);
+        mdio_write(tp, 0x19, 0x4408);
+        mdio_write(tp, 0x15, 0x00f7);
+        mdio_write(tp, 0x19, 0x480b);
+        mdio_write(tp, 0x15, 0x00f8);
+        mdio_write(tp, 0x19, 0x6f03);
+        mdio_write(tp, 0x15, 0x00f9);
+        mdio_write(tp, 0x19, 0x405f);
+        mdio_write(tp, 0x15, 0x00fa);
+        mdio_write(tp, 0x19, 0x4448);
+        mdio_write(tp, 0x15, 0x00fb);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x00fc);
+        mdio_write(tp, 0x19, 0x4468);
+        mdio_write(tp, 0x15, 0x00fd);
+        mdio_write(tp, 0x19, 0x9c03);
+        mdio_write(tp, 0x15, 0x00fe);
+        mdio_write(tp, 0x19, 0x6f07);
+        mdio_write(tp, 0x15, 0x00ff);
+        mdio_write(tp, 0x19, 0x58a0);
+        mdio_write(tp, 0x15, 0x0100);
+        mdio_write(tp, 0x19, 0xd6d1);
+        mdio_write(tp, 0x15, 0x0101);
+        mdio_write(tp, 0x19, 0x0004);
+        mdio_write(tp, 0x15, 0x0102);
+        mdio_write(tp, 0x19, 0xc137);
+        mdio_write(tp, 0x15, 0x0103);
+        mdio_write(tp, 0x19, 0x0002);
+        mdio_write(tp, 0x15, 0x0104);
+        mdio_write(tp, 0x19, 0xa0e5);
+        mdio_write(tp, 0x15, 0x0105);
+        mdio_write(tp, 0x19, 0x9df8);
+        mdio_write(tp, 0x15, 0x0106);
+        mdio_write(tp, 0x19, 0x30c6);
+        mdio_write(tp, 0x15, 0x0107);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0108);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0109);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x010a);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x010b);
+        mdio_write(tp, 0x19, 0x4808);
+        mdio_write(tp, 0x15, 0x010c);
+        mdio_write(tp, 0x19, 0xc32d);
+        mdio_write(tp, 0x15, 0x010d);
+        mdio_write(tp, 0x19, 0x0003);
+        mdio_write(tp, 0x15, 0x010e);
+        mdio_write(tp, 0x19, 0xc8b3);
+        mdio_write(tp, 0x15, 0x010f);
+        mdio_write(tp, 0x19, 0x00fc);
+        mdio_write(tp, 0x15, 0x0110);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x0111);
+        mdio_write(tp, 0x19, 0x3116);
+        mdio_write(tp, 0x15, 0x0112);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0113);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0114);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0115);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0116);
+        mdio_write(tp, 0x19, 0x4803);
+        mdio_write(tp, 0x15, 0x0117);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0118);
+        mdio_write(tp, 0x19, 0x6c02);
+        mdio_write(tp, 0x15, 0x0119);
+        mdio_write(tp, 0x19, 0x7c04);
+        mdio_write(tp, 0x15, 0x011a);
+        mdio_write(tp, 0x19, 0x6000);
+        mdio_write(tp, 0x15, 0x011b);
+        mdio_write(tp, 0x19, 0x5cf7);
+        mdio_write(tp, 0x15, 0x011c);
+        mdio_write(tp, 0x19, 0x7c2a);
+        mdio_write(tp, 0x15, 0x011d);
+        mdio_write(tp, 0x19, 0x5800);
+        mdio_write(tp, 0x15, 0x011e);
+        mdio_write(tp, 0x19, 0x5400);
+        mdio_write(tp, 0x15, 0x011f);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x0120);
+        mdio_write(tp, 0x19, 0x74f0);
+        mdio_write(tp, 0x15, 0x0121);
+        mdio_write(tp, 0x19, 0x4019);
+        mdio_write(tp, 0x15, 0x0122);
+        mdio_write(tp, 0x19, 0x440d);
+        mdio_write(tp, 0x15, 0x0123);
+        mdio_write(tp, 0x19, 0xb6c1);
+        mdio_write(tp, 0x15, 0x0124);
+        mdio_write(tp, 0x19, 0xc05b);
+        mdio_write(tp, 0x15, 0x0125);
+        mdio_write(tp, 0x19, 0x00bf);
+        mdio_write(tp, 0x15, 0x0126);
+        mdio_write(tp, 0x19, 0xc025);
+        mdio_write(tp, 0x15, 0x0127);
+        mdio_write(tp, 0x19, 0x00bd);
+        mdio_write(tp, 0x15, 0x0128);
+        mdio_write(tp, 0x19, 0xc603);
+        mdio_write(tp, 0x15, 0x0129);
+        mdio_write(tp, 0x19, 0x00bb);
+        mdio_write(tp, 0x15, 0x012a);
+        mdio_write(tp, 0x19, 0x8805);
+        mdio_write(tp, 0x15, 0x012b);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x012c);
+        mdio_write(tp, 0x19, 0x4001);
+        mdio_write(tp, 0x15, 0x012d);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x012e);
+        mdio_write(tp, 0x19, 0xa3dd);
+        mdio_write(tp, 0x15, 0x012f);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0130);
+        mdio_write(tp, 0x19, 0x6c03);
+        mdio_write(tp, 0x15, 0x0131);
+        mdio_write(tp, 0x19, 0x8407);
+        mdio_write(tp, 0x15, 0x0132);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0133);
+        mdio_write(tp, 0x19, 0x6c02);
+        mdio_write(tp, 0x15, 0x0134);
+        mdio_write(tp, 0x19, 0xd9b8);
+        mdio_write(tp, 0x15, 0x0135);
+        mdio_write(tp, 0x19, 0x0003);
+        mdio_write(tp, 0x15, 0x0136);
+        mdio_write(tp, 0x19, 0xc240);
+        mdio_write(tp, 0x15, 0x0137);
+        mdio_write(tp, 0x19, 0x0015);
+        mdio_write(tp, 0x15, 0x0138);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0139);
+        mdio_write(tp, 0x19, 0x6c02);
+        mdio_write(tp, 0x15, 0x013a);
+        mdio_write(tp, 0x19, 0x9ae9);
+        mdio_write(tp, 0x15, 0x013b);
+        mdio_write(tp, 0x19, 0x3140);
+        mdio_write(tp, 0x15, 0x013c);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x013d);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x013e);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x013f);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0140);
+        mdio_write(tp, 0x19, 0x4807);
+        mdio_write(tp, 0x15, 0x0141);
+        mdio_write(tp, 0x19, 0x4004);
+        mdio_write(tp, 0x15, 0x0142);
+        mdio_write(tp, 0x19, 0x4410);
+        mdio_write(tp, 0x15, 0x0143);
+        mdio_write(tp, 0x19, 0x7c0c);
+        mdio_write(tp, 0x15, 0x0144);
+        mdio_write(tp, 0x19, 0x600c);
+        mdio_write(tp, 0x15, 0x0145);
+        mdio_write(tp, 0x19, 0x9b00);
+        mdio_write(tp, 0x15, 0x0146);
+        mdio_write(tp, 0x19, 0xa68f);
+        mdio_write(tp, 0x15, 0x0147);
+        mdio_write(tp, 0x19, 0x3116);
+        mdio_write(tp, 0x15, 0x0148);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0149);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x014a);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x014b);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x014c);
+        mdio_write(tp, 0x19, 0x4804);
+        mdio_write(tp, 0x15, 0x014d);
+        mdio_write(tp, 0x19, 0x54c0);
+        mdio_write(tp, 0x15, 0x014e);
+        mdio_write(tp, 0x19, 0xb703);
+        mdio_write(tp, 0x15, 0x014f);
+        mdio_write(tp, 0x19, 0x5cff);
+        mdio_write(tp, 0x15, 0x0150);
+        mdio_write(tp, 0x19, 0x315f);
+        mdio_write(tp, 0x15, 0x0151);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x0152);
+        mdio_write(tp, 0x19, 0x74f8);
+        mdio_write(tp, 0x15, 0x0153);
+        mdio_write(tp, 0x19, 0x6421);
+        mdio_write(tp, 0x15, 0x0154);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x0155);
+        mdio_write(tp, 0x19, 0x6000);
+        mdio_write(tp, 0x15, 0x0156);
+        mdio_write(tp, 0x19, 0x4003);
+        mdio_write(tp, 0x15, 0x0157);
+        mdio_write(tp, 0x19, 0x4418);
+        mdio_write(tp, 0x15, 0x0158);
+        mdio_write(tp, 0x19, 0x9b00);
+        mdio_write(tp, 0x15, 0x0159);
+        mdio_write(tp, 0x19, 0x6461);
+        mdio_write(tp, 0x15, 0x015a);
+        mdio_write(tp, 0x19, 0x64e1);
+        mdio_write(tp, 0x15, 0x015b);
+        mdio_write(tp, 0x19, 0x7c20);
+        mdio_write(tp, 0x15, 0x015c);
+        mdio_write(tp, 0x19, 0x5820);
+        mdio_write(tp, 0x15, 0x015d);
+        mdio_write(tp, 0x19, 0x5ccf);
+        mdio_write(tp, 0x15, 0x015e);
+        mdio_write(tp, 0x19, 0x7050);
+        mdio_write(tp, 0x15, 0x015f);
+        mdio_write(tp, 0x19, 0xd9b8);
+        mdio_write(tp, 0x15, 0x0160);
+        mdio_write(tp, 0x19, 0x0008);
+        mdio_write(tp, 0x15, 0x0161);
+        mdio_write(tp, 0x19, 0xdab1);
+        mdio_write(tp, 0x15, 0x0162);
+        mdio_write(tp, 0x19, 0x0015);
+        mdio_write(tp, 0x15, 0x0163);
+        mdio_write(tp, 0x19, 0xc244);
+        mdio_write(tp, 0x15, 0x0164);
+        mdio_write(tp, 0x19, 0x0013);
+        mdio_write(tp, 0x15, 0x0165);
+        mdio_write(tp, 0x19, 0xc021);
+        mdio_write(tp, 0x15, 0x0166);
+        mdio_write(tp, 0x19, 0x00f9);
+        mdio_write(tp, 0x15, 0x0167);
+        mdio_write(tp, 0x19, 0x3177);
+        mdio_write(tp, 0x15, 0x0168);
+        mdio_write(tp, 0x19, 0x5cf7);
+        mdio_write(tp, 0x15, 0x0169);
+        mdio_write(tp, 0x19, 0x4010);
+        mdio_write(tp, 0x15, 0x016a);
+        mdio_write(tp, 0x19, 0x4428);
+        mdio_write(tp, 0x15, 0x016b);
+        mdio_write(tp, 0x19, 0x9c00);
+        mdio_write(tp, 0x15, 0x016c);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x016d);
+        mdio_write(tp, 0x19, 0x6008);
+        mdio_write(tp, 0x15, 0x016e);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x016f);
+        mdio_write(tp, 0x19, 0x74f0);
+        mdio_write(tp, 0x15, 0x0170);
+        mdio_write(tp, 0x19, 0x6461);
+        mdio_write(tp, 0x15, 0x0171);
+        mdio_write(tp, 0x19, 0x6421);
+        mdio_write(tp, 0x15, 0x0172);
+        mdio_write(tp, 0x19, 0x64a1);
+        mdio_write(tp, 0x15, 0x0173);
+        mdio_write(tp, 0x19, 0x3116);
+        mdio_write(tp, 0x15, 0x0174);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0175);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0176);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0177);
+        mdio_write(tp, 0x19, 0x4805);
+        mdio_write(tp, 0x15, 0x0178);
+        mdio_write(tp, 0x19, 0xa103);
+        mdio_write(tp, 0x15, 0x0179);
+        mdio_write(tp, 0x19, 0x7c02);
+        mdio_write(tp, 0x15, 0x017a);
+        mdio_write(tp, 0x19, 0x6002);
+        mdio_write(tp, 0x15, 0x017b);
+        mdio_write(tp, 0x19, 0x7e00);
+        mdio_write(tp, 0x15, 0x017c);
+        mdio_write(tp, 0x19, 0x5400);
+        mdio_write(tp, 0x15, 0x017d);
+        mdio_write(tp, 0x19, 0x7c6b);
+        mdio_write(tp, 0x15, 0x017e);
+        mdio_write(tp, 0x19, 0x5c63);
+        mdio_write(tp, 0x15, 0x017f);
+        mdio_write(tp, 0x19, 0x407d);
+        mdio_write(tp, 0x15, 0x0180);
+        mdio_write(tp, 0x19, 0xa602);
+        mdio_write(tp, 0x15, 0x0181);
+        mdio_write(tp, 0x19, 0x4001);
+        mdio_write(tp, 0x15, 0x0182);
+        mdio_write(tp, 0x19, 0x4420);
+        mdio_write(tp, 0x15, 0x0183);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x0184);
+        mdio_write(tp, 0x19, 0x44a1);
+        mdio_write(tp, 0x15, 0x0185);
+        mdio_write(tp, 0x19, 0xd6e0);
+        mdio_write(tp, 0x15, 0x0186);
+        mdio_write(tp, 0x19, 0x0009);
+        mdio_write(tp, 0x15, 0x0187);
+        mdio_write(tp, 0x19, 0x9efe);
+        mdio_write(tp, 0x15, 0x0188);
+        mdio_write(tp, 0x19, 0x7c02);
+        mdio_write(tp, 0x15, 0x0189);
+        mdio_write(tp, 0x19, 0x6000);
+        mdio_write(tp, 0x15, 0x018a);
+        mdio_write(tp, 0x19, 0x9c00);
+        mdio_write(tp, 0x15, 0x018b);
+        mdio_write(tp, 0x19, 0x318f);
+        mdio_write(tp, 0x15, 0x018c);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x018d);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x018e);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x018f);
+        mdio_write(tp, 0x19, 0x4806);
+        mdio_write(tp, 0x15, 0x0190);
+        mdio_write(tp, 0x19, 0x7c10);
+        mdio_write(tp, 0x15, 0x0191);
+        mdio_write(tp, 0x19, 0x5c10);
+        mdio_write(tp, 0x15, 0x0192);
+        mdio_write(tp, 0x19, 0x40fa);
+        mdio_write(tp, 0x15, 0x0193);
+        mdio_write(tp, 0x19, 0xa602);
+        mdio_write(tp, 0x15, 0x0194);
+        mdio_write(tp, 0x19, 0x4010);
+        mdio_write(tp, 0x15, 0x0195);
+        mdio_write(tp, 0x19, 0x4440);
+        mdio_write(tp, 0x15, 0x0196);
+        mdio_write(tp, 0x19, 0x9d00);
+        mdio_write(tp, 0x15, 0x0197);
+        mdio_write(tp, 0x19, 0x7c80);
+        mdio_write(tp, 0x15, 0x0198);
+        mdio_write(tp, 0x19, 0x6400);
+        mdio_write(tp, 0x15, 0x0199);
+        mdio_write(tp, 0x19, 0x4003);
+        mdio_write(tp, 0x15, 0x019a);
+        mdio_write(tp, 0x19, 0x4540);
+        mdio_write(tp, 0x15, 0x019b);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x019c);
+        mdio_write(tp, 0x19, 0x6008);
+        mdio_write(tp, 0x15, 0x019d);
+        mdio_write(tp, 0x19, 0x9f00);
+        mdio_write(tp, 0x15, 0x019e);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x019f);
+        mdio_write(tp, 0x19, 0x6400);
+        mdio_write(tp, 0x15, 0x01a0);
+        mdio_write(tp, 0x19, 0x7c80);
+        mdio_write(tp, 0x15, 0x01a1);
+        mdio_write(tp, 0x19, 0x6480);
+        mdio_write(tp, 0x15, 0x01a2);
+        mdio_write(tp, 0x19, 0x3140);
+        mdio_write(tp, 0x15, 0x01a3);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01a4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01a5);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01a6);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x01a7);
+        mdio_write(tp, 0x19, 0x7c0b);
+        mdio_write(tp, 0x15, 0x01a8);
+        mdio_write(tp, 0x19, 0x6c01);
+        mdio_write(tp, 0x15, 0x01a9);
+        mdio_write(tp, 0x19, 0x64a8);
+        mdio_write(tp, 0x15, 0x01aa);
+        mdio_write(tp, 0x19, 0x6800);
+        mdio_write(tp, 0x15, 0x01ab);
+        mdio_write(tp, 0x19, 0x5cf0);
+        mdio_write(tp, 0x15, 0x01ac);
+        mdio_write(tp, 0x19, 0x588f);
+        mdio_write(tp, 0x15, 0x01ad);
+        mdio_write(tp, 0x19, 0xb628);
+        mdio_write(tp, 0x15, 0x01ae);
+        mdio_write(tp, 0x19, 0xc053);
+        mdio_write(tp, 0x15, 0x01af);
+        mdio_write(tp, 0x19, 0x0026);
+        mdio_write(tp, 0x15, 0x01b0);
+        mdio_write(tp, 0x19, 0xc02d);
+        mdio_write(tp, 0x15, 0x01b1);
+        mdio_write(tp, 0x19, 0x0024);
+        mdio_write(tp, 0x15, 0x01b2);
+        mdio_write(tp, 0x19, 0xc603);
+        mdio_write(tp, 0x15, 0x01b3);
+        mdio_write(tp, 0x19, 0x0022);
+        mdio_write(tp, 0x15, 0x01b4);
+        mdio_write(tp, 0x19, 0x8cf9);
+        mdio_write(tp, 0x15, 0x01b5);
+        mdio_write(tp, 0x19, 0x31ba);
+        mdio_write(tp, 0x15, 0x01b6);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01b7);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01b8);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01b9);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01ba);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x01bb);
+        mdio_write(tp, 0x19, 0x5420);
+        mdio_write(tp, 0x15, 0x01bc);
+        mdio_write(tp, 0x19, 0x4811);
+        mdio_write(tp, 0x15, 0x01bd);
+        mdio_write(tp, 0x19, 0x5000);
+        mdio_write(tp, 0x15, 0x01be);
+        mdio_write(tp, 0x19, 0x4801);
+        mdio_write(tp, 0x15, 0x01bf);
+        mdio_write(tp, 0x19, 0x6800);
+        mdio_write(tp, 0x15, 0x01c0);
+        mdio_write(tp, 0x19, 0x31f5);
+        mdio_write(tp, 0x15, 0x01c1);
+        mdio_write(tp, 0x19, 0xb614);
+        mdio_write(tp, 0x15, 0x01c2);
+        mdio_write(tp, 0x19, 0x8ce4);
+        mdio_write(tp, 0x15, 0x01c3);
+        mdio_write(tp, 0x19, 0xb30c);
+        mdio_write(tp, 0x15, 0x01c4);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x01c5);
+        mdio_write(tp, 0x19, 0x6c02);
+        mdio_write(tp, 0x15, 0x01c6);
+        mdio_write(tp, 0x19, 0x8206);
+        mdio_write(tp, 0x15, 0x01c7);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x01c8);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x01c9);
+        mdio_write(tp, 0x19, 0x7c04);
+        mdio_write(tp, 0x15, 0x01ca);
+        mdio_write(tp, 0x19, 0x7404);
+        mdio_write(tp, 0x15, 0x01cb);
+        mdio_write(tp, 0x19, 0x31c0);
+        mdio_write(tp, 0x15, 0x01cc);
+        mdio_write(tp, 0x19, 0x7c04);
+        mdio_write(tp, 0x15, 0x01cd);
+        mdio_write(tp, 0x19, 0x7400);
+        mdio_write(tp, 0x15, 0x01ce);
+        mdio_write(tp, 0x19, 0x31c0);
+        mdio_write(tp, 0x15, 0x01cf);
+        mdio_write(tp, 0x19, 0x8df1);
+        mdio_write(tp, 0x15, 0x01d0);
+        mdio_write(tp, 0x19, 0x3248);
+        mdio_write(tp, 0x15, 0x01d1);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01d2);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01d3);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01d4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01d5);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x01d6);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x01d7);
+        mdio_write(tp, 0x19, 0x6c03);
+        mdio_write(tp, 0x15, 0x01d8);
+        mdio_write(tp, 0x19, 0x7670);
+        mdio_write(tp, 0x15, 0x01d9);
+        mdio_write(tp, 0x19, 0x4023);
+        mdio_write(tp, 0x15, 0x01da);
+        mdio_write(tp, 0x19, 0x4500);
+        mdio_write(tp, 0x15, 0x01db);
+        mdio_write(tp, 0x19, 0x4069);
+        mdio_write(tp, 0x15, 0x01dc);
+        mdio_write(tp, 0x19, 0x4580);
+        mdio_write(tp, 0x15, 0x01dd);
+        mdio_write(tp, 0x19, 0x9f00);
+        mdio_write(tp, 0x15, 0x01de);
+        mdio_write(tp, 0x19, 0xcff5);
+        mdio_write(tp, 0x15, 0x01df);
+        mdio_write(tp, 0x19, 0x00ff);
+        mdio_write(tp, 0x15, 0x01e0);
+        mdio_write(tp, 0x19, 0x76f0);
+        mdio_write(tp, 0x15, 0x01e1);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x01e2);
+        mdio_write(tp, 0x19, 0x4023);
+        mdio_write(tp, 0x15, 0x01e3);
+        mdio_write(tp, 0x19, 0x4500);
+        mdio_write(tp, 0x15, 0x01e4);
+        mdio_write(tp, 0x19, 0x4069);
+        mdio_write(tp, 0x15, 0x01e5);
+        mdio_write(tp, 0x19, 0x4580);
+        mdio_write(tp, 0x15, 0x01e6);
+        mdio_write(tp, 0x19, 0x9f00);
+        mdio_write(tp, 0x15, 0x01e7);
+        mdio_write(tp, 0x19, 0xd0f5);
+        mdio_write(tp, 0x15, 0x01e8);
+        mdio_write(tp, 0x19, 0x00ff);
+        mdio_write(tp, 0x15, 0x01e9);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x01ea);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x01eb);
+        mdio_write(tp, 0x19, 0x6800);
+        mdio_write(tp, 0x15, 0x01ec);
+        mdio_write(tp, 0x19, 0x66a0);
+        mdio_write(tp, 0x15, 0x01ed);
+        mdio_write(tp, 0x19, 0x8300);
+        mdio_write(tp, 0x15, 0x01ee);
+        mdio_write(tp, 0x19, 0x74f0);
+        mdio_write(tp, 0x15, 0x01ef);
+        mdio_write(tp, 0x19, 0x3006);
+        mdio_write(tp, 0x15, 0x01f0);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01f1);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01f2);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01f3);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01f4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x01f5);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x01f6);
+        mdio_write(tp, 0x19, 0x6c02);
+        mdio_write(tp, 0x15, 0x01f7);
+        mdio_write(tp, 0x19, 0x409d);
+        mdio_write(tp, 0x15, 0x01f8);
+        mdio_write(tp, 0x19, 0x7c87);
+        mdio_write(tp, 0x15, 0x01f9);
+        mdio_write(tp, 0x19, 0xae14);
+        mdio_write(tp, 0x15, 0x01fa);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x01fb);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x01fc);
+        mdio_write(tp, 0x19, 0x6800);
+        mdio_write(tp, 0x15, 0x01fd);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x01fe);
+        mdio_write(tp, 0x19, 0x980e);
+        mdio_write(tp, 0x15, 0x01ff);
+        mdio_write(tp, 0x19, 0x930c);
+        mdio_write(tp, 0x15, 0x0200);
+        mdio_write(tp, 0x19, 0x9206);
+        mdio_write(tp, 0x15, 0x0201);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0202);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0203);
+        mdio_write(tp, 0x19, 0x588f);
+        mdio_write(tp, 0x15, 0x0204);
+        mdio_write(tp, 0x19, 0x5520);
+        mdio_write(tp, 0x15, 0x0205);
+        mdio_write(tp, 0x19, 0x320c);
+        mdio_write(tp, 0x15, 0x0206);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x15, 0x0207);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0208);
+        mdio_write(tp, 0x19, 0x588d);
+        mdio_write(tp, 0x15, 0x0209);
+        mdio_write(tp, 0x19, 0x5500);
+        mdio_write(tp, 0x15, 0x020a);
+        mdio_write(tp, 0x19, 0x320c);
+        mdio_write(tp, 0x15, 0x020b);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x020c);
+        mdio_write(tp, 0x19, 0x3220);
+        mdio_write(tp, 0x15, 0x020d);
+        mdio_write(tp, 0x19, 0x4480);
+        mdio_write(tp, 0x15, 0x020e);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x020f);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x0210);
+        mdio_write(tp, 0x19, 0x6840);
+        mdio_write(tp, 0x15, 0x0211);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x0212);
+        mdio_write(tp, 0x19, 0x980e);
+        mdio_write(tp, 0x15, 0x0213);
+        mdio_write(tp, 0x19, 0x930c);
+        mdio_write(tp, 0x15, 0x0214);
+        mdio_write(tp, 0x19, 0x9206);
+        mdio_write(tp, 0x15, 0x0215);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x15, 0x0216);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0217);
+        mdio_write(tp, 0x19, 0x588f);
+        mdio_write(tp, 0x15, 0x0218);
+        mdio_write(tp, 0x19, 0x5520);
+        mdio_write(tp, 0x15, 0x0219);
+        mdio_write(tp, 0x19, 0x3220);
+        mdio_write(tp, 0x15, 0x021a);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x021b);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x021c);
+        mdio_write(tp, 0x19, 0x588d);
+        mdio_write(tp, 0x15, 0x021d);
+        mdio_write(tp, 0x19, 0x5540);
+        mdio_write(tp, 0x15, 0x021e);
+        mdio_write(tp, 0x19, 0x3220);
+        mdio_write(tp, 0x15, 0x021f);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x15, 0x0220);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0221);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0222);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x0223);
+        mdio_write(tp, 0x19, 0x3231);
+        mdio_write(tp, 0x15, 0x0224);
+        mdio_write(tp, 0x19, 0xab06);
+        mdio_write(tp, 0x15, 0x0225);
+        mdio_write(tp, 0x19, 0xbf08);
+        mdio_write(tp, 0x15, 0x0226);
+        mdio_write(tp, 0x19, 0x4076);
+        mdio_write(tp, 0x15, 0x0227);
+        mdio_write(tp, 0x19, 0x7d07);
+        mdio_write(tp, 0x15, 0x0228);
+        mdio_write(tp, 0x19, 0x4502);
+        mdio_write(tp, 0x15, 0x0229);
+        mdio_write(tp, 0x19, 0x3231);
+        mdio_write(tp, 0x15, 0x022a);
+        mdio_write(tp, 0x19, 0x7d80);
+        mdio_write(tp, 0x15, 0x022b);
+        mdio_write(tp, 0x19, 0x5180);
+        mdio_write(tp, 0x15, 0x022c);
+        mdio_write(tp, 0x19, 0x322f);
+        mdio_write(tp, 0x15, 0x022d);
+        mdio_write(tp, 0x19, 0x7d80);
+        mdio_write(tp, 0x15, 0x022e);
+        mdio_write(tp, 0x19, 0x5000);
+        mdio_write(tp, 0x15, 0x022f);
+        mdio_write(tp, 0x19, 0x7d07);
+        mdio_write(tp, 0x15, 0x0230);
+        mdio_write(tp, 0x19, 0x4402);
+        mdio_write(tp, 0x15, 0x0231);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0232);
+        mdio_write(tp, 0x19, 0x6c02);
+        mdio_write(tp, 0x15, 0x0233);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0234);
+        mdio_write(tp, 0x19, 0xb309);
+        mdio_write(tp, 0x15, 0x0235);
+        mdio_write(tp, 0x19, 0xb204);
+        mdio_write(tp, 0x15, 0x0236);
+        mdio_write(tp, 0x19, 0xb105);
+        mdio_write(tp, 0x15, 0x0237);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x0238);
+        mdio_write(tp, 0x19, 0x31c1);
+        mdio_write(tp, 0x15, 0x0239);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x023a);
+        mdio_write(tp, 0x19, 0x3261);
+        mdio_write(tp, 0x15, 0x023b);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x023c);
+        mdio_write(tp, 0x19, 0x3250);
+        mdio_write(tp, 0x15, 0x023d);
+        mdio_write(tp, 0x19, 0xb203);
+        mdio_write(tp, 0x15, 0x023e);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x023f);
+        mdio_write(tp, 0x19, 0x327a);
+        mdio_write(tp, 0x15, 0x0240);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x0241);
+        mdio_write(tp, 0x19, 0x3293);
+        mdio_write(tp, 0x15, 0x0242);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0243);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0244);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0245);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0246);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0247);
+        mdio_write(tp, 0x19, 0x32a3);
+        mdio_write(tp, 0x15, 0x0248);
+        mdio_write(tp, 0x19, 0x5520);
+        mdio_write(tp, 0x15, 0x0249);
+        mdio_write(tp, 0x19, 0x403d);
+        mdio_write(tp, 0x15, 0x024a);
+        mdio_write(tp, 0x19, 0x440c);
+        mdio_write(tp, 0x15, 0x024b);
+        mdio_write(tp, 0x19, 0x4812);
+        mdio_write(tp, 0x15, 0x024c);
+        mdio_write(tp, 0x19, 0x5001);
+        mdio_write(tp, 0x15, 0x024d);
+        mdio_write(tp, 0x19, 0x4802);
+        mdio_write(tp, 0x15, 0x024e);
+        mdio_write(tp, 0x19, 0x6880);
+        mdio_write(tp, 0x15, 0x024f);
+        mdio_write(tp, 0x19, 0x31f5);
+        mdio_write(tp, 0x15, 0x0250);
+        mdio_write(tp, 0x19, 0xb685);
+        mdio_write(tp, 0x15, 0x0251);
+        mdio_write(tp, 0x19, 0x801c);
+        mdio_write(tp, 0x15, 0x0252);
+        mdio_write(tp, 0x19, 0xbaf5);
+        mdio_write(tp, 0x15, 0x0253);
+        mdio_write(tp, 0x19, 0xc07c);
+        mdio_write(tp, 0x15, 0x0254);
+        mdio_write(tp, 0x19, 0x00fb);
+        mdio_write(tp, 0x15, 0x0255);
+        mdio_write(tp, 0x19, 0x325a);
+        mdio_write(tp, 0x15, 0x0256);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0257);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0258);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0259);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x025a);
+        mdio_write(tp, 0x19, 0x481a);
+        mdio_write(tp, 0x15, 0x025b);
+        mdio_write(tp, 0x19, 0x5001);
+        mdio_write(tp, 0x15, 0x025c);
+        mdio_write(tp, 0x19, 0x401b);
+        mdio_write(tp, 0x15, 0x025d);
+        mdio_write(tp, 0x19, 0x480a);
+        mdio_write(tp, 0x15, 0x025e);
+        mdio_write(tp, 0x19, 0x4418);
+        mdio_write(tp, 0x15, 0x025f);
+        mdio_write(tp, 0x19, 0x6900);
+        mdio_write(tp, 0x15, 0x0260);
+        mdio_write(tp, 0x19, 0x31f5);
+        mdio_write(tp, 0x15, 0x0261);
+        mdio_write(tp, 0x19, 0xb64b);
+        mdio_write(tp, 0x15, 0x0262);
+        mdio_write(tp, 0x19, 0xdb00);
+        mdio_write(tp, 0x15, 0x0263);
+        mdio_write(tp, 0x19, 0x0048);
+        mdio_write(tp, 0x15, 0x0264);
+        mdio_write(tp, 0x19, 0xdb7d);
+        mdio_write(tp, 0x15, 0x0265);
+        mdio_write(tp, 0x19, 0x0002);
+        mdio_write(tp, 0x15, 0x0266);
+        mdio_write(tp, 0x19, 0xa0fa);
+        mdio_write(tp, 0x15, 0x0267);
+        mdio_write(tp, 0x19, 0x4408);
+        mdio_write(tp, 0x15, 0x0268);
+        mdio_write(tp, 0x19, 0x3248);
+        mdio_write(tp, 0x15, 0x0269);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x026a);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x026b);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x026c);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x026d);
+        mdio_write(tp, 0x19, 0xb806);
+        mdio_write(tp, 0x15, 0x026e);
+        mdio_write(tp, 0x19, 0x588d);
+        mdio_write(tp, 0x15, 0x026f);
+        mdio_write(tp, 0x19, 0x5500);
+        mdio_write(tp, 0x15, 0x0270);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x0271);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0272);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0273);
+        mdio_write(tp, 0x19, 0x4814);
+        mdio_write(tp, 0x15, 0x0274);
+        mdio_write(tp, 0x19, 0x500b);
+        mdio_write(tp, 0x15, 0x0275);
+        mdio_write(tp, 0x19, 0x4804);
+        mdio_write(tp, 0x15, 0x0276);
+        mdio_write(tp, 0x19, 0x40c4);
+        mdio_write(tp, 0x15, 0x0277);
+        mdio_write(tp, 0x19, 0x4425);
+        mdio_write(tp, 0x15, 0x0278);
+        mdio_write(tp, 0x19, 0x6a00);
+        mdio_write(tp, 0x15, 0x0279);
+        mdio_write(tp, 0x19, 0x31f5);
+        mdio_write(tp, 0x15, 0x027a);
+        mdio_write(tp, 0x19, 0xb632);
+        mdio_write(tp, 0x15, 0x027b);
+        mdio_write(tp, 0x19, 0xdc03);
+        mdio_write(tp, 0x15, 0x027c);
+        mdio_write(tp, 0x19, 0x0027);
+        mdio_write(tp, 0x15, 0x027d);
+        mdio_write(tp, 0x19, 0x80fc);
+        mdio_write(tp, 0x15, 0x027e);
+        mdio_write(tp, 0x19, 0x3283);
+        mdio_write(tp, 0x15, 0x027f);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0280);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0281);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0282);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0283);
+        mdio_write(tp, 0x19, 0xb806);
+        mdio_write(tp, 0x15, 0x0284);
+        mdio_write(tp, 0x19, 0x588f);
+        mdio_write(tp, 0x15, 0x0285);
+        mdio_write(tp, 0x19, 0x5520);
+        mdio_write(tp, 0x15, 0x0286);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x0287);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x15, 0x0288);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0289);
+        mdio_write(tp, 0x19, 0x4818);
+        mdio_write(tp, 0x15, 0x028a);
+        mdio_write(tp, 0x19, 0x5051);
+        mdio_write(tp, 0x15, 0x028b);
+        mdio_write(tp, 0x19, 0x4808);
+        mdio_write(tp, 0x15, 0x028c);
+        mdio_write(tp, 0x19, 0x4050);
+        mdio_write(tp, 0x15, 0x028d);
+        mdio_write(tp, 0x19, 0x4462);
+        mdio_write(tp, 0x15, 0x028e);
+        mdio_write(tp, 0x19, 0x40c4);
+        mdio_write(tp, 0x15, 0x028f);
+        mdio_write(tp, 0x19, 0x4473);
+        mdio_write(tp, 0x15, 0x0290);
+        mdio_write(tp, 0x19, 0x5041);
+        mdio_write(tp, 0x15, 0x0291);
+        mdio_write(tp, 0x19, 0x6b00);
+        mdio_write(tp, 0x15, 0x0292);
+        mdio_write(tp, 0x19, 0x31f5);
+        mdio_write(tp, 0x15, 0x0293);
+        mdio_write(tp, 0x19, 0xb619);
+        mdio_write(tp, 0x15, 0x0294);
+        mdio_write(tp, 0x19, 0x80d9);
+        mdio_write(tp, 0x15, 0x0295);
+        mdio_write(tp, 0x19, 0xbd06);
+        mdio_write(tp, 0x15, 0x0296);
+        mdio_write(tp, 0x19, 0xbb0d);
+        mdio_write(tp, 0x15, 0x0297);
+        mdio_write(tp, 0x19, 0xaf14);
+        mdio_write(tp, 0x15, 0x0298);
+        mdio_write(tp, 0x19, 0x8efa);
+        mdio_write(tp, 0x15, 0x0299);
+        mdio_write(tp, 0x19, 0x5049);
+        mdio_write(tp, 0x15, 0x029a);
+        mdio_write(tp, 0x19, 0x3248);
+        mdio_write(tp, 0x15, 0x029b);
+        mdio_write(tp, 0x19, 0x4c10);
+        mdio_write(tp, 0x15, 0x029c);
+        mdio_write(tp, 0x19, 0x44b0);
+        mdio_write(tp, 0x15, 0x029d);
+        mdio_write(tp, 0x19, 0x4c00);
+        mdio_write(tp, 0x15, 0x029e);
+        mdio_write(tp, 0x19, 0x3292);
+        mdio_write(tp, 0x15, 0x029f);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02a0);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02a1);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02a2);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02a3);
+        mdio_write(tp, 0x19, 0x481f);
+        mdio_write(tp, 0x15, 0x02a4);
+        mdio_write(tp, 0x19, 0x5005);
+        mdio_write(tp, 0x15, 0x02a5);
+        mdio_write(tp, 0x19, 0x480f);
+        mdio_write(tp, 0x15, 0x02a6);
+        mdio_write(tp, 0x19, 0xac00);
+        mdio_write(tp, 0x15, 0x02a7);
+        mdio_write(tp, 0x19, 0x31a6);
+        mdio_write(tp, 0x15, 0x02a8);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02a9);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02aa);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02ab);
+        mdio_write(tp, 0x19, 0x31ba);
+        mdio_write(tp, 0x15, 0x02ac);
+        mdio_write(tp, 0x19, 0x31d5);
+        mdio_write(tp, 0x15, 0x02ad);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02ae);
+        mdio_write(tp, 0x19, 0x5cf0);
+        mdio_write(tp, 0x15, 0x02af);
+        mdio_write(tp, 0x19, 0x588c);
+        mdio_write(tp, 0x15, 0x02b0);
+        mdio_write(tp, 0x19, 0x542f);
+        mdio_write(tp, 0x15, 0x02b1);
+        mdio_write(tp, 0x19, 0x7ffb);
+        mdio_write(tp, 0x15, 0x02b2);
+        mdio_write(tp, 0x19, 0x6ff8);
+        mdio_write(tp, 0x15, 0x02b3);
+        mdio_write(tp, 0x19, 0x64a4);
+        mdio_write(tp, 0x15, 0x02b4);
+        mdio_write(tp, 0x19, 0x64a0);
+        mdio_write(tp, 0x15, 0x02b5);
+        mdio_write(tp, 0x19, 0x6800);
+        mdio_write(tp, 0x15, 0x02b6);
+        mdio_write(tp, 0x19, 0x4400);
+        mdio_write(tp, 0x15, 0x02b7);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x02b8);
+        mdio_write(tp, 0x19, 0x4480);
+        mdio_write(tp, 0x15, 0x02b9);
+        mdio_write(tp, 0x19, 0x9e00);
+        mdio_write(tp, 0x15, 0x02ba);
+        mdio_write(tp, 0x19, 0x4891);
+        mdio_write(tp, 0x15, 0x02bb);
+        mdio_write(tp, 0x19, 0x4cc0);
+        mdio_write(tp, 0x15, 0x02bc);
+        mdio_write(tp, 0x19, 0x4801);
+        mdio_write(tp, 0x15, 0x02bd);
+        mdio_write(tp, 0x19, 0xa609);
+        mdio_write(tp, 0x15, 0x02be);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x02bf);
+        mdio_write(tp, 0x19, 0x004e);
+        mdio_write(tp, 0x15, 0x02c0);
+        mdio_write(tp, 0x19, 0x87fe);
+        mdio_write(tp, 0x15, 0x02c1);
+        mdio_write(tp, 0x19, 0x32c6);
+        mdio_write(tp, 0x15, 0x02c2);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02c3);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02c4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02c5);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02c6);
+        mdio_write(tp, 0x19, 0x48b2);
+        mdio_write(tp, 0x15, 0x02c7);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x02c8);
+        mdio_write(tp, 0x19, 0x4822);
+        mdio_write(tp, 0x15, 0x02c9);
+        mdio_write(tp, 0x19, 0x4488);
+        mdio_write(tp, 0x15, 0x02ca);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x02cb);
+        mdio_write(tp, 0x19, 0x0042);
+        mdio_write(tp, 0x15, 0x02cc);
+        mdio_write(tp, 0x19, 0x8203);
+        mdio_write(tp, 0x15, 0x02cd);
+        mdio_write(tp, 0x19, 0x4cc8);
+        mdio_write(tp, 0x15, 0x02ce);
+        mdio_write(tp, 0x19, 0x32d0);
+        mdio_write(tp, 0x15, 0x02cf);
+        mdio_write(tp, 0x19, 0x4cc0);
+        mdio_write(tp, 0x15, 0x02d0);
+        mdio_write(tp, 0x19, 0xc4d4);
+        mdio_write(tp, 0x15, 0x02d1);
+        mdio_write(tp, 0x19, 0x00f9);
+        mdio_write(tp, 0x15, 0x02d2);
+        mdio_write(tp, 0x19, 0xa51a);
+        mdio_write(tp, 0x15, 0x02d3);
+        mdio_write(tp, 0x19, 0x32d9);
+        mdio_write(tp, 0x15, 0x02d4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02d5);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02d6);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02d7);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02d8);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02d9);
+        mdio_write(tp, 0x19, 0x48b3);
+        mdio_write(tp, 0x15, 0x02da);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x02db);
+        mdio_write(tp, 0x19, 0x4823);
+        mdio_write(tp, 0x15, 0x02dc);
+        mdio_write(tp, 0x19, 0x4410);
+        mdio_write(tp, 0x15, 0x02dd);
+        mdio_write(tp, 0x19, 0xb630);
+        mdio_write(tp, 0x15, 0x02de);
+        mdio_write(tp, 0x19, 0x7dc8);
+        mdio_write(tp, 0x15, 0x02df);
+        mdio_write(tp, 0x19, 0x8203);
+        mdio_write(tp, 0x15, 0x02e0);
+        mdio_write(tp, 0x19, 0x4c48);
+        mdio_write(tp, 0x15, 0x02e1);
+        mdio_write(tp, 0x19, 0x32e3);
+        mdio_write(tp, 0x15, 0x02e2);
+        mdio_write(tp, 0x19, 0x4c40);
+        mdio_write(tp, 0x15, 0x02e3);
+        mdio_write(tp, 0x19, 0x9bfa);
+        mdio_write(tp, 0x15, 0x02e4);
+        mdio_write(tp, 0x19, 0x84ca);
+        mdio_write(tp, 0x15, 0x02e5);
+        mdio_write(tp, 0x19, 0x85f8);
+        mdio_write(tp, 0x15, 0x02e6);
+        mdio_write(tp, 0x19, 0x32ec);
+        mdio_write(tp, 0x15, 0x02e7);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02e8);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02e9);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02ea);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02eb);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x02ec);
+        mdio_write(tp, 0x19, 0x48d4);
+        mdio_write(tp, 0x15, 0x02ed);
+        mdio_write(tp, 0x19, 0x4020);
+        mdio_write(tp, 0x15, 0x02ee);
+        mdio_write(tp, 0x19, 0x4844);
+        mdio_write(tp, 0x15, 0x02ef);
+        mdio_write(tp, 0x19, 0x4420);
+        mdio_write(tp, 0x15, 0x02f0);
+        mdio_write(tp, 0x19, 0x6800);
+        mdio_write(tp, 0x15, 0x02f1);
+        mdio_write(tp, 0x19, 0x7dc0);
+        mdio_write(tp, 0x15, 0x02f2);
+        mdio_write(tp, 0x19, 0x4c40);
+        mdio_write(tp, 0x15, 0x02f3);
+        mdio_write(tp, 0x19, 0x7c0b);
+        mdio_write(tp, 0x15, 0x02f4);
+        mdio_write(tp, 0x19, 0x6c08);
+        mdio_write(tp, 0x15, 0x02f5);
+        mdio_write(tp, 0x19, 0x3311);
+        mdio_write(tp, 0x15, 0x02f6);
+        mdio_write(tp, 0x19, 0x9cfd);
+        mdio_write(tp, 0x15, 0x02f7);
+        mdio_write(tp, 0x19, 0xb616);
+        mdio_write(tp, 0x15, 0x02f8);
+        mdio_write(tp, 0x19, 0xc42b);
+        mdio_write(tp, 0x15, 0x02f9);
+        mdio_write(tp, 0x19, 0x00e0);
+        mdio_write(tp, 0x15, 0x02fa);
+        mdio_write(tp, 0x19, 0xc455);
+        mdio_write(tp, 0x15, 0x02fb);
+        mdio_write(tp, 0x19, 0x00b3);
+        mdio_write(tp, 0x15, 0x02fc);
+        mdio_write(tp, 0x19, 0xb20a);
+        mdio_write(tp, 0x15, 0x02fd);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x02fe);
+        mdio_write(tp, 0x19, 0x6c02);
+        mdio_write(tp, 0x15, 0x02ff);
+        mdio_write(tp, 0x19, 0x8204);
+        mdio_write(tp, 0x15, 0x0300);
+        mdio_write(tp, 0x19, 0x7c04);
+        mdio_write(tp, 0x15, 0x0301);
+        mdio_write(tp, 0x19, 0x7404);
+        mdio_write(tp, 0x15, 0x0302);
+        mdio_write(tp, 0x19, 0x32f3);
+        mdio_write(tp, 0x15, 0x0303);
+        mdio_write(tp, 0x19, 0x7c04);
+        mdio_write(tp, 0x15, 0x0304);
+        mdio_write(tp, 0x19, 0x7400);
+        mdio_write(tp, 0x15, 0x0305);
+        mdio_write(tp, 0x19, 0x32f3);
+        mdio_write(tp, 0x15, 0x0306);
+        mdio_write(tp, 0x19, 0xefed);
+        mdio_write(tp, 0x15, 0x0307);
+        mdio_write(tp, 0x19, 0x3342);
+        mdio_write(tp, 0x15, 0x0308);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0309);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x030a);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x030b);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x030c);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x030d);
+        mdio_write(tp, 0x19, 0x3006);
+        mdio_write(tp, 0x15, 0x030e);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x030f);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0310);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0311);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x0312);
+        mdio_write(tp, 0x19, 0xa207);
+        mdio_write(tp, 0x15, 0x0313);
+        mdio_write(tp, 0x19, 0x4c00);
+        mdio_write(tp, 0x15, 0x0314);
+        mdio_write(tp, 0x19, 0x3322);
+        mdio_write(tp, 0x15, 0x0315);
+        mdio_write(tp, 0x19, 0x4041);
+        mdio_write(tp, 0x15, 0x0316);
+        mdio_write(tp, 0x19, 0x7d07);
+        mdio_write(tp, 0x15, 0x0317);
+        mdio_write(tp, 0x19, 0x4502);
+        mdio_write(tp, 0x15, 0x0318);
+        mdio_write(tp, 0x19, 0x3322);
+        mdio_write(tp, 0x15, 0x0319);
+        mdio_write(tp, 0x19, 0x4c08);
+        mdio_write(tp, 0x15, 0x031a);
+        mdio_write(tp, 0x19, 0x3322);
+        mdio_write(tp, 0x15, 0x031b);
+        mdio_write(tp, 0x19, 0x7d80);
+        mdio_write(tp, 0x15, 0x031c);
+        mdio_write(tp, 0x19, 0x5180);
+        mdio_write(tp, 0x15, 0x031d);
+        mdio_write(tp, 0x19, 0x3320);
+        mdio_write(tp, 0x15, 0x031e);
+        mdio_write(tp, 0x19, 0x7d80);
+        mdio_write(tp, 0x15, 0x031f);
+        mdio_write(tp, 0x19, 0x5000);
+        mdio_write(tp, 0x15, 0x0320);
+        mdio_write(tp, 0x19, 0x7d07);
+        mdio_write(tp, 0x15, 0x0321);
+        mdio_write(tp, 0x19, 0x4402);
+        mdio_write(tp, 0x15, 0x0322);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0323);
+        mdio_write(tp, 0x19, 0x6c02);
+        mdio_write(tp, 0x15, 0x0324);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x0325);
+        mdio_write(tp, 0x19, 0xb30c);
+        mdio_write(tp, 0x15, 0x0326);
+        mdio_write(tp, 0x19, 0xb206);
+        mdio_write(tp, 0x15, 0x0327);
+        mdio_write(tp, 0x19, 0xb103);
+        mdio_write(tp, 0x15, 0x0328);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x0329);
+        mdio_write(tp, 0x19, 0x32f6);
+        mdio_write(tp, 0x15, 0x032a);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x032b);
+        mdio_write(tp, 0x19, 0x3352);
+        mdio_write(tp, 0x15, 0x032c);
+        mdio_write(tp, 0x19, 0xb103);
+        mdio_write(tp, 0x15, 0x032d);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x032e);
+        mdio_write(tp, 0x19, 0x336a);
+        mdio_write(tp, 0x15, 0x032f);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x0330);
+        mdio_write(tp, 0x19, 0x3382);
+        mdio_write(tp, 0x15, 0x0331);
+        mdio_write(tp, 0x19, 0xb206);
+        mdio_write(tp, 0x15, 0x0332);
+        mdio_write(tp, 0x19, 0xb103);
+        mdio_write(tp, 0x15, 0x0333);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x0334);
+        mdio_write(tp, 0x19, 0x3395);
+        mdio_write(tp, 0x15, 0x0335);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x0336);
+        mdio_write(tp, 0x19, 0x33c6);
+        mdio_write(tp, 0x15, 0x0337);
+        mdio_write(tp, 0x19, 0xb103);
+        mdio_write(tp, 0x15, 0x0338);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x0339);
+        mdio_write(tp, 0x19, 0x33d7);
+        mdio_write(tp, 0x15, 0x033a);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x033b);
+        mdio_write(tp, 0x19, 0x33f2);
+        mdio_write(tp, 0x15, 0x033c);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x033d);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x033e);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x033f);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0340);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0341);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0342);
+        mdio_write(tp, 0x19, 0x49b5);
+        mdio_write(tp, 0x15, 0x0343);
+        mdio_write(tp, 0x19, 0x7d00);
+        mdio_write(tp, 0x15, 0x0344);
+        mdio_write(tp, 0x19, 0x4d00);
+        mdio_write(tp, 0x15, 0x0345);
+        mdio_write(tp, 0x19, 0x6880);
+        mdio_write(tp, 0x15, 0x0346);
+        mdio_write(tp, 0x19, 0x7c08);
+        mdio_write(tp, 0x15, 0x0347);
+        mdio_write(tp, 0x19, 0x6c08);
+        mdio_write(tp, 0x15, 0x0348);
+        mdio_write(tp, 0x19, 0x4925);
+        mdio_write(tp, 0x15, 0x0349);
+        mdio_write(tp, 0x19, 0x403b);
+        mdio_write(tp, 0x15, 0x034a);
+        mdio_write(tp, 0x19, 0xa602);
+        mdio_write(tp, 0x15, 0x034b);
+        mdio_write(tp, 0x19, 0x402f);
+        mdio_write(tp, 0x15, 0x034c);
+        mdio_write(tp, 0x19, 0x4484);
+        mdio_write(tp, 0x15, 0x034d);
+        mdio_write(tp, 0x19, 0x40c8);
+        mdio_write(tp, 0x15, 0x034e);
+        mdio_write(tp, 0x19, 0x44c4);
+        mdio_write(tp, 0x15, 0x034f);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x0350);
+        mdio_write(tp, 0x19, 0x00bd);
+        mdio_write(tp, 0x15, 0x0351);
+        mdio_write(tp, 0x19, 0x3311);
+        mdio_write(tp, 0x15, 0x0352);
+        mdio_write(tp, 0x19, 0xc8ed);
+        mdio_write(tp, 0x15, 0x0353);
+        mdio_write(tp, 0x19, 0x00fc);
+        mdio_write(tp, 0x15, 0x0354);
+        mdio_write(tp, 0x19, 0x8221);
+        mdio_write(tp, 0x15, 0x0355);
+        mdio_write(tp, 0x19, 0xd11d);
+        mdio_write(tp, 0x15, 0x0356);
+        mdio_write(tp, 0x19, 0x001f);
+        mdio_write(tp, 0x15, 0x0357);
+        mdio_write(tp, 0x19, 0xde18);
+        mdio_write(tp, 0x15, 0x0358);
+        mdio_write(tp, 0x19, 0x0008);
+        mdio_write(tp, 0x15, 0x0359);
+        mdio_write(tp, 0x19, 0x91f6);
+        mdio_write(tp, 0x15, 0x035a);
+        mdio_write(tp, 0x19, 0x3360);
+        mdio_write(tp, 0x15, 0x035b);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x035c);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x035d);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x035e);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x035f);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0360);
+        mdio_write(tp, 0x19, 0x4bb6);
+        mdio_write(tp, 0x15, 0x0361);
+        mdio_write(tp, 0x19, 0x4064);
+        mdio_write(tp, 0x15, 0x0362);
+        mdio_write(tp, 0x19, 0x4b26);
+        mdio_write(tp, 0x15, 0x0363);
+        mdio_write(tp, 0x19, 0x4410);
+        mdio_write(tp, 0x15, 0x0364);
+        mdio_write(tp, 0x19, 0x4006);
+        mdio_write(tp, 0x15, 0x0365);
+        mdio_write(tp, 0x19, 0x4490);
+        mdio_write(tp, 0x15, 0x0366);
+        mdio_write(tp, 0x19, 0x6900);
+        mdio_write(tp, 0x15, 0x0367);
+        mdio_write(tp, 0x19, 0xb6a6);
+        mdio_write(tp, 0x15, 0x0368);
+        mdio_write(tp, 0x19, 0x9e02);
+        mdio_write(tp, 0x15, 0x0369);
+        mdio_write(tp, 0x19, 0x3311);
+        mdio_write(tp, 0x15, 0x036a);
+        mdio_write(tp, 0x19, 0xd11d);
+        mdio_write(tp, 0x15, 0x036b);
+        mdio_write(tp, 0x19, 0x000a);
+        mdio_write(tp, 0x15, 0x036c);
+        mdio_write(tp, 0x19, 0xbb0f);
+        mdio_write(tp, 0x15, 0x036d);
+        mdio_write(tp, 0x19, 0x8102);
+        mdio_write(tp, 0x15, 0x036e);
+        mdio_write(tp, 0x19, 0x3371);
+        mdio_write(tp, 0x15, 0x036f);
+        mdio_write(tp, 0x19, 0xa21e);
+        mdio_write(tp, 0x15, 0x0370);
+        mdio_write(tp, 0x19, 0x33b6);
+        mdio_write(tp, 0x15, 0x0371);
+        mdio_write(tp, 0x19, 0x91f6);
+        mdio_write(tp, 0x15, 0x0372);
+        mdio_write(tp, 0x19, 0xc218);
+        mdio_write(tp, 0x15, 0x0373);
+        mdio_write(tp, 0x19, 0x00f4);
+        mdio_write(tp, 0x15, 0x0374);
+        mdio_write(tp, 0x19, 0x33b6);
+        mdio_write(tp, 0x15, 0x0375);
+        mdio_write(tp, 0x19, 0x32ec);
+        mdio_write(tp, 0x15, 0x0376);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0377);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0378);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x0379);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x037a);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x037b);
+        mdio_write(tp, 0x19, 0x4b97);
+        mdio_write(tp, 0x15, 0x037c);
+        mdio_write(tp, 0x19, 0x402b);
+        mdio_write(tp, 0x15, 0x037d);
+        mdio_write(tp, 0x19, 0x4b07);
+        mdio_write(tp, 0x15, 0x037e);
+        mdio_write(tp, 0x19, 0x4422);
+        mdio_write(tp, 0x15, 0x037f);
+        mdio_write(tp, 0x19, 0x6980);
+        mdio_write(tp, 0x15, 0x0380);
+        mdio_write(tp, 0x19, 0xb608);
+        mdio_write(tp, 0x15, 0x0381);
+        mdio_write(tp, 0x19, 0x3311);
+        mdio_write(tp, 0x15, 0x0382);
+        mdio_write(tp, 0x19, 0xbc05);
+        mdio_write(tp, 0x15, 0x0383);
+        mdio_write(tp, 0x19, 0xc21c);
+        mdio_write(tp, 0x15, 0x0384);
+        mdio_write(tp, 0x19, 0x0032);
+        mdio_write(tp, 0x15, 0x0385);
+        mdio_write(tp, 0x19, 0xa1fb);
+        mdio_write(tp, 0x15, 0x0386);
+        mdio_write(tp, 0x19, 0x338d);
+        mdio_write(tp, 0x15, 0x0387);
+        mdio_write(tp, 0x19, 0x32ae);
+        mdio_write(tp, 0x15, 0x0388);
+        mdio_write(tp, 0x19, 0x330d);
+        mdio_write(tp, 0x15, 0x0389);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x038a);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x038b);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x038c);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x038d);
+        mdio_write(tp, 0x19, 0x4b97);
+        mdio_write(tp, 0x15, 0x038e);
+        mdio_write(tp, 0x19, 0x6a08);
+        mdio_write(tp, 0x15, 0x038f);
+        mdio_write(tp, 0x19, 0x4b07);
+        mdio_write(tp, 0x15, 0x0390);
+        mdio_write(tp, 0x19, 0x40ac);
+        mdio_write(tp, 0x15, 0x0391);
+        mdio_write(tp, 0x19, 0x4445);
+        mdio_write(tp, 0x15, 0x0392);
+        mdio_write(tp, 0x19, 0x404e);
+        mdio_write(tp, 0x15, 0x0393);
+        mdio_write(tp, 0x19, 0x4461);
+        mdio_write(tp, 0x15, 0x0394);
+        mdio_write(tp, 0x19, 0x3311);
+        mdio_write(tp, 0x15, 0x0395);
+        mdio_write(tp, 0x19, 0x9c0a);
+        mdio_write(tp, 0x15, 0x0396);
+        mdio_write(tp, 0x19, 0x63da);
+        mdio_write(tp, 0x15, 0x0397);
+        mdio_write(tp, 0x19, 0x6f0c);
+        mdio_write(tp, 0x15, 0x0398);
+        mdio_write(tp, 0x19, 0x5440);
+        mdio_write(tp, 0x15, 0x0399);
+        mdio_write(tp, 0x19, 0x4b98);
+        mdio_write(tp, 0x15, 0x039a);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x039b);
+        mdio_write(tp, 0x19, 0x4c00);
+        mdio_write(tp, 0x15, 0x039c);
+        mdio_write(tp, 0x19, 0x4b08);
+        mdio_write(tp, 0x15, 0x039d);
+        mdio_write(tp, 0x19, 0x63d8);
+        mdio_write(tp, 0x15, 0x039e);
+        mdio_write(tp, 0x19, 0x33a5);
+        mdio_write(tp, 0x15, 0x039f);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x03a0);
+        mdio_write(tp, 0x19, 0x00e8);
+        mdio_write(tp, 0x15, 0x03a1);
+        mdio_write(tp, 0x19, 0x820e);
+        mdio_write(tp, 0x15, 0x03a2);
+        mdio_write(tp, 0x19, 0xa10d);
+        mdio_write(tp, 0x15, 0x03a3);
+        mdio_write(tp, 0x19, 0x9df1);
+        mdio_write(tp, 0x15, 0x03a4);
+        mdio_write(tp, 0x19, 0x33af);
+        mdio_write(tp, 0x15, 0x03a5);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x03a6);
+        mdio_write(tp, 0x19, 0x00f9);
+        mdio_write(tp, 0x15, 0x03a7);
+        mdio_write(tp, 0x19, 0xc017);
+        mdio_write(tp, 0x15, 0x03a8);
+        mdio_write(tp, 0x19, 0x0007);
+        mdio_write(tp, 0x15, 0x03a9);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x03aa);
+        mdio_write(tp, 0x19, 0x6c03);
+        mdio_write(tp, 0x15, 0x03ab);
+        mdio_write(tp, 0x19, 0xa104);
+        mdio_write(tp, 0x15, 0x03ac);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x03ad);
+        mdio_write(tp, 0x19, 0x6c00);
+        mdio_write(tp, 0x15, 0x03ae);
+        mdio_write(tp, 0x19, 0x9df7);
+        mdio_write(tp, 0x15, 0x03af);
+        mdio_write(tp, 0x19, 0x7c03);
+        mdio_write(tp, 0x15, 0x03b0);
+        mdio_write(tp, 0x19, 0x6c08);
+        mdio_write(tp, 0x15, 0x03b1);
+        mdio_write(tp, 0x19, 0x33b6);
+        mdio_write(tp, 0x15, 0x03b2);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03b3);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03b4);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03b5);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03b6);
+        mdio_write(tp, 0x19, 0x55af);
+        mdio_write(tp, 0x15, 0x03b7);
+        mdio_write(tp, 0x19, 0x7ff0);
+        mdio_write(tp, 0x15, 0x03b8);
+        mdio_write(tp, 0x19, 0x6ff0);
+        mdio_write(tp, 0x15, 0x03b9);
+        mdio_write(tp, 0x19, 0x4bb9);
+        mdio_write(tp, 0x15, 0x03ba);
+        mdio_write(tp, 0x19, 0x6a80);
+        mdio_write(tp, 0x15, 0x03bb);
+        mdio_write(tp, 0x19, 0x4b29);
+        mdio_write(tp, 0x15, 0x03bc);
+        mdio_write(tp, 0x19, 0x4041);
+        mdio_write(tp, 0x15, 0x03bd);
+        mdio_write(tp, 0x19, 0x440a);
+        mdio_write(tp, 0x15, 0x03be);
+        mdio_write(tp, 0x19, 0x4029);
+        mdio_write(tp, 0x15, 0x03bf);
+        mdio_write(tp, 0x19, 0x4418);
+        mdio_write(tp, 0x15, 0x03c0);
+        mdio_write(tp, 0x19, 0x4090);
+        mdio_write(tp, 0x15, 0x03c1);
+        mdio_write(tp, 0x19, 0x4438);
+        mdio_write(tp, 0x15, 0x03c2);
+        mdio_write(tp, 0x19, 0x40c4);
+        mdio_write(tp, 0x15, 0x03c3);
+        mdio_write(tp, 0x19, 0x447b);
+        mdio_write(tp, 0x15, 0x03c4);
+        mdio_write(tp, 0x19, 0xb6c4);
+        mdio_write(tp, 0x15, 0x03c5);
+        mdio_write(tp, 0x19, 0x3311);
+        mdio_write(tp, 0x15, 0x03c6);
+        mdio_write(tp, 0x19, 0x9bfe);
+        mdio_write(tp, 0x15, 0x03c7);
+        mdio_write(tp, 0x19, 0x33cc);
+        mdio_write(tp, 0x15, 0x03c8);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03c9);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03ca);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03cb);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03cc);
+        mdio_write(tp, 0x19, 0x542f);
+        mdio_write(tp, 0x15, 0x03cd);
+        mdio_write(tp, 0x19, 0x499a);
+        mdio_write(tp, 0x15, 0x03ce);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x03cf);
+        mdio_write(tp, 0x19, 0x4c40);
+        mdio_write(tp, 0x15, 0x03d0);
+        mdio_write(tp, 0x19, 0x490a);
+        mdio_write(tp, 0x15, 0x03d1);
+        mdio_write(tp, 0x19, 0x405e);
+        mdio_write(tp, 0x15, 0x03d2);
+        mdio_write(tp, 0x19, 0x44f8);
+        mdio_write(tp, 0x15, 0x03d3);
+        mdio_write(tp, 0x19, 0x6b00);
+        mdio_write(tp, 0x15, 0x03d4);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x03d5);
+        mdio_write(tp, 0x19, 0x0028);
+        mdio_write(tp, 0x15, 0x03d6);
+        mdio_write(tp, 0x19, 0x3311);
+        mdio_write(tp, 0x15, 0x03d7);
+        mdio_write(tp, 0x19, 0xbd27);
+        mdio_write(tp, 0x15, 0x03d8);
+        mdio_write(tp, 0x19, 0x9cfc);
+        mdio_write(tp, 0x15, 0x03d9);
+        mdio_write(tp, 0x19, 0xc639);
+        mdio_write(tp, 0x15, 0x03da);
+        mdio_write(tp, 0x19, 0x000f);
+        mdio_write(tp, 0x15, 0x03db);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x03dc);
+        mdio_write(tp, 0x19, 0x7c01);
+        mdio_write(tp, 0x15, 0x03dd);
+        mdio_write(tp, 0x19, 0x4c01);
+        mdio_write(tp, 0x15, 0x03de);
+        mdio_write(tp, 0x19, 0x9af6);
+        mdio_write(tp, 0x15, 0x03df);
+        mdio_write(tp, 0x19, 0x7c12);
+        mdio_write(tp, 0x15, 0x03e0);
+        mdio_write(tp, 0x19, 0x4c52);
+        mdio_write(tp, 0x15, 0x03e1);
+        mdio_write(tp, 0x19, 0x4470);
+        mdio_write(tp, 0x15, 0x03e2);
+        mdio_write(tp, 0x19, 0x7c12);
+        mdio_write(tp, 0x15, 0x03e3);
+        mdio_write(tp, 0x19, 0x4c40);
+        mdio_write(tp, 0x15, 0x03e4);
+        mdio_write(tp, 0x19, 0x33d4);
+        mdio_write(tp, 0x15, 0x03e5);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03e6);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03e7);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03e8);
+        mdio_write(tp, 0x19, 0x0000);
+        mdio_write(tp, 0x15, 0x03e9);
+        mdio_write(tp, 0x19, 0x49bb);
+        mdio_write(tp, 0x15, 0x03ea);
+        mdio_write(tp, 0x19, 0x4478);
+        mdio_write(tp, 0x15, 0x03eb);
+        mdio_write(tp, 0x19, 0x492b);
+        mdio_write(tp, 0x15, 0x03ec);
+        mdio_write(tp, 0x19, 0x6b80);
+        mdio_write(tp, 0x15, 0x03ed);
+        mdio_write(tp, 0x19, 0x7c01);
+        mdio_write(tp, 0x15, 0x03ee);
+        mdio_write(tp, 0x19, 0x4c00);
+        mdio_write(tp, 0x15, 0x03ef);
+        mdio_write(tp, 0x19, 0xd64f);
+        mdio_write(tp, 0x15, 0x03f0);
+        mdio_write(tp, 0x19, 0x000d);
+        mdio_write(tp, 0x15, 0x03f1);
+        mdio_write(tp, 0x19, 0x3311);
+        mdio_write(tp, 0x15, 0x03f2);
+        mdio_write(tp, 0x19, 0xbd0c);
+        mdio_write(tp, 0x15, 0x03f3);
+        mdio_write(tp, 0x19, 0xc428);
+        mdio_write(tp, 0x15, 0x03f4);
+        mdio_write(tp, 0x19, 0x0008);
+        mdio_write(tp, 0x15, 0x03f5);
+        mdio_write(tp, 0x19, 0x9afa);
+        mdio_write(tp, 0x15, 0x03f6);
+        mdio_write(tp, 0x19, 0x7c12);
+        mdio_write(tp, 0x15, 0x03f7);
+        mdio_write(tp, 0x19, 0x4c52);
+        mdio_write(tp, 0x15, 0x03f8);
+        mdio_write(tp, 0x19, 0x4470);
+        mdio_write(tp, 0x15, 0x03f9);
+        mdio_write(tp, 0x19, 0x7c12);
+        mdio_write(tp, 0x15, 0x03fa);
+        mdio_write(tp, 0x19, 0x4c40);
+        mdio_write(tp, 0x15, 0x03fb);
+        mdio_write(tp, 0x19, 0x33ef);
+        mdio_write(tp, 0x15, 0x03fc);
+        mdio_write(tp, 0x19, 0x3342);
+        mdio_write(tp, 0x15, 0x03fd);
+        mdio_write(tp, 0x19, 0x330d);
+        mdio_write(tp, 0x15, 0x03fe);
+        mdio_write(tp, 0x19, 0x32ae);
+        mdio_write(tp, 0x15, 0x0000);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0300);
+        mdio_write(tp, 0x1f, 0x0002);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x05, 0x8000);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0x48f7);
+        mdio_write(tp, 0x06, 0x00e0);
+        mdio_write(tp, 0x06, 0xfff7);
+        mdio_write(tp, 0x06, 0xa080);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0xf602);
+        mdio_write(tp, 0x06, 0x0112);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x1f02);
+        mdio_write(tp, 0x06, 0x012c);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x3c02);
+        mdio_write(tp, 0x06, 0x0156);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x6d02);
+        mdio_write(tp, 0x06, 0x809d);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x88e1);
+        mdio_write(tp, 0x06, 0x8b89);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8a1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8b);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8c1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8e1e);
+        mdio_write(tp, 0x06, 0x01a0);
+        mdio_write(tp, 0x06, 0x00c7);
+        mdio_write(tp, 0x06, 0xaebb);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xc702);
+        mdio_write(tp, 0x06, 0x320a);
+        mdio_write(tp, 0x06, 0xd105);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xcd02);
+        mdio_write(tp, 0x06, 0x320a);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xca02);
+        mdio_write(tp, 0x06, 0x320a);
+        mdio_write(tp, 0x06, 0xd105);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xd002);
+        mdio_write(tp, 0x06, 0x320a);
+        mdio_write(tp, 0x06, 0xd481);
+        mdio_write(tp, 0x06, 0xc9e4);
+        mdio_write(tp, 0x06, 0x8b90);
+        mdio_write(tp, 0x06, 0xe58b);
+        mdio_write(tp, 0x06, 0x91d4);
+        mdio_write(tp, 0x06, 0x81b8);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x92e5);
+        mdio_write(tp, 0x06, 0x8b93);
+        mdio_write(tp, 0x06, 0xbf8b);
+        mdio_write(tp, 0x06, 0x88ec);
+        mdio_write(tp, 0x06, 0x0019);
+        mdio_write(tp, 0x06, 0xa98b);
+        mdio_write(tp, 0x06, 0x90f9);
+        mdio_write(tp, 0x06, 0xeeff);
+        mdio_write(tp, 0x06, 0xf600);
+        mdio_write(tp, 0x06, 0xeeff);
+        mdio_write(tp, 0x06, 0xf7fc);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xc102);
+        mdio_write(tp, 0x06, 0x320a);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xc402);
+        mdio_write(tp, 0x06, 0x320a);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x201a);
+        mdio_write(tp, 0x06, 0xf620);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x824b);
+        mdio_write(tp, 0x06, 0x0281);
+        mdio_write(tp, 0x06, 0x1902);
+        mdio_write(tp, 0x06, 0x2c9d);
+        mdio_write(tp, 0x06, 0x0203);
+        mdio_write(tp, 0x06, 0x9602);
+        mdio_write(tp, 0x06, 0x0473);
+        mdio_write(tp, 0x06, 0x022e);
+        mdio_write(tp, 0x06, 0x3902);
+        mdio_write(tp, 0x06, 0x044d);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x210b);
+        mdio_write(tp, 0x06, 0xf621);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x0416);
+        mdio_write(tp, 0x06, 0x021b);
+        mdio_write(tp, 0x06, 0xa4e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad22);
+        mdio_write(tp, 0x06, 0x05f6);
+        mdio_write(tp, 0x06, 0x22e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2305);
+        mdio_write(tp, 0x06, 0xf623);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8ee0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad24);
+        mdio_write(tp, 0x06, 0x05f6);
+        mdio_write(tp, 0x06, 0x24e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2505);
+        mdio_write(tp, 0x06, 0xf625);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8ee0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad26);
+        mdio_write(tp, 0x06, 0x08f6);
+        mdio_write(tp, 0x06, 0x26e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x0281);
+        mdio_write(tp, 0x06, 0xdae0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x05f6);
+        mdio_write(tp, 0x06, 0x27e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x0203);
+        mdio_write(tp, 0x06, 0x5cfc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad21);
+        mdio_write(tp, 0x06, 0x57e0);
+        mdio_write(tp, 0x06, 0xe022);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0x2358);
+        mdio_write(tp, 0x06, 0xc059);
+        mdio_write(tp, 0x06, 0x021e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b3c);
+        mdio_write(tp, 0x06, 0x1f10);
+        mdio_write(tp, 0x06, 0x9e44);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x3cad);
+        mdio_write(tp, 0x06, 0x211d);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x84f7);
+        mdio_write(tp, 0x06, 0x29e5);
+        mdio_write(tp, 0x06, 0x8b84);
+        mdio_write(tp, 0x06, 0xac27);
+        mdio_write(tp, 0x06, 0x0dac);
+        mdio_write(tp, 0x06, 0x2605);
+        mdio_write(tp, 0x06, 0x0281);
+        mdio_write(tp, 0x06, 0x7fae);
+        mdio_write(tp, 0x06, 0x2b02);
+        mdio_write(tp, 0x06, 0x2c23);
+        mdio_write(tp, 0x06, 0xae26);
+        mdio_write(tp, 0x06, 0x022c);
+        mdio_write(tp, 0x06, 0x41ae);
+        mdio_write(tp, 0x06, 0x21e0);
+        mdio_write(tp, 0x06, 0x8b87);
+        mdio_write(tp, 0x06, 0xad22);
+        mdio_write(tp, 0x06, 0x18e0);
+        mdio_write(tp, 0x06, 0xfff7);
+        mdio_write(tp, 0x06, 0x58fc);
+        mdio_write(tp, 0x06, 0xe4ff);
+        mdio_write(tp, 0x06, 0xf7d1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x2eee);
+        mdio_write(tp, 0x06, 0x0232);
+        mdio_write(tp, 0x06, 0x0ad1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x82e8);
+        mdio_write(tp, 0x06, 0x0232);
+        mdio_write(tp, 0x06, 0x0a02);
+        mdio_write(tp, 0x06, 0x2bdf);
+        mdio_write(tp, 0x06, 0xef96);
+        mdio_write(tp, 0x06, 0xfefc);
+        mdio_write(tp, 0x06, 0x04d0);
+        mdio_write(tp, 0x06, 0x0202);
+        mdio_write(tp, 0x06, 0x1e97);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x87ad);
+        mdio_write(tp, 0x06, 0x2228);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xd302);
+        mdio_write(tp, 0x06, 0x320a);
+        mdio_write(tp, 0x06, 0xd10c);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xd602);
+        mdio_write(tp, 0x06, 0x320a);
+        mdio_write(tp, 0x06, 0xd104);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xd902);
+        mdio_write(tp, 0x06, 0x320a);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xe802);
+        mdio_write(tp, 0x06, 0x320a);
+        mdio_write(tp, 0x06, 0xe0ff);
+        mdio_write(tp, 0x06, 0xf768);
+        mdio_write(tp, 0x06, 0x03e4);
+        mdio_write(tp, 0x06, 0xfff7);
+        mdio_write(tp, 0x06, 0xd004);
+        mdio_write(tp, 0x06, 0x0228);
+        mdio_write(tp, 0x06, 0x7a04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0xe234);
+        mdio_write(tp, 0x06, 0xe1e2);
+        mdio_write(tp, 0x06, 0x35f6);
+        mdio_write(tp, 0x06, 0x2be4);
+        mdio_write(tp, 0x06, 0xe234);
+        mdio_write(tp, 0x06, 0xe5e2);
+        mdio_write(tp, 0x06, 0x35fc);
+        mdio_write(tp, 0x06, 0x05f8);
+        mdio_write(tp, 0x06, 0xe0e2);
+        mdio_write(tp, 0x06, 0x34e1);
+        mdio_write(tp, 0x06, 0xe235);
+        mdio_write(tp, 0x06, 0xf72b);
+        mdio_write(tp, 0x06, 0xe4e2);
+        mdio_write(tp, 0x06, 0x34e5);
+        mdio_write(tp, 0x06, 0xe235);
+        mdio_write(tp, 0x06, 0xfc05);
+        mdio_write(tp, 0x06, 0xf8f9);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69ac);
+        mdio_write(tp, 0x06, 0x1b4c);
+        mdio_write(tp, 0x06, 0xbf2e);
+        mdio_write(tp, 0x06, 0x3002);
+        mdio_write(tp, 0x06, 0x31dd);
+        mdio_write(tp, 0x06, 0xef01);
+        mdio_write(tp, 0x06, 0xe28a);
+        mdio_write(tp, 0x06, 0x76e4);
+        mdio_write(tp, 0x06, 0x8a76);
+        mdio_write(tp, 0x06, 0x1f12);
+        mdio_write(tp, 0x06, 0x9e3a);
+        mdio_write(tp, 0x06, 0xef12);
+        mdio_write(tp, 0x06, 0x5907);
+        mdio_write(tp, 0x06, 0x9f12);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b40);
+        mdio_write(tp, 0x06, 0xf721);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x40d0);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0x287a);
+        mdio_write(tp, 0x06, 0x0282);
+        mdio_write(tp, 0x06, 0x34fc);
+        mdio_write(tp, 0x06, 0xa000);
+        mdio_write(tp, 0x06, 0x1002);
+        mdio_write(tp, 0x06, 0x2dc3);
+        mdio_write(tp, 0x06, 0x022e);
+        mdio_write(tp, 0x06, 0x21e0);
+        mdio_write(tp, 0x06, 0x8b40);
+        mdio_write(tp, 0x06, 0xf621);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x40ae);
+        mdio_write(tp, 0x06, 0x0fbf);
+        mdio_write(tp, 0x06, 0x3fa5);
+        mdio_write(tp, 0x06, 0x0231);
+        mdio_write(tp, 0x06, 0x6cbf);
+        mdio_write(tp, 0x06, 0x3fa2);
+        mdio_write(tp, 0x06, 0x0231);
+        mdio_write(tp, 0x06, 0x6c02);
+        mdio_write(tp, 0x06, 0x2dc3);
+        mdio_write(tp, 0x06, 0xef96);
+        mdio_write(tp, 0x06, 0xfefd);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0xe2f4);
+        mdio_write(tp, 0x06, 0xe1e2);
+        mdio_write(tp, 0x06, 0xf5e4);
+        mdio_write(tp, 0x06, 0x8a78);
+        mdio_write(tp, 0x06, 0xe58a);
+        mdio_write(tp, 0x06, 0x79ee);
+        mdio_write(tp, 0x06, 0xe2f4);
+        mdio_write(tp, 0x06, 0xd8ee);
+        mdio_write(tp, 0x06, 0xe2f5);
+        mdio_write(tp, 0x06, 0x20fc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x87ad);
+        mdio_write(tp, 0x06, 0x2065);
+        mdio_write(tp, 0x06, 0xd200);
+        mdio_write(tp, 0x06, 0xbf2e);
+        mdio_write(tp, 0x06, 0xe802);
+        mdio_write(tp, 0x06, 0x31dd);
+        mdio_write(tp, 0x06, 0x1e21);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xdf02);
+        mdio_write(tp, 0x06, 0x31dd);
+        mdio_write(tp, 0x06, 0x0c11);
+        mdio_write(tp, 0x06, 0x1e21);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xe202);
+        mdio_write(tp, 0x06, 0x31dd);
+        mdio_write(tp, 0x06, 0x0c12);
+        mdio_write(tp, 0x06, 0x1e21);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xe502);
+        mdio_write(tp, 0x06, 0x31dd);
+        mdio_write(tp, 0x06, 0x0c13);
+        mdio_write(tp, 0x06, 0x1e21);
+        mdio_write(tp, 0x06, 0xbf1f);
+        mdio_write(tp, 0x06, 0x5302);
+        mdio_write(tp, 0x06, 0x31dd);
+        mdio_write(tp, 0x06, 0x0c14);
+        mdio_write(tp, 0x06, 0x1e21);
+        mdio_write(tp, 0x06, 0xbf82);
+        mdio_write(tp, 0x06, 0xeb02);
+        mdio_write(tp, 0x06, 0x31dd);
+        mdio_write(tp, 0x06, 0x0c16);
+        mdio_write(tp, 0x06, 0x1e21);
+        mdio_write(tp, 0x06, 0xe083);
+        mdio_write(tp, 0x06, 0xe01f);
+        mdio_write(tp, 0x06, 0x029e);
+        mdio_write(tp, 0x06, 0x22e6);
+        mdio_write(tp, 0x06, 0x83e0);
+        mdio_write(tp, 0x06, 0xad31);
+        mdio_write(tp, 0x06, 0x14ad);
+        mdio_write(tp, 0x06, 0x3011);
+        mdio_write(tp, 0x06, 0xef02);
+        mdio_write(tp, 0x06, 0x580c);
+        mdio_write(tp, 0x06, 0x9e07);
+        mdio_write(tp, 0x06, 0xad36);
+        mdio_write(tp, 0x06, 0x085a);
+        mdio_write(tp, 0x06, 0x309f);
+        mdio_write(tp, 0x06, 0x04d1);
+        mdio_write(tp, 0x06, 0x01ae);
+        mdio_write(tp, 0x06, 0x02d1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x82dc);
+        mdio_write(tp, 0x06, 0x0232);
+        mdio_write(tp, 0x06, 0x0aef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfdfc);
+        mdio_write(tp, 0x06, 0x0400);
+        mdio_write(tp, 0x06, 0xe140);
+        mdio_write(tp, 0x06, 0x77e1);
+        mdio_write(tp, 0x06, 0x4010);
+        mdio_write(tp, 0x06, 0xe150);
+        mdio_write(tp, 0x06, 0x32e1);
+        mdio_write(tp, 0x06, 0x5030);
+        mdio_write(tp, 0x06, 0xe144);
+        mdio_write(tp, 0x06, 0x74e1);
+        mdio_write(tp, 0x06, 0x44bb);
+        mdio_write(tp, 0x06, 0xe2d2);
+        mdio_write(tp, 0x06, 0x40e0);
+        mdio_write(tp, 0x06, 0x2cfc);
+        mdio_write(tp, 0x06, 0xe2cc);
+        mdio_write(tp, 0x06, 0xcce2);
+        mdio_write(tp, 0x06, 0x00cc);
+        mdio_write(tp, 0x06, 0xe000);
+        mdio_write(tp, 0x06, 0x99e0);
+        mdio_write(tp, 0x06, 0x3688);
+        mdio_write(tp, 0x06, 0xe036);
+        mdio_write(tp, 0x06, 0x99e1);
+        mdio_write(tp, 0x06, 0x40dd);
+        mdio_write(tp, 0x06, 0xe022);
+        mdio_write(tp, 0x05, 0xe142);
+        gphy_val = mdio_read(tp, 0x06);
+        gphy_val |= BIT_0;
+        mdio_write(tp, 0x06, gphy_val);
+        mdio_write(tp, 0x05, 0xe140);
+        gphy_val = mdio_read(tp, 0x06);
+        gphy_val |= BIT_0;
+        mdio_write(tp, 0x06, gphy_val);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0005);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x00);
+                if (gphy_val & BIT_7)
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0004);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        gphy_val = mdio_read(tp, 0x17);
+        gphy_val &= ~(BIT_0);
+        gphy_val |= BIT_2;
+        mdio_write(tp, 0x17, gphy_val);
+        mdio_write(tp, 0x1f, 0x0002);
+        mdio_write(tp, 0x1f, 0x0000);
+}
+
+static void
+rtl8168_set_phy_mcu_8168evl_2(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+        unsigned int gphy_val,i;
+
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x00, 0x1800);
+        gphy_val = mdio_read(tp, 0x15);
+        gphy_val &= ~(BIT_12);
+        mdio_write(tp, 0x15, gphy_val);
+        mdio_write(tp, 0x00, 0x4800);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x002f);
+        for (i = 0; i < 1000; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x1c);
+                if ((gphy_val & 0x0080) == 0x0080)
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x00, 0x1800);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x17);
+                if (!(gphy_val & 0x0001))
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0307);
+        mdio_write(tp, 0x15, 0x00AF);
+        mdio_write(tp, 0x19, 0x4060);
+        mdio_write(tp, 0x15, 0x00B0);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x00B1);
+        mdio_write(tp, 0x19, 0x7e00);
+        mdio_write(tp, 0x15, 0x00B2);
+        mdio_write(tp, 0x19, 0x72B0);
+        mdio_write(tp, 0x15, 0x00B3);
+        mdio_write(tp, 0x19, 0x7F00);
+        mdio_write(tp, 0x15, 0x00B4);
+        mdio_write(tp, 0x19, 0x73B0);
+        mdio_write(tp, 0x15, 0x0101);
+        mdio_write(tp, 0x19, 0x0005);
+        mdio_write(tp, 0x15, 0x0103);
+        mdio_write(tp, 0x19, 0x0003);
+        mdio_write(tp, 0x15, 0x0105);
+        mdio_write(tp, 0x19, 0x30FD);
+        mdio_write(tp, 0x15, 0x0106);
+        mdio_write(tp, 0x19, 0x9DF7);
+        mdio_write(tp, 0x15, 0x0107);
+        mdio_write(tp, 0x19, 0x30C6);
+        mdio_write(tp, 0x15, 0x0098);
+        mdio_write(tp, 0x19, 0x7c0b);
+        mdio_write(tp, 0x15, 0x0099);
+        mdio_write(tp, 0x19, 0x6c0b);
+        mdio_write(tp, 0x15, 0x00eb);
+        mdio_write(tp, 0x19, 0x6c0b);
+        mdio_write(tp, 0x15, 0x00f8);
+        mdio_write(tp, 0x19, 0x6f0b);
+        mdio_write(tp, 0x15, 0x00fe);
+        mdio_write(tp, 0x19, 0x6f0f);
+        mdio_write(tp, 0x15, 0x00db);
+        mdio_write(tp, 0x19, 0x6f09);
+        mdio_write(tp, 0x15, 0x00dc);
+        mdio_write(tp, 0x19, 0xaefd);
+        mdio_write(tp, 0x15, 0x00dd);
+        mdio_write(tp, 0x19, 0x6f0b);
+        mdio_write(tp, 0x15, 0x00de);
+        mdio_write(tp, 0x19, 0xc60b);
+        mdio_write(tp, 0x15, 0x00df);
+        mdio_write(tp, 0x19, 0x00fa);
+        mdio_write(tp, 0x15, 0x00e0);
+        mdio_write(tp, 0x19, 0x30e1);
+        mdio_write(tp, 0x15, 0x020c);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x020e);
+        mdio_write(tp, 0x19, 0x9813);
+        mdio_write(tp, 0x15, 0x020f);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x0210);
+        mdio_write(tp, 0x19, 0x930f);
+        mdio_write(tp, 0x15, 0x0211);
+        mdio_write(tp, 0x19, 0x9206);
+        mdio_write(tp, 0x15, 0x0212);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0213);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0214);
+        mdio_write(tp, 0x19, 0x588f);
+        mdio_write(tp, 0x15, 0x0215);
+        mdio_write(tp, 0x19, 0x5520);
+        mdio_write(tp, 0x15, 0x0216);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x0217);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0218);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0219);
+        mdio_write(tp, 0x19, 0x588d);
+        mdio_write(tp, 0x15, 0x021a);
+        mdio_write(tp, 0x19, 0x5540);
+        mdio_write(tp, 0x15, 0x021b);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x021c);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x021d);
+        mdio_write(tp, 0x19, 0x6840);
+        mdio_write(tp, 0x15, 0x021e);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x021f);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0220);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x0221);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x0222);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x0223);
+        mdio_write(tp, 0x19, 0x6840);
+        mdio_write(tp, 0x15, 0x0224);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0225);
+        mdio_write(tp, 0x19, 0x3231);
+        mdio_write(tp, 0x15, 0x0000);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0300);
+        mdio_write(tp, 0x1f, 0x0002);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x17, 0x2160);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0040);
+        mdio_write(tp, 0x18, 0x0004);
+        if (pdev->subsystem_vendor == 0x144d &&
+            pdev->subsystem_device == 0xc0a6) {
+                mdio_write(tp, 0x18, 0x0724);
+                mdio_write(tp, 0x19, 0xfe00);
+                mdio_write(tp, 0x18, 0x0734);
+                mdio_write(tp, 0x19, 0xfd00);
+                mdio_write(tp, 0x18, 0x1824);
+                mdio_write(tp, 0x19, 0xfc00);
+                mdio_write(tp, 0x18, 0x1834);
+                mdio_write(tp, 0x19, 0xfd00);
+        }
+        mdio_write(tp, 0x18, 0x09d4);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x09e4);
+        mdio_write(tp, 0x19, 0x0800);
+        mdio_write(tp, 0x18, 0x09f4);
+        mdio_write(tp, 0x19, 0xff00);
+        mdio_write(tp, 0x18, 0x0a04);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x0a14);
+        mdio_write(tp, 0x19, 0x0c00);
+        mdio_write(tp, 0x18, 0x0a24);
+        mdio_write(tp, 0x19, 0xff00);
+        mdio_write(tp, 0x18, 0x0a74);
+        mdio_write(tp, 0x19, 0xf600);
+        mdio_write(tp, 0x18, 0x1a24);
+        mdio_write(tp, 0x19, 0x7d00);
+        mdio_write(tp, 0x18, 0x1a64);
+        mdio_write(tp, 0x19, 0x0500);
+        mdio_write(tp, 0x18, 0x1a74);
+        mdio_write(tp, 0x19, 0x9500);
+        mdio_write(tp, 0x18, 0x1a84);
+        mdio_write(tp, 0x19, 0x8000);
+        mdio_write(tp, 0x18, 0x1a94);
+        mdio_write(tp, 0x19, 0x7d00);
+        mdio_write(tp, 0x18, 0x1aa4);
+        mdio_write(tp, 0x19, 0x9600);
+        mdio_write(tp, 0x18, 0x1ac4);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x1ad4);
+        mdio_write(tp, 0x19, 0x0800);
+        mdio_write(tp, 0x18, 0x1af4);
+        mdio_write(tp, 0x19, 0xc400);
+        mdio_write(tp, 0x18, 0x1b04);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x1b14);
+        mdio_write(tp, 0x19, 0x0800);
+        mdio_write(tp, 0x18, 0x1b24);
+        mdio_write(tp, 0x19, 0xfd00);
+        mdio_write(tp, 0x18, 0x1b34);
+        mdio_write(tp, 0x19, 0x4000);
+        mdio_write(tp, 0x18, 0x1b44);
+        mdio_write(tp, 0x19, 0x0400);
+        mdio_write(tp, 0x18, 0x1b94);
+        mdio_write(tp, 0x19, 0xf100);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x17, 0x2100);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0040);
+        mdio_write(tp, 0x18, 0x0000);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x05, 0x8000);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0x48f7);
+        mdio_write(tp, 0x06, 0x00e0);
+        mdio_write(tp, 0x06, 0xfff7);
+        mdio_write(tp, 0x06, 0xa080);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0xf602);
+        mdio_write(tp, 0x06, 0x0115);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x2202);
+        mdio_write(tp, 0x06, 0x80a0);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x3f02);
+        mdio_write(tp, 0x06, 0x0159);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0xbd02);
+        mdio_write(tp, 0x06, 0x80da);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x88e1);
+        mdio_write(tp, 0x06, 0x8b89);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8a1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8b);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8c1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8e1e);
+        mdio_write(tp, 0x06, 0x01a0);
+        mdio_write(tp, 0x06, 0x00c7);
+        mdio_write(tp, 0x06, 0xaebb);
+        mdio_write(tp, 0x06, 0xd481);
+        mdio_write(tp, 0x06, 0xd2e4);
+        mdio_write(tp, 0x06, 0x8b92);
+        mdio_write(tp, 0x06, 0xe58b);
+        mdio_write(tp, 0x06, 0x93d1);
+        mdio_write(tp, 0x06, 0x03bf);
+        mdio_write(tp, 0x06, 0x859e);
+        mdio_write(tp, 0x06, 0x0237);
+        mdio_write(tp, 0x06, 0x23d1);
+        mdio_write(tp, 0x06, 0x02bf);
+        mdio_write(tp, 0x06, 0x85a1);
+        mdio_write(tp, 0x06, 0x0237);
+        mdio_write(tp, 0x06, 0x23ee);
+        mdio_write(tp, 0x06, 0x8608);
+        mdio_write(tp, 0x06, 0x03ee);
+        mdio_write(tp, 0x06, 0x860a);
+        mdio_write(tp, 0x06, 0x60ee);
+        mdio_write(tp, 0x06, 0x8610);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8611);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8abe);
+        mdio_write(tp, 0x06, 0x07ee);
+        mdio_write(tp, 0x06, 0x8abf);
+        mdio_write(tp, 0x06, 0x73ee);
+        mdio_write(tp, 0x06, 0x8a95);
+        mdio_write(tp, 0x06, 0x02bf);
+        mdio_write(tp, 0x06, 0x8b88);
+        mdio_write(tp, 0x06, 0xec00);
+        mdio_write(tp, 0x06, 0x19a9);
+        mdio_write(tp, 0x06, 0x8b90);
+        mdio_write(tp, 0x06, 0xf9ee);
+        mdio_write(tp, 0x06, 0xfff6);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0xfff7);
+        mdio_write(tp, 0x06, 0xfed1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x8595);
+        mdio_write(tp, 0x06, 0x0237);
+        mdio_write(tp, 0x06, 0x23d1);
+        mdio_write(tp, 0x06, 0x01bf);
+        mdio_write(tp, 0x06, 0x8598);
+        mdio_write(tp, 0x06, 0x0237);
+        mdio_write(tp, 0x06, 0x2304);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b8a);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x14ee);
+        mdio_write(tp, 0x06, 0x8b8a);
+        mdio_write(tp, 0x06, 0x0002);
+        mdio_write(tp, 0x06, 0x1f9a);
+        mdio_write(tp, 0x06, 0xe0e4);
+        mdio_write(tp, 0x06, 0x26e1);
+        mdio_write(tp, 0x06, 0xe427);
+        mdio_write(tp, 0x06, 0xeee4);
+        mdio_write(tp, 0x06, 0x2623);
+        mdio_write(tp, 0x06, 0xe5e4);
+        mdio_write(tp, 0x06, 0x27fc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8dad);
+        mdio_write(tp, 0x06, 0x2014);
+        mdio_write(tp, 0x06, 0xee8b);
+        mdio_write(tp, 0x06, 0x8d00);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0x5a78);
+        mdio_write(tp, 0x06, 0x039e);
+        mdio_write(tp, 0x06, 0x0902);
+        mdio_write(tp, 0x06, 0x05db);
+        mdio_write(tp, 0x06, 0x0282);
+        mdio_write(tp, 0x06, 0x7b02);
+        mdio_write(tp, 0x06, 0x3231);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x1df6);
+        mdio_write(tp, 0x06, 0x20e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x0281);
+        mdio_write(tp, 0x06, 0x5c02);
+        mdio_write(tp, 0x06, 0x2bcb);
+        mdio_write(tp, 0x06, 0x022d);
+        mdio_write(tp, 0x06, 0x2902);
+        mdio_write(tp, 0x06, 0x03b4);
+        mdio_write(tp, 0x06, 0x0285);
+        mdio_write(tp, 0x06, 0x6402);
+        mdio_write(tp, 0x06, 0x2eca);
+        mdio_write(tp, 0x06, 0x0284);
+        mdio_write(tp, 0x06, 0xcd02);
+        mdio_write(tp, 0x06, 0x046f);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x210b);
+        mdio_write(tp, 0x06, 0xf621);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x8520);
+        mdio_write(tp, 0x06, 0x021b);
+        mdio_write(tp, 0x06, 0xe8e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad22);
+        mdio_write(tp, 0x06, 0x05f6);
+        mdio_write(tp, 0x06, 0x22e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2308);
+        mdio_write(tp, 0x06, 0xf623);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x311c);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2405);
+        mdio_write(tp, 0x06, 0xf624);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8ee0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad25);
+        mdio_write(tp, 0x06, 0x05f6);
+        mdio_write(tp, 0x06, 0x25e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2608);
+        mdio_write(tp, 0x06, 0xf626);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x2df5);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2705);
+        mdio_write(tp, 0x06, 0xf627);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x037a);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8f9);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69e0);
+        mdio_write(tp, 0x06, 0x8b87);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x65d2);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x2fe9);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf61e);
+        mdio_write(tp, 0x06, 0x21bf);
+        mdio_write(tp, 0x06, 0x2ff5);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf60c);
+        mdio_write(tp, 0x06, 0x111e);
+        mdio_write(tp, 0x06, 0x21bf);
+        mdio_write(tp, 0x06, 0x2ff8);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf60c);
+        mdio_write(tp, 0x06, 0x121e);
+        mdio_write(tp, 0x06, 0x21bf);
+        mdio_write(tp, 0x06, 0x2ffb);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf60c);
+        mdio_write(tp, 0x06, 0x131e);
+        mdio_write(tp, 0x06, 0x21bf);
+        mdio_write(tp, 0x06, 0x1f97);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf60c);
+        mdio_write(tp, 0x06, 0x141e);
+        mdio_write(tp, 0x06, 0x21bf);
+        mdio_write(tp, 0x06, 0x859b);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf60c);
+        mdio_write(tp, 0x06, 0x161e);
+        mdio_write(tp, 0x06, 0x21e0);
+        mdio_write(tp, 0x06, 0x8a8c);
+        mdio_write(tp, 0x06, 0x1f02);
+        mdio_write(tp, 0x06, 0x9e22);
+        mdio_write(tp, 0x06, 0xe68a);
+        mdio_write(tp, 0x06, 0x8cad);
+        mdio_write(tp, 0x06, 0x3114);
+        mdio_write(tp, 0x06, 0xad30);
+        mdio_write(tp, 0x06, 0x11ef);
+        mdio_write(tp, 0x06, 0x0258);
+        mdio_write(tp, 0x06, 0x0c9e);
+        mdio_write(tp, 0x06, 0x07ad);
+        mdio_write(tp, 0x06, 0x3608);
+        mdio_write(tp, 0x06, 0x5a30);
+        mdio_write(tp, 0x06, 0x9f04);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xae02);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf2f);
+        mdio_write(tp, 0x06, 0xf202);
+        mdio_write(tp, 0x06, 0x3723);
+        mdio_write(tp, 0x06, 0xef96);
+        mdio_write(tp, 0x06, 0xfefd);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8f9);
+        mdio_write(tp, 0x06, 0xface);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69fa);
+        mdio_write(tp, 0x06, 0xd401);
+        mdio_write(tp, 0x06, 0x55b4);
+        mdio_write(tp, 0x06, 0xfebf);
+        mdio_write(tp, 0x06, 0x85a7);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf6ac);
+        mdio_write(tp, 0x06, 0x280b);
+        mdio_write(tp, 0x06, 0xbf85);
+        mdio_write(tp, 0x06, 0xa402);
+        mdio_write(tp, 0x06, 0x36f6);
+        mdio_write(tp, 0x06, 0xac28);
+        mdio_write(tp, 0x06, 0x49ae);
+        mdio_write(tp, 0x06, 0x64bf);
+        mdio_write(tp, 0x06, 0x85a4);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf6ac);
+        mdio_write(tp, 0x06, 0x285b);
+        mdio_write(tp, 0x06, 0xd000);
+        mdio_write(tp, 0x06, 0x0282);
+        mdio_write(tp, 0x06, 0x60ac);
+        mdio_write(tp, 0x06, 0x2105);
+        mdio_write(tp, 0x06, 0xac22);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x4ebf);
+        mdio_write(tp, 0x06, 0xe0c4);
+        mdio_write(tp, 0x06, 0xbe86);
+        mdio_write(tp, 0x06, 0x14d2);
+        mdio_write(tp, 0x06, 0x04d8);
+        mdio_write(tp, 0x06, 0x19d9);
+        mdio_write(tp, 0x06, 0x1907);
+        mdio_write(tp, 0x06, 0xdc19);
+        mdio_write(tp, 0x06, 0xdd19);
+        mdio_write(tp, 0x06, 0x0789);
+        mdio_write(tp, 0x06, 0x89ef);
+        mdio_write(tp, 0x06, 0x645e);
+        mdio_write(tp, 0x06, 0x07ff);
+        mdio_write(tp, 0x06, 0x0d65);
+        mdio_write(tp, 0x06, 0x5cf8);
+        mdio_write(tp, 0x06, 0x001e);
+        mdio_write(tp, 0x06, 0x46dc);
+        mdio_write(tp, 0x06, 0x19dd);
+        mdio_write(tp, 0x06, 0x19b2);
+        mdio_write(tp, 0x06, 0xe2d4);
+        mdio_write(tp, 0x06, 0x0001);
+        mdio_write(tp, 0x06, 0xbf85);
+        mdio_write(tp, 0x06, 0xa402);
+        mdio_write(tp, 0x06, 0x3723);
+        mdio_write(tp, 0x06, 0xae1d);
+        mdio_write(tp, 0x06, 0xbee0);
+        mdio_write(tp, 0x06, 0xc4bf);
+        mdio_write(tp, 0x06, 0x8614);
+        mdio_write(tp, 0x06, 0xd204);
+        mdio_write(tp, 0x06, 0xd819);
+        mdio_write(tp, 0x06, 0xd919);
+        mdio_write(tp, 0x06, 0x07dc);
+        mdio_write(tp, 0x06, 0x19dd);
+        mdio_write(tp, 0x06, 0x1907);
+        mdio_write(tp, 0x06, 0xb2f4);
+        mdio_write(tp, 0x06, 0xd400);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x85a4);
+        mdio_write(tp, 0x06, 0x0237);
+        mdio_write(tp, 0x06, 0x23fe);
+        mdio_write(tp, 0x06, 0xef96);
+        mdio_write(tp, 0x06, 0xfec6);
+        mdio_write(tp, 0x06, 0xfefd);
+        mdio_write(tp, 0x06, 0xfc05);
+        mdio_write(tp, 0x06, 0xf9e2);
+        mdio_write(tp, 0x06, 0xe0ea);
+        mdio_write(tp, 0x06, 0xe3e0);
+        mdio_write(tp, 0x06, 0xeb5a);
+        mdio_write(tp, 0x06, 0x070c);
+        mdio_write(tp, 0x06, 0x031e);
+        mdio_write(tp, 0x06, 0x20e6);
+        mdio_write(tp, 0x06, 0xe0ea);
+        mdio_write(tp, 0x06, 0xe7e0);
+        mdio_write(tp, 0x06, 0xebe0);
+        mdio_write(tp, 0x06, 0xe0fc);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0xfdfd);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9e0);
+        mdio_write(tp, 0x06, 0x8b81);
+        mdio_write(tp, 0x06, 0xac26);
+        mdio_write(tp, 0x06, 0x1ae0);
+        mdio_write(tp, 0x06, 0x8b81);
+        mdio_write(tp, 0x06, 0xac21);
+        mdio_write(tp, 0x06, 0x14e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xac20);
+        mdio_write(tp, 0x06, 0x0ee0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xac23);
+        mdio_write(tp, 0x06, 0x08e0);
+        mdio_write(tp, 0x06, 0x8b87);
+        mdio_write(tp, 0x06, 0xac24);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x3802);
+        mdio_write(tp, 0x06, 0x1ab5);
+        mdio_write(tp, 0x06, 0xeee4);
+        mdio_write(tp, 0x06, 0x1c04);
+        mdio_write(tp, 0x06, 0xeee4);
+        mdio_write(tp, 0x06, 0x1d04);
+        mdio_write(tp, 0x06, 0xe2e0);
+        mdio_write(tp, 0x06, 0x7ce3);
+        mdio_write(tp, 0x06, 0xe07d);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x38e1);
+        mdio_write(tp, 0x06, 0xe039);
+        mdio_write(tp, 0x06, 0xad2e);
+        mdio_write(tp, 0x06, 0x1bad);
+        mdio_write(tp, 0x06, 0x390d);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf21);
+        mdio_write(tp, 0x06, 0xd502);
+        mdio_write(tp, 0x06, 0x3723);
+        mdio_write(tp, 0x06, 0x0282);
+        mdio_write(tp, 0x06, 0xd8ae);
+        mdio_write(tp, 0x06, 0x0bac);
+        mdio_write(tp, 0x06, 0x3802);
+        mdio_write(tp, 0x06, 0xae06);
+        mdio_write(tp, 0x06, 0x0283);
+        mdio_write(tp, 0x06, 0x1802);
+        mdio_write(tp, 0x06, 0x8360);
+        mdio_write(tp, 0x06, 0x021a);
+        mdio_write(tp, 0x06, 0xc6fd);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e1);
+        mdio_write(tp, 0x06, 0x8af4);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x2605);
+        mdio_write(tp, 0x06, 0x0222);
+        mdio_write(tp, 0x06, 0xa4f7);
+        mdio_write(tp, 0x06, 0x28e0);
+        mdio_write(tp, 0x06, 0x8b81);
+        mdio_write(tp, 0x06, 0xad21);
+        mdio_write(tp, 0x06, 0x0502);
+        mdio_write(tp, 0x06, 0x23a9);
+        mdio_write(tp, 0x06, 0xf729);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x85ad);
+        mdio_write(tp, 0x06, 0x2005);
+        mdio_write(tp, 0x06, 0x0214);
+        mdio_write(tp, 0x06, 0xabf7);
+        mdio_write(tp, 0x06, 0x2ae0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad23);
+        mdio_write(tp, 0x06, 0x0502);
+        mdio_write(tp, 0x06, 0x12e7);
+        mdio_write(tp, 0x06, 0xf72b);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x87ad);
+        mdio_write(tp, 0x06, 0x2405);
+        mdio_write(tp, 0x06, 0x0283);
+        mdio_write(tp, 0x06, 0xbcf7);
+        mdio_write(tp, 0x06, 0x2ce5);
+        mdio_write(tp, 0x06, 0x8af4);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b81);
+        mdio_write(tp, 0x06, 0xad26);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0x21e5);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x2109);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xf4ac);
+        mdio_write(tp, 0x06, 0x2003);
+        mdio_write(tp, 0x06, 0x0223);
+        mdio_write(tp, 0x06, 0x98e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x09e0);
+        mdio_write(tp, 0x06, 0x8af4);
+        mdio_write(tp, 0x06, 0xac21);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0x13fb);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x85ad);
+        mdio_write(tp, 0x06, 0x2309);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xf4ac);
+        mdio_write(tp, 0x06, 0x2203);
+        mdio_write(tp, 0x06, 0x0212);
+        mdio_write(tp, 0x06, 0xfae0);
+        mdio_write(tp, 0x06, 0x8b87);
+        mdio_write(tp, 0x06, 0xad24);
+        mdio_write(tp, 0x06, 0x09e0);
+        mdio_write(tp, 0x06, 0x8af4);
+        mdio_write(tp, 0x06, 0xac23);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0x83c1);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e1);
+        mdio_write(tp, 0x06, 0x8af4);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x2608);
+        mdio_write(tp, 0x06, 0xe083);
+        mdio_write(tp, 0x06, 0xd2ad);
+        mdio_write(tp, 0x06, 0x2502);
+        mdio_write(tp, 0x06, 0xf628);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x210a);
+        mdio_write(tp, 0x06, 0xe084);
+        mdio_write(tp, 0x06, 0x0af6);
+        mdio_write(tp, 0x06, 0x27a0);
+        mdio_write(tp, 0x06, 0x0502);
+        mdio_write(tp, 0x06, 0xf629);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x85ad);
+        mdio_write(tp, 0x06, 0x2008);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xe8ad);
+        mdio_write(tp, 0x06, 0x2102);
+        mdio_write(tp, 0x06, 0xf62a);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x85ad);
+        mdio_write(tp, 0x06, 0x2308);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x20a0);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0xf62b);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x87ad);
+        mdio_write(tp, 0x06, 0x2408);
+        mdio_write(tp, 0x06, 0xe086);
+        mdio_write(tp, 0x06, 0x02a0);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0xf62c);
+        mdio_write(tp, 0x06, 0xe58a);
+        mdio_write(tp, 0x06, 0xf4a1);
+        mdio_write(tp, 0x06, 0x0008);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf21);
+        mdio_write(tp, 0x06, 0xd502);
+        mdio_write(tp, 0x06, 0x3723);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xee86);
+        mdio_write(tp, 0x06, 0x0200);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x87ad);
+        mdio_write(tp, 0x06, 0x241e);
+        mdio_write(tp, 0x06, 0xe086);
+        mdio_write(tp, 0x06, 0x02a0);
+        mdio_write(tp, 0x06, 0x0005);
+        mdio_write(tp, 0x06, 0x0283);
+        mdio_write(tp, 0x06, 0xe8ae);
+        mdio_write(tp, 0x06, 0xf5a0);
+        mdio_write(tp, 0x06, 0x0105);
+        mdio_write(tp, 0x06, 0x0283);
+        mdio_write(tp, 0x06, 0xf8ae);
+        mdio_write(tp, 0x06, 0x0ba0);
+        mdio_write(tp, 0x06, 0x0205);
+        mdio_write(tp, 0x06, 0x0284);
+        mdio_write(tp, 0x06, 0x14ae);
+        mdio_write(tp, 0x06, 0x03a0);
+        mdio_write(tp, 0x06, 0x0300);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0x0284);
+        mdio_write(tp, 0x06, 0x2bee);
+        mdio_write(tp, 0x06, 0x8602);
+        mdio_write(tp, 0x06, 0x01ef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8ee);
+        mdio_write(tp, 0x06, 0x8609);
+        mdio_write(tp, 0x06, 0x0002);
+        mdio_write(tp, 0x06, 0x8461);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xae10);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8608);
+        mdio_write(tp, 0x06, 0xe186);
+        mdio_write(tp, 0x06, 0x091f);
+        mdio_write(tp, 0x06, 0x019e);
+        mdio_write(tp, 0x06, 0x0611);
+        mdio_write(tp, 0x06, 0xe586);
+        mdio_write(tp, 0x06, 0x09ae);
+        mdio_write(tp, 0x06, 0x04ee);
+        mdio_write(tp, 0x06, 0x8602);
+        mdio_write(tp, 0x06, 0x01fc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0xfbbf);
+        mdio_write(tp, 0x06, 0x8604);
+        mdio_write(tp, 0x06, 0xef79);
+        mdio_write(tp, 0x06, 0xd200);
+        mdio_write(tp, 0x06, 0xd400);
+        mdio_write(tp, 0x06, 0x221e);
+        mdio_write(tp, 0x06, 0x02bf);
+        mdio_write(tp, 0x06, 0x2fec);
+        mdio_write(tp, 0x06, 0x0237);
+        mdio_write(tp, 0x06, 0x23bf);
+        mdio_write(tp, 0x06, 0x13f2);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf60d);
+        mdio_write(tp, 0x06, 0x4559);
+        mdio_write(tp, 0x06, 0x1fef);
+        mdio_write(tp, 0x06, 0x97dd);
+        mdio_write(tp, 0x06, 0xd308);
+        mdio_write(tp, 0x06, 0x1a93);
+        mdio_write(tp, 0x06, 0xdd12);
+        mdio_write(tp, 0x06, 0x17a2);
+        mdio_write(tp, 0x06, 0x04de);
+        mdio_write(tp, 0x06, 0xffef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfdfc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0xfbee);
+        mdio_write(tp, 0x06, 0x8602);
+        mdio_write(tp, 0x06, 0x03d5);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x06, 0xbf86);
+        mdio_write(tp, 0x06, 0x04ef);
+        mdio_write(tp, 0x06, 0x79ef);
+        mdio_write(tp, 0x06, 0x45bf);
+        mdio_write(tp, 0x06, 0x2fec);
+        mdio_write(tp, 0x06, 0x0237);
+        mdio_write(tp, 0x06, 0x23bf);
+        mdio_write(tp, 0x06, 0x13f2);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf6ad);
+        mdio_write(tp, 0x06, 0x2702);
+        mdio_write(tp, 0x06, 0x78ff);
+        mdio_write(tp, 0x06, 0xe186);
+        mdio_write(tp, 0x06, 0x0a1b);
+        mdio_write(tp, 0x06, 0x01aa);
+        mdio_write(tp, 0x06, 0x2eef);
+        mdio_write(tp, 0x06, 0x97d9);
+        mdio_write(tp, 0x06, 0x7900);
+        mdio_write(tp, 0x06, 0x9e2b);
+        mdio_write(tp, 0x06, 0x81dd);
+        mdio_write(tp, 0x06, 0xbf85);
+        mdio_write(tp, 0x06, 0xad02);
+        mdio_write(tp, 0x06, 0x3723);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xef02);
+        mdio_write(tp, 0x06, 0x100c);
+        mdio_write(tp, 0x06, 0x11b0);
+        mdio_write(tp, 0x06, 0xfc0d);
+        mdio_write(tp, 0x06, 0x11bf);
+        mdio_write(tp, 0x06, 0x85aa);
+        mdio_write(tp, 0x06, 0x0237);
+        mdio_write(tp, 0x06, 0x23d1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x85aa);
+        mdio_write(tp, 0x06, 0x0237);
+        mdio_write(tp, 0x06, 0x23ee);
+        mdio_write(tp, 0x06, 0x8602);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x0413);
+        mdio_write(tp, 0x06, 0xa38b);
+        mdio_write(tp, 0x06, 0xb4d3);
+        mdio_write(tp, 0x06, 0x8012);
+        mdio_write(tp, 0x06, 0x17a2);
+        mdio_write(tp, 0x06, 0x04ad);
+        mdio_write(tp, 0x06, 0xffef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfdfc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad25);
+        mdio_write(tp, 0x06, 0x48e0);
+        mdio_write(tp, 0x06, 0x8a96);
+        mdio_write(tp, 0x06, 0xe18a);
+        mdio_write(tp, 0x06, 0x977c);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x9e35);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0x9600);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0x9700);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xbee1);
+        mdio_write(tp, 0x06, 0x8abf);
+        mdio_write(tp, 0x06, 0xe286);
+        mdio_write(tp, 0x06, 0x10e3);
+        mdio_write(tp, 0x06, 0x8611);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0x1aad);
+        mdio_write(tp, 0x06, 0x2012);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0x9603);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0x97b7);
+        mdio_write(tp, 0x06, 0xee86);
+        mdio_write(tp, 0x06, 0x1000);
+        mdio_write(tp, 0x06, 0xee86);
+        mdio_write(tp, 0x06, 0x1100);
+        mdio_write(tp, 0x06, 0xae11);
+        mdio_write(tp, 0x06, 0x15e6);
+        mdio_write(tp, 0x06, 0x8610);
+        mdio_write(tp, 0x06, 0xe786);
+        mdio_write(tp, 0x06, 0x11ae);
+        mdio_write(tp, 0x06, 0x08ee);
+        mdio_write(tp, 0x06, 0x8610);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8611);
+        mdio_write(tp, 0x06, 0x00fd);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x00e1);
+        mdio_write(tp, 0x06, 0xe001);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x32e0);
+        mdio_write(tp, 0x06, 0x8b40);
+        mdio_write(tp, 0x06, 0xf720);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x40bf);
+        mdio_write(tp, 0x06, 0x31f5);
+        mdio_write(tp, 0x06, 0x0236);
+        mdio_write(tp, 0x06, 0xf6ad);
+        mdio_write(tp, 0x06, 0x2821);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x20e1);
+        mdio_write(tp, 0x06, 0xe021);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x18e0);
+        mdio_write(tp, 0x06, 0x8b40);
+        mdio_write(tp, 0x06, 0xf620);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x40ee);
+        mdio_write(tp, 0x06, 0x8b3b);
+        mdio_write(tp, 0x06, 0xffe0);
+        mdio_write(tp, 0x06, 0x8a8a);
+        mdio_write(tp, 0x06, 0xe18a);
+        mdio_write(tp, 0x06, 0x8be4);
+        mdio_write(tp, 0x06, 0xe000);
+        mdio_write(tp, 0x06, 0xe5e0);
+        mdio_write(tp, 0x06, 0x01ef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x80ad);
+        mdio_write(tp, 0x06, 0x2722);
+        mdio_write(tp, 0x06, 0xbf44);
+        mdio_write(tp, 0x06, 0xfc02);
+        mdio_write(tp, 0x06, 0x36f6);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x441f);
+        mdio_write(tp, 0x06, 0x019e);
+        mdio_write(tp, 0x06, 0x15e5);
+        mdio_write(tp, 0x06, 0x8b44);
+        mdio_write(tp, 0x06, 0xad29);
+        mdio_write(tp, 0x06, 0x07ac);
+        mdio_write(tp, 0x06, 0x2804);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xae02);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf85);
+        mdio_write(tp, 0x06, 0xb002);
+        mdio_write(tp, 0x06, 0x3723);
+        mdio_write(tp, 0x06, 0xef96);
+        mdio_write(tp, 0x06, 0xfefc);
+        mdio_write(tp, 0x06, 0x0400);
+        mdio_write(tp, 0x06, 0xe140);
+        mdio_write(tp, 0x06, 0x77e1);
+        mdio_write(tp, 0x06, 0x40dd);
+        mdio_write(tp, 0x06, 0xe022);
+        mdio_write(tp, 0x06, 0x32e1);
+        mdio_write(tp, 0x06, 0x5074);
+        mdio_write(tp, 0x06, 0xe144);
+        mdio_write(tp, 0x06, 0xffe0);
+        mdio_write(tp, 0x06, 0xdaff);
+        mdio_write(tp, 0x06, 0xe0c0);
+        mdio_write(tp, 0x06, 0x52e0);
+        mdio_write(tp, 0x06, 0xeed9);
+        mdio_write(tp, 0x06, 0xe04c);
+        mdio_write(tp, 0x06, 0xbbe0);
+        mdio_write(tp, 0x06, 0x2a00);
+        mdio_write(tp, 0x05, 0xe142);
+        gphy_val = mdio_read(tp, 0x06);
+        gphy_val |= BIT_0;
+        mdio_write(tp, 0x06, gphy_val);
+        mdio_write(tp, 0x05, 0xe140);
+        gphy_val = mdio_read(tp, 0x06);
+        gphy_val |= BIT_0;
+        mdio_write(tp, 0x06, gphy_val);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0005);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x00);
+                if (gphy_val & BIT_7)
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0042);
+        mdio_write(tp, 0x18, 0x2300);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        if (tp->RequiredSecLanDonglePatch) {
+                gphy_val = mdio_read(tp, 0x17);
+                gphy_val &= ~BIT_2;
+                mdio_write(tp, 0x17, gphy_val);
+        }
+
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x00, 0x9200);
+}
+
+static void
+rtl8168_set_phy_mcu_8168f_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp,0x1f, 0x0000);
+        mdio_write(tp,0x00, 0x1800);
+        gphy_val = mdio_read(tp, 0x15);
+        gphy_val &= ~(BIT_12);
+        mdio_write(tp,0x15, gphy_val);
+        mdio_write(tp,0x00, 0x4800);
+        mdio_write(tp,0x1f, 0x0007);
+        mdio_write(tp,0x1e, 0x002f);
+        for (i = 0; i < 1000; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x1c);
+                if (gphy_val & 0x0080)
+                        break;
+        }
+        mdio_write(tp,0x1f, 0x0000);
+        mdio_write(tp,0x00, 0x1800);
+        mdio_write(tp,0x1f, 0x0007);
+        mdio_write(tp,0x1e, 0x0023);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x18);
+                if (!(gphy_val & 0x0001))
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0307);
+        mdio_write(tp, 0x15, 0x0194);
+        mdio_write(tp, 0x19, 0x407D);
+        mdio_write(tp, 0x15, 0x0098);
+        mdio_write(tp, 0x19, 0x7c0b);
+        mdio_write(tp, 0x15, 0x0099);
+        mdio_write(tp, 0x19, 0x6c0b);
+        mdio_write(tp, 0x15, 0x00eb);
+        mdio_write(tp, 0x19, 0x6c0b);
+        mdio_write(tp, 0x15, 0x00f8);
+        mdio_write(tp, 0x19, 0x6f0b);
+        mdio_write(tp, 0x15, 0x00fe);
+        mdio_write(tp, 0x19, 0x6f0f);
+        mdio_write(tp, 0x15, 0x00db);
+        mdio_write(tp, 0x19, 0x6f09);
+        mdio_write(tp, 0x15, 0x00dc);
+        mdio_write(tp, 0x19, 0xaefd);
+        mdio_write(tp, 0x15, 0x00dd);
+        mdio_write(tp, 0x19, 0x6f0b);
+        mdio_write(tp, 0x15, 0x00de);
+        mdio_write(tp, 0x19, 0xc60b);
+        mdio_write(tp, 0x15, 0x00df);
+        mdio_write(tp, 0x19, 0x00fa);
+        mdio_write(tp, 0x15, 0x00e0);
+        mdio_write(tp, 0x19, 0x30e1);
+        mdio_write(tp, 0x15, 0x020c);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x020e);
+        mdio_write(tp, 0x19, 0x9813);
+        mdio_write(tp, 0x15, 0x020f);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x0210);
+        mdio_write(tp, 0x19, 0x930f);
+        mdio_write(tp, 0x15, 0x0211);
+        mdio_write(tp, 0x19, 0x9206);
+        mdio_write(tp, 0x15, 0x0212);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0213);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0214);
+        mdio_write(tp, 0x19, 0x588f);
+        mdio_write(tp, 0x15, 0x0215);
+        mdio_write(tp, 0x19, 0x5520);
+        mdio_write(tp, 0x15, 0x0216);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x0217);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0218);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0219);
+        mdio_write(tp, 0x19, 0x588d);
+        mdio_write(tp, 0x15, 0x021a);
+        mdio_write(tp, 0x19, 0x5540);
+        mdio_write(tp, 0x15, 0x021b);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x021c);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x021d);
+        mdio_write(tp, 0x19, 0x6840);
+        mdio_write(tp, 0x15, 0x021e);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x021f);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0220);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x0221);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x0222);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x0223);
+        mdio_write(tp, 0x19, 0x6840);
+        mdio_write(tp, 0x15, 0x0224);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0225);
+        mdio_write(tp, 0x19, 0x3231);
+        mdio_write(tp, 0x15, 0x0000);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0300);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x05, 0x8000);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0x48f7);
+        mdio_write(tp, 0x06, 0x00e0);
+        mdio_write(tp, 0x06, 0xfff7);
+        mdio_write(tp, 0x06, 0xa080);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0xf602);
+        mdio_write(tp, 0x06, 0x0118);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x2502);
+        mdio_write(tp, 0x06, 0x8090);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x4202);
+        mdio_write(tp, 0x06, 0x015c);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0xad02);
+        mdio_write(tp, 0x06, 0x80ca);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x88e1);
+        mdio_write(tp, 0x06, 0x8b89);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8a1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8b);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8c1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8e1e);
+        mdio_write(tp, 0x06, 0x01a0);
+        mdio_write(tp, 0x06, 0x00c7);
+        mdio_write(tp, 0x06, 0xaebb);
+        mdio_write(tp, 0x06, 0xd484);
+        mdio_write(tp, 0x06, 0x3ce4);
+        mdio_write(tp, 0x06, 0x8b92);
+        mdio_write(tp, 0x06, 0xe58b);
+        mdio_write(tp, 0x06, 0x93ee);
+        mdio_write(tp, 0x06, 0x8ac8);
+        mdio_write(tp, 0x06, 0x03ee);
+        mdio_write(tp, 0x06, 0x8aca);
+        mdio_write(tp, 0x06, 0x60ee);
+        mdio_write(tp, 0x06, 0x8ac0);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8ac1);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8abe);
+        mdio_write(tp, 0x06, 0x07ee);
+        mdio_write(tp, 0x06, 0x8abf);
+        mdio_write(tp, 0x06, 0x73ee);
+        mdio_write(tp, 0x06, 0x8a95);
+        mdio_write(tp, 0x06, 0x02bf);
+        mdio_write(tp, 0x06, 0x8b88);
+        mdio_write(tp, 0x06, 0xec00);
+        mdio_write(tp, 0x06, 0x19a9);
+        mdio_write(tp, 0x06, 0x8b90);
+        mdio_write(tp, 0x06, 0xf9ee);
+        mdio_write(tp, 0x06, 0xfff6);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0xfff7);
+        mdio_write(tp, 0x06, 0xfed1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x85a4);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x7dd1);
+        mdio_write(tp, 0x06, 0x01bf);
+        mdio_write(tp, 0x06, 0x85a7);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x7d04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b8a);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x14ee);
+        mdio_write(tp, 0x06, 0x8b8a);
+        mdio_write(tp, 0x06, 0x0002);
+        mdio_write(tp, 0x06, 0x204b);
+        mdio_write(tp, 0x06, 0xe0e4);
+        mdio_write(tp, 0x06, 0x26e1);
+        mdio_write(tp, 0x06, 0xe427);
+        mdio_write(tp, 0x06, 0xeee4);
+        mdio_write(tp, 0x06, 0x2623);
+        mdio_write(tp, 0x06, 0xe5e4);
+        mdio_write(tp, 0x06, 0x27fc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8dad);
+        mdio_write(tp, 0x06, 0x2014);
+        mdio_write(tp, 0x06, 0xee8b);
+        mdio_write(tp, 0x06, 0x8d00);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0x5a78);
+        mdio_write(tp, 0x06, 0x039e);
+        mdio_write(tp, 0x06, 0x0902);
+        mdio_write(tp, 0x06, 0x05e8);
+        mdio_write(tp, 0x06, 0x0281);
+        mdio_write(tp, 0x06, 0x4f02);
+        mdio_write(tp, 0x06, 0x326c);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x1df6);
+        mdio_write(tp, 0x06, 0x20e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x022f);
+        mdio_write(tp, 0x06, 0x0902);
+        mdio_write(tp, 0x06, 0x2ab0);
+        mdio_write(tp, 0x06, 0x0285);
+        mdio_write(tp, 0x06, 0x1602);
+        mdio_write(tp, 0x06, 0x03ba);
+        mdio_write(tp, 0x06, 0x0284);
+        mdio_write(tp, 0x06, 0xe502);
+        mdio_write(tp, 0x06, 0x2df1);
+        mdio_write(tp, 0x06, 0x0283);
+        mdio_write(tp, 0x06, 0x8302);
+        mdio_write(tp, 0x06, 0x0475);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x210b);
+        mdio_write(tp, 0x06, 0xf621);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x83f8);
+        mdio_write(tp, 0x06, 0x021c);
+        mdio_write(tp, 0x06, 0x99e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad22);
+        mdio_write(tp, 0x06, 0x08f6);
+        mdio_write(tp, 0x06, 0x22e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x0235);
+        mdio_write(tp, 0x06, 0x63e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad23);
+        mdio_write(tp, 0x06, 0x08f6);
+        mdio_write(tp, 0x06, 0x23e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x0231);
+        mdio_write(tp, 0x06, 0x57e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad24);
+        mdio_write(tp, 0x06, 0x05f6);
+        mdio_write(tp, 0x06, 0x24e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2505);
+        mdio_write(tp, 0x06, 0xf625);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8ee0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad26);
+        mdio_write(tp, 0x06, 0x08f6);
+        mdio_write(tp, 0x06, 0x26e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x022d);
+        mdio_write(tp, 0x06, 0x1ce0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x05f6);
+        mdio_write(tp, 0x06, 0x27e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x0203);
+        mdio_write(tp, 0x06, 0x80fc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9e0);
+        mdio_write(tp, 0x06, 0x8b81);
+        mdio_write(tp, 0x06, 0xac26);
+        mdio_write(tp, 0x06, 0x1ae0);
+        mdio_write(tp, 0x06, 0x8b81);
+        mdio_write(tp, 0x06, 0xac21);
+        mdio_write(tp, 0x06, 0x14e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xac20);
+        mdio_write(tp, 0x06, 0x0ee0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xac23);
+        mdio_write(tp, 0x06, 0x08e0);
+        mdio_write(tp, 0x06, 0x8b87);
+        mdio_write(tp, 0x06, 0xac24);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x3802);
+        mdio_write(tp, 0x06, 0x1ac2);
+        mdio_write(tp, 0x06, 0xeee4);
+        mdio_write(tp, 0x06, 0x1c04);
+        mdio_write(tp, 0x06, 0xeee4);
+        mdio_write(tp, 0x06, 0x1d04);
+        mdio_write(tp, 0x06, 0xe2e0);
+        mdio_write(tp, 0x06, 0x7ce3);
+        mdio_write(tp, 0x06, 0xe07d);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x38e1);
+        mdio_write(tp, 0x06, 0xe039);
+        mdio_write(tp, 0x06, 0xad2e);
+        mdio_write(tp, 0x06, 0x1bad);
+        mdio_write(tp, 0x06, 0x390d);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf22);
+        mdio_write(tp, 0x06, 0x7a02);
+        mdio_write(tp, 0x06, 0x387d);
+        mdio_write(tp, 0x06, 0x0281);
+        mdio_write(tp, 0x06, 0xacae);
+        mdio_write(tp, 0x06, 0x0bac);
+        mdio_write(tp, 0x06, 0x3802);
+        mdio_write(tp, 0x06, 0xae06);
+        mdio_write(tp, 0x06, 0x0281);
+        mdio_write(tp, 0x06, 0xe902);
+        mdio_write(tp, 0x06, 0x822e);
+        mdio_write(tp, 0x06, 0x021a);
+        mdio_write(tp, 0x06, 0xd3fd);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e1);
+        mdio_write(tp, 0x06, 0x8af4);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x2602);
+        mdio_write(tp, 0x06, 0xf728);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x2105);
+        mdio_write(tp, 0x06, 0x0222);
+        mdio_write(tp, 0x06, 0x8ef7);
+        mdio_write(tp, 0x06, 0x29e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x0502);
+        mdio_write(tp, 0x06, 0x14b8);
+        mdio_write(tp, 0x06, 0xf72a);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x85ad);
+        mdio_write(tp, 0x06, 0x2305);
+        mdio_write(tp, 0x06, 0x0212);
+        mdio_write(tp, 0x06, 0xf4f7);
+        mdio_write(tp, 0x06, 0x2be0);
+        mdio_write(tp, 0x06, 0x8b87);
+        mdio_write(tp, 0x06, 0xad24);
+        mdio_write(tp, 0x06, 0x0502);
+        mdio_write(tp, 0x06, 0x8284);
+        mdio_write(tp, 0x06, 0xf72c);
+        mdio_write(tp, 0x06, 0xe58a);
+        mdio_write(tp, 0x06, 0xf4fc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x2600);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x2109);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xf4ac);
+        mdio_write(tp, 0x06, 0x2003);
+        mdio_write(tp, 0x06, 0x0222);
+        mdio_write(tp, 0x06, 0x7de0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x09e0);
+        mdio_write(tp, 0x06, 0x8af4);
+        mdio_write(tp, 0x06, 0xac21);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0x1408);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x85ad);
+        mdio_write(tp, 0x06, 0x2309);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xf4ac);
+        mdio_write(tp, 0x06, 0x2203);
+        mdio_write(tp, 0x06, 0x0213);
+        mdio_write(tp, 0x06, 0x07e0);
+        mdio_write(tp, 0x06, 0x8b87);
+        mdio_write(tp, 0x06, 0xad24);
+        mdio_write(tp, 0x06, 0x09e0);
+        mdio_write(tp, 0x06, 0x8af4);
+        mdio_write(tp, 0x06, 0xac23);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0x8289);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e1);
+        mdio_write(tp, 0x06, 0x8af4);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x2602);
+        mdio_write(tp, 0x06, 0xf628);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ad);
+        mdio_write(tp, 0x06, 0x210a);
+        mdio_write(tp, 0x06, 0xe083);
+        mdio_write(tp, 0x06, 0xecf6);
+        mdio_write(tp, 0x06, 0x27a0);
+        mdio_write(tp, 0x06, 0x0502);
+        mdio_write(tp, 0x06, 0xf629);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x85ad);
+        mdio_write(tp, 0x06, 0x2008);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xe8ad);
+        mdio_write(tp, 0x06, 0x2102);
+        mdio_write(tp, 0x06, 0xf62a);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x85ad);
+        mdio_write(tp, 0x06, 0x2308);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x20a0);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0xf62b);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x87ad);
+        mdio_write(tp, 0x06, 0x2408);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xc2a0);
+        mdio_write(tp, 0x06, 0x0302);
+        mdio_write(tp, 0x06, 0xf62c);
+        mdio_write(tp, 0x06, 0xe58a);
+        mdio_write(tp, 0x06, 0xf4a1);
+        mdio_write(tp, 0x06, 0x0008);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf22);
+        mdio_write(tp, 0x06, 0x7a02);
+        mdio_write(tp, 0x06, 0x387d);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0xc200);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x87ad);
+        mdio_write(tp, 0x06, 0x241e);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xc2a0);
+        mdio_write(tp, 0x06, 0x0005);
+        mdio_write(tp, 0x06, 0x0282);
+        mdio_write(tp, 0x06, 0xb0ae);
+        mdio_write(tp, 0x06, 0xf5a0);
+        mdio_write(tp, 0x06, 0x0105);
+        mdio_write(tp, 0x06, 0x0282);
+        mdio_write(tp, 0x06, 0xc0ae);
+        mdio_write(tp, 0x06, 0x0ba0);
+        mdio_write(tp, 0x06, 0x0205);
+        mdio_write(tp, 0x06, 0x0282);
+        mdio_write(tp, 0x06, 0xcaae);
+        mdio_write(tp, 0x06, 0x03a0);
+        mdio_write(tp, 0x06, 0x0300);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0x0282);
+        mdio_write(tp, 0x06, 0xe1ee);
+        mdio_write(tp, 0x06, 0x8ac2);
+        mdio_write(tp, 0x06, 0x01ef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8ee);
+        mdio_write(tp, 0x06, 0x8ac9);
+        mdio_write(tp, 0x06, 0x0002);
+        mdio_write(tp, 0x06, 0x8317);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8ac8);
+        mdio_write(tp, 0x06, 0xe18a);
+        mdio_write(tp, 0x06, 0xc91f);
+        mdio_write(tp, 0x06, 0x019e);
+        mdio_write(tp, 0x06, 0x0611);
+        mdio_write(tp, 0x06, 0xe58a);
+        mdio_write(tp, 0x06, 0xc9ae);
+        mdio_write(tp, 0x06, 0x04ee);
+        mdio_write(tp, 0x06, 0x8ac2);
+        mdio_write(tp, 0x06, 0x01fc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0xfbbf);
+        mdio_write(tp, 0x06, 0x8ac4);
+        mdio_write(tp, 0x06, 0xef79);
+        mdio_write(tp, 0x06, 0xd200);
+        mdio_write(tp, 0x06, 0xd400);
+        mdio_write(tp, 0x06, 0x221e);
+        mdio_write(tp, 0x06, 0x02bf);
+        mdio_write(tp, 0x06, 0x3024);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x7dbf);
+        mdio_write(tp, 0x06, 0x13ff);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x500d);
+        mdio_write(tp, 0x06, 0x4559);
+        mdio_write(tp, 0x06, 0x1fef);
+        mdio_write(tp, 0x06, 0x97dd);
+        mdio_write(tp, 0x06, 0xd308);
+        mdio_write(tp, 0x06, 0x1a93);
+        mdio_write(tp, 0x06, 0xdd12);
+        mdio_write(tp, 0x06, 0x17a2);
+        mdio_write(tp, 0x06, 0x04de);
+        mdio_write(tp, 0x06, 0xffef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfdfc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0xfbee);
+        mdio_write(tp, 0x06, 0x8ac2);
+        mdio_write(tp, 0x06, 0x03d5);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x06, 0xbf8a);
+        mdio_write(tp, 0x06, 0xc4ef);
+        mdio_write(tp, 0x06, 0x79ef);
+        mdio_write(tp, 0x06, 0x45bf);
+        mdio_write(tp, 0x06, 0x3024);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x7dbf);
+        mdio_write(tp, 0x06, 0x13ff);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x50ad);
+        mdio_write(tp, 0x06, 0x2702);
+        mdio_write(tp, 0x06, 0x78ff);
+        mdio_write(tp, 0x06, 0xe18a);
+        mdio_write(tp, 0x06, 0xca1b);
+        mdio_write(tp, 0x06, 0x01aa);
+        mdio_write(tp, 0x06, 0x2eef);
+        mdio_write(tp, 0x06, 0x97d9);
+        mdio_write(tp, 0x06, 0x7900);
+        mdio_write(tp, 0x06, 0x9e2b);
+        mdio_write(tp, 0x06, 0x81dd);
+        mdio_write(tp, 0x06, 0xbf85);
+        mdio_write(tp, 0x06, 0xad02);
+        mdio_write(tp, 0x06, 0x387d);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xef02);
+        mdio_write(tp, 0x06, 0x100c);
+        mdio_write(tp, 0x06, 0x11b0);
+        mdio_write(tp, 0x06, 0xfc0d);
+        mdio_write(tp, 0x06, 0x11bf);
+        mdio_write(tp, 0x06, 0x85aa);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x7dd1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x85aa);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x7dee);
+        mdio_write(tp, 0x06, 0x8ac2);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x0413);
+        mdio_write(tp, 0x06, 0xa38b);
+        mdio_write(tp, 0x06, 0xb4d3);
+        mdio_write(tp, 0x06, 0x8012);
+        mdio_write(tp, 0x06, 0x17a2);
+        mdio_write(tp, 0x06, 0x04ad);
+        mdio_write(tp, 0x06, 0xffef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfdfc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad25);
+        mdio_write(tp, 0x06, 0x48e0);
+        mdio_write(tp, 0x06, 0x8a96);
+        mdio_write(tp, 0x06, 0xe18a);
+        mdio_write(tp, 0x06, 0x977c);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x9e35);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0x9600);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0x9700);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0xbee1);
+        mdio_write(tp, 0x06, 0x8abf);
+        mdio_write(tp, 0x06, 0xe28a);
+        mdio_write(tp, 0x06, 0xc0e3);
+        mdio_write(tp, 0x06, 0x8ac1);
+        mdio_write(tp, 0x06, 0x0237);
+        mdio_write(tp, 0x06, 0x74ad);
+        mdio_write(tp, 0x06, 0x2012);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0x9603);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0x97b7);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0xc000);
+        mdio_write(tp, 0x06, 0xee8a);
+        mdio_write(tp, 0x06, 0xc100);
+        mdio_write(tp, 0x06, 0xae11);
+        mdio_write(tp, 0x06, 0x15e6);
+        mdio_write(tp, 0x06, 0x8ac0);
+        mdio_write(tp, 0x06, 0xe78a);
+        mdio_write(tp, 0x06, 0xc1ae);
+        mdio_write(tp, 0x06, 0x08ee);
+        mdio_write(tp, 0x06, 0x8ac0);
+        mdio_write(tp, 0x06, 0x00ee);
+        mdio_write(tp, 0x06, 0x8ac1);
+        mdio_write(tp, 0x06, 0x00fd);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xae20);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0x0000);
+        mdio_write(tp, 0x06, 0xf8fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x00e1);
+        mdio_write(tp, 0x06, 0xe001);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x32e0);
+        mdio_write(tp, 0x06, 0x8b40);
+        mdio_write(tp, 0x06, 0xf720);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x40bf);
+        mdio_write(tp, 0x06, 0x3230);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x50ad);
+        mdio_write(tp, 0x06, 0x2821);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x20e1);
+        mdio_write(tp, 0x06, 0xe021);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x18e0);
+        mdio_write(tp, 0x06, 0x8b40);
+        mdio_write(tp, 0x06, 0xf620);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x40ee);
+        mdio_write(tp, 0x06, 0x8b3b);
+        mdio_write(tp, 0x06, 0xffe0);
+        mdio_write(tp, 0x06, 0x8a8a);
+        mdio_write(tp, 0x06, 0xe18a);
+        mdio_write(tp, 0x06, 0x8be4);
+        mdio_write(tp, 0x06, 0xe000);
+        mdio_write(tp, 0x06, 0xe5e0);
+        mdio_write(tp, 0x06, 0x01ef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8f9);
+        mdio_write(tp, 0x06, 0xface);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69fa);
+        mdio_write(tp, 0x06, 0xd401);
+        mdio_write(tp, 0x06, 0x55b4);
+        mdio_write(tp, 0x06, 0xfebf);
+        mdio_write(tp, 0x06, 0x1c1e);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x50ac);
+        mdio_write(tp, 0x06, 0x280b);
+        mdio_write(tp, 0x06, 0xbf1c);
+        mdio_write(tp, 0x06, 0x1b02);
+        mdio_write(tp, 0x06, 0x3850);
+        mdio_write(tp, 0x06, 0xac28);
+        mdio_write(tp, 0x06, 0x49ae);
+        mdio_write(tp, 0x06, 0x64bf);
+        mdio_write(tp, 0x06, 0x1c1b);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x50ac);
+        mdio_write(tp, 0x06, 0x285b);
+        mdio_write(tp, 0x06, 0xd000);
+        mdio_write(tp, 0x06, 0x0284);
+        mdio_write(tp, 0x06, 0xcaac);
+        mdio_write(tp, 0x06, 0x2105);
+        mdio_write(tp, 0x06, 0xac22);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x4ebf);
+        mdio_write(tp, 0x06, 0xe0c4);
+        mdio_write(tp, 0x06, 0xbe85);
+        mdio_write(tp, 0x06, 0xf6d2);
+        mdio_write(tp, 0x06, 0x04d8);
+        mdio_write(tp, 0x06, 0x19d9);
+        mdio_write(tp, 0x06, 0x1907);
+        mdio_write(tp, 0x06, 0xdc19);
+        mdio_write(tp, 0x06, 0xdd19);
+        mdio_write(tp, 0x06, 0x0789);
+        mdio_write(tp, 0x06, 0x89ef);
+        mdio_write(tp, 0x06, 0x645e);
+        mdio_write(tp, 0x06, 0x07ff);
+        mdio_write(tp, 0x06, 0x0d65);
+        mdio_write(tp, 0x06, 0x5cf8);
+        mdio_write(tp, 0x06, 0x001e);
+        mdio_write(tp, 0x06, 0x46dc);
+        mdio_write(tp, 0x06, 0x19dd);
+        mdio_write(tp, 0x06, 0x19b2);
+        mdio_write(tp, 0x06, 0xe2d4);
+        mdio_write(tp, 0x06, 0x0001);
+        mdio_write(tp, 0x06, 0xbf1c);
+        mdio_write(tp, 0x06, 0x1b02);
+        mdio_write(tp, 0x06, 0x387d);
+        mdio_write(tp, 0x06, 0xae1d);
+        mdio_write(tp, 0x06, 0xbee0);
+        mdio_write(tp, 0x06, 0xc4bf);
+        mdio_write(tp, 0x06, 0x85f6);
+        mdio_write(tp, 0x06, 0xd204);
+        mdio_write(tp, 0x06, 0xd819);
+        mdio_write(tp, 0x06, 0xd919);
+        mdio_write(tp, 0x06, 0x07dc);
+        mdio_write(tp, 0x06, 0x19dd);
+        mdio_write(tp, 0x06, 0x1907);
+        mdio_write(tp, 0x06, 0xb2f4);
+        mdio_write(tp, 0x06, 0xd400);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x1c1b);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x7dfe);
+        mdio_write(tp, 0x06, 0xef96);
+        mdio_write(tp, 0x06, 0xfec6);
+        mdio_write(tp, 0x06, 0xfefd);
+        mdio_write(tp, 0x06, 0xfc05);
+        mdio_write(tp, 0x06, 0xf9e2);
+        mdio_write(tp, 0x06, 0xe0ea);
+        mdio_write(tp, 0x06, 0xe3e0);
+        mdio_write(tp, 0x06, 0xeb5a);
+        mdio_write(tp, 0x06, 0x070c);
+        mdio_write(tp, 0x06, 0x031e);
+        mdio_write(tp, 0x06, 0x20e6);
+        mdio_write(tp, 0x06, 0xe0ea);
+        mdio_write(tp, 0x06, 0xe7e0);
+        mdio_write(tp, 0x06, 0xebe0);
+        mdio_write(tp, 0x06, 0xe0fc);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0xfdfd);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69e0);
+        mdio_write(tp, 0x06, 0x8b80);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x22bf);
+        mdio_write(tp, 0x06, 0x4616);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x50e0);
+        mdio_write(tp, 0x06, 0x8b44);
+        mdio_write(tp, 0x06, 0x1f01);
+        mdio_write(tp, 0x06, 0x9e15);
+        mdio_write(tp, 0x06, 0xe58b);
+        mdio_write(tp, 0x06, 0x44ad);
+        mdio_write(tp, 0x06, 0x2907);
+        mdio_write(tp, 0x06, 0xac28);
+        mdio_write(tp, 0x06, 0x04d1);
+        mdio_write(tp, 0x06, 0x01ae);
+        mdio_write(tp, 0x06, 0x02d1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x85b0);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x7def);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad26);
+        mdio_write(tp, 0x06, 0x30e0);
+        mdio_write(tp, 0x06, 0xe036);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0x37e1);
+        mdio_write(tp, 0x06, 0x8b3f);
+        mdio_write(tp, 0x06, 0x1f10);
+        mdio_write(tp, 0x06, 0x9e23);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x3fac);
+        mdio_write(tp, 0x06, 0x200b);
+        mdio_write(tp, 0x06, 0xac21);
+        mdio_write(tp, 0x06, 0x0dac);
+        mdio_write(tp, 0x06, 0x250f);
+        mdio_write(tp, 0x06, 0xac27);
+        mdio_write(tp, 0x06, 0x11ae);
+        mdio_write(tp, 0x06, 0x1202);
+        mdio_write(tp, 0x06, 0x2c47);
+        mdio_write(tp, 0x06, 0xae0d);
+        mdio_write(tp, 0x06, 0x0285);
+        mdio_write(tp, 0x06, 0x4fae);
+        mdio_write(tp, 0x06, 0x0802);
+        mdio_write(tp, 0x06, 0x2c69);
+        mdio_write(tp, 0x06, 0xae03);
+        mdio_write(tp, 0x06, 0x022c);
+        mdio_write(tp, 0x06, 0x7cfc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x6902);
+        mdio_write(tp, 0x06, 0x856c);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x14e1);
+        mdio_write(tp, 0x06, 0xe015);
+        mdio_write(tp, 0x06, 0xad26);
+        mdio_write(tp, 0x06, 0x08d1);
+        mdio_write(tp, 0x06, 0x1ebf);
+        mdio_write(tp, 0x06, 0x2cd9);
+        mdio_write(tp, 0x06, 0x0238);
+        mdio_write(tp, 0x06, 0x7def);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x2fd0);
+        mdio_write(tp, 0x06, 0x0b02);
+        mdio_write(tp, 0x06, 0x3682);
+        mdio_write(tp, 0x06, 0x5882);
+        mdio_write(tp, 0x06, 0x7882);
+        mdio_write(tp, 0x06, 0x9f24);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x32e1);
+        mdio_write(tp, 0x06, 0x8b33);
+        mdio_write(tp, 0x06, 0x1f10);
+        mdio_write(tp, 0x06, 0x9e1a);
+        mdio_write(tp, 0x06, 0x10e4);
+        mdio_write(tp, 0x06, 0x8b32);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x28e1);
+        mdio_write(tp, 0x06, 0xe029);
+        mdio_write(tp, 0x06, 0xf72c);
+        mdio_write(tp, 0x06, 0xe4e0);
+        mdio_write(tp, 0x06, 0x28e5);
+        mdio_write(tp, 0x06, 0xe029);
+        mdio_write(tp, 0x06, 0xf62c);
+        mdio_write(tp, 0x06, 0xe4e0);
+        mdio_write(tp, 0x06, 0x28e5);
+        mdio_write(tp, 0x06, 0xe029);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0x00e1);
+        mdio_write(tp, 0x06, 0x4077);
+        mdio_write(tp, 0x06, 0xe140);
+        mdio_write(tp, 0x06, 0x52e0);
+        mdio_write(tp, 0x06, 0xeed9);
+        mdio_write(tp, 0x06, 0xe04c);
+        mdio_write(tp, 0x06, 0xbbe0);
+        mdio_write(tp, 0x06, 0x2a00);
+        mdio_write(tp, 0x05, 0xe142);
+        gphy_val = mdio_read(tp, 0x06);
+        gphy_val |= BIT_0;
+        mdio_write(tp,0x06, gphy_val);
+        mdio_write(tp, 0x05, 0xe140);
+        gphy_val = mdio_read(tp, 0x06);
+        gphy_val |= BIT_0;
+        mdio_write(tp,0x06, gphy_val);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp,0x1f, 0x0005);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x00);
+                if (gphy_val & BIT_7)
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        gphy_val = mdio_read(tp, 0x17);
+        gphy_val |= BIT_1;
+        if (tp->RequiredSecLanDonglePatch)
+                gphy_val &= ~BIT_2;
+        mdio_write(tp, 0x17, gphy_val);
+        mdio_write(tp, 0x1f, 0x0000);
+
+        mdio_write(tp, 0x1F, 0x0003);
+        mdio_write(tp, 0x09, 0xA20F);
+        mdio_write(tp, 0x1F, 0x0000);
+        mdio_write(tp, 0x1f, 0x0003);
+        mdio_write(tp, 0x01, 0x328A);
+        mdio_write(tp, 0x1f, 0x0000);
+
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x00, 0x9200);
+}
+
+static void
+rtl8168_set_phy_mcu_8168f_2(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp,0x1f, 0x0000);
+        mdio_write(tp,0x00, 0x1800);
+        gphy_val = mdio_read(tp, 0x15);
+        gphy_val &= ~(BIT_12);
+        mdio_write(tp,0x15, gphy_val);
+        mdio_write(tp,0x00, 0x4800);
+        mdio_write(tp,0x1f, 0x0007);
+        mdio_write(tp,0x1e, 0x002f);
+        for (i = 0; i < 1000; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x1c);
+                if (gphy_val & 0x0080)
+                        break;
+        }
+        mdio_write(tp,0x1f, 0x0000);
+        mdio_write(tp,0x00, 0x1800);
+        mdio_write(tp,0x1f, 0x0007);
+        mdio_write(tp,0x1e, 0x0023);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x18);
+                if (!(gphy_val & 0x0001))
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0307);
+        mdio_write(tp, 0x15, 0x0098);
+        mdio_write(tp, 0x19, 0x7c0b);
+        mdio_write(tp, 0x15, 0x0099);
+        mdio_write(tp, 0x19, 0x6c0b);
+        mdio_write(tp, 0x15, 0x00eb);
+        mdio_write(tp, 0x19, 0x6c0b);
+        mdio_write(tp, 0x15, 0x00f8);
+        mdio_write(tp, 0x19, 0x6f0b);
+        mdio_write(tp, 0x15, 0x00fe);
+        mdio_write(tp, 0x19, 0x6f0f);
+        mdio_write(tp, 0x15, 0x00db);
+        mdio_write(tp, 0x19, 0x6f09);
+        mdio_write(tp, 0x15, 0x00dc);
+        mdio_write(tp, 0x19, 0xaefd);
+        mdio_write(tp, 0x15, 0x00dd);
+        mdio_write(tp, 0x19, 0x6f0b);
+        mdio_write(tp, 0x15, 0x00de);
+        mdio_write(tp, 0x19, 0xc60b);
+        mdio_write(tp, 0x15, 0x00df);
+        mdio_write(tp, 0x19, 0x00fa);
+        mdio_write(tp, 0x15, 0x00e0);
+        mdio_write(tp, 0x19, 0x30e1);
+        mdio_write(tp, 0x15, 0x020c);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x020e);
+        mdio_write(tp, 0x19, 0x9813);
+        mdio_write(tp, 0x15, 0x020f);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x0210);
+        mdio_write(tp, 0x19, 0x930f);
+        mdio_write(tp, 0x15, 0x0211);
+        mdio_write(tp, 0x19, 0x9206);
+        mdio_write(tp, 0x15, 0x0212);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0213);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0214);
+        mdio_write(tp, 0x19, 0x588f);
+        mdio_write(tp, 0x15, 0x0215);
+        mdio_write(tp, 0x19, 0x5520);
+        mdio_write(tp, 0x15, 0x0216);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x0217);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0218);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0219);
+        mdio_write(tp, 0x19, 0x588d);
+        mdio_write(tp, 0x15, 0x021a);
+        mdio_write(tp, 0x19, 0x5540);
+        mdio_write(tp, 0x15, 0x021b);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x021c);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x021d);
+        mdio_write(tp, 0x19, 0x6840);
+        mdio_write(tp, 0x15, 0x021e);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x021f);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0220);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x0221);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x0222);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x0223);
+        mdio_write(tp, 0x19, 0x6840);
+        mdio_write(tp, 0x15, 0x0224);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0225);
+        mdio_write(tp, 0x19, 0x3231);
+        mdio_write(tp, 0x15, 0x0000);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0300);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x05, 0x8000);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0x48f7);
+        mdio_write(tp, 0x06, 0x00e0);
+        mdio_write(tp, 0x06, 0xfff7);
+        mdio_write(tp, 0x06, 0xa080);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0xf602);
+        mdio_write(tp, 0x06, 0x011b);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x2802);
+        mdio_write(tp, 0x06, 0x0135);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x4502);
+        mdio_write(tp, 0x06, 0x015f);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0x6b02);
+        mdio_write(tp, 0x06, 0x80e5);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x88e1);
+        mdio_write(tp, 0x06, 0x8b89);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8a1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8b);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8c1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8e1e);
+        mdio_write(tp, 0x06, 0x01a0);
+        mdio_write(tp, 0x06, 0x00c7);
+        mdio_write(tp, 0x06, 0xaebb);
+        mdio_write(tp, 0x06, 0xbf8b);
+        mdio_write(tp, 0x06, 0x88ec);
+        mdio_write(tp, 0x06, 0x0019);
+        mdio_write(tp, 0x06, 0xa98b);
+        mdio_write(tp, 0x06, 0x90f9);
+        mdio_write(tp, 0x06, 0xeeff);
+        mdio_write(tp, 0x06, 0xf600);
+        mdio_write(tp, 0x06, 0xeeff);
+        mdio_write(tp, 0x06, 0xf7fe);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf81);
+        mdio_write(tp, 0x06, 0x9802);
+        mdio_write(tp, 0x06, 0x39f3);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf81);
+        mdio_write(tp, 0x06, 0x9b02);
+        mdio_write(tp, 0x06, 0x39f3);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8dad);
+        mdio_write(tp, 0x06, 0x2014);
+        mdio_write(tp, 0x06, 0xee8b);
+        mdio_write(tp, 0x06, 0x8d00);
+        mdio_write(tp, 0x06, 0xe08a);
+        mdio_write(tp, 0x06, 0x5a78);
+        mdio_write(tp, 0x06, 0x039e);
+        mdio_write(tp, 0x06, 0x0902);
+        mdio_write(tp, 0x06, 0x05fc);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0x8802);
+        mdio_write(tp, 0x06, 0x32dd);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8f9);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ac);
+        mdio_write(tp, 0x06, 0x261a);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x81ac);
+        mdio_write(tp, 0x06, 0x2114);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x85ac);
+        mdio_write(tp, 0x06, 0x200e);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x85ac);
+        mdio_write(tp, 0x06, 0x2308);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x87ac);
+        mdio_write(tp, 0x06, 0x2402);
+        mdio_write(tp, 0x06, 0xae38);
+        mdio_write(tp, 0x06, 0x021a);
+        mdio_write(tp, 0x06, 0xd6ee);
+        mdio_write(tp, 0x06, 0xe41c);
+        mdio_write(tp, 0x06, 0x04ee);
+        mdio_write(tp, 0x06, 0xe41d);
+        mdio_write(tp, 0x06, 0x04e2);
+        mdio_write(tp, 0x06, 0xe07c);
+        mdio_write(tp, 0x06, 0xe3e0);
+        mdio_write(tp, 0x06, 0x7de0);
+        mdio_write(tp, 0x06, 0xe038);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0x39ad);
+        mdio_write(tp, 0x06, 0x2e1b);
+        mdio_write(tp, 0x06, 0xad39);
+        mdio_write(tp, 0x06, 0x0dd1);
+        mdio_write(tp, 0x06, 0x01bf);
+        mdio_write(tp, 0x06, 0x22c8);
+        mdio_write(tp, 0x06, 0x0239);
+        mdio_write(tp, 0x06, 0xf302);
+        mdio_write(tp, 0x06, 0x21f0);
+        mdio_write(tp, 0x06, 0xae0b);
+        mdio_write(tp, 0x06, 0xac38);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x0602);
+        mdio_write(tp, 0x06, 0x222d);
+        mdio_write(tp, 0x06, 0x0222);
+        mdio_write(tp, 0x06, 0x7202);
+        mdio_write(tp, 0x06, 0x1ae7);
+        mdio_write(tp, 0x06, 0xfdfc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x201a);
+        mdio_write(tp, 0x06, 0xf620);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x2afe);
+        mdio_write(tp, 0x06, 0x022c);
+        mdio_write(tp, 0x06, 0x5c02);
+        mdio_write(tp, 0x06, 0x03c5);
+        mdio_write(tp, 0x06, 0x0281);
+        mdio_write(tp, 0x06, 0x6702);
+        mdio_write(tp, 0x06, 0x2e4f);
+        mdio_write(tp, 0x06, 0x0204);
+        mdio_write(tp, 0x06, 0x8902);
+        mdio_write(tp, 0x06, 0x2f7a);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x210b);
+        mdio_write(tp, 0x06, 0xf621);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x0445);
+        mdio_write(tp, 0x06, 0x021c);
+        mdio_write(tp, 0x06, 0xb8e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad22);
+        mdio_write(tp, 0x06, 0x08f6);
+        mdio_write(tp, 0x06, 0x22e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x0235);
+        mdio_write(tp, 0x06, 0xd4e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad23);
+        mdio_write(tp, 0x06, 0x08f6);
+        mdio_write(tp, 0x06, 0x23e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x0231);
+        mdio_write(tp, 0x06, 0xc8e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad24);
+        mdio_write(tp, 0x06, 0x05f6);
+        mdio_write(tp, 0x06, 0x24e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2505);
+        mdio_write(tp, 0x06, 0xf625);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8ee0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad26);
+        mdio_write(tp, 0x06, 0x08f6);
+        mdio_write(tp, 0x06, 0x26e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x022d);
+        mdio_write(tp, 0x06, 0x6ae0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x05f6);
+        mdio_write(tp, 0x06, 0x27e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x0203);
+        mdio_write(tp, 0x06, 0x8bfc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69e0);
+        mdio_write(tp, 0x06, 0x8b80);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x22bf);
+        mdio_write(tp, 0x06, 0x479a);
+        mdio_write(tp, 0x06, 0x0239);
+        mdio_write(tp, 0x06, 0xc6e0);
+        mdio_write(tp, 0x06, 0x8b44);
+        mdio_write(tp, 0x06, 0x1f01);
+        mdio_write(tp, 0x06, 0x9e15);
+        mdio_write(tp, 0x06, 0xe58b);
+        mdio_write(tp, 0x06, 0x44ad);
+        mdio_write(tp, 0x06, 0x2907);
+        mdio_write(tp, 0x06, 0xac28);
+        mdio_write(tp, 0x06, 0x04d1);
+        mdio_write(tp, 0x06, 0x01ae);
+        mdio_write(tp, 0x06, 0x02d1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x819e);
+        mdio_write(tp, 0x06, 0x0239);
+        mdio_write(tp, 0x06, 0xf3ef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0x00e1);
+        mdio_write(tp, 0x06, 0x4077);
+        mdio_write(tp, 0x06, 0xe140);
+        mdio_write(tp, 0x06, 0xbbe0);
+        mdio_write(tp, 0x06, 0x2a00);
+        mdio_write(tp, 0x05, 0xe142);
+        gphy_val = mdio_read(tp, 0x06);
+        gphy_val |= BIT_0;
+        mdio_write(tp, 0x06, gphy_val);
+        mdio_write(tp, 0x05, 0xe140);
+        gphy_val = mdio_read(tp, 0x06);
+        gphy_val |= BIT_0;
+        mdio_write(tp, 0x06, gphy_val);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp,0x1f, 0x0005);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x00);
+                if (gphy_val & BIT_7)
+                        break;
+        }
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        gphy_val = mdio_read(tp, 0x17);
+        gphy_val |= BIT_1;
+        if (tp->RequiredSecLanDonglePatch)
+                gphy_val &= ~BIT_2;
+        mdio_write(tp, 0x17, gphy_val);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x00, 0x9200);
+}
+
+static void
+rtl8168_set_phy_mcu_8411_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp,0x1f, 0x0000);
+        mdio_write(tp,0x00, 0x1800);
+        gphy_val = mdio_read(tp, 0x15);
+        gphy_val &= ~(BIT_12);
+        mdio_write(tp,0x15, gphy_val);
+        mdio_write(tp,0x00, 0x4800);
+        mdio_write(tp,0x1f, 0x0007);
+        mdio_write(tp,0x1e, 0x002f);
+        for (i = 0; i < 1000; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x1c);
+                if (gphy_val & 0x0080)
+                        break;
+        }
+        mdio_write(tp,0x1f, 0x0000);
+        mdio_write(tp,0x00, 0x1800);
+        mdio_write(tp,0x1f, 0x0007);
+        mdio_write(tp,0x1e, 0x0023);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x18);
+                if (!(gphy_val & 0x0001))
+                        break;
+        }
+        mdio_write(tp,0x1f, 0x0005);
+        mdio_write(tp,0x05, 0xfff6);
+        mdio_write(tp,0x06, 0x0080);
+        mdio_write(tp, 0x1f, 0x0007);
+        mdio_write(tp, 0x1e, 0x0023);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0307);
+        mdio_write(tp, 0x15, 0x0098);
+        mdio_write(tp, 0x19, 0x7c0b);
+        mdio_write(tp, 0x15, 0x0099);
+        mdio_write(tp, 0x19, 0x6c0b);
+        mdio_write(tp, 0x15, 0x00eb);
+        mdio_write(tp, 0x19, 0x6c0b);
+        mdio_write(tp, 0x15, 0x00f8);
+        mdio_write(tp, 0x19, 0x6f0b);
+        mdio_write(tp, 0x15, 0x00fe);
+        mdio_write(tp, 0x19, 0x6f0f);
+        mdio_write(tp, 0x15, 0x00db);
+        mdio_write(tp, 0x19, 0x6f09);
+        mdio_write(tp, 0x15, 0x00dc);
+        mdio_write(tp, 0x19, 0xaefd);
+        mdio_write(tp, 0x15, 0x00dd);
+        mdio_write(tp, 0x19, 0x6f0b);
+        mdio_write(tp, 0x15, 0x00de);
+        mdio_write(tp, 0x19, 0xc60b);
+        mdio_write(tp, 0x15, 0x00df);
+        mdio_write(tp, 0x19, 0x00fa);
+        mdio_write(tp, 0x15, 0x00e0);
+        mdio_write(tp, 0x19, 0x30e1);
+        mdio_write(tp, 0x15, 0x020c);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x020e);
+        mdio_write(tp, 0x19, 0x9813);
+        mdio_write(tp, 0x15, 0x020f);
+        mdio_write(tp, 0x19, 0x7801);
+        mdio_write(tp, 0x15, 0x0210);
+        mdio_write(tp, 0x19, 0x930f);
+        mdio_write(tp, 0x15, 0x0211);
+        mdio_write(tp, 0x19, 0x9206);
+        mdio_write(tp, 0x15, 0x0212);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0213);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0214);
+        mdio_write(tp, 0x19, 0x588f);
+        mdio_write(tp, 0x15, 0x0215);
+        mdio_write(tp, 0x19, 0x5520);
+        mdio_write(tp, 0x15, 0x0216);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x0217);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0218);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0219);
+        mdio_write(tp, 0x19, 0x588d);
+        mdio_write(tp, 0x15, 0x021a);
+        mdio_write(tp, 0x19, 0x5540);
+        mdio_write(tp, 0x15, 0x021b);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x021c);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x021d);
+        mdio_write(tp, 0x19, 0x6840);
+        mdio_write(tp, 0x15, 0x021e);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x021f);
+        mdio_write(tp, 0x19, 0x4002);
+        mdio_write(tp, 0x15, 0x0220);
+        mdio_write(tp, 0x19, 0x3224);
+        mdio_write(tp, 0x15, 0x0221);
+        mdio_write(tp, 0x19, 0x9e03);
+        mdio_write(tp, 0x15, 0x0222);
+        mdio_write(tp, 0x19, 0x7c40);
+        mdio_write(tp, 0x15, 0x0223);
+        mdio_write(tp, 0x19, 0x6840);
+        mdio_write(tp, 0x15, 0x0224);
+        mdio_write(tp, 0x19, 0x7800);
+        mdio_write(tp, 0x15, 0x0225);
+        mdio_write(tp, 0x19, 0x3231);
+        mdio_write(tp, 0x15, 0x0000);
+        mdio_write(tp, 0x16, 0x0306);
+        mdio_write(tp, 0x16, 0x0300);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp, 0x1f, 0x0005);
+        mdio_write(tp, 0x05, 0xfff6);
+        mdio_write(tp, 0x06, 0x0080);
+        mdio_write(tp, 0x05, 0x8000);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0x48f7);
+        mdio_write(tp, 0x06, 0x00e0);
+        mdio_write(tp, 0x06, 0xfff7);
+        mdio_write(tp, 0x06, 0xa080);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0xf602);
+        mdio_write(tp, 0x06, 0x011e);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x2b02);
+        mdio_write(tp, 0x06, 0x8077);
+        mdio_write(tp, 0x06, 0x0201);
+        mdio_write(tp, 0x06, 0x4802);
+        mdio_write(tp, 0x06, 0x0162);
+        mdio_write(tp, 0x06, 0x0280);
+        mdio_write(tp, 0x06, 0x9402);
+        mdio_write(tp, 0x06, 0x810e);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x88e1);
+        mdio_write(tp, 0x06, 0x8b89);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8a1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8b);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8c1e);
+        mdio_write(tp, 0x06, 0x01e1);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0x1e01);
+        mdio_write(tp, 0x06, 0xe18b);
+        mdio_write(tp, 0x06, 0x8e1e);
+        mdio_write(tp, 0x06, 0x01a0);
+        mdio_write(tp, 0x06, 0x00c7);
+        mdio_write(tp, 0x06, 0xaebb);
+        mdio_write(tp, 0x06, 0xd481);
+        mdio_write(tp, 0x06, 0xd4e4);
+        mdio_write(tp, 0x06, 0x8b92);
+        mdio_write(tp, 0x06, 0xe58b);
+        mdio_write(tp, 0x06, 0x9302);
+        mdio_write(tp, 0x06, 0x2e5a);
+        mdio_write(tp, 0x06, 0xbf8b);
+        mdio_write(tp, 0x06, 0x88ec);
+        mdio_write(tp, 0x06, 0x0019);
+        mdio_write(tp, 0x06, 0xa98b);
+        mdio_write(tp, 0x06, 0x90f9);
+        mdio_write(tp, 0x06, 0xeeff);
+        mdio_write(tp, 0x06, 0xf600);
+        mdio_write(tp, 0x06, 0xeeff);
+        mdio_write(tp, 0x06, 0xf7fc);
+        mdio_write(tp, 0x06, 0xd100);
+        mdio_write(tp, 0x06, 0xbf83);
+        mdio_write(tp, 0x06, 0x3c02);
+        mdio_write(tp, 0x06, 0x3a21);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf83);
+        mdio_write(tp, 0x06, 0x3f02);
+        mdio_write(tp, 0x06, 0x3a21);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8aad);
+        mdio_write(tp, 0x06, 0x2014);
+        mdio_write(tp, 0x06, 0xee8b);
+        mdio_write(tp, 0x06, 0x8a00);
+        mdio_write(tp, 0x06, 0x0220);
+        mdio_write(tp, 0x06, 0x8be0);
+        mdio_write(tp, 0x06, 0xe426);
+        mdio_write(tp, 0x06, 0xe1e4);
+        mdio_write(tp, 0x06, 0x27ee);
+        mdio_write(tp, 0x06, 0xe426);
+        mdio_write(tp, 0x06, 0x23e5);
+        mdio_write(tp, 0x06, 0xe427);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x14ee);
+        mdio_write(tp, 0x06, 0x8b8d);
+        mdio_write(tp, 0x06, 0x00e0);
+        mdio_write(tp, 0x06, 0x8a5a);
+        mdio_write(tp, 0x06, 0x7803);
+        mdio_write(tp, 0x06, 0x9e09);
+        mdio_write(tp, 0x06, 0x0206);
+        mdio_write(tp, 0x06, 0x2802);
+        mdio_write(tp, 0x06, 0x80b1);
+        mdio_write(tp, 0x06, 0x0232);
+        mdio_write(tp, 0x06, 0xfdfc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xf9e0);
+        mdio_write(tp, 0x06, 0x8b81);
+        mdio_write(tp, 0x06, 0xac26);
+        mdio_write(tp, 0x06, 0x1ae0);
+        mdio_write(tp, 0x06, 0x8b81);
+        mdio_write(tp, 0x06, 0xac21);
+        mdio_write(tp, 0x06, 0x14e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xac20);
+        mdio_write(tp, 0x06, 0x0ee0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xac23);
+        mdio_write(tp, 0x06, 0x08e0);
+        mdio_write(tp, 0x06, 0x8b87);
+        mdio_write(tp, 0x06, 0xac24);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x3802);
+        mdio_write(tp, 0x06, 0x1b02);
+        mdio_write(tp, 0x06, 0xeee4);
+        mdio_write(tp, 0x06, 0x1c04);
+        mdio_write(tp, 0x06, 0xeee4);
+        mdio_write(tp, 0x06, 0x1d04);
+        mdio_write(tp, 0x06, 0xe2e0);
+        mdio_write(tp, 0x06, 0x7ce3);
+        mdio_write(tp, 0x06, 0xe07d);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x38e1);
+        mdio_write(tp, 0x06, 0xe039);
+        mdio_write(tp, 0x06, 0xad2e);
+        mdio_write(tp, 0x06, 0x1bad);
+        mdio_write(tp, 0x06, 0x390d);
+        mdio_write(tp, 0x06, 0xd101);
+        mdio_write(tp, 0x06, 0xbf22);
+        mdio_write(tp, 0x06, 0xe802);
+        mdio_write(tp, 0x06, 0x3a21);
+        mdio_write(tp, 0x06, 0x0222);
+        mdio_write(tp, 0x06, 0x10ae);
+        mdio_write(tp, 0x06, 0x0bac);
+        mdio_write(tp, 0x06, 0x3802);
+        mdio_write(tp, 0x06, 0xae06);
+        mdio_write(tp, 0x06, 0x0222);
+        mdio_write(tp, 0x06, 0x4d02);
+        mdio_write(tp, 0x06, 0x2292);
+        mdio_write(tp, 0x06, 0x021b);
+        mdio_write(tp, 0x06, 0x13fd);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x1af6);
+        mdio_write(tp, 0x06, 0x20e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x022b);
+        mdio_write(tp, 0x06, 0x1e02);
+        mdio_write(tp, 0x06, 0x82ae);
+        mdio_write(tp, 0x06, 0x0203);
+        mdio_write(tp, 0x06, 0xc002);
+        mdio_write(tp, 0x06, 0x827d);
+        mdio_write(tp, 0x06, 0x022e);
+        mdio_write(tp, 0x06, 0x6f02);
+        mdio_write(tp, 0x06, 0x047b);
+        mdio_write(tp, 0x06, 0x022f);
+        mdio_write(tp, 0x06, 0x9ae0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad21);
+        mdio_write(tp, 0x06, 0x0bf6);
+        mdio_write(tp, 0x06, 0x21e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0x0281);
+        mdio_write(tp, 0x06, 0x9002);
+        mdio_write(tp, 0x06, 0x1cd9);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2208);
+        mdio_write(tp, 0x06, 0xf622);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x35f4);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2308);
+        mdio_write(tp, 0x06, 0xf623);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x31e8);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2405);
+        mdio_write(tp, 0x06, 0xf624);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8ee0);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xad25);
+        mdio_write(tp, 0x06, 0x05f6);
+        mdio_write(tp, 0x06, 0x25e4);
+        mdio_write(tp, 0x06, 0x8b8e);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2608);
+        mdio_write(tp, 0x06, 0xf626);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x2d8a);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x8ead);
+        mdio_write(tp, 0x06, 0x2705);
+        mdio_write(tp, 0x06, 0xf627);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x8e02);
+        mdio_write(tp, 0x06, 0x0386);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8fa);
+        mdio_write(tp, 0x06, 0xef69);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x00e1);
+        mdio_write(tp, 0x06, 0xe001);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x32e0);
+        mdio_write(tp, 0x06, 0x8b40);
+        mdio_write(tp, 0x06, 0xf720);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x40bf);
+        mdio_write(tp, 0x06, 0x32c1);
+        mdio_write(tp, 0x06, 0x0239);
+        mdio_write(tp, 0x06, 0xf4ad);
+        mdio_write(tp, 0x06, 0x2821);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x20e1);
+        mdio_write(tp, 0x06, 0xe021);
+        mdio_write(tp, 0x06, 0xad20);
+        mdio_write(tp, 0x06, 0x18e0);
+        mdio_write(tp, 0x06, 0x8b40);
+        mdio_write(tp, 0x06, 0xf620);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x40ee);
+        mdio_write(tp, 0x06, 0x8b3b);
+        mdio_write(tp, 0x06, 0xffe0);
+        mdio_write(tp, 0x06, 0x8a8a);
+        mdio_write(tp, 0x06, 0xe18a);
+        mdio_write(tp, 0x06, 0x8be4);
+        mdio_write(tp, 0x06, 0xe000);
+        mdio_write(tp, 0x06, 0xe5e0);
+        mdio_write(tp, 0x06, 0x01ef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8f9);
+        mdio_write(tp, 0x06, 0xface);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69fa);
+        mdio_write(tp, 0x06, 0xd401);
+        mdio_write(tp, 0x06, 0x55b4);
+        mdio_write(tp, 0x06, 0xfebf);
+        mdio_write(tp, 0x06, 0x1c5e);
+        mdio_write(tp, 0x06, 0x0239);
+        mdio_write(tp, 0x06, 0xf4ac);
+        mdio_write(tp, 0x06, 0x280b);
+        mdio_write(tp, 0x06, 0xbf1c);
+        mdio_write(tp, 0x06, 0x5b02);
+        mdio_write(tp, 0x06, 0x39f4);
+        mdio_write(tp, 0x06, 0xac28);
+        mdio_write(tp, 0x06, 0x49ae);
+        mdio_write(tp, 0x06, 0x64bf);
+        mdio_write(tp, 0x06, 0x1c5b);
+        mdio_write(tp, 0x06, 0x0239);
+        mdio_write(tp, 0x06, 0xf4ac);
+        mdio_write(tp, 0x06, 0x285b);
+        mdio_write(tp, 0x06, 0xd000);
+        mdio_write(tp, 0x06, 0x0282);
+        mdio_write(tp, 0x06, 0x62ac);
+        mdio_write(tp, 0x06, 0x2105);
+        mdio_write(tp, 0x06, 0xac22);
+        mdio_write(tp, 0x06, 0x02ae);
+        mdio_write(tp, 0x06, 0x4ebf);
+        mdio_write(tp, 0x06, 0xe0c4);
+        mdio_write(tp, 0x06, 0xbe85);
+        mdio_write(tp, 0x06, 0xecd2);
+        mdio_write(tp, 0x06, 0x04d8);
+        mdio_write(tp, 0x06, 0x19d9);
+        mdio_write(tp, 0x06, 0x1907);
+        mdio_write(tp, 0x06, 0xdc19);
+        mdio_write(tp, 0x06, 0xdd19);
+        mdio_write(tp, 0x06, 0x0789);
+        mdio_write(tp, 0x06, 0x89ef);
+        mdio_write(tp, 0x06, 0x645e);
+        mdio_write(tp, 0x06, 0x07ff);
+        mdio_write(tp, 0x06, 0x0d65);
+        mdio_write(tp, 0x06, 0x5cf8);
+        mdio_write(tp, 0x06, 0x001e);
+        mdio_write(tp, 0x06, 0x46dc);
+        mdio_write(tp, 0x06, 0x19dd);
+        mdio_write(tp, 0x06, 0x19b2);
+        mdio_write(tp, 0x06, 0xe2d4);
+        mdio_write(tp, 0x06, 0x0001);
+        mdio_write(tp, 0x06, 0xbf1c);
+        mdio_write(tp, 0x06, 0x5b02);
+        mdio_write(tp, 0x06, 0x3a21);
+        mdio_write(tp, 0x06, 0xae1d);
+        mdio_write(tp, 0x06, 0xbee0);
+        mdio_write(tp, 0x06, 0xc4bf);
+        mdio_write(tp, 0x06, 0x85ec);
+        mdio_write(tp, 0x06, 0xd204);
+        mdio_write(tp, 0x06, 0xd819);
+        mdio_write(tp, 0x06, 0xd919);
+        mdio_write(tp, 0x06, 0x07dc);
+        mdio_write(tp, 0x06, 0x19dd);
+        mdio_write(tp, 0x06, 0x1907);
+        mdio_write(tp, 0x06, 0xb2f4);
+        mdio_write(tp, 0x06, 0xd400);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x1c5b);
+        mdio_write(tp, 0x06, 0x023a);
+        mdio_write(tp, 0x06, 0x21fe);
+        mdio_write(tp, 0x06, 0xef96);
+        mdio_write(tp, 0x06, 0xfec6);
+        mdio_write(tp, 0x06, 0xfefd);
+        mdio_write(tp, 0x06, 0xfc05);
+        mdio_write(tp, 0x06, 0xf9e2);
+        mdio_write(tp, 0x06, 0xe0ea);
+        mdio_write(tp, 0x06, 0xe3e0);
+        mdio_write(tp, 0x06, 0xeb5a);
+        mdio_write(tp, 0x06, 0x070c);
+        mdio_write(tp, 0x06, 0x031e);
+        mdio_write(tp, 0x06, 0x20e6);
+        mdio_write(tp, 0x06, 0xe0ea);
+        mdio_write(tp, 0x06, 0xe7e0);
+        mdio_write(tp, 0x06, 0xebe0);
+        mdio_write(tp, 0x06, 0xe0fc);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0xfdfd);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x69e0);
+        mdio_write(tp, 0x06, 0x8b80);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x22bf);
+        mdio_write(tp, 0x06, 0x47ba);
+        mdio_write(tp, 0x06, 0x0239);
+        mdio_write(tp, 0x06, 0xf4e0);
+        mdio_write(tp, 0x06, 0x8b44);
+        mdio_write(tp, 0x06, 0x1f01);
+        mdio_write(tp, 0x06, 0x9e15);
+        mdio_write(tp, 0x06, 0xe58b);
+        mdio_write(tp, 0x06, 0x44ad);
+        mdio_write(tp, 0x06, 0x2907);
+        mdio_write(tp, 0x06, 0xac28);
+        mdio_write(tp, 0x06, 0x04d1);
+        mdio_write(tp, 0x06, 0x01ae);
+        mdio_write(tp, 0x06, 0x02d1);
+        mdio_write(tp, 0x06, 0x00bf);
+        mdio_write(tp, 0x06, 0x8342);
+        mdio_write(tp, 0x06, 0x023a);
+        mdio_write(tp, 0x06, 0x21ef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad26);
+        mdio_write(tp, 0x06, 0x30e0);
+        mdio_write(tp, 0x06, 0xe036);
+        mdio_write(tp, 0x06, 0xe1e0);
+        mdio_write(tp, 0x06, 0x37e1);
+        mdio_write(tp, 0x06, 0x8b3f);
+        mdio_write(tp, 0x06, 0x1f10);
+        mdio_write(tp, 0x06, 0x9e23);
+        mdio_write(tp, 0x06, 0xe48b);
+        mdio_write(tp, 0x06, 0x3fac);
+        mdio_write(tp, 0x06, 0x200b);
+        mdio_write(tp, 0x06, 0xac21);
+        mdio_write(tp, 0x06, 0x0dac);
+        mdio_write(tp, 0x06, 0x250f);
+        mdio_write(tp, 0x06, 0xac27);
+        mdio_write(tp, 0x06, 0x11ae);
+        mdio_write(tp, 0x06, 0x1202);
+        mdio_write(tp, 0x06, 0x2cb5);
+        mdio_write(tp, 0x06, 0xae0d);
+        mdio_write(tp, 0x06, 0x0282);
+        mdio_write(tp, 0x06, 0xe7ae);
+        mdio_write(tp, 0x06, 0x0802);
+        mdio_write(tp, 0x06, 0x2cd7);
+        mdio_write(tp, 0x06, 0xae03);
+        mdio_write(tp, 0x06, 0x022c);
+        mdio_write(tp, 0x06, 0xeafc);
+        mdio_write(tp, 0x06, 0x04f8);
+        mdio_write(tp, 0x06, 0xfaef);
+        mdio_write(tp, 0x06, 0x6902);
+        mdio_write(tp, 0x06, 0x8304);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x14e1);
+        mdio_write(tp, 0x06, 0xe015);
+        mdio_write(tp, 0x06, 0xad26);
+        mdio_write(tp, 0x06, 0x08d1);
+        mdio_write(tp, 0x06, 0x1ebf);
+        mdio_write(tp, 0x06, 0x2d47);
+        mdio_write(tp, 0x06, 0x023a);
+        mdio_write(tp, 0x06, 0x21ef);
+        mdio_write(tp, 0x06, 0x96fe);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0xf8e0);
+        mdio_write(tp, 0x06, 0x8b85);
+        mdio_write(tp, 0x06, 0xad27);
+        mdio_write(tp, 0x06, 0x2fd0);
+        mdio_write(tp, 0x06, 0x0b02);
+        mdio_write(tp, 0x06, 0x3826);
+        mdio_write(tp, 0x06, 0x5882);
+        mdio_write(tp, 0x06, 0x7882);
+        mdio_write(tp, 0x06, 0x9f24);
+        mdio_write(tp, 0x06, 0xe08b);
+        mdio_write(tp, 0x06, 0x32e1);
+        mdio_write(tp, 0x06, 0x8b33);
+        mdio_write(tp, 0x06, 0x1f10);
+        mdio_write(tp, 0x06, 0x9e1a);
+        mdio_write(tp, 0x06, 0x10e4);
+        mdio_write(tp, 0x06, 0x8b32);
+        mdio_write(tp, 0x06, 0xe0e0);
+        mdio_write(tp, 0x06, 0x28e1);
+        mdio_write(tp, 0x06, 0xe029);
+        mdio_write(tp, 0x06, 0xf72c);
+        mdio_write(tp, 0x06, 0xe4e0);
+        mdio_write(tp, 0x06, 0x28e5);
+        mdio_write(tp, 0x06, 0xe029);
+        mdio_write(tp, 0x06, 0xf62c);
+        mdio_write(tp, 0x06, 0xe4e0);
+        mdio_write(tp, 0x06, 0x28e5);
+        mdio_write(tp, 0x06, 0xe029);
+        mdio_write(tp, 0x06, 0xfc04);
+        mdio_write(tp, 0x06, 0x00e1);
+        mdio_write(tp, 0x06, 0x4077);
+        mdio_write(tp, 0x06, 0xe140);
+        mdio_write(tp, 0x06, 0xbbe0);
+        mdio_write(tp, 0x06, 0x2a00);
+        mdio_write(tp, 0x05, 0xe142);
+        gphy_val = mdio_read(tp, 0x06);
+        gphy_val |= BIT_0;
+        mdio_write(tp,0x06, gphy_val);
+        mdio_write(tp, 0x05, 0xe140);
+        gphy_val = mdio_read(tp, 0x06);
+        gphy_val |= BIT_0;
+        mdio_write(tp,0x06, gphy_val);
+        mdio_write(tp, 0x1f, 0x0000);
+        mdio_write(tp,0x1f, 0x0005);
+        for (i = 0; i < 200; i++) {
+                udelay(100);
+                gphy_val = mdio_read(tp, 0x00);
+                if (gphy_val & BIT_7)
+                        break;
+        }
+        mdio_write(tp,0x1f, 0x0007);
+        mdio_write(tp,0x1e, 0x0023);
+        gphy_val = mdio_read(tp, 0x17);
+        gphy_val |= BIT_1;
+        if (tp->RequiredSecLanDonglePatch)
+                gphy_val &= ~BIT_2;
+        mdio_write(tp,0x17, gphy_val);
+        mdio_write(tp,0x1f, 0x0000);
+
+        mdio_write(tp, 0x1F, 0x0003);
+        mdio_write(tp, 0x09, 0xA20F);
+        mdio_write(tp, 0x1F, 0x0000);
+        mdio_write(tp, 0x1f, 0x0003);
+        mdio_write(tp, 0x01, 0x328A);
+        mdio_write(tp, 0x1f, 0x0000);
+
+        mdio_write(tp,0x1f, 0x0000);
+        mdio_write(tp,0x00, 0x9200);
+}
+
+static void
+rtl8168_set_phy_mcu_8168g_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val |= BIT_4;
+        mdio_write(tp, 0x10, gphy_val);
+        mdio_write(tp, 0x1f, 0x0B80);
+        for (i = 0; i < 10; i++) {
+                if (mdio_read(tp, 0x10) & 0x0040)
+                        break;
+                mdelay(10);
+        }
+        mdio_write(tp, 0x1f, 0x0A43);
+        mdio_write(tp, 0x13, 0x8146);
+        mdio_write(tp, 0x14, 0x2300);
+        mdio_write(tp, 0x13, 0xB820);
+        mdio_write(tp, 0x14, 0x0210);
+
+        mdio_write(tp, 0x1F, 0x0A43);
+        mdio_write(tp, 0x13, 0xB820);
+        mdio_write(tp, 0x14, 0x0290);
+        mdio_write(tp, 0x13, 0xA012);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x13, 0xA014);
+        mdio_write(tp, 0x14, 0x2c04);
+        mdio_write(tp, 0x14, 0x2c0c);
+        mdio_write(tp, 0x14, 0x2c6c);
+        mdio_write(tp, 0x14, 0x2d0d);
+        mdio_write(tp, 0x14, 0x31ce);
+        mdio_write(tp, 0x14, 0x506d);
+        mdio_write(tp, 0x14, 0xd708);
+        mdio_write(tp, 0x14, 0x3108);
+        mdio_write(tp, 0x14, 0x106d);
+        mdio_write(tp, 0x14, 0x1560);
+        mdio_write(tp, 0x14, 0x15a9);
+        mdio_write(tp, 0x14, 0x206e);
+        mdio_write(tp, 0x14, 0x175b);
+        mdio_write(tp, 0x14, 0x6062);
+        mdio_write(tp, 0x14, 0xd700);
+        mdio_write(tp, 0x14, 0x5fae);
+        mdio_write(tp, 0x14, 0xd708);
+        mdio_write(tp, 0x14, 0x3107);
+        mdio_write(tp, 0x14, 0x4c1e);
+        mdio_write(tp, 0x14, 0x4169);
+        mdio_write(tp, 0x14, 0x316a);
+        mdio_write(tp, 0x14, 0x0c19);
+        mdio_write(tp, 0x14, 0x31aa);
+        mdio_write(tp, 0x14, 0x0c19);
+        mdio_write(tp, 0x14, 0x2c1b);
+        mdio_write(tp, 0x14, 0x5e62);
+        mdio_write(tp, 0x14, 0x26b5);
+        mdio_write(tp, 0x14, 0x31ab);
+        mdio_write(tp, 0x14, 0x5c1e);
+        mdio_write(tp, 0x14, 0x2c0c);
+        mdio_write(tp, 0x14, 0xc040);
+        mdio_write(tp, 0x14, 0x8808);
+        mdio_write(tp, 0x14, 0xc520);
+        mdio_write(tp, 0x14, 0xc421);
+        mdio_write(tp, 0x14, 0xd05a);
+        mdio_write(tp, 0x14, 0xd19a);
+        mdio_write(tp, 0x14, 0xd709);
+        mdio_write(tp, 0x14, 0x608f);
+        mdio_write(tp, 0x14, 0xd06b);
+        mdio_write(tp, 0x14, 0xd18a);
+        mdio_write(tp, 0x14, 0x2c2c);
+        mdio_write(tp, 0x14, 0xd0be);
+        mdio_write(tp, 0x14, 0xd188);
+        mdio_write(tp, 0x14, 0x2c2c);
+        mdio_write(tp, 0x14, 0xd708);
+        mdio_write(tp, 0x14, 0x4072);
+        mdio_write(tp, 0x14, 0xc104);
+        mdio_write(tp, 0x14, 0x2c3e);
+        mdio_write(tp, 0x14, 0x4076);
+        mdio_write(tp, 0x14, 0xc110);
+        mdio_write(tp, 0x14, 0x2c3e);
+        mdio_write(tp, 0x14, 0x4071);
+        mdio_write(tp, 0x14, 0xc102);
+        mdio_write(tp, 0x14, 0x2c3e);
+        mdio_write(tp, 0x14, 0x4070);
+        mdio_write(tp, 0x14, 0xc101);
+        mdio_write(tp, 0x14, 0x2c3e);
+        mdio_write(tp, 0x14, 0x175b);
+        mdio_write(tp, 0x14, 0xd709);
+        mdio_write(tp, 0x14, 0x3390);
+        mdio_write(tp, 0x14, 0x5c39);
+        mdio_write(tp, 0x14, 0x2c4e);
+        mdio_write(tp, 0x14, 0x175b);
+        mdio_write(tp, 0x14, 0xd708);
+        mdio_write(tp, 0x14, 0x6193);
+        mdio_write(tp, 0x14, 0xd709);
+        mdio_write(tp, 0x14, 0x5f9d);
+        mdio_write(tp, 0x14, 0x408b);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x6042);
+        mdio_write(tp, 0x14, 0xb401);
+        mdio_write(tp, 0x14, 0x175b);
+        mdio_write(tp, 0x14, 0xd708);
+        mdio_write(tp, 0x14, 0x6073);
+        mdio_write(tp, 0x14, 0x5fbc);
+        mdio_write(tp, 0x14, 0x2c4d);
+        mdio_write(tp, 0x14, 0x26ed);
+        mdio_write(tp, 0x14, 0xb280);
+        mdio_write(tp, 0x14, 0xa841);
+        mdio_write(tp, 0x14, 0x9420);
+        mdio_write(tp, 0x14, 0x8710);
+        mdio_write(tp, 0x14, 0xd709);
+        mdio_write(tp, 0x14, 0x42ec);
+        mdio_write(tp, 0x14, 0x606d);
+        mdio_write(tp, 0x14, 0xd207);
+        mdio_write(tp, 0x14, 0x2c57);
+        mdio_write(tp, 0x14, 0xd203);
+        mdio_write(tp, 0x14, 0x33ff);
+        mdio_write(tp, 0x14, 0x563b);
+        mdio_write(tp, 0x14, 0x3275);
+        mdio_write(tp, 0x14, 0x7c5e);
+        mdio_write(tp, 0x14, 0xb240);
+        mdio_write(tp, 0x14, 0xb402);
+        mdio_write(tp, 0x14, 0x263b);
+        mdio_write(tp, 0x14, 0x6096);
+        mdio_write(tp, 0x14, 0xb240);
+        mdio_write(tp, 0x14, 0xb406);
+        mdio_write(tp, 0x14, 0x263b);
+        mdio_write(tp, 0x14, 0x31d7);
+        mdio_write(tp, 0x14, 0x7c67);
+        mdio_write(tp, 0x14, 0xb240);
+        mdio_write(tp, 0x14, 0xb40e);
+        mdio_write(tp, 0x14, 0x263b);
+        mdio_write(tp, 0x14, 0xb410);
+        mdio_write(tp, 0x14, 0x8802);
+        mdio_write(tp, 0x14, 0xb240);
+        mdio_write(tp, 0x14, 0x940e);
+        mdio_write(tp, 0x14, 0x263b);
+        mdio_write(tp, 0x14, 0xba04);
+        mdio_write(tp, 0x14, 0x1cd6);
+        mdio_write(tp, 0x14, 0xa902);
+        mdio_write(tp, 0x14, 0xd711);
+        mdio_write(tp, 0x14, 0x4045);
+        mdio_write(tp, 0x14, 0xa980);
+        mdio_write(tp, 0x14, 0x3003);
+        mdio_write(tp, 0x14, 0x59b1);
+        mdio_write(tp, 0x14, 0xa540);
+        mdio_write(tp, 0x14, 0xa601);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4043);
+        mdio_write(tp, 0x14, 0xa910);
+        mdio_write(tp, 0x14, 0xd711);
+        mdio_write(tp, 0x14, 0x60a0);
+        mdio_write(tp, 0x14, 0xca33);
+        mdio_write(tp, 0x14, 0xcb33);
+        mdio_write(tp, 0x14, 0xa941);
+        mdio_write(tp, 0x14, 0x2c82);
+        mdio_write(tp, 0x14, 0xcaff);
+        mdio_write(tp, 0x14, 0xcbff);
+        mdio_write(tp, 0x14, 0xa921);
+        mdio_write(tp, 0x14, 0xce02);
+        mdio_write(tp, 0x14, 0xe070);
+        mdio_write(tp, 0x14, 0x0f10);
+        mdio_write(tp, 0x14, 0xaf01);
+        mdio_write(tp, 0x14, 0x8f01);
+        mdio_write(tp, 0x14, 0x1766);
+        mdio_write(tp, 0x14, 0x8e02);
+        mdio_write(tp, 0x14, 0x1787);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x609c);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7fa4);
+        mdio_write(tp, 0x14, 0x2cd4);
+        mdio_write(tp, 0x14, 0x1ce9);
+        mdio_write(tp, 0x14, 0xce04);
+        mdio_write(tp, 0x14, 0xe070);
+        mdio_write(tp, 0x14, 0x0f20);
+        mdio_write(tp, 0x14, 0xaf01);
+        mdio_write(tp, 0x14, 0x8f01);
+        mdio_write(tp, 0x14, 0x1766);
+        mdio_write(tp, 0x14, 0x8e04);
+        mdio_write(tp, 0x14, 0x6044);
+        mdio_write(tp, 0x14, 0x2cd4);
+        mdio_write(tp, 0x14, 0xa520);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4043);
+        mdio_write(tp, 0x14, 0x2cc1);
+        mdio_write(tp, 0x14, 0xe00f);
+        mdio_write(tp, 0x14, 0x0501);
+        mdio_write(tp, 0x14, 0x1cef);
+        mdio_write(tp, 0x14, 0xb801);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x4060);
+        mdio_write(tp, 0x14, 0x7fc4);
+        mdio_write(tp, 0x14, 0x2cd4);
+        mdio_write(tp, 0x14, 0x1cf5);
+        mdio_write(tp, 0x14, 0xe00f);
+        mdio_write(tp, 0x14, 0x0502);
+        mdio_write(tp, 0x14, 0x1cef);
+        mdio_write(tp, 0x14, 0xb802);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x4061);
+        mdio_write(tp, 0x14, 0x7fc4);
+        mdio_write(tp, 0x14, 0x2cd4);
+        mdio_write(tp, 0x14, 0x1cf5);
+        mdio_write(tp, 0x14, 0xe00f);
+        mdio_write(tp, 0x14, 0x0504);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x6099);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7fa4);
+        mdio_write(tp, 0x14, 0x2cd4);
+        mdio_write(tp, 0x14, 0xc17f);
+        mdio_write(tp, 0x14, 0xc200);
+        mdio_write(tp, 0x14, 0xc43f);
+        mdio_write(tp, 0x14, 0xcc03);
+        mdio_write(tp, 0x14, 0xa701);
+        mdio_write(tp, 0x14, 0xa510);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4018);
+        mdio_write(tp, 0x14, 0x9910);
+        mdio_write(tp, 0x14, 0x8510);
+        mdio_write(tp, 0x14, 0x2860);
+        mdio_write(tp, 0x14, 0xe00f);
+        mdio_write(tp, 0x14, 0x0504);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x6099);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7fa4);
+        mdio_write(tp, 0x14, 0x2cd4);
+        mdio_write(tp, 0x14, 0xa608);
+        mdio_write(tp, 0x14, 0xc17d);
+        mdio_write(tp, 0x14, 0xc200);
+        mdio_write(tp, 0x14, 0xc43f);
+        mdio_write(tp, 0x14, 0xcc03);
+        mdio_write(tp, 0x14, 0xa701);
+        mdio_write(tp, 0x14, 0xa510);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4018);
+        mdio_write(tp, 0x14, 0x9910);
+        mdio_write(tp, 0x14, 0x8510);
+        mdio_write(tp, 0x14, 0x2926);
+        mdio_write(tp, 0x14, 0x1792);
+        mdio_write(tp, 0x14, 0x27db);
+        mdio_write(tp, 0x14, 0xc000);
+        mdio_write(tp, 0x14, 0xc100);
+        mdio_write(tp, 0x14, 0xc200);
+        mdio_write(tp, 0x14, 0xc300);
+        mdio_write(tp, 0x14, 0xc400);
+        mdio_write(tp, 0x14, 0xc500);
+        mdio_write(tp, 0x14, 0xc600);
+        mdio_write(tp, 0x14, 0xc7c1);
+        mdio_write(tp, 0x14, 0xc800);
+        mdio_write(tp, 0x14, 0xcc00);
+        mdio_write(tp, 0x14, 0x0800);
+        mdio_write(tp, 0x14, 0xca0f);
+        mdio_write(tp, 0x14, 0xcbff);
+        mdio_write(tp, 0x14, 0xa901);
+        mdio_write(tp, 0x14, 0x8902);
+        mdio_write(tp, 0x14, 0xc900);
+        mdio_write(tp, 0x14, 0xca00);
+        mdio_write(tp, 0x14, 0xcb00);
+        mdio_write(tp, 0x14, 0x0800);
+        mdio_write(tp, 0x14, 0xb804);
+        mdio_write(tp, 0x14, 0x0800);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x6044);
+        mdio_write(tp, 0x14, 0x9804);
+        mdio_write(tp, 0x14, 0x0800);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x6099);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7fa4);
+        mdio_write(tp, 0x14, 0x2cd4);
+        mdio_write(tp, 0x14, 0x0800);
+        mdio_write(tp, 0x14, 0xa510);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x6098);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7fa4);
+        mdio_write(tp, 0x14, 0x2cd4);
+        mdio_write(tp, 0x14, 0x8510);
+        mdio_write(tp, 0x14, 0x0800);
+        mdio_write(tp, 0x14, 0xd711);
+        mdio_write(tp, 0x14, 0x3003);
+        mdio_write(tp, 0x14, 0x1d01);
+        mdio_write(tp, 0x14, 0x2d0b);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x60be);
+        mdio_write(tp, 0x14, 0xe060);
+        mdio_write(tp, 0x14, 0x0920);
+        mdio_write(tp, 0x14, 0x1cd6);
+        mdio_write(tp, 0x14, 0x2c89);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x3063);
+        mdio_write(tp, 0x14, 0x1948);
+        mdio_write(tp, 0x14, 0x288a);
+        mdio_write(tp, 0x14, 0x1cd6);
+        mdio_write(tp, 0x14, 0x29bd);
+        mdio_write(tp, 0x14, 0xa802);
+        mdio_write(tp, 0x14, 0xa303);
+        mdio_write(tp, 0x14, 0x843f);
+        mdio_write(tp, 0x14, 0x81ff);
+        mdio_write(tp, 0x14, 0x8208);
+        mdio_write(tp, 0x14, 0xa201);
+        mdio_write(tp, 0x14, 0xc001);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x30a0);
+        mdio_write(tp, 0x14, 0x0d1c);
+        mdio_write(tp, 0x14, 0x30a0);
+        mdio_write(tp, 0x14, 0x3d13);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7f4c);
+        mdio_write(tp, 0x14, 0x2ab6);
+        mdio_write(tp, 0x14, 0xe003);
+        mdio_write(tp, 0x14, 0x0202);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x6090);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7fac);
+        mdio_write(tp, 0x14, 0x2ab6);
+        mdio_write(tp, 0x14, 0xa20c);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x6091);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7fac);
+        mdio_write(tp, 0x14, 0x2ab6);
+        mdio_write(tp, 0x14, 0x820e);
+        mdio_write(tp, 0x14, 0xa3e0);
+        mdio_write(tp, 0x14, 0xa520);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x609d);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7fac);
+        mdio_write(tp, 0x14, 0x2ab6);
+        mdio_write(tp, 0x14, 0x8520);
+        mdio_write(tp, 0x14, 0x6703);
+        mdio_write(tp, 0x14, 0x2d34);
+        mdio_write(tp, 0x14, 0xa13e);
+        mdio_write(tp, 0x14, 0xc001);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4000);
+        mdio_write(tp, 0x14, 0x6046);
+        mdio_write(tp, 0x14, 0x2d0d);
+        mdio_write(tp, 0x14, 0xa43f);
+        mdio_write(tp, 0x14, 0xa101);
+        mdio_write(tp, 0x14, 0xc020);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x3121);
+        mdio_write(tp, 0x14, 0x0d45);
+        mdio_write(tp, 0x14, 0x30c0);
+        mdio_write(tp, 0x14, 0x3d0d);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7f4c);
+        mdio_write(tp, 0x14, 0x2ab6);
+        mdio_write(tp, 0x14, 0xa540);
+        mdio_write(tp, 0x14, 0xc001);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4001);
+        mdio_write(tp, 0x14, 0xe00f);
+        mdio_write(tp, 0x14, 0x0501);
+        mdio_write(tp, 0x14, 0x1dac);
+        mdio_write(tp, 0x14, 0xc1c4);
+        mdio_write(tp, 0x14, 0xa268);
+        mdio_write(tp, 0x14, 0xa303);
+        mdio_write(tp, 0x14, 0x8420);
+        mdio_write(tp, 0x14, 0xe00f);
+        mdio_write(tp, 0x14, 0x0502);
+        mdio_write(tp, 0x14, 0x1dac);
+        mdio_write(tp, 0x14, 0xc002);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4000);
+        mdio_write(tp, 0x14, 0x8208);
+        mdio_write(tp, 0x14, 0x8410);
+        mdio_write(tp, 0x14, 0xa121);
+        mdio_write(tp, 0x14, 0xc002);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4000);
+        mdio_write(tp, 0x14, 0x8120);
+        mdio_write(tp, 0x14, 0x8180);
+        mdio_write(tp, 0x14, 0x1d97);
+        mdio_write(tp, 0x14, 0xa180);
+        mdio_write(tp, 0x14, 0xa13a);
+        mdio_write(tp, 0x14, 0x8240);
+        mdio_write(tp, 0x14, 0xa430);
+        mdio_write(tp, 0x14, 0xc010);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x30e1);
+        mdio_write(tp, 0x14, 0x0abc);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7f8c);
+        mdio_write(tp, 0x14, 0x2ab6);
+        mdio_write(tp, 0x14, 0xa480);
+        mdio_write(tp, 0x14, 0xa230);
+        mdio_write(tp, 0x14, 0xa303);
+        mdio_write(tp, 0x14, 0xc001);
+        mdio_write(tp, 0x14, 0xd70c);
+        mdio_write(tp, 0x14, 0x4124);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x6120);
+        mdio_write(tp, 0x14, 0xd711);
+        mdio_write(tp, 0x14, 0x3128);
+        mdio_write(tp, 0x14, 0x3d76);
+        mdio_write(tp, 0x14, 0x2d70);
+        mdio_write(tp, 0x14, 0xa801);
+        mdio_write(tp, 0x14, 0x2d6c);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4000);
+        mdio_write(tp, 0x14, 0xe018);
+        mdio_write(tp, 0x14, 0x0208);
+        mdio_write(tp, 0x14, 0xa1f8);
+        mdio_write(tp, 0x14, 0x8480);
+        mdio_write(tp, 0x14, 0xc004);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4000);
+        mdio_write(tp, 0x14, 0x6046);
+        mdio_write(tp, 0x14, 0x2d0d);
+        mdio_write(tp, 0x14, 0xa43f);
+        mdio_write(tp, 0x14, 0xa105);
+        mdio_write(tp, 0x14, 0x8228);
+        mdio_write(tp, 0x14, 0xc004);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4000);
+        mdio_write(tp, 0x14, 0x81bc);
+        mdio_write(tp, 0x14, 0xa220);
+        mdio_write(tp, 0x14, 0x1d97);
+        mdio_write(tp, 0x14, 0x8220);
+        mdio_write(tp, 0x14, 0xa1bc);
+        mdio_write(tp, 0x14, 0xc040);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x30e1);
+        mdio_write(tp, 0x14, 0x0abc);
+        mdio_write(tp, 0x14, 0x30e1);
+        mdio_write(tp, 0x14, 0x3d0d);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7f4c);
+        mdio_write(tp, 0x14, 0x2ab6);
+        mdio_write(tp, 0x14, 0xa802);
+        mdio_write(tp, 0x14, 0xd70c);
+        mdio_write(tp, 0x14, 0x4244);
+        mdio_write(tp, 0x14, 0xa301);
+        mdio_write(tp, 0x14, 0xc004);
+        mdio_write(tp, 0x14, 0xd711);
+        mdio_write(tp, 0x14, 0x3128);
+        mdio_write(tp, 0x14, 0x3da5);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x5f80);
+        mdio_write(tp, 0x14, 0xd711);
+        mdio_write(tp, 0x14, 0x3109);
+        mdio_write(tp, 0x14, 0x3da7);
+        mdio_write(tp, 0x14, 0x2dab);
+        mdio_write(tp, 0x14, 0xa801);
+        mdio_write(tp, 0x14, 0x2d9a);
+        mdio_write(tp, 0x14, 0xa802);
+        mdio_write(tp, 0x14, 0xc004);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x4000);
+        mdio_write(tp, 0x14, 0x0800);
+        mdio_write(tp, 0x14, 0xa510);
+        mdio_write(tp, 0x14, 0xd710);
+        mdio_write(tp, 0x14, 0x609a);
+        mdio_write(tp, 0x14, 0xd71e);
+        mdio_write(tp, 0x14, 0x7fac);
+        mdio_write(tp, 0x14, 0x2ab6);
+        mdio_write(tp, 0x14, 0x8510);
+        mdio_write(tp, 0x14, 0x0800);
+        mdio_write(tp, 0x13, 0xA01A);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x13, 0xA006);
+        mdio_write(tp, 0x14, 0x0ad6);
+        mdio_write(tp, 0x13, 0xA004);
+        mdio_write(tp, 0x14, 0x07f5);
+        mdio_write(tp, 0x13, 0xA002);
+        mdio_write(tp, 0x14, 0x06a9);
+        mdio_write(tp, 0x13, 0xA000);
+        mdio_write(tp, 0x14, 0xf069);
+        mdio_write(tp, 0x13, 0xB820);
+        mdio_write(tp, 0x14, 0x0210);
+
+        mdio_write(tp, 0x1F, 0x0A43);
+        mdio_write(tp, 0x13, 0x83a0);
+        mdio_write(tp, 0x14, 0xaf83);
+        mdio_write(tp, 0x14, 0xacaf);
+        mdio_write(tp, 0x14, 0x83b8);
+        mdio_write(tp, 0x14, 0xaf83);
+        mdio_write(tp, 0x14, 0xcdaf);
+        mdio_write(tp, 0x14, 0x83d3);
+        mdio_write(tp, 0x14, 0x0204);
+        mdio_write(tp, 0x14, 0x9a02);
+        mdio_write(tp, 0x14, 0x09a9);
+        mdio_write(tp, 0x14, 0x0284);
+        mdio_write(tp, 0x14, 0x61af);
+        mdio_write(tp, 0x14, 0x02fc);
+        mdio_write(tp, 0x14, 0xad20);
+        mdio_write(tp, 0x14, 0x0302);
+        mdio_write(tp, 0x14, 0x867c);
+        mdio_write(tp, 0x14, 0xad21);
+        mdio_write(tp, 0x14, 0x0302);
+        mdio_write(tp, 0x14, 0x85c9);
+        mdio_write(tp, 0x14, 0xad22);
+        mdio_write(tp, 0x14, 0x0302);
+        mdio_write(tp, 0x14, 0x1bc0);
+        mdio_write(tp, 0x14, 0xaf17);
+        mdio_write(tp, 0x14, 0xe302);
+        mdio_write(tp, 0x14, 0x8703);
+        mdio_write(tp, 0x14, 0xaf18);
+        mdio_write(tp, 0x14, 0x6201);
+        mdio_write(tp, 0x14, 0x06e0);
+        mdio_write(tp, 0x14, 0x8148);
+        mdio_write(tp, 0x14, 0xaf3c);
+        mdio_write(tp, 0x14, 0x69f8);
+        mdio_write(tp, 0x14, 0xf9fa);
+        mdio_write(tp, 0x14, 0xef69);
+        mdio_write(tp, 0x14, 0xee80);
+        mdio_write(tp, 0x14, 0x10f7);
+        mdio_write(tp, 0x14, 0xee80);
+        mdio_write(tp, 0x14, 0x131f);
+        mdio_write(tp, 0x14, 0xd104);
+        mdio_write(tp, 0x14, 0xbf87);
+        mdio_write(tp, 0x14, 0xf302);
+        mdio_write(tp, 0x14, 0x4259);
+        mdio_write(tp, 0x14, 0x0287);
+        mdio_write(tp, 0x14, 0x88bf);
+        mdio_write(tp, 0x14, 0x87cf);
+        mdio_write(tp, 0x14, 0xd7b8);
+        mdio_write(tp, 0x14, 0x22d0);
+        mdio_write(tp, 0x14, 0x0c02);
+        mdio_write(tp, 0x14, 0x4252);
+        mdio_write(tp, 0x14, 0xee80);
+        mdio_write(tp, 0x14, 0xcda0);
+        mdio_write(tp, 0x14, 0xee80);
+        mdio_write(tp, 0x14, 0xce8b);
+        mdio_write(tp, 0x14, 0xee80);
+        mdio_write(tp, 0x14, 0xd1f5);
+        mdio_write(tp, 0x14, 0xee80);
+        mdio_write(tp, 0x14, 0xd2a9);
+        mdio_write(tp, 0x14, 0xee80);
+        mdio_write(tp, 0x14, 0xd30a);
+        mdio_write(tp, 0x14, 0xee80);
+        mdio_write(tp, 0x14, 0xf010);
+        mdio_write(tp, 0x14, 0xee80);
+        mdio_write(tp, 0x14, 0xf38f);
+        mdio_write(tp, 0x14, 0xee81);
+        mdio_write(tp, 0x14, 0x011e);
+        mdio_write(tp, 0x14, 0xee81);
+        mdio_write(tp, 0x14, 0x0b4a);
+        mdio_write(tp, 0x14, 0xee81);
+        mdio_write(tp, 0x14, 0x0c7c);
+        mdio_write(tp, 0x14, 0xee81);
+        mdio_write(tp, 0x14, 0x127f);
+        mdio_write(tp, 0x14, 0xd100);
+        mdio_write(tp, 0x14, 0x0210);
+        mdio_write(tp, 0x14, 0xb5ee);
+        mdio_write(tp, 0x14, 0x8088);
+        mdio_write(tp, 0x14, 0xa4ee);
+        mdio_write(tp, 0x14, 0x8089);
+        mdio_write(tp, 0x14, 0x44ee);
+        mdio_write(tp, 0x14, 0x809a);
+        mdio_write(tp, 0x14, 0xa4ee);
+        mdio_write(tp, 0x14, 0x809b);
+        mdio_write(tp, 0x14, 0x44ee);
+        mdio_write(tp, 0x14, 0x809c);
+        mdio_write(tp, 0x14, 0xa7ee);
+        mdio_write(tp, 0x14, 0x80a5);
+        mdio_write(tp, 0x14, 0xa7d2);
+        mdio_write(tp, 0x14, 0x0002);
+        mdio_write(tp, 0x14, 0x0e66);
+        mdio_write(tp, 0x14, 0x0285);
+        mdio_write(tp, 0x14, 0xc0ee);
+        mdio_write(tp, 0x14, 0x87fc);
+        mdio_write(tp, 0x14, 0x00e0);
+        mdio_write(tp, 0x14, 0x8245);
+        mdio_write(tp, 0x14, 0xf622);
+        mdio_write(tp, 0x14, 0xe482);
+        mdio_write(tp, 0x14, 0x45ef);
+        mdio_write(tp, 0x14, 0x96fe);
+        mdio_write(tp, 0x14, 0xfdfc);
+        mdio_write(tp, 0x14, 0x0402);
+        mdio_write(tp, 0x14, 0x847a);
+        mdio_write(tp, 0x14, 0x0284);
+        mdio_write(tp, 0x14, 0xb302);
+        mdio_write(tp, 0x14, 0x0cab);
+        mdio_write(tp, 0x14, 0x020c);
+        mdio_write(tp, 0x14, 0xc402);
+        mdio_write(tp, 0x14, 0x0cef);
+        mdio_write(tp, 0x14, 0x020d);
+        mdio_write(tp, 0x14, 0x0802);
+        mdio_write(tp, 0x14, 0x0d33);
+        mdio_write(tp, 0x14, 0x020c);
+        mdio_write(tp, 0x14, 0x3d04);
+        mdio_write(tp, 0x14, 0xf8fa);
+        mdio_write(tp, 0x14, 0xef69);
+        mdio_write(tp, 0x14, 0xe182);
+        mdio_write(tp, 0x14, 0x2fac);
+        mdio_write(tp, 0x14, 0x291a);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x24ac);
+        mdio_write(tp, 0x14, 0x2102);
+        mdio_write(tp, 0x14, 0xae22);
+        mdio_write(tp, 0x14, 0x0210);
+        mdio_write(tp, 0x14, 0x57f6);
+        mdio_write(tp, 0x14, 0x21e4);
+        mdio_write(tp, 0x14, 0x8224);
+        mdio_write(tp, 0x14, 0xd101);
+        mdio_write(tp, 0x14, 0xbf44);
+        mdio_write(tp, 0x14, 0xd202);
+        mdio_write(tp, 0x14, 0x4259);
+        mdio_write(tp, 0x14, 0xae10);
+        mdio_write(tp, 0x14, 0x0212);
+        mdio_write(tp, 0x14, 0x4cf6);
+        mdio_write(tp, 0x14, 0x29e5);
+        mdio_write(tp, 0x14, 0x822f);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x24f6);
+        mdio_write(tp, 0x14, 0x21e4);
+        mdio_write(tp, 0x14, 0x8224);
+        mdio_write(tp, 0x14, 0xef96);
+        mdio_write(tp, 0x14, 0xfefc);
+        mdio_write(tp, 0x14, 0x04f8);
+        mdio_write(tp, 0x14, 0xe182);
+        mdio_write(tp, 0x14, 0x2fac);
+        mdio_write(tp, 0x14, 0x2a18);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x24ac);
+        mdio_write(tp, 0x14, 0x2202);
+        mdio_write(tp, 0x14, 0xae26);
+        mdio_write(tp, 0x14, 0x0284);
+        mdio_write(tp, 0x14, 0xf802);
+        mdio_write(tp, 0x14, 0x8565);
+        mdio_write(tp, 0x14, 0xd101);
+        mdio_write(tp, 0x14, 0xbf44);
+        mdio_write(tp, 0x14, 0xd502);
+        mdio_write(tp, 0x14, 0x4259);
+        mdio_write(tp, 0x14, 0xae0e);
+        mdio_write(tp, 0x14, 0x0284);
+        mdio_write(tp, 0x14, 0xea02);
+        mdio_write(tp, 0x14, 0x85a9);
+        mdio_write(tp, 0x14, 0xe182);
+        mdio_write(tp, 0x14, 0x2ff6);
+        mdio_write(tp, 0x14, 0x2ae5);
+        mdio_write(tp, 0x14, 0x822f);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x24f6);
+        mdio_write(tp, 0x14, 0x22e4);
+        mdio_write(tp, 0x14, 0x8224);
+        mdio_write(tp, 0x14, 0xfc04);
+        mdio_write(tp, 0x14, 0xf9e2);
+        mdio_write(tp, 0x14, 0x8011);
+        mdio_write(tp, 0x14, 0xad31);
+        mdio_write(tp, 0x14, 0x05d2);
+        mdio_write(tp, 0x14, 0x0002);
+        mdio_write(tp, 0x14, 0x0e66);
+        mdio_write(tp, 0x14, 0xfd04);
+        mdio_write(tp, 0x14, 0xf8f9);
+        mdio_write(tp, 0x14, 0xfaef);
+        mdio_write(tp, 0x14, 0x69e0);
+        mdio_write(tp, 0x14, 0x8011);
+        mdio_write(tp, 0x14, 0xad21);
+        mdio_write(tp, 0x14, 0x5cbf);
+        mdio_write(tp, 0x14, 0x43be);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x97ac);
+        mdio_write(tp, 0x14, 0x281b);
+        mdio_write(tp, 0x14, 0xbf43);
+        mdio_write(tp, 0x14, 0xc102);
+        mdio_write(tp, 0x14, 0x4297);
+        mdio_write(tp, 0x14, 0xac28);
+        mdio_write(tp, 0x14, 0x12bf);
+        mdio_write(tp, 0x14, 0x43c7);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x97ac);
+        mdio_write(tp, 0x14, 0x2804);
+        mdio_write(tp, 0x14, 0xd300);
+        mdio_write(tp, 0x14, 0xae07);
+        mdio_write(tp, 0x14, 0xd306);
+        mdio_write(tp, 0x14, 0xaf85);
+        mdio_write(tp, 0x14, 0x56d3);
+        mdio_write(tp, 0x14, 0x03e0);
+        mdio_write(tp, 0x14, 0x8011);
+        mdio_write(tp, 0x14, 0xad26);
+        mdio_write(tp, 0x14, 0x25bf);
+        mdio_write(tp, 0x14, 0x4559);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x97e2);
+        mdio_write(tp, 0x14, 0x8073);
+        mdio_write(tp, 0x14, 0x0d21);
+        mdio_write(tp, 0x14, 0xf637);
+        mdio_write(tp, 0x14, 0x0d11);
+        mdio_write(tp, 0x14, 0xf62f);
+        mdio_write(tp, 0x14, 0x1b21);
+        mdio_write(tp, 0x14, 0xaa02);
+        mdio_write(tp, 0x14, 0xae10);
+        mdio_write(tp, 0x14, 0xe280);
+        mdio_write(tp, 0x14, 0x740d);
+        mdio_write(tp, 0x14, 0x21f6);
+        mdio_write(tp, 0x14, 0x371b);
+        mdio_write(tp, 0x14, 0x21aa);
+        mdio_write(tp, 0x14, 0x0313);
+        mdio_write(tp, 0x14, 0xae02);
+        mdio_write(tp, 0x14, 0x2b02);
+        mdio_write(tp, 0x14, 0x020e);
+        mdio_write(tp, 0x14, 0x5102);
+        mdio_write(tp, 0x14, 0x0e66);
+        mdio_write(tp, 0x14, 0x020f);
+        mdio_write(tp, 0x14, 0xa3ef);
+        mdio_write(tp, 0x14, 0x96fe);
+        mdio_write(tp, 0x14, 0xfdfc);
+        mdio_write(tp, 0x14, 0x04f8);
+        mdio_write(tp, 0x14, 0xf9fa);
+        mdio_write(tp, 0x14, 0xef69);
+        mdio_write(tp, 0x14, 0xe080);
+        mdio_write(tp, 0x14, 0x12ad);
+        mdio_write(tp, 0x14, 0x2733);
+        mdio_write(tp, 0x14, 0xbf43);
+        mdio_write(tp, 0x14, 0xbe02);
+        mdio_write(tp, 0x14, 0x4297);
+        mdio_write(tp, 0x14, 0xac28);
+        mdio_write(tp, 0x14, 0x09bf);
+        mdio_write(tp, 0x14, 0x43c1);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x97ad);
+        mdio_write(tp, 0x14, 0x2821);
+        mdio_write(tp, 0x14, 0xbf45);
+        mdio_write(tp, 0x14, 0x5902);
+        mdio_write(tp, 0x14, 0x4297);
+        mdio_write(tp, 0x14, 0xe387);
+        mdio_write(tp, 0x14, 0xffd2);
+        mdio_write(tp, 0x14, 0x001b);
+        mdio_write(tp, 0x14, 0x45ac);
+        mdio_write(tp, 0x14, 0x2711);
+        mdio_write(tp, 0x14, 0xe187);
+        mdio_write(tp, 0x14, 0xfebf);
+        mdio_write(tp, 0x14, 0x87e4);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x590d);
+        mdio_write(tp, 0x14, 0x11bf);
+        mdio_write(tp, 0x14, 0x87e7);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x59ef);
+        mdio_write(tp, 0x14, 0x96fe);
+        mdio_write(tp, 0x14, 0xfdfc);
+        mdio_write(tp, 0x14, 0x04f8);
+        mdio_write(tp, 0x14, 0xfaef);
+        mdio_write(tp, 0x14, 0x69d1);
+        mdio_write(tp, 0x14, 0x00bf);
+        mdio_write(tp, 0x14, 0x87e4);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x59bf);
+        mdio_write(tp, 0x14, 0x87e7);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x59ef);
+        mdio_write(tp, 0x14, 0x96fe);
+        mdio_write(tp, 0x14, 0xfc04);
+        mdio_write(tp, 0x14, 0xee87);
+        mdio_write(tp, 0x14, 0xff46);
+        mdio_write(tp, 0x14, 0xee87);
+        mdio_write(tp, 0x14, 0xfe01);
+        mdio_write(tp, 0x14, 0x04f8);
+        mdio_write(tp, 0x14, 0xfaef);
+        mdio_write(tp, 0x14, 0x69e0);
+        mdio_write(tp, 0x14, 0x8241);
+        mdio_write(tp, 0x14, 0xa000);
+        mdio_write(tp, 0x14, 0x0502);
+        mdio_write(tp, 0x14, 0x85eb);
+        mdio_write(tp, 0x14, 0xae0e);
+        mdio_write(tp, 0x14, 0xa001);
+        mdio_write(tp, 0x14, 0x0502);
+        mdio_write(tp, 0x14, 0x1a5a);
+        mdio_write(tp, 0x14, 0xae06);
+        mdio_write(tp, 0x14, 0xa002);
+        mdio_write(tp, 0x14, 0x0302);
+        mdio_write(tp, 0x14, 0x1ae6);
+        mdio_write(tp, 0x14, 0xef96);
+        mdio_write(tp, 0x14, 0xfefc);
+        mdio_write(tp, 0x14, 0x04f8);
+        mdio_write(tp, 0x14, 0xf9fa);
+        mdio_write(tp, 0x14, 0xef69);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x29f6);
+        mdio_write(tp, 0x14, 0x21e4);
+        mdio_write(tp, 0x14, 0x8229);
+        mdio_write(tp, 0x14, 0xe080);
+        mdio_write(tp, 0x14, 0x10ac);
+        mdio_write(tp, 0x14, 0x2202);
+        mdio_write(tp, 0x14, 0xae76);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x27f7);
+        mdio_write(tp, 0x14, 0x21e4);
+        mdio_write(tp, 0x14, 0x8227);
+        mdio_write(tp, 0x14, 0xbf43);
+        mdio_write(tp, 0x14, 0x1302);
+        mdio_write(tp, 0x14, 0x4297);
+        mdio_write(tp, 0x14, 0xef21);
+        mdio_write(tp, 0x14, 0xbf43);
+        mdio_write(tp, 0x14, 0x1602);
+        mdio_write(tp, 0x14, 0x4297);
+        mdio_write(tp, 0x14, 0x0c11);
+        mdio_write(tp, 0x14, 0x1e21);
+        mdio_write(tp, 0x14, 0xbf43);
+        mdio_write(tp, 0x14, 0x1902);
+        mdio_write(tp, 0x14, 0x4297);
+        mdio_write(tp, 0x14, 0x0c12);
+        mdio_write(tp, 0x14, 0x1e21);
+        mdio_write(tp, 0x14, 0xe682);
+        mdio_write(tp, 0x14, 0x43a2);
+        mdio_write(tp, 0x14, 0x000a);
+        mdio_write(tp, 0x14, 0xe182);
+        mdio_write(tp, 0x14, 0x27f6);
+        mdio_write(tp, 0x14, 0x29e5);
+        mdio_write(tp, 0x14, 0x8227);
+        mdio_write(tp, 0x14, 0xae42);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x44f7);
+        mdio_write(tp, 0x14, 0x21e4);
+        mdio_write(tp, 0x14, 0x8244);
+        mdio_write(tp, 0x14, 0x0246);
+        mdio_write(tp, 0x14, 0xaebf);
+        mdio_write(tp, 0x14, 0x4325);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x97ef);
+        mdio_write(tp, 0x14, 0x21bf);
+        mdio_write(tp, 0x14, 0x431c);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x970c);
+        mdio_write(tp, 0x14, 0x121e);
+        mdio_write(tp, 0x14, 0x21bf);
+        mdio_write(tp, 0x14, 0x431f);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x970c);
+        mdio_write(tp, 0x14, 0x131e);
+        mdio_write(tp, 0x14, 0x21bf);
+        mdio_write(tp, 0x14, 0x4328);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x970c);
+        mdio_write(tp, 0x14, 0x141e);
+        mdio_write(tp, 0x14, 0x21bf);
+        mdio_write(tp, 0x14, 0x44b1);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x970c);
+        mdio_write(tp, 0x14, 0x161e);
+        mdio_write(tp, 0x14, 0x21e6);
+        mdio_write(tp, 0x14, 0x8242);
+        mdio_write(tp, 0x14, 0xee82);
+        mdio_write(tp, 0x14, 0x4101);
+        mdio_write(tp, 0x14, 0xef96);
+        mdio_write(tp, 0x14, 0xfefd);
+        mdio_write(tp, 0x14, 0xfc04);
+        mdio_write(tp, 0x14, 0xf8fa);
+        mdio_write(tp, 0x14, 0xef69);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x46a0);
+        mdio_write(tp, 0x14, 0x0005);
+        mdio_write(tp, 0x14, 0x0286);
+        mdio_write(tp, 0x14, 0x96ae);
+        mdio_write(tp, 0x14, 0x06a0);
+        mdio_write(tp, 0x14, 0x0103);
+        mdio_write(tp, 0x14, 0x0219);
+        mdio_write(tp, 0x14, 0x19ef);
+        mdio_write(tp, 0x14, 0x96fe);
+        mdio_write(tp, 0x14, 0xfc04);
+        mdio_write(tp, 0x14, 0xf8fa);
+        mdio_write(tp, 0x14, 0xef69);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x29f6);
+        mdio_write(tp, 0x14, 0x20e4);
+        mdio_write(tp, 0x14, 0x8229);
+        mdio_write(tp, 0x14, 0xe080);
+        mdio_write(tp, 0x14, 0x10ac);
+        mdio_write(tp, 0x14, 0x2102);
+        mdio_write(tp, 0x14, 0xae54);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x27f7);
+        mdio_write(tp, 0x14, 0x20e4);
+        mdio_write(tp, 0x14, 0x8227);
+        mdio_write(tp, 0x14, 0xbf42);
+        mdio_write(tp, 0x14, 0xe602);
+        mdio_write(tp, 0x14, 0x4297);
+        mdio_write(tp, 0x14, 0xac28);
+        mdio_write(tp, 0x14, 0x22bf);
+        mdio_write(tp, 0x14, 0x430d);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x97e5);
+        mdio_write(tp, 0x14, 0x8247);
+        mdio_write(tp, 0x14, 0xac28);
+        mdio_write(tp, 0x14, 0x20d1);
+        mdio_write(tp, 0x14, 0x03bf);
+        mdio_write(tp, 0x14, 0x4307);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x59ee);
+        mdio_write(tp, 0x14, 0x8246);
+        mdio_write(tp, 0x14, 0x00e1);
+        mdio_write(tp, 0x14, 0x8227);
+        mdio_write(tp, 0x14, 0xf628);
+        mdio_write(tp, 0x14, 0xe582);
+        mdio_write(tp, 0x14, 0x27ae);
+        mdio_write(tp, 0x14, 0x21d1);
+        mdio_write(tp, 0x14, 0x04bf);
+        mdio_write(tp, 0x14, 0x4307);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x59ae);
+        mdio_write(tp, 0x14, 0x08d1);
+        mdio_write(tp, 0x14, 0x05bf);
+        mdio_write(tp, 0x14, 0x4307);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x59e0);
+        mdio_write(tp, 0x14, 0x8244);
+        mdio_write(tp, 0x14, 0xf720);
+        mdio_write(tp, 0x14, 0xe482);
+        mdio_write(tp, 0x14, 0x4402);
+        mdio_write(tp, 0x14, 0x46ae);
+        mdio_write(tp, 0x14, 0xee82);
+        mdio_write(tp, 0x14, 0x4601);
+        mdio_write(tp, 0x14, 0xef96);
+        mdio_write(tp, 0x14, 0xfefc);
+        mdio_write(tp, 0x14, 0x04f8);
+        mdio_write(tp, 0x14, 0xfaef);
+        mdio_write(tp, 0x14, 0x69e0);
+        mdio_write(tp, 0x14, 0x8013);
+        mdio_write(tp, 0x14, 0xad24);
+        mdio_write(tp, 0x14, 0x1cbf);
+        mdio_write(tp, 0x14, 0x87f0);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x97ad);
+        mdio_write(tp, 0x14, 0x2813);
+        mdio_write(tp, 0x14, 0xe087);
+        mdio_write(tp, 0x14, 0xfca0);
+        mdio_write(tp, 0x14, 0x0005);
+        mdio_write(tp, 0x14, 0x0287);
+        mdio_write(tp, 0x14, 0x36ae);
+        mdio_write(tp, 0x14, 0x10a0);
+        mdio_write(tp, 0x14, 0x0105);
+        mdio_write(tp, 0x14, 0x0287);
+        mdio_write(tp, 0x14, 0x48ae);
+        mdio_write(tp, 0x14, 0x08e0);
+        mdio_write(tp, 0x14, 0x8230);
+        mdio_write(tp, 0x14, 0xf626);
+        mdio_write(tp, 0x14, 0xe482);
+        mdio_write(tp, 0x14, 0x30ef);
+        mdio_write(tp, 0x14, 0x96fe);
+        mdio_write(tp, 0x14, 0xfc04);
+        mdio_write(tp, 0x14, 0xf8e0);
+        mdio_write(tp, 0x14, 0x8245);
+        mdio_write(tp, 0x14, 0xf722);
+        mdio_write(tp, 0x14, 0xe482);
+        mdio_write(tp, 0x14, 0x4502);
+        mdio_write(tp, 0x14, 0x46ae);
+        mdio_write(tp, 0x14, 0xee87);
+        mdio_write(tp, 0x14, 0xfc01);
+        mdio_write(tp, 0x14, 0xfc04);
+        mdio_write(tp, 0x14, 0xf8fa);
+        mdio_write(tp, 0x14, 0xef69);
+        mdio_write(tp, 0x14, 0xfb02);
+        mdio_write(tp, 0x14, 0x46d3);
+        mdio_write(tp, 0x14, 0xad50);
+        mdio_write(tp, 0x14, 0x2fbf);
+        mdio_write(tp, 0x14, 0x87ed);
+        mdio_write(tp, 0x14, 0xd101);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x59bf);
+        mdio_write(tp, 0x14, 0x87ed);
+        mdio_write(tp, 0x14, 0xd100);
+        mdio_write(tp, 0x14, 0x0242);
+        mdio_write(tp, 0x14, 0x59e0);
+        mdio_write(tp, 0x14, 0x8245);
+        mdio_write(tp, 0x14, 0xf622);
+        mdio_write(tp, 0x14, 0xe482);
+        mdio_write(tp, 0x14, 0x4502);
+        mdio_write(tp, 0x14, 0x46ae);
+        mdio_write(tp, 0x14, 0xd100);
+        mdio_write(tp, 0x14, 0xbf87);
+        mdio_write(tp, 0x14, 0xf002);
+        mdio_write(tp, 0x14, 0x4259);
+        mdio_write(tp, 0x14, 0xee87);
+        mdio_write(tp, 0x14, 0xfc00);
+        mdio_write(tp, 0x14, 0xe082);
+        mdio_write(tp, 0x14, 0x30f6);
+        mdio_write(tp, 0x14, 0x26e4);
+        mdio_write(tp, 0x14, 0x8230);
+        mdio_write(tp, 0x14, 0xffef);
+        mdio_write(tp, 0x14, 0x96fe);
+        mdio_write(tp, 0x14, 0xfc04);
+        mdio_write(tp, 0x14, 0xf8f9);
+        mdio_write(tp, 0x14, 0xface);
+        mdio_write(tp, 0x14, 0xfaef);
+        mdio_write(tp, 0x14, 0x69fb);
+        mdio_write(tp, 0x14, 0xbf87);
+        mdio_write(tp, 0x14, 0xb3d7);
+        mdio_write(tp, 0x14, 0x001c);
+        mdio_write(tp, 0x14, 0xd819);
+        mdio_write(tp, 0x14, 0xd919);
+        mdio_write(tp, 0x14, 0xda19);
+        mdio_write(tp, 0x14, 0xdb19);
+        mdio_write(tp, 0x14, 0x07ef);
+        mdio_write(tp, 0x14, 0x9502);
+        mdio_write(tp, 0x14, 0x4259);
+        mdio_write(tp, 0x14, 0x073f);
+        mdio_write(tp, 0x14, 0x0004);
+        mdio_write(tp, 0x14, 0x9fec);
+        mdio_write(tp, 0x14, 0xffef);
+        mdio_write(tp, 0x14, 0x96fe);
+        mdio_write(tp, 0x14, 0xc6fe);
+        mdio_write(tp, 0x14, 0xfdfc);
+        mdio_write(tp, 0x14, 0x0400);
+        mdio_write(tp, 0x14, 0x0145);
+        mdio_write(tp, 0x14, 0x7d00);
+        mdio_write(tp, 0x14, 0x0345);
+        mdio_write(tp, 0x14, 0x5c00);
+        mdio_write(tp, 0x14, 0x0143);
+        mdio_write(tp, 0x14, 0x4f00);
+        mdio_write(tp, 0x14, 0x0387);
+        mdio_write(tp, 0x14, 0xdb00);
+        mdio_write(tp, 0x14, 0x0987);
+        mdio_write(tp, 0x14, 0xde00);
+        mdio_write(tp, 0x14, 0x0987);
+        mdio_write(tp, 0x14, 0xe100);
+        mdio_write(tp, 0x14, 0x0087);
+        mdio_write(tp, 0x14, 0xeaa4);
+        mdio_write(tp, 0x14, 0x00b8);
+        mdio_write(tp, 0x14, 0x20c4);
+        mdio_write(tp, 0x14, 0x1600);
+        mdio_write(tp, 0x14, 0x000f);
+        mdio_write(tp, 0x14, 0xf800);
+        mdio_write(tp, 0x14, 0x7098);
+        mdio_write(tp, 0x14, 0xa58a);
+        mdio_write(tp, 0x14, 0xb6a8);
+        mdio_write(tp, 0x14, 0x3e50);
+        mdio_write(tp, 0x14, 0xa83e);
+        mdio_write(tp, 0x14, 0x33bc);
+        mdio_write(tp, 0x14, 0xc622);
+        mdio_write(tp, 0x14, 0xbcc6);
+        mdio_write(tp, 0x14, 0xaaa4);
+        mdio_write(tp, 0x14, 0x42ff);
+        mdio_write(tp, 0x14, 0xc408);
+        mdio_write(tp, 0x14, 0x00c4);
+        mdio_write(tp, 0x14, 0x16a8);
+        mdio_write(tp, 0x14, 0xbcc0);
+        mdio_write(tp, 0x13, 0xb818);
+        mdio_write(tp, 0x14, 0x02f3);
+        mdio_write(tp, 0x13, 0xb81a);
+        mdio_write(tp, 0x14, 0x17d1);
+        mdio_write(tp, 0x13, 0xb81c);
+        mdio_write(tp, 0x14, 0x185a);
+        mdio_write(tp, 0x13, 0xb81e);
+        mdio_write(tp, 0x14, 0x3c66);
+        mdio_write(tp, 0x13, 0xb820);
+        mdio_write(tp, 0x14, 0x021f);
+        mdio_write(tp, 0x13, 0xc416);
+        mdio_write(tp, 0x14, 0x0500);
+        mdio_write(tp, 0x13, 0xb82e);
+        mdio_write(tp, 0x14, 0xfffc);
+
+        mdio_write(tp, 0x1F, 0x0A43);
+        mdio_write(tp, 0x13, 0x0000);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val &= ~(BIT_9);
+        mdio_write(tp, 0x10, gphy_val);
+        mdio_write(tp, 0x1f, 0x0A43);
+        mdio_write(tp, 0x13, 0x8146);
+        mdio_write(tp, 0x14, 0x0000);
+
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val &= ~(BIT_4);
+        mdio_write(tp, 0x10, gphy_val);
+}
+
+static void
+rtl8168_set_phy_mcu_8168gu_2(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val |= BIT_4;
+        mdio_write(tp, 0x10, gphy_val);
+        mdio_write(tp, 0x1f, 0x0B80);
+        i = 0;
+        do {
+                gphy_val = mdio_read(tp, 0x10);
+                gphy_val &= 0x0040;
+                udelay(50);
+                udelay(50);
+                i++;
+        } while(gphy_val != 0x0040 && i <1000);
+        mdio_write(tp, 0x1f, 0x0A43);
+        mdio_write(tp, 0x13, 0x8146);
+        mdio_write(tp, 0x14, 0x0300);
+        mdio_write(tp, 0x13, 0xB82E);
+        mdio_write(tp, 0x14, 0x0001);
+        mdio_write(tp, 0x1F, 0x0A43);
+        mdio_write(tp, 0x13, 0xb820);
+        mdio_write(tp, 0x14, 0x0290);
+        mdio_write(tp, 0x13, 0xa012);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x13, 0xa014);
+        mdio_write(tp, 0x14, 0x2c04);
+        mdio_write(tp, 0x14, 0x2c07);
+        mdio_write(tp, 0x14, 0x2c07);
+        mdio_write(tp, 0x14, 0x2c07);
+        mdio_write(tp, 0x14, 0xa304);
+        mdio_write(tp, 0x14, 0xa301);
+        mdio_write(tp, 0x14, 0x207e);
+        mdio_write(tp, 0x13, 0xa01a);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x13, 0xa006);
+        mdio_write(tp, 0x14, 0x0fff);
+        mdio_write(tp, 0x13, 0xa004);
+        mdio_write(tp, 0x14, 0x0fff);
+        mdio_write(tp, 0x13, 0xa002);
+        mdio_write(tp, 0x14, 0x0fff);
+        mdio_write(tp, 0x13, 0xa000);
+        mdio_write(tp, 0x14, 0x107c);
+        mdio_write(tp, 0x13, 0xb820);
+        mdio_write(tp, 0x14, 0x0210);
+        mdio_write(tp, 0x1F, 0x0A43);
+        mdio_write(tp, 0x13, 0x0000);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x17);
+        gphy_val &= ~(BIT_0);
+        mdio_write(tp, 0x17, gphy_val);
+        mdio_write(tp, 0x1f, 0x0A43);
+        mdio_write(tp, 0x13, 0x8146);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val &= ~(BIT_4);
+        mdio_write(tp, 0x10, gphy_val);
+}
+
+static void
+rtl8168_set_phy_mcu_8411b_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp,0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val |= BIT_4;
+        mdio_write(tp,0x10, gphy_val);
+
+        mdio_write(tp,0x1f, 0x0B80);
+        i = 0;
+        do {
+                gphy_val = mdio_read(tp, 0x10);
+                gphy_val &= 0x0040;
+                udelay(50);
+                udelay(50);
+                i++;
+        } while(gphy_val != 0x0040 && i <1000);
+
+        mdio_write(tp,0x1f, 0x0A43);
+        mdio_write(tp,0x13, 0x8146);
+        mdio_write(tp,0x14, 0x0100);
+        mdio_write(tp,0x13, 0xB82E);
+        mdio_write(tp,0x14, 0x0001);
+
+
+        mdio_write(tp,0x1F, 0x0A43);
+        mdio_write(tp, 0x13, 0xb820);
+        mdio_write(tp, 0x14, 0x0290);
+        mdio_write(tp, 0x13, 0xa012);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x13, 0xa014);
+        mdio_write(tp, 0x14, 0x2c04);
+        mdio_write(tp, 0x14, 0x2c07);
+        mdio_write(tp, 0x14, 0x2c07);
+        mdio_write(tp, 0x14, 0x2c07);
+        mdio_write(tp, 0x14, 0xa304);
+        mdio_write(tp, 0x14, 0xa301);
+        mdio_write(tp, 0x14, 0x207e);
+        mdio_write(tp, 0x13, 0xa01a);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x13, 0xa006);
+        mdio_write(tp, 0x14, 0x0fff);
+        mdio_write(tp, 0x13, 0xa004);
+        mdio_write(tp, 0x14, 0x0fff);
+        mdio_write(tp, 0x13, 0xa002);
+        mdio_write(tp, 0x14, 0x0fff);
+        mdio_write(tp, 0x13, 0xa000);
+        mdio_write(tp, 0x14, 0x107c);
+        mdio_write(tp, 0x13, 0xb820);
+        mdio_write(tp, 0x14, 0x0210);
+
+
+        mdio_write(tp,0x1F, 0x0A43);
+        mdio_write(tp,0x13, 0x0000);
+        mdio_write(tp,0x14, 0x0000);
+        mdio_write(tp,0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x17);
+        gphy_val &= ~(BIT_0);
+        mdio_write(tp,0x17, gphy_val);
+        mdio_write(tp,0x1f, 0x0A43);
+        mdio_write(tp,0x13, 0x8146);
+        mdio_write(tp,0x14, 0x0000);
+
+
+        mdio_write(tp,0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val &= ~(BIT_4);
+        mdio_write(tp,0x10, gphy_val);
+}
+
+static void
+rtl8168_set_phy_mcu_8168ep_2(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp,0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val |= BIT_4;
+        mdio_write(tp,0x10, gphy_val);
+
+        mdio_write(tp,0x1f, 0x0B80);
+        i = 0;
+        do {
+                gphy_val = mdio_read(tp, 0x10);
+                gphy_val &= 0x0040;
+                udelay(50);
+                udelay(50);
+                i++;
+        } while(gphy_val != 0x0040 && i <1000);
+
+        mdio_write(tp,0x1f, 0x0A43);
+        mdio_write(tp,0x13, 0x8146);
+        mdio_write(tp,0x14, 0x8700);
+        mdio_write(tp,0x13, 0xB82E);
+        mdio_write(tp,0x14, 0x0001);
+
+        mdio_write(tp, 0x1F, 0x0A43);
+
+        mdio_write(tp, 0x13, 0x83DD);
+        mdio_write(tp, 0x14, 0xAF83);
+        mdio_write(tp, 0x14, 0xE9AF);
+        mdio_write(tp, 0x14, 0x83EE);
+        mdio_write(tp, 0x14, 0xAF83);
+        mdio_write(tp, 0x14, 0xF1A1);
+        mdio_write(tp, 0x14, 0x83F4);
+        mdio_write(tp, 0x14, 0xD149);
+        mdio_write(tp, 0x14, 0xAF06);
+        mdio_write(tp, 0x14, 0x47AF);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x14, 0xAF00);
+        mdio_write(tp, 0x14, 0x00AF);
+        mdio_write(tp, 0x14, 0x0000);
+
+        mdio_write(tp, 0x13, 0xB818);
+        mdio_write(tp, 0x14, 0x0645);
+
+        mdio_write(tp, 0x13, 0xB81A);
+        mdio_write(tp, 0x14, 0x0000);
+
+        mdio_write(tp, 0x13, 0xB81C);
+        mdio_write(tp, 0x14, 0x0000);
+
+        mdio_write(tp, 0x13, 0xB81E);
+        mdio_write(tp, 0x14, 0x0000);
+
+        mdio_write(tp, 0x13, 0xB832);
+        mdio_write(tp, 0x14, 0x0001);
+
+        mdio_write(tp,0x1F, 0x0A43);
+        mdio_write(tp,0x13, 0x0000);
+        mdio_write(tp,0x14, 0x0000);
+        mdio_write(tp,0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x17);
+        gphy_val &= ~(BIT_0);
+        mdio_write(tp,0x17, gphy_val);
+        mdio_write(tp,0x1f, 0x0A43);
+        mdio_write(tp,0x13, 0x8146);
+        mdio_write(tp,0x14, 0x0000);
+
+        mdio_write(tp,0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val &= ~(BIT_4);
+        mdio_write(tp,0x10, gphy_val);
+}
+
+static void
+rtl8168_set_phy_mcu_8168h_1(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val |= BIT_4;
+        mdio_write(tp, 0x10, gphy_val);
+
+        mdio_write(tp, 0x1f, 0x0B80);
+        i = 0;
+        do {
+                gphy_val = mdio_read(tp, 0x10);
+                gphy_val &= 0x0040;
+                udelay(50);
+                udelay(50);
+                i++;
+        } while(gphy_val != 0x0040 && i <1000);
+
+        mdio_write(tp, 0x1f, 0x0A43);
+        mdio_write(tp, 0x13, 0x8028);
+        mdio_write(tp, 0x14, 0x6200);
+        mdio_write(tp, 0x13, 0xB82E);
+        mdio_write(tp, 0x14, 0x0001);
+
+
+        mdio_write(tp, 0x1F, 0x0A43);
+        mdio_write(tp, 0x13, 0xB820);
+        mdio_write(tp, 0x14, 0x0290);
+        mdio_write(tp, 0x13, 0xA012);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x13, 0xA014);
+        mdio_write(tp, 0x14, 0x2c04);
+        mdio_write(tp, 0x14, 0x2c10);
+        mdio_write(tp, 0x14, 0x2c10);
+        mdio_write(tp, 0x14, 0x2c10);
+        mdio_write(tp, 0x14, 0xa210);
+        mdio_write(tp, 0x14, 0xa101);
+        mdio_write(tp, 0x14, 0xce10);
+        mdio_write(tp, 0x14, 0xe070);
+        mdio_write(tp, 0x14, 0x0f40);
+        mdio_write(tp, 0x14, 0xaf01);
+        mdio_write(tp, 0x14, 0x8f01);
+        mdio_write(tp, 0x14, 0x183e);
+        mdio_write(tp, 0x14, 0x8e10);
+        mdio_write(tp, 0x14, 0x8101);
+        mdio_write(tp, 0x14, 0x8210);
+        mdio_write(tp, 0x14, 0x28da);
+        mdio_write(tp, 0x13, 0xA01A);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x13, 0xA006);
+        mdio_write(tp, 0x14, 0x0017);
+        mdio_write(tp, 0x13, 0xA004);
+        mdio_write(tp, 0x14, 0x0015);
+        mdio_write(tp, 0x13, 0xA002);
+        mdio_write(tp, 0x14, 0x0013);
+        mdio_write(tp, 0x13, 0xA000);
+        mdio_write(tp, 0x14, 0x18d1);
+        mdio_write(tp, 0x13, 0xB820);
+        mdio_write(tp, 0x14, 0x0210);
+
+
+        mdio_write(tp, 0x1F, 0x0A43);
+        mdio_write(tp, 0x13, 0x0000);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp,  0x17);
+        gphy_val &= ~(BIT_0);
+        mdio_write(tp, 0x17, gphy_val);
+        mdio_write(tp, 0x1f, 0x0A43);
+        mdio_write(tp, 0x13, 0x8028);
+        mdio_write(tp, 0x14, 0x0000);
+
+
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val &= ~(BIT_4);
+        mdio_write(tp, 0x10, gphy_val);
+}
+
+static void
+rtl8168_set_phy_mcu_8168h_2(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int gphy_val,i;
+
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val |= BIT_4;
+        mdio_write(tp, 0x10, gphy_val);
+
+        mdio_write(tp, 0x1f, 0x0B80);
+        i = 0;
+        do {
+                gphy_val = mdio_read(tp, 0x10);
+                gphy_val &= 0x0040;
+                udelay(50);
+                udelay(50);
+                i++;
+        } while(gphy_val != 0x0040 && i <1000);
+
+        mdio_write(tp, 0x1f, 0x0A43);
+        mdio_write(tp, 0x13, 0x8028);
+        mdio_write(tp, 0x14, 0x6201);
+        mdio_write(tp, 0x13, 0xB82E);
+        mdio_write(tp, 0x14, 0x0001);
+
+
+        mdio_write(tp, 0x1F, 0x0A43);
+        mdio_write(tp, 0x13, 0xB820);
+        mdio_write(tp, 0x14, 0x0290);
+        mdio_write(tp, 0x13, 0xA012);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x13, 0xA014);
+        mdio_write(tp, 0x14, 0x2c04);
+        mdio_write(tp, 0x14, 0x2c09);
+        mdio_write(tp, 0x14, 0x2c09);
+        mdio_write(tp, 0x14, 0x2c09);
+        mdio_write(tp, 0x14, 0xad01);
+        mdio_write(tp, 0x14, 0xad01);
+        mdio_write(tp, 0x14, 0xad01);
+        mdio_write(tp, 0x14, 0xad01);
+        mdio_write(tp, 0x14, 0x236c);
+        mdio_write(tp, 0x13, 0xA01A);
+        mdio_write(tp, 0x14, 0x0000);
+        mdio_write(tp, 0x13, 0xA006);
+        mdio_write(tp, 0x14, 0x0fff);
+        mdio_write(tp, 0x13, 0xA004);
+        mdio_write(tp, 0x14, 0x0fff);
+        mdio_write(tp, 0x13, 0xA002);
+        mdio_write(tp, 0x14, 0x0fff);
+        mdio_write(tp, 0x13, 0xA000);
+        mdio_write(tp, 0x14, 0x136b);
+        mdio_write(tp, 0x13, 0xB820);
+        mdio_write(tp, 0x14, 0x0210);
+
+
+        mdio_write(tp,0x1F, 0x0A43);
+        mdio_write(tp,0x13, 0x0000);
+        mdio_write(tp,0x14, 0x0000);
+        mdio_write(tp,0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x17);
+        gphy_val &= ~(BIT_0);
+        mdio_write(tp,0x17, gphy_val);
+        mdio_write(tp,0x1f, 0x0A43);
+        mdio_write(tp,0x13, 0x8028);
+        mdio_write(tp,0x14, 0x0000);
+
+
+        mdio_write(tp, 0x1f, 0x0B82);
+        gphy_val = mdio_read(tp, 0x10);
+        gphy_val &= ~(BIT_4);
+        mdio_write(tp, 0x10, gphy_val);
+
+        if (tp->RequiredSecLanDonglePatch) {
+                mdio_write(tp, 0x1F, 0x0A43);
+                gphy_val = mdio_read(tp, 0x11);
+                gphy_val &= ~BIT_6;
+                mdio_write(tp, 0x11, gphy_val);
+        }
+}
+
+static void
+rtl8168_init_hw_phy_mcu(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        u8 require_disable_phy_disable_mode = FALSE;
+
+        if (tp->NotWrRamCodeToMicroP == TRUE) return;
+        if (rtl8168_check_hw_phy_mcu_code_ver(dev)) return;
+
+        if (FALSE == rtl8168_phy_ram_code_check(dev)) {
+                rtl8168_set_phy_ram_code_check_fail_flag(dev);
+                return;
+        }
+
+        if (HW_SUPPORT_CHECK_PHY_DISABLE_MODE(tp) && rtl8168_is_in_phy_disable_mode(dev))
+                require_disable_phy_disable_mode = TRUE;
+
+        if (require_disable_phy_disable_mode)
+                rtl8168_disable_phy_disable_mode(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+                rtl8168_set_phy_mcu_8168e_1(dev);
+                break;
+        case CFG_METHOD_15:
+                rtl8168_set_phy_mcu_8168e_2(dev);
+                break;
+        case CFG_METHOD_16:
+                rtl8168_set_phy_mcu_8168evl_1(dev);
+                break;
+        case CFG_METHOD_17:
+                rtl8168_set_phy_mcu_8168evl_2(dev);
+                break;
+        case CFG_METHOD_18:
+                rtl8168_set_phy_mcu_8168f_1(dev);
+                break;
+        case CFG_METHOD_19:
+                rtl8168_set_phy_mcu_8168f_2(dev);
+                break;
+        case CFG_METHOD_20:
+                rtl8168_set_phy_mcu_8411_1(dev);
+                break;
+        case CFG_METHOD_21:
+                rtl8168_set_phy_mcu_8168g_1(dev);
+                break;
+        case CFG_METHOD_25:
+                rtl8168_set_phy_mcu_8168gu_2(dev);
+                break;
+        case CFG_METHOD_26:
+                rtl8168_set_phy_mcu_8411b_1(dev);
+                break;
+        case CFG_METHOD_28:
+                rtl8168_set_phy_mcu_8168ep_2(dev);
+                break;
+        case CFG_METHOD_29:
+                rtl8168_set_phy_mcu_8168h_1(dev);
+                break;
+        case CFG_METHOD_30:
+                rtl8168_set_phy_mcu_8168h_2(dev);
+                break;
+        }
+
+        if (require_disable_phy_disable_mode)
+                rtl8168_enable_phy_disable_mode(dev);
+
+        rtl8168_write_hw_phy_mcu_code_ver(dev);
+
+        mdio_write(tp,0x1F, 0x0000);
+
+        tp->HwHasWrRamCodeToMicroP = TRUE;
+}
+
+static void
+rtl8168_hw_phy_config(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+        u16 gphy_val;
+        unsigned int i;
+        unsigned long flags;
+
+        tp->phy_reset_enable(dev);
+
+        if (HW_DASH_SUPPORT_TYPE_3(tp) && tp->HwPkgDet == 0x06) return;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+
+        rtl8168_init_hw_phy_mcu(dev);
+
+        if (tp->mcfg == CFG_METHOD_1) {
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x0B, 0x94B0);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x12, 0x6096);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x0D, 0xF8A0);
+        } else if (tp->mcfg == CFG_METHOD_2) {
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x0B, 0x94B0);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x12, 0x6096);
+
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_3) {
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x0B, 0x94B0);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x12, 0x6096);
+
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_4) {
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x12, 0x2300);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x16, 0x000A);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x12, 0xC096);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x00, 0x88DE);
+                mdio_write(tp, 0x01, 0x82B1);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x08, 0x9E30);
+                mdio_write(tp, 0x09, 0x01F0);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x0A, 0x5500);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x03, 0x7002);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x0C, 0x00C8);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) | (1 << 5));
+                mdio_write(tp, 0x0D, mdio_read(tp, 0x0D) & ~(1 << 5));
+        } else if (tp->mcfg == CFG_METHOD_5) {
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x12, 0x2300);
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x16, 0x0F0A);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x00, 0x88DE);
+                mdio_write(tp, 0x01, 0x82B1);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x0C, 0x7EB8);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x06, 0x0761);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x03, 0x802F);
+                mdio_write(tp, 0x02, 0x4F02);
+                mdio_write(tp, 0x01, 0x0409);
+                mdio_write(tp, 0x00, 0xF099);
+                mdio_write(tp, 0x04, 0x9800);
+                mdio_write(tp, 0x04, 0x9000);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x16, mdio_read(tp, 0x16) | (1 << 0));
+
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) | (1 << 5));
+                mdio_write(tp, 0x0D, mdio_read(tp, 0x0D) & ~(1 << 5));
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x1D, 0x3D98);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x17, 0x0CC0);
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_6) {
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x12, 0x2300);
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x16, 0x0F0A);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x00, 0x88DE);
+                mdio_write(tp, 0x01, 0x82B1);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x0C, 0x7EB8);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x06, 0x5461);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x06, 0x5461);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x16, mdio_read(tp, 0x16) | (1 << 0));
+
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) | (1 << 5));
+                mdio_write(tp, 0x0D, mdio_read(tp, 0x0D) & ~(1 << 5));
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x1D, 0x3D98);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0001);
+                mdio_write(tp, 0x17, 0x0CC0);
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_7) {
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) | (1 << 5));
+                mdio_write(tp, 0x0D, mdio_read(tp, 0x0D) & ~(1 << 5));
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x1D, 0x3D98);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x14, 0xCAA3);
+                mdio_write(tp, 0x1C, 0x000A);
+                mdio_write(tp, 0x18, 0x65D0);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x17, 0xB580);
+                mdio_write(tp, 0x18, 0xFF54);
+                mdio_write(tp, 0x19, 0x3954);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x0D, 0x310C);
+                mdio_write(tp, 0x0E, 0x310C);
+                mdio_write(tp, 0x0F, 0x311C);
+                mdio_write(tp, 0x06, 0x0761);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x18, 0xFF55);
+                mdio_write(tp, 0x19, 0x3955);
+                mdio_write(tp, 0x18, 0xFF54);
+                mdio_write(tp, 0x19, 0x3954);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x17, 0x0CC0);
+
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_8) {
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) | (1 << 5));
+                mdio_write(tp, 0x0D, mdio_read(tp, 0x0D) & ~(1 << 5));
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x14, 0xCAA3);
+                mdio_write(tp, 0x1C, 0x000A);
+                mdio_write(tp, 0x18, 0x65D0);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x17, 0xB580);
+                mdio_write(tp, 0x18, 0xFF54);
+                mdio_write(tp, 0x19, 0x3954);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x0D, 0x310C);
+                mdio_write(tp, 0x0E, 0x310C);
+                mdio_write(tp, 0x0F, 0x311C);
+                mdio_write(tp, 0x06, 0x0761);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x18, 0xFF55);
+                mdio_write(tp, 0x19, 0x3955);
+                mdio_write(tp, 0x18, 0xFF54);
+                mdio_write(tp, 0x19, 0x3954);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x17, 0x0CC0);
+
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x16, mdio_read(tp, 0x16) | (1 << 0));
+
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_9) {
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x06, 0x4064);
+                mdio_write(tp, 0x07, 0x2863);
+                mdio_write(tp, 0x08, 0x059C);
+                mdio_write(tp, 0x09, 0x26B4);
+                mdio_write(tp, 0x0A, 0x6A19);
+                mdio_write(tp, 0x0B, 0xDCC8);
+                mdio_write(tp, 0x10, 0xF06D);
+                mdio_write(tp, 0x14, 0x7F68);
+                mdio_write(tp, 0x18, 0x7FD9);
+                mdio_write(tp, 0x1C, 0xF0FF);
+                mdio_write(tp, 0x1D, 0x3D9C);
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x12, 0xF49F);
+                mdio_write(tp, 0x13, 0x070B);
+                mdio_write(tp, 0x1A, 0x05AD);
+                mdio_write(tp, 0x14, 0x94C0);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                gphy_val = mdio_read(tp, 0x0B) & 0xFF00;
+                gphy_val |= 0x10;
+                mdio_write(tp, 0x0B, gphy_val);
+                gphy_val = mdio_read(tp, 0x0C) & 0x00FF;
+                gphy_val |= 0xA200;
+                mdio_write(tp, 0x0C, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x06, 0x5561);
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8332);
+                mdio_write(tp, 0x06, 0x5561);
+
+                if (rtl8168_efuse_read(tp, 0x01) == 0xb1) {
+                        mdio_write(tp, 0x1F, 0x0002);
+                        mdio_write(tp, 0x05, 0x669A);
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8330);
+                        mdio_write(tp, 0x06, 0x669A);
+
+                        mdio_write(tp, 0x1F, 0x0002);
+                        gphy_val = mdio_read(tp, 0x0D);
+                        if ((gphy_val & 0x00FF) != 0x006C) {
+                                gphy_val &= 0xFF00;
+                                mdio_write(tp, 0x1F, 0x0002);
+                                mdio_write(tp, 0x0D, gphy_val | 0x0065);
+                                mdio_write(tp, 0x0D, gphy_val | 0x0066);
+                                mdio_write(tp, 0x0D, gphy_val | 0x0067);
+                                mdio_write(tp, 0x0D, gphy_val | 0x0068);
+                                mdio_write(tp, 0x0D, gphy_val | 0x0069);
+                                mdio_write(tp, 0x0D, gphy_val | 0x006A);
+                                mdio_write(tp, 0x0D, gphy_val | 0x006B);
+                                mdio_write(tp, 0x0D, gphy_val | 0x006C);
+                        }
+                } else {
+                        mdio_write(tp, 0x1F, 0x0002);
+                        mdio_write(tp, 0x05, 0x6662);
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8330);
+                        mdio_write(tp, 0x06, 0x6662);
+                }
+
+                mdio_write(tp, 0x1F, 0x0002);
+                gphy_val = mdio_read(tp, 0x0D);
+                gphy_val |= BIT_9;
+                gphy_val |= BIT_8;
+                mdio_write(tp, 0x0D, gphy_val);
+                gphy_val = mdio_read(tp, 0x0F);
+                gphy_val |= BIT_4;
+                mdio_write(tp, 0x0F, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                gphy_val = mdio_read(tp, 0x02);
+                gphy_val &= ~BIT_10;
+                gphy_val &= ~BIT_9;
+                gphy_val |= BIT_8;
+                mdio_write(tp, 0x02, gphy_val);
+                gphy_val = mdio_read(tp, 0x03);
+                gphy_val &= ~BIT_15;
+                gphy_val &= ~BIT_14;
+                gphy_val &= ~BIT_13;
+                mdio_write(tp, 0x03, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x17, 0x0CC0);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x001B);
+                if (mdio_read(tp, 0x06) == 0xBF00) {
+                        mdio_write(tp, 0x1f, 0x0005);
+                        mdio_write(tp, 0x05, 0xfff6);
+                        mdio_write(tp, 0x06, 0x0080);
+                        mdio_write(tp, 0x05, 0x8000);
+                        mdio_write(tp, 0x06, 0xf8f9);
+                        mdio_write(tp, 0x06, 0xfaef);
+                        mdio_write(tp, 0x06, 0x59ee);
+                        mdio_write(tp, 0x06, 0xf8ea);
+                        mdio_write(tp, 0x06, 0x00ee);
+                        mdio_write(tp, 0x06, 0xf8eb);
+                        mdio_write(tp, 0x06, 0x00e0);
+                        mdio_write(tp, 0x06, 0xf87c);
+                        mdio_write(tp, 0x06, 0xe1f8);
+                        mdio_write(tp, 0x06, 0x7d59);
+                        mdio_write(tp, 0x06, 0x0fef);
+                        mdio_write(tp, 0x06, 0x0139);
+                        mdio_write(tp, 0x06, 0x029e);
+                        mdio_write(tp, 0x06, 0x06ef);
+                        mdio_write(tp, 0x06, 0x1039);
+                        mdio_write(tp, 0x06, 0x089f);
+                        mdio_write(tp, 0x06, 0x2aee);
+                        mdio_write(tp, 0x06, 0xf8ea);
+                        mdio_write(tp, 0x06, 0x00ee);
+                        mdio_write(tp, 0x06, 0xf8eb);
+                        mdio_write(tp, 0x06, 0x01e0);
+                        mdio_write(tp, 0x06, 0xf87c);
+                        mdio_write(tp, 0x06, 0xe1f8);
+                        mdio_write(tp, 0x06, 0x7d58);
+                        mdio_write(tp, 0x06, 0x409e);
+                        mdio_write(tp, 0x06, 0x0f39);
+                        mdio_write(tp, 0x06, 0x46aa);
+                        mdio_write(tp, 0x06, 0x0bbf);
+                        mdio_write(tp, 0x06, 0x8290);
+                        mdio_write(tp, 0x06, 0xd682);
+                        mdio_write(tp, 0x06, 0x9802);
+                        mdio_write(tp, 0x06, 0x014f);
+                        mdio_write(tp, 0x06, 0xae09);
+                        mdio_write(tp, 0x06, 0xbf82);
+                        mdio_write(tp, 0x06, 0x98d6);
+                        mdio_write(tp, 0x06, 0x82a0);
+                        mdio_write(tp, 0x06, 0x0201);
+                        mdio_write(tp, 0x06, 0x4fef);
+                        mdio_write(tp, 0x06, 0x95fe);
+                        mdio_write(tp, 0x06, 0xfdfc);
+                        mdio_write(tp, 0x06, 0x05f8);
+                        mdio_write(tp, 0x06, 0xf9fa);
+                        mdio_write(tp, 0x06, 0xeef8);
+                        mdio_write(tp, 0x06, 0xea00);
+                        mdio_write(tp, 0x06, 0xeef8);
+                        mdio_write(tp, 0x06, 0xeb00);
+                        mdio_write(tp, 0x06, 0xe2f8);
+                        mdio_write(tp, 0x06, 0x7ce3);
+                        mdio_write(tp, 0x06, 0xf87d);
+                        mdio_write(tp, 0x06, 0xa511);
+                        mdio_write(tp, 0x06, 0x1112);
+                        mdio_write(tp, 0x06, 0xd240);
+                        mdio_write(tp, 0x06, 0xd644);
+                        mdio_write(tp, 0x06, 0x4402);
+                        mdio_write(tp, 0x06, 0x8217);
+                        mdio_write(tp, 0x06, 0xd2a0);
+                        mdio_write(tp, 0x06, 0xd6aa);
+                        mdio_write(tp, 0x06, 0xaa02);
+                        mdio_write(tp, 0x06, 0x8217);
+                        mdio_write(tp, 0x06, 0xae0f);
+                        mdio_write(tp, 0x06, 0xa544);
+                        mdio_write(tp, 0x06, 0x4402);
+                        mdio_write(tp, 0x06, 0xae4d);
+                        mdio_write(tp, 0x06, 0xa5aa);
+                        mdio_write(tp, 0x06, 0xaa02);
+                        mdio_write(tp, 0x06, 0xae47);
+                        mdio_write(tp, 0x06, 0xaf82);
+                        mdio_write(tp, 0x06, 0x13ee);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x00ee);
+                        mdio_write(tp, 0x06, 0x834d);
+                        mdio_write(tp, 0x06, 0x0fee);
+                        mdio_write(tp, 0x06, 0x834c);
+                        mdio_write(tp, 0x06, 0x0fee);
+                        mdio_write(tp, 0x06, 0x834f);
+                        mdio_write(tp, 0x06, 0x00ee);
+                        mdio_write(tp, 0x06, 0x8351);
+                        mdio_write(tp, 0x06, 0x00ee);
+                        mdio_write(tp, 0x06, 0x834a);
+                        mdio_write(tp, 0x06, 0xffee);
+                        mdio_write(tp, 0x06, 0x834b);
+                        mdio_write(tp, 0x06, 0xffe0);
+                        mdio_write(tp, 0x06, 0x8330);
+                        mdio_write(tp, 0x06, 0xe183);
+                        mdio_write(tp, 0x06, 0x3158);
+                        mdio_write(tp, 0x06, 0xfee4);
+                        mdio_write(tp, 0x06, 0xf88a);
+                        mdio_write(tp, 0x06, 0xe5f8);
+                        mdio_write(tp, 0x06, 0x8be0);
+                        mdio_write(tp, 0x06, 0x8332);
+                        mdio_write(tp, 0x06, 0xe183);
+                        mdio_write(tp, 0x06, 0x3359);
+                        mdio_write(tp, 0x06, 0x0fe2);
+                        mdio_write(tp, 0x06, 0x834d);
+                        mdio_write(tp, 0x06, 0x0c24);
+                        mdio_write(tp, 0x06, 0x5af0);
+                        mdio_write(tp, 0x06, 0x1e12);
+                        mdio_write(tp, 0x06, 0xe4f8);
+                        mdio_write(tp, 0x06, 0x8ce5);
+                        mdio_write(tp, 0x06, 0xf88d);
+                        mdio_write(tp, 0x06, 0xaf82);
+                        mdio_write(tp, 0x06, 0x13e0);
+                        mdio_write(tp, 0x06, 0x834f);
+                        mdio_write(tp, 0x06, 0x10e4);
+                        mdio_write(tp, 0x06, 0x834f);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4e78);
+                        mdio_write(tp, 0x06, 0x009f);
+                        mdio_write(tp, 0x06, 0x0ae0);
+                        mdio_write(tp, 0x06, 0x834f);
+                        mdio_write(tp, 0x06, 0xa010);
+                        mdio_write(tp, 0x06, 0xa5ee);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x01e0);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x7805);
+                        mdio_write(tp, 0x06, 0x9e9a);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4e78);
+                        mdio_write(tp, 0x06, 0x049e);
+                        mdio_write(tp, 0x06, 0x10e0);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x7803);
+                        mdio_write(tp, 0x06, 0x9e0f);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4e78);
+                        mdio_write(tp, 0x06, 0x019e);
+                        mdio_write(tp, 0x06, 0x05ae);
+                        mdio_write(tp, 0x06, 0x0caf);
+                        mdio_write(tp, 0x06, 0x81f8);
+                        mdio_write(tp, 0x06, 0xaf81);
+                        mdio_write(tp, 0x06, 0xa3af);
+                        mdio_write(tp, 0x06, 0x81dc);
+                        mdio_write(tp, 0x06, 0xaf82);
+                        mdio_write(tp, 0x06, 0x13ee);
+                        mdio_write(tp, 0x06, 0x8348);
+                        mdio_write(tp, 0x06, 0x00ee);
+                        mdio_write(tp, 0x06, 0x8349);
+                        mdio_write(tp, 0x06, 0x00e0);
+                        mdio_write(tp, 0x06, 0x8351);
+                        mdio_write(tp, 0x06, 0x10e4);
+                        mdio_write(tp, 0x06, 0x8351);
+                        mdio_write(tp, 0x06, 0x5801);
+                        mdio_write(tp, 0x06, 0x9fea);
+                        mdio_write(tp, 0x06, 0xd000);
+                        mdio_write(tp, 0x06, 0xd180);
+                        mdio_write(tp, 0x06, 0x1f66);
+                        mdio_write(tp, 0x06, 0xe2f8);
+                        mdio_write(tp, 0x06, 0xeae3);
+                        mdio_write(tp, 0x06, 0xf8eb);
+                        mdio_write(tp, 0x06, 0x5af8);
+                        mdio_write(tp, 0x06, 0x1e20);
+                        mdio_write(tp, 0x06, 0xe6f8);
+                        mdio_write(tp, 0x06, 0xeae5);
+                        mdio_write(tp, 0x06, 0xf8eb);
+                        mdio_write(tp, 0x06, 0xd302);
+                        mdio_write(tp, 0x06, 0xb3fe);
+                        mdio_write(tp, 0x06, 0xe2f8);
+                        mdio_write(tp, 0x06, 0x7cef);
+                        mdio_write(tp, 0x06, 0x325b);
+                        mdio_write(tp, 0x06, 0x80e3);
+                        mdio_write(tp, 0x06, 0xf87d);
+                        mdio_write(tp, 0x06, 0x9e03);
+                        mdio_write(tp, 0x06, 0x7dff);
+                        mdio_write(tp, 0x06, 0xff0d);
+                        mdio_write(tp, 0x06, 0x581c);
+                        mdio_write(tp, 0x06, 0x551a);
+                        mdio_write(tp, 0x06, 0x6511);
+                        mdio_write(tp, 0x06, 0xa190);
+                        mdio_write(tp, 0x06, 0xd3e2);
+                        mdio_write(tp, 0x06, 0x8348);
+                        mdio_write(tp, 0x06, 0xe383);
+                        mdio_write(tp, 0x06, 0x491b);
+                        mdio_write(tp, 0x06, 0x56ab);
+                        mdio_write(tp, 0x06, 0x08ef);
+                        mdio_write(tp, 0x06, 0x56e6);
+                        mdio_write(tp, 0x06, 0x8348);
+                        mdio_write(tp, 0x06, 0xe783);
+                        mdio_write(tp, 0x06, 0x4910);
+                        mdio_write(tp, 0x06, 0xd180);
+                        mdio_write(tp, 0x06, 0x1f66);
+                        mdio_write(tp, 0x06, 0xa004);
+                        mdio_write(tp, 0x06, 0xb9e2);
+                        mdio_write(tp, 0x06, 0x8348);
+                        mdio_write(tp, 0x06, 0xe383);
+                        mdio_write(tp, 0x06, 0x49ef);
+                        mdio_write(tp, 0x06, 0x65e2);
+                        mdio_write(tp, 0x06, 0x834a);
+                        mdio_write(tp, 0x06, 0xe383);
+                        mdio_write(tp, 0x06, 0x4b1b);
+                        mdio_write(tp, 0x06, 0x56aa);
+                        mdio_write(tp, 0x06, 0x0eef);
+                        mdio_write(tp, 0x06, 0x56e6);
+                        mdio_write(tp, 0x06, 0x834a);
+                        mdio_write(tp, 0x06, 0xe783);
+                        mdio_write(tp, 0x06, 0x4be2);
+                        mdio_write(tp, 0x06, 0x834d);
+                        mdio_write(tp, 0x06, 0xe683);
+                        mdio_write(tp, 0x06, 0x4ce0);
+                        mdio_write(tp, 0x06, 0x834d);
+                        mdio_write(tp, 0x06, 0xa000);
+                        mdio_write(tp, 0x06, 0x0caf);
+                        mdio_write(tp, 0x06, 0x81dc);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4d10);
+                        mdio_write(tp, 0x06, 0xe483);
+                        mdio_write(tp, 0x06, 0x4dae);
+                        mdio_write(tp, 0x06, 0x0480);
+                        mdio_write(tp, 0x06, 0xe483);
+                        mdio_write(tp, 0x06, 0x4de0);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x7803);
+                        mdio_write(tp, 0x06, 0x9e0b);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4e78);
+                        mdio_write(tp, 0x06, 0x049e);
+                        mdio_write(tp, 0x06, 0x04ee);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x02e0);
+                        mdio_write(tp, 0x06, 0x8332);
+                        mdio_write(tp, 0x06, 0xe183);
+                        mdio_write(tp, 0x06, 0x3359);
+                        mdio_write(tp, 0x06, 0x0fe2);
+                        mdio_write(tp, 0x06, 0x834d);
+                        mdio_write(tp, 0x06, 0x0c24);
+                        mdio_write(tp, 0x06, 0x5af0);
+                        mdio_write(tp, 0x06, 0x1e12);
+                        mdio_write(tp, 0x06, 0xe4f8);
+                        mdio_write(tp, 0x06, 0x8ce5);
+                        mdio_write(tp, 0x06, 0xf88d);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x30e1);
+                        mdio_write(tp, 0x06, 0x8331);
+                        mdio_write(tp, 0x06, 0x6801);
+                        mdio_write(tp, 0x06, 0xe4f8);
+                        mdio_write(tp, 0x06, 0x8ae5);
+                        mdio_write(tp, 0x06, 0xf88b);
+                        mdio_write(tp, 0x06, 0xae37);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4e03);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4ce1);
+                        mdio_write(tp, 0x06, 0x834d);
+                        mdio_write(tp, 0x06, 0x1b01);
+                        mdio_write(tp, 0x06, 0x9e04);
+                        mdio_write(tp, 0x06, 0xaaa1);
+                        mdio_write(tp, 0x06, 0xaea8);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4e04);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4f00);
+                        mdio_write(tp, 0x06, 0xaeab);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4f78);
+                        mdio_write(tp, 0x06, 0x039f);
+                        mdio_write(tp, 0x06, 0x14ee);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x05d2);
+                        mdio_write(tp, 0x06, 0x40d6);
+                        mdio_write(tp, 0x06, 0x5554);
+                        mdio_write(tp, 0x06, 0x0282);
+                        mdio_write(tp, 0x06, 0x17d2);
+                        mdio_write(tp, 0x06, 0xa0d6);
+                        mdio_write(tp, 0x06, 0xba00);
+                        mdio_write(tp, 0x06, 0x0282);
+                        mdio_write(tp, 0x06, 0x17fe);
+                        mdio_write(tp, 0x06, 0xfdfc);
+                        mdio_write(tp, 0x06, 0x05f8);
+                        mdio_write(tp, 0x06, 0xe0f8);
+                        mdio_write(tp, 0x06, 0x60e1);
+                        mdio_write(tp, 0x06, 0xf861);
+                        mdio_write(tp, 0x06, 0x6802);
+                        mdio_write(tp, 0x06, 0xe4f8);
+                        mdio_write(tp, 0x06, 0x60e5);
+                        mdio_write(tp, 0x06, 0xf861);
+                        mdio_write(tp, 0x06, 0xe0f8);
+                        mdio_write(tp, 0x06, 0x48e1);
+                        mdio_write(tp, 0x06, 0xf849);
+                        mdio_write(tp, 0x06, 0x580f);
+                        mdio_write(tp, 0x06, 0x1e02);
+                        mdio_write(tp, 0x06, 0xe4f8);
+                        mdio_write(tp, 0x06, 0x48e5);
+                        mdio_write(tp, 0x06, 0xf849);
+                        mdio_write(tp, 0x06, 0xd000);
+                        mdio_write(tp, 0x06, 0x0282);
+                        mdio_write(tp, 0x06, 0x5bbf);
+                        mdio_write(tp, 0x06, 0x8350);
+                        mdio_write(tp, 0x06, 0xef46);
+                        mdio_write(tp, 0x06, 0xdc19);
+                        mdio_write(tp, 0x06, 0xddd0);
+                        mdio_write(tp, 0x06, 0x0102);
+                        mdio_write(tp, 0x06, 0x825b);
+                        mdio_write(tp, 0x06, 0x0282);
+                        mdio_write(tp, 0x06, 0x77e0);
+                        mdio_write(tp, 0x06, 0xf860);
+                        mdio_write(tp, 0x06, 0xe1f8);
+                        mdio_write(tp, 0x06, 0x6158);
+                        mdio_write(tp, 0x06, 0xfde4);
+                        mdio_write(tp, 0x06, 0xf860);
+                        mdio_write(tp, 0x06, 0xe5f8);
+                        mdio_write(tp, 0x06, 0x61fc);
+                        mdio_write(tp, 0x06, 0x04f9);
+                        mdio_write(tp, 0x06, 0xfafb);
+                        mdio_write(tp, 0x06, 0xc6bf);
+                        mdio_write(tp, 0x06, 0xf840);
+                        mdio_write(tp, 0x06, 0xbe83);
+                        mdio_write(tp, 0x06, 0x50a0);
+                        mdio_write(tp, 0x06, 0x0101);
+                        mdio_write(tp, 0x06, 0x071b);
+                        mdio_write(tp, 0x06, 0x89cf);
+                        mdio_write(tp, 0x06, 0xd208);
+                        mdio_write(tp, 0x06, 0xebdb);
+                        mdio_write(tp, 0x06, 0x19b2);
+                        mdio_write(tp, 0x06, 0xfbff);
+                        mdio_write(tp, 0x06, 0xfefd);
+                        mdio_write(tp, 0x06, 0x04f8);
+                        mdio_write(tp, 0x06, 0xe0f8);
+                        mdio_write(tp, 0x06, 0x48e1);
+                        mdio_write(tp, 0x06, 0xf849);
+                        mdio_write(tp, 0x06, 0x6808);
+                        mdio_write(tp, 0x06, 0xe4f8);
+                        mdio_write(tp, 0x06, 0x48e5);
+                        mdio_write(tp, 0x06, 0xf849);
+                        mdio_write(tp, 0x06, 0x58f7);
+                        mdio_write(tp, 0x06, 0xe4f8);
+                        mdio_write(tp, 0x06, 0x48e5);
+                        mdio_write(tp, 0x06, 0xf849);
+                        mdio_write(tp, 0x06, 0xfc04);
+                        mdio_write(tp, 0x06, 0x4d20);
+                        mdio_write(tp, 0x06, 0x0002);
+                        mdio_write(tp, 0x06, 0x4e22);
+                        mdio_write(tp, 0x06, 0x0002);
+                        mdio_write(tp, 0x06, 0x4ddf);
+                        mdio_write(tp, 0x06, 0xff01);
+                        mdio_write(tp, 0x06, 0x4edd);
+                        mdio_write(tp, 0x06, 0xff01);
+                        mdio_write(tp, 0x06, 0xf8fa);
+                        mdio_write(tp, 0x06, 0xfbef);
+                        mdio_write(tp, 0x06, 0x79bf);
+                        mdio_write(tp, 0x06, 0xf822);
+                        mdio_write(tp, 0x06, 0xd819);
+                        mdio_write(tp, 0x06, 0xd958);
+                        mdio_write(tp, 0x06, 0x849f);
+                        mdio_write(tp, 0x06, 0x09bf);
+                        mdio_write(tp, 0x06, 0x82be);
+                        mdio_write(tp, 0x06, 0xd682);
+                        mdio_write(tp, 0x06, 0xc602);
+                        mdio_write(tp, 0x06, 0x014f);
+                        mdio_write(tp, 0x06, 0xef97);
+                        mdio_write(tp, 0x06, 0xfffe);
+                        mdio_write(tp, 0x06, 0xfc05);
+                        mdio_write(tp, 0x06, 0x17ff);
+                        mdio_write(tp, 0x06, 0xfe01);
+                        mdio_write(tp, 0x06, 0x1700);
+                        mdio_write(tp, 0x06, 0x0102);
+                        mdio_write(tp, 0x05, 0x83d8);
+                        mdio_write(tp, 0x06, 0x8051);
+                        mdio_write(tp, 0x05, 0x83d6);
+                        mdio_write(tp, 0x06, 0x82a0);
+                        mdio_write(tp, 0x05, 0x83d4);
+                        mdio_write(tp, 0x06, 0x8000);
+                        mdio_write(tp, 0x02, 0x2010);
+                        mdio_write(tp, 0x03, 0xdc00);
+                        mdio_write(tp, 0x1f, 0x0000);
+                        mdio_write(tp, 0x0b, 0x0600);
+                        mdio_write(tp, 0x1f, 0x0005);
+                        mdio_write(tp, 0x05, 0xfff6);
+                        mdio_write(tp, 0x06, 0x00fc);
+                        mdio_write(tp, 0x1f, 0x0000);
+                }
+
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x0D, 0xF880);
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_10) {
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x06, 0x4064);
+                mdio_write(tp, 0x07, 0x2863);
+                mdio_write(tp, 0x08, 0x059C);
+                mdio_write(tp, 0x09, 0x26B4);
+                mdio_write(tp, 0x0A, 0x6A19);
+                mdio_write(tp, 0x0B, 0xDCC8);
+                mdio_write(tp, 0x10, 0xF06D);
+                mdio_write(tp, 0x14, 0x7F68);
+                mdio_write(tp, 0x18, 0x7FD9);
+                mdio_write(tp, 0x1C, 0xF0FF);
+                mdio_write(tp, 0x1D, 0x3D9C);
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x12, 0xF49F);
+                mdio_write(tp, 0x13, 0x070B);
+                mdio_write(tp, 0x1A, 0x05AD);
+                mdio_write(tp, 0x14, 0x94C0);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x06, 0x5561);
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8332);
+                mdio_write(tp, 0x06, 0x5561);
+
+                if (rtl8168_efuse_read(tp, 0x01) == 0xb1) {
+                        mdio_write(tp, 0x1F, 0x0002);
+                        mdio_write(tp, 0x05, 0x669A);
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8330);
+                        mdio_write(tp, 0x06, 0x669A);
+
+                        mdio_write(tp, 0x1F, 0x0002);
+                        gphy_val = mdio_read(tp, 0x0D);
+                        if ((gphy_val & 0x00FF) != 0x006C) {
+                                gphy_val &= 0xFF00;
+                                mdio_write(tp, 0x1F, 0x0002);
+                                mdio_write(tp, 0x0D, gphy_val | 0x0065);
+                                mdio_write(tp, 0x0D, gphy_val | 0x0066);
+                                mdio_write(tp, 0x0D, gphy_val | 0x0067);
+                                mdio_write(tp, 0x0D, gphy_val | 0x0068);
+                                mdio_write(tp, 0x0D, gphy_val | 0x0069);
+                                mdio_write(tp, 0x0D, gphy_val | 0x006A);
+                                mdio_write(tp, 0x0D, gphy_val | 0x006B);
+                                mdio_write(tp, 0x0D, gphy_val | 0x006C);
+                        }
+                } else {
+                        mdio_write(tp, 0x1F, 0x0002);
+                        mdio_write(tp, 0x05, 0x2642);
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8330);
+                        mdio_write(tp, 0x06, 0x2642);
+                }
+
+                if (rtl8168_efuse_read(tp, 0x30) == 0x98) {
+                        mdio_write(tp, 0x1F, 0x0000);
+                        mdio_write(tp, 0x11, mdio_read(tp, 0x11) & ~BIT_1);
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x01, mdio_read(tp, 0x01) | BIT_9);
+                } else if (rtl8168_efuse_read(tp, 0x30) == 0x90) {
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x01, mdio_read(tp, 0x01) & ~BIT_9);
+                        mdio_write(tp, 0x1F, 0x0000);
+                        mdio_write(tp, 0x16, 0x5101);
+                }
+
+                mdio_write(tp, 0x1F, 0x0002);
+                gphy_val = mdio_read(tp, 0x02);
+                gphy_val &= ~BIT_10;
+                gphy_val &= ~BIT_9;
+                gphy_val |= BIT_8;
+                mdio_write(tp, 0x02, gphy_val);
+                gphy_val = mdio_read(tp, 0x03);
+                gphy_val &= ~BIT_15;
+                gphy_val &= ~BIT_14;
+                gphy_val &= ~BIT_13;
+                mdio_write(tp, 0x03, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x17, 0x0CC0);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                gphy_val = mdio_read(tp, 0x0F);
+                gphy_val |= BIT_4;
+                gphy_val |= BIT_2;
+                gphy_val |= BIT_1;
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x0F, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x001B);
+                if (mdio_read(tp, 0x06) == 0xB300) {
+                        mdio_write(tp, 0x1f, 0x0005);
+                        mdio_write(tp, 0x05, 0xfff6);
+                        mdio_write(tp, 0x06, 0x0080);
+                        mdio_write(tp, 0x05, 0x8000);
+                        mdio_write(tp, 0x06, 0xf8f9);
+                        mdio_write(tp, 0x06, 0xfaee);
+                        mdio_write(tp, 0x06, 0xf8ea);
+                        mdio_write(tp, 0x06, 0x00ee);
+                        mdio_write(tp, 0x06, 0xf8eb);
+                        mdio_write(tp, 0x06, 0x00e2);
+                        mdio_write(tp, 0x06, 0xf87c);
+                        mdio_write(tp, 0x06, 0xe3f8);
+                        mdio_write(tp, 0x06, 0x7da5);
+                        mdio_write(tp, 0x06, 0x1111);
+                        mdio_write(tp, 0x06, 0x12d2);
+                        mdio_write(tp, 0x06, 0x40d6);
+                        mdio_write(tp, 0x06, 0x4444);
+                        mdio_write(tp, 0x06, 0x0281);
+                        mdio_write(tp, 0x06, 0xc6d2);
+                        mdio_write(tp, 0x06, 0xa0d6);
+                        mdio_write(tp, 0x06, 0xaaaa);
+                        mdio_write(tp, 0x06, 0x0281);
+                        mdio_write(tp, 0x06, 0xc6ae);
+                        mdio_write(tp, 0x06, 0x0fa5);
+                        mdio_write(tp, 0x06, 0x4444);
+                        mdio_write(tp, 0x06, 0x02ae);
+                        mdio_write(tp, 0x06, 0x4da5);
+                        mdio_write(tp, 0x06, 0xaaaa);
+                        mdio_write(tp, 0x06, 0x02ae);
+                        mdio_write(tp, 0x06, 0x47af);
+                        mdio_write(tp, 0x06, 0x81c2);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4e00);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4d0f);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4c0f);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4f00);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x5100);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4aff);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4bff);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x30e1);
+                        mdio_write(tp, 0x06, 0x8331);
+                        mdio_write(tp, 0x06, 0x58fe);
+                        mdio_write(tp, 0x06, 0xe4f8);
+                        mdio_write(tp, 0x06, 0x8ae5);
+                        mdio_write(tp, 0x06, 0xf88b);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x32e1);
+                        mdio_write(tp, 0x06, 0x8333);
+                        mdio_write(tp, 0x06, 0x590f);
+                        mdio_write(tp, 0x06, 0xe283);
+                        mdio_write(tp, 0x06, 0x4d0c);
+                        mdio_write(tp, 0x06, 0x245a);
+                        mdio_write(tp, 0x06, 0xf01e);
+                        mdio_write(tp, 0x06, 0x12e4);
+                        mdio_write(tp, 0x06, 0xf88c);
+                        mdio_write(tp, 0x06, 0xe5f8);
+                        mdio_write(tp, 0x06, 0x8daf);
+                        mdio_write(tp, 0x06, 0x81c2);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4f10);
+                        mdio_write(tp, 0x06, 0xe483);
+                        mdio_write(tp, 0x06, 0x4fe0);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x7800);
+                        mdio_write(tp, 0x06, 0x9f0a);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4fa0);
+                        mdio_write(tp, 0x06, 0x10a5);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4e01);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4e78);
+                        mdio_write(tp, 0x06, 0x059e);
+                        mdio_write(tp, 0x06, 0x9ae0);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x7804);
+                        mdio_write(tp, 0x06, 0x9e10);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4e78);
+                        mdio_write(tp, 0x06, 0x039e);
+                        mdio_write(tp, 0x06, 0x0fe0);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x7801);
+                        mdio_write(tp, 0x06, 0x9e05);
+                        mdio_write(tp, 0x06, 0xae0c);
+                        mdio_write(tp, 0x06, 0xaf81);
+                        mdio_write(tp, 0x06, 0xa7af);
+                        mdio_write(tp, 0x06, 0x8152);
+                        mdio_write(tp, 0x06, 0xaf81);
+                        mdio_write(tp, 0x06, 0x8baf);
+                        mdio_write(tp, 0x06, 0x81c2);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4800);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4900);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x5110);
+                        mdio_write(tp, 0x06, 0xe483);
+                        mdio_write(tp, 0x06, 0x5158);
+                        mdio_write(tp, 0x06, 0x019f);
+                        mdio_write(tp, 0x06, 0xead0);
+                        mdio_write(tp, 0x06, 0x00d1);
+                        mdio_write(tp, 0x06, 0x801f);
+                        mdio_write(tp, 0x06, 0x66e2);
+                        mdio_write(tp, 0x06, 0xf8ea);
+                        mdio_write(tp, 0x06, 0xe3f8);
+                        mdio_write(tp, 0x06, 0xeb5a);
+                        mdio_write(tp, 0x06, 0xf81e);
+                        mdio_write(tp, 0x06, 0x20e6);
+                        mdio_write(tp, 0x06, 0xf8ea);
+                        mdio_write(tp, 0x06, 0xe5f8);
+                        mdio_write(tp, 0x06, 0xebd3);
+                        mdio_write(tp, 0x06, 0x02b3);
+                        mdio_write(tp, 0x06, 0xfee2);
+                        mdio_write(tp, 0x06, 0xf87c);
+                        mdio_write(tp, 0x06, 0xef32);
+                        mdio_write(tp, 0x06, 0x5b80);
+                        mdio_write(tp, 0x06, 0xe3f8);
+                        mdio_write(tp, 0x06, 0x7d9e);
+                        mdio_write(tp, 0x06, 0x037d);
+                        mdio_write(tp, 0x06, 0xffff);
+                        mdio_write(tp, 0x06, 0x0d58);
+                        mdio_write(tp, 0x06, 0x1c55);
+                        mdio_write(tp, 0x06, 0x1a65);
+                        mdio_write(tp, 0x06, 0x11a1);
+                        mdio_write(tp, 0x06, 0x90d3);
+                        mdio_write(tp, 0x06, 0xe283);
+                        mdio_write(tp, 0x06, 0x48e3);
+                        mdio_write(tp, 0x06, 0x8349);
+                        mdio_write(tp, 0x06, 0x1b56);
+                        mdio_write(tp, 0x06, 0xab08);
+                        mdio_write(tp, 0x06, 0xef56);
+                        mdio_write(tp, 0x06, 0xe683);
+                        mdio_write(tp, 0x06, 0x48e7);
+                        mdio_write(tp, 0x06, 0x8349);
+                        mdio_write(tp, 0x06, 0x10d1);
+                        mdio_write(tp, 0x06, 0x801f);
+                        mdio_write(tp, 0x06, 0x66a0);
+                        mdio_write(tp, 0x06, 0x04b9);
+                        mdio_write(tp, 0x06, 0xe283);
+                        mdio_write(tp, 0x06, 0x48e3);
+                        mdio_write(tp, 0x06, 0x8349);
+                        mdio_write(tp, 0x06, 0xef65);
+                        mdio_write(tp, 0x06, 0xe283);
+                        mdio_write(tp, 0x06, 0x4ae3);
+                        mdio_write(tp, 0x06, 0x834b);
+                        mdio_write(tp, 0x06, 0x1b56);
+                        mdio_write(tp, 0x06, 0xaa0e);
+                        mdio_write(tp, 0x06, 0xef56);
+                        mdio_write(tp, 0x06, 0xe683);
+                        mdio_write(tp, 0x06, 0x4ae7);
+                        mdio_write(tp, 0x06, 0x834b);
+                        mdio_write(tp, 0x06, 0xe283);
+                        mdio_write(tp, 0x06, 0x4de6);
+                        mdio_write(tp, 0x06, 0x834c);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4da0);
+                        mdio_write(tp, 0x06, 0x000c);
+                        mdio_write(tp, 0x06, 0xaf81);
+                        mdio_write(tp, 0x06, 0x8be0);
+                        mdio_write(tp, 0x06, 0x834d);
+                        mdio_write(tp, 0x06, 0x10e4);
+                        mdio_write(tp, 0x06, 0x834d);
+                        mdio_write(tp, 0x06, 0xae04);
+                        mdio_write(tp, 0x06, 0x80e4);
+                        mdio_write(tp, 0x06, 0x834d);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x4e78);
+                        mdio_write(tp, 0x06, 0x039e);
+                        mdio_write(tp, 0x06, 0x0be0);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x7804);
+                        mdio_write(tp, 0x06, 0x9e04);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4e02);
+                        mdio_write(tp, 0x06, 0xe083);
+                        mdio_write(tp, 0x06, 0x32e1);
+                        mdio_write(tp, 0x06, 0x8333);
+                        mdio_write(tp, 0x06, 0x590f);
+                        mdio_write(tp, 0x06, 0xe283);
+                        mdio_write(tp, 0x06, 0x4d0c);
+                        mdio_write(tp, 0x06, 0x245a);
+                        mdio_write(tp, 0x06, 0xf01e);
+                        mdio_write(tp, 0x06, 0x12e4);
+                        mdio_write(tp, 0x06, 0xf88c);
+                        mdio_write(tp, 0x06, 0xe5f8);
+                        mdio_write(tp, 0x06, 0x8de0);
+                        mdio_write(tp, 0x06, 0x8330);
+                        mdio_write(tp, 0x06, 0xe183);
+                        mdio_write(tp, 0x06, 0x3168);
+                        mdio_write(tp, 0x06, 0x01e4);
+                        mdio_write(tp, 0x06, 0xf88a);
+                        mdio_write(tp, 0x06, 0xe5f8);
+                        mdio_write(tp, 0x06, 0x8bae);
+                        mdio_write(tp, 0x06, 0x37ee);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x03e0);
+                        mdio_write(tp, 0x06, 0x834c);
+                        mdio_write(tp, 0x06, 0xe183);
+                        mdio_write(tp, 0x06, 0x4d1b);
+                        mdio_write(tp, 0x06, 0x019e);
+                        mdio_write(tp, 0x06, 0x04aa);
+                        mdio_write(tp, 0x06, 0xa1ae);
+                        mdio_write(tp, 0x06, 0xa8ee);
+                        mdio_write(tp, 0x06, 0x834e);
+                        mdio_write(tp, 0x06, 0x04ee);
+                        mdio_write(tp, 0x06, 0x834f);
+                        mdio_write(tp, 0x06, 0x00ae);
+                        mdio_write(tp, 0x06, 0xabe0);
+                        mdio_write(tp, 0x06, 0x834f);
+                        mdio_write(tp, 0x06, 0x7803);
+                        mdio_write(tp, 0x06, 0x9f14);
+                        mdio_write(tp, 0x06, 0xee83);
+                        mdio_write(tp, 0x06, 0x4e05);
+                        mdio_write(tp, 0x06, 0xd240);
+                        mdio_write(tp, 0x06, 0xd655);
+                        mdio_write(tp, 0x06, 0x5402);
+                        mdio_write(tp, 0x06, 0x81c6);
+                        mdio_write(tp, 0x06, 0xd2a0);
+                        mdio_write(tp, 0x06, 0xd6ba);
+                        mdio_write(tp, 0x06, 0x0002);
+                        mdio_write(tp, 0x06, 0x81c6);
+                        mdio_write(tp, 0x06, 0xfefd);
+                        mdio_write(tp, 0x06, 0xfc05);
+                        mdio_write(tp, 0x06, 0xf8e0);
+                        mdio_write(tp, 0x06, 0xf860);
+                        mdio_write(tp, 0x06, 0xe1f8);
+                        mdio_write(tp, 0x06, 0x6168);
+                        mdio_write(tp, 0x06, 0x02e4);
+                        mdio_write(tp, 0x06, 0xf860);
+                        mdio_write(tp, 0x06, 0xe5f8);
+                        mdio_write(tp, 0x06, 0x61e0);
+                        mdio_write(tp, 0x06, 0xf848);
+                        mdio_write(tp, 0x06, 0xe1f8);
+                        mdio_write(tp, 0x06, 0x4958);
+                        mdio_write(tp, 0x06, 0x0f1e);
+                        mdio_write(tp, 0x06, 0x02e4);
+                        mdio_write(tp, 0x06, 0xf848);
+                        mdio_write(tp, 0x06, 0xe5f8);
+                        mdio_write(tp, 0x06, 0x49d0);
+                        mdio_write(tp, 0x06, 0x0002);
+                        mdio_write(tp, 0x06, 0x820a);
+                        mdio_write(tp, 0x06, 0xbf83);
+                        mdio_write(tp, 0x06, 0x50ef);
+                        mdio_write(tp, 0x06, 0x46dc);
+                        mdio_write(tp, 0x06, 0x19dd);
+                        mdio_write(tp, 0x06, 0xd001);
+                        mdio_write(tp, 0x06, 0x0282);
+                        mdio_write(tp, 0x06, 0x0a02);
+                        mdio_write(tp, 0x06, 0x8226);
+                        mdio_write(tp, 0x06, 0xe0f8);
+                        mdio_write(tp, 0x06, 0x60e1);
+                        mdio_write(tp, 0x06, 0xf861);
+                        mdio_write(tp, 0x06, 0x58fd);
+                        mdio_write(tp, 0x06, 0xe4f8);
+                        mdio_write(tp, 0x06, 0x60e5);
+                        mdio_write(tp, 0x06, 0xf861);
+                        mdio_write(tp, 0x06, 0xfc04);
+                        mdio_write(tp, 0x06, 0xf9fa);
+                        mdio_write(tp, 0x06, 0xfbc6);
+                        mdio_write(tp, 0x06, 0xbff8);
+                        mdio_write(tp, 0x06, 0x40be);
+                        mdio_write(tp, 0x06, 0x8350);
+                        mdio_write(tp, 0x06, 0xa001);
+                        mdio_write(tp, 0x06, 0x0107);
+                        mdio_write(tp, 0x06, 0x1b89);
+                        mdio_write(tp, 0x06, 0xcfd2);
+                        mdio_write(tp, 0x06, 0x08eb);
+                        mdio_write(tp, 0x06, 0xdb19);
+                        mdio_write(tp, 0x06, 0xb2fb);
+                        mdio_write(tp, 0x06, 0xfffe);
+                        mdio_write(tp, 0x06, 0xfd04);
+                        mdio_write(tp, 0x06, 0xf8e0);
+                        mdio_write(tp, 0x06, 0xf848);
+                        mdio_write(tp, 0x06, 0xe1f8);
+                        mdio_write(tp, 0x06, 0x4968);
+                        mdio_write(tp, 0x06, 0x08e4);
+                        mdio_write(tp, 0x06, 0xf848);
+                        mdio_write(tp, 0x06, 0xe5f8);
+                        mdio_write(tp, 0x06, 0x4958);
+                        mdio_write(tp, 0x06, 0xf7e4);
+                        mdio_write(tp, 0x06, 0xf848);
+                        mdio_write(tp, 0x06, 0xe5f8);
+                        mdio_write(tp, 0x06, 0x49fc);
+                        mdio_write(tp, 0x06, 0x044d);
+                        mdio_write(tp, 0x06, 0x2000);
+                        mdio_write(tp, 0x06, 0x024e);
+                        mdio_write(tp, 0x06, 0x2200);
+                        mdio_write(tp, 0x06, 0x024d);
+                        mdio_write(tp, 0x06, 0xdfff);
+                        mdio_write(tp, 0x06, 0x014e);
+                        mdio_write(tp, 0x06, 0xddff);
+                        mdio_write(tp, 0x06, 0x01f8);
+                        mdio_write(tp, 0x06, 0xfafb);
+                        mdio_write(tp, 0x06, 0xef79);
+                        mdio_write(tp, 0x06, 0xbff8);
+                        mdio_write(tp, 0x06, 0x22d8);
+                        mdio_write(tp, 0x06, 0x19d9);
+                        mdio_write(tp, 0x06, 0x5884);
+                        mdio_write(tp, 0x06, 0x9f09);
+                        mdio_write(tp, 0x06, 0xbf82);
+                        mdio_write(tp, 0x06, 0x6dd6);
+                        mdio_write(tp, 0x06, 0x8275);
+                        mdio_write(tp, 0x06, 0x0201);
+                        mdio_write(tp, 0x06, 0x4fef);
+                        mdio_write(tp, 0x06, 0x97ff);
+                        mdio_write(tp, 0x06, 0xfefc);
+                        mdio_write(tp, 0x06, 0x0517);
+                        mdio_write(tp, 0x06, 0xfffe);
+                        mdio_write(tp, 0x06, 0x0117);
+                        mdio_write(tp, 0x06, 0x0001);
+                        mdio_write(tp, 0x06, 0x0200);
+                        mdio_write(tp, 0x05, 0x83d8);
+                        mdio_write(tp, 0x06, 0x8000);
+                        mdio_write(tp, 0x05, 0x83d6);
+                        mdio_write(tp, 0x06, 0x824f);
+                        mdio_write(tp, 0x02, 0x2010);
+                        mdio_write(tp, 0x03, 0xdc00);
+                        mdio_write(tp, 0x1f, 0x0000);
+                        mdio_write(tp, 0x0b, 0x0600);
+                        mdio_write(tp, 0x1f, 0x0005);
+                        mdio_write(tp, 0x05, 0xfff6);
+                        mdio_write(tp, 0x06, 0x00fc);
+                        mdio_write(tp, 0x1f, 0x0000);
+                }
+
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x0D, 0xF880);
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_11) {
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x10, 0x0008);
+                mdio_write(tp, 0x0D, 0x006C);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x17, 0x0CC0);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x0B, 0xA4D8);
+                mdio_write(tp, 0x09, 0x281C);
+                mdio_write(tp, 0x07, 0x2883);
+                mdio_write(tp, 0x0A, 0x6B35);
+                mdio_write(tp, 0x1D, 0x3DA4);
+                mdio_write(tp, 0x1C, 0xEFFD);
+                mdio_write(tp, 0x14, 0x7F52);
+                mdio_write(tp, 0x18, 0x7FC6);
+                mdio_write(tp, 0x08, 0x0601);
+                mdio_write(tp, 0x06, 0x4063);
+                mdio_write(tp, 0x10, 0xF074);
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x13, 0x0789);
+                mdio_write(tp, 0x12, 0xF4BD);
+                mdio_write(tp, 0x1A, 0x04FD);
+                mdio_write(tp, 0x14, 0x84B0);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x00, 0x9200);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x01, 0x0340);
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x04, 0x4000);
+                mdio_write(tp, 0x03, 0x1D21);
+                mdio_write(tp, 0x02, 0x0C32);
+                mdio_write(tp, 0x01, 0x0200);
+                mdio_write(tp, 0x00, 0x5554);
+                mdio_write(tp, 0x04, 0x4800);
+                mdio_write(tp, 0x04, 0x4000);
+                mdio_write(tp, 0x04, 0xF000);
+                mdio_write(tp, 0x03, 0xDF01);
+                mdio_write(tp, 0x02, 0xDF20);
+                mdio_write(tp, 0x01, 0x101A);
+                mdio_write(tp, 0x00, 0xA0FF);
+                mdio_write(tp, 0x04, 0xF800);
+                mdio_write(tp, 0x04, 0xF000);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x0023);
+                mdio_write(tp, 0x16, 0x0000);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                gphy_val = mdio_read(tp, 0x0D);
+                gphy_val |= BIT_5;
+                mdio_write(tp, 0x0D, gphy_val);
+        } else if (tp->mcfg == CFG_METHOD_12 || tp->mcfg == CFG_METHOD_13) {
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x17, 0x0CC0);
+
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x002D);
+                mdio_write(tp, 0x18, 0x0040);
+
+                mdio_write(tp, 0x1F, 0x0000);
+                gphy_val = mdio_read(tp, 0x0D);
+                gphy_val |= BIT_5;
+                mdio_write(tp, 0x0D, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                gphy_val = mdio_read(tp, 0x0C);
+                gphy_val |= BIT_10;
+                mdio_write(tp, 0x0C, gphy_val);
+        } else if (tp->mcfg == CFG_METHOD_14 || tp->mcfg == CFG_METHOD_15) {
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x0023);
+                gphy_val = mdio_read(tp, 0x17) | BIT_1;
+                if (tp->RequiredSecLanDonglePatch)
+                        gphy_val &= ~(BIT_2);
+                else
+                        gphy_val |= (BIT_2);
+                mdio_write(tp, 0x17, gphy_val);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x05, 0x8b80);
+                mdio_write(tp, 0x06, 0xc896);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x0B, 0x6C20);
+                mdio_write(tp, 0x07, 0x2872);
+                mdio_write(tp, 0x1C, 0xEFFF);
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x14, 0x6420);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                gphy_val = mdio_read(tp, 0x08) & 0x00FF;
+                mdio_write(tp, 0x08, gphy_val | 0x8000);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x002D);
+                gphy_val = mdio_read(tp, 0x18);
+                mdio_write(tp, 0x18, gphy_val | 0x0010);
+                mdio_write(tp, 0x1F, 0x0000);
+                gphy_val = mdio_read(tp, 0x14);
+                mdio_write(tp, 0x14, gphy_val | 0x8000);
+
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x00, 0x080B);
+                mdio_write(tp, 0x0B, 0x09D7);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1f, 0x0000);
+                                mdio_write(tp, 0x15, 0x1006);
+                        }
+                }
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x19, 0x7F46);
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8AD2);
+                mdio_write(tp, 0x06, 0x6810);
+                mdio_write(tp, 0x05, 0x8AD4);
+                mdio_write(tp, 0x06, 0x8002);
+                mdio_write(tp, 0x05, 0x8ADE);
+                mdio_write(tp, 0x06, 0x8025);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x002F);
+                mdio_write(tp, 0x15, 0x1919);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x002D);
+                gphy_val = mdio_read(tp, 0x18);
+                mdio_write(tp, 0x18, gphy_val | 0x0040);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B86);
+                gphy_val = mdio_read(tp, 0x06);
+                mdio_write(tp, 0x06, gphy_val | 0x0001);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x00AC);
+                mdio_write(tp, 0x18, 0x0006);
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_16) {
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B80);
+                gphy_val = mdio_read(tp, 0x06);
+                gphy_val |= BIT_2 | BIT_1;
+                mdio_write(tp, 0x06, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0004);
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x002D);
+                gphy_val = mdio_read(tp, 0x18);
+                gphy_val |= BIT_4;
+                mdio_write(tp, 0x18, gphy_val);
+                mdio_write(tp, 0x1f, 0x0002);
+                mdio_write(tp, 0x1f, 0x0000);
+                gphy_val = mdio_read(tp, 0x14);
+                gphy_val |= BIT_15;
+                mdio_write(tp, 0x14, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x15, 0x1006);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B86);
+                gphy_val = mdio_read(tp, 0x06);
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x06, gphy_val);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0001);
+                mdio_write(tp, 0x0B, 0x6C14);
+                mdio_write(tp, 0x14, 0x7F3D);
+                mdio_write(tp, 0x1C, 0xFAFE);
+                mdio_write(tp, 0x08, 0x07C5);
+                mdio_write(tp, 0x10, 0xF090);
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x14, 0x641A);
+                mdio_write(tp, 0x1A, 0x0606);
+                mdio_write(tp, 0x12, 0xF480);
+                mdio_write(tp, 0x13, 0x0747);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0004);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x0078);
+                mdio_write(tp, 0x15, 0xA408);
+                mdio_write(tp, 0x17, 0x5100);
+                mdio_write(tp, 0x19, 0x0008);
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x0D, 0x0207);
+                mdio_write(tp, 0x02, 0x5FD0);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0004);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x00A1);
+                gphy_val = mdio_read(tp, 0x1A);
+                gphy_val &= ~BIT_2;
+                mdio_write(tp, 0x1A, gphy_val);
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0004);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x002D);
+                gphy_val = mdio_read(tp, 0x16);
+                gphy_val |= BIT_5;
+                mdio_write(tp, 0x16, gphy_val);
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0004);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x00AC);
+                mdio_write(tp, 0x18, 0x0006);
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x09, 0xA20F);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B5B);
+                mdio_write(tp, 0x06, 0x9222);
+                mdio_write(tp, 0x05, 0x8B6D);
+                mdio_write(tp, 0x06, 0x8000);
+                mdio_write(tp, 0x05, 0x8B76);
+                mdio_write(tp, 0x06, 0x8000);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                if (pdev->subsystem_vendor == 0x1043 &&
+                    pdev->subsystem_device == 0x13F7) {
+
+                        static const u16 evl_phy_value[] = {
+                                0x8B56, 0x8B5F, 0x8B68, 0x8B71,
+                                0x8B7A, 0x8A7B, 0x8A7E, 0x8A81,
+                                0x8A84, 0x8A87
+                        };
+
+                        mdio_write(tp, 0x1F, 0x0005);
+                        for (i = 0; i < ARRAY_SIZE(evl_phy_value); i++) {
+                                mdio_write(tp, 0x05, evl_phy_value[i]);
+                                gphy_val = (0xAA << 8) | (mdio_read(tp, 0x06) & 0xFF);
+                                mdio_write(tp, 0x06, gphy_val);
+                        }
+                        mdio_write(tp, 0x1F, 0x0007);
+                        mdio_write(tp, 0x1E, 0x0078);
+                        mdio_write(tp, 0x17, 0x51AA);
+                        mdio_write(tp, 0x1F, 0x0000);
+                }
+
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x05, 0x8B54);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_11);
+                mdio_write(tp, 0x05, 0x8B5D);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_11);
+                mdio_write(tp, 0x05, 0x8A7C);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A7F);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) | BIT_8);
+                mdio_write(tp, 0x05, 0x8A82);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A85);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A88);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B85);
+                gphy_val = mdio_read(tp, 0x06) | BIT_14 | BIT_15;
+                mdio_write(tp, 0x06, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_17) {
+                if (pdev->subsystem_vendor == 0x144d &&
+                    pdev->subsystem_device == 0xc0a6) {
+                        mdio_write(tp, 0x1F, 0x0001);
+                        mdio_write(tp, 0x0e, 0x6b7f);
+                        mdio_write(tp, 0x1f, 0x0000);
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8B86);
+                        gphy_val = mdio_read(tp, 0x06);
+                        gphy_val |= BIT_4;
+                        mdio_write(tp, 0x06, gphy_val);
+                        mdio_write(tp, 0x1f, 0x0000);
+                } else {
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8B80);
+                        gphy_val = mdio_read(tp, 0x06);
+                        gphy_val |= BIT_2 | BIT_1;
+                        mdio_write(tp, 0x06, gphy_val);
+                        mdio_write(tp, 0x1f, 0x0000);
+
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8B86);
+                        gphy_val = mdio_read(tp, 0x06);
+                        gphy_val &= ~BIT_4;
+                        mdio_write(tp, 0x06, gphy_val);
+                        mdio_write(tp, 0x1f, 0x0000);
+                }
+
+                mdio_write(tp, 0x1f, 0x0004);
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x002D);
+                gphy_val = mdio_read(tp, 0x18);
+                gphy_val |= BIT_4;
+                mdio_write(tp, 0x18, gphy_val);
+                mdio_write(tp, 0x1f, 0x0002);
+                mdio_write(tp, 0x1f, 0x0000);
+                gphy_val = mdio_read(tp, 0x14);
+                gphy_val |= BIT_15;
+                mdio_write(tp, 0x14, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B86);
+                gphy_val = mdio_read(tp, 0x06);
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x06, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0004);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x00AC);
+                mdio_write(tp, 0x18, 0x0006);
+                mdio_write(tp, 0x1F, 0x0002);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x09, 0xA20F);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B85);
+                gphy_val = mdio_read(tp, 0x06) | BIT_14 | BIT_15;
+                mdio_write(tp, 0x06, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B5B);
+                mdio_write(tp, 0x06, 0x9222);
+                mdio_write(tp, 0x05, 0x8B6D);
+                mdio_write(tp, 0x06, 0x8000);
+                mdio_write(tp, 0x05, 0x8B76);
+                mdio_write(tp, 0x06, 0x8000);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                if (pdev->subsystem_vendor == 0x1043 &&
+                    pdev->subsystem_device == 0x13F7) {
+
+                        static const u16 evl_phy_value[] = {
+                                0x8B56, 0x8B5F, 0x8B68, 0x8B71,
+                                0x8B7A, 0x8A7B, 0x8A7E, 0x8A81,
+                                0x8A84, 0x8A87
+                        };
+
+                        mdio_write(tp, 0x1F, 0x0005);
+                        for (i = 0; i < ARRAY_SIZE(evl_phy_value); i++) {
+                                mdio_write(tp, 0x05, evl_phy_value[i]);
+                                gphy_val = (0xAA << 8) | (mdio_read(tp, 0x06) & 0xFF);
+                                mdio_write(tp, 0x06, gphy_val);
+                        }
+                        mdio_write(tp, 0x1F, 0x0007);
+                        mdio_write(tp, 0x1E, 0x0078);
+                        mdio_write(tp, 0x17, 0x51AA);
+                        mdio_write(tp, 0x1F, 0x0000);
+                }
+
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x05, 0x8B54);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_11);
+                mdio_write(tp, 0x05, 0x8B5D);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_11);
+                mdio_write(tp, 0x05, 0x8A7C);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A7F);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) | BIT_8);
+                mdio_write(tp, 0x05, 0x8A82);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A85);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A88);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1f, 0x0000);
+                                gphy_val = mdio_read(tp, 0x15);
+                                gphy_val |= BIT_12;
+                                mdio_write(tp, 0x15, gphy_val);
+                        }
+                }
+        } else if (tp->mcfg == CFG_METHOD_18) {
+                if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8b80);
+                        gphy_val = mdio_read(tp, 0x06);
+                        gphy_val |= BIT_2 | BIT_1;
+                        mdio_write(tp, 0x06, gphy_val);
+                        mdio_write(tp, 0x1F, 0x0000);
+                }
+
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x002D);
+                gphy_val = mdio_read(tp, 0x18);
+                gphy_val |= BIT_4;
+                mdio_write(tp, 0x18, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+                gphy_val = mdio_read(tp, 0x14);
+                gphy_val |= BIT_15;
+                mdio_write(tp, 0x14, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B86);
+                gphy_val = mdio_read(tp, 0x06);
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x06, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B85);
+                gphy_val = mdio_read(tp, 0x06);
+                gphy_val |= BIT_14;
+                mdio_write(tp, 0x06, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x09, 0xA20F);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B55);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x05, 0x8B5E);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x05, 0x8B67);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x05, 0x8B70);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x0078);
+                mdio_write(tp, 0x17, 0x0000);
+                mdio_write(tp, 0x19, 0x00FB);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B79);
+                mdio_write(tp, 0x06, 0xAA00);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0003);
+                mdio_write(tp, 0x01, 0x328A);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x05, 0x8B54);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_11);
+                mdio_write(tp, 0x05, 0x8B5D);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_11);
+                mdio_write(tp, 0x05, 0x8A7C);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A7F);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) | BIT_8);
+                mdio_write(tp, 0x05, 0x8A82);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A85);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A88);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                        mdio_write(tp, 0x1f, 0x0005);
+                        mdio_write(tp, 0x05, 0x8b85);
+                        mdio_write(tp, 0x06, mdio_read(tp, 0x06) | BIT_15);
+                        mdio_write(tp, 0x1f, 0x0000);
+                }
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1f, 0x0000);
+                                gphy_val = mdio_read(tp, 0x15);
+                                gphy_val |= BIT_12;
+                                mdio_write(tp, 0x15, gphy_val);
+                        }
+                }
+        } else if (tp->mcfg == CFG_METHOD_19) {
+                if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8b80);
+                        gphy_val = mdio_read(tp, 0x06);
+                        gphy_val |= BIT_2 | BIT_1;
+                        mdio_write(tp, 0x06, gphy_val);
+                        mdio_write(tp, 0x1F, 0x0000);
+                }
+
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x002D);
+                gphy_val = mdio_read(tp, 0x18);
+                gphy_val |= BIT_4;
+                mdio_write(tp, 0x18, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+                gphy_val = mdio_read(tp, 0x14);
+                gphy_val |= BIT_15;
+                mdio_write(tp, 0x14, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B86);
+                gphy_val = mdio_read(tp, 0x06);
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x06, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x05, 0x8B54);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_11);
+                mdio_write(tp, 0x05, 0x8B5D);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_11);
+                mdio_write(tp, 0x05, 0x8A7C);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A7F);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) | BIT_8);
+                mdio_write(tp, 0x05, 0x8A82);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A85);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A88);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                        mdio_write(tp, 0x1f, 0x0005);
+                        mdio_write(tp, 0x05, 0x8b85);
+                        mdio_write(tp, 0x06, mdio_read(tp, 0x06) | BIT_15);
+                        mdio_write(tp, 0x1f, 0x0000);
+                }
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1f, 0x0000);
+                                gphy_val = mdio_read(tp, 0x15);
+                                gphy_val |= BIT_12;
+                                mdio_write(tp, 0x15, gphy_val);
+                        }
+                }
+        } else if (tp->mcfg == CFG_METHOD_20) {
+
+                if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8b80);
+                        gphy_val = mdio_read(tp, 0x06);
+                        gphy_val |= BIT_2 | BIT_1;
+                        mdio_write(tp, 0x06, gphy_val);
+                        mdio_write(tp, 0x1F, 0x0000);
+                }
+
+                mdio_write(tp, 0x1f, 0x0007);
+                mdio_write(tp, 0x1e, 0x002D);
+                gphy_val = mdio_read(tp, 0x18);
+                gphy_val |= BIT_4;
+                mdio_write(tp, 0x18, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+                gphy_val = mdio_read(tp, 0x14);
+                gphy_val |= BIT_15;
+                mdio_write(tp, 0x14, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B86);
+                gphy_val = mdio_read(tp, 0x06);
+                gphy_val |= BIT_0;
+                mdio_write(tp, 0x06, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B85);
+                gphy_val = mdio_read(tp, 0x06);
+                gphy_val |= BIT_14;
+                mdio_write(tp, 0x06, gphy_val);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0003);
+                mdio_write(tp, 0x09, 0xA20F);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B55);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x05, 0x8B5E);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x05, 0x8B67);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x05, 0x8B70);
+                mdio_write(tp, 0x06, 0x0000);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, 0x1F, 0x0007);
+                mdio_write(tp, 0x1E, 0x0078);
+                mdio_write(tp, 0x17, 0x0000);
+                mdio_write(tp, 0x19, 0x00FB);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0005);
+                mdio_write(tp, 0x05, 0x8B79);
+                mdio_write(tp, 0x06, 0xAA00);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1f, 0x0005);
+                mdio_write(tp, 0x05, 0x8B54);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_11);
+                mdio_write(tp, 0x05, 0x8B5D);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_11);
+                mdio_write(tp, 0x05, 0x8A7C);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A7F);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) | BIT_8);
+                mdio_write(tp, 0x05, 0x8A82);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A85);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x05, 0x8A88);
+                mdio_write(tp, 0x06, mdio_read(tp, 0x06) & ~BIT_8);
+                mdio_write(tp, 0x1f, 0x0000);
+
+                if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                        mdio_write(tp, 0x1f, 0x0005);
+                        mdio_write(tp, 0x05, 0x8b85);
+                        mdio_write(tp, 0x06, mdio_read(tp, 0x06) | BIT_15);
+                        mdio_write(tp, 0x1f, 0x0000);
+                }
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1f, 0x0000);
+                                gphy_val = mdio_read(tp, 0x15);
+                                gphy_val |= BIT_12;
+                                mdio_write(tp, 0x15, gphy_val);
+                        }
+                }
+        } else if (tp->mcfg == CFG_METHOD_21) {
+                mdio_write(tp, 0x1F, 0x0A46);
+                gphy_val = mdio_read(tp, 0x10);
+                mdio_write(tp, 0x1F, 0x0BCC);
+                if (gphy_val & BIT_8)
+                        ClearEthPhyBit(tp, 0x12, BIT_15);
+                else
+                        SetEthPhyBit(tp, 0x12, BIT_15);
+                mdio_write(tp, 0x1F, 0x0A46);
+                gphy_val = mdio_read(tp, 0x13);
+                mdio_write(tp, 0x1F, 0x0C41);
+                if (gphy_val & BIT_8)
+                        SetEthPhyBit(tp, 0x15, BIT_1);
+                else
+                        ClearEthPhyBit(tp, 0x15, BIT_1);
+
+                mdio_write(tp, 0x1F, 0x0A44);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_2 | BIT_3);
+
+                mdio_write(tp, 0x1F, 0x0BCC);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) & ~BIT_8);
+                mdio_write(tp, 0x1F, 0x0A44);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_7);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_6);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8084);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) & ~(BIT_14 | BIT_13));
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_12);
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_1);
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_0);
+
+                mdio_write(tp, 0x1F, 0x0A4B);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_2);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8012);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) | BIT_15);
+
+                mdio_write(tp, 0x1F, 0x0C42);
+                gphy_val = mdio_read(tp, 0x11);
+                gphy_val |= BIT_14;
+                gphy_val &= ~BIT_13;
+                mdio_write(tp, 0x11, gphy_val);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x809A);
+                mdio_write(tp, 0x14, 0x8022);
+                mdio_write(tp, 0x13, 0x80A0);
+                gphy_val = mdio_read(tp, 0x14) & 0x00FF;
+                gphy_val |= 0x1000;
+                mdio_write(tp, 0x14, gphy_val);
+                mdio_write(tp, 0x13, 0x8088);
+                mdio_write(tp, 0x14, 0x9222);
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1F, 0x0A43);
+                                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_2);
+                        }
+                }
+
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_22) {
+                //do nothing
+        } else if (tp->mcfg == CFG_METHOD_23) {
+                mdio_write(tp, 0x1F, 0x0A44);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | (BIT_3 | BIT_2));
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0BCC);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) & ~BIT_8);
+                mdio_write(tp, 0x1F, 0x0A44);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_7);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_6);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8084);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) & ~(BIT_14 | BIT_13));
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_12);
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_1);
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_0);
+
+                mdio_write(tp, 0x1F, 0x0A4B);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_2);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8012);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) | BIT_15);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0C42);
+                ClearAndSetEthPhyBit(tp,
+                                     0x11,
+                                     BIT_13,
+                                     BIT_14
+                                    );
+                mdio_write(tp, 0x1F, 0x0000);
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1F, 0x0A43);
+                                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_2);
+                        }
+                }
+        } else if (tp->mcfg == CFG_METHOD_24) {
+                mdio_write(tp, 0x1F, 0x0BCC);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) & ~BIT_8);
+                mdio_write(tp, 0x1F, 0x0A44);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_7);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_6);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8084);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) & ~(BIT_14 | BIT_13));
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_12);
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_1);
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_0);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8012);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) | BIT_15);
+
+                mdio_write(tp, 0x1F, 0x0C42);
+                gphy_val = mdio_read(tp, 0x11);
+                gphy_val |= BIT_14;
+                gphy_val &= ~BIT_13;
+                mdio_write(tp, 0x11, gphy_val);
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1F, 0x0A43);
+                                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_2);
+                        }
+                }
+        } else if (tp->mcfg == CFG_METHOD_25 || tp->mcfg == CFG_METHOD_26) {
+                mdio_write(tp, 0x1F, 0x0BCC);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) & ~BIT_8);
+                mdio_write(tp, 0x1F, 0x0A44);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_7);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_6);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8084);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) & ~(BIT_14 | BIT_13));
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_12);
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_1);
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_0);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8012);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) | BIT_15);
+
+                mdio_write(tp, 0x1F, 0x0BCE);
+                mdio_write(tp, 0x12, 0x8860);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x80F3);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x8B00);
+                mdio_write(tp, 0x13, 0x80F0);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x3A00);
+                mdio_write(tp, 0x13, 0x80EF);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x0500);
+                mdio_write(tp, 0x13, 0x80F6);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x6E00);
+                mdio_write(tp, 0x13, 0x80EC);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x6800);
+                mdio_write(tp, 0x13, 0x80ED);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x7C00);
+                mdio_write(tp, 0x13, 0x80F2);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0xF400);
+                mdio_write(tp, 0x13, 0x80F4);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x8500);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8110);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0xA800);
+                mdio_write(tp, 0x13, 0x810F);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x1D00);
+                mdio_write(tp, 0x13, 0x8111);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0xF500);
+                mdio_write(tp, 0x13, 0x8113);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x6100);
+                mdio_write(tp, 0x13, 0x8115);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x9200);
+                mdio_write(tp, 0x13, 0x810E);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x0400);
+                mdio_write(tp, 0x13, 0x810C);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x7C00);
+                mdio_write(tp, 0x13, 0x810B);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x5A00);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x80D1);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0xFF00);
+                mdio_write(tp, 0x13, 0x80CD);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x9E00);
+                mdio_write(tp, 0x13, 0x80D3);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x0E00);
+                mdio_write(tp, 0x13, 0x80D5);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0xCA00);
+                mdio_write(tp, 0x13, 0x80D7);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x8400);
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1F, 0x0A43);
+                                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_2);
+                        }
+                }
+        } else if (tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28) {
+                mdio_write(tp, 0x1F, 0x0BCC);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) & ~BIT_8);
+                mdio_write(tp, 0x1F, 0x0A44);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_7);
+                mdio_write(tp, 0x11, mdio_read(tp, 0x11) | BIT_6);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8084);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) & ~(BIT_14 | BIT_13));
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_12);
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_1);
+                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_0);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8012);
+                mdio_write(tp, 0x14, mdio_read(tp, 0x14) | BIT_15);
+
+                mdio_write(tp, 0x1F, 0x0C42);
+                mdio_write(tp, 0x11, (mdio_read(tp, 0x11) & ~BIT_13) | BIT_14);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x80F3);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x8B00);
+                mdio_write(tp, 0x13, 0x80F0);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x3A00);
+                mdio_write(tp, 0x13, 0x80EF);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x0500);
+                mdio_write(tp, 0x13, 0x80F6);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x6E00);
+                mdio_write(tp, 0x13, 0x80EC);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x6800);
+                mdio_write(tp, 0x13, 0x80ED);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x7C00);
+                mdio_write(tp, 0x13, 0x80F2);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0xF400);
+                mdio_write(tp, 0x13, 0x80F4);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x8500);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8110);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0xA800);
+                mdio_write(tp, 0x13, 0x810F);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x1D00);
+                mdio_write(tp, 0x13, 0x8111);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0xF500);
+                mdio_write(tp, 0x13, 0x8113);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x6100);
+                mdio_write(tp, 0x13, 0x8115);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x9200);
+                mdio_write(tp, 0x13, 0x810E);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x0400);
+                mdio_write(tp, 0x13, 0x810C);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x7C00);
+                mdio_write(tp, 0x13, 0x810B);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x5A00);
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x80D1);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0xFF00);
+                mdio_write(tp, 0x13, 0x80CD);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x9E00);
+                mdio_write(tp, 0x13, 0x80D3);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x0E00);
+                mdio_write(tp, 0x13, 0x80D5);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0xCA00);
+                mdio_write(tp, 0x13, 0x80D7);
+                mdio_write(tp, 0x14, (mdio_read(tp, 0x14) & ~0xFF00) | 0x8400);
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1F, 0x0A43);
+                                mdio_write(tp, 0x10, mdio_read(tp, 0x10) | BIT_2);
+                        }
+                }
+        } else if (tp->mcfg == CFG_METHOD_29) {
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x809b);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xF800 ,
+                                      0x8000
+                                    );
+                mdio_write(tp, 0x13, 0x80A2);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x8000
+                                    );
+                mdio_write(tp, 0x13, 0x80A4);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x8500
+                                    );
+                mdio_write(tp, 0x13, 0x809C);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0xbd00
+                                    );
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x80AD);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xF800 ,
+                                      0x7000
+                                    );
+                mdio_write(tp, 0x13, 0x80B4);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x5000
+                                    );
+                mdio_write(tp, 0x13, 0x80AC);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x4000
+                                    );
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x808E);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x1200
+                                    );
+                mdio_write(tp, 0x13, 0x8090);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0xE500
+                                    );
+                mdio_write(tp, 0x13, 0x8092);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x9F00
+                                    );
+                mdio_write(tp, 0x1F, 0x0000);
+
+                if (tp->HwHasWrRamCodeToMicroP) {
+                        u16 dout_tapbin;
+
+                        dout_tapbin = 0x0000;
+                        mdio_write( tp, 0x1F, 0x0A46 );
+                        gphy_val = mdio_read( tp, 0x13 );
+                        gphy_val &= (BIT_1|BIT_0);
+                        gphy_val <<= 2;
+                        dout_tapbin |= gphy_val;
+
+                        gphy_val = mdio_read( tp, 0x12 );
+                        gphy_val &= (BIT_15|BIT_14);
+                        gphy_val >>= 14;
+                        dout_tapbin |= gphy_val;
+
+                        dout_tapbin = ~( dout_tapbin^BIT_3 );
+                        dout_tapbin <<= 12;
+                        dout_tapbin &= 0xF000;
+
+                        mdio_write( tp, 0x1F, 0x0A43 );
+
+                        mdio_write( tp, 0x13, 0x827A );
+                        ClearAndSetEthPhyBit( tp,
+                                              0x14,
+                                              BIT_15|BIT_14|BIT_13|BIT_12,
+                                              dout_tapbin
+                                            );
+
+
+                        mdio_write( tp, 0x13, 0x827B );
+                        ClearAndSetEthPhyBit( tp,
+                                              0x14,
+                                              BIT_15|BIT_14|BIT_13|BIT_12,
+                                              dout_tapbin
+                                            );
+
+
+                        mdio_write( tp, 0x13, 0x827C );
+                        ClearAndSetEthPhyBit( tp,
+                                              0x14,
+                                              BIT_15|BIT_14|BIT_13|BIT_12,
+                                              dout_tapbin
+                                            );
+
+
+                        mdio_write( tp, 0x13, 0x827D );
+                        ClearAndSetEthPhyBit( tp,
+                                              0x14,
+                                              BIT_15|BIT_14|BIT_13|BIT_12,
+                                              dout_tapbin
+                                            );
+
+                        mdio_write(tp, 0x1F, 0x0A43);
+                        mdio_write(tp, 0x13, 0x8011);
+                        SetEthPhyBit(tp, 0x14, BIT_11);
+                        mdio_write(tp, 0x1F, 0x0A42);
+                        SetEthPhyBit(tp, 0x16, BIT_1);
+                }
+
+                mdio_write(tp, 0x1F, 0x0A44);
+                SetEthPhyBit( tp, 0x11, BIT_11 );
+                mdio_write(tp, 0x1F, 0x0000);
+
+
+                mdio_write(tp, 0x1F, 0x0BCA);
+                ClearAndSetEthPhyBit( tp,
+                                      0x17,
+                                      (BIT_13 | BIT_12) ,
+                                      BIT_14
+                                    );
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x803F);
+                ClearEthPhyBit( tp, 0x14, (BIT_13 | BIT_12));
+                mdio_write(tp, 0x13, 0x8047);
+                ClearEthPhyBit( tp, 0x14, (BIT_13 | BIT_12));
+                mdio_write(tp, 0x13, 0x804F);
+                ClearEthPhyBit( tp, 0x14, (BIT_13 | BIT_12));
+                mdio_write(tp, 0x13, 0x8057);
+                ClearEthPhyBit( tp, 0x14, (BIT_13 | BIT_12));
+                mdio_write(tp, 0x13, 0x805F);
+                ClearEthPhyBit( tp, 0x14, (BIT_13 | BIT_12));
+                mdio_write(tp, 0x13, 0x8067 );
+                ClearEthPhyBit( tp, 0x14, (BIT_13 | BIT_12));
+                mdio_write(tp, 0x13, 0x806F );
+                ClearEthPhyBit( tp, 0x14, (BIT_13 | BIT_12));
+                mdio_write(tp, 0x1F, 0x0000);
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1F, 0x0A43);
+                                SetEthPhyBit( tp, 0x10, BIT_2 );
+                                mdio_write(tp, 0x1F, 0x0000);
+                        }
+                }
+        } else if (tp->mcfg == CFG_METHOD_30) {
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x808A);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0,
+                                      0x0A );
+
+                if (tp->HwHasWrRamCodeToMicroP) {
+                        mdio_write(tp, 0x1F, 0x0A43);
+                        mdio_write(tp, 0x13, 0x8011);
+                        SetEthPhyBit(tp, 0x14, BIT_11);
+                        mdio_write(tp, 0x1F, 0x0A42);
+                        SetEthPhyBit(tp, 0x16, BIT_1);
+                }
+
+                mdio_write(tp, 0x1F, 0x0A44);
+                SetEthPhyBit( tp, 0x11, BIT_11 );
+                mdio_write(tp, 0x1F, 0x0000);
+
+                if (tp->RequireAdcBiasPatch) {
+                        mdio_write(tp, 0x1F, 0x0BCF);
+                        mdio_write(tp, 0x16, tp->AdcBiasPatchIoffset);
+                        mdio_write(tp, 0x1F, 0x0000);
+                }
+
+                {
+                        u16 rlen;
+
+                        mdio_write(tp, 0x1F, 0x0BCD);
+                        gphy_val = mdio_read( tp, 0x16 );
+                        gphy_val &= 0x000F;
+
+                        if ( gphy_val > 3 ) {
+                                rlen = gphy_val - 3;
+                        } else {
+                                rlen = 0;
+                        }
+
+                        gphy_val = rlen | (rlen<<4) | (rlen<<8) | (rlen<<12);
+
+                        mdio_write(tp, 0x1F, 0x0BCD);
+                        mdio_write(tp, 0x17, gphy_val);
+                        mdio_write(tp, 0x1F, 0x0000);
+                }
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1F, 0x0A43);
+                                SetEthPhyBit( tp, 0x10, BIT_2 );
+                                mdio_write(tp, 0x1F, 0x0000);
+                        }
+                }
+        } else if (tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x808E);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x4800
+                                    );
+                mdio_write(tp, 0x13, 0x8090);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0xCC00
+                                    );
+                mdio_write(tp, 0x13, 0x8092);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0xB000
+                                    );
+                mdio_write(tp, 0x13, 0x8088);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x6000
+                                    );
+                mdio_write(tp, 0x13, 0x808B);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0x3F00 ,
+                                      0x0B00
+                                    );
+                mdio_write(tp, 0x13, 0x808D);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0x1F00 ,
+                                      0x0600
+                                    );
+                mdio_write(tp, 0x13, 0x808C);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0xB000
+                                    );
+
+                mdio_write(tp, 0x13, 0x80A0);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x2800
+                                    );
+                mdio_write(tp, 0x13, 0x80A2);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x5000
+                                    );
+                mdio_write(tp, 0x13, 0x809B);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xF800 ,
+                                      0xB000
+                                    );
+                mdio_write(tp, 0x13, 0x809A);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x4B00
+                                    );
+                mdio_write(tp, 0x13, 0x809D);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0x3F00 ,
+                                      0x0800
+                                    );
+                mdio_write(tp, 0x13, 0x80A1);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x7000
+                                    );
+                mdio_write(tp, 0x13, 0x809F);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0x1F00 ,
+                                      0x0300
+                                    );
+                mdio_write(tp, 0x13, 0x809E);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x8800
+                                    );
+
+                mdio_write(tp, 0x13, 0x80B2);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x2200
+                                    );
+                mdio_write(tp, 0x13, 0x80AD);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xF800 ,
+                                      0x9800
+                                    );
+                mdio_write(tp, 0x13, 0x80AF);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0x3F00 ,
+                                      0x0800
+                                    );
+                mdio_write(tp, 0x13, 0x80B3);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x6F00
+                                    );
+                mdio_write(tp, 0x13, 0x80B1);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0x1F00 ,
+                                      0x0300
+                                    );
+                mdio_write(tp, 0x13, 0x80B0);
+                ClearAndSetEthPhyBit( tp,
+                                      0x14,
+                                      0xFF00 ,
+                                      0x9300
+                                    );
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8011);
+                SetEthPhyBit(tp, 0x14, BIT_11);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0A44);
+                SetEthPhyBit(tp, 0x11, BIT_11);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                mdio_write(tp, 0x1F, 0x0A43);
+                mdio_write(tp, 0x13, 0x8016);
+                SetEthPhyBit(tp, 0x14, BIT_10);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                if (aspm) {
+                        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                                mdio_write(tp, 0x1F, 0x0A43);
+                                SetEthPhyBit( tp, 0x10, BIT_2 );
+                        }
+                }
+        }
+
+#ifdef ENABLE_FIBER_SUPPORT
+        if (HW_FIBER_MODE_ENABLED(tp))
+                rtl8168_hw_fiber_phy_config(dev);
+#endif //ENABLE_FIBER_SUPPORT
+
+        //EthPhyPPSW
+        if (tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+            tp->mcfg == CFG_METHOD_24 || tp->mcfg == CFG_METHOD_25 ||
+            tp->mcfg == CFG_METHOD_26) {
+                //disable EthPhyPPSW
+                mdio_write(tp, 0x1F, 0x0BCD);
+                mdio_write(tp, 0x14, 0x5065);
+                mdio_write(tp, 0x14, 0xD065);
+                mdio_write(tp, 0x1F, 0x0BC8);
+                mdio_write(tp, 0x11, 0x5655);
+                mdio_write(tp, 0x1F, 0x0BCD);
+                mdio_write(tp, 0x14, 0x1065);
+                mdio_write(tp, 0x14, 0x9065);
+                mdio_write(tp, 0x14, 0x1065);
+                mdio_write(tp, 0x1F, 0x0000);
+        } else if (tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30) {
+                //enable EthPhyPPSW
+                mdio_write(tp, 0x1F, 0x0A44);
+                SetEthPhyBit( tp, 0x11, BIT_7 );
+                mdio_write(tp, 0x1F, 0x0000);
+        }
+
+        /*ocp phy power saving*/
+        if (tp->mcfg == CFG_METHOD_25 || tp->mcfg == CFG_METHOD_26 ||
+            tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28 ||
+            tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30 ||
+            tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                if (aspm) {
+                        mdio_write_phy_ocp(tp, 0x0C41, 0x13, 0x0000);
+                        mdio_write_phy_ocp(tp, 0x0C41, 0x13, 0x0050);
+                }
+        }
+
+        mdio_write(tp, 0x1F, 0x0000);
+
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+        if (tp->HwHasWrRamCodeToMicroP == TRUE) {
+                if (eee_enable == 1)
+                        rtl8168_enable_EEE(tp);
+                else
+                        rtl8168_disable_EEE(tp);
+        }
+}
+
+static inline void rtl8168_delete_esd_timer(struct net_device *dev, struct timer_list *timer)
+{
+        del_timer_sync(timer);
+}
+
+static inline void rtl8168_request_esd_timer(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct timer_list *timer = &tp->esd_timer;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+        setup_timer(timer, rtl8168_esd_timer, (unsigned long)dev);
+#else
+        timer_setup(timer, rtl8168_esd_timer, 0);
+#endif
+        mod_timer(timer, jiffies + RTL8168_ESD_TIMEOUT);
+}
+
+static inline void rtl8168_delete_link_timer(struct net_device *dev, struct timer_list *timer)
+{
+        del_timer_sync(timer);
+}
+
+static inline void rtl8168_request_link_timer(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct timer_list *timer = &tp->link_timer;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+        setup_timer(timer, rtl8168_link_timer, (unsigned long)dev);
+#else
+        timer_setup(timer, rtl8168_link_timer, 0);
+#endif
+        mod_timer(timer, jiffies + RTL8168_LINK_TIMEOUT);
+}
+
+#ifdef CONFIG_NET_POLL_CONTROLLER
+/*
+ * Polling 'interrupt' - used by things like netconsole to send skbs
+ * without having to re-enable interrupts. It's not called while
+ * the interrupt routine is executing.
+ */
+static void
+rtl8168_netpoll(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+
+        disable_irq(pdev->irq);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
+        rtl8168_interrupt(pdev->irq, dev, NULL);
+#else
+        rtl8168_interrupt(pdev->irq, dev);
+#endif
+        enable_irq(pdev->irq);
+}
+#endif
+
+static void
+rtl8168_get_bios_setting(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_9:
+        case CFG_METHOD_10:
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+        case CFG_METHOD_13:
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                tp->bios_setting = RTL_R32(0x8c);
+                break;
+        }
+}
+
+static void
+rtl8168_set_bios_setting(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_9:
+        case CFG_METHOD_10:
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+        case CFG_METHOD_13:
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                RTL_W32(0x8C, tp->bios_setting);
+                break;
+        }
+}
+
+static void
+rtl8168_init_software_variable(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        rtl8168_get_bios_setting(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+        case CFG_METHOD_13:
+                tp->HwSuppDashVer = 1;
+                break;
+        case CFG_METHOD_23:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                tp->HwSuppDashVer = 2;
+                break;
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                tp->HwSuppDashVer = 3;
+                break;
+        default:
+                tp->HwSuppDashVer = 0;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                tp->HwPkgDet = mac_ocp_read(tp, 0xDC00);
+                tp->HwPkgDet = (tp->HwPkgDet >> 3) & 0x0F;
+                break;
+        }
+
+        if (HW_DASH_SUPPORT_TYPE_3(tp) && tp->HwPkgDet == 0x06)
+                eee_enable = 0;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                tp->HwSuppNowIsOobVer = 1;
+                break;
+        }
+
+#ifdef ENABLE_REALWOW_SUPPORT
+        get_realwow_hw_version(dev);
+#endif //ENABLE_REALWOW_SUPPORT
+
+        if (HW_DASH_SUPPORT_DASH(tp) && rtl8168_check_dash(tp))
+                tp->DASH = 1;
+        else
+                tp->DASH = 0;
+
+        if (tp->DASH) {
+                if (HW_DASH_SUPPORT_TYPE_3(tp)) {
+                        u64 CmacMemPhysAddress;
+                        void __iomem *cmac_ioaddr = NULL;
+
+                        //map CMAC IO space
+                        CmacMemPhysAddress = rtl8168_csi_other_fun_read(tp, 0, 0x18);
+                        if (!(CmacMemPhysAddress & BIT_0)) {
+                                if (CmacMemPhysAddress & BIT_2)
+                                        CmacMemPhysAddress |=  (u64)rtl8168_csi_other_fun_read(tp, 0, 0x1C) << 32;
+
+                                CmacMemPhysAddress &=  0xFFFFFFF0;
+                                /* ioremap MMIO region */
+                                cmac_ioaddr = ioremap(CmacMemPhysAddress, R8168_REGS_SIZE);
+                        }
+
+                        if (cmac_ioaddr == NULL) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                                if (netif_msg_probe(tp))
+                                        dev_err(&pdev->dev, "cannot remap CMAC MMIO, aborting\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                        }
+
+                        if (cmac_ioaddr == NULL) {
+                                tp->DASH = 0;
+                        } else {
+                                tp->mapped_cmac_ioaddr = cmac_ioaddr;
+                        }
+                }
+        }
+
+#ifdef ENABLE_DASH_SUPPORT
+#ifdef ENABLE_DASH_PRINTER_SUPPORT
+        if (tp->DASH) {
+                if (HW_DASH_SUPPORT_TYPE_3(tp) && tp->HwPkgDet == 0x0F)
+                        tp->dash_printer_enabled = 1;
+                else if (HW_DASH_SUPPORT_TYPE_2(tp))
+                        tp->dash_printer_enabled = 1;
+        }
+#endif //ENABLE_DASH_PRINTER_SUPPORT
+#endif //ENABLE_DASH_SUPPORT
+
+        if (HW_DASH_SUPPORT_TYPE_2(tp))
+                tp->cmac_ioaddr = tp->mmio_addr;
+        else if	(HW_DASH_SUPPORT_TYPE_3(tp))
+                tp->cmac_ioaddr = tp->mapped_cmac_ioaddr;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_1:
+                tp->intr_mask = RxDescUnavail | RxFIFOOver | TxDescUnavail | TxOK | RxOK | SWInt;
+                tp->timer_intr_mask = PCSTimeout | RxFIFOOver;
+                break;
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+                tp->intr_mask = RxDescUnavail | TxDescUnavail | TxOK | RxOK | SWInt;
+                tp->timer_intr_mask = PCSTimeout;
+                break;
+        default:
+                tp->intr_mask = RxDescUnavail | TxOK | RxOK | SWInt;
+                tp->timer_intr_mask = PCSTimeout;
+                break;
+        }
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH) {
+                if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                        tp->timer_intr_mask |= ( ISRIMR_DASH_INTR_EN | ISRIMR_DASH_INTR_CMAC_RESET);
+                        tp->intr_mask |= ( ISRIMR_DASH_INTR_EN | ISRIMR_DASH_INTR_CMAC_RESET);
+                } else {
+                        tp->timer_intr_mask |= ( ISRIMR_DP_DASH_OK | ISRIMR_DP_HOST_OK | ISRIMR_DP_REQSYS_OK );
+                        tp->intr_mask |= ( ISRIMR_DP_DASH_OK | ISRIMR_DP_HOST_OK | ISRIMR_DP_REQSYS_OK );
+                }
+        }
+#endif
+        if (aspm) {
+                switch (tp->mcfg) {
+                case CFG_METHOD_21:
+                case CFG_METHOD_22:
+                case CFG_METHOD_23:
+                case CFG_METHOD_24:
+                case CFG_METHOD_25:
+                case CFG_METHOD_26:
+                case CFG_METHOD_27:
+                case CFG_METHOD_28:
+                case CFG_METHOD_29:
+                case CFG_METHOD_30:
+                case CFG_METHOD_31:
+                case CFG_METHOD_32:
+                        tp->org_pci_offset_99 = rtl8168_csi_fun0_read_byte(tp, 0x99);
+                        tp->org_pci_offset_99 &= ~(BIT_5|BIT_6);
+                        break;
+                }
+                switch (tp->mcfg) {
+                case CFG_METHOD_24:
+                case CFG_METHOD_25:
+                case CFG_METHOD_26:
+                case CFG_METHOD_27:
+                case CFG_METHOD_28:
+                case CFG_METHOD_29:
+                case CFG_METHOD_30:
+                        tp->org_pci_offset_180 = rtl8168_csi_fun0_read_byte(tp, 0x180);
+                        break;
+                case CFG_METHOD_31:
+                case CFG_METHOD_32:
+                        tp->org_pci_offset_180 = rtl8168_csi_fun0_read_byte(tp, 0x214);
+                        break;
+                }
+        }
+
+        pci_read_config_byte(pdev, 0x80, &tp->org_pci_offset_80);
+        pci_read_config_byte(pdev, 0x81, &tp->org_pci_offset_81);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+                if ((tp->features & RTL_FEATURE_MSI) && (tp->org_pci_offset_80 & BIT_1))
+                        tp->use_timer_interrrupt = FALSE;
+                else
+                        tp->use_timer_interrrupt = TRUE;
+                break;
+        default:
+                tp->use_timer_interrrupt = TRUE;
+                break;
+        }
+
+        if (timer_count == 0 || tp->mcfg == CFG_METHOD_DEFAULT)
+                tp->use_timer_interrrupt = FALSE;
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_1:
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+                tp->ShortPacketSwChecksum = TRUE;
+                break;
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+                tp->ShortPacketSwChecksum = TRUE;
+                tp->UseSwPaddingShortPkt = TRUE;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_30: {
+                u16 ioffset_p3, ioffset_p2, ioffset_p1, ioffset_p0;
+                u16 TmpUshort;
+
+                mac_ocp_write( tp, 0xDD02, 0x807D);
+                TmpUshort = mac_ocp_read( tp, 0xDD02 );
+                ioffset_p3 = ( (TmpUshort & BIT_7) >>7 );
+                ioffset_p3 <<= 3;
+                TmpUshort = mac_ocp_read( tp, 0xDD00 );
+
+                ioffset_p3 |= ((TmpUshort & (BIT_15 | BIT_14 | BIT_13))>>13);
+
+                ioffset_p2 = ((TmpUshort & (BIT_12|BIT_11|BIT_10|BIT_9))>>9);
+                ioffset_p1 = ((TmpUshort & (BIT_8|BIT_7|BIT_6|BIT_5))>>5);
+
+                ioffset_p0 = ( (TmpUshort & BIT_4) >>4 );
+                ioffset_p0 <<= 3;
+                ioffset_p0 |= (TmpUshort & (BIT_2| BIT_1 | BIT_0));
+
+                if ((ioffset_p3 == 0x0F) && (ioffset_p2 == 0x0F) && (ioffset_p1 == 0x0F) && (ioffset_p0 == 0x0F)) {
+                        tp->RequireAdcBiasPatch = FALSE;
+                } else {
+                        tp->RequireAdcBiasPatch = TRUE;
+                        tp->AdcBiasPatchIoffset = (ioffset_p3<<12)|(ioffset_p2<<8)|(ioffset_p1<<4)|(ioffset_p0);
+                }
+        }
+        break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32: {
+                u16 rg_saw_cnt;
+
+                mdio_write(tp, 0x1F, 0x0C42);
+                rg_saw_cnt = mdio_read(tp, 0x13);
+                rg_saw_cnt &= ~(BIT_15|BIT_14);
+                mdio_write(tp, 0x1F, 0x0000);
+
+                if ( rg_saw_cnt > 0) {
+                        tp->SwrCnt1msIni = 16000000/rg_saw_cnt;
+                        tp->SwrCnt1msIni &= 0x0FFF;
+
+                        tp->RequireAdjustUpsTxLinkPulseTiming = TRUE;
+                }
+        }
+        break;
+        }
+
+#ifdef ENABLE_FIBER_SUPPORT
+        switch(tp->mcfg) {
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                if ((pdev->subsystem_vendor == 0x1170 && pdev->subsystem_device == 0x0612) ||
+                    (pdev->subsystem_vendor == 0x1028 && pdev->subsystem_device == 0x080C))
+                        tp->HwFiberModeVer = FIBER_MODE_RTL8168H_RTL8211FS;
+                if((pdev->subsystem_vendor == 0x1d05 && pdev->subsystem_device == 0x2014))
+                        tp->HwFiberModeVer = FIBER_MODE_RTL8168H_MDI_SWITCH_RTL8211FS;
+                break;
+        }
+
+        if (HW_FIBER_MODE_ENABLED(tp))
+                tp->HwFiberStat = rtl8168_hw_fiber_get_connect_status(dev);
+
+        if (tp->HwFiberStat != FIBER_STAT_CONNECT)
+                tp->HwFiberModeVer = FIBER_MODE_NIC_ONLY;
+#endif //ENABLE_FIBER_SUPPORT
+
+        if (pdev->subsystem_vendor == 0x144d) {
+                if (pdev->subsystem_device == 0xc098 ||
+                    pdev->subsystem_device == 0xc0b1 ||
+                    pdev->subsystem_device == 0xc0b8)
+                        hwoptimize |= HW_PATCH_SAMSUNG_LAN_DONGLE;
+        }
+
+        if (hwoptimize & HW_PATCH_SAMSUNG_LAN_DONGLE) {
+                switch (tp->mcfg) {
+                case CFG_METHOD_14:
+                case CFG_METHOD_15:
+                case CFG_METHOD_16:
+                case CFG_METHOD_17:
+                case CFG_METHOD_18:
+                case CFG_METHOD_19:
+                case CFG_METHOD_20:
+                case CFG_METHOD_30:
+                        tp->RequiredSecLanDonglePatch = TRUE;
+                        break;
+                }
+        }
+#ifdef ENABLE_FIBER_SUPPORT
+        switch (tp->HwFiberModeVer) {
+        case FIBER_MODE_RTL8168H_RTL8211FS:
+        case FIBER_MODE_RTL8168H_MDI_SWITCH_RTL8211FS:
+                tp->RequiredSecLanDonglePatch = TRUE;
+                break;
+        }
+#endif //ENABLE_FIBER_SUPPORT
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                tp->HwSuppMagicPktVer = WAKEUP_MAGIC_PACKET_V2;
+                break;
+        case CFG_METHOD_DEFAULT:
+                tp->HwSuppMagicPktVer = WAKEUP_MAGIC_PACKET_NOT_SUPPORT;
+                break;
+        default:
+                tp->HwSuppMagicPktVer = WAKEUP_MAGIC_PACKET_V1;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+                tp->HwSuppCheckPhyDisableModeVer = 1;
+                break;
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                tp->HwSuppCheckPhyDisableModeVer = 2;
+                break;
+        case CFG_METHOD_23:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                tp->HwSuppCheckPhyDisableModeVer = 3;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                tp->HwSuppGigaForceMode = TRUE;
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_14;
+                break;
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_16;
+                break;
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_18;
+                break;
+        case CFG_METHOD_20:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_20;
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_21;
+                break;
+        case CFG_METHOD_23:
+        case CFG_METHOD_27:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_23;
+                break;
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_24;
+                break;
+        case CFG_METHOD_26:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_26;
+                break;
+        case CFG_METHOD_28:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_28;
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_29;
+                break;
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                tp->sw_ram_code_ver = NIC_RAMCODE_VERSION_CFG_METHOD_31;
+                break;
+        }
+
+        if (tp->HwIcVerUnknown) {
+                tp->NotWrRamCodeToMicroP = TRUE;
+                tp->NotWrMcuPatchCode = TRUE;
+        }
+
+        tp->NicCustLedValue = RTL_R16(CustomLED);
+
+        rtl8168_get_hw_wol(dev);
+
+        rtl8168_link_option((u8*)&autoneg_mode, (u32*)&speed_mode, (u8*)&duplex_mode, (u32*)&advertising_mode);
+
+        tp->autoneg = autoneg_mode;
+        tp->speed = speed_mode;
+        tp->duplex = duplex_mode;
+        tp->advertising = advertising_mode;
+
+        tp->max_jumbo_frame_size = rtl_chip_info[tp->chipset].jumbo_frame_sz;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,10,0)
+        /* MTU range: 60 - hw-specific max */
+        dev->min_mtu = ETH_ZLEN;
+        dev->max_mtu = tp->max_jumbo_frame_size;
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(4,10,0)
+}
+
+static void
+rtl8168_release_board(struct pci_dev *pdev,
+                      struct net_device *dev,
+                      void __iomem *ioaddr)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        rtl8168_set_bios_setting(dev);
+        rtl8168_rar_set(tp, tp->org_mac_addr);
+        tp->wol_enabled = WOL_DISABLED;
+
+
+	if (wol_enable) {
+		pci_write_config_byte(pdev, 0x44, 0x0B);
+		pci_write_config_byte(pdev, 0x45, 0x01);
+	} else {
+		if(!tp->DASH)
+			rtl8168_phy_power_down(dev);
+	}
+
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH)
+                FreeAllocatedDashShareMemory(dev);
+#endif
+
+        if (tp->mapped_cmac_ioaddr != NULL)
+                iounmap(tp->mapped_cmac_ioaddr);
+
+        iounmap(ioaddr);
+        pci_release_regions(pdev);
+        pci_disable_device(pdev);
+        free_netdev(dev);
+}
+
+static int
+rtl8168_get_mac_address(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        int i;
+        u8 mac_addr[MAC_ADDR_LEN];
+
+        for (i = 0; i < MAC_ADDR_LEN; i++)
+                mac_addr[i] = RTL_R8(MAC0 + i);
+
+        if (tp->mcfg == CFG_METHOD_18 ||
+            tp->mcfg == CFG_METHOD_19 ||
+            tp->mcfg == CFG_METHOD_20 ||
+            tp->mcfg == CFG_METHOD_21 ||
+            tp->mcfg == CFG_METHOD_22 ||
+            tp->mcfg == CFG_METHOD_23 ||
+            tp->mcfg == CFG_METHOD_24 ||
+            tp->mcfg == CFG_METHOD_25 ||
+            tp->mcfg == CFG_METHOD_26 ||
+            tp->mcfg == CFG_METHOD_27 ||
+            tp->mcfg == CFG_METHOD_28 ||
+            tp->mcfg == CFG_METHOD_29 ||
+            tp->mcfg == CFG_METHOD_30 ||
+            tp->mcfg == CFG_METHOD_31 ||
+            tp->mcfg == CFG_METHOD_32) {
+                *(u32*)&mac_addr[0] = rtl8168_eri_read(ioaddr, 0xE0, 4, ERIAR_ExGMAC);
+                *(u16*)&mac_addr[4] = rtl8168_eri_read(ioaddr, 0xE4, 2, ERIAR_ExGMAC);
+        } else {
+                if (tp->eeprom_type != EEPROM_TYPE_NONE) {
+                        u16 *pUshort = (u16*)mac_addr;
+                        /* Get MAC address from EEPROM */
+                        if (tp->mcfg == CFG_METHOD_16 ||
+                            tp->mcfg == CFG_METHOD_17 ||
+                            tp->mcfg == CFG_METHOD_18 ||
+                            tp->mcfg == CFG_METHOD_19 ||
+                            tp->mcfg == CFG_METHOD_20 ||
+                            tp->mcfg == CFG_METHOD_21 ||
+                            tp->mcfg == CFG_METHOD_22 ||
+                            tp->mcfg == CFG_METHOD_23 ||
+                            tp->mcfg == CFG_METHOD_24 ||
+                            tp->mcfg == CFG_METHOD_25 ||
+                            tp->mcfg == CFG_METHOD_26 ||
+                            tp->mcfg == CFG_METHOD_27 ||
+                            tp->mcfg == CFG_METHOD_28 ||
+                            tp->mcfg == CFG_METHOD_29 ||
+                            tp->mcfg == CFG_METHOD_30 ||
+                            tp->mcfg == CFG_METHOD_31 ||
+                            tp->mcfg == CFG_METHOD_32) {
+                                *pUshort++ = rtl_eeprom_read_sc(tp, 1);
+                                *pUshort++ = rtl_eeprom_read_sc(tp, 2);
+                                *pUshort = rtl_eeprom_read_sc(tp, 3);
+                        } else {
+                                *pUshort++ = rtl_eeprom_read_sc(tp, 7);
+                                *pUshort++ = rtl_eeprom_read_sc(tp, 8);
+                                *pUshort = rtl_eeprom_read_sc(tp, 9);
+                        }
+                }
+        }
+
+        if (!is_valid_ether_addr(mac_addr)) {
+                netif_err(tp, probe, dev, "Invalid ether addr %pM\n",
+                          mac_addr);
+                eth_hw_addr_random(dev);
+                ether_addr_copy(mac_addr, dev->dev_addr);
+                netif_info(tp, probe, dev, "Random ether addr %pM\n",
+                           mac_addr);
+                tp->random_mac = 1;
+        }
+
+        rtl8168_rar_set(tp, mac_addr);
+
+        for (i = 0; i < MAC_ADDR_LEN; i++) {
+                dev->dev_addr[i] = RTL_R8(MAC0 + i);
+                tp->org_mac_addr[i] = dev->dev_addr[i]; /* keep the original MAC address */
+        }
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+        memcpy(dev->perm_addr, dev->dev_addr, dev->addr_len);
+#endif
+//  memcpy(dev->dev_addr, dev->dev_addr, dev->addr_len);
+
+        return 0;
+}
+
+/**
+ * rtl8168_set_mac_address - Change the Ethernet Address of the NIC
+ * @dev: network interface device structure
+ * @p:   pointer to an address structure
+ *
+ * Return 0 on success, negative on failure
+ **/
+static int
+rtl8168_set_mac_address(struct net_device *dev,
+                        void *p)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct sockaddr *addr = p;
+        unsigned long flags;
+
+        if (!is_valid_ether_addr(addr->sa_data))
+                return -EADDRNOTAVAIL;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        memcpy(dev->dev_addr, addr->sa_data, dev->addr_len);
+
+        rtl8168_rar_set(tp, dev->dev_addr);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        return 0;
+}
+
+/******************************************************************************
+ * rtl8168_rar_set - Puts an ethernet address into a receive address register.
+ *
+ * tp - The private data structure for driver
+ * addr - Address to put into receive address register
+ *****************************************************************************/
+void
+rtl8168_rar_set(struct rtl8168_private *tp,
+                uint8_t *addr)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+        uint32_t rar_low = 0;
+        uint32_t rar_high = 0;
+
+        rar_low = ((uint32_t) addr[0] |
+                   ((uint32_t) addr[1] << 8) |
+                   ((uint32_t) addr[2] << 16) |
+                   ((uint32_t) addr[3] << 24));
+
+        rar_high = ((uint32_t) addr[4] |
+                    ((uint32_t) addr[5] << 8));
+
+        rtl8168_enable_cfg9346_write(tp);
+        RTL_W32(MAC0, rar_low);
+        RTL_W32(MAC4, rar_high);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+                RTL_W32(SecMAC0, rar_low);
+                RTL_W16(SecMAC4, (uint16_t)rar_high);
+                break;
+        }
+
+        if (tp->mcfg == CFG_METHOD_17) {
+                rtl8168_eri_write(ioaddr, 0xf0, 4, rar_low << 16, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xf4, 4, rar_low >> 16 | rar_high << 16, ERIAR_ExGMAC);
+        }
+
+        rtl8168_disable_cfg9346_write(tp);
+}
+
+#ifdef ETHTOOL_OPS_COMPAT
+static int ethtool_get_settings(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_cmd cmd = { ETHTOOL_GSET };
+        int err;
+
+        if (!ethtool_ops->get_settings)
+                return -EOPNOTSUPP;
+
+        err = ethtool_ops->get_settings(dev, &cmd);
+        if (err < 0)
+                return err;
+
+        if (copy_to_user(useraddr, &cmd, sizeof(cmd)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_settings(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_cmd cmd;
+
+        if (!ethtool_ops->set_settings)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&cmd, useraddr, sizeof(cmd)))
+                return -EFAULT;
+
+        return ethtool_ops->set_settings(dev, &cmd);
+}
+
+static int ethtool_get_drvinfo(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_drvinfo info;
+        struct ethtool_ops *ops = ethtool_ops;
+
+        if (!ops->get_drvinfo)
+                return -EOPNOTSUPP;
+
+        memset(&info, 0, sizeof(info));
+        info.cmd = ETHTOOL_GDRVINFO;
+        ops->get_drvinfo(dev, &info);
+
+        if (ops->self_test_count)
+                info.testinfo_len = ops->self_test_count(dev);
+        if (ops->get_stats_count)
+                info.n_stats = ops->get_stats_count(dev);
+        if (ops->get_regs_len)
+                info.regdump_len = ops->get_regs_len(dev);
+        if (ops->get_eeprom_len)
+                info.eedump_len = ops->get_eeprom_len(dev);
+
+        if (copy_to_user(useraddr, &info, sizeof(info)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_get_regs(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_regs regs;
+        struct ethtool_ops *ops = ethtool_ops;
+        void *regbuf;
+        int reglen, ret;
+
+        if (!ops->get_regs || !ops->get_regs_len)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&regs, useraddr, sizeof(regs)))
+                return -EFAULT;
+
+        reglen = ops->get_regs_len(dev);
+        if (regs.len > reglen)
+                regs.len = reglen;
+
+        regbuf = kmalloc(reglen, GFP_USER);
+        if (!regbuf)
+                return -ENOMEM;
+
+        ops->get_regs(dev, &regs, regbuf);
+
+        ret = -EFAULT;
+        if (copy_to_user(useraddr, &regs, sizeof(regs)))
+                goto out;
+        useraddr += offsetof(struct ethtool_regs, data);
+        if (copy_to_user(useraddr, regbuf, reglen))
+                goto out;
+        ret = 0;
+
+out:
+        kfree(regbuf);
+        return ret;
+}
+
+static int ethtool_get_wol(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_wolinfo wol = { ETHTOOL_GWOL };
+
+        if (!ethtool_ops->get_wol)
+                return -EOPNOTSUPP;
+
+        ethtool_ops->get_wol(dev, &wol);
+
+        if (copy_to_user(useraddr, &wol, sizeof(wol)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_wol(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_wolinfo wol;
+
+        if (!ethtool_ops->set_wol)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&wol, useraddr, sizeof(wol)))
+                return -EFAULT;
+
+        return ethtool_ops->set_wol(dev, &wol);
+}
+
+static int ethtool_get_msglevel(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GMSGLVL };
+
+        if (!ethtool_ops->get_msglevel)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_msglevel(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_msglevel(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata;
+
+        if (!ethtool_ops->set_msglevel)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&edata, useraddr, sizeof(edata)))
+                return -EFAULT;
+
+        ethtool_ops->set_msglevel(dev, edata.data);
+        return 0;
+}
+
+static int ethtool_nway_reset(struct net_device *dev)
+{
+        if (!ethtool_ops->nway_reset)
+                return -EOPNOTSUPP;
+
+        return ethtool_ops->nway_reset(dev);
+}
+
+static int ethtool_get_link(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GLINK };
+
+        if (!ethtool_ops->get_link)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_link(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_get_eeprom(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_eeprom eeprom;
+        struct ethtool_ops *ops = ethtool_ops;
+        u8 *data;
+        int ret;
+
+        if (!ops->get_eeprom || !ops->get_eeprom_len)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&eeprom, useraddr, sizeof(eeprom)))
+                return -EFAULT;
+
+        /* Check for wrap and zero */
+        if (eeprom.offset + eeprom.len <= eeprom.offset)
+                return -EINVAL;
+
+        /* Check for exceeding total eeprom len */
+        if (eeprom.offset + eeprom.len > ops->get_eeprom_len(dev))
+                return -EINVAL;
+
+        data = kmalloc(eeprom.len, GFP_USER);
+        if (!data)
+                return -ENOMEM;
+
+        ret = -EFAULT;
+        if (copy_from_user(data, useraddr + sizeof(eeprom), eeprom.len))
+                goto out;
+
+        ret = ops->get_eeprom(dev, &eeprom, data);
+        if (ret)
+                goto out;
+
+        ret = -EFAULT;
+        if (copy_to_user(useraddr, &eeprom, sizeof(eeprom)))
+                goto out;
+        if (copy_to_user(useraddr + sizeof(eeprom), data, eeprom.len))
+                goto out;
+        ret = 0;
+
+out:
+        kfree(data);
+        return ret;
+}
+
+static int ethtool_set_eeprom(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_eeprom eeprom;
+        struct ethtool_ops *ops = ethtool_ops;
+        u8 *data;
+        int ret;
+
+        if (!ops->set_eeprom || !ops->get_eeprom_len)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&eeprom, useraddr, sizeof(eeprom)))
+                return -EFAULT;
+
+        /* Check for wrap and zero */
+        if (eeprom.offset + eeprom.len <= eeprom.offset)
+                return -EINVAL;
+
+        /* Check for exceeding total eeprom len */
+        if (eeprom.offset + eeprom.len > ops->get_eeprom_len(dev))
+                return -EINVAL;
+
+        data = kmalloc(eeprom.len, GFP_USER);
+        if (!data)
+                return -ENOMEM;
+
+        ret = -EFAULT;
+        if (copy_from_user(data, useraddr + sizeof(eeprom), eeprom.len))
+                goto out;
+
+        ret = ops->set_eeprom(dev, &eeprom, data);
+        if (ret)
+                goto out;
+
+        if (copy_to_user(useraddr + sizeof(eeprom), data, eeprom.len))
+                ret = -EFAULT;
+
+out:
+        kfree(data);
+        return ret;
+}
+
+static int ethtool_get_coalesce(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_coalesce coalesce = { ETHTOOL_GCOALESCE };
+
+        if (!ethtool_ops->get_coalesce)
+                return -EOPNOTSUPP;
+
+        ethtool_ops->get_coalesce(dev, &coalesce);
+
+        if (copy_to_user(useraddr, &coalesce, sizeof(coalesce)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_coalesce(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_coalesce coalesce;
+
+        if (!ethtool_ops->get_coalesce)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&coalesce, useraddr, sizeof(coalesce)))
+                return -EFAULT;
+
+        return ethtool_ops->set_coalesce(dev, &coalesce);
+}
+
+static int ethtool_get_ringparam(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_ringparam ringparam = { ETHTOOL_GRINGPARAM };
+
+        if (!ethtool_ops->get_ringparam)
+                return -EOPNOTSUPP;
+
+        ethtool_ops->get_ringparam(dev, &ringparam);
+
+        if (copy_to_user(useraddr, &ringparam, sizeof(ringparam)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_ringparam(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_ringparam ringparam;
+
+        if (!ethtool_ops->get_ringparam)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&ringparam, useraddr, sizeof(ringparam)))
+                return -EFAULT;
+
+        return ethtool_ops->set_ringparam(dev, &ringparam);
+}
+
+static int ethtool_get_pauseparam(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_pauseparam pauseparam = { ETHTOOL_GPAUSEPARAM };
+
+        if (!ethtool_ops->get_pauseparam)
+                return -EOPNOTSUPP;
+
+        ethtool_ops->get_pauseparam(dev, &pauseparam);
+
+        if (copy_to_user(useraddr, &pauseparam, sizeof(pauseparam)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_pauseparam(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_pauseparam pauseparam;
+
+        if (!ethtool_ops->get_pauseparam)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&pauseparam, useraddr, sizeof(pauseparam)))
+                return -EFAULT;
+
+        return ethtool_ops->set_pauseparam(dev, &pauseparam);
+}
+
+static int ethtool_get_rx_csum(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GRXCSUM };
+
+        if (!ethtool_ops->get_rx_csum)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_rx_csum(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_rx_csum(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata;
+
+        if (!ethtool_ops->set_rx_csum)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&edata, useraddr, sizeof(edata)))
+                return -EFAULT;
+
+        ethtool_ops->set_rx_csum(dev, edata.data);
+        return 0;
+}
+
+static int ethtool_get_tx_csum(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GTXCSUM };
+
+        if (!ethtool_ops->get_tx_csum)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_tx_csum(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_tx_csum(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata;
+
+        if (!ethtool_ops->set_tx_csum)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&edata, useraddr, sizeof(edata)))
+                return -EFAULT;
+
+        return ethtool_ops->set_tx_csum(dev, edata.data);
+}
+
+static int ethtool_get_sg(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GSG };
+
+        if (!ethtool_ops->get_sg)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_sg(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_sg(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata;
+
+        if (!ethtool_ops->set_sg)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&edata, useraddr, sizeof(edata)))
+                return -EFAULT;
+
+        return ethtool_ops->set_sg(dev, edata.data);
+}
+
+static int ethtool_get_tso(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata = { ETHTOOL_GTSO };
+
+        if (!ethtool_ops->get_tso)
+                return -EOPNOTSUPP;
+
+        edata.data = ethtool_ops->get_tso(dev);
+
+        if (copy_to_user(useraddr, &edata, sizeof(edata)))
+                return -EFAULT;
+        return 0;
+}
+
+static int ethtool_set_tso(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_value edata;
+
+        if (!ethtool_ops->set_tso)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&edata, useraddr, sizeof(edata)))
+                return -EFAULT;
+
+        return ethtool_ops->set_tso(dev, edata.data);
+}
+
+static int ethtool_self_test(struct net_device *dev, char *useraddr)
+{
+        struct ethtool_test test;
+        struct ethtool_ops *ops = ethtool_ops;
+        u64 *data;
+        int ret;
+
+        if (!ops->self_test || !ops->self_test_count)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&test, useraddr, sizeof(test)))
+                return -EFAULT;
+
+        test.len = ops->self_test_count(dev);
+        data = kmalloc(test.len * sizeof(u64), GFP_USER);
+        if (!data)
+                return -ENOMEM;
+
+        ops->self_test(dev, &test, data);
+
+        ret = -EFAULT;
+        if (copy_to_user(useraddr, &test, sizeof(test)))
+                goto out;
+        useraddr += sizeof(test);
+        if (copy_to_user(useraddr, data, test.len * sizeof(u64)))
+                goto out;
+        ret = 0;
+
+out:
+        kfree(data);
+        return ret;
+}
+
+static int ethtool_get_strings(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_gstrings gstrings;
+        struct ethtool_ops *ops = ethtool_ops;
+        u8 *data;
+        int ret;
+
+        if (!ops->get_strings)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&gstrings, useraddr, sizeof(gstrings)))
+                return -EFAULT;
+
+        switch (gstrings.string_set) {
+        case ETH_SS_TEST:
+                if (!ops->self_test_count)
+                        return -EOPNOTSUPP;
+                gstrings.len = ops->self_test_count(dev);
+                break;
+        case ETH_SS_STATS:
+                if (!ops->get_stats_count)
+                        return -EOPNOTSUPP;
+                gstrings.len = ops->get_stats_count(dev);
+                break;
+        default:
+                return -EINVAL;
+        }
+
+        data = kmalloc(gstrings.len * ETH_GSTRING_LEN, GFP_USER);
+        if (!data)
+                return -ENOMEM;
+
+        ops->get_strings(dev, gstrings.string_set, data);
+
+        ret = -EFAULT;
+        if (copy_to_user(useraddr, &gstrings, sizeof(gstrings)))
+                goto out;
+        useraddr += sizeof(gstrings);
+        if (copy_to_user(useraddr, data, gstrings.len * ETH_GSTRING_LEN))
+                goto out;
+        ret = 0;
+
+out:
+        kfree(data);
+        return ret;
+}
+
+static int ethtool_phys_id(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_value id;
+
+        if (!ethtool_ops->phys_id)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&id, useraddr, sizeof(id)))
+                return -EFAULT;
+
+        return ethtool_ops->phys_id(dev, id.data);
+}
+
+static int ethtool_get_stats(struct net_device *dev, void *useraddr)
+{
+        struct ethtool_stats stats;
+        struct ethtool_ops *ops = ethtool_ops;
+        u64 *data;
+        int ret;
+
+        if (!ops->get_ethtool_stats || !ops->get_stats_count)
+                return -EOPNOTSUPP;
+
+        if (copy_from_user(&stats, useraddr, sizeof(stats)))
+                return -EFAULT;
+
+        stats.n_stats = ops->get_stats_count(dev);
+        data = kmalloc(stats.n_stats * sizeof(u64), GFP_USER);
+        if (!data)
+                return -ENOMEM;
+
+        ops->get_ethtool_stats(dev, &stats, data);
+
+        ret = -EFAULT;
+        if (copy_to_user(useraddr, &stats, sizeof(stats)))
+                goto out;
+        useraddr += sizeof(stats);
+        if (copy_to_user(useraddr, data, stats.n_stats * sizeof(u64)))
+                goto out;
+        ret = 0;
+
+out:
+        kfree(data);
+        return ret;
+}
+
+static int ethtool_ioctl(struct ifreq *ifr)
+{
+        struct net_device *dev = __dev_get_by_name(ifr->ifr_name);
+        void *useraddr = (void *) ifr->ifr_data;
+        u32 ethcmd;
+
+        /*
+         * XXX: This can be pushed down into the ethtool_* handlers that
+         * need it.  Keep existing behaviour for the moment.
+         */
+        if (!capable(CAP_NET_ADMIN))
+                return -EPERM;
+
+        if (!dev || !netif_device_present(dev))
+                return -ENODEV;
+
+        if (copy_from_user(&ethcmd, useraddr, sizeof (ethcmd)))
+                return -EFAULT;
+
+        switch (ethcmd) {
+        case ETHTOOL_GSET:
+                return ethtool_get_settings(dev, useraddr);
+        case ETHTOOL_SSET:
+                return ethtool_set_settings(dev, useraddr);
+        case ETHTOOL_GDRVINFO:
+                return ethtool_get_drvinfo(dev, useraddr);
+        case ETHTOOL_GREGS:
+                return ethtool_get_regs(dev, useraddr);
+        case ETHTOOL_GWOL:
+                return ethtool_get_wol(dev, useraddr);
+        case ETHTOOL_SWOL:
+                return ethtool_set_wol(dev, useraddr);
+        case ETHTOOL_GMSGLVL:
+                return ethtool_get_msglevel(dev, useraddr);
+        case ETHTOOL_SMSGLVL:
+                return ethtool_set_msglevel(dev, useraddr);
+        case ETHTOOL_NWAY_RST:
+                return ethtool_nway_reset(dev);
+        case ETHTOOL_GLINK:
+                return ethtool_get_link(dev, useraddr);
+        case ETHTOOL_GEEPROM:
+                return ethtool_get_eeprom(dev, useraddr);
+        case ETHTOOL_SEEPROM:
+                return ethtool_set_eeprom(dev, useraddr);
+        case ETHTOOL_GCOALESCE:
+                return ethtool_get_coalesce(dev, useraddr);
+        case ETHTOOL_SCOALESCE:
+                return ethtool_set_coalesce(dev, useraddr);
+        case ETHTOOL_GRINGPARAM:
+                return ethtool_get_ringparam(dev, useraddr);
+        case ETHTOOL_SRINGPARAM:
+                return ethtool_set_ringparam(dev, useraddr);
+        case ETHTOOL_GPAUSEPARAM:
+                return ethtool_get_pauseparam(dev, useraddr);
+        case ETHTOOL_SPAUSEPARAM:
+                return ethtool_set_pauseparam(dev, useraddr);
+        case ETHTOOL_GRXCSUM:
+                return ethtool_get_rx_csum(dev, useraddr);
+        case ETHTOOL_SRXCSUM:
+                return ethtool_set_rx_csum(dev, useraddr);
+        case ETHTOOL_GTXCSUM:
+                return ethtool_get_tx_csum(dev, useraddr);
+        case ETHTOOL_STXCSUM:
+                return ethtool_set_tx_csum(dev, useraddr);
+        case ETHTOOL_GSG:
+                return ethtool_get_sg(dev, useraddr);
+        case ETHTOOL_SSG:
+                return ethtool_set_sg(dev, useraddr);
+        case ETHTOOL_GTSO:
+                return ethtool_get_tso(dev, useraddr);
+        case ETHTOOL_STSO:
+                return ethtool_set_tso(dev, useraddr);
+        case ETHTOOL_TEST:
+                return ethtool_self_test(dev, useraddr);
+        case ETHTOOL_GSTRINGS:
+                return ethtool_get_strings(dev, useraddr);
+        case ETHTOOL_PHYS_ID:
+                return ethtool_phys_id(dev, useraddr);
+        case ETHTOOL_GSTATS:
+                return ethtool_get_stats(dev, useraddr);
+        default:
+                return -EOPNOTSUPP;
+        }
+
+        return -EOPNOTSUPP;
+}
+#endif //ETHTOOL_OPS_COMPAT
+
+static int
+rtl8168_do_ioctl(struct net_device *dev,
+                 struct ifreq *ifr,
+                 int cmd)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct mii_ioctl_data *data = if_mii(ifr);
+        int ret;
+        unsigned long flags;
+
+        ret = 0;
+        switch (cmd) {
+        case SIOCGMIIPHY:
+                data->phy_id = 32; /* Internal PHY */
+                break;
+
+        case SIOCGMIIREG:
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0000);
+                data->val_out = mdio_read(tp, data->reg_num);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        case SIOCSMIIREG:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_write(tp, 0x1F, 0x0000);
+                mdio_write(tp, data->reg_num, data->val_in);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+#ifdef ETHTOOL_OPS_COMPAT
+        case SIOCETHTOOL:
+                ret = ethtool_ioctl(ifr);
+                break;
+#endif
+        case SIOCDEVPRIVATE_RTLASF:
+                if (!netif_running(dev)) {
+                        ret = -ENODEV;
+                        break;
+                }
+
+                ret = rtl8168_asf_ioctl(dev, ifr);
+                break;
+
+#ifdef ENABLE_DASH_SUPPORT
+        case SIOCDEVPRIVATE_RTLDASH:
+                if (!netif_running(dev)) {
+                        ret = -ENODEV;
+                        break;
+                }
+                if (!capable(CAP_NET_ADMIN)) {
+                        ret = -EPERM;
+                        break;
+                }
+
+                ret = rtl8168_dash_ioctl(dev, ifr);
+                break;
+#endif
+
+#ifdef ENABLE_REALWOW_SUPPORT
+        case SIOCDEVPRIVATE_RTLREALWOW:
+                if (!netif_running(dev)) {
+                        ret = -ENODEV;
+                        break;
+                }
+
+                ret = rtl8168_realwow_ioctl(dev, ifr);
+                break;
+#endif
+
+        case SIOCRTLTOOL:
+                ret = rtltool_ioctl(tp, ifr);
+                break;
+
+        default:
+                ret = -EOPNOTSUPP;
+                break;
+        }
+
+        return ret;
+}
+
+static void
+rtl8168_phy_power_up(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+
+        if (rtl8168_is_in_phy_disable_mode(dev)) {
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                return;
+        }
+
+        mdio_write(tp, 0x1F, 0x0000);
+        switch (tp->mcfg) {
+        case CFG_METHOD_1:
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        case CFG_METHOD_6:
+        case CFG_METHOD_7:
+        case CFG_METHOD_8:
+        case CFG_METHOD_9:
+        case CFG_METHOD_10:
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+        case CFG_METHOD_13:
+                mdio_write(tp, 0x0E, 0x0000);
+                break;
+        }
+        mdio_write(tp, MII_BMCR, BMCR_ANENABLE);
+
+        //wait mdc/mdio ready
+        switch (tp->mcfg) {
+        case CFG_METHOD_23:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+                mdelay(10);
+                break;
+        }
+
+        //wait ups resume (phy state 3)
+        switch (tp->mcfg) {
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                rtl8168_wait_phy_ups_resume(dev, 3);
+                break;
+        };
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+}
+
+static void
+rtl8168_phy_power_down(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 csi_tmp;
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->phy_lock, flags);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1AB, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~( BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
+                rtl8168_eri_write(ioaddr, 0x1AB, 1, csi_tmp, ERIAR_ExGMAC);
+                break;
+        }
+
+        mdio_write(tp, 0x1F, 0x0000);
+        switch (tp->mcfg) {
+        case CFG_METHOD_1:
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        case CFG_METHOD_6:
+        case CFG_METHOD_7:
+        case CFG_METHOD_8:
+        case CFG_METHOD_9:
+        case CFG_METHOD_10:
+        case CFG_METHOD_11:
+        case CFG_METHOD_12:
+        case CFG_METHOD_13:
+                mdio_write(tp, 0x0E, 0x0200);
+                mdio_write(tp, MII_BMCR, BMCR_PDOWN);
+                break;
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                mdio_write(tp, MII_BMCR, BMCR_ANENABLE | BMCR_PDOWN);
+                break;
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+                mdio_write(tp, MII_BMCR, BMCR_ANENABLE | BMCR_PDOWN);
+                RTL_W8(0xD0, RTL_R8(0xD0) & ~BIT_6);
+                break;
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+                mdio_write(tp, MII_BMCR, BMCR_ANENABLE | BMCR_PDOWN);
+                break;
+        default:
+                mdio_write(tp, MII_BMCR, BMCR_PDOWN);
+                break;
+        }
+        spin_unlock_irqrestore(&tp->phy_lock, flags);
+}
+
+static int __devinit
+rtl8168_init_board(struct pci_dev *pdev,
+                   struct net_device **dev_out,
+                   void __iomem **ioaddr_out)
+{
+        void __iomem *ioaddr;
+        struct net_device *dev;
+        struct rtl8168_private *tp;
+        int rc = -ENOMEM, i, pm_cap;
+
+        assert(ioaddr_out != NULL);
+
+        /* dev zeroed in alloc_etherdev */
+        dev = alloc_etherdev(sizeof (*tp));
+        if (dev == NULL) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_drv(&debug))
+                        dev_err(&pdev->dev, "unable to alloc new ethernet\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                goto err_out;
+        }
+
+        SET_MODULE_OWNER(dev);
+        SET_NETDEV_DEV(dev, &pdev->dev);
+        tp = netdev_priv(dev);
+        tp->dev = dev;
+        tp->msg_enable = netif_msg_init(debug.msg_enable, R8168_MSG_DEFAULT);
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,26)
+        if (!aspm || tp->mcfg == CFG_METHOD_9)
+                pci_disable_link_state(pdev, PCIE_LINK_STATE_L0S | PCIE_LINK_STATE_L1 |
+                                       PCIE_LINK_STATE_CLKPM);
+#endif
+
+        /* enable device (incl. PCI PM wakeup and hotplug setup) */
+        rc = pci_enable_device(pdev);
+        if (rc < 0) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_err(&pdev->dev, "enable failure\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                goto err_out_free_dev;
+        }
+
+        rc = pci_set_mwi(pdev);
+        if (rc < 0)
+                goto err_out_disable;
+
+        /* save power state before pci_enable_device overwrites it */
+        pm_cap = pci_find_capability(pdev, PCI_CAP_ID_PM);
+        if (pm_cap) {
+                u16 pwr_command;
+
+                pci_read_config_word(pdev, pm_cap + PCI_PM_CTRL, &pwr_command);
+        } else {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp)) {
+                        dev_err(&pdev->dev, "PowerManagement capability not found.\n");
+                }
+#else
+                printk("PowerManagement capability not found.\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+
+        }
+
+        /* make sure PCI base addr 1 is MMIO */
+        if (!(pci_resource_flags(pdev, 2) & IORESOURCE_MEM)) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_err(&pdev->dev, "region #1 not an MMIO resource, aborting\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                rc = -ENODEV;
+                goto err_out_mwi;
+        }
+        /* check for weird/broken PCI region reporting */
+        if (pci_resource_len(pdev, 2) < R8168_REGS_SIZE) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_err(&pdev->dev, "Invalid PCI region size(s), aborting\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                rc = -ENODEV;
+                goto err_out_mwi;
+        }
+
+        rc = pci_request_regions(pdev, MODULENAME);
+        if (rc < 0) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_err(&pdev->dev, "could not request regions.\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                goto err_out_mwi;
+        }
+
+        if ((sizeof(dma_addr_t) > 4) &&
+            use_dac &&
+            !pci_set_dma_mask(pdev, DMA_BIT_MASK(64)) &&
+            !pci_set_consistent_dma_mask(pdev, DMA_BIT_MASK(64))) {
+                dev->features |= NETIF_F_HIGHDMA;
+        } else {
+                rc = pci_set_dma_mask(pdev, DMA_BIT_MASK(32));
+                if (rc < 0) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                        if (netif_msg_probe(tp))
+                                dev_err(&pdev->dev, "DMA configuration failed.\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                        goto err_out_free_res;
+                }
+        }
+
+        pci_set_master(pdev);
+
+	/* ioremap MMIO region */
+#ifdef CONFIG_ARCH_RTD129x
+	if (pdev->bus->number == 0)
+		ioaddr = ioremap(0x9804f000, R8168_REGS_SIZE);
+	else
+		ioaddr = ioremap(0x9803C000, R8168_REGS_SIZE);
+
+#else
+	ioaddr = ioremap(pci_resource_start(pdev, 2), R8168_REGS_SIZE);
+#endif
+        if (ioaddr == NULL) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_err(&pdev->dev, "cannot remap MMIO, aborting\n");
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                rc = -EIO;
+                goto err_out_free_res;
+        }
+
+        /* Identify chip attached to board */
+        rtl8168_get_mac_version(tp, ioaddr);
+
+        rtl8168_print_mac_version(tp);
+
+        for (i = ARRAY_SIZE(rtl_chip_info) - 1; i >= 0; i--) {
+                if (tp->mcfg == rtl_chip_info[i].mcfg)
+                        break;
+        }
+
+        if (i < 0) {
+                /* Unknown chip: assume array element #0, original RTL-8168 */
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                if (netif_msg_probe(tp))
+                        dev_printk(KERN_DEBUG, &pdev->dev, "unknown chip version, assuming %s\n", rtl_chip_info[0].name);
+#else
+                printk("Realtek unknown chip version, assuming %s\n", rtl_chip_info[0].name);
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
+                i++;
+        }
+
+        tp->chipset = i;
+
+        *ioaddr_out = ioaddr;
+        *dev_out = dev;
+out:
+        return rc;
+
+err_out_free_res:
+        pci_release_regions(pdev);
+
+err_out_mwi:
+        pci_clear_mwi(pdev);
+
+err_out_disable:
+        pci_disable_device(pdev);
+
+err_out_free_dev:
+        free_netdev(dev);
+err_out:
+        *ioaddr_out = NULL;
+        *dev_out = NULL;
+        goto out;
+}
+
+#define PCI_DEVICE_SERIAL_NUMBER (0x0164)
+
+static void
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+rtl8168_esd_timer(unsigned long __opaque)
+#else
+rtl8168_esd_timer(struct timer_list *t)
+#endif
+{
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+        struct net_device *dev = (struct net_device *)__opaque;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct timer_list *timer = &tp->esd_timer;
+#else
+        struct rtl8168_private *tp = from_timer(tp, t, esd_timer);
+        struct net_device *dev = tp->dev;
+        struct timer_list *timer = t;
+#endif
+        struct pci_dev *pdev = tp->pci_dev;
+        unsigned long timeout = RTL8168_ESD_TIMEOUT;
+        unsigned long flags;
+        u8 cmd;
+        u16 io_base_l;
+        u16 mem_base_l;
+        u16 mem_base_h;
+        u8 ilr;
+        u16 resv_0x1c_h;
+        u16 resv_0x1c_l;
+        u16 resv_0x20_l;
+        u16 resv_0x20_h;
+        u16 resv_0x24_l;
+        u16 resv_0x24_h;
+        u16 resv_0x2c_h;
+        u16 resv_0x2c_l;
+        u32 pci_sn_l;
+        u32 pci_sn_h;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        tp->esd_flag = 0;
+
+        pci_read_config_byte(pdev, PCI_COMMAND, &cmd);
+        if (cmd != tp->pci_cfg_space.cmd) {
+                pci_write_config_byte(pdev, PCI_COMMAND, tp->pci_cfg_space.cmd);
+                tp->esd_flag |= BIT_0;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_0, &io_base_l);
+        if (io_base_l != tp->pci_cfg_space.io_base_l) {
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_0, tp->pci_cfg_space.io_base_l);
+                tp->esd_flag |= BIT_1;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_2, &mem_base_l);
+        if (mem_base_l != tp->pci_cfg_space.mem_base_l) {
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_2, tp->pci_cfg_space.mem_base_l);
+                tp->esd_flag |= BIT_2;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_2 + 2, &mem_base_h);
+        if (mem_base_h!= tp->pci_cfg_space.mem_base_h) {
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_2 + 2, tp->pci_cfg_space.mem_base_h);
+                tp->esd_flag |= BIT_3;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_3, &resv_0x1c_l);
+        if (resv_0x1c_l != tp->pci_cfg_space.resv_0x1c_l) {
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_3, tp->pci_cfg_space.resv_0x1c_l);
+                tp->esd_flag |= BIT_4;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_3 + 2, &resv_0x1c_h);
+        if (resv_0x1c_h != tp->pci_cfg_space.resv_0x1c_h) {
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_3 + 2, tp->pci_cfg_space.resv_0x1c_h);
+                tp->esd_flag |= BIT_5;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_4, &resv_0x20_l);
+        if (resv_0x20_l != tp->pci_cfg_space.resv_0x20_l) {
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_4, tp->pci_cfg_space.resv_0x20_l);
+                tp->esd_flag |= BIT_6;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_4 + 2, &resv_0x20_h);
+        if (resv_0x20_h != tp->pci_cfg_space.resv_0x20_h) {
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_4 + 2, tp->pci_cfg_space.resv_0x20_h);
+                tp->esd_flag |= BIT_7;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_5, &resv_0x24_l);
+        if (resv_0x24_l != tp->pci_cfg_space.resv_0x24_l) {
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_5, tp->pci_cfg_space.resv_0x24_l);
+                tp->esd_flag |= BIT_8;
+        }
+
+        pci_read_config_word(pdev, PCI_BASE_ADDRESS_5 + 2, &resv_0x24_h);
+        if (resv_0x24_h != tp->pci_cfg_space.resv_0x24_h) {
+                pci_write_config_word(pdev, PCI_BASE_ADDRESS_5 + 2, tp->pci_cfg_space.resv_0x24_h);
+                tp->esd_flag |= BIT_9;
+        }
+
+        pci_read_config_byte(pdev, PCI_INTERRUPT_LINE, &ilr);
+        if (ilr != tp->pci_cfg_space.ilr) {
+                pci_write_config_byte(pdev, PCI_INTERRUPT_LINE, tp->pci_cfg_space.ilr);
+                tp->esd_flag |= BIT_10;
+        }
+
+        pci_read_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID, &resv_0x2c_l);
+        if (resv_0x2c_l != tp->pci_cfg_space.resv_0x2c_l) {
+                pci_write_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID, tp->pci_cfg_space.resv_0x2c_l);
+                tp->esd_flag |= BIT_11;
+        }
+
+        pci_read_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID + 2, &resv_0x2c_h);
+        if (resv_0x2c_h != tp->pci_cfg_space.resv_0x2c_h) {
+                pci_write_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID + 2, tp->pci_cfg_space.resv_0x2c_h);
+                tp->esd_flag |= BIT_12;
+        }
+
+        pci_sn_l = rtl8168_csi_read(tp, PCI_DEVICE_SERIAL_NUMBER);
+        if (pci_sn_l != tp->pci_cfg_space.pci_sn_l) {
+                rtl8168_csi_write(tp, PCI_DEVICE_SERIAL_NUMBER, tp->pci_cfg_space.pci_sn_l);
+                tp->esd_flag |= BIT_13;
+        }
+
+        pci_sn_h = rtl8168_csi_read(tp, PCI_DEVICE_SERIAL_NUMBER + 4);
+        if (pci_sn_h != tp->pci_cfg_space.pci_sn_h) {
+                rtl8168_csi_write(tp, PCI_DEVICE_SERIAL_NUMBER + 4, tp->pci_cfg_space.pci_sn_h);
+                tp->esd_flag |= BIT_14;
+        }
+
+        if (tp->esd_flag != 0) {
+                netif_stop_queue(dev);
+                netif_carrier_off(dev);
+                rtl8168_hw_reset(dev);
+                rtl8168_tx_clear(tp);
+                rtl8168_rx_clear(tp);
+                rtl8168_init_ring(dev);
+                rtl8168_hw_init(dev);
+                rtl8168_powerup_pll(dev);
+                rtl8168_hw_ephy_config(dev);
+                rtl8168_hw_phy_config(dev);
+                rtl8168_hw_config(dev);
+                rtl8168_set_speed(dev, tp->autoneg, tp->speed, tp->duplex, tp->advertising);
+                tp->esd_flag = 0;
+        }
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        mod_timer(timer, jiffies + timeout);
+}
+
+static void
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+rtl8168_link_timer(unsigned long __opaque)
+#else
+rtl8168_link_timer(struct timer_list *t)
+#endif
+{
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,14,0)
+        struct net_device *dev = (struct net_device *)__opaque;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct timer_list *timer = &tp->link_timer;
+#else
+        struct rtl8168_private *tp = from_timer(tp, t, link_timer);
+        struct net_device *dev = tp->dev;
+        struct timer_list *timer = t;
+#endif
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        rtl8168_check_link_status(dev);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        mod_timer(timer, jiffies + RTL8168_LINK_TIMEOUT);
+}
+
+/* Cfg9346_Unlock assumed. */
+static unsigned rtl8168_try_msi(struct pci_dev *pdev, struct rtl8168_private *tp)
+{
+        unsigned msi = 0;
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+        switch (tp->mcfg) {
+        case CFG_METHOD_1:
+        case CFG_METHOD_2:
+        case CFG_METHOD_3:
+        case CFG_METHOD_4:
+        case CFG_METHOD_5:
+        case CFG_METHOD_6:
+        case CFG_METHOD_7:
+        case CFG_METHOD_8:
+                dev_info(&pdev->dev, "Default use INTx.\n");
+                break;
+        default:
+                if (pci_enable_msi(pdev))
+                        dev_info(&pdev->dev, "no MSI. Back to INTx.\n");
+                else
+                        msi |= RTL_FEATURE_MSI;
+                break;
+        }
+#endif
+
+        return msi;
+}
+
+static void rtl8168_disable_msi(struct pci_dev *pdev, struct rtl8168_private *tp)
+{
+        if (tp->features & RTL_FEATURE_MSI) {
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,13)
+                pci_disable_msi(pdev);
+#endif
+                tp->features &= ~RTL_FEATURE_MSI;
+        }
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,29)
+static const struct net_device_ops rtl8168_netdev_ops = {
+        .ndo_open       = rtl8168_open,
+        .ndo_stop       = rtl8168_close,
+        .ndo_get_stats      = rtl8168_get_stats,
+        .ndo_start_xmit     = rtl8168_start_xmit,
+        .ndo_tx_timeout     = rtl8168_tx_timeout,
+        .ndo_change_mtu     = rtl8168_change_mtu,
+        .ndo_set_mac_address    = rtl8168_set_mac_address,
+        .ndo_do_ioctl       = rtl8168_do_ioctl,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,1,0)
+        .ndo_set_multicast_list = rtl8168_set_rx_mode,
+#else
+        .ndo_set_rx_mode    = rtl8168_set_rx_mode,
+#endif
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+#ifdef CONFIG_R8168_VLAN
+        .ndo_vlan_rx_register   = rtl8168_vlan_rx_register,
+#endif
+#else
+        .ndo_fix_features   = rtl8168_fix_features,
+        .ndo_set_features   = rtl8168_set_features,
+#endif
+#ifdef CONFIG_NET_POLL_CONTROLLER
+        .ndo_poll_controller    = rtl8168_netpoll,
+#endif
+};
+#endif
+
+static int __devinit
+rtl8168_init_one(struct pci_dev *pdev,
+                 const struct pci_device_id *ent)
+{
+        struct net_device *dev = NULL;
+        struct rtl8168_private *tp;
+        void __iomem *ioaddr = NULL;
+        static int board_idx = -1;
+
+        int rc;
+
+        assert(pdev != NULL);
+        assert(ent != NULL);
+
+        board_idx++;
+
+        if (netif_msg_drv(&debug))
+                printk(KERN_INFO "%s Gigabit Ethernet driver %s loaded\n",
+                       MODULENAME, RTL8168_VERSION);
+
+        rc = rtl8168_init_board(pdev, &dev, &ioaddr);
+        if (rc)
+                goto out;
+
+        tp = netdev_priv(dev);
+        assert(ioaddr != NULL);
+
+        tp->mmio_addr = ioaddr;
+        tp->set_speed = rtl8168_set_speed_xmii;
+        tp->get_settings = rtl8168_gset_xmii;
+        tp->phy_reset_enable = rtl8168_xmii_reset_enable;
+        tp->phy_reset_pending = rtl8168_xmii_reset_pending;
+        tp->link_ok = rtl8168_xmii_link_ok;
+
+        tp->features |= rtl8168_try_msi(pdev, tp);
+
+        RTL_NET_DEVICE_OPS(rtl8168_netdev_ops);
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,22)
+        SET_ETHTOOL_OPS(dev, &rtl8168_ethtool_ops);
+#endif
+
+        dev->watchdog_timeo = RTL8168_TX_TIMEOUT;
+        dev->irq = pdev->irq;
+        dev->base_addr = (unsigned long) ioaddr;
+
+#ifdef CONFIG_R8168_NAPI
+        RTL_NAPI_CONFIG(dev, tp, rtl8168_poll, R8168_NAPI_WEIGHT);
+#endif
+
+#ifdef CONFIG_R8168_VLAN
+        if (tp->mcfg != CFG_METHOD_DEFAULT) {
+                dev->features |= NETIF_F_HW_VLAN_TX | NETIF_F_HW_VLAN_RX;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+                dev->vlan_rx_kill_vid = rtl8168_vlan_rx_kill_vid;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+        }
+#endif
+
+        tp->cp_cmd |= RTL_R16(CPlusCmd);
+        if (tp->mcfg != CFG_METHOD_DEFAULT) {
+                dev->features |= NETIF_F_IP_CSUM;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+                tp->cp_cmd |= RxChkSum;
+#else
+                dev->features |= NETIF_F_RXCSUM | NETIF_F_SG | NETIF_F_TSO;
+                dev->hw_features = NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |
+                                   NETIF_F_RXCSUM | NETIF_F_HW_VLAN_TX | NETIF_F_HW_VLAN_RX;
+                dev->vlan_features = NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |
+                                     NETIF_F_HIGHDMA;
+
+                dev->hw_features |= NETIF_F_RXALL;
+                dev->hw_features |= NETIF_F_RXFCS;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,22)
+                if ((tp->mcfg == CFG_METHOD_1) || (tp->mcfg == CFG_METHOD_2) || (tp->mcfg == CFG_METHOD_3)) {
+                        dev->hw_features &= ~NETIF_F_IPV6_CSUM;
+                        netif_set_gso_max_size(dev, LSO_32K);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,18,0)
+                        dev->gso_max_segs = NIC_MAX_PHYS_BUF_COUNT_LSO_64K;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,7,0)
+                        dev->gso_min_segs = NIC_MIN_PHYS_BUF_COUNT;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(4,7,0)
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(3,18,0)
+                } else {
+                        dev->hw_features |= NETIF_F_IPV6_CSUM | NETIF_F_TSO6;
+                        dev->features |=  NETIF_F_IPV6_CSUM | NETIF_F_TSO6;
+                        netif_set_gso_max_size(dev, LSO_64K);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,18,0)
+                        dev->gso_max_segs = NIC_MAX_PHYS_BUF_COUNT_LSO2;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,7,0)
+                        dev->gso_min_segs = NIC_MIN_PHYS_BUF_COUNT;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(4,7,0)
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(3,18,0)
+                }
+#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,22)
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        }
+
+        tp->pci_dev = pdev;
+
+        spin_lock_init(&tp->lock);
+
+        spin_lock_init(&tp->phy_lock);
+
+        rtl8168_init_software_variable(dev);
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH)
+                AllocateDashShareMemory(dev);
+#endif
+
+        rtl8168_exit_oob(dev);
+
+        rtl8168_hw_init(dev);
+
+        rtl8168_hw_reset(dev);
+
+        /* Get production from EEPROM */
+        if (((tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+              tp->mcfg == CFG_METHOD_25 || tp->mcfg == CFG_METHOD_29 ||
+              tp->mcfg == CFG_METHOD_30) && (mac_ocp_read(tp, 0xDC00) & BIT_3)) ||
+            ((tp->mcfg == CFG_METHOD_26) && (mac_ocp_read(tp, 0xDC00) & BIT_4)))
+                tp->eeprom_type = EEPROM_TYPE_NONE;
+        else
+                rtl_eeprom_type(tp);
+
+        if (tp->eeprom_type == EEPROM_TYPE_93C46 || tp->eeprom_type == EEPROM_TYPE_93C56)
+                rtl_set_eeprom_sel_low(ioaddr);
+
+        rtl8168_get_mac_address(dev);
+
+#if defined(ENABLE_DASH_PRINTER_SUPPORT)
+        init_completion(&tp->fw_host_ok);
+        init_completion(&tp->fw_ack);
+        init_completion(&tp->fw_req);
+#endif
+
+        tp->tally_vaddr = pci_alloc_consistent(pdev, sizeof(*tp->tally_vaddr), &tp->tally_paddr);
+        if (!tp->tally_vaddr) {
+                rc = -ENOMEM;
+                goto err_out;
+        }
+
+        rtl8168_tally_counter_clear(tp);
+
+        pci_set_drvdata(pdev, dev);
+
+        rc = register_netdev(dev);
+        if (rc)
+                goto err_out;
+
+        printk(KERN_INFO "%s: This product is covered by one or more of the following patents: US6,570,884, US6,115,776, and US6,327,625.\n", MODULENAME);
+
+        device_set_wakeup_enable(&pdev->dev, tp->wol_enabled);
+
+        netif_carrier_off(dev);
+
+        printk("%s", GPL_CLAIM);
+
+out:
+        return rc;
+
+err_out:
+        if (tp->tally_vaddr != NULL) {
+                pci_free_consistent(pdev, sizeof(*tp->tally_vaddr), tp->tally_vaddr,
+                                    tp->tally_paddr);
+
+                tp->tally_vaddr = NULL;
+        }
+#ifdef  CONFIG_R8168_NAPI
+        RTL_NAPI_DEL(tp);
+#endif
+        rtl8168_disable_msi(pdev, tp);
+        rtl8168_release_board(pdev, dev, ioaddr);
+
+        goto out;
+}
+
+static void __devexit
+rtl8168_remove_one(struct pci_dev *pdev)
+{
+        struct net_device *dev = pci_get_drvdata(pdev);
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        assert(dev != NULL);
+        assert(tp != NULL);
+
+#ifdef  CONFIG_R8168_NAPI
+        RTL_NAPI_DEL(tp);
+#endif
+        if (tp->DASH)
+                rtl8168_driver_stop(tp);
+
+        unregister_netdev(dev);
+        rtl8168_disable_msi(pdev, tp);
+#ifdef ENABLE_R8168_PROCFS
+        rtl8168_proc_remove(dev);
+#endif
+        if (tp->tally_vaddr != NULL) {
+                pci_free_consistent(pdev, sizeof(*tp->tally_vaddr), tp->tally_vaddr, tp->tally_paddr);
+                tp->tally_vaddr = NULL;
+        }
+
+        rtl8168_release_board(pdev, dev, tp->mmio_addr);
+        pci_set_drvdata(pdev, NULL);
+}
+
+static void
+rtl8168_set_rxbufsize(struct rtl8168_private *tp,
+                      struct net_device *dev)
+{
+        unsigned int mtu = dev->mtu;
+
+        tp->rx_buf_sz = (mtu > ETH_DATA_LEN) ? mtu + ETH_HLEN + 8 + 1 : RX_BUF_SIZE;
+}
+
+static int rtl8168_open(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+        int retval;
+
+        retval = -ENOMEM;
+
+#ifdef ENABLE_R8168_PROCFS
+        rtl8168_proc_init(dev);
+#endif
+        rtl8168_set_rxbufsize(tp, dev);
+        /*
+         * Rx and Tx descriptors needs 256 bytes alignment.
+         * pci_alloc_consistent provides more.
+         */
+        tp->TxDescArray = pci_alloc_consistent(pdev, R8168_TX_RING_BYTES,
+                                               &tp->TxPhyAddr);
+        if (!tp->TxDescArray)
+                goto err_free_all_allocated_mem;
+
+        tp->RxDescArray = pci_alloc_consistent(pdev, R8168_RX_RING_BYTES,
+                                               &tp->RxPhyAddr);
+        if (!tp->RxDescArray)
+                goto err_free_all_allocated_mem;
+
+        if (tp->UseSwPaddingShortPkt) {
+                tp->ShortPacketEmptyBuffer = pci_alloc_consistent(pdev, SHORT_PACKET_PADDING_BUF_SIZE,
+                                             &tp->ShortPacketEmptyBufferPhy);
+                if (!tp->ShortPacketEmptyBuffer)
+                        goto err_free_all_allocated_mem;
+
+                memset(tp->ShortPacketEmptyBuffer, 0x0, SHORT_PACKET_PADDING_BUF_SIZE);
+        }
+
+        retval = rtl8168_init_ring(dev);
+        if (retval < 0)
+                goto err_free_all_allocated_mem;
+
+        if (netif_msg_probe(tp)) {
+                printk(KERN_INFO "%s: 0x%lx, "
+                       "%2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x, "
+                       "IRQ %d\n",
+                       dev->name,
+                       dev->base_addr,
+                       dev->dev_addr[0], dev->dev_addr[1],
+                       dev->dev_addr[2], dev->dev_addr[3],
+                       dev->dev_addr[4], dev->dev_addr[5], dev->irq);
+        }
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+        INIT_WORK(&tp->task, NULL, dev);
+#else
+        INIT_DELAYED_WORK(&tp->task, NULL);
+#endif
+
+#ifdef  CONFIG_R8168_NAPI
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        RTL_NAPI_ENABLE(dev, &tp->napi);
+#endif
+#endif
+
+        rtl8168_exit_oob(dev);
+
+        rtl8168_hw_init(dev);
+
+        rtl8168_hw_reset(dev);
+
+        rtl8168_powerup_pll(dev);
+
+        rtl8168_hw_ephy_config(dev);
+
+        rtl8168_hw_phy_config(dev);
+
+        rtl8168_hw_config(dev);
+
+        rtl8168_dsm(dev, DSM_IF_UP);
+
+        rtl8168_set_speed(dev, tp->autoneg, tp->speed, tp->duplex, tp->advertising);
+
+        retval = request_irq(dev->irq, rtl8168_interrupt, (tp->features & RTL_FEATURE_MSI) ? 0 : SA_SHIRQ, dev->name, dev);
+        if (retval<0)
+                goto err_free_all_allocated_mem;
+
+        if (tp->esd_flag == 0)
+                rtl8168_request_esd_timer(dev);
+
+        rtl8168_request_link_timer(dev);
+
+out:
+
+        return retval;
+
+err_free_all_allocated_mem:
+        if (tp->RxDescArray != NULL) {
+                pci_free_consistent(pdev, R8168_RX_RING_BYTES, tp->RxDescArray,
+                                    tp->RxPhyAddr);
+                tp->RxDescArray = NULL;
+        }
+
+        if (tp->TxDescArray != NULL) {
+                pci_free_consistent(pdev, R8168_TX_RING_BYTES, tp->TxDescArray,
+                                    tp->TxPhyAddr);
+                tp->TxDescArray = NULL;
+        }
+
+        if (tp->ShortPacketEmptyBuffer != NULL) {
+                pci_free_consistent(pdev, ETH_ZLEN, tp->ShortPacketEmptyBuffer,
+                                    tp->ShortPacketEmptyBufferPhy);
+                tp->ShortPacketEmptyBuffer = NULL;
+        }
+
+        goto out;
+}
+
+static void
+rtl8168_dsm(struct net_device *dev, int dev_state)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        switch (dev_state) {
+        case DSM_MAC_INIT:
+                if ((tp->mcfg == CFG_METHOD_5) || (tp->mcfg == CFG_METHOD_6)) {
+                        if (RTL_R8(MACDBG) & 0x80)
+                                RTL_W8(GPIO, RTL_R8(GPIO) | GPIO_en);
+                        else
+                                RTL_W8(GPIO, RTL_R8(GPIO) & ~GPIO_en);
+                }
+
+                break;
+        case DSM_NIC_GOTO_D3:
+        case DSM_IF_DOWN:
+                if ((tp->mcfg == CFG_METHOD_5) || (tp->mcfg == CFG_METHOD_6)) {
+                        if (RTL_R8(MACDBG) & 0x80)
+                                RTL_W8(GPIO, RTL_R8(GPIO) & ~GPIO_en);
+                }
+                break;
+
+        case DSM_NIC_RESUME_D3:
+        case DSM_IF_UP:
+                if ((tp->mcfg == CFG_METHOD_5) || (tp->mcfg == CFG_METHOD_6)) {
+                        if (RTL_R8(MACDBG) & 0x80)
+                                RTL_W8(GPIO, RTL_R8(GPIO) | GPIO_en);
+                }
+
+                break;
+        }
+
+}
+
+static void
+set_offset70F(struct rtl8168_private *tp, u8 setting)
+{
+        u32 csi_tmp;
+        u32 temp = (u32)setting;
+        temp = temp << 24;
+        /*set PCI configuration space offset 0x70F to setting*/
+        /*When the register offset of PCI configuration space larger than 0xff, use CSI to access it.*/
+
+        csi_tmp = rtl8168_csi_read(tp, 0x70c) & 0x00ffffff;
+        rtl8168_csi_write(tp, 0x70c, csi_tmp | temp);
+}
+
+static void
+set_offset79(struct rtl8168_private *tp, u8 setting)
+{
+        //Set PCI configuration space offset 0x79 to setting
+
+        struct pci_dev *pdev = tp->pci_dev;
+        u8 device_control;
+
+        if (hwoptimize & HW_PATCH_SOC_LAN) return;
+
+        pci_read_config_byte(pdev, 0x79, &device_control);
+        device_control &= ~0x70;
+        device_control |= setting;
+        pci_write_config_byte(pdev, 0x79, device_control);
+}
+
+static void
+set_offset711(struct rtl8168_private *tp, u8 setting)
+{
+        u32 csi_tmp;
+        u32 temp = (u32)setting;
+        temp &= 0x0f;
+        temp = temp << 12;
+        /*set PCI configuration space offset 0x711 to setting*/
+
+        csi_tmp = rtl8168_csi_read(tp, 0x710) & 0xffff0fff;
+        rtl8168_csi_write(tp, 0x710, csi_tmp | temp);
+}
+
+static void
+rtl8168_hw_set_rx_packet_filter(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        u32 mc_filter[2];   /* Multicast hash filter */
+        int rx_mode;
+        u32 tmp = 0;
+
+        if (dev->flags & IFF_PROMISC) {
+                /* Unconditionally log net taps. */
+                if (netif_msg_link(tp))
+                        printk(KERN_NOTICE "%s: Promiscuous mode enabled.\n",
+                               dev->name);
+
+                rx_mode =
+                        AcceptBroadcast | AcceptMulticast | AcceptMyPhys |
+                        AcceptAllPhys;
+                mc_filter[1] = mc_filter[0] = 0xffffffff;
+        } else if ((netdev_mc_count(dev) > multicast_filter_limit)
+                   || (dev->flags & IFF_ALLMULTI)) {
+                /* Too many to filter perfectly -- accept all multicasts. */
+                rx_mode = AcceptBroadcast | AcceptMulticast | AcceptMyPhys;
+                mc_filter[1] = mc_filter[0] = 0xffffffff;
+        } else {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,35)
+                struct dev_mc_list *mclist;
+                unsigned int i;
+
+                rx_mode = AcceptBroadcast | AcceptMyPhys;
+                mc_filter[1] = mc_filter[0] = 0;
+                for (i = 0, mclist = dev->mc_list; mclist && i < dev->mc_count;
+                     i++, mclist = mclist->next) {
+                        int bit_nr = ether_crc(ETH_ALEN, mclist->dmi_addr) >> 26;
+                        mc_filter[bit_nr >> 5] |= 1 << (bit_nr & 31);
+                        rx_mode |= AcceptMulticast;
+                }
+#else
+                struct netdev_hw_addr *ha;
+
+                rx_mode = AcceptBroadcast | AcceptMyPhys;
+                mc_filter[1] = mc_filter[0] = 0;
+                netdev_for_each_mc_addr(ha, dev) {
+                        int bit_nr = ether_crc(ETH_ALEN, ha->addr) >> 26;
+                        mc_filter[bit_nr >> 5] |= 1 << (bit_nr & 31);
+                        rx_mode |= AcceptMulticast;
+                }
+#endif
+        }
+
+        if (dev->features & NETIF_F_RXALL)
+                rx_mode |= (AcceptErr | AcceptRunt);
+
+        tmp = mc_filter[0];
+        mc_filter[0] = swab32(mc_filter[1]);
+        mc_filter[1] = swab32(tmp);
+
+        tp->rtl8168_rx_config = rtl_chip_info[tp->chipset].RCR_Cfg;
+        tmp = tp->rtl8168_rx_config | rx_mode | (RTL_R32(RxConfig) & rtl_chip_info[tp->chipset].RxConfigMask);
+
+        RTL_W32(RxConfig, tmp);
+        RTL_W32(MAR0 + 0, mc_filter[0]);
+        RTL_W32(MAR0 + 4, mc_filter[1]);
+}
+
+static void
+rtl8168_set_rx_mode(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8168_hw_set_rx_packet_filter(dev);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+static void
+rtl8168_hw_config(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        struct pci_dev *pdev = tp->pci_dev;
+        u8 device_control;
+        u16 mac_ocp_data;
+        u32 csi_tmp;
+        unsigned long flags;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        if (dev->mtu > ETH_DATA_LEN) {
+                dev->features &= ~(NETIF_F_IP_CSUM);
+        } else {
+                dev->features |= NETIF_F_IP_CSUM;
+        }
+#endif
+
+        RTL_W32(RxConfig, (RX_DMA_BURST << RxCfgDMAShift));
+
+        rtl8168_hw_reset(dev);
+
+        rtl8168_enable_cfg9346_write(tp);
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                RTL_W8(0xF1, RTL_R8(0xF1) & ~BIT_7);
+                RTL_W8(Config2, RTL_R8(Config2) & ~BIT_7);
+                RTL_W8(Config5, RTL_R8(Config5) & ~BIT_0);
+                break;
+        }
+
+        //clear io_rdy_l23
+        switch (tp->mcfg) {
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                RTL_W8(Config3, RTL_R8(Config3) & ~BIT_1);
+                break;
+        }
+
+        RTL_W8(MTPS, Reserved1_data);
+
+        tp->cp_cmd |= INTT_1;
+        if (tp->use_timer_interrrupt)
+                tp->cp_cmd |= PktCntrDisable;
+        else
+                tp->cp_cmd &= ~PktCntrDisable;
+
+        RTL_W16(IntrMitigate, 0x5f51);
+
+        rtl8168_tally_counter_addr_fill(tp);
+
+        rtl8168_desc_addr_fill(tp);
+
+        /* Set DMA burst size and Interframe Gap Time */
+        if (tp->mcfg == CFG_METHOD_1)
+                RTL_W32(TxConfig, (TX_DMA_BURST_512 << TxDMAShift) |
+                        (InterFrameGap << TxInterFrameGapShift));
+        else
+                RTL_W32(TxConfig, (TX_DMA_BURST_unlimited << TxDMAShift) |
+                        (InterFrameGap << TxInterFrameGapShift));
+
+        if (tp->mcfg == CFG_METHOD_4) {
+                set_offset70F(tp, 0x27);
+
+                RTL_W8(DBG_reg, (0x0E << 4) | Fix_Nak_1 | Fix_Nak_2);
+
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                //disable clock request.
+                pci_write_config_byte(pdev, 0x81, 0x00);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) | Jumbo_En1);
+
+                        set_offset79(tp, 0x20);
+                } else {
+                        RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) & ~Jumbo_En1);
+
+                        set_offset79(tp, 0x50);
+                }
+
+                //rx checksum offload enable
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+                tp->cp_cmd |= RxChkSum;
+#else
+                dev->features |= NETIF_F_RXCSUM;
+#endif
+
+                tp->cp_cmd &= ~(EnableBist | Macdbgo_oe | Force_halfdup |
+                                Force_rxflow_en | Force_txflow_en | Cxpl_dbg_sel |
+                                ASF | PktCntrDisable | Macdbgo_sel);
+        } else if (tp->mcfg == CFG_METHOD_5) {
+
+                set_offset70F(tp, 0x27);
+
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                //disable clock request.
+                pci_write_config_byte(pdev, 0x81, 0x00);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) | Jumbo_En1);
+
+                        set_offset79(tp, 0x20);
+                } else {
+                        RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) & ~Jumbo_En1);
+
+                        set_offset79(tp, 0x50);
+                }
+
+                //rx checksum offload enable
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+                tp->cp_cmd |= RxChkSum;
+#else
+                dev->features |= NETIF_F_RXCSUM;
+#endif
+        } else if (tp->mcfg == CFG_METHOD_6) {
+                set_offset70F(tp, 0x27);
+
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                //disable clock request.
+                pci_write_config_byte(pdev, 0x81, 0x00);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) | Jumbo_En1);
+
+                        set_offset79(tp, 0x20);
+                } else {
+                        RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) & ~Jumbo_En1);
+
+                        set_offset79(tp, 0x50);
+                }
+
+                //rx checksum offload enable
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+                tp->cp_cmd |= RxChkSum;
+#else
+                dev->features |= NETIF_F_RXCSUM;
+#endif
+        } else if (tp->mcfg == CFG_METHOD_7) {
+                set_offset70F(tp, 0x27);
+
+                rtl8168_eri_write(ioaddr, 0x1EC, 1, 0x07, ERIAR_ASF);
+
+                //disable clock request.
+                pci_write_config_byte(pdev, 0x81, 0x00);
+
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) | Jumbo_En1);
+
+                        set_offset79(tp, 0x20);
+                } else {
+                        RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) & ~Jumbo_En1);
+
+
+                        set_offset79(tp, 0x50);
+                }
+        } else if (tp->mcfg == CFG_METHOD_8) {
+
+                set_offset70F(tp, 0x27);
+
+                rtl8168_eri_write(ioaddr, 0x1EC, 1, 0x07, ERIAR_ASF);
+
+                //disable clock request.
+                pci_write_config_byte(pdev, 0x81, 0x00);
+
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                RTL_W8(0xD1, 0x20);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) | Jumbo_En1);
+
+                        set_offset79(tp, 0x20);
+                } else {
+                        RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) & ~Jumbo_En1);
+
+                        set_offset79(tp, 0x50);
+                }
+        } else if (tp->mcfg == CFG_METHOD_9) {
+                set_offset70F(tp, 0x27);
+
+                /* disable clock request. */
+                pci_write_config_byte(pdev, 0x81, 0x00);
+
+                RTL_W8(Config3, RTL_R8(Config3) & ~BIT_4);
+                RTL_W8(DBG_reg, RTL_R8(DBG_reg) | BIT_7 | BIT_1);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) | Jumbo_En1);
+
+                        set_offset79(tp, 0x20);
+                } else {
+                        RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) & ~Jumbo_En1);
+
+                        set_offset79(tp, 0x50);
+                }
+
+                RTL_W8(TDFNR, 0x8);
+
+        } else if (tp->mcfg == CFG_METHOD_10) {
+                set_offset70F(tp, 0x27);
+
+                RTL_W8(DBG_reg, RTL_R8(DBG_reg) | BIT_7 | BIT_1);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) | Jumbo_En1);
+
+                        set_offset79(tp, 0x20);
+                } else {
+                        RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) & ~Jumbo_En1);
+
+                        set_offset79(tp, 0x50);
+                }
+
+                RTL_W8(TDFNR, 0x8);
+
+                RTL_W8(Config1, RTL_R8(Config1) | 0x10);
+
+                /* disable clock request. */
+                pci_write_config_byte(pdev, 0x81, 0x00);
+        } else if (tp->mcfg == CFG_METHOD_11 || tp->mcfg == CFG_METHOD_13) {
+                set_offset70F(tp, 0x27);
+                set_offset79(tp, 0x50);
+
+                if (dev->mtu > ETH_DATA_LEN)
+                        RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+                else
+                        RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+
+                pci_write_config_byte(pdev, 0x81, 0x00);
+
+                RTL_W8(Config1, RTL_R8(Config1) | 0x10);
+
+        } else if (tp->mcfg == CFG_METHOD_12) {
+                set_offset70F(tp, 0x27);
+                set_offset79(tp, 0x50);
+
+                if (dev->mtu > ETH_DATA_LEN)
+                        RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+                else
+                        RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+
+                pci_write_config_byte(pdev, 0x81, 0x01);
+
+                RTL_W8(Config1, RTL_R8(Config1) | 0x10);
+
+        } else if (tp->mcfg == CFG_METHOD_14 || tp->mcfg == CFG_METHOD_15) {
+
+                set_offset70F(tp, 0x27);
+                set_offset79(tp, 0x50);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        RTL_W8(MTPS, 0x24);
+                        RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) | 0x01);
+                } else {
+                        RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+                        RTL_W8(Config4, RTL_R8(Config4) & ~0x01);
+                }
+
+                RTL_W8(0xF3, RTL_R8(0xF3) | BIT_5);
+                RTL_W8(0xF3, RTL_R8(0xF3) & ~BIT_5);
+
+                RTL_W8(0xD0, RTL_R8(0xD0) | BIT_7 | BIT_6);
+
+                RTL_W8(0xD1, RTL_R8(0xD1) | BIT_2 | BIT_3);
+
+                RTL_W8(0xF1, RTL_R8(0xF1) | BIT_6 | BIT_5 | BIT_4 | BIT_2 | BIT_1);
+
+                RTL_W8(TDFNR, 0x8);
+
+                if (aspm)
+                        RTL_W8(0xF1, RTL_R8(0xF1) | BIT_7);
+
+                RTL_W8(Config5, RTL_R8(Config5) & ~BIT_3);
+
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                RTL_W8(Config1, RTL_R8(Config1) & ~0x10);
+        } else if (tp->mcfg == CFG_METHOD_16 || tp->mcfg == CFG_METHOD_17) {
+                set_offset70F(tp, 0x27);
+                set_offset79(tp, 0x50);
+
+                rtl8168_eri_write(ioaddr, 0xC0, 2, 0x0000, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xB8, 4, 0x00000000, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xC8, 4, 0x00100002, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xE8, 4, 0x00100006, ERIAR_ExGMAC);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xD4, 4, ERIAR_ExGMAC);
+                csi_tmp |= (BIT_8 | BIT_9 | BIT_10 | BIT_11 | BIT_12);
+                rtl8168_eri_write(ioaddr, 0xD4, 4, csi_tmp, ERIAR_ExGMAC);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1D0, 4, ERIAR_ExGMAC);
+                csi_tmp |= BIT_1;
+                rtl8168_eri_write(ioaddr, 0x1D0, 1, csi_tmp, ERIAR_ExGMAC);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xDC, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+
+                RTL_W32(TxConfig, RTL_R32(TxConfig) | BIT_7);
+                RTL_W8(0xD3, RTL_R8(0xD3) & ~BIT_7);
+                RTL_W8(0x1B, RTL_R8(0x1B) & ~0x07);
+
+                if (tp->mcfg == CFG_METHOD_16) {
+                        RTL_W32(0xB0, 0xEE480010);
+                        RTL_W8(0x1A, RTL_R8(0x1A) & ~(BIT_2|BIT_3));
+                        rtl8168_eri_write(ioaddr, 0x1DC, 1, 0x64, ERIAR_ExGMAC);
+                } else {
+                        csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 4, ERIAR_ExGMAC);
+                        csi_tmp |= BIT_4;
+                        rtl8168_eri_write(ioaddr, 0x1B0, 1, csi_tmp, ERIAR_ExGMAC);
+                        rtl8168_eri_write(ioaddr, 0xCC, 4, 0x00000050, ERIAR_ExGMAC);
+                        rtl8168_eri_write(ioaddr, 0xD0, 4, 0x07ff0060, ERIAR_ExGMAC);
+                }
+
+                RTL_W8(TDFNR, 0x8);
+
+                RTL_W8(Config2, RTL_R8(Config2) & ~PMSTS_En);
+
+                RTL_W8(0xD0, RTL_R8(0xD0) | BIT_6);
+                RTL_W8(0xF2, RTL_R8(0xF2) | BIT_6);
+
+                if (dev->mtu > ETH_DATA_LEN)
+                        RTL_W8(MTPS, 0x27);
+
+                /* disable clock request. */
+                pci_write_config_byte(pdev, 0x81, 0x00);
+
+        } else if (tp->mcfg == CFG_METHOD_18 || tp->mcfg == CFG_METHOD_19) {
+                set_offset70F(tp, 0x27);
+                set_offset79(tp, 0x50);
+
+                rtl8168_eri_write(ioaddr, 0xC8, 4, 0x00100002, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xE8, 4, 0x00100006, ERIAR_ExGMAC);
+                RTL_W32(TxConfig, RTL_R32(TxConfig) | BIT_7);
+                RTL_W8(0xD3, RTL_R8(0xD3) & ~BIT_7);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xDC, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+
+                if (aspm)
+                        RTL_W8(0xF1, RTL_R8(0xF1) | BIT_7);
+
+                if (dev->mtu > ETH_DATA_LEN)
+                        RTL_W8(MTPS, 0x27);
+
+                RTL_W8(TDFNR, 0x8);
+
+                RTL_W8(0xD0, RTL_R8(0xD0) | BIT_6);
+                RTL_W8(0xF2, RTL_R8(0xF2) | BIT_6);
+
+                rtl8168_eri_write(ioaddr, 0xC0, 2, 0x0000, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xB8, 4, 0x00000000, ERIAR_ExGMAC);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xD4, 4, ERIAR_ExGMAC);
+                csi_tmp |= (BIT_8 | BIT_9 | BIT_10 | BIT_11 | BIT_12);
+                rtl8168_eri_write(ioaddr, 0xD4, 4, csi_tmp, ERIAR_ExGMAC);
+                RTL_W8(0x1B,RTL_R8(0x1B) & ~0x07);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_4;
+                rtl8168_eri_write(ioaddr, 0x1B0, 1, csi_tmp, ERIAR_ExGMAC);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1d0, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_4 | BIT_1;
+                rtl8168_eri_write(ioaddr, 0x1d0, 1, csi_tmp, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xCC, 4, 0x00000050, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xd0, 4, 0x00000060, ERIAR_ExGMAC);
+        } else if (tp->mcfg == CFG_METHOD_20) {
+                set_offset70F(tp, 0x27);
+                set_offset79(tp, 0x50);
+
+                rtl8168_eri_write(ioaddr, 0xC8, 4, 0x00100002, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xE8, 4, 0x00100006, ERIAR_ExGMAC);
+                RTL_W32(TxConfig, RTL_R32(TxConfig) | BIT_7);
+                RTL_W8(0xD3, RTL_R8(0xD3) & ~BIT_7);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xDC, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+
+                if (aspm)
+                        RTL_W8(0xF1, RTL_R8(0xF1) | BIT_7);
+
+                if (dev->mtu > ETH_DATA_LEN)
+                        RTL_W8(MTPS, 0x27);
+
+                RTL_W8(TDFNR, 0x8);
+
+                RTL_W8(0xD0, RTL_R8(0xD0) | BIT_6);
+                RTL_W8(0xF2, RTL_R8(0xF2) | BIT_6);
+                rtl8168_eri_write(ioaddr, 0xC0, 2, 0x0000, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xB8, 4, 0x00000000, ERIAR_ExGMAC);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xD4, 4, ERIAR_ExGMAC);
+                csi_tmp |= BIT_10 | BIT_11;
+                rtl8168_eri_write(ioaddr, 0xD4, 4, csi_tmp, ERIAR_ExGMAC);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_4;
+                rtl8168_eri_write(ioaddr, 0x1B0, 1, csi_tmp, ERIAR_ExGMAC);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1d0, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_4 | BIT_1;
+                rtl8168_eri_write(ioaddr, 0x1d0, 1, csi_tmp, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xCC, 4, 0x00000050, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xd0, 4, 0x00000060, ERIAR_ExGMAC);
+        } else if (tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+                   tp->mcfg == CFG_METHOD_24 || tp->mcfg == CFG_METHOD_25 ||
+                   tp->mcfg == CFG_METHOD_26 || tp->mcfg == CFG_METHOD_29 ||
+                   tp->mcfg == CFG_METHOD_30) {
+                set_offset70F(tp, 0x27);
+                set_offset79(tp, 0x50);
+                if (tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22)
+                        set_offset711(tp, 0x04);
+
+                rtl8168_eri_write(ioaddr, 0xC8, 4, 0x00080002, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xCC, 1, 0x38, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xD0, 1, 0x48, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xE8, 4, 0x00100006, ERIAR_ExGMAC);
+
+                RTL_W32(TxConfig, RTL_R32(TxConfig) | BIT_7);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xDC, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+
+                if (tp->mcfg == CFG_METHOD_26) {
+                        mac_ocp_data = mac_ocp_read(tp, 0xD3C0);
+                        mac_ocp_data &= ~(BIT_11 | BIT_10 | BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
+                        mac_ocp_data |= 0x03A9;
+                        mac_ocp_write(tp, 0xD3C0, mac_ocp_data);
+                        mac_ocp_data = mac_ocp_read(tp, 0xD3C2);
+                        mac_ocp_data &= ~(BIT_7 | BIT_6 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
+                        mac_ocp_write(tp, 0xD3C2, mac_ocp_data);
+                        mac_ocp_data = mac_ocp_read(tp, 0xD3C4);
+                        mac_ocp_data |= BIT_0;
+                        mac_ocp_write(tp, 0xD3C4, mac_ocp_data);
+                } else if (tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30) {
+
+                        if (tp->RequireAdjustUpsTxLinkPulseTiming) {
+                                mac_ocp_data = mac_ocp_read(tp, 0xD412);
+                                mac_ocp_data &= ~(0x0FFF);
+                                mac_ocp_data |= tp->SwrCnt1msIni;
+                                mac_ocp_write(tp, 0xD412, mac_ocp_data);
+                        }
+
+                        mac_ocp_data = mac_ocp_read(tp, 0xE056);
+                        mac_ocp_data &= ~(BIT_7 | BIT_6 | BIT_5 | BIT_4);
+                        mac_ocp_data |= (BIT_6 | BIT_5 | BIT_4);
+                        mac_ocp_write(tp, 0xE056, mac_ocp_data);
+
+                        mac_ocp_data = mac_ocp_read(tp, 0xE052);
+                        mac_ocp_data &= ~( BIT_14 | BIT_13);
+                        mac_ocp_data |= BIT_15;
+                        mac_ocp_data |= BIT_3;
+                        mac_ocp_write(tp, 0xE052, mac_ocp_data);
+
+                        mac_ocp_data = mac_ocp_read(tp, 0xD420);
+                        mac_ocp_data &= ~(BIT_11 | BIT_10 | BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
+                        mac_ocp_data |= 0x47F;
+                        mac_ocp_write(tp, 0xD420, mac_ocp_data);
+
+                        mac_ocp_data = mac_ocp_read(tp, 0xE0D6);
+                        mac_ocp_data &= ~(BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
+                        mac_ocp_data |= 0x17F;
+                        mac_ocp_write(tp, 0xE0D6, mac_ocp_data);
+                }
+
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                RTL_W8(0x1B, RTL_R8(0x1B) & ~0x07);
+
+                RTL_W8(TDFNR, 0x4);
+
+                RTL_W8(Config2, RTL_R8(Config2) & ~PMSTS_En);
+
+                if (aspm)
+                        RTL_W8(0xF1, RTL_R8(0xF1) | BIT_7);
+
+                if (dev->mtu > ETH_DATA_LEN)
+                        RTL_W8(MTPS, 0x27);
+
+                RTL_W8(0xD0, RTL_R8(0xD0) | BIT_6);
+                RTL_W8(0xF2, RTL_R8(0xF2) | BIT_6);
+
+                RTL_W8(0xD0, RTL_R8(0xD0) | BIT_7);
+
+                rtl8168_eri_write(ioaddr, 0xC0, 2, 0x0000, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xB8, 4, 0x00000000, ERIAR_ExGMAC);
+
+                if (tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30)
+                        mac_ocp_write(tp, 0xE054, 0xFC01);
+
+                rtl8168_eri_write(ioaddr, 0x5F0, 2, 0x4F87, ERIAR_ExGMAC);
+
+                if (tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30) {
+                        csi_tmp = rtl8168_eri_read(ioaddr, 0xD4, 4, ERIAR_ExGMAC);
+                        csi_tmp |= (BIT_8 | BIT_9 | BIT_10 | BIT_11 | BIT_12);
+                        rtl8168_eri_write(ioaddr, 0xD4, 4, csi_tmp, ERIAR_ExGMAC);
+
+                        csi_tmp = rtl8168_eri_read(ioaddr, 0xDC, 4, ERIAR_ExGMAC);
+                        csi_tmp |= (BIT_2 | BIT_3 | BIT_4);
+                        rtl8168_eri_write(ioaddr, 0xDC, 4, csi_tmp, ERIAR_ExGMAC);
+                } else {
+                        csi_tmp = rtl8168_eri_read(ioaddr, 0xD4, 4, ERIAR_ExGMAC);
+                        csi_tmp |= (BIT_7 | BIT_8 | BIT_9 | BIT_10 | BIT_11 | BIT_12);
+                        rtl8168_eri_write(ioaddr, 0xD4, 4, csi_tmp, ERIAR_ExGMAC);
+                }
+
+                if (tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+                    tp->mcfg == CFG_METHOD_24 || tp->mcfg == CFG_METHOD_25) {
+                        mac_ocp_write(tp, 0xC140, 0xFFFF);
+                } else if (tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30) {
+                        mac_ocp_write(tp, 0xC140, 0xFFFF);
+                        mac_ocp_write(tp, 0xC142, 0xFFFF);
+                }
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 4, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_12;
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, csi_tmp, ERIAR_ExGMAC);
+
+                if (tp->mcfg == CFG_METHOD_29 || tp->mcfg == CFG_METHOD_30) {
+                        csi_tmp = rtl8168_eri_read(ioaddr, 0x2FC, 1, ERIAR_ExGMAC);
+                        csi_tmp &= ~(BIT_2);
+                        rtl8168_eri_write(ioaddr, 0x2FC, 1, csi_tmp, ERIAR_ExGMAC);
+                } else {
+                        csi_tmp = rtl8168_eri_read(ioaddr, 0x2FC, 1, ERIAR_ExGMAC);
+                        csi_tmp &= ~(BIT_0 | BIT_1 | BIT_2);
+                        csi_tmp |= BIT_0;
+                        rtl8168_eri_write(ioaddr, 0x2FC, 1, csi_tmp, ERIAR_ExGMAC);
+                }
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1D0, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_1;
+                rtl8168_eri_write(ioaddr, 0x1D0, 1, csi_tmp, ERIAR_ExGMAC);
+        } else if (tp->mcfg == CFG_METHOD_23 || tp->mcfg == CFG_METHOD_27 ||
+                   tp->mcfg == CFG_METHOD_28) {
+                set_offset70F(tp, 0x27);
+                set_offset79(tp, 0x50);
+
+                rtl8168_eri_write(ioaddr, 0xC8, 4, 0x00080002, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xCC, 1, 0x2F, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xD0, 1, 0x5F, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xE8, 4, 0x00100006, ERIAR_ExGMAC);
+
+                RTL_W32(TxConfig, RTL_R32(TxConfig) | BIT_7);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xDC, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                RTL_W8(0xD0, RTL_R8(0xD0) | BIT_6);
+                RTL_W8(0xF2, RTL_R8(0xF2) | BIT_6);
+
+                RTL_W8(0xD0, RTL_R8(0xD0) | BIT_7);
+
+                rtl8168_eri_write(ioaddr, 0xC0, 2, 0x0000, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xB8, 4, 0x00000000, ERIAR_ExGMAC);
+                RTL_W8(0x1B, RTL_R8(0x1B) & ~0x07);
+
+                RTL_W8(TDFNR, 0x4);
+
+                if (aspm)
+                        RTL_W8(0xF1, RTL_R8(0xF1) | BIT_7);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 4, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_12;
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, csi_tmp, ERIAR_ExGMAC);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x2FC, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~(BIT_0 | BIT_1 | BIT_2);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0x2FC, 1, csi_tmp, ERIAR_ExGMAC);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1D0, 1, ERIAR_ExGMAC);
+                csi_tmp |= BIT_1;
+                rtl8168_eri_write(ioaddr, 0x1D0, 1, csi_tmp, ERIAR_ExGMAC);
+
+                if (dev->mtu > ETH_DATA_LEN)
+                        RTL_W8(MTPS, 0x27);
+
+                if (tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28) {
+                        OOB_mutex_lock(tp);
+                        rtl8168_eri_write(ioaddr, 0x5F0, 2, 0x4F87, ERIAR_ExGMAC);
+                        OOB_mutex_unlock(tp);
+                }
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xD4, 4, ERIAR_ExGMAC);
+                csi_tmp  |= ( BIT_7 | BIT_8 | BIT_9 | BIT_10 | BIT_11 | BIT_12 );
+                rtl8168_eri_write(ioaddr, 0xD4, 4, csi_tmp, ERIAR_ExGMAC);
+
+                mac_ocp_write(tp, 0xC140, 0xFFFF);
+                mac_ocp_write(tp, 0xC142, 0xFFFF);
+
+                if (tp->mcfg == CFG_METHOD_28) {
+                        mac_ocp_data = mac_ocp_read(tp, 0xD3E2);
+                        mac_ocp_data &= 0xF000;
+                        mac_ocp_data |= 0x3A9;
+                        mac_ocp_write(tp, 0xD3E2, mac_ocp_data);
+
+                        mac_ocp_data = mac_ocp_read(tp, 0xD3E4);
+                        mac_ocp_data &= 0xFF00;
+                        mac_ocp_write(tp, 0xD3E4, mac_ocp_data);
+
+                        mac_ocp_data = mac_ocp_read(tp, 0xE860);
+                        mac_ocp_data |= BIT_7;
+                        mac_ocp_write(tp, 0xE860, mac_ocp_data);
+                }
+
+                rtl8168_set_dash_other_fun_dev_pci_cmd_register(tp, 0x07, 0x0E);
+                rtl8168_set_dash_other_fun_dev_aspm_clkreq(tp, 3, 1, 0x0E);
+                rtl8168_set_dash_other_fun_dev_state_change(tp, 0, 0x0E);
+        } else if (tp->mcfg == CFG_METHOD_31 || tp->mcfg == CFG_METHOD_32) {
+                set_offset70F(tp, 0x27);
+                set_offset79(tp, 0x50);
+
+                rtl8168_eri_write(ioaddr, 0xC8, 4, 0x00080002, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xCC, 1, 0x2F, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xD0, 1, 0x5F, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xE8, 4, 0x00100006, ERIAR_ExGMAC);
+
+                RTL_W32(TxConfig, RTL_R32(TxConfig) | BIT_7);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xDC, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0xDC, 1, csi_tmp, ERIAR_ExGMAC);
+
+                if (tp->RequireAdjustUpsTxLinkPulseTiming) {
+                        mac_ocp_data = mac_ocp_read(tp, 0xD412);
+                        mac_ocp_data &= ~(0x0FFF);
+                        mac_ocp_data |= tp->SwrCnt1msIni;
+                        mac_ocp_write(tp, 0xD412, mac_ocp_data);
+                }
+
+                mac_ocp_data = mac_ocp_read(tp, 0xE056);
+                mac_ocp_data &= ~(BIT_7 | BIT_6 | BIT_5 | BIT_4);
+                mac_ocp_data |= (BIT_6 | BIT_5 | BIT_4);
+                mac_ocp_write(tp, 0xE056, mac_ocp_data);
+                mac_ocp_write(tp, 0xEA80, 0x0003);
+
+                OOB_mutex_lock(tp);
+                mac_ocp_data = mac_ocp_read(tp, 0xE052);
+                if (tp->mcfg == CFG_METHOD_32)
+                        mac_ocp_data |= BIT_3;
+                else
+                        mac_ocp_data &= ~BIT_3;
+                mac_ocp_write(tp, 0xE052, mac_ocp_data);
+                OOB_mutex_unlock(tp);
+
+                mac_ocp_data = mac_ocp_read(tp, 0xD420);
+                mac_ocp_data &= ~(BIT_11 | BIT_10 | BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
+                mac_ocp_data |= 0x47F;
+                mac_ocp_write(tp, 0xD420, mac_ocp_data);
+
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                RTL_W8(0x1B, RTL_R8(0x1B) & ~0x07);
+
+                RTL_W8(TDFNR, 0x4);
+
+                RTL_W8(Config2, RTL_R8(Config2) & ~PMSTS_En);
+
+                if (aspm)
+                        RTL_W8(0xF1, RTL_R8(0xF1) | BIT_7);
+
+                if (dev->mtu > ETH_DATA_LEN)
+                        RTL_W8(MTPS, 0x27);
+
+                RTL_W8(0xD0, RTL_R8(0xD0) | BIT_6);
+                RTL_W8(0xF2, RTL_R8(0xF2) | BIT_6);
+
+                RTL_W8(0xD0, RTL_R8(0xD0) | BIT_7);
+
+                rtl8168_eri_write(ioaddr, 0xC0, 2, 0x0000, ERIAR_ExGMAC);
+                rtl8168_eri_write(ioaddr, 0xB8, 4, 0x00000000, ERIAR_ExGMAC);
+
+                mac_ocp_write(tp, 0xE054, 0xFC01);
+
+                OOB_mutex_lock(tp);
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x5F0, 4, ERIAR_ExGMAC);
+                csi_tmp |= (BIT_8 | BIT_9 | BIT_10 | BIT_11);
+                rtl8168_eri_write(ioaddr, 0x5F0, 4, csi_tmp, ERIAR_ExGMAC);
+                OOB_mutex_unlock(tp);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0xD4, 4, ERIAR_ExGMAC);
+                csi_tmp |= (BIT_7 | BIT_8 | BIT_9 | BIT_10 | BIT_11 | BIT_12);
+                if (tp->mcfg == CFG_METHOD_32) csi_tmp|= BIT_4;
+                rtl8168_eri_write(ioaddr, 0xD4, 4, csi_tmp, ERIAR_ExGMAC);
+
+                mac_ocp_write(tp, 0xC140, 0xFFFF);
+                mac_ocp_write(tp, 0xC142, 0xFFFF);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1B0, 4, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_12;
+                rtl8168_eri_write(ioaddr, 0x1B0, 4, csi_tmp, ERIAR_ExGMAC);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x2FC, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~(BIT_0 | BIT_1 | BIT_2);
+                csi_tmp |= BIT_0;
+                rtl8168_eri_write(ioaddr, 0x2FC, 1, csi_tmp, ERIAR_ExGMAC);
+
+                csi_tmp = rtl8168_eri_read(ioaddr, 0x1D0, 1, ERIAR_ExGMAC);
+                csi_tmp &= ~BIT_1;
+                rtl8168_eri_write(ioaddr, 0x1D0, 1, csi_tmp, ERIAR_ExGMAC);
+
+                mac_ocp_data = mac_ocp_read(tp, 0xD3E2);
+                mac_ocp_data &= 0xF000;
+                mac_ocp_data |= 0x3A9;
+                mac_ocp_write(tp, 0xD3E2, mac_ocp_data);
+
+                mac_ocp_data = mac_ocp_read(tp, 0xD3E4);
+                mac_ocp_data &= 0xFF00;
+                mac_ocp_write(tp, 0xD3E4, mac_ocp_data);
+
+                mac_ocp_data = mac_ocp_read(tp, 0xE860);
+                mac_ocp_data |= BIT_7;
+                mac_ocp_write(tp, 0xE860, mac_ocp_data);
+
+                rtl8168_set_dash_other_fun_dev_aspm_clkreq(tp, 2, 1, 0xED);
+                rtl8168_set_dash_other_fun_dev_state_change(tp, 3, 0x78);
+                if (tp->DASH) {
+                        rtl8168_set_dash_other_fun_dev_state_change(tp, 0, 0x85);
+                        rtl8168_set_dash_other_fun_dev_pci_cmd_register(tp, 0x07, 0x85);
+                } else {
+                        rtl8168_set_dash_other_fun_dev_state_change(tp, 3, 0x85);
+                }
+        } else if (tp->mcfg == CFG_METHOD_1) {
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        pci_read_config_byte(pdev, 0x69, &device_control);
+                        device_control &= ~0x70;
+                        device_control |= 0x28;
+                        pci_write_config_byte(pdev, 0x69, device_control);
+                } else {
+                        pci_read_config_byte(pdev, 0x69, &device_control);
+                        device_control &= ~0x70;
+                        device_control |= 0x58;
+                        pci_write_config_byte(pdev, 0x69, device_control);
+                }
+        } else if (tp->mcfg == CFG_METHOD_2) {
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        pci_read_config_byte(pdev, 0x69, &device_control);
+                        device_control &= ~0x70;
+                        device_control |= 0x28;
+                        pci_write_config_byte(pdev, 0x69, device_control);
+
+                        RTL_W8(Config4, RTL_R8(Config4) | (1 << 0));
+                } else {
+                        pci_read_config_byte(pdev, 0x69, &device_control);
+                        device_control &= ~0x70;
+                        device_control |= 0x58;
+                        pci_write_config_byte(pdev, 0x69, device_control);
+
+                        RTL_W8(Config4, RTL_R8(Config4) & ~(1 << 0));
+                }
+        } else if (tp->mcfg == CFG_METHOD_3) {
+                RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+                if (dev->mtu > ETH_DATA_LEN) {
+                        pci_read_config_byte(pdev, 0x69, &device_control);
+                        device_control &= ~0x70;
+                        device_control |= 0x28;
+                        pci_write_config_byte(pdev, 0x69, device_control);
+
+                        RTL_W8(Config4, RTL_R8(Config4) | (1 << 0));
+                } else {
+                        pci_read_config_byte(pdev, 0x69, &device_control);
+                        device_control &= ~0x70;
+                        device_control |= 0x58;
+                        pci_write_config_byte(pdev, 0x69, device_control);
+
+                        RTL_W8(Config4, RTL_R8(Config4) & ~(1 << 0));
+                }
+        }
+
+        if ((tp->mcfg == CFG_METHOD_1) || (tp->mcfg == CFG_METHOD_2) || (tp->mcfg == CFG_METHOD_3)) {
+                /* csum offload command for RTL8168B/8111B */
+                tp->tx_tcp_csum_cmd = TxTCPCS;
+                tp->tx_udp_csum_cmd = TxUDPCS;
+                tp->tx_ip_csum_cmd = TxIPCS;
+                tp->tx_ipv6_csum_cmd = 0;
+        } else {
+                /* csum offload command for RTL8168C/8111C and RTL8168CP/8111CP */
+                tp->tx_tcp_csum_cmd = TxTCPCS_C;
+                tp->tx_udp_csum_cmd = TxUDPCS_C;
+                tp->tx_ip_csum_cmd = TxIPCS_C;
+                tp->tx_ipv6_csum_cmd = TxIPV6F_C;
+        }
+
+
+        //other hw parameters
+        if (tp->mcfg == CFG_METHOD_21 || tp->mcfg == CFG_METHOD_22 ||
+            tp->mcfg == CFG_METHOD_23 || tp->mcfg == CFG_METHOD_24 ||
+            tp->mcfg == CFG_METHOD_25 || tp->mcfg == CFG_METHOD_26 ||
+            tp->mcfg == CFG_METHOD_27 || tp->mcfg == CFG_METHOD_28)
+                rtl8168_eri_write(ioaddr, 0x2F8, 2, 0x1D8F, ERIAR_ExGMAC);
+
+        if (tp->bios_setting & BIT_28) {
+                if (tp->mcfg == CFG_METHOD_18 || tp->mcfg == CFG_METHOD_19 ||
+                    tp->mcfg == CFG_METHOD_20) {
+                        u32 gphy_val;
+
+                        spin_lock_irqsave(&tp->phy_lock, flags);
+                        mdio_write(tp, 0x1F, 0x0007);
+                        mdio_write(tp, 0x1E, 0x002C);
+                        gphy_val = mdio_read(tp, 0x16);
+                        gphy_val |= BIT_10;
+                        mdio_write(tp, 0x16, gphy_val);
+                        mdio_write(tp, 0x1F, 0x0005);
+                        mdio_write(tp, 0x05, 0x8B80);
+                        gphy_val = mdio_read(tp, 0x06);
+                        gphy_val |= BIT_7;
+                        mdio_write(tp, 0x06, gphy_val);
+                        mdio_write(tp, 0x1F, 0x0000);
+                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                }
+        }
+
+        rtl8168_hw_clear_timer_int(dev);
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_25:
+                mac_ocp_write(tp, 0xD3C0, 0x0B00);
+                mac_ocp_write(tp, 0xD3C2, 0x0000);
+                break;
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+                mac_ocp_write(tp, 0xE098, 0x0AA2);
+                break;
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                mac_ocp_write(tp, 0xE098, mac_ocp_read(tp, 0xE098) | (0x64 << 4));
+                break;
+        }
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                if (aspm) {
+                        rtl8168_init_pci_offset_99(tp);
+                }
+                break;
+        }
+        switch (tp->mcfg) {
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                if (aspm) {
+                        rtl8168_init_pci_offset_180(tp);
+                }
+                break;
+        }
+
+        tp->cp_cmd &= ~(EnableBist | Macdbgo_oe | Force_halfdup |
+                        Force_rxflow_en | Force_txflow_en | Cxpl_dbg_sel |
+                        ASF | Macdbgo_sel);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+        RTL_W16(CPlusCmd, tp->cp_cmd);
+#else
+        rtl8168_hw_set_features(dev, dev->features);
+#endif
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32: {
+                int timeout;
+                for (timeout = 0; timeout < 10; timeout++) {
+                        if ((rtl8168_eri_read(ioaddr, 0x1AE, 2, ERIAR_ExGMAC) & BIT_13)==0)
+                                break;
+                        mdelay(1);
+                }
+        }
+        break;
+        }
+
+        RTL_W16(RxMaxSize, tp->rx_buf_sz);
+
+        rtl8168_disable_rxdvgate(dev);
+
+        if (tp->mcfg == CFG_METHOD_11 || tp->mcfg == CFG_METHOD_12)
+                rtl8168_mac_loopback_test(tp);
+
+        if (!tp->pci_cfg_is_read) {
+                pci_read_config_byte(pdev, PCI_COMMAND, &tp->pci_cfg_space.cmd);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_0, &tp->pci_cfg_space.io_base_l);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_0 + 2, &tp->pci_cfg_space.io_base_h);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_2, &tp->pci_cfg_space.mem_base_l);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_2 + 2, &tp->pci_cfg_space.mem_base_h);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_3, &tp->pci_cfg_space.resv_0x1c_l);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_3 + 2, &tp->pci_cfg_space.resv_0x1c_h);
+                pci_read_config_byte(pdev, PCI_INTERRUPT_LINE, &tp->pci_cfg_space.ilr);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_4, &tp->pci_cfg_space.resv_0x20_l);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_4 + 2, &tp->pci_cfg_space.resv_0x20_h);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_5, &tp->pci_cfg_space.resv_0x24_l);
+                pci_read_config_word(pdev, PCI_BASE_ADDRESS_5 + 2, &tp->pci_cfg_space.resv_0x24_h);
+                pci_read_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID, &tp->pci_cfg_space.resv_0x2c_l);
+                pci_read_config_word(pdev, PCI_SUBSYSTEM_VENDOR_ID + 2, &tp->pci_cfg_space.resv_0x2c_h);
+                tp->pci_cfg_space.pci_sn_l = rtl8168_csi_read(tp, PCI_DEVICE_SERIAL_NUMBER);
+                tp->pci_cfg_space.pci_sn_h = rtl8168_csi_read(tp, PCI_DEVICE_SERIAL_NUMBER + 4);
+
+                tp->pci_cfg_is_read = 1;
+        }
+
+        rtl8168_dsm(dev, DSM_MAC_INIT);
+
+        /* Set Rx packet filter */
+        rtl8168_hw_set_rx_packet_filter(dev);
+
+#ifdef ENABLE_DASH_SUPPORT
+        if (tp->DASH && !tp->dash_printer_enabled)
+                NICChkTypeEnableDashInterrupt(tp);
+#endif
+
+        switch (tp->mcfg) {
+        case CFG_METHOD_14:
+        case CFG_METHOD_15:
+        case CFG_METHOD_16:
+        case CFG_METHOD_17:
+        case CFG_METHOD_18:
+        case CFG_METHOD_19:
+        case CFG_METHOD_20:
+        case CFG_METHOD_21:
+        case CFG_METHOD_22:
+        case CFG_METHOD_23:
+        case CFG_METHOD_24:
+        case CFG_METHOD_25:
+        case CFG_METHOD_26:
+        case CFG_METHOD_27:
+        case CFG_METHOD_28:
+        case CFG_METHOD_29:
+        case CFG_METHOD_30:
+        case CFG_METHOD_31:
+        case CFG_METHOD_32:
+                if (aspm) {
+                        RTL_W8(Config5, RTL_R8(Config5) | BIT_0);
+                        RTL_W8(Config2, RTL_R8(Config2) | BIT_7);
+                } else {
+                        RTL_W8(Config2, RTL_R8(Config2) & ~BIT_7);
+                        RTL_W8(Config5, RTL_R8(Config5) & ~BIT_0);
+                }
+                break;
+        }
+
+        rtl8168_disable_cfg9346_write(tp);
+
+        udelay(10);
+}
+
+static void
+rtl8168_hw_start(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+
+        rtl8168_enable_hw_interrupt(tp, ioaddr);
+}
+
+
+static int
+rtl8168_change_mtu(struct net_device *dev,
+                   int new_mtu)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        int ret = 0;
+        unsigned long flags;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,10,0)
+        if (new_mtu < ETH_ZLEN)
+                return -EINVAL;
+        else if (new_mtu > tp->max_jumbo_frame_size)
+                new_mtu = tp->max_jumbo_frame_size;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(4,10,0)
+
+        spin_lock_irqsave(&tp->lock, flags);
+        dev->mtu = new_mtu;
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        if (!netif_running(dev))
+                goto out;
+
+        rtl8168_down(dev);
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8168_set_rxbufsize(tp, dev);
+
+        ret = rtl8168_init_ring(dev);
+
+        if (ret < 0) {
+                spin_unlock_irqrestore(&tp->lock, flags);
+                goto err_out;
+        }
+
+#ifdef CONFIG_R8168_NAPI
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        RTL_NAPI_ENABLE(dev, &tp->napi);
+#endif
+#endif//CONFIG_R8168_NAPI
+
+        netif_stop_queue(dev);
+        netif_carrier_off(dev);
+        rtl8168_hw_config(dev);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        rtl8168_set_speed(dev, tp->autoneg, tp->speed, tp->duplex, tp->advertising);
+
+        mod_timer(&tp->esd_timer, jiffies + RTL8168_ESD_TIMEOUT);
+        mod_timer(&tp->link_timer, jiffies + RTL8168_LINK_TIMEOUT);
+out:
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,0,0)
+        netdev_update_features(dev);
+#endif
+
+err_out:
+        return ret;
+}
+
+static inline void
+rtl8168_make_unusable_by_asic(struct RxDesc *desc)
+{
+        desc->addr = 0x0badbadbadbadbadull;
+        desc->opts1 &= ~cpu_to_le32(DescOwn | RsvdMask);
+}
+
+static void
+rtl8168_free_rx_skb(struct rtl8168_private *tp,
+                    struct sk_buff **sk_buff,
+                    struct RxDesc *desc)
+{
+        struct pci_dev *pdev = tp->pci_dev;
+
+        pci_unmap_single(pdev, le64_to_cpu(desc->addr), tp->rx_buf_sz,
+                         PCI_DMA_FROMDEVICE);
+        dev_kfree_skb(*sk_buff);
+        *sk_buff = NULL;
+        rtl8168_make_unusable_by_asic(desc);
+}
+
+static inline void
+rtl8168_mark_to_asic(struct RxDesc *desc,
+                     u32 rx_buf_sz)
+{
+        u32 eor = le32_to_cpu(desc->opts1) & RingEnd;
+
+        desc->opts1 = cpu_to_le32(DescOwn | eor | rx_buf_sz);
+}
+
+static inline void
+rtl8168_map_to_asic(struct RxDesc *desc,
+                    dma_addr_t mapping,
+                    u32 rx_buf_sz)
+{
+        desc->addr = cpu_to_le64(mapping);
+        wmb();
+        rtl8168_mark_to_asic(desc, rx_buf_sz);
+}
+
+static int
+rtl8168_alloc_rx_skb(struct rtl8168_private *tp,
+                     struct sk_buff **sk_buff,
+                     struct RxDesc *desc,
+                     int rx_buf_sz,
+                     u8 in_intr)
+{
+        struct sk_buff *skb;
+        dma_addr_t mapping;
+        int ret = 0;
+
+        if (in_intr)
+                skb = RTL_ALLOC_SKB_INTR(tp, rx_buf_sz + RTK_RX_ALIGN);
+        else
+                skb = dev_alloc_skb(rx_buf_sz + RTK_RX_ALIGN);
+
+        if (unlikely(!skb))
+                goto err_out;
+
+        skb_reserve(skb, RTK_RX_ALIGN);
+
+        mapping = pci_map_single(tp->pci_dev, skb->data, rx_buf_sz,
+                                 PCI_DMA_FROMDEVICE);
+        if (unlikely(dma_mapping_error(&tp->pci_dev->dev, mapping))) {
+                if (unlikely(net_ratelimit()))
+                        netif_err(tp, drv, tp->dev, "Failed to map RX DMA!\n");
+                goto err_out;
+        }
+
+        *sk_buff = skb;
+        rtl8168_map_to_asic(desc, mapping, rx_buf_sz);
+out:
+        return ret;
+
+err_out:
+        if (skb)
+                dev_kfree_skb(skb);
+        ret = -ENOMEM;
+        rtl8168_make_unusable_by_asic(desc);
+        goto out;
+}
+
+static void
+rtl8168_rx_clear(struct rtl8168_private *tp)
+{
+        int i;
+
+        for (i = 0; i < NUM_RX_DESC; i++) {
+                if (tp->Rx_skbuff[i])
+                        rtl8168_free_rx_skb(tp, tp->Rx_skbuff + i,
+                                            tp->RxDescArray + i);
+        }
+}
+
+static u32
+rtl8168_rx_fill(struct rtl8168_private *tp,
+                struct net_device *dev,
+                u32 start,
+                u32 end,
+                u8 in_intr)
+{
+        u32 cur;
+
+        for (cur = start; end - cur > 0; cur++) {
+                int ret, i = cur % NUM_RX_DESC;
+
+                if (tp->Rx_skbuff[i])
+                        continue;
+
+                ret = rtl8168_alloc_rx_skb(tp, tp->Rx_skbuff + i,
+                                           tp->RxDescArray + i,
+                                           tp->rx_buf_sz,
+                                           in_intr);
+                if (ret < 0)
+                        break;
+        }
+        return cur - start;
+}
+
+static inline void
+rtl8168_mark_as_last_descriptor(struct RxDesc *desc)
+{
+        desc->opts1 |= cpu_to_le32(RingEnd);
+}
+
+static void
+rtl8168_desc_addr_fill(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        if (!tp->TxPhyAddr || !tp->RxPhyAddr)
+                return;
+
+        RTL_W32(TxDescStartAddrLow, ((u64) tp->TxPhyAddr & DMA_BIT_MASK(32)));
+        RTL_W32(TxDescStartAddrHigh, ((u64) tp->TxPhyAddr >> 32));
+        RTL_W32(RxDescAddrLow, ((u64) tp->RxPhyAddr & DMA_BIT_MASK(32)));
+        RTL_W32(RxDescAddrHigh, ((u64) tp->RxPhyAddr >> 32));
+}
+
+static void
+rtl8168_tx_desc_init(struct rtl8168_private *tp)
+{
+        int i = 0;
+
+        memset(tp->TxDescArray, 0x0, NUM_TX_DESC * sizeof(struct TxDesc));
+
+        for (i = 0; i < NUM_TX_DESC; i++) {
+                if (i == (NUM_TX_DESC - 1))
+                        tp->TxDescArray[i].opts1 = cpu_to_le32(RingEnd);
+        }
+}
+
+static void
+rtl8168_rx_desc_offset0_init(struct rtl8168_private *tp, int own)
+{
+        int i = 0;
+        int ownbit = 0;
+
+        if (own)
+                ownbit = DescOwn;
+
+        for (i = 0; i < NUM_RX_DESC; i++) {
+                if (i == (NUM_RX_DESC - 1))
+                        tp->RxDescArray[i].opts1 = cpu_to_le32((ownbit | RingEnd) | (unsigned long)tp->rx_buf_sz);
+                else
+                        tp->RxDescArray[i].opts1 = cpu_to_le32(ownbit | (unsigned long)tp->rx_buf_sz);
+        }
+}
+
+static void
+rtl8168_rx_desc_init(struct rtl8168_private *tp)
+{
+        memset(tp->RxDescArray, 0x0, NUM_RX_DESC * sizeof(struct RxDesc));
+}
+
+static int
+rtl8168_init_ring(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        rtl8168_init_ring_indexes(tp);
+
+        memset(tp->tx_skb, 0x0, NUM_TX_DESC * sizeof(struct ring_info));
+        memset(tp->Rx_skbuff, 0x0, NUM_RX_DESC * sizeof(struct sk_buff *));
+
+        rtl8168_tx_desc_init(tp);
+        rtl8168_rx_desc_init(tp);
+
+        if (rtl8168_rx_fill(tp, dev, 0, NUM_RX_DESC, 0) != NUM_RX_DESC)
+                goto err_out;
+
+        rtl8168_mark_as_last_descriptor(tp->RxDescArray + NUM_RX_DESC - 1);
+
+        return 0;
+
+err_out:
+        rtl8168_rx_clear(tp);
+        return -ENOMEM;
+}
+
+static void
+rtl8168_unmap_tx_skb(struct pci_dev *pdev,
+                     struct ring_info *tx_skb,
+                     struct TxDesc *desc)
+{
+        unsigned int len = tx_skb->len;
+
+        pci_unmap_single(pdev, le64_to_cpu(desc->addr), len, PCI_DMA_TODEVICE);
+        desc->opts1 = 0x00;
+        desc->opts2 = 0x00;
+        desc->addr = 0x00;
+        tx_skb->len = 0;
+}
+
+static void rtl8168_tx_clear_range(struct rtl8168_private *tp, u32 start,
+                                   unsigned int n)
+{
+        unsigned int i;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,22)
+        struct net_device *dev = tp->dev;
+#endif
+
+        for (i = 0; i < n; i++) {
+                unsigned int entry = (start + i) % NUM_TX_DESC;
+                struct ring_info *tx_skb = tp->tx_skb + entry;
+                unsigned int len = tx_skb->len;
+
+                if (len) {
+                        struct sk_buff *skb = tx_skb->skb;
+
+                        rtl8168_unmap_tx_skb(tp->pci_dev, tx_skb,
+                                             tp->TxDescArray + entry);
+                        if (skb) {
+                                RTLDEV->stats.tx_dropped++;
+                                dev_kfree_skb_any(skb);
+                                tx_skb->skb = NULL;
+                        }
+                }
+        }
+}
+
+static void
+rtl8168_tx_clear(struct rtl8168_private *tp)
+{
+        rtl8168_tx_clear_range(tp, tp->dirty_tx, NUM_TX_DESC);
+        tp->cur_tx = tp->dirty_tx = 0;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+static void rtl8168_schedule_work(struct net_device *dev, void (*task)(void *))
+{
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        INIT_WORK(&tp->task, task, dev);
+        schedule_delayed_work(&tp->task, 4);
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+}
+
+#define rtl8168_cancel_schedule_work(a)
+
+#else
+static void rtl8168_schedule_work(struct net_device *dev, work_func_t task)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        INIT_DELAYED_WORK(&tp->task, task);
+        schedule_delayed_work(&tp->task, 4);
+}
+
+static void rtl8168_cancel_schedule_work(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        cancel_delayed_work_sync(&tp->task);
+}
+#endif
+
+static void
+rtl8168_wait_for_quiescence(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        synchronize_irq(dev->irq);
+
+        /* Wait for any pending NAPI task to complete */
+#ifdef CONFIG_R8168_NAPI
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        RTL_NAPI_DISABLE(dev, &tp->napi);
+#endif
+#endif//CONFIG_R8168_NAPI
+
+        rtl8168_irq_mask_and_ack(tp, ioaddr);
+
+#ifdef CONFIG_R8168_NAPI
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        RTL_NAPI_ENABLE(dev, &tp->napi);
+#endif
+#endif//CONFIG_R8168_NAPI
+}
+
+#if 0
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+static void rtl8168_reinit_task(void *_data)
+#else
+static void rtl8168_reinit_task(struct work_struct *work)
+#endif
+{
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+        struct net_device *dev = _data;
+#else
+        struct rtl8168_private *tp =
+                container_of(work, struct rtl8168_private, task.work);
+        struct net_device *dev = tp->dev;
+#endif
+        int ret;
+
+        if (netif_running(dev)) {
+                rtl8168_wait_for_quiescence(dev);
+                rtl8168_close(dev);
+        }
+
+        ret = rtl8168_open(dev);
+        if (unlikely(ret < 0)) {
+                if (unlikely(net_ratelimit())) {
+                        struct rtl8168_private *tp = netdev_priv(dev);
+
+                        if (netif_msg_drv(tp)) {
+                                printk(PFX KERN_ERR
+                                       "%s: reinit failure (status = %d)."
+                                       " Rescheduling.\n", dev->name, ret);
+                        }
+                }
+                rtl8168_schedule_work(dev, rtl8168_reinit_task);
+        }
+}
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+static void rtl8168_reset_task(void *_data)
+{
+        struct net_device *dev = _data;
+        struct rtl8168_private *tp = netdev_priv(dev);
+#else
+static void rtl8168_reset_task(struct work_struct *work)
+{
+        struct rtl8168_private *tp =
+                container_of(work, struct rtl8168_private, task.work);
+        struct net_device *dev = tp->dev;
+#endif
+        u32 budget = ~(u32)0;
+        unsigned long flags;
+
+        if (!netif_running(dev))
+                return;
+
+        rtl8168_wait_for_quiescence(dev);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+        rtl8168_rx_interrupt(dev, tp, tp->mmio_addr, &budget);
+#else
+        rtl8168_rx_interrupt(dev, tp, tp->mmio_addr, budget);
+#endif	//LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8168_tx_clear(tp);
+
+        if (tp->dirty_rx == tp->cur_rx) {
+                rtl8168_rx_clear(tp);
+                rtl8168_init_ring(dev);
+                rtl8168_set_speed(dev, tp->autoneg, tp->speed, tp->duplex, tp->advertising);
+                spin_unlock_irqrestore(&tp->lock, flags);
+        } else {
+                spin_unlock_irqrestore(&tp->lock, flags);
+                if (unlikely(net_ratelimit())) {
+                        struct rtl8168_private *tp = netdev_priv(dev);
+
+                        if (netif_msg_intr(tp)) {
+                                printk(PFX KERN_EMERG
+                                       "%s: Rx buffers shortage\n", dev->name);
+                        }
+                }
+                rtl8168_schedule_work(dev, rtl8168_reset_task);
+        }
+}
+
+static void
+rtl8168_tx_timeout(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+        netif_stop_queue(dev);
+        netif_carrier_off(dev);
+        rtl8168_hw_reset(dev);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        /* Let's wait a bit while any (async) irq lands on */
+        rtl8168_schedule_work(dev, rtl8168_reset_task);
+}
+
+static int
+rtl8168_xmit_frags(struct rtl8168_private *tp,
+                   struct sk_buff *skb,
+                   u32 opts1,
+                   u32 opts2)
+{
+        struct skb_shared_info *info = skb_shinfo(skb);
+        unsigned int cur_frag, entry;
+        struct TxDesc *txd = NULL;
+
+        entry = tp->cur_tx;
+        for (cur_frag = 0; cur_frag < info->nr_frags; cur_frag++) {
+                skb_frag_t *frag = info->frags + cur_frag;
+                dma_addr_t mapping;
+                u32 status, len;
+                void *addr;
+
+                entry = (entry + 1) % NUM_TX_DESC;
+
+                txd = tp->TxDescArray + entry;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
+                len = frag->size;
+                addr = ((void *) page_address(frag->page)) + frag->page_offset;
+#else
+                len = skb_frag_size(frag);
+                addr = skb_frag_address(frag);
+#endif
+                mapping = pci_map_single(tp->pci_dev, addr, len, PCI_DMA_TODEVICE);
+
+                if (unlikely(dma_mapping_error(&tp->pci_dev->dev, mapping))) {
+                        if (unlikely(net_ratelimit()))
+                                netif_err(tp, drv, tp->dev,
+                                          "Failed to map TX fragments DMA!\n");
+                        goto err_out;
+                }
+
+                /* anti gcc 2.95.3 bugware (sic) */
+                status = opts1 | len | (RingEnd * !((entry + 1) % NUM_TX_DESC));
+
+                txd->addr = cpu_to_le64(mapping);
+
+                tp->tx_skb[entry].len = len;
+
+                txd->opts1 = cpu_to_le32(status);
+                txd->opts2 = cpu_to_le32(opts2);
+        }
+
+        if (cur_frag) {
+                tp->tx_skb[entry].skb = skb;
+                wmb();
+                txd->opts1 |= cpu_to_le32(LastFrag);
+        }
+
+        return cur_frag;
+
+err_out:
+        rtl8168_tx_clear_range(tp, tp->cur_tx + 1, cur_frag);
+        return -EIO;
+}
+
+static inline
+__be16 get_protocol(struct sk_buff *skb)
+{
+        __be16 protocol;
+
+        if (skb->protocol == htons(ETH_P_8021Q))
+                protocol = vlan_eth_hdr(skb)->h_vlan_encapsulated_proto;
+        else
+                protocol = skb->protocol;
+
+        return protocol;
+}
+
+static inline u32
+rtl8168_tx_csum(struct sk_buff *skb,
+                struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        u32 csum_cmd = 0;
+        u8 sw_calc_csum = FALSE;
+
+        if (skb->ip_summed == CHECKSUM_PARTIAL) {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+                const struct iphdr *ip = skb->nh.iph;
+
+                if (dev->features & NETIF_F_IP_CSUM) {
+                        if (ip->protocol == IPPROTO_TCP)
+                                csum_cmd = tp->tx_ip_csum_cmd | tp->tx_tcp_csum_cmd;
+                        else if (ip->protocol == IPPROTO_UDP)
+                                csum_cmd = tp->tx_ip_csum_cmd | tp->tx_udp_csum_cmd;
+                        else if (ip->protocol == IPPROTO_IP)
+                                csum_cmd = tp->tx_ip_csum_cmd;
+                }
+#else
+                u8 ip_protocol = IPPROTO_RAW;
+
+                switch (get_protocol(skb)) {
+                case  __constant_htons(ETH_P_IP):
+                        if (dev->features & NETIF_F_IP_CSUM) {
+                                ip_protocol = ip_hdr(skb)->protocol;
+                                csum_cmd = tp->tx_ip_csum_cmd;
+                        }
+                        break;
+                case  __constant_htons(ETH_P_IPV6):
+                        if (dev->features & NETIF_F_IPV6_CSUM) {
+                                u32 transport_offset = (u32)skb_transport_offset(skb);
+                                if (transport_offset > 0 && transport_offset <= TCPHO_MAX) {
+                                        ip_protocol = ipv6_hdr(skb)->nexthdr;
+                                        csum_cmd = tp->tx_ipv6_csum_cmd;
+                                        csum_cmd |= transport_offset << TCPHO_SHIFT;
+                                }
+                        }
+                        break;
+                default:
+                        if (unlikely(net_ratelimit()))
+                                dprintk("checksum_partial proto=%x!\n", skb->protocol);
+                        break;
+                }
+
+                if (ip_protocol == IPPROTO_TCP)
+                        csum_cmd |= tp->tx_tcp_csum_cmd;
+                else if (ip_protocol == IPPROTO_UDP)
+                        csum_cmd |= tp->tx_udp_csum_cmd;
+#endif
+                if (csum_cmd == 0) {
+                        sw_calc_csum = TRUE;
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+                        WARN_ON(1); /* we need a WARN() */
+#endif
+                }
+        }
+
+        if (tp->ShortPacketSwChecksum && skb->len < 60 && csum_cmd != 0)
+                sw_calc_csum = TRUE;
+
+        if (sw_calc_csum) {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10) && LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,7)
+                skb_checksum_help(&skb, 0);
+#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19) && LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,10)
+                skb_checksum_help(skb, 0);
+#else
+                skb_checksum_help(skb);
+#endif
+                csum_cmd = 0;
+        }
+
+        return csum_cmd;
+}
+
+static int
+rtl8168_sw_padding_short_pkt(struct rtl8168_private *tp,
+                             struct sk_buff *skb,
+                             u32 opts1,
+                             u32 opts2)
+{
+        unsigned int entry;
+        dma_addr_t mapping;
+        u32 status, len;
+        void *addr;
+        struct TxDesc *txd = NULL;
+        int ret = 0;
+
+        if (skb->len >= ETH_ZLEN)
+                goto out;
+
+        entry = tp->cur_tx;
+
+        entry = (entry + 1) % NUM_TX_DESC;
+
+        txd = tp->TxDescArray + entry;
+        len = ETH_ZLEN - skb->len;
+        addr = tp->ShortPacketEmptyBuffer;
+        mapping = pci_map_single(tp->pci_dev, addr, len, PCI_DMA_TODEVICE);
+        if (unlikely(dma_mapping_error(&tp->pci_dev->dev, mapping))) {
+                if (unlikely(net_ratelimit()))
+                        netif_err(tp, drv, tp->dev,
+                                  "Failed to map Short Packet Buffer DMA!\n");
+                ret = -ENOMEM;
+                goto out;
+        }
+        status = opts1 | len | (RingEnd * !((entry + 1) % NUM_TX_DESC));
+
+        txd->addr = cpu_to_le64(mapping);
+
+        txd->opts1 = cpu_to_le32(status);
+        txd->opts2 = cpu_to_le32(opts2);
+
+        wmb();
+        txd->opts1 |= cpu_to_le32(LastFrag);
+out:
+        return ret;
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,14,0)
+/* r8169_csum_workaround()
+  * The hw limites the value the transport offset. When the offset is out of the
+  * range, calculate the checksum by sw.
+  */
+static void r8168_csum_workaround(struct rtl8168_private *tp,
+                                  struct sk_buff *skb)
+{
+        if (skb_shinfo(skb)->gso_size) {
+                netdev_features_t features = tp->dev->features;
+                struct sk_buff *segs, *nskb;
+
+                features &= ~(NETIF_F_SG | NETIF_F_IPV6_CSUM | NETIF_F_TSO6);
+                segs = skb_gso_segment(skb, features);
+                if (IS_ERR(segs) || !segs)
+                        goto drop;
+
+                do {
+                        nskb = segs;
+                        segs = segs->next;
+                        nskb->next = NULL;
+                        rtl8168_start_xmit(nskb, tp->dev);
+                } while (segs);
+
+                dev_consume_skb_any(skb);
+        } else if (skb->ip_summed == CHECKSUM_PARTIAL) {
+                if (skb_checksum_help(skb) < 0)
+                        goto drop;
+
+                rtl8168_start_xmit(skb, tp->dev);
+        } else {
+                struct net_device_stats *stats;
+
+drop:
+                stats = &tp->dev->stats;
+                stats->tx_dropped++;
+                dev_kfree_skb_any(skb);
+        }
+}
+
+/* msdn_giant_send_check()
+ * According to the document of microsoft, the TCP Pseudo Header excludes the
+ * packet length for IPv6 TCP large packets.
+ */
+static int msdn_giant_send_check(struct sk_buff *skb)
+{
+        const struct ipv6hdr *ipv6h;
+        struct tcphdr *th;
+        int ret;
+
+        ret = skb_cow_head(skb, 0);
+        if (ret)
+                return ret;
+
+        ipv6h = ipv6_hdr(skb);
+        th = tcp_hdr(skb);
+
+        th->check = 0;
+        th->check = ~tcp_v6_check(0, &ipv6h->saddr, &ipv6h->daddr, 0);
+
+        return ret;
+}
+#endif
+
+static int
+rtl8168_start_xmit(struct sk_buff *skb,
+                   struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned int entry;
+        struct TxDesc *txd;
+        void __iomem *ioaddr = tp->mmio_addr;
+        dma_addr_t mapping;
+        u32 len;
+        u32 opts1;
+        u32 opts2;
+        int ret = NETDEV_TX_OK;
+        unsigned long flags, large_send;
+        int frags;
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        if (unlikely(TX_BUFFS_AVAIL(tp) < skb_shinfo(skb)->nr_frags)) {
+                if (netif_msg_drv(tp)) {
+                        printk(KERN_ERR
+                               "%s: BUG! Tx Ring full when queue awake!\n",
+                               dev->name);
+                }
+                goto err_stop;
+        }
+
+        entry = tp->cur_tx % NUM_TX_DESC;
+        txd = tp->TxDescArray + entry;
+
+        if (unlikely(le32_to_cpu(txd->opts1) & DescOwn))
+                goto err_stop;
+
+        opts1 = DescOwn;
+        opts2 = rtl8168_tx_vlan_tag(tp, skb);
+
+        large_send = 0;
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        if (dev->features & (NETIF_F_TSO | NETIF_F_TSO6)) {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18)
+                u32 mss = skb_shinfo(skb)->tso_size;
+#else
+                u32 mss = skb_shinfo(skb)->gso_size;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18)
+
+                /* TCP Segmentation Offload (or TCP Large Send) */
+                if (mss) {
+                        if ((tp->mcfg == CFG_METHOD_1) ||
+                            (tp->mcfg == CFG_METHOD_2) ||
+                            (tp->mcfg == CFG_METHOD_3)) {
+                                opts1 |= LargeSend | (min(mss, MSS_MAX) << 16);
+                                large_send = 1;
+                        } else {
+                                u32 transport_offset = (u32)skb_transport_offset(skb);
+                                switch (get_protocol(skb)) {
+                                case __constant_htons(ETH_P_IP):
+                                        if (transport_offset <= 128) {
+                                                opts1 |= GiantSendv4;
+                                                opts1 |= transport_offset << GTTCPHO_SHIFT;
+                                                opts2 |= min(mss, MSS_MAX) << 18;
+                                                large_send = 1;
+                                        }
+                                        break;
+                                case __constant_htons(ETH_P_IPV6):
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,14,0)
+                                        if (msdn_giant_send_check(skb)) {
+                                                spin_unlock_irqrestore(&tp->lock, flags);
+                                                r8168_csum_workaround(tp, skb);
+                                                goto out;
+                                        }
+#endif
+                                        if (transport_offset <= 128) {
+                                                opts1 |= GiantSendv6;
+                                                opts1 |= transport_offset << GTTCPHO_SHIFT;
+                                                opts2 |= min(mss, MSS_MAX) << 18;
+                                                large_send = 1;
+                                        }
+                                        break;
+                                default:
+                                        if (unlikely(net_ratelimit()))
+                                                dprintk("tso proto=%x!\n", skb->protocol);
+                                        break;
+                                }
+                        }
+
+                        if (large_send == 0)
+                                goto err_dma_0;
+                }
+        }
+#endif //LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+
+        if (large_send == 0) {
+                if (skb->ip_summed == CHECKSUM_PARTIAL) {
+                        if ((tp->mcfg == CFG_METHOD_1) || (tp->mcfg == CFG_METHOD_2) || (tp->mcfg == CFG_METHOD_3))
+                                opts1 |= rtl8168_tx_csum(skb, dev);
+                        else
+                                opts2 |= rtl8168_tx_csum(skb, dev);
+                }
+        }
+
+        frags = rtl8168_xmit_frags(tp, skb, opts1, opts2);
+        if (unlikely(frags < 0))
+                goto err_dma_0;
+        if (frags) {
+                len = skb_headlen(skb);
+                opts1 |= FirstFrag;
+        } else {
+                len = skb->len;
+
+                tp->tx_skb[entry].skb = skb;
+
+                if (tp->UseSwPaddingShortPkt && len < 60) {
+                        if (unlikely(rtl8168_sw_padding_short_pkt(tp, skb, opts1, opts2)))
+                                goto err_dma_1;
+                        opts1 |= FirstFrag;
+                        frags++;
+                } else {
+                        opts1 |= FirstFrag | LastFrag;
+                }
+        }
+
+        opts1 |= len | (RingEnd * !((entry + 1) % NUM_TX_DESC));
+        mapping = pci_map_single(tp->pci_dev, skb->data, len, PCI_DMA_TODEVICE);
+        if (unlikely(dma_mapping_error(&tp->pci_dev->dev, mapping))) {
+                if (unlikely(net_ratelimit()))
+                        netif_err(tp, drv, dev, "Failed to map TX DMA!\n");
+                goto err_dma_1;
+        }
+        tp->tx_skb[entry].len = len;
+        txd->addr = cpu_to_le64(mapping);
+        txd->opts2 = cpu_to_le32(opts2);
+        txd->opts1 = cpu_to_le32(opts1&~DescOwn);
+        wmb();
+        txd->opts1 = cpu_to_le32(opts1);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,5,0)
+        dev->trans_start = jiffies;
+#else
+        skb_tx_timestamp(skb);
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(3,5,0)
+
+        tp->cur_tx += frags + 1;
+
+        wmb();
+
+        RTL_W8(TxPoll, NPQ);    /* set polling bit */
+
+        if (TX_BUFFS_AVAIL(tp) < MAX_SKB_FRAGS) {
+                netif_stop_queue(dev);
+                smp_rmb();
+                if (TX_BUFFS_AVAIL(tp) >= MAX_SKB_FRAGS)
+                        netif_wake_queue(dev);
+        }
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+out:
+        return ret;
+err_dma_1:
+        tp->tx_skb[entry].skb = NULL;
+        rtl8168_tx_clear_range(tp, tp->cur_tx + 1, frags);
+err_dma_0:
+        RTLDEV->stats.tx_dropped++;
+        spin_unlock_irqrestore(&tp->lock, flags);
+        dev_kfree_skb_any(skb);
+        ret = NETDEV_TX_OK;
+        goto out;
+err_stop:
+        netif_stop_queue(dev);
+        ret = NETDEV_TX_BUSY;
+        RTLDEV->stats.tx_dropped++;
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+        goto out;
+}
+
+static void
+rtl8168_tx_interrupt(struct net_device *dev,
+                     struct rtl8168_private *tp,
+                     void __iomem *ioaddr)
+{
+        unsigned int dirty_tx, tx_left;
+
+        assert(dev != NULL);
+        assert(tp != NULL);
+        assert(ioaddr != NULL);
+
+        dirty_tx = tp->dirty_tx;
+        smp_rmb();
+        tx_left = tp->cur_tx - dirty_tx;
+
+        while (tx_left > 0) {
+                unsigned int entry = dirty_tx % NUM_TX_DESC;
+                struct ring_info *tx_skb = tp->tx_skb + entry;
+                u32 len = tx_skb->len;
+                u32 status;
+
+                rmb();
+                status = le32_to_cpu(tp->TxDescArray[entry].opts1);
+                if (status & DescOwn)
+                        break;
+
+                RTLDEV->stats.tx_bytes += len;
+                RTLDEV->stats.tx_packets++;
+
+                rtl8168_unmap_tx_skb(tp->pci_dev,
+                                     tx_skb,
+                                     tp->TxDescArray + entry);
+
+                if (tx_skb->skb!=NULL) {
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,14,0)
+                        dev_consume_skb_any(tx_skb->skb);
+#else
+                        dev_kfree_skb_any(tx_skb->skb);
+#endif
+                        tx_skb->skb = NULL;
+                }
+                dirty_tx++;
+                tx_left--;
+        }
+
+        if (tp->dirty_tx != dirty_tx) {
+                tp->dirty_tx = dirty_tx;
+                smp_wmb();
+                if (netif_queue_stopped(dev) &&
+                    (TX_BUFFS_AVAIL(tp) >= MAX_SKB_FRAGS)) {
+                        netif_wake_queue(dev);
+                }
+                smp_rmb();
+                if (tp->cur_tx != dirty_tx)
+                        RTL_W8(TxPoll, NPQ);
+        }
+}
+
+static inline int
+rtl8168_fragmented_frame(u32 status)
+{
+        return (status & (FirstFrag | LastFrag)) != (FirstFrag | LastFrag);
+}
+
+static inline void
+rtl8168_rx_csum(struct rtl8168_private *tp,
+                struct sk_buff *skb,
+                struct RxDesc *desc)
+{
+        u32 opts1 = le32_to_cpu(desc->opts1);
+        u32 opts2 = le32_to_cpu(desc->opts2);
+
+        if ((tp->mcfg == CFG_METHOD_1) ||
+            (tp->mcfg == CFG_METHOD_2) ||
+            (tp->mcfg == CFG_METHOD_3)) {
+                u32 status = opts1 & RxProtoMask;
+
+                /* rx csum offload for RTL8168B/8111B */
+                if (((status == RxProtoTCP) && !(opts1 & (RxTCPF | RxIPF))) ||
+                    ((status == RxProtoUDP) && !(opts1 & (RxUDPF | RxIPF))))
+                        skb->ip_summed = CHECKSUM_UNNECESSARY;
+                else
+                        skb->ip_summed = CHECKSUM_NONE;
+        } else {
+                /* rx csum offload for RTL8168C/8111C and RTL8168CP/8111CP */
+                if (((opts2 & RxV4F) && !(opts1 & RxIPF)) || (opts2 & RxV6F)) {
+                        if (((opts1 & RxTCPT) && !(opts1 & RxTCPF)) ||
+                            ((opts1 & RxUDPT) && !(opts1 & RxUDPF)))
+                                skb->ip_summed = CHECKSUM_UNNECESSARY;
+                        else
+                                skb->ip_summed = CHECKSUM_NONE;
+                } else
+                        skb->ip_summed = CHECKSUM_NONE;
+        }
+}
+
+static inline int
+rtl8168_try_rx_copy(struct rtl8168_private *tp,
+                    struct sk_buff **sk_buff,
+                    int pkt_size,
+                    struct RxDesc *desc,
+                    int rx_buf_sz)
+{
+        int ret = -1;
+
+        if (pkt_size < rx_copybreak) {
+                struct sk_buff *skb;
+
+                skb = RTL_ALLOC_SKB_INTR(tp, pkt_size + RTK_RX_ALIGN);
+                if (skb) {
+                        u8 *data;
+
+                        data = sk_buff[0]->data;
+                        skb_reserve(skb, RTK_RX_ALIGN);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,37)
+                        prefetch(data - RTK_RX_ALIGN);
+#endif
+                        eth_copy_and_sum(skb, data, pkt_size, 0);
+                        *sk_buff = skb;
+                        rtl8168_mark_to_asic(desc, rx_buf_sz);
+                        ret = 0;
+                }
+        }
+        return ret;
+}
+
+static inline void
+rtl8168_rx_skb(struct rtl8168_private *tp,
+               struct sk_buff *skb)
+{
+#ifdef CONFIG_R8168_NAPI
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+        netif_receive_skb(skb);
+#else
+        napi_gro_receive(&tp->napi, skb);
+#endif
+#else
+        netif_rx(skb);
+#endif
+}
+
+static int
+rtl8168_rx_interrupt(struct net_device *dev,
+                     struct rtl8168_private *tp,
+                     void __iomem *ioaddr, napi_budget budget)
+{
+        unsigned int cur_rx, rx_left;
+        unsigned int delta, count = 0;
+        unsigned int entry;
+        struct RxDesc *desc;
+        u32 status;
+        u32 rx_quota;
+
+        assert(dev != NULL);
+        assert(tp != NULL);
+        assert(ioaddr != NULL);
+
+        if ((tp->RxDescArray == NULL) || (tp->Rx_skbuff == NULL))
+                goto rx_out;
+
+        rx_quota = RTL_RX_QUOTA(budget);
+        cur_rx = tp->cur_rx;
+        entry = cur_rx % NUM_RX_DESC;
+        desc = tp->RxDescArray + entry;
+        rx_left = NUM_RX_DESC + tp->dirty_rx - cur_rx;
+        rx_left = rtl8168_rx_quota(rx_left, (u32)rx_quota);
+
+        for (; rx_left > 0; rx_left--) {
+                rmb();
+                status = le32_to_cpu(desc->opts1);
+                if (status & DescOwn)
+                        break;
+                if (unlikely(status & RxRES)) {
+                        if (netif_msg_rx_err(tp)) {
+                                printk(KERN_INFO
+                                       "%s: Rx ERROR. status = %08x\n",
+                                       dev->name, status);
+                        }
+
+                        RTLDEV->stats.rx_errors++;
+
+                        if (status & (RxRWT | RxRUNT))
+                                RTLDEV->stats.rx_length_errors++;
+                        if (status & RxCRC)
+                                RTLDEV->stats.rx_crc_errors++;
+                        if (dev->features & NETIF_F_RXALL)
+                                goto process_pkt;
+
+                        rtl8168_mark_to_asic(desc, tp->rx_buf_sz);
+                } else {
+                        struct sk_buff *skb;
+                        int pkt_size;
+                        void (*pci_action)(struct pci_dev *, dma_addr_t,
+                                           size_t, int);
+
+process_pkt:
+                        if (likely(!(dev->features & NETIF_F_RXFCS)))
+                                pkt_size = (status & 0x00003fff) - 4;
+                        else
+                                pkt_size = status & 0x00003fff;
+
+                        /*
+                         * The driver does not support incoming fragmented
+                         * frames. They are seen as a symptom of over-mtu
+                         * sized frames.
+                         */
+                        if (unlikely(rtl8168_fragmented_frame(status))) {
+                                RTLDEV->stats.rx_dropped++;
+                                RTLDEV->stats.rx_length_errors++;
+                                rtl8168_mark_to_asic(desc, tp->rx_buf_sz);
+                                continue;
+                        }
+
+                        skb = tp->Rx_skbuff[entry];
+                        if (tp->cp_cmd & RxChkSum)
+                                rtl8168_rx_csum(tp, skb, desc);
+
+                        pci_dma_sync_single_for_cpu(tp->pci_dev,
+                                                    le64_to_cpu(desc->addr), tp->rx_buf_sz,
+                                                    PCI_DMA_FROMDEVICE);
+
+                        pci_action = pci_dma_sync_single_for_device;
+                        if (rtl8168_try_rx_copy(tp, &skb, pkt_size,
+                                                desc, tp->rx_buf_sz)) {
+                                pci_action = pci_unmap_single;
+                                tp->Rx_skbuff[entry] = NULL;
+                        }
+
+                        pci_action(tp->pci_dev, le64_to_cpu(desc->addr),
+                                   tp->rx_buf_sz, PCI_DMA_FROMDEVICE);
+
+                        skb->dev = dev;
+                        skb_put(skb, pkt_size);
+                        skb->protocol = eth_type_trans(skb, dev);
+
+                        if (skb->pkt_type == PACKET_MULTICAST)
+                                RTLDEV->stats.multicast++;
+
+                        if (rtl8168_rx_vlan_skb(tp, desc, skb) < 0)
+                                rtl8168_rx_skb(tp, skb);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,11,0)
+                        dev->last_rx = jiffies;
+#endif //LINUX_VERSION_CODE < KERNEL_VERSION(4,11,0)
+                        RTLDEV->stats.rx_bytes += pkt_size;
+                        RTLDEV->stats.rx_packets++;
+                }
+
+                cur_rx++;
+                entry = cur_rx % NUM_RX_DESC;
+                desc = tp->RxDescArray + entry;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,37)
+                prefetch(desc);
+#endif
+        }
+
+        count = cur_rx - tp->cur_rx;
+        tp->cur_rx = cur_rx;
+
+        delta = rtl8168_rx_fill(tp, dev, tp->dirty_rx, tp->cur_rx, 1);
+        if (!delta && count && netif_msg_intr(tp))
+                printk(KERN_INFO "%s: no Rx buffer allocated\n", dev->name);
+        tp->dirty_rx += delta;
+
+        /*
+         * FIXME: until there is periodic timer to try and refill the ring,
+         * a temporary shortage may definitely kill the Rx process.
+         * - disable the asic to try and avoid an overflow and kick it again
+         *   after refill ?
+         * - how do others driver handle this condition (Uh oh...).
+         */
+        if ((tp->dirty_rx + NUM_RX_DESC == tp->cur_rx) && netif_msg_intr(tp))
+                printk(KERN_EMERG "%s: Rx buffers exhausted\n", dev->name);
+
+rx_out:
+        return count;
+}
+
+/*
+ *The interrupt handler does all of the Rx thread work and cleans up after
+ *the Tx thread.
+ */
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
+static irqreturn_t rtl8168_interrupt(int irq, void *dev_instance, struct pt_regs *regs)
+#else
+static irqreturn_t rtl8168_interrupt(int irq, void *dev_instance)
+#endif
+{
+        struct net_device *dev = (struct net_device *) dev_instance;
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+        int status;
+        int handled = 0;
+
+        do {
+                status = RTL_R16(IntrStatus);
+
+                if (!(tp->features & RTL_FEATURE_MSI)) {
+                        /* hotplug/major error/no more work/shared irq */
+                        if ((status == 0xFFFF) || !status)
+                                break;
+
+                        if (!(status & (tp->intr_mask | tp->timer_intr_mask)))
+                                break;
+                }
+
+                handled = 1;
+
+                rtl8168_disable_hw_interrupt(tp, ioaddr);
+
+                switch (tp->mcfg) {
+                case CFG_METHOD_9:
+                case CFG_METHOD_10:
+                case CFG_METHOD_11:
+                case CFG_METHOD_12:
+                case CFG_METHOD_13:
+                case CFG_METHOD_14:
+                case CFG_METHOD_15:
+                case CFG_METHOD_16:
+                case CFG_METHOD_17:
+                case CFG_METHOD_18:
+                case CFG_METHOD_19:
+                case CFG_METHOD_20:
+                case CFG_METHOD_21:
+                case CFG_METHOD_22:
+                case CFG_METHOD_23:
+                case CFG_METHOD_24:
+                case CFG_METHOD_25:
+                case CFG_METHOD_26:
+                case CFG_METHOD_27:
+                case CFG_METHOD_28:
+                case CFG_METHOD_29:
+                case CFG_METHOD_30:
+                case CFG_METHOD_31:
+                case CFG_METHOD_32:
+                        /* RX_OVERFLOW RE-START mechanism now HW handles it automatically*/
+                        RTL_W16(IntrStatus, status&~RxFIFOOver);
+                        break;
+                default:
+                        RTL_W16(IntrStatus, status);
+                        break;
+                }
+
+                //Work around for rx fifo overflow
+                if (unlikely(status & RxFIFOOver)) {
+                        if (tp->mcfg == CFG_METHOD_1) {
+                                netif_stop_queue(dev);
+                                udelay(300);
+                                rtl8168_hw_reset(dev);
+                                rtl8168_tx_clear(tp);
+                                rtl8168_rx_clear(tp);
+                                rtl8168_init_ring(dev);
+                                rtl8168_hw_config(dev);
+                                rtl8168_hw_start(dev);
+                                netif_wake_queue(dev);
+                        }
+                }
+
+#ifdef ENABLE_DASH_SUPPORT
+                if ( tp->DASH ) {
+                        if (HW_DASH_SUPPORT_TYPE_2(tp) || HW_DASH_SUPPORT_TYPE_3(tp)) {
+                                u8 DashIntType2Status;
+
+                                if (status & ISRIMR_DASH_INTR_CMAC_RESET)
+                                        tp->CmacResetIntr = TRUE;
+
+                                DashIntType2Status = RTL_CMAC_R8(CMAC_IBISR0);
+                                if (DashIntType2Status & ISRIMR_DASH_TYPE2_ROK) {
+                                        tp->RcvFwDashOkEvt = TRUE;
+                                }
+                                if (DashIntType2Status & ISRIMR_DASH_TYPE2_TOK) {
+                                        tp->SendFwHostOkEvt = TRUE;
+                                }
+                                if (DashIntType2Status & ISRIMR_DASH_TYPE2_RX_DISABLE_IDLE) {
+                                        tp->DashFwDisableRx = TRUE;
+                                }
+
+                                RTL_CMAC_W8(CMAC_IBISR0, DashIntType2Status);
+                        } else {
+                                if (status & ISRIMR_DP_REQSYS_OK) {
+                                        tp->RcvFwReqSysOkEvt = TRUE;
+                                }
+                                if (status & ISRIMR_DP_DASH_OK) {
+                                        tp->RcvFwDashOkEvt = TRUE;
+                                }
+                                if (status & ISRIMR_DP_HOST_OK) {
+                                        tp->SendFwHostOkEvt = TRUE;
+                                }
+                        }
+                }
+#endif
+
+#ifdef CONFIG_R8168_NAPI
+                if (status & tp->intr_mask || tp->keep_intr_cnt-- > 0) {
+                        if (status & tp->intr_mask)
+                                tp->keep_intr_cnt = RTK_KEEP_INTERRUPT_COUNT;
+
+                        if (likely(RTL_NETIF_RX_SCHEDULE_PREP(dev, &tp->napi)))
+                                __RTL_NETIF_RX_SCHEDULE(dev, &tp->napi);
+                        else if (netif_msg_intr(tp))
+                                printk(KERN_INFO "%s: interrupt %04x in poll\n",
+                                       dev->name, status);
+                } else {
+                        tp->keep_intr_cnt = RTK_KEEP_INTERRUPT_COUNT;
+                        rtl8168_switch_to_hw_interrupt(tp, ioaddr);
+                }
+#else
+                if (status & tp->intr_mask || tp->keep_intr_cnt-- > 0) {
+                        u32 budget = ~(u32)0;
+
+                        if (status & tp->intr_mask)
+                                tp->keep_intr_cnt = RTK_KEEP_INTERRUPT_COUNT;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+                        rtl8168_rx_interrupt(dev, tp, tp->mmio_addr, &budget);
+#else
+                        rtl8168_rx_interrupt(dev, tp, tp->mmio_addr, budget);
+#endif	//LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+                        rtl8168_tx_interrupt(dev, tp, ioaddr);
+
+#ifdef ENABLE_DASH_SUPPORT
+                        if ( tp->DASH ) {
+                                struct net_device *dev = tp->dev;
+
+                                HandleDashInterrupt(dev);
+                        }
+#endif
+
+                        rtl8168_switch_to_timer_interrupt(tp, ioaddr);
+                } else {
+                        tp->keep_intr_cnt = RTK_KEEP_INTERRUPT_COUNT;
+                        rtl8168_switch_to_hw_interrupt(tp, ioaddr);
+                }
+#endif
+
+        } while (false);
+
+        return IRQ_RETVAL(handled);
+}
+
+#ifdef CONFIG_R8168_NAPI
+static int rtl8168_poll(napi_ptr napi, napi_budget budget)
+{
+        struct rtl8168_private *tp = RTL_GET_PRIV(napi, struct rtl8168_private);
+        void __iomem *ioaddr = tp->mmio_addr;
+        RTL_GET_NETDEV(tp)
+        unsigned int work_to_do = RTL_NAPI_QUOTA(budget, dev);
+        unsigned int work_done;
+        unsigned long flags;
+
+        work_done = rtl8168_rx_interrupt(dev, tp, ioaddr, budget);
+
+        spin_lock_irqsave(&tp->lock, flags);
+        rtl8168_tx_interrupt(dev, tp, ioaddr);
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        RTL_NAPI_QUOTA_UPDATE(dev, work_done, budget);
+
+        if (work_done < work_to_do) {
+#ifdef ENABLE_DASH_SUPPORT
+                if ( tp->DASH ) {
+                        struct net_device *dev = tp->dev;
+
+                        spin_lock_irqsave(&tp->lock, flags);
+                        HandleDashInterrupt(dev);
+                        spin_unlock_irqrestore(&tp->lock, flags);
+                }
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,10,0)
+                if (RTL_NETIF_RX_COMPLETE(dev, napi, work_done) == FALSE) return RTL_NAPI_RETURN_VALUE;
+#else
+                RTL_NETIF_RX_COMPLETE(dev, napi, work_done);
+#endif
+                /*
+                 * 20040426: the barrier is not strictly required but the
+                 * behavior of the irq handler could be less predictable
+                 * without it. Btw, the lack of flush for the posted pci
+                 * write is safe - FR
+                 */
+                smp_wmb();
+
+                rtl8168_switch_to_timer_interrupt(tp, ioaddr);
+        }
+
+        return RTL_NAPI_RETURN_VALUE;
+}
+#endif//CONFIG_R8168_NAPI
+
+static void rtl8168_sleep_rx_enable(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        void __iomem *ioaddr = tp->mmio_addr;
+
+        if ((tp->mcfg == CFG_METHOD_1) || (tp->mcfg == CFG_METHOD_2)) {
+                RTL_W8(ChipCmd, CmdReset);
+                rtl8168_rx_desc_offset0_init(tp, 0);
+                RTL_W8(ChipCmd, CmdRxEnb);
+        } else if (tp->mcfg == CFG_METHOD_14 || tp->mcfg == CFG_METHOD_15) {
+                rtl8168_ephy_write(ioaddr, 0x19, 0xFF64);
+                RTL_W32(RxConfig, RTL_R32(RxConfig) | AcceptBroadcast | AcceptMulticast | AcceptMyPhys);
+        }
+}
+
+static void rtl8168_down(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        unsigned long flags;
+
+        rtl8168_delete_esd_timer(dev, &tp->esd_timer);
+
+        rtl8168_delete_link_timer(dev, &tp->link_timer);
+
+#ifdef CONFIG_R8168_NAPI
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        RTL_NAPI_DISABLE(dev, &tp->napi);
+#endif
+#endif//CONFIG_R8168_NAPI
+
+        netif_stop_queue(dev);
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,11)
+        /* Give a racing hard_start_xmit a few cycles to complete. */
+        synchronize_sched();  /* FIXME: should this be synchronize_irq()? */
+#endif
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        netif_carrier_off(dev);
+
+        rtl8168_dsm(dev, DSM_IF_DOWN);
+
+        rtl8168_hw_reset(dev);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        synchronize_irq(dev->irq);
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8168_tx_clear(tp);
+
+        rtl8168_rx_clear(tp);
+
+        rtl8168_sleep_rx_enable(dev);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+}
+
+static int rtl8168_close(struct net_device *dev)
+{
+        struct rtl8168_private *tp = netdev_priv(dev);
+        struct pci_dev *pdev = tp->pci_dev;
+
+        if (tp->TxDescArray!=NULL && tp->RxDescArray!=NULL) {
+                rtl8168_cancel_schedule_work(dev);
+
+                rtl8168_down(dev);
+
+                rtl8168_hw_d3_para(dev);
+
+                rtl8168_powerdown_pll(dev);
+
+                free_irq(dev->irq, dev);
+
+                pci_free_consistent(pdev, R8168_RX_RING_BYTES, tp->RxDescArray,
+                                    tp->RxPhyAddr);
+                pci_free_consistent(pdev, R8168_TX_RING_BYTES, tp->TxDescArray,
+                                    tp->TxPhyAddr);
+                tp->TxDescArray = NULL;
+                tp->RxDescArray = NULL;
+
+                if (tp->ShortPacketEmptyBuffer != NULL) {
+                        pci_free_consistent(pdev, SHORT_PACKET_PADDING_BUF_SIZE, tp->ShortPacketEmptyBuffer,
+                                            tp->ShortPacketEmptyBufferPhy);
+                        tp->ShortPacketEmptyBuffer = NULL;
+                }
+        }
+
+        return 0;
+}
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,11)
+static void rtl8168_shutdown(struct pci_dev *pdev)
+{
+        struct net_device *dev = pci_get_drvdata(pdev);
+        struct rtl8168_private *tp = netdev_priv(dev);
+
+        if (tp->DASH)
+                rtl8168_driver_stop(tp);
+
+        rtl8168_set_bios_setting(dev);
+        if (s5_keep_curr_mac == 0 && tp->random_mac == 0)
+                rtl8168_rar_set(tp, tp->org_mac_addr);
+
+#ifdef ENABLE_REALWOW_SUPPORT
+        set_realwow_d3_para(dev);
+#endif
+
+#ifdef ENABLE_FIBER_SUPPORT
+        rtl8168_hw_fiber_nic_d3_para(dev);
+#endif  //ENABLE_FIBER_SUPPORT
+
+        if (s5wol == 0)
+                tp->wol_enabled = WOL_DISABLED;
+
+        rtl8168_close(dev);
+        rtl8168_disable_msi(pdev, tp);
+}
+#endif
+
+/**
+ *  rtl8168_get_stats - Get rtl8168 read/write statistics
+ *  @dev: The Ethernet Device to get statistics for
+ *
+ *  Get TX/RX statistics for rtl8168
+ */
+static struct
+net_device_stats *rtl8168_get_stats(struct net_device *dev)
+{
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+        struct rtl8168_private *tp = netdev_priv(dev);
+#endif
+        if (netif_running(dev)) {
+//      spin_lock_irqsave(&tp->lock, flags);
+//      spin_unlock_irqrestore(&tp->lock, flags);
+        }
+
+        return &RTLDEV->stats;
+}
+
+#ifdef CONFIG_PM
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,11)
+static int
+rtl8168_suspend(struct pci_dev *pdev, u32 state)
+#else
+static int
+rtl8168_suspend(struct pci_dev *pdev, pm_message_t state)
+#endif
+{
+        struct net_device *dev = pci_get_drvdata(pdev);
+        struct rtl8168_private *tp = netdev_priv(dev);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
+        u32 pci_pm_state = pci_choose_state(pdev, state);
+#endif
+        unsigned long flags;
+
+        if (!netif_running(dev))
+                goto out;
+
+        rtl8168_cancel_schedule_work(dev);
+
+        rtl8168_delete_esd_timer(dev, &tp->esd_timer);
+
+        rtl8168_delete_link_timer(dev, &tp->link_timer);
+
+        netif_stop_queue(dev);
+
+        netif_carrier_off(dev);
+
+        rtl8168_dsm(dev, DSM_NIC_GOTO_D3);
+
+        netif_device_detach(dev);
+
+        spin_lock_irqsave(&tp->lock, flags);
+
+        rtl8168_hw_reset(dev);
+
+        rtl8168_sleep_rx_enable(dev);
+
+        rtl8168_hw_d3_para(dev);
+
+#ifdef ENABLE_REALWOW_SUPPORT
+        set_realwow_d3_para(dev);
+#endif
+
+#ifdef ENABLE_FIBER_SUPPORT
+        rtl8168_hw_fiber_nic_d3_para(dev);
+#endif  //ENABLE_FIBER_SUPPORT
+
+        rtl8168_powerdown_pll(dev);
+
+        spin_unlock_irqrestore(&tp->lock, flags);
+
+        if (tp->DASH)
+                rtl8168_driver_stop(tp);
+out:
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
+        pci_save_state(pdev, &pci_pm_state);
+#else
+        pci_save_state(pdev);
+#endif
+        pci_enable_wake(pdev, pci_choose_state(pdev, state), tp->wol_enabled);
+//  pci_set_power_state(pdev, pci_choose_state(pdev, state));
+
+        return 0;
+}
+
+static int
+rtl8168_resume(struct pci_dev *pdev)
+{
+        struct net_device *dev = pci_get_drvdata(pdev);
+        struct rtl8168_private *tp = netdev_priv(dev);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
+        u32 pci_pm_state = PCI_D0;
+#endif
+
+        pci_set_power_state(pdev, PCI_D0);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
+        pci_restore_state(pdev, &pci_pm_state);
+#else
+        pci_restore_state(pdev);
+#endif
+        pci_enable_wake(pdev, PCI_D0, 0);
+
+        /* restore last modified mac address */
+        rtl8168_rar_set(tp, dev->dev_addr);
+
+        if (!netif_running(dev))
+                goto out;
+
+        rtl8168_exit_oob(dev);
+
+        rtl8168_dsm(dev, DSM_NIC_RESUME_D3);
+
+        rtl8168_hw_init(dev);
+
+        rtl8168_powerup_pll(dev);
+
+        rtl8168_hw_ephy_config(dev);
+
+        rtl8168_hw_phy_config(dev);
+
+        rtl8168_schedule_work(dev, rtl8168_reset_task);
+
+        netif_device_attach(dev);
+
+        mod_timer(&tp->esd_timer, jiffies + RTL8168_ESD_TIMEOUT);
+        mod_timer(&tp->link_timer, jiffies + RTL8168_LINK_TIMEOUT);
+out:
+        return 0;
+}
+
+#endif /* CONFIG_PM */
+
+static struct pci_driver rtl8168_pci_driver = {
+        .name       = MODULENAME,
+        .id_table   = rtl8168_pci_tbl,
+        .probe      = rtl8168_init_one,
+        .remove     = __devexit_p(rtl8168_remove_one),
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,11)
+        .shutdown   = rtl8168_shutdown,
+#endif
+#ifdef CONFIG_PM
+        .suspend    = rtl8168_suspend,
+        .resume     = rtl8168_resume,
+#endif
+};
+
+static int __init
+rtl8168_init_module(void)
+{
+#ifdef ENABLE_R8168_PROCFS
+        rtl8168_proc_module_init();
+#endif
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+        return pci_register_driver(&rtl8168_pci_driver);
+#else
+        return pci_module_init(&rtl8168_pci_driver);
+#endif
+}
+
+static void __exit
+rtl8168_cleanup_module(void)
+{
+        pci_unregister_driver(&rtl8168_pci_driver);
+#ifdef ENABLE_R8168_PROCFS
+        if (rtl8168_proc) {
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+                remove_proc_subtree(MODULENAME, init_net.proc_net);
+#else
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,32)
+                remove_proc_entry(MODULENAME, init_net.proc_net);
+#else
+                remove_proc_entry(MODULENAME, proc_net);
+#endif  //LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,32)
+#endif  //LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+                rtl8168_proc = NULL;
+        }
+#endif
+}
+
+module_init(rtl8168_init_module);
+module_exit(rtl8168_cleanup_module);
diff --git a/drivers/net/ethernet/realtek/r8168/r8168_realwow.h b/drivers/net/ethernet/realtek/r8168/r8168_realwow.h
new file mode 100644
index 00000000..8d55c80
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/r8168_realwow.h
@@ -0,0 +1,117 @@
+/*
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#ifndef _LINUX_R8168_REALWOW_H
+#define _LINUX_R8168_REALWOW_H
+
+#define SIOCDEVPRIVATE_RTLREALWOW   SIOCDEVPRIVATE+3
+
+#define MAX_RealWoW_KCP_SIZE (100)
+#define MAX_RealWoW_Payload (64)
+
+#define KA_TX_PACKET_SIZE (100)
+#define KA_WAKEUP_PATTERN_SIZE (120)
+
+//HwSuppKeepAliveOffloadVer
+#define HW_SUPPORT_KCP_OFFLOAD(_M)        ((_M)->HwSuppKCPOffloadVer > 0)
+
+enum rtl_realwow_cmd {
+
+        RTL_REALWOW_SET_KCP_DISABLE=0,
+        RTL_REALWOW_SET_KCP_INFO,
+        RTL_REALWOW_SET_KCP_CONTENT,
+
+        RTL_REALWOW_SET_KCP_ACKPKTINFO,
+        RTL_REALWOW_SET_KCP_WPINFO,
+        RTL_REALWOW_SET_KCPDHCP_TIMEOUT,
+
+        RTLT_REALWOW_COMMAND_INVALID
+};
+
+struct rtl_realwow_ioctl_struct {
+        __u32	cmd;
+        __u32	offset;
+        __u32	len;
+        union {
+                __u32	data;
+                void *data_buffer;
+        };
+};
+
+typedef struct _MP_KCPInfo {
+        u8 DIPv4[4];
+        u8 MacID[6];
+        u16 UdpPort[2];
+        u8 PKTLEN[2];
+
+        u16 ackLostCnt;
+        u8 KCP_WakePattern[MAX_RealWoW_Payload];
+        u8 KCP_AckPacket[MAX_RealWoW_Payload];
+        u32 KCP_interval;
+        u8 KCP_WakePattern_Len;
+        u8 KCP_AckPacket_Len;
+        u8 KCP_TxPacket[2][KA_TX_PACKET_SIZE];
+} MP_KCP_INFO, *PMP_KCP_INFO;
+
+typedef struct _KCPInfo {
+        u32 nId; // = id
+        u8 DIPv4[4];
+        u8 MacID[6];
+        u16 UdpPort;
+        u16 PKTLEN;
+} KCPInfo, *PKCPInfo;
+
+typedef struct _KCPContent {
+        u32 id; // = id
+        u32 mSec; // = msec
+        u32 size; // =size
+        u8 bPacket[MAX_RealWoW_KCP_SIZE]; // put packet here
+} KCPContent, *PKCPContent;
+
+typedef struct _RealWoWAckPktInfo {
+        u16 ackLostCnt;
+        u16 patterntSize;
+        u8 pattern[MAX_RealWoW_Payload];
+} RealWoWAckPktInfo,*PRealWoWAckPktInfo;
+
+typedef struct _RealWoWWPInfo {
+        u16 patterntSize;
+        u8 pattern[MAX_RealWoW_Payload];
+} RealWoWWPInfo,*PRealWoWWPInfo;
+
+int rtl8168_realwow_ioctl(struct net_device *dev, struct ifreq *ifr);
+void realwow_hw_init(struct net_device *dev);
+void get_realwow_hw_version(struct net_device *dev);
+void set_realwow_d3_para(struct net_device *dev);
+
+#endif /* _LINUX_R8168_REALWOW_H */
diff --git a/drivers/net/ethernet/realtek/r8168/rtl_eeprom.c b/drivers/net/ethernet/realtek/r8168/rtl_eeprom.c
new file mode 100644
index 00000000..800aaf6
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/rtl_eeprom.c
@@ -0,0 +1,291 @@
+/*
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/version.h>
+#include <linux/ethtool.h>
+#include <linux/netdevice.h>
+#include <linux/delay.h>
+
+#include <asm/io.h>
+
+#include "r8168.h"
+#include "rtl_eeprom.h"
+
+//-------------------------------------------------------------------
+//rtl_eeprom_type():
+//  tell the eeprom type
+//return value:
+//  0: the eeprom type is 93C46
+//  1: the eeprom type is 93C56 or 93C66
+//-------------------------------------------------------------------
+void rtl_eeprom_type(struct rtl8168_private *tp)
+{
+        void __iomem *ioaddr=tp->mmio_addr;
+        u16 magic = 0;
+
+        if (tp->mcfg == CFG_METHOD_DEFAULT)
+                goto out_no_eeprom;
+
+        if(RTL_R8(0xD2)&0x04) {
+                //not support
+                //tp->eeprom_type = EEPROM_TWSI;
+                //tp->eeprom_len = 256;
+                goto out_no_eeprom;
+        } else if(RTL_R32(RxConfig) & RxCfg_9356SEL) {
+                tp->eeprom_type = EEPROM_TYPE_93C56;
+                tp->eeprom_len = 256;
+        } else {
+                tp->eeprom_type = EEPROM_TYPE_93C46;
+                tp->eeprom_len = 128;
+        }
+
+        magic = rtl_eeprom_read_sc(tp, 0);
+
+out_no_eeprom:
+        if ((magic != 0x8129) && (magic != 0x8128)) {
+                tp->eeprom_type = EEPROM_TYPE_NONE;
+                tp->eeprom_len = 0;
+        }
+}
+
+void rtl_eeprom_cleanup(void __iomem *ioaddr)
+{
+        u8 x;
+
+        x = RTL_R8(Cfg9346);
+        x &= ~(Cfg9346_EEDI | Cfg9346_EECS);
+
+        RTL_W8(Cfg9346, x);
+
+        rtl_raise_clock(&x, ioaddr);
+        rtl_lower_clock(&x, ioaddr);
+}
+
+int rtl_eeprom_cmd_done(void __iomem *ioaddr)
+{
+        u8 x;
+        int i;
+
+        rtl_stand_by(ioaddr);
+
+        for (i = 0; i < 50000; i++) {
+                x = RTL_R8(Cfg9346);
+
+                if (x & Cfg9346_EEDO) {
+                        udelay(RTL_CLOCK_RATE * 2 * 3);
+                        return 0;
+                }
+                udelay(1);
+        }
+
+        return -1;
+}
+
+//-------------------------------------------------------------------
+//rtl_eeprom_read_sc():
+//  read one word from eeprom
+//-------------------------------------------------------------------
+u16 rtl_eeprom_read_sc(struct rtl8168_private *tp, u16 reg)
+{
+        void __iomem *ioaddr=tp->mmio_addr;
+        int addr_sz = 6;
+        u8 x;
+        u16 data;
+
+        if(tp->eeprom_type == EEPROM_TYPE_NONE) {
+                return -1;
+        }
+
+        if (tp->eeprom_type==EEPROM_TYPE_93C46)
+                addr_sz = 6;
+        else if (tp->eeprom_type==EEPROM_TYPE_93C56)
+                addr_sz = 8;
+
+        x = Cfg9346_EEM1 | Cfg9346_EECS;
+        RTL_W8(Cfg9346, x);
+
+        rtl_shift_out_bits(RTL_EEPROM_READ_OPCODE, 3, ioaddr);
+        rtl_shift_out_bits(reg, addr_sz, ioaddr);
+
+        data = rtl_shift_in_bits(ioaddr);
+
+        rtl_eeprom_cleanup(ioaddr);
+
+        RTL_W8(Cfg9346, 0);
+
+        return data;
+}
+
+//-------------------------------------------------------------------
+//rtl_eeprom_write_sc():
+//  write one word to a specific address in the eeprom
+//-------------------------------------------------------------------
+void rtl_eeprom_write_sc(struct rtl8168_private *tp, u16 reg, u16 data)
+{
+        void __iomem *ioaddr=tp->mmio_addr;
+        u8 x;
+        int addr_sz = 6;
+        int w_dummy_addr = 4;
+
+        if(tp->eeprom_type == EEPROM_TYPE_NONE) {
+                return ;
+        }
+
+        if (tp->eeprom_type==EEPROM_TYPE_93C46) {
+                addr_sz = 6;
+                w_dummy_addr = 4;
+        } else if (tp->eeprom_type==EEPROM_TYPE_93C56) {
+                addr_sz = 8;
+                w_dummy_addr = 6;
+        }
+
+        x = Cfg9346_EEM1 | Cfg9346_EECS;
+        RTL_W8(Cfg9346, x);
+
+        rtl_shift_out_bits(RTL_EEPROM_EWEN_OPCODE, 5, ioaddr);
+        rtl_shift_out_bits(reg, w_dummy_addr, ioaddr);
+        rtl_stand_by(ioaddr);
+
+        rtl_shift_out_bits(RTL_EEPROM_ERASE_OPCODE, 3, ioaddr);
+        rtl_shift_out_bits(reg, addr_sz, ioaddr);
+        if (rtl_eeprom_cmd_done(ioaddr) < 0) {
+                return;
+        }
+        rtl_stand_by(ioaddr);
+
+        rtl_shift_out_bits(RTL_EEPROM_WRITE_OPCODE, 3, ioaddr);
+        rtl_shift_out_bits(reg, addr_sz, ioaddr);
+        rtl_shift_out_bits(data, 16, ioaddr);
+        if (rtl_eeprom_cmd_done(ioaddr) < 0) {
+                return;
+        }
+        rtl_stand_by(ioaddr);
+
+        rtl_shift_out_bits(RTL_EEPROM_EWDS_OPCODE, 5, ioaddr);
+        rtl_shift_out_bits(reg, w_dummy_addr, ioaddr);
+
+        rtl_eeprom_cleanup(ioaddr);
+        RTL_W8(Cfg9346, 0);
+}
+
+void rtl_raise_clock(u8 *x, void __iomem *ioaddr)
+{
+        *x = *x | Cfg9346_EESK;
+        RTL_W8(Cfg9346, *x);
+        udelay(RTL_CLOCK_RATE);
+}
+
+void rtl_lower_clock(u8 *x, void __iomem *ioaddr)
+{
+
+        *x = *x & ~Cfg9346_EESK;
+        RTL_W8(Cfg9346, *x);
+        udelay(RTL_CLOCK_RATE);
+}
+
+void rtl_shift_out_bits(int data, int count, void __iomem *ioaddr)
+{
+        u8 x;
+        int  mask;
+
+        mask = 0x01 << (count - 1);
+        x = RTL_R8(Cfg9346);
+        x &= ~(Cfg9346_EEDI | Cfg9346_EEDO);
+
+        do {
+                if (data & mask)
+                        x |= Cfg9346_EEDI;
+                else
+                        x &= ~Cfg9346_EEDI;
+
+                RTL_W8(Cfg9346, x);
+                udelay(RTL_CLOCK_RATE);
+                rtl_raise_clock(&x, ioaddr);
+                rtl_lower_clock(&x, ioaddr);
+                mask = mask >> 1;
+        } while(mask);
+
+        x &= ~Cfg9346_EEDI;
+        RTL_W8(Cfg9346, x);
+}
+
+u16 rtl_shift_in_bits(void __iomem *ioaddr)
+{
+        u8 x;
+        u16 d, i;
+
+        x = RTL_R8(Cfg9346);
+        x &= ~(Cfg9346_EEDI | Cfg9346_EEDO);
+
+        d = 0;
+
+        for (i = 0; i < 16; i++) {
+                d = d << 1;
+                rtl_raise_clock(&x, ioaddr);
+
+                x = RTL_R8(Cfg9346);
+                x &= ~Cfg9346_EEDI;
+
+                if (x & Cfg9346_EEDO)
+                        d |= 1;
+
+                rtl_lower_clock(&x, ioaddr);
+        }
+
+        return d;
+}
+
+void rtl_stand_by(void __iomem *ioaddr)
+{
+        u8 x;
+
+        x = RTL_R8(Cfg9346);
+        x &= ~(Cfg9346_EECS | Cfg9346_EESK);
+        RTL_W8(Cfg9346, x);
+        udelay(RTL_CLOCK_RATE);
+
+        x |= Cfg9346_EECS;
+        RTL_W8(Cfg9346, x);
+}
+
+void rtl_set_eeprom_sel_low(void __iomem *ioaddr)
+{
+        RTL_W8(Cfg9346, Cfg9346_EEM1);
+        RTL_W8(Cfg9346, Cfg9346_EEM1 | Cfg9346_EESK);
+
+        udelay(20);
+
+        RTL_W8(Cfg9346, Cfg9346_EEM1);
+}
diff --git a/drivers/net/ethernet/realtek/r8168/rtl_eeprom.h b/drivers/net/ethernet/realtek/r8168/rtl_eeprom.h
new file mode 100644
index 00000000..452a43b
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/rtl_eeprom.h
@@ -0,0 +1,55 @@
+/*
+################################################################################
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the Free
+# Software Foundation; either version 2 of the License, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, see <http://www.gnu.org/licenses/>.
+#
+# Author:
+# Realtek NIC software team <nicfae@realtek.com>
+# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
+#
+################################################################################
+*/
+
+/************************************************************************************
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ ***********************************************************************************/
+
+//EEPROM opcodes
+#define RTL_EEPROM_READ_OPCODE      06
+#define RTL_EEPROM_WRITE_OPCODE     05
+#define RTL_EEPROM_ERASE_OPCODE     07
+#define RTL_EEPROM_EWEN_OPCODE      19
+#define RTL_EEPROM_EWDS_OPCODE      16
+
+#define RTL_CLOCK_RATE  3
+
+void rtl_eeprom_type(struct rtl8168_private *tp);
+void rtl_eeprom_cleanup(void __iomem *ioaddr);
+u16 rtl_eeprom_read_sc(struct rtl8168_private *tp, u16 reg);
+void rtl_eeprom_write_sc(struct rtl8168_private *tp, u16 reg, u16 data);
+void rtl_shift_out_bits(int data, int count, void __iomem *ioaddr);
+u16 rtl_shift_in_bits(void __iomem *ioaddr);
+void rtl_raise_clock(u8 *x, void __iomem *ioaddr);
+void rtl_lower_clock(u8 *x, void __iomem *ioaddr);
+void rtl_stand_by(void __iomem *ioaddr);
+void rtl_set_eeprom_sel_low(void __iomem *ioaddr);
+
+
+
diff --git a/drivers/net/ethernet/realtek/r8168/rtltool.c b/drivers/net/ethernet/realtek/r8168/rtltool.c
new file mode 100644
index 00000000..16c8d15
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/rtltool.c
@@ -0,0 +1,305 @@
+#include <linux/module.h>
+#include <linux/version.h>
+#include <linux/pci.h>
+#include <linux/netdevice.h>
+#include <linux/delay.h>
+#include <linux/in.h>
+#include <linux/ethtool.h>
+#include <asm/uaccess.h>
+#include "r8168.h"
+#include "rtl_eeprom.h"
+#include "rtltool.h"
+
+int rtltool_ioctl(struct rtl8168_private *tp, struct ifreq *ifr)
+{
+        struct rtltool_cmd my_cmd;
+        unsigned long flags, flags2;
+        int ret;
+
+        if (copy_from_user(&my_cmd, ifr->ifr_data, sizeof(my_cmd)))
+                return -EFAULT;
+
+        ret = 0;
+        switch (my_cmd.cmd) {
+        case RTLTOOL_READ_MAC:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.len==1)
+                        my_cmd.data = readb(tp->mmio_addr+my_cmd.offset);
+                else if (my_cmd.len==2)
+                        my_cmd.data = readw(tp->mmio_addr+(my_cmd.offset&~1));
+                else if (my_cmd.len==4)
+                        my_cmd.data = readl(tp->mmio_addr+(my_cmd.offset&~3));
+                else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+                break;
+
+        case RTLTOOL_WRITE_MAC:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.len==1)
+                        writeb(my_cmd.data, tp->mmio_addr+my_cmd.offset);
+                else if (my_cmd.len==2)
+                        writew(my_cmd.data, tp->mmio_addr+(my_cmd.offset&~1));
+                else if (my_cmd.len==4)
+                        writel(my_cmd.data, tp->mmio_addr+(my_cmd.offset&~3));
+                else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_READ_PHY:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                my_cmd.data = mdio_read(tp, my_cmd.offset);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_WRITE_PHY:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mdio_prot_write(tp, my_cmd.offset, my_cmd.data);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        case RTLTOOL_READ_EPHY:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                my_cmd.data = rtl8168_ephy_read(tp->mmio_addr, my_cmd.offset);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_WRITE_EPHY:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                rtl8168_ephy_write(tp->mmio_addr, my_cmd.offset, my_cmd.data);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        case RTLTOOL_READ_ERI:
+                my_cmd.data = 0;
+                if (my_cmd.len==1 || my_cmd.len==2 || my_cmd.len==4) {
+                        spin_lock_irqsave(&tp->phy_lock, flags);
+                        my_cmd.data = rtl8168_eri_read(tp->mmio_addr, my_cmd.offset, my_cmd.len, ERIAR_ExGMAC);
+                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                } else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_WRITE_ERI:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.len==1 || my_cmd.len==2 || my_cmd.len==4) {
+                        spin_lock_irqsave(&tp->phy_lock, flags);
+                        rtl8168_eri_write(tp->mmio_addr, my_cmd.offset, my_cmd.len, my_cmd.data, ERIAR_ExGMAC);
+                        spin_unlock_irqrestore(&tp->phy_lock, flags);
+                } else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+                break;
+
+        case RTLTOOL_READ_PCI:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                my_cmd.data = 0;
+                if (my_cmd.len==1)
+                        pci_read_config_byte(tp->pci_dev, my_cmd.offset,
+                                             (u8 *)&my_cmd.data);
+                else if (my_cmd.len==2)
+                        pci_read_config_word(tp->pci_dev, my_cmd.offset,
+                                             (u16 *)&my_cmd.data);
+                else if (my_cmd.len==4)
+                        pci_read_config_dword(tp->pci_dev, my_cmd.offset,
+                                              &my_cmd.data);
+                else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+                break;
+
+        case RTLTOOL_WRITE_PCI:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.len==1)
+                        pci_write_config_byte(tp->pci_dev, my_cmd.offset,
+                                              my_cmd.data);
+                else if (my_cmd.len==2)
+                        pci_write_config_word(tp->pci_dev, my_cmd.offset,
+                                              my_cmd.data);
+                else if (my_cmd.len==4)
+                        pci_write_config_dword(tp->pci_dev, my_cmd.offset,
+                                               my_cmd.data);
+                else {
+                        ret = -EOPNOTSUPP;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_READ_EEPROM:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                my_cmd.data = rtl_eeprom_read_sc(tp, my_cmd.offset);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+
+                break;
+
+        case RTLTOOL_WRITE_EEPROM:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                rtl_eeprom_write_sc(tp, my_cmd.offset, my_cmd.data);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        case RTL_READ_OOB_MAC:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                OOB_mutex_lock(tp);
+                my_cmd.data = OCP_read(tp, my_cmd.offset, 4);
+                OOB_mutex_unlock(tp);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+                break;
+
+        case RTL_WRITE_OOB_MAC:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.len == 0 || my_cmd.len > 4)
+                        return -EOPNOTSUPP;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                OOB_mutex_lock(tp);
+                OCP_write(tp, my_cmd.offset, my_cmd.len, my_cmd.data);
+                OOB_mutex_unlock(tp);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        case RTL_ENABLE_PCI_DIAG:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                spin_lock_irqsave(&tp->phy_lock, flags2);
+                tp->rtk_enable_diag = 1;
+                spin_unlock_irqrestore(&tp->phy_lock, flags2);
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                dprintk("enable rtk diag\n");
+                break;
+
+        case RTL_DISABLE_PCI_DIAG:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                spin_lock_irqsave(&tp->lock, flags);
+                spin_lock_irqsave(&tp->phy_lock, flags2);
+                tp->rtk_enable_diag = 0;
+                spin_unlock_irqrestore(&tp->phy_lock, flags2);
+                spin_unlock_irqrestore(&tp->lock, flags);
+
+                dprintk("disable rtk diag\n");
+                break;
+
+        case RTL_READ_MAC_OCP:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if (my_cmd.offset % 2)
+                        return -EOPNOTSUPP;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                my_cmd.data = mac_ocp_read(tp, my_cmd.offset);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+
+                if (copy_to_user(ifr->ifr_data, &my_cmd, sizeof(my_cmd))) {
+                        ret = -EFAULT;
+                        break;
+                }
+                break;
+
+        case RTL_WRITE_MAC_OCP:
+                if (!capable(CAP_NET_ADMIN))
+                        return -EPERM;
+
+                if ((my_cmd.offset % 2) || (my_cmd.len != 2))
+                        return -EOPNOTSUPP;
+
+                spin_lock_irqsave(&tp->phy_lock, flags);
+                mac_ocp_write(tp, my_cmd.offset, (u16)my_cmd.data);
+                spin_unlock_irqrestore(&tp->phy_lock, flags);
+                break;
+
+        default:
+                ret = -EOPNOTSUPP;
+                break;
+        }
+
+        return ret;
+}
diff --git a/drivers/net/ethernet/realtek/r8168/rtltool.h b/drivers/net/ethernet/realtek/r8168/rtltool.h
new file mode 100644
index 00000000..4cbe128
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8168/rtltool.h
@@ -0,0 +1,49 @@
+#ifndef _LINUX_RTLTOOL_H
+#define _LINUX_RTLTOOL_H
+
+#define SIOCRTLTOOL		SIOCDEVPRIVATE+1
+
+enum rtl_cmd {
+        RTLTOOL_READ_MAC=0,
+        RTLTOOL_WRITE_MAC,
+        RTLTOOL_READ_PHY,
+        RTLTOOL_WRITE_PHY,
+        RTLTOOL_READ_EPHY,
+        RTLTOOL_WRITE_EPHY,
+        RTLTOOL_READ_ERI,
+        RTLTOOL_WRITE_ERI,
+        RTLTOOL_READ_PCI,
+        RTLTOOL_WRITE_PCI,
+        RTLTOOL_READ_EEPROM,
+        RTLTOOL_WRITE_EEPROM,
+
+        RTL_READ_OOB_MAC,
+        RTL_WRITE_OOB_MAC,
+
+        RTL_ENABLE_PCI_DIAG,
+        RTL_DISABLE_PCI_DIAG,
+
+        RTL_READ_MAC_OCP,
+        RTL_WRITE_MAC_OCP,
+
+        RTLTOOL_INVALID
+};
+
+struct rtltool_cmd {
+        __u32	cmd;
+        __u32	offset;
+        __u32	len;
+        __u32	data;
+};
+
+enum mode_access {
+        MODE_NONE=0,
+        MODE_READ,
+        MODE_WRITE
+};
+
+#ifdef __KERNEL__
+int rtltool_ioctl(struct rtl8168_private *tp, struct ifreq *ifr);
+#endif
+
+#endif /* _LINUX_RTLTOOL_H */
diff --git a/drivers/net/ethernet/realtek/r8169soc.c b/drivers/net/ethernet/realtek/r8169soc.c
new file mode 100644
index 00000000..67a702b
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8169soc.c
@@ -0,0 +1,12102 @@
+/*
+ * r8169.c: RealTek 8169/8168/8101 ethernet driver.
+ *
+ * Copyright (c) 2002 ShuChen <shuchen@realtek.com.tw>
+ * Copyright (c) 2003 - 2007 Francois Romieu <romieu@fr.zoreil.com>
+ * Copyright (c) a lot of people too. Please respect their work.
+ *
+ * See MAINTAINERS file for support contact information.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/proc_fs.h>
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/delay.h>
+#include <linux/ethtool.h>
+#include <linux/mii.h>
+#include <linux/if_vlan.h>
+#include <linux/crc32.h>
+#include <linux/in.h>
+#include <linux/ip.h>
+#include <linux/tcp.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/dma-mapping.h>
+#include <linux/pm_runtime.h>
+#include <linux/firmware.h>
+#include <linux/platform_device.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_net.h>
+#include <linux/of_address.h>
+//#include <mach/cpu.h>
+
+#include <asm/io.h>
+#include <asm/irq.h>
+
+/* Yukuen: Use kthread to watch link status change. 20150206 */
+#include <linux/kthread.h>
+#include <linux/suspend.h>
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+#include <linux/reset.h>
+
+#include <soc/realtek/rtk_chip.h>
+#include <soc/realtek/rtk_chip.h>
+
+#include <linux/atomic.h>
+
+#if defined(CONFIG_ARCH_RTD139x)
+#include <linux/pinctrl/consumer.h>
+#define R_K_DEFAULT		0x8
+#define IDAC_FINE_DEFAULT	0x33
+#elif defined(CONFIG_ARCH_RTD16xx)
+#define RC_K_DEFAULT		0x8888
+#define R_K_DEFAULT		0x8888
+#define AMP_K_DEFAULT		0x7777
+#define ADC_BIAS_K_DEFAULT	0x8888
+#elif defined(CONFIG_ARCH_RTD13xx)
+#define R_K_DEFAULT		0x8
+#define IDAC_FINE_DEFAULT	0x77
+#endif /* CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx | CONFIG_ARCH_RTD13xx */
+
+#define RTL8169_VERSION "2.6.0LK-NAPI"
+#define MODULENAME "r8169"
+#define PFX MODULENAME ": "
+
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+#define RTL_TX_NO_CLOSE
+#define RTL_ADJUST_FIFO_THRESHOLD
+#endif /* CONFIG_ARCH_RTD16xx | CONFIG_ARCH_RTD13xx */
+
+//#define RTK_FPGA
+
+#define FIRMWARE_8168D_1	"rtl_nic/rtl8168d-1.fw"
+#define FIRMWARE_8168D_2	"rtl_nic/rtl8168d-2.fw"
+#define FIRMWARE_8168E_1	"rtl_nic/rtl8168e-1.fw"
+#define FIRMWARE_8168E_2	"rtl_nic/rtl8168e-2.fw"
+#define FIRMWARE_8168E_3	"rtl_nic/rtl8168e-3.fw"
+#define FIRMWARE_8168F_1	"rtl_nic/rtl8168f-1.fw"
+#define FIRMWARE_8168F_2	"rtl_nic/rtl8168f-2.fw"
+#define FIRMWARE_8105E_1	"rtl_nic/rtl8105e-1.fw"
+#define FIRMWARE_8402_1		"rtl_nic/rtl8402-1.fw"
+#define FIRMWARE_8411_1		"rtl_nic/rtl8411-1.fw"
+#define FIRMWARE_8106E_1	"rtl_nic/rtl8106e-1.fw"
+#define FIRMWARE_8106E_2	"rtl_nic/rtl8106e-2.fw"
+#define FIRMWARE_8168G_2	"rtl_nic/rtl8168g-2.fw"
+#define FIRMWARE_8168G_3	"rtl_nic/rtl8168g-3.fw"
+
+// Fix me : work aroud for 1295
+#define IOMEM(x)        ((void __force __iomem *)(x))
+#define RTK1195_REV_A		0
+#define soc_is_rtk1195()	0
+#define realtek_rev()		RTK1195_REV_A
+// Fix me : work aroud for 1295 end
+
+#define CYAN	"\033[0;36m"
+#define NONE	"\033[m"
+#ifdef RTL8169_DEBUG
+#define assert(expr) \
+	if (!(expr)) {					\
+		printk( "Assertion failed! %s,%s,%s,line=%d\n",	\
+		#expr,__FILE__,__func__,__LINE__);		\
+	}
+#define dprintk(fmt, args...) \
+	do { printk(KERN_DEBUG "\033[0;36m" PFX "\033[m" fmt, ## args); } while (0)
+#else
+#define assert(expr) do {} while (0)
+#define dprintk(fmt, args...)	do {} while (0)
+#endif /* RTL8169_DEBUG */
+
+#define R8169_MSG_DEFAULT \
+	(NETIF_MSG_DRV | NETIF_MSG_PROBE | NETIF_MSG_IFUP | NETIF_MSG_IFDOWN)
+
+#define TX_SLOTS_AVAIL(tp) \
+	(tp->dirty_tx + NUM_TX_DESC - tp->cur_tx)
+
+/* A skbuff with nr_frags needs nr_frags+1 entries in the tx queue */
+#define TX_FRAGS_READY_FOR(tp,nr_frags) \
+	(TX_SLOTS_AVAIL(tp) >= (nr_frags + 1))
+
+/* Maximum number of multicast addresses to filter (vs. Rx-all-multicast).
+   The RTL chips use a 64 element hash table based on the Ethernet CRC. */
+static const int multicast_filter_limit = 32;
+
+#define MAX_READ_REQUEST_SHIFT	12
+#define TX_DMA_BURST	4	/* Maximum PCI burst, '7' is unlimited */
+#define InterFrameGap	0x03	/* 3 means InterFrameGap = the shortest one */
+
+#define R8169_REGS_SIZE		256
+#define R8169_NAPI_WEIGHT	64
+#define NUM_TX_DESC	1024	/* Number of Tx descriptor registers */
+#define NUM_RX_DESC	1024	/* Number of Rx descriptor registers */
+#define R8169_TX_RING_BYTES	(NUM_TX_DESC * sizeof(struct TxDesc))
+#define R8169_RX_RING_BYTES	(NUM_RX_DESC * sizeof(struct RxDesc))
+
+#define RTL8169_TX_TIMEOUT	(6*HZ)
+#define RTL8169_PHY_TIMEOUT	(2*HZ)
+
+#if defined(CONFIG_RTL_RX_NO_COPY)
+#define RX_BUF_SIZE 0x05F3  /* 0x05F3 = 1522bye + 1 */
+#define RTK_RX_ALIGN        8
+#endif /* CONFIG_RTL_RX_NO_COPY */
+
+#define RTL_PROC 1
+
+/* write/read MMIO register */
+#define RTL_W8(reg, val8)	writeb ((val8), ioaddr + (reg))
+#define RTL_W16(reg, val16)	writew ((val16), ioaddr + (reg))
+#define RTL_W32(reg, val32)	writel ((val32), ioaddr + (reg))
+#define RTL_R8(reg)		readb (ioaddr + (reg))
+#define RTL_R16(reg)		readw (ioaddr + (reg))
+#define RTL_R32(reg)		readl (ioaddr + (reg))
+
+enum mac_version {
+	RTL_GIGA_MAC_VER_01 = 0,
+	RTL_GIGA_MAC_VER_02,
+	RTL_GIGA_MAC_VER_03,
+	RTL_GIGA_MAC_VER_04,
+	RTL_GIGA_MAC_VER_05,
+	RTL_GIGA_MAC_VER_06,
+	RTL_GIGA_MAC_VER_07,
+	RTL_GIGA_MAC_VER_08,
+	RTL_GIGA_MAC_VER_09,
+	RTL_GIGA_MAC_VER_10,
+	RTL_GIGA_MAC_VER_11,
+	RTL_GIGA_MAC_VER_12,
+	RTL_GIGA_MAC_VER_13,
+	RTL_GIGA_MAC_VER_14,
+	RTL_GIGA_MAC_VER_15,
+	RTL_GIGA_MAC_VER_16,
+	RTL_GIGA_MAC_VER_17,
+	RTL_GIGA_MAC_VER_18,
+	RTL_GIGA_MAC_VER_19,
+	RTL_GIGA_MAC_VER_20,
+	RTL_GIGA_MAC_VER_21,
+	RTL_GIGA_MAC_VER_22,
+	RTL_GIGA_MAC_VER_23,
+	RTL_GIGA_MAC_VER_24,
+	RTL_GIGA_MAC_VER_25,
+	RTL_GIGA_MAC_VER_26,
+	RTL_GIGA_MAC_VER_27,
+	RTL_GIGA_MAC_VER_28,
+	RTL_GIGA_MAC_VER_29,
+	RTL_GIGA_MAC_VER_30,
+	RTL_GIGA_MAC_VER_31,
+	RTL_GIGA_MAC_VER_32,
+	RTL_GIGA_MAC_VER_33,
+	RTL_GIGA_MAC_VER_34,
+	RTL_GIGA_MAC_VER_35,
+	RTL_GIGA_MAC_VER_36,
+	RTL_GIGA_MAC_VER_37,
+	RTL_GIGA_MAC_VER_38,
+	RTL_GIGA_MAC_VER_39,
+	RTL_GIGA_MAC_VER_40,
+	RTL_GIGA_MAC_VER_41,
+	RTL_GIGA_MAC_VER_42,
+	RTL_GIGA_MAC_VER_43,
+	RTL_GIGA_MAC_NONE   = 0xff,
+};
+
+enum rtl_tx_desc_version {
+	RTL_TD_0	= 0,
+	RTL_TD_1	= 1,
+};
+
+#define JUMBO_1K	ETH_DATA_LEN
+#define JUMBO_4K	(4*1024 - ETH_HLEN - 2)
+#define JUMBO_6K	(6*1024 - ETH_HLEN - 2)
+#define JUMBO_7K	(7*1024 - ETH_HLEN - 2)
+#define JUMBO_9K	(9*1024 - ETH_HLEN - 2)
+
+#define _R(NAME,TD,FW,SZ,B) {	\
+	.name = NAME,		\
+	.txd_version = TD,	\
+	.fw_name = FW,		\
+	.jumbo_max = SZ,	\
+	.jumbo_tx_csum = B	\
+}
+
+static const struct {
+	const char *name;
+	enum rtl_tx_desc_version txd_version;
+	const char *fw_name;
+	u16 jumbo_max;
+	bool jumbo_tx_csum;
+} rtl_chip_infos[] = {
+	/* PCI devices. */
+	[RTL_GIGA_MAC_VER_01] =
+		_R("RTL8169",		RTL_TD_0, NULL, JUMBO_7K, true),
+	[RTL_GIGA_MAC_VER_02] =
+		_R("RTL8169s",		RTL_TD_0, NULL, JUMBO_7K, true),
+	[RTL_GIGA_MAC_VER_03] =
+		_R("RTL8110s",		RTL_TD_0, NULL, JUMBO_7K, true),
+	[RTL_GIGA_MAC_VER_04] =
+		_R("RTL8169sb/8110sb",	RTL_TD_0, NULL, JUMBO_7K, true),
+	[RTL_GIGA_MAC_VER_05] =
+		_R("RTL8169sc/8110sc",	RTL_TD_0, NULL, JUMBO_7K, true),
+	[RTL_GIGA_MAC_VER_06] =
+		_R("RTL8169sc/8110sc",	RTL_TD_0, NULL, JUMBO_7K, true),
+	/* PCI-E devices. */
+	[RTL_GIGA_MAC_VER_07] =
+		_R("RTL8102e",		RTL_TD_1, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_08] =
+		_R("RTL8102e",		RTL_TD_1, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_09] =
+		_R("RTL8102e",		RTL_TD_1, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_10] =
+		_R("RTL8101e",		RTL_TD_0, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_11] =
+		_R("RTL8168b/8111b",	RTL_TD_0, NULL, JUMBO_4K, false),
+	[RTL_GIGA_MAC_VER_12] =
+		_R("RTL8168b/8111b",	RTL_TD_0, NULL, JUMBO_4K, false),
+	[RTL_GIGA_MAC_VER_13] =
+		_R("RTL8101e",		RTL_TD_0, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_14] =
+		_R("RTL8100e",		RTL_TD_0, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_15] =
+		_R("RTL8100e",		RTL_TD_0, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_16] =
+		_R("RTL8101e",		RTL_TD_0, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_17] =
+		_R("RTL8168b/8111b",	RTL_TD_1, NULL, JUMBO_4K, false),
+	[RTL_GIGA_MAC_VER_18] =
+		_R("RTL8168cp/8111cp",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_19] =
+		_R("RTL8168c/8111c",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_20] =
+		_R("RTL8168c/8111c",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_21] =
+		_R("RTL8168c/8111c",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_22] =
+		_R("RTL8168c/8111c",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_23] =
+		_R("RTL8168cp/8111cp",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_24] =
+		_R("RTL8168cp/8111cp",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_25] =
+		_R("RTL8168d/8111d",	RTL_TD_1, FIRMWARE_8168D_1,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_26] =
+		_R("RTL8168d/8111d",	RTL_TD_1, FIRMWARE_8168D_2,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_27] =
+		_R("RTL8168dp/8111dp",	RTL_TD_1, NULL, JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_28] =
+		_R("RTL8168dp/8111dp",	RTL_TD_1, NULL, JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_29] =
+		_R("RTL8105e",		RTL_TD_1, FIRMWARE_8105E_1,
+							JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_30] =
+		_R("RTL8105e",		RTL_TD_1, FIRMWARE_8105E_1,
+							JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_31] =
+		_R("RTL8168dp/8111dp",	RTL_TD_1, NULL, JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_32] =
+		_R("RTL8168e/8111e",	RTL_TD_1, FIRMWARE_8168E_1,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_33] =
+		_R("RTL8168e/8111e",	RTL_TD_1, FIRMWARE_8168E_2,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_34] =
+		_R("RTL8168evl/8111evl",RTL_TD_1, FIRMWARE_8168E_3,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_35] =
+		_R("RTL8168f/8111f",	RTL_TD_1, FIRMWARE_8168F_1,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_36] =
+		_R("RTL8168f/8111f",	RTL_TD_1, FIRMWARE_8168F_2,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_37] =
+		_R("RTL8402",		RTL_TD_1, FIRMWARE_8402_1,
+							JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_38] =
+		_R("RTL8411",		RTL_TD_1, FIRMWARE_8411_1,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_39] =
+		_R("RTL8106e",		RTL_TD_1, FIRMWARE_8106E_1,
+							JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_40] =
+		_R("RTL8168g/8111g",	RTL_TD_1, FIRMWARE_8168G_2,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_41] =
+		_R("RTL8168g/8111g",	RTL_TD_1, NULL, JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_42] =
+	//	_R("RTL8168g/8111g",	RTL_TD_1, FIRMWARE_8168G_3,
+		_R("RTL8168g/8111g",	RTL_TD_1, NULL,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_43] =
+		_R("RTL8106e",		RTL_TD_1, FIRMWARE_8106E_2,
+							JUMBO_1K, true),
+};
+#undef _R
+
+enum cfg_version {
+	RTL_CFG_0 = 0x00,
+	RTL_CFG_1,
+	RTL_CFG_2
+};
+
+static const struct of_device_id rtl8169_dt_ids[] = {
+	{ .compatible = "Realtek,r8168", },
+	{},
+};
+
+MODULE_DEVICE_TABLE(of, rtl8169_dt_ids);
+
+#if defined(CONFIG_RTL_RX_NO_COPY)
+static int rx_buf_sz = 1523;   /* 0x05F3 = 1522bye + 1 */
+static int rx_buf_sz_new = 1523;
+#else
+static int rx_buf_sz = 16383;
+#endif /* CONFIG_RTL_RX_NO_COPY */
+
+static int use_dac;
+static struct {
+	u32 msg_enable;
+} debug = { -1 };
+
+enum rtl_registers {
+	MAC0		= 0,	/* Ethernet hardware address. */
+	MAC4		= 4,
+	MAR0		= 8,	/* Multicast filter. */
+	CounterAddrLow		= 0x10,
+	CounterAddrHigh		= 0x14,
+	LEDSEL				= 0x18,
+	TxDescStartAddrLow	= 0x20,
+	TxDescStartAddrHigh	= 0x24,
+	TxHDescStartAddrLow	= 0x28,
+	TxHDescStartAddrHigh	= 0x2c,
+	FLASH		= 0x30,
+	ERSR		= 0x36,
+	ChipCmd		= 0x37,
+	TxPoll		= 0x38,
+	IntrMask	= 0x3c,
+	IntrStatus	= 0x3e,
+
+	TxConfig	= 0x40,
+#define	TXCFG_AUTO_FIFO			(1 << 7)	/* 8111e-vl */
+#define	TXCFG_EMPTY			(1 << 11)	/* 8111e-vl */
+
+	RxConfig	= 0x44,
+#define	RX128_INT_EN			(1 << 15)	/* 8111c and later */
+#define	RX_MULTI_EN			(1 << 14)	/* 8111c only */
+#define	RXCFG_FIFO_SHIFT		13
+					/* No threshold before first PCI xfer */
+#define	RX_FIFO_THRESH			(7 << RXCFG_FIFO_SHIFT)
+#define	RX_EARLY_OFF			(1 << 11)
+#define	RXCFG_DMA_SHIFT			8
+					/* Unlimited maximum PCI burst. */
+#define	RX_DMA_BURST			(3 << RXCFG_DMA_SHIFT)	/* 128 bytes */
+
+	RxMissed	= 0x4c,
+	Cfg9346		= 0x50,
+	Config0		= 0x51,
+	Config1		= 0x52,
+	Config2		= 0x53,
+#define PME_SIGNAL			(1 << 5)	/* 8168c and later */
+
+	Config3		= 0x54,
+	Config4		= 0x55,
+	Config5		= 0x56,
+	MultiIntr	= 0x5c,
+	PHYAR		= 0x60,
+	PHYstatus	= 0x6c,
+	RxMaxSize	= 0xda,
+	CPlusCmd	= 0xe0,
+	IntrMitigate	= 0xe2,
+	RxDescAddrLow	= 0xe4,
+	RxDescAddrHigh	= 0xe8,
+	EarlyTxThres	= 0xec,	/* 8169. Unit of 32 bytes. */
+
+#define NoEarlyTx	0x3f	/* Max value : no early transmit. */
+
+	MaxTxPacketSize	= 0xec,	/* 8101/8168. Unit of 128 bytes. */
+
+#define TxPacketMax	(8064 >> 7)
+#define EarlySize	0x27
+
+	FuncEvent	= 0xf0,
+	FuncEventMask	= 0xf4,
+	FuncPresetState	= 0xf8,
+	FuncForceEvent	= 0xfc,
+};
+
+enum rtl8110_registers {
+	TBICSR			= 0x64,
+	TBI_ANAR		= 0x68,
+	TBI_LPAR		= 0x6a,
+};
+
+enum rtl8168_8101_registers {
+	CSIDR			= 0x64,
+	CSIAR			= 0x68,
+#define	CSIAR_FLAG			0x80000000
+#define	CSIAR_WRITE_CMD			0x80000000
+#define	CSIAR_BYTE_ENABLE		0x0f
+#define	CSIAR_BYTE_ENABLE_SHIFT		12
+#define	CSIAR_ADDR_MASK			0x0fff
+#define CSIAR_FUNC_CARD			0x00000000
+#define CSIAR_FUNC_SDIO			0x00010000
+#define CSIAR_FUNC_NIC			0x00020000
+	PMCH			= 0x6f,
+	EPHYAR			= 0x80,
+#define	EPHYAR_FLAG			0x80000000
+#define	EPHYAR_WRITE_CMD		0x80000000
+#define	EPHYAR_REG_MASK			0x1f
+#define	EPHYAR_REG_SHIFT		16
+#define	EPHYAR_DATA_MASK		0xffff
+	DLLPR			= 0xd0,
+#define	PFM_EN				(1 << 6)
+	DBG_REG			= 0xd1,
+#define	FIX_NAK_1			(1 << 4)
+#define	FIX_NAK_2			(1 << 3)
+	TWSI			= 0xd2,
+	MCU			= 0xd3,
+#define	NOW_IS_OOB			(1 << 7)
+#define	TX_EMPTY			(1 << 5)
+#define	RX_EMPTY			(1 << 4)
+#define	RXTX_EMPTY			(TX_EMPTY | RX_EMPTY)
+#define	EN_NDP				(1 << 3)
+#define	EN_OOB_RESET			(1 << 2)
+#define	LINK_LIST_RDY			(1 << 1)
+#define	DIS_MCU_CLROOB			(1 << 0)
+	EFUSEAR			= 0xdc,
+#define	EFUSEAR_FLAG			0x80000000
+#define	EFUSEAR_WRITE_CMD		0x80000000
+#define	EFUSEAR_READ_CMD		0x00000000
+#define	EFUSEAR_REG_MASK		0x03ff
+#define	EFUSEAR_REG_SHIFT		8
+#define	EFUSEAR_DATA_MASK		0xff
+};
+
+enum rtl8168_registers {
+	LED_FREQ		= 0x1a,
+	EEE_LED			= 0x1b,
+	ERIDR			= 0x70,
+	ERIAR			= 0x74,
+#define ERIAR_FLAG			0x80000000
+#define ERIAR_WRITE_CMD			0x80000000
+#define ERIAR_READ_CMD			0x00000000
+#define ERIAR_ADDR_BYTE_ALIGN		4
+#define ERIAR_TYPE_SHIFT		16
+#define ERIAR_EXGMAC			(0x00 << ERIAR_TYPE_SHIFT)
+#define ERIAR_MSIX			(0x01 << ERIAR_TYPE_SHIFT)
+#define ERIAR_ASF			(0x02 << ERIAR_TYPE_SHIFT)
+#define ERIAR_MASK_SHIFT		12
+#define ERIAR_MASK_0001			(0x1 << ERIAR_MASK_SHIFT)
+#define ERIAR_MASK_0010			(0x2 << ERIAR_MASK_SHIFT)
+#define ERIAR_MASK_0011			(0x3 << ERIAR_MASK_SHIFT)
+#define ERIAR_MASK_0100			(0x4 << ERIAR_MASK_SHIFT)
+#define ERIAR_MASK_0101			(0x5 << ERIAR_MASK_SHIFT)
+#define ERIAR_MASK_1000			(0x8 << ERIAR_MASK_SHIFT)
+#define ERIAR_MASK_1100			(0xc << ERIAR_MASK_SHIFT)
+#define ERIAR_MASK_1111			(0xf << ERIAR_MASK_SHIFT)
+	EPHY_RXER_NUM		= 0x7c,
+	OCPDR			= 0xb0,	/* OCP GPHY access */
+#define OCPDR_WRITE_CMD			0x80000000
+#define OCPDR_READ_CMD			0x00000000
+#define OCPDR_REG_MASK			0x7f
+#define OCPDR_GPHY_REG_SHIFT		16
+#define OCPDR_DATA_MASK			0xffff
+	OCPAR			= 0xb4,
+#define OCPAR_FLAG			0x80000000
+#define OCPAR_GPHY_WRITE_CMD		0x8000f060
+#define OCPAR_GPHY_READ_CMD		0x0000f060
+	GPHY_OCP		= 0xb8,
+	RDSAR1			= 0xd0,	/* 8168c only. Undocumented on 8168dp */
+	MISC			= 0xf0,	/* 8168e only. */
+#define TXPLA_RST			(1 << 29)
+#define DISABLE_LAN_EN			(1 << 23) /* Enable GPIO pin */
+#define PWM_EN				(1 << 22)
+#define RXDV_GATED_EN			(1 << 19)
+#define EARLY_TALLY_EN			(1 << 16)
+};
+
+#if defined(RTL_TX_NO_CLOSE)
+enum rtl8169soc_registers {
+	TX_DESC_TAIL_IDX	= 0x20,	/* the last descriptor index */
+	TX_DESC_CLOSE_IDX	= 0x22,	/* the closed descriptor index */
+#define TX_DESC_CNT_MASK		0x3FFF
+#define TX_DESC_CNT_SIZE		0x4000
+};
+#endif /* RTL_TX_NO_CLOSE */
+
+enum rtl_register_content {
+	/* InterruptStatusBits */
+	SYSErr		= 0x8000,
+	PCSTimeout	= 0x4000,
+	SWInt		= 0x0100,
+	TxDescUnavail	= 0x0080,
+	RxFIFOOver	= 0x0040,
+	LinkChg		= 0x0020,
+	RxOverflow	= 0x0010,
+	TxErr		= 0x0008,
+	TxOK		= 0x0004,
+	RxErr		= 0x0002,
+	RxOK		= 0x0001,
+
+	/* RxStatusDesc */
+	RxBOVF	= (1 << 24),
+	RxFOVF	= (1 << 23),
+	RxRWT	= (1 << 22),
+	RxRES	= (1 << 21),
+	RxRUNT	= (1 << 20),
+	RxCRC	= (1 << 19),
+
+	/* ChipCmdBits */
+	StopReq		= 0x80,
+	CmdReset	= 0x10,
+	CmdRxEnb	= 0x08,
+	CmdTxEnb	= 0x04,
+	RxBufEmpty	= 0x01,
+
+	/* TXPoll register p.5 */
+	HPQ		= 0x80,		/* Poll cmd on the high prio queue */
+	NPQ		= 0x40,		/* Poll cmd on the low prio queue */
+	FSWInt		= 0x01,		/* Forced software interrupt */
+
+	/* Cfg9346Bits */
+	Cfg9346_Lock	= 0x00,
+	Cfg9346_Unlock	= 0xc0,
+
+	/* rx_mode_bits */
+	AcceptErr	= 0x20,
+	AcceptRunt	= 0x10,
+	AcceptBroadcast	= 0x08,
+	AcceptMulticast	= 0x04,
+	AcceptMyPhys	= 0x02,
+	AcceptAllPhys	= 0x01,
+#define RX_CONFIG_ACCEPT_MASK		0x3f
+
+	/* TxConfigBits */
+	TxInterFrameGapShift = 24,
+	TxDMAShift = 8,	/* DMA burst value (0-7) is shift this many bits */
+
+	/* Config1 register p.24 */
+	LEDS1		= (1 << 7),
+	LEDS0		= (1 << 6),
+	Speed_down	= (1 << 4),
+	MEMMAP		= (1 << 3),
+	IOMAP		= (1 << 2),
+	VPD		= (1 << 1),
+	PMEnable	= (1 << 0),	/* Power Management Enable */
+
+	/* Config2 register p. 25 */
+	ClkReqEn	= (1 << 7),	/* Clock Request Enable */
+	MSIEnable	= (1 << 5),	/* 8169 only. Reserved in the 8168. */
+	PCI_Clock_66MHz = 0x01,
+	PCI_Clock_33MHz = 0x00,
+
+	/* Config3 register p.25 */
+	MagicPacket	= (1 << 5),	/* Wake up when receives a Magic Packet */
+	LinkUp		= (1 << 4),	/* Wake up when the cable connection is re-established */
+	Jumbo_En0	= (1 << 2),	/* 8168 only. Reserved in the 8168b */
+	Beacon_en	= (1 << 0),	/* 8168 only. Reserved in the 8168b */
+
+	/* Config4 register */
+	Jumbo_En1	= (1 << 1),	/* 8168 only. Reserved in the 8168b */
+
+	/* Config5 register p.27 */
+	BWF		= (1 << 6),	/* Accept Broadcast wakeup frame */
+	MWF		= (1 << 5),	/* Accept Multicast wakeup frame */
+	UWF		= (1 << 4),	/* Accept Unicast wakeup frame */
+	Spi_en		= (1 << 3),
+	LanWake		= (1 << 1),	/* LanWake enable/disable */
+	PMEStatus	= (1 << 0),	/* PME status can be reset by PCI RST# */
+	ASPM_en		= (1 << 0),	/* ASPM enable */
+
+	/* TBICSR p.28 */
+	TBIReset	= 0x80000000,
+	TBILoopback	= 0x40000000,
+	TBINwEnable	= 0x20000000,
+	TBINwRestart	= 0x10000000,
+	TBILinkOk	= 0x02000000,
+	TBINwComplete	= 0x01000000,
+
+	/* CPlusCmd p.31 */
+	EnableBist	= (1 << 15),	// 8168 8101
+	Mac_dbgo_oe	= (1 << 14),	// 8168 8101
+	Normal_mode	= (1 << 13),	// unused
+	Force_half_dup	= (1 << 12),	// 8168 8101
+	Force_rxflow_en	= (1 << 11),	// 8168 8101
+	Force_txflow_en	= (1 << 10),	// 8168 8101
+	Cxpl_dbg_sel	= (1 << 9),	// 8168 8101
+	ASF		= (1 << 8),	// 8168 8101
+	PktCntrDisable	= (1 << 7),	// 8168 8101
+	Mac_dbgo_sel	= 0x001c,	// 8168
+	RxVlan		= (1 << 6),
+	RxChkSum	= (1 << 5),
+	PCIDAC		= (1 << 4),
+	PCIMulRW	= (1 << 3),
+	INTT_0		= 0x0000,	// 8168
+	INTT_1		= 0x0001,	// 8168
+	INTT_2		= 0x0002,	// 8168
+	INTT_3		= 0x0003,	// 8168
+
+	/* rtl8169_PHYstatus */
+	TBI_Enable	= 0x80,
+	TxFlowCtrl	= 0x40,
+	RxFlowCtrl	= 0x20,
+	_1000bpsF	= 0x10,
+	_100bps		= 0x08,
+	_10bps		= 0x04,
+	LinkStatus	= 0x02,
+	FullDup		= 0x01,
+
+	/* _TBICSRBit */
+	TBILinkOK	= 0x02000000,
+
+	/* DumpCounterCommand */
+	CounterDump	= 0x8,
+};
+
+enum rtl_desc_bit {
+	/* First doubleword. */
+	DescOwn		= (1 << 31), /* Descriptor is owned by NIC */
+	RingEnd		= (1 << 30), /* End of descriptor ring */
+	FirstFrag	= (1 << 29), /* First segment of a packet */
+	LastFrag	= (1 << 28), /* Final segment of a packet */
+};
+
+/* Generic case. */
+enum rtl_tx_desc_bit {
+	/* First doubleword. */
+	TD_LSO		= (1 << 27),		/* Large Send Offload */
+#define TD_MSS_MAX			0x07ffu	/* MSS value */
+
+	/* Second doubleword. */
+	TxVlanTag	= (1 << 17),		/* Add VLAN tag */
+};
+
+/* 8169, 8168b and 810x except 8102e. */
+enum rtl_tx_desc_bit_0 {
+	/* First doubleword. */
+#define TD0_MSS_SHIFT			16	/* MSS position (11 bits) */
+	TD0_TCP_CS	= (1 << 16),		/* Calculate TCP/IP checksum */
+	TD0_UDP_CS	= (1 << 17),		/* Calculate UDP/IP checksum */
+	TD0_IP_CS	= (1 << 18),		/* Calculate IP checksum */
+};
+
+/* 8102e, 8168c and beyond. */
+enum rtl_tx_desc_bit_1 {
+	/* Second doubleword. */
+#define TD1_MSS_SHIFT			18	/* MSS position (11 bits) */
+	TD1_IP_CS	= (1 << 29),		/* Calculate IP checksum */
+	TD1_TCP_CS	= (1 << 30),		/* Calculate TCP/IP checksum */
+	TD1_UDP_CS	= (1 << 31),		/* Calculate UDP/IP checksum */
+};
+
+static const struct rtl_tx_desc_info {
+	struct {
+		u32 udp;
+		u32 tcp;
+	} checksum;
+	u16 mss_shift;
+	u16 opts_offset;
+} tx_desc_info [] = {
+	[RTL_TD_0] = {
+		.checksum = {
+			.udp	= TD0_IP_CS | TD0_UDP_CS,
+			.tcp	= TD0_IP_CS | TD0_TCP_CS
+		},
+		.mss_shift	= TD0_MSS_SHIFT,
+		.opts_offset	= 0
+	},
+	[RTL_TD_1] = {
+		.checksum = {
+			.udp	= TD1_IP_CS | TD1_UDP_CS,
+			.tcp	= TD1_IP_CS | TD1_TCP_CS
+		},
+		.mss_shift	= TD1_MSS_SHIFT,
+		.opts_offset	= 1
+	}
+};
+
+enum rtl_rx_desc_bit {
+	/* Rx private */
+	PID1		= (1 << 18), /* Protocol ID bit 1/2 */
+	PID0		= (1 << 17), /* Protocol ID bit 2/2 */
+
+#define RxProtoUDP	(PID1)
+#define RxProtoTCP	(PID0)
+#define RxProtoIP	(PID1 | PID0)
+#define RxProtoMask	RxProtoIP
+
+	IPFail		= (1 << 16), /* IP checksum failed */
+	UDPFail		= (1 << 15), /* UDP/IP checksum failed */
+	TCPFail		= (1 << 14), /* TCP/IP checksum failed */
+	RxVlanTag	= (1 << 16), /* VLAN tag available */
+};
+
+#define RsvdMask	0x3fffc000
+
+struct TxDesc {
+	__le32 opts1;
+	__le32 opts2;
+	__le64 addr;
+};
+
+struct RxDesc {
+	__le32 opts1;
+	__le32 opts2;
+	__le64 addr;
+};
+
+struct ring_info {
+	struct sk_buff	*skb;
+	u32		len;
+	u8		__pad[sizeof(void *) - sizeof(u32)];
+};
+
+enum features {
+	RTL_FEATURE_WOL		= (1 << 0),
+	RTL_FEATURE_MSI		= (1 << 1),
+	RTL_FEATURE_GMII	= (1 << 2),
+};
+
+struct rtl8169_counters {
+	__le64	tx_packets;
+	__le64	rx_packets;
+	__le64	tx_errors;
+	__le32	rx_errors;
+	__le16	rx_missed;
+	__le16	align_errors;
+	__le32	tx_one_collision;
+	__le32	tx_multi_collision;
+	__le64	rx_unicast;
+	__le64	rx_broadcast;
+	__le32	rx_multicast;
+	__le16	tx_aborted;
+	__le16	tx_underun;
+};
+
+enum rtl_flag {
+	RTL_FLAG_TASK_ENABLED,
+	RTL_FLAG_TASK_SLOW_PENDING,
+	RTL_FLAG_TASK_RESET_PENDING,
+	RTL_FLAG_TASK_PHY_PENDING,
+	RTL_FLAG_MAX
+};
+
+struct rtl8169_stats {
+	u64			packets;
+	u64			bytes;
+	struct u64_stats_sync	syncp;
+};
+
+#define RGMII0_PAD_CTRL_ADDR	0x9801a960
+#define ISO_RGMII_MDIO_TO_GMAC	0x98007064
+
+enum rtl_output_mode {
+	OUTPUT_EMBEDDED_PHY,
+	#if defined(CONFIG_ARCH_RTD129x)
+	OUTPUT_RGMII_TO_MAC,
+	OUTPUT_RGMII_TO_PHY,
+	#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	OUTPUT_SGMII_TO_MAC,
+	OUTPUT_SGMII_TO_PHY,
+	#elif defined(CONFIG_ARCH_RTD13xx)
+	OUTPUT_RGMII_TO_MAC,
+	OUTPUT_RGMII_TO_PHY,
+	OUTPUT_RMII,
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x |
+		  CONFIG_ARCH_RTD16xx | CONFIG_ARCH_RTD13xx */
+	OUTPUT_MAX
+};
+
+/* ISO base addr 0x98007000 */
+enum iso_registers {
+	ISO_UMSK_ISR	= 0x0004,
+	ISO_POWERCUT_ETN = 0x005c,
+	ISO_ETN_TESTIO	= 0x0060,
+	ISO_SOFT_RESET = 0x0088,
+	ISO_CLOCK_ENABLE = 0x008c,
+	ISO_POR_DATAI	= 0x0218,
+	#if defined(CONFIG_ARCH_RTD13xx)
+	ISO_ETN_DBUS_CTRL = 0x0fc0,
+	#endif /* CONFIG_ARCH_RTD13xx */
+};
+
+#define POR_NUM		3
+#define POR_XV_MASK	0x00000111
+
+#if defined(CONFIG_ARCH_RTD129x)
+enum rtl_rgmii_voltage {
+	VOLTAGE_1_DOT_8V = 1,
+	VOLTAGE_2_DOT_5V,
+	VOLTAGE_3_DOT_3V,
+	VOLTAGE_MAX
+};
+
+enum rtl_rgmii_delay {
+	RGMII_DELAY_0NS,
+	RGMII_DELAY_2NS,
+	RGMII_DELAY_MAX
+};
+#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+enum phy_addr_e {
+	INT_PHY_ADDR = 1,	/* embedded PHY PHY ID */
+	SERDES_DPHY_0 = 0,	/* embedded SerDes DPHY PHY ID 0, RL6481_T28_SGMII.doc ANA00~ANA0F */
+	SERDES_DPHY_1 = 1,	/* embedded SerDes DPHY PHY ID 1, RL6481_T28_SGMII.doc ANA20~ANA2F */
+	EXT_PHY_ADDR = 3,	/* external RTL8211FS SGMII PHY ID */
+};
+
+/* SDS base addr 0x981c8000 */
+#if defined(CONFIG_ARCH_RTD139x)
+enum sds_registers {
+	SDS_REG02 	= 0x0008,
+	SDS_REG28 	= 0x0070,
+	SDS_REG29 	= 0x0074,
+	SDS_MISC	= 0x1804,
+	SDS_LINK	= 0x1810,
+};
+#elif defined(CONFIG_ARCH_RTD16xx)
+enum sds_registers {
+	SDS_REG02 	= 0x0008,
+	SDS_MISC	= 0x1804,
+	SDS_LINK	= 0x180c,
+	SDS_DEBUG	= 0x1810,
+};
+#endif
+
+/* ISO testmux base addr 0x9804e000 */
+enum testmux_registers {
+	ISO_TESTMUX_MUXPAD0 	= 0x0000,
+	ISO_TESTMUX_MUXPAD1 	= 0x0004,
+	ISO_TESTMUX_MUXPAD2 	= 0x0008,
+	#if defined(CONFIG_ARCH_RTD13xx)
+	ISO_TESTMUX_MUXPAD5	= 0x0014,
+	ISO_TESTMUX_MUXPAD6	= 0x0018,
+	ISO_TESTMUX_PFUNC9	= 0x0040, /* MDC/MDIO current */
+	ISO_TESTMUX_PFUNC20	= 0x006c, /* RGMII current */
+	ISO_TESTMUX_PFUNC21	= 0x0070, /* RGMII current */
+	ISO_TESTMUX_PFUNC25	= 0x0090, /* RGMII BIAS */
+	#endif
+};
+
+#if defined(CONFIG_ARCH_RTD16xx)
+enum sgmii_swing_e {
+	TX_Swing_550mV,
+	TX_Swing_380mV,
+	TX_Swing_250mV,
+	TX_Swing_190mV
+};
+#else
+#define SGMII_SWING		(0X3 << 8)
+#define TX_SWING_1040MV		(0X0 << 8)	/* DEFAULT */
+#define TX_SWING_693MV		(0X1 << 8)
+#define TX_SWING_474MV		(0X2 << 8)
+#define TX_SWING_352MV		(0X3 << 8)
+#define TX_SWING_312MV		(0X4 << 8)
+#endif /* CONFIG_ARCH_RTD16xx */
+
+/* SBX and SC_WRAP base addr 0x9801c000 */
+enum sbx_sc_wrap_registers {
+	SBX_SB3_CHANNEL_REQ_MASK	= 0x020c,
+	SBX_SB3_CHANNEL_REQ_BUSY	= 0x0210,
+	SBX_ACP_CHANNEL_REQ_MASK	= 0x080c,
+	SBX_ACP_CHANNEL_REQ_BUSY	= 0x0810,
+	SBX_ACP_MISC_CTRL		= 0x0814,
+	SC_WRAP_ACP_CRT_CTRL		= 0x1030,
+	SC_WRAP_CRT_CTRL		= 0x1100,
+	SC_WRAP_INTERFACE_EN		= 0x1124,
+	SC_WRAP_ACP_CTRL		= 0x1800,
+};
+#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x |
+	  CONFIG_ARCH_RTD16xx || CONFIG_ARCH_RTD13xx */
+
+#define RTL_WPD_SIZE		16
+#define RTL_WPD_MASK_SIZE	16
+
+#ifdef RTL_PROC
+static struct proc_dir_entry *rtw_proc;
+static u8 wol_enable=0;
+#endif
+
+struct rtl8169_private {
+	void __iomem *mmio_addr;	/* memory map physical address */
+	void __iomem *mmio_clkaddr;
+	struct platform_device *pdev;
+//	struct device *device;
+	struct net_device *dev;
+	struct napi_struct napi;
+	u32 msg_enable;
+	u16 txd_version;
+	u16 mac_version;
+	u32 cur_rx; /* Index into the Rx descriptor buffer of next Rx pkt. */
+	u32 cur_tx; /* Index into the Tx descriptor buffer of next Rx pkt. */
+	u32 dirty_tx;
+
+	#if defined(CONFIG_RTL_RX_NO_COPY)
+	u32 dirty_rx;
+	u32 last_dirty_tx;
+	u32 tx_reset_count;
+	u32 last_cur_rx;
+	u32 rx_reset_count;
+	u8 checkRDU;
+	#endif /* CONFIG_RTL_RX_NO_COPY */
+
+	struct rtl8169_stats rx_stats;
+	struct rtl8169_stats tx_stats;
+	struct TxDesc *TxDescArray;	/* 256-aligned Tx descriptor ring */
+	struct RxDesc *RxDescArray;	/* 256-aligned Rx descriptor ring */
+	dma_addr_t TxPhyAddr;
+	dma_addr_t RxPhyAddr;
+
+	#if defined(CONFIG_RTL_RX_NO_COPY)
+	struct sk_buff *Rx_databuff[NUM_RX_DESC]; /* Rx data buffers */
+	#else
+	void *Rx_databuff[NUM_RX_DESC];	/* Rx data buffers */
+	#endif /* CONFIG_RTL_RX_NO_COPY */
+
+	struct ring_info tx_skb[NUM_TX_DESC];	/* Tx data buffers */
+	struct timer_list timer;
+	u16 cp_cmd;
+
+	u16 event_slow;
+
+#ifdef RTL_PROC
+	struct proc_dir_entry *dir_dev;
+#endif
+
+	struct mdio_ops {
+		void (*write)(struct rtl8169_private *, int, int);
+		int (*read)(struct rtl8169_private *, int);
+	} mdio_ops;
+
+	struct pll_power_ops {
+		void (*down)(struct rtl8169_private *);
+		void (*up)(struct rtl8169_private *);
+	} pll_power_ops;
+
+	struct jumbo_ops {
+		void (*enable)(struct rtl8169_private *);
+		void (*disable)(struct rtl8169_private *);
+	} jumbo_ops;
+
+	struct csi_ops {
+		void (*write)(struct rtl8169_private *, int, int);
+		u32 (*read)(struct rtl8169_private *, int);
+	} csi_ops;
+
+	int (*set_speed)(struct net_device *, u8 aneg, u16 sp, u8 dpx, u32 adv);
+	int (*get_settings)(struct net_device *, struct ethtool_cmd *);
+	void (*phy_reset_enable)(struct rtl8169_private *tp);
+	void (*hw_start)(struct net_device *);
+	unsigned int (*phy_reset_pending)(struct rtl8169_private *tp);
+	unsigned int (*link_ok)(void __iomem *);
+	int (*do_ioctl)(struct rtl8169_private *tp, struct mii_ioctl_data *data, int cmd);
+
+	struct {
+		DECLARE_BITMAP(flags, RTL_FLAG_MAX);
+		struct mutex mutex;
+		struct work_struct work;
+	} wk;
+
+	unsigned features;
+
+	struct mii_if_info mii;
+	struct rtl8169_counters counters;
+	u32 saved_wolopts;
+	u32 opts1_mask;
+
+	u8 wol_wpd_cnt;
+	u8 wol_mask[RTL_WPD_SIZE][RTL_WPD_MASK_SIZE];
+	u8 wol_mask_size[RTL_WPD_SIZE];
+	u32 wol_crc[RTL_WPD_SIZE];
+
+	struct rtl_fw {
+		const struct firmware *fw;
+
+#define RTL_VER_SIZE		32
+
+		char version[RTL_VER_SIZE];
+
+		struct rtl_fw_phy_action {
+			__le32 *code;
+			size_t size;
+		} phy_action;
+	} *rtl_fw;
+#define RTL_FIRMWARE_UNKNOWN	ERR_PTR(-EAGAIN)
+
+	u32 ocp_base;
+	u32 led_cfg;
+
+	/* For link status change. */
+	struct task_struct *kthr;
+	wait_queue_head_t thr_wait;
+	int link_chg;
+	int phy_irq[POR_NUM];
+	atomic_t phy_reinit_flag;
+
+	#if defined(CONFIG_ARCH_RTD129x)
+	/* RGMII */
+	u8 output_mode; /* 0:embedded PHY, 1:RGMII to MAC, 2:RGMII to PHY */
+	u8 rgmii_voltage; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+	u8 rgmii_tx_delay; /* 0: 0ns, 1: 2ns */
+	u8 rgmii_rx_delay; /* 0: 0ns, 1: 2ns */
+	#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	void __iomem *mmio_sbxaddr;
+	void __iomem *mmio_otpaddr;
+	void __iomem *mmio_sdsaddr;
+	void __iomem *mmio_pinmuxaddr;
+
+	/* SGMII */
+	u8 output_mode; /* 0:embedded PHY, 1:SGMII to MAC, 2:SGMII to PHY */
+	#if defined(CONFIG_ARCH_RTD16xx)
+	u8 sgmii_swing; /* 0:640mV, 1:380mV, 2:250mV, 3:190mV */
+	#endif /* CONFIG_ARCH_RTD16xx */
+
+	bool bypass_enable; /* 0: disable, 1: enable */
+	#elif defined(CONFIG_ARCH_RTD13xx)
+	u8 output_mode; /* 0:embedded PHY, 1:RGMII to MAC, 2:RGMII to PHY, 3:RMII */
+	u8 voltage; /* 1:1.8V, 2: 2.5V, 3:3.3V */
+	u8 tx_delay; /* 0: 0ns, 1: 2ns */
+	u8 rx_delay; /* 0 ~ 7 x 0.5ns */
+
+	void __iomem *mmio_sbxaddr;
+	void __iomem *mmio_otpaddr;
+	void __iomem *mmio_pinmuxaddr;
+
+	bool bypass_enable; /* 0: disable, 1: enable */
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+	u8 ext_phy_id; /* 0 ~ 31 */
+	bool eee_enable; /* 0: disable, 1: enable */
+	bool acp_enable; /* 0: disable, 1: enable */
+	bool ext_phy;
+};
+
+MODULE_AUTHOR("Realtek and the Linux r8169 crew <netdev@vger.kernel.org>");
+MODULE_DESCRIPTION("RealTek RTL-8169 Gigabit Ethernet driver");
+module_param(use_dac, int, 0);
+MODULE_PARM_DESC(use_dac, "Enable PCI DAC. Unsafe on 32 bit PCI slot.");
+module_param_named(debug, debug.msg_enable, int, 0);
+MODULE_PARM_DESC(debug, "Debug verbosity level (0=none, ..., 16=all)");
+MODULE_LICENSE("GPL");
+MODULE_VERSION(RTL8169_VERSION);
+MODULE_FIRMWARE(FIRMWARE_8168D_1);
+MODULE_FIRMWARE(FIRMWARE_8168D_2);
+MODULE_FIRMWARE(FIRMWARE_8168E_1);
+MODULE_FIRMWARE(FIRMWARE_8168E_2);
+MODULE_FIRMWARE(FIRMWARE_8168E_3);
+MODULE_FIRMWARE(FIRMWARE_8105E_1);
+MODULE_FIRMWARE(FIRMWARE_8168F_1);
+MODULE_FIRMWARE(FIRMWARE_8168F_2);
+MODULE_FIRMWARE(FIRMWARE_8402_1);
+MODULE_FIRMWARE(FIRMWARE_8411_1);
+MODULE_FIRMWARE(FIRMWARE_8106E_1);
+MODULE_FIRMWARE(FIRMWARE_8106E_2);
+MODULE_FIRMWARE(FIRMWARE_8168G_2);
+MODULE_FIRMWARE(FIRMWARE_8168G_3);
+
+static void rtl_lock_work(struct rtl8169_private *tp)
+{
+	mutex_lock(&tp->wk.mutex);
+}
+
+static void rtl_unlock_work(struct rtl8169_private *tp)
+{
+	mutex_unlock(&tp->wk.mutex);
+}
+
+static void rtl_tx_performance_tweak(struct platform_device *pdev, u16 force)
+{
+//	pcie_capability_clear_and_set_word(pdev, PCI_EXP_DEVCTL,
+//					   PCI_EXP_DEVCTL_READRQ, force);
+}
+
+struct rtl_cond {
+	bool (*check)(struct rtl8169_private *);
+	const char *msg;
+};
+
+static void rtl_udelay(unsigned int d)
+{
+	udelay(d);
+}
+
+static bool rtl_loop_wait(struct rtl8169_private *tp, const struct rtl_cond *c,
+			  void (*delay)(unsigned int), unsigned int d, int n,
+			  bool high)
+{
+	int i;
+
+	for (i = 0; i < n; i++) {
+		delay(d);
+		if (c->check(tp) == high)
+			return true;
+	}
+	netif_err(tp, drv, tp->dev, "%s == %d (loop: %d, delay: %d).\n",
+		  c->msg, !high, n, d);
+	return false;
+}
+
+static bool rtl_udelay_loop_wait_high(struct rtl8169_private *tp,
+					  const struct rtl_cond *c,
+					  unsigned int d, int n)
+{
+	return rtl_loop_wait(tp, c, rtl_udelay, d, n, true);
+}
+
+static bool rtl_udelay_loop_wait_low(struct rtl8169_private *tp,
+					 const struct rtl_cond *c,
+					 unsigned int d, int n)
+{
+	return rtl_loop_wait(tp, c, rtl_udelay, d, n, false);
+}
+
+static bool rtl_msleep_loop_wait_high(struct rtl8169_private *tp,
+					  const struct rtl_cond *c,
+					  unsigned int d, int n)
+{
+	return rtl_loop_wait(tp, c, msleep, d, n, true);
+}
+
+static bool rtl_msleep_loop_wait_low(struct rtl8169_private *tp,
+					 const struct rtl_cond *c,
+					 unsigned int d, int n)
+{
+	return rtl_loop_wait(tp, c, msleep, d, n, false);
+}
+
+#define DECLARE_RTL_COND(name)				\
+static bool name ## _check(struct rtl8169_private *);	\
+							\
+static const struct rtl_cond name = {			\
+	.check	= name ## _check,			\
+	.msg	= #name					\
+};							\
+							\
+static bool name ## _check(struct rtl8169_private *tp)
+
+DECLARE_RTL_COND(rtl_ocpar_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(OCPAR) & OCPAR_FLAG;
+}
+
+static u32 ocp_read(struct rtl8169_private *tp, u8 mask, u16 reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(OCPAR, ((u32)mask & 0x0f) << 12 | (reg & 0x0fff));
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_ocpar_cond, 100, 20) ?
+		RTL_R32(OCPDR) : ~0;
+}
+
+static void ocp_write(struct rtl8169_private *tp, u8 mask, u16 reg, u32 data)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(OCPDR, data);
+	RTL_W32(OCPAR, OCPAR_FLAG | ((u32)mask & 0x0f) << 12 | (reg & 0x0fff));
+
+	rtl_udelay_loop_wait_low(tp, &rtl_ocpar_cond, 100, 20);
+}
+
+DECLARE_RTL_COND(rtl_eriar_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(ERIAR) & ERIAR_FLAG;
+}
+
+static void rtl8168_oob_notify(struct rtl8169_private *tp, u8 cmd)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(ERIDR, cmd);
+	RTL_W32(ERIAR, 0x800010e8);
+	msleep(2);
+
+	if (!rtl_udelay_loop_wait_low(tp, &rtl_eriar_cond, 100, 5))
+		return;
+
+	ocp_write(tp, 0x1, 0x30, 0x00000001);
+}
+
+#define OOB_CMD_RESET		0x00
+#define OOB_CMD_DRIVER_START	0x05
+#define OOB_CMD_DRIVER_STOP	0x06
+
+static u16 rtl8168_get_ocp_reg(struct rtl8169_private *tp)
+{
+	return (tp->mac_version == RTL_GIGA_MAC_VER_31) ? 0xb8 : 0x10;
+}
+
+DECLARE_RTL_COND(rtl_ocp_read_cond)
+{
+	u16 reg;
+
+	reg = rtl8168_get_ocp_reg(tp);
+
+	return ocp_read(tp, 0x0f, reg) & 0x00000800;
+}
+
+static void rtl8168_driver_start(struct rtl8169_private *tp)
+{
+	rtl8168_oob_notify(tp, OOB_CMD_DRIVER_START);
+
+	rtl_msleep_loop_wait_high(tp, &rtl_ocp_read_cond, 10, 10);
+}
+
+static void rtl8168_driver_stop(struct rtl8169_private *tp)
+{
+	rtl8168_oob_notify(tp, OOB_CMD_DRIVER_STOP);
+
+	rtl_msleep_loop_wait_low(tp, &rtl_ocp_read_cond, 10, 10);
+}
+
+static int r8168dp_check_dash(struct rtl8169_private *tp)
+{
+	u16 reg = rtl8168_get_ocp_reg(tp);
+
+	return (ocp_read(tp, 0x0f, reg) & 0x00008000) ? 1 : 0;
+}
+
+static bool rtl_ocp_reg_failure(struct rtl8169_private *tp, u32 reg)
+{
+	if (reg & 0xffff0001) {
+		netif_err(tp, drv, tp->dev, "Invalid ocp reg %x!\n", reg);
+		return true;
+	}
+	return false;
+}
+
+DECLARE_RTL_COND(rtl_ocp_gphy_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(GPHY_OCP) & OCPAR_FLAG;
+}
+
+static void r8168_phy_ocp_write(struct rtl8169_private *tp, u32 reg, u32 data)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (rtl_ocp_reg_failure(tp, reg))
+		return;
+
+	RTL_W32(GPHY_OCP, OCPAR_FLAG | (reg << 15) | data);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_ocp_gphy_cond, 25, 10);
+}
+
+static u16 r8168_phy_ocp_read(struct rtl8169_private *tp, u32 reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (rtl_ocp_reg_failure(tp, reg))
+		return 0;
+
+	RTL_W32(GPHY_OCP, reg << 15);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_ocp_gphy_cond, 25, 10) ?
+		(RTL_R32(GPHY_OCP) & 0xffff) : ~0;
+}
+
+static void r8168_mac_ocp_write(struct rtl8169_private *tp, u32 reg, u32 data)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (rtl_ocp_reg_failure(tp, reg))
+		return;
+
+	RTL_W32(OCPDR, OCPAR_FLAG | (reg << 15) | data);
+}
+
+static u16 r8168_mac_ocp_read(struct rtl8169_private *tp, u32 reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (rtl_ocp_reg_failure(tp, reg))
+		return 0;
+
+	RTL_W32(OCPDR, reg << 15);
+
+	return RTL_R32(OCPDR);
+}
+
+void r8169soc_ocp_reg_write(struct rtl8169_private *tp,
+				unsigned int reg_addr,
+				unsigned int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	unsigned int wdata;
+
+	// write value to reg
+	wdata = (0x1 << 31) | (((reg_addr & 0xffff) >> 1) << 16) |
+		(value & 0xffff);
+	RTL_W32(OCPDR, wdata);
+}
+
+unsigned int r8169soc_ocp_reg_read(struct rtl8169_private *tp,
+				unsigned int reg_addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	unsigned int wdata;
+	unsigned int rdata;
+
+	// write value to reg
+	wdata = (0x0 << 31) | (((reg_addr & 0xffff) >> 1) << 16);
+	RTL_W32(OCPDR, wdata);
+	rdata = RTL_R32(OCPDR);
+	return(rdata & 0xffff);
+}
+
+#define OCP_STD_PHY_BASE	0xa400
+
+static __maybe_unused void r8168g_mdio_write(struct rtl8169_private *tp, int reg, int value)
+{
+	if (reg == 0x1f) {
+		tp->ocp_base = value ? value << 4 : OCP_STD_PHY_BASE;
+		return;
+	}
+
+	if (tp->ocp_base != OCP_STD_PHY_BASE)
+		reg -= 0x10;
+
+	r8168_phy_ocp_write(tp, tp->ocp_base + reg * 2, value);
+}
+
+static __maybe_unused int r8168g_mdio_read(struct rtl8169_private *tp, int reg)
+{
+	if (tp->ocp_base != OCP_STD_PHY_BASE)
+		reg -= 0x10;
+
+	return r8168_phy_ocp_read(tp, tp->ocp_base + reg * 2);
+}
+
+static __maybe_unused void mac_mcu_write(struct rtl8169_private *tp, int reg, int value)
+{
+	if (reg == 0x1f) {
+		tp->ocp_base = value << 4;
+		return;
+	}
+
+	r8168_mac_ocp_write(tp, tp->ocp_base + reg, value);
+}
+
+static __maybe_unused int mac_mcu_read(struct rtl8169_private *tp, int reg)
+{
+	return r8168_mac_ocp_read(tp, tp->ocp_base + reg);
+}
+
+DECLARE_RTL_COND(rtl_phyar_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(PHYAR) & 0x80000000;
+}
+
+static void rtl_ephy_write(struct rtl8169_private *tp, int reg_addr, int value);
+static u16 rtl_ephy_read(struct rtl8169_private *tp, int reg_addr);
+
+static void r8169_mdio_write(struct rtl8169_private *tp, int reg, int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (tp->ext_phy) {
+		rtl_ephy_write(tp, reg, value);
+		return;
+	}
+	RTL_W32(PHYAR, 0x80000000 | (reg & 0x1f) << 16 | (value & 0xffff));
+
+	rtl_udelay_loop_wait_low(tp, &rtl_phyar_cond, 25, 20);
+	/*
+	 * According to hardware specs a 20us delay is required after write
+	 * complete indication, but before sending next command.
+	 */
+	udelay(20);
+}
+
+static int r8169_mdio_read(struct rtl8169_private *tp, int reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	int value;
+
+	if (tp->ext_phy) {
+		return rtl_ephy_read(tp, reg);
+	}
+
+	RTL_W32(PHYAR, 0x0 | (reg & 0x1f) << 16);
+
+	value = rtl_udelay_loop_wait_high(tp, &rtl_phyar_cond, 25, 20) ?
+		RTL_R32(PHYAR) & 0xffff : ~0;
+
+	/*
+	 * According to hardware specs a 20us delay is required after read
+	 * complete indication, but before sending next command.
+	 */
+	udelay(20);
+
+	return value;
+}
+
+#if defined(CONFIG_ARCH_RTD129x)
+#define MDIO_LOCK							\
+do {									\
+	/* disable interrupt from PHY to MCU */				\
+	r8169soc_ocp_reg_write(tp, 0xfc1e,				\
+		r8169soc_ocp_reg_read(tp, 0xfc1e) &			\
+					~(BIT(1) | BIT(11) | BIT(12)));	\
+} while (0)
+#define MDIO_UNLOCK							\
+do {									\
+	u32 tmp;							\
+	/* enable interrupt from PHY to MCU */				\
+	tmp = r8169soc_ocp_reg_read(tp, 0xfc1e);			\
+	if (tp->output_mode == OUTPUT_RGMII_TO_MAC)			\
+		tmp |= (BIT(11) | BIT(12)); /* ignore BIT(1):mac_intr*/	\
+	else								\
+		tmp |= (BIT(1) | BIT(11) | BIT(12));			\
+	r8169soc_ocp_reg_write(tp, 0xfc1e, tmp);			\
+} while (0)
+#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+#define MDIO_WAIT_TIMEOUT	100
+#define MDIO_LOCK							\
+do {									\
+	u32 wait_cnt = 0;						\
+	u32 log_de4e = 0;						\
+									\
+	/* disable EEE IMR */						\
+	r8169soc_ocp_reg_write(tp, 0xE044,				\
+		(r8169soc_ocp_reg_read(tp, 0xE044) & 			\
+		~(BIT(3) | BIT(2) | BIT(1) | BIT(0))));			\
+	/* disable timer 2 */						\
+	r8169soc_ocp_reg_write(tp, 0xE404,				\
+		(r8169soc_ocp_reg_read(tp, 0xE404) & 			\
+		~(BIT(12) | BIT(11) | BIT(8))) | (BIT(12)));		\
+	/* wait MDIO channel is free */					\
+	log_de4e = BIT(0) & r8169soc_ocp_reg_read(tp, 0xDE4E);		\
+	log_de4e = (log_de4e << 1) | 					\
+		(BIT(0) & r8169soc_ocp_reg_read(tp, 0xDE4E));		\
+	/* check if 0 for continuous 2 times */				\
+	while (0 != (((0x1 << 2) - 1) & log_de4e)) {			\
+		wait_cnt++;						\
+		udelay(1);						\
+		log_de4e = (log_de4e << 1) | (BIT(0) & 			\
+			r8169soc_ocp_reg_read(tp, 0xDE4E));		\
+		if (wait_cnt > MDIO_WAIT_TIMEOUT)			\
+			break;						\
+	}								\
+	/* enter driver mode */						\
+	r8169soc_ocp_reg_write(tp, 0xDE42,				\
+		r8169soc_ocp_reg_read(tp, 0xDE42) | BIT(0));		\
+	if (wait_cnt > MDIO_WAIT_TIMEOUT)				\
+		pr_err("%s:%d: MDIO lock failed\n", __func__,__LINE__);	\
+} while (0)
+
+#define MDIO_UNLOCK							\
+do {									\
+	/* exit driver mode */						\
+	r8169soc_ocp_reg_write(tp, 0xDE42,				\
+			r8169soc_ocp_reg_read(tp, 0xDE42) & ~BIT(0));	\
+	/* enable timer 2 */						\
+	r8169soc_ocp_reg_write(tp, 0xE404,				\
+		(r8169soc_ocp_reg_read(tp, 0xE404) | 			\
+		BIT(12) | BIT(11) | BIT(8)));				\
+	/* enable EEE IMR */						\
+	r8169soc_ocp_reg_write(tp, 0xE044,				\
+		(r8169soc_ocp_reg_read(tp, 0xE044) | 			\
+		BIT(3) | BIT(2) | BIT(1) | BIT(0)));			\
+} while (0)
+#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+
+static void r8168dp_1_mdio_access(struct rtl8169_private *tp, int reg, u32 data)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(OCPDR, data | ((reg & OCPDR_REG_MASK) << OCPDR_GPHY_REG_SHIFT));
+	RTL_W32(OCPAR, OCPAR_GPHY_WRITE_CMD);
+	RTL_W32(EPHY_RXER_NUM, 0);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_ocpar_cond, 1000, 100);
+}
+
+static void r8168dp_1_mdio_write(struct rtl8169_private *tp, int reg, int value)
+{
+	r8168dp_1_mdio_access(tp, reg,
+				  OCPDR_WRITE_CMD | (value & OCPDR_DATA_MASK));
+}
+
+static int r8168dp_1_mdio_read(struct rtl8169_private *tp, int reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	r8168dp_1_mdio_access(tp, reg, OCPDR_READ_CMD);
+
+	mdelay(1);
+	RTL_W32(OCPAR, OCPAR_GPHY_READ_CMD);
+	RTL_W32(EPHY_RXER_NUM, 0);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_ocpar_cond, 1000, 100) ?
+		RTL_R32(OCPDR) & OCPDR_DATA_MASK : ~0;
+}
+
+#define R8168DP_1_MDIO_ACCESS_BIT	0x00020000
+
+static void r8168dp_2_mdio_start(void __iomem *ioaddr)
+{
+	RTL_W32(0xd0, RTL_R32(0xd0) & ~R8168DP_1_MDIO_ACCESS_BIT);
+}
+
+static void r8168dp_2_mdio_stop(void __iomem *ioaddr)
+{
+	RTL_W32(0xd0, RTL_R32(0xd0) | R8168DP_1_MDIO_ACCESS_BIT);
+}
+
+static void r8168dp_2_mdio_write(struct rtl8169_private *tp, int reg, int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	r8168dp_2_mdio_start(ioaddr);
+
+	r8169_mdio_write(tp, reg, value);
+
+	r8168dp_2_mdio_stop(ioaddr);
+}
+
+static int r8168dp_2_mdio_read(struct rtl8169_private *tp, int reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	int value;
+
+	r8168dp_2_mdio_start(ioaddr);
+
+	value = r8169_mdio_read(tp, reg);
+
+	r8168dp_2_mdio_stop(ioaddr);
+
+	return value;
+}
+
+static void rtl_writephy(struct rtl8169_private *tp, int location, u32 val)
+{
+	tp->mdio_ops.write(tp, location, val);
+}
+
+static int rtl_readphy(struct rtl8169_private *tp, int location)
+{
+	return tp->mdio_ops.read(tp, location);
+}
+
+static void rtl_patchphy(struct rtl8169_private *tp, int reg_addr, int value)
+{
+	rtl_writephy(tp, reg_addr, rtl_readphy(tp, reg_addr) | value);
+}
+
+static void rtl_w1w0_phy(struct rtl8169_private *tp, int reg_addr, int p, int m)
+{
+	int val;
+
+	val = rtl_readphy(tp, reg_addr);
+	rtl_writephy(tp, reg_addr, (val | p) & ~m);
+}
+
+static void rtl_mdio_write(struct net_device *dev, int phy_id, int location,
+			   int val)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	MDIO_LOCK;
+	rtl_writephy(tp, location, val);
+	MDIO_UNLOCK;
+}
+
+static int rtl_mdio_read(struct net_device *dev, int phy_id, int location)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int ret;
+
+	MDIO_LOCK;
+	ret = rtl_readphy(tp, location);
+	MDIO_UNLOCK;
+	return ret;
+}
+
+DECLARE_RTL_COND(rtl_ephyar_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(EPHYAR) & EPHYAR_FLAG;
+}
+
+static void rtl_ephy_write(struct rtl8169_private *tp, int reg_addr, int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(EPHYAR, EPHYAR_WRITE_CMD | (value & EPHYAR_DATA_MASK) |
+		(reg_addr & EPHYAR_REG_MASK) << EPHYAR_REG_SHIFT);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_ephyar_cond, 10, 100);
+
+	udelay(10);
+}
+
+static u16 rtl_ephy_read(struct rtl8169_private *tp, int reg_addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(EPHYAR, (reg_addr & EPHYAR_REG_MASK) << EPHYAR_REG_SHIFT);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_ephyar_cond, 10, 100) ?
+		RTL_R32(EPHYAR) & EPHYAR_DATA_MASK : ~0;
+}
+
+static void rtl_eri_write(struct rtl8169_private *tp, int addr, u32 mask,
+			  u32 val, int type)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	BUG_ON((addr & 3) || (mask == 0));
+	RTL_W32(ERIDR, val);
+	RTL_W32(ERIAR, ERIAR_WRITE_CMD | type | mask | addr);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_eriar_cond, 100, 100);
+}
+
+static u32 rtl_eri_read(struct rtl8169_private *tp, int addr, int type)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(ERIAR, ERIAR_READ_CMD | type | ERIAR_MASK_1111 | addr);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_eriar_cond, 100, 100) ?
+		RTL_R32(ERIDR) : ~0;
+}
+
+static void rtl_w1w0_eri(struct rtl8169_private *tp, int addr, u32 mask, u32 p,
+			 u32 m, int type)
+{
+	u32 val;
+
+	val = rtl_eri_read(tp, addr, type);
+	rtl_eri_write(tp, addr, mask, (val & ~m) | p, type);
+}
+
+struct exgmac_reg {
+	u16 addr;
+	u16 mask;
+	u32 val;
+};
+
+static void rtl_write_exgmac_batch(struct rtl8169_private *tp,
+				   const struct exgmac_reg *r, int len)
+{
+	while (len-- > 0) {
+		rtl_eri_write(tp, r->addr, r->mask, r->val, ERIAR_EXGMAC);
+		r++;
+	}
+}
+
+DECLARE_RTL_COND(rtl_efusear_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(EFUSEAR) & EFUSEAR_FLAG;
+}
+
+static u8 rtl8168d_efuse_read(struct rtl8169_private *tp, int reg_addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(EFUSEAR, (reg_addr & EFUSEAR_REG_MASK) << EFUSEAR_REG_SHIFT);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_efusear_cond, 100, 300) ?
+		RTL_R32(EFUSEAR) & EFUSEAR_DATA_MASK : ~0;
+}
+
+static u16 rtl_get_events(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R16(IntrStatus);
+}
+
+static void rtl_ack_events(struct rtl8169_private *tp, u16 bits)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W16(IntrStatus, bits);
+	mmiowb();
+}
+
+static void rtl_irq_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W16(IntrMask, 0);
+	mmiowb();
+}
+
+static void rtl_irq_enable(struct rtl8169_private *tp, u16 bits)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W16(IntrMask, bits);
+}
+
+#if defined(RTL_ADJUST_FIFO_THRESHOLD)
+#define RTL_EVENT_NAPI_RX	(RxOK | RxErr | RxOverflow)
+#else
+#define RTL_EVENT_NAPI_RX	(RxOK | RxErr)
+#endif /* RTL_ADJUST_FIFO_THRESHOLD */
+#define RTL_EVENT_NAPI_TX	(TxOK | TxErr)
+#define RTL_EVENT_NAPI		(RTL_EVENT_NAPI_RX | RTL_EVENT_NAPI_TX)
+
+static void rtl_irq_enable_all(struct rtl8169_private *tp)
+{
+	rtl_irq_enable(tp, RTL_EVENT_NAPI | tp->event_slow);
+}
+
+static void rtl8169_irq_mask_and_ack(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	rtl_irq_disable(tp);
+	rtl_ack_events(tp, RTL_EVENT_NAPI | tp->event_slow);
+	RTL_R8(ChipCmd);
+}
+
+static unsigned int rtl8169_tbi_reset_pending(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(TBICSR) & TBIReset;
+}
+
+static unsigned int rtl8169_xmii_reset_pending(struct rtl8169_private *tp)
+{
+	int ret;
+
+	MDIO_LOCK;
+	ret = rtl_readphy(tp, MII_BMCR);
+	MDIO_UNLOCK;
+	return ret & BMCR_RESET;
+}
+
+static unsigned int rtl8169_tbi_link_ok(void __iomem *ioaddr)
+{
+	return RTL_R32(TBICSR) & TBILinkOk;
+}
+
+static unsigned int rtl8169_xmii_link_ok(void __iomem *ioaddr)
+{
+	return RTL_R8(PHYstatus) & LinkStatus;
+}
+
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD139x)
+static unsigned int rtl8169_xmii_always_link_ok(void __iomem *ioaddr)
+{
+	return true;
+}
+#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x */
+
+static void rtl8169_tbi_reset_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(TBICSR, RTL_R32(TBICSR) | TBIReset);
+}
+
+static void rtl8169_xmii_reset_enable(struct rtl8169_private *tp)
+{
+	unsigned int val;
+
+	MDIO_LOCK;
+	val = rtl_readphy(tp, MII_BMCR) | BMCR_RESET;
+	rtl_writephy(tp, MII_BMCR, val & 0xffff);
+	MDIO_UNLOCK;
+}
+
+static void rtl_link_chg_patch(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct net_device *dev = tp->dev;
+
+	if (!netif_running(dev))
+		return;
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_34 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_38) {
+		if (RTL_R8(PHYstatus) & _1000bpsF) {
+			rtl_eri_write(tp, 0x1bc, ERIAR_MASK_1111, 0x00000011,
+					  ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_1111, 0x00000005,
+					  ERIAR_EXGMAC);
+		} else if (RTL_R8(PHYstatus) & _100bps) {
+			rtl_eri_write(tp, 0x1bc, ERIAR_MASK_1111, 0x0000001f,
+					  ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_1111, 0x00000005,
+					  ERIAR_EXGMAC);
+		} else {
+			rtl_eri_write(tp, 0x1bc, ERIAR_MASK_1111, 0x0000001f,
+					  ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_1111, 0x0000003f,
+					  ERIAR_EXGMAC);
+		}
+		/* Reset packet filter */
+		rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x00, 0x01,
+				 ERIAR_EXGMAC);
+		rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x01, 0x00,
+				 ERIAR_EXGMAC);
+	} else if (tp->mac_version == RTL_GIGA_MAC_VER_35 ||
+		   tp->mac_version == RTL_GIGA_MAC_VER_36) {
+		if (RTL_R8(PHYstatus) & _1000bpsF) {
+			rtl_eri_write(tp, 0x1bc, ERIAR_MASK_1111, 0x00000011,
+					  ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_1111, 0x00000005,
+					  ERIAR_EXGMAC);
+		} else {
+			rtl_eri_write(tp, 0x1bc, ERIAR_MASK_1111, 0x0000001f,
+					  ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_1111, 0x0000003f,
+					  ERIAR_EXGMAC);
+		}
+	} else if (tp->mac_version == RTL_GIGA_MAC_VER_37) {
+		if (RTL_R8(PHYstatus) & _10bps) {
+			rtl_eri_write(tp, 0x1d0, ERIAR_MASK_0011, 0x4d02,
+					  ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_0011, 0x0060,
+					  ERIAR_EXGMAC);
+		} else {
+			rtl_eri_write(tp, 0x1d0, ERIAR_MASK_0011, 0x0000,
+					  ERIAR_EXGMAC);
+		}
+	}
+}
+
+void r8169_mmd_write(struct rtl8169_private *tp, unsigned int dev_addr, unsigned int reg_addr, unsigned int value)
+{
+	// page 0
+	r8169_mdio_write(tp, 0x1f, 0);
+	// address mode
+	r8169_mdio_write(tp, 13, (0x3fff & dev_addr));
+	// write the desired address
+	r8169_mdio_write(tp, 14, reg_addr);
+	// data mode, no post increment
+	r8169_mdio_write(tp, 13, ((0x3fff & dev_addr) | (0x1 << 14)));
+	// write the content of the selected register
+	r8169_mdio_write(tp, 14, value);
+}
+
+unsigned int r8169_mmd_read(struct rtl8169_private *tp, unsigned int dev_addr, unsigned int reg_addr)
+{
+	// page 0
+	r8169_mdio_write(tp, 0x1f, 0);
+	// address mode
+	r8169_mdio_write(tp, 13, (0x3fff & dev_addr));
+	// write the desired address
+	r8169_mdio_write(tp, 14, reg_addr);
+	// data mode, no post increment
+	r8169_mdio_write(tp, 13, ((0x3fff & dev_addr) | (0x1 << 14)));
+	// read the content of the selected register
+	return r8169_mdio_read(tp, 14);
+}
+
+void r8169_display_eee_info(struct net_device *dev, struct rtl8169_private *tp)
+{
+	// display DUT and link partner EEE capability
+	unsigned int	temp, tmp1, tmp2;
+	int		speed = 0;
+	bool		eee1000, eee100, eee10;
+	int		duplex;
+
+	MDIO_LOCK;
+	// page 0xa43
+	r8169_mdio_write(tp, 0x1f, 0xa43);
+	temp = r8169_mdio_read(tp, 26);
+	if (0 == ((0x1 << 2) & temp)) {
+		MDIO_UNLOCK;
+		pr_err("%s: link is down\n", dev->name);
+		return;
+	}
+
+	if ((0x1 << 3) & temp)
+		duplex = 1;
+	else
+		duplex = 0;
+
+	if ((0x0 << 4) == ((0x3 << 4) & temp)) {
+		speed = 10;
+
+		r8169_mdio_write(tp, 0x1f, 0xbcd);
+		tmp1 = r8169_mdio_read(tp, 19);
+
+		r8169_mdio_write(tp, 0x1f, 0xa60);
+		tmp2 = r8169_mdio_read(tp, 16);
+
+		if (0 == ((0x1 << 4) & tmp1))
+			eee10 = false;
+		else
+			eee10 = true;
+
+		MDIO_UNLOCK;
+		pr_err("%s: link speed = %dM %s, EEE = %s, PCS_Status = 0x%02x\n",
+			dev->name, speed,
+			duplex?"full":"half",
+			eee10?"Y":"N",
+			tmp2 & 0xff);
+		return;
+	}
+	if ((0x1 << 4) == ((0x3 << 4) & temp)) speed = 100;
+	if ((0x2 << 4) == ((0x3 << 4) & temp)) speed = 1000;
+	if ((0x1 << 8) == ((0x1 << 8) & temp)) {
+		pr_err("%s: link speed = %dM %s, EEE = Y\n", dev->name, speed,
+			duplex?"full":"half");
+
+		r8169_mdio_write(tp, 0x1f, 0xa60);
+		tmp1 = r8169_mdio_read(tp, 16);
+
+		r8169_mdio_write(tp, 0x1f, 0xa5c);
+		tmp2 = r8169_mdio_read(tp, 19);
+		pr_err("PCS_Status = 0x%02x, EEE_wake_error = 0x%04x\n", tmp1 & 0xff, tmp2);
+	} else {
+		pr_err("%s: link speed = %dM %s, EEE = N\n", dev->name, speed,
+			duplex?"full":"half");
+
+		temp = r8169_mmd_read(tp, 0x7, 0x3d);
+		if (0 == (temp & (0x1 << 2)))
+			eee1000 = false;
+		else
+			eee1000 = true;
+
+		if (0 == (temp & (0x1 << 1)))
+			eee100 = false;
+		else
+			eee100 = true;
+
+		pr_err("%s: Link Partner EEE1000=%s, EEE100=%s\n", dev->name, eee1000?"Y":"N", eee100?"Y":"N");
+	}
+	MDIO_UNLOCK;
+}
+
+static void __rtl8169_check_link_status(struct net_device *dev,
+					struct rtl8169_private *tp,
+					void __iomem *ioaddr, bool pm)
+{
+	if (tp->link_ok(ioaddr)) {
+		rtl_link_chg_patch(tp);
+		/* This is to cancel a scheduled suspend if there's one. */
+		if (pm)
+			pm_request_resume(&tp->pdev->dev);
+		netif_carrier_on(dev);
+		if (net_ratelimit())
+			netif_info(tp, ifup, dev, "link up\n");
+	} else {
+		netif_carrier_off(dev);
+		netif_info(tp, ifdown, dev, "link down\n");
+		if (pm)
+			pm_schedule_suspend(&tp->pdev->dev, 5000);
+	}
+}
+
+static void rtl8169_check_link_status(struct net_device *dev,
+					  struct rtl8169_private *tp,
+					  void __iomem *ioaddr)
+{
+	__rtl8169_check_link_status(dev, tp, ioaddr, false);
+}
+
+#define WAKE_ANY (WAKE_PHY | WAKE_MAGIC | WAKE_UCAST | WAKE_BCAST | WAKE_MCAST)
+
+static u32 __rtl8169_get_wol(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	u8 options;
+	u32 wolopts = 0;
+
+	options = RTL_R8(Config1);
+	if (!(options & PMEnable))
+		return 0;
+
+	options = RTL_R8(Config3);
+	if (options & LinkUp)
+		wolopts |= WAKE_PHY;
+	if (options & MagicPacket)
+		wolopts |= WAKE_MAGIC;
+
+	options = RTL_R8(Config5);
+	if (options & UWF)
+		wolopts |= WAKE_UCAST;
+	if (options & BWF)
+		wolopts |= WAKE_BCAST;
+	if (options & MWF)
+		wolopts |= WAKE_MCAST;
+
+	return wolopts;
+}
+
+static void rtl8169_get_wol(struct net_device *dev, struct ethtool_wolinfo *wol)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl_lock_work(tp);
+
+	wol->supported = WAKE_ANY;
+	wol->wolopts = __rtl8169_get_wol(tp);
+
+	rtl_unlock_work(tp);
+}
+
+static void __rtl8169_set_wol(struct rtl8169_private *tp, u32 wolopts)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	unsigned int i;
+	static const struct {
+		u32 opt;
+		u16 reg;
+		u8  mask;
+	} cfg[] = {
+		{ WAKE_PHY,   Config3, LinkUp },
+		{ WAKE_MAGIC, Config3, MagicPacket },
+		{ WAKE_UCAST, Config5, UWF },
+		{ WAKE_BCAST, Config5, BWF },
+		{ WAKE_MCAST, Config5, MWF },
+		{ WAKE_ANY,   Config5, LanWake }
+	};
+	u8 options;
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	for (i = 0; i < ARRAY_SIZE(cfg); i++) {
+		options = RTL_R8(cfg[i].reg) & ~cfg[i].mask;
+		if (wolopts & cfg[i].opt)
+			options |= cfg[i].mask;
+		RTL_W8(cfg[i].reg, options);
+	}
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_01 ... RTL_GIGA_MAC_VER_17:
+		options = RTL_R8(Config1) & ~PMEnable;
+		if (wolopts)
+			options |= PMEnable;
+		RTL_W8(Config1, options);
+		break;
+	default:
+		options = RTL_R8(Config2) & ~PME_SIGNAL;
+		if (wolopts)
+			options |= PME_SIGNAL;
+		RTL_W8(Config2, options);
+		break;
+	}
+
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+}
+
+static int rtl8169_set_wol(struct net_device *dev, struct ethtool_wolinfo *wol)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl_lock_work(tp);
+
+	if (wol->wolopts)
+		tp->features |= RTL_FEATURE_WOL;
+	else
+		tp->features &= ~RTL_FEATURE_WOL;
+	__rtl8169_set_wol(tp, wol->wolopts);
+
+	rtl_unlock_work(tp);
+
+	device_set_wakeup_enable(&tp->pdev->dev, wol->wolopts);
+
+	return 0;
+}
+
+static const char *rtl_lookup_firmware_name(struct rtl8169_private *tp)
+{
+	return rtl_chip_infos[tp->mac_version].fw_name;
+}
+
+static void rtl8169_get_drvinfo(struct net_device *dev,
+				struct ethtool_drvinfo *info)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	struct rtl_fw *rtl_fw = tp->rtl_fw;
+
+	strlcpy(info->driver, MODULENAME, sizeof(info->driver));
+	strlcpy(info->version, RTL8169_VERSION, sizeof(info->version));
+	strlcpy(info->bus_info, "RTK119X-ETN", sizeof(info->bus_info));
+	BUILD_BUG_ON(sizeof(info->fw_version) < sizeof(rtl_fw->version));
+	if (!IS_ERR_OR_NULL(rtl_fw))
+		strlcpy(info->fw_version, rtl_fw->version,
+			sizeof(info->fw_version));
+}
+
+static int rtl8169_get_regs_len(struct net_device *dev)
+{
+	return R8169_REGS_SIZE;
+}
+
+static int rtl8169_set_speed_tbi(struct net_device *dev,
+				 u8 autoneg, u16 speed, u8 duplex, u32 ignored)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	int ret = 0;
+	u32 reg;
+
+	reg = RTL_R32(TBICSR);
+	if ((autoneg == AUTONEG_DISABLE) && (speed == SPEED_1000) &&
+		(duplex == DUPLEX_FULL)) {
+		RTL_W32(TBICSR, reg & ~(TBINwEnable | TBINwRestart));
+	} else if (autoneg == AUTONEG_ENABLE)
+		RTL_W32(TBICSR, reg | TBINwEnable | TBINwRestart);
+	else {
+		netif_warn(tp, link, dev,
+			   "incorrect speed setting refused in TBI mode\n");
+		ret = -EOPNOTSUPP;
+	}
+
+	return ret;
+}
+
+static int rtl8169_set_speed_xmii(struct net_device *dev,
+				  u8 autoneg, u16 speed, u8 duplex, u32 adv)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int giga_ctrl, bmcr;
+	int rc = -EINVAL;
+
+	MDIO_LOCK;
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	if (autoneg == AUTONEG_ENABLE) {
+		int auto_nego;
+
+		auto_nego = rtl_readphy(tp, MII_ADVERTISE);
+		auto_nego &= ~(ADVERTISE_10HALF | ADVERTISE_10FULL |
+				ADVERTISE_100HALF | ADVERTISE_100FULL);
+
+		if (adv & ADVERTISED_10baseT_Half)
+			auto_nego |= ADVERTISE_10HALF;
+		if (adv & ADVERTISED_10baseT_Full)
+			auto_nego |= ADVERTISE_10FULL;
+		if (adv & ADVERTISED_100baseT_Half)
+			auto_nego |= ADVERTISE_100HALF;
+		if (adv & ADVERTISED_100baseT_Full)
+			auto_nego |= ADVERTISE_100FULL;
+
+		auto_nego |= ADVERTISE_PAUSE_CAP | ADVERTISE_PAUSE_ASYM;
+
+		giga_ctrl = rtl_readphy(tp, MII_CTRL1000);
+		giga_ctrl &= ~(ADVERTISE_1000FULL | ADVERTISE_1000HALF);
+
+		/* The 8100e/8101e/8102e do Fast Ethernet only. */
+		if (tp->mii.supports_gmii) {
+			if (adv & ADVERTISED_1000baseT_Half)
+				giga_ctrl |= ADVERTISE_1000HALF;
+			if (adv & ADVERTISED_1000baseT_Full)
+				giga_ctrl |= ADVERTISE_1000FULL;
+		} else if (adv & (ADVERTISED_1000baseT_Half |
+				  ADVERTISED_1000baseT_Full)) {
+			netif_info(tp, link, dev,
+				   "PHY does not support 1000Mbps\n");
+			goto out;
+		}
+
+		bmcr = BMCR_ANENABLE | BMCR_ANRESTART;
+
+		rtl_writephy(tp, MII_ADVERTISE, auto_nego);
+		rtl_writephy(tp, MII_CTRL1000, giga_ctrl);
+	} else {
+		giga_ctrl = 0;
+
+		if (speed == SPEED_10)
+			bmcr = 0;
+		else if (speed == SPEED_100)
+			bmcr = BMCR_SPEED100;
+		else
+			goto out;
+
+		if (duplex == DUPLEX_FULL)
+			bmcr |= BMCR_FULLDPLX;
+	}
+
+	rtl_writephy(tp, MII_BMCR, bmcr);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_02 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_03) {
+		if ((speed == SPEED_100) && (autoneg != AUTONEG_ENABLE)) {
+			rtl_writephy(tp, 0x17, 0x2138);
+			rtl_writephy(tp, 0x0e, 0x0260);
+		} else {
+			rtl_writephy(tp, 0x17, 0x2108);
+			rtl_writephy(tp, 0x0e, 0x0000);
+		}
+	}
+
+	rc = 0;
+out:
+	MDIO_UNLOCK;
+	return rc;
+}
+
+static int rtl8169_set_speed(struct net_device *dev,
+				 u8 autoneg, u16 speed, u8 duplex, u32 advertising)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int ret;
+
+	ret = tp->set_speed(dev, autoneg, speed, duplex, advertising);
+	if (ret < 0)
+		goto out;
+
+	if (netif_running(dev)) {
+		//mod_timer(&tp->timer, jiffies + RTL8169_PHY_TIMEOUT);
+	}
+out:
+	return ret;
+}
+
+static int rtl8169_set_settings(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int ret;
+
+	//del_timer_sync(&tp->timer);
+
+	rtl_lock_work(tp);
+	ret = rtl8169_set_speed(dev, cmd->autoneg, ethtool_cmd_speed(cmd),
+				cmd->duplex, cmd->advertising);
+	rtl_unlock_work(tp);
+
+	return ret;
+}
+
+static netdev_features_t rtl8169_fix_features(struct net_device *dev,
+	netdev_features_t features)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (dev->mtu > TD_MSS_MAX)
+		features &= ~NETIF_F_ALL_TSO;
+
+	if (dev->mtu > JUMBO_1K &&
+		!rtl_chip_infos[tp->mac_version].jumbo_tx_csum)
+		features &= ~NETIF_F_IP_CSUM;
+
+	return features;
+}
+
+static void __rtl8169_set_features(struct net_device *dev,
+				   netdev_features_t features)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	netdev_features_t changed = features ^ dev->features;
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (!(changed & (NETIF_F_RXALL | NETIF_F_RXCSUM |
+			 NETIF_F_HW_VLAN_CTAG_RX)))
+		return;
+
+	if (changed & (NETIF_F_RXCSUM | NETIF_F_HW_VLAN_CTAG_RX)) {
+		if (features & NETIF_F_RXCSUM)
+			tp->cp_cmd |= RxChkSum;
+		else
+			tp->cp_cmd &= ~RxChkSum;
+
+		if (dev->features & NETIF_F_HW_VLAN_CTAG_RX)
+			tp->cp_cmd |= RxVlan;
+		else
+			tp->cp_cmd &= ~RxVlan;
+
+		RTL_W16(CPlusCmd, tp->cp_cmd);
+		RTL_R16(CPlusCmd);
+	}
+	if (changed & NETIF_F_RXALL) {
+		int tmp = (RTL_R32(RxConfig) & ~(AcceptErr | AcceptRunt));
+		if (features & NETIF_F_RXALL)
+			tmp |= (AcceptErr | AcceptRunt);
+		RTL_W32(RxConfig, tmp);
+	}
+}
+
+static int rtl8169_set_features(struct net_device *dev,
+				netdev_features_t features)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl_lock_work(tp);
+	__rtl8169_set_features(dev, features);
+	rtl_unlock_work(tp);
+
+	return 0;
+}
+
+
+static inline u32 rtl8169_tx_vlan_tag(struct sk_buff *skb)
+{
+	return (skb_vlan_tag_present(skb)) ?
+		TxVlanTag | swab16(skb_vlan_tag_get(skb)) : 0x00;
+}
+
+static void rtl8169_rx_vlan_tag(struct RxDesc *desc, struct sk_buff *skb)
+{
+	u32 opts2 = le32_to_cpu(desc->opts2);
+
+	if (opts2 & RxVlanTag)
+		__vlan_hwaccel_put_tag(skb, htons(ETH_P_8021Q), swab16(opts2 & 0xffff));
+}
+
+static int rtl8169_gset_tbi(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	u32 status;
+
+	cmd->supported =
+		SUPPORTED_1000baseT_Full | SUPPORTED_Autoneg | SUPPORTED_FIBRE;
+	cmd->port = PORT_FIBRE;
+	cmd->transceiver = XCVR_INTERNAL;
+
+	status = RTL_R32(TBICSR);
+	cmd->advertising = (status & TBINwEnable) ?  ADVERTISED_Autoneg : 0;
+	cmd->autoneg = !!(status & TBINwEnable);
+
+	ethtool_cmd_speed_set(cmd, SPEED_1000);
+	cmd->duplex = DUPLEX_FULL; /* Always set */
+
+	return 0;
+}
+
+static int rtl8169_gset_xmii(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	return mii_ethtool_gset(&tp->mii, cmd);
+}
+
+static int rtl8169_get_settings(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int rc;
+
+	rtl_lock_work(tp);
+	rc = tp->get_settings(dev, cmd);
+	rtl_unlock_work(tp);
+
+	return rc;
+}
+
+static void rtl8169_get_regs(struct net_device *dev, struct ethtool_regs *regs,
+				 void *p)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (regs->len > R8169_REGS_SIZE)
+		regs->len = R8169_REGS_SIZE;
+
+	rtl_lock_work(tp);
+	memcpy_fromio(p, tp->mmio_addr, regs->len);
+	rtl_unlock_work(tp);
+}
+
+static u32 rtl8169_get_msglevel(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	return tp->msg_enable;
+}
+
+static void rtl8169_set_msglevel(struct net_device *dev, u32 value)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	tp->msg_enable = value;
+}
+
+static const char rtl8169_gstrings[][ETH_GSTRING_LEN] = {
+	"tx_packets",
+	"rx_packets",
+	"tx_errors",
+	"rx_errors",
+	"rx_missed",
+	"align_errors",
+	"tx_single_collisions",
+	"tx_multi_collisions",
+	"unicast",
+	"broadcast",
+	"multicast",
+	"tx_aborted",
+	"tx_underrun",
+};
+
+static int rtl8169_get_sset_count(struct net_device *dev, int sset)
+{
+	switch (sset) {
+	case ETH_SS_STATS:
+		return ARRAY_SIZE(rtl8169_gstrings);
+	default:
+		return -EOPNOTSUPP;
+	}
+}
+
+DECLARE_RTL_COND(rtl_counters_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(CounterAddrLow) & CounterDump;
+}
+
+static void rtl8169_update_counters(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct device *d = &tp->pdev->dev;
+	struct rtl8169_counters *counters;
+	dma_addr_t paddr;
+	u32 cmd;
+	int node = dev->dev.parent ? dev_to_node(dev->dev.parent) : -1;
+
+	/*
+	 * Some chips are unable to dump tally counters when the receiver
+	 * is disabled.
+	 */
+	if ((RTL_R8(ChipCmd) & CmdRxEnb) == 0)
+		return;
+
+	if (tp->acp_enable) {
+		counters = kzalloc_node(sizeof(*counters), GFP_KERNEL, node);
+		paddr = virt_to_phys(counters);
+	} else {
+		counters = dma_alloc_coherent(d, sizeof(*counters), &paddr, GFP_KERNEL);
+	}
+	if (!counters)
+		return;
+
+	RTL_W32(CounterAddrHigh, (u64)paddr >> 32);
+	cmd = (u64)paddr & DMA_BIT_MASK(32);
+	RTL_W32(CounterAddrLow, cmd);
+	RTL_W32(CounterAddrLow, cmd | CounterDump);
+
+	if (rtl_udelay_loop_wait_low(tp, &rtl_counters_cond, 10, 1000))
+		memcpy(&tp->counters, counters, sizeof(*counters));
+
+	RTL_W32(CounterAddrLow, 0);
+	RTL_W32(CounterAddrHigh, 0);
+
+	if (tp->acp_enable) {
+		kfree(counters);
+	} else {
+		dma_free_coherent(d, sizeof(*counters), counters, paddr);
+	}
+}
+
+static void rtl8169_get_ethtool_stats(struct net_device *dev,
+					  struct ethtool_stats *stats, u64 *data)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	ASSERT_RTNL();
+
+	rtl8169_update_counters(dev);
+
+	data[0] = le64_to_cpu(tp->counters.tx_packets);
+	data[1] = le64_to_cpu(tp->counters.rx_packets);
+	data[2] = le64_to_cpu(tp->counters.tx_errors);
+	data[3] = le32_to_cpu(tp->counters.rx_errors);
+	data[4] = le16_to_cpu(tp->counters.rx_missed);
+	data[5] = le16_to_cpu(tp->counters.align_errors);
+	data[6] = le32_to_cpu(tp->counters.tx_one_collision);
+	data[7] = le32_to_cpu(tp->counters.tx_multi_collision);
+	data[8] = le64_to_cpu(tp->counters.rx_unicast);
+	data[9] = le64_to_cpu(tp->counters.rx_broadcast);
+	data[10] = le32_to_cpu(tp->counters.rx_multicast);
+	data[11] = le16_to_cpu(tp->counters.tx_aborted);
+	data[12] = le16_to_cpu(tp->counters.tx_underun);
+}
+
+static void rtl8169_get_strings(struct net_device *dev, u32 stringset, u8 *data)
+{
+	switch(stringset) {
+	case ETH_SS_STATS:
+		memcpy(data, *rtl8169_gstrings, sizeof(rtl8169_gstrings));
+		break;
+	}
+}
+
+static const struct ethtool_ops rtl8169_ethtool_ops = {
+	.get_drvinfo		= rtl8169_get_drvinfo,
+	.get_regs_len		= rtl8169_get_regs_len,
+	.get_link		= ethtool_op_get_link,
+	.get_settings		= rtl8169_get_settings,
+	.set_settings		= rtl8169_set_settings,
+	.get_msglevel		= rtl8169_get_msglevel,
+	.set_msglevel		= rtl8169_set_msglevel,
+	.get_regs		= rtl8169_get_regs,
+	.get_wol		= rtl8169_get_wol,
+	.set_wol		= rtl8169_set_wol,
+	.get_strings		= rtl8169_get_strings,
+	.get_sset_count		= rtl8169_get_sset_count,
+	.get_ethtool_stats	= rtl8169_get_ethtool_stats,
+	.get_ts_info		= ethtool_op_get_ts_info,
+};
+
+static void rtl8169_get_mac_version(struct rtl8169_private *tp,
+					struct net_device *dev, u8 default_version)
+{
+//	void __iomem *ioaddr = tp->mmio_addr;
+	/*
+	 * The driver currently handles the 8168Bf and the 8168Be identically
+	 * but they can be identified more specifically through the test below
+	 * if needed:
+	 *
+	 * (RTL_R32(TxConfig) & 0x700000) == 0x500000 ? 8168Bf : 8168Be
+	 *
+	 * Same thing for the 8101Eb and the 8101Ec:
+	 *
+	 * (RTL_R32(TxConfig) & 0x700000) == 0x200000 ? 8101Eb : 8101Ec
+	 */
+#if 0
+	static const struct rtl_mac_info {
+		u32 mask;
+		u32 val;
+		int mac_version;
+	} mac_info[] = {
+		/* 8168G family. */
+		{ 0x7cf00000, 0x50900000,	RTL_GIGA_MAC_VER_42 },
+		{ 0x7cf00000, 0x4c100000,	RTL_GIGA_MAC_VER_41 },
+		{ 0x7cf00000, 0x4c000000,	RTL_GIGA_MAC_VER_40 },
+
+		/* 8168F family. */
+		{ 0x7c800000, 0x48800000,	RTL_GIGA_MAC_VER_38 },
+		{ 0x7cf00000, 0x48100000,	RTL_GIGA_MAC_VER_36 },
+		{ 0x7cf00000, 0x48000000,	RTL_GIGA_MAC_VER_35 },
+
+		/* 8168E family. */
+		{ 0x7c800000, 0x2c800000,	RTL_GIGA_MAC_VER_34 },
+		{ 0x7cf00000, 0x2c200000,	RTL_GIGA_MAC_VER_33 },
+		{ 0x7cf00000, 0x2c100000,	RTL_GIGA_MAC_VER_32 },
+		{ 0x7c800000, 0x2c000000,	RTL_GIGA_MAC_VER_33 },
+
+		/* 8168D family. */
+		{ 0x7cf00000, 0x28300000,	RTL_GIGA_MAC_VER_26 },
+		{ 0x7cf00000, 0x28100000,	RTL_GIGA_MAC_VER_25 },
+		{ 0x7c800000, 0x28000000,	RTL_GIGA_MAC_VER_26 },
+
+		/* 8168DP family. */
+		{ 0x7cf00000, 0x28800000,	RTL_GIGA_MAC_VER_27 },
+		{ 0x7cf00000, 0x28a00000,	RTL_GIGA_MAC_VER_28 },
+		{ 0x7cf00000, 0x28b00000,	RTL_GIGA_MAC_VER_31 },
+
+		/* 8168C family. */
+		{ 0x7cf00000, 0x3cb00000,	RTL_GIGA_MAC_VER_24 },
+		{ 0x7cf00000, 0x3c900000,	RTL_GIGA_MAC_VER_23 },
+		{ 0x7cf00000, 0x3c800000,	RTL_GIGA_MAC_VER_18 },
+		{ 0x7c800000, 0x3c800000,	RTL_GIGA_MAC_VER_24 },
+		{ 0x7cf00000, 0x3c000000,	RTL_GIGA_MAC_VER_19 },
+		{ 0x7cf00000, 0x3c200000,	RTL_GIGA_MAC_VER_20 },
+		{ 0x7cf00000, 0x3c300000,	RTL_GIGA_MAC_VER_21 },
+		{ 0x7cf00000, 0x3c400000,	RTL_GIGA_MAC_VER_22 },
+		{ 0x7c800000, 0x3c000000,	RTL_GIGA_MAC_VER_22 },
+
+		/* 8168B family. */
+		{ 0x7cf00000, 0x38000000,	RTL_GIGA_MAC_VER_12 },
+		{ 0x7cf00000, 0x38500000,	RTL_GIGA_MAC_VER_17 },
+		{ 0x7c800000, 0x38000000,	RTL_GIGA_MAC_VER_17 },
+		{ 0x7c800000, 0x30000000,	RTL_GIGA_MAC_VER_11 },
+
+		/* 8101 family. */
+		{ 0x7cf00000, 0x44900000,	RTL_GIGA_MAC_VER_39 },
+		{ 0x7c800000, 0x44800000,	RTL_GIGA_MAC_VER_39 },
+		{ 0x7c800000, 0x44000000,	RTL_GIGA_MAC_VER_37 },
+		{ 0x7cf00000, 0x40b00000,	RTL_GIGA_MAC_VER_30 },
+		{ 0x7cf00000, 0x40a00000,	RTL_GIGA_MAC_VER_30 },
+		{ 0x7cf00000, 0x40900000,	RTL_GIGA_MAC_VER_29 },
+		{ 0x7c800000, 0x40800000,	RTL_GIGA_MAC_VER_30 },
+		{ 0x7cf00000, 0x34a00000,	RTL_GIGA_MAC_VER_09 },
+		{ 0x7cf00000, 0x24a00000,	RTL_GIGA_MAC_VER_09 },
+		{ 0x7cf00000, 0x34900000,	RTL_GIGA_MAC_VER_08 },
+		{ 0x7cf00000, 0x24900000,	RTL_GIGA_MAC_VER_08 },
+		{ 0x7cf00000, 0x34800000,	RTL_GIGA_MAC_VER_07 },
+		{ 0x7cf00000, 0x24800000,	RTL_GIGA_MAC_VER_07 },
+		{ 0x7cf00000, 0x34000000,	RTL_GIGA_MAC_VER_13 },
+		{ 0x7cf00000, 0x34300000,	RTL_GIGA_MAC_VER_10 },
+		{ 0x7cf00000, 0x34200000,	RTL_GIGA_MAC_VER_16 },
+		{ 0x7c800000, 0x34800000,	RTL_GIGA_MAC_VER_09 },
+		{ 0x7c800000, 0x24800000,	RTL_GIGA_MAC_VER_09 },
+		{ 0x7c800000, 0x34000000,	RTL_GIGA_MAC_VER_16 },
+		/* FIXME: where did these entries come from ? -- FR */
+		{ 0xfc800000, 0x38800000,	RTL_GIGA_MAC_VER_15 },
+		{ 0xfc800000, 0x30800000,	RTL_GIGA_MAC_VER_14 },
+
+		/* 8110 family. */
+		{ 0xfc800000, 0x98000000,	RTL_GIGA_MAC_VER_06 },
+		{ 0xfc800000, 0x18000000,	RTL_GIGA_MAC_VER_05 },
+		{ 0xfc800000, 0x10000000,	RTL_GIGA_MAC_VER_04 },
+		{ 0xfc800000, 0x04000000,	RTL_GIGA_MAC_VER_03 },
+		{ 0xfc800000, 0x00800000,	RTL_GIGA_MAC_VER_02 },
+		{ 0xfc800000, 0x00000000,	RTL_GIGA_MAC_VER_01 },
+
+		/* Catch-all */
+		{ 0x00000000, 0x00000000,	RTL_GIGA_MAC_NONE   }
+	};
+	const struct rtl_mac_info *p = mac_info;
+	u32 reg;
+
+	reg = RTL_R32(TxConfig);
+	while ((reg & p->mask) != p->val)
+		p++;
+	tp->mac_version = p->mac_version;
+#endif
+
+	if (tp->mac_version == RTL_GIGA_MAC_NONE) {
+		netif_notice(tp, probe, dev,
+				 "unknown MAC, using family default\n");
+		tp->mac_version = default_version;
+	}
+/* barry mask off
+	else if (tp->mac_version == RTL_GIGA_MAC_VER_42) {
+		tp->mac_version = tp->mii.supports_gmii ?
+				  RTL_GIGA_MAC_VER_42 :
+				  RTL_GIGA_MAC_VER_43;
+	}
+*/
+}
+
+static void rtl8169_print_mac_version(struct rtl8169_private *tp)
+{
+	dprintk("mac_version = 0x%02x\n", tp->mac_version);
+}
+
+struct phy_reg {
+	u16 reg;
+	u16 val;
+};
+
+static void rtl_writephy_batch(struct rtl8169_private *tp,
+				   const struct phy_reg *regs, int len)
+{
+	while (len-- > 0) {
+		rtl_writephy(tp, regs->reg, regs->val);
+		regs++;
+	}
+}
+
+#define PHY_READ		0x00000000
+#define PHY_DATA_OR		0x10000000
+#define PHY_DATA_AND		0x20000000
+#define PHY_BJMPN		0x30000000
+#define PHY_MDIO_CHG		0x40000000
+#define PHY_CLEAR_READCOUNT	0x70000000
+#define PHY_WRITE		0x80000000
+#define PHY_READCOUNT_EQ_SKIP	0x90000000
+#define PHY_COMP_EQ_SKIPN	0xa0000000
+#define PHY_COMP_NEQ_SKIPN	0xb0000000
+#define PHY_WRITE_PREVIOUS	0xc0000000
+#define PHY_SKIPN		0xd0000000
+#define PHY_DELAY_MS		0xe0000000
+
+struct fw_info {
+	u32	magic;
+	char	version[RTL_VER_SIZE];
+	__le32	fw_start;
+	__le32	fw_len;
+	u8	chksum;
+} __packed;
+
+#define FW_OPCODE_SIZE	sizeof(typeof(*((struct rtl_fw_phy_action *)0)->code))
+
+static bool rtl_fw_format_ok(struct rtl8169_private *tp, struct rtl_fw *rtl_fw)
+{
+	const struct firmware *fw = rtl_fw->fw;
+	struct fw_info *fw_info = (struct fw_info *)fw->data;
+	struct rtl_fw_phy_action *pa = &rtl_fw->phy_action;
+	char *version = rtl_fw->version;
+	bool rc = false;
+
+	if (fw->size < FW_OPCODE_SIZE)
+		goto out;
+
+	if (!fw_info->magic) {
+		size_t i, size, start;
+		u8 checksum = 0;
+
+		if (fw->size < sizeof(*fw_info))
+			goto out;
+
+		for (i = 0; i < fw->size; i++)
+			checksum += fw->data[i];
+		if (checksum != 0)
+			goto out;
+
+		start = le32_to_cpu(fw_info->fw_start);
+		if (start > fw->size)
+			goto out;
+
+		size = le32_to_cpu(fw_info->fw_len);
+		if (size > (fw->size - start) / FW_OPCODE_SIZE)
+			goto out;
+
+		memcpy(version, fw_info->version, RTL_VER_SIZE);
+
+		pa->code = (__le32 *)(fw->data + start);
+		pa->size = size;
+	} else {
+		if (fw->size % FW_OPCODE_SIZE)
+			goto out;
+
+		strlcpy(version, rtl_lookup_firmware_name(tp), RTL_VER_SIZE);
+
+		pa->code = (__le32 *)fw->data;
+		pa->size = fw->size / FW_OPCODE_SIZE;
+	}
+	version[RTL_VER_SIZE - 1] = 0;
+
+	rc = true;
+out:
+	return rc;
+}
+
+static bool rtl_fw_data_ok(struct rtl8169_private *tp, struct net_device *dev,
+			   struct rtl_fw_phy_action *pa)
+{
+	bool rc = false;
+	size_t index;
+
+	for (index = 0; index < pa->size; index++) {
+		u32 action = le32_to_cpu(pa->code[index]);
+		u32 regno = (action & 0x0fff0000) >> 16;
+
+		switch(action & 0xf0000000) {
+		case PHY_READ:
+		case PHY_DATA_OR:
+		case PHY_DATA_AND:
+		case PHY_MDIO_CHG:
+		case PHY_CLEAR_READCOUNT:
+		case PHY_WRITE:
+		case PHY_WRITE_PREVIOUS:
+		case PHY_DELAY_MS:
+			break;
+
+		case PHY_BJMPN:
+			if (regno > index) {
+				netif_err(tp, ifup, tp->dev,
+					  "Out of range of firmware\n");
+				goto out;
+			}
+			break;
+		case PHY_READCOUNT_EQ_SKIP:
+			if (index + 2 >= pa->size) {
+				netif_err(tp, ifup, tp->dev,
+					  "Out of range of firmware\n");
+				goto out;
+			}
+			break;
+		case PHY_COMP_EQ_SKIPN:
+		case PHY_COMP_NEQ_SKIPN:
+		case PHY_SKIPN:
+			if (index + 1 + regno >= pa->size) {
+				netif_err(tp, ifup, tp->dev,
+					  "Out of range of firmware\n");
+				goto out;
+			}
+			break;
+
+		default:
+			netif_err(tp, ifup, tp->dev,
+				  "Invalid action 0x%08x\n", action);
+			goto out;
+		}
+	}
+	rc = true;
+out:
+	return rc;
+}
+
+static int rtl_check_firmware(struct rtl8169_private *tp, struct rtl_fw *rtl_fw)
+{
+	struct net_device *dev = tp->dev;
+	int rc = -EINVAL;
+
+	if (!rtl_fw_format_ok(tp, rtl_fw)) {
+		netif_err(tp, ifup, dev, "invalid firwmare\n");
+		goto out;
+	}
+
+	if (rtl_fw_data_ok(tp, dev, &rtl_fw->phy_action))
+		rc = 0;
+out:
+	return rc;
+}
+
+static void rtl_phy_write_fw(struct rtl8169_private *tp, struct rtl_fw *rtl_fw)
+{
+#if 0
+	struct rtl_fw_phy_action *pa = &rtl_fw->phy_action;
+	struct mdio_ops org, *ops = &tp->mdio_ops;
+	u32 predata, count;
+	size_t index;
+
+	predata = count = 0;
+	org.write = ops->write;
+	org.read = ops->read;
+
+	for (index = 0; index < pa->size; ) {
+		u32 action = le32_to_cpu(pa->code[index]);
+		u32 data = action & 0x0000ffff;
+		u32 regno = (action & 0x0fff0000) >> 16;
+
+		if (!action)
+			break;
+
+		switch(action & 0xf0000000) {
+		case PHY_READ:
+			predata = rtl_readphy(tp, regno);
+			count++;
+			index++;
+			break;
+		case PHY_DATA_OR:
+			predata |= data;
+			index++;
+			break;
+		case PHY_DATA_AND:
+			predata &= data;
+			index++;
+			break;
+		case PHY_BJMPN:
+			index -= regno;
+			break;
+		case PHY_MDIO_CHG:
+			if (data == 0) {
+				ops->write = org.write;
+				ops->read = org.read;
+			} else if (data == 1) {
+				ops->write = mac_mcu_write;
+				ops->read = mac_mcu_read;
+			}
+
+			index++;
+			break;
+		case PHY_CLEAR_READCOUNT:
+			count = 0;
+			index++;
+			break;
+		case PHY_WRITE:
+			rtl_writephy(tp, regno, data);
+			index++;
+			break;
+		case PHY_READCOUNT_EQ_SKIP:
+			index += (count == data) ? 2 : 1;
+			break;
+		case PHY_COMP_EQ_SKIPN:
+			if (predata == data)
+				index += regno;
+			index++;
+			break;
+		case PHY_COMP_NEQ_SKIPN:
+			if (predata != data)
+				index += regno;
+			index++;
+			break;
+		case PHY_WRITE_PREVIOUS:
+			rtl_writephy(tp, regno, predata);
+			index++;
+			break;
+		case PHY_SKIPN:
+			index += regno + 1;
+			break;
+		case PHY_DELAY_MS:
+			mdelay(data);
+			index++;
+			break;
+
+		default:
+			BUG();
+		}
+	}
+
+	ops->write = org.write;
+	ops->read = org.read;
+#endif
+}
+
+static void rtl_release_firmware(struct rtl8169_private *tp)
+{
+	if (!IS_ERR_OR_NULL(tp->rtl_fw)) {
+		release_firmware(tp->rtl_fw->fw);
+		kfree(tp->rtl_fw);
+	}
+	tp->rtl_fw = RTL_FIRMWARE_UNKNOWN;
+}
+
+static void rtl_apply_firmware(struct rtl8169_private *tp)
+{
+	struct rtl_fw *rtl_fw = tp->rtl_fw;
+
+	/* TODO: release firmware once rtl_phy_write_fw signals failures. */
+	if (!IS_ERR_OR_NULL(rtl_fw))
+		rtl_phy_write_fw(tp, rtl_fw);
+}
+
+static void rtl_apply_firmware_cond(struct rtl8169_private *tp, u8 reg, u16 val)
+{
+	if (rtl_readphy(tp, reg) != val)
+		netif_warn(tp, hw, tp->dev, "chipset not ready for firmware\n");
+	else
+		rtl_apply_firmware(tp);
+}
+
+static void rtl8169s_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x06, 0x006e },
+		{ 0x08, 0x0708 },
+		{ 0x15, 0x4000 },
+		{ 0x18, 0x65c7 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x03, 0x00a1 },
+		{ 0x02, 0x0008 },
+		{ 0x01, 0x0120 },
+		{ 0x00, 0x1000 },
+		{ 0x04, 0x0800 },
+		{ 0x04, 0x0000 },
+
+		{ 0x03, 0xff41 },
+		{ 0x02, 0xdf60 },
+		{ 0x01, 0x0140 },
+		{ 0x00, 0x0077 },
+		{ 0x04, 0x7800 },
+		{ 0x04, 0x7000 },
+
+		{ 0x03, 0x802f },
+		{ 0x02, 0x4f02 },
+		{ 0x01, 0x0409 },
+		{ 0x00, 0xf0f9 },
+		{ 0x04, 0x9800 },
+		{ 0x04, 0x9000 },
+
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0xff95 },
+		{ 0x00, 0xba00 },
+		{ 0x04, 0xa800 },
+		{ 0x04, 0xa000 },
+
+		{ 0x03, 0xff41 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0x0140 },
+		{ 0x00, 0x00bb },
+		{ 0x04, 0xb800 },
+		{ 0x04, 0xb000 },
+
+		{ 0x03, 0xdf41 },
+		{ 0x02, 0xdc60 },
+		{ 0x01, 0x6340 },
+		{ 0x00, 0x007d },
+		{ 0x04, 0xd800 },
+		{ 0x04, 0xd000 },
+
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0x100a },
+		{ 0x00, 0xa0ff },
+		{ 0x04, 0xf800 },
+		{ 0x04, 0xf000 },
+
+		{ 0x1f, 0x0000 },
+		{ 0x0b, 0x0000 },
+		{ 0x00, 0x9200 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8169sb_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0002 },
+		{ 0x01, 0x90d0 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8169scd_hw_phy_config_quirk(struct rtl8169_private *tp)
+{
+#if 0
+	struct platform_device *pdev = tp->pdev;
+
+	if ((pdev->subsystem_vendor != PCI_VENDOR_ID_GIGABYTE) ||
+		(pdev->subsystem_device != 0xe000))
+		return;
+
+	rtl_writephy(tp, 0x1f, 0x0001);
+	rtl_writephy(tp, 0x10, 0xf01b);
+	rtl_writephy(tp, 0x1f, 0x0000);
+#endif
+}
+
+static void rtl8169scd_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x04, 0x0000 },
+		{ 0x03, 0x00a1 },
+		{ 0x02, 0x0008 },
+		{ 0x01, 0x0120 },
+		{ 0x00, 0x1000 },
+		{ 0x04, 0x0800 },
+		{ 0x04, 0x9000 },
+		{ 0x03, 0x802f },
+		{ 0x02, 0x4f02 },
+		{ 0x01, 0x0409 },
+		{ 0x00, 0xf099 },
+		{ 0x04, 0x9800 },
+		{ 0x04, 0xa000 },
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0xff95 },
+		{ 0x00, 0xba00 },
+		{ 0x04, 0xa800 },
+		{ 0x04, 0xf000 },
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0x101a },
+		{ 0x00, 0xa0ff },
+		{ 0x04, 0xf800 },
+		{ 0x04, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x10, 0xf41b },
+		{ 0x14, 0xfb54 },
+		{ 0x18, 0xf5c7 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl8169scd_hw_phy_config_quirk(tp);
+}
+
+static void rtl8169sce_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x04, 0x0000 },
+		{ 0x03, 0x00a1 },
+		{ 0x02, 0x0008 },
+		{ 0x01, 0x0120 },
+		{ 0x00, 0x1000 },
+		{ 0x04, 0x0800 },
+		{ 0x04, 0x9000 },
+		{ 0x03, 0x802f },
+		{ 0x02, 0x4f02 },
+		{ 0x01, 0x0409 },
+		{ 0x00, 0xf099 },
+		{ 0x04, 0x9800 },
+		{ 0x04, 0xa000 },
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0xff95 },
+		{ 0x00, 0xba00 },
+		{ 0x04, 0xa800 },
+		{ 0x04, 0xf000 },
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0x101a },
+		{ 0x00, 0xa0ff },
+		{ 0x04, 0xf800 },
+		{ 0x04, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x0b, 0x8480 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x18, 0x67c7 },
+		{ 0x04, 0x2000 },
+		{ 0x03, 0x002f },
+		{ 0x02, 0x4360 },
+		{ 0x01, 0x0109 },
+		{ 0x00, 0x3022 },
+		{ 0x04, 0x2800 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168bb_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x10, 0xf41b },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy(tp, 0x1f, 0x0001);
+	rtl_patchphy(tp, 0x16, 1 << 0);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168bef_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x10, 0xf41b },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168cp_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0000 },
+		{ 0x1d, 0x0f00 },
+		{ 0x1f, 0x0002 },
+		{ 0x0c, 0x1ec8 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168cp_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x1d, 0x3d98 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_patchphy(tp, 0x14, 1 << 5);
+	rtl_patchphy(tp, 0x0d, 1 << 5);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168c_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x12, 0x2300 },
+		{ 0x1f, 0x0002 },
+		{ 0x00, 0x88d4 },
+		{ 0x01, 0x82b1 },
+		{ 0x03, 0x7002 },
+		{ 0x08, 0x9e30 },
+		{ 0x09, 0x01f0 },
+		{ 0x0a, 0x5500 },
+		{ 0x0c, 0x00c8 },
+		{ 0x1f, 0x0003 },
+		{ 0x12, 0xc096 },
+		{ 0x16, 0x000a },
+		{ 0x1f, 0x0000 },
+		{ 0x1f, 0x0000 },
+		{ 0x09, 0x2000 },
+		{ 0x09, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl_patchphy(tp, 0x14, 1 << 5);
+	rtl_patchphy(tp, 0x0d, 1 << 5);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168c_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x12, 0x2300 },
+		{ 0x03, 0x802f },
+		{ 0x02, 0x4f02 },
+		{ 0x01, 0x0409 },
+		{ 0x00, 0xf099 },
+		{ 0x04, 0x9800 },
+		{ 0x04, 0x9000 },
+		{ 0x1d, 0x3d98 },
+		{ 0x1f, 0x0002 },
+		{ 0x0c, 0x7eb8 },
+		{ 0x06, 0x0761 },
+		{ 0x1f, 0x0003 },
+		{ 0x16, 0x0f0a },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl_patchphy(tp, 0x16, 1 << 0);
+	rtl_patchphy(tp, 0x14, 1 << 5);
+	rtl_patchphy(tp, 0x0d, 1 << 5);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168c_3_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x12, 0x2300 },
+		{ 0x1d, 0x3d98 },
+		{ 0x1f, 0x0002 },
+		{ 0x0c, 0x7eb8 },
+		{ 0x06, 0x5461 },
+		{ 0x1f, 0x0003 },
+		{ 0x16, 0x0f0a },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl_patchphy(tp, 0x16, 1 << 0);
+	rtl_patchphy(tp, 0x14, 1 << 5);
+	rtl_patchphy(tp, 0x0d, 1 << 5);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168c_4_hw_phy_config(struct rtl8169_private *tp)
+{
+	rtl8168c_3_hw_phy_config(tp);
+}
+
+static void rtl8168d_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init_0[] = {
+		/* Channel Estimation */
+		{ 0x1f, 0x0001 },
+		{ 0x06, 0x4064 },
+		{ 0x07, 0x2863 },
+		{ 0x08, 0x059c },
+		{ 0x09, 0x26b4 },
+		{ 0x0a, 0x6a19 },
+		{ 0x0b, 0xdcc8 },
+		{ 0x10, 0xf06d },
+		{ 0x14, 0x7f68 },
+		{ 0x18, 0x7fd9 },
+		{ 0x1c, 0xf0ff },
+		{ 0x1d, 0x3d9c },
+		{ 0x1f, 0x0003 },
+		{ 0x12, 0xf49f },
+		{ 0x13, 0x070b },
+		{ 0x1a, 0x05ad },
+		{ 0x14, 0x94c0 },
+
+		/*
+		 * Tx Error Issue
+		 * Enhance line driver power
+		 */
+		{ 0x1f, 0x0002 },
+		{ 0x06, 0x5561 },
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8332 },
+		{ 0x06, 0x5561 },
+
+		/*
+		 * Can not link to 1Gbps with bad cable
+		 * Decrease SNR threshold form 21.07dB to 19.04dB
+		 */
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+
+		{ 0x1f, 0x0000 },
+		{ 0x0d, 0xf880 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init_0, ARRAY_SIZE(phy_reg_init_0));
+
+	/*
+	 * Rx Error Issue
+	 * Fine Tune Switching regulator parameter
+	 */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_w1w0_phy(tp, 0x0b, 0x0010, 0x00ef);
+	rtl_w1w0_phy(tp, 0x0c, 0xa200, 0x5d00);
+
+	if (rtl8168d_efuse_read(tp, 0x01) == 0xb1) {
+		static const struct phy_reg phy_reg_init[] = {
+			{ 0x1f, 0x0002 },
+			{ 0x05, 0x669a },
+			{ 0x1f, 0x0005 },
+			{ 0x05, 0x8330 },
+			{ 0x06, 0x669a },
+			{ 0x1f, 0x0002 }
+		};
+		int val;
+
+		rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+		val = rtl_readphy(tp, 0x0d);
+
+		if ((val & 0x00ff) != 0x006c) {
+			static const u32 set[] = {
+				0x0065, 0x0066, 0x0067, 0x0068,
+				0x0069, 0x006a, 0x006b, 0x006c
+			};
+			int i;
+
+			rtl_writephy(tp, 0x1f, 0x0002);
+
+			val &= 0xff00;
+			for (i = 0; i < ARRAY_SIZE(set); i++)
+				rtl_writephy(tp, 0x0d, val | set[i]);
+		}
+	} else {
+		static const struct phy_reg phy_reg_init[] = {
+			{ 0x1f, 0x0002 },
+			{ 0x05, 0x6662 },
+			{ 0x1f, 0x0005 },
+			{ 0x05, 0x8330 },
+			{ 0x06, 0x6662 }
+		};
+
+		rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+	}
+
+	/* RSET couple improve */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_patchphy(tp, 0x0d, 0x0300);
+	rtl_patchphy(tp, 0x0f, 0x0010);
+
+	/* Fine tune PLL performance */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_w1w0_phy(tp, 0x02, 0x0100, 0x0600);
+	rtl_w1w0_phy(tp, 0x03, 0x0000, 0xe000);
+
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x001b);
+
+	rtl_apply_firmware_cond(tp, MII_EXPANSION, 0xbf00);
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168d_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init_0[] = {
+		/* Channel Estimation */
+		{ 0x1f, 0x0001 },
+		{ 0x06, 0x4064 },
+		{ 0x07, 0x2863 },
+		{ 0x08, 0x059c },
+		{ 0x09, 0x26b4 },
+		{ 0x0a, 0x6a19 },
+		{ 0x0b, 0xdcc8 },
+		{ 0x10, 0xf06d },
+		{ 0x14, 0x7f68 },
+		{ 0x18, 0x7fd9 },
+		{ 0x1c, 0xf0ff },
+		{ 0x1d, 0x3d9c },
+		{ 0x1f, 0x0003 },
+		{ 0x12, 0xf49f },
+		{ 0x13, 0x070b },
+		{ 0x1a, 0x05ad },
+		{ 0x14, 0x94c0 },
+
+		/*
+		 * Tx Error Issue
+		 * Enhance line driver power
+		 */
+		{ 0x1f, 0x0002 },
+		{ 0x06, 0x5561 },
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8332 },
+		{ 0x06, 0x5561 },
+
+		/*
+		 * Can not link to 1Gbps with bad cable
+		 * Decrease SNR threshold form 21.07dB to 19.04dB
+		 */
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+
+		{ 0x1f, 0x0000 },
+		{ 0x0d, 0xf880 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init_0, ARRAY_SIZE(phy_reg_init_0));
+
+	if (rtl8168d_efuse_read(tp, 0x01) == 0xb1) {
+		static const struct phy_reg phy_reg_init[] = {
+			{ 0x1f, 0x0002 },
+			{ 0x05, 0x669a },
+			{ 0x1f, 0x0005 },
+			{ 0x05, 0x8330 },
+			{ 0x06, 0x669a },
+
+			{ 0x1f, 0x0002 }
+		};
+		int val;
+
+		rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+		val = rtl_readphy(tp, 0x0d);
+		if ((val & 0x00ff) != 0x006c) {
+			static const u32 set[] = {
+				0x0065, 0x0066, 0x0067, 0x0068,
+				0x0069, 0x006a, 0x006b, 0x006c
+			};
+			int i;
+
+			rtl_writephy(tp, 0x1f, 0x0002);
+
+			val &= 0xff00;
+			for (i = 0; i < ARRAY_SIZE(set); i++)
+				rtl_writephy(tp, 0x0d, val | set[i]);
+		}
+	} else {
+		static const struct phy_reg phy_reg_init[] = {
+			{ 0x1f, 0x0002 },
+			{ 0x05, 0x2642 },
+			{ 0x1f, 0x0005 },
+			{ 0x05, 0x8330 },
+			{ 0x06, 0x2642 }
+		};
+
+		rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+	}
+
+	/* Fine tune PLL performance */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_w1w0_phy(tp, 0x02, 0x0100, 0x0600);
+	rtl_w1w0_phy(tp, 0x03, 0x0000, 0xe000);
+
+	/* Switching regulator Slew rate */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_patchphy(tp, 0x0f, 0x0017);
+
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x001b);
+
+	rtl_apply_firmware_cond(tp, MII_EXPANSION, 0xb300);
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168d_3_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0002 },
+		{ 0x10, 0x0008 },
+		{ 0x0d, 0x006c },
+
+		{ 0x1f, 0x0000 },
+		{ 0x0d, 0xf880 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x0b, 0xa4d8 },
+		{ 0x09, 0x281c },
+		{ 0x07, 0x2883 },
+		{ 0x0a, 0x6b35 },
+		{ 0x1d, 0x3da4 },
+		{ 0x1c, 0xeffd },
+		{ 0x14, 0x7f52 },
+		{ 0x18, 0x7fc6 },
+		{ 0x08, 0x0601 },
+		{ 0x06, 0x4063 },
+		{ 0x10, 0xf074 },
+		{ 0x1f, 0x0003 },
+		{ 0x13, 0x0789 },
+		{ 0x12, 0xf4bd },
+		{ 0x1a, 0x04fd },
+		{ 0x14, 0x84b0 },
+		{ 0x1f, 0x0000 },
+		{ 0x00, 0x9200 },
+
+		{ 0x1f, 0x0005 },
+		{ 0x01, 0x0340 },
+		{ 0x1f, 0x0001 },
+		{ 0x04, 0x4000 },
+		{ 0x03, 0x1d21 },
+		{ 0x02, 0x0c32 },
+		{ 0x01, 0x0200 },
+		{ 0x00, 0x5554 },
+		{ 0x04, 0x4800 },
+		{ 0x04, 0x4000 },
+		{ 0x04, 0xf000 },
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0x101a },
+		{ 0x00, 0xa0ff },
+		{ 0x04, 0xf800 },
+		{ 0x04, 0xf000 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x0023 },
+		{ 0x16, 0x0000 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168d_4_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x002d },
+		{ 0x18, 0x0040 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+	rtl_patchphy(tp, 0x0d, 1 << 5);
+}
+
+static void rtl8168e_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		/* Enable Delay cap */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b80 },
+		{ 0x06, 0xc896 },
+		{ 0x1f, 0x0000 },
+
+		/* Channel estimation fine tune */
+		{ 0x1f, 0x0001 },
+		{ 0x0b, 0x6c20 },
+		{ 0x07, 0x2872 },
+		{ 0x1c, 0xefff },
+		{ 0x1f, 0x0003 },
+		{ 0x14, 0x6420 },
+		{ 0x1f, 0x0000 },
+
+		/* Update PFM & 10M TX idle timer */
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x002f },
+		{ 0x15, 0x1919 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x00ac },
+		{ 0x18, 0x0006 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_apply_firmware(tp);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	/* DCO enable for 10M IDLE Power */
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x0023);
+	rtl_w1w0_phy(tp, 0x17, 0x0006, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* For impedance matching */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_w1w0_phy(tp, 0x08, 0x8000, 0x7f00);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* PHY auto speed down */
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x002d);
+	rtl_w1w0_phy(tp, 0x18, 0x0050, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_w1w0_phy(tp, 0x14, 0x8000, 0x0000);
+
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b86);
+	rtl_w1w0_phy(tp, 0x06, 0x0001, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x2000);
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x0020);
+	rtl_w1w0_phy(tp, 0x15, 0x0000, 0x1100);
+	rtl_writephy(tp, 0x1f, 0x0006);
+	rtl_writephy(tp, 0x00, 0x5a00);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0007);
+	rtl_writephy(tp, 0x0e, 0x003c);
+	rtl_writephy(tp, 0x0d, 0x4007);
+	rtl_writephy(tp, 0x0e, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0000);
+}
+
+static void rtl_rar_exgmac_set(struct rtl8169_private *tp, u8 *addr)
+{
+	const u16 w[] = {
+		addr[0] | (addr[1] << 8),
+		addr[2] | (addr[3] << 8),
+		addr[4] | (addr[5] << 8)
+	};
+	const struct exgmac_reg e[] = {
+		{ .addr = 0xe0, ERIAR_MASK_1111, .val = w[0] | (w[1] << 16) },
+		{ .addr = 0xe4, ERIAR_MASK_1111, .val = w[2] },
+		{ .addr = 0xf0, ERIAR_MASK_1111, .val = w[0] << 16 },
+		{ .addr = 0xf4, ERIAR_MASK_1111, .val = w[1] | (w[2] << 16) }
+	};
+
+	rtl_write_exgmac_batch(tp, e, ARRAY_SIZE(e));
+}
+
+static void rtl8168e_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		/* Enable Delay cap */
+		{ 0x1f, 0x0004 },
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x00ac },
+		{ 0x18, 0x0006 },
+		{ 0x1f, 0x0002 },
+		{ 0x1f, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		/* Channel estimation fine tune */
+		{ 0x1f, 0x0003 },
+		{ 0x09, 0xa20f },
+		{ 0x1f, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		/* Green Setting */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b5b },
+		{ 0x06, 0x9222 },
+		{ 0x05, 0x8b6d },
+		{ 0x06, 0x8000 },
+		{ 0x05, 0x8b76 },
+		{ 0x06, 0x8000 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_apply_firmware(tp);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	/* For 4-corner performance improve */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b80);
+	rtl_w1w0_phy(tp, 0x17, 0x0006, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* PHY auto speed down */
+	rtl_writephy(tp, 0x1f, 0x0004);
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x002d);
+	rtl_w1w0_phy(tp, 0x18, 0x0010, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_w1w0_phy(tp, 0x14, 0x8000, 0x0000);
+
+	/* improve 10M EEE waveform */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b86);
+	rtl_w1w0_phy(tp, 0x06, 0x0001, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* Improve 2-pair detection performance */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x4000, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* EEE setting */
+	rtl_w1w0_eri(tp, 0x1b0, ERIAR_MASK_1111, 0x0000, 0x0003, ERIAR_EXGMAC);
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x2000);
+	rtl_writephy(tp, 0x1f, 0x0004);
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x0020);
+	rtl_w1w0_phy(tp, 0x15, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0007);
+	rtl_writephy(tp, 0x0e, 0x003c);
+	rtl_writephy(tp, 0x0d, 0x4007);
+	rtl_writephy(tp, 0x0e, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0000);
+
+	/* Green feature */
+	rtl_writephy(tp, 0x1f, 0x0003);
+	rtl_w1w0_phy(tp, 0x19, 0x0000, 0x0001);
+	rtl_w1w0_phy(tp, 0x10, 0x0000, 0x0400);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* Broken BIOS workaround: feed GigaMAC registers with MAC address. */
+	rtl_rar_exgmac_set(tp, tp->dev->dev_addr);
+}
+
+static void rtl8168f_hw_phy_config(struct rtl8169_private *tp)
+{
+	/* For 4-corner performance improve */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b80);
+	rtl_w1w0_phy(tp, 0x06, 0x0006, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* PHY auto speed down */
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x002d);
+	rtl_w1w0_phy(tp, 0x18, 0x0010, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_w1w0_phy(tp, 0x14, 0x8000, 0x0000);
+
+	/* Improve 10M EEE waveform */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b86);
+	rtl_w1w0_phy(tp, 0x06, 0x0001, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168f_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		/* Channel estimation fine tune */
+		{ 0x1f, 0x0003 },
+		{ 0x09, 0xa20f },
+		{ 0x1f, 0x0000 },
+
+		/* Modify green table for giga & fnet */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b55 },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b5e },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b67 },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b70 },
+		{ 0x06, 0x0000 },
+		{ 0x1f, 0x0000 },
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x0078 },
+		{ 0x17, 0x0000 },
+		{ 0x19, 0x00fb },
+		{ 0x1f, 0x0000 },
+
+		/* Modify green table for 10M */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b79 },
+		{ 0x06, 0xaa00 },
+		{ 0x1f, 0x0000 },
+
+		/* Disable hiimpedance detection (RTCT) */
+		{ 0x1f, 0x0003 },
+		{ 0x01, 0x328a },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_apply_firmware(tp);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl8168f_hw_phy_config(tp);
+
+	/* Improve 2-pair detection performance */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x4000, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168f_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	rtl_apply_firmware(tp);
+
+	rtl8168f_hw_phy_config(tp);
+}
+
+static void rtl8411_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		/* Channel estimation fine tune */
+		{ 0x1f, 0x0003 },
+		{ 0x09, 0xa20f },
+		{ 0x1f, 0x0000 },
+
+		/* Modify green table for giga & fnet */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b55 },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b5e },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b67 },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b70 },
+		{ 0x06, 0x0000 },
+		{ 0x1f, 0x0000 },
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x0078 },
+		{ 0x17, 0x0000 },
+		{ 0x19, 0x00aa },
+		{ 0x1f, 0x0000 },
+
+		/* Modify green table for 10M */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b79 },
+		{ 0x06, 0xaa00 },
+		{ 0x1f, 0x0000 },
+
+		/* Disable hiimpedance detection (RTCT) */
+		{ 0x1f, 0x0003 },
+		{ 0x01, 0x328a },
+		{ 0x1f, 0x0000 }
+	};
+
+
+	rtl_apply_firmware(tp);
+
+	rtl8168f_hw_phy_config(tp);
+
+	/* Improve 2-pair detection performance */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x4000, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	/* Modify green table for giga */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b54);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0800);
+	rtl_writephy(tp, 0x05, 0x8b5d);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0800);
+	rtl_writephy(tp, 0x05, 0x8a7c);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x05, 0x8a7f);
+	rtl_w1w0_phy(tp, 0x06, 0x0100, 0x0000);
+	rtl_writephy(tp, 0x05, 0x8a82);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x05, 0x8a85);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x05, 0x8a88);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* uc same-seed solution */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x8000, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* eee setting */
+	rtl_w1w0_eri(tp, 0x1b0, ERIAR_MASK_0001, 0x00, 0x03, ERIAR_EXGMAC);
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x2000);
+	rtl_writephy(tp, 0x1f, 0x0004);
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x0020);
+	rtl_w1w0_phy(tp, 0x15, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0007);
+	rtl_writephy(tp, 0x0e, 0x003c);
+	rtl_writephy(tp, 0x0d, 0x4007);
+	rtl_writephy(tp, 0x0e, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0000);
+
+	/* Green feature */
+	rtl_writephy(tp, 0x1f, 0x0003);
+	rtl_w1w0_phy(tp, 0x19, 0x0000, 0x0001);
+	rtl_w1w0_phy(tp, 0x10, 0x0000, 0x0400);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168g_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	rtl_apply_firmware(tp);
+
+	rtl_writephy(tp, 0x1f, 0x0a46);
+	if (rtl_readphy(tp, 0x10) & 0x0100) {
+		rtl_writephy(tp, 0x1f, 0x0bcc);
+		rtl_w1w0_phy(tp, 0x12, 0x0000, 0x8000);
+	} else {
+		rtl_writephy(tp, 0x1f, 0x0bcc);
+		rtl_w1w0_phy(tp, 0x12, 0x8000, 0x0000);
+	}
+
+	rtl_writephy(tp, 0x1f, 0x0a46);
+	if (rtl_readphy(tp, 0x13) & 0x0100) {
+		rtl_writephy(tp, 0x1f, 0x0c41);
+		rtl_w1w0_phy(tp, 0x15, 0x0002, 0x0000);
+	} else {
+		rtl_writephy(tp, 0x1f, 0x0c41);
+		rtl_w1w0_phy(tp, 0x15, 0x0000, 0x0002);
+	}
+
+	/* Enable PHY auto speed down */
+	rtl_writephy(tp, 0x1f, 0x0a44);
+	rtl_w1w0_phy(tp, 0x11, 0x000c, 0x0000);
+
+	rtl_writephy(tp, 0x1f, 0x0bcc);
+	rtl_w1w0_phy(tp, 0x14, 0x0100, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0a44);
+	rtl_w1w0_phy(tp, 0x11, 0x00c0, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0a43);
+	rtl_writephy(tp, 0x13, 0x8084);
+	rtl_w1w0_phy(tp, 0x14, 0x0000, 0x6000);
+	rtl_w1w0_phy(tp, 0x10, 0x1003, 0x0000);
+
+	/* EEE auto-fallback function */
+	rtl_writephy(tp, 0x1f, 0x0a4b);
+	rtl_w1w0_phy(tp, 0x11, 0x0004, 0x0000);
+
+	/* Enable UC LPF tune function */
+	rtl_writephy(tp, 0x1f, 0x0a43);
+	rtl_writephy(tp, 0x13, 0x8012);
+	rtl_w1w0_phy(tp, 0x14, 0x8000, 0x0000);
+
+	rtl_writephy(tp, 0x1f, 0x0c42);
+	rtl_w1w0_phy(tp, 0x11, 0x4000, 0x2000);
+
+	/* Improve SWR Efficiency */
+	rtl_writephy(tp, 0x1f, 0x0bcd);
+	rtl_writephy(tp, 0x14, 0x5065);
+	rtl_writephy(tp, 0x14, 0xd065);
+	rtl_writephy(tp, 0x1f, 0x0bc8);
+	rtl_writephy(tp, 0x11, 0x5655);
+	rtl_writephy(tp, 0x1f, 0x0bcd);
+	rtl_writephy(tp, 0x14, 0x1065);
+	rtl_writephy(tp, 0x14, 0x9065);
+	rtl_writephy(tp, 0x14, 0x1065);
+
+	/* Check ALDPS bit, disable it if enabled */
+	rtl_writephy(tp, 0x1f, 0x0a43);
+	if (rtl_readphy(tp, 0x10) & 0x0004)
+		rtl_w1w0_phy(tp, 0x10, 0x0000, 0x0004);
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168g_2_hw_mac_mcu_patch(struct rtl8169_private *tp)
+{
+	#if defined(CONFIG_ARCH_RTD129x)
+	unsigned int tmp;
+	unsigned int cpu_revision;
+	void __iomem *rgmii0_addr, *tmp_addr;
+	#endif /* CONFIG_ARCH_RTD129x */
+
+	MDIO_LOCK;
+	/* power down PHY */
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_patchphy(tp, MII_BMCR, BMCR_PDOWN);
+	MDIO_UNLOCK;
+
+	#if defined(CONFIG_ARCH_RTD129x)
+	// mac mcu patch from Tenno to support EEE/EEE+
+	cpu_revision = get_rtd_chip_revision();
+	if ((cpu_revision == RTD_CHIP_A00) ||
+		(cpu_revision == RTD_CHIP_A01) ||
+		(cpu_revision >= RTD_CHIP_B00)) {
+		// disable break point
+		r8169soc_ocp_reg_write(tp, 0xfc28, 0);
+		r8169soc_ocp_reg_write(tp, 0xfc2a, 0);
+		r8169soc_ocp_reg_write(tp, 0xfc2c, 0);
+		r8169soc_ocp_reg_write(tp, 0xfc2e, 0);
+		r8169soc_ocp_reg_write(tp, 0xfc30, 0);
+		r8169soc_ocp_reg_write(tp, 0xfc32, 0);
+		r8169soc_ocp_reg_write(tp, 0xfc34, 0);
+		r8169soc_ocp_reg_write(tp, 0xfc36, 0);
+		mdelay(3);
+
+		// disable base address
+		r8169soc_ocp_reg_write(tp, 0xfc26, 0);
+
+		// patch code
+		r8169soc_ocp_reg_write(tp, 0xf800, 0xE008);
+		r8169soc_ocp_reg_write(tp, 0xf802, 0xE012);
+		r8169soc_ocp_reg_write(tp, 0xf804, 0xE044);
+		r8169soc_ocp_reg_write(tp, 0xf806, 0xE046);
+		r8169soc_ocp_reg_write(tp, 0xf808, 0xE048);
+		r8169soc_ocp_reg_write(tp, 0xf80a, 0xE04A);
+		r8169soc_ocp_reg_write(tp, 0xf80c, 0xE04C);
+		r8169soc_ocp_reg_write(tp, 0xf80e, 0xE04E);
+		r8169soc_ocp_reg_write(tp, 0xf810, 0x44E3);
+		r8169soc_ocp_reg_write(tp, 0xf812, 0xC708);
+		r8169soc_ocp_reg_write(tp, 0xf814, 0x75E0);
+		r8169soc_ocp_reg_write(tp, 0xf816, 0x485D);
+		r8169soc_ocp_reg_write(tp, 0xf818, 0x9DE0);
+		r8169soc_ocp_reg_write(tp, 0xf81a, 0xC705);
+		r8169soc_ocp_reg_write(tp, 0xf81c, 0xC502);
+		r8169soc_ocp_reg_write(tp, 0xf81e, 0xBD00);
+		r8169soc_ocp_reg_write(tp, 0xf820, 0x01EE);
+		r8169soc_ocp_reg_write(tp, 0xf822, 0xE85A);
+		r8169soc_ocp_reg_write(tp, 0xf824, 0xE000);
+		r8169soc_ocp_reg_write(tp, 0xf826, 0xC72D);
+		r8169soc_ocp_reg_write(tp, 0xf828, 0x76E0);
+		r8169soc_ocp_reg_write(tp, 0xf82a, 0x49ED);
+		r8169soc_ocp_reg_write(tp, 0xf82c, 0xF026);
+		r8169soc_ocp_reg_write(tp, 0xf82e, 0xC02A);
+		r8169soc_ocp_reg_write(tp, 0xf830, 0x7400);
+		r8169soc_ocp_reg_write(tp, 0xf832, 0xC526);
+		r8169soc_ocp_reg_write(tp, 0xf834, 0xC228);
+		r8169soc_ocp_reg_write(tp, 0xf836, 0x9AA0);
+		r8169soc_ocp_reg_write(tp, 0xf838, 0x73A2);
+		r8169soc_ocp_reg_write(tp, 0xf83a, 0x49BE);
+		r8169soc_ocp_reg_write(tp, 0xf83c, 0xF11E);
+		r8169soc_ocp_reg_write(tp, 0xf83e, 0xC324);
+		r8169soc_ocp_reg_write(tp, 0xf840, 0x9BA2);
+		r8169soc_ocp_reg_write(tp, 0xf842, 0x73A2);
+		r8169soc_ocp_reg_write(tp, 0xf844, 0x49BE);
+		r8169soc_ocp_reg_write(tp, 0xf846, 0xF0FE);
+		r8169soc_ocp_reg_write(tp, 0xf848, 0x73A2);
+		r8169soc_ocp_reg_write(tp, 0xf84a, 0x49BE);
+		r8169soc_ocp_reg_write(tp, 0xf84c, 0xF1FE);
+		r8169soc_ocp_reg_write(tp, 0xf84e, 0x1A02);
+		r8169soc_ocp_reg_write(tp, 0xf850, 0x49C9);
+		r8169soc_ocp_reg_write(tp, 0xf852, 0xF003);
+		r8169soc_ocp_reg_write(tp, 0xf854, 0x4821);
+		r8169soc_ocp_reg_write(tp, 0xf856, 0xE002);
+		r8169soc_ocp_reg_write(tp, 0xf858, 0x48A1);
+		r8169soc_ocp_reg_write(tp, 0xf85a, 0x73A2);
+		r8169soc_ocp_reg_write(tp, 0xf85c, 0x49BE);
+		r8169soc_ocp_reg_write(tp, 0xf85e, 0xF10D);
+		r8169soc_ocp_reg_write(tp, 0xf860, 0xC313);
+		r8169soc_ocp_reg_write(tp, 0xf862, 0x9AA0);
+		r8169soc_ocp_reg_write(tp, 0xf864, 0xC312);
+		r8169soc_ocp_reg_write(tp, 0xf866, 0x9BA2);
+		r8169soc_ocp_reg_write(tp, 0xf868, 0x73A2);
+		r8169soc_ocp_reg_write(tp, 0xf86a, 0x49BE);
+		r8169soc_ocp_reg_write(tp, 0xf86c, 0xF0FE);
+		r8169soc_ocp_reg_write(tp, 0xf86e, 0x73A2);
+		r8169soc_ocp_reg_write(tp, 0xf870, 0x49BE);
+		r8169soc_ocp_reg_write(tp, 0xf872, 0xF1FE);
+		r8169soc_ocp_reg_write(tp, 0xf874, 0x48ED);
+		r8169soc_ocp_reg_write(tp, 0xf876, 0x9EE0);
+		r8169soc_ocp_reg_write(tp, 0xf878, 0xC602);
+		r8169soc_ocp_reg_write(tp, 0xf87a, 0xBE00);
+		r8169soc_ocp_reg_write(tp, 0xf87c, 0x0532);
+		r8169soc_ocp_reg_write(tp, 0xf87e, 0xDE00);
+		r8169soc_ocp_reg_write(tp, 0xf880, 0xE85A);
+		r8169soc_ocp_reg_write(tp, 0xf882, 0xE086);
+		r8169soc_ocp_reg_write(tp, 0xf884, 0x0A44);
+		r8169soc_ocp_reg_write(tp, 0xf886, 0x801F);
+		r8169soc_ocp_reg_write(tp, 0xf888, 0x8015);
+		r8169soc_ocp_reg_write(tp, 0xf88a, 0x0015);
+		r8169soc_ocp_reg_write(tp, 0xf88c, 0xC602);
+		r8169soc_ocp_reg_write(tp, 0xf88e, 0xBE00);
+		r8169soc_ocp_reg_write(tp, 0xf890, 0x0000);
+		r8169soc_ocp_reg_write(tp, 0xf892, 0xC602);
+		r8169soc_ocp_reg_write(tp, 0xf894, 0xBE00);
+		r8169soc_ocp_reg_write(tp, 0xf896, 0x0000);
+		r8169soc_ocp_reg_write(tp, 0xf898, 0xC602);
+		r8169soc_ocp_reg_write(tp, 0xf89a, 0xBE00);
+		r8169soc_ocp_reg_write(tp, 0xf89c, 0x0000);
+		r8169soc_ocp_reg_write(tp, 0xf89e, 0xC602);
+		r8169soc_ocp_reg_write(tp, 0xf8a0, 0xBE00);
+		r8169soc_ocp_reg_write(tp, 0xf8a2, 0x0000);
+		r8169soc_ocp_reg_write(tp, 0xf8a4, 0xC602);
+		r8169soc_ocp_reg_write(tp, 0xf8a6, 0xBE00);
+		r8169soc_ocp_reg_write(tp, 0xf8a8, 0x0000);
+		r8169soc_ocp_reg_write(tp, 0xf8aa, 0xC602);
+		r8169soc_ocp_reg_write(tp, 0xf8ac, 0xBE00);
+		r8169soc_ocp_reg_write(tp, 0xf8ae, 0x0000);
+
+		// enable base address
+		r8169soc_ocp_reg_write(tp, 0xfc26, 0x8000);
+
+		// enable breakpoint
+		r8169soc_ocp_reg_write(tp, 0xfc28, 0x01ED);
+		r8169soc_ocp_reg_write(tp, 0xfc2a, 0x0531);
+
+		if (tp->eee_enable) {
+			/* EEE MAC mode */
+			r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) | (BIT(1) | BIT(0))));
+			/* EEE+ MAC mode */
+			r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) | BIT(1)));
+		}
+	}
+
+	if ((cpu_revision >= RTD_CHIP_B00)) {
+		if (tp->output_mode == OUTPUT_EMBEDDED_PHY) {
+			tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(0) | BIT(1));
+			tmp |= BIT(1); // MII
+			r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+		} else { /* RGMII */
+			if (tp->output_mode == OUTPUT_RGMII_TO_PHY) {
+				//# ETN spec, MDC freq=2.5MHz
+				r8169soc_ocp_reg_write(tp, 0xde30, (r8169soc_ocp_reg_read(tp, 0xde30) & ~(BIT(6) | BIT(7))));
+				//# ETN spec, set external PHY addr
+				r8169soc_ocp_reg_write(tp, 0xde24,
+					(r8169soc_ocp_reg_read(tp, 0xde24) & ~(0x1F)) | (tp->ext_phy_id & 0x1F));
+			}
+
+			tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(0) | BIT(1));
+			tmp |= BIT(0); // RGMII
+
+			if (tp->output_mode == OUTPUT_RGMII_TO_MAC) {
+				tmp &= ~(BIT(3) | BIT(4));
+				tmp |= BIT(4); // speed: 1G
+				tmp |= BIT(2); // full duplex
+			}
+			if (tp->rgmii_rx_delay == RGMII_DELAY_0NS)
+				tmp &= ~BIT(6);
+			else
+				tmp |= BIT(6);
+
+			if (tp->rgmii_tx_delay == RGMII_DELAY_0NS)
+				tmp &= ~BIT(7);
+			else
+				tmp |= BIT(7);
+
+			r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+			/* adjust RGMII voltage */
+			rgmii0_addr = ioremap(RGMII0_PAD_CTRL_ADDR, 12);
+			switch(tp->rgmii_voltage) {
+			case VOLTAGE_1_DOT_8V:
+				writel(0, rgmii0_addr);
+				writel(0x44444444, rgmii0_addr + 4);
+				writel(0x24444444, rgmii0_addr + 8);
+				break;
+			case VOLTAGE_2_DOT_5V:
+				writel(0, rgmii0_addr);
+				writel(0x44444444, rgmii0_addr + 4);
+				writel(0x64444444, rgmii0_addr + 8);
+				break;
+			case VOLTAGE_3_DOT_3V:
+				writel(0x3F, rgmii0_addr);
+				writel(0, rgmii0_addr + 4);
+				writel(0xA4000000, rgmii0_addr + 8);
+			}
+			__iounmap(rgmii0_addr);
+
+			/* switch RGMII/MDIO to GMAC */
+			tmp_addr = ioremap(ISO_RGMII_MDIO_TO_GMAC, 4);
+			writel((readl(tmp_addr) | BIT(1)), tmp_addr);
+			__iounmap(tmp_addr);
+
+			if (tp->output_mode == OUTPUT_RGMII_TO_MAC) {
+				/* force GMAC link up */
+				r8169soc_ocp_reg_write(tp, 0xde40, 0x30EC);
+				/* ignore mac_intr from PHY */
+				r8169soc_ocp_reg_write(tp, 0xfc1e, (r8169soc_ocp_reg_read(tp, 0xfc1e) & ~BIT(1)));
+			}
+		}
+	}
+	#endif /* CONFIG_ARCH_RTD129x */
+
+}
+
+static void rtl8168g_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* set dis_mcu_clroob to avoid WOL fail when ALDPS mode is enabled */
+	RTL_W8(MCU, RTL_R8(MCU) | DIS_MCU_CLROOB);
+	#if defined(CONFIG_ARCH_RTD129x)
+	MDIO_LOCK;
+	/* enable ALDPS mode */
+	rtl_writephy(tp, 0x1f, 0x0a43);
+	rtl_w1w0_phy(tp, 0x18, BIT(2), BIT(12) | BIT(1) | BIT(0));
+
+	/* enable EEE of 10Mbps */
+	rtl_writephy(tp, 0x1f, 0x0a43);
+	rtl_patchphy(tp, 0x19, (1 << 4));
+	MDIO_UNLOCK;
+	#elif defined(CONFIG_ARCH_RTD139x)
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x */
+
+	//	rtl_apply_firmware(tp);
+	// gphy patch from Riri   	add by yukuen
+/*	if (soc_is_rtk1195()) {
+		if ((realtek_rev() == RTK1195_REV_A)) {
+			// disable green
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x8011);
+			rtl_writephy(tp, 0x1c, 0x1737);   //disable green
+
+			rtl_writephy(tp, 0x1f, 0x0BCC);
+			rtl_writephy(tp, 0x11, 0x4444);	  //write abiq /ldvbias
+
+			// R/ RC auto k
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x8013);
+			rtl_writephy(tp, 0x1c, 0x0F08);   //default ff08  disable auto k RC/R
+
+			rtl_writephy(tp, 0x1f, 0x0BCE);   //force tapbin = 4
+			rtl_writephy(tp, 0x10, 0x4444);
+
+			rtl_writephy(tp, 0x1f, 0x0BCD);
+			rtl_writephy(tp, 0x17, 0x8888);		//tx rc
+			rtl_writephy(tp, 0x16, 0x9999);		//rx rc
+
+			// increase sd thd
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x8101);
+			rtl_writephy(tp, 0x1c, 0x3E00);   //master sd  : 0x1e00
+
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x80E2);
+			rtl_writephy(tp, 0x1c, 0x3E00);   //default sd  : 0x0e00
+
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x8120);
+			rtl_writephy(tp, 0x1c, 0x3E00);   //slave sd  : 0x0e00
+		}
+		else {	// REV_B
+			//#GDAC updown
+			rtl_writephy(tp, 0x1f, 0x0BCC);
+			rtl_writephy(tp, 0x12, 0x00BE);
+
+			//R_RC
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x81DE);
+			rtl_writephy(tp, 0x1c, 0xFDFE);     //#  fbfe [15:8] tapbin tx -3 #  [7:0] tapbin rx -2
+
+			rtl_writephy(tp, 0x1b, 0x81E0);
+			rtl_writephy(tp, 0x1c, 0xFDFF);     //#  [15:8] rlen  -3
+
+			rtl_writephy(tp, 0x1b, 0x81E2);
+			rtl_writephy(tp, 0x1c, 0x0400);     //#  [15:8] rlen_100 +4, -3+4=1
+			rtl_writephy(tp, 0x1b, 0x80d3);
+			rtl_writephy(tp, 0x1c, 0x04a4);     //# fnet cable length constant 0aa4
+
+			rtl_writephy(tp, 0x1b, 0x8111);
+			rtl_writephy(tp, 0x1c, 0x0a7f);     //# slave cable length constant fa7f
+
+			rtl_writephy(tp, 0x1b, 0x810d);
+			rtl_writephy(tp, 0x1c, 0x5604);     //# slave const dagc 0606
+
+			rtl_writephy(tp, 0x1b, 0x80f4);
+			rtl_writephy(tp, 0x1c, 0x5df7);     //# master cable length delta 3df7
+
+			rtl_writephy(tp, 0x1b, 0x80f2);
+			rtl_writephy(tp, 0x1c, 0x0a8f);     //# master cable length constant fa8f
+
+			rtl_writephy(tp, 0x1b, 0x80f6);
+			rtl_writephy(tp, 0x1c, 0x54ca);     //# master delta dagc 63ca
+
+			rtl_writephy(tp, 0x1b, 0x80ec);
+			rtl_writephy(tp, 0x1c, 0x007c);     //# master aagc 146c
+
+			//disble ALDPS interrupt
+			rtl_writephy(tp, 0x1f, 0x0a42);
+			rtl_writephy(tp, 0x12, rtl_readphy(tp, 0x12) & ~BIT(9));
+
+			//enable ALDPS
+			rtl_writephy(tp, 0x1f, 0x0a43);
+			rtl_writephy(tp, 0x10, rtl_readphy(tp, 0x10) | BIT(2));
+		}
+	}*/
+}
+
+static void rtl8102e_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0003 },
+		{ 0x08, 0x441d },
+		{ 0x01, 0x9100 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_patchphy(tp, 0x11, 1 << 12);
+	rtl_patchphy(tp, 0x19, 1 << 13);
+	rtl_patchphy(tp, 0x10, 1 << 15);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8105e_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0005 },
+		{ 0x1a, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0004 },
+		{ 0x1c, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x15, 0x7701 },
+		{ 0x1f, 0x0000 }
+	};
+
+	/* Disable ALDPS before ram code */
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x18, 0x0310);
+	msleep(100);
+
+	rtl_apply_firmware(tp);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8402_hw_phy_config(struct rtl8169_private *tp)
+{
+	/* Disable ALDPS before setting firmware */
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x18, 0x0310);
+	msleep(20);
+
+	rtl_apply_firmware(tp);
+
+	/* EEE setting */
+	rtl_eri_write(tp, 0x1b0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_writephy(tp, 0x1f, 0x0004);
+	rtl_writephy(tp, 0x10, 0x401f);
+	rtl_writephy(tp, 0x19, 0x7030);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8106e_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0004 },
+		{ 0x10, 0xc07f },
+		{ 0x19, 0x7030 },
+		{ 0x1f, 0x0000 }
+	};
+
+	/* Disable ALDPS before ram code */
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x18, 0x0310);
+	msleep(100);
+
+	rtl_apply_firmware(tp);
+
+	rtl_eri_write(tp, 0x1b0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl_eri_write(tp, 0x1d0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+}
+
+static void rtl_hw_phy_config(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl8169_print_mac_version(tp);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_01:
+		break;
+	case RTL_GIGA_MAC_VER_02:
+	case RTL_GIGA_MAC_VER_03:
+		rtl8169s_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_04:
+		rtl8169sb_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_05:
+		rtl8169scd_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_06:
+		rtl8169sce_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_07:
+	case RTL_GIGA_MAC_VER_08:
+	case RTL_GIGA_MAC_VER_09:
+		rtl8102e_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_11:
+		rtl8168bb_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_12:
+		rtl8168bef_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_17:
+		rtl8168bef_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_18:
+		rtl8168cp_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_19:
+		rtl8168c_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_20:
+		rtl8168c_2_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_21:
+		rtl8168c_3_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_22:
+		rtl8168c_4_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+		rtl8168cp_2_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_25:
+		rtl8168d_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_26:
+		rtl8168d_2_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_27:
+		rtl8168d_3_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_28:
+		rtl8168d_4_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_29:
+	case RTL_GIGA_MAC_VER_30:
+		rtl8105e_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_31:
+		/* None. */
+		break;
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+		rtl8168e_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_34:
+		rtl8168e_2_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_35:
+		rtl8168f_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_36:
+		rtl8168f_2_hw_phy_config(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_37:
+		rtl8402_hw_phy_config(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_38:
+		rtl8411_hw_phy_config(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_39:
+		rtl8106e_hw_phy_config(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_40:
+		rtl8168g_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+		rtl8168g_2_hw_mac_mcu_patch(tp);
+		rtl8168g_2_hw_phy_config(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_41:
+	default:
+		break;
+	}
+}
+
+static void rtl_schedule_task(struct rtl8169_private *tp, enum rtl_flag flag)
+{
+	if (!test_and_set_bit(flag, tp->wk.flags))
+		schedule_work(&tp->wk.work);
+}
+
+static void rtl_rar_set(struct rtl8169_private *tp, u8 *addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	rtl_lock_work(tp);
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	RTL_W32(MAC4, addr[4] | addr[5] << 8);
+	RTL_R32(MAC4);
+
+	RTL_W32(MAC0, addr[0] | addr[1] << 8 | addr[2] << 16 | addr[3] << 24);
+	RTL_R32(MAC0);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_34)
+		rtl_rar_exgmac_set(tp, addr);
+
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	rtl_unlock_work(tp);
+}
+
+static void rtl_phy_reinit(struct rtl8169_private *tp)
+{
+	u32 tmp;
+
+	MDIO_LOCK;
+
+	/* fill fuse_rdy & rg_ext_ini_done */
+	r8169_mdio_write(tp, 31, 0x0a46);
+	r8169_mdio_write(tp, 20,
+		(r8169_mdio_read(tp, 20) | (BIT(1) | BIT(0))));
+
+	/* init_autoload_done = 1 */
+	tmp = r8169soc_ocp_reg_read(tp, 0xe004);
+	tmp |= BIT(7);
+	r8169soc_ocp_reg_write(tp, 0xe004, tmp);
+
+	/* wait LAN-ON */
+	r8169_mdio_write(tp, 31, 0x0a42);
+	tmp = 0;
+	do {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 2000) {
+			pr_err("PHY status is not 0x3, current = 0x%02x\n",
+				(r8169_mdio_read(tp, 16) & 0x07));
+			break;
+		}
+	} while (0x3 != (r8169_mdio_read(tp, 16) & 0x07));
+	pr_info("wait %d ms for PHY ready, current = 0x%x\n",
+		tmp, r8169_mdio_read(tp, 16));
+
+	MDIO_UNLOCK;
+
+	tp->phy_reset_enable(tp);
+}
+
+static void rtl_phy_work(struct rtl8169_private *tp)
+{
+	rtl_phy_reinit(tp);
+	atomic_dec(&tp->phy_reinit_flag);
+	return;
+/*	struct timer_list *timer = &tp->timer;
+	void __iomem *ioaddr = tp->mmio_addr;
+	unsigned long timeout = RTL8169_PHY_TIMEOUT;
+	u32 i,j;
+	int gphy_code;
+	int gphy_status;
+	u32  macaddr1;
+	u16  macaddr2;
+
+	macaddr1 = RTL_R32(MAC0);
+	macaddr2 = RTL_R16(MAC4);
+
+	if (tp->link_ok(ioaddr))
+		return;
+
+	rtl_writephy(tp, 0x1f, 0x0A46);
+	gphy_status = rtl_readphy(tp, 0x15);
+
+	rtl_writephy(tp, 0x1b, 0x0002);
+	gphy_code=rtl_readphy(tp, 0x1c);
+
+	gphy_status = gphy_status & 0x0F00;
+	gphy_status = gphy_status >>8;
+
+
+	if((gphy_status>=3)&&(gphy_code==0x6329))
+	{
+		goto out_mod_timer;
+	}
+
+	napi_disable(&tp->napi);
+	rtl_irq_disable(tp);
+
+	netif_err(tp, drv, tp->dev, "gphy check failed, reset start\n");
+
+	i=readl(IOMEM(0xFE000000));
+	i = i & 0xffffbfff;
+	writel(i,IOMEM(0xFE000000));
+
+	j=readl(IOMEM(0xFE007088));
+	j = j & 0xfffff9ff;
+	writel(j,IOMEM(0xFE007088));
+
+
+	i=readl(IOMEM(0xFE000000));
+	i = i | 0x00004000;
+	writel(i,IOMEM(0xFE000000));
+
+	j=readl(IOMEM(0xFE007088));
+	j = j | 0x00000600;
+	writel(j,IOMEM(0xFE007088));
+
+	msleep(300);
+
+	napi_enable(&tp->napi);
+
+	rtl_writephy(tp, 0x1f, 0x0A46);
+	gphy_status = rtl_readphy(tp, 0x15);
+	gphy_status = gphy_status & 0x0700;
+	gphy_status = gphy_status >>8;
+
+	netif_err(tp, drv, tp->dev, "gphy check failed, reset check phystatus=%x\n",gphy_status);
+
+	if(gphy_status>=3)
+	{
+		// refill addres
+
+		RTL_W8(Cfg9346, Cfg9346_Unlock);
+		RTL_W32(MAC0,macaddr1);
+		RTL_W16(MAC4,macaddr2);
+		RTL_W8(Cfg9346, Cfg9346_Lock);
+		netif_err(tp, drv, tp->dev, "gphy check failed, reset complete\n");
+		rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+	}
+
+out_mod_timer:
+	mod_timer(timer, jiffies + timeout);
+*/
+}
+
+
+/*
+static void rtl8169_phy_timer(unsigned long __opaque)
+{
+	struct net_device *dev = (struct net_device *)__opaque;
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl_schedule_task(tp, RTL_FLAG_TASK_PHY_PENDING);
+}
+*/
+
+static void rtl8169_release_board(struct platform_device *pdev, struct net_device *dev,
+				  void __iomem *ioaddr)
+{
+//	iounmap(ioaddr);
+//	pci_release_regions(pdev);
+//	pci_clear_mwi(pdev);
+//	pci_disable_device(pdev);
+	free_netdev(dev);
+}
+
+DECLARE_RTL_COND(rtl_phy_reset_cond)
+{
+	return tp->phy_reset_pending(tp);
+}
+
+static void rtl8169_phy_reset(struct net_device *dev,
+				  struct rtl8169_private *tp)
+{
+	tp->phy_reset_enable(tp);
+	rtl_msleep_loop_wait_low(tp, &rtl_phy_reset_cond, 1, 100);
+}
+
+static bool rtl_tbi_enabled(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return (tp->mac_version == RTL_GIGA_MAC_VER_01) &&
+		(RTL_R8(PHYstatus) & TBI_Enable);
+}
+
+static void rtl8169_init_phy(struct net_device *dev, struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	rtl_hw_phy_config(dev);
+
+	if (tp->mac_version <= RTL_GIGA_MAC_VER_06) {
+		dprintk("Set MAC Reg C+CR Offset 0x82h = 0x01h\n");
+		RTL_W8(0x82, 0x01);
+	}
+
+	// disable now is oob
+	RTL_W8(MCU, RTL_R8(MCU) & ~NOW_IS_OOB);
+
+//	pci_write_config_byte(tp->pci_dev, PCI_LATENCY_TIMER, 0x40);
+
+//	if (tp->mac_version <= RTL_GIGA_MAC_VER_06)
+//		pci_write_config_byte(tp->pci_dev, PCI_CACHE_LINE_SIZE, 0x08);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_02) {
+		dprintk("Set MAC Reg C+CR Offset 0x82h = 0x01h\n");
+		RTL_W8(0x82, 0x01);
+		dprintk("Set PHY Reg 0x0bh = 0x00h\n");
+		rtl_writephy(tp, 0x0b, 0x0000); //w 0x0b 15 0 0
+	}
+
+	rtl8169_phy_reset(dev, tp);
+
+	rtl8169_set_speed(dev, AUTONEG_ENABLE, SPEED_1000, DUPLEX_FULL,
+			  ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full |
+			  ADVERTISED_100baseT_Half | ADVERTISED_100baseT_Full |
+			  (tp->mii.supports_gmii ?
+			   ADVERTISED_1000baseT_Half |
+			   ADVERTISED_1000baseT_Full : 0));
+
+	if (rtl_tbi_enabled(tp))
+		netif_info(tp, link, dev, "TBI auto-negotiating\n");
+}
+
+
+static int rtl_set_mac_address(struct net_device *dev, void *p)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	struct sockaddr *addr = p;
+
+	if (!is_valid_ether_addr(addr->sa_data))
+		return -EADDRNOTAVAIL;
+
+	memcpy(dev->dev_addr, addr->sa_data, dev->addr_len);
+
+	rtl_rar_set(tp, dev->dev_addr);
+
+	return 0;
+}
+
+static int rtl8169_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	struct mii_ioctl_data *data = if_mii(ifr);
+
+	return netif_running(dev) ? tp->do_ioctl(tp, data, cmd) : -ENODEV;
+}
+
+static int rtl_xmii_ioctl(struct rtl8169_private *tp,
+			  struct mii_ioctl_data *data, int cmd)
+{
+	int tmp;
+
+	switch (cmd) {
+	case SIOCGMIIPHY:
+		data->phy_id = 32; /* Internal PHY */
+		return 0;
+
+	case SIOCGMIIREG:
+		MDIO_LOCK;
+		/* save current page */
+		tmp = rtl_readphy(tp, 0x1f);
+		rtl_writephy(tp, 0x1f, 0);
+
+		data->val_out = rtl_readphy(tp, data->reg_num & 0x1f);
+
+		/* restore current page */
+		rtl_writephy(tp, 0x1f, tmp);
+		MDIO_UNLOCK;
+		return 0;
+
+	case SIOCSMIIREG:
+		MDIO_LOCK;
+		/* save current page */
+		tmp = rtl_readphy(tp, 0x1f);
+		rtl_writephy(tp, 0x1f, 0);
+
+		rtl_writephy(tp, data->reg_num & 0x1f, data->val_in);
+
+		/* restore current page */
+		rtl_writephy(tp, 0x1f, tmp);
+		MDIO_UNLOCK;
+		return 0;
+	}
+	return -EOPNOTSUPP;
+}
+
+static int rtl_tbi_ioctl(struct rtl8169_private *tp, struct mii_ioctl_data *data, int cmd)
+{
+	return -EOPNOTSUPP;
+}
+
+static __maybe_unused void rtl_disable_msi(struct platform_device *pdev, struct rtl8169_private *tp)
+{
+//	if (tp->features & RTL_FEATURE_MSI) {
+//		pci_disable_msi(pdev);
+//		tp->features &= ~RTL_FEATURE_MSI;
+//	}
+}
+
+static void rtl_write_wakeup_pattern(struct rtl8169_private *tp, u32 idx)
+{
+	u8 i,j;
+	u32 reg_mask, reg_shift, reg_offset;
+
+	reg_offset = idx & ~(BIT(0) | BIT(1));
+	reg_shift = (idx % 4) * 8;
+	switch (reg_shift) {
+	case 0:
+		reg_mask = ERIAR_MASK_0001;
+		break;
+	case 8:
+		reg_mask = ERIAR_MASK_0010;
+		break;
+	case 16:
+		reg_mask = ERIAR_MASK_0100;
+		break;
+	case 24:
+		reg_mask = ERIAR_MASK_1000;
+		break;
+	default:
+		pr_err("Invalid shift bit 0x%x, idx = %d\n", reg_shift, idx);
+		return;
+	}
+
+	for (i = 0, j = 0; i < 0x80; i += 8, j++) {
+		/*
+		pr_err("%s:%d: idx %d, j %02d, addr 0x%x mask 0x%04x, val 0x%04x, type 0x%x\n",
+			__func__, __LINE__,
+			idx, j,
+			i + reg_offset, reg_mask,  tp->wol_mask[idx][j] << reg_shift, ERIAR_EXGMAC);
+		*/
+		rtl_eri_write(tp, i + reg_offset, reg_mask, tp->wol_mask[idx][j] << reg_shift, ERIAR_EXGMAC);
+	}
+
+	reg_offset = idx * 2;
+	if (idx % 2) {
+		reg_mask = ERIAR_MASK_1100;
+		reg_offset -= 2;
+		reg_shift = 16;
+	} else {
+		reg_mask = ERIAR_MASK_0011;
+		reg_shift = 0;
+	}
+	/*
+	pr_err("%s:%d: idx %d, CRC addr 0x%x mask 0x%04x, val 0x%04x, type 0x%x\n",
+		__func__, __LINE__,
+		idx,
+		0x80 + reg_offset, reg_mask,  tp->wol_crc[idx] << reg_shift, ERIAR_EXGMAC);
+	*/
+	rtl_eri_write(tp, (int)(0x80 + reg_offset), reg_mask, tp->wol_crc[idx] << reg_shift, ERIAR_EXGMAC);
+}
+
+static void rtl_mdns_crc_wakeup(struct rtl8169_private *tp)
+{
+	int i;
+
+	for (i = 0; i < tp->wol_wpd_cnt; i++)
+		rtl_write_wakeup_pattern(tp, i);
+
+}
+
+static void rtl_clear_wakeup_pattern(struct rtl8169_private *tp)
+{
+	u8 i;
+
+	for (i=0;i<0x80;i+=4)
+		rtl_eri_write(tp, i, ERIAR_MASK_1111, 0x0, ERIAR_EXGMAC);
+
+	for (i=0x80;i<0x90;i+=4)
+		rtl_eri_write(tp, i, ERIAR_MASK_1111, 0x0, ERIAR_EXGMAC);
+}
+
+static void rtl_init_mdio_ops(struct rtl8169_private *tp)
+{
+	struct mdio_ops *ops = &tp->mdio_ops;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_27:
+		ops->write	= r8168dp_1_mdio_write;
+		ops->read	= r8168dp_1_mdio_read;
+		break;
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+		ops->write	= r8168dp_2_mdio_write;
+		ops->read	= r8168dp_2_mdio_read;
+		break;
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+	//	ops->write	= r8168g_mdio_write;
+	//	ops->read	= r8168g_mdio_read;
+		ops->write	= r8169_mdio_write;
+		ops->read	= r8169_mdio_read;
+		break;
+	default:
+		ops->write	= r8169_mdio_write;
+		ops->read	= r8169_mdio_read;
+		break;
+	}
+}
+
+static void rtl_speed_down(struct rtl8169_private *tp)
+{
+	u32 adv;
+	int lpa;
+
+	MDIO_LOCK;
+	rtl_writephy(tp, 0x1f, 0x0000);
+	lpa = rtl_readphy(tp, MII_LPA);
+	MDIO_UNLOCK;
+
+	if (lpa & (LPA_10HALF | LPA_10FULL))
+		adv = ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full;
+	else if (lpa & (LPA_100HALF | LPA_100FULL))
+		adv = ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full |
+			  ADVERTISED_100baseT_Half | ADVERTISED_100baseT_Full;
+	else
+		adv = ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full |
+			  ADVERTISED_100baseT_Half | ADVERTISED_100baseT_Full |
+			  (tp->mii.supports_gmii ?
+			   ADVERTISED_1000baseT_Half |
+			   ADVERTISED_1000baseT_Full : 0);
+
+	rtl8169_set_speed(tp->dev, AUTONEG_ENABLE, SPEED_1000, DUPLEX_FULL,
+			  adv);
+}
+
+static void rtl_wol_suspend_quirk(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_29:
+	case RTL_GIGA_MAC_VER_30:
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+	case RTL_GIGA_MAC_VER_34:
+	case RTL_GIGA_MAC_VER_37:
+	case RTL_GIGA_MAC_VER_38:
+	case RTL_GIGA_MAC_VER_39:
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+		RTL_W32(RxConfig, RTL_R32(RxConfig) |
+			AcceptBroadcast | AcceptMulticast | AcceptMyPhys);
+		break;
+	default:
+		break;
+	}
+}
+
+static bool rtl_wol_pll_power_down(struct rtl8169_private *tp)
+{
+	if (!(__rtl8169_get_wol(tp) & WAKE_ANY))
+		return false;
+
+	rtl_speed_down(tp);
+	rtl_wol_suspend_quirk(tp);
+
+	return true;
+}
+
+static void r810x_phy_power_down(struct rtl8169_private *tp)
+{
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, MII_BMCR, BMCR_PDOWN);
+}
+
+static void r810x_phy_power_up(struct rtl8169_private *tp)
+{
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, MII_BMCR, BMCR_ANENABLE);
+}
+
+static void r810x_pll_power_down(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (rtl_wol_pll_power_down(tp))
+		return;
+
+	r810x_phy_power_down(tp);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_07:
+	case RTL_GIGA_MAC_VER_08:
+	case RTL_GIGA_MAC_VER_09:
+	case RTL_GIGA_MAC_VER_10:
+	case RTL_GIGA_MAC_VER_13:
+	case RTL_GIGA_MAC_VER_16:
+		break;
+	default:
+		RTL_W8(PMCH, RTL_R8(PMCH) & ~0x80);
+		break;
+	}
+}
+
+static void r810x_pll_power_up(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	r810x_phy_power_up(tp);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_07:
+	case RTL_GIGA_MAC_VER_08:
+	case RTL_GIGA_MAC_VER_09:
+	case RTL_GIGA_MAC_VER_10:
+	case RTL_GIGA_MAC_VER_13:
+	case RTL_GIGA_MAC_VER_16:
+		break;
+	default:
+		RTL_W8(PMCH, RTL_R8(PMCH) | 0x80);
+		break;
+	}
+}
+
+static void r8168_phy_power_up(struct rtl8169_private *tp)
+{
+	rtl_writephy(tp, 0x1f, 0x0000);
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+	case RTL_GIGA_MAC_VER_18:
+	case RTL_GIGA_MAC_VER_19:
+	case RTL_GIGA_MAC_VER_20:
+	case RTL_GIGA_MAC_VER_21:
+	case RTL_GIGA_MAC_VER_22:
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+		rtl_writephy(tp, 0x0e, 0x0000);
+		break;
+	default:
+		break;
+	}
+	rtl_writephy(tp, MII_BMCR, BMCR_ANENABLE);
+}
+
+static void r8168_phy_power_down(struct rtl8169_private *tp)
+{
+	rtl_writephy(tp, 0x1f, 0x0000);
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+		rtl_writephy(tp, MII_BMCR, BMCR_ANENABLE | BMCR_PDOWN);
+		break;
+
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+	case RTL_GIGA_MAC_VER_18:
+	case RTL_GIGA_MAC_VER_19:
+	case RTL_GIGA_MAC_VER_20:
+	case RTL_GIGA_MAC_VER_21:
+	case RTL_GIGA_MAC_VER_22:
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+		rtl_writephy(tp, 0x0e, 0x0200);
+	default:
+		rtl_writephy(tp, MII_BMCR, BMCR_PDOWN);
+		break;
+	}
+}
+
+static void r8168_pll_power_down(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if ((tp->mac_version == RTL_GIGA_MAC_VER_27 ||
+		 tp->mac_version == RTL_GIGA_MAC_VER_28 ||
+		 tp->mac_version == RTL_GIGA_MAC_VER_31) &&
+		r8168dp_check_dash(tp)) {
+		return;
+	}
+
+	if ((tp->mac_version == RTL_GIGA_MAC_VER_23 ||
+		 tp->mac_version == RTL_GIGA_MAC_VER_24) &&
+		(RTL_R16(CPlusCmd) & ASF)) {
+		return;
+	}
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_32 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_33)
+		rtl_ephy_write(tp, 0x19, 0xff64);
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+	if(wol_enable)
+	{
+		//enable now_is_oob
+		RTL_W8(MCU, RTL_R8(MCU) | NOW_IS_OOB);
+		RTL_W8(Config5, RTL_R8(Config5) | LanWake);;
+		RTL_W8(Config3, RTL_R8(Config3) | MagicPacket);
+
+		rtl_clear_wakeup_pattern(tp);
+		if (tp->wol_wpd_cnt > 0 && wol_enable == 1)
+			rtl_mdns_crc_wakeup(tp);
+	}
+	else
+	{
+		RTL_W8(Config5, RTL_R8(Config5) & ~LanWake);
+		RTL_W8(Config3, RTL_R8(Config3) & ~MagicPacket);
+	}
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	if (rtl_wol_pll_power_down(tp))
+		return;
+
+	r8168_phy_power_down(tp);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+		RTL_W8(PMCH, RTL_R8(PMCH) & ~0x80);
+		break;
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+		rtl_w1w0_eri(tp, 0x1a8, ERIAR_MASK_1111, 0x00000000,
+				 0xfc000000, ERIAR_EXGMAC);
+		break;
+	}
+}
+
+static void r8168_pll_power_up(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+		RTL_W8(PMCH, RTL_R8(PMCH) | 0x80);
+		break;
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+		rtl_w1w0_eri(tp, 0x1a8, ERIAR_MASK_1111, 0xfc000000,
+				 0x00000000, ERIAR_EXGMAC);
+		break;
+	}
+
+	r8168_phy_power_up(tp);
+}
+
+static void rtl_generic_op(struct rtl8169_private *tp,
+			   void (*op)(struct rtl8169_private *))
+{
+	if (op)
+		op(tp);
+}
+
+static void rtl_pll_power_down(struct rtl8169_private *tp)
+{
+	rtl_generic_op(tp, tp->pll_power_ops.down);
+}
+
+static void rtl_pll_power_up(struct rtl8169_private *tp)
+{
+	rtl_generic_op(tp, tp->pll_power_ops.up);
+}
+
+static void rtl_init_pll_power_ops(struct rtl8169_private *tp)
+{
+	struct pll_power_ops *ops = &tp->pll_power_ops;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_07:
+	case RTL_GIGA_MAC_VER_08:
+	case RTL_GIGA_MAC_VER_09:
+	case RTL_GIGA_MAC_VER_10:
+	case RTL_GIGA_MAC_VER_16:
+	case RTL_GIGA_MAC_VER_29:
+	case RTL_GIGA_MAC_VER_30:
+	case RTL_GIGA_MAC_VER_37:
+	case RTL_GIGA_MAC_VER_39:
+	case RTL_GIGA_MAC_VER_43:
+		ops->down	= r810x_pll_power_down;
+		ops->up		= r810x_pll_power_up;
+		break;
+
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+	case RTL_GIGA_MAC_VER_18:
+	case RTL_GIGA_MAC_VER_19:
+	case RTL_GIGA_MAC_VER_20:
+	case RTL_GIGA_MAC_VER_21:
+	case RTL_GIGA_MAC_VER_22:
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+	case RTL_GIGA_MAC_VER_34:
+	case RTL_GIGA_MAC_VER_35:
+	case RTL_GIGA_MAC_VER_36:
+	case RTL_GIGA_MAC_VER_38:
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+		ops->down	= r8168_pll_power_down;
+		ops->up		= r8168_pll_power_up;
+		break;
+
+	default:
+		ops->down	= NULL;
+		ops->up		= NULL;
+		break;
+	}
+}
+
+static void rtl_init_rxcfg(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_01:
+	case RTL_GIGA_MAC_VER_02:
+	case RTL_GIGA_MAC_VER_03:
+	case RTL_GIGA_MAC_VER_04:
+	case RTL_GIGA_MAC_VER_05:
+	case RTL_GIGA_MAC_VER_06:
+	case RTL_GIGA_MAC_VER_10:
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_13:
+	case RTL_GIGA_MAC_VER_14:
+	case RTL_GIGA_MAC_VER_15:
+	case RTL_GIGA_MAC_VER_16:
+	case RTL_GIGA_MAC_VER_17:
+		RTL_W32(RxConfig, RX_FIFO_THRESH | RX_DMA_BURST);
+		break;
+	case RTL_GIGA_MAC_VER_18:
+	case RTL_GIGA_MAC_VER_19:
+	case RTL_GIGA_MAC_VER_20:
+	case RTL_GIGA_MAC_VER_21:
+	case RTL_GIGA_MAC_VER_22:
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+	case RTL_GIGA_MAC_VER_34:
+	case RTL_GIGA_MAC_VER_35:
+		RTL_W32(RxConfig, RX128_INT_EN | RX_MULTI_EN | RX_DMA_BURST);
+		break;
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+		RTL_W32(RxConfig, RX128_INT_EN | RX_DMA_BURST | RX_EARLY_OFF);
+		break;
+	default:
+		RTL_W32(RxConfig, RX128_INT_EN | RX_DMA_BURST);
+		break;
+	}
+}
+
+static void rtl8169_init_ring_indexes(struct rtl8169_private *tp)
+{
+	tp->dirty_tx = tp->cur_tx = tp->cur_rx = 0;
+
+	#if defined(CONFIG_RTL_RX_NO_COPY)
+	tp->dirty_rx = 0;
+	#endif /* CONFIG_RTL_RX_NO_COPY */
+}
+
+static void rtl_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+	rtl_generic_op(tp, tp->jumbo_ops.enable);
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+}
+
+static void rtl_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+	rtl_generic_op(tp, tp->jumbo_ops.disable);
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+}
+
+static void r8168c_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+	RTL_W8(Config4, RTL_R8(Config4) | Jumbo_En1);
+	rtl_tx_performance_tweak(tp->pdev, 0x2 << MAX_READ_REQUEST_SHIFT);
+}
+
+static void r8168c_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+	RTL_W8(Config4, RTL_R8(Config4) & ~Jumbo_En1);
+	rtl_tx_performance_tweak(tp->pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+}
+
+static void r8168dp_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+}
+
+static void r8168dp_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+}
+
+static void r8168e_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(MaxTxPacketSize, 0x3f);
+	RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+	RTL_W8(Config4, RTL_R8(Config4) | 0x01);
+	rtl_tx_performance_tweak(tp->pdev, 0x2 << MAX_READ_REQUEST_SHIFT);
+}
+
+static void r8168e_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(MaxTxPacketSize, 0x0c);
+	RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+	RTL_W8(Config4, RTL_R8(Config4) & ~0x01);
+	rtl_tx_performance_tweak(tp->pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+}
+
+static void r8168b_0_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+//	rtl_tx_performance_tweak(tp->pdev,
+//		(0x2 << MAX_READ_REQUEST_SHIFT) | PCI_EXP_DEVCTL_NOSNOOP_EN);
+}
+
+static void r8168b_0_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+//	rtl_tx_performance_tweak(tp->pdev,
+//		(0x5 << MAX_READ_REQUEST_SHIFT) | PCI_EXP_DEVCTL_NOSNOOP_EN);
+}
+
+static void r8168b_1_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	r8168b_0_hw_jumbo_enable(tp);
+
+	RTL_W8(Config4, RTL_R8(Config4) | (1 << 0));
+}
+
+static void r8168b_1_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	r8168b_0_hw_jumbo_disable(tp);
+
+	RTL_W8(Config4, RTL_R8(Config4) & ~(1 << 0));
+}
+
+static void rtl_init_jumbo_ops(struct rtl8169_private *tp)
+{
+	struct jumbo_ops *ops = &tp->jumbo_ops;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_11:
+		ops->disable	= r8168b_0_hw_jumbo_disable;
+		ops->enable	= r8168b_0_hw_jumbo_enable;
+		break;
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+		ops->disable	= r8168b_1_hw_jumbo_disable;
+		ops->enable	= r8168b_1_hw_jumbo_enable;
+		break;
+	case RTL_GIGA_MAC_VER_18: /* Wild guess. Needs info from Realtek. */
+	case RTL_GIGA_MAC_VER_19:
+	case RTL_GIGA_MAC_VER_20:
+	case RTL_GIGA_MAC_VER_21: /* Wild guess. Needs info from Realtek. */
+	case RTL_GIGA_MAC_VER_22:
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+		ops->disable	= r8168c_hw_jumbo_disable;
+		ops->enable	= r8168c_hw_jumbo_enable;
+		break;
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+		ops->disable	= r8168dp_hw_jumbo_disable;
+		ops->enable	= r8168dp_hw_jumbo_enable;
+		break;
+	case RTL_GIGA_MAC_VER_31: /* Wild guess. Needs info from Realtek. */
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+	case RTL_GIGA_MAC_VER_34:
+		ops->disable	= r8168e_hw_jumbo_disable;
+		ops->enable	= r8168e_hw_jumbo_enable;
+		break;
+
+	/*
+	 * No action needed for jumbo frames with 8169.
+	 * No jumbo for 810x at all.
+	 */
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+	default:
+		ops->disable	= NULL;
+		ops->enable	= NULL;
+		break;
+	}
+}
+
+DECLARE_RTL_COND(rtl_chipcmd_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R8(ChipCmd) & CmdReset;
+}
+
+static void rtl_hw_reset(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(ChipCmd, CmdReset);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_chipcmd_cond, 100, 100);
+}
+
+static void rtl_request_uncached_firmware(struct rtl8169_private *tp)
+{
+	struct rtl_fw *rtl_fw;
+	const char *name;
+	int rc = -ENOMEM;
+
+	name = rtl_lookup_firmware_name(tp);
+	if (!name)
+		goto out_no_firmware;
+
+	rtl_fw = kzalloc(sizeof(*rtl_fw), GFP_KERNEL);
+	if (!rtl_fw)
+		goto err_warn;
+
+	rc = request_firmware(&rtl_fw->fw, name, &tp->pdev->dev);
+	if (rc < 0)
+		goto err_free;
+
+	rc = rtl_check_firmware(tp, rtl_fw);
+	if (rc < 0)
+		goto err_release_firmware;
+
+	tp->rtl_fw = rtl_fw;
+out:
+	return;
+
+err_release_firmware:
+	release_firmware(rtl_fw->fw);
+err_free:
+	kfree(rtl_fw);
+err_warn:
+	netif_warn(tp, ifup, tp->dev, "unable to load firmware patch %s (%d)\n",
+		   name, rc);
+out_no_firmware:
+	tp->rtl_fw = NULL;
+	goto out;
+}
+
+static __maybe_unused void rtl_request_firmware(struct rtl8169_private *tp)
+{
+	if (IS_ERR(tp->rtl_fw))
+		rtl_request_uncached_firmware(tp);
+}
+
+static void rtl_rx_close(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(RxConfig, RTL_R32(RxConfig) & ~RX_CONFIG_ACCEPT_MASK);
+}
+
+DECLARE_RTL_COND(rtl_npq_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R8(TxPoll) & NPQ;
+}
+
+DECLARE_RTL_COND(rtl_txcfg_empty_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(TxConfig) & TXCFG_EMPTY;
+}
+
+static void rtl8169_hw_reset(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* Disable interrupts */
+	rtl8169_irq_mask_and_ack(tp);
+
+	rtl_rx_close(tp);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_27 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_28 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_31) {
+		rtl_udelay_loop_wait_low(tp, &rtl_npq_cond, 20, 42*42);
+	} else if (tp->mac_version == RTL_GIGA_MAC_VER_34 ||
+			   tp->mac_version == RTL_GIGA_MAC_VER_35 ||
+			   tp->mac_version == RTL_GIGA_MAC_VER_36 ||
+			   tp->mac_version == RTL_GIGA_MAC_VER_37 ||
+			   tp->mac_version == RTL_GIGA_MAC_VER_40 ||
+			   tp->mac_version == RTL_GIGA_MAC_VER_41 ||
+			   tp->mac_version == RTL_GIGA_MAC_VER_42 ||
+			   tp->mac_version == RTL_GIGA_MAC_VER_43 ||
+			   tp->mac_version == RTL_GIGA_MAC_VER_38) {
+		RTL_W8(ChipCmd, RTL_R8(ChipCmd) | StopReq);
+		rtl_udelay_loop_wait_high(tp, &rtl_txcfg_empty_cond, 100, 666);
+	} else {
+		RTL_W8(ChipCmd, RTL_R8(ChipCmd) | StopReq);
+		udelay(100);
+	}
+
+	rtl_hw_reset(tp);
+
+	#if defined(RTL_TX_NO_CLOSE)
+	/* disable tx no close mode */
+	r8169soc_ocp_reg_write(tp, 0xE610,
+		(r8169soc_ocp_reg_read(tp, 0xE610) & ~(BIT(4) | BIT(6))));
+	#endif /* RTL_TX_NO_CLOSE */
+}
+
+static void rtl_set_rx_tx_config_registers(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* Set DMA burst size and Interframe Gap Time */
+	RTL_W32(TxConfig, (TX_DMA_BURST << TxDMAShift) |
+		(InterFrameGap << TxInterFrameGapShift));
+}
+
+static void rtl_hw_start(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	tp->hw_start(dev);
+
+	rtl_irq_enable_all(tp);
+}
+
+static void rtl_set_rx_tx_desc_registers(struct rtl8169_private *tp,
+					 void __iomem *ioaddr)
+{
+	/*
+	 * Magic spell: some iop3xx ARM board needs the TxDescAddrHigh
+	 * register to be written before TxDescAddrLow to work.
+	 * Switching from MMIO to I/O access fixes the issue as well.
+	 */
+	RTL_W32(TxDescStartAddrHigh, ((u64) tp->TxPhyAddr) >> 32);
+	RTL_W32(TxDescStartAddrLow, ((u64) tp->TxPhyAddr) & DMA_BIT_MASK(32));
+	RTL_W32(RxDescAddrHigh, ((u64) tp->RxPhyAddr) >> 32);
+	RTL_W32(RxDescAddrLow, ((u64) tp->RxPhyAddr) & DMA_BIT_MASK(32));
+}
+
+static u16 rtl_rw_cpluscmd(void __iomem *ioaddr)
+{
+	u16 cmd;
+
+	cmd = RTL_R16(CPlusCmd);
+	RTL_W16(CPlusCmd, cmd);
+	return cmd;
+}
+
+static void rtl_set_rx_max_size(void __iomem *ioaddr, unsigned int rx_buf_sz)
+{
+	/* Low hurts. Let's disable the filtering. */
+	RTL_W16(RxMaxSize, rx_buf_sz + 1);
+}
+
+static void rtl8169_set_magic_reg(void __iomem *ioaddr, unsigned mac_version)
+{
+	static const struct rtl_cfg2_info {
+		u32 mac_version;
+		u32 clk;
+		u32 val;
+	} cfg2_info [] = {
+		{ RTL_GIGA_MAC_VER_05, PCI_Clock_33MHz, 0x000fff00 }, // 8110SCd
+		{ RTL_GIGA_MAC_VER_05, PCI_Clock_66MHz, 0x000fffff },
+		{ RTL_GIGA_MAC_VER_06, PCI_Clock_33MHz, 0x00ffff00 }, // 8110SCe
+		{ RTL_GIGA_MAC_VER_06, PCI_Clock_66MHz, 0x00ffffff }
+	};
+	const struct rtl_cfg2_info *p = cfg2_info;
+	unsigned int i;
+	u32 clk;
+
+	clk = RTL_R8(Config2) & PCI_Clock_66MHz;
+	for (i = 0; i < ARRAY_SIZE(cfg2_info); i++, p++) {
+		if ((p->mac_version == mac_version) && (p->clk == clk)) {
+			RTL_W32(0x7c, p->val);
+			break;
+		}
+	}
+}
+
+static void rtl_set_rx_mode(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	u32 mc_filter[2];	/* Multicast hash filter */
+	int rx_mode;
+	u32 tmp = 0;
+
+	if (dev->flags & IFF_PROMISC) {
+		/* Unconditionally log net taps. */
+		netif_notice(tp, link, dev, "Promiscuous mode enabled\n");
+		rx_mode =
+			AcceptBroadcast | AcceptMulticast | AcceptMyPhys |
+			AcceptAllPhys;
+		mc_filter[1] = mc_filter[0] = 0xffffffff;
+	} else if ((netdev_mc_count(dev) > multicast_filter_limit) ||
+		   (dev->flags & IFF_ALLMULTI)) {
+		/* Too many to filter perfectly -- accept all multicasts. */
+		rx_mode = AcceptBroadcast | AcceptMulticast | AcceptMyPhys;
+		mc_filter[1] = mc_filter[0] = 0xffffffff;
+	} else {
+		struct netdev_hw_addr *ha;
+
+		rx_mode = AcceptBroadcast | AcceptMyPhys;
+		mc_filter[1] = mc_filter[0] = 0;
+		netdev_for_each_mc_addr(ha, dev) {
+			int bit_nr = ether_crc(ETH_ALEN, ha->addr) >> 26;
+			mc_filter[bit_nr >> 5] |= 1 << (bit_nr & 31);
+			rx_mode |= AcceptMulticast;
+		}
+	}
+
+	if (dev->features & NETIF_F_RXALL)
+		rx_mode |= (AcceptErr | AcceptRunt);
+
+	tmp = (RTL_R32(RxConfig) & ~RX_CONFIG_ACCEPT_MASK) | rx_mode;
+
+	if (tp->mac_version > RTL_GIGA_MAC_VER_06) {
+		u32 data = mc_filter[0];
+
+		mc_filter[0] = swab32(mc_filter[1]);
+		mc_filter[1] = swab32(data);
+	}
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_35)
+		mc_filter[1] = mc_filter[0] = 0xffffffff;
+
+	RTL_W32(MAR0 + 4, mc_filter[1]);
+	RTL_W32(MAR0 + 0, mc_filter[0]);
+
+	RTL_W32(RxConfig, tmp);
+}
+
+static void rtl_hw_start_8169(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+//	struct platform_device *pdev = tp->pdev;
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_05) {
+		RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) | PCIMulRW);
+	//	pci_write_config_byte(pdev, PCI_CACHE_LINE_SIZE, 0x08);
+	}
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+	if (tp->mac_version == RTL_GIGA_MAC_VER_01 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_02 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_03 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_04)
+		RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+
+	rtl_init_rxcfg(tp);
+
+	RTL_W8(EarlyTxThres, NoEarlyTx);
+
+	rtl_set_rx_max_size(ioaddr, rx_buf_sz);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_01 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_02 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_03 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_04)
+		rtl_set_rx_tx_config_registers(tp);
+
+	tp->cp_cmd |= rtl_rw_cpluscmd(ioaddr) | PCIMulRW;
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_02 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_03) {
+		dprintk("Set MAC Reg C+CR Offset 0xE0. "
+			"Bit-3 and bit-14 MUST be 1\n");
+		tp->cp_cmd |= (1 << 14);
+	}
+
+	RTL_W16(CPlusCmd, tp->cp_cmd);
+
+	rtl8169_set_magic_reg(ioaddr, tp->mac_version);
+
+	/*
+	 * Undocumented corner. Supposedly:
+	 * (TxTimer << 12) | (TxPackets << 8) | (RxTimer << 4) | RxPackets
+	 */
+	RTL_W16(IntrMitigate, 0x0000);
+
+	rtl_set_rx_tx_desc_registers(tp, ioaddr);
+
+	if (tp->mac_version != RTL_GIGA_MAC_VER_01 &&
+		tp->mac_version != RTL_GIGA_MAC_VER_02 &&
+		tp->mac_version != RTL_GIGA_MAC_VER_03 &&
+		tp->mac_version != RTL_GIGA_MAC_VER_04) {
+		RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+		rtl_set_rx_tx_config_registers(tp);
+	}
+
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	/* Initially a 10 us delay. Turned it into a PCI commit. - FR */
+	RTL_R8(IntrMask);
+
+	RTL_W32(RxMissed, 0);
+
+	rtl_set_rx_mode(dev);
+
+	/* no early-rx interrupts */
+	RTL_W16(MultiIntr, RTL_R16(MultiIntr) & 0xF000);
+}
+
+static void rtl_csi_write(struct rtl8169_private *tp, int addr, int value)
+{
+	if (tp->csi_ops.write)
+		tp->csi_ops.write(tp, addr, value);
+}
+
+static u32 rtl_csi_read(struct rtl8169_private *tp, int addr)
+{
+	return tp->csi_ops.read ? tp->csi_ops.read(tp, addr) : ~0;
+}
+
+static void rtl_csi_access_enable(struct rtl8169_private *tp, u32 bits)
+{
+	u32 csi;
+
+	csi = rtl_csi_read(tp, 0x070c) & 0x00ffffff;
+	rtl_csi_write(tp, 0x070c, csi | bits);
+}
+
+static void rtl_csi_access_enable_1(struct rtl8169_private *tp)
+{
+	rtl_csi_access_enable(tp, 0x17000000);
+}
+
+static void rtl_csi_access_enable_2(struct rtl8169_private *tp)
+{
+	rtl_csi_access_enable(tp, 0x27000000);
+}
+
+DECLARE_RTL_COND(rtl_csiar_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(CSIAR) & CSIAR_FLAG;
+}
+
+static void r8169_csi_write(struct rtl8169_private *tp, int addr, int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(CSIDR, value);
+	RTL_W32(CSIAR, CSIAR_WRITE_CMD | (addr & CSIAR_ADDR_MASK) |
+		CSIAR_BYTE_ENABLE << CSIAR_BYTE_ENABLE_SHIFT);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_csiar_cond, 10, 100);
+}
+
+static u32 r8169_csi_read(struct rtl8169_private *tp, int addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(CSIAR, (addr & CSIAR_ADDR_MASK) |
+		CSIAR_BYTE_ENABLE << CSIAR_BYTE_ENABLE_SHIFT);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_csiar_cond, 10, 100) ?
+		RTL_R32(CSIDR) : ~0;
+}
+
+static void r8402_csi_write(struct rtl8169_private *tp, int addr, int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(CSIDR, value);
+	RTL_W32(CSIAR, CSIAR_WRITE_CMD | (addr & CSIAR_ADDR_MASK) |
+		CSIAR_BYTE_ENABLE << CSIAR_BYTE_ENABLE_SHIFT |
+		CSIAR_FUNC_NIC);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_csiar_cond, 10, 100);
+}
+
+static u32 r8402_csi_read(struct rtl8169_private *tp, int addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(CSIAR, (addr & CSIAR_ADDR_MASK) | CSIAR_FUNC_NIC |
+		CSIAR_BYTE_ENABLE << CSIAR_BYTE_ENABLE_SHIFT);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_csiar_cond, 10, 100) ?
+		RTL_R32(CSIDR) : ~0;
+}
+
+static void rtl_init_csi_ops(struct rtl8169_private *tp)
+{
+	struct csi_ops *ops = &tp->csi_ops;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_01:
+	case RTL_GIGA_MAC_VER_02:
+	case RTL_GIGA_MAC_VER_03:
+	case RTL_GIGA_MAC_VER_04:
+	case RTL_GIGA_MAC_VER_05:
+	case RTL_GIGA_MAC_VER_06:
+	case RTL_GIGA_MAC_VER_10:
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_13:
+	case RTL_GIGA_MAC_VER_14:
+	case RTL_GIGA_MAC_VER_15:
+	case RTL_GIGA_MAC_VER_16:
+	case RTL_GIGA_MAC_VER_17:
+		ops->write	= NULL;
+		ops->read	= NULL;
+		break;
+
+	case RTL_GIGA_MAC_VER_37:
+	case RTL_GIGA_MAC_VER_38:
+		ops->write	= r8402_csi_write;
+		ops->read	= r8402_csi_read;
+		break;
+
+	default:
+		ops->write	= r8169_csi_write;
+		ops->read	= r8169_csi_read;
+		break;
+	}
+}
+
+struct ephy_info {
+	unsigned int offset;
+	u16 mask;
+	u16 bits;
+};
+
+static void rtl_ephy_init(struct rtl8169_private *tp, const struct ephy_info *e,
+			  int len)
+{
+#if 0
+	u16 w;
+
+	while (len-- > 0) {
+		w = (rtl_ephy_read(tp, e->offset) & ~e->mask) | e->bits;
+		rtl_ephy_write(tp, e->offset, w);
+		e++;
+	}
+#endif
+}
+
+static void rtl_disable_clock_request(struct platform_device *pdev)
+{
+//	pcie_capability_clear_word(pdev, PCI_EXP_LNKCTL,
+//				   PCI_EXP_LNKCTL_CLKREQ_EN);
+}
+
+static void rtl_enable_clock_request(struct platform_device *pdev)
+{
+//	pcie_capability_set_word(pdev, PCI_EXP_LNKCTL,
+//				 PCI_EXP_LNKCTL_CLKREQ_EN);
+}
+
+#define R8168_CPCMD_QUIRK_MASK (\
+	EnableBist | \
+	Mac_dbgo_oe | \
+	Force_half_dup | \
+	Force_rxflow_en | \
+	Force_txflow_en | \
+	Cxpl_dbg_sel | \
+	ASF | \
+	PktCntrDisable | \
+	Mac_dbgo_sel)
+
+static void rtl_hw_start_8168bb(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+	RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~R8168_CPCMD_QUIRK_MASK);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN) {
+		rtl_tx_performance_tweak(pdev, (0x5 << MAX_READ_REQUEST_SHIFT) |
+					 0x0800);
+		//			 PCI_EXP_DEVCTL_NOSNOOP_EN);
+	}
+}
+
+static void rtl_hw_start_8168bef(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	rtl_hw_start_8168bb(tp);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	RTL_W8(Config4, RTL_R8(Config4) & ~(1 << 0));
+}
+
+static void __rtl_hw_start_8168cp(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	RTL_W8(Config1, RTL_R8(Config1) | Speed_down);
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	rtl_disable_clock_request(pdev);
+
+	RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~R8168_CPCMD_QUIRK_MASK);
+}
+
+static void rtl_hw_start_8168cp_1(struct rtl8169_private *tp)
+{
+	static const struct ephy_info e_info_8168cp[] = {
+		{ 0x01, 0,	0x0001 },
+		{ 0x02, 0x0800,	0x1000 },
+		{ 0x03, 0,	0x0042 },
+		{ 0x06, 0x0080,	0x0000 },
+		{ 0x07, 0,	0x2000 }
+	};
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_ephy_init(tp, e_info_8168cp, ARRAY_SIZE(e_info_8168cp));
+
+	__rtl_hw_start_8168cp(tp);
+}
+
+static void rtl_hw_start_8168cp_2(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_2(tp);
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~R8168_CPCMD_QUIRK_MASK);
+}
+
+static void rtl_hw_start_8168cp_3(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_2(tp);
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+	/* Magic. */
+	RTL_W8(DBG_REG, 0x20);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~R8168_CPCMD_QUIRK_MASK);
+}
+
+static void rtl_hw_start_8168c_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	static const struct ephy_info e_info_8168c_1[] = {
+		{ 0x02, 0x0800,	0x1000 },
+		{ 0x03, 0,	0x0002 },
+		{ 0x06, 0x0080,	0x0000 }
+	};
+
+	rtl_csi_access_enable_2(tp);
+
+	RTL_W8(DBG_REG, 0x06 | FIX_NAK_1 | FIX_NAK_2);
+
+	rtl_ephy_init(tp, e_info_8168c_1, ARRAY_SIZE(e_info_8168c_1));
+
+	__rtl_hw_start_8168cp(tp);
+}
+
+static void rtl_hw_start_8168c_2(struct rtl8169_private *tp)
+{
+	static const struct ephy_info e_info_8168c_2[] = {
+		{ 0x01, 0,	0x0001 },
+		{ 0x03, 0x0400,	0x0220 }
+	};
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_ephy_init(tp, e_info_8168c_2, ARRAY_SIZE(e_info_8168c_2));
+
+	__rtl_hw_start_8168cp(tp);
+}
+
+static void rtl_hw_start_8168c_3(struct rtl8169_private *tp)
+{
+	rtl_hw_start_8168c_2(tp);
+}
+
+static void rtl_hw_start_8168c_4(struct rtl8169_private *tp)
+{
+	rtl_csi_access_enable_2(tp);
+
+	__rtl_hw_start_8168cp(tp);
+}
+
+static void rtl_hw_start_8168d(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_disable_clock_request(pdev);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~R8168_CPCMD_QUIRK_MASK);
+}
+
+static void rtl_hw_start_8168dp(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_1(tp);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	rtl_disable_clock_request(pdev);
+}
+
+static void rtl_hw_start_8168d_4(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+	static const struct ephy_info e_info_8168d_4[] = {
+		{ 0x0b, ~0,	0x48 },
+		{ 0x19, 0x20,	0x50 },
+		{ 0x0c, ~0,	0x20 }
+	};
+	int i;
+
+	rtl_csi_access_enable_1(tp);
+
+	rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	for (i = 0; i < ARRAY_SIZE(e_info_8168d_4); i++) {
+		const struct ephy_info *e = e_info_8168d_4 + i;
+		u16 w;
+
+		w = rtl_ephy_read(tp, e->offset);
+		rtl_ephy_write(tp, 0x03, (w & e->mask) | e->bits);
+	}
+
+	rtl_enable_clock_request(pdev);
+}
+
+static void rtl_hw_start_8168e_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+	static const struct ephy_info e_info_8168e_1[] = {
+		{ 0x00, 0x0200,	0x0100 },
+		{ 0x00, 0x0000,	0x0004 },
+		{ 0x06, 0x0002,	0x0001 },
+		{ 0x06, 0x0000,	0x0030 },
+		{ 0x07, 0x0000,	0x2000 },
+		{ 0x00, 0x0000,	0x0020 },
+		{ 0x03, 0x5800,	0x2000 },
+		{ 0x03, 0x0000,	0x0001 },
+		{ 0x01, 0x0800,	0x1000 },
+		{ 0x07, 0x0000,	0x4000 },
+		{ 0x1e, 0x0000,	0x2000 },
+		{ 0x19, 0xffff,	0xfe6c },
+		{ 0x0a, 0x0000,	0x0040 }
+	};
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_ephy_init(tp, e_info_8168e_1, ARRAY_SIZE(e_info_8168e_1));
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	rtl_disable_clock_request(pdev);
+
+	/* Reset tx FIFO pointer */
+	RTL_W32(MISC, RTL_R32(MISC) | TXPLA_RST);
+	RTL_W32(MISC, RTL_R32(MISC) & ~TXPLA_RST);
+
+	RTL_W8(Config5, RTL_R8(Config5) & ~Spi_en);
+}
+
+static void rtl_hw_start_8168e_2(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+	static const struct ephy_info e_info_8168e_2[] = {
+		{ 0x09, 0x0000,	0x0080 },
+		{ 0x19, 0x0000,	0x0224 }
+	};
+
+	rtl_csi_access_enable_1(tp);
+
+	rtl_ephy_init(tp, e_info_8168e_2, ARRAY_SIZE(e_info_8168e_2));
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	rtl_eri_write(tp, 0xc0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xb8, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xc8, ERIAR_MASK_1111, 0x00100002, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xe8, ERIAR_MASK_1111, 0x00100006, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xcc, ERIAR_MASK_1111, 0x00000050, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xd0, ERIAR_MASK_1111, 0x07ff0060, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x1b0, ERIAR_MASK_0001, 0x10, 0x00, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x0d4, ERIAR_MASK_0011, 0x0c00, 0xff00, ERIAR_EXGMAC);
+
+	RTL_W8(MaxTxPacketSize, EarlySize);
+
+	rtl_disable_clock_request(pdev);
+
+	RTL_W32(TxConfig, RTL_R32(TxConfig) | TXCFG_AUTO_FIFO);
+	RTL_W8(MCU, RTL_R8(MCU) & ~NOW_IS_OOB);
+
+	/* Adjust EEE LED frequency */
+	RTL_W8(EEE_LED, RTL_R8(EEE_LED) & ~0x07);
+
+	RTL_W8(DLLPR, RTL_R8(DLLPR) | PFM_EN);
+	RTL_W32(MISC, RTL_R32(MISC) | PWM_EN);
+	RTL_W8(Config5, RTL_R8(Config5) & ~Spi_en);
+}
+
+static void rtl_hw_start_8168f(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	rtl_eri_write(tp, 0xc0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xb8, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xc8, ERIAR_MASK_1111, 0x00100002, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xe8, ERIAR_MASK_1111, 0x00100006, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x00, 0x01, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x01, 0x00, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x1b0, ERIAR_MASK_0001, 0x10, 0x00, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x1d0, ERIAR_MASK_0001, 0x10, 0x00, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xcc, ERIAR_MASK_1111, 0x00000050, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xd0, ERIAR_MASK_1111, 0x00000060, ERIAR_EXGMAC);
+
+	RTL_W8(MaxTxPacketSize, EarlySize);
+
+	rtl_disable_clock_request(pdev);
+
+	RTL_W32(TxConfig, RTL_R32(TxConfig) | TXCFG_AUTO_FIFO);
+	RTL_W8(MCU, RTL_R8(MCU) & ~NOW_IS_OOB);
+	RTL_W8(DLLPR, RTL_R8(DLLPR) | PFM_EN);
+	RTL_W32(MISC, RTL_R32(MISC) | PWM_EN);
+	RTL_W8(Config5, RTL_R8(Config5) & ~Spi_en);
+}
+
+static void rtl_hw_start_8168f_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	static const struct ephy_info e_info_8168f_1[] = {
+		{ 0x06, 0x00c0,	0x0020 },
+		{ 0x08, 0x0001,	0x0002 },
+		{ 0x09, 0x0000,	0x0080 },
+		{ 0x19, 0x0000,	0x0224 }
+	};
+
+	rtl_hw_start_8168f(tp);
+
+	rtl_ephy_init(tp, e_info_8168f_1, ARRAY_SIZE(e_info_8168f_1));
+
+	rtl_w1w0_eri(tp, 0x0d4, ERIAR_MASK_0011, 0x0c00, 0xff00, ERIAR_EXGMAC);
+
+	/* Adjust EEE LED frequency */
+	RTL_W8(EEE_LED, RTL_R8(EEE_LED) & ~0x07);
+}
+
+static void rtl_hw_start_8411(struct rtl8169_private *tp)
+{
+	static const struct ephy_info e_info_8168f_1[] = {
+		{ 0x06, 0x00c0,	0x0020 },
+		{ 0x0f, 0xffff,	0x5200 },
+		{ 0x1e, 0x0000,	0x4000 },
+		{ 0x19, 0x0000,	0x0224 }
+	};
+
+	rtl_hw_start_8168f(tp);
+
+	rtl_ephy_init(tp, e_info_8168f_1, ARRAY_SIZE(e_info_8168f_1));
+
+	rtl_w1w0_eri(tp, 0x0d4, ERIAR_MASK_0011, 0x0c00, 0x0000, ERIAR_EXGMAC);
+}
+
+static void rtl_hw_start_8168g_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	RTL_W32(TxConfig, RTL_R32(TxConfig) | TXCFG_AUTO_FIFO);
+
+	#if !defined(RTL_ADJUST_FIFO_THRESHOLD)
+	rtl_eri_write(tp, 0xc8, ERIAR_MASK_0101, 0x080002, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xcc, ERIAR_MASK_0001, 0x38, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xd0, ERIAR_MASK_0001, 0x48, ERIAR_EXGMAC);
+	#endif /* !RTL_ADJUST_FIFO_THRESHOLD */
+	rtl_eri_write(tp, 0xe8, ERIAR_MASK_1111, 0x00100006, ERIAR_EXGMAC);
+
+	rtl_csi_access_enable_1(tp);
+
+	rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x00, 0x01, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x01, 0x00, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0x2f8, ERIAR_MASK_0011, 0x1d8f, ERIAR_EXGMAC);
+
+	RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+	RTL_W32(MISC, RTL_R32(MISC) & ~RXDV_GATED_EN);
+	RTL_W8(MaxTxPacketSize, EarlySize);
+
+	rtl_eri_write(tp, 0xc0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xb8, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+
+	/* Adjust EEE LED frequency */
+	RTL_W8(EEE_LED, RTL_R8(EEE_LED) & ~0x07);
+
+	rtl_w1w0_eri(tp, 0x2fc, ERIAR_MASK_0001, 0x01, 0x06, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x1b0, ERIAR_MASK_0011, 0x0000, 0x1000, ERIAR_EXGMAC);
+}
+
+static void rtl_hw_start_8168g_2(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	static const struct ephy_info e_info_8168g_2[] = {
+		{ 0x00, 0x0000,	0x0008 },
+		{ 0x0c, 0x3df0,	0x0200 },
+		{ 0x19, 0xffff,	0xfc00 },
+		{ 0x1e, 0xffff,	0x20eb }
+	};
+
+	rtl_hw_start_8168g_1(tp);
+
+	// LED setting  add by yukuen
+	if (tp->led_cfg)
+		RTL_W32(LEDSEL, 0x00060000 | tp->led_cfg);
+	else {
+		#if defined(CONFIG_ARCH_RTD129x)
+		RTL_W32(LEDSEL, 0x000670ca);
+		#elif defined(CONFIG_ARCH_RTD139x)
+		RTL_W32(LEDSEL, 0x000679a9);
+		#elif defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+		RTL_W32(LEDSEL, 0x00067ca9);
+		#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x |
+			  CONFIG_ARCH_RTD16xx | CONFIG_ARCH_RTD13xx */
+	}
+
+	/* disable aspm and clock request before access ephy */
+	RTL_W8(Config2, RTL_R8(Config2) & ~ClkReqEn);
+	RTL_W8(Config5, RTL_R8(Config5) & ~ASPM_en);
+	rtl_ephy_init(tp, e_info_8168g_2, ARRAY_SIZE(e_info_8168g_2));
+}
+
+static void rtl_hw_start_8168(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	#if defined(CONFIG_ARCH_RTD13xx)
+	u32 tmp;
+	u32 phy_status;
+	#endif
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	rtl_set_rx_max_size(ioaddr, rx_buf_sz);
+
+	#if defined(CONFIG_RTL_RX_NO_COPY)
+	tp->cp_cmd |= RTL_R16(CPlusCmd) | PktCntrDisable | INTT_3;
+	#else
+	tp->cp_cmd |= RTL_R16(CPlusCmd) | PktCntrDisable | INTT_1;
+	#endif /* CONFIG_RTL_RX_NO_COPY */
+
+	RTL_W16(CPlusCmd, tp->cp_cmd);
+
+	RTL_W16(IntrMitigate, 0x5151);
+
+	/* Work around for RxFIFO overflow. */
+	if (tp->mac_version == RTL_GIGA_MAC_VER_11) {
+		tp->event_slow |= RxFIFOOver | PCSTimeout;
+		tp->event_slow &= ~RxOverflow;
+	}
+
+	rtl_set_rx_tx_desc_registers(tp, ioaddr);
+
+	rtl_set_rx_tx_config_registers(tp);
+
+	#if defined(RTL_TX_NO_CLOSE)
+	/* enable tx no close mode */
+	r8169soc_ocp_reg_write(tp, 0xE610,
+		(r8169soc_ocp_reg_read(tp, 0xE610) | (BIT(4) | BIT(6))));
+	#endif /* RTL_TX_NO_CLOSE */
+
+	#if defined(RTL_ADJUST_FIFO_THRESHOLD)
+	tp->event_slow &= ~RxOverflow;
+
+	/* TX FIFO threshold */
+	r8169soc_ocp_reg_write(tp, 0xE618, 0x0006);
+	r8169soc_ocp_reg_write(tp, 0xE61A, 0x0010);
+
+	/* RX FIFO threshold */
+	r8169soc_ocp_reg_write(tp, 0xC0A0, 0x0002);
+	r8169soc_ocp_reg_write(tp, 0xC0A2, 0x0008);
+	r8169soc_ocp_reg_write(tp, 0xC0A4, 0x0088);
+	r8169soc_ocp_reg_write(tp, 0xC0A8, 0x00A8);
+	#endif /* RTL_ADJUST_FIFO_THRESHOLD */
+
+	#if defined(CONFIG_ARCH_RTD16xx)
+	/* disable pause frame resend caused by nearfull for revision A01 */
+	if (get_rtd_chip_revision() == RTD_CHIP_A01)
+		r8169soc_ocp_reg_write(tp, 0xE862,
+			(r8169soc_ocp_reg_read(tp, 0xE862) | BIT(0)));
+	#endif /* CONFIG_ARCH_RTD16xx */
+
+	RTL_R8(IntrMask);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_11:
+		rtl_hw_start_8168bb(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+		rtl_hw_start_8168bef(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_18:
+		rtl_hw_start_8168cp_1(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_19:
+		rtl_hw_start_8168c_1(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_20:
+		rtl_hw_start_8168c_2(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_21:
+		rtl_hw_start_8168c_3(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_22:
+		rtl_hw_start_8168c_4(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_23:
+		rtl_hw_start_8168cp_2(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_24:
+		rtl_hw_start_8168cp_3(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+		rtl_hw_start_8168d(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_28:
+		rtl_hw_start_8168d_4(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_31:
+		rtl_hw_start_8168dp(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+		rtl_hw_start_8168e_1(tp);
+		break;
+	case RTL_GIGA_MAC_VER_34:
+		rtl_hw_start_8168e_2(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_35:
+	case RTL_GIGA_MAC_VER_36:
+		rtl_hw_start_8168f_1(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_38:
+		rtl_hw_start_8411(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+		rtl_hw_start_8168g_1(tp);
+		break;
+	case RTL_GIGA_MAC_VER_42:
+		rtl_hw_start_8168g_2(tp);
+		break;
+
+	default:
+		printk(KERN_ERR PFX "%s: unknown chipset (mac_version = %d).\n",
+			dev->name, tp->mac_version);
+		break;
+	}
+
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+
+	#if defined(CONFIG_ARCH_RTD13xx)
+	phy_status = r8169soc_ocp_reg_read(tp, 0xde40);
+	switch (tp->output_mode) {
+	case OUTPUT_EMBEDDED_PHY:
+		/* do nothing */
+		break;
+	case OUTPUT_RMII:
+		/* adjust RMII interface setting, speed */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea30) & ~(BIT(6) | BIT(5));
+		switch (phy_status & 0x0030) { /* link speed */
+		case 0x0000:	/* 10M, ETN spec, RGMII clock speed = 2.5MHz */
+			break;
+		case 0x0010:	/* 100M, ETN spec, RGMII clock speed = 25MHz */
+			tmp |= BIT(5);
+		}
+		/* adjust RGMII interface setting, duplex */
+		if ((phy_status & BIT(3)) == 0)	/* ETN spec, half duplex */
+			tmp &= ~BIT(4);
+		else	/* ETN spec, full duplex */
+			tmp |= BIT(4);
+		r8169soc_ocp_reg_write(tp, 0xea30, tmp);
+		break;
+	case OUTPUT_RGMII_TO_MAC:
+	case OUTPUT_RGMII_TO_PHY:
+		/* adjust RGMII interface setting, duplex */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(4) | BIT(3));
+		switch (phy_status & 0x0030) { /* link speed */
+		case 0x0000:	/* 10M, ETN spec, RGMII clock speed = 2.5MHz */
+			break;
+		case 0x0010:	/* 100M, ETN spec, RGMII clock speed = 25MHz */
+			tmp |= BIT(3);
+			break;
+		case 0x0020:	/* 1000M, ETN spec, RGMII clock speed = 125MHz */
+			tmp |= BIT(4);
+			break;
+		}
+		/* adjust RGMII interface setting, duplex */
+		if ((phy_status & BIT(3)) == 0)	/* ETN spec, half duplex */
+			tmp &= ~BIT(2);
+		else	/* ETN spec, full duplex */
+			tmp |= BIT(2);
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+	}
+	#endif /* CONFIG_ARCH_RTD13xx */
+
+	rtl_set_rx_mode(dev);
+
+	RTL_W16(MultiIntr, RTL_R16(MultiIntr) & 0xF000);
+}
+
+#define R810X_CPCMD_QUIRK_MASK (\
+	EnableBist | \
+	Mac_dbgo_oe | \
+	Force_half_dup | \
+	Force_rxflow_en | \
+	Force_txflow_en | \
+	Cxpl_dbg_sel | \
+	ASF | \
+	PktCntrDisable | \
+	Mac_dbgo_sel)
+
+static void rtl_hw_start_8102e_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+	static const struct ephy_info e_info_8102e_1[] = {
+		{ 0x01,	0, 0x6e65 },
+		{ 0x02,	0, 0x091f },
+		{ 0x03,	0, 0xc2f9 },
+		{ 0x06,	0, 0xafb5 },
+		{ 0x07,	0, 0x0e00 },
+		{ 0x19,	0, 0xec80 },
+		{ 0x01,	0, 0x2e65 },
+		{ 0x01,	0, 0x6e65 }
+	};
+	u8 cfg1;
+
+	rtl_csi_access_enable_2(tp);
+
+	RTL_W8(DBG_REG, FIX_NAK_1);
+
+	rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W8(Config1,
+		   LEDS1 | LEDS0 | Speed_down | MEMMAP | IOMAP | VPD | PMEnable);
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+	cfg1 = RTL_R8(Config1);
+	if ((cfg1 & LEDS0) && (cfg1 & LEDS1))
+		RTL_W8(Config1, cfg1 & ~LEDS0);
+
+	rtl_ephy_init(tp, e_info_8102e_1, ARRAY_SIZE(e_info_8102e_1));
+}
+
+static void rtl_hw_start_8102e_2(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W8(Config1, MEMMAP | IOMAP | VPD | PMEnable);
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+}
+
+static void rtl_hw_start_8102e_3(struct rtl8169_private *tp)
+{
+	rtl_hw_start_8102e_2(tp);
+
+	rtl_ephy_write(tp, 0x03, 0xc2f9);
+}
+
+static void rtl_hw_start_8105e_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	static const struct ephy_info e_info_8105e_1[] = {
+		{ 0x07,	0, 0x4000 },
+		{ 0x19,	0, 0x0200 },
+		{ 0x19,	0, 0x0020 },
+		{ 0x1e,	0, 0x2000 },
+		{ 0x03,	0, 0x0001 },
+		{ 0x19,	0, 0x0100 },
+		{ 0x19,	0, 0x0004 },
+		{ 0x0a,	0, 0x0020 }
+	};
+
+	/* Force LAN exit from ASPM if Rx/Tx are not idle */
+	RTL_W32(FuncEvent, RTL_R32(FuncEvent) | 0x002800);
+
+	/* Disable Early Tally Counter */
+	RTL_W32(FuncEvent, RTL_R32(FuncEvent) & ~0x010000);
+
+	RTL_W8(MCU, RTL_R8(MCU) | EN_NDP | EN_OOB_RESET);
+	RTL_W8(DLLPR, RTL_R8(DLLPR) | PFM_EN);
+
+	rtl_ephy_init(tp, e_info_8105e_1, ARRAY_SIZE(e_info_8105e_1));
+}
+
+static void rtl_hw_start_8105e_2(struct rtl8169_private *tp)
+{
+	rtl_hw_start_8105e_1(tp);
+	rtl_ephy_write(tp, 0x1e, rtl_ephy_read(tp, 0x1e) | 0x8000);
+}
+
+static void rtl_hw_start_8402(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	static const struct ephy_info e_info_8402[] = {
+		{ 0x19,	0xffff, 0xff64 },
+		{ 0x1e,	0, 0x4000 }
+	};
+
+	rtl_csi_access_enable_2(tp);
+
+	/* Force LAN exit from ASPM if Rx/Tx are not idle */
+	RTL_W32(FuncEvent, RTL_R32(FuncEvent) | 0x002800);
+
+	RTL_W32(TxConfig, RTL_R32(TxConfig) | TXCFG_AUTO_FIFO);
+	RTL_W8(MCU, RTL_R8(MCU) & ~NOW_IS_OOB);
+
+	rtl_ephy_init(tp, e_info_8402, ARRAY_SIZE(e_info_8402));
+
+	rtl_tx_performance_tweak(tp->pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	rtl_eri_write(tp, 0xc8, ERIAR_MASK_1111, 0x00000002, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xe8, ERIAR_MASK_1111, 0x00000006, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x00, 0x01, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x01, 0x00, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xc0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xb8, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x0d4, ERIAR_MASK_0011, 0x0e00, 0xff00, ERIAR_EXGMAC);
+}
+
+static void rtl_hw_start_8106(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* Force LAN exit from ASPM if Rx/Tx are not idle */
+	RTL_W32(FuncEvent, RTL_R32(FuncEvent) | 0x002800);
+
+	RTL_W32(MISC, (RTL_R32(MISC) | DISABLE_LAN_EN) & ~EARLY_TALLY_EN);
+	RTL_W8(MCU, RTL_R8(MCU) | EN_NDP | EN_OOB_RESET);
+	RTL_W8(DLLPR, RTL_R8(DLLPR) & ~PFM_EN);
+}
+
+static void rtl_hw_start_8101(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+//	struct platform_device *pdev = tp->pdev;
+
+	if (tp->mac_version >= RTL_GIGA_MAC_VER_30)
+		tp->event_slow &= ~RxFIFOOver;
+
+//	if (tp->mac_version == RTL_GIGA_MAC_VER_13 ||
+//	    tp->mac_version == RTL_GIGA_MAC_VER_16)
+//		pcie_capability_set_word(pdev, PCI_EXP_DEVCTL,
+//					 PCI_EXP_DEVCTL_NOSNOOP_EN);
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	rtl_set_rx_max_size(ioaddr, rx_buf_sz);
+
+	tp->cp_cmd &= ~R810X_CPCMD_QUIRK_MASK;
+	RTL_W16(CPlusCmd, tp->cp_cmd);
+
+	rtl_set_rx_tx_desc_registers(tp, ioaddr);
+
+	rtl_set_rx_tx_config_registers(tp);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_07:
+		rtl_hw_start_8102e_1(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_08:
+		rtl_hw_start_8102e_3(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_09:
+		rtl_hw_start_8102e_2(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_29:
+		rtl_hw_start_8105e_1(tp);
+		break;
+	case RTL_GIGA_MAC_VER_30:
+		rtl_hw_start_8105e_2(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_37:
+		rtl_hw_start_8402(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_39:
+		rtl_hw_start_8106(tp);
+		break;
+	case RTL_GIGA_MAC_VER_43:
+		rtl_hw_start_8168g_2(tp);
+		break;
+	}
+
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	RTL_W16(IntrMitigate, 0x0000);
+
+	RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+
+	rtl_set_rx_mode(dev);
+
+	RTL_R8(IntrMask);
+
+	RTL_W16(MultiIntr, RTL_R16(MultiIntr) & 0xf000);
+}
+
+static int link_status(void *data)
+{
+	struct net_device *dev = data;
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	set_user_nice(current, 5);
+	printk("[Ethernet] Watch link status change.\n");
+
+	while(!kthread_should_stop()){
+		wait_event_interruptible(tp->thr_wait, kthread_should_stop() || tp->link_chg);
+		if(kthread_should_stop()){
+			break;
+		}
+		else if(!tp->link_chg)
+			continue;
+		else
+			tp->link_chg = 0;
+
+		// Send uevent about link status
+		if(tp->link_ok(ioaddr)){
+			kobject_uevent(&tp->dev->dev.kobj, KOBJ_LINKUP);
+		}
+		else{
+			kobject_uevent(&tp->dev->dev.kobj, KOBJ_LINKDOWN);
+		}
+	}
+
+	do_exit(0);
+}
+
+static int rtl8169_change_mtu(struct net_device *dev, int new_mtu)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (new_mtu < ETH_ZLEN ||
+		new_mtu > rtl_chip_infos[tp->mac_version].jumbo_max)
+		return -EINVAL;
+
+	#if defined(CONFIG_RTL_RX_NO_COPY)
+	if (!netif_running(dev)){
+		rx_buf_sz_new = (new_mtu > ETH_DATA_LEN) ? new_mtu + ETH_HLEN + 8 + 1 : RX_BUF_SIZE;
+		rx_buf_sz = rx_buf_sz_new;
+		goto out;
+	}
+
+	rx_buf_sz_new = (new_mtu > ETH_DATA_LEN) ? new_mtu + ETH_HLEN + 8 + 1 : RX_BUF_SIZE;
+
+	rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+
+out:
+	#endif /* CONFIG_RTL_RX_NO_COPY */
+
+	if (new_mtu > ETH_DATA_LEN)
+		rtl_hw_jumbo_enable(tp);
+	else
+		rtl_hw_jumbo_disable(tp);
+
+	dev->mtu = new_mtu;
+	netdev_update_features(dev);
+
+	return 0;
+}
+
+static inline void rtl8169_make_unusable_by_asic(struct RxDesc *desc)
+{
+	desc->addr = cpu_to_le64(0x0badbadbadbadbadull);
+	desc->opts1 &= ~cpu_to_le32(DescOwn | RsvdMask);
+}
+
+#if defined(CONFIG_RTL_RX_NO_COPY)
+static void rtl8169_free_rx_databuff(struct rtl8169_private *tp,
+					struct sk_buff **data_buff, struct RxDesc *desc)
+{
+	if (!tp->acp_enable)
+		dma_unmap_single(&tp->pdev->dev, le64_to_cpu(desc->addr),
+				 rx_buf_sz, DMA_FROM_DEVICE);
+
+	dev_kfree_skb(*data_buff);
+	*data_buff = NULL;
+	rtl8169_make_unusable_by_asic(desc);
+}
+#else
+static void rtl8169_free_rx_databuff(struct rtl8169_private *tp,
+					 void **data_buff, struct RxDesc *desc)
+{
+	if (!tp->acp_enable)
+		dma_unmap_single(&tp->pdev->dev, le64_to_cpu(desc->addr),
+				 rx_buf_sz, DMA_FROM_DEVICE);
+
+	kfree(*data_buff);
+	*data_buff = NULL;
+	rtl8169_make_unusable_by_asic(desc);
+}
+#endif /* CONFIG_RTL_RX_NO_COPY */
+
+static inline void rtl8169_mark_to_asic(struct RxDesc *desc, u32 rx_buf_sz)
+{
+	u32 eor = le32_to_cpu(desc->opts1) & RingEnd;
+
+	desc->opts1 = cpu_to_le32(DescOwn | eor | rx_buf_sz);
+}
+
+static inline void rtl8169_map_to_asic(struct RxDesc *desc, dma_addr_t mapping,
+					   u32 rx_buf_sz)
+{
+	desc->addr = cpu_to_le64(mapping);
+	wmb();
+	rtl8169_mark_to_asic(desc, rx_buf_sz);
+}
+
+static inline void *rtl8169_align(void *data)
+{
+	return (void *)ALIGN((long)data, 16);
+}
+
+#if defined(CONFIG_RTL_RX_NO_COPY)
+static int
+rtl8168_alloc_rx_skb(struct rtl8169_private *tp,
+			struct sk_buff **sk_buff,
+			struct RxDesc *desc,
+			int rx_buf_sz)
+{
+	struct device *d = &tp->pdev->dev;
+	struct sk_buff *skb;
+	dma_addr_t mapping;
+	int ret = 0;
+
+	skb = dev_alloc_skb(rx_buf_sz + RTK_RX_ALIGN);
+	if (!skb)
+		goto err_out;
+
+	skb_reserve(skb, RTK_RX_ALIGN);
+
+	if (tp->acp_enable) {
+			mapping = virt_to_phys(skb->data);
+	} else {
+		mapping = dma_map_single(d, skb->data, rx_buf_sz,
+					DMA_FROM_DEVICE);
+
+		if (unlikely(dma_mapping_error(d, mapping))) {
+			if (unlikely(net_ratelimit()))
+				netif_err(tp, drv, tp->dev, "Failed to map RX DMA!\n");
+			goto err_out;
+		}
+	}
+	*sk_buff = skb;
+	rtl8169_map_to_asic(desc, mapping, rx_buf_sz);
+
+out:
+	return ret;
+
+err_out:
+	if (skb)
+		dev_kfree_skb(skb);
+	ret = -ENOMEM;
+	rtl8169_make_unusable_by_asic(desc);
+	goto out;
+}
+#else
+static struct sk_buff *rtl8169_alloc_rx_data(struct rtl8169_private *tp,
+						 struct RxDesc *desc)
+{
+	void *data;
+	dma_addr_t mapping;
+	struct device *d = &tp->pdev->dev;
+	struct net_device *dev = tp->dev;
+	int node = dev->dev.parent ? dev_to_node(dev->dev.parent) : -1;
+
+	data = kmalloc_node(rx_buf_sz, GFP_KERNEL, node);
+	if (!data)
+		return NULL;
+
+	if (rtl8169_align(data) != data) {
+		kfree(data);
+		data = kmalloc_node(rx_buf_sz + 15, GFP_KERNEL, node);
+		if (!data)
+			return NULL;
+	}
+
+	if (tp->acp_enable) {
+		mapping = virt_to_phys(rtl8169_align(data));
+	} else {
+		mapping = dma_map_single(d, rtl8169_align(data), rx_buf_sz,
+					 DMA_FROM_DEVICE);
+		if (unlikely(dma_mapping_error(d, mapping))) {
+			if (net_ratelimit())
+				netif_err(tp, drv, tp->dev, "Failed to map RX DMA!\n");
+			goto err_out;
+		}
+	}
+
+	rtl8169_map_to_asic(desc, mapping, rx_buf_sz);
+	return data;
+
+err_out:
+	kfree(data);
+	return NULL;
+}
+#endif /* CONFIG_RTL_RX_NO_COPY */
+
+static void rtl8169_rx_clear(struct rtl8169_private *tp)
+{
+	unsigned int i;
+
+	for (i = 0; i < NUM_RX_DESC; i++) {
+		if (tp->Rx_databuff[i]) {
+			rtl8169_free_rx_databuff(tp, tp->Rx_databuff + i,
+						tp->RxDescArray + i);
+		}
+	}
+}
+
+static inline void rtl8169_mark_as_last_descriptor(struct RxDesc *desc)
+{
+	desc->opts1 |= cpu_to_le32(RingEnd);
+}
+
+#if defined(CONFIG_RTL_RX_NO_COPY)
+static u32
+rtl8168_rx_fill(struct rtl8169_private *tp,
+		struct net_device *dev,
+		u32 start,
+		u32 end)
+{
+	u32 cur;
+
+	for (cur = start; end - cur > 0; cur++) {
+		int ret, i = cur % NUM_RX_DESC;
+
+		if (tp->Rx_databuff[i])
+			continue;
+		ret = rtl8168_alloc_rx_skb(tp, tp->Rx_databuff + i,
+						tp->RxDescArray + i, rx_buf_sz);
+		if (ret < 0)
+			break;
+		if(i==(NUM_RX_DESC - 1))
+			rtl8169_mark_as_last_descriptor(tp->RxDescArray + NUM_RX_DESC - 1);
+	}
+	return cur - start;
+}
+#else
+static int rtl8169_rx_fill(struct rtl8169_private *tp)
+{
+	unsigned int i;
+
+	for (i = 0; i < NUM_RX_DESC; i++) {
+		void *data;
+
+		if (tp->Rx_databuff[i])
+			continue;
+
+		data = rtl8169_alloc_rx_data(tp, tp->RxDescArray + i);
+		if (!data) {
+			rtl8169_make_unusable_by_asic(tp->RxDescArray + i);
+			goto err_out;
+		}
+		tp->Rx_databuff[i] = data;
+	}
+
+	rtl8169_mark_as_last_descriptor(tp->RxDescArray + NUM_RX_DESC - 1);
+	return 0;
+
+err_out:
+	rtl8169_rx_clear(tp);
+	return -ENOMEM;
+}
+#endif /* CONFIG_RTL_RX_NO_COPY */
+
+static int rtl8169_init_ring(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int ret;
+
+	rtl8169_init_ring_indexes(tp);
+
+	memset(tp->tx_skb, 0x0, NUM_TX_DESC * sizeof(struct ring_info));
+	memset(tp->Rx_databuff, 0x0, NUM_RX_DESC * sizeof(void *));
+
+	#if defined(CONFIG_RTL_RX_NO_COPY)
+	ret = rtl8168_rx_fill(tp, dev, 0, NUM_RX_DESC);
+	if(ret < NUM_RX_DESC)
+		ret = -ENOMEM;
+	else
+		ret = 0;
+	#else
+	ret = rtl8169_rx_fill(tp);
+	#endif /* CONFIG_RTL_RX_NO_COPY */
+
+	return ret;
+}
+
+static void rtl8169_unmap_tx_skb(struct rtl8169_private *tp, struct device *d,
+				 struct ring_info *tx_skb, struct TxDesc *desc)
+{
+	unsigned int len = tx_skb->len;
+
+	if (!tp->acp_enable)
+		dma_unmap_single(d, le64_to_cpu(desc->addr), len,
+				 DMA_TO_DEVICE);
+
+	desc->opts1 = 0x00;
+	desc->opts2 = 0x00;
+	desc->addr = 0x00;
+	tx_skb->len = 0;
+}
+
+static void rtl8169_tx_clear_range(struct rtl8169_private *tp, u32 start,
+				   unsigned int n)
+{
+	unsigned int i;
+
+	for (i = 0; i < n; i++) {
+		unsigned int entry = (start + i) % NUM_TX_DESC;
+		struct ring_info *tx_skb = tp->tx_skb + entry;
+		unsigned int len = tx_skb->len;
+
+		if (len) {
+			struct sk_buff *skb = tx_skb->skb;
+
+			rtl8169_unmap_tx_skb(tp, &tp->pdev->dev, tx_skb,
+						 tp->TxDescArray + entry);
+			if (skb) {
+				tp->dev->stats.tx_dropped++;
+				dev_kfree_skb(skb);
+				tx_skb->skb = NULL;
+			}
+		}
+	}
+}
+
+static void rtl8169_tx_clear(struct rtl8169_private *tp)
+{
+	rtl8169_tx_clear_range(tp, tp->dirty_tx, NUM_TX_DESC);
+	tp->cur_tx = tp->dirty_tx = 0;
+}
+
+static void rtl_reset_work(struct rtl8169_private *tp)
+{
+	struct net_device *dev = tp->dev;
+	int i;
+
+	napi_disable(&tp->napi);
+	netif_stop_queue(dev);
+	synchronize_sched();
+
+	rtl8169_hw_reset(tp);
+
+	#if defined(CONFIG_RTL_RX_NO_COPY)
+	rtl8169_rx_clear(tp);
+	rtl8169_tx_clear(tp);
+
+	if(rx_buf_sz_new != rx_buf_sz)
+		rx_buf_sz = rx_buf_sz_new;
+
+	memset(tp->TxDescArray, 0x0, NUM_TX_DESC * sizeof(struct TxDesc));
+	for (i = 0; i < NUM_TX_DESC; i++) {
+		if (i == (NUM_TX_DESC - 1))
+			tp->TxDescArray[i].opts1 = cpu_to_le32(RingEnd);
+	}
+	memset(tp->RxDescArray, 0x0, NUM_RX_DESC * sizeof(struct RxDesc));
+
+	rtl8169_init_ring(dev);
+	#else
+	for (i = 0; i < NUM_RX_DESC; i++)
+		rtl8169_mark_to_asic(tp->RxDescArray + i, rx_buf_sz);
+
+	rtl8169_tx_clear(tp);
+	rtl8169_init_ring_indexes(tp);
+	#endif /* CONFIG_RTL_RX_NO_COPY */
+
+	napi_enable(&tp->napi);
+	rtl_hw_start(dev);
+	netif_wake_queue(dev);
+	rtl8169_check_link_status(dev, tp, tp->mmio_addr);
+}
+
+static void rtl8169_tx_timeout(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+}
+
+static int rtl8169_xmit_frags(struct rtl8169_private *tp, struct sk_buff *skb,
+				  u32 *opts)
+{
+	struct skb_shared_info *info = skb_shinfo(skb);
+	unsigned int cur_frag, entry;
+	struct TxDesc * uninitialized_var(txd);
+	struct device *d = &tp->pdev->dev;
+
+	entry = tp->cur_tx;
+	for (cur_frag = 0; cur_frag < info->nr_frags; cur_frag++) {
+		const skb_frag_t *frag = info->frags + cur_frag;
+		dma_addr_t mapping;
+		u32 status, len;
+		void *addr;
+
+		entry = (entry + 1) % NUM_TX_DESC;
+
+		txd = tp->TxDescArray + entry;
+		len = skb_frag_size(frag);
+		addr = skb_frag_address(frag);
+		if (tp->acp_enable) {
+			mapping = virt_to_phys(addr);
+		} else {
+			mapping = dma_map_single(d, addr, len, DMA_TO_DEVICE);
+			if (unlikely(dma_mapping_error(d, mapping))) {
+				if (net_ratelimit())
+					netif_err(tp, drv, tp->dev,
+						  "Failed to map TX fragments DMA!\n");
+				goto err_out;
+			}
+		}
+
+		/* Anti gcc 2.95.3 bugware (sic) */
+		status = opts[0] | len |
+			(RingEnd * !((entry + 1) % NUM_TX_DESC));
+
+		txd->opts1 = cpu_to_le32(status);
+		txd->opts2 = cpu_to_le32(opts[1]);
+		txd->addr = cpu_to_le64(mapping);
+
+		tp->tx_skb[entry].len = len;
+	}
+
+	if (cur_frag) {
+		tp->tx_skb[entry].skb = skb;
+		txd->opts1 |= cpu_to_le32(LastFrag);
+	}
+
+	return cur_frag;
+
+err_out:
+	rtl8169_tx_clear_range(tp, tp->cur_tx + 1, cur_frag);
+	return -EIO;
+}
+
+static bool rtl_skb_pad(struct sk_buff *skb)
+{
+	if (skb_padto(skb, ETH_ZLEN))
+		return false;
+	skb_put(skb, ETH_ZLEN - skb->len);
+	return true;
+}
+
+static bool rtl_test_hw_pad_bug(struct rtl8169_private *tp, struct sk_buff *skb)
+{
+	return skb->len < ETH_ZLEN && tp->mac_version == RTL_GIGA_MAC_VER_34;
+}
+
+static inline bool rtl8169_tso_csum(struct rtl8169_private *tp,
+					struct sk_buff *skb, u32 *opts)
+{
+	const struct rtl_tx_desc_info *info = tx_desc_info + tp->txd_version;
+	u32 mss = skb_shinfo(skb)->gso_size;
+	int offset = info->opts_offset;
+
+	if (mss) {
+		opts[0] |= TD_LSO;
+		opts[offset] |= min(mss, TD_MSS_MAX) << info->mss_shift;
+	} else if (skb->ip_summed == CHECKSUM_PARTIAL) {
+		const struct iphdr *ip = ip_hdr(skb);
+
+		if (unlikely(rtl_test_hw_pad_bug(tp, skb)))
+			return skb_checksum_help(skb) == 0 && rtl_skb_pad(skb);
+
+		if (ip->protocol == IPPROTO_TCP)
+			opts[offset] |= info->checksum.tcp;
+		else if (ip->protocol == IPPROTO_UDP)
+			opts[offset] |= info->checksum.udp;
+		else
+			WARN_ON_ONCE(1);
+	} else {
+		if (unlikely(rtl_test_hw_pad_bug(tp, skb)))
+			return rtl_skb_pad(skb);
+	}
+	return true;
+}
+
+static netdev_tx_t rtl8169_start_xmit(struct sk_buff *skb,
+					  struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	unsigned int entry = tp->cur_tx % NUM_TX_DESC;
+	struct TxDesc *txd = tp->TxDescArray + entry;
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct device *d = &tp->pdev->dev;
+	dma_addr_t mapping;
+	u32 status, len;
+	u32 opts[2];
+	int frags;
+	#if defined(RTL_TX_NO_CLOSE)
+	u16 close_idx;
+	u16 tail_idx;
+	#endif /* RTL_TX_NO_CLOSE */
+
+	if (unlikely(!TX_FRAGS_READY_FOR(tp, skb_shinfo(skb)->nr_frags))) {
+		netif_err(tp, drv, dev, "BUG! Tx Ring full when queue awake!\n");
+		goto err_stop_0;
+	}
+
+	#if defined(RTL_TX_NO_CLOSE)
+	close_idx = RTL_R16(TX_DESC_CLOSE_IDX) & TX_DESC_CNT_MASK;
+	tail_idx = tp->cur_tx & TX_DESC_CNT_MASK;
+	if (((tail_idx > close_idx) && (tail_idx - close_idx == NUM_TX_DESC)) ||
+		((tail_idx < close_idx) &&
+		 (TX_DESC_CNT_SIZE - close_idx + tail_idx == NUM_TX_DESC)))
+		goto err_stop_0;
+	#else
+	if (unlikely(le32_to_cpu(txd->opts1) & DescOwn))
+		goto err_stop_0;
+	#endif /* RTL_TX_NO_CLOSE */
+
+	opts[1] = cpu_to_le32(rtl8169_tx_vlan_tag(skb));
+	opts[0] = DescOwn;
+
+	if (!rtl8169_tso_csum(tp, skb, opts))
+		goto err_update_stats;
+
+	len = skb_headlen(skb);
+	if (tp->acp_enable) {
+		mapping = virt_to_phys(skb->data);
+	} else {
+		mapping = dma_map_single(d, skb->data, len, DMA_TO_DEVICE);
+		if (unlikely(dma_mapping_error(d, mapping))) {
+			if (net_ratelimit())
+				netif_err(tp, drv, dev, "Failed to map TX DMA!\n");
+			goto err_dma_0;
+		}
+	}
+
+	tp->tx_skb[entry].len = len;
+	txd->addr = cpu_to_le64(mapping);
+
+	frags = rtl8169_xmit_frags(tp, skb, opts);
+	if (frags < 0)
+		goto err_dma_1;
+	else if (frags)
+		opts[0] |= FirstFrag;
+	else {
+		opts[0] |= FirstFrag | LastFrag;
+		tp->tx_skb[entry].skb = skb;
+	}
+
+	txd->opts2 = cpu_to_le32(opts[1]);
+
+	skb_tx_timestamp(skb);
+
+	wmb();
+
+	/* Anti gcc 2.95.3 bugware (sic) */
+	status = opts[0] | len | (RingEnd * !((entry + 1) % NUM_TX_DESC));
+	txd->opts1 = cpu_to_le32(status);
+
+	tp->cur_tx += frags + 1;
+
+	#if defined(RTL_TX_NO_CLOSE)
+	RTL_W16(TX_DESC_TAIL_IDX, tp->cur_tx & TX_DESC_CNT_MASK);
+	#endif /* RTL_TX_NO_CLOSE */
+
+	wmb();
+
+	RTL_W8(TxPoll, NPQ);
+
+	mmiowb();
+
+	if (!TX_FRAGS_READY_FOR(tp, MAX_SKB_FRAGS)) {
+		/* Avoid wrongly optimistic queue wake-up: rtl_tx thread must
+		 * not miss a ring update when it notices a stopped queue.
+		 */
+		smp_wmb();
+		netif_stop_queue(dev);
+		/* Sync with rtl_tx:
+		 * - publish queue status and cur_tx ring index (write barrier)
+		 * - refresh dirty_tx ring index (read barrier).
+		 * May the current thread have a pessimistic view of the ring
+		 * status and forget to wake up queue, a racing rtl_tx thread
+		 * can't.
+		 */
+		smp_mb();
+		if (TX_FRAGS_READY_FOR(tp, MAX_SKB_FRAGS))
+			netif_wake_queue(dev);
+	}
+
+	return NETDEV_TX_OK;
+
+err_dma_1:
+	rtl8169_unmap_tx_skb(tp, d, tp->tx_skb + entry, txd);
+err_dma_0:
+	dev_kfree_skb(skb);
+err_update_stats:
+	dev->stats.tx_dropped++;
+	return NETDEV_TX_OK;
+
+err_stop_0:
+	netif_stop_queue(dev);
+	dev->stats.tx_dropped++;
+	return NETDEV_TX_BUSY;
+}
+
+static void rtl8169_pcierr_interrupt(struct net_device *dev)
+{
+#if 0	//barry
+	struct rtl8169_private *tp = netdev_priv(dev);
+	struct platform_device *pdev = tp->pdev;
+	u16 pci_status, pci_cmd;
+
+	pci_read_config_word(pdev, PCI_COMMAND, &pci_cmd);
+	pci_read_config_word(pdev, PCI_STATUS, &pci_status);
+
+	netif_err(tp, intr, dev, "PCI error (cmd = 0x%04x, status = 0x%04x)\n",
+		  pci_cmd, pci_status);
+
+	/*
+	 * The recovery sequence below admits a very elaborated explanation:
+	 * - it seems to work;
+	 * - I did not see what else could be done;
+	 * - it makes iop3xx happy.
+	 *
+	 * Feel free to adjust to your needs.
+	 */
+	if (pdev->broken_parity_status)
+		pci_cmd &= ~PCI_COMMAND_PARITY;
+	else
+		pci_cmd |= PCI_COMMAND_SERR | PCI_COMMAND_PARITY;
+
+	pci_write_config_word(pdev, PCI_COMMAND, pci_cmd);
+
+	pci_write_config_word(pdev, PCI_STATUS,
+		pci_status & (PCI_STATUS_DETECTED_PARITY |
+		PCI_STATUS_SIG_SYSTEM_ERROR | PCI_STATUS_REC_MASTER_ABORT |
+		PCI_STATUS_REC_TARGET_ABORT | PCI_STATUS_SIG_TARGET_ABORT));
+
+	/* The infamous DAC f*ckup only happens at boot time */
+	if ((tp->cp_cmd & PCIDAC) && !tp->cur_rx) {
+		void __iomem *ioaddr = tp->mmio_addr;
+
+		netif_info(tp, intr, dev, "disabling PCI DAC\n");
+		tp->cp_cmd &= ~PCIDAC;
+		RTL_W16(CPlusCmd, tp->cp_cmd);
+		dev->features &= ~NETIF_F_HIGHDMA;
+	}
+
+	rtl8169_hw_reset(tp);
+
+	rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+#endif
+}
+
+static void rtl_tx(struct net_device *dev, struct rtl8169_private *tp)
+{
+	unsigned int dirty_tx, tx_left;
+	#if defined(RTL_TX_NO_CLOSE)
+	u16 close_idx;
+	u16 dirty_tx_idx;
+	void __iomem *ioaddr = tp->mmio_addr;
+	#endif /* RTL_TX_NO_CLOSE */
+
+	dirty_tx = tp->dirty_tx;
+	#if defined(RTL_TX_NO_CLOSE)
+	close_idx = RTL_R16(TX_DESC_CLOSE_IDX) & TX_DESC_CNT_MASK;
+	dirty_tx_idx = dirty_tx & TX_DESC_CNT_MASK;
+	smp_rmb();
+	if (dirty_tx_idx <= close_idx)
+		tx_left = close_idx - dirty_tx_idx;
+	else
+		tx_left = close_idx + TX_DESC_CNT_SIZE - dirty_tx_idx;
+	#else
+	smp_rmb();
+	tx_left = tp->cur_tx - dirty_tx;
+	#endif /* RTL_TX_NO_CLOSE */
+
+	while (tx_left > 0) {
+		unsigned int entry = dirty_tx % NUM_TX_DESC;
+		struct ring_info *tx_skb = tp->tx_skb + entry;
+		u32 status;
+
+		rmb();
+		status = le32_to_cpu(tp->TxDescArray[entry].opts1);
+		#if !defined(RTL_TX_NO_CLOSE)
+		if (status & DescOwn)
+			break;
+		#endif /* !RTL_TX_NO_CLOSE */
+
+		rtl8169_unmap_tx_skb(tp, &tp->pdev->dev, tx_skb,
+					 tp->TxDescArray + entry);
+		if (status & LastFrag) {
+			u64_stats_update_begin(&tp->tx_stats.syncp);
+			tp->tx_stats.packets++;
+			tp->tx_stats.bytes += tx_skb->skb->len;
+			u64_stats_update_end(&tp->tx_stats.syncp);
+			dev_kfree_skb(tx_skb->skb);
+			tx_skb->skb = NULL;
+		}
+		dirty_tx++;
+		tx_left--;
+	}
+
+	if (tp->dirty_tx != dirty_tx) {
+		tp->dirty_tx = dirty_tx;
+		/* Sync with rtl8169_start_xmit:
+		 * - publish dirty_tx ring index (write barrier)
+		 * - refresh cur_tx ring index and queue status (read barrier)
+		 * May the current thread miss the stopped queue condition,
+		 * a racing xmit thread can only have a right view of the
+		 * ring status.
+		 */
+		smp_mb();
+		if (netif_queue_stopped(dev) &&
+			TX_FRAGS_READY_FOR(tp, MAX_SKB_FRAGS)) {
+			netif_wake_queue(dev);
+		}
+		/*
+		 * 8168 hack: TxPoll requests are lost when the Tx packets are
+		 * too close. Let's kick an extra TxPoll request when a burst
+		 * of start_xmit activity is detected (if it is not detected,
+		 * it is slow enough). -- FR
+		 */
+		if (tp->cur_tx != dirty_tx) {
+			void __iomem *ioaddr = tp->mmio_addr;
+
+			RTL_W8(TxPoll, NPQ);
+		}
+	}
+}
+
+static inline int rtl8169_fragmented_frame(u32 status)
+{
+	return (status & (FirstFrag | LastFrag)) != (FirstFrag | LastFrag);
+}
+
+static inline void rtl8169_rx_csum(struct sk_buff *skb, u32 opts1)
+{
+	u32 status = opts1 & RxProtoMask;
+
+	if (((status == RxProtoTCP) && !(opts1 & TCPFail)) ||
+		((status == RxProtoUDP) && !(opts1 & UDPFail)))
+		skb->ip_summed = CHECKSUM_UNNECESSARY;
+	else
+		skb_checksum_none_assert(skb);
+}
+
+#if defined(CONFIG_RTL_RX_NO_COPY)
+static int rtl_rx(struct net_device *dev, struct rtl8169_private *tp, u32 budget)
+{
+	unsigned int cur_rx, rx_left;
+	unsigned int count,delta;
+	struct device *d = &tp->pdev->dev;
+
+	cur_rx = tp->cur_rx;
+
+	rx_left = NUM_RX_DESC + tp->dirty_rx - cur_rx;
+	rx_left = min(budget, rx_left);
+
+	for (; rx_left > 0; rx_left--, cur_rx++) {
+		unsigned int entry = cur_rx % NUM_RX_DESC;
+		struct RxDesc *desc = tp->RxDescArray + entry;
+		u32 status;
+
+		rmb();
+		status = le32_to_cpu(desc->opts1) & tp->opts1_mask;
+
+		if (status & DescOwn)
+			break;
+		if (unlikely(status & RxRES)) {
+			netif_info(tp, rx_err, dev, "Rx ERROR. status = %08x\n",
+				   status);
+			dev->stats.rx_errors++;
+			if (status & (RxRWT | RxRUNT))
+				dev->stats.rx_length_errors++;
+			if (status & RxCRC)
+				dev->stats.rx_crc_errors++;
+			if (status & RxFOVF) {
+				rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+				dev->stats.rx_fifo_errors++;
+			}
+			if ((status & (RxRUNT | RxCRC)) &&
+				!(status & (RxRWT | RxFOVF)) &&
+				(dev->features & NETIF_F_RXALL))
+				goto process_pkt;
+		} else {
+			struct sk_buff *skb;
+			dma_addr_t addr;
+			int pkt_size;
+
+process_pkt:
+
+			skb = tp->Rx_databuff[entry];
+			addr = le64_to_cpu(desc->addr);
+			if (likely(!(dev->features & NETIF_F_RXFCS)))
+				pkt_size = (status & 0x00003fff) - 4;
+			else
+				pkt_size = status & 0x00003fff;
+
+			/*
+			 * The driver does not support incoming fragmented
+			 * frames. They are seen as a symptom of over-mtu
+			 * sized frames.
+			 */
+			if (unlikely(rtl8169_fragmented_frame(status))) {
+				dev->stats.rx_dropped++;
+				dev->stats.rx_length_errors++;
+				continue;
+			}
+
+			if (!tp->acp_enable)
+				dma_sync_single_for_cpu(d, addr, pkt_size, DMA_FROM_DEVICE);
+			tp->Rx_databuff[entry] = NULL;
+			if (!tp->acp_enable)
+				dma_unmap_single(d, addr, pkt_size, DMA_FROM_DEVICE);
+
+			rtl8169_rx_csum(skb, status);
+			skb_put(skb, pkt_size);
+			skb->protocol = eth_type_trans(skb, dev);
+
+			rtl8169_rx_vlan_tag(desc, skb);
+
+			napi_gro_receive(&tp->napi, skb);
+
+			u64_stats_update_begin(&tp->rx_stats.syncp);
+			tp->rx_stats.packets++;
+			tp->rx_stats.bytes += pkt_size;
+			u64_stats_update_end(&tp->rx_stats.syncp);
+		}
+	}
+
+	count = cur_rx - tp->cur_rx;
+	tp->cur_rx = cur_rx;
+
+
+	delta = rtl8168_rx_fill(tp, dev, tp->dirty_rx, tp->cur_rx);
+	//netif_err(tp, drv, tp->dev, "delta =%x \n",delta);
+	tp->dirty_rx += delta;
+
+	if (tp->dirty_rx + NUM_RX_DESC == tp->cur_rx){
+		rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+		netif_err(tp, drv, tp->dev, "%s: Rx buffers exhausted\n", dev->name);
+	}
+
+	return count;
+}
+#else
+static struct sk_buff *rtl8169_try_rx_copy(void *data,
+					   struct rtl8169_private *tp,
+					   int pkt_size,
+					   dma_addr_t addr)
+{
+	struct sk_buff *skb;
+	struct device *d = &tp->pdev->dev;
+
+	data = rtl8169_align(data);
+	if (!tp->acp_enable)
+		dma_sync_single_for_cpu(d, addr, pkt_size, DMA_FROM_DEVICE);
+	prefetch(data);
+	skb = netdev_alloc_skb_ip_align(tp->dev, pkt_size);
+	if (skb)
+		memcpy(skb->data, data, pkt_size);
+	if (!tp->acp_enable)
+		dma_sync_single_for_device(d, addr, pkt_size, DMA_FROM_DEVICE);
+
+	return skb;
+}
+
+static int rtl_rx(struct net_device *dev, struct rtl8169_private *tp, u32 budget)
+{
+	unsigned int cur_rx, rx_left;
+	unsigned int count;
+	const unsigned int num_rx_desc = NUM_RX_DESC;
+
+	cur_rx = tp->cur_rx;
+
+	for (rx_left = min(budget, num_rx_desc); rx_left > 0; rx_left--, cur_rx++) {
+		unsigned int entry = cur_rx % NUM_RX_DESC;
+		struct RxDesc *desc = tp->RxDescArray + entry;
+		u32 status;
+
+		rmb();
+		status = le32_to_cpu(desc->opts1) & tp->opts1_mask;
+
+		if (status & DescOwn)
+			break;
+		if (unlikely(status & RxRES)) {
+			netif_info(tp, rx_err, dev, "Rx ERROR. status = %08x\n",
+				   status);
+			dev->stats.rx_errors++;
+			if (status & (RxRWT | RxRUNT))
+				dev->stats.rx_length_errors++;
+			if (status & RxCRC)
+				dev->stats.rx_crc_errors++;
+			if (status & RxFOVF) {
+				rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+				dev->stats.rx_fifo_errors++;
+			}
+			if ((status & (RxRUNT | RxCRC)) &&
+				!(status & (RxRWT | RxFOVF)) &&
+				(dev->features & NETIF_F_RXALL))
+				goto process_pkt;
+		} else {
+			struct sk_buff *skb;
+			dma_addr_t addr;
+			int pkt_size;
+
+process_pkt:
+			addr = le64_to_cpu(desc->addr);
+			if (likely(!(dev->features & NETIF_F_RXFCS)))
+				pkt_size = (status & 0x00003fff) - 4;
+			else
+				pkt_size = status & 0x00003fff;
+
+			/*
+			 * The driver does not support incoming fragmented
+			 * frames. They are seen as a symptom of over-mtu
+			 * sized frames.
+			 */
+			if (unlikely(rtl8169_fragmented_frame(status))) {
+				dev->stats.rx_dropped++;
+				dev->stats.rx_length_errors++;
+				goto release_descriptor;
+			}
+
+			skb = rtl8169_try_rx_copy(tp->Rx_databuff[entry],
+						  tp, pkt_size, addr);
+			if (!skb) {
+				dev->stats.rx_dropped++;
+				goto release_descriptor;
+			}
+
+			rtl8169_rx_csum(skb, status);
+			skb_put(skb, pkt_size);
+			skb->protocol = eth_type_trans(skb, dev);
+
+			rtl8169_rx_vlan_tag(desc, skb);
+
+			napi_gro_receive(&tp->napi, skb);
+
+			u64_stats_update_begin(&tp->rx_stats.syncp);
+			tp->rx_stats.packets++;
+			tp->rx_stats.bytes += pkt_size;
+			u64_stats_update_end(&tp->rx_stats.syncp);
+		}
+release_descriptor:
+		desc->opts2 = 0;
+		wmb();
+		rtl8169_mark_to_asic(desc, rx_buf_sz);
+	}
+
+	count = cur_rx - tp->cur_rx;
+	tp->cur_rx = cur_rx;
+
+	return count;
+}
+#endif /* CONFIG_RTL_RX_NO_COPY */
+
+static irqreturn_t phy_irq_handler(int irq, void *dev_instance)
+{
+	struct rtl8169_private *tp = dev_instance;
+	u32 isr;
+	u32 por;
+	int i;
+	const char offset[POR_NUM] = {28, 29, 30};
+	const char *name[POR_NUM] = {"HV", "DV", "AV"};
+	bool hit = false;
+
+	pr_err("%s:%d: irq %d, tp 0x%p\n", __func__, __LINE__, irq, tp);
+	isr = readl(tp->mmio_clkaddr + ISO_UMSK_ISR);
+	pr_err("ISO_UMSK_ISR = 0x%08x\n", isr);
+	por = readl(tp->mmio_clkaddr + ISO_POR_DATAI);
+	pr_err("ISO_POR_DATAI = 0x%08x\n", por);
+
+	for (i = 0; i < POR_NUM; i++) {
+		if (irq == tp->phy_irq[i] && (isr & (1 << offset[i]))) {
+			pr_err("%s: get GPHY %s POR interrupt\n",
+				tp->dev->name, name[i]);
+			writel(1 << offset[i], tp->mmio_clkaddr + ISO_UMSK_ISR);
+			hit = true;
+			break;
+		}
+	}
+
+	if (hit) {
+		if ((por & POR_XV_MASK) != POR_XV_MASK) {
+			pr_err("%s: GPHY has power issue (0x%x)\n",
+				tp->dev->name, por);
+			goto out;
+		}
+
+		if (!test_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags))
+			rtl_phy_reinit(tp);
+		else if (atomic_inc_return(&tp->phy_reinit_flag) == 1)
+			rtl_schedule_task(tp, RTL_FLAG_TASK_PHY_PENDING);
+		else
+			atomic_dec(&tp->phy_reinit_flag);
+	}
+
+out:
+	return IRQ_RETVAL(IRQ_HANDLED);
+}
+
+static irqreturn_t rtl8169_interrupt(int irq, void *dev_instance)
+{
+	struct net_device *dev = dev_instance;
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int handled = 0;
+	u16 status;
+
+	status = rtl_get_events(tp);
+	if (status && status != 0xffff) {
+		status &= RTL_EVENT_NAPI | tp->event_slow;
+		if (status) {
+			handled = 1;
+
+			rtl_irq_disable(tp);
+			napi_schedule(&tp->napi);
+		}
+	}
+	return IRQ_RETVAL(handled);
+}
+
+/*
+ * Workqueue context.
+ */
+static void rtl_slow_event_work(struct rtl8169_private *tp)
+{
+	struct net_device *dev = tp->dev;
+	void __iomem *ioaddr = tp->mmio_addr;
+	u16 status;
+
+	status = rtl_get_events(tp) & tp->event_slow;
+	rtl_ack_events(tp, status);
+
+	if (unlikely(status & RxFIFOOver)) {
+		switch (tp->mac_version) {
+		/* Work around for rx fifo overflow */
+		case RTL_GIGA_MAC_VER_11:
+			netif_stop_queue(dev);
+			/* XXX - Hack alert. See rtl_task(). */
+			set_bit(RTL_FLAG_TASK_RESET_PENDING, tp->wk.flags);
+		default:
+			break;
+		}
+	}
+
+	if (unlikely(status & SYSErr))
+		rtl8169_pcierr_interrupt(dev);
+
+	if (status & LinkChg)
+	{
+		__rtl8169_check_link_status(dev, tp, tp->mmio_addr, true);
+
+		/* Add for link status change */
+		tp->link_chg = 1;
+		wake_up(&tp->thr_wait);
+
+				// prevet ALDPS enter MAC Powercut Tx/Rx disable
+				// use MAC reset to set counter to offset 0
+		if (tp->link_ok(ioaddr))
+		{
+		   rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+		}
+		else
+		{
+		   //mod_timer(&tp->timer, jiffies + RTL8169_PHY_TIMEOUT);
+		}
+	}
+
+	rtl_irq_enable_all(tp);
+}
+
+static void rtl_task(struct work_struct *work)
+{
+	static const struct {
+		int bitnr;
+		void (*action)(struct rtl8169_private *);
+	} rtl_work[] = {
+		/* XXX - keep rtl_slow_event_work() as first element. */
+		{ RTL_FLAG_TASK_SLOW_PENDING,	rtl_slow_event_work },
+		{ RTL_FLAG_TASK_RESET_PENDING,	rtl_reset_work },
+		{ RTL_FLAG_TASK_PHY_PENDING,	rtl_phy_work }
+	};
+	struct rtl8169_private *tp =
+		container_of(work, struct rtl8169_private, wk.work);
+	struct net_device *dev = tp->dev;
+	int i;
+
+	rtl_lock_work(tp);
+
+	if (!netif_running(dev) ||
+		!test_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags))
+		goto out_unlock;
+
+	for (i = 0; i < ARRAY_SIZE(rtl_work); i++) {
+		bool pending;
+
+		pending = test_and_clear_bit(rtl_work[i].bitnr, tp->wk.flags);
+		if (pending)
+			rtl_work[i].action(tp);
+	}
+
+out_unlock:
+	rtl_unlock_work(tp);
+}
+
+static int rtl8169_poll(struct napi_struct *napi, int budget)
+{
+	struct rtl8169_private *tp = container_of(napi, struct rtl8169_private, napi);
+	struct net_device *dev = tp->dev;
+	u16 enable_mask = RTL_EVENT_NAPI | tp->event_slow;
+	int work_done= 0;
+	u16 status;
+
+	status = rtl_get_events(tp);
+	rtl_ack_events(tp, status & ~(tp->event_slow | RxOverflow));
+
+	if (status & RTL_EVENT_NAPI_RX)
+		work_done = rtl_rx(dev, tp, (u32) budget);
+
+	#if defined(RTL_ADJUST_FIFO_THRESHOLD)
+	if ((status & RxOverflow) && work_done > 0)
+		rtl_ack_events(tp, RxOverflow);
+	#endif /* RTL_ADJUST_FIFO_THRESHOLD */
+
+	if (status & RTL_EVENT_NAPI_TX)
+		rtl_tx(dev, tp);
+
+	if (status & tp->event_slow) {
+		enable_mask &= ~tp->event_slow;
+
+		rtl_schedule_task(tp, RTL_FLAG_TASK_SLOW_PENDING);
+	}
+
+	if (work_done < budget) {
+		napi_complete(napi);
+
+		rtl_irq_enable(tp, enable_mask);
+		mmiowb();
+	}
+
+	return work_done;
+}
+
+static void rtl8169_rx_missed(struct net_device *dev, void __iomem *ioaddr)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (tp->mac_version > RTL_GIGA_MAC_VER_06)
+		return;
+
+	dev->stats.rx_missed_errors += (RTL_R32(RxMissed) & 0xffffff);
+	RTL_W32(RxMissed, 0);
+}
+
+static void rtl8169_down(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	//del_timer_sync(&tp->timer);
+
+	napi_disable(&tp->napi);
+	netif_stop_queue(dev);
+
+	rtl8169_hw_reset(tp);
+	/*
+	 * At this point device interrupts can not be enabled in any function,
+	 * as netif_running is not true (rtl8169_interrupt, rtl8169_reset_task)
+	 * and napi is disabled (rtl8169_poll).
+	 */
+	rtl8169_rx_missed(dev, ioaddr);
+
+	/* Give a racing hard_start_xmit a few cycles to complete. */
+	synchronize_sched();
+
+	rtl8169_tx_clear(tp);
+
+	rtl8169_rx_clear(tp);
+
+	rtl_pll_power_down(tp);
+}
+
+static int rtl8169_close(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	struct platform_device *pdev = tp->pdev;
+
+//	pm_runtime_get_sync(&pdev->dev);
+
+	/* Update counters before going down */
+	rtl8169_update_counters(dev);
+
+	rtl_lock_work(tp);
+	clear_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags);
+
+	rtl8169_down(dev);
+
+	rtl_unlock_work(tp);
+
+	free_irq(dev->irq, dev);
+
+	if (tp->acp_enable) {
+		kfree(tp->RxDescArray);
+		kfree(tp->TxDescArray);
+	} else {
+		dma_free_coherent(&pdev->dev, R8169_RX_RING_BYTES,
+				  tp->RxDescArray, tp->RxPhyAddr);
+		dma_free_coherent(&pdev->dev, R8169_TX_RING_BYTES,
+				  tp->TxDescArray, tp->TxPhyAddr);
+	}
+	tp->TxDescArray = NULL;
+	tp->RxDescArray = NULL;
+
+//	pm_runtime_put_sync(&pdev->dev);
+
+	return 0;
+}
+
+#ifdef CONFIG_NET_POLL_CONTROLLER
+static void rtl8169_netpoll(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl8169_interrupt(tp->pdev->irq, dev);
+}
+#endif
+
+static int rtl_open(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+	int retval = -ENOMEM;
+	int node = dev->dev.parent ? dev_to_node(dev->dev.parent) : -1;
+
+//	pm_runtime_get_sync(&pdev->dev);
+
+	/*
+	 * Rx and Tx descriptors needs 256 bytes alignment.
+	 * dma_alloc_coherent provides more.
+	 */
+	if (tp->acp_enable) {
+		tp->TxDescArray = kzalloc_node(R8169_TX_RING_BYTES, GFP_KERNEL,
+						node);
+		tp->TxPhyAddr = virt_to_phys(tp->TxDescArray);
+	} else {
+		tp->TxDescArray = dma_alloc_coherent(&pdev->dev,
+			R8169_TX_RING_BYTES, &tp->TxPhyAddr, GFP_KERNEL);
+	}
+	if (!tp->TxDescArray)
+		goto err_pm_runtime_put;
+
+	if (tp->acp_enable) {
+		tp->RxDescArray = kzalloc_node(R8169_RX_RING_BYTES, GFP_KERNEL,
+						node);
+		tp->RxPhyAddr = virt_to_phys(tp->RxDescArray);
+	} else {
+		tp->RxDescArray = dma_alloc_coherent(&pdev->dev,
+			R8169_RX_RING_BYTES, &tp->RxPhyAddr, GFP_KERNEL);
+	}
+	if (!tp->RxDescArray)
+		goto err_free_tx_0;
+
+	retval = rtl8169_init_ring(dev);
+	if (retval < 0)
+		goto err_free_rx_1;
+
+	INIT_WORK(&tp->wk.work, rtl_task);
+
+	smp_mb();
+
+	//rtl_request_firmware(tp);
+
+	retval = request_irq(dev->irq, rtl8169_interrupt,
+				 (tp->features & RTL_FEATURE_MSI) ? 0 : IRQF_SHARED,
+				 dev->name, dev);
+	if (retval < 0)
+		goto err_release_fw_2;
+
+	rtl_lock_work(tp);
+
+	set_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags);
+
+	napi_enable(&tp->napi);
+
+	rtl8169_init_phy(dev, tp);
+
+	__rtl8169_set_features(dev, dev->features);
+
+	rtl_pll_power_up(tp);
+
+	rtl_hw_start(dev);
+
+	netif_start_queue(dev);
+
+	rtl_unlock_work(tp);
+
+	tp->saved_wolopts = 0;
+//	pm_runtime_put_noidle(&pdev->dev);
+
+	rtl8169_check_link_status(dev, tp, ioaddr);
+out:
+	return retval;
+
+err_release_fw_2:
+	rtl_release_firmware(tp);
+	rtl8169_rx_clear(tp);
+err_free_rx_1:
+	if (tp->acp_enable)
+		kfree(tp->RxDescArray);
+	else
+		dma_free_coherent(&pdev->dev, R8169_RX_RING_BYTES,
+				  tp->RxDescArray, tp->RxPhyAddr);
+	tp->RxDescArray = NULL;
+err_free_tx_0:
+	if (tp->acp_enable)
+		kfree(tp->TxDescArray);
+	else
+		dma_free_coherent(&pdev->dev, R8169_TX_RING_BYTES,
+				  tp->TxDescArray, tp->TxPhyAddr);
+	tp->TxDescArray = NULL;
+err_pm_runtime_put:
+//	pm_runtime_put_noidle(&pdev->dev);
+	goto out;
+}
+
+static struct rtnl_link_stats64 *
+rtl8169_get_stats64(struct net_device *dev, struct rtnl_link_stats64 *stats)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	unsigned int start;
+
+	if (netif_running(dev))
+		rtl8169_rx_missed(dev, ioaddr);
+
+	do {
+		start = u64_stats_fetch_begin_irq(&tp->rx_stats.syncp);
+		stats->rx_packets = tp->rx_stats.packets;
+		stats->rx_bytes	= tp->rx_stats.bytes;
+	} while (u64_stats_fetch_retry_irq(&tp->rx_stats.syncp, start));
+
+
+	do {
+		start = u64_stats_fetch_begin_irq(&tp->tx_stats.syncp);
+		stats->tx_packets = tp->tx_stats.packets;
+		stats->tx_bytes	= tp->tx_stats.bytes;
+	} while (u64_stats_fetch_retry_irq(&tp->tx_stats.syncp, start));
+
+	stats->rx_dropped	= dev->stats.rx_dropped;
+	stats->tx_dropped	= dev->stats.tx_dropped;
+	stats->rx_length_errors = dev->stats.rx_length_errors;
+	stats->rx_errors	= dev->stats.rx_errors;
+	stats->rx_crc_errors	= dev->stats.rx_crc_errors;
+	stats->rx_fifo_errors	= dev->stats.rx_fifo_errors;
+	stats->rx_missed_errors = dev->stats.rx_missed_errors;
+
+	return stats;
+}
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+static void r8169soc_eee_init(struct rtl8169_private *tp, bool enable);
+#endif /* CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+
+static void rtl8169_net_suspend(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (!netif_running(dev))
+		return;
+
+	netif_device_detach(dev);
+	netif_stop_queue(dev);
+
+	rtl_lock_work(tp);
+	napi_disable(&tp->napi);
+	clear_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags);
+	rtl_unlock_work(tp);
+
+	/* disable EEE if it is enabled */
+	if (tp->eee_enable) {
+		#if defined(CONFIG_ARCH_RTD129x)
+		MDIO_LOCK;
+		r8169_mmd_write(tp, 0x7, 0x3c, 0);
+		MDIO_UNLOCK;
+
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) & ~0x3));   // turn off EEE
+		r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) & ~0x2));   // turn off EEE+
+		#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		r8169soc_eee_init(tp, false);
+		#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+	}
+
+	rtl8169_hw_reset(tp);
+
+	rtl_pll_power_down(tp);
+}
+
+#ifdef CONFIG_PM
+
+static int rtl8169_suspend(struct device *dev)
+{
+	struct net_device *ndev = dev_get_drvdata(dev);
+	struct rtl8169_private *tp = netdev_priv(ndev);
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	printk(KERN_ERR "[RTK_ETN] Enter %s\n", __func__);
+
+	rtl8169_net_suspend(ndev);
+
+	/* turn off LED, and current solution is switch pad to GPIO input */
+	#if defined(CONFIG_ARCH_RTD129x)
+	writel(readl(tp->mmio_clkaddr + 0x310) & ~0x3C000000,
+		(tp->mmio_clkaddr + 0x310));
+	#elif defined(CONFIG_ARCH_RTD139x)
+	writel(readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD1) & ~0x000000F0,
+		(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD1));
+	#elif defined(CONFIG_ARCH_RTD16xx)
+	writel(readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD0) & ~0x3C000000,
+		(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD0));
+	writel(readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD2) & ~0x38000000,
+		(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD2));
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+
+	if(RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		printk(KERN_ERR "[RTK_ETN] %s Idle mode\n", __func__);
+
+		/* stop PLL for power saving */
+		RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) | BIT(2));
+	}else{
+		//For suspend mode
+		printk(KERN_ERR "[RTK_ETN] %s Suspend mode\n", __func__);
+	}
+
+
+	printk(KERN_ERR "[RTK_ETN] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static void __rtl8169_resume(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD139x) || \
+		defined(CONFIG_ARCH_RTD16xx)
+	u32 val;
+	#endif
+
+	netif_device_attach(dev);
+
+	/* turn on LED */
+	#if defined(CONFIG_ARCH_RTD129x)
+	val = readl(tp->mmio_clkaddr + 0x310) & ~0x3C000000;
+	writel(val | 0x14000000, (tp->mmio_clkaddr + 0x310));
+	#elif defined(CONFIG_ARCH_RTD139x)
+	val = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD1) & ~0x000000F0;
+	writel(val | 0x50, (tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD1));
+	#elif defined(CONFIG_ARCH_RTD16xx)
+	val = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD0) & ~0x3C000000;
+	writel(val | 0x14000000, (tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD0));
+	val = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD2) & ~0x38000000;
+	writel(val | 0x18000000, (tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD2));
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+
+	rtl_pll_power_up(tp);
+	rtl_rar_set(tp, tp->dev->dev_addr);
+
+	rtl_lock_work(tp);
+	napi_enable(&tp->napi);
+	set_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags);
+	rtl_unlock_work(tp);
+
+	rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+}
+
+static int rtl8169_resume(struct device *dev)
+{
+	struct net_device *ndev = dev_get_drvdata(dev);
+	struct rtl8169_private *tp = netdev_priv(ndev);
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	printk(KERN_ERR "[RTK_ETN] Enter %s\n", __func__);
+
+	if(RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		printk(KERN_ERR "[RTK_ETN] %s Idle mode\n", __func__);
+
+		/* enable PLL from power saving */
+		RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~BIT(2));
+	}else{
+		//For suspend mode
+		printk(KERN_ERR "[RTK_ETN] %s Suspend mode\n", __func__);
+	}
+
+	if (netif_running(ndev))
+		__rtl8169_resume(ndev);
+
+	/* enable EEE according to tp->eee_enable */
+	if (tp->eee_enable) {
+		#if defined(CONFIG_ARCH_RTD129x)
+		MDIO_LOCK;
+		r8169_mmd_write(tp, 0x7, 0x3c, 0x6);
+		MDIO_UNLOCK;
+
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) | 0x3));   // turn on EEE
+		r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) | 0x2));   // turn on EEE+
+		#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		r8169soc_eee_init(tp, true);
+		#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+	}
+
+	rtl8169_init_phy(ndev, tp);
+
+	printk(KERN_ERR "[RTK_ETN] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static __maybe_unused int rtl8169_runtime_suspend(struct device *dev)
+{
+	struct net_device *ndev = dev_get_drvdata(dev);
+	struct rtl8169_private *tp = netdev_priv(ndev);
+
+	if (!tp->TxDescArray)
+		return 0;
+
+	rtl_lock_work(tp);
+	tp->saved_wolopts = __rtl8169_get_wol(tp);
+	__rtl8169_set_wol(tp, WAKE_ANY);
+	rtl_unlock_work(tp);
+
+	rtl8169_net_suspend(ndev);
+
+	return 0;
+}
+
+static __maybe_unused int rtl8169_runtime_resume(struct device *dev)
+{
+	struct net_device *ndev = dev_get_drvdata(dev);
+	struct rtl8169_private *tp = netdev_priv(ndev);
+
+	if (!tp->TxDescArray)
+		return 0;
+
+	rtl_lock_work(tp);
+	__rtl8169_set_wol(tp, tp->saved_wolopts);
+	tp->saved_wolopts = 0;
+	rtl_unlock_work(tp);
+
+	rtl8169_init_phy(ndev, tp);
+
+	__rtl8169_resume(ndev);
+
+	return 0;
+}
+
+static __maybe_unused int rtl8169_runtime_idle(struct device *dev)
+{
+	struct net_device *ndev = dev_get_drvdata(dev);
+	struct rtl8169_private *tp = netdev_priv(ndev);
+
+	return tp->TxDescArray ? -EBUSY : 0;
+}
+
+static const struct dev_pm_ops rtl8169_pm_ops = {
+	.suspend		= rtl8169_suspend,
+	.resume			= rtl8169_resume,
+	.freeze			= rtl8169_suspend,
+	.thaw			= rtl8169_resume,
+	.poweroff		= rtl8169_suspend,
+	.restore		= rtl8169_resume,
+	.runtime_suspend	= rtl8169_runtime_suspend,
+	.runtime_resume		= rtl8169_runtime_resume,
+	.runtime_idle		= rtl8169_runtime_idle,
+};
+
+#define RTL8169_PM_OPS	(&rtl8169_pm_ops)
+
+#else /* !CONFIG_PM */
+
+#define RTL8169_PM_OPS	NULL
+
+#endif /* !CONFIG_PM */
+
+static void rtl_wol_shutdown_quirk(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* WoL fails with 8168b when the receiver is disabled. */
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+		//pci_clear_master(tp->pdev);
+
+		RTL_W8(ChipCmd, CmdRxEnb);
+		/* PCI commit */
+		RTL_R8(ChipCmd);
+		break;
+	default:
+		break;
+	}
+}
+
+static void rtl_shutdown(struct platform_device *pdev)
+{
+	struct net_device *dev = platform_get_drvdata(pdev);
+	struct rtl8169_private *tp = netdev_priv(dev);
+//	struct device *d = &pdev->dev;
+
+//	pm_runtime_get_sync(d);
+
+	rtl8169_net_suspend(dev);
+
+	/* Restore original MAC address */
+	rtl_rar_set(tp, dev->perm_addr);
+
+	rtl8169_hw_reset(tp);
+
+	if (system_state == SYSTEM_POWER_OFF) {
+		if (__rtl8169_get_wol(tp) & WAKE_ANY) {
+			rtl_wol_suspend_quirk(tp);
+			rtl_wol_shutdown_quirk(tp);
+		}
+
+		//pci_wake_from_d3(pdev, true);
+		//pci_set_power_state(pdev, PCI_D3hot);
+	}
+
+//	pm_runtime_put_noidle(d);
+}
+
+static int rtl_remove_one(struct platform_device *pdev)
+{
+	struct net_device *dev = platform_get_drvdata(pdev);
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int i;
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_27 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_28 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_31) {
+		rtl8168_driver_stop(tp);
+	}
+
+
+#ifdef RTL_PROC
+	do{
+		if(tp->dir_dev==NULL)
+			break;
+
+		remove_proc_entry("wol_enable", tp->dir_dev);
+		remove_proc_entry("phy_reinit", tp->dir_dev);
+		remove_proc_entry("eee", tp->dir_dev);
+		remove_proc_entry("test", tp->dir_dev);
+
+		if(rtw_proc==NULL)
+			break;
+
+		remove_proc_entry(MODULENAME, rtw_proc);
+		remove_proc_entry("eth0", init_net.proc_net);
+
+			rtw_proc=NULL;
+
+	}while(0);
+#endif
+
+	cancel_work_sync(&tp->wk.work);
+
+	netif_napi_del(&tp->napi);
+
+	unregister_netdev(dev);
+
+	rtl_release_firmware(tp);
+
+//	if (pci_dev_run_wake(pdev))
+//		pm_runtime_get_noresume(&pdev->dev);
+
+	/* restore original MAC address */
+	rtl_rar_set(tp, dev->perm_addr);
+
+//	rtl_disable_msi(pdev, tp);
+	rtl8169_release_board(pdev, dev, tp->mmio_addr);
+	platform_set_drvdata(pdev, NULL);
+
+	/* Yukuen: Add for link status uevent. 20150206 */
+	if(tp->kthr){
+		kthread_stop(tp->kthr);
+		tp->kthr = NULL;
+	}
+
+	for (i = 0; i < POR_NUM; i++)
+		free_irq(tp->phy_irq[i], tp);
+	return 0;
+}
+
+static const struct net_device_ops rtl_netdev_ops = {
+	.ndo_open		= rtl_open,
+	.ndo_stop		= rtl8169_close,
+	.ndo_get_stats64	= rtl8169_get_stats64,
+	.ndo_start_xmit		= rtl8169_start_xmit,
+	.ndo_tx_timeout		= rtl8169_tx_timeout,
+	.ndo_validate_addr	= eth_validate_addr,
+	.ndo_change_mtu		= rtl8169_change_mtu,
+	.ndo_fix_features	= rtl8169_fix_features,
+	.ndo_set_features	= rtl8169_set_features,
+	.ndo_set_mac_address	= rtl_set_mac_address,
+	.ndo_do_ioctl		= rtl8169_ioctl,
+	.ndo_set_rx_mode	= rtl_set_rx_mode,
+#ifdef CONFIG_NET_POLL_CONTROLLER
+	.ndo_poll_controller	= rtl8169_netpoll,
+#endif
+
+};
+
+static struct rtl_cfg_info {
+	void (*hw_start)(struct net_device *);
+	unsigned int region;
+	unsigned int align;
+	u16 event_slow;
+	unsigned features;
+	u8 default_ver;
+} rtl_cfg_infos [] = {
+	[RTL_CFG_0] = {
+		.hw_start	= rtl_hw_start_8169,
+		.region		= 1,
+		.align		= 0,
+		.event_slow	= SYSErr | LinkChg | RxOverflow | RxFIFOOver,
+		.features	= RTL_FEATURE_GMII,
+		.default_ver	= RTL_GIGA_MAC_VER_01,
+	},
+	[RTL_CFG_1] = {
+		.hw_start	= rtl_hw_start_8168,
+		.region		= 2,
+		.align		= 8,
+		.event_slow	= SYSErr | LinkChg | RxOverflow,
+		.features	= RTL_FEATURE_GMII | RTL_FEATURE_MSI,
+		.default_ver	= RTL_GIGA_MAC_VER_11,
+	},
+	[RTL_CFG_2] = {
+		.hw_start	= rtl_hw_start_8101,
+		.region		= 2,
+		.align		= 8,
+		.event_slow	= SYSErr | LinkChg | RxOverflow | RxFIFOOver |
+				  PCSTimeout,
+		.features	= RTL_FEATURE_MSI,
+		.default_ver	= RTL_GIGA_MAC_VER_13,
+	}
+};
+
+/* Cfg9346_Unlock assumed. */
+static unsigned rtl_try_msi(struct rtl8169_private *tp,
+				const struct rtl_cfg_info *cfg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	unsigned msi = 0;
+	u8 cfg2;
+
+	cfg2 = RTL_R8(Config2) & ~MSIEnable;
+	if (cfg->features & RTL_FEATURE_MSI) {
+#if 0
+
+		if (pci_enable_msi(tp->pci_dev)) {
+			netif_info(tp, hw, tp->dev, "no MSI. Back to INTx.\n");
+		} else {
+			cfg2 |= MSIEnable;
+			msi = RTL_FEATURE_MSI;
+		}
+#endif
+	}
+	if (tp->mac_version <= RTL_GIGA_MAC_VER_06)
+		RTL_W8(Config2, cfg2);
+	return msi;
+}
+
+DECLARE_RTL_COND(rtl_link_list_ready_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R8(MCU) & LINK_LIST_RDY;
+}
+
+DECLARE_RTL_COND(rtl_rxtx_empty_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return (RTL_R8(MCU) & RXTX_EMPTY) == RXTX_EMPTY;
+}
+
+static void rtl_hw_init_8168g(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	u32 data;
+
+	tp->ocp_base = OCP_STD_PHY_BASE;
+
+	RTL_W32(MISC, RTL_R32(MISC) | RXDV_GATED_EN);
+
+	if (!rtl_udelay_loop_wait_high(tp, &rtl_txcfg_empty_cond, 100, 42))
+		return;
+
+	if (!rtl_udelay_loop_wait_high(tp, &rtl_rxtx_empty_cond, 100, 42))
+		return;
+
+	RTL_W8(ChipCmd, RTL_R8(ChipCmd) & ~(CmdTxEnb | CmdRxEnb));
+	msleep(1);		// yukuen mask for SMP issue
+	RTL_W8(MCU, RTL_R8(MCU) & ~NOW_IS_OOB);
+
+	data = r8168_mac_ocp_read(tp, 0xe8de);
+	data &= ~(1 << 14);
+	r8168_mac_ocp_write(tp, 0xe8de, data);
+
+	if (!rtl_udelay_loop_wait_high(tp, &rtl_link_list_ready_cond, 100, 42))
+		return;
+
+	data = r8168_mac_ocp_read(tp, 0xe8de);
+	data |= (1 << 15);
+	r8168_mac_ocp_write(tp, 0xe8de, data);
+
+	if (!rtl_udelay_loop_wait_high(tp, &rtl_link_list_ready_cond, 100, 42))
+		return;
+}
+
+static void rtl_hw_initialize(struct rtl8169_private *tp)
+{
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+		rtl_hw_init_8168g(tp);
+		break;
+
+	default:
+		break;
+	}
+}
+#ifdef RTL_PROC
+static int wol_read_proc(struct seq_file *m, void *v)
+{
+	printk(KERN_INFO "read procfs ethernet wol_enable = %x \n",wol_enable);
+
+	seq_printf(m, "%d\n", wol_enable);
+	return 0;
+}
+
+static ssize_t wol_write_proc(struct file *file, const char __user *buffer, size_t count, loff_t *pos)
+{
+	char tmp[32];
+	u32 val,num;
+
+	if (buffer && !copy_from_user(tmp, buffer, sizeof(tmp)))
+	{
+		num = sscanf(tmp, "%x", &val);
+		wol_enable=val;
+		printk(KERN_INFO "write procfs ethernet wol_enable = %x \n",wol_enable);
+	}
+	return count;
+}
+
+static int wol_proc_open(struct inode *inode, struct file *file)
+{
+	struct net_device *dev = proc_get_parent_data(inode);
+
+	return single_open(file, wol_read_proc, dev);
+}
+
+static const struct file_operations wol_proc_fops = {
+	.open           = wol_proc_open,
+	.read           = seq_read,
+	.write          = wol_write_proc,
+	.llseek         = seq_lseek,
+	.release        = single_release,
+};
+
+static int phy_reinit_read_proc(struct seq_file *m, void *v)
+{
+	struct net_device *dev = m->private;
+	struct rtl8169_private *tp = netdev_priv(dev);
+	u32 isr;
+	u32 por;
+
+	isr = readl(tp->mmio_clkaddr + ISO_UMSK_ISR);
+	pr_err("ISO_UMSK_ISR = 0x%08x\n", isr);
+	por = readl(tp->mmio_clkaddr + ISO_POR_DATAI);
+	pr_err("ISO_POR_DATAI = 0x%08x\n", por);
+
+	pr_err("\n\nUsage: echo 1 > phy_reinit\n");
+
+	return 0;
+}
+
+static ssize_t phy_reinit_write_proc(struct file *file, const char __user *buffer, size_t count, loff_t *pos)
+{
+	char tmp[32];
+	u32 val, num;
+	struct net_device *dev = (struct net_device *) ((struct seq_file *)file->private_data)->private;
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (buffer && !copy_from_user(tmp, buffer, sizeof(tmp)))
+	{
+		num = sscanf(tmp, "%x", &val);
+		pr_info("phy_reinit = %x \n", val);
+
+		if (!test_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags))
+			rtl_phy_reinit(tp);
+		else if (atomic_inc_return(&tp->phy_reinit_flag) == 1)
+			rtl_schedule_task(tp, RTL_FLAG_TASK_PHY_PENDING);
+		else
+			atomic_dec(&tp->phy_reinit_flag);
+	}
+	return count;
+}
+
+static int phy_reinit_proc_open(struct inode *inode, struct file *file)
+{
+	struct net_device *dev = proc_get_parent_data(inode);
+
+	return single_open(file, phy_reinit_read_proc, dev);
+}
+
+static const struct file_operations phy_reinit_proc_fops = {
+	.open           = phy_reinit_proc_open,
+	.read           = seq_read,
+	.write          = phy_reinit_write_proc,
+	.llseek         = seq_lseek,
+	.release        = single_release,
+};
+
+static int eee_read_proc(struct seq_file *m, void *v)
+{
+
+	struct net_device *dev = m->private;
+	struct rtl8169_private *tp = netdev_priv(dev);
+	unsigned short e040, e080;
+
+	e040 = r8169soc_ocp_reg_read(tp, 0xe040);   // EEE
+	e080 = r8169soc_ocp_reg_read(tp, 0xe080);   // EEE+
+	pr_err("%s: eee = %d, OCP 0xe040 = 0x%x, OCP 0xe080 = 0x%x\n", dev->name, tp->eee_enable, e040, e080);
+	r8169_display_eee_info(dev, tp);
+
+	seq_putc(m, '\n');
+	return 0;
+
+}
+
+static ssize_t eee_write_proc(struct file *file, const char __user *buffer, size_t count, loff_t *pos)
+{
+	char tmp[32];
+	u32 val = 0,num;
+	struct net_device *dev = (struct net_device *) ((struct seq_file *)file->private_data)->private;
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (buffer && !copy_from_user(tmp, buffer, sizeof(tmp)))
+	{
+		num = sscanf(tmp, "%x", &val);
+		pr_err("write %s eee = %x\n", dev->name, val);
+	}
+
+	if (val > 0 && tp->eee_enable == false) {
+		tp->eee_enable = true;
+
+		/* power down PHY */
+		MDIO_LOCK;
+		rtl_writephy(tp, 0x1f, 0x0000);
+		rtl_patchphy(tp, MII_BMCR, BMCR_PDOWN);
+		MDIO_UNLOCK;
+
+		#if defined(CONFIG_ARCH_RTD129x)
+		MDIO_LOCK;
+		r8169_mmd_write(tp, 0x7, 0x3c, 0x6);
+		MDIO_UNLOCK;
+
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) | 0x3));   // turn on EEE
+		r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) | 0x2));   // turn on EEE+
+		#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		r8169soc_eee_init(tp, tp->eee_enable);
+		#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+
+		mdelay(100); // wait PHY ready
+		rtl8169_phy_reset(dev, tp);
+	} else if (val == 0 && tp->eee_enable == true) {
+		tp->eee_enable = false;
+
+		/* power down PHY */
+		MDIO_LOCK;
+		rtl_writephy(tp, 0x1f, 0x0000);
+		rtl_patchphy(tp, MII_BMCR, BMCR_PDOWN);
+		MDIO_UNLOCK;
+
+		#if defined(CONFIG_ARCH_RTD129x)
+		MDIO_LOCK;
+		r8169_mmd_write(tp, 0x7, 0x3c, 0);
+		MDIO_UNLOCK;
+
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) & ~0x3));   // turn off EEE
+		r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) & ~0x2));   // turn off EEE+
+		#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+		r8169soc_eee_init(tp, tp->eee_enable);
+		#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+
+		mdelay(100); // wait PHY ready
+		rtl8169_phy_reset(dev, tp);
+	}
+	return count;
+}
+
+/*
+ * seq_file wrappers for procfile show routines.
+ */
+static int eee_proc_open(struct inode *inode, struct file *file)
+{
+	struct net_device *dev = proc_get_parent_data(inode);
+
+	return single_open(file, eee_read_proc, dev);
+}
+
+static const struct file_operations eee_proc_fops = {
+	.open           = eee_proc_open,
+	.read           = seq_read,
+	.write          = eee_write_proc,
+	.llseek         = seq_lseek,
+	.release        = single_release,
+};
+
+static void r8169soc_dump_regs(struct rtl8169_private *tp) {
+	u32 addr;
+	u32 val;
+	u32 i;
+
+	pr_err("eee = %d\n", tp->eee_enable);
+	#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	pr_err("output_mode = %d, bypass = %d, acp = %d\n\n",
+		tp->output_mode, tp->bypass_enable, tp->acp_enable);
+
+	#endif /* CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx | CONFIG_ARCH_RTD13xx */
+
+	pr_err("ISO_UMSK_ISR\t[0x98007004] = %08x\n",
+		readl(tp->mmio_clkaddr + ISO_UMSK_ISR));
+	pr_err("ISO_POWERCUT_ETN\t[0x9800705c] = %08x\n",
+		readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN));
+	pr_err("ISO_ETN_TESTIO\t[0x98007060] = %08x\n",
+		readl(tp->mmio_clkaddr + ISO_ETN_TESTIO));
+	pr_err("ETN_RESET_CTRL\t[0x98007088] = %08x\n",
+		readl(tp->mmio_clkaddr + ISO_SOFT_RESET));
+	pr_err("ETN_CLK_CTRL\t[0x9800708c] = %08x\n",
+		readl(tp->mmio_clkaddr + ISO_CLOCK_ENABLE));
+
+	if (tp->output_mode != OUTPUT_EMBEDDED_PHY) {
+		#if defined(CONFIG_ARCH_RTD139x)
+		pr_err("SDS_REG02\t[0x981c8008] = %08x\n",
+			readl(tp->mmio_sdsaddr + SDS_REG02));
+		pr_err("SDS_REG28\t[0x981c8070] = %08x\n",
+			readl(tp->mmio_sdsaddr + SDS_REG28));
+		pr_err("SDS_REG29\t[0x981c8074] = %08x\n",
+			readl(tp->mmio_sdsaddr + SDS_REG29));
+		pr_err("SDS_MISC\t\t[0x981c9804] = %08x\n",
+			readl(tp->mmio_sdsaddr + SDS_MISC));
+		pr_err("SDS_LINK\t\t[0x981c9810] = %08x\n",
+			readl(tp->mmio_sdsaddr + SDS_LINK));
+		#elif defined(CONFIG_ARCH_RTD16xx)
+		pr_err("SDS_REG02\t[0x981c8008] = %08x\n",
+			readl(tp->mmio_sdsaddr + SDS_REG02));
+		pr_err("SDS_MISC\t\t[0x981c9804] = %08x\n",
+			readl(tp->mmio_sdsaddr + SDS_MISC));
+		pr_err("SDS_LINK\t\t[0x981c9808] = %08x\n",
+			readl(tp->mmio_sdsaddr + SDS_LINK));
+		pr_err("SDS_DEBUG\t\t[0x981c9810] = %08x\n",
+			readl(tp->mmio_sdsaddr + SDS_DEBUG));
+		#endif /* CONFIG_ARCH_RTD139x | CONFIG_ARCH_RTD16xx */
+	}
+
+	pr_err("ETN MAC regs:\n");
+	for (i = 0; i < 256; i += 4) {
+		addr = 0x98106000 + i;
+		val = readl(tp->mmio_addr + i);
+		pr_err("[%08x] = %08x\n", addr, val);
+	}
+}
+
+static int test_read_proc(struct seq_file *m, void *v)
+{
+
+	struct net_device *dev = m->private;
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	r8169soc_dump_regs(tp);
+
+	seq_putc(m, '\n');
+	return 0;
+
+}
+
+static ssize_t test_write_proc(struct file *file, const char __user *buffer,
+				size_t count, loff_t *pos)
+{
+	char tmp[32];
+	u32 val,num;
+	struct net_device *dev = (struct net_device *)
+			((struct seq_file *)file->private_data)->private;
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (buffer && !copy_from_user(tmp, buffer, sizeof(tmp)))
+	{
+		num = sscanf(tmp, "%x", &val);
+		pr_err("%s test case 0x%x\n", dev->name, val);
+	}
+
+	if (val & BIT(1)) {
+		pr_err("BIT 1 = 1: MDIO lock\n");
+		MDIO_LOCK;
+	} else {
+		pr_err("BIT 1 = 0: MDIO unlock\n");
+		MDIO_UNLOCK;
+	}
+
+	return count;
+}
+
+/*
+ * seq_file wrappers for procfile show routines.
+ */
+static int test_proc_open(struct inode *inode, struct file *file)
+{
+	struct net_device *dev = proc_get_parent_data(inode);
+
+	return single_open(file, test_read_proc, dev);
+}
+
+static const struct file_operations test_proc_fops = {
+	.open           = test_proc_open,
+	.read           = seq_read,
+	.write          = test_write_proc,
+	.llseek         = seq_lseek,
+	.release        = single_release,
+};
+
+#endif
+
+#if defined(CONFIG_ARCH_RTD139x)
+static void r8169soc_reset_phy_gmac(struct rtl8169_private *tp)
+{
+	u32 tmp;
+	struct clk *clk_etn_sys  = clk_get(&tp->pdev->dev, "etn_sys");
+	struct clk *clk_etn_250m = clk_get(&tp->pdev->dev, "etn_250m");
+	struct reset_control *rstc_gphy =
+		reset_control_get(&tp->pdev->dev, "gphy");
+	struct reset_control *rstc_gmac =
+		reset_control_get(&tp->pdev->dev, "gmac");
+	struct clk *clk_en_sds = NULL;
+	struct reset_control *rstc_sds_reg = NULL;
+	struct reset_control *rstc_sds = NULL;
+	struct reset_control *rstc_pcie0_power = NULL;
+	struct reset_control *rstc_pcie0_phy = NULL;
+	struct reset_control *rstc_pcie0_sgmii_mdio = NULL;
+	struct reset_control *rstc_pcie0_phy_mdio = NULL;
+
+	clk_prepare_enable(clk_etn_sys);
+	clk_prepare_enable(clk_etn_250m);
+
+	/* reg_0x9800708c[12:11] = 00 */
+	/* ISO spec, clock enable bit for etn clock & etn 250MHz */
+	clk_disable_unprepare(clk_etn_sys);
+	clk_disable_unprepare(clk_etn_250m);
+
+	/* reg_0x98007088[10:9] = 00 */
+	/* ISO spec, rstn_gphy & rstn_gmac */
+	reset_control_assert(rstc_gphy);
+	reset_control_assert(rstc_gmac);
+
+	/* reg_0x98007060[1] = 1 */
+	/* ISO spec, bypass mode enable */
+	tmp = readl(tp->mmio_clkaddr + ISO_ETN_TESTIO);
+	tmp |= BIT(1);
+	writel(tmp, tp->mmio_clkaddr + ISO_ETN_TESTIO);
+
+	/* reg_0x9800705c = 0x00616703 */
+	/* ISO spec, default value */
+	writel(0x00616703, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* RESET for SGMII if needed */
+	if (tp->output_mode != OUTPUT_EMBEDDED_PHY) {
+		clk_en_sds = clk_get(&tp->pdev->dev, "sds");
+		rstc_sds_reg = reset_control_get(&tp->pdev->dev, "sds_reg");
+		rstc_sds = reset_control_get(&tp->pdev->dev, "sds");
+		rstc_pcie0_power =
+			reset_control_get(&tp->pdev->dev, "pcie0_power");
+		rstc_pcie0_phy =
+			reset_control_get(&tp->pdev->dev, "pcie0_phy");
+		rstc_pcie0_sgmii_mdio =
+			reset_control_get(&tp->pdev->dev, "pcie0_sgmii_mdio");
+		rstc_pcie0_phy_mdio =
+			reset_control_get(&tp->pdev->dev, "pcie0_phy_mdio");
+
+		clk_prepare_enable(clk_en_sds);
+
+		/* reg_0x9800000c[7] = 0 */
+		/* CRT spec, clk_en_sds */
+		clk_disable_unprepare(clk_en_sds);
+
+		/* reg_0x98000000[4:3] = 00 */
+		/* CRT spec, rstn_sds_reg & rstn_sds */
+		reset_control_assert(rstc_sds);
+		reset_control_assert(rstc_sds_reg);
+
+		/* reg_0x98000004[7] = 0 */
+		/* reg_0x98000004[14] = 0 */
+		/* CRT spec, rstn_pcie0_power & rstn_pcie0_phy */
+		reset_control_assert(rstc_pcie0_power);
+		reset_control_assert(rstc_pcie0_phy);
+
+		/* reg_0x98000050[13] = 0 */
+		/* reg_0x98000050[16] = 0 */
+		/* CRT spec, rstn_pcie0_sgmii_mdio & rstn_pcie0_phy_mdio */
+		reset_control_assert(rstc_pcie0_sgmii_mdio);
+		reset_control_assert(rstc_pcie0_phy_mdio);
+
+		reset_control_put(rstc_sds_reg);
+		reset_control_put(rstc_sds);
+		reset_control_put(rstc_pcie0_power);
+		reset_control_put(rstc_pcie0_phy);
+		reset_control_put(rstc_pcie0_sgmii_mdio);
+		reset_control_put(rstc_pcie0_phy_mdio);
+	}
+
+	mdelay(1);
+
+	/* release resource */
+	reset_control_put(rstc_gphy);
+	reset_control_put(rstc_gmac);
+}
+
+static void r8169soc_acp_init(struct rtl8169_private *tp)
+{
+	u32 tmp;
+
+	/* SBX spec, Select ETN access DDR path. */
+	if (tp->acp_enable) {
+		/* reg_0x9801c20c[6] = 1 */
+		/* SBX spec, Mask ETN_ALL to SB3 DBUS REQ */
+		tmp = readl(tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_MASK);
+		tmp |= BIT(6);
+		writel(tmp, tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_MASK);
+
+		pr_info("wait all SB3 access finished...");
+		tmp = 0;
+		while (0 != (BIT(6) & readl(tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_BUSY))) {
+			mdelay(1);
+			tmp += 1;
+			if (tmp >= 100) {
+				pr_err("\n wait SB3 access failed (wait %d ms)\n", tmp);
+				break;
+			}
+		}
+		if (tmp < 100)
+			pr_info("done.\n");
+
+		/* reg_0x9801d100[29] = 0 */
+		/* SCPU wrapper spec, CLKACP division, 0 = div 2, 1 = div 3 */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp &= ~(BIT(29));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d124[1:0] = 00 */
+		/* SCPU wrapper spec, ACP master active, 0 = active */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_INTERFACE_EN);
+		tmp &= ~(BIT(1) | BIT(0));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_INTERFACE_EN);
+
+		/* reg_0x9801d100[30] = 1 */
+		/* SCPU wrapper spec, dy_icg_en_acp */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp |= BIT(30);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d100[21] = 1 */
+		/* SCPU wrapper spec, ACP CLK enable */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp |= BIT(21);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d100[14] = 1 */
+		/* SCPU wrapper spec, Do not apply reset to ACP port axi3 master */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp |= BIT(14);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d800[3:0] = 0111 */
+		/* reg_0x9801d800[7:4] = 0111 */
+		/* reg_0x9801d800[9:8] = 00 */
+		/* reg_0x9801d800[20:16] = 01100 */
+		/* reg_0x9801d800[28:24] = 01110 */
+		/* Configure control of ACP port */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CTRL);
+		tmp &= ~((0x1f << 24) | (0x1f << 16) | (0x1 << 9) |
+			(0xf << 4) | (0xf << 0));
+		tmp |= (0x0e << 24) | (0x0c << 16) | (0x1 << 9) | (0x7 << 4) |
+			(0x7 << 0);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CTRL);
+
+		/* reg_0x9801d030[28] = 1 */
+		/* SCPU wrapper spec, dy_icg_en_acp */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp |= BIT(28);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801d030[16] = 1 */
+		/* SCPU wrapper spec, ACP CLK Enable for acp of scpu_chip_top */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp |= BIT(16);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801d030[0] = 1 */
+		/* SCPU wrapper spec, Do not apply reset to ACP port axi3 master */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp |= BIT(0);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801c814[17] = 1 */
+		/* through ACP to SCPU_ACP */
+		tmp = readl(tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+		tmp |= BIT(17);
+		writel(tmp, tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+
+		pr_info("ARM ACP on\n.");
+	} else {
+		#if 0
+		/* reg_0x9801c814[17] = 0 */
+		/* through SB3 to DC_SYS (default) */
+		tmp = readl(tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+		tmp &= ~(BIT(17));
+		writel(tmp, tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+		#endif
+	}
+}
+
+static void r8169soc_pll_clock_init(struct rtl8169_private *tp)
+{
+	u32 tmp;
+	struct clk *clk_etn_sys  = clk_get(&tp->pdev->dev, "etn_sys");
+	struct clk *clk_etn_250m = clk_get(&tp->pdev->dev, "etn_250m");
+	struct reset_control *rstc_gphy =
+		reset_control_get(&tp->pdev->dev, "gphy");
+	struct reset_control *rstc_gmac =
+		reset_control_get(&tp->pdev->dev, "gmac");
+
+	/* reg_0x98007004[27] = 1 */
+	/* ISO spec, ETN_PHY_INTR, clear ETN interrupt for ByPassMode */
+	writel(BIT(27), tp->mmio_clkaddr + ISO_UMSK_ISR);
+
+	/* reg_0x98007088[10] = 1 */
+	/* ISO spec, reset bit of gphy */
+	reset_control_deassert(rstc_gphy);
+
+	mdelay(1);	/* wait 1ms for PHY PLL stable */
+
+	/* In Hercules, EPHY need choose the bypass mode or Non-bypass mode */
+	/* Bypass mode : ETN MAC bypass efuse update flow. SW need to take this sequence. */
+	/* Non-Bypass mode : ETN MAC set efuse update and efuse_rdy setting */
+	/* Default : Bypass mode (0x9800_7060[1] = 1'b1) */
+	if (!tp->bypass_enable) {
+		/* reg_0x98007060[1] = 0 */
+		/* ISO spec, bypass mode disable */
+		tmp = readl(tp->mmio_clkaddr + ISO_ETN_TESTIO);
+		tmp &= ~(BIT(1));
+		writel(tmp, tp->mmio_clkaddr + ISO_ETN_TESTIO);
+	} else {
+		/* reg_0x98007060[1] = 1 */
+		/* ISO spec, bypass mode enable */
+		/* bypass mode, SW need to handle the EPHY Status check ,
+		   EFUSE data update and EPHY fuse_rdy setting. */
+		tmp = readl(tp->mmio_clkaddr + ISO_ETN_TESTIO);
+		tmp |= BIT(1);
+		writel(tmp, tp->mmio_clkaddr + ISO_ETN_TESTIO);
+	}
+
+	/* reg_0x98007088[9] = 1 */
+	/* ISO spec, reset bit of gmac */
+	reset_control_deassert(rstc_gmac);
+
+	/* reg_0x9800708c[12:11] = 11 */
+	/* ISO spec, clock enable bit for etn clock & etn 250MHz */
+	clk_prepare_enable(clk_etn_sys);
+	clk_prepare_enable(clk_etn_250m);
+
+	mdelay(1);	/* wait 1ms for GMAC uC to be stable */
+
+	/* release resource */
+	reset_control_put(rstc_gphy);
+	reset_control_put(rstc_gmac);
+}
+
+/* Hercules only uses 13 bits in OTP 0x9801_72C8[12:8] and 0x9801_72D8[7:0]
+   if 0x9801_72C8[12] is 1, then 0x9801_72C8[11:8] (R-calibration) is used to set PHY
+   0x9801_72D8[7:0] is used to set idac_fine for PHY
+ */
+static void r8169soc_load_otp_content(struct rtl8169_private *tp)
+{
+
+	u32 otp;
+	u16 tmp;
+
+	otp = (readl(tp->mmio_otpaddr) & (0x1f << 8)) >> 8;
+	if (0 != ((0x1 << 4) & otp)) {    /* OTP[4] = valid flag, OTP[3:0] = content */
+		tmp = otp ^ R_K_DEFAULT;      /* frc_r_value_default = 0x8 */
+		r8169_mdio_write(tp, 31, 0xbc0);
+		r8169_mdio_write(tp, 20,
+			(tmp | (r8169_mdio_read(tp, 20) & ~(0x1f << 0))));
+	}
+
+	otp = (readl(tp->mmio_otpaddr + 0x10) & (0xff << 0));
+	tmp = otp ^ IDAC_FINE_DEFAULT;      /* IDAC_FINE_DEFAULT = 0x33 */
+	r8169_mdio_write(tp, 31, 0xbc0);
+	r8169_mdio_write(tp, 23,
+			(tmp | (r8169_mdio_read(tp, 23) & ~(0xff << 0))));
+}
+
+static u32 r8169soc_serdes_init(struct rtl8169_private *tp)
+{
+	u32 stable_ticks;
+	u32 tmp;
+	struct clk *clk_en_sds = clk_get(&tp->pdev->dev, "sds");
+	struct reset_control *rstc_sds_reg =
+		reset_control_get(&tp->pdev->dev, "sds_reg");
+	struct reset_control *rstc_sds =
+		reset_control_get(&tp->pdev->dev, "sds");
+	struct reset_control *rstc_pcie0_power =
+		reset_control_get(&tp->pdev->dev, "pcie0_power");
+	struct reset_control *rstc_pcie0_phy =
+		reset_control_get(&tp->pdev->dev, "pcie0_phy");
+	struct reset_control *rstc_pcie0_sgmii_mdio =
+		reset_control_get(&tp->pdev->dev, "pcie0_sgmii_mdio");
+	struct reset_control *rstc_pcie0_phy_mdio =
+		reset_control_get(&tp->pdev->dev, "pcie0_phy_mdio");
+
+	/* reg_0x98000000[4:3] = 11 */
+	/* CRT spec, rstn_sds_reg & rstn_sds */
+	reset_control_deassert(rstc_sds);
+	reset_control_deassert(rstc_sds_reg);
+
+	/* reg_0x98000004[7] = 1 */
+	/* reg_0x98000004[14] = 1 */
+	/* CRT spec, rstn_pcie0_power & rstn_pcie0_phy */
+	reset_control_deassert(rstc_pcie0_power);
+	reset_control_deassert(rstc_pcie0_phy);
+
+	/* reg_0x98000050[13] = 1 */
+	/* reg_0x98000050[16] = 1 */
+	/* CRT spec, rstn_pcie0_sgmii_mdio & rstn_pcie0_phy_mdio */
+	reset_control_deassert(rstc_pcie0_sgmii_mdio);
+	reset_control_deassert(rstc_pcie0_phy_mdio);
+
+	/* reg_0x9800000c[7] = 1 */
+	/* CRT spec, clk_en_sds */
+	clk_prepare_enable(clk_en_sds);
+
+	/* reg_0x9800705c[6] = 1 */
+	/* ISO spec, set PCIE channel to SGMII */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp |= BIT(6);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* reg_0x9800705c[7] = 1 */
+	/* ISO spec, set internal MDIO to PCIE */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp |= BIT(7);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* ### Beginning of SGMII DPHY register tuning ### */
+	MDIO_LOCK;
+
+	/* reg_0x9800705c[20:16] = 00000 */
+	/* ISO spec, set internal PHY addr to SERDES_DPHY_0 */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp &= ~(BIT(20) | BIT(19) | BIT(18) | BIT(17) | BIT(16));
+	tmp |= (SERDES_DPHY_0 << 16);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* # DPHY spec, DPHY reg13[8:7]=00, choose 1.25GHz */
+	r8169_mdio_write(tp, 0x0d,
+		(tmp | (r8169_mdio_read(tp, 0x0d) & ~(BIT(8) | BIT(7)))));
+
+	/* # DPHY spec, 5GHz tuning */
+	r8169_mdio_write(tp, 0x4, 0x52f5);
+	r8169_mdio_write(tp, 0x5, 0xead7);
+	r8169_mdio_write(tp, 0x6, 0x0010);
+	r8169_mdio_write(tp, 0xa, 0xc653);
+	r8169_mdio_write(tp, 0x1, 0xa830);
+
+	/* reg_0x9800705c[20:16] = 00001 */
+	/* ISO spec, set internal PHY addr to SERDES_DPHY_1 */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp &= ~(BIT(20) | BIT(19) | BIT(18) | BIT(17) | BIT(16));
+	tmp |= (SERDES_DPHY_1 << 16);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* TX_Swing_1040mV */
+	r8169_mdio_write(tp, 0x0, 0xd4aa);
+	r8169_mdio_write(tp, 0x1, 0x88aa);
+
+	/* reg_0x9800705c[20:16] = 00001 */
+	/* ISO spec, set internal PHY addr to INT_PHY_ADDR */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp &= ~(BIT(20) | BIT(19) | BIT(18) | BIT(17) | BIT(16));
+	tmp |= (INT_PHY_ADDR << 16);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	tp->ext_phy = true;
+	MDIO_UNLOCK;
+	mdelay(10);     /* wait for clock stable */
+	/* ext_phy == true now */
+
+	#if 0
+	mdelay(10);
+	#else
+	/* reg_0x981c8070[9:0] = 0000000110 */
+	/* SDS spec, set SP_CFG_SDS_DBG_SEL to get PHY_Ready */
+	tmp = readl(tp->mmio_sdsaddr + SDS_REG28);
+	tmp &= ~(0x3ff << 0);
+	tmp |= (0x006 << 0);
+	writel(tmp, tp->mmio_sdsaddr + SDS_REG28);
+
+	tmp = 0;
+	stable_ticks = 0;
+	while (10 > stable_ticks) {
+		/* # SDS spec, wait for phy ready */
+		while (0 == (readl(tp->mmio_sdsaddr + SDS_REG29) & BIT(14))) {
+			stable_ticks = 0;
+			if (tmp >= 100) {
+				stable_ticks = 10;
+				pr_err("SGMII PHY not ready in 100ms\n");
+				break;
+			}
+		}
+		stable_ticks++;
+		tmp++;
+		mdelay(1);
+	}
+	pr_info("SGMII PHY is ready in %d ms", tmp);
+	#endif
+
+	/* reg_0x9800705c[4] = 1 */
+	/* ISO spec, set data path to SGMII */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp |= BIT(4);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* reg_0x981c8008[9:8] = 00 */
+	/* # SDS spec, SP_SDS_FRC_AN, SERDES auto mode */
+	tmp = readl(tp->mmio_sdsaddr + SDS_REG02);
+	tmp &= ~(BIT(9) | BIT(8));
+	writel(tmp, tp->mmio_sdsaddr + SDS_REG02);
+
+	/* # SDS spec, wait for SERDES link up */
+	tmp = 0;
+	stable_ticks = 0;
+	while (10 > stable_ticks) {
+		while ( (BIT(13) | BIT(12)) !=
+			(readl(tp->mmio_sdsaddr + SDS_MISC) &
+			(BIT(13) | BIT(12)))) {
+			stable_ticks = 0;
+			if (tmp >= 100) {
+				stable_ticks = 10;
+				pr_err("SGMII link down in 100ms\n");
+				break;
+			}
+		}
+		stable_ticks++;
+		tmp++;
+		mdelay(1);
+	}
+	pr_info("SGMII link up in %d ms", tmp);
+
+	reset_control_put(rstc_sds_reg);
+	reset_control_put(rstc_sds);
+	reset_control_put(rstc_pcie0_power);
+	reset_control_put(rstc_pcie0_phy);
+	reset_control_put(rstc_pcie0_sgmii_mdio);
+	reset_control_put(rstc_pcie0_phy_mdio);
+	return 0;
+}
+
+static void r8169soc_phy_iol_tuning(struct rtl8169_private *tp)
+{
+	switch (get_rtd_chip_revision()) {
+	case RTD_CHIP_A00: /* TSMC, cut A */
+	case RTD_CHIP_A01: /* TSMC, cut B */
+		/* idacfine */
+		r8169_mdio_write(tp, 31, 0xbc0);
+		r8169_mdio_write(tp, 23, 0x0088);
+
+		/* abiq */
+		/* r8169_mdio_write(tp, 31, 0xbc0); */
+		r8169_mdio_write(tp, 21, 0x0004);
+
+		/* ldvbias */
+		/* r8169_mdio_write(tp, 31, 0xbc0); */
+		r8169_mdio_write(tp, 22, 0x0777);
+
+		/* iatt */
+		r8169_mdio_write(tp, 31, 0xbd0);
+		r8169_mdio_write(tp, 16, 0x0300);
+
+		/* vcm_ref, cf_l */
+		/* r8169_mdio_write(tp, 31, 0xbd0); */
+		r8169_mdio_write(tp, 17, 0xf8ca);
+		break;
+	case RTD_CHIP_A02: /* UMC, cut C */
+		/* 100M Swing */
+		/* idac_fine_mdix, idac_fine_mdi */
+		r8169_mdio_write(tp, 31, 0xbc0);
+		r8169_mdio_write(tp, 23, 0x0044);
+
+		/* 100M Tr/Tf */
+		/* abiq_10m=0x0, abiq_100m_short=0x4, abiq_normal=0x6 */
+		/* mdio_write(tp, 31, 0xbc0); */
+		r8169_mdio_write(tp, 21, 0x0046);
+
+		/* 10M */
+		/* ldvbias_10m=0x7, ldvbias_10m_short=0x4, ldvbias_normal=0x4 */
+		/* mdio_write(tp, 31, 0xbc0); */
+		r8169_mdio_write(tp, 22, 0x0744);
+
+		/* vcmref=0x0, cf_l=0x3 */
+		r8169_mdio_write(tp, 31, 0xbd0);
+		r8169_mdio_write(tp, 17, 0x18ca);
+
+		/* iatt=0x2 */
+		/* mdio_write(tp, 31, 0xbd0); */
+		r8169_mdio_write(tp, 16, 0x0200);
+		break;
+
+	/* default: */
+	}
+}
+
+static void r8169soc_mdio_init(struct rtl8169_private *tp)
+{
+	u32 tmp;
+	struct pinctrl *p_sgmii_mdio;
+	struct pinctrl_state * ps_sgmii_mdio;
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* ISO spec, ETN_PHY_INTR, wait interrupt from PHY and it means MDIO is ready */
+	tmp = 0;
+	while ((readl(tp->mmio_clkaddr + ISO_UMSK_ISR) & BIT(27)) == 0) {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 100) {
+			pr_err("PHY PHY_Status timeout.\n");
+			break;
+		}
+	}
+	pr_info("wait %d ms for PHY interrupt. UMSK_ISR = 0x%x\n",
+		tmp, readl(tp->mmio_clkaddr + ISO_UMSK_ISR));
+
+	MDIO_LOCK;
+	/* In Hercules ByPass mode,
+	   SW need to handle the EPHY Status check ,
+	   OTP data update and EPHY fuse_rdy setting. */
+	if (tp->bypass_enable) {
+		/* PHY will stay in state 1 mode */
+		r8169_mdio_write(tp, 31, 0x0a42);
+		tmp = 0;
+		while (0x1 != (r8169_mdio_read(tp, 16) & 0x07)) {
+			tmp += 1;
+			mdelay(1);
+			if (tmp >= 2000) {
+				pr_err("PHY status is not 0x1 in bypass mode, current = 0x%02x\n",
+					(r8169_mdio_read(tp, 16) & 0x07));
+				break;
+			}
+		}
+
+		/* adjust FE PHY electrical characteristics */
+		r8169soc_phy_iol_tuning(tp);
+
+		/* 1. read OTP 0x9801_72C8[12:8]
+		   2. xor 0x08
+		   3. set value to PHY registers to correct R-calibration
+		   4. read OTP 0x9801_72D8[7:0]
+		   5. xor 0x33
+		   6. set value to PHY registers to correct AMP
+		 */
+		r8169soc_load_otp_content(tp);
+
+		/* fill fuse_rdy & rg_ext_ini_done */
+		r8169_mdio_write(tp, 31, 0x0a46);
+		r8169_mdio_write(tp, 20,
+			(r8169_mdio_read(tp, 20) | (BIT(1) | BIT(0))));
+	} else {
+		/* adjust FE PHY electrical characteristics */
+		r8169soc_phy_iol_tuning(tp);
+	}
+
+	/* init_autoload_done = 1 */
+	tmp = r8169soc_ocp_reg_read(tp, 0xe004);
+	tmp |= BIT(7);
+	r8169soc_ocp_reg_write(tp, 0xe004, tmp);
+	/* ee_mode = 3 */
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	/* wait LAN-ON */
+	r8169_mdio_write(tp, 31, 0x0a42);
+	tmp = 0;
+	do {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 2000) {
+			pr_err("PHY status is not 0x3, current = 0x%02x\n",
+				(r8169_mdio_read(tp, 16) & 0x07));
+			break;
+		}
+	} while (0x3 != (r8169_mdio_read(tp, 16) & 0x07));
+	MDIO_UNLOCK;
+	pr_info("wait %d ms for PHY ready, current = 0x%x\n",
+		tmp, r8169_mdio_read(tp, 16));
+
+	if (tp->output_mode == OUTPUT_EMBEDDED_PHY) {
+		/* Init PHY path */
+		/* reg_0x9800705c[5] = 0 */
+		/* reg_0x9800705c[7] = 0 */
+		/* ISO spec, set internal MDIO to access PHY */
+		tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+		tmp &= ~(BIT(7) | BIT(5));
+		writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+		/* reg_0x9800705c[4] = 0 */
+		/* ISO spec, set data path to access PHY */
+		tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+		tmp &= ~(BIT(4));
+		writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+		/* # ETN spec, GMAC data path select MII-like(embedded GPHY), not SGMII(external PHY) */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(0) | BIT(1));
+		tmp |= BIT(1); /* MII */
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+	} else {
+		/* SGMII */
+		/* # ETN spec, adjust MDC freq=2.5MHz */
+		r8169soc_ocp_reg_write(tp, 0xDE30,
+			r8169soc_ocp_reg_read(tp, 0xDE30) & ~(BIT(7) | BIT(6)));
+		/* # ETN spec, set external PHY addr */
+		r8169soc_ocp_reg_write(tp, 0xDE24,
+			((r8169soc_ocp_reg_read(tp, 0xDE24) & ~(0x1f << 0)) |
+						(tp->ext_phy_id & 0x1f)));
+		/* ISO mux spec, GPIO29 is set to MDC pin */
+		/* ISO mux spec, GPIO46 is set to MDIO pin */
+		p_sgmii_mdio = devm_pinctrl_get(&tp->pdev->dev);
+		ps_sgmii_mdio = pinctrl_lookup_state(p_sgmii_mdio, "sgmii");
+		pinctrl_select_state(p_sgmii_mdio, ps_sgmii_mdio);
+
+		/* check if external PHY is available */
+		pr_info("Searching external PHY...");
+		MDIO_LOCK;
+		tp->ext_phy = true;
+		r8169_mdio_write(tp, 31, 0x0a43);
+		tmp = 0;
+		while (0xa43 != r8169_mdio_read(tp, 31)) {
+			pr_cont(".");
+			tmp += 1;
+			mdelay(1);
+			if (tmp >= 2000) {
+				pr_err("\n External SGMII PHY not found, current = 0x%02x\n",
+					r8169_mdio_read(tp, 31));
+				break;
+			}
+		}
+		if (tmp < 2000)
+			pr_info("found.\n");
+
+		/* lower SGMII TX swing of RTL8211FS to reduce EMI */
+		r8169_mdio_write(tp, 31, 0x0dcd);
+		r8169_mdio_write(tp, 16, 0x104e);	/* TX swing = 470mV, default value */
+
+		tp->ext_phy = false;
+		MDIO_UNLOCK;
+
+		/* # ETN spec, GMAC data path select SGMII(external PHY), not MII-like(embedded GPHY) */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(0) | BIT(1));
+		tmp |= BIT(1) | BIT(0); /* SGMII */
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+		if (0 != r8169soc_serdes_init(tp))
+			pr_err("SERDES init failed\n");
+		/* ext_phy == true now */
+
+		/* SDS spec, auto update SGMII link capability */
+		tmp = readl(tp->mmio_sdsaddr + SDS_LINK);
+		tmp |= BIT(2);
+		writel(tmp, tp->mmio_sdsaddr + SDS_LINK);
+	}
+}
+
+static void r8169soc_eee_init(struct rtl8169_private *tp, bool enable)
+{
+	if (enable) {
+		MDIO_LOCK;
+		if (tp->output_mode == OUTPUT_EMBEDDED_PHY) {
+			/* 100M EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, BIT(1));
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) | (BIT(4) | BIT(2)));
+			/* disable dynamic RX power in PHY */
+			r8169_mdio_write(tp, 31, 0xbd0);
+			r8169_mdio_write(tp, 21, (r8169_mdio_read(tp, 21) & ~BIT(8)) | BIT(9));
+		} else { /* SGMII */
+			/* 1000M & 100M EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, (BIT(2) | BIT(1)));
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) | (BIT(4) | BIT(2)));
+		}
+		MDIO_UNLOCK;
+		/* EEE MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) | (BIT(1) | BIT(0))));
+		/* EEE+ MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe08a, 0x00a7); /* timer to wait FEPHY ready */
+		r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) | BIT(1)));
+	} else {
+		if (tp->output_mode == OUTPUT_EMBEDDED_PHY) {
+			/* no EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, 0);
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) & ~(BIT(4) | BIT(2)));
+		} else { /* SGMII */
+			/* no EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, 0);
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) & ~(BIT(4) | BIT(2)));
+		}
+		MDIO_UNLOCK;
+		/* reset to default value */
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) | BIT(13)));
+		/* EEE MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) & ~(BIT(1) | BIT(0))));
+		/* EEE+ MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) & ~BIT(1)));
+		r8169soc_ocp_reg_write(tp, 0xe08a, 0x003f); /* default value */
+	}
+}
+#endif /* CONFIG_ARCH_RTD139x */
+
+#if defined(CONFIG_ARCH_RTD16xx)
+static void r8169soc_reset_phy_gmac(struct rtl8169_private *tp)
+{
+	u32 tmp;
+	struct clk *clk_etn_sys  = clk_get(&tp->pdev->dev, "etn_sys");
+	struct clk *clk_etn_250m = clk_get(&tp->pdev->dev, "etn_250m");
+	struct reset_control *rstc_gphy =
+		reset_control_get(&tp->pdev->dev, "gphy");
+	struct reset_control *rstc_gmac =
+		reset_control_get(&tp->pdev->dev, "gmac");
+	struct clk *clk_en_sds = NULL;
+	struct reset_control *rstc_sds_reg = NULL;
+	struct reset_control *rstc_sds = NULL;
+	struct reset_control *rstc_pcie0_power = NULL;
+	struct reset_control *rstc_pcie0_phy = NULL;
+	struct reset_control *rstc_pcie0_sgmii_mdio = NULL;
+	struct reset_control *rstc_pcie0_phy_mdio = NULL;
+
+	clk_prepare_enable(clk_etn_sys);
+	clk_prepare_enable(clk_etn_250m);
+
+	if (tp->output_mode != OUTPUT_EMBEDDED_PHY) {
+		clk_en_sds = clk_get(&tp->pdev->dev, "sds");
+		rstc_sds_reg = reset_control_get(&tp->pdev->dev, "sds_reg");
+		rstc_sds = reset_control_get(&tp->pdev->dev, "sds");
+		rstc_pcie0_power = reset_control_get(&tp->pdev->dev, "pcie0_power");
+		rstc_pcie0_phy = reset_control_get(&tp->pdev->dev, "pcie0_phy");
+		rstc_pcie0_sgmii_mdio = reset_control_get(&tp->pdev->dev, "pcie0_sgmii_mdio");
+		rstc_pcie0_phy_mdio = reset_control_get(&tp->pdev->dev, "pcie0_phy_mdio");
+	}
+
+
+	/* reg_0x9800708c[12:11] = 00 */
+	/* ISO spec, clock enable bit for etn clock & etn 250MHz */
+	clk_disable_unprepare(clk_etn_sys);
+	clk_disable_unprepare(clk_etn_250m);
+
+	/* reg_0x98007088[10:9] = 00 */
+	/* ISO spec, rstn_gphy & rstn_gmac */
+	reset_control_assert(rstc_gphy);
+	reset_control_assert(rstc_gmac);
+
+	/* reg_0x98007060[1] = 1 */
+	/* ISO spec, bypass mode enable */
+	tmp = readl(tp->mmio_clkaddr + ISO_ETN_TESTIO);
+	tmp |= BIT(1);
+	writel(tmp, tp->mmio_clkaddr + ISO_ETN_TESTIO);
+
+	/* reg_0x9800705c = 0x00616703 */
+	/* ISO spec, default value */
+	writel(0x00616703, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	if (tp->output_mode != OUTPUT_EMBEDDED_PHY) {
+		/* RESET for SGMII if needed */
+		clk_prepare_enable(clk_en_sds);
+
+		/* reg_0x98000050[13:12] = 10 */
+		/* CRT spec, clk_en_sds */
+		clk_disable_unprepare(clk_en_sds);
+
+		/* reg_0x98000000[7:6] = 10 */
+		/* reg_0x98000000[9:8] = 10 */
+		/* CRT spec, rstn_sds_reg & rstn_sds */
+		reset_control_assert(rstc_sds);
+		reset_control_assert(rstc_sds_reg);
+
+		/* reg_0x98000004[25:24] = 10 	CRT spec, rstn_pcie0_sgmii_mdio */
+		/* reg_0x98000004[23:22] = 10 	CRT spec, rstn_pcie0_phy_mdio */
+		/* reg_0x98000004[19:18] = 10 	CRT spec, rstn_pcie0_power */
+		/* reg_0x98000004[13:12] = 10 	CRT spec, rstn_pcie0_phy */
+		reset_control_assert(rstc_pcie0_sgmii_mdio);
+		reset_control_assert(rstc_pcie0_phy_mdio);
+		reset_control_assert(rstc_pcie0_power);
+		reset_control_assert(rstc_pcie0_phy);
+	}
+
+
+	mdelay(1);
+
+	/* release resource */
+	if (tp->output_mode != OUTPUT_EMBEDDED_PHY) {
+		reset_control_put(rstc_sds_reg);
+		reset_control_put(rstc_sds);
+		reset_control_put(rstc_pcie0_power);
+		reset_control_put(rstc_pcie0_phy);
+		reset_control_put(rstc_pcie0_sgmii_mdio);
+		reset_control_put(rstc_pcie0_phy_mdio);
+	}
+	reset_control_put(rstc_gphy);
+	reset_control_put(rstc_gmac);
+}
+
+static void r8169soc_acp_init(struct rtl8169_private *tp)
+{
+	u32 tmp;
+
+	/* SBX spec, Select ETN access DDR path. */
+	if (tp->acp_enable) {
+		/* reg_0x9801c20c[6] = 1 */
+		/* SBX spec, Mask ETN_ALL to SB3 DBUS REQ */
+		tmp = readl(tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_MASK);
+		tmp |= BIT(6);
+		writel(tmp, tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_MASK);
+
+		pr_info("wait all SB3 access finished...");
+		tmp = 0;
+		while (0 != (BIT(6) & readl(tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_BUSY))) {
+			mdelay(1);
+			tmp += 1;
+			if (tmp >= 100) {
+				pr_err("\n wait SB3 access failed (wait %d ms)\n", tmp);
+				break;
+			}
+		}
+		if (tmp < 100)
+			pr_info("done.\n");
+
+		/* reg_0x9801d100[29] = 0 */
+		/* SCPU wrapper spec, CLKACP division, 0 = div 2, 1 = div 3 */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp &= ~(BIT(29));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d124[1:0] = 00 */
+		/* SCPU wrapper spec, ACP master active, 0 = active */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_INTERFACE_EN);
+		tmp &= ~(BIT(1) | BIT(0));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_INTERFACE_EN);
+
+		/* reg_0x9801d100[30] = 1 */
+		/* SCPU wrapper spec, dy_icg_en_acp */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp |= BIT(30);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d100[21] = 1 */
+		/* SCPU wrapper spec, ACP CLK enable */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp |= BIT(21);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d100[14] = 1 */
+		/* SCPU wrapper spec, Do not apply reset to ACP port axi3 master */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp |= BIT(14);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d800[3:0] = 0111 */
+		/* reg_0x9801d800[7:4] = 0111 */
+		/* reg_0x9801d800[9:8] = 00 */
+		/* reg_0x9801d800[20:16] = 01100 */
+		/* reg_0x9801d800[28:24] = 01110 */
+		/* Configure control of ACP port */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CTRL);
+		tmp &= ~((0x1f << 24) | (0x1f << 16) | (0x1 << 9) |
+			(0xf << 4) | (0xf << 0));
+		tmp |= (0x0e << 24) | (0x0c << 16) | (0x1 << 9) | (0x7 << 4) |
+			(0x7 << 0);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CTRL);
+
+		/* reg_0x9801d030[28] = 1 */
+		/* SCPU wrapper spec, dy_icg_en_acp */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp |= BIT(28);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801d030[16] = 1 */
+		/* SCPU wrapper spec, ACP CLK Enable for acp of scpu_chip_top */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp |= BIT(16);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801d030[0] = 1 */
+		/* SCPU wrapper spec, Do not apply reset to ACP port axi3 master */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp |= BIT(0);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801c814[17] = 1 */
+		/* through ACP to SCPU_ACP */
+		tmp = readl(tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+		tmp |= BIT(17);
+		writel(tmp, tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+
+		/* SBX spec, Remove mask ETN_ALL to ACP DBUS REQ */
+		tmp = readl(tp->mmio_sbxaddr + SBX_ACP_CHANNEL_REQ_MASK);
+		tmp &= ~BIT(1);
+		writel(tmp, tp->mmio_sbxaddr + SBX_ACP_CHANNEL_REQ_MASK);
+
+
+		pr_info("ARM ACP on\n.");
+	} else {
+		/* SBX spec, Mask ETN_ALL to ACP DBUS REQ */
+		tmp = readl(tp->mmio_sbxaddr + SBX_ACP_CHANNEL_REQ_MASK);
+		tmp |= BIT(1);
+		writel(tmp, tp->mmio_sbxaddr + SBX_ACP_CHANNEL_REQ_MASK);
+
+		pr_info("wait all ACP access finished...");
+		tmp = 0;
+		while (0 != (BIT(1) & readl(tp->mmio_sbxaddr + SBX_ACP_CHANNEL_REQ_BUSY))) {
+			mdelay(1);
+			tmp += 1;
+			if (tmp >= 100) {
+				pr_err("\n ACP channel is still busy (wait %d ms)\n", tmp);
+				break;
+			}
+		}
+		if (tmp < 100)
+			pr_info("done.\n");
+
+		/* SCPU wrapper spec, Inactive MP4 AINACTS signal */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_INTERFACE_EN);
+		tmp |= (BIT(1) | BIT(0));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_INTERFACE_EN);
+
+		/* SCPU wrapper spec, nACPRESET_DVFS & CLKENACP_DVFS */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp &= ~(BIT(21) | BIT(14));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* SCPU wrapper spec, nACPRESET & CLKENACP */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp &= ~(BIT(16) | BIT(0));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801c814[17] = 0 */
+		/* SBX spec, Switch ETN_ALL to DC_SYS path */
+		tmp = readl(tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+		tmp &= ~BIT(17);
+		writel(tmp, tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+
+		/* SBX spec, Remove mask ETN_ALL to SB3 DBUS REQ */
+		tmp = readl(tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_MASK);
+		tmp &= ~BIT(6);
+		writel(tmp, tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_MASK);
+
+		pr_info("ARM ACP off\n.");
+	}
+}
+
+static void r8169soc_pll_clock_init(struct rtl8169_private *tp)
+{
+	u32 tmp;
+	struct clk *clk_etn_sys  = clk_get(&tp->pdev->dev, "etn_sys");
+	struct clk *clk_etn_250m = clk_get(&tp->pdev->dev, "etn_250m");
+	struct reset_control *rstc_gphy =
+		reset_control_get(&tp->pdev->dev, "gphy");
+	struct reset_control *rstc_gmac =
+		reset_control_get(&tp->pdev->dev, "gmac");
+
+	/* reg_0x98007004[27] = 1 */
+	/* ISO spec, ETN_PHY_INTR, clear ETN interrupt for ByPassMode */
+	writel(BIT(27), tp->mmio_clkaddr + ISO_UMSK_ISR);
+
+	/* reg_0x98007088[10] = 1 */
+	/* ISO spec, reset bit of gphy */
+	reset_control_deassert(rstc_gphy);
+
+	mdelay(1);	/* wait 1ms for PHY PLL stable */
+
+	/* Thor only supports the bypass mode */
+	/* Bypass mode : ETN MAC bypass efuse update flow. SW need to take this sequence. */
+	/* reg_0x98007060[1] = 1 */
+	/* ISO spec, bypass mode enable */
+	/* bypass mode, SW need to handle the EPHY Status check ,
+	   EFUSE data update and EPHY fuse_rdy setting. */
+	tmp = readl(tp->mmio_clkaddr + ISO_ETN_TESTIO);
+	tmp |= BIT(1);
+	writel(tmp, tp->mmio_clkaddr + ISO_ETN_TESTIO);
+
+	/* reg_0x98007088[9] = 1 */
+	/* ISO spec, reset bit of gmac */
+	reset_control_deassert(rstc_gmac);
+
+	/* reg_0x9800708c[12:11] = 11 */
+	/* ISO spec, clock enable bit for etn clock & etn 250MHz */
+	clk_prepare_enable(clk_etn_sys);
+	clk_prepare_enable(clk_etn_250m);
+
+	mdelay(1);	/* wait 1ms for GMAC uC to be stable */
+
+	/* release resource */
+	reset_control_put(rstc_gphy);
+	reset_control_put(rstc_gmac);
+}
+
+static void r8169soc_load_otp_content(struct rtl8169_private *tp)
+{
+	u32 otp;
+	u16 tmp;
+
+	/* RC-K 0x980174F8[27:24] */
+	otp = (readl(tp->mmio_otpaddr) & (0xf << 24)) >> 24;
+	tmp = (otp << 12) | (otp << 8) | (otp << 4) | otp;
+	tmp ^= RC_K_DEFAULT;
+	r8169_mdio_write(tp, 31, 0xbcd);
+	r8169_mdio_write(tp, 22, tmp);
+	r8169_mdio_write(tp, 23, tmp);
+
+	/* R-K 0x98017500[18:15] */
+	otp = (readl(tp->mmio_otpaddr + 0x8) & (0xf << 15)) >> 15;
+	tmp = (otp << 12) | (otp << 8) | (otp << 4) | otp;
+	tmp ^= R_K_DEFAULT;
+	r8169_mdio_write(tp, 31, 0xbce);
+	r8169_mdio_write(tp, 16, tmp);
+	r8169_mdio_write(tp, 17, tmp);
+
+	/* Amp-K 0x980174FC[15:0] */
+	otp = (readl(tp->mmio_otpaddr + 0x4) & (0xffff << 0)) >> 0;
+	tmp = otp ^ AMP_K_DEFAULT;
+	r8169_mdio_write(tp, 31, 0xbca);
+	r8169_mdio_write(tp, 22, tmp);
+
+	/* Bias-K 0x980174FC[31:16] */
+	otp = (readl(tp->mmio_otpaddr + 0x4) & (0xffff << 16)) >> 16;
+	tmp = otp ^ ADC_BIAS_K_DEFAULT;
+	r8169_mdio_write(tp, 31, 0xbcf);
+	r8169_mdio_write(tp, 22, tmp);
+}
+
+static u32 r8169soc_serdes_init(struct rtl8169_private *tp)
+{
+	u32 stable_ticks;
+	u32 tmp;
+	struct clk *clk_en_sds = clk_get(&tp->pdev->dev, "sds");
+	struct reset_control *rstc_sds_reg =
+		reset_control_get(&tp->pdev->dev, "sds_reg");
+	struct reset_control *rstc_sds =
+		reset_control_get(&tp->pdev->dev, "sds");
+	struct reset_control *rstc_pcie0_power =
+		reset_control_get(&tp->pdev->dev, "pcie0_power");
+	struct reset_control *rstc_pcie0_phy =
+		reset_control_get(&tp->pdev->dev, "pcie0_phy");
+	struct reset_control *rstc_pcie0_sgmii_mdio =
+		reset_control_get(&tp->pdev->dev, "pcie0_sgmii_mdio");
+	struct reset_control *rstc_pcie0_phy_mdio =
+		reset_control_get(&tp->pdev->dev, "pcie0_phy_mdio");
+
+	/* reg_0x98000050[13:12] = 11 */
+	/* CRT spec, clk_en_sds */
+	clk_prepare_enable(clk_en_sds);
+
+	/* reg_0x98000000[9:8] = 11 */
+	/* reg_0x98000000[7:6] = 11 */
+	/* CRT spec, rstn_sds_reg & rstn_sds */
+	reset_control_deassert(rstc_sds);
+	reset_control_deassert(rstc_sds_reg);
+
+	/* reg_0x98000004[25:24] = 11 	CRT spec, rstn_pcie0_sgmii_mdio */
+	/* reg_0x98000004[23:22] = 11 	CRT spec, rstn_pcie0_phy_mdio */
+	/* reg_0x98000004[19:18] = 11 	CRT spec, rstn_pcie0_power */
+	/* reg_0x98000004[13:12] = 11 	CRT spec, rstn_pcie0_phy */
+	reset_control_deassert(rstc_pcie0_power);
+	reset_control_deassert(rstc_pcie0_phy);
+	reset_control_deassert(rstc_pcie0_sgmii_mdio);
+	reset_control_deassert(rstc_pcie0_phy_mdio);
+
+	/* reg_0x9800705c[6] = 1 */
+	/* ISO spec, set PCIe channel to SGMII */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp |= BIT(6);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* ### Beginning of SGMII DPHY register tuning ### */
+	MDIO_LOCK;
+
+	/* reg_0x9800705c[7] = 1 */
+	/* ISO spec, set internal MDIO to PCIe */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp |= BIT(7);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* reg_0x9800705c[20:16] = 00000 */
+	/* ISO spec, set internal PHY addr to SERDES_DPHY_0 */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp &= ~(BIT(20) | BIT(19) | BIT(18) | BIT(17) | BIT(16));
+	tmp |= (SERDES_DPHY_0 << 16);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* # DPHY spec, 5GHz tuning */
+	r8169_mdio_write(tp, 0x4, 0x52f5);
+	r8169_mdio_write(tp, 0x5, 0xead7);
+	r8169_mdio_write(tp, 0x6, 0x0010);
+	r8169_mdio_write(tp, 0xa, 0xc653);
+	r8169_mdio_write(tp, 0x1, 0xe030);
+	r8169_mdio_write(tp, 0xd, 0xee1c);
+
+	/* reg_0x9800705c[20:16] = 00001 */
+	/* ISO spec, set internal PHY addr to SERDES_DPHY_1 */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp &= ~(BIT(20) | BIT(19) | BIT(18) | BIT(17) | BIT(16));
+	tmp |= (SERDES_DPHY_1 << 16);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* TX_Swing_550mV by default */
+	switch (tp->sgmii_swing) {
+	case TX_Swing_190mV:
+		r8169_mdio_write(tp, 0x0, 0xd411);
+		r8169_mdio_write(tp, 0x1, 0x2277);
+		break;
+	case TX_Swing_250mV:
+		r8169_mdio_write(tp, 0x0, 0xd433);
+		r8169_mdio_write(tp, 0x1, 0x2244);
+		break;
+	case TX_Swing_380mV:
+		r8169_mdio_write(tp, 0x0, 0xd433);
+		r8169_mdio_write(tp, 0x1, 0x22aa);
+		break;
+	case TX_Swing_550mV: /* recommended by RDC */
+	default :
+		r8169_mdio_write(tp, 0x0, 0xd455);
+		r8169_mdio_write(tp, 0x1, 0x2828);
+	}
+
+	/* reg_0x9800705c[20:16] = 00001 */
+	/* ISO spec, set internal PHY addr to INT_PHY_ADDR */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp &= ~(BIT(20) | BIT(19) | BIT(18) | BIT(17) | BIT(16));
+	tmp |= (INT_PHY_ADDR << 16);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	mdelay(10);     /* wait for clock stable */
+
+	/* reg_0x9800705c[5] = 0 */
+	/* reg_0x9800705c[7] = 0 */
+	/* ISO spec, set internal MDIO to GPHY */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp &= ~(BIT(7) | BIT(5));
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	MDIO_UNLOCK;
+	tp->ext_phy = true;
+	/* ext_phy == true now */
+
+	tmp = 0;
+	stable_ticks = 0;
+	while (10 > stable_ticks) {
+		/* # SDS spec, wait for phy ready */
+		while (0 == (readl(tp->mmio_sdsaddr + SDS_LINK) & BIT(24))) {
+			stable_ticks = 0;
+			if (tmp >= 100) {
+				stable_ticks = 10;
+				pr_err("SGMII PHY not ready in 100ms\n");
+				break;
+			}
+		}
+		stable_ticks++;
+		tmp++;
+		mdelay(1);
+	}
+	pr_info("SGMII PHY is ready in %d ms", tmp);
+
+	/* reg_0x9800705c[4] = 1 */
+	/* ISO spec, set data path to SGMII */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp |= BIT(4);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	/* reg_0x981c8008[9:8] = 00 */
+	/* # SDS spec, SP_SDS_FRC_AN, SERDES auto mode */
+	tmp = readl(tp->mmio_sdsaddr + SDS_REG02);
+	tmp &= ~(BIT(9) | BIT(8));
+	writel(tmp, tp->mmio_sdsaddr + SDS_REG02);
+
+	/* # SDS spec, wait for SERDES link up */
+	tmp = 0;
+	stable_ticks = 0;
+	while (10 > stable_ticks) {
+		while ( 0 == (readl(tp->mmio_sdsaddr + SDS_MISC) & BIT(12))) {
+			stable_ticks = 0;
+			if (tmp >= 100) {
+				stable_ticks = 10;
+				pr_err("SGMII link down in 100ms\n");
+				break;
+			}
+		}
+		stable_ticks++;
+		tmp++;
+		mdelay(1);
+	}
+	pr_info("SGMII link up in %d ms", tmp);
+
+	reset_control_put(rstc_sds_reg);
+	reset_control_put(rstc_sds);
+	reset_control_put(rstc_pcie0_power);
+	reset_control_put(rstc_pcie0_phy);
+	reset_control_put(rstc_pcie0_sgmii_mdio);
+	reset_control_put(rstc_pcie0_phy_mdio);
+	return 0;
+}
+
+static void r8169soc_phy_iol_tuning(struct rtl8169_private *tp)
+{
+	/* for common mode voltage */
+	r8169_mdio_write(tp, 31, 0xbc0);
+	r8169_mdio_write(tp, 17,
+		((r8169_mdio_read(tp, 17) & ~(0xff << 4)) | (0xb4 << 4)));
+
+	/* for 1000 Base-T, Transmitter Distortion */
+	r8169_mdio_write(tp, 31, 0xa43);
+	r8169_mdio_write(tp, 27, 0x8082);
+	r8169_mdio_write(tp, 28, 0xae00);
+}
+
+static void r8169soc_phy_sram_table(struct rtl8169_private *tp)
+{
+	/* enable echo power*2 */
+	r8169_mdio_write(tp, 31, 0xa42);
+	r8169_mdio_write(tp, 22, 0x0f10);
+
+	/* Channel estimation, 100Mbps adjustment */
+	r8169_mdio_write(tp, 31, 0xa43);
+	r8169_mdio_write(tp, 27, 0x8087);	/* gain_i slope */
+	r8169_mdio_write(tp, 28, 0x42f0);	/* 0x43 => 0x42 */
+	r8169_mdio_write(tp, 27, 0x808e);	/* clen_i_c initial value */
+	r8169_mdio_write(tp, 28, 0x14a4);	/* 0x13 => 0x14 */
+	/* adc peak adjustment */
+	r8169_mdio_write(tp, 27, 0x8088);	/* aagc_lvl_c initial value 0x3f0 => ok */
+	r8169_mdio_write(tp, 28, 0xf0eb);	/* delta_a slope 0x1e => 0x1d */
+	/* cb0 adjustment */
+	r8169_mdio_write(tp, 27, 0x808c);	/* cb0_i_c initial value */
+	r8169_mdio_write(tp, 28, 0xef09);	/* 0x9ef => ok */
+	r8169_mdio_write(tp, 27, 0x808f);	/* delta_b slope */
+	r8169_mdio_write(tp, 28, 0xa4c6);	/* 0xa4 => ok */
+	/* DAGC adjustment */
+	r8169_mdio_write(tp, 27, 0x808a);	/* cg_i_c initial value */
+	r8169_mdio_write(tp, 28, 0x400a);	/* 0xb40 => 0xa40 */
+	r8169_mdio_write(tp, 27, 0x8092);	/* delta_g slope */
+	r8169_mdio_write(tp, 28, 0xc21e);	/* 0x0c0 => 0x0c2 */
+
+	/* 1000Mbps master adjustment */
+	/* line adjustment */
+	r8169_mdio_write(tp, 27, 0x8099);	/* gain_i slope */
+	r8169_mdio_write(tp, 28, 0x2ae0);	/* 0x2e => 0x2a */
+	r8169_mdio_write(tp, 27, 0x80a0);	/* clen_i_c initial value */
+	r8169_mdio_write(tp, 28, 0xf28f);	/* 0xfe => 0xf2 */
+	/* adc peak adjustment */
+	r8169_mdio_write(tp, 27, 0x809a);	/* aagc_lvl_c initial value 0x3e0 => 0x470 */
+	r8169_mdio_write(tp, 28, 0x7084);	/* delta_a slope 0x0d => 0x10 */
+	/* cb0 adjustment */
+	r8169_mdio_write(tp, 27, 0x809e);	/* cb0_i_c initial value */
+	r8169_mdio_write(tp, 28, 0xa008);	/* 0x7a1 => 0x8a0 */
+	r8169_mdio_write(tp, 27, 0x80a1);	/* delta_b slope */
+	r8169_mdio_write(tp, 28, 0x783d);	/* 0x8f => 0x78 */
+	/* DAGC adjustment */
+	r8169_mdio_write(tp, 27, 0x809c);	/* cg_i_c initial value */
+	r8169_mdio_write(tp, 28, 0x8008);	/* 0xb00 => 0x880 */
+	r8169_mdio_write(tp, 27, 0x80a4);	/* delta_g slope */
+	r8169_mdio_write(tp, 28, 0x580c);	/* 0x063 => 0x058 */
+
+	/* 1000Mbps slave adjustment */
+	/* line adjustment */
+	r8169_mdio_write(tp, 27, 0x80ab);	/* gain_i slope */
+	r8169_mdio_write(tp, 28, 0x2b4a);	/* 0x2e => 0x2b */
+	r8169_mdio_write(tp, 27, 0x80b2);	/* clen_i_c initial value */
+	r8169_mdio_write(tp, 28, 0xf47f);	/* 0xfa => 0xf4 */
+	/* adc peak adjustment */
+	r8169_mdio_write(tp, 27, 0x80ac);	/* aagc_lvl_c initial value 0x44a => 0x488 */
+	r8169_mdio_write(tp, 28, 0x8884);	/* delta_a slope 0x0e => 0x10 */
+	/* cb0 adjustment */
+	r8169_mdio_write(tp, 27, 0x80b0);	/* cb0_i_c initial value */
+	r8169_mdio_write(tp, 28, 0xa107);	/* 0x6a1 => 0x7a1 */
+	r8169_mdio_write(tp, 27, 0x80b3);	/* delta_b slope */
+	r8169_mdio_write(tp, 28, 0x683d);	/* 0x7f => 0x68 */
+	/* DAGC adjustment */
+	r8169_mdio_write(tp, 27, 0x80ae);	/* cg_i_c initial value */
+	r8169_mdio_write(tp, 28, 0x2006);	/* 0x760 => 0x620 */
+	r8169_mdio_write(tp, 27, 0x80b6);	/* delta_g slope */
+	r8169_mdio_write(tp, 28, 0x850c);	/* 0x090 => 0x085 */
+}
+
+static void r8169soc_patch_gphy_uc_code(struct rtl8169_private *tp)
+{
+	u32 tmp;
+
+	/* patch for GPHY uC firmware, adjust 1000M EEE lpi_waketx_timer = 1.3uS */
+	#define PATCH_KEY_ADDR  0x8028   // for RL6525
+	#define PATCH_KEY       0x5600   // for RL6525
+
+	/* Patch request & wait for the asserting of patch_rdy */
+	r8169_mdio_write(tp, 31, 0xb82);
+	r8169_mdio_write(tp, 16, r8169_mdio_read(tp, 16) | (BIT(4)));
+
+	tmp = 0;
+	r8169_mdio_write(tp, 31, 0xb80);
+	while ((r8169_mdio_read(tp, 16) & BIT(6)) == 0) {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 100) {
+			pr_err("GPHY patch_rdy timeout.\n");
+			break;
+		}
+	}
+	pr_err("wait %d ms for GPHY patch_rdy. reg = 0x%x\n",
+		tmp, r8169_mdio_read(tp, 16));
+	pr_err("patch_rdy is asserted!!\n");
+
+	/* Set patch_key & patch_lock */
+	r8169_mdio_write(tp, 31, 0);
+	r8169_mdio_write(tp, 27, PATCH_KEY_ADDR);
+	r8169_mdio_write(tp, 28, PATCH_KEY);
+	r8169_mdio_write(tp, 27, PATCH_KEY_ADDR);
+	pr_err("check patch key = %04x\n", r8169_mdio_read(tp, 28));
+	r8169_mdio_write(tp, 27, 0xb82e);
+	r8169_mdio_write(tp, 28, 0x0001);
+
+	/* uC patch code, released by Digital Designer */
+	r8169_mdio_write(tp, 0x1f, 0x0000);
+	r8169_mdio_write(tp, 27, 0xb820);
+	r8169_mdio_write(tp, 28, 0x0290);
+
+	r8169_mdio_write(tp, 27, 0xa012);
+	r8169_mdio_write(tp, 28, 0x0000);
+
+	r8169_mdio_write(tp, 27, 0xa014);
+	r8169_mdio_write(tp, 28, 0x2c04);
+	r8169_mdio_write(tp, 28, 0x2c06);
+	r8169_mdio_write(tp, 28, 0x2c09);
+	r8169_mdio_write(tp, 28, 0x2c0c);
+	r8169_mdio_write(tp, 28, 0xd093);
+	r8169_mdio_write(tp, 28, 0x2265);
+	r8169_mdio_write(tp, 28, 0x9e20);
+	r8169_mdio_write(tp, 28, 0xd703);
+	r8169_mdio_write(tp, 28, 0x2502);
+	r8169_mdio_write(tp, 28, 0x9e40);
+	r8169_mdio_write(tp, 28, 0xd700);
+	r8169_mdio_write(tp, 28, 0x0800);
+	r8169_mdio_write(tp, 28, 0x9e80);
+	r8169_mdio_write(tp, 28, 0xd70d);
+	r8169_mdio_write(tp, 28, 0x202e);
+
+	r8169_mdio_write(tp, 27, 0xa01a);
+	r8169_mdio_write(tp, 28, 0x0000);
+
+	r8169_mdio_write(tp, 27, 0xa006);
+	r8169_mdio_write(tp, 28, 0x002d);
+
+	r8169_mdio_write(tp, 27, 0xa004);
+	r8169_mdio_write(tp, 28, 0x0507);
+
+	r8169_mdio_write(tp, 27, 0xa002);
+	r8169_mdio_write(tp, 28, 0x0501);
+
+	r8169_mdio_write(tp, 27, 0xa000);
+	r8169_mdio_write(tp, 28, 0x1264);
+
+	r8169_mdio_write(tp, 27, 0xb820);
+	r8169_mdio_write(tp, 28, 0x0210);
+
+	r8169_mdio_write(tp, 31, 0);
+
+	mdelay(10);
+
+	/* Clear patch_key & patch_lock */
+	r8169_mdio_write(tp, 27, PATCH_KEY_ADDR);
+	r8169_mdio_write(tp, 28, 0);
+	r8169_mdio_write(tp, 31, 0xb82);
+	r8169_mdio_write(tp, 23, 0);
+
+	/* Release patch request & wait for the deasserting of patch_rdy. */
+	r8169_mdio_write(tp, 31, 0xb82);
+	r8169_mdio_write(tp, 16, r8169_mdio_read(tp, 16) & ~(BIT(4)));
+
+	tmp = 0;
+	r8169_mdio_write(tp, 31, 0xb80);
+	while ((r8169_mdio_read(tp, 16) & BIT(6)) != 0) {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 100) {
+			pr_err("GPHY patch_rdy timeout.\n");
+			break;
+		}
+	}
+	pr_err("wait %d ms for GPHY patch_rdy. reg = 0x%x\n",
+		tmp, r8169_mdio_read(tp, 16));
+
+	pr_err("\npatch_rdy is de-asserted!!\n");
+	pr_err("GPHY uC code patched.\n");
+}
+
+static void r8169soc_mdio_init(struct rtl8169_private *tp)
+{
+	u32 tmp;
+	struct pinctrl *p_sgmii_mdio;
+	struct pinctrl_state * ps_sgmii_mdio;
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* ISO spec, ETN_PHY_INTR, wait interrupt from PHY and it means MDIO is ready */
+	tmp = 0;
+	while ((readl(tp->mmio_clkaddr + ISO_UMSK_ISR) & BIT(27)) == 0) {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 100) {
+			pr_err("PHY PHY_Status timeout.\n");
+			break;
+		}
+	}
+	pr_info("wait %d ms for PHY interrupt. UMSK_ISR = 0x%x\n",
+		tmp, readl(tp->mmio_clkaddr + ISO_UMSK_ISR));
+
+	MDIO_LOCK;
+	/* In ByPass mode,
+	   SW need to handle the EPHY Status check ,
+	   OTP data update and EPHY fuse_rdy setting. */
+	/* PHY will stay in state 1 mode */
+	r8169_mdio_write(tp, 31, 0x0a42);
+	tmp = 0;
+	while (0x1 != (r8169_mdio_read(tp, 16) & 0x07)) {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 2000) {
+			pr_err("PHY status is not 0x1 in bypass mode, current = 0x%02x\n",
+				(r8169_mdio_read(tp, 16) & 0x07));
+			break;
+		}
+	}
+
+	/* fill fuse_rdy & rg_ext_ini_done */
+	r8169_mdio_write(tp, 31, 0x0a46);
+	r8169_mdio_write(tp, 20,
+		(r8169_mdio_read(tp, 20) | (BIT(1) | BIT(0))));
+
+	/* init_autoload_done = 1 */
+	tmp = r8169soc_ocp_reg_read(tp, 0xe004);
+	tmp |= BIT(7);
+	r8169soc_ocp_reg_write(tp, 0xe004, tmp);
+
+	/* ee_mode = 3 */
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	/* wait LAN-ON */
+	r8169_mdio_write(tp, 31, 0x0a42);
+	tmp = 0;
+	do {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 2000) {
+			pr_err("PHY status is not 0x3, current = 0x%02x\n",
+				(r8169_mdio_read(tp, 16) & 0x07));
+			break;
+		}
+	} while (0x3 != (r8169_mdio_read(tp, 16) & 0x07));
+	pr_info("wait %d ms for PHY ready, current = 0x%x\n",
+		tmp, r8169_mdio_read(tp, 16));
+
+	/* adjust PHY SRAM table */
+	r8169soc_phy_sram_table(tp);
+
+	/* GPHY patch code */
+	r8169soc_patch_gphy_uc_code(tp);
+
+	/* adjust PHY electrical characteristics */
+	r8169soc_phy_iol_tuning(tp);
+
+	/* load OTP contents (RC-K, R-K, Amp-K, and Bias-K)
+	   RC-K:	0x980174F8[27:24]
+	   R-K:		0x98017500[18:15]
+	   Amp-K:	0x980174FC[15:0]
+	   Bias-K:	0x980174FC[31:16]
+	 */
+	r8169soc_load_otp_content(tp);
+
+	MDIO_UNLOCK;
+
+	if (tp->output_mode == OUTPUT_EMBEDDED_PHY) {
+		/* Init PHY path */
+		/* reg_0x9800705c[5] = 0 */
+		/* reg_0x9800705c[7] = 0 */
+		/* ISO spec, set internal MDIO to access PHY */
+		tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+		tmp &= ~(BIT(7) | BIT(5));
+		writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+		/* reg_0x9800705c[4] = 0 */
+		/* ISO spec, set data path to access PHY */
+		tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+		tmp &= ~(BIT(4));
+		writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+		/* # ETN spec, GMAC data path select MII-like(embedded GPHY), not SGMII(external PHY) */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(0) | BIT(1));
+		tmp |= BIT(1); /* MII */
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+	} else {
+		/* SGMII */
+		/* # ETN spec, adjust MDC freq=2.5MHz */
+		r8169soc_ocp_reg_write(tp, 0xDE30,
+			r8169soc_ocp_reg_read(tp, 0xDE30) & ~(BIT(7) | BIT(6)));
+		/* # ETN spec, set external PHY addr */
+		r8169soc_ocp_reg_write(tp, 0xDE24,
+			((r8169soc_ocp_reg_read(tp, 0xDE24) & ~(0x1f << 0)) |
+						(tp->ext_phy_id & 0x1f)));
+		/* ISO mux spec, GPIO29 is set to MDC pin */
+		/* ISO mux spec, GPIO46 is set to MDIO pin */
+		p_sgmii_mdio = devm_pinctrl_get(&tp->pdev->dev);
+		ps_sgmii_mdio = pinctrl_lookup_state(p_sgmii_mdio, "sgmii");
+		pinctrl_select_state(p_sgmii_mdio, ps_sgmii_mdio);
+
+		/* check if external PHY is available */
+		pr_info("Searching external PHY...");
+		MDIO_LOCK;
+		tp->ext_phy = true;
+		r8169_mdio_write(tp, 31, 0x0a43);
+		tmp = 0;
+		while (0xa43 != r8169_mdio_read(tp, 31)) {
+			pr_cont(".");
+			tmp += 1;
+			mdelay(1);
+			if (tmp >= 2000) {
+				pr_err("\n External SGMII PHY not found, current = 0x%02x\n",
+					r8169_mdio_read(tp, 31));
+				return;
+			}
+		}
+		if (tmp < 2000)
+			pr_cont("found.\n");
+
+		/* lower SGMII TX swing of RTL8211FS to reduce EMI */
+		r8169_mdio_write(tp, 31, 0x0dcd);
+		r8169_mdio_write(tp, 16, 0x104e);	/* TX swing = 470mV, default value */
+
+		tp->ext_phy = false;
+		MDIO_UNLOCK;
+
+		/* # ETN spec, GMAC data path select SGMII(external PHY), not MII-like(embedded GPHY) */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(0) | BIT(1));
+		tmp |= BIT(1) | BIT(0); /* SGMII */
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+		if (0 != r8169soc_serdes_init(tp))
+			pr_err("SERDES init failed\n");
+		/* ext_phy == true now */
+
+		/* SDS spec, auto update SGMII link capability */
+		tmp = readl(tp->mmio_sdsaddr + SDS_DEBUG);
+		tmp |= BIT(2);
+		writel(tmp, tp->mmio_sdsaddr + SDS_DEBUG);
+
+		/* enable 8b/10b symbol error even it is only valid in 1000Mbps */
+		r8169_mdio_write(tp, 31, 0x0dcf);
+		r8169_mdio_write(tp, 16,
+			(r8169_mdio_read(tp, 16) & ~(BIT(2) | BIT(1) | BIT(0))));
+		r8169_mdio_read(tp, 17); /* dummy read */
+	}
+}
+
+static void r8169soc_eee_init(struct rtl8169_private *tp, bool enable)
+{
+	if (enable) {
+		MDIO_LOCK;
+		if (tp->output_mode == OUTPUT_EMBEDDED_PHY) {
+			/* 1000M/100M EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, (BIT(2) | BIT(1)));
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) | (BIT(4) | BIT(2)));
+			/* disable dynamic RX power in PHY */
+			r8169_mdio_write(tp, 31, 0xbd0);
+			r8169_mdio_write(tp, 21, (r8169_mdio_read(tp, 21) & ~BIT(8)) | BIT(9));
+		} else { /* SGMII */
+			/* 1000M & 100M EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, (BIT(2) | BIT(1)));
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) | (BIT(4) | BIT(2)));
+		}
+		MDIO_UNLOCK;
+		/* EEE MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) | (BIT(1) | BIT(0))));
+		/* EEE+ MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) | BIT(1)));
+	} else {
+		if (tp->output_mode == OUTPUT_EMBEDDED_PHY) {
+			/* no EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, 0);
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) & ~(BIT(4) | BIT(2)));
+		} else { /* SGMII */
+			/* no EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, 0);
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) & ~(BIT(4) | BIT(2)));
+		}
+		MDIO_UNLOCK;
+		/* reset to default value */
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) | BIT(13)));
+		/* EEE MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) & ~(BIT(1) | BIT(0))));
+		/* EEE+ MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) & ~BIT(1)));
+	}
+}
+#endif /* CONFIG_ARCH_RTD16xx */
+
+#if defined(CONFIG_ARCH_RTD13xx)
+static void r8169soc_reset_phy_gmac(struct rtl8169_private *tp)
+{
+	u32 tmp;
+	struct clk *clk_etn_sys  = clk_get(&tp->pdev->dev, "etn_sys");
+	struct clk *clk_etn_250m = clk_get(&tp->pdev->dev, "etn_250m");
+	struct reset_control *rstc_gphy =
+		reset_control_get(&tp->pdev->dev, "gphy");
+	struct reset_control *rstc_gmac =
+		reset_control_get(&tp->pdev->dev, "gmac");
+
+	clk_prepare_enable(clk_etn_sys);
+	clk_prepare_enable(clk_etn_250m);
+
+	/* reg_0x9800708c[12:11] = 00 */
+	/* ISO spec, clock enable bit for etn clock & etn 250MHz */
+	clk_disable_unprepare(clk_etn_sys);
+	clk_disable_unprepare(clk_etn_250m);
+
+	/* reg_0x98007088[10:9] = 00 */
+	/* ISO spec, rstn_gphy & rstn_gmac */
+	reset_control_assert(rstc_gphy);
+	reset_control_assert(rstc_gmac);
+
+	/* reg_0x98007060[1] = 1 */
+	/* ISO spec, bypass mode enable */
+	tmp = readl(tp->mmio_clkaddr + ISO_ETN_TESTIO);
+	tmp |= BIT(1);
+	writel(tmp, tp->mmio_clkaddr + ISO_ETN_TESTIO);
+
+	/* reg_0x9800705c[5] = 0 */
+	/* ISO spec, default value and specify internal/external PHY ID as 1 */
+	tmp = readl(tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+	tmp &= ~((0x1f << 21) | (0x1f << 16) | BIT(5));
+	tmp |= (0x1 << 21) | (0x1 << 16);
+	writel(tmp, tp->mmio_clkaddr + ISO_POWERCUT_ETN);
+
+	#if defined(RTK_FPGA)
+	/* reg_0x98007fc0[0] = 0 */
+	/* ISO spec, disable dbus clock gating */
+	tmp = readl(tp->mmio_clkaddr + ISO_ETN_DBUS_CTRL);
+	tmp &= ~BIT(0);
+	writel(tmp, tp->mmio_clkaddr + ISO_ETN_DBUS_CTRL);
+	#endif /* RTK_FPGA */
+
+	mdelay(1);
+
+	/* release resource */
+	reset_control_put(rstc_gphy);
+	reset_control_put(rstc_gmac);
+}
+
+static void r8169soc_acp_init(struct rtl8169_private *tp)
+{
+#if 0
+	u32 tmp;
+
+	/* SBX spec, Select ETN access DDR path. */
+	if (tp->acp_enable) {
+		/* reg_0x9801c20c[6] = 1 */
+		/* SBX spec, Mask ETN_ALL to SB3 DBUS REQ */
+		tmp = readl(tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_MASK);
+		tmp |= BIT(6);
+		writel(tmp, tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_MASK);
+
+		pr_info("wait all SB3 access finished...");
+		tmp = 0;
+		while (0 != (BIT(6) & readl(tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_BUSY))) {
+			mdelay(10);
+			tmp += 10;
+			if (tmp >= 100) {
+				pr_err("\n wait SB3 access failed (wait %d ms)\n", tmp);
+				break;
+			}
+		}
+		if (tmp < 100)
+			pr_info("done.\n");
+
+		/* reg_0x9801d100[29] = 0 */
+		/* SCPU wrapper spec, CLKACP division, 0 = div 2, 1 = div 3 */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp &= ~(BIT(29));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d124[1:0] = 00 */
+		/* SCPU wrapper spec, ACP master active, 0 = active */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_INTERFACE_EN);
+		tmp &= ~(BIT(1) | BIT(0));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_INTERFACE_EN);
+
+		/* reg_0x9801d100[30] = 1 */
+		/* SCPU wrapper spec, dy_icg_en_acp */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp |= BIT(30);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d100[21] = 1 */
+		/* SCPU wrapper spec, ACP CLK enable */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp |= BIT(21);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d100[14] = 1 */
+		/* SCPU wrapper spec, Do not apply reset to ACP port axi3 master */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp |= BIT(14);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* reg_0x9801d800[3:0] = 0111 */
+		/* reg_0x9801d800[7:4] = 0111 */
+		/* reg_0x9801d800[9:8] = 00 */
+		/* reg_0x9801d800[20:16] = 01100 */
+		/* reg_0x9801d800[28:24] = 01110 */
+		/* Configure control of ACP port */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CTRL);
+		tmp &= ~((0x1f << 24) | (0x1f << 16) | (0x1 << 9) |
+			(0xf << 4) | (0xf << 0));
+		tmp |= (0x0e << 24) | (0x0c << 16) | (0x1 << 9) | (0x7 << 4) |
+			(0x7 << 0);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CTRL);
+
+		/* reg_0x9801d030[28] = 1 */
+		/* SCPU wrapper spec, dy_icg_en_acp */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp |= BIT(28);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801d030[16] = 1 */
+		/* SCPU wrapper spec, ACP CLK Enable for acp of scpu_chip_top */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp |= BIT(16);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801d030[0] = 1 */
+		/* SCPU wrapper spec, Do not apply reset to ACP port axi3 master */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp |= BIT(0);
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801c814[17] = 1 */
+		/* through ACP to SCPU_ACP */
+		tmp = readl(tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+		tmp |= BIT(17);
+		writel(tmp, tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+
+		/* SBX spec, Remove mask ETN_ALL to ACP DBUS REQ */
+		tmp = readl(tp->mmio_sbxaddr + SBX_ACP_CHANNEL_REQ_MASK);
+		tmp &= ~BIT(1);
+		writel(tmp, tp->mmio_sbxaddr + SBX_ACP_CHANNEL_REQ_MASK);
+
+
+		pr_info("ARM ACP on\n.");
+	} else {
+		/* SBX spec, Mask ETN_ALL to ACP DBUS REQ */
+		tmp = readl(tp->mmio_sbxaddr + SBX_ACP_CHANNEL_REQ_MASK);
+		tmp |= BIT(1);
+		writel(tmp, tp->mmio_sbxaddr + SBX_ACP_CHANNEL_REQ_MASK);
+
+		pr_info("wait all ACP access finished...");
+		tmp = 0;
+		while (0 != (BIT(1) & readl(tp->mmio_sbxaddr + SBX_ACP_CHANNEL_REQ_BUSY))) {
+			mdelay(1);
+			tmp += 1;
+			if (tmp >= 100) {
+				pr_err("\n ACP channel is still busy (wait %d ms)\n", tmp);
+				break;
+			}
+		}
+		if (tmp < 100)
+			pr_info("done.\n");
+
+		/* SCPU wrapper spec, Inactive MP4 AINACTS signal */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_INTERFACE_EN);
+		tmp |= (BIT(1) | BIT(0));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_INTERFACE_EN);
+
+		/* SCPU wrapper spec, nACPRESET_DVFS & CLKENACP_DVFS */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+		tmp &= ~(BIT(21) | BIT(14));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_CRT_CTRL);
+
+		/* SCPU wrapper spec, nACPRESET & CLKENACP */
+		tmp = readl(tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+		tmp &= ~(BIT(16) | BIT(0));
+		writel(tmp, tp->mmio_sbxaddr + SC_WRAP_ACP_CRT_CTRL);
+
+		/* reg_0x9801c814[17] = 0 */
+		/* SBX spec, Switch ETN_ALL to DC_SYS path */
+		tmp = readl(tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+		tmp &= ~BIT(17);
+		writel(tmp, tp->mmio_sbxaddr + SBX_ACP_MISC_CTRL);
+
+		/* SBX spec, Remove mask ETN_ALL to SB3 DBUS REQ */
+		tmp = readl(tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_MASK);
+		tmp &= ~BIT(6);
+		writel(tmp, tp->mmio_sbxaddr + SBX_SB3_CHANNEL_REQ_MASK);
+
+		pr_info("ARM ACP off\n.");
+	}
+#endif
+}
+
+static void r8169soc_pll_clock_init(struct rtl8169_private *tp)
+{
+	u32 tmp;
+	struct clk *clk_etn_sys  = clk_get(&tp->pdev->dev, "etn_sys");
+	struct clk *clk_etn_250m = clk_get(&tp->pdev->dev, "etn_250m");
+	struct reset_control *rstc_gphy =
+		reset_control_get(&tp->pdev->dev, "gphy");
+	struct reset_control *rstc_gmac =
+		reset_control_get(&tp->pdev->dev, "gmac");
+
+	/* reg_0x98007004[27] = 1 */
+	/* ISO spec, ETN_PHY_INTR, clear ETN interrupt for ByPassMode */
+	writel(BIT(27), tp->mmio_clkaddr + ISO_UMSK_ISR);
+
+	/* reg_0x98007088[10] = 1 */
+	/* ISO spec, reset bit of fephy */
+	reset_control_deassert(rstc_gphy);
+
+	mdelay(1);	/* wait 1ms for PHY PLL stable */
+
+	/* reg_0x98007060[1] = 1 */
+	/* ISO spec, bypass mode enable */
+	tmp = readl(tp->mmio_clkaddr + ISO_ETN_TESTIO);
+	tmp |= BIT(1);
+	writel(tmp, tp->mmio_clkaddr + ISO_ETN_TESTIO);
+
+	/* reg_0x98007088[9] = 1 */
+	/* ISO spec, reset bit of gmac */
+	reset_control_deassert(rstc_gmac);
+
+	/* reg_0x9800708c[12:11] = 11 */
+	/* ISO spec, clock enable bit for etn clock & etn 250MHz */
+	clk_prepare_enable(clk_etn_sys);
+	clk_prepare_enable(clk_etn_250m);
+
+	mdelay(1);	/* wait 1ms for GMAC uC to be stable */
+
+	/* release resource */
+	reset_control_put(rstc_gphy);
+	reset_control_put(rstc_gmac);
+}
+
+#if !defined(RTK_FPGA)
+static void r8169soc_load_otp_content(struct rtl8169_private *tp)
+{
+	u32 otp;
+	u16 tmp;
+
+	/* enable 0x980174FC[4] */
+	/* R-K 0x980174FC[3:0] */
+	otp = readl(tp->mmio_otpaddr) & (0x1f << 0);
+	if (otp & BIT(4)) {
+		tmp = otp ^ R_K_DEFAULT;
+		r8169_mdio_write(tp, 31, 0xbc0);
+		r8169_mdio_write(tp, 20,
+			((r8169_mdio_read(tp, 20) & ~(0x1f << 0)) | tmp));
+	}
+
+	/* Amp-K 0x98017500[7:0] */
+	otp = readl(tp->mmio_otpaddr + 0x4) & (0xff << 0);
+	tmp = otp ^ IDAC_FINE_DEFAULT;
+	r8169_mdio_write(tp, 31, 0xbc0);
+	r8169_mdio_write(tp, 23,
+		((r8169_mdio_read(tp, 23) & ~(0xff << 0)) | tmp));
+}
+
+static void r8169soc_phy_iol_tuning(struct rtl8169_private *tp)
+{
+	u16 tmp;
+
+	switch (get_rtd_chip_revision()) {
+	case RTD_CHIP_A00:
+		/* rs_offset=rsw_offset=0xc */
+		tmp = 0xcc << 8;
+		r8169_mdio_write(tp, 31, 0xbc0);
+		r8169_mdio_write(tp, 20,
+			((r8169_mdio_read(tp, 20) & ~(0xff << 8)) | tmp));
+
+		/* 100M Tr/Tf */
+		/* reg_cf_l=0x3 */
+		tmp = 0x3 << 11;
+		r8169_mdio_write(tp, 31, 0xbd0);
+		r8169_mdio_write(tp, 17,
+			((r8169_mdio_read(tp, 17) & ~(0x7 << 11)) | tmp));
+
+		/* 100M Swing */
+		/* idac_fine_mdix, idac_fine_mdi */
+		tmp = 0x55 << 0;
+		r8169_mdio_write(tp, 31, 0xbc0);
+		r8169_mdio_write(tp, 23,
+			((r8169_mdio_read(tp, 23) & ~(0xff << 0)) | tmp));
+		break;
+	/* default:
+		do nothing */
+	}
+}
+
+static void r8169soc_phy_sram_table(struct rtl8169_private *tp)
+{
+#if 0
+	/* enable echo power*2 */
+	r8169_mdio_write(tp, 31, 0xa42);
+	r8169_mdio_write(tp, 22, 0x0f10);
+
+	/* Channel estimation, 100Mbps adjustment */
+	r8169_mdio_write(tp, 31, 0xa43);
+	r8169_mdio_write(tp, 27, 0x8087);	/* gain_i slope */
+	r8169_mdio_write(tp, 28, 0x42f0);	/* 0x43 => 0x42 */
+	r8169_mdio_write(tp, 27, 0x808e);	/* clen_i_c initial value */
+	r8169_mdio_write(tp, 28, 0x14a4);	/* 0x13 => 0x14 */
+	/* adc peak adjustment */
+	r8169_mdio_write(tp, 27, 0x8088);	/* aagc_lvl_c initial value 0x3f0 => ok */
+	r8169_mdio_write(tp, 28, 0xf0eb);	/* delta_a slope 0x1e => 0x1d */
+	/* cb0 adjustment */
+	r8169_mdio_write(tp, 27, 0x808c);	/* cb0_i_c initial value */
+	r8169_mdio_write(tp, 28, 0xef09);	/* 0x9ef => ok */
+	r8169_mdio_write(tp, 27, 0x808f);	/* delta_b slope */
+	r8169_mdio_write(tp, 28, 0xa4c6);	/* 0xa4 => ok */
+	/* DAGC adjustment */
+	r8169_mdio_write(tp, 27, 0x808a);	/* cg_i_c initial value */
+	r8169_mdio_write(tp, 28, 0x400a);	/* 0xb40 => 0xa40 */
+	r8169_mdio_write(tp, 27, 0x8092);	/* delta_g slope */
+	r8169_mdio_write(tp, 28, 0xc21e);	/* 0x0c0 => 0x0c2 */
+
+	/* 1000Mbps master adjustment */
+	/* line adjustment */
+	r8169_mdio_write(tp, 27, 0x8099);	/* gain_i slope */
+	r8169_mdio_write(tp, 28, 0x2ae0);	/* 0x2e => 0x2a */
+	r8169_mdio_write(tp, 27, 0x80a0);	/* clen_i_c initial value */
+	r8169_mdio_write(tp, 28, 0xf28f);	/* 0xfe => 0xf2 */
+	/* adc peak adjustment */
+	r8169_mdio_write(tp, 27, 0x809a);	/* aagc_lvl_c initial value 0x3e0 => 0x470 */
+	r8169_mdio_write(tp, 28, 0x7084);	/* delta_a slope 0x0d => 0x10 */
+	/* cb0 adjustment */
+	r8169_mdio_write(tp, 27, 0x809e);	/* cb0_i_c initial value */
+	r8169_mdio_write(tp, 28, 0xa008);	/* 0x7a1 => 0x8a0 */
+	r8169_mdio_write(tp, 27, 0x80a1);	/* delta_b slope */
+	r8169_mdio_write(tp, 28, 0x783d);	/* 0x8f => 0x78 */
+	/* DAGC adjustment */
+	r8169_mdio_write(tp, 27, 0x809c);	/* cg_i_c initial value */
+	r8169_mdio_write(tp, 28, 0x8008);	/* 0xb00 => 0x880 */
+	r8169_mdio_write(tp, 27, 0x80a4);	/* delta_g slope */
+	r8169_mdio_write(tp, 28, 0x580c);	/* 0x063 => 0x058 */
+
+	/* 1000Mbps slave adjustment */
+	/* line adjustment */
+	r8169_mdio_write(tp, 27, 0x80ab);	/* gain_i slope */
+	r8169_mdio_write(tp, 28, 0x2b4a);	/* 0x2e => 0x2b */
+	r8169_mdio_write(tp, 27, 0x80b2);	/* clen_i_c initial value */
+	r8169_mdio_write(tp, 28, 0xf47f);	/* 0xfa => 0xf4 */
+	/* adc peak adjustment */
+	r8169_mdio_write(tp, 27, 0x80ac);	/* aagc_lvl_c initial value 0x44a => 0x488 */
+	r8169_mdio_write(tp, 28, 0x8884);	/* delta_a slope 0x0e => 0x10 */
+	/* cb0 adjustment */
+	r8169_mdio_write(tp, 27, 0x80b0);	/* cb0_i_c initial value */
+	r8169_mdio_write(tp, 28, 0xa107);	/* 0x6a1 => 0x7a1 */
+	r8169_mdio_write(tp, 27, 0x80b3);	/* delta_b slope */
+	r8169_mdio_write(tp, 28, 0x683d);	/* 0x7f => 0x68 */
+	/* DAGC adjustment */
+	r8169_mdio_write(tp, 27, 0x80ae);	/* cg_i_c initial value */
+	r8169_mdio_write(tp, 28, 0x2006);	/* 0x760 => 0x620 */
+	r8169_mdio_write(tp, 27, 0x80b6);	/* delta_g slope */
+	r8169_mdio_write(tp, 28, 0x850c);	/* 0x090 => 0x085 */
+#endif
+}
+
+static void r8169soc_patch_phy_uc_code(struct rtl8169_private *tp)
+{
+#if 0
+	u32 tmp;
+
+	/* patch for GPHY uC firmware, adjust 1000M EEE lpi_waketx_timer = 1.3uS */
+	#define PATCH_KEY_ADDR  0x8028   // for RL6525
+	#define PATCH_KEY       0x5600   // for RL6525
+
+	/* Patch request & wait for the asserting of patch_rdy */
+	r8169_mdio_write(tp, 31, 0xb82);
+	r8169_mdio_write(tp, 16, r8169_mdio_read(tp, 16) | (BIT(4)));
+
+	tmp = 0;
+	r8169_mdio_write(tp, 31, 0xb80);
+	while ((r8169_mdio_read(tp, 16) & BIT(6)) == 0) {
+		tmp += 10;
+		mdelay(10);
+		if (tmp >= 100) {
+			pr_err("GPHY patch_rdy timeout.\n");
+			break;
+		}
+	}
+	pr_err("wait %d ms for GPHY patch_rdy. reg = 0x%x\n",
+		tmp, r8169_mdio_read(tp, 16));
+	pr_err("patch_rdy is asserted!!\n");
+
+	/* Set patch_key & patch_lock */
+	r8169_mdio_write(tp, 31, 0);
+	r8169_mdio_write(tp, 27, PATCH_KEY_ADDR);
+	r8169_mdio_write(tp, 28, PATCH_KEY);
+	r8169_mdio_write(tp, 27, PATCH_KEY_ADDR);
+	pr_err("check patch key = %04x\n", r8169_mdio_read(tp, 28));
+	r8169_mdio_write(tp, 27, 0xb82e);
+	r8169_mdio_write(tp, 28, 0x0001);
+
+	/* uC patch code, released by Digital Designer */
+	r8169_mdio_write(tp, 0x1f, 0x0000);
+	r8169_mdio_write(tp, 27, 0xb820);
+	r8169_mdio_write(tp, 28, 0x0290);
+
+	r8169_mdio_write(tp, 27, 0xa012);
+	r8169_mdio_write(tp, 28, 0x0000);
+
+	r8169_mdio_write(tp, 27, 0xa014);
+	r8169_mdio_write(tp, 28, 0x2c04);
+	r8169_mdio_write(tp, 28, 0x2c06);
+	r8169_mdio_write(tp, 28, 0x2c09);
+	r8169_mdio_write(tp, 28, 0x2c0c);
+	r8169_mdio_write(tp, 28, 0xd093);
+	r8169_mdio_write(tp, 28, 0x2265);
+	r8169_mdio_write(tp, 28, 0x9e20);
+	r8169_mdio_write(tp, 28, 0xd703);
+	r8169_mdio_write(tp, 28, 0x2502);
+	r8169_mdio_write(tp, 28, 0x9e40);
+	r8169_mdio_write(tp, 28, 0xd700);
+	r8169_mdio_write(tp, 28, 0x0800);
+	r8169_mdio_write(tp, 28, 0x9e80);
+	r8169_mdio_write(tp, 28, 0xd70d);
+	r8169_mdio_write(tp, 28, 0x202e);
+
+	r8169_mdio_write(tp, 27, 0xa01a);
+	r8169_mdio_write(tp, 28, 0x0000);
+
+	r8169_mdio_write(tp, 27, 0xa006);
+	r8169_mdio_write(tp, 28, 0x002d);
+
+	r8169_mdio_write(tp, 27, 0xa004);
+	r8169_mdio_write(tp, 28, 0x0507);
+
+	r8169_mdio_write(tp, 27, 0xa002);
+	r8169_mdio_write(tp, 28, 0x0501);
+
+	r8169_mdio_write(tp, 27, 0xa000);
+	r8169_mdio_write(tp, 28, 0x1264);
+
+	r8169_mdio_write(tp, 27, 0xb820);
+	r8169_mdio_write(tp, 28, 0x0210);
+
+	r8169_mdio_write(tp, 31, 0);
+
+	mdelay(10);
+
+	/* Clear patch_key & patch_lock */
+	r8169_mdio_write(tp, 27, PATCH_KEY_ADDR);
+	r8169_mdio_write(tp, 28, 0);
+	r8169_mdio_write(tp, 31, 0xb82);
+	r8169_mdio_write(tp, 23, 0);
+
+	/* Release patch request & wait for the deasserting of patch_rdy. */
+	r8169_mdio_write(tp, 31, 0xb82);
+	r8169_mdio_write(tp, 16, r8169_mdio_read(tp, 16) & ~(BIT(4)));
+
+	tmp = 0;
+	r8169_mdio_write(tp, 31, 0xb80);
+	while ((r8169_mdio_read(tp, 16) & BIT(6)) != 0) {
+		tmp += 10;
+		mdelay(10);
+		if (tmp >= 100) {
+			pr_err("GPHY patch_rdy timeout.\n");
+			break;
+		}
+	}
+	pr_err("wait %d ms for GPHY patch_rdy. reg = 0x%x\n",
+		tmp, r8169_mdio_read(tp, 16));
+
+	pr_err("\npatch_rdy is de-asserted!!\n");
+	pr_err("GPHY uC code patched.\n");
+#endif
+}
+#endif /* !RTK_FPGA */
+
+#if defined(RTK_FPGA)
+/* For FPGA w/o embedded PHY */
+static void r8169soc_mdio_init(struct rtl8169_private *tp)
+{
+	u32 tmp;
+	#if 0
+	struct pinctrl *p_rgmii_mdio;
+	struct pinctrl_state * ps_rgmii_mdio;
+	#endif
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* wait GMAC registers ready */
+	tmp = 0;
+	while (RTL_R8(MAC0) != 0x0) {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 100) {
+			pr_err("GMAC init timeout.\n");
+			break;
+		}
+	}
+	pr_info("wait %d ms for GMAC registers ready. MAC0 = 0x%x\n",
+		tmp, RTL_R8(MAC0));
+
+	/* init_autoload_done = 1 */
+	tmp = r8169soc_ocp_reg_read(tp, 0xe004);
+	tmp |= BIT(7);
+	r8169soc_ocp_reg_write(tp, 0xe004, tmp);
+
+	/* ee_mode = 3 */
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	/* Interface Config : RGMII */
+	switch (tp->output_mode) {
+	case OUTPUT_RGMII_TO_PHY:
+		/* ISO mux spec, GPIO15 is set to MDC pin */
+		/* ISO mux spec, GPIO14 is set to MDIO pin */
+		/* ISO mux spec, GPIO65~76 is set to TX/RX pin */
+		#if 0
+		p_rgmii_mdio = devm_pinctrl_get(&tp->pdev->dev);
+		ps_rgmii_mdio = pinctrl_lookup_state(p_rgmii_mdio, "rgmii");
+		pinctrl_select_state(p_rgmii_mdio, ps_rgmii_mdio);
+		#else
+		tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD2);
+		tmp &= ~((0x7 << 7) | (0x7 << 4));
+		tmp |= (0x4 << 7) | (0x4 << 4);
+		writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD2);
+
+		tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD5);
+		tmp &= ~((0x7 << 27) | (0x7 << 24) | (0x7 << 21) | (0x7 << 18) | (0x1 << 17));
+		tmp |= (0x1 << 27) | (0x1 << 24) | (0x1 << 21) | (0x1 << 18) | (0x1 << 17);
+		writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD5);
+
+		tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD6);
+		tmp &= ~((0x3 << 17) | (0x3 << 15) | (0x7 << 12) | (0x7 << 9) | (0x7 << 6) | (0x7 << 3) | (0x7 << 0));
+		tmp |= (0x1 << 17) | (0x1 << 15) | (0x1 << 12) | (0x1 << 9) | (0x1 << 6) | (0x1 << 3) | (0x1 << 0);
+		writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_MUXPAD6);
+		#endif
+
+		/* FPGA is fixed to 1.8V, DP=100, DN=100 */
+		writel((0x4 << 3) | (0x4 << 0),
+			(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC25));
+
+		/* no Schmitt_Trigger */
+		/* MODE2=0, MODE=0, SR=0, smt=0, pudsel=0, puden=0, E2=1 */
+		writel((readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC20) &
+			~((0xf << 24) | (0xf << 20) | (0x1f << 16) | (0x1f << 12) | (0x1f << 8) | (0x1f << 4))) |
+			 ((0x1 << 24) | (0x1 << 20) | (0x1 << 16) | (0x1 << 12) | (0x1 << 8) | (0x1 << 4)),
+			(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC20));
+		writel((readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC21) &
+			~((0x3 << 30) | (0x1f << 25) | (0x1f << 20) | (0x1f << 15) | (0x1f << 10) | (0x1f << 5) | (0x1f << 0))) |
+			 ((0x0 << 30) | (0x1 << 25) | (0x1 << 20) | (0x1 << 15) | (0x1 << 10) | (0x1 << 5) | (0x1 << 0)),
+			(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC21));
+
+		/* check if external PHY is available */
+		pr_info("Searching external PHY...");
+		MDIO_LOCK;
+		tp->ext_phy = true;
+		r8169_mdio_write(tp, 31, 0x0a43);
+		tmp = 0;
+		while (0xa43 != r8169_mdio_read(tp, 31)) {
+			pr_cont(".");
+			tmp += 1;
+			mdelay(1);
+			if (tmp >= 2000) {
+				pr_err("\n External RGMII PHY not found, current = 0x%02x\n",
+					r8169_mdio_read(tp, 31));
+				return;
+			}
+		}
+		if (tmp < 2000)
+			pr_cont("found.\n");
+
+		/* set RGMII RX delay = 0 */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea36) & ~(BIT(0)); /* rg_clk_en */
+		r8169soc_ocp_reg_write(tp, 0xea36, tmp);
+
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(14) | BIT(9)| BIT(8) | BIT(6));
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+		/* external PHY RGMII timing tuning, rg_rgmii_id_mode = 1 (default) */
+		r8169_mdio_write(tp, 31, 0x0d08);
+		r8169_mdio_write(tp, 21,
+			(r8169_mdio_read(tp, 21) | BIT(3)));
+
+		/* set RGMII TX delay = 0 */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(7));
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+		/* external PHY RGMII timing tuning, tx_dly_mode = 1 */
+		r8169_mdio_write(tp, 31, 0x0d08);
+		r8169_mdio_write(tp, 17,
+			(r8169_mdio_read(tp, 17) | BIT(8)));
+
+		/* ISO spec, data path is set to RGMII */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea30) & ~(BIT(0));
+		r8169soc_ocp_reg_write(tp, 0xea30, tmp);
+
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(0) | BIT(1));
+		tmp |= BIT(0); /* RGMII */
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+		//tp->ext_phy = false;
+		MDIO_UNLOCK;
+
+		/* ext_phy == true now */
+
+		break;
+	default:
+		pr_err("%s:%d: unsupported output mode (%d) in FPGA\n", __func__, __LINE__, tp->output_mode);
+	}
+}
+
+#else
+static void r8169soc_mdio_init(struct rtl8169_private *tp)
+{
+	u32 tmp;
+	struct pinctrl *p_rgmii_mdio;
+	struct pinctrl_state * ps_rgmii_mdio;
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* ISO spec, ETN_PHY_INTR, wait interrupt from PHY and it means MDIO is ready */
+	tmp = 0;
+	while ((readl(tp->mmio_clkaddr + ISO_UMSK_ISR) & BIT(27)) == 0) {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 100) {
+			pr_err("PHY PHY_Status timeout.\n");
+			break;
+		}
+	}
+	pr_info("wait %d ms for PHY interrupt. UMSK_ISR = 0x%x\n",
+		tmp, readl(tp->mmio_clkaddr + ISO_UMSK_ISR));
+
+	MDIO_LOCK;
+	/* In ByPass mode,
+	   SW need to handle the EPHY Status check ,
+	   OTP data update and EPHY fuse_rdy setting. */
+	/* PHY will stay in state 1 mode */
+	r8169_mdio_write(tp, 31, 0x0a42);
+	tmp = 0;
+	while (0x1 != (r8169_mdio_read(tp, 16) & 0x07)) {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 2000) {
+			pr_err("PHY status is not 0x1 in bypass mode, current = 0x%02x\n",
+				(r8169_mdio_read(tp, 16) & 0x07));
+			break;
+		}
+	}
+
+	/* fix A00 known issue */
+	if (get_rtd_chip_revision() == RTD_CHIP_A00) {
+		/* fix AFE RX power as 1 */
+		r8169_mdio_write(tp, 31, 0x0bd0);
+		r8169_mdio_write(tp, 21, 0x7201);
+	}
+
+	/* ETN spec. set MDC freq = 8.9MHZ */
+	tmp = r8169soc_ocp_reg_read(tp, 0xde10) & ~(BIT(7) | BIT(6));
+	tmp |= BIT(6); /* MDC freq = 8.9MHz */
+	r8169soc_ocp_reg_write(tp, 0xde10, tmp);
+
+	/* fill fuse_rdy & rg_ext_ini_done */
+	r8169_mdio_write(tp, 31, 0x0a46);
+	r8169_mdio_write(tp, 20,
+		(r8169_mdio_read(tp, 20) | (BIT(1) | BIT(0))));
+
+	/* init_autoload_done = 1 */
+	tmp = r8169soc_ocp_reg_read(tp, 0xe004);
+	tmp |= BIT(7);
+	r8169soc_ocp_reg_write(tp, 0xe004, tmp);
+
+	/* ee_mode = 3 */
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	/* wait LAN-ON */
+	r8169_mdio_write(tp, 31, 0x0a42);
+	tmp = 0;
+	do {
+		tmp += 1;
+		mdelay(1);
+		if (tmp >= 2000) {
+			pr_err("PHY status is not 0x3, current = 0x%02x\n",
+				(r8169_mdio_read(tp, 16) & 0x07));
+			break;
+		}
+	} while (0x3 != (r8169_mdio_read(tp, 16) & 0x07));
+	pr_info("wait %d ms for PHY ready, current = 0x%x\n",
+		tmp, r8169_mdio_read(tp, 16));
+
+	/* adjust PHY SRAM table */
+	r8169soc_phy_sram_table(tp);
+
+	/* PHY patch code */
+	r8169soc_patch_phy_uc_code(tp);
+
+	/* adjust PHY electrical characteristics */
+	r8169soc_phy_iol_tuning(tp);
+
+	/* load OTP contents (R-K, Amp)
+	   R-K:		0x980174FC[4:0]
+	   Amp:		0x98017500[7:0]
+	 */
+	r8169soc_load_otp_content(tp);
+
+	MDIO_UNLOCK;
+
+	switch (tp->output_mode) {
+	case OUTPUT_EMBEDDED_PHY:
+		/* ISO spec, set data path to FEPHY */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea30);
+		tmp &= ~(BIT(0));
+		r8169soc_ocp_reg_write(tp, 0xea30, tmp);
+
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34);
+		tmp &= ~(BIT(1) | BIT(0));
+		tmp |= BIT(1);  /* FEPHY */
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+		/* LED high active circuit */
+		/* output current: 4mA */
+		tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC9);
+		tmp &= ~(0xff << 16);
+		writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC9);
+		break;
+	case OUTPUT_RGMII_TO_MAC:
+		pr_err("%s:%d: FIXME! PHY_TYPE_RGMII_MAC\n", __func__, __LINE__);
+		break;
+	case OUTPUT_RMII:
+		pr_err("%s:%d: FIXME! PHY_TYPE_RMII\n", __func__, __LINE__);
+		break;
+	case OUTPUT_RGMII_TO_PHY:
+		/* ISO mux spec, GPIO15 is set to MDC pin */
+		/* ISO mux spec, GPIO14 is set to MDIO pin */
+		/* ISO mux spec, GPIO65~76 is set to TX/RX pin */
+		p_rgmii_mdio = devm_pinctrl_get(&tp->pdev->dev);
+		ps_rgmii_mdio = pinctrl_lookup_state(p_rgmii_mdio, "rgmii");
+		pinctrl_select_state(p_rgmii_mdio, ps_rgmii_mdio);
+
+		/* fixed to 1.8V, DP=100, DN=100 */
+		tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC25);
+		tmp &= ~((0x7 << 3) | (0x7 << 0));
+		tmp |= (0x4 << 3) | (0x4 << 0);
+		writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC25);
+
+		/* no Schmitt_Trigger */
+		switch (tp->voltage) {
+		case 3: /* 3.3v */
+			/* MODE2=1, MODE=0, SR=1, smt=0, pudsel=0, puden=0, E2=0 */
+			tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC20);
+			tmp &= ~((0xf << 24) | (0xf << 20) | (0x1f << 16) | (0x1f << 12) | (0x1f << 8) | (0x1f << 4));
+			tmp |= (0x0 << 24) | (0x0 << 20) | (0x0 << 16) | (0x0 << 12) | (0x0 << 8) | (0x0 << 4);
+			writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC20);
+
+			tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC21);
+			tmp &= ~((0x3 << 30) | (0x1f << 25) | (0x1f << 20) | (0x1f << 15) | (0x1f << 10) | (0x1f << 5) | (0x1f << 0));
+			tmp |= (0x2 << 30) | (0x10 << 25) | (0x10 << 20) | (0x10 << 15) | (0x10 << 10) | (0x10 << 5) | (0x10 << 0);
+			writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC21);
+			break;
+		case 2: /* 2.5v */
+			/* MODE2=0, MODE=1, SR=0, smt=0, pudsel=0, puden=0, E2=1 */
+			tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC20);
+			tmp &= ~((0xf << 24) | (0xf << 20) | (0x1f << 16) | (0x1f << 12) | (0x1f << 8) | (0x1f << 4));
+			tmp |= (0x1 << 24) | (0x1 << 20) | (0x1 << 16) | (0x1 << 12) | (0x1 << 8) | (0x1 << 4);
+			writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC20);
+
+			tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC21);
+			tmp &= ~((0x3 << 30) | (0x1f << 25) | (0x1f << 20) | (0x1f << 15) | (0x1f << 10) | (0x1f << 5) | (0x1f << 0));
+			tmp |= (0x1 << 30) | (0x1 << 25) | (0x1 << 20) | (0x1 << 15) | (0x1 << 10) | (0x1 << 5) | (0x1 << 0);
+			writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC21);
+			break;
+		case 1: /* 1.8v */
+		default :
+			/* MODE2=0, MODE=0, SR=0, smt=0, pudsel=0, puden=0, E2=1 */
+			tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC20);
+			tmp &= ~((0xf << 24) | (0xf << 20) | (0x1f << 16) | (0x1f << 12) | (0x1f << 8) | (0x1f << 4));
+			tmp |= (0x1 << 24) | (0x1 << 20) | (0x1 << 16) | (0x1 << 12) | (0x1 << 8) | (0x1 << 4);
+			writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC20);
+
+			tmp = readl(tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC21);
+			tmp &= ~((0x3 << 30) | (0x1f << 25) | (0x1f << 20) | (0x1f << 15) | (0x1f << 10) | (0x1f << 5) | (0x1f << 0));
+			tmp |= (0x0 << 30) | (0x1 << 25) | (0x1 << 20) | (0x1 << 15) | (0x1 << 10) | (0x1 << 5) | (0x1 << 0);
+			writel(tmp, tp->mmio_pinmuxaddr + ISO_TESTMUX_PFUNC21);
+		}
+
+		/* check if external PHY is available */
+		pr_info("Searching external PHY...");
+		MDIO_LOCK;
+		tp->ext_phy = true;
+		r8169_mdio_write(tp, 31, 0x0a43);
+		tmp = 0;
+		while (0xa43 != r8169_mdio_read(tp, 31)) {
+			pr_cont(".");
+			tmp += 1;
+			mdelay(1);
+			if (tmp >= 2000) {
+				pr_err("\n External RGMII PHY not found, current = 0x%02x\n",
+					r8169_mdio_read(tp, 31));
+				return;
+			}
+		}
+		if (tmp < 2000)
+			pr_cont("found.\n");
+
+		/* set RGMII RX delay */
+		//FIXME! todo: rxc_type = addll
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(14) | BIT(9)| BIT(8) | BIT(6));
+		switch (tp->rx_delay) {
+		case 1:
+			tmp |= (0x0 << 6) | (0x1 << 8);
+			break;
+		case 2:
+			tmp |= (0x0 << 6) | (0x2 << 8);
+			break;
+		case 3:
+			tmp |= (0x0 << 6) | (0x3 << 8);
+			break;
+		case 4:
+			tmp |= (0x1 << 6) | (0x0 << 8);
+			break;
+		case 5:
+			tmp |= (0x1 << 6) | (0x1 << 8);
+			break;
+		case 6:
+			tmp |= (0x1 << 6) | (0x2 << 8);
+			break;
+		case 7:
+			tmp |= (0x1 << 6) | (0x3 << 8);
+		}
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+		tmp = r8169soc_ocp_reg_read(tp, 0xea36) & ~(BIT(0)); /* rg_clk_en */
+		r8169soc_ocp_reg_write(tp, 0xea36, tmp);
+
+		/* external PHY RGMII timing tuning, rg_rgmii_id_mode = 1 (default) */
+		r8169_mdio_write(tp, 31, 0x0d08);
+		tmp = r8169_mdio_read(tp, 21);
+		switch (tp->rx_delay) {
+		case 0:
+		case 1:
+		case 2:
+		case 3:
+			tmp |= BIT(3);
+			break;
+		case 4:
+		case 5:
+		case 6:
+		case 7:
+			tmp &= ~BIT(3);
+		}
+		r8169_mdio_write(tp, 21, tmp);
+
+		/* set RGMII TX delay */
+		if (tp->tx_delay == 0) {
+			tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(7));
+			r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+			/* external PHY RGMII timing tuning, tx_dly_mode = 1 */
+			r8169_mdio_write(tp, 31, 0x0d08);
+			r8169_mdio_write(tp, 17,
+				(r8169_mdio_read(tp, 17) | BIT(8)));
+		} else {	/* tp->tx_delay == 1 (2ns) */
+			tmp = r8169soc_ocp_reg_read(tp, 0xea34) | (BIT(7));
+			r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+			/* external PHY RGMII timing tuning, tx_dly_mode = 0 */
+			r8169_mdio_write(tp, 31, 0x0d08);
+			r8169_mdio_write(tp, 17,
+				(r8169_mdio_read(tp, 17) & ~BIT(8)));
+		}
+
+		/* ISO spec, data path is set to RGMII */
+		tmp = r8169soc_ocp_reg_read(tp, 0xea30) & ~(BIT(0));
+		r8169soc_ocp_reg_write(tp, 0xea30, tmp);
+
+		tmp = r8169soc_ocp_reg_read(tp, 0xea34) & ~(BIT(0) | BIT(1));
+		tmp |= BIT(0); /* RGMII */
+		r8169soc_ocp_reg_write(tp, 0xea34, tmp);
+
+		//tp->ext_phy = false;
+		MDIO_UNLOCK;
+
+		/* ext_phy == true now */
+
+		break;
+	default:
+		pr_err("%s:%d: unsupport output mode (%d) in FPGA\n", __func__, __LINE__, tp->output_mode);
+	}
+}
+#endif /* RTK_FPGA */
+
+static void r8169soc_eee_init(struct rtl8169_private *tp, bool enable)
+{
+	if (enable) {
+		MDIO_LOCK;
+		if (tp->output_mode == OUTPUT_EMBEDDED_PHY) {
+			/* 1000M/100M EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, (BIT(2) | BIT(1)));
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) | (BIT(4) | BIT(2)));
+			/* disable dynamic RX power in PHY */
+			r8169_mdio_write(tp, 31, 0xbd0);
+			r8169_mdio_write(tp, 21, (r8169_mdio_read(tp, 21) & ~BIT(8)) | BIT(9));
+		} else { /* SGMII */
+			/* 1000M & 100M EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, (BIT(2) | BIT(1)));
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) | (BIT(4) | BIT(2)));
+		}
+		MDIO_UNLOCK;
+		/* EEE MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) | (BIT(1) | BIT(0))));
+		/* EEE+ MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) | BIT(1)));
+	} else {
+		if (tp->output_mode == OUTPUT_EMBEDDED_PHY) {
+			/* no EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, 0);
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) & ~(BIT(4) | BIT(2)));
+		} else { /* SGMII */
+			/* no EEE capability */
+			r8169_mmd_write(tp, 0x7, 60, 0);
+			/* 10M EEE */
+			r8169_mdio_write(tp, 31, 0xa43);
+			r8169_mdio_write(tp, 25, r8169_mdio_read(tp, 25) & ~(BIT(4) | BIT(2)));
+		}
+		MDIO_UNLOCK;
+		/* reset to default value */
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) | BIT(13)));
+		/* EEE MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe040, (r8169soc_ocp_reg_read(tp, 0xe040) & ~(BIT(1) | BIT(0))));
+		/* EEE+ MAC mode */
+		r8169soc_ocp_reg_write(tp, 0xe080, (r8169soc_ocp_reg_read(tp, 0xe080) & ~BIT(1)));
+	}
+}
+#endif /* CONFIG_ARCH_RTD13xx */
+
+static int
+rtl_init_one(struct platform_device *pdev)
+{
+	struct rtl_cfg_info *cfg;
+	struct rtl8169_private *tp;
+	struct mii_if_info *mii;
+	struct net_device *ndev;
+	void __iomem *ioaddr;
+	void __iomem *clkaddr;
+	int chipset, i;
+	int rc;
+	int rtl_config;
+	int mac_version;
+	int led_config;
+	u32 tmp;
+	int irq;
+	int retry;
+	const char *mac_addr;
+	struct property *wake_mask;
+	char tmp_str[80];
+	struct device_node *phy_0;
+	int phy_irq[POR_NUM] = {0, 0, 0};
+#ifdef RTL_PROC
+	struct proc_dir_entry *dir_dev = NULL;
+	struct proc_dir_entry *entry=NULL;
+#endif
+	#if defined(CONFIG_ARCH_RTD129x)
+	struct clk *clk_etn_sys  = clk_get(&pdev->dev, "etn_sys");
+	struct clk *clk_etn_250m = clk_get(&pdev->dev, "etn_250m");
+	struct reset_control *rstc_gphy = reset_control_get(&pdev->dev, "gphy");
+	struct reset_control *rstc_gmac = reset_control_get(&pdev->dev, "gmac");
+	u32 rgmii_voltage = 1;
+	u32 rgmii_tx_delay = 0;
+	u32 rgmii_rx_delay = 0;
+	#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	void __iomem *sbxaddr;
+	void __iomem *otpaddr;
+	void __iomem *sdsaddr;
+	void __iomem *pinmuxaddr;
+	u32 bypass_enable = 0;
+	u32 acp_enable = 0;
+	#if defined(CONFIG_ARCH_RTD16xx)
+	u32 sgmii_swing = 0;
+	#endif /* CONFIG_ARCH_RTD16xx */
+	#elif defined(CONFIG_ARCH_RTD13xx)
+	void __iomem *sbxaddr;
+	void __iomem *otpaddr;
+	void __iomem *pinmuxaddr;
+	u32 bypass_enable = 0;
+	u32 acp_enable = 0;
+	u32 voltage = 1;
+	u32 tx_delay = 0;
+	u32 rx_delay = 0;
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x |
+		  CONFIG_ARCH_RTD16xx | CONFIG_ARCH_RTD13xx */
+	u32 output_mode = 0;
+	u32 ext_phy_id = 1;
+	u32 eee_enable = 0;
+
+	if (netif_msg_drv(&debug)) {
+		printk(KERN_INFO "%s Gigabit Ethernet driver %s loaded\n",
+			   MODULENAME, RTL8169_VERSION);
+	}
+
+#if 1	//barry
+	if (of_property_read_u32(pdev->dev.of_node, "rtl-config", &rtl_config)) {
+		dprintk("%s canot specified config", __func__);
+	}
+	cfg = rtl_cfg_infos + rtl_config;
+	if (of_property_read_u32(pdev->dev.of_node, "mac-version", &mac_version)) {
+		dprintk("%s canot specified config", __func__);
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "led-cfg", &led_config)) {
+		led_config = 0;
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "output-mode", &output_mode)) {
+		dprintk("%s can't get output mode", __func__);
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "ext-phy-id", &ext_phy_id)) {
+		dprintk("%s can't get RGMII external PHY ID", __func__);
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "eee", &eee_enable)) {
+		dprintk("%s can't get eee_enable", __func__);
+	}
+
+	#if defined(CONFIG_ARCH_RTD129x)
+	if (of_property_read_u32(pdev->dev.of_node, "rgmii-voltage", &rgmii_voltage)) {
+		dprintk("%s can't get RGMII voltage", __func__);
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "rgmii-tx-delay", &rgmii_tx_delay)) {
+		dprintk("%s can't get RGMII TX delay", __func__);
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "rgmii-rx-delay", &rgmii_rx_delay)) {
+		dprintk("%s can't get RGMII RX delay", __func__);
+	}
+	#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	if (of_property_read_u32(pdev->dev.of_node, "bypass", &bypass_enable)) {
+		dprintk("%s can't get bypass", __func__);
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "acp", &acp_enable)) {
+		dprintk("%s can't get acp", __func__);
+	}
+	#if defined(CONFIG_ARCH_RTD16xx)
+	if (of_property_read_u32(pdev->dev.of_node, "sgmii-swing", &sgmii_swing)) {
+		dprintk("%s can't get sgmii-swing", __func__);
+	}
+	#endif /* CONFIG_ARCH_RTD16xx */
+
+	sbxaddr = of_iomap(pdev->dev.of_node, 2);
+	otpaddr = of_iomap(pdev->dev.of_node, 3);
+	sdsaddr = of_iomap(pdev->dev.of_node, 4);
+	pinmuxaddr = of_iomap(pdev->dev.of_node, 5);
+
+	#elif defined(CONFIG_ARCH_RTD13xx)
+	if (of_property_read_u32(pdev->dev.of_node, "voltage", &voltage)) {
+		dprintk("%s can't get voltage", __func__);
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "tx-delay", &tx_delay)) {
+		dprintk("%s can't get TX delay", __func__);
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "rx-delay", &rx_delay)) {
+		dprintk("%s can't get RX delay", __func__);
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "bypass", &bypass_enable)) {
+		dprintk("%s can't get bypass", __func__);
+	}
+	if (of_property_read_u32(pdev->dev.of_node, "acp", &acp_enable)) {
+		dprintk("%s can't get acp", __func__);
+	}
+
+	sbxaddr = of_iomap(pdev->dev.of_node, 2);
+	otpaddr = of_iomap(pdev->dev.of_node, 3);
+	pinmuxaddr = of_iomap(pdev->dev.of_node, 4);
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x |
+		  CONFIG_ARCH_RTD16xx | CONFIG_ARCH_RTD13xx */
+
+	if (soc_is_rtk1195() && (realtek_rev() == RTK1195_REV_A)) {
+		if (of_property_read_u32(pdev->dev.of_node, "rtl-features", &(cfg->features))) {
+			cfg->features &= ~RTL_FEATURE_GMII;
+		}
+	}
+	if (of_get_property(pdev->dev.of_node, "force-Gb-off", NULL)) {
+		pr_info("~~~ disable Gb features~~~\n");
+		cfg->features &= ~RTL_FEATURE_GMII;
+	}
+
+	phy_0 = of_get_child_by_name(pdev->dev.of_node, "phy_0");
+	if (phy_0) {
+		for (i = 0; i < POR_NUM; i++)
+			phy_irq[i] = irq_of_parse_and_map(phy_0, i);
+		pr_err("get phy_irq from device tree: %d, %d, %d\n",
+			phy_irq[0], phy_irq[1], phy_irq[2]);
+	} else {
+		pr_err("could not find [phy_0] sub-node\n");
+	}
+
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (!pdev->dev.dma_mask)
+		pdev->dev.dma_mask = &pdev->dev.coherent_dma_mask;
+	if (!pdev->dev.coherent_dma_mask)
+		pdev->dev.coherent_dma_mask = DMA_BIT_MASK(32);
+
+	ioaddr = of_iomap(pdev->dev.of_node, 0);
+
+
+	clkaddr = of_iomap(pdev->dev.of_node, 1);
+
+	ndev = alloc_etherdev(sizeof (*tp));
+	if (!ndev) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	SET_NETDEV_DEV(ndev, &pdev->dev);
+	ndev->netdev_ops = &rtl_netdev_ops;
+	ndev->irq = irq;
+	tp = netdev_priv(ndev);
+	tp->dev = ndev;
+	tp->pdev = pdev;
+	tp->msg_enable = netif_msg_init(debug.msg_enable, R8169_MSG_DEFAULT);
+	tp->mac_version = mac_version - 1;
+	tp->mmio_addr = ioaddr;
+	tp->mmio_clkaddr = clkaddr;
+	tp->led_cfg = led_config;
+	tp->output_mode = output_mode;
+	tp->ext_phy_id = ext_phy_id;
+	tp->eee_enable = !!(eee_enable > 0);
+	for (i =0; i < POR_NUM; i++)
+		tp->phy_irq[i] = phy_irq[i];
+	atomic_set(&tp->phy_reinit_flag, 0);
+
+	#if defined(CONFIG_ARCH_RTD129x)
+	tp->rgmii_voltage = rgmii_voltage;
+	tp->rgmii_tx_delay = rgmii_tx_delay;
+	tp->rgmii_rx_delay = rgmii_rx_delay;
+	tp->acp_enable = false;
+	#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	tp->mmio_sbxaddr = sbxaddr;
+	tp->mmio_otpaddr = otpaddr;
+	tp->mmio_sdsaddr = sdsaddr;
+	tp->mmio_pinmuxaddr = pinmuxaddr;
+	tp->bypass_enable = !!(bypass_enable > 0);
+	tp->acp_enable = !!(acp_enable > 0);
+	tp->ext_phy = false;
+	#if defined(CONFIG_ARCH_RTD16xx)
+	tp->sgmii_swing = sgmii_swing;
+	#endif /* CONFIG_ARCH_RTD16xx */
+	#elif defined(CONFIG_ARCH_RTD13xx)
+	tp->mmio_sbxaddr = sbxaddr;
+	tp->mmio_otpaddr = otpaddr;
+	tp->mmio_pinmuxaddr = pinmuxaddr;
+	tp->bypass_enable = !!(bypass_enable > 0);
+	tp->acp_enable = !!(acp_enable > 0);
+	tp->ext_phy = false;
+	tp->voltage = voltage;
+	tp->tx_delay = tx_delay;
+	tp->rx_delay = rx_delay;
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x |
+		  CONFIG_ARCH_RTD16xx | CONFIG_ARCH_RTD13xx */
+
+	mii = &tp->mii;
+	mii->dev = ndev;
+	mii->mdio_read = rtl_mdio_read;
+	mii->mdio_write = rtl_mdio_write;
+	mii->phy_id_mask = 0x1f;
+	mii->reg_num_mask = 0x1f;
+	mii->supports_gmii = !!(cfg->features & RTL_FEATURE_GMII);
+
+//#define ETN_GPHY_BYPASS 0x98007060
+//#define ETN_RESET_CTRL  0x98007088
+//#define ETN_CLK_CTRL    0x9800708c
+//#define ETN_DBUS_CLK    0x98007fc0
+
+	#if defined(CONFIG_ARCH_RTD129x)
+	if (unlikely(!__clk_is_enabled(clk_etn_sys) || !__clk_is_enabled(clk_etn_250m))) {
+		//1. reg_0x98007088[10] = 1                    // ISO spec, reset bit of gphy
+		reset_control_deassert(rstc_gphy);
+
+		//2. CPU software waiting 200uS
+		udelay(200);
+
+		//3. reg_0x98007060[1] = 0                      // ISO spec, Ethernet Boot up bypass gphy ready mode
+		tmp = readl(clkaddr+0x60);
+		tmp &= ~BIT(1);
+		writel(tmp,clkaddr+0x60);
+
+		//4. reg_0x98007fc0[0] = 0                      // ISO spec, Ethernet Boot up disable dbus clock gating
+		tmp = readl(clkaddr+0xfc0);
+		tmp &= ~BIT(0);
+		writel(tmp,clkaddr+0xfc0);
+
+		//5. CPU software waiting 200uS
+		udelay(200);
+
+		//6. reg_0x9800708c[12:11] = 11              // ISO spec, clock enable bit for etn clock & etn 250MHz
+		clk_prepare_enable(clk_etn_sys);
+		clk_prepare_enable(clk_etn_250m);
+
+		//7. reg_0x9800708c[12:11] = 00              // ISO spec, clock enable bit for etn clock & etn 250MHz
+		clk_disable_unprepare(clk_etn_sys);
+		clk_disable_unprepare(clk_etn_250m);
+
+		//8. reg_0x98007088[9] = 1                      // ISO spec, reset bit of gmac
+		reset_control_deassert(rstc_gmac);
+
+		//9. reg_0x9800708c[12:11] = 11              // ISO spec, clock enable bit for etn clock & etn 250MHz
+		clk_prepare_enable(clk_etn_sys);
+		clk_prepare_enable(clk_etn_250m);
+
+		msleep(100);
+	}
+	#elif defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+	r8169soc_reset_phy_gmac(tp);
+	r8169soc_acp_init(tp);
+	r8169soc_pll_clock_init(tp);
+	r8169soc_mdio_init(tp);
+	/* after r8169soc_mdio_init(),
+	   SGMII : tp->ext_phy == true  ==> external MDIO,
+	   FE PHY: tp->ext_phy == false ==> internal MDIO */
+
+	r8169soc_eee_init(tp, tp->eee_enable);
+
+	/* Enable ALDPS */
+	MDIO_LOCK;
+	r8169_mdio_write(tp, 31, 0xa43);
+	r8169_mdio_write(tp, 24, (r8169_mdio_read(tp, 24) | BIT(2)));
+	MDIO_UNLOCK;
+	#elif defined(CONFIG_ARCH_RTD13xx)
+	r8169soc_reset_phy_gmac(tp);
+	r8169soc_acp_init(tp);
+	r8169soc_pll_clock_init(tp);
+	r8169soc_mdio_init(tp);
+	r8169soc_eee_init(tp, tp->eee_enable);
+
+	/* Enable ALDPS */
+	MDIO_LOCK;
+	r8169_mdio_write(tp, 31, 0xa43);
+	r8169_mdio_write(tp, 24, (r8169_mdio_read(tp, 24) | BIT(2)));
+	MDIO_UNLOCK;
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x | \
+	          CONFIG_ARCH_RTD16xx | CONFIG_ARCH_RTD13xx */
+#endif
+
+	tp->wol_wpd_cnt = 0;
+	for (i = 0; i < RTL_WPD_SIZE; i++) {
+		memset(tmp_str, 0, 80);
+		sprintf(tmp_str, "wake-mask%d", i);
+		wake_mask = of_find_property(pdev->dev.of_node, tmp_str, NULL);
+		if (!wake_mask)
+			break;
+		tp->wol_mask_size[i] = wake_mask->length;
+		memcpy(&tp->wol_mask[i][0], wake_mask->value, wake_mask->length);
+
+		sprintf(tmp_str, "wake-crc%d", i);
+		if (of_property_read_u32(pdev->dev.of_node, tmp_str, &tp->wol_crc[i]))
+			break;
+		tp->wol_wpd_cnt = i + 1;
+	}
+
+#if 0	//barry
+	/* disable ASPM completely as that cause random device stop working
+	 * problems as well as full system hangs for some PCIe devices users */
+	pci_disable_link_state(pdev, PCIE_LINK_STATE_L0S | PCIE_LINK_STATE_L1 |
+					 PCIE_LINK_STATE_CLKPM);
+
+	/* enable device (incl. PCI PM wakeup and hotplug setup) */
+	rc = pci_enable_device(pdev);
+	if (rc < 0) {
+		netif_err(tp, probe, dev, "enable failure\n");
+		goto err_out_free_dev_1;
+	}
+
+	if (pci_set_mwi(pdev) < 0)
+		netif_info(tp, probe, dev, "Mem-Wr-Inval unavailable\n");
+
+	/* make sure PCI base addr 1 is MMIO */
+	if (!(pci_resource_flags(pdev, region) & IORESOURCE_MEM)) {
+		netif_err(tp, probe, dev,
+			  "region #%d not an MMIO resource, aborting\n",
+			  region);
+		rc = -ENODEV;
+		goto err_out_mwi_2;
+	}
+
+	/* check for weird/broken PCI region reporting */
+	if (pci_resource_len(pdev, region) < R8169_REGS_SIZE) {
+		netif_err(tp, probe, dev,
+			  "Invalid PCI region size(s), aborting\n");
+		rc = -ENODEV;
+		goto err_out_mwi_2;
+	}
+
+	rc = pci_request_regions(pdev, MODULENAME);
+	if (rc < 0) {
+		netif_err(tp, probe, dev, "could not request regions\n");
+		goto err_out_mwi_2;
+	}
+
+	tp->cp_cmd = RxChkSum;
+
+	if ((sizeof(dma_addr_t) > 4) &&
+		!pci_set_dma_mask(pdev, DMA_BIT_MASK(64)) && use_dac) {
+		tp->cp_cmd |= PCIDAC;
+		dev->features |= NETIF_F_HIGHDMA;
+	} else {
+		rc = pci_set_dma_mask(pdev, DMA_BIT_MASK(32));
+		if (rc < 0) {
+			netif_err(tp, probe, dev, "DMA configuration failed\n");
+			goto err_out_free_res_3;
+		}
+	}
+
+	/* ioremap MMIO region */
+	ioaddr = ioremap(pci_resource_start(pdev, region), R8169_REGS_SIZE);
+	if (!ioaddr) {
+		netif_err(tp, probe, dev, "cannot remap MMIO, aborting\n");
+		rc = -EIO;
+		goto err_out_free_res_3;
+	}
+#endif
+#ifdef RTL_PROC
+	do{
+		// create /proc/net/$rtw_proc_name
+		rtw_proc=proc_mkdir_data("eth0",  S_IRUGO|S_IXUGO,init_net.proc_net, NULL);
+
+		if (rtw_proc == NULL) {
+			//DBG_871X(KERN_ERR "Unable to create rtw_proc directory\n");
+			printk(KERN_INFO "procfs:create /proc/net/eth0 failed\n");
+			break;
+		}
+
+		// create /proc/net/$rtw_proc_name/$dev->name
+		if(tp->dir_dev == NULL)
+		{
+			tp->dir_dev = proc_mkdir_data(MODULENAME, S_IFDIR | S_IRUGO | S_IXUGO,rtw_proc, ndev);
+			dir_dev = tp->dir_dev;
+
+			if(dir_dev==NULL)
+			{
+				printk(KERN_INFO "procfs:create /proc/net/eth0/r8169 failed\n");
+
+				if(rtw_proc){
+					remove_proc_entry("eth0", init_net.proc_net);
+					rtw_proc = NULL;
+				}
+				break;
+			}
+		}
+		else
+		{
+			break;
+		}
+
+
+		entry = proc_create_data("wol_enable", S_IFREG | S_IRUGO,
+				   dir_dev, &wol_proc_fops, NULL);
+		if (!entry) {
+			printk(KERN_INFO "procfs:create /proc/net/eth0/r8169/wol_enable failed\n");
+			break;
+		}
+
+		entry = proc_create_data("phy_reinit", S_IFREG | S_IRUGO,
+				   dir_dev, &phy_reinit_proc_fops, NULL);
+		if (!entry) {
+			printk(KERN_INFO "procfs:create /proc/net/eth0/r8169/phy_reinit failed\n");
+			break;
+		}
+
+		entry = proc_create_data("eee", S_IFREG | S_IRUGO,
+				   dir_dev, &eee_proc_fops, NULL);
+		if (!entry) {
+			printk(KERN_INFO "procfs:create /proc/net/eth0/r8169/eee failed\n");
+			break;
+		}
+
+		entry = proc_create_data("test", S_IFREG | S_IRUGO,
+				   dir_dev, &test_proc_fops, NULL);
+		if (!entry) {
+			printk(KERN_INFO "procfs:create /proc/net/eth0/r8169/test failed\n");
+			break;
+		}
+	}while(0);
+#endif
+
+//	if (!pci_is_pcie(pdev))
+//		netif_info(tp, probe, dev, "not PCI Express\n");
+
+	/* Identify chip attached to board */
+	rtl8169_get_mac_version(tp, ndev, cfg->default_ver);
+
+	rtl_init_rxcfg(tp);
+
+	rtl_irq_disable(tp);
+
+	rtl_hw_initialize(tp);
+
+	rtl_hw_reset(tp);
+
+	rtl_ack_events(tp, 0xffff);
+
+//	pci_set_master(pdev);
+
+	/*
+	 * Pretend we are using VLANs; This bypasses a nasty bug where
+	 * Interrupts stop flowing on high load on 8110SCd controllers.
+	 */
+	if (tp->mac_version == RTL_GIGA_MAC_VER_05)
+		tp->cp_cmd |= RxVlan;
+
+	rtl_init_mdio_ops(tp);
+	rtl_init_pll_power_ops(tp);
+	rtl_init_jumbo_ops(tp);
+	rtl_init_csi_ops(tp);
+
+	rtl8169_print_mac_version(tp);
+
+	chipset = tp->mac_version;
+	tp->txd_version = rtl_chip_infos[chipset].txd_version;
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+	RTL_W8(Config1, RTL_R8(Config1) | PMEnable);
+	RTL_W8(Config5, RTL_R8(Config5) & PMEStatus);
+
+	//disable magic packet WOL
+	RTL_W8(Config3, RTL_R8(Config3) & ~MagicPacket);
+
+	if ((RTL_R8(Config3) & (LinkUp | MagicPacket)) != 0)
+		tp->features |= RTL_FEATURE_WOL;
+	if ((RTL_R8(Config5) & (UWF | BWF | MWF)) != 0)
+		tp->features |= RTL_FEATURE_WOL;
+	tp->features |= rtl_try_msi(tp, cfg);
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	if (rtl_tbi_enabled(tp)) {
+		tp->set_speed = rtl8169_set_speed_tbi;
+		tp->get_settings = rtl8169_gset_tbi;
+		tp->phy_reset_enable = rtl8169_tbi_reset_enable;
+		tp->phy_reset_pending = rtl8169_tbi_reset_pending;
+		tp->link_ok = rtl8169_tbi_link_ok;
+		tp->do_ioctl = rtl_tbi_ioctl;
+	} else {
+		tp->set_speed = rtl8169_set_speed_xmii;
+		tp->get_settings = rtl8169_gset_xmii;
+		tp->phy_reset_enable = rtl8169_xmii_reset_enable;
+		tp->phy_reset_pending = rtl8169_xmii_reset_pending;
+		tp->link_ok = rtl8169_xmii_link_ok;
+		tp->do_ioctl = rtl_xmii_ioctl;
+	}
+
+	#if defined(CONFIG_ARCH_RTD129x)
+	if ((get_rtd_chip_revision() >= RTD_CHIP_B00) &&
+		(tp->output_mode == OUTPUT_RGMII_TO_MAC))
+		tp->link_ok = rtl8169_xmii_always_link_ok;
+	#elif defined(CONFIG_ARCH_RTD139x)
+	if (tp->output_mode == OUTPUT_SGMII_TO_MAC)
+		tp->link_ok = rtl8169_xmii_always_link_ok;
+	#endif /* CONFIG_ARCH_RTD129x | CONFIG_ARCH_RTD139x */
+
+	mutex_init(&tp->wk.mutex);
+
+	/* Get MAC address */
+	mac_addr = of_get_mac_address(pdev->dev.of_node);
+	if (mac_addr)
+		rtl_rar_set(tp, (u8*)mac_addr);
+
+	/* workaround: avoid getting deadbeef */
+	#define RETRY_MAX	10
+	for (retry = 0; retry < RETRY_MAX; retry++) {
+		for (i = 0; i < ETH_ALEN; i++)
+			ndev->dev_addr[i] = RTL_R8(MAC0 + i);
+
+		if (*(u32 *) ndev->dev_addr != 0xdeadbeef) {
+			break;
+		} else {
+			printk(KERN_ERR "%s get invalid MAC address %pM, retry %d\n",
+				rtl_chip_infos[chipset].name, ndev->dev_addr, retry);
+			tmp = RTL_R32(PHYAR); // read something else
+			msleep(10);
+		}
+	}
+	if (retry == RETRY_MAX)
+		printk(KERN_ERR "%s get invalid MAC address %pM, give up!\n",
+			rtl_chip_infos[chipset].name, ndev->dev_addr);
+
+
+	ndev->ethtool_ops = &rtl8169_ethtool_ops;
+	ndev->watchdog_timeo = RTL8169_TX_TIMEOUT;
+
+	netif_napi_add(ndev, &tp->napi, rtl8169_poll, R8169_NAPI_WEIGHT);
+
+	/* don't enable SG, IP_CSUM and TSO by default - it might not work
+	 * properly for all devices */
+	ndev->features |= NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |NETIF_F_RXCSUM | NETIF_F_HW_VLAN_CTAG_TX | NETIF_F_HW_VLAN_CTAG_RX;
+
+	ndev->hw_features = NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |
+		NETIF_F_RXCSUM | NETIF_F_HW_VLAN_CTAG_TX |
+		NETIF_F_HW_VLAN_CTAG_RX;
+	ndev->vlan_features = NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |
+		NETIF_F_HIGHDMA;
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_05)
+		/* 8110SCd requires hardware Rx VLAN - disallow toggling */
+		ndev->hw_features &= ~NETIF_F_HW_VLAN_CTAG_RX;
+
+	ndev->hw_features |= NETIF_F_RXALL;
+	ndev->hw_features |= NETIF_F_RXFCS;
+
+	tp->hw_start = cfg->hw_start;
+	tp->event_slow = cfg->event_slow;
+
+	tp->opts1_mask = (tp->mac_version != RTL_GIGA_MAC_VER_01) ?
+		~(RxBOVF | RxFOVF) : ~0;
+
+	//init_timer(&tp->timer);
+	//tp->timer.data = (unsigned long) ndev;
+	//tp->timer.function = rtl8169_phy_timer;
+
+	tp->rtl_fw = RTL_FIRMWARE_UNKNOWN;
+
+	rc = register_netdev(ndev);
+	if (rc < 0)
+		goto err_out_msi_4;
+
+//	pci_set_drvdata(pdev, dev);
+	platform_set_drvdata(pdev, ndev);
+
+	netif_info(tp, probe, ndev, "%s at 0x%p, XID %08x IRQ %d\n",
+		   rtl_chip_infos[chipset].name, ioaddr,
+		   (u32)(RTL_R32(TxConfig) & 0x9cf0f8ff), ndev->irq);
+	if (rtl_chip_infos[chipset].jumbo_max != JUMBO_1K) {
+		netif_info(tp, probe, ndev, "jumbo features [frames: %d bytes, "
+			   "tx checksumming: %s]\n",
+			   rtl_chip_infos[chipset].jumbo_max,
+			   rtl_chip_infos[chipset].jumbo_tx_csum ? "ok" : "ko");
+	}
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_27 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_28 ||
+		tp->mac_version == RTL_GIGA_MAC_VER_31) {
+		rtl8168_driver_start(tp);
+	}
+
+	device_set_wakeup_enable(&pdev->dev, tp->features & RTL_FEATURE_WOL);
+
+//	if (pci_dev_run_wake(pdev))
+//		pm_runtime_put_noidle(&pdev->dev);
+
+	netif_carrier_off(ndev);
+
+	/* Yukuen: Add for link status uevent. 20150206 */
+	init_waitqueue_head(&tp->thr_wait);
+	tp->link_chg = 0;
+	tp->kthr = NULL;
+	tp->kthr = kthread_create(link_status, (void*)ndev, "%s-linkstatus", ndev->name);
+	if(IS_ERR(tp->kthr)){
+		tp->kthr = NULL;
+		printk (KERN_WARNING "%s: unable to start kthread for link status.\n",
+				ndev->name);
+	}
+	else{
+		wake_up_process(tp->kthr);  // run thread function
+	}
+
+	/* clear GPHY HV/DV/AV POR interrupts */
+	writel(0x70000000, tp->mmio_clkaddr + ISO_UMSK_ISR);
+
+	for (i = 0; i < POR_NUM; i++) {
+		memset(tmp_str, 0, 80);
+		sprintf(tmp_str, "eth_phy%d", i);
+		rc = request_irq(tp->phy_irq[i], phy_irq_handler, IRQF_SHARED,
+				 tmp_str, tp);
+		if (rc < 0) {
+			pr_err("%s: unable to request %s IRQ %d, ret = 0x%x\n",
+				ndev->name, tmp_str, tp->phy_irq[i], rc);
+		} else {
+			pr_info("%s: request %s IRQ %d successfully, ret = 0x%x\n",
+				ndev->name, tmp_str, tp->phy_irq[i], rc);
+		}
+	}
+out:
+	return rc;
+
+err_out_msi_4:
+	netif_napi_del(&tp->napi);
+//	rtl_disable_msi(pdev, tp);
+//	iounmap(ioaddr);
+//err_out_free_res_3:
+//	pci_release_regions(pdev);
+//err_out_mwi_2:
+//	pci_clear_mwi(pdev);
+//	pci_disable_device(pdev);
+//err_out_free_dev_1:
+	free_netdev(ndev);
+	goto out;
+}
+
+static struct platform_driver rtl8169_soc_driver = {
+	.probe		= rtl_init_one,
+	.remove		= rtl_remove_one,
+	.shutdown	= rtl_shutdown,
+	.driver = {
+		.name		= MODULENAME,
+		.owner		= THIS_MODULE,
+		.pm			= RTL8169_PM_OPS,
+		.of_match_table = of_match_ptr(rtl8169_dt_ids),
+	},
+};
+
+module_platform_driver(rtl8169_soc_driver);
diff --git a/drivers/net/ethernet/realtek/r8169soc_rtd119x.c b/drivers/net/ethernet/realtek/r8169soc_rtd119x.c
new file mode 100644
index 00000000..04df1ef
--- /dev/null
+++ b/drivers/net/ethernet/realtek/r8169soc_rtd119x.c
@@ -0,0 +1,7811 @@
+/*
+ * r8169.c: RealTek 8169/8168/8101 ethernet driver.
+ *
+ * Copyright (c) 2002 ShuChen <shuchen@realtek.com.tw>
+ * Copyright (c) 2003 - 2007 Francois Romieu <romieu@fr.zoreil.com>
+ * Copyright (c) a lot of people too. Please respect their work.
+ *
+ * See MAINTAINERS file for support contact information.
+ */
+
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/proc_fs.h> 
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/delay.h>
+#include <linux/ethtool.h>
+#include <linux/mii.h>
+#include <linux/if_vlan.h>
+#include <linux/crc32.h>
+#include <linux/in.h>
+#include <linux/ip.h>
+#include <linux/tcp.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/dma-mapping.h>
+#include <linux/pm_runtime.h>
+#include <linux/firmware.h>
+#include <linux/platform_device.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_net.h>
+#include <linux/of_address.h>
+
+#include <mach/cpu.h>
+
+#include <asm/io.h>
+#include <asm/irq.h>
+
+/* Yukuen: Use kthread to watch link status change. 20150206 */
+#include <linux/kthread.h>
+
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+#define RTL8169_VERSION "2.7LK-NAPI"
+#define MODULENAME "r8169"
+#define PFX MODULENAME ": "
+
+#define FIRMWARE_8168D_1	"rtl_nic/rtl8168d-1.fw"
+#define FIRMWARE_8168D_2	"rtl_nic/rtl8168d-2.fw"
+#define FIRMWARE_8168E_1	"rtl_nic/rtl8168e-1.fw"
+#define FIRMWARE_8168E_2	"rtl_nic/rtl8168e-2.fw"
+#define FIRMWARE_8168E_3	"rtl_nic/rtl8168e-3.fw"
+#define FIRMWARE_8168F_1	"rtl_nic/rtl8168f-1.fw"
+#define FIRMWARE_8168F_2	"rtl_nic/rtl8168f-2.fw"
+#define FIRMWARE_8105E_1	"rtl_nic/rtl8105e-1.fw"
+#define FIRMWARE_8402_1		"rtl_nic/rtl8402-1.fw"
+#define FIRMWARE_8411_1		"rtl_nic/rtl8411-1.fw"
+#define FIRMWARE_8106E_1	"rtl_nic/rtl8106e-1.fw"
+#define FIRMWARE_8106E_2	"rtl_nic/rtl8106e-2.fw"
+#define FIRMWARE_8168G_2	"rtl_nic/rtl8168g-2.fw"
+#define FIRMWARE_8168G_3	"rtl_nic/rtl8168g-3.fw"
+
+#define CYAN	"\033[0;36m"
+#define NONE	"\033[m"
+#ifdef RTL8169_DEBUG
+#define assert(expr) \
+	if (!(expr)) {					\
+		printk( "Assertion failed! %s,%s,%s,line=%d\n",	\
+		#expr,__FILE__,__func__,__LINE__);		\
+	}
+#define dprintk(fmt, args...) \
+	do { printk(KERN_DEBUG "\033[0;36m" PFX "\033[m" fmt, ## args); } while (0)
+#else
+#define assert(expr) do {} while (0)
+#define dprintk(fmt, args...)	do {} while (0)
+#endif /* RTL8169_DEBUG */
+
+#define R8169_MSG_DEFAULT \
+	(NETIF_MSG_DRV | NETIF_MSG_PROBE | NETIF_MSG_IFUP | NETIF_MSG_IFDOWN)
+
+#define TX_SLOTS_AVAIL(tp) \
+	(tp->dirty_tx + NUM_TX_DESC - tp->cur_tx)
+
+/* A skbuff with nr_frags needs nr_frags+1 entries in the tx queue */
+#define TX_FRAGS_READY_FOR(tp,nr_frags) \
+	(TX_SLOTS_AVAIL(tp) >= (nr_frags + 1))
+
+/* Maximum number of multicast addresses to filter (vs. Rx-all-multicast).
+   The RTL chips use a 64 element hash table based on the Ethernet CRC. */
+static const int multicast_filter_limit = 32;
+
+#define MAX_READ_REQUEST_SHIFT	12
+#define TX_DMA_BURST	4	/* Maximum PCI burst, '7' is unlimited */
+#define InterFrameGap	0x03	/* 3 means InterFrameGap = the shortest one */
+
+#define R8169_REGS_SIZE		256
+#define R8169_NAPI_WEIGHT	64
+#define NUM_TX_DESC	64	/* Number of Tx descriptor registers */
+#define NUM_RX_DESC	256U	/* Number of Rx descriptor registers */
+#define R8169_TX_RING_BYTES	(NUM_TX_DESC * sizeof(struct TxDesc))
+#define R8169_RX_RING_BYTES	(NUM_RX_DESC * sizeof(struct RxDesc))
+
+#define RTL8169_TX_TIMEOUT	(6*HZ)
+#define RTL8169_PHY_TIMEOUT	(2*HZ)
+
+#define RTL_PROC 1
+
+/* write/read MMIO register */
+#define RTL_W8(reg, val8)	writeb ((val8), ioaddr + (reg))
+#define RTL_W16(reg, val16)	writew ((val16), ioaddr + (reg))
+#define RTL_W32(reg, val32)	writel ((val32), ioaddr + (reg))
+#define RTL_R8(reg)		readb (ioaddr + (reg))
+#define RTL_R16(reg)		readw (ioaddr + (reg))
+#define RTL_R32(reg)		readl (ioaddr + (reg))
+
+enum mac_version {
+	RTL_GIGA_MAC_VER_01 = 0,
+	RTL_GIGA_MAC_VER_02,
+	RTL_GIGA_MAC_VER_03,
+	RTL_GIGA_MAC_VER_04,
+	RTL_GIGA_MAC_VER_05,
+	RTL_GIGA_MAC_VER_06,
+	RTL_GIGA_MAC_VER_07,
+	RTL_GIGA_MAC_VER_08,
+	RTL_GIGA_MAC_VER_09,
+	RTL_GIGA_MAC_VER_10,
+	RTL_GIGA_MAC_VER_11,
+	RTL_GIGA_MAC_VER_12,
+	RTL_GIGA_MAC_VER_13,
+	RTL_GIGA_MAC_VER_14,
+	RTL_GIGA_MAC_VER_15,
+	RTL_GIGA_MAC_VER_16,
+	RTL_GIGA_MAC_VER_17,
+	RTL_GIGA_MAC_VER_18,
+	RTL_GIGA_MAC_VER_19,
+	RTL_GIGA_MAC_VER_20,
+	RTL_GIGA_MAC_VER_21,
+	RTL_GIGA_MAC_VER_22,
+	RTL_GIGA_MAC_VER_23,
+	RTL_GIGA_MAC_VER_24,
+	RTL_GIGA_MAC_VER_25,
+	RTL_GIGA_MAC_VER_26,
+	RTL_GIGA_MAC_VER_27,
+	RTL_GIGA_MAC_VER_28,
+	RTL_GIGA_MAC_VER_29,
+	RTL_GIGA_MAC_VER_30,
+	RTL_GIGA_MAC_VER_31,
+	RTL_GIGA_MAC_VER_32,
+	RTL_GIGA_MAC_VER_33,
+	RTL_GIGA_MAC_VER_34,
+	RTL_GIGA_MAC_VER_35,
+	RTL_GIGA_MAC_VER_36,
+	RTL_GIGA_MAC_VER_37,
+	RTL_GIGA_MAC_VER_38,
+	RTL_GIGA_MAC_VER_39,
+	RTL_GIGA_MAC_VER_40,
+	RTL_GIGA_MAC_VER_41,
+	RTL_GIGA_MAC_VER_42,
+	RTL_GIGA_MAC_VER_43,
+	RTL_GIGA_MAC_NONE   = 0xff,
+};
+
+enum rtl_tx_desc_version {
+	RTL_TD_0	= 0,
+	RTL_TD_1	= 1,
+};
+
+#define JUMBO_1K	ETH_DATA_LEN
+#define JUMBO_4K	(4*1024 - ETH_HLEN - 2)
+#define JUMBO_6K	(6*1024 - ETH_HLEN - 2)
+#define JUMBO_7K	(7*1024 - ETH_HLEN - 2)
+#define JUMBO_9K	(9*1024 - ETH_HLEN - 2)
+
+#define _R(NAME,TD,FW,SZ,B) {	\
+	.name = NAME,		\
+	.txd_version = TD,	\
+	.fw_name = FW,		\
+	.jumbo_max = SZ,	\
+	.jumbo_tx_csum = B	\
+}
+
+static const struct {
+	const char *name;
+	enum rtl_tx_desc_version txd_version;
+	const char *fw_name;
+	u16 jumbo_max;
+	bool jumbo_tx_csum;
+} rtl_chip_infos[] = {
+	/* PCI devices. */
+	[RTL_GIGA_MAC_VER_01] =
+		_R("RTL8169",		RTL_TD_0, NULL, JUMBO_7K, true),
+	[RTL_GIGA_MAC_VER_02] =
+		_R("RTL8169s",		RTL_TD_0, NULL, JUMBO_7K, true),
+	[RTL_GIGA_MAC_VER_03] =
+		_R("RTL8110s",		RTL_TD_0, NULL, JUMBO_7K, true),
+	[RTL_GIGA_MAC_VER_04] =
+		_R("RTL8169sb/8110sb",	RTL_TD_0, NULL, JUMBO_7K, true),
+	[RTL_GIGA_MAC_VER_05] =
+		_R("RTL8169sc/8110sc",	RTL_TD_0, NULL, JUMBO_7K, true),
+	[RTL_GIGA_MAC_VER_06] =
+		_R("RTL8169sc/8110sc",	RTL_TD_0, NULL, JUMBO_7K, true),
+	/* PCI-E devices. */
+	[RTL_GIGA_MAC_VER_07] =
+		_R("RTL8102e",		RTL_TD_1, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_08] =
+		_R("RTL8102e",		RTL_TD_1, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_09] =
+		_R("RTL8102e",		RTL_TD_1, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_10] =
+		_R("RTL8101e",		RTL_TD_0, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_11] =
+		_R("RTL8168b/8111b",	RTL_TD_0, NULL, JUMBO_4K, false),
+	[RTL_GIGA_MAC_VER_12] =
+		_R("RTL8168b/8111b",	RTL_TD_0, NULL, JUMBO_4K, false),
+	[RTL_GIGA_MAC_VER_13] =
+		_R("RTL8101e",		RTL_TD_0, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_14] =
+		_R("RTL8100e",		RTL_TD_0, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_15] =
+		_R("RTL8100e",		RTL_TD_0, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_16] =
+		_R("RTL8101e",		RTL_TD_0, NULL, JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_17] =
+		_R("RTL8168b/8111b",	RTL_TD_1, NULL, JUMBO_4K, false),
+	[RTL_GIGA_MAC_VER_18] =
+		_R("RTL8168cp/8111cp",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_19] =
+		_R("RTL8168c/8111c",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_20] =
+		_R("RTL8168c/8111c",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_21] =
+		_R("RTL8168c/8111c",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_22] =
+		_R("RTL8168c/8111c",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_23] =
+		_R("RTL8168cp/8111cp",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_24] =
+		_R("RTL8168cp/8111cp",	RTL_TD_1, NULL, JUMBO_6K, false),
+	[RTL_GIGA_MAC_VER_25] =
+		_R("RTL8168d/8111d",	RTL_TD_1, FIRMWARE_8168D_1,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_26] =
+		_R("RTL8168d/8111d",	RTL_TD_1, FIRMWARE_8168D_2,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_27] =
+		_R("RTL8168dp/8111dp",	RTL_TD_1, NULL, JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_28] =
+		_R("RTL8168dp/8111dp",	RTL_TD_1, NULL, JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_29] =
+		_R("RTL8105e",		RTL_TD_1, FIRMWARE_8105E_1,
+							JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_30] =
+		_R("RTL8105e",		RTL_TD_1, FIRMWARE_8105E_1,
+							JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_31] =
+		_R("RTL8168dp/8111dp",	RTL_TD_1, NULL, JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_32] =
+		_R("RTL8168e/8111e",	RTL_TD_1, FIRMWARE_8168E_1,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_33] =
+		_R("RTL8168e/8111e",	RTL_TD_1, FIRMWARE_8168E_2,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_34] =
+		_R("RTL8168evl/8111evl",RTL_TD_1, FIRMWARE_8168E_3,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_35] =
+		_R("RTL8168f/8111f",	RTL_TD_1, FIRMWARE_8168F_1,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_36] =
+		_R("RTL8168f/8111f",	RTL_TD_1, FIRMWARE_8168F_2,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_37] =
+		_R("RTL8402",		RTL_TD_1, FIRMWARE_8402_1,
+							JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_38] =
+		_R("RTL8411",		RTL_TD_1, FIRMWARE_8411_1,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_39] =
+		_R("RTL8106e",		RTL_TD_1, FIRMWARE_8106E_1,
+							JUMBO_1K, true),
+	[RTL_GIGA_MAC_VER_40] =
+		_R("RTL8168g/8111g",	RTL_TD_1, FIRMWARE_8168G_2,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_41] =
+		_R("RTL8168g/8111g",	RTL_TD_1, NULL, JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_42] =
+	//	_R("RTL8168g/8111g",	RTL_TD_1, FIRMWARE_8168G_3,
+		_R("RTL8168g/8111g",	RTL_TD_1, NULL,
+							JUMBO_9K, false),
+	[RTL_GIGA_MAC_VER_43] =
+		_R("RTL8106e",		RTL_TD_1, FIRMWARE_8106E_2,
+							JUMBO_1K, true),
+};
+#undef _R
+
+enum cfg_version {
+	RTL_CFG_0 = 0x00,
+	RTL_CFG_1,
+	RTL_CFG_2
+};
+
+static const struct of_device_id rtl8169_dt_ids[] = {
+	{ .compatible = "Realtek,r8168", },
+	{},
+};
+
+MODULE_DEVICE_TABLE(of, rtl8169_dt_ids);
+
+static int rx_buf_sz = 16383;
+static int use_dac;
+static struct {
+	u32 msg_enable;
+} debug = { -1 };
+
+enum rtl_registers {
+	MAC0		= 0,	/* Ethernet hardware address. */
+	MAC4		= 4,
+	MAR0		= 8,	/* Multicast filter. */
+	CounterAddrLow		= 0x10,
+	CounterAddrHigh		= 0x14,
+	LEDSEL				= 0x18,
+	TxDescStartAddrLow	= 0x20,
+	TxDescStartAddrHigh	= 0x24,
+	TxHDescStartAddrLow	= 0x28,
+	TxHDescStartAddrHigh	= 0x2c,
+	FLASH		= 0x30,
+	ERSR		= 0x36,
+	ChipCmd		= 0x37,
+	TxPoll		= 0x38,
+	IntrMask	= 0x3c,
+	IntrStatus	= 0x3e,
+
+	TxConfig	= 0x40,
+#define	TXCFG_AUTO_FIFO			(1 << 7)	/* 8111e-vl */
+#define	TXCFG_EMPTY			(1 << 11)	/* 8111e-vl */
+
+	RxConfig	= 0x44,
+#define	RX128_INT_EN			(1 << 15)	/* 8111c and later */
+#define	RX_MULTI_EN			(1 << 14)	/* 8111c only */
+#define	RXCFG_FIFO_SHIFT		13
+					/* No threshold before first PCI xfer */
+#define	RX_FIFO_THRESH			(7 << RXCFG_FIFO_SHIFT)
+#define	RX_EARLY_OFF			(1 << 11)
+#define	RXCFG_DMA_SHIFT			8
+					/* Unlimited maximum PCI burst. */
+#define	RX_DMA_BURST			(3 << RXCFG_DMA_SHIFT)	/* 128 bytes */
+
+	RxMissed	= 0x4c,
+	Cfg9346		= 0x50,
+	Config0		= 0x51,
+	Config1		= 0x52,
+	Config2		= 0x53,
+#define PME_SIGNAL			(1 << 5)	/* 8168c and later */
+
+	Config3		= 0x54,
+	Config4		= 0x55,
+	Config5		= 0x56,
+	MultiIntr	= 0x5c,
+	PHYAR		= 0x60,
+	PHYstatus	= 0x6c,
+	RxMaxSize	= 0xda,
+	CPlusCmd	= 0xe0,
+	IntrMitigate	= 0xe2,
+	RxDescAddrLow	= 0xe4,
+	RxDescAddrHigh	= 0xe8,
+	EarlyTxThres	= 0xec,	/* 8169. Unit of 32 bytes. */
+
+#define NoEarlyTx	0x3f	/* Max value : no early transmit. */
+
+	MaxTxPacketSize	= 0xec,	/* 8101/8168. Unit of 128 bytes. */
+
+#define TxPacketMax	(8064 >> 7)
+#define EarlySize	0x27
+
+	FuncEvent	= 0xf0,
+	FuncEventMask	= 0xf4,
+	FuncPresetState	= 0xf8,
+	FuncForceEvent	= 0xfc,
+};
+
+enum rtl8110_registers {
+	TBICSR			= 0x64,
+	TBI_ANAR		= 0x68,
+	TBI_LPAR		= 0x6a,
+};
+
+enum rtl8168_8101_registers {
+	CSIDR			= 0x64,
+	CSIAR			= 0x68,
+#define	CSIAR_FLAG			0x80000000
+#define	CSIAR_WRITE_CMD			0x80000000
+#define	CSIAR_BYTE_ENABLE		0x0f
+#define	CSIAR_BYTE_ENABLE_SHIFT		12
+#define	CSIAR_ADDR_MASK			0x0fff
+#define CSIAR_FUNC_CARD			0x00000000
+#define CSIAR_FUNC_SDIO			0x00010000
+#define CSIAR_FUNC_NIC			0x00020000
+	PMCH			= 0x6f,
+	EPHYAR			= 0x80,
+#define	EPHYAR_FLAG			0x80000000
+#define	EPHYAR_WRITE_CMD		0x80000000
+#define	EPHYAR_REG_MASK			0x1f
+#define	EPHYAR_REG_SHIFT		16
+#define	EPHYAR_DATA_MASK		0xffff
+	DLLPR			= 0xd0,
+#define	PFM_EN				(1 << 6)
+	DBG_REG			= 0xd1,
+#define	FIX_NAK_1			(1 << 4)
+#define	FIX_NAK_2			(1 << 3)
+	TWSI			= 0xd2,
+	MCU			= 0xd3,
+#define	NOW_IS_OOB			(1 << 7)
+#define	TX_EMPTY			(1 << 5)
+#define	RX_EMPTY			(1 << 4)
+#define	RXTX_EMPTY			(TX_EMPTY | RX_EMPTY)
+#define	EN_NDP				(1 << 3)
+#define	EN_OOB_RESET			(1 << 2)
+#define	LINK_LIST_RDY			(1 << 1)
+	EFUSEAR			= 0xdc,
+#define	EFUSEAR_FLAG			0x80000000
+#define	EFUSEAR_WRITE_CMD		0x80000000
+#define	EFUSEAR_READ_CMD		0x00000000
+#define	EFUSEAR_REG_MASK		0x03ff
+#define	EFUSEAR_REG_SHIFT		8
+#define	EFUSEAR_DATA_MASK		0xff
+};
+
+enum rtl8168_registers {
+	LED_FREQ		= 0x1a,
+	EEE_LED			= 0x1b,
+	ERIDR			= 0x70,
+	ERIAR			= 0x74,
+#define ERIAR_FLAG			0x80000000
+#define ERIAR_WRITE_CMD			0x80000000
+#define ERIAR_READ_CMD			0x00000000
+#define ERIAR_ADDR_BYTE_ALIGN		4
+#define ERIAR_TYPE_SHIFT		16
+#define ERIAR_EXGMAC			(0x00 << ERIAR_TYPE_SHIFT)
+#define ERIAR_MSIX			(0x01 << ERIAR_TYPE_SHIFT)
+#define ERIAR_ASF			(0x02 << ERIAR_TYPE_SHIFT)
+#define ERIAR_MASK_SHIFT		12
+#define ERIAR_MASK_0001			(0x1 << ERIAR_MASK_SHIFT)
+#define ERIAR_MASK_0011			(0x3 << ERIAR_MASK_SHIFT)
+#define ERIAR_MASK_0101			(0x5 << ERIAR_MASK_SHIFT)
+#define ERIAR_MASK_1111			(0xf << ERIAR_MASK_SHIFT)
+	EPHY_RXER_NUM		= 0x7c,
+	OCPDR			= 0xb0,	/* OCP GPHY access */
+#define OCPDR_WRITE_CMD			0x80000000
+#define OCPDR_READ_CMD			0x00000000
+#define OCPDR_REG_MASK			0x7f
+#define OCPDR_GPHY_REG_SHIFT		16
+#define OCPDR_DATA_MASK			0xffff
+	OCPAR			= 0xb4,
+#define OCPAR_FLAG			0x80000000
+#define OCPAR_GPHY_WRITE_CMD		0x8000f060
+#define OCPAR_GPHY_READ_CMD		0x0000f060
+	GPHY_OCP		= 0xb8,
+	RDSAR1			= 0xd0,	/* 8168c only. Undocumented on 8168dp */
+	MISC			= 0xf0,	/* 8168e only. */
+#define TXPLA_RST			(1 << 29)
+#define DISABLE_LAN_EN			(1 << 23) /* Enable GPIO pin */
+#define PWM_EN				(1 << 22)
+#define RXDV_GATED_EN			(1 << 19)
+#define EARLY_TALLY_EN			(1 << 16)
+};
+
+enum rtl_register_content {
+	/* InterruptStatusBits */
+	SYSErr		= 0x8000,
+	PCSTimeout	= 0x4000,
+	SWInt		= 0x0100,
+	TxDescUnavail	= 0x0080,
+	RxFIFOOver	= 0x0040,
+	LinkChg		= 0x0020,
+	RxOverflow	= 0x0010,
+	TxErr		= 0x0008,
+	TxOK		= 0x0004,
+	RxErr		= 0x0002,
+	RxOK		= 0x0001,
+
+	/* RxStatusDesc */
+	RxBOVF	= (1 << 24),
+	RxFOVF	= (1 << 23),
+	RxRWT	= (1 << 22),
+	RxRES	= (1 << 21),
+	RxRUNT	= (1 << 20),
+	RxCRC	= (1 << 19),
+
+	/* ChipCmdBits */
+	StopReq		= 0x80,
+	CmdReset	= 0x10,
+	CmdRxEnb	= 0x08,
+	CmdTxEnb	= 0x04,
+	RxBufEmpty	= 0x01,
+
+	/* TXPoll register p.5 */
+	HPQ		= 0x80,		/* Poll cmd on the high prio queue */
+	NPQ		= 0x40,		/* Poll cmd on the low prio queue */
+	FSWInt		= 0x01,		/* Forced software interrupt */
+
+	/* Cfg9346Bits */
+	Cfg9346_Lock	= 0x00,
+	Cfg9346_Unlock	= 0xc0,
+
+	/* rx_mode_bits */
+	AcceptErr	= 0x20,
+	AcceptRunt	= 0x10,
+	AcceptBroadcast	= 0x08,
+	AcceptMulticast	= 0x04,
+	AcceptMyPhys	= 0x02,
+	AcceptAllPhys	= 0x01,
+#define RX_CONFIG_ACCEPT_MASK		0x3f
+
+	/* TxConfigBits */
+	TxInterFrameGapShift = 24,
+	TxDMAShift = 8,	/* DMA burst value (0-7) is shift this many bits */
+
+	/* Config1 register p.24 */
+	LEDS1		= (1 << 7),
+	LEDS0		= (1 << 6),
+	Speed_down	= (1 << 4),
+	MEMMAP		= (1 << 3),
+	IOMAP		= (1 << 2),
+	VPD		= (1 << 1),
+	PMEnable	= (1 << 0),	/* Power Management Enable */
+
+	/* Config2 register p. 25 */
+	ClkReqEn	= (1 << 7),	/* Clock Request Enable */
+	MSIEnable	= (1 << 5),	/* 8169 only. Reserved in the 8168. */
+	PCI_Clock_66MHz = 0x01,
+	PCI_Clock_33MHz = 0x00,
+
+	/* Config3 register p.25 */
+	MagicPacket	= (1 << 5),	/* Wake up when receives a Magic Packet */
+	LinkUp		= (1 << 4),	/* Wake up when the cable connection is re-established */
+	Jumbo_En0	= (1 << 2),	/* 8168 only. Reserved in the 8168b */
+	Beacon_en	= (1 << 0),	/* 8168 only. Reserved in the 8168b */
+
+	/* Config4 register */
+	Jumbo_En1	= (1 << 1),	/* 8168 only. Reserved in the 8168b */
+
+	/* Config5 register p.27 */
+	BWF		= (1 << 6),	/* Accept Broadcast wakeup frame */
+	MWF		= (1 << 5),	/* Accept Multicast wakeup frame */
+	UWF		= (1 << 4),	/* Accept Unicast wakeup frame */
+	Spi_en		= (1 << 3),
+	LanWake		= (1 << 1),	/* LanWake enable/disable */
+	PMEStatus	= (1 << 0),	/* PME status can be reset by PCI RST# */
+	ASPM_en		= (1 << 0),	/* ASPM enable */
+
+	/* TBICSR p.28 */
+	TBIReset	= 0x80000000,
+	TBILoopback	= 0x40000000,
+	TBINwEnable	= 0x20000000,
+	TBINwRestart	= 0x10000000,
+	TBILinkOk	= 0x02000000,
+	TBINwComplete	= 0x01000000,
+
+	/* CPlusCmd p.31 */
+	EnableBist	= (1 << 15),	// 8168 8101
+	Mac_dbgo_oe	= (1 << 14),	// 8168 8101
+	Normal_mode	= (1 << 13),	// unused
+	Force_half_dup	= (1 << 12),	// 8168 8101
+	Force_rxflow_en	= (1 << 11),	// 8168 8101
+	Force_txflow_en	= (1 << 10),	// 8168 8101
+	Cxpl_dbg_sel	= (1 << 9),	// 8168 8101
+	ASF		= (1 << 8),	// 8168 8101
+	PktCntrDisable	= (1 << 7),	// 8168 8101
+	Mac_dbgo_sel	= 0x001c,	// 8168
+	RxVlan		= (1 << 6),
+	RxChkSum	= (1 << 5),
+	PCIDAC		= (1 << 4),
+	PCIMulRW	= (1 << 3),
+	INTT_0		= 0x0000,	// 8168
+	INTT_1		= 0x0001,	// 8168
+	INTT_2		= 0x0002,	// 8168
+	INTT_3		= 0x0003,	// 8168
+
+	/* rtl8169_PHYstatus */
+	TBI_Enable	= 0x80,
+	TxFlowCtrl	= 0x40,
+	RxFlowCtrl	= 0x20,
+	_1000bpsF	= 0x10,
+	_100bps		= 0x08,
+	_10bps		= 0x04,
+	LinkStatus	= 0x02,
+	FullDup		= 0x01,
+
+	/* _TBICSRBit */
+	TBILinkOK	= 0x02000000,
+
+	/* DumpCounterCommand */
+	CounterDump	= 0x8,
+};
+
+enum rtl_desc_bit {
+	/* First doubleword. */
+	DescOwn		= (1 << 31), /* Descriptor is owned by NIC */
+	RingEnd		= (1 << 30), /* End of descriptor ring */
+	FirstFrag	= (1 << 29), /* First segment of a packet */
+	LastFrag	= (1 << 28), /* Final segment of a packet */
+};
+
+/* Generic case. */
+enum rtl_tx_desc_bit {
+	/* First doubleword. */
+	TD_LSO		= (1 << 27),		/* Large Send Offload */
+#define TD_MSS_MAX			0x07ffu	/* MSS value */
+
+	/* Second doubleword. */
+	TxVlanTag	= (1 << 17),		/* Add VLAN tag */
+};
+
+/* 8169, 8168b and 810x except 8102e. */
+enum rtl_tx_desc_bit_0 {
+	/* First doubleword. */
+#define TD0_MSS_SHIFT			16	/* MSS position (11 bits) */
+	TD0_TCP_CS	= (1 << 16),		/* Calculate TCP/IP checksum */
+	TD0_UDP_CS	= (1 << 17),		/* Calculate UDP/IP checksum */
+	TD0_IP_CS	= (1 << 18),		/* Calculate IP checksum */
+};
+
+/* 8102e, 8168c and beyond. */
+enum rtl_tx_desc_bit_1 {
+	/* Second doubleword. */
+#define TD1_MSS_SHIFT			18	/* MSS position (11 bits) */
+	TD1_IP_CS	= (1 << 29),		/* Calculate IP checksum */
+	TD1_TCP_CS	= (1 << 30),		/* Calculate TCP/IP checksum */
+	TD1_UDP_CS	= (1 << 31),		/* Calculate UDP/IP checksum */
+};
+
+static const struct rtl_tx_desc_info {
+	struct {
+		u32 udp;
+		u32 tcp;
+	} checksum;
+	u16 mss_shift;
+	u16 opts_offset;
+} tx_desc_info [] = {
+	[RTL_TD_0] = {
+		.checksum = {
+			.udp	= TD0_IP_CS | TD0_UDP_CS,
+			.tcp	= TD0_IP_CS | TD0_TCP_CS
+		},
+		.mss_shift	= TD0_MSS_SHIFT,
+		.opts_offset	= 0
+	},
+	[RTL_TD_1] = {
+		.checksum = {
+			.udp	= TD1_IP_CS | TD1_UDP_CS,
+			.tcp	= TD1_IP_CS | TD1_TCP_CS
+		},
+		.mss_shift	= TD1_MSS_SHIFT,
+		.opts_offset	= 1
+	}
+};
+
+enum rtl_rx_desc_bit {
+	/* Rx private */
+	PID1		= (1 << 18), /* Protocol ID bit 1/2 */
+	PID0		= (1 << 17), /* Protocol ID bit 2/2 */
+
+#define RxProtoUDP	(PID1)
+#define RxProtoTCP	(PID0)
+#define RxProtoIP	(PID1 | PID0)
+#define RxProtoMask	RxProtoIP
+
+	IPFail		= (1 << 16), /* IP checksum failed */
+	UDPFail		= (1 << 15), /* UDP/IP checksum failed */
+	TCPFail		= (1 << 14), /* TCP/IP checksum failed */
+	RxVlanTag	= (1 << 16), /* VLAN tag available */
+};
+
+#define RsvdMask	0x3fffc000
+
+struct TxDesc {
+	__le32 opts1;
+	__le32 opts2;
+	__le64 addr;
+};
+
+struct RxDesc {
+	__le32 opts1;
+	__le32 opts2;
+	__le64 addr;
+};
+
+struct ring_info {
+	struct sk_buff	*skb;
+	u32		len;
+	u8		__pad[sizeof(void *) - sizeof(u32)];
+};
+
+enum features {
+	RTL_FEATURE_WOL		= (1 << 0),
+	RTL_FEATURE_MSI		= (1 << 1),
+	RTL_FEATURE_GMII	= (1 << 2),
+};
+
+struct rtl8169_counters {
+	__le64	tx_packets;
+	__le64	rx_packets;
+	__le64	tx_errors;
+	__le32	rx_errors;
+	__le16	rx_missed;
+	__le16	align_errors;
+	__le32	tx_one_collision;
+	__le32	tx_multi_collision;
+	__le64	rx_unicast;
+	__le64	rx_broadcast;
+	__le32	rx_multicast;
+	__le16	tx_aborted;
+	__le16	tx_underun;
+};
+
+enum rtl_flag {
+	RTL_FLAG_TASK_ENABLED,
+	RTL_FLAG_TASK_SLOW_PENDING,
+	RTL_FLAG_TASK_RESET_PENDING,
+	RTL_FLAG_TASK_PHY_PENDING,
+	RTL_FLAG_MAX
+};
+
+struct rtl8169_stats {
+	u64			packets;
+	u64			bytes;
+	struct u64_stats_sync	syncp;
+};
+
+
+#ifdef RTL_PROC		
+static struct proc_dir_entry *rtw_proc;
+static u8 wol_enable=0;
+#endif	
+
+struct rtl8169_private {
+	void __iomem *mmio_addr;	/* memory map physical address */
+	struct platform_device *pdev;
+//	struct device *device;
+	struct net_device *dev;
+	struct napi_struct napi;
+	u32 msg_enable;
+	u16 txd_version;
+	u16 mac_version;
+	u32 cur_rx; /* Index into the Rx descriptor buffer of next Rx pkt. */
+	u32 cur_tx; /* Index into the Tx descriptor buffer of next Rx pkt. */
+	u32 dirty_tx;
+	struct rtl8169_stats rx_stats;
+	struct rtl8169_stats tx_stats;
+	struct TxDesc *TxDescArray;	/* 256-aligned Tx descriptor ring */
+	struct RxDesc *RxDescArray;	/* 256-aligned Rx descriptor ring */
+	dma_addr_t TxPhyAddr;
+	dma_addr_t RxPhyAddr;
+	void *Rx_databuff[NUM_RX_DESC];	/* Rx data buffers */
+	struct ring_info tx_skb[NUM_TX_DESC];	/* Tx data buffers */
+	struct timer_list timer;
+	u16 cp_cmd;
+
+	u16 event_slow;
+
+#ifdef RTL_PROC		
+	struct proc_dir_entry *dir_dev;	
+#endif
+
+	struct mdio_ops {
+		void (*write)(struct rtl8169_private *, int, int);
+		int (*read)(struct rtl8169_private *, int);
+	} mdio_ops;
+
+	struct pll_power_ops {
+		void (*down)(struct rtl8169_private *);
+		void (*up)(struct rtl8169_private *);
+	} pll_power_ops;
+
+	struct jumbo_ops {
+		void (*enable)(struct rtl8169_private *);
+		void (*disable)(struct rtl8169_private *);
+	} jumbo_ops;
+
+	struct csi_ops {
+		void (*write)(struct rtl8169_private *, int, int);
+		u32 (*read)(struct rtl8169_private *, int);
+	} csi_ops;
+
+	int (*set_speed)(struct net_device *, u8 aneg, u16 sp, u8 dpx, u32 adv);
+	int (*get_settings)(struct net_device *, struct ethtool_cmd *);
+	void (*phy_reset_enable)(struct rtl8169_private *tp);
+	void (*hw_start)(struct net_device *);
+	unsigned int (*phy_reset_pending)(struct rtl8169_private *tp);
+	unsigned int (*link_ok)(void __iomem *);
+	int (*do_ioctl)(struct rtl8169_private *tp, struct mii_ioctl_data *data, int cmd);
+
+	struct {
+		DECLARE_BITMAP(flags, RTL_FLAG_MAX);
+		struct mutex mutex;
+		struct work_struct work;
+	} wk;
+
+	unsigned features;
+
+	struct mii_if_info mii;
+	struct rtl8169_counters counters;
+	u32 saved_wolopts;
+	u32 opts1_mask;
+
+	struct rtl_fw {
+		const struct firmware *fw;
+
+#define RTL_VER_SIZE		32
+
+		char version[RTL_VER_SIZE];
+
+		struct rtl_fw_phy_action {
+			__le32 *code;
+			size_t size;
+		} phy_action;
+	} *rtl_fw;
+#define RTL_FIRMWARE_UNKNOWN	ERR_PTR(-EAGAIN)
+
+	u32 ocp_base;
+
+	    /* For link status change. */
+	struct task_struct *kthr;
+	wait_queue_head_t thr_wait;
+	int link_chg;
+};
+
+MODULE_AUTHOR("Realtek and the Linux r8169 crew <netdev@vger.kernel.org>");
+MODULE_DESCRIPTION("RealTek RTL-8169 Gigabit Ethernet driver");
+module_param(use_dac, int, 0);
+MODULE_PARM_DESC(use_dac, "Enable PCI DAC. Unsafe on 32 bit PCI slot.");
+module_param_named(debug, debug.msg_enable, int, 0);
+MODULE_PARM_DESC(debug, "Debug verbosity level (0=none, ..., 16=all)");
+MODULE_LICENSE("GPL");
+MODULE_VERSION(RTL8169_VERSION);
+MODULE_FIRMWARE(FIRMWARE_8168D_1);
+MODULE_FIRMWARE(FIRMWARE_8168D_2);
+MODULE_FIRMWARE(FIRMWARE_8168E_1);
+MODULE_FIRMWARE(FIRMWARE_8168E_2);
+MODULE_FIRMWARE(FIRMWARE_8168E_3);
+MODULE_FIRMWARE(FIRMWARE_8105E_1);
+MODULE_FIRMWARE(FIRMWARE_8168F_1);
+MODULE_FIRMWARE(FIRMWARE_8168F_2);
+MODULE_FIRMWARE(FIRMWARE_8402_1);
+MODULE_FIRMWARE(FIRMWARE_8411_1);
+MODULE_FIRMWARE(FIRMWARE_8106E_1);
+MODULE_FIRMWARE(FIRMWARE_8106E_2);
+MODULE_FIRMWARE(FIRMWARE_8168G_2);
+MODULE_FIRMWARE(FIRMWARE_8168G_3);
+
+static void rtl_lock_work(struct rtl8169_private *tp)
+{
+	mutex_lock(&tp->wk.mutex);
+}
+
+static void rtl_unlock_work(struct rtl8169_private *tp)
+{
+	mutex_unlock(&tp->wk.mutex);
+}
+
+static void rtl_tx_performance_tweak(struct platform_device *pdev, u16 force)
+{
+//	pcie_capability_clear_and_set_word(pdev, PCI_EXP_DEVCTL,
+//					   PCI_EXP_DEVCTL_READRQ, force);
+}
+
+struct rtl_cond {
+	bool (*check)(struct rtl8169_private *);
+	const char *msg;
+};
+
+static void rtl_udelay(unsigned int d)
+{
+	udelay(d);
+}
+
+static bool rtl_loop_wait(struct rtl8169_private *tp, const struct rtl_cond *c,
+			  void (*delay)(unsigned int), unsigned int d, int n,
+			  bool high)
+{
+	int i;
+
+	for (i = 0; i < n; i++) {
+		delay(d);
+		if (c->check(tp) == high)
+			return true;
+	}
+	netif_err(tp, drv, tp->dev, "%s == %d (loop: %d, delay: %d).\n",
+		  c->msg, !high, n, d);
+	return false;
+}
+
+static bool rtl_udelay_loop_wait_high(struct rtl8169_private *tp,
+				      const struct rtl_cond *c,
+				      unsigned int d, int n)
+{
+	return rtl_loop_wait(tp, c, rtl_udelay, d, n, true);
+}
+
+static bool rtl_udelay_loop_wait_low(struct rtl8169_private *tp,
+				     const struct rtl_cond *c,
+				     unsigned int d, int n)
+{
+	return rtl_loop_wait(tp, c, rtl_udelay, d, n, false);
+}
+
+static bool rtl_msleep_loop_wait_high(struct rtl8169_private *tp,
+				      const struct rtl_cond *c,
+				      unsigned int d, int n)
+{
+	return rtl_loop_wait(tp, c, msleep, d, n, true);
+}
+
+static bool rtl_msleep_loop_wait_low(struct rtl8169_private *tp,
+				     const struct rtl_cond *c,
+				     unsigned int d, int n)
+{
+	return rtl_loop_wait(tp, c, msleep, d, n, false);
+}
+
+#define DECLARE_RTL_COND(name)				\
+static bool name ## _check(struct rtl8169_private *);	\
+							\
+static const struct rtl_cond name = {			\
+	.check	= name ## _check,			\
+	.msg	= #name					\
+};							\
+							\
+static bool name ## _check(struct rtl8169_private *tp)
+
+DECLARE_RTL_COND(rtl_ocpar_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(OCPAR) & OCPAR_FLAG;
+}
+
+static u32 ocp_read(struct rtl8169_private *tp, u8 mask, u16 reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(OCPAR, ((u32)mask & 0x0f) << 12 | (reg & 0x0fff));
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_ocpar_cond, 100, 20) ?
+		RTL_R32(OCPDR) : ~0;
+}
+
+static void ocp_write(struct rtl8169_private *tp, u8 mask, u16 reg, u32 data)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(OCPDR, data);
+	RTL_W32(OCPAR, OCPAR_FLAG | ((u32)mask & 0x0f) << 12 | (reg & 0x0fff));
+
+	rtl_udelay_loop_wait_low(tp, &rtl_ocpar_cond, 100, 20);
+}
+
+DECLARE_RTL_COND(rtl_eriar_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(ERIAR) & ERIAR_FLAG;
+}
+
+static void rtl8168_oob_notify(struct rtl8169_private *tp, u8 cmd)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(ERIDR, cmd);
+	RTL_W32(ERIAR, 0x800010e8);
+	msleep(2);
+
+	if (!rtl_udelay_loop_wait_low(tp, &rtl_eriar_cond, 100, 5))
+		return;
+
+	ocp_write(tp, 0x1, 0x30, 0x00000001);
+}
+
+#define OOB_CMD_RESET		0x00
+#define OOB_CMD_DRIVER_START	0x05
+#define OOB_CMD_DRIVER_STOP	0x06
+
+static u16 rtl8168_get_ocp_reg(struct rtl8169_private *tp)
+{
+	return (tp->mac_version == RTL_GIGA_MAC_VER_31) ? 0xb8 : 0x10;
+}
+
+DECLARE_RTL_COND(rtl_ocp_read_cond)
+{
+	u16 reg;
+
+	reg = rtl8168_get_ocp_reg(tp);
+
+	return ocp_read(tp, 0x0f, reg) & 0x00000800;
+}
+
+static void rtl8168_driver_start(struct rtl8169_private *tp)
+{
+	rtl8168_oob_notify(tp, OOB_CMD_DRIVER_START);
+
+	rtl_msleep_loop_wait_high(tp, &rtl_ocp_read_cond, 10, 10);
+}
+
+static void rtl8168_driver_stop(struct rtl8169_private *tp)
+{
+	rtl8168_oob_notify(tp, OOB_CMD_DRIVER_STOP);
+
+	rtl_msleep_loop_wait_low(tp, &rtl_ocp_read_cond, 10, 10);
+}
+
+static int r8168dp_check_dash(struct rtl8169_private *tp)
+{
+	u16 reg = rtl8168_get_ocp_reg(tp);
+
+	return (ocp_read(tp, 0x0f, reg) & 0x00008000) ? 1 : 0;
+}
+
+static bool rtl_ocp_reg_failure(struct rtl8169_private *tp, u32 reg)
+{
+	if (reg & 0xffff0001) {
+		netif_err(tp, drv, tp->dev, "Invalid ocp reg %x!\n", reg);
+		return true;
+	}
+	return false;
+}
+
+DECLARE_RTL_COND(rtl_ocp_gphy_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(GPHY_OCP) & OCPAR_FLAG;
+}
+
+static void r8168_phy_ocp_write(struct rtl8169_private *tp, u32 reg, u32 data)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (rtl_ocp_reg_failure(tp, reg))
+		return;
+
+	RTL_W32(GPHY_OCP, OCPAR_FLAG | (reg << 15) | data);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_ocp_gphy_cond, 25, 10);
+}
+
+static u16 r8168_phy_ocp_read(struct rtl8169_private *tp, u32 reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (rtl_ocp_reg_failure(tp, reg))
+		return 0;
+
+	RTL_W32(GPHY_OCP, reg << 15);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_ocp_gphy_cond, 25, 10) ?
+		(RTL_R32(GPHY_OCP) & 0xffff) : ~0;
+}
+
+static void r8168_mac_ocp_write(struct rtl8169_private *tp, u32 reg, u32 data)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (rtl_ocp_reg_failure(tp, reg))
+		return;
+
+	RTL_W32(OCPDR, OCPAR_FLAG | (reg << 15) | data);
+}
+
+static u16 r8168_mac_ocp_read(struct rtl8169_private *tp, u32 reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (rtl_ocp_reg_failure(tp, reg))
+		return 0;
+
+	RTL_W32(OCPDR, reg << 15);
+
+	return RTL_R32(OCPDR);
+}
+
+#define OCP_STD_PHY_BASE	0xa400
+
+static __maybe_unused void r8168g_mdio_write(struct rtl8169_private *tp, int reg, int value)
+{
+	if (reg == 0x1f) {
+		tp->ocp_base = value ? value << 4 : OCP_STD_PHY_BASE;
+		return;
+	}
+
+	if (tp->ocp_base != OCP_STD_PHY_BASE)
+		reg -= 0x10;
+
+	r8168_phy_ocp_write(tp, tp->ocp_base + reg * 2, value);
+}
+
+static __maybe_unused int r8168g_mdio_read(struct rtl8169_private *tp, int reg)
+{
+	if (tp->ocp_base != OCP_STD_PHY_BASE)
+		reg -= 0x10;
+
+	return r8168_phy_ocp_read(tp, tp->ocp_base + reg * 2);
+}
+
+static __maybe_unused void mac_mcu_write(struct rtl8169_private *tp, int reg, int value)
+{
+	if (reg == 0x1f) {
+		tp->ocp_base = value << 4;
+		return;
+	}
+
+	r8168_mac_ocp_write(tp, tp->ocp_base + reg, value);
+}
+
+static __maybe_unused int mac_mcu_read(struct rtl8169_private *tp, int reg)
+{
+	return r8168_mac_ocp_read(tp, tp->ocp_base + reg);
+}
+
+DECLARE_RTL_COND(rtl_phyar_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(PHYAR) & 0x80000000;
+}
+
+static void r8169_mdio_write(struct rtl8169_private *tp, int reg, int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(PHYAR, 0x80000000 | (reg & 0x1f) << 16 | (value & 0xffff));
+
+	rtl_udelay_loop_wait_low(tp, &rtl_phyar_cond, 25, 20);
+	/*
+	 * According to hardware specs a 20us delay is required after write
+	 * complete indication, but before sending next command.
+	 */
+	udelay(20);
+}
+
+static int r8169_mdio_read(struct rtl8169_private *tp, int reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	int value;
+
+	RTL_W32(PHYAR, 0x0 | (reg & 0x1f) << 16);
+
+	value = rtl_udelay_loop_wait_high(tp, &rtl_phyar_cond, 25, 20) ?
+		RTL_R32(PHYAR) & 0xffff : ~0;
+
+	/*
+	 * According to hardware specs a 20us delay is required after read
+	 * complete indication, but before sending next command.
+	 */
+	udelay(20);
+
+	return value;
+}
+
+static void r8168dp_1_mdio_access(struct rtl8169_private *tp, int reg, u32 data)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(OCPDR, data | ((reg & OCPDR_REG_MASK) << OCPDR_GPHY_REG_SHIFT));
+	RTL_W32(OCPAR, OCPAR_GPHY_WRITE_CMD);
+	RTL_W32(EPHY_RXER_NUM, 0);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_ocpar_cond, 1000, 100);
+}
+
+static void r8168dp_1_mdio_write(struct rtl8169_private *tp, int reg, int value)
+{
+	r8168dp_1_mdio_access(tp, reg,
+			      OCPDR_WRITE_CMD | (value & OCPDR_DATA_MASK));
+}
+
+static int r8168dp_1_mdio_read(struct rtl8169_private *tp, int reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	r8168dp_1_mdio_access(tp, reg, OCPDR_READ_CMD);
+
+	mdelay(1);
+	RTL_W32(OCPAR, OCPAR_GPHY_READ_CMD);
+	RTL_W32(EPHY_RXER_NUM, 0);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_ocpar_cond, 1000, 100) ?
+		RTL_R32(OCPDR) & OCPDR_DATA_MASK : ~0;
+}
+
+#define R8168DP_1_MDIO_ACCESS_BIT	0x00020000
+
+static void r8168dp_2_mdio_start(void __iomem *ioaddr)
+{
+	RTL_W32(0xd0, RTL_R32(0xd0) & ~R8168DP_1_MDIO_ACCESS_BIT);
+}
+
+static void r8168dp_2_mdio_stop(void __iomem *ioaddr)
+{
+	RTL_W32(0xd0, RTL_R32(0xd0) | R8168DP_1_MDIO_ACCESS_BIT);
+}
+
+static void r8168dp_2_mdio_write(struct rtl8169_private *tp, int reg, int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	r8168dp_2_mdio_start(ioaddr);
+
+	r8169_mdio_write(tp, reg, value);
+
+	r8168dp_2_mdio_stop(ioaddr);
+}
+
+static int r8168dp_2_mdio_read(struct rtl8169_private *tp, int reg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	int value;
+
+	r8168dp_2_mdio_start(ioaddr);
+
+	value = r8169_mdio_read(tp, reg);
+
+	r8168dp_2_mdio_stop(ioaddr);
+
+	return value;
+}
+
+static void rtl_writephy(struct rtl8169_private *tp, int location, u32 val)
+{
+	tp->mdio_ops.write(tp, location, val);
+}
+
+static int rtl_readphy(struct rtl8169_private *tp, int location)
+{
+	return tp->mdio_ops.read(tp, location);
+}
+
+static void rtl_patchphy(struct rtl8169_private *tp, int reg_addr, int value)
+{
+	rtl_writephy(tp, reg_addr, rtl_readphy(tp, reg_addr) | value);
+}
+
+static void rtl_w1w0_phy(struct rtl8169_private *tp, int reg_addr, int p, int m)
+{
+	int val;
+
+	val = rtl_readphy(tp, reg_addr);
+	rtl_writephy(tp, reg_addr, (val | p) & ~m);
+}
+
+static void rtl_mdio_write(struct net_device *dev, int phy_id, int location,
+			   int val)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl_writephy(tp, location, val);
+}
+
+static int rtl_mdio_read(struct net_device *dev, int phy_id, int location)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	return rtl_readphy(tp, location);
+}
+
+DECLARE_RTL_COND(rtl_ephyar_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(EPHYAR) & EPHYAR_FLAG;
+}
+
+static void rtl_ephy_write(struct rtl8169_private *tp, int reg_addr, int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(EPHYAR, EPHYAR_WRITE_CMD | (value & EPHYAR_DATA_MASK) |
+		(reg_addr & EPHYAR_REG_MASK) << EPHYAR_REG_SHIFT);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_ephyar_cond, 10, 100);
+
+	udelay(10);
+}
+
+static u16 rtl_ephy_read(struct rtl8169_private *tp, int reg_addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(EPHYAR, (reg_addr & EPHYAR_REG_MASK) << EPHYAR_REG_SHIFT);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_ephyar_cond, 10, 100) ?
+		RTL_R32(EPHYAR) & EPHYAR_DATA_MASK : ~0;
+}
+
+static void rtl_eri_write(struct rtl8169_private *tp, int addr, u32 mask,
+			  u32 val, int type)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	BUG_ON((addr & 3) || (mask == 0));
+	RTL_W32(ERIDR, val);
+	RTL_W32(ERIAR, ERIAR_WRITE_CMD | type | mask | addr);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_eriar_cond, 100, 100);
+}
+
+static u32 rtl_eri_read(struct rtl8169_private *tp, int addr, int type)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(ERIAR, ERIAR_READ_CMD | type | ERIAR_MASK_1111 | addr);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_eriar_cond, 100, 100) ?
+		RTL_R32(ERIDR) : ~0;
+}
+
+static void rtl_w1w0_eri(struct rtl8169_private *tp, int addr, u32 mask, u32 p,
+			 u32 m, int type)
+{
+	u32 val;
+
+	val = rtl_eri_read(tp, addr, type);
+	rtl_eri_write(tp, addr, mask, (val & ~m) | p, type);
+}
+
+struct exgmac_reg {
+	u16 addr;
+	u16 mask;
+	u32 val;
+};
+
+static void rtl_write_exgmac_batch(struct rtl8169_private *tp,
+				   const struct exgmac_reg *r, int len)
+{
+	while (len-- > 0) {
+		rtl_eri_write(tp, r->addr, r->mask, r->val, ERIAR_EXGMAC);
+		r++;
+	}
+}
+
+DECLARE_RTL_COND(rtl_efusear_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(EFUSEAR) & EFUSEAR_FLAG;
+}
+
+static u8 rtl8168d_efuse_read(struct rtl8169_private *tp, int reg_addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(EFUSEAR, (reg_addr & EFUSEAR_REG_MASK) << EFUSEAR_REG_SHIFT);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_efusear_cond, 100, 300) ?
+		RTL_R32(EFUSEAR) & EFUSEAR_DATA_MASK : ~0;
+}
+
+static u16 rtl_get_events(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R16(IntrStatus);
+}
+
+static void rtl_ack_events(struct rtl8169_private *tp, u16 bits)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W16(IntrStatus, bits);
+	mmiowb();
+}
+
+static void rtl_irq_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W16(IntrMask, 0);
+	mmiowb();
+}
+
+static void rtl_irq_enable(struct rtl8169_private *tp, u16 bits)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W16(IntrMask, bits);
+}
+
+#define RTL_EVENT_NAPI_RX	(RxOK | RxErr)
+#define RTL_EVENT_NAPI_TX	(TxOK | TxErr)
+#define RTL_EVENT_NAPI		(RTL_EVENT_NAPI_RX | RTL_EVENT_NAPI_TX)
+
+static void rtl_irq_enable_all(struct rtl8169_private *tp)
+{
+	rtl_irq_enable(tp, RTL_EVENT_NAPI | tp->event_slow);
+}
+
+static void rtl8169_irq_mask_and_ack(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	rtl_irq_disable(tp);
+	rtl_ack_events(tp, RTL_EVENT_NAPI | tp->event_slow);
+	RTL_R8(ChipCmd);
+}
+
+static unsigned int rtl8169_tbi_reset_pending(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(TBICSR) & TBIReset;
+}
+
+static unsigned int rtl8169_xmii_reset_pending(struct rtl8169_private *tp)
+{
+	return rtl_readphy(tp, MII_BMCR) & BMCR_RESET;
+}
+
+static unsigned int rtl8169_tbi_link_ok(void __iomem *ioaddr)
+{
+	return RTL_R32(TBICSR) & TBILinkOk;
+}
+
+static unsigned int rtl8169_xmii_link_ok(void __iomem *ioaddr)
+{
+	return RTL_R8(PHYstatus) & LinkStatus;
+}
+
+static void rtl8169_tbi_reset_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(TBICSR, RTL_R32(TBICSR) | TBIReset);
+}
+
+static void rtl8169_xmii_reset_enable(struct rtl8169_private *tp)
+{
+	unsigned int val;
+
+	val = rtl_readphy(tp, MII_BMCR) | BMCR_RESET;
+	rtl_writephy(tp, MII_BMCR, val & 0xffff);
+}
+
+static void rtl_link_chg_patch(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct net_device *dev = tp->dev;
+
+	if (!netif_running(dev))
+		return;
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_34 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_38) {
+		if (RTL_R8(PHYstatus) & _1000bpsF) {
+			rtl_eri_write(tp, 0x1bc, ERIAR_MASK_1111, 0x00000011,
+				      ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_1111, 0x00000005,
+				      ERIAR_EXGMAC);
+		} else if (RTL_R8(PHYstatus) & _100bps) {
+			rtl_eri_write(tp, 0x1bc, ERIAR_MASK_1111, 0x0000001f,
+				      ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_1111, 0x00000005,
+				      ERIAR_EXGMAC);
+		} else {
+			rtl_eri_write(tp, 0x1bc, ERIAR_MASK_1111, 0x0000001f,
+				      ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_1111, 0x0000003f,
+				      ERIAR_EXGMAC);
+		}
+		/* Reset packet filter */
+		rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x00, 0x01,
+			     ERIAR_EXGMAC);
+		rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x01, 0x00,
+			     ERIAR_EXGMAC);
+	} else if (tp->mac_version == RTL_GIGA_MAC_VER_35 ||
+		   tp->mac_version == RTL_GIGA_MAC_VER_36) {
+		if (RTL_R8(PHYstatus) & _1000bpsF) {
+			rtl_eri_write(tp, 0x1bc, ERIAR_MASK_1111, 0x00000011,
+				      ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_1111, 0x00000005,
+				      ERIAR_EXGMAC);
+		} else {
+			rtl_eri_write(tp, 0x1bc, ERIAR_MASK_1111, 0x0000001f,
+				      ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_1111, 0x0000003f,
+				      ERIAR_EXGMAC);
+		}
+	} else if (tp->mac_version == RTL_GIGA_MAC_VER_37) {
+		if (RTL_R8(PHYstatus) & _10bps) {
+			rtl_eri_write(tp, 0x1d0, ERIAR_MASK_0011, 0x4d02,
+				      ERIAR_EXGMAC);
+			rtl_eri_write(tp, 0x1dc, ERIAR_MASK_0011, 0x0060,
+				      ERIAR_EXGMAC);
+		} else {
+			rtl_eri_write(tp, 0x1d0, ERIAR_MASK_0011, 0x0000,
+				      ERIAR_EXGMAC);
+		}
+	}
+}
+
+static void __rtl8169_check_link_status(struct net_device *dev,
+					struct rtl8169_private *tp,
+					void __iomem *ioaddr, bool pm)
+{
+	if (tp->link_ok(ioaddr)) {
+		rtl_link_chg_patch(tp);
+		/* This is to cancel a scheduled suspend if there's one. */
+		if (pm)
+			pm_request_resume(&tp->pdev->dev);
+		netif_carrier_on(dev);
+		if (net_ratelimit())
+			netif_info(tp, ifup, dev, "link up\n");
+	} else {
+		netif_carrier_off(dev);
+		netif_info(tp, ifdown, dev, "link down\n");
+		if (pm)
+			pm_schedule_suspend(&tp->pdev->dev, 5000);
+	}
+}
+
+static void rtl8169_check_link_status(struct net_device *dev,
+				      struct rtl8169_private *tp,
+				      void __iomem *ioaddr)
+{
+	__rtl8169_check_link_status(dev, tp, ioaddr, false);
+}
+
+#define WAKE_ANY (WAKE_PHY | WAKE_MAGIC | WAKE_UCAST | WAKE_BCAST | WAKE_MCAST)
+
+static u32 __rtl8169_get_wol(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	u8 options;
+	u32 wolopts = 0;
+
+	options = RTL_R8(Config1);
+	if (!(options & PMEnable))
+		return 0;
+
+	options = RTL_R8(Config3);
+	if (options & LinkUp)
+		wolopts |= WAKE_PHY;
+	if (options & MagicPacket)
+		wolopts |= WAKE_MAGIC;
+
+	options = RTL_R8(Config5);
+	if (options & UWF)
+		wolopts |= WAKE_UCAST;
+	if (options & BWF)
+		wolopts |= WAKE_BCAST;
+	if (options & MWF)
+		wolopts |= WAKE_MCAST;
+
+	return wolopts;
+}
+
+static void rtl8169_get_wol(struct net_device *dev, struct ethtool_wolinfo *wol)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl_lock_work(tp);
+
+	wol->supported = WAKE_ANY;
+	wol->wolopts = __rtl8169_get_wol(tp);
+
+	rtl_unlock_work(tp);
+}
+
+static void __rtl8169_set_wol(struct rtl8169_private *tp, u32 wolopts)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	unsigned int i;
+	static const struct {
+		u32 opt;
+		u16 reg;
+		u8  mask;
+	} cfg[] = {
+		{ WAKE_PHY,   Config3, LinkUp },
+		{ WAKE_MAGIC, Config3, MagicPacket },
+		{ WAKE_UCAST, Config5, UWF },
+		{ WAKE_BCAST, Config5, BWF },
+		{ WAKE_MCAST, Config5, MWF },
+		{ WAKE_ANY,   Config5, LanWake }
+	};
+	u8 options;
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	for (i = 0; i < ARRAY_SIZE(cfg); i++) {
+		options = RTL_R8(cfg[i].reg) & ~cfg[i].mask;
+		if (wolopts & cfg[i].opt)
+			options |= cfg[i].mask;
+		RTL_W8(cfg[i].reg, options);
+	}
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_01 ... RTL_GIGA_MAC_VER_17:
+		options = RTL_R8(Config1) & ~PMEnable;
+		if (wolopts)
+			options |= PMEnable;
+		RTL_W8(Config1, options);
+		break;
+	default:
+		options = RTL_R8(Config2) & ~PME_SIGNAL;
+		if (wolopts)
+			options |= PME_SIGNAL;
+		RTL_W8(Config2, options);
+		break;
+	}
+
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+}
+
+static int rtl8169_set_wol(struct net_device *dev, struct ethtool_wolinfo *wol)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl_lock_work(tp);
+
+	if (wol->wolopts)
+		tp->features |= RTL_FEATURE_WOL;
+	else
+		tp->features &= ~RTL_FEATURE_WOL;
+	__rtl8169_set_wol(tp, wol->wolopts);
+
+	rtl_unlock_work(tp);
+
+	device_set_wakeup_enable(&tp->pdev->dev, wol->wolopts);
+
+	return 0;
+}
+
+static const char *rtl_lookup_firmware_name(struct rtl8169_private *tp)
+{
+	return rtl_chip_infos[tp->mac_version].fw_name;
+}
+
+static void rtl8169_get_drvinfo(struct net_device *dev,
+				struct ethtool_drvinfo *info)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	struct rtl_fw *rtl_fw = tp->rtl_fw;
+
+	strlcpy(info->driver, MODULENAME, sizeof(info->driver));
+	strlcpy(info->version, RTL8169_VERSION, sizeof(info->version));
+	strlcpy(info->bus_info, "RTK119X-ETN", sizeof(info->bus_info));
+	BUILD_BUG_ON(sizeof(info->fw_version) < sizeof(rtl_fw->version));
+	if (!IS_ERR_OR_NULL(rtl_fw))
+		strlcpy(info->fw_version, rtl_fw->version,
+			sizeof(info->fw_version));
+}
+
+static int rtl8169_get_regs_len(struct net_device *dev)
+{
+	return R8169_REGS_SIZE;
+}
+
+static int rtl8169_set_speed_tbi(struct net_device *dev,
+				 u8 autoneg, u16 speed, u8 duplex, u32 ignored)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	int ret = 0;
+	u32 reg;
+
+	reg = RTL_R32(TBICSR);
+	if ((autoneg == AUTONEG_DISABLE) && (speed == SPEED_1000) &&
+	    (duplex == DUPLEX_FULL)) {
+		RTL_W32(TBICSR, reg & ~(TBINwEnable | TBINwRestart));
+	} else if (autoneg == AUTONEG_ENABLE)
+		RTL_W32(TBICSR, reg | TBINwEnable | TBINwRestart);
+	else {
+		netif_warn(tp, link, dev,
+			   "incorrect speed setting refused in TBI mode\n");
+		ret = -EOPNOTSUPP;
+	}
+
+	return ret;
+}
+
+static int rtl8169_set_speed_xmii(struct net_device *dev,
+				  u8 autoneg, u16 speed, u8 duplex, u32 adv)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int giga_ctrl, bmcr;
+	int rc = -EINVAL;
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	if (autoneg == AUTONEG_ENABLE) {
+		int auto_nego;
+
+		auto_nego = rtl_readphy(tp, MII_ADVERTISE);
+		auto_nego &= ~(ADVERTISE_10HALF | ADVERTISE_10FULL |
+				ADVERTISE_100HALF | ADVERTISE_100FULL);
+
+		if (adv & ADVERTISED_10baseT_Half)
+			auto_nego |= ADVERTISE_10HALF;
+		if (adv & ADVERTISED_10baseT_Full)
+			auto_nego |= ADVERTISE_10FULL;
+		if (adv & ADVERTISED_100baseT_Half)
+			auto_nego |= ADVERTISE_100HALF;
+		if (adv & ADVERTISED_100baseT_Full)
+			auto_nego |= ADVERTISE_100FULL;
+
+		auto_nego |= ADVERTISE_PAUSE_CAP | ADVERTISE_PAUSE_ASYM;
+
+		giga_ctrl = rtl_readphy(tp, MII_CTRL1000);
+		giga_ctrl &= ~(ADVERTISE_1000FULL | ADVERTISE_1000HALF);
+
+		/* The 8100e/8101e/8102e do Fast Ethernet only. */
+		if (tp->mii.supports_gmii) {
+			if (adv & ADVERTISED_1000baseT_Half)
+				giga_ctrl |= ADVERTISE_1000HALF;
+			if (adv & ADVERTISED_1000baseT_Full)
+				giga_ctrl |= ADVERTISE_1000FULL;
+		} else if (adv & (ADVERTISED_1000baseT_Half |
+				  ADVERTISED_1000baseT_Full)) {
+			netif_info(tp, link, dev,
+				   "PHY does not support 1000Mbps\n");
+			goto out;
+		}
+
+		bmcr = BMCR_ANENABLE | BMCR_ANRESTART;
+
+		rtl_writephy(tp, MII_ADVERTISE, auto_nego);
+		rtl_writephy(tp, MII_CTRL1000, giga_ctrl);
+	} else {
+		giga_ctrl = 0;
+
+		if (speed == SPEED_10)
+			bmcr = 0;
+		else if (speed == SPEED_100)
+			bmcr = BMCR_SPEED100;
+		else
+			goto out;
+
+		if (duplex == DUPLEX_FULL)
+			bmcr |= BMCR_FULLDPLX;
+	}
+
+	rtl_writephy(tp, MII_BMCR, bmcr);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_02 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_03) {
+		if ((speed == SPEED_100) && (autoneg != AUTONEG_ENABLE)) {
+			rtl_writephy(tp, 0x17, 0x2138);
+			rtl_writephy(tp, 0x0e, 0x0260);
+		} else {
+			rtl_writephy(tp, 0x17, 0x2108);
+			rtl_writephy(tp, 0x0e, 0x0000);
+		}
+	}
+
+	rc = 0;
+out:
+	return rc;
+}
+
+static int rtl8169_set_speed(struct net_device *dev,
+			     u8 autoneg, u16 speed, u8 duplex, u32 advertising)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int ret;
+
+	ret = tp->set_speed(dev, autoneg, speed, duplex, advertising);
+	if (ret < 0)
+		goto out;
+	
+	if (netif_running(dev)) {
+		mod_timer(&tp->timer, jiffies + RTL8169_PHY_TIMEOUT);
+	}
+out:
+	return ret;
+}
+
+static int rtl8169_set_settings(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int ret;
+
+	del_timer_sync(&tp->timer);
+
+	rtl_lock_work(tp);
+	ret = rtl8169_set_speed(dev, cmd->autoneg, ethtool_cmd_speed(cmd),
+				cmd->duplex, cmd->advertising);
+	rtl_unlock_work(tp);
+
+	return ret;
+}
+
+static netdev_features_t rtl8169_fix_features(struct net_device *dev,
+	netdev_features_t features)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (dev->mtu > TD_MSS_MAX)
+		features &= ~NETIF_F_ALL_TSO;
+
+	if (dev->mtu > JUMBO_1K &&
+	    !rtl_chip_infos[tp->mac_version].jumbo_tx_csum)
+		features &= ~NETIF_F_IP_CSUM;
+
+	return features;
+}
+
+static void __rtl8169_set_features(struct net_device *dev,
+				   netdev_features_t features)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	netdev_features_t changed = features ^ dev->features;
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (!(changed & (NETIF_F_RXALL | NETIF_F_RXCSUM |
+			 NETIF_F_HW_VLAN_CTAG_RX)))
+		return;
+
+	if (changed & (NETIF_F_RXCSUM | NETIF_F_HW_VLAN_CTAG_RX)) {
+		if (features & NETIF_F_RXCSUM)
+			tp->cp_cmd |= RxChkSum;
+		else
+			tp->cp_cmd &= ~RxChkSum;
+
+		if (dev->features & NETIF_F_HW_VLAN_CTAG_RX)
+			tp->cp_cmd |= RxVlan;
+		else
+			tp->cp_cmd &= ~RxVlan;
+
+		RTL_W16(CPlusCmd, tp->cp_cmd);
+		RTL_R16(CPlusCmd);
+	}
+	if (changed & NETIF_F_RXALL) {
+		int tmp = (RTL_R32(RxConfig) & ~(AcceptErr | AcceptRunt));
+		if (features & NETIF_F_RXALL)
+			tmp |= (AcceptErr | AcceptRunt);
+		RTL_W32(RxConfig, tmp);
+	}
+}
+
+static int rtl8169_set_features(struct net_device *dev,
+				netdev_features_t features)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl_lock_work(tp);
+	__rtl8169_set_features(dev, features);
+	rtl_unlock_work(tp);
+
+	return 0;
+}
+
+
+static inline u32 rtl8169_tx_vlan_tag(struct sk_buff *skb)
+{
+	return (skb_vlan_tag_present(skb)) ?
+		TxVlanTag | swab16(skb_vlan_tag_get(skb)) : 0x00;
+}
+
+static void rtl8169_rx_vlan_tag(struct RxDesc *desc, struct sk_buff *skb)
+{
+	u32 opts2 = le32_to_cpu(desc->opts2);
+
+	if (opts2 & RxVlanTag)
+		__vlan_hwaccel_put_tag(skb, htons(ETH_P_8021Q), swab16(opts2 & 0xffff));
+}
+
+static int rtl8169_gset_tbi(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	u32 status;
+
+	cmd->supported =
+		SUPPORTED_1000baseT_Full | SUPPORTED_Autoneg | SUPPORTED_FIBRE;
+	cmd->port = PORT_FIBRE;
+	cmd->transceiver = XCVR_INTERNAL;
+
+	status = RTL_R32(TBICSR);
+	cmd->advertising = (status & TBINwEnable) ?  ADVERTISED_Autoneg : 0;
+	cmd->autoneg = !!(status & TBINwEnable);
+
+	ethtool_cmd_speed_set(cmd, SPEED_1000);
+	cmd->duplex = DUPLEX_FULL; /* Always set */
+
+	return 0;
+}
+
+static int rtl8169_gset_xmii(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	return mii_ethtool_gset(&tp->mii, cmd);
+}
+
+static int rtl8169_get_settings(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int rc;
+
+	rtl_lock_work(tp);
+	rc = tp->get_settings(dev, cmd);
+	rtl_unlock_work(tp);
+
+	return rc;
+}
+
+static void rtl8169_get_regs(struct net_device *dev, struct ethtool_regs *regs,
+			     void *p)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (regs->len > R8169_REGS_SIZE)
+		regs->len = R8169_REGS_SIZE;
+
+	rtl_lock_work(tp);
+	memcpy_fromio(p, tp->mmio_addr, regs->len);
+	rtl_unlock_work(tp);
+}
+
+static u32 rtl8169_get_msglevel(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	return tp->msg_enable;
+}
+
+static void rtl8169_set_msglevel(struct net_device *dev, u32 value)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	tp->msg_enable = value;
+}
+
+static const char rtl8169_gstrings[][ETH_GSTRING_LEN] = {
+	"tx_packets",
+	"rx_packets",
+	"tx_errors",
+	"rx_errors",
+	"rx_missed",
+	"align_errors",
+	"tx_single_collisions",
+	"tx_multi_collisions",
+	"unicast",
+	"broadcast",
+	"multicast",
+	"tx_aborted",
+	"tx_underrun",
+};
+
+static int rtl8169_get_sset_count(struct net_device *dev, int sset)
+{
+	switch (sset) {
+	case ETH_SS_STATS:
+		return ARRAY_SIZE(rtl8169_gstrings);
+	default:
+		return -EOPNOTSUPP;
+	}
+}
+
+DECLARE_RTL_COND(rtl_counters_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(CounterAddrLow) & CounterDump;
+}
+
+static void rtl8169_update_counters(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct device *d = &tp->pdev->dev;
+	struct rtl8169_counters *counters;
+	dma_addr_t paddr;
+	u32 cmd;
+
+	/*
+	 * Some chips are unable to dump tally counters when the receiver
+	 * is disabled.
+	 */
+	if ((RTL_R8(ChipCmd) & CmdRxEnb) == 0)
+		return;
+
+	counters = dma_alloc_coherent(d, sizeof(*counters), &paddr, GFP_KERNEL);
+	if (!counters)
+		return;
+
+	RTL_W32(CounterAddrHigh, (u64)paddr >> 32);
+	cmd = (u64)paddr & DMA_BIT_MASK(32);
+	RTL_W32(CounterAddrLow, cmd);
+	RTL_W32(CounterAddrLow, cmd | CounterDump);
+
+	if (rtl_udelay_loop_wait_low(tp, &rtl_counters_cond, 10, 1000))
+		memcpy(&tp->counters, counters, sizeof(*counters));
+
+	RTL_W32(CounterAddrLow, 0);
+	RTL_W32(CounterAddrHigh, 0);
+
+	dma_free_coherent(d, sizeof(*counters), counters, paddr);
+}
+
+static void rtl8169_get_ethtool_stats(struct net_device *dev,
+				      struct ethtool_stats *stats, u64 *data)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	ASSERT_RTNL();
+
+	rtl8169_update_counters(dev);
+
+	data[0] = le64_to_cpu(tp->counters.tx_packets);
+	data[1] = le64_to_cpu(tp->counters.rx_packets);
+	data[2] = le64_to_cpu(tp->counters.tx_errors);
+	data[3] = le32_to_cpu(tp->counters.rx_errors);
+	data[4] = le16_to_cpu(tp->counters.rx_missed);
+	data[5] = le16_to_cpu(tp->counters.align_errors);
+	data[6] = le32_to_cpu(tp->counters.tx_one_collision);
+	data[7] = le32_to_cpu(tp->counters.tx_multi_collision);
+	data[8] = le64_to_cpu(tp->counters.rx_unicast);
+	data[9] = le64_to_cpu(tp->counters.rx_broadcast);
+	data[10] = le32_to_cpu(tp->counters.rx_multicast);
+	data[11] = le16_to_cpu(tp->counters.tx_aborted);
+	data[12] = le16_to_cpu(tp->counters.tx_underun);
+}
+
+static void rtl8169_get_strings(struct net_device *dev, u32 stringset, u8 *data)
+{
+	switch(stringset) {
+	case ETH_SS_STATS:
+		memcpy(data, *rtl8169_gstrings, sizeof(rtl8169_gstrings));
+		break;
+	}
+}
+
+static const struct ethtool_ops rtl8169_ethtool_ops = {
+	.get_drvinfo		= rtl8169_get_drvinfo,
+	.get_regs_len		= rtl8169_get_regs_len,
+	.get_link		= ethtool_op_get_link,
+	.get_settings		= rtl8169_get_settings,
+	.set_settings		= rtl8169_set_settings,
+	.get_msglevel		= rtl8169_get_msglevel,
+	.set_msglevel		= rtl8169_set_msglevel,
+	.get_regs		= rtl8169_get_regs,
+	.get_wol		= rtl8169_get_wol,
+	.set_wol		= rtl8169_set_wol,
+	.get_strings		= rtl8169_get_strings,
+	.get_sset_count		= rtl8169_get_sset_count,
+	.get_ethtool_stats	= rtl8169_get_ethtool_stats,
+	.get_ts_info		= ethtool_op_get_ts_info,
+};
+
+static void rtl8169_get_mac_version(struct rtl8169_private *tp,
+				    struct net_device *dev, u8 default_version)
+{
+//	void __iomem *ioaddr = tp->mmio_addr;
+	/*
+	 * The driver currently handles the 8168Bf and the 8168Be identically
+	 * but they can be identified more specifically through the test below
+	 * if needed:
+	 *
+	 * (RTL_R32(TxConfig) & 0x700000) == 0x500000 ? 8168Bf : 8168Be
+	 *
+	 * Same thing for the 8101Eb and the 8101Ec:
+	 *
+	 * (RTL_R32(TxConfig) & 0x700000) == 0x200000 ? 8101Eb : 8101Ec
+	 */
+#if 0
+	static const struct rtl_mac_info {
+		u32 mask;
+		u32 val;
+		int mac_version;
+	} mac_info[] = {
+		/* 8168G family. */
+		{ 0x7cf00000, 0x50900000,	RTL_GIGA_MAC_VER_42 },
+		{ 0x7cf00000, 0x4c100000,	RTL_GIGA_MAC_VER_41 },
+		{ 0x7cf00000, 0x4c000000,	RTL_GIGA_MAC_VER_40 },
+
+		/* 8168F family. */
+		{ 0x7c800000, 0x48800000,	RTL_GIGA_MAC_VER_38 },
+		{ 0x7cf00000, 0x48100000,	RTL_GIGA_MAC_VER_36 },
+		{ 0x7cf00000, 0x48000000,	RTL_GIGA_MAC_VER_35 },
+
+		/* 8168E family. */
+		{ 0x7c800000, 0x2c800000,	RTL_GIGA_MAC_VER_34 },
+		{ 0x7cf00000, 0x2c200000,	RTL_GIGA_MAC_VER_33 },
+		{ 0x7cf00000, 0x2c100000,	RTL_GIGA_MAC_VER_32 },
+		{ 0x7c800000, 0x2c000000,	RTL_GIGA_MAC_VER_33 },
+
+		/* 8168D family. */
+		{ 0x7cf00000, 0x28300000,	RTL_GIGA_MAC_VER_26 },
+		{ 0x7cf00000, 0x28100000,	RTL_GIGA_MAC_VER_25 },
+		{ 0x7c800000, 0x28000000,	RTL_GIGA_MAC_VER_26 },
+
+		/* 8168DP family. */
+		{ 0x7cf00000, 0x28800000,	RTL_GIGA_MAC_VER_27 },
+		{ 0x7cf00000, 0x28a00000,	RTL_GIGA_MAC_VER_28 },
+		{ 0x7cf00000, 0x28b00000,	RTL_GIGA_MAC_VER_31 },
+
+		/* 8168C family. */
+		{ 0x7cf00000, 0x3cb00000,	RTL_GIGA_MAC_VER_24 },
+		{ 0x7cf00000, 0x3c900000,	RTL_GIGA_MAC_VER_23 },
+		{ 0x7cf00000, 0x3c800000,	RTL_GIGA_MAC_VER_18 },
+		{ 0x7c800000, 0x3c800000,	RTL_GIGA_MAC_VER_24 },
+		{ 0x7cf00000, 0x3c000000,	RTL_GIGA_MAC_VER_19 },
+		{ 0x7cf00000, 0x3c200000,	RTL_GIGA_MAC_VER_20 },
+		{ 0x7cf00000, 0x3c300000,	RTL_GIGA_MAC_VER_21 },
+		{ 0x7cf00000, 0x3c400000,	RTL_GIGA_MAC_VER_22 },
+		{ 0x7c800000, 0x3c000000,	RTL_GIGA_MAC_VER_22 },
+
+		/* 8168B family. */
+		{ 0x7cf00000, 0x38000000,	RTL_GIGA_MAC_VER_12 },
+		{ 0x7cf00000, 0x38500000,	RTL_GIGA_MAC_VER_17 },
+		{ 0x7c800000, 0x38000000,	RTL_GIGA_MAC_VER_17 },
+		{ 0x7c800000, 0x30000000,	RTL_GIGA_MAC_VER_11 },
+
+		/* 8101 family. */
+		{ 0x7cf00000, 0x44900000,	RTL_GIGA_MAC_VER_39 },
+		{ 0x7c800000, 0x44800000,	RTL_GIGA_MAC_VER_39 },
+		{ 0x7c800000, 0x44000000,	RTL_GIGA_MAC_VER_37 },
+		{ 0x7cf00000, 0x40b00000,	RTL_GIGA_MAC_VER_30 },
+		{ 0x7cf00000, 0x40a00000,	RTL_GIGA_MAC_VER_30 },
+		{ 0x7cf00000, 0x40900000,	RTL_GIGA_MAC_VER_29 },
+		{ 0x7c800000, 0x40800000,	RTL_GIGA_MAC_VER_30 },
+		{ 0x7cf00000, 0x34a00000,	RTL_GIGA_MAC_VER_09 },
+		{ 0x7cf00000, 0x24a00000,	RTL_GIGA_MAC_VER_09 },
+		{ 0x7cf00000, 0x34900000,	RTL_GIGA_MAC_VER_08 },
+		{ 0x7cf00000, 0x24900000,	RTL_GIGA_MAC_VER_08 },
+		{ 0x7cf00000, 0x34800000,	RTL_GIGA_MAC_VER_07 },
+		{ 0x7cf00000, 0x24800000,	RTL_GIGA_MAC_VER_07 },
+		{ 0x7cf00000, 0x34000000,	RTL_GIGA_MAC_VER_13 },
+		{ 0x7cf00000, 0x34300000,	RTL_GIGA_MAC_VER_10 },
+		{ 0x7cf00000, 0x34200000,	RTL_GIGA_MAC_VER_16 },
+		{ 0x7c800000, 0x34800000,	RTL_GIGA_MAC_VER_09 },
+		{ 0x7c800000, 0x24800000,	RTL_GIGA_MAC_VER_09 },
+		{ 0x7c800000, 0x34000000,	RTL_GIGA_MAC_VER_16 },
+		/* FIXME: where did these entries come from ? -- FR */
+		{ 0xfc800000, 0x38800000,	RTL_GIGA_MAC_VER_15 },
+		{ 0xfc800000, 0x30800000,	RTL_GIGA_MAC_VER_14 },
+
+		/* 8110 family. */
+		{ 0xfc800000, 0x98000000,	RTL_GIGA_MAC_VER_06 },
+		{ 0xfc800000, 0x18000000,	RTL_GIGA_MAC_VER_05 },
+		{ 0xfc800000, 0x10000000,	RTL_GIGA_MAC_VER_04 },
+		{ 0xfc800000, 0x04000000,	RTL_GIGA_MAC_VER_03 },
+		{ 0xfc800000, 0x00800000,	RTL_GIGA_MAC_VER_02 },
+		{ 0xfc800000, 0x00000000,	RTL_GIGA_MAC_VER_01 },
+
+		/* Catch-all */
+		{ 0x00000000, 0x00000000,	RTL_GIGA_MAC_NONE   }
+	};
+	const struct rtl_mac_info *p = mac_info;
+	u32 reg;
+
+	reg = RTL_R32(TxConfig);
+	while ((reg & p->mask) != p->val)
+		p++;
+	tp->mac_version = p->mac_version;
+#endif
+
+	if (tp->mac_version == RTL_GIGA_MAC_NONE) {
+		netif_notice(tp, probe, dev,
+			     "unknown MAC, using family default\n");
+		tp->mac_version = default_version;
+	}
+/* barry mask off
+	else if (tp->mac_version == RTL_GIGA_MAC_VER_42) {
+		tp->mac_version = tp->mii.supports_gmii ?
+				  RTL_GIGA_MAC_VER_42 :
+				  RTL_GIGA_MAC_VER_43;
+	}
+*/
+}
+
+static void rtl8169_print_mac_version(struct rtl8169_private *tp)
+{
+	dprintk("mac_version = 0x%02x\n", tp->mac_version);
+}
+
+struct phy_reg {
+	u16 reg;
+	u16 val;
+};
+
+static void rtl_writephy_batch(struct rtl8169_private *tp,
+			       const struct phy_reg *regs, int len)
+{
+	while (len-- > 0) {
+		rtl_writephy(tp, regs->reg, regs->val);
+		regs++;
+	}
+}
+
+#define PHY_READ		0x00000000
+#define PHY_DATA_OR		0x10000000
+#define PHY_DATA_AND		0x20000000
+#define PHY_BJMPN		0x30000000
+#define PHY_MDIO_CHG		0x40000000
+#define PHY_CLEAR_READCOUNT	0x70000000
+#define PHY_WRITE		0x80000000
+#define PHY_READCOUNT_EQ_SKIP	0x90000000
+#define PHY_COMP_EQ_SKIPN	0xa0000000
+#define PHY_COMP_NEQ_SKIPN	0xb0000000
+#define PHY_WRITE_PREVIOUS	0xc0000000
+#define PHY_SKIPN		0xd0000000
+#define PHY_DELAY_MS		0xe0000000
+
+struct fw_info {
+	u32	magic;
+	char	version[RTL_VER_SIZE];
+	__le32	fw_start;
+	__le32	fw_len;
+	u8	chksum;
+} __packed;
+
+#define FW_OPCODE_SIZE	sizeof(typeof(*((struct rtl_fw_phy_action *)0)->code))
+
+static bool rtl_fw_format_ok(struct rtl8169_private *tp, struct rtl_fw *rtl_fw)
+{
+	const struct firmware *fw = rtl_fw->fw;
+	struct fw_info *fw_info = (struct fw_info *)fw->data;
+	struct rtl_fw_phy_action *pa = &rtl_fw->phy_action;
+	char *version = rtl_fw->version;
+	bool rc = false;
+
+	if (fw->size < FW_OPCODE_SIZE)
+		goto out;
+
+	if (!fw_info->magic) {
+		size_t i, size, start;
+		u8 checksum = 0;
+
+		if (fw->size < sizeof(*fw_info))
+			goto out;
+
+		for (i = 0; i < fw->size; i++)
+			checksum += fw->data[i];
+		if (checksum != 0)
+			goto out;
+
+		start = le32_to_cpu(fw_info->fw_start);
+		if (start > fw->size)
+			goto out;
+
+		size = le32_to_cpu(fw_info->fw_len);
+		if (size > (fw->size - start) / FW_OPCODE_SIZE)
+			goto out;
+
+		memcpy(version, fw_info->version, RTL_VER_SIZE);
+
+		pa->code = (__le32 *)(fw->data + start);
+		pa->size = size;
+	} else {
+		if (fw->size % FW_OPCODE_SIZE)
+			goto out;
+
+		strlcpy(version, rtl_lookup_firmware_name(tp), RTL_VER_SIZE);
+
+		pa->code = (__le32 *)fw->data;
+		pa->size = fw->size / FW_OPCODE_SIZE;
+	}
+	version[RTL_VER_SIZE - 1] = 0;
+
+	rc = true;
+out:
+	return rc;
+}
+
+static bool rtl_fw_data_ok(struct rtl8169_private *tp, struct net_device *dev,
+			   struct rtl_fw_phy_action *pa)
+{
+	bool rc = false;
+	size_t index;
+
+	for (index = 0; index < pa->size; index++) {
+		u32 action = le32_to_cpu(pa->code[index]);
+		u32 regno = (action & 0x0fff0000) >> 16;
+
+		switch(action & 0xf0000000) {
+		case PHY_READ:
+		case PHY_DATA_OR:
+		case PHY_DATA_AND:
+		case PHY_MDIO_CHG:
+		case PHY_CLEAR_READCOUNT:
+		case PHY_WRITE:
+		case PHY_WRITE_PREVIOUS:
+		case PHY_DELAY_MS:
+			break;
+
+		case PHY_BJMPN:
+			if (regno > index) {
+				netif_err(tp, ifup, tp->dev,
+					  "Out of range of firmware\n");
+				goto out;
+			}
+			break;
+		case PHY_READCOUNT_EQ_SKIP:
+			if (index + 2 >= pa->size) {
+				netif_err(tp, ifup, tp->dev,
+					  "Out of range of firmware\n");
+				goto out;
+			}
+			break;
+		case PHY_COMP_EQ_SKIPN:
+		case PHY_COMP_NEQ_SKIPN:
+		case PHY_SKIPN:
+			if (index + 1 + regno >= pa->size) {
+				netif_err(tp, ifup, tp->dev,
+					  "Out of range of firmware\n");
+				goto out;
+			}
+			break;
+
+		default:
+			netif_err(tp, ifup, tp->dev,
+				  "Invalid action 0x%08x\n", action);
+			goto out;
+		}
+	}
+	rc = true;
+out:
+	return rc;
+}
+
+static int rtl_check_firmware(struct rtl8169_private *tp, struct rtl_fw *rtl_fw)
+{
+	struct net_device *dev = tp->dev;
+	int rc = -EINVAL;
+
+	if (!rtl_fw_format_ok(tp, rtl_fw)) {
+		netif_err(tp, ifup, dev, "invalid firwmare\n");
+		goto out;
+	}
+
+	if (rtl_fw_data_ok(tp, dev, &rtl_fw->phy_action))
+		rc = 0;
+out:
+	return rc;
+}
+
+static void rtl_phy_write_fw(struct rtl8169_private *tp, struct rtl_fw *rtl_fw)
+{
+#if 0
+	struct rtl_fw_phy_action *pa = &rtl_fw->phy_action;
+	struct mdio_ops org, *ops = &tp->mdio_ops;
+	u32 predata, count;
+	size_t index;
+
+	predata = count = 0;
+	org.write = ops->write;
+	org.read = ops->read;
+
+	for (index = 0; index < pa->size; ) {
+		u32 action = le32_to_cpu(pa->code[index]);
+		u32 data = action & 0x0000ffff;
+		u32 regno = (action & 0x0fff0000) >> 16;
+
+		if (!action)
+			break;
+
+		switch(action & 0xf0000000) {
+		case PHY_READ:
+			predata = rtl_readphy(tp, regno);
+			count++;
+			index++;
+			break;
+		case PHY_DATA_OR:
+			predata |= data;
+			index++;
+			break;
+		case PHY_DATA_AND:
+			predata &= data;
+			index++;
+			break;
+		case PHY_BJMPN:
+			index -= regno;
+			break;
+		case PHY_MDIO_CHG:
+			if (data == 0) {
+				ops->write = org.write;
+				ops->read = org.read;
+			} else if (data == 1) {
+				ops->write = mac_mcu_write;
+				ops->read = mac_mcu_read;
+			}
+
+			index++;
+			break;
+		case PHY_CLEAR_READCOUNT:
+			count = 0;
+			index++;
+			break;
+		case PHY_WRITE:
+			rtl_writephy(tp, regno, data);
+			index++;
+			break;
+		case PHY_READCOUNT_EQ_SKIP:
+			index += (count == data) ? 2 : 1;
+			break;
+		case PHY_COMP_EQ_SKIPN:
+			if (predata == data)
+				index += regno;
+			index++;
+			break;
+		case PHY_COMP_NEQ_SKIPN:
+			if (predata != data)
+				index += regno;
+			index++;
+			break;
+		case PHY_WRITE_PREVIOUS:
+			rtl_writephy(tp, regno, predata);
+			index++;
+			break;
+		case PHY_SKIPN:
+			index += regno + 1;
+			break;
+		case PHY_DELAY_MS:
+			mdelay(data);
+			index++;
+			break;
+
+		default:
+			BUG();
+		}
+	}
+
+	ops->write = org.write;
+	ops->read = org.read;
+#endif
+}
+
+static void rtl_release_firmware(struct rtl8169_private *tp)
+{
+	if (!IS_ERR_OR_NULL(tp->rtl_fw)) {
+		release_firmware(tp->rtl_fw->fw);
+		kfree(tp->rtl_fw);
+	}
+	tp->rtl_fw = RTL_FIRMWARE_UNKNOWN;
+}
+
+static void rtl_apply_firmware(struct rtl8169_private *tp)
+{
+	struct rtl_fw *rtl_fw = tp->rtl_fw;
+
+	/* TODO: release firmware once rtl_phy_write_fw signals failures. */
+	if (!IS_ERR_OR_NULL(rtl_fw))
+		rtl_phy_write_fw(tp, rtl_fw);
+}
+
+static void rtl_apply_firmware_cond(struct rtl8169_private *tp, u8 reg, u16 val)
+{
+	if (rtl_readphy(tp, reg) != val)
+		netif_warn(tp, hw, tp->dev, "chipset not ready for firmware\n");
+	else
+		rtl_apply_firmware(tp);
+}
+
+static void rtl8169s_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x06, 0x006e },
+		{ 0x08, 0x0708 },
+		{ 0x15, 0x4000 },
+		{ 0x18, 0x65c7 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x03, 0x00a1 },
+		{ 0x02, 0x0008 },
+		{ 0x01, 0x0120 },
+		{ 0x00, 0x1000 },
+		{ 0x04, 0x0800 },
+		{ 0x04, 0x0000 },
+
+		{ 0x03, 0xff41 },
+		{ 0x02, 0xdf60 },
+		{ 0x01, 0x0140 },
+		{ 0x00, 0x0077 },
+		{ 0x04, 0x7800 },
+		{ 0x04, 0x7000 },
+
+		{ 0x03, 0x802f },
+		{ 0x02, 0x4f02 },
+		{ 0x01, 0x0409 },
+		{ 0x00, 0xf0f9 },
+		{ 0x04, 0x9800 },
+		{ 0x04, 0x9000 },
+
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0xff95 },
+		{ 0x00, 0xba00 },
+		{ 0x04, 0xa800 },
+		{ 0x04, 0xa000 },
+
+		{ 0x03, 0xff41 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0x0140 },
+		{ 0x00, 0x00bb },
+		{ 0x04, 0xb800 },
+		{ 0x04, 0xb000 },
+
+		{ 0x03, 0xdf41 },
+		{ 0x02, 0xdc60 },
+		{ 0x01, 0x6340 },
+		{ 0x00, 0x007d },
+		{ 0x04, 0xd800 },
+		{ 0x04, 0xd000 },
+
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0x100a },
+		{ 0x00, 0xa0ff },
+		{ 0x04, 0xf800 },
+		{ 0x04, 0xf000 },
+
+		{ 0x1f, 0x0000 },
+		{ 0x0b, 0x0000 },
+		{ 0x00, 0x9200 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8169sb_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0002 },
+		{ 0x01, 0x90d0 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8169scd_hw_phy_config_quirk(struct rtl8169_private *tp)
+{
+#if 0
+	struct platform_device *pdev = tp->pdev;
+
+	if ((pdev->subsystem_vendor != PCI_VENDOR_ID_GIGABYTE) ||
+	    (pdev->subsystem_device != 0xe000))
+		return;
+
+	rtl_writephy(tp, 0x1f, 0x0001);
+	rtl_writephy(tp, 0x10, 0xf01b);
+	rtl_writephy(tp, 0x1f, 0x0000);
+#endif
+}
+
+static void rtl8169scd_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x04, 0x0000 },
+		{ 0x03, 0x00a1 },
+		{ 0x02, 0x0008 },
+		{ 0x01, 0x0120 },
+		{ 0x00, 0x1000 },
+		{ 0x04, 0x0800 },
+		{ 0x04, 0x9000 },
+		{ 0x03, 0x802f },
+		{ 0x02, 0x4f02 },
+		{ 0x01, 0x0409 },
+		{ 0x00, 0xf099 },
+		{ 0x04, 0x9800 },
+		{ 0x04, 0xa000 },
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0xff95 },
+		{ 0x00, 0xba00 },
+		{ 0x04, 0xa800 },
+		{ 0x04, 0xf000 },
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0x101a },
+		{ 0x00, 0xa0ff },
+		{ 0x04, 0xf800 },
+		{ 0x04, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x10, 0xf41b },
+		{ 0x14, 0xfb54 },
+		{ 0x18, 0xf5c7 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl8169scd_hw_phy_config_quirk(tp);
+}
+
+static void rtl8169sce_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x04, 0x0000 },
+		{ 0x03, 0x00a1 },
+		{ 0x02, 0x0008 },
+		{ 0x01, 0x0120 },
+		{ 0x00, 0x1000 },
+		{ 0x04, 0x0800 },
+		{ 0x04, 0x9000 },
+		{ 0x03, 0x802f },
+		{ 0x02, 0x4f02 },
+		{ 0x01, 0x0409 },
+		{ 0x00, 0xf099 },
+		{ 0x04, 0x9800 },
+		{ 0x04, 0xa000 },
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0xff95 },
+		{ 0x00, 0xba00 },
+		{ 0x04, 0xa800 },
+		{ 0x04, 0xf000 },
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0x101a },
+		{ 0x00, 0xa0ff },
+		{ 0x04, 0xf800 },
+		{ 0x04, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x0b, 0x8480 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x18, 0x67c7 },
+		{ 0x04, 0x2000 },
+		{ 0x03, 0x002f },
+		{ 0x02, 0x4360 },
+		{ 0x01, 0x0109 },
+		{ 0x00, 0x3022 },
+		{ 0x04, 0x2800 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168bb_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x10, 0xf41b },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy(tp, 0x1f, 0x0001);
+	rtl_patchphy(tp, 0x16, 1 << 0);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168bef_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x10, 0xf41b },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168cp_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0000 },
+		{ 0x1d, 0x0f00 },
+		{ 0x1f, 0x0002 },
+		{ 0x0c, 0x1ec8 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168cp_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x1d, 0x3d98 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_patchphy(tp, 0x14, 1 << 5);
+	rtl_patchphy(tp, 0x0d, 1 << 5);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168c_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x12, 0x2300 },
+		{ 0x1f, 0x0002 },
+		{ 0x00, 0x88d4 },
+		{ 0x01, 0x82b1 },
+		{ 0x03, 0x7002 },
+		{ 0x08, 0x9e30 },
+		{ 0x09, 0x01f0 },
+		{ 0x0a, 0x5500 },
+		{ 0x0c, 0x00c8 },
+		{ 0x1f, 0x0003 },
+		{ 0x12, 0xc096 },
+		{ 0x16, 0x000a },
+		{ 0x1f, 0x0000 },
+		{ 0x1f, 0x0000 },
+		{ 0x09, 0x2000 },
+		{ 0x09, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl_patchphy(tp, 0x14, 1 << 5);
+	rtl_patchphy(tp, 0x0d, 1 << 5);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168c_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x12, 0x2300 },
+		{ 0x03, 0x802f },
+		{ 0x02, 0x4f02 },
+		{ 0x01, 0x0409 },
+		{ 0x00, 0xf099 },
+		{ 0x04, 0x9800 },
+		{ 0x04, 0x9000 },
+		{ 0x1d, 0x3d98 },
+		{ 0x1f, 0x0002 },
+		{ 0x0c, 0x7eb8 },
+		{ 0x06, 0x0761 },
+		{ 0x1f, 0x0003 },
+		{ 0x16, 0x0f0a },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl_patchphy(tp, 0x16, 1 << 0);
+	rtl_patchphy(tp, 0x14, 1 << 5);
+	rtl_patchphy(tp, 0x0d, 1 << 5);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168c_3_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x12, 0x2300 },
+		{ 0x1d, 0x3d98 },
+		{ 0x1f, 0x0002 },
+		{ 0x0c, 0x7eb8 },
+		{ 0x06, 0x5461 },
+		{ 0x1f, 0x0003 },
+		{ 0x16, 0x0f0a },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl_patchphy(tp, 0x16, 1 << 0);
+	rtl_patchphy(tp, 0x14, 1 << 5);
+	rtl_patchphy(tp, 0x0d, 1 << 5);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168c_4_hw_phy_config(struct rtl8169_private *tp)
+{
+	rtl8168c_3_hw_phy_config(tp);
+}
+
+static void rtl8168d_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init_0[] = {
+		/* Channel Estimation */
+		{ 0x1f, 0x0001 },
+		{ 0x06, 0x4064 },
+		{ 0x07, 0x2863 },
+		{ 0x08, 0x059c },
+		{ 0x09, 0x26b4 },
+		{ 0x0a, 0x6a19 },
+		{ 0x0b, 0xdcc8 },
+		{ 0x10, 0xf06d },
+		{ 0x14, 0x7f68 },
+		{ 0x18, 0x7fd9 },
+		{ 0x1c, 0xf0ff },
+		{ 0x1d, 0x3d9c },
+		{ 0x1f, 0x0003 },
+		{ 0x12, 0xf49f },
+		{ 0x13, 0x070b },
+		{ 0x1a, 0x05ad },
+		{ 0x14, 0x94c0 },
+
+		/*
+		 * Tx Error Issue
+		 * Enhance line driver power
+		 */
+		{ 0x1f, 0x0002 },
+		{ 0x06, 0x5561 },
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8332 },
+		{ 0x06, 0x5561 },
+
+		/*
+		 * Can not link to 1Gbps with bad cable
+		 * Decrease SNR threshold form 21.07dB to 19.04dB
+		 */
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+
+		{ 0x1f, 0x0000 },
+		{ 0x0d, 0xf880 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init_0, ARRAY_SIZE(phy_reg_init_0));
+
+	/*
+	 * Rx Error Issue
+	 * Fine Tune Switching regulator parameter
+	 */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_w1w0_phy(tp, 0x0b, 0x0010, 0x00ef);
+	rtl_w1w0_phy(tp, 0x0c, 0xa200, 0x5d00);
+
+	if (rtl8168d_efuse_read(tp, 0x01) == 0xb1) {
+		static const struct phy_reg phy_reg_init[] = {
+			{ 0x1f, 0x0002 },
+			{ 0x05, 0x669a },
+			{ 0x1f, 0x0005 },
+			{ 0x05, 0x8330 },
+			{ 0x06, 0x669a },
+			{ 0x1f, 0x0002 }
+		};
+		int val;
+
+		rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+		val = rtl_readphy(tp, 0x0d);
+
+		if ((val & 0x00ff) != 0x006c) {
+			static const u32 set[] = {
+				0x0065, 0x0066, 0x0067, 0x0068,
+				0x0069, 0x006a, 0x006b, 0x006c
+			};
+			int i;
+
+			rtl_writephy(tp, 0x1f, 0x0002);
+
+			val &= 0xff00;
+			for (i = 0; i < ARRAY_SIZE(set); i++)
+				rtl_writephy(tp, 0x0d, val | set[i]);
+		}
+	} else {
+		static const struct phy_reg phy_reg_init[] = {
+			{ 0x1f, 0x0002 },
+			{ 0x05, 0x6662 },
+			{ 0x1f, 0x0005 },
+			{ 0x05, 0x8330 },
+			{ 0x06, 0x6662 }
+		};
+
+		rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+	}
+
+	/* RSET couple improve */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_patchphy(tp, 0x0d, 0x0300);
+	rtl_patchphy(tp, 0x0f, 0x0010);
+
+	/* Fine tune PLL performance */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_w1w0_phy(tp, 0x02, 0x0100, 0x0600);
+	rtl_w1w0_phy(tp, 0x03, 0x0000, 0xe000);
+
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x001b);
+
+	rtl_apply_firmware_cond(tp, MII_EXPANSION, 0xbf00);
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168d_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init_0[] = {
+		/* Channel Estimation */
+		{ 0x1f, 0x0001 },
+		{ 0x06, 0x4064 },
+		{ 0x07, 0x2863 },
+		{ 0x08, 0x059c },
+		{ 0x09, 0x26b4 },
+		{ 0x0a, 0x6a19 },
+		{ 0x0b, 0xdcc8 },
+		{ 0x10, 0xf06d },
+		{ 0x14, 0x7f68 },
+		{ 0x18, 0x7fd9 },
+		{ 0x1c, 0xf0ff },
+		{ 0x1d, 0x3d9c },
+		{ 0x1f, 0x0003 },
+		{ 0x12, 0xf49f },
+		{ 0x13, 0x070b },
+		{ 0x1a, 0x05ad },
+		{ 0x14, 0x94c0 },
+
+		/*
+		 * Tx Error Issue
+		 * Enhance line driver power
+		 */
+		{ 0x1f, 0x0002 },
+		{ 0x06, 0x5561 },
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8332 },
+		{ 0x06, 0x5561 },
+
+		/*
+		 * Can not link to 1Gbps with bad cable
+		 * Decrease SNR threshold form 21.07dB to 19.04dB
+		 */
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+
+		{ 0x1f, 0x0000 },
+		{ 0x0d, 0xf880 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init_0, ARRAY_SIZE(phy_reg_init_0));
+
+	if (rtl8168d_efuse_read(tp, 0x01) == 0xb1) {
+		static const struct phy_reg phy_reg_init[] = {
+			{ 0x1f, 0x0002 },
+			{ 0x05, 0x669a },
+			{ 0x1f, 0x0005 },
+			{ 0x05, 0x8330 },
+			{ 0x06, 0x669a },
+
+			{ 0x1f, 0x0002 }
+		};
+		int val;
+
+		rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+		val = rtl_readphy(tp, 0x0d);
+		if ((val & 0x00ff) != 0x006c) {
+			static const u32 set[] = {
+				0x0065, 0x0066, 0x0067, 0x0068,
+				0x0069, 0x006a, 0x006b, 0x006c
+			};
+			int i;
+
+			rtl_writephy(tp, 0x1f, 0x0002);
+
+			val &= 0xff00;
+			for (i = 0; i < ARRAY_SIZE(set); i++)
+				rtl_writephy(tp, 0x0d, val | set[i]);
+		}
+	} else {
+		static const struct phy_reg phy_reg_init[] = {
+			{ 0x1f, 0x0002 },
+			{ 0x05, 0x2642 },
+			{ 0x1f, 0x0005 },
+			{ 0x05, 0x8330 },
+			{ 0x06, 0x2642 }
+		};
+
+		rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+	}
+
+	/* Fine tune PLL performance */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_w1w0_phy(tp, 0x02, 0x0100, 0x0600);
+	rtl_w1w0_phy(tp, 0x03, 0x0000, 0xe000);
+
+	/* Switching regulator Slew rate */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_patchphy(tp, 0x0f, 0x0017);
+
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x001b);
+
+	rtl_apply_firmware_cond(tp, MII_EXPANSION, 0xb300);
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168d_3_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0002 },
+		{ 0x10, 0x0008 },
+		{ 0x0d, 0x006c },
+
+		{ 0x1f, 0x0000 },
+		{ 0x0d, 0xf880 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x0b, 0xa4d8 },
+		{ 0x09, 0x281c },
+		{ 0x07, 0x2883 },
+		{ 0x0a, 0x6b35 },
+		{ 0x1d, 0x3da4 },
+		{ 0x1c, 0xeffd },
+		{ 0x14, 0x7f52 },
+		{ 0x18, 0x7fc6 },
+		{ 0x08, 0x0601 },
+		{ 0x06, 0x4063 },
+		{ 0x10, 0xf074 },
+		{ 0x1f, 0x0003 },
+		{ 0x13, 0x0789 },
+		{ 0x12, 0xf4bd },
+		{ 0x1a, 0x04fd },
+		{ 0x14, 0x84b0 },
+		{ 0x1f, 0x0000 },
+		{ 0x00, 0x9200 },
+
+		{ 0x1f, 0x0005 },
+		{ 0x01, 0x0340 },
+		{ 0x1f, 0x0001 },
+		{ 0x04, 0x4000 },
+		{ 0x03, 0x1d21 },
+		{ 0x02, 0x0c32 },
+		{ 0x01, 0x0200 },
+		{ 0x00, 0x5554 },
+		{ 0x04, 0x4800 },
+		{ 0x04, 0x4000 },
+		{ 0x04, 0xf000 },
+		{ 0x03, 0xdf01 },
+		{ 0x02, 0xdf20 },
+		{ 0x01, 0x101a },
+		{ 0x00, 0xa0ff },
+		{ 0x04, 0xf800 },
+		{ 0x04, 0xf000 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x0023 },
+		{ 0x16, 0x0000 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8168d_4_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0001 },
+		{ 0x17, 0x0cc0 },
+
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x002d },
+		{ 0x18, 0x0040 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+	rtl_patchphy(tp, 0x0d, 1 << 5);
+}
+
+static void rtl8168e_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		/* Enable Delay cap */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b80 },
+		{ 0x06, 0xc896 },
+		{ 0x1f, 0x0000 },
+
+		/* Channel estimation fine tune */
+		{ 0x1f, 0x0001 },
+		{ 0x0b, 0x6c20 },
+		{ 0x07, 0x2872 },
+		{ 0x1c, 0xefff },
+		{ 0x1f, 0x0003 },
+		{ 0x14, 0x6420 },
+		{ 0x1f, 0x0000 },
+
+		/* Update PFM & 10M TX idle timer */
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x002f },
+		{ 0x15, 0x1919 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x00ac },
+		{ 0x18, 0x0006 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_apply_firmware(tp);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	/* DCO enable for 10M IDLE Power */
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x0023);
+	rtl_w1w0_phy(tp, 0x17, 0x0006, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* For impedance matching */
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_w1w0_phy(tp, 0x08, 0x8000, 0x7f00);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* PHY auto speed down */
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x002d);
+	rtl_w1w0_phy(tp, 0x18, 0x0050, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_w1w0_phy(tp, 0x14, 0x8000, 0x0000);
+
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b86);
+	rtl_w1w0_phy(tp, 0x06, 0x0001, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x2000);
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x0020);
+	rtl_w1w0_phy(tp, 0x15, 0x0000, 0x1100);
+	rtl_writephy(tp, 0x1f, 0x0006);
+	rtl_writephy(tp, 0x00, 0x5a00);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0007);
+	rtl_writephy(tp, 0x0e, 0x003c);
+	rtl_writephy(tp, 0x0d, 0x4007);
+	rtl_writephy(tp, 0x0e, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0000);
+}
+
+static void rtl_rar_exgmac_set(struct rtl8169_private *tp, u8 *addr)
+{
+	const u16 w[] = {
+		addr[0] | (addr[1] << 8),
+		addr[2] | (addr[3] << 8),
+		addr[4] | (addr[5] << 8)
+	};
+	const struct exgmac_reg e[] = {
+		{ .addr = 0xe0, ERIAR_MASK_1111, .val = w[0] | (w[1] << 16) },
+		{ .addr = 0xe4, ERIAR_MASK_1111, .val = w[2] },
+		{ .addr = 0xf0, ERIAR_MASK_1111, .val = w[0] << 16 },
+		{ .addr = 0xf4, ERIAR_MASK_1111, .val = w[1] | (w[2] << 16) }
+	};
+
+	rtl_write_exgmac_batch(tp, e, ARRAY_SIZE(e));
+}
+
+static void rtl8168e_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		/* Enable Delay cap */
+		{ 0x1f, 0x0004 },
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x00ac },
+		{ 0x18, 0x0006 },
+		{ 0x1f, 0x0002 },
+		{ 0x1f, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		/* Channel estimation fine tune */
+		{ 0x1f, 0x0003 },
+		{ 0x09, 0xa20f },
+		{ 0x1f, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		/* Green Setting */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b5b },
+		{ 0x06, 0x9222 },
+		{ 0x05, 0x8b6d },
+		{ 0x06, 0x8000 },
+		{ 0x05, 0x8b76 },
+		{ 0x06, 0x8000 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_apply_firmware(tp);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	/* For 4-corner performance improve */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b80);
+	rtl_w1w0_phy(tp, 0x17, 0x0006, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* PHY auto speed down */
+	rtl_writephy(tp, 0x1f, 0x0004);
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x002d);
+	rtl_w1w0_phy(tp, 0x18, 0x0010, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_w1w0_phy(tp, 0x14, 0x8000, 0x0000);
+
+	/* improve 10M EEE waveform */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b86);
+	rtl_w1w0_phy(tp, 0x06, 0x0001, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* Improve 2-pair detection performance */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x4000, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* EEE setting */
+	rtl_w1w0_eri(tp, 0x1b0, ERIAR_MASK_1111, 0x0000, 0x0003, ERIAR_EXGMAC);
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x2000);
+	rtl_writephy(tp, 0x1f, 0x0004);
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x0020);
+	rtl_w1w0_phy(tp, 0x15, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x1f, 0x0002);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0007);
+	rtl_writephy(tp, 0x0e, 0x003c);
+	rtl_writephy(tp, 0x0d, 0x4007);
+	rtl_writephy(tp, 0x0e, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0000);
+
+	/* Green feature */
+	rtl_writephy(tp, 0x1f, 0x0003);
+	rtl_w1w0_phy(tp, 0x19, 0x0000, 0x0001);
+	rtl_w1w0_phy(tp, 0x10, 0x0000, 0x0400);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* Broken BIOS workaround: feed GigaMAC registers with MAC address. */
+	rtl_rar_exgmac_set(tp, tp->dev->dev_addr);
+}
+
+static void rtl8168f_hw_phy_config(struct rtl8169_private *tp)
+{
+	/* For 4-corner performance improve */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b80);
+	rtl_w1w0_phy(tp, 0x06, 0x0006, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* PHY auto speed down */
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x002d);
+	rtl_w1w0_phy(tp, 0x18, 0x0010, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_w1w0_phy(tp, 0x14, 0x8000, 0x0000);
+
+	/* Improve 10M EEE waveform */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b86);
+	rtl_w1w0_phy(tp, 0x06, 0x0001, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168f_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		/* Channel estimation fine tune */
+		{ 0x1f, 0x0003 },
+		{ 0x09, 0xa20f },
+		{ 0x1f, 0x0000 },
+
+		/* Modify green table for giga & fnet */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b55 },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b5e },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b67 },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b70 },
+		{ 0x06, 0x0000 },
+		{ 0x1f, 0x0000 },
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x0078 },
+		{ 0x17, 0x0000 },
+		{ 0x19, 0x00fb },
+		{ 0x1f, 0x0000 },
+
+		/* Modify green table for 10M */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b79 },
+		{ 0x06, 0xaa00 },
+		{ 0x1f, 0x0000 },
+
+		/* Disable hiimpedance detection (RTCT) */
+		{ 0x1f, 0x0003 },
+		{ 0x01, 0x328a },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_apply_firmware(tp);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl8168f_hw_phy_config(tp);
+
+	/* Improve 2-pair detection performance */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x4000, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168f_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	rtl_apply_firmware(tp);
+
+	rtl8168f_hw_phy_config(tp);
+}
+
+static void rtl8411_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		/* Channel estimation fine tune */
+		{ 0x1f, 0x0003 },
+		{ 0x09, 0xa20f },
+		{ 0x1f, 0x0000 },
+
+		/* Modify green table for giga & fnet */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b55 },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b5e },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b67 },
+		{ 0x06, 0x0000 },
+		{ 0x05, 0x8b70 },
+		{ 0x06, 0x0000 },
+		{ 0x1f, 0x0000 },
+		{ 0x1f, 0x0007 },
+		{ 0x1e, 0x0078 },
+		{ 0x17, 0x0000 },
+		{ 0x19, 0x00aa },
+		{ 0x1f, 0x0000 },
+
+		/* Modify green table for 10M */
+		{ 0x1f, 0x0005 },
+		{ 0x05, 0x8b79 },
+		{ 0x06, 0xaa00 },
+		{ 0x1f, 0x0000 },
+
+		/* Disable hiimpedance detection (RTCT) */
+		{ 0x1f, 0x0003 },
+		{ 0x01, 0x328a },
+		{ 0x1f, 0x0000 }
+	};
+
+
+	rtl_apply_firmware(tp);
+
+	rtl8168f_hw_phy_config(tp);
+
+	/* Improve 2-pair detection performance */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x4000, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	/* Modify green table for giga */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b54);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0800);
+	rtl_writephy(tp, 0x05, 0x8b5d);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0800);
+	rtl_writephy(tp, 0x05, 0x8a7c);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x05, 0x8a7f);
+	rtl_w1w0_phy(tp, 0x06, 0x0100, 0x0000);
+	rtl_writephy(tp, 0x05, 0x8a82);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x05, 0x8a85);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x05, 0x8a88);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* uc same-seed solution */
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x8000, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0000);
+
+	/* eee setting */
+	rtl_w1w0_eri(tp, 0x1b0, ERIAR_MASK_0001, 0x00, 0x03, ERIAR_EXGMAC);
+	rtl_writephy(tp, 0x1f, 0x0005);
+	rtl_writephy(tp, 0x05, 0x8b85);
+	rtl_w1w0_phy(tp, 0x06, 0x0000, 0x2000);
+	rtl_writephy(tp, 0x1f, 0x0004);
+	rtl_writephy(tp, 0x1f, 0x0007);
+	rtl_writephy(tp, 0x1e, 0x0020);
+	rtl_w1w0_phy(tp, 0x15, 0x0000, 0x0100);
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0007);
+	rtl_writephy(tp, 0x0e, 0x003c);
+	rtl_writephy(tp, 0x0d, 0x4007);
+	rtl_writephy(tp, 0x0e, 0x0000);
+	rtl_writephy(tp, 0x0d, 0x0000);
+
+	/* Green feature */
+	rtl_writephy(tp, 0x1f, 0x0003);
+	rtl_w1w0_phy(tp, 0x19, 0x0000, 0x0001);
+	rtl_w1w0_phy(tp, 0x10, 0x0000, 0x0400);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8168g_1_hw_phy_config(struct rtl8169_private *tp)
+{
+	rtl_apply_firmware(tp);
+
+	rtl_writephy(tp, 0x1f, 0x0a46);
+	if (rtl_readphy(tp, 0x10) & 0x0100) {
+		rtl_writephy(tp, 0x1f, 0x0bcc);
+		rtl_w1w0_phy(tp, 0x12, 0x0000, 0x8000);
+	} else {
+		rtl_writephy(tp, 0x1f, 0x0bcc);
+		rtl_w1w0_phy(tp, 0x12, 0x8000, 0x0000);
+	}
+
+	rtl_writephy(tp, 0x1f, 0x0a46);
+	if (rtl_readphy(tp, 0x13) & 0x0100) {
+		rtl_writephy(tp, 0x1f, 0x0c41);
+		rtl_w1w0_phy(tp, 0x15, 0x0002, 0x0000);
+	} else {
+		rtl_writephy(tp, 0x1f, 0x0c41);
+		rtl_w1w0_phy(tp, 0x15, 0x0000, 0x0002);
+	}
+
+	/* Enable PHY auto speed down */
+	rtl_writephy(tp, 0x1f, 0x0a44);
+	rtl_w1w0_phy(tp, 0x11, 0x000c, 0x0000);
+
+	rtl_writephy(tp, 0x1f, 0x0bcc);
+	rtl_w1w0_phy(tp, 0x14, 0x0100, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0a44);
+	rtl_w1w0_phy(tp, 0x11, 0x00c0, 0x0000);
+	rtl_writephy(tp, 0x1f, 0x0a43);
+	rtl_writephy(tp, 0x13, 0x8084);
+	rtl_w1w0_phy(tp, 0x14, 0x0000, 0x6000);
+	rtl_w1w0_phy(tp, 0x10, 0x1003, 0x0000);
+
+	/* EEE auto-fallback function */
+	rtl_writephy(tp, 0x1f, 0x0a4b);
+	rtl_w1w0_phy(tp, 0x11, 0x0004, 0x0000);
+
+	/* Enable UC LPF tune function */
+	rtl_writephy(tp, 0x1f, 0x0a43);
+	rtl_writephy(tp, 0x13, 0x8012);
+	rtl_w1w0_phy(tp, 0x14, 0x8000, 0x0000);
+
+	rtl_writephy(tp, 0x1f, 0x0c42);
+	rtl_w1w0_phy(tp, 0x11, 0x4000, 0x2000);
+
+	/* Improve SWR Efficiency */
+	rtl_writephy(tp, 0x1f, 0x0bcd);
+	rtl_writephy(tp, 0x14, 0x5065);
+	rtl_writephy(tp, 0x14, 0xd065);
+	rtl_writephy(tp, 0x1f, 0x0bc8);
+	rtl_writephy(tp, 0x11, 0x5655);
+	rtl_writephy(tp, 0x1f, 0x0bcd);
+	rtl_writephy(tp, 0x14, 0x1065);
+	rtl_writephy(tp, 0x14, 0x9065);
+	rtl_writephy(tp, 0x14, 0x1065);
+
+	/* Check ALDPS bit, disable it if enabled */
+	rtl_writephy(tp, 0x1f, 0x0a43);
+	if (rtl_readphy(tp, 0x10) & 0x0004)
+		rtl_w1w0_phy(tp, 0x10, 0x0000, 0x0004);
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+static void rtl8168g_2_hw_mac_mcu_patch(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	// mac mcu patch from BlueSatan  add by yukuen
+	if (soc_is_rtk1195()) {
+		if ((realtek_rev() == RTK1195_REV_A)) {
+
+		}
+		else {	// Fix ALDPS			
+			RTL_W32(OCPDR,0xFE140000);
+			RTL_W32(OCPDR,0xFE150000);
+			RTL_W32(OCPDR,0xFE160000);
+			RTL_W32(OCPDR,0xFE170000);
+			RTL_W32(OCPDR,0xFE180000);
+			RTL_W32(OCPDR,0xFE190000);
+			RTL_W32(OCPDR,0xFE1A0000);
+			RTL_W32(OCPDR,0xFE1B0000);
+			mdelay(3);
+			RTL_W32(OCPDR,0xFE130000);
+						
+			RTL_W32(OCPDR,0xFC00E008);
+			RTL_W32(OCPDR,0xFC01E051);
+			RTL_W32(OCPDR,0xFC02E059);
+			RTL_W32(OCPDR,0xFC03E05B);
+			RTL_W32(OCPDR,0xFC04E05D);
+			RTL_W32(OCPDR,0xFC05E05F);
+			RTL_W32(OCPDR,0xFC06E061);
+			RTL_W32(OCPDR,0xFC07E063);
+			RTL_W32(OCPDR,0xFC08C422);
+			RTL_W32(OCPDR,0xFC097380);
+			RTL_W32(OCPDR,0xFC0A49B7);
+			RTL_W32(OCPDR,0xFC0BF003);
+			RTL_W32(OCPDR,0xFC0C1D02);
+			RTL_W32(OCPDR,0xFC0D8D80);
+			RTL_W32(OCPDR,0xFC0EC51D);
+			RTL_W32(OCPDR,0xFC0F73A0);
+			RTL_W32(OCPDR,0xFC101300);
+			RTL_W32(OCPDR,0xFC11F104);
+			RTL_W32(OCPDR,0xFC1273A2);
+			RTL_W32(OCPDR,0xFC131300);
+			RTL_W32(OCPDR,0xFC14F010);
+			RTL_W32(OCPDR,0xFC15C517);
+			RTL_W32(OCPDR,0xFC1676A0);
+			RTL_W32(OCPDR,0xFC1774A2);
+			RTL_W32(OCPDR,0xFC180601);
+			RTL_W32(OCPDR,0xFC193720);
+			RTL_W32(OCPDR,0xFC1A9EA0);
+			RTL_W32(OCPDR,0xFC1B9CA2);
+			RTL_W32(OCPDR,0xFC1CC50F);
+			RTL_W32(OCPDR,0xFC1D73A2);
+			RTL_W32(OCPDR,0xFC1E4023);
+			RTL_W32(OCPDR,0xFC1FF813);
+			RTL_W32(OCPDR,0xFC20F304);
+			RTL_W32(OCPDR,0xFC2173A0);
+			RTL_W32(OCPDR,0xFC224033);
+			RTL_W32(OCPDR,0xFC23F80F);
+			RTL_W32(OCPDR,0xFC24C206);
+			RTL_W32(OCPDR,0xFC257340);
+			RTL_W32(OCPDR,0xFC2649B7);
+			RTL_W32(OCPDR,0xFC27F013);
+			RTL_W32(OCPDR,0xFC28C207);
+			RTL_W32(OCPDR,0xFC29BA00);
+			RTL_W32(OCPDR,0xFC2AC0BC);
+			RTL_W32(OCPDR,0xFC2BD2C8);
+			RTL_W32(OCPDR,0xFC2CD2CC);
+			RTL_W32(OCPDR,0xFC2DC0C4);
+			RTL_W32(OCPDR,0xFC2ED2E4);
+			RTL_W32(OCPDR,0xFC2F100A);
+			RTL_W32(OCPDR,0xFC30104C);
+			RTL_W32(OCPDR,0xFC310C7E);
+			RTL_W32(OCPDR,0xFC321D02);
+			RTL_W32(OCPDR,0xFC33C6F7);
+			RTL_W32(OCPDR,0xFC348DC0);
+			RTL_W32(OCPDR,0xFC351C01);
+			RTL_W32(OCPDR,0xFC36C5F7);
+			RTL_W32(OCPDR,0xFC378CA1);
+			RTL_W32(OCPDR,0xFC38C6F8);
+			RTL_W32(OCPDR,0xFC39BE00);
+			RTL_W32(OCPDR,0xFC3AC5F4);
+			RTL_W32(OCPDR,0xFC3B74A0);
+			RTL_W32(OCPDR,0xFC3C49C0);
+			RTL_W32(OCPDR,0xFC3DF010);
+			RTL_W32(OCPDR,0xFC3E74A2);
+			RTL_W32(OCPDR,0xFC3F76A4);
+			RTL_W32(OCPDR,0xFC404034);
+			RTL_W32(OCPDR,0xFC41F804);
+			RTL_W32(OCPDR,0xFC420601);
+			RTL_W32(OCPDR,0xFC439EA4);
+			RTL_W32(OCPDR,0xFC44E009);
+			RTL_W32(OCPDR,0xFC451D02);
+			RTL_W32(OCPDR,0xFC46C4E4);
+			RTL_W32(OCPDR,0xFC478D80);
+			RTL_W32(OCPDR,0xFC48C5E5);
+			RTL_W32(OCPDR,0xFC4964A1);
+			RTL_W32(OCPDR,0xFC4A4845);
+			RTL_W32(OCPDR,0xFC4B8CA1);
+			RTL_W32(OCPDR,0xFC4CE7EC);
+			RTL_W32(OCPDR,0xFC4D1C20);
+			RTL_W32(OCPDR,0xFC4EC5DC);
+			RTL_W32(OCPDR,0xFC4F8CA1);
+			RTL_W32(OCPDR,0xFC50C2E1);
+			RTL_W32(OCPDR,0xFC51BA00);
+			RTL_W32(OCPDR,0xFC521D02);
+			RTL_W32(OCPDR,0xFC53C606);
+			RTL_W32(OCPDR,0xFC548DC0);
+			RTL_W32(OCPDR,0xFC551D20);
+			RTL_W32(OCPDR,0xFC568DC0);
+			RTL_W32(OCPDR,0xFC57C603);
+			RTL_W32(OCPDR,0xFC58BE00);
+			RTL_W32(OCPDR,0xFC59C0BC);
+			RTL_W32(OCPDR,0xFC5A0E22);
+			RTL_W32(OCPDR,0xFC5BC102);
+			RTL_W32(OCPDR,0xFC5CB900);
+			RTL_W32(OCPDR,0xFC5D02A2);
+			RTL_W32(OCPDR,0xFC5EC602);
+			RTL_W32(OCPDR,0xFC5FBE00);
+			RTL_W32(OCPDR,0xFC600000);
+			RTL_W32(OCPDR,0xFC61C602);
+			RTL_W32(OCPDR,0xFC62BE00);
+			RTL_W32(OCPDR,0xFC630000);
+			RTL_W32(OCPDR,0xFC64C602);
+			RTL_W32(OCPDR,0xFC65BE00);
+			RTL_W32(OCPDR,0xFC660000);
+			RTL_W32(OCPDR,0xFC67C602);
+			RTL_W32(OCPDR,0xFC68BE00);
+			RTL_W32(OCPDR,0xFC690000);
+			RTL_W32(OCPDR,0xFC6AC602);
+			RTL_W32(OCPDR,0xFC6BBE00);
+			RTL_W32(OCPDR,0xFC6C0000);
+			
+			RTL_W32(OCPDR,0xFE138000);
+			RTL_W32(OCPDR,0xFE140FD1);
+			RTL_W32(OCPDR,0xFE150D21);
+			RTL_W32(OCPDR,0xFE16029D);
+
+			//MDC/MDIO clock speedup 
+			RTL_W32(OCPDR,0xEf080040);
+			
+		} 
+	}   
+}     
+
+static void rtl8168g_2_hw_phy_config(struct rtl8169_private *tp)
+{
+	//	rtl_apply_firmware(tp);
+	// gphy patch from Riri   	add by yukuen
+	if (soc_is_rtk1195()) {
+		if ((realtek_rev() == RTK1195_REV_A)) {
+			// disable green
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x8011);
+			rtl_writephy(tp, 0x1c, 0x1737);   //disable green
+
+			rtl_writephy(tp, 0x1f, 0x0BCC);
+			rtl_writephy(tp, 0x11, 0x4444);	  //write abiq /ldvbias
+
+			// R/ RC auto k
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x8013);
+			rtl_writephy(tp, 0x1c, 0x0F08);   //default ff08  disable auto k RC/R
+
+			rtl_writephy(tp, 0x1f, 0x0BCE);   //force tapbin = 4
+			rtl_writephy(tp, 0x10, 0x4444);
+
+			rtl_writephy(tp, 0x1f, 0x0BCD);
+			rtl_writephy(tp, 0x17, 0x8888);		//tx rc
+			rtl_writephy(tp, 0x16, 0x9999);		//rx rc
+
+			// increase sd thd
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x8101);
+			rtl_writephy(tp, 0x1c, 0x3E00);   //master sd  : 0x1e00
+
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x80E2);
+			rtl_writephy(tp, 0x1c, 0x3E00);   //default sd  : 0x0e00
+
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x8120);
+			rtl_writephy(tp, 0x1c, 0x3E00);   //slave sd  : 0x0e00
+		}
+		else {	// REV_B
+			//#GDAC updown
+			rtl_writephy(tp, 0x1f, 0x0BCC);
+			rtl_writephy(tp, 0x12, 0x00BE);
+
+			//R_RC
+			rtl_writephy(tp, 0x1f, 0x0A43);
+			rtl_writephy(tp, 0x1b, 0x81DE);
+			rtl_writephy(tp, 0x1c, 0xFDFE);     //#  fbfe [15:8] tapbin tx -3 #  [7:0] tapbin rx -2
+
+			rtl_writephy(tp, 0x1b, 0x81E0);
+			rtl_writephy(tp, 0x1c, 0xFDFF);     //#  [15:8] rlen  -3
+
+			rtl_writephy(tp, 0x1b, 0x81E2);
+			rtl_writephy(tp, 0x1c, 0x0400);     //#  [15:8] rlen_100 +4, -3+4=1
+			rtl_writephy(tp, 0x1b, 0x80d3);
+			rtl_writephy(tp, 0x1c, 0x04a4);     //# fnet cable length constant 0aa4
+
+			rtl_writephy(tp, 0x1b, 0x8111);
+			rtl_writephy(tp, 0x1c, 0x0a7f);     //# slave cable length constant fa7f
+
+			rtl_writephy(tp, 0x1b, 0x810d);
+			rtl_writephy(tp, 0x1c, 0x5604);     //# slave const dagc 0606
+
+			rtl_writephy(tp, 0x1b, 0x80f4);
+			rtl_writephy(tp, 0x1c, 0x5df7);     //# master cable length delta 3df7
+
+			rtl_writephy(tp, 0x1b, 0x80f2);
+			rtl_writephy(tp, 0x1c, 0x0a8f);     //# master cable length constant fa8f
+
+			rtl_writephy(tp, 0x1b, 0x80f6);
+			rtl_writephy(tp, 0x1c, 0x54ca);     //# master delta dagc 63ca
+
+			rtl_writephy(tp, 0x1b, 0x80ec);
+			rtl_writephy(tp, 0x1c, 0x007c);     //# master aagc 146c
+
+			//disble ALDPS interrupt
+			rtl_writephy(tp, 0x1f, 0x0a42);
+			rtl_writephy(tp, 0x12, rtl_readphy(tp, 0x12) & ~BIT(9));		
+			
+			//enable ALDPS
+			rtl_writephy(tp, 0x1f, 0x0a43);
+			rtl_writephy(tp, 0x10, rtl_readphy(tp, 0x10) | BIT(2));
+		}
+	}
+}
+
+static void rtl8102e_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0003 },
+		{ 0x08, 0x441d },
+		{ 0x01, 0x9100 },
+		{ 0x1f, 0x0000 }
+	};
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_patchphy(tp, 0x11, 1 << 12);
+	rtl_patchphy(tp, 0x19, 1 << 13);
+	rtl_patchphy(tp, 0x10, 1 << 15);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8105e_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0005 },
+		{ 0x1a, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0004 },
+		{ 0x1c, 0x0000 },
+		{ 0x1f, 0x0000 },
+
+		{ 0x1f, 0x0001 },
+		{ 0x15, 0x7701 },
+		{ 0x1f, 0x0000 }
+	};
+
+	/* Disable ALDPS before ram code */
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x18, 0x0310);
+	msleep(100);
+
+	rtl_apply_firmware(tp);
+
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+}
+
+static void rtl8402_hw_phy_config(struct rtl8169_private *tp)
+{
+	/* Disable ALDPS before setting firmware */
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x18, 0x0310);
+	msleep(20);
+
+	rtl_apply_firmware(tp);
+
+	/* EEE setting */
+	rtl_eri_write(tp, 0x1b0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_writephy(tp, 0x1f, 0x0004);
+	rtl_writephy(tp, 0x10, 0x401f);
+	rtl_writephy(tp, 0x19, 0x7030);
+	rtl_writephy(tp, 0x1f, 0x0000);
+}
+
+static void rtl8106e_hw_phy_config(struct rtl8169_private *tp)
+{
+	static const struct phy_reg phy_reg_init[] = {
+		{ 0x1f, 0x0004 },
+		{ 0x10, 0xc07f },
+		{ 0x19, 0x7030 },
+		{ 0x1f, 0x0000 }
+	};
+
+	/* Disable ALDPS before ram code */
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, 0x18, 0x0310);
+	msleep(100);
+
+	rtl_apply_firmware(tp);
+
+	rtl_eri_write(tp, 0x1b0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_writephy_batch(tp, phy_reg_init, ARRAY_SIZE(phy_reg_init));
+
+	rtl_eri_write(tp, 0x1d0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+}
+
+static void rtl_hw_phy_config(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl8169_print_mac_version(tp);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_01:
+		break;
+	case RTL_GIGA_MAC_VER_02:
+	case RTL_GIGA_MAC_VER_03:
+		rtl8169s_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_04:
+		rtl8169sb_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_05:
+		rtl8169scd_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_06:
+		rtl8169sce_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_07:
+	case RTL_GIGA_MAC_VER_08:
+	case RTL_GIGA_MAC_VER_09:
+		rtl8102e_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_11:
+		rtl8168bb_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_12:
+		rtl8168bef_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_17:
+		rtl8168bef_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_18:
+		rtl8168cp_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_19:
+		rtl8168c_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_20:
+		rtl8168c_2_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_21:
+		rtl8168c_3_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_22:
+		rtl8168c_4_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+		rtl8168cp_2_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_25:
+		rtl8168d_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_26:
+		rtl8168d_2_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_27:
+		rtl8168d_3_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_28:
+		rtl8168d_4_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_29:
+	case RTL_GIGA_MAC_VER_30:
+		rtl8105e_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_31:
+		/* None. */
+		break;
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+		rtl8168e_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_34:
+		rtl8168e_2_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_35:
+		rtl8168f_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_36:
+		rtl8168f_2_hw_phy_config(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_37:
+		rtl8402_hw_phy_config(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_38:
+		rtl8411_hw_phy_config(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_39:
+		rtl8106e_hw_phy_config(tp);
+		break;
+	
+	case RTL_GIGA_MAC_VER_40:
+		rtl8168g_1_hw_phy_config(tp);
+		break;
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+		rtl8168g_2_hw_mac_mcu_patch(tp);
+		rtl8168g_2_hw_phy_config(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_41:
+	default:
+		break;
+	}
+}
+
+static void rtl_schedule_task(struct rtl8169_private *tp, enum rtl_flag flag)
+{
+	if (!test_and_set_bit(flag, tp->wk.flags))
+		schedule_work(&tp->wk.work);
+}
+
+static void rtl_rar_set(struct rtl8169_private *tp, u8 *addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	rtl_lock_work(tp);
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	RTL_W32(MAC4, addr[4] | addr[5] << 8);
+	RTL_R32(MAC4);
+
+	RTL_W32(MAC0, addr[0] | addr[1] << 8 | addr[2] << 16 | addr[3] << 24);
+	RTL_R32(MAC0);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_34)
+		rtl_rar_exgmac_set(tp, addr);
+
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	rtl_unlock_work(tp);
+}
+
+static void rtl_phy_work(struct rtl8169_private *tp)
+{
+	struct timer_list *timer = &tp->timer;
+	void __iomem *ioaddr = tp->mmio_addr;	
+	unsigned long timeout = RTL8169_PHY_TIMEOUT;
+ 	u32 i,j;
+	int gphy_code;	
+	int gphy_status;	
+	u32  macaddr1;
+	u16  macaddr2;
+	
+	macaddr1 = RTL_R32(MAC0);
+	macaddr2 = RTL_R16(MAC4);		
+	
+	if (tp->link_ok(ioaddr))
+		return;
+					
+	rtl_writephy(tp, 0x1f, 0x0A46);
+	gphy_status = rtl_readphy(tp, 0x15);		
+	
+	rtl_writephy(tp, 0x1b, 0x0002);
+	gphy_code=rtl_readphy(tp, 0x1c);
+	
+	gphy_status = gphy_status & 0x0F00;
+	gphy_status = gphy_status >>8;
+	
+	
+	if((gphy_status>=3)&&(gphy_code==0x6329))
+	{		
+		goto out_mod_timer;
+	}
+
+	napi_disable(&tp->napi);
+	rtl_irq_disable(tp);
+
+	netif_err(tp, drv, tp->dev, "gphy check failed, reset start\n");
+	
+	i=readl(IOMEM(0xFE000000));	
+	i = i & 0xffffbfff;
+	writel(i,IOMEM(0xFE000000));
+	
+	j=readl(IOMEM(0xFE007088));	
+	j = j & 0xfffff9ff;
+	writel(j,IOMEM(0xFE007088));
+	
+	
+	i=readl(IOMEM(0xFE000000));	
+	i = i | 0x00004000;
+	writel(i,IOMEM(0xFE000000));
+	
+	j=readl(IOMEM(0xFE007088));	
+	j = j | 0x00000600;
+	writel(j,IOMEM(0xFE007088));
+	
+	msleep(300);	
+	
+	napi_enable(&tp->napi);
+	
+	rtl_writephy(tp, 0x1f, 0x0A46);
+	gphy_status = rtl_readphy(tp, 0x15);		
+	gphy_status = gphy_status & 0x0700;
+	gphy_status = gphy_status >>8;
+	
+	netif_err(tp, drv, tp->dev, "gphy check failed, reset check phystatus=%x\n",gphy_status);					
+	
+	if(gphy_status>=3)
+	{
+		// refill addres
+		
+		RTL_W8(Cfg9346, Cfg9346_Unlock);
+		RTL_W32(MAC0,macaddr1);
+		RTL_W16(MAC4,macaddr2);				
+		RTL_W8(Cfg9346, Cfg9346_Lock);	
+		//rtl_init_rxcfg(tp);
+		// re-init Rx setting
+		RTL_W32(RxConfig, RX128_INT_EN | RX_DMA_BURST | RX_EARLY_OFF);
+
+		netif_err(tp, drv, tp->dev, "gphy check failed, reset complete\n");					
+		rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+	}
+
+out_mod_timer:
+	mod_timer(timer, jiffies + timeout);
+}
+
+
+static void rtl8169_phy_timer(unsigned long __opaque)
+{
+	struct net_device *dev = (struct net_device *)__opaque;
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl_schedule_task(tp, RTL_FLAG_TASK_PHY_PENDING);
+}
+
+static void rtl8169_release_board(struct platform_device *pdev, struct net_device *dev,
+				  void __iomem *ioaddr)
+{
+//	iounmap(ioaddr);
+//	pci_release_regions(pdev);
+//	pci_clear_mwi(pdev);
+//	pci_disable_device(pdev);
+	free_netdev(dev);
+}
+
+DECLARE_RTL_COND(rtl_phy_reset_cond)
+{
+	return tp->phy_reset_pending(tp);
+}
+
+static void rtl8169_phy_reset(struct net_device *dev,
+			      struct rtl8169_private *tp)
+{
+	tp->phy_reset_enable(tp);
+	rtl_msleep_loop_wait_low(tp, &rtl_phy_reset_cond, 1, 100);
+}
+
+static bool rtl_tbi_enabled(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return (tp->mac_version == RTL_GIGA_MAC_VER_01) &&
+	    (RTL_R8(PHYstatus) & TBI_Enable);
+}
+
+static void rtl8169_init_phy(struct net_device *dev, struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	rtl_hw_phy_config(dev);
+
+	if (tp->mac_version <= RTL_GIGA_MAC_VER_06) {
+		dprintk("Set MAC Reg C+CR Offset 0x82h = 0x01h\n");
+		RTL_W8(0x82, 0x01);
+	}
+
+	// disable now is oob
+	RTL_W8(MCU, RTL_R8(MCU) & ~NOW_IS_OOB);
+
+//	pci_write_config_byte(tp->pci_dev, PCI_LATENCY_TIMER, 0x40);
+
+//	if (tp->mac_version <= RTL_GIGA_MAC_VER_06)
+//		pci_write_config_byte(tp->pci_dev, PCI_CACHE_LINE_SIZE, 0x08);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_02) {
+		dprintk("Set MAC Reg C+CR Offset 0x82h = 0x01h\n");
+		RTL_W8(0x82, 0x01);
+		dprintk("Set PHY Reg 0x0bh = 0x00h\n");
+		rtl_writephy(tp, 0x0b, 0x0000); //w 0x0b 15 0 0
+	}
+
+	rtl8169_phy_reset(dev, tp);
+
+	rtl8169_set_speed(dev, AUTONEG_ENABLE, SPEED_1000, DUPLEX_FULL,
+			  ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full |
+			  ADVERTISED_100baseT_Half | ADVERTISED_100baseT_Full |
+			  (tp->mii.supports_gmii ?
+			   ADVERTISED_1000baseT_Half |
+			   ADVERTISED_1000baseT_Full : 0));
+
+	if (rtl_tbi_enabled(tp))
+		netif_info(tp, link, dev, "TBI auto-negotiating\n");
+}
+
+
+static int rtl_set_mac_address(struct net_device *dev, void *p)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	struct sockaddr *addr = p;
+
+	if (!is_valid_ether_addr(addr->sa_data))
+		return -EADDRNOTAVAIL;
+
+	memcpy(dev->dev_addr, addr->sa_data, dev->addr_len);
+
+	rtl_rar_set(tp, dev->dev_addr);
+
+	return 0;
+}
+
+static int rtl8169_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	struct mii_ioctl_data *data = if_mii(ifr);
+
+	return netif_running(dev) ? tp->do_ioctl(tp, data, cmd) : -ENODEV;
+}
+
+static int rtl_xmii_ioctl(struct rtl8169_private *tp,
+			  struct mii_ioctl_data *data, int cmd)
+{
+	switch (cmd) {
+	case SIOCGMIIPHY:
+		data->phy_id = 32; /* Internal PHY */
+		return 0;
+
+	case SIOCGMIIREG:
+		data->val_out = rtl_readphy(tp, data->reg_num & 0x1f);
+		return 0;
+
+	case SIOCSMIIREG:
+		rtl_writephy(tp, data->reg_num & 0x1f, data->val_in);
+		return 0;
+	}
+	return -EOPNOTSUPP;
+}
+
+static int rtl_tbi_ioctl(struct rtl8169_private *tp, struct mii_ioctl_data *data, int cmd)
+{
+	return -EOPNOTSUPP;
+}
+
+static __maybe_unused void rtl_disable_msi(struct platform_device *pdev, struct rtl8169_private *tp)
+{
+//	if (tp->features & RTL_FEATURE_MSI) {
+//		pci_disable_msi(pdev);
+//		tp->features &= ~RTL_FEATURE_MSI;
+//	}
+}
+
+static void rtl_init_mdio_ops(struct rtl8169_private *tp)
+{
+	struct mdio_ops *ops = &tp->mdio_ops;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_27:
+		ops->write	= r8168dp_1_mdio_write;
+		ops->read	= r8168dp_1_mdio_read;
+		break;
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+		ops->write	= r8168dp_2_mdio_write;
+		ops->read	= r8168dp_2_mdio_read;
+		break;
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+	//	ops->write	= r8168g_mdio_write;
+	//	ops->read	= r8168g_mdio_read;
+		ops->write	= r8169_mdio_write;
+		ops->read	= r8169_mdio_read;
+		break;
+	default:
+		ops->write	= r8169_mdio_write;
+		ops->read	= r8169_mdio_read;
+		break;
+	}
+}
+
+static void rtl_speed_down(struct rtl8169_private *tp)
+{
+	u32 adv;
+	int lpa;
+
+	rtl_writephy(tp, 0x1f, 0x0000);
+	lpa = rtl_readphy(tp, MII_LPA);
+
+	if (lpa & (LPA_10HALF | LPA_10FULL))
+		adv = ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full;
+	else if (lpa & (LPA_100HALF | LPA_100FULL))
+		adv = ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full |
+		      ADVERTISED_100baseT_Half | ADVERTISED_100baseT_Full;
+	else
+		adv = ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full |
+		      ADVERTISED_100baseT_Half | ADVERTISED_100baseT_Full |
+		      (tp->mii.supports_gmii ?
+		       ADVERTISED_1000baseT_Half |
+		       ADVERTISED_1000baseT_Full : 0);
+
+	rtl8169_set_speed(tp->dev, AUTONEG_ENABLE, SPEED_1000, DUPLEX_FULL,
+			  adv);
+}
+
+static void rtl_wol_suspend_quirk(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_29:
+	case RTL_GIGA_MAC_VER_30:
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+	case RTL_GIGA_MAC_VER_34:
+	case RTL_GIGA_MAC_VER_37:
+	case RTL_GIGA_MAC_VER_38:
+	case RTL_GIGA_MAC_VER_39:
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+		RTL_W32(RxConfig, RTL_R32(RxConfig) |
+			AcceptBroadcast | AcceptMulticast | AcceptMyPhys);
+		break;
+	default:
+		break;
+	}
+}
+
+static bool rtl_wol_pll_power_down(struct rtl8169_private *tp)
+{
+	if (!(__rtl8169_get_wol(tp) & WAKE_ANY))
+		return false;
+
+	rtl_speed_down(tp);
+	rtl_wol_suspend_quirk(tp);
+
+	return true;
+}
+
+static void r810x_phy_power_down(struct rtl8169_private *tp)
+{
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, MII_BMCR, BMCR_PDOWN);
+}
+
+static void r810x_phy_power_up(struct rtl8169_private *tp)
+{
+	rtl_writephy(tp, 0x1f, 0x0000);
+	rtl_writephy(tp, MII_BMCR, BMCR_ANENABLE);
+}
+
+static void r810x_pll_power_down(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if (rtl_wol_pll_power_down(tp))
+		return;
+
+	r810x_phy_power_down(tp);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_07:
+	case RTL_GIGA_MAC_VER_08:
+	case RTL_GIGA_MAC_VER_09:
+	case RTL_GIGA_MAC_VER_10:
+	case RTL_GIGA_MAC_VER_13:
+	case RTL_GIGA_MAC_VER_16:
+		break;
+	default:
+		RTL_W8(PMCH, RTL_R8(PMCH) & ~0x80);
+		break;
+	}
+}
+
+static void r810x_pll_power_up(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	r810x_phy_power_up(tp);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_07:
+	case RTL_GIGA_MAC_VER_08:
+	case RTL_GIGA_MAC_VER_09:
+	case RTL_GIGA_MAC_VER_10:
+	case RTL_GIGA_MAC_VER_13:
+	case RTL_GIGA_MAC_VER_16:
+		break;
+	default:
+		RTL_W8(PMCH, RTL_R8(PMCH) | 0x80);
+		break;
+	}
+}
+
+static void r8168_phy_power_up(struct rtl8169_private *tp)
+{
+	rtl_writephy(tp, 0x1f, 0x0000);
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+	case RTL_GIGA_MAC_VER_18:
+	case RTL_GIGA_MAC_VER_19:
+	case RTL_GIGA_MAC_VER_20:
+	case RTL_GIGA_MAC_VER_21:
+	case RTL_GIGA_MAC_VER_22:
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+		rtl_writephy(tp, 0x0e, 0x0000);
+		break;
+	default:
+		break;
+	}
+	rtl_writephy(tp, MII_BMCR, BMCR_ANENABLE);
+}
+
+static void r8168_phy_power_down(struct rtl8169_private *tp)
+{
+	rtl_writephy(tp, 0x1f, 0x0000);
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+		rtl_writephy(tp, MII_BMCR, BMCR_ANENABLE | BMCR_PDOWN);
+		break;
+
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+	case RTL_GIGA_MAC_VER_18:
+	case RTL_GIGA_MAC_VER_19:
+	case RTL_GIGA_MAC_VER_20:
+	case RTL_GIGA_MAC_VER_21:
+	case RTL_GIGA_MAC_VER_22:
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+		rtl_writephy(tp, 0x0e, 0x0200);
+	default:
+		rtl_writephy(tp, MII_BMCR, BMCR_PDOWN);
+		break;
+	}
+}
+
+static void r8168_pll_power_down(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	if ((tp->mac_version == RTL_GIGA_MAC_VER_27 ||
+	     tp->mac_version == RTL_GIGA_MAC_VER_28 ||
+	     tp->mac_version == RTL_GIGA_MAC_VER_31) &&
+	    r8168dp_check_dash(tp)) {
+		return;
+	}
+
+	if ((tp->mac_version == RTL_GIGA_MAC_VER_23 ||
+	     tp->mac_version == RTL_GIGA_MAC_VER_24) &&
+	    (RTL_R16(CPlusCmd) & ASF)) {
+		return;
+	}
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_32 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_33)
+		rtl_ephy_write(tp, 0x19, 0xff64);
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+	if(wol_enable)
+	{
+		//enable now_is_oob
+		RTL_W8(MCU, RTL_R8(MCU) | NOW_IS_OOB);			
+		RTL_W8(Config5, RTL_R8(Config5) | LanWake);;	
+		RTL_W8(Config3, RTL_R8(Config3) | MagicPacket);	
+	}	
+	else
+	{
+		RTL_W8(Config5, RTL_R8(Config5) & ~LanWake);
+		RTL_W8(Config3, RTL_R8(Config3) & ~MagicPacket);	
+	}	
+	RTL_W8(Cfg9346, Cfg9346_Lock);	
+
+	if (rtl_wol_pll_power_down(tp))
+		return;
+
+	r8168_phy_power_down(tp);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+		RTL_W8(PMCH, RTL_R8(PMCH) & ~0x80);
+		break;
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+		rtl_w1w0_eri(tp, 0x1a8, ERIAR_MASK_1111, 0x00000000,
+			     0xfc000000, ERIAR_EXGMAC);
+		break;
+	}
+}
+
+static void r8168_pll_power_up(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+		RTL_W8(PMCH, RTL_R8(PMCH) | 0x80);
+		break;
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+		rtl_w1w0_eri(tp, 0x1a8, ERIAR_MASK_1111, 0xfc000000,
+			     0x00000000, ERIAR_EXGMAC);
+		break;
+	}
+
+	r8168_phy_power_up(tp);
+}
+
+static void rtl_generic_op(struct rtl8169_private *tp,
+			   void (*op)(struct rtl8169_private *))
+{
+	if (op)
+		op(tp);
+}
+
+static void rtl_pll_power_down(struct rtl8169_private *tp)
+{
+	rtl_generic_op(tp, tp->pll_power_ops.down);
+}
+
+static void rtl_pll_power_up(struct rtl8169_private *tp)
+{
+	rtl_generic_op(tp, tp->pll_power_ops.up);
+}
+
+static void rtl_init_pll_power_ops(struct rtl8169_private *tp)
+{
+	struct pll_power_ops *ops = &tp->pll_power_ops;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_07:
+	case RTL_GIGA_MAC_VER_08:
+	case RTL_GIGA_MAC_VER_09:
+	case RTL_GIGA_MAC_VER_10:
+	case RTL_GIGA_MAC_VER_16:
+	case RTL_GIGA_MAC_VER_29:
+	case RTL_GIGA_MAC_VER_30:
+	case RTL_GIGA_MAC_VER_37:
+	case RTL_GIGA_MAC_VER_39:
+	case RTL_GIGA_MAC_VER_43:
+		ops->down	= r810x_pll_power_down;
+		ops->up		= r810x_pll_power_up;
+		break;
+
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+	case RTL_GIGA_MAC_VER_18:
+	case RTL_GIGA_MAC_VER_19:
+	case RTL_GIGA_MAC_VER_20:
+	case RTL_GIGA_MAC_VER_21:
+	case RTL_GIGA_MAC_VER_22:
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+	case RTL_GIGA_MAC_VER_31:
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+	case RTL_GIGA_MAC_VER_34:
+	case RTL_GIGA_MAC_VER_35:
+	case RTL_GIGA_MAC_VER_36:
+	case RTL_GIGA_MAC_VER_38:
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+		ops->down	= r8168_pll_power_down;
+		ops->up		= r8168_pll_power_up;
+		break;
+
+	default:
+		ops->down	= NULL;
+		ops->up		= NULL;
+		break;
+	}
+}
+
+static void rtl_init_rxcfg(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_01:
+	case RTL_GIGA_MAC_VER_02:
+	case RTL_GIGA_MAC_VER_03:
+	case RTL_GIGA_MAC_VER_04:
+	case RTL_GIGA_MAC_VER_05:
+	case RTL_GIGA_MAC_VER_06:
+	case RTL_GIGA_MAC_VER_10:
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_13:
+	case RTL_GIGA_MAC_VER_14:
+	case RTL_GIGA_MAC_VER_15:
+	case RTL_GIGA_MAC_VER_16:
+	case RTL_GIGA_MAC_VER_17:
+		RTL_W32(RxConfig, RX_FIFO_THRESH | RX_DMA_BURST);
+		break;
+	case RTL_GIGA_MAC_VER_18:
+	case RTL_GIGA_MAC_VER_19:
+	case RTL_GIGA_MAC_VER_20:
+	case RTL_GIGA_MAC_VER_21:
+	case RTL_GIGA_MAC_VER_22:
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+	case RTL_GIGA_MAC_VER_34:
+	case RTL_GIGA_MAC_VER_35:
+		RTL_W32(RxConfig, RX128_INT_EN | RX_MULTI_EN | RX_DMA_BURST);
+		break;
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+		RTL_W32(RxConfig, RX128_INT_EN | RX_DMA_BURST | RX_EARLY_OFF);
+		break;
+	default:
+		RTL_W32(RxConfig, RX128_INT_EN | RX_DMA_BURST);
+		break;
+	}
+}
+
+static void rtl8169_init_ring_indexes(struct rtl8169_private *tp)
+{
+	tp->dirty_tx = tp->cur_tx = tp->cur_rx = 0;
+}
+
+static void rtl_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+	rtl_generic_op(tp, tp->jumbo_ops.enable);
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+}
+
+static void rtl_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+	rtl_generic_op(tp, tp->jumbo_ops.disable);
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+}
+
+static void r8168c_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+	RTL_W8(Config4, RTL_R8(Config4) | Jumbo_En1);
+	rtl_tx_performance_tweak(tp->pdev, 0x2 << MAX_READ_REQUEST_SHIFT);
+}
+
+static void r8168c_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+	RTL_W8(Config4, RTL_R8(Config4) & ~Jumbo_En1);
+	rtl_tx_performance_tweak(tp->pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+}
+
+static void r8168dp_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+}
+
+static void r8168dp_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+}
+
+static void r8168e_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(MaxTxPacketSize, 0x3f);
+	RTL_W8(Config3, RTL_R8(Config3) | Jumbo_En0);
+	RTL_W8(Config4, RTL_R8(Config4) | 0x01);
+	rtl_tx_performance_tweak(tp->pdev, 0x2 << MAX_READ_REQUEST_SHIFT);
+}
+
+static void r8168e_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(MaxTxPacketSize, 0x0c);
+	RTL_W8(Config3, RTL_R8(Config3) & ~Jumbo_En0);
+	RTL_W8(Config4, RTL_R8(Config4) & ~0x01);
+	rtl_tx_performance_tweak(tp->pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+}
+
+static void r8168b_0_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+//	rtl_tx_performance_tweak(tp->pdev,
+//		(0x2 << MAX_READ_REQUEST_SHIFT) | PCI_EXP_DEVCTL_NOSNOOP_EN);
+}
+
+static void r8168b_0_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+//	rtl_tx_performance_tweak(tp->pdev,
+//		(0x5 << MAX_READ_REQUEST_SHIFT) | PCI_EXP_DEVCTL_NOSNOOP_EN);
+}
+
+static void r8168b_1_hw_jumbo_enable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	r8168b_0_hw_jumbo_enable(tp);
+
+	RTL_W8(Config4, RTL_R8(Config4) | (1 << 0));
+}
+
+static void r8168b_1_hw_jumbo_disable(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	r8168b_0_hw_jumbo_disable(tp);
+
+	RTL_W8(Config4, RTL_R8(Config4) & ~(1 << 0));
+}
+
+static void rtl_init_jumbo_ops(struct rtl8169_private *tp)
+{
+	struct jumbo_ops *ops = &tp->jumbo_ops;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_11:
+		ops->disable	= r8168b_0_hw_jumbo_disable;
+		ops->enable	= r8168b_0_hw_jumbo_enable;
+		break;
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+		ops->disable	= r8168b_1_hw_jumbo_disable;
+		ops->enable	= r8168b_1_hw_jumbo_enable;
+		break;
+	case RTL_GIGA_MAC_VER_18: /* Wild guess. Needs info from Realtek. */
+	case RTL_GIGA_MAC_VER_19:
+	case RTL_GIGA_MAC_VER_20:
+	case RTL_GIGA_MAC_VER_21: /* Wild guess. Needs info from Realtek. */
+	case RTL_GIGA_MAC_VER_22:
+	case RTL_GIGA_MAC_VER_23:
+	case RTL_GIGA_MAC_VER_24:
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+		ops->disable	= r8168c_hw_jumbo_disable;
+		ops->enable	= r8168c_hw_jumbo_enable;
+		break;
+	case RTL_GIGA_MAC_VER_27:
+	case RTL_GIGA_MAC_VER_28:
+		ops->disable	= r8168dp_hw_jumbo_disable;
+		ops->enable	= r8168dp_hw_jumbo_enable;
+		break;
+	case RTL_GIGA_MAC_VER_31: /* Wild guess. Needs info from Realtek. */
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+	case RTL_GIGA_MAC_VER_34:
+		ops->disable	= r8168e_hw_jumbo_disable;
+		ops->enable	= r8168e_hw_jumbo_enable;
+		break;
+
+	/*
+	 * No action needed for jumbo frames with 8169.
+	 * No jumbo for 810x at all.
+	 */
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+	default:
+		ops->disable	= NULL;
+		ops->enable	= NULL;
+		break;
+	}
+}
+
+DECLARE_RTL_COND(rtl_chipcmd_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R8(ChipCmd) & CmdReset;
+}
+
+static void rtl_hw_reset(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(ChipCmd, CmdReset);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_chipcmd_cond, 100, 100);
+}
+
+static void rtl_request_uncached_firmware(struct rtl8169_private *tp)
+{
+	struct rtl_fw *rtl_fw;
+	const char *name;
+	int rc = -ENOMEM;
+
+	name = rtl_lookup_firmware_name(tp);
+	if (!name)
+		goto out_no_firmware;
+
+	rtl_fw = kzalloc(sizeof(*rtl_fw), GFP_KERNEL);
+	if (!rtl_fw)
+		goto err_warn;
+
+	rc = request_firmware(&rtl_fw->fw, name, &tp->pdev->dev);
+	if (rc < 0)
+		goto err_free;
+
+	rc = rtl_check_firmware(tp, rtl_fw);
+	if (rc < 0)
+		goto err_release_firmware;
+
+	tp->rtl_fw = rtl_fw;
+out:
+	return;
+
+err_release_firmware:
+	release_firmware(rtl_fw->fw);
+err_free:
+	kfree(rtl_fw);
+err_warn:
+	netif_warn(tp, ifup, tp->dev, "unable to load firmware patch %s (%d)\n",
+		   name, rc);
+out_no_firmware:
+	tp->rtl_fw = NULL;
+	goto out;
+}
+
+static __maybe_unused void rtl_request_firmware(struct rtl8169_private *tp)
+{
+	if (IS_ERR(tp->rtl_fw))
+		rtl_request_uncached_firmware(tp);
+}
+
+static void rtl_rx_close(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(RxConfig, RTL_R32(RxConfig) & ~RX_CONFIG_ACCEPT_MASK);
+}
+
+DECLARE_RTL_COND(rtl_npq_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R8(TxPoll) & NPQ;
+}
+
+DECLARE_RTL_COND(rtl_txcfg_empty_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(TxConfig) & TXCFG_EMPTY;
+}
+
+static void rtl8169_hw_reset(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* Disable interrupts */
+	rtl8169_irq_mask_and_ack(tp);
+
+	rtl_rx_close(tp);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_27 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_28 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_31) {
+		rtl_udelay_loop_wait_low(tp, &rtl_npq_cond, 20, 42*42);
+	} else if (tp->mac_version == RTL_GIGA_MAC_VER_34 ||
+	           tp->mac_version == RTL_GIGA_MAC_VER_35 ||
+	           tp->mac_version == RTL_GIGA_MAC_VER_36 ||
+	           tp->mac_version == RTL_GIGA_MAC_VER_37 ||
+	           tp->mac_version == RTL_GIGA_MAC_VER_40 ||
+	           tp->mac_version == RTL_GIGA_MAC_VER_41 ||
+	           tp->mac_version == RTL_GIGA_MAC_VER_42 ||
+	           tp->mac_version == RTL_GIGA_MAC_VER_43 ||
+	           tp->mac_version == RTL_GIGA_MAC_VER_38) {
+		RTL_W8(ChipCmd, RTL_R8(ChipCmd) | StopReq);
+		rtl_udelay_loop_wait_high(tp, &rtl_txcfg_empty_cond, 100, 666);
+	} else {
+		RTL_W8(ChipCmd, RTL_R8(ChipCmd) | StopReq);
+		udelay(100);
+	}
+
+	rtl_hw_reset(tp);
+}
+
+static void rtl_set_rx_tx_config_registers(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* Set DMA burst size and Interframe Gap Time */
+	RTL_W32(TxConfig, (TX_DMA_BURST << TxDMAShift) |
+		(InterFrameGap << TxInterFrameGapShift));
+}
+
+static void rtl_hw_start(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	tp->hw_start(dev);
+
+	rtl_irq_enable_all(tp);
+}
+
+static void rtl_set_rx_tx_desc_registers(struct rtl8169_private *tp,
+					 void __iomem *ioaddr)
+{
+	/*
+	 * Magic spell: some iop3xx ARM board needs the TxDescAddrHigh
+	 * register to be written before TxDescAddrLow to work.
+	 * Switching from MMIO to I/O access fixes the issue as well.
+	 */
+	RTL_W32(TxDescStartAddrHigh, ((u64) tp->TxPhyAddr) >> 32);
+	RTL_W32(TxDescStartAddrLow, ((u64) tp->TxPhyAddr) & DMA_BIT_MASK(32));
+	RTL_W32(RxDescAddrHigh, ((u64) tp->RxPhyAddr) >> 32);
+	RTL_W32(RxDescAddrLow, ((u64) tp->RxPhyAddr) & DMA_BIT_MASK(32));
+}
+
+static u16 rtl_rw_cpluscmd(void __iomem *ioaddr)
+{
+	u16 cmd;
+
+	cmd = RTL_R16(CPlusCmd);
+	RTL_W16(CPlusCmd, cmd);
+	return cmd;
+}
+
+static void rtl_set_rx_max_size(void __iomem *ioaddr, unsigned int rx_buf_sz)
+{
+	/* Low hurts. Let's disable the filtering. */
+	RTL_W16(RxMaxSize, rx_buf_sz + 1);
+}
+
+static void rtl8169_set_magic_reg(void __iomem *ioaddr, unsigned mac_version)
+{
+	static const struct rtl_cfg2_info {
+		u32 mac_version;
+		u32 clk;
+		u32 val;
+	} cfg2_info [] = {
+		{ RTL_GIGA_MAC_VER_05, PCI_Clock_33MHz, 0x000fff00 }, // 8110SCd
+		{ RTL_GIGA_MAC_VER_05, PCI_Clock_66MHz, 0x000fffff },
+		{ RTL_GIGA_MAC_VER_06, PCI_Clock_33MHz, 0x00ffff00 }, // 8110SCe
+		{ RTL_GIGA_MAC_VER_06, PCI_Clock_66MHz, 0x00ffffff }
+	};
+	const struct rtl_cfg2_info *p = cfg2_info;
+	unsigned int i;
+	u32 clk;
+
+	clk = RTL_R8(Config2) & PCI_Clock_66MHz;
+	for (i = 0; i < ARRAY_SIZE(cfg2_info); i++, p++) {
+		if ((p->mac_version == mac_version) && (p->clk == clk)) {
+			RTL_W32(0x7c, p->val);
+			break;
+		}
+	}
+}
+
+static void rtl_set_rx_mode(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	u32 mc_filter[2];	/* Multicast hash filter */
+	int rx_mode;
+	u32 tmp = 0;
+
+	if (dev->flags & IFF_PROMISC) {
+		/* Unconditionally log net taps. */
+		netif_notice(tp, link, dev, "Promiscuous mode enabled\n");
+		rx_mode =
+		    AcceptBroadcast | AcceptMulticast | AcceptMyPhys |
+		    AcceptAllPhys;
+		mc_filter[1] = mc_filter[0] = 0xffffffff;
+	} else if ((netdev_mc_count(dev) > multicast_filter_limit) ||
+		   (dev->flags & IFF_ALLMULTI)) {
+		/* Too many to filter perfectly -- accept all multicasts. */
+		rx_mode = AcceptBroadcast | AcceptMulticast | AcceptMyPhys;
+		mc_filter[1] = mc_filter[0] = 0xffffffff;
+	} else {
+		struct netdev_hw_addr *ha;
+
+		rx_mode = AcceptBroadcast | AcceptMyPhys;
+		mc_filter[1] = mc_filter[0] = 0;
+		netdev_for_each_mc_addr(ha, dev) {
+			int bit_nr = ether_crc(ETH_ALEN, ha->addr) >> 26;
+			mc_filter[bit_nr >> 5] |= 1 << (bit_nr & 31);
+			rx_mode |= AcceptMulticast;
+		}
+	}
+
+	if (dev->features & NETIF_F_RXALL)
+		rx_mode |= (AcceptErr | AcceptRunt);
+
+	tmp = (RTL_R32(RxConfig) & ~RX_CONFIG_ACCEPT_MASK) | rx_mode;
+
+	if (tp->mac_version > RTL_GIGA_MAC_VER_06) {
+		u32 data = mc_filter[0];
+
+		mc_filter[0] = swab32(mc_filter[1]);
+		mc_filter[1] = swab32(data);
+	}
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_35)
+		mc_filter[1] = mc_filter[0] = 0xffffffff;
+
+	RTL_W32(MAR0 + 4, mc_filter[1]);
+	RTL_W32(MAR0 + 0, mc_filter[0]);
+
+	RTL_W32(RxConfig, tmp);
+}
+
+static void rtl_hw_start_8169(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+//	struct platform_device *pdev = tp->pdev;
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_05) {
+		RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) | PCIMulRW);
+	//	pci_write_config_byte(pdev, PCI_CACHE_LINE_SIZE, 0x08);
+	}
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+	if (tp->mac_version == RTL_GIGA_MAC_VER_01 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_02 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_03 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_04)
+		RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+
+	rtl_init_rxcfg(tp);
+
+	RTL_W8(EarlyTxThres, NoEarlyTx);
+
+	rtl_set_rx_max_size(ioaddr, rx_buf_sz);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_01 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_02 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_03 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_04)
+		rtl_set_rx_tx_config_registers(tp);
+
+	tp->cp_cmd |= rtl_rw_cpluscmd(ioaddr) | PCIMulRW;
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_02 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_03) {
+		dprintk("Set MAC Reg C+CR Offset 0xE0. "
+			"Bit-3 and bit-14 MUST be 1\n");
+		tp->cp_cmd |= (1 << 14);
+	}
+
+	RTL_W16(CPlusCmd, tp->cp_cmd);
+
+	rtl8169_set_magic_reg(ioaddr, tp->mac_version);
+
+	/*
+	 * Undocumented corner. Supposedly:
+	 * (TxTimer << 12) | (TxPackets << 8) | (RxTimer << 4) | RxPackets
+	 */
+	RTL_W16(IntrMitigate, 0x0000);
+
+	rtl_set_rx_tx_desc_registers(tp, ioaddr);
+
+	if (tp->mac_version != RTL_GIGA_MAC_VER_01 &&
+	    tp->mac_version != RTL_GIGA_MAC_VER_02 &&
+	    tp->mac_version != RTL_GIGA_MAC_VER_03 &&
+	    tp->mac_version != RTL_GIGA_MAC_VER_04) {
+		RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+		rtl_set_rx_tx_config_registers(tp);
+	}
+
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	/* Initially a 10 us delay. Turned it into a PCI commit. - FR */
+	RTL_R8(IntrMask);
+
+	RTL_W32(RxMissed, 0);
+
+	rtl_set_rx_mode(dev);
+
+	/* no early-rx interrupts */
+	RTL_W16(MultiIntr, RTL_R16(MultiIntr) & 0xF000);
+}
+
+static void rtl_csi_write(struct rtl8169_private *tp, int addr, int value)
+{
+	if (tp->csi_ops.write)
+		tp->csi_ops.write(tp, addr, value);
+}
+
+static u32 rtl_csi_read(struct rtl8169_private *tp, int addr)
+{
+	return tp->csi_ops.read ? tp->csi_ops.read(tp, addr) : ~0;
+}
+
+static void rtl_csi_access_enable(struct rtl8169_private *tp, u32 bits)
+{
+	u32 csi;
+
+	csi = rtl_csi_read(tp, 0x070c) & 0x00ffffff;
+	rtl_csi_write(tp, 0x070c, csi | bits);
+}
+
+static void rtl_csi_access_enable_1(struct rtl8169_private *tp)
+{
+	rtl_csi_access_enable(tp, 0x17000000);
+}
+
+static void rtl_csi_access_enable_2(struct rtl8169_private *tp)
+{
+	rtl_csi_access_enable(tp, 0x27000000);
+}
+
+DECLARE_RTL_COND(rtl_csiar_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R32(CSIAR) & CSIAR_FLAG;
+}
+
+static void r8169_csi_write(struct rtl8169_private *tp, int addr, int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(CSIDR, value);
+	RTL_W32(CSIAR, CSIAR_WRITE_CMD | (addr & CSIAR_ADDR_MASK) |
+		CSIAR_BYTE_ENABLE << CSIAR_BYTE_ENABLE_SHIFT);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_csiar_cond, 10, 100);
+}
+
+static u32 r8169_csi_read(struct rtl8169_private *tp, int addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(CSIAR, (addr & CSIAR_ADDR_MASK) |
+		CSIAR_BYTE_ENABLE << CSIAR_BYTE_ENABLE_SHIFT);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_csiar_cond, 10, 100) ?
+		RTL_R32(CSIDR) : ~0;
+}
+
+static void r8402_csi_write(struct rtl8169_private *tp, int addr, int value)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(CSIDR, value);
+	RTL_W32(CSIAR, CSIAR_WRITE_CMD | (addr & CSIAR_ADDR_MASK) |
+		CSIAR_BYTE_ENABLE << CSIAR_BYTE_ENABLE_SHIFT |
+		CSIAR_FUNC_NIC);
+
+	rtl_udelay_loop_wait_low(tp, &rtl_csiar_cond, 10, 100);
+}
+
+static u32 r8402_csi_read(struct rtl8169_private *tp, int addr)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W32(CSIAR, (addr & CSIAR_ADDR_MASK) | CSIAR_FUNC_NIC |
+		CSIAR_BYTE_ENABLE << CSIAR_BYTE_ENABLE_SHIFT);
+
+	return rtl_udelay_loop_wait_high(tp, &rtl_csiar_cond, 10, 100) ?
+		RTL_R32(CSIDR) : ~0;
+}
+
+static void rtl_init_csi_ops(struct rtl8169_private *tp)
+{
+	struct csi_ops *ops = &tp->csi_ops;
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_01:
+	case RTL_GIGA_MAC_VER_02:
+	case RTL_GIGA_MAC_VER_03:
+	case RTL_GIGA_MAC_VER_04:
+	case RTL_GIGA_MAC_VER_05:
+	case RTL_GIGA_MAC_VER_06:
+	case RTL_GIGA_MAC_VER_10:
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_13:
+	case RTL_GIGA_MAC_VER_14:
+	case RTL_GIGA_MAC_VER_15:
+	case RTL_GIGA_MAC_VER_16:
+	case RTL_GIGA_MAC_VER_17:
+		ops->write	= NULL;
+		ops->read	= NULL;
+		break;
+
+	case RTL_GIGA_MAC_VER_37:
+	case RTL_GIGA_MAC_VER_38:
+		ops->write	= r8402_csi_write;
+		ops->read	= r8402_csi_read;
+		break;
+
+	default:
+		ops->write	= r8169_csi_write;
+		ops->read	= r8169_csi_read;
+		break;
+	}
+}
+
+struct ephy_info {
+	unsigned int offset;
+	u16 mask;
+	u16 bits;
+};
+
+static void rtl_ephy_init(struct rtl8169_private *tp, const struct ephy_info *e,
+			  int len)
+{
+#if 0
+	u16 w;
+
+	while (len-- > 0) {
+		w = (rtl_ephy_read(tp, e->offset) & ~e->mask) | e->bits;
+		rtl_ephy_write(tp, e->offset, w);
+		e++;
+	}
+#endif
+}
+
+static void rtl_disable_clock_request(struct platform_device *pdev)
+{
+//	pcie_capability_clear_word(pdev, PCI_EXP_LNKCTL,
+//				   PCI_EXP_LNKCTL_CLKREQ_EN);
+}
+
+static void rtl_enable_clock_request(struct platform_device *pdev)
+{
+//	pcie_capability_set_word(pdev, PCI_EXP_LNKCTL,
+//				 PCI_EXP_LNKCTL_CLKREQ_EN);
+}
+
+#define R8168_CPCMD_QUIRK_MASK (\
+	EnableBist | \
+	Mac_dbgo_oe | \
+	Force_half_dup | \
+	Force_rxflow_en | \
+	Force_txflow_en | \
+	Cxpl_dbg_sel | \
+	ASF | \
+	PktCntrDisable | \
+	Mac_dbgo_sel)
+
+static void rtl_hw_start_8168bb(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+	RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~R8168_CPCMD_QUIRK_MASK);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN) {
+		rtl_tx_performance_tweak(pdev, (0x5 << MAX_READ_REQUEST_SHIFT) |
+					 0x0800);
+		//			 PCI_EXP_DEVCTL_NOSNOOP_EN);
+	}
+}
+
+static void rtl_hw_start_8168bef(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	rtl_hw_start_8168bb(tp);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	RTL_W8(Config4, RTL_R8(Config4) & ~(1 << 0));
+}
+
+static void __rtl_hw_start_8168cp(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	RTL_W8(Config1, RTL_R8(Config1) | Speed_down);
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	rtl_disable_clock_request(pdev);
+
+	RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~R8168_CPCMD_QUIRK_MASK);
+}
+
+static void rtl_hw_start_8168cp_1(struct rtl8169_private *tp)
+{
+	static const struct ephy_info e_info_8168cp[] = {
+		{ 0x01, 0,	0x0001 },
+		{ 0x02, 0x0800,	0x1000 },
+		{ 0x03, 0,	0x0042 },
+		{ 0x06, 0x0080,	0x0000 },
+		{ 0x07, 0,	0x2000 }
+	};
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_ephy_init(tp, e_info_8168cp, ARRAY_SIZE(e_info_8168cp));
+
+	__rtl_hw_start_8168cp(tp);
+}
+
+static void rtl_hw_start_8168cp_2(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_2(tp);
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~R8168_CPCMD_QUIRK_MASK);
+}
+
+static void rtl_hw_start_8168cp_3(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_2(tp);
+
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+	/* Magic. */
+	RTL_W8(DBG_REG, 0x20);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~R8168_CPCMD_QUIRK_MASK);
+}
+
+static void rtl_hw_start_8168c_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	static const struct ephy_info e_info_8168c_1[] = {
+		{ 0x02, 0x0800,	0x1000 },
+		{ 0x03, 0,	0x0002 },
+		{ 0x06, 0x0080,	0x0000 }
+	};
+
+	rtl_csi_access_enable_2(tp);
+
+	RTL_W8(DBG_REG, 0x06 | FIX_NAK_1 | FIX_NAK_2);
+
+	rtl_ephy_init(tp, e_info_8168c_1, ARRAY_SIZE(e_info_8168c_1));
+
+	__rtl_hw_start_8168cp(tp);
+}
+
+static void rtl_hw_start_8168c_2(struct rtl8169_private *tp)
+{
+	static const struct ephy_info e_info_8168c_2[] = {
+		{ 0x01, 0,	0x0001 },
+		{ 0x03, 0x0400,	0x0220 }
+	};
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_ephy_init(tp, e_info_8168c_2, ARRAY_SIZE(e_info_8168c_2));
+
+	__rtl_hw_start_8168cp(tp);
+}
+
+static void rtl_hw_start_8168c_3(struct rtl8169_private *tp)
+{
+	rtl_hw_start_8168c_2(tp);
+}
+
+static void rtl_hw_start_8168c_4(struct rtl8169_private *tp)
+{
+	rtl_csi_access_enable_2(tp);
+
+	__rtl_hw_start_8168cp(tp);
+}
+
+static void rtl_hw_start_8168d(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_disable_clock_request(pdev);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W16(CPlusCmd, RTL_R16(CPlusCmd) & ~R8168_CPCMD_QUIRK_MASK);
+}
+
+static void rtl_hw_start_8168dp(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_1(tp);
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	rtl_disable_clock_request(pdev);
+}
+
+static void rtl_hw_start_8168d_4(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+	static const struct ephy_info e_info_8168d_4[] = {
+		{ 0x0b, ~0,	0x48 },
+		{ 0x19, 0x20,	0x50 },
+		{ 0x0c, ~0,	0x20 }
+	};
+	int i;
+
+	rtl_csi_access_enable_1(tp);
+
+	rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	for (i = 0; i < ARRAY_SIZE(e_info_8168d_4); i++) {
+		const struct ephy_info *e = e_info_8168d_4 + i;
+		u16 w;
+
+		w = rtl_ephy_read(tp, e->offset);
+		rtl_ephy_write(tp, 0x03, (w & e->mask) | e->bits);
+	}
+
+	rtl_enable_clock_request(pdev);
+}
+
+static void rtl_hw_start_8168e_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+	static const struct ephy_info e_info_8168e_1[] = {
+		{ 0x00, 0x0200,	0x0100 },
+		{ 0x00, 0x0000,	0x0004 },
+		{ 0x06, 0x0002,	0x0001 },
+		{ 0x06, 0x0000,	0x0030 },
+		{ 0x07, 0x0000,	0x2000 },
+		{ 0x00, 0x0000,	0x0020 },
+		{ 0x03, 0x5800,	0x2000 },
+		{ 0x03, 0x0000,	0x0001 },
+		{ 0x01, 0x0800,	0x1000 },
+		{ 0x07, 0x0000,	0x4000 },
+		{ 0x1e, 0x0000,	0x2000 },
+		{ 0x19, 0xffff,	0xfe6c },
+		{ 0x0a, 0x0000,	0x0040 }
+	};
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_ephy_init(tp, e_info_8168e_1, ARRAY_SIZE(e_info_8168e_1));
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	rtl_disable_clock_request(pdev);
+
+	/* Reset tx FIFO pointer */
+	RTL_W32(MISC, RTL_R32(MISC) | TXPLA_RST);
+	RTL_W32(MISC, RTL_R32(MISC) & ~TXPLA_RST);
+
+	RTL_W8(Config5, RTL_R8(Config5) & ~Spi_en);
+}
+
+static void rtl_hw_start_8168e_2(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+	static const struct ephy_info e_info_8168e_2[] = {
+		{ 0x09, 0x0000,	0x0080 },
+		{ 0x19, 0x0000,	0x0224 }
+	};
+
+	rtl_csi_access_enable_1(tp);
+
+	rtl_ephy_init(tp, e_info_8168e_2, ARRAY_SIZE(e_info_8168e_2));
+
+	if (tp->dev->mtu <= ETH_DATA_LEN)
+		rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	rtl_eri_write(tp, 0xc0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xb8, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xc8, ERIAR_MASK_1111, 0x00100002, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xe8, ERIAR_MASK_1111, 0x00100006, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xcc, ERIAR_MASK_1111, 0x00000050, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xd0, ERIAR_MASK_1111, 0x07ff0060, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x1b0, ERIAR_MASK_0001, 0x10, 0x00, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x0d4, ERIAR_MASK_0011, 0x0c00, 0xff00, ERIAR_EXGMAC);
+
+	RTL_W8(MaxTxPacketSize, EarlySize);
+
+	rtl_disable_clock_request(pdev);
+
+	RTL_W32(TxConfig, RTL_R32(TxConfig) | TXCFG_AUTO_FIFO);
+	RTL_W8(MCU, RTL_R8(MCU) & ~NOW_IS_OOB);
+
+	/* Adjust EEE LED frequency */
+	RTL_W8(EEE_LED, RTL_R8(EEE_LED) & ~0x07);
+
+	RTL_W8(DLLPR, RTL_R8(DLLPR) | PFM_EN);
+	RTL_W32(MISC, RTL_R32(MISC) | PWM_EN);
+	RTL_W8(Config5, RTL_R8(Config5) & ~Spi_en);
+}
+
+static void rtl_hw_start_8168f(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	rtl_eri_write(tp, 0xc0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xb8, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xc8, ERIAR_MASK_1111, 0x00100002, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xe8, ERIAR_MASK_1111, 0x00100006, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x00, 0x01, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x01, 0x00, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x1b0, ERIAR_MASK_0001, 0x10, 0x00, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x1d0, ERIAR_MASK_0001, 0x10, 0x00, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xcc, ERIAR_MASK_1111, 0x00000050, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xd0, ERIAR_MASK_1111, 0x00000060, ERIAR_EXGMAC);
+
+	RTL_W8(MaxTxPacketSize, EarlySize);
+
+	rtl_disable_clock_request(pdev);
+
+	RTL_W32(TxConfig, RTL_R32(TxConfig) | TXCFG_AUTO_FIFO);
+	RTL_W8(MCU, RTL_R8(MCU) & ~NOW_IS_OOB);
+	RTL_W8(DLLPR, RTL_R8(DLLPR) | PFM_EN);
+	RTL_W32(MISC, RTL_R32(MISC) | PWM_EN);
+	RTL_W8(Config5, RTL_R8(Config5) & ~Spi_en);
+}
+
+static void rtl_hw_start_8168f_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	static const struct ephy_info e_info_8168f_1[] = {
+		{ 0x06, 0x00c0,	0x0020 },
+		{ 0x08, 0x0001,	0x0002 },
+		{ 0x09, 0x0000,	0x0080 },
+		{ 0x19, 0x0000,	0x0224 }
+	};
+
+	rtl_hw_start_8168f(tp);
+
+	rtl_ephy_init(tp, e_info_8168f_1, ARRAY_SIZE(e_info_8168f_1));
+
+	rtl_w1w0_eri(tp, 0x0d4, ERIAR_MASK_0011, 0x0c00, 0xff00, ERIAR_EXGMAC);
+
+	/* Adjust EEE LED frequency */
+	RTL_W8(EEE_LED, RTL_R8(EEE_LED) & ~0x07);
+}
+
+static void rtl_hw_start_8411(struct rtl8169_private *tp)
+{
+	static const struct ephy_info e_info_8168f_1[] = {
+		{ 0x06, 0x00c0,	0x0020 },
+		{ 0x0f, 0xffff,	0x5200 },
+		{ 0x1e, 0x0000,	0x4000 },
+		{ 0x19, 0x0000,	0x0224 }
+	};
+
+	rtl_hw_start_8168f(tp);
+
+	rtl_ephy_init(tp, e_info_8168f_1, ARRAY_SIZE(e_info_8168f_1));
+
+	rtl_w1w0_eri(tp, 0x0d4, ERIAR_MASK_0011, 0x0c00, 0x0000, ERIAR_EXGMAC);
+}
+
+static void rtl_hw_start_8168g_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	RTL_W32(TxConfig, RTL_R32(TxConfig) | TXCFG_AUTO_FIFO);
+
+	rtl_eri_write(tp, 0xc8, ERIAR_MASK_0101, 0x080002, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xcc, ERIAR_MASK_0001, 0x38, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xd0, ERIAR_MASK_0001, 0x48, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xe8, ERIAR_MASK_1111, 0x00100006, ERIAR_EXGMAC);
+
+	rtl_csi_access_enable_1(tp);
+
+	rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x00, 0x01, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x01, 0x00, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0x2f8, ERIAR_MASK_0011, 0x1d8f, ERIAR_EXGMAC);
+
+	RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+	RTL_W32(MISC, RTL_R32(MISC) & ~RXDV_GATED_EN);
+	RTL_W8(MaxTxPacketSize, EarlySize);
+
+	rtl_eri_write(tp, 0xc0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xb8, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+
+	/* Adjust EEE LED frequency */
+	RTL_W8(EEE_LED, RTL_R8(EEE_LED) & ~0x07);
+
+	rtl_w1w0_eri(tp, 0x2fc, ERIAR_MASK_0001, 0x01, 0x06, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x1b0, ERIAR_MASK_0011, 0x0000, 0x1000, ERIAR_EXGMAC);
+}
+
+static void rtl_hw_start_8168g_2(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	static const struct ephy_info e_info_8168g_2[] = {
+		{ 0x00, 0x0000,	0x0008 },
+		{ 0x0c, 0x3df0,	0x0200 },
+		{ 0x19, 0xffff,	0xfc00 },
+		{ 0x1e, 0xffff,	0x20eb }
+	};
+
+	rtl_hw_start_8168g_1(tp);
+
+	// LED setting  add by yukuen
+	RTL_W32(LEDSEL, 0x000670ca);
+
+	/* disable aspm and clock request before access ephy */
+	RTL_W8(Config2, RTL_R8(Config2) & ~ClkReqEn);
+	RTL_W8(Config5, RTL_R8(Config5) & ~ASPM_en);
+	rtl_ephy_init(tp, e_info_8168g_2, ARRAY_SIZE(e_info_8168g_2));
+}
+
+static void rtl_hw_start_8168(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	rtl_set_rx_max_size(ioaddr, rx_buf_sz);
+
+	tp->cp_cmd |= RTL_R16(CPlusCmd) | PktCntrDisable | INTT_1;
+
+	RTL_W16(CPlusCmd, tp->cp_cmd);
+
+	RTL_W16(IntrMitigate, 0x5151);
+
+	/* Work around for RxFIFO overflow. */
+	if (tp->mac_version == RTL_GIGA_MAC_VER_11) {
+		tp->event_slow |= RxFIFOOver | PCSTimeout;
+		tp->event_slow &= ~RxOverflow;
+	}
+
+	rtl_set_rx_tx_desc_registers(tp, ioaddr);
+
+	rtl_set_rx_tx_config_registers(tp);
+
+	RTL_R8(IntrMask);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_11:
+		rtl_hw_start_8168bb(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+		rtl_hw_start_8168bef(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_18:
+		rtl_hw_start_8168cp_1(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_19:
+		rtl_hw_start_8168c_1(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_20:
+		rtl_hw_start_8168c_2(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_21:
+		rtl_hw_start_8168c_3(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_22:
+		rtl_hw_start_8168c_4(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_23:
+		rtl_hw_start_8168cp_2(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_24:
+		rtl_hw_start_8168cp_3(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_25:
+	case RTL_GIGA_MAC_VER_26:
+	case RTL_GIGA_MAC_VER_27:
+		rtl_hw_start_8168d(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_28:
+		rtl_hw_start_8168d_4(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_31:
+		rtl_hw_start_8168dp(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_32:
+	case RTL_GIGA_MAC_VER_33:
+		rtl_hw_start_8168e_1(tp);
+		break;
+	case RTL_GIGA_MAC_VER_34:
+		rtl_hw_start_8168e_2(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_35:
+	case RTL_GIGA_MAC_VER_36:
+		rtl_hw_start_8168f_1(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_38:
+		rtl_hw_start_8411(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+		rtl_hw_start_8168g_1(tp);
+		break;
+	case RTL_GIGA_MAC_VER_42:
+		rtl_hw_start_8168g_2(tp);
+		break;
+
+	default:
+		printk(KERN_ERR PFX "%s: unknown chipset (mac_version = %d).\n",
+			dev->name, tp->mac_version);
+		break;
+	}
+
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+
+	rtl_set_rx_mode(dev);
+
+	RTL_W16(MultiIntr, RTL_R16(MultiIntr) & 0xF000);
+}
+
+#define R810X_CPCMD_QUIRK_MASK (\
+	EnableBist | \
+	Mac_dbgo_oe | \
+	Force_half_dup | \
+	Force_rxflow_en | \
+	Force_txflow_en | \
+	Cxpl_dbg_sel | \
+	ASF | \
+	PktCntrDisable | \
+	Mac_dbgo_sel)
+
+static void rtl_hw_start_8102e_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+	static const struct ephy_info e_info_8102e_1[] = {
+		{ 0x01,	0, 0x6e65 },
+		{ 0x02,	0, 0x091f },
+		{ 0x03,	0, 0xc2f9 },
+		{ 0x06,	0, 0xafb5 },
+		{ 0x07,	0, 0x0e00 },
+		{ 0x19,	0, 0xec80 },
+		{ 0x01,	0, 0x2e65 },
+		{ 0x01,	0, 0x6e65 }
+	};
+	u8 cfg1;
+
+	rtl_csi_access_enable_2(tp);
+
+	RTL_W8(DBG_REG, FIX_NAK_1);
+
+	rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W8(Config1,
+	       LEDS1 | LEDS0 | Speed_down | MEMMAP | IOMAP | VPD | PMEnable);
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+
+	cfg1 = RTL_R8(Config1);
+	if ((cfg1 & LEDS0) && (cfg1 & LEDS1))
+		RTL_W8(Config1, cfg1 & ~LEDS0);
+
+	rtl_ephy_init(tp, e_info_8102e_1, ARRAY_SIZE(e_info_8102e_1));
+}
+
+static void rtl_hw_start_8102e_2(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+
+	rtl_csi_access_enable_2(tp);
+
+	rtl_tx_performance_tweak(pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	RTL_W8(Config1, MEMMAP | IOMAP | VPD | PMEnable);
+	RTL_W8(Config3, RTL_R8(Config3) & ~Beacon_en);
+}
+
+static void rtl_hw_start_8102e_3(struct rtl8169_private *tp)
+{
+	rtl_hw_start_8102e_2(tp);
+
+	rtl_ephy_write(tp, 0x03, 0xc2f9);
+}
+
+static void rtl_hw_start_8105e_1(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	static const struct ephy_info e_info_8105e_1[] = {
+		{ 0x07,	0, 0x4000 },
+		{ 0x19,	0, 0x0200 },
+		{ 0x19,	0, 0x0020 },
+		{ 0x1e,	0, 0x2000 },
+		{ 0x03,	0, 0x0001 },
+		{ 0x19,	0, 0x0100 },
+		{ 0x19,	0, 0x0004 },
+		{ 0x0a,	0, 0x0020 }
+	};
+
+	/* Force LAN exit from ASPM if Rx/Tx are not idle */
+	RTL_W32(FuncEvent, RTL_R32(FuncEvent) | 0x002800);
+
+	/* Disable Early Tally Counter */
+	RTL_W32(FuncEvent, RTL_R32(FuncEvent) & ~0x010000);
+
+	RTL_W8(MCU, RTL_R8(MCU) | EN_NDP | EN_OOB_RESET);
+	RTL_W8(DLLPR, RTL_R8(DLLPR) | PFM_EN);
+
+	rtl_ephy_init(tp, e_info_8105e_1, ARRAY_SIZE(e_info_8105e_1));
+}
+
+static void rtl_hw_start_8105e_2(struct rtl8169_private *tp)
+{
+	rtl_hw_start_8105e_1(tp);
+	rtl_ephy_write(tp, 0x1e, rtl_ephy_read(tp, 0x1e) | 0x8000);
+}
+
+static void rtl_hw_start_8402(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	static const struct ephy_info e_info_8402[] = {
+		{ 0x19,	0xffff, 0xff64 },
+		{ 0x1e,	0, 0x4000 }
+	};
+
+	rtl_csi_access_enable_2(tp);
+
+	/* Force LAN exit from ASPM if Rx/Tx are not idle */
+	RTL_W32(FuncEvent, RTL_R32(FuncEvent) | 0x002800);
+
+	RTL_W32(TxConfig, RTL_R32(TxConfig) | TXCFG_AUTO_FIFO);
+	RTL_W8(MCU, RTL_R8(MCU) & ~NOW_IS_OOB);
+
+	rtl_ephy_init(tp, e_info_8402, ARRAY_SIZE(e_info_8402));
+
+	rtl_tx_performance_tweak(tp->pdev, 0x5 << MAX_READ_REQUEST_SHIFT);
+
+	rtl_eri_write(tp, 0xc8, ERIAR_MASK_1111, 0x00000002, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xe8, ERIAR_MASK_1111, 0x00000006, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x00, 0x01, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0xdc, ERIAR_MASK_0001, 0x01, 0x00, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xc0, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_eri_write(tp, 0xb8, ERIAR_MASK_0011, 0x0000, ERIAR_EXGMAC);
+	rtl_w1w0_eri(tp, 0x0d4, ERIAR_MASK_0011, 0x0e00, 0xff00, ERIAR_EXGMAC);
+}
+
+static void rtl_hw_start_8106(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* Force LAN exit from ASPM if Rx/Tx are not idle */
+	RTL_W32(FuncEvent, RTL_R32(FuncEvent) | 0x002800);
+
+	RTL_W32(MISC, (RTL_R32(MISC) | DISABLE_LAN_EN) & ~EARLY_TALLY_EN);
+	RTL_W8(MCU, RTL_R8(MCU) | EN_NDP | EN_OOB_RESET);
+	RTL_W8(DLLPR, RTL_R8(DLLPR) & ~PFM_EN);
+}
+
+static void rtl_hw_start_8101(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+//	struct platform_device *pdev = tp->pdev;
+
+	if (tp->mac_version >= RTL_GIGA_MAC_VER_30)
+		tp->event_slow &= ~RxFIFOOver;
+
+//	if (tp->mac_version == RTL_GIGA_MAC_VER_13 ||
+//	    tp->mac_version == RTL_GIGA_MAC_VER_16)
+//		pcie_capability_set_word(pdev, PCI_EXP_DEVCTL,
+//					 PCI_EXP_DEVCTL_NOSNOOP_EN);
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+
+	RTL_W8(MaxTxPacketSize, TxPacketMax);
+
+	rtl_set_rx_max_size(ioaddr, rx_buf_sz);
+
+	tp->cp_cmd &= ~R810X_CPCMD_QUIRK_MASK;
+	RTL_W16(CPlusCmd, tp->cp_cmd);
+
+	rtl_set_rx_tx_desc_registers(tp, ioaddr);
+
+	rtl_set_rx_tx_config_registers(tp);
+
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_07:
+		rtl_hw_start_8102e_1(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_08:
+		rtl_hw_start_8102e_3(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_09:
+		rtl_hw_start_8102e_2(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_29:
+		rtl_hw_start_8105e_1(tp);
+		break;
+	case RTL_GIGA_MAC_VER_30:
+		rtl_hw_start_8105e_2(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_37:
+		rtl_hw_start_8402(tp);
+		break;
+
+	case RTL_GIGA_MAC_VER_39:
+		rtl_hw_start_8106(tp);
+		break;
+	case RTL_GIGA_MAC_VER_43:
+		rtl_hw_start_8168g_2(tp);
+		break;
+	}
+
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	RTL_W16(IntrMitigate, 0x0000);
+
+	RTL_W8(ChipCmd, CmdTxEnb | CmdRxEnb);
+
+	rtl_set_rx_mode(dev);
+
+	RTL_R8(IntrMask);
+
+	RTL_W16(MultiIntr, RTL_R16(MultiIntr) & 0xf000);
+}
+
+static int link_status(void *data)
+{
+    struct net_device *dev = data;
+    struct rtl8169_private *tp = netdev_priv(dev);
+    void __iomem *ioaddr = tp->mmio_addr;
+    set_user_nice(current, 5);
+    printk("[Ethernet] Watch link status change.\n");
+
+    while(!kthread_should_stop()){
+        wait_event_interruptible(tp->thr_wait, kthread_should_stop() || tp->link_chg);
+        if(kthread_should_stop()){
+            break;
+        }
+        else if(!tp->link_chg)
+            continue;
+        else
+            tp->link_chg = 0;
+
+        // Send uevent about link status
+        if(tp->link_ok(ioaddr)){        	    
+            kobject_uevent(&tp->dev->dev.kobj, KOBJ_LINKUP);
+        }
+        else{
+            kobject_uevent(&tp->dev->dev.kobj, KOBJ_LINKDOWN);
+        }
+    }
+
+    do_exit(0);
+}
+
+static int rtl8169_change_mtu(struct net_device *dev, int new_mtu)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (new_mtu < ETH_ZLEN ||
+	    new_mtu > rtl_chip_infos[tp->mac_version].jumbo_max)
+		return -EINVAL;
+
+	if (new_mtu > ETH_DATA_LEN)
+		rtl_hw_jumbo_enable(tp);
+	else
+		rtl_hw_jumbo_disable(tp);
+
+	dev->mtu = new_mtu;
+	netdev_update_features(dev);
+
+	return 0;
+}
+
+static inline void rtl8169_make_unusable_by_asic(struct RxDesc *desc)
+{
+	desc->addr = cpu_to_le64(0x0badbadbadbadbadull);
+	desc->opts1 &= ~cpu_to_le32(DescOwn | RsvdMask);
+}
+
+static void rtl8169_free_rx_databuff(struct rtl8169_private *tp,
+				     void **data_buff, struct RxDesc *desc)
+{
+	dma_unmap_single(&tp->pdev->dev, le64_to_cpu(desc->addr), rx_buf_sz,
+			 DMA_FROM_DEVICE);
+
+	kfree(*data_buff);
+	*data_buff = NULL;
+	rtl8169_make_unusable_by_asic(desc);
+}
+
+static inline void rtl8169_mark_to_asic(struct RxDesc *desc, u32 rx_buf_sz)
+{
+	u32 eor = le32_to_cpu(desc->opts1) & RingEnd;
+
+	desc->opts1 = cpu_to_le32(DescOwn | eor | rx_buf_sz);
+}
+
+static void rtl8169_tx_desc_dump(struct rtl8169_private *tp)
+{
+        int i = 0;
+
+        for (i = 0; i < NUM_TX_DESC; i++) {
+		printk(KERN_INFO "Desc[%d] opts1=%x opts2=%x addr= %llx\n",i,tp->TxDescArray[i].opts1,tp->TxDescArray[i].opts2,tp->TxDescArray[i].addr);                
+        }
+}
+
+
+static void rtl8169_tx_desc_clear(struct rtl8169_private *tp)
+{
+        int i = 0;
+
+	memset(tp->TxDescArray, 0x0, NUM_TX_DESC * sizeof(struct TxDesc));
+
+        for (i = 0; i < NUM_TX_DESC; i++) {
+                if (i == (NUM_TX_DESC - 1))
+                        tp->TxDescArray[i].opts1 = cpu_to_le32(RingEnd);
+        }
+}
+
+static void rtl8169_rx_desc_offset0_init(struct rtl8169_private *tp, int own)
+{
+	int i = 0;
+	int ownbit = 0;
+
+	if (own)
+		ownbit = DescOwn;
+
+	for (i = 0; i < NUM_RX_DESC; i++) {
+		if (i == (NUM_RX_DESC - 1))
+			tp->RxDescArray[i].opts1 = cpu_to_le32((ownbit | RingEnd) | (unsigned long)rx_buf_sz);
+		else
+			tp->RxDescArray[i].opts1 = cpu_to_le32(ownbit | (unsigned long)rx_buf_sz);
+	}
+}
+
+static inline void rtl8169_map_to_asic(struct RxDesc *desc, dma_addr_t mapping,
+				       u32 rx_buf_sz)
+{
+	desc->addr = cpu_to_le64(mapping);
+	wmb();
+	rtl8169_mark_to_asic(desc, rx_buf_sz);
+}
+
+static inline void *rtl8169_align(void *data)
+{
+	return (void *)ALIGN((long)data, 16);
+}
+
+static struct sk_buff *rtl8169_alloc_rx_data(struct rtl8169_private *tp,
+					     struct RxDesc *desc)
+{
+	void *data;
+	dma_addr_t mapping;
+	struct device *d = &tp->pdev->dev;
+	struct net_device *dev = tp->dev;
+	int node = dev->dev.parent ? dev_to_node(dev->dev.parent) : -1;
+
+	data = kmalloc_node(rx_buf_sz, GFP_KERNEL, node);
+	if (!data)
+		return NULL;
+
+	if (rtl8169_align(data) != data) {
+		kfree(data);
+		data = kmalloc_node(rx_buf_sz + 15, GFP_KERNEL, node);
+		if (!data)
+			return NULL;
+	}
+
+	mapping = dma_map_single(d, rtl8169_align(data), rx_buf_sz,
+				 DMA_FROM_DEVICE);
+	if (unlikely(dma_mapping_error(d, mapping))) {
+		if (net_ratelimit())
+			netif_err(tp, drv, tp->dev, "Failed to map RX DMA!\n");
+		goto err_out;
+	}
+
+	rtl8169_map_to_asic(desc, mapping, rx_buf_sz);
+	return data;
+
+err_out:
+	kfree(data);
+	return NULL;
+}
+
+static void rtl8169_rx_clear(struct rtl8169_private *tp)
+{
+	unsigned int i;
+
+	for (i = 0; i < NUM_RX_DESC; i++) {
+		if (tp->Rx_databuff[i]) {
+			rtl8169_free_rx_databuff(tp, tp->Rx_databuff + i,
+					    tp->RxDescArray + i);
+		}
+	}
+}
+
+static inline void rtl8169_mark_as_last_descriptor(struct RxDesc *desc)
+{
+	desc->opts1 |= cpu_to_le32(RingEnd);
+}
+
+static int rtl8169_rx_fill(struct rtl8169_private *tp)
+{
+	unsigned int i;
+
+	for (i = 0; i < NUM_RX_DESC; i++) {
+		void *data;
+
+		if (tp->Rx_databuff[i])
+			continue;
+
+		data = rtl8169_alloc_rx_data(tp, tp->RxDescArray + i);
+		if (!data) {
+			rtl8169_make_unusable_by_asic(tp->RxDescArray + i);
+			goto err_out;
+		}
+		tp->Rx_databuff[i] = data;
+	}
+
+	rtl8169_mark_as_last_descriptor(tp->RxDescArray + NUM_RX_DESC - 1);
+	return 0;
+
+err_out:
+	rtl8169_rx_clear(tp);
+	return -ENOMEM;
+}
+
+static int rtl8169_init_ring(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl8169_init_ring_indexes(tp);
+
+	memset(tp->tx_skb, 0x0, NUM_TX_DESC * sizeof(struct ring_info));
+	memset(tp->Rx_databuff, 0x0, NUM_RX_DESC * sizeof(void *));
+
+	return rtl8169_rx_fill(tp);
+}
+
+static void rtl8169_unmap_tx_skb(struct device *d, struct ring_info *tx_skb,
+				 struct TxDesc *desc)
+{
+	unsigned int len = tx_skb->len;
+
+	dma_unmap_single(d, le64_to_cpu(desc->addr), len, DMA_TO_DEVICE);
+
+	desc->opts1 = 0x00;
+	desc->opts2 = 0x00;
+	desc->addr = 0x00;
+	tx_skb->len = 0;
+}
+
+static void rtl8169_tx_clear_range(struct rtl8169_private *tp, u32 start,
+				   unsigned int n)
+{
+	unsigned int i;
+
+	for (i = 0; i < n; i++) {
+		unsigned int entry = (start + i) % NUM_TX_DESC;
+		struct ring_info *tx_skb = tp->tx_skb + entry;
+		unsigned int len = tx_skb->len;
+
+		if (len) {
+			struct sk_buff *skb = tx_skb->skb;
+
+			rtl8169_unmap_tx_skb(&tp->pdev->dev, tx_skb,
+					     tp->TxDescArray + entry);
+			if (skb) {
+				tp->dev->stats.tx_dropped++;
+				dev_kfree_skb(skb);
+				tx_skb->skb = NULL;
+			}
+		}
+	}
+}
+
+static void rtl8169_tx_clear(struct rtl8169_private *tp)
+{
+	rtl8169_tx_clear_range(tp, tp->dirty_tx, NUM_TX_DESC);
+	tp->cur_tx = tp->dirty_tx = 0;
+}
+
+static void rtl_reset_work(struct rtl8169_private *tp)
+{
+	struct net_device *dev = tp->dev;
+	//int i;
+
+	napi_disable(&tp->napi);
+	netif_stop_queue(dev);
+	synchronize_sched();
+
+	rtl8169_hw_reset(tp);
+
+	//for (i = 0; i < NUM_RX_DESC; i++)
+	//	rtl8169_mark_to_asic(tp->RxDescArray + i, rx_buf_sz);
+
+	rtl8169_rx_desc_offset0_init(tp,1);	
+
+	rtl8169_tx_clear(tp);
+	
+	// prevent Tx desc is overwriten
+	rtl8169_tx_desc_clear(tp);
+	rtl8169_init_ring_indexes(tp);
+
+	napi_enable(&tp->napi);
+	rtl_hw_start(dev);
+	netif_wake_queue(dev);
+	rtl8169_check_link_status(dev, tp, tp->mmio_addr);
+}
+
+static void rtl8169_tx_timeout(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl8169_tx_desc_dump(tp);
+	rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+}
+
+static int rtl8169_xmit_frags(struct rtl8169_private *tp, struct sk_buff *skb,
+			      u32 *opts)
+{
+	struct skb_shared_info *info = skb_shinfo(skb);
+	unsigned int cur_frag, entry;
+	struct TxDesc * uninitialized_var(txd);
+	struct device *d = &tp->pdev->dev;
+
+	entry = tp->cur_tx;
+	for (cur_frag = 0; cur_frag < info->nr_frags; cur_frag++) {
+		const skb_frag_t *frag = info->frags + cur_frag;
+		dma_addr_t mapping;
+		u32 status, len;
+		void *addr;
+
+		entry = (entry + 1) % NUM_TX_DESC;
+
+		txd = tp->TxDescArray + entry;
+		len = skb_frag_size(frag);
+		addr = skb_frag_address(frag);
+		mapping = dma_map_single(d, addr, len, DMA_TO_DEVICE);
+		if (unlikely(dma_mapping_error(d, mapping))) {
+			if (net_ratelimit())
+				netif_err(tp, drv, tp->dev,
+					  "Failed to map TX fragments DMA!\n");
+			goto err_out;
+		}
+
+		/* Anti gcc 2.95.3 bugware (sic) */
+		status = opts[0] | len |
+			(RingEnd * !((entry + 1) % NUM_TX_DESC));
+
+		txd->opts1 = cpu_to_le32(status);
+		txd->opts2 = cpu_to_le32(opts[1]);
+		txd->addr = cpu_to_le64(mapping);
+
+		tp->tx_skb[entry].len = len;
+	}
+
+	if (cur_frag) {
+		tp->tx_skb[entry].skb = skb;
+		txd->opts1 |= cpu_to_le32(LastFrag);
+	}
+
+	return cur_frag;
+
+err_out:
+	rtl8169_tx_clear_range(tp, tp->cur_tx + 1, cur_frag);
+	return -EIO;
+}
+
+static bool rtl_skb_pad(struct sk_buff *skb)
+{
+	if (skb_padto(skb, ETH_ZLEN))
+		return false;
+	skb_put(skb, ETH_ZLEN - skb->len);
+	return true;
+}
+
+static bool rtl_test_hw_pad_bug(struct rtl8169_private *tp, struct sk_buff *skb)
+{
+	return skb->len < ETH_ZLEN && tp->mac_version == RTL_GIGA_MAC_VER_34;
+}
+
+static inline bool rtl8169_tso_csum(struct rtl8169_private *tp,
+				    struct sk_buff *skb, u32 *opts)
+{
+	const struct rtl_tx_desc_info *info = tx_desc_info + tp->txd_version;
+	u32 mss = skb_shinfo(skb)->gso_size;
+	int offset = info->opts_offset;
+
+	if (mss) {
+		opts[0] |= TD_LSO;
+		opts[offset] |= min(mss, TD_MSS_MAX) << info->mss_shift;
+	} else if (skb->ip_summed == CHECKSUM_PARTIAL) {
+		const struct iphdr *ip = ip_hdr(skb);
+
+		if (unlikely(rtl_test_hw_pad_bug(tp, skb)))
+			return skb_checksum_help(skb) == 0 && rtl_skb_pad(skb);
+
+		if (ip->protocol == IPPROTO_TCP)
+			opts[offset] |= info->checksum.tcp;
+		else if (ip->protocol == IPPROTO_UDP)
+			opts[offset] |= info->checksum.udp;
+		else
+			WARN_ON_ONCE(1);
+	} else {
+		if (unlikely(rtl_test_hw_pad_bug(tp, skb)))
+			return rtl_skb_pad(skb);
+	}
+	return true;
+}
+
+static netdev_tx_t rtl8169_start_xmit(struct sk_buff *skb,
+				      struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	unsigned int entry = tp->cur_tx % NUM_TX_DESC;
+	struct TxDesc *txd = tp->TxDescArray + entry;
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct device *d = &tp->pdev->dev;
+	dma_addr_t mapping;
+	u32 status, len;
+	u32 opts[2];
+	int frags;
+
+	if (unlikely(!TX_FRAGS_READY_FOR(tp, skb_shinfo(skb)->nr_frags))) {
+		netif_err(tp, drv, dev, "BUG! Tx Ring full when queue awake!\n");
+		goto err_stop_0;
+	}
+
+	if (unlikely(le32_to_cpu(txd->opts1) & DescOwn))
+		goto err_stop_0;
+
+	opts[1] = cpu_to_le32(rtl8169_tx_vlan_tag(skb));
+	opts[0] = DescOwn;
+
+	if (!rtl8169_tso_csum(tp, skb, opts))
+		goto err_update_stats;
+
+	len = skb_headlen(skb);
+	mapping = dma_map_single(d, skb->data, len, DMA_TO_DEVICE);
+	if (unlikely(dma_mapping_error(d, mapping))) {
+		if (net_ratelimit())
+			netif_err(tp, drv, dev, "Failed to map TX DMA!\n");
+		goto err_dma_0;
+	}
+
+	tp->tx_skb[entry].len = len;
+	txd->addr = cpu_to_le64(mapping);
+
+	frags = rtl8169_xmit_frags(tp, skb, opts);
+	if (frags < 0)
+		goto err_dma_1;
+	else if (frags)
+		opts[0] |= FirstFrag;
+	else {
+		opts[0] |= FirstFrag | LastFrag;
+		tp->tx_skb[entry].skb = skb;
+	}
+
+	txd->opts2 = cpu_to_le32(opts[1]);
+
+	skb_tx_timestamp(skb);
+
+	wmb();
+
+	/* Anti gcc 2.95.3 bugware (sic) */
+	status = opts[0] | len | (RingEnd * !((entry + 1) % NUM_TX_DESC));
+	txd->opts1 = cpu_to_le32(status);
+
+	tp->cur_tx += frags + 1;
+
+	wmb();
+
+	RTL_W8(TxPoll, NPQ);
+
+	mmiowb();
+
+	if (!TX_FRAGS_READY_FOR(tp, MAX_SKB_FRAGS)) {
+		/* Avoid wrongly optimistic queue wake-up: rtl_tx thread must
+		 * not miss a ring update when it notices a stopped queue.
+		 */
+		smp_wmb();
+		netif_stop_queue(dev);
+		/* Sync with rtl_tx:
+		 * - publish queue status and cur_tx ring index (write barrier)
+		 * - refresh dirty_tx ring index (read barrier).
+		 * May the current thread have a pessimistic view of the ring
+		 * status and forget to wake up queue, a racing rtl_tx thread
+		 * can't.
+		 */
+		smp_mb();
+		if (TX_FRAGS_READY_FOR(tp, MAX_SKB_FRAGS))
+			netif_wake_queue(dev);
+	}
+
+	return NETDEV_TX_OK;
+
+err_dma_1:
+	rtl8169_unmap_tx_skb(d, tp->tx_skb + entry, txd);
+err_dma_0:
+	dev_kfree_skb(skb);
+err_update_stats:
+	dev->stats.tx_dropped++;
+	return NETDEV_TX_OK;
+
+err_stop_0:
+	netif_stop_queue(dev);
+	dev->stats.tx_dropped++;
+	return NETDEV_TX_BUSY;
+}
+
+static void rtl8169_pcierr_interrupt(struct net_device *dev)
+{
+#if 0	//barry
+	struct rtl8169_private *tp = netdev_priv(dev);
+	struct platform_device *pdev = tp->pdev;
+	u16 pci_status, pci_cmd;
+
+	pci_read_config_word(pdev, PCI_COMMAND, &pci_cmd);
+	pci_read_config_word(pdev, PCI_STATUS, &pci_status);
+
+	netif_err(tp, intr, dev, "PCI error (cmd = 0x%04x, status = 0x%04x)\n",
+		  pci_cmd, pci_status);
+
+	/*
+	 * The recovery sequence below admits a very elaborated explanation:
+	 * - it seems to work;
+	 * - I did not see what else could be done;
+	 * - it makes iop3xx happy.
+	 *
+	 * Feel free to adjust to your needs.
+	 */
+	if (pdev->broken_parity_status)
+		pci_cmd &= ~PCI_COMMAND_PARITY;
+	else
+		pci_cmd |= PCI_COMMAND_SERR | PCI_COMMAND_PARITY;
+
+	pci_write_config_word(pdev, PCI_COMMAND, pci_cmd);
+
+	pci_write_config_word(pdev, PCI_STATUS,
+		pci_status & (PCI_STATUS_DETECTED_PARITY |
+		PCI_STATUS_SIG_SYSTEM_ERROR | PCI_STATUS_REC_MASTER_ABORT |
+		PCI_STATUS_REC_TARGET_ABORT | PCI_STATUS_SIG_TARGET_ABORT));
+
+	/* The infamous DAC f*ckup only happens at boot time */
+	if ((tp->cp_cmd & PCIDAC) && !tp->cur_rx) {
+		void __iomem *ioaddr = tp->mmio_addr;
+
+		netif_info(tp, intr, dev, "disabling PCI DAC\n");
+		tp->cp_cmd &= ~PCIDAC;
+		RTL_W16(CPlusCmd, tp->cp_cmd);
+		dev->features &= ~NETIF_F_HIGHDMA;
+	}
+
+	rtl8169_hw_reset(tp);
+
+	rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+#endif
+}
+
+static void rtl_tx(struct net_device *dev, struct rtl8169_private *tp)
+{
+	unsigned int dirty_tx, tx_left;
+
+	dirty_tx = tp->dirty_tx;
+	smp_rmb();
+	tx_left = tp->cur_tx - dirty_tx;
+
+	while (tx_left > 0) {
+		unsigned int entry = dirty_tx % NUM_TX_DESC;
+		struct ring_info *tx_skb = tp->tx_skb + entry;
+		u32 status;
+
+		rmb();
+		status = le32_to_cpu(tp->TxDescArray[entry].opts1);
+		if (status & DescOwn)
+			break;
+
+		rtl8169_unmap_tx_skb(&tp->pdev->dev, tx_skb,
+				     tp->TxDescArray + entry);
+		if (status & LastFrag) {
+			u64_stats_update_begin(&tp->tx_stats.syncp);
+			tp->tx_stats.packets++;
+			tp->tx_stats.bytes += tx_skb->skb->len;
+			u64_stats_update_end(&tp->tx_stats.syncp);
+			dev_kfree_skb(tx_skb->skb);
+			tx_skb->skb = NULL;
+		}
+		dirty_tx++;
+		tx_left--;
+	}
+
+	if (tp->dirty_tx != dirty_tx) {
+		tp->dirty_tx = dirty_tx;
+		/* Sync with rtl8169_start_xmit:
+		 * - publish dirty_tx ring index (write barrier)
+		 * - refresh cur_tx ring index and queue status (read barrier)
+		 * May the current thread miss the stopped queue condition,
+		 * a racing xmit thread can only have a right view of the
+		 * ring status.
+		 */
+		smp_mb();
+		if (netif_queue_stopped(dev) &&
+		    TX_FRAGS_READY_FOR(tp, MAX_SKB_FRAGS)) {
+			netif_wake_queue(dev);
+		}
+		/*
+		 * 8168 hack: TxPoll requests are lost when the Tx packets are
+		 * too close. Let's kick an extra TxPoll request when a burst
+		 * of start_xmit activity is detected (if it is not detected,
+		 * it is slow enough). -- FR
+		 */
+		if (tp->cur_tx != dirty_tx) {
+			void __iomem *ioaddr = tp->mmio_addr;
+
+			RTL_W8(TxPoll, NPQ);
+		}
+	}
+}
+
+static inline int rtl8169_fragmented_frame(u32 status)
+{
+	return (status & (FirstFrag | LastFrag)) != (FirstFrag | LastFrag);
+}
+
+static inline void rtl8169_rx_csum(struct sk_buff *skb, u32 opts1)
+{
+	u32 status = opts1 & RxProtoMask;
+
+	if (((status == RxProtoTCP) && !(opts1 & TCPFail)) ||
+	    ((status == RxProtoUDP) && !(opts1 & UDPFail)))
+		skb->ip_summed = CHECKSUM_UNNECESSARY;
+	else
+		skb_checksum_none_assert(skb);
+}
+
+static struct sk_buff *rtl8169_try_rx_copy(void *data,
+					   struct rtl8169_private *tp,
+					   int pkt_size,
+					   dma_addr_t addr)
+{
+	struct sk_buff *skb;
+	struct device *d = &tp->pdev->dev;
+
+	data = rtl8169_align(data);
+	dma_sync_single_for_cpu(d, addr, pkt_size, DMA_FROM_DEVICE);
+	prefetch(data);
+	skb = netdev_alloc_skb_ip_align(tp->dev, pkt_size);
+	if (skb)
+		memcpy(skb->data, data, pkt_size);
+	dma_sync_single_for_device(d, addr, pkt_size, DMA_FROM_DEVICE);
+
+	return skb;
+}
+
+static int rtl_rx(struct net_device *dev, struct rtl8169_private *tp, u32 budget)
+{
+	unsigned int cur_rx, rx_left;
+	unsigned int count;
+
+	cur_rx = tp->cur_rx;
+
+	for (rx_left = min(budget, NUM_RX_DESC); rx_left > 0; rx_left--, cur_rx++) {
+		unsigned int entry = cur_rx % NUM_RX_DESC;
+		struct RxDesc *desc = tp->RxDescArray + entry;
+		u32 status;
+
+		rmb();
+		status = le32_to_cpu(desc->opts1) & tp->opts1_mask;
+
+		if (status & DescOwn)
+			break;
+		if (unlikely(status & RxRES)) {
+			netif_info(tp, rx_err, dev, "Rx ERROR. status = %08x\n",
+				   status);
+			dev->stats.rx_errors++;
+			if (status & (RxRWT | RxRUNT))
+				dev->stats.rx_length_errors++;
+			if (status & RxCRC)
+				dev->stats.rx_crc_errors++;
+			if (status & RxFOVF) {
+				rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+				dev->stats.rx_fifo_errors++;
+			}
+			if ((status & (RxRUNT | RxCRC)) &&
+			    !(status & (RxRWT | RxFOVF)) &&
+			    (dev->features & NETIF_F_RXALL))
+				goto process_pkt;
+		} else {
+			struct sk_buff *skb;
+			dma_addr_t addr;
+			int pkt_size;
+
+process_pkt:
+			addr = le64_to_cpu(desc->addr);
+			if (likely(!(dev->features & NETIF_F_RXFCS)))
+				pkt_size = (status & 0x00003fff) - 4;
+			else
+				pkt_size = status & 0x00003fff;
+
+			/*
+			 * The driver does not support incoming fragmented
+			 * frames. They are seen as a symptom of over-mtu
+			 * sized frames.
+			 */
+			if (unlikely(rtl8169_fragmented_frame(status))) {
+				dev->stats.rx_dropped++;
+				dev->stats.rx_length_errors++;
+				goto release_descriptor;
+			}
+
+			skb = rtl8169_try_rx_copy(tp->Rx_databuff[entry],
+						  tp, pkt_size, addr);
+			if (!skb) {
+				dev->stats.rx_dropped++;
+				goto release_descriptor;
+			}
+
+			rtl8169_rx_csum(skb, status);
+			skb_put(skb, pkt_size);
+			skb->protocol = eth_type_trans(skb, dev);
+
+			rtl8169_rx_vlan_tag(desc, skb);
+
+			napi_gro_receive(&tp->napi, skb);
+
+			u64_stats_update_begin(&tp->rx_stats.syncp);
+			tp->rx_stats.packets++;
+			tp->rx_stats.bytes += pkt_size;
+			u64_stats_update_end(&tp->rx_stats.syncp);
+		}
+release_descriptor:
+		desc->opts2 = 0;
+		wmb();
+		rtl8169_mark_to_asic(desc, rx_buf_sz);
+	}
+
+	count = cur_rx - tp->cur_rx;
+	tp->cur_rx = cur_rx;
+
+	return count;
+}
+
+static irqreturn_t rtl8169_interrupt(int irq, void *dev_instance)
+{
+	struct net_device *dev = dev_instance;
+	struct rtl8169_private *tp = netdev_priv(dev);
+	int handled = 0;
+	u16 status;
+
+	status = rtl_get_events(tp);
+	if (status && status != 0xffff) {
+		status &= RTL_EVENT_NAPI | tp->event_slow;
+		if (status) {
+			handled = 1;
+
+			rtl_irq_disable(tp);
+			napi_schedule(&tp->napi);
+		}
+	}
+	return IRQ_RETVAL(handled);
+}
+
+/*
+ * Workqueue context.
+ */
+static void rtl_slow_event_work(struct rtl8169_private *tp)
+{
+	struct net_device *dev = tp->dev;
+	void __iomem *ioaddr = tp->mmio_addr;
+	u16 status;
+
+	status = rtl_get_events(tp) & tp->event_slow;
+	rtl_ack_events(tp, status);
+
+	if (unlikely(status & RxFIFOOver)) {
+		switch (tp->mac_version) {
+		/* Work around for rx fifo overflow */
+		case RTL_GIGA_MAC_VER_11:
+			netif_stop_queue(dev);
+			/* XXX - Hack alert. See rtl_task(). */
+			set_bit(RTL_FLAG_TASK_RESET_PENDING, tp->wk.flags);
+		default:
+			break;
+		}
+	}
+
+	if (unlikely(status & SYSErr))
+		rtl8169_pcierr_interrupt(dev);
+
+	if (status & LinkChg)
+	{
+		__rtl8169_check_link_status(dev, tp, tp->mmio_addr, true);
+		
+		/* Add for link status change */
+		tp->link_chg = 1;
+		wake_up(&tp->thr_wait);
+
+                // prevet ALDPS enter MAC Powercut Tx/Rx disable
+                // use MAC reset to set counter to offset 0 
+		if (tp->link_ok(ioaddr))		
+		{
+		   rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+		}
+		else
+		{
+		   mod_timer(&tp->timer, jiffies + RTL8169_PHY_TIMEOUT);			
+		}
+	}
+
+	rtl_irq_enable_all(tp);
+}
+
+static void rtl_task(struct work_struct *work)
+{
+	static const struct {
+		int bitnr;
+		void (*action)(struct rtl8169_private *);
+	} rtl_work[] = {
+		/* XXX - keep rtl_slow_event_work() as first element. */
+		{ RTL_FLAG_TASK_SLOW_PENDING,	rtl_slow_event_work },
+		{ RTL_FLAG_TASK_RESET_PENDING,	rtl_reset_work },
+		{ RTL_FLAG_TASK_PHY_PENDING,	rtl_phy_work }
+	};
+	struct rtl8169_private *tp =
+		container_of(work, struct rtl8169_private, wk.work);
+	struct net_device *dev = tp->dev;
+	int i;
+
+	rtl_lock_work(tp);
+
+	if (!netif_running(dev) ||
+	    !test_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags))
+		goto out_unlock;
+
+	for (i = 0; i < ARRAY_SIZE(rtl_work); i++) {
+		bool pending;
+
+		pending = test_and_clear_bit(rtl_work[i].bitnr, tp->wk.flags);
+		if (pending)
+			rtl_work[i].action(tp);
+	}
+
+out_unlock:
+	rtl_unlock_work(tp);
+}
+
+static int rtl8169_poll(struct napi_struct *napi, int budget)
+{
+	struct rtl8169_private *tp = container_of(napi, struct rtl8169_private, napi);
+	struct net_device *dev = tp->dev;
+	u16 enable_mask = RTL_EVENT_NAPI | tp->event_slow;
+	int work_done= 0;
+	u16 status;
+
+	status = rtl_get_events(tp);
+	rtl_ack_events(tp, status & ~tp->event_slow);
+
+	if (status & RTL_EVENT_NAPI_RX)
+		work_done = rtl_rx(dev, tp, (u32) budget);
+
+	if (status & RTL_EVENT_NAPI_TX)
+		rtl_tx(dev, tp);
+
+	if (status & tp->event_slow) {
+		enable_mask &= ~tp->event_slow;
+
+		rtl_schedule_task(tp, RTL_FLAG_TASK_SLOW_PENDING);
+	}
+
+	if (work_done < budget) {
+		napi_complete(napi);
+
+		rtl_irq_enable(tp, enable_mask);
+		mmiowb();
+	}
+
+	return work_done;
+}
+
+static void rtl8169_rx_missed(struct net_device *dev, void __iomem *ioaddr)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (tp->mac_version > RTL_GIGA_MAC_VER_06)
+		return;
+
+	dev->stats.rx_missed_errors += (RTL_R32(RxMissed) & 0xffffff);
+	RTL_W32(RxMissed, 0);
+}
+
+static void rtl8169_down(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	del_timer_sync(&tp->timer);
+
+	napi_disable(&tp->napi);
+	netif_stop_queue(dev);
+
+	rtl8169_hw_reset(tp);
+	/*
+	 * At this point device interrupts can not be enabled in any function,
+	 * as netif_running is not true (rtl8169_interrupt, rtl8169_reset_task)
+	 * and napi is disabled (rtl8169_poll).
+	 */
+	rtl8169_rx_missed(dev, ioaddr);
+
+	/* Give a racing hard_start_xmit a few cycles to complete. */
+	synchronize_sched();
+
+	rtl8169_tx_clear(tp);
+
+	rtl8169_rx_clear(tp);
+
+	rtl_pll_power_down(tp);
+}
+
+static int rtl8169_close(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	struct platform_device *pdev = tp->pdev;
+
+//	pm_runtime_get_sync(&pdev->dev);
+
+	/* Update counters before going down */
+	rtl8169_update_counters(dev);
+
+	rtl_lock_work(tp);
+	clear_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags);
+
+	rtl8169_down(dev);
+	rtl_unlock_work(tp);
+
+	free_irq(dev->irq, dev);
+
+	dma_free_coherent(&pdev->dev, R8169_RX_RING_BYTES, tp->RxDescArray,
+			  tp->RxPhyAddr);
+	dma_free_coherent(&pdev->dev, R8169_TX_RING_BYTES, tp->TxDescArray,
+			  tp->TxPhyAddr);
+	tp->TxDescArray = NULL;
+	tp->RxDescArray = NULL;
+
+//	pm_runtime_put_sync(&pdev->dev);
+
+	return 0;
+}
+
+#ifdef CONFIG_NET_POLL_CONTROLLER
+static void rtl8169_netpoll(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	rtl8169_interrupt(tp->pdev->irq, dev);
+}
+#endif
+
+static int rtl_open(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	struct platform_device *pdev = tp->pdev;
+	int retval = -ENOMEM;
+
+//	pm_runtime_get_sync(&pdev->dev);
+
+	/*
+	 * Rx and Tx descriptors needs 256 bytes alignment.
+	 * dma_alloc_coherent provides more.
+	 */
+	tp->TxDescArray = dma_alloc_coherent(&pdev->dev, R8169_TX_RING_BYTES,
+					     &tp->TxPhyAddr, GFP_KERNEL);
+	if (!tp->TxDescArray)
+		goto err_pm_runtime_put;
+
+	tp->RxDescArray = dma_alloc_coherent(&pdev->dev, R8169_RX_RING_BYTES,
+					     &tp->RxPhyAddr, GFP_KERNEL);
+	if (!tp->RxDescArray)
+		goto err_free_tx_0;
+
+	retval = rtl8169_init_ring(dev);
+	if (retval < 0)
+		goto err_free_rx_1;
+
+	INIT_WORK(&tp->wk.work, rtl_task);
+
+	smp_mb();
+
+	//rtl_request_firmware(tp);
+
+	retval = request_irq(dev->irq, rtl8169_interrupt,
+			     (tp->features & RTL_FEATURE_MSI) ? 0 : IRQF_SHARED,
+			     dev->name, dev);
+	if (retval < 0)
+		goto err_release_fw_2;
+
+	rtl_lock_work(tp);
+
+	set_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags);
+
+	napi_enable(&tp->napi);
+
+	rtl8169_init_phy(dev, tp);
+
+	__rtl8169_set_features(dev, dev->features);
+
+	rtl_pll_power_up(tp);
+
+	rtl_hw_start(dev);
+
+	netif_start_queue(dev);
+
+	rtl_unlock_work(tp);
+
+	tp->saved_wolopts = 0;
+//	pm_runtime_put_noidle(&pdev->dev);
+
+	rtl8169_check_link_status(dev, tp, ioaddr);
+out:
+	return retval;
+
+err_release_fw_2:
+	rtl_release_firmware(tp);
+	rtl8169_rx_clear(tp);
+err_free_rx_1:
+	dma_free_coherent(&pdev->dev, R8169_RX_RING_BYTES, tp->RxDescArray,
+			  tp->RxPhyAddr);
+	tp->RxDescArray = NULL;
+err_free_tx_0:
+	dma_free_coherent(&pdev->dev, R8169_TX_RING_BYTES, tp->TxDescArray,
+			  tp->TxPhyAddr);
+	tp->TxDescArray = NULL;
+err_pm_runtime_put:
+//	pm_runtime_put_noidle(&pdev->dev);
+	goto out;
+}
+
+static struct rtnl_link_stats64 *
+rtl8169_get_stats64(struct net_device *dev, struct rtnl_link_stats64 *stats)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+	void __iomem *ioaddr = tp->mmio_addr;
+	unsigned int start;
+
+	if (netif_running(dev))
+		rtl8169_rx_missed(dev, ioaddr);
+
+	do {
+		start = u64_stats_fetch_begin_irq(&tp->rx_stats.syncp);
+		stats->rx_packets = tp->rx_stats.packets;
+		stats->rx_bytes	= tp->rx_stats.bytes;
+	} while (u64_stats_fetch_retry_irq(&tp->rx_stats.syncp, start));
+
+
+	do {
+		start = u64_stats_fetch_begin_irq(&tp->tx_stats.syncp);
+		stats->tx_packets = tp->tx_stats.packets;
+		stats->tx_bytes	= tp->tx_stats.bytes;
+	} while (u64_stats_fetch_retry_irq(&tp->tx_stats.syncp, start));
+
+	stats->rx_dropped	= dev->stats.rx_dropped;
+	stats->tx_dropped	= dev->stats.tx_dropped;
+	stats->rx_length_errors = dev->stats.rx_length_errors;
+	stats->rx_errors	= dev->stats.rx_errors;
+	stats->rx_crc_errors	= dev->stats.rx_crc_errors;
+	stats->rx_fifo_errors	= dev->stats.rx_fifo_errors;
+	stats->rx_missed_errors = dev->stats.rx_missed_errors;
+
+	return stats;
+}
+
+static void rtl8169_net_suspend(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (!netif_running(dev))
+		return;
+
+	netif_device_detach(dev);
+	netif_stop_queue(dev);
+
+	rtl_lock_work(tp);
+	napi_disable(&tp->napi);
+	clear_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags);
+	rtl_unlock_work(tp);
+	
+	rtl8169_hw_reset(tp);
+
+	rtl_pll_power_down(tp);
+}
+
+#ifdef CONFIG_PM
+
+static int rtl8169_suspend(struct device *dev)
+{
+	struct net_device *ndev = dev_get_drvdata(dev);
+
+	rtl8169_net_suspend(ndev);
+
+	//FIXME: disable LED, current solution is switch pad to GPIO input
+	writel(readl(IOMEM(0xfe007310)) & ~0xf0000000, IOMEM(0xfe007310));
+
+	return 0;
+}
+
+static void __rtl8169_resume(struct net_device *dev)
+{
+	struct rtl8169_private *tp = netdev_priv(dev);
+ 	u32 i,j;
+ 	
+	netif_device_attach(dev);
+			
+	printk(KERN_INFO "resume r8169 eth0 gphy work \n");
+
+	i=readl(IOMEM(0xFE000000));	
+	i = i & 0xffffbfff;
+	writel(i,IOMEM(0xFE000000));
+	
+	j=readl(IOMEM(0xFE007088));	
+	j = j & 0xfffff9ff;
+	writel(j,IOMEM(0xFE007088));
+	
+	
+	i=readl(IOMEM(0xFE000000));	
+	i = i | 0x00004000;
+	writel(i,IOMEM(0xFE000000));
+	
+	j=readl(IOMEM(0xFE007088));	
+	j = j | 0x00000600;
+	writel(j,IOMEM(0xFE007088));
+					
+	msleep(300);	
+		
+	//FIXME: switch pad to MAC control
+	writel(readl(IOMEM(0xfe007310)) | 0x50000000, IOMEM(0xfe007310));
+
+	rtl_pll_power_up(tp);
+	rtl_rar_set(tp, tp->dev->dev_addr);
+	rtl_init_rxcfg(tp);
+	
+	rtl_lock_work(tp);
+	napi_enable(&tp->napi);
+	set_bit(RTL_FLAG_TASK_ENABLED, tp->wk.flags);
+	rtl_unlock_work(tp);
+
+	rtl_schedule_task(tp, RTL_FLAG_TASK_RESET_PENDING);
+}
+
+static int rtl8169_resume(struct device *dev)
+{
+	struct net_device *ndev = dev_get_drvdata(dev);
+	struct rtl8169_private *tp = netdev_priv(ndev);
+
+
+	if (netif_running(ndev))
+		__rtl8169_resume(ndev);
+		
+	rtl8169_init_phy(ndev, tp);
+
+	return 0;
+}
+
+static __maybe_unused int rtl8169_runtime_suspend(struct device *dev)
+{
+	struct net_device *ndev = dev_get_drvdata(dev);
+	struct rtl8169_private *tp = netdev_priv(ndev);
+
+	if (!tp->TxDescArray)
+		return 0;
+
+	rtl_lock_work(tp);
+	tp->saved_wolopts = __rtl8169_get_wol(tp);
+	__rtl8169_set_wol(tp, WAKE_ANY);
+	rtl_unlock_work(tp);
+
+	rtl8169_net_suspend(ndev);
+
+	return 0;
+}
+
+static __maybe_unused int rtl8169_runtime_resume(struct device *dev)
+{
+	struct net_device *ndev = dev_get_drvdata(dev);
+	struct rtl8169_private *tp = netdev_priv(ndev);
+
+	if (!tp->TxDescArray)
+		return 0;
+
+	rtl_lock_work(tp);
+	__rtl8169_set_wol(tp, tp->saved_wolopts);
+	tp->saved_wolopts = 0;
+	rtl_unlock_work(tp);
+
+	rtl8169_init_phy(ndev, tp);
+
+	__rtl8169_resume(ndev);
+
+	return 0;
+}
+
+static __maybe_unused int rtl8169_runtime_idle(struct device *dev)
+{
+	struct net_device *ndev = dev_get_drvdata(dev);
+	struct rtl8169_private *tp = netdev_priv(ndev);
+
+	return tp->TxDescArray ? -EBUSY : 0;
+}
+
+static const struct dev_pm_ops rtl8169_pm_ops = {
+	.suspend		= rtl8169_suspend,
+	.resume			= rtl8169_resume,
+	.freeze			= rtl8169_suspend,
+	.thaw			= rtl8169_resume,
+	.poweroff		= rtl8169_suspend,
+	.restore		= rtl8169_resume,
+	.runtime_suspend	= rtl8169_runtime_suspend,
+	.runtime_resume		= rtl8169_runtime_resume,
+	.runtime_idle		= rtl8169_runtime_idle,
+};
+
+#define RTL8169_PM_OPS	(&rtl8169_pm_ops)
+
+#else /* !CONFIG_PM */
+
+#define RTL8169_PM_OPS	NULL
+
+#endif /* !CONFIG_PM */
+
+static void rtl_wol_shutdown_quirk(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	/* WoL fails with 8168b when the receiver is disabled. */
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_11:
+	case RTL_GIGA_MAC_VER_12:
+	case RTL_GIGA_MAC_VER_17:
+		//pci_clear_master(tp->pdev);
+
+		RTL_W8(ChipCmd, CmdRxEnb);
+		/* PCI commit */
+		RTL_R8(ChipCmd);
+		break;
+	default:
+		break;
+	}
+}
+
+static void rtl_shutdown(struct platform_device *pdev)
+{
+	struct net_device *dev = platform_get_drvdata(pdev);
+	struct rtl8169_private *tp = netdev_priv(dev);
+//	struct device *d = &pdev->dev;
+
+//	pm_runtime_get_sync(d);
+
+	rtl8169_net_suspend(dev);
+
+	/* Restore original MAC address */
+	rtl_rar_set(tp, dev->perm_addr);
+
+	rtl8169_hw_reset(tp);
+
+	if (system_state == SYSTEM_POWER_OFF) {
+		if (__rtl8169_get_wol(tp) & WAKE_ANY) {
+			rtl_wol_suspend_quirk(tp);
+			rtl_wol_shutdown_quirk(tp);
+		}
+
+		//pci_wake_from_d3(pdev, true);
+		//pci_set_power_state(pdev, PCI_D3hot);
+	}
+
+//	pm_runtime_put_noidle(d);
+}
+
+static int rtl_remove_one(struct platform_device *pdev)
+{
+	struct net_device *dev = platform_get_drvdata(pdev);
+	struct rtl8169_private *tp = netdev_priv(dev);
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_27 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_28 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_31) {
+		rtl8168_driver_stop(tp);
+	}
+
+
+#ifdef RTL_PROC	
+	do{	
+		if(tp->dir_dev==NULL)
+			break;
+	
+		remove_proc_entry("wol_enable", tp->dir_dev);	
+	
+		if(rtw_proc==NULL)
+			break;
+	
+		remove_proc_entry(MODULENAME, rtw_proc);	
+		remove_proc_entry("eth0", init_net.proc_net);	
+	
+	        rtw_proc=NULL;
+
+	}while(0);	
+#endif		
+
+	cancel_work_sync(&tp->wk.work);
+
+	netif_napi_del(&tp->napi);
+
+	unregister_netdev(dev);
+
+	rtl_release_firmware(tp);
+
+//	if (pci_dev_run_wake(pdev))
+//		pm_runtime_get_noresume(&pdev->dev);
+
+	/* restore original MAC address */
+	rtl_rar_set(tp, dev->perm_addr);
+
+//	rtl_disable_msi(pdev, tp);
+	rtl8169_release_board(pdev, dev, tp->mmio_addr);
+	platform_set_drvdata(pdev, NULL);
+
+	/* Yukuen: Add for link status uevent. 20150206 */
+	if(tp->kthr){
+	    kthread_stop(tp->kthr);
+        tp->kthr = NULL;
+    }
+	return 0;
+}
+
+static const struct net_device_ops rtl_netdev_ops = {
+	.ndo_open		= rtl_open,
+	.ndo_stop		= rtl8169_close,
+	.ndo_get_stats64	= rtl8169_get_stats64,
+	.ndo_start_xmit		= rtl8169_start_xmit,
+	.ndo_tx_timeout		= rtl8169_tx_timeout,
+	.ndo_validate_addr	= eth_validate_addr,
+	.ndo_change_mtu		= rtl8169_change_mtu,
+	.ndo_fix_features	= rtl8169_fix_features,
+	.ndo_set_features	= rtl8169_set_features,
+	.ndo_set_mac_address	= rtl_set_mac_address,
+	.ndo_do_ioctl		= rtl8169_ioctl,
+	.ndo_set_rx_mode	= rtl_set_rx_mode,
+#ifdef CONFIG_NET_POLL_CONTROLLER
+	.ndo_poll_controller	= rtl8169_netpoll,
+#endif
+
+};
+
+static struct rtl_cfg_info {
+	void (*hw_start)(struct net_device *);
+	unsigned int region;
+	unsigned int align;
+	u16 event_slow;
+	unsigned features;
+	u8 default_ver;
+} rtl_cfg_infos [] = {
+	[RTL_CFG_0] = {
+		.hw_start	= rtl_hw_start_8169,
+		.region		= 1,
+		.align		= 0,
+		.event_slow	= SYSErr | LinkChg | RxOverflow | RxFIFOOver,
+		.features	= RTL_FEATURE_GMII,
+		.default_ver	= RTL_GIGA_MAC_VER_01,
+	},
+	[RTL_CFG_1] = {
+		.hw_start	= rtl_hw_start_8168,
+		.region		= 2,
+		.align		= 8,
+		.event_slow	= SYSErr | LinkChg | RxOverflow,
+		.features	= RTL_FEATURE_GMII | RTL_FEATURE_MSI,
+		.default_ver	= RTL_GIGA_MAC_VER_11,
+	},
+	[RTL_CFG_2] = {
+		.hw_start	= rtl_hw_start_8101,
+		.region		= 2,
+		.align		= 8,
+		.event_slow	= SYSErr | LinkChg | RxOverflow | RxFIFOOver |
+				  PCSTimeout,
+		.features	= RTL_FEATURE_MSI,
+		.default_ver	= RTL_GIGA_MAC_VER_13,
+	}
+};
+
+/* Cfg9346_Unlock assumed. */
+static unsigned rtl_try_msi(struct rtl8169_private *tp,
+			    const struct rtl_cfg_info *cfg)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	unsigned msi = 0;
+	u8 cfg2;
+
+	cfg2 = RTL_R8(Config2) & ~MSIEnable;
+	if (cfg->features & RTL_FEATURE_MSI) {
+#if 0
+
+		if (pci_enable_msi(tp->pci_dev)) {
+			netif_info(tp, hw, tp->dev, "no MSI. Back to INTx.\n");
+		} else {
+			cfg2 |= MSIEnable;
+			msi = RTL_FEATURE_MSI;
+		}
+#endif
+	}
+	if (tp->mac_version <= RTL_GIGA_MAC_VER_06)
+		RTL_W8(Config2, cfg2);
+	return msi;
+}
+
+DECLARE_RTL_COND(rtl_link_list_ready_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return RTL_R8(MCU) & LINK_LIST_RDY;
+}
+
+DECLARE_RTL_COND(rtl_rxtx_empty_cond)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+
+	return (RTL_R8(MCU) & RXTX_EMPTY) == RXTX_EMPTY;
+}
+
+static void rtl_hw_init_8168g(struct rtl8169_private *tp)
+{
+	void __iomem *ioaddr = tp->mmio_addr;
+	u32 data;
+
+	tp->ocp_base = OCP_STD_PHY_BASE;
+
+	RTL_W32(MISC, RTL_R32(MISC) | RXDV_GATED_EN);
+
+	if (!rtl_udelay_loop_wait_high(tp, &rtl_txcfg_empty_cond, 100, 42))
+		return;
+
+	if (!rtl_udelay_loop_wait_high(tp, &rtl_rxtx_empty_cond, 100, 42))
+		return;
+
+	RTL_W8(ChipCmd, RTL_R8(ChipCmd) & ~(CmdTxEnb | CmdRxEnb));
+	msleep(1);		// yukuen mask for SMP issue
+	RTL_W8(MCU, RTL_R8(MCU) & ~NOW_IS_OOB);
+
+	data = r8168_mac_ocp_read(tp, 0xe8de);
+	data &= ~(1 << 14);
+	r8168_mac_ocp_write(tp, 0xe8de, data);
+
+	if (!rtl_udelay_loop_wait_high(tp, &rtl_link_list_ready_cond, 100, 42))
+		return;
+
+	data = r8168_mac_ocp_read(tp, 0xe8de);
+	data |= (1 << 15);
+	r8168_mac_ocp_write(tp, 0xe8de, data);
+
+	if (!rtl_udelay_loop_wait_high(tp, &rtl_link_list_ready_cond, 100, 42))
+		return;
+}
+
+static void rtl_hw_initialize(struct rtl8169_private *tp)
+{
+	switch (tp->mac_version) {
+	case RTL_GIGA_MAC_VER_40:
+	case RTL_GIGA_MAC_VER_41:
+	case RTL_GIGA_MAC_VER_42:
+	case RTL_GIGA_MAC_VER_43:
+		rtl_hw_init_8168g(tp);
+		break;
+
+	default:
+		break;
+	}
+}
+#ifdef RTL_PROC	
+static ssize_t read_proc(struct file *filp,char *buf,size_t count,loff_t *offp ) 
+{
+
+	ssize_t len = 0;
+	static int finished = 0;
+
+	if ( finished ) {
+		printk(KERN_INFO "procfs_read: END\n");
+		finished = 0;
+		return 0;
+	}
+	
+	finished = 1;
+
+	printk(KERN_INFO "read procfs ethernet wol_enable = %x \n",wol_enable);	
+
+	len = sprintf(buf,"%d\n", wol_enable);
+	return len;
+}
+
+static ssize_t write_proc(struct file *file, const char __user *buffer, size_t count, loff_t *pos)
+{     
+	char tmp[32];
+	u32 val,num;	
+	   
+	if (buffer && !copy_from_user(tmp, buffer, sizeof(tmp))) 
+	{          
+		num = sscanf(tmp, "%x", &val);
+		wol_enable=val;	      
+		printk(KERN_INFO "write procfs ethernet wol_enable = %x \n",wol_enable);
+	}				      
+	return count;     
+}
+
+static const struct file_operations proc_fops = {
+.read= read_proc,
+.write= write_proc,
+};
+
+#endif	
+
+static int
+rtl_init_one(struct platform_device *pdev)
+{
+	struct rtl_cfg_info *cfg;
+	struct rtl8169_private *tp;
+	struct mii_if_info *mii;
+	struct net_device *ndev;
+	void __iomem *ioaddr;
+	int chipset, i;
+	int rc;
+	int rtl_config;
+	int mac_version;
+	int irq;
+	const char *mac_addr;
+
+	struct clk *clk_etn  = clk_get(&pdev->dev, "etn");
+	if (IS_ERR(clk_etn)) {
+		printk(KERN_ERR "%s: clk_get() returns %ld\n", __func__, PTR_ERR(clk_etn));
+		clk_etn = NULL;
+	}
+
+	struct clk *clk_etn_sys  = clk_get(&pdev->dev, "etn_sys");
+	if (IS_ERR(clk_etn_sys)) {
+		printk(KERN_ERR "%s: clk_get() returns %ld\n", __func__, PTR_ERR(clk_etn_sys));
+		clk_etn_sys = NULL;
+        }
+
+	struct clk *clk_etn_250m = clk_get(&pdev->dev, "etn_250m");
+	if (IS_ERR(clk_etn_250m)) {
+		printk(KERN_ERR "%s: clk_get() returns %ld\n", __func__, PTR_ERR(clk_etn_250m));
+		clk_etn_250m = NULL;
+	}
+
+	struct reset_control *rstc_etn = reset_control_get(&pdev->dev, "rst_etn");
+	if (IS_ERR(rstc_etn)) {
+		printk(KERN_ERR "%s: reset_control_get() returns %ld\n", __func__, PTR_ERR(rstc_etn));
+		rstc_etn = NULL;
+	}
+
+#ifdef RTL_PROC	
+	struct proc_dir_entry *dir_dev = NULL;
+	struct proc_dir_entry *entry=NULL;
+#endif	
+
+	if (netif_msg_drv(&debug)) {
+		printk(KERN_INFO "%s Gigabit Ethernet driver %s loaded\n",
+		       MODULENAME, RTL8169_VERSION);
+	}
+
+#if 1	//barry
+	if (of_property_read_u32(pdev->dev.of_node, "rtl-config", &rtl_config)) {
+		dprintk("%s canot specified config", __func__);
+	}
+	cfg = rtl_cfg_infos + rtl_config;
+	if (of_property_read_u32(pdev->dev.of_node, "mac-version", &mac_version)) {
+		dprintk("%s canot specified config", __func__);
+	}
+	if (soc_is_rtk1195() && (realtek_rev() == RTK1195_REV_A)) {
+		if (of_property_read_u32(pdev->dev.of_node, "rtl-features", &(cfg->features))) {
+			cfg->features &= ~RTL_FEATURE_GMII;
+		}
+	}
+	if (of_get_property(pdev->dev.of_node, "force-Gb-off", NULL)) {
+		pr_err("~~~ disable Gb features~~~\n");
+		cfg->features &= ~RTL_FEATURE_GMII;
+	}
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (!pdev->dev.dma_mask)
+		pdev->dev.dma_mask = &pdev->dev.coherent_dma_mask;
+	if (!pdev->dev.coherent_dma_mask)
+		pdev->dev.coherent_dma_mask = DMA_BIT_MASK(32);
+
+	ioaddr = of_iomap(pdev->dev.of_node, 0);
+#endif
+
+	ndev = alloc_etherdev(sizeof (*tp));
+	if (!ndev) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	SET_NETDEV_DEV(ndev, &pdev->dev);
+	ndev->netdev_ops = &rtl_netdev_ops;
+	ndev->irq = irq;
+	tp = netdev_priv(ndev);
+	tp->dev = ndev;
+	tp->pdev = pdev;
+	tp->msg_enable = netif_msg_init(debug.msg_enable, R8169_MSG_DEFAULT);
+	tp->mac_version = mac_version - 1;
+
+	mii = &tp->mii;
+	mii->dev = ndev;
+	mii->mdio_read = rtl_mdio_read;
+	mii->mdio_write = rtl_mdio_write;
+	mii->phy_id_mask = 0x1f;
+	mii->reg_num_mask = 0x1f;
+	mii->supports_gmii = !!(cfg->features & RTL_FEATURE_GMII);
+
+	clk_prepare_enable(clk_etn);
+	clk_prepare_enable(clk_etn_sys);
+	clk_prepare_enable(clk_etn_250m);
+	reset_control_deassert(rstc_etn);
+#if 0	//barry
+	/* disable ASPM completely as that cause random device stop working
+	 * problems as well as full system hangs for some PCIe devices users */
+	pci_disable_link_state(pdev, PCIE_LINK_STATE_L0S | PCIE_LINK_STATE_L1 |
+				     PCIE_LINK_STATE_CLKPM);
+
+	/* enable device (incl. PCI PM wakeup and hotplug setup) */
+	rc = pci_enable_device(pdev);
+	if (rc < 0) {
+		netif_err(tp, probe, dev, "enable failure\n");
+		goto err_out_free_dev_1;
+	}
+
+	if (pci_set_mwi(pdev) < 0)
+		netif_info(tp, probe, dev, "Mem-Wr-Inval unavailable\n");
+
+	/* make sure PCI base addr 1 is MMIO */
+	if (!(pci_resource_flags(pdev, region) & IORESOURCE_MEM)) {
+		netif_err(tp, probe, dev,
+			  "region #%d not an MMIO resource, aborting\n",
+			  region);
+		rc = -ENODEV;
+		goto err_out_mwi_2;
+	}
+
+	/* check for weird/broken PCI region reporting */
+	if (pci_resource_len(pdev, region) < R8169_REGS_SIZE) {
+		netif_err(tp, probe, dev,
+			  "Invalid PCI region size(s), aborting\n");
+		rc = -ENODEV;
+		goto err_out_mwi_2;
+	}
+
+	rc = pci_request_regions(pdev, MODULENAME);
+	if (rc < 0) {
+		netif_err(tp, probe, dev, "could not request regions\n");
+		goto err_out_mwi_2;
+	}
+
+	tp->cp_cmd = RxChkSum;
+
+	if ((sizeof(dma_addr_t) > 4) &&
+	    !pci_set_dma_mask(pdev, DMA_BIT_MASK(64)) && use_dac) {
+		tp->cp_cmd |= PCIDAC;
+		dev->features |= NETIF_F_HIGHDMA;
+	} else {
+		rc = pci_set_dma_mask(pdev, DMA_BIT_MASK(32));
+		if (rc < 0) {
+			netif_err(tp, probe, dev, "DMA configuration failed\n");
+			goto err_out_free_res_3;
+		}
+	}
+
+	/* ioremap MMIO region */
+	ioaddr = ioremap(pci_resource_start(pdev, region), R8169_REGS_SIZE);
+	if (!ioaddr) {
+		netif_err(tp, probe, dev, "cannot remap MMIO, aborting\n");
+		rc = -EIO;
+		goto err_out_free_res_3;
+	}
+#endif
+#ifdef RTL_PROC		
+ 	do{
+		// create /proc/net/$rtw_proc_name
+		rtw_proc=proc_mkdir_data("eth0",  S_IRUGO|S_IXUGO,init_net.proc_net, NULL);
+
+		if (rtw_proc == NULL) {
+			//DBG_871X(KERN_ERR "Unable to create rtw_proc directory\n");
+			printk(KERN_INFO "procfs:create /proc/net/eth0 failed\n");
+			break;
+		}
+		
+		// create /proc/net/$rtw_proc_name/$dev->name
+		if(tp->dir_dev == NULL)
+		{
+			tp->dir_dev = proc_mkdir_data(MODULENAME, S_IFDIR | S_IRUGO | S_IXUGO,rtw_proc, NULL);
+			dir_dev = tp->dir_dev;
+
+			if(dir_dev==NULL)
+			{
+				printk(KERN_INFO "procfs:create /proc/net/eth0/r8169 failed\n");
+				
+				if(rtw_proc){
+					remove_proc_entry("eth0", init_net.proc_net);
+					rtw_proc = NULL;
+				}						
+				break;
+			}		
+		}
+		else
+		{
+			break;
+		}
+
+
+		entry = proc_create_data("wol_enable", S_IFREG | S_IRUGO,
+				   dir_dev, &proc_fops, NULL);
+		if (!entry) {
+			printk(KERN_INFO "procfs:create /proc/net/eth0/r8169/wol_enable failed\n");		
+			break;
+		}		
+	}while(0);	
+#endif	
+	tp->mmio_addr = ioaddr;
+
+//	if (!pci_is_pcie(pdev))
+//		netif_info(tp, probe, dev, "not PCI Express\n");
+
+	/* Identify chip attached to board */
+	rtl8169_get_mac_version(tp, ndev, cfg->default_ver);
+
+	rtl_init_rxcfg(tp);
+
+	rtl_irq_disable(tp);
+
+	rtl_hw_initialize(tp);
+
+	rtl_hw_reset(tp);
+
+	rtl_ack_events(tp, 0xffff);
+
+//	pci_set_master(pdev);
+
+	/*
+	 * Pretend we are using VLANs; This bypasses a nasty bug where
+	 * Interrupts stop flowing on high load on 8110SCd controllers.
+	 */
+	if (tp->mac_version == RTL_GIGA_MAC_VER_05)
+		tp->cp_cmd |= RxVlan;
+
+	rtl_init_mdio_ops(tp);
+	rtl_init_pll_power_ops(tp);
+	rtl_init_jumbo_ops(tp);
+	rtl_init_csi_ops(tp);
+
+	rtl8169_print_mac_version(tp);
+
+	chipset = tp->mac_version;
+	tp->txd_version = rtl_chip_infos[chipset].txd_version;
+
+	RTL_W8(Cfg9346, Cfg9346_Unlock);
+	RTL_W8(Config1, RTL_R8(Config1) | PMEnable);
+	RTL_W8(Config5, RTL_R8(Config5) & PMEStatus);
+
+	//disable magic packet WOL
+	RTL_W8(Config3, RTL_R8(Config3) & ~MagicPacket);	
+
+	if ((RTL_R8(Config3) & (LinkUp | MagicPacket)) != 0)
+		tp->features |= RTL_FEATURE_WOL;
+	if ((RTL_R8(Config5) & (UWF | BWF | MWF)) != 0)
+		tp->features |= RTL_FEATURE_WOL;
+	tp->features |= rtl_try_msi(tp, cfg);
+	RTL_W8(Cfg9346, Cfg9346_Lock);
+
+	if (rtl_tbi_enabled(tp)) {
+		tp->set_speed = rtl8169_set_speed_tbi;
+		tp->get_settings = rtl8169_gset_tbi;
+		tp->phy_reset_enable = rtl8169_tbi_reset_enable;
+		tp->phy_reset_pending = rtl8169_tbi_reset_pending;
+		tp->link_ok = rtl8169_tbi_link_ok;
+		tp->do_ioctl = rtl_tbi_ioctl;
+	} else {
+		tp->set_speed = rtl8169_set_speed_xmii;
+		tp->get_settings = rtl8169_gset_xmii;
+		tp->phy_reset_enable = rtl8169_xmii_reset_enable;
+		tp->phy_reset_pending = rtl8169_xmii_reset_pending;
+		tp->link_ok = rtl8169_xmii_link_ok;
+		tp->do_ioctl = rtl_xmii_ioctl;
+	}
+
+	mutex_init(&tp->wk.mutex);
+
+	/* Get MAC address */
+	mac_addr = of_get_mac_address(pdev->dev.of_node);
+	if (mac_addr)
+		rtl_rar_set(tp, (u8*)mac_addr);
+
+	for (i = 0; i < ETH_ALEN; i++)
+		ndev->dev_addr[i] = RTL_R8(MAC0 + i);
+
+	ndev->ethtool_ops = &rtl8169_ethtool_ops;
+	ndev->watchdog_timeo = RTL8169_TX_TIMEOUT;
+
+	netif_napi_add(ndev, &tp->napi, rtl8169_poll, R8169_NAPI_WEIGHT);
+
+	/* don't enable SG, IP_CSUM and TSO by default - it might not work
+	 * properly for all devices */
+	ndev->features |= NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |NETIF_F_RXCSUM | NETIF_F_HW_VLAN_CTAG_TX | NETIF_F_HW_VLAN_CTAG_RX;
+
+	ndev->hw_features = NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |
+		NETIF_F_RXCSUM | NETIF_F_HW_VLAN_CTAG_TX |
+		NETIF_F_HW_VLAN_CTAG_RX;
+	ndev->vlan_features = NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |
+		NETIF_F_HIGHDMA;
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_05)
+		/* 8110SCd requires hardware Rx VLAN - disallow toggling */
+		ndev->hw_features &= ~NETIF_F_HW_VLAN_CTAG_RX;
+
+	ndev->hw_features |= NETIF_F_RXALL;
+	ndev->hw_features |= NETIF_F_RXFCS;
+
+	tp->hw_start = cfg->hw_start;
+	tp->event_slow = cfg->event_slow;
+
+	tp->opts1_mask = (tp->mac_version != RTL_GIGA_MAC_VER_01) ?
+		~(RxBOVF | RxFOVF) : ~0;
+
+	init_timer(&tp->timer);
+	tp->timer.data = (unsigned long) ndev;
+	tp->timer.function = rtl8169_phy_timer;
+
+	tp->rtl_fw = RTL_FIRMWARE_UNKNOWN;
+
+	rc = register_netdev(ndev);
+	if (rc < 0)
+		goto err_out_msi_4;
+
+//	pci_set_drvdata(pdev, dev);
+	platform_set_drvdata(pdev, ndev);
+
+	netif_info(tp, probe, ndev, "%s at 0x%p, %pM, XID %08x IRQ %d\n",
+		   rtl_chip_infos[chipset].name, ioaddr, ndev->dev_addr,
+		   (u32)(RTL_R32(TxConfig) & 0x9cf0f8ff), ndev->irq);
+	if (rtl_chip_infos[chipset].jumbo_max != JUMBO_1K) {
+		netif_info(tp, probe, ndev, "jumbo features [frames: %d bytes, "
+			   "tx checksumming: %s]\n",
+			   rtl_chip_infos[chipset].jumbo_max,
+			   rtl_chip_infos[chipset].jumbo_tx_csum ? "ok" : "ko");
+	}
+
+	if (tp->mac_version == RTL_GIGA_MAC_VER_27 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_28 ||
+	    tp->mac_version == RTL_GIGA_MAC_VER_31) {
+		rtl8168_driver_start(tp);
+	}
+
+	device_set_wakeup_enable(&pdev->dev, tp->features & RTL_FEATURE_WOL);
+
+//	if (pci_dev_run_wake(pdev))
+//		pm_runtime_put_noidle(&pdev->dev);
+
+	netif_carrier_off(ndev);
+
+	/* Yukuen: Add for link status uevent. 20150206 */
+	init_waitqueue_head(&tp->thr_wait);
+	tp->link_chg = 0;
+	tp->kthr = NULL;
+	tp->kthr = kthread_create(link_status, (void*)ndev, "%s-linkstatus", ndev->name);
+	if(IS_ERR(tp->kthr)){
+	    tp->kthr = NULL;
+	    printk (KERN_WARNING "%s: unable to start kthread for link status.\n",
+	            ndev->name);
+	}	
+	else{
+	    wake_up_process(tp->kthr);  // run thread function
+	}	
+
+out:
+	return rc;
+
+err_out_msi_4:
+	netif_napi_del(&tp->napi);
+//	rtl_disable_msi(pdev, tp);
+//	iounmap(ioaddr);
+//err_out_free_res_3:
+//	pci_release_regions(pdev);
+//err_out_mwi_2:
+//	pci_clear_mwi(pdev);
+//	pci_disable_device(pdev);
+//err_out_free_dev_1:
+	free_netdev(ndev);
+	goto out;
+}
+
+static struct platform_driver rtl8169_soc_driver = {
+	.probe		= rtl_init_one,
+	.remove		= rtl_remove_one,
+	.shutdown	= rtl_shutdown,
+	.driver = {
+		.name		= MODULENAME,
+		.owner		= THIS_MODULE,
+		.pm			= RTL8169_PM_OPS,
+		.of_match_table = of_match_ptr(rtl8169_dt_ids),
+	},
+};
+
+module_platform_driver(rtl8169_soc_driver);
diff --git a/drivers/net/irda/Kconfig b/drivers/net/irda/Kconfig
index e070e12..7801e1b 100644
--- a/drivers/net/irda/Kconfig
+++ b/drivers/net/irda/Kconfig
@@ -393,6 +393,9 @@ config MCS_FIR
 
 	  To compile it as a module, choose M here: the module will be called
 	  mcs7780.
+	  
+source "drivers/net/irda/realtek/Kconfig"
 
 endmenu
 
+
diff --git a/drivers/net/irda/Makefile b/drivers/net/irda/Makefile
index 4c34443..fc884b1 100644
--- a/drivers/net/irda/Makefile
+++ b/drivers/net/irda/Makefile
@@ -19,6 +19,7 @@ obj-$(CONFIG_VIA_FIR)		+= via-ircc.o
 obj-$(CONFIG_PXA_FICP)	        += pxaficp_ir.o
 obj-$(CONFIG_MCS_FIR)	        += mcs7780.o
 obj-$(CONFIG_AU1000_FIR)	+= au1k_ir.o
+obj-$(CONFIG_RTK_IR)		+= realtek/
 # SIR drivers
 obj-$(CONFIG_IRTTY_SIR)		+= irtty-sir.o	sir-dev.o
 obj-$(CONFIG_BFIN_SIR)		+= bfin_sir.o
diff --git a/drivers/net/irda/realtek/Kconfig b/drivers/net/irda/realtek/Kconfig
new file mode 100644
index 00000000..5a53f21
--- /dev/null
+++ b/drivers/net/irda/realtek/Kconfig
@@ -0,0 +1,35 @@
+config RTK_IR
+	tristate "Realtek IR Receiver Driver"
+	default y
+	help
+		IR Receiver Character Device Driver
+ 
+if RTK_IR
+config SUPPORT_INPUT_DEVICE
+	bool "Support IR Input Device"
+	depends on RTK_IR
+	default y
+	help
+	  IR Input Device Support
+
+config SUPPORT_IRTX
+	bool "Support IR TX"
+	depends on RTK_IR
+	default y
+	help
+	  IR TX Support
+
+config YK_54LU
+	bool "Support Skyworth TV Remote Controller"
+	depends on RTK_IR
+	default n
+	help
+	  Skyworth TV Remote Controller
+
+config RTK_MK5_2
+	bool "Support Realtek DTV Controller"
+	depends on RTK_IR
+	default n
+	help
+	  Realtek DTV Remote Controller
+endif
diff --git a/drivers/net/irda/realtek/Makefile b/drivers/net/irda/realtek/Makefile
new file mode 100644
index 00000000..278769d
--- /dev/null
+++ b/drivers/net/irda/realtek/Makefile
@@ -0,0 +1,7 @@
+#
+# Makefile for the Realtek IRDA drivers.
+#
+
+obj-$(CONFIG_RTK_IR)	+= rtk_irda.o \
+				xmp_decoder.o \
+				rc6_decoder.o
diff --git a/drivers/net/irda/realtek/comcast_decoder.c b/drivers/net/irda/realtek/comcast_decoder.c
new file mode 100644
index 00000000..ab92c2c
--- /dev/null
+++ b/drivers/net/irda/realtek/comcast_decoder.c
@@ -0,0 +1,163 @@
+/*
+ *  comcast_decoder.c - RTK irda software decoder for comcast remote
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+#include <linux/io.h>
+#include "irda_sw_decoder.h"
+
+static int get_bit_count(unsigned int *fifo, unsigned int number, unsigned int *ptr, unsigned int *bptr, int polar)
+{
+	unsigned int bit_cnt = 0;
+
+	if(polar != 0 && polar != 1)
+		return -1;
+
+	while(1) {
+		if(*bptr == 0) {
+			(*ptr)++;
+			if( *ptr>=number )
+				return bit_cnt;
+			(*bptr) = 32;
+		} else {
+			if( test_bit((*bptr)-1, (unsigned long *)(fifo+*ptr)) ) {
+				if(polar == 1) {
+					(*bptr)--;
+					bit_cnt++;
+				} else
+					break;
+			} else {
+				if(polar == 0) {
+					(*bptr)--;
+					bit_cnt++;
+				} else
+					break;
+			}
+		}
+	}
+	return bit_cnt;
+}
+
+static int length_table[]=
+{ 20, 23, 27, 30, 34, 37, 40, 44, 47, 51, 54, 58, 61, 64, 68, 71};
+
+static int comcast_length_decode(unsigned int len_h, unsigned int len_l)
+{
+	int i;
+	if( len_h>8 || len_h<3 || len_l<16 || len_l>72 )
+		return -1;
+	for(i=0; i<0x10; i++) {
+		if(len_l < length_table[i])
+			return i;
+	}
+	return i;
+}
+
+static int comcast_checksum(int code)
+{
+	int i;
+	int temp=0;
+	int bits;
+
+	for(i=0; i<8; i++) {
+		if(i!=6) {
+			bits = (code & (0xF<<(4*i)))>>(4*i);
+			temp = temp + bits;
+		}
+	}
+	temp = (~temp+1) & 0xF;
+	if(temp == (code & 0xF<<24)>>24 )
+		return 1;
+	else
+		return 0;
+}
+
+int raw_comcast_decoder(struct swdec_priv *pdec, unsigned int *fifoval, int fifolv)
+{
+	unsigned int length_low=0, length_high=0;
+	int code;
+	unsigned int fifoptr=0, bitptr=32;
+
+	pdec->codenum=0;
+
+	while(1) {
+		length_high = length_low = 0;
+		length_high = get_bit_count(fifoval, fifolv, &fifoptr, &bitptr, 0);
+		length_low = get_bit_count(fifoval, fifolv, &fifoptr, &bitptr, 1);
+		if( bitptr==0 && fifoptr>=fifolv ) {
+			if(pdec->fifostate==3 || pdec->fifostate==1) {
+				pdec->fifostate = pdec->symbol_cnt = pdec->symbol = 0;
+				pdec->length_hb = pdec->length_lb = 0;
+			}
+			break;
+		}
+decode_start:
+		if(pdec->fifostate<2) {
+			if(pdec->fifostate == 1) {
+				if(length_high==0 || length_low==0 || pdec->length_lb==0 || pdec->length_hb==0) {
+					length_low += pdec->length_lb;
+					length_high += pdec->length_hb;
+				} else {
+					if(pdec->length_lb>=336 && pdec->length_lb<=348) {
+						pdec->symbol_cnt = pdec->symbol = 0;
+						pdec->fifostate = 2;
+					} else
+						pdec->fifostate = 0;
+				}
+				pdec->length_hb = pdec->length_lb = 0;
+				if(pdec->fifostate==2)
+					goto decode_start;
+			}
+			if(length_low>=336 && length_low<=348) {
+				pdec->symbol_cnt = pdec->symbol = 0;
+				pdec->fifostate = 2;
+			} else
+				pdec->fifostate = 0;
+		}
+		else if(pdec->fifostate>=2 && pdec->symbol_cnt<=8) {
+			if(pdec->fifostate==3) {
+				pdec->fifostate = 2;
+				if(length_high==0 || length_low==0 || pdec->length_hb==0 || pdec->length_lb==0) {
+					length_low += pdec->length_lb;
+					length_high += pdec->length_hb;
+				} else {
+					code = comcast_length_decode(pdec->length_hb, pdec->length_lb);
+					if(code < 0)
+						pdec->fifostate = pdec->symbol_cnt = pdec->symbol = 0;
+					else
+						pdec->symbol = pdec->symbol | code << (7-pdec->symbol_cnt++)*4;
+				}
+				pdec->length_hb = pdec->length_lb = 0;
+			}
+			if(pdec->symbol_cnt < 8) {
+				code = comcast_length_decode(length_high, length_low);
+				if(code < 0)
+					pdec->fifostate = pdec->symbol_cnt = pdec->symbol = 0;
+				else
+					pdec->symbol = pdec->symbol | code << (7-pdec->symbol_cnt++)*4;
+			}
+			if(pdec->symbol_cnt==8) {
+				if(comcast_checksum(pdec->symbol)) {
+					if( (pdec->symbol & 0xFF00)!=0x4400 )
+						pdec->valid_code[pdec->codenum++] = (pdec->symbol&0xFF00)>>8;
+				}
+				pdec->fifostate = pdec->symbol = pdec->symbol_cnt = 0;
+			}
+		}
+	}
+	if(pdec->fifostate==2 || length_low<350 ) {
+		pdec->length_hb = length_high;
+		pdec->length_lb = length_low;
+		pdec->fifostate += 1;
+	}
+	if(pdec->codenum>0)
+		return pdec->valid_code[pdec->codenum-1];
+	else
+		return -1;
+}
+
diff --git a/drivers/net/irda/realtek/ir_input.c b/drivers/net/irda/realtek/ir_input.c
new file mode 100644
index 00000000..cfd8fc0
--- /dev/null
+++ b/drivers/net/irda/realtek/ir_input.c
@@ -0,0 +1,138 @@
+#include "ir_input.h"
+#include "rtk_ir.h"
+#include <linux/pinctrl/consumer.h>
+//#include <linux/input.h>
+
+static int _rtk_ir_setkeycode(struct input_dev *dev, const struct input_keymap_entry *ke, unsigned int *old_keycode);
+static int _rtk_ir_getkeycode(struct input_dev *dev, struct input_keymap_entry *ke);
+
+extern int rtk_ir_setkeycode(unsigned int scancode, unsigned int new_keycode, unsigned int *p_old_keycode, unsigned long *keybit_addr);
+extern int rtk_ir_getkeycode(unsigned int scancode, unsigned int *p_keycode);
+
+extern void rtk_ir_set_keybit(unsigned long *addr);
+extern void rtk_ir_set_relbit(unsigned long *addr);
+
+
+struct rtk_ir_data {
+	unsigned int irq;
+	struct input_dev *input_dev;
+	u8 keypressed;
+	u32 keycode;
+	atomic_t reportCount;
+};
+
+static struct rtk_ir_data *data = NULL;
+
+long int Input_Keybit_Length = sizeof(data->input_dev->keybit); 
+
+int rtk_ir_input_init(void)
+{
+	struct input_dev *input_dev;
+
+	int result;
+	data = kzalloc(sizeof(*data), GFP_KERNEL);
+	if (!data) {
+		result = -ENOMEM;
+		goto exit;
+	}
+	input_dev = input_allocate_device();
+	if (!input_dev) {
+		result = -ENOMEM;
+		printk(KERN_ERR "rtk IR: can't allocate input device.\n");
+		goto fail_alloc_input_dev;
+	}
+
+	atomic_set(&data->reportCount, 0);
+
+	data->input_dev = input_dev;
+
+//	data->input_dev->evbit[0] = BIT_MASK(EV_KEY) |BIT(EV_REL) |BIT(EV_REP);
+	data->input_dev->evbit[0] = BIT_MASK(EV_KEY) |BIT(EV_REL);
+	data->input_dev->name = "venus_IR_input";
+	data->input_dev->phys = "rtk/input0";
+	
+	data->input_dev->setkeycode = _rtk_ir_setkeycode;
+	data->input_dev->getkeycode = _rtk_ir_getkeycode;
+
+	rtk_ir_set_keybit(data->input_dev->keybit);
+	rtk_ir_set_relbit(data->input_dev->relbit);
+
+	result = input_register_device(data->input_dev);
+	if (result) {
+		printk(KERN_ERR "rtk IR: cannot register input device.\n");
+		goto fail_register_input_dev;
+	}
+/*
+	pinctrl = devm_pinctrl_get_select_default(&(data->input_dev->dev));
+	if (IS_ERR(pinctrl)) {
+		printk(KERN_ERR "rtk IR: pinctrl cannot select default state.\n");
+		goto fail_pinctrl_select_default;
+	}
+*/
+	return 0;
+/*
+fail_pinctrl_select_default:
+	input_unregister_device(data->input_dev);
+*/
+fail_register_input_dev:
+	input_free_device(data->input_dev);
+fail_alloc_input_dev:
+	kfree(data);
+exit:
+	return -1;
+}
+
+void rtk_ir_input_report_key(uint32_t keycode)
+{
+	atomic_inc(&data->reportCount);
+	data->keycode = keycode;
+	input_report_key(data->input_dev, data->keycode, 1);
+	input_sync(data->input_dev);	
+}
+
+void rtk_ir_input_report_end(void)
+{
+	if (atomic_read(&data->reportCount) != 1)//Should not happen
+		pr_err("[IR input] report key not in pairs, reportCount(%d)\n",atomic_read(&data->reportCount));
+
+	atomic_set(&data->reportCount, 0);
+	input_report_key(data->input_dev, data->keycode, 0);
+	input_sync(data->input_dev);
+}
+
+static int _rtk_ir_setkeycode(struct input_dev *dev, const struct input_keymap_entry *ke, unsigned int *old_keycode)
+{
+	unsigned int scancode;
+	unsigned int new_keycode;
+
+	if (input_scancode_to_scalar(ke, &scancode))
+		return -EINVAL;
+	new_keycode = ke->keycode;
+
+	rtk_ir_setkeycode(scancode, new_keycode, old_keycode, data->input_dev->keybit);
+	return 0;
+}
+
+static int _rtk_ir_getkeycode(struct input_dev *dev, struct input_keymap_entry *ke)
+{
+	unsigned int scancode;
+	unsigned int keycode;
+
+	if (input_scancode_to_scalar(ke, &scancode))
+		return -EINVAL;
+
+	if (-1 != rtk_ir_getkeycode(scancode, &keycode))
+	{
+		ke->keycode = keycode;
+		ke->len = sizeof(scancode);
+		memcpy(&ke->scancode, &scancode, sizeof(scancode));
+		return 0;
+	}
+
+	keycode = KEY_RESERVED; //not found, set to KEY_RESERVED
+	ke->keycode = keycode;
+	ke->len = sizeof(scancode);
+	memcpy(&ke->scancode, &scancode, sizeof(scancode));
+
+	return 0;
+}
diff --git a/drivers/net/irda/realtek/ir_input.h b/drivers/net/irda/realtek/ir_input.h
new file mode 100644
index 00000000..99d58b6
--- /dev/null
+++ b/drivers/net/irda/realtek/ir_input.h
@@ -0,0 +1,13 @@
+#ifndef __IR_INPUT_H
+#define __IR_INPUT_H
+
+#include <linux/input.h>
+#include <linux/slab.h>
+#include <linux/types.h>
+
+int rtk_ir_input_init(void);
+void rtk_ir_input_cleanup(void);
+void rtk_ir_input_report_key(uint32_t keycode);
+void rtk_ir_input_report_end(void);
+
+#endif
diff --git a/drivers/net/irda/realtek/irda_sw_decoder.h b/drivers/net/irda/realtek/irda_sw_decoder.h
new file mode 100644
index 00000000..012efec
--- /dev/null
+++ b/drivers/net/irda/realtek/irda_sw_decoder.h
@@ -0,0 +1,21 @@
+/*
+ *  irda_sw_decoder.h - RTK irda software decoder header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+#ifndef __IRDA_SW_DECODER__H__
+#define __IRDA_SW_DECODER__H__
+
+struct swdec_ops {
+	void (*init)(void);
+	int (*decoder)(unsigned int *, int);
+};
+
+extern const struct swdec_ops rc6_swdec_ops;
+extern const struct swdec_ops xmp_swdec_ops;
+#endif
diff --git a/drivers/net/irda/realtek/rc6_decoder.c b/drivers/net/irda/realtek/rc6_decoder.c
new file mode 100644
index 00000000..177f91f
--- /dev/null
+++ b/drivers/net/irda/realtek/rc6_decoder.c
@@ -0,0 +1,238 @@
+/*
+ *  rc6_decoder.c - rc6 decoder for RTK irda driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/io.h>
+#include "irda_sw_decoder.h"
+
+enum {
+	dec_leader = 0,
+	dec_mode,
+	dec_trailer,
+	dec_data,
+	dec_ready,
+};
+
+struct swdec_priv {
+	unsigned int state;
+	unsigned int len_h;
+	unsigned int len_l;
+	unsigned int allcnt;
+	bool remain;
+	int code;
+	unsigned int bitcnt;
+};
+
+static struct swdec_priv dec;
+
+static int get_bitcnt(unsigned int *fifo, unsigned int len,
+		      unsigned int *fifoptr, unsigned int *bitptr, int polar)
+{
+	unsigned int cnt = 0;
+
+	while (1) {
+		if (*bitptr == 0) {
+			(*fifoptr)++;
+			(*bitptr) = 32;
+		}
+		if (*fifoptr >= len) {
+			(*bitptr) = 0;
+			break;
+		}
+		if (test_bit((*bitptr) - 1,
+			     (unsigned long *)(fifo + *fifoptr)) == polar)
+			cnt++;
+		else
+			break;
+		(*bitptr)--;
+	}
+	return cnt;
+}
+
+static int rc6_dec_data(bool *remain, unsigned int bit,
+			unsigned int high, unsigned int low)
+{
+	int data = 0;
+
+	if (high >= 30 && high <= 36) {
+		high = high - 22;
+		*remain = 0;
+	}
+
+	if ((bit == 30 || bit == 31) && low >= 28)
+		low = 11;
+
+	if (high >= 18 && high <= 28) {
+		if (*remain == 0)
+			goto fail;
+		if (low >= 18 && low <= 28)
+			*remain = 1;
+		else if (low >= 8 && low <= 15)
+			*remain = 0;
+		else
+			goto fail;
+
+		data |= (2 << 4) | 0x1;
+	} else if (high >= 8 && high <= 15) {
+		if (low >= 8 && low <= 15) {
+			data |= (1 << 4) | !(*remain);
+		} else if (low >= 18 && low <= 28) {
+			if (*remain == 1)
+				goto fail;
+			data |= (1 << 4) | 1;
+			*remain = 1;
+		} else {
+			goto fail;
+		}
+	} else {
+		goto fail;
+	}
+	return data;
+fail:
+	*remain = 0;
+	return -1;
+}
+
+bool rc6_dec_leader(bool *remain, unsigned int high, unsigned int low)
+{
+	if (high >= 60 && high <= 70) {
+		if (low >= 20 && low <= 25)
+			*remain = 0;
+		else if (low >= 30 && low <= 35)
+			*remain = 1;
+		else
+			goto fail;
+	} else {
+		goto fail;
+	}
+
+	return true;
+fail:
+	remain = 0;
+	return false;
+}
+
+int raw_rc6_decoder(unsigned int *fifo, int len)
+{
+	unsigned int lowcnt[2], highcnt[2];
+	unsigned int fifoptr = 0;
+	unsigned int bitptr = 32;
+	int valid_code = -1;
+	int ptr;
+	int data;
+	int i;
+
+get_length:
+	for (i = 0; i < 2; i++) {
+		lowcnt[i] = 0;
+		highcnt[i] = 0;
+	}
+	ptr = 0;
+	highcnt[ptr] = get_bitcnt(fifo, len, &fifoptr, &bitptr, 0);
+	lowcnt[ptr] = get_bitcnt(fifo, len, &fifoptr, &bitptr, 1);
+
+	if (bitptr == 0 && fifoptr >= len) {
+		if ((highcnt[ptr] + lowcnt[ptr]) == 512 && dec.len_l != 512) {
+			highcnt[ptr] += dec.len_h;
+			lowcnt[ptr] += dec.len_l;
+			dec.len_h = 0;
+			dec.len_l = 512;
+			goto start_decode;
+		}
+		dec.len_h = highcnt[ptr];
+		dec.len_l = lowcnt[ptr];
+		goto end_decode;
+	}
+	if (dec.len_h != 0 || dec.len_l != 0) {
+		if (dec.len_h != 0 && dec.len_l != 0 &&
+		    highcnt[ptr] != 0 && lowcnt[ptr] != 0)
+			ptr++;
+
+		highcnt[ptr] += dec.len_h;
+		lowcnt[ptr] += dec.len_l;
+		dec.len_h = 0;
+		dec.len_l = 0;
+	}
+
+start_decode:
+	switch (dec.state) {
+	case dec_leader:
+		dec.remain = false;
+		if (rc6_dec_leader(&dec.remain, highcnt[ptr], lowcnt[ptr])) {
+			if (dec.remain)
+				dec.allcnt = 11;
+			else
+				dec.allcnt = 0;
+			dec.bitcnt = 0;
+			dec.code = 0;
+			dec.state = dec_mode;
+		}
+		break;
+	case dec_mode:
+		dec.allcnt += (highcnt[ptr] + lowcnt[ptr]);
+		if (dec.allcnt >= 108 && dec.allcnt <= 115) {
+			dec.remain = true;
+			dec.state = dec_data;
+		} else if (dec.allcnt >= 130 && dec.allcnt <= 136) {
+			dec.remain = false;
+			dec.state = dec_data;
+		} else if (dec.allcnt >= 140 && dec.allcnt <= 148) {
+			dec.remain = true;
+			dec.state = dec_data;
+		}
+		if (dec.allcnt >= 150 || dec.allcnt < 0) {
+			dec.allcnt = 0;
+			dec.state = 0;
+		}
+		break;
+	case dec_data:
+		data = rc6_dec_data(&dec.remain, dec.bitcnt,
+				    highcnt[ptr], lowcnt[ptr]);
+		if (data < 0) {
+			pr_err("dec error %d %d\n", highcnt[ptr], lowcnt[ptr]);
+			dec.state = dec_leader;
+		} else {
+			if (((data & 0x30) >> 4) == 0x1) {
+				dec.code |= (data & 0x1) << (31 - dec.bitcnt);
+				dec.bitcnt += 1;
+			} else if (((data & 0x30) >> 4) == 0x2) {
+				dec.code |= (data & 0x3) << (30 - dec.bitcnt);
+				dec.bitcnt += 2;
+			}
+		}
+		if (dec.bitcnt >= 32)
+			dec.state = dec_ready;
+		else
+			break;
+	case dec_ready:
+		valid_code = dec.code & 0x1fffff;
+		dec.state = dec_leader;
+		break;
+	}
+	ptr--;
+	if (ptr >= 0)
+		goto start_decode;
+	else
+		goto get_length;
+
+end_decode:
+	return valid_code;
+}
+
+void raw_rc6_init(void)
+{
+	memset(&dec, 0, sizeof(struct swdec_priv));
+}
+
+const struct swdec_ops rc6_swdec_ops = {
+	.init = raw_rc6_init,
+	.decoder = raw_rc6_decoder,
+};
+
diff --git a/drivers/net/irda/realtek/rtk_irda.c b/drivers/net/irda/realtek/rtk_irda.c
new file mode 100644
index 00000000..ae8ef73
--- /dev/null
+++ b/drivers/net/irda/realtek/rtk_irda.c
@@ -0,0 +1,1496 @@
+/*
+ *  rtk_irda.c - RTK irda driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/fs.h>
+#include <linux/interrupt.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/input.h>
+#include <linux/kfifo.h>
+#include <linux/cdev.h>
+#include <linux/freezer.h>
+#include <linux/uaccess.h>
+#include <linux/poll.h>
+
+#include <linux/cdev.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+#include "rtk_irda.h"
+#include "irda_sw_decoder.h"
+
+#include <soc/realtek/rtk_chip.h>
+#include <soc/realtek/memory.h>
+#include <soc/realtek/rtk_ipc_shm.h>
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+#define IRDA_CDEV_MAJOR			234
+#define IRDA_CDEV_MINOR			50
+
+#define IRDA_RXFIFO			128
+#define IRDA_TXFIFO			16
+
+#define FIFO_DEPTH			16
+#define RTK_MK5_CUSTOMER_CODE		0x7F80
+
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+extern struct ipc_shm_irda pcpu_data_irda;
+#endif
+
+enum {
+	irda_rx = 0,
+	irda_tx,
+};
+
+enum {
+	software = 0,
+	hardware,
+};
+
+enum {
+	NORMAL = 0,
+	RC6,
+	COMCAST,
+	DIRECTTV,
+	SWDEC,
+};
+
+enum {
+	SINGLE_WORD_IF = 0,
+	DOUBLE_WORD_IF = 1,
+};
+
+struct irda_protocol_info {
+	char name[16];
+	unsigned int burst_len;
+	unsigned int modulation_len;
+	unsigned int zero_len;
+	unsigned int one_len;
+	unsigned int repeat_len;
+	unsigned int silence_len;
+
+	unsigned int hw_decoder;
+	const struct swdec_ops *swdec;
+};
+
+static const struct irda_protocol_info protocol[] = {
+	{ "NEC", 9000, 560, 560, 1690, 2250, 4500, 0x5df, NULL },
+	{ "SONY", 2400, 600, 600, 1200, 0, 2500, 0xdd3, NULL },
+	{ "RC5", 0, 889, 889, 889, 0, 0, 0x70c, NULL },
+	{ "RC6_16", 2666, 444, 444, 444, 0, 889, 0x715, NULL },
+	{ "RC6_32", 2666, 444, 444, 444, 0, 889, 0xa50720, &rc6_swdec_ops },
+	{ "SHARP", 0, 320, 680, 1680, 0, 0, 0x58e, NULL },
+	{ "DIRECTTV", 0, 0, 0, 0, 0, 0, 0x040007cf, NULL },
+	{ "COMCAST", 0, 0, 0, 0, 0, 0, 0x0800071f, &xmp_swdec_ops },
+	{ "XMP", 0, 0, 0, 0, 0, 0, 0x0800071f, &xmp_swdec_ops },
+	{ "RAW", 0, 0, 0, 0, 0, 0, 0, NULL },
+};
+
+struct irda_keymap {
+	unsigned int scancode;
+	unsigned int keycode;
+};
+
+struct irda_key_table {
+	int size;
+	unsigned int cust_code;
+	unsigned int scancode_msk;
+	unsigned int custcode_msk;
+	struct irda_keymap *keys;
+};
+
+static struct irda_keymap rtk_mk5_tv_keys[] = {
+	{0x18, KEY_POWER},
+	{0x5A, KEY_SELECT},
+	{0x58, KEY_CYCLEWINDOWS},
+	{0x1A, KEY_TV},
+	{0x14, KEY_HOME},
+	{0x56, KEY_OPTION},
+	{0x54, KEY_INFO},
+	{0x19, KEY_REPLY},
+	{0x57, KEY_BACK},
+	{0x55, KEY_PLAY},
+	{0x17, KEY_STOP},
+	{0x15, KEY_ZOOM},
+	{0x4F, KEY_REWIND},
+	{0x4D, KEY_UP},
+	{0x16, KEY_FASTFORWARD},
+	{0x0C, KEY_LEFT},
+	{0x4C, KEY_OK},
+	{0x0E, KEY_RIGHT},
+	{0x08, KEY_PREVIOUS},
+	{0x48, KEY_DOWN},
+	{0x09, KEY_NEXT},
+	{0x4B, KEY_VOLUMEDOWN},
+	{0x49, KEY_VOLUMEUP},
+	{0x0B, KEY_TOUCHPAD_OFF},
+	{0x0A, KEY_TOUCHPAD_ON},
+	{0xEEEE, REL_X},
+	{0xEEEE, REL_Y},
+	{0xFFFF, BTN_LEFT},
+};
+
+static struct irda_key_table rtk_mk5_tv_key_table = {
+	.keys = rtk_mk5_tv_keys,
+	.size = ARRAY_SIZE(rtk_mk5_tv_keys),
+	.cust_code = RTK_MK5_CUSTOMER_CODE,
+	.scancode_msk = 0x00FF0000,
+	.custcode_msk = 0xFFFF,
+};
+
+struct irda_protocol_desc {
+	const struct swdec_ops *swdec;
+	struct irda_key_table *keytable;
+
+	unsigned int mode;
+	unsigned int protocol;
+	unsigned int index;
+	unsigned int sample_rate;
+	unsigned int accuracy;
+	unsigned int dpir;
+	unsigned int repeat_time;
+
+	unsigned int lastRecvMs;
+	unsigned int lastdata;
+	unsigned int debounce;
+
+	unsigned int multi_remote;
+	unsigned int wakeup_key;
+};
+
+struct irda_chrdev {
+	struct device *dev;
+	struct cdev cdev;
+	struct class *class;
+
+	unsigned char *rxbuf;
+	unsigned char *txbuf;
+	struct kfifo rxfifo;
+	struct kfifo txfifo;
+
+	wait_queue_head_t rx_wait;
+
+	unsigned int fifosize;
+};
+
+struct rtk_irda_dev {
+	struct device *dev;
+	struct irda_chrdev chrdev;
+
+	void __iomem *reg;
+	struct clk *clk;
+	struct reset_control *rstc;
+
+	struct irda_protocol_desc *rx_desc;
+	struct irda_protocol_desc *tx_desc;
+
+	struct timer_list key_timer;
+	struct timer_list wakeup_timer;
+	spinlock_t splock;
+
+	struct input_dev *input;
+	atomic_t report_cnt;
+
+	enum rtd_chip_id chip_id;
+	enum rtd_chip_revision chip_revision;
+
+	unsigned int rx_cnt;
+	unsigned int tx_cnt;
+	unsigned int irq;
+	unsigned int driver_mode;
+	unsigned int keycode;
+	unsigned int input_disable;
+	bool isKeyTimerCreate;
+};
+
+static void irda_input_report(struct rtk_irda_dev *irda_dev)
+{
+	struct input_dev *input = irda_dev->input;
+	unsigned int keycode = irda_dev->keycode;
+
+	if (irda_dev->input_disable == true)
+		return;
+
+	atomic_inc(&irda_dev->report_cnt);
+	input_report_key(input, keycode, 1);
+	input_sync(input);
+}
+
+static void irda_input_report_end(struct rtk_irda_dev *irda_dev)
+{
+	struct input_dev *input = irda_dev->input;
+	unsigned int keycode = irda_dev->keycode;
+
+	if (irda_dev->input_disable == true)
+		return;
+
+	if (atomic_read(&irda_dev->report_cnt) != 1)
+		dev_err(irda_dev->dev, "report key not in pairs");
+
+	atomic_set(&irda_dev->report_cnt, 0);
+	input_report_key(input, keycode, 0);
+	input_sync(input);
+}
+
+static void irda_wakeup_timer(unsigned long data)
+{
+	struct rtk_irda_dev *irda_dev = (struct rtk_irda_dev *)data;
+	unsigned long lock_flags;
+
+	spin_lock_irqsave(&irda_dev->splock, lock_flags);
+
+	irda_dev->keycode = KEY_STOP;
+	irda_input_report(irda_dev);
+	irda_input_report_end(irda_dev);
+
+	spin_unlock_irqrestore(&irda_dev->splock, lock_flags);
+}
+
+static void irda_key_timer(unsigned long data)
+{
+	struct rtk_irda_dev *irda_dev = (struct rtk_irda_dev *)data;
+	unsigned long lock_flags;
+
+	spin_lock_irqsave(&irda_dev->splock, lock_flags);
+	if (irda_dev->isKeyTimerCreate) {
+		irda_dev->isKeyTimerCreate = false;
+		irda_input_report_end(irda_dev);
+	}
+	spin_unlock_irqrestore(&irda_dev->splock, lock_flags);
+}
+
+static void irda_set_keybit(struct rtk_irda_dev *irda_dev, unsigned long *addr)
+{
+	struct irda_protocol_desc *desc = irda_dev->rx_desc;
+	struct irda_key_table *table;
+	int i, j, k;
+
+	for (i = 0; i < irda_dev->rx_cnt; i++) {
+		for (j = 0; j < (desc + i)->multi_remote; j++) {
+			table = (desc + i)->keytable + j;
+			for (k = 0; k < table->size; k++) {
+				if (table->keys[k].scancode == 0xEEEE)
+					continue;
+				set_bit(table->keys[k].keycode, addr);
+			}
+		}
+	}
+}
+
+static void irda_set_relbit(struct rtk_irda_dev *irda_dev, unsigned long *addr)
+{
+	struct irda_protocol_desc *desc = irda_dev->rx_desc;
+	struct irda_key_table *table;
+	int i, j, k;
+
+	for (i = 0; i < irda_dev->rx_cnt; i++) {
+		for (j = 0; j < (desc + i)->multi_remote; j++) {
+			table = (desc + i)->keytable + j;
+			for (k = 0; k < table->size; k++) {
+				if (table->keys[k].scancode != 0xEEEE)
+					continue;
+				set_bit(table->keys[k].keycode, addr);
+			}
+		}
+	}
+}
+
+static int irda_input_init(struct rtk_irda_dev *irda_dev)
+{
+	struct input_dev *input;
+	int result;
+
+	input = input_allocate_device();
+	if (!input)
+		return -ENOMEM;
+
+	irda_dev->input = input;
+	atomic_set(&irda_dev->report_cnt, 0);
+
+	input->evbit[0] = BIT_MASK(EV_KEY) | BIT(EV_REL);
+	input->name = "venus_IR_input";
+	input->phys = "venus/input0";
+	input->setkeycode = NULL;
+	input->getkeycode = NULL;
+
+	irda_set_keybit(irda_dev, input->keybit);
+	irda_set_relbit(irda_dev, input->relbit);
+
+	result = input_register_device(input);
+	if (result) {
+		input_free_device(input);
+		return -1;
+	}
+
+	return 0;
+}
+
+static void rtk_irda_rx_init(struct rtk_irda_dev *irda_dev,
+		struct irda_protocol_desc *desc, void __iomem *reg)
+{
+	unsigned int val;
+	unsigned int mode, idx;
+	unsigned int burst, mod, one, zero, repeat, sil, sr, accur, dpir;
+
+	if (desc->mode == hardware) {
+		if (!strcmp(protocol[desc->index].name, "DIRECTTV"))
+			mode = DIRECTTV;
+		else if (!strcmp(protocol[desc->index].name, "COMCAST"))
+			mode = COMCAST;
+		else if (!strcmp(protocol[desc->index].name, "RC6_16") ||
+				!strcmp(protocol[desc->index].name, "RC6_32"))
+			mode = RC6;
+		else
+			mode = NORMAL;
+		desc->protocol = mode;
+	} else {
+		mode = SWDEC;
+		if (!strcmp(protocol[desc->index].name, "RC6_16") ||
+			!strcmp(protocol[desc->index].name, "RC6_32"))
+			desc->protocol = RC6;
+		else
+			desc->protocol = mode;
+	}
+
+	idx = desc->index;
+	sr = desc->sample_rate;
+	accur = desc->accuracy;
+	dpir = desc->dpir;
+
+	switch (mode) {
+	case NORMAL:
+	case RC6:
+		writel((sr * 27 - 1), reg + IR_SF_OFF);
+
+		burst = protocol[idx].burst_len	* accur / 400 / sr;
+		mod = protocol[idx].modulation_len * accur / 100 / sr;
+		zero = protocol[idx].zero_len * accur / 100 / sr;
+		one = protocol[idx].one_len * accur / 100 / sr;
+		repeat = protocol[idx].repeat_len * accur / 400 / sr;
+		sil = protocol[idx].silence_len * accur / 400 / sr;
+
+		val = (burst & 0xff) << 24 | (mod & 0xff) << 16 |
+			(zero & 0xff) << 8 | (one & 0xff);
+		writel(val, reg + IR_PSR_OFF);
+		val = 1 << 16 | (repeat & 0xff) << 8 | (sil & 0xff);
+		writel(val, reg + IR_PER_OFF);
+
+		if (mode == RC6)
+			writel(0x123, reg + IR_CTRL_RC6_OFF);
+
+		if (irda_dev->chip_id == CHIP_ID_RTD1619)
+			writel(protocol[idx].hw_decoder
+					| IR_REPEAT_EN, reg + IR_CR_OFF);
+		else
+			writel(protocol[idx].hw_decoder, reg + IR_CR_OFF);
+		writel(dpir * 1000 / sr, reg + IR_DPIR_OFF);
+		break;
+	case DIRECTTV:
+		writel(0x64, reg + IR_SF_OFF);
+		writel(0xbb000000, reg + IR_PSR_OFF);
+		writel(0x1004b, reg + IR_PER_OFF);
+		writel(0x00fa007d, reg + IRDIRECTV_TIMING1);
+		writel(0x01f40177, reg + IRDIRECTV_TIMING2);
+		writel(protocol[idx].hw_decoder, reg + IR_CR_OFF);
+		break;
+	case COMCAST:
+		writel(0x1a, reg + IR_SF_OFF);
+		writel(0x10001, reg + IR_PER_OFF);
+		writel(0x2ee0, reg + IR_DPIR_OFF);
+		writel(0x11d89385, reg + IRCOMCAST_TIMING);
+		writel(protocol[idx].hw_decoder, reg + IR_CR_OFF);
+		break;
+	case SWDEC:
+		writel(sr * 27, reg + IR_SF_OFF);
+		writel(0x03138850, reg + IR_RAW_CTRL_OFF);
+		writel(0x7300, reg + IR_CR_OFF);
+		desc->swdec->init();
+		break;
+	default:
+		break;
+	}
+}
+
+static void rtk_irda_tx_init(struct irda_protocol_desc *desc,
+				void __iomem *reg)
+{
+	writel(0x00000400, reg + IRTX_CFG_OFF);
+	writel(0x13AB0, reg + IRTX_PWM_SETTING_OFF);
+	if (!strcmp(protocol[desc->index].name, "NEC")) {
+		writel(0x3B0D, reg + IRTX_TIM_OFF);
+		writel(0x80000710, reg + IRTX_CFG_OFF);
+		writel(0xf04, reg + IRTX_INT_EN_OFF);
+	} else if (!strcmp(protocol[desc->index].name, "RAW")) {
+		writel((desc->sample_rate * 27) - 1, reg + IRTX_TIM_OFF);
+		writel(0x80000510, reg + IRTX_CFG_OFF);
+		writel(0xf06, reg + IRTX_INT_EN_OFF);
+	}
+	writel(0x80000000, reg + IRTX_FIFO_ST_OFF);
+	writel(0x00000000, reg + IRTX_FIFO_ST_OFF);
+}
+
+static void rtk_irda_init(struct rtk_irda_dev *irda_dev)
+{
+	void __iomem *reg = irda_dev->reg;
+	struct irda_protocol_desc *desc;
+	int i;
+
+	writel(IRCR_RESET, reg + IR_CR_OFF);
+
+	for (i = 0; i < irda_dev->rx_cnt; i++) {
+		desc = irda_dev->rx_desc + i;
+		rtk_irda_rx_init(irda_dev, desc, reg);
+	}
+
+	for (i = 0; i < irda_dev->tx_cnt; i++) {
+		desc = irda_dev->tx_desc + i;
+		rtk_irda_tx_init(desc, reg);
+	}
+}
+
+static int rxdata_transcode(struct irda_protocol_desc *desc, unsigned int data)
+{
+	struct irda_key_table *table;
+	unsigned int scancode, keycode;
+	int shift;
+	int i, j;
+
+	for (j = 0; j < desc->multi_remote; j++) {
+		table = desc->keytable + j;
+
+		for (shift = 0; shift < 32; shift++)
+			if ((1 << shift) & table->custcode_msk)
+				break;
+		if (((data & table->custcode_msk) >> shift) != table->cust_code)
+			continue;
+
+		for (shift = 0; shift < 32; shift++)
+			if ((1 << shift) & table->scancode_msk)
+				break;
+
+		scancode = (data & table->scancode_msk) >> shift;
+		for (i = 0; i < table->size; i++) {
+			if (scancode == table->keys[i].scancode) {
+				keycode = table->keys[i].keycode;
+				return keycode;
+			}
+		}
+	}
+
+	return -1;
+}
+
+static int txdata_transcode(struct irda_protocol_desc *desc, unsigned int data)
+{
+	struct irda_key_table *table;
+	unsigned int scancode;
+	int i;
+
+	table = desc->keytable;
+	for (i = 0; i < table->size; i++) {
+		if (data == table->keys[i].keycode) {
+			scancode = table->keys[i].scancode;
+			return scancode;
+		}
+	}
+	return -1;
+}
+
+static int irda_nec_send(struct rtk_irda_dev *irda_dev,
+			struct irda_protocol_desc *desc, unsigned int scancode)
+{
+	void __iomem *reg = irda_dev->reg;
+	unsigned char burst[3], addr[6], cmd[6], cmdend;
+	unsigned short necaddr, neccmd;
+	unsigned int custcode, val;
+	int offset;
+	int i;
+
+	custcode = desc->keytable->cust_code;
+
+	necaddr = (unsigned short)(custcode & 0x0000ffff);
+	neccmd = (unsigned short)((~(scancode & 0x000000ff)) << 8 |
+						(scancode & 0x000000ff));
+
+	memset(addr, 0 , sizeof(addr));
+	memset(cmd, 0 , sizeof(cmd));
+
+	burst[2] = burst[1] = 0xff;
+	burst[0] = 0x0;
+	cmdend = 0x80;
+
+	offset = 8 * sizeof(addr) - 1;
+	for (i=0; i<(8 * sizeof(necaddr)); i++) {
+		if (offset < 0) {
+			pr_err("IRTX: offset error\n");
+			return -1;
+		} else if (necaddr & (0x1 << i)) {
+			__set_bit(offset, (unsigned long *)addr);
+			offset = offset - 4;
+		} else {
+			__set_bit(offset, (unsigned long *)addr);
+			offset = offset - 2;
+		}
+	}
+
+	offset = 8 * sizeof(cmd) - 1;
+	for (i=0; i<(8*sizeof(neccmd)); i++) {
+		if (offset < 0) {
+			pr_err("IRTX: offset error\n");
+			return -1;
+		} else if (neccmd & (0x1 << i)){
+			__set_bit(offset, (unsigned long *)cmd);
+			offset = offset - 4;
+		} else {
+			__set_bit(offset, (unsigned long *)cmd);
+			offset = offset - 2;
+		}
+	}
+	val = ((burst[2]<<24) | (burst[1]<<16) |(burst[0]<<8) | addr[5]);
+	writel(val, reg + IRTX_FIFO_OFF);
+
+	val = ((addr[4]<<24) | (addr[3]<<16) | (addr[2]<<8) | addr[1]);
+	writel(val, reg + IRTX_FIFO_OFF);
+
+	val = ((addr[0]<<24) | (cmd[5]<<16) | (cmd[4]<<8) | cmd[3] );
+	writel(val, reg + IRTX_FIFO_OFF);
+
+	val = ((cmd[2]<<24) | (cmd[1]<<16) | (cmd[0]<<8) | cmdend );
+	writel(val, reg + IRTX_FIFO_OFF);
+
+	return 0;
+}
+
+static void irda_key_handle(struct rtk_irda_dev *irda_dev,
+			struct irda_protocol_desc *desc, int code, int repeat)
+{
+	struct irda_chrdev *chrdev = &irda_dev->chrdev;
+	int time;
+	int keycode;
+
+	time = jiffies_to_msecs(jiffies) - desc->lastRecvMs;
+	if (desc->debounce > 0 && time < desc->debounce)
+		return;
+
+	if (desc->protocol == RC6) {
+		code = ~(code) & 0x1fffff;
+		if ((desc->lastdata & 0xffff) == (code & 0xffff))
+			repeat = 1;
+		desc->lastdata = code;
+	}
+	dev_info(irda_dev->dev, "scancode = 0x%x\n", code);
+
+	kfifo_in(&chrdev->rxfifo, &code, sizeof(unsigned int));
+	if (irda_dev->driver_mode == DOUBLE_WORD_IF)
+		kfifo_in(&chrdev->rxfifo, (unsigned char *)&repeat,
+						sizeof(unsigned int));
+	wake_up_interruptible(&chrdev->rx_wait);
+	desc->lastRecvMs = jiffies_to_msecs(jiffies);
+
+	keycode = rxdata_transcode(desc, code);
+	if (keycode < 0)
+		return;
+
+	if (desc->mode == software)
+		if (time < desc->repeat_time && irda_dev->keycode == keycode)
+			repeat = 1;
+
+	if (repeat == 1 && (irda_dev->isKeyTimerCreate == true ||
+		time > desc->repeat_time))
+		return;
+
+	if (irda_dev->isKeyTimerCreate) {
+		irda_dev->isKeyTimerCreate = false;
+		irda_input_report_end(irda_dev);
+	}
+	irda_dev->keycode = keycode;
+	irda_dev->isKeyTimerCreate = true;
+	irda_input_report(irda_dev);
+
+	dev_info(irda_dev->dev, "keycode = 0x%x\n", keycode);
+}
+
+static irqreturn_t rtk_irda_isr(int irq, void *dev_id)
+{
+	struct rtk_irda_dev *irda_dev = (struct rtk_irda_dev *)dev_id;
+	struct irda_chrdev *chrdev = &irda_dev->chrdev;
+	struct irda_protocol_desc *desc;
+	void __iomem *reg = irda_dev->reg;
+	unsigned int val;
+	unsigned int data;
+	unsigned int fifoval[IRDA_RXFIFO], fifolv = 0;
+	int keycode;
+	int repeat = 0;
+	int i;
+
+	val = readl(reg + IR_SR_OFF);
+
+	desc = irda_dev->rx_desc;
+	if (val & IR_DVF) {
+		if (val & IR_REPEAT)
+			repeat = 1;
+		writel((IR_DVF | IR_REPEAT), reg + IR_SR_OFF);
+		data = readl(reg + IR_RP_OFF);
+		for (i = 0; i < irda_dev->rx_cnt; i++)
+			if (desc[i].mode == hardware)
+				break;
+		if (i != irda_dev->rx_cnt)
+			irda_key_handle(irda_dev, desc + i, data, repeat);
+		mod_timer(&irda_dev->key_timer,
+			jiffies + msecs_to_jiffies(desc->repeat_time));
+	}
+	if (val & (IR_RAWDOV | IR_RAWDVF)) {
+		writel((val & (~0xf)), reg + IR_SR_OFF);
+		fifolv = readl(reg + IR_RAW_WL_OFF) & 0x3f;
+		for (i = 0; i < fifolv; i++)
+			fifoval[i] = readl(reg + IR_RAW_FF_OFF);
+		for (i = 0; i < irda_dev->rx_cnt; i++) {
+			if (desc[i].mode == hardware)
+				continue;
+			if (desc[i].swdec->decoder) {
+				keycode = desc[i].swdec->decoder(
+							fifoval, fifolv);
+				if (keycode < 0)
+					continue;
+			} else {
+				kfifo_in(&chrdev->rxfifo, fifoval, fifolv * 4);
+				continue;
+			}
+			irda_key_handle(irda_dev, desc + i, keycode, repeat);
+			mod_timer(&irda_dev->key_timer,
+				jiffies + msecs_to_jiffies(desc->repeat_time));
+		}
+	}
+
+	desc = irda_dev->tx_desc;
+	val = readl(reg + IRTX_INT_ST_OFF);
+
+	if (!strcmp(protocol[desc->index].name, "RAW")) {
+	
+	}
+	if (val & 0x4) {
+		val = readl(reg + IRTX_CFG_OFF);
+		writel(val & ~0x1, reg + IRTX_CFG_OFF);
+
+		writel(0x80000000, reg + IRTX_FIFO_ST_OFF);	//irtx fifo reset
+		writel(0x00000000, reg + IRTX_FIFO_ST_OFF);	//irtx fifo normal
+	}
+
+	return IRQ_HANDLED;
+}
+
+static int get_irda_protocol_index(const char *name, int mode, int irmode)
+{
+	int cnt;
+	int index;
+
+	cnt = ARRAY_SIZE(protocol);
+	for (index = 0; index < cnt; index++)
+		if (!strcmp(name, protocol[index].name))
+			break;
+	if (index == cnt)
+		return -1;
+
+	switch (irmode) {
+	case irda_rx:
+		if (mode == software) {
+			if (!protocol[index].swdec)
+				return -1;
+		} else {
+			if (!protocol[index].hw_decoder)
+				return -1;
+		}
+		break;
+
+	case irda_tx:
+		break;
+	default:
+		break;
+	}
+
+	return index;
+}
+
+ssize_t irda_show_keytable(struct device *dev,
+			struct device_attribute *attr, char *buf)
+{
+	struct rtk_irda_dev *irda_dev = dev_get_drvdata(dev);
+	struct irda_protocol_desc *desc = irda_dev->rx_desc;
+
+//	if(desc->keytable == NULL)
+//		return sprintf(buf, "key table is not exist!\n");
+	return sprintf(buf, "table size=%d\n", desc->keytable->size);
+}
+
+ssize_t irda_store_keytable(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct rtk_irda_dev *irda_dev = dev_get_drvdata(dev);
+	struct irda_protocol_desc *desc = irda_dev->rx_desc;
+	struct irda_key_table *keytbl = desc->keytable;
+	struct irda_keymap *key;
+	struct file *fp;
+	struct kstat stat;
+	char filename[64] = {0};
+	char *buffer;
+	char *token, *vtoken, *cur;
+	unsigned int keymap_size = 0;
+	mm_segment_t old_fs = get_fs();
+	unsigned int idx = 0;
+
+	if (!buf || count < 1) {
+		dev_err(dev, "%s - buffer is null!\n", __func__);
+		return count;
+	}
+	sscanf(buf, "%s", filename);
+
+	set_fs(KERNEL_DS);
+	if (vfs_stat(filename, &stat) < 0) {
+		dev_err(dev, "%s - file fail!\n", __func__);
+		set_fs(old_fs);
+		return count;
+	}
+	set_fs(old_fs);
+
+	fp = filp_open(filename, O_RDONLY, 0);
+	if (IS_ERR(fp)) {
+		dev_err(dev, "%s - can't open file!\n", __func__);
+		return count;
+	}
+
+	buffer = devm_kzalloc(dev, stat.size, GFP_KERNEL);
+	if (!buffer)
+		goto kzalloc_fail;
+
+	cur = buffer;
+	if (kernel_read(fp, 0, buffer, stat.size) < 0)
+		goto get_file_fail;
+
+	filp_close(fp, 0);
+
+	while ((token = strsep(&cur, "\n"))) {
+		vtoken = strsep(&token, "=");
+		if (strcmp(vtoken, "cust-code") == 0) {
+			if (!sscanf(token, "0x%X", &(keytbl->cust_code)))
+				goto format_err;
+		} else if (strcmp(vtoken, "scancode-msk") == 0) {
+			if (!sscanf(token, "0x%08X", &(keytbl->scancode_msk)))
+				goto format_err;
+		} else if (strcmp(vtoken, "custcode-msk") == 0) {
+			if (!sscanf(token, "0x%08X", &(keytbl->custcode_msk)))
+				goto format_err;
+		} else if (strcmp(vtoken, "keymap-size") == 0) {
+			if (!sscanf(token, "%d", &keymap_size))
+				goto format_err;
+		} else if (strcmp(vtoken, "keymap-tbl") == 0) {
+			if (keymap_size < 1) {
+				dev_err(dev, "%s - keysize error\n", __func__);
+				return count;
+			}
+			key = devm_kzalloc(dev, keymap_size, GFP_KERNEL);
+			if (!key)
+				return count;
+
+			devm_kfree(dev, keytbl->keys);
+			keytbl->keys = key;
+			keytbl->size = keymap_size;
+
+			while ((token = strsep(&cur, "\n")) &&
+						(idx < keymap_size)) {
+				vtoken = strsep(&token, "=");
+				if (strlen(vtoken) > 1) {
+					if (!sscanf(vtoken, "0x%X", &(key[idx].scancode)))
+						goto format_err;
+					if (!sscanf(token, "%d", &(key[idx].keycode)))
+						goto format_err;
+					idx++;
+				}
+			}
+			break;
+		}
+		continue;
+format_err:
+		dev_err(dev, "%s - replace table format error\n", __func__);
+	}
+	return count;
+
+get_file_fail:
+	dev_err(dev, "%s - read file fail\n", __func__);
+	devm_kfree(dev, buffer);
+kzalloc_fail:
+	filp_close(fp, 0);
+	return count;
+}
+
+ssize_t irda_input_ctrl_show(struct device *dev,
+			struct device_attribute *attr, char *buf)
+{
+	struct rtk_irda_dev *irda_dev = dev_get_drvdata(dev);
+
+	return sprintf(buf, "=> %d\n", irda_dev->input_disable);
+}
+
+ssize_t irda_input_ctrl_store(struct device *dev, struct device_attribute *attr,
+			const char *buf, size_t count)
+{
+	struct rtk_irda_dev *irda_dev = dev_get_drvdata(dev);
+
+	sscanf(buf, "%d", &irda_dev->input_disable);
+	return count;
+}
+
+static DEVICE_ATTR(replace_table, S_IRUGO | S_IWUSR,
+		irda_show_keytable, irda_store_keytable);
+static DEVICE_ATTR(input_disable, S_IRUGO | S_IWUSR, irda_input_ctrl_show,
+		irda_input_ctrl_store);
+
+static struct attribute *irda_dev_attrs[] = {
+	&dev_attr_replace_table.attr,
+	&dev_attr_input_disable.attr,
+	NULL,
+};
+
+static struct attribute_group irda_attr_group = {
+	.attrs = irda_dev_attrs,
+};
+
+int rtk_irda_open(struct inode *inode, struct file *filp)
+{
+	struct rtk_irda_dev *irda_dev;
+	struct irda_chrdev *chrdev;
+
+	chrdev = container_of(inode->i_cdev, struct irda_chrdev, cdev);
+	irda_dev = container_of(chrdev, struct rtk_irda_dev, chrdev);
+	filp->private_data = irda_dev;
+
+	if ((filp->f_flags & O_ACCMODE) == O_WRONLY) {
+		if (irda_dev->tx_cnt == 0)
+			return -1;
+		kfifo_reset(&chrdev->txfifo);
+	}
+	if ((filp->f_flags & O_ACCMODE) == O_RDONLY) {
+		if (irda_dev->rx_cnt == 0)
+			return -1;
+		kfifo_reset(&chrdev->rxfifo);
+	}
+	return 0;
+}
+
+ssize_t rtk_irda_read(struct file *filp, char __user *buf,
+			size_t count, loff_t *f_pos)
+{
+	struct rtk_irda_dev *irda_dev = filp->private_data;
+	struct irda_chrdev *chrdev = &irda_dev->chrdev;
+	int rCnt = count;
+	int len;
+
+restart:
+	if (wait_event_interruptible
+		(chrdev->rx_wait, kfifo_len(&chrdev->rxfifo) > 0)) {
+		if (try_to_freeze())
+			goto restart;
+	}
+
+	if (kfifo_len(&chrdev->rxfifo) < count)
+		rCnt = kfifo_len(&chrdev->rxfifo);
+
+	len = kfifo_out(&chrdev->rxfifo, chrdev->rxbuf, rCnt);
+	if (!len)
+		return -EFAULT;
+	rCnt = len;
+	if (copy_to_user(buf, chrdev->rxbuf, len)) {
+		dev_err(irda_dev->dev, "copy fail\n");
+		return -EFAULT;
+	}
+
+	return rCnt;
+}
+
+ssize_t rtk_irda_write(struct file *filp, const char __user *buf,
+			size_t count, loff_t *f_pos)
+{
+	struct rtk_irda_dev *irda_dev = filp->private_data;
+	struct irda_chrdev *chrdev = &irda_dev->chrdev;
+	struct irda_protocol_desc *desc;
+	void __iomem *reg = irda_dev->reg;
+	unsigned int val;
+	int wCnt;
+	int keycode, scancode;
+	int i;
+
+	desc = irda_dev->tx_desc;
+
+	wCnt = kfifo_avail(&chrdev->txfifo);
+	if (count < wCnt)
+		wCnt = count;
+	if (copy_from_user(chrdev->txbuf, buf, wCnt)) {
+		dev_err(irda_dev->dev, "copy from user error\n");
+		return -EFAULT;
+	}
+
+	if (!strcmp(protocol[desc->index].name, "RAW")) {
+		val = readl(reg + IRTX_CFG_OFF);
+		if (val & 0x1) {
+			kfifo_in(&chrdev->txfifo, chrdev->txbuf, wCnt);
+			return wCnt;
+		}
+		if(wCnt <= FIFO_DEPTH * 4) {
+			for(i=0; i<(wCnt/4); i++)
+				writel( *((int *)(chrdev->txbuf) + i), reg + IRTX_FIFO_OFF);
+			writel(0x80000511, reg + IRTX_CFG_OFF);
+		} else {
+			for(i=0; i<FIFO_DEPTH; i++)
+				writel( *((int *)(chrdev->txbuf) + i), reg + IRTX_FIFO_OFF);
+			writel(0x80000511, reg + IRTX_CFG_OFF);
+			kfifo_in(&chrdev->txfifo, chrdev->txbuf + FIFO_DEPTH * 4, wCnt - FIFO_DEPTH * 4);
+		}
+	} else {
+		sscanf(chrdev->txbuf, "%d", &keycode);
+		if (desc == NULL)
+			return -1;
+
+		scancode = txdata_transcode(desc, keycode);
+		if (scancode >= 0) {
+			irda_nec_send(irda_dev, desc, scancode);
+			val = readl(reg + IRTX_CFG_OFF);
+			writel(val | 0x1, reg + IRTX_CFG_OFF);
+		}
+	}
+	return wCnt;
+}
+
+unsigned int rtk_irda_poll(struct file *filp, poll_table *wait)
+{
+	struct rtk_irda_dev *irda_dev = filp->private_data;
+	struct irda_chrdev *chrdev = &irda_dev->chrdev;
+
+	poll_wait(filp, &chrdev->rx_wait, wait);
+
+	if (kfifo_len(&chrdev->rxfifo) > 0)
+		return POLLIN | POLLRDNORM;
+	else
+		return 0;
+}
+
+long rtk_irda_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	struct rtk_irda_dev *irda_dev = filp->private_data;
+	struct irda_chrdev *chrdev = &irda_dev->chrdev;
+	void __iomem *reg = irda_dev->reg;
+	int ret = 0;
+	int i;
+
+	switch (cmd) {
+	case VENUS_IR_IOC_SET_IRPSR:
+		writel(arg, reg + IR_PSR_OFF);
+		break;
+	case VENUS_IR_IOC_SET_IRPER:
+		writel(arg, reg + IR_PER_OFF);
+		break;
+	case VENUS_IR_IOC_SET_IRSF:
+		writel(arg, reg + IR_SF_OFF);
+		break;
+	case VENUS_IR_IOC_SET_IRCR:
+		writel(arg, reg + IR_CR_OFF);
+		break;
+	case VENUS_IR_IOC_SET_IRIOTCDP:
+		writel(arg, reg + IR_DPIR_OFF);
+		break;
+	case VENUS_IR_IOC_SET_PROTOCOL:
+	case VENUS_IR_IOC_SET_FIRST_REPEAT_DELAY:
+	case VENUS_IRTX_IOC_SET_TX_TABLE:
+		dev_err(irda_dev->dev, "ioctl not support now\n");
+		break;
+	case VENUS_IR_IOC_FLUSH_IRRP:
+		kfifo_reset(&chrdev->rxfifo);
+		break;
+	case VENUS_IR_IOC_SET_DEBOUNCE:
+		for (i = 0; i < irda_dev->rx_cnt; i++)
+			irda_dev->rx_desc[i].debounce = (unsigned int)arg;
+		break;
+	case VENUS_IR_IOC_SET_DRIVER_MODE:
+		if ((unsigned int)arg >= 2) {
+			ret = -EFAULT;
+		} else {
+			kfifo_reset(&chrdev->rxfifo);
+			irda_dev->driver_mode = (unsigned int)arg;
+		}
+		break;
+	default:
+		ret = -ENOIOCTLCMD;
+		break;
+	}
+	return ret;
+}
+#ifdef CONFIG_64BIT
+long rtk_irda_compat_ioctl(struct file *filp, unsigned int cmd,
+			unsigned long arg)
+{
+	long (*ioctl)(struct file*, unsigned int, unsigned long);
+
+	if (!filp->f_op->unlocked_ioctl)
+		return -ENOTTY;
+
+	ioctl = filp->f_op->unlocked_ioctl;
+
+	switch (cmd) {
+	case VENUS_IR_IOC_SET_IRPSR:
+	case VENUS_IR_IOC_SET_IRPER:
+	case VENUS_IR_IOC_SET_IRSF:
+	case VENUS_IR_IOC_SET_IRCR:
+	case VENUS_IR_IOC_SET_IRIOTCDP:
+	case VENUS_IR_IOC_SET_PROTOCOL:
+	case VENUS_IR_IOC_FLUSH_IRRP:
+	case VENUS_IR_IOC_SET_DEBOUNCE:
+	case VENUS_IR_IOC_SET_FIRST_REPEAT_DELAY:
+	case VENUS_IR_IOC_SET_DRIVER_MODE:
+	case VENUS_IRTX_IOC_SET_TX_TABLE:
+	case VENUS_IRRX_RAW_STOP:
+		return ioctl(filp, cmd, (unsigned long)compat_ptr(arg));
+	default:
+		return -EFAULT;
+	}
+}
+#endif
+static const struct file_operations rtk_irda_fops = {
+	.owner = THIS_MODULE,
+	.open = rtk_irda_open,
+	.read = rtk_irda_read,
+	.write = rtk_irda_write,
+	.poll = rtk_irda_poll,
+	.unlocked_ioctl = rtk_irda_ioctl,
+#ifdef CONFIG_64BIT 
+	.compat_ioctl = rtk_irda_compat_ioctl,
+#endif
+};
+
+static int create_irda_chrdev(struct rtk_irda_dev *irda_dev)
+{
+	struct irda_chrdev *chrdev = &irda_dev->chrdev;
+	struct device *dev = irda_dev->dev;
+	struct device_node *np = irda_dev->dev->of_node;
+	struct class *class;
+	dev_t dev_no;
+
+	if (of_property_read_u32(np, "fifo-size", &chrdev->fifosize))
+		chrdev->fifosize = 128;
+	if (irda_dev->rx_cnt) {
+		if (kfifo_alloc(&chrdev->rxfifo, chrdev->fifosize, GFP_KERNEL))
+			goto chrdev_malloc_fail;
+		chrdev->rxbuf = devm_kzalloc(dev, chrdev->fifosize, GFP_KERNEL);
+		if (!chrdev->rxbuf)
+			goto chrdev_malloc_fail;
+	}
+	if (irda_dev->tx_cnt) {
+		if (kfifo_alloc(&chrdev->txfifo, chrdev->fifosize, GFP_KERNEL))
+			goto chrdev_malloc_fail;
+		chrdev->txbuf = devm_kzalloc(dev, chrdev->fifosize, GFP_KERNEL);
+		if (!chrdev->txbuf)
+			goto chrdev_malloc_fail;
+	}
+
+	dev_no = MKDEV(IRDA_CDEV_MAJOR, IRDA_CDEV_MINOR);
+	if (register_chrdev_region(dev_no, 1, "rtk_irda_cdev"))
+		goto chrdev_malloc_fail;
+
+	cdev_init(&chrdev->cdev, &rtk_irda_fops);
+	chrdev->cdev.ops = &rtk_irda_fops;
+	if (cdev_add(&chrdev->cdev, dev_no, 1))
+		goto cdev_add_fail;
+
+	class = class_create(THIS_MODULE, "rtk_irda_class");
+	chrdev->dev = device_create(class, NULL, dev_no, &chrdev->cdev, "venus_ir");
+	chrdev->class = class;
+
+	init_waitqueue_head(&chrdev->rx_wait);
+	return 0;
+cdev_add_fail:
+	unregister_chrdev_region(dev_no, 1);
+chrdev_malloc_fail:
+	if (&chrdev->rxfifo)
+		kfifo_free(&chrdev->rxfifo);
+	if (&chrdev->txfifo)
+		kfifo_free(&chrdev->txfifo);
+	return -1;
+}
+
+static int get_desc_from_dtb(struct device *dev,
+				struct irda_protocol_desc *desc,
+				int mode)
+{
+	struct device_node *node = dev->of_node;
+	struct device_node *np;
+	struct irda_key_table *table;
+	struct irda_keymap *keys;
+	const unsigned int *pkey;
+	const char *str;
+	char name[32];
+	int cnt = 0;
+	int tmp;
+	int i, j;
+
+	for_each_child_of_node(node, np) {
+		if (mode == irda_rx) {
+			if (of_property_read_string(np, "irrx-protocol", &str))
+				continue;
+		} else {
+			if (of_property_read_string(np, "irtx-protocol", &str))
+				continue;
+		}
+		if (of_property_read_u32(np, "transcode-mode", &desc->mode))
+			desc->mode = 1;
+
+		if (of_property_read_u32(np, "sample-rate", &desc->sample_rate))
+			desc->sample_rate = 20;
+
+		if (of_property_read_u32(np, "reg-ir-dpir", &desc->dpir))
+			desc->dpir = 50;
+
+		if (of_property_read_u32(np, "debounce", &desc->debounce))
+			desc->debounce = 0;
+
+		if (of_property_read_u32(np, "accuracy", &desc->accuracy))
+			desc->accuracy = 70;
+
+		if (of_property_read_u32(np, "repeat-time", &desc->repeat_time))
+			desc->repeat_time = 250;
+
+		if (of_property_read_u32(np, "wakeup-key", &desc->wakeup_key))
+			desc->wakeup_key = 116;
+
+		dev_err(dev, "wakeup key = %d\n", desc->wakeup_key);
+		desc->index = get_irda_protocol_index(str, desc->mode, mode);
+		if (desc->index < 0)
+			continue;
+
+		if (desc->mode == software)
+			desc->swdec = protocol[desc->index].swdec;
+
+		// start get key table
+		if (of_property_read_u32(np, "multi-remote", &desc->multi_remote))
+			desc->multi_remote = 1;
+
+		table = devm_kzalloc(dev, sizeof(*table) * desc->multi_remote,
+				GFP_KERNEL);
+		if (!table)
+			continue;
+		desc->keytable = table;
+
+		pkey = of_get_property(np, "keymap-tbl", &tmp);
+		if (!pkey) {
+			dev_err(dev, "can't find key table, use default\n");
+			memcpy(table, &rtk_mk5_tv_key_table,
+						sizeof(rtk_mk5_tv_key_table));
+			goto get_next_keytable;
+		}
+		table->keys = devm_kzalloc(dev, tmp, GFP_KERNEL);
+		table->size = tmp / (2 * sizeof(unsigned int));
+		keys = table->keys;
+		for (i = 0; i < table->size; i++) {
+			keys[i].scancode = of_read_number(pkey, 1 + (i * 2));
+			keys[i].keycode = of_read_number(pkey, 2 + (i * 2));
+		}
+		if (of_property_read_u32(np, "cust-code", &table->cust_code))
+			table->cust_code = RTK_MK5_CUSTOMER_CODE;
+		if (of_property_read_u32(np, "scancode-msk", &table->scancode_msk))
+			table->scancode_msk = 0x00FF0000;
+		if (of_property_read_u32(np, "custcode-msk", &table->custcode_msk))
+			table->custcode_msk = 0xFFFF;
+
+get_next_keytable:
+		for (i=1; i<desc->multi_remote; i++) {
+			sprintf(name, "cust-code%d", i);
+			if (of_property_read_u32(np, name, &table[i].cust_code))
+				table[i].cust_code = table->cust_code;
+			sprintf(name, "scancode-msk%d", i);
+			if (of_property_read_u32(np, name, &table[i].scancode_msk))
+				table[i].scancode_msk = table->scancode_msk;
+			sprintf(name, "custcode-msk%d", i);
+			if (of_property_read_u32(np, name, &table[i].custcode_msk))
+				table[i].custcode_msk = table->custcode_msk;
+
+			sprintf(name, "keymap-tbl%d", i);
+			pkey = of_get_property(np, name, &tmp);
+			if (!pkey) {
+				table[i].keys = table->keys;
+				table[i].size = table->size;
+				continue;
+			}
+
+			table[i].keys = devm_kzalloc(dev, tmp, GFP_KERNEL);
+			table[i].size = tmp / (2 * sizeof(unsigned int));
+			keys = table[i].keys;
+			for (j = 0; j < table[i].size; j++) {
+				keys[j].scancode = of_read_number(pkey, 1 + (j * 2));
+				keys[j].keycode = of_read_number(pkey, 2 + (j * 2));
+			}
+		}
+		cnt++;
+		desc++;
+	}
+	return cnt;
+}
+
+#ifdef CONFIG_PM
+static int irda_set_wakeup_keys(struct rtk_irda_dev *irda_dev,
+				struct ipc_shm_irda *p_table)
+{
+	struct irda_protocol_desc *desc;
+	struct irda_key_table *table;
+	int i, j, k;
+	int cnt = 0;
+
+	for (i = 0; i < irda_dev->rx_cnt; i++) {
+		desc = irda_dev->rx_desc + i;
+		for (j = 0; j < desc->multi_remote; j++) {
+			table = desc->keytable + j;
+			p_table->key_tbl[cnt].protocol = htonl(0);
+			p_table->key_tbl[cnt].scancode_mask = htonl(table->scancode_msk);
+			p_table->key_tbl[cnt].cus_mask = htonl(table->custcode_msk);
+			p_table->key_tbl[cnt].cus_code = htonl(table->cust_code);
+
+			for (k = 0; k < table->size; k++) {
+				if (desc->wakeup_key == table->keys[k].keycode) {
+					p_table->key_tbl[cnt].wakeup_scancode =
+							htonl(table->keys[k].scancode);
+					break;
+				}
+			}
+			cnt ++;
+		}
+	}
+	p_table->dev_count = htonl(cnt);
+	p_table->ipc_shm_ir_magic = htonl(0x49525641);
+
+	return 0;
+}
+#endif
+
+int rtk_irda_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct rtk_irda_dev *irda_dev;
+	struct irda_protocol_desc *desc;
+#ifdef CONFIG_PM
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+	struct ipc_shm_irda __iomem *ir_ipc;
+	unsigned int phy_ir_ipc;
+#endif
+	int ret;
+
+	/* malloc memory for irda device */
+	irda_dev = devm_kzalloc(dev, sizeof(*irda_dev), GFP_KERNEL);
+	if (!irda_dev)
+		goto mem_alloc_fail;
+
+	irda_dev->dev = dev;
+	dev->driver_data = irda_dev;
+
+	irda_dev->chip_id = get_rtd_chip_id();
+	irda_dev->chip_revision = get_rtd_chip_revision();
+
+	spin_lock_init(&irda_dev->splock);
+
+	/* Read parameter from DTB */
+	irda_dev->reg = of_iomap(dev->of_node, 1);
+	if (!irda_dev->reg)
+		goto read_dtb_fail;
+
+	irda_dev->clk = clk_get(dev, NULL);
+	irda_dev->rstc = reset_control_get(dev, NULL);
+	if (!irda_dev->clk || !irda_dev->rstc)
+		goto read_dtb_fail;
+
+	irda_dev->irq = irq_of_parse_and_map(dev->of_node, 0);
+
+	ret = of_get_child_count(dev->of_node);
+	if (!ret)
+		goto read_dtb_fail;
+	desc = devm_kzalloc(dev, sizeof(*desc) * ret, GFP_KERNEL);
+	if (!desc)
+		goto mem_alloc_fail;
+
+	irda_dev->rx_desc = desc;
+	irda_dev->rx_cnt = get_desc_from_dtb(dev, irda_dev->rx_desc, irda_rx);
+
+	irda_dev->tx_desc = desc + irda_dev->rx_cnt;
+	irda_dev->tx_cnt = get_desc_from_dtb(dev, irda_dev->tx_desc, irda_tx);
+
+	if (irda_dev->rx_cnt == 0 && irda_dev->tx_cnt == 0)
+		goto read_dtb_fail;
+
+	/* create character device for irda module */
+	ret = create_irda_chrdev(irda_dev);
+	if (ret)
+		dev_err(dev, "create irda character device fail\n");
+
+	irda_input_init(irda_dev);
+
+	ret = sysfs_create_group(&pdev->dev.kobj, &irda_attr_group);
+	if (ret)
+		dev_err(dev, "create irda sysfs fail\n");
+
+	setup_timer(&irda_dev->key_timer, irda_key_timer, (unsigned long)irda_dev);
+	setup_timer(&irda_dev->wakeup_timer, irda_wakeup_timer, (unsigned long)irda_dev);
+	irda_dev->key_timer.expires = jiffies + msecs_to_jiffies(70);
+
+	/* Start realtek irda initial */
+	reset_control_deassert(irda_dev->rstc);
+	clk_prepare_enable(irda_dev->clk);
+
+	rtk_irda_init(irda_dev);
+
+	if (request_irq(irda_dev->irq, rtk_irda_isr, IRQF_SHARED,
+			"RTK_IRDA", irda_dev)) {
+		dev_err(dev, "cannot register IRQ\n");
+		goto read_dtb_fail;
+	}
+
+#ifdef CONFIG_PM
+	ir_ipc = (void __iomem *)(IPC_SHM_VIRT + sizeof(*ipc));
+	phy_ir_ipc = RPC_COMM_PHYS + 0xC4 + sizeof(*ipc);
+
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	irda_set_wakeup_keys(irda_dev, &pcpu_data_irda);
+#else
+	irda_set_wakeup_keys(irda_dev, ir_ipc);
+#endif
+	writel(cpu_to_be32(phy_ir_ipc), &(ipc->ir_extended_tbl_pt));
+#endif
+	return 0;
+
+read_dtb_fail:
+	dev_err(dev, "%s read dtb fail\n", __func__);
+	return -1;
+
+mem_alloc_fail:
+	dev_err(dev, "%s mem alloc fail\n", __func__);
+	return -ENOMEM;
+}
+
+int rtk_irda_remove(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct rtk_irda_dev *irda_dev = dev_get_drvdata(dev);
+	struct irda_chrdev *chrdev = &irda_dev->chrdev;
+	dev_t dev_no;
+
+	del_timer_sync(&irda_dev->wakeup_timer);
+
+	writel(0x80000000, irda_dev->reg + IR_CR_OFF);
+
+	free_irq(irda_dev->irq, rtk_irda_isr);
+
+	dev_no = MKDEV(IRDA_CDEV_MAJOR, IRDA_CDEV_MINOR);
+	device_destroy(chrdev->class, dev_no);
+	class_destroy(chrdev->class);
+	cdev_del(&chrdev->cdev);
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+static int rtk_irda_suspend(struct device *dev)
+{
+	struct rtk_irda_dev *irda_dev = dev_get_drvdata(dev);
+	void __iomem *reg = irda_dev->reg;
+	unsigned int regValue;
+
+	dev_info(dev, "Enter %s\n", __func__);
+
+	while (readl(reg + IR_SR_OFF) & 0x1) {
+		writel(0x00000003, reg + IR_SR_OFF); /* clear IRDVF */
+		regValue = readl(reg + IR_RP_OFF); /* read IRRP */
+	}
+	regValue = readl(reg + IR_CR_OFF);
+	regValue = regValue & ~(0x400);
+	writel(regValue, reg + IR_CR_OFF);
+
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static void rtk_irda_shutdown(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+
+	rtk_irda_suspend(dev);
+
+	return;
+}
+
+static int rtk_irda_resume(struct device *dev)
+{
+	struct rtk_irda_dev *irda_dev = dev_get_drvdata(dev);
+	void __iomem *reg = irda_dev->reg;
+	unsigned int regValue;
+
+	dev_info(dev, "Enter %s\n", __func__);
+
+	while (readl(reg + IR_SR_OFF) & 0x1) {
+		writel(0x00000003, reg + IR_SR_OFF); /* clear IRDVF */
+		regValue = readl(reg + IR_RP_OFF); /* read IRRP */
+	}
+	rtk_irda_init(irda_dev);
+
+	regValue = readl(reg + IR_CR_OFF);
+	regValue = regValue | 0x400;
+	writel(regValue, reg + IR_CR_OFF);
+
+	mod_timer(&irda_dev->wakeup_timer, (jiffies + (msecs_to_jiffies(1000))));
+
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_irda_pm_ops = {
+	.suspend = rtk_irda_suspend,
+	.resume = rtk_irda_resume,
+};
+
+#else
+
+static const struct dev_pm_ops rtk_irda_pm_ops = {};
+
+#endif
+
+static const struct of_device_id rtk_irda_ids[] = {
+	{ .compatible = "Realtek,rtk-irda" },
+	{ /* Sentinel */ },
+};
+MODULE_DEVICE_TABLE(of, rtk_irda_ids);
+
+static struct platform_driver rtk_irda_driver = {
+	.driver = {
+		.name = "rtk-irda",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_irda_ids,
+#ifdef CONFIG_PM
+		.pm = &rtk_irda_pm_ops,
+#endif /* CONFIG_PM */
+	},
+	.probe = rtk_irda_probe,
+	.remove = rtk_irda_remove,
+#ifdef CONFIG_PM
+	.shutdown = rtk_irda_shutdown,
+#endif /* CONFIG_PM */
+};
+
+module_platform_driver(rtk_irda_driver);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("REALTEK Corporation");
+MODULE_ALIAS("platform:irda");
diff --git a/drivers/net/irda/realtek/rtk_irda.h b/drivers/net/irda/realtek/rtk_irda.h
new file mode 100644
index 00000000..b9a1e66
--- /dev/null
+++ b/drivers/net/irda/realtek/rtk_irda.h
@@ -0,0 +1,70 @@
+/*
+ *  rtk_irda.h - RTK irda driver header file
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+#ifndef __RTK_IRDA__H__
+#define __RTK_IRDA__H__
+
+#include <soc/realtek/rtk_ir.h>
+
+#define IRCR_RESET		1<<31
+
+#define IR_PSR_OFF		(0x00)
+#define IR_PER_OFF		(0x04)
+#define IR_SF_OFF		(0x08)
+#define IR_DPIR_OFF		(0x0c)
+#define IR_CR_OFF		(0x10)
+#define IR_RP_OFF		(0x14)
+#define IR_SR_OFF		(0x18)
+#define IR_RAW_CTRL_OFF		(0x1c)
+#define IR_RAW_FF_OFF		(0x20)
+#define IR_RAW_SAMPLE_TIME_OFF	(0x24)
+#define IR_RAW_WL_OFF		(0x28)
+#define IR_RAW_DEB_OFF		(0x2c)
+#define IR_PSR_UP_OFF		(0x30)
+#define IR_PER_UP_OFF		(0x34)
+#define IR_CTRL_RC6_OFF		(0x38)
+#define IR_RP2_OFF		(0x3C)
+#define IRTX_CFG_OFF		(0x40)
+#define IRTX_TIM_OFF		(0x44)
+#define IRTX_PWM_SETTING_OFF	(0x48)
+#define IRTX_INT_EN_OFF		(0x4c)
+#define IRTX_INT_ST_OFF		(0x50)
+#define IRTX_FIFO_ST_OFF	(0x54)
+#define IRTX_FIFO_OFF		(0x58)
+#define IRRCMM_TIMING_OFF	(0x60)
+#define IR_CR1_OFF		(0x64)
+#define IRRCMM_APKB_OFF		(0x68)
+#define IRRXRCLFIFO_OFF		(0x6C)
+#define IRDIRECTV_TIMING1	(0x70)
+#define IRDIRECTV_TIMING2	(0x74)
+#define IRCOMCAST_TIMING	(0x78)
+#define IR_RAW_SF		(0xC8)
+
+#define IR_DVF			1<<0
+#define IR_REPEAT		1<<1
+#define IR_RAWDVF		1<<2
+#define IR_RAWDOV		1<<3
+#define IR_REPEAT_EN		1<<28
+
+#define VENUS_IR_IOC_MAGIC			'r'
+#define VENUS_IR_IOC_SET_IRIOTCDP		_IOW(VENUS_IR_IOC_MAGIC, 1, int)
+#define VENUS_IR_IOC_FLUSH_IRRP			_IOW(VENUS_IR_IOC_MAGIC, 2, int)
+#define VENUS_IR_IOC_SET_PROTOCOL		_IOW(VENUS_IR_IOC_MAGIC, 3, int)
+#define VENUS_IR_IOC_SET_DEBOUNCE		_IOW(VENUS_IR_IOC_MAGIC, 4, int)
+#define VENUS_IR_IOC_SET_IRPSR			_IOW(VENUS_IR_IOC_MAGIC, 5, int)
+#define VENUS_IR_IOC_SET_IRPER			_IOW(VENUS_IR_IOC_MAGIC, 6, int)
+#define VENUS_IR_IOC_SET_IRSF			_IOW(VENUS_IR_IOC_MAGIC, 7, int)
+#define VENUS_IR_IOC_SET_IRCR			_IOW(VENUS_IR_IOC_MAGIC, 8, int)
+#define VENUS_IR_IOC_SET_DRIVER_MODE		_IOW(VENUS_IR_IOC_MAGIC, 9, int)
+#define VENUS_IR_IOC_SET_FIRST_REPEAT_DELAY	_IOW(VENUS_IR_IOC_MAGIC, 10, int)
+#define VENUS_IRTX_IOC_SET_TX_TABLE		_IOW(VENUS_IR_IOC_MAGIC, 11, int)
+#define VENUS_IRRX_RAW_STOP			_IOW(VENUS_IR_IOC_MAGIC, 12, int)
+
+#endif
diff --git a/drivers/net/irda/realtek/xmp_decoder.c b/drivers/net/irda/realtek/xmp_decoder.c
new file mode 100644
index 00000000..a361d44
--- /dev/null
+++ b/drivers/net/irda/realtek/xmp_decoder.c
@@ -0,0 +1,183 @@
+/*
+ *  xmp_decoder.c - xmp decoder for RTK irda driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/io.h>
+#include "irda_sw_decoder.h"
+
+enum {
+	dec_header = 0,
+	dec_data,
+	dec_ready,
+};
+
+struct swdec_priv {
+	unsigned int state;
+	unsigned int len_h;
+	unsigned int len_l;
+	unsigned int bitcnt;
+	int code;
+};
+
+static struct swdec_priv dec;
+
+static int get_bitcnt(unsigned int *fifo, unsigned int len,
+		      unsigned int *fifoptr, unsigned int *bitptr, int polar)
+{
+	unsigned int cnt = 0;
+
+	while (1) {
+		if (*bitptr == 0) {
+			(*fifoptr)++;
+			(*bitptr) = 32;
+		}
+		if (*fifoptr >= len) {
+			(*bitptr) = 0;
+			break;
+		}
+		if (test_bit((*bitptr) - 1,
+			     (unsigned long *)(fifo + *fifoptr)) == polar)
+			cnt++;
+		else
+			break;
+		(*bitptr)--;
+	}
+	return cnt;
+}
+
+static bool xmp_checksum(int code)
+{
+	int i;
+	int temp = 0;
+	int bits;
+
+	for (i = 0; i < 8; i++) {
+		if (i == 6)
+			continue;
+		bits = (code & (0xF << (4 * i))) >> (4 * i);
+		temp = temp + bits;
+	}
+	temp = (~temp + 1) & 0xF;
+	if (temp == (code & 0xF << 24) >> 24)
+		return true;
+	else
+		return false;
+}
+
+static int length_table[] = {
+	20, 23, 27, 30, 34, 37, 40, 44, 47, 51, 54, 58, 61, 64, 68, 71};
+
+static int xmp_dec_data(unsigned int high, unsigned int low)
+{
+	int i;
+
+	if (high > 8 || high < 3 || low < 16 || low > 72)
+		return -1;
+
+	for (i = 0; i < 0x10; i++) {
+		if (low < length_table[i])
+			return i;
+	}
+	return -1;
+}
+
+bool xmp_dec_header(unsigned int high, unsigned int low)
+{
+	if (low >= 315 && low <= 350)
+		return true;
+	return false;
+}
+
+int raw_xmp_decoder(unsigned int *fifo, int len)
+{
+	unsigned int lowcnt[2], highcnt[2];
+	unsigned int fifoptr = 0;
+	unsigned int bitptr = 32;
+	int code;
+	int valid_code = -1;
+	int dataptr;
+	int i;
+
+get_length:
+	for (i = 0; i < 2; i++) {
+		lowcnt[i] = 0;
+		highcnt[i] = 0;
+	}
+	dataptr = 0;
+	lowcnt[dataptr] = 0;
+	highcnt[dataptr] = 0;
+	highcnt[dataptr] = get_bitcnt(fifo, len, &fifoptr, &bitptr, 0);
+	lowcnt[dataptr] = get_bitcnt(fifo, len, &fifoptr, &bitptr, 1);
+
+	if (bitptr == 0 && fifoptr >= len) {
+		dec.len_h = highcnt[dataptr];
+		dec.len_l = lowcnt[dataptr];
+		goto end_decode;
+	}
+	if (dec.len_h != 0 || dec.len_l != 0) {
+		if (dec.len_h != 0 && dec.len_l != 0 &&
+		    highcnt[dataptr] != 0 && lowcnt[dataptr] != 0)
+			dataptr++;
+
+		highcnt[dataptr] += dec.len_h;
+		lowcnt[dataptr] += dec.len_l;
+		dec.len_h = 0;
+		dec.len_l = 0;
+	}
+
+start_decode:
+	switch (dec.state) {
+	case dec_header:
+		if (xmp_dec_header(highcnt[dataptr], lowcnt[dataptr]))
+			dec.state = dec_data;
+		break;
+	case dec_data:
+		code = xmp_dec_data(highcnt[dataptr], lowcnt[dataptr]);
+		if (code < 0) {
+			dec.state = 0;
+			dec.bitcnt = 0;
+			dec.code = 0;
+		} else {
+			dec.code |= code << (7 - dec.bitcnt++) * 4;
+		}
+		if (dec.bitcnt == 8)
+			dec.state = dec_ready;
+		else
+			break;
+	case dec_ready:
+		if (xmp_checksum(dec.code)) {
+			if ((dec.code & 0xFF00) != 0x4400)
+				valid_code = (dec.code & 0xFF00) >> 8;
+		}
+		dec.state = 0;
+		dec.bitcnt = 0;
+		dec.code = 0;
+		break;
+	}
+	dataptr--;
+	if (dataptr >= 0)
+		goto start_decode;
+	else
+		goto get_length;
+
+end_decode:
+	return valid_code;
+}
+
+void raw_xmp_init(void)
+{
+	memset(&dec, 0, sizeof(struct swdec_priv));
+}
+
+const struct swdec_ops xmp_swdec_ops = {
+	.init = raw_xmp_init,
+	.decoder = raw_xmp_decoder,
+};
+
diff --git a/drivers/net/ppp/Kconfig b/drivers/net/ppp/Kconfig
index 1373c6d..282aec4 100644
--- a/drivers/net/ppp/Kconfig
+++ b/drivers/net/ppp/Kconfig
@@ -149,6 +149,23 @@ config PPPOL2TP
 	  tunnels. L2TP is replacing PPTP for VPN uses.
 if TTY
 
+config PPPOLAC
+	tristate "PPP on L2TP Access Concentrator"
+	depends on PPP && INET
+	help
+	  L2TP (RFC 2661) is a tunneling protocol widely used in virtual private
+	  networks. This driver handles L2TP data packets between a UDP socket
+	  and a PPP channel, but only permits one session per socket. Thus it is
+	  fairly simple and suited for clients.
+
+config PPPOPNS
+	tristate "PPP on PPTP Network Server"
+	depends on PPP && INET
+	help
+	  PPTP (RFC 2637) is a tunneling protocol widely used in virtual private
+	  networks. This driver handles PPTP data packets between a RAW socket
+	  and a PPP channel. It is fairly simple and easy to use.
+
 config PPP_ASYNC
 	tristate "PPP support for async serial ports"
 	depends on PPP
diff --git a/drivers/net/ppp/Makefile b/drivers/net/ppp/Makefile
index a6b6297..d283d03c 100644
--- a/drivers/net/ppp/Makefile
+++ b/drivers/net/ppp/Makefile
@@ -11,3 +11,5 @@ obj-$(CONFIG_PPP_SYNC_TTY) += ppp_synctty.o
 obj-$(CONFIG_PPPOE) += pppox.o pppoe.o
 obj-$(CONFIG_PPPOL2TP) += pppox.o
 obj-$(CONFIG_PPTP) += pppox.o pptp.o
+obj-$(CONFIG_PPPOLAC) += pppox.o pppolac.o
+obj-$(CONFIG_PPPOPNS) += pppox.o pppopns.o
diff --git a/drivers/net/ppp/pppolac.c b/drivers/net/ppp/pppolac.c
new file mode 100644
index 00000000..3a45cf8
--- /dev/null
+++ b/drivers/net/ppp/pppolac.c
@@ -0,0 +1,450 @@
+/* drivers/net/pppolac.c
+ *
+ * Driver for PPP on L2TP Access Concentrator / PPPoLAC Socket (RFC 2661)
+ *
+ * Copyright (C) 2009 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+/* This driver handles L2TP data packets between a UDP socket and a PPP channel.
+ * The socket must keep connected, and only one session per socket is permitted.
+ * Sequencing of outgoing packets is controlled by LNS. Incoming packets with
+ * sequences are reordered within a sliding window of one second. Currently
+ * reordering only happens when a packet is received. It is done for simplicity
+ * since no additional locks or threads are required. This driver only works on
+ * IPv4 due to the lack of UDP encapsulation support in IPv6. */
+
+#include <linux/module.h>
+#include <linux/jiffies.h>
+#include <linux/workqueue.h>
+#include <linux/skbuff.h>
+#include <linux/file.h>
+#include <linux/netdevice.h>
+#include <linux/net.h>
+#include <linux/udp.h>
+#include <linux/ppp_defs.h>
+#include <linux/if_ppp.h>
+#include <linux/if_pppox.h>
+#include <linux/ppp_channel.h>
+#include <net/tcp_states.h>
+#include <asm/uaccess.h>
+
+#define L2TP_CONTROL_BIT	0x80
+#define L2TP_LENGTH_BIT		0x40
+#define L2TP_SEQUENCE_BIT	0x08
+#define L2TP_OFFSET_BIT		0x02
+#define L2TP_VERSION		0x02
+#define L2TP_VERSION_MASK	0x0F
+
+#define PPP_ADDR	0xFF
+#define PPP_CTRL	0x03
+
+union unaligned {
+	__u32 u32;
+} __attribute__((packed));
+
+static inline union unaligned *unaligned(void *ptr)
+{
+	return (union unaligned *)ptr;
+}
+
+struct meta {
+	__u32 sequence;
+	__u32 timestamp;
+};
+
+static inline struct meta *skb_meta(struct sk_buff *skb)
+{
+	return (struct meta *)skb->cb;
+}
+
+/******************************************************************************/
+
+static int pppolac_recv_core(struct sock *sk_udp, struct sk_buff *skb)
+{
+	struct sock *sk = (struct sock *)sk_udp->sk_user_data;
+	struct pppolac_opt *opt = &pppox_sk(sk)->proto.lac;
+	struct meta *meta = skb_meta(skb);
+	__u32 now = jiffies;
+	__u8 bits;
+	__u8 *ptr;
+
+	/* Drop the packet if L2TP header is missing. */
+	if (skb->len < sizeof(struct udphdr) + 6)
+		goto drop;
+
+	/* Put it back if it is a control packet. */
+	if (skb->data[sizeof(struct udphdr)] & L2TP_CONTROL_BIT)
+		return opt->backlog_rcv(sk_udp, skb);
+
+	/* Skip UDP header. */
+	skb_pull(skb, sizeof(struct udphdr));
+
+	/* Check the version. */
+	if ((skb->data[1] & L2TP_VERSION_MASK) != L2TP_VERSION)
+		goto drop;
+	bits = skb->data[0];
+	ptr = &skb->data[2];
+
+	/* Check the length if it is present. */
+	if (bits & L2TP_LENGTH_BIT) {
+		if ((ptr[0] << 8 | ptr[1]) != skb->len)
+			goto drop;
+		ptr += 2;
+	}
+
+	/* Skip all fields including optional ones. */
+	if (!skb_pull(skb, 6 + (bits & L2TP_SEQUENCE_BIT ? 4 : 0) +
+			(bits & L2TP_LENGTH_BIT ? 2 : 0) +
+			(bits & L2TP_OFFSET_BIT ? 2 : 0)))
+		goto drop;
+
+	/* Skip the offset padding if it is present. */
+	if (bits & L2TP_OFFSET_BIT &&
+			!skb_pull(skb, skb->data[-2] << 8 | skb->data[-1]))
+		goto drop;
+
+	/* Check the tunnel and the session. */
+	if (unaligned(ptr)->u32 != opt->local)
+		goto drop;
+
+	/* Check the sequence if it is present. */
+	if (bits & L2TP_SEQUENCE_BIT) {
+		meta->sequence = ptr[4] << 8 | ptr[5];
+		if ((__s16)(meta->sequence - opt->recv_sequence) < 0)
+			goto drop;
+	}
+
+	/* Skip PPP address and control if they are present. */
+	if (skb->len >= 2 && skb->data[0] == PPP_ADDR &&
+			skb->data[1] == PPP_CTRL)
+		skb_pull(skb, 2);
+
+	/* Fix PPP protocol if it is compressed. */
+	if (skb->len >= 1 && skb->data[0] & 1)
+		skb_push(skb, 1)[0] = 0;
+
+	/* Drop the packet if PPP protocol is missing. */
+	if (skb->len < 2)
+		goto drop;
+
+	/* Perform reordering if sequencing is enabled. */
+	atomic_set(&opt->sequencing, bits & L2TP_SEQUENCE_BIT);
+	if (bits & L2TP_SEQUENCE_BIT) {
+		struct sk_buff *skb1;
+
+		/* Insert the packet into receive queue in order. */
+		skb_set_owner_r(skb, sk);
+		skb_queue_walk(&sk->sk_receive_queue, skb1) {
+			struct meta *meta1 = skb_meta(skb1);
+			__s16 order = meta->sequence - meta1->sequence;
+			if (order == 0)
+				goto drop;
+			if (order < 0) {
+				meta->timestamp = meta1->timestamp;
+				skb_insert(skb1, skb, &sk->sk_receive_queue);
+				skb = NULL;
+				break;
+			}
+		}
+		if (skb) {
+			meta->timestamp = now;
+			skb_queue_tail(&sk->sk_receive_queue, skb);
+		}
+
+		/* Remove packets from receive queue as long as
+		 * 1. the receive buffer is full,
+		 * 2. they are queued longer than one second, or
+		 * 3. there are no missing packets before them. */
+		skb_queue_walk_safe(&sk->sk_receive_queue, skb, skb1) {
+			meta = skb_meta(skb);
+			if (atomic_read(&sk->sk_rmem_alloc) < sk->sk_rcvbuf &&
+					now - meta->timestamp < HZ &&
+					meta->sequence != opt->recv_sequence)
+				break;
+			skb_unlink(skb, &sk->sk_receive_queue);
+			opt->recv_sequence = (__u16)(meta->sequence + 1);
+			skb_orphan(skb);
+			ppp_input(&pppox_sk(sk)->chan, skb);
+		}
+		return NET_RX_SUCCESS;
+	}
+
+	/* Flush receive queue if sequencing is disabled. */
+	skb_queue_purge(&sk->sk_receive_queue);
+	skb_orphan(skb);
+	ppp_input(&pppox_sk(sk)->chan, skb);
+	return NET_RX_SUCCESS;
+drop:
+	kfree_skb(skb);
+	return NET_RX_DROP;
+}
+
+static int pppolac_recv(struct sock *sk_udp, struct sk_buff *skb)
+{
+	sock_hold(sk_udp);
+	sk_receive_skb(sk_udp, skb, 0);
+	return 0;
+}
+
+static struct sk_buff_head delivery_queue;
+
+static void pppolac_xmit_core(struct work_struct *delivery_work)
+{
+	mm_segment_t old_fs = get_fs();
+	struct sk_buff *skb;
+
+	set_fs(KERNEL_DS);
+	while ((skb = skb_dequeue(&delivery_queue))) {
+		struct sock *sk_udp = skb->sk;
+		struct kvec iov = {.iov_base = skb->data, .iov_len = skb->len};
+		struct msghdr msg = {
+			.msg_flags = MSG_NOSIGNAL | MSG_DONTWAIT,
+		};
+
+		iov_iter_kvec(&msg.msg_iter, WRITE | ITER_KVEC, &iov, 1,
+			      skb->len);
+		sk_udp->sk_prot->sendmsg(sk_udp, &msg, skb->len);
+		kfree_skb(skb);
+	}
+	set_fs(old_fs);
+}
+
+static DECLARE_WORK(delivery_work, pppolac_xmit_core);
+
+static int pppolac_xmit(struct ppp_channel *chan, struct sk_buff *skb)
+{
+	struct sock *sk_udp = (struct sock *)chan->private;
+	struct pppolac_opt *opt = &pppox_sk(sk_udp->sk_user_data)->proto.lac;
+
+	/* Install PPP address and control. */
+	skb_push(skb, 2);
+	skb->data[0] = PPP_ADDR;
+	skb->data[1] = PPP_CTRL;
+
+	/* Install L2TP header. */
+	if (atomic_read(&opt->sequencing)) {
+		skb_push(skb, 10);
+		skb->data[0] = L2TP_SEQUENCE_BIT;
+		skb->data[6] = opt->xmit_sequence >> 8;
+		skb->data[7] = opt->xmit_sequence;
+		skb->data[8] = 0;
+		skb->data[9] = 0;
+		opt->xmit_sequence++;
+	} else {
+		skb_push(skb, 6);
+		skb->data[0] = 0;
+	}
+	skb->data[1] = L2TP_VERSION;
+	unaligned(&skb->data[2])->u32 = opt->remote;
+
+	/* Now send the packet via the delivery queue. */
+	skb_set_owner_w(skb, sk_udp);
+	skb_queue_tail(&delivery_queue, skb);
+	schedule_work(&delivery_work);
+	return 1;
+}
+
+/******************************************************************************/
+
+static struct ppp_channel_ops pppolac_channel_ops = {
+	.start_xmit = pppolac_xmit,
+};
+
+static int pppolac_connect(struct socket *sock, struct sockaddr *useraddr,
+	int addrlen, int flags)
+{
+	struct sock *sk = sock->sk;
+	struct pppox_sock *po = pppox_sk(sk);
+	struct sockaddr_pppolac *addr = (struct sockaddr_pppolac *)useraddr;
+	struct socket *sock_udp = NULL;
+	struct sock *sk_udp;
+	int error;
+
+	if (addrlen != sizeof(struct sockaddr_pppolac) ||
+			!addr->local.tunnel || !addr->local.session ||
+			!addr->remote.tunnel || !addr->remote.session) {
+		return -EINVAL;
+	}
+
+	lock_sock(sk);
+	error = -EALREADY;
+	if (sk->sk_state != PPPOX_NONE)
+		goto out;
+
+	sock_udp = sockfd_lookup(addr->udp_socket, &error);
+	if (!sock_udp)
+		goto out;
+	sk_udp = sock_udp->sk;
+	lock_sock(sk_udp);
+
+	/* Remove this check when IPv6 supports UDP encapsulation. */
+	error = -EAFNOSUPPORT;
+	if (sk_udp->sk_family != AF_INET)
+		goto out;
+	error = -EPROTONOSUPPORT;
+	if (sk_udp->sk_protocol != IPPROTO_UDP)
+		goto out;
+	error = -EDESTADDRREQ;
+	if (sk_udp->sk_state != TCP_ESTABLISHED)
+		goto out;
+	error = -EBUSY;
+	if (udp_sk(sk_udp)->encap_type || sk_udp->sk_user_data)
+		goto out;
+	if (!sk_udp->sk_bound_dev_if) {
+		struct dst_entry *dst = sk_dst_get(sk_udp);
+		error = -ENODEV;
+		if (!dst)
+			goto out;
+		sk_udp->sk_bound_dev_if = dst->dev->ifindex;
+		dst_release(dst);
+	}
+
+	po->chan.hdrlen = 12;
+	po->chan.private = sk_udp;
+	po->chan.ops = &pppolac_channel_ops;
+	po->chan.mtu = PPP_MRU - 80;
+	po->proto.lac.local = unaligned(&addr->local)->u32;
+	po->proto.lac.remote = unaligned(&addr->remote)->u32;
+	atomic_set(&po->proto.lac.sequencing, 1);
+	po->proto.lac.backlog_rcv = sk_udp->sk_backlog_rcv;
+
+	error = ppp_register_channel(&po->chan);
+	if (error)
+		goto out;
+
+	sk->sk_state = PPPOX_CONNECTED;
+	udp_sk(sk_udp)->encap_type = UDP_ENCAP_L2TPINUDP;
+	udp_sk(sk_udp)->encap_rcv = pppolac_recv;
+	sk_udp->sk_backlog_rcv = pppolac_recv_core;
+	sk_udp->sk_user_data = sk;
+out:
+	if (sock_udp) {
+		release_sock(sk_udp);
+		if (error)
+			sockfd_put(sock_udp);
+	}
+	release_sock(sk);
+	return error;
+}
+
+static int pppolac_release(struct socket *sock)
+{
+	struct sock *sk = sock->sk;
+
+	if (!sk)
+		return 0;
+
+	lock_sock(sk);
+	if (sock_flag(sk, SOCK_DEAD)) {
+		release_sock(sk);
+		return -EBADF;
+	}
+
+	if (sk->sk_state != PPPOX_NONE) {
+		struct sock *sk_udp = (struct sock *)pppox_sk(sk)->chan.private;
+		lock_sock(sk_udp);
+		skb_queue_purge(&sk->sk_receive_queue);
+		pppox_unbind_sock(sk);
+		udp_sk(sk_udp)->encap_type = 0;
+		udp_sk(sk_udp)->encap_rcv = NULL;
+		sk_udp->sk_backlog_rcv = pppox_sk(sk)->proto.lac.backlog_rcv;
+		sk_udp->sk_user_data = NULL;
+		release_sock(sk_udp);
+		sockfd_put(sk_udp->sk_socket);
+	}
+
+	sock_orphan(sk);
+	sock->sk = NULL;
+	release_sock(sk);
+	sock_put(sk);
+	return 0;
+}
+
+/******************************************************************************/
+
+static struct proto pppolac_proto = {
+	.name = "PPPOLAC",
+	.owner = THIS_MODULE,
+	.obj_size = sizeof(struct pppox_sock),
+};
+
+static struct proto_ops pppolac_proto_ops = {
+	.family = PF_PPPOX,
+	.owner = THIS_MODULE,
+	.release = pppolac_release,
+	.bind = sock_no_bind,
+	.connect = pppolac_connect,
+	.socketpair = sock_no_socketpair,
+	.accept = sock_no_accept,
+	.getname = sock_no_getname,
+	.poll = sock_no_poll,
+	.ioctl = pppox_ioctl,
+	.listen = sock_no_listen,
+	.shutdown = sock_no_shutdown,
+	.setsockopt = sock_no_setsockopt,
+	.getsockopt = sock_no_getsockopt,
+	.sendmsg = sock_no_sendmsg,
+	.recvmsg = sock_no_recvmsg,
+	.mmap = sock_no_mmap,
+};
+
+static int pppolac_create(struct net *net, struct socket *sock, int kern)
+{
+	struct sock *sk;
+
+	sk = sk_alloc(net, PF_PPPOX, GFP_KERNEL, &pppolac_proto, kern);
+	if (!sk)
+		return -ENOMEM;
+
+	sock_init_data(sock, sk);
+	sock->state = SS_UNCONNECTED;
+	sock->ops = &pppolac_proto_ops;
+	sk->sk_protocol = PX_PROTO_OLAC;
+	sk->sk_state = PPPOX_NONE;
+	return 0;
+}
+
+/******************************************************************************/
+
+static struct pppox_proto pppolac_pppox_proto = {
+	.create = pppolac_create,
+	.owner = THIS_MODULE,
+};
+
+static int __init pppolac_init(void)
+{
+	int error;
+
+	error = proto_register(&pppolac_proto, 0);
+	if (error)
+		return error;
+
+	error = register_pppox_proto(PX_PROTO_OLAC, &pppolac_pppox_proto);
+	if (error)
+		proto_unregister(&pppolac_proto);
+	else
+		skb_queue_head_init(&delivery_queue);
+	return error;
+}
+
+static void __exit pppolac_exit(void)
+{
+	unregister_pppox_proto(PX_PROTO_OLAC);
+	proto_unregister(&pppolac_proto);
+}
+
+module_init(pppolac_init);
+module_exit(pppolac_exit);
+
+MODULE_DESCRIPTION("PPP on L2TP Access Concentrator (PPPoLAC)");
+MODULE_AUTHOR("Chia-chi Yeh <chiachi@android.com>");
+MODULE_LICENSE("GPL");
diff --git a/drivers/net/ppp/pppopns.c b/drivers/net/ppp/pppopns.c
new file mode 100644
index 00000000..cdb4fa1
--- /dev/null
+++ b/drivers/net/ppp/pppopns.c
@@ -0,0 +1,429 @@
+/* drivers/net/pppopns.c
+ *
+ * Driver for PPP on PPTP Network Server / PPPoPNS Socket (RFC 2637)
+ *
+ * Copyright (C) 2009 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+/* This driver handles PPTP data packets between a RAW socket and a PPP channel.
+ * The socket is created in the kernel space and connected to the same address
+ * of the control socket. Outgoing packets are always sent with sequences but
+ * without acknowledgements. Incoming packets with sequences are reordered
+ * within a sliding window of one second. Currently reordering only happens when
+ * a packet is received. It is done for simplicity since no additional locks or
+ * threads are required. This driver should work on both IPv4 and IPv6. */
+
+#include <linux/module.h>
+#include <linux/jiffies.h>
+#include <linux/workqueue.h>
+#include <linux/skbuff.h>
+#include <linux/file.h>
+#include <linux/netdevice.h>
+#include <linux/net.h>
+#include <linux/ppp_defs.h>
+#include <linux/if.h>
+#include <linux/if_ppp.h>
+#include <linux/if_pppox.h>
+#include <linux/ppp_channel.h>
+#include <asm/uaccess.h>
+
+#define GRE_HEADER_SIZE		8
+
+#define PPTP_GRE_BITS		htons(0x2001)
+#define PPTP_GRE_BITS_MASK	htons(0xEF7F)
+#define PPTP_GRE_SEQ_BIT	htons(0x1000)
+#define PPTP_GRE_ACK_BIT	htons(0x0080)
+#define PPTP_GRE_TYPE		htons(0x880B)
+
+#define PPP_ADDR	0xFF
+#define PPP_CTRL	0x03
+
+struct header {
+	__u16	bits;
+	__u16	type;
+	__u16	length;
+	__u16	call;
+	__u32	sequence;
+} __attribute__((packed));
+
+struct meta {
+	__u32 sequence;
+	__u32 timestamp;
+};
+
+static inline struct meta *skb_meta(struct sk_buff *skb)
+{
+	return (struct meta *)skb->cb;
+}
+
+/******************************************************************************/
+
+static int pppopns_recv_core(struct sock *sk_raw, struct sk_buff *skb)
+{
+	struct sock *sk = (struct sock *)sk_raw->sk_user_data;
+	struct pppopns_opt *opt = &pppox_sk(sk)->proto.pns;
+	struct meta *meta = skb_meta(skb);
+	__u32 now = jiffies;
+	struct header *hdr;
+
+	/* Skip transport header */
+	skb_pull(skb, skb_transport_header(skb) - skb->data);
+
+	/* Drop the packet if GRE header is missing. */
+	if (skb->len < GRE_HEADER_SIZE)
+		goto drop;
+	hdr = (struct header *)skb->data;
+
+	/* Check the header. */
+	if (hdr->type != PPTP_GRE_TYPE || hdr->call != opt->local ||
+			(hdr->bits & PPTP_GRE_BITS_MASK) != PPTP_GRE_BITS)
+		goto drop;
+
+	/* Skip all fields including optional ones. */
+	if (!skb_pull(skb, GRE_HEADER_SIZE +
+			(hdr->bits & PPTP_GRE_SEQ_BIT ? 4 : 0) +
+			(hdr->bits & PPTP_GRE_ACK_BIT ? 4 : 0)))
+		goto drop;
+
+	/* Check the length. */
+	if (skb->len != ntohs(hdr->length))
+		goto drop;
+
+	/* Check the sequence if it is present. */
+	if (hdr->bits & PPTP_GRE_SEQ_BIT) {
+		meta->sequence = ntohl(hdr->sequence);
+		if ((__s32)(meta->sequence - opt->recv_sequence) < 0)
+			goto drop;
+	}
+
+	/* Skip PPP address and control if they are present. */
+	if (skb->len >= 2 && skb->data[0] == PPP_ADDR &&
+			skb->data[1] == PPP_CTRL)
+		skb_pull(skb, 2);
+
+	/* Fix PPP protocol if it is compressed. */
+	if (skb->len >= 1 && skb->data[0] & 1)
+		skb_push(skb, 1)[0] = 0;
+
+	/* Drop the packet if PPP protocol is missing. */
+	if (skb->len < 2)
+		goto drop;
+
+	/* Perform reordering if sequencing is enabled. */
+	if (hdr->bits & PPTP_GRE_SEQ_BIT) {
+		struct sk_buff *skb1;
+
+		/* Insert the packet into receive queue in order. */
+		skb_set_owner_r(skb, sk);
+		skb_queue_walk(&sk->sk_receive_queue, skb1) {
+			struct meta *meta1 = skb_meta(skb1);
+			__s32 order = meta->sequence - meta1->sequence;
+			if (order == 0)
+				goto drop;
+			if (order < 0) {
+				meta->timestamp = meta1->timestamp;
+				skb_insert(skb1, skb, &sk->sk_receive_queue);
+				skb = NULL;
+				break;
+			}
+		}
+		if (skb) {
+			meta->timestamp = now;
+			skb_queue_tail(&sk->sk_receive_queue, skb);
+		}
+
+		/* Remove packets from receive queue as long as
+		 * 1. the receive buffer is full,
+		 * 2. they are queued longer than one second, or
+		 * 3. there are no missing packets before them. */
+		skb_queue_walk_safe(&sk->sk_receive_queue, skb, skb1) {
+			meta = skb_meta(skb);
+			if (atomic_read(&sk->sk_rmem_alloc) < sk->sk_rcvbuf &&
+					now - meta->timestamp < HZ &&
+					meta->sequence != opt->recv_sequence)
+				break;
+			skb_unlink(skb, &sk->sk_receive_queue);
+			opt->recv_sequence = meta->sequence + 1;
+			skb_orphan(skb);
+			ppp_input(&pppox_sk(sk)->chan, skb);
+		}
+		return NET_RX_SUCCESS;
+	}
+
+	/* Flush receive queue if sequencing is disabled. */
+	skb_queue_purge(&sk->sk_receive_queue);
+	skb_orphan(skb);
+	ppp_input(&pppox_sk(sk)->chan, skb);
+	return NET_RX_SUCCESS;
+drop:
+	kfree_skb(skb);
+	return NET_RX_DROP;
+}
+
+static void pppopns_recv(struct sock *sk_raw)
+{
+	struct sk_buff *skb;
+	while ((skb = skb_dequeue(&sk_raw->sk_receive_queue))) {
+		sock_hold(sk_raw);
+		sk_receive_skb(sk_raw, skb, 0);
+	}
+}
+
+static struct sk_buff_head delivery_queue;
+
+static void pppopns_xmit_core(struct work_struct *delivery_work)
+{
+	mm_segment_t old_fs = get_fs();
+	struct sk_buff *skb;
+
+	set_fs(KERNEL_DS);
+	while ((skb = skb_dequeue(&delivery_queue))) {
+		struct sock *sk_raw = skb->sk;
+		struct kvec iov = {.iov_base = skb->data, .iov_len = skb->len};
+		struct msghdr msg = {
+			.msg_flags = MSG_NOSIGNAL | MSG_DONTWAIT,
+		};
+
+		iov_iter_kvec(&msg.msg_iter, WRITE | ITER_KVEC, &iov, 1,
+			      skb->len);
+		sk_raw->sk_prot->sendmsg(sk_raw, &msg, skb->len);
+		kfree_skb(skb);
+	}
+	set_fs(old_fs);
+}
+
+static DECLARE_WORK(delivery_work, pppopns_xmit_core);
+
+static int pppopns_xmit(struct ppp_channel *chan, struct sk_buff *skb)
+{
+	struct sock *sk_raw = (struct sock *)chan->private;
+	struct pppopns_opt *opt = &pppox_sk(sk_raw->sk_user_data)->proto.pns;
+	struct header *hdr;
+	__u16 length;
+
+	/* Install PPP address and control. */
+	skb_push(skb, 2);
+	skb->data[0] = PPP_ADDR;
+	skb->data[1] = PPP_CTRL;
+	length = skb->len;
+
+	/* Install PPTP GRE header. */
+	hdr = (struct header *)skb_push(skb, 12);
+	hdr->bits = PPTP_GRE_BITS | PPTP_GRE_SEQ_BIT;
+	hdr->type = PPTP_GRE_TYPE;
+	hdr->length = htons(length);
+	hdr->call = opt->remote;
+	hdr->sequence = htonl(opt->xmit_sequence);
+	opt->xmit_sequence++;
+
+	/* Now send the packet via the delivery queue. */
+	skb_set_owner_w(skb, sk_raw);
+	skb_queue_tail(&delivery_queue, skb);
+	schedule_work(&delivery_work);
+	return 1;
+}
+
+/******************************************************************************/
+
+static struct ppp_channel_ops pppopns_channel_ops = {
+	.start_xmit = pppopns_xmit,
+};
+
+static int pppopns_connect(struct socket *sock, struct sockaddr *useraddr,
+	int addrlen, int flags)
+{
+	struct sock *sk = sock->sk;
+	struct pppox_sock *po = pppox_sk(sk);
+	struct sockaddr_pppopns *addr = (struct sockaddr_pppopns *)useraddr;
+	struct sockaddr_storage ss;
+	struct socket *sock_tcp = NULL;
+	struct socket *sock_raw = NULL;
+	struct sock *sk_tcp;
+	struct sock *sk_raw;
+	int error;
+
+	if (addrlen != sizeof(struct sockaddr_pppopns))
+		return -EINVAL;
+
+	lock_sock(sk);
+	error = -EALREADY;
+	if (sk->sk_state != PPPOX_NONE)
+		goto out;
+
+	sock_tcp = sockfd_lookup(addr->tcp_socket, &error);
+	if (!sock_tcp)
+		goto out;
+	sk_tcp = sock_tcp->sk;
+	error = -EPROTONOSUPPORT;
+	if (sk_tcp->sk_protocol != IPPROTO_TCP)
+		goto out;
+	addrlen = sizeof(struct sockaddr_storage);
+	error = kernel_getpeername(sock_tcp, (struct sockaddr *)&ss, &addrlen);
+	if (error)
+		goto out;
+	if (!sk_tcp->sk_bound_dev_if) {
+		struct dst_entry *dst = sk_dst_get(sk_tcp);
+		error = -ENODEV;
+		if (!dst)
+			goto out;
+		sk_tcp->sk_bound_dev_if = dst->dev->ifindex;
+		dst_release(dst);
+	}
+
+	error = sock_create(ss.ss_family, SOCK_RAW, IPPROTO_GRE, &sock_raw);
+	if (error)
+		goto out;
+	sk_raw = sock_raw->sk;
+	sk_raw->sk_bound_dev_if = sk_tcp->sk_bound_dev_if;
+	error = kernel_connect(sock_raw, (struct sockaddr *)&ss, addrlen, 0);
+	if (error)
+		goto out;
+
+	po->chan.hdrlen = 14;
+	po->chan.private = sk_raw;
+	po->chan.ops = &pppopns_channel_ops;
+	po->chan.mtu = PPP_MRU - 80;
+	po->proto.pns.local = addr->local;
+	po->proto.pns.remote = addr->remote;
+	po->proto.pns.data_ready = sk_raw->sk_data_ready;
+	po->proto.pns.backlog_rcv = sk_raw->sk_backlog_rcv;
+
+	error = ppp_register_channel(&po->chan);
+	if (error)
+		goto out;
+
+	sk->sk_state = PPPOX_CONNECTED;
+	lock_sock(sk_raw);
+	sk_raw->sk_data_ready = pppopns_recv;
+	sk_raw->sk_backlog_rcv = pppopns_recv_core;
+	sk_raw->sk_user_data = sk;
+	release_sock(sk_raw);
+out:
+	if (sock_tcp)
+		sockfd_put(sock_tcp);
+	if (error && sock_raw)
+		sock_release(sock_raw);
+	release_sock(sk);
+	return error;
+}
+
+static int pppopns_release(struct socket *sock)
+{
+	struct sock *sk = sock->sk;
+
+	if (!sk)
+		return 0;
+
+	lock_sock(sk);
+	if (sock_flag(sk, SOCK_DEAD)) {
+		release_sock(sk);
+		return -EBADF;
+	}
+
+	if (sk->sk_state != PPPOX_NONE) {
+		struct sock *sk_raw = (struct sock *)pppox_sk(sk)->chan.private;
+		lock_sock(sk_raw);
+		skb_queue_purge(&sk->sk_receive_queue);
+		pppox_unbind_sock(sk);
+		sk_raw->sk_data_ready = pppox_sk(sk)->proto.pns.data_ready;
+		sk_raw->sk_backlog_rcv = pppox_sk(sk)->proto.pns.backlog_rcv;
+		sk_raw->sk_user_data = NULL;
+		release_sock(sk_raw);
+		sock_release(sk_raw->sk_socket);
+	}
+
+	sock_orphan(sk);
+	sock->sk = NULL;
+	release_sock(sk);
+	sock_put(sk);
+	return 0;
+}
+
+/******************************************************************************/
+
+static struct proto pppopns_proto = {
+	.name = "PPPOPNS",
+	.owner = THIS_MODULE,
+	.obj_size = sizeof(struct pppox_sock),
+};
+
+static struct proto_ops pppopns_proto_ops = {
+	.family = PF_PPPOX,
+	.owner = THIS_MODULE,
+	.release = pppopns_release,
+	.bind = sock_no_bind,
+	.connect = pppopns_connect,
+	.socketpair = sock_no_socketpair,
+	.accept = sock_no_accept,
+	.getname = sock_no_getname,
+	.poll = sock_no_poll,
+	.ioctl = pppox_ioctl,
+	.listen = sock_no_listen,
+	.shutdown = sock_no_shutdown,
+	.setsockopt = sock_no_setsockopt,
+	.getsockopt = sock_no_getsockopt,
+	.sendmsg = sock_no_sendmsg,
+	.recvmsg = sock_no_recvmsg,
+	.mmap = sock_no_mmap,
+};
+
+static int pppopns_create(struct net *net, struct socket *sock, int kern)
+{
+	struct sock *sk;
+
+	sk = sk_alloc(net, PF_PPPOX, GFP_KERNEL, &pppopns_proto, kern);
+	if (!sk)
+		return -ENOMEM;
+
+	sock_init_data(sock, sk);
+	sock->state = SS_UNCONNECTED;
+	sock->ops = &pppopns_proto_ops;
+	sk->sk_protocol = PX_PROTO_OPNS;
+	sk->sk_state = PPPOX_NONE;
+	return 0;
+}
+
+/******************************************************************************/
+
+static struct pppox_proto pppopns_pppox_proto = {
+	.create = pppopns_create,
+	.owner = THIS_MODULE,
+};
+
+static int __init pppopns_init(void)
+{
+	int error;
+
+	error = proto_register(&pppopns_proto, 0);
+	if (error)
+		return error;
+
+	error = register_pppox_proto(PX_PROTO_OPNS, &pppopns_pppox_proto);
+	if (error)
+		proto_unregister(&pppopns_proto);
+	else
+		skb_queue_head_init(&delivery_queue);
+	return error;
+}
+
+static void __exit pppopns_exit(void)
+{
+	unregister_pppox_proto(PX_PROTO_OPNS);
+	proto_unregister(&pppopns_proto);
+}
+
+module_init(pppopns_init);
+module_exit(pppopns_exit);
+
+MODULE_DESCRIPTION("PPP on PPTP Network Server (PPPoPNS)");
+MODULE_AUTHOR("Chia-chi Yeh <chiachi@android.com>");
+MODULE_LICENSE("GPL");
diff --git a/drivers/net/tun.c b/drivers/net/tun.c
index eb6dc28..5f51668 100644
--- a/drivers/net/tun.c
+++ b/drivers/net/tun.c
@@ -2019,6 +2019,12 @@ static long __tun_chr_ioctl(struct file *file, unsigned int cmd,
 	int le;
 	int ret;
 
+#ifdef CONFIG_ANDROID_PARANOID_NETWORK
+	if (cmd != TUNGETIFF && !capable(CAP_NET_ADMIN)) {
+		return -EPERM;
+	}
+#endif
+
 	if (cmd == TUNSETIFF || cmd == TUNSETQUEUE || _IOC_TYPE(cmd) == 0x89) {
 		if (copy_from_user(&ifr, argp, ifreq_len))
 			return -EFAULT;
diff --git a/drivers/net/usb/Makefile b/drivers/net/usb/Makefile
index 37fb46ae..5689090 100644
--- a/drivers/net/usb/Makefile
+++ b/drivers/net/usb/Makefile
@@ -6,7 +6,7 @@ obj-$(CONFIG_USB_CATC)		+= catc.o
 obj-$(CONFIG_USB_KAWETH)	+= kaweth.o
 obj-$(CONFIG_USB_PEGASUS)	+= pegasus.o
 obj-$(CONFIG_USB_RTL8150)	+= rtl8150.o
-obj-$(CONFIG_USB_RTL8152)	+= r8152.o
+obj-$(CONFIG_USB_RTL8152)	+= r8152/
 obj-$(CONFIG_USB_HSO)		+= hso.o
 obj-$(CONFIG_USB_LAN78XX)	+= lan78xx.o
 obj-$(CONFIG_USB_NET_AX8817X)	+= asix.o
diff --git a/drivers/net/usb/r8152/Makefile b/drivers/net/usb/r8152/Makefile
new file mode 100644
index 00000000..8c9a808
--- /dev/null
+++ b/drivers/net/usb/r8152/Makefile
@@ -0,0 +1,49 @@
+#
+#
+#
+
+CONFIG_CTAP_SHORT = ON
+
+ifneq ($(KERNELRELEASE),)
+	obj-$(CONFIG_USB_RTL8152)	:= r8152.o
+#	EXTRA_CFLAGS += -DRTL8152_S5_WOL
+#	EXTRA_CFLAGS += -DRTL8152_DEBUG
+	ifneq (,$(filter OFF off, $(CONFIG_CTAP_SHORT)))
+		EXTRA_CFLAGS += -DCONFIG_CTAP_SHORT_OFF
+	endif
+else
+	KERNELDIR ?= /lib/modules/$(shell uname -r)/build
+	PWD :=$(shell pwd)
+	TARGET_PATH := kernel/drivers/net/usb
+	INBOXDRIVER := $(shell find $(subst build,$(TARGET_PATH),$(KERNELDIR)) -name r8152.ko.* -type f)
+	RULEFILE = 50-usb-realtek-net.rules
+	RULEDIR = /etc/udev/rules.d/
+
+.PHONY: modules
+modules:
+	$(MAKE) -C $(KERNELDIR) M=$(PWD) modules
+
+.PHONY: all
+all: clean modules install
+
+.PHONY: clean
+clean:
+	$(MAKE) -C $(KERNELDIR) M=$(PWD) clean
+
+.PHONY: install
+install:
+ifneq ($(shell lsmod | grep r8152),)
+	rmmod r8152
+endif
+ifneq ($(INBOXDRIVER),)
+	rm -f $(INBOXDRIVER)
+endif
+	$(MAKE) -C $(KERNELDIR) M=$(PWD) INSTALL_MOD_DIR=$(TARGET_PATH) modules_install
+	modprobe r8152
+
+.PHONY: install_rules
+install_rules:
+	install --group=root --owner=root --mode=0644 $(RULEFILE) $(RULEDIR)
+
+endif
+
diff --git a/drivers/net/usb/r8152/compatibility.h b/drivers/net/usb/r8152/compatibility.h
new file mode 100644
index 00000000..511d837
--- /dev/null
+++ b/drivers/net/usb/r8152/compatibility.h
@@ -0,0 +1,514 @@
+#ifndef LINUX_COMPATIBILITY_H
+#define LINUX_COMPATIBILITY_H
+
+/*
+ * Definition and macro
+ */
+
+#include <linux/init.h>
+#include <linux/version.h>
+#include <linux/in.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,31)
+	#include <linux/mdio.h>
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,7,0)
+	#include <uapi/linux/mdio.h>
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,7,0) */
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,31) */
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,12,0)
+	#define SPEED_2500				2500
+	#define SPEED_25000				25000
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,9,0)
+	#define BMCR_SPEED10				0x0000
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,5,0)
+	#define NETIF_F_CSUM_MASK			NETIF_F_ALL_CSUM
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,1,0)
+	#define IS_REACHABLE(option)			(defined(option) || \
+							 (defined(option##_MODULE) && defined(MODULE)))
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,0,0)
+	#define skb_vlan_tag_present(__skb)		vlan_tx_tag_present(__skb)
+	#define skb_vlan_tag_get(__skb)			vlan_tx_tag_get(__skb)
+	#define skb_vlan_tag_get_id(__skb)		vlan_tx_tag_get_id(__skb)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,19,0)
+	#define napi_alloc_skb(napi, length)		netdev_alloc_skb_ip_align(netdev,length)
+	#define napi_complete_done(n, d)		napi_complete(n)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,16,0)
+	#ifndef smp_mb__before_atomic
+	#define smp_mb__before_atomic()			smp_mb()
+	#endif
+
+	#ifndef smp_mb__after_atomic
+	#define smp_mb__after_atomic()			smp_mb()
+	#endif
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,15,0)
+	#define IS_ERR_OR_NULL(ptr)			(!ptr)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,14,0)
+	#define ether_addr_copy(dst, src)		memcpy(dst, src, ETH_ALEN)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,13,0)
+	#define BIT(nr)					(1UL << (nr))
+	#define BIT_ULL(nr)				(1ULL << (nr))
+	#define BITS_PER_BYTE				8
+	#define reinit_completion(x)			((x)->done = 0)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,12,0)
+	static inline bool usb_device_no_sg_constraint(struct usb_device *udev)
+	{
+		return 0;
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0)
+	#define NETIF_F_HW_VLAN_CTAG_RX			NETIF_F_HW_VLAN_RX
+	#define NETIF_F_HW_VLAN_CTAG_TX			NETIF_F_HW_VLAN_TX
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,8,0)
+	#define USB_DEVICE_INTERFACE_CLASS(vend, prod, iclass) \
+		USB_DEVICE_AND_INTERFACE_INFO(vend, prod, iclass, 0xff, 0)
+
+	static inline __sum16 tcp_v6_check(int len,
+					   const struct in6_addr *saddr,
+					   const struct in6_addr *daddr,
+					   __wsum base)
+	{
+		return csum_ipv6_magic(saddr, daddr, len, IPPROTO_TCP, base);
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,7,0)
+	#ifndef SPEED_UNKNOWN
+		#define SPEED_UNKNOWN		0
+	#endif
+
+	#ifndef DUPLEX_UNKNOWN
+		#define DUPLEX_UNKNOWN		0xff
+	#endif
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,6,0)
+	#define eth_random_addr(addr)			random_ether_addr(addr)
+	#define usb_enable_lpm(udev)
+	#define MDIO_EEE_100TX				MDIO_AN_EEE_ADV_100TX	/* 100TX EEE cap */
+	#define MDIO_EEE_1000T				MDIO_AN_EEE_ADV_1000T	/* 1000T EEE cap */
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,4,0)
+	#define ETH_MDIO_SUPPORTS_C22			MDIO_SUPPORTS_C22
+
+	static inline void eth_hw_addr_random(struct net_device *dev)
+	{
+		random_ether_addr(dev->dev_addr);
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+	#define module_usb_driver(__driver) \
+	static int __init __driver##_init(void) \
+	{ \
+		return usb_register(&(__driver)); \
+	} \
+	module_init(__driver##_init); \
+	static void __exit __driver##_exit(void) \
+	{ \
+		usb_deregister(&(__driver)); \
+	} \
+	module_exit(__driver##_exit);
+
+	#define netdev_features_t			u32
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
+	#define PMSG_IS_AUTO(msg)	(((msg).event & PM_EVENT_AUTO) != 0)
+
+	static inline struct page *skb_frag_page(const skb_frag_t *frag)
+	{
+		return frag->page;
+	}
+
+	static inline void *skb_frag_address(const skb_frag_t *frag)
+	{
+		return page_address(skb_frag_page(frag)) + frag->page_offset;
+	}
+
+	static inline unsigned int skb_frag_size(const skb_frag_t *frag)
+	{
+		return frag->size;
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,1,0)
+	#define ndo_set_rx_mode				ndo_set_multicast_list
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,39)
+	#define NETIF_F_RXCSUM				(1 << 29) /* Receive checksumming offload */
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,38)
+	#define MDIO_AN_EEE_ADV				60	/* EEE advertisement */
+	#define MDIO_AN_EEE_ADV_100TX			0x0002	/* Advertise 100TX EEE cap */
+	#define MDIO_AN_EEE_ADV_1000T			0x0004	/* Advertise 1000T EEE cap */
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,37)
+	#define skb_checksum_none_assert(skb_ptr)	(skb_ptr)->ip_summed = CHECKSUM_NONE
+
+	static inline __be16 vlan_get_protocol(const struct sk_buff *skb)
+	{
+	       __be16 protocol = 0;
+
+	       if (vlan_tx_tag_present(skb) ||
+	            skb->protocol != cpu_to_be16(ETH_P_8021Q))
+	               protocol = skb->protocol;
+	       else {
+	               __be16 proto, *protop;
+	               protop = skb_header_pointer(skb, offsetof(struct vlan_ethhdr,
+	                                               h_vlan_encapsulated_proto),
+	                                               sizeof(proto), &proto);
+	               if (likely(protop))
+	                       protocol = *protop;
+	       }
+
+	       return protocol;
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,36)
+	#define skb_tx_timestamp(skb)
+
+	#define queue_delayed_work(long_wq, work, delay)	schedule_delayed_work(work, delay)
+
+	static inline void usleep_range(unsigned long min, unsigned long max)
+	{
+		unsigned long ms = min / 1000;
+
+		if (ms)
+			mdelay(ms);
+
+		udelay(min % 1000);
+	}
+
+	#define work_busy(x)				0
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,35)
+	static inline bool pci_dev_run_wake(struct pci_dev *dev)
+	{
+		return 1;
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,34)
+	#define netdev_mc_count(netdev)			((netdev)->mc_count)
+	#define netdev_mc_empty(netdev)			(netdev_mc_count(netdev) == 0)
+
+	#define netif_printk(priv, type, level, netdev, fmt, args...)	\
+	do {								\
+		if (netif_msg_##type(priv))				\
+			printk(level "%s: " fmt,(netdev)->name , ##args); \
+	} while (0)
+
+	#define netif_emerg(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_EMERG, netdev, fmt, ##args)
+	#define netif_alert(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_ALERT, netdev, fmt, ##args)
+	#define netif_crit(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_CRIT, netdev, fmt, ##args)
+	#define netif_err(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_ERR, netdev, fmt, ##args)
+	#define netif_warn(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_WARNING, netdev, fmt, ##args)
+	#define netif_notice(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_NOTICE, netdev, fmt, ##args)
+	#define netif_info(priv, type, netdev, fmt, args...)		\
+		netif_printk(priv, type, KERN_INFO, (netdev), fmt, ##args)
+
+	static inline int usb_enable_autosuspend(struct usb_device *udev)
+	{ return 0; }
+	static inline int usb_disable_autosuspend(struct usb_device *udev)
+	{ return 0; }
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,33)
+	#define get_sset_count				get_stats_count
+
+	static inline
+	struct sk_buff *netdev_alloc_skb_ip_align(struct net_device *dev,
+						  unsigned int length)
+	{
+		struct sk_buff *skb = netdev_alloc_skb(dev, length + NET_IP_ALIGN);
+
+		if (NET_IP_ALIGN && skb)
+			skb_reserve(skb, NET_IP_ALIGN);
+		return skb;
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,32)
+	#define pm_request_resume(para)
+	#define pm_runtime_set_suspended(para)
+	#define pm_schedule_suspend(para1, para2)
+	#define pm_runtime_get_sync(para)
+	#define pm_runtime_put_sync(para)
+	#define pm_runtime_put_noidle(para)
+	#define pm_runtime_idle(para)
+	#define pm_runtime_set_active(para)
+	#define pm_runtime_enable(para)
+	#define pm_runtime_disable(para)
+	typedef int netdev_tx_t;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,31)
+	#define USB_SPEED_SUPER				(USB_SPEED_VARIABLE + 1)
+	#define MDIO_MMD_AN				7	/* Auto-Negotiation */
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+	#define napi_gro_receive(napi, skb)		netif_receive_skb(skb)
+	#define vlan_gro_receive(napi, grp, vlan_tci, skb) \
+		vlan_hwaccel_receive_skb(skb, grp, vlan_tci)
+
+	static inline void usb_autopm_put_interface_async(struct usb_interface *intf)
+	{
+		struct usb_device *udev = interface_to_usbdev(intf);
+		int status = 0;
+
+		if (intf->condition == USB_INTERFACE_UNBOUND) {
+			status = -ENODEV;
+		} else {
+			udev->last_busy = jiffies;
+			--intf->pm_usage_cnt;
+			if (udev->autosuspend_disabled || udev->autosuspend_delay < 0)
+				status = -EPERM;
+		}
+	}
+
+	static inline int usb_autopm_get_interface_async(struct usb_interface *intf)
+	{
+		struct usb_device *udev = interface_to_usbdev(intf);
+		int status = 0;
+
+		if (intf->condition == USB_INTERFACE_UNBOUND)
+			status = -ENODEV;
+		else if (udev->autoresume_disabled)
+			status = -EPERM;
+		else
+			++intf->pm_usage_cnt;
+		return status;
+	}
+
+	static inline int eth_change_mtu(struct net_device *dev, int new_mtu)
+	{
+		if (new_mtu < 68 || new_mtu > ETH_DATA_LEN)
+			return -EINVAL;
+		dev->mtu = new_mtu;
+		return 0;
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,28)
+	static inline void __skb_queue_splice(const struct sk_buff_head *list,
+					      struct sk_buff *prev,
+					      struct sk_buff *next)
+	{
+		struct sk_buff *first = list->next;
+		struct sk_buff *last = list->prev;
+
+		first->prev = prev;
+		prev->next = first;
+
+		last->next = next;
+		next->prev = last;
+	}
+
+	static inline void skb_queue_splice(const struct sk_buff_head *list,
+					    struct sk_buff_head *head)
+	{
+		if (!skb_queue_empty(list)) {
+			__skb_queue_splice(list, (struct sk_buff *) head, head->next);
+			head->qlen += list->qlen;
+		}
+	}
+
+	static inline void __skb_queue_head_init(struct sk_buff_head *list)
+	{
+		list->prev = list->next = (struct sk_buff *)list;
+		list->qlen = 0;
+	}
+
+	static inline void skb_queue_splice_init(struct sk_buff_head *list,
+						 struct sk_buff_head *head)
+	{
+		if (!skb_queue_empty(list)) {
+			__skb_queue_splice(list, (struct sk_buff *) head, head->next);
+			head->qlen += list->qlen;
+			__skb_queue_head_init(list);
+		}
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,27)
+	#define PM_EVENT_AUTO		0x0400
+
+	static inline void __list_splice2(const struct list_head *list,
+					  struct list_head *prev,
+					  struct list_head *next)
+	{
+		struct list_head *first = list->next;
+		struct list_head *last = list->prev;
+
+		first->prev = prev;
+		prev->next = first;
+
+		last->next = next;
+		next->prev = last;
+	}
+
+	static inline void list_splice_tail(struct list_head *list,
+					    struct list_head *head)
+	{
+		if (!list_empty(list))
+			__list_splice2(list, head->prev, head);
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+	struct napi_struct {
+		struct list_head	poll_list;
+		unsigned long		state;
+		int			weight;
+		int			(*poll)(struct napi_struct *, int);
+	#ifdef CONFIG_NETPOLL
+		spinlock_t		poll_lock;
+		int			poll_owner;
+		struct net_device	*dev;
+		struct list_head	dev_list;
+	#endif
+	};
+
+	#define napi_enable(napi_ptr)			netif_poll_enable(container_of(napi_ptr, struct r8152, napi)->netdev)
+	#define napi_disable(napi_ptr)			netif_poll_disable(container_of(napi_ptr, struct r8152, napi)->netdev)
+	#define napi_schedule(napi_ptr)			netif_rx_schedule(container_of(napi_ptr, struct r8152, napi)->netdev)
+	#define napi_complete(napi_ptr)			netif_rx_complete(container_of(napi_ptr, struct r8152, napi)->netdev)
+	#define netif_napi_add(ndev, napi_ptr, function, weight_t) \
+		ndev->poll = function; \
+		ndev->weight = weight_t;
+	typedef unsigned long				uintptr_t;
+	#define DMA_BIT_MASK(value) \
+		(value < 64 ? ((1ULL << value) - 1) : 0xFFFFFFFFFFFFFFFFULL)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,23)
+	#define NETIF_F_IPV6_CSUM			16
+	#define cancel_delayed_work_sync		cancel_delayed_work
+
+	static inline int skb_cow_head(struct sk_buff *skb, unsigned int headroom)
+	{
+		int delta = 0;
+
+		if (headroom > skb_headroom(skb))
+			delta = headroom - skb_headroom(skb);
+
+		if (delta || skb_header_cloned(skb))
+			return pskb_expand_head(skb, ALIGN(delta, NET_SKB_PAD),
+						0, GFP_ATOMIC);
+		return 0;
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+	#define ip_hdr(skb_ptr)				(skb_ptr)->nh.iph
+	#define ipv6hdr(skb_ptr)			(skb_ptr)->nh.ipv6h
+
+	static inline void skb_copy_from_linear_data(const struct sk_buff *skb,
+						     void *to,
+						     const unsigned int len)
+	{
+		memcpy(to, skb->data, len);
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,21)
+	#define vlan_group_set_device(vlgrp, vid, value) \
+		if (vlgrp) \
+			(vlgrp)->vlan_devices[vid] = value;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+	#define delayed_work				work_struct
+	#define INIT_DELAYED_WORK(a,b)			INIT_WORK(a,b,tp)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
+	#define CHECKSUM_PARTIAL			CHECKSUM_HW
+
+	static inline void *kmemdup(const void *src, size_t len, gfp_t gfp)
+	{
+		void *p;
+
+		p = kmalloc_track_caller(len, gfp);
+		if (p)
+			memcpy(p, src, len);
+		return p;
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18)
+	#define skb_is_gso(skb_ptr)			skb_shinfo(skb_ptr)->tso_size
+	#define netdev_alloc_skb(dev, len)		dev_alloc_skb(len)
+	#define IRQF_SHARED				SA_SHIRQ
+
+	static inline struct sk_buff *skb_gso_segment(struct sk_buff *skb, int features)
+	{
+		return NULL;
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16)
+	#ifndef __LINUX_MUTEX_H
+	#define mutex					semaphore
+	#define mutex_lock				down
+	#define mutex_unlock				up
+	#define mutex_trylock				down_trylock
+	#define mutex_lock_interruptible		down_interruptible
+	#define mutex_init				init_MUTEX
+	#endif
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,14)
+	#define ADVERTISED_Pause			(1 << 13)
+	#define ADVERTISED_Asym_Pause			(1 << 14)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,12)
+	#define skb_header_cloned(skb)			skb_cloned(skb)
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,12) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,14) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,21) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,23) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24) */
+	static inline void netif_napi_del(struct napi_struct *napi)
+	{
+	#ifdef CONFIG_NETPOLL
+	        list_del(&napi->dev_list);
+	#endif
+	}
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,27) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,28) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,31) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,32) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,33) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,34) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,35) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,36) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,37) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,38) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,39) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,1,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,4,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,6,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,7,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,8,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,12,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,13,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,14,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,15,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,16,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,19,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(4,0,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(4,1,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(4,5,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(4,9,0) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(4,12,0) */
+
+#ifndef FALSE
+	#define TRUE	1
+	#define FALSE	0
+#endif
+
+enum rtl_cmd {
+	RTLTOOL_PLA_OCP_READ_DWORD = 0,
+	RTLTOOL_PLA_OCP_WRITE_DWORD,
+	RTLTOOL_USB_OCP_READ_DWORD,
+	RTLTOOL_USB_OCP_WRITE_DWORD,
+	RTLTOOL_PLA_OCP_READ,
+	RTLTOOL_PLA_OCP_WRITE,
+	RTLTOOL_USB_OCP_READ,
+	RTLTOOL_USB_OCP_WRITE,
+	RTLTOOL_USB_INFO,
+	RTL_ENABLE_USB_DIAG,
+	RTL_DISABLE_USB_DIAG,
+
+	RTLTOOL_INVALID
+};
+
+struct usb_device_info {
+	__u16		idVendor;
+	__u16		idProduct;
+	__u16		bcdDevice;
+	__u8		dev_addr[8];
+	char		devpath[16];
+};
+
+struct rtltool_cmd {
+	__u32	cmd;
+	__u32	offset;
+	__u32	byteen;
+	__u32	data;
+	void	*buf;
+	struct usb_device_info nic_info;
+	struct sockaddr ifru_addr;
+	struct sockaddr ifru_netmask;
+	struct sockaddr ifru_hwaddr;
+};
+
+#endif /* LINUX_COMPATIBILITY_H */
diff --git a/drivers/net/usb/r8152/r8152.c b/drivers/net/usb/r8152/r8152.c
new file mode 100644
index 00000000..082fa3c
--- /dev/null
+++ b/drivers/net/usb/r8152/r8152.c
@@ -0,0 +1,13666 @@
+/*
+ *  Copyright (c) 2017 Realtek Semiconductor Corp. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * version 2 as published by the Free Software Foundation.
+ *
+ *  This product is covered by one or more of the following patents:
+ *  US6,570,884, US6,115,776, and US6,327,625.
+ */
+
+#include <linux/signal.h>
+#include <linux/slab.h>
+#include <linux/module.h>
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/mii.h>
+#include <linux/ethtool.h>
+#include <linux/usb.h>
+#include <linux/crc32.h>
+#include <linux/if_vlan.h>
+#include <linux/uaccess.h>
+#include <linux/list.h>
+#include <linux/ip.h>
+#include <linux/ipv6.h>
+#include <net/ip6_checksum.h>
+#include <linux/usb/cdc.h>
+#include <linux/suspend.h>
+#include <linux/atomic.h>
+
+#include "compatibility.h"
+
+/* Version Information */
+#define DRIVER_VERSION "v2.Thor.4 (2019/07/17)"
+#define DRIVER_AUTHOR "Realtek nic sw <nic_swsd@realtek.com>"
+#define DRIVER_DESC "Realtek RTL8152/RTL8153 Based USB Ethernet Adapters"
+#define MODULENAME "r8152"
+
+#define PATENTS		"This product is covered by one or more of the " \
+			"following patents:\n" \
+			"\t\tUS6,570,884, US6,115,776, and US6,327,625.\n"
+
+#define R8152_PHY_ID		32
+
+#define PLA_IDR			0xc000
+#define PLA_RCR			0xc010
+#define PLA_RMS			0xc016
+#define PLA_RXFIFO_CTRL0	0xc0a0
+#define PLA_RXFIFO_CTRL1	0xc0a4
+#define PLA_RXFIFO_CTRL2	0xc0a8
+#define PLA_DMY_REG0		0xc0b0
+#define PLA_FMC			0xc0b4
+#define PLA_CFG_WOL		0xc0b6
+#define PLA_TEREDO_CFG		0xc0bc
+#define PLA_TEREDO_WAKE_BASE	0xc0c4
+#define PLA_MAR			0xcd00
+#define PLA_BACKUP		0xd000
+#define PAL_BDC_CR		0xd1a0
+#define PLA_TEREDO_TIMER	0xd2cc
+#define PLA_REALWOW_TIMER	0xd2e8
+#define PLA_SUSPEND_FLAG	0xd38a
+#define PLA_INDICATE_FALG	0xd38c
+#define PLA_EXTRA_STATUS	0xd398
+#define PLA_EFUSE_DATA		0xdd00
+#define PLA_EFUSE_CMD		0xdd02
+#define PLA_LEDSEL		0xdd90
+#define PLA_LED_FEATURE		0xdd92
+#define PLA_PHYAR		0xde00
+#define PLA_BOOT_CTRL		0xe004
+#define PLA_GPHY_INTR_IMR	0xe022
+#define PLA_EEE_CR		0xe040
+#define PLA_EEEP_CR		0xe080
+#define PLA_MAC_PWR_CTRL	0xe0c0
+#define PLA_MAC_PWR_CTRL2	0xe0ca
+#define PLA_MAC_PWR_CTRL3	0xe0cc
+#define PLA_MAC_PWR_CTRL4	0xe0ce
+#define PLA_WDT6_CTRL		0xe428
+#define PLA_TCR0		0xe610
+#define PLA_TCR1		0xe612
+#define PLA_MTPS		0xe615
+#define PLA_TXFIFO_CTRL		0xe618
+#define PLA_RSTTALLY		0xe800
+#define PLA_CR			0xe813
+#define PLA_CRWECR		0xe81c
+#define PLA_CONFIG12		0xe81e	/* CONFIG1, CONFIG2 */
+#define PLA_CONFIG34		0xe820	/* CONFIG3, CONFIG4 */
+#define PLA_CONFIG5		0xe822
+#define PLA_PHY_PWR		0xe84c
+#define PLA_OOB_CTRL		0xe84f
+#define PLA_CPCR		0xe854
+#define PLA_MISC_0		0xe858
+#define PLA_MISC_1		0xe85a
+#define PLA_OCP_GPHY_BASE	0xe86c
+#define PLA_TALLYCNT		0xe890
+#define PLA_SFF_STS_7		0xe8de
+#define PLA_PHYSTATUS		0xe908
+#define PLA_BP_BA		0xfc26
+#define PLA_BP_0		0xfc28
+#define PLA_BP_1		0xfc2a
+#define PLA_BP_2		0xfc2c
+#define PLA_BP_3		0xfc2e
+#define PLA_BP_4		0xfc30
+#define PLA_BP_5		0xfc32
+#define PLA_BP_6		0xfc34
+#define PLA_BP_7		0xfc36
+#define PLA_BP_EN		0xfc38
+
+#define USB_USB2PHY		0xb41e
+#define USB_SSPHYLINK2		0xb428
+#define USB_U2P3_CTRL		0xb460
+#define USB_CSR_DUMMY1		0xb464
+#define USB_CSR_DUMMY2		0xb466
+#define USB_DEV_STAT		0xb808
+#define USB_CONNECT_TIMER	0xcbf8
+#define USB_MSC_TIMER		0xcbfc
+#define USB_BURST_SIZE		0xcfc0
+#define USB_LPM_CONFIG		0xcfd8
+#define USB_USB_CTRL		0xd406
+#define USB_PHY_CTRL		0xd408
+#define USB_TX_AGG		0xd40a
+#define USB_RX_BUF_TH		0xd40c
+#define USB_USB_TIMER		0xd428
+#define USB_RX_EARLY_TIMEOUT	0xd42c
+#define USB_RX_EARLY_SIZE	0xd42e
+#define USB_PM_CTRL_STATUS	0xd432	/* RTL8153A */
+#define USB_RX_EXTRA_AGGR_TMR	0xd432	/* RTL8153B */
+#define USB_TX_DMA		0xd434
+#define USB_UPT_RXDMA_OWN	0xd437
+#define USB_TOLERANCE		0xd490
+#define USB_LPM_CTRL		0xd41a
+#define USB_BMU_RESET		0xd4b0
+#define USB_U1U2_TIMER		0xd4da
+#define USB_UPS_CTRL		0xd800
+#define USB_POWER_CUT		0xd80a
+#define USB_MISC_0		0xd81a
+#define USB_MISC_1		0xd81f
+#define USB_AFE_CTRL2		0xd824
+#define USB_UPS_CFG		0xd842
+#define USB_UPS_FLAGS		0xd848
+#define USB_WDT11_CTRL		0xe43c
+#define USB_BP_BA		0xfc26
+#define USB_BP_0		0xfc28
+#define USB_BP_1		0xfc2a
+#define USB_BP_2		0xfc2c
+#define USB_BP_3		0xfc2e
+#define USB_BP_4		0xfc30
+#define USB_BP_5		0xfc32
+#define USB_BP_6		0xfc34
+#define USB_BP_7		0xfc36
+#define USB_BP_EN		0xfc38
+#define USB_BP_8		0xfc38
+#define USB_BP_9		0xfc3a
+#define USB_BP_10		0xfc3c
+#define USB_BP_11		0xfc3e
+#define USB_BP_12		0xfc40
+#define USB_BP_13		0xfc42
+#define USB_BP_14		0xfc44
+#define USB_BP_15		0xfc46
+#define USB_BP2_EN		0xfc48
+
+/* OCP Registers */
+#define OCP_ALDPS_CONFIG	0x2010
+#define OCP_EEE_CONFIG1		0x2080
+#define OCP_EEE_CONFIG2		0x2092
+#define OCP_EEE_CONFIG3		0x2094
+#define OCP_BASE_MII		0xa400
+#define OCP_EEE_AR		0xa41a
+#define OCP_EEE_DATA		0xa41c
+#define OCP_PHY_STATUS		0xa420
+#define OCP_NCTL_CFG		0xa42c
+#define OCP_POWER_CFG		0xa430
+#define OCP_EEE_CFG		0xa432
+#define OCP_SRAM_ADDR		0xa436
+#define OCP_SRAM_DATA		0xa438
+#define OCP_DOWN_SPEED		0xa442
+#define OCP_EEE_ABLE		0xa5c4
+#define OCP_EEE_ADV		0xa5d0
+#define OCP_EEE_LPABLE		0xa5d2
+#define OCP_PHY_STATE		0xa708		/* nway state for 8153 */
+#define OCP_PHY_PATCH_STAT	0xb800
+#define OCP_PHY_PATCH_CMD	0xb820
+#define OCP_ADC_IOFFSET		0xbcfc
+#define OCP_ADC_CFG		0xbc06
+#define OCP_SYSCLK_CFG		0xc416
+
+/* SRAM Register */
+#define SRAM_GREEN_CFG		0x8011
+#define SRAM_LPF_CFG		0x8012
+#define SRAM_10M_AMP1		0x8080
+#define SRAM_10M_AMP2		0x8082
+#define SRAM_IMPEDANCE		0x8084
+
+/* PLA_RCR */
+#define RCR_AAP			0x00000001
+#define RCR_APM			0x00000002
+#define RCR_AM			0x00000004
+#define RCR_AB			0x00000008
+#define RCR_ACPT_ALL		(RCR_AAP | RCR_APM | RCR_AM | RCR_AB)
+
+/* PLA_RXFIFO_CTRL0 */
+#define RXFIFO_THR1_NORMAL	0x00080002
+#define RXFIFO_THR1_OOB		0x01800003
+
+/* PLA_RXFIFO_CTRL1 */
+#define RXFIFO_THR2_FULL	0x00000060
+#define RXFIFO_THR2_HIGH	0x00000038
+#define RXFIFO_THR2_OOB		0x0000004a
+#define RXFIFO_THR2_NORMAL	0x00a0
+
+/* PLA_RXFIFO_CTRL2 */
+#define RXFIFO_THR3_FULL	0x00000078
+#define RXFIFO_THR3_HIGH	0x00000048
+#define RXFIFO_THR3_OOB		0x0000005a
+#define RXFIFO_THR3_NORMAL	0x0110
+
+/* PLA_TXFIFO_CTRL */
+#define TXFIFO_THR_NORMAL	0x00400008
+#define TXFIFO_THR_NORMAL2	0x01000008
+
+/* PLA_DMY_REG0 */
+#define ECM_ALDPS		0x0002
+
+/* PLA_FMC */
+#define FMC_FCR_MCU_EN		0x0001
+
+/* PLA_EEEP_CR */
+#define EEEP_CR_EEEP_TX		0x0002
+
+/* PLA_WDT6_CTRL */
+#define WDT6_SET_MODE		0x0010
+
+/* PLA_TCR0 */
+#define TCR0_TX_EMPTY		0x0800
+#define TCR0_AUTO_FIFO		0x0080
+
+/* PLA_TCR1 */
+#define VERSION_MASK		0x7cf0
+
+/* PLA_MTPS */
+#define MTPS_JUMBO		(12 * 1024 / 64)
+#define MTPS_DEFAULT		(6 * 1024 / 64)
+
+/* PLA_RSTTALLY */
+#define TALLY_RESET		0x0001
+
+/* PLA_CR */
+#define CR_RST			0x10
+#define CR_RE			0x08
+#define CR_TE			0x04
+
+/* PLA_CRWECR */
+#define CRWECR_NORAML		0x00
+#define CRWECR_CONFIG		0xc0
+
+/* PLA_OOB_CTRL */
+#define NOW_IS_OOB		0x80
+#define TXFIFO_EMPTY		0x20
+#define RXFIFO_EMPTY		0x10
+#define LINK_LIST_READY		0x02
+#define DIS_MCU_CLROOB		0x01
+#define FIFO_EMPTY		(TXFIFO_EMPTY | RXFIFO_EMPTY)
+
+/* PLA_MISC_1 */
+#define RXDY_GATED_EN		0x0008
+
+/* PLA_SFF_STS_7 */
+#define RE_INIT_LL		0x8000
+#define MCU_BORW_EN		0x4000
+
+/* PLA_CPCR */
+#define CPCR_RX_VLAN		0x0040
+
+/* PLA_CFG_WOL */
+#define MAGIC_EN		0x0001
+
+/* PLA_TEREDO_CFG */
+#define TEREDO_SEL		0x8000
+#define TEREDO_WAKE_MASK	0x7f00
+#define TEREDO_RS_EVENT_MASK	0x00fe
+#define OOB_TEREDO_EN		0x0001
+
+/* PAL_BDC_CR */
+#define ALDPS_PROXY_MODE	0x0001
+
+/* PLA_EFUSE_CMD */
+#define EFUSE_READ_CMD		BIT(15)
+#define EFUSE_DATA_BIT16	BIT(7)
+
+/* PLA_CONFIG34 */
+#define LINK_ON_WAKE_EN		0x0010
+#define LINK_OFF_WAKE_EN	0x0008
+
+/* PLA_CONFIG5 */
+#define BWF_EN			0x0040
+#define MWF_EN			0x0020
+#define UWF_EN			0x0010
+#define LAN_WAKE_EN		0x0002
+
+/* PLA_LED_FEATURE */
+#define LED_MODE_MASK		0x0700
+
+/* PLA_PHY_PWR */
+#define TX_10M_IDLE_EN		0x0080
+#define PFM_PWM_SWITCH		0x0040
+#define TEST_IO_OFF		BIT(4)
+
+/* PLA_MAC_PWR_CTRL */
+#define D3_CLK_GATED_EN		0x00004000
+#define MCU_CLK_RATIO		0x07010f07
+#define MCU_CLK_RATIO_MASK	0x0f0f0f0f
+#define ALDPS_SPDWN_RATIO	0x0f87
+
+/* PLA_MAC_PWR_CTRL2 */
+#define EEE_SPDWN_RATIO		0x8007
+#define MAC_CLK_SPDWN_EN	BIT(15)
+
+/* PLA_MAC_PWR_CTRL3 */
+#define PKT_AVAIL_SPDWN_EN	0x0100
+#define SUSPEND_SPDWN_EN	0x0004
+#define U1U2_SPDWN_EN		0x0002
+#define L1_SPDWN_EN		0x0001
+
+/* PLA_MAC_PWR_CTRL4 */
+#define PWRSAVE_SPDWN_EN	0x1000
+#define RXDV_SPDWN_EN		0x0800
+#define TX10MIDLE_EN		0x0100
+#define TP100_SPDWN_EN		0x0020
+#define TP500_SPDWN_EN		0x0010
+#define TP1000_SPDWN_EN		0x0008
+#define EEE_SPDWN_EN		0x0001
+
+/* PLA_GPHY_INTR_IMR */
+#define GPHY_STS_MSK		0x0001
+#define SPEED_DOWN_MSK		0x0002
+#define SPDWN_RXDV_MSK		0x0004
+#define SPDWN_LINKCHG_MSK	0x0008
+
+/* PLA_PHYAR */
+#define PHYAR_FLAG		0x80000000
+
+/* PLA_EEE_CR */
+#define EEE_RX_EN		0x0001
+#define EEE_TX_EN		0x0002
+
+/* PLA_BOOT_CTRL */
+#define AUTOLOAD_DONE		0x0002
+
+/* PLA_SUSPEND_FLAG */
+#define LINK_CHG_EVENT		BIT(0)
+
+/* PLA_INDICATE_FALG */
+#define UPCOMING_RUNTIME_D3	BIT(0)
+
+/* PLA_EXTRA_STATUS */
+#define LINK_CHANGE_FLAG	BIT(8)
+
+/* USB_USB2PHY */
+#define USB2PHY_SUSPEND		0x0001
+#define USB2PHY_L1		0x0002
+
+/* USB_SSPHYLINK2 */
+#define pwd_dn_scale_mask	0x3ffe
+#define pwd_dn_scale(x)		((x) << 1)
+
+/* USB_CSR_DUMMY1 */
+#define DYNAMIC_BURST		0x0001
+
+/* USB_CSR_DUMMY2 */
+#define EP4_FULL_FC		0x0001
+
+/* USB_DEV_STAT */
+#define STAT_SPEED_MASK		0x0006
+#define STAT_SPEED_HIGH		0x0000
+#define STAT_SPEED_FULL		0x0002
+
+/* USB_LPM_CONFIG */
+#define LPM_U1U2_EN		BIT(0)
+
+/* USB_TX_AGG */
+#define TX_AGG_MAX_THRESHOLD	0x03
+
+/* USB_RX_BUF_TH */
+#define RX_THR_SUPPER		0x0c350180
+#define RX_THR_HIGH		0x7a120180
+#define RX_THR_SLOW		0xffff0180
+#define RX_THR_B		0x00010001
+
+/* USB_TX_DMA */
+#define TEST_MODE_DISABLE	0x00000001
+#define TX_SIZE_ADJUST1		0x00000100
+
+/* USB_BMU_RESET */
+#define BMU_RESET_EP_IN		0x01
+#define BMU_RESET_EP_OUT	0x02
+
+/* USB_UPT_RXDMA_OWN */
+#define OWN_UPDATE		BIT(0)
+#define OWN_CLEAR		BIT(1)
+
+/* USB_UPS_CTRL */
+#define POWER_CUT		0x0100
+
+/* USB_PM_CTRL_STATUS */
+#define RESUME_INDICATE		0x0001
+
+/* USB_USB_CTRL */
+#define RX_AGG_DISABLE		0x0010
+#define RX_ZERO_EN		0x0080
+
+/* USB_U2P3_CTRL */
+#define U2P3_ENABLE		0x0001
+
+/* USB_POWER_CUT */
+#define PWR_EN			0x0001
+#define PHASE2_EN		0x0008
+#define UPS_EN			BIT(4)
+#define USP_PREWAKE		BIT(5)
+
+/* USB_MISC_0 */
+#define PCUT_STATUS		0x0001
+
+/* USB_RX_EARLY_TIMEOUT */
+#define COALESCE_SUPER		 85000U
+#define COALESCE_HIGH		250000U
+#define COALESCE_SLOW		524280U
+
+/* USB_WDT11_CTRL */
+#define TIMER11_EN		0x0001
+
+/* USB_LPM_CTRL */
+/* bit 4 ~ 5: fifo empty boundary */
+#define FIFO_EMPTY_1FB		0x30	/* 0x1fb * 64 = 32448 bytes */
+/* bit 2 ~ 3: LMP timer */
+#define LPM_TIMER_MASK		0x0c
+#define LPM_TIMER_500MS		0x04	/* 500 ms */
+#define LPM_TIMER_500US		0x0c	/* 500 us */
+#define ROK_EXIT_LPM		0x02
+
+/* USB_AFE_CTRL2 */
+#define SEN_VAL_MASK		0xf800
+#define SEN_VAL_NORMAL		0xa000
+#define SEL_RXIDLE		0x0100
+
+/* USB_UPS_CFG */
+#define SAW_CNT_1MS_MASK	0x0fff
+
+/* USB_UPS_FLAGS */
+#define UPS_FLAGS_R_TUNE		BIT(0)
+#define UPS_FLAGS_EN_10M_CKDIV		BIT(1)
+#define UPS_FLAGS_250M_CKDIV		BIT(2)
+#define UPS_FLAGS_EN_ALDPS		BIT(3)
+#define UPS_FLAGS_CTAP_SHORT_DIS	BIT(4)
+#define UPS_FLAGS_SPEED_MASK		(0xf << 16)
+#define ups_flags_speed(x)		((x) << 16)
+#define UPS_FLAGS_EN_EEE		BIT(20)
+#define UPS_FLAGS_EN_500M_EEE		BIT(21)
+#define UPS_FLAGS_EN_EEE_CKDIV		BIT(22)
+#define UPS_FLAGS_EEE_PLLOFF_100	BIT(23)
+#define UPS_FLAGS_EEE_PLLOFF_GIGA	BIT(24)
+#define UPS_FLAGS_EEE_CMOD_LV_EN	BIT(25)
+#define UPS_FLAGS_EN_GREEN		BIT(26)
+#define UPS_FLAGS_EN_FLOW_CTR		BIT(27)
+
+enum spd_duplex {
+	NWAY_10M_HALF,
+	NWAY_10M_FULL,
+	NWAY_100M_HALF,
+	NWAY_100M_FULL,
+	NWAY_1000M_FULL,
+	FORCE_10M_HALF,
+	FORCE_10M_FULL,
+	FORCE_100M_HALF,
+	FORCE_100M_FULL,
+	FORCE_1000M_FULL,
+	NWAY_2500M_FULL,
+};
+
+/* OCP_ALDPS_CONFIG */
+#define ENPWRSAVE		0x8000
+#define ENPDNPS			0x0200
+#define LINKENA			0x0100
+#define DIS_SDSAVE		0x0010
+
+/* OCP_PHY_STATUS */
+#define PHY_STAT_MASK		0x0007
+#define PHY_STAT_EXT_INIT	2
+#define PHY_STAT_LAN_ON		3
+#define PHY_STAT_PWRDN		5
+
+/* OCP_NCTL_CFG */
+#define PGA_RETURN_EN		BIT(1)
+
+/* OCP_POWER_CFG */
+#define EEE_CLKDIV_EN		0x8000
+#define EN_ALDPS		0x0004
+#define EN_10M_PLLOFF		0x0001
+
+/* OCP_EEE_CONFIG1 */
+#define RG_TXLPI_MSK_HFDUP	0x8000
+#define RG_MATCLR_EN		0x4000
+#define EEE_10_CAP		0x2000
+#define EEE_NWAY_EN		0x1000
+#define TX_QUIET_EN		0x0200
+#define RX_QUIET_EN		0x0100
+#define sd_rise_time_mask	0x0070
+#define sd_rise_time(x)		(min(x, 7) << 4)	/* bit 4 ~ 6 */
+#define RG_RXLPI_MSK_HFDUP	0x0008
+#define SDFALLTIME		0x0007	/* bit 0 ~ 2 */
+
+/* OCP_EEE_CONFIG2 */
+#define RG_LPIHYS_NUM		0x7000	/* bit 12 ~ 15 */
+#define RG_DACQUIET_EN		0x0400
+#define RG_LDVQUIET_EN		0x0200
+#define RG_CKRSEL		0x0020
+#define RG_EEEPRG_EN		0x0010
+
+/* OCP_EEE_CONFIG3 */
+#define fast_snr_mask		0xff80
+#define fast_snr(x)		(min(x, 0x1ff) << 7)	/* bit 7 ~ 15 */
+#define RG_LFS_SEL		0x0060	/* bit 6 ~ 5 */
+#define MSK_PH			0x0006	/* bit 0 ~ 3 */
+
+/* OCP_EEE_AR */
+/* bit[15:14] function */
+#define FUN_ADDR		0x0000
+#define FUN_DATA		0x4000
+/* bit[4:0] device addr */
+
+/* OCP_EEE_CFG */
+#define CTAP_SHORT_EN		0x0040
+#define EEE10_EN		0x0010
+
+/* OCP_DOWN_SPEED */
+#define EN_EEE_CMODE		BIT(14)
+#define EN_EEE_1000		BIT(13)
+#define EN_EEE_100		BIT(12)
+#define EN_10M_CLKDIV		BIT(11)
+#define EN_10M_BGOFF		0x0080
+
+/* OCP_PHY_STATE */
+#define TXDIS_STATE		0x01
+#define ABD_STATE		0x02
+
+/* OCP_PHY_PATCH_STAT */
+#define PATCH_READY		BIT(6)
+
+/* OCP_PHY_PATCH_CMD */
+#define PATCH_REQUEST		BIT(4)
+
+/* OCP_ADC_CFG */
+#define CKADSEL_L		0x0100
+#define ADC_EN			0x0080
+#define EN_EMI_L		0x0040
+
+/* OCP_SYSCLK_CFG */
+#define clk_div_expo(x)		(min(x, 5) << 8)
+
+/* SRAM_GREEN_CFG */
+#define GREEN_ETH_EN		BIT(15)
+#define R_TUNE_EN		BIT(11)
+
+/* SRAM_LPF_CFG */
+#define LPF_AUTO_TUNE		0x8000
+
+/* SRAM_10M_AMP1 */
+#define GDAC_IB_UPALL		0x0008
+
+/* SRAM_10M_AMP2 */
+#define AMP_DN			0x0200
+
+/* SRAM_IMPEDANCE */
+#define RX_DRIVING_MASK		0x6000
+
+enum rtl_register_content {
+	_2500bps	= BIT(10),
+	_1250bps	= BIT(9),
+	_500bps		= BIT(8),
+	_1000bps	= 0x10,
+	_100bps		= 0x08,
+	_10bps		= 0x04,
+	LINK_STATUS	= 0x02,
+	FULL_DUP	= 0x01,
+};
+
+#define RTL8152_MAX_TX		4
+#define RTL8152_MAX_RX		10
+#define INTBUFSIZE		2
+#define TX_ALIGN		4
+#define RX_ALIGN		8
+
+#define RTL8152_MAX_RX_AGG	(10 * RTL8152_MAX_RX)
+#define RTL8152_RXFG_HEADSZ	256
+
+#define INTR_LINK		0x0004
+
+#define RTL8152_REQT_READ	0xc0
+#define RTL8152_REQT_WRITE	0x40
+#define RTL8152_REQ_GET_REGS	0x05
+#define RTL8152_REQ_SET_REGS	0x05
+
+#define BYTE_EN_DWORD		0xff
+#define BYTE_EN_WORD		0x33
+#define BYTE_EN_BYTE		0x11
+#define BYTE_EN_SIX_BYTES	0x3f
+#define BYTE_EN_START_MASK	0x0f
+#define BYTE_EN_END_MASK	0xf0
+
+#define RTL8153_MAX_PACKET	9216 /* 9K */
+#define RTL8153_MAX_MTU		(RTL8153_MAX_PACKET - VLAN_ETH_HLEN - \
+				 ETH_FCS_LEN)
+#define RTL8152_RMS		(VLAN_ETH_FRAME_LEN + ETH_FCS_LEN)
+#define RTL8153_RMS		RTL8153_MAX_PACKET
+#define RTL8152_TX_TIMEOUT	(5 * HZ)
+#define rx_reserved_size(x)	((x) + VLAN_ETH_HLEN + ETH_FCS_LEN + \
+				 sizeof(struct rx_desc) + RX_ALIGN)
+
+#define RTL_MAX_SG_NUM		64
+
+/* rtl8152 flags */
+enum rtl8152_flags {
+	RTL8152_UNPLUG = 0,
+	RTL8152_SET_RX_MODE,
+	WORK_ENABLE,
+	RTL8152_LINK_CHG,
+	SELECTIVE_SUSPEND,
+	PHY_RESET,
+	SCHEDULE_TASKLET,
+	GREEN_ETHERNET,
+	RECOVER_SPEED,
+};
+
+/* Define these values to match your device */
+#define VENDOR_ID_REALTEK		0x0bda
+#define VENDOR_ID_MICROSOFT		0x045e
+#define VENDOR_ID_SAMSUNG		0x04e8
+#define VENDOR_ID_LENOVO		0x17ef
+#define VENDOR_ID_LINKSYS		0x13b1
+#define VENDOR_ID_NVIDIA		0x0955
+#define VENDOR_ID_TPLINK		0x2357
+
+#define MCU_TYPE_PLA			0x0100
+#define MCU_TYPE_USB			0x0000
+
+struct tally_counter {
+	__le64	tx_packets;
+	__le64	rx_packets;
+	__le64	tx_errors;
+	__le32	rx_errors;
+	__le16	rx_missed;
+	__le16	align_errors;
+	__le32	tx_one_collision;
+	__le32	tx_multi_collision;
+	__le64	rx_unicast;
+	__le64	rx_broadcast;
+	__le32	rx_multicast;
+	__le16	tx_aborted;
+	__le16	tx_underrun;
+};
+
+struct rx_desc {
+	__le32 opts1;
+#define RD_CRC				BIT(15)
+#define RX_LEN_MASK			0x7fff
+
+	__le32 opts2;
+#define RD_UDP_CS			BIT(23)
+#define RD_TCP_CS			BIT(22)
+#define RD_IPV6_CS			BIT(20)
+#define RD_IPV4_CS			BIT(19)
+
+	__le32 opts3;
+#define IPF				BIT(23) /* IP checksum fail */
+#define UDPF				BIT(22) /* UDP checksum fail */
+#define TCPF				BIT(21) /* TCP checksum fail */
+#define RX_VLAN_TAG			BIT(16)
+
+	__le32 opts4;
+	__le32 opts5;
+	__le32 opts6;
+};
+
+struct tx_desc {
+	__le32 opts1;
+#define TX_FS			BIT(31) /* First segment of a packet */
+#define TX_LS			BIT(30) /* Final segment of a packet */
+#define LGSEND			BIT(29)
+#define GTSENDV4		BIT(28)
+#define GTSENDV6		BIT(27)
+#define GTTCPHO_SHIFT		18
+#define GTTCPHO_MAX		0x7fU
+#define TX_LEN_MAX		0x3ffffU
+
+	__le32 opts2;
+#define UDP_CS			BIT(31) /* Calculate UDP/IP checksum */
+#define TCP_CS			BIT(30) /* Calculate TCP/IP checksum */
+#define IPV4_CS			BIT(29) /* Calculate IPv4 checksum */
+#define IPV6_CS			BIT(28) /* Calculate IPv6 checksum */
+#define MSS_SHIFT		17
+#define MSS_MAX			0x7ffU
+#define TCPHO_SHIFT		17
+#define TCPHO_MAX		0x7ffU
+#define TX_VLAN_TAG		BIT(16)
+};
+
+struct r8152;
+
+struct rx_agg {
+	struct list_head list, info_list;
+	struct urb *urb;
+	struct r8152 *context;
+	struct page *page;
+	void *buffer;
+};
+
+struct tx_agg {
+	struct list_head list;
+	struct urb *urb;
+	struct r8152 *context;
+	struct sk_buff_head tx_skb;
+	void *buffer;
+	void *head;
+	u32 skb_num;
+	u32 skb_len;
+};
+
+struct r8152 {
+	unsigned long flags;
+	struct usb_device *udev;
+	struct napi_struct napi;
+	struct usb_interface *intf;
+	struct net_device *netdev;
+	struct urb *intr_urb;
+	struct tx_agg tx_info[RTL8152_MAX_TX];
+	struct list_head rx_info, rx_used;
+	struct list_head rx_done, tx_free;
+	struct sk_buff_head tx_queue, rx_queue;
+	spinlock_t rx_lock, tx_lock;
+	struct delayed_work schedule, hw_phy_work;
+	struct mii_if_info mii;
+	struct mutex control;	/* use for hw setting */
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+	struct vlan_group *vlgrp;
+#endif
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+	struct net_device_stats stats;
+#endif
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,23) && defined(CONFIG_PM_SLEEP)
+	struct notifier_block pm_notifier;
+#endif
+	struct tasklet_struct tx_tl;
+
+	struct rtl_ops {
+		void (*init)(struct r8152 *);
+		int (*enable)(struct r8152 *);
+		void (*disable)(struct r8152 *);
+		void (*up)(struct r8152 *);
+		void (*down)(struct r8152 *);
+		void (*unload)(struct r8152 *);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+		int (*eee_get)(struct r8152 *, struct ethtool_eee *);
+		int (*eee_set)(struct r8152 *, struct ethtool_eee *);
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+		bool (*in_nway)(struct r8152 *);
+		void (*hw_phy_cfg)(struct r8152 *);
+		void (*autosuspend_en)(struct r8152 *tp, bool enable);
+	} rtl_ops;
+
+	struct ups_info {
+		u32 _10m_ckdiv:1;
+		u32 _250m_ckdiv:1;
+		u32 aldps:1;
+		u32 lite_mode:2;
+		u32 speed_duplex:4;
+		u32 eee:1;
+		u32 eee_lite:1;
+		u32 eee_ckdiv:1;
+		u32 eee_plloff_100:1;
+		u32 eee_plloff_giga:1;
+		u32 eee_cmod_lv:1;
+		u32 green:1;
+		u32 flow_control:1;
+		u32 ctap_short_off:1;
+	} ups_info;
+
+	atomic_t rx_count;
+
+	bool eee_en;
+	int intr_interval;
+	u32 saved_wolopts;
+	u32 msg_enable;
+	u32 tx_qlen;
+	u32 coalesce;
+	u32 advertising;
+	u32 rx_buf_sz;
+	u32 rx_frag_head_sz;
+	u32 rx_max_agg_num;
+
+	u32 support_2500full:1;
+	u32 sg_use:1;
+
+	u16 ocp_base;
+	u16 speed;
+	u16 eee_adv;
+	u8 *intr_buff;
+	u8 version;
+	u8 rtk_enable_diag;
+	u8 duplex;
+	u8 autoneg;
+};
+
+enum rtl_version {
+	RTL_VER_UNKNOWN = 0,
+	RTL_VER_01,
+	RTL_VER_02,
+	RTL_VER_03,
+	RTL_VER_04,
+	RTL_VER_05,
+	RTL_VER_06,
+	RTL_VER_07,
+	RTL_VER_08,
+	RTL_VER_09,
+
+	RTL_TEST_01,
+	RTL_VER_10,
+	RTL_VER_11,
+
+	RTL_VER_MAX
+};
+
+enum tx_csum_stat {
+	TX_CSUM_SUCCESS = 0,
+	TX_CSUM_TSO,
+	TX_CSUM_NONE
+};
+
+/* Maximum number of multicast addresses to filter (vs. Rx-all-multicast).
+ * The RTL chips use a 64 element hash table based on the Ethernet CRC.
+ */
+static const int multicast_filter_limit = 32;
+static unsigned int agg_buf_sz = 38528;
+
+#define RTL_LIMITED_TSO_SIZE	(agg_buf_sz - sizeof(struct tx_desc) - \
+				 VLAN_ETH_HLEN - ETH_FCS_LEN)
+
+static
+int get_registers(struct r8152 *tp, u16 value, u16 index, u16 size, void *data)
+{
+	int ret;
+	void *tmp;
+
+	tmp = kmalloc(size, GFP_KERNEL);
+	if (!tmp)
+		return -ENOMEM;
+
+	ret = usb_control_msg(tp->udev, usb_rcvctrlpipe(tp->udev, 0),
+			      RTL8152_REQ_GET_REGS, RTL8152_REQT_READ,
+			      value, index, tmp, size, 500);
+	if (ret < 0)
+		memset(data, 0xff, size);
+	else
+		memcpy(data, tmp, size);
+
+	kfree(tmp);
+
+	return ret;
+}
+
+static
+int set_registers(struct r8152 *tp, u16 value, u16 index, u16 size, void *data)
+{
+	int ret;
+	void *tmp;
+
+	tmp = kmemdup(data, size, GFP_KERNEL);
+	if (!tmp)
+		return -ENOMEM;
+
+	ret = usb_control_msg(tp->udev, usb_sndctrlpipe(tp->udev, 0),
+			      RTL8152_REQ_SET_REGS, RTL8152_REQT_WRITE,
+			      value, index, tmp, size, 500);
+
+	kfree(tmp);
+
+	return ret;
+}
+
+static void rtl_set_unplug(struct r8152 *tp)
+{
+	if (tp->udev->state == USB_STATE_NOTATTACHED) {
+		set_bit(RTL8152_UNPLUG, &tp->flags);
+		smp_mb__after_atomic();
+	}
+}
+
+static int generic_ocp_read(struct r8152 *tp, u16 index, u16 size,
+			    void *data, u16 type)
+{
+	u16 limit = 64;
+	int ret = 0;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return -ENODEV;
+
+	/* both size and indix must be 4 bytes align */
+	if ((size & 3) || !size || (index & 3) || !data)
+		return -EPERM;
+
+	if ((u32)index + (u32)size > 0xffff)
+		return -EPERM;
+
+	while (size) {
+		if (size > limit) {
+			ret = get_registers(tp, index, type, limit, data);
+			if (ret < 0)
+				break;
+
+			index += limit;
+			data += limit;
+			size -= limit;
+		} else {
+			ret = get_registers(tp, index, type, size, data);
+			if (ret < 0)
+				break;
+
+			index += size;
+			data += size;
+			size = 0;
+			break;
+		}
+	}
+
+	if (ret == -ENODEV)
+		rtl_set_unplug(tp);
+
+	return ret;
+}
+
+static int generic_ocp_write(struct r8152 *tp, u16 index, u16 byteen,
+			     u16 size, void *data, u16 type)
+{
+	int ret;
+	u16 byteen_start, byteen_end, byen;
+	u16 limit = 512;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return -ENODEV;
+
+	/* both size and indix must be 4 bytes align */
+	if ((size & 3) || !size || (index & 3) || !data)
+		return -EPERM;
+
+	if ((u32)index + (u32)size > 0xffff)
+		return -EPERM;
+
+	byteen_start = byteen & BYTE_EN_START_MASK;
+	byteen_end = byteen & BYTE_EN_END_MASK;
+
+	byen = byteen_start | (byteen_start << 4);
+	ret = set_registers(tp, index, type | byen, 4, data);
+	if (ret < 0)
+		goto error1;
+
+	index += 4;
+	data += 4;
+	size -= 4;
+
+	if (size) {
+		size -= 4;
+
+		while (size) {
+			if (size > limit) {
+				ret = set_registers(tp, index,
+						    type | BYTE_EN_DWORD,
+						    limit, data);
+				if (ret < 0)
+					goto error1;
+
+				index += limit;
+				data += limit;
+				size -= limit;
+			} else {
+				ret = set_registers(tp, index,
+						    type | BYTE_EN_DWORD,
+						    size, data);
+				if (ret < 0)
+					goto error1;
+
+				index += size;
+				data += size;
+				size = 0;
+				break;
+			}
+		}
+
+		byen = byteen_end | (byteen_end >> 4);
+		ret = set_registers(tp, index, type | byen, 4, data);
+		if (ret < 0)
+			goto error1;
+	}
+
+error1:
+	if (ret == -ENODEV)
+		rtl_set_unplug(tp);
+
+	return ret;
+}
+
+static inline
+int pla_ocp_read(struct r8152 *tp, u16 index, u16 size, void *data)
+{
+	return generic_ocp_read(tp, index, size, data, MCU_TYPE_PLA);
+}
+
+static inline
+int pla_ocp_write(struct r8152 *tp, u16 index, u16 byteen, u16 size, void *data)
+{
+	return generic_ocp_write(tp, index, byteen, size, data, MCU_TYPE_PLA);
+}
+
+static inline
+int usb_ocp_read(struct r8152 *tp, u16 index, u16 size, void *data)
+{
+	return generic_ocp_read(tp, index, size, data, MCU_TYPE_USB);
+}
+
+static inline
+int usb_ocp_write(struct r8152 *tp, u16 index, u16 byteen, u16 size, void *data)
+{
+	return generic_ocp_write(tp, index, byteen, size, data, MCU_TYPE_USB);
+}
+
+static u32 ocp_read_dword(struct r8152 *tp, u16 type, u16 index)
+{
+	__le32 data;
+
+	generic_ocp_read(tp, index, sizeof(data), &data, type);
+
+	return __le32_to_cpu(data);
+}
+
+static void ocp_write_dword(struct r8152 *tp, u16 type, u16 index, u32 data)
+{
+	__le32 tmp = __cpu_to_le32(data);
+
+	generic_ocp_write(tp, index, BYTE_EN_DWORD, sizeof(tmp), &tmp, type);
+}
+
+static u16 ocp_read_word(struct r8152 *tp, u16 type, u16 index)
+{
+	u32 data;
+	__le32 tmp;
+	u16 byen = BYTE_EN_WORD;
+	u8 shift = index & 2;
+
+	index &= ~3;
+	byen <<= shift;
+
+	generic_ocp_read(tp, index, sizeof(tmp), &tmp, type | byen);
+
+	data = __le32_to_cpu(tmp);
+	data >>= (shift * 8);
+	data &= 0xffff;
+
+	return (u16)data;
+}
+
+static void ocp_write_word(struct r8152 *tp, u16 type, u16 index, u32 data)
+{
+	u32 mask = 0xffff;
+	__le32 tmp;
+	u16 byen = BYTE_EN_WORD;
+	u8 shift = index & 2;
+
+	data &= mask;
+
+	if (index & 2) {
+		byen <<= shift;
+		mask <<= (shift * 8);
+		data <<= (shift * 8);
+		index &= ~3;
+	}
+
+	tmp = __cpu_to_le32(data);
+
+	generic_ocp_write(tp, index, byen, sizeof(tmp), &tmp, type);
+}
+
+static u8 ocp_read_byte(struct r8152 *tp, u16 type, u16 index)
+{
+	u32 data;
+	__le32 tmp;
+	u8 shift = index & 3;
+
+	index &= ~3;
+
+	generic_ocp_read(tp, index, sizeof(tmp), &tmp, type);
+
+	data = __le32_to_cpu(tmp);
+	data >>= (shift * 8);
+	data &= 0xff;
+
+	return (u8)data;
+}
+
+static void ocp_write_byte(struct r8152 *tp, u16 type, u16 index, u32 data)
+{
+	u32 mask = 0xff;
+	__le32 tmp;
+	u16 byen = BYTE_EN_BYTE;
+	u8 shift = index & 3;
+
+	data &= mask;
+
+	if (index & 3) {
+		byen <<= shift;
+		mask <<= (shift * 8);
+		data <<= (shift * 8);
+		index &= ~3;
+	}
+
+	tmp = __cpu_to_le32(data);
+
+	generic_ocp_write(tp, index, byen, sizeof(tmp), &tmp, type);
+}
+
+static u16 ocp_reg_read(struct r8152 *tp, u16 addr)
+{
+	u16 ocp_base, ocp_index;
+
+	ocp_base = addr & 0xf000;
+	if (ocp_base != tp->ocp_base) {
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_OCP_GPHY_BASE, ocp_base);
+		tp->ocp_base = ocp_base;
+	}
+
+	ocp_index = (addr & 0x0fff) | 0xb000;
+	return ocp_read_word(tp, MCU_TYPE_PLA, ocp_index);
+}
+
+static void ocp_reg_write(struct r8152 *tp, u16 addr, u16 data)
+{
+	u16 ocp_base, ocp_index;
+
+	ocp_base = addr & 0xf000;
+	if (ocp_base != tp->ocp_base) {
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_OCP_GPHY_BASE, ocp_base);
+		tp->ocp_base = ocp_base;
+	}
+
+	ocp_index = (addr & 0x0fff) | 0xb000;
+	ocp_write_word(tp, MCU_TYPE_PLA, ocp_index, data);
+}
+
+static inline void r8152_mdio_write(struct r8152 *tp, u32 reg_addr, u32 value)
+{
+	ocp_reg_write(tp, OCP_BASE_MII + reg_addr * 2, value);
+}
+
+static inline int r8152_mdio_read(struct r8152 *tp, u32 reg_addr)
+{
+	return ocp_reg_read(tp, OCP_BASE_MII + reg_addr * 2);
+}
+
+static void sram_write(struct r8152 *tp, u16 addr, u16 data)
+{
+	ocp_reg_write(tp, OCP_SRAM_ADDR, addr);
+	ocp_reg_write(tp, OCP_SRAM_DATA, data);
+}
+
+static u16 sram_read(struct r8152 *tp, u16 addr)
+{
+	ocp_reg_write(tp, OCP_SRAM_ADDR, addr);
+	return ocp_reg_read(tp, OCP_SRAM_DATA);
+}
+
+static int read_mii_word(struct net_device *netdev, int phy_id, int reg)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+	int ret, lock;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return -ENODEV;
+
+	if (phy_id != R8152_PHY_ID)
+		return -EINVAL;
+
+	lock = mutex_trylock(&tp->control);
+
+	ret = r8152_mdio_read(tp, reg);
+
+	if (lock) {
+		mutex_unlock(&tp->control);
+		netif_warn(tp, drv, netdev, "miss mutex for read_mii_word?\n");
+	}
+
+	return ret;
+}
+
+static
+void write_mii_word(struct net_device *netdev, int phy_id, int reg, int val)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+	int lock;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	if (phy_id != R8152_PHY_ID)
+		return;
+
+	lock = mutex_trylock(&tp->control);
+
+	r8152_mdio_write(tp, reg, val);
+
+	if (lock) {
+		mutex_unlock(&tp->control);
+		netif_warn(tp, drv, netdev, "miss mutex for write_mii_word?\n");
+	}
+}
+
+static int
+r8152_submit_rx(struct r8152 *tp, struct rx_agg *agg, gfp_t mem_flags);
+
+static int
+rtl8152_set_speed(struct r8152 *tp, u8 autoneg, u32 speed, u8 duplex,
+		  u32 advertising);
+
+static int rtl8152_set_mac_address(struct net_device *netdev, void *p)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+	struct sockaddr *addr = p;
+	int ret = -EADDRNOTAVAIL;
+
+	if (unlikely(tp->rtk_enable_diag))
+		return -EBUSY;
+
+	if (!is_valid_ether_addr(addr->sa_data))
+		goto out1;
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		goto out1;
+
+	mutex_lock(&tp->control);
+
+	memcpy(netdev->dev_addr, addr->sa_data, netdev->addr_len);
+
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CRWECR, CRWECR_CONFIG);
+	pla_ocp_write(tp, PLA_IDR, BYTE_EN_SIX_BYTES, 8, addr->sa_data);
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CRWECR, CRWECR_NORAML);
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+out1:
+	return ret;
+}
+
+static int set_ethernet_addr(struct r8152 *tp)
+{
+	struct net_device *dev = tp->netdev;
+	struct sockaddr sa;
+	int ret;
+
+	if (tp->version == RTL_VER_01)
+		ret = pla_ocp_read(tp, PLA_IDR, 8, sa.sa_data);
+	else
+		ret = pla_ocp_read(tp, PLA_BACKUP, 8, sa.sa_data);
+
+	if (ret < 0) {
+		netif_err(tp, probe, dev, "Get ether addr fail\n");
+	} else if (!is_valid_ether_addr(sa.sa_data)) {
+		netif_err(tp, probe, dev, "Invalid ether addr %pM\n",
+			  sa.sa_data);
+		eth_hw_addr_random(dev);
+		ether_addr_copy(sa.sa_data, dev->dev_addr);
+		ret = rtl8152_set_mac_address(dev, &sa);
+		netif_info(tp, probe, dev, "Random ether addr %pM\n",
+			   sa.sa_data);
+	} else {
+		if (tp->version == RTL_VER_01)
+			ether_addr_copy(dev->dev_addr, sa.sa_data);
+		else
+			ret = rtl8152_set_mac_address(dev, &sa);
+	}
+
+	return ret;
+}
+
+static inline struct net_device_stats *rtl8152_get_stats(struct net_device *dev)
+{
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+	struct rtl8152 *tp = netdev_priv(dev);
+
+	return (struct net_device_stats *)&tp->stats;
+#else
+	return &dev->stats;
+#endif
+}
+
+static void read_bulk_callback(struct urb *urb)
+{
+	struct net_device *netdev;
+	int status = urb->status;
+	struct rx_agg *agg;
+	struct r8152 *tp;
+	unsigned long flags;
+
+	agg = urb->context;
+	if (!agg)
+		return;
+
+	tp = agg->context;
+	if (!tp)
+		return;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	if (!test_bit(WORK_ENABLE, &tp->flags))
+		return;
+
+	netdev = tp->netdev;
+
+	/* When link down, the driver would cancel all bulks. */
+	/* This avoid the re-submitting bulk */
+	if (!netif_carrier_ok(netdev))
+		return;
+
+	usb_mark_last_busy(tp->udev);
+
+	switch (status) {
+	case 0:
+		if (urb->actual_length < ETH_ZLEN)
+			break;
+
+		spin_lock_irqsave(&tp->rx_lock, flags);
+		list_add_tail(&agg->list, &tp->rx_done);
+		spin_unlock_irqrestore(&tp->rx_lock, flags);
+		napi_schedule(&tp->napi);
+		return;
+	case -ESHUTDOWN:
+		rtl_set_unplug(tp);
+		netif_device_detach(tp->netdev);
+		return;
+	case -ENOENT:
+		return;	/* the urb is in unlink state */
+	case -ETIME:
+		if (net_ratelimit())
+			netif_warn(tp, rx_err, netdev,
+				   "maybe reset is needed?\n");
+		break;
+	default:
+		if (net_ratelimit())
+			netif_warn(tp, rx_err, netdev,
+				   "Rx status %d\n", status);
+		break;
+	}
+
+	r8152_submit_rx(tp, agg, GFP_ATOMIC);
+}
+
+static void write_bulk_callback(struct urb *urb)
+{
+	struct net_device_stats *stats;
+	struct net_device *netdev;
+	struct tx_agg *agg;
+	struct r8152 *tp;
+	unsigned long flags;
+	int status = urb->status;
+
+	agg = urb->context;
+	if (!agg)
+		return;
+
+	tp = agg->context;
+	if (!tp)
+		return;
+
+	netdev = tp->netdev;
+	stats = rtl8152_get_stats(netdev);
+	if (status) {
+		if (net_ratelimit())
+			netif_warn(tp, tx_err, netdev,
+				   "Tx status %d\n", status);
+		stats->tx_errors += agg->skb_num;
+	} else {
+		stats->tx_packets += agg->skb_num;
+		stats->tx_bytes += agg->skb_len;
+	}
+
+	spin_lock_irqsave(&tp->tx_lock, flags);
+	list_add_tail(&agg->list, &tp->tx_free);
+	spin_unlock_irqrestore(&tp->tx_lock, flags);
+
+	usb_autopm_put_interface_async(tp->intf);
+
+	if (!netif_carrier_ok(netdev))
+		return;
+
+	if (!test_bit(WORK_ENABLE, &tp->flags))
+		return;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	if (!skb_queue_empty(&tp->tx_queue))
+		tasklet_schedule(&tp->tx_tl);
+}
+
+static void write_bulk_sg_callback(struct urb *urb)
+{
+	struct net_device *netdev;
+	struct tx_agg *agg;
+	struct r8152 *tp;
+	unsigned long flags;
+	int status = urb->status;
+
+	agg = urb->context;
+	if (!agg)
+		return;
+
+	tp = agg->context;
+	if (!tp)
+		return;
+
+	netdev = tp->netdev;
+	if (status && net_ratelimit())
+		netif_warn(tp, tx_err, netdev, "Tx status %d\n", status);
+
+	while (!skb_queue_empty(&agg->tx_skb)) {
+		struct sk_buff *skb = __skb_dequeue(&agg->tx_skb);
+		struct net_device_stats *stats = rtl8152_get_stats(netdev);
+
+		if (status) {
+			stats->tx_errors += skb_shinfo(skb)->gso_segs ?: 1;
+			dev_kfree_skb_any(skb);
+		} else {
+			stats->tx_packets += skb_shinfo(skb)->gso_segs ?: 1;
+			stats->tx_bytes += skb->len - skb->cb[0];
+			dev_consume_skb_any(skb);
+		}
+	}
+
+	spin_lock_irqsave(&tp->tx_lock, flags);
+	list_add_tail(&agg->list, &tp->tx_free);
+	spin_unlock_irqrestore(&tp->tx_lock, flags);
+
+	usb_autopm_put_interface_async(tp->intf);
+
+	if (!netif_carrier_ok(netdev))
+		return;
+
+	if (!test_bit(WORK_ENABLE, &tp->flags))
+		return;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	if (!skb_queue_empty(&tp->tx_queue))
+		tasklet_schedule(&tp->tx_tl);
+}
+
+static void intr_callback(struct urb *urb)
+{
+	struct r8152 *tp;
+	__le16 *d;
+	int status = urb->status;
+	int res;
+
+	tp = urb->context;
+	if (!tp)
+		return;
+
+	if (!test_bit(WORK_ENABLE, &tp->flags))
+		return;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	switch (status) {
+	case 0:			/* success */
+		break;
+	case -ECONNRESET:	/* unlink */
+	case -ESHUTDOWN:
+		netif_device_detach(tp->netdev);
+	case -ENOENT:
+	case -EPROTO:
+		netif_info(tp, intr, tp->netdev,
+			   "Stop submitting intr, status %d\n", status);
+		return;
+	case -EOVERFLOW:
+		netif_info(tp, intr, tp->netdev, "intr status -EOVERFLOW\n");
+		goto resubmit;
+	/* -EPIPE:  should clear the halt */
+	default:
+		netif_info(tp, intr, tp->netdev, "intr status %d\n", status);
+		goto resubmit;
+	}
+
+	d = urb->transfer_buffer;
+	if (INTR_LINK & __le16_to_cpu(d[0])) {
+		if (!netif_carrier_ok(tp->netdev)) {
+			set_bit(RTL8152_LINK_CHG, &tp->flags);
+			schedule_delayed_work(&tp->schedule, 0);
+		}
+	} else {
+		if (netif_carrier_ok(tp->netdev)) {
+			netif_stop_queue(tp->netdev);
+			set_bit(RTL8152_LINK_CHG, &tp->flags);
+			schedule_delayed_work(&tp->schedule, 0);
+		}
+	}
+
+resubmit:
+	res = usb_submit_urb(urb, GFP_ATOMIC);
+	if (res == -ENODEV) {
+		rtl_set_unplug(tp);
+		netif_device_detach(tp->netdev);
+	} else if (res) {
+		netif_err(tp, intr, tp->netdev,
+			  "can't resubmit intr, status %d\n", res);
+	}
+}
+
+static inline void *rx_agg_align(void *data)
+{
+	return (void *)ALIGN((uintptr_t)data, RX_ALIGN);
+}
+
+static inline void *tx_agg_align(void *data)
+{
+	return (void *)ALIGN((uintptr_t)data, TX_ALIGN);
+}
+
+static void free_rx_agg(struct r8152 *tp, struct rx_agg *agg)
+{
+	list_del(&agg->info_list);
+
+	usb_free_urb(agg->urb);
+	put_page(agg->page);
+	kfree(agg);
+
+	atomic_dec(&tp->rx_count);
+}
+
+static struct rx_agg *alloc_rx_agg(struct r8152 *tp, gfp_t mflags)
+{
+	struct net_device *netdev = tp->netdev;
+	int node = netdev->dev.parent ? dev_to_node(netdev->dev.parent) : -1;
+	struct rx_agg *rx_agg;
+	unsigned int order = get_order(tp->rx_buf_sz);
+
+	rx_agg = kmalloc_node(sizeof(struct rx_agg), mflags, node);
+	if (rx_agg) {
+		unsigned long flags;
+
+		rx_agg->page = alloc_pages(mflags | __GFP_COMP, order);
+		if (!rx_agg->page)
+			goto free_rx;
+
+		rx_agg->buffer = page_address(rx_agg->page);
+
+		rx_agg->urb = usb_alloc_urb(0, mflags);
+		if (!rx_agg->urb)
+			goto free_buf;
+
+		rx_agg->context = tp;
+
+		INIT_LIST_HEAD(&rx_agg->list);
+		INIT_LIST_HEAD(&rx_agg->info_list);
+		spin_lock_irqsave(&tp->rx_lock, flags);
+		list_add_tail(&rx_agg->info_list, &tp->rx_info);
+		spin_unlock_irqrestore(&tp->rx_lock, flags);
+
+		atomic_inc(&tp->rx_count);
+	}
+
+	return rx_agg;
+
+free_buf:
+	__free_pages(rx_agg->page, order);
+free_rx:
+	kfree(rx_agg);
+	return NULL;
+}
+
+static void free_all_mem(struct r8152 *tp)
+{
+	struct list_head *cursor, *next;
+	unsigned long flags;
+	int i;
+
+	spin_lock_irqsave(&tp->rx_lock, flags);
+
+	list_for_each_safe(cursor, next, &tp->rx_info) {
+		struct rx_agg *agg;
+
+		agg = list_entry(cursor, struct rx_agg, info_list);
+		free_rx_agg(tp, agg);
+	}
+
+	spin_unlock_irqrestore(&tp->rx_lock, flags);
+
+	WARN_ON(unlikely(atomic_read(&tp->rx_count)));
+
+	for (i = 0; i < RTL8152_MAX_TX; i++) {
+		usb_free_urb(tp->tx_info[i].urb);
+		tp->tx_info[i].urb = NULL;
+
+		kfree(tp->tx_info[i].buffer);
+		tp->tx_info[i].buffer = NULL;
+		tp->tx_info[i].head = NULL;
+	}
+
+	usb_free_urb(tp->intr_urb);
+	tp->intr_urb = NULL;
+
+	kfree(tp->intr_buff);
+	tp->intr_buff = NULL;
+}
+
+static int alloc_all_mem(struct r8152 *tp)
+{
+	struct net_device *netdev = tp->netdev;
+	struct usb_interface *intf = tp->intf;
+	struct usb_host_interface *alt = intf->cur_altsetting;
+	struct usb_host_endpoint *ep_intr = alt->endpoint + 2;
+	int node, i;
+
+	node = netdev->dev.parent ? dev_to_node(netdev->dev.parent) : -1;
+
+	spin_lock_init(&tp->rx_lock);
+	spin_lock_init(&tp->tx_lock);
+	INIT_LIST_HEAD(&tp->rx_info);
+	INIT_LIST_HEAD(&tp->tx_free);
+	INIT_LIST_HEAD(&tp->rx_done);
+	skb_queue_head_init(&tp->tx_queue);
+	skb_queue_head_init(&tp->rx_queue);
+	atomic_set(&tp->rx_count, 0);
+
+	for (i = 0; i < RTL8152_MAX_RX; i++) {
+		if (!alloc_rx_agg(tp, GFP_KERNEL))
+			goto err1;
+	}
+
+	for (i = 0; i < RTL8152_MAX_TX; i++) {
+		struct urb *urb;
+		u8 *buf;
+
+		buf = kmalloc_node(agg_buf_sz, GFP_KERNEL, node);
+		if (!buf)
+			goto err1;
+
+		if (buf != tx_agg_align(buf)) {
+			kfree(buf);
+			buf = kmalloc_node(agg_buf_sz + TX_ALIGN, GFP_KERNEL,
+					   node);
+			if (!buf)
+				goto err1;
+		}
+
+		urb = usb_alloc_urb(0, GFP_KERNEL);
+		if (!urb) {
+			kfree(buf);
+			goto err1;
+		}
+
+		INIT_LIST_HEAD(&tp->tx_info[i].list);
+		tp->tx_info[i].context = tp;
+		tp->tx_info[i].urb = urb;
+		tp->tx_info[i].buffer = buf;
+		tp->tx_info[i].head = tx_agg_align(buf);
+
+		list_add_tail(&tp->tx_info[i].list, &tp->tx_free);
+		skb_queue_head_init(&tp->tx_info[i].tx_skb);
+	}
+
+	tp->intr_urb = usb_alloc_urb(0, GFP_KERNEL);
+	if (!tp->intr_urb)
+		goto err1;
+
+	tp->intr_buff = kmalloc(INTBUFSIZE, GFP_KERNEL);
+	if (!tp->intr_buff)
+		goto err1;
+
+	tp->intr_interval = (int)ep_intr->desc.bInterval;
+	usb_fill_int_urb(tp->intr_urb, tp->udev, usb_rcvintpipe(tp->udev, 3),
+			 tp->intr_buff, INTBUFSIZE, intr_callback,
+			 tp, tp->intr_interval);
+
+	return 0;
+
+err1:
+	free_all_mem(tp);
+	return -ENOMEM;
+}
+
+static struct tx_agg *r8152_get_tx_agg(struct r8152 *tp)
+{
+	struct tx_agg *agg = NULL;
+	unsigned long flags;
+
+	if (list_empty(&tp->tx_free))
+		return NULL;
+
+	spin_lock_irqsave(&tp->tx_lock, flags);
+	if (!list_empty(&tp->tx_free)) {
+		struct list_head *cursor;
+
+		cursor = tp->tx_free.next;
+		list_del_init(cursor);
+		agg = list_entry(cursor, struct tx_agg, list);
+	}
+	spin_unlock_irqrestore(&tp->tx_lock, flags);
+
+	return agg;
+}
+
+/* r8152_csum_workaround()
+ * The hw limites the value the transport offset. When the offset is out of the
+ * range, calculate the checksum by sw.
+ */
+static void r8152_csum_workaround(struct r8152 *tp, struct sk_buff *skb,
+				  struct sk_buff_head *list)
+{
+	if (skb_shinfo(skb)->gso_size) {
+		netdev_features_t features = tp->netdev->features;
+		struct sk_buff_head seg_list;
+		struct sk_buff *segs, *nskb;
+
+		features &= ~(NETIF_F_SG | NETIF_F_IPV6_CSUM | NETIF_F_TSO6);
+		segs = skb_gso_segment(skb, features);
+		if (IS_ERR(segs) || !segs)
+			goto drop;
+
+		__skb_queue_head_init(&seg_list);
+
+		do {
+			nskb = segs;
+			segs = segs->next;
+			nskb->next = NULL;
+			__skb_queue_tail(&seg_list, nskb);
+		} while (segs);
+
+		skb_queue_splice(&seg_list, list);
+		dev_kfree_skb(skb);
+	} else if (skb->ip_summed == CHECKSUM_PARTIAL) {
+		if (skb_checksum_help(skb) < 0)
+			goto drop;
+
+		__skb_queue_head(list, skb);
+	} else {
+		struct net_device_stats *stats;
+
+drop:
+		stats = rtl8152_get_stats(tp->netdev);
+		stats->tx_dropped++;
+		dev_kfree_skb(skb);
+	}
+}
+
+/* msdn_giant_send_check()
+ * According to the document of microsoft, the TCP Pseudo Header excludes the
+ * packet length for IPv6 TCP large packets.
+ */
+static int msdn_giant_send_check(struct sk_buff *skb)
+{
+	const struct ipv6hdr *ipv6h;
+	struct tcphdr *th;
+	int ret;
+
+	ret = skb_cow_head(skb, 0);
+	if (ret)
+		return ret;
+
+	ipv6h = ipv6_hdr(skb);
+	th = tcp_hdr(skb);
+
+	th->check = 0;
+	th->check = ~tcp_v6_check(0, &ipv6h->saddr, &ipv6h->daddr, 0);
+
+	return ret;
+}
+
+static inline void rtl_tx_vlan_tag(struct tx_desc *desc, struct sk_buff *skb)
+{
+	if (skb_vlan_tag_present(skb)) {
+		u32 opts2;
+
+		opts2 = TX_VLAN_TAG | swab16(skb_vlan_tag_get(skb));
+		desc->opts2 |= cpu_to_le32(opts2);
+	}
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+
+static inline bool
+rtl_rx_vlan_tag(struct r8152 *tp, struct rx_desc *desc, struct sk_buff *skb)
+{
+	u32 opts2 = le32_to_cpu(desc->opts2);
+
+	if (tp->vlgrp && (opts2 & RX_VLAN_TAG)) {
+		vlan_gro_receive(&tp->napi, tp->vlgrp, swab16(opts2 & 0xffff),
+				 skb);
+		return true;
+	}
+
+	return false;
+}
+
+static inline void
+rtl_vlan_put_tag(struct r8152 *tp, struct rx_desc *desc, struct sk_buff *skb)
+{
+	u32 opts2 = le32_to_cpu(desc->opts2);
+
+	if (tp->vlgrp && (opts2 & RX_VLAN_TAG))
+		__vlan_hwaccel_put_tag(skb, swab16(opts2 & 0xffff));
+}
+
+static inline __u16
+rtl_vlan_get_tag(struct sk_buff *skb)
+{
+	__u16 tag;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,27)
+	__vlan_hwaccel_get_tag(skb, &tag);
+#else
+	tag = skb->vlan_tci;
+#endif
+
+	return tag;
+}
+
+#else
+
+static inline void rtl_rx_vlan_tag(struct rx_desc *desc, struct sk_buff *skb)
+{
+	u32 opts2 = le32_to_cpu(desc->opts2);
+
+	if (opts2 & RX_VLAN_TAG)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0)
+		__vlan_hwaccel_put_tag(skb, swab16(opts2 & 0xffff));
+#else
+		__vlan_hwaccel_put_tag(skb, htons(ETH_P_8021Q),
+				       swab16(opts2 & 0xffff));
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0) */
+}
+
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0) */
+
+static int r8152_tx_csum(struct r8152 *tp, struct tx_desc *desc,
+			 struct sk_buff *skb, u32 len, u32 transport_offset)
+{
+	u32 mss = skb_shinfo(skb)->gso_size;
+	u32 opts1, opts2 = 0;
+	int ret = TX_CSUM_SUCCESS;
+
+	WARN_ON_ONCE(len > TX_LEN_MAX);
+
+	opts1 = len | TX_FS | TX_LS;
+
+	if (mss) {
+		if (transport_offset > GTTCPHO_MAX) {
+			netif_warn(tp, tx_err, tp->netdev,
+				   "Invalid transport offset 0x%x for TSO\n",
+				   transport_offset);
+			ret = TX_CSUM_TSO;
+			goto unavailable;
+		}
+
+		switch (vlan_get_protocol(skb)) {
+		case htons(ETH_P_IP):
+			opts1 |= GTSENDV4;
+			break;
+
+		case htons(ETH_P_IPV6):
+			if (msdn_giant_send_check(skb)) {
+				ret = TX_CSUM_TSO;
+				goto unavailable;
+			}
+			opts1 |= GTSENDV6;
+			break;
+
+		default:
+			WARN_ON_ONCE(1);
+			break;
+		}
+
+		opts1 |= transport_offset << GTTCPHO_SHIFT;
+		opts2 |= min(mss, MSS_MAX) << MSS_SHIFT;
+	} else if (skb->ip_summed == CHECKSUM_PARTIAL) {
+		u8 ip_protocol;
+
+		if (transport_offset > TCPHO_MAX) {
+			netif_warn(tp, tx_err, tp->netdev,
+				   "Invalid transport offset 0x%x\n",
+				   transport_offset);
+			ret = TX_CSUM_NONE;
+			goto unavailable;
+		}
+
+		switch (vlan_get_protocol(skb)) {
+		case htons(ETH_P_IP):
+			opts2 |= IPV4_CS;
+			ip_protocol = ip_hdr(skb)->protocol;
+			break;
+
+		case htons(ETH_P_IPV6):
+			opts2 |= IPV6_CS;
+			ip_protocol = ipv6_hdr(skb)->nexthdr;
+			break;
+
+		default:
+			ip_protocol = IPPROTO_RAW;
+			break;
+		}
+
+		if (ip_protocol == IPPROTO_TCP)
+			opts2 |= TCP_CS;
+		else if (ip_protocol == IPPROTO_UDP)
+			opts2 |= UDP_CS;
+		else
+			WARN_ON_ONCE(1);
+
+		opts2 |= transport_offset << TCPHO_SHIFT;
+	}
+
+	desc->opts2 = cpu_to_le32(opts2);
+	desc->opts1 = cpu_to_le32(opts1);
+
+unavailable:
+	return ret;
+}
+
+static int r8152_tx_agg_fill(struct r8152 *tp, struct tx_agg *agg)
+{
+	struct sk_buff_head skb_head, *tx_queue = &tp->tx_queue;
+	int remain, ret;
+	u8 *tx_data;
+
+	__skb_queue_head_init(&skb_head);
+	spin_lock(&tx_queue->lock);
+	skb_queue_splice_init(tx_queue, &skb_head);
+	spin_unlock(&tx_queue->lock);
+
+	tx_data = agg->head;
+	agg->skb_num = 0;
+	agg->skb_len = 0;
+	remain = agg_buf_sz;
+
+	while (remain >= ETH_ZLEN + sizeof(struct tx_desc)) {
+		struct tx_desc *tx_desc;
+		struct sk_buff *skb;
+		unsigned int len;
+		u32 offset;
+
+		skb = __skb_dequeue(&skb_head);
+		if (!skb)
+			break;
+
+		len = skb->len + sizeof(*tx_desc);
+
+		if (len > remain) {
+			__skb_queue_head(&skb_head, skb);
+			break;
+		}
+
+		tx_data = tx_agg_align(tx_data);
+		tx_desc = (struct tx_desc *)tx_data;
+
+		offset = (u32)skb_transport_offset(skb);
+
+		if (r8152_tx_csum(tp, tx_desc, skb, skb->len, offset)) {
+			r8152_csum_workaround(tp, skb, &skb_head);
+			continue;
+		}
+
+		rtl_tx_vlan_tag(tx_desc, skb);
+
+		tx_data += sizeof(*tx_desc);
+
+		len = skb->len;
+		if (skb_copy_bits(skb, 0, tx_data, len) < 0) {
+			struct net_device_stats *stats = &tp->netdev->stats;
+
+			stats->tx_dropped++;
+			dev_kfree_skb_any(skb);
+			tx_data -= sizeof(*tx_desc);
+			continue;
+		}
+
+		tx_data += len;
+		agg->skb_len += len;
+		agg->skb_num += skb_shinfo(skb)->gso_segs ?: 1;
+
+		dev_consume_skb_any(skb);
+
+		remain = agg_buf_sz - (int)(tx_agg_align(tx_data) - agg->head);
+	}
+
+	if (!skb_queue_empty(&skb_head)) {
+		spin_lock(&tx_queue->lock);
+		skb_queue_splice(&skb_head, tx_queue);
+		spin_unlock(&tx_queue->lock);
+	}
+
+	netif_tx_lock(tp->netdev);
+
+	if (netif_queue_stopped(tp->netdev) &&
+	    skb_queue_len(&tp->tx_queue) < tp->tx_qlen)
+		netif_wake_queue(tp->netdev);
+
+	netif_tx_unlock(tp->netdev);
+
+	ret = usb_autopm_get_interface_async(tp->intf);
+	if (ret < 0)
+		goto out_tx_fill;
+
+	usb_fill_bulk_urb(agg->urb, tp->udev, usb_sndbulkpipe(tp->udev, 2),
+			  agg->head, (int)(tx_data - (u8 *)agg->head),
+			  (usb_complete_t)write_bulk_callback, agg);
+
+	agg->urb->sg = NULL;
+	agg->urb->num_sgs = 0;
+
+	ret = usb_submit_urb(agg->urb, GFP_ATOMIC);
+	if (ret < 0)
+		usb_autopm_put_interface_async(tp->intf);
+
+out_tx_fill:
+	return ret;
+}
+
+static int r8152_tx_agg_sg_fill(struct r8152 *tp, struct tx_agg *agg)
+{
+	struct sk_buff_head skb_head, *tx_queue = &tp->tx_queue;
+	int max_sg_num, ret, sg_num;
+	struct scatterlist *sg;
+	int padding = 0;
+
+	__skb_queue_head_init(&skb_head);
+	spin_lock(&tx_queue->lock);
+	skb_queue_splice_init(tx_queue, &skb_head);
+	spin_unlock(&tx_queue->lock);
+
+	sg = agg->head;
+	max_sg_num = (agg_buf_sz / sizeof(*sg)) - 1;
+	max_sg_num = min_t(int, RTL_MAX_SG_NUM, max_sg_num);
+	sg_init_table(sg, max_sg_num + 1);
+	agg->skb_num = 0;
+	agg->skb_len = 0;
+
+	for (sg_num = 0; sg_num < max_sg_num;) {
+		struct tx_desc tx_desc;
+		struct sk_buff *skb;
+		int num_sgs, headroom;
+		unsigned int len;
+		u32 offset;
+
+		skb = __skb_dequeue(&skb_head);
+		if (!skb)
+			break;
+
+		headroom = skb_headroom(skb) - padding - sizeof(tx_desc);
+
+		if (skb_header_cloned(skb) || headroom < 0) {
+			struct sk_buff *tx_skb;
+
+			headroom = padding + sizeof(tx_desc);
+			tx_skb = skb_copy_expand(skb, headroom, 0, GFP_ATOMIC);
+			dev_kfree_skb_any(skb);
+			if (!tx_skb) {
+				struct net_device_stats *stats;
+
+				stats = rtl8152_get_stats(tp->netdev);
+				stats->tx_dropped++;
+				netif_wake_queue(tp->netdev);
+				return NETDEV_TX_OK;
+			}
+			skb = tx_skb;
+			headroom = skb_headroom(skb) - headroom;
+		}
+
+		 /* calculate the fragment numbers for skb */
+		num_sgs = 1 + skb_shinfo(skb)->nr_frags;
+		len = skb->len;
+
+		if ((num_sgs + sg_num) > max_sg_num) {
+			__skb_queue_head(&skb_head, skb);
+			break;
+		}
+
+		offset = (u32)skb_transport_offset(skb);
+
+		if (r8152_tx_csum(tp, &tx_desc, skb, len, offset)) {
+			r8152_csum_workaround(tp, skb, &skb_head);
+			continue;
+		}
+
+		rtl_tx_vlan_tag(&tx_desc, skb);
+
+		WARN_ON(padding < 0);
+
+		/* use skb_headroom for tx desc */
+		skb->cb[0] = padding + sizeof(tx_desc);
+		memcpy(skb_push(skb, sizeof(tx_desc)), &tx_desc,
+		       sizeof(tx_desc));
+		if (padding)
+			memset(skb_push(skb, padding), 0, padding);
+
+		num_sgs = skb_to_sgvec_nomark(skb, sg, 0, skb->len);
+		if (num_sgs < 0) {
+			netif_err(tp, tx_err, tp->netdev,
+				  "skb_to_sgvec fail %d\n", num_sgs);
+			__skb_queue_head(&skb_head, skb);
+			break;
+		}
+
+		sg += num_sgs;
+
+		__skb_queue_tail(&agg->tx_skb, skb);
+
+		sg_num += num_sgs;
+		agg->skb_len += skb->len;
+		padding = len + sizeof(tx_desc);
+
+		agg->skb_num++;
+
+		padding = ALIGN(padding, TX_ALIGN) - padding;
+	}
+
+	sg_mark_end(sg);
+
+	if (!skb_queue_empty(&skb_head)) {
+		spin_lock(&tx_queue->lock);
+		skb_queue_splice(&skb_head, tx_queue);
+		spin_unlock(&tx_queue->lock);
+	}
+
+	netif_tx_lock(tp->netdev);
+
+	if (netif_queue_stopped(tp->netdev) &&
+	    skb_queue_len(&tp->tx_queue) < tp->tx_qlen)
+		netif_wake_queue(tp->netdev);
+
+	netif_tx_unlock(tp->netdev);
+
+	if (sg_num == 0) {
+		unsigned long flags;
+
+		spin_lock_irqsave(&tp->tx_lock, flags);
+		list_add_tail(&agg->list, &tp->tx_free);
+		spin_unlock_irqrestore(&tp->tx_lock, flags);
+
+		ret = 0;
+		goto out_tx_fill;
+	}
+
+	ret = usb_autopm_get_interface_async(tp->intf);
+	if (ret < 0)
+		goto out_tx_fill;
+
+	usb_fill_bulk_urb(agg->urb, tp->udev, usb_sndbulkpipe(tp->udev, 2),
+			  NULL, (int)agg->skb_len,
+			  (usb_complete_t)write_bulk_sg_callback, agg);
+
+	agg->urb->sg = agg->head;
+	agg->urb->num_sgs = sg_num;
+
+	ret = usb_submit_urb(agg->urb, GFP_ATOMIC);
+	if (ret < 0)
+		usb_autopm_put_interface_async(tp->intf);
+
+out_tx_fill:
+	return ret;
+}
+
+static u8 r8152_rx_csum(struct r8152 *tp, struct rx_desc *rx_desc)
+{
+	u8 checksum = CHECKSUM_NONE;
+	u32 opts2, opts3;
+
+	if (!(tp->netdev->features & NETIF_F_RXCSUM))
+		goto return_result;
+
+	opts2 = le32_to_cpu(rx_desc->opts2);
+	opts3 = le32_to_cpu(rx_desc->opts3);
+
+	if (opts2 & RD_IPV4_CS) {
+		if (opts3 & IPF)
+			checksum = CHECKSUM_NONE;
+		else if ((opts2 & RD_UDP_CS) && !(opts3 & UDPF))
+			checksum = CHECKSUM_UNNECESSARY;
+		else if ((opts2 & RD_TCP_CS) && !(opts3 & TCPF))
+			checksum = CHECKSUM_UNNECESSARY;
+	} else if (opts2 & RD_IPV6_CS) {
+		if ((opts2 & RD_UDP_CS) && !(opts3 & UDPF))
+			checksum = CHECKSUM_UNNECESSARY;
+		else if ((opts2 & RD_TCP_CS) && !(opts3 & TCPF))
+			checksum = CHECKSUM_UNNECESSARY;
+	}
+
+return_result:
+	return checksum;
+}
+
+static inline bool rx_count_exceed(struct r8152 *tp)
+{
+	return atomic_read(&tp->rx_count) > RTL8152_MAX_RX;
+}
+
+static inline int agg_offset(struct rx_agg *agg, void *addr)
+{
+	return (int)(addr - agg->buffer);
+}
+
+static struct rx_agg *rtl_get_free_rx(struct r8152 *tp, gfp_t mflags)
+{
+	struct list_head *cursor, *next;
+	struct rx_agg *agg_free = NULL;
+	unsigned long flags;
+
+	spin_lock_irqsave(&tp->rx_lock, flags);
+
+	list_for_each_safe(cursor, next, &tp->rx_used) {
+		struct rx_agg *agg;
+
+		agg = list_entry(cursor, struct rx_agg, list);
+
+		if (page_count(agg->page) == 1) {
+			if (!agg_free) {
+				list_del_init(cursor);
+				agg_free = agg;
+			} else if (rx_count_exceed(tp)) {
+				list_del_init(cursor);
+				free_rx_agg(tp, agg);
+				break;
+			} else {
+				break;
+			}
+		}
+	}
+
+	spin_unlock_irqrestore(&tp->rx_lock, flags);
+
+	if (!agg_free && atomic_read(&tp->rx_count) < tp->rx_max_agg_num)
+		agg_free = alloc_rx_agg(tp, mflags);
+
+	return agg_free;
+}
+
+static int rx_bottom(struct r8152 *tp, int budget)
+{
+	unsigned long flags;
+	struct list_head *cursor, *next, rx_queue;
+	int ret = 0, work_done = 0;
+	struct napi_struct *napi = &tp->napi;
+
+	if (!skb_queue_empty(&tp->rx_queue)) {
+		while (work_done < budget) {
+			struct sk_buff *skb = __skb_dequeue(&tp->rx_queue);
+			struct net_device *netdev = tp->netdev;
+			struct net_device_stats *stats;
+			unsigned int pkt_len;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+			u16 vlan_tci;
+#endif
+
+			if (!skb)
+				break;
+
+			pkt_len = skb->len;
+			stats = rtl8152_get_stats(netdev);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+			vlan_tci = rtl_vlan_get_tag(skb);
+
+			if (vlan_tci)
+				vlan_gro_receive(napi, tp->vlgrp, vlan_tci,
+						 skb);
+			else
+				napi_gro_receive(napi, skb);
+#else
+			napi_gro_receive(napi, skb);
+#endif
+
+			work_done++;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+			netdev->last_rx = jiffies;
+#endif
+			stats->rx_packets++;
+			stats->rx_bytes += pkt_len;
+		}
+	}
+
+	if (list_empty(&tp->rx_done))
+		goto out1;
+
+	INIT_LIST_HEAD(&rx_queue);
+	spin_lock_irqsave(&tp->rx_lock, flags);
+	list_splice_init(&tp->rx_done, &rx_queue);
+	spin_unlock_irqrestore(&tp->rx_lock, flags);
+
+	list_for_each_safe(cursor, next, &rx_queue) {
+		struct rx_desc *rx_desc;
+		struct rx_agg *agg, *agg_next;
+		int len_used = 0;
+		struct urb *urb;
+		u8 *rx_data;
+
+		list_del_init(cursor);
+
+		agg = list_entry(cursor, struct rx_agg, list);
+		urb = agg->urb;
+		if (urb->actual_length < ETH_ZLEN)
+			goto submit;
+
+		agg_next = rtl_get_free_rx(tp, GFP_ATOMIC);
+
+		rx_desc = agg->buffer;
+		rx_data = agg->buffer;
+		len_used += sizeof(struct rx_desc);
+
+		while (urb->actual_length > len_used) {
+			struct net_device *netdev = tp->netdev;
+			struct net_device_stats *stats;
+			unsigned int pkt_len, rx_frag_head_sz;
+			struct sk_buff *skb;
+
+			/* limite the skb numbers for rx_queue */
+			if (unlikely(skb_queue_len(&tp->rx_queue) >= 1000))
+				break;
+
+			pkt_len = le32_to_cpu(rx_desc->opts1) & RX_LEN_MASK;
+			if (pkt_len < ETH_ZLEN)
+				break;
+
+			len_used += pkt_len;
+			if (urb->actual_length < len_used)
+				break;
+
+			stats = rtl8152_get_stats(netdev);
+
+			pkt_len -= ETH_FCS_LEN;
+			rx_data += sizeof(struct rx_desc);
+
+			if (!agg_next || tp->rx_frag_head_sz > pkt_len)
+				rx_frag_head_sz = pkt_len;
+			else
+				rx_frag_head_sz = tp->rx_frag_head_sz;
+
+			skb = napi_alloc_skb(napi, rx_frag_head_sz);
+			if (!skb) {
+				stats->rx_dropped++;
+				goto find_next_rx;
+			}
+
+			skb->ip_summed = r8152_rx_csum(tp, rx_desc);
+			memcpy(skb->data, rx_data, rx_frag_head_sz);
+			skb_put(skb, rx_frag_head_sz);
+			pkt_len -= rx_frag_head_sz;
+			rx_data += rx_frag_head_sz;
+			if (pkt_len) {
+				skb_add_rx_frag(skb, 0, agg->page,
+						agg_offset(agg, rx_data),
+						pkt_len,
+						SKB_DATA_ALIGN(pkt_len));
+				get_page(agg->page);
+			}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+			skb->dev = netdev;
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22) */
+			skb->protocol = eth_type_trans(skb, netdev);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+			if (work_done < budget) {
+				if (!rtl_rx_vlan_tag(tp, rx_desc, skb))
+					napi_gro_receive(napi, skb);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+				netdev->last_rx = jiffies;
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29) */
+				work_done++;
+				stats->rx_packets++;
+				stats->rx_bytes += skb->len;
+			} else {
+				rtl_vlan_put_tag(tp, rx_desc, skb);
+				__skb_queue_tail(&tp->rx_queue, skb);
+			}
+#else
+			rtl_rx_vlan_tag(rx_desc, skb);
+			if (work_done < budget) {
+				napi_gro_receive(napi, skb);
+				work_done++;
+				stats->rx_packets++;
+				stats->rx_bytes += skb->len;
+			} else {
+				__skb_queue_tail(&tp->rx_queue, skb);
+			}
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0) */
+
+find_next_rx:
+			rx_data = rx_agg_align(rx_data + pkt_len + ETH_FCS_LEN);
+			rx_desc = (struct rx_desc *)rx_data;
+			len_used = agg_offset(agg, rx_data);
+			len_used += sizeof(struct rx_desc);
+		}
+
+		WARN_ON(!agg_next && page_count(agg->page) > 1);
+
+		if (agg_next) {
+			spin_lock_irqsave(&tp->rx_lock, flags);
+			if (page_count(agg->page) == 1) {
+				list_add(&agg_next->list, &tp->rx_used);
+			} else {
+				list_add_tail(&agg->list, &tp->rx_used);
+				agg = agg_next;
+				urb = agg->urb;
+			}
+			spin_unlock_irqrestore(&tp->rx_lock, flags);
+		}
+
+submit:
+		if (!ret) {
+			ret = r8152_submit_rx(tp, agg, GFP_ATOMIC);
+		} else {
+			urb->actual_length = 0;
+			list_add_tail(&agg->list, next);
+		}
+	}
+
+	if (!list_empty(&rx_queue)) {
+		spin_lock_irqsave(&tp->rx_lock, flags);
+		list_splice_tail(&rx_queue, &tp->rx_done);
+		spin_unlock_irqrestore(&tp->rx_lock, flags);
+	}
+
+out1:
+	return work_done;
+}
+
+static void tx_bottom(struct r8152 *tp)
+{
+	int res;
+
+	do {
+		struct tx_agg *agg;
+
+		if (skb_queue_empty(&tp->tx_queue))
+			break;
+
+		agg = r8152_get_tx_agg(tp);
+		if (!agg)
+			break;
+
+		if (tp->sg_use)
+			res = r8152_tx_agg_sg_fill(tp, agg);
+		else
+			res = r8152_tx_agg_fill(tp, agg);
+
+		if (res) {
+			struct net_device *netdev = tp->netdev;
+
+			if (res == -ENODEV) {
+				rtl_set_unplug(tp);
+				netif_device_detach(netdev);
+			} else {
+				struct net_device_stats *stats;
+				unsigned long flags;
+
+				stats = rtl8152_get_stats(netdev);
+				netif_warn(tp, tx_err, netdev,
+					   "failed tx_urb %d\n", res);
+				stats->tx_dropped += agg->skb_num;
+
+				spin_lock_irqsave(&tp->tx_lock, flags);
+				list_add_tail(&agg->list, &tp->tx_free);
+				spin_unlock_irqrestore(&tp->tx_lock, flags);
+			}
+		}
+	} while (res == 0);
+}
+
+static void bottom_half(unsigned long data)
+{
+	struct r8152 *tp;
+
+	tp = (struct r8152 *)data;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	if (!test_bit(WORK_ENABLE, &tp->flags))
+		return;
+
+	/* When link down, the driver would cancel all bulks. */
+	/* This avoid the re-submitting bulk */
+	if (!netif_carrier_ok(tp->netdev))
+		return;
+
+	clear_bit(SCHEDULE_TASKLET, &tp->flags);
+
+	if (tp->sg_use) {
+		tx_bottom(tp);
+	} else {
+		unsigned long flags;
+
+		local_irq_save(flags);
+		tx_bottom(tp);
+		local_irq_restore(flags);
+	}
+}
+
+static inline int __r8152_poll(struct r8152 *tp, int budget)
+{
+	struct napi_struct *napi = &tp->napi;
+	int work_done;
+
+	work_done = rx_bottom(tp, budget);
+
+	if (work_done < budget) {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,10,0)
+		napi_complete_done(napi, work_done);
+#else
+		if (!napi_complete_done(napi, work_done))
+			goto out;
+#endif
+		if (!list_empty(&tp->rx_done))
+			napi_schedule(napi);
+	}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,10,0)
+out:
+#endif
+	return work_done;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
+
+static int r8152_poll(struct net_device *dev, int *budget)
+{
+	struct r8152 *tp = netdev_priv(dev);
+	int quota = min(dev->quota, *budget);
+	int work_done;
+
+	work_done = __r8152_poll(tp, quota);
+
+	*budget -= work_done;
+	dev->quota -= work_done;
+
+	return (work_done >= quota);
+}
+
+#else
+
+static int r8152_poll(struct napi_struct *napi, int budget)
+{
+	struct r8152 *tp = container_of(napi, struct r8152, napi);
+
+	return __r8152_poll(tp, budget);
+}
+
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24) */
+
+static
+int r8152_submit_rx(struct r8152 *tp, struct rx_agg *agg, gfp_t mem_flags)
+{
+	int ret;
+
+	/* The rx would be stopped, so skip submitting */
+	if (test_bit(RTL8152_UNPLUG, &tp->flags) ||
+	    !test_bit(WORK_ENABLE, &tp->flags) || !netif_carrier_ok(tp->netdev))
+		return 0;
+
+	usb_fill_bulk_urb(agg->urb, tp->udev, usb_rcvbulkpipe(tp->udev, 1),
+			  agg->buffer, tp->rx_buf_sz,
+			  (usb_complete_t)read_bulk_callback, agg);
+
+	ret = usb_submit_urb(agg->urb, mem_flags);
+	if (ret == -ENODEV) {
+		rtl_set_unplug(tp);
+		netif_device_detach(tp->netdev);
+	} else if (ret) {
+		struct urb *urb = agg->urb;
+		unsigned long flags;
+
+		urb->actual_length = 0;
+		spin_lock_irqsave(&tp->rx_lock, flags);
+		list_add_tail(&agg->list, &tp->rx_done);
+		spin_unlock_irqrestore(&tp->rx_lock, flags);
+
+		netif_err(tp, rx_err, tp->netdev,
+			  "Couldn't submit rx[%p], ret = %d\n", agg, ret);
+
+		napi_schedule(&tp->napi);
+	}
+
+	return ret;
+}
+
+static void rtl_drop_queued_tx(struct r8152 *tp)
+{
+	struct net_device_stats *stats = rtl8152_get_stats(tp->netdev);
+	struct sk_buff_head skb_head, *tx_queue = &tp->tx_queue;
+	struct sk_buff *skb;
+
+	if (skb_queue_empty(tx_queue))
+		return;
+
+	__skb_queue_head_init(&skb_head);
+	spin_lock_bh(&tx_queue->lock);
+	skb_queue_splice_init(tx_queue, &skb_head);
+	spin_unlock_bh(&tx_queue->lock);
+
+	while ((skb = __skb_dequeue(&skb_head))) {
+		dev_kfree_skb(skb);
+		stats->tx_dropped++;
+	}
+}
+
+static void rtl8152_tx_timeout(struct net_device *netdev)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+	int i;
+#endif
+
+	netif_warn(tp, tx_err, netdev, "Tx timeout\n");
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+	for (i = 0; i < RTL8152_MAX_TX; i++)
+		usb_unlink_urb(tp->tx_info[i].urb);
+#else
+	usb_queue_reset_device(tp->intf);
+#endif
+}
+
+static void rtl8152_set_rx_mode(struct net_device *netdev)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+	u32 mc_filter[2];	/* Multicast hash filter */
+	__le32 tmp[2];
+	u32 ocp_data;
+
+	if (in_atomic()) {
+		if (netif_carrier_ok(netdev)) {
+			set_bit(RTL8152_SET_RX_MODE, &tp->flags);
+			schedule_delayed_work(&tp->schedule, 0);
+		}
+		return;
+	}
+
+	clear_bit(RTL8152_SET_RX_MODE, &tp->flags);
+
+	if (!netif_carrier_ok(netdev))
+		return;
+
+	netif_stop_queue(netdev);
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, PLA_RCR);
+	ocp_data &= ~RCR_ACPT_ALL;
+	ocp_data |= RCR_AB | RCR_APM;
+
+	if (netdev->flags & IFF_PROMISC) {
+		/* Unconditionally log net taps. */
+		netif_notice(tp, link, netdev, "Promiscuous mode enabled\n");
+		ocp_data |= RCR_AM | RCR_AAP;
+		mc_filter[1] = 0xffffffff;
+		mc_filter[0] = 0xffffffff;
+	} else if ((netdev_mc_count(netdev) > multicast_filter_limit) ||
+		   (netdev->flags & IFF_ALLMULTI)) {
+		/* Too many to filter perfectly -- accept all multicasts. */
+		ocp_data |= RCR_AM;
+		mc_filter[1] = 0xffffffff;
+		mc_filter[0] = 0xffffffff;
+	} else {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,35)
+		struct dev_mc_list *mclist;
+		unsigned int i;
+
+		mc_filter[1] = mc_filter[0] = 0;
+		for (i = 0, mclist = netdev->mc_list;
+		     mclist && i < netdev->mc_count;
+		     i++, mclist = mclist->next) {
+			int bit_nr;
+
+			bit_nr = ether_crc(ETH_ALEN, mclist->dmi_addr) >> 26;
+			mc_filter[bit_nr >> 5] |= 1 << (bit_nr & 31);
+			ocp_data |= RCR_AM;
+		}
+#else
+		struct netdev_hw_addr *ha;
+
+		mc_filter[1] = 0;
+		mc_filter[0] = 0;
+		netdev_for_each_mc_addr(ha, netdev) {
+			int bit_nr = ether_crc(ETH_ALEN, ha->addr) >> 26;
+
+			mc_filter[bit_nr >> 5] |= 1 << (bit_nr & 31);
+			ocp_data |= RCR_AM;
+		}
+#endif
+	}
+
+	tmp[0] = __cpu_to_le32(swab32(mc_filter[1]));
+	tmp[1] = __cpu_to_le32(swab32(mc_filter[0]));
+
+	pla_ocp_write(tp, PLA_MAR, BYTE_EN_DWORD, sizeof(tmp), tmp);
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, ocp_data);
+	netif_wake_queue(netdev);
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,18,4)
+
+static inline bool rtl_gso_check(struct net_device *dev, struct sk_buff *skb)
+{
+	struct r8152 *tp = netdev_priv(dev);
+
+	if (tp->sg_use)
+		return true;
+	else if ((skb->len + sizeof(struct tx_desc)) <= agg_buf_sz)
+		return true;
+	else
+		return false;
+}
+
+static netdev_features_t
+rtl8152_features_check(struct sk_buff *skb, struct net_device *dev,
+		       netdev_features_t features)
+{
+	u32 mss = skb_shinfo(skb)->gso_size;
+	int max_offset = mss ? GTTCPHO_MAX : TCPHO_MAX;
+	int offset = skb_transport_offset(skb);
+
+	if ((mss || skb->ip_summed == CHECKSUM_PARTIAL) && offset > max_offset)
+		features &= ~(NETIF_F_CSUM_MASK | NETIF_F_GSO_MASK);
+	else if (!rtl_gso_check(dev, skb))
+		features &= ~NETIF_F_GSO_MASK;
+
+	return features;
+}
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,18,4) */
+
+static netdev_tx_t rtl8152_start_xmit(struct sk_buff *skb,
+				      struct net_device *netdev)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,18,4)
+	if (unlikely(!rtl_gso_check(netdev, skb)) {
+		netdev_features_t features = netdev->features;
+		struct sk_buff *segs, *nskb;
+
+		features &= ~(NETIF_F_TSO | NETIF_F_TSO6);
+		segs = skb_gso_segment(skb, features);
+		if (IS_ERR(segs) || !segs)
+			goto free_skb;
+
+		do {
+			nskb = segs;
+			segs = segs->next;
+			nskb->next = NULL;
+			rtl8152_start_xmit(nskb, netdev);
+		} while (segs);
+
+free_skb:
+		dev_kfree_skb_any(skb);
+
+		return NETDEV_TX_OK;
+	}
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,31)
+	netdev->trans_start = jiffies
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,31) */
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,18,4) */
+
+	skb_tx_timestamp(skb);
+
+	skb_queue_tail(&tp->tx_queue, skb);
+
+	if (!list_empty(&tp->tx_free)) {
+		if (test_bit(SELECTIVE_SUSPEND, &tp->flags)) {
+			set_bit(SCHEDULE_TASKLET, &tp->flags);
+			schedule_delayed_work(&tp->schedule, 0);
+		} else {
+			usb_mark_last_busy(tp->udev);
+			tasklet_schedule(&tp->tx_tl);
+		}
+	} else if (skb_queue_len(&tp->tx_queue) > tp->tx_qlen) {
+		netif_stop_queue(netdev);
+	}
+
+	return NETDEV_TX_OK;
+}
+
+static void r8152b_reset_packet_filter(struct r8152 *tp)
+{
+	u32	ocp_data;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_FMC);
+	ocp_data &= ~FMC_FCR_MCU_EN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_FMC, ocp_data);
+	ocp_data |= FMC_FCR_MCU_EN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_FMC, ocp_data);
+}
+
+static void rtl8152_nic_reset(struct r8152 *tp)
+{
+	int	i;
+
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CR, CR_RST);
+
+	for (i = 0; i < 1000; i++) {
+		if (!(ocp_read_byte(tp, MCU_TYPE_PLA, PLA_CR) & CR_RST))
+			break;
+		usleep_range(100, 400);
+	}
+}
+
+static void set_tx_qlen(struct r8152 *tp)
+{
+	struct net_device *netdev = tp->netdev;
+
+	if (tp->sg_use)
+		tp->tx_qlen = RTL_MAX_SG_NUM;
+	else
+		tp->tx_qlen = agg_buf_sz / (netdev->mtu + VLAN_ETH_HLEN +
+					    ETH_FCS_LEN +
+					    sizeof(struct tx_desc));
+}
+
+static inline u16 rtl8152_get_speed(struct r8152 *tp)
+{
+	return ocp_read_word(tp, MCU_TYPE_PLA, PLA_PHYSTATUS);
+}
+
+static void rtl_set_eee_plus(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u16 speed;
+
+	speed = rtl8152_get_speed(tp);
+	if (speed & _10bps) {
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_EEEP_CR);
+		ocp_data |= EEEP_CR_EEEP_TX;
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_EEEP_CR, ocp_data);
+	} else {
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_EEEP_CR);
+		ocp_data &= ~EEEP_CR_EEEP_TX;
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_EEEP_CR, ocp_data);
+	}
+}
+
+static void rxdy_gated_en(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MISC_1);
+	if (enable)
+		ocp_data |= RXDY_GATED_EN;
+	else
+		ocp_data &= ~RXDY_GATED_EN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_MISC_1, ocp_data);
+}
+
+#if defined(RTL8152_S5_WOL) && defined(CONFIG_PM)
+static int rtl_s5_wol(struct r8152 *tp)
+{
+	struct usb_device *udev = tp->udev;
+
+	if (!tp->saved_wolopts)
+		return 0;
+
+	/* usb_enable_remote_wakeup */
+	if (udev->speed < USB_SPEED_SUPER)
+		return usb_control_msg(udev, usb_sndctrlpipe(udev, 0),
+				USB_REQ_SET_FEATURE, USB_RECIP_DEVICE,
+				USB_DEVICE_REMOTE_WAKEUP, 0, NULL, 0,
+				USB_CTRL_SET_TIMEOUT);
+	else
+		return usb_control_msg(udev, usb_sndctrlpipe(udev, 0),
+				USB_REQ_SET_FEATURE, USB_RECIP_INTERFACE,
+				USB_INTRF_FUNC_SUSPEND,
+				USB_INTRF_FUNC_SUSPEND_RW |
+					USB_INTRF_FUNC_SUSPEND_LP,
+				NULL, 0, USB_CTRL_SET_TIMEOUT);
+}
+#endif
+
+static int rtl_start_rx(struct r8152 *tp)
+{
+	struct list_head *cursor, *next, tmp_list;
+	unsigned long flags;
+	int ret = 0, i = 0;
+
+	INIT_LIST_HEAD(&tmp_list);
+
+	spin_lock_irqsave(&tp->rx_lock, flags);
+
+	INIT_LIST_HEAD(&tp->rx_done);
+	INIT_LIST_HEAD(&tp->rx_used);
+
+	list_splice_init(&tp->rx_info, &tmp_list);
+
+	spin_unlock_irqrestore(&tp->rx_lock, flags);
+
+	list_for_each_safe(cursor, next, &tmp_list) {
+		struct rx_agg *agg;
+
+		agg = list_entry(cursor, struct rx_agg, info_list);
+		INIT_LIST_HEAD(&agg->list);
+
+		/* Only RTL8152_MAX_RX rx_agg need to be submitted. */
+		if (++i > RTL8152_MAX_RX) {
+			spin_lock_irqsave(&tp->rx_lock, flags);
+			list_add_tail(&agg->list, &tp->rx_used);
+			spin_unlock_irqrestore(&tp->rx_lock, flags);
+		} else if (unlikely(ret < 0)) {
+			spin_lock_irqsave(&tp->rx_lock, flags);
+			list_add_tail(&agg->list, &tp->rx_done);
+			spin_unlock_irqrestore(&tp->rx_lock, flags);
+		} else {
+			ret = r8152_submit_rx(tp, agg, GFP_KERNEL);
+		}
+	}
+
+	spin_lock_irqsave(&tp->rx_lock, flags);
+	WARN_ON(unlikely(!list_empty(&tp->rx_info)));
+	list_splice(&tmp_list, &tp->rx_info);
+	spin_unlock_irqrestore(&tp->rx_lock, flags);
+
+	return ret;
+}
+
+static int rtl_stop_rx(struct r8152 *tp)
+{
+	struct list_head *cursor, *next, tmp_list;
+	unsigned long flags;
+
+	INIT_LIST_HEAD(&tmp_list);
+
+	/* The usb_kill_urb() couldn't be used in atomic.
+	 * Therefore, move the list of rx_info to a tmp one.
+	 * Then, list_for_each_safe could be used without
+	 * spin lock.
+	 */
+
+	spin_lock_irqsave(&tp->rx_lock, flags);
+	list_splice_init(&tp->rx_info, &tmp_list);
+	spin_unlock_irqrestore(&tp->rx_lock, flags);
+
+	list_for_each_safe(cursor, next, &tmp_list) {
+		struct rx_agg *agg;
+
+		agg = list_entry(cursor, struct rx_agg, info_list);
+
+		/* At least RTL8152_MAX_RX rx_agg have the page_count being
+		 * equal to 1, so the other ones could be freed safely.
+		 */
+		if (page_count(agg->page) > 1)
+			free_rx_agg(tp, agg);
+		else
+			usb_kill_urb(agg->urb);
+	}
+
+	/* Move back the list of temp to the rx_info */
+	spin_lock_irqsave(&tp->rx_lock, flags);
+	WARN_ON(unlikely(!list_empty(&tp->rx_info)));
+	list_splice(&tmp_list, &tp->rx_info);
+	spin_unlock_irqrestore(&tp->rx_lock, flags);
+
+	while (!skb_queue_empty(&tp->rx_queue))
+		dev_kfree_skb(__skb_dequeue(&tp->rx_queue));
+
+	return 0;
+}
+
+static inline void r8153b_rx_agg_chg_indicate(struct r8152 *tp)
+{
+	ocp_write_byte(tp, MCU_TYPE_USB, USB_UPT_RXDMA_OWN,
+		       OWN_UPDATE | OWN_CLEAR);
+}
+
+static int rtl_enable(struct r8152 *tp)
+{
+	u32 ocp_data;
+
+	r8152b_reset_packet_filter(tp);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_CR);
+	ocp_data |= CR_RE | CR_TE;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CR, ocp_data);
+
+	switch (tp->version) {
+	case RTL_VER_08:
+	case RTL_VER_09:
+		r8153b_rx_agg_chg_indicate(tp);
+		break;
+	default:
+		break;
+	}
+
+	rxdy_gated_en(tp, false);
+
+	return 0;
+}
+
+static int rtl8152_enable(struct r8152 *tp)
+{
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return -ENODEV;
+
+	set_tx_qlen(tp);
+	rtl_set_eee_plus(tp);
+
+	return rtl_enable(tp);
+}
+
+static void r8153_set_rx_early_timeout(struct r8152 *tp)
+{
+	u32 ocp_data = tp->coalesce / 8;
+
+	switch (tp->version) {
+	case RTL_VER_03:
+	case RTL_VER_04:
+	case RTL_VER_05:
+	case RTL_VER_06:
+		ocp_write_word(tp, MCU_TYPE_USB, USB_RX_EARLY_TIMEOUT,
+			       ocp_data);
+		break;
+
+	case RTL_VER_08:
+	case RTL_VER_09:
+		/* The RTL8153B uses USB_RX_EXTRA_AGGR_TMR for rx timeout
+		 * primarily. For USB_RX_EARLY_TIMEOUT, we fix it to 1264ns.
+		 */
+		ocp_write_word(tp, MCU_TYPE_USB, USB_RX_EARLY_TIMEOUT,
+			       1264 / 8);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_RX_EXTRA_AGGR_TMR,
+			       ocp_data);
+		break;
+
+	case RTL_TEST_01:
+	case RTL_VER_10:
+	case RTL_VER_11:
+		ocp_write_word(tp, MCU_TYPE_USB, USB_RX_EARLY_TIMEOUT,
+			       640 / 8);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_RX_EXTRA_AGGR_TMR,
+			       ocp_data);
+		r8153b_rx_agg_chg_indicate(tp);
+		break;
+
+	default:
+		break;
+	}
+}
+
+static void r8153_set_rx_early_size(struct r8152 *tp)
+{
+	u32 ocp_data = tp->rx_buf_sz - rx_reserved_size(tp->netdev->mtu);
+
+	switch (tp->version) {
+	case RTL_VER_03:
+	case RTL_VER_04:
+	case RTL_VER_05:
+	case RTL_VER_06:
+		ocp_write_word(tp, MCU_TYPE_USB, USB_RX_EARLY_SIZE,
+			       ocp_data / 4);
+		break;
+	case RTL_VER_08:
+	case RTL_VER_09:
+		ocp_write_word(tp, MCU_TYPE_USB, USB_RX_EARLY_SIZE,
+			       ocp_data / 8);
+		break;
+	case RTL_TEST_01:
+	case RTL_VER_10:
+	case RTL_VER_11:
+		ocp_write_word(tp, MCU_TYPE_USB, USB_RX_EARLY_SIZE,
+			       ocp_data / 8);
+		r8153b_rx_agg_chg_indicate(tp);
+		break;
+	default:
+		WARN_ON_ONCE(1);
+		break;
+	}
+}
+
+static int rtl8153_enable(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u16 speed;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return -ENODEV;
+
+	set_tx_qlen(tp);
+	rtl_set_eee_plus(tp);
+	r8153_set_rx_early_timeout(tp);
+	r8153_set_rx_early_size(tp);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_TCR1);
+	ocp_data &= ~(BIT(3) | BIT(9) | BIT(8));
+	speed = rtl8152_get_speed(tp);
+	if ((speed & (_10bps | _100bps)) && !(speed & FULL_DUP)) {
+		ocp_data |= BIT(9);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_TCR1, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4);
+		ocp_data &= ~BIT(8);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4, ocp_data);
+	} else {
+		ocp_data |= BIT(9) | BIT(8);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_TCR1, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4);
+		ocp_data |= BIT(8);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4, ocp_data);
+	}
+
+	if (tp->version == RTL_VER_09) {
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xd4e8);
+		ocp_data &= ~BIT(1);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xd4e8, ocp_data);
+		usleep_range(1000, 2000);
+		ocp_data |= BIT(1);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xd4e8, ocp_data);
+	}
+
+	return rtl_enable(tp);
+}
+
+static void rtl_disable(struct r8152 *tp)
+{
+	u32 ocp_data;
+	int i;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags)) {
+		rtl_drop_queued_tx(tp);
+		return;
+	}
+
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, PLA_RCR);
+	ocp_data &= ~RCR_ACPT_ALL;
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, ocp_data);
+
+	rtl_drop_queued_tx(tp);
+
+	for (i = 0; i < RTL8152_MAX_TX; i++)
+		usb_kill_urb(tp->tx_info[i].urb);
+
+	rxdy_gated_en(tp, true);
+
+	for (i = 0; i < 1000; i++) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+		if ((ocp_data & FIFO_EMPTY) == FIFO_EMPTY)
+			break;
+		usleep_range(1000, 2000);
+	}
+
+	for (i = 0; i < 1000; i++) {
+		if (ocp_read_word(tp, MCU_TYPE_PLA, PLA_TCR0) & TCR0_TX_EMPTY)
+			break;
+		usleep_range(1000, 2000);
+	}
+
+	rtl_stop_rx(tp);
+
+	switch (tp->version) {
+	case RTL_VER_01:
+	case RTL_VER_02:
+	case RTL_VER_03:
+	case RTL_VER_04:
+	case RTL_VER_05:
+	case RTL_VER_06:
+	case RTL_VER_07:
+	case RTL_VER_08:
+	case RTL_VER_09:
+		rtl8152_nic_reset(tp);
+		break;
+
+	case RTL_TEST_01:
+	case RTL_VER_10:
+	case RTL_VER_11:
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_CR);
+		ocp_data &= ~CR_TE;
+		ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CR, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xd4b0);
+		ocp_data &= ~BIT(0);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xd4b0, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xd406);
+		ocp_data |= BIT(3);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xd406, ocp_data);
+
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_CR);
+		ocp_data &= ~CR_RE;
+		ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CR, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xd4b0);
+		ocp_data |= BIT(0);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xd4b0, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xd406);
+		ocp_data &= ~BIT(3);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xd406, ocp_data);
+		break;
+
+	default:
+		ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CR, 0);
+		break;
+	}
+}
+
+static void r8152_power_cut_en(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_UPS_CTRL);
+	if (enable)
+		ocp_data |= POWER_CUT;
+	else
+		ocp_data &= ~POWER_CUT;
+	ocp_write_word(tp, MCU_TYPE_USB, USB_UPS_CTRL, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_PM_CTRL_STATUS);
+	ocp_data &= ~RESUME_INDICATE;
+	ocp_write_word(tp, MCU_TYPE_USB, USB_PM_CTRL_STATUS, ocp_data);
+}
+
+static void rtl_rx_vlan_en(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data;
+
+	switch (tp->version) {
+	case RTL_VER_01:
+	case RTL_VER_02:
+	case RTL_VER_03:
+	case RTL_VER_04:
+	case RTL_VER_05:
+	case RTL_VER_06:
+	case RTL_VER_07:
+	case RTL_VER_08:
+	case RTL_VER_09:
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_CPCR);
+		if (enable)
+			ocp_data |= CPCR_RX_VLAN;
+		else
+			ocp_data &= ~CPCR_RX_VLAN;
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_CPCR, ocp_data);
+		break;
+
+	case RTL_TEST_01:
+	case RTL_VER_10:
+	case RTL_VER_11:
+	default:
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, 0xc012);
+		if (enable)
+			ocp_data |= BIT(7) | BIT(6);
+		else
+			ocp_data &= ~(BIT(7) | BIT(6));
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_CPCR, ocp_data);
+		break;
+	}
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+
+static void
+rtl8152_vlan_rx_register(struct net_device *dev, struct vlan_group *grp)
+{
+	struct r8152 *tp = netdev_priv(dev);
+
+	if (unlikely(tp->rtk_enable_diag))
+		return;
+
+	if (usb_autopm_get_interface(tp->intf) < 0)
+		return;
+
+	mutex_lock(&tp->control);
+
+	tp->vlgrp = grp;
+	if (tp->vlgrp)
+		rtl_rx_vlan_en(tp, true);
+	else
+		rtl_rx_vlan_en(tp, false);
+
+	mutex_unlock(&tp->control);
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+
+static void rtl8152_vlan_rx_kill_vid(struct net_device *dev, unsigned short vid)
+{
+	struct r8152 *tp = netdev_priv(dev);
+
+	vlan_group_set_device(tp->vlgrp, vid, NULL);
+}
+
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22) */
+
+#else
+
+static int rtl8152_set_features(struct net_device *dev,
+				netdev_features_t features)
+{
+	netdev_features_t changed = features ^ dev->features;
+	struct r8152 *tp = netdev_priv(dev);
+	int ret;
+
+	if (unlikely(tp->rtk_enable_diag))
+		return -EBUSY;
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		goto out;
+
+	mutex_lock(&tp->control);
+
+	if (changed & NETIF_F_HW_VLAN_CTAG_RX) {
+		if (features & NETIF_F_HW_VLAN_CTAG_RX)
+			rtl_rx_vlan_en(tp, true);
+		else
+			rtl_rx_vlan_en(tp, false);
+	}
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+out:
+	return ret;
+}
+
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0) */
+
+#define WAKE_ANY (WAKE_PHY | WAKE_MAGIC | WAKE_UCAST | WAKE_BCAST | WAKE_MCAST)
+
+static u32 __rtl_get_wol(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u32 wolopts = 0;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_CONFIG34);
+	if (ocp_data & LINK_ON_WAKE_EN)
+		wolopts |= WAKE_PHY;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_CONFIG5);
+	if (ocp_data & UWF_EN)
+		wolopts |= WAKE_UCAST;
+	if (ocp_data & BWF_EN)
+		wolopts |= WAKE_BCAST;
+	if (ocp_data & MWF_EN)
+		wolopts |= WAKE_MCAST;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_CFG_WOL);
+	if (ocp_data & MAGIC_EN)
+		wolopts |= WAKE_MAGIC;
+
+	return wolopts;
+}
+
+static void __rtl_set_wol(struct r8152 *tp, u32 wolopts)
+{
+	u32 ocp_data;
+
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CRWECR, CRWECR_CONFIG);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_CONFIG34);
+	ocp_data &= ~LINK_ON_WAKE_EN;
+	if (wolopts & WAKE_PHY)
+		ocp_data |= LINK_ON_WAKE_EN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_CONFIG34, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_CONFIG5);
+	ocp_data &= ~(UWF_EN | BWF_EN | MWF_EN);
+	if (wolopts & WAKE_UCAST)
+		ocp_data |= UWF_EN;
+	if (wolopts & WAKE_BCAST)
+		ocp_data |= BWF_EN;
+	if (wolopts & WAKE_MCAST)
+		ocp_data |= MWF_EN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_CONFIG5, ocp_data);
+
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CRWECR, CRWECR_NORAML);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_CFG_WOL);
+	ocp_data &= ~MAGIC_EN;
+	if (wolopts & WAKE_MAGIC)
+		ocp_data |= MAGIC_EN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_CFG_WOL, ocp_data);
+
+	if (wolopts & WAKE_ANY)
+		device_set_wakeup_enable(&tp->udev->dev, true);
+	else
+		device_set_wakeup_enable(&tp->udev->dev, false);
+}
+
+static void r8153_mac_clk_spd(struct r8152 *tp, bool enable)
+{
+	/* MAC clock speed down */
+	if (enable) {
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL,
+			       ALDPS_SPDWN_RATIO);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL2,
+			       EEE_SPDWN_RATIO);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3,
+			       PKT_AVAIL_SPDWN_EN | SUSPEND_SPDWN_EN |
+			       U1U2_SPDWN_EN | L1_SPDWN_EN);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4,
+			       PWRSAVE_SPDWN_EN | RXDV_SPDWN_EN | TX10MIDLE_EN |
+			       TP100_SPDWN_EN | TP500_SPDWN_EN | EEE_SPDWN_EN |
+			       TP1000_SPDWN_EN);
+	} else {
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL, 0);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL2, 0);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3, 0);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4, 0);
+	}
+}
+
+static void r8156_mac_clk_spd(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data;
+
+	/* MAC clock speed down */
+	if (enable) {
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL,
+			       0x0403);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL2);
+		ocp_data &= ~0xff;
+		ocp_data |= MAC_CLK_SPDWN_EN | 0x03;
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL2, ocp_data);
+	} else {
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL2);
+		ocp_data &= ~MAC_CLK_SPDWN_EN;
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL2, ocp_data);
+	}
+}
+
+static void r8153_u1u2en(struct r8152 *tp, bool enable)
+{
+	u8 u1u2[8];
+
+	if (enable)
+		memset(u1u2, 0xff, sizeof(u1u2));
+	else
+		memset(u1u2, 0x00, sizeof(u1u2));
+
+	usb_ocp_write(tp, USB_TOLERANCE, BYTE_EN_SIX_BYTES, sizeof(u1u2), u1u2);
+}
+
+static void r8153b_u1u2en(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_LPM_CONFIG);
+	if (enable)
+		ocp_data |= LPM_U1U2_EN;
+	else
+		ocp_data &= ~LPM_U1U2_EN;
+
+	ocp_write_word(tp, MCU_TYPE_USB, USB_LPM_CONFIG, ocp_data);
+}
+
+static void r8153_u2p3en(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_U2P3_CTRL);
+	if (enable)
+		ocp_data |= U2P3_ENABLE;
+	else
+		ocp_data &= ~U2P3_ENABLE;
+	ocp_write_word(tp, MCU_TYPE_USB, USB_U2P3_CTRL, ocp_data);
+}
+
+static void r8153b_ups_flags(struct r8152 *tp)
+{
+	u32 ups_flags = 0;
+
+	if (tp->ups_info.green)
+		ups_flags |= UPS_FLAGS_EN_GREEN;
+
+	if (tp->ups_info.aldps)
+		ups_flags |= UPS_FLAGS_EN_ALDPS;
+
+	if (tp->ups_info.eee)
+		ups_flags |= UPS_FLAGS_EN_EEE;
+
+	if (tp->ups_info.flow_control)
+		ups_flags |= UPS_FLAGS_EN_FLOW_CTR;
+
+	if (tp->ups_info.eee_ckdiv)
+		ups_flags |= UPS_FLAGS_EN_EEE_CKDIV;
+
+	if (tp->ups_info.eee_cmod_lv)
+		ups_flags |= UPS_FLAGS_EEE_CMOD_LV_EN;
+
+	if (tp->ups_info._10m_ckdiv)
+		ups_flags |= UPS_FLAGS_EN_10M_CKDIV;
+
+	if (tp->ups_info.eee_plloff_100)
+		ups_flags |= UPS_FLAGS_EEE_PLLOFF_100;
+
+	if (tp->ups_info.eee_plloff_giga)
+		ups_flags |= UPS_FLAGS_EEE_PLLOFF_GIGA;
+
+	if (tp->ups_info._250m_ckdiv)
+		ups_flags |= UPS_FLAGS_250M_CKDIV;
+
+	if (tp->ups_info.ctap_short_off)
+		ups_flags |= UPS_FLAGS_CTAP_SHORT_DIS;
+
+	switch (tp->ups_info.speed_duplex) {
+	case NWAY_10M_HALF:
+		ups_flags |= 1 << 16;
+		break;
+	case NWAY_10M_FULL:
+		ups_flags |= 2 << 16;
+		break;
+	case NWAY_100M_HALF:
+		ups_flags |= 3 << 16;
+		break;
+	case NWAY_100M_FULL:
+		ups_flags |= 4 << 16;
+		break;
+	case NWAY_1000M_FULL:
+		ups_flags |= 5 << 16;
+		break;
+	case FORCE_10M_HALF:
+		ups_flags |= 6 << 16;
+		break;
+	case FORCE_10M_FULL:
+		ups_flags |= 7 << 16;
+		break;
+	case FORCE_100M_HALF:
+		ups_flags |= 8 << 16;
+		break;
+	case FORCE_100M_FULL:
+		ups_flags |= 9 << 16;
+		break;
+	default:
+		break;
+	}
+
+	ocp_write_dword(tp, MCU_TYPE_USB, USB_UPS_FLAGS, ups_flags);
+}
+
+static void r8156_ups_flags(struct r8152 *tp)
+{
+	u32 ups_flags = 0;
+
+	if (tp->ups_info.green)
+		ups_flags |= UPS_FLAGS_EN_GREEN;
+
+	if (tp->ups_info.aldps)
+		ups_flags |= UPS_FLAGS_EN_ALDPS;
+
+	if (tp->ups_info.eee)
+		ups_flags |= UPS_FLAGS_EN_EEE;
+
+	if (tp->ups_info.flow_control)
+		ups_flags |= UPS_FLAGS_EN_FLOW_CTR;
+
+	if (tp->ups_info.eee_ckdiv)
+		ups_flags |= UPS_FLAGS_EN_EEE_CKDIV;
+
+	if (tp->ups_info._10m_ckdiv)
+		ups_flags |= UPS_FLAGS_EN_10M_CKDIV;
+
+	if (tp->ups_info.eee_plloff_100)
+		ups_flags |= UPS_FLAGS_EEE_PLLOFF_100;
+
+	if (tp->ups_info.eee_plloff_giga)
+		ups_flags |= UPS_FLAGS_EEE_PLLOFF_GIGA;
+
+	if (tp->ups_info._250m_ckdiv)
+		ups_flags |= UPS_FLAGS_250M_CKDIV;
+
+	switch (tp->ups_info.speed_duplex) {
+	case FORCE_10M_HALF:
+		ups_flags |= 0 << 16;
+		break;
+	case FORCE_10M_FULL:
+		ups_flags |= 1 << 16;
+		break;
+	case FORCE_100M_HALF:
+		ups_flags |= 2 << 16;
+		break;
+	case FORCE_100M_FULL:
+		ups_flags |= 3 << 16;
+		break;
+	case NWAY_10M_HALF:
+		ups_flags |= 4 << 16;
+		break;
+	case NWAY_10M_FULL:
+		ups_flags |= 5 << 16;
+		break;
+	case NWAY_100M_HALF:
+		ups_flags |= 6 << 16;
+		break;
+	case NWAY_100M_FULL:
+		ups_flags |= 7 << 16;
+		break;
+	case NWAY_1000M_FULL:
+		ups_flags |= 8 << 16;
+		break;
+	case NWAY_2500M_FULL:
+		ups_flags |= 9 << 16;
+		break;
+	default:
+		break;
+	}
+
+	switch (tp->ups_info.lite_mode) {
+	case 0:
+		ups_flags |= 1 << 5;
+		break;
+	case 1:
+		ups_flags |= 0 << 5;
+		break;
+	case 2:
+	default:
+		ups_flags |= 2 << 5;
+		break;
+	}
+
+	ocp_write_dword(tp, MCU_TYPE_USB, USB_UPS_FLAGS, ups_flags);
+}
+
+static void r8153b_green_en(struct r8152 *tp, bool enable)
+{
+	u16 data;
+
+	if (enable) {
+		sram_write(tp, 0x8045, 0);	/* 10M abiq&ldvbias */
+		sram_write(tp, 0x804d, 0x1222);	/* 100M short abiq&ldvbias */
+		sram_write(tp, 0x805d, 0x0022);	/* 1000M short abiq&ldvbias */
+	} else {
+		sram_write(tp, 0x8045, 0x2444);	/* 10M abiq&ldvbias */
+		sram_write(tp, 0x804d, 0x2444);	/* 100M short abiq&ldvbias */
+		sram_write(tp, 0x805d, 0x2444);	/* 1000M short abiq&ldvbias */
+	}
+
+	data = sram_read(tp, SRAM_GREEN_CFG);
+	data |= GREEN_ETH_EN;
+	sram_write(tp, SRAM_GREEN_CFG, data);
+
+	tp->ups_info.green = enable;
+}
+
+static u16 r8153_phy_status(struct r8152 *tp, u16 desired)
+{
+	u16 data;
+	int i;
+
+	for (i = 0; i < 500; i++) {
+		data = ocp_reg_read(tp, OCP_PHY_STATUS);
+		data &= PHY_STAT_MASK;
+		if (desired) {
+			if (data == desired)
+				break;
+		} else if (data == PHY_STAT_LAN_ON || data == PHY_STAT_PWRDN ||
+			   data == PHY_STAT_EXT_INIT) {
+			break;
+		}
+
+		msleep(20);
+	}
+
+	return data;
+}
+
+static void r8153b_ups_en(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, USB_POWER_CUT);
+
+	if (enable) {
+		r8153b_ups_flags(tp);
+
+		ocp_data |= UPS_EN | USP_PREWAKE | PHASE2_EN;
+		ocp_write_byte(tp, MCU_TYPE_USB, USB_POWER_CUT, ocp_data);
+
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, 0xcfff);
+		ocp_data |= BIT(0);
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xcfff, ocp_data);
+	} else {
+		bool pcut_enter;
+		u16 data;
+		int i;
+
+		ocp_data &= ~(UPS_EN | USP_PREWAKE);
+		ocp_write_byte(tp, MCU_TYPE_USB, USB_POWER_CUT, ocp_data);
+
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, 0xcfff);
+		ocp_data &= ~BIT(0);
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xcfff, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_MISC_0);
+		pcut_enter = !!(ocp_data & PCUT_STATUS);
+		ocp_data &= ~PCUT_STATUS;
+		ocp_write_word(tp, MCU_TYPE_USB, USB_MISC_0, ocp_data);
+
+		for (i = 0; pcut_enter && i < 500; i++) {
+			if (ocp_read_word(tp, MCU_TYPE_PLA, PLA_BOOT_CTRL) &
+			    AUTOLOAD_DONE)
+				break;
+			msleep(20);
+		}
+
+		data = r8153_phy_status(tp, 0);
+
+		switch (data) {
+		case PHY_STAT_PWRDN:
+		case PHY_STAT_EXT_INIT:
+			tp->rtl_ops.hw_phy_cfg(tp);
+
+			data = r8152_mdio_read(tp, MII_BMCR);
+			data &= ~BMCR_PDOWN;
+			r8152_mdio_write(tp, MII_BMCR, data);
+
+			data = r8153_phy_status(tp, PHY_STAT_LAN_ON);
+
+		default:
+			if (data != PHY_STAT_LAN_ON)
+				netif_warn(tp, link, tp->netdev,
+					   "PHY not ready");
+
+			if (!pcut_enter)
+				break;
+
+			rtl8152_set_speed(tp, tp->autoneg, tp->speed,
+					  tp->duplex, tp->advertising);
+			break;
+		}
+	}
+}
+
+static void r8156_ups_en(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, USB_POWER_CUT);
+
+	if (enable) {
+		r8156_ups_flags(tp);
+
+		ocp_data |= UPS_EN | USP_PREWAKE | PHASE2_EN;
+		ocp_write_byte(tp, MCU_TYPE_USB, USB_POWER_CUT, ocp_data);
+
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, 0xcfff);
+		ocp_data |= BIT(0);
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xcfff, ocp_data);
+	} else {
+		ocp_data &= ~(UPS_EN | USP_PREWAKE);
+		ocp_write_byte(tp, MCU_TYPE_USB, USB_POWER_CUT, ocp_data);
+
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, 0xcfff);
+		ocp_data &= ~BIT(0);
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xcfff, ocp_data);
+
+//		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xd32a);
+//		ocp_data &= ~(BIT(8) | BIT(9));
+//		ocp_write_word(tp, MCU_TYPE_USB, 0xd32a, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_MISC_0);
+		if (ocp_data & PCUT_STATUS)
+			tp->rtl_ops.hw_phy_cfg(tp);
+	}
+}
+
+static void r8153_power_cut_en(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_POWER_CUT);
+	if (enable)
+		ocp_data |= PWR_EN | PHASE2_EN;
+	else
+		ocp_data &= ~(PWR_EN | PHASE2_EN);
+	ocp_write_word(tp, MCU_TYPE_USB, USB_POWER_CUT, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_MISC_0);
+	ocp_data &= ~PCUT_STATUS;
+	ocp_write_word(tp, MCU_TYPE_USB, USB_MISC_0, ocp_data);
+}
+
+static void r8153b_power_cut_en(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_POWER_CUT);
+	if (enable)
+		ocp_data |= PWR_EN | PHASE2_EN;
+	else
+		ocp_data &= ~PWR_EN;
+	ocp_write_word(tp, MCU_TYPE_USB, USB_POWER_CUT, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_MISC_0);
+	ocp_data &= ~PCUT_STATUS;
+	ocp_write_word(tp, MCU_TYPE_USB, USB_MISC_0, ocp_data);
+}
+
+static void r8153_queue_wake(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data;
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_INDICATE_FALG);
+	if (enable)
+		ocp_data |= UPCOMING_RUNTIME_D3;
+	else
+		ocp_data &= ~UPCOMING_RUNTIME_D3;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_INDICATE_FALG, ocp_data);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_SUSPEND_FLAG);
+	ocp_data &= ~LINK_CHG_EVENT;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_SUSPEND_FLAG, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_EXTRA_STATUS);
+	ocp_data &= ~LINK_CHANGE_FLAG;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_EXTRA_STATUS, ocp_data);
+}
+
+static bool rtl_can_wakeup(struct r8152 *tp)
+{
+	struct usb_device *udev = tp->udev;
+
+	return (udev->actconfig->desc.bmAttributes & USB_CONFIG_ATT_WAKEUP);
+}
+
+static void rtl_runtime_suspend_enable(struct r8152 *tp, bool enable)
+{
+	if (enable) {
+		u32 ocp_data;
+
+		__rtl_set_wol(tp, WAKE_ANY);
+
+		ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CRWECR, CRWECR_CONFIG);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_CONFIG34);
+		ocp_data |= LINK_OFF_WAKE_EN;
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_CONFIG34, ocp_data);
+
+		ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CRWECR, CRWECR_NORAML);
+	} else {
+		u32 ocp_data;
+
+		__rtl_set_wol(tp, tp->saved_wolopts);
+
+		ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CRWECR, CRWECR_CONFIG);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_CONFIG34);
+		ocp_data &= ~LINK_OFF_WAKE_EN;
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_CONFIG34, ocp_data);
+
+		ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CRWECR, CRWECR_NORAML);
+	}
+}
+
+static void rtl8153_runtime_enable(struct r8152 *tp, bool enable)
+{
+	if (enable) {
+		if (tp->version == RTL_VER_06)
+			r8153_queue_wake(tp, true);
+		r8153_u1u2en(tp, false);
+		r8153_u2p3en(tp, false);
+		r8153_mac_clk_spd(tp, true);
+		rtl_runtime_suspend_enable(tp, true);
+	} else {
+		if (tp->version == RTL_VER_06)
+			r8153_queue_wake(tp, false);
+		rtl_runtime_suspend_enable(tp, false);
+		r8153_mac_clk_spd(tp, false);
+
+		switch (tp->version) {
+		case RTL_VER_03:
+		case RTL_VER_04:
+			break;
+		case RTL_VER_05:
+		case RTL_VER_06:
+		default:
+			r8153_u2p3en(tp, true);
+			break;
+		}
+
+		r8153_u1u2en(tp, true);
+	}
+}
+
+static void rtl8153b_runtime_enable(struct r8152 *tp, bool enable)
+{
+	if (enable) {
+		r8153_queue_wake(tp, true);
+		r8153b_u1u2en(tp, false);
+		r8153_u2p3en(tp, false);
+		rtl_runtime_suspend_enable(tp, true);
+		r8153b_ups_en(tp, true);
+	} else {
+		r8153b_ups_en(tp, false);
+		r8153_queue_wake(tp, false);
+		rtl_runtime_suspend_enable(tp, false);
+//		r8153_u2p3en(tp, true);
+		r8153b_u1u2en(tp, true);
+	}
+}
+
+static void rtl8156_runtime_enable(struct r8152 *tp, bool enable)
+{
+	if (enable) {
+		r8153_queue_wake(tp, true);
+		r8153b_u1u2en(tp, false);
+		r8153_u2p3en(tp, false);
+		rtl_runtime_suspend_enable(tp, true);
+//		if (tp->version != RTL_VER_10 ||
+//		    tp->udev->speed == USB_SPEED_HIGH)
+//			r8156_ups_en(tp, true);
+	} else {
+		r8156_ups_en(tp, false);
+		r8153_queue_wake(tp, false);
+		rtl_runtime_suspend_enable(tp, false);
+		r8153_u2p3en(tp, true);
+		r8153b_u1u2en(tp, true);
+	}
+}
+
+static int rtl_nway_restart(struct r8152 *tp)
+{
+	int r = -EINVAL;
+	int bmcr;
+
+	/* if autoneg is off, it's an error */
+	bmcr = r8152_mdio_read(tp, MII_BMCR);
+
+	if (bmcr & BMCR_ANENABLE) {
+		bmcr |= BMCR_ANRESTART;
+		r8152_mdio_write(tp, MII_BMCR, bmcr);
+		r = 0;
+	}
+
+	return r;
+}
+
+static void r8153_teredo_off(struct r8152 *tp)
+{
+	u32 ocp_data;
+
+	switch (tp->version) {
+	case RTL_VER_01:
+	case RTL_VER_02:
+	case RTL_VER_03:
+	case RTL_VER_04:
+	case RTL_VER_05:
+	case RTL_VER_06:
+	case RTL_VER_07:
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_TEREDO_CFG);
+		ocp_data &= ~(TEREDO_SEL | TEREDO_RS_EVENT_MASK |
+			      OOB_TEREDO_EN);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_TEREDO_CFG, ocp_data);
+		break;
+
+	case RTL_VER_08:
+	case RTL_VER_09:
+	case RTL_TEST_01:
+	case RTL_VER_10:
+	case RTL_VER_11:
+		/* The bit 0 ~ 7 are relative with teredo settings. They are
+		 * W1C (write 1 to clear), so set all 1 to disable it.
+		 */
+		ocp_write_byte(tp, MCU_TYPE_PLA, PLA_TEREDO_CFG, 0xff);
+		break;
+
+	default:
+		break;
+	}
+
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_WDT6_CTRL, WDT6_SET_MODE);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_REALWOW_TIMER, 0);
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_TEREDO_TIMER, 0);
+}
+
+static void rtl_reset_bmu(struct r8152 *tp)
+{
+	u32 ocp_data;
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, USB_BMU_RESET);
+	ocp_data &= ~(BMU_RESET_EP_IN | BMU_RESET_EP_OUT);
+	ocp_write_byte(tp, MCU_TYPE_USB, USB_BMU_RESET, ocp_data);
+	ocp_data |= BMU_RESET_EP_IN | BMU_RESET_EP_OUT;
+	ocp_write_byte(tp, MCU_TYPE_USB, USB_BMU_RESET, ocp_data);
+}
+
+static void rtl_clear_bp(struct r8152 *tp)
+{
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_BP_0, 0);
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_BP_2, 0);
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_BP_4, 0);
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_BP_6, 0);
+	ocp_write_dword(tp, MCU_TYPE_USB, USB_BP_0, 0);
+	ocp_write_dword(tp, MCU_TYPE_USB, USB_BP_2, 0);
+	ocp_write_dword(tp, MCU_TYPE_USB, USB_BP_4, 0);
+	ocp_write_dword(tp, MCU_TYPE_USB, USB_BP_6, 0);
+	usleep_range(3000, 6000);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_BA, 0);
+	ocp_write_word(tp, MCU_TYPE_USB, USB_BP_BA, 0);
+}
+
+static void r8153_clear_bp(struct r8152 *tp)
+{
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_BP_EN, 0);
+	ocp_write_byte(tp, MCU_TYPE_USB, USB_BP_EN, 0);
+	rtl_clear_bp(tp);
+}
+
+static void r8153b_clear_bp(struct r8152 *tp, u16 type)
+{
+	if (type == MCU_TYPE_PLA)
+		ocp_write_byte(tp, MCU_TYPE_PLA, PLA_BP_EN, 0);
+	else
+		ocp_write_byte(tp, MCU_TYPE_USB, USB_BP2_EN, 0);
+
+	ocp_write_word(tp, type, PLA_BP_0, 0);
+	ocp_write_word(tp, type, PLA_BP_1, 0);
+	ocp_write_word(tp, type, PLA_BP_2, 0);
+	ocp_write_word(tp, type, PLA_BP_3, 0);
+	ocp_write_word(tp, type, PLA_BP_4, 0);
+	ocp_write_word(tp, type, PLA_BP_5, 0);
+	ocp_write_word(tp, type, PLA_BP_6, 0);
+	ocp_write_word(tp, type, PLA_BP_7, 0);
+
+	if (type == MCU_TYPE_USB) {
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_8, 0);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_9, 0);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_10, 0);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_11, 0);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_12, 0);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_13, 0);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_14, 0);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_15, 0);
+	}
+	usleep_range(3000, 6000);
+	ocp_write_word(tp, type, PLA_BP_BA, 0);
+}
+
+static void patch4(struct r8152 *tp)
+{
+	u8 data;
+
+	data = ocp_read_byte(tp, MCU_TYPE_USB, 0xd429);
+	data |= 0x80;
+	ocp_write_byte(tp, MCU_TYPE_USB, 0xd429, data);
+	ocp_write_word(tp, MCU_TYPE_USB, 0xc0ce, 0x0210);
+	data = ocp_read_byte(tp, MCU_TYPE_USB, 0xd429);
+	data &= ~0x80;
+	ocp_write_byte(tp, MCU_TYPE_USB, 0xd429, data);
+}
+
+static void r8152b_firmware(struct r8152 *tp)
+{
+	if (tp->version == RTL_VER_01) {
+		int i;
+		static u8 pla_patch_a[] = {
+			0x08, 0xe0, 0x40, 0xe0,
+			0x78, 0xe0, 0x85, 0xe0,
+			0x5d, 0xe1, 0xa1, 0xe1,
+			0xa3, 0xe1, 0xab, 0xe1,
+			0x31, 0xc3, 0x60, 0x72,
+			0xa0, 0x49, 0x10, 0xf0,
+			0xa4, 0x49, 0x0e, 0xf0,
+			0x2c, 0xc3, 0x62, 0x72,
+			0x26, 0x70, 0x80, 0x49,
+			0x05, 0xf0, 0x2f, 0x48,
+			0x62, 0x9a, 0x24, 0x70,
+			0x60, 0x98, 0x24, 0xc3,
+			0x60, 0x99, 0x23, 0xc3,
+			0x00, 0xbb, 0x2c, 0x75,
+			0xdc, 0x21, 0xbc, 0x25,
+			0x04, 0x13, 0x0a, 0xf0,
+			0x03, 0x13, 0x08, 0xf0,
+			0x02, 0x13, 0x06, 0xf0,
+			0x01, 0x13, 0x04, 0xf0,
+			0x08, 0x13, 0x02, 0xf0,
+			0x03, 0xe0, 0xd4, 0x49,
+			0x04, 0xf1, 0x14, 0xc2,
+			0x12, 0xc3, 0x00, 0xbb,
+			0x12, 0xc3, 0x60, 0x75,
+			0xd0, 0x49, 0x05, 0xf1,
+			0x50, 0x48, 0x60, 0x9d,
+			0x09, 0xc6, 0x00, 0xbe,
+			0xd0, 0x48, 0x60, 0x9d,
+			0xf3, 0xe7, 0xc2, 0xc0,
+			0x38, 0xd2, 0xc6, 0xd2,
+			0x84, 0x17, 0xa2, 0x13,
+			0x0c, 0x17, 0xbc, 0xc0,
+			0xa2, 0xd1, 0x33, 0xc5,
+			0xa0, 0x74, 0xc0, 0x49,
+			0x1f, 0xf0, 0x30, 0xc5,
+			0xa0, 0x73, 0x00, 0x13,
+			0x04, 0xf1, 0xa2, 0x73,
+			0x00, 0x13, 0x14, 0xf0,
+			0x28, 0xc5, 0xa0, 0x74,
+			0xc8, 0x49, 0x1b, 0xf1,
+			0x26, 0xc5, 0xa0, 0x76,
+			0xa2, 0x74, 0x01, 0x06,
+			0x20, 0x37, 0xa0, 0x9e,
+			0xa2, 0x9c, 0x1e, 0xc5,
+			0xa2, 0x73, 0x23, 0x40,
+			0x10, 0xf8, 0x04, 0xf3,
+			0xa0, 0x73, 0x33, 0x40,
+			0x0c, 0xf8, 0x15, 0xc5,
+			0xa0, 0x74, 0x41, 0x48,
+			0xa0, 0x9c, 0x14, 0xc5,
+			0xa0, 0x76, 0x62, 0x48,
+			0xe0, 0x48, 0xa0, 0x9e,
+			0x10, 0xc6, 0x00, 0xbe,
+			0x0a, 0xc5, 0xa0, 0x74,
+			0x48, 0x48, 0xa0, 0x9c,
+			0x0b, 0xc5, 0x20, 0x1e,
+			0xa0, 0x9e, 0xe5, 0x48,
+			0xa0, 0x9e, 0xf0, 0xe7,
+			0xbc, 0xc0, 0xc8, 0xd2,
+			0xcc, 0xd2, 0x28, 0xe4,
+			0x22, 0x02, 0xf0, 0xc0,
+			0x0b, 0xc0, 0x00, 0x71,
+			0x0a, 0xc0, 0x00, 0x72,
+			0xa0, 0x49, 0x04, 0xf0,
+			0xa4, 0x49, 0x02, 0xf0,
+			0x93, 0x48, 0x04, 0xc0,
+			0x00, 0xb8, 0x00, 0xe4,
+			0xc2, 0xc0, 0x8c, 0x09,
+			0x14, 0xc2, 0x40, 0x73,
+			0xba, 0x48, 0x40, 0x9b,
+			0x11, 0xc2, 0x40, 0x73,
+			0xb0, 0x49, 0x17, 0xf0,
+			0xbf, 0x49, 0x03, 0xf1,
+			0x09, 0xc5, 0x00, 0xbd,
+			0xb1, 0x49, 0x11, 0xf0,
+			0xb1, 0x48, 0x40, 0x9b,
+			0x02, 0xc2, 0x00, 0xba,
+			0x82, 0x18, 0x00, 0xa0,
+			0x1e, 0xfc, 0xbc, 0xc0,
+			0xf0, 0xc0, 0xde, 0xe8,
+			0x00, 0x80, 0x00, 0x60,
+			0x2c, 0x75, 0xd4, 0x49,
+			0x12, 0xf1, 0x29, 0xe0,
+			0xf8, 0xc2, 0x46, 0x71,
+			0xf7, 0xc2, 0x40, 0x73,
+			0xbe, 0x49, 0x03, 0xf1,
+			0xf5, 0xc7, 0x02, 0xe0,
+			0xf2, 0xc7, 0x4f, 0x30,
+			0x26, 0x62, 0xa1, 0x49,
+			0xf0, 0xf1, 0x22, 0x72,
+			0xa0, 0x49, 0xed, 0xf1,
+			0x25, 0x25, 0x18, 0x1f,
+			0x97, 0x30, 0x91, 0x30,
+			0x36, 0x9a, 0x2c, 0x75,
+			0x32, 0xc3, 0x60, 0x73,
+			0xb1, 0x49, 0x0d, 0xf1,
+			0xdc, 0x21, 0xbc, 0x25,
+			0x27, 0xc6, 0xc0, 0x77,
+			0x04, 0x13, 0x18, 0xf0,
+			0x03, 0x13, 0x19, 0xf0,
+			0x02, 0x13, 0x1a, 0xf0,
+			0x01, 0x13, 0x1b, 0xf0,
+			0xd4, 0x49, 0x03, 0xf1,
+			0x1c, 0xc5, 0x00, 0xbd,
+			0xcd, 0xc6, 0xc6, 0x67,
+			0x2e, 0x75, 0xd7, 0x22,
+			0xdd, 0x26, 0x05, 0x15,
+			0x1a, 0xf0, 0x14, 0xc6,
+			0x00, 0xbe, 0x13, 0xc5,
+			0x00, 0xbd, 0x12, 0xc5,
+			0x00, 0xbd, 0xf1, 0x49,
+			0xfb, 0xf1, 0xef, 0xe7,
+			0xf4, 0x49, 0xfa, 0xf1,
+			0xec, 0xe7, 0xf3, 0x49,
+			0xf7, 0xf1, 0xe9, 0xe7,
+			0xf2, 0x49, 0xf4, 0xf1,
+			0xe6, 0xe7, 0xb6, 0xc0,
+			0x6a, 0x14, 0xac, 0x13,
+			0xd6, 0x13, 0xfa, 0x14,
+			0xa0, 0xd1, 0x00, 0x00,
+			0xc0, 0x75, 0xd0, 0x49,
+			0x46, 0xf0, 0x26, 0x72,
+			0xa7, 0x49, 0x43, 0xf0,
+			0x22, 0x72, 0x25, 0x25,
+			0x20, 0x1f, 0x97, 0x30,
+			0x91, 0x30, 0x40, 0x73,
+			0xf3, 0xc4, 0x1c, 0x40,
+			0x04, 0xf0, 0xd7, 0x49,
+			0x05, 0xf1, 0x37, 0xe0,
+			0x53, 0x48, 0xc0, 0x9d,
+			0x08, 0x02, 0x40, 0x66,
+			0x64, 0x27, 0x06, 0x16,
+			0x30, 0xf1, 0x46, 0x63,
+			0x3b, 0x13, 0x2d, 0xf1,
+			0x34, 0x9b, 0x18, 0x1b,
+			0x93, 0x30, 0x2b, 0xc3,
+			0x10, 0x1c, 0x2b, 0xe8,
+			0x01, 0x14, 0x25, 0xf1,
+			0x00, 0x1d, 0x26, 0x1a,
+			0x8a, 0x30, 0x22, 0x73,
+			0xb5, 0x25, 0x0e, 0x0b,
+			0x00, 0x1c, 0x2c, 0xe8,
+			0x1f, 0xc7, 0x27, 0x40,
+			0x1a, 0xf1, 0x38, 0xe8,
+			0x32, 0x1f, 0x8f, 0x30,
+			0x08, 0x1b, 0x24, 0xe8,
+			0x36, 0x72, 0x46, 0x77,
+			0x00, 0x17, 0x0d, 0xf0,
+			0x13, 0xc3, 0x1f, 0x40,
+			0x03, 0xf1, 0x00, 0x1f,
+			0x46, 0x9f, 0x44, 0x77,
+			0x9f, 0x44, 0x5f, 0x44,
+			0x17, 0xe8, 0x0a, 0xc7,
+			0x27, 0x40, 0x05, 0xf1,
+			0x02, 0xc3, 0x00, 0xbb,
+			0x50, 0x1a, 0x06, 0x1a,
+			0xff, 0xc7, 0x00, 0xbf,
+			0xb8, 0xcd, 0xff, 0xff,
+			0x02, 0x0c, 0x54, 0xa5,
+			0xdc, 0xa5, 0x2f, 0x40,
+			0x05, 0xf1, 0x00, 0x14,
+			0xfa, 0xf1, 0x01, 0x1c,
+			0x02, 0xe0, 0x00, 0x1c,
+			0x80, 0xff, 0xb0, 0x49,
+			0x04, 0xf0, 0x01, 0x0b,
+			0xd3, 0xa1, 0x03, 0xe0,
+			0x02, 0x0b, 0xd3, 0xa5,
+			0x27, 0x31, 0x20, 0x37,
+			0x02, 0x0b, 0xd3, 0xa5,
+			0x27, 0x31, 0x20, 0x37,
+			0x00, 0x13, 0xfb, 0xf1,
+			0x80, 0xff, 0x22, 0x73,
+			0xb5, 0x25, 0x18, 0x1e,
+			0xde, 0x30, 0xd9, 0x30,
+			0x64, 0x72, 0x11, 0x1e,
+			0x68, 0x23, 0x16, 0x31,
+			0x80, 0xff, 0xd4, 0x49,
+			0x28, 0xf0, 0x02, 0xb4,
+			0x2a, 0xc4, 0x00, 0x1d,
+			0x2e, 0xe8, 0xe0, 0x73,
+			0xb9, 0x21, 0xbd, 0x25,
+			0x04, 0x13, 0x02, 0xf0,
+			0x1a, 0xe0, 0x22, 0xc4,
+			0x23, 0xc3, 0x2f, 0xe8,
+			0x23, 0xc3, 0x2d, 0xe8,
+			0x00, 0x1d, 0x21, 0xe8,
+			0xe2, 0x73, 0xbb, 0x49,
+			0xfc, 0xf0, 0xe0, 0x73,
+			0xb7, 0x48, 0x03, 0xb4,
+			0x81, 0x1d, 0x19, 0xe8,
+			0x40, 0x1a, 0x84, 0x1d,
+			0x16, 0xe8, 0x12, 0xc3,
+			0x1e, 0xe8, 0x03, 0xb0,
+			0x81, 0x1d, 0x11, 0xe8,
+			0x0e, 0xc3, 0x19, 0xe8,
+			0x02, 0xb0, 0x06, 0xc7,
+			0x04, 0x1e, 0xe0, 0x9e,
+			0x02, 0xc6, 0x00, 0xbe,
+			0x22, 0x02, 0x20, 0xe4,
+			0x04, 0xb8, 0x34, 0xb0,
+			0x00, 0x02, 0x00, 0x03,
+			0x00, 0x0e, 0x00, 0x0c,
+			0x09, 0xc7, 0xe0, 0x9b,
+			0xe2, 0x9a, 0xe4, 0x9c,
+			0xe6, 0x8d, 0xe6, 0x76,
+			0xef, 0x49, 0xfe, 0xf1,
+			0x80, 0xff, 0x08, 0xea,
+			0x82, 0x1d, 0xf5, 0xef,
+			0x00, 0x1a, 0x88, 0x1d,
+			0xf2, 0xef, 0xed, 0xc2,
+			0xf0, 0xef, 0x80, 0xff,
+			0x02, 0xc6, 0x00, 0xbe,
+			0x46, 0x06, 0x08, 0xc2,
+			0x40, 0x73, 0x3a, 0x48,
+			0x40, 0x9b, 0x06, 0xff,
+			0x02, 0xc6, 0x00, 0xbe,
+			0x86, 0x17, 0x1e, 0xfc,
+			0x36, 0xf0, 0x08, 0x1c,
+			0xea, 0x8c, 0xe3, 0x64,
+			0xc7, 0x49, 0x25, 0xf1,
+			0xe0, 0x75, 0xff, 0x1b,
+			0xeb, 0x47, 0xff, 0x1b,
+			0x6b, 0x47, 0xe0, 0x9d,
+			0x15, 0xc3, 0x60, 0x75,
+			0xd8, 0x49, 0x04, 0xf0,
+			0x81, 0x1d, 0xe2, 0x8d,
+			0x05, 0xe0, 0xe2, 0x63,
+			0x81, 0x1d, 0xdd, 0x47,
+			0xe2, 0x8b, 0x0b, 0xc3,
+			0x00, 0x1d, 0x61, 0x8d,
+			0x3c, 0x03, 0x60, 0x75,
+			0xd8, 0x49, 0x06, 0xf1,
+			0xdf, 0x48, 0x61, 0x95,
+			0x16, 0xe0, 0x4e, 0xe8,
+			0x12, 0xe8, 0x21, 0xc5,
+			0xa0, 0x73, 0xb0, 0x49,
+			0x03, 0xf0, 0x31, 0x48,
+			0xa0, 0x9b, 0x0d, 0xe0,
+			0xc0, 0x49, 0x0b, 0xf1,
+			0xe2, 0x63, 0x7e, 0x1d,
+			0xdd, 0x46, 0xe2, 0x8b,
+			0xe0, 0x75, 0x83, 0x1b,
+			0xeb, 0x46, 0xfe, 0x1b,
+			0x6b, 0x46, 0xe0, 0x9d,
+			0xe4, 0x49, 0x11, 0xf0,
+			0x10, 0x1d, 0xea, 0x8d,
+			0xe3, 0x64, 0xc6, 0x49,
+			0x09, 0xf1, 0x07, 0xc5,
+			0xa0, 0x73, 0xb1, 0x48,
+			0xa0, 0x9b, 0x02, 0xc5,
+			0x00, 0xbd, 0xe6, 0x04,
+			0xa0, 0xd1, 0x02, 0xc5,
+			0x00, 0xbd, 0xfe, 0x04,
+			0x02, 0xc5, 0x00, 0xbd,
+			0x30, 0x05, 0x00, 0x00 };
+		static u16 ram_code1[] = {
+			0x9700, 0x7fe0, 0x4c00, 0x4007,
+			0x4400, 0x4800, 0x7c1f, 0x4c00,
+			0x5310, 0x6000, 0x7c07, 0x6800,
+			0x673e, 0x0000, 0x0000, 0x571f,
+			0x5ffb, 0xaa05, 0x5b58, 0x7d80,
+			0x6100, 0x3019, 0x5b64, 0x7d80,
+			0x6080, 0xa6f8, 0xdcdb, 0x0015,
+			0xb915, 0xb511, 0xd16b, 0x000f,
+			0xb40f, 0xd06b, 0x000d, 0xb206,
+			0x7c01, 0x5800, 0x7c04, 0x5c00,
+			0x3011, 0x7c01, 0x5801, 0x7c04,
+			0x5c04, 0x3019, 0x30a5, 0x3127,
+			0x31d5, 0x7fe0, 0x4c60, 0x7c07,
+			0x6803, 0x7d00, 0x6900, 0x65a0,
+			0x0000, 0x0000, 0xaf03, 0x6015,
+			0x303e, 0x6017, 0x57e0, 0x580c,
+			0x588c, 0x7fdd, 0x5fa2, 0x4827,
+			0x7c1f, 0x4c00, 0x7c1f, 0x4c10,
+			0x8400, 0x7c30, 0x6020, 0x48bf,
+			0x7c1f, 0x4c00, 0x7c1f, 0x4c01,
+			0x7c07, 0x6803, 0xb806, 0x7c08,
+			0x6800, 0x0000, 0x0000, 0x305c,
+			0x7c08, 0x6808, 0x0000, 0x0000,
+			0xae06, 0x7c02, 0x5c02, 0x0000,
+			0x0000, 0x3067, 0x8e05, 0x7c02,
+			0x5c00, 0x0000, 0x0000, 0xad06,
+			0x7c20, 0x5c20, 0x0000, 0x0000,
+			0x3072, 0x8d05, 0x7c20, 0x5c00,
+			0x0000, 0x0000, 0xa008, 0x7c07,
+			0x6800, 0xb8db, 0x7c07, 0x6803,
+			0xd9b3, 0x00d7, 0x7fe0, 0x4c80,
+			0x7c08, 0x6800, 0x0000, 0x0000,
+			0x7c23, 0x5c23, 0x481d, 0x7c1f,
+			0x4c00, 0x7c1f, 0x4c02, 0x5310,
+			0x81ff, 0x30f5, 0x7fe0, 0x4d00,
+			0x4832, 0x7c1f, 0x4c00, 0x7c1f,
+			0x4c10, 0x7c08, 0x6000, 0xa49e,
+			0x7c07, 0x6800, 0xb89b, 0x7c07,
+			0x6803, 0xd9b3, 0x00f9, 0x7fe0,
+			0x4d20, 0x7e00, 0x6200, 0x3001,
+			0x7fe0, 0x4dc0, 0xd09d, 0x0002,
+			0xb4fe, 0x7fe0, 0x4d80, 0x7c04,
+			0x6004, 0x7c07, 0x6802, 0x6728,
+			0x0000, 0x0000, 0x7c08, 0x6000,
+			0x486c, 0x7c1f, 0x4c00, 0x7c1f,
+			0x4c01, 0x9503, 0x7e00, 0x6200,
+			0x571f, 0x5fbb, 0xaa05, 0x5b58,
+			0x7d80, 0x6100, 0x30c2, 0x5b64,
+			0x7d80, 0x6080, 0xcdab, 0x0063,
+			0xcd8d, 0x0061, 0xd96b, 0x005f,
+			0xd0a0, 0x00d7, 0xcba0, 0x0003,
+			0x80ec, 0x30cf, 0x30dc, 0x7fe0,
+			0x4ce0, 0x4832, 0x7c1f, 0x4c00,
+			0x7c1f, 0x4c08, 0x7c08, 0x6008,
+			0x8300, 0xb902, 0x30a5, 0x308a,
+			0x7fe0, 0x4da0, 0x65a8, 0x0000,
+			0x0000, 0x56a0, 0x590c, 0x7ffd,
+			0x5fa2, 0xae06, 0x7c02, 0x5c02,
+			0x0000, 0x0000, 0x30f0, 0x8e05,
+			0x7c02, 0x5c00, 0x0000, 0x0000,
+			0xcba4, 0x0004, 0xcd8d, 0x0002,
+			0x80f1, 0x7fe0, 0x4ca0, 0x7c08,
+			0x6408, 0x0000, 0x0000, 0x7d00,
+			0x6800, 0xb603, 0x7c10, 0x6010,
+			0x7d1f, 0x551f, 0x5fb3, 0xaa07,
+			0x7c80, 0x5800, 0x5b58, 0x7d80,
+			0x6100, 0x310f, 0x7c80, 0x5800,
+			0x5b64, 0x7d80, 0x6080, 0x4827,
+			0x7c1f, 0x4c00, 0x7c1f, 0x4c10,
+			0x8400, 0x7c10, 0x6000, 0x7fe0,
+			0x4cc0, 0x5fbb, 0x4824, 0x7c1f,
+			0x4c00, 0x7c1f, 0x4c04, 0x8200,
+			0x7ce0, 0x5400, 0x6728, 0x0000,
+			0x0000, 0x30cf, 0x3001, 0x7fe0,
+			0x4e00, 0x4007, 0x4400, 0x5310,
+			0x7c07, 0x6800, 0x673e, 0x0000,
+			0x0000, 0x570f, 0x5fff, 0xaa05,
+			0x585b, 0x7d80, 0x6100, 0x313b,
+			0x5867, 0x7d80, 0x6080, 0x9403,
+			0x7e00, 0x6200, 0xcda3, 0x00e7,
+			0xcd85, 0x00e5, 0xd96b, 0x00e3,
+			0x96e3, 0x7c07, 0x6800, 0x673e,
+			0x0000, 0x0000, 0x7fe0, 0x4e20,
+			0x96db, 0x8b04, 0x7c08, 0x5008,
+			0xab03, 0x7c08, 0x5000, 0x7c07,
+			0x6801, 0x677e, 0x0000, 0x0000,
+			0xdb7c, 0x00ec, 0x0000, 0x7fe1,
+			0x4f40, 0x4837, 0x4418, 0x41c7,
+			0x7fe0, 0x4e40, 0x7c40, 0x5400,
+			0x7c1f, 0x4c01, 0x7c1f, 0x4c01,
+			0x8fbf, 0xd2a0, 0x004b, 0x9204,
+			0xa042, 0x3168, 0x3127, 0x7fe1,
+			0x4f60, 0x489c, 0x4628, 0x7fe0,
+			0x4e60, 0x7e28, 0x4628, 0x7c40,
+			0x5400, 0x7c01, 0x5800, 0x7c04,
+			0x5c00, 0x41e8, 0x7c1f, 0x4c01,
+			0x7c1f, 0x4c01, 0x8fa5, 0xb241,
+			0xa02a, 0x3182, 0x7fe0, 0x4ea0,
+			0x7c02, 0x4402, 0x4448, 0x4894,
+			0x7c1f, 0x4c01, 0x7c1f, 0x4c03,
+			0x4824, 0x7c1f, 0x4c07, 0x41ef,
+			0x41ff, 0x4891, 0x7c1f, 0x4c07,
+			0x7c1f, 0x4c17, 0x8400, 0x8ef8,
+			0x41c7, 0x8f8a, 0x92d5, 0xa10f,
+			0xd480, 0x0008, 0xd580, 0x00b8,
+			0xa202, 0x319d, 0x7c04, 0x4404,
+			0x319d, 0xd484, 0x00f3, 0xd484,
+			0x00f1, 0x3127, 0x7fe0, 0x4ee0,
+			0x7c40, 0x5400, 0x4488, 0x41cf,
+			0x3127, 0x7fe0, 0x4ec0, 0x48f3,
+			0x7c1f, 0x4c01, 0x7c1f, 0x4c09,
+			0x4508, 0x41c7, 0x8fb0, 0xd218,
+			0x00ae, 0xd2a4, 0x009e, 0x31be,
+			0x7fe0, 0x4e80, 0x4832, 0x7c1f,
+			0x4c01, 0x7c1f, 0x4c11, 0x4428,
+			0x7c40, 0x5440, 0x7c01, 0x5801,
+			0x7c04, 0x5c04, 0x41e8, 0xa4b3,
+			0x31d3, 0x7fe0, 0x4f20, 0x7c07,
+			0x6800, 0x673e, 0x0000, 0x0000,
+			0x570f, 0x5fff, 0xaa04, 0x585b,
+			0x6100, 0x31e4, 0x5867, 0x6080,
+			0xbcf1, 0x3001 };
+
+		patch4(tp);
+		rtl_clear_bp(tp);
+
+		generic_ocp_write(tp, 0xf800, 0x3f, sizeof(pla_patch_a),
+				  pla_patch_a, MCU_TYPE_PLA);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc26, 0x8000);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc28, 0x170b);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2a, 0x01e1);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2c, 0x0989);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2e, 0x1349);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc30, 0x01b7);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc32, 0x061d);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xe422, 0x0020);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xe420, 0x0018);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc34, 0x1785);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc36, 0x047b);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_OCP_GPHY_BASE, 0x2000);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb092, 0x7070);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb098, 0x0600);
+		for (i = 0; i < ARRAY_SIZE(ram_code1); i++)
+			ocp_write_word(tp, MCU_TYPE_PLA, 0xb09a, ram_code1[i]);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb098, 0x0200);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb092, 0x7030);
+	} else if (tp->version == RTL_VER_02) {
+		static u8 pla_patch_a2[] = {
+			0x08, 0xe0, 0x1a, 0xe0,
+			0xf2, 0xe0, 0xfa, 0xe0,
+			0x32, 0xe1, 0x34, 0xe1,
+			0x36, 0xe1, 0x38, 0xe1,
+			0x2c, 0x75, 0xdc, 0x21,
+			0xbc, 0x25, 0x04, 0x13,
+			0x0b, 0xf0, 0x03, 0x13,
+			0x09, 0xf0, 0x02, 0x13,
+			0x07, 0xf0, 0x01, 0x13,
+			0x05, 0xf0, 0x08, 0x13,
+			0x03, 0xf0, 0x04, 0xc3,
+			0x00, 0xbb, 0x03, 0xc3,
+			0x00, 0xbb, 0xd2, 0x17,
+			0xbc, 0x17, 0x14, 0xc2,
+			0x40, 0x73, 0xba, 0x48,
+			0x40, 0x9b, 0x11, 0xc2,
+			0x40, 0x73, 0xb0, 0x49,
+			0x17, 0xf0, 0xbf, 0x49,
+			0x03, 0xf1, 0x09, 0xc5,
+			0x00, 0xbd, 0xb1, 0x49,
+			0x11, 0xf0, 0xb1, 0x48,
+			0x40, 0x9b, 0x02, 0xc2,
+			0x00, 0xba, 0x4e, 0x19,
+			0x00, 0xa0, 0x1e, 0xfc,
+			0xbc, 0xc0, 0xf0, 0xc0,
+			0xde, 0xe8, 0x00, 0x80,
+			0x00, 0x60, 0x2c, 0x75,
+			0xd4, 0x49, 0x12, 0xf1,
+			0x29, 0xe0, 0xf8, 0xc2,
+			0x46, 0x71, 0xf7, 0xc2,
+			0x40, 0x73, 0xbe, 0x49,
+			0x03, 0xf1, 0xf5, 0xc7,
+			0x02, 0xe0, 0xf2, 0xc7,
+			0x4f, 0x30, 0x26, 0x62,
+			0xa1, 0x49, 0xf0, 0xf1,
+			0x22, 0x72, 0xa0, 0x49,
+			0xed, 0xf1, 0x25, 0x25,
+			0x18, 0x1f, 0x97, 0x30,
+			0x91, 0x30, 0x36, 0x9a,
+			0x2c, 0x75, 0x32, 0xc3,
+			0x60, 0x73, 0xb1, 0x49,
+			0x0d, 0xf1, 0xdc, 0x21,
+			0xbc, 0x25, 0x27, 0xc6,
+			0xc0, 0x77, 0x04, 0x13,
+			0x18, 0xf0, 0x03, 0x13,
+			0x19, 0xf0, 0x02, 0x13,
+			0x1a, 0xf0, 0x01, 0x13,
+			0x1b, 0xf0, 0xd4, 0x49,
+			0x03, 0xf1, 0x1c, 0xc5,
+			0x00, 0xbd, 0xcd, 0xc6,
+			0xc6, 0x67, 0x2e, 0x75,
+			0xd7, 0x22, 0xdd, 0x26,
+			0x05, 0x15, 0x1a, 0xf0,
+			0x14, 0xc6, 0x00, 0xbe,
+			0x13, 0xc5, 0x00, 0xbd,
+			0x12, 0xc5, 0x00, 0xbd,
+			0xf1, 0x49, 0xfb, 0xf1,
+			0xef, 0xe7, 0xf4, 0x49,
+			0xfa, 0xf1, 0xec, 0xe7,
+			0xf3, 0x49, 0xf7, 0xf1,
+			0xe9, 0xe7, 0xf2, 0x49,
+			0xf4, 0xf1, 0xe6, 0xe7,
+			0xb6, 0xc0, 0xf6, 0x14,
+			0x36, 0x14, 0x62, 0x14,
+			0x86, 0x15, 0xa0, 0xd1,
+			0x00, 0x00, 0xc0, 0x75,
+			0xd0, 0x49, 0x46, 0xf0,
+			0x26, 0x72, 0xa7, 0x49,
+			0x43, 0xf0, 0x22, 0x72,
+			0x25, 0x25, 0x20, 0x1f,
+			0x97, 0x30, 0x91, 0x30,
+			0x40, 0x73, 0xf3, 0xc4,
+			0x1c, 0x40, 0x04, 0xf0,
+			0xd7, 0x49, 0x05, 0xf1,
+			0x37, 0xe0, 0x53, 0x48,
+			0xc0, 0x9d, 0x08, 0x02,
+			0x40, 0x66, 0x64, 0x27,
+			0x06, 0x16, 0x30, 0xf1,
+			0x46, 0x63, 0x3b, 0x13,
+			0x2d, 0xf1, 0x34, 0x9b,
+			0x18, 0x1b, 0x93, 0x30,
+			0x2b, 0xc3, 0x10, 0x1c,
+			0x2b, 0xe8, 0x01, 0x14,
+			0x25, 0xf1, 0x00, 0x1d,
+			0x26, 0x1a, 0x8a, 0x30,
+			0x22, 0x73, 0xb5, 0x25,
+			0x0e, 0x0b, 0x00, 0x1c,
+			0x2c, 0xe8, 0x1f, 0xc7,
+			0x27, 0x40, 0x1a, 0xf1,
+			0x38, 0xe8, 0x32, 0x1f,
+			0x8f, 0x30, 0x08, 0x1b,
+			0x24, 0xe8, 0x36, 0x72,
+			0x46, 0x77, 0x00, 0x17,
+			0x0d, 0xf0, 0x13, 0xc3,
+			0x1f, 0x40, 0x03, 0xf1,
+			0x00, 0x1f, 0x46, 0x9f,
+			0x44, 0x77, 0x9f, 0x44,
+			0x5f, 0x44, 0x17, 0xe8,
+			0x0a, 0xc7, 0x27, 0x40,
+			0x05, 0xf1, 0x02, 0xc3,
+			0x00, 0xbb, 0x1c, 0x1b,
+			0xd2, 0x1a, 0xff, 0xc7,
+			0x00, 0xbf, 0xb8, 0xcd,
+			0xff, 0xff, 0x02, 0x0c,
+			0x54, 0xa5, 0xdc, 0xa5,
+			0x2f, 0x40, 0x05, 0xf1,
+			0x00, 0x14, 0xfa, 0xf1,
+			0x01, 0x1c, 0x02, 0xe0,
+			0x00, 0x1c, 0x80, 0xff,
+			0xb0, 0x49, 0x04, 0xf0,
+			0x01, 0x0b, 0xd3, 0xa1,
+			0x03, 0xe0, 0x02, 0x0b,
+			0xd3, 0xa5, 0x27, 0x31,
+			0x20, 0x37, 0x02, 0x0b,
+			0xd3, 0xa5, 0x27, 0x31,
+			0x20, 0x37, 0x00, 0x13,
+			0xfb, 0xf1, 0x80, 0xff,
+			0x22, 0x73, 0xb5, 0x25,
+			0x18, 0x1e, 0xde, 0x30,
+			0xd9, 0x30, 0x64, 0x72,
+			0x11, 0x1e, 0x68, 0x23,
+			0x16, 0x31, 0x80, 0xff,
+			0x08, 0xc2, 0x40, 0x73,
+			0x3a, 0x48, 0x40, 0x9b,
+			0x06, 0xff, 0x02, 0xc6,
+			0x00, 0xbe, 0x4e, 0x18,
+			0x1e, 0xfc, 0x33, 0xc5,
+			0xa0, 0x74, 0xc0, 0x49,
+			0x1f, 0xf0, 0x30, 0xc5,
+			0xa0, 0x73, 0x00, 0x13,
+			0x04, 0xf1, 0xa2, 0x73,
+			0x00, 0x13, 0x14, 0xf0,
+			0x28, 0xc5, 0xa0, 0x74,
+			0xc8, 0x49, 0x1b, 0xf1,
+			0x26, 0xc5, 0xa0, 0x76,
+			0xa2, 0x74, 0x01, 0x06,
+			0x20, 0x37, 0xa0, 0x9e,
+			0xa2, 0x9c, 0x1e, 0xc5,
+			0xa2, 0x73, 0x23, 0x40,
+			0x10, 0xf8, 0x04, 0xf3,
+			0xa0, 0x73, 0x33, 0x40,
+			0x0c, 0xf8, 0x15, 0xc5,
+			0xa0, 0x74, 0x41, 0x48,
+			0xa0, 0x9c, 0x14, 0xc5,
+			0xa0, 0x76, 0x62, 0x48,
+			0xe0, 0x48, 0xa0, 0x9e,
+			0x10, 0xc6, 0x00, 0xbe,
+			0x0a, 0xc5, 0xa0, 0x74,
+			0x48, 0x48, 0xa0, 0x9c,
+			0x0b, 0xc5, 0x20, 0x1e,
+			0xa0, 0x9e, 0xe5, 0x48,
+			0xa0, 0x9e, 0xf0, 0xe7,
+			0xbc, 0xc0, 0xc8, 0xd2,
+			0xcc, 0xd2, 0x28, 0xe4,
+			0x22, 0x02, 0xf0, 0xc0,
+			0x02, 0xc6, 0x00, 0xbe,
+			0x00, 0x00, 0x02, 0xc6,
+			0x00, 0xbe, 0x00, 0x00,
+			0x02, 0xc6, 0x00, 0xbe,
+			0x00, 0x00, 0x02, 0xc6,
+			0x00, 0xbe, 0x00, 0x00,
+			0x00, 0x00, 0x00, 0x00 };
+
+		rtl_clear_bp(tp);
+
+		generic_ocp_write(tp, 0xf800, 0xff, sizeof(pla_patch_a2),
+				  pla_patch_a2, MCU_TYPE_PLA);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc26, 0x8000);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc28, 0x17a5);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2a, 0x13ad);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2c, 0x184d);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2e, 0x01e1);
+	}
+}
+
+static void r8152_aldps_en(struct r8152 *tp, bool enable)
+{
+	if (enable) {
+		ocp_reg_write(tp, OCP_ALDPS_CONFIG, ENPWRSAVE | ENPDNPS |
+						    LINKENA | DIS_SDSAVE);
+	} else {
+		ocp_reg_write(tp, OCP_ALDPS_CONFIG, ENPDNPS | LINKENA |
+						    DIS_SDSAVE);
+		msleep(20);
+	}
+}
+
+static inline void r8152_mmd_indirect(struct r8152 *tp, u16 dev, u16 reg)
+{
+	ocp_reg_write(tp, OCP_EEE_AR, FUN_ADDR | dev);
+	ocp_reg_write(tp, OCP_EEE_DATA, reg);
+	ocp_reg_write(tp, OCP_EEE_AR, FUN_DATA | dev);
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+static u16 r8152_mmd_read(struct r8152 *tp, u16 dev, u16 reg)
+{
+	u16 data;
+
+	r8152_mmd_indirect(tp, dev, reg);
+	data = ocp_reg_read(tp, OCP_EEE_DATA);
+	ocp_reg_write(tp, OCP_EEE_AR, 0x0000);
+
+	return data;
+}
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+
+static void r8152_mmd_write(struct r8152 *tp, u16 dev, u16 reg, u16 data)
+{
+	r8152_mmd_indirect(tp, dev, reg);
+	ocp_reg_write(tp, OCP_EEE_DATA, data);
+	ocp_reg_write(tp, OCP_EEE_AR, 0x0000);
+}
+
+static void r8152_eee_en(struct r8152 *tp, bool enable)
+{
+	u16 config1, config2, config3;
+	u32 ocp_data;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_EEE_CR);
+	config1 = ocp_reg_read(tp, OCP_EEE_CONFIG1) & ~sd_rise_time_mask;
+	config2 = ocp_reg_read(tp, OCP_EEE_CONFIG2);
+	config3 = ocp_reg_read(tp, OCP_EEE_CONFIG3) & ~fast_snr_mask;
+
+	if (enable) {
+		ocp_data |= EEE_RX_EN | EEE_TX_EN;
+		config1 |= EEE_10_CAP | EEE_NWAY_EN | TX_QUIET_EN | RX_QUIET_EN;
+		config1 |= sd_rise_time(1);
+		config2 |= RG_DACQUIET_EN | RG_LDVQUIET_EN;
+		config3 |= fast_snr(42);
+	} else {
+		ocp_data &= ~(EEE_RX_EN | EEE_TX_EN);
+		config1 &= ~(EEE_10_CAP | EEE_NWAY_EN | TX_QUIET_EN |
+			     RX_QUIET_EN);
+		config1 |= sd_rise_time(7);
+		config2 &= ~(RG_DACQUIET_EN | RG_LDVQUIET_EN);
+		config3 |= fast_snr(511);
+	}
+
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_EEE_CR, ocp_data);
+	ocp_reg_write(tp, OCP_EEE_CONFIG1, config1);
+	ocp_reg_write(tp, OCP_EEE_CONFIG2, config2);
+	ocp_reg_write(tp, OCP_EEE_CONFIG3, config3);
+}
+
+static void r8152b_enable_eee(struct r8152 *tp)
+{
+	r8152_eee_en(tp, true);
+	r8152_mmd_write(tp, MDIO_MMD_AN, MDIO_AN_EEE_ADV, tp->eee_adv);
+}
+
+static void r8152b_enable_fc(struct r8152 *tp)
+{
+	u16 anar;
+
+	anar = r8152_mdio_read(tp, MII_ADVERTISE);
+	anar |= ADVERTISE_PAUSE_CAP | ADVERTISE_PAUSE_ASYM;
+	r8152_mdio_write(tp, MII_ADVERTISE, anar);
+
+	tp->ups_info.flow_control = true;
+}
+
+static void rtl8152_disable(struct r8152 *tp)
+{
+	r8152_aldps_en(tp, false);
+	rtl_disable(tp);
+	r8152_aldps_en(tp, true);
+}
+
+static void r8152b_hw_phy_cfg(struct r8152 *tp)
+{
+	r8152b_firmware(tp);
+
+	r8152b_enable_eee(tp);
+	r8152_aldps_en(tp, true);
+	r8152b_enable_fc(tp);
+
+	set_bit(PHY_RESET, &tp->flags);
+}
+
+static void r8152b_exit_oob(struct r8152 *tp)
+{
+	u32 ocp_data;
+	int i;
+
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, PLA_RCR);
+	ocp_data &= ~RCR_ACPT_ALL;
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, ocp_data);
+
+	rxdy_gated_en(tp, true);
+	r8153_teredo_off(tp);
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CRWECR, CRWECR_NORAML);
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CR, 0x00);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+	ocp_data &= ~NOW_IS_OOB;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7);
+	ocp_data &= ~MCU_BORW_EN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7, ocp_data);
+
+	for (i = 0; i < 1000; i++) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+		if (ocp_data & LINK_LIST_READY)
+			break;
+		usleep_range(1000, 2000);
+	}
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7);
+	ocp_data |= RE_INIT_LL;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7, ocp_data);
+
+	for (i = 0; i < 1000; i++) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+		if (ocp_data & LINK_LIST_READY)
+			break;
+		usleep_range(1000, 2000);
+	}
+
+	rtl8152_nic_reset(tp);
+
+	/* rx share fifo credit full threshold */
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL0, RXFIFO_THR1_NORMAL);
+
+	if (tp->udev->speed == USB_SPEED_FULL ||
+	    tp->udev->speed == USB_SPEED_LOW) {
+		/* rx share fifo credit near full threshold */
+		ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL1,
+				RXFIFO_THR2_FULL);
+		ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL2,
+				RXFIFO_THR3_FULL);
+	} else {
+		/* rx share fifo credit near full threshold */
+		ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL1,
+				RXFIFO_THR2_HIGH);
+		ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL2,
+				RXFIFO_THR3_HIGH);
+	}
+
+	/* TX share fifo free credit full threshold */
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_TXFIFO_CTRL, TXFIFO_THR_NORMAL);
+
+	ocp_write_byte(tp, MCU_TYPE_USB, USB_TX_AGG, TX_AGG_MAX_THRESHOLD);
+	ocp_write_dword(tp, MCU_TYPE_USB, USB_RX_BUF_TH, RX_THR_HIGH);
+	ocp_write_dword(tp, MCU_TYPE_USB, USB_TX_DMA,
+			TEST_MODE_DISABLE | TX_SIZE_ADJUST1);
+
+	rtl_rx_vlan_en(tp, tp->netdev->features & NETIF_F_HW_VLAN_CTAG_RX);
+
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_RMS, RTL8152_RMS);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_TCR0);
+	ocp_data |= TCR0_AUTO_FIFO;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_TCR0, ocp_data);
+}
+
+static void r8152b_enter_oob(struct r8152 *tp)
+{
+	u32 ocp_data;
+	int i;
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+	ocp_data &= ~NOW_IS_OOB;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL, ocp_data);
+
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL0, RXFIFO_THR1_OOB);
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL1, RXFIFO_THR2_OOB);
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL2, RXFIFO_THR3_OOB);
+
+	rtl_disable(tp);
+
+	for (i = 0; i < 1000; i++) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+		if (ocp_data & LINK_LIST_READY)
+			break;
+		usleep_range(1000, 2000);
+	}
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7);
+	ocp_data |= RE_INIT_LL;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7, ocp_data);
+
+	for (i = 0; i < 1000; i++) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+		if (ocp_data & LINK_LIST_READY)
+			break;
+		usleep_range(1000, 2000);
+	}
+
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_RMS, RTL8152_RMS);
+
+	rtl_rx_vlan_en(tp, true);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PAL_BDC_CR);
+	ocp_data |= ALDPS_PROXY_MODE;
+	ocp_write_word(tp, MCU_TYPE_PLA, PAL_BDC_CR, ocp_data);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+	ocp_data |= NOW_IS_OOB | DIS_MCU_CLROOB;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL, ocp_data);
+
+	rxdy_gated_en(tp, false);
+
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, PLA_RCR);
+	ocp_data |= RCR_APM | RCR_AM | RCR_AB;
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, ocp_data);
+}
+
+static int r8153_patch_request(struct r8152 *tp, bool request)
+{
+	u16 data, check;
+	int i;
+
+	data = ocp_reg_read(tp, OCP_PHY_PATCH_CMD);
+	if (request) {
+		data |= PATCH_REQUEST;
+		check = 0;
+	} else {
+		data &= ~PATCH_REQUEST;
+		check = PATCH_READY;
+	}
+	ocp_reg_write(tp, OCP_PHY_PATCH_CMD, data);
+
+	for (i = 0; i < 5000; i++) {
+		usleep_range(1000, 2000);
+		if ((ocp_reg_read(tp, OCP_PHY_PATCH_STAT) & PATCH_READY) ^ check)
+			break;
+	}
+
+	if (request && !(ocp_reg_read(tp, OCP_PHY_PATCH_STAT) & PATCH_READY)) {
+		netif_err(tp, drv, tp->netdev, "patch request fail\n");
+		r8153_patch_request(tp, false);
+		return -ETIME;
+	} else {
+		return 0;
+	}
+}
+
+static int r8153_pre_ram_code(struct r8152 *tp, u16 key_addr, u16 patch_key)
+{
+	if (r8153_patch_request(tp, true))
+		return -ETIME;
+
+	sram_write(tp, key_addr, patch_key);
+	sram_write(tp, 0xb82e, 0x0001);
+
+	return 0;
+}
+
+static int r8153_post_ram_code(struct r8152 *tp, u16 key_addr)
+{
+	u16 data;
+
+	sram_write(tp, 0x0000, 0x0000);
+
+	data = ocp_reg_read(tp, 0xb82e);
+	data &= ~0x0001;
+	ocp_reg_write(tp, 0xb82e, data);
+
+	sram_write(tp, key_addr, 0x0000);
+
+	r8153_patch_request(tp, false);
+
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_OCP_GPHY_BASE, tp->ocp_base);
+
+	return 0;
+}
+
+static int r8156_lock_mian(struct r8152 *tp, bool lock)
+{
+	u16 data;
+	int i;
+
+	data = ocp_reg_read(tp, 0xa46a);
+	if (lock)
+		data |= BIT(1);
+	else
+		data &= ~BIT(1);
+	ocp_reg_write(tp, 0xa46a, data);
+
+	if (lock) {
+		for (i = 0; i < 100; i++) {
+			usleep_range(1000, 2000);
+			data = ocp_reg_read(tp, 0xa730) & 0xff;
+			if (data == 1)
+				break;
+		}
+	} else {
+		for (i = 0; i < 100; i++) {
+			usleep_range(1000, 2000);
+			data = ocp_reg_read(tp, 0xa730) & 0xff;
+			if (data != 1)
+				break;
+		}
+	}
+
+	if (i == 100)
+		return -ETIME;
+	else
+		return 0;
+}
+
+static void r8153_wdt1_end(struct r8152 *tp)
+{
+	int i;
+
+	for (i = 0; i < 104; i++) {
+		if (!(ocp_read_byte(tp, MCU_TYPE_USB, 0xe404) & 1))
+			break;
+		usleep_range(1000, 2000);
+	}
+}
+
+static void r8153_firmware(struct r8152 *tp)
+{
+	if (tp->version == RTL_VER_03) {
+		r8153_clear_bp(tp);
+
+		r8153_pre_ram_code(tp, 0x8146, 0x7000);
+		sram_write(tp, 0xb820, 0x0290);
+		sram_write(tp, 0xa012, 0x0000);
+		sram_write(tp, 0xa014, 0x2c04);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c18);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c45);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c45);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd502);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8301);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8306);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd500);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8208);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd501);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xe018);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x0308);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x60f2);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8404);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x607d);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc117);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c16);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc116);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c16);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x607d);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc117);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa404);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd500);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x0800);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd501);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x62d2);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x615d);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc115);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa404);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc307);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd502);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8301);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8306);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd500);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8208);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c42);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc114);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8404);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc317);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd701);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x435d);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd500);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa208);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd502);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa306);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa301);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c42);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8404);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x613d);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc115);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc307);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd502);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8301);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8306);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd500);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8208);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c42);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc114);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xc317);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd701);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x40dd);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd500);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa208);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd502);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa306);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa301);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd500);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd702);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x0800);
+		sram_write(tp, 0xa01a, 0x0000);
+		sram_write(tp, 0xa006, 0x0fff);
+		sram_write(tp, 0xa004, 0x0fff);
+		sram_write(tp, 0xa002, 0x05a3);
+		sram_write(tp, 0xa000, 0x3591);
+		sram_write(tp, 0xb820, 0x0210);
+		r8153_post_ram_code(tp, 0x8146);
+	} else if (tp->version == RTL_VER_04) {
+		static u8 usb_patch_b[] = {
+			0x08, 0xe0, 0x0f, 0xe0,
+			0x18, 0xe0, 0x24, 0xe0,
+			0x26, 0xe0, 0x3a, 0xe0,
+			0x84, 0xe0, 0x9c, 0xe0,
+			0xc2, 0x49, 0x04, 0xf0,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x14, 0x18, 0x02, 0xc0,
+			0x00, 0xb8, 0x2e, 0x18,
+			0x06, 0x89, 0x08, 0xc0,
+			0x0c, 0x61, 0x92, 0x48,
+			0x93, 0x48, 0x0c, 0x89,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x08, 0x05, 0x40, 0xb4,
+			0x16, 0x89, 0x6d, 0xc0,
+			0x00, 0x61, 0x95, 0x49,
+			0x06, 0xf0, 0xfa, 0xc0,
+			0x0c, 0x61, 0x92, 0x48,
+			0x93, 0x48, 0x0c, 0x89,
+			0x02, 0xc0, 0x00, 0xb8,
+			0xe2, 0x04, 0x02, 0xc2,
+			0x00, 0xba, 0xec, 0x11,
+			0x60, 0x60, 0x85, 0x49,
+			0x0d, 0xf1, 0x11, 0xc6,
+			0xd2, 0x61, 0x91, 0x49,
+			0xfd, 0xf0, 0x74, 0x60,
+			0x04, 0x48, 0x74, 0x88,
+			0x08, 0xc6, 0x08, 0xc0,
+			0xc4, 0x98, 0x01, 0x18,
+			0xc0, 0x88, 0x02, 0xc0,
+			0x00, 0xb8, 0x6e, 0x12,
+			0x04, 0xe4, 0x0d, 0x00,
+			0x00, 0xd4, 0xd1, 0x49,
+			0x3c, 0xf1, 0xd2, 0x49,
+			0x16, 0xf1, 0xd3, 0x49,
+			0x18, 0xf1, 0xd4, 0x49,
+			0x19, 0xf1, 0xd5, 0x49,
+			0x1a, 0xf1, 0xd6, 0x49,
+			0x1b, 0xf1, 0xd7, 0x49,
+			0x1c, 0xf1, 0xd8, 0x49,
+			0x1d, 0xf1, 0xd9, 0x49,
+			0x20, 0xf1, 0xda, 0x49,
+			0x23, 0xf1, 0xdb, 0x49,
+			0x24, 0xf1, 0x02, 0xc4,
+			0x00, 0xbc, 0x20, 0x04,
+			0xe5, 0x8e, 0x02, 0xc4,
+			0x00, 0xbc, 0x14, 0x02,
+			0x02, 0xc4, 0x00, 0xbc,
+			0x16, 0x02, 0x02, 0xc4,
+			0x00, 0xbc, 0x18, 0x02,
+			0x02, 0xc4, 0x00, 0xbc,
+			0x1a, 0x02, 0x02, 0xc4,
+			0x00, 0xbc, 0x1c, 0x02,
+			0x02, 0xc4, 0x00, 0xbc,
+			0x94, 0x02, 0x10, 0xc7,
+			0xe0, 0x8e, 0x02, 0xc4,
+			0x00, 0xbc, 0x8a, 0x02,
+			0x0b, 0xc7, 0xe4, 0x8e,
+			0x02, 0xc4, 0x00, 0xbc,
+			0x88, 0x02, 0x02, 0xc4,
+			0x00, 0xbc, 0x6e, 0x02,
+			0x02, 0xc4, 0x00, 0xbc,
+			0x5a, 0x02, 0x30, 0xe4,
+			0x0c, 0xc3, 0x60, 0x64,
+			0xc5, 0x49, 0x04, 0xf1,
+			0x74, 0x64, 0xc4, 0x48,
+			0x74, 0x8c, 0x06, 0xc3,
+			0x64, 0x8e, 0x02, 0xc4,
+			0x00, 0xbc, 0x20, 0x04,
+			0x00, 0xd8, 0x00, 0xe4,
+			0xb2, 0xc0, 0x00, 0x61,
+			0x90, 0x49, 0x09, 0xf1,
+			0x8b, 0xc6, 0xca, 0x61,
+			0x94, 0x49, 0x0e, 0xf1,
+			0xf6, 0xc6, 0xda, 0x60,
+			0x81, 0x49, 0x0a, 0xf0,
+			0x65, 0x60, 0x03, 0x48,
+			0x65, 0x88, 0xef, 0xc6,
+			0xdc, 0x60, 0x80, 0x48,
+			0xdc, 0x88, 0x05, 0xc6,
+			0x00, 0xbe, 0x02, 0xc6,
+			0x00, 0xbe, 0x36, 0x13,
+			0x4c, 0x17, 0x99, 0xc4,
+			0x80, 0x65, 0xd0, 0x49,
+			0x04, 0xf1, 0xfa, 0x75,
+			0x04, 0xc4, 0x00, 0xbc,
+			0x03, 0xc4, 0x00, 0xbc,
+			0x9a, 0x00, 0xee, 0x01 };
+		static u8 pla_patch_b[] = {
+			0x08, 0xe0, 0xea, 0xe0,
+			0xf2, 0xe0, 0x04, 0xe1,
+			0x09, 0xe1, 0x0e, 0xe1,
+			0x46, 0xe1, 0xf7, 0xe1,
+			0x14, 0xc2, 0x40, 0x73,
+			0xba, 0x48, 0x40, 0x9b,
+			0x11, 0xc2, 0x40, 0x73,
+			0xb0, 0x49, 0x17, 0xf0,
+			0xbf, 0x49, 0x03, 0xf1,
+			0x09, 0xc5, 0x00, 0xbd,
+			0xb1, 0x49, 0x11, 0xf0,
+			0xb1, 0x48, 0x40, 0x9b,
+			0x02, 0xc2, 0x00, 0xba,
+			0x1a, 0x17, 0x00, 0xe0,
+			0x1e, 0xfc, 0xbc, 0xc0,
+			0xf0, 0xc0, 0xde, 0xe8,
+			0x00, 0x80, 0x00, 0x20,
+			0x2c, 0x75, 0xd4, 0x49,
+			0x12, 0xf1, 0x32, 0xe0,
+			0xf8, 0xc2, 0x46, 0x71,
+			0xf7, 0xc2, 0x40, 0x73,
+			0xbe, 0x49, 0x03, 0xf1,
+			0xf5, 0xc7, 0x02, 0xe0,
+			0xf2, 0xc7, 0x4f, 0x30,
+			0x26, 0x62, 0xa1, 0x49,
+			0xf0, 0xf1, 0x22, 0x72,
+			0xa0, 0x49, 0xed, 0xf1,
+			0x25, 0x25, 0x18, 0x1f,
+			0x97, 0x30, 0x91, 0x30,
+			0x36, 0x9a, 0x2c, 0x75,
+			0x3c, 0xc3, 0x60, 0x73,
+			0xb1, 0x49, 0x0d, 0xf1,
+			0xdc, 0x21, 0xbc, 0x25,
+			0x30, 0xc6, 0xc0, 0x77,
+			0x04, 0x13, 0x21, 0xf0,
+			0x03, 0x13, 0x22, 0xf0,
+			0x02, 0x13, 0x23, 0xf0,
+			0x01, 0x13, 0x24, 0xf0,
+			0x08, 0x13, 0x08, 0xf1,
+			0x2e, 0x73, 0xba, 0x21,
+			0xbd, 0x25, 0x05, 0x13,
+			0x03, 0xf1, 0x24, 0xc5,
+			0x00, 0xbd, 0xd4, 0x49,
+			0x03, 0xf1, 0x1c, 0xc5,
+			0x00, 0xbd, 0xc4, 0xc6,
+			0xc6, 0x67, 0x2e, 0x75,
+			0xd7, 0x22, 0xdd, 0x26,
+			0x05, 0x15, 0x1b, 0xf0,
+			0x14, 0xc6, 0x00, 0xbe,
+			0x13, 0xc5, 0x00, 0xbd,
+			0x12, 0xc5, 0x00, 0xbd,
+			0xf1, 0x49, 0xfb, 0xf1,
+			0xef, 0xe7, 0xf4, 0x49,
+			0xfa, 0xf1, 0xec, 0xe7,
+			0xf3, 0x49, 0xf7, 0xf1,
+			0xe9, 0xe7, 0xf2, 0x49,
+			0xf4, 0xf1, 0xe6, 0xe7,
+			0xb6, 0xc0, 0x9e, 0x12,
+			0xde, 0x11, 0x0a, 0x12,
+			0x3c, 0x13, 0x00, 0xa0,
+			0xa0, 0xd1, 0x00, 0x00,
+			0xc0, 0x75, 0xd0, 0x49,
+			0x46, 0xf0, 0x26, 0x72,
+			0xa7, 0x49, 0x43, 0xf0,
+			0x22, 0x72, 0x25, 0x25,
+			0x20, 0x1f, 0x97, 0x30,
+			0x91, 0x30, 0x40, 0x73,
+			0xf3, 0xc4, 0x1c, 0x40,
+			0x04, 0xf0, 0xd7, 0x49,
+			0x05, 0xf1, 0x37, 0xe0,
+			0x53, 0x48, 0xc0, 0x9d,
+			0x08, 0x02, 0x40, 0x66,
+			0x64, 0x27, 0x06, 0x16,
+			0x30, 0xf1, 0x46, 0x63,
+			0x3b, 0x13, 0x2d, 0xf1,
+			0x34, 0x9b, 0x18, 0x1b,
+			0x93, 0x30, 0x2b, 0xc3,
+			0x10, 0x1c, 0x2b, 0xe8,
+			0x01, 0x14, 0x25, 0xf1,
+			0x00, 0x1d, 0x26, 0x1a,
+			0x8a, 0x30, 0x22, 0x73,
+			0xb5, 0x25, 0x0e, 0x0b,
+			0x00, 0x1c, 0x2c, 0xe8,
+			0x1f, 0xc7, 0x27, 0x40,
+			0x1a, 0xf1, 0x38, 0xe8,
+			0x32, 0x1f, 0x8f, 0x30,
+			0x08, 0x1b, 0x24, 0xe8,
+			0x36, 0x72, 0x46, 0x77,
+			0x00, 0x17, 0x0d, 0xf0,
+			0x13, 0xc3, 0x1f, 0x40,
+			0x03, 0xf1, 0x00, 0x1f,
+			0x46, 0x9f, 0x44, 0x77,
+			0x9f, 0x44, 0x5f, 0x44,
+			0x17, 0xe8, 0x0a, 0xc7,
+			0x27, 0x40, 0x05, 0xf1,
+			0x02, 0xc3, 0x00, 0xbb,
+			0xfa, 0x18, 0xb0, 0x18,
+			0xff, 0xc7, 0x00, 0xbf,
+			0xb8, 0xcd, 0xff, 0xff,
+			0x02, 0x0c, 0x54, 0xa5,
+			0xdc, 0xa5, 0x2f, 0x40,
+			0x05, 0xf1, 0x00, 0x14,
+			0xfa, 0xf1, 0x01, 0x1c,
+			0x02, 0xe0, 0x00, 0x1c,
+			0x80, 0xff, 0xb0, 0x49,
+			0x04, 0xf0, 0x01, 0x0b,
+			0xd3, 0xa1, 0x03, 0xe0,
+			0x02, 0x0b, 0xd3, 0xa5,
+			0x27, 0x31, 0x20, 0x37,
+			0x02, 0x0b, 0xd3, 0xa5,
+			0x27, 0x31, 0x20, 0x37,
+			0x00, 0x13, 0xfb, 0xf1,
+			0x80, 0xff, 0x22, 0x73,
+			0xb5, 0x25, 0x18, 0x1e,
+			0xde, 0x30, 0xd9, 0x30,
+			0x64, 0x72, 0x11, 0x1e,
+			0x68, 0x23, 0x16, 0x31,
+			0x80, 0xff, 0x08, 0xc2,
+			0x40, 0x73, 0x3a, 0x48,
+			0x40, 0x9b, 0x06, 0xff,
+			0x02, 0xc6, 0x00, 0xbe,
+			0x08, 0x16, 0x1e, 0xfc,
+			0x2c, 0x75, 0xdc, 0x21,
+			0xbc, 0x25, 0x04, 0x13,
+			0x0b, 0xf0, 0x03, 0x13,
+			0x09, 0xf0, 0x02, 0x13,
+			0x07, 0xf0, 0x01, 0x13,
+			0x05, 0xf0, 0x08, 0x13,
+			0x03, 0xf0, 0x04, 0xc3,
+			0x00, 0xbb, 0x03, 0xc3,
+			0x00, 0xbb, 0x8c, 0x15,
+			0x76, 0x15, 0xa0, 0x64,
+			0x40, 0x48, 0xa0, 0x8c,
+			0x02, 0xc4, 0x00, 0xbc,
+			0x82, 0x00, 0xa0, 0x62,
+			0x21, 0x48, 0xa0, 0x8a,
+			0x02, 0xc2, 0x00, 0xba,
+			0x40, 0x03, 0x33, 0xc5,
+			0xa0, 0x74, 0xc0, 0x49,
+			0x1f, 0xf0, 0x30, 0xc5,
+			0xa0, 0x73, 0x00, 0x13,
+			0x04, 0xf1, 0xa2, 0x73,
+			0x00, 0x13, 0x14, 0xf0,
+			0x28, 0xc5, 0xa0, 0x74,
+			0xc8, 0x49, 0x1b, 0xf1,
+			0x26, 0xc5, 0xa0, 0x76,
+			0xa2, 0x74, 0x01, 0x06,
+			0x20, 0x37, 0xa0, 0x9e,
+			0xa2, 0x9c, 0x1e, 0xc5,
+			0xa2, 0x73, 0x23, 0x40,
+			0x10, 0xf8, 0x04, 0xf3,
+			0xa0, 0x73, 0x33, 0x40,
+			0x0c, 0xf8, 0x15, 0xc5,
+			0xa0, 0x74, 0x41, 0x48,
+			0xa0, 0x9c, 0x14, 0xc5,
+			0xa0, 0x76, 0x62, 0x48,
+			0xe0, 0x48, 0xa0, 0x9e,
+			0x10, 0xc6, 0x00, 0xbe,
+			0x0a, 0xc5, 0xa0, 0x74,
+			0x48, 0x48, 0xa0, 0x9c,
+			0x0b, 0xc5, 0x20, 0x1e,
+			0xa0, 0x9e, 0xe5, 0x48,
+			0xa0, 0x9e, 0xf0, 0xe7,
+			0xbc, 0xc0, 0xc8, 0xd2,
+			0xcc, 0xd2, 0x28, 0xe4,
+			0xe6, 0x01, 0xf0, 0xc0,
+			0x18, 0x89, 0x00, 0x1d,
+			0x3c, 0xc3, 0x64, 0x71,
+			0x3c, 0xc0, 0x02, 0x99,
+			0x00, 0x61, 0x67, 0x11,
+			0x3c, 0xf1, 0x69, 0x33,
+			0x35, 0xc0, 0x28, 0x40,
+			0xf6, 0xf1, 0x34, 0xc0,
+			0x00, 0x19, 0x81, 0x1b,
+			0x91, 0xe8, 0x31, 0xc0,
+			0x04, 0x1a, 0x84, 0x1b,
+			0x8d, 0xe8, 0x82, 0xe8,
+			0xa3, 0x49, 0xfe, 0xf0,
+			0x2b, 0xc0, 0x7e, 0xe8,
+			0xa1, 0x48, 0x28, 0xc0,
+			0x84, 0x1b, 0x84, 0xe8,
+			0x00, 0x1d, 0x69, 0x33,
+			0x00, 0x1e, 0x01, 0x06,
+			0xff, 0x18, 0x30, 0x40,
+			0xfd, 0xf1, 0x19, 0xc0,
+			0x00, 0x76, 0x2e, 0x40,
+			0xf7, 0xf1, 0x21, 0x48,
+			0x19, 0xc0, 0x84, 0x1b,
+			0x75, 0xe8, 0x10, 0xc0,
+			0x69, 0xe8, 0xa1, 0x49,
+			0xfd, 0xf0, 0x11, 0xc0,
+			0x00, 0x1a, 0x84, 0x1b,
+			0x6d, 0xe8, 0x62, 0xe8,
+			0xa5, 0x49, 0xfe, 0xf0,
+			0x09, 0xc0, 0x01, 0x19,
+			0x81, 0x1b, 0x66, 0xe8,
+			0x54, 0xe0, 0x10, 0xd4,
+			0x88, 0xd3, 0xb8, 0x0b,
+			0x50, 0xe8, 0x20, 0xb4,
+			0x10, 0xd8, 0x84, 0xd4,
+			0xfd, 0xc0, 0x52, 0xe8,
+			0x48, 0x33, 0xf9, 0xc0,
+			0x00, 0x61, 0x9c, 0x20,
+			0x9c, 0x24, 0xd0, 0x49,
+			0x04, 0xf0, 0x04, 0x11,
+			0x02, 0xf1, 0x03, 0xe0,
+			0x00, 0x11, 0x06, 0xf1,
+			0x5c, 0xc0, 0x00, 0x61,
+			0x92, 0x48, 0x00, 0x89,
+			0x3a, 0xe0, 0x06, 0x11,
+			0x06, 0xf1, 0x55, 0xc0,
+			0x00, 0x61, 0x11, 0x48,
+			0x00, 0x89, 0x33, 0xe0,
+			0x05, 0x11, 0x08, 0xf1,
+			0x4e, 0xc0, 0x00, 0x61,
+			0x91, 0x49, 0x04, 0xf0,
+			0x91, 0x48, 0x00, 0x89,
+			0x11, 0xe0, 0xd9, 0xc0,
+			0x00, 0x61, 0x98, 0x20,
+			0x98, 0x24, 0x25, 0x11,
+			0x24, 0xf1, 0x44, 0xc0,
+			0x29, 0xe8, 0x95, 0x49,
+			0x20, 0xf0, 0xcf, 0xc0,
+			0x00, 0x61, 0x98, 0x20,
+			0x98, 0x24, 0x25, 0x11,
+			0x1a, 0xf1, 0x37, 0xc0,
+			0x00, 0x61, 0x92, 0x49,
+			0x16, 0xf1, 0x12, 0x48,
+			0x00, 0x89, 0x2f, 0xc0,
+			0x00, 0x19, 0x00, 0x89,
+			0x2d, 0xc0, 0x01, 0x89,
+			0x2d, 0xc0, 0x04, 0x19,
+			0x81, 0x1b, 0x1c, 0xe8,
+			0x2a, 0xc0, 0x14, 0x19,
+			0x81, 0x1b, 0x18, 0xe8,
+			0x21, 0xc0, 0x0c, 0xe8,
+			0x1f, 0xc0, 0x12, 0x48,
+			0x81, 0x1b, 0x12, 0xe8,
+			0xae, 0xc3, 0x66, 0x71,
+			0xae, 0xc0, 0x02, 0x99,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x96, 0x07, 0x13, 0xc4,
+			0x84, 0x98, 0x00, 0x1b,
+			0x86, 0x8b, 0x86, 0x73,
+			0xbf, 0x49, 0xfe, 0xf1,
+			0x80, 0x71, 0x82, 0x72,
+			0x80, 0xff, 0x09, 0xc4,
+			0x84, 0x98, 0x80, 0x99,
+			0x82, 0x9a, 0x86, 0x8b,
+			0x86, 0x73, 0xbf, 0x49,
+			0xfe, 0xf1, 0x80, 0xff,
+			0x08, 0xea, 0x30, 0xd4,
+			0x10, 0xc0, 0x12, 0xe8,
+			0x8a, 0xd3, 0x28, 0xe4,
+			0x2c, 0xe4, 0x00, 0xd8,
+			0x00, 0x00, 0x00, 0x00 };
+
+		r8153_pre_ram_code(tp, 0x8146, 0x7001);
+		sram_write(tp, 0xb820, 0x0290);
+		sram_write(tp, 0xa012, 0x0000);
+		sram_write(tp, 0xa014, 0x2c04);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c07);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c0a);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c0d);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa240);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa104);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x292d);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8620);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa480);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2a2c);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8480);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa101);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2a36);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd056);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2223);
+		sram_write(tp, 0xa01a, 0x0000);
+		sram_write(tp, 0xa006, 0x0222);
+		sram_write(tp, 0xa004, 0x0a35);
+		sram_write(tp, 0xa002, 0x0a2b);
+		sram_write(tp, 0xa000, 0xf92c);
+		sram_write(tp, 0xb820, 0x0210);
+		r8153_post_ram_code(tp, 0x8146);
+
+		r8153_wdt1_end(tp);
+		r8153_clear_bp(tp);
+
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_EN, 0x0000);
+		generic_ocp_write(tp, 0xf800, 0xff, sizeof(usb_patch_b),
+				  usb_patch_b, MCU_TYPE_USB);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc26, 0xa000);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc28, 0x180c);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc2a, 0x0506);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc2c, 0x04E0);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc2e, 0x11E4);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc30, 0x125C);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc32, 0x0232);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc34, 0x131E);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc36, 0x0098);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_EN, 0x00FF);
+
+		if (!(ocp_read_word(tp, MCU_TYPE_PLA, 0xd38e) & BIT(0))) {
+			ocp_write_word(tp, MCU_TYPE_PLA, 0xd38c, 0x0082);
+			ocp_write_word(tp, MCU_TYPE_PLA, 0xd38e, 0x0082);
+		}
+
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_EN, 0x0000);
+		generic_ocp_write(tp, 0xf800, 0xff, sizeof(pla_patch_b),
+				  pla_patch_b, MCU_TYPE_PLA);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc26, 0x8000);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc28, 0x1154);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2a, 0x1606);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2c, 0x155a);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2e, 0x0080);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc30, 0x033c);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc32, 0x01a0);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc34, 0x0794);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc36, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_EN, 0x007f);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xd388, 0x08ca);
+	} else if (tp->version == RTL_VER_05) {
+		u32 ocp_data;
+		static u8 usb_patch_c[] = {
+			0x08, 0xe0, 0x0a, 0xe0,
+			0x14, 0xe0, 0x58, 0xe0,
+			0x64, 0xe0, 0x79, 0xe0,
+			0xa8, 0xe0, 0xb3, 0xe0,
+			0x02, 0xc5, 0x00, 0xbd,
+			0x38, 0x3b, 0xdb, 0x49,
+			0x04, 0xf1, 0x06, 0xc3,
+			0x00, 0xbb, 0x5a, 0x02,
+			0x05, 0xc4, 0x03, 0xc3,
+			0x00, 0xbb, 0xa4, 0x04,
+			0x7e, 0x02, 0x30, 0xd4,
+			0x65, 0xc6, 0x66, 0x61,
+			0x92, 0x49, 0x12, 0xf1,
+			0x3e, 0xc0, 0x02, 0x61,
+			0x97, 0x49, 0x05, 0xf0,
+			0x3c, 0xc0, 0x00, 0x61,
+			0x90, 0x49, 0x0a, 0xf1,
+			0xca, 0x63, 0xb0, 0x49,
+			0x09, 0xf1, 0xb1, 0x49,
+			0x05, 0xf0, 0x32, 0xc0,
+			0x00, 0x71, 0x9e, 0x49,
+			0x03, 0xf1, 0xb0, 0x48,
+			0x05, 0xe0, 0x30, 0x48,
+			0xda, 0x61, 0x10, 0x48,
+			0xda, 0x89, 0x4a, 0xc6,
+			0xc0, 0x60, 0x85, 0x49,
+			0x03, 0xf0, 0x31, 0x48,
+			0x04, 0xe0, 0xb1, 0x48,
+			0xb2, 0x48, 0x0f, 0xe0,
+			0x30, 0x18, 0x1b, 0xc1,
+			0x0f, 0xe8, 0x1a, 0xc6,
+			0xc7, 0x65, 0xd0, 0x49,
+			0x05, 0xf0, 0x32, 0x48,
+			0x02, 0xc2, 0x00, 0xba,
+			0x3e, 0x16, 0x02, 0xc2,
+			0x00, 0xba, 0x48, 0x16,
+			0x02, 0xc2, 0x00, 0xba,
+			0x4a, 0x16, 0x02, 0xb4,
+			0x09, 0xc2, 0x40, 0x99,
+			0x0e, 0x48, 0x42, 0x98,
+			0x42, 0x70, 0x8e, 0x49,
+			0xfe, 0xf1, 0x02, 0xb0,
+			0x80, 0xff, 0xc0, 0xd4,
+			0xe4, 0x40, 0x20, 0xd4,
+			0xca, 0xcf, 0x00, 0xcf,
+			0x3c, 0xe4, 0x0c, 0xc0,
+			0x00, 0x63, 0xb5, 0x49,
+			0x09, 0xc0, 0x30, 0x18,
+			0x06, 0xc1, 0xea, 0xef,
+			0xf5, 0xc7, 0x02, 0xc0,
+			0x00, 0xb8, 0xd0, 0x10,
+			0xe4, 0x4b, 0x00, 0xd8,
+			0x14, 0xc3, 0x60, 0x61,
+			0x90, 0x49, 0x06, 0xf0,
+			0x11, 0xc3, 0x70, 0x61,
+			0x12, 0x48, 0x70, 0x89,
+			0x08, 0xe0, 0x0a, 0xc6,
+			0xd4, 0x61, 0x93, 0x48,
+			0xd4, 0x89, 0x02, 0xc1,
+			0x00, 0xb9, 0x72, 0x17,
+			0x02, 0xc1, 0x00, 0xb9,
+			0x9c, 0x15, 0x00, 0xd8,
+			0xef, 0xcf, 0x20, 0xd4,
+			0x2b, 0xc5, 0xa0, 0x77,
+			0x00, 0x1c, 0xa0, 0x9c,
+			0x28, 0xc5, 0xa0, 0x64,
+			0xc0, 0x48, 0xc1, 0x48,
+			0xc2, 0x48, 0xa0, 0x8c,
+			0xb1, 0x64, 0xc0, 0x48,
+			0xb1, 0x8c, 0x20, 0xc5,
+			0xa0, 0x64, 0x40, 0x48,
+			0x41, 0x48, 0xc2, 0x48,
+			0xa0, 0x8c, 0x19, 0xc5,
+			0xa4, 0x64, 0x44, 0x48,
+			0xa4, 0x8c, 0xb1, 0x64,
+			0x40, 0x48, 0xb1, 0x8c,
+			0x14, 0xc4, 0x80, 0x73,
+			0x13, 0xc4, 0x82, 0x9b,
+			0x11, 0x1b, 0x80, 0x9b,
+			0x0c, 0xc5, 0xa0, 0x64,
+			0x40, 0x48, 0x41, 0x48,
+			0x42, 0x48, 0xa0, 0x8c,
+			0x05, 0xc5, 0xa0, 0x9f,
+			0x02, 0xc5, 0x00, 0xbd,
+			0x6c, 0x3a, 0x1e, 0xfc,
+			0x10, 0xd8, 0x86, 0xd4,
+			0xf8, 0xcb, 0x20, 0xe4,
+			0x0a, 0xc0, 0x16, 0x61,
+			0x91, 0x48, 0x16, 0x89,
+			0x07, 0xc0, 0x11, 0x19,
+			0x0c, 0x89, 0x02, 0xc1,
+			0x00, 0xb9, 0x02, 0x06,
+			0x00, 0xd4, 0x40, 0xb4,
+			0xfe, 0xc0, 0x16, 0x61,
+			0x91, 0x48, 0x16, 0x89,
+			0xfb, 0xc0, 0x11, 0x19,
+			0x0c, 0x89, 0x02, 0xc1,
+			0x00, 0xb9, 0xd2, 0x05 };
+		static u8 pla_patch_c[] = {
+			0x5d, 0xe0, 0x07, 0xe0,
+			0x0f, 0xe0, 0x5a, 0xe0,
+			0x59, 0xe0, 0x1f, 0xe0,
+			0x57, 0xe0, 0x3e, 0xe1,
+			0x08, 0xc2, 0x40, 0x73,
+			0x3a, 0x48, 0x40, 0x9b,
+			0x06, 0xff, 0x02, 0xc6,
+			0x00, 0xbe, 0xcc, 0x17,
+			0x1e, 0xfc, 0x2c, 0x75,
+			0xdc, 0x21, 0xbc, 0x25,
+			0x04, 0x13, 0x0b, 0xf0,
+			0x03, 0x13, 0x09, 0xf0,
+			0x02, 0x13, 0x07, 0xf0,
+			0x01, 0x13, 0x05, 0xf0,
+			0x08, 0x13, 0x03, 0xf0,
+			0x04, 0xc3, 0x00, 0xbb,
+			0x03, 0xc3, 0x00, 0xbb,
+			0x50, 0x17, 0x3a, 0x17,
+			0x33, 0xc5, 0xa0, 0x74,
+			0xc0, 0x49, 0x1f, 0xf0,
+			0x30, 0xc5, 0xa0, 0x73,
+			0x00, 0x13, 0x04, 0xf1,
+			0xa2, 0x73, 0x00, 0x13,
+			0x14, 0xf0, 0x28, 0xc5,
+			0xa0, 0x74, 0xc8, 0x49,
+			0x1b, 0xf1, 0x26, 0xc5,
+			0xa0, 0x76, 0xa2, 0x74,
+			0x01, 0x06, 0x20, 0x37,
+			0xa0, 0x9e, 0xa2, 0x9c,
+			0x1e, 0xc5, 0xa2, 0x73,
+			0x23, 0x40, 0x10, 0xf8,
+			0x04, 0xf3, 0xa0, 0x73,
+			0x33, 0x40, 0x0c, 0xf8,
+			0x15, 0xc5, 0xa0, 0x74,
+			0x41, 0x48, 0xa0, 0x9c,
+			0x14, 0xc5, 0xa0, 0x76,
+			0x62, 0x48, 0xe0, 0x48,
+			0xa0, 0x9e, 0x10, 0xc6,
+			0x00, 0xbe, 0x0a, 0xc5,
+			0xa0, 0x74, 0x48, 0x48,
+			0xa0, 0x9c, 0x0b, 0xc5,
+			0x20, 0x1e, 0xa0, 0x9e,
+			0xe5, 0x48, 0xa0, 0x9e,
+			0xf0, 0xe7, 0xbc, 0xc0,
+			0xc8, 0xd2, 0xcc, 0xd2,
+			0x28, 0xe4, 0xfa, 0x01,
+			0xf0, 0xc0, 0x18, 0x89,
+			0x74, 0xc0, 0xcd, 0xe8,
+			0x80, 0x76, 0x00, 0x1d,
+			0x6e, 0xc3, 0x66, 0x62,
+			0xa0, 0x49, 0x06, 0xf0,
+			0x64, 0xc0, 0x02, 0x71,
+			0x60, 0x99, 0x62, 0xc1,
+			0x03, 0xe0, 0x5f, 0xc0,
+			0x60, 0xc1, 0x02, 0x99,
+			0x00, 0x61, 0x0f, 0x1b,
+			0x59, 0x41, 0x03, 0x13,
+			0x18, 0xf1, 0xe4, 0x49,
+			0x20, 0xf1, 0xe5, 0x49,
+			0x1e, 0xf0, 0x59, 0xc6,
+			0xd0, 0x73, 0xb7, 0x49,
+			0x08, 0xf0, 0x01, 0x0b,
+			0x80, 0x13, 0x03, 0xf0,
+			0xd0, 0x8b, 0x03, 0xe0,
+			0x3f, 0x48, 0xd0, 0x9b,
+			0x51, 0xc0, 0x10, 0x1a,
+			0x84, 0x1b, 0xb1, 0xe8,
+			0x4b, 0xc2, 0x40, 0x63,
+			0x30, 0x48, 0x0a, 0xe0,
+			0xe5, 0x49, 0x09, 0xf0,
+			0x47, 0xc0, 0x00, 0x1a,
+			0x84, 0x1b, 0xa7, 0xe8,
+			0x41, 0xc2, 0x40, 0x63,
+			0xb0, 0x48, 0x40, 0x8b,
+			0x67, 0x11, 0x3f, 0xf1,
+			0x69, 0x33, 0x32, 0xc0,
+			0x28, 0x40, 0xd2, 0xf1,
+			0x33, 0xc0, 0x00, 0x19,
+			0x81, 0x1b, 0x99, 0xe8,
+			0x30, 0xc0, 0x04, 0x1a,
+			0x84, 0x1b, 0x95, 0xe8,
+			0x8a, 0xe8, 0xa3, 0x49,
+			0xfe, 0xf0, 0x2a, 0xc0,
+			0x86, 0xe8, 0xa1, 0x48,
+			0x84, 0x1b, 0x8d, 0xe8,
+			0x00, 0x1d, 0x69, 0x33,
+			0x00, 0x1e, 0x01, 0x06,
+			0xff, 0x18, 0x30, 0x40,
+			0xfd, 0xf1, 0x1f, 0xc0,
+			0x00, 0x76, 0x2e, 0x40,
+			0xf7, 0xf1, 0x21, 0x48,
+			0x19, 0xc0, 0x84, 0x1b,
+			0x7e, 0xe8, 0x74, 0x08,
+			0x72, 0xe8, 0xa1, 0x49,
+			0xfd, 0xf0, 0x11, 0xc0,
+			0x00, 0x1a, 0x84, 0x1b,
+			0x76, 0xe8, 0x6b, 0xe8,
+			0xa5, 0x49, 0xfe, 0xf0,
+			0x09, 0xc0, 0x01, 0x19,
+			0x81, 0x1b, 0x6f, 0xe8,
+			0x5a, 0xe0, 0xb8, 0x0b,
+			0x50, 0xe8, 0x83, 0x00,
+			0x82, 0x00, 0x20, 0xb4,
+			0x10, 0xd8, 0x84, 0xd4,
+			0x88, 0xd3, 0x10, 0xe0,
+			0x00, 0xd8, 0x24, 0xd4,
+			0xf9, 0xc0, 0x57, 0xe8,
+			0x48, 0x33, 0xf3, 0xc0,
+			0x00, 0x61, 0x6a, 0xc0,
+			0x47, 0x11, 0x03, 0xf0,
+			0x57, 0x11, 0x05, 0xf1,
+			0x00, 0x61, 0x17, 0x48,
+			0x00, 0x89, 0x41, 0xe0,
+			0x9c, 0x20, 0x9c, 0x24,
+			0xd0, 0x49, 0x09, 0xf0,
+			0x04, 0x11, 0x07, 0xf1,
+			0x00, 0x61, 0x97, 0x49,
+			0x38, 0xf0, 0x97, 0x48,
+			0x00, 0x89, 0x2b, 0xe0,
+			0x00, 0x11, 0x05, 0xf1,
+			0x00, 0x61, 0x92, 0x48,
+			0x00, 0x89, 0x2f, 0xe0,
+			0x06, 0x11, 0x05, 0xf1,
+			0x00, 0x61, 0x11, 0x48,
+			0x00, 0x89, 0x29, 0xe0,
+			0x05, 0x11, 0x0f, 0xf1,
+			0x00, 0x61, 0x93, 0x49,
+			0x1a, 0xf1, 0x91, 0x49,
+			0x0a, 0xf0, 0x91, 0x48,
+			0x00, 0x89, 0x0f, 0xe0,
+			0xc6, 0xc0, 0x00, 0x61,
+			0x98, 0x20, 0x98, 0x24,
+			0x25, 0x11, 0x80, 0xff,
+			0xfa, 0xef, 0x17, 0xf1,
+			0x38, 0xc0, 0x1f, 0xe8,
+			0x95, 0x49, 0x13, 0xf0,
+			0xf4, 0xef, 0x11, 0xf1,
+			0x31, 0xc0, 0x00, 0x61,
+			0x92, 0x49, 0x0d, 0xf1,
+			0x12, 0x48, 0x00, 0x89,
+			0x29, 0xc0, 0x00, 0x19,
+			0x00, 0x89, 0x27, 0xc0,
+			0x01, 0x89, 0x23, 0xc0,
+			0x0e, 0xe8, 0x12, 0x48,
+			0x81, 0x1b, 0x15, 0xe8,
+			0xae, 0xc3, 0x66, 0x62,
+			0xa0, 0x49, 0x04, 0xf0,
+			0x64, 0x71, 0xa3, 0xc0,
+			0x02, 0x99, 0x02, 0xc0,
+			0x00, 0xb8, 0xd6, 0x07,
+			0x13, 0xc4, 0x84, 0x98,
+			0x00, 0x1b, 0x86, 0x8b,
+			0x86, 0x73, 0xbf, 0x49,
+			0xfe, 0xf1, 0x80, 0x71,
+			0x82, 0x72, 0x80, 0xff,
+			0x09, 0xc4, 0x84, 0x98,
+			0x80, 0x99, 0x82, 0x9a,
+			0x86, 0x8b, 0x86, 0x73,
+			0xbf, 0x49, 0xfe, 0xf1,
+			0x80, 0xff, 0x08, 0xea,
+			0x30, 0xd4, 0x10, 0xc0,
+			0x12, 0xe8, 0x8a, 0xd3,
+			0x00, 0xd8, 0x02, 0xc6,
+			0x00, 0xbe, 0xe0, 0x08 };
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xcfca);
+		ocp_data &= ~0x4000;
+		ocp_write_word(tp, MCU_TYPE_USB, 0xcfca, ocp_data);
+
+		r8153_pre_ram_code(tp, 0x8146, 0x7001);
+		sram_write(tp, 0xb820, 0x0290);
+		sram_write(tp, 0xa012, 0x0000);
+		sram_write(tp, 0xa014, 0x2c04);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c07);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c0a);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c0d);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa240);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa104);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x292d);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8620);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa480);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2a2c);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x8480);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa101);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2a36);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xd056);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2223);
+		sram_write(tp, 0xa01a, 0x0000);
+		sram_write(tp, 0xa006, 0x0222);
+		sram_write(tp, 0xa004, 0x0a35);
+		sram_write(tp, 0xa002, 0x0a2b);
+		sram_write(tp, 0xa000, 0xf92c);
+		sram_write(tp, 0xb820, 0x0210);
+		r8153_post_ram_code(tp, 0x8146);
+
+		r8153_wdt1_end(tp);
+		r8153_clear_bp(tp);
+
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_EN, 0x0000);
+		generic_ocp_write(tp, 0xf800, 0xff, sizeof(usb_patch_c),
+				  usb_patch_c, MCU_TYPE_USB);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc26, 0xa000);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc28, 0x3b34);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc2a, 0x027c);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc2c, 0x15de);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc2e, 0x10ce);
+		if (ocp_read_byte(tp, MCU_TYPE_USB, 0xcfef) & 1)
+			ocp_write_word(tp, MCU_TYPE_USB, 0xfc30, 0x1578);
+		else
+			ocp_write_word(tp, MCU_TYPE_USB, 0xfc30, 0x1adc);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc32, 0x3a28);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc34, 0x05f8);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc36, 0x05c8);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_EN, 0x00ff);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_EN, 0x0000);
+		generic_ocp_write(tp, 0xf800, 0xff, sizeof(pla_patch_c),
+				  pla_patch_c, MCU_TYPE_PLA);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc26, 0x8000);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc28, 0x1306);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2a, 0x17ca);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2c, 0x171e);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2e, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc30, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc32, 0x01b4);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc34, 0x07d4);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc36, 0x0894);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_EN, 0x00e6);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xd388, 0x08ca);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xd398, 0x0084);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xcfca);
+		ocp_data |= 0x4000;
+		ocp_write_word(tp, MCU_TYPE_USB, 0xcfca, ocp_data);
+
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, USB_USB2PHY);
+		ocp_data |= USB2PHY_L1 | USB2PHY_SUSPEND;
+		ocp_write_byte(tp, MCU_TYPE_USB, USB_USB2PHY, ocp_data);
+	} else if (tp->version == RTL_VER_06) {
+		u32 ocp_data;
+		static u8 usb_patch_d[] = {
+			0x08, 0xe0, 0x0e, 0xe0,
+			0x11, 0xe0, 0x24, 0xe0,
+			0x30, 0xe0, 0x38, 0xe0,
+			0x3a, 0xe0, 0x3c, 0xe0,
+			0x1e, 0xc3, 0x70, 0x61,
+			0x12, 0x48, 0x70, 0x89,
+			0x02, 0xc3, 0x00, 0xbb,
+			0x02, 0x17, 0x31, 0x19,
+			0x02, 0xc3, 0x00, 0xbb,
+			0x44, 0x14, 0x30, 0x18,
+			0x11, 0xc1, 0x05, 0xe8,
+			0x10, 0xc6, 0x02, 0xc2,
+			0x00, 0xba, 0x94, 0x17,
+			0x02, 0xb4, 0x09, 0xc2,
+			0x40, 0x99, 0x0e, 0x48,
+			0x42, 0x98, 0x42, 0x70,
+			0x8e, 0x49, 0xfe, 0xf1,
+			0x02, 0xb0, 0x80, 0xff,
+			0xc0, 0xd4, 0xe4, 0x40,
+			0x20, 0xd4, 0x0c, 0xc0,
+			0x00, 0x63, 0xb5, 0x49,
+			0x0c, 0xc0, 0x30, 0x18,
+			0x06, 0xc1, 0xed, 0xef,
+			0xf8, 0xc7, 0x02, 0xc0,
+			0x00, 0xb8, 0x38, 0x12,
+			0xe4, 0x4b, 0x00, 0xd8,
+			0x0c, 0x61, 0x95, 0x48,
+			0x96, 0x48, 0x92, 0x48,
+			0x93, 0x48, 0x0c, 0x89,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x0e, 0x06, 0x02, 0xc5,
+			0x00, 0xbd, 0x00, 0x00,
+			0x02, 0xc1, 0x00, 0xb9,
+			0x00, 0x00, 0x02, 0xc1,
+			0x00, 0xb9, 0x00, 0x00 };
+		static u8 pla_patch_d[] = {
+			0x03, 0xe0, 0x16, 0xe0,
+			0x30, 0xe0, 0x12, 0xc2,
+			0x40, 0x73, 0xb0, 0x49,
+			0x08, 0xf0, 0xb8, 0x49,
+			0x06, 0xf0, 0xb8, 0x48,
+			0x40, 0x9b, 0x0b, 0xc2,
+			0x40, 0x76, 0x05, 0xe0,
+			0x02, 0x61, 0x02, 0xc3,
+			0x00, 0xbb, 0x54, 0x08,
+			0x02, 0xc3, 0x00, 0xbb,
+			0x64, 0x08, 0x98, 0xd3,
+			0x1e, 0xfc, 0xfe, 0xc0,
+			0x02, 0x62, 0xa0, 0x48,
+			0x02, 0x8a, 0x00, 0x72,
+			0xa0, 0x49, 0x11, 0xf0,
+			0x13, 0xc1, 0x20, 0x62,
+			0x2e, 0x21, 0x2f, 0x25,
+			0x00, 0x71, 0x9f, 0x24,
+			0x0a, 0x40, 0x09, 0xf0,
+			0x00, 0x71, 0x18, 0x48,
+			0xa0, 0x49, 0x03, 0xf1,
+			0x9f, 0x48, 0x02, 0xe0,
+			0x1f, 0x48, 0x00, 0x99,
+			0x02, 0xc2, 0x00, 0xba,
+			0xac, 0x0c, 0x08, 0xe9,
+			0x36, 0xc0, 0x00, 0x61,
+			0x9c, 0x20, 0x9c, 0x24,
+			0x33, 0xc0, 0x07, 0x11,
+			0x05, 0xf1, 0x00, 0x61,
+			0x17, 0x48, 0x00, 0x89,
+			0x0d, 0xe0, 0x04, 0x11,
+			0x0b, 0xf1, 0x00, 0x61,
+			0x97, 0x49, 0x08, 0xf0,
+			0x97, 0x48, 0x00, 0x89,
+			0x23, 0xc0, 0x0e, 0xe8,
+			0x12, 0x48, 0x81, 0x1b,
+			0x15, 0xe8, 0x1f, 0xc0,
+			0x00, 0x61, 0x67, 0x11,
+			0x04, 0xf0, 0x02, 0xc0,
+			0x00, 0xb8, 0x42, 0x09,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x90, 0x08, 0x13, 0xc4,
+			0x84, 0x98, 0x00, 0x1b,
+			0x86, 0x8b, 0x86, 0x73,
+			0xbf, 0x49, 0xfe, 0xf1,
+			0x80, 0x71, 0x82, 0x72,
+			0x80, 0xff, 0x09, 0xc4,
+			0x84, 0x98, 0x80, 0x99,
+			0x82, 0x9a, 0x86, 0x8b,
+			0x86, 0x73, 0xbf, 0x49,
+			0xfe, 0xf1, 0x80, 0xff,
+			0x08, 0xea, 0x30, 0xd4,
+			0x50, 0xe8, 0x8a, 0xd3 };
+
+		r8153_pre_ram_code(tp, 0x8146, 0x7002);
+		sram_write(tp, 0xb820, 0x0290);
+		sram_write(tp, 0xa012, 0x0000);
+		sram_write(tp, 0xa014, 0x2c04);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c07);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c07);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2c07);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa240);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0xa104);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xb438, 0x2944);
+		sram_write(tp, 0xa01a, 0x0000);
+		sram_write(tp, 0xa006, 0x0fff);
+		sram_write(tp, 0xa004, 0x0fff);
+		sram_write(tp, 0xa002, 0x0fff);
+		sram_write(tp, 0xa000, 0x1943);
+		sram_write(tp, 0xb820, 0x0210);
+		r8153_post_ram_code(tp, 0x8146);
+
+		r8153_clear_bp(tp);
+
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_EN, 0x0000);
+		generic_ocp_write(tp, 0xf800, 0xff, sizeof(usb_patch_d),
+				  usb_patch_d, MCU_TYPE_USB);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc26, 0xa000);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc28, 0x16de);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc2a, 0x1442);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc2c, 0x1792);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc2e, 0x1236);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc30, 0x0606);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc32, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc34, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xfc36, 0x0000);
+		if (ocp_read_byte(tp, MCU_TYPE_USB, 0xcfef) & 1)
+			ocp_write_word(tp, MCU_TYPE_USB, USB_BP_EN, 0x001b);
+		else
+			ocp_write_word(tp, MCU_TYPE_USB, USB_BP_EN, 0x001a);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_EN, 0x0000);
+		generic_ocp_write(tp, 0xf800, 0xff, sizeof(pla_patch_d),
+				  pla_patch_d, MCU_TYPE_PLA);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc26, 0x8000);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc28, 0x0852);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2a, 0x0c92);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2c, 0x088c);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc2e, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc30, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc32, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc34, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xfc36, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_EN, 0x0007);
+
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, USB_USB2PHY);
+		ocp_data |= USB2PHY_L1 | USB2PHY_SUSPEND;
+		ocp_write_byte(tp, MCU_TYPE_USB, USB_USB2PHY, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xcfcc);
+		ocp_data |= BIT(9);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xcfcc, ocp_data);
+	}
+}
+
+static void r8153b_firmware(struct r8152 *tp)
+{
+	if (tp->version == RTL_VER_09) {
+		u32 ocp_data;
+		static u8 usb_patch2_b[] = {
+			0x10, 0xe0, 0x26, 0xe0,
+			0x3a, 0xe0, 0x58, 0xe0,
+			0x6c, 0xe0, 0x85, 0xe0,
+			0xa5, 0xe0, 0xbe, 0xe0,
+			0xd8, 0xe0, 0xdb, 0xe0,
+			0xdd, 0xe0, 0xdf, 0xe0,
+			0xe1, 0xe0, 0xe3, 0xe0,
+			0xe5, 0xe0, 0xe7, 0xe0,
+			0x16, 0xc0, 0x00, 0x75,
+			0xd1, 0x49, 0x0d, 0xf0,
+			0x0f, 0xc0, 0x0f, 0xc5,
+			0x00, 0x1e, 0x08, 0x9e,
+			0x0c, 0x9d, 0x0c, 0xc6,
+			0x0a, 0x9e, 0x8f, 0x1c,
+			0x0e, 0x8c, 0x0e, 0x74,
+			0xcf, 0x49, 0xfe, 0xf1,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x96, 0x31, 0x00, 0xdc,
+			0x24, 0xe4, 0x80, 0x02,
+			0x34, 0xd3, 0xff, 0xc3,
+			0x60, 0x72, 0xa1, 0x49,
+			0x0d, 0xf0, 0xf8, 0xc3,
+			0xf8, 0xc2, 0x00, 0x1c,
+			0x68, 0x9c, 0xf6, 0xc4,
+			0x6a, 0x9c, 0x6c, 0x9a,
+			0x8f, 0x1c, 0x6e, 0x8c,
+			0x6e, 0x74, 0xcf, 0x49,
+			0xfe, 0xf1, 0x04, 0xc0,
+			0x02, 0xc2, 0x00, 0xba,
+			0xa8, 0x28, 0xf8, 0xc7,
+			0xea, 0xc0, 0x00, 0x75,
+			0xd1, 0x49, 0x15, 0xf0,
+			0x19, 0xc7, 0x17, 0xc2,
+			0xec, 0x9a, 0x00, 0x19,
+			0xee, 0x89, 0xee, 0x71,
+			0x9f, 0x49, 0xfe, 0xf1,
+			0xea, 0x71, 0x9f, 0x49,
+			0x0a, 0xf0, 0xd9, 0xc2,
+			0xec, 0x9a, 0x00, 0x19,
+			0xe8, 0x99, 0x81, 0x19,
+			0xee, 0x89, 0xee, 0x71,
+			0x9f, 0x49, 0xfe, 0xf1,
+			0x06, 0xc3, 0x02, 0xc2,
+			0x00, 0xba, 0xf0, 0x1d,
+			0x4c, 0xe8, 0x00, 0xdc,
+			0x00, 0xd4, 0xcb, 0xc0,
+			0x00, 0x75, 0xd1, 0x49,
+			0x0d, 0xf0, 0xc4, 0xc0,
+			0xc4, 0xc5, 0x00, 0x1e,
+			0x08, 0x9e, 0xc2, 0xc6,
+			0x0a, 0x9e, 0x0c, 0x9d,
+			0x8f, 0x1c, 0x0e, 0x8c,
+			0x0e, 0x74, 0xcf, 0x49,
+			0xfe, 0xf1, 0x04, 0xc0,
+			0x02, 0xc1, 0x00, 0xb9,
+			0xc4, 0x16, 0x20, 0xd4,
+			0xb6, 0xc0, 0x00, 0x75,
+			0xd1, 0x48, 0x00, 0x9d,
+			0xe5, 0xc7, 0xaf, 0xc2,
+			0xec, 0x9a, 0x00, 0x19,
+			0xe8, 0x9a, 0x81, 0x19,
+			0xee, 0x89, 0xee, 0x71,
+			0x9f, 0x49, 0xfe, 0xf1,
+			0x2c, 0xc1, 0xec, 0x99,
+			0x81, 0x19, 0xee, 0x89,
+			0xee, 0x71, 0x9f, 0x49,
+			0xfe, 0xf1, 0x04, 0xc3,
+			0x02, 0xc2, 0x00, 0xba,
+			0x96, 0x1c, 0xc0, 0xd4,
+			0xc0, 0x88, 0x1e, 0xc6,
+			0xc0, 0x70, 0x8f, 0x49,
+			0x0e, 0xf0, 0x8f, 0x48,
+			0x93, 0xc6, 0xca, 0x98,
+			0x11, 0x18, 0xc8, 0x98,
+			0x16, 0xc0, 0xcc, 0x98,
+			0x8f, 0x18, 0xce, 0x88,
+			0xce, 0x70, 0x8f, 0x49,
+			0xfe, 0xf1, 0x0b, 0xe0,
+			0x43, 0xc6, 0x00, 0x18,
+			0xc8, 0x98, 0x0b, 0xc0,
+			0xcc, 0x98, 0x81, 0x18,
+			0xce, 0x88, 0xce, 0x70,
+			0x8f, 0x49, 0xfe, 0xf1,
+			0x02, 0xc0, 0x00, 0xb8,
+			0xf2, 0x19, 0x40, 0xd3,
+			0x20, 0xe4, 0x33, 0xc2,
+			0x40, 0x71, 0x91, 0x48,
+			0x40, 0x99, 0x30, 0xc2,
+			0x00, 0x19, 0x48, 0x99,
+			0xf8, 0xc1, 0x4c, 0x99,
+			0x81, 0x19, 0x4e, 0x89,
+			0x4e, 0x71, 0x9f, 0x49,
+			0xfe, 0xf1, 0x0b, 0xc1,
+			0x4c, 0x99, 0x81, 0x19,
+			0x4e, 0x89, 0x4e, 0x71,
+			0x9f, 0x49, 0xfe, 0xf1,
+			0x02, 0x71, 0x02, 0xc2,
+			0x00, 0xba, 0x0e, 0x34,
+			0x24, 0xe4, 0x19, 0xc2,
+			0x40, 0x71, 0x91, 0x48,
+			0x40, 0x99, 0x16, 0xc2,
+			0x00, 0x19, 0x48, 0x99,
+			0xde, 0xc1, 0x4c, 0x99,
+			0x81, 0x19, 0x4e, 0x89,
+			0x4e, 0x71, 0x9f, 0x49,
+			0xfe, 0xf1, 0xf1, 0xc1,
+			0x4c, 0x99, 0x81, 0x19,
+			0x4e, 0x89, 0x4e, 0x71,
+			0x9f, 0x49, 0xfe, 0xf1,
+			0x02, 0x71, 0x02, 0xc2,
+			0x00, 0xba, 0x60, 0x33,
+			0x34, 0xd3, 0x00, 0xdc,
+			0x1e, 0x89, 0x02, 0xc0,
+			0x00, 0xb8, 0xfa, 0x12,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x00, 0x00, 0x02, 0xc0,
+			0x00, 0xb8, 0x00, 0x00,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x00, 0x00, 0x02, 0xc0,
+			0x00, 0xb8, 0x00, 0x00,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x00, 0x00, 0x02, 0xc0,
+			0x00, 0xb8, 0x00, 0x00,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x00, 0x00, 0x00, 0x00 };
+		static u8 pla_patch2_b[] = {
+			0x05, 0xe0, 0x1b, 0xe0,
+			0x2c, 0xe0, 0x60, 0xe0,
+			0x73, 0xe0, 0x15, 0xc6,
+			0xc2, 0x64, 0xd2, 0x49,
+			0x06, 0xf1, 0xc4, 0x48,
+			0xc5, 0x48, 0xc6, 0x48,
+			0xc7, 0x48, 0x05, 0xe0,
+			0x44, 0x48, 0x45, 0x48,
+			0x46, 0x48, 0x47, 0x48,
+			0xc2, 0x8c, 0xc0, 0x64,
+			0x46, 0x48, 0xc0, 0x8c,
+			0x05, 0xc5, 0x02, 0xc4,
+			0x00, 0xbc, 0x18, 0x02,
+			0x06, 0xdc, 0xb0, 0xc0,
+			0x10, 0xc5, 0xa0, 0x77,
+			0xa0, 0x74, 0x46, 0x48,
+			0x47, 0x48, 0xa0, 0x9c,
+			0x0b, 0xc5, 0xa0, 0x74,
+			0x44, 0x48, 0x43, 0x48,
+			0xa0, 0x9c, 0x05, 0xc5,
+			0xa0, 0x9f, 0x02, 0xc5,
+			0x00, 0xbd, 0x3c, 0x03,
+			0x1c, 0xe8, 0x20, 0xe8,
+			0xd4, 0x49, 0x04, 0xf1,
+			0xd5, 0x49, 0x20, 0xf1,
+			0x28, 0xe0, 0x2a, 0xc7,
+			0xe0, 0x75, 0xda, 0x49,
+			0x14, 0xf0, 0x27, 0xc7,
+			0xe0, 0x75, 0xdc, 0x49,
+			0x10, 0xf1, 0x24, 0xc7,
+			0xe0, 0x75, 0x25, 0xc7,
+			0xe0, 0x74, 0x2c, 0x40,
+			0x0a, 0xfa, 0x1f, 0xc7,
+			0xe4, 0x75, 0xd0, 0x49,
+			0x09, 0xf1, 0x1c, 0xc5,
+			0xe6, 0x9d, 0x11, 0x1d,
+			0xe4, 0x8d, 0x04, 0xe0,
+			0x16, 0xc7, 0x00, 0x1d,
+			0xe4, 0x8d, 0xe0, 0x8e,
+			0x11, 0x1d, 0xe0, 0x8d,
+			0x07, 0xe0, 0x0c, 0xc7,
+			0xe0, 0x75, 0xda, 0x48,
+			0xe0, 0x9d, 0x0b, 0xc7,
+			0xe4, 0x8e, 0x02, 0xc4,
+			0x00, 0xbc, 0x28, 0x03,
+			0x02, 0xc4, 0x00, 0xbc,
+			0x14, 0x03, 0x12, 0xe8,
+			0x4e, 0xe8, 0x1c, 0xe6,
+			0x20, 0xe4, 0x80, 0x02,
+			0xa4, 0xc0, 0x12, 0xc2,
+			0x40, 0x73, 0xb0, 0x49,
+			0x08, 0xf0, 0xb8, 0x49,
+			0x06, 0xf0, 0xb8, 0x48,
+			0x40, 0x9b, 0x0b, 0xc2,
+			0x40, 0x76, 0x05, 0xe0,
+			0x02, 0x61, 0x02, 0xc3,
+			0x00, 0xbb, 0x0a, 0x0a,
+			0x02, 0xc3, 0x00, 0xbb,
+			0x1a, 0x0a, 0x98, 0xd3,
+			0x1e, 0xfc, 0xfe, 0xc0,
+			0x02, 0x62, 0xa0, 0x48,
+			0x02, 0x8a, 0x00, 0x72,
+			0xa0, 0x49, 0x11, 0xf0,
+			0x13, 0xc1, 0x20, 0x62,
+			0x2e, 0x21, 0x2f, 0x25,
+			0x00, 0x71, 0x9f, 0x24,
+			0x0a, 0x40, 0x09, 0xf0,
+			0x00, 0x71, 0x18, 0x48,
+			0xa0, 0x49, 0x03, 0xf1,
+			0x9f, 0x48, 0x02, 0xe0,
+			0x1f, 0x48, 0x00, 0x99,
+			0x02, 0xc2, 0x00, 0xba,
+			0xda, 0x0e, 0x08, 0xe9 };
+
+		r8153b_clear_bp(tp, MCU_TYPE_USB);
+		r8153b_clear_bp(tp, MCU_TYPE_PLA);
+
+		ocp_write_word(tp, MCU_TYPE_USB, 0xd340, 0x807d);
+
+		generic_ocp_write(tp, 0xe600, 0xff, sizeof(usb_patch2_b),
+				  usb_patch2_b, MCU_TYPE_USB);
+
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_BA, 0xa000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_0, 0x2a20);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_1, 0x28a6);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_2, 0x1dee);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_3, 0x16c2);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_4, 0x1c94);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_5, 0x19f0);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_6, 0x340c);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_7, 0x335e);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_8, 0x12f8);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_9, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_10, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_11, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_12, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_13, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_14, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_15, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP2_EN, 0x01ff);
+
+		generic_ocp_write(tp, 0xf800, 0xff, sizeof(pla_patch2_b),
+				  pla_patch2_b, MCU_TYPE_PLA);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_BA, 0x8000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_0, 0x0216);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_1, 0x0332);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_2, 0x030c);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_3, 0x0a08);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_4, 0x0ec0);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_5, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_6, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_7, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_EN, 0x001e);
+
+		if (ocp_read_byte(tp, MCU_TYPE_USB, 0xd81f) & BIT(2)) {
+			ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_BP_EN);
+			ocp_data |= BIT(0);
+			ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_EN, ocp_data);
+		}
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xd334);
+		ocp_data |= BIT(1);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xd334, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xd4e8);
+		ocp_data |= BIT(1);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xd4e8, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xcfcc);
+		ocp_data |= BIT(9);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xcfcc, ocp_data);
+	}
+}
+
+static void r8156_firmware(struct r8152 *tp)
+{
+	if (tp->version == RTL_TEST_01) {
+		static u8 usb3_patch_t[] = {
+			0x01, 0xe0, 0x05, 0xc7,
+			0xf6, 0x65, 0x02, 0xc0,
+			0x00, 0xb8, 0x40, 0x03,
+			0x00, 0xd4, 0x00, 0x00 };
+		u16 data;
+
+		ocp_reg_write(tp, 0xb87c, 0x8099);
+		ocp_reg_write(tp, 0xb87e, 0x2a50);
+		ocp_reg_write(tp, 0xb87c, 0x80a1);
+		ocp_reg_write(tp, 0xb87e, 0x2a50);
+		ocp_reg_write(tp, 0xb87c, 0x809a);
+		ocp_reg_write(tp, 0xb87e, 0x5010);
+		ocp_reg_write(tp, 0xb87c, 0x80a2);
+		ocp_reg_write(tp, 0xb87e, 0x500f);
+		ocp_reg_write(tp, 0xb87c, 0x8087);
+		ocp_reg_write(tp, 0xb87e, 0xc0cf);
+		ocp_reg_write(tp, 0xb87c, 0x8080);
+		ocp_reg_write(tp, 0xb87e, 0x0f16);
+		ocp_reg_write(tp, 0xb87c, 0x8089);
+		ocp_reg_write(tp, 0xb87e, 0x161b);
+		ocp_reg_write(tp, 0xb87c, 0x808a);
+		ocp_reg_write(tp, 0xb87e, 0x1b1f);
+
+		ocp_reg_write(tp, 0xac36, 0x0080);
+		ocp_reg_write(tp, 0xac4a, 0xff00);
+		data = ocp_reg_read(tp, 0xac34);
+		data &= ~BIT(4);
+		data |= BIT(2) | BIT(3);
+		ocp_reg_write(tp, 0xac34, data);
+
+		data = ocp_reg_read(tp, 0xac54);
+		data &= ~(BIT(9) | BIT(10));
+		ocp_reg_write(tp, 0xac54, data);
+		ocp_reg_write(tp, 0xb87c, 0x8099);
+		ocp_reg_write(tp, 0xb87e, 0x2050);
+		ocp_reg_write(tp, 0xb87c, 0x80a1);
+		ocp_reg_write(tp, 0xb87e, 0x2050);
+		ocp_reg_write(tp, 0xb87c, 0x809a);
+		ocp_reg_write(tp, 0xb87e, 0x5010);
+		ocp_reg_write(tp, 0xb87c, 0x80a2);
+		ocp_reg_write(tp, 0xb87e, 0x500f);
+		data = ocp_reg_read(tp, 0xac34);
+		data &= ~BIT(5);
+		data |= BIT(6) | BIT(7);
+		ocp_reg_write(tp, 0xac34, data);
+
+		if (r8153_patch_request(tp, true)) {
+			netif_err(tp, drv, tp->netdev,
+				  "patch request error\n");
+			return;
+		}
+
+		data = ocp_reg_read(tp, 0xb896);
+		data &= ~BIT(0);
+		ocp_reg_write(tp, 0xb896, data);
+		ocp_reg_write(tp, 0xb892, 0x0000);
+		ocp_reg_write(tp, 0xb88e, 0xc089);
+		ocp_reg_write(tp, 0xb890, 0xc1d0);
+		ocp_reg_write(tp, 0xb88e, 0xc08a);
+		ocp_reg_write(tp, 0xb890, 0xe0f0);
+		ocp_reg_write(tp, 0xb88e, 0xc08b);
+		ocp_reg_write(tp, 0xb890, 0xe0f0);
+		ocp_reg_write(tp, 0xb88e, 0xc08c);
+		ocp_reg_write(tp, 0xb890, 0xffff);
+		ocp_reg_write(tp, 0xb88e, 0xc08d);
+		ocp_reg_write(tp, 0xb890, 0xffff);
+		ocp_reg_write(tp, 0xb88e, 0xc08e);
+		ocp_reg_write(tp, 0xb890, 0xffff);
+		ocp_reg_write(tp, 0xb88e, 0xc08f);
+		ocp_reg_write(tp, 0xb890, 0xffff);
+		ocp_reg_write(tp, 0xb88e, 0xc090);
+		ocp_reg_write(tp, 0xb890, 0xff12);
+
+		ocp_reg_write(tp, 0xb88e, 0xc09a);
+		ocp_reg_write(tp, 0xb890, 0x191a);
+		ocp_reg_write(tp, 0xb88e, 0xc09b);
+		ocp_reg_write(tp, 0xb890, 0x191a);
+		ocp_reg_write(tp, 0xb88e, 0xc09e);
+		ocp_reg_write(tp, 0xb890, 0x1d1e);
+		ocp_reg_write(tp, 0xb88e, 0xc09f);
+		ocp_reg_write(tp, 0xb890, 0x1d1e);
+		ocp_reg_write(tp, 0xb88e, 0xc0a0);
+		ocp_reg_write(tp, 0xb890, 0x1f20);
+		ocp_reg_write(tp, 0xb88e, 0xc0a1);
+		ocp_reg_write(tp, 0xb890, 0x1f20);
+		ocp_reg_write(tp, 0xb88e, 0xc0a2);
+		ocp_reg_write(tp, 0xb890, 0x2122);
+		ocp_reg_write(tp, 0xb88e, 0xc0a3);
+		ocp_reg_write(tp, 0xb890, 0x2122);
+		ocp_reg_write(tp, 0xb88e, 0xc0a4);
+		ocp_reg_write(tp, 0xb890, 0x2324);
+		ocp_reg_write(tp, 0xb88e, 0xc0a5);
+		ocp_reg_write(tp, 0xb890, 0x2324);
+
+		ocp_reg_write(tp, 0xb88e, 0xc029);
+		ocp_reg_write(tp, 0xb890, 0xdff3);
+		ocp_reg_write(tp, 0xb88e, 0xc02a);
+		ocp_reg_write(tp, 0xb890, 0xf3f3);
+		ocp_reg_write(tp, 0xb88e, 0xc02b);
+		ocp_reg_write(tp, 0xb890, 0xf3f3);
+		ocp_reg_write(tp, 0xb88e, 0xc02c);
+		ocp_reg_write(tp, 0xb890, 0xf3ef);
+		ocp_reg_write(tp, 0xb88e, 0xc02d);
+		ocp_reg_write(tp, 0xb890, 0xf3ef);
+		ocp_reg_write(tp, 0xb88e, 0xc02e);
+		ocp_reg_write(tp, 0xb890, 0xebe7);
+		ocp_reg_write(tp, 0xb88e, 0xc02f);
+		ocp_reg_write(tp, 0xb890, 0xebe7);
+		ocp_reg_write(tp, 0xb88e, 0xc030);
+		ocp_reg_write(tp, 0xb890, 0xe4e2);
+		ocp_reg_write(tp, 0xb88e, 0xc031);
+		ocp_reg_write(tp, 0xb890, 0xe4e2);
+		ocp_reg_write(tp, 0xb88e, 0xc032);
+		ocp_reg_write(tp, 0xb890, 0xdfdf);
+		ocp_reg_write(tp, 0xb88e, 0xc033);
+		ocp_reg_write(tp, 0xb890, 0xdfdf);
+		ocp_reg_write(tp, 0xb88e, 0xc034);
+		ocp_reg_write(tp, 0xb890, 0xdfdf);
+		ocp_reg_write(tp, 0xb88e, 0xc035);
+		ocp_reg_write(tp, 0xb890, 0xdfdf);
+		ocp_reg_write(tp, 0xb88e, 0xc036);
+		ocp_reg_write(tp, 0xb890, 0xdfdf);
+		ocp_reg_write(tp, 0xb88e, 0xc037);
+		ocp_reg_write(tp, 0xb890, 0xdfdf);
+		ocp_reg_write(tp, 0xb88e, 0xc038);
+		ocp_reg_write(tp, 0xb890, 0xdfdf);
+		ocp_reg_write(tp, 0xb88e, 0xc039);
+		ocp_reg_write(tp, 0xb890, 0xdfdf);
+		ocp_reg_write(tp, 0xb88e, 0xc03a);
+		ocp_reg_write(tp, 0xb890, 0xdfdf);
+		ocp_reg_write(tp, 0xb88e, 0xc03b);
+		ocp_reg_write(tp, 0xb890, 0xdfdf);
+		ocp_reg_write(tp, 0xb88e, 0xc03c);
+		ocp_reg_write(tp, 0xb890, 0xdf00);
+
+		data = ocp_reg_read(tp, 0xb896);
+		data |= BIT(0);
+		ocp_reg_write(tp, 0xb896, data);
+
+		r8153_pre_ram_code(tp, 0x8024, 0x0000);
+
+		data = ocp_reg_read(tp, 0xb820);
+		data |= BIT(7);
+		ocp_reg_write(tp, 0xb820, data);
+
+		/* nc0_patch_RLE0847_171220_loop_test_USB */
+		sram_write(tp, 0xA016, 0x0000);
+		sram_write(tp, 0xA012, 0x0000);
+		sram_write(tp, 0xA014, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8027);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x802e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8035);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x806d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8077);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x808c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8091);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x12ad);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd708);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3709);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8017);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3bdd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x801f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc100);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x38c0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1034);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4061);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb902);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x37b8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1034);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x12ad);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd71e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5fa6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x12ad);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1044);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x12ad);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd708);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3b0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1032);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x12ed);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x12ad);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd708);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2109);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1032);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x12e5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa130);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa140);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd020);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8120);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa8c0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd020);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8140);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd093);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa63f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa73f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd09e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa180);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd0dc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa401);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd03b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1c4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x617d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8401);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd503);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcdc7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4013);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0f7a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8401);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8280);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0f7a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8208);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcc08);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x08ba);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x08c6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0ee6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x068b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0e9d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd719);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x34a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0da2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f1c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd75e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ffd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0dca);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd707);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5e67);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd719);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2f79);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0dc0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd75e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2a51);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0db6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffec);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa540);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1308);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x159e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc445);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xdb02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c28);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0608);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c47);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0542);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd00a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x408d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd075);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6045);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd05d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd07a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1b5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0771);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3b4d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x809f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2635);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0241);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2745);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0241);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x27d0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80aa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ec8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc446);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xdb04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa602);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd064);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd018);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1b0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x068b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0753);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x407b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0771);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2745);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0241);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x61da);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x608a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6306);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80c5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5e28);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2730);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80b1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80c5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0771);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8103);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc447);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xdb08);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x406d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c07);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd056);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1c2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ce1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x01ae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2734);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80c5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7f8a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c07);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd04e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1b2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd0a8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xdb08);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc447);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x26d7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8103);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x648a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5fbb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0ca0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0320);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80f0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa208);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc317);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2c51);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8103);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xdb10);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc448);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa620);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8710);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x41dd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa306);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x415f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa210);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c1f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0004);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa330);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc575);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8210);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8320);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2c59);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8103);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3a33);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80ff);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd098);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd191);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x609f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8306);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8110);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa320);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa210);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd006);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1e3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc30f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4093);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc033);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x02fb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa0f0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8208);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x02fb);
+		sram_write(tp, 0xA026, 0x0279);
+		sram_write(tp, 0xA024, 0x159c);
+		sram_write(tp, 0xA022, 0x0d94);
+		sram_write(tp, 0xA020, 0x0ee1);
+		sram_write(tp, 0xA006, 0x0f46);
+		sram_write(tp, 0xA004, 0x12e2);
+		sram_write(tp, 0xA002, 0x12ea);
+		sram_write(tp, 0xA000, 0x1034);
+		sram_write(tp, 0xA008, 0xff00);
+
+		/* nc2_patch_RLE0847_171109_USB */
+		sram_write(tp, 0xA016, 0x0020);
+		sram_write(tp, 0xA012, 0x0000);
+		sram_write(tp, 0xA014, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8014);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8018);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8024);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8056);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8062);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8069);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8080);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8708);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0390);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd37a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd21a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0508);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd164);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd04d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0441);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5fb4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcf0c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0437);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x010c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb60);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd71f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x61ee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd71f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x210c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x001a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f57);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbb80);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x605f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9b80);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1c3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd074);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfff1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb62);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb910);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd71f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7fae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9930);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb80);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8190);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x82a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x800a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8406);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa780);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd141);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd040);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0441);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5fb4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb82);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa70c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa190);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa2b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa00a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6041);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa402);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0441);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5fa7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x02ed);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd164);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd04d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0441);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5fb4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0450);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb401);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0236);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb808);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbb80);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1c3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd074);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x03f3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb17);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0441);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8ec0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0426);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae40);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0426);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cc0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0e80);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0426);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaec0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0426);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x34a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x012c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5d8e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0134);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb23);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0441);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8ec0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0426);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae40);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0426);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cc0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0e80);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0426);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaec0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0426);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5dee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0249);
+		sram_write(tp, 0xA10E, 0x0239);
+		sram_write(tp, 0xA10C, 0x0119);
+		sram_write(tp, 0xA10A, 0x03f2);
+		sram_write(tp, 0xA108, 0x0231);
+		sram_write(tp, 0xA106, 0x0413);
+		sram_write(tp, 0xA104, 0x0108);
+		sram_write(tp, 0xA102, 0x0506);
+		sram_write(tp, 0xA100, 0x038e);
+		sram_write(tp, 0xA110, 0x00ff);
+
+		/* uc2_patch_RLE0847_171006_calc_txcrc_reg_write_seq_USB */
+		sram_write(tp, 0xb87c, 0x82c1);
+		sram_write(tp, 0xb87e, 0xaf82);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcdaf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x82d6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf82);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd9af);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x82dc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0282);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xdc02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x830c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf03);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd7af);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0eea);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe4f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x69e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8169);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac23);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1ee0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x815d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad23);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1bf7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0ee0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffcf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad26);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfa02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0b99);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0283);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3cf6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0ee0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffcf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac26);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0302);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d70);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef96);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfefc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x69e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8169);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac24);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1ee0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x815d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad24);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1bf7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0ee0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffcf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad26);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfa02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8349);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0283);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3cf6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0ee0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffcf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac26);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0302);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x861d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef96);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfefc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf70f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe0ff);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcfad);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x27fa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf60f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf8f9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x69e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8375);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae16);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa001);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x83aa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae0e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x848f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae06);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa003);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0302);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x857e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef96);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfefd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf8f9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x69e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad2b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x16ee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00ee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00ee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x01ee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x01ee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x01ae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0ee1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x815d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf62c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe581);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5dbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8663);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0243);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x96fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfdfc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf9fa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef69);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe281);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa6e3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef13);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3905);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac2f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1da2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0417);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0285);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf0e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x815d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf62c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe581);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5dbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8663);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0243);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5cee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00ae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4412);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0284);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x20e6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe781);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa75d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0303);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef12);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c12);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1e13);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe281);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa4e3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5d03);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x030c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x260c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x341e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x121e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x13bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8666);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8d1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x09bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8669);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x866c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0243);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5cbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8675);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0243);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5cee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x02ef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x96fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfdfc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf9fa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef69);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa201);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0abf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x867b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x64ae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x22a2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x020a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7e02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3f2c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef64);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae15);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa203);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0abf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8681);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x64ae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x08bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8684);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6483);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c64);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c32);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1a63);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf81);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa81a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x961f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x66ef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x563d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0004);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad37);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1fd9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef79);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6602);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ee8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef16);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x290a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6902);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ee8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6c02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x435c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef97);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1916);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaed9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef96);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfefd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf8f9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x69bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8678);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2cad);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2879);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd103);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7202);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ee8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6f02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3f2c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa094);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x62e2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe381);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa7d1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8672);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x866f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x100d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x121f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1259);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x03a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0043);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef10);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1f13);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5903);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa100);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3a02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x851c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe681);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa4e7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5d03);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x03ef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x120c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x121e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x130c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x121e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x120c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x121e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x13bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8666);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8d1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x09bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8669);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x866c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0243);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5cbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8675);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0243);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5cee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x03ae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x06bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8675);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0243);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x96fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfdfc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf9fa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef69);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1f66);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8283);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c32);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef12);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8702);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ee8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef46);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3c00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x02ad);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2741);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef46);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2c00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x05bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8672);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x866f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2cbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x868a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8ef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x13bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x868d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8690);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0243);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x10bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x868a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8ef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1311);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8d02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ee8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x435c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2b02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x16ae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7ef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x96fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfdfc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf9fa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef69);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7802);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3f2c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad28);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ee2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe381);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa7d1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x03bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8672);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x866f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1259);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x03a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0014);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef13);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5903);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa100);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0da0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x900a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x13e7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x81a7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xee81);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae2f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa094);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x26d1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8672);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x866f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x100d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x161f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1259);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x03a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x000d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef10);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d14);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1f13);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5903);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa100);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x02ae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcdbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8675);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0243);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x96fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfdfc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf9fa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef69);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd209);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd100);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6602);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ee8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef32);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3b0e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad3f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x11ef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x12bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8669);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x866c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0243);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5c12);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaee8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef96);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfefd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf8f9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x69e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad2b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0602);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x85f0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0286);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x44e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8169);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf62c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe581);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x69e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x815d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf62c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe581);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5def);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x96fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfdfc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf9fa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef69);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xee81);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa400);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xee81);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xee81);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa601);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xee81);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xee81);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa300);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef96);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfefd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x44a6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe070);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb468);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xdab4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x68ff);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb468);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf0b6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3a20);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb638);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xeeb6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x38ff);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb638);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x10b5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0032);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x54b5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0076);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x10b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4e70);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb450);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x52b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4e66);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb44e);
+		sram_write(tp, 0xb85e, 0x03d1);
+		sram_write(tp, 0xb860, 0x0ee4);
+		sram_write(tp, 0xb862, 0x0fde);
+		sram_write(tp, 0xb864, 0xffff);
+		sram_write(tp, 0xb878, 0x0001);
+
+		data = ocp_reg_read(tp, 0xb820);
+		data &= ~BIT(7);
+		ocp_reg_write(tp, 0xb820, data);
+
+		/* uc_patch_RLE0847_171212_customer_USB */
+		sram_write(tp, 0x8586, 0xaf85);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x92af);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8598);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf85);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa1af);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x85a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0285);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa1af);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0414);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0286);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7e02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1273);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf10);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1cf8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf9e3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x83ab);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe0a6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa601);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x580f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa008);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4659);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0f9e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4239);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0aab);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ee0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffcf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad26);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07f7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0ead);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2729);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf60e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe283);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xab1f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x239f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x28e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb714);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe1b7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x155c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9fee);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0285);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfee0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffcf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad26);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0af7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0fe0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffcf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac27);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaf6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0fe2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x83ab);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1f23);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9f03);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf85);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa6fd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf8f9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfb02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x866d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1f77);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe0b7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2ee1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb72f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0286);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4ce0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb72c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe1b7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2d02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x864c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe0b7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2ae1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb72b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0286);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4ce0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb728);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe1b7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2902);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x864c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe0b7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x26e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb727);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0286);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x47d2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb8e6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb468);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe5b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x69d2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbce6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb468);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe4b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6902);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x866d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfffd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf8f9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfad2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00ef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x675e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0001);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1f46);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d71);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f7f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffad);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2803);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7fa0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x010d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4112);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa210);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe8fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfdfc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x04f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe0b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x62e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb463);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6901);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe4b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x62e5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb463);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf8f9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x69e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8016);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad2d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3bbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86fd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x08ac);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2832);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3f08);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad28);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x29d2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x03bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8703);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x023f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x080d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x11f6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2fef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x31e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8ff3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf627);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1b03);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaa01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x82e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8ff2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf627);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1b03);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaa01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8202);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86ca);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef69);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfefd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfbfa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef69);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf9f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf8f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf4e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8fed);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1c21);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1a92);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe08f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xeee1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8fef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef74);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe08f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf0e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8ff1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef64);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0217);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x70fc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfdef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x96fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xff04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2087);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0620);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8709);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0087);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cbb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa880);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xeea8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8070);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa880);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60a8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x18e8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa818);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60a8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1a00);
+		sram_write(tp, 0xb818, 0x040e);
+		sram_write(tp, 0xb81a, 0x1019);
+		sram_write(tp, 0xb81c, 0xffff);
+		sram_write(tp, 0xb81e, 0xffff);
+		sram_write(tp, 0xb832, 0x0003);
+
+		r8153_post_ram_code(tp, 0x8024);
+		ocp_reg_write(tp, 0xc414, 0x0200);
+
+		r8153_patch_request(tp, false);
+
+		r8156_lock_mian(tp, true);
+
+		sram_write(tp, 0x80c9, 0x3478);
+		sram_write(tp, 0x80d0, 0xfe8f);
+		sram_write(tp, 0x80ca, 0x7843);
+		sram_write(tp, 0x80cb, 0x43b0);
+		sram_write(tp, 0x80cb, 0x4380);
+		sram_write(tp, 0x80cc, 0xb00b);
+		sram_write(tp, 0x80cd, 0x0ba1);
+		sram_write(tp, 0x80d8, 0x1078);
+		sram_write(tp, 0x8016, 0x3f00);
+		sram_write(tp, 0x8fed, 0x0386);
+		sram_write(tp, 0x8fee, 0x86f4);
+		sram_write(tp, 0x8fef, 0xf486);
+		sram_write(tp, 0x8ff0, 0x86fd);
+		sram_write(tp, 0x8ff1, 0xfd28);
+		sram_write(tp, 0x8ff2, 0x285a);
+		sram_write(tp, 0x8ff3, 0x5a70);
+		sram_write(tp, 0x8ff4, 0x7000);
+		sram_write(tp, 0x8ff5, 0x005d);
+		sram_write(tp, 0x8ff6, 0x5d77);
+		sram_write(tp, 0x8ff7, 0x7778);
+		sram_write(tp, 0x8ff8, 0x785f);
+		sram_write(tp, 0x8ff9, 0x5f74);
+		sram_write(tp, 0x8ffa, 0x7478);
+		sram_write(tp, 0x8ffb, 0x7858);
+		sram_write(tp, 0x8ffc, 0x5870);
+		sram_write(tp, 0x8ffd, 0x7078);
+		sram_write(tp, 0x8ffe, 0x7850);
+		sram_write(tp, 0x8fff, 0x5000);
+		sram_write(tp, 0x80dd, 0x34a4);
+		sram_write(tp, 0x80e4, 0xfe7f);
+		sram_write(tp, 0x80e6, 0x4a19);
+		sram_write(tp, 0x80de, 0xa443);
+		sram_write(tp, 0x80df, 0x43a0);
+		sram_write(tp, 0x80df, 0x43a0);
+		sram_write(tp, 0x80e0, 0xa00a);
+		sram_write(tp, 0x80e1, 0x0a00);
+		sram_write(tp, 0x80e8, 0x700c);
+		sram_write(tp, 0x80e2, 0x0007);
+		sram_write(tp, 0x80e3, 0x07fe);
+		sram_write(tp, 0x80ec, 0x0e78);
+		sram_write(tp, 0x80b5, 0x42f7);
+		sram_write(tp, 0x80bc, 0xfaa4);
+		sram_write(tp, 0x80bf, 0x1f80);
+		sram_write(tp, 0x80be, 0xff1f);
+		sram_write(tp, 0x80b7, 0x4280);
+		sram_write(tp, 0x80b6, 0xf742);
+		sram_write(tp, 0x80b8, 0x800f);
+		sram_write(tp, 0x80b9, 0x0fab);
+		sram_write(tp, 0x80c1, 0x1e0a);
+		sram_write(tp, 0x80c0, 0x801e);
+		sram_write(tp, 0x80bd, 0xa4ff);
+		sram_write(tp, 0x80bb, 0x0bfa);
+		sram_write(tp, 0x80ba, 0xab0b);
+		ocp_reg_write(tp, OCP_SRAM_ADDR, 0x818d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x003d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x009b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00cb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00e5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00f2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00f9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00fd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00ff);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00c2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0065);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0034);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x001b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x000e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0007);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0003);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0001);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		sram_write(tp, 0x8163, 0xdb06);
+		sram_write(tp, 0x816a, 0xdb06);
+		sram_write(tp, 0x8171, 0xdb06);
+
+		r8156_lock_mian(tp, false);
+
+		r8153b_clear_bp(tp, MCU_TYPE_USB);
+
+		generic_ocp_write(tp, 0xe600, 0xff, sizeof(usb3_patch_t),
+				  usb3_patch_t, MCU_TYPE_USB);
+
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_BA, 0xa000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_0, 0x033e);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_1, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_2, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_3, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_4, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_5, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_6, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_7, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_8, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_9, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_10, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_11, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_12, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_13, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_14, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_15, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP2_EN, 0x0001);
+	}
+}
+
+static void r8153_aldps_en(struct r8152 *tp, bool enable)
+{
+	u16 data;
+
+	data = ocp_reg_read(tp, OCP_POWER_CFG);
+	if (enable) {
+		data |= EN_ALDPS;
+		ocp_reg_write(tp, OCP_POWER_CFG, data);
+	} else {
+		int i;
+
+		data &= ~EN_ALDPS;
+		ocp_reg_write(tp, OCP_POWER_CFG, data);
+		for (i = 0; i < 20; i++) {
+			usleep_range(1000, 2000);
+			if (ocp_read_word(tp, MCU_TYPE_PLA, 0xe000) & 0x0100)
+				break;
+		}
+	}
+
+	tp->ups_info.aldps = enable;
+}
+
+static void r8153_eee_en(struct r8152 *tp, bool enable)
+{
+	u32 ocp_data;
+	u16 config;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_EEE_CR);
+	config = ocp_reg_read(tp, OCP_EEE_CFG);
+
+	if (enable) {
+		ocp_data |= EEE_RX_EN | EEE_TX_EN;
+		config |= EEE10_EN;
+	} else {
+		ocp_data &= ~(EEE_RX_EN | EEE_TX_EN);
+		config &= ~EEE10_EN;
+	}
+
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_EEE_CR, ocp_data);
+	ocp_reg_write(tp, OCP_EEE_CFG, config);
+
+	tp->ups_info.eee = enable;
+}
+
+static void r8156_eee_en(struct r8152 *tp, bool enable)
+{
+	u16 config;
+
+	r8153_eee_en(tp, enable);
+
+	config = ocp_reg_read(tp, 0xa6d4);
+
+	if (enable)
+		config |= BIT(0);
+	else
+		config &= ~BIT(0);
+
+	ocp_reg_write(tp, 0xa6d4, config);
+}
+
+static void r8153_hw_phy_cfg(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u16 data;
+
+	/* disable ALDPS before updating the PHY parameters */
+	r8153_aldps_en(tp, false);
+
+	/* disable EEE before updating the PHY parameters */
+	r8153_eee_en(tp, false);
+	ocp_reg_write(tp, OCP_EEE_ADV, 0);
+
+	r8153_firmware(tp);
+
+	if (tp->version == RTL_VER_03) {
+		data = ocp_reg_read(tp, OCP_EEE_CFG);
+		data &= ~CTAP_SHORT_EN;
+		ocp_reg_write(tp, OCP_EEE_CFG, data);
+	}
+
+	data = ocp_reg_read(tp, OCP_POWER_CFG);
+	data |= EEE_CLKDIV_EN;
+	ocp_reg_write(tp, OCP_POWER_CFG, data);
+
+	data = ocp_reg_read(tp, OCP_DOWN_SPEED);
+	data |= EN_10M_BGOFF;
+	ocp_reg_write(tp, OCP_DOWN_SPEED, data);
+	data = ocp_reg_read(tp, OCP_POWER_CFG);
+	data |= EN_10M_PLLOFF;
+	ocp_reg_write(tp, OCP_POWER_CFG, data);
+	sram_write(tp, SRAM_IMPEDANCE, 0x0b13);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_PHY_PWR);
+	ocp_data |= PFM_PWM_SWITCH;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_PHY_PWR, ocp_data);
+
+	/* Enable LPF corner auto tune */
+	sram_write(tp, SRAM_LPF_CFG, 0xf70f);
+
+	/* Adjust 10M Amplitude */
+	sram_write(tp, SRAM_10M_AMP1, 0x00af);
+	sram_write(tp, SRAM_10M_AMP2, 0x0208);
+
+	if (tp->eee_en) {
+		r8153_eee_en(tp, true);
+		ocp_reg_write(tp, OCP_EEE_ADV, tp->eee_adv);
+	}
+
+	r8153_aldps_en(tp, true);
+	r8152b_enable_fc(tp);
+
+	switch (tp->version) {
+	case RTL_VER_03:
+	case RTL_VER_04:
+		break;
+	case RTL_VER_05:
+	case RTL_VER_06:
+	default:
+		r8153_u2p3en(tp, true);
+		break;
+	}
+
+	set_bit(PHY_RESET, &tp->flags);
+}
+
+static u32 r8152_efuse_read(struct r8152 *tp, u8 addr)
+{
+	u32 ocp_data;
+
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_EFUSE_CMD, EFUSE_READ_CMD | addr);
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_EFUSE_CMD);
+	ocp_data = (ocp_data & EFUSE_DATA_BIT16) << 9;	/* data of bit16 */
+	ocp_data |= ocp_read_word(tp, MCU_TYPE_PLA, PLA_EFUSE_DATA);
+
+	return ocp_data;
+}
+
+static void r8153b_hw_phy_cfg(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u16 data;
+
+	/* disable ALDPS before updating the PHY parameters */
+	r8153_aldps_en(tp, false);
+
+	/* disable EEE before updating the PHY parameters */
+	r8153_eee_en(tp, false);
+	ocp_reg_write(tp, OCP_EEE_ADV, 0);
+
+	/* U1/U2/L1 idle timer. 500 us */
+	ocp_write_word(tp, MCU_TYPE_USB, USB_U1U2_TIMER, 500);
+
+	r8153b_firmware(tp);
+
+	r8153b_green_en(tp, test_bit(GREEN_ETHERNET, &tp->flags));
+
+	data = sram_read(tp, SRAM_GREEN_CFG);
+	data |= R_TUNE_EN;
+	sram_write(tp, SRAM_GREEN_CFG, data);
+	data = ocp_reg_read(tp, OCP_NCTL_CFG);
+	data |= PGA_RETURN_EN;
+	ocp_reg_write(tp, OCP_NCTL_CFG, data);
+
+	/* ADC Bias Calibration:
+	 * read efuse offset 0x7d to get a 17-bit data. Remove the dummy/fake
+	 * bit (bit3) to rebuild the real 16-bit data. Write the data to the
+	 * ADC ioffset.
+	 */
+	ocp_data = r8152_efuse_read(tp, 0x7d);
+	data = (u16)(((ocp_data & 0x1fff0) >> 1) | (ocp_data & 0x7));
+	if (data != 0xffff)
+		ocp_reg_write(tp, OCP_ADC_IOFFSET, data);
+
+	/* ups mode tx-link-pulse timing adjustment:
+	 * rg_saw_cnt = OCP reg 0xC426 Bit[13:0]
+	 * swr_cnt_1ms_ini = 16000000 / rg_saw_cnt
+	 */
+	ocp_data = ocp_reg_read(tp, 0xc426);
+	ocp_data &= 0x3fff;
+	if (ocp_data) {
+		u32 swr_cnt_1ms_ini;
+
+		swr_cnt_1ms_ini = (16000000 / ocp_data) & SAW_CNT_1MS_MASK;
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_UPS_CFG);
+		ocp_data = (ocp_data & ~SAW_CNT_1MS_MASK) | swr_cnt_1ms_ini;
+		ocp_write_word(tp, MCU_TYPE_USB, USB_UPS_CFG, ocp_data);
+	}
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_PHY_PWR);
+	ocp_data |= PFM_PWM_SWITCH;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_PHY_PWR, ocp_data);
+
+#ifdef CONFIG_CTAP_SHORT_OFF
+	data = ocp_reg_read(tp, OCP_EEE_CFG);
+	data &= ~CTAP_SHORT_EN;
+	ocp_reg_write(tp, OCP_EEE_CFG, data);
+
+	tp->ups_info.ctap_short_off = true;
+#endif
+	/* Advnace EEE */
+	if (!r8153_patch_request(tp, true)) {
+		data = ocp_reg_read(tp, OCP_POWER_CFG);
+		data |= EEE_CLKDIV_EN;
+		ocp_reg_write(tp, OCP_POWER_CFG, data);
+		tp->ups_info.eee_ckdiv = true;
+
+		data = ocp_reg_read(tp, OCP_DOWN_SPEED);
+		data |= EN_EEE_CMODE | EN_EEE_1000 | EN_10M_CLKDIV;
+		ocp_reg_write(tp, OCP_DOWN_SPEED, data);
+		tp->ups_info.eee_cmod_lv = true;
+		tp->ups_info._10m_ckdiv = true;
+		tp->ups_info.eee_plloff_giga = true;
+
+		ocp_reg_write(tp, OCP_SYSCLK_CFG, 0);
+		ocp_reg_write(tp, OCP_SYSCLK_CFG, clk_div_expo(5));
+		tp->ups_info._250m_ckdiv = true;
+
+		r8153_patch_request(tp, false);
+	}
+
+	if (tp->eee_en) {
+		r8153_eee_en(tp, true);
+		ocp_reg_write(tp, OCP_EEE_ADV, tp->eee_adv);
+	}
+
+	r8153_aldps_en(tp, true);
+	r8152b_enable_fc(tp);
+//	r8153_u2p3en(tp, true);
+
+	set_bit(PHY_RESET, &tp->flags);
+}
+
+static void r8153_first_init(struct r8152 *tp)
+{
+	u32 ocp_data;
+	int i;
+
+	rxdy_gated_en(tp, true);
+	r8153_teredo_off(tp);
+
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, PLA_RCR);
+	ocp_data &= ~RCR_ACPT_ALL;
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, ocp_data);
+
+	rtl8152_nic_reset(tp);
+	rtl_reset_bmu(tp);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+	ocp_data &= ~NOW_IS_OOB;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7);
+	ocp_data &= ~MCU_BORW_EN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7, ocp_data);
+
+	for (i = 0; i < 1000; i++) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+		if (ocp_data & LINK_LIST_READY)
+			break;
+		usleep_range(1000, 2000);
+	}
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7);
+	ocp_data |= RE_INIT_LL;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7, ocp_data);
+
+	for (i = 0; i < 1000; i++) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+		if (ocp_data & LINK_LIST_READY)
+			break;
+		usleep_range(1000, 2000);
+	}
+
+	rtl_rx_vlan_en(tp, tp->netdev->features & NETIF_F_HW_VLAN_CTAG_RX);
+
+	ocp_data = tp->netdev->mtu + VLAN_ETH_HLEN + ETH_FCS_LEN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_RMS, ocp_data);
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_MTPS, MTPS_JUMBO);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_TCR0);
+	ocp_data |= TCR0_AUTO_FIFO;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_TCR0, ocp_data);
+
+	rtl8152_nic_reset(tp);
+
+	/* rx share fifo credit full threshold */
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL0, RXFIFO_THR1_NORMAL);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL1, RXFIFO_THR2_NORMAL);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_RXFIFO_CTRL2, RXFIFO_THR3_NORMAL);
+	/* TX share fifo free credit full threshold */
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_TXFIFO_CTRL, TXFIFO_THR_NORMAL2);
+}
+
+static void r8153_enter_oob(struct r8152 *tp)
+{
+	u32 ocp_data;
+	int i;
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+	ocp_data &= ~NOW_IS_OOB;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL, ocp_data);
+
+	rtl_disable(tp);
+	rtl_reset_bmu(tp);
+
+	for (i = 0; i < 1000; i++) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+		if (ocp_data & LINK_LIST_READY)
+			break;
+		usleep_range(1000, 2000);
+	}
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7);
+	ocp_data |= RE_INIT_LL;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7, ocp_data);
+
+	for (i = 0; i < 1000; i++) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+		if (ocp_data & LINK_LIST_READY)
+			break;
+		usleep_range(1000, 2000);
+	}
+
+	ocp_data = tp->netdev->mtu + VLAN_ETH_HLEN + ETH_FCS_LEN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_RMS, ocp_data);
+
+	switch (tp->version) {
+	case RTL_VER_03:
+	case RTL_VER_04:
+	case RTL_VER_05:
+	case RTL_VER_06:
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_TEREDO_CFG);
+		ocp_data &= ~TEREDO_WAKE_MASK;
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_TEREDO_CFG, ocp_data);
+		break;
+
+	case RTL_VER_08:
+	case RTL_VER_09:
+		/* Clear teredo wake event. bit[15:8] is the teredo wakeup
+		 * type. Set it to zero. bits[7:0] are the W1C bits about
+		 * the events. Set them to all 1 to clear them.
+		 */
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_TEREDO_WAKE_BASE, 0x00ff);
+		break;
+
+	default:
+		break;
+	}
+
+	rtl_rx_vlan_en(tp, true);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PAL_BDC_CR);
+	ocp_data |= ALDPS_PROXY_MODE;
+	ocp_write_word(tp, MCU_TYPE_PLA, PAL_BDC_CR, ocp_data);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+	ocp_data |= NOW_IS_OOB | DIS_MCU_CLROOB;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL, ocp_data);
+
+	rxdy_gated_en(tp, false);
+
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, PLA_RCR);
+	ocp_data |= RCR_APM | RCR_AM | RCR_AB;
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, ocp_data);
+}
+
+static void rtl8153_disable(struct r8152 *tp)
+{
+	r8153_aldps_en(tp, false);
+	rtl_disable(tp);
+	rtl_reset_bmu(tp);
+	r8153_aldps_en(tp, true);
+}
+
+static int rtl8156_enable(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u16 speed;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return -ENODEV;
+
+	set_tx_qlen(tp);
+	rtl_set_eee_plus(tp);
+	r8153_set_rx_early_timeout(tp);
+	r8153_set_rx_early_size(tp);
+
+	switch (tp->version) {
+	case RTL_TEST_01:
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, 0xe95a);
+		ocp_data &= ~0xf;
+		ocp_data |= 5;
+		ocp_write_byte(tp, MCU_TYPE_PLA, 0xe95a, ocp_data);
+
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, 0xe940);
+		ocp_data &= ~0x1f;
+		ocp_data |= 4;
+		ocp_write_byte(tp, MCU_TYPE_PLA, 0xe940, ocp_data);
+		break;
+	default:
+		break;
+	}
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_TCR1);
+	ocp_data &= ~(BIT(3) | BIT(9) | BIT(8));
+	speed = rtl8152_get_speed(tp);
+	if ((speed & (_10bps | _100bps)) && !(speed & FULL_DUP)) {
+		ocp_data |= BIT(9);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_TCR1, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4);
+		ocp_data &= ~BIT(8);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4, ocp_data);
+	} else {
+		ocp_data |= BIT(9) | BIT(8);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_TCR1, ocp_data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4);
+		ocp_data |= BIT(8);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4, ocp_data);
+	}
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4);
+	if (speed & _2500bps)
+		ocp_data &= ~BIT(6);
+	else
+		ocp_data |= BIT(6);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4, ocp_data);
+
+	if (speed & _1000bps)
+		ocp_write_byte(tp, MCU_TYPE_PLA, 0xe04c, 0x11);
+	else if (speed & _500bps)
+		ocp_write_byte(tp, MCU_TYPE_PLA, 0xe04c, 0x3d);
+
+	return rtl_enable(tp);
+}
+
+static int rtl8152_set_speed(struct r8152 *tp, u8 autoneg, u32 speed, u8 duplex,
+			     u32 advertising)
+{
+	u16 bmcr;
+	int ret = 0;
+
+	if (autoneg == AUTONEG_DISABLE) {
+		if (duplex != DUPLEX_HALF && duplex != DUPLEX_FULL)
+			return -EINVAL;
+
+		switch (speed) {
+		case SPEED_10:
+			bmcr = BMCR_SPEED10;
+			if (duplex == DUPLEX_FULL) {
+				bmcr |= BMCR_FULLDPLX;
+				tp->ups_info.speed_duplex = FORCE_10M_FULL;
+			} else {
+				tp->ups_info.speed_duplex = FORCE_10M_HALF;
+			}
+			break;
+		case SPEED_100:
+			bmcr = BMCR_SPEED100;
+			if (duplex == DUPLEX_FULL) {
+				bmcr |= BMCR_FULLDPLX;
+				tp->ups_info.speed_duplex = FORCE_100M_FULL;
+			} else {
+				tp->ups_info.speed_duplex = FORCE_100M_HALF;
+			}
+			break;
+		case SPEED_1000:
+			if (tp->mii.supports_gmii) {
+				bmcr = BMCR_SPEED1000 | BMCR_FULLDPLX;
+				tp->ups_info.speed_duplex = NWAY_1000M_FULL;
+				break;
+			}
+		default:
+			ret = -EINVAL;
+			goto out;
+		}
+
+		if (duplex == DUPLEX_FULL)
+			tp->mii.full_duplex = 1;
+		else
+			tp->mii.full_duplex = 0;
+
+		tp->mii.force_media = 1;
+	} else {
+		u16 anar, tmp1;
+		u32 support;
+
+		support = ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full |
+			  ADVERTISED_100baseT_Half |
+			  ADVERTISED_100baseT_Full;
+
+		if (tp->mii.supports_gmii) {
+			support |= ADVERTISED_1000baseT_Full;
+
+			if (tp->support_2500full)
+				support |= ADVERTISED_2500baseX_Full;
+		}
+
+		if (!(advertising & support))
+			return -EINVAL;
+
+		anar = r8152_mdio_read(tp, MII_ADVERTISE);
+		tmp1 = anar & ~(ADVERTISE_10HALF | ADVERTISE_10FULL |
+				ADVERTISE_100HALF | ADVERTISE_100FULL);
+		if (advertising & ADVERTISED_10baseT_Half) {
+			tmp1 |= ADVERTISE_10HALF;
+			tp->ups_info.speed_duplex = NWAY_10M_HALF;
+		}
+		if (advertising & ADVERTISED_10baseT_Full) {
+			tmp1 |= ADVERTISE_10FULL;
+			tp->ups_info.speed_duplex = NWAY_10M_FULL;
+		}
+
+		if (advertising & ADVERTISED_100baseT_Half) {
+			tmp1 |= ADVERTISE_100HALF;
+			tp->ups_info.speed_duplex = NWAY_100M_HALF;
+		}
+		if (advertising & ADVERTISED_100baseT_Full) {
+			tmp1 |= ADVERTISE_100FULL;
+			tp->ups_info.speed_duplex = NWAY_100M_FULL;
+		}
+
+		if (anar != tmp1) {
+			r8152_mdio_write(tp, MII_ADVERTISE, tmp1);
+			tp->mii.advertising = tmp1;
+		}
+
+		if (tp->mii.supports_gmii) {
+			u16 gbcr, tmp2 = 0;
+
+			gbcr = r8152_mdio_read(tp, MII_CTRL1000);
+			tmp2 = gbcr & ~(ADVERTISE_1000FULL |
+					ADVERTISE_1000HALF);
+
+			if (advertising & ADVERTISED_1000baseT_Half) {
+				tmp2 |= ADVERTISE_1000HALF;
+				tp->ups_info.speed_duplex = NWAY_1000M_FULL;
+			}
+			if (advertising & ADVERTISED_1000baseT_Full) {
+				tmp2 |= ADVERTISE_1000FULL;
+				tp->ups_info.speed_duplex = NWAY_1000M_FULL;
+			}
+
+			if (gbcr != tmp2)
+				r8152_mdio_write(tp, MII_CTRL1000, tmp2);
+
+			gbcr = ocp_reg_read(tp, 0xa5d4);
+			tmp2 = gbcr & ~BIT(7);
+
+			if (advertising & ADVERTISED_2500baseX_Full)
+				tmp2 |= BIT(7);
+
+			if (gbcr != tmp2)
+				ocp_reg_write(tp, 0xa5d4, tmp2);
+		}
+
+		bmcr = BMCR_ANENABLE | BMCR_ANRESTART;
+
+		tp->mii.force_media = 0;
+	}
+
+	if (test_and_clear_bit(PHY_RESET, &tp->flags))
+		bmcr |= BMCR_RESET;
+
+	r8152_mdio_write(tp, MII_BMCR, bmcr);
+
+	if (bmcr & BMCR_RESET) {
+		int i;
+
+		for (i = 0; i < 50; i++) {
+			msleep(20);
+			if ((r8152_mdio_read(tp, MII_BMCR) & BMCR_RESET) == 0)
+				break;
+		}
+	}
+
+out:
+	return ret;
+}
+
+static bool rtl_speed_down(struct r8152 *tp)
+{
+	bool ret = false;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return ret;
+
+	if ((tp->saved_wolopts & WAKE_ANY) && !(tp->saved_wolopts & WAKE_PHY)) {
+		u16 bmcr;
+
+		bmcr = r8152_mdio_read(tp, MII_BMCR);
+
+		if (netif_carrier_ok(tp->netdev) && (bmcr & BMCR_ANENABLE) &&
+		    (r8152_mdio_read(tp, MII_EXPANSION) & EXPANSION_NWAY)) {
+			u16 anar, gbcr = 0, lpa, gbcr2 = 0;
+
+			anar = r8152_mdio_read(tp, MII_ADVERTISE);
+			anar &= ~(ADVERTISE_10HALF | ADVERTISE_10FULL |
+				  ADVERTISE_100HALF | ADVERTISE_100FULL);
+
+			if (tp->mii.supports_gmii) {
+				gbcr = r8152_mdio_read(tp, MII_CTRL1000);
+				gbcr &= ~(ADVERTISE_1000FULL |
+					  ADVERTISE_1000HALF);
+				if (tp->support_2500full) {
+					gbcr2 = ocp_reg_read(tp, 0xa5d4);
+					gbcr2 &= ~BIT(7);
+				}
+			}
+
+			lpa = r8152_mdio_read(tp, MII_LPA);
+			if (lpa & (LPA_10HALF | LPA_10FULL)) {
+				anar |= ADVERTISE_10HALF | ADVERTISE_10FULL;
+			} else if (lpa & (LPA_100HALF | LPA_100FULL)) {
+				anar |= ADVERTISE_10HALF | ADVERTISE_10FULL |
+					ADVERTISE_100HALF | ADVERTISE_100FULL;
+			} else {
+				goto out1;
+			}
+
+			if (tp->mii.supports_gmii) {
+				r8152_mdio_write(tp, MII_CTRL1000, gbcr);
+				if (tp->support_2500full)
+					ocp_reg_write(tp, 0xa5d4, gbcr2);
+			}
+
+			r8152_mdio_write(tp, MII_ADVERTISE, anar);
+			r8152_mdio_write(tp, MII_BMCR, bmcr | BMCR_ANRESTART);
+
+			set_bit(RECOVER_SPEED, &tp->flags);
+			ret = true;
+		}
+	}
+
+out1:
+	return ret;
+}
+
+static void rtl8152_up(struct r8152 *tp)
+{
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	r8152_aldps_en(tp, false);
+	r8152b_exit_oob(tp);
+	r8152_aldps_en(tp, true);
+}
+
+static void rtl8152_down(struct r8152 *tp)
+{
+	if (test_bit(RTL8152_UNPLUG, &tp->flags)) {
+		rtl_drop_queued_tx(tp);
+		return;
+	}
+
+	r8152_power_cut_en(tp, false);
+	r8152_aldps_en(tp, false);
+	r8152b_enter_oob(tp);
+	r8152_aldps_en(tp, true);
+}
+
+static void rtl8153_up(struct r8152 *tp)
+{
+	u32 ocp_data;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	r8153_u1u2en(tp, false);
+	r8153_u2p3en(tp, false);
+	r8153_aldps_en(tp, false);
+	r8153_mac_clk_spd(tp, false);
+	r8153_first_init(tp);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, 0xe90a);
+	ocp_data |= BIT(0);
+	ocp_write_byte(tp, MCU_TYPE_PLA, 0xe90a, ocp_data);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, 0xe007);
+	ocp_data &= ~BIT(7);
+	ocp_write_byte(tp, MCU_TYPE_PLA, 0xe007, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xb426);
+	ocp_data &= ~BIT(1);
+	ocp_write_word(tp, MCU_TYPE_USB, 0xb426, ocp_data);
+
+	if (!work_busy(&tp->hw_phy_work.work)) {
+		r8153_aldps_en(tp, true);
+
+		switch (tp->version) {
+		case RTL_VER_03:
+		case RTL_VER_04:
+			break;
+		case RTL_VER_05:
+		case RTL_VER_06:
+		default:
+			r8153_u2p3en(tp, true);
+			break;
+		}
+	}
+
+	r8153_u1u2en(tp, true);
+}
+
+static void rtl8153_down(struct r8152 *tp)
+{
+	u32 ocp_data;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags)) {
+		rtl_drop_queued_tx(tp);
+		return;
+	}
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, 0xe90a);
+	ocp_data &= ~BIT(0);
+	ocp_write_byte(tp, MCU_TYPE_PLA, 0xe90a, ocp_data);
+
+	r8153_u1u2en(tp, false);
+	r8153_u2p3en(tp, false);
+	r8153_power_cut_en(tp, false);
+	r8153_aldps_en(tp, false);
+	r8153_mac_clk_spd(tp, true);
+	r8153_enter_oob(tp);
+	r8153_aldps_en(tp, true);
+}
+
+static void rtl8153b_up(struct r8152 *tp)
+{
+	u32 ocp_data;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	r8153b_u1u2en(tp, false);
+	r8153_u2p3en(tp, false);
+	r8153_aldps_en(tp, false);
+
+	r8153_first_init(tp);
+	ocp_write_dword(tp, MCU_TYPE_USB, USB_RX_BUF_TH, RX_THR_B);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3);
+	ocp_data &= ~BIT(14);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3, ocp_data);
+
+	if (!work_busy(&tp->hw_phy_work.work)) {
+		r8153_aldps_en(tp, true);
+//		r8153_u2p3en(tp, true);
+	}
+
+	r8153b_u1u2en(tp, true);
+}
+
+static void rtl8153b_down(struct r8152 *tp)
+{
+	u32 ocp_data;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags)) {
+		rtl_drop_queued_tx(tp);
+		return;
+	}
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3);
+	ocp_data |= BIT(14);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3, ocp_data);
+
+	r8153b_u1u2en(tp, false);
+	r8153_u2p3en(tp, false);
+	r8153b_power_cut_en(tp, false);
+	r8153_aldps_en(tp, false);
+	r8153_enter_oob(tp);
+	r8153_aldps_en(tp, true);
+}
+
+static void rtl8156_up(struct r8152 *tp)
+{
+	u32 ocp_data;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	r8153b_u1u2en(tp, false);
+	r8153_u2p3en(tp, false);
+	r8153_aldps_en(tp, false);
+
+	rxdy_gated_en(tp, true);
+	r8153_teredo_off(tp);
+
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, PLA_RCR);
+	ocp_data &= ~RCR_ACPT_ALL;
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, ocp_data);
+
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_CR, 0);
+	rtl_reset_bmu(tp);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+	ocp_data &= ~NOW_IS_OOB;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7);
+	ocp_data &= ~MCU_BORW_EN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_SFF_STS_7, ocp_data);
+
+	rtl_rx_vlan_en(tp, tp->netdev->features & NETIF_F_HW_VLAN_CTAG_RX);
+
+	ocp_data = tp->netdev->mtu + VLAN_ETH_HLEN + ETH_FCS_LEN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_RMS, ocp_data);
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_MTPS, MTPS_JUMBO);
+
+	ocp_data = ALIGN(ocp_data, 1024);
+	ocp_write_word(tp, MCU_TYPE_PLA, 0xc0a6, (ocp_data + 0x800) / 8);
+	ocp_write_word(tp, MCU_TYPE_PLA, 0xc0aa, (ocp_data + 0x1800) / 8);
+
+	/* share FIFO settings */
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, 0xc0a2);
+	ocp_data &= ~0xfff;
+	ocp_data |= 0x01;
+	ocp_write_word(tp, MCU_TYPE_PLA, 0xc0a2, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, 0xc0a8);
+	ocp_data &= ~0xfff;
+	ocp_data |= 0x0200;
+	ocp_write_word(tp, MCU_TYPE_PLA, 0xc0a8, ocp_data);
+
+	/* TX share fifo free credit full threshold */
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_TXFIFO_CTRL, TXFIFO_THR_NORMAL2);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3);
+	ocp_data &= ~BIT(14);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xd32a);
+	ocp_data &= ~(BIT(8) | BIT(9));
+	ocp_write_word(tp, MCU_TYPE_USB, 0xd32a, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xd4b4);
+	ocp_data |= BIT(1);
+	ocp_write_word(tp, MCU_TYPE_USB, 0xd4b4, ocp_data);
+
+	ocp_write_dword(tp, MCU_TYPE_USB, USB_RX_BUF_TH, 0x00600400);
+
+	if (tp->saved_wolopts != __rtl_get_wol(tp)) {
+		netif_warn(tp, ifup, tp->netdev, "wol setting is changed\n");
+		__rtl_set_wol(tp, tp->saved_wolopts);
+	}
+
+	if (!work_busy(&tp->hw_phy_work.work)) {
+		r8153_aldps_en(tp, true);
+		r8153_u2p3en(tp, true);
+	}
+
+	r8153b_u1u2en(tp, true);
+}
+
+static void rtl8156_down(struct r8152 *tp)
+{
+	u32 ocp_data;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags)) {
+		rtl_drop_queued_tx(tp);
+		return;
+	}
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3);
+	ocp_data |= BIT(14);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3, ocp_data);
+
+	r8153b_u1u2en(tp, false);
+	r8153_u2p3en(tp, false);
+	r8153b_power_cut_en(tp, false);
+	r8153_aldps_en(tp, false);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+	ocp_data &= ~NOW_IS_OOB;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL, ocp_data);
+
+	rtl_disable(tp);
+	rtl_reset_bmu(tp);
+
+	/* Clear teredo wake event. bit[15:8] is the teredo wakeup
+	 * type. Set it to zero. bits[7:0] are the W1C bits about
+	 * the events. Set them to all 1 to clear them.
+	 */
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_TEREDO_WAKE_BASE, 0x00ff);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL);
+	ocp_data |= NOW_IS_OOB;
+	ocp_write_byte(tp, MCU_TYPE_PLA, PLA_OOB_CTRL, ocp_data);
+
+	rtl_rx_vlan_en(tp, true);
+	rxdy_gated_en(tp, false);
+
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, PLA_RCR);
+	ocp_data |= RCR_APM | RCR_AM | RCR_AB;
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, ocp_data);
+
+	r8153_aldps_en(tp, true);
+}
+
+static bool rtl8152_in_nway(struct r8152 *tp)
+{
+	u16 nway_state;
+
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_OCP_GPHY_BASE, 0x2000);
+	tp->ocp_base = 0x2000;
+	ocp_write_byte(tp, MCU_TYPE_PLA, 0xb014, 0x4c);		/* phy state */
+	nway_state = ocp_read_word(tp, MCU_TYPE_PLA, 0xb01a);
+
+	/* bit 15: TXDIS_STATE, bit 14: ABD_STATE */
+	if (nway_state & 0xc000)
+		return false;
+	else
+		return true;
+}
+
+static bool rtl8153_in_nway(struct r8152 *tp)
+{
+	u16 phy_state = ocp_reg_read(tp, OCP_PHY_STATE) & 0xff;
+
+	if (phy_state == TXDIS_STATE || phy_state == ABD_STATE)
+		return false;
+	else
+		return true;
+}
+
+static void set_carrier(struct r8152 *tp)
+{
+	struct net_device *netdev = tp->netdev;
+	struct napi_struct *napi = &tp->napi;
+	u16 speed;
+
+	speed = rtl8152_get_speed(tp);
+
+	if (speed & LINK_STATUS) {
+		if (!netif_carrier_ok(netdev)) {
+			tp->rtl_ops.enable(tp);
+			netif_stop_queue(netdev);
+			napi_disable(napi);
+			netif_carrier_on(netdev);
+			rtl_start_rx(tp);
+			rtl8152_set_rx_mode(netdev);
+			napi_enable(&tp->napi);
+			netif_wake_queue(netdev);
+			netif_info(tp, link, netdev, "carrier on\n");
+		} else if (netif_queue_stopped(netdev) &&
+			   skb_queue_len(&tp->tx_queue) < tp->tx_qlen) {
+			netif_wake_queue(netdev);
+		}
+	} else {
+		if (netif_carrier_ok(netdev)) {
+			netif_carrier_off(netdev);
+			tasklet_disable(&tp->tx_tl);
+			napi_disable(napi);
+			tp->rtl_ops.disable(tp);
+			napi_enable(napi);
+			tasklet_enable(&tp->tx_tl);
+			netif_info(tp, link, netdev, "carrier off\n");
+		}
+	}
+}
+
+static inline void __rtl_work_func(struct r8152 *tp)
+{
+	/* If the device is unplugged or !netif_running(), the workqueue
+	 * doesn't need to wake the device, and could return directly.
+	 */
+	if (test_bit(RTL8152_UNPLUG, &tp->flags) || !netif_running(tp->netdev))
+		return;
+
+	if (usb_autopm_get_interface(tp->intf) < 0)
+		return;
+
+	if (!test_bit(WORK_ENABLE, &tp->flags))
+		goto out1;
+
+	if (!mutex_trylock(&tp->control)) {
+		schedule_delayed_work(&tp->schedule, 0);
+		goto out1;
+	}
+
+	if (test_and_clear_bit(RTL8152_LINK_CHG, &tp->flags))
+		set_carrier(tp);
+
+	if (test_bit(RTL8152_SET_RX_MODE, &tp->flags))
+		rtl8152_set_rx_mode(tp->netdev);
+
+	/* don't schedule tasket before linking */
+	if (test_and_clear_bit(SCHEDULE_TASKLET, &tp->flags) &&
+	    netif_carrier_ok(tp->netdev))
+		tasklet_schedule(&tp->tx_tl);
+
+	mutex_unlock(&tp->control);
+
+out1:
+	usb_autopm_put_interface(tp->intf);
+}
+
+static inline void __rtl_hw_phy_work_func(struct r8152 *tp)
+{
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	if (usb_autopm_get_interface(tp->intf) < 0)
+		return;
+
+	mutex_lock(&tp->control);
+
+	tp->rtl_ops.hw_phy_cfg(tp);
+
+	rtl8152_set_speed(tp, tp->autoneg, tp->speed, tp->duplex,
+			  tp->advertising);
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
+
+static void rtl_work_func_t(void *data)
+{
+	struct r8152 *tp = (struct r8152 *)data;
+
+	__rtl_work_func(tp);
+}
+
+static void rtl_hw_phy_work_func_t(void *data)
+{
+	struct r8152 *tp = (struct r8152 *)data;
+
+	__rtl_hw_phy_work_func(tp);
+}
+
+#else
+
+static void rtl_work_func_t(struct work_struct *work)
+{
+	struct r8152 *tp = container_of(work, struct r8152, schedule.work);
+
+	__rtl_work_func(tp);
+}
+
+static void rtl_hw_phy_work_func_t(struct work_struct *work)
+{
+	struct r8152 *tp = container_of(work, struct r8152, hw_phy_work.work);
+
+	__rtl_hw_phy_work_func(tp);
+}
+
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,23) && defined(CONFIG_PM_SLEEP)
+static int rtl_notifier(struct notifier_block *nb, unsigned long action,
+			void *data)
+{
+	struct r8152 *tp = container_of(nb, struct r8152, pm_notifier);
+
+	switch (action) {
+	case PM_HIBERNATION_PREPARE:
+	case PM_SUSPEND_PREPARE:
+		usb_autopm_get_interface(tp->intf);
+		break;
+
+	case PM_POST_HIBERNATION:
+	case PM_POST_SUSPEND:
+		usb_autopm_put_interface(tp->intf);
+		break;
+
+	case PM_POST_RESTORE:
+	case PM_RESTORE_PREPARE:
+	default:
+		break;
+	}
+
+	return NOTIFY_DONE;
+}
+#endif
+
+static int rtk_disable_diag(struct r8152 *tp)
+{
+	tp->rtk_enable_diag--;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_OCP_GPHY_BASE, tp->ocp_base);
+	netif_info(tp, drv, tp->netdev, "disable rtk diag %d\n",
+		   tp->rtk_enable_diag);
+	mutex_unlock(&tp->control);
+	usb_autopm_put_interface(tp->intf);
+
+	return 0;
+}
+
+static int rtl8152_open(struct net_device *netdev)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+	int res = 0;
+
+	if (unlikely(tp->rtk_enable_diag))
+		return -EBUSY;
+
+	res = alloc_all_mem(tp);
+	if (res)
+		goto out;
+
+	res = usb_autopm_get_interface(tp->intf);
+	if (res < 0)
+		goto out_free;
+
+	mutex_lock(&tp->control);
+
+	tp->rtl_ops.up(tp);
+
+	netif_carrier_off(netdev);
+	netif_start_queue(netdev);
+	smp_mb__before_atomic();
+	set_bit(WORK_ENABLE, &tp->flags);
+	smp_mb__after_atomic();
+
+	if (test_and_clear_bit(RECOVER_SPEED, &tp->flags))
+		rtl8152_set_speed(tp, tp->autoneg, tp->speed, tp->duplex,
+				  tp->advertising);
+
+	res = usb_submit_urb(tp->intr_urb, GFP_KERNEL);
+	if (res) {
+		if (res == -ENODEV)
+			netif_device_detach(tp->netdev);
+		netif_warn(tp, ifup, netdev, "intr_urb submit failed: %d\n",
+			   res);
+		goto out_unlock;
+	}
+	napi_enable(&tp->napi);
+	tasklet_enable(&tp->tx_tl);
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,23) && defined(CONFIG_PM_SLEEP)
+	tp->pm_notifier.notifier_call = rtl_notifier;
+	register_pm_notifier(&tp->pm_notifier);
+#endif
+	return 0;
+
+out_unlock:
+	mutex_unlock(&tp->control);
+	usb_autopm_put_interface(tp->intf);
+out_free:
+	free_all_mem(tp);
+out:
+	return res;
+}
+
+static int rtl8152_close(struct net_device *netdev)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+	int res = 0;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,23) && defined(CONFIG_PM_SLEEP)
+	unregister_pm_notifier(&tp->pm_notifier);
+#endif
+	tasklet_disable(&tp->tx_tl);
+	napi_disable(&tp->napi);
+	smp_mb__before_atomic();
+	clear_bit(WORK_ENABLE, &tp->flags);
+	smp_mb__after_atomic();
+	usb_kill_urb(tp->intr_urb);
+	cancel_delayed_work_sync(&tp->schedule);
+	netif_stop_queue(netdev);
+
+	if (unlikely(tp->rtk_enable_diag)) {
+		netif_err(tp, drv, tp->netdev, "rtk diag isn't disabled\n");
+		rtk_disable_diag(tp);
+	}
+
+	res = usb_autopm_get_interface(tp->intf);
+	if (res < 0 || test_bit(RTL8152_UNPLUG, &tp->flags)) {
+		rtl_drop_queued_tx(tp);
+		rtl_stop_rx(tp);
+	} else {
+		mutex_lock(&tp->control);
+
+		tp->rtl_ops.down(tp);
+
+		if (tp->version == RTL_VER_01)
+			rtl8152_set_speed(tp, AUTONEG_ENABLE, 0, 0, 3);
+		else
+			rtl_speed_down(tp);
+
+#if defined(RTL8152_S5_WOL) && defined(CONFIG_PM)
+		res = rtl_s5_wol(tp);
+#endif
+		mutex_unlock(&tp->control);
+
+		usb_autopm_put_interface(tp->intf);
+	}
+
+	free_all_mem(tp);
+
+	return res;
+}
+
+static void rtl_tally_reset(struct r8152 *tp)
+{
+	u32 ocp_data;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_RSTTALLY);
+	ocp_data |= TALLY_RESET;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_RSTTALLY, ocp_data);
+}
+
+static void r8152b_init(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u16 data;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+#if 0
+	/* Clear EP3 Fifo before using interrupt transfer */
+	if (ocp_read_byte(tp, MCU_TYPE_USB, 0xb963) & 0x80) {
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xb963, 0x08);
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xb963, 0x40);
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xb963, 0x00);
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xb968, 0x00);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xb010, 0x00e0);
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xb963, 0x04);
+	}
+#endif
+
+	data = r8152_mdio_read(tp, MII_BMCR);
+	if (data & BMCR_PDOWN) {
+		data &= ~BMCR_PDOWN;
+		r8152_mdio_write(tp, MII_BMCR, data);
+	}
+
+	r8152_aldps_en(tp, false);
+
+	if (tp->version == RTL_VER_01) {
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_LED_FEATURE);
+		ocp_data &= ~LED_MODE_MASK;
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_LED_FEATURE, ocp_data);
+	}
+
+	r8152_power_cut_en(tp, false);
+	rtl_runtime_suspend_enable(tp, false);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_PHY_PWR);
+	ocp_data |= TX_10M_IDLE_EN | PFM_PWM_SWITCH;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_PHY_PWR, ocp_data);
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL);
+	ocp_data &= ~MCU_CLK_RATIO_MASK;
+	ocp_data |= MCU_CLK_RATIO | D3_CLK_GATED_EN;
+	ocp_write_dword(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL, ocp_data);
+	ocp_data = GPHY_STS_MSK | SPEED_DOWN_MSK |
+		   SPDWN_RXDV_MSK | SPDWN_LINKCHG_MSK;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_GPHY_INTR_IMR, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_USB_TIMER);
+	ocp_data |= BIT(15);
+	ocp_write_word(tp, MCU_TYPE_USB, USB_USB_TIMER, ocp_data);
+	ocp_write_word(tp, MCU_TYPE_USB, 0xcbfc, 0x03e8);
+	ocp_data &= ~BIT(15);
+	ocp_write_word(tp, MCU_TYPE_USB, USB_USB_TIMER, ocp_data);
+
+	rtl_tally_reset(tp);
+
+	/* enable rx aggregation */
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_USB_CTRL);
+	ocp_data &= ~(RX_AGG_DISABLE | RX_ZERO_EN);
+	ocp_write_word(tp, MCU_TYPE_USB, USB_USB_CTRL, ocp_data);
+}
+
+static void r8153_init(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u16 data;
+	int i;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	r8153_u1u2en(tp, false);
+
+	for (i = 0; i < 500; i++) {
+		if (ocp_read_word(tp, MCU_TYPE_PLA, PLA_BOOT_CTRL) &
+		    AUTOLOAD_DONE)
+			break;
+		msleep(20);
+	}
+
+	data = r8153_phy_status(tp, 0);
+
+	if (tp->version == RTL_VER_03 || tp->version == RTL_VER_04 ||
+	    tp->version == RTL_VER_05)
+		ocp_reg_write(tp, OCP_ADC_CFG, CKADSEL_L | ADC_EN | EN_EMI_L);
+
+	data = r8152_mdio_read(tp, MII_BMCR);
+	if (data & BMCR_PDOWN) {
+		data &= ~BMCR_PDOWN;
+		r8152_mdio_write(tp, MII_BMCR, data);
+	}
+
+	data = r8153_phy_status(tp, PHY_STAT_LAN_ON);
+
+	r8153_u2p3en(tp, false);
+
+	if (tp->version == RTL_VER_04) {
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_SSPHYLINK2);
+		ocp_data &= ~pwd_dn_scale_mask;
+		ocp_data |= pwd_dn_scale(96);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_SSPHYLINK2, ocp_data);
+
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, USB_USB2PHY);
+		ocp_data |= USB2PHY_L1 | USB2PHY_SUSPEND;
+		ocp_write_byte(tp, MCU_TYPE_USB, USB_USB2PHY, ocp_data);
+	} else if (tp->version == RTL_VER_05) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, PLA_DMY_REG0);
+		ocp_data &= ~ECM_ALDPS;
+		ocp_write_byte(tp, MCU_TYPE_PLA, PLA_DMY_REG0, ocp_data);
+
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, USB_CSR_DUMMY1);
+		if (ocp_read_word(tp, MCU_TYPE_USB, USB_BURST_SIZE) == 0)
+			ocp_data &= ~DYNAMIC_BURST;
+		else
+			ocp_data |= DYNAMIC_BURST;
+		ocp_write_byte(tp, MCU_TYPE_USB, USB_CSR_DUMMY1, ocp_data);
+	} else if (tp->version == RTL_VER_06) {
+		ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, USB_CSR_DUMMY1);
+		if (ocp_read_word(tp, MCU_TYPE_USB, USB_BURST_SIZE) == 0)
+			ocp_data &= ~DYNAMIC_BURST;
+		else
+			ocp_data |= DYNAMIC_BURST;
+		ocp_write_byte(tp, MCU_TYPE_USB, USB_CSR_DUMMY1, ocp_data);
+
+		r8153_queue_wake(tp, false);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, 0xd398);
+		if (rtl8152_get_speed(tp) & LINK_STATUS)
+			ocp_data |= BIT(15);
+		else
+			ocp_data &= ~BIT(15);
+
+		/* r8153_queue_wake() has set this bit */
+		/* ocp_data &= ~BIT(8); */
+
+		ocp_data |= BIT(0);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xd398, ocp_data);
+	}
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, USB_CSR_DUMMY2);
+	ocp_data |= EP4_FULL_FC;
+	ocp_write_byte(tp, MCU_TYPE_USB, USB_CSR_DUMMY2, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_WDT11_CTRL);
+	ocp_data &= ~TIMER11_EN;
+	ocp_write_word(tp, MCU_TYPE_USB, USB_WDT11_CTRL, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_LED_FEATURE);
+	ocp_data &= ~LED_MODE_MASK;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_LED_FEATURE, ocp_data);
+
+	ocp_data = FIFO_EMPTY_1FB | ROK_EXIT_LPM;
+	if (tp->version == RTL_VER_04 && tp->udev->speed < USB_SPEED_SUPER)
+		ocp_data |= LPM_TIMER_500MS;
+	else
+		ocp_data |= LPM_TIMER_500US;
+	ocp_write_byte(tp, MCU_TYPE_USB, USB_LPM_CTRL, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_AFE_CTRL2);
+	ocp_data &= ~SEN_VAL_MASK;
+	ocp_data |= SEN_VAL_NORMAL | SEL_RXIDLE;
+	ocp_write_word(tp, MCU_TYPE_USB, USB_AFE_CTRL2, ocp_data);
+
+	ocp_write_word(tp, MCU_TYPE_USB, USB_CONNECT_TIMER, 0x0001);
+
+	r8153_power_cut_en(tp, false);
+	rtl_runtime_suspend_enable(tp, false);
+	r8153_u1u2en(tp, true);
+	r8153_mac_clk_spd(tp, false);
+	usb_enable_lpm(tp->udev);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, 0xe90a);
+	ocp_data |= BIT(0);
+	ocp_write_byte(tp, MCU_TYPE_PLA, 0xe90a, ocp_data);
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA, 0xe007);
+	ocp_data &= ~BIT(7);
+	ocp_write_byte(tp, MCU_TYPE_PLA, 0xe007, ocp_data);
+
+	/* rx aggregation */
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_USB_CTRL);
+	ocp_data &= ~(RX_AGG_DISABLE | RX_ZERO_EN);
+	ocp_write_word(tp, MCU_TYPE_USB, USB_USB_CTRL, ocp_data);
+
+	rtl_tally_reset(tp);
+
+	switch (tp->udev->speed) {
+	case USB_SPEED_SUPER:
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,6,0)
+	case USB_SPEED_SUPER_PLUS:
+#endif
+		tp->coalesce = COALESCE_SUPER;
+		break;
+	case USB_SPEED_HIGH:
+		tp->coalesce = COALESCE_HIGH;
+		break;
+	default:
+		tp->coalesce = COALESCE_SLOW;
+		break;
+	}
+}
+
+static void r8153b_init(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u16 data;
+	int i;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	r8153b_u1u2en(tp, false);
+
+	for (i = 0; i < 500; i++) {
+		if (ocp_read_word(tp, MCU_TYPE_PLA, PLA_BOOT_CTRL) &
+		    AUTOLOAD_DONE)
+			break;
+		msleep(20);
+	}
+
+	data = r8153_phy_status(tp, 0);
+
+	data = r8152_mdio_read(tp, MII_BMCR);
+	if (data & BMCR_PDOWN) {
+		data &= ~BMCR_PDOWN;
+		r8152_mdio_write(tp, MII_BMCR, data);
+	}
+
+	data = r8153_phy_status(tp, PHY_STAT_LAN_ON);
+
+	r8153_u2p3en(tp, false);
+
+	/* MSC timer = 0xfff * 8ms = 32760 ms */
+	ocp_write_word(tp, MCU_TYPE_USB, USB_MSC_TIMER, 0x0fff);
+
+	r8153b_power_cut_en(tp, false);
+	r8153b_ups_en(tp, false);
+	r8153_queue_wake(tp, false);
+	rtl_runtime_suspend_enable(tp, false);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, 0xd398);
+	if (rtl8152_get_speed(tp) & LINK_STATUS)
+		ocp_data |= BIT(15);
+	else
+		ocp_data &= ~BIT(15);
+
+	/* r8153_queue_wake() has set this bit */
+	/* ocp_data &= ~BIT(8); */
+
+	ocp_data |= BIT(0);
+	ocp_write_word(tp, MCU_TYPE_PLA, 0xd398, ocp_data);
+
+	if (tp->udev->descriptor.idVendor == VENDOR_ID_LENOVO &&
+	    tp->udev->descriptor.idProduct == 0x3069)
+		ocp_write_word(tp, MCU_TYPE_USB, USB_SSPHYLINK2, 0x0c8c);
+
+	r8153b_u1u2en(tp, true);
+	usb_enable_lpm(tp->udev);
+
+	/* MAC clock speed down */
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL2);
+	ocp_data |= MAC_CLK_SPDWN_EN;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL2, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3);
+	ocp_data &= ~BIT(14);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3, ocp_data);
+
+	if (tp->version == RTL_VER_09) {
+		if (ocp_read_byte(tp, MCU_TYPE_PLA, 0xdc00) & BIT(5)) {
+			ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_PHY_PWR);
+			ocp_data |= TEST_IO_OFF;
+			ocp_write_word(tp, MCU_TYPE_PLA, PLA_PHY_PWR, ocp_data);
+		}
+	}
+
+	set_bit(GREEN_ETHERNET, &tp->flags);
+
+	/* rx aggregation */
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_USB_CTRL);
+	ocp_data &= ~(RX_AGG_DISABLE | RX_ZERO_EN);
+	ocp_write_word(tp, MCU_TYPE_USB, USB_USB_CTRL, ocp_data);
+
+	rtl_tally_reset(tp);
+
+	tp->coalesce = 15000;	/* 15 us */
+}
+
+static void r8156_patch_code(struct r8152 *tp)
+{
+	if (tp->version == RTL_TEST_01) {
+		static u8 usb3_patch_t[] = {
+			0x01, 0xe0, 0x05, 0xc7,
+			0xf6, 0x65, 0x02, 0xc0,
+			0x00, 0xb8, 0x40, 0x03,
+			0x00, 0xd4, 0x00, 0x00 };
+
+		r8153b_clear_bp(tp, MCU_TYPE_USB);
+
+		generic_ocp_write(tp, 0xe600, 0xff, sizeof(usb3_patch_t),
+				  usb3_patch_t, MCU_TYPE_USB);
+
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_BA, 0xa000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_0, 0x033e);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_1, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_2, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_3, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_4, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_5, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_6, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_7, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_8, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_9, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_10, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_11, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_12, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_13, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_14, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_15, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP2_EN, 0x0001);
+
+	} else if (tp->version == RTL_VER_11) {
+		u32 ocp_data;
+		static u8 usb_patch3_b[] = {
+			0x05, 0xe0, 0x31, 0xe0,
+			0x77, 0xe0, 0x86, 0xe0,
+			0x97, 0xe0, 0x2c, 0xc3,
+			0x60, 0x70, 0x80, 0x49,
+			0xfd, 0xf0, 0x27, 0xc3,
+			0x66, 0x60, 0x80, 0x48,
+			0x02, 0x48, 0x66, 0x88,
+			0x00, 0x48, 0x82, 0x48,
+			0x66, 0x88, 0x1b, 0xc3,
+			0x60, 0x70, 0x17, 0xc4,
+			0x88, 0x98, 0x14, 0xc0,
+			0x8c, 0x98, 0x83, 0x18,
+			0x8e, 0x88, 0x8e, 0x70,
+			0x8f, 0x49, 0xfe, 0xf1,
+			0x62, 0x70, 0x8a, 0x98,
+			0x0d, 0xc0, 0x8c, 0x98,
+			0x84, 0x18, 0x8e, 0x88,
+			0x8e, 0x70, 0x8f, 0x49,
+			0xfe, 0xf1, 0x08, 0xc3,
+			0x02, 0xc4, 0x00, 0xbc,
+			0x68, 0x0f, 0x6c, 0xe9,
+			0x00, 0xdc, 0x50, 0xe8,
+			0x30, 0xc1, 0x36, 0xd3,
+			0x80, 0x10, 0x00, 0x00,
+			0x80, 0xd4, 0x26, 0xd8,
+			0x44, 0xc2, 0x4a, 0x41,
+			0x94, 0x20, 0x42, 0xc0,
+			0x16, 0x00, 0x00, 0x73,
+			0x40, 0xc4, 0x5c, 0x41,
+			0x8b, 0x41, 0x0b, 0x18,
+			0x38, 0xc6, 0xc0, 0x88,
+			0xc1, 0x99, 0x21, 0xe8,
+			0x35, 0xc0, 0x00, 0x73,
+			0xbd, 0x48, 0x0d, 0x18,
+			0x30, 0xc6, 0xc0, 0x88,
+			0xc1, 0x9b, 0x19, 0xe8,
+			0x2d, 0xc0, 0x02, 0x73,
+			0x35, 0x48, 0x0e, 0x18,
+			0x28, 0xc6, 0xc0, 0x88,
+			0xc1, 0x9b, 0x11, 0xe8,
+			0xdf, 0xc3, 0xdd, 0xc6,
+			0x01, 0x03, 0x1e, 0x40,
+			0xfe, 0xf1, 0x20, 0xc0,
+			0x02, 0x73, 0xb5, 0x48,
+			0x0e, 0x18, 0x1b, 0xc6,
+			0xc0, 0x88, 0xc1, 0x9b,
+			0x04, 0xe8, 0x02, 0xc6,
+			0x00, 0xbe, 0xb6, 0x10,
+			0x00, 0xb4, 0x01, 0xb4,
+			0x02, 0xb4, 0x03, 0xb4,
+			0x10, 0xc3, 0x0e, 0xc2,
+			0x61, 0x71, 0x40, 0x99,
+			0x60, 0x60, 0x0e, 0x48,
+			0x42, 0x98, 0x42, 0x70,
+			0x8e, 0x49, 0xfe, 0xf1,
+			0x03, 0xb0, 0x02, 0xb0,
+			0x01, 0xb0, 0x00, 0xb0,
+			0x80, 0xff, 0xc0, 0xd4,
+			0x8f, 0xcb, 0xaa, 0xc7,
+			0x1e, 0x00, 0x90, 0xc7,
+			0x1f, 0xfe, 0x0a, 0x10,
+			0x0c, 0xf0, 0x0b, 0x10,
+			0x0a, 0xf0, 0x0d, 0x10,
+			0x08, 0xf0, 0x0e, 0x10,
+			0x06, 0xf0, 0x24, 0x10,
+			0x04, 0xf0, 0x02, 0xc7,
+			0x00, 0xbf, 0x58, 0x11,
+			0x02, 0xc7, 0x00, 0xbf,
+			0x62, 0x11, 0xec, 0xc0,
+			0x02, 0x75, 0xd5, 0x48,
+			0x0e, 0x18, 0xe7, 0xc6,
+			0xc0, 0x88, 0xc1, 0x9d,
+			0xd0, 0xef, 0x02, 0x75,
+			0x55, 0x48, 0x0e, 0x18,
+			0xe0, 0xc6, 0xc0, 0x88,
+			0xc1, 0x9d, 0xc9, 0xef,
+			0x02, 0xc7, 0x00, 0xbf,
+			0x8e, 0x11, 0x16, 0xc0,
+			0xbb, 0x21, 0xb9, 0x25,
+			0x00, 0x71, 0x13, 0xc2,
+			0x4a, 0x41, 0x8b, 0x41,
+			0x24, 0x18, 0xd1, 0xc6,
+			0xc0, 0x88, 0xc1, 0x99,
+			0xba, 0xef, 0x0a, 0xc0,
+			0x08, 0x71, 0x28, 0x18,
+			0xca, 0xc6, 0xc0, 0x88,
+			0xc1, 0x99, 0xb3, 0xef,
+			0x02, 0xc0, 0x00, 0xb8,
+			0x3c, 0x11, 0xd8, 0xc7,
+			0x83, 0xff, 0x00, 0x00};
+		static u8 pla_patch11[] = {
+			0x02, 0xe0, 0x07, 0xe0,
+			0x05, 0xc2, 0x40, 0x76,
+			0x02, 0xc4, 0x00, 0xbc,
+			0xd6, 0x0b, 0x1e, 0xfc,
+			0x2a, 0xc5, 0xa0, 0x77,
+			0x2a, 0xc5, 0x2b, 0xc4,
+			0xa0, 0x9c, 0x26, 0xc5,
+			0xa0, 0x64, 0x01, 0x14,
+			0x0b, 0xf0, 0x02, 0x14,
+			0x09, 0xf0, 0x01, 0x07,
+			0xf1, 0x49, 0x06, 0xf0,
+			0x21, 0xc7, 0xe0, 0x8e,
+			0x11, 0x1e, 0xe0, 0x8e,
+			0x14, 0xe0, 0x17, 0xc5,
+			0x00, 0x1f, 0xa0, 0x9f,
+			0x13, 0xc5, 0xa0, 0x77,
+			0xa0, 0x74, 0x46, 0x48,
+			0x47, 0x48, 0xa0, 0x9c,
+			0x11, 0xc5, 0xa0, 0x74,
+			0x44, 0x48, 0x43, 0x48,
+			0xa0, 0x9c, 0x08, 0xc5,
+			0xa0, 0x9f, 0x02, 0xc5,
+			0x00, 0xbd, 0xea, 0x03,
+			0x02, 0xc5, 0x00, 0xbd,
+			0xf6, 0x03, 0x1c, 0xe8,
+			0xaa, 0xd3, 0x08, 0xb7,
+			0x6c, 0xe8, 0x20, 0xe8,
+			0x00, 0xa0, 0x38, 0xe4};
+
+		r8153b_clear_bp(tp, MCU_TYPE_USB);
+
+		generic_ocp_write(tp, 0xe600, 0xff, sizeof(usb_patch3_b),
+				  usb_patch3_b, MCU_TYPE_USB);
+
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_BA, 0xa000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_0, 0x0f66);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_1, 0x1098);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_2, 0x1148);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_3, 0x116c);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_4, 0x10e0);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_5, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_6, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_7, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_8, 0x0000);
+//		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_9, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_10, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_11, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_12, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_13, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_14, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP_15, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_USB, USB_BP2_EN, 0x001f);
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xcfd7, 0x03);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xcfcc);
+		ocp_data |= BIT(9);
+		ocp_write_word(tp, MCU_TYPE_USB, 0xcfcc, ocp_data);
+
+		ocp_write_dword(tp, MCU_TYPE_USB, 0xd480, 0x4026840e);
+		ocp_write_dword(tp, MCU_TYPE_USB, 0xd480, 0x4001acc9);
+
+		r8153b_clear_bp(tp, MCU_TYPE_PLA);
+
+		generic_ocp_write(tp, 0xf800, 0xff, sizeof(pla_patch11),
+				  pla_patch11, MCU_TYPE_PLA);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_BA, 0x8000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_0, 0x0bc2);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_1, 0x03e0);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_2, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_3, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_4, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_5, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_6, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_7, 0x0000);
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_BP_EN, 0x0003);
+		ocp_write_byte(tp, MCU_TYPE_USB, 0xcfd6, 0x02);
+	}
+}
+
+static void r8156_ram_code(struct r8152 *tp)
+{
+	u16 data;
+
+	if (tp->version == RTL_VER_10) {
+		r8153_pre_ram_code(tp, 0x8024, 0x8600);
+
+		data = ocp_reg_read(tp, 0xb820);
+		data |= BIT(7);
+		ocp_reg_write(tp, 0xb820, data);
+
+		/* nc0_patch_6486_180504_usb */
+		sram_write(tp, 0xA016, 0x0000);
+		sram_write(tp, 0xA012, 0x0000);
+		sram_write(tp, 0xA014, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8013);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8021);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x802f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x803d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8042);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8051);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8051);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa088);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a50);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8008);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd014);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd707);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x40c2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60a6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f8b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a6c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8080);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd019);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1a2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd707);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x40c4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60a6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f8b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a84);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd503);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8970);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c07);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0901);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcf09);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd705);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xceff);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf0a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1213);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8401);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8580);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1253);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd064);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd181);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4018);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc50f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd706);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2c59);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x804d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc60f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc605);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x10fd);
+		sram_write(tp, 0xA026, 0xffff);
+		sram_write(tp, 0xA024, 0xffff);
+		sram_write(tp, 0xA022, 0x10f4);
+		sram_write(tp, 0xA020, 0x1252);
+		sram_write(tp, 0xA006, 0x1206);
+		sram_write(tp, 0xA004, 0x0a78);
+		sram_write(tp, 0xA002, 0x0a60);
+		sram_write(tp, 0xA000, 0x0a4f);
+		sram_write(tp, 0xA008, 0x3f00);
+
+		/* nc1_patch_6486_180423_cml_usb */
+		sram_write(tp, 0xA016, 0x0010);
+		sram_write(tp, 0xA012, 0x0000);
+		sram_write(tp, 0xA014, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8066);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x807c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8089);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x808e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80b2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80c2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x62db);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x655c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd73e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60e9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x614a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x61ab);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0503);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0505);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0509);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x653c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd73e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60e9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x614a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x61ab);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0503);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0506);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x050a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd73e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60e9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x614a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x61ab);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0505);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0506);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x050c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd73e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60e9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x614a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x61ab);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0509);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x050a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x050c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0508);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0304);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd73e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60e9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x614a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x61ab);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0321);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0321);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0321);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0508);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0321);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0346);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8208);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x609d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa50f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x001a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0503);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x001a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x607d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00ab);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00ab);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60fd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa50f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaa0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x017b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0503);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a05);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x017b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60fd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa50f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaa0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x01e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0503);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a05);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x01e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60fd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa50f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaa0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0231);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0503);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a05);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0231);
+		sram_write(tp, 0xA08E, 0xffff);
+		sram_write(tp, 0xA08C, 0x0221);
+		sram_write(tp, 0xA08A, 0x01ce);
+		sram_write(tp, 0xA088, 0x0169);
+		sram_write(tp, 0xA086, 0x00a6);
+		sram_write(tp, 0xA084, 0x000d);
+		sram_write(tp, 0xA082, 0x0308);
+		sram_write(tp, 0xA080, 0x029f);
+		sram_write(tp, 0xA090, 0x007f);
+
+		/* nc2_patch_6486_180508_usb */
+		sram_write(tp, 0xA016, 0x0020);
+		sram_write(tp, 0xA012, 0x0000);
+		sram_write(tp, 0xA014, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8017);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x801b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8029);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8054);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x805a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8064);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80a7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9430);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9480);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb408);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd120);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd057);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x064b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb80);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9906);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0567);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb94);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8190);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x82a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x800a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8406);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8dff);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07e4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa840);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0773);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb91);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4063);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd139);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd140);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd040);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07dc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa610);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa110);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa2a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4045);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa180);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x405d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa720);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0742);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07ec);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f74);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0742);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd702);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7fb6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8190);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x82a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8610);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07dc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x064b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07c0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5fa7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0481);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x94bc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x870c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa190);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa00a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa280);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8220);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x078e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb92);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa840);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4063);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd140);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd150);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd040);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd703);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6121);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x61a2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6223);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf02f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d10);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf00f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d20);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf00a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d30);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf005);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d40);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07e4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa610);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa008);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4046);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x405d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa720);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0742);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07f7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f74);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0742);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd702);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7fb5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x800a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07e4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ad4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0537);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8610);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8840);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x064b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x800a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8190);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x82a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa70c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9402);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x890c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8840);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x064b);
+		sram_write(tp, 0xA10E, 0x0642);
+		sram_write(tp, 0xA10C, 0x0686);
+		sram_write(tp, 0xA10A, 0x0788);
+		sram_write(tp, 0xA108, 0x047b);
+		sram_write(tp, 0xA106, 0x065c);
+		sram_write(tp, 0xA104, 0x0769);
+		sram_write(tp, 0xA102, 0x0565);
+		sram_write(tp, 0xA100, 0x06f9);
+		sram_write(tp, 0xA110, 0x00ff);
+
+		/* uc2_patch_6486_180507_usb */
+		sram_write(tp, 0xb87c, 0x8530);
+		sram_write(tp, 0xb87e, 0xaf85);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3caf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8593);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf85);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9caf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x85a5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd702);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5afb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe083);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfb0c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x020d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x021b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x10bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86d7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86da);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfbe0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x83fc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1b10);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xda02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xdd02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5afb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe083);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfd0c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x020d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x021b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x10bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86dd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfbe0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x83fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1b10);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf2f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbd02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2cac);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0286);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x65af);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x212b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x022c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86b6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf21);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cd1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x03bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8710);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x870d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8719);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8716);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x871f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x871c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8728);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8725);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8707);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfbad);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x281c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd100);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1302);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2202);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2b02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae1a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd101);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1302);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2202);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2b02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd101);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3402);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3102);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3d02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3a02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4302);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4c02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4902);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd100);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2e02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3702);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4602);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf87);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4f02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ab7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf35);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7ff8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfaef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x69bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86e3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfbbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86fb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86e6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfbbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86e9);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfbbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86ec);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfbbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x025a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7bf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86ef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0262);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7cbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86f2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0262);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7cbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86f5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0262);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7cbf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x86f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0262);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7cef);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x96fe);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf8fa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef69);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6273);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf202);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6273);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf502);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6273);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbf86);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf802);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6273);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef96);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfefc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0420);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb540);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x53b5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4086);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb540);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb9b5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x40c8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb03a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc8b0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbac8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb13a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc8b1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xba77);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbd26);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffbd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2677);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbd28);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xffbd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2840);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbd26);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc8bd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x2640);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbd28);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc8bd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x28bb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa430);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x98b0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1eba);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb01e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xdcb0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1e98);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb09e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbab0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9edc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb09e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x98b1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1eba);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb11e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xdcb1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1e98);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb19e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbab1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9edc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb19e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x11b0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1e22);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb01e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x33b0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1e11);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb09e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x22b0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9e33);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb09e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x11b1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1e22);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb11e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x33b1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1e11);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb19e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x22b1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9e33);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb19e);
+		sram_write(tp, 0xb85e, 0x2f71);
+		sram_write(tp, 0xb860, 0x20d9);
+		sram_write(tp, 0xb862, 0x2109);
+		sram_write(tp, 0xb864, 0x34e7);
+		sram_write(tp, 0xb878, 0x000f);
+
+		data = ocp_reg_read(tp, 0xb820);
+		data &= ~BIT(7);
+		ocp_reg_write(tp, 0xb820, data);
+
+		r8153_post_ram_code(tp, 0x8024);
+	} else if (tp->version == RTL_VER_11) {
+		r8153_pre_ram_code(tp, 0x8024, 0x8601);
+
+		data = ocp_reg_read(tp, 0xb820);
+		data |= BIT(7);
+		ocp_reg_write(tp, 0xb820, data);
+
+		/* nc_patch */
+		sram_write(tp, 0xA016, 0x0000);
+		sram_write(tp, 0xA012, 0x0000);
+		sram_write(tp, 0xA014, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x808b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x808f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8093);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8097);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x809d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80aa);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd718);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x607b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x40da);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf00e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x42da);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf01e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd718);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x615b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1456);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x14a4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x14bc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd718);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f2e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf01c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1456);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x14a4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x14bc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd718);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f2e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf024);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1456);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x14a4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x14bc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd718);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f2e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf02c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1456);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x14a4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x14bc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd718);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f2e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf034);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd719);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4118);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac11);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa410);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4779);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1444);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf034);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd719);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4118);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac22);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa420);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4559);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1444);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf023);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd719);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4118);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac44);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa440);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4339);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1444);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf012);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd719);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4118);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac88);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa480);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xce00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4119);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xac0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1444);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf001);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1456);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd718);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5fac);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc48f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x141b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd504);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x121a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd0b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1bb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0898);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd0b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1bb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0a0e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd064);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd18a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0b7e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x401c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd501);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa804);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8804);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x053b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd500);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0648);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc520);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa201);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x252d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1646);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd708);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4006);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1646);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0308);
+		sram_write(tp, 0xA026, 0x0307);
+		sram_write(tp, 0xA024, 0x1645);
+		sram_write(tp, 0xA022, 0x0647);
+		sram_write(tp, 0xA020, 0x053a);
+		sram_write(tp, 0xA006, 0x0b7c);
+		sram_write(tp, 0xA004, 0x0a0c);
+		sram_write(tp, 0xA002, 0x0896);
+		sram_write(tp, 0xA000, 0x11a1);
+		sram_write(tp, 0xA008, 0xff00);
+
+		/* nc1_patch */
+		sram_write(tp, 0xA016, 0x0010);
+		sram_write(tp, 0xA012, 0x0000);
+		sram_write(tp, 0xA014, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8015);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x801a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x801a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x801a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x801a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x801a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x801a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xad02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x02d7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00ed);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0509);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xc100);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x008f);
+		sram_write(tp, 0xA08E, 0xffff);
+		sram_write(tp, 0xA08C, 0xffff);
+		sram_write(tp, 0xA08A, 0xffff);
+		sram_write(tp, 0xA088, 0xffff);
+		sram_write(tp, 0xA086, 0xffff);
+		sram_write(tp, 0xA084, 0xffff);
+		sram_write(tp, 0xA082, 0x008d);
+		sram_write(tp, 0xA080, 0x00eb);
+		sram_write(tp, 0xA090, 0x0103);
+
+		/* nc2_patch */
+		sram_write(tp, 0xA016, 0x0020);
+		sram_write(tp, 0xA012, 0x0000);
+		sram_write(tp, 0xA014, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8014);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8018);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8024);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8051);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8055);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8072);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x80dc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfffd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfffd);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x800a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8190);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x82a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa70c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x9402);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x890c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8840);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa380);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x066e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb91);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4063);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd139);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd140);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd040);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa610);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa110);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa2a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4085);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa180);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8280);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x405d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa720);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0743);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07f0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5f74);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0743);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd702);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7fb6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8190);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x82a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8610);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0c0f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07e0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x066e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd158);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd04d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x03d4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x94bc);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x870c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8380);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd10d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd040);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07c4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5fb4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa190);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa00a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa280);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa404);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa220);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd130);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd040);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07c4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5fb4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xbb80);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1c4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd074);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa301);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x604b);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa90c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0556);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xcb92);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4063);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd116);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd119);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd040);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd703);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x60a0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6241);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x63e2);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6583);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf054);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x611e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x40da);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d10);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf02f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d50);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf02a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x611e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x40da);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d20);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf021);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d60);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf01c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x611e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x40da);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d30);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf013);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d70);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf00e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x611e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x40da);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d40);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf005);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d80);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07e8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa610);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x405d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa720);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd700);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x5ff4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa008);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd704);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x4046);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0743);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07fb);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd703);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7f6f);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7f4e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7f2d);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7f0c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x800a);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0cf0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0d00);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07e8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8010);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa740);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0743);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd702);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x7fb5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd701);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3ad4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0556);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8610);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x066e);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd1f5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xd049);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x1800);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x01ec);
+		sram_write(tp, 0xA10E, 0x01ea);
+		sram_write(tp, 0xA10C, 0x06a9);
+		sram_write(tp, 0xA10A, 0x078a);
+		sram_write(tp, 0xA108, 0x03d2);
+		sram_write(tp, 0xA106, 0x067f);
+		sram_write(tp, 0xA104, 0x0665);
+		sram_write(tp, 0xA102, 0x0000);
+		sram_write(tp, 0xA100, 0x0000);
+		sram_write(tp, 0xA110, 0x00fc);
+
+		/* uc2 */
+		sram_write(tp, 0xb87c, 0x8530);
+		sram_write(tp, 0xb87e, 0xaf85);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x3caf);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8545);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf85);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x45af);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8545);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xee82);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xf900);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0103);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xaf03);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb7f8);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe0a6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa601);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xef01);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x58f0);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa080);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x37a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8402);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae16);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa185);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x02ae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x11a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8702);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae0c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xa188);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x02ae);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x07a1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x8902);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae02);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xae1c);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe0b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x62e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb463);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6901);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe4b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x62e5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb463);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe0b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x62e1);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb463);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x6901);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xe4b4);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x62e5);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xb463);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0xfc04);
+		sram_write(tp, 0xb85e, 0x03b3);
+		sram_write(tp, 0xb860, 0xffff);
+		sram_write(tp, 0xb862, 0xffff);
+		sram_write(tp, 0xb864, 0xffff);
+		sram_write(tp, 0xb878, 0x0001);
+
+		data = ocp_reg_read(tp, 0xb820);
+		data &= ~BIT(7);
+		ocp_reg_write(tp, 0xb820, data);
+
+		r8153_post_ram_code(tp, 0x8024);
+	}
+}
+
+static void r8156_hw_phy_cfg2(struct r8152 *tp)
+{
+	bool pcut_entr;
+	u32 ocp_data;
+	u16 data;
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_MISC_0);
+	pcut_entr = (ocp_data & PCUT_STATUS) ? true : false;
+	if (pcut_entr) {
+		ocp_data &= ~PCUT_STATUS;
+		ocp_write_word(tp, MCU_TYPE_USB, USB_MISC_0, ocp_data);
+
+		data = r8153_phy_status(tp, PHY_STAT_EXT_INIT);
+		WARN_ON_ONCE(data != PHY_STAT_EXT_INIT);
+
+		r8156_ram_code(tp);
+
+		data = ocp_reg_read(tp, 0xa468);
+		data &= ~(BIT(3) | BIT(0));
+		ocp_reg_write(tp, 0xa468, data);
+	} else {
+		r8156_patch_code(tp);
+
+		if (r8153_patch_request(tp, true)) {
+			netif_err(tp, drv, tp->netdev,
+				  "patch request error\n");
+			return;
+		}
+
+		r8156_ram_code(tp);
+
+		r8153_patch_request(tp, false);
+
+		/* disable ALDPS before updating the PHY parameters */
+		r8153_aldps_en(tp, false);
+
+		/* disable EEE before updating the PHY parameters */
+		r8153_eee_en(tp, false);
+		ocp_reg_write(tp, OCP_EEE_ADV, 0);
+	}
+
+	data = r8153_phy_status(tp, PHY_STAT_LAN_ON);
+	WARN_ON_ONCE(data != PHY_STAT_LAN_ON);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_PHY_PWR);
+	ocp_data |= PFM_PWM_SWITCH;
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_PHY_PWR, ocp_data);
+
+	switch (tp->version) {
+	case RTL_VER_10:
+		data = ocp_reg_read(tp, 0xad40);
+		data &= ~0x3ff;
+		data |= BIT(7) | BIT(2);
+		ocp_reg_write(tp, 0xad40, data);
+
+		data = ocp_reg_read(tp, 0xad4e);
+		data |= BIT(4);
+		ocp_reg_write(tp, 0xad4e, data);
+		data = ocp_reg_read(tp, 0xad16);
+		data &= ~0x3ff;
+		data |= 0x6;
+		ocp_reg_write(tp, 0xad16, data);
+		data = ocp_reg_read(tp, 0xad32);
+		data &= ~0x3f;
+		data |= 6;
+		ocp_reg_write(tp, 0xad32, data);
+		data = ocp_reg_read(tp, 0xac08);
+		data &= ~(BIT(12) | BIT(8));
+		ocp_reg_write(tp, 0xac08, data);
+		data = ocp_reg_read(tp, 0xac8a);
+		data |= BIT(12) | BIT(13) | BIT(14);
+		data &= ~BIT(15);
+		ocp_reg_write(tp, 0xac8a, data);
+		data = ocp_reg_read(tp, 0xad18);
+		data |= BIT(10);
+		ocp_reg_write(tp, 0xad18, data);
+		data = ocp_reg_read(tp, 0xad1a);
+		data |= 0x3ff;
+		ocp_reg_write(tp, 0xad1a, data);
+		data = ocp_reg_read(tp, 0xad1c);
+		data |= 0x3ff;
+		ocp_reg_write(tp, 0xad1c, data);
+
+		data = sram_read(tp, 0x80ea);
+		data &= ~0xff00;
+		data |= 0xc400;
+		sram_write(tp, 0x80ea, data);
+		data = sram_read(tp, 0x80eb);
+		data &= ~0x0700;
+		data |= 0x0300;
+		sram_write(tp, 0x80eb, data);
+		data = sram_read(tp, 0x80f8);
+		data &= ~0xff00;
+		data |= 0x1c00;
+		sram_write(tp, 0x80f8, data);
+		data = sram_read(tp, 0x80f1);
+		data &= ~0xff00;
+		data |= 0x3000;
+		sram_write(tp, 0x80f1, data);
+
+		data = sram_read(tp, 0x80fe);
+		data &= ~0xff00;
+		data |= 0xa500;
+		sram_write(tp, 0x80fe, data);
+		data = sram_read(tp, 0x8102);
+		data &= ~0xff00;
+		data |= 0x5000;
+		sram_write(tp, 0x8102, data);
+		data = sram_read(tp, 0x8015);
+		data &= ~0xff00;
+		data |= 0x3300;
+		sram_write(tp, 0x8015, data);
+		data = sram_read(tp, 0x8100);
+		data &= ~0xff00;
+		data |= 0x7000;
+		sram_write(tp, 0x8100, data);
+		data = sram_read(tp, 0x8014);
+		data &= ~0xff00;
+		data |= 0xf000;
+		sram_write(tp, 0x8014, data);
+		data = sram_read(tp, 0x8016);
+		data &= ~0xff00;
+		data |= 0x6500;
+		sram_write(tp, 0x8016, data);
+		data = sram_read(tp, 0x80dc);
+		data &= ~0xff00;
+		data |= 0xed00;
+		sram_write(tp, 0x80dc, data);
+		data = sram_read(tp, 0x80df);
+		data |= BIT(8);
+		sram_write(tp, 0x80df, data);
+		data = sram_read(tp, 0x80e1);
+		data &= ~BIT(8);
+		sram_write(tp, 0x80e1, data);
+
+		data = ocp_reg_read(tp, 0xbf06);
+		data &= ~0x003f;
+		data |= 0x0038;
+		ocp_reg_write(tp, 0xbf06, data);
+
+		sram_write(tp, 0x819f, 0xddb6);
+
+		ocp_reg_write(tp, 0xbc34, 0x5555);
+		data = ocp_reg_read(tp, 0xbf0a);
+		data &= ~0x0e00;
+		data |= 0x0a00;
+		ocp_reg_write(tp, 0xbf0a, data);
+
+		data = ocp_reg_read(tp, 0xbd2c);
+		data &= ~BIT(13);
+		ocp_reg_write(tp, 0xbd2c, data);
+		break;
+	case RTL_VER_11:
+//		data = ocp_reg_read(tp, 0xad4e);
+//		data |= BIT(4);
+//		ocp_reg_write(tp, 0xad4e, data);
+		data = ocp_reg_read(tp, 0xad16);
+		data |= 0x3ff;
+		ocp_reg_write(tp, 0xad16, data);
+		data = ocp_reg_read(tp, 0xad32);
+		data &= ~0x3f;
+		data |= 6;
+		ocp_reg_write(tp, 0xad32, data);
+		data = ocp_reg_read(tp, 0xac08);
+		data &= ~(BIT(12) | BIT(8));
+		ocp_reg_write(tp, 0xac08, data);
+		data = ocp_reg_read(tp, 0xacc0);
+		data &= ~0x3;
+		data |= BIT(1);
+		ocp_reg_write(tp, 0xacc0, data);
+		data = ocp_reg_read(tp, 0xad40);
+		data &= ~0xe7;
+		data |= BIT(6) | BIT(2);
+		ocp_reg_write(tp, 0xad40, data);
+		data = ocp_reg_read(tp, 0xac14);
+		data &= ~BIT(7);
+		ocp_reg_write(tp, 0xac14, data);
+		data = ocp_reg_read(tp, 0xac80);
+		data &= ~(BIT(8) | BIT(9));
+		ocp_reg_write(tp, 0xac80, data);
+		data = ocp_reg_read(tp, 0xac5e);
+		data &= ~0x7;
+		data |= BIT(1);
+		ocp_reg_write(tp, 0xac5e, data);
+		ocp_reg_write(tp, 0xad4c, 0x00a8);
+		data = ocp_reg_read(tp, 0xac5c);
+		ocp_reg_write(tp, 0xac5c, 0x01ff);
+		data = ocp_reg_read(tp, 0xac8a);
+		data &= ~0xf0;
+		data |= BIT(4) | BIT(5);
+		ocp_reg_write(tp, 0xac8a, data);
+		ocp_reg_write(tp, 0xb87c, 0x80a2);
+		ocp_reg_write(tp, 0xb87e, 0x0153);
+		ocp_reg_write(tp, 0xb87c, 0x809c);
+		ocp_reg_write(tp, 0xb87e, 0x0153);
+
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xe058, 0x0056);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, 0xe952);
+		ocp_data |= BIT(1) | BIT(2);
+		ocp_write_word(tp, MCU_TYPE_PLA, 0xe952, ocp_data);
+
+		ocp_reg_write(tp, OCP_SRAM_ADDR, 0x81B3);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0043);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00A7);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00D6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00EC);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00F6);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00FB);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00FD);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00FF);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x00BB);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0058);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0029);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0013);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0009);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0004);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0002);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+		ocp_reg_write(tp, OCP_SRAM_DATA, 0x0000);
+
+		sram_write(tp, 0x8257, 0x020f);
+		sram_write(tp, 0x80ea, 0x7843);
+		if (r8153_patch_request(tp, true)) {
+			netif_err(tp, drv, tp->netdev,
+				  "patch request error\n");
+			return;
+		}
+
+		data = ocp_reg_read(tp, 0xb896);
+		data &= ~BIT(0);
+		ocp_reg_write(tp, 0xb896, data);
+
+		data = ocp_reg_read(tp, 0xb892);
+		data &= ~0xff00;
+		ocp_reg_write(tp, 0xb892, data);
+
+		ocp_reg_write(tp, 0xB88E, 0xC091);
+		ocp_reg_write(tp, 0xB890, 0x6E12);
+		ocp_reg_write(tp, 0xB88E, 0xC092);
+		ocp_reg_write(tp, 0xB890, 0x1214);
+		ocp_reg_write(tp, 0xB88E, 0xC094);
+		ocp_reg_write(tp, 0xB890, 0x1516);
+		ocp_reg_write(tp, 0xB88E, 0xC096);
+		ocp_reg_write(tp, 0xB890, 0x171B);
+		ocp_reg_write(tp, 0xB88E, 0xC098);
+		ocp_reg_write(tp, 0xB890, 0x1B1C);
+		ocp_reg_write(tp, 0xB88E, 0xC09A);
+		ocp_reg_write(tp, 0xB890, 0x1F1F);
+		ocp_reg_write(tp, 0xB88E, 0xC09C);
+		ocp_reg_write(tp, 0xB890, 0x2021);
+		ocp_reg_write(tp, 0xB88E, 0xC09E);
+		ocp_reg_write(tp, 0xB890, 0x2224);
+		ocp_reg_write(tp, 0xB88E, 0xC0A0);
+		ocp_reg_write(tp, 0xB890, 0x2424);
+		ocp_reg_write(tp, 0xB88E, 0xC0A2);
+		ocp_reg_write(tp, 0xB890, 0x2424);
+		ocp_reg_write(tp, 0xB88E, 0xC0A4);
+		ocp_reg_write(tp, 0xB890, 0x2424);
+		ocp_reg_write(tp, 0xB88E, 0xC018);
+		ocp_reg_write(tp, 0xB890, 0x0AF2);
+		ocp_reg_write(tp, 0xB88E, 0xC01A);
+		ocp_reg_write(tp, 0xB890, 0x0D4A);
+		ocp_reg_write(tp, 0xB88E, 0xC01C);
+		ocp_reg_write(tp, 0xB890, 0x0F26);
+		ocp_reg_write(tp, 0xB88E, 0xC01E);
+		ocp_reg_write(tp, 0xB890, 0x118D);
+		ocp_reg_write(tp, 0xB88E, 0xC020);
+		ocp_reg_write(tp, 0xB890, 0x14F3);
+		ocp_reg_write(tp, 0xB88E, 0xC022);
+		ocp_reg_write(tp, 0xB890, 0x175A);
+		ocp_reg_write(tp, 0xB88E, 0xC024);
+		ocp_reg_write(tp, 0xB890, 0x19C0);
+		ocp_reg_write(tp, 0xB88E, 0xC026);
+		ocp_reg_write(tp, 0xB890, 0x1C26);
+		ocp_reg_write(tp, 0xB88E, 0xC089);
+		ocp_reg_write(tp, 0xB890, 0x6050);
+		ocp_reg_write(tp, 0xB88E, 0xC08A);
+		ocp_reg_write(tp, 0xB890, 0x5F6E);
+		ocp_reg_write(tp, 0xB88E, 0xC08C);
+		ocp_reg_write(tp, 0xB890, 0x6E6E);
+		ocp_reg_write(tp, 0xB88E, 0xC08E);
+		ocp_reg_write(tp, 0xB890, 0x6E6E);
+		ocp_reg_write(tp, 0xB88E, 0xC090);
+		ocp_reg_write(tp, 0xB890, 0x6E12);
+
+		data = ocp_reg_read(tp, 0xb896);
+		data |= BIT(0);
+		ocp_reg_write(tp, 0xb896, data);
+
+		ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4);
+		ocp_data |= EEE_SPDWN_EN;
+		ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL4, ocp_data);
+
+		data = ocp_reg_read(tp, OCP_DOWN_SPEED);
+		data &= ~(EN_EEE_100 | EN_EEE_1000);
+		data |= EN_10M_CLKDIV;
+		ocp_reg_write(tp, OCP_DOWN_SPEED, data);
+		tp->ups_info._10m_ckdiv = true;
+		tp->ups_info.eee_plloff_100 = false;
+		tp->ups_info.eee_plloff_giga = false;
+
+		data = ocp_reg_read(tp, OCP_POWER_CFG);
+		data &= ~EEE_CLKDIV_EN;
+		ocp_reg_write(tp, OCP_POWER_CFG, data);
+		tp->ups_info.eee_ckdiv = false;
+
+		ocp_reg_write(tp, OCP_SYSCLK_CFG, 0);
+		ocp_reg_write(tp, OCP_SYSCLK_CFG, clk_div_expo(5));
+		tp->ups_info._250m_ckdiv = false;
+
+		r8153_patch_request(tp, false);
+
+		data = ocp_reg_read(tp, 0xd068);
+		data |= BIT(13);
+		ocp_reg_write(tp, 0xd068, data);
+
+		data = sram_read(tp, 0x81a2);
+		data &= ~BIT(8);
+		sram_write(tp, 0x81a2, data);
+		data = ocp_reg_read(tp, 0xb54c);
+		data &= ~0xff00;
+		data |= 0xdb00;
+		ocp_reg_write(tp, 0xb54c, data);
+
+		data = ocp_reg_read(tp, 0xa454);
+		data &= ~BIT(0);
+		ocp_reg_write(tp, 0xa454, data);
+
+		data = ocp_reg_read(tp, 0xa5d4);
+		data |= BIT(5);
+		ocp_reg_write(tp, 0xa5d4, data);
+		data = ocp_reg_read(tp, 0xad4e);
+		data &= ~BIT(4);
+		ocp_reg_write(tp, 0xad4e, data);
+		data = ocp_reg_read(tp, 0xa86a);
+		data &= ~BIT(0);
+		ocp_reg_write(tp, 0xa86a, data);
+		break;
+	default:
+		break;
+	}
+
+	if (!pcut_entr) {
+		data = ocp_reg_read(tp, 0xa428);
+		data &= ~BIT(9);
+		ocp_reg_write(tp, 0xa428, data);
+		data = ocp_reg_read(tp, 0xa5ea);
+		data &= ~BIT(0);
+		ocp_reg_write(tp, 0xa5ea, data);
+		tp->ups_info.lite_mode = 0;
+
+		if (tp->eee_en) {
+			r8156_eee_en(tp, true);
+			ocp_reg_write(tp, OCP_EEE_ADV, tp->eee_adv);
+		}
+
+		r8153_aldps_en(tp, true);
+		r8152b_enable_fc(tp);
+		r8153_u2p3en(tp, true);
+
+		set_bit(PHY_RESET, &tp->flags);
+	}
+}
+
+static void r8156_hw_phy_cfg(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u16 data;
+
+	data = r8153_phy_status(tp, PHY_STAT_LAN_ON);
+
+	/* disable ALDPS before updating the PHY parameters */
+	r8153_aldps_en(tp, false);
+
+	/* disable EEE before updating the PHY parameters */
+	r8153_eee_en(tp, false);
+	ocp_reg_write(tp, OCP_EEE_ADV, 0);
+
+	r8156_firmware(tp);
+
+	data = ocp_reg_read(tp, 0xa5d4);
+	data |= BIT(7) | BIT(0);
+	ocp_reg_write(tp, 0xa5d4, data);
+	ocp_reg_write(tp, 0xa5e6, 0x6290);
+
+	data = ocp_reg_read(tp, 0xa5e8);
+	data &= ~BIT(3);
+	ocp_reg_write(tp, 0xa5e8, data);
+	data = ocp_reg_read(tp, 0xa428);
+	data |= BIT(9);
+	ocp_reg_write(tp, 0xa428, data);
+
+	ocp_reg_write(tp, 0xb636, 0x2c00);
+	data = ocp_reg_read(tp, 0xb460);
+	data &= ~BIT(13);
+	ocp_reg_write(tp, 0xb460, data);
+	ocp_reg_write(tp, 0xb83e, 0x00a9);
+	ocp_reg_write(tp, 0xb840, 0x0035);
+	ocp_reg_write(tp, 0xb680, 0x0022);
+	ocp_reg_write(tp, 0xb468, 0x10c0);
+	ocp_reg_write(tp, 0xb468, 0x90c0);
+
+	data = ocp_reg_read(tp, 0xb60a);
+	data &= ~0xfff;
+	data |= 0xc0;
+	ocp_reg_write(tp, 0xb60a, data);
+	data = ocp_reg_read(tp, 0xb628);
+	data &= ~0xfff;
+	data |= 0xc0;
+	ocp_reg_write(tp, 0xb628, data);
+	data = ocp_reg_read(tp, 0xb62a);
+	data &= ~0xfff;
+	data |= 0xc0;
+	ocp_reg_write(tp, 0xb62a, data);
+
+	data = ocp_reg_read(tp, 0xbc1e);
+	data &= 0xf;
+	data |= (data << 4) | (data << 8) | (data << 12);
+	ocp_reg_write(tp, 0xbce0, data);
+	data = ocp_reg_read(tp, 0xbd42);
+	data &= ~BIT(8);
+	ocp_reg_write(tp, 0xbd42, data);
+
+	data = ocp_reg_read(tp, 0xbf90);
+	data &= ~0xf0;
+	data |= BIT(7);
+	ocp_reg_write(tp, 0xbf90, data);
+	data = ocp_reg_read(tp, 0xbf92);
+	data &= ~0x3f;
+	data |= 0x3fc0;
+	ocp_reg_write(tp, 0xbf92, data);
+
+	data = ocp_reg_read(tp, 0xbf94);
+	data |= 0x3e00;
+	ocp_reg_write(tp, 0xbf94, data);
+	data = ocp_reg_read(tp, 0xbf88);
+	data &= ~0x3eff;
+	data |= 0x1e01;
+	ocp_reg_write(tp, 0xbf88, data);
+
+	data = ocp_reg_read(tp, 0xbc58);
+	data &= ~BIT(1);
+	ocp_reg_write(tp, 0xbc58, data);
+
+	data = ocp_reg_read(tp, 0xbd0c);
+	data &= ~0x3f;
+	ocp_reg_write(tp, 0xbd0c, data);
+
+	data = ocp_reg_read(tp, 0xbcc2);
+	data &= ~BIT(14);
+	ocp_reg_write(tp, 0xbcc2, data);
+
+	ocp_reg_write(tp, 0xd098, 0x0427);
+
+	data = ocp_reg_read(tp, 0xa430);
+	data &= ~BIT(12);
+	ocp_reg_write(tp, 0xa430, data);
+
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, 0xe84c);
+	ocp_data |= BIT(6);
+	ocp_write_dword(tp, MCU_TYPE_PLA, 0xe84c, ocp_data);
+
+	data = ocp_reg_read(tp, 0xbeb4);
+	data &= ~BIT(1);
+	ocp_reg_write(tp, 0xbeb4, data);
+	data = ocp_reg_read(tp, 0xbf0c);
+	data &= ~BIT(13);
+	data |= BIT(12);
+	ocp_reg_write(tp, 0xbf0c, data);
+	data = ocp_reg_read(tp, 0xbd44);
+	data &= ~BIT(2);
+	ocp_reg_write(tp, 0xbd44, data);
+
+	data = ocp_reg_read(tp, 0xa442);
+	data |= BIT(11);
+	ocp_reg_write(tp, 0xa442, data);
+	ocp_data = ocp_read_dword(tp, MCU_TYPE_PLA, 0xe84c);
+	ocp_data |= BIT(7);
+	ocp_write_dword(tp, MCU_TYPE_PLA, 0xe84c, ocp_data);
+
+	r8156_lock_mian(tp, true);
+	data = ocp_reg_read(tp, 0xcc46);
+	data &= ~0x700;
+	ocp_reg_write(tp, 0xcc46, data);
+	data = ocp_reg_read(tp, 0xcc46);
+	data &= ~0x70;
+	ocp_reg_write(tp, 0xcc46, data);
+	data = ocp_reg_read(tp, 0xcc46);
+	data &= ~0x70;
+	data |= BIT(6) | BIT(4);
+	ocp_reg_write(tp, 0xcc46, data);
+	r8156_lock_mian(tp, false);
+
+	data = ocp_reg_read(tp, 0xbd38);
+	data &= ~BIT(13);
+	ocp_reg_write(tp, 0xbd38, data);
+	data = ocp_reg_read(tp, 0xbd38);
+	data |= BIT(12);
+	ocp_reg_write(tp, 0xbd38, data);
+	ocp_reg_write(tp, 0xbd36, 0x0fb4);
+	data = ocp_reg_read(tp, 0xbd38);
+	data |= BIT(13);
+	ocp_reg_write(tp, 0xbd38, data);
+
+//	if (tp->eee_en) {
+//		r8153_eee_en(tp, true);
+//		ocp_reg_write(tp, OCP_EEE_ADV, tp->eee_adv);
+//	}
+
+	r8153_aldps_en(tp, true);
+	r8152b_enable_fc(tp);
+	r8153_u2p3en(tp, true);
+}
+
+static void r8156_init(struct r8152 *tp)
+{
+	u32 ocp_data;
+	u16 data;
+	int i;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, 0xd26b);
+	ocp_data &= ~BIT(0);
+	ocp_write_byte(tp, MCU_TYPE_USB, 0xd26b, ocp_data);
+
+	ocp_write_word(tp, MCU_TYPE_USB, 0xd32a, 0);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, 0xcfee);
+	ocp_data |= BIT(5);
+	ocp_write_word(tp, MCU_TYPE_USB, 0xcfee, ocp_data);
+
+	r8153b_u1u2en(tp, false);
+
+	for (i = 0; i < 500; i++) {
+		if (ocp_read_word(tp, MCU_TYPE_PLA, PLA_BOOT_CTRL) &
+		    AUTOLOAD_DONE)
+			break;
+		msleep(20);
+	}
+
+	data = r8153_phy_status(tp, 0);
+	if (data == PHY_STAT_EXT_INIT) {
+		data = ocp_reg_read(tp, 0xa468);
+		data &= ~(BIT(3) | BIT(0));
+		ocp_reg_write(tp, 0xa468, data);
+	}
+
+	data = r8152_mdio_read(tp, MII_BMCR);
+	if (data & BMCR_PDOWN) {
+		data &= ~BMCR_PDOWN;
+		r8152_mdio_write(tp, MII_BMCR, data);
+	}
+
+	data = r8153_phy_status(tp, PHY_STAT_LAN_ON);
+
+	r8153_u2p3en(tp, false);
+
+	/* MSC timer = 0xfff * 8ms = 32760 ms */
+	ocp_write_word(tp, MCU_TYPE_USB, USB_MSC_TIMER, 0x0fff);
+
+	/* U1/U2/L1 idle timer. 500 us */
+	ocp_write_word(tp, MCU_TYPE_USB, USB_U1U2_TIMER, 500);
+
+	r8153b_power_cut_en(tp, false);
+	r8156_ups_en(tp, false);
+	r8153_queue_wake(tp, false);
+	rtl_runtime_suspend_enable(tp, false);
+
+	r8153b_u1u2en(tp, true);
+	usb_enable_lpm(tp->udev);
+
+	r8156_mac_clk_spd(tp, true);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3);
+	ocp_data &= ~BIT(14);
+	ocp_write_word(tp, MCU_TYPE_PLA, PLA_MAC_PWR_CTRL3, ocp_data);
+
+	ocp_data = ocp_read_word(tp, MCU_TYPE_PLA, 0xd398);
+	if (rtl8152_get_speed(tp) & LINK_STATUS)
+		ocp_data |= BIT(15);
+	else
+		ocp_data &= ~BIT(15);
+	ocp_data &= ~BIT(8);
+	ocp_data |= BIT(0);
+	ocp_write_word(tp, MCU_TYPE_PLA, 0xd398, ocp_data);
+
+//	set_bit(GREEN_ETHERNET, &tp->flags);
+
+	/* rx aggregation */
+	ocp_data = ocp_read_word(tp, MCU_TYPE_USB, USB_USB_CTRL);
+	ocp_data &= ~(RX_AGG_DISABLE | RX_ZERO_EN);
+	ocp_write_word(tp, MCU_TYPE_USB, USB_USB_CTRL, ocp_data);
+
+	/* Set Rx aggregation parameters to default value
+	ocp_data = ocp_read_byte(tp, MCU_TYPE_USB, 0xd4c9);
+	ocp_data |= BIT(2);
+	ocp_write_byte(tp, MCU_TYPE_USB, 0xd4c9, ocp_data);
+	*/
+
+	rtl_tally_reset(tp);
+
+	tp->coalesce = 15000;	/* 15 us */
+}
+
+static bool rtl_vendor_mode(struct usb_interface *intf)
+{
+	struct usb_host_interface *alt = intf->cur_altsetting;
+
+	return alt->desc.bInterfaceClass == USB_CLASS_VENDOR_SPEC;
+}
+
+static int rtl8152_pre_reset(struct usb_interface *intf)
+{
+	struct r8152 *tp = usb_get_intfdata(intf);
+	struct net_device *netdev;
+
+	if (!tp)
+		return 0;
+
+	netdev = tp->netdev;
+	if (!netif_running(netdev))
+		return 0;
+
+	netif_stop_queue(netdev);
+	tasklet_disable(&tp->tx_tl);
+	napi_disable(&tp->napi);
+	smp_mb__before_atomic();
+	clear_bit(WORK_ENABLE, &tp->flags);
+	smp_mb__after_atomic();
+	usb_kill_urb(tp->intr_urb);
+	cancel_delayed_work_sync(&tp->schedule);
+	if (netif_carrier_ok(netdev)) {
+		mutex_lock(&tp->control);
+		tp->rtl_ops.disable(tp);
+		mutex_unlock(&tp->control);
+	}
+
+	return 0;
+}
+
+static int rtl8152_post_reset(struct usb_interface *intf)
+{
+	struct r8152 *tp = usb_get_intfdata(intf);
+	struct net_device *netdev;
+
+	if (!tp)
+		return 0;
+
+	netdev = tp->netdev;
+	if (!netif_running(netdev))
+		return 0;
+
+	smp_mb__before_atomic();
+	set_bit(WORK_ENABLE, &tp->flags);
+	smp_mb__after_atomic();
+	if (netif_carrier_ok(netdev)) {
+		mutex_lock(&tp->control);
+		tp->rtl_ops.enable(tp);
+		rtl_start_rx(tp);
+		rtl8152_set_rx_mode(netdev);
+		mutex_unlock(&tp->control);
+	}
+
+	napi_enable(&tp->napi);
+	tasklet_enable(&tp->tx_tl);
+	netif_wake_queue(netdev);
+	usb_submit_urb(tp->intr_urb, GFP_KERNEL);
+
+	if (!list_empty(&tp->rx_done))
+		napi_schedule(&tp->napi);
+
+	return 0;
+}
+
+static bool delay_autosuspend(struct r8152 *tp)
+{
+	bool sw_linking = !!netif_carrier_ok(tp->netdev);
+	bool hw_linking = !!(rtl8152_get_speed(tp) & LINK_STATUS);
+
+	/* This means a linking change occurs and the driver doesn't detect it,
+	 * yet. If the driver has disabled tx/rx and hw is linking on, the
+	 * device wouldn't wake up by receiving any packet.
+	 */
+	if (work_busy(&tp->schedule.work) || sw_linking != hw_linking)
+		return true;
+
+	/* If the linking down is occurred by nway, the device may miss the
+	 * linking change event. And it wouldn't wake when linking on.
+	 */
+	if (!sw_linking && tp->rtl_ops.in_nway(tp))
+		return true;
+	else if (!skb_queue_empty(&tp->tx_queue))
+		return true;
+	else
+		return false;
+}
+
+static int rtl8152_runtime_resume(struct r8152 *tp)
+{
+	struct net_device *netdev = tp->netdev;
+
+	if (netif_running(netdev) && netdev->flags & IFF_UP) {
+		struct napi_struct *napi = &tp->napi;
+
+		tp->rtl_ops.autosuspend_en(tp, false);
+		napi_disable(napi);
+		smp_mb__before_atomic();
+		set_bit(WORK_ENABLE, &tp->flags);
+		smp_mb__after_atomic();
+
+		if (netif_carrier_ok(netdev)) {
+			if (rtl8152_get_speed(tp) & LINK_STATUS) {
+				rtl_start_rx(tp);
+			} else {
+				netif_carrier_off(netdev);
+				tp->rtl_ops.disable(tp);
+				netif_info(tp, link, netdev, "linking down\n");
+			}
+		}
+
+		napi_enable(napi);
+		clear_bit(SELECTIVE_SUSPEND, &tp->flags);
+		smp_mb__after_atomic();
+
+		if (!list_empty(&tp->rx_done)) {
+			local_bh_disable();
+			napi_schedule(&tp->napi);
+			local_bh_enable();
+		}
+
+		usb_submit_urb(tp->intr_urb, GFP_NOIO);
+	} else {
+		if (netdev->flags & IFF_UP)
+			tp->rtl_ops.autosuspend_en(tp, false);
+
+		clear_bit(SELECTIVE_SUSPEND, &tp->flags);
+		smp_mb__after_atomic();
+	}
+
+	return 0;
+}
+
+static int rtl8152_system_resume(struct r8152 *tp)
+{
+	struct net_device *netdev = tp->netdev;
+
+	netif_device_attach(netdev);
+
+	if (netif_running(netdev) && (netdev->flags & IFF_UP)) {
+		tp->rtl_ops.up(tp);
+		netif_carrier_off(netdev);
+		smp_mb__before_atomic();
+		set_bit(WORK_ENABLE, &tp->flags);
+		smp_mb__after_atomic();
+		if (test_and_clear_bit(RECOVER_SPEED, &tp->flags))
+			rtl8152_set_speed(tp, tp->autoneg, tp->speed,
+					  tp->duplex, tp->advertising);
+		usb_submit_urb(tp->intr_urb, GFP_NOIO);
+	}
+
+	return 0;
+}
+
+static int rtl8152_runtime_suspend(struct r8152 *tp)
+{
+	struct net_device *netdev = tp->netdev;
+	int ret = 0;
+
+	if (!tp->rtl_ops.autosuspend_en)
+		return -EBUSY;
+
+	set_bit(SELECTIVE_SUSPEND, &tp->flags);
+	smp_mb__after_atomic();
+
+	if (netif_running(netdev) && test_bit(WORK_ENABLE, &tp->flags)) {
+		u32 rcr = 0;
+
+		if (netif_carrier_ok(netdev)) {
+			u32 ocp_data;
+
+			rcr = ocp_read_dword(tp, MCU_TYPE_PLA, PLA_RCR);
+			ocp_data = rcr & ~RCR_ACPT_ALL;
+			ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, ocp_data);
+			rxdy_gated_en(tp, true);
+			ocp_data = ocp_read_byte(tp, MCU_TYPE_PLA,
+						 PLA_OOB_CTRL);
+			if (!(ocp_data & RXFIFO_EMPTY)) {
+				rxdy_gated_en(tp, false);
+				ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, rcr);
+				clear_bit(SELECTIVE_SUSPEND, &tp->flags);
+				smp_mb__after_atomic();
+				ret = -EBUSY;
+				goto out1;
+			}
+		}
+
+		smp_mb__before_atomic();
+		clear_bit(WORK_ENABLE, &tp->flags);
+		smp_mb__after_atomic();
+		usb_kill_urb(tp->intr_urb);
+
+		tp->rtl_ops.autosuspend_en(tp, true);
+
+		if (netif_carrier_ok(netdev)) {
+			struct napi_struct *napi = &tp->napi;
+
+			napi_disable(napi);
+			rtl_stop_rx(tp);
+			rxdy_gated_en(tp, false);
+			ocp_write_dword(tp, MCU_TYPE_PLA, PLA_RCR, rcr);
+			napi_enable(napi);
+		}
+
+		if (delay_autosuspend(tp)) {
+			rtl8152_runtime_resume(tp);
+			ret = -EBUSY;
+		}
+	}
+
+out1:
+	return ret;
+}
+
+static int rtl8152_system_suspend(struct r8152 *tp)
+{
+	struct net_device *netdev = tp->netdev;
+
+	netif_device_detach(netdev);
+
+	if (netif_running(netdev) && test_bit(WORK_ENABLE, &tp->flags)) {
+		struct napi_struct *napi = &tp->napi;
+
+		smp_mb__before_atomic();
+		clear_bit(WORK_ENABLE, &tp->flags);
+		smp_mb__after_atomic();
+		usb_kill_urb(tp->intr_urb);
+		tasklet_disable(&tp->tx_tl);
+		napi_disable(napi);
+		cancel_delayed_work_sync(&tp->schedule);
+		tp->rtl_ops.down(tp);
+
+		if (tp->version == RTL_VER_01)
+			rtl8152_set_speed(tp, AUTONEG_ENABLE, 0, 0, 3);
+		else
+			rtl_speed_down(tp);
+
+		napi_enable(napi);
+		tasklet_enable(&tp->tx_tl);
+	}
+
+	return 0;
+}
+
+static int rtl8152_suspend(struct usb_interface *intf, pm_message_t message)
+{
+	struct r8152 *tp = usb_get_intfdata(intf);
+	int ret;
+
+	mutex_lock(&tp->control);
+
+	if (PMSG_IS_AUTO(message))
+		ret = rtl8152_runtime_suspend(tp);
+	else
+		ret = rtl8152_system_suspend(tp);
+
+	mutex_unlock(&tp->control);
+
+	return ret;
+}
+
+static int rtl8152_resume(struct usb_interface *intf)
+{
+	struct r8152 *tp = usb_get_intfdata(intf);
+	int ret;
+
+	mutex_lock(&tp->control);
+
+	if (test_bit(SELECTIVE_SUSPEND, &tp->flags))
+		ret = rtl8152_runtime_resume(tp);
+	else
+		ret = rtl8152_system_resume(tp);
+
+	mutex_unlock(&tp->control);
+
+	return ret;
+}
+
+static int rtl8152_reset_resume(struct usb_interface *intf)
+{
+	struct r8152 *tp = usb_get_intfdata(intf);
+
+	clear_bit(SELECTIVE_SUSPEND, &tp->flags);
+	mutex_lock(&tp->control);
+	tp->rtl_ops.init(tp);
+	queue_delayed_work(system_long_wq, &tp->hw_phy_work, 0);
+	mutex_unlock(&tp->control);
+	return rtl8152_resume(intf);
+}
+
+static void rtl8152_get_wol(struct net_device *dev, struct ethtool_wolinfo *wol)
+{
+	struct r8152 *tp = netdev_priv(dev);
+
+	if (usb_autopm_get_interface(tp->intf) < 0)
+		return;
+
+	if (!rtl_can_wakeup(tp)) {
+		wol->supported = 0;
+		wol->wolopts = 0;
+	} else {
+		mutex_lock(&tp->control);
+		wol->supported = WAKE_ANY;
+		wol->wolopts = __rtl_get_wol(tp);
+		mutex_unlock(&tp->control);
+	}
+
+	usb_autopm_put_interface(tp->intf);
+}
+
+static int rtl8152_set_wol(struct net_device *dev, struct ethtool_wolinfo *wol)
+{
+	struct r8152 *tp = netdev_priv(dev);
+	int ret;
+
+	if (!rtl_can_wakeup(tp))
+		return -EOPNOTSUPP;
+
+	if (wol->wolopts & ~WAKE_ANY)
+		return -EINVAL;
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		goto out_set_wol;
+
+	mutex_lock(&tp->control);
+
+	__rtl_set_wol(tp, wol->wolopts);
+	tp->saved_wolopts = wol->wolopts & WAKE_ANY;
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+out_set_wol:
+	return ret;
+}
+
+static u32 rtl8152_get_msglevel(struct net_device *dev)
+{
+	struct r8152 *tp = netdev_priv(dev);
+
+	return tp->msg_enable;
+}
+
+static void rtl8152_set_msglevel(struct net_device *dev, u32 value)
+{
+	struct r8152 *tp = netdev_priv(dev);
+
+	tp->msg_enable = value;
+}
+
+static void rtl8152_get_drvinfo(struct net_device *netdev,
+				struct ethtool_drvinfo *info)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+
+	strlcpy(info->driver, MODULENAME, sizeof(info->driver));
+	strlcpy(info->version, DRIVER_VERSION, sizeof(info->version));
+	usb_make_path(tp->udev, info->bus_info, sizeof(info->bus_info));
+}
+
+static
+int rtl8152_get_settings(struct net_device *netdev, struct ethtool_cmd *cmd)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+	u16 bmcr, bmsr;
+	int ret, advert;
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		goto out;
+
+	cmd->supported =
+	    (SUPPORTED_10baseT_Half | SUPPORTED_10baseT_Full |
+	     SUPPORTED_100baseT_Half | SUPPORTED_100baseT_Full |
+	     SUPPORTED_Autoneg | SUPPORTED_MII);
+
+	/* only supports twisted-pair */
+	cmd->port = PORT_MII;
+
+	/* only supports internal transceiver */
+	cmd->transceiver = XCVR_INTERNAL;
+	cmd->phy_address = 32;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,31)
+	cmd->mdio_support = ETH_MDIO_SUPPORTS_C22;
+#endif
+	cmd->advertising = ADVERTISED_MII;
+
+	mutex_lock(&tp->control);
+
+	bmcr = r8152_mdio_read(tp, MII_BMCR);
+	bmsr = r8152_mdio_read(tp, MII_BMSR);
+
+	advert = r8152_mdio_read(tp, MII_ADVERTISE);
+	if (advert & ADVERTISE_10HALF)
+		cmd->advertising |= ADVERTISED_10baseT_Half;
+	if (advert & ADVERTISE_10FULL)
+		cmd->advertising |= ADVERTISED_10baseT_Full;
+	if (advert & ADVERTISE_100HALF)
+		cmd->advertising |= ADVERTISED_100baseT_Half;
+	if (advert & ADVERTISE_100FULL)
+		cmd->advertising |= ADVERTISED_100baseT_Full;
+	if (advert & ADVERTISE_PAUSE_CAP)
+		cmd->advertising |= ADVERTISED_Pause;
+	if (advert & ADVERTISE_PAUSE_ASYM)
+		cmd->advertising |= ADVERTISED_Asym_Pause;
+	if (tp->mii.supports_gmii) {
+		u16 ctrl1000 = r8152_mdio_read(tp, MII_CTRL1000);
+
+		cmd->supported |= SUPPORTED_1000baseT_Full;
+
+		if (tp->support_2500full) {
+			u16 data = ocp_reg_read(tp, 0xa5d4);
+
+			cmd->supported |= SUPPORTED_2500baseX_Full;
+			if (data & BIT(7))
+				cmd->advertising |= ADVERTISED_2500baseX_Full;
+		}
+
+		if (ctrl1000 & ADVERTISE_1000HALF)
+			cmd->advertising |= ADVERTISED_1000baseT_Half;
+		if (ctrl1000 & ADVERTISE_1000FULL)
+			cmd->advertising |= ADVERTISED_1000baseT_Full;
+	}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,31)
+	if (bmsr & BMSR_ANEGCOMPLETE) {
+		advert = r8152_mdio_read(tp, MII_LPA);
+		if (advert & LPA_LPACK)
+			cmd->lp_advertising |= ADVERTISED_Autoneg;
+		if (advert & ADVERTISE_10HALF)
+			cmd->lp_advertising |=
+				ADVERTISED_10baseT_Half;
+		if (advert & ADVERTISE_10FULL)
+			cmd->lp_advertising |=
+				ADVERTISED_10baseT_Full;
+		if (advert & ADVERTISE_100HALF)
+			cmd->lp_advertising |=
+				ADVERTISED_100baseT_Half;
+		if (advert & ADVERTISE_100FULL)
+			cmd->lp_advertising |=
+				ADVERTISED_100baseT_Full;
+
+		if (tp->mii.supports_gmii) {
+			u16 stat1000 = r8152_mdio_read(tp, MII_STAT1000);
+
+			if (stat1000 & LPA_1000HALF)
+				cmd->lp_advertising |=
+					ADVERTISED_1000baseT_Half;
+			if (stat1000 & LPA_1000FULL)
+				cmd->lp_advertising |=
+					ADVERTISED_1000baseT_Full;
+		}
+	} else {
+		cmd->lp_advertising = 0;
+	}
+#endif
+
+	if (bmcr & BMCR_ANENABLE) {
+		cmd->advertising |= ADVERTISED_Autoneg;
+		cmd->autoneg = AUTONEG_ENABLE;
+	} else {
+		cmd->autoneg = AUTONEG_DISABLE;
+	}
+
+
+	if (netif_running(netdev) && netif_carrier_ok(netdev)) {
+		u16 speed = rtl8152_get_speed(tp);
+
+		if (speed & _100bps)
+			cmd->speed = SPEED_100;
+		else if (speed & _10bps)
+			cmd->speed = SPEED_10;
+		else if (tp->mii.supports_gmii && (speed & _1000bps))
+			cmd->speed = SPEED_1000;
+		else if (tp->support_2500full && (speed & _2500bps))
+			cmd->speed = SPEED_2500;
+
+		cmd->duplex = (speed & FULL_DUP) ? DUPLEX_FULL : DUPLEX_HALF;
+	} else {
+		cmd->speed = SPEED_UNKNOWN;
+		cmd->duplex = DUPLEX_UNKNOWN;
+	}
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+out:
+	return ret;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,20,0)
+static int rtl8152_set_settings(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct r8152 *tp = netdev_priv(dev);
+	int ret;
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		goto out;
+
+	mutex_lock(&tp->control);
+
+	ret = rtl8152_set_speed(tp, cmd->autoneg, cmd->speed, cmd->duplex,
+				cmd->advertising);
+	if (!ret) {
+		tp->autoneg = cmd->autoneg;
+		tp->speed = cmd->speed;
+		tp->duplex = cmd->duplex;
+		tp->advertising = cmd->advertising;
+	}
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+out:
+	return ret;
+}
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(4,20,0) */
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,6,0)
+static int rtl8152_get_link_ksettings(struct net_device *netdev,
+				      struct ethtool_link_ksettings *cmd)
+{
+	struct ethtool_cmd ecmd;
+	int ret;
+
+	memset(&ecmd, 0, sizeof(ecmd));
+	ret = rtl8152_get_settings(netdev, &ecmd);
+	if (ret < 0)
+		goto out;
+
+	/* only supports twisted-pair */
+	cmd->base.port = ecmd.port;
+
+	cmd->base.phy_address = ecmd.phy_address;
+	cmd->base.mdio_support = ecmd.mdio_support;
+	cmd->base.autoneg = ecmd.autoneg;
+	cmd->base.speed = ecmd.speed;
+	cmd->base.duplex = ecmd.duplex;
+
+	ethtool_convert_legacy_u32_to_link_mode(cmd->link_modes.supported,
+						ecmd.supported);
+	ethtool_convert_legacy_u32_to_link_mode(cmd->link_modes.advertising,
+						ecmd.advertising);
+	ethtool_convert_legacy_u32_to_link_mode(cmd->link_modes.lp_advertising,
+						ecmd.lp_advertising);
+
+out:
+	return ret;
+}
+
+static int rtl8152_set_link_ksettings(struct net_device *dev,
+				      const struct ethtool_link_ksettings *cmd)
+{
+	struct r8152 *tp = netdev_priv(dev);
+	u32 advertising;
+	int ret;
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		goto out;
+
+	mutex_lock(&tp->control);
+
+	ethtool_convert_link_mode_to_legacy_u32(&advertising,
+						cmd->link_modes.advertising);
+
+	ret = rtl8152_set_speed(tp, cmd->base.autoneg, cmd->base.speed,
+				cmd->base.duplex, advertising);
+	if (!ret) {
+		tp->autoneg = cmd->base.autoneg;
+		tp->speed = cmd->base.speed;
+		tp->duplex = cmd->base.duplex;
+		tp->advertising = advertising;
+	}
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+out:
+	return ret;
+}
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(4,6,0) */
+
+static const char rtl8152_gstrings[][ETH_GSTRING_LEN] = {
+	"tx_packets",
+	"rx_packets",
+	"tx_errors",
+	"rx_errors",
+	"rx_missed",
+	"align_errors",
+	"tx_single_collisions",
+	"tx_multi_collisions",
+	"rx_unicast",
+	"rx_broadcast",
+	"rx_multicast",
+	"tx_aborted",
+	"tx_underrun",
+};
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,33)
+static int rtl8152_get_sset_count(struct net_device *dev)
+{
+	return ARRAY_SIZE(rtl8152_gstrings);
+}
+#else
+static int rtl8152_get_sset_count(struct net_device *dev, int sset)
+{
+	switch (sset) {
+	case ETH_SS_STATS:
+		return ARRAY_SIZE(rtl8152_gstrings);
+	default:
+		return -EOPNOTSUPP;
+	}
+}
+#endif
+
+static void rtl8152_get_ethtool_stats(struct net_device *dev,
+				      struct ethtool_stats *stats, u64 *data)
+{
+	struct r8152 *tp = netdev_priv(dev);
+	struct tally_counter tally;
+
+	if (usb_autopm_get_interface(tp->intf) < 0)
+		return;
+
+	if (mutex_lock_interruptible(&tp->control) < 0) {
+		usb_autopm_put_interface(tp->intf);
+		return;
+	}
+
+	generic_ocp_read(tp, PLA_TALLYCNT, sizeof(tally), &tally, MCU_TYPE_PLA);
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+	data[0] = le64_to_cpu(tally.tx_packets);
+	data[1] = le64_to_cpu(tally.rx_packets);
+	data[2] = le64_to_cpu(tally.tx_errors);
+	data[3] = le32_to_cpu(tally.rx_errors);
+	data[4] = le16_to_cpu(tally.rx_missed);
+	data[5] = le16_to_cpu(tally.align_errors);
+	data[6] = le32_to_cpu(tally.tx_one_collision);
+	data[7] = le32_to_cpu(tally.tx_multi_collision);
+	data[8] = le64_to_cpu(tally.rx_unicast);
+	data[9] = le64_to_cpu(tally.rx_broadcast);
+	data[10] = le32_to_cpu(tally.rx_multicast);
+	data[11] = le16_to_cpu(tally.tx_aborted);
+	data[12] = le16_to_cpu(tally.tx_underrun);
+}
+
+static void rtl8152_get_strings(struct net_device *dev, u32 stringset, u8 *data)
+{
+	switch (stringset) {
+	case ETH_SS_STATS:
+		memcpy(data, *rtl8152_gstrings, sizeof(rtl8152_gstrings));
+		break;
+	}
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+static int r8152_get_eee(struct r8152 *tp, struct ethtool_eee *eee)
+{
+	u32 lp, adv, supported = 0;
+	u16 val;
+
+	val = r8152_mmd_read(tp, MDIO_MMD_PCS, MDIO_PCS_EEE_ABLE);
+	supported = mmd_eee_cap_to_ethtool_sup_t(val);
+
+	val = r8152_mmd_read(tp, MDIO_MMD_AN, MDIO_AN_EEE_ADV);
+	adv = mmd_eee_adv_to_ethtool_adv_t(val);
+
+	val = r8152_mmd_read(tp, MDIO_MMD_AN, MDIO_AN_EEE_LPABLE);
+	lp = mmd_eee_adv_to_ethtool_adv_t(val);
+
+	eee->eee_enabled = tp->eee_en;
+	eee->eee_active = !!(supported & adv & lp);
+	eee->supported = supported;
+	eee->advertised = adv;
+	eee->lp_advertised = lp;
+
+	return 0;
+}
+
+static int r8152_set_eee(struct r8152 *tp, struct ethtool_eee *eee)
+{
+	u16 val = ethtool_adv_to_mmd_eee_adv_t(eee->advertised);
+
+	r8152_eee_en(tp, eee->eee_enabled);
+	tp->eee_en = eee->eee_enabled;
+
+	if (eee->eee_enabled) {
+		r8152_mmd_write(tp, MDIO_MMD_AN, MDIO_AN_EEE_ADV, val);
+		tp->eee_adv = val;
+	} else {
+		r8152_mmd_write(tp, MDIO_MMD_AN, MDIO_AN_EEE_ADV, 0);
+	}
+
+	return 0;
+}
+
+static int r8153_get_eee(struct r8152 *tp, struct ethtool_eee *eee)
+{
+	u32 lp, adv, supported = 0;
+	u16 val;
+
+	val = ocp_reg_read(tp, OCP_EEE_ABLE);
+	supported = mmd_eee_cap_to_ethtool_sup_t(val);
+
+	val = ocp_reg_read(tp, OCP_EEE_ADV);
+	adv = mmd_eee_adv_to_ethtool_adv_t(val);
+
+	val = ocp_reg_read(tp, OCP_EEE_LPABLE);
+	lp = mmd_eee_adv_to_ethtool_adv_t(val);
+
+	eee->eee_enabled = tp->eee_en;
+	eee->eee_active = !!(supported & adv & lp);
+	eee->supported = supported;
+	eee->advertised = adv;
+	eee->lp_advertised = lp;
+
+	return 0;
+}
+
+static int r8153_set_eee(struct r8152 *tp, struct ethtool_eee *eee)
+{
+	u16 val = ethtool_adv_to_mmd_eee_adv_t(eee->advertised);
+
+	r8153_eee_en(tp, eee->eee_enabled);
+	tp->eee_en = eee->eee_enabled;
+
+	if (eee->eee_enabled) {
+		ocp_reg_write(tp, OCP_EEE_ADV, val);
+		tp->eee_adv = val;
+	} else {
+		ocp_reg_write(tp, OCP_EEE_ADV, 0);
+	}
+
+	return 0;
+}
+
+static int r8153b_set_eee(struct r8152 *tp, struct ethtool_eee *eee)
+{
+	u16 val = ethtool_adv_to_mmd_eee_adv_t(eee->advertised);
+
+	r8153_eee_en(tp, eee->eee_enabled);
+	tp->eee_en = eee->eee_enabled;
+
+	if (eee->eee_enabled) {
+		ocp_reg_write(tp, OCP_EEE_ADV, val);
+		tp->eee_adv = val;
+	} else {
+		ocp_reg_write(tp, OCP_EEE_ADV, 0);
+	}
+
+	return 0;
+}
+
+static int r8156_set_eee(struct r8152 *tp, struct ethtool_eee *eee)
+{
+	u16 val = ethtool_adv_to_mmd_eee_adv_t(eee->advertised);
+
+	r8156_eee_en(tp, eee->eee_enabled);
+	tp->eee_en = eee->eee_enabled;
+
+	if (eee->eee_enabled) {
+		ocp_reg_write(tp, OCP_EEE_ADV, val);
+		tp->eee_adv = val;
+	} else {
+		ocp_reg_write(tp, OCP_EEE_ADV, 0);
+	}
+
+	return 0;
+}
+
+static int
+rtl_ethtool_get_eee(struct net_device *net, struct ethtool_eee *edata)
+{
+	struct r8152 *tp = netdev_priv(net);
+	int ret;
+
+	if (!tp->rtl_ops.eee_get) {
+		ret = -EOPNOTSUPP;
+		goto out;
+	}
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		goto out;
+
+	mutex_lock(&tp->control);
+
+	ret = tp->rtl_ops.eee_get(tp, edata);
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+out:
+	return ret;
+}
+
+static int
+rtl_ethtool_set_eee(struct net_device *net, struct ethtool_eee *edata)
+{
+	struct r8152 *tp = netdev_priv(net);
+	int ret;
+
+	if (!tp->rtl_ops.eee_set) {
+		ret = -EOPNOTSUPP;
+		goto out;
+	}
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		goto out;
+
+	mutex_lock(&tp->control);
+
+	ret = tp->rtl_ops.eee_set(tp, edata);
+	if (!ret)
+		ret = rtl_nway_restart(tp);
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+out:
+	return ret;
+}
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+
+static int rtl8152_nway_reset(struct net_device *dev)
+{
+	struct r8152 *tp = netdev_priv(dev);
+	int ret;
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		goto out;
+
+	mutex_lock(&tp->control);
+
+	ret = rtl_nway_restart(tp);
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+out:
+	return ret;
+}
+
+static int rtl8152_get_coalesce(struct net_device *netdev,
+				struct ethtool_coalesce *coalesce)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+
+	switch (tp->version) {
+	case RTL_VER_01:
+	case RTL_VER_02:
+	case RTL_VER_07:
+		return -EOPNOTSUPP;
+	default:
+		break;
+	}
+
+	coalesce->rx_coalesce_usecs = tp->coalesce / 1000;
+
+	return 0;
+}
+
+static int rtl8152_set_coalesce(struct net_device *netdev,
+				struct ethtool_coalesce *coalesce)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+	u32 rx_coalesce_nsecs;
+	int ret;
+
+	switch (tp->version) {
+	case RTL_VER_01:
+	case RTL_VER_02:
+	case RTL_VER_07:
+	case RTL_TEST_01: /* fix me */
+		return -EOPNOTSUPP;
+	default:
+		break;
+	}
+
+	rx_coalesce_nsecs = coalesce->rx_coalesce_usecs * 1000;
+
+	if (rx_coalesce_nsecs > COALESCE_SLOW)
+		return -EINVAL;
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		return ret;
+
+	mutex_lock(&tp->control);
+
+	if (tp->coalesce != rx_coalesce_nsecs) {
+		tp->coalesce = rx_coalesce_nsecs;
+
+		if (netif_running(netdev) && netif_carrier_ok(netdev)) {
+			netif_stop_queue(netdev);
+			napi_disable(&tp->napi);
+			tp->rtl_ops.disable(tp);
+			tp->rtl_ops.enable(tp);
+			rtl_start_rx(tp);
+			napi_enable(&tp->napi);
+			rtl8152_set_rx_mode(netdev);
+			netif_wake_queue(netdev);
+		}
+	}
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+	return ret;
+}
+
+static int rtl8152_ethtool_begin(struct net_device *netdev)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+
+	if (unlikely(tp->rtk_enable_diag))
+		return -EBUSY;
+
+	return 0;
+}
+
+static const struct ethtool_ops ops = {
+	.get_drvinfo = rtl8152_get_drvinfo,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,20,0)
+	.get_settings = rtl8152_get_settings,
+	.set_settings = rtl8152_set_settings,
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(4,20,0) */
+	.get_link = ethtool_op_get_link,
+	.nway_reset = rtl8152_nway_reset,
+	.get_msglevel = rtl8152_get_msglevel,
+	.set_msglevel = rtl8152_set_msglevel,
+	.get_wol = rtl8152_get_wol,
+	.set_wol = rtl8152_set_wol,
+	.get_strings = rtl8152_get_strings,
+	.get_sset_count = rtl8152_get_sset_count,
+	.get_ethtool_stats = rtl8152_get_ethtool_stats,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
+	.get_tx_csum = ethtool_op_get_tx_csum,
+	.set_tx_csum = ethtool_op_set_tx_csum,
+	.get_sg = ethtool_op_get_sg,
+	.set_sg = ethtool_op_set_sg,
+#ifdef NETIF_F_TSO
+	.get_tso = ethtool_op_get_tso,
+	.set_tso = ethtool_op_set_tso,
+#endif
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0) */
+	.get_coalesce = rtl8152_get_coalesce,
+	.set_coalesce = rtl8152_set_coalesce,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+	.get_eee = rtl_ethtool_get_eee,
+	.set_eee = rtl_ethtool_set_eee,
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,6,0)
+	.get_link_ksettings = rtl8152_get_link_ksettings,
+	.set_link_ksettings = rtl8152_set_link_ksettings,
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(4,6,0) */
+	.begin = rtl8152_ethtool_begin,
+};
+
+static int rtltool_ioctl(struct r8152 *tp, struct ifreq *ifr)
+{
+	struct net_device *netdev = tp->netdev;
+	struct rtltool_cmd my_cmd, *myptr;
+	struct usb_device_info *uinfo;
+	struct usb_device *udev;
+	__le32	ocp_data;
+	void	*buffer;
+	int	ret;
+
+	myptr = (struct rtltool_cmd *)ifr->ifr_data;
+	if (copy_from_user(&my_cmd, myptr, sizeof(my_cmd)))
+		return -EFAULT;
+
+	ret = 0;
+
+	switch (my_cmd.cmd) {
+	case RTLTOOL_PLA_OCP_READ_DWORD:
+		pla_ocp_read(tp, (u16)my_cmd.offset, sizeof(ocp_data),
+			     &ocp_data);
+		my_cmd.data = __le32_to_cpu(ocp_data);
+
+		if (copy_to_user(myptr, &my_cmd, sizeof(my_cmd))) {
+			ret = -EFAULT;
+			break;
+		}
+		break;
+
+	case RTLTOOL_PLA_OCP_WRITE_DWORD:
+		if (!tp->rtk_enable_diag && net_ratelimit())
+			netif_warn(tp, drv, netdev,
+				   "rtk diag isn't enable\n");
+
+		ocp_data = __cpu_to_le32(my_cmd.data);
+		pla_ocp_write(tp, (u16)my_cmd.offset, (u16)my_cmd.byteen,
+			      sizeof(ocp_data), &ocp_data);
+		break;
+
+	case RTLTOOL_USB_OCP_READ_DWORD:
+		usb_ocp_read(tp, (u16)my_cmd.offset, sizeof(ocp_data),
+			     &ocp_data);
+		my_cmd.data = __le32_to_cpu(ocp_data);
+
+		if (copy_to_user(myptr, &my_cmd, sizeof(my_cmd))) {
+			ret = -EFAULT;
+			break;
+		}
+		break;
+
+
+	case RTLTOOL_USB_OCP_WRITE_DWORD:
+		if (!tp->rtk_enable_diag && net_ratelimit())
+			netif_warn(tp, drv, netdev,
+				   "rtk diag isn't enable\n");
+
+		ocp_data = __cpu_to_le32(my_cmd.data);
+		usb_ocp_write(tp, (u16)my_cmd.offset, (u16)my_cmd.byteen,
+			      sizeof(ocp_data), &ocp_data);
+		break;
+
+	case RTLTOOL_PLA_OCP_READ:
+		buffer = kmalloc(my_cmd.data, GFP_KERNEL);
+		if (!buffer) {
+			ret = -ENOMEM;
+			break;
+		}
+
+		pla_ocp_read(tp, (u16)my_cmd.offset, my_cmd.data, buffer);
+
+		if (copy_to_user(my_cmd.buf, buffer, my_cmd.data))
+			ret = -EFAULT;
+
+		kfree(buffer);
+		break;
+
+	case RTLTOOL_PLA_OCP_WRITE:
+		if (!tp->rtk_enable_diag && net_ratelimit())
+			netif_warn(tp, drv, netdev,
+				   "rtk diag isn't enable\n");
+
+		buffer = kmalloc(my_cmd.data, GFP_KERNEL);
+		if (!buffer) {
+			ret = -ENOMEM;
+			break;
+		}
+
+		if (copy_from_user(buffer, my_cmd.buf, my_cmd.data)) {
+			ret = -EFAULT;
+			kfree(buffer);
+			break;
+		}
+
+		pla_ocp_write(tp, (u16)my_cmd.offset, (u16)my_cmd.byteen,
+			      my_cmd.data, buffer);
+		kfree(buffer);
+		break;
+
+	case RTLTOOL_USB_OCP_READ:
+		buffer = kmalloc(my_cmd.data, GFP_KERNEL);
+		if (!buffer) {
+			ret = -ENOMEM;
+			break;
+		}
+
+		usb_ocp_read(tp, (u16)my_cmd.offset, my_cmd.data, buffer);
+
+		if (copy_to_user(my_cmd.buf, buffer, my_cmd.data))
+			ret = -EFAULT;
+
+		kfree(buffer);
+		break;
+
+	case RTLTOOL_USB_OCP_WRITE:
+		if (!tp->rtk_enable_diag && net_ratelimit())
+			netif_warn(tp, drv, netdev,
+				   "rtk diag isn't enable\n");
+
+		buffer = kmalloc(my_cmd.data, GFP_KERNEL);
+		if (!buffer) {
+			ret = -ENOMEM;
+			break;
+		}
+
+		if (copy_from_user(buffer, my_cmd.buf, my_cmd.data)) {
+			ret = -EFAULT;
+			kfree(buffer);
+			break;
+		}
+
+		usb_ocp_write(tp, (u16)my_cmd.offset, (u16)my_cmd.byteen,
+			      my_cmd.data, buffer);
+		kfree(buffer);
+		break;
+
+	case RTLTOOL_USB_INFO:
+		uinfo = (struct usb_device_info *)&my_cmd.nic_info;
+		udev = tp->udev;
+		uinfo->idVendor = __le16_to_cpu(udev->descriptor.idVendor);
+		uinfo->idProduct = __le16_to_cpu(udev->descriptor.idProduct);
+		uinfo->bcdDevice = __le16_to_cpu(udev->descriptor.bcdDevice);
+		strlcpy(uinfo->devpath, udev->devpath, sizeof(udev->devpath));
+		pla_ocp_read(tp, PLA_IDR, sizeof(uinfo->dev_addr),
+			     uinfo->dev_addr);
+
+		if (copy_to_user(myptr, &my_cmd, sizeof(my_cmd)))
+			ret = -EFAULT;
+
+		break;
+
+	case RTL_ENABLE_USB_DIAG:
+		ret = usb_autopm_get_interface(tp->intf);
+		if (ret < 0)
+			break;
+
+		mutex_lock(&tp->control);
+		tp->rtk_enable_diag++;
+		netif_info(tp, drv, netdev, "enable rtk diag %d\n",
+			   tp->rtk_enable_diag);
+		break;
+
+	case RTL_DISABLE_USB_DIAG:
+		if (!tp->rtk_enable_diag) {
+			netif_err(tp, drv, netdev,
+				  "Invalid using rtk diag\n");
+			ret = -EPERM;
+			break;
+		}
+
+		rtk_disable_diag(tp);
+		break;
+
+	default:
+		ret = -EOPNOTSUPP;
+		break;
+	}
+
+	return ret;
+}
+
+static int rtl8152_ioctl(struct net_device *netdev, struct ifreq *rq, int cmd)
+{
+	struct r8152 *tp = netdev_priv(netdev);
+	struct mii_ioctl_data *data = if_mii(rq);
+	int ret;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return -ENODEV;
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		goto out;
+
+	switch (cmd) {
+	case SIOCGMIIPHY:
+		data->phy_id = R8152_PHY_ID; /* Internal PHY */
+		break;
+
+	case SIOCGMIIREG:
+		if (unlikely(tp->rtk_enable_diag)) {
+			ret = -EBUSY;
+			break;
+		}
+
+		mutex_lock(&tp->control);
+		data->val_out = r8152_mdio_read(tp, data->reg_num);
+		mutex_unlock(&tp->control);
+		break;
+
+	case SIOCSMIIREG:
+		if (!capable(CAP_NET_ADMIN)) {
+			ret = -EPERM;
+			break;
+		}
+
+		if (unlikely(tp->rtk_enable_diag)) {
+			ret = -EBUSY;
+			break;
+		}
+
+		mutex_lock(&tp->control);
+		r8152_mdio_write(tp, data->reg_num, data->val_in);
+		mutex_unlock(&tp->control);
+		break;
+
+	case SIOCDEVPRIVATE:
+		if (!capable(CAP_NET_ADMIN)) {
+			ret = -EPERM;
+			break;
+		}
+		ret = rtltool_ioctl(tp, rq);
+		break;
+
+	default:
+		ret = -EOPNOTSUPP;
+	}
+
+	usb_autopm_put_interface(tp->intf);
+
+out:
+	return ret;
+}
+
+static int rtl8152_change_mtu(struct net_device *dev, int new_mtu)
+{
+	struct r8152 *tp = netdev_priv(dev);
+	int ret;
+
+	switch (tp->version) {
+	case RTL_VER_01:
+	case RTL_VER_02:
+	case RTL_VER_07:
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,10,0)
+		return eth_change_mtu(dev, new_mtu);
+#else
+		dev->mtu = new_mtu;
+		return 0;
+#endif
+	default:
+		break;
+	}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4,10,0)
+	if (new_mtu < 68 || new_mtu > RTL8153_MAX_MTU)
+		return -EINVAL;
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(4,10,0) */
+
+	ret = usb_autopm_get_interface(tp->intf);
+	if (ret < 0)
+		return ret;
+
+	mutex_lock(&tp->control);
+
+	dev->mtu = new_mtu;
+
+	if (netif_running(dev)) {
+		netif_stop_queue(dev);
+		napi_disable(&tp->napi);
+		tasklet_disable(&tp->tx_tl);
+//		clear_bit(WORK_ENABLE, &tp->flags);
+		tp->rtl_ops.down(tp);
+		tp->rtl_ops.up(tp);
+//		set_bit(WORK_ENABLE, &tp->flags);
+		tasklet_enable(&tp->tx_tl);
+		if (netif_carrier_ok(dev) &&
+		    (rtl8152_get_speed(tp) & LINK_STATUS)) {
+			tp->rtl_ops.enable(tp);
+			rtl_start_rx(tp);
+			rtl8152_set_rx_mode(dev);
+		} else {
+			netif_carrier_off(dev);
+		}
+		napi_enable(&tp->napi);
+		netif_wake_queue(dev);
+
+		if (!list_empty(&tp->rx_done))
+			napi_schedule(&tp->napi);
+	}
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(tp->intf);
+
+	return ret;
+}
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,29)
+static const struct net_device_ops rtl8152_netdev_ops = {
+	.ndo_open		= rtl8152_open,
+	.ndo_stop		= rtl8152_close,
+	.ndo_do_ioctl		= rtl8152_ioctl,
+	.ndo_start_xmit		= rtl8152_start_xmit,
+	.ndo_tx_timeout		= rtl8152_tx_timeout,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
+	.ndo_vlan_rx_register	= rtl8152_vlan_rx_register,
+#else
+	.ndo_set_features	= rtl8152_set_features,
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0) */
+	.ndo_set_rx_mode	= rtl8152_set_rx_mode,
+	.ndo_set_mac_address	= rtl8152_set_mac_address,
+	.ndo_change_mtu		= rtl8152_change_mtu,
+	.ndo_validate_addr	= eth_validate_addr,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,18,4)
+	.ndo_features_check	= rtl8152_features_check,
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,18,4) */
+};
+#endif
+
+static void rtl8152_unload(struct r8152 *tp)
+{
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	if (tp->version != RTL_VER_01)
+		r8152_power_cut_en(tp, true);
+}
+
+static void rtl8153_unload(struct r8152 *tp)
+{
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	r8153_power_cut_en(tp, false);
+}
+
+static void rtl8153b_unload(struct r8152 *tp)
+{
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return;
+
+	r8153b_power_cut_en(tp, false);
+}
+
+static int rtl_ops_init(struct r8152 *tp)
+{
+	struct rtl_ops *ops = &tp->rtl_ops;
+	int ret = 0;
+
+	switch (tp->version) {
+	case RTL_VER_01:
+	case RTL_VER_02:
+	case RTL_VER_07:
+		ops->init		= r8152b_init;
+		ops->enable		= rtl8152_enable;
+		ops->disable		= rtl8152_disable;
+		ops->up			= rtl8152_up;
+		ops->down		= rtl8152_down;
+		ops->unload		= rtl8152_unload;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+		ops->eee_get		= r8152_get_eee;
+		ops->eee_set		= r8152_set_eee;
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+		ops->in_nway		= rtl8152_in_nway;
+		ops->hw_phy_cfg		= r8152b_hw_phy_cfg;
+		ops->autosuspend_en	= rtl_runtime_suspend_enable;
+		tp->rx_buf_sz		= 16 * 1024;
+		tp->eee_en		= true;
+		tp->eee_adv		= MDIO_EEE_100TX;
+		break;
+
+	case RTL_VER_03:
+	case RTL_VER_04:
+	case RTL_VER_05:
+	case RTL_VER_06:
+		ops->init		= r8153_init;
+		ops->enable		= rtl8153_enable;
+		ops->disable		= rtl8153_disable;
+		ops->up			= rtl8153_up;
+		ops->down		= rtl8153_down;
+		ops->unload		= rtl8153_unload;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+		ops->eee_get		= r8153_get_eee;
+		ops->eee_set		= r8153_set_eee;
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+		ops->in_nway		= rtl8153_in_nway;
+		ops->hw_phy_cfg		= r8153_hw_phy_cfg;
+		ops->autosuspend_en	= rtl8153_runtime_enable;
+		tp->rx_buf_sz		= 32 * 1024;
+		tp->eee_en		= true;
+		tp->eee_adv		= MDIO_EEE_1000T | MDIO_EEE_100TX;
+		break;
+
+	case RTL_VER_08:
+	case RTL_VER_09:
+		ops->init		= r8153b_init;
+		ops->enable		= rtl8153_enable;
+		ops->disable		= rtl8153_disable;
+		ops->up			= rtl8153b_up;
+		ops->down		= rtl8153b_down;
+		ops->unload		= rtl8153b_unload;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+		ops->eee_get		= r8153_get_eee;
+		ops->eee_set		= r8153b_set_eee;
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+		ops->in_nway		= rtl8153_in_nway;
+		ops->hw_phy_cfg		= r8153b_hw_phy_cfg;
+		ops->autosuspend_en	= rtl8153b_runtime_enable;
+		tp->rx_buf_sz		= 32 * 1024;
+		tp->eee_en		= true;
+		tp->eee_adv		= MDIO_EEE_1000T | MDIO_EEE_100TX;
+		break;
+
+	case RTL_TEST_01:
+		ops->init		= r8156_init;
+		ops->enable		= rtl8156_enable;
+		ops->disable		= rtl8153_disable;
+		ops->up			= rtl8156_up;
+		ops->down		= rtl8156_down;
+		ops->unload		= rtl8153_unload;
+//#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+//		ops->eee_get		= r8156_get_eee;
+//		ops->eee_set		= r8156_set_eee;
+//#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+		ops->in_nway		= rtl8153_in_nway;
+		ops->hw_phy_cfg		= r8156_hw_phy_cfg;
+		ops->autosuspend_en	= rtl8156_runtime_enable;
+		tp->rx_buf_sz		= 48 * 1024;
+		tp->support_2500full	= 1;
+		break;
+
+	case RTL_VER_11:
+		tp->eee_en		= true;
+		tp->eee_adv		= MDIO_EEE_1000T | MDIO_EEE_100TX;
+	case RTL_VER_10:
+		ops->init		= r8156_init;
+		ops->enable		= rtl8156_enable;
+		ops->disable		= rtl8153_disable;
+		ops->up			= rtl8156_up;
+		ops->down		= rtl8156_down;
+		ops->unload		= rtl8153_unload;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0)
+		ops->eee_get		= r8153_get_eee;
+		ops->eee_set		= r8156_set_eee;
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,6,0) */
+		ops->in_nway		= rtl8153_in_nway;
+		ops->hw_phy_cfg		= r8156_hw_phy_cfg2;
+		ops->autosuspend_en	= rtl8156_runtime_enable;
+		tp->rx_buf_sz		= 48 * 1024;
+		tp->support_2500full	= 1;
+		break;
+
+	default:
+		ret = -ENODEV;
+		netif_err(tp, probe, tp->netdev, "Unknown Device\n");
+		break;
+	}
+
+	return ret;
+}
+
+static u8 rtl_get_version(struct usb_interface *intf)
+{
+	struct usb_device *udev = interface_to_usbdev(intf);
+	u32 ocp_data = 0;
+	__le32 *tmp;
+	u8 version;
+	int ret;
+
+	tmp = kmalloc(sizeof(*tmp), GFP_KERNEL);
+	if (!tmp)
+		return 0;
+
+	ret = usb_control_msg(udev, usb_rcvctrlpipe(udev, 0),
+			      RTL8152_REQ_GET_REGS, RTL8152_REQT_READ,
+			      PLA_TCR0, MCU_TYPE_PLA, tmp, sizeof(*tmp), 500);
+	if (ret > 0)
+		ocp_data = (__le32_to_cpu(*tmp) >> 16) & VERSION_MASK;
+
+	kfree(tmp);
+
+	switch (ocp_data) {
+	case 0x4c00:
+		version = RTL_VER_01;
+		break;
+	case 0x4c10:
+		version = RTL_VER_02;
+		break;
+	case 0x5c00:
+		version = RTL_VER_03;
+		break;
+	case 0x5c10:
+		version = RTL_VER_04;
+		break;
+	case 0x5c20:
+		version = RTL_VER_05;
+		break;
+	case 0x5c30:
+		version = RTL_VER_06;
+		break;
+	case 0x4800:
+		version = RTL_VER_07;
+		break;
+	case 0x6000:
+		version = RTL_VER_08;
+		break;
+	case 0x6010:
+		version = RTL_VER_09;
+		break;
+	case 0x7010:
+		version = RTL_TEST_01;
+		break;
+	case 0x7020:
+		version = RTL_VER_10;
+		break;
+	case 0x7030:
+		version = RTL_VER_11;
+		break;
+	default:
+		version = RTL_VER_UNKNOWN;
+		dev_info(&intf->dev, "Unknown version 0x%04x\n", ocp_data);
+		break;
+	}
+
+	dev_dbg(&intf->dev, "Detected version 0x%04x\n", version);
+
+	return version;
+}
+
+#ifdef RTL8152_DEBUG
+
+static ssize_t
+ocp_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct usb_interface *intf = to_usb_interface(dev);
+	struct r8152 *tp = usb_get_intfdata(intf);
+	char tmp[256];
+	struct tally_counter tally;
+	int ret;
+
+	strcpy(buf, dev_name(dev));
+	strcat(buf, "\n");
+	strcat(buf, DRIVER_VERSION);
+	strcat(buf, "\n");
+
+	switch (tp->version) {
+	case RTL_VER_05:
+		strcat(buf, "RTL_VER_05\n");
+		strcat(buf, "pla_patch_code_20190220_0\n");
+		strcat(buf, "\n\n\n\n\n");
+		break;
+	case RTL_VER_06:
+		strcat(buf, "RTL_VER_06\n");
+		strcat(buf, "pla_patch_code_20190311_0\n");
+		strcat(buf, "\n\n\n\n\n");
+		break;
+	case RTL_VER_09:
+		strcat(buf, "RTL_VER_09\n");
+		strcat(buf, "usb_patch_code_20190418\n");
+		strcat(buf, "plamcu_patch_code_20190408_0\n");
+		strcat(buf, "\n\n\n\n");
+		break;
+	case RTL_VER_11:
+		strcat(buf, "RTL_VER_11\n");
+		strcat(buf, "nc0_patch_190128_usb\n");
+		strcat(buf, "nc1_patch_181029_usb\n");
+		strcat(buf, "nc2_patch_180821_usb\n");
+		strcat(buf, "uc2_patch_181018_usb\n");
+		strcat(buf, "USB_patch_code_20190212_v3\n");
+		strcat(buf, "PLA_patch_code_20180914_v3\n");
+		break;
+	default:
+		strcat(buf, "\n\n\n\n\n\n\n");
+		break;
+	}
+
+	ret = usb_autopm_get_interface(intf);
+	if (ret < 0)
+		return ret;
+
+	ret = mutex_lock_interruptible(&tp->control);
+	if (ret < 0) {
+		usb_autopm_put_interface(intf);
+		goto err1;
+	}
+
+	generic_ocp_read(tp, PLA_TALLYCNT, sizeof(tally), &tally, MCU_TYPE_PLA);
+
+	mutex_unlock(&tp->control);
+
+	usb_autopm_put_interface(intf);
+
+	sprintf(tmp, "tx_packets = %Lu\n", le64_to_cpu(tally.tx_packets));
+	strcat(buf, tmp);
+	sprintf(tmp, "rx_packets = %Lu\n", le64_to_cpu(tally.rx_packets));
+	strcat(buf, tmp);
+	sprintf(tmp, "tx_errors = %Lu\n", le64_to_cpu(tally.tx_errors));
+	strcat(buf, tmp);
+	sprintf(tmp, "tx_errors = %u\n", le32_to_cpu(tally.rx_errors));
+	strcat(buf, tmp);
+	sprintf(tmp, "rx_missed = %u\n", le16_to_cpu(tally.rx_missed));
+	strcat(buf, tmp);
+	sprintf(tmp, "align_errors = %u\n", le16_to_cpu(tally.align_errors));
+	strcat(buf, tmp);
+	sprintf(tmp, "tx_one_collision = %u\n",
+		le32_to_cpu(tally.tx_one_collision));
+	strcat(buf, tmp);
+	sprintf(tmp, "tx_multi_collision = %u\n",
+		le32_to_cpu(tally.tx_multi_collision));
+	strcat(buf, tmp);
+	sprintf(tmp, "rx_unicast = %Lu\n", le64_to_cpu(tally.rx_unicast));
+	strcat(buf, tmp);
+	sprintf(tmp, "rx_broadcast = %Lu\n", le64_to_cpu(tally.rx_broadcast));
+	strcat(buf, tmp);
+	sprintf(tmp, "rx_multicast = %u\n", le32_to_cpu(tally.rx_multicast));
+	strcat(buf, tmp);
+	sprintf(tmp, "tx_aborted = %u\n", le16_to_cpu(tally.tx_aborted));
+	strcat(buf, tmp);
+	sprintf(tmp, "tx_underrun = %u\n", le16_to_cpu(tally.tx_underrun));
+	strcat(buf, tmp);
+
+err1:
+	if (ret < 0)
+		return ret;
+	else
+		return strlen(buf);
+}
+
+static inline bool hex_value(char p)
+{
+	return (p >= '0' && p <= '9') ||
+	       (p >= 'a' && p <= 'f') ||
+	       (p >= 'A' && p <= 'F');
+}
+
+static int ocp_count(char *v1)
+{
+	int len = strlen(v1), count = 0;
+	char *v2 = strchr(v1, ' ');
+	bool is_vaild = false;
+
+	if (len < 5 || !v2)
+		goto out1;
+//	else if (strncmp(v1, "pla ", 4) && strncmp(v1, "usb ", 4))
+//		goto out1;
+
+	v1 = v2;
+	len = strlen(v2);
+	while(len) {
+		if (*v1 != ' ')
+			break;
+		v1++;
+		len--;
+	}
+
+	if (!len || *v1 == '\n')
+		goto out1;
+
+check:
+	v2 = strchr(v1, ' ');
+
+	if (len > 2 && !strncasecmp(v1, "0x", 2)) {
+		v1 += 2;
+		len -= 2;
+		if (v1 == v2 || *v1 == '\n')
+			goto out1;
+	}
+
+	if (v2) {
+		while (v1 < v2) {
+			if (!hex_value(*v1))
+				goto out1;
+			v1++;
+			len--;
+		}
+
+		count++;
+
+		while(len) {
+			if (*v1 != ' ')
+				break;
+			v1++;
+			len--;
+		}
+
+		if (len)
+			goto check;
+
+		is_vaild = true;
+	} else {
+		int i;
+
+		if (len && v1[len - 1] == '\n')
+			len--;
+
+		for (i = 0; i < len; i++) {
+			if (!hex_value(*v1))
+				goto out1;
+			v1++;
+		}
+
+		if (len)
+			count++;
+
+		is_vaild = true;
+	}
+
+out1:
+	if (is_vaild)
+		return count;
+	else
+		return 0;
+}
+
+static ssize_t ocp_store(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	struct usb_interface *intf;
+	struct net_device *netdev;
+	u32 v1, v2, v3, v4;
+	struct r8152 *tp;
+	u16 type;
+	int num, ret;
+
+	intf = to_usb_interface(dev);
+	tp = usb_get_intfdata(intf);
+	netdev = tp->netdev;
+
+	if (!strncmp(buf, "pla ", 4))
+		type = MCU_TYPE_PLA;
+	else if (!strncmp(buf, "usb ", 4))
+		type = MCU_TYPE_USB;
+	else
+		return -EINVAL;
+
+	if (!ocp_count((char *)buf))
+		return -EINVAL;
+
+	num = sscanf(strchr(buf, ' '), "%x %x %x %x\n", &v1, &v2, &v3, &v4);
+
+	if (num > 1) {
+		if ((v1 == 2 && (v2 & 1)) ||
+		    (v1 == 4 && (v2 & 3)) ||
+		    (type == MCU_TYPE_PLA &&
+		     (v2 < 0xc000 || (v2 & ~3) == PLA_OCP_GPHY_BASE)))
+			return -EINVAL;
+	}
+
+	ret = usb_autopm_get_interface(intf);
+	if (ret < 0)
+		return ret;
+
+	ret = mutex_lock_interruptible(&tp->control);
+	if (ret < 0)
+		goto put;
+
+	switch(num) {
+	case 2:
+		switch (v1) {
+		case 1:
+			netif_info(tp, drv, netdev, "%s read byte %x = %x\n",
+				   type ? "PLA" : "USB", v2,
+				   ocp_read_byte(tp, type, v2));
+			break;
+		case 2:
+			netif_info(tp, drv, netdev, "%s read word %x = %x\n",
+				   type ? "PLA" : "USB", v2,
+				   ocp_read_word(tp, type, v2));
+			break;
+		case 4:
+			netif_info(tp, drv, netdev, "%s read dword %x = %x\n",
+				   type ? "PLA" : "USB", v2,
+				   ocp_read_dword(tp, type, v2));
+			break;
+		default:
+			ret = -EINVAL;
+			break;
+		}
+		break;
+	case 3:
+		switch (v1) {
+		case 1:
+			netif_info(tp, drv, netdev, "%s write byte %x = %x\n",
+				   type ? "PLA" : "USB", v2, v3);
+			ocp_write_byte(tp, type, v2, v3);
+			break;
+		case 2:
+			netif_info(tp, drv, netdev, "%s write word %x = %x\n",
+				   type ? "PLA" : "USB", v2, v3);
+			ocp_write_word(tp, type, v2, v3);
+			break;
+		case 4:
+			netif_info(tp, drv, netdev, "%s write dword %x = %x\n",
+				   type ? "PLA" : "USB", v2, v3);
+			ocp_write_dword(tp, type, v2, v3);
+			break;
+		default:
+			ret = -EINVAL;
+			break;
+		}
+		break;
+	case 4:
+	case 1:
+	default:
+		ret = -EINVAL;
+		break;
+	}
+
+	mutex_unlock(&tp->control);
+
+put:
+	usb_autopm_put_interface(intf);
+
+	if (ret < 0)
+		count = ret;
+
+	return count;
+}
+
+static DEVICE_ATTR_RW(ocp);
+
+static struct attribute *rtk_attrs[] = {
+	&dev_attr_ocp.attr,
+	NULL
+};
+
+#define ATTR_PLA_SIZE	0x3000
+
+/* hexdump -e '"%04_ax\t" 16/1 "%02X " "\n"' pla */
+static ssize_t pla_read(struct file *fp, struct kobject *kobj,
+			struct bin_attribute *attr, char *buf, loff_t offset,
+			size_t size)
+{
+	struct device *dev = kobj_to_dev(kobj);
+	struct usb_interface *intf = to_usb_interface(dev);
+	struct r8152 *tp = usb_get_intfdata(intf);
+	struct net_device *netdev = tp->netdev;
+
+	if (size <= ATTR_PLA_SIZE)
+		size = min(size, ATTR_PLA_SIZE - (size_t)offset);
+	else
+		return -EINVAL;
+
+	/* rtnl_lock(); */
+	if (mutex_lock_interruptible(&tp->control))
+		return -EINTR;
+
+	if (pla_ocp_read(tp, offset + 0xc000, (u16)size, buf) < 0)
+		netif_err(tp, drv, netdev,
+			  "Read PLA offset 0x%Lx, len = %zd fail\n",
+			  offset + 0xc000, size);
+
+	mutex_unlock(&tp->control);
+	/* rtnl_unlock(); */
+
+	return size;
+}
+
+static BIN_ATTR_RO(pla, ATTR_PLA_SIZE);
+
+static struct bin_attribute *rtk_bin_attrs[] = {
+	&bin_attr_pla,
+	NULL
+};
+
+static struct attribute_group rtk_dbg_grp = {
+	.name = "nic_swsd",
+	.attrs = rtk_attrs,
+	.bin_attrs = rtk_bin_attrs,
+};
+
+#endif
+
+static ssize_t rx_frag_head_sz_show(struct device *dev,
+				    struct device_attribute *attr, char *buf)
+{
+	struct usb_interface *intf = to_usb_interface(dev);
+	struct r8152 *tp = usb_get_intfdata(intf);
+
+	sprintf(buf, "%u\n", tp->rx_frag_head_sz);
+
+	return strlen(buf);
+}
+
+static ssize_t rx_frag_head_sz_store(struct device *dev,
+				     struct device_attribute *attr,
+				     const char *buf, size_t count)
+{
+	struct usb_interface *intf;
+	u32 rx_frag_head_sz;
+	struct r8152 *tp;
+
+	intf = to_usb_interface(dev);
+	tp = usb_get_intfdata(intf);
+
+	if (sscanf(buf, "%u\n", &rx_frag_head_sz) != 1)
+			return -EINVAL;
+
+	if (rx_frag_head_sz < ETH_ZLEN)
+			return -EINVAL;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return -ENODEV;
+
+	if (tp->rx_frag_head_sz != rx_frag_head_sz) {
+		napi_disable(&tp->napi);
+		tp->rx_frag_head_sz = rx_frag_head_sz;
+		napi_enable(&tp->napi);
+	}
+
+	return count;
+}
+
+static DEVICE_ATTR_RW(rx_frag_head_sz);
+
+static ssize_t rx_max_agg_num_show(struct device *dev,
+				    struct device_attribute *attr, char *buf)
+{
+	struct usb_interface *intf = to_usb_interface(dev);
+	struct r8152 *tp = usb_get_intfdata(intf);
+
+	sprintf(buf, "%u\n", tp->rx_max_agg_num);
+
+	return strlen(buf);
+}
+
+static ssize_t rx_max_agg_num_store(struct device *dev,
+				     struct device_attribute *attr,
+				     const char *buf, size_t count)
+{
+	struct usb_interface *intf;
+	u32 rx_max_agg_num;
+	struct r8152 *tp;
+
+	intf = to_usb_interface(dev);
+	tp = usb_get_intfdata(intf);
+
+	if (sscanf(buf, "%u\n", &rx_max_agg_num) != 1)
+			return -EINVAL;
+
+	if (rx_max_agg_num < (RTL8152_MAX_RX * 2))
+			return -EINVAL;
+
+	if (test_bit(RTL8152_UNPLUG, &tp->flags))
+		return -ENODEV;
+
+	if (tp->rx_max_agg_num != rx_max_agg_num) {
+		napi_disable(&tp->napi);
+		tp->rx_max_agg_num = rx_max_agg_num;
+		napi_enable(&tp->napi);
+	}
+
+	return count;
+}
+
+static DEVICE_ATTR_RW(rx_max_agg_num);
+
+static ssize_t
+sg_en_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct usb_interface *intf;
+	struct r8152 *tp;
+
+	intf = to_usb_interface(dev);
+	tp = usb_get_intfdata(intf);
+
+	if (tp->sg_use)
+		strcat(buf, "enable\n");
+	else
+		strcat(buf, "disable\n");
+
+	return strlen(buf);
+}
+
+static ssize_t sg_en_store(struct device *dev, struct device_attribute *attr,
+			   const char *buf, size_t count)
+{
+	struct usb_interface *intf;
+	struct r8152 *tp;
+	u32 tso_size;
+
+	intf = to_usb_interface(dev);
+	tp = usb_get_intfdata(intf);
+
+	if (!strncmp(buf, "enable", 6) &&
+	    usb_device_no_sg_constraint(tp->udev)) {
+		tp->sg_use = true;
+		tso_size = GSO_MAX_SIZE;
+	} else if (!strncmp(buf, "disable", 7)) {
+		tp->sg_use = false;
+		tso_size = RTL_LIMITED_TSO_SIZE;
+	} else {
+		return -EINVAL;
+	}
+
+	netif_set_gso_max_size(tp->netdev, tso_size);
+
+	return count;
+}
+
+static DEVICE_ATTR_RW(sg_en);
+
+static struct attribute *rtk_adv_attrs[] = {
+	&dev_attr_rx_frag_head_sz.attr,
+	&dev_attr_rx_max_agg_num.attr,
+	&dev_attr_sg_en.attr,
+	NULL
+};
+
+static struct attribute_group rtk_adv_grp = {
+	.name = "rtl_adv",
+	.attrs = rtk_adv_attrs,
+};
+
+static int rtl8152_probe(struct usb_interface *intf,
+			 const struct usb_device_id *id)
+{
+	struct usb_device *udev = interface_to_usbdev(intf);
+	u8 version = rtl_get_version(intf);
+	struct r8152 *tp;
+	struct net_device *netdev;
+	int ret;
+
+	if (version == RTL_VER_UNKNOWN)
+		return -ENODEV;
+
+	if (!rtl_vendor_mode(intf)) {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
+		dev_err(&intf->dev, "The kernel too old to set configuration\n");
+#else
+		usb_driver_set_configuration(udev, 1);
+#endif
+		return -ENODEV;
+	}
+
+	usb_reset_device(udev);
+	netdev = alloc_etherdev(sizeof(struct r8152));
+	if (!netdev) {
+		dev_err(&intf->dev, "Out of memory\n");
+		return -ENOMEM;
+	}
+
+	SET_NETDEV_DEV(netdev, &intf->dev);
+	tp = netdev_priv(netdev);
+	tp->msg_enable = 0x7FFF;
+
+	tp->udev = udev;
+	tp->netdev = netdev;
+	tp->intf = intf;
+	tp->version = version;
+
+	switch (version) {
+	case RTL_VER_01:
+	case RTL_VER_02:
+	case RTL_VER_07:
+		tp->mii.supports_gmii = 0;
+		break;
+	default:
+		tp->mii.supports_gmii = 1;
+		break;
+	}
+
+	ret = rtl_ops_init(tp);
+	if (ret)
+		goto out;
+
+	mutex_init(&tp->control);
+	INIT_DELAYED_WORK(&tp->schedule, rtl_work_func_t);
+	INIT_DELAYED_WORK(&tp->hw_phy_work, rtl_hw_phy_work_func_t);
+	tasklet_init(&tp->tx_tl, bottom_half, (unsigned long)tp);
+	tasklet_disable(&tp->tx_tl);
+
+	if (usb_device_no_sg_constraint(udev))
+		tp->sg_use = true;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,29)
+	netdev->open = rtl8152_open;
+	netdev->stop = rtl8152_close;
+	netdev->get_stats = rtl8152_get_stats;
+	netdev->hard_start_xmit = rtl8152_start_xmit;
+	netdev->tx_timeout = rtl8152_tx_timeout;
+	netdev->change_mtu = rtl8152_change_mtu;
+	netdev->set_mac_address = rtl8152_set_mac_address;
+	netdev->do_ioctl = rtl8152_ioctl;
+	netdev->set_multicast_list = rtl8152_set_rx_mode;
+	netdev->vlan_rx_register = rtl8152_vlan_rx_register;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22)
+	netdev->vlan_rx_kill_vid = rtl8152_vlan_rx_kill_vid;
+#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,22) */
+#else
+	netdev->netdev_ops = &rtl8152_netdev_ops;
+#endif /* HAVE_NET_DEVICE_OPS */
+
+	netdev->watchdog_timeo = RTL8152_TX_TIMEOUT;
+
+	netdev->features |= NETIF_F_RXCSUM | NETIF_F_IP_CSUM | NETIF_F_SG |
+			    NETIF_F_TSO | NETIF_F_FRAGLIST | NETIF_F_IPV6_CSUM |
+			    NETIF_F_TSO6 | NETIF_F_HW_VLAN_CTAG_RX |
+			    NETIF_F_HW_VLAN_CTAG_TX;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,39)
+	netdev->hw_features = NETIF_F_RXCSUM | NETIF_F_IP_CSUM | NETIF_F_SG |
+			      NETIF_F_TSO | NETIF_F_FRAGLIST |
+			      NETIF_F_IPV6_CSUM | NETIF_F_TSO6 |
+			      NETIF_F_HW_VLAN_CTAG_RX | NETIF_F_HW_VLAN_CTAG_TX;
+	netdev->vlan_features = NETIF_F_SG | NETIF_F_IP_CSUM | NETIF_F_TSO |
+				NETIF_F_HIGHDMA | NETIF_F_FRAGLIST |
+				NETIF_F_IPV6_CSUM | NETIF_F_TSO6;
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,39) */
+
+	if (tp->version == RTL_VER_01) {
+		netdev->features &= ~NETIF_F_RXCSUM;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,39)
+		netdev->hw_features &= ~NETIF_F_RXCSUM;
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,39) */
+	}
+
+	netdev->ethtool_ops = &ops;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,26)
+	if (!tp->sg_use)
+		netif_set_gso_max_size(netdev, RTL_LIMITED_TSO_SIZE);
+#else
+	netdev->features &= ~(NETIF_F_TSO | NETIF_F_TSO6);
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,26) */
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,10,0)
+	/* MTU range: 68 - 1500 or 9194 */
+	netdev->min_mtu = ETH_MIN_MTU;
+	switch (tp->version) {
+	case RTL_VER_01:
+	case RTL_VER_02:
+		netdev->max_mtu = ETH_DATA_LEN;
+		break;
+	default:
+		netdev->max_mtu = RTL8153_MAX_MTU;
+		break;
+	}
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(4,10,0) */
+
+	tp->mii.dev = netdev;
+	tp->mii.mdio_read = read_mii_word;
+	tp->mii.mdio_write = write_mii_word;
+	tp->mii.phy_id_mask = 0x3f;
+	tp->mii.reg_num_mask = 0x1f;
+	tp->mii.phy_id = R8152_PHY_ID;
+	tp->mii.force_media = 0;
+	tp->mii.advertising = ADVERTISE_10HALF | ADVERTISE_10FULL |
+			      ADVERTISE_100HALF | ADVERTISE_100FULL;
+
+	tp->autoneg = AUTONEG_ENABLE;
+	tp->speed = SPEED_100;
+	tp->advertising = ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full |
+			  ADVERTISED_100baseT_Half |
+			  ADVERTISED_100baseT_Full;
+	if (tp->mii.supports_gmii) {
+		if (tp->support_2500full &&
+		    tp->udev->speed >= USB_SPEED_SUPER) {
+			tp->speed = SPEED_2500;
+			tp->advertising |= ADVERTISED_2500baseX_Full;
+		} else {
+			tp->speed = SPEED_1000;
+		}
+		tp->advertising |= ADVERTISED_1000baseT_Full;
+	}
+	tp->duplex = DUPLEX_FULL;
+
+	tp->rx_frag_head_sz = RTL8152_RXFG_HEADSZ;
+	tp->rx_max_agg_num = RTL8152_MAX_RX_AGG;
+
+	intf->needs_remote_wakeup = 1;
+
+	if (!rtl_can_wakeup(tp))
+		__rtl_set_wol(tp, 0);
+	else
+		tp->saved_wolopts = __rtl_get_wol(tp);
+
+	tp->rtl_ops.init(tp);
+	queue_delayed_work(system_long_wq, &tp->hw_phy_work, 0);
+	set_ethernet_addr(tp);
+
+	usb_set_intfdata(intf, tp);
+
+	if (tp->support_2500full)
+		netif_napi_add(netdev, &tp->napi, r8152_poll, 256);
+	else
+		netif_napi_add(netdev, &tp->napi, r8152_poll, 64);
+
+	ret = register_netdev(netdev);
+	if (ret != 0) {
+		netif_err(tp, probe, netdev, "couldn't register the device\n");
+		goto out1;
+	}
+
+	if (tp->saved_wolopts)
+		device_set_wakeup_enable(&udev->dev, true);
+	else
+		device_set_wakeup_enable(&udev->dev, false);
+
+	/* usb_enable_autosuspend(udev); */
+
+	netif_info(tp, probe, netdev, "%s\n", DRIVER_VERSION);
+	netif_info(tp, probe, netdev, "%s\n", PATENTS);
+	if (tp->sg_use)
+		netif_info(tp, probe, netdev, "Tx with scatterlist\n");
+	else
+		netif_info(tp, probe, netdev, "Tx without scatterlist\n");
+
+	ret = sysfs_create_group(&intf->dev.kobj, &rtk_adv_grp);
+	if (ret < 0) {
+		netif_err(tp, probe, netdev, "creat rtk_adv_grp fail\n");
+		goto out2;
+	}
+
+#ifdef RTL8152_DEBUG
+	ret = sysfs_create_group(&intf->dev.kobj, &rtk_dbg_grp);
+	if (ret < 0) {
+		netif_err(tp, probe, netdev, "creat rtk_dbg_grp fail\n");
+		goto out3;
+	}
+#endif
+
+	return 0;
+
+#ifdef RTL8152_DEBUG
+out3:
+	sysfs_remove_group(&intf->dev.kobj, &rtk_adv_grp);
+#endif
+out2:
+	unregister_netdev(netdev);
+out1:
+	netif_napi_del(&tp->napi);
+	tasklet_kill(&tp->tx_tl);
+	usb_set_intfdata(intf, NULL);
+out:
+	free_netdev(netdev);
+	return ret;
+}
+
+static void rtl8152_disconnect(struct usb_interface *intf)
+{
+	struct r8152 *tp = usb_get_intfdata(intf);
+
+#ifdef RTL8152_DEBUG
+	sysfs_remove_group(&intf->dev.kobj, &rtk_dbg_grp);
+#endif
+	sysfs_remove_group(&intf->dev.kobj, &rtk_adv_grp);
+
+	usb_set_intfdata(intf, NULL);
+	if (tp) {
+		rtl_set_unplug(tp);
+		unregister_netdev(tp->netdev);
+		netif_napi_del(&tp->napi);
+		tasklet_kill(&tp->tx_tl);
+		cancel_delayed_work_sync(&tp->hw_phy_work);
+		if (tp->rtl_ops.unload)
+			tp->rtl_ops.unload(tp);
+		free_netdev(tp->netdev);
+	}
+}
+
+#define REALTEK_USB_DEVICE(vend, prod)	\
+	USB_DEVICE_INTERFACE_CLASS(vend, prod, USB_CLASS_VENDOR_SPEC) \
+}, \
+{ \
+	USB_DEVICE_AND_INTERFACE_INFO(vend, prod, USB_CLASS_COMM, \
+				      USB_CDC_SUBCLASS_ETHERNET, \
+				      USB_CDC_PROTO_NONE) \
+}, \
+{ \
+	USB_DEVICE_AND_INTERFACE_INFO(vend, prod, USB_CLASS_COMM, \
+				      USB_CDC_SUBCLASS_NCM, \
+				      USB_CDC_PROTO_NONE)
+
+/* table of devices that work with this driver */
+static const struct usb_device_id rtl8152_table[] = {
+	/* Realtek */
+	{REALTEK_USB_DEVICE(VENDOR_ID_REALTEK, 0x8050)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_REALTEK, 0x8152)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_REALTEK, 0x8153)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_REALTEK, 0x8156)},
+
+	/* Microsoft */
+	{REALTEK_USB_DEVICE(VENDOR_ID_MICROSOFT, 0x07ab)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_MICROSOFT, 0x07c6)},
+
+	/* Samsung */
+	{REALTEK_USB_DEVICE(VENDOR_ID_SAMSUNG, 0xa101)},
+
+	/* Lenovo */
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x304f)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3052)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3054)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3057)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3062)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3069)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3082)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x7205)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x720a)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x720b)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x720c)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x7214)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x721e)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0xa359)},
+	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0xa387)},
+
+	/* TP-LINK */
+	{REALTEK_USB_DEVICE(VENDOR_ID_TPLINK, 0x0601)},
+
+	/* Nvidia */
+	{REALTEK_USB_DEVICE(VENDOR_ID_NVIDIA,  0x09ff)},
+
+	/* LINKSYS */
+	{REALTEK_USB_DEVICE(VENDOR_ID_LINKSYS, 0x0041)},
+
+	{}
+};
+
+MODULE_DEVICE_TABLE(usb, rtl8152_table);
+
+static struct usb_driver rtl8152_driver = {
+	.name =		MODULENAME,
+	.id_table =	rtl8152_table,
+	.probe =	rtl8152_probe,
+	.disconnect =	rtl8152_disconnect,
+	.suspend =	rtl8152_suspend,
+	.resume =	rtl8152_resume,
+	.reset_resume =	rtl8152_reset_resume,
+	.pre_reset =	rtl8152_pre_reset,
+	.post_reset =	rtl8152_post_reset,
+	.supports_autosuspend = 1,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,5,0)
+	.disable_hub_initiated_lpm = 1,
+#endif
+};
+
+module_usb_driver(rtl8152_driver);
+
+MODULE_AUTHOR(DRIVER_AUTHOR);
+MODULE_DESCRIPTION(DRIVER_DESC);
+MODULE_LICENSE("GPL");
+MODULE_VERSION(DRIVER_VERSION);
diff --git a/drivers/net/wireless/broadcom/brcm80211/brcmfmac/cfg80211.c b/drivers/net/wireless/broadcom/brcm80211/brcmfmac/cfg80211.c
index c221597..00f2c0b 100644
--- a/drivers/net/wireless/broadcom/brcm80211/brcmfmac/cfg80211.c
+++ b/drivers/net/wireless/broadcom/brcm80211/brcmfmac/cfg80211.c
@@ -2774,7 +2774,6 @@ static s32 brcmf_inform_single_bss(struct brcmf_cfg80211_info *cfg,
 				   struct brcmf_bss_info_le *bi)
 {
 	struct wiphy *wiphy = cfg_to_wiphy(cfg);
-	struct ieee80211_channel *notify_channel;
 	struct cfg80211_bss *bss;
 	struct ieee80211_supported_band *band;
 	struct brcmu_chan ch;
@@ -2784,7 +2783,7 @@ static s32 brcmf_inform_single_bss(struct brcmf_cfg80211_info *cfg,
 	u16 notify_interval;
 	u8 *notify_ie;
 	size_t notify_ielen;
-	s32 notify_signal;
+	struct cfg80211_inform_bss bss_data = {};
 
 	if (le32_to_cpu(bi->length) > WL_BSS_INFO_MAX) {
 		brcmf_err("Bss info is larger than buffer. Discarding\n");
@@ -2804,27 +2803,28 @@ static s32 brcmf_inform_single_bss(struct brcmf_cfg80211_info *cfg,
 		band = wiphy->bands[NL80211_BAND_5GHZ];
 
 	freq = ieee80211_channel_to_frequency(channel, band->band);
-	notify_channel = ieee80211_get_channel(wiphy, freq);
+	bss_data.chan = ieee80211_get_channel(wiphy, freq);
+	bss_data.scan_width = NL80211_BSS_CHAN_WIDTH_20;
+	bss_data.boottime_ns = ktime_to_ns(ktime_get_boottime());
 
 	notify_capability = le16_to_cpu(bi->capability);
 	notify_interval = le16_to_cpu(bi->beacon_period);
 	notify_ie = (u8 *)bi + le16_to_cpu(bi->ie_offset);
 	notify_ielen = le32_to_cpu(bi->ie_length);
-	notify_signal = (s16)le16_to_cpu(bi->RSSI) * 100;
+	bss_data.signal = (s16)le16_to_cpu(bi->RSSI) * 100;
 
 	brcmf_dbg(CONN, "bssid: %pM\n", bi->BSSID);
 	brcmf_dbg(CONN, "Channel: %d(%d)\n", channel, freq);
 	brcmf_dbg(CONN, "Capability: %X\n", notify_capability);
 	brcmf_dbg(CONN, "Beacon interval: %d\n", notify_interval);
-	brcmf_dbg(CONN, "Signal: %d\n", notify_signal);
-
-	bss = cfg80211_inform_bss(wiphy, notify_channel,
-				  CFG80211_BSS_FTYPE_UNKNOWN,
-				  (const u8 *)bi->BSSID,
-				  0, notify_capability,
-				  notify_interval, notify_ie,
-				  notify_ielen, notify_signal,
-				  GFP_KERNEL);
+	brcmf_dbg(CONN, "Signal: %d\n", bss_data.signal);
+
+	bss = cfg80211_inform_bss_data(wiphy, &bss_data,
+				       CFG80211_BSS_FTYPE_UNKNOWN,
+				       (const u8 *)bi->BSSID,
+				       0, notify_capability,
+				       notify_interval, notify_ie,
+				       notify_ielen, GFP_KERNEL);
 
 	if (!bss)
 		return -ENOMEM;
diff --git a/drivers/net/wireless/ti/wlcore/init.c b/drivers/net/wireless/ti/wlcore/init.c
index d0b7734..b7974b4 100644
--- a/drivers/net/wireless/ti/wlcore/init.c
+++ b/drivers/net/wireless/ti/wlcore/init.c
@@ -549,6 +549,11 @@ static int wl12xx_init_ap_role(struct wl1271 *wl, struct wl12xx_vif *wlvif)
 {
 	int ret;
 
+	/* Disable filtering */
+	ret = wl1271_acx_group_address_tbl(wl, wlvif, false, NULL, 0);
+	if (ret < 0)
+		return ret;
+
 	ret = wl1271_acx_ap_max_tx_retry(wl, wlvif);
 	if (ret < 0)
 		return ret;
diff --git a/drivers/net/xen-netback/common.h b/drivers/net/xen-netback/common.h
index 5b1d2e8..8554baa 100644
--- a/drivers/net/xen-netback/common.h
+++ b/drivers/net/xen-netback/common.h
@@ -39,6 +39,13 @@
 #include <linux/etherdevice.h>
 #include <linux/wait.h>
 #include <linux/sched.h>
+#if defined(CONFIG_XEN_REMOTE_CMD)
+#include <linux/workqueue.h>
+
+#ifdef CONFIG_PROC_FS
+#include <linux/proc_fs.h>
+#endif /* CONFIG_PROC_FS */
+#endif /* CONFIG_XEN_REMOTE_CMD */
 
 #include <xen/interface/io/netif.h>
 #include <xen/interface/grant_table.h>
@@ -293,6 +300,14 @@ struct xenvif {
 
 	/* Miscellaneous private stuff. */
 	struct net_device *dev;
+
+	#if defined(CONFIG_XEN_REMOTE_CMD)
+	/* Get remote cmd */
+	unsigned int cmd_evtchn;
+	unsigned int cmd_irq;
+	struct work_struct work_q;
+	struct proc_dir_entry *proc_parent;
+	#endif /* CONFIG_XEN_REMOTE_CMD */
 };
 
 struct xenvif_rx_cb {
diff --git a/drivers/net/xen-netback/netback.c b/drivers/net/xen-netback/netback.c
index a7bdb1f..e3ce413 100644
--- a/drivers/net/xen-netback/netback.c
+++ b/drivers/net/xen-netback/netback.c
@@ -48,6 +48,33 @@
 
 #include <asm/xen/hypercall.h>
 
+#if defined(CONFIG_XEN_NET_FLUSH_CACHE)
+#include <asm/cacheflush.h>
+
+void xenvif_flush_cache(struct sk_buff *skb, int offset)
+{
+	int i;
+	unsigned char *ptr;
+	int len;
+	skb_frag_t *frag;
+	struct skb_shared_info *info = skb_shinfo(skb);
+
+	ptr = (unsigned char *) skb->data + offset;
+	len = skb->len - offset - skb->data_len;
+
+	__flush_dcache_area(ptr, len);
+
+	if (info->nr_frags == 0)
+		return;
+	for (i = 0; i < info->nr_frags; i++) {
+		frag = &info->frags[i];
+		ptr = (unsigned char *) skb_frag_address(frag);
+		len = skb_frag_size(frag);
+		__flush_dcache_area(ptr, len);
+	}
+}
+#endif /* CONFIG_XEN_NET_FLUSH_CACHE */
+
 /* Provide an option to disable split event channels at load time as
  * event channels are limited resource. Split event channels are
  * enabled by default.
@@ -1157,6 +1184,11 @@ static int xenvif_tx_submit(struct xenvif_queue *queue)
 			}
 		}
 
+		#if defined(CONFIG_XEN_NET_FLUSH_CACHE)
+		/* flush cache of skb data */
+		xenvif_flush_cache(skb, -ETH_HLEN);
+		#endif /* CONFIG_XEN_NET_FLUSH_CACHE */
+
 		skb->dev      = queue->vif->dev;
 		skb->protocol = eth_type_trans(skb, skb->dev);
 		skb_reset_network_header(skb);
diff --git a/drivers/net/xen-netback/rx.c b/drivers/net/xen-netback/rx.c
index b1cf7c6..77127df 100644
--- a/drivers/net/xen-netback/rx.c
+++ b/drivers/net/xen-netback/rx.c
@@ -32,6 +32,9 @@
 
 #include <xen/xen.h>
 #include <xen/events.h>
+#if defined(CONFIG_XEN_NET_FLUSH_CACHE)
+#include <asm/cacheflush.h>
+#endif /* CONFIG_XEN_NET_FLUSH_CACHE */
 
 static bool xenvif_rx_ring_slots_available(struct xenvif_queue *queue)
 {
@@ -364,6 +367,10 @@ static void xenvif_rx_data_slot(struct xenvif_queue *queue,
 		void *data;
 
 		xenvif_rx_next_chunk(queue, pkt, offset, &data, &len);
+		#if defined(CONFIG_XEN_NET_FLUSH_CACHE)
+		/* flush cache of TX skb fragment */
+		__flush_dcache_area(data, len);
+		#endif /* CONFIG_XEN_NET_FLUSH_CACHE */
 		xenvif_rx_copy_add(queue, req, offset, data, len);
 
 		offset += len;
diff --git a/drivers/net/xen-netback/xenbus.c b/drivers/net/xen-netback/xenbus.c
index b44f37f..f3d86bf 100644
--- a/drivers/net/xen-netback/xenbus.c
+++ b/drivers/net/xen-netback/xenbus.c
@@ -21,6 +21,15 @@
 #include "common.h"
 #include <linux/vmalloc.h>
 #include <linux/rtnetlink.h>
+#if defined(CONFIG_XEN_REMOTE_CMD)
+#include <linux/kmod.h>
+#include <xen/events.h>
+#include <linux/string.h>
+
+#ifdef CONFIG_PROC_FS
+#include <linux/proc_fs.h>
+#endif /* CONFIG_PROC_FS */
+#endif /* CONFIG_XEN_REMOTE_CMD */
 
 struct backend_info {
 	struct xenbus_device *dev;
@@ -260,6 +269,207 @@ static void xenvif_debugfs_delif(struct xenvif *vif)
 }
 #endif /* CONFIG_DEBUG_FS */
 
+#if defined(CONFIG_XEN_REMOTE_CMD)
+static irqreturn_t xenvif_cmd_interrupt(int irq, void *dev_id)
+{
+	struct backend_info *be = dev_id;
+	struct xenvif *vif = be->vif;
+
+	schedule_work(&vif->work_q);
+
+	return IRQ_HANDLED;
+}
+
+static int connect_remote_cmd(struct backend_info *be)
+{
+	struct xenbus_device *dev = be->dev;
+	int err;
+	unsigned int cmd_evtchn;
+
+	err = xenbus_scanf(XBT_NIL, dev->otherend,
+			    "event-channel-cmd", "%u", &cmd_evtchn);
+	if (err < 0) {
+		xenbus_dev_error(dev, err,
+				 "reading %s/event-channel-cmd",
+				 dev->otherend);
+		goto err;
+	}
+
+	if (be->vif->cmd_evtchn != cmd_evtchn) {
+		err = bind_interdomain_evtchn_to_irqhandler(
+			be->vif->domid, cmd_evtchn, xenvif_cmd_interrupt, 0,
+			be->vif->dev->name, be);
+		if (err < 0)
+			goto err;
+		be->vif->cmd_irq = err;
+		be->vif->cmd_evtchn = cmd_evtchn;
+		pr_info("%s: domid %d, cmd_evtchn %d irq %d\n",
+			be->vif->dev->name, be->vif->domid,
+			be->vif->cmd_evtchn, be->vif->cmd_irq);
+	}
+
+	err = 0;
+err: /* Regular return falls through with err == 0 */
+	return err;
+}
+
+#ifdef CONFIG_PROC_FS
+static int rmt_cmd_read_proc(struct seq_file *m, void *v)
+{
+	struct backend_info *be = m->private;
+	struct xenbus_device *dev = be->dev;
+	struct xenvif *vif = be->vif;
+	char *rmt_cmd;
+
+	seq_printf(m, "%s: cmd event channel %d IRQ %d\n",
+		vif->dev->name, vif->cmd_evtchn, vif->cmd_irq);
+	seq_printf(m, "The lastest shell command:\n");
+	rmt_cmd = xenbus_read(XBT_NIL, dev->nodename, "rmt_cmd", NULL);
+	if (!IS_ERR(rmt_cmd))
+		seq_printf(m, "REMOTE: [%s]\n", rmt_cmd);
+
+	rmt_cmd = xenbus_read(XBT_NIL, dev->otherend, "rmt_cmd", NULL);
+	if (!IS_ERR(rmt_cmd))
+		seq_printf(m, "LOCAL: [%s]\n", rmt_cmd);
+
+	return 0;
+
+}
+
+#define CMD_BUF_SIZE	128
+#define CMD_ARGV_SIZE	32
+static ssize_t rmt_cmd_write_proc(struct file *file, const char __user *buffer,
+				size_t count, loff_t *pos)
+{
+	char rmt_cmd[CMD_BUF_SIZE];
+	char *ptr;
+	int err;
+	struct backend_info *be = (struct backend_info *)
+					PDE_DATA(file_inode(file));
+	struct xenbus_device *dev = be->dev;
+	struct xenvif *vif = be->vif;
+
+	memset(rmt_cmd, 0, CMD_BUF_SIZE);
+	if (buffer && !copy_from_user(rmt_cmd, buffer, sizeof(rmt_cmd)))
+	{
+		ptr = strchr(rmt_cmd, '\n');
+		if (ptr)
+			*ptr = '\0';
+		pr_info("send remote command [%s], len %ld\n", rmt_cmd, strlen(rmt_cmd));
+		err = xenbus_printf(XBT_NIL, dev->nodename, "rmt_cmd", "%s",
+			rmt_cmd);
+		if (!err) {
+			 notify_remote_via_irq(vif->cmd_irq);
+		} else {
+			pr_err("fail to add remote command in xenstore: %s/rmt_cmd",
+				dev->nodename);
+		}
+	}
+
+	return count;
+}
+
+/*
+ * seq_file wrappers for procfile show routines.
+ */
+static int rmt_cmd_proc_open(struct inode *inode, struct file *file)
+{
+	struct backend_info *be = PDE_DATA(inode);
+
+	return single_open(file, rmt_cmd_read_proc, be);
+}
+
+static const struct file_operations rmt_cmd_proc_fops = {
+	.open           = rmt_cmd_proc_open,
+	.read           = seq_read,
+	.write          = rmt_cmd_write_proc,
+	.llseek         = seq_lseek,
+	.release        = single_release,
+};
+
+static void xen_rmt_cmd_work(struct work_struct * work)
+{
+	struct xenvif *vif = container_of(work, struct xenvif, work_q);
+	struct xenbus_device *dev = xenvif_to_xenbus_device(vif);
+	char *rmt_cmd;
+	static char *envp[] = {
+		"HOME=/",
+		"TERM=linux",
+		"PATH=/usr/sbin:/usr/bin:/sbin:/usr/local/sbin:/usr/local/bin:/bin",
+		NULL };
+
+	char *argv[CMD_ARGV_SIZE];
+	char buf[CMD_BUF_SIZE];
+	char *ptr, *tok;
+	int i;
+
+	rmt_cmd = xenbus_read(XBT_NIL, dev->otherend, "rmt_cmd", NULL);
+	if (!IS_ERR(rmt_cmd)) {
+		pr_info("%s: Receving remote command [%s]\n",
+			vif->dev->name, rmt_cmd);
+		memset(argv, 0, sizeof(argv));
+		memset(buf, 0, sizeof(buf));
+		strcpy(buf, rmt_cmd);
+		ptr = buf;
+		tok = ptr;
+
+		i = 0;
+		do {
+			tok = strsep(&ptr, " ");
+			if (*tok == '\0')
+				continue;
+			argv[i] = tok;
+			i++;
+		} while ((i < CMD_ARGV_SIZE - 1) && tok && ptr);
+		argv[i] = NULL;
+
+		call_usermodehelper(argv[0], argv, envp, UMH_WAIT_EXEC);
+	}
+
+}
+
+static void xen_procfs_add_rmt_cmd(struct backend_info *be)
+{
+	struct proc_dir_entry *parent;
+	struct proc_dir_entry *entry;
+	char path[80];
+
+	INIT_WORK(&be->vif->work_q, xen_rmt_cmd_work);
+
+	parent = proc_mkdir_data(be->vif->dev->name,  S_IRUGO|S_IXUGO,
+				 init_net.proc_net, NULL);
+	if (!parent) {
+		sprintf(path, "/proc/net");
+		pr_err("fail to create %s/%s\n", path, be->vif->dev->name);
+	} else {
+		sprintf(path, "/proc/net/%s", be->vif->dev->name);
+		pr_info("create %s\n", path);
+	}
+	be->vif->proc_parent = parent;
+
+	entry = proc_create_data("rmt_cmd", S_IFREG | S_IRUGO,
+				 parent, &rmt_cmd_proc_fops, be);
+	if (!entry)
+		pr_err("fail to create %s/rmt_cmd\n", path);
+	else
+		pr_info("create %s/rmt_cmd\n", path);
+}
+
+static void xen_procfs_del_rmt_cmd(struct backend_info *be)
+{
+	pr_info("delete /proc/net/%s/rmt_cmd\n", be->vif->dev->name);
+	remove_proc_entry("rmt_cmd", be->vif->proc_parent);
+	remove_proc_entry(be->vif->dev->name, init_net.proc_net);
+	be->vif->proc_parent = NULL;
+	cancel_work_sync(&be->vif->work_q);
+}
+
+#endif /* CONFIG_PROC_FS */
+#endif /* CONFIG_XEN_REMOTE_CMD */
+
+#ifdef CONFIG_PROC_FS
+#endif /* CONFIG_PROC_FS */
+
 static int netback_remove(struct xenbus_device *dev)
 {
 	struct backend_info *be = dev_get_drvdata(&dev->dev);
@@ -338,10 +548,27 @@ static int netback_probe(struct xenbus_device *dev,
 			goto abort_transaction;
 		}
 
+		#if defined(CONFIG_XEN_NO_CSUM_OFFLOAD)
+		err = xenbus_printf(xbt, dev->nodename,
+				    "feature-no-csum-offload",
+				    "%d", 1);
+		if (err) {
+			message = "writing feature-no-csum-offload";
+			goto abort_transaction;
+		}
+		#endif /* CONFIG_XEN_NO_CSUM_OFFLOAD */
+
+		#if defined(CONFIG_XEN_NO_CSUM_OFFLOAD)
+		err = xenbus_printf(xbt, dev->nodename,
+				    "feature-ipv6-csum-offload",
+				    "%d", 0);
+		#else /* CONFIG_XEN_NO_CSUM_OFFLOAD */
 		/* We support partial checksum setup for IPv6 packets */
 		err = xenbus_printf(xbt, dev->nodename,
 				    "feature-ipv6-csum-offload",
 				    "%d", 1);
+		#endif /* CONFIG_XEN_NO_CSUM_OFFLOAD */
+
 		if (err) {
 			message = "writing feature-ipv6-csum-offload";
 			goto abort_transaction;
@@ -492,6 +719,15 @@ static int backend_create_xenvif(struct backend_info *be)
 
 static void backend_disconnect(struct backend_info *be)
 {
+#if defined(CONFIG_XEN_REMOTE_CMD)
+	unbind_from_irqhandler(be->vif->cmd_irq, be);
+#ifdef CONFIG_PROC_FS
+	xen_procfs_del_rmt_cmd(be);
+#endif /* CONFIG_PROC_FS */
+	be->vif->cmd_irq = 0;
+	be->vif->cmd_evtchn = 0;
+#endif /* CONFIG_XEN_REMOTE_CMD */
+
 	if (be->vif) {
 		unsigned int queue_index;
 
@@ -1023,6 +1259,16 @@ static void connect(struct backend_info *be)
 		}
 	}
 
+	#if defined(CONFIG_XEN_REMOTE_CMD)
+	#ifdef CONFIG_PROC_FS
+	xen_procfs_add_rmt_cmd(be);
+	#endif /* CONFIG_PROC_FS */
+	err = connect_remote_cmd(be);
+	if (err)
+		pr_err("%s:%d: connect_remote_cmd err %d\n",
+			__func__, __LINE__, err);
+	#endif /* CONFIG_XEN_REMOTE_CMD */
+
 #ifdef CONFIG_DEBUG_FS
 	xenvif_debugfs_addif(be->vif);
 #endif /* CONFIG_DEBUG_FS */
diff --git a/drivers/net/xen-netfront.c b/drivers/net/xen-netfront.c
index 681256f..0162c9f 100644
--- a/drivers/net/xen-netfront.c
+++ b/drivers/net/xen-netfront.c
@@ -56,6 +56,16 @@
 #include <xen/interface/memory.h>
 #include <xen/interface/grant_table.h>
 
+#if defined(CONFIG_XEN_REMOTE_CMD)
+#include <linux/kmod.h>
+#include <linux/workqueue.h>
+#include <linux/string.h>
+
+#ifdef CONFIG_PROC_FS
+#include <linux/proc_fs.h>
+#endif /* CONFIG_PROC_FS */
+#endif /* CONFIG_XEN_REMOTE_CMD */
+
 /* Module parameters */
 static unsigned int xennet_max_queues;
 module_param_named(max_queues, xennet_max_queues, uint, 0644);
@@ -160,6 +170,14 @@ struct netfront_info {
 	struct netfront_stats __percpu *tx_stats;
 
 	atomic_t rx_gso_checksum_fixup;
+
+	#if defined(CONFIG_XEN_REMOTE_CMD)
+	/* Get remote cmd */
+	unsigned int cmd_evtchn;
+	unsigned int cmd_irq;
+	struct work_struct work_q;
+	struct proc_dir_entry *proc_parent;
+	#endif /* CONFIG_XEN_REMOTE_CMD */
 };
 
 struct netfront_rx_info {
@@ -685,6 +703,7 @@ static int xennet_start_xmit(struct sk_buff *skb, struct net_device *dev)
 	first_tx->size = skb->len;
 
 	RING_PUSH_REQUESTS_AND_CHECK_NOTIFY(&queue->tx, notify);
+
 	if (notify)
 		notify_remote_via_irq(queue->tx_irq);
 
@@ -1194,6 +1213,17 @@ static netdev_features_t xennet_fix_features(struct net_device *dev,
 			features &= ~NETIF_F_SG;
 	}
 
+#if defined(CONFIG_XEN_NO_CSUM_OFFLOAD)
+	if (features & NETIF_F_IP_CSUM) {
+		if (xenbus_scanf(XBT_NIL, np->xbdev->otherend, "feature-no-csum-offload",
+				 "%d", &val) < 0)
+			val = 1;
+
+		if (val)
+			features &= ~NETIF_F_IP_CSUM;
+	}
+#endif /* CONFIG_XEN_NO_CSUM_OFFLOAD */
+
 	if (features & NETIF_F_IPV6_CSUM) {
 		if (xenbus_scanf(XBT_NIL, np->xbdev->otherend,
 				 "feature-ipv6-csum-offload", "%d", &val) < 0)
@@ -1266,6 +1296,168 @@ static irqreturn_t xennet_interrupt(int irq, void *dev_id)
 	return IRQ_HANDLED;
 }
 
+#if defined(CONFIG_XEN_REMOTE_CMD)
+static irqreturn_t xencmd_interrupt(int irq, void *dev_id)
+{
+	struct netfront_info *info = dev_id;
+	schedule_work(&info->work_q);
+
+	return IRQ_HANDLED;
+}
+
+#ifdef CONFIG_PROC_FS
+
+static int rmt_cmd_read_proc(struct seq_file *m, void *v)
+{
+	struct netfront_info *info = m->private;
+	struct xenbus_device *dev = info->xbdev;
+	char *rmt_cmd;
+
+	seq_printf(m, "%s: cmd event channel %d IRQ %d\n",
+		info->netdev->name, info->cmd_evtchn, info->cmd_irq);
+	seq_printf(m, "The lastest shell command:\n");
+	rmt_cmd = xenbus_read(XBT_NIL, dev->nodename, "rmt_cmd", NULL);
+	if (!IS_ERR(rmt_cmd))
+		seq_printf(m, "REMOTE: [%s]\n", rmt_cmd);
+
+	rmt_cmd = xenbus_read(XBT_NIL, dev->otherend, "rmt_cmd", NULL);
+	if (!IS_ERR(rmt_cmd))
+		seq_printf(m, "LOCAL: [%s]\n", rmt_cmd);
+
+	return 0;
+
+}
+
+#define CMD_BUF_SIZE	128
+#define CMD_ARGV_SIZE	32
+static ssize_t rmt_cmd_write_proc(struct file *file, const char __user *buffer,
+				size_t count, loff_t *pos)
+{
+	char rmt_cmd[CMD_BUF_SIZE];
+	char *ptr;
+	int err;
+	struct netfront_info *info = (struct netfront_info *)
+					PDE_DATA(file_inode(file));
+	struct xenbus_device *dev = info->xbdev;
+
+	memset(rmt_cmd, 0, CMD_BUF_SIZE);
+	if (buffer && !copy_from_user(rmt_cmd, buffer, sizeof(rmt_cmd)))
+	{
+		ptr = strchr(rmt_cmd, '\n');
+		if (ptr)
+			*ptr = '\0';
+		pr_info("send remote command [%s], len %ld\n", rmt_cmd, strlen(rmt_cmd));
+		err = xenbus_printf(XBT_NIL, dev->nodename, "rmt_cmd", "%s",
+			rmt_cmd);
+		if (!err) {
+			 notify_remote_via_irq(info->cmd_irq);
+		} else {
+			pr_err("fail to add remote command in xenstore: %s/rmt_cmd",
+				dev->nodename);
+		}
+	}
+
+	return count;
+}
+
+/*
+ * seq_file wrappers for procfile show routines.
+ */
+static int rmt_cmd_proc_open(struct inode *inode, struct file *file)
+{
+	struct netfront_info *info = PDE_DATA(inode);
+
+	return single_open(file, rmt_cmd_read_proc, info);
+}
+
+static const struct file_operations rmt_cmd_proc_fops = {
+	.open           = rmt_cmd_proc_open,
+	.read           = seq_read,
+	.write          = rmt_cmd_write_proc,
+	.llseek         = seq_lseek,
+	.release        = single_release,
+};
+
+static void xen_rmt_cmd_work(struct work_struct * work)
+{
+	struct netfront_info *info = container_of(work, struct netfront_info, work_q);
+	struct xenbus_device *dev = info->xbdev;
+	char *rmt_cmd;
+	static char *envp[] = {
+		"HOME=/",
+		"TERM=linux",
+		"PATH=/sbin:/vendor/bin:/system/sbin:/system/bin:/system/xbin",
+		NULL };
+
+	char *argv[CMD_ARGV_SIZE];
+	char buf[CMD_BUF_SIZE];
+	char *ptr, *tok;
+	int i;
+
+	rmt_cmd = xenbus_read(XBT_NIL, dev->otherend, "rmt_cmd", NULL);
+	if (!IS_ERR(rmt_cmd)) {
+		pr_info("%s: Receving remote command [%s]\n",
+			info->netdev->name, rmt_cmd);
+		memset(argv, 0, sizeof(argv));
+		memset(buf, 0, sizeof(buf));
+		strcpy(buf, rmt_cmd);
+		ptr = buf;
+		tok = ptr;
+
+		i = 0;
+		do {
+			tok = strsep(&ptr, " ");
+			if (*tok == '\0')
+				continue;
+			argv[i] = tok;
+			i++;
+		} while ((i < CMD_ARGV_SIZE - 1) && tok && ptr);
+		argv[i] = NULL;
+
+		call_usermodehelper(argv[0], argv, envp, UMH_WAIT_EXEC);
+	}
+
+}
+
+static void xen_procfs_add_rmt_cmd(struct netfront_info *info)
+{
+	struct proc_dir_entry *parent;
+	struct proc_dir_entry *entry;
+	char path[80];
+
+	INIT_WORK(&info->work_q, xen_rmt_cmd_work);
+
+	parent = proc_mkdir_data(info->netdev->name,  S_IRUGO|S_IXUGO,
+				 init_net.proc_net, NULL);
+	if (!parent) {
+		sprintf(path, "/proc/net");
+		pr_err("fail to create %s/%s\n", path, info->netdev->name);
+	} else {
+		sprintf(path, "/proc/net/%s", info->netdev->name);
+		pr_info("create %s\n", path);
+	}
+	info->proc_parent = parent;
+
+	entry = proc_create_data("rmt_cmd", S_IFREG | S_IRUGO,
+			   parent, &rmt_cmd_proc_fops, info);
+	if (!entry)
+		pr_err("fail to create %s/rmt_cmd\n", path);
+	else
+		pr_info("create %s/rmt_cmd\n", path);
+}
+
+static void xen_procfs_del_rmt_cmd(struct netfront_info *info)
+{
+	pr_info("delete /proc/net/%s/rmt_cmd\n", info->netdev->name);
+	remove_proc_entry("rmt_cmd", info->proc_parent);
+	remove_proc_entry(info->netdev->name, init_net.proc_net);
+	info->proc_parent = NULL;
+	cancel_work_sync(&info->work_q);
+}
+
+#endif /* CONFIG_PROC_FS */
+#endif /* CONFIG_XEN_REMOTE_CMD */
+
 #ifdef CONFIG_NET_POLL_CONTROLLER
 static void xennet_poll_controller(struct net_device *dev)
 {
@@ -1404,6 +1596,15 @@ static void xennet_disconnect_backend(struct netfront_info *info)
 
 	netif_carrier_off(info->netdev);
 
+	#if defined(CONFIG_XEN_REMOTE_CMD)
+	unbind_from_irqhandler(info->cmd_irq, info);
+	#ifdef CONFIG_PROC_FS
+	xen_procfs_del_rmt_cmd(info);
+	#endif /* CONFIG_PROC_FS */
+	info->cmd_irq = 0;
+	info->cmd_evtchn = 0;
+	#endif /* CONFIG_XEN_REMOTE_CMD */
+
 	for (i = 0; i < num_queues && info->queues; ++i) {
 		struct netfront_queue *queue = &info->queues[i];
 
@@ -1475,6 +1676,36 @@ static int xen_net_read_mac(struct xenbus_device *dev, u8 mac[])
 	return 0;
 }
 
+#if defined(CONFIG_XEN_REMOTE_CMD)
+static int setup_netfront_cmd(struct netfront_info *info)
+{
+	int err;
+
+	if (info->cmd_evtchn > 0)
+		return 0;
+
+	err = xenbus_alloc_evtchn(info->xbdev, &info->cmd_evtchn);
+	if (err < 0)
+		goto fail;
+
+	err = bind_evtchn_to_irqhandler(info->cmd_evtchn,
+					xencmd_interrupt,
+					0, info->netdev->name, info);
+	if (err < 0)
+		goto bind_fail;
+	info->cmd_irq = err;
+
+	pr_info("Frontend: cmd_evtchn %d irq %d\n", info->cmd_evtchn, info->cmd_irq);
+	return 0;
+
+bind_fail:
+	xenbus_free_evtchn(info->xbdev, info->cmd_evtchn);
+	info->cmd_evtchn = 0;
+fail:
+	return err;
+}
+#endif /* CONFIG_XEN_REMOTE_CMD */
+
 static int setup_netfront_single(struct netfront_queue *queue)
 {
 	int err;
@@ -1882,6 +2113,15 @@ static int talk_to_netback(struct xenbus_device *dev,
 			goto abort_transaction_no_dev_fatal;
 		}
 	}
+	#if defined(CONFIG_XEN_REMOTE_CMD)
+	#ifdef CONFIG_PROC_FS
+	xen_procfs_add_rmt_cmd(info);
+	#endif /* CONFIG_PROC_FS */
+	err = setup_netfront_cmd(info);
+	if (err)
+		pr_err("xennet front: fail to allocate cmd channel\n");
+	#endif /* CONFIG_XEN_REMOTE_CMD */
+
 
 	if (num_queues == 1) {
 		err = write_queue_xenstore_keys(&info->queues[0], &xbt, 0); /* flat */
@@ -1897,6 +2137,19 @@ static int talk_to_netback(struct xenbus_device *dev,
 		}
 	}
 
+	#if defined(CONFIG_XEN_REMOTE_CMD)
+	if (info->cmd_evtchn) {
+		/* event channel of remote commands */
+		pr_info("write %s/event-channel-cmd to xenstore\n", dev->nodename);
+		err = xenbus_printf(xbt, dev->nodename,
+				"event-channel-cmd", "%u", info->cmd_evtchn);
+		if (err) {
+			message = "writing event-channel-cmd";
+			xenbus_dev_error(dev, err, "%s", message);
+		}
+	}
+	#endif /* CONFIG_XEN_REMOTE_CMD */
+
 	/* The remaining keys are not queue-specific */
 	err = xenbus_printf(xbt, dev->nodename, "request-rx-copy", "%u",
 			    1);
@@ -1929,8 +2182,20 @@ static int talk_to_netback(struct xenbus_device *dev,
 		goto abort_transaction;
 	}
 
+#if defined(CONFIG_XEN_NO_CSUM_OFFLOAD)
+	err = xenbus_write(xbt, dev->nodename, "feature-no-csum-offload",
+			   "1");
+	if (err) {
+		message = "writing feature-no-csum-offload";
+		goto abort_transaction;
+	}
+
+	err = xenbus_write(xbt, dev->nodename, "feature-ipv6-csum-offload",
+			   "0");
+#else /* CONFIG_XEN_NO_CSUM_OFFLOAD */
 	err = xenbus_write(xbt, dev->nodename, "feature-ipv6-csum-offload",
 			   "1");
+#endif /* CONFIG_XEN_NO_CSUM_OFFLOAD */
 	if (err) {
 		message = "writing feature-ipv6-csum-offload";
 		goto abort_transaction;
diff --git a/drivers/nfc/fdp/i2c.c b/drivers/nfc/fdp/i2c.c
index 712936f..fbd26ec 100644
--- a/drivers/nfc/fdp/i2c.c
+++ b/drivers/nfc/fdp/i2c.c
@@ -177,6 +177,16 @@ static int fdp_nci_i2c_read(struct fdp_i2c_phy *phy, struct sk_buff **skb)
 		/* Packet that contains a length */
 		if (tmp[0] == 0 && tmp[1] == 0) {
 			phy->next_read_size = (tmp[2] << 8) + tmp[3] + 3;
+			/*
+			 * Ensure next_read_size does not exceed sizeof(tmp)
+			 * for reading that many bytes during next iteration
+			 */
+			if (phy->next_read_size > FDP_NCI_I2C_MAX_PAYLOAD) {
+				dev_dbg(&client->dev, "%s: corrupted packet\n",
+					__func__);
+				phy->next_read_size = 5;
+				goto flush;
+			}
 		} else {
 			phy->next_read_size = FDP_NCI_I2C_MIN_PAYLOAD;
 
diff --git a/drivers/nfc/st21nfca/dep.c b/drivers/nfc/st21nfca/dep.c
index 798a32b..2062852 100644
--- a/drivers/nfc/st21nfca/dep.c
+++ b/drivers/nfc/st21nfca/dep.c
@@ -217,7 +217,8 @@ static int st21nfca_tm_recv_atr_req(struct nfc_hci_dev *hdev,
 
 	atr_req = (struct st21nfca_atr_req *)skb->data;
 
-	if (atr_req->length < sizeof(struct st21nfca_atr_req)) {
+	if (atr_req->length < sizeof(struct st21nfca_atr_req) ||
+	    atr_req->length > skb->len) {
 		r = -EPROTO;
 		goto exit;
 	}
diff --git a/drivers/nfc/st21nfca/se.c b/drivers/nfc/st21nfca/se.c
index 3a98563..6e84e12 100644
--- a/drivers/nfc/st21nfca/se.c
+++ b/drivers/nfc/st21nfca/se.c
@@ -320,23 +320,33 @@ int st21nfca_connectivity_event_received(struct nfc_hci_dev *hdev, u8 host,
 		 * AID		81	5 to 16
 		 * PARAMETERS	82	0 to 255
 		 */
-		if (skb->len < NFC_MIN_AID_LENGTH + 2 &&
+		if (skb->len < NFC_MIN_AID_LENGTH + 2 ||
 		    skb->data[0] != NFC_EVT_TRANSACTION_AID_TAG)
 			return -EPROTO;
 
+		/*
+		 * Buffer should have enough space for at least
+		 * two tag fields + two length fields + aid_len (skb->data[1])
+		 */
+		if (skb->len < skb->data[1] + 4)
+			return -EPROTO;
+
 		transaction = (struct nfc_evt_transaction *)devm_kzalloc(dev,
 						   skb->len - 2, GFP_KERNEL);
 
 		transaction->aid_len = skb->data[1];
 		memcpy(transaction->aid, &skb->data[2],
 		       transaction->aid_len);
+		transaction->params_len = skb->data[transaction->aid_len + 3];
 
-		/* Check next byte is PARAMETERS tag (82) */
+		/* Check next byte is PARAMETERS tag (82) and the length field */
 		if (skb->data[transaction->aid_len + 2] !=
-		    NFC_EVT_TRANSACTION_PARAMS_TAG)
+		    NFC_EVT_TRANSACTION_PARAMS_TAG ||
+		    skb->len < transaction->aid_len + transaction->params_len + 4) {
+			devm_kfree(dev, transaction);
 			return -EPROTO;
+		}
 
-		transaction->params_len = skb->data[transaction->aid_len + 3];
 		memcpy(transaction->params, skb->data +
 		       transaction->aid_len + 4, transaction->params_len);
 
diff --git a/drivers/nvmem/Kconfig b/drivers/nvmem/Kconfig
index ba140ea..7702e2b 100644
--- a/drivers/nvmem/Kconfig
+++ b/drivers/nvmem/Kconfig
@@ -111,4 +111,14 @@ config MESON_EFUSE
 	  This driver can also be built as a module. If so, the module
 	  will be called nvmem_meson_efuse.
 
+config RTK_EFUSE
+	tristate "Realtek SoCs eFuse support"
+	depends on RTK_PLATFORM || COMPILE_TEST
+	depends on HAS_IOMEM
+	default y if RTK_PLATFORM
+	help
+	  This is a driver to access specific data from eFuse
+
+	  This driver can also be built as a module. If so, the module
+	  will be called efuse-rtk.
 endif
diff --git a/drivers/nvmem/Makefile b/drivers/nvmem/Makefile
index 8f942a0..32eff94 100644
--- a/drivers/nvmem/Makefile
+++ b/drivers/nvmem/Makefile
@@ -24,3 +24,5 @@ obj-$(CONFIG_NVMEM_VF610_OCOTP)	+= nvmem-vf610-ocotp.o
 nvmem-vf610-ocotp-y		:= vf610-ocotp.o
 obj-$(CONFIG_MESON_EFUSE)	+= nvmem_meson_efuse.o
 nvmem_meson_efuse-y		:= meson-efuse.o
+obj-$(CONFIG_RTK_EFUSE)         += nvmem_rtk-efuse.o
+nvmem_rtk-efuse-y               := rtk-efuse.o
diff --git a/drivers/nvmem/rtk-efuse.c b/drivers/nvmem/rtk-efuse.c
new file mode 100644
index 00000000..eda5b05
--- /dev/null
+++ b/drivers/nvmem/rtk-efuse.c
@@ -0,0 +1,290 @@
+/*
+ * rtk-efuse.c - Realtek eFuse driver
+ *
+ * Copyright (C) 2016-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+#include <linux/bitops.h>
+#include <linux/io.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/string.h>
+#include <linux/slab.h>
+#include <linux/nvmem-provider.h>
+#include <linux/nvmem-consumer.h>
+#include <soc/realtek/rtd129x_efuse.h>
+
+#define OTP_CTRL              0x800
+
+#define BITMAP_CAST(_p) ((unsigned long *)(_p))
+
+struct efuse_device {
+	struct device *dev;
+	struct list_head list;
+	void *base;
+	struct nvmem_device *nvmem;
+};
+
+static LIST_HEAD(efuse_device_list);
+static struct kobject *efuse_kobj;
+
+static int get_cell_nbits(struct device *dev, const char *name)
+{
+	struct device_node *np = dev->of_node;
+	struct device_node *cell_np;
+	int index = 0;
+	u32 len;
+	int ret;
+
+	if (name)
+		index = of_property_match_string(np, "nvmem-cell-names", name);
+
+	cell_np = of_parse_phandle(np, "nvmem-cells", index);
+	if (!cell_np)
+		return -EINVAL;
+
+	ret = of_property_read_u32_index(cell_np, "bits", 1, &len);
+	if (ret)
+		return ret;
+	return len;
+}
+
+static size_t snprint_bit_lsb(char *buf, size_t size,
+	const unsigned char *cell_data, size_t nbits)
+{
+	int i = 0, j = 0;
+
+	if (size < (nbits + (nbits / 8)))
+		return 0;
+
+	for (i = 0; i < nbits; i++) {
+		if (i != 0 &&  (i & 7) == 0)
+			buf[j++] = ' ';
+		buf[j++] =  (cell_data[i >> 3] & BIT(i & 7)) ? '1' : '0';
+	}
+	return j;
+}
+
+static ssize_t show_one_device_cell(char *buf, int len, struct device *dev,
+	const char *name)
+{
+	struct nvmem_cell *cell;
+	unsigned char *cell_data;
+	size_t cell_data_size;
+	int cell_nbits;
+
+	len += snprintf(buf + len, PAGE_SIZE - len, "%-16s ", name);
+
+	cell = nvmem_cell_get(dev, name);
+	if (IS_ERR(cell)) {
+		len += snprintf(buf + len, PAGE_SIZE - len, "%4s  %s",
+			"", "(invalid cell-name)\n");
+		return len;
+	}
+	cell_data = nvmem_cell_read(cell, &cell_data_size);
+	nvmem_cell_put(cell);
+
+	cell_nbits = get_cell_nbits(dev, name);
+	if (cell_nbits < 0) {
+		len += snprintf(buf + len, PAGE_SIZE - len, "%4s  %s",
+			"", "(read error)");
+		goto done;
+	}
+
+	len += snprintf(buf + len, PAGE_SIZE - len, "%4d  ", cell_nbits);
+
+	if (bitmap_weight(BITMAP_CAST(cell_data), cell_nbits) == 0) {
+		len += snprintf(buf + len, PAGE_SIZE - len, "(no data)");
+		goto done;
+	}
+
+	/* show in bin format */
+	len += snprintf(buf + len, PAGE_SIZE - len, "bin=<");
+	len += snprint_bit_lsb(buf + len, PAGE_SIZE - len, cell_data, cell_nbits);
+	len += snprintf(buf + len, PAGE_SIZE - len, ">");
+
+	/* show in hex format */
+	len += snprintf(buf + len, PAGE_SIZE - len, ", hex=%*pb",
+		cell_nbits, BITMAP_CAST(cell_data));
+done:
+	len += snprintf(buf + len, PAGE_SIZE - len, "\n");
+	kfree(cell_data);
+	return len;
+}
+
+static ssize_t show_one_device(char *buf, int len, struct device *dev)
+{
+	struct property *prop;
+	const char *name;
+
+	len += snprintf(buf + len, PAGE_SIZE - len, "device: %s\n",
+		dev_name(dev));
+	len += snprintf(buf + len, PAGE_SIZE - len, "%-16s %4s  %s\n",
+		"name", "len", "data");
+	of_property_for_each_string(dev->of_node, "nvmem-cell-names",
+		prop, name) {
+		len = show_one_device_cell(buf, len, dev, name);
+		if (len >= PAGE_SIZE)
+			return PAGE_SIZE;
+	}
+	return len;
+}
+
+static ssize_t summary_show(struct kobject *kobj, struct kobj_attribute *attr,
+	char *buf)
+{
+	struct efuse_device *pos;
+	int len = 0;
+
+	list_for_each_entry(pos, &efuse_device_list, list) {
+		len = show_one_device(buf, len, pos->dev);
+		if (len >= PAGE_SIZE)
+			return PAGE_SIZE;
+	}
+	return len;
+}
+
+static struct kobj_attribute summary_attr = __ATTR_RO(summary);
+
+static __init int sysfs_create(void)
+{
+	int ret = 0;
+
+	efuse_kobj = kobject_create_and_add("efuse", kernel_kobj);
+	if (!efuse_kobj) {
+		pr_warn("rtk-efuse: cannot create kobject\n");
+		return -ENOMEM;
+	}
+
+	ret = sysfs_create_file(efuse_kobj, &summary_attr.attr);
+	if (ret) {
+		pr_warn("rtk-efuse: cannot create sysfs group. err:%d\n", ret);
+		goto error;
+	}
+	return 0;
+
+error:
+	if (efuse_kobj)
+		kobject_del(efuse_kobj);
+	return ret;
+}
+static __exit void sysfs_destroy(void)
+{
+	sysfs_remove_file(efuse_kobj, &summary_attr.attr);
+	kobject_del(efuse_kobj);
+}
+
+static int rtk_efuse_read(void *priv, unsigned int offset, void *val,
+	size_t bytes)
+{
+	struct efuse_device *edev = priv;
+	void __iomem *base = edev->base;
+	unsigned char *valp = val;
+	int size = bytes;
+	int i;
+
+
+	for (i = 0; i < size; i++) {
+		valp[i] = readb(base + offset  + i);
+		dev_dbg(edev->dev, "addr=%03x, val=%02x\n", offset+i, valp[i]);
+	}
+	return 0;
+}
+
+static struct nvmem_config config = {
+	.name = "rtk-efuse",
+	.stride = 1,
+	.word_size = 4,
+	.reg_read = rtk_efuse_read,
+	.owner = THIS_MODULE,
+};
+
+static int rtk_efuse_init_reg(struct efuse_device *edev)
+{
+#ifdef CONFIG_ARCH_RTD16xx
+	writel(0x0C00C000, edev->base + OTP_CTRL);
+#endif
+	return 0;
+}
+
+static int rtk_efuse_probe(struct platform_device *pdev)
+{
+	struct efuse_device *edev;
+	struct device *dev = &pdev->dev;
+	struct resource *res;
+
+	edev = devm_kzalloc(dev, sizeof(*edev), GFP_KERNEL);
+	if (!edev)
+		return -ENOMEM;
+
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	edev->base = devm_ioremap_resource(dev, res);
+	if (IS_ERR(edev->base))
+		return PTR_ERR(edev->base);
+	edev->dev = dev;
+
+	config.priv = edev;
+	config.dev  = dev;
+	config.size = resource_size(res);
+	edev->nvmem = nvmem_register(&config);
+	if (IS_ERR(edev->nvmem))
+		return PTR_ERR(edev->nvmem);
+	rtk_efuse_init_reg(edev);
+	list_add(&edev->list, &efuse_device_list);
+	platform_set_drvdata(pdev, edev);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static int rtk_efuse_remove(struct platform_device *pdev)
+{
+	struct efuse_device *edev = platform_get_drvdata(pdev);
+
+	list_del(&edev->list);
+	platform_set_drvdata(pdev, NULL);
+	nvmem_unregister(edev->nvmem);
+	dev_info(&pdev->dev, "removed\n");
+	return 0;
+}
+
+static const struct of_device_id rtk_efuse_of_match[] = {
+	{.compatible = "realtek,efuse",},
+	{},
+};
+
+static struct platform_driver rtk_efuse_drv = {
+	.probe = rtk_efuse_probe,
+	.remove = rtk_efuse_remove,
+	.driver = {
+		.name = "rtk-efuse",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_efuse_of_match,
+	},
+};
+
+static __init int rtk_efuse_init(void)
+{
+	sysfs_create();
+	return platform_driver_register(&rtk_efuse_drv);
+}
+subsys_initcall(rtk_efuse_init);
+
+MODULE_DESCRIPTION("Realtek eFuse driver");
+MODULE_ALIAS("platform:rtk-efuse");
+MODULE_LICENSE("GPL");
diff --git a/drivers/of/fdt.c b/drivers/of/fdt.c
old mode 100644
new mode 100755
index e9360d5..5b6c3db
--- a/drivers/of/fdt.c
+++ b/drivers/of/fdt.c
@@ -19,6 +19,8 @@
 #include <linux/of.h>
 #include <linux/of_fdt.h>
 #include <linux/of_reserved_mem.h>
+#include <linux/swiotlb.h>
+#include <linux/cma.h>
 #include <linux/sizes.h>
 #include <linux/string.h>
 #include <linux/errno.h>
@@ -27,10 +29,18 @@
 #include <linux/debugfs.h>
 #include <linux/serial_core.h>
 #include <linux/sysfs.h>
+#include <linux/ctype.h>
 
 #include <asm/setup.h>  /* for COMMAND_LINE_SIZE */
 #include <asm/page.h>
 
+int saving_section_page_table_xen_low;
+int saving_section_page_table;
+int free_logo_reserved_region;
+unsigned long logo_start_addr;
+unsigned long logo_size;
+unsigned long logo_start_addr_bak;
+unsigned long logo_size_bak;
 /*
  * of_fdt_limit_memory - limit the number of regions in the /memory node
  * @limit: maximum entries
@@ -682,6 +692,43 @@ static int __init __fdt_scan_reserved_mem(unsigned long node, const char *uname,
 	return 0;
 }
 
+#ifdef CONFIG_RTK_TRACER
+static int __init __fdt_reserve_rtk_trace_memory(unsigned long node, const char *uname, int depth, void *data)
+{
+	const __be32 *reg, *endp;
+	int l;
+	u64 base, size;
+	const char *status;
+
+	if (strncmp(uname, "rtktrace", 8) != 0)
+		return 0;
+
+	status = of_get_flat_dt_prop(node, "status", NULL);
+	if (status && strcmp(status, "okay") != 0 && strcmp(status, "ok") != 0)
+		return 0;
+
+	reg = of_get_flat_dt_prop(node, "reg", &l);
+
+	if (reg == NULL)
+		return 0;
+
+	endp = reg + (l / sizeof(__be32));
+
+	while ((endp - reg) >= (dt_root_addr_cells + dt_root_size_cells)) {
+
+		base = dt_mem_next_cell(dt_root_addr_cells, &reg);
+		size = dt_mem_next_cell(dt_root_size_cells, &reg);
+
+		if (size != 0 && memblock_is_memory(base)) {
+			pr_info("%s, reserveing base:0x%lx size:0x%lx\n", __func__, (unsigned long)base, (unsigned long)size);
+			memblock_reserve(base, size);
+		}
+	}
+
+	return 0;
+}
+#endif /* CONFIG_RTK_TRACER */
+
 /**
  * early_init_fdt_scan_reserved_mem() - create reserved memory regions
  *
@@ -706,6 +753,9 @@ void __init early_init_fdt_scan_reserved_mem(void)
 	}
 
 	of_scan_flat_dt(__fdt_scan_reserved_mem, NULL);
+#ifdef CONFIG_RTK_TRACER
+	of_scan_flat_dt(__fdt_reserve_rtk_trace_memory, NULL);
+#endif
 	fdt_init_reserved_mem();
 }
 
@@ -928,6 +978,112 @@ static inline void early_init_dt_check_for_initrd(unsigned long node)
 }
 #endif /* CONFIG_BLK_DEV_INITRD */
 
+extern void  swiotlb_init_variable(unsigned long of_io_tlb_nslabs,
+	enum swiotlb_force of_swiotlb_force);
+static inline void early_init_dt_check_for_swiotlb(unsigned long node)
+{
+	int len;
+	const __be32 *prop;
+	unsigned long of_io_tlb_nslabs;
+	enum swiotlb_force of_swiotlb_force;
+
+	pr_debug("Looking for swiotlb properties... ");
+
+	of_io_tlb_nslabs = 0;
+	of_swiotlb_force = 0;
+
+	prop = of_get_flat_dt_prop(node, "swiotlb-memory-reservation-size", &len);
+	if (!prop)
+		return;
+	of_io_tlb_nslabs = of_read_number(prop, len/4);
+
+	prop = of_get_flat_dt_prop(node, "swiotlb-force", &len);
+	if (prop) {
+		of_swiotlb_force = of_read_number(prop, len/4);
+	}
+
+	pr_debug("of_io_tlb_nslabs=0x%llx, of_swiotlb_force=%d\n",
+		 (unsigned long long)of_io_tlb_nslabs, of_swiotlb_force);
+
+	swiotlb_init_variable(of_io_tlb_nslabs, of_swiotlb_force);
+}
+
+#if defined(CONFIG_CMA_AREAS)
+#if defined(CONFIG_RTD119X) || defined(CONFIG_RTD129x) || defined(CONFIG_RTD139x) || defined(CONFIG_RTD16xx)
+extern of_cma_info_t of_cma_info;
+static inline void early_init_dt_check_for_cma(unsigned long node)
+{
+	int i, len;
+	const __be32 *prop;
+
+	pr_debug("Looking for cma properties... ");
+
+	// init data
+	memset(&of_cma_info, 0, sizeof(of_cma_info_t)) ;
+	of_cma_info.region_enable = 0;
+	of_cma_info.region_cnt = 0;
+	logo_start_addr_bak = logo_start_addr = 0;
+	logo_size_bak = logo_size = 0;
+
+	prop = of_get_flat_dt_prop(node, "logo-area", &len);
+	if (prop) {
+		logo_start_addr_bak =
+			logo_start_addr = of_read_number(prop, 1);
+		logo_size_bak =
+			logo_size = of_read_number(prop+1, 1);
+	}
+	if( sizeof(logo_size) == 8 )
+		printk(KERN_ERR "\033[1;33m" "DT: logo_start_addr 0x%llx, size 0x%llx" "\033[m\n",
+			logo_start_addr, logo_size);
+	else
+		printk(KERN_ERR "\033[1;33m" "DT: logo_start_addr 0x%lx, size 0x%lx" "\033[m\n",
+			logo_start_addr, logo_size);
+
+#if 0 /* Obsolete. Please use standard of statement */
+	prop = of_get_flat_dt_prop(node, "cma-region-enable", &len);
+	if (prop) {
+		of_cma_info.region_enable = of_read_number(prop, 1);
+	}
+	pr_debug("of_cma_info.region_enable %d\n", of_cma_info.region_enable);
+	printk(KERN_ERR "\033[1;33m" "DT: of_cma_info.region_enable %d" "\033[m\n",
+		of_cma_info.region_enable);
+
+	prop = of_get_flat_dt_prop(node, "cma-region-info", &len);
+	if (prop) {
+		int array_size;
+		array_size = len / (sizeof(u32)*CMA_REGION_COLUMN);
+		of_cma_info.region_cnt = array_size =
+			min(array_size,MAX_CMA_AREAS);
+		for (i=0; i<array_size; i++) {
+			of_cma_info.region[i].flag =
+				of_read_number(prop+0+(i*CMA_REGION_COLUMN), 1);
+			of_cma_info.region[i].size =
+				of_read_number(prop+1+(i*CMA_REGION_COLUMN), 1);
+			of_cma_info.region[i].base =
+				of_read_number(prop+2+(i*CMA_REGION_COLUMN), 1);
+
+			pr_debug("region_cnt.region[%d]{0x%x,0x%llx,0x%llx}\n",
+				i,
+				of_cma_info.region[i].flag,
+				of_cma_info.region[i].size,
+				of_cma_info.region[i].base);
+		}
+	}
+#endif
+}
+#else
+static inline void early_init_dt_check_for_cma(unsigned long node)
+{
+	pr_debug("#CONFIG_CMA_AREA is not set\n");
+}
+#endif // defined(CONFIG_RTD129x) || defined(CONFIG_RTD139x) || defined(CONFIG_RTD16xx)
+#else
+static inline void early_init_dt_check_for_cma(unsigned long node)
+{
+	pr_debug("#CONFIG_CMA_AREA is not set\n");
+}
+#endif // defined(CONFIG_CMA_AREAS)
+
 #ifdef CONFIG_SERIAL_EARLYCON
 
 int __init early_init_dt_scan_chosen_stdout(void)
@@ -1016,6 +1172,38 @@ u64 __init dt_mem_next_cell(int s, const __be32 **cellp)
 }
 
 /**
+ * sspt: saving-section-page-table for low-memory dom0
+ */
+static int __init
+setup_sspt(char *str)
+{
+	if (isdigit(*str)) {
+		saving_section_page_table_xen_low = simple_strtoul(str, &str, 0);
+		printk(KERN_ERR "\033[1;33m" "DT: saving_section_page_table_xen_low %d" "\033[m\n",
+			saving_section_page_table_xen_low);
+	}
+
+	return 0;
+}
+early_param("sspt", setup_sspt);
+
+/**
+ * sspt2: saving-section-page-table for low-memory domU
+ */
+static int __init
+setup_sspt2(char *str)
+{
+	if (isdigit(*str)) {
+		saving_section_page_table = simple_strtoul(str, &str, 0);
+		printk(KERN_ERR "\033[1;33m" "DT: saving_section_page_table %d(bootargs)" "\033[m\n",
+			saving_section_page_table);
+	}
+
+	return 0;
+}
+early_param("sspt2", setup_sspt2);
+
+/**
  * early_init_dt_scan_memory - Look for an parse memory nodes
  */
 int __init early_init_dt_scan_memory(unsigned long node, const char *uname,
@@ -1036,6 +1224,20 @@ int __init early_init_dt_scan_memory(unsigned long node, const char *uname,
 	} else if (strcmp(type, "memory") != 0)
 		return 0;
 
+	reg = of_get_flat_dt_prop(node, "free-logo-reserved-region", &l);
+	if (reg) {
+		free_logo_reserved_region = of_read_number(reg, 1);
+	}
+	printk(KERN_ERR "\033[1;33m" "DT: free_logo_reserved_region %d" "\033[m\n",
+		free_logo_reserved_region);
+
+	reg = of_get_flat_dt_prop(node, "saving-section-page-table", &l);
+	if (reg) {
+		saving_section_page_table = of_read_number(reg, 1);
+	}
+	printk(KERN_ERR "\033[1;33m" "DT: saving_section_page_table %d" "\033[m\n",
+		saving_section_page_table);
+
 	reg = of_get_flat_dt_prop(node, "linux,usable-memory", &l);
 	if (reg == NULL)
 		reg = of_get_flat_dt_prop(node, "reg", &l);
@@ -1063,42 +1265,70 @@ int __init early_init_dt_scan_memory(unsigned long node, const char *uname,
 	return 0;
 }
 
+/*
+ * Convert configs to something easy to use in C code
+ */
+#if defined(CONFIG_CMDLINE_FORCE)
+static const int overwrite_incoming_cmdline = 1;
+static const int read_dt_cmdline;
+static const int concat_cmdline;
+#elif defined(CONFIG_CMDLINE_EXTEND)
+static const int overwrite_incoming_cmdline;
+static const int read_dt_cmdline = 1;
+static const int concat_cmdline = 1;
+#else /* CMDLINE_FROM_BOOTLOADER */
+static const int overwrite_incoming_cmdline;
+static const int read_dt_cmdline = 1;
+static const int concat_cmdline;
+#endif
+
+#ifdef CONFIG_CMDLINE
+static const char *config_cmdline = CONFIG_CMDLINE;
+#else
+static const char *config_cmdline = "";
+#endif
+
 int __init early_init_dt_scan_chosen(unsigned long node, const char *uname,
 				     int depth, void *data)
 {
-	int l;
-	const char *p;
+	int l = 0;
+	const char *p = NULL;
+	char *cmdline = data;
 
 	pr_debug("search \"chosen\", depth: %d, uname: %s\n", depth, uname);
 
-	if (depth != 1 || !data ||
+	if (depth != 1 || !cmdline ||
 	    (strcmp(uname, "chosen") != 0 && strcmp(uname, "chosen@0") != 0))
 		return 0;
 
 	early_init_dt_check_for_initrd(node);
 
-	/* Retrieve command line */
-	p = of_get_flat_dt_prop(node, "bootargs", &l);
-	if (p != NULL && l > 0)
-		strlcpy(data, p, min((int)l, COMMAND_LINE_SIZE));
+	early_init_dt_check_for_swiotlb(node);
 
-	/*
-	 * CONFIG_CMDLINE is meant to be a default in case nothing else
-	 * managed to set the command line, unless CONFIG_CMDLINE_FORCE
-	 * is set in which case we override whatever was found earlier.
-	 */
-#ifdef CONFIG_CMDLINE
-#if defined(CONFIG_CMDLINE_EXTEND)
-	strlcat(data, " ", COMMAND_LINE_SIZE);
-	strlcat(data, CONFIG_CMDLINE, COMMAND_LINE_SIZE);
-#elif defined(CONFIG_CMDLINE_FORCE)
-	strlcpy(data, CONFIG_CMDLINE, COMMAND_LINE_SIZE);
-#else
-	/* No arguments from boot loader, use kernel's  cmdl*/
-	if (!((char *)data)[0])
-		strlcpy(data, CONFIG_CMDLINE, COMMAND_LINE_SIZE);
-#endif
-#endif /* CONFIG_CMDLINE */
+	early_init_dt_check_for_cma(node);
+
+	/* Put CONFIG_CMDLINE in if forced or if data had nothing in it to start */
+	if (overwrite_incoming_cmdline || !cmdline[0])
+		strlcpy(cmdline, config_cmdline, COMMAND_LINE_SIZE);
+
+	/* Retrieve command line unless forcing */
+	if (read_dt_cmdline)
+		p = of_get_flat_dt_prop(node, "bootargs", &l);
+
+	if (p != NULL && l > 0) {
+		if (concat_cmdline) {
+			int cmdline_len;
+			int copy_len;
+			strlcat(cmdline, " ", COMMAND_LINE_SIZE);
+			cmdline_len = strlen(cmdline);
+			copy_len = COMMAND_LINE_SIZE - cmdline_len - 1;
+			copy_len = min((int)l, copy_len);
+			strncpy(cmdline + cmdline_len, p, copy_len);
+			cmdline[cmdline_len + copy_len] = '\0';
+		} else {
+			strlcpy(cmdline, p, min((int)l, COMMAND_LINE_SIZE));
+		}
+	}
 
 	pr_debug("Command line is: %s\n", (char*)data);
 
@@ -1225,6 +1455,10 @@ bool __init early_init_dt_scan(void *params)
 {
 	bool status;
 
+	saving_section_page_table_xen_low = 0;
+	saving_section_page_table = 0;
+	free_logo_reserved_region = 0;
+
 	status = early_init_dt_verify(params);
 	if (!status)
 		return false;
diff --git a/drivers/of/of_reserved_mem.c b/drivers/of/of_reserved_mem.c
index 366d8c3..a85ac54 100644
--- a/drivers/of/of_reserved_mem.c
+++ b/drivers/of/of_reserved_mem.c
@@ -393,3 +393,13 @@ void of_reserved_mem_device_release(struct device *dev)
 	rmem->ops->device_release(rmem, dev);
 }
 EXPORT_SYMBOL_GPL(of_reserved_mem_device_release);
+
+void __init of_reserved_mem_remap(void)
+{
+#ifdef CONFIG_RTK_MEM_REMAP
+	/* drivers/soc/realtek/commo/rtk_memory_remap.c */
+	extern void __init rtk_mem_remap_of_init_by_DT(struct reserved_mem *, int);
+	rtk_mem_remap_of_init_by_DT( reserved_mem, reserved_mem_count);
+#endif
+}
+EXPORT_SYMBOL_GPL(of_reserved_mem_remap);
diff --git a/drivers/pci/host/Kconfig b/drivers/pci/host/Kconfig
index d7e7c0a..a7a7a1a 100644
--- a/drivers/pci/host/Kconfig
+++ b/drivers/pci/host/Kconfig
@@ -301,4 +301,52 @@ config VMD
 	  To compile this driver as a module, choose M here: the
 	  module will be called vmd.
 
+config PCIE_RTD129x_SLOT1
+	bool "Realtek PCIe host controller (slot1)"
+	depends on ARCH_RTD129x
+	help
+	  Realtek PCIe host controller support (slot1).
+
+config PCIE_RTD129x_SLOT2
+	bool "Realtek PCIe host controller (slot2)"
+	depends on ARCH_RTD129x
+	help
+	  Realtek PCIe host controller support (slot2).
+
+config PCIE_RTD139x
+	bool "Realtek PCIe host controller"
+	depends on ARCH_RTD139x
+	help
+	  Realtek PCIe host controller support.
+
+config PCIE_RTD16xx_SLOT1
+	bool "Realtek PCIe host controller(slot1)"
+	depends on ARCH_RTD16xx
+	help
+	  Realtek PCIe host controller support(slot1).
+
+config PCIE_RTD16xx_SLOT2
+	bool "Realtek PCIe host controller(slot2)"
+	depends on ARCH_RTD16xx
+	help
+	  Realtek PCIe host controller support(slot2).
+
+config PCIE_RTD13xx_SLOT1
+	bool "Realtek PCIe host controller(slot1)"
+	depends on ARCH_RTD13xx
+	help
+	  Realtek PCIe host controller support(slot1).
+
+config PCIE_RTD13xx_SLOT2
+	bool "Realtek PCIe host controller(slot2)"
+	depends on ARCH_RTD13xx
+	help
+	  Realtek PCIe host controller support(slot2).
+
+config PCIE_RTD13xx_SLOT3
+	bool "Realtek PCIe host controller(slot3)"
+	depends on ARCH_RTD13xx
+	help
+	  Realtek PCIe host controller support(slot3).
+
 endmenu
diff --git a/drivers/pci/host/Makefile b/drivers/pci/host/Makefile
index 084cb49..0ad0b7e 100644
--- a/drivers/pci/host/Makefile
+++ b/drivers/pci/host/Makefile
@@ -33,3 +33,11 @@ obj-$(CONFIG_PCIE_ARMADA_8K) += pcie-armada8k.o
 obj-$(CONFIG_PCIE_ARTPEC6) += pcie-artpec6.o
 obj-$(CONFIG_PCIE_ROCKCHIP) += pcie-rockchip.o
 obj-$(CONFIG_VMD) += vmd.o
+obj-$(CONFIG_PCIE_RTD129x_SLOT2) += pcie-rtd129x-slot2.o
+obj-$(CONFIG_PCIE_RTD129x_SLOT1) += pcie-rtd129x-slot1.o
+obj-$(CONFIG_PCIE_RTD139x) += pcie-rtd139x.o
+obj-$(CONFIG_PCIE_RTD16xx_SLOT1) += pcie-rtd16xx-slot1.o
+obj-$(CONFIG_PCIE_RTD16xx_SLOT2) += pcie-rtd16xx-slot2.o
+obj-$(CONFIG_PCIE_RTD13xx_SLOT1) += pcie-rtd13xx-slot1.o
+obj-$(CONFIG_PCIE_RTD13xx_SLOT2) += pcie-rtd13xx-slot2.o
+obj-$(CONFIG_PCIE_RTD13xx_SLOT3) += pcie-rtd13xx-slot3.o
\ No newline at end of file
diff --git a/drivers/pci/host/pcie-rtd129x-slot1.c b/drivers/pci/host/pcie-rtd129x-slot1.c
new file mode 100644
index 00000000..983bdce
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd129x-slot1.c
@@ -0,0 +1,946 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/gpio.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/of_gpio.h>
+#include <linux/of_address.h>
+#include <linux/of_pci.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <linux/pci.h>
+#include <linux/platform_device.h>
+#include <linux/resource.h>
+#include <linux/signal.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+#include <linux/suspend.h>
+#include <linux/kthread.h>
+#include <linux/spinlock.h>
+
+#include <soc/realtek/rtk_pcie.h>
+#include <soc/realtek/rtk_cpu.h>
+#include "pcie-rtd129x.h"
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+#include <soc/realtek/rtd129x_lockapi.h>
+#endif
+
+spinlock_t rtk_pcie1_lock;
+#define DEV_NAME "[RTK PCIE 1]"
+#define PCIE_IO_2K_MASK 0xFFFFF800
+#define PCIE_IO_4K_MASK 0xFFFFF000
+
+static void __iomem *PCIE_CTRL_BASE;
+static void __iomem *PCIE_CFG_BASE;
+static void __iomem *SYSTEM_BASE1;
+static void __iomem *SYSTEM_BASE2;
+
+#ifdef CONFIG_ARCH_RTD129x
+static void __iomem *EMMC_MUXPAD;
+#endif /* CONFIG_ARCH_RTD129x */
+
+static u32 PCIE2_MMIO_PHY_ADDR;
+static u32 PCIE2_MMIO_PHY_ADDR_LEN;
+
+static u32 pcie_gpio_18;
+
+static bool cfg_direct_access;
+
+static int rtk_cpu_id;
+static int rtk_cpu_revision;
+
+static struct clk *pcie0_clk;
+static struct reset_control *rstn_pcie0_stitch;
+static struct reset_control *rstn_pcie0;
+static struct reset_control *rstn_pcie0_core;
+static struct reset_control *rstn_pcie0_power;
+static struct reset_control *rstn_pcie0_nonstitch;
+static struct reset_control *rstn_pcie0_phy;
+static struct reset_control *rstn_pcie0_phy_mdio;
+
+static struct pci_bus *bus;
+static struct platform_device *local_pdev;
+
+static u32 debug_mode;
+
+static void rtk_pci_ctrl_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CTRL_BASE);
+}
+
+static unsigned int rtk_pci_ctrl_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CTRL_BASE);
+	return val;
+}
+
+static void rtk_pci_direct_cfg_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pci_direct_cfg_write_word(unsigned long addr, u16 val)
+{
+	writew(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pci_direct_cfg_write_byte(unsigned long addr, u8 val)
+{
+	writeb(val, addr + PCIE_CFG_BASE);
+}
+
+static unsigned int rtk_pci_direct_cfg_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u16 rtk_pci_direct_cfg_read_word(unsigned long addr)
+{
+	u16 val = readw(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u8 rtk_pci_direct_cfg_read_byte(unsigned long addr)
+{
+	u8 val = readb(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+u32 rtk_pcie_mmio_start(void)
+{
+	return PCIE2_MMIO_PHY_ADDR;
+}
+
+u32 rtk_pcie_mmio_end(void)
+{
+	return PCIE2_MMIO_PHY_ADDR + (PCIE2_MMIO_PHY_ADDR_LEN - 1);
+}
+
+u32 rtk_pcie_mmio_len(void)
+{
+	return PCIE2_MMIO_PHY_ADDR_LEN;
+}
+
+u32 rtk_pcie1_read(u32 addr, u8 size)
+{
+	u32 rval = 0;
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	u32 pci_error_status = 0;
+	int retry_cnt = 0;
+	u8 retry = 5;
+	unsigned long irqL;
+	unsigned long flags;
+
+	spin_lock_irqsave(&rtk_pcie1_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 129x hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pci_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pci_ctrl_read(0xD04);
+		rtk_pci_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x1000) {
+		mask = PCIE_IO_4K_MASK;
+		translate_val = rtk_pci_ctrl_read(0xD04);
+		rtk_pci_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+
+pci_read_retry:
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error
+	 *
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, (char *)__func__);
+#endif
+
+	switch (size) {
+	case 1:
+		rval = rtk_pci_direct_cfg_read_byte((addr & ~mask));
+		break;
+	case 2:
+		rval = rtk_pci_direct_cfg_read_word((addr & ~mask));
+		break;
+	case 4:
+		rval = rtk_pci_direct_cfg_read((addr & ~mask));
+		break;
+	default:
+		pr_info("%s: wrong size %d\n", __func__, size);
+		break;
+	}
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, (char *)__func__);
+#endif
+
+	/* DLLP error patch */
+	pci_error_status = rtk_pci_ctrl_read(0xc7c);
+	if (pci_error_status & 0x1F) {
+		rtk_pci_ctrl_write(0xc7c, pci_error_status);
+		pr_info("%s: DLLP(#%d) 0x%x reg=0x%x val=0x%x\n",
+			__func__, retry_cnt, pci_error_status, addr, rval);
+
+		if (retry_cnt < retry) {
+			retry_cnt++;
+			goto pci_read_retry;
+		}
+	}
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 129x hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pci_ctrl_write(0xD04, translate_val);
+		rtk_pci_ctrl_write(0xD00, PCIE_IO_4K_MASK);
+	} else if (addr >= 0x1000) {
+		rtk_pci_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie1_lock, irqL);
+
+	return rval;
+}
+EXPORT_SYMBOL(rtk_pcie1_read);
+
+void rtk_pcie1_write(u32 addr, u8 size, u32 wval)
+{
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+	unsigned long flags;
+
+	spin_lock_irqsave(&rtk_pcie1_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 129x hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pci_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pci_ctrl_read(0xD04);
+		rtk_pci_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x1000) {
+		mask = PCIE_IO_4K_MASK;
+		translate_val = rtk_pci_ctrl_read(0xD04);
+		rtk_pci_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 *
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags,  (char *)__func__);
+#endif
+
+	switch (size) {
+	case 1:
+		rtk_pci_direct_cfg_write_byte((addr&~mask), wval);
+		break;
+	case 2:
+		rtk_pci_direct_cfg_write_word((addr&~mask), wval);
+		break;
+	case 4:
+		rtk_pci_direct_cfg_write((addr&~mask), wval);
+		break;
+	default:
+
+		pr_info("%s: wrong size %d\n", __func__, size);
+		break;
+	}
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags,  (char *)__func__);
+#endif
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 129x hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pci_ctrl_write(0xD04, translate_val);
+		rtk_pci_ctrl_write(0xD00, PCIE_IO_4K_MASK);
+	} else if (addr >= 0x1000) {
+		rtk_pci_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie1_lock, irqL);
+}
+EXPORT_SYMBOL(rtk_pcie1_write);
+
+static int _indirect_cfg_write(unsigned long addr, unsigned long data,
+	unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 1000;
+
+#if 0
+	pr_alert("_indirect_cfg_write: addr(%x): %x size %d\n",
+		addr, data, size);
+#endif
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	data = (data << _pci_bit_shift(addr)) & _pci_bit_mask(mask);
+
+	rtk_pci_ctrl_write(PCIE_INDIR_CTR, 0x12);
+	rtk_pci_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+	rtk_pci_ctrl_write(PCIE_CFG_ADDR, addr);
+	rtk_pci_ctrl_write(PCIE_CFG_WDATA, data);
+
+	if (size == 4) {
+		rtk_pci_ctrl_write(PCIE_CFG_EN, 0x1);
+	} else {
+		rtk_pci_ctrl_write(PCIE_CFG_EN, BYTE_CNT(mask) |
+			BYTE_EN | WRRD_EN(1));
+	}
+
+	rtk_pci_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pci_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("write config data (%p) failed - timeout\n",
+				(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pci_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+
+		PCI_CFG_WARNING("write config data failed - ");
+
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING(" master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("tar abort\n");
+
+		goto error_occur;
+	}
+
+	rtk_pci_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+
+	rtk_pci_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SET_FAILED;
+}
+
+static int _indirect_cfg_read(unsigned long addr, u32 *pdata,
+	unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 20000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	rtk_pci_ctrl_write(PCIE_INDIR_CTR, 0x10);
+	rtk_pci_ctrl_write(PCIE_CFG_ST, 0x3);
+	rtk_pci_ctrl_write(PCIE_CFG_ADDR, (addr & ~0x3));
+	rtk_pci_ctrl_write(PCIE_CFG_EN, BYTE_CNT(mask) | BYTE_EN | WRRD_EN(0));
+	rtk_pci_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pci_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("read config data (%p) failed - timeout\n",
+			(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pci_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+
+		PCI_CFG_WARNING("read config data failed - ");
+
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("tar abort\n");
+		goto error_occur;
+	}
+
+	rtk_pci_ctrl_write(PCIE_CFG_ST, 0x3);
+
+	*pdata = (rtk_pci_ctrl_read(PCIE_CFG_RDATA) & _pci_bit_mask(mask))
+		>> _pci_bit_shift(addr);
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+	rtk_pci_ctrl_write(PCIE_CFG_ST, 0x3);
+	return PCIBIOS_SET_FAILED;
+}
+
+static int rtk_pcie_rd_conf(struct pci_bus *bus, unsigned int devfn,
+	int reg, int size, u32 *pval)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+	u32 val = 0;
+	u8 retry = 5;
+
+	if (rtk_cpu_revision == RTD129x_CHIP_REVISION_A00)
+		udelay(200);
+
+again:
+	if (bus->number == 0 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if (cfg_direct_access) {
+			rtk_pci_ctrl_write(0xC00, 0x40012);
+
+			if (size == 1)
+				*pval = rtk_pci_direct_cfg_read_byte(reg);
+			else if (size == 2)
+				*pval = rtk_pci_direct_cfg_read_word(reg);
+			else if (size == 4)
+				*pval = rtk_pci_direct_cfg_read(reg);
+
+			rtk_pci_ctrl_write(0xC00, 0x1E0002);
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_read(address, pval, size);
+		}
+	}
+
+	val = rtk_pci_ctrl_read(0xC7C);
+	if ((val & 0x1f) && retry) {
+		rtk_pci_ctrl_write(0xC7C, val);
+		retry--;
+		dev_err(&bus->dev, "pcie1 dllp error occur = 0x%x\n", val);
+		goto again;
+	}
+
+#if 0
+	pr_info("%s devfn = 0x%x, reg = 0x%x, *pval = 0x%x\n",
+		_func_, devfn, reg, *pval);
+#endif
+
+	return ret;
+}
+
+static int rtk_pcie_wr_conf(struct pci_bus *bus, unsigned int devfn,
+	int reg, int size, u32 val)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+
+	if (rtk_cpu_revision == RTD129x_CHIP_REVISION_A00)
+		udelay(200);
+
+#if 0
+	pr_info("%s devfn = 0x%x, reg = 0x%x, *pval = 0x%x\n",
+		_func_, devfn, reg, *pval);
+#endif
+
+	if (bus->number == 0 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if ((reg == 0x10) || (reg == 0x18) || (reg == 0x20) ||
+			(reg == 0x24)) {
+
+			if ((val & 0xc0000000) == 0xc0000000)
+				rtk_pci_ctrl_write(0xD04, (val&0xfffffff0));
+		}
+
+		if (cfg_direct_access) {
+			rtk_pci_ctrl_write(0xC00, 0x40012);
+
+			if (size == 1)
+				rtk_pci_direct_cfg_write_byte(reg, val);
+			else if (size == 2)
+				rtk_pci_direct_cfg_write_word(reg, val);
+			else if (size == 4)
+				rtk_pci_direct_cfg_write(reg, val);
+
+			rtk_pci_ctrl_write(0xC00, 0x1E0002);
+			ret = PCIBIOS_SUCCESSFUL;
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_write(address, val, size);
+		}
+	}
+
+	return ret;
+}
+
+static struct pci_ops rtk_pcie_ops = {
+	.read = rtk_pcie_rd_conf,
+	.write = rtk_pcie_wr_conf,
+};
+
+static int rtk_pcie_hw_initial(struct device *dev)
+{
+	bool pci_link_detected;
+	int timeout = 0;
+	int ret = 0;
+	u32 val;
+	u32 *phy;
+	int size = 0, i = 0;
+
+	if (rtk_cpu_revision == RTD129x_CHIP_REVISION_A00 ||
+		(rtk_cpu_id == RTK1296_CPU_ID &&
+		rtk_cpu_revision != RTD129x_CHIP_REVISION_B00)) {
+
+		/* 0x9801C614[2:0] = 1 */
+		val = readl(SYSTEM_BASE1 + 0x14);
+		val &= (~0x7);
+		val |= 0x1;
+		writel(val, (SYSTEM_BASE1 + 0x14));
+
+		/* 0x9801C600[3:0] = 0 --PCIE */
+		val = readl(SYSTEM_BASE1);
+		val &= (~0xf);
+		writel(val, SYSTEM_BASE1);
+
+		/* 0x9801C608[7:0] = 8’b01010000 */
+		writeb(0x51, SYSTEM_BASE1 + 0x8);
+	}
+
+	reset_control_deassert(rstn_pcie0_stitch);
+	reset_control_deassert(rstn_pcie0);
+	reset_control_deassert(rstn_pcie0_core);
+	reset_control_deassert(rstn_pcie0_power);
+	reset_control_deassert(rstn_pcie0_nonstitch);
+	reset_control_deassert(rstn_pcie0_phy);
+	reset_control_deassert(rstn_pcie0_phy_mdio);
+	ret = clk_prepare_enable(pcie0_clk);
+	if (ret) {
+		dev_err(dev, "unable to enable pcie0_clk clock\n");
+		clk_disable_unprepare(pcie0_clk);
+		return -EINVAL;
+	}
+
+	/* #bit17 null for mdio rstN */
+	rtk_pci_ctrl_write(0xC00, 0x00140010);
+
+	if (rtk_cpu_revision == RTD129x_CHIP_REVISION_A01 ||
+		rtk_cpu_revision == RTD129x_CHIP_REVISION_A00) {
+
+		size = of_property_count_u32_elems(dev->of_node, "phys_a");
+		phy = kmalloc(size * sizeof(u32), GFP_KERNEL);
+		of_property_read_u32_array(dev->of_node, "phys_a", phy, size);
+		for (i = 0; i < size; i++) {
+			rtk_pci_ctrl_write(0xC1C, phy[i]);
+			mdelay(1);
+		}
+		kfree(phy);
+
+	} else {
+		size = of_property_count_u32_elems(dev->of_node, "phys_b");
+		phy = kmalloc(size * sizeof(u32), GFP_KERNEL);
+		of_property_read_u32_array(dev->of_node, "phys_b", phy, size);
+		for (i = 0; i < size; i++) {
+			rtk_pci_ctrl_write(0xC1C, phy[i]);
+			mdelay(1);
+		}
+		kfree(phy);
+
+	}
+
+	/* Reset PCIE1 device */
+	ret = gpio_direction_output(pcie_gpio_18, 0);
+	mdelay(100);
+	ret = gpio_direction_output(pcie_gpio_18, 1);
+
+	if (cfg_direct_access)
+		rtk_pci_ctrl_write(0xC00, 0x00040012);
+	else
+		rtk_pci_ctrl_write(0xC00, 0x001E0022);
+
+	mdelay(50);
+
+	/* #Link initial setting */
+	rtk_pci_ctrl_write(0x710, 0x00010120);
+
+	do {
+		pci_link_detected = (rtk_pci_ctrl_read(0xCB4) & 0x800);
+		if (!pci_link_detected) {
+			mdelay(TIMEOUT_RESOLUTION);
+			timeout += TIMEOUT_RESOLUTION;
+		}
+	} while (!pci_link_detected && timeout < PCIE_CONNECT_TIMEOUT);
+
+	if (pci_link_detected) {
+		dev_err(dev, "pcie device has link up in slot 1\n");
+	} else {
+		if (!debug_mode) { /*do not turn off clk in debug mode*/
+			reset_control_assert(rstn_pcie0_stitch);
+			reset_control_assert(rstn_pcie0);
+			reset_control_assert(rstn_pcie0_core);
+			reset_control_assert(rstn_pcie0_power);
+			reset_control_assert(rstn_pcie0_nonstitch);
+			reset_control_assert(rstn_pcie0_phy);
+			reset_control_assert(rstn_pcie0_phy_mdio);
+			clk_disable_unprepare(pcie0_clk);
+		}
+		gpio_free(pcie_gpio_18);
+		dev_err(dev, "pcie device has link down in slot 1\n");
+		return -ENODEV;
+	}
+
+#ifdef CONFIG_ARCH_RTD129x
+	//writel(readl(EMMC_MUXPAD + 0x61C) | 0x00000004, EMMC_MUXPAD + 0x61C);
+#endif /* CONFIG_ARCH_RTD129x */
+
+	/* #make sure DBI is working */
+	rtk_pci_ctrl_write(0x04, 0x00000007);
+
+	/* #Base */
+	rtk_pci_ctrl_write(0xCFC, 0x9804f000);
+
+	/* #Mask */
+	rtk_pci_ctrl_write(0xD00, 0xFFFFF000);
+
+	/* #translate for CFG R/W */
+	rtk_pci_ctrl_write(0xD04, 0xC0000000);
+
+	/* prevent pcie hang if dllp error occur*/
+	rtk_pci_ctrl_write(0xC78, 0x200001);
+
+	/* set limit and base register */
+	rtk_pci_ctrl_write(0x20, 0x0000FFF0);
+	rtk_pci_ctrl_write(0x24, 0x0000FFF0);
+
+	return 0;
+}
+
+static int rtk_pcie_probe(struct platform_device *pdev)
+{
+	int ret = 0;
+	resource_size_t iobase = 0;
+	struct resource pcie_mmio_res;
+	int size = 0;
+	const u32 *prop2;
+	LIST_HEAD(res);
+
+	local_pdev = pdev;
+	cfg_direct_access = false;
+
+	dev_info(&pdev->dev, "pcie host driver initial begin\n");
+
+	spin_lock_init(&rtk_pcie1_lock);
+
+	prop2 = of_get_property(pdev->dev.of_node, "debug-mode", &size);
+	if (prop2) {
+		debug_mode = of_read_number(prop2, 1);
+		if (debug_mode == 0)
+			dev_info(&pdev->dev, "PCIE Debug Mode off\n");
+		else if (debug_mode == 1)
+			dev_info(&pdev->dev, "PCIE Debug Mode on\n");
+	} else {
+		debug_mode = 0;
+	}
+
+	PCIE_CTRL_BASE = of_iomap(pdev->dev.of_node, 0);
+	if (!PCIE_CTRL_BASE) {
+		dev_err(&pdev->dev, "can't request 'ctrl' address\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	PCIE_CFG_BASE = of_iomap(pdev->dev.of_node, 1);
+	if (!PCIE_CFG_BASE) {
+		dev_err(&pdev->dev, "can't request 'cfg' address\n");
+		ret = -EINVAL;
+		goto err_out;
+	} else {
+		of_address_to_resource(pdev->dev.of_node, 1, &pcie_mmio_res);
+		PCIE2_MMIO_PHY_ADDR = pcie_mmio_res.start;
+		PCIE2_MMIO_PHY_ADDR_LEN = resource_size(&pcie_mmio_res);
+	}
+
+	SYSTEM_BASE1 = of_iomap(pdev->dev.of_node, 2);
+	if (!SYSTEM_BASE1) {
+		dev_err(&pdev->dev, "can't request 'base1' address\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	SYSTEM_BASE2 = of_iomap(pdev->dev.of_node, 3);
+	if (!SYSTEM_BASE2) {
+		dev_err(&pdev->dev, "can't request 'base2' address\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+#ifdef CONFIG_ARCH_RTD129x
+	EMMC_MUXPAD = of_iomap(pdev->dev.of_node, 4);
+	if (!EMMC_MUXPAD) {
+		dev_err(&pdev->dev, "can't request 'EMMC_MUXPAD' address\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	pcie_gpio_18 = of_get_gpio_flags(pdev->dev.of_node, 0, NULL);
+	if (gpio_is_valid(pcie_gpio_18)) {
+		ret = gpio_request(pcie_gpio_18, "pcie_gpio(18)");
+		if (ret < 0)
+			dev_err(&pdev->dev, "%s: can't request gpio %d\n",
+				__func__, pcie_gpio_18);
+	} else
+		dev_err(&pdev->dev, "%s: gpio %d is not valid\n",
+			__func__, pcie_gpio_18);
+#endif /* CONFIG_ARCH_RTD129x */
+
+	pcie0_clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(pcie0_clk)) {
+		dev_err(&pdev->dev, "clk_en_pcie0 source missing or invalid\n");
+		ret = PTR_ERR(pcie0_clk);
+		goto err_out;
+	}
+
+	rstn_pcie0_stitch = devm_reset_control_get(&pdev->dev, "stitch");
+	if (rstn_pcie0_stitch == NULL) {
+		dev_err(&pdev->dev, "stitch source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	rstn_pcie0 = devm_reset_control_get(&pdev->dev, "rstn");
+	if (rstn_pcie0 == NULL) {
+		dev_err(&pdev->dev, "rstn_pcie0 source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	rstn_pcie0_core = devm_reset_control_get(&pdev->dev, "core");
+	if (rstn_pcie0_core == NULL) {
+		dev_err(&pdev->dev, "core source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	rstn_pcie0_power = devm_reset_control_get(&pdev->dev, "power");
+	if (rstn_pcie0_power == NULL) {
+		dev_err(&pdev->dev, "power source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	rstn_pcie0_nonstitch = devm_reset_control_get(&pdev->dev, "nonstitch");
+	if (rstn_pcie0_nonstitch == NULL) {
+		dev_err(&pdev->dev, "nonstitch source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	rstn_pcie0_phy = devm_reset_control_get(&pdev->dev, "phy");
+	if (rstn_pcie0_phy == NULL) {
+		dev_err(&pdev->dev, "phy source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	rstn_pcie0_phy_mdio = devm_reset_control_get(&pdev->dev, "phy_mdio");
+	if (rstn_pcie0_phy_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	reset_control_assert(rstn_pcie0_stitch);
+	reset_control_assert(rstn_pcie0);
+	reset_control_assert(rstn_pcie0_core);
+	reset_control_assert(rstn_pcie0_power);
+	reset_control_assert(rstn_pcie0_nonstitch);
+	reset_control_assert(rstn_pcie0_phy);
+	reset_control_assert(rstn_pcie0_phy_mdio);
+
+	rtk_cpu_id = get_rtd129x_cpu_id();
+	rtk_cpu_revision = get_rtd129x_cpu_revision();
+
+	if (rtk_pcie_hw_initial(&pdev->dev) < 0) {
+		dev_err(&pdev->dev, "rtk_pcie_hw_initial fail\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	/* Register PCI-E host */
+	ret = of_pci_get_host_bridge_resources(pdev->dev.of_node, 0x0, 0xff,
+		&res, &iobase);
+	if (ret)
+		goto err_out;
+
+	bus = pci_create_root_bus(&pdev->dev, 0x0, &rtk_pcie_ops, NULL, &res);
+	if (!bus) {
+		ret = -ENOMEM;
+		goto err_out;
+	}
+
+	pci_scan_child_bus(bus);
+	pci_assign_unassigned_bus_resources(bus);
+	pci_bus_add_devices(bus);
+
+	dev_info(&pdev->dev, "pcie host driver initial done\n");
+
+err_out:
+
+	return ret;
+}
+
+#ifdef CONFIG_SUSPEND
+static int rtk_pcie1_suspend(struct device *dev)
+{
+	dev_info(dev, "suspend enter ...\n");
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pci_ctrl_write(0x178, 0xA3FF0001);
+		rtk_pci_ctrl_write(0x098, 0x400);
+		rtk_pci_ctrl_write(0xC6C, 0x00000031);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+		reset_control_assert(rstn_pcie0_stitch);
+		reset_control_assert(rstn_pcie0);
+		reset_control_assert(rstn_pcie0_core);
+		reset_control_assert(rstn_pcie0_power);
+		reset_control_assert(rstn_pcie0_nonstitch);
+		reset_control_assert(rstn_pcie0_phy);
+		reset_control_assert(rstn_pcie0_phy_mdio);
+		clk_disable_unprepare(pcie0_clk);
+		gpio_free(pcie_gpio_18);
+	}
+	dev_info(dev, "suspend exit ...\n");
+
+	return 0;
+}
+
+static int rtk_pcie1_resume(struct device *dev)
+{
+	int ret = 0;
+
+	dev_info(dev, "resume enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pci_ctrl_write(0xC6C, 0x00000032);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+		if (gpio_is_valid(pcie_gpio_18)) {
+			ret = gpio_request(pcie_gpio_18, "pcie_gpio(18)");
+			if (ret < 0)
+				pr_err("%s: can't request gpio %d\n",
+					__func__, pcie_gpio_18);
+		} else
+			pr_err("%s: gpio %d is not valid\n", __func__,
+				pcie_gpio_18);
+
+		reset_control_deassert(rstn_pcie0_stitch);
+		reset_control_deassert(rstn_pcie0);
+		reset_control_deassert(rstn_pcie0_core);
+		reset_control_deassert(rstn_pcie0_power);
+		reset_control_deassert(rstn_pcie0_nonstitch);
+		reset_control_deassert(rstn_pcie0_phy);
+		reset_control_deassert(rstn_pcie0_phy_mdio);
+		ret = clk_prepare_enable(pcie0_clk);
+		if (ret) {
+			dev_err(dev, "unable to enable pcie0_clk clock\n");
+			clk_disable_unprepare(pcie0_clk);
+			return -EINVAL;
+		}
+
+		/* Reset PCIE1 device, Pull high reset signal. */
+		ret = gpio_direction_output(pcie_gpio_18, 0);
+		mdelay(100);
+		ret = gpio_direction_output(pcie_gpio_18, 1);
+
+		if (rtk_pcie_hw_initial(dev) < 0) {
+			dev_err(dev, "rtk_pcie_hw_initial fail\n");
+			return -EINVAL;
+		}
+
+		if (cfg_direct_access)
+			rtk_pci_ctrl_write(0xC00, 0x00040012);
+		else
+			rtk_pci_ctrl_write(0xC00, 0x001E0022);
+	}
+
+	dev_info(dev, "resume exit ...\n");
+
+	return ret;
+}
+
+static const struct dev_pm_ops rtk_pcie1_pm_ops = {
+	.suspend_noirq = rtk_pcie1_suspend,
+	.resume_noirq = rtk_pcie1_resume,
+};
+#endif /* CONFIG_SUSPEND */
+
+static const struct of_device_id rtk_pcie_match_table[] = {
+	{.compatible = "realtek,rtk-pcie-slot1",},
+	{},
+};
+
+static struct platform_driver rtk_pcie_driver = {
+	.driver = {
+		.name = DEV_NAME,
+		.of_match_table = of_match_ptr(rtk_pcie_match_table),
+#ifdef CONFIG_SUSPEND
+		.pm = &rtk_pcie1_pm_ops,
+#endif
+	},
+	.probe = rtk_pcie_probe,
+};
+module_platform_driver(rtk_pcie_driver);
+
+MODULE_AUTHOR("James Tai <james.tai@realtek.com>");
+MODULE_DESCRIPTION("Realtek PCIe slot1 host controller driver");
diff --git a/drivers/pci/host/pcie-rtd129x-slot2.c b/drivers/pci/host/pcie-rtd129x-slot2.c
new file mode 100644
index 00000000..a71952c
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd129x-slot2.c
@@ -0,0 +1,943 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/gpio.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/of_gpio.h>
+#include <linux/of_address.h>
+#include <linux/of_pci.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <linux/pci.h>
+#include <linux/platform_device.h>
+#include <linux/resource.h>
+#include <linux/signal.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+#include <linux/suspend.h>
+#include <linux/kthread.h>
+#include <linux/spinlock.h>
+
+#include <soc/realtek/rtk_pcie.h>
+#include <soc/realtek/rtk_cpu.h>
+#include "pcie-rtd129x.h"
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+#include <soc/realtek/rtd129x_lockapi.h>
+#endif
+
+spinlock_t rtk_pcie2_lock;
+#define DEV_NAME "[RTK PCIE 2]"
+#define PCIE_IO_2K_MASK 0xFFFFF800
+#define PCIE_IO_4K_MASK 0xFFFFF000
+
+static void __iomem *PCIE_CTRL_BASE;
+static void __iomem *PCIE_CFG_BASE;
+static void __iomem *SYSTEM_BASE1;
+static void __iomem *SYSTEM_BASE2;
+static void __iomem *EMMC_MUXPAD;
+static u32 PCIE_MMIO_PHY_ADDR;
+static u32 PCIE_MMIO_PHY_ADDR_LEN;
+
+static u32 pcie_gpio_20;
+static u32 speed_mode;
+static u32 debug_mode;
+static bool cfg_direct_access;
+
+static int rtk_cpu_id;
+static int rtk_cpu_revision;
+
+static struct clk *pcie1_clk;
+static struct reset_control *rstn_pcie1_stitch;
+static struct reset_control *rstn_pcie1;
+static struct reset_control *rstn_pcie1_core;
+static struct reset_control *rstn_pcie1_power;
+static struct reset_control *rstn_pcie1_nonstitch;
+static struct reset_control *rstn_pcie1_phy;
+static struct reset_control *rstn_pcie1_phy_mdio;
+
+static struct pci_bus *bus;
+static struct platform_device *local_pdev;
+
+static void rtk_pci2_ctrl_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CTRL_BASE);
+}
+
+static unsigned int rtk_pci2_ctrl_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CTRL_BASE);
+	return val;
+}
+
+static void rtk_pci2_direct_cfg_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pci2_direct_cfg_write_word(unsigned long addr, u16 val)
+{
+	writew(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pci2_direct_cfg_write_byte(unsigned long addr, u8 val)
+{
+	writeb(val, addr + PCIE_CFG_BASE);
+}
+
+static unsigned int rtk_pci2_direct_cfg_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u16 rtk_pci2_direct_cfg_read_word(unsigned long addr)
+{
+	u16 val = readw(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u8 rtk_pci2_direct_cfg_read_byte(unsigned long addr)
+{
+	u8 val = readb(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+u32 rtk_pcie2_mmio_start(void)
+{
+	return PCIE_MMIO_PHY_ADDR;
+}
+
+u32 rtk_pcie2_mmio_end(void)
+{
+	return (PCIE_MMIO_PHY_ADDR + (PCIE_MMIO_PHY_ADDR_LEN - 1));
+}
+
+u32 rtk_pcie2_mmio_len(void)
+{
+	return PCIE_MMIO_PHY_ADDR_LEN;
+}
+
+u32 rtk_pcie2_read(u32 addr, u8 size)
+{
+	u32 rval = 0;
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	u32 pci_error_status = 0;
+	int retry_cnt = 0;
+	u8 retry = 5;
+	unsigned long irqL;
+	unsigned long flags;
+
+	spin_lock_irqsave(&rtk_pcie2_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 129x hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pci2_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pci2_ctrl_read(0xD04);
+		rtk_pci2_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x1000) {
+		mask = PCIE_IO_4K_MASK;
+		translate_val = rtk_pci2_ctrl_read(0xD04);
+		rtk_pci2_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+
+pci_read_retry:
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround for
+	 * emmc hardware error.
+	 *
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, (char *)__func__);
+#endif
+
+	switch (size) {
+	case 1:
+		rval = rtk_pci2_direct_cfg_read_byte((addr & ~mask));
+		break;
+	case 2:
+		rval = rtk_pci2_direct_cfg_read_word((addr & ~mask));
+		break;
+	case 4:
+		rval = rtk_pci2_direct_cfg_read((addr & ~mask));
+		break;
+	default:
+		pr_info("%s: wrong size %d\n", __func__, size);
+		break;
+	}
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, (char *)__func__);
+#endif
+
+	/* DLLP error patch */
+	pci_error_status = rtk_pci2_ctrl_read(0xc7c);
+	if (pci_error_status & 0x1F) {
+		rtk_pci2_ctrl_write(0xc7c, pci_error_status);
+		pr_info("%s: DLLP(#%d) 0x%x reg=0x%x val=0x%x\n",
+			__func__, retry_cnt, pci_error_status, addr, rval);
+
+		if (retry_cnt < retry) {
+			retry_cnt++;
+			goto pci_read_retry;
+		}
+	}
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 129x hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pci2_ctrl_write(0xD04, translate_val);
+		rtk_pci2_ctrl_write(0xD00, PCIE_IO_4K_MASK);
+	} else if (addr >= 0x1000) {
+		rtk_pci2_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie2_lock, irqL);
+
+	return rval;
+}
+EXPORT_SYMBOL(rtk_pcie2_read);
+
+void rtk_pcie2_write(u32 addr, u8 size, u32 wval)
+{
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long flags;
+	unsigned long irqL;
+
+	spin_lock_irqsave(&rtk_pcie2_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 129x hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pci2_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pci2_ctrl_read(0xD04);
+		rtk_pci2_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x1000) {
+		mask = PCIE_IO_4K_MASK;
+		translate_val = rtk_pci2_ctrl_read(0xD04);
+		rtk_pci2_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround for
+	 * emmc hardware error.
+	 *
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, (char *)__func__);
+#endif
+
+	switch (size) {
+	case 1:
+		rtk_pci2_direct_cfg_write_byte((addr&~mask), wval);
+		break;
+	case 2:
+		rtk_pci2_direct_cfg_write_word((addr&~mask), wval);
+		break;
+	case 4:
+		rtk_pci2_direct_cfg_write((addr&~mask), wval);
+		break;
+	default:
+		pr_info("%s: wrong size %d\n", __func__, size);
+		break;
+	}
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, (char *)__func__);
+#endif
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 129x hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pci2_ctrl_write(0xD04, translate_val);
+		rtk_pci2_ctrl_write(0xD00, PCIE_IO_4K_MASK);
+	} else if (addr >= 0x1000) {
+		rtk_pci2_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie2_lock, irqL);
+}
+EXPORT_SYMBOL(rtk_pcie2_write);
+
+static int _indirect_cfg_write(unsigned long addr, unsigned long data,
+	unsigned char size)
+{
+
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 1000;
+	int retry = 0;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	data = (data << _pci_bit_shift(addr)) & _pci_bit_mask(mask);
+
+write_resend:
+
+	rtk_pci2_ctrl_write(PCIE_INDIR_CTR, 0x12);
+	rtk_pci2_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+	rtk_pci2_ctrl_write(PCIE_CFG_ADDR, addr);
+	rtk_pci2_ctrl_write(PCIE_CFG_WDATA, data);
+
+	if (size == 4)
+		rtk_pci2_ctrl_write(PCIE_CFG_EN, 0x1);
+	else
+		rtk_pci2_ctrl_write(PCIE_CFG_EN, BYTE_CNT(mask) | BYTE_EN |
+			WRRD_EN(1));
+
+	rtk_pci2_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pci2_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (rtk_pci2_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR || try_count < 0) {
+		if (try_count < 0)
+		PCI_CFG_WARNING("Write config data (%p) failed - timeout\n",
+				(void *) addr);
+
+		PCI_CFG_WARNING("write config data failed - ");
+
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("tar abort\n");
+
+		retry++;
+		if (retry < 2) {
+			rtk_pci2_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+			goto write_resend;
+		} else {
+			goto error_occur;
+		}
+	}
+
+	rtk_pci2_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+
+	rtk_pci2_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SET_FAILED;
+}
+
+static int _indirect_cfg_read(unsigned long addr, u32 *pdata,
+	unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 20000;
+	int retry = 0;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+read_resend:
+	rtk_pci2_ctrl_write(PCIE_INDIR_CTR, 0x10);
+	rtk_pci2_ctrl_write(PCIE_CFG_ST, 0x3);
+	rtk_pci2_ctrl_write(PCIE_CFG_ADDR, (addr & ~0x3));
+	rtk_pci2_ctrl_write(PCIE_CFG_EN, BYTE_CNT(mask) | BYTE_EN |
+		WRRD_EN(0));
+	rtk_pci2_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pci2_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+
+	if (rtk_pci2_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR || try_count < 0) {
+		if (try_count < 0)
+			PCI_CFG_WARNING("Read config data (%p) failed - timeout\n", (void *) addr);
+
+		PCI_CFG_WARNING("read config data failed - ");
+
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("tar abort\n");
+
+		retry++;
+		if (retry < 2) {
+			rtk_pci2_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+			goto read_resend;
+		} else {
+			goto error_occur;
+		}
+	}
+
+	rtk_pci2_ctrl_write(PCIE_CFG_ST, 0x3);
+
+	*pdata = (rtk_pci2_ctrl_read(PCIE_CFG_RDATA) & _pci_bit_mask(mask))
+		>> _pci_bit_shift(addr);
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+	rtk_pci2_ctrl_write(PCIE_CFG_ST, 0x3);
+	return PCIBIOS_SET_FAILED;
+}
+
+static int rtk_pcie2_rd_conf(struct pci_bus *bus, unsigned int devfn,
+	int reg, int size, u32 *pval)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+	u32 val = 0;
+	u8 retry = 5;
+
+	if (rtk_cpu_revision == RTD129x_CHIP_REVISION_A00)
+		udelay(200);
+
+again:
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if (cfg_direct_access) {
+			rtk_pci2_ctrl_write(0xC00, 0x40012);
+
+			if (size == 1)
+				*pval = rtk_pci2_direct_cfg_read_byte(reg);
+			else if (size == 2)
+				*pval = rtk_pci2_direct_cfg_read_word(reg);
+			else if (size == 4)
+				*pval = rtk_pci2_direct_cfg_read(reg);
+
+			rtk_pci2_ctrl_write(0xC00, 0x1E0002);
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_read(address, pval, size);
+		}
+	}
+
+	val = rtk_pci2_ctrl_read(0xC7C);
+	if ((val & 0x1f) && retry) {
+		rtk_pci2_ctrl_write(0xC7C, val);
+		retry--;
+		dev_err(&bus->dev, "pcie2 dllp error occur = 0x%x\n", val);
+		goto again;
+	}
+
+#if 0
+	dev_info(&bus->dev, "%s reg = 0x%x, *pval = 0x%x\n",
+		__func__, reg, *pval);
+#endif
+
+	return ret;
+}
+
+static int rtk_pcie2_wr_conf(struct pci_bus *bus, unsigned int devfn,
+	int reg, int size, u32 val)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+
+#if 0
+	dev_info(&bus->dev, "%s reg = 0x%x, *pval = 0x%x\n",
+		__func__, reg, *pval);
+#endif
+
+	if (rtk_cpu_revision == RTD129x_CHIP_REVISION_A00)
+		udelay(200);
+
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if ((reg == 0x10) || (reg == 0x18) || (reg == 0x20) ||
+			(reg == 0x24)) {
+			if ((val & 0xc1000000) == 0xc1000000)
+				rtk_pci2_ctrl_write(0xD04, (val&0xfffffff0));
+		}
+
+		if (cfg_direct_access) {
+			rtk_pci2_ctrl_write(0xC00, 0x40012);
+
+			if (size == 1)
+				rtk_pci2_direct_cfg_write_byte(reg, val);
+			else if (size == 2)
+				rtk_pci2_direct_cfg_write_word(reg, val);
+			else if (size == 4)
+				rtk_pci2_direct_cfg_write(reg, val);
+
+			rtk_pci2_ctrl_write(0xC00, 0x1E0002);
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_write(address, val, size);
+		}
+	}
+
+	return ret;
+}
+
+static struct pci_ops rtk_pcie2_ops = {
+	.read = rtk_pcie2_rd_conf,
+	.write = rtk_pcie2_wr_conf,
+};
+
+static int rtk_pcie2_hw_initial(struct device *dev)
+{
+	bool pci_link_detected;
+	int timeout = 0;
+	int ret = 0;
+	u32 val;
+	u32 *phy;
+	int size = 0, i = 0;
+
+	if (rtk_cpu_revision == RTD129x_CHIP_REVISION_A00 ||
+		(rtk_cpu_id == RTK1296_CPU_ID &&
+		rtk_cpu_revision != RTD129x_CHIP_REVISION_B00)) {
+		/* 0x9801C614[2:0] = 1 */
+		val = readl(SYSTEM_BASE1 + 0x14);
+		val &= (~0x7);
+		val |= 0x1;
+		writel(val, SYSTEM_BASE1 + 0x14);
+
+		/* 0x9801C600[19:16] = 0  --PCIE2 */
+		val = readl(SYSTEM_BASE1);
+		val &= (~(0xf << 16));
+		writel(val, SYSTEM_BASE1);
+
+		/* 0x9801C608[7:0] = 8’b01010000 */
+		writeb(0x51, SYSTEM_BASE1 + 0x8);
+	}
+
+	reset_control_deassert(rstn_pcie1_stitch);
+	reset_control_deassert(rstn_pcie1);
+	reset_control_deassert(rstn_pcie1_core);
+	reset_control_deassert(rstn_pcie1_power);
+	reset_control_deassert(rstn_pcie1_nonstitch);
+	reset_control_deassert(rstn_pcie1_phy);
+	reset_control_deassert(rstn_pcie1_phy_mdio);
+	ret = clk_prepare_enable(pcie1_clk);
+
+	if (ret) {
+		dev_err(dev, "unable to enable pcie1_clk clock\n");
+		clk_disable_unprepare(pcie1_clk);
+		return -EINVAL;
+	}
+
+	rtk_pci2_ctrl_write(0xC00, 0x00140010);
+
+	if (speed_mode == 0) {
+		rtk_pci2_ctrl_write(0x0A0, (rtk_pci2_ctrl_read(0x0A0) &
+			0xFFFFFFF0) | 0x00000001);
+	}
+
+	/*phy mdio setting*/
+	size = of_property_count_u32_elems(dev->of_node, "phys");
+	phy = kmalloc(size * sizeof(u32), GFP_KERNEL);
+	of_property_read_u32_array(dev->of_node, "phys", phy, size);
+	for (i = 0; i < size; i++) {
+		rtk_pci2_ctrl_write(0xC1C, phy[i]);
+		mdelay(1);
+	}
+	kfree(phy);
+
+	/* after phy mdio set */
+	ret = gpio_direction_output(pcie_gpio_20, 0);
+	mdelay(100);
+	ret = gpio_direction_output(pcie_gpio_20, 1);
+
+	/* set to MMIO */
+	if (cfg_direct_access)
+		rtk_pci2_ctrl_write(0xC00, 0x00040012);
+	else
+		rtk_pci2_ctrl_write(0xC00, 0x001E0022);
+
+	mdelay(50);
+
+	/* #Link initial setting */
+	rtk_pci2_ctrl_write(0x710, 0x00010120);
+
+	do {
+		pci_link_detected = (rtk_pci2_ctrl_read(0xCB4) & 0x800);
+		if (!pci_link_detected) {
+			mdelay(TIMEOUT_RESOLUTION);
+			timeout += TIMEOUT_RESOLUTION;
+		}
+	} while (!pci_link_detected && timeout < PCIE_CONNECT_TIMEOUT);
+
+	if (pci_link_detected) {
+		dev_err(dev, "pcie device has link up in slot 2\n");
+	} else {
+		if (!debug_mode) { /*do not turn off clk in debug mode*/
+			reset_control_assert(rstn_pcie1_stitch);
+			reset_control_assert(rstn_pcie1);
+			reset_control_assert(rstn_pcie1_core);
+			reset_control_assert(rstn_pcie1_power);
+			reset_control_assert(rstn_pcie1_nonstitch);
+			reset_control_assert(rstn_pcie1_phy);
+			reset_control_assert(rstn_pcie1_phy_mdio);
+			clk_disable_unprepare(pcie1_clk);
+		}
+		gpio_free(pcie_gpio_20);
+		dev_err(dev, "pcie device has link down in slot 2\n");
+		return -ENODEV;
+	}
+
+	writel(readl(EMMC_MUXPAD + 0x61C) | 0x00000010, EMMC_MUXPAD + 0x61C);
+
+	/* make sure DBI is working */
+	rtk_pci2_ctrl_write(0x04, 0x00000007);
+
+	/* #Base */
+	rtk_pci2_ctrl_write(0xCFC, 0x9803C000);
+
+	/* #Mask */
+	rtk_pci2_ctrl_write(0xD00, 0xFFFFF000);
+
+	/* #translate for CFG R/W */
+	rtk_pci2_ctrl_write(0xD04, 0xC1000000);
+
+	/* prevent pcie hang if dllp error occur*/
+	rtk_pci2_ctrl_write(0xC78, 0x1000001);
+
+	/* set limit and base register */
+	rtk_pci2_ctrl_write(0x20, 0x0000FFF0);
+	rtk_pci2_ctrl_write(0x24, 0x0000FFF0);
+
+	return ret;
+}
+
+static int rtk_pcie2_probe(struct platform_device *pdev)
+{
+	int ret = 0;
+	int size = 0;
+	const u32 *prop, *prop2;
+	struct resource pcie_mmio_res;
+	resource_size_t iobase = 0;
+
+	LIST_HEAD(res);
+
+	local_pdev = pdev;
+	cfg_direct_access = false;
+
+	spin_lock_init(&rtk_pcie2_lock);
+
+	dev_info(&pdev->dev, "pcie host driver initial begin\n");
+
+	prop = of_get_property(pdev->dev.of_node, "speed-mode", &size);
+	if (prop) {
+		speed_mode = of_read_number(prop, 1);
+		if (speed_mode == 0)
+			dev_info(&pdev->dev, "speed mode: GEN1\n");
+		else if (speed_mode == 1)
+			dev_info(&pdev->dev, "speed mode: GEN2\n");
+	}
+
+	prop2 = of_get_property(pdev->dev.of_node, "debug-mode", &size);
+	if (prop2) {
+		debug_mode = of_read_number(prop2, 1);
+		if (debug_mode == 0)
+			dev_info(&pdev->dev, "PCIE Debug Mode off\n");
+		else if (debug_mode == 1)
+			dev_info(&pdev->dev, "PCIE Debug Mode on\n");
+	} else {
+		debug_mode = 0;
+	}
+
+	PCIE_CTRL_BASE = of_iomap(pdev->dev.of_node, 0);
+	if (!PCIE_CTRL_BASE) {
+		dev_err(&pdev->dev, "pcie no ctrl address\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	PCIE_CFG_BASE = of_iomap(pdev->dev.of_node, 1);
+	if (!PCIE_CFG_BASE) {
+		dev_err(&pdev->dev, "pcie no cfg address\n");
+		ret = -EINVAL;
+		goto err_out;
+	} else {
+		of_address_to_resource(pdev->dev.of_node, 1, &pcie_mmio_res);
+		PCIE_MMIO_PHY_ADDR = pcie_mmio_res.start;
+		PCIE_MMIO_PHY_ADDR_LEN = resource_size(&pcie_mmio_res);
+	}
+
+	SYSTEM_BASE1 = of_iomap(pdev->dev.of_node, 2);
+	if (!SYSTEM_BASE1) {
+		dev_err(&pdev->dev, "pcie no base1 address\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	SYSTEM_BASE2 = of_iomap(pdev->dev.of_node, 3);
+	if (!SYSTEM_BASE2) {
+		dev_err(&pdev->dev, "pcie no base2 address\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	EMMC_MUXPAD = of_iomap(pdev->dev.of_node, 4);
+	if (!EMMC_MUXPAD) {
+		dev_err(&pdev->dev, "can't request 'EMMC_MUXPAD' address\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	pcie_gpio_20 = of_get_gpio_flags(pdev->dev.of_node, 0, NULL);
+	if (gpio_is_valid(pcie_gpio_20)) {
+		ret = gpio_request(pcie_gpio_20, "pcie_gpio(20)");
+		if (ret < 0)
+			dev_err(&pdev->dev, "%s: can't request gpio %d\n",
+				__func__, pcie_gpio_20);
+	} else
+		dev_err(&pdev->dev, "%s: gpio %d is not valid\n",
+			__func__, pcie_gpio_20);
+
+	pcie1_clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(pcie1_clk)) {
+		dev_err(&pdev->dev,
+			"pcie 1 clock source missing or invalid\n");
+		return PTR_ERR(pcie1_clk);
+	}
+
+	rstn_pcie1_stitch = devm_reset_control_get(&pdev->dev, "stitch");
+	if (rstn_pcie1_stitch == NULL) {
+		dev_err(&pdev->dev, "stitch source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	rstn_pcie1 = devm_reset_control_get(&pdev->dev, "rstn");
+	if (rstn_pcie1 == NULL) {
+		dev_err(&pdev->dev, "rstn_pcie1 source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	rstn_pcie1_core = devm_reset_control_get(&pdev->dev, "core");
+	if (rstn_pcie1_core == NULL) {
+		dev_err(&pdev->dev, "core source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie1_power = devm_reset_control_get(&pdev->dev, "power");
+	if (rstn_pcie1_power == NULL) {
+		dev_err(&pdev->dev, "power source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	rstn_pcie1_nonstitch = devm_reset_control_get(&pdev->dev, "nonstitch");
+	if (rstn_pcie1_nonstitch == NULL) {
+		dev_err(&pdev->dev, "nonstitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie1_phy = devm_reset_control_get(&pdev->dev, "phy");
+	if (rstn_pcie1_phy == NULL) {
+		dev_err(&pdev->dev, "phy source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	rstn_pcie1_phy_mdio = devm_reset_control_get(&pdev->dev, "phy_mdio");
+	if (rstn_pcie1_phy_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing or invalid\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	reset_control_assert(rstn_pcie1_stitch);
+	reset_control_assert(rstn_pcie1);
+	reset_control_assert(rstn_pcie1_core);
+	reset_control_assert(rstn_pcie1_power);
+	reset_control_assert(rstn_pcie1_nonstitch);
+	reset_control_assert(rstn_pcie1_phy);
+	reset_control_assert(rstn_pcie1_phy_mdio);
+
+	rtk_cpu_id = get_rtd129x_cpu_id();
+	rtk_cpu_revision = get_rtd129x_cpu_revision();
+
+	if (rtk_pcie2_hw_initial(&pdev->dev) < 0) {
+		dev_err(&pdev->dev, "rtk_pcie2_hw_initial fail\n");
+		ret = -EINVAL;
+		goto err_out;
+	}
+
+	/* Register PCI-E host */
+	ret = of_pci_get_host_bridge_resources(pdev->dev.of_node, 0x1, 0xff,
+		&res, &iobase);
+	if (ret)
+		goto err_out;
+
+	bus = pci_create_root_bus(&pdev->dev, 1, &rtk_pcie2_ops, NULL, &res);
+
+	if (!bus) {
+		ret = -ENOMEM;
+		goto err_out;
+	}
+
+	pci_scan_child_bus(bus);
+	pci_assign_unassigned_bus_resources(bus);
+	pci_bus_add_devices(bus);
+
+	dev_info(&pdev->dev, "pcie host driver initial done\n");
+
+err_out:
+	return ret;
+}
+#ifdef CONFIG_SUSPEND
+static int rtk_pcie2_suspend(struct device *dev)
+{
+	dev_info(dev, "suspend enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pci2_ctrl_write(0x178, 0xA3FF0001);
+		rtk_pci2_ctrl_write(0x098, 0x400);
+		rtk_pci2_ctrl_write(0xC6C, 0x00000031);
+		dev_info(dev, "idle mode\n");
+	} else {
+		dev_info(dev, "suspend mode\n");
+		reset_control_assert(rstn_pcie1_stitch);
+		reset_control_assert(rstn_pcie1);
+		reset_control_assert(rstn_pcie1_core);
+		reset_control_assert(rstn_pcie1_power);
+		reset_control_assert(rstn_pcie1_nonstitch);
+		reset_control_assert(rstn_pcie1_phy);
+		reset_control_assert(rstn_pcie1_phy_mdio);
+		clk_disable_unprepare(pcie1_clk);
+		gpio_free(pcie_gpio_20);
+	}
+
+	dev_info(dev, "suspend exit ...\n");
+
+	return 0;
+}
+
+static int rtk_pcie2_resume(struct device *dev)
+{
+	int ret = 0;
+
+	dev_info(dev, "resume enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pci2_ctrl_write(0xC6C, 0x00000032);
+		dev_info(dev, "idle mode\n");
+	} else {
+		dev_info(dev, "suspend mode\n");
+		if (gpio_is_valid(pcie_gpio_20)) {
+			ret = gpio_request(pcie_gpio_20, "pcie_gpio(20)");
+			if (ret < 0)
+				pr_err("%s: can't request gpio %d\n",
+					__func__, pcie_gpio_20);
+		} else
+			pr_err("%s: gpio %d is not valid\n",
+				__func__, pcie_gpio_20);
+
+		reset_control_deassert(rstn_pcie1_stitch);
+		reset_control_deassert(rstn_pcie1);
+		reset_control_deassert(rstn_pcie1_core);
+		reset_control_deassert(rstn_pcie1_power);
+		reset_control_deassert(rstn_pcie1_nonstitch);
+		reset_control_deassert(rstn_pcie1_phy);
+		reset_control_deassert(rstn_pcie1_phy_mdio);
+		ret = clk_prepare_enable(pcie1_clk);
+		if (ret) {
+			dev_err(dev, "unable to enable pcie1_clk clock\n");
+			clk_disable_unprepare(pcie1_clk);
+			return -EINVAL;
+		}
+
+		ret = gpio_direction_output(pcie_gpio_20, 0);
+		mdelay(100);
+		/* Reset PCIE2 device, Pull high reset signal. */
+		ret = gpio_direction_output(pcie_gpio_20, 1);
+
+		if (rtk_pcie2_hw_initial(dev) < 0) {
+			dev_err(dev, "rtk_pcie2_hw_initial fail\n");
+			return -EINVAL;
+		}
+
+		if (cfg_direct_access)
+			rtk_pci2_ctrl_write(0xC00, 0x00040012);
+		else
+			rtk_pci2_ctrl_write(0xC00, 0x001E0022);
+	}
+
+	dev_info(dev, "resume exit ...\n");
+
+	return ret;
+}
+
+static const struct dev_pm_ops rtk_pcie2_pm_ops = {
+	.suspend_noirq = rtk_pcie2_suspend,
+	.resume_noirq = rtk_pcie2_resume,
+};
+#endif /* CONFIG_SUSPEND */
+static const struct of_device_id rtk_pcie2_match_table[] = {
+	{.compatible = "realtek,rtk-pcie-slot2",},
+	{},
+};
+
+static struct platform_driver rtk_pcie2_driver = {
+	.driver = {
+		.name = DEV_NAME,
+		.of_match_table = of_match_ptr(rtk_pcie2_match_table),
+#ifdef CONFIG_SUSPEND
+		.pm = &rtk_pcie2_pm_ops,
+#endif
+	},
+	.probe = rtk_pcie2_probe,
+};
+module_platform_driver(rtk_pcie2_driver);
+
+MODULE_AUTHOR("James Tai <james.tai@realtek.com>");
+MODULE_DESCRIPTION("Realtek PCIe host controller driver");
diff --git a/drivers/pci/host/pcie-rtd129x.h b/drivers/pci/host/pcie-rtd129x.h
new file mode 100644
index 00000000..8f106f7
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd129x.h
@@ -0,0 +1,301 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#ifndef RTK_PCIE_H_
+#define RTK_PCIE_H_
+
+#include <linux/of_platform.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of.h>
+
+#define PCI_INFO(fmt, args...) pr_info("[RTK PCIE] INFO," fmt, ## args)
+#define PCI_WARNING(fmt, args...) pr_warn("[RTK PCIE] WARNING," fmt, ## args)
+#define PCI_CFG_WARNING(fmt, args...) \
+	pr_alert("[RTK PCIE] CFG WARNING," fmt, ## args)
+
+/* SB2 for PCI */
+#define SB2_PCI_BASE0 0x00000030
+#define SB2_PCI_BASE1 0x00000034
+#define SB2_PCI_BASE2 0x00000038
+#define SB2_PCI_BASE3 0x0000003C
+#define SB2_PCI_MASK0 0x00000040
+#define SB2_PCI_MASK1 0x00000044
+#define SB2_PCI_MASK2 0x00000048
+#define SB2_PCI_MASK3 0x0000004C
+#define SB2_PCI_TRAN0 0x00000050
+#define SB2_PCI_TRAN1 0x00000054
+#define SB2_PCI_TRAN2 0x00000058
+#define SB2_PCI_TRAN3 0x0000005C
+#define SB2_PCI_CTRL 0x00000060
+
+/* PCIE Bridge */
+#define PCIE_SYS_CTR 0x00000C00U
+#define TRANS_EN (1 << 20)
+#define PHY_MMIO_TYPE (1 << 19)
+#define PHY_MDIO_OE (1 << 18)
+#define PHY_MDIO_RSTN (1 << 17)
+#define APP_INIT_RST (1 << 16)
+#define LOOPBACK_EN (1 << 9)
+#define DIR_REQ_INFO_EN (1 << 8)
+#define RX_LANE_REVERSAL_EN (1 << 7)
+#define TX_LANE_REVERSAL_EN (1 << 6)
+#define INDOR_CFG_EN (1 << 5)
+#define DIR_CFG_EN (1 << 4)
+#define RCV_ADDR0_EN (1 << 3)
+#define RCV_ADDR1_EN (1 << 2)
+#define APP_LTSSM_EN (1 << 1)
+#define RCV_TRANS_EN (1)
+
+#define DVR_INT_CTR 0x00000C04U
+#define DVR_GNR_INT 0x00000C08U
+
+#define S_INTP_PCIE_LEGACY_MSI_INT 14
+#define S_INTP_PM_TO_ACK_INT 13
+#define S_INTP_CFG_SYS_ERR_RC_INT 12
+#define S_INTP_PCIE_LEGACY_INT 11
+#define S_INTP_CFG_RSDM_VENDOR_MSG_INT 10
+#define S_INTP_CFG_PME_MSI 9
+#define S_INTP_CFG_PME_INT 8
+#define S_INTP_CFG_AER_RC_MSI 7
+#define S_INTP_CFG_AER_RC_ERR 6
+#define S_INTP_RTGT 5 /* Slave Receiver Interrupt */
+#define S_INTP_RCPL /* Master Receiver Interrupt */
+#define S_INTP_DIR_CFG 3 /* Direct CFG Interrupt */
+#define S_INTP_DIR_MIO 2 /* Direct MIO Interrupt */
+#define S_INTP_CFG 1 /* Indirect CFG Interrupt */
+#define S_INTP_MIO 0 /* Indirect MIO Interrupt */
+#define INTP_PCIE_LEGACY_MSI_INT (1 << INTP_PCIE_LEGACY_MSI_INT)
+#define INTP_PM_TO_ACK_INT (1 << INTP_PM_TO_ACK_INT)
+#define INTP_CFG_SYS_ERR_RC_INT (1 << INTP_CFG_SYS_ERR_RC_INT)
+#define INTP_PCIE_LEGACY_INT (1 << INTP_PCIE_LEGACY_INT)
+#define INTP_CFG_RSDM_VENDOR_MSG_INT (1 << INTP_CFG_RSDM_VENDOR_MSG_INT)
+#define INTP_CFG_PME_MSI (1 << INTP_CFG_PME_MSI)
+#define INTP_CFG_PME_INT (1 << INTP_CFG_PME_INT)
+#define INTP_CFG_AER_RC_MSI (1 << INTP_CFG_AER_RC_MSI)
+#define INTP_CFG_AER_RC_ERR (1 << INTP_CFG_AER_RC_ERR)
+#define INTP_RTGT (1 << INTP_RTGT)
+#define INTP_RCPL (1 << INTP_RCPL)
+#define INTP_DIR_CFG (1 << INTP_DIR_CFG)
+#define INTP_DIR_MIO (1 << INTP_DIR_MIO)
+#define INTP_CFG (1 << INTP_CFG)
+#define INTP_MIO (1 << INTP_MIO)
+
+#define DVR_PCIE_INT 0x00000C0CU
+#define PCIE_INTP_INTD (0x1U << 3)
+#define PCIE_INTP_INTC (0x1U << 2)
+#define PCIE_INTP_INTB (0x1U << 1)
+#define PCIE_INTP_INTA (0x1U)
+
+#define PCIE_DBI_CTR 0x00000C10U
+#define DBI_IO_ACCESS (0x1U << 9)
+#define DBI_ROM_ACCESS (0x1U << 8)
+#define DBI_BAR_NUM(x) ((x & 0x7) << 5)
+#define DBI_FUNC_NUM(x) ((x & 0x7) << 2)
+#define DBI_SC2_ACCESS (0x1U << 1)
+#define DBI_CMD_ACCESS (0x1U)
+
+#define PCIE_INDIR_CTR 0x00000C14
+#define PCIE_DIR_CTR 0x00000018U
+#define REQ_INFO_ALIGN (0x1U << 13)
+#define REQ_INFO_ATTR(x) ((x & 0x3) << 11)
+#define REQ_INFO_EP (0x1U << 10)
+#define REQ_INFO_TC(x) ((x & 0x7) << 7)
+#define REQ_INFO_TYPE(x) ((x & 0x1F) << 2)
+#define REQ_INFO_FMT(x) (x & 0x3)
+
+#define PCIE_MDIO_CTR 0x00000C1CU
+#define MDIO_DATA(x) ((x & 0xFFFF) << 16) /* MDIO Data */
+#define MDIO_PHY_ADDR(x) ((x & 0x7) << 13) /* MDIO PHY Address */
+#define MDIO_REG_ADDR(x) ((x & 0x1F) << 8) /* MDIO Register Address */
+#define MDIO_BUSY (0x1U << 7)
+#define MDIO_ST(x) ((x & 0x03) << 5) /* MDIO Host Control State Monitor */
+#define MDIO_RDY (0x1U << 4) /* MDIO PREAMBLE Signal Monitor */
+#define MDIO_RATE(x) ((x & 0x3) << 2) /* MDIO Clock Rate */
+#define CLK_SYS_1_32(x) 0 /* MDIO Clock Rate = 1/32 */
+#define CLK_SYS_1_16(x) 1 /* MDIO Clock Rate = 1/16 */
+#define CLK_SYS_1_8(x) 2 /* MDIO Clock Rate = 1/8 */
+#define CLK_SYS_1_4(x) 3 /* MDIO Clock Rate = 1/4 */
+#define MDIO_SRST (0x1U << 1)
+#define MDIO_RDWR(x) (x & 0x1) /* MDIO Read/Write : 0 read, 1 write */
+
+/*
+ * Address Translation
+ * PCI-E Bridge provides 2 set of control registers
+ * for inbound address translation
+ */
+#define PCIE_BASE0 0x00000C20U
+#define PCIE_BASE1 0x00000C24U
+#define PCIE_MASK0 0x00000C28U
+#define PCIE_MASK1 0x00000C2CU
+#define PCIE_TRAN0 0x00000C30U
+#define PCIE_TRAN1 0x00000C34U
+
+/*
+ * Configuration Access
+ * the following registers are used to access configuration
+ * space
+ */
+#define PCIE_CFG_CT 0x00000C38U
+#define GO_CT (0x1U)
+
+#define PCIE_CFG_EN 0x00000C3CU
+#define BUS_NUM(x) ((x & 0xFF) << 16) /* Bus number */
+#define DEV_NUM(x) ((x & 0xF) << 11) /* Device number */
+#define FUN_NUM(x) ((x & 0x7) << 8) /* Function number */
+#define BYTE_CNT(x) ((x & 0xF) << 4) /* Byte enable bits */
+#define ERROR_EN(x) ((x & 0x1) << 2) /* Enable error timeout counter */
+#define BYTE_EN (0x1 << 1) /* Byte enable bits enable */
+#define WRRD_EN(x) (x & 0x01)
+#define WRITE_CFG WRRD_EN(1)
+#define READ_CFG WRRD_EN(0)
+
+#define PCIE_CFG_ST 0x00000C40U
+#define CFG_ST_ERROR (0x1U << 1)
+#define CFG_ST_DONE 0x1U
+
+#define PCIE_CFG_ADDR 0x00000C44U
+#define PCIE_CFG_WDATA 0x00000C48U
+#define PCIE_CFG_RDATA 0x00000C4CU
+
+/*
+ * Memory / IO Access
+ * the following registers are used to access configuration
+ * space
+ */
+#define PCIE_MIO_CT 0x00000C50U
+#define PCIE_MIO_EN 0x00000C54U
+
+#define TIMEOUT_CNT_VAL(x) ((x & 0xFFFFFFF) << 8)
+
+#define PCIE_MIO_ST 0x00000C58U
+#define PCIE_MIO_ADDR 0x00000C5CU
+#define PCIE_MIO_WDATA 0x00000C60U
+#define PCIE_MIO_RDATA 0x00000C64U
+
+/* MISC */
+#define PCIE_CTR 0x00000C68U
+#define PCIE_PWR_CTR 0x00000C6CU
+#define PCIE_DBG 0x00000C70U
+#define PCIE_DIR_ST 0x00000C74U /* Status for Direct Access */
+#define CFG_RERROR_ST (0x1U << 1)
+#define MIO_RERROR_ST (0x1U)
+
+#define PCIE_DIR_EN 0x00000C78U
+#define TIMEOUT_EN (0x1U)
+
+#define PCIE_MAC_ST 0x00000CB4
+#define RDLH_LINK_UP (0x1U << 14)
+#define PM_XTLH_BLOCK_TLP (0x1U << 13)
+#define CFG_BUS_MASTER_EN (0x1U << 12)
+#define CFG_PM_NO_SOFT_RST (0x1U << 11)
+#define XMLH_LINK_UP (0x1U << 10)
+#define LINK_REQ_RST_NOT (0x1U << 9)
+#define XMLH_LTSSM_STATE(x) ((x & 0xF) << 4)
+#define PM_CURNT_STATE(x) ((x & 0x7) << 1)
+#define CFG_CLK_REQ_N (0x1U)
+
+/* PCI-E RC registers */
+#define PCI_CFG_REG 0x00000000U /* PCI compatible registers */
+#define PCIE_DEV_REG 0x00000040U /* PCI-E Device Configuration Space */
+#define PCIE_EXT_REG 0x00000100U /* PCI-E Extend Configuration Space */
+#define PCIE_DVR_REG 0x00000C00U /* DVR space register */
+
+#define CFG(addr) (PCI_CFG_REG + (addr))
+#define BAR1 0x10
+#define BAR2 0x14
+#define BAR3 0x18
+#define BAR4 0x1C
+
+#define CFG_ST_DETEC_PAR_ERROR (1 << 31)
+#define CFG_ST_SIGNAL_SYS_ERROR (1 << 30)
+#define CFG_ST_REC_MASTER_ABORT (1 << 29)
+#define CFG_ST_REC_TARGET_ABORT (1 << 28)
+#define CFG_ST_SIG_TAR_ABORT (1 << 27)
+
+#define TIMEOUT_RESOLUTION 1
+#define PCIE_CONNECT_TIMEOUT 60
+
+#define RBUS1_TIMEOUT(x) ((x & 0x7) << 2)
+#define RBUS_TIMEOUT(x) (x & 0x3)
+
+#define ADDR_TO_DEVICE_NO(addr) ((addr >> 19) & 0x1F)
+
+static unsigned long _pci_bit_mask(unsigned char byte_mask)
+{
+	int i;
+	unsigned long mask = 0;
+
+	for (i = 0; i < 4; i++) {
+		if ((byte_mask >> i) & 0x1)
+			mask |= (0xFF << (i << 3));
+	}
+
+	return mask;
+}
+
+static unsigned long _pci_bit_shift(unsigned long addr)
+{
+	return ((addr & 0x3) << 3);
+}
+
+static unsigned long _pci_byte_mask(unsigned long addr, unsigned char size)
+{
+	unsigned char offset = (addr & 0x03);
+
+	switch (size) {
+	case 0x01:
+		return 0x1 << offset;
+	case 0x02:
+		if (offset <= 2)
+			return 0x3 << offset;
+
+		PCI_CFG_WARNING(
+			"data cross dword boundrary (addr=%p, length=2)\n",
+			(void *) addr);
+
+		break;
+
+	case 0x03:
+		if (offset <= 1)
+			return 0x7 << offset;
+
+		PCI_CFG_WARNING(
+			"data cross dword boundrary (addr=%p, length=3)\n",
+			(void *) addr);
+		break;
+
+	case 0x04:
+		if (offset == 0)
+			return 0xF;
+
+		PCI_CFG_WARNING(
+			"data cross dword boundrary (addr=%p, length=4)\n",
+			(void *) addr);
+		break;
+
+	default:
+		PCI_CFG_WARNING("size %d should between 1~4\n", size);
+	}
+	return 0;
+}
+
+static unsigned long _pci_address_conversion(struct pci_bus *bus,
+	unsigned int devfn, int reg)
+{
+	int busno = bus->number;
+	int dev = PCI_SLOT(devfn);
+	int func = PCI_FUNC(devfn);
+
+	return (busno << 24) | (dev << 19) | (func << 16) | reg;
+}
+
+#endif /* RTK_PCIE_H_ */
diff --git a/drivers/pci/host/pcie-rtd139x.c b/drivers/pci/host/pcie-rtd139x.c
new file mode 100644
index 00000000..b314249
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd139x.c
@@ -0,0 +1,1002 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/gpio.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/of_gpio.h>
+#include <linux/of_address.h>
+#include <linux/of_pci.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <linux/pci.h>
+#include <linux/platform_device.h>
+#include <linux/resource.h>
+#include <linux/signal.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+#include <linux/suspend.h>
+#include <linux/kthread.h>
+#include <linux/spinlock.h>
+#include "pcie-rtd139x.h"
+
+
+spinlock_t rtk_pcie_139x_lock;
+#define PCIE_IO_2K_MASK  0xFFFFF800
+#define PCIE_IO_4K_MASK  0xFFFFF000
+#define PCIE_IO_64K_MASK 0xFFFF0000
+
+
+static void __iomem *PCIE_CTRL_BASE;
+static void __iomem *PCIE_CFG_BASE;
+
+
+static void __iomem *SYSTEM_BASE1;
+static void __iomem *SYSTEM_BASE2;
+
+
+static u32 PCIE_MMIO_PHY_ADDR;
+static u32 PCIE_MMIO_PHY_ADDR_LEN;
+
+static u32 pcie_gpio_29;
+
+
+static u32 speed_mode;
+static u32 debug_mode;
+
+
+#define cfg_direct_access false
+
+static struct clk *pcie_clk;
+static struct reset_control *rstn_pcie_stitch;
+static struct reset_control *rstn_pcie;
+static struct reset_control *rstn_pcie_core;
+static struct reset_control *rstn_pcie_power;
+static struct reset_control *rstn_pcie_nonstitch;
+static struct reset_control *rstn_pcie_phy;
+static struct reset_control *rstn_pcie_phy_mdio;
+static struct reset_control *rstn_pcie_sgmii_mdio;
+
+static struct pci_bus *bus;
+static struct platform_device *local_pdev;
+int irq;
+resource_size_t iobase = 0;
+
+
+
+
+static void rtk_pcie_139x_ctrl_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CTRL_BASE);
+}
+
+static unsigned int rtk_pcie_139x_ctrl_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CTRL_BASE);
+	return val;
+}
+
+static void rtk_pcie_139x_direct_cfg_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie_139x_direct_cfg_write_word(unsigned long addr, u16 val)
+{
+	writew(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie_139x_direct_cfg_write_byte(unsigned long addr, u8 val)
+{
+	writeb(val, addr + PCIE_CFG_BASE);
+}
+
+static unsigned int rtk_pcie_139x_direct_cfg_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u16 rtk_pcie_139x_direct_cfg_read_word(unsigned long addr)
+{
+	u16 val = readw(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u8 rtk_pcie_139x_direct_cfg_read_byte(unsigned long addr)
+{
+	u8 val = readb(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+
+u32 rtk_pcie_139x_mmio_start(void)
+{
+	return PCIE_MMIO_PHY_ADDR;
+}
+
+u32 rtk_pcie_139x_mmio_end(void)
+{
+	return (PCIE_MMIO_PHY_ADDR + (PCIE_MMIO_PHY_ADDR_LEN - 1));
+}
+
+u32 rtk_pcie_139x_mmio_len(void)
+{
+	return PCIE_MMIO_PHY_ADDR_LEN;
+}
+
+u32 rtk_pcie_139x_read(u32 addr, u8 size)
+{
+	u32 rval = 0;
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+	u32 pci_error_status = 0;
+	int retry_cnt = 0;
+	u8 retry = 5;
+
+	spin_lock_irqsave(&rtk_pcie_139x_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie_139x_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie_139x_ctrl_read(0xD04);
+		rtk_pcie_139x_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie_139x_ctrl_read(0xD04);
+		rtk_pcie_139x_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+
+pci_read_139x_retry:
+
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rval = rtk_pcie_139x_direct_cfg_read_byte((addr & ~mask));
+		break;
+	case 2:
+		rval = rtk_pcie_139x_direct_cfg_read_word((addr & ~mask));
+		break;
+	case 4:
+		rval = rtk_pcie_139x_direct_cfg_read((addr & ~mask));
+		break;
+	default:
+		pr_info("RTD139X: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	//DLLP error patch
+	pci_error_status = rtk_pcie_139x_ctrl_read(0xc7c);
+	if (pci_error_status & 0x1F) {
+		rtk_pcie_139x_ctrl_write(0xc7c, pci_error_status);
+		pr_info("RTD139X: %s: DLLP(#%d) 0x%x reg=0x%x val=0x%x\n",
+			__func__, retry_cnt, pci_error_status, addr, rval);
+
+		if (retry_cnt < retry) {
+			retry_cnt++;
+			goto pci_read_139x_retry;
+		}
+	}
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie_139x_ctrl_write(0xD04, translate_val);
+		rtk_pcie_139x_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie_139x_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie_139x_lock, irqL);
+
+	return rval;
+}
+EXPORT_SYMBOL(rtk_pcie_139x_read);
+
+void rtk_pcie_139x_write(u32 addr, u8 size, u32 wval)
+{
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+
+	spin_lock_irqsave(&rtk_pcie_139x_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie_139x_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie_139x_ctrl_read(0xD04);
+		rtk_pcie_139x_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie_139x_ctrl_read(0xD04);
+		rtk_pcie_139x_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rtk_pcie_139x_direct_cfg_write_byte((addr&~mask), wval);
+		break;
+	case 2:
+		rtk_pcie_139x_direct_cfg_write_word((addr&~mask), wval);
+		break;
+	case 4:
+		rtk_pcie_139x_direct_cfg_write((addr&~mask), wval);
+		break;
+	default:
+		pr_info("RTD139X: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie_139x_ctrl_write(0xD04, translate_val);
+		rtk_pcie_139x_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie_139x_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie_139x_lock, irqL);
+}
+EXPORT_SYMBOL(rtk_pcie_139x_write);
+
+static int _indirect_cfg_write(unsigned long addr,
+					unsigned long data,
+					unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 1000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	data = (data << _pci_bit_shift(addr)) & _pci_bit_mask(mask);
+
+	rtk_pcie_139x_ctrl_write(PCIE_INDIR_CTR, 0x12);
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_ADDR, addr);
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_WDATA, data);
+
+	if (size == 4)
+		rtk_pcie_139x_ctrl_write(PCIE_CFG_EN, 0x1);
+	else
+		rtk_pcie_139x_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(1));
+
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie_139x_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Write config data (%p) failed - timeout\n",
+				(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie_139x_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Write config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Write config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Write config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Write config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Write config data failed - tar abort\n");
+
+		goto error_occur;
+	}
+
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SET_FAILED;
+}
+
+static int _indirect_cfg_read(unsigned long addr, u32 *pdata,
+						unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 20000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+	rtk_pcie_139x_ctrl_write(PCIE_INDIR_CTR, 0x10);
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_ST, 0x3);
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_ADDR, (addr & ~0x3));
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(0));
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie_139x_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Read config data (%p) failed - timeout\n",
+								(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie_139x_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Read config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Read config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Read config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Read config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Read config data failed - tar abort\n");
+		goto error_occur;
+	}
+
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_ST, 0x3);
+
+	*pdata = (rtk_pcie_139x_ctrl_read(PCIE_CFG_RDATA) & _pci_bit_mask(mask))
+							>> _pci_bit_shift(addr);
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+	rtk_pcie_139x_ctrl_write(PCIE_CFG_ST, 0x3);
+	return PCIBIOS_SET_FAILED;
+}
+
+static int rtk_pcie_139x_rd_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 *pval)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+	u32 val = 0;
+	u8 retry = 5;
+
+again:
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if (cfg_direct_access) {
+
+			rtk_pcie_139x_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				*pval = rtk_pcie_139x_direct_cfg_read_byte(reg);
+			else if (size == 2)
+				*pval = rtk_pcie_139x_direct_cfg_read_word(reg);
+			else if (size == 4)
+				*pval = rtk_pcie_139x_direct_cfg_read(reg);
+
+			rtk_pcie_139x_ctrl_write(0xD00, 0xFFF00000);
+
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_read(address, pval, size);
+		}
+	}
+
+	val = rtk_pcie_139x_ctrl_read(0xC7C);
+	if ((val & 0x1f) && retry) {
+		rtk_pcie_139x_ctrl_write(0xC7C, val);
+		retry--;
+		dev_err(&bus->dev, "pcie dllp error occur = 0x%x\n", val);
+		goto again;
+	}
+
+	//dev_info(&bus->dev, "rtk_pcie_139x_rd_conf reg = 0x%x, devfun:%d, size=%d, *pval = 0x%x\n",
+	//							reg, devfn, size, *pval);
+
+	return ret;
+}
+
+static int rtk_pcie_139x_wr_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 val)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+
+
+	//dev_info(&bus->dev, "rtk_pcie_139x_wr_conf reg = 0x%x, val = 0x%x\n",
+	//							reg, val);
+
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if ((reg == 0x10) || (reg == 0x18) ||
+				(reg == 0x20) || (reg == 0x24)) {
+			if ((val & 0x98070000) == 0x98070000 || (val & 0x98060000) == 0x98060000 ) {
+				rtk_pcie_139x_ctrl_write(0xD04,
+						(val&0xfffffff0));
+			}
+		}
+
+		if (cfg_direct_access) {
+			rtk_pcie_139x_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				rtk_pcie_139x_direct_cfg_write_byte(reg, val);
+			else if (size == 2)
+				rtk_pcie_139x_direct_cfg_write_word(reg, val);
+			else if (size == 4)
+				rtk_pcie_139x_direct_cfg_write(reg, val);
+
+			rtk_pcie_139x_ctrl_write(0xD00, 0xFFF00000);
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_write(address, val, size);
+		}
+	}
+
+	return ret;
+}
+
+static struct pci_ops rtk_pcie_139x_ops = {
+	.read = rtk_pcie_139x_rd_conf,
+	.write = rtk_pcie_139x_wr_conf,
+};
+
+static int rtk_pcie_139x_hw_initial(struct device *dev)
+{
+	bool pci_link_detected;
+	int timeout = 0;
+	int ret = 0;
+	u32 val;
+	u32 *phy;
+	int size = 0, i = 0;
+
+	/* 0x9801C814[2:0] = 1 */
+	val = readl(SYSTEM_BASE1 + 0x14);
+	val &= (~0x7);
+	val |= 0x1;
+	writel(val, SYSTEM_BASE1 + 0x14);
+
+	/* 0x9801C804[3:0] = 0  --PCIE */
+	val = readl(SYSTEM_BASE1 + 0x4);
+	val &= (~0xf);
+	writel(val, SYSTEM_BASE1);
+
+	/* 0x9801C808[7:0] = 1 */
+	writeb(0x1, SYSTEM_BASE1 + 0x8);
+
+	reset_control_deassert(rstn_pcie_stitch);
+	reset_control_deassert(rstn_pcie);
+	reset_control_deassert(rstn_pcie_core);
+	reset_control_deassert(rstn_pcie_power);
+	reset_control_deassert(rstn_pcie_nonstitch);
+	reset_control_deassert(rstn_pcie_phy);
+	reset_control_deassert(rstn_pcie_phy_mdio);
+	reset_control_deassert(rstn_pcie_sgmii_mdio);
+
+	ret = clk_prepare_enable(pcie_clk);
+
+	if (ret) {
+		dev_err(dev, "unable to enable pcie1_clk clock\n");
+		clk_disable_unprepare(pcie_clk);
+		return -EINVAL;
+	}
+
+
+	rtk_pcie_139x_ctrl_write(0xC00, 0x00140010);
+
+	if (speed_mode == 0) {
+		rtk_pcie_139x_ctrl_write(0x0A0,
+			(rtk_pcie_139x_ctrl_read(0x0A0)&0xFFFFFFF0)|0x00000001);
+	}
+
+
+	/*phy mdio setting*/
+	size = of_property_count_u32_elems(dev->of_node, "phys");
+	phy = kmalloc(size * sizeof(u32), GFP_KERNEL);
+	of_property_read_u32_array(dev->of_node, "phys", phy, size);
+	for (i = 0; i < size; i++) {
+		rtk_pcie_139x_ctrl_write(0xC1C, phy[i]);
+		mdelay(1);
+	}
+	kfree(phy);
+
+	// after phy mdio set
+	ret = gpio_direction_output(pcie_gpio_29, 0);
+	mdelay(100);
+	ret = gpio_direction_output(pcie_gpio_29, 1);
+
+
+	/* set to MMIO */
+	if (cfg_direct_access)
+		rtk_pcie_139x_ctrl_write(0xC00, 0x00BE0002);
+	else
+		rtk_pcie_139x_ctrl_write(0xC00, 0x001E0022);
+
+	mdelay(50);
+
+	/* #Link initial setting */
+	rtk_pcie_139x_ctrl_write(0x710, 0x00010120);
+
+	do {
+		pci_link_detected = (rtk_pcie_139x_ctrl_read(0xCB4) & 0x800);
+		if (!pci_link_detected) {
+			mdelay(TIMEOUT_RESOLUTION);
+			timeout += TIMEOUT_RESOLUTION;
+		}
+	} while (!pci_link_detected && timeout < PCIE_CONNECT_TIMEOUT);
+
+	if (pci_link_detected) {
+		dev_err(dev, "PCIE device has link up in slot 2\n");
+	} else {
+		if (!debug_mode) { /*do not turn off clk in debug mode*/
+			reset_control_assert(rstn_pcie_stitch);
+			reset_control_assert(rstn_pcie);
+			reset_control_assert(rstn_pcie_core);
+			reset_control_assert(rstn_pcie_power);
+			reset_control_assert(rstn_pcie_nonstitch);
+			reset_control_assert(rstn_pcie_phy);
+			reset_control_assert(rstn_pcie_phy_mdio);
+			reset_control_assert(rstn_pcie_sgmii_mdio);
+			clk_disable_unprepare(pcie_clk);
+		}
+		gpio_free(pcie_gpio_29);
+
+		dev_err(dev, "PCIE device has link down in slot 2\n");
+		return -ENODEV;
+	}
+
+
+	/* make sure DBI is working */
+	rtk_pcie_139x_ctrl_write(0x04, 0x00000007);
+
+	if (cfg_direct_access) {
+		/* #Base 1 */
+		rtk_pcie_139x_ctrl_write(0xD08, 0x98061000);
+
+		/* #Mask 1 */
+		rtk_pcie_139x_ctrl_write(0xD0C, 0xFFFFF000);
+
+		/* #translate for CFG R/W */
+		rtk_pcie_139x_ctrl_write(0xD10, 0x00000000);
+	}
+	/* #Base 0 */
+	rtk_pcie_139x_ctrl_write(0xCFC, 0x98062000);
+
+	/* #Mask 0 */
+	rtk_pcie_139x_ctrl_write(0xD00, 0xFFF00000);
+
+	/* #translate for MMIO R/W */
+	rtk_pcie_139x_ctrl_write(0xD04, 0x00000000);
+
+#ifdef CONFIG_R8125
+	/*pcie timeout extend to 250us*/
+	rtk_pcie_139x_ctrl_write(0xC78, 0x7A1201);
+#else
+	/* prevent pcie hang if dllp error occur*/
+	rtk_pcie_139x_ctrl_write(0xC78, 0x200001);
+#endif
+	/* set limit and base register */
+	rtk_pcie_139x_ctrl_write(0x20, 0x0000FFF0);
+	rtk_pcie_139x_ctrl_write(0x24, 0x0000FFF0);
+
+	return ret;
+}
+
+#if defined(CONFIG_CPU_V7)
+static int __init rtk_pcie_setup(int nr, struct pci_sys_data *sys){
+
+	struct device *dev = sys->private_data;
+	int ret = 0;
+
+	sys->busnr = 1;
+	ret = of_pci_get_host_bridge_resources(dev->of_node,
+					0x1, 0xff, &sys->resources, &iobase);
+	if (ret) {
+		return ret;
+	}
+
+        return 1;
+}
+
+static int __init rtk_pcie_map_irq(const struct pci_dev *dev, u8 slot, u8 pin){
+        return irq;
+}
+
+
+/*static struct pci_bus *rtk_pcie_scan(int nr, struct pci_sys_data *sys) {
+	return pci_scan_bus(sys->busnr, &rtk_pcie_139x_ops, sys);
+}*/
+
+static struct hw_pci rtk_pci_hw __initdata = {
+        .nr_controllers = 1,
+        .setup = rtk_pcie_setup,
+        .map_irq = rtk_pcie_map_irq,
+        .ops = &rtk_pcie_139x_ops,
+};
+#endif
+
+static int rtk_pcie_139x_probe(struct platform_device *pdev)
+{
+	int ret = 0;
+	int size = 0;
+	const u32 *prop, *prop2;
+	struct resource pcie_mmio_res;
+	struct device *priv_dev;
+	LIST_HEAD(res);
+
+	local_pdev = pdev;
+
+	spin_lock_init(&rtk_pcie_139x_lock);
+
+	dev_info(&pdev->dev, "PCIE host driver initial begin.\n");
+
+	prop = of_get_property(pdev->dev.of_node, "speed-mode", &size);
+	if (prop) {
+		speed_mode = of_read_number(prop, 1);
+		if (speed_mode == 0)
+			dev_info(&pdev->dev, "Speed Mode: GEN1\n");
+		else if (speed_mode == 1)
+			dev_info(&pdev->dev, "Speed Mode: GEN2\n");
+	} else {
+		speed_mode = 0;
+	}
+
+	prop2 = of_get_property(pdev->dev.of_node, "debug-mode", &size);
+	if (prop2) {
+		debug_mode = of_read_number(prop2, 1);
+		if (debug_mode == 0)
+			dev_info(&pdev->dev, "PCIE Debug Mode off\n");
+		else if (debug_mode == 1)
+			dev_info(&pdev->dev, "PCIE Debug Mode on\n");
+	} else {
+		debug_mode = 0;
+	}
+
+	PCIE_CTRL_BASE = of_iomap(pdev->dev.of_node, 0);
+	if (!PCIE_CTRL_BASE) {
+		dev_err(&pdev->dev, "pcie no ctrl address\n");
+		return -EINVAL;
+	}
+
+	PCIE_CFG_BASE = of_iomap(pdev->dev.of_node, 1);
+	if (!PCIE_CFG_BASE) {
+		dev_err(&pdev->dev, "pcie no cfg address\n");
+		return -EINVAL;
+	} else {
+		of_address_to_resource(pdev->dev.of_node, 1, &pcie_mmio_res);
+		PCIE_MMIO_PHY_ADDR = pcie_mmio_res.start;
+		PCIE_MMIO_PHY_ADDR_LEN = resource_size(&pcie_mmio_res);
+	}
+
+
+	SYSTEM_BASE1 = of_iomap(pdev->dev.of_node, 2);
+	if (!SYSTEM_BASE1) {
+		dev_err(&pdev->dev, "pcie no base1 address\n");
+		return -EINVAL;
+	}
+
+	SYSTEM_BASE2 = of_iomap(pdev->dev.of_node, 3);
+	if (!SYSTEM_BASE2) {
+		dev_err(&pdev->dev, "pcie no base2 address\n");
+		return -EINVAL;
+	}
+
+
+
+	pcie_gpio_29 = of_get_gpio_flags(pdev->dev.of_node, 0, NULL);
+	if (gpio_is_valid(pcie_gpio_29)) {
+		ret = gpio_request(pcie_gpio_29, "pcie_gpio(29)");
+		if (ret < 0)
+			pr_err("%s: can't request gpio %d\n",
+						__func__, pcie_gpio_29);
+	} else {
+		pr_err("%s: gpio %d is not valid\n", __func__, pcie_gpio_29);
+	}
+
+	pcie_clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(pcie_clk)) {
+		dev_err(&pdev->dev, "pcie clock source missing or invalid\n");
+		return PTR_ERR(pcie_clk);
+	}
+
+	rstn_pcie_stitch = devm_reset_control_get(&pdev->dev, "stitch");
+	if (rstn_pcie_stitch == NULL) {
+		dev_err(&pdev->dev, "stitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie = devm_reset_control_get(&pdev->dev, "rstn");
+	if (rstn_pcie == NULL) {
+		dev_err(&pdev->dev, "rstn_pcie source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_core = devm_reset_control_get(&pdev->dev, "core");
+	if (rstn_pcie_core == NULL) {
+		dev_err(&pdev->dev, "core source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_power = devm_reset_control_get(&pdev->dev, "power");
+	if (rstn_pcie_power == NULL) {
+		dev_err(&pdev->dev, "power source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_nonstitch = devm_reset_control_get(&pdev->dev, "nonstitch");
+	if (rstn_pcie_nonstitch == NULL) {
+		dev_err(&pdev->dev, "nonstitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_phy = devm_reset_control_get(&pdev->dev, "phy");
+	if (rstn_pcie_phy == NULL) {
+		dev_err(&pdev->dev, "phy source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_phy_mdio = devm_reset_control_get(&pdev->dev, "phy_mdio");
+	if (rstn_pcie_phy_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing. or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_sgmii_mdio = devm_reset_control_get(&pdev->dev, "sgmii_mdio");
+	if (rstn_pcie_sgmii_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing. or invalid\n");
+		return -EINVAL;
+	}
+
+	reset_control_assert(rstn_pcie_stitch);
+	reset_control_assert(rstn_pcie);
+	reset_control_assert(rstn_pcie_core);
+	reset_control_assert(rstn_pcie_power);
+	reset_control_assert(rstn_pcie_nonstitch);
+	reset_control_assert(rstn_pcie_phy);
+	reset_control_assert(rstn_pcie_phy_mdio);
+	reset_control_assert(rstn_pcie_sgmii_mdio);
+
+
+	if (rtk_pcie_139x_hw_initial(&pdev->dev) < 0) {
+		dev_err(&pdev->dev, "rtk_pcie_139x_hw_initial fail\n");
+		return -EINVAL;
+	}
+
+	/*-------------------------------------------
+	 * Register PCI-E host
+	 *-------------------------------------------
+	 */
+
+#if defined(CONFIG_CPU_V7)
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	priv_dev = &pdev->dev;
+	rtk_pci_hw.private_data = (void **)&priv_dev;
+	pci_common_init_dev(&pdev->dev, &rtk_pci_hw);
+#else
+
+	ret = of_pci_get_host_bridge_resources(pdev->dev.of_node,
+					0x1, 0xff, &res, &iobase);
+	if (ret)
+		return ret;
+
+	bus = pci_create_root_bus(&pdev->dev, 1,
+				&rtk_pcie_139x_ops, NULL, &res);
+
+	if (!bus)
+		return -ENOMEM;
+
+	pci_scan_child_bus(bus);
+	pci_assign_unassigned_bus_resources(bus);
+	pci_bus_add_devices(bus);
+#endif
+	dev_info(&pdev->dev, "PCIE host driver initial done.\n");
+
+	return ret;
+}
+#ifdef CONFIG_SUSPEND
+static int rtk_pcie_139x_suspend(struct device *dev)
+{
+	dev_info(dev, "suspend enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie_139x_ctrl_write(0x178, 0xA3FF0001);
+		rtk_pcie_139x_ctrl_write(0x098, 0x400);
+		rtk_pcie_139x_ctrl_write(0xC6C, 0x00000031);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+
+		reset_control_assert(rstn_pcie_stitch);
+		reset_control_assert(rstn_pcie);
+		reset_control_assert(rstn_pcie_core);
+		reset_control_assert(rstn_pcie_power);
+		reset_control_assert(rstn_pcie_nonstitch);
+		reset_control_assert(rstn_pcie_phy);
+		reset_control_assert(rstn_pcie_phy_mdio);
+		reset_control_assert(rstn_pcie_sgmii_mdio);
+		clk_disable_unprepare(pcie_clk);
+		gpio_free(pcie_gpio_29);
+
+	}
+
+	dev_info(dev, "suspend exit ...\n");
+
+	return 0;
+}
+
+static int rtk_pcie_139x_resume(struct device *dev)
+{
+	int ret = 0;
+
+	dev_info(dev, "resume enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie_139x_ctrl_write(0xC6C, 0x00000032);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+		if (gpio_is_valid(pcie_gpio_29)) {
+			ret = gpio_request(pcie_gpio_29, "pcie_gpio(29)");
+			if (ret < 0)
+				pr_err("%s: can't request gpio %d\n",
+						__func__, pcie_gpio_29);
+		} else
+			pr_err("%s: gpio %d is not valid\n",
+						__func__, pcie_gpio_29);
+
+		reset_control_deassert(rstn_pcie_stitch);
+		reset_control_deassert(rstn_pcie);
+		reset_control_deassert(rstn_pcie_core);
+		reset_control_deassert(rstn_pcie_power);
+		reset_control_deassert(rstn_pcie_nonstitch);
+		reset_control_deassert(rstn_pcie_phy);
+		reset_control_deassert(rstn_pcie_phy_mdio);
+		reset_control_deassert(rstn_pcie_sgmii_mdio);
+		ret = clk_prepare_enable(pcie_clk);
+		if (ret) {
+			dev_err(dev, "unable to enable pcie_clk clock\n");
+			clk_disable_unprepare(pcie_clk);
+			return -EINVAL;
+		}
+		ret = gpio_direction_output(pcie_gpio_29, 0);
+		mdelay(100);
+		/*Reset PCIE device, Pull high reset signal.*/
+		ret = gpio_direction_output(pcie_gpio_29, 1);
+
+		if (rtk_pcie_139x_hw_initial(dev) < 0) {
+			dev_err(dev, "rtk_pcie_139x_hw_initial fail\n");
+			return -EINVAL;
+		}
+
+
+		if (cfg_direct_access)
+			rtk_pcie_139x_ctrl_write(0xC00, 0x00BE0002);
+		else
+			rtk_pcie_139x_ctrl_write(0xC00, 0x001E0022);
+	}
+
+	dev_info(dev, "resume exit ...\n");
+
+	return ret;
+}
+
+static void rtk_pcie_139x_shutdown(struct platform_device *pdev)
+{
+	dev_info(&pdev->dev, "shutdown enter ...\n");
+
+	dev_info(&pdev->dev, "shutdown mode\n");
+
+	reset_control_assert(rstn_pcie_stitch);
+	reset_control_assert(rstn_pcie);
+	reset_control_assert(rstn_pcie_core);
+	reset_control_assert(rstn_pcie_power);
+	reset_control_assert(rstn_pcie_nonstitch);
+	reset_control_assert(rstn_pcie_phy);
+	reset_control_assert(rstn_pcie_phy_mdio);
+	reset_control_assert(rstn_pcie_sgmii_mdio);
+	clk_disable_unprepare(pcie_clk);
+	gpio_free(pcie_gpio_29);
+
+	dev_info(&pdev->dev, "shutdown exit ...\n");
+}
+
+
+static const struct dev_pm_ops rtk_pcie_139x_pm_ops = {
+	.suspend_noirq = rtk_pcie_139x_suspend,
+	.resume_noirq = rtk_pcie_139x_resume,
+};
+#endif //CONFIG_SUSPEND
+static const struct of_device_id rtk_pcie_139x_match_table[] = {
+	{.compatible = "realtek,rtk139x-pcie",},
+	{},
+};
+
+static struct platform_driver rtk_pcie_139x_driver = {
+	.driver = {
+		.name = "[RTD139x PCIE]",
+		.of_match_table = of_match_ptr(rtk_pcie_139x_match_table),
+#ifdef CONFIG_SUSPEND
+		.pm = &rtk_pcie_139x_pm_ops,
+#endif
+	},
+	.probe = rtk_pcie_139x_probe,
+	.shutdown = rtk_pcie_139x_shutdown,
+};
+module_platform_driver(rtk_pcie_139x_driver);
+
+MODULE_AUTHOR("James Tai <james.tai@realtek.com>");
+MODULE_DESCRIPTION("Realtek PCIe host controller driver");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/pci/host/pcie-rtd139x.h b/drivers/pci/host/pcie-rtd139x.h
new file mode 100644
index 00000000..67553b1
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd139x.h
@@ -0,0 +1,330 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+#ifndef RTK_PCIE_139x_H_
+#define RTK_PCIE_139x_H_
+
+#include <linux/of_platform.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of.h>
+
+/* SB2 for PCI */
+#define PCI_PRINT printk
+
+#ifdef PCI_DBG_EN
+#define PCI_DBG(fmt, args...) \
+	pr_info("[RTD139x PCIE] DBG, " fmt, ## args)
+#else
+#define PCI_DBG(fmt, args...) \
+do { \
+} while (0)
+#endif
+
+#define PCI_INFO(fmt, args...) \
+	pr_info("[RTD139x PCIE] INFO," fmt, ## args)
+#define PCI_WARNING(fmt, args...) \
+	pr_info("[RTD139x PCIE] WARNING," fmt, ## args)
+
+#ifdef PCI_REG_DBG_EN
+#define PCI_REG_DBG(fmt, args...) \
+	pr_info("[RTD139x PCIE] REG DBG," fmt, ## args)
+#else
+#define PCI_REG_DBG(fmt, args...) \
+do { \
+} while (0)
+#endif
+
+#ifdef PCI_CFG_DBG_EN
+#define PCI_CFG_DBG(fmt, args...) \
+	pr_info("[RTD139x PCIE] CFG DBG," fmt, ## args)
+#else
+#define PCI_CFG_DBG(fmt, args...) do {} while (0)
+#endif
+
+#define PCI_CFG_WARNING(fmt, args...) pr_alert("[RTD139x PCIE] CFG WARNING," fmt, ## args)
+
+/* SB2 for PCI */
+#define SB2_PCI_BASE0 0x00000030
+#define SB2_PCI_BASE1 0x00000034
+#define SB2_PCI_BASE2 0x00000038
+#define SB2_PCI_BASE3 0x0000003C
+#define SB2_PCI_MASK0 0x00000040
+#define SB2_PCI_MASK1 0x00000044
+#define SB2_PCI_MASK2 0x00000048
+#define SB2_PCI_MASK3 0x0000004C
+#define SB2_PCI_TRAN0 0x00000050
+#define SB2_PCI_TRAN1 0x00000054
+#define SB2_PCI_TRAN2 0x00000058
+#define SB2_PCI_TRAN3 0x0000005C
+#define SB2_PCI_CTRL 0x00000060
+
+/*
+ * PCI-DVR Bridge
+ */
+#define PCIE_SYS_CTR 0x00000C00U
+#define TRANS_EN (1 << 20)
+#define PHY_MMIO_TYPE (1 << 19)
+#define PHY_MDIO_OE (1 << 18)
+#define PHY_MDIO_RSTN (1 << 17)
+#define APP_INIT_RST (1 << 16)
+#define LOOPBACK_EN (1 << 9)
+#define DIR_REQ_INFO_EN (1 << 8)
+#define RX_LANE_REVERSAL_EN (1 << 7)
+#define TX_LANE_REVERSAL_EN (1 << 6)
+#define INDOR_CFG_EN (1 << 5)
+#define DIR_CFG_EN (1 << 4)
+#define RCV_ADDR0_EN (1 << 3)
+#define RCV_ADDR1_EN (1 << 2)
+#define APP_LTSSM_EN (1 << 1)
+#define RCV_TRANS_EN (1)
+
+#define DVR_INT_CTR 0x00000C04U
+
+#define DVR_GNR_INT 0x00000C08U
+#define S_INTP_PCIE_LEGACY_MSI_INT 14
+#define S_INTP_PM_TO_ACK_INT 13
+#define S_INTP_CFG_SYS_ERR_RC_INT 12
+#define S_INTP_PCIE_LEGACY_INT 11
+#define S_INTP_CFG_RSDM_VENDOR_MSG_INT 10
+#define S_INTP_CFG_PME_MSI 9
+#define S_INTP_CFG_PME_INT 8
+#define S_INTP_CFG_AER_RC_MSI 7
+#define S_INTP_CFG_AER_RC_ERR 6
+#define S_INTP_RTGT 5 /* Slave Receiver Interrupt */
+#define S_INTP_RCPL 4 /* Master Receiver Interrupt */
+#define S_INTP_DIR_CFG 3 /* Direct CFG Interrupt */
+#define S_INTP_DIR_MIO 2 /* Direct MIO Interrupt */
+#define S_INTP_CFG 1 /* Indirect CFG Interrupt */
+#define S_INTP_MIO 0 /* Indirect MIO Interrupt */
+#define INTP_PCIE_LEGACY_MSI_INT (1 << INTP_PCIE_LEGACY_MSI_INT)
+#define INTP_PM_TO_ACK_INT (1 << INTP_PM_TO_ACK_INT)
+#define INTP_CFG_SYS_ERR_RC_INT (1 << INTP_CFG_SYS_ERR_RC_INT)
+#define INTP_PCIE_LEGACY_INT (1 << INTP_PCIE_LEGACY_INT)
+#define INTP_CFG_RSDM_VENDOR_MSG_INT (1 << INTP_CFG_RSDM_VENDOR_MSG_INT)
+#define INTP_CFG_PME_MSI (1 << INTP_CFG_PME_MSI)
+#define INTP_CFG_PME_INT (1 << INTP_CFG_PME_INT)
+#define INTP_CFG_AER_RC_MSI (1 << INTP_CFG_AER_RC_MSI)
+#define INTP_CFG_AER_RC_ERR (1 << INTP_CFG_AER_RC_ERR)
+#define INTP_RTGT (1 << INTP_RTGT)
+#define INTP_RCPL (1 << INTP_RCPL)
+#define INTP_DIR_CFG (1 << INTP_DIR_CFG)
+#define INTP_DIR_MIO (1 << INTP_DIR_MIO)
+#define INTP_CFG (1 << INTP_CFG)
+#define INTP_MIO (1 << INTP_MIO)
+
+#define DVR_PCIE_INT 0x00000C0CU
+#define PCIE_INTP_INTD (0x1U << 3)
+#define PCIE_INTP_INTC (0x1U << 2)
+#define PCIE_INTP_INTB (0x1U << 1)
+#define PCIE_INTP_INTA (0x1U)
+
+#define PCIE_DBI_CTR 0x00000C10U
+#define DBI_IO_ACCESS (0x1U << 9)
+#define DBI_ROM_ACCESS (0x1U << 8)
+#define DBI_BAR_NUM(x) ((x & 0x7) << 5)
+#define DBI_FUNC_NUM(x) ((x & 0x7) << 2)
+#define DBI_SC2_ACCESS (0x1U << 1)
+#define DBI_CMD_ACCESS (0x1U)
+
+#define PCIE_INDIR_CTR 0x00000C14
+#define PCIE_DIR_CTR 0x00000018U
+#define REQ_INFO_ALIGN (0x1U << 13)
+#define REQ_INFO_ATTR(x) ((x & 0x3) << 11)
+#define REQ_INFO_EP (0x1U << 10)
+#define REQ_INFO_TC(x) ((x & 0x7) << 7)
+#define REQ_INFO_TYPE(x) ((x & 0x1F) << 2)
+#define REQ_INFO_FMT(x) (x & 0x3)
+
+#define PCIE_MDIO_CTR 0x00000C1CU
+#define MDIO_DATA(x) ((x & 0xFFFF) << 16) /* MDIO Data */
+#define MDIO_PHY_ADDR(x) ((x & 0x7) << 13) /* MDIO PHY Address */
+#define MDIO_REG_ADDR(x) ((x & 0x1F) << 8) /* MDIO Register Address */
+#define MDIO_BUSY (0x1U << 7)
+#define MDIO_ST(x) ((x & 0x03) << 5) /* MDIO Host Control State Monitor */
+#define MDIO_RDY (0x1U << 4) /* MDIO PREAMBLE Signal Monitor */
+#define MDIO_RATE(x) ((x & 0x3) << 2) /* MDIO Clock Rate */
+#define CLK_SYS_1_32(x) 0 /* MDIO Clock Rate = 1/32 */
+#define CLK_SYS_1_16(x) 1 /* MDIO Clock Rate = 1/16 */
+#define CLK_SYS_1_8(x) 2 /* MDIO Clock Rate = 1/8 */
+#define CLK_SYS_1_4(x) 3 /* MDIO Clock Rate = 1/4 */
+#define MDIO_SRST (0x1U << 1)
+#define MDIO_RDWR(x) (x & 0x1) /* MDIO Read/Write : 0 read, 1 write */
+
+/*
+ * Address Translation
+ * PCI-E Bridge provides 2 set of control registers
+ * for in-bound address translation
+ */
+#define PCIE_BASE0 0x00000C20U
+#define PCIE_BASE1 0x00000C24U
+#define PCIE_MASK0 0x00000C28U
+#define PCIE_MASK1 0x00000C2CU
+#define PCIE_TRAN0 0x00000C30U
+#define PCIE_TRAN1 0x00000C34U
+
+/*
+ * Configuration Access
+ * the following registers are used to access configuration
+ * space
+ */
+#define PCIE_CFG_CT 0x00000C38U
+#define GO_CT (0x1U)
+
+#define PCIE_CFG_EN 0x00000C3CU
+#define BUS_NUM(x) ((x & 0xFF) << 16) /* Bus number */
+#define DEV_NUM(x) ((x & 0xF) << 11) /* Device number */
+#define FUN_NUM(x) ((x & 0x7) << 8) /* Function number */
+#define BYTE_CNT(x) ((x & 0xF) << 4) /* Byte enable bits */
+#define ERROR_EN(x) ((x & 0x1) << 2) /* Enable error timeout counter */
+#define BYTE_EN (0x1 << 1) /* Byte enable bits enable */
+#define WRRD_EN(x) (x & 0x01)
+#define WRITE_CFG WRRD_EN(1)
+#define READ_CFG WRRD_EN(0)
+
+#define PCIE_CFG_ST 0x00000C40U
+#define CFG_ST_ERROR (0x1U << 1)
+#define CFG_ST_DONE 0x1U
+
+#define PCIE_CFG_ADDR 0x00000C44U
+#define PCIE_CFG_WDATA 0x00000C48U
+#define PCIE_CFG_RDATA 0x00000C4CU
+
+/*
+ * Memory / IO Access
+ * the following registers are used to access configuration
+ * space
+ */
+#define PCIE_MIO_CT 0x00000C50U
+#define PCIE_MIO_EN 0x00000C54U
+
+#define TIMEOUT_CNT_VAL(x) ((x & 0xFFFFFFF) << 8)
+
+#define PCIE_MIO_ST 0x00000C58U
+#define PCIE_MIO_ADDR 0x00000C5CU
+#define PCIE_MIO_WDATA 0x00000C60U
+#define PCIE_MIO_RDATA 0x00000C64U
+
+/*
+ * MISC
+ */
+#define PCIE_CTR 0x00000C68U
+#define PCIE_PWR_CTR 0x00000C6CU
+#define PCIE_DBG 0x00000C70U
+#define PCIE_DIR_ST 0x00000C74U /* Status for Direct Access */
+#define CFG_RERROR_ST (0x1U << 1)
+#define MIO_RERROR_ST (0x1U)
+
+#define PCIE_DIR_EN 0x00000C78U
+#define TIMEOUT_EN (0x1U)
+
+#define PCIE_MAC_ST 0x00000CB4
+#define RDLH_LINK_UP (0x1U << 14)
+#define PM_XTLH_BLOCK_TLP (0x1U << 13)
+#define CFG_BUS_MASTER_EN (0x1U << 12)
+#define CFG_PM_NO_SOFT_RST (0x1U << 11)
+#define XMLH_LINK_UP (0x1U << 10)
+#define LINK_REQ_RST_NOT (0x1U << 9)
+#define XMLH_LTSSM_STATE(x) ((x & 0xF) << 4)
+#define PM_CURNT_STATE(x) ((x & 0x7) << 1)
+#define CFG_CLK_REQ_N (0x1U)
+
+/*
+ * PCI-E RC registers
+ */
+#define PCI_CFG_REG 0x00000000U /* PCI compatible registers */
+#define PCIE_DEV_REG 0x00000040U /* PCI-E Device Configuration Space */
+#define PCIE_EXT_REG 0x00000100U /* PCI-E Extend Configuration Space */
+#define PCIE_DVR_REG 0x00000C00U /* DVR space register */
+
+#define CFG(addr) (PCI_CFG_REG + (addr))
+#define BAR1 0x10
+#define BAR2 0x14
+#define BAR3 0x18
+#define BAR4 0x1C
+
+#define CFG_ST_DETEC_PAR_ERROR (1 << 31)
+#define CFG_ST_SIGNAL_SYS_ERROR (1 << 30)
+#define CFG_ST_REC_MASTER_ABORT (1 << 29)
+#define CFG_ST_REC_TARGET_ABORT (1 << 28)
+#define CFG_ST_SIG_TAR_ABORT (1 << 27)
+
+#define TIMEOUT_RESOLUTION 1
+#define PCIE_CONNECT_TIMEOUT 60
+
+#define RBUS1_TIMEOUT(x) ((x & 0x7) << 2)
+#define RBUS_TIMEOUT(x) (x & 0x3)
+
+#define ADDR_TO_DEVICE_NO(addr) ((addr >> 19) & 0x1F)
+
+static unsigned long _pci_bit_mask(unsigned char byte_mask)
+{
+	int i;
+	unsigned long mask = 0;
+
+	for (i = 0; i < 4; i++) {
+		if ((byte_mask >> i) & 0x1)
+			mask |= (0xFF << (i << 3));
+	}
+
+	return mask;
+}
+
+static unsigned long _pci_bit_shift(unsigned long addr)
+{
+	return ((addr & 0x3) << 3);
+}
+
+static unsigned long _pci_byte_mask(unsigned long addr, unsigned char size)
+{
+	unsigned char offset = (addr & 0x03);
+
+	switch (size) {
+	case 0x01:
+		return 0x1 << offset;
+	case 0x02:
+		if (offset <= 2)
+			return 0x3 << offset;
+
+		PCI_CFG_WARNING("compute config mask - data cross dword boundrary (addr=%p, length=2)\n", (void *) addr);
+
+		break;
+
+	case 0x03:
+		if (offset <= 1)
+			return 0x7 << offset;
+
+		PCI_CFG_WARNING("compute config mask - data cross dword boundrary (addr=%p, length=3)\n", (void *) addr);
+		break;
+
+	case 0x04:
+		if (offset == 0)
+			return 0xF;
+
+		PCI_CFG_WARNING("compute config mask - data cross dword boundrary (addr=%p, length=4)\n", (void *) addr);
+		break;
+
+	default:
+		PCI_CFG_WARNING("compute config mask failed - size %d should between 1~4\n", size);
+	}
+	return 0;
+}
+
+static unsigned long _pci_address_conversion(struct pci_bus *bus,
+						unsigned int devfn, int reg)
+{
+	int busno = bus->number;
+	int dev = PCI_SLOT(devfn);
+	int func = PCI_FUNC(devfn);
+
+	return (busno << 24) | (dev << 19) | (func << 16) | reg;
+}
+
+#endif /* RTK_PCIE_139x_H_ */
diff --git a/drivers/pci/host/pcie-rtd13xx-slot1.c b/drivers/pci/host/pcie-rtd13xx-slot1.c
new file mode 100644
index 00000000..3a3cd20
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd13xx-slot1.c
@@ -0,0 +1,1147 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/gpio.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/of_gpio.h>
+#include <linux/of_address.h>
+#include <linux/of_pci.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <linux/pci.h>
+#include <linux/platform_device.h>
+#include <linux/resource.h>
+#include <linux/signal.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+#include <linux/suspend.h>
+#include <linux/kthread.h>
+#include <linux/spinlock.h>
+#include "pcie-rtd13xx.h"
+
+
+spinlock_t rtk_pcie_13xx_lock;
+#define PCIE_IO_2K_MASK  0xFFFFF800
+#define PCIE_IO_4K_MASK  0xFFFFF000
+#define PCIE_IO_64K_MASK 0xFFFF0000
+
+
+static void __iomem *PCIE_CTRL_BASE;
+static void __iomem *PCIE_CFG_BASE;
+
+
+static void __iomem *SYSTEM_BASE1;
+static void __iomem *USB_PCIE_PHY;
+
+
+static u32 PCIE_MMIO_PHY_ADDR;
+static u32 PCIE_MMIO_PHY_ADDR_LEN;
+
+static u32 pcie_gpio;
+
+
+static u32 speed_mode;
+static u32 debug_mode;
+
+
+#define cfg_direct_access false
+
+static struct clk *pcie_clk;
+static struct reset_control *rstn_pcie_stitch;
+static struct reset_control *rstn_pcie;
+static struct reset_control *rstn_pcie_core;
+static struct reset_control *rstn_pcie_power;
+static struct reset_control *rstn_pcie_nonstitch;
+static struct reset_control *rstn_pcie_phy;
+static struct reset_control *rstn_pcie_phy_mdio;
+static struct reset_control *rstn_pcie_sgmii_mdio;
+
+static struct pci_bus *bus;
+static struct platform_device *local_pdev;
+
+#ifdef CONFIG_PCI_MSI
+#define MAX_RTK_MSI_IRQS 16
+#define MAX_RTK_MSI_CTRLS	(MAX_RTK_MSI_IRQS / 16)
+struct irq_domain *rtk_msi_domain;
+struct mutex		msi_lock;
+DECLARE_BITMAP(rtk_pcie0_irq_bitmap, MAX_RTK_MSI_IRQS);
+unsigned int *pcie_msi_data;
+dma_addr_t dma_handle;
+
+#endif
+
+
+static void rtk_pcie_13xx_ctrl_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CTRL_BASE);
+}
+
+static unsigned int rtk_pcie_13xx_ctrl_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CTRL_BASE);
+	return val;
+}
+
+static void rtk_pcie_13xx_direct_cfg_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie_13xx_direct_cfg_write_word(unsigned long addr, u16 val)
+{
+	writew(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie_13xx_direct_cfg_write_byte(unsigned long addr, u8 val)
+{
+	writeb(val, addr + PCIE_CFG_BASE);
+}
+
+static unsigned int rtk_pcie_13xx_direct_cfg_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u16 rtk_pcie_13xx_direct_cfg_read_word(unsigned long addr)
+{
+	u16 val = readw(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u8 rtk_pcie_13xx_direct_cfg_read_byte(unsigned long addr)
+{
+	u8 val = readb(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+
+u32 rtk_pcie_13xx_mmio_start(void)
+{
+	return PCIE_MMIO_PHY_ADDR;
+}
+
+u32 rtk_pcie_13xx_mmio_end(void)
+{
+	return (PCIE_MMIO_PHY_ADDR + (PCIE_MMIO_PHY_ADDR_LEN - 1));
+}
+
+u32 rtk_pcie_13xx_mmio_len(void)
+{
+	return PCIE_MMIO_PHY_ADDR_LEN;
+}
+
+u32 rtk_pcie_13xx_read(u32 addr, u8 size)
+{
+	u32 rval = 0;
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+	u32 pci_error_status = 0;
+	int retry_cnt = 0;
+	u8 retry = 5;
+
+	spin_lock_irqsave(&rtk_pcie_13xx_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie_13xx_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie_13xx_ctrl_read(0xD04);
+		rtk_pcie_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie_13xx_ctrl_read(0xD04);
+		rtk_pcie_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+
+pci_read_13xx_retry:
+
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rval = rtk_pcie_13xx_direct_cfg_read_byte((addr & ~mask));
+		break;
+	case 2:
+		rval = rtk_pcie_13xx_direct_cfg_read_word((addr & ~mask));
+		break;
+	case 4:
+		rval = rtk_pcie_13xx_direct_cfg_read((addr & ~mask));
+		break;
+	default:
+		pr_info("RTD13xx: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	//DLLP error patch
+	pci_error_status = rtk_pcie_13xx_ctrl_read(0xc7c);
+	if (pci_error_status & 0x1F) {
+		rtk_pcie_13xx_ctrl_write(0xc7c, pci_error_status);
+		pr_info("RTD13xx: %s: DLLP(#%d) 0x%x reg=0x%x val=0x%x\n",
+			__func__, retry_cnt, pci_error_status, addr, rval);
+
+		if (retry_cnt < retry) {
+			retry_cnt++;
+			goto pci_read_13xx_retry;
+		}
+	}
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie_13xx_ctrl_write(0xD04, translate_val);
+		rtk_pcie_13xx_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie_13xx_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie_13xx_lock, irqL);
+
+	return rval;
+}
+EXPORT_SYMBOL(rtk_pcie_13xx_read);
+
+void rtk_pcie_13xx_write(u32 addr, u8 size, u32 wval)
+{
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+
+	spin_lock_irqsave(&rtk_pcie_13xx_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie_13xx_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie_13xx_ctrl_read(0xD04);
+		rtk_pcie_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie_13xx_ctrl_read(0xD04);
+		rtk_pcie_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rtk_pcie_13xx_direct_cfg_write_byte((addr&~mask), wval);
+		break;
+	case 2:
+		rtk_pcie_13xx_direct_cfg_write_word((addr&~mask), wval);
+		break;
+	case 4:
+		rtk_pcie_13xx_direct_cfg_write((addr&~mask), wval);
+		break;
+	default:
+		pr_info("RTD13xx: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie_13xx_ctrl_write(0xD04, translate_val);
+		rtk_pcie_13xx_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie_13xx_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie_13xx_lock, irqL);
+}
+EXPORT_SYMBOL(rtk_pcie_13xx_write);
+
+static int _indirect_cfg_write(unsigned long addr,
+					unsigned long data,
+					unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 1000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	data = (data << _pci_bit_shift(addr)) & _pci_bit_mask(mask);
+
+	rtk_pcie_13xx_ctrl_write(PCIE_INDIR_CTR, 0x12);
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_ADDR, addr);
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_WDATA, data);
+
+	if (size == 4)
+		rtk_pcie_13xx_ctrl_write(PCIE_CFG_EN, 0x1);
+	else
+		rtk_pcie_13xx_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(1));
+
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie_13xx_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Write config data (%p) failed - timeout\n",
+				(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie_13xx_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Write config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Write config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Write config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Write config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Write config data failed - tar abort\n");
+
+		goto error_occur;
+	}
+
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SET_FAILED;
+}
+
+static int _indirect_cfg_read(unsigned long addr, u32 *pdata,
+						unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 20000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	rtk_pcie_13xx_ctrl_write(PCIE_INDIR_CTR, 0x10);
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_ST, 0x3);
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_ADDR, (addr & ~0x3));
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(0));
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie_13xx_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Read config data (%p) failed - timeout\n",
+								(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie_13xx_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Read config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Read config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Read config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Read config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Read config data failed - tar abort\n");
+		goto error_occur;
+	}
+
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_ST, 0x3);
+
+	*pdata = (rtk_pcie_13xx_ctrl_read(PCIE_CFG_RDATA) & _pci_bit_mask(mask))
+							>> _pci_bit_shift(addr);
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+	rtk_pcie_13xx_ctrl_write(PCIE_CFG_ST, 0x3);
+	return PCIBIOS_SET_FAILED;
+}
+
+static int rtk_pcie_13xx_rd_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 *pval)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+	u32 val = 0;
+	u8 retry = 5;
+
+
+again:
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if (cfg_direct_access) {
+
+			rtk_pcie_13xx_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				*pval = rtk_pcie_13xx_direct_cfg_read_byte(reg);
+			else if (size == 2)
+				*pval = rtk_pcie_13xx_direct_cfg_read_word(reg);
+			else if (size == 4)
+				*pval = rtk_pcie_13xx_direct_cfg_read(reg);
+
+			rtk_pcie_13xx_ctrl_write(0xD00, 0xFFF00000);
+
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_read(address, pval, size);
+		}
+	}
+
+	val = rtk_pcie_13xx_ctrl_read(0xC7C);
+	if ((val & 0x1f) && retry) {
+		rtk_pcie_13xx_ctrl_write(0xC7C, val);
+		retry--;
+		dev_err(&bus->dev, "pcie dllp error occur = 0x%x\n", val);
+		goto again;
+	}
+
+	//dev_info(&bus->dev, "rtk_pcie_13xx_rd_conf reg = 0x%x, devfun:%d, size=%d, *pval = 0x%x\n",
+	//							reg, devfn, size, *pval);
+
+	return ret;
+}
+
+static int rtk_pcie_13xx_wr_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 val)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+
+	//dev_info(&bus->dev, "rtk_pcie_13xx_wr_conf reg = 0x%x, val = 0x%x\n",
+	//							reg, val);
+
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+
+		if (cfg_direct_access) {
+			rtk_pcie_13xx_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				rtk_pcie_13xx_direct_cfg_write_byte(reg, val);
+			else if (size == 2)
+				rtk_pcie_13xx_direct_cfg_write_word(reg, val);
+			else if (size == 4)
+				rtk_pcie_13xx_direct_cfg_write(reg, val);
+
+			rtk_pcie_13xx_ctrl_write(0xD00, 0xFFF00000);
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_write(address, val, size);
+		}
+	}
+
+	return ret;
+}
+
+static struct pci_ops rtk_pcie_13xx_ops = {
+	.read = rtk_pcie_13xx_rd_conf,
+	.write = rtk_pcie_13xx_wr_conf,
+};
+
+static int rtk_pcie_13xx_hw_initial(struct device *dev)
+{
+	bool pci_link_detected;
+	int timeout = 0;
+	int ret = 0;
+	u32 val;
+	u32 *phy;
+	int size = 0, i = 0;
+
+	/* 0x9801C814[2:0] = 1 */
+	val = readl(SYSTEM_BASE1 + 0x14);
+	val &= (~0x7);
+	val |= 0x1;
+	writel(val, SYSTEM_BASE1 + 0x14);
+
+	/* 0x9801C804[3:0] = 0  --PCIE */
+	val = readl(SYSTEM_BASE1 + 0x4);
+	val &= (~0xf);
+	writel(val, SYSTEM_BASE1 + 0x4);
+
+	/* 0x9801C808[7:0] = 1 */
+	writeb(0x1, SYSTEM_BASE1 + 0x8);
+
+	/*USB PCIE PHY Selector (select to PCIE)*/
+	writel(readl(USB_PCIE_PHY) & ~0x40, USB_PCIE_PHY);
+
+	reset_control_deassert(rstn_pcie_stitch);
+	reset_control_deassert(rstn_pcie);
+	reset_control_deassert(rstn_pcie_core);
+	reset_control_deassert(rstn_pcie_power);
+	reset_control_deassert(rstn_pcie_nonstitch);
+	reset_control_deassert(rstn_pcie_phy);
+	reset_control_deassert(rstn_pcie_phy_mdio);
+	reset_control_deassert(rstn_pcie_sgmii_mdio);
+
+	ret = clk_prepare_enable(pcie_clk);
+
+	if (ret) {
+		dev_err(dev, "unable to enable pcie1_clk clock\n");
+		clk_disable_unprepare(pcie_clk);
+		return -EINVAL;
+	}
+
+
+	rtk_pcie_13xx_ctrl_write(0xC00, 0x00140010);
+
+	if (speed_mode == 0) {
+		rtk_pcie_13xx_ctrl_write(0x0A0,
+			(rtk_pcie_13xx_ctrl_read(0x0A0)&0xFFFFFFF0)|0x00000001);
+	}
+
+
+	/*phy mdio setting*/
+	size = of_property_count_u32_elems(dev->of_node, "phys");
+	phy = kmalloc(size * sizeof(u32), GFP_KERNEL);
+	of_property_read_u32_array(dev->of_node, "phys", phy, size);
+	for (i = 0; i < size; i++) {
+		rtk_pcie_13xx_ctrl_write(0xC1C, phy[i]);
+		mdelay(1);
+	}
+	kfree(phy);
+
+	// after phy mdio set
+	ret = gpio_direction_output(pcie_gpio, 0);
+	mdelay(100);
+	ret = gpio_direction_output(pcie_gpio, 1);
+
+
+	/* set to MMIO */
+	if (cfg_direct_access)
+		rtk_pcie_13xx_ctrl_write(0xC00, 0x00BE0002);
+	else
+		rtk_pcie_13xx_ctrl_write(0xC00, 0x001E0022);
+
+	mdelay(50);
+
+	/* #Link initial setting */
+	rtk_pcie_13xx_ctrl_write(0x710, 0x00010120);
+
+	do {
+		pci_link_detected = (rtk_pcie_13xx_ctrl_read(0xCB4) & 0x800);
+		if (!pci_link_detected) {
+			mdelay(TIMEOUT_RESOLUTION);
+			timeout += TIMEOUT_RESOLUTION;
+		}
+	} while (!pci_link_detected && timeout < PCIE_CONNECT_TIMEOUT);
+
+	if (pci_link_detected) {
+		dev_err(dev, "PCIE device has link up in slot 2\n");
+	} else {
+		if (!debug_mode) { /*do not turn off clk in debug mode*/
+			/*USB PCIE PHY Selector (select to USB)*/
+			writel(readl(USB_PCIE_PHY) | 0x40, USB_PCIE_PHY);
+			reset_control_assert(rstn_pcie_stitch);
+			reset_control_assert(rstn_pcie);
+			reset_control_assert(rstn_pcie_core);
+			reset_control_assert(rstn_pcie_power);
+			reset_control_assert(rstn_pcie_nonstitch);
+			reset_control_assert(rstn_pcie_phy);
+			reset_control_assert(rstn_pcie_phy_mdio);
+			reset_control_assert(rstn_pcie_sgmii_mdio);
+
+			clk_disable_unprepare(pcie_clk);
+		}
+		gpio_free(pcie_gpio);
+
+		dev_err(dev, "PCIE device has link down in slot 2\n");
+		return -ENODEV;
+	}
+
+
+	/* make sure DBI is working */
+	rtk_pcie_13xx_ctrl_write(0x04, 0x00000007);
+
+	if (cfg_direct_access) {
+		/* #Base 1 */
+		rtk_pcie_13xx_ctrl_write(0xD08, 0x98061000);
+
+		/* #Mask 1 */
+		rtk_pcie_13xx_ctrl_write(0xD0C, 0xFFFFF000);
+
+		/* #translate for CFG R/W */
+		rtk_pcie_13xx_ctrl_write(0xD10, 0x00000000);
+	}
+	/* #Base 0 */
+	rtk_pcie_13xx_ctrl_write(0xCFC, 0x98062000);
+
+	/* #Mask 0 */
+	rtk_pcie_13xx_ctrl_write(0xD00, 0xFFF00000);
+
+	/* #translate for MMIO R/W */
+	rtk_pcie_13xx_ctrl_write(0xD04, 0x98000000);
+
+#if defined(CONFIG_R8125) || defined(CONFIG_R8125_MODULE)
+	/*pcie timeout extend to 500us*/
+	rtk_pcie_13xx_ctrl_write(0xC78, 0xF42401);
+#else
+	/* prevent pcie hang if dllp error occur*/
+	rtk_pcie_13xx_ctrl_write(0xC78, 0x200001);
+#endif
+	/* set limit and base register */
+	rtk_pcie_13xx_ctrl_write(0x20, 0x0000FFF0);
+	rtk_pcie_13xx_ctrl_write(0x24, 0x0000FFF0);
+
+#ifdef CONFIG_PCI_MSI
+	rtk_pcie_13xx_ctrl_write(0xC04, 0x4C00);
+#endif
+
+	return ret;
+}
+
+#ifdef CONFIG_PCI_MSI
+/* MSI interrupt handler */
+irqreturn_t rtk_handle_msi_irq(int this_irq, void *dev_id)
+{
+	unsigned long int val = 0;
+	int i, pos, irq;
+	irqreturn_t ret = IRQ_NONE;
+	u32 int_stat = 0;
+
+	if (rtk_pcie_13xx_ctrl_read(0xCD4) & 0x10000) {
+		rtk_pcie_13xx_ctrl_write(0xCD4, 0x10000);
+	} else {
+		return IRQ_HANDLED;
+	}
+
+	while(1){
+		val = *pcie_msi_data;
+		if(val != 0x0){
+			*pcie_msi_data = 0x0;
+			break;
+		}
+	}
+
+	ret = IRQ_HANDLED;
+	pos = 0;
+	while ((pos = find_next_bit(&val, MAX_RTK_MSI_IRQS, pos)) != MAX_RTK_MSI_IRQS) {
+		irq = irq_find_mapping(rtk_msi_domain, pos);
+		generic_handle_irq(irq);
+		pos++;
+	}
+
+
+	return ret;
+}
+
+
+static struct irq_chip rtk_msi_irq_chip = {
+	.name = "RTK-PCIE0-MSI",
+	.irq_enable = pci_msi_unmask_irq,
+	.irq_disable = pci_msi_mask_irq,
+	.irq_mask = pci_msi_mask_irq,
+	.irq_unmask = pci_msi_unmask_irq,
+};
+
+void rtk_pcie_msi_init(void)
+{
+	pcie_msi_data = __get_free_pages(GFP_KERNEL, 0);
+	rtk_pcie_13xx_ctrl_write(0xCD0, virt_to_phys((void *)pcie_msi_data));
+	*(volatile unsigned int *)pcie_msi_data = 0;
+}
+
+static int rtk_msi_map(struct irq_domain *domain, unsigned int irq,
+			 irq_hw_number_t hwirq)
+{
+	irq_set_chip_and_handler(irq, &rtk_msi_irq_chip, handle_simple_irq);
+	irq_set_chip_data(irq, domain->host_data);
+
+	return 0;
+}
+
+static const struct irq_domain_ops rtk_msi_domain_ops = {
+	.map = rtk_msi_map,
+};
+
+static int rtk_msi_alloc(void)
+{
+	int msi;
+	int msi_enable_bit;
+
+	mutex_lock(&msi_lock);
+	msi = find_first_zero_bit(rtk_pcie0_irq_bitmap, MAX_RTK_MSI_IRQS);
+	if (msi < MAX_RTK_MSI_IRQS)
+		set_bit(msi, rtk_pcie0_irq_bitmap);
+	else
+		msi = -ENOSPC;
+	mutex_unlock(&msi_lock);
+	return msi;
+}
+
+static void rtk_msi_free(unsigned long irq)
+{
+
+	mutex_lock(&msi_lock);
+
+	if (!test_bit(irq, rtk_pcie0_irq_bitmap))
+		pr_err("[%s]trying to free unused MSI#%lu\n", __func__, irq);
+	else
+		clear_bit(irq, rtk_pcie0_irq_bitmap);
+
+	mutex_unlock(&msi_lock);
+}
+
+static int rtk_msi_setup_irq(struct msi_controller *chip,
+			       struct pci_dev *pdev, struct msi_desc *desc)
+{
+	struct msi_msg msg;
+	unsigned int irq;
+	int hwirq;
+
+	hwirq = rtk_msi_alloc();
+	if (hwirq < 0)
+		return hwirq;
+
+	irq = irq_create_mapping(rtk_msi_domain, hwirq);
+	if (!irq) {
+		pr_err("[%s] irq mapping error\n", __func__);
+		rtk_msi_free(hwirq);
+		return -EINVAL;
+	}
+
+	irq_set_msi_desc(irq, desc);
+	msg.address_lo = dma_handle;
+	msg.address_hi = 0x0;
+	msg.data = 1 << hwirq;
+
+	pci_write_msi_msg(irq, &msg);
+
+	return 0;
+}
+
+static void rtk_msi_teardown_irq(struct msi_controller *chip,
+				   unsigned int irq)
+{
+	struct irq_data *d = irq_get_irq_data(irq);
+	irq_hw_number_t hwirq = irqd_to_hwirq(d);
+
+	irq_dispose_mapping(irq);
+	rtk_msi_free(hwirq);
+}
+
+static struct msi_controller rtk_pcie_msi_chip = {
+	.setup_irq = rtk_msi_setup_irq,
+	.teardown_irq = rtk_msi_teardown_irq,
+};
+
+#endif
+
+static int rtk_pcie_13xx_probe(struct platform_device *pdev)
+{
+	int ret = 0;
+	int size = 0;
+	const u32 *prop, *prop2;
+	struct resource pcie_mmio_res;
+	struct pci_dev *dev;
+	int irq;
+
+	resource_size_t iobase = 0;
+	LIST_HEAD(res);
+
+	local_pdev = pdev;
+
+	spin_lock_init(&rtk_pcie_13xx_lock);
+
+	dev_info(&pdev->dev, "PCIE host driver initial begin.\n");
+
+	prop = of_get_property(pdev->dev.of_node, "speed-mode", &size);
+	if (prop) {
+		speed_mode = of_read_number(prop, 1);
+		if (speed_mode == 0)
+			dev_info(&pdev->dev, "Speed Mode: GEN1\n");
+		else if (speed_mode == 1)
+			dev_info(&pdev->dev, "Speed Mode: GEN2\n");
+	} else {
+		speed_mode = 0;
+	}
+
+	prop2 = of_get_property(pdev->dev.of_node, "debug-mode", &size);
+	if (prop2) {
+		debug_mode = of_read_number(prop2, 1);
+		if (debug_mode == 0)
+			dev_info(&pdev->dev, "PCIE Debug Mode off\n");
+		else if (debug_mode == 1)
+			dev_info(&pdev->dev, "PCIE Debug Mode on\n");
+	} else {
+		debug_mode = 0;
+	}
+
+	PCIE_CTRL_BASE = of_iomap(pdev->dev.of_node, 0);
+	if (!PCIE_CTRL_BASE) {
+		dev_err(&pdev->dev, "pcie no ctrl address\n");
+		return -EINVAL;
+	}
+
+	PCIE_CFG_BASE = of_iomap(pdev->dev.of_node, 1);
+	if (!PCIE_CFG_BASE) {
+		dev_err(&pdev->dev, "pcie no cfg address\n");
+		return -EINVAL;
+	} else {
+		of_address_to_resource(pdev->dev.of_node, 1, &pcie_mmio_res);
+		PCIE_MMIO_PHY_ADDR = pcie_mmio_res.start;
+		PCIE_MMIO_PHY_ADDR_LEN = resource_size(&pcie_mmio_res);
+	}
+
+
+	SYSTEM_BASE1 = of_iomap(pdev->dev.of_node, 2);
+	if (!SYSTEM_BASE1) {
+		dev_err(&pdev->dev, "pcie no base1 address\n");
+		return -EINVAL;
+	}
+
+	USB_PCIE_PHY = of_iomap(pdev->dev.of_node, 3);
+	if (!USB_PCIE_PHY) {
+		dev_err(&pdev->dev, "pcie no USB_PCIE_PHY address\n");
+		return -EINVAL;
+	}
+
+
+
+	pcie_gpio = of_get_gpio_flags(pdev->dev.of_node, 0, NULL);
+	if (gpio_is_valid(pcie_gpio)) {
+		ret = gpio_request(pcie_gpio, "pcie_gpio");
+		if (ret < 0)
+			pr_err("%s: can't request gpio %d\n",
+						__func__, pcie_gpio);
+	} else {
+		pr_err("%s: gpio %d is not valid\n", __func__, pcie_gpio);
+	}
+
+	pcie_clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(pcie_clk)) {
+		dev_err(&pdev->dev, "pcie clock source missing or invalid\n");
+		return PTR_ERR(pcie_clk);
+	}
+
+	rstn_pcie_stitch = devm_reset_control_get(&pdev->dev, "stitch");
+	if (rstn_pcie_stitch == NULL) {
+		dev_err(&pdev->dev, "stitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie = devm_reset_control_get(&pdev->dev, "rstn");
+	if (rstn_pcie == NULL) {
+		dev_err(&pdev->dev, "rstn_pcie source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_core = devm_reset_control_get(&pdev->dev, "core");
+	if (rstn_pcie_core == NULL) {
+		dev_err(&pdev->dev, "core source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_power = devm_reset_control_get(&pdev->dev, "power");
+	if (rstn_pcie_power == NULL) {
+		dev_err(&pdev->dev, "power source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_nonstitch = devm_reset_control_get(&pdev->dev, "nonstitch");
+	if (rstn_pcie_nonstitch == NULL) {
+		dev_err(&pdev->dev, "nonstitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_phy = devm_reset_control_get(&pdev->dev, "phy");
+	if (rstn_pcie_phy == NULL) {
+		dev_err(&pdev->dev, "phy source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_phy_mdio = devm_reset_control_get(&pdev->dev, "phy_mdio");
+	if (rstn_pcie_phy_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing. or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_sgmii_mdio = devm_reset_control_get(&pdev->dev, "sgmii_mdio");
+	if (rstn_pcie_sgmii_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing. or invalid\n");
+		return -EINVAL;
+	}
+
+	reset_control_assert(rstn_pcie_stitch);
+	reset_control_assert(rstn_pcie);
+	reset_control_assert(rstn_pcie_core);
+	reset_control_assert(rstn_pcie_power);
+	reset_control_assert(rstn_pcie_nonstitch);
+	reset_control_assert(rstn_pcie_phy);
+	reset_control_assert(rstn_pcie_phy_mdio);
+	reset_control_assert(rstn_pcie_sgmii_mdio);
+
+
+	if (rtk_pcie_13xx_hw_initial(&pdev->dev) < 0) {
+		dev_err(&pdev->dev, "rtk_pcie_13xx_hw_initial fail\n");
+		return -EINVAL;
+	}
+
+#ifdef CONFIG_PCI_MSI
+	mutex_init(&msi_lock);
+	/*MSI Init*/
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (irq < 0) {
+		pr_err("PCIE0 parse irq(%d) failed\n", irq);
+		return -EINVAL;
+	}
+	ret = request_irq(irq, rtk_handle_msi_irq, IRQF_SHARED, "rtk-pcie1-msi", pdev);
+	if (ret !=0)
+		pr_err("[%s]request irq failed\n", __func__);
+	rtk_msi_domain = irq_domain_add_linear(NULL, MAX_RTK_MSI_IRQS, &rtk_msi_domain_ops, &rtk_pcie_msi_chip);
+	if (!rtk_msi_domain) {
+		dev_err(&pdev->dev, "irq domain init failed\n");
+		return -ENXIO;
+	}
+	pcie_msi_data = dma_alloc_coherent(&pdev->dev, PAGE_SIZE, &dma_handle, GFP_KERNEL);
+	rtk_pcie_13xx_ctrl_write(0xCD0, dma_handle);
+	*pcie_msi_data = 0x0;
+#endif
+
+
+	/*-------------------------------------------
+	 * Register PCI-E host
+	 *-------------------------------------------
+	 */
+
+	ret = of_pci_get_host_bridge_resources(pdev->dev.of_node,
+					0x1, 0xff, &res, &iobase);
+	if (ret)
+		return ret;
+
+	if (IS_ENABLED(CONFIG_PCI_MSI))
+		bus = pci_scan_root_bus_msi(&pdev->dev, 1,
+				&rtk_pcie_13xx_ops, NULL, &res, &rtk_pcie_msi_chip);
+	else
+		bus = pci_scan_root_bus(&pdev->dev, 1,
+				&rtk_pcie_13xx_ops, NULL, &res);
+
+	if (!bus)
+		return -ENOMEM;
+
+	pci_scan_child_bus(bus);
+	pci_assign_unassigned_bus_resources(bus);
+	pci_bus_add_devices(bus);
+
+#if defined(CONFIG_CPU_V7)
+	list_for_each_entry(dev, &bus->devices, bus_list) {
+		dev->irq = of_irq_parse_and_map_pci(dev, 0, 0);
+	}
+#endif
+
+
+	dev_info(&pdev->dev, "PCIE host driver initial done.\n");
+
+	return ret;
+}
+#ifdef CONFIG_SUSPEND
+static int rtk_pcie_13xx_suspend(struct device *dev)
+{
+	dev_info(dev, "suspend enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie_13xx_ctrl_write(0x178, 0xA3FF0001);
+		rtk_pcie_13xx_ctrl_write(0x098, 0x400);
+		rtk_pcie_13xx_ctrl_write(0xC6C, 0x00000031);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+
+		reset_control_assert(rstn_pcie_stitch);
+		reset_control_assert(rstn_pcie);
+		reset_control_assert(rstn_pcie_core);
+		reset_control_assert(rstn_pcie_power);
+		reset_control_assert(rstn_pcie_nonstitch);
+		reset_control_assert(rstn_pcie_phy);
+		reset_control_assert(rstn_pcie_phy_mdio);
+		reset_control_assert(rstn_pcie_sgmii_mdio);
+		clk_disable_unprepare(pcie_clk);
+		gpio_free(pcie_gpio);
+
+	}
+
+	dev_info(dev, "suspend exit ...\n");
+
+	return 0;
+}
+
+static int rtk_pcie_13xx_resume(struct device *dev)
+{
+	int ret = 0;
+
+	dev_info(dev, "resume enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie_13xx_ctrl_write(0xC6C, 0x00000032);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+		if (gpio_is_valid(pcie_gpio)) {
+			ret = gpio_request(pcie_gpio, "pcie_gpio");
+			if (ret < 0)
+				pr_err("%s: can't request gpio %d\n",
+						__func__, pcie_gpio);
+		} else
+			pr_err("%s: gpio %d is not valid\n",
+						__func__, pcie_gpio);
+
+		reset_control_deassert(rstn_pcie_stitch);
+		reset_control_deassert(rstn_pcie);
+		reset_control_deassert(rstn_pcie_core);
+		reset_control_deassert(rstn_pcie_power);
+		reset_control_deassert(rstn_pcie_nonstitch);
+		reset_control_deassert(rstn_pcie_phy);
+		reset_control_deassert(rstn_pcie_phy_mdio);
+		reset_control_deassert(rstn_pcie_sgmii_mdio);
+		ret = clk_prepare_enable(pcie_clk);
+		if (ret) {
+			dev_err(dev, "unable to enable pcie_clk clock\n");
+			clk_disable_unprepare(pcie_clk);
+			return -EINVAL;
+		}
+		ret = gpio_direction_output(pcie_gpio, 0);
+		mdelay(100);
+		/*Reset PCIE device, Pull high reset signal.*/
+		ret = gpio_direction_output(pcie_gpio, 1);
+
+		if (rtk_pcie_13xx_hw_initial(dev) < 0) {
+			dev_err(dev, "rtk_pcie_13xx_hw_initial fail\n");
+			return -EINVAL;
+		}
+
+
+		if (cfg_direct_access)
+			rtk_pcie_13xx_ctrl_write(0xC00, 0x00BE0002);
+		else
+			rtk_pcie_13xx_ctrl_write(0xC00, 0x001E0022);
+	}
+
+	dev_info(dev, "resume exit ...\n");
+
+	return ret;
+}
+
+static void rtk_pcie_13xx_shutdown(struct platform_device *pdev)
+{
+	dev_info(&pdev->dev, "shutdown enter ...\n");
+
+	dev_info(&pdev->dev, "shutdown mode\n");
+
+	reset_control_assert(rstn_pcie_stitch);
+	reset_control_assert(rstn_pcie);
+	reset_control_assert(rstn_pcie_core);
+	reset_control_assert(rstn_pcie_power);
+	reset_control_assert(rstn_pcie_nonstitch);
+	reset_control_assert(rstn_pcie_phy);
+	reset_control_assert(rstn_pcie_phy_mdio);
+	reset_control_assert(rstn_pcie_sgmii_mdio);
+	clk_disable_unprepare(pcie_clk);
+	gpio_free(pcie_gpio);
+
+	dev_info(&pdev->dev, "shutdown exit ...\n");
+}
+
+
+static const struct dev_pm_ops rtk_pcie_13xx_pm_ops = {
+	.suspend_noirq = rtk_pcie_13xx_suspend,
+	.resume_noirq = rtk_pcie_13xx_resume,
+};
+#endif //CONFIG_SUSPEND
+static const struct of_device_id rtk_pcie_13xx_match_table[] = {
+	{.compatible = "realtek,rtk13xx-pcie-slot1",},
+	{},
+};
+
+static struct platform_driver rtk_pcie_13xx_driver = {
+	.driver = {
+		.name = "[RTD13xx PCIE1]",
+		.of_match_table = of_match_ptr(rtk_pcie_13xx_match_table),
+#ifdef CONFIG_SUSPEND
+		.pm = &rtk_pcie_13xx_pm_ops,
+#endif
+	},
+	.probe = rtk_pcie_13xx_probe,
+	.shutdown = rtk_pcie_13xx_shutdown,
+};
+module_platform_driver(rtk_pcie_13xx_driver);
+
+MODULE_AUTHOR("James Tai <james.tai@realtek.com>");
+MODULE_DESCRIPTION("Realtek PCIe host controller driver");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/pci/host/pcie-rtd13xx-slot2.c b/drivers/pci/host/pcie-rtd13xx-slot2.c
new file mode 100644
index 00000000..2ddc264
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd13xx-slot2.c
@@ -0,0 +1,1140 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/gpio.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/of_gpio.h>
+#include <linux/of_address.h>
+#include <linux/of_pci.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <linux/pci.h>
+#include <linux/platform_device.h>
+#include <linux/resource.h>
+#include <linux/signal.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+#include <linux/suspend.h>
+#include <linux/kthread.h>
+#include <linux/spinlock.h>
+#include "pcie-rtd13xx.h"
+
+
+spinlock_t rtk_pcie2_13xx_lock;
+#define PCIE_IO_2K_MASK  0xFFFFF800
+#define PCIE_IO_4K_MASK  0xFFFFF000
+#define PCIE_IO_64K_MASK 0xFFFF0000
+
+
+static void __iomem *PCIE_CTRL_BASE;
+static void __iomem *PCIE_CFG_BASE;
+
+
+static void __iomem *SYSTEM_BASE1;
+static void __iomem *PINMUX_BASE;
+
+
+static u32 PCIE_MMIO_PHY_ADDR;
+static u32 PCIE_MMIO_PHY_ADDR_LEN;
+
+static u32 pcie2_gpio;
+
+
+static u32 speed_mode;
+static u32 debug_mode;
+
+
+#define cfg_direct_access false
+
+static struct clk *pcie2_clk;
+static struct reset_control *rstn_pcie2_stitch;
+static struct reset_control *rstn_pcie2;
+static struct reset_control *rstn_pcie2_core;
+static struct reset_control *rstn_pcie2_power;
+static struct reset_control *rstn_pcie2_nonstitch;
+static struct reset_control *rstn_pcie2_phy;
+static struct reset_control *rstn_pcie2_phy_mdio;
+
+static struct pci_bus *bus;
+static struct platform_device *local_pdev;
+
+
+#ifdef CONFIG_PCI_MSI
+#define MAX_RTK_MSI_IRQS 16
+#define MAX_RTK_MSI_CTRLS	(MAX_RTK_MSI_IRQS / 16)
+struct irq_domain *rtk_pcie2_msi_domain;
+struct mutex		pcie2_msi_lock;
+DECLARE_BITMAP(rtk_pcie1_irq_bitmap, MAX_RTK_MSI_IRQS);
+unsigned int *pcie2_msi_data;
+dma_addr_t pcie2_dma_handle;
+
+#endif
+
+
+static void rtk_pcie2_13xx_ctrl_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CTRL_BASE);
+}
+
+static unsigned int rtk_pcie2_13xx_ctrl_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CTRL_BASE);
+	return val;
+}
+
+static void rtk_pcie2_13xx_direct_cfg_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie2_13xx_direct_cfg_write_word(unsigned long addr, u16 val)
+{
+	writew(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie2_13xx_direct_cfg_write_byte(unsigned long addr, u8 val)
+{
+	writeb(val, addr + PCIE_CFG_BASE);
+}
+
+static unsigned int rtk_pcie2_13xx_direct_cfg_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u16 rtk_pcie2_13xx_direct_cfg_read_word(unsigned long addr)
+{
+	u16 val = readw(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u8 rtk_pcie2_13xx_direct_cfg_read_byte(unsigned long addr)
+{
+	u8 val = readb(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+
+u32 rtk_pcie2_13xx_mmio_start(void)
+{
+	return PCIE_MMIO_PHY_ADDR;
+}
+
+u32 rtk_pcie2_13xx_mmio_end(void)
+{
+	return (PCIE_MMIO_PHY_ADDR + (PCIE_MMIO_PHY_ADDR_LEN - 1));
+}
+
+u32 rtk_pcie2_13xx_mmio_len(void)
+{
+	return PCIE_MMIO_PHY_ADDR_LEN;
+}
+
+u32 rtk_pcie2_13xx_read(u32 addr, u8 size)
+{
+	u32 rval = 0;
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+	u32 pci_error_status = 0;
+	int retry_cnt = 0;
+	u8 retry = 5;
+
+	spin_lock_irqsave(&rtk_pcie2_13xx_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie2_13xx_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie2_13xx_ctrl_read(0xD04);
+		rtk_pcie2_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie2_13xx_ctrl_read(0xD04);
+		rtk_pcie2_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+
+pci_read_13xx_retry:
+
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rval = rtk_pcie2_13xx_direct_cfg_read_byte((addr & ~mask));
+		break;
+	case 2:
+		rval = rtk_pcie2_13xx_direct_cfg_read_word((addr & ~mask));
+		break;
+	case 4:
+		rval = rtk_pcie2_13xx_direct_cfg_read((addr & ~mask));
+		break;
+	default:
+		pr_info("RTD13xx: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	//DLLP error patch
+	pci_error_status = rtk_pcie2_13xx_ctrl_read(0xc7c);
+	if (pci_error_status & 0x1F) {
+		rtk_pcie2_13xx_ctrl_write(0xc7c, pci_error_status);
+		pr_info("RTD13xx: %s: DLLP(#%d) 0x%x reg=0x%x val=0x%x\n",
+			__func__, retry_cnt, pci_error_status, addr, rval);
+
+		if (retry_cnt < retry) {
+			retry_cnt++;
+			goto pci_read_13xx_retry;
+		}
+	}
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie2_13xx_ctrl_write(0xD04, translate_val);
+		rtk_pcie2_13xx_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie2_13xx_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie2_13xx_lock, irqL);
+
+	return rval;
+}
+EXPORT_SYMBOL(rtk_pcie2_13xx_read);
+
+void rtk_pcie2_13xx_write(u32 addr, u8 size, u32 wval)
+{
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+
+	spin_lock_irqsave(&rtk_pcie2_13xx_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie2_13xx_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie2_13xx_ctrl_read(0xD04);
+		rtk_pcie2_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie2_13xx_ctrl_read(0xD04);
+		rtk_pcie2_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rtk_pcie2_13xx_direct_cfg_write_byte((addr&~mask), wval);
+		break;
+	case 2:
+		rtk_pcie2_13xx_direct_cfg_write_word((addr&~mask), wval);
+		break;
+	case 4:
+		rtk_pcie2_13xx_direct_cfg_write((addr&~mask), wval);
+		break;
+	default:
+		pr_info("RTD13xx: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie2_13xx_ctrl_write(0xD04, translate_val);
+		rtk_pcie2_13xx_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie2_13xx_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie2_13xx_lock, irqL);
+}
+EXPORT_SYMBOL(rtk_pcie2_13xx_write);
+
+static int _indirect_cfg_write(unsigned long addr,
+					unsigned long data,
+					unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 1000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	data = (data << _pci_bit_shift(addr)) & _pci_bit_mask(mask);
+
+	rtk_pcie2_13xx_ctrl_write(PCIE_INDIR_CTR, 0x12);
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_ADDR, addr);
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_WDATA, data);
+
+	if (size == 4)
+		rtk_pcie2_13xx_ctrl_write(PCIE_CFG_EN, 0x1);
+	else
+		rtk_pcie2_13xx_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(1));
+
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie2_13xx_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Write config data (%p) failed - timeout\n",
+				(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie2_13xx_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Write config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Write config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Write config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Write config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Write config data failed - tar abort\n");
+
+		goto error_occur;
+	}
+
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SET_FAILED;
+}
+
+static int _indirect_cfg_read(unsigned long addr, u32 *pdata,
+						unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 20000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	rtk_pcie2_13xx_ctrl_write(PCIE_INDIR_CTR, 0x10);
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_ST, 0x3);
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_ADDR, (addr & ~0x3));
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(0));
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie2_13xx_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Read config data (%p) failed - timeout\n",
+								(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie2_13xx_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Read config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Read config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Read config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Read config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Read config data failed - tar abort\n");
+		goto error_occur;
+	}
+
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_ST, 0x3);
+
+	*pdata = (rtk_pcie2_13xx_ctrl_read(PCIE_CFG_RDATA) & _pci_bit_mask(mask))
+							>> _pci_bit_shift(addr);
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+	rtk_pcie2_13xx_ctrl_write(PCIE_CFG_ST, 0x3);
+	return PCIBIOS_SET_FAILED;
+}
+
+static int rtk_pcie2_13xx_rd_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 *pval)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+	u32 val = 0;
+	u8 retry = 5;
+
+
+again:
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if (cfg_direct_access) {
+
+			rtk_pcie2_13xx_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				*pval = rtk_pcie2_13xx_direct_cfg_read_byte(reg);
+			else if (size == 2)
+				*pval = rtk_pcie2_13xx_direct_cfg_read_word(reg);
+			else if (size == 4)
+				*pval = rtk_pcie2_13xx_direct_cfg_read(reg);
+
+			rtk_pcie2_13xx_ctrl_write(0xD00, 0xFFF00000);
+
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_read(address, pval, size);
+		}
+	}
+
+	val = rtk_pcie2_13xx_ctrl_read(0xC7C);
+	if ((val & 0x1f) && retry) {
+		rtk_pcie2_13xx_ctrl_write(0xC7C, val);
+		retry--;
+		dev_err(&bus->dev, "pcie dllp error occur = 0x%x\n", val);
+		goto again;
+	}
+
+	//dev_info(&bus->dev, "rtk_pcie2_13xx_rd_conf reg = 0x%x, devfun:%d, size=%d, *pval = 0x%x\n",
+	//							reg, devfn, size, *pval);
+
+	return ret;
+}
+
+static int rtk_pcie2_13xx_wr_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 val)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+
+	//dev_info(&bus->dev, "rtk_pcie2_13xx_wr_conf reg = 0x%x, val = 0x%x\n",
+	//							reg, val);
+
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if (cfg_direct_access) {
+			rtk_pcie2_13xx_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				rtk_pcie2_13xx_direct_cfg_write_byte(reg, val);
+			else if (size == 2)
+				rtk_pcie2_13xx_direct_cfg_write_word(reg, val);
+			else if (size == 4)
+				rtk_pcie2_13xx_direct_cfg_write(reg, val);
+
+			rtk_pcie2_13xx_ctrl_write(0xD00, 0xFFF00000);
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_write(address, val, size);
+		}
+	}
+
+	return ret;
+}
+
+static struct pci_ops rtk_pcie_13xx_ops = {
+	.read = rtk_pcie2_13xx_rd_conf,
+	.write = rtk_pcie2_13xx_wr_conf,
+};
+
+static int rtk_pcie2_13xx_hw_initial(struct device *dev)
+{
+	bool pci_link_detected;
+	int timeout = 0;
+	int ret = 0;
+	u32 val;
+	u32 *phy;
+	int size = 0, i = 0;
+
+
+	/*pcie sata phy selector 0x9804F050[8] = 0*/
+	val = readl(PINMUX_BASE + 0x50);
+	val &= (~(0x1 << 8));
+	writel(val, PINMUX_BASE + 0x50);
+
+	/* 0x9801C614[2:0] = 1 */
+	val = readl(SYSTEM_BASE1 + 0x14);
+	val &= (~0x7);
+	val |= 0x1;
+	writel(val, SYSTEM_BASE1 + 0x14);
+
+	/* 0x9801C604[16:19] = 0  --PCIE */
+	val = readl(SYSTEM_BASE1 + 0x4);
+	val &= (~(0xf << 16));
+	writel(val, SYSTEM_BASE1 + 0x4);
+
+	/* 0x9801C608[7:0] = 4 */
+	writeb(0x4, SYSTEM_BASE1 + 0x8);
+
+	reset_control_deassert(rstn_pcie2_stitch);
+	reset_control_deassert(rstn_pcie2);
+	reset_control_deassert(rstn_pcie2_core);
+	reset_control_deassert(rstn_pcie2_power);
+	reset_control_deassert(rstn_pcie2_nonstitch);
+	reset_control_deassert(rstn_pcie2_phy);
+	reset_control_deassert(rstn_pcie2_phy_mdio);
+
+	ret = clk_prepare_enable(pcie2_clk);
+
+	if (ret) {
+		dev_err(dev, "unable to enable pcie1_clk clock\n");
+		clk_disable_unprepare(pcie2_clk);
+		return -EINVAL;
+	}
+
+
+	rtk_pcie2_13xx_ctrl_write(0xC00, 0x00140010);
+
+	if (speed_mode == 0) {
+		rtk_pcie2_13xx_ctrl_write(0x0A0,
+			(rtk_pcie2_13xx_ctrl_read(0x0A0)&0xFFFFFFF0)|0x00000001);
+	}
+
+
+	/*phy mdio setting*/
+	size = of_property_count_u32_elems(dev->of_node, "phys");
+	phy = kmalloc(size * sizeof(u32), GFP_KERNEL);
+	of_property_read_u32_array(dev->of_node, "phys", phy, size);
+	for (i = 0; i < size; i++) {
+		rtk_pcie2_13xx_ctrl_write(0xC1C, phy[i]);
+		mdelay(1);
+	}
+	kfree(phy);
+
+	// after phy mdio set
+	ret = gpio_direction_output(pcie2_gpio, 0);
+	mdelay(100);
+	ret = gpio_direction_output(pcie2_gpio, 1);
+
+
+	/* set to MMIO */
+	if (cfg_direct_access)
+		rtk_pcie2_13xx_ctrl_write(0xC00, 0x00BE0002);
+	else
+		rtk_pcie2_13xx_ctrl_write(0xC00, 0x1E0022);
+
+	mdelay(50);
+
+	/* #Link initial setting */
+	rtk_pcie2_13xx_ctrl_write(0x710, 0x00010120);
+
+	do {
+		pci_link_detected = (rtk_pcie2_13xx_ctrl_read(0xCB4) & 0x800);
+		if (!pci_link_detected) {
+			mdelay(TIMEOUT_RESOLUTION);
+			timeout += TIMEOUT_RESOLUTION;
+		}
+	} while (!pci_link_detected && timeout < PCIE_CONNECT_TIMEOUT);
+
+	if (pci_link_detected) {
+		dev_err(dev, "PCIE device has link up in slot 2\n");
+	} else {
+		if (!debug_mode) { /*do not turn off clk in debug mode*/
+			reset_control_assert(rstn_pcie2_stitch);
+			reset_control_assert(rstn_pcie2);
+			reset_control_assert(rstn_pcie2_core);
+			reset_control_assert(rstn_pcie2_power);
+			reset_control_assert(rstn_pcie2_nonstitch);
+			reset_control_assert(rstn_pcie2_phy);
+			reset_control_assert(rstn_pcie2_phy_mdio);
+
+			clk_disable_unprepare(pcie2_clk);
+		}
+		gpio_free(pcie2_gpio);
+
+		dev_err(dev, "PCIE device has link down in slot 2\n");
+		return -ENODEV;
+	}
+
+
+	/* make sure DBI is working */
+	rtk_pcie2_13xx_ctrl_write(0x04, 0x00000007);
+
+	if (cfg_direct_access) {
+		/* #Base 1 */
+		rtk_pcie2_13xx_ctrl_write(0xD08, 0x980A1000);
+
+		/* #Mask 1 */
+		rtk_pcie2_13xx_ctrl_write(0xD0C, 0xFFFFF000);
+
+		/* #translate for CFG R/W */
+		rtk_pcie2_13xx_ctrl_write(0xD10, 0x00000000);
+	}
+	/* #Base 0 */
+	rtk_pcie2_13xx_ctrl_write(0xCFC, 0x980A2000);
+
+	/* #Mask 0 */
+	rtk_pcie2_13xx_ctrl_write(0xD00, 0xFFF00000);
+
+	/* #translate for MMIO R/W */
+	rtk_pcie2_13xx_ctrl_write(0xD04, 0x98000000);
+
+#if defined(CONFIG_R8125) || defined(CONFIG_R8125_MODULE)
+	/*pcie timeout extend to 500us*/
+	rtk_pcie2_13xx_ctrl_write(0xC78, 0xF42401);
+#else
+	/* prevent pcie hang if dllp error occur*/
+	rtk_pcie2_13xx_ctrl_write(0xC78, 0x200001);
+#endif
+	/* set limit and base register */
+	rtk_pcie2_13xx_ctrl_write(0x20, 0x0000FFF0);
+	rtk_pcie2_13xx_ctrl_write(0x24, 0x0000FFF0);
+
+//#ifdef CONFIG_PCI_MSI
+#if 0
+	rtk_pcie2_13xx_ctrl_write(0xC04, 0x4C00);
+#endif
+
+	return ret;
+}
+
+#ifdef CONFIG_PCI_MSI
+/* MSI interrupt handler */
+irqreturn_t rtk_handle_pcie2_msi_irq(int this_irq, void *dev_id)
+{
+	unsigned long int val = 0;
+	int i, pos, irq;
+	irqreturn_t ret = IRQ_NONE;
+	u32 int_stat = 0;
+
+	if (rtk_pcie2_13xx_ctrl_read(0xCD4) & 0x10000) {
+		rtk_pcie2_13xx_ctrl_write(0xCD4, 0x10000);
+	} else {
+		return IRQ_HANDLED;
+	}
+
+	while(1){
+		val = *pcie2_msi_data;
+		if(val != 0x0){
+			*pcie2_msi_data = 0x0;
+			break;
+		}
+	}
+
+	ret = IRQ_HANDLED;
+	pos = 0;
+	while ((pos = find_next_bit(&val, MAX_RTK_MSI_IRQS, pos)) != MAX_RTK_MSI_IRQS) {
+		irq = irq_find_mapping(rtk_pcie2_msi_domain, pos);
+		generic_handle_irq(irq);
+		pos++;
+	}
+
+
+	return ret;
+}
+
+
+static struct irq_chip rtk_msi_irq_chip = {
+	.name = "RTK-PCIE1-MSI",
+	.irq_enable = pci_msi_unmask_irq,
+	.irq_disable = pci_msi_mask_irq,
+	.irq_mask = pci_msi_mask_irq,
+	.irq_unmask = pci_msi_unmask_irq,
+};
+
+void rtk_pcie2_msi_init(void)
+{
+	pcie2_msi_data = __get_free_pages(GFP_KERNEL, 0);
+	rtk_pcie2_13xx_ctrl_write(0xCD0, virt_to_phys((void *)pcie2_msi_data));
+	*(volatile unsigned int *)pcie2_msi_data = 0;
+}
+
+static int rtk_msi_map(struct irq_domain *domain, unsigned int irq,
+			 irq_hw_number_t hwirq)
+{
+	irq_set_chip_and_handler(irq, &rtk_msi_irq_chip, handle_simple_irq);
+	irq_set_chip_data(irq, domain->host_data);
+
+	return 0;
+}
+
+static const struct irq_domain_ops rtk_pcie2_msi_domain_ops = {
+	.map = rtk_msi_map,
+};
+
+static int rtk_msi_alloc(void)
+{
+	int msi;
+	int msi_enable_bit;
+
+	mutex_lock(&pcie2_msi_lock);
+	msi = find_first_zero_bit(rtk_pcie1_irq_bitmap, MAX_RTK_MSI_IRQS);
+	if (msi < MAX_RTK_MSI_IRQS)
+		set_bit(msi, rtk_pcie1_irq_bitmap);
+	else
+		msi = -ENOSPC;
+	mutex_unlock(&pcie2_msi_lock);
+	return msi;
+}
+
+static void rtk_msi_free(unsigned long irq)
+{
+
+	mutex_lock(&pcie2_msi_lock);
+
+	if (!test_bit(irq, rtk_pcie1_irq_bitmap))
+		pr_err("[%s]trying to free unused MSI#%lu\n", __func__, irq);
+	else
+		clear_bit(irq, rtk_pcie1_irq_bitmap);
+
+	mutex_unlock(&pcie2_msi_lock);
+}
+
+static int rtk_msi_setup_irq(struct msi_controller *chip,
+			       struct pci_dev *pdev, struct msi_desc *desc)
+{
+	struct msi_msg msg;
+	unsigned int irq;
+	int hwirq;
+
+	hwirq = rtk_msi_alloc();
+	if (hwirq < 0)
+		return hwirq;
+
+	irq = irq_create_mapping(rtk_pcie2_msi_domain, hwirq);
+	if (!irq) {
+		pr_err("[%s] irq mapping error\n", __func__);
+		rtk_msi_free(hwirq);
+		return -EINVAL;
+	}
+
+	irq_set_msi_desc(irq, desc);
+	msg.address_lo = pcie2_dma_handle;
+	msg.address_hi = 0x0;
+	msg.data = 1 << hwirq;
+
+	pci_write_msi_msg(irq, &msg);
+
+	return 0;
+}
+
+static void rtk_msi_teardown_irq(struct msi_controller *chip,
+				   unsigned int irq)
+{
+	struct irq_data *d = irq_get_irq_data(irq);
+	irq_hw_number_t hwirq = irqd_to_hwirq(d);
+
+	irq_dispose_mapping(irq);
+	rtk_msi_free(hwirq);
+}
+
+static struct msi_controller rtk_pcie_msi_chip = {
+	.setup_irq = rtk_msi_setup_irq,
+	.teardown_irq = rtk_msi_teardown_irq,
+};
+
+#endif
+
+
+
+static int rtk_pcie2_13xx_probe(struct platform_device *pdev)
+{
+	int ret = 0;
+	int size = 0;
+	const u32 *prop, *prop2;
+	struct resource pcie_mmio_res;
+	struct pci_dev *dev;
+
+	resource_size_t iobase = 0;
+	LIST_HEAD(res);
+	int irq;
+
+	local_pdev = pdev;
+
+	spin_lock_init(&rtk_pcie2_13xx_lock);
+
+	dev_info(&pdev->dev, "PCIE host driver initial begin.\n");
+
+	prop = of_get_property(pdev->dev.of_node, "speed-mode", &size);
+	if (prop) {
+		speed_mode = of_read_number(prop, 1);
+		if (speed_mode == 0)
+			dev_info(&pdev->dev, "Speed Mode: GEN1\n");
+		else if (speed_mode == 1)
+			dev_info(&pdev->dev, "Speed Mode: GEN2\n");
+	} else {
+		speed_mode = 0;
+	}
+
+	prop2 = of_get_property(pdev->dev.of_node, "debug-mode", &size);
+	if (prop2) {
+		debug_mode = of_read_number(prop2, 1);
+		if (debug_mode == 0)
+			dev_info(&pdev->dev, "PCIE Debug Mode off\n");
+		else if (debug_mode == 1)
+			dev_info(&pdev->dev, "PCIE Debug Mode on\n");
+	} else {
+		debug_mode = 0;
+	}
+
+	PCIE_CTRL_BASE = of_iomap(pdev->dev.of_node, 0);
+	if (!PCIE_CTRL_BASE) {
+		dev_err(&pdev->dev, "pcie no ctrl address\n");
+		return -EINVAL;
+	}
+
+	PCIE_CFG_BASE = of_iomap(pdev->dev.of_node, 1);
+	if (!PCIE_CFG_BASE) {
+		dev_err(&pdev->dev, "pcie no cfg address\n");
+		return -EINVAL;
+	} else {
+		of_address_to_resource(pdev->dev.of_node, 1, &pcie_mmio_res);
+		PCIE_MMIO_PHY_ADDR = pcie_mmio_res.start;
+		PCIE_MMIO_PHY_ADDR_LEN = resource_size(&pcie_mmio_res);
+	}
+
+
+	SYSTEM_BASE1 = of_iomap(pdev->dev.of_node, 2);
+	if (!SYSTEM_BASE1) {
+		dev_err(&pdev->dev, "pcie no base1 address\n");
+		return -EINVAL;
+	}
+
+	PINMUX_BASE = of_iomap(pdev->dev.of_node, 3);
+	if (!PINMUX_BASE) {
+		dev_err(&pdev->dev, "pcie no PINMUX_BASE address\n");
+		return -EINVAL;
+	}
+
+
+
+	pcie2_gpio = of_get_gpio_flags(pdev->dev.of_node, 0, NULL);
+	if (gpio_is_valid(pcie2_gpio)) {
+		ret = gpio_request(pcie2_gpio, "pcie2_gpio");
+		if (ret < 0)
+			pr_err("%s: can't request gpio %d\n",
+						__func__, pcie2_gpio);
+	} else {
+		pr_err("%s: gpio %d is not valid\n", __func__, pcie2_gpio);
+	}
+
+	pcie2_clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(pcie2_clk)) {
+		dev_err(&pdev->dev, "pcie clock source missing or invalid\n");
+		return PTR_ERR(pcie2_clk);
+	}
+
+	rstn_pcie2_stitch = devm_reset_control_get(&pdev->dev, "stitch");
+	if (rstn_pcie2_stitch == NULL) {
+		dev_err(&pdev->dev, "stitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2 = devm_reset_control_get(&pdev->dev, "rstn");
+	if (rstn_pcie2 == NULL) {
+		dev_err(&pdev->dev, "rstn_pcie2 source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2_core = devm_reset_control_get(&pdev->dev, "core");
+	if (rstn_pcie2_core == NULL) {
+		dev_err(&pdev->dev, "core source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2_power = devm_reset_control_get(&pdev->dev, "power");
+	if (rstn_pcie2_power == NULL) {
+		dev_err(&pdev->dev, "power source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2_nonstitch = devm_reset_control_get(&pdev->dev, "nonstitch");
+	if (rstn_pcie2_nonstitch == NULL) {
+		dev_err(&pdev->dev, "nonstitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2_phy = devm_reset_control_get(&pdev->dev, "phy");
+	if (rstn_pcie2_phy == NULL) {
+		dev_err(&pdev->dev, "phy source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2_phy_mdio = devm_reset_control_get(&pdev->dev, "phy_mdio");
+	if (rstn_pcie2_phy_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing. or invalid\n");
+		return -EINVAL;
+	}
+
+
+	reset_control_assert(rstn_pcie2_stitch);
+	reset_control_assert(rstn_pcie2);
+	reset_control_assert(rstn_pcie2_core);
+	reset_control_assert(rstn_pcie2_power);
+	reset_control_assert(rstn_pcie2_nonstitch);
+	reset_control_assert(rstn_pcie2_phy);
+	reset_control_assert(rstn_pcie2_phy_mdio);
+
+
+	if (rtk_pcie2_13xx_hw_initial(&pdev->dev) < 0) {
+		dev_err(&pdev->dev, "rtk_pcie2_13xx_hw_initial fail\n");
+		return -EINVAL;
+	}
+
+//#ifdef CONFIG_PCI_MSI
+#if 0
+	mutex_init(&pcie2_msi_lock);
+	/*MSI Init*/
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (irq < 0) {
+		pr_err("PCIE1 parse irq(%d) failed\n", irq);
+		return -EINVAL;
+	}
+	ret = request_irq(irq, rtk_handle_pcie2_msi_irq, IRQF_SHARED, "rtk-pcie2-msi", pdev);
+	if (ret !=0)
+		pr_err("[%s]request irq failed\n", __func__);
+	rtk_pcie2_msi_domain = irq_domain_add_linear(NULL, MAX_RTK_MSI_IRQS, &rtk_pcie2_msi_domain_ops, &rtk_pcie_msi_chip);
+	if (!rtk_pcie2_msi_domain) {
+		dev_err(&pdev->dev, "irq domain init failed\n");
+		return -ENXIO;
+	}
+	pcie2_msi_data = dma_alloc_coherent(&pdev->dev, PAGE_SIZE, &pcie2_dma_handle, GFP_KERNEL);
+	rtk_pcie2_13xx_ctrl_write(0xCD0, pcie2_dma_handle);
+	*pcie2_msi_data = 0x0;
+#endif
+
+
+	/*-------------------------------------------
+	 * Register PCI-E host
+	 *-------------------------------------------
+	 */
+
+	ret = of_pci_get_host_bridge_resources(pdev->dev.of_node,
+					0x1, 0xff, &res, &iobase);
+	if (ret)
+		return ret;
+
+	//if (IS_ENABLED(CONFIG_PCI_MSI))
+	if (0)
+                bus = pci_scan_root_bus_msi(&pdev->dev, 1,
+                                &rtk_pcie_13xx_ops, NULL, &res, &rtk_pcie_msi_chip);
+        else
+		bus = pci_scan_root_bus(&pdev->dev, 1,
+				&rtk_pcie_13xx_ops, NULL, &res);
+
+	if (!bus)
+		return -ENOMEM;
+
+	pci_scan_child_bus(bus);
+	pci_assign_unassigned_bus_resources(bus);
+	pci_bus_add_devices(bus);
+
+#if defined(CONFIG_CPU_V7)
+	list_for_each_entry(dev, &bus->devices, bus_list) {
+		dev->irq = of_irq_parse_and_map_pci(dev, 0, 0);
+	}
+#endif
+
+	dev_info(&pdev->dev, "PCIE host driver initial done.\n");
+
+	return ret;
+}
+#ifdef CONFIG_SUSPEND
+static int rtk_pcie2_13xx_suspend(struct device *dev)
+{
+	dev_info(dev, "suspend enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie2_13xx_ctrl_write(0x178, 0xA3FF0001);
+		rtk_pcie2_13xx_ctrl_write(0x098, 0x400);
+		rtk_pcie2_13xx_ctrl_write(0xC6C, 0x00000031);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+
+		reset_control_assert(rstn_pcie2_stitch);
+		reset_control_assert(rstn_pcie2);
+		reset_control_assert(rstn_pcie2_core);
+		reset_control_assert(rstn_pcie2_power);
+		reset_control_assert(rstn_pcie2_nonstitch);
+		reset_control_assert(rstn_pcie2_phy);
+		reset_control_assert(rstn_pcie2_phy_mdio);
+		clk_disable_unprepare(pcie2_clk);
+		gpio_free(pcie2_gpio);
+
+	}
+
+	dev_info(dev, "suspend exit ...\n");
+
+	return 0;
+}
+
+static int rtk_pcie2_13xx_resume(struct device *dev)
+{
+	int ret = 0;
+
+	dev_info(dev, "resume enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie2_13xx_ctrl_write(0xC6C, 0x00000032);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+		if (gpio_is_valid(pcie2_gpio)) {
+			ret = gpio_request(pcie2_gpio, "pcie2_gpio");
+			if (ret < 0)
+				pr_err("%s: can't request gpio %d\n",
+						__func__, pcie2_gpio);
+		} else
+			pr_err("%s: gpio %d is not valid\n",
+						__func__, pcie2_gpio);
+
+		reset_control_deassert(rstn_pcie2_stitch);
+		reset_control_deassert(rstn_pcie2);
+		reset_control_deassert(rstn_pcie2_core);
+		reset_control_deassert(rstn_pcie2_power);
+		reset_control_deassert(rstn_pcie2_nonstitch);
+		reset_control_deassert(rstn_pcie2_phy);
+		reset_control_deassert(rstn_pcie2_phy_mdio);
+		ret = clk_prepare_enable(pcie2_clk);
+		if (ret) {
+			dev_err(dev, "unable to enable pcie2_clk clock\n");
+			clk_disable_unprepare(pcie2_clk);
+			return -EINVAL;
+		}
+		ret = gpio_direction_output(pcie2_gpio, 0);
+		mdelay(100);
+		/*Reset PCIE device, Pull high reset signal.*/
+		ret = gpio_direction_output(pcie2_gpio, 1);
+
+		if (rtk_pcie2_13xx_hw_initial(dev) < 0) {
+			dev_err(dev, "rtk_pcie2_13xx_hw_initial fail\n");
+			return -EINVAL;
+		}
+
+
+		if (cfg_direct_access)
+			rtk_pcie2_13xx_ctrl_write(0xC00, 0x00BE0002);
+		else
+			rtk_pcie2_13xx_ctrl_write(0xC00, 0x001E0022);
+	}
+
+	dev_info(dev, "resume exit ...\n");
+
+	return ret;
+}
+
+static void rtk_pcie2_13xx_shutdown(struct platform_device *pdev)
+{
+	dev_info(&pdev->dev, "shutdown enter ...\n");
+
+	dev_info(&pdev->dev, "shutdown mode\n");
+
+	reset_control_assert(rstn_pcie2_stitch);
+	reset_control_assert(rstn_pcie2);
+	reset_control_assert(rstn_pcie2_core);
+	reset_control_assert(rstn_pcie2_power);
+	reset_control_assert(rstn_pcie2_nonstitch);
+	reset_control_assert(rstn_pcie2_phy);
+	reset_control_assert(rstn_pcie2_phy_mdio);
+	clk_disable_unprepare(pcie2_clk);
+	gpio_free(pcie2_gpio);
+
+	dev_info(&pdev->dev, "shutdown exit ...\n");
+}
+
+
+static const struct dev_pm_ops rtk_pcie2_13xx_pm_ops = {
+	.suspend_noirq = rtk_pcie2_13xx_suspend,
+	.resume_noirq = rtk_pcie2_13xx_resume,
+};
+#endif //CONFIG_SUSPEND
+static const struct of_device_id rtk_pcie2_13xx_match_table[] = {
+	{.compatible = "realtek,rtk13xx-pcie-slot2",},
+	{},
+};
+
+static struct platform_driver rtk_pcie2_13xx_driver = {
+	.driver = {
+		.name = "[RTD13xx PCIE2]",
+		.of_match_table = of_match_ptr(rtk_pcie2_13xx_match_table),
+#ifdef CONFIG_SUSPEND
+		.pm = &rtk_pcie2_13xx_pm_ops,
+#endif
+	},
+	.probe = rtk_pcie2_13xx_probe,
+	.shutdown = rtk_pcie2_13xx_shutdown,
+};
+module_platform_driver(rtk_pcie2_13xx_driver);
+
+MODULE_AUTHOR("James Tai <james.tai@realtek.com>");
+MODULE_DESCRIPTION("Realtek PCIe host controller driver");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/pci/host/pcie-rtd13xx-slot3.c b/drivers/pci/host/pcie-rtd13xx-slot3.c
new file mode 100644
index 00000000..37268a8
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd13xx-slot3.c
@@ -0,0 +1,1137 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/gpio.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/of_gpio.h>
+#include <linux/of_address.h>
+#include <linux/of_pci.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <linux/pci.h>
+#include <linux/platform_device.h>
+#include <linux/resource.h>
+#include <linux/signal.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+#include <linux/suspend.h>
+#include <linux/kthread.h>
+#include <linux/spinlock.h>
+#include "pcie-rtd13xx.h"
+
+
+spinlock_t rtk_pcie3_13xx_lock;
+#define PCIE_IO_2K_MASK  0xFFFFF800
+#define PCIE_IO_4K_MASK  0xFFFFF000
+#define PCIE_IO_64K_MASK 0xFFFF0000
+
+
+static void __iomem *PCIE_CTRL_BASE;
+static void __iomem *PCIE_CFG_BASE;
+
+
+static void __iomem *SYSTEM_BASE1;
+static void __iomem *PINMUX_BASE;
+
+
+static u32 PCIE_MMIO_PHY_ADDR;
+static u32 PCIE_MMIO_PHY_ADDR_LEN;
+
+static u32 pcie3_gpio;
+
+
+static u32 speed_mode;
+static u32 debug_mode;
+
+
+#define cfg_direct_access false
+
+static struct clk *pcie3_clk;
+static struct reset_control *rstn_pcie3_stitch;
+static struct reset_control *rstn_pcie3;
+static struct reset_control *rstn_pcie3_core;
+static struct reset_control *rstn_pcie3_power;
+static struct reset_control *rstn_pcie3_nonstitch;
+static struct reset_control *rstn_pcie3_phy;
+static struct reset_control *rstn_pcie3_phy_mdio;
+
+static struct pci_bus *bus;
+static struct platform_device *local_pdev;
+
+#ifdef CONFIG_PCI_MSI
+#define MAX_RTK_MSI_IRQS 16
+#define MAX_RTK_MSI_CTRLS	(MAX_RTK_MSI_IRQS / 16)
+struct irq_domain *rtk_pcie3_msi_domain;
+struct mutex		pcie3_msi_lock;
+DECLARE_BITMAP(rtk_pcie3_irq_bitmap, MAX_RTK_MSI_IRQS);
+unsigned int *pcie3_msi_data;
+dma_addr_t pcie3_dma_handle;
+
+#endif
+
+
+static void rtk_pcie3_13xx_ctrl_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CTRL_BASE);
+}
+
+static unsigned int rtk_pcie3_13xx_ctrl_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CTRL_BASE);
+	return val;
+}
+
+static void rtk_pcie3_13xx_direct_cfg_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie3_13xx_direct_cfg_write_word(unsigned long addr, u16 val)
+{
+	writew(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie3_13xx_direct_cfg_write_byte(unsigned long addr, u8 val)
+{
+	writeb(val, addr + PCIE_CFG_BASE);
+}
+
+static unsigned int rtk_pcie3_13xx_direct_cfg_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u16 rtk_pcie3_13xx_direct_cfg_read_word(unsigned long addr)
+{
+	u16 val = readw(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u8 rtk_pcie3_13xx_direct_cfg_read_byte(unsigned long addr)
+{
+	u8 val = readb(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+
+u32 rtk_pcie3_13xx_mmio_start(void)
+{
+	return PCIE_MMIO_PHY_ADDR;
+}
+
+u32 rtk_pcie3_13xx_mmio_end(void)
+{
+	return (PCIE_MMIO_PHY_ADDR + (PCIE_MMIO_PHY_ADDR_LEN - 1));
+}
+
+u32 rtk_pcie3_13xx_mmio_len(void)
+{
+	return PCIE_MMIO_PHY_ADDR_LEN;
+}
+
+u32 rtk_pcie3_13xx_read(u32 addr, u8 size)
+{
+	u32 rval = 0;
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+	u32 pci_error_status = 0;
+	int retry_cnt = 0;
+	u8 retry = 5;
+
+	spin_lock_irqsave(&rtk_pcie3_13xx_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, pcie3.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie3_13xx_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie3_13xx_ctrl_read(0xD04);
+		rtk_pcie3_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie3_13xx_ctrl_read(0xD04);
+		rtk_pcie3_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+
+pci_read_13xx_retry:
+
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rval = rtk_pcie3_13xx_direct_cfg_read_byte((addr & ~mask));
+		break;
+	case 2:
+		rval = rtk_pcie3_13xx_direct_cfg_read_word((addr & ~mask));
+		break;
+	case 4:
+		rval = rtk_pcie3_13xx_direct_cfg_read((addr & ~mask));
+		break;
+	default:
+		pr_info("RTD13xx: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	//DLLP error patch
+	pci_error_status = rtk_pcie3_13xx_ctrl_read(0xc7c);
+	if (pci_error_status & 0x1F) {
+		rtk_pcie3_13xx_ctrl_write(0xc7c, pci_error_status);
+		pr_info("RTD13xx: %s: DLLP(#%d) 0x%x reg=0x%x val=0x%x\n",
+			__func__, retry_cnt, pci_error_status, addr, rval);
+
+		if (retry_cnt < retry) {
+			retry_cnt++;
+			goto pci_read_13xx_retry;
+		}
+	}
+
+	/* PCIE1.1 0x9804FCEC, pcie3.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie3_13xx_ctrl_write(0xD04, translate_val);
+		rtk_pcie3_13xx_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie3_13xx_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie3_13xx_lock, irqL);
+
+	return rval;
+}
+EXPORT_SYMBOL(rtk_pcie3_13xx_read);
+
+void rtk_pcie3_13xx_write(u32 addr, u8 size, u32 wval)
+{
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+
+	spin_lock_irqsave(&rtk_pcie3_13xx_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, pcie3.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie3_13xx_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie3_13xx_ctrl_read(0xD04);
+		rtk_pcie3_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie3_13xx_ctrl_read(0xD04);
+		rtk_pcie3_13xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rtk_pcie3_13xx_direct_cfg_write_byte((addr&~mask), wval);
+		break;
+	case 2:
+		rtk_pcie3_13xx_direct_cfg_write_word((addr&~mask), wval);
+		break;
+	case 4:
+		rtk_pcie3_13xx_direct_cfg_write((addr&~mask), wval);
+		break;
+	default:
+		pr_info("RTD13xx: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	/* PCIE1.1 0x9804FCEC, pcie3.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie3_13xx_ctrl_write(0xD04, translate_val);
+		rtk_pcie3_13xx_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie3_13xx_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie3_13xx_lock, irqL);
+}
+EXPORT_SYMBOL(rtk_pcie3_13xx_write);
+
+static int _indirect_cfg_write(unsigned long addr,
+					unsigned long data,
+					unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 1000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	data = (data << _pci_bit_shift(addr)) & _pci_bit_mask(mask);
+
+	rtk_pcie3_13xx_ctrl_write(PCIE_INDIR_CTR, 0x12);
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_ADDR, addr);
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_WDATA, data);
+
+	if (size == 4)
+		rtk_pcie3_13xx_ctrl_write(PCIE_CFG_EN, 0x1);
+	else
+		rtk_pcie3_13xx_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(1));
+
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie3_13xx_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Write config data (%p) failed - timeout\n",
+				(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie3_13xx_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Write config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Write config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Write config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Write config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Write config data failed - tar abort\n");
+
+		goto error_occur;
+	}
+
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SET_FAILED;
+}
+
+static int _indirect_cfg_read(unsigned long addr, u32 *pdata,
+						unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 20000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	rtk_pcie3_13xx_ctrl_write(PCIE_INDIR_CTR, 0x10);
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_ST, 0x3);
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_ADDR, (addr & ~0x3));
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(0));
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie3_13xx_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Read config data (%p) failed - timeout\n",
+								(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie3_13xx_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Read config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Read config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Read config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Read config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Read config data failed - tar abort\n");
+		goto error_occur;
+	}
+
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_ST, 0x3);
+
+	*pdata = (rtk_pcie3_13xx_ctrl_read(PCIE_CFG_RDATA) & _pci_bit_mask(mask))
+							>> _pci_bit_shift(addr);
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+	rtk_pcie3_13xx_ctrl_write(PCIE_CFG_ST, 0x3);
+	return PCIBIOS_SET_FAILED;
+}
+
+static int rtk_pcie3_13xx_rd_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 *pval)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+	u32 val = 0;
+	u8 retry = 5;
+
+
+again:
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if (cfg_direct_access) {
+
+			rtk_pcie3_13xx_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				*pval = rtk_pcie3_13xx_direct_cfg_read_byte(reg);
+			else if (size == 2)
+				*pval = rtk_pcie3_13xx_direct_cfg_read_word(reg);
+			else if (size == 4)
+				*pval = rtk_pcie3_13xx_direct_cfg_read(reg);
+
+			rtk_pcie3_13xx_ctrl_write(0xD00, 0xFFF00000);
+
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_read(address, pval, size);
+		}
+	}
+
+	val = rtk_pcie3_13xx_ctrl_read(0xC7C);
+	if ((val & 0x1f) && retry) {
+		rtk_pcie3_13xx_ctrl_write(0xC7C, val);
+		retry--;
+		dev_err(&bus->dev, "pcie dllp error occur = 0x%x\n", val);
+		goto again;
+	}
+
+	//dev_info(&bus->dev, "rtk_pcie3_13xx_rd_conf reg = 0x%x, devfun:%d, size=%d, *pval = 0x%x\n",
+	//							reg, devfn, size, *pval);
+
+	return ret;
+}
+
+static int rtk_pcie3_13xx_wr_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 val)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+
+	//dev_info(&bus->dev, "rtk_pcie3_13xx_wr_conf reg = 0x%x, val = 0x%x\n",
+	//							reg, val);
+
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if (cfg_direct_access) {
+			rtk_pcie3_13xx_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				rtk_pcie3_13xx_direct_cfg_write_byte(reg, val);
+			else if (size == 2)
+				rtk_pcie3_13xx_direct_cfg_write_word(reg, val);
+			else if (size == 4)
+				rtk_pcie3_13xx_direct_cfg_write(reg, val);
+
+			rtk_pcie3_13xx_ctrl_write(0xD00, 0xFFF00000);
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_write(address, val, size);
+		}
+	}
+
+	return ret;
+}
+
+static struct pci_ops rtk_pcie_13xx_ops = {
+	.read = rtk_pcie3_13xx_rd_conf,
+	.write = rtk_pcie3_13xx_wr_conf,
+};
+
+static int rtk_pcie3_13xx_hw_initial(struct device *dev)
+{
+	bool pci_link_detected;
+	int timeout = 0;
+	int ret = 0;
+	u32 val;
+	u32 *phy;
+	int size = 0, i = 0;
+
+	/*pcie sata phy selector 0x9804F050[9] = 0*/
+	val = readl(PINMUX_BASE + 0x50);
+	val &= (~(0x1 << 9));
+	writel(val, PINMUX_BASE + 0x50);
+
+	/* 0x9801C614[2:0] = 1 */
+	val = readl(SYSTEM_BASE1 + 0x14);
+	val &= (~0x7);
+	val |= 0x1;
+	writel(val, SYSTEM_BASE1 + 0x14);
+
+	/* 0x9801C604[16:19] = 0  --PCIE */
+	val = readl(SYSTEM_BASE1 + 0x4);
+	val &= (~(0xf << 16));
+	writel(val, SYSTEM_BASE1 + 0x4);
+
+	/* 0x9801C608[7:0] = 4 */
+	writeb(0x4, SYSTEM_BASE1 + 0x8);
+
+	reset_control_deassert(rstn_pcie3_stitch);
+	reset_control_deassert(rstn_pcie3);
+	reset_control_deassert(rstn_pcie3_core);
+	reset_control_deassert(rstn_pcie3_power);
+	reset_control_deassert(rstn_pcie3_nonstitch);
+	reset_control_deassert(rstn_pcie3_phy);
+	reset_control_deassert(rstn_pcie3_phy_mdio);
+
+	ret = clk_prepare_enable(pcie3_clk);
+
+	if (ret) {
+		dev_err(dev, "unable to enable pcie1_clk clock\n");
+		clk_disable_unprepare(pcie3_clk);
+		return -EINVAL;
+	}
+
+
+	rtk_pcie3_13xx_ctrl_write(0xC00, 0x00140010);
+
+	if (speed_mode == 0) {
+		rtk_pcie3_13xx_ctrl_write(0x0A0,
+			(rtk_pcie3_13xx_ctrl_read(0x0A0)&0xFFFFFFF0)|0x00000001);
+	}
+
+
+	/*phy mdio setting*/
+	size = of_property_count_u32_elems(dev->of_node, "phys");
+	phy = kmalloc(size * sizeof(u32), GFP_KERNEL);
+	of_property_read_u32_array(dev->of_node, "phys", phy, size);
+	for (i = 0; i < size; i++) {
+		rtk_pcie3_13xx_ctrl_write(0xC1C, phy[i]);
+		mdelay(1);
+	}
+	kfree(phy);
+
+	// after phy mdio set
+	ret = gpio_direction_output(pcie3_gpio, 0);
+	mdelay(100);
+	ret = gpio_direction_output(pcie3_gpio, 1);
+
+
+	/* set to MMIO */
+	if (cfg_direct_access)
+		rtk_pcie3_13xx_ctrl_write(0xC00, 0x00BE0002);
+	else
+		rtk_pcie3_13xx_ctrl_write(0xC00, 0x001E0022);
+
+	mdelay(50);
+
+	/* #Link initial setting */
+	rtk_pcie3_13xx_ctrl_write(0x710, 0x00010120);
+
+	do {
+		pci_link_detected = (rtk_pcie3_13xx_ctrl_read(0xCB4) & 0x800);
+		if (!pci_link_detected) {
+			mdelay(TIMEOUT_RESOLUTION);
+			timeout += TIMEOUT_RESOLUTION;
+		}
+	} while (!pci_link_detected && timeout < PCIE_CONNECT_TIMEOUT);
+
+	if (pci_link_detected) {
+		dev_err(dev, "PCIE device has link up in slot 2\n");
+	} else {
+		if (!debug_mode) { /*do not turn off clk in debug mode*/
+			reset_control_assert(rstn_pcie3_stitch);
+			reset_control_assert(rstn_pcie3);
+			reset_control_assert(rstn_pcie3_core);
+			reset_control_assert(rstn_pcie3_power);
+			reset_control_assert(rstn_pcie3_nonstitch);
+			reset_control_assert(rstn_pcie3_phy);
+			reset_control_assert(rstn_pcie3_phy_mdio);
+
+			clk_disable_unprepare(pcie3_clk);
+		}
+		gpio_free(pcie3_gpio);
+
+		dev_err(dev, "PCIE device has link down in slot 2\n");
+		return -ENODEV;
+	}
+
+
+	/* make sure DBI is working */
+	rtk_pcie3_13xx_ctrl_write(0x04, 0x00000007);
+
+	if (cfg_direct_access) {
+		/* #Base 1 */
+		rtk_pcie3_13xx_ctrl_write(0xD08, 0x980C1000);
+
+		/* #Mask 1 */
+		rtk_pcie3_13xx_ctrl_write(0xD0C, 0xFFFFF000);
+
+		/* #translate for CFG R/W */
+		rtk_pcie3_13xx_ctrl_write(0xD10, 0x00000000);
+	}
+	/* #Base 0 */
+	rtk_pcie3_13xx_ctrl_write(0xCFC, 0x980C2000);
+
+	/* #Mask 0 */
+	rtk_pcie3_13xx_ctrl_write(0xD00, 0xFFF00000);
+
+	/* #translate for MMIO R/W */
+	rtk_pcie3_13xx_ctrl_write(0xD04, 0x98000000);
+
+#if defined(CONFIG_R8125) || defined(CONFIG_R8125_MODULE)
+	/*pcie timeout extend to 500us*/
+	rtk_pcie3_13xx_ctrl_write(0xC78, 0xF42401);
+#else
+	/* prevent pcie hang if dllp error occur*/
+	rtk_pcie3_13xx_ctrl_write(0xC78, 0x200001);
+#endif
+	/* set limit and base register */
+	rtk_pcie3_13xx_ctrl_write(0x20, 0x0000FFF0);
+	rtk_pcie3_13xx_ctrl_write(0x24, 0x0000FFF0);
+
+//#ifdef CONFIG_PCI_MSI
+#if 0
+	rtk_pcie3_13xx_ctrl_write(0xC04, 0x4C00);
+#endif
+	return ret;
+}
+
+#ifdef CONFIG_PCI_MSI
+/* MSI interrupt handler */
+irqreturn_t rtk_handle_pcie3_msi_irq(int this_irq, void *dev_id)
+{
+	unsigned long int val = 0;
+	int i, pos, irq;
+	irqreturn_t ret = IRQ_NONE;
+	u32 int_stat = 0;
+
+	if (rtk_pcie3_13xx_ctrl_read(0xCD4) & 0x10000) {
+		rtk_pcie3_13xx_ctrl_write(0xCD4, 0x10000);
+	} else {
+		return IRQ_HANDLED;
+	}
+
+	while(1){
+		val = *pcie3_msi_data;
+		if(val != 0x0){
+			*pcie3_msi_data = 0x0;
+			break;
+		}
+	}
+
+	ret = IRQ_HANDLED;
+	pos = 0;
+	while ((pos = find_next_bit(&val, MAX_RTK_MSI_IRQS, pos)) != MAX_RTK_MSI_IRQS) {
+		irq = irq_find_mapping(rtk_pcie3_msi_domain, pos);
+		generic_handle_irq(irq);
+		pos++;
+	}
+
+
+	return ret;
+}
+
+
+static struct irq_chip rtk_msi_irq_chip = {
+	.name = "RTK-PCIE1-MSI",
+	.irq_enable = pci_msi_unmask_irq,
+	.irq_disable = pci_msi_mask_irq,
+	.irq_mask = pci_msi_mask_irq,
+	.irq_unmask = pci_msi_unmask_irq,
+};
+
+void rtk_pcie3_msi_init(void)
+{
+	pcie3_msi_data = __get_free_pages(GFP_KERNEL, 0);
+	rtk_pcie3_13xx_ctrl_write(0xCD0, virt_to_phys((void *)pcie3_msi_data));
+	*(volatile unsigned int *)pcie3_msi_data = 0;
+}
+
+static int rtk_msi_map(struct irq_domain *domain, unsigned int irq,
+			 irq_hw_number_t hwirq)
+{
+	irq_set_chip_and_handler(irq, &rtk_msi_irq_chip, handle_simple_irq);
+	irq_set_chip_data(irq, domain->host_data);
+
+	return 0;
+}
+
+static const struct irq_domain_ops rtk_pcie3_msi_domain_ops = {
+	.map = rtk_msi_map,
+};
+
+static int rtk_msi_alloc(void)
+{
+	int msi;
+	int msi_enable_bit;
+
+	mutex_lock(&pcie3_msi_lock);
+	msi = find_first_zero_bit(rtk_pcie3_irq_bitmap, MAX_RTK_MSI_IRQS);
+	if (msi < MAX_RTK_MSI_IRQS)
+		set_bit(msi, rtk_pcie3_irq_bitmap);
+	else
+		msi = -ENOSPC;
+	mutex_unlock(&pcie3_msi_lock);
+	return msi;
+}
+
+static void rtk_msi_free(unsigned long irq)
+{
+
+	mutex_lock(&pcie3_msi_lock);
+
+	if (!test_bit(irq, rtk_pcie3_irq_bitmap))
+		pr_err("[%s]trying to free unused MSI#%lu\n", __func__, irq);
+	else
+		clear_bit(irq, rtk_pcie3_irq_bitmap);
+
+	mutex_unlock(&pcie3_msi_lock);
+}
+
+static int rtk_msi_setup_irq(struct msi_controller *chip,
+			       struct pci_dev *pdev, struct msi_desc *desc)
+{
+	struct msi_msg msg;
+	unsigned int irq;
+	int hwirq;
+
+	hwirq = rtk_msi_alloc();
+	if (hwirq < 0)
+		return hwirq;
+
+	irq = irq_create_mapping(rtk_pcie3_msi_domain, hwirq);
+	if (!irq) {
+		pr_err("[%s] irq mapping error\n", __func__);
+		rtk_msi_free(hwirq);
+		return -EINVAL;
+	}
+
+	irq_set_msi_desc(irq, desc);
+	msg.address_lo = pcie3_dma_handle;
+	msg.address_hi = 0x0;
+	msg.data = 1 << hwirq;
+
+	pci_write_msi_msg(irq, &msg);
+
+	return 0;
+}
+
+static void rtk_msi_teardown_irq(struct msi_controller *chip,
+				   unsigned int irq)
+{
+	struct irq_data *d = irq_get_irq_data(irq);
+	irq_hw_number_t hwirq = irqd_to_hwirq(d);
+
+	irq_dispose_mapping(irq);
+	rtk_msi_free(hwirq);
+}
+
+static struct msi_controller rtk_pcie_msi_chip = {
+	.setup_irq = rtk_msi_setup_irq,
+	.teardown_irq = rtk_msi_teardown_irq,
+};
+
+#endif
+
+
+static int rtk_pcie3_13xx_probe(struct platform_device *pdev)
+{
+	int ret = 0;
+	int size = 0;
+	const u32 *prop, *prop2;
+	struct resource pcie_mmio_res;
+	struct pci_dev *dev;
+	int irq;
+	u32 tmp;
+
+	resource_size_t iobase = 0;
+	LIST_HEAD(res);
+
+	local_pdev = pdev;
+
+	spin_lock_init(&rtk_pcie3_13xx_lock);
+
+	dev_info(&pdev->dev, "PCIE host driver initial begin.\n");
+
+	prop = of_get_property(pdev->dev.of_node, "speed-mode", &size);
+	if (prop) {
+		speed_mode = of_read_number(prop, 1);
+		if (speed_mode == 0)
+			dev_info(&pdev->dev, "Speed Mode: GEN1\n");
+		else if (speed_mode == 1)
+			dev_info(&pdev->dev, "Speed Mode: GEN2\n");
+	} else {
+		speed_mode = 0;
+	}
+
+	prop2 = of_get_property(pdev->dev.of_node, "debug-mode", &size);
+	if (prop2) {
+		debug_mode = of_read_number(prop2, 1);
+		if (debug_mode == 0)
+			dev_info(&pdev->dev, "PCIE Debug Mode off\n");
+		else if (debug_mode == 1)
+			dev_info(&pdev->dev, "PCIE Debug Mode on\n");
+	} else {
+		debug_mode = 0;
+	}
+
+	PCIE_CTRL_BASE = of_iomap(pdev->dev.of_node, 0);
+	if (!PCIE_CTRL_BASE) {
+		dev_err(&pdev->dev, "pcie no ctrl address\n");
+		return -EINVAL;
+	}
+
+	PCIE_CFG_BASE = of_iomap(pdev->dev.of_node, 1);
+	if (!PCIE_CFG_BASE) {
+		dev_err(&pdev->dev, "pcie no cfg address\n");
+		return -EINVAL;
+	} else {
+		of_address_to_resource(pdev->dev.of_node, 1, &pcie_mmio_res);
+		PCIE_MMIO_PHY_ADDR = pcie_mmio_res.start;
+		PCIE_MMIO_PHY_ADDR_LEN = resource_size(&pcie_mmio_res);
+	}
+
+
+	SYSTEM_BASE1 = of_iomap(pdev->dev.of_node, 2);
+	if (!SYSTEM_BASE1) {
+		dev_err(&pdev->dev, "pcie no base1 address\n");
+		return -EINVAL;
+	}
+
+	PINMUX_BASE = of_iomap(pdev->dev.of_node, 3);
+	if (!PINMUX_BASE) {
+		dev_err(&pdev->dev, "pcie no PINMUX_BASE address\n");
+		return -EINVAL;
+	}
+
+
+
+	pcie3_gpio = of_get_gpio_flags(pdev->dev.of_node, 0, NULL);
+	if (gpio_is_valid(pcie3_gpio)) {
+		ret = gpio_request(pcie3_gpio, "pcie3_gpio");
+		if (ret < 0)
+			pr_err("%s: can't request gpio %d\n",
+						__func__, pcie3_gpio);
+	} else {
+		pr_err("%s: gpio %d is not valid\n", __func__, pcie3_gpio);
+	}
+
+	pcie3_clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(pcie3_clk)) {
+		dev_err(&pdev->dev, "pcie clock source missing or invalid\n");
+		return PTR_ERR(pcie3_clk);
+	}
+
+	rstn_pcie3_stitch = devm_reset_control_get(&pdev->dev, "stitch");
+	if (rstn_pcie3_stitch == NULL) {
+		dev_err(&pdev->dev, "stitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie3 = devm_reset_control_get(&pdev->dev, "rstn");
+	if (rstn_pcie3 == NULL) {
+		dev_err(&pdev->dev, "rstn_pcie3 source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie3_core = devm_reset_control_get(&pdev->dev, "core");
+	if (rstn_pcie3_core == NULL) {
+		dev_err(&pdev->dev, "core source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie3_power = devm_reset_control_get(&pdev->dev, "power");
+	if (rstn_pcie3_power == NULL) {
+		dev_err(&pdev->dev, "power source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie3_nonstitch = devm_reset_control_get(&pdev->dev, "nonstitch");
+	if (rstn_pcie3_nonstitch == NULL) {
+		dev_err(&pdev->dev, "nonstitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie3_phy = devm_reset_control_get(&pdev->dev, "phy");
+	if (rstn_pcie3_phy == NULL) {
+		dev_err(&pdev->dev, "phy source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie3_phy_mdio = devm_reset_control_get(&pdev->dev, "phy_mdio");
+	if (rstn_pcie3_phy_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing. or invalid\n");
+		return -EINVAL;
+	}
+
+
+	reset_control_assert(rstn_pcie3_stitch);
+	reset_control_assert(rstn_pcie3);
+	reset_control_assert(rstn_pcie3_core);
+	reset_control_assert(rstn_pcie3_power);
+	reset_control_assert(rstn_pcie3_nonstitch);
+	reset_control_assert(rstn_pcie3_phy);
+	reset_control_assert(rstn_pcie3_phy_mdio);
+
+
+	if (rtk_pcie3_13xx_hw_initial(&pdev->dev) < 0) {
+		dev_err(&pdev->dev, "rtk_pcie3_13xx_hw_initial fail\n");
+		return -EINVAL;
+	}
+//#ifdef CONFIG_PCI_MSI
+#if 0
+        mutex_init(&pcie3_msi_lock);
+        /*MSI Init*/
+        irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+        if (irq < 0) {
+                pr_err("PCIE1 parse irq(%d) failed\n", irq);
+                return -EINVAL;
+        }
+        ret = request_irq(irq, rtk_handle_pcie3_msi_irq, IRQF_SHARED, "rtk-pcie3-msi", pdev);
+        if (ret !=0)
+                pr_err("[%s]request irq failed\n", __func__);
+        rtk_pcie3_msi_domain = irq_domain_add_linear(NULL, MAX_RTK_MSI_IRQS, &rtk_pcie3_msi_domain_ops, &rtk_pcie_msi_chip);
+        if (!rtk_pcie3_msi_domain) {
+                dev_err(&pdev->dev, "irq domain init failed\n");
+                return -ENXIO;
+        }
+        pcie3_msi_data = dma_alloc_coherent(&pdev->dev, PAGE_SIZE, &pcie3_dma_handle, GFP_KERNEL);
+        rtk_pcie3_13xx_ctrl_write(0xCD0, pcie3_dma_handle);
+        *pcie3_msi_data = 0x0;
+#endif
+
+	/*-------------------------------------------
+	 * Register PCI-E host
+	 *-------------------------------------------
+	 */
+
+	ret = of_pci_get_host_bridge_resources(pdev->dev.of_node,
+					0x1, 0xff, &res, &iobase);
+	if (ret)
+		return ret;
+
+
+	//if (IS_ENABLED(CONFIG_PCI_MSI))
+	if (0)
+                bus = pci_scan_root_bus_msi(&pdev->dev, 1,
+                                &rtk_pcie_13xx_ops, NULL, &res, &rtk_pcie_msi_chip);
+        else
+                bus = pci_scan_root_bus(&pdev->dev, 1,
+				&rtk_pcie_13xx_ops, NULL, &res);
+
+	if (!bus)
+		return -ENOMEM;
+
+	pci_scan_child_bus(bus);
+	pci_assign_unassigned_bus_resources(bus);
+	pci_bus_add_devices(bus);
+
+
+#if defined(CONFIG_CPU_V7)
+	list_for_each_entry(dev, &bus->devices, bus_list) {
+		dev->irq = of_irq_parse_and_map_pci(dev, 0, 0);
+	}
+#endif
+
+	dev_info(&pdev->dev, "PCIE host driver initial done.\n");
+
+	return ret;
+}
+#ifdef CONFIG_SUSPEND
+static int rtk_pcie3_13xx_suspend(struct device *dev)
+{
+	dev_info(dev, "suspend enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie3_13xx_ctrl_write(0x178, 0xA3FF0001);
+		rtk_pcie3_13xx_ctrl_write(0x098, 0x400);
+		rtk_pcie3_13xx_ctrl_write(0xC6C, 0x00000031);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+
+		reset_control_assert(rstn_pcie3_stitch);
+		reset_control_assert(rstn_pcie3);
+		reset_control_assert(rstn_pcie3_core);
+		reset_control_assert(rstn_pcie3_power);
+		reset_control_assert(rstn_pcie3_nonstitch);
+		reset_control_assert(rstn_pcie3_phy);
+		reset_control_assert(rstn_pcie3_phy_mdio);
+		clk_disable_unprepare(pcie3_clk);
+		gpio_free(pcie3_gpio);
+
+	}
+
+	dev_info(dev, "suspend exit ...\n");
+
+	return 0;
+}
+
+static int rtk_pcie3_13xx_resume(struct device *dev)
+{
+	int ret = 0;
+
+	dev_info(dev, "resume enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie3_13xx_ctrl_write(0xC6C, 0x00000032);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+		if (gpio_is_valid(pcie3_gpio)) {
+			ret = gpio_request(pcie3_gpio, "pcie3_gpio");
+			if (ret < 0)
+				pr_err("%s: can't request gpio %d\n",
+						__func__, pcie3_gpio);
+		} else
+			pr_err("%s: gpio %d is not valid\n",
+						__func__, pcie3_gpio);
+
+		reset_control_deassert(rstn_pcie3_stitch);
+		reset_control_deassert(rstn_pcie3);
+		reset_control_deassert(rstn_pcie3_core);
+		reset_control_deassert(rstn_pcie3_power);
+		reset_control_deassert(rstn_pcie3_nonstitch);
+		reset_control_deassert(rstn_pcie3_phy);
+		reset_control_deassert(rstn_pcie3_phy_mdio);
+		ret = clk_prepare_enable(pcie3_clk);
+		if (ret) {
+			dev_err(dev, "unable to enable pcie3_clk clock\n");
+			clk_disable_unprepare(pcie3_clk);
+			return -EINVAL;
+		}
+		ret = gpio_direction_output(pcie3_gpio, 0);
+		mdelay(100);
+		/*Reset PCIE device, Pull high reset signal.*/
+		ret = gpio_direction_output(pcie3_gpio, 1);
+
+		if (rtk_pcie3_13xx_hw_initial(dev) < 0) {
+			dev_err(dev, "rtk_pcie3_13xx_hw_initial fail\n");
+			return -EINVAL;
+		}
+
+
+		if (cfg_direct_access)
+			rtk_pcie3_13xx_ctrl_write(0xC00, 0x00BE0002);
+		else
+			rtk_pcie3_13xx_ctrl_write(0xC00, 0x001E0022);
+	}
+
+	dev_info(dev, "resume exit ...\n");
+
+	return ret;
+}
+
+static void rtk_pcie3_13xx_shutdown(struct platform_device *pdev)
+{
+	dev_info(&pdev->dev, "shutdown enter ...\n");
+
+	dev_info(&pdev->dev, "shutdown mode\n");
+
+	reset_control_assert(rstn_pcie3_stitch);
+	reset_control_assert(rstn_pcie3);
+	reset_control_assert(rstn_pcie3_core);
+	reset_control_assert(rstn_pcie3_power);
+	reset_control_assert(rstn_pcie3_nonstitch);
+	reset_control_assert(rstn_pcie3_phy);
+	reset_control_assert(rstn_pcie3_phy_mdio);
+	clk_disable_unprepare(pcie3_clk);
+	gpio_free(pcie3_gpio);
+
+	dev_info(&pdev->dev, "shutdown exit ...\n");
+}
+
+
+static const struct dev_pm_ops rtk_pcie3_13xx_pm_ops = {
+	.suspend_noirq = rtk_pcie3_13xx_suspend,
+	.resume_noirq = rtk_pcie3_13xx_resume,
+};
+#endif //CONFIG_SUSPEND
+static const struct of_device_id rtk_pcie3_13xx_match_table[] = {
+	{.compatible = "realtek,rtk13xx-pcie-slot3",},
+	{},
+};
+
+static struct platform_driver rtk_pcie3_13xx_driver = {
+	.driver = {
+		.name = "[RTD13xx pcie3]",
+		.of_match_table = of_match_ptr(rtk_pcie3_13xx_match_table),
+#ifdef CONFIG_SUSPEND
+		.pm = &rtk_pcie3_13xx_pm_ops,
+#endif
+	},
+	.probe = rtk_pcie3_13xx_probe,
+	.shutdown = rtk_pcie3_13xx_shutdown,
+};
+module_platform_driver(rtk_pcie3_13xx_driver);
+
+MODULE_AUTHOR("James Tai <james.tai@realtek.com>");
+MODULE_DESCRIPTION("Realtek PCIe host controller driver");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/pci/host/pcie-rtd13xx.h b/drivers/pci/host/pcie-rtd13xx.h
new file mode 100644
index 00000000..a1c7b45
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd13xx.h
@@ -0,0 +1,330 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+#ifndef RTK_PCIE_13xx_H_
+#define RTK_PCIE_13xx_H_
+
+#include <linux/of_platform.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of.h>
+
+/* SB2 for PCI */
+#define PCI_PRINT printk
+
+#ifdef PCI_DBG_EN
+#define PCI_DBG(fmt, args...) \
+	pr_info("[RTD13xx PCIE] DBG, " fmt, ## args)
+#else
+#define PCI_DBG(fmt, args...) \
+do { \
+} while (0)
+#endif
+
+#define PCI_INFO(fmt, args...) \
+	pr_info("[RTD13xx PCIE] INFO," fmt, ## args)
+#define PCI_WARNING(fmt, args...) \
+	pr_info("[RTD13xx PCIE] WARNING," fmt, ## args)
+
+#ifdef PCI_REG_DBG_EN
+#define PCI_REG_DBG(fmt, args...) \
+	pr_info("[RTD13xx PCIE] REG DBG," fmt, ## args)
+#else
+#define PCI_REG_DBG(fmt, args...) \
+do { \
+} while (0)
+#endif
+
+#ifdef PCI_CFG_DBG_EN
+#define PCI_CFG_DBG(fmt, args...) \
+	pr_info("[RTD13xx PCIE] CFG DBG," fmt, ## args)
+#else
+#define PCI_CFG_DBG(fmt, args...) do {} while (0)
+#endif
+
+#define PCI_CFG_WARNING(fmt, args...) pr_alert("[RTD13xx PCIE] CFG WARNING," fmt, ## args)
+
+/* SB2 for PCI */
+#define SB2_PCI_BASE0 0x00000030
+#define SB2_PCI_BASE1 0x00000034
+#define SB2_PCI_BASE2 0x00000038
+#define SB2_PCI_BASE3 0x0000003C
+#define SB2_PCI_MASK0 0x00000040
+#define SB2_PCI_MASK1 0x00000044
+#define SB2_PCI_MASK2 0x00000048
+#define SB2_PCI_MASK3 0x0000004C
+#define SB2_PCI_TRAN0 0x00000050
+#define SB2_PCI_TRAN1 0x00000054
+#define SB2_PCI_TRAN2 0x00000058
+#define SB2_PCI_TRAN3 0x0000005C
+#define SB2_PCI_CTRL 0x00000060
+
+/*
+ * PCI-DVR Bridge
+ */
+#define PCIE_SYS_CTR 0x00000C00U
+#define TRANS_EN (1 << 20)
+#define PHY_MMIO_TYPE (1 << 19)
+#define PHY_MDIO_OE (1 << 18)
+#define PHY_MDIO_RSTN (1 << 17)
+#define APP_INIT_RST (1 << 16)
+#define LOOPBACK_EN (1 << 9)
+#define DIR_REQ_INFO_EN (1 << 8)
+#define RX_LANE_REVERSAL_EN (1 << 7)
+#define TX_LANE_REVERSAL_EN (1 << 6)
+#define INDOR_CFG_EN (1 << 5)
+#define DIR_CFG_EN (1 << 4)
+#define RCV_ADDR0_EN (1 << 3)
+#define RCV_ADDR1_EN (1 << 2)
+#define APP_LTSSM_EN (1 << 1)
+#define RCV_TRANS_EN (1)
+
+#define DVR_INT_CTR 0x00000C04U
+
+#define DVR_GNR_INT 0x00000C08U
+#define S_INTP_PCIE_LEGACY_MSI_INT 14
+#define S_INTP_PM_TO_ACK_INT 13
+#define S_INTP_CFG_SYS_ERR_RC_INT 12
+#define S_INTP_PCIE_LEGACY_INT 11
+#define S_INTP_CFG_RSDM_VENDOR_MSG_INT 10
+#define S_INTP_CFG_PME_MSI 9
+#define S_INTP_CFG_PME_INT 8
+#define S_INTP_CFG_AER_RC_MSI 7
+#define S_INTP_CFG_AER_RC_ERR 6
+#define S_INTP_RTGT 5 /* Slave Receiver Interrupt */
+#define S_INTP_RCPL 4 /* Master Receiver Interrupt */
+#define S_INTP_DIR_CFG 3 /* Direct CFG Interrupt */
+#define S_INTP_DIR_MIO 2 /* Direct MIO Interrupt */
+#define S_INTP_CFG 1 /* Indirect CFG Interrupt */
+#define S_INTP_MIO 0 /* Indirect MIO Interrupt */
+#define INTP_PCIE_LEGACY_MSI_INT (1 << INTP_PCIE_LEGACY_MSI_INT)
+#define INTP_PM_TO_ACK_INT (1 << INTP_PM_TO_ACK_INT)
+#define INTP_CFG_SYS_ERR_RC_INT (1 << INTP_CFG_SYS_ERR_RC_INT)
+#define INTP_PCIE_LEGACY_INT (1 << INTP_PCIE_LEGACY_INT)
+#define INTP_CFG_RSDM_VENDOR_MSG_INT (1 << INTP_CFG_RSDM_VENDOR_MSG_INT)
+#define INTP_CFG_PME_MSI (1 << INTP_CFG_PME_MSI)
+#define INTP_CFG_PME_INT (1 << INTP_CFG_PME_INT)
+#define INTP_CFG_AER_RC_MSI (1 << INTP_CFG_AER_RC_MSI)
+#define INTP_CFG_AER_RC_ERR (1 << INTP_CFG_AER_RC_ERR)
+#define INTP_RTGT (1 << INTP_RTGT)
+#define INTP_RCPL (1 << INTP_RCPL)
+#define INTP_DIR_CFG (1 << INTP_DIR_CFG)
+#define INTP_DIR_MIO (1 << INTP_DIR_MIO)
+#define INTP_CFG (1 << INTP_CFG)
+#define INTP_MIO (1 << INTP_MIO)
+
+#define DVR_PCIE_INT 0x00000C0CU
+#define PCIE_INTP_INTD (0x1U << 3)
+#define PCIE_INTP_INTC (0x1U << 2)
+#define PCIE_INTP_INTB (0x1U << 1)
+#define PCIE_INTP_INTA (0x1U)
+
+#define PCIE_DBI_CTR 0x00000C10U
+#define DBI_IO_ACCESS (0x1U << 9)
+#define DBI_ROM_ACCESS (0x1U << 8)
+#define DBI_BAR_NUM(x) ((x & 0x7) << 5)
+#define DBI_FUNC_NUM(x) ((x & 0x7) << 2)
+#define DBI_SC2_ACCESS (0x1U << 1)
+#define DBI_CMD_ACCESS (0x1U)
+
+#define PCIE_INDIR_CTR 0x00000C14
+#define PCIE_DIR_CTR 0x00000018U
+#define REQ_INFO_ALIGN (0x1U << 13)
+#define REQ_INFO_ATTR(x) ((x & 0x3) << 11)
+#define REQ_INFO_EP (0x1U << 10)
+#define REQ_INFO_TC(x) ((x & 0x7) << 7)
+#define REQ_INFO_TYPE(x) ((x & 0x1F) << 2)
+#define REQ_INFO_FMT(x) (x & 0x3)
+
+#define PCIE_MDIO_CTR 0x00000C1CU
+#define MDIO_DATA(x) ((x & 0xFFFF) << 16) /* MDIO Data */
+#define MDIO_PHY_ADDR(x) ((x & 0x7) << 13) /* MDIO PHY Address */
+#define MDIO_REG_ADDR(x) ((x & 0x1F) << 8) /* MDIO Register Address */
+#define MDIO_BUSY (0x1U << 7)
+#define MDIO_ST(x) ((x & 0x03) << 5) /* MDIO Host Control State Monitor */
+#define MDIO_RDY (0x1U << 4) /* MDIO PREAMBLE Signal Monitor */
+#define MDIO_RATE(x) ((x & 0x3) << 2) /* MDIO Clock Rate */
+#define CLK_SYS_1_32(x) 0 /* MDIO Clock Rate = 1/32 */
+#define CLK_SYS_1_16(x) 1 /* MDIO Clock Rate = 1/16 */
+#define CLK_SYS_1_8(x) 2 /* MDIO Clock Rate = 1/8 */
+#define CLK_SYS_1_4(x) 3 /* MDIO Clock Rate = 1/4 */
+#define MDIO_SRST (0x1U << 1)
+#define MDIO_RDWR(x) (x & 0x1) /* MDIO Read/Write : 0 read, 1 write */
+
+/*
+ * Address Translation
+ * PCI-E Bridge provides 2 set of control registers
+ * for in-bound address translation
+ */
+#define PCIE_BASE0 0x00000C20U
+#define PCIE_BASE1 0x00000C24U
+#define PCIE_MASK0 0x00000C28U
+#define PCIE_MASK1 0x00000C2CU
+#define PCIE_TRAN0 0x00000C30U
+#define PCIE_TRAN1 0x00000C34U
+
+/*
+ * Configuration Access
+ * the following registers are used to access configuration
+ * space
+ */
+#define PCIE_CFG_CT 0x00000C38U
+#define GO_CT (0x1U)
+
+#define PCIE_CFG_EN 0x00000C3CU
+#define BUS_NUM(x) ((x & 0xFF) << 16) /* Bus number */
+#define DEV_NUM(x) ((x & 0xF) << 11) /* Device number */
+#define FUN_NUM(x) ((x & 0x7) << 8) /* Function number */
+#define BYTE_CNT(x) ((x & 0xF) << 4) /* Byte enable bits */
+#define ERROR_EN(x) ((x & 0x1) << 2) /* Enable error timeout counter */
+#define BYTE_EN (0x1 << 1) /* Byte enable bits enable */
+#define WRRD_EN(x) (x & 0x01)
+#define WRITE_CFG WRRD_EN(1)
+#define READ_CFG WRRD_EN(0)
+
+#define PCIE_CFG_ST 0x00000C40U
+#define CFG_ST_ERROR (0x1U << 1)
+#define CFG_ST_DONE 0x1U
+
+#define PCIE_CFG_ADDR 0x00000C44U
+#define PCIE_CFG_WDATA 0x00000C48U
+#define PCIE_CFG_RDATA 0x00000C4CU
+
+/*
+ * Memory / IO Access
+ * the following registers are used to access configuration
+ * space
+ */
+#define PCIE_MIO_CT 0x00000C50U
+#define PCIE_MIO_EN 0x00000C54U
+
+#define TIMEOUT_CNT_VAL(x) ((x & 0xFFFFFFF) << 8)
+
+#define PCIE_MIO_ST 0x00000C58U
+#define PCIE_MIO_ADDR 0x00000C5CU
+#define PCIE_MIO_WDATA 0x00000C60U
+#define PCIE_MIO_RDATA 0x00000C64U
+
+/*
+ * MISC
+ */
+#define PCIE_CTR 0x00000C68U
+#define PCIE_PWR_CTR 0x00000C6CU
+#define PCIE_DBG 0x00000C70U
+#define PCIE_DIR_ST 0x00000C74U /* Status for Direct Access */
+#define CFG_RERROR_ST (0x1U << 1)
+#define MIO_RERROR_ST (0x1U)
+
+#define PCIE_DIR_EN 0x00000C78U
+#define TIMEOUT_EN (0x1U)
+
+#define PCIE_MAC_ST 0x00000CB4
+#define RDLH_LINK_UP (0x1U << 14)
+#define PM_XTLH_BLOCK_TLP (0x1U << 13)
+#define CFG_BUS_MASTER_EN (0x1U << 12)
+#define CFG_PM_NO_SOFT_RST (0x1U << 11)
+#define XMLH_LINK_UP (0x1U << 10)
+#define LINK_REQ_RST_NOT (0x1U << 9)
+#define XMLH_LTSSM_STATE(x) ((x & 0xF) << 4)
+#define PM_CURNT_STATE(x) ((x & 0x7) << 1)
+#define CFG_CLK_REQ_N (0x1U)
+
+/*
+ * PCI-E RC registers
+ */
+#define PCI_CFG_REG 0x00000000U /* PCI compatible registers */
+#define PCIE_DEV_REG 0x00000040U /* PCI-E Device Configuration Space */
+#define PCIE_EXT_REG 0x00000100U /* PCI-E Extend Configuration Space */
+#define PCIE_DVR_REG 0x00000C00U /* DVR space register */
+
+#define CFG(addr) (PCI_CFG_REG + (addr))
+#define BAR1 0x10
+#define BAR2 0x14
+#define BAR3 0x18
+#define BAR4 0x1C
+
+#define CFG_ST_DETEC_PAR_ERROR (1 << 31)
+#define CFG_ST_SIGNAL_SYS_ERROR (1 << 30)
+#define CFG_ST_REC_MASTER_ABORT (1 << 29)
+#define CFG_ST_REC_TARGET_ABORT (1 << 28)
+#define CFG_ST_SIG_TAR_ABORT (1 << 27)
+
+#define TIMEOUT_RESOLUTION 1
+#define PCIE_CONNECT_TIMEOUT 60
+
+#define RBUS1_TIMEOUT(x) ((x & 0x7) << 2)
+#define RBUS_TIMEOUT(x) (x & 0x3)
+
+#define ADDR_TO_DEVICE_NO(addr) ((addr >> 19) & 0x1F)
+
+static unsigned long _pci_bit_mask(unsigned char byte_mask)
+{
+	int i;
+	unsigned long mask = 0;
+
+	for (i = 0; i < 4; i++) {
+		if ((byte_mask >> i) & 0x1)
+			mask |= (0xFF << (i << 3));
+	}
+
+	return mask;
+}
+
+static unsigned long _pci_bit_shift(unsigned long addr)
+{
+	return ((addr & 0x3) << 3);
+}
+
+static unsigned long _pci_byte_mask(unsigned long addr, unsigned char size)
+{
+	unsigned char offset = (addr & 0x03);
+
+	switch (size) {
+	case 0x01:
+		return 0x1 << offset;
+	case 0x02:
+		if (offset <= 2)
+			return 0x3 << offset;
+
+		PCI_CFG_WARNING("compute config mask - data cross dword boundrary (addr=%p, length=2)\n", (void *) addr);
+
+		break;
+
+	case 0x03:
+		if (offset <= 1)
+			return 0x7 << offset;
+
+		PCI_CFG_WARNING("compute config mask - data cross dword boundrary (addr=%p, length=3)\n", (void *) addr);
+		break;
+
+	case 0x04:
+		if (offset == 0)
+			return 0xF;
+
+		PCI_CFG_WARNING("compute config mask - data cross dword boundrary (addr=%p, length=4)\n", (void *) addr);
+		break;
+
+	default:
+		PCI_CFG_WARNING("compute config mask failed - size %d should between 1~4\n", size);
+	}
+	return 0;
+}
+
+static unsigned long _pci_address_conversion(struct pci_bus *bus,
+						unsigned int devfn, int reg)
+{
+	int busno = bus->number;
+	int dev = PCI_SLOT(devfn);
+	int func = PCI_FUNC(devfn);
+
+	return (busno << 24) | (dev << 19) | (func << 16) | reg;
+}
+
+#endif /* RTK_PCIE_13xx_H_ */
diff --git a/drivers/pci/host/pcie-rtd16xx-slot1.c b/drivers/pci/host/pcie-rtd16xx-slot1.c
new file mode 100644
index 00000000..c0eae6b
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd16xx-slot1.c
@@ -0,0 +1,960 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/gpio.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/of_gpio.h>
+#include <linux/of_address.h>
+#include <linux/of_pci.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <linux/pci.h>
+#include <linux/platform_device.h>
+#include <linux/resource.h>
+#include <linux/signal.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+#include <linux/suspend.h>
+#include <linux/kthread.h>
+#include <linux/spinlock.h>
+#include "pcie-rtd16xx.h"
+
+
+spinlock_t rtk_pcie_16xx_lock;
+#define PCIE_IO_2K_MASK  0xFFFFF800
+#define PCIE_IO_4K_MASK  0xFFFFF000
+#define PCIE_IO_64K_MASK 0xFFFF0000
+
+
+static void __iomem *PCIE_CTRL_BASE;
+static void __iomem *PCIE_CFG_BASE;
+
+
+static void __iomem *SYSTEM_BASE1;
+static void __iomem *SYSTEM_BASE2;
+
+
+static u32 PCIE_MMIO_PHY_ADDR;
+static u32 PCIE_MMIO_PHY_ADDR_LEN;
+
+static u32 pcie_gpio;
+
+
+static u32 speed_mode;
+static u32 debug_mode;
+
+
+#define cfg_direct_access false
+
+static struct clk *pcie_clk;
+static struct reset_control *rstn_pcie_stitch;
+static struct reset_control *rstn_pcie;
+static struct reset_control *rstn_pcie_core;
+static struct reset_control *rstn_pcie_power;
+static struct reset_control *rstn_pcie_nonstitch;
+static struct reset_control *rstn_pcie_phy;
+static struct reset_control *rstn_pcie_phy_mdio;
+static struct reset_control *rstn_pcie_sgmii_mdio;
+
+static struct pci_bus *bus;
+static struct platform_device *local_pdev;
+
+static void rtk_pcie_16xx_ctrl_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CTRL_BASE);
+}
+
+static unsigned int rtk_pcie_16xx_ctrl_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CTRL_BASE);
+	return val;
+}
+
+static void rtk_pcie_16xx_direct_cfg_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie_16xx_direct_cfg_write_word(unsigned long addr, u16 val)
+{
+	writew(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie_16xx_direct_cfg_write_byte(unsigned long addr, u8 val)
+{
+	writeb(val, addr + PCIE_CFG_BASE);
+}
+
+static unsigned int rtk_pcie_16xx_direct_cfg_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u16 rtk_pcie_16xx_direct_cfg_read_word(unsigned long addr)
+{
+	u16 val = readw(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u8 rtk_pcie_16xx_direct_cfg_read_byte(unsigned long addr)
+{
+	u8 val = readb(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+
+u32 rtk_pcie_16xx_mmio_start(void)
+{
+	return PCIE_MMIO_PHY_ADDR;
+}
+
+u32 rtk_pcie_16xx_mmio_end(void)
+{
+	return (PCIE_MMIO_PHY_ADDR + (PCIE_MMIO_PHY_ADDR_LEN - 1));
+}
+
+u32 rtk_pcie_16xx_mmio_len(void)
+{
+	return PCIE_MMIO_PHY_ADDR_LEN;
+}
+
+u32 rtk_pcie_16xx_read(u32 addr, u8 size)
+{
+	u32 rval = 0;
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+	u32 pci_error_status = 0;
+	int retry_cnt = 0;
+	u8 retry = 5;
+
+	spin_lock_irqsave(&rtk_pcie_16xx_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie_16xx_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie_16xx_ctrl_read(0xD04);
+		rtk_pcie_16xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie_16xx_ctrl_read(0xD04);
+		rtk_pcie_16xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+
+pci_read_16xx_retry:
+
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rval = rtk_pcie_16xx_direct_cfg_read_byte((addr & ~mask));
+		break;
+	case 2:
+		rval = rtk_pcie_16xx_direct_cfg_read_word((addr & ~mask));
+		break;
+	case 4:
+		rval = rtk_pcie_16xx_direct_cfg_read((addr & ~mask));
+		break;
+	default:
+		pr_info("RTD16xx: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	//DLLP error patch
+	pci_error_status = rtk_pcie_16xx_ctrl_read(0xc7c);
+	if (pci_error_status & 0x1F) {
+		rtk_pcie_16xx_ctrl_write(0xc7c, pci_error_status);
+		pr_info("RTD16xx: %s: DLLP(#%d) 0x%x reg=0x%x val=0x%x\n",
+			__func__, retry_cnt, pci_error_status, addr, rval);
+
+		if (retry_cnt < retry) {
+			retry_cnt++;
+			goto pci_read_16xx_retry;
+		}
+	}
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie_16xx_ctrl_write(0xD04, translate_val);
+		rtk_pcie_16xx_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie_16xx_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie_16xx_lock, irqL);
+
+	return rval;
+}
+EXPORT_SYMBOL(rtk_pcie_16xx_read);
+
+void rtk_pcie_16xx_write(u32 addr, u8 size, u32 wval)
+{
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+
+	spin_lock_irqsave(&rtk_pcie_16xx_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie_16xx_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie_16xx_ctrl_read(0xD04);
+		rtk_pcie_16xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie_16xx_ctrl_read(0xD04);
+		rtk_pcie_16xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rtk_pcie_16xx_direct_cfg_write_byte((addr&~mask), wval);
+		break;
+	case 2:
+		rtk_pcie_16xx_direct_cfg_write_word((addr&~mask), wval);
+		break;
+	case 4:
+		rtk_pcie_16xx_direct_cfg_write((addr&~mask), wval);
+		break;
+	default:
+		pr_info("RTD16xx: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie_16xx_ctrl_write(0xD04, translate_val);
+		rtk_pcie_16xx_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie_16xx_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie_16xx_lock, irqL);
+}
+EXPORT_SYMBOL(rtk_pcie_16xx_write);
+
+static int _indirect_cfg_write(unsigned long addr,
+					unsigned long data,
+					unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 1000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	data = (data << _pci_bit_shift(addr)) & _pci_bit_mask(mask);
+
+	rtk_pcie_16xx_ctrl_write(PCIE_INDIR_CTR, 0x12);
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_ADDR, addr);
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_WDATA, data);
+
+	if (size == 4)
+		rtk_pcie_16xx_ctrl_write(PCIE_CFG_EN, 0x1);
+	else
+		rtk_pcie_16xx_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(1));
+
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie_16xx_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Write config data (%p) failed - timeout\n",
+				(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie_16xx_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Write config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Write config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Write config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Write config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Write config data failed - tar abort\n");
+
+		goto error_occur;
+	}
+
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SET_FAILED;
+}
+
+static int _indirect_cfg_read(unsigned long addr, u32 *pdata,
+						unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 20000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	rtk_pcie_16xx_ctrl_write(PCIE_INDIR_CTR, 0x10);
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_ST, 0x3);
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_ADDR, (addr & ~0x3));
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(0));
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie_16xx_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Read config data (%p) failed - timeout\n",
+								(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie_16xx_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Read config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Read config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Read config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Read config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Read config data failed - tar abort\n");
+		goto error_occur;
+	}
+
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_ST, 0x3);
+
+	*pdata = (rtk_pcie_16xx_ctrl_read(PCIE_CFG_RDATA) & _pci_bit_mask(mask))
+							>> _pci_bit_shift(addr);
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+	rtk_pcie_16xx_ctrl_write(PCIE_CFG_ST, 0x3);
+	return PCIBIOS_SET_FAILED;
+}
+
+static int rtk_pcie_16xx_rd_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 *pval)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+	u32 val = 0;
+	u8 retry = 5;
+
+
+again:
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if (cfg_direct_access) {
+
+			rtk_pcie_16xx_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				*pval = rtk_pcie_16xx_direct_cfg_read_byte(reg);
+			else if (size == 2)
+				*pval = rtk_pcie_16xx_direct_cfg_read_word(reg);
+			else if (size == 4)
+				*pval = rtk_pcie_16xx_direct_cfg_read(reg);
+
+			rtk_pcie_16xx_ctrl_write(0xD00, 0xFFF00000);
+
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_read(address, pval, size);
+		}
+	}
+
+	val = rtk_pcie_16xx_ctrl_read(0xC7C);
+	if ((val & 0x1f) && retry) {
+		rtk_pcie_16xx_ctrl_write(0xC7C, val);
+		retry--;
+		dev_err(&bus->dev, "pcie dllp error occur = 0x%x\n", val);
+		goto again;
+	}
+
+	//dev_info(&bus->dev, "rtk_pcie_16xx_rd_conf reg = 0x%x, devfun:%d, size=%d, *pval = 0x%x\n",
+	//							reg, devfn, size, *pval);
+
+	return ret;
+}
+
+static int rtk_pcie_16xx_wr_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 val)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+
+	//dev_info(&bus->dev, "rtk_pcie_16xx_wr_conf reg = 0x%x, val = 0x%x\n",
+	//							reg, val);
+
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if ((reg == 0x10) || (reg == 0x18) ||
+				(reg == 0x20) || (reg == 0x24)) {
+			if ((val & 0x98070000) == 0x98070000 || (val & 0x98060000) == 0x98060000 ) {
+				rtk_pcie_16xx_ctrl_write(0xD04,
+						(val&0xfffffff0));
+			}
+		}
+
+		if (cfg_direct_access) {
+			rtk_pcie_16xx_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				rtk_pcie_16xx_direct_cfg_write_byte(reg, val);
+			else if (size == 2)
+				rtk_pcie_16xx_direct_cfg_write_word(reg, val);
+			else if (size == 4)
+				rtk_pcie_16xx_direct_cfg_write(reg, val);
+
+			rtk_pcie_16xx_ctrl_write(0xD00, 0xFFF00000);
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_write(address, val, size);
+		}
+	}
+
+	return ret;
+}
+
+static struct pci_ops rtk_pcie_16xx_ops = {
+	.read = rtk_pcie_16xx_rd_conf,
+	.write = rtk_pcie_16xx_wr_conf,
+};
+
+static int rtk_pcie_16xx_hw_initial(struct device *dev)
+{
+	bool pci_link_detected;
+	int timeout = 0;
+	int ret = 0;
+	u32 val;
+	u32 *phy;
+	int size = 0, i = 0;
+
+	/* 0x9801C814[2:0] = 1 */
+	val = readl(SYSTEM_BASE1 + 0x14);
+	val &= (~0x7);
+	val |= 0x1;
+	writel(val, SYSTEM_BASE1 + 0x14);
+
+	/* 0x9801C804[3:0] = 0  --PCIE */
+	val = readl(SYSTEM_BASE1 + 0x4);
+	val &= (~0xf);
+	writel(val, SYSTEM_BASE1 + 0x4);
+
+	/* 0x9801C808[7:0] = 1 */
+	writeb(0x1, SYSTEM_BASE1 + 0x8);
+
+	reset_control_deassert(rstn_pcie_stitch);
+	reset_control_deassert(rstn_pcie);
+	reset_control_deassert(rstn_pcie_core);
+	reset_control_deassert(rstn_pcie_power);
+	reset_control_deassert(rstn_pcie_nonstitch);
+	reset_control_deassert(rstn_pcie_phy);
+	reset_control_deassert(rstn_pcie_phy_mdio);
+	reset_control_deassert(rstn_pcie_sgmii_mdio);
+
+	ret = clk_prepare_enable(pcie_clk);
+
+	if (ret) {
+		dev_err(dev, "unable to enable pcie1_clk clock\n");
+		clk_disable_unprepare(pcie_clk);
+		return -EINVAL;
+	}
+
+
+	rtk_pcie_16xx_ctrl_write(0xC00, 0x00140010);
+
+	if (speed_mode == 0) {
+		rtk_pcie_16xx_ctrl_write(0x0A0,
+			(rtk_pcie_16xx_ctrl_read(0x0A0)&0xFFFFFFF0)|0x00000001);
+	}
+
+
+	/*phy mdio setting*/
+	size = of_property_count_u32_elems(dev->of_node, "phys");
+	phy = kmalloc(size * sizeof(u32), GFP_KERNEL);
+	of_property_read_u32_array(dev->of_node, "phys", phy, size);
+	for (i = 0; i < size; i++) {
+		rtk_pcie_16xx_ctrl_write(0xC1C, phy[i]);
+		udelay(100);
+	}
+	kfree(phy);
+
+	// after phy mdio set
+	ret = gpio_direction_output(pcie_gpio, 1);
+
+
+	/* set to MMIO */
+	if (cfg_direct_access)
+		rtk_pcie_16xx_ctrl_write(0xC00, 0x00BE0002);
+	else
+		rtk_pcie_16xx_ctrl_write(0xC00, 0x001E0022);
+
+	mdelay(1);
+
+	/* #Link initial setting */
+	rtk_pcie_16xx_ctrl_write(0x710, 0x00010120);
+
+	do {
+		pci_link_detected = (rtk_pcie_16xx_ctrl_read(0xCB4) & 0x800);
+		if (!pci_link_detected) {
+			mdelay(TIMEOUT_RESOLUTION);
+			timeout += TIMEOUT_RESOLUTION;
+		}
+	} while (!pci_link_detected && timeout < PCIE_CONNECT_TIMEOUT);
+
+	if (pci_link_detected) {
+		dev_err(dev, "PCIE device has link up in slot 1\n");
+	} else {
+		if (!debug_mode) { /*do not turn off clk in debug mode*/
+			reset_control_assert(rstn_pcie_stitch);
+			reset_control_assert(rstn_pcie);
+			reset_control_assert(rstn_pcie_core);
+			reset_control_assert(rstn_pcie_power);
+			reset_control_assert(rstn_pcie_nonstitch);
+			reset_control_assert(rstn_pcie_phy);
+			reset_control_assert(rstn_pcie_phy_mdio);
+			reset_control_assert(rstn_pcie_sgmii_mdio);
+
+			clk_disable_unprepare(pcie_clk);
+		}
+		gpio_free(pcie_gpio);
+
+		dev_err(dev, "PCIE device has link down in slot 1\n");
+		return -ENODEV;
+	}
+
+
+	/* make sure DBI is working */
+	rtk_pcie_16xx_ctrl_write(0x04, 0x00000007);
+
+	if (cfg_direct_access) {
+		/* #Base 1 */
+		rtk_pcie_16xx_ctrl_write(0xD08, 0x98061000);
+
+		/* #Mask 1 */
+		rtk_pcie_16xx_ctrl_write(0xD0C, 0xFFFFF000);
+
+		/* #translate for CFG R/W */
+		rtk_pcie_16xx_ctrl_write(0xD10, 0x00000000);
+	}
+	/* #Base 0 */
+	rtk_pcie_16xx_ctrl_write(0xCFC, 0x98062000);
+
+	/* #Mask 0 */
+	rtk_pcie_16xx_ctrl_write(0xD00, 0xFFF00000);
+
+	/* #translate for MMIO R/W */
+	rtk_pcie_16xx_ctrl_write(0xD04, 0x00000000);
+
+	/*pcie timeout extend to 100*/
+	rtk_pcie_16xx_ctrl_write(0xC78, 0xBEBC2001);
+
+	/* set limit and base register */
+	rtk_pcie_16xx_ctrl_write(0x20, 0x0000FFF0);
+	rtk_pcie_16xx_ctrl_write(0x24, 0x0000FFF0);
+
+	return ret;
+}
+
+static int rtk_pcie_16xx_probe(struct platform_device *pdev)
+{
+	int ret = 0;
+	int size = 0;
+	const u32 *prop, *prop2;
+	struct resource pcie_mmio_res;
+	struct pci_dev *dev;
+
+	resource_size_t iobase = 0;
+	LIST_HEAD(res);
+
+	local_pdev = pdev;
+
+	spin_lock_init(&rtk_pcie_16xx_lock);
+
+	dev_info(&pdev->dev, "PCIE host driver initial begin.\n");
+
+	prop = of_get_property(pdev->dev.of_node, "speed-mode", &size);
+	if (prop) {
+		speed_mode = of_read_number(prop, 1);
+		if (speed_mode == 0)
+			dev_info(&pdev->dev, "Speed Mode: GEN1\n");
+		else if (speed_mode == 1)
+			dev_info(&pdev->dev, "Speed Mode: GEN2\n");
+	} else {
+		speed_mode = 0;
+	}
+
+	prop2 = of_get_property(pdev->dev.of_node, "debug-mode", &size);
+	if (prop2) {
+		debug_mode = of_read_number(prop2, 1);
+		if (debug_mode == 0)
+			dev_info(&pdev->dev, "PCIE Debug Mode off\n");
+		else if (debug_mode == 1)
+			dev_info(&pdev->dev, "PCIE Debug Mode on\n");
+	} else {
+		debug_mode = 0;
+	}
+
+	PCIE_CTRL_BASE = of_iomap(pdev->dev.of_node, 0);
+	if (!PCIE_CTRL_BASE) {
+		dev_err(&pdev->dev, "pcie no ctrl address\n");
+		return -EINVAL;
+	}
+
+	PCIE_CFG_BASE = of_iomap(pdev->dev.of_node, 1);
+	if (!PCIE_CFG_BASE) {
+		dev_err(&pdev->dev, "pcie no cfg address\n");
+		return -EINVAL;
+	} else {
+		of_address_to_resource(pdev->dev.of_node, 1, &pcie_mmio_res);
+		PCIE_MMIO_PHY_ADDR = pcie_mmio_res.start;
+		PCIE_MMIO_PHY_ADDR_LEN = resource_size(&pcie_mmio_res);
+	}
+
+
+	SYSTEM_BASE1 = of_iomap(pdev->dev.of_node, 2);
+	if (!SYSTEM_BASE1) {
+		dev_err(&pdev->dev, "pcie no base1 address\n");
+		return -EINVAL;
+	}
+
+	SYSTEM_BASE2 = of_iomap(pdev->dev.of_node, 3);
+	if (!SYSTEM_BASE2) {
+		dev_err(&pdev->dev, "pcie no base2 address\n");
+		return -EINVAL;
+	}
+
+
+
+	pcie_gpio = of_get_gpio_flags(pdev->dev.of_node, 0, NULL);
+	if (gpio_is_valid(pcie_gpio)) {
+		ret = gpio_request(pcie_gpio, "pcie_gpio");
+		if (ret < 0)
+			pr_err("%s: can't request gpio %d\n",
+						__func__, pcie_gpio);
+	} else {
+		pr_err("%s: gpio %d is not valid\n", __func__, pcie_gpio);
+	}
+
+	pcie_clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(pcie_clk)) {
+		dev_err(&pdev->dev, "pcie clock source missing or invalid\n");
+		return PTR_ERR(pcie_clk);
+	}
+
+	rstn_pcie_stitch = devm_reset_control_get(&pdev->dev, "stitch");
+	if (rstn_pcie_stitch == NULL) {
+		dev_err(&pdev->dev, "stitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie = devm_reset_control_get(&pdev->dev, "rstn");
+	if (rstn_pcie == NULL) {
+		dev_err(&pdev->dev, "rstn_pcie source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_core = devm_reset_control_get(&pdev->dev, "core");
+	if (rstn_pcie_core == NULL) {
+		dev_err(&pdev->dev, "core source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_power = devm_reset_control_get(&pdev->dev, "power");
+	if (rstn_pcie_power == NULL) {
+		dev_err(&pdev->dev, "power source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_nonstitch = devm_reset_control_get(&pdev->dev, "nonstitch");
+	if (rstn_pcie_nonstitch == NULL) {
+		dev_err(&pdev->dev, "nonstitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_phy = devm_reset_control_get(&pdev->dev, "phy");
+	if (rstn_pcie_phy == NULL) {
+		dev_err(&pdev->dev, "phy source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_phy_mdio = devm_reset_control_get(&pdev->dev, "phy_mdio");
+	if (rstn_pcie_phy_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing. or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie_sgmii_mdio = devm_reset_control_get(&pdev->dev, "sgmii_mdio");
+	if (rstn_pcie_sgmii_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing. or invalid\n");
+		return -EINVAL;
+	}
+
+	reset_control_assert(rstn_pcie_stitch);
+	reset_control_assert(rstn_pcie);
+	reset_control_assert(rstn_pcie_core);
+	reset_control_assert(rstn_pcie_power);
+	reset_control_assert(rstn_pcie_nonstitch);
+	reset_control_assert(rstn_pcie_phy);
+	reset_control_assert(rstn_pcie_phy_mdio);
+	reset_control_assert(rstn_pcie_sgmii_mdio);
+
+
+	if (rtk_pcie_16xx_hw_initial(&pdev->dev) < 0) {
+		dev_err(&pdev->dev, "rtk_pcie_16xx_hw_initial fail\n");
+		return -EINVAL;
+	}
+
+	/*-------------------------------------------
+	 * Register PCI-E host
+	 *-------------------------------------------
+	 */
+
+	ret = of_pci_get_host_bridge_resources(pdev->dev.of_node,
+					0x1, 0xff, &res, &iobase);
+	if (ret)
+		return ret;
+
+	bus = pci_create_root_bus(&pdev->dev, 1,
+				&rtk_pcie_16xx_ops, NULL, &res);
+
+	if (!bus)
+		return -ENOMEM;
+
+	pci_scan_child_bus(bus);
+	pci_assign_unassigned_bus_resources(bus);
+	pci_bus_add_devices(bus);
+
+#if defined(CONFIG_CPU_V7)
+	list_for_each_entry(dev, &bus->devices, bus_list) {
+		dev->irq = of_irq_parse_and_map_pci(dev, 0, 0);
+	}
+#endif
+
+
+	dev_info(&pdev->dev, "PCIE host driver initial done.\n");
+
+	return ret;
+}
+#ifdef CONFIG_SUSPEND
+static int rtk_pcie_16xx_suspend(struct device *dev)
+{
+	dev_info(dev, "suspend enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie_16xx_ctrl_write(0x178, 0xA3FF0001);
+		rtk_pcie_16xx_ctrl_write(0x098, 0x400);
+		rtk_pcie_16xx_ctrl_write(0xC6C, 0x00000031);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+		gpio_direction_output(pcie_gpio, 0);
+
+		reset_control_assert(rstn_pcie_stitch);
+		reset_control_assert(rstn_pcie);
+		reset_control_assert(rstn_pcie_core);
+		reset_control_assert(rstn_pcie_power);
+		reset_control_assert(rstn_pcie_nonstitch);
+		reset_control_assert(rstn_pcie_phy);
+		reset_control_assert(rstn_pcie_phy_mdio);
+		reset_control_assert(rstn_pcie_sgmii_mdio);
+		clk_disable_unprepare(pcie_clk);
+		gpio_free(pcie_gpio);
+
+	}
+
+	dev_info(dev, "suspend exit ...\n");
+
+	return 0;
+}
+
+static int rtk_pcie_16xx_resume(struct device *dev)
+{
+	int ret = 0;
+
+	dev_info(dev, "resume enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie_16xx_ctrl_write(0xC6C, 0x00000032);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+		if (gpio_is_valid(pcie_gpio)) {
+			ret = gpio_request(pcie_gpio, "pcie_gpio");
+			if (ret < 0)
+				pr_err("%s: can't request gpio %d\n",
+						__func__, pcie_gpio);
+		} else
+			pr_err("%s: gpio %d is not valid\n",
+						__func__, pcie_gpio);
+
+		reset_control_deassert(rstn_pcie_stitch);
+		reset_control_deassert(rstn_pcie);
+		reset_control_deassert(rstn_pcie_core);
+		reset_control_deassert(rstn_pcie_power);
+		reset_control_deassert(rstn_pcie_nonstitch);
+		reset_control_deassert(rstn_pcie_phy);
+		reset_control_deassert(rstn_pcie_phy_mdio);
+		reset_control_deassert(rstn_pcie_sgmii_mdio);
+		ret = clk_prepare_enable(pcie_clk);
+		if (ret) {
+			dev_err(dev, "unable to enable pcie_clk clock\n");
+			clk_disable_unprepare(pcie_clk);
+			return -EINVAL;
+		}
+
+		if (rtk_pcie_16xx_hw_initial(dev) < 0) {
+			dev_err(dev, "rtk_pcie_16xx_hw_initial fail\n");
+			return -EINVAL;
+		}
+
+
+		if (cfg_direct_access)
+			rtk_pcie_16xx_ctrl_write(0xC00, 0x00BE0002);
+		else
+			rtk_pcie_16xx_ctrl_write(0xC00, 0x001E0022);
+	}
+
+	dev_info(dev, "resume exit ...\n");
+
+	return ret;
+}
+
+static void rtk_pcie_16xx_shutdown(struct platform_device *pdev)
+{
+	dev_info(&pdev->dev, "shutdown enter ...\n");
+
+	dev_info(&pdev->dev, "shutdown mode\n");
+
+	reset_control_assert(rstn_pcie_stitch);
+	reset_control_assert(rstn_pcie);
+	reset_control_assert(rstn_pcie_core);
+	reset_control_assert(rstn_pcie_power);
+	reset_control_assert(rstn_pcie_nonstitch);
+	reset_control_assert(rstn_pcie_phy);
+	reset_control_assert(rstn_pcie_phy_mdio);
+	reset_control_assert(rstn_pcie_sgmii_mdio);
+	clk_disable_unprepare(pcie_clk);
+	gpio_free(pcie_gpio);
+
+	dev_info(&pdev->dev, "shutdown exit ...\n");
+}
+
+
+static const struct dev_pm_ops rtk_pcie_16xx_pm_ops = {
+	.suspend_noirq = rtk_pcie_16xx_suspend,
+	.resume_noirq = rtk_pcie_16xx_resume,
+};
+#endif //CONFIG_SUSPEND
+static const struct of_device_id rtk_pcie_16xx_match_table[] = {
+	{.compatible = "realtek,rtk16xx-pcie-slot1",},
+	{},
+};
+
+static struct platform_driver rtk_pcie_16xx_driver = {
+	.driver = {
+		.name = "[RTD16xx PCIE1]",
+		.of_match_table = of_match_ptr(rtk_pcie_16xx_match_table),
+#ifdef CONFIG_SUSPEND
+		.pm = &rtk_pcie_16xx_pm_ops,
+#endif
+	},
+	.probe = rtk_pcie_16xx_probe,
+	.shutdown = rtk_pcie_16xx_shutdown,
+};
+module_platform_driver(rtk_pcie_16xx_driver);
+
+MODULE_AUTHOR("James Tai <james.tai@realtek.com>");
+MODULE_DESCRIPTION("Realtek PCIe host controller driver");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/pci/host/pcie-rtd16xx-slot2.c b/drivers/pci/host/pcie-rtd16xx-slot2.c
new file mode 100644
index 00000000..9a987b9
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd16xx-slot2.c
@@ -0,0 +1,954 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/gpio.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/of_gpio.h>
+#include <linux/of_address.h>
+#include <linux/of_pci.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <linux/pci.h>
+#include <linux/platform_device.h>
+#include <linux/resource.h>
+#include <linux/signal.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+#include <linux/suspend.h>
+#include <linux/kthread.h>
+#include <linux/spinlock.h>
+#include "pcie-rtd16xx.h"
+
+
+spinlock_t rtk_pcie2_16xx_lock;
+#define PCIE_IO_2K_MASK  0xFFFFF800
+#define PCIE_IO_4K_MASK  0xFFFFF000
+#define PCIE_IO_64K_MASK 0xFFFF0000
+
+
+static void __iomem *PCIE_CTRL_BASE;
+static void __iomem *PCIE_CFG_BASE;
+
+
+static void __iomem *SYSTEM_BASE1;
+static void __iomem *PINMUX_BASE;
+
+
+static u32 PCIE_MMIO_PHY_ADDR;
+static u32 PCIE_MMIO_PHY_ADDR_LEN;
+
+static u32 pcie2_gpio;
+
+
+static u32 speed_mode;
+static u32 debug_mode;
+
+
+#define cfg_direct_access false
+
+static struct clk *pcie2_clk;
+static struct reset_control *rstn_pcie2_stitch;
+static struct reset_control *rstn_pcie2;
+static struct reset_control *rstn_pcie2_core;
+static struct reset_control *rstn_pcie2_power;
+static struct reset_control *rstn_pcie2_nonstitch;
+static struct reset_control *rstn_pcie2_phy;
+static struct reset_control *rstn_pcie2_phy_mdio;
+
+static struct pci_bus *bus;
+static struct platform_device *local_pdev;
+
+static void rtk_pcie2_16xx_ctrl_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CTRL_BASE);
+}
+
+static unsigned int rtk_pcie2_16xx_ctrl_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CTRL_BASE);
+	return val;
+}
+
+static void rtk_pcie2_16xx_direct_cfg_write(unsigned long addr, unsigned int val)
+{
+	writel(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie2_16xx_direct_cfg_write_word(unsigned long addr, u16 val)
+{
+	writew(val, addr + PCIE_CFG_BASE);
+}
+
+static void rtk_pcie2_16xx_direct_cfg_write_byte(unsigned long addr, u8 val)
+{
+	writeb(val, addr + PCIE_CFG_BASE);
+}
+
+static unsigned int rtk_pcie2_16xx_direct_cfg_read(unsigned long addr)
+{
+	unsigned int val = readl(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u16 rtk_pcie2_16xx_direct_cfg_read_word(unsigned long addr)
+{
+	u16 val = readw(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+static u8 rtk_pcie2_16xx_direct_cfg_read_byte(unsigned long addr)
+{
+	u8 val = readb(addr + PCIE_CFG_BASE);
+	return val;
+}
+
+
+u32 rtk_pcie2_16xx_mmio_start(void)
+{
+	return PCIE_MMIO_PHY_ADDR;
+}
+
+u32 rtk_pcie2_16xx_mmio_end(void)
+{
+	return (PCIE_MMIO_PHY_ADDR + (PCIE_MMIO_PHY_ADDR_LEN - 1));
+}
+
+u32 rtk_pcie2_16xx_mmio_len(void)
+{
+	return PCIE_MMIO_PHY_ADDR_LEN;
+}
+
+u32 rtk_pcie2_16xx_read(u32 addr, u8 size)
+{
+	u32 rval = 0;
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+	u32 pci_error_status = 0;
+	int retry_cnt = 0;
+	u8 retry = 5;
+
+	spin_lock_irqsave(&rtk_pcie2_16xx_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie2_16xx_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie2_16xx_ctrl_read(0xD04);
+		rtk_pcie2_16xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie2_16xx_ctrl_read(0xD04);
+		rtk_pcie2_16xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+
+pci_read_16xx_retry:
+
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rval = rtk_pcie2_16xx_direct_cfg_read_byte((addr & ~mask));
+		break;
+	case 2:
+		rval = rtk_pcie2_16xx_direct_cfg_read_word((addr & ~mask));
+		break;
+	case 4:
+		rval = rtk_pcie2_16xx_direct_cfg_read((addr & ~mask));
+		break;
+	default:
+		pr_info("RTD16xx: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+#if 0 /* ToDo: Fix me */
+
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	//DLLP error patch
+	pci_error_status = rtk_pcie2_16xx_ctrl_read(0xc7c);
+	if (pci_error_status & 0x1F) {
+		rtk_pcie2_16xx_ctrl_write(0xc7c, pci_error_status);
+		pr_info("RTD16xx: %s: DLLP(#%d) 0x%x reg=0x%x val=0x%x\n",
+			__func__, retry_cnt, pci_error_status, addr, rval);
+
+		if (retry_cnt < retry) {
+			retry_cnt++;
+			goto pci_read_16xx_retry;
+		}
+	}
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie2_16xx_ctrl_write(0xD04, translate_val);
+		rtk_pcie2_16xx_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie2_16xx_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie2_16xx_lock, irqL);
+
+	return rval;
+}
+EXPORT_SYMBOL(rtk_pcie2_16xx_read);
+
+void rtk_pcie2_16xx_write(u32 addr, u8 size, u32 wval)
+{
+	u32 mask;
+	u32 translate_val = 0;
+	u32 tmp_addr = addr & 0xFFF;
+	unsigned long irqL;
+
+	spin_lock_irqsave(&rtk_pcie2_16xx_lock, irqL);
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		mask = PCIE_IO_2K_MASK;
+		rtk_pcie2_16xx_ctrl_write(0xD00, PCIE_IO_2K_MASK);
+		translate_val = rtk_pcie2_16xx_ctrl_read(0xD04);
+		rtk_pcie2_16xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else if (addr >= 0x10000) {
+		mask = PCIE_IO_64K_MASK;
+		translate_val = rtk_pcie2_16xx_ctrl_read(0xD04);
+		rtk_pcie2_16xx_ctrl_write(0xD04, translate_val | (addr & mask));
+	} else
+		mask = 0x0;
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	/* All RBUS1 driver need to have a workaround
+	 * for emmc hardware error.
+	 * Need to protect 0xXXXX_X8XX~ 0xXXXX_X9XX.
+	 */
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_lock(flags, __func__);
+#endif
+#endif
+
+	switch (size) {
+	case 1:
+		rtk_pcie2_16xx_direct_cfg_write_byte((addr&~mask), wval);
+		break;
+	case 2:
+		rtk_pcie2_16xx_direct_cfg_write_word((addr&~mask), wval);
+		break;
+	case 4:
+		rtk_pcie2_16xx_direct_cfg_write((addr&~mask), wval);
+		break;
+	default:
+		pr_info("RTD16xx: %s: wrong size %d\n", __func__, size);
+		break;
+	}
+
+#if 0 /* ToDo: Fix me */
+#ifdef CONFIG_RTK_SW_LOCK_API
+	if ((tmp_addr > 0x7FF) && (tmp_addr < 0xA00))
+		rtk_lockapi_unlock(flags, __func__);
+#endif
+#endif
+
+	/* PCIE1.1 0x9804FCEC, PCIE2.0 0x9803CCEC & 0x9803CC68
+	 * can't be used because of 1295 hardware issue.
+	 */
+	if (tmp_addr == 0xCEC || tmp_addr == 0xC68) {
+		rtk_pcie2_16xx_ctrl_write(0xD04, translate_val);
+		rtk_pcie2_16xx_ctrl_write(0xD00, PCIE_IO_64K_MASK);
+	} else if (addr >= 0x10000) {
+		rtk_pcie2_16xx_ctrl_write(0xD04, translate_val);
+	}
+
+	spin_unlock_irqrestore(&rtk_pcie2_16xx_lock, irqL);
+}
+EXPORT_SYMBOL(rtk_pcie2_16xx_write);
+
+static int _indirect_cfg_write(unsigned long addr,
+					unsigned long data,
+					unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 1000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	data = (data << _pci_bit_shift(addr)) & _pci_bit_mask(mask);
+
+	rtk_pcie2_16xx_ctrl_write(PCIE_INDIR_CTR, 0x12);
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_ADDR, addr);
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_WDATA, data);
+
+	if (size == 4)
+		rtk_pcie2_16xx_ctrl_write(PCIE_CFG_EN, 0x1);
+	else
+		rtk_pcie2_16xx_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(1));
+
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie2_16xx_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Write config data (%p) failed - timeout\n",
+				(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie2_16xx_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Write config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Write config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Write config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Write config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Write config data failed - tar abort\n");
+
+		goto error_occur;
+	}
+
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_ST, CFG_ST_ERROR|CFG_ST_DONE);
+
+	return PCIBIOS_SET_FAILED;
+}
+
+static int _indirect_cfg_read(unsigned long addr, u32 *pdata,
+						unsigned char size)
+{
+	unsigned long status;
+	unsigned char mask;
+	int try_count = 20000;
+
+	if (ADDR_TO_DEVICE_NO(addr) != 0)
+		return PCIBIOS_DEVICE_NOT_FOUND;
+
+	mask = _pci_byte_mask(addr, size);
+
+	if (!mask)
+		return PCIBIOS_SET_FAILED;
+
+	rtk_pcie2_16xx_ctrl_write(PCIE_INDIR_CTR, 0x10);
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_ST, 0x3);
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_ADDR, (addr & ~0x3));
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_EN,
+			BYTE_CNT(mask) | BYTE_EN | WRRD_EN(0));
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_CT, GO_CT);
+
+	do {
+		status = rtk_pcie2_16xx_ctrl_read(PCIE_CFG_ST);
+		udelay(50);
+	} while (!(status & CFG_ST_DONE) && try_count--);
+
+	if (try_count < 0) {
+		PCI_CFG_WARNING("Read config data (%p) failed - timeout\n",
+								(void *) addr);
+		goto error_occur;
+	}
+
+	if (rtk_pcie2_16xx_ctrl_read(PCIE_CFG_ST) & CFG_ST_ERROR) {
+		if (status & CFG_ST_DETEC_PAR_ERROR)
+			PCI_CFG_WARNING("Read config data failed - PAR error detected\n");
+		if (status & CFG_ST_SIGNAL_SYS_ERROR)
+			PCI_CFG_WARNING("Read config data failed - system error\n");
+		if (status & CFG_ST_REC_MASTER_ABORT)
+			PCI_CFG_WARNING("Read config data failed - master abort\n");
+		if (status & CFG_ST_REC_TARGET_ABORT)
+			PCI_CFG_WARNING("Read config data failed - target abort\n");
+		if (status & CFG_ST_SIG_TAR_ABORT)
+			PCI_CFG_WARNING("Read config data failed - tar abort\n");
+		goto error_occur;
+	}
+
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_ST, 0x3);
+
+	*pdata = (rtk_pcie2_16xx_ctrl_read(PCIE_CFG_RDATA) & _pci_bit_mask(mask))
+							>> _pci_bit_shift(addr);
+	return PCIBIOS_SUCCESSFUL;
+
+error_occur:
+	rtk_pcie2_16xx_ctrl_write(PCIE_CFG_ST, 0x3);
+	return PCIBIOS_SET_FAILED;
+}
+
+static int rtk_pcie2_16xx_rd_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 *pval)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+	u32 val = 0;
+	u8 retry = 5;
+
+
+again:
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if (cfg_direct_access) {
+
+			rtk_pcie2_16xx_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				*pval = rtk_pcie2_16xx_direct_cfg_read_byte(reg);
+			else if (size == 2)
+				*pval = rtk_pcie2_16xx_direct_cfg_read_word(reg);
+			else if (size == 4)
+				*pval = rtk_pcie2_16xx_direct_cfg_read(reg);
+
+			rtk_pcie2_16xx_ctrl_write(0xD00, 0xFFF00000);
+
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_read(address, pval, size);
+		}
+	}
+
+	val = rtk_pcie2_16xx_ctrl_read(0xC7C);
+	if ((val & 0x1f) && retry) {
+		rtk_pcie2_16xx_ctrl_write(0xC7C, val);
+		retry--;
+		dev_err(&bus->dev, "pcie dllp error occur = 0x%x\n", val);
+		goto again;
+	}
+
+	//dev_info(&bus->dev, "rtk_pcie2_16xx_rd_conf reg = 0x%x, devfun:%d, size=%d, *pval = 0x%x\n",
+	//							reg, devfn, size, *pval);
+
+	return ret;
+}
+
+static int rtk_pcie2_16xx_wr_conf(struct pci_bus *bus, unsigned int devfn,
+			     int reg, int size, u32 val)
+{
+	unsigned long address;
+	int ret = PCIBIOS_DEVICE_NOT_FOUND;
+
+	//dev_info(&bus->dev, "rtk_pcie2_16xx_wr_conf reg = 0x%x, val = 0x%x\n",
+	//							reg, val);
+
+	if (bus->number == 1 && PCI_SLOT(devfn) == 0 && PCI_FUNC(devfn) == 0) {
+		if ((reg == 0x10) || (reg == 0x18) ||
+				(reg == 0x20) || (reg == 0x24)) {
+			if ((val & 0x980B0000) == 0x980B0000 || (val & 0x980A0000) == 0x980A0000 ) {
+				rtk_pcie2_16xx_ctrl_write(0xD04,
+						(val&0xfffffff0));
+			}
+		}
+
+		if (cfg_direct_access) {
+			rtk_pcie2_16xx_ctrl_write(0xD00, 0xFFFFF000);
+
+			if (size == 1)
+				rtk_pcie2_16xx_direct_cfg_write_byte(reg, val);
+			else if (size == 2)
+				rtk_pcie2_16xx_direct_cfg_write_word(reg, val);
+			else if (size == 4)
+				rtk_pcie2_16xx_direct_cfg_write(reg, val);
+
+			rtk_pcie2_16xx_ctrl_write(0xD00, 0xFFF00000);
+			ret = PCIBIOS_SUCCESSFUL;
+
+		} else {
+			address = _pci_address_conversion(bus, devfn, reg);
+			ret = _indirect_cfg_write(address, val, size);
+		}
+	}
+
+	return ret;
+}
+
+static struct pci_ops rtk_pcie_16xx_ops = {
+	.read = rtk_pcie2_16xx_rd_conf,
+	.write = rtk_pcie2_16xx_wr_conf,
+};
+
+static int rtk_pcie2_16xx_hw_initial(struct device *dev)
+{
+	bool pci_link_detected;
+	int timeout = 0;
+	int ret = 0;
+	u32 val;
+	u32 *phy;
+	int size = 0, i = 0;
+
+
+	/* 0x9804F050[8] = 1*/
+	val = readl(PINMUX_BASE + 0x50);
+	val &= (~(0x1 << 8));
+	writel(val, PINMUX_BASE + 0x50);
+
+	/* 0x9801C614[2:0] = 1 */
+	val = readl(SYSTEM_BASE1 + 0x14);
+	val &= (~0x7);
+	val |= 0x1;
+	writel(val, SYSTEM_BASE1 + 0x14);
+
+	/* 0x9801C604[16:19] = 0  --PCIE */
+	val = readl(SYSTEM_BASE1 + 0x4);
+	val &= (~(0xf << 16));
+	writel(val, SYSTEM_BASE1 + 0x4);
+
+	/* 0x9801C608[7:0] = 4 */
+	writeb(0x4, SYSTEM_BASE1 + 0x8);
+
+	reset_control_deassert(rstn_pcie2_stitch);
+	reset_control_deassert(rstn_pcie2);
+	reset_control_deassert(rstn_pcie2_core);
+	reset_control_deassert(rstn_pcie2_power);
+	reset_control_deassert(rstn_pcie2_nonstitch);
+	reset_control_deassert(rstn_pcie2_phy);
+	reset_control_deassert(rstn_pcie2_phy_mdio);
+
+	ret = clk_prepare_enable(pcie2_clk);
+
+	if (ret) {
+		dev_err(dev, "unable to enable pcie1_clk clock\n");
+		clk_disable_unprepare(pcie2_clk);
+		return -EINVAL;
+	}
+
+
+	rtk_pcie2_16xx_ctrl_write(0xC00, 0x00140010);
+
+	if (speed_mode == 0) {
+		rtk_pcie2_16xx_ctrl_write(0x0A0,
+			(rtk_pcie2_16xx_ctrl_read(0x0A0)&0xFFFFFFF0)|0x00000001);
+	}
+
+
+	/*phy mdio setting*/
+	size = of_property_count_u32_elems(dev->of_node, "phys");
+	phy = kmalloc(size * sizeof(u32), GFP_KERNEL);
+	of_property_read_u32_array(dev->of_node, "phys", phy, size);
+	for (i = 0; i < size; i++) {
+		rtk_pcie2_16xx_ctrl_write(0xC1C, phy[i]);
+		udelay(100);
+	}
+	kfree(phy);
+
+	// after phy mdio set
+	ret = gpio_direction_output(pcie2_gpio, 1);
+
+
+	/* set to MMIO */
+	if (cfg_direct_access)
+		rtk_pcie2_16xx_ctrl_write(0xC00, 0x00BE0002);
+	else
+		rtk_pcie2_16xx_ctrl_write(0xC00, 0x001E0022);
+
+	mdelay(1);
+
+	/* #Link initial setting */
+	rtk_pcie2_16xx_ctrl_write(0x710, 0x00010120);
+
+	do {
+		pci_link_detected = (rtk_pcie2_16xx_ctrl_read(0xCB4) & 0x800);
+		if (!pci_link_detected) {
+			mdelay(TIMEOUT_RESOLUTION);
+			timeout += TIMEOUT_RESOLUTION;
+		}
+	} while (!pci_link_detected && timeout < PCIE_CONNECT_TIMEOUT);
+
+	if (pci_link_detected) {
+		dev_err(dev, "PCIE device has link up in slot 2\n");
+	} else {
+		if (!debug_mode) { /*do not turn off clk in debug mode*/
+			reset_control_assert(rstn_pcie2_stitch);
+			reset_control_assert(rstn_pcie2);
+			reset_control_assert(rstn_pcie2_core);
+			reset_control_assert(rstn_pcie2_power);
+			reset_control_assert(rstn_pcie2_nonstitch);
+			reset_control_assert(rstn_pcie2_phy);
+			reset_control_assert(rstn_pcie2_phy_mdio);
+
+			clk_disable_unprepare(pcie2_clk);
+		}
+		gpio_free(pcie2_gpio);
+
+		dev_err(dev, "PCIE device has link down in slot 2\n");
+		return -ENODEV;
+	}
+
+
+	/* make sure DBI is working */
+	rtk_pcie2_16xx_ctrl_write(0x04, 0x00000007);
+
+	if (cfg_direct_access) {
+		/* #Base 1 */
+		rtk_pcie2_16xx_ctrl_write(0xD08, 0x980A1000);
+
+		/* #Mask 1 */
+		rtk_pcie2_16xx_ctrl_write(0xD0C, 0xFFFFF000);
+
+		/* #translate for CFG R/W */
+		rtk_pcie2_16xx_ctrl_write(0xD10, 0x00000000);
+	}
+	/* #Base 0 */
+	rtk_pcie2_16xx_ctrl_write(0xCFC, 0x980A2000);
+
+	/* #Mask 0 */
+	rtk_pcie2_16xx_ctrl_write(0xD00, 0xFFF00000);
+
+	/* #translate for MMIO R/W */
+	rtk_pcie2_16xx_ctrl_write(0xD04, 0x00000000);
+
+	/*pcie timeout extend to 100*/
+	rtk_pcie2_16xx_ctrl_write(0xC78, 0xBEBC2001);
+
+	/* set limit and base register */
+	rtk_pcie2_16xx_ctrl_write(0x20, 0x0000FFF0);
+	rtk_pcie2_16xx_ctrl_write(0x24, 0x0000FFF0);
+
+	return ret;
+}
+
+static int rtk_pcie2_16xx_probe(struct platform_device *pdev)
+{
+	int ret = 0;
+	int size = 0;
+	const u32 *prop, *prop2;
+	struct resource pcie_mmio_res;
+	struct pci_dev *dev;
+
+	resource_size_t iobase = 0;
+	LIST_HEAD(res);
+
+	local_pdev = pdev;
+
+	spin_lock_init(&rtk_pcie2_16xx_lock);
+
+	dev_info(&pdev->dev, "PCIE host driver initial begin.\n");
+
+	prop = of_get_property(pdev->dev.of_node, "speed-mode", &size);
+	if (prop) {
+		speed_mode = of_read_number(prop, 1);
+		if (speed_mode == 0)
+			dev_info(&pdev->dev, "Speed Mode: GEN1\n");
+		else if (speed_mode == 1)
+			dev_info(&pdev->dev, "Speed Mode: GEN2\n");
+	} else {
+		speed_mode = 0;
+	}
+
+	prop2 = of_get_property(pdev->dev.of_node, "debug-mode", &size);
+	if (prop2) {
+		debug_mode = of_read_number(prop2, 1);
+		if (debug_mode == 0)
+			dev_info(&pdev->dev, "PCIE Debug Mode off\n");
+		else if (debug_mode == 1)
+			dev_info(&pdev->dev, "PCIE Debug Mode on\n");
+	} else {
+		debug_mode = 0;
+	}
+
+	PCIE_CTRL_BASE = of_iomap(pdev->dev.of_node, 0);
+	if (!PCIE_CTRL_BASE) {
+		dev_err(&pdev->dev, "pcie no ctrl address\n");
+		return -EINVAL;
+	}
+
+	PCIE_CFG_BASE = of_iomap(pdev->dev.of_node, 1);
+	if (!PCIE_CFG_BASE) {
+		dev_err(&pdev->dev, "pcie no cfg address\n");
+		return -EINVAL;
+	} else {
+		of_address_to_resource(pdev->dev.of_node, 1, &pcie_mmio_res);
+		PCIE_MMIO_PHY_ADDR = pcie_mmio_res.start;
+		PCIE_MMIO_PHY_ADDR_LEN = resource_size(&pcie_mmio_res);
+	}
+
+
+	SYSTEM_BASE1 = of_iomap(pdev->dev.of_node, 2);
+	if (!SYSTEM_BASE1) {
+		dev_err(&pdev->dev, "pcie no base1 address\n");
+		return -EINVAL;
+	}
+
+	PINMUX_BASE = of_iomap(pdev->dev.of_node, 3);
+	if (!PINMUX_BASE) {
+		dev_err(&pdev->dev, "pcie no PINMUX_BASE address\n");
+		return -EINVAL;
+	}
+
+
+
+	pcie2_gpio = of_get_gpio_flags(pdev->dev.of_node, 0, NULL);
+	if (gpio_is_valid(pcie2_gpio)) {
+		ret = gpio_request(pcie2_gpio, "pcie2_gpio");
+		if (ret < 0)
+			pr_err("%s: can't request gpio %d\n",
+						__func__, pcie2_gpio);
+	} else {
+		pr_err("%s: gpio %d is not valid\n", __func__, pcie2_gpio);
+	}
+
+	pcie2_clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(pcie2_clk)) {
+		dev_err(&pdev->dev, "pcie clock source missing or invalid\n");
+		return PTR_ERR(pcie2_clk);
+	}
+
+	rstn_pcie2_stitch = devm_reset_control_get(&pdev->dev, "stitch");
+	if (rstn_pcie2_stitch == NULL) {
+		dev_err(&pdev->dev, "stitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2 = devm_reset_control_get(&pdev->dev, "rstn");
+	if (rstn_pcie2 == NULL) {
+		dev_err(&pdev->dev, "rstn_pcie2 source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2_core = devm_reset_control_get(&pdev->dev, "core");
+	if (rstn_pcie2_core == NULL) {
+		dev_err(&pdev->dev, "core source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2_power = devm_reset_control_get(&pdev->dev, "power");
+	if (rstn_pcie2_power == NULL) {
+		dev_err(&pdev->dev, "power source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2_nonstitch = devm_reset_control_get(&pdev->dev, "nonstitch");
+	if (rstn_pcie2_nonstitch == NULL) {
+		dev_err(&pdev->dev, "nonstitch source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2_phy = devm_reset_control_get(&pdev->dev, "phy");
+	if (rstn_pcie2_phy == NULL) {
+		dev_err(&pdev->dev, "phy source missing or invalid\n");
+		return -EINVAL;
+	}
+
+	rstn_pcie2_phy_mdio = devm_reset_control_get(&pdev->dev, "phy_mdio");
+	if (rstn_pcie2_phy_mdio == NULL) {
+		dev_err(&pdev->dev, "phy_mdio source missing. or invalid\n");
+		return -EINVAL;
+	}
+
+
+	reset_control_assert(rstn_pcie2_stitch);
+	reset_control_assert(rstn_pcie2);
+	reset_control_assert(rstn_pcie2_core);
+	reset_control_assert(rstn_pcie2_power);
+	reset_control_assert(rstn_pcie2_nonstitch);
+	reset_control_assert(rstn_pcie2_phy);
+	reset_control_assert(rstn_pcie2_phy_mdio);
+
+
+	if (rtk_pcie2_16xx_hw_initial(&pdev->dev) < 0) {
+		dev_err(&pdev->dev, "rtk_pcie2_16xx_hw_initial fail\n");
+		return -EINVAL;
+	}
+
+	/*-------------------------------------------
+	 * Register PCI-E host
+	 *-------------------------------------------
+	 */
+
+	ret = of_pci_get_host_bridge_resources(pdev->dev.of_node,
+					0x1, 0xff, &res, &iobase);
+	if (ret)
+		return ret;
+
+	bus = pci_create_root_bus(&pdev->dev, 1,
+				&rtk_pcie_16xx_ops, NULL, &res);
+
+	if (!bus)
+		return -ENOMEM;
+
+	pci_scan_child_bus(bus);
+	pci_assign_unassigned_bus_resources(bus);
+	pci_bus_add_devices(bus);
+
+
+#if defined(CONFIG_CPU_V7)
+	list_for_each_entry(dev, &bus->devices, bus_list) {
+		dev->irq = of_irq_parse_and_map_pci(dev, 0, 0);
+	}
+#endif
+
+	dev_info(&pdev->dev, "PCIE host driver initial done.\n");
+
+	return ret;
+}
+#ifdef CONFIG_SUSPEND
+static int rtk_pcie2_16xx_suspend(struct device *dev)
+{
+	dev_info(dev, "suspend enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie2_16xx_ctrl_write(0x178, 0xA3FF0001);
+		rtk_pcie2_16xx_ctrl_write(0x098, 0x400);
+		rtk_pcie2_16xx_ctrl_write(0xC6C, 0x00000031);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+		gpio_direction_output(pcie2_gpio, 0);
+		reset_control_assert(rstn_pcie2_stitch);
+		reset_control_assert(rstn_pcie2);
+		reset_control_assert(rstn_pcie2_core);
+		reset_control_assert(rstn_pcie2_power);
+		reset_control_assert(rstn_pcie2_nonstitch);
+		reset_control_assert(rstn_pcie2_phy);
+		reset_control_assert(rstn_pcie2_phy_mdio);
+		clk_disable_unprepare(pcie2_clk);
+		gpio_free(pcie2_gpio);
+
+	}
+
+	dev_info(dev, "suspend exit ...\n");
+
+	return 0;
+}
+
+static int rtk_pcie2_16xx_resume(struct device *dev)
+{
+	int ret = 0;
+
+	dev_info(dev, "resume enter ...\n");
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		rtk_pcie2_16xx_ctrl_write(0xC6C, 0x00000032);
+		dev_info(dev, "Idle mode\n");
+	} else {
+		dev_info(dev, "Suspend mode\n");
+		if (gpio_is_valid(pcie2_gpio)) {
+			ret = gpio_request(pcie2_gpio, "pcie2_gpio");
+			if (ret < 0)
+				pr_err("%s: can't request gpio %d\n",
+						__func__, pcie2_gpio);
+		} else
+			pr_err("%s: gpio %d is not valid\n",
+						__func__, pcie2_gpio);
+
+		reset_control_deassert(rstn_pcie2_stitch);
+		reset_control_deassert(rstn_pcie2);
+		reset_control_deassert(rstn_pcie2_core);
+		reset_control_deassert(rstn_pcie2_power);
+		reset_control_deassert(rstn_pcie2_nonstitch);
+		reset_control_deassert(rstn_pcie2_phy);
+		reset_control_deassert(rstn_pcie2_phy_mdio);
+		ret = clk_prepare_enable(pcie2_clk);
+		if (ret) {
+			dev_err(dev, "unable to enable pcie2_clk clock\n");
+			clk_disable_unprepare(pcie2_clk);
+			return -EINVAL;
+		}
+
+		if (rtk_pcie2_16xx_hw_initial(dev) < 0) {
+			dev_err(dev, "rtk_pcie2_16xx_hw_initial fail\n");
+			return -EINVAL;
+		}
+
+
+		if (cfg_direct_access)
+			rtk_pcie2_16xx_ctrl_write(0xC00, 0x00BE0002);
+		else
+			rtk_pcie2_16xx_ctrl_write(0xC00, 0x001E0022);
+	}
+
+	dev_info(dev, "resume exit ...\n");
+
+	return ret;
+}
+
+static void rtk_pcie2_16xx_shutdown(struct platform_device *pdev)
+{
+	dev_info(&pdev->dev, "shutdown enter ...\n");
+
+	dev_info(&pdev->dev, "shutdown mode\n");
+
+	gpio_direction_output(pcie2_gpio, 0);
+	reset_control_assert(rstn_pcie2_stitch);
+	reset_control_assert(rstn_pcie2);
+	reset_control_assert(rstn_pcie2_core);
+	reset_control_assert(rstn_pcie2_power);
+	reset_control_assert(rstn_pcie2_nonstitch);
+	reset_control_assert(rstn_pcie2_phy);
+	reset_control_assert(rstn_pcie2_phy_mdio);
+	clk_disable_unprepare(pcie2_clk);
+	gpio_free(pcie2_gpio);
+
+	dev_info(&pdev->dev, "shutdown exit ...\n");
+}
+
+
+static const struct dev_pm_ops rtk_pcie2_16xx_pm_ops = {
+	.suspend_noirq = rtk_pcie2_16xx_suspend,
+	.resume_noirq = rtk_pcie2_16xx_resume,
+};
+#endif //CONFIG_SUSPEND
+static const struct of_device_id rtk_pcie2_16xx_match_table[] = {
+	{.compatible = "realtek,rtk16xx-pcie-slot2",},
+	{},
+};
+
+static struct platform_driver rtk_pcie2_16xx_driver = {
+	.driver = {
+		.name = "[RTD16xx PCIE2]",
+		.of_match_table = of_match_ptr(rtk_pcie2_16xx_match_table),
+#ifdef CONFIG_SUSPEND
+		.pm = &rtk_pcie2_16xx_pm_ops,
+#endif
+	},
+	.probe = rtk_pcie2_16xx_probe,
+	.shutdown = rtk_pcie2_16xx_shutdown,
+};
+module_platform_driver(rtk_pcie2_16xx_driver);
+
+MODULE_AUTHOR("James Tai <james.tai@realtek.com>");
+MODULE_DESCRIPTION("Realtek PCIe host controller driver");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/pci/host/pcie-rtd16xx.h b/drivers/pci/host/pcie-rtd16xx.h
new file mode 100644
index 00000000..0636057
--- /dev/null
+++ b/drivers/pci/host/pcie-rtd16xx.h
@@ -0,0 +1,330 @@
+/*
+ * Realtek PCIe host controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+#ifndef RTK_PCIE_16xx_H_
+#define RTK_PCIE_16xx_H_
+
+#include <linux/of_platform.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of.h>
+
+/* SB2 for PCI */
+#define PCI_PRINT printk
+
+#ifdef PCI_DBG_EN
+#define PCI_DBG(fmt, args...) \
+	pr_info("[RTD16xx PCIE] DBG, " fmt, ## args)
+#else
+#define PCI_DBG(fmt, args...) \
+do { \
+} while (0)
+#endif
+
+#define PCI_INFO(fmt, args...) \
+	pr_info("[RTD16xx PCIE] INFO," fmt, ## args)
+#define PCI_WARNING(fmt, args...) \
+	pr_info("[RTD16xx PCIE] WARNING," fmt, ## args)
+
+#ifdef PCI_REG_DBG_EN
+#define PCI_REG_DBG(fmt, args...) \
+	pr_info("[RTD16xx PCIE] REG DBG," fmt, ## args)
+#else
+#define PCI_REG_DBG(fmt, args...) \
+do { \
+} while (0)
+#endif
+
+#ifdef PCI_CFG_DBG_EN
+#define PCI_CFG_DBG(fmt, args...) \
+	pr_info("[RTD16xx PCIE] CFG DBG," fmt, ## args)
+#else
+#define PCI_CFG_DBG(fmt, args...) do {} while (0)
+#endif
+
+#define PCI_CFG_WARNING(fmt, args...) pr_alert("[RTD16xx PCIE] CFG WARNING," fmt, ## args)
+
+/* SB2 for PCI */
+#define SB2_PCI_BASE0 0x00000030
+#define SB2_PCI_BASE1 0x00000034
+#define SB2_PCI_BASE2 0x00000038
+#define SB2_PCI_BASE3 0x0000003C
+#define SB2_PCI_MASK0 0x00000040
+#define SB2_PCI_MASK1 0x00000044
+#define SB2_PCI_MASK2 0x00000048
+#define SB2_PCI_MASK3 0x0000004C
+#define SB2_PCI_TRAN0 0x00000050
+#define SB2_PCI_TRAN1 0x00000054
+#define SB2_PCI_TRAN2 0x00000058
+#define SB2_PCI_TRAN3 0x0000005C
+#define SB2_PCI_CTRL 0x00000060
+
+/*
+ * PCI-DVR Bridge
+ */
+#define PCIE_SYS_CTR 0x00000C00U
+#define TRANS_EN (1 << 20)
+#define PHY_MMIO_TYPE (1 << 19)
+#define PHY_MDIO_OE (1 << 18)
+#define PHY_MDIO_RSTN (1 << 17)
+#define APP_INIT_RST (1 << 16)
+#define LOOPBACK_EN (1 << 9)
+#define DIR_REQ_INFO_EN (1 << 8)
+#define RX_LANE_REVERSAL_EN (1 << 7)
+#define TX_LANE_REVERSAL_EN (1 << 6)
+#define INDOR_CFG_EN (1 << 5)
+#define DIR_CFG_EN (1 << 4)
+#define RCV_ADDR0_EN (1 << 3)
+#define RCV_ADDR1_EN (1 << 2)
+#define APP_LTSSM_EN (1 << 1)
+#define RCV_TRANS_EN (1)
+
+#define DVR_INT_CTR 0x00000C04U
+
+#define DVR_GNR_INT 0x00000C08U
+#define S_INTP_PCIE_LEGACY_MSI_INT 14
+#define S_INTP_PM_TO_ACK_INT 13
+#define S_INTP_CFG_SYS_ERR_RC_INT 12
+#define S_INTP_PCIE_LEGACY_INT 11
+#define S_INTP_CFG_RSDM_VENDOR_MSG_INT 10
+#define S_INTP_CFG_PME_MSI 9
+#define S_INTP_CFG_PME_INT 8
+#define S_INTP_CFG_AER_RC_MSI 7
+#define S_INTP_CFG_AER_RC_ERR 6
+#define S_INTP_RTGT 5 /* Slave Receiver Interrupt */
+#define S_INTP_RCPL 4 /* Master Receiver Interrupt */
+#define S_INTP_DIR_CFG 3 /* Direct CFG Interrupt */
+#define S_INTP_DIR_MIO 2 /* Direct MIO Interrupt */
+#define S_INTP_CFG 1 /* Indirect CFG Interrupt */
+#define S_INTP_MIO 0 /* Indirect MIO Interrupt */
+#define INTP_PCIE_LEGACY_MSI_INT (1 << INTP_PCIE_LEGACY_MSI_INT)
+#define INTP_PM_TO_ACK_INT (1 << INTP_PM_TO_ACK_INT)
+#define INTP_CFG_SYS_ERR_RC_INT (1 << INTP_CFG_SYS_ERR_RC_INT)
+#define INTP_PCIE_LEGACY_INT (1 << INTP_PCIE_LEGACY_INT)
+#define INTP_CFG_RSDM_VENDOR_MSG_INT (1 << INTP_CFG_RSDM_VENDOR_MSG_INT)
+#define INTP_CFG_PME_MSI (1 << INTP_CFG_PME_MSI)
+#define INTP_CFG_PME_INT (1 << INTP_CFG_PME_INT)
+#define INTP_CFG_AER_RC_MSI (1 << INTP_CFG_AER_RC_MSI)
+#define INTP_CFG_AER_RC_ERR (1 << INTP_CFG_AER_RC_ERR)
+#define INTP_RTGT (1 << INTP_RTGT)
+#define INTP_RCPL (1 << INTP_RCPL)
+#define INTP_DIR_CFG (1 << INTP_DIR_CFG)
+#define INTP_DIR_MIO (1 << INTP_DIR_MIO)
+#define INTP_CFG (1 << INTP_CFG)
+#define INTP_MIO (1 << INTP_MIO)
+
+#define DVR_PCIE_INT 0x00000C0CU
+#define PCIE_INTP_INTD (0x1U << 3)
+#define PCIE_INTP_INTC (0x1U << 2)
+#define PCIE_INTP_INTB (0x1U << 1)
+#define PCIE_INTP_INTA (0x1U)
+
+#define PCIE_DBI_CTR 0x00000C10U
+#define DBI_IO_ACCESS (0x1U << 9)
+#define DBI_ROM_ACCESS (0x1U << 8)
+#define DBI_BAR_NUM(x) ((x & 0x7) << 5)
+#define DBI_FUNC_NUM(x) ((x & 0x7) << 2)
+#define DBI_SC2_ACCESS (0x1U << 1)
+#define DBI_CMD_ACCESS (0x1U)
+
+#define PCIE_INDIR_CTR 0x00000C14
+#define PCIE_DIR_CTR 0x00000018U
+#define REQ_INFO_ALIGN (0x1U << 13)
+#define REQ_INFO_ATTR(x) ((x & 0x3) << 11)
+#define REQ_INFO_EP (0x1U << 10)
+#define REQ_INFO_TC(x) ((x & 0x7) << 7)
+#define REQ_INFO_TYPE(x) ((x & 0x1F) << 2)
+#define REQ_INFO_FMT(x) (x & 0x3)
+
+#define PCIE_MDIO_CTR 0x00000C1CU
+#define MDIO_DATA(x) ((x & 0xFFFF) << 16) /* MDIO Data */
+#define MDIO_PHY_ADDR(x) ((x & 0x7) << 13) /* MDIO PHY Address */
+#define MDIO_REG_ADDR(x) ((x & 0x1F) << 8) /* MDIO Register Address */
+#define MDIO_BUSY (0x1U << 7)
+#define MDIO_ST(x) ((x & 0x03) << 5) /* MDIO Host Control State Monitor */
+#define MDIO_RDY (0x1U << 4) /* MDIO PREAMBLE Signal Monitor */
+#define MDIO_RATE(x) ((x & 0x3) << 2) /* MDIO Clock Rate */
+#define CLK_SYS_1_32(x) 0 /* MDIO Clock Rate = 1/32 */
+#define CLK_SYS_1_16(x) 1 /* MDIO Clock Rate = 1/16 */
+#define CLK_SYS_1_8(x) 2 /* MDIO Clock Rate = 1/8 */
+#define CLK_SYS_1_4(x) 3 /* MDIO Clock Rate = 1/4 */
+#define MDIO_SRST (0x1U << 1)
+#define MDIO_RDWR(x) (x & 0x1) /* MDIO Read/Write : 0 read, 1 write */
+
+/*
+ * Address Translation
+ * PCI-E Bridge provides 2 set of control registers
+ * for in-bound address translation
+ */
+#define PCIE_BASE0 0x00000C20U
+#define PCIE_BASE1 0x00000C24U
+#define PCIE_MASK0 0x00000C28U
+#define PCIE_MASK1 0x00000C2CU
+#define PCIE_TRAN0 0x00000C30U
+#define PCIE_TRAN1 0x00000C34U
+
+/*
+ * Configuration Access
+ * the following registers are used to access configuration
+ * space
+ */
+#define PCIE_CFG_CT 0x00000C38U
+#define GO_CT (0x1U)
+
+#define PCIE_CFG_EN 0x00000C3CU
+#define BUS_NUM(x) ((x & 0xFF) << 16) /* Bus number */
+#define DEV_NUM(x) ((x & 0xF) << 11) /* Device number */
+#define FUN_NUM(x) ((x & 0x7) << 8) /* Function number */
+#define BYTE_CNT(x) ((x & 0xF) << 4) /* Byte enable bits */
+#define ERROR_EN(x) ((x & 0x1) << 2) /* Enable error timeout counter */
+#define BYTE_EN (0x1 << 1) /* Byte enable bits enable */
+#define WRRD_EN(x) (x & 0x01)
+#define WRITE_CFG WRRD_EN(1)
+#define READ_CFG WRRD_EN(0)
+
+#define PCIE_CFG_ST 0x00000C40U
+#define CFG_ST_ERROR (0x1U << 1)
+#define CFG_ST_DONE 0x1U
+
+#define PCIE_CFG_ADDR 0x00000C44U
+#define PCIE_CFG_WDATA 0x00000C48U
+#define PCIE_CFG_RDATA 0x00000C4CU
+
+/*
+ * Memory / IO Access
+ * the following registers are used to access configuration
+ * space
+ */
+#define PCIE_MIO_CT 0x00000C50U
+#define PCIE_MIO_EN 0x00000C54U
+
+#define TIMEOUT_CNT_VAL(x) ((x & 0xFFFFFFF) << 8)
+
+#define PCIE_MIO_ST 0x00000C58U
+#define PCIE_MIO_ADDR 0x00000C5CU
+#define PCIE_MIO_WDATA 0x00000C60U
+#define PCIE_MIO_RDATA 0x00000C64U
+
+/*
+ * MISC
+ */
+#define PCIE_CTR 0x00000C68U
+#define PCIE_PWR_CTR 0x00000C6CU
+#define PCIE_DBG 0x00000C70U
+#define PCIE_DIR_ST 0x00000C74U /* Status for Direct Access */
+#define CFG_RERROR_ST (0x1U << 1)
+#define MIO_RERROR_ST (0x1U)
+
+#define PCIE_DIR_EN 0x00000C78U
+#define TIMEOUT_EN (0x1U)
+
+#define PCIE_MAC_ST 0x00000CB4
+#define RDLH_LINK_UP (0x1U << 14)
+#define PM_XTLH_BLOCK_TLP (0x1U << 13)
+#define CFG_BUS_MASTER_EN (0x1U << 12)
+#define CFG_PM_NO_SOFT_RST (0x1U << 11)
+#define XMLH_LINK_UP (0x1U << 10)
+#define LINK_REQ_RST_NOT (0x1U << 9)
+#define XMLH_LTSSM_STATE(x) ((x & 0xF) << 4)
+#define PM_CURNT_STATE(x) ((x & 0x7) << 1)
+#define CFG_CLK_REQ_N (0x1U)
+
+/*
+ * PCI-E RC registers
+ */
+#define PCI_CFG_REG 0x00000000U /* PCI compatible registers */
+#define PCIE_DEV_REG 0x00000040U /* PCI-E Device Configuration Space */
+#define PCIE_EXT_REG 0x00000100U /* PCI-E Extend Configuration Space */
+#define PCIE_DVR_REG 0x00000C00U /* DVR space register */
+
+#define CFG(addr) (PCI_CFG_REG + (addr))
+#define BAR1 0x10
+#define BAR2 0x14
+#define BAR3 0x18
+#define BAR4 0x1C
+
+#define CFG_ST_DETEC_PAR_ERROR (1 << 31)
+#define CFG_ST_SIGNAL_SYS_ERROR (1 << 30)
+#define CFG_ST_REC_MASTER_ABORT (1 << 29)
+#define CFG_ST_REC_TARGET_ABORT (1 << 28)
+#define CFG_ST_SIG_TAR_ABORT (1 << 27)
+
+#define TIMEOUT_RESOLUTION 1
+#define PCIE_CONNECT_TIMEOUT 60
+
+#define RBUS1_TIMEOUT(x) ((x & 0x7) << 2)
+#define RBUS_TIMEOUT(x) (x & 0x3)
+
+#define ADDR_TO_DEVICE_NO(addr) ((addr >> 19) & 0x1F)
+
+static unsigned long _pci_bit_mask(unsigned char byte_mask)
+{
+	int i;
+	unsigned long mask = 0;
+
+	for (i = 0; i < 4; i++) {
+		if ((byte_mask >> i) & 0x1)
+			mask |= (0xFF << (i << 3));
+	}
+
+	return mask;
+}
+
+static unsigned long _pci_bit_shift(unsigned long addr)
+{
+	return ((addr & 0x3) << 3);
+}
+
+static unsigned long _pci_byte_mask(unsigned long addr, unsigned char size)
+{
+	unsigned char offset = (addr & 0x03);
+
+	switch (size) {
+	case 0x01:
+		return 0x1 << offset;
+	case 0x02:
+		if (offset <= 2)
+			return 0x3 << offset;
+
+		PCI_CFG_WARNING("compute config mask - data cross dword boundrary (addr=%p, length=2)\n", (void *) addr);
+
+		break;
+
+	case 0x03:
+		if (offset <= 1)
+			return 0x7 << offset;
+
+		PCI_CFG_WARNING("compute config mask - data cross dword boundrary (addr=%p, length=3)\n", (void *) addr);
+		break;
+
+	case 0x04:
+		if (offset == 0)
+			return 0xF;
+
+		PCI_CFG_WARNING("compute config mask - data cross dword boundrary (addr=%p, length=4)\n", (void *) addr);
+		break;
+
+	default:
+		PCI_CFG_WARNING("compute config mask failed - size %d should between 1~4\n", size);
+	}
+	return 0;
+}
+
+static unsigned long _pci_address_conversion(struct pci_bus *bus,
+						unsigned int devfn, int reg)
+{
+	int busno = bus->number;
+	int dev = PCI_SLOT(devfn);
+	int func = PCI_FUNC(devfn);
+
+	return (busno << 24) | (dev << 19) | (func << 16) | reg;
+}
+
+#endif /* RTK_PCIE_16xx_H_ */
diff --git a/drivers/pci/pcie/aspm.c b/drivers/pci/pcie/aspm.c
index 6643a7bc..e38bb48 100644
--- a/drivers/pci/pcie/aspm.c
+++ b/drivers/pci/pcie/aspm.c
@@ -786,7 +786,8 @@ void pci_disable_link_state(struct pci_dev *pdev, int state)
 }
 EXPORT_SYMBOL(pci_disable_link_state);
 
-static int pcie_aspm_set_policy(const char *val, struct kernel_param *kp)
+static int pcie_aspm_set_policy(const char *val,
+				const struct kernel_param *kp)
 {
 	int i;
 	struct pcie_link_state *link;
@@ -813,7 +814,7 @@ static int pcie_aspm_set_policy(const char *val, struct kernel_param *kp)
 	return 0;
 }
 
-static int pcie_aspm_get_policy(char *buffer, struct kernel_param *kp)
+static int pcie_aspm_get_policy(char *buffer, const struct kernel_param *kp)
 {
 	int i, cnt = 0;
 	for (i = 0; i < ARRAY_SIZE(policy_str); i++)
diff --git a/drivers/perf/Kconfig b/drivers/perf/Kconfig
index 4d5c5f9..bbb6453 100644
--- a/drivers/perf/Kconfig
+++ b/drivers/perf/Kconfig
@@ -12,6 +12,14 @@ config ARM_PMU
 	  Say y if you want to use CPU performance monitors on ARM-based
 	  systems.
 
+config ARM_PMUV3
+	depends on HW_PERF_EVENTS && ((ARM && CPU_V7) || ARM64)
+	bool "ARM PMUv3 support" if !ARM64
+	default ARM64
+	help
+	  Say y if you want to use CPU performance monitors on ARMv8
+	  systems that implement the PMUv3 architecture.
+
 config XGENE_PMU
         depends on PERF_EVENTS && ARCH_XGENE
         bool "APM X-Gene SoC PMU"
diff --git a/drivers/perf/Makefile b/drivers/perf/Makefile
index b116e98..0ffff46 100644
--- a/drivers/perf/Makefile
+++ b/drivers/perf/Makefile
@@ -1,2 +1,3 @@
 obj-$(CONFIG_ARM_PMU) += arm_pmu.o
+obj-$(CONFIG_ARM_PMUV3) += arm_pmuv3.o
 obj-$(CONFIG_XGENE_PMU) += xgene_pmu.o
diff --git a/drivers/perf/arm_pmu.c b/drivers/perf/arm_pmu.c
index af82edc..652337d 100644
--- a/drivers/perf/arm_pmu.c
+++ b/drivers/perf/arm_pmu.c
@@ -688,6 +688,13 @@ static int cpu_pmu_request_irq(struct arm_pmu *cpu_pmu, irq_handler_t handler)
 			if (cpu_pmu->irq_affinity)
 				cpu = cpu_pmu->irq_affinity[i];
 
+#ifdef CONFIG_RTK_PLATFORM
+			if (irq_set_affinity(irq, &cpu_pmu->supported_cpus)) {
+				pr_warn("unable to set irq affinity (irq=%d, cpumask=%*pb)\n",
+					irq, cpumask_pr_args(&cpu_pmu->supported_cpus));
+				continue;
+			}
+#else
 			/*
 			 * If we have a single PMU interrupt that we can't shift,
 			 * assume that we're running on a uniprocessor machine and
@@ -698,6 +705,7 @@ static int cpu_pmu_request_irq(struct arm_pmu *cpu_pmu, irq_handler_t handler)
 					irq, cpu);
 				continue;
 			}
+#endif /* CONFIG_RTK_PLATFORM */
 
 			err = request_irq(irq, handler,
 					  IRQF_NOBALANCING | IRQF_NO_THREAD, "arm-pmu",
@@ -1018,7 +1026,7 @@ int arm_pmu_device_probe(struct platform_device *pdev,
 			 const struct pmu_probe_info *probe_table)
 {
 	const struct of_device_id *of_id;
-	const int (*init_fn)(struct arm_pmu *);
+	int (*init_fn)(struct arm_pmu *);
 	struct device_node *node = pdev->dev.of_node;
 	struct arm_pmu *pmu;
 	int ret = -ENODEV;
diff --git a/drivers/perf/arm_pmuv3.c b/drivers/perf/arm_pmuv3.c
new file mode 100644
index 00000000..3132324
--- /dev/null
+++ b/drivers/perf/arm_pmuv3.c
@@ -0,0 +1,1122 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * PMU support
+ *
+ * Copyright (C) 2012 ARM Limited
+ * Author: Will Deacon <will.deacon@arm.com>
+ *
+ * This code is based heavily on the ARMv7 perf event code.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <asm/irq_regs.h>
+#include <asm/perf_event.h>
+#include <asm/virt.h>
+
+#include <linux/acpi.h>
+#include <linux/of.h>
+#include <linux/perf/arm_pmu.h>
+#include <linux/perf/arm_pmuv3.h>
+#include <linux/platform_device.h>
+
+/*
+ * ARMv8 PMUv3 Performance Events handling code.
+ * Common event types (some are defined in asm/perf_event.h).
+ */
+
+/* At least one of the following is required. */
+#define ARMV8_PMUV3_PERFCTR_INST_RETIRED			0x08
+#define ARMV8_PMUV3_PERFCTR_INST_SPEC				0x1B
+
+/* Common architectural events. */
+#define ARMV8_PMUV3_PERFCTR_LD_RETIRED				0x06
+#define ARMV8_PMUV3_PERFCTR_ST_RETIRED				0x07
+#define ARMV8_PMUV3_PERFCTR_EXC_TAKEN				0x09
+#define ARMV8_PMUV3_PERFCTR_EXC_RETURN				0x0A
+#define ARMV8_PMUV3_PERFCTR_CID_WRITE_RETIRED			0x0B
+#define ARMV8_PMUV3_PERFCTR_PC_WRITE_RETIRED			0x0C
+#define ARMV8_PMUV3_PERFCTR_BR_IMMED_RETIRED			0x0D
+#define ARMV8_PMUV3_PERFCTR_BR_RETURN_RETIRED			0x0E
+#define ARMV8_PMUV3_PERFCTR_UNALIGNED_LDST_RETIRED		0x0F
+#define ARMV8_PMUV3_PERFCTR_TTBR_WRITE_RETIRED			0x1C
+#define ARMV8_PMUV3_PERFCTR_CHAIN				0x1E
+#define ARMV8_PMUV3_PERFCTR_BR_RETIRED				0x21
+
+/* Common microarchitectural events. */
+#define ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL			0x01
+#define ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL			0x02
+#define ARMV8_PMUV3_PERFCTR_L1D_TLB_REFILL			0x05
+#define ARMV8_PMUV3_PERFCTR_MEM_ACCESS				0x13
+#define ARMV8_PMUV3_PERFCTR_L1I_CACHE				0x14
+#define ARMV8_PMUV3_PERFCTR_L1D_CACHE_WB			0x15
+#define ARMV8_PMUV3_PERFCTR_L2D_CACHE				0x16
+#define ARMV8_PMUV3_PERFCTR_L2D_CACHE_REFILL			0x17
+#define ARMV8_PMUV3_PERFCTR_L2D_CACHE_WB			0x18
+#define ARMV8_PMUV3_PERFCTR_BUS_ACCESS				0x19
+#define ARMV8_PMUV3_PERFCTR_MEMORY_ERROR			0x1A
+#define ARMV8_PMUV3_PERFCTR_BUS_CYCLES				0x1D
+#define ARMV8_PMUV3_PERFCTR_L1D_CACHE_ALLOCATE			0x1F
+#define ARMV8_PMUV3_PERFCTR_L2D_CACHE_ALLOCATE			0x20
+#define ARMV8_PMUV3_PERFCTR_BR_MIS_PRED_RETIRED			0x22
+#define ARMV8_PMUV3_PERFCTR_STALL_FRONTEND			0x23
+#define ARMV8_PMUV3_PERFCTR_STALL_BACKEND			0x24
+#define ARMV8_PMUV3_PERFCTR_L1D_TLB				0x25
+#define ARMV8_PMUV3_PERFCTR_L1I_TLB				0x26
+#define ARMV8_PMUV3_PERFCTR_L2I_CACHE				0x27
+#define ARMV8_PMUV3_PERFCTR_L2I_CACHE_REFILL			0x28
+#define ARMV8_PMUV3_PERFCTR_L3D_CACHE_ALLOCATE			0x29
+#define ARMV8_PMUV3_PERFCTR_L3D_CACHE_REFILL			0x2A
+#define ARMV8_PMUV3_PERFCTR_L3D_CACHE				0x2B
+#define ARMV8_PMUV3_PERFCTR_L3D_CACHE_WB			0x2C
+#define ARMV8_PMUV3_PERFCTR_L2D_TLB_REFILL			0x2D
+#define ARMV8_PMUV3_PERFCTR_L2I_TLB_REFILL			0x2E
+#define ARMV8_PMUV3_PERFCTR_L2D_TLB				0x2F
+#define ARMV8_PMUV3_PERFCTR_L2I_TLB				0x30
+
+/* ARMv8 recommended implementation defined event types */
+#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_RD			0x40
+#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WR			0x41
+#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_RD		0x42
+#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_WR		0x43
+#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_INNER		0x44
+#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_OUTER		0x45
+#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WB_VICTIM		0x46
+#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WB_CLEAN			0x47
+#define ARMV8_IMPDEF_PERFCTR_L1D_CACHE_INVAL			0x48
+
+#define ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_RD			0x4C
+#define ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_WR			0x4D
+#define ARMV8_IMPDEF_PERFCTR_L1D_TLB_RD				0x4E
+#define ARMV8_IMPDEF_PERFCTR_L1D_TLB_WR				0x4F
+#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_RD			0x50
+#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_WR			0x51
+#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_REFILL_RD		0x52
+#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_REFILL_WR		0x53
+
+#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_WB_VICTIM		0x56
+#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_WB_CLEAN			0x57
+#define ARMV8_IMPDEF_PERFCTR_L2D_CACHE_INVAL			0x58
+
+#define ARMV8_IMPDEF_PERFCTR_L2D_TLB_REFILL_RD			0x5C
+#define ARMV8_IMPDEF_PERFCTR_L2D_TLB_REFILL_WR			0x5D
+#define ARMV8_IMPDEF_PERFCTR_L2D_TLB_RD				0x5E
+#define ARMV8_IMPDEF_PERFCTR_L2D_TLB_WR				0x5F
+
+#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_RD			0x60
+#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_WR			0x61
+#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_SHARED			0x62
+#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_NOT_SHARED		0x63
+#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_NORMAL			0x64
+#define ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_PERIPH			0x65
+
+#define ARMV8_IMPDEF_PERFCTR_MEM_ACCESS_RD			0x66
+#define ARMV8_IMPDEF_PERFCTR_MEM_ACCESS_WR			0x67
+#define ARMV8_IMPDEF_PERFCTR_UNALIGNED_LD_SPEC			0x68
+#define ARMV8_IMPDEF_PERFCTR_UNALIGNED_ST_SPEC			0x69
+#define ARMV8_IMPDEF_PERFCTR_UNALIGNED_LDST_SPEC		0x6A
+
+#define ARMV8_IMPDEF_PERFCTR_LDREX_SPEC				0x6C
+#define ARMV8_IMPDEF_PERFCTR_STREX_PASS_SPEC			0x6D
+#define ARMV8_IMPDEF_PERFCTR_STREX_FAIL_SPEC			0x6E
+#define ARMV8_IMPDEF_PERFCTR_STREX_SPEC				0x6F
+#define ARMV8_IMPDEF_PERFCTR_LD_SPEC				0x70
+#define ARMV8_IMPDEF_PERFCTR_ST_SPEC				0x71
+#define ARMV8_IMPDEF_PERFCTR_LDST_SPEC				0x72
+#define ARMV8_IMPDEF_PERFCTR_DP_SPEC				0x73
+#define ARMV8_IMPDEF_PERFCTR_ASE_SPEC				0x74
+#define ARMV8_IMPDEF_PERFCTR_VFP_SPEC				0x75
+#define ARMV8_IMPDEF_PERFCTR_PC_WRITE_SPEC			0x76
+#define ARMV8_IMPDEF_PERFCTR_CRYPTO_SPEC			0x77
+#define ARMV8_IMPDEF_PERFCTR_BR_IMMED_SPEC			0x78
+#define ARMV8_IMPDEF_PERFCTR_BR_RETURN_SPEC			0x79
+#define ARMV8_IMPDEF_PERFCTR_BR_INDIRECT_SPEC			0x7A
+
+#define ARMV8_IMPDEF_PERFCTR_ISB_SPEC				0x7C
+#define ARMV8_IMPDEF_PERFCTR_DSB_SPEC				0x7D
+#define ARMV8_IMPDEF_PERFCTR_DMB_SPEC				0x7E
+
+#define ARMV8_IMPDEF_PERFCTR_EXC_UNDEF				0x81
+#define ARMV8_IMPDEF_PERFCTR_EXC_SVC				0x82
+#define ARMV8_IMPDEF_PERFCTR_EXC_PABORT				0x83
+#define ARMV8_IMPDEF_PERFCTR_EXC_DABORT				0x84
+
+#define ARMV8_IMPDEF_PERFCTR_EXC_IRQ				0x86
+#define ARMV8_IMPDEF_PERFCTR_EXC_FIQ				0x87
+#define ARMV8_IMPDEF_PERFCTR_EXC_SMC				0x88
+
+#define ARMV8_IMPDEF_PERFCTR_EXC_HVC				0x8A
+#define ARMV8_IMPDEF_PERFCTR_EXC_TRAP_PABORT			0x8B
+#define ARMV8_IMPDEF_PERFCTR_EXC_TRAP_DABORT			0x8C
+#define ARMV8_IMPDEF_PERFCTR_EXC_TRAP_OTHER			0x8D
+#define ARMV8_IMPDEF_PERFCTR_EXC_TRAP_IRQ			0x8E
+#define ARMV8_IMPDEF_PERFCTR_EXC_TRAP_FIQ			0x8F
+#define ARMV8_IMPDEF_PERFCTR_RC_LD_SPEC				0x90
+#define ARMV8_IMPDEF_PERFCTR_RC_ST_SPEC				0x91
+
+#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_RD			0xA0
+#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_WR			0xA1
+#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_REFILL_RD		0xA2
+#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_REFILL_WR		0xA3
+
+#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_WB_VICTIM		0xA6
+#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_WB_CLEAN			0xA7
+#define ARMV8_IMPDEF_PERFCTR_L3D_CACHE_INVAL			0xA8
+
+/* ARMv8 Cortex-A53 specific event types. */
+#define ARMV8_A53_PERFCTR_PREF_LINEFILL				0xC2
+
+/* ARMv8 Cavium ThunderX specific event types. */
+#define ARMV8_THUNDER_PERFCTR_L1D_CACHE_MISS_ST			0xE9
+#define ARMV8_THUNDER_PERFCTR_L1D_CACHE_PREF_ACCESS		0xEA
+#define ARMV8_THUNDER_PERFCTR_L1D_CACHE_PREF_MISS		0xEB
+#define ARMV8_THUNDER_PERFCTR_L1I_CACHE_PREF_ACCESS		0xEC
+#define ARMV8_THUNDER_PERFCTR_L1I_CACHE_PREF_MISS		0xED
+
+/* PMUv3 HW events mapping. */
+
+/*
+ * ARMv8 Architectural defined events, not all of these may
+ * be supported on any given implementation. Undefined events will
+ * be disabled at run-time.
+ */
+static const unsigned armv8_pmuv3_perf_map[PERF_COUNT_HW_MAX] = {
+	PERF_MAP_ALL_UNSUPPORTED,
+	[PERF_COUNT_HW_CPU_CYCLES]		= ARMV8_PMUV3_PERFCTR_CPU_CYCLES,
+	[PERF_COUNT_HW_INSTRUCTIONS]		= ARMV8_PMUV3_PERFCTR_INST_RETIRED,
+	[PERF_COUNT_HW_CACHE_REFERENCES]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
+	[PERF_COUNT_HW_CACHE_MISSES]		= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
+	[PERF_COUNT_HW_BRANCH_INSTRUCTIONS]	= ARMV8_PMUV3_PERFCTR_PC_WRITE_RETIRED,
+	[PERF_COUNT_HW_BRANCH_MISSES]		= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+	[PERF_COUNT_HW_BUS_CYCLES]		= ARMV8_PMUV3_PERFCTR_BUS_CYCLES,
+	[PERF_COUNT_HW_STALLED_CYCLES_FRONTEND]	= ARMV8_PMUV3_PERFCTR_STALL_FRONTEND,
+	[PERF_COUNT_HW_STALLED_CYCLES_BACKEND]	= ARMV8_PMUV3_PERFCTR_STALL_BACKEND,
+};
+
+/* ARM Cortex-A53 HW events mapping. */
+static const unsigned armv8_a53_perf_map[PERF_COUNT_HW_MAX] = {
+	PERF_MAP_ALL_UNSUPPORTED,
+	[PERF_COUNT_HW_CPU_CYCLES]		= ARMV8_PMUV3_PERFCTR_CPU_CYCLES,
+	[PERF_COUNT_HW_INSTRUCTIONS]		= ARMV8_PMUV3_PERFCTR_INST_RETIRED,
+	[PERF_COUNT_HW_CACHE_REFERENCES]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
+	[PERF_COUNT_HW_CACHE_MISSES]		= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
+	[PERF_COUNT_HW_BRANCH_INSTRUCTIONS]	= ARMV8_PMUV3_PERFCTR_PC_WRITE_RETIRED,
+	[PERF_COUNT_HW_BRANCH_MISSES]		= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+	[PERF_COUNT_HW_BUS_CYCLES]		= ARMV8_PMUV3_PERFCTR_BUS_CYCLES,
+};
+
+/* ARM Cortex-A57 and Cortex-A72 events mapping. */
+static const unsigned armv8_a57_perf_map[PERF_COUNT_HW_MAX] = {
+	PERF_MAP_ALL_UNSUPPORTED,
+	[PERF_COUNT_HW_CPU_CYCLES]		= ARMV8_PMUV3_PERFCTR_CPU_CYCLES,
+	[PERF_COUNT_HW_INSTRUCTIONS]		= ARMV8_PMUV3_PERFCTR_INST_RETIRED,
+	[PERF_COUNT_HW_CACHE_REFERENCES]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
+	[PERF_COUNT_HW_CACHE_MISSES]		= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
+	[PERF_COUNT_HW_BRANCH_MISSES]		= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+	[PERF_COUNT_HW_BUS_CYCLES]		= ARMV8_PMUV3_PERFCTR_BUS_CYCLES,
+};
+
+static const unsigned armv8_thunder_perf_map[PERF_COUNT_HW_MAX] = {
+	PERF_MAP_ALL_UNSUPPORTED,
+	[PERF_COUNT_HW_CPU_CYCLES]		= ARMV8_PMUV3_PERFCTR_CPU_CYCLES,
+	[PERF_COUNT_HW_INSTRUCTIONS]		= ARMV8_PMUV3_PERFCTR_INST_RETIRED,
+	[PERF_COUNT_HW_CACHE_REFERENCES]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
+	[PERF_COUNT_HW_CACHE_MISSES]		= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
+	[PERF_COUNT_HW_BRANCH_INSTRUCTIONS]	= ARMV8_PMUV3_PERFCTR_PC_WRITE_RETIRED,
+	[PERF_COUNT_HW_BRANCH_MISSES]		= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+	[PERF_COUNT_HW_STALLED_CYCLES_FRONTEND] = ARMV8_PMUV3_PERFCTR_STALL_FRONTEND,
+	[PERF_COUNT_HW_STALLED_CYCLES_BACKEND]	= ARMV8_PMUV3_PERFCTR_STALL_BACKEND,
+};
+
+/* Broadcom Vulcan events mapping */
+static const unsigned armv8_vulcan_perf_map[PERF_COUNT_HW_MAX] = {
+	PERF_MAP_ALL_UNSUPPORTED,
+	[PERF_COUNT_HW_CPU_CYCLES]		= ARMV8_PMUV3_PERFCTR_CPU_CYCLES,
+	[PERF_COUNT_HW_INSTRUCTIONS]		= ARMV8_PMUV3_PERFCTR_INST_RETIRED,
+	[PERF_COUNT_HW_CACHE_REFERENCES]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
+	[PERF_COUNT_HW_CACHE_MISSES]		= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
+	[PERF_COUNT_HW_BRANCH_INSTRUCTIONS]	= ARMV8_PMUV3_PERFCTR_BR_RETIRED,
+	[PERF_COUNT_HW_BRANCH_MISSES]		= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+	[PERF_COUNT_HW_BUS_CYCLES]		= ARMV8_PMUV3_PERFCTR_BUS_CYCLES,
+	[PERF_COUNT_HW_STALLED_CYCLES_FRONTEND]	= ARMV8_PMUV3_PERFCTR_STALL_FRONTEND,
+	[PERF_COUNT_HW_STALLED_CYCLES_BACKEND]	= ARMV8_PMUV3_PERFCTR_STALL_BACKEND,
+};
+
+static const unsigned armv8_pmuv3_perf_cache_map[PERF_COUNT_HW_CACHE_MAX]
+						[PERF_COUNT_HW_CACHE_OP_MAX]
+						[PERF_COUNT_HW_CACHE_RESULT_MAX] = {
+	PERF_CACHE_MAP_ALL_UNSUPPORTED,
+
+	[C(L1D)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
+	[C(L1D)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
+	[C(L1D)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
+	[C(L1D)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
+
+	[C(L1I)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE,
+	[C(L1I)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL,
+
+	[C(DTLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1D_TLB_REFILL,
+	[C(DTLB)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1D_TLB,
+
+	[C(ITLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL,
+	[C(ITLB)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB,
+
+	[C(BPU)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
+	[C(BPU)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+	[C(BPU)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
+	[C(BPU)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+};
+
+static const unsigned armv8_a53_perf_cache_map[PERF_COUNT_HW_CACHE_MAX]
+					      [PERF_COUNT_HW_CACHE_OP_MAX]
+					      [PERF_COUNT_HW_CACHE_RESULT_MAX] = {
+	PERF_CACHE_MAP_ALL_UNSUPPORTED,
+
+	[C(L1D)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
+	[C(L1D)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
+	[C(L1D)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE,
+	[C(L1D)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL,
+	[C(L1D)][C(OP_PREFETCH)][C(RESULT_MISS)] = ARMV8_A53_PERFCTR_PREF_LINEFILL,
+
+	[C(L1I)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE,
+	[C(L1I)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL,
+
+	[C(ITLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL,
+
+	[C(BPU)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
+	[C(BPU)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+	[C(BPU)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
+	[C(BPU)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+};
+
+static const unsigned armv8_a57_perf_cache_map[PERF_COUNT_HW_CACHE_MAX]
+					      [PERF_COUNT_HW_CACHE_OP_MAX]
+					      [PERF_COUNT_HW_CACHE_RESULT_MAX] = {
+	PERF_CACHE_MAP_ALL_UNSUPPORTED,
+
+	[C(L1D)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_RD,
+	[C(L1D)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_RD,
+	[C(L1D)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WR,
+	[C(L1D)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_WR,
+
+	[C(L1I)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE,
+	[C(L1I)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL,
+
+	[C(DTLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_RD,
+	[C(DTLB)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_WR,
+
+	[C(ITLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL,
+
+	[C(BPU)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
+	[C(BPU)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+	[C(BPU)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
+	[C(BPU)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+};
+
+static const unsigned armv8_thunder_perf_cache_map[PERF_COUNT_HW_CACHE_MAX]
+						   [PERF_COUNT_HW_CACHE_OP_MAX]
+						   [PERF_COUNT_HW_CACHE_RESULT_MAX] = {
+	PERF_CACHE_MAP_ALL_UNSUPPORTED,
+
+	[C(L1D)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_RD,
+	[C(L1D)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_RD,
+	[C(L1D)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WR,
+	[C(L1D)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_THUNDER_PERFCTR_L1D_CACHE_MISS_ST,
+	[C(L1D)][C(OP_PREFETCH)][C(RESULT_ACCESS)] = ARMV8_THUNDER_PERFCTR_L1D_CACHE_PREF_ACCESS,
+	[C(L1D)][C(OP_PREFETCH)][C(RESULT_MISS)] = ARMV8_THUNDER_PERFCTR_L1D_CACHE_PREF_MISS,
+
+	[C(L1I)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE,
+	[C(L1I)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL,
+	[C(L1I)][C(OP_PREFETCH)][C(RESULT_ACCESS)] = ARMV8_THUNDER_PERFCTR_L1I_CACHE_PREF_ACCESS,
+	[C(L1I)][C(OP_PREFETCH)][C(RESULT_MISS)] = ARMV8_THUNDER_PERFCTR_L1I_CACHE_PREF_MISS,
+
+	[C(DTLB)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_RD,
+	[C(DTLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_RD,
+	[C(DTLB)][C(OP_WRITE)][C(RESULT_ACCESS)] = ARMV8_IMPDEF_PERFCTR_L1D_TLB_WR,
+	[C(DTLB)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_WR,
+
+	[C(ITLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL,
+
+	[C(BPU)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
+	[C(BPU)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+	[C(BPU)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
+	[C(BPU)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+};
+
+static const unsigned armv8_vulcan_perf_cache_map[PERF_COUNT_HW_CACHE_MAX]
+					      [PERF_COUNT_HW_CACHE_OP_MAX]
+					      [PERF_COUNT_HW_CACHE_RESULT_MAX] = {
+	PERF_CACHE_MAP_ALL_UNSUPPORTED,
+
+	[C(L1D)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_RD,
+	[C(L1D)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_RD,
+	[C(L1D)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_WR,
+	[C(L1D)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_CACHE_REFILL_WR,
+
+	[C(L1I)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE,
+	[C(L1I)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL,
+
+	[C(ITLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL,
+	[C(ITLB)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_L1I_TLB,
+
+	[C(DTLB)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_RD,
+	[C(DTLB)][C(OP_WRITE)][C(RESULT_ACCESS)] = ARMV8_IMPDEF_PERFCTR_L1D_TLB_WR,
+	[C(DTLB)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_RD,
+	[C(DTLB)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_IMPDEF_PERFCTR_L1D_TLB_REFILL_WR,
+
+	[C(BPU)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
+	[C(BPU)][C(OP_READ)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+	[C(BPU)][C(OP_WRITE)][C(RESULT_ACCESS)]	= ARMV8_PMUV3_PERFCTR_BR_PRED,
+	[C(BPU)][C(OP_WRITE)][C(RESULT_MISS)]	= ARMV8_PMUV3_PERFCTR_BR_MIS_PRED,
+
+	[C(NODE)][C(OP_READ)][C(RESULT_ACCESS)]	= ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_RD,
+	[C(NODE)][C(OP_WRITE)][C(RESULT_ACCESS)] = ARMV8_IMPDEF_PERFCTR_BUS_ACCESS_WR,
+};
+
+static ssize_t
+armv8pmu_events_sysfs_show(struct device *dev,
+			   struct device_attribute *attr, char *page)
+{
+	struct perf_pmu_events_attr *pmu_attr;
+
+	pmu_attr = container_of(attr, struct perf_pmu_events_attr, attr);
+
+	return sprintf(page, "event=0x%03llx\n", pmu_attr->id);
+}
+
+#define ARMV8_EVENT_ATTR_RESOLVE(m) #m
+#define ARMV8_EVENT_ATTR(name, config) \
+	PMU_EVENT_ATTR(name, armv8_event_attr_##name, \
+		       config, armv8pmu_events_sysfs_show)
+
+ARMV8_EVENT_ATTR(sw_incr, ARMV8_PMUV3_PERFCTR_SW_INCR);
+ARMV8_EVENT_ATTR(l1i_cache_refill, ARMV8_PMUV3_PERFCTR_L1I_CACHE_REFILL);
+ARMV8_EVENT_ATTR(l1i_tlb_refill, ARMV8_PMUV3_PERFCTR_L1I_TLB_REFILL);
+ARMV8_EVENT_ATTR(l1d_cache_refill, ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL);
+ARMV8_EVENT_ATTR(l1d_cache, ARMV8_PMUV3_PERFCTR_L1D_CACHE);
+ARMV8_EVENT_ATTR(l1d_tlb_refill, ARMV8_PMUV3_PERFCTR_L1D_TLB_REFILL);
+ARMV8_EVENT_ATTR(ld_retired, ARMV8_PMUV3_PERFCTR_LD_RETIRED);
+ARMV8_EVENT_ATTR(st_retired, ARMV8_PMUV3_PERFCTR_ST_RETIRED);
+ARMV8_EVENT_ATTR(inst_retired, ARMV8_PMUV3_PERFCTR_INST_RETIRED);
+ARMV8_EVENT_ATTR(exc_taken, ARMV8_PMUV3_PERFCTR_EXC_TAKEN);
+ARMV8_EVENT_ATTR(exc_return, ARMV8_PMUV3_PERFCTR_EXC_RETURN);
+ARMV8_EVENT_ATTR(cid_write_retired, ARMV8_PMUV3_PERFCTR_CID_WRITE_RETIRED);
+ARMV8_EVENT_ATTR(pc_write_retired, ARMV8_PMUV3_PERFCTR_PC_WRITE_RETIRED);
+ARMV8_EVENT_ATTR(br_immed_retired, ARMV8_PMUV3_PERFCTR_BR_IMMED_RETIRED);
+ARMV8_EVENT_ATTR(br_return_retired, ARMV8_PMUV3_PERFCTR_BR_RETURN_RETIRED);
+ARMV8_EVENT_ATTR(unaligned_ldst_retired, ARMV8_PMUV3_PERFCTR_UNALIGNED_LDST_RETIRED);
+ARMV8_EVENT_ATTR(br_mis_pred, ARMV8_PMUV3_PERFCTR_BR_MIS_PRED);
+ARMV8_EVENT_ATTR(cpu_cycles, ARMV8_PMUV3_PERFCTR_CPU_CYCLES);
+ARMV8_EVENT_ATTR(br_pred, ARMV8_PMUV3_PERFCTR_BR_PRED);
+ARMV8_EVENT_ATTR(mem_access, ARMV8_PMUV3_PERFCTR_MEM_ACCESS);
+ARMV8_EVENT_ATTR(l1i_cache, ARMV8_PMUV3_PERFCTR_L1I_CACHE);
+ARMV8_EVENT_ATTR(l1d_cache_wb, ARMV8_PMUV3_PERFCTR_L1D_CACHE_WB);
+ARMV8_EVENT_ATTR(l2d_cache, ARMV8_PMUV3_PERFCTR_L2D_CACHE);
+ARMV8_EVENT_ATTR(l2d_cache_refill, ARMV8_PMUV3_PERFCTR_L2D_CACHE_REFILL);
+ARMV8_EVENT_ATTR(l2d_cache_wb, ARMV8_PMUV3_PERFCTR_L2D_CACHE_WB);
+ARMV8_EVENT_ATTR(bus_access, ARMV8_PMUV3_PERFCTR_BUS_ACCESS);
+ARMV8_EVENT_ATTR(memory_error, ARMV8_PMUV3_PERFCTR_MEMORY_ERROR);
+ARMV8_EVENT_ATTR(inst_spec, ARMV8_PMUV3_PERFCTR_INST_SPEC);
+ARMV8_EVENT_ATTR(ttbr_write_retired, ARMV8_PMUV3_PERFCTR_TTBR_WRITE_RETIRED);
+ARMV8_EVENT_ATTR(bus_cycles, ARMV8_PMUV3_PERFCTR_BUS_CYCLES);
+/* Don't expose the chain event in /sys, since it's useless in isolation */
+ARMV8_EVENT_ATTR(l1d_cache_allocate, ARMV8_PMUV3_PERFCTR_L1D_CACHE_ALLOCATE);
+ARMV8_EVENT_ATTR(l2d_cache_allocate, ARMV8_PMUV3_PERFCTR_L2D_CACHE_ALLOCATE);
+ARMV8_EVENT_ATTR(br_retired, ARMV8_PMUV3_PERFCTR_BR_RETIRED);
+ARMV8_EVENT_ATTR(br_mis_pred_retired, ARMV8_PMUV3_PERFCTR_BR_MIS_PRED_RETIRED);
+ARMV8_EVENT_ATTR(stall_frontend, ARMV8_PMUV3_PERFCTR_STALL_FRONTEND);
+ARMV8_EVENT_ATTR(stall_backend, ARMV8_PMUV3_PERFCTR_STALL_BACKEND);
+ARMV8_EVENT_ATTR(l1d_tlb, ARMV8_PMUV3_PERFCTR_L1D_TLB);
+ARMV8_EVENT_ATTR(l1i_tlb, ARMV8_PMUV3_PERFCTR_L1I_TLB);
+ARMV8_EVENT_ATTR(l2i_cache, ARMV8_PMUV3_PERFCTR_L2I_CACHE);
+ARMV8_EVENT_ATTR(l2i_cache_refill, ARMV8_PMUV3_PERFCTR_L2I_CACHE_REFILL);
+ARMV8_EVENT_ATTR(l3d_cache_allocate, ARMV8_PMUV3_PERFCTR_L3D_CACHE_ALLOCATE);
+ARMV8_EVENT_ATTR(l3d_cache_refill, ARMV8_PMUV3_PERFCTR_L3D_CACHE_REFILL);
+ARMV8_EVENT_ATTR(l3d_cache, ARMV8_PMUV3_PERFCTR_L3D_CACHE);
+ARMV8_EVENT_ATTR(l3d_cache_wb, ARMV8_PMUV3_PERFCTR_L3D_CACHE_WB);
+ARMV8_EVENT_ATTR(l2d_tlb_refill, ARMV8_PMUV3_PERFCTR_L2D_TLB_REFILL);
+ARMV8_EVENT_ATTR(l2i_tlb_refill, ARMV8_PMUV3_PERFCTR_L2I_TLB_REFILL);
+ARMV8_EVENT_ATTR(l2d_tlb, ARMV8_PMUV3_PERFCTR_L2D_TLB);
+ARMV8_EVENT_ATTR(l2i_tlb, ARMV8_PMUV3_PERFCTR_L2I_TLB);
+
+static struct attribute *armv8_pmuv3_event_attrs[] = {
+	&armv8_event_attr_sw_incr.attr.attr,
+	&armv8_event_attr_l1i_cache_refill.attr.attr,
+	&armv8_event_attr_l1i_tlb_refill.attr.attr,
+	&armv8_event_attr_l1d_cache_refill.attr.attr,
+	&armv8_event_attr_l1d_cache.attr.attr,
+	&armv8_event_attr_l1d_tlb_refill.attr.attr,
+	&armv8_event_attr_ld_retired.attr.attr,
+	&armv8_event_attr_st_retired.attr.attr,
+	&armv8_event_attr_inst_retired.attr.attr,
+	&armv8_event_attr_exc_taken.attr.attr,
+	&armv8_event_attr_exc_return.attr.attr,
+	&armv8_event_attr_cid_write_retired.attr.attr,
+	&armv8_event_attr_pc_write_retired.attr.attr,
+	&armv8_event_attr_br_immed_retired.attr.attr,
+	&armv8_event_attr_br_return_retired.attr.attr,
+	&armv8_event_attr_unaligned_ldst_retired.attr.attr,
+	&armv8_event_attr_br_mis_pred.attr.attr,
+	&armv8_event_attr_cpu_cycles.attr.attr,
+	&armv8_event_attr_br_pred.attr.attr,
+	&armv8_event_attr_mem_access.attr.attr,
+	&armv8_event_attr_l1i_cache.attr.attr,
+	&armv8_event_attr_l1d_cache_wb.attr.attr,
+	&armv8_event_attr_l2d_cache.attr.attr,
+	&armv8_event_attr_l2d_cache_refill.attr.attr,
+	&armv8_event_attr_l2d_cache_wb.attr.attr,
+	&armv8_event_attr_bus_access.attr.attr,
+	&armv8_event_attr_memory_error.attr.attr,
+	&armv8_event_attr_inst_spec.attr.attr,
+	&armv8_event_attr_ttbr_write_retired.attr.attr,
+	&armv8_event_attr_bus_cycles.attr.attr,
+	&armv8_event_attr_l1d_cache_allocate.attr.attr,
+	&armv8_event_attr_l2d_cache_allocate.attr.attr,
+	&armv8_event_attr_br_retired.attr.attr,
+	&armv8_event_attr_br_mis_pred_retired.attr.attr,
+	&armv8_event_attr_stall_frontend.attr.attr,
+	&armv8_event_attr_stall_backend.attr.attr,
+	&armv8_event_attr_l1d_tlb.attr.attr,
+	&armv8_event_attr_l1i_tlb.attr.attr,
+	&armv8_event_attr_l2i_cache.attr.attr,
+	&armv8_event_attr_l2i_cache_refill.attr.attr,
+	&armv8_event_attr_l3d_cache_allocate.attr.attr,
+	&armv8_event_attr_l3d_cache_refill.attr.attr,
+	&armv8_event_attr_l3d_cache.attr.attr,
+	&armv8_event_attr_l3d_cache_wb.attr.attr,
+	&armv8_event_attr_l2d_tlb_refill.attr.attr,
+	&armv8_event_attr_l2i_tlb_refill.attr.attr,
+	&armv8_event_attr_l2d_tlb.attr.attr,
+	&armv8_event_attr_l2i_tlb.attr.attr,
+	NULL,
+};
+
+static umode_t
+armv8pmu_event_attr_is_visible(struct kobject *kobj,
+			       struct attribute *attr, int unused)
+{
+	struct device *dev = kobj_to_dev(kobj);
+	struct pmu *pmu = dev_get_drvdata(dev);
+	struct arm_pmu *cpu_pmu = container_of(pmu, struct arm_pmu, pmu);
+	struct perf_pmu_events_attr *pmu_attr;
+
+	pmu_attr = container_of(attr, struct perf_pmu_events_attr, attr.attr);
+
+	if (test_bit(pmu_attr->id, cpu_pmu->pmceid_bitmap))
+		return attr->mode;
+
+	return 0;
+}
+
+static struct attribute_group armv8_pmuv3_events_attr_group = {
+	.name = "events",
+	.attrs = armv8_pmuv3_event_attrs,
+	.is_visible = armv8pmu_event_attr_is_visible,
+};
+
+PMU_FORMAT_ATTR(event, "config:0-9");
+
+static struct attribute *armv8_pmuv3_format_attrs[] = {
+	&format_attr_event.attr,
+	NULL,
+};
+
+static struct attribute_group armv8_pmuv3_format_attr_group = {
+	.name = "format",
+	.attrs = armv8_pmuv3_format_attrs,
+};
+
+/*
+ * Perf Events' indices
+ */
+#define	ARMV8_IDX_CYCLE_COUNTER	0
+#define	ARMV8_IDX_COUNTER0	1
+#define	ARMV8_IDX_COUNTER_LAST(cpu_pmu) \
+	(ARMV8_IDX_CYCLE_COUNTER + cpu_pmu->num_events - 1)
+
+/*
+ * ARMv8 low level PMU access
+ */
+
+/*
+ * Perf Event to low level counters mapping
+ */
+#define	ARMV8_IDX_TO_COUNTER(x)	\
+	(((x) - ARMV8_IDX_COUNTER0) & ARMV8_PMU_COUNTER_MASK)
+
+static inline u32 armv8pmu_pmcr_read(void)
+{
+	return read_pmcr();
+}
+
+static inline void armv8pmu_pmcr_write(u32 val)
+{
+	val &= ARMV8_PMU_PMCR_MASK;
+	isb();
+	write_pmcr(val);
+}
+
+static inline int armv8pmu_has_overflowed(u32 pmovsr)
+{
+	return pmovsr & ARMV8_PMU_OVERFLOWED_MASK;
+}
+
+static inline int armv8pmu_counter_valid(struct arm_pmu *cpu_pmu, int idx)
+{
+	return idx >= ARMV8_IDX_CYCLE_COUNTER &&
+		idx <= ARMV8_IDX_COUNTER_LAST(cpu_pmu);
+}
+
+static inline int armv8pmu_counter_has_overflowed(u32 pmnc, int idx)
+{
+	return pmnc & BIT(ARMV8_IDX_TO_COUNTER(idx));
+}
+
+static inline int armv8pmu_select_counter(int idx)
+{
+	u32 counter = ARMV8_IDX_TO_COUNTER(idx);
+	write_pmselr(counter);
+	isb();
+
+	return idx;
+}
+
+static inline u32 armv8pmu_read_counter(struct perf_event *event)
+{
+	struct arm_pmu *cpu_pmu = to_arm_pmu(event->pmu);
+	struct hw_perf_event *hwc = &event->hw;
+	int idx = hwc->idx;
+	u32 value = 0;
+
+	if (!armv8pmu_counter_valid(cpu_pmu, idx))
+		pr_err("CPU%u reading wrong counter %d\n",
+			smp_processor_id(), idx);
+	else if (idx == ARMV8_IDX_CYCLE_COUNTER)
+		value = read_pmccntr();
+	else if (armv8pmu_select_counter(idx) == idx)
+		value = read_pmxevcntr();
+
+	return value;
+}
+
+static inline void armv8pmu_write_counter(struct perf_event *event, u32 value)
+{
+	struct arm_pmu *cpu_pmu = to_arm_pmu(event->pmu);
+	struct hw_perf_event *hwc = &event->hw;
+	int idx = hwc->idx;
+
+	if (!armv8pmu_counter_valid(cpu_pmu, idx))
+		pr_err("CPU%u writing wrong counter %d\n",
+			smp_processor_id(), idx);
+	else if (idx == ARMV8_IDX_CYCLE_COUNTER) {
+		/*
+		 * Set the upper 32bits as this is a 64bit counter but we only
+		 * count using the lower 32bits and we want an interrupt when
+		 * it overflows.
+		 */
+		u64 value64 = 0xffffffff00000000ULL | value;
+
+		write_pmccntr(value64);
+	} else if (armv8pmu_select_counter(idx) == idx)
+		write_pmxevcntr(value);
+}
+
+static inline void armv8pmu_write_evtype(int idx, u32 val)
+{
+	if (armv8pmu_select_counter(idx) == idx) {
+		val &= ARMV8_PMU_EVTYPE_MASK;
+		write_pmxevtyper(val);
+	}
+}
+
+static inline int armv8pmu_enable_counter(int idx)
+{
+	u32 counter = ARMV8_IDX_TO_COUNTER(idx);
+	write_pmcntenset(BIT(counter));
+	return idx;
+}
+
+static inline int armv8pmu_disable_counter(int idx)
+{
+	u32 counter = ARMV8_IDX_TO_COUNTER(idx);
+	write_pmcntenclr(BIT(counter));
+	return idx;
+}
+
+static inline int armv8pmu_enable_intens(int idx)
+{
+	u32 counter = ARMV8_IDX_TO_COUNTER(idx);
+	write_pmintenset(BIT(counter));
+	return idx;
+}
+
+static inline int armv8pmu_disable_intens(int idx)
+{
+	u32 counter = ARMV8_IDX_TO_COUNTER(idx);
+	write_pmintenclr(BIT(counter));
+	isb();
+	/* Clear the overflow flag in case an interrupt is pending. */
+	write_pmovsclr(BIT(counter));
+	isb();
+
+	return idx;
+}
+
+static inline u32 armv8pmu_getreset_flags(void)
+{
+	u32 value;
+
+	/* Read */
+	value = read_pmovsclr();
+
+	/* Write to clear flags */
+	value &= ARMV8_PMU_OVSR_MASK;
+	write_pmovsclr(value);
+
+	return value;
+}
+
+static void armv8pmu_enable_event(struct perf_event *event)
+{
+	unsigned long flags;
+	struct hw_perf_event *hwc = &event->hw;
+	struct arm_pmu *cpu_pmu = to_arm_pmu(event->pmu);
+	struct pmu_hw_events *events = this_cpu_ptr(cpu_pmu->hw_events);
+	int idx = hwc->idx;
+
+	/*
+	 * Enable counter and interrupt, and set the counter to count
+	 * the event that we're interested in.
+	 */
+	raw_spin_lock_irqsave(&events->pmu_lock, flags);
+
+	/*
+	 * Disable counter
+	 */
+	armv8pmu_disable_counter(idx);
+
+	/*
+	 * Set event (if destined for PMNx counters).
+	 */
+	armv8pmu_write_evtype(idx, hwc->config_base);
+
+	/*
+	 * Enable interrupt for this counter
+	 */
+	armv8pmu_enable_intens(idx);
+
+	/*
+	 * Enable counter
+	 */
+	armv8pmu_enable_counter(idx);
+
+	raw_spin_unlock_irqrestore(&events->pmu_lock, flags);
+}
+
+static void armv8pmu_disable_event(struct perf_event *event)
+{
+	unsigned long flags;
+	struct hw_perf_event *hwc = &event->hw;
+	struct arm_pmu *cpu_pmu = to_arm_pmu(event->pmu);
+	struct pmu_hw_events *events = this_cpu_ptr(cpu_pmu->hw_events);
+	int idx = hwc->idx;
+
+	/*
+	 * Disable counter and interrupt
+	 */
+	raw_spin_lock_irqsave(&events->pmu_lock, flags);
+
+	/*
+	 * Disable counter
+	 */
+	armv8pmu_disable_counter(idx);
+
+	/*
+	 * Disable interrupt for this counter
+	 */
+	armv8pmu_disable_intens(idx);
+
+	raw_spin_unlock_irqrestore(&events->pmu_lock, flags);
+}
+
+static irqreturn_t armv8pmu_handle_irq(int irq_num, void *dev)
+{
+	u32 pmovsr;
+	struct perf_sample_data data;
+	struct arm_pmu *cpu_pmu = (struct arm_pmu *)dev;
+	struct pmu_hw_events *cpuc = this_cpu_ptr(cpu_pmu->hw_events);
+	struct pt_regs *regs;
+	int idx;
+
+	/*
+	 * Get and reset the IRQ flags
+	 */
+	pmovsr = armv8pmu_getreset_flags();
+
+	/*
+	 * Did an overflow occur?
+	 */
+	if (!armv8pmu_has_overflowed(pmovsr))
+		return IRQ_NONE;
+
+	/*
+	 * Handle the counter(s) overflow(s)
+	 */
+	regs = get_irq_regs();
+
+	for (idx = 0; idx < cpu_pmu->num_events; ++idx) {
+		struct perf_event *event = cpuc->events[idx];
+		struct hw_perf_event *hwc;
+
+		/* Ignore if we don't have an event. */
+		if (!event)
+			continue;
+
+		/*
+		 * We have a single interrupt for all counters. Check that
+		 * each counter has overflowed before we process it.
+		 */
+		if (!armv8pmu_counter_has_overflowed(pmovsr, idx))
+			continue;
+
+		hwc = &event->hw;
+		armpmu_event_update(event);
+		perf_sample_data_init(&data, 0, hwc->last_period);
+		if (!armpmu_event_set_period(event))
+			continue;
+
+		if (perf_event_overflow(event, &data, regs))
+			cpu_pmu->disable(event);
+	}
+
+	/*
+	 * Handle the pending perf events.
+	 *
+	 * Note: this call *must* be run with interrupts disabled. For
+	 * platforms that can have the PMU interrupts raised as an NMI, this
+	 * will not work.
+	 */
+	irq_work_run();
+
+	return IRQ_HANDLED;
+}
+
+static void armv8pmu_start(struct arm_pmu *cpu_pmu)
+{
+	unsigned long flags;
+	struct pmu_hw_events *events = this_cpu_ptr(cpu_pmu->hw_events);
+
+	raw_spin_lock_irqsave(&events->pmu_lock, flags);
+	/* Enable all counters */
+	armv8pmu_pmcr_write(armv8pmu_pmcr_read() | ARMV8_PMU_PMCR_E);
+	raw_spin_unlock_irqrestore(&events->pmu_lock, flags);
+}
+
+static void armv8pmu_stop(struct arm_pmu *cpu_pmu)
+{
+	unsigned long flags;
+	struct pmu_hw_events *events = this_cpu_ptr(cpu_pmu->hw_events);
+
+	raw_spin_lock_irqsave(&events->pmu_lock, flags);
+	/* Disable all counters */
+	armv8pmu_pmcr_write(armv8pmu_pmcr_read() & ~ARMV8_PMU_PMCR_E);
+	raw_spin_unlock_irqrestore(&events->pmu_lock, flags);
+}
+
+static int armv8pmu_get_event_idx(struct pmu_hw_events *cpuc,
+				  struct perf_event *event)
+{
+	int idx;
+	struct arm_pmu *cpu_pmu = to_arm_pmu(event->pmu);
+	struct hw_perf_event *hwc = &event->hw;
+	unsigned long evtype = hwc->config_base & ARMV8_PMU_EVTYPE_EVENT;
+
+	/* Always place a cycle counter into the cycle counter. */
+	if (evtype == ARMV8_PMUV3_PERFCTR_CPU_CYCLES) {
+		if (test_and_set_bit(ARMV8_IDX_CYCLE_COUNTER, cpuc->used_mask))
+			return -EAGAIN;
+
+		return ARMV8_IDX_CYCLE_COUNTER;
+	}
+
+	/*
+	 * For anything other than a cycle counter, try and use
+	 * the events counters
+	 */
+	for (idx = ARMV8_IDX_COUNTER0; idx < cpu_pmu->num_events; ++idx) {
+		if (!test_and_set_bit(idx, cpuc->used_mask))
+			return idx;
+	}
+
+	/* The counters are all in use. */
+	return -EAGAIN;
+}
+
+/*
+ * Add an event filter to a given event. This will only work for PMUv2 PMUs.
+ */
+static int armv8pmu_set_event_filter(struct hw_perf_event *event,
+				     struct perf_event_attr *attr)
+{
+	unsigned long config_base = 0;
+
+	if (attr->exclude_idle)
+		return -EPERM;
+
+	/*
+	 * If we're running in hyp mode, then we *are* the hypervisor.
+	 * Therefore we ignore exclude_hv in this configuration, since
+	 * there's no hypervisor to sample anyway. This is consistent
+	 * with other architectures (x86 and Power).
+	 */
+	if (is_kernel_in_hyp_mode()) {
+		if (!attr->exclude_kernel)
+			config_base |= ARMV8_PMU_INCLUDE_EL2;
+	} else {
+		if (attr->exclude_kernel)
+			config_base |= ARMV8_PMU_EXCLUDE_EL1;
+		if (!attr->exclude_hv)
+			config_base |= ARMV8_PMU_INCLUDE_EL2;
+	}
+	if (attr->exclude_user)
+		config_base |= ARMV8_PMU_EXCLUDE_EL0;
+
+	/*
+	 * Install the filter into config_base as this is used to
+	 * construct the event type.
+	 */
+	event->config_base = config_base;
+
+	return 0;
+}
+
+static void armv8pmu_reset(void *info)
+{
+	struct arm_pmu *cpu_pmu = (struct arm_pmu *)info;
+	u32 idx, nb_cnt = cpu_pmu->num_events;
+
+	/* The counter and interrupt enable registers are unknown at reset. */
+	for (idx = ARMV8_IDX_CYCLE_COUNTER; idx < nb_cnt; ++idx) {
+		armv8pmu_disable_counter(idx);
+		armv8pmu_disable_intens(idx);
+	}
+
+	/*
+	 * Initialize & Reset PMNC. Request overflow interrupt for
+	 * 64 bit cycle counter but cheat in armv8pmu_write_counter().
+	 */
+	armv8pmu_pmcr_write(ARMV8_PMU_PMCR_P | ARMV8_PMU_PMCR_C |
+			    ARMV8_PMU_PMCR_LC);
+}
+
+static int armv8_pmuv3_map_event(struct perf_event *event)
+{
+	int hw_event_id;
+	struct arm_pmu *armpmu = to_arm_pmu(event->pmu);
+
+	hw_event_id = armpmu_map_event(event, &armv8_pmuv3_perf_map,
+				       &armv8_pmuv3_perf_cache_map,
+				       ARMV8_PMU_EVTYPE_EVENT);
+	if (hw_event_id < 0)
+		return hw_event_id;
+
+	/* disable micro/arch events not supported by this PMU */
+	if ((hw_event_id < ARMV8_PMUV3_MAX_COMMON_EVENTS) &&
+		!test_bit(hw_event_id, armpmu->pmceid_bitmap)) {
+			return -EOPNOTSUPP;
+	}
+
+	return hw_event_id;
+}
+
+static int armv8_a53_map_event(struct perf_event *event)
+{
+	return armpmu_map_event(event, &armv8_a53_perf_map,
+				&armv8_a53_perf_cache_map,
+				ARMV8_PMU_EVTYPE_EVENT);
+}
+
+static int armv8_a57_map_event(struct perf_event *event)
+{
+	return armpmu_map_event(event, &armv8_a57_perf_map,
+				&armv8_a57_perf_cache_map,
+				ARMV8_PMU_EVTYPE_EVENT);
+}
+
+static int armv8_thunder_map_event(struct perf_event *event)
+{
+	return armpmu_map_event(event, &armv8_thunder_perf_map,
+				&armv8_thunder_perf_cache_map,
+				ARMV8_PMU_EVTYPE_EVENT);
+}
+
+static int armv8_vulcan_map_event(struct perf_event *event)
+{
+	return armpmu_map_event(event, &armv8_vulcan_perf_map,
+				&armv8_vulcan_perf_cache_map,
+				ARMV8_PMU_EVTYPE_EVENT);
+}
+
+static void __armv8pmu_probe_pmu(void *info)
+{
+	struct arm_pmu *cpu_pmu = info;
+	u32 pmceid[2];
+
+	/* Read the nb of CNTx counters supported from PMNC */
+	cpu_pmu->num_events = (armv8pmu_pmcr_read() >> ARMV8_PMU_PMCR_N_SHIFT)
+		& ARMV8_PMU_PMCR_N_MASK;
+
+	/* Add the CPU cycles counter */
+	cpu_pmu->num_events += 1;
+
+	pmceid[0] = read_pmceid0();
+	pmceid[1] = read_pmceid1();
+
+	bitmap_from_u32array(cpu_pmu->pmceid_bitmap,
+			     ARMV8_PMUV3_MAX_COMMON_EVENTS, pmceid,
+			     ARRAY_SIZE(pmceid));
+}
+
+static int armv8pmu_probe_pmu(struct arm_pmu *cpu_pmu)
+{
+	return smp_call_function_any(&cpu_pmu->supported_cpus,
+				    __armv8pmu_probe_pmu,
+				    cpu_pmu, 1);
+}
+
+static void armv8_pmu_init(struct arm_pmu *cpu_pmu)
+{
+	cpu_pmu->handle_irq		= armv8pmu_handle_irq,
+	cpu_pmu->enable			= armv8pmu_enable_event,
+	cpu_pmu->disable		= armv8pmu_disable_event,
+	cpu_pmu->read_counter		= armv8pmu_read_counter,
+	cpu_pmu->write_counter		= armv8pmu_write_counter,
+	cpu_pmu->get_event_idx		= armv8pmu_get_event_idx,
+	cpu_pmu->start			= armv8pmu_start,
+	cpu_pmu->stop			= armv8pmu_stop,
+	cpu_pmu->reset			= armv8pmu_reset,
+	cpu_pmu->max_period		= (1LLU << 32) - 1,
+	cpu_pmu->set_event_filter	= armv8pmu_set_event_filter;
+}
+
+static int armv8_pmuv3_init(struct arm_pmu *cpu_pmu)
+{
+	armv8_pmu_init(cpu_pmu);
+	cpu_pmu->name			= "armv8_pmuv3";
+	cpu_pmu->map_event		= armv8_pmuv3_map_event;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
+		&armv8_pmuv3_events_attr_group;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
+		&armv8_pmuv3_format_attr_group;
+	return armv8pmu_probe_pmu(cpu_pmu);
+}
+
+static int armv8_a53_pmu_init(struct arm_pmu *cpu_pmu)
+{
+	armv8_pmu_init(cpu_pmu);
+	cpu_pmu->name			= "armv8_cortex_a53";
+	cpu_pmu->map_event		= armv8_a53_map_event;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
+		&armv8_pmuv3_events_attr_group;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
+		&armv8_pmuv3_format_attr_group;
+	return armv8pmu_probe_pmu(cpu_pmu);
+}
+
+static int armv8_a57_pmu_init(struct arm_pmu *cpu_pmu)
+{
+	armv8_pmu_init(cpu_pmu);
+	cpu_pmu->name			= "armv8_cortex_a57";
+	cpu_pmu->map_event		= armv8_a57_map_event;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
+		&armv8_pmuv3_events_attr_group;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
+		&armv8_pmuv3_format_attr_group;
+	return armv8pmu_probe_pmu(cpu_pmu);
+}
+
+static int armv8_a72_pmu_init(struct arm_pmu *cpu_pmu)
+{
+	armv8_pmu_init(cpu_pmu);
+	cpu_pmu->name			= "armv8_cortex_a72";
+	cpu_pmu->map_event		= armv8_a57_map_event;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
+		&armv8_pmuv3_events_attr_group;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
+		&armv8_pmuv3_format_attr_group;
+	return armv8pmu_probe_pmu(cpu_pmu);
+}
+
+static int armv8_thunder_pmu_init(struct arm_pmu *cpu_pmu)
+{
+	armv8_pmu_init(cpu_pmu);
+	cpu_pmu->name			= "armv8_cavium_thunder";
+	cpu_pmu->map_event		= armv8_thunder_map_event;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
+		&armv8_pmuv3_events_attr_group;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
+		&armv8_pmuv3_format_attr_group;
+	return armv8pmu_probe_pmu(cpu_pmu);
+}
+
+static int armv8_vulcan_pmu_init(struct arm_pmu *cpu_pmu)
+{
+	armv8_pmu_init(cpu_pmu);
+	cpu_pmu->name			= "armv8_brcm_vulcan";
+	cpu_pmu->map_event		= armv8_vulcan_map_event;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_EVENTS] =
+		&armv8_pmuv3_events_attr_group;
+	cpu_pmu->attr_groups[ARMPMU_ATTR_GROUP_FORMATS] =
+		&armv8_pmuv3_format_attr_group;
+	return armv8pmu_probe_pmu(cpu_pmu);
+}
+
+static const struct of_device_id armv8_pmu_of_device_ids[] = {
+	{.compatible = "arm,armv8-pmuv3",	.data = armv8_pmuv3_init},
+	{.compatible = "arm,cortex-a53-pmu",	.data = armv8_a53_pmu_init},
+	{.compatible = "arm,cortex-a57-pmu",	.data = armv8_a57_pmu_init},
+	{.compatible = "arm,cortex-a72-pmu",	.data = armv8_a72_pmu_init},
+	{.compatible = "cavium,thunder-pmu",	.data = armv8_thunder_pmu_init},
+	{.compatible = "brcm,vulcan-pmu",	.data = armv8_vulcan_pmu_init},
+	{},
+};
+
+/*
+ * Non DT systems have their micro/arch events probed at run-time.
+ * A fairly complete list of generic events are provided and ones that
+ * aren't supported by the current PMU are disabled.
+ */
+static const struct pmu_probe_info armv8_pmu_probe_table[] = {
+	PMU_PROBE(0, 0, armv8_pmuv3_init), /* enable all defined counters */
+	{ /* sentinel value */ }
+};
+
+static int armv8_pmu_device_probe(struct platform_device *pdev)
+{
+	if (acpi_disabled)
+		return arm_pmu_device_probe(pdev, armv8_pmu_of_device_ids,
+					    NULL);
+
+	return arm_pmu_device_probe(pdev, armv8_pmu_of_device_ids,
+				    armv8_pmu_probe_table);
+}
+
+static struct platform_driver armv8_pmu_driver = {
+	.driver		= {
+		.name	= ARMV8_PMU_PDEV_NAME,
+		.of_match_table = armv8_pmu_of_device_ids,
+	},
+	.probe		= armv8_pmu_device_probe,
+};
+
+builtin_platform_driver(armv8_pmu_driver);
diff --git a/drivers/phy/Kconfig b/drivers/phy/Kconfig
index 7dc726d..b8cf112 100644
--- a/drivers/phy/Kconfig
+++ b/drivers/phy/Kconfig
@@ -490,4 +490,12 @@ config PHY_NS2_PCIE
 	help
 	  Enable this to support the Broadcom Northstar2 PCIe PHY.
 	  If unsure, say N.
+
+config PHY_RTK_SATA
+	tristate "Realtek SATA PHY driver"
+	depends on OF
+	select GENERIC_PHY
+	help
+	  Support for SATA GEN3 PHY on realtek chipsets.
+
 endmenu
diff --git a/drivers/phy/Makefile b/drivers/phy/Makefile
index a534cf5..94e6b04 100644
--- a/drivers/phy/Makefile
+++ b/drivers/phy/Makefile
@@ -60,3 +60,4 @@ obj-$(CONFIG_PHY_PISTACHIO_USB)		+= phy-pistachio-usb.o
 obj-$(CONFIG_PHY_CYGNUS_PCIE)		+= phy-bcm-cygnus-pcie.o
 obj-$(CONFIG_ARCH_TEGRA) += tegra/
 obj-$(CONFIG_PHY_NS2_PCIE)		+= phy-bcm-ns2-pcie.o
+obj-$(CONFIG_PHY_RTK_SATA)      += phy-rtk-sata.o
diff --git a/drivers/phy/phy-rtk-sata.c b/drivers/phy/phy-rtk-sata.c
new file mode 100644
index 00000000..7d49e77
--- /dev/null
+++ b/drivers/phy/phy-rtk-sata.c
@@ -0,0 +1,643 @@
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/of_address.h>
+#include <linux/clk.h>
+#include <linux/io.h>
+#include <linux/reset.h>
+#include <linux/phy/phy.h>
+#include <linux/delay.h>
+
+#include <soc/realtek/rtk_chip.h>
+
+#define RTK_SATA_PHY_NUMBER	2
+#define DEFAULT_TXDRV_LEVEL	3
+#define PHY_MAX_CLK		5
+#define PHY_MAX_RST		5
+
+#define PHY_CLK_EN		0x18
+#define MDIO_CTR		0x60
+#define MDIO_CTR1		0x64
+#define PHY_SPD			0x68
+
+struct phy_rtk_desc {
+	unsigned int index;
+	unsigned int param_size;
+	unsigned int *param_table;
+	unsigned int txdrv_size;
+	unsigned int *txdrv_table;
+	unsigned int rxsense_size;
+	unsigned int *rxsense_table;
+	unsigned int ssc_en;
+	unsigned int speed;
+	struct phy *phy;
+	struct reset_control *rsts[PHY_MAX_RST];
+};
+
+struct phy_rtk_priv {
+	void __iomem *base;
+	void __iomem *sb2base;
+	struct clk *clks[PHY_MAX_CLK];
+	struct reset_control *rsts[PHY_MAX_RST];
+	struct phy_rtk_desc **phys;
+	struct device *dev;
+	unsigned int nphys;
+	enum rtd_chip_id chip_id;
+	enum rtd_chip_revision chip_revision;
+};
+
+static const unsigned int PHY_PARA_TABLE[] = {
+	0x00001111, 0x00005111, 0x00009111,
+	0x336a0511, 0x336a4511, 0x336a8511,
+	0xE0700111, 0xE05C4111, 0xE04A8111,
+	0x00150611, 0x00154611, 0x00158611,
+	0xC6000A11, 0xC6004A11, 0xC6008A11,
+	0x70000211, 0x70004211, 0x70008211,
+	0xC6600A11, 0xC6604A11, 0xC6608A11,
+	0x20041911, 0x20045911, 0x20049911,
+	0x94aa2011, 0x94aa6011, 0x94aaa011,
+	0x17171511, 0x17175511, 0x17179511,
+	0x07701611, 0x07705611, 0x07709611,
+	0x40002a11, 0x40006a11, 0x4000aa11,
+	0x29001011, 0x29005011, 0x29009011,
+	0x40000C11, 0x40004C11, 0x40008C11,
+	0x00271711, 0x00275711, 0x00279711,
+};
+
+static const unsigned int TX_DRV_TABLE[][6] = {
+	//max_500mV
+	{ 0x94a52011, 0x94a56011, 0x94a5a011,
+		0x385a2111, 0x385a6111, 0x385aa111 },
+	//max_573mV
+	{ 0x94a62011, 0x94a66011, 0x94a6a011,
+		0x486a2111, 0x486a6111, 0x486aa111 },
+	//max_683mV
+	{ 0x94a72011, 0x94a76011, 0x94a7a011,
+		0x587a2111, 0x587a6111, 0x587aa111 },
+	//max_786mV
+	{ 0x94aa2011, 0x94aa6011, 0x94aaa011,
+		0x88aa2111, 0x88aa6111, 0x88aaa111 },
+	//max_786mV
+	{ 0x94aa2011, 0x94aa6011, 0x94aaa011,
+		0x88aa2111, 0x88aa6111, 0x88aaa111 },
+	//max_786mV
+	{ 0x94aa2011, 0x94aa6011, 0x94aaa011,
+		0x88aa2111, 0x88aa6111, 0x88aaa111 },
+	//max_786mV
+	{ 0x94aa2011, 0x94aa6011, 0x94aaa011,
+		0x88aa2111, 0x88aa6111, 0x88aaa111 },
+	//max_786mV
+	{ 0x94aa2011, 0x94aa6011, 0x94aaa011,
+		0x88aa2111, 0x88aa6111, 0x88aaa111 },
+};
+
+static const unsigned int PHY_SENSITIVITY[][6] = {
+	{ 0x72100911, 0x72104911, 0x72108911,
+		0x27730311, 0x27684311, 0x27688311 },
+	{ 0x42100911, 0x42104911, 0x42108911,
+		0x276f0311, 0x276d4311, 0x276d8311 },
+	{ 0x42100911, 0x42104911, 0x42108911,
+		0x276a0311, 0x276a4311, 0x27688311 },
+};
+
+static const unsigned int SSCEN_SET_TABLE[] = {
+	0x738E0411, 0x738E0411, 0x738E8411,
+	0x35910811, 0x35914811, 0x35918811,
+	0x02342711, 0x02346711, 0x0234a711,
+};
+
+static const unsigned int SSCDIS_SET_TABLE[] = {
+	0x538E0411, 0x538E4411, 0x538E8411,
+};
+
+static const unsigned int PHY_CLOCK_DELAY[] = {
+	0x7c002a11, 0x7c006a11, 0x7c00aa11,
+};
+
+static const unsigned int PHY_PARA_TABLE_THOR[] = {
+	0x70000211, 0x70004211, 0x70008211,
+	0x336a0511, 0x336a4511, 0x336a8511,
+	0xa9040b11, 0xa9044b11, 0xa9048b11,
+	0x500b1411, 0x500b5411, 0x500b9411,
+	0x77771511, 0x77775511, 0x77779511,
+	0x00231711, 0x00235711, 0x00239711,
+	0x00632211, 0x00636211, 0x0063a211,
+	0xab762311, 0xab766311, 0xab76a311,
+};
+
+static const unsigned int TX_DRV_TABLE_THOR[][6] = {
+	{ 0x40aa2011, 0x40aa6011, 0x40a8a011,
+		0x88aa2111, 0x88aa6111, 0x88aaa111 },
+};
+
+static int write_mdio_reg(unsigned int value, void __iomem *address)
+{
+	unsigned int cnt = 0;
+
+	while (readl(address) & 0x80) {
+		udelay(10);
+		cnt++;
+		if (cnt > 5) {
+			pr_err("sata %s fail\n", __func__);
+			return -1;
+		}
+	}
+	writel(value, address);
+
+	return 0;
+}
+
+static unsigned int read_mdio_reg(unsigned int reg, void __iomem *address)
+{
+	unsigned int value;
+
+	value = (reg << 8) | 0x10;
+	write_mdio_reg(value, address);
+
+	value = readl(address);
+	return value;
+}
+
+static struct phy *phy_rtk_sata_xlate(struct device *dev,
+					struct of_phandle_args *args)
+{
+	struct phy_rtk_priv *priv = dev_get_drvdata(dev);
+	int i;
+
+	for (i = 0; i < priv->nphys; i++)
+		if (priv->phys[i]->index == args->args[0])
+			break;
+
+	if (i == priv->nphys)
+		return ERR_PTR(-ENODEV);
+
+	return priv->phys[i]->phy;
+}
+
+static int phy_rtk_sata_init(struct phy *phy)
+{
+	struct phy_rtk_desc *desc = phy_get_drvdata(phy);
+	struct phy_rtk_priv *priv = dev_get_drvdata(phy->dev.parent);
+	void __iomem *base = priv->base;
+	void __iomem *sb2base = priv->sb2base;
+	unsigned int *table;
+	unsigned int reg;
+	int i;
+	unsigned int size;
+
+	if (priv->chip_id == CHIP_ID_RTD1619 ||
+		priv->chip_id == CHIP_ID_RTD1319) {
+		for (i=0; i<PHY_MAX_RST; i++) {
+			if (desc->rsts[i] == NULL)
+				break;
+			reset_control_deassert(desc->rsts[i]);
+		}
+	}
+
+	reg = readl(sb2base);
+	if (desc->index == 0)
+		reg = reg | BIT(0) | BIT(2) | BIT(4) | BIT(8);
+	else
+		reg = reg | BIT(1) | BIT(3) | BIT(5);
+	writel(reg, sb2base);
+
+	writel(desc->index, base + MDIO_CTR1);
+
+	for (i = 0; i < desc->param_size; i++) {
+		dev_info(priv->dev, "phy%d para 0x%x\n", desc->index, desc->param_table[i]);
+		write_mdio_reg(desc->param_table[i], base + MDIO_CTR);
+	}
+	for (i = 0; i < desc->txdrv_size; i++) {
+		dev_info(priv->dev, "phy%d txdrv 0x%x\n", desc->index, desc->txdrv_table[i]);
+		write_mdio_reg(desc->txdrv_table[i], base + MDIO_CTR);
+	}
+
+	for (i = 0; i < desc->rxsense_size; i++) {
+		dev_info(priv->dev, "phy%d rxsense 0x%x\n", desc->index, desc->rxsense_table[i]);
+		write_mdio_reg(desc->rxsense_table[i], base + MDIO_CTR);
+	}
+
+	if (priv->chip_id != CHIP_ID_RTD1619 ||
+		priv->chip_id != CHIP_ID_RTD1319) {
+		if (desc->ssc_en) {
+			table = (unsigned int *)&SSCEN_SET_TABLE;
+			size = sizeof(SSCEN_SET_TABLE)/sizeof(unsigned int);
+		} else {
+			table = (unsigned int *)&SSCDIS_SET_TABLE;
+			size = sizeof(SSCDIS_SET_TABLE)/sizeof(unsigned int);
+		}
+		for (i = 0; i < size; i++)
+			write_mdio_reg(table[i], base + MDIO_CTR);
+
+		if ((priv->chip_id & 0xFFF0) == CHIP_ID_RTD129X &&
+			priv->chip_revision == RTD_CHIP_B00) {
+			table = (unsigned int *)&PHY_CLOCK_DELAY;
+			size = sizeof(PHY_CLOCK_DELAY)/sizeof(unsigned int);
+			for (i = 0; i < size; i++)
+				write_mdio_reg(table[i], base + MDIO_CTR);
+		}
+	}
+
+	if (desc->speed == 0)
+		writel(0xA, base + PHY_SPD);
+	else if (desc->speed == 2)
+		writel(0x5, base + PHY_SPD);
+	else if (desc->speed == 1)
+		writel(0x0, base + PHY_SPD);
+
+	if (priv->chip_id == CHIP_ID_RTD1319) {
+		reg = readl(base + PHY_CLK_EN) | (1 << (desc->index+7));
+		writel(reg, base + PHY_CLK_EN);
+	}
+	dev_info(priv->dev, "init phy%d OK\n", desc->index);
+
+	return 0;
+}
+
+static int phy_rtk_sata_power_on(struct phy *phy)
+{
+	struct phy_rtk_desc *desc = phy_get_drvdata(phy);
+	struct phy_rtk_priv *priv = dev_get_drvdata(phy->dev.parent);
+	int i;
+
+	dev_info(priv->dev, "power on phy%d\n", desc->index);
+
+	for (i=0; i<PHY_MAX_RST; i++) {
+		if (desc->rsts[i] != NULL)
+			reset_control_deassert(desc->rsts[i]);
+		else
+			break;
+	}
+	return 0;
+}
+
+static int phy_rtk_sata_power_off(struct phy *phy)
+{
+	struct phy_rtk_desc *desc = phy_get_drvdata(phy);
+	struct phy_rtk_priv *priv = dev_get_drvdata(phy->dev.parent);
+	int i;
+
+	dev_info(priv->dev, "power off phy%d\n", desc->index);
+
+	for (i=0; i<PHY_MAX_RST; i++) {
+		if (desc->rsts[i] != NULL)
+			reset_control_assert(desc->rsts[i]);
+		else
+			break;
+	}
+	return 0;
+}
+
+static int phy_rtk_sata_set_mode(struct phy *phy, enum phy_mode mode)
+{
+	struct phy_rtk_desc *desc = phy_get_drvdata(phy);
+	struct phy_rtk_priv *priv = dev_get_drvdata(phy->dev.parent);
+	void __iomem *base = priv->base;
+	unsigned int value;
+	int i;
+
+	if (priv->chip_id == CHIP_ID_RTD1619 ||
+		priv->chip_id == CHIP_ID_RTD1319) {
+		writel(desc->index, base + MDIO_CTR1);
+		for (i=0; i<3; i++) {
+			value = read_mdio_reg(0x20+0x40*i, base + MDIO_CTR);
+			if (mode)
+				value = value | (0x3 << 28);
+			else
+				value = value & ~(0x3 << 28);
+			value = value | 0x11;
+			write_mdio_reg(value, base + MDIO_CTR);
+
+			value = read_mdio_reg(0x2a+0x40*i, base + MDIO_CTR);
+			if (mode)
+				value = value & ~(0x1 << 23);
+			else
+				value = value | (0x1 << 23);
+			value = value | 0x11;
+			write_mdio_reg(value, base + MDIO_CTR);
+		}
+	} else {
+		for (i=0; i<PHY_MAX_RST; i++) {
+			if (desc->rsts[i] != NULL && mode)
+				reset_control_assert(desc->rsts[i]);
+			else if (desc->rsts[i] != NULL && !mode)
+				reset_control_deassert(desc->rsts[i]);
+			else
+				break;
+		}
+	}
+	return 0;
+}
+
+static struct phy_ops phy_rtk_sata_ops = {
+	.init = phy_rtk_sata_init,
+	.power_on = phy_rtk_sata_power_on,
+	.power_off = phy_rtk_sata_power_off,
+	.set_mode = phy_rtk_sata_set_mode,
+	.owner = THIS_MODULE,
+};
+
+static int get_phy_parameter(struct device *dev, struct device_node *node,
+				struct phy_rtk_desc *desc)
+{
+	struct phy_rtk_priv *priv = dev_get_drvdata(dev);
+	const void *prop;
+	unsigned int drv_level;
+	unsigned int size;
+	unsigned int *table;
+	unsigned int num = 0;
+
+	prop = of_get_property(node, "phy-param", NULL);
+	if (!prop) {
+		if (priv->chip_id == CHIP_ID_RTD1619 ||
+			priv->chip_id == CHIP_ID_RTD1319)
+			size = sizeof(PHY_PARA_TABLE_THOR)/sizeof(unsigned int);
+		else
+			size = sizeof(PHY_PARA_TABLE)/sizeof(unsigned int);
+	} else {
+		size = of_property_count_u32_elems(node, "phy-param");
+	}
+
+	table = devm_kzalloc(dev, sizeof(unsigned int)*size, GFP_KERNEL);
+	if (!table)
+		return -ENOMEM;
+	if (!prop) {
+		if (priv->chip_id == CHIP_ID_RTD1619 ||
+			priv->chip_id == CHIP_ID_RTD1319)
+			memcpy(table, &PHY_PARA_TABLE_THOR, sizeof(PHY_PARA_TABLE_THOR));
+		else
+			memcpy(table, &PHY_PARA_TABLE, sizeof(PHY_PARA_TABLE));
+	} else {
+		of_property_read_u32_array(node, "phy-param", table, size);
+	}
+	desc->param_size = size;
+	desc->param_table = table;
+
+	prop = of_get_property(node, "tx-driving-tbl", NULL);
+	if (!prop)
+		size = sizeof(*TX_DRV_TABLE)/sizeof(unsigned int);
+	else
+		size = of_property_count_u32_elems(node, "tx-driving-tbl");
+
+	table = devm_kzalloc(dev, sizeof(unsigned int)*size, GFP_KERNEL);
+	if (!table)
+		return -ENOMEM;
+	if (!prop) {
+		if ((priv->chip_id & 0xFFF0) == CHIP_ID_RTD129X) {
+			drv_level = DEFAULT_TXDRV_LEVEL;
+			of_property_read_u32(node, "tx-driving", &drv_level);
+			if (drv_level >= sizeof(TX_DRV_TABLE)/sizeof(*TX_DRV_TABLE))
+				drv_level = DEFAULT_TXDRV_LEVEL;
+			memcpy(table, TX_DRV_TABLE[drv_level], sizeof(*TX_DRV_TABLE));
+		} else if (priv->chip_id == CHIP_ID_RTD1619 ||
+				priv->chip_id == CHIP_ID_RTD1319) {
+			dev_info(dev, "can't find tx table\n");
+			drv_level = 0;
+			memcpy(table, TX_DRV_TABLE_THOR[drv_level], sizeof(*TX_DRV_TABLE_THOR));
+		}
+	} else {
+		of_property_read_u32_array(node, "tx-driving-tbl", table, size);
+	}
+	desc->txdrv_size = size;
+	desc->txdrv_table = table;
+
+	prop = of_get_property(node, "rx-sense-tbl", NULL);
+	if (!prop) {
+		size = sizeof(*PHY_SENSITIVITY)/sizeof(unsigned int);
+	} else {
+		size = of_property_count_u32_elems(node, "rx-sense-tbl");
+	}
+
+	table = devm_kzalloc(dev, sizeof(unsigned int)*size, GFP_KERNEL);
+	if (!table)
+		return -ENOMEM;
+	if (!prop) {
+		dev_info(dev, "can't find rx table\n");
+		if ((priv->chip_id & 0xFFF0) == CHIP_ID_RTD129X) {
+			if (priv->chip_revision == RTD_CHIP_A00 ||
+				priv->chip_revision == RTD_CHIP_A01)
+				num = 0;
+			else
+				num = 1;
+		} else if (priv->chip_id == CHIP_ID_RTD1619 ||
+				priv->chip_id == CHIP_ID_RTD1319) {
+			num = 2;
+		}
+		memcpy(table, PHY_SENSITIVITY[num], sizeof(*PHY_SENSITIVITY));
+	} else {
+		of_property_read_u32_array(node, "rx-sense-tbl", table, size);
+	}
+	desc->rxsense_size = size;
+	desc->rxsense_table = table;
+
+	if (priv->chip_id == CHIP_ID_RTD1319)
+		desc->rxsense_size = 0;
+
+	of_property_read_u32(node, "spread-spectrum", &desc->ssc_en);
+	of_property_read_u32(node, "speed-limit", &desc->speed);
+
+	return 0;
+}
+
+static void phy_rtk_sata_enable(struct phy_rtk_priv *priv)
+{
+	int i;
+
+	for (i=0; i<PHY_MAX_CLK; i++) {
+		if (priv->clks[i] == NULL)
+			break;
+		clk_prepare_enable(priv->clks[i]);
+	}
+	for (i=0; i<PHY_MAX_RST; i++) {
+		if (priv->rsts[i] == NULL)
+			break;
+		reset_control_deassert(priv->rsts[i]);
+	}
+}
+
+static void phy_rtk_sata_disable(struct phy_rtk_priv *priv)
+{
+#ifdef DISABLE_CLKRST
+	int i;
+
+	for (i=0; i<PHY_MAX_RST; i++) {
+		if (priv->rsts[i] == NULL)
+			break;
+		reset_control_assert(priv->rsts[i]);
+	}
+	for (i=0; i<PHY_MAX_CLK; i++) {
+		if (priv->clks[i] == NULL)
+			break;
+		clk_disable_unprepare(priv->clks[i]);
+	}
+#endif
+	return;
+}
+
+static int phy_rtk_sata_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *child;
+	struct phy *phy;
+	struct phy_rtk_priv *priv;
+	struct phy_provider *phy_provider;
+	struct clk *clk;
+	struct reset_control *rst;
+
+	unsigned int phy_id;
+	unsigned int i = 0, cnt = 0;
+	int ret;
+
+	priv = devm_kzalloc(dev, sizeof(*priv), GFP_KERNEL);
+	if (!priv)
+		goto memalloc_fail;
+
+	priv->chip_id = get_rtd_chip_id();
+	priv->chip_revision = get_rtd_chip_revision();
+
+	priv->base = of_iomap(dev->of_node, 0);
+	if (!priv->base)
+		goto dtb_fail;
+	priv->sb2base = of_iomap(dev->of_node, 1);
+	if (!priv->base)
+		goto dtb_fail;
+
+	for (i=0; i<PHY_MAX_CLK; i++) {
+		clk = of_clk_get(dev->of_node, i);
+		if (IS_ERR(clk))
+			break;
+		priv->clks[i] = clk;
+	}
+	for (i=0; i<PHY_MAX_RST; i++) {
+		rst = of_reset_control_get_by_index(dev->of_node, i);
+		if (IS_ERR(rst))
+			break;
+		priv->rsts[i] = rst;
+	}
+	phy_rtk_sata_enable(priv);
+
+	priv->nphys = of_get_child_count(dev->of_node);
+	if (priv->nphys == 0 || priv->nphys > RTK_SATA_PHY_NUMBER)
+		return -ENODEV;
+
+	priv->dev = dev;
+	priv->phys =
+		devm_kcalloc(dev, priv->nphys, sizeof(*priv->phys), GFP_KERNEL);
+	if (!priv->phys)
+		goto memalloc_fail;
+
+	dev_set_drvdata(dev, priv);
+
+	for_each_available_child_of_node(dev->of_node, child) {
+		struct phy_rtk_desc *phy_desc;
+
+		phy_desc = devm_kzalloc(dev, sizeof(*phy_desc), GFP_KERNEL);
+		if (!phy_desc)
+			goto memalloc_fail;
+
+		if (of_property_read_u32(child, "reg", &phy_id))
+			goto dtb_fail;
+
+		if (phy_id >= RTK_SATA_PHY_NUMBER)
+			goto dtb_fail;
+
+		for (i=0; i<PHY_MAX_RST; i++) {
+			rst = of_reset_control_get_by_index(child, i);
+			if (IS_ERR(rst))
+				break;
+			phy_desc->rsts[i] = rst;
+		}
+
+		ret = get_phy_parameter(dev, child, phy_desc);
+		if (ret < 0)
+			goto memalloc_fail;
+
+		phy = devm_phy_create(dev, NULL, &phy_rtk_sata_ops);
+		if (IS_ERR(phy)) {
+			dev_err(dev, "failed to create phy %d\n", phy_id);
+			return PTR_ERR(phy);
+		}
+
+		phy_desc->phy = phy;
+		phy_desc->index = phy_id;
+		phy_set_drvdata(phy, phy_desc);
+		priv->phys[cnt++] = phy_desc;
+	}
+
+	phy_provider = devm_of_phy_provider_register(dev, phy_rtk_sata_xlate);
+
+	return PTR_ERR_OR_ZERO(phy_provider);
+
+dtb_fail:
+	dev_err(dev, "[SATA_PHY] get resource from dtb fail\n");
+	return -EINVAL;
+
+memalloc_fail:
+	dev_err(dev, "[SATA_PHY] can't allocate memory\n");
+	return -ENOMEM;
+}
+
+#ifdef CONFIG_PM
+static int phy_rtk_sata_suspend(struct device *dev)
+{
+	struct phy_rtk_priv *priv = dev_get_drvdata(dev);
+
+	dev_info(dev, "enter %s\n", __func__);
+	phy_rtk_sata_disable(priv);
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static void phy_rtk_sata_shutdown(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct phy_rtk_priv *priv = dev_get_drvdata(dev);
+
+	dev_info(dev, "enter %s\n", __func__);
+	phy_rtk_sata_disable(priv);
+	dev_info(dev, "exit %s\n", __func__);
+	return;
+}
+
+static int phy_rtk_sata_resume(struct device *dev)
+{
+	struct phy_rtk_priv *priv = dev_get_drvdata(dev);
+
+	dev_info(dev, "enter %s\n", __func__);
+	phy_rtk_sata_enable(priv);
+	dev_info(dev, "exit %s\n", __func__);
+
+	return 0;
+
+}
+
+static const struct dev_pm_ops phy_rtk_sata_pm_ops = {
+	.suspend = phy_rtk_sata_suspend,
+	.resume = phy_rtk_sata_resume,
+};
+#else
+static const struct dev_pm_ops phy_rtk_sata_pm_ops = {};
+#endif
+
+static const struct of_device_id phy_rtk_sata_of_match[] = {
+	{ .compatible = "Realtek,rtk-sata-phy" },
+	{ },
+};
+
+static struct platform_driver phy_rtk_sata_driver = {
+	.probe	= phy_rtk_sata_probe,
+#ifdef CONFIG_PM
+	.shutdown = phy_rtk_sata_shutdown,
+#endif
+	.driver	= {
+		.name		= "phy-rtk-sata",
+		.of_match_table	= phy_rtk_sata_of_match,
+#ifdef CONFIG_PM
+		.pm = &phy_rtk_sata_pm_ops,
+#endif
+	},
+};
+module_platform_driver(phy_rtk_sata_driver);
+
+MODULE_DESCRIPTION("Realtek SATA PHY driver");
+MODULE_AUTHOR("Simon HSU <simon_hsu@realtek.com>");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/pinctrl/Kconfig b/drivers/pinctrl/Kconfig
index b0c0fa0..c87cb3d 100644
--- a/drivers/pinctrl/Kconfig
+++ b/drivers/pinctrl/Kconfig
@@ -274,6 +274,7 @@ source "drivers/pinctrl/tegra/Kconfig"
 source "drivers/pinctrl/uniphier/Kconfig"
 source "drivers/pinctrl/vt8500/Kconfig"
 source "drivers/pinctrl/mediatek/Kconfig"
+source "drivers/pinctrl/realtek/Kconfig"
 
 config PINCTRL_XWAY
 	bool
diff --git a/drivers/pinctrl/Makefile b/drivers/pinctrl/Makefile
index 11bad37..6e64533 100644
--- a/drivers/pinctrl/Makefile
+++ b/drivers/pinctrl/Makefile
@@ -54,3 +54,8 @@ obj-$(CONFIG_PINCTRL_SUNXI)	+= sunxi/
 obj-$(CONFIG_PINCTRL_UNIPHIER)	+= uniphier/
 obj-$(CONFIG_ARCH_VT8500)	+= vt8500/
 obj-$(CONFIG_PINCTRL_MTK)	+= mediatek/
+obj-$(CONFIG_ARCH_RTD119X)      += realtek/
+obj-$(CONFIG_ARCH_RTD129x)	+= realtek/
+obj-$(CONFIG_ARCH_RTD139x)	+= realtek/
+obj-$(CONFIG_ARCH_RTD16xx)	+= realtek/
+obj-$(CONFIG_ARCH_RTD13xx)      += realtek/
diff --git a/drivers/pinctrl/realtek/Kconfig b/drivers/pinctrl/realtek/Kconfig
new file mode 100644
index 00000000..41b7d07
--- /dev/null
+++ b/drivers/pinctrl/realtek/Kconfig
@@ -0,0 +1,34 @@
+config PINCTRL_RTD119X
+        bool "RTD119X pin controller driver"
+        depends on ARCH_RTD119X
+        default y
+        select PINMUX
+        select GENERIC_PINCONF
+
+config PINCTRL_RTD129x
+	bool "RTD129x pin controller driver"
+	depends on ARCH_RTD129x
+	default y
+	select PINMUX
+	select GENERIC_PINCONF
+
+config PINCTRL_RTD139x
+	bool "RTD139x pin controller driver"
+	depends on ARCH_RTD139x
+	default y
+	select PINMUX
+	select GENERIC_PINCONF
+
+config PINCTRL_RTD16xx
+	bool "RTD16xx pin controller driver"
+	depends on ARCH_RTD16xx
+	default y
+	select PINMUX
+	select GENERIC_PINCONF
+
+config PINCTRL_RTD13xx
+	bool "RTD13xx pin controller driver"
+	depends on ARCH_RTD13xx
+	default y
+	select PINMUX
+	select GENERIC_PINCONF
diff --git a/drivers/pinctrl/realtek/Makefile b/drivers/pinctrl/realtek/Makefile
new file mode 100644
index 00000000..5953f65
--- /dev/null
+++ b/drivers/pinctrl/realtek/Makefile
@@ -0,0 +1,5 @@
+obj-$(CONFIG_PINCTRL_RTD119X)	+= pinctrl-rtd119x.o
+obj-$(CONFIG_PINCTRL_RTD129x)	+= pinctrl-rtd129x.o
+obj-$(CONFIG_PINCTRL_RTD139x)	+= pinctrl-rtd139x.o
+obj-$(CONFIG_PINCTRL_RTD16xx)	+= pinctrl-rtd16xx.o
+obj-$(CONFIG_PINCTRL_RTD13xx)	+= pinctrl-rtd13xx.o
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd1192.h b/drivers/pinctrl/realtek/pinctrl-rtd1192.h
new file mode 100644
index 00000000..4cb251a
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd1192.h
@@ -0,0 +1,1073 @@
+/*
+ * Allwinner A1X SoCs pinctrl driver.
+ *
+ * Copyright (C) 2012 Maxime Ripard
+ *
+ * Maxime Ripard <maxime.ripard@free-electrons.com>
+ *
+ * This file is licensed under the terms of the GNU General Public
+ * License version 2.  This program is licensed "as is" without any
+ * warranty of any kind, whether express or implied.
+ */
+
+#ifndef __PINCTRL_RTK119X_H
+#define __PINCTRL_RTK119X_H
+
+#include <linux/kernel.h>
+
+#define P_SB2_BASE	0
+#define P_ISO_BASE	115
+
+
+//#define RTK_DEBUG
+#ifdef RTK_DEBUG
+#define RTK_debug(fmt, ...) printk(fmt, ##__VA_ARGS__)
+#else
+#define RTK_debug(fmt, ...) do {} while(0)
+#endif
+
+/**********************************************************************************
+* sb2_muxpad0
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_SB2_nf_dqs					PINCTRL_PIN(P_SB2_BASE + 110,  	"nf_dqs")
+#define RTK_PINCTRL_PIN_SB2_nf_rdy					PINCTRL_PIN(P_SB2_BASE + 17,  	"nf_rdy")
+#define RTK_PINCTRL_PIN_SB2_nf_rd_n					PINCTRL_PIN(P_SB2_BASE + 18, 	"nf_rd_n")
+#define RTK_PINCTRL_PIN_SB2_nf_wr_n					PINCTRL_PIN(P_SB2_BASE + 19,  	"nf_wr_n")
+#define RTK_PINCTRL_PIN_SB2_nf_ale					PINCTRL_PIN(P_SB2_BASE + 20,  	"nf_ale")
+#define RTK_PINCTRL_PIN_SB2_nf_cle					PINCTRL_PIN(P_SB2_BASE + 21,  	"nf_cle")
+#define RTK_PINCTRL_PIN_SB2_nf_ce_n_0 				PINCTRL_PIN(P_SB2_BASE + 22,  	"nf_ce_n_0")
+#define RTK_PINCTRL_PIN_SB2_nf_ce_n_1 				PINCTRL_PIN(P_SB2_BASE + 23,  	"nf_ce_n_1")
+#define RTK_PINCTRL_PIN_SB2_nf_dd_0					PINCTRL_PIN(P_SB2_BASE + 9,  	"nf_dd_0")
+#define RTK_PINCTRL_PIN_SB2_nf_dd_1					PINCTRL_PIN(P_SB2_BASE + 10,  	"nf_dd_1")
+#define RTK_PINCTRL_PIN_SB2_nf_dd_2					PINCTRL_PIN(P_SB2_BASE + 11,  	"nf_dd_2")
+#define RTK_PINCTRL_PIN_SB2_nf_dd_3					PINCTRL_PIN(P_SB2_BASE + 12,  	"nf_dd_3")
+#define RTK_PINCTRL_PIN_SB2_nf_dd_4 				PINCTRL_PIN(P_SB2_BASE + 13,  	"nf_dd_4")
+#define RTK_PINCTRL_PIN_SB2_nf_dd_5					PINCTRL_PIN(P_SB2_BASE + 14,  	"nf_dd_5")
+#define RTK_PINCTRL_PIN_SB2_nf_dd_6					PINCTRL_PIN(P_SB2_BASE + 15,  	"nf_dd_6")
+#define RTK_PINCTRL_PIN_SB2_nf_dd_7					PINCTRL_PIN(P_SB2_BASE + 16,  	"nf_dd_7")
+
+
+/**********************************************************************************
+* sb2_muxpad1
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_SB2_sdio_cmd				PINCTRL_PIN(P_SB2_BASE + 37,  	"sdio_cmd")
+#define RTK_PINCTRL_PIN_SB2_sdio_clk				PINCTRL_PIN(P_SB2_BASE + 32,  	"sdio_clk")
+#define RTK_PINCTRL_PIN_SB2_sdio_data_0				PINCTRL_PIN(P_SB2_BASE + 33,  	"sdio_data_0")
+#define RTK_PINCTRL_PIN_SB2_sdio_data_1 			PINCTRL_PIN(P_SB2_BASE + 34,  	"sdio_data_1")
+#define RTK_PINCTRL_PIN_SB2_sdio_data_2 			PINCTRL_PIN(P_SB2_BASE + 35,  	"sdio_data_2")
+#define RTK_PINCTRL_PIN_SB2_sdio_data_3 			PINCTRL_PIN(P_SB2_BASE + 36,  	"sdio_data_3")
+//Rvd:12~15
+#define RTK_PINCTRL_PIN_SB2_mmc_cmd 				PINCTRL_PIN(P_SB2_BASE + 29,  	"mmc_cmd")
+#define RTK_PINCTRL_PIN_SB2_mmc_clk 				PINCTRL_PIN(P_SB2_BASE + 28,  	"mmc_clk")
+#define RTK_PINCTRL_PIN_SB2_mmc_wp 					PINCTRL_PIN(P_SB2_BASE + 30,  	"mmc_wp")
+#define RTK_PINCTRL_PIN_SB2_mmc_cd 					PINCTRL_PIN(P_SB2_BASE + 31,  	"mmc_cd")
+#define RTK_PINCTRL_PIN_SB2_mmc_data_0 				PINCTRL_PIN(P_SB2_BASE + 24,  	"mmc_data_0")
+#define RTK_PINCTRL_PIN_SB2_mmc_data_1 				PINCTRL_PIN(P_SB2_BASE + 25,  	"mmc_data_1")
+#define RTK_PINCTRL_PIN_SB2_mmc_data_2 				PINCTRL_PIN(P_SB2_BASE + 26,  	"mmc_data_2")
+#define RTK_PINCTRL_PIN_SB2_mmc_data_3 				PINCTRL_PIN(P_SB2_BASE + 27,  	"mmc_data_3")
+
+
+/**********************************************************************************
+* sb2_muxpad2
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_SB2_tp0_data 				PINCTRL_PIN(P_SB2_BASE + 44,  	"tp0_data")
+#define RTK_PINCTRL_PIN_SB2_tp0_sync 				PINCTRL_PIN(P_SB2_BASE + 47,  	"tp0_sync")
+#define RTK_PINCTRL_PIN_SB2_tp0_valid 				PINCTRL_PIN(P_SB2_BASE + 46,  	"tp0_valid")
+#define RTK_PINCTRL_PIN_SB2_tp0_clk 				PINCTRL_PIN(P_SB2_BASE + 45,  	"tp0_clk")
+//Rvd:12~15
+#define RTK_PINCTRL_PIN_SB2_tp1_data 				PINCTRL_PIN(P_SB2_BASE + 40,  	"tp1_data")
+#define RTK_PINCTRL_PIN_SB2_tp1_sync 				PINCTRL_PIN(P_SB2_BASE + 43,  	"tp1_sync")
+#define RTK_PINCTRL_PIN_SB2_tp1_valid 				PINCTRL_PIN(P_SB2_BASE + 42,  	"tp1_valid")
+#define RTK_PINCTRL_PIN_SB2_tp1_clk 				PINCTRL_PIN(P_SB2_BASE + 41,  	"tp1_clk")
+//Rvd:24~31
+
+
+/**********************************************************************************
+* sb2_muxpad3
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_SB2_i2c_sda_1				PINCTRL_PIN(P_SB2_BASE + 52,  	"i2c_sda_1")
+#define RTK_PINCTRL_PIN_SB2_i2c_scl_1 				PINCTRL_PIN(P_SB2_BASE + 51,  	"i2c_scl_1")
+#define RTK_PINCTRL_PIN_SB2_i2c_sda_4				PINCTRL_PIN(P_SB2_BASE + 54,  	"i2c_sda_4")
+#define RTK_PINCTRL_PIN_SB2_i2c_scl_4 				PINCTRL_PIN(P_SB2_BASE + 53,  	"i2c_scl_4")
+#define RTK_PINCTRL_PIN_SB2_i2c_sda_5				PINCTRL_PIN(P_SB2_BASE + 39,  	"i2c_sda_5")
+#define RTK_PINCTRL_PIN_SB2_i2c_scl_5 				PINCTRL_PIN(P_SB2_BASE + 38,  	"i2c_scl_5")
+#define RTK_PINCTRL_PIN_SB2_spdif 					PINCTRL_PIN(P_SB2_BASE + 50,  	"spdif")
+#define RTK_PINCTRL_PIN_SB2_hdmi_hpd				PINCTRL_PIN(P_SB2_BASE + 49,  	"hdmi_hpd")
+#define RTK_PINCTRL_PIN_SB2_usb_id					PINCTRL_PIN(P_SB2_BASE + 48,  	"usb_id")
+#define RTK_PINCTRL_PIN_SB2_hi_loc					PINCTRL_PIN(P_SB2_BASE + 103,  	"hi_loc")
+#define RTK_PINCTRL_PIN_SB2_ejtag_scpu_loc			PINCTRL_PIN(P_SB2_BASE + 104,  	"ejtag_scpu_loc")
+#define RTK_PINCTRL_PIN_SB2_sensor_stb_1			PINCTRL_PIN(P_SB2_BASE + 59,  	"sensor_stb_1")
+#define RTK_PINCTRL_PIN_SB2_sensor_stb_0 			PINCTRL_PIN(P_SB2_BASE + 58,  	"sensor_stb_0")
+#define RTK_PINCTRL_PIN_SB2_sensor_rst				PINCTRL_PIN(P_SB2_BASE + 57,  	"sensor_rst")
+#define RTK_PINCTRL_PIN_SB2_sensor_cko_1			PINCTRL_PIN(P_SB2_BASE + 56,  	"sensor_cko_1")
+#define RTK_PINCTRL_PIN_SB2_sensor_cko_0			PINCTRL_PIN(P_SB2_BASE + 55,  	"sensor_cko_0")
+
+
+/**********************************************************************************
+* sb2_muxpad4
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_SB2_gpio_0					PINCTRL_PIN(P_SB2_BASE + 0,  	"gpio_0")
+#define RTK_PINCTRL_PIN_SB2_gpio_1					PINCTRL_PIN(P_SB2_BASE + 1,  	"gpio_1")
+#define RTK_PINCTRL_PIN_SB2_gpio_2					PINCTRL_PIN(P_SB2_BASE + 2,  	"gpio_2")
+#define RTK_PINCTRL_PIN_SB2_gpio_3					PINCTRL_PIN(P_SB2_BASE + 3,  	"gpio_3")
+#define RTK_PINCTRL_PIN_SB2_gpio_4					PINCTRL_PIN(P_SB2_BASE + 4,  	"gpio_4")
+#define RTK_PINCTRL_PIN_SB2_gpio_5					PINCTRL_PIN(P_SB2_BASE + 5,  	"gpio_5")
+#define RTK_PINCTRL_PIN_SB2_gpio_6					PINCTRL_PIN(P_SB2_BASE + 6,  	"gpio_6")
+#define RTK_PINCTRL_PIN_SB2_gpio_7					PINCTRL_PIN(P_SB2_BASE + 7,  	"gpio_7")
+#define RTK_PINCTRL_PIN_SB2_gpio_8					PINCTRL_PIN(P_SB2_BASE + 8,  	"gpio_8")
+//Rvd:22~31
+
+
+/**********************************************************************************
+* sb2_muxpad5
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_SB2_sf_en					PINCTRL_PIN(P_SB2_BASE + 105,  	"sf_en")
+#define RTK_PINCTRL_PIN_SB2_arm_trace_dbg_en		PINCTRL_PIN(P_SB2_BASE + 106,  	"arm_trace_dbg_en")
+#define RTK_PINCTRL_PIN_SB2_ao_loc					PINCTRL_PIN(P_SB2_BASE + 107,  	"ao_loc")
+#define RTK_PINCTRL_PIN_SB2_sdio_loc				PINCTRL_PIN(P_SB2_BASE + 108,  	"sdio_loc")
+#define RTK_PINCTRL_PIN_SB2_ur1_loc					PINCTRL_PIN(P_SB2_BASE + 109,  	"ur1_loc")
+//Rvd:8~31
+
+
+/**********************************************************************************
+* sb2_muxpad6
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_SB2_sdio_data_4				PINCTRL_PIN(P_SB2_BASE + 111,  	"sdio_data_4")
+#define RTK_PINCTRL_PIN_SB2_sdio_data_5				PINCTRL_PIN(P_SB2_BASE + 112,  	"sdio_data_5")
+#define RTK_PINCTRL_PIN_SB2_sdio_data_6				PINCTRL_PIN(P_SB2_BASE + 113,  	"sdio_data_6")
+#define RTK_PINCTRL_PIN_SB2_sdio_data_7				PINCTRL_PIN(P_SB2_BASE + 114,  	"sdio_data_7")
+//Rvd:8~31
+
+
+
+/**********************************************************************************
+* iso_muxpad0
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_PISO_vfd_d					PINCTRL_PIN(P_ISO_BASE + 6, 	"vfd_d")
+#define RTK_PINCTRL_PIN_PISO_vfd_clk 				PINCTRL_PIN(P_ISO_BASE + 5,  	"vfd_clk")
+#define RTK_PINCTRL_PIN_PISO_vfd_cs_n 				PINCTRL_PIN(P_ISO_BASE + 4, 	"vfd_cs_n")
+#define RTK_PINCTRL_PIN_PISO_ir_rx 					PINCTRL_PIN(P_ISO_BASE + 7,  	"ir_rx")
+#define RTK_PINCTRL_PIN_PISO_ir_tx					PINCTRL_PIN(P_ISO_BASE + 8, 	"ir_tx")
+//Rvd:10~11
+#define RTK_PINCTRL_PIN_PISO_ur1_rx 				PINCTRL_PIN(P_ISO_BASE + 11,  	"ur1_rx")
+#define RTK_PINCTRL_PIN_PISO_ur1_tx 				PINCTRL_PIN(P_ISO_BASE + 12,  	"ur1_tx")
+#define RTK_PINCTRL_PIN_PISO_ur1_rts_n				PINCTRL_PIN(P_ISO_BASE + 14,  	"ur1_rts_n")
+#define RTK_PINCTRL_PIN_PISO_ur1_cts_n				PINCTRL_PIN(P_ISO_BASE + 13,  	"ur1_cts_n")
+#define RTK_PINCTRL_PIN_PISO_ur0_rx 				PINCTRL_PIN(P_ISO_BASE + 9,  	"ur0_rx")
+#define RTK_PINCTRL_PIN_PISO_ur0_tx 				PINCTRL_PIN(P_ISO_BASE + 10,  	"ur0_tx")
+#define RTK_PINCTRL_PIN_PISO_i2c_scl_0 				PINCTRL_PIN(P_ISO_BASE + 15,  	"i2c_scl_0")
+#define RTK_PINCTRL_PIN_PISO_i2c_sda_0				PINCTRL_PIN(P_ISO_BASE + 16,  	"i2c_sda_0")
+#define RTK_PINCTRL_PIN_PISO_etn_led_link 			PINCTRL_PIN(P_ISO_BASE + 17,  	"etn_led_link")
+#define RTK_PINCTRL_PIN_PISO_etn_led_rxtx 			PINCTRL_PIN(P_ISO_BASE + 18,  	"etn_led_rxtx")
+
+
+/**********************************************************************************
+* iso_muxpad1
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_PISO_i2c_scl_6				PINCTRL_PIN(P_ISO_BASE + 19,  	"i2c_scl_6")
+#define RTK_PINCTRL_PIN_PISO_i2c_sda_6 				PINCTRL_PIN(P_ISO_BASE + 20,  	"i2c_sda_6")
+//Rvd:4~5
+#define RTK_PINCTRL_PIN_PISO_iso_gpio_2				PINCTRL_PIN(P_ISO_BASE + 2,		"iso_gpio_2")
+#define RTK_PINCTRL_PIN_PISO_iso_gpio_3				PINCTRL_PIN(P_ISO_BASE + 3,		"iso_gpio_3")
+//Rvd:12~23
+#define RTK_PINCTRL_PIN_PISO_pwm_23_open_drain_switch	PINCTRL_PIN(P_ISO_BASE + 40,"pwm_23_open_drain_switch")
+#define RTK_PINCTRL_PIN_PISO_pwm_01_open_drain_switch	PINCTRL_PIN(P_ISO_BASE + 41,"pwm_01_open_drain_switch")
+//Rvd:26~27
+#define RTK_PINCTRL_PIN_PISO_ejtag_avcpu_loc		PINCTRL_PIN(P_ISO_BASE + 42,	"ejtag_avcpu_loc")
+#define RTK_PINCTRL_PIN_PISO_ai_loc					PINCTRL_PIN(P_ISO_BASE + 43,	"ai_loc")
+
+
+/**********************************************************************************
+* iso_muxpad2
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_PISO_rgmii_txc				PINCTRL_PIN(P_ISO_BASE + 39,	"rgmii_txc")
+#define RTK_PINCTRL_PIN_PISO_rgmii_tx_ctl			PINCTRL_PIN(P_ISO_BASE + 26,	"rgmii_tx_ctl")
+#define RTK_PINCTRL_PIN_PISO_rgmii_txd_0			PINCTRL_PIN(P_ISO_BASE + 27,	"rgmii_txd_0")
+#define RTK_PINCTRL_PIN_PISO_rgmii_txd_1			PINCTRL_PIN(P_ISO_BASE + 28,	"rgmii_txd_1")
+#define RTK_PINCTRL_PIN_PISO_rgmii_txd_2			PINCTRL_PIN(P_ISO_BASE + 29,	"rgmii_txd_2")
+#define RTK_PINCTRL_PIN_PISO_rgmii_txd_3			PINCTRL_PIN(P_ISO_BASE + 30,	"rgmii_txd_3")
+#define RTK_PINCTRL_PIN_PISO_rgmii_rxc				PINCTRL_PIN(P_ISO_BASE + 31,	"rgmii_rxc")
+#define RTK_PINCTRL_PIN_PISO_rgmii_rx_ctl			PINCTRL_PIN(P_ISO_BASE + 32,	"rgmii_rx_ctl")
+#define RTK_PINCTRL_PIN_PISO_rgmii_rxd_0			PINCTRL_PIN(P_ISO_BASE + 33,	"rgmii_rxd_0")
+#define RTK_PINCTRL_PIN_PISO_rgmii_rxd_1			PINCTRL_PIN(P_ISO_BASE + 34,	"rgmii_rxd_1")
+#define RTK_PINCTRL_PIN_PISO_rgmii_rxd_2			PINCTRL_PIN(P_ISO_BASE + 35,	"rgmii_rxd_2")
+#define RTK_PINCTRL_PIN_PISO_rgmii_rxd_3			PINCTRL_PIN(P_ISO_BASE + 36,	"rgmii_rxd_3")
+#define RTK_PINCTRL_PIN_PISO_rgmii_mdio				PINCTRL_PIN(P_ISO_BASE + 37,	"rgmii_mdio")
+#define RTK_PINCTRL_PIN_PISO_rgmii_mdc				PINCTRL_PIN(P_ISO_BASE + 38,	"rgmii_mdc")
+//Rvd:28~31
+
+
+/**********************************************************************************
+* iso_muxpad3
+**********************************************************************************/
+#define RTK_PINCTRL_PIN_PISO_iso_gpio_21 				PINCTRL_PIN(P_ISO_BASE + 21,	"iso_gpio_21")
+#define RTK_PINCTRL_PIN_PISO_iso_gpio_22 				PINCTRL_PIN(P_ISO_BASE + 22,	"iso_gpio_22")
+#define RTK_PINCTRL_PIN_PISO_iso_gpio_23 				PINCTRL_PIN(P_ISO_BASE + 23,	"iso_gpio_23")
+#define RTK_PINCTRL_PIN_PISO_iso_gpio_24 				PINCTRL_PIN(P_ISO_BASE + 24,	"iso_gpio_24")
+#define RTK_PINCTRL_PIN_PISO_iso_gpio_25 				PINCTRL_PIN(P_ISO_BASE + 25,	"iso_gpio_25")
+//Rvd:10~31
+
+
+#define RTK_PINCTRL_PIN_SB2_gpio_60					PINCTRL_PIN(P_SB2_BASE + 60, 	"gpio_60")
+#define RTK_PINCTRL_PIN_SB2_gpio_61 				PINCTRL_PIN(P_SB2_BASE + 61,	"gpio_61")
+#define RTK_PINCTRL_PIN_SB2_gpio_62 				PINCTRL_PIN(P_SB2_BASE + 62,	"gpio_62")
+#define RTK_PINCTRL_PIN_SB2_gpio_63 				PINCTRL_PIN(P_SB2_BASE + 63,	"gpio_63")
+#define RTK_PINCTRL_PIN_SB2_gpio_64 				PINCTRL_PIN(P_SB2_BASE + 64,	"gpio_64")
+#define RTK_PINCTRL_PIN_SB2_gpio_65 				PINCTRL_PIN(P_SB2_BASE + 65,	"gpio_65")
+#define RTK_PINCTRL_PIN_SB2_gpio_66 				PINCTRL_PIN(P_SB2_BASE + 66,	"gpio_66")
+#define RTK_PINCTRL_PIN_SB2_gpio_67 				PINCTRL_PIN(P_SB2_BASE + 67,	"gpio_67")
+#define RTK_PINCTRL_PIN_SB2_gpio_68 				PINCTRL_PIN(P_SB2_BASE + 68,	"gpio_68")
+#define RTK_PINCTRL_PIN_SB2_gpio_69 				PINCTRL_PIN(P_SB2_BASE + 69,	"gpio_69")
+#define RTK_PINCTRL_PIN_SB2_gpio_70 				PINCTRL_PIN(P_SB2_BASE + 70,	"gpio_70")
+#define RTK_PINCTRL_PIN_SB2_gpio_71 				PINCTRL_PIN(P_SB2_BASE + 71,	"gpio_71")
+#define RTK_PINCTRL_PIN_SB2_gpio_72 				PINCTRL_PIN(P_SB2_BASE + 72,	"gpio_72")
+#define RTK_PINCTRL_PIN_SB2_gpio_73 				PINCTRL_PIN(P_SB2_BASE + 73,	"gpio_73")
+#define RTK_PINCTRL_PIN_SB2_gpio_74 				PINCTRL_PIN(P_SB2_BASE + 74,	"gpio_74")
+#define RTK_PINCTRL_PIN_SB2_gpio_75 				PINCTRL_PIN(P_SB2_BASE + 75,	"gpio_75")
+#define RTK_PINCTRL_PIN_SB2_gpio_76 				PINCTRL_PIN(P_SB2_BASE + 76,	"gpio_76")
+#define RTK_PINCTRL_PIN_SB2_gpio_77 				PINCTRL_PIN(P_SB2_BASE + 77,	"gpio_77")
+#define RTK_PINCTRL_PIN_SB2_gpio_78 				PINCTRL_PIN(P_SB2_BASE + 78,	"gpio_78")
+#define RTK_PINCTRL_PIN_SB2_gpio_79 				PINCTRL_PIN(P_SB2_BASE + 79,	"gpio_79")
+#define RTK_PINCTRL_PIN_SB2_gpio_80 				PINCTRL_PIN(P_SB2_BASE + 80,	"gpio_80")
+#define RTK_PINCTRL_PIN_SB2_gpio_81 				PINCTRL_PIN(P_SB2_BASE + 81,	"gpio_81")
+#define RTK_PINCTRL_PIN_SB2_gpio_82 				PINCTRL_PIN(P_SB2_BASE + 82,	"gpio_82")
+#define RTK_PINCTRL_PIN_SB2_gpio_83 				PINCTRL_PIN(P_SB2_BASE + 83,	"gpio_83")
+#define RTK_PINCTRL_PIN_SB2_gpio_84 				PINCTRL_PIN(P_SB2_BASE + 84,	"gpio_84")
+#define RTK_PINCTRL_PIN_SB2_gpio_85 				PINCTRL_PIN(P_SB2_BASE + 85,	"gpio_85")
+#define RTK_PINCTRL_PIN_SB2_gpio_86 				PINCTRL_PIN(P_SB2_BASE + 86,	"gpio_86")
+#define RTK_PINCTRL_PIN_SB2_gpio_87 				PINCTRL_PIN(P_SB2_BASE + 87,	"gpio_87")
+#define RTK_PINCTRL_PIN_SB2_gpio_88 				PINCTRL_PIN(P_SB2_BASE + 88,	"gpio_88")
+#define RTK_PINCTRL_PIN_SB2_gpio_89 				PINCTRL_PIN(P_SB2_BASE + 89,	"gpio_89")
+#define RTK_PINCTRL_PIN_SB2_gpio_90 				PINCTRL_PIN(P_SB2_BASE + 90,	"gpio_90")
+#define RTK_PINCTRL_PIN_SB2_gpio_91 				PINCTRL_PIN(P_SB2_BASE + 91,	"gpio_91")
+#define RTK_PINCTRL_PIN_SB2_gpio_92 				PINCTRL_PIN(P_SB2_BASE + 92,	"gpio_92")
+#define RTK_PINCTRL_PIN_SB2_gpio_93 				PINCTRL_PIN(P_SB2_BASE + 93,	"gpio_93")
+#define RTK_PINCTRL_PIN_SB2_gpio_94 				PINCTRL_PIN(P_SB2_BASE + 94,	"gpio_94")
+#define RTK_PINCTRL_PIN_SB2_gpio_95 				PINCTRL_PIN(P_SB2_BASE + 95,	"gpio_95")
+#define RTK_PINCTRL_PIN_SB2_gpio_96 				PINCTRL_PIN(P_SB2_BASE + 96,	"gpio_96")
+#define RTK_PINCTRL_PIN_SB2_gpio_97 				PINCTRL_PIN(P_SB2_BASE + 97,	"gpio_97")
+#define RTK_PINCTRL_PIN_SB2_gpio_98 				PINCTRL_PIN(P_SB2_BASE + 98,	"gpio_98")
+#define RTK_PINCTRL_PIN_SB2_gpio_99 				PINCTRL_PIN(P_SB2_BASE + 99,	"gpio_99")
+#define RTK_PINCTRL_PIN_SB2_gpio_100 				PINCTRL_PIN(P_SB2_BASE + 100,	"gpio_100")
+#define RTK_PINCTRL_PIN_SB2_gpio_101 				PINCTRL_PIN(P_SB2_BASE + 101,	"gpio_101")
+#define RTK_PINCTRL_PIN_SB2_gpio_102				PINCTRL_PIN(P_SB2_BASE + 102,	"gpio_102")
+
+#define RTK_PINCTRL_PIN_PISO_iso_gpio_0					PINCTRL_PIN(P_ISO_BASE + 0, 	"iso_gpio0")
+#define RTK_PINCTRL_PIN_PISO_iso_gpio_1					PINCTRL_PIN(P_ISO_BASE + 1, 	"iso_gpio1")
+
+
+struct rtk119x_pin_regmap{
+	u16 pmux_regoff;
+	u16 pmux_regbit;
+	u16 pmux_regbitmsk;
+	u16 pcof_regoff;
+	u16 pcof_regbit;
+	u16 pcof_cur_strgh;//0 : 2&4mA   1:4&8mA
+};
+
+#define PADDRI_4_8 1
+#define PADDRI_2_4 0
+#define PADDRI_UNSUPPORT 0xFFFF
+
+#define PCOF_UNSUPPORT 0xFFFF
+#define PMUX_UNSUPPORT 0xFFFF //GPIO[60]~GPIO[102]
+
+static const struct rtk119x_pin_regmap pin_regmap[] = {
+	////////////////////////////sb2_muxpad////////////////////////////
+	{.pmux_regoff=0x910,	.pmux_regbit= 0, .pmux_regbitmsk=0x7,	.pcof_regoff=0x938, .pcof_regbit= 0, .pcof_cur_strgh = PADDRI_4_8}, //(P_SB2_BASE + 0,	"gpio_0")
+	{.pmux_regoff=0x910,	.pmux_regbit= 3, .pmux_regbitmsk=0x7,	.pcof_regoff=0x938, .pcof_regbit= 4, .pcof_cur_strgh = PADDRI_4_8}, //(P_SB2_BASE + 1,	"gpio_1")
+	{.pmux_regoff=0x910,	.pmux_regbit= 6, .pmux_regbitmsk=0x7,	.pcof_regoff=0x938, .pcof_regbit= 8, .pcof_cur_strgh = PADDRI_4_8}, //(P_SB2_BASE + 2,	"gpio_2")
+	{.pmux_regoff=0x910,	.pmux_regbit= 9, .pmux_regbitmsk=0x7,	.pcof_regoff=0x938, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_4_8}, //(P_SB2_BASE + 3,	"gpio_3")
+	{.pmux_regoff=0x910,	.pmux_regbit=12, .pmux_regbitmsk=0x3,	.pcof_regoff=0x938, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 4,	"gpio_4")
+	{.pmux_regoff=0x910,	.pmux_regbit=14, .pmux_regbitmsk=0x3,	.pcof_regoff=0x938, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 5,	"gpio_5")
+	{.pmux_regoff=0x910,	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x938, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 6,	"gpio_6")
+	{.pmux_regoff=0x910,	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x938, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 7,	"gpio_7")
+	{.pmux_regoff=0x910,	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x93C, .pcof_regbit= 0, .pcof_cur_strgh = PADDRI_4_8}, //(P_SB2_BASE + 8,	"gpio_8")
+	{.pmux_regoff=0x900,	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x91C, .pcof_regbit= 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 9,	"nf_dd_0")
+	{.pmux_regoff=0x900,	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x91C, .pcof_regbit= 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 10,	"nf_dd_1")
+	{.pmux_regoff=0x900,	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x91C, .pcof_regbit= 8, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 11,	"nf_dd_2")
+	{.pmux_regoff=0x900,	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x91C, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 12, 	"nf_dd_3")
+	{.pmux_regoff=0x900,	.pmux_regbit=24, .pmux_regbitmsk=0x3,	.pcof_regoff=0x91C, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 13, 	"nf_dd_4")
+	{.pmux_regoff=0x900,	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=0x91C, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 14, 	"nf_dd_5")
+	{.pmux_regoff=0x900,	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=0x91C, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 15, 	"nf_dd_6")
+	{.pmux_regoff=0x900,	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=0x91C, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 16, 	"nf_dd_7")
+	{.pmux_regoff=0x900,	.pmux_regbit= 2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x918, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 17, 	"nf_rdy")
+	{.pmux_regoff=0x900,	.pmux_regbit= 4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x918, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 18, 	"nf_rd_n")
+	{.pmux_regoff=0x900,	.pmux_regbit= 6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x918, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 19, 	"nf_wr_n")
+	{.pmux_regoff=0x900,	.pmux_regbit= 8, .pmux_regbitmsk=0x3,	.pcof_regoff=0x918, .pcof_regbit= 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 20,	"nf_ale")
+	{.pmux_regoff=0x900,	.pmux_regbit=10, .pmux_regbitmsk=0x3,	.pcof_regoff=0x918, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 21, 	"nf_cle")
+	{.pmux_regoff=0x900,	.pmux_regbit=12, .pmux_regbitmsk=0x3,	.pcof_regoff=0x918, .pcof_regbit= 8, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 22,	"nf_ce_n_0")
+	{.pmux_regoff=0x900,	.pmux_regbit=14, .pmux_regbitmsk=0x3,	.pcof_regoff=0x918, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 23, 	"nf_ce_n_1")
+	{.pmux_regoff=0x904,	.pmux_regbit=24, .pmux_regbitmsk=0x3,	.pcof_regoff=0x920, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 24, 	"mmc_data_0")
+	{.pmux_regoff=0x904,	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=0x920, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 25, 	"mmc_data_1")
+	{.pmux_regoff=0x904,	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=0x920, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 26, 	"mmc_data_2")
+	{.pmux_regoff=0x904,	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=0x920, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 27, 	"mmc_data_3")
+	{.pmux_regoff=0x904,	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x920, .pcof_regbit= 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 28,	"mmc_clk")
+	{.pmux_regoff=0x904,	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x920, .pcof_regbit= 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 29,	"mmc_cmd")
+	{.pmux_regoff=0x904,	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x920, .pcof_regbit= 8, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 30,	"mmc_wp")
+	{.pmux_regoff=0x904,	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x920, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 31, 	"mmc_cd")
+	{.pmux_regoff=0x904,	.pmux_regbit= 2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x924, .pcof_regbit= 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 32,	"sdio_clk")
+	{.pmux_regoff=0x904,	.pmux_regbit= 4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x924, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 33, 	"sdio_data_0")
+	{.pmux_regoff=0x904,	.pmux_regbit= 6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x924, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 34, 	"sdio_data_1")
+	{.pmux_regoff=0x904,	.pmux_regbit= 8, .pmux_regbitmsk=0x3,	.pcof_regoff=0x924, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 35, 	"sdio_data_2")
+	{.pmux_regoff=0x904,	.pmux_regbit=10, .pmux_regbitmsk=0x3,	.pcof_regoff=0x924, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 36, 	"sdio_data_3")
+	{.pmux_regoff=0x904,	.pmux_regbit= 0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x924, .pcof_regbit= 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 37,	"sdio_cmd")
+	{.pmux_regoff=0x90C,	.pmux_regbit=10, .pmux_regbitmsk=0x3,	.pcof_regoff=0x924, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 38, 	"i2c_scl_5")
+	{.pmux_regoff=0x90C,	.pmux_regbit= 8, .pmux_regbitmsk=0x3,	.pcof_regoff=0x924, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 39, 	"i2c_sda_5")
+	{.pmux_regoff=0x908,	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x92C, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 40, 	"tp1_data")
+	{.pmux_regoff=0x908,	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x92C, .pcof_regbit= 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 41,	"tp1_clk")
+	{.pmux_regoff=0x908,	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x92C, .pcof_regbit= 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 42,	"tp1_valid")
+	{.pmux_regoff=0x908,	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x92C, .pcof_regbit= 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 43,	"tp1_sync")
+	{.pmux_regoff=0x908,	.pmux_regbit= 0, .pmux_regbitmsk=0x7,	.pcof_regoff=0x928, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 44, 	"tp0_data")
+	{.pmux_regoff=0x908,	.pmux_regbit= 9, .pmux_regbitmsk=0x7,	.pcof_regoff=0x928, .pcof_regbit= 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 45,	"tp0_clk")
+	{.pmux_regoff=0x908,	.pmux_regbit= 6, .pmux_regbitmsk=0x7,	.pcof_regoff=0x928, .pcof_regbit= 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 46,	"tp0_valid")
+	{.pmux_regoff=0x908,	.pmux_regbit= 3, .pmux_regbitmsk=0x7,	.pcof_regoff=0x928, .pcof_regbit= 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 47,	"tp0_sync")
+	{.pmux_regoff=0x90C,	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x93C, .pcof_regbit= 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 48,	"usb_id")
+	{.pmux_regoff=0x90C,	.pmux_regbit=14, .pmux_regbitmsk=0x3,	.pcof_regoff=0x93C, .pcof_regbit= 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 49,	"hdmi_hpd")
+	{.pmux_regoff=0x90C,	.pmux_regbit=12, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 50,	"spdif")		//NO SMT
+	{.pmux_regoff=0x90C,	.pmux_regbit= 2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x934, .pcof_regbit= 4, .pcof_cur_strgh = PADDRI_4_8}, //(P_SB2_BASE + 51,	"i2c_scl_1")
+	{.pmux_regoff=0x90C,	.pmux_regbit= 0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x934, .pcof_regbit= 0, .pcof_cur_strgh = PADDRI_4_8}, //(P_SB2_BASE + 52,	"i2c_sda_1")
+	{.pmux_regoff=0x90C,	.pmux_regbit= 6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x934, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_4_8}, //(P_SB2_BASE + 53, 	"i2c_scl_4")
+	{.pmux_regoff=0x90C,	.pmux_regbit= 4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x934, .pcof_regbit= 8, .pcof_cur_strgh = PADDRI_4_8}, //(P_SB2_BASE + 54,	"i2c_sda_4")
+	{.pmux_regoff=0x90C,	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=0x93C, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 55, 	"sensor_cko_0")
+	{.pmux_regoff=0x90C,	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=0x93C, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 56, 	"sensor_cko_1")
+	{.pmux_regoff=0x90C,	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=0x93C, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 57, 	"sensor_rst")
+	{.pmux_regoff=0x90C,	.pmux_regbit=24, .pmux_regbitmsk=0x3,	.pcof_regoff=0x93C, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 58, 	"sensor_stb_0")
+	{.pmux_regoff=0x90C,	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x93C, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_SB2_BASE + 59, 	"sensor_stb_1")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 60, 	"gpio_60")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 61, 	"gpio_61")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 62, 	"gpio_62")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 63, 	"gpio_63")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 64, 	"gpio_64")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 65, 	"gpio_65")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 66, 	"gpio_66")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 67, 	"gpio_67")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 68, 	"gpio_68")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 69, 	"gpio_69")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 70, 	"gpio_70")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 71, 	"gpio_71")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 72, 	"gpio_72")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 73, 	"gpio_73")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 74, 	"gpio_74")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 75, 	"gpio_75")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 76, 	"gpio_76")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 77, 	"gpio_77")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 78, 	"gpio_78")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 79, 	"gpio_79")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 80, 	"gpio_80")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 81, 	"gpio_81")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 82, 	"gpio_82")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 83, 	"gpio_83")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 84, 	"gpio_84")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 85, 	"gpio_85")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 86, 	"gpio_86")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 87, 	"gpio_87")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 88, 	"gpio_88")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 89, 	"gpio_89")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 90, 	"gpio_90")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 91, 	"gpio_91")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 92, 	"gpio_92")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 93, 	"gpio_93")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 94, 	"gpio_94")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 95, 	"gpio_95")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 96, 	"gpio_96")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 97, 	"gpio_97")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 98, 	"gpio_98")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 99, 	"gpio_99")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 100, 	"gpio_100")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 101, 	"gpio_101")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 102, 	"gpio_102")
+	{.pmux_regoff=0x90C,	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 103, 	"hi_loc")
+	{.pmux_regoff=0x90C,	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 104, 	"ejtag_scpu_loc")
+	{.pmux_regoff=0x914,	.pmux_regbit= 0, .pmux_regbitmsk=0x1,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 105, 	"sf_en")
+	{.pmux_regoff=0x914,	.pmux_regbit= 1, .pmux_regbitmsk=0x1,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 106, 	"arm_trace_dbg_en")
+	{.pmux_regoff=0x914,	.pmux_regbit= 2, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 107, 	"ao_loc")
+	{.pmux_regoff=0x914,	.pmux_regbit= 4, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 108,	"sdio_loc")
+	{.pmux_regoff=0x914,	.pmux_regbit= 6, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_SB2_BASE + 109,	"ur1_loc")
+	{.pmux_regoff=0x900,	.pmux_regbit= 0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x918, .pcof_regbit= 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 110,	"nf_dqs")
+	{.pmux_regoff=0x944,	.pmux_regbit= 0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x948, .pcof_regbit= 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 111,	"sdio_data_4")
+	{.pmux_regoff=0x944,	.pmux_regbit= 2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x948, .pcof_regbit= 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 112,	"sdio_data_5")
+	{.pmux_regoff=0x944,	.pmux_regbit= 4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x948, .pcof_regbit= 8, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 113,	"sdio_data_6")
+	{.pmux_regoff=0x944,	.pmux_regbit= 6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x948, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_SB2_BASE + 114,	"sdio_data_7")
+
+	////////////////////////////iso_muxpad////////////////////////////
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0x0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0},//(P_ISO_BASE + 0,	"iso_gpio_0")
+	{.pmux_regoff=PMUX_UNSUPPORT,	.pmux_regbit=0, .pmux_regbitmsk=0x0,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0},//(P_ISO_BASE + 1,	"iso_gpio_1)
+	{.pmux_regoff=0x314,	.pmux_regbit= 6, .pmux_regbitmsk=0x7,	.pcof_regoff=0x300, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 2,	"iso_gpio_2")
+	{.pmux_regoff=0x314,	.pmux_regbit= 9, .pmux_regbitmsk=0x7,	.pcof_regoff=0x300, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 3,	"iso_gpio_3")
+	{.pmux_regoff=0x310,	.pmux_regbit= 4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 4,	"vfd_cs_n")
+	{.pmux_regoff=0x310,	.pmux_regbit= 2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 5,	"vfd_clk")
+	{.pmux_regoff=0x310,	.pmux_regbit= 0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 6,	"vfd_d")
+	{.pmux_regoff=0x310,	.pmux_regbit= 6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 7,	"ir_rx")
+	{.pmux_regoff=0x310,	.pmux_regbit= 8, .pmux_regbitmsk=0x3,	.pcof_regoff=0x308, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 8,	"ir_tx")
+	{.pmux_regoff=0x310,	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 9,	"ur0_rx")
+	{.pmux_regoff=0x310,	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 10, 	"ur0_tx")
+	{.pmux_regoff=0x310,	.pmux_regbit=12, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 11,	"ur1_rx")
+	{.pmux_regoff=0x310,	.pmux_regbit=14, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 12,	"ur1_tx")
+	{.pmux_regoff=0x310,	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 13, 	"ur1_cts_n")
+	{.pmux_regoff=0x310,	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 14,	"ur1_rts_n")
+	{.pmux_regoff=0x310,	.pmux_regbit=24, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 15, 	"i2c_scl_0")
+	{.pmux_regoff=0x310,	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 16, 	"i2c_sda_0")
+	{.pmux_regoff=0x310,	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 17, 	"etn_led_link")
+	{.pmux_regoff=0x310,	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 18, 	"etn_led_rxtx")
+	{.pmux_regoff=0x314,	.pmux_regbit= 0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x308, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 19, 	"i2c_scl_6")
+	{.pmux_regoff=0x314,	.pmux_regbit= 2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x308, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 20, 	"i2c_sda_6")
+	{.pmux_regoff=0x328,	.pmux_regbit=24, .pmux_regbitmsk=0x1,	.pcof_regoff=0x318, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 21, 	"iso_gpio_21")
+	{.pmux_regoff=0x328,	.pmux_regbit=25, .pmux_regbitmsk=0x1,	.pcof_regoff=0x318, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 22, 	"iso_gpio_22")
+	{.pmux_regoff=0x328,	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=0x318, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 23, 	"iso_gpio_23")
+	{.pmux_regoff=0x328,	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=0x318, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 24, 	"iso_gpio_24")
+	{.pmux_regoff=0x328,	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=0x318, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 25, 	"iso_gpio_25")
+	{.pmux_regoff=0x324,	.pmux_regbit= 2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x31C, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 26, 	"rgmii_tx_ctl")
+	{.pmux_regoff=0x324,	.pmux_regbit= 4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x31C, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 27, 	"rgmii_txd_0")
+	{.pmux_regoff=0x324,	.pmux_regbit= 6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x31C, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 28, 	"rgmii_txd_1")
+	{.pmux_regoff=0x324,	.pmux_regbit= 8, .pmux_regbitmsk=0x3,	.pcof_regoff=0x31C, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 29, 	"rgmii_txd_2")
+	{.pmux_regoff=0x324,	.pmux_regbit=10, .pmux_regbitmsk=0x3,	.pcof_regoff=0x31C, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 30, 	"rgmii_txd_3")
+	{.pmux_regoff=0x324,	.pmux_regbit=12, .pmux_regbitmsk=0x3,	.pcof_regoff=0x31C, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 31, 	"rgmii_rxc")
+	{.pmux_regoff=0x324,	.pmux_regbit=14, .pmux_regbitmsk=0x3,	.pcof_regoff=0x31C, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 32, 	"rgmii_rx_ctl")
+	{.pmux_regoff=0x324,	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x320, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 33, 	"rgmii_rxd_0")
+	{.pmux_regoff=0x324,	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x320, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 34, 	"rgmii_rxd_1")
+	{.pmux_regoff=0x324,	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x320, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 35, 	"rgmii_rxd_2")
+	{.pmux_regoff=0x324,	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x320, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 36, 	"rgmii_rxd_3")
+	{.pmux_regoff=0x324,	.pmux_regbit=24, .pmux_regbitmsk=0x3,	.pcof_regoff=0x320, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 37, 	"rgmii_mdio")
+	{.pmux_regoff=0x324,	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=0x320, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 38, 	"rgmii_mdc")
+	{.pmux_regoff=0x324,	.pmux_regbit= 0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x31C, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 39, 	"rgmii_txc")
+	{.pmux_regoff=0x314,	.pmux_regbit=24, .pmux_regbitmsk=0x1,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_ISO_BASE + 40, 	"pwm_23_open_drain_switch")
+	{.pmux_regoff=0x314,	.pmux_regbit=25, .pmux_regbitmsk=0x1,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_ISO_BASE + 41, 	"pwm_01_open_drain_switch")
+	{.pmux_regoff=0x314,	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_ISO_BASE + 42, 	"ejtag_avcpu_loc")
+	{.pmux_regoff=0x314,	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_ISO_BASE + 43, 	"ai_loc")
+
+};
+
+#define RTK119X_PCONF_SCHM 3
+#define RTK119X_PCONF_CURR 2
+#define RTK119X_PCONF_PULEN 1
+#define RTK119X_PCONF_PULSEL 0
+
+/*
+
+#define RTK119X_PIN_NAME_MAX_LEN	5
+
+#define BANK_MEM_SIZE		0x24
+#define MUX_REGS_OFFSET	0x0
+#define DATA_REGS_OFFSET	0x10
+#define DLEVEL_REGS_OFFSET	0x14
+#define PULL_REGS_OFFSET	0x1c
+*/
+
+#define PINS_OF_CRTBANK				115
+#define MUX_PINS_PER_REG			16
+#define MUX_PINS_NUMBER_MASK		0xffff0000
+#define MUX_PINS_NUMBER_MASK_OFF	16
+#define MUX_REG_BITNUM_MASK			0x0000ff00
+#define MUX_REG_BITNUM_MASK_OFF		8
+#define MUX_REG_BITOFF_MASK			0x000000ff
+
+
+
+
+/*
+#define MUX_PINS_BITS		4
+#define MUX_PINS_MASK		0x0f
+#define DATA_PINS_PER_REG	32
+#define DATA_PINS_BITS		1
+#define DATA_PINS_MASK		0x01
+#define DLEVEL_PINS_PER_REG	16
+#define DLEVEL_PINS_BITS	2
+#define DLEVEL_PINS_MASK	0x03
+#define PULL_PINS_PER_REG	16
+#define PULL_PINS_BITS		2
+#define PULL_PINS_MASK		0x03
+*/
+struct RTK119X_desc_function {
+	const char	*name;
+	u8		muxval;
+};
+
+struct RTK119X_desc_pin {
+	struct pinctrl_pin_desc		pin;
+	struct RTK119X_desc_function	*functions;
+};
+
+struct RTK119X_pinctrl_desc {
+	const struct RTK119X_desc_pin	*pins;
+	int				npins;
+	struct pinctrl_gpio_range	*ranges;
+	int				nranges;
+};
+
+struct RTK119X_pinctrl_function {
+	const char	*name;
+	const char	**groups;
+	unsigned	ngroups;
+};
+
+struct RTK119X_pinctrl_group {
+	const char	*name;
+	unsigned long	config;
+	unsigned	pin;
+};
+
+struct RTK119X_pinctrl {
+	void __iomem			*crt_membase;
+	void __iomem			*iso_membase;
+//	struct gpio_chip		*chip;
+	struct RTK119X_pinctrl_desc	*desc;
+	struct device			*dev;
+	struct RTK119X_pinctrl_function	*functions;
+	unsigned			nfunctions;
+	struct RTK119X_pinctrl_group	*groups;
+	unsigned			ngroups;
+	struct pinctrl_dev		*pctl_dev;
+};
+
+#define RTK119X_PIN(_pin, ...)					\
+	{							\
+		.pin = _pin,					\
+		.functions = (struct RTK119X_desc_function[]){	\
+			__VA_ARGS__, { } },			\
+	}
+
+#define RTK119X_FUNCTION(_val, _name)				\
+	{							\
+		.name = _name,					\
+		.muxval = _val,					\
+	}
+
+static const struct RTK119X_desc_pin rtk119x_pins[] = {
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_0,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "uart1_loc_misc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x4, "gspi")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_1,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "uart1_loc_misc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x4, "gspi")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_2,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "uart1_loc_misc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x4, "gspi")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_3,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "uart1_loc_misc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x4, "gspi")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_4,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_misc"),
+		RTK119X_FUNCTION(0x3, "ao_loc_misc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_5,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_misc"),
+		RTK119X_FUNCTION(0x3, "ao_loc_misc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_6,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_misc"),
+		RTK119X_FUNCTION(0x3, "ao_loc_misc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_7,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_misc"),
+		RTK119X_FUNCTION(0x3, "ao_loc_misc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_8,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_misc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_dd_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_dd_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_dd_2,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_dd_3,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_dd_4,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_dd_5,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_dd_6,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_dd_7,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_rdy,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_rd_n,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_wr_n,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_ale,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_cle,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_ce_n_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_ce_n_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_mmc_data_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x2, "sdio"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_mmc_data_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x2, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_mmc_data_2,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x2, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_mmc_data_3,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x2, "sdio"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_mmc_clk,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x2, "sdio"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_mmc_cmd,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x2, "sdio"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_mmc_wp,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_mmc_cd,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_clk,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_data_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_data_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_data_2,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_data_3,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_cmd,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_i2c_scl_5,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c5"),
+		RTK119X_FUNCTION(0x3, "nand")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_i2c_sda_5,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c5"),
+		RTK119X_FUNCTION(0x3, "nand")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_tp1_data,
+		RTK119X_FUNCTION(0x0, "tp1"),
+		RTK119X_FUNCTION(0x1, "tp0"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "i2c3")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_tp1_clk,
+		RTK119X_FUNCTION(0x0, "tp1"),
+		RTK119X_FUNCTION(0x1, "tp0"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "i2c2")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_tp1_valid,
+		RTK119X_FUNCTION(0x0, "tp1"),
+		RTK119X_FUNCTION(0x1, "tp0"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "i2c3")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_tp1_sync,
+		RTK119X_FUNCTION(0x0, "tp1"),
+		RTK119X_FUNCTION(0x1, "tp0"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "i2c2")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_tp0_data,
+		RTK119X_FUNCTION(0x0, "tp0"),
+		RTK119X_FUNCTION(0x1, "tp1"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "ao_loc_tp"),
+		RTK119X_FUNCTION(0x4, "ttl")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_tp0_clk,
+		RTK119X_FUNCTION(0x0, "tp0"),
+		RTK119X_FUNCTION(0x1, "tp1"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "ao_loc_tp"),
+		RTK119X_FUNCTION(0x4, "ttl")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_tp0_valid,
+		RTK119X_FUNCTION(0x0, "tp0"),
+		RTK119X_FUNCTION(0x1, "tp1"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "ao_loc_tp"),
+		RTK119X_FUNCTION(0x4, "ttl")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_tp0_sync,
+		RTK119X_FUNCTION(0x0, "tp0"),
+		RTK119X_FUNCTION(0x1, "tp1"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "ao_loc_tp"),
+		RTK119X_FUNCTION(0x4, "ttl")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_usb_id,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "cpu_loop")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_hdmi_hpd,
+		RTK119X_FUNCTION(0x1, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_spdif,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "spdif")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_i2c_scl_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c1")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_i2c_sda_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c1")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_i2c_scl_4,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c4"),
+		RTK119X_FUNCTION(0x2, "uart2")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_i2c_sda_4,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c4"),
+		RTK119X_FUNCTION(0x2, "uart2")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sensor_cko_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sensor"),
+		RTK119X_FUNCTION(0x2, "uart2")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sensor_cko_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sensor"),
+		RTK119X_FUNCTION(0x2, "uart2"),
+		RTK119X_FUNCTION(0x3, "usb")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sensor_rst,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sensor_stb_0,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sensor_stb_1,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_60,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_61,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_62,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_63,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_64,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_65,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_66,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_67,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_68,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_69,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_70,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_71,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_72,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_73,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_74,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_75,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_76,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_77,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_78,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_79,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_80,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_81,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_82,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_83,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_84,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_85,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_86,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_87,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_88,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_89,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_90,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_91,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_92,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_93,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_94,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_95,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_96,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_97,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_98,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_99,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_100,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_101,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_gpio_102,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_hi_loc,
+		RTK119X_FUNCTION(0x1, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x2, "hif_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_ejtag_scpu_loc,
+		RTK119X_FUNCTION(0x1, "scpu_ejtag_loc_misc"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_cr"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_scpu")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sf_en,
+		RTK119X_FUNCTION(0x0, "uart1_loc_misc"),
+		RTK119X_FUNCTION(0x0, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x0, "gspi"),
+		RTK119X_FUNCTION(0x1, "spi")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_arm_trace_dbg_en,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "jtag")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_ao_loc,
+		RTK119X_FUNCTION(0x1, "ao_loc_tp"),
+		RTK119X_FUNCTION(0x2, "ao_loc_misc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_loc,
+		RTK119X_FUNCTION(0x1, "sdio_from_sdio"),
+		RTK119X_FUNCTION(0x2, "sdio_from_mmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_ur1_loc,
+		RTK119X_FUNCTION(0x1, "uart1_loc_iso"),
+		RTK119X_FUNCTION(0x2, "uart1_loc_misc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_nf_dqs,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_data_4,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_data_5,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_data_6,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_SB2_sdio_data_7,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+//////////iso pinmux////////////////
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio_0,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio_1,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio_2,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "standby_dbg"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_usb"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_iso"),
+		RTK119X_FUNCTION(0x4, "pwm")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio_3,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "standby_dbg"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_usb"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_iso"),
+		RTK119X_FUNCTION(0x4, "pwm")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_vfd_cs_n,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "vfd"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_usb"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_iso")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_vfd_clk,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "vfd"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_usb"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_iso")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_vfd_d,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "vfd"),
+		RTK119X_FUNCTION(0x2, "i2c2"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_iso")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ir_rx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "irrx"),
+		RTK119X_FUNCTION(0x2, "standby_dbg")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ir_tx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "irtx"),
+		RTK119X_FUNCTION(0x2, "i2c3")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur0_rx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart0"),
+		RTK119X_FUNCTION(0x2, "pwm")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur0_tx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart0"),
+		RTK119X_FUNCTION(0x2, "pwm")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur1_rx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart1_loc_iso"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_ur"),
+		RTK119X_FUNCTION(0x3, "pwm")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur1_tx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart1_loc_iso"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_ur"),
+		RTK119X_FUNCTION(0x3, "pwm")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur1_cts_n,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart1_loc_iso"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_ur")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur1_rts_n,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart1_loc_iso"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_ur")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_i2c_scl_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c0")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_i2c_sda_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c0")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_etn_led_link,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "etn_led"),
+		RTK119X_FUNCTION(0x2, "pwm")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_etn_led_rxtx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "etn_led"),
+		RTK119X_FUNCTION(0x2, "pwm")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_i2c_scl_6,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c6")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_i2c_sda_6,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c6")),	
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio_21,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio_22,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio_23,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio_24,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio_25,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_tx_ctl,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_txd_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii"),
+		RTK119X_FUNCTION(0x2, "rmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_txd_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii"),
+		RTK119X_FUNCTION(0x2, "rmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_txd_2,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_txd_3,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_rxc,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii"),
+		RTK119X_FUNCTION(0x2, "rmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_rx_ctl,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii"),
+		RTK119X_FUNCTION(0x2, "rmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_rxd_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii"),
+		RTK119X_FUNCTION(0x2, "rmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_rxd_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii"),
+		RTK119X_FUNCTION(0x2, "rmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_rxd_2,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_rxd_3,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_mdio,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii"),
+		RTK119X_FUNCTION(0x2, "fephy")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_mdc,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii"),
+		RTK119X_FUNCTION(0x2, "fephy")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_rgmii_txc,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "rgmii")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_pwm_23_open_drain_switch,
+		RTK119X_FUNCTION(0x0, "normal"),
+		RTK119X_FUNCTION(0x1, "open_drain")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_pwm_01_open_drain_switch,
+		RTK119X_FUNCTION(0x0, "normal"),
+		RTK119X_FUNCTION(0x1, "open_drain")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ejtag_avcpu_loc,
+		RTK119X_FUNCTION(0x1, "avcpu_ejtag_loc_iso"),
+		RTK119X_FUNCTION(0x2, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ai_loc,
+		RTK119X_FUNCTION(0x1, "ai_loc_iso_ur"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_usb")),
+};
+
+#endif /* __PINCTRL_RTK119X_H */
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd119x.c b/drivers/pinctrl/realtek/pinctrl-rtd119x.c
new file mode 100644
index 00000000..aa23be4
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd119x.c
@@ -0,0 +1,827 @@
+/*
+ * Realtek pin controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/io.h>
+#include <linux/clk.h>
+#include <linux/gpio.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/pinctrl/consumer.h>
+#include <linux/pinctrl/machine.h>
+#include <linux/pinctrl/pinctrl.h>
+#include <linux/pinctrl/pinconf-generic.h>
+#include <linux/pinctrl/pinmux.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+
+#include "../core.h"
+#ifndef CONFIG_MACH_RTK1192
+#include "pinctrl-rtd119x.h"
+#else
+#include "pinctrl-rtk1192.h"
+#endif
+
+static const struct RTK119X_pinctrl_desc rtk119x_pinctrl_data = {
+	.pins = rtk119x_pins,
+	.npins = ARRAY_SIZE(rtk119x_pins),
+};
+
+static void RTK119X_pmx_set(struct pinctrl_dev *pctldev,unsigned pin,u8 config)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	void __iomem *addr;
+	u32 val;
+	u32 mask ;
+
+#ifdef CONFIG_MACH_RTK1192
+	if(pin_regmap[pin].pmux_regoff == PMUX_UNSUPPORT)
+		return;
+#endif
+
+	if ( pin < PINS_OF_CRTBANK)
+		addr = pctl->crt_membase + pin_regmap[pin].pmux_regoff;
+	 else
+		addr = pctl->iso_membase + pin_regmap[pin].pmux_regoff;
+
+	RTK_debug("[%s]  %s   %d  addr=%x, bit=%d ,config = %x	 \n ",__FILE__,__FUNCTION__, __LINE__,(u32)addr ,pin_regmap[pin].pmux_regbit ,config);
+
+	val = readl(addr);
+	mask =	pin_regmap[pin].pmux_regbitmsk << pin_regmap[pin].pmux_regbit;
+	writel(((val & ~mask) | (config << pin_regmap[pin].pmux_regbit)),  addr);
+
+	RTK_debug("[%s]  %s   %d  addr=%x , bit=%d ,final_val = %x	 \n ",__FILE__,__FUNCTION__, __LINE__,(u32)addr,pin_regmap[pin].pmux_regbit ,readl(addr) );
+
+}
+
+static struct RTK119X_pinctrl_group *
+RTK119X_pinctrl_find_group_by_name(struct RTK119X_pinctrl *pctl, const char *group)
+{
+	int i;
+	RTK_debug("[%s]  %s   %d  name = %s \n ",__FILE__,__FUNCTION__, __LINE__,group);
+	for (i = 0; i < pctl->ngroups; i++) {
+		struct RTK119X_pinctrl_group *grp = pctl->groups + i;
+
+		if (!strcmp(grp->name, group))
+			return grp;
+	}
+
+	return NULL;
+}
+
+static struct RTK119X_pinctrl_function *
+RTK119X_pinctrl_find_function_by_name(struct RTK119X_pinctrl *pctl,
+				    const char *name)
+{
+	struct RTK119X_pinctrl_function *func = pctl->functions;
+	int i;
+//	RTK_debug("[%s]  %s   %d \n ",__FILE__,__FUNCTION__, __LINE__);
+	for (i = 0; i < pctl->nfunctions; i++) {
+		if (!func[i].name)
+			break;
+
+		if (!strcmp(func[i].name, name))
+			return func + i;
+	}
+
+	return NULL;
+}
+
+static struct RTK119X_desc_function *
+RTK119X_pinctrl_desc_find_function_by_name(struct RTK119X_pinctrl *pctl,
+					 const char *pin_name,
+					 const char *func_name)
+{
+	int i;
+	RTK_debug("[%s]  %s   %d  pin_name=%s, func_name=%s\n ",__FILE__,__FUNCTION__, __LINE__, pin_name,func_name);
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK119X_desc_pin *pin = pctl->desc->pins + i;
+
+		if (!strcmp(pin->pin.name, pin_name)) {
+			struct RTK119X_desc_function *func = pin->functions;
+
+			while (func->name) {
+				if (!strcmp(func->name, func_name))
+					return func;
+
+				func++;
+			}
+		}
+	}
+
+	return NULL;
+}
+
+static int RTK119X_pctrl_get_groups_count(struct pinctrl_dev *pctldev)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	RTK_debug("[%s]  %s   %d pctl->ngroups=%d \n ",__FILE__,__FUNCTION__, __LINE__, pctl->ngroups);
+	return pctl->ngroups;
+}
+
+static const char *RTK119X_pctrl_get_group_name(struct pinctrl_dev *pctldev,
+					      unsigned group)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	RTK_debug("[%s]  %s   %d group].name=%s \n ",__FILE__,__FUNCTION__, __LINE__,pctl->groups[group].name);
+	return pctl->groups[group].name;
+}
+
+static int RTK119X_pctrl_get_group_pins(struct pinctrl_dev *pctldev,
+				      unsigned group,
+				      const unsigned **pins,
+				      unsigned *num_pins)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	RTK_debug("[%s]  %s   %d \n ",__FILE__,__FUNCTION__, __LINE__);
+	*pins = (unsigned *)&pctl->groups[group].pin;
+	*num_pins = 1;
+
+	return 0;
+}
+
+static int RTK119X_pctrl_dt_node_to_map(struct pinctrl_dev *pctldev,
+				      struct device_node *node,
+				      struct pinctrl_map **map,
+				      unsigned *num_maps)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	unsigned long *pinconfig;
+	struct property *prop;
+	const char *function;
+	const char *group;
+	int ret, nmaps, i = 0;
+	u32 val;
+	RTK_debug("[%s]  %s   %d \n ",__FILE__,__FUNCTION__, __LINE__);
+	*map = NULL;
+	*num_maps = 0;
+
+	ret = of_property_read_string(node, "rtk119x,function", &function);
+	if (ret) {
+		printk(
+			"missing rtk119x,function property in node %s\n",
+			node->name);
+		return -EINVAL;
+	}
+
+	nmaps = of_property_count_strings(node, "rtk119x,pins") * 2;
+	if (nmaps < 0) {
+		printk(
+			"missing rtk119x,pins property in node %s\n",
+			node->name);
+		return -EINVAL;
+	}
+
+	*map = kmalloc(nmaps * sizeof(struct pinctrl_map), GFP_KERNEL);
+	if (!map)
+		return -ENOMEM;
+
+	of_property_for_each_string(node, "rtk119x,pins", prop, group) {
+		struct RTK119X_pinctrl_group *grp =
+			RTK119X_pinctrl_find_group_by_name(pctl, group);
+		int j = 0, configlen = 0;
+
+		if (!grp) {
+			printk( "unknown pin %s", group);
+			continue;
+		}
+
+		if (!RTK119X_pinctrl_desc_find_function_by_name(pctl,
+							      grp->name,
+							      function)) {
+			printk( "unsupported function %s on pin %s",
+				function, group);
+			continue;
+		}
+
+		(*map)[i].type = PIN_MAP_TYPE_MUX_GROUP;
+		(*map)[i].data.mux.group = group;
+		(*map)[i].data.mux.function = function;
+
+		i++;
+
+		(*map)[i].type = PIN_MAP_TYPE_CONFIGS_GROUP;
+		(*map)[i].data.configs.group_or_pin = group;
+
+		if (of_find_property(node, "rtk119x,schmitt", NULL))
+			configlen++;
+		if (of_find_property(node, "rtk119x,drive", NULL))
+			configlen++;
+		if (of_find_property(node, "rtk119x,pull_en", NULL))
+			configlen++;
+		if (of_find_property(node, "rtk119x,pull_sel", NULL))
+			configlen++;
+
+
+		pinconfig = kzalloc(configlen * sizeof(*pinconfig), GFP_KERNEL);
+
+		if (!of_property_read_u32(node, "rtk119x,schmitt", &val)) {
+			u16 schmitt_enable;
+			if (val==0)
+				schmitt_enable = 0;
+			else
+				schmitt_enable = 1;
+			
+			pinconfig[j++] = pinconf_to_config_packed(PIN_CONFIG_INPUT_SCHMITT_ENABLE, schmitt_enable);
+		}
+
+		if (!of_property_read_u32(node, "rtk119x,drive", &val)) {
+			pinconfig[j++] = pinconf_to_config_packed(PIN_CONFIG_DRIVE_STRENGTH, val);
+		}
+
+		if (!of_property_read_u32(node, "rtk119x,pull_en", &val)) {
+			enum pin_config_param pull= PIN_CONFIG_END;
+			if (val == 0)
+				pull = PIN_CONFIG_BIAS_DISABLE;
+			else if(val == 1)
+				pull = PIN_CONFIG_DRIVE_PUSH_PULL;
+			pinconfig[j++] = pinconf_to_config_packed(pull, 0);
+		}
+
+		if (!of_property_read_u32(node, "rtk119x,pull_sel", &val)) {
+			enum pin_config_param pull = PIN_CONFIG_END;
+			if (val == 0)
+				pull = PIN_CONFIG_BIAS_PULL_DOWN;
+			else if (val == 1)
+				pull = PIN_CONFIG_BIAS_PULL_UP;
+			pinconfig[j++] = pinconf_to_config_packed(pull, 1);
+		}
+		RTK_debug("[%s]  %s   %d \n ",__FILE__,__FUNCTION__, __LINE__);
+		(*map)[i].data.configs.configs = pinconfig;
+		(*map)[i].data.configs.num_configs = configlen;
+
+		i++;
+	}
+
+	*num_maps = nmaps;
+
+	return 0;
+}
+
+static void RTK119X_pctrl_dt_free_map(struct pinctrl_dev *pctldev,
+				    struct pinctrl_map *map,
+				    unsigned num_maps)
+{
+	int i;
+	RTK_debug("[%s]  %s   %d \n ",__FILE__,__FUNCTION__, __LINE__);
+	for (i = 0; i < num_maps; i++) {
+		if (map[i].type == PIN_MAP_TYPE_CONFIGS_GROUP)
+			kfree(map[i].data.configs.configs);
+	}
+
+	kfree(map);
+}
+
+static const struct pinctrl_ops RTK119X_pctrl_ops = {
+	.dt_node_to_map		= RTK119X_pctrl_dt_node_to_map,
+	.dt_free_map		= RTK119X_pctrl_dt_free_map,
+	.get_groups_count	= RTK119X_pctrl_get_groups_count,
+	.get_group_name		= RTK119X_pctrl_get_group_name,
+	.get_group_pins		= RTK119X_pctrl_get_group_pins,
+};
+
+static int RTK119X_pconf_group_get(struct pinctrl_dev *pctldev,
+				 unsigned group,
+				 unsigned long *config)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	RTK_debug("[%s]  %s   %d \n ",__FILE__,__FUNCTION__, __LINE__);
+	*config = pctl->groups[group].config;
+
+	return 0;
+}
+
+static int RTK119X_pconf_group_set(struct pinctrl_dev *pctldev,
+				 unsigned group,
+				 unsigned long config)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK119X_pinctrl_group *g = &pctl->groups[group];
+	u32 val, mask;
+	u16 strength;
+	u8 set_val;
+	void __iomem *addr;
+	RTK_debug("[%s]  %s   %d   g->pin=%d    g->name =%s  config = %lx \n ",__FILE__,__FUNCTION__, __LINE__,g->pin,g->name,config);
+
+	if(pin_regmap[g->pin].pcof_regoff == PCOF_UNSUPPORT)
+	{
+		RTK_debug("[pinctrl] g->pin(%d) g->name(%s) not support pin config\n",g->pin,g->name);
+		g->config = config;
+		return 0;
+	}
+
+	if ( g->pin < PINS_OF_CRTBANK)
+		addr = pctl->crt_membase + pin_regmap[g->pin].pcof_regoff;
+	 else
+		addr = pctl->iso_membase + pin_regmap[g->pin].pcof_regoff;
+
+
+	switch (pinconf_to_config_param(config)) {
+
+		case PIN_CONFIG_INPUT_SCHMITT:
+			break;
+		case PIN_CONFIG_INPUT_SCHMITT_ENABLE:
+			set_val = pinconf_to_config_argument(config);
+			if(set_val)
+				set_val = 1;
+			else
+				set_val = 0;
+
+			val = readl(addr);
+			mask =  1 << (pin_regmap[g->pin].pcof_regbit + RTK119X_PCONF_SCHM);
+			writel(((val & ~mask)|(set_val<<(pin_regmap[g->pin].pcof_regbit+RTK119X_PCONF_SCHM))), addr);
+			break;
+
+
+		case PIN_CONFIG_DRIVE_STRENGTH:
+			strength = pinconf_to_config_argument(config);
+			switch(pin_regmap[g->pin].pcof_cur_strgh)
+			{
+				case PADDRI_4_8:
+					if(strength == 4) set_val = 0;
+					else if(strength == 8) set_val = 1;
+					else return -EINVAL;
+					break;
+				case PADDRI_2_4:
+					if(strength == 2) set_val = 0;
+					else if(strength == 4) set_val = 1;
+					else return -EINVAL;
+					break;
+				case PADDRI_UNSUPPORT:
+				default:
+					return -EINVAL;
+					break;
+			}
+
+			val = readl(addr);
+			mask =  1 << (pin_regmap[g->pin].pcof_regbit + RTK119X_PCONF_CURR);
+			writel(((val & ~mask)|(set_val<<(pin_regmap[g->pin].pcof_regbit+RTK119X_PCONF_CURR))), addr);
+			break;
+		case PIN_CONFIG_DRIVE_PUSH_PULL :
+			val = readl(addr);
+			mask =  1 << (pin_regmap[g->pin].pcof_regbit + RTK119X_PCONF_PULEN);
+			writel(((val & ~mask)|(1<<(pin_regmap[g->pin].pcof_regbit+RTK119X_PCONF_PULEN))), addr);
+			break;
+
+		case PIN_CONFIG_BIAS_DISABLE :
+			val = readl(addr);
+			mask =  1 << (pin_regmap[g->pin].pcof_regbit + RTK119X_PCONF_PULEN);
+			writel(((val & ~mask)|(0<<(pin_regmap[g->pin].pcof_regbit+RTK119X_PCONF_PULEN))), addr);
+			break;
+		case PIN_CONFIG_BIAS_PULL_UP:
+			val = readl(addr);
+			mask =  1 << (pin_regmap[g->pin].pcof_regbit + RTK119X_PCONF_PULSEL);
+			writel(((val & ~mask)|(1<<(pin_regmap[g->pin].pcof_regbit+RTK119X_PCONF_PULSEL))), addr);
+			break;
+		case PIN_CONFIG_BIAS_PULL_DOWN:
+			val = readl(addr);
+			mask =  1 << (pin_regmap[g->pin].pcof_regbit + RTK119X_PCONF_PULSEL);
+			writel(((val & ~mask)|(0<<(pin_regmap[g->pin].pcof_regbit+RTK119X_PCONF_PULSEL))), addr);
+
+			break;
+		default:
+			break;
+	}
+
+	/* cache the config value */
+	g->config = config;
+	return 0;
+}
+
+static const struct pinconf_ops RTK119X_pconf_ops = {
+	.pin_config_group_get	= RTK119X_pconf_group_get,
+	.pin_config_group_set	= RTK119X_pconf_group_set,
+};
+
+static int RTK119X_pmx_get_funcs_cnt(struct pinctrl_dev *pctldev)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	RTK_debug("[%s]  %s   %d pctl->nfunctions =%d \n ",__FILE__,__FUNCTION__, __LINE__,pctl->nfunctions);
+	return pctl->nfunctions;
+}
+
+static const char *RTK119X_pmx_get_func_name(struct pinctrl_dev *pctldev,
+					   unsigned function)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	RTK_debug("[%s]  %s   %d function[%d] = %s\n ",__FILE__,__FUNCTION__, __LINE__, function,pctl->functions[function].name);
+	return pctl->functions[function].name;
+}
+
+static int RTK119X_pmx_get_func_groups(struct pinctrl_dev *pctldev,
+				     unsigned function,
+				     const char * const **groups,
+				     unsigned * const num_groups)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	RTK_debug("[%s]  %s   %d \n ",__FILE__,__FUNCTION__, __LINE__);
+	*groups = pctl->functions[function].groups;
+	*num_groups = pctl->functions[function].ngroups;
+
+	return 0;
+}
+
+static int RTK119X_pmx_enable(struct pinctrl_dev *pctldev,
+			    unsigned function,
+			    unsigned group)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK119X_pinctrl_group *g = pctl->groups + group;
+	struct RTK119X_pinctrl_function *func = pctl->functions + function;
+	struct RTK119X_desc_function *desc =
+		RTK119X_pinctrl_desc_find_function_by_name(pctl,
+							 g->name,
+							 func->name);
+	RTK_debug("[%s]  %s   %d  g->name=%s ,func->name=%s  \n ",__FILE__,__FUNCTION__, __LINE__,g->name,func->name );
+	if (!desc)
+		return -EINVAL;
+
+	RTK119X_pmx_set(pctldev, g->pin, desc->muxval);
+
+	return 0;
+}
+
+
+static int
+RTK119X_pmx_gpio_request_enable (struct pinctrl_dev *pctldev,
+				    struct pinctrl_gpio_range *range,
+				    unsigned offset)
+{
+	struct RTK119X_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK119X_pinctrl_group *g = pctl->groups + offset;
+	struct RTK119X_desc_function *desc;
+	const char *func;
+	int ret;
+	func = "gpio";
+	RTK_debug("[%s]  %s   %d gpio_offset = %d \n ",__FILE__,__FUNCTION__, __LINE__,offset);
+	desc = RTK119X_pinctrl_desc_find_function_by_name(pctl,
+							g->name,
+							func);
+	if (!desc) {
+		ret = -EINVAL;
+		goto error;
+	}
+
+	RTK119X_pmx_set(pctldev, offset, desc->muxval);
+
+	ret = 0;
+
+error:
+	return ret;
+}
+
+static void
+RTK119X_pmx_gpio_disable_free (struct pinctrl_dev *pctldev,
+				    struct pinctrl_gpio_range *range,
+				    unsigned offset)
+{
+	RTK_debug("[%s]  %s   %d \n ",__FILE__,__FUNCTION__, __LINE__);
+/*TODO : need to add gpio related api*/
+	return ;
+}
+
+
+
+static const struct pinmux_ops RTK119X_pmx_ops = {
+	.get_functions_count	= RTK119X_pmx_get_funcs_cnt,
+	.get_function_name	= RTK119X_pmx_get_func_name,
+	.get_function_groups	= RTK119X_pmx_get_func_groups,
+	.set_mux		= RTK119X_pmx_enable,
+	.gpio_request_enable = RTK119X_pmx_gpio_request_enable,
+	.gpio_disable_free = RTK119X_pmx_gpio_disable_free,
+};
+
+static struct pinctrl_desc RTK119X_pctrl_desc = {
+	.confops	= &RTK119X_pconf_ops,
+	.pctlops	= &RTK119X_pctrl_ops,
+	.pmxops		= &RTK119X_pmx_ops,
+};
+#if 0
+static int RTK119X_pinctrl_gpio_request(struct gpio_chip *chip, unsigned offset)
+{
+	return pinctrl_request_gpio((unsigned)chip->base + offset);
+}
+
+static void RTK119X_pinctrl_gpio_free(struct gpio_chip *chip, unsigned offset)
+{
+	pinctrl_free_gpio((unsigned)chip->base + offset);
+}
+
+static int RTK119X_pinctrl_gpio_direction_input(struct gpio_chip *chip,
+					unsigned offset)
+{
+	return pinctrl_gpio_direction_input((unsigned)chip->base + offset);
+}
+
+static int RTK119X_pinctrl_gpio_get(struct gpio_chip *chip, unsigned offset)
+{
+	struct RTK119X_pinctrl *pctl = dev_get_drvdata(chip->dev);
+
+	u32 reg = RTK119X_data_reg(offset);
+	u8 index = RTK119X_data_offset(offset);
+	u32 val = (readl(pctl->membase + reg) >> index) & DATA_PINS_MASK;
+
+	return val;
+}
+
+static int RTK119X_pinctrl_gpio_direction_output(struct gpio_chip *chip,
+					unsigned offset, int value)
+{
+	return pinctrl_gpio_direction_output((unsigned)chip->base + offset);
+}
+
+static void RTK119X_pinctrl_gpio_set(struct gpio_chip *chip,
+				unsigned offset, int value)
+{
+	struct RTK119X_pinctrl *pctl = dev_get_drvdata(chip->dev);
+	u32 reg = RTK119X_data_reg(offset);
+	u8 index = RTK119X_data_offset(offset);
+
+	writel((value & DATA_PINS_MASK) << index, pctl->membase + reg);
+}
+
+static int RTK119X_pinctrl_gpio_of_xlate(struct gpio_chip *gc,
+				const struct of_phandle_args *gpiospec,
+				u32 *flags)
+{
+	int pin, base;
+
+	base = PINS_PER_BANK * gpiospec->args[0];
+	pin = base + gpiospec->args[1];
+
+	if (pin > ((unsigned)gc->base + gc->ngpio))
+		return -EINVAL;
+
+	if (flags)
+		*flags = gpiospec->args[2];
+
+	return pin;
+}
+
+static struct gpio_chip RTK119X_pinctrl_gpio_chip = {
+	.owner			= THIS_MODULE,
+	.request		= RTK119X_pinctrl_gpio_request,
+	.free			= RTK119X_pinctrl_gpio_free,
+	.direction_input	= RTK119X_pinctrl_gpio_direction_input,
+	.direction_output	= RTK119X_pinctrl_gpio_direction_output,
+	.get			= RTK119X_pinctrl_gpio_get,
+	.set			= RTK119X_pinctrl_gpio_set,
+	.of_xlate		= RTK119X_pinctrl_gpio_of_xlate,
+	.of_gpio_n_cells	= 3,
+	.can_sleep		= 0,
+};
+#endif
+
+static struct of_device_id RTK119X_pinctrl_match[] = {
+	{ .compatible = "rtk119x,rtk119x-pinctrl", .data = (void *)&rtk119x_pinctrl_data },
+	{ /* Sentinel */ },
+};
+MODULE_DEVICE_TABLE(of, RTK119X_pinctrl_match);
+
+static int RTK119X_pinctrl_add_function(struct RTK119X_pinctrl *pctl,
+					const char *name)
+{
+	struct RTK119X_pinctrl_function *func = pctl->functions;
+	while (func->name) {
+		/* function already there */
+		if (strcmp(func->name, name) == 0) {
+			func->ngroups++;
+			return -EEXIST;
+		}
+		func++;
+	}
+	
+	func->name = name;
+	func->ngroups = 1;
+
+	pctl->nfunctions++;
+
+	return 0;
+}
+
+static int RTK119X_pinctrl_build_state(struct platform_device *pdev)
+{
+	struct RTK119X_pinctrl *pctl = platform_get_drvdata(pdev);
+	int i;
+	RTK_debug("[%s]  %s   %d \n ",__FILE__,__FUNCTION__, __LINE__);
+	pctl->ngroups = pctl->desc->npins;
+
+	/* Allocate groups */
+	pctl->groups = devm_kzalloc(&pdev->dev,
+				    pctl->ngroups * sizeof(*pctl->groups),
+				    GFP_KERNEL);
+	if (!pctl->groups)
+		return -ENOMEM;
+
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK119X_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK119X_pinctrl_group *group = pctl->groups + i;
+
+		group->name = pin->pin.name;
+		group->pin = pin->pin.number;
+	}
+
+	/*
+	 * We suppose that we won't have any more functions than pins,
+	 * we'll reallocate that later anyway
+	 */
+	pctl->functions = devm_kzalloc(&pdev->dev,
+				pctl->desc->npins * sizeof(*pctl->functions),
+				GFP_KERNEL);
+	if (!pctl->functions)
+		return -ENOMEM;
+
+	/* Count functions and their associated groups */
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK119X_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK119X_desc_function *func = pin->functions;
+
+		while (func->name) {
+			RTK119X_pinctrl_add_function(pctl, func->name);
+			func++;
+		}
+	}
+
+	pctl->functions = krealloc(pctl->functions,
+				pctl->nfunctions * sizeof(*pctl->functions),
+				GFP_KERNEL);
+
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK119X_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK119X_desc_function *func = pin->functions;
+
+		while (func->name) {
+			struct RTK119X_pinctrl_function *func_item;
+			const char **func_grp;
+
+			func_item = RTK119X_pinctrl_find_function_by_name(pctl,
+									func->name);
+			if (!func_item)
+				return -EINVAL;
+
+			if (!func_item->groups) {
+				func_item->groups =
+					devm_kzalloc(&pdev->dev,
+						     func_item->ngroups * sizeof(*func_item->groups),
+						     GFP_KERNEL);
+				if (!func_item->groups)
+					return -ENOMEM;
+			}
+
+			func_grp = func_item->groups;
+			while (*func_grp)
+				func_grp++;
+
+			*func_grp = pin->pin.name;
+			func++;
+		}
+	}
+
+	return 0;
+}
+
+static int RTK119X_pinctrl_probe(struct platform_device *pdev)
+{
+	struct device_node *node = pdev->dev.of_node;
+	const struct of_device_id *device;
+	struct pinctrl_pin_desc *pins;
+	struct RTK119X_pinctrl *pctl;
+	int i, ret;
+
+	RTK_debug(KERN_ERR "[%s]  %s   %d \n ",__FILE__,__FUNCTION__, __LINE__);
+	pctl = devm_kzalloc(&pdev->dev, sizeof(*pctl), GFP_KERNEL);
+	if (!pctl)
+		return -ENOMEM;
+	platform_set_drvdata(pdev, pctl);
+
+	pctl->crt_membase = of_iomap(node, 0);
+	if (!pctl->crt_membase)
+		return -ENOMEM;
+
+	pctl->iso_membase = of_iomap(node, 1);
+	if (!pctl->iso_membase)
+		return -ENOMEM;
+
+	device = of_match_device(RTK119X_pinctrl_match, &pdev->dev);
+	if (!device)
+		return -ENODEV;
+
+	pctl->desc = (struct RTK119X_pinctrl_desc *)device->data;
+
+	ret = RTK119X_pinctrl_build_state(pdev);
+	if (ret) {
+		dev_err(&pdev->dev, "dt probe failed: %d\n", ret);
+		return ret;
+	}
+
+	pins = devm_kzalloc(&pdev->dev,
+			    pctl->desc->npins * sizeof(*pins),
+			    GFP_KERNEL);
+	if (!pins)
+		return -ENOMEM;
+
+	for (i = 0; i < pctl->desc->npins; i++)
+		pins[i] = pctl->desc->pins[i].pin;
+
+	RTK119X_pctrl_desc.name = dev_name(&pdev->dev);
+	RTK119X_pctrl_desc.owner = THIS_MODULE;
+	RTK119X_pctrl_desc.pins = pins;
+	RTK119X_pctrl_desc.npins = pctl->desc->npins;
+	pctl->dev = &pdev->dev;
+	pctl->pctl_dev = pinctrl_register(&RTK119X_pctrl_desc,
+					  &pdev->dev, pctl);
+	if (!pctl->pctl_dev) {
+		dev_err(&pdev->dev, "couldn't register pinctrl driver\n");
+		return -EINVAL;
+	}
+
+/*
+	pctl->chip = devm_kzalloc(&pdev->dev, sizeof(*pctl->chip), GFP_KERNEL);
+	if (!pctl->chip) {
+		ret = -ENOMEM;
+		goto pinctrl_error;
+	}
+
+	last_pin = pctl->desc->pins[pctl->desc->npins - 1].pin.number;
+
+
+	pctl->chip = &RTK119X_pinctrl_gpio_chip;
+	pctl->chip->ngpio = round_up(last_pin, PINS_PER_BANK);
+	pctl->chip->label = dev_name(&pdev->dev);
+	pctl->chip->dev = &pdev->dev;
+	pctl->chip->base = 0;
+
+	ret = gpiochip_add(pctl->chip);
+	if (ret)
+		goto pinctrl_error;
+*/
+
+/*TODO : gpio should add range to pinctrl   victor*/
+/*
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK119X_desc_pin *pin = pctl->desc->pins + i;
+
+		ret = gpiochip_add_pin_range(pctl->chip, dev_name(&pdev->dev),
+					     pin->pin.number,
+					     pin->pin.number, 1);
+		if (ret)
+			goto gpiochip_error;
+	}
+
+
+	clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(clk)) {
+		ret = PTR_ERR(clk);
+		goto gpiochip_error;
+	}
+
+	clk_prepare_enable(clk);
+
+	dev_info(&pdev->dev, "initialized rtk119x PIO driver\n");
+*/
+	return 0;
+/*
+gpiochip_error:
+	if (gpiochip_remove(pctl->chip))
+		dev_err(&pdev->dev, "failed to remove gpio chip\n");
+pinctrl_error:
+
+	pinctrl_unregister(pctl->pctl_dev);
+	return ret;
+*/
+}
+
+static struct platform_driver RTK119X_pinctrl_driver = {
+	.probe = RTK119X_pinctrl_probe,
+	.driver = {
+		.name = "rtk119x-pinctrl",
+		.owner = THIS_MODULE,
+		.of_match_table = RTK119X_pinctrl_match,
+	},
+};
+//early_platform_init("RTK119XPinctrlDriver", &RTK119X_pinctrl_driver);
+
+
+
+static int  rtk119x_pinctrl_init(void)
+{
+	return platform_driver_register(&RTK119X_pinctrl_driver);
+}
+postcore_initcall(rtk119x_pinctrl_init);
+//module_platform_driver(RTK119X_pinctrl_driver);
+//module_platform_driver(RTK119X_pinctrl_driver);
+
+MODULE_DESCRIPTION("RTK119x pinctrl driver");
+MODULE_LICENSE("GPL");
+
+
+
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd119x.h b/drivers/pinctrl/realtek/pinctrl-rtd119x.h
new file mode 100644
index 00000000..77e885b
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd119x.h
@@ -0,0 +1,706 @@
+/*
+ * Allwinner A1X SoCs pinctrl driver.
+ *
+ * Copyright (C) 2012 Maxime Ripard
+ *
+ * Maxime Ripard <maxime.ripard@free-electrons.com>
+ *
+ * This file is licensed under the terms of the GNU General Public
+ * License version 2.  This program is licensed "as is" without any
+ * warranty of any kind, whether express or implied.
+ */
+
+#ifndef __PINCTRL_RTK119X_H
+#define __PINCTRL_RTK119X_H
+
+#include <linux/kernel.h>
+
+#define P_CRT_BASE	0
+#define P_ISO_BASE	64
+
+
+//#define RTK_DEBUG
+#ifdef RTK_DEBUG
+#define RTK_debug(fmt, ...) printk(fmt, ##__VA_ARGS__)
+#else
+#define RTK_debug(fmt, ...) do {} while(0)
+#endif
+
+
+//////////////////////////////muxpad0////////////////////////////
+/*hole:0*/
+#define RTK_PINCTRL_PIN_PCRT_nf_rdy 				PINCTRL_PIN(P_CRT_BASE + 17,  	"nf_rdy")
+#define RTK_PINCTRL_PIN_PCRT_nf_rd_n 				PINCTRL_PIN(P_CRT_BASE + 18, 	"nf_rd_n")
+#define RTK_PINCTRL_PIN_PCRT_nf_wr_n 				PINCTRL_PIN(P_CRT_BASE + 19,  	"nf_wr_n")
+#define RTK_PINCTRL_PIN_PCRT_nf_ale 				PINCTRL_PIN(P_CRT_BASE + 20,  	"nf_ale")
+#define RTK_PINCTRL_PIN_PCRT_nf_cle 				PINCTRL_PIN(P_CRT_BASE + 21,  	"nf_cle")
+#define RTK_PINCTRL_PIN_PCRT_nf_ce_n_0 			PINCTRL_PIN(P_CRT_BASE + 22,  	"nf_ce_n_0")
+#define RTK_PINCTRL_PIN_PCRT_nf_ce_n_1 			PINCTRL_PIN(P_CRT_BASE + 23,  	"nf_ce_n_1")
+#define RTK_PINCTRL_PIN_PCRT_nf_dd_0 				PINCTRL_PIN(P_CRT_BASE + 9,  	"nf_dd_0")
+#define RTK_PINCTRL_PIN_PCRT_nf_dd_1 				PINCTRL_PIN(P_CRT_BASE + 10,  	"nf_dd_1")
+#define RTK_PINCTRL_PIN_PCRT_nf_dd_2 				PINCTRL_PIN(P_CRT_BASE + 11,  	"nf_dd_2")
+#define RTK_PINCTRL_PIN_PCRT_nf_dd_3 				PINCTRL_PIN(P_CRT_BASE + 12,  	"nf_dd_3")
+#define RTK_PINCTRL_PIN_PCRT_nf_dd_4 				PINCTRL_PIN(P_CRT_BASE + 13,  	"nf_dd_4")
+#define RTK_PINCTRL_PIN_PCRT_nf_dd_5 				PINCTRL_PIN(P_CRT_BASE + 14,  	"nf_dd_5")
+#define RTK_PINCTRL_PIN_PCRT_nf_dd_6 				PINCTRL_PIN(P_CRT_BASE + 15,  	"nf_dd_6")
+#define RTK_PINCTRL_PIN_PCRT_nf_dd_7 				PINCTRL_PIN(P_CRT_BASE + 16,  	"nf_dd_7")
+//////////////////////////////muxpad1////////////////////////////
+#define RTK_PINCTRL_PIN_PCRT_sdio_cmd 				PINCTRL_PIN(P_CRT_BASE + 37,  	"sdio_cmd")
+#define RTK_PINCTRL_PIN_PCRT_sdio_clk 				PINCTRL_PIN(P_CRT_BASE + 32,  	"sdio_clk")
+#define RTK_PINCTRL_PIN_PCRT_sdio_data_0 			PINCTRL_PIN(P_CRT_BASE + 33,  	"sdio_data_0")
+#define RTK_PINCTRL_PIN_PCRT_sdio_data_1 			PINCTRL_PIN(P_CRT_BASE + 34,  	"sdio_data_1")
+#define RTK_PINCTRL_PIN_PCRT_sdio_data_2 			PINCTRL_PIN(P_CRT_BASE + 35,  	"sdio_data_2")
+#define RTK_PINCTRL_PIN_PCRT_sdio_data_3 			PINCTRL_PIN(P_CRT_BASE + 36,  	"sdio_data_3")
+/*hole:22~23*/
+#define RTK_PINCTRL_PIN_PCRT_mmc_cmd 			PINCTRL_PIN(P_CRT_BASE + 29,  	"mmc_cmd")
+#define RTK_PINCTRL_PIN_PCRT_mmc_clk 				PINCTRL_PIN(P_CRT_BASE + 28,  	"mmc_clk")
+#define RTK_PINCTRL_PIN_PCRT_mmc_wp 				PINCTRL_PIN(P_CRT_BASE + 30,  	"mmc_wp")
+#define RTK_PINCTRL_PIN_PCRT_mmc_cd 				PINCTRL_PIN(P_CRT_BASE + 31,  	"mmc_cd")
+#define RTK_PINCTRL_PIN_PCRT_mmc_data_0 			PINCTRL_PIN(P_CRT_BASE + 24,  	"mmc_data_0")
+#define RTK_PINCTRL_PIN_PCRT_mmc_data_1 			PINCTRL_PIN(P_CRT_BASE + 25,  	"mmc_data_1")
+#define RTK_PINCTRL_PIN_PCRT_mmc_data_2 			PINCTRL_PIN(P_CRT_BASE + 26,  	"mmc_data_2")
+#define RTK_PINCTRL_PIN_PCRT_mmc_data_3 			PINCTRL_PIN(P_CRT_BASE + 27,  	"mmc_data_3")
+//////////////////////////////muxpad2////////////////////////////
+#define RTK_PINCTRL_PIN_PCRT_tp0_data 				PINCTRL_PIN(P_CRT_BASE + 44,  	"tp0_data")
+#define RTK_PINCTRL_PIN_PCRT_tp0_sync 				PINCTRL_PIN(P_CRT_BASE + 47,  	"tp0_sync")
+#define RTK_PINCTRL_PIN_PCRT_tp0_valid 				PINCTRL_PIN(P_CRT_BASE + 46,  	"tp0_valid")
+#define RTK_PINCTRL_PIN_PCRT_tp0_clk 				PINCTRL_PIN(P_CRT_BASE + 45,  	"tp0_clk")
+/*hole:36~39*/
+#define RTK_PINCTRL_PIN_PCRT_tp1_data 				PINCTRL_PIN(P_CRT_BASE + 40,  	"tp1_data")
+#define RTK_PINCTRL_PIN_PCRT_tp1_sync 				PINCTRL_PIN(P_CRT_BASE + 43,  	"tp1_sync")
+#define RTK_PINCTRL_PIN_PCRT_tp1_valid 				PINCTRL_PIN(P_CRT_BASE + 42,  	"tp1_valid")
+#define RTK_PINCTRL_PIN_PCRT_tp1_clk 				PINCTRL_PIN(P_CRT_BASE + 41,  	"tp1_clk")
+/*hole:44~47*/
+//////////////////////////////muxpad3////////////////////////////
+#define RTK_PINCTRL_PIN_PCRT_i2c_sda_1 			PINCTRL_PIN(P_CRT_BASE + 52,  	"i2c_sda_1")
+#define RTK_PINCTRL_PIN_PCRT_i2c_scl_1 				PINCTRL_PIN(P_CRT_BASE + 51,  	"i2c_scl_1")
+#define RTK_PINCTRL_PIN_PCRT_i2c_sda_4 			PINCTRL_PIN(P_CRT_BASE + 54,  	"i2c_sda_4")
+#define RTK_PINCTRL_PIN_PCRT_i2c_scl_4 				PINCTRL_PIN(P_CRT_BASE + 53,  	"i2c_scl_4")
+#define RTK_PINCTRL_PIN_PCRT_i2c_sda_5 			PINCTRL_PIN(P_CRT_BASE + 39,  	"i2c_sda_5")
+#define RTK_PINCTRL_PIN_PCRT_i2c_scl_5 				PINCTRL_PIN(P_CRT_BASE + 38,  	"i2c_scl_5")
+#define RTK_PINCTRL_PIN_PCRT_spdif 					PINCTRL_PIN(P_CRT_BASE + 50,  	"spdif")
+#define RTK_PINCTRL_PIN_PCRT_hdmi_hpd 			PINCTRL_PIN(P_CRT_BASE + 49,  	"hdmi_hpd")
+#define RTK_PINCTRL_PIN_PCRT_usb_id 				PINCTRL_PIN(P_CRT_BASE + 48,  	"usb_id")
+#define RTK_PINCTRL_PIN_PCRT_hi_loc 				PINCTRL_PIN(P_CRT_BASE + 60,  	"hi_loc")
+#define RTK_PINCTRL_PIN_PCRT_ejtag_scpu_loc 		PINCTRL_PIN(P_CRT_BASE + 61,  	"ejtag_scpu_loc")
+#define RTK_PINCTRL_PIN_PCRT_sensor_stb_1 			PINCTRL_PIN(P_CRT_BASE + 59,  	"sensor_stb_1")
+#define RTK_PINCTRL_PIN_PCRT_sensor_stb_0 			PINCTRL_PIN(P_CRT_BASE + 58,  	"sensor_stb_0")
+#define RTK_PINCTRL_PIN_PCRT_sensor_rst 			PINCTRL_PIN(P_CRT_BASE + 57,  	"sensor_rst")
+#define RTK_PINCTRL_PIN_PCRT_sensor_cko_1 		PINCTRL_PIN(P_CRT_BASE + 56,  	"sensor_cko_1")
+#define RTK_PINCTRL_PIN_PCRT_sensor_cko_0 		PINCTRL_PIN(P_CRT_BASE + 55,  	"sensor_cko_0")
+////////////////////////////muxpad4////////////////////////////
+#define RTK_PINCTRL_PIN_PCRT_gpio_0 				PINCTRL_PIN(P_CRT_BASE + 0,  	"gpio_0")
+#define RTK_PINCTRL_PIN_PCRT_gpio_1 				PINCTRL_PIN(P_CRT_BASE + 1,  	"gpio_1")
+#define RTK_PINCTRL_PIN_PCRT_gpio_2 				PINCTRL_PIN(P_CRT_BASE + 2,  	"gpio_2")
+#define RTK_PINCTRL_PIN_PCRT_gpio_3 				PINCTRL_PIN(P_CRT_BASE + 3,  	"gpio_3")
+#define RTK_PINCTRL_PIN_PCRT_gpio_4 				PINCTRL_PIN(P_CRT_BASE + 4,  	"gpio_4")
+#define RTK_PINCTRL_PIN_PCRT_gpio_5 				PINCTRL_PIN(P_CRT_BASE + 5,  	"gpio_5")
+#define RTK_PINCTRL_PIN_PCRT_gpio_6 				PINCTRL_PIN(P_CRT_BASE + 6,  	"gpio_6")
+#define RTK_PINCTRL_PIN_PCRT_gpio_7 				PINCTRL_PIN(P_CRT_BASE + 7,  	"gpio_7")
+#define RTK_PINCTRL_PIN_PCRT_gpio_8 				PINCTRL_PIN(P_CRT_BASE + 8,  	"gpio_8")
+//hole : 73~79
+////////////////////////////muxpad5////////////////////////////
+#define RTK_PINCTRL_PIN_PCRT_sf_en 				PINCTRL_PIN(P_CRT_BASE + 62,  	"sf_en")
+//#define RTK_PINCTRL_PIN_PCRT_arm_trace_dbg_en 	PINCTRL_PIN(P_CRT_BASE + 81,  	"arm_trace_dbg_en")
+#define RTK_PINCTRL_PIN_PCRT_ao_loc 				PINCTRL_PIN(P_CRT_BASE + 63,  	"ao_loc")
+//hole : 83~95
+////////////////////////////iso_muxpad0////////////////////////////
+#define RTK_PINCTRL_PIN_PISO_vfd_d 				PINCTRL_PIN(P_ISO_BASE + 6, 	"vfd_d")
+#define RTK_PINCTRL_PIN_PISO_vfd_clk 				PINCTRL_PIN(P_ISO_BASE + 5,  	"vfd_clk")
+#define RTK_PINCTRL_PIN_PISO_vfd_cs_n 				PINCTRL_PIN(P_ISO_BASE + 4, 	"vfd_cs_n")
+#define RTK_PINCTRL_PIN_PISO_ir_rx 					PINCTRL_PIN(P_ISO_BASE + 7,  	"ir_rx")
+#define RTK_PINCTRL_PIN_PISO_usb0 					PINCTRL_PIN(P_ISO_BASE + 2,  	"usb0")
+#define RTK_PINCTRL_PIN_PISO_usb1 					PINCTRL_PIN(P_ISO_BASE + 3,  	"usb1")
+#define RTK_PINCTRL_PIN_PISO_ur1_rx 				PINCTRL_PIN(P_ISO_BASE + 11,  	"ur1_rx")
+#define RTK_PINCTRL_PIN_PISO_ur1_tx 				PINCTRL_PIN(P_ISO_BASE + 12,  	"ur1_tx")
+#define RTK_PINCTRL_PIN_PISO_ur1_rts_n 			PINCTRL_PIN(P_ISO_BASE + 14,  	"ur1_rts_n")
+#define RTK_PINCTRL_PIN_PISO_ur1_cts_n 			PINCTRL_PIN(P_ISO_BASE + 13,  	"ur1_cts_n")
+#define RTK_PINCTRL_PIN_PISO_ur0_rx 				PINCTRL_PIN(P_ISO_BASE + 9,  	"ur0_rx")
+#define RTK_PINCTRL_PIN_PISO_ur0_tx 				PINCTRL_PIN(P_ISO_BASE + 10,  	"ur0_tx")
+#define RTK_PINCTRL_PIN_PISO_i2c_scl_0 				PINCTRL_PIN(P_ISO_BASE + 15,  	"i2c_scl_0")
+#define RTK_PINCTRL_PIN_PISO_i2c_sda_0 			PINCTRL_PIN(P_ISO_BASE + 16,  	"i2c_sda_0")
+#define RTK_PINCTRL_PIN_PISO_etn_led_link 			PINCTRL_PIN(P_ISO_BASE + 17,  	"etn_led_link")
+#define RTK_PINCTRL_PIN_PISO_etn_led_rxtx 			PINCTRL_PIN(P_ISO_BASE + 18,  	"etn_led_rxtx")
+////////////////////////////iso_muxpad1////////////////////////////
+#define RTK_PINCTRL_PIN_PISO_i2c_scl_6 				PINCTRL_PIN(P_ISO_BASE + 19,  	"i2c_scl_6")
+#define RTK_PINCTRL_PIN_PISO_i2c_sda_6 			PINCTRL_PIN(P_ISO_BASE + 20,  	"i2c_sda_6")
+#define RTK_PINCTRL_PIN_PISO_ir_tx 					PINCTRL_PIN(P_ISO_BASE + 8,  	"ir_tx")
+/*hole : 19~26*/
+#define RTK_PINCTRL_PIN_PISO_pwm_23_open_drain_switch PINCTRL_PIN(P_ISO_BASE + 21,  	"pwm_23_open_drain_switch")
+#define RTK_PINCTRL_PIN_PISO_pwm_01_open_drain_switch PINCTRL_PIN(P_ISO_BASE + 22,  	"pwm_01_open_drain_switch")
+#define RTK_PINCTRL_PIN_PISO_ur1_loc 				PINCTRL_PIN(P_ISO_BASE + 23,  	"ur1_loc")
+#define RTK_PINCTRL_PIN_PISO_ejtag_avcpu_loc 		PINCTRL_PIN(P_ISO_BASE + 24,  	"ejtag_avcpu_loc")
+#define RTK_PINCTRL_PIN_PISO_ai_loc					PINCTRL_PIN(P_ISO_BASE + 25,  	"ai_loc")
+#define RTK_PINCTRL_PIN_PISO_iso_gpio0					PINCTRL_PIN(P_ISO_BASE + 0,  	"iso_gpio0")
+#define RTK_PINCTRL_PIN_PISO_iso_gpio1					PINCTRL_PIN(P_ISO_BASE + 1,  	"iso_gpio1")
+
+
+
+
+struct rtk119x_pin_regmap{
+	u16 pmux_regoff;
+	u16 pmux_regbit;
+	u16 pmux_regbitmsk;
+	u16 pcof_regoff;
+	u16 pcof_regbit;
+	u16 pcof_cur_strgh;//0 : 2&4mA   1:4&8mA
+};
+
+#define PADDRI_4_8 1
+#define PADDRI_2_4 0
+#define PADDRI_UNSUPPORT 0xFFFF
+
+#define PCOF_UNSUPPORT 0xFFFF
+
+static const struct rtk119x_pin_regmap pin_regmap[] = {
+	{.pmux_regoff=0x370, 	.pmux_regbit=0, .pmux_regbitmsk=0x7,	.pcof_regoff=0x398, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 0,  	"gpio_0")
+	{.pmux_regoff=0x370, 	.pmux_regbit=3, .pmux_regbitmsk=0x7,	.pcof_regoff=0x398, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 1,  	"gpio_1")
+	{.pmux_regoff=0x370, 	.pmux_regbit=6, .pmux_regbitmsk=0x7,	.pcof_regoff=0x398, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 2,  	"gpio_2")
+	{.pmux_regoff=0x370, 	.pmux_regbit=9, .pmux_regbitmsk=0x7,	.pcof_regoff=0x398, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 3,  	"gpio_3")
+	{.pmux_regoff=0x370, 	.pmux_regbit=12, .pmux_regbitmsk=0x3,	.pcof_regoff=0x398, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 4,  	"gpio_4")
+	{.pmux_regoff=0x370, 	.pmux_regbit=14, .pmux_regbitmsk=0x3,	.pcof_regoff=0x398, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 5,  	"gpio_5")
+	{.pmux_regoff=0x370, 	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x398, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 6,  	"gpio_6")
+	{.pmux_regoff=0x370, 	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x398, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 7,  	"gpio_7")
+	{.pmux_regoff=0x370, 	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x39c, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 8,  	"gpio_8")
+	{.pmux_regoff=0x360, 	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x37c, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 9,  	"nf_dd_0")
+	{.pmux_regoff=0x360, 	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x37c, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 10,  	"nf_dd_1")
+	{.pmux_regoff=0x360, 	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x37c, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 11,  	"nf_dd_2")
+	{.pmux_regoff=0x360, 	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x37c, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 12,  	"nf_dd_3")
+	{.pmux_regoff=0x360, 	.pmux_regbit=24, .pmux_regbitmsk=0x3,	.pcof_regoff=0x37c, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 13,  	"nf_dd_4")
+	{.pmux_regoff=0x360, 	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=0x37c, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 14,  	"nf_dd_5")
+	{.pmux_regoff=0x360, 	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=0x37c, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 15,  	"nf_dd_6")
+	{.pmux_regoff=0x360, 	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=0x37c, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 16,  	"nf_dd_7")
+	{.pmux_regoff=0x360, 	.pmux_regbit=2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x378, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 17,  	"nf_rdy")
+	{.pmux_regoff=0x360, 	.pmux_regbit=4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x378, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 18, 	"nf_rd_n")
+	{.pmux_regoff=0x360, 	.pmux_regbit=6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x378, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 19,  	"nf_wr_n")
+	{.pmux_regoff=0x360, 	.pmux_regbit=8, .pmux_regbitmsk=0x3,	.pcof_regoff=0x378, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 20,  	"nf_ale")
+	{.pmux_regoff=0x360, 	.pmux_regbit=10, .pmux_regbitmsk=0x3,	.pcof_regoff=0x378, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 21,  	"nf_cle")
+	{.pmux_regoff=0x360, 	.pmux_regbit=12, .pmux_regbitmsk=0x3,	.pcof_regoff=0x378, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 22,  	"nf_ce_n_0")
+	{.pmux_regoff=0x360, 	.pmux_regbit=14, .pmux_regbitmsk=0x3,	.pcof_regoff=0x378, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 23,  	"nf_ce_n_1")
+	{.pmux_regoff=0x364, 	.pmux_regbit=24, .pmux_regbitmsk=0x3,	.pcof_regoff=0x380, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 24,  	"mmc_data_0")
+	{.pmux_regoff=0x364, 	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=0x380, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 25,  	"mmc_data_1")
+	{.pmux_regoff=0x364, 	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=0x380, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 26,  	"mmc_data_2")
+	{.pmux_regoff=0x364, 	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=0x380, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 27,  	"mmc_data_3")
+	{.pmux_regoff=0x364, 	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x380, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 28,  	"mmc_clk")
+	{.pmux_regoff=0x364, 	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x380, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 29,  	"mmc_cmd")
+	{.pmux_regoff=0x364, 	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x380, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 30,  	"mmc_wp")
+	{.pmux_regoff=0x364, 	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x380, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 31,  	"mmc_cd")
+	{.pmux_regoff=0x364, 	.pmux_regbit=2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x384, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 32,  	"sdio_clk")
+	{.pmux_regoff=0x364, 	.pmux_regbit=4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x384, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 33,  	"sdio_data_0")
+	{.pmux_regoff=0x364, 	.pmux_regbit=6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x384, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 34,  	"sdio_data_1")
+	{.pmux_regoff=0x364, 	.pmux_regbit=8, .pmux_regbitmsk=0x3,	.pcof_regoff=0x384, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 35,  	"sdio_data_2")
+	{.pmux_regoff=0x364, 	.pmux_regbit=10, .pmux_regbitmsk=0x3,	.pcof_regoff=0x384, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 36,  	"sdio_data_3")
+	{.pmux_regoff=0x364, 	.pmux_regbit=0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x384, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 37,  	"sdio_cmd")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=10, .pmux_regbitmsk=0x3,	.pcof_regoff=0x394, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 38,  	"i2c_scl_5")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=8, .pmux_regbitmsk=0x3,	.pcof_regoff=0x394, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 39,  	"i2c_sda_5")
+	{.pmux_regoff=0x368, 	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x390, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 40,  	"tp1_data")
+	{.pmux_regoff=0x368, 	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x390, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 41,  	"tp1_clk")
+	{.pmux_regoff=0x368, 	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x390, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 42,  	"tp1_valid")
+	{.pmux_regoff=0x368, 	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x390, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 43,  	"tp1_sync")
+	{.pmux_regoff=0x368, 	.pmux_regbit=0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x38c, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 44,  	"tp0_data")
+	{.pmux_regoff=0x368, 	.pmux_regbit=6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x38c, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 45,  	"tp0_clk")
+	{.pmux_regoff=0x368, 	.pmux_regbit=4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x38c, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 46,  	"tp0_valid")
+	{.pmux_regoff=0x368, 	.pmux_regbit=2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x38c, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 47,  	"tp0_sync")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x39c, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 48,  	"usb_id")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=14, .pmux_regbitmsk=0x3,	.pcof_regoff=0x39c, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 49,  	"hdmi_hpd")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=12, .pmux_regbitmsk=0x3,	.pcof_regoff=0x388, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 50,  	"spdif")		//NO SMT
+	{.pmux_regoff=0x36c, 	.pmux_regbit=2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x394, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 51,  	"i2c_scl_1")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x394, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 52,  	"i2c_sda_1")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x394, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 53,  	"i2c_scl_4")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x394, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_4_8}, //(P_CRT_BASE + 54,  	"i2c_sda_4")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=0x39c, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 55,  	"sensor_cko_0")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=0x39c, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 56,  	"sensor_cko_1")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=0x39c, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 57,  	"sensor_rst")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=24, .pmux_regbitmsk=0x3,	.pcof_regoff=0x39c, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 58,  	"sensor_stb_0")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x39c, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_CRT_BASE + 59,  	"sensor_stb_1")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_CRT_BASE + 60,  	"hi_loc")
+	{.pmux_regoff=0x36c, 	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_CRT_BASE + 61,  	"ejtag_scpu_loc")
+	{.pmux_regoff=0x374, 	.pmux_regbit=0, .pmux_regbitmsk=0x1,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_CRT_BASE + 62,  	"sf_en")
+	{.pmux_regoff=0x374, 	.pmux_regbit=2, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_CRT_BASE + 63,  	"ao_loc")
+
+	////////////////////////////iso_muxpad0////////////////////////////
+	{.pmux_regoff=0x0, 	.pmux_regbit=0, .pmux_regbitmsk=0x0,	.pcof_regoff=0x0, .pcof_regbit=0, .pcof_cur_strgh = 0},//(P_ISO_BASE + 0,  	"gpio0")
+	{.pmux_regoff=0x0, 	.pmux_regbit=0, .pmux_regbitmsk=0x0,	.pcof_regoff=0x0, .pcof_regbit=0, .pcof_cur_strgh = 0},//(P_ISO_BASE + 1,  	"gpio1)
+	{.pmux_regoff=0x310, 	.pmux_regbit=8, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 2,  	"usb0")
+	{.pmux_regoff=0x310, 	.pmux_regbit=10, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 3,  	"usb1")
+	{.pmux_regoff=0x310, 	.pmux_regbit=4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 4, 	"vfd_cs_n")
+	{.pmux_regoff=0x310, 	.pmux_regbit=2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 5,  	"vfd_clk")
+	{.pmux_regoff=0x310, 	.pmux_regbit=0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 6, 	"vfd_d")
+	{.pmux_regoff=0x310, 	.pmux_regbit=6, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 7,  	"ir_rx")
+	{.pmux_regoff=0x314, 	.pmux_regbit=4, .pmux_regbitmsk=0x3,	.pcof_regoff=0x308, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 8,  	"ir_tx")
+	{.pmux_regoff=0x310, 	.pmux_regbit=20, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 9,  	"ur0_rx")
+	{.pmux_regoff=0x310, 	.pmux_regbit=22, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=20, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 10,  	"ur0_tx")
+	{.pmux_regoff=0x310, 	.pmux_regbit=12, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 11,  	"ur1_rx")
+	{.pmux_regoff=0x310, 	.pmux_regbit=14, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 12,  	"ur1_tx")
+	{.pmux_regoff=0x310, 	.pmux_regbit=18, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 13,  	"ur1_cts_n")
+	{.pmux_regoff=0x310, 	.pmux_regbit=16, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=8, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 14,  	"ur1_rts_n")
+	{.pmux_regoff=0x310, 	.pmux_regbit=24, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 15,  	"i2c_scl_0")
+	{.pmux_regoff=0x310, 	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=0x300, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 16,  	"i2c_sda_0")
+	{.pmux_regoff=0x310, 	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=24, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 17,  	"etn_led_link")
+	{.pmux_regoff=0x310, 	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=0x304, .pcof_regbit=28, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 18,  	"etn_led_rxtx")
+	{.pmux_regoff=0x314, 	.pmux_regbit=0, .pmux_regbitmsk=0x3,	.pcof_regoff=0x308, .pcof_regbit=16, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 19,  	"i2c_scl_6")
+	{.pmux_regoff=0x314, 	.pmux_regbit=2, .pmux_regbitmsk=0x3,	.pcof_regoff=0x308, .pcof_regbit=12, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 20,  	"i2c_sda_6")
+	{.pmux_regoff=0x314, 	.pmux_regbit=24, .pmux_regbitmsk=0x1,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_ISO_BASE + 21,  	"pwm_23_open_drain_switch")
+	{.pmux_regoff=0x314, 	.pmux_regbit=25, .pmux_regbitmsk=0x1,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_ISO_BASE + 22,  	"pwm_01_open_drain_switch")
+	{.pmux_regoff=0x314, 	.pmux_regbit=26, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_ISO_BASE + 23,  	"ur1_loc")
+	{.pmux_regoff=0x314, 	.pmux_regbit=28, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_ISO_BASE + 24,  	"ejtag_avcpu_loc")
+	{.pmux_regoff=0x314, 	.pmux_regbit=30, .pmux_regbitmsk=0x3,	.pcof_regoff=PCOF_UNSUPPORT, .pcof_regbit=0, .pcof_cur_strgh = 0}, //(P_ISO_BASE + 25,  	"ai_loc")
+};
+
+
+#define RTK119X_PCONF_SCHM 3
+#define RTK119X_PCONF_CURR 2
+#define RTK119X_PCONF_PULEN 1
+#define RTK119X_PCONF_PULSEL 0
+
+/*
+
+#define RTK119X_PIN_NAME_MAX_LEN	5
+
+#define BANK_MEM_SIZE		0x24
+#define MUX_REGS_OFFSET	0x0
+#define DATA_REGS_OFFSET	0x10
+#define DLEVEL_REGS_OFFSET	0x14
+#define PULL_REGS_OFFSET	0x1c
+*/
+
+#define PINS_OF_CRTBANK			64
+#define MUX_PINS_PER_REG			16
+#define MUX_PINS_NUMBER_MASK				0xffff0000
+#define MUX_PINS_NUMBER_MASK_OFF			16
+#define MUX_REG_BITNUM_MASK			0x0000ff00
+#define MUX_REG_BITNUM_MASK_OFF			8
+#define MUX_REG_BITOFF_MASK			0x000000ff
+
+
+
+
+/*
+#define MUX_PINS_BITS		4
+#define MUX_PINS_MASK		0x0f
+#define DATA_PINS_PER_REG	32
+#define DATA_PINS_BITS		1
+#define DATA_PINS_MASK		0x01
+#define DLEVEL_PINS_PER_REG	16
+#define DLEVEL_PINS_BITS	2
+#define DLEVEL_PINS_MASK	0x03
+#define PULL_PINS_PER_REG	16
+#define PULL_PINS_BITS		2
+#define PULL_PINS_MASK		0x03
+*/
+struct RTK119X_desc_function {
+	const char	*name;
+	u8		muxval;
+};
+
+struct RTK119X_desc_pin {
+	struct pinctrl_pin_desc		pin;
+	struct RTK119X_desc_function	*functions;
+};
+
+struct RTK119X_pinctrl_desc {
+	const struct RTK119X_desc_pin	*pins;
+	int				npins;
+	struct pinctrl_gpio_range	*ranges;
+	int				nranges;
+};
+
+struct RTK119X_pinctrl_function {
+	const char	*name;
+	const char	**groups;
+	unsigned	ngroups;
+};
+
+struct RTK119X_pinctrl_group {
+	const char	*name;
+	unsigned long	config;
+	unsigned	pin;
+};
+
+struct RTK119X_pinctrl {
+	void __iomem			*crt_membase;
+	void __iomem			*iso_membase;
+//	struct gpio_chip		*chip;
+	struct RTK119X_pinctrl_desc	*desc;
+	struct device			*dev;
+	struct RTK119X_pinctrl_function	*functions;
+	unsigned			nfunctions;
+	struct RTK119X_pinctrl_group	*groups;
+	unsigned			ngroups;
+	struct pinctrl_dev		*pctl_dev;
+};
+
+#define RTK119X_PIN(_pin, ...)					\
+	{							\
+		.pin = _pin,					\
+		.functions = (struct RTK119X_desc_function[]){	\
+			__VA_ARGS__, { } },			\
+	}
+
+#define RTK119X_FUNCTION(_val, _name)				\
+	{							\
+		.name = _name,					\
+		.muxval = _val,					\
+	}
+
+
+static const struct RTK119X_desc_pin rtk119x_pins[] = {
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_gpio_0,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "uart1_loc_misc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x4, "gspi")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_gpio_1,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "uart1_loc_misc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x4, "gspi")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_gpio_2,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "uart1_loc_misc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x4, "gspi")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_gpio_3,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "uart1_loc_misc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x4, "gspi")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_gpio_4,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_misc"),
+		RTK119X_FUNCTION(0x3, "ao_loc_misc")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_gpio_5,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_misc"),
+		RTK119X_FUNCTION(0x3, "ao_loc_misc")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_gpio_6,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_misc"),
+		RTK119X_FUNCTION(0x3, "ao_loc_misc")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_gpio_7,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_misc"),
+		RTK119X_FUNCTION(0x3, "ao_loc_misc")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_gpio_8,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_misc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_dd_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_dd_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_dd_2,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_dd_3,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_dd_4,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_dd_5,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_dd_6,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_dd_7,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_rdy,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_rd_n,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_wr_n,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_ale,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_cle,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "hif_loc_nf")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_ce_n_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_nf_ce_n_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_mmc_data_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_mmc_data_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_mmc_data_2,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_mmc_data_3,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_mmc_clk,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_mmc_cmd,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_mmc_wp,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc"),
+		RTK119X_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_mmc_cd,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "mmc")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sdio_clk,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sdio_data_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sdio_data_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sdio_data_2,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sdio_data_3,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sdio_cmd,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sdio")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_i2c_scl_5,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c5"),
+		RTK119X_FUNCTION(0x3, "nand")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_i2c_sda_5,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c5"),
+		RTK119X_FUNCTION(0x3, "nand")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_tp1_data,
+		RTK119X_FUNCTION(0x0, "tp1"),
+		RTK119X_FUNCTION(0x1, "tp0"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "i2c3")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_tp1_clk,
+		RTK119X_FUNCTION(0x0, "tp1"),
+		RTK119X_FUNCTION(0x1, "tp0"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "i2c2")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_tp1_valid,
+		RTK119X_FUNCTION(0x0, "tp1"),
+		RTK119X_FUNCTION(0x1, "tp0"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "i2c3")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_tp1_sync,
+		RTK119X_FUNCTION(0x0, "tp1"),
+		RTK119X_FUNCTION(0x1, "tp0"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "i2c2")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_tp0_data,
+		RTK119X_FUNCTION(0x0, "tp0"),
+		RTK119X_FUNCTION(0x1, "tp1"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "ao_loc_tp")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_tp0_clk,
+		RTK119X_FUNCTION(0x0, "tp0"),
+		RTK119X_FUNCTION(0x1, "tp1"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "ao_loc_tp")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_tp0_valid,
+		RTK119X_FUNCTION(0x0, "tp0"),
+		RTK119X_FUNCTION(0x1, "tp1"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "ao_loc_tp")),
+	RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_tp0_sync,
+		RTK119X_FUNCTION(0x0, "tp0"),
+		RTK119X_FUNCTION(0x1, "tp1"),
+		RTK119X_FUNCTION(0x2, "gpio"),
+		RTK119X_FUNCTION(0x3, "ao_loc_tp")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_usb_id,
+		RTK119X_FUNCTION(0x1, "gpio"),
+		RTK119X_FUNCTION(0x2, "cpu_loop")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_hdmi_hpd,
+		RTK119X_FUNCTION(0x1, "gpio")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_spdif,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "spdif")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_i2c_scl_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c1")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_i2c_sda_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c1")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_i2c_scl_4,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c4")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_i2c_sda_4,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c4")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sensor_cko_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sensor")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sensor_cko_1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "sensor"),
+		RTK119X_FUNCTION(0x3, "usb")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sensor_rst,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sensor_stb_0,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sensor_stb_1,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_hi_loc,
+		RTK119X_FUNCTION(0x1, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x2, "hif_loc_nf")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_ejtag_scpu_loc,
+		RTK119X_FUNCTION(0x1, "scpu_ejtag_loc_misc"),
+		RTK119X_FUNCTION(0x2, "scpu_ejtag_loc_cr")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_sf_en,
+		RTK119X_FUNCTION(0x0, "uart1_loc_misc"),
+		RTK119X_FUNCTION(0x0, "hif_loc_misc"),
+		RTK119X_FUNCTION(0x0, "gspi"),
+		RTK119X_FUNCTION(0x1, "spi")),
+/*	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_arm_trace_dbg_en,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "jtag")),*/
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PCRT_ao_loc,
+		RTK119X_FUNCTION(0x1, "ao_loc_tp"),
+		RTK119X_FUNCTION(0x2, "ao_loc_misc")),
+//////////iso pinmux////////////////
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio0,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_iso_gpio1,
+		RTK119X_FUNCTION(0x0, "gpio")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_usb0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "standby_dbg"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_usb"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_iso")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_usb1,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "standby_dbg"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_usb"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_iso")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_vfd_cs_n,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "vfd"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_usb"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_iso")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_vfd_clk,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "vfd"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_usb"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_iso")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_vfd_d,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "vfd"),
+		RTK119X_FUNCTION(0x2, "i2c2"),
+		RTK119X_FUNCTION(0x3, "avcpu_ejtag_loc_iso")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ir_rx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "irrx"),
+		RTK119X_FUNCTION(0x2, "standby_dbg")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ir_tx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "irtx"),
+		RTK119X_FUNCTION(0x2, "i2c3")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur0_rx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart0"),
+		RTK119X_FUNCTION(0x2, "pwm")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur0_tx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart0"),
+		RTK119X_FUNCTION(0x2, "pwm")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur1_rx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart1_loc_iso"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_ur"),
+		RTK119X_FUNCTION(0x3, "pwm")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur1_tx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart1_loc_iso"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_ur"),
+		RTK119X_FUNCTION(0x3, "pwm")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur1_cts_n,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart1_loc_iso"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_ur")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur1_rts_n,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "uart1_loc_iso"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_ur")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_i2c_scl_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c0")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_i2c_sda_0,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c0")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_etn_led_link,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "etn_led"),
+		RTK119X_FUNCTION(0x2, "pwm")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_etn_led_rxtx,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "etn_led"),
+		RTK119X_FUNCTION(0x2, "pwm")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_i2c_scl_6,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c6")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_i2c_sda_6,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "i2c6")),
+/*	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_pwm_23_open_drain_switch,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "jtag")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_pwm_01_open_drain_switch,
+		RTK119X_FUNCTION(0x0, "gpio"),
+		RTK119X_FUNCTION(0x1, "nand"),
+		RTK119X_FUNCTION(0x2, "emmc"),
+		RTK119X_FUNCTION(0x3, "jtag")),*/
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ur1_loc,
+		RTK119X_FUNCTION(0x1, "uart1_loc_iso"),
+		RTK119X_FUNCTION(0x2, "uart1_loc_misc")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ejtag_avcpu_loc,
+		RTK119X_FUNCTION(0x1, "avcpu_ejtag_loc_iso"),
+		RTK119X_FUNCTION(0x2, "avcpu_ejtag_loc_nf")),
+	 RTK119X_PIN(RTK_PINCTRL_PIN_PISO_ai_loc,
+		RTK119X_FUNCTION(0x1, "ai_loc_iso_ur"),
+		RTK119X_FUNCTION(0x2, "ai_loc_iso_usb")),
+};
+
+#endif /* __PINCTRL_RTK119X_H */
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd129x.c b/drivers/pinctrl/realtek/pinctrl-rtd129x.c
new file mode 100644
index 00000000..e975dc9
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd129x.c
@@ -0,0 +1,933 @@
+/*
+ * Realtek pin controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include "pinctrl-rtd129x.h"
+
+#include <linux/io.h>
+#include <linux/clk.h>
+#include <linux/gpio.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/pinctrl/consumer.h>
+#include <linux/pinctrl/machine.h>
+#include <linux/pinctrl/pinctrl.h>
+#include <linux/pinctrl/pinconf-generic.h>
+#include <linux/pinctrl/pinmux.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+
+#include "../core.h"
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+static u32 *pinctrl_reg_values;
+
+static const struct RTK_pinctrl_desc rtk129x_pinctrl_data = {
+	.pins = rtk_pins,
+	.npins = ARRAY_SIZE(rtk_pins),
+};
+
+static void RTK_pmx_set(struct pinctrl_dev *pctldev,
+		unsigned int pin, u8 config)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	void __iomem *addr;
+	u32 val;
+	u32 mask;
+
+	if (pin_regmap[pin].pmux_regoff == PMUX_UNSUPPORT)
+		return;
+
+	switch (pin_regmap[pin].pmux_base) {
+	case PMUX_BASE_SB2:
+		addr = pctl->sb2_membase + pin_regmap[pin].pmux_regoff;
+		break;
+	case PMUX_BASE_DISP:
+		addr = pctl->disp_membase + pin_regmap[pin].pmux_regoff;
+		break;
+	case PMUX_BASE_CR:
+		addr = pctl->cr_membase + pin_regmap[pin].pmux_regoff;
+		break;
+	case PMUX_BASE_ISO:
+		addr = pctl->iso_membase + pin_regmap[pin].pmux_regoff;
+		break;
+	default:
+		RTK_PINCTRL_ERR("[%s] Unknow pmux_base", __func__);
+		return;
+	}
+
+
+	RTK_PINCTRL_DBG("[%s] Addr(0x%08llx), bit=%u, config=%u",
+			__func__, (u64)addr, pin_regmap[pin].pmux_regbit,
+			config);
+
+	val = readl(addr);
+	mask =	pin_regmap[pin].pmux_regbitmsk << pin_regmap[pin].pmux_regbit;
+	writel(((val & ~mask) |
+		(config << pin_regmap[pin].pmux_regbit)),  addr);
+
+	RTK_PINCTRL_DBG("[%s] Addr(0x%08llx) final_val=0x%08x",
+			__func__, (u64)addr, readl(addr));
+
+}
+
+static struct RTK_pinctrl_group *
+RTK_pinctrl_find_group_by_name(struct RTK_pinctrl *pctl, const char *group)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s] name = %s", __func__, group);
+	for (i = 0; i < pctl->ngroups; i++) {
+		struct RTK_pinctrl_group *grp = pctl->groups + i;
+
+		if (!strcmp(grp->name, group))
+			return grp;
+	}
+
+	return NULL;
+}
+
+static struct RTK_pinctrl_function *
+RTK_pinctrl_find_function_by_name(struct RTK_pinctrl *pctl,
+				    const char *name)
+{
+	struct RTK_pinctrl_function *func = pctl->functions;
+	int i;
+//	RTK_PINCTRL_DBG("[%s]", __func__);
+	for (i = 0; i < pctl->nfunctions; i++) {
+		if (!func[i].name)
+			break;
+
+		if (!strcmp(func[i].name, name))
+			return func + i;
+	}
+
+	return NULL;
+}
+
+static struct RTK_desc_function *
+RTK_pinctrl_desc_find_function_by_name(struct RTK_pinctrl *pctl,
+					 const char *pin_name,
+					 const char *func_name)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s] pin_name=%s, func_name=%s",
+			__func__, pin_name, func_name);
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+
+		if (!strcmp(pin->pin.name, pin_name)) {
+			struct RTK_desc_function *func = pin->functions;
+
+			while (func->name) {
+				if (!strcmp(func->name, func_name))
+					return func;
+
+				func++;
+			}
+		}
+	}
+
+	return NULL;
+}
+
+static int RTK_pctrl_get_groups_count(struct pinctrl_dev *pctldev)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] pctl->ngroups=%d", __func__, pctl->ngroups);
+	return pctl->ngroups;
+}
+
+static const char *RTK_pctrl_get_group_name(struct pinctrl_dev *pctldev,
+					      unsigned int group)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	//RTK_PINCTRL_DBG("[%s] group.name=%s",
+	//	__func__, pctl->groups[group].name);
+	return pctl->groups[group].name;
+}
+
+static int RTK_pctrl_get_group_pins(struct pinctrl_dev *pctldev,
+				      unsigned int group,
+				      const unsigned int **pins,
+				      unsigned int *num_pins)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*pins = (unsigned int *)&pctl->groups[group].pin;
+	*num_pins = 1;
+
+	return 0;
+}
+
+static int RTK_pctrl_dt_node_to_map(struct pinctrl_dev *pctldev,
+				      struct device_node *node,
+				      struct pinctrl_map **map,
+				      unsigned int *num_maps)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	unsigned long *pinconfig;
+	struct property *prop;
+	const char *function;
+	const char *group;
+	int ret, nmaps, i = 0;
+	u32 val;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+
+	*map = NULL;
+	*num_maps = 0;
+
+	ret = of_property_read_string(node, "realtek,function", &function);
+	if (ret) {
+		printk(
+			"missing realtek,function property in node %s\n",
+			node->name);
+		return -EINVAL;
+	}
+
+	nmaps = of_property_count_strings(node, "realtek,pins") * 2;
+	if (nmaps < 0) {
+		printk(
+			"missing realtek,pins property in node %s\n",
+			node->name);
+		return -EINVAL;
+	}
+
+	*map = kmalloc_array(nmaps, sizeof(struct pinctrl_map), GFP_KERNEL);
+	if (!map)
+		return -ENOMEM;
+
+	of_property_for_each_string(node, "realtek,pins", prop, group) {
+		struct RTK_pinctrl_group *grp =
+			RTK_pinctrl_find_group_by_name(pctl, group);
+		int j = 0, configlen = 0;
+
+		if (!grp) {
+			printk("unknown pin %s", group);
+			continue;
+		}
+		if (!RTK_pinctrl_desc_find_function_by_name(pctl,
+							      grp->name,
+							      function)) {
+			printk("unsupported function %s on pin %s",
+				function, group);
+			continue;
+		}
+
+		(*map)[i].type = PIN_MAP_TYPE_MUX_GROUP;
+		(*map)[i].data.mux.group = group;
+		(*map)[i].data.mux.function = function;
+
+		i++;
+
+		(*map)[i].type = PIN_MAP_TYPE_CONFIGS_GROUP;
+		(*map)[i].data.configs.group_or_pin = group;
+
+		if (of_find_property(node, "realtek,schmitt", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,drive", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,pull_en", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,pull_sel", NULL))
+			configlen++;
+
+		RTK_PINCTRL_DBG("[%s] configlen %d", __func__, configlen);
+
+		if (configlen) {
+			pinconfig = kcalloc(configlen, sizeof(*pinconfig),
+					GFP_KERNEL);
+		} else {
+			// Prevent failed to register map default
+			configlen = 1;
+			pinconfig = kzalloc(1 * sizeof(*pinconfig), GFP_KERNEL);
+			pinconfig[j++] = pinconf_to_config_packed(
+					PIN_CONFIG_END, 0);
+		}
+
+		if (!of_property_read_u32(node, "realtek,schmitt", &val)) {
+			u16 schmitt_enable;
+
+			if (val == 0)
+				schmitt_enable = 0;
+			else
+				schmitt_enable = 1;
+
+			pinconfig[j++] = pinconf_to_config_packed(
+					PIN_CONFIG_INPUT_SCHMITT_ENABLE,
+					schmitt_enable);
+		}
+
+		if (!of_property_read_u32(node, "realtek,drive", &val))
+			pinconfig[j++] = pinconf_to_config_packed(
+					PIN_CONFIG_DRIVE_STRENGTH, val);
+
+		if (!of_property_read_u32(node, "realtek,pull_en", &val)) {
+			enum pin_config_param pull = PIN_CONFIG_END;
+
+			if (val == 0)
+				pull = PIN_CONFIG_BIAS_DISABLE;
+			else if (val == 1)
+				pull = PIN_CONFIG_DRIVE_PUSH_PULL;
+			pinconfig[j++] = pinconf_to_config_packed(pull, 0);
+		}
+
+		if (!of_property_read_u32(node, "realtek,pull_sel", &val)) {
+			enum pin_config_param pull = PIN_CONFIG_END;
+
+			if (val == 0)
+				pull = PIN_CONFIG_BIAS_PULL_DOWN;
+			else if (val == 1)
+				pull = PIN_CONFIG_BIAS_PULL_UP;
+			pinconfig[j++] = pinconf_to_config_packed(pull, 1);
+		}
+
+		(*map)[i].data.configs.configs = pinconfig;
+		(*map)[i].data.configs.num_configs = configlen;
+
+		i++;
+	}
+
+	*num_maps = nmaps;
+
+	return 0;
+}
+
+static void RTK_pctrl_dt_free_map(struct pinctrl_dev *pctldev,
+				    struct pinctrl_map *map,
+				    unsigned int num_maps)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	for (i = 0; i < num_maps; i++) {
+		if (map[i].type == PIN_MAP_TYPE_CONFIGS_GROUP)
+			kfree(map[i].data.configs.configs);
+	}
+
+	kfree(map);
+}
+
+static const struct pinctrl_ops RTK_pctrl_ops = {
+	.dt_node_to_map		= RTK_pctrl_dt_node_to_map,
+	.dt_free_map		= RTK_pctrl_dt_free_map,
+	.get_groups_count	= RTK_pctrl_get_groups_count,
+	.get_group_name		= RTK_pctrl_get_group_name,
+	.get_group_pins		= RTK_pctrl_get_group_pins,
+};
+
+static int RTK_pconf_parse_conf(struct pinctrl_dev *pctldev,
+	unsigned int pin, enum pin_config_param param,
+	enum pin_config_param arg)
+{
+	void __iomem *addr;
+	u8 set_val;
+	u16 strength;
+	u32 val, mask;
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] pin=%u, config_param=%u, config_argument=%u",
+			__func__, pin, param, arg);
+
+	if (pin_regmap[pin].pcof_regoff == PCOF_UNSUPPORT)
+		return 0;
+
+	switch (pin_regmap[pin].pmux_base) {
+	case PMUX_BASE_SB2:
+		addr = pctl->sb2_membase + pin_regmap[pin].pcof_regoff;
+		break;
+	case PMUX_BASE_DISP:
+		addr = pctl->disp_membase + pin_regmap[pin].pcof_regoff;
+		break;
+	case PMUX_BASE_CR:
+		addr = pctl->cr_membase + pin_regmap[pin].pcof_regoff;
+		break;
+	case PMUX_BASE_ISO:
+		addr = pctl->iso_membase + pin_regmap[pin].pcof_regoff;
+		break;
+	default:
+		RTK_PINCTRL_ERR("[%s] Unknow pmux_base\n", __func__);
+		return -EINVAL;
+	}
+
+
+	switch (param) {
+	case PIN_CONFIG_INPUT_SCHMITT:
+		break;
+	case PIN_CONFIG_INPUT_SCHMITT_ENABLE:
+		set_val = arg;
+		if (set_val)
+			set_val = 1;
+		else
+			set_val = 0;
+
+		val = readl(addr);
+		mask =	1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_SCHM);
+		writel(((val & ~mask) |
+			(set_val<<(pin_regmap[pin].pcof_regbit +
+			RTK_PCONF_SCHM))), addr);
+		break;
+	case PIN_CONFIG_DRIVE_STRENGTH:
+		strength = arg;
+		switch (pin_regmap[pin].pcof_cur_strgh) {
+		case PADDRI_4_8:
+			if (strength == 4)
+				set_val = 0;
+			else if (strength == 8)
+				set_val = 1;
+			else
+				return -EINVAL;
+			break;
+		case PADDRI_2_4:
+			if (strength == 2)
+				set_val = 0;
+			else if (strength == 4)
+				set_val = 1;
+			else
+				return -EINVAL;
+			break;
+		case PADDRI_UNSUPPORT:
+		default:
+			return -EINVAL;
+		}
+
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_CURR);
+		writel(((val & ~mask) |
+			(set_val<<(pin_regmap[pin].pcof_regbit +
+			RTK_PCONF_CURR))), addr);
+		break;
+	case PIN_CONFIG_DRIVE_PUSH_PULL:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_PULEN);
+		writel(((val & ~mask) |
+			(1<<(pin_regmap[pin].pcof_regbit + RTK_PCONF_PULEN))),
+			addr);
+		break;
+
+	case PIN_CONFIG_BIAS_DISABLE:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_PULEN);
+		writel(((val & ~mask) |
+			(0<<(pin_regmap[pin].pcof_regbit + RTK_PCONF_PULEN))),
+			addr);
+		break;
+	case PIN_CONFIG_BIAS_PULL_UP:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_PULSEL);
+		writel(((val & ~mask) |
+			(1<<(pin_regmap[pin].pcof_regbit + RTK_PCONF_PULSEL))),
+			addr);
+		break;
+	case PIN_CONFIG_BIAS_PULL_DOWN:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_PULSEL);
+		writel(((val & ~mask) |
+			(0<<(pin_regmap[pin].pcof_regbit + RTK_PCONF_PULSEL))),
+			addr);
+		break;
+	default:
+		break;
+
+	}
+	return 0;
+}
+
+static int RTK_pconf_group_get(struct pinctrl_dev *pctldev,
+				 unsigned int group,
+				 unsigned long *config)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*config = pctl->groups[group].config;
+
+	return 0;
+}
+
+static int RTK_pconf_group_set(struct pinctrl_dev *pctldev,
+				 unsigned int group,
+				 unsigned long *configs,
+				 unsigned int num_configs)
+{
+	u32 i;
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = &pctl->groups[group];
+
+	RTK_PINCTRL_DBG("[%s] g->pin=%d, g->name =%s, num_configs = %u",
+				__func__, g->pin, g->name, num_configs);
+
+	if (pin_regmap[g->pin].pcof_regoff == PCOF_UNSUPPORT) {
+		RTK_PINCTRL_DBG(
+			"[%s] g->pin(%d) g->name(%s) not support pin config"
+				, __func__, g->pin, g->name);
+		g->config = configs[num_configs-1];
+		return 0;
+	}
+
+	for (i = 0; i < num_configs; i++) {
+		RTK_pconf_parse_conf(pctldev, g->pin,
+			pinconf_to_config_param(configs[i]),
+			pinconf_to_config_argument(configs[i]));
+
+		g->config = configs[i];
+	}
+
+	return 0;
+}
+
+static const struct pinconf_ops RTK_pconf_ops = {
+	.pin_config_group_get	= RTK_pconf_group_get,
+	.pin_config_group_set	= RTK_pconf_group_set,
+};
+
+static int RTK_pmx_get_funcs_cnt(struct pinctrl_dev *pctldev)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] pctl->nfunctions =%d",
+			__func__, pctl->nfunctions);
+	return pctl->nfunctions;
+}
+
+static const char *RTK_pmx_get_func_name(struct pinctrl_dev *pctldev,
+					   unsigned int function)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] function[%d] = %s", __func__,
+			function, pctl->functions[function].name);
+	return pctl->functions[function].name;
+}
+
+static int RTK_pmx_get_func_groups(struct pinctrl_dev *pctldev,
+				     unsigned int function,
+				     const char * const **groups,
+				     unsigned * const num_groups)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*groups = pctl->functions[function].groups;
+	*num_groups = pctl->functions[function].ngroups;
+
+	return 0;
+}
+
+static int RTK_pmx_enable(struct pinctrl_dev *pctldev,
+			    unsigned int function,
+			    unsigned int group)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = pctl->groups + group;
+	struct RTK_pinctrl_function *func = pctl->functions + function;
+	struct RTK_desc_function *desc =
+		RTK_pinctrl_desc_find_function_by_name(pctl,
+							 g->name,
+							 func->name);
+	RTK_PINCTRL_DBG("[%s] g->name=%s ,func->name=%s",
+				__func__, g->name, func->name);
+	if (!desc)
+		return -EINVAL;
+
+	RTK_pmx_set(pctldev, g->pin, desc->muxval);
+
+	return 0;
+}
+
+
+static int
+RTK_pmx_gpio_request_enable(struct pinctrl_dev *pctldev,
+				    struct pinctrl_gpio_range *range,
+				    unsigned int offset)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = pctl->groups + offset;
+	struct RTK_desc_function *desc;
+	const char *func;
+	int ret;
+
+	func = "gpio";
+	RTK_PINCTRL_DBG("[%s] gpio_offset=%u", __func__, offset);
+	desc = RTK_pinctrl_desc_find_function_by_name(pctl,
+							g->name,
+							func);
+	if (!desc) {
+		ret = -EINVAL;
+		RTK_PINCTRL_ERR("Set gpio pinmux fail, Pin(%s) offset=%u\n",
+					g->name, offset);
+		goto error;
+	}
+
+	RTK_pmx_set(pctldev, offset, desc->muxval);
+
+	// Set pull disable
+	RTK_pconf_parse_conf(pctldev, offset, PIN_CONFIG_BIAS_DISABLE, 0);
+
+	ret = 0;
+
+error:
+	return ret;
+}
+
+static void
+RTK_pmx_gpio_disable_free(struct pinctrl_dev *pctldev,
+				    struct pinctrl_gpio_range *range,
+				    unsigned int offset)
+{
+	RTK_PINCTRL_DBG("[%s]", __func__);
+/*TODO : need to add gpio related api*/
+}
+
+
+
+static const struct pinmux_ops RTK_pmx_ops = {
+	.get_functions_count = RTK_pmx_get_funcs_cnt,
+	.get_function_name = RTK_pmx_get_func_name,
+	.get_function_groups = RTK_pmx_get_func_groups,
+	.set_mux = RTK_pmx_enable,
+	.gpio_request_enable = RTK_pmx_gpio_request_enable,
+	.gpio_disable_free = RTK_pmx_gpio_disable_free,
+};
+
+static struct pinctrl_desc RTK_pctrl_desc = {
+	.confops	= &RTK_pconf_ops,
+	.pctlops	= &RTK_pctrl_ops,
+	.pmxops		= &RTK_pmx_ops,
+};
+
+
+static const struct of_device_id RTK_pinctrl_match[] = {
+	{ .compatible = "realtek,rtk129x-pinctrl",
+		.data = (void *)&rtk129x_pinctrl_data },
+	{ /* Sentinel */ },
+};
+MODULE_DEVICE_TABLE(of, RTK_pinctrl_match);
+
+static int RTK_pinctrl_add_function(struct RTK_pinctrl *pctl,
+					const char *name)
+{
+	struct RTK_pinctrl_function *func = pctl->functions;
+
+	while (func->name) {
+		/* function already there */
+		if (strcmp(func->name, name) == 0) {
+			func->ngroups++;
+			return -EEXIST;
+		}
+		func++;
+	}
+
+	func->name = name;
+	func->ngroups = 1;
+
+	pctl->nfunctions++;
+
+	return 0;
+}
+
+static int RTK_pinctrl_build_state(struct platform_device *pdev)
+{
+	struct RTK_pinctrl *pctl = platform_get_drvdata(pdev);
+	int i;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	pctl->ngroups = pctl->desc->npins;
+
+	/* Allocate groups */
+	pctl->groups = devm_kzalloc(&pdev->dev,
+				    pctl->ngroups * sizeof(*pctl->groups),
+				    GFP_KERNEL);
+	if (!pctl->groups)
+		return -ENOMEM;
+
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_pinctrl_group *group = pctl->groups + i;
+
+		group->name = pin->pin.name;
+		group->pin = pin->pin.number;
+	}
+
+	/*
+	 * We suppose that we won't have any more functions than pins,
+	 * we'll reallocate that later anyway
+	 */
+	pctl->functions = devm_kzalloc(&pdev->dev,
+				pctl->desc->npins * sizeof(*pctl->functions),
+				GFP_KERNEL);
+	if (!pctl->functions)
+		return -ENOMEM;
+
+	/* Count functions and their associated groups */
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_desc_function *func = pin->functions;
+
+		while (func->name) {
+			RTK_pinctrl_add_function(pctl, func->name);
+			func++;
+		}
+	}
+
+	pctl->functions = krealloc(pctl->functions,
+				pctl->nfunctions * sizeof(*pctl->functions),
+				GFP_KERNEL);
+
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_desc_function *func = pin->functions;
+
+		while (func->name) {
+			struct RTK_pinctrl_function *func_item;
+			const char **func_grp;
+
+			func_item = RTK_pinctrl_find_function_by_name(pctl,
+								func->name);
+			if (!func_item)
+				return -EINVAL;
+
+			if (!func_item->groups) {
+				func_item->groups =
+					devm_kzalloc(&pdev->dev,
+						     func_item->ngroups *
+						     sizeof(*func_item->groups),
+						     GFP_KERNEL);
+				if (!func_item->groups)
+					return -ENOMEM;
+			}
+
+			func_grp = func_item->groups;
+			while (*func_grp)
+				func_grp++;
+
+			*func_grp = pin->pin.name;
+			func++;
+		}
+	}
+
+	return 0;
+}
+
+static int RTK_pinctrl_probe(struct platform_device *pdev)
+{
+	struct device_node *node = pdev->dev.of_node;
+	const struct of_device_id *device;
+	struct pinctrl_pin_desc *pins;
+	struct RTK_pinctrl *pctl;
+	int i, ret;
+
+	RTK_PINCTRL_INF("driver init");
+
+	pctl = devm_kzalloc(&pdev->dev, sizeof(*pctl), GFP_KERNEL);
+	if (!pctl)
+		return -ENOMEM;
+	platform_set_drvdata(pdev, pctl);
+
+	pctl->sb2_membase = of_iomap(node, 0);
+	if (!pctl->sb2_membase) {
+		RTK_PINCTRL_ERR("of_iomap sb2_membase fail");
+		return -ENOMEM;
+	}
+
+	pctl->disp_membase = of_iomap(node, 1);
+	if (!pctl->disp_membase) {
+		RTK_PINCTRL_ERR("of_iomap disp_membase fail");
+		return -ENOMEM;
+	}
+
+	pctl->cr_membase = of_iomap(node, 2);
+	if (!pctl->cr_membase) {
+		RTK_PINCTRL_ERR("of_iomap cr_membase fail");
+		return -ENOMEM;
+	}
+
+	pctl->iso_membase = of_iomap(node, 3);
+	if (!pctl->iso_membase) {
+		RTK_PINCTRL_ERR("of_iomap iso_membase fail");
+		return -ENOMEM;
+	}
+	RTK_PINCTRL_DBG("sb2_membase(0x%p) disp_membase(0x%p) ",
+			pctl->sb2_membase, pctl->disp_membase);
+	RTK_PINCTRL_DBG("cr_membase(0x%p) iso_membase(0x%p)",
+			pctl->cr_membase, pctl->iso_membase);
+
+	device = of_match_device(RTK_pinctrl_match, &pdev->dev);
+	if (!device) {
+		RTK_PINCTRL_ERR("of_match_device fail");
+		return -ENODEV;
+	}
+
+	pctl->desc = (struct RTK_pinctrl_desc *)device->data;
+
+	ret = RTK_pinctrl_build_state(pdev);
+	if (ret) {
+		RTK_PINCTRL_ERR("RTK_pinctrl_build_state fail");
+		return ret;
+	}
+
+	pins = devm_kzalloc(&pdev->dev,
+			    pctl->desc->npins * sizeof(*pins),
+			    GFP_KERNEL);
+	if (!pins) {
+		RTK_PINCTRL_ERR("[%s]devm_kzalloc fail", __func__);
+		return -ENOMEM;
+	}
+
+	for (i = 0; i < pctl->desc->npins; i++)
+		pins[i] = pctl->desc->pins[i].pin;
+
+	RTK_pctrl_desc.name = dev_name(&pdev->dev);
+	RTK_pctrl_desc.owner = THIS_MODULE;
+	RTK_pctrl_desc.pins = pins;
+	RTK_pctrl_desc.npins = pctl->desc->npins;
+	pctl->dev = &pdev->dev;
+	pctl->pctl_dev = pinctrl_register(&RTK_pctrl_desc,
+					  &pdev->dev, pctl);
+	if (!pctl->pctl_dev) {
+		RTK_PINCTRL_ERR("register pinctrl driver fail");
+		return -EINVAL;
+	}
+
+	RTK_PINCTRL_INF("init done");
+
+	return 0;
+}
+
+int RTK_pinctrl_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct RTK_pinctrl *pctl;
+	void __iomem *addr;
+	unsigned int i;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		RTK_PINCTRL_INF("skip %s under DomU", __func__);
+		return 0;
+	}
+#endif
+
+	RTK_PINCTRL_INF("Enter %s", __func__);
+
+	pctl = platform_get_drvdata(pdev);
+
+	pinctrl_reg_values = kcalloc(ARRAY_SIZE(pinmux_reg_list), sizeof(u32),
+					GFP_KERNEL);
+
+	for (i = 0; i < ARRAY_SIZE(pinmux_reg_list); i++) {
+		switch (pinmux_reg_list[i].reg_base) {
+		case PMUX_BASE_SB2:
+			addr = pctl->sb2_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		case PMUX_BASE_DISP:
+			addr = pctl->disp_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		case PMUX_BASE_CR:
+			addr = pctl->cr_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		case PMUX_BASE_ISO:
+			addr = pctl->iso_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		default:
+			RTK_PINCTRL_ERR("[%s] Unknow reg_base\n",
+					__func__);
+			return -EINVAL;
+		}
+		//Store pinmux registers
+		pinctrl_reg_values[i] = readl(addr);
+	}
+
+	RTK_PINCTRL_INF("Exit %s", __func__);
+	return 0;
+}
+
+int RTK_pinctrl_resume(struct platform_device *pdev)
+{
+	struct RTK_pinctrl *pctl;
+	void __iomem *addr;
+	unsigned int i;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		RTK_PINCTRL_INF("skip %s under DomU", __func__);
+		return 0;
+	}
+#endif
+
+	RTK_PINCTRL_INF("Enter %s", __func__);
+
+	pctl = platform_get_drvdata(pdev);
+
+	for (i = 0; i < ARRAY_SIZE(pinmux_reg_list); i++) {
+		switch (pinmux_reg_list[i].reg_base) {
+		case PMUX_BASE_SB2:
+			addr = pctl->sb2_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		case PMUX_BASE_DISP:
+			addr = pctl->disp_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		case PMUX_BASE_CR:
+			addr = pctl->cr_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		case PMUX_BASE_ISO:
+			addr = pctl->iso_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		default:
+			RTK_PINCTRL_ERR("[%s] Unknow reg_base\n",
+					__func__);
+			return -EINVAL;
+		}
+		/*Restore pinmux registers*/
+		writel(pinctrl_reg_values[i], addr);
+	}
+
+	kfree(pinctrl_reg_values);
+
+	RTK_PINCTRL_INF("Exit %s", __func__);
+	return 0;
+}
+
+static struct platform_driver RTK_pinctrl_driver = {
+	.probe = RTK_pinctrl_probe,
+	.driver = {
+		.name = "rtk-pinctrl",
+		.owner = THIS_MODULE,
+		.of_match_table = RTK_pinctrl_match,
+	},
+	.suspend = RTK_pinctrl_suspend,
+	.resume = RTK_pinctrl_resume,
+};
+
+static int  rtk_pinctrl_init(void)
+{
+	return platform_driver_register(&RTK_pinctrl_driver);
+}
+postcore_initcall(rtk_pinctrl_init);
+
+MODULE_DESCRIPTION("RTK pinctrl driver");
+MODULE_LICENSE("GPL");
+
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd129x.h b/drivers/pinctrl/realtek/pinctrl-rtd129x.h
new file mode 100644
index 00000000..2a33bf0
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd129x.h
@@ -0,0 +1,1112 @@
+/*
+ * Realtek pin controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+
+#ifndef __PINCTRL_RTK129X_H
+#define __PINCTRL_RTK129X_H
+
+#include <linux/kernel.h>
+#include <linux/pinctrl/pinctrl.h>
+
+//#define RTK_PINCTRL_DEBUG
+#ifdef RTK_PINCTRL_DEBUG
+#define RTK_PINCTRL_DBG(fmt, ....) pr_info("[PINCTRL] " fmt "\n", ## __VA_ARGS__)
+#else
+#define RTK_PINCTRL_DBG(fmt, ...) do {} while (0)
+#endif
+
+#define RTK_PINCTRL_INF(fmt, ...) pr_info("[PINCTRL] " fmt "\n", ## __VA_ARGS__)
+#define RTK_PINCTRL_ERR(fmt, ...) pr_err("[PINCTRL Error] " fmt "\n", ## __VA_ARGS__)
+
+#define P_MISC_BASE		0
+#define P_MISC_BANK		101
+#define P_ISO_BASE		(P_MISC_BASE+P_MISC_BANK)
+#define P_ISO_BANK		35
+#define P_OTHER_BASE		(P_ISO_BASE+P_ISO_BANK)
+
+
+#define RTK_PCONF_SCHM		3
+#define RTK_PCONF_CURR		2
+#define RTK_PCONF_PULEN		1
+#define RTK_PCONF_PULSEL	0
+
+
+/*****   SB2 muxpad2   *****/
+#define RTK_PINCTRL_PIN_SB2_tp0_data				PINCTRL_PIN(P_MISC_BASE + 21, "tp0_data")
+#define RTK_PINCTRL_PIN_SB2_tp0_sync				PINCTRL_PIN(P_MISC_BASE + 24, "tp0_sync")
+#define RTK_PINCTRL_PIN_SB2_tp0_valid				PINCTRL_PIN(P_MISC_BASE + 23, "tp0_valid")
+#define RTK_PINCTRL_PIN_SB2_tp0_clk					PINCTRL_PIN(P_MISC_BASE + 22, "tp0_clk")
+/*hole:9~11*/
+#define RTK_PINCTRL_PIN_SB2_tp1_data				PINCTRL_PIN(P_MISC_BASE + 25, "tp1_data")
+#define RTK_PINCTRL_PIN_SB2_tp1_sync				PINCTRL_PIN(P_MISC_BASE + 10, "tp1_sync")
+#define RTK_PINCTRL_PIN_SB2_tp1_valid				PINCTRL_PIN(P_MISC_BASE + 27, "tp1_valid")
+#define RTK_PINCTRL_PIN_SB2_tp1_clk					PINCTRL_PIN(P_MISC_BASE + 26, "tp1_clk")
+/*hole:24~31*/
+
+/*****	 SB2 muxpad3   *****/
+/*hole:0~3*/
+#define RTK_PINCTRL_PIN_SB2_i2c_sda_4				PINCTRL_PIN(P_MISC_BASE + 12, "i2c_sda_4")
+#define RTK_PINCTRL_PIN_SB2_i2c_scl_4				PINCTRL_PIN(P_MISC_BASE + 11, "i2c_scl_4")
+#define RTK_PINCTRL_PIN_SB2_i2c_sda_5				PINCTRL_PIN(P_MISC_BASE + 14, "i2c_sda_5")
+#define RTK_PINCTRL_PIN_SB2_i2c_scl_5				PINCTRL_PIN(P_MISC_BASE + 13, "i2c_scl_5")
+/*hole:12~15*/
+#define RTK_PINCTRL_PIN_SB2_usb_id					PINCTRL_PIN(P_MISC_BASE + 15, "usb_id")
+#define RTK_PINCTRL_PIN_SB2_hi_loc					PINCTRL_PIN(P_OTHER_BASE + 0, "hi_loc")
+#define RTK_PINCTRL_PIN_SB2_ejtag_scpu_loc			PINCTRL_PIN(P_OTHER_BASE + 1, "ejtag_scpu_loc")
+#define RTK_PINCTRL_PIN_SB2_sensor_stb_1			PINCTRL_PIN(P_MISC_BASE + 20, "sensor_stb_1")
+#define RTK_PINCTRL_PIN_SB2_sensor_stb_0			PINCTRL_PIN(P_MISC_BASE + 19, "sensor_stb_0")
+#define RTK_PINCTRL_PIN_SB2_sensor_rst				PINCTRL_PIN(P_MISC_BASE + 18, "sensor_rst")
+#define RTK_PINCTRL_PIN_SB2_sensor_cko_1			PINCTRL_PIN(P_MISC_BASE + 17, "sensor_cko_1")
+#define RTK_PINCTRL_PIN_SB2_sensor_cko_0			PINCTRL_PIN(P_MISC_BASE + 16, "sensor_cko_0")
+
+/*****	 SB2 muxpad4   *****/
+#define RTK_PINCTRL_PIN_SB2_gpio_0					PINCTRL_PIN(P_MISC_BASE + 0, "gpio_0")
+#define RTK_PINCTRL_PIN_SB2_gpio_1					PINCTRL_PIN(P_MISC_BASE + 1, "gpio_1")
+#define RTK_PINCTRL_PIN_SB2_gpio_2					PINCTRL_PIN(P_MISC_BASE + 2, "gpio_2")
+#define RTK_PINCTRL_PIN_SB2_gpio_3					PINCTRL_PIN(P_MISC_BASE + 3, "gpio_3")
+#define RTK_PINCTRL_PIN_SB2_gpio_4					PINCTRL_PIN(P_MISC_BASE + 4, "gpio_4")
+#define RTK_PINCTRL_PIN_SB2_gpio_5					PINCTRL_PIN(P_MISC_BASE + 5, "gpio_5")
+#define RTK_PINCTRL_PIN_SB2_gpio_6					PINCTRL_PIN(P_MISC_BASE + 6, "gpio_6")
+#define RTK_PINCTRL_PIN_SB2_gpio_7					PINCTRL_PIN(P_MISC_BASE + 7, "gpio_7")
+#define RTK_PINCTRL_PIN_SB2_gpio_8					PINCTRL_PIN(P_MISC_BASE + 8, "gpio_8")
+#define RTK_PINCTRL_PIN_SB2_gpio_9					PINCTRL_PIN(P_MISC_BASE + 9, "gpio_9")
+/*hole:24~31*/
+
+/*****	  SB2 muxpad5   *****/
+#define RTK_PINCTRL_PIN_SB2_sf_en					PINCTRL_PIN(P_OTHER_BASE + 2, "sf_en")
+#define RTK_PINCTRL_PIN_SB2_arm_trace_dbg_en		PINCTRL_PIN(P_OTHER_BASE + 3, "arm_trace_dbg_en")
+/*hole:2~5*/
+#define RTK_PINCTRL_PIN_SB2_debug_p2s_enable		PINCTRL_PIN(P_OTHER_BASE + 4, "debug_p2s_enable")
+#define RTK_PINCTRL_PIN_SB2_tp0_loc					PINCTRL_PIN(P_OTHER_BASE + 5, "tp0_loc")
+#define RTK_PINCTRL_PIN_SB2_tp1_loc					PINCTRL_PIN(P_OTHER_BASE + 6, "tp1_loc")
+/*hole:9~31*/
+
+/*****	  SB2 muxpad_reg0   *****/
+#define RTK_PINCTRL_PIN_SB2_rgmii0_txc				PINCTRL_PIN(P_MISC_BASE + 28, "rgmii0_txc")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_tx_ctl			PINCTRL_PIN(P_MISC_BASE + 29, "rgmii0_tx_ctl")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_txd_0			PINCTRL_PIN(P_MISC_BASE + 30, "rgmii0_txd_0")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_txd_1			PINCTRL_PIN(P_MISC_BASE + 31, "rgmii0_txd_1")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_txd_2			PINCTRL_PIN(P_MISC_BASE + 32, "rgmii0_txd_2")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_txd_3			PINCTRL_PIN(P_MISC_BASE + 33, "rgmii0_txd_3")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_rxc				PINCTRL_PIN(P_MISC_BASE + 34, "rgmii0_rxc")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_rx_ctl			PINCTRL_PIN(P_MISC_BASE + 35, "rgmii0_rx_ctl")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_rxd_0			PINCTRL_PIN(P_MISC_BASE + 36, "rgmii0_rxd_0")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_rxd_1			PINCTRL_PIN(P_MISC_BASE + 37, "rgmii0_rxd_1")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_rxd_2			PINCTRL_PIN(P_MISC_BASE + 38, "rgmii0_rxd_2")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_rxd_3			PINCTRL_PIN(P_MISC_BASE + 39, "rgmii0_rxd_3")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_mdio				PINCTRL_PIN(P_MISC_BASE + 40, "rgmii0_mdio")
+#define RTK_PINCTRL_PIN_SB2_rgmii0_mdc				PINCTRL_PIN(P_MISC_BASE + 41, "rgmii0_mdc")
+/*hole:28~31*/
+
+/*****	  SB2 muxpad_reg1	*****/
+#define RTK_PINCTRL_PIN_SB2_rgmii1_txc				PINCTRL_PIN(P_MISC_BASE + 42, "rgmii1_txc")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_tx_ctl			PINCTRL_PIN(P_MISC_BASE + 43, "rgmii1_tx_ctl")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_txd_0			PINCTRL_PIN(P_MISC_BASE + 44, "rgmii1_txd_0")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_txd_1			PINCTRL_PIN(P_MISC_BASE + 45, "rgmii1_txd_1")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_txd_2			PINCTRL_PIN(P_MISC_BASE + 46, "rgmii1_txd_2")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_txd_3			PINCTRL_PIN(P_MISC_BASE + 47, "rgmii1_txd_3")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_rxc				PINCTRL_PIN(P_MISC_BASE + 48, "rgmii1_rxc")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_rx_ctl			PINCTRL_PIN(P_MISC_BASE + 49, "rgmii1_rx_ctl")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_rxd_0			PINCTRL_PIN(P_MISC_BASE + 50, "rgmii1_rxd_0")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_rxd_1			PINCTRL_PIN(P_MISC_BASE + 51, "rgmii1_rxd_1")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_rxd_2			PINCTRL_PIN(P_MISC_BASE + 52, "rgmii1_rxd_2")
+#define RTK_PINCTRL_PIN_SB2_rgmii1_rxd_3			PINCTRL_PIN(P_MISC_BASE + 53, "rgmii1_rxd_3")
+/*hole:28~31*/
+
+
+/*****	  DISP muxpad0   *****/
+#define RTK_PINCTRL_PIN_DISP_spdif					PINCTRL_PIN(P_MISC_BASE + 54, "spdif")
+#define RTK_PINCTRL_PIN_DISP_dmic_clk				PINCTRL_PIN(P_MISC_BASE + 55, "dmic_clk")
+#define RTK_PINCTRL_PIN_DISP_dmic_data				PINCTRL_PIN(P_MISC_BASE + 56, "dmic_data")
+#define RTK_PINCTRL_PIN_DISP_ao_lrck				PINCTRL_PIN(P_MISC_BASE + 57, "ao_lrck")
+#define RTK_PINCTRL_PIN_DISP_ao_bck					PINCTRL_PIN(P_MISC_BASE + 58, "ao_bck")
+#define RTK_PINCTRL_PIN_DISP_aock					PINCTRL_PIN(P_MISC_BASE + 59, "aock")
+#define RTK_PINCTRL_PIN_DISP_ao_sd_0				PINCTRL_PIN(P_MISC_BASE + 60, "ao_sd_0")
+#define RTK_PINCTRL_PIN_DISP_ao_sd_1				PINCTRL_PIN(P_MISC_BASE + 61, "ao_sd_1")
+#define RTK_PINCTRL_PIN_DISP_ao_sd_2				PINCTRL_PIN(P_MISC_BASE + 62, "ao_sd_2")
+#define RTK_PINCTRL_PIN_DISP_ao_sd_3				PINCTRL_PIN(P_MISC_BASE + 63, "ao_sd_3")
+#define RTK_PINCTRL_PIN_DISP_ai_loc					PINCTRL_PIN(P_OTHER_BASE + 7, "ai_loc")
+/*hole:22~31*/
+
+
+/*****	  CardReader muxpad0	  *****/
+#define RTK_PINCTRL_PIN_CR_nf_dqs				PINCTRL_PIN(P_MISC_BASE + 77, "nf_dqs")
+#define RTK_PINCTRL_PIN_CR_nf_rdy				PINCTRL_PIN(P_MISC_BASE + 68, "nf_rdy")
+#define RTK_PINCTRL_PIN_CR_nf_rd_n				PINCTRL_PIN(P_MISC_BASE + 66, "nf_rd_n")
+#define RTK_PINCTRL_PIN_CR_nf_wr_n				PINCTRL_PIN(P_MISC_BASE + 67, "nf_wr_n")
+#define RTK_PINCTRL_PIN_CR_nf_ale				PINCTRL_PIN(P_MISC_BASE + 65, "nf_ale")
+#define RTK_PINCTRL_PIN_CR_nf_cle				PINCTRL_PIN(P_MISC_BASE + 64, "nf_cle")
+#define RTK_PINCTRL_PIN_CR_nf_ce_n_0				PINCTRL_PIN(P_MISC_BASE + 78, "nf_ce_n_0")
+#define RTK_PINCTRL_PIN_CR_nf_ce_n_1				PINCTRL_PIN(P_MISC_BASE + 79, "nf_ce_n_1")
+#define RTK_PINCTRL_PIN_CR_nf_dd_0				PINCTRL_PIN(P_MISC_BASE + 76, "nf_dd_0")
+#define RTK_PINCTRL_PIN_CR_nf_dd_1				PINCTRL_PIN(P_MISC_BASE + 75, "nf_dd_1")
+#define RTK_PINCTRL_PIN_CR_nf_dd_2				PINCTRL_PIN(P_MISC_BASE + 74, "nf_dd_2")
+#define RTK_PINCTRL_PIN_CR_nf_dd_3				PINCTRL_PIN(P_MISC_BASE + 73, "nf_dd_3")
+#define RTK_PINCTRL_PIN_CR_nf_dd_4				PINCTRL_PIN(P_MISC_BASE + 72, "nf_dd_4")
+#define RTK_PINCTRL_PIN_CR_nf_dd_5				PINCTRL_PIN(P_MISC_BASE + 71, "nf_dd_5")
+#define RTK_PINCTRL_PIN_CR_nf_dd_6				PINCTRL_PIN(P_MISC_BASE + 70, "nf_dd_6")
+#define RTK_PINCTRL_PIN_CR_nf_dd_7				PINCTRL_PIN(P_MISC_BASE + 69, "nf_dd_7")
+
+
+/*****	  CardReader muxpad1   *****/
+#define RTK_PINCTRL_PIN_CR_sdio_cmd				PINCTRL_PIN(P_MISC_BASE + 89, "sdio_cmd")
+#define RTK_PINCTRL_PIN_CR_sdio_clk				PINCTRL_PIN(P_MISC_BASE + 90, "sdio_clk")
+#define RTK_PINCTRL_PIN_CR_sdio_data_0				PINCTRL_PIN(P_MISC_BASE + 91, "sdio_data_0")
+#define RTK_PINCTRL_PIN_CR_sdio_data_1				PINCTRL_PIN(P_MISC_BASE + 92, "sdio_data_1")
+#define RTK_PINCTRL_PIN_CR_sdio_data_2				PINCTRL_PIN(P_MISC_BASE + 93, "sdio_data_2")
+#define RTK_PINCTRL_PIN_CR_sdio_data_3				PINCTRL_PIN(P_MISC_BASE + 94, "sdio_data_3")
+#define RTK_PINCTRL_PIN_CR_emmc_dd_sb				PINCTRL_PIN(P_MISC_BASE + 80, "emmc_dd_sb")
+/*hole:14~15*/
+#define RTK_PINCTRL_PIN_CR_mmc_cmd				PINCTRL_PIN(P_MISC_BASE + 81, "mmc_cmd")
+#define RTK_PINCTRL_PIN_CR_mmc_clk				PINCTRL_PIN(P_MISC_BASE + 82, "mmc_clk")
+#define RTK_PINCTRL_PIN_CR_mmc_wp				PINCTRL_PIN(P_MISC_BASE + 83, "mmc_wp")
+#define RTK_PINCTRL_PIN_CR_mmc_cd				PINCTRL_PIN(P_MISC_BASE + 84, "mmc_cd")
+#define RTK_PINCTRL_PIN_CR_mmc_data_0				PINCTRL_PIN(P_MISC_BASE + 85, "mmc_data_0")
+#define RTK_PINCTRL_PIN_CR_mmc_data_1				PINCTRL_PIN(P_MISC_BASE + 86, "mmc_data_1")
+#define RTK_PINCTRL_PIN_CR_mmc_data_2				PINCTRL_PIN(P_MISC_BASE + 87, "mmc_data_2")
+#define RTK_PINCTRL_PIN_CR_mmc_data_3				PINCTRL_PIN(P_MISC_BASE + 88, "mmc_data_3")
+
+
+/*****	  CardReader muxpad2   *****/
+#define RTK_PINCTRL_PIN_CR_sdio_loc				PINCTRL_PIN(P_OTHER_BASE + 8, "sdio_loc")
+#define RTK_PINCTRL_PIN_CR_pcie_clkreq_0			PINCTRL_PIN(P_MISC_BASE + 95, "pcie_clkreq_0")
+#define RTK_PINCTRL_PIN_CR_pcie_clkreq_1			PINCTRL_PIN(P_MISC_BASE + 96, "pcie_clkreq_1")
+#define RTK_PINCTRL_PIN_CR_prob_0				PINCTRL_PIN(P_MISC_BASE + 97, "prob_0")
+#define RTK_PINCTRL_PIN_CR_prob_1				PINCTRL_PIN(P_MISC_BASE + 98, "prob_1")
+#define RTK_PINCTRL_PIN_CR_prob_2				PINCTRL_PIN(P_MISC_BASE + 99, "prob_2")
+#define RTK_PINCTRL_PIN_CR_prob_3				PINCTRL_PIN(P_MISC_BASE + 100, "prob_3")
+/*hole:14~31*/
+
+
+/*****	  ISO muxpad0   *****/
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_4				PINCTRL_PIN(P_ISO_BASE + 4, "iso_gpio_4")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_5				PINCTRL_PIN(P_ISO_BASE + 5,	"iso_gpio_5")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_7				PINCTRL_PIN(P_ISO_BASE + 7,	"iso_gpio_7")
+#define RTK_PINCTRL_PIN_ISO_ir_rx					PINCTRL_PIN(P_ISO_BASE + 8,	"ir_rx")
+#define RTK_PINCTRL_PIN_ISO_ir_tx					PINCTRL_PIN(P_ISO_BASE + 9,	"ir_tx")
+#define RTK_PINCTRL_PIN_ISO_ur0_rx					PINCTRL_PIN(P_ISO_BASE + 10, "ur0_rx")
+#define RTK_PINCTRL_PIN_ISO_ur0_tx					PINCTRL_PIN(P_ISO_BASE + 11, "ur0_tx")
+#define RTK_PINCTRL_PIN_ISO_ur1_rx					PINCTRL_PIN(P_ISO_BASE + 12, "ur1_rx")
+#define RTK_PINCTRL_PIN_ISO_ur1_tx					PINCTRL_PIN(P_ISO_BASE + 13, "ur1_tx")
+#define RTK_PINCTRL_PIN_ISO_ur1_cts_n				PINCTRL_PIN(P_ISO_BASE + 14, "ur1_cts_n")
+#define RTK_PINCTRL_PIN_ISO_ur1_rts_n				PINCTRL_PIN(P_ISO_BASE + 15, "ur1_rts_n")
+#define RTK_PINCTRL_PIN_ISO_i2c_scl_0				PINCTRL_PIN(P_ISO_BASE + 16, "i2c_scl_0")
+#define RTK_PINCTRL_PIN_ISO_i2c_sda_0				PINCTRL_PIN(P_ISO_BASE + 17, "i2c_sda_0")
+#define RTK_PINCTRL_PIN_ISO_etn_led_link			PINCTRL_PIN(P_ISO_BASE + 27, "etn_led_link")
+#define RTK_PINCTRL_PIN_ISO_etn_led_rxtx			PINCTRL_PIN(P_ISO_BASE + 28, "etn_led_rxtx")
+
+
+/*****	  ISO muxpad1	*****/
+#define RTK_PINCTRL_PIN_ISO_i2c_scl_6				PINCTRL_PIN(P_ISO_BASE + 20, "i2c_scl_6")
+#define RTK_PINCTRL_PIN_ISO_i2c_sda_6				PINCTRL_PIN(P_ISO_BASE + 26, "i2c_sda_6")
+#define RTK_PINCTRL_PIN_ISO_hdmi_hpd				PINCTRL_PIN(P_ISO_BASE + 6,	"hdmi_hpd")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_2				PINCTRL_PIN(P_ISO_BASE + 2,	"iso_gpio_2")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_3				PINCTRL_PIN(P_ISO_BASE + 3,	"iso_gpio_3")
+#define RTK_PINCTRL_PIN_ISO_i2c_scl_1				PINCTRL_PIN(P_ISO_BASE + 18, "i2c_scl_1")
+#define RTK_PINCTRL_PIN_ISO_i2c_sda_1				PINCTRL_PIN(P_ISO_BASE + 19, "i2c_sda_1")
+#define RTK_PINCTRL_PIN_ISO_nat_led_0				PINCTRL_PIN(P_ISO_BASE + 29, "nat_led_0")
+#define RTK_PINCTRL_PIN_ISO_nat_led_1				PINCTRL_PIN(P_ISO_BASE + 30, "nat_led_1")
+#define RTK_PINCTRL_PIN_ISO_nat_led_2				PINCTRL_PIN(P_ISO_BASE + 31, "nat_led_2")
+#define RTK_PINCTRL_PIN_ISO_nat_led_3				PINCTRL_PIN(P_ISO_BASE + 32, "nat_led_3")
+#define RTK_PINCTRL_PIN_ISO_pwm_23_open_drain_en_loc0					PINCTRL_PIN(P_OTHER_BASE + 9,	"pwm_23_open_drain_en_loc0")
+#define RTK_PINCTRL_PIN_ISO_pwm_01_open_drain_en_loc0					PINCTRL_PIN(P_OTHER_BASE + 10,	"pwm_01_open_drain_en_loc0")
+#define RTK_PINCTRL_PIN_ISO_pwm_23_open_drain_en_loc1					PINCTRL_PIN(P_OTHER_BASE + 11,	"pwm_23_open_drain_en_loc1")
+#define RTK_PINCTRL_PIN_ISO_pwm_01_open_drain_en_loc1					PINCTRL_PIN(P_OTHER_BASE + 12,	"pwm_01_open_drain_en_loc1")
+#define RTK_PINCTRL_PIN_ISO_ejtag_avcpu_loc			PINCTRL_PIN(P_OTHER_BASE + 13, "ejtag_avcpu_loc")
+#define RTK_PINCTRL_PIN_ISO_ur2_loc					PINCTRL_PIN(P_OTHER_BASE + 14, "ur2_loc")
+
+
+/*****	  ISO muxpad2	*****/
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_21					PINCTRL_PIN(P_ISO_BASE + 21, "iso_gpio_21")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_22					PINCTRL_PIN(P_ISO_BASE + 22, "iso_gpio_22")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_23					PINCTRL_PIN(P_ISO_BASE + 23, "iso_gpio_23")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_24					PINCTRL_PIN(P_ISO_BASE + 24, "iso_gpio_24")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_25					PINCTRL_PIN(P_ISO_BASE + 25, "iso_gpio_25")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_33					PINCTRL_PIN(P_ISO_BASE + 33, "iso_gpio_33")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_34					PINCTRL_PIN(P_ISO_BASE + 34, "iso_gpio_34")
+/*hole:14*/
+#define RTK_PINCTRL_PIN_ISO_i2c_tg_enable				PINCTRL_PIN(P_OTHER_BASE + 15,	"i2c_tg_enable")
+
+
+/*****	  No muxpad GPIO	*****/
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_0				PINCTRL_PIN(P_ISO_BASE + 0, "iso_gpio_0")
+#define RTK_PINCTRL_PIN_ISO_iso_gpio_1				PINCTRL_PIN(P_ISO_BASE + 1, "iso_gpio_1")
+
+
+enum PMUX_BASE_TYPE {
+	PMUX_BASE_SB2,
+	PMUX_BASE_DISP,
+	PMUX_BASE_CR,
+	PMUX_BASE_ISO
+};
+
+struct rtk_pin_regmap {
+	u8	pmux_base;
+	u16 pmux_regoff;
+	u16 pmux_regbit;
+	u16 pmux_regbitmsk;
+	u16 pcof_regoff;
+	u16 pcof_regbit;
+	u16 pcof_cur_strgh;//0 : 2&4mA   1:4&8mA
+};
+
+struct rtk_pinmux_reg {
+	u8	reg_base;
+	u16 reg_offset;
+};
+
+#define PADDRI_4_8 1
+#define PADDRI_2_4 0
+#define PADDRI_UNSUPPORT 0xFFFF
+
+#define PCOF_UNSUPPORT 0xFFFF
+#define PMUX_UNSUPPORT 0xFFFF
+
+static const struct rtk_pinmux_reg pinmux_reg_list[] = {
+	/* ----- SB2 muxpad ----- */
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x908},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x90c},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x910},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x914},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x96c},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x97c},
+	/* ----- SB2 pfunc ----- */
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x928},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x92c},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x930},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x934},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x938},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x93c},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x964},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x968},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x974},
+	{.reg_base = PMUX_BASE_SB2, .reg_offset = 0x978},
+	/* ----- disp muxpad ----- */
+	{.reg_base = PMUX_BASE_DISP, .reg_offset = 0x008},
+	/* ----- disp pfunc ----- */
+	{.reg_base = PMUX_BASE_DISP, .reg_offset = 0x000},
+	{.reg_base = PMUX_BASE_DISP, .reg_offset = 0x004},
+	/* ----- CardReader muxpad ----- */
+	{.reg_base = PMUX_BASE_CR, .reg_offset = 0x600},
+	{.reg_base = PMUX_BASE_CR, .reg_offset = 0x604},
+	{.reg_base = PMUX_BASE_CR, .reg_offset = 0x61c},
+	/* ----- CardReader pfunc ----- */
+	{.reg_base = PMUX_BASE_CR, .reg_offset = 0x608},
+	{.reg_base = PMUX_BASE_CR, .reg_offset = 0x60c},
+	{.reg_base = PMUX_BASE_CR, .reg_offset = 0x610},
+	{.reg_base = PMUX_BASE_CR, .reg_offset = 0x614},
+	{.reg_base = PMUX_BASE_CR, .reg_offset = 0x618},
+	/* ----- ISO muxpad ----- */
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x310},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x314},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x31c},
+	/* ----- ISO pfunc ----- */
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x300},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x304},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x308},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x30c},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x318},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x320},
+};
+
+static const struct rtk_pin_regmap pin_regmap[] = {
+	/* ----- SB2 muxpad ----- */
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x910, .pmux_regbit = 0, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x934, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 0, "gpio_0")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x910, .pmux_regbit = 3, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x934, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 1, "gpio_1")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x910, .pmux_regbit = 6, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x934, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 2, "gpio_2")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x910, .pmux_regbit = 9, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x934, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 3, "gpio_3")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x910, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x934, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 4, "gpio_4")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x910, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x934, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 5, "gpio_5")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x910, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x934, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 6, "gpio_6")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x910, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x934, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 7, "gpio_7")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x910, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x938, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 8, "gpio_8")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x910, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x938, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 9, "gpio_9")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x908, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x92c, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 10, "tp1_sync")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x930, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 11, "i2c_scl_4")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x930, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 12, "i2c_sda_4")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x930, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 13, "i2c_scl_5")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x930, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 14, "i2c_sda_5")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x938, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 15, "usb_id")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c, .pmux_regbit = 30, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x938, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 16, "sensor_cko_0")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c, .pmux_regbit = 28, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x938, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 17, "sensor_cko_1")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c, .pmux_regbit = 26, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x938, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 18, "sensor_rst")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c, .pmux_regbit = 24, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x938, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 19, "sensor_stb_0")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x938, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 20, "sensor_stb_1")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x908, .pmux_regbit = 0, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x928, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 21, "tp0_data")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x908, .pmux_regbit = 9, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x928, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 22, "tp0_clk")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x908, .pmux_regbit = 6, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x928, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 23, "tp0_valid")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x908, .pmux_regbit = 3, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x928, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 24, "tp0_sync")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x908, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x92c, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 25, "tp1_data")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x908, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x92c, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 26, "tp1_clk")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x908, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x92c, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 27, "tp1_valid")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x964, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 28, "rgmii0_txc")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x964, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 29, "rgmii0_tx_ctl")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x964, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 30, "rgmii0_txd_0")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x964, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 31, "rgmii0_txd_1")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x964, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 32, "rgmii0_txd_2")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x964, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 33, "rgmii0_txd_3")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x964, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 34, "rgmii0_rxc")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x964, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 35, "rgmii0_rx_ctl")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x968, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 36, "rgmii0_rxd_0")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x968, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 37, "rgmii0_rxd_1")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x968, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 38, "rgmii0_rxd_2")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x968, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 39, "rgmii0_rxd_3")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 24, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x968, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 40, "rgmii0_mdio")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x96c, .pmux_regbit = 26, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x968, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 41, "rgmii0_mdc")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x974, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 42, "rgmii1_txc")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x974, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 43, "rgmii1_tx_ctl")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x974, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 44, "rgmii1_txd_0")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x974, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 45, "rgmii1_txd_1")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x974, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 46, "rgmii1_txd_2")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x974, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 47, "rgmii1_txd_3")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x974, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 48, "rgmii1_rxc")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x974, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 49, "rgmii1_rx_ctl")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x978, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 50, "rgmii1_rxd_0")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x978, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 51, "rgmii1_rxd_1")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x978, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 52, "rgmii1_rxd_2")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x97c, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x978, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 53, "rgmii1_rxd_3")
+	/* ----- disp muxpad ----- */
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x000, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 54, "spdif")
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x000, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 55, "dmic_clk")
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x000, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 56, "dmic_data")
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x004, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 57, "ao_lrck")
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x004, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 58, "ao_bck")
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x004, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 59, "aock")
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x004, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 60, "ao_sd_0")
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x004, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 61, "ao_sd_1")
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x004, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 62, "ao_sd_2")
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x004, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_2_4}, //(P_MISC_BASE + 63, "ao_sd_3")
+	/* ----- CardReader muxpad ----- */
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x608, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 64, "nf_cle")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x608, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 65, "nf_ale")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x608, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 66, "nf_rd_n")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x608, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 67, "nf_wr_n")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x608, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 68, "nf_rdy")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 30, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x60c, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 69, "nf_dd_7")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 28, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x60c, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 70, "nf_dd_6")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 26, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x60c, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 71, "nf_dd_5")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 24, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x60c, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 72, "nf_dd_4")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x60c, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 73, "nf_dd_3")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x60c, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 74, "nf_dd_2")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x60c, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 75, "nf_dd_1")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x60c, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 76, "nf_dd_0")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x608, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 77, "nf_dqs")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x608, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 78, "nf_ce_n_0")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x600, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x608, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 79, "nf_ce_n_1")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x618, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 80, "emmc_dd_sb")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x610, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 81, "mmc_cmd")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x610, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 82, "mmc_clk")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x610, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 83, "mmc_wp")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x610, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 84, "mmc_cd")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 24, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x610, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 85, "mmc_data_0")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 26, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x610, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 86, "mmc_data_1")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 28, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x610, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 87, "mmc_data_2")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 30, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x610, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 88, "mmc_data_3")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x614, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 89, "sdio_cmd")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x614, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 90, "sdio_clk")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x614, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 91, "sdio_data_0")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x614, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 92, "sdio_data_1")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x614, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 93, "sdio_data_2")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x604, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x614, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_MISC_BASE + 94, "sdio_data_3")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x61c, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x618, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 95, "pcie_clkreq_0")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x61c, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x618, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 96, "pcie_clkreq_1")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x61c, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x618, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 97, "prob_0")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x61c, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x618, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 98, "prob_1")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x61c, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x618, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 99, "prob_2")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x61c, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x618, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_4_8}, //(P_MISC_BASE + 100, "prob_3")
+	/* ----- ISO muxpad ----- */
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = PMUX_UNSUPPORT,	.pmux_regbit = 0, .pmux_regbitmsk = 0x0,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = 0},//(P_ISO_BASE + 0, "iso_gpio_0")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = PMUX_UNSUPPORT,	.pmux_regbit = 0, .pmux_regbitmsk = 0x0,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = 0},//(P_ISO_BASE + 1, "iso_gpio_1)
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 6, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x300, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 2,	"iso_gpio_2")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 9, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x300, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 3,	"iso_gpio_3")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x300, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 4,	"iso_gpio_4")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x300, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 5,	"iso_gpio_5")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x30c, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 6,	"hdmi_hpd")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x300, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 7,	"iso_gpio_7")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x300, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 8,	"ir_rx")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x308, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 9,	"ir_tx")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x304, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 10, "ur0_rx")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x304, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 11, "ur0_tx")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x304, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 12, "ur1_rx")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x304, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 13, "ur1_tx")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x304, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 14, "ur1_cts_n")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x304, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 15, "ur1_rts_n")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x300, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 16, "i2c_scl_0")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 24, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x300, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 17, "i2c_sda_0")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x308, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 18, "i2c_scl_1")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x308, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 19, "i2c_sda_1")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x308, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 20, "i2c_scl_6")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x31c, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x318, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 21, "iso_gpio_21")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x31c, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x318, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 22, "iso_gpio_22")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x31c, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x318, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 23, "iso_gpio_23")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x31c, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x318, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 24, "iso_gpio_24")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x31c, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x318, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 25, "iso_gpio_25")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x308, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 26, "i2c_sda_6")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 26, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x304, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 27, "etn_led_link")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x310, .pmux_regbit = 28, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x304, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 28, "etn_led_rxtx")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x30c, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 29, "nat_led_0")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x30c, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 30, "nat_led_1")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x30c, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 31, "nat_led_2")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x30c, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_4_8}, //(P_ISO_BASE + 32, "nat_led_3")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x31c, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x320, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 33, "iso_gpio_33")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x31c, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x320, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_2_4}, //(P_ISO_BASE + 34, "iso_gpio_34")
+	/* Other, not gpio*/
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c,	.pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 0, "hi_loc")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x90c,	.pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 1, "ejtag_scpu_loc")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x914,	.pmux_regbit = 0, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 2, "sf_en")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x914,	.pmux_regbit = 1, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 3, "arm_trace_dbg_en")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x914,	.pmux_regbit = 6, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 4, "debug_p2s_enable")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x914,	.pmux_regbit = 7, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 5, "tp0_loc")
+	{.pmux_base = PMUX_BASE_SB2,	.pmux_regoff = 0x914,	.pmux_regbit = 8, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 6, "tp1_loc")
+	{.pmux_base = PMUX_BASE_DISP, .pmux_regoff = 0x008,	.pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 7, "ai_loc")
+	{.pmux_base = PMUX_BASE_CR,	.pmux_regoff = 0x61c,	.pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 8, "sdio_loc")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 24, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 9, "pwm_23_open_drain_en_loc0")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 25, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 10, "pwm_01_open_drain_en_loc0")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 26, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 11, "pwm_23_open_drain_en_loc1")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 27, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 12, "pwm_01_open_drain_en_loc1")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 28, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 13, "ejtag_avcpu_loc")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x314, .pmux_regbit = 30, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 14, "ur2_loc")
+	{.pmux_base = PMUX_BASE_ISO,	.pmux_regoff = 0x31c, .pmux_regbit = 15, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, //(P_OTHER_BASE + 15, "i2c_tg_enable")
+};
+
+
+
+struct RTK_desc_function {
+	const char	*name;
+	u8		muxval;
+};
+
+struct RTK_desc_pin {
+	struct pinctrl_pin_desc		pin;
+	struct RTK_desc_function	*functions;
+};
+
+struct RTK_pinctrl_desc {
+	const struct RTK_desc_pin	*pins;
+	int				npins;
+	struct pinctrl_gpio_range	*ranges;
+	int				nranges;
+};
+
+struct RTK_pinctrl_function {
+	const char	*name;
+	const char	**groups;
+	unsigned int	ngroups;
+};
+
+struct RTK_pinctrl_group {
+	const char	*name;
+	unsigned long	config;
+	unsigned int	pin;
+};
+
+struct RTK_pinctrl {
+	void __iomem			*sb2_membase;
+	void __iomem			*disp_membase;
+	void __iomem			*cr_membase;
+	void __iomem			*iso_membase;
+//	struct gpio_chip		*chip;
+	struct RTK_pinctrl_desc	*desc;
+	struct device			*dev;
+	struct RTK_pinctrl_function	*functions;
+	unsigned int			nfunctions;
+	struct RTK_pinctrl_group	*groups;
+	unsigned int			ngroups;
+	struct pinctrl_dev		*pctl_dev;
+};
+
+#define RTK_PIN(_pin, ...)					\
+	{							\
+		.pin = _pin,					\
+		.functions = (struct RTK_desc_function[]){	\
+			__VA_ARGS__, { } },			\
+	}
+
+#define RTK_FUNCTION(_val, _name)				\
+	{							\
+		.name = _name,					\
+		.muxval = _val,					\
+	}
+
+
+static const struct RTK_desc_pin rtk_pins[] = {
+	/*****   Pin 0~4   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_gpio_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_gpio_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_gpio_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_gpio_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_gpio_4,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "scpu_ejtag_loc_gpio"),
+		RTK_FUNCTION(0x3, "gspi")),
+	/*****   Pin 5~9   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_gpio_5,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "scpu_ejtag_loc_gpio"),
+		RTK_FUNCTION(0x3, "gspi")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_gpio_6,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "scpu_ejtag_loc_gpio"),
+		RTK_FUNCTION(0x3, "gspi")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_gpio_7,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "scpu_ejtag_loc_gpio"),
+		RTK_FUNCTION(0x3, "gspi")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_gpio_8,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "scpu_ejtag_loc_gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_gpio_9,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "dc_fan_sensor")),
+	/*****   Pin 10~14   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_tp1_sync,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tp1_loc_tp1"),
+		RTK_FUNCTION(0x2, "tp1_loc_tp0"),
+		RTK_FUNCTION(0x3, "i2c2")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_i2c_scl_4,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c4")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_i2c_sda_4,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c4")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_i2c_scl_5,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c5"),
+		RTK_FUNCTION(0x3, "nand")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_i2c_sda_5,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c5"),
+		RTK_FUNCTION(0x3, "nand")),
+	/*****   Pin 15~19   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_usb_id,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "test_loop_dis")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_sensor_cko_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sensor_cko_output")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_sensor_cko_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sensor_cko_output"),
+		RTK_FUNCTION(0x3, "usb_clock_output")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_sensor_rst,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_sensor_stb_0,
+		RTK_FUNCTION(0x0, "gpio")),
+	/*****   Pin 20~24   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_sensor_stb_1,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_tp0_data,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tp0_loc_tp0"),
+		RTK_FUNCTION(0x2, "tp0_loc_tp1"),
+		RTK_FUNCTION(0x3, "AI")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_tp0_clk,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tp0_loc_tp0"),
+		RTK_FUNCTION(0x2, "tp0_loc_tp1"),
+		RTK_FUNCTION(0x3, "AI")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_tp0_valid,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tp0_loc_tp0"),
+		RTK_FUNCTION(0x2, "tp0_loc_tp1"),
+		RTK_FUNCTION(0x3, "AI")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_tp0_sync,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tp0_loc_tp0"),
+		RTK_FUNCTION(0x2, "tp0_loc_tp1"),
+		RTK_FUNCTION(0x3, "AI")),
+	/*****   Pin 25~29   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_tp1_data,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tp1_loc_tp1"),
+		RTK_FUNCTION(0x2, "tp1_loc_tp0"),
+		RTK_FUNCTION(0x3, "i2c3")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_tp1_clk,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tp1_loc_tp1"),
+		RTK_FUNCTION(0x2, "tp1_loc_tp0"),
+		RTK_FUNCTION(0x3, "i2c2")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_tp1_valid,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tp1_loc_tp1"),
+		RTK_FUNCTION(0x2, "tp1_loc_tp0"),
+		RTK_FUNCTION(0x3, "i2c3")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_txc,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_tx_ctl,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	/*****   Pin 30~34   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_txd_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0_loc_rgmii0_tx")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_txd_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0_loc_rgmii0_tx")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_txd_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0_loc_rgmii0_tx")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_txd_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0_loc_rgmii0_tx")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_rxc,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	/*****   Pin 35~39   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_rx_ctl,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_rxd_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp1_loc_rgmii0_rx")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_rxd_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp1_loc_rgmii0_rx")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_rxd_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp1_loc_rgmii0_rx")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_rxd_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp1_loc_rgmii0_rx")),
+	/*****   Pin 40~44   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_mdio,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "eth_gpy")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii0_mdc,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "eth_gpy")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_txc,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_tx_ctl,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_txd_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	/*****   Pin 45~49   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_txd_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_txd_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_txd_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_rxc,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_rx_ctl,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	/*****   Pin 50~54   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_rxd_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_rxd_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_rxd_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_rgmii1_rxd_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_spdif,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "spdif_out")),
+	/*****   Pin 55~59   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_dmic_clk,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "dmic"),
+		RTK_FUNCTION(0x2, "ai")),
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_dmic_data,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "dmic"),
+		RTK_FUNCTION(0x2, "ai")),
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_ao_lrck,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_ao_bck,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_aock,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ao")),
+	/*****   Pin 60~64   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_ao_sd_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_ao_sd_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_ao_sd_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ao"),
+		RTK_FUNCTION(0x2, "ai")),
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_ao_sd_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ao"),
+		RTK_FUNCTION(0x2, "ai")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_cle,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "hif")),
+	/*****   Pin 65~69   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_ale,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x3, "hif")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_rd_n,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "avcpu_ej")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_wr_n,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x3, "hif")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_rdy,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "avcpu_ej")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_dd_7,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "avcpu_ej")),
+	/*****   Pin 70~74   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_dd_6,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "avcpu_ej")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_dd_5,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "avcpu_ej")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_dd_4,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "hif")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_dd_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_dd_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	/*****   Pin 75~79   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_dd_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_dd_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_dqs,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_ce_n_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_nf_ce_n_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nand")),
+	/*****   Pin 80~84   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_CR_emmc_dd_sb,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_mmc_cmd,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd_card"),
+		RTK_FUNCTION(0x2, "sdio"),
+		RTK_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_mmc_clk,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd_card"),
+		RTK_FUNCTION(0x2, "sdio"),
+		RTK_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_mmc_wp,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd_card"),
+		RTK_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_mmc_cd,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd_card")),
+	/*****   Pin 85~89   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_CR_mmc_data_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd_card"),
+		RTK_FUNCTION(0x2, "sdio"),
+		RTK_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_mmc_data_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd_card"),
+		RTK_FUNCTION(0x2, "sdio")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_mmc_data_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd_card"),
+		RTK_FUNCTION(0x2, "sdio")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_mmc_data_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd_card"),
+		RTK_FUNCTION(0x2, "sdio"),
+		RTK_FUNCTION(0x3, "scpu_ejtag_loc_cr")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_sdio_cmd,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio")),
+	/*****   Pin 90~94   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_CR_sdio_clk,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd_card")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_sdio_data_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_sdio_data_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_sdio_data_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_sdio_data_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio")),
+	/*****   Pin 95~99   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_CR_pcie_clkreq_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pcie")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_pcie_clkreq_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pcie")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_prob_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test"),
+		RTK_FUNCTION(0x2, "p2s")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_prob_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test"),
+		RTK_FUNCTION(0x2, "p2s")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_prob_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test")),
+	/*****   Pin 100~104   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_CR_prob_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_0,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_1,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "standby_dbg"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc_iso"),
+		RTK_FUNCTION(0x4, "uart2_0")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "standby_dbg"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc_iso"),
+		RTK_FUNCTION(0x4, "uart2_0")),
+	/*****   Pin 105~109   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_4,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_0"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc_iso")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_5,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_0"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc_iso")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_hdmi_hpd,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_7,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "edp_hpd"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc_iso")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_ir_rx,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ir_rx"),
+		RTK_FUNCTION(0x2, "standby_dbg")),
+	/*****   Pin 110~114   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_ir_tx,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ir_tx")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_ur0_rx,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart0")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_ur0_tx,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart0")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_ur1_rx,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_ur1_tx,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1")),
+	/*****   Pin 115~119   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_ur1_cts_n,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_ur1_rts_n,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_i2c_scl_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c0")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_i2c_sda_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c0")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_i2c_scl_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c1")),
+	/*****   Pin 120~124   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_i2c_sda_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c1")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_i2c_scl_6,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c6")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_21,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pwm")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_22,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pwm")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_23,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pwm"),
+		RTK_FUNCTION(0x2, "uart2_1")),
+	/*****   Pin 125~129   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_24,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pwm"),
+		RTK_FUNCTION(0x2, "uart2_1")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_25,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rtc")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_i2c_sda_6,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c6")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_etn_led_link,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "etn_led"),
+		RTK_FUNCTION(0x2, "pwm")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_etn_led_rxtx,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "etn_led"),
+		RTK_FUNCTION(0x2, "pwm")),
+	/*****   Pin 130~134   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_nat_led_0,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nat_led"),
+		RTK_FUNCTION(0x2, "pwm"),
+		RTK_FUNCTION(0x3, "sc")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_nat_led_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nat_led"),
+		RTK_FUNCTION(0x2, "pwm"),
+		RTK_FUNCTION(0x3, "sc")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_nat_led_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nat_led"),
+		RTK_FUNCTION(0x3, "sc")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_nat_led_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "nat_led"),
+		RTK_FUNCTION(0x3, "sc")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_33,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "uart2_1")),
+	/*****   Pin 135   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_iso_gpio_34,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "uart2_1")),
+	/*****   Pin 136~   *****/
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_hi_loc,
+		RTK_FUNCTION(0x1, "hi_loc_misc"),
+		RTK_FUNCTION(0x2, "hi_loc_nf")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_ejtag_scpu_loc,
+		RTK_FUNCTION(0x1, "scpu_ejtag_loc_gpio"),
+		RTK_FUNCTION(0x2, "scpu_ejtag_loc_cr")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_sf_en,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_arm_trace_dbg_en,
+		RTK_FUNCTION(0x0, "arm_trace_disable"),
+		RTK_FUNCTION(0x1, "arm_trace_enable")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_debug_p2s_enable,
+		RTK_FUNCTION(0x0, "p2s_disable"),
+		RTK_FUNCTION(0x1, "p2s_enable")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_tp0_loc,
+		RTK_FUNCTION(0x0, "tp0_loc_tp0"),
+		RTK_FUNCTION(0x0, "tp0_loc_tp1"),
+		RTK_FUNCTION(0x1, "tp0_loc_rgmii0_tx")),
+	RTK_PIN(RTK_PINCTRL_PIN_SB2_tp1_loc,
+		RTK_FUNCTION(0x0, "tp1_loc_tp1"),
+		RTK_FUNCTION(0x0, "tp1_loc_tp0"),
+		RTK_FUNCTION(0x1, "tp1_loc_rgmii0_rx")),
+	RTK_PIN(RTK_PINCTRL_PIN_DISP_ai_loc,
+		RTK_FUNCTION(0x1, "ai_loc_main"),
+		RTK_FUNCTION(0x2, "ai_loc_disp")),
+	RTK_PIN(RTK_PINCTRL_PIN_CR_sdio_loc,
+		RTK_FUNCTION(0x1, "sdio_loc_sdio"),
+		RTK_FUNCTION(0x2, "sdio_loc_mmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_pwm_23_open_drain_en_loc0,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_pwm_01_open_drain_en_loc0,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_pwm_23_open_drain_en_loc1,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_pwm_01_open_drain_en_loc1,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_ejtag_avcpu_loc,
+		RTK_FUNCTION(0x1, "acpu_ejtag_loc_iso"),
+		RTK_FUNCTION(0x2, "acpu_ejtag_loc_nf")),
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_ur2_loc,
+		RTK_FUNCTION(0x1, "uart2_0"),//iso_2_3_4_5
+		RTK_FUNCTION(0x2, "uart2_1")),//iso_23_24_33_34
+	RTK_PIN(RTK_PINCTRL_PIN_ISO_i2c_tg_enable,
+		RTK_FUNCTION(0x0, "i2c_tg_enable"),
+		RTK_FUNCTION(0x1, "i2c_tg_disable")),
+};
+
+#endif /* __PINCTRL_RTK129X_H */
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd139x.c b/drivers/pinctrl/realtek/pinctrl-rtd139x.c
new file mode 100644
index 00000000..bba7ae6
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd139x.c
@@ -0,0 +1,921 @@
+/*
+ * Realtek pin controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include "pinctrl-rtd139x.h"
+#include <linux/io.h>
+#include <linux/clk.h>
+#include <linux/gpio.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/pinctrl/consumer.h>
+#include <linux/pinctrl/machine.h>
+#include <linux/pinctrl/pinctrl.h>
+#include <linux/pinctrl/pinconf-generic.h>
+#include <linux/pinctrl/pinmux.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include "../core.h"
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+static u32 *pinctrl_reg_values;
+
+static const struct RTK_pinctrl_desc rtk139x_pinctrl_data = {
+	.pins = rtk_pins,
+	.npins = ARRAY_SIZE(rtk_pins),
+};
+
+static void RTK_pmx_set(struct pinctrl_dev *pctldev,
+	unsigned int pin, u8 config)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	void __iomem *addr;
+	u32 val;
+	u32 mask;
+
+	if (pin_regmap[pin].pmux_regoff == PMUX_UNSUPPORT)
+		return;
+
+	if (pin_regmap[pin].pmux_base != PMUX_BASE_ISO)
+		RTK_PINCTRL_ERR("[%s] Unknow pmux_base\n", __func__);
+	addr = pctl->iso_membase + pin_regmap[pin].pmux_regoff;
+
+	RTK_PINCTRL_DBG("[%s] Addr(0x%08llx), bit=%u, config=%u",
+		__func__, (u64)addr, pin_regmap[pin].pmux_regbit, config);
+
+	val = readl(addr);
+	mask =	pin_regmap[pin].pmux_regbitmsk << pin_regmap[pin].pmux_regbit;
+	writel(((val & ~mask) | (config << pin_regmap[pin].pmux_regbit)), addr);
+
+	RTK_PINCTRL_DBG("[%s] Addr(0x%08llx) final_val=0x%08x",
+			__func__, (u64)addr, readl(addr));
+
+}
+
+static struct RTK_pinctrl_group *
+RTK_pinctrl_find_group_by_name(struct RTK_pinctrl *pctl, const char *group)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s] name = %s", __func__, group);
+	for (i = 0; i < pctl->ngroups; i++) {
+		struct RTK_pinctrl_group *grp = pctl->groups + i;
+
+		if (!strcmp(grp->name, group))
+			return grp;
+	}
+
+	return NULL;
+}
+
+static struct RTK_pinctrl_function *
+RTK_pinctrl_find_function_by_name(struct RTK_pinctrl *pctl,
+				    const char *name)
+{
+	struct RTK_pinctrl_function *func = pctl->functions;
+	int i;
+	/*RTK_PINCTRL_DBG("[%s]", __func__);*/
+	for (i = 0; i < pctl->nfunctions; i++) {
+		if (!func[i].name)
+			break;
+
+		if (!strcmp(func[i].name, name))
+			return func + i;
+	}
+
+	return NULL;
+}
+
+static struct RTK_desc_function *
+RTK_pinctrl_desc_find_function_by_name(struct RTK_pinctrl *pctl,
+					 const char *pin_name,
+					 const char *func_name)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s] pin_name=%s, func_name=%s",
+			__func__, pin_name, func_name);
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+
+		if (!strcmp(pin->pin.name, pin_name)) {
+			struct RTK_desc_function *func = pin->functions;
+
+			while (func->name) {
+				if (!strcmp(func->name, func_name))
+					return func;
+
+				func++;
+			}
+		}
+	}
+
+	return NULL;
+}
+
+static int RTK_pctrl_get_groups_count(struct pinctrl_dev *pctldev)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] pctl->ngroups=%d",
+			__func__, pctl->ngroups);
+	return pctl->ngroups;
+}
+
+static const char *RTK_pctrl_get_group_name(struct pinctrl_dev *pctldev,
+					      unsigned int group)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	/*RTK_PINCTRL_DBG("[%s] group.name=%s",
+	 *		__func__, pctl->groups[group].name);
+	 */
+	return pctl->groups[group].name;
+}
+
+static int RTK_pctrl_get_group_pins(struct pinctrl_dev *pctldev,
+				      unsigned int group,
+				      const unsigned int **pins,
+				      unsigned int *num_pins)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*pins = (unsigned int *)&pctl->groups[group].pin;
+	*num_pins = 1;
+
+	return 0;
+}
+
+static int RTK_pctrl_dt_node_to_map(struct pinctrl_dev *pctldev,
+				      struct device_node *node,
+				      struct pinctrl_map **map,
+				      unsigned int *num_maps)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	unsigned long *pinconfig;
+	struct property *prop;
+	const char *function;
+	const char *group;
+	int ret, nmaps, i = 0;
+	u32 val;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+
+	*map = NULL;
+	*num_maps = 0;
+
+	ret = of_property_read_string(node, "realtek,function", &function);
+	if (ret) {
+		printk(
+			"missing realtek,function property in node %s\n",
+			node->name);
+		return -EINVAL;
+	}
+
+	nmaps = of_property_count_strings(node, "realtek,pins") * 2;
+	if (nmaps < 0) {
+		printk(
+			"missing realtek,pins property in node %s\n",
+			node->name);
+		return -EINVAL;
+	}
+
+	*map = kmalloc_array(nmaps, sizeof(struct pinctrl_map), GFP_KERNEL);
+	if (!map)
+		return -ENOMEM;
+
+	of_property_for_each_string(node, "realtek,pins", prop, group) {
+		struct RTK_pinctrl_group *grp =
+			RTK_pinctrl_find_group_by_name(pctl, group);
+		int j = 0, configlen = 0;
+
+		if (!grp) {
+			printk("unknown pin %s", group);
+			continue;
+		}
+
+		if (!RTK_pinctrl_desc_find_function_by_name(pctl,
+							      grp->name,
+							      function)) {
+			printk("unsupported function %s on pin %s",
+				function, group);
+			continue;
+		}
+
+		(*map)[i].type = PIN_MAP_TYPE_MUX_GROUP;
+		(*map)[i].data.mux.group = group;
+		(*map)[i].data.mux.function = function;
+
+		i++;
+
+		(*map)[i].type = PIN_MAP_TYPE_CONFIGS_GROUP;
+		(*map)[i].data.configs.group_or_pin = group;
+
+		if (of_find_property(node, "realtek,schmitt", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,drive", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,pull_en", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,pull_sel", NULL))
+			configlen++;
+
+		RTK_PINCTRL_DBG("[%s] configlen %d", __func__, configlen);
+
+		if (configlen) {
+			pinconfig = kcalloc(configlen,
+					sizeof(*pinconfig), GFP_KERNEL);
+		} else {
+			/* Prevent failed to register map default*/
+			configlen = 1;
+			pinconfig = kzalloc(1 * sizeof(*pinconfig), GFP_KERNEL);
+			pinconfig[j++] = pinconf_to_config_packed
+						(PIN_CONFIG_END, 0);
+		}
+
+		if (!of_property_read_u32(node, "realtek,schmitt", &val)) {
+			u16 schmitt_enable;
+
+			if (val == 0)
+				schmitt_enable = 0;
+			else
+				schmitt_enable = 1;
+
+			pinconfig[j++] = pinconf_to_config_packed
+					(PIN_CONFIG_INPUT_SCHMITT_ENABLE,
+					schmitt_enable);
+		}
+
+		if (!of_property_read_u32(node, "realtek,drive", &val)) {
+			pinconfig[j++] = pinconf_to_config_packed
+					(PIN_CONFIG_DRIVE_STRENGTH, val);
+		}
+
+		if (!of_property_read_u32(node, "realtek,pull_en", &val)) {
+			enum pin_config_param pull = PIN_CONFIG_END;
+
+			if (val == 0)
+				pull = PIN_CONFIG_BIAS_DISABLE;
+			else if (val == 1)
+				pull = PIN_CONFIG_DRIVE_PUSH_PULL;
+			pinconfig[j++] = pinconf_to_config_packed(pull, 0);
+		}
+
+		if (!of_property_read_u32(node, "realtek,pull_sel", &val)) {
+			enum pin_config_param pull = PIN_CONFIG_END;
+
+			if (val == 0)
+				pull = PIN_CONFIG_BIAS_PULL_DOWN;
+			else if (val == 1)
+				pull = PIN_CONFIG_BIAS_PULL_UP;
+			pinconfig[j++] = pinconf_to_config_packed(pull, 1);
+		}
+
+		(*map)[i].data.configs.configs = pinconfig;
+		(*map)[i].data.configs.num_configs = configlen;
+
+		i++;
+	}
+
+	*num_maps = nmaps;
+
+	return 0;
+}
+
+static void RTK_pctrl_dt_free_map(struct pinctrl_dev *pctldev,
+				    struct pinctrl_map *map,
+				    unsigned int num_maps)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	for (i = 0; i < num_maps; i++) {
+		if (map[i].type == PIN_MAP_TYPE_CONFIGS_GROUP)
+			kfree(map[i].data.configs.configs);
+	}
+
+	kfree(map);
+}
+
+static void RTK_pctrl_dbg_show(struct pinctrl_dev *pctldev, struct seq_file *s,
+			  unsigned offset)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_desc_function *func = rtk_pins[offset].functions;
+	void __iomem *addr;
+	u32 val;
+	u32 mask;
+	u8 pin_val;
+	int is_map;
+
+	if(pin_regmap[offset].pmux_regoff == PMUX_UNSUPPORT)
+		return;
+
+	addr = pctl->iso_membase + pin_regmap[offset].pmux_regoff;
+	val = readl(addr);
+	mask =pin_regmap[offset].pmux_regbitmsk << pin_regmap[offset].pmux_regbit;
+	pin_val = (val & mask) >> pin_regmap[offset].pmux_regbit;
+
+	is_map = 0;
+	seq_printf(s, "function: ");
+	while (func->name) {
+		if (func->muxval == pin_val) {
+			is_map = 1;
+			seq_printf(s, "[%s] ",func->name);
+		} else {
+			seq_printf(s, "%s ",func->name);
+		}
+		func++;
+	}
+	if (!is_map)
+		seq_printf(s, "[not defined] ");
+}
+
+
+static const struct pinctrl_ops RTK_pctrl_ops = {
+	.dt_node_to_map		= RTK_pctrl_dt_node_to_map,
+	.dt_free_map		= RTK_pctrl_dt_free_map,
+	.get_groups_count	= RTK_pctrl_get_groups_count,
+	.get_group_name		= RTK_pctrl_get_group_name,
+	.get_group_pins		= RTK_pctrl_get_group_pins,
+	.pin_dbg_show		= RTK_pctrl_dbg_show,
+};
+
+static int RTK_pconf_parse_conf(struct pinctrl_dev *pctldev,
+	unsigned int pin, enum pin_config_param param,
+	enum pin_config_param arg)
+{
+	void __iomem *addr;
+	u8 set_val;
+	u16 strength;
+	u32 val, mask;
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] pin=%u, config_param=%u, config_argument=%u",
+			__func__, pin, param, arg);
+
+	if (pin_regmap[pin].pcof_regoff == PCOF_UNSUPPORT)
+		return 0;
+	if (pin_regmap[pin].pmux_base != PMUX_BASE_ISO)
+		RTK_PINCTRL_ERR("[%s] Unknow pmux_base\n", __func__);
+	addr = pctl->iso_membase + pin_regmap[pin].pcof_regoff;
+
+	switch (param) {
+	case PIN_CONFIG_INPUT_SCHMITT:
+		break;
+	case PIN_CONFIG_INPUT_SCHMITT_ENABLE:
+		set_val = arg;
+		if (set_val)
+			set_val = 1;
+		else
+			set_val = 0;
+
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_SCHM);
+		writel(((val & ~mask)|
+			(set_val <<
+			(pin_regmap[pin].pcof_regbit+RTK_PCONF_SCHM))),
+			addr);
+		break;
+	case PIN_CONFIG_DRIVE_STRENGTH:
+		strength = arg;
+		switch (pin_regmap[pin].pcof_cur_strgh) {
+		case PADDRI_4_8:
+			if (strength == 4)
+				set_val = 0;
+			else if (strength == 8)
+				set_val = 1;
+			else
+				return -EINVAL;
+			break;
+		case PADDRI_2_4:
+			if (strength == 2)
+				set_val = 0;
+			else if (strength == 4)
+				set_val = 1;
+			else
+				return -EINVAL;
+			break;
+		case PADDRI_UNSUPPORT:
+		default:
+			return -EINVAL;
+		}
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_CURR);
+		writel(((val & ~mask)|
+			(set_val <<
+			(pin_regmap[pin].pcof_regbit+RTK_PCONF_CURR))),
+			addr);
+		break;
+	case PIN_CONFIG_DRIVE_PUSH_PULL:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_PULEN);
+		writel(((val & ~mask)|
+			(1 << (pin_regmap[pin].pcof_regbit+RTK_PCONF_PULEN))),
+			addr);
+		break;
+	case PIN_CONFIG_BIAS_DISABLE:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_PULEN);
+		writel(((val & ~mask)|
+			(0 << (pin_regmap[pin].pcof_regbit+RTK_PCONF_PULEN))),
+			addr);
+		break;
+	case PIN_CONFIG_BIAS_PULL_UP:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_PULSEL);
+		writel(((val & ~mask)|
+			(1 << (pin_regmap[pin].pcof_regbit+RTK_PCONF_PULSEL))),
+			addr);
+		break;
+	case PIN_CONFIG_BIAS_PULL_DOWN:
+		val = readl(addr);
+		mask =	1 << (pin_regmap[pin].pcof_regbit + RTK_PCONF_PULSEL);
+		writel(((val & ~mask)|
+			(0 << (pin_regmap[pin].pcof_regbit+RTK_PCONF_PULSEL))),
+			addr);
+		break;
+	default:
+		break;
+	}
+
+	return 0;
+}
+
+static int RTK_pconf_group_get(struct pinctrl_dev *pctldev,
+				 unsigned int group,
+				 unsigned long *config)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*config = pctl->groups[group].config;
+
+	return 0;
+}
+
+static int RTK_pconf_group_set(struct pinctrl_dev *pctldev,
+				 unsigned int group,
+				 unsigned long *configs,
+				 unsigned int num_configs)
+{
+	u32 i;
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = &pctl->groups[group];
+
+	RTK_PINCTRL_DBG("[%s] g->pin=%d, g->name =%s, num_configs = %u",
+				__func__, g->pin, g->name, num_configs);
+
+	if (pin_regmap[g->pin].pcof_regoff == PCOF_UNSUPPORT) {
+		RTK_PINCTRL_DBG(
+			"[%s] g->pin(%d) g->name(%s) not support pin config"
+			, __func__, g->pin, g->name);
+		g->config = configs[num_configs-1];
+		return 0;
+	}
+
+	for (i = 0; i < num_configs; i++) {
+		RTK_pconf_parse_conf(pctldev, g->pin,
+			pinconf_to_config_param(configs[i]),
+			pinconf_to_config_argument(configs[i]));
+
+		g->config = configs[i];
+	}
+
+	return 0;
+}
+
+static const struct pinconf_ops RTK_pconf_ops = {
+	.pin_config_group_get	= RTK_pconf_group_get,
+	.pin_config_group_set	= RTK_pconf_group_set,
+};
+
+static int RTK_pmx_get_funcs_cnt(struct pinctrl_dev *pctldev)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] pctl->nfunctions =%d",
+			__func__, pctl->nfunctions);
+	return pctl->nfunctions;
+}
+
+static const char *RTK_pmx_get_func_name(struct pinctrl_dev *pctldev,
+					   unsigned int function)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] function[%d] = %s", __func__,
+			function, pctl->functions[function].name);
+	return pctl->functions[function].name;
+}
+
+static int RTK_pmx_get_func_groups(struct pinctrl_dev *pctldev,
+				     unsigned int function,
+				     const char * const **groups,
+				     unsigned int * const num_groups)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*groups = pctl->functions[function].groups;
+	*num_groups = pctl->functions[function].ngroups;
+
+	return 0;
+}
+
+static int RTK_pmx_enable(struct pinctrl_dev *pctldev,
+			    unsigned int function,
+			    unsigned int group)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = pctl->groups + group;
+	struct RTK_pinctrl_function *func = pctl->functions + function;
+	struct RTK_desc_function *desc =
+		RTK_pinctrl_desc_find_function_by_name(pctl,
+							 g->name,
+							 func->name);
+	RTK_PINCTRL_DBG("[%s] g->name=%s, func->name=%s",
+				__func__, g->name, func->name);
+	if (!desc)
+		return -EINVAL;
+
+	RTK_pmx_set(pctldev, g->pin, desc->muxval);
+
+	return 0;
+}
+
+void gpio_pinctrl_control(struct gpio_chip *gc, int gpio,
+	int direction, int value)
+{
+	struct device_node *np = gc->of_node;
+	struct of_phandle_args pinspec;
+	struct pinctrl_dev *pctldev;
+	int ret, pin;
+
+	ret = of_parse_phandle_with_fixed_args(np, "gpio-ranges", 3,
+					0, &pinspec);
+	if (ret)
+		RTK_PINCTRL_ERR("Can't get pinspec");
+
+	pctldev = of_pinctrl_get(pinspec.np);
+	pin = gpio + pinspec.args[1];
+
+	if (direction) {
+		if (value == 0 || value == 1) {
+			RTK_pconf_parse_conf(pctldev, pin, PIN_CONFIG_BIAS_DISABLE, 0);
+		} else if (value == 2 || value == 3) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_UP, 0);
+		} else if (value == 4 || value == 5) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_DOWN, 0);
+		}
+	} else {
+		if (value == 1) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_UP, 0);
+		} else if (value == 0) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_DOWN, 0);
+		} else if (value == 2) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_DISABLE, 0);
+		}
+	}
+}
+
+static int
+RTK_pmx_gpio_request_enable(struct pinctrl_dev *pctldev,
+				    struct pinctrl_gpio_range *range,
+				    unsigned int offset)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = pctl->groups + offset;
+	struct RTK_desc_function *desc;
+	const char *func;
+	int ret;
+
+	func = "gpio";
+	RTK_PINCTRL_DBG("[%s] gpio_offset=%u", __func__, offset);
+	desc = RTK_pinctrl_desc_find_function_by_name(pctl,
+							g->name,
+							func);
+	if (!desc) {
+		ret = -EINVAL;
+		RTK_PINCTRL_ERR(
+			"Set gpio pinmux fail, Pin(%s) offset=%u\n"
+			, g->name, offset);
+		goto error;
+	}
+
+	RTK_pmx_set(pctldev, offset, desc->muxval);
+
+	ret = 0;
+
+error:
+	return ret;
+}
+
+static void
+RTK_pmx_gpio_disable_free(struct pinctrl_dev *pctldev,
+				    struct pinctrl_gpio_range *range,
+				    unsigned int offset)
+{
+	RTK_PINCTRL_DBG("[%s]", __func__);
+/*TODO : need to add gpio related api*/
+}
+
+
+
+static const struct pinmux_ops RTK_pmx_ops = {
+	.get_functions_count = RTK_pmx_get_funcs_cnt,
+	.get_function_name = RTK_pmx_get_func_name,
+	.get_function_groups = RTK_pmx_get_func_groups,
+	.set_mux = RTK_pmx_enable,
+	.gpio_request_enable = RTK_pmx_gpio_request_enable,
+	.gpio_disable_free = RTK_pmx_gpio_disable_free,
+};
+
+static struct pinctrl_desc RTK_pctrl_desc = {
+	.confops	= &RTK_pconf_ops,
+	.pctlops	= &RTK_pctrl_ops,
+	.pmxops		= &RTK_pmx_ops,
+};
+
+
+static const struct of_device_id RTK_pinctrl_match[] = {
+	{ .compatible = "realtek,rtk139x-pinctrl",
+		.data = (void *)&rtk139x_pinctrl_data },
+	{ /* Sentinel */ },
+};
+MODULE_DEVICE_TABLE(of, RTK_pinctrl_match);
+
+static int RTK_pinctrl_add_function(struct RTK_pinctrl *pctl,
+					const char *name)
+{
+	struct RTK_pinctrl_function *func = pctl->functions;
+
+	while (func->name) {
+		/* function already there */
+		if (strcmp(func->name, name) == 0) {
+			func->ngroups++;
+			return -EEXIST;
+		}
+		func++;
+	}
+
+	func->name = name;
+	func->ngroups = 1;
+
+	pctl->nfunctions++;
+
+	return 0;
+}
+
+static int RTK_pinctrl_build_state(struct platform_device *pdev)
+{
+	struct RTK_pinctrl *pctl = platform_get_drvdata(pdev);
+	int i;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	pctl->ngroups = pctl->desc->npins;
+
+	/* Allocate groups */
+	pctl->groups = devm_kzalloc(&pdev->dev,
+				    pctl->ngroups * sizeof(*pctl->groups),
+				    GFP_KERNEL);
+	if (!pctl->groups)
+		return -ENOMEM;
+
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_pinctrl_group *group = pctl->groups + i;
+
+		group->name = pin->pin.name;
+		group->pin = pin->pin.number;
+	}
+
+	/*
+	 * We suppose that we won't have any more functions than pins,
+	 * we'll reallocate that later anyway
+	 */
+	pctl->functions = devm_kzalloc(&pdev->dev,
+				pctl->desc->npins * sizeof(*pctl->functions),
+				GFP_KERNEL);
+	if (!pctl->functions)
+		return -ENOMEM;
+
+	/* Count functions and their associated groups */
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_desc_function *func = pin->functions;
+
+		while (func->name) {
+			RTK_pinctrl_add_function(pctl, func->name);
+			func++;
+		}
+	}
+
+	pctl->functions = krealloc(pctl->functions,
+				pctl->nfunctions * sizeof(*pctl->functions),
+				GFP_KERNEL);
+
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_desc_function *func = pin->functions;
+
+		while (func->name) {
+			struct RTK_pinctrl_function *func_item;
+			const char **func_grp;
+
+			func_item = RTK_pinctrl_find_function_by_name(pctl,
+								func->name);
+			if (!func_item)
+				return -EINVAL;
+
+			if (!func_item->groups) {
+				func_item->groups =
+					devm_kzalloc(&pdev->dev,
+						func_item->ngroups *
+						sizeof(*func_item->groups),
+						GFP_KERNEL);
+				if (!func_item->groups)
+					return -ENOMEM;
+			}
+
+			func_grp = func_item->groups;
+			while (*func_grp)
+				func_grp++;
+
+			*func_grp = pin->pin.name;
+			func++;
+		}
+	}
+
+	return 0;
+}
+
+static int RTK_pinctrl_probe(struct platform_device *pdev)
+{
+	struct device_node *node = pdev->dev.of_node;
+	const struct of_device_id *device;
+	struct pinctrl_pin_desc *pins;
+	struct RTK_pinctrl *pctl;
+	int i, ret;
+
+	RTK_PINCTRL_INF("driver init");
+
+	pctl = devm_kzalloc(&pdev->dev, sizeof(*pctl), GFP_KERNEL);
+	if (!pctl)
+		return -ENOMEM;
+	platform_set_drvdata(pdev, pctl);
+
+	pctl->iso_membase = of_iomap(node, 0);
+	if (!pctl->iso_membase) {
+		RTK_PINCTRL_ERR("of_iomap iso_membase fail");
+		return -ENOMEM;
+	}
+
+	RTK_PINCTRL_DBG("iso_membase(0x%p)", pctl->iso_membase);
+
+	device = of_match_device(RTK_pinctrl_match, &pdev->dev);
+	if (!device) {
+		RTK_PINCTRL_ERR("of_match_device fail");
+		return -ENODEV;
+	}
+
+	pctl->desc = (struct RTK_pinctrl_desc *)device->data;
+
+	ret = RTK_pinctrl_build_state(pdev);
+	if (ret) {
+		RTK_PINCTRL_ERR("RTK_pinctrl_build_state fail");
+		return ret;
+	}
+
+	pins = devm_kzalloc(&pdev->dev,
+			    pctl->desc->npins * sizeof(*pins),
+			    GFP_KERNEL);
+	if (!pins) {
+		RTK_PINCTRL_ERR("[%s]devm_kzalloc fail", __func__);
+		return -ENOMEM;
+	}
+
+	for (i = 0; i < pctl->desc->npins; i++)
+		pins[i] = pctl->desc->pins[i].pin;
+
+	RTK_pctrl_desc.name = dev_name(&pdev->dev);
+	RTK_pctrl_desc.owner = THIS_MODULE;
+	RTK_pctrl_desc.pins = pins;
+	RTK_pctrl_desc.npins = pctl->desc->npins;
+	pctl->dev = &pdev->dev;
+	pctl->pctl_dev = pinctrl_register(&RTK_pctrl_desc,
+					  &pdev->dev, pctl);
+	if (!pctl->pctl_dev) {
+		RTK_PINCTRL_ERR("register pinctrl driver fail");
+		return -EINVAL;
+	}
+
+	RTK_PINCTRL_INF("init done");
+
+	return 0;
+}
+
+int RTK_pinctrl_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct RTK_pinctrl *pctl;
+	void __iomem *addr;
+	unsigned int i;
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		RTK_PINCTRL_INF("skip %s under DomU", __func__);
+		return 0;
+	}
+#endif
+	RTK_PINCTRL_INF("Enter %s", __func__);
+
+	pctl = platform_get_drvdata(pdev);
+
+	pinctrl_reg_values = kcalloc(ARRAY_SIZE(pinmux_reg_list), sizeof(u32),
+				GFP_KERNEL);
+
+	for (i = 0; i < ARRAY_SIZE(pinmux_reg_list); i++) {
+		if (pinmux_reg_list[i].reg_base != PMUX_BASE_ISO)
+			RTK_PINCTRL_ERR("[%s] Unknow pmux_base\n", __func__);
+		addr = pctl->iso_membase + pinmux_reg_list[i].reg_offset;
+		/*Store pinmux registers*/
+		pinctrl_reg_values[i] = readl(addr);
+	}
+
+	RTK_PINCTRL_INF("Exit %s", __func__);
+	return 0;
+}
+
+int RTK_pinctrl_resume(struct platform_device *pdev)
+{
+	struct RTK_pinctrl *pctl;
+	void __iomem *addr;
+	unsigned int i;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		RTK_PINCTRL_INF("skip %s under DomU", __func__);
+		return 0;
+	}
+#endif
+	RTK_PINCTRL_INF("Enter %s", __func__);
+
+	pctl = platform_get_drvdata(pdev);
+
+	for (i = 0; i < ARRAY_SIZE(pinmux_reg_list); i++) {
+		if (pinmux_reg_list[i].reg_base != PMUX_BASE_ISO)
+			RTK_PINCTRL_ERR("[%s] Unknow pmux_base\n", __func__);
+		addr = pctl->iso_membase + pinmux_reg_list[i].reg_offset;
+		/*Restore pinmux registers*/
+		writel(pinctrl_reg_values[i], addr);
+	}
+
+	kfree(pinctrl_reg_values);
+
+	RTK_PINCTRL_INF("Exit %s", __func__);
+	return 0;
+}
+
+static struct platform_driver RTK_pinctrl_driver = {
+	.probe = RTK_pinctrl_probe,
+	.driver = {
+		.name = "rtk-pinctrl",
+		.owner = THIS_MODULE,
+		.of_match_table = RTK_pinctrl_match,
+	},
+	.suspend = RTK_pinctrl_suspend,
+	.resume = RTK_pinctrl_resume,
+};
+
+static int  rtk_pinctrl_init(void)
+{
+	return platform_driver_register(&RTK_pinctrl_driver);
+}
+postcore_initcall(rtk_pinctrl_init);
+
+MODULE_DESCRIPTION("RTK pinctrl driver");
+MODULE_LICENSE("GPL");
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd139x.h b/drivers/pinctrl/realtek/pinctrl-rtd139x.h
new file mode 100644
index 00000000..a782646
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd139x.h
@@ -0,0 +1,697 @@
+/*
+ * Realtek pin controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#ifndef __PINCTRL_RTK139X_H
+#define __PINCTRL_RTK139X_H
+
+#include <linux/kernel.h>
+#include <linux/pinctrl/pinctrl.h>
+
+//#define RTK_PINCTRL_DEBUG
+#ifdef RTK_PINCTRL_DEBUG
+#define RTK_PINCTRL_DBG(fmt, ...) pr_info("[PINCTRL] " fmt "\n", ## __VA_ARGS__)
+#else
+#define RTK_PINCTRL_DBG(fmt, ...) do {} while (0)
+#endif
+
+#define RTK_PINCTRL_INF(fmt, ...) pr_info("[PINCTRL] " fmt "\n", ## __VA_ARGS__)
+#define RTK_PINCTRL_ERR(fmt, ...) pr_err("[PINCTRL Error] " fmt "\n", ## __VA_ARGS__)
+
+#define P_ISO_BASE			 0
+
+#define RTK_PCONF_SCHM		2
+#define RTK_PCONF_PULEN		1
+#define RTK_PCONF_PULSEL	0
+#define RTK_PCONF_CURR		-1
+
+
+/* GPIO muxpad0*/
+#define RTK_PINCTRL_PIN_gpio_0				PINCTRL_PIN(P_ISO_BASE + 0, "gpio_0")
+#define RTK_PINCTRL_PIN_gpio_1				PINCTRL_PIN(P_ISO_BASE + 1, "gpio_1")
+#define RTK_PINCTRL_PIN_gpio_2				PINCTRL_PIN(P_ISO_BASE + 2, "gpio_2")
+#define RTK_PINCTRL_PIN_gpio_3				PINCTRL_PIN(P_ISO_BASE + 3, "gpio_3")
+#define RTK_PINCTRL_PIN_gpio_4				PINCTRL_PIN(P_ISO_BASE + 4, "gpio_4")
+#define RTK_PINCTRL_PIN_gpio_5				PINCTRL_PIN(P_ISO_BASE + 5, "gpio_5")
+#define RTK_PINCTRL_PIN_gpio_6				PINCTRL_PIN(P_ISO_BASE + 6, "gpio_6")
+#define RTK_PINCTRL_PIN_gpio_7				PINCTRL_PIN(P_ISO_BASE + 7, "gpio_7")
+#define RTK_PINCTRL_PIN_gpio_8				PINCTRL_PIN(P_ISO_BASE + 8, "gpio_8")
+#define RTK_PINCTRL_PIN_gpio_9				PINCTRL_PIN(P_ISO_BASE + 9, "gpio_9")
+#define RTK_PINCTRL_PIN_gpio_10				PINCTRL_PIN(P_ISO_BASE + 10, "gpio_10")
+#define RTK_PINCTRL_PIN_gpio_11				PINCTRL_PIN(P_ISO_BASE + 11, "gpio_11")
+
+/* GPIO muxpad1*/
+#define RTK_PINCTRL_PIN_gpio_12				PINCTRL_PIN(P_ISO_BASE + 12, "gpio_12")
+#define RTK_PINCTRL_PIN_gpio_13				PINCTRL_PIN(P_ISO_BASE + 13, "gpio_13")
+#define RTK_PINCTRL_PIN_gpio_14				PINCTRL_PIN(P_ISO_BASE + 14, "gpio_14")
+#define RTK_PINCTRL_PIN_gpio_15				PINCTRL_PIN(P_ISO_BASE + 15, "gpio_15")
+#define RTK_PINCTRL_PIN_gpio_16				PINCTRL_PIN(P_ISO_BASE + 16, "gpio_16")
+#define RTK_PINCTRL_PIN_gpio_17				PINCTRL_PIN(P_ISO_BASE + 17, "gpio_17")
+#define RTK_PINCTRL_PIN_gpio_18				PINCTRL_PIN(P_ISO_BASE + 18, "gpio_18")
+#define RTK_PINCTRL_PIN_gpio_19				PINCTRL_PIN(P_ISO_BASE + 19, "gpio_19")
+#define RTK_PINCTRL_PIN_gpio_20				PINCTRL_PIN(P_ISO_BASE + 20, "gpio_20")
+#define RTK_PINCTRL_PIN_gpio_21				PINCTRL_PIN(P_ISO_BASE + 21, "gpio_21")
+#define RTK_PINCTRL_PIN_gpio_22				PINCTRL_PIN(P_ISO_BASE + 22, "gpio_22")
+#define RTK_PINCTRL_PIN_gpio_23				PINCTRL_PIN(P_ISO_BASE + 23, "gpio_23")
+#define RTK_PINCTRL_PIN_usb_cc2				PINCTRL_PIN(P_ISO_BASE + 24, "usb_cc2")
+#define RTK_PINCTRL_PIN_gpio_25				PINCTRL_PIN(P_ISO_BASE + 25, "gpio_25")
+#define RTK_PINCTRL_PIN_gpio_26				PINCTRL_PIN(P_ISO_BASE + 26, "gpio_26")
+
+/* GPIO muxpad2*/
+#define RTK_PINCTRL_PIN_gpio_27				PINCTRL_PIN(P_ISO_BASE + 27, "gpio_27")
+#define RTK_PINCTRL_PIN_gpio_28				PINCTRL_PIN(P_ISO_BASE + 28, "gpio_28")
+#define RTK_PINCTRL_PIN_gpio_29				PINCTRL_PIN(P_ISO_BASE + 29, "gpio_29")
+#define RTK_PINCTRL_PIN_gpio_30				PINCTRL_PIN(P_ISO_BASE + 30, "gpio_30")
+#define RTK_PINCTRL_PIN_gpio_31				PINCTRL_PIN(P_ISO_BASE + 31, "gpio_31")
+#define RTK_PINCTRL_PIN_gpio_32				PINCTRL_PIN(P_ISO_BASE + 32, "gpio_32")
+#define RTK_PINCTRL_PIN_gpio_33				PINCTRL_PIN(P_ISO_BASE + 33, "gpio_33")
+#define RTK_PINCTRL_PIN_gpio_34				PINCTRL_PIN(P_ISO_BASE + 34, "gpio_34")
+#define RTK_PINCTRL_PIN_gpio_35				PINCTRL_PIN(P_ISO_BASE + 35, "gpio_35")
+#define RTK_PINCTRL_PIN_gpio_36				PINCTRL_PIN(P_ISO_BASE + 36, "gpio_36")
+#define RTK_PINCTRL_PIN_gpio_37				PINCTRL_PIN(P_ISO_BASE + 37, "gpio_37")
+#define RTK_PINCTRL_PIN_gpio_38				PINCTRL_PIN(P_ISO_BASE + 38, "gpio_38")
+
+/* GPIO muxpad3*/
+#define RTK_PINCTRL_PIN_gpio_39				PINCTRL_PIN(P_ISO_BASE + 39, "gpio_39")
+#define RTK_PINCTRL_PIN_gpio_40				PINCTRL_PIN(P_ISO_BASE + 40, "gpio_40")
+#define RTK_PINCTRL_PIN_gpio_41				PINCTRL_PIN(P_ISO_BASE + 41, "gpio_41")
+#define RTK_PINCTRL_PIN_gpio_42				PINCTRL_PIN(P_ISO_BASE + 42, "gpio_42")
+#define RTK_PINCTRL_PIN_gpio_43				PINCTRL_PIN(P_ISO_BASE + 43, "gpio_43")
+#define RTK_PINCTRL_PIN_gpio_44				PINCTRL_PIN(P_ISO_BASE + 44, "gpio_44")
+#define RTK_PINCTRL_PIN_gpio_45				PINCTRL_PIN(P_ISO_BASE + 45, "gpio_45")
+#define RTK_PINCTRL_PIN_gpio_46				PINCTRL_PIN(P_ISO_BASE + 46, "gpio_46")
+#define RTK_PINCTRL_PIN_gpio_47				PINCTRL_PIN(P_ISO_BASE + 47, "gpio_47")
+#define RTK_PINCTRL_PIN_gpio_48				PINCTRL_PIN(P_ISO_BASE + 48, "gpio_48")
+#define RTK_PINCTRL_PIN_gpio_49				PINCTRL_PIN(P_ISO_BASE + 49, "gpio_49")
+#define RTK_PINCTRL_PIN_gpio_50				PINCTRL_PIN(P_ISO_BASE + 50, "gpio_50")
+
+/*EMMC muxpad4*/
+#define RTK_PINCTRL_PIN_emmc_rst_n			PINCTRL_PIN(P_ISO_BASE + 61, "emmc_rst_n")
+#define RTK_PINCTRL_PIN_emmc_dd_sb			PINCTRL_PIN(P_ISO_BASE + 62, "emmc_dd_sb")
+#define RTK_PINCTRL_PIN_emmc_clk			PINCTRL_PIN(P_ISO_BASE + 63, "emmc_clk")
+#define RTK_PINCTRL_PIN_emmc_cmd			PINCTRL_PIN(P_ISO_BASE + 64, "emmc_cmd")
+#define RTK_PINCTRL_PIN_emmc_data_0			PINCTRL_PIN(P_ISO_BASE + 65, "emmc_data_0")
+#define RTK_PINCTRL_PIN_emmc_data_1			PINCTRL_PIN(P_ISO_BASE + 66, "emmc_data_1")
+#define RTK_PINCTRL_PIN_emmc_data_2			PINCTRL_PIN(P_ISO_BASE + 67, "emmc_data_2")
+#define RTK_PINCTRL_PIN_emmc_data_3			PINCTRL_PIN(P_ISO_BASE + 68, "emmc_data_3")
+#define RTK_PINCTRL_PIN_emmc_data_4			PINCTRL_PIN(P_ISO_BASE + 69, "emmc_data_4")
+#define RTK_PINCTRL_PIN_emmc_data_5			PINCTRL_PIN(P_ISO_BASE + 70, "emmc_data_5")
+#define RTK_PINCTRL_PIN_emmc_data_6			PINCTRL_PIN(P_ISO_BASE + 71, "emmc_data_6")
+#define RTK_PINCTRL_PIN_emmc_data_7			PINCTRL_PIN(P_ISO_BASE + 72, "emmc_data_7")
+
+/*muxpad5*/
+#define RTK_PINCTRL_PIN_spi_ce_n			PINCTRL_PIN(P_ISO_BASE + 57, "spi_ce_n")
+#define RTK_PINCTRL_PIN_spi_sck				PINCTRL_PIN(P_ISO_BASE + 58, "spi_sck")
+#define RTK_PINCTRL_PIN_spi_so				PINCTRL_PIN(P_ISO_BASE + 59, "spi_so")
+#define RTK_PINCTRL_PIN_spi_si				PINCTRL_PIN(P_ISO_BASE + 60, "spi_si")
+#define RTK_PINCTRL_PIN_usb_cc1				PINCTRL_PIN(P_ISO_BASE + 51, "usb_cc1")
+#define RTK_PINCTRL_PIN_prob_0				PINCTRL_PIN(P_ISO_BASE + 52, "prob_0")
+#define RTK_PINCTRL_PIN_prob_1				PINCTRL_PIN(P_ISO_BASE + 53, "prob_1")
+#define RTK_PINCTRL_PIN_ir_rx				PINCTRL_PIN(P_ISO_BASE + 54, "ir_rx")
+#define RTK_PINCTRL_PIN_ur0_rx				PINCTRL_PIN(P_ISO_BASE + 55, "ur0_rx")
+#define RTK_PINCTRL_PIN_ur0_tx				PINCTRL_PIN(P_ISO_BASE + 56, "ur0_tx")
+
+/*muxpad6*/
+#define RTK_PINCTRL_PIN_ur2_loc				PINCTRL_PIN(P_ISO_BASE + 73, "ur2_loc")
+#define RTK_PINCTRL_PIN_gspi_loc			PINCTRL_PIN(P_ISO_BASE + 74, "gspi_loc")
+#define RTK_PINCTRL_PIN_sdio_loc			PINCTRL_PIN(P_ISO_BASE + 75, "sdio_loc")
+#define RTK_PINCTRL_PIN_hi_loc				PINCTRL_PIN(P_ISO_BASE + 76, "hi_loc")
+#define RTK_PINCTRL_PIN_hi_width			PINCTRL_PIN(P_ISO_BASE + 77, "hi_width")
+#define RTK_PINCTRL_PIN_debug_p2s_enable		PINCTRL_PIN(P_ISO_BASE + 78, "debug_p2s_enable")
+#define RTK_PINCTRL_PIN_sf_en				PINCTRL_PIN(P_ISO_BASE + 79, "sf_en")
+#define RTK_PINCTRL_PIN_arm_trace_dbg_en		PINCTRL_PIN(P_ISO_BASE + 80, "arm_trace_dbg_en")
+#define RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc0	PINCTRL_PIN(P_ISO_BASE + 81, "pwm_01_open_drain_en_loc0")
+#define RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc0	PINCTRL_PIN(P_ISO_BASE + 82, "pwm_23_open_drain_en_loc0")
+#define RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc1	PINCTRL_PIN(P_ISO_BASE + 83, "pwm_01_open_drain_en_loc1")
+#define RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc1	PINCTRL_PIN(P_ISO_BASE + 84, "pwm_23_open_drain_en_loc1")
+#define RTK_PINCTRL_PIN_ejtag_avcpu_loc			PINCTRL_PIN(P_ISO_BASE + 85, "ejtag_avcpu_loc")
+#define RTK_PINCTRL_PIN_ejtag_scpu_loc			PINCTRL_PIN(P_ISO_BASE + 86, "ejtag_scpu_loc")
+
+
+enum PMUX_BASE_TYPE {
+	PMUX_BASE_SB2,
+	PMUX_BASE_DISP,
+	PMUX_BASE_CR,
+	PMUX_BASE_ISO
+};
+
+struct rtk_pin_regmap {
+	u8 pmux_base;
+	u16 pmux_regoff;
+	u16 pmux_regbit;
+	u16 pmux_regbitmsk;
+	u16 pcof_regoff;
+	u16 pcof_regbit;
+	u16 pcof_cur_strgh;/*0 : 2&4mA   1:4&8mA*/
+};
+
+struct rtk_pinmux_reg {
+	u8 reg_base;
+	u16 reg_offset;
+};
+
+#define PADDRI_4_8 1
+#define PADDRI_2_4 0
+#define PADDRI_UNSUPPORT 0xFFFF
+
+#define PCOF_UNSUPPORT 0xFFFF
+#define PMUX_UNSUPPORT 0xFFFF
+
+static const struct rtk_pinmux_reg pinmux_reg_list[] = {
+	/* muxpad*/
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x000},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x004},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x008},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x00c},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x010},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x014},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x018},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x01c},
+	/*ISO  pfunc*/
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x020},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x024},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x028},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x02c},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x030},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x034},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x038},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x03c},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x040},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x044},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x048},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x04c},
+	/*emmc pfunc*/
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x050},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x054},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x058},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x05c},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x060},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x064},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x068},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x06c},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x070},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x074},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x078},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x07c},
+};
+
+static const struct rtk_pin_regmap pin_regmap[] = {
+	/*GPIO*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x020, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 0, "gpio_0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x020, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 1, "gpio_1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 4, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x020, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 2, "gpio_2")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 7, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x020, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 3, "gpio_3")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 10, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x020, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 4, "gpio_4")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 13, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x020, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 5, "gpio_5")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 16, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x020, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 6, "gpio_6")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 19, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 7, "gpio_7")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 21, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 8, "gpio_8")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 23, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 9, "gpio_9")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 25, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 10, "gpio_10")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 27, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 11, "gpio_11")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 12, "gpio_12")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 13, "gpio_13")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 14, "gpio_14")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 15, "gpio_15")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 16, "gpio_16")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 17, "gpio_17")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 18, "gpio_18")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 19, "gpio_19")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 16, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x028, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 20, "gpio_20")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 19, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 21, "gpio_21")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 21, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 22, "gpio_22")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 23, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 23, "gpio_23")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 25, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 24, "usb_cc2")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 27, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 25, "gpio_25")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 26, "gpio_26")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 27, "gpio_27")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x030, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 28, "gpio_28")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 6, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x030, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 29, "gpio_29")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 9, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x030, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 30, "gpio_30")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 11, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x030, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 31, "gpio_31")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 13, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x034, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 32, "gpio_32")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 16, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x034, .pcof_regbit = 11, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 33, "gpio_33")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 19, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x034, .pcof_regbit = 23, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 34, "gpio_34")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 21, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x034, .pcof_regbit = 27, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 35, "gpio_35")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 23, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x038, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 36, "gpio_36")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 26, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x038, .pcof_regbit = 11, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 37, "gpio_37")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 29, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x03c, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 38, "gpio_38")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 0, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x03c, .pcof_regbit = 11, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 39, "gpio_39")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 3, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x040, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 40, "gpio_40")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 5, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x040, .pcof_regbit = 11, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 41, "gpio_41")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 7, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x044, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 42, "gpio_42")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 9, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x044, .pcof_regbit = 11, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 43, "gpio_43")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 11, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x048, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 44, "gpio_44")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 13, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x048, .pcof_regbit = 11, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 45, "gpio_45")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 15, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x04c, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 46, "gpio_46")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x04c, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 47, "gpio_47")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x04c, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 48, "gpio_48")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x04c, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 49, "gpio_49")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00c, .pmux_regbit = 24, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x04c, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 50, "gpio_50")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 51, "usb_cc1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x070, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 52, "prob_0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x070, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 53, "prob_1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x070, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 54, "ir_rx")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x070, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 55, "ur0_rx")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x070, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_2_4}, /*(P_ISO_BASE + 56, "ur0_tx")*/
+	/*SPI*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x068, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 57, "spi_ce_n")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x068, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 58, "spi_sck")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x06c, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 59, "spi_so")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x06c, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 60, "spi_si")*/
+	/*MMC*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x050, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 61, "emmc_rst_n")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x050, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 62, "emmc_dd_sb")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x054, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 63, "emmc_clk")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x054, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 64, "emmc_cmd")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x058, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 65, "emmc_data_0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x058, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 66, "emmc_data_1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x05c, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 67, "emmc_data_2")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x05c, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 68, "emmc_data_3")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x060, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 69, "emmc_data_4")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x060, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 70, "emmc_data_5")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x064, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 71, "emmc_data_6")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x064, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 72, "emmc_data_7")*/
+	/*OTHERS*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 0, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 73, "ur2_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 2, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 74, "gspi_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 4, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 75, "sdio_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 6, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 76, "hi_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 8, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 77, "hi_width")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 10, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 78, "debug_p2s_enable")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 11, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 79, "sf_en")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 12, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 80, "arm_trace_dbg_en")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 13, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 81, "pwm_01_open_drain_en_loc0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 14, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 82, "pwm_23_open_drain_en_loc0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 15, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 83, "pwm_01_open_drain_en_loc1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 16, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 84, "pwm_23_open_drain_en_loc1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 17, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 85, "ejtag_avcpu_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 21, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 86, "ejtag_scpu_loc")*/
+};
+
+
+struct RTK_desc_function {
+	const char	*name;
+	u8		muxval;
+};
+
+struct RTK_desc_pin {
+	struct pinctrl_pin_desc		pin;
+	struct RTK_desc_function	*functions;
+};
+
+struct RTK_pinctrl_desc {
+	const struct RTK_desc_pin	*pins;
+	int				npins;
+	struct pinctrl_gpio_range	*ranges;
+	int				nranges;
+};
+
+struct RTK_pinctrl_function {
+	const char	*name;
+	const char	**groups;
+	unsigned int	ngroups;
+};
+
+struct RTK_pinctrl_group {
+	const char	*name;
+	unsigned long	config;
+	unsigned int	pin;
+};
+
+struct RTK_pinctrl {
+/*
+ *	void __iomem			*sb2_membase;
+ *	void __iomem			*disp_membase;
+ *	void __iomem			*cr_membase;
+ *	void __iomem			*iso_membase;
+ *	struct gpio_chip		*chip;
+ */
+	void __iomem			*iso_membase;
+	struct RTK_pinctrl_desc	*desc;
+	struct device			*dev;
+	struct RTK_pinctrl_function	*functions;
+	unsigned int			nfunctions;
+	struct RTK_pinctrl_group	*groups;
+	unsigned int			ngroups;
+	struct pinctrl_dev		*pctl_dev;
+};
+
+#define RTK_PIN(_pin, ...)					\
+	{							\
+		.pin = _pin,					\
+		.functions = (struct RTK_desc_function[]){	\
+			__VA_ARGS__, { } },			\
+	}
+
+#define RTK_FUNCTION(_val, _name)				\
+	{							\
+		.name = _name,					\
+		.muxval = _val,					\
+	}
+
+
+static const struct RTK_desc_pin rtk_pins[] = {
+	/*GPIO*/
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_0,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_1,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "standby_dbg"),
+		RTK_FUNCTION(0x2, "ao"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "scpu_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "standby_dbg"),
+		RTK_FUNCTION(0x2, "ao"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "scpu_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_4,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "ao"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "scpu_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_5,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "ao"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "scpu_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_6,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x7, "ai")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_7,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_8,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1"),
+		RTK_FUNCTION(0x2, "hi"),
+		RTK_FUNCTION(0x3, "tp0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_9,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1"),
+		RTK_FUNCTION(0x2, "hi"),
+		RTK_FUNCTION(0x3, "tp0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_10,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1"),
+		RTK_FUNCTION(0x2, "hi"),
+		RTK_FUNCTION(0x3, "tp0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_11,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1"),
+		RTK_FUNCTION(0x2, "hi"),
+		RTK_FUNCTION(0x3, "tp0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_12,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c0"),
+		RTK_FUNCTION(0x2, "pwm0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_13,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c0"),
+		RTK_FUNCTION(0x2, "pwm1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_14,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "etn_led"),
+		RTK_FUNCTION(0x2, "pwm2")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_15,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "etn_led"),
+		RTK_FUNCTION(0x2, "pwm3")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_16,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_17,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_18,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "gspi_loc0"),
+		RTK_FUNCTION(0x3, "sc_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_19,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "gspi_loc0"),
+		RTK_FUNCTION(0x3, "sc_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_20,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "gspi_loc0"),
+		RTK_FUNCTION(0x3, "sc_loc0"),
+		RTK_FUNCTION(0x4, "pwm0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_21,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "pwm1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_22,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "pwm2")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_23,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "pwm3")),
+	RTK_PIN(RTK_PINCTRL_PIN_usb_cc2,
+		RTK_FUNCTION(0x0, "usb_cc2"),
+		RTK_FUNCTION(0x1, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_25,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "gspi_loc1"),
+		RTK_FUNCTION(0x2, "uart2_loc1"),
+		RTK_FUNCTION(0x3, "rtc")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_26,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "gspi_loc1"),
+		RTK_FUNCTION(0x2, "uart2_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_27,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "gspi_loc1"),
+		RTK_FUNCTION(0x2, "uart2_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_28,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "gspi_loc1"),
+		RTK_FUNCTION(0x2, "uart2_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_29,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "gphy"),
+		RTK_FUNCTION(0x4, "extphy")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_30,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_31,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "gspi_loc0"),
+		RTK_FUNCTION(0x3, "sc_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_32,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "mmc"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "scpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_33,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "mmc"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "scpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_34,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "mmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_35,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "mmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_36,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "mmc"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc1"),
+		RTK_FUNCTION(0x5, "tp1"),
+		RTK_FUNCTION(0x6, "scpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_37,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "mmc"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc1"),
+		RTK_FUNCTION(0x5, "tp1"),
+		RTK_FUNCTION(0x6, "scpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_38,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "mmc"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x5, "tp1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_39,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "mmc"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "acpu_ejtag_loc1"),
+		RTK_FUNCTION(0x5, "tp1"),
+		RTK_FUNCTION(0x6, "scpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_40,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_41,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_42,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_43,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_44,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_45,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_46,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pcie"),
+		RTK_FUNCTION(0x3, "gphy"),
+		RTK_FUNCTION(0x4, "extphy")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_47,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "dc_fan_sensor")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_48,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "prob_2")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_49,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "prob_3")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_50,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "spdif"),
+		RTK_FUNCTION(0x2, "test_loop_dis")),
+	RTK_PIN(RTK_PINCTRL_PIN_usb_cc1,
+		RTK_FUNCTION(0x0, "usb_cc1"),
+		RTK_FUNCTION(0x1, "gpio")), /*gpio51*/
+	RTK_PIN(RTK_PINCTRL_PIN_prob_0,
+		RTK_FUNCTION(0x0, "gpio"),  /*gpio52*/
+		RTK_FUNCTION(0x1, "prob_0"),
+		RTK_FUNCTION(0x2, "p2s")),
+	RTK_PIN(RTK_PINCTRL_PIN_prob_1,
+		RTK_FUNCTION(0x0, "gpio"),  /*gpio53*/
+		RTK_FUNCTION(0x1, "prob_1"),
+		RTK_FUNCTION(0x2, "p2s")),
+	RTK_PIN(RTK_PINCTRL_PIN_ir_rx,
+		RTK_FUNCTION(0x0, "gpio"),  /*gpio54*/
+		RTK_FUNCTION(0x1, "ir_rx"),
+		RTK_FUNCTION(0x2, "standby_dbg")),
+	RTK_PIN(RTK_PINCTRL_PIN_ur0_rx,
+		RTK_FUNCTION(0x0, "gpio"),  /*gpio55*/
+		RTK_FUNCTION(0x1, "uart0")),
+	RTK_PIN(RTK_PINCTRL_PIN_ur0_tx,
+		RTK_FUNCTION(0x0, "gpio"),  /*gpio56*/
+		RTK_FUNCTION(0x1, "uart0")),
+	/*SPI*/
+	RTK_PIN(RTK_PINCTRL_PIN_spi_ce_n,
+		RTK_FUNCTION(0x0, "spi"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "i2c5")),
+	RTK_PIN(RTK_PINCTRL_PIN_spi_sck,
+		RTK_FUNCTION(0x0, "spi"),
+		RTK_FUNCTION(0x1, "nand")),
+	RTK_PIN(RTK_PINCTRL_PIN_spi_so,
+		RTK_FUNCTION(0x0, "spi"),
+		RTK_FUNCTION(0x1, "nand")),
+	RTK_PIN(RTK_PINCTRL_PIN_spi_si,
+		RTK_FUNCTION(0x0, "spi"),
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "i2c5")),
+	/*MMC*/
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_rst_n,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_dd_sb,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_clk,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_cmd,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_0,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_1,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_2,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_3,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_4,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_5,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_6,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_7,
+		RTK_FUNCTION(0x1, "nand"),
+		RTK_FUNCTION(0x2, "emmc")),
+	/*OTHERS*/
+	RTK_PIN(RTK_PINCTRL_PIN_ur2_loc,
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "uart2_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gspi_loc,
+		RTK_FUNCTION(0x1, "gspi_loc0"),
+		RTK_FUNCTION(0x2, "gspi_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_sdio_loc,
+		RTK_FUNCTION(0x1, "sdio_loc0"),
+		RTK_FUNCTION(0x2, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_hi_loc,
+		RTK_FUNCTION(0x0, "hi_loc_disable"),
+		RTK_FUNCTION(0x1, "hi_loc0"),
+		RTK_FUNCTION(0x2, "hi_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_hi_width,
+		RTK_FUNCTION(0x0, "hi_width_disable"),
+		RTK_FUNCTION(0x1, "hi_width_1bit"),
+		RTK_FUNCTION(0x2, "hi_width_8bit"),
+		RTK_FUNCTION(0x3, "hi_width_16bit")),
+	RTK_PIN(RTK_PINCTRL_PIN_debug_p2s_enable,
+		RTK_FUNCTION(0x0, "p2s_disable"),
+		RTK_FUNCTION(0x1, "p2s_enable")),
+	RTK_PIN(RTK_PINCTRL_PIN_sf_en,
+		RTK_FUNCTION(0x0, "sf_disable"),
+		RTK_FUNCTION(0x1, "sf_enable")),
+	RTK_PIN(RTK_PINCTRL_PIN_arm_trace_dbg_en,
+		RTK_FUNCTION(0x0, "arm_trace_debug_disable"),
+		RTK_FUNCTION(0x1, "arm_trace_debug_enable")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc0,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc0,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc1,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc1,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_ejtag_avcpu_loc,
+		RTK_FUNCTION(0x1, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x2, "acpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_ejtag_scpu_loc,
+		RTK_FUNCTION(0x1, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x2, "scpu_ejtag_loc1")),
+};
+
+void gpio_pinctrl_control(struct gpio_chip *gc, int gpio, int direction, int value);
+
+#endif /* __PINCTRL_RTK139X_H */
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd13xx.c b/drivers/pinctrl/realtek/pinctrl-rtd13xx.c
new file mode 100644
index 00000000..ae88d76
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd13xx.c
@@ -0,0 +1,992 @@
+/*
+ * Realtek pin controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include "pinctrl-rtd13xx.h"
+#include <linux/io.h>
+#include <linux/clk.h>
+#include <linux/gpio.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/pinctrl/consumer.h>
+#include <linux/pinctrl/machine.h>
+#include <linux/pinctrl/pinctrl.h>
+#include <linux/pinctrl/pinconf-generic.h>
+#include <linux/pinctrl/pinmux.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include "../core.h"
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+static u32 *pinctrl_reg_values;
+
+static const struct RTK_pinctrl_desc rtk13xx_pinctrl_data = {
+	.pins = rtk_pins,
+	.npins = ARRAY_SIZE(rtk_pins),
+};
+
+static void RTK_pmx_set(struct pinctrl_dev *pctldev,
+	unsigned int pin, u8 config)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	void __iomem *addr;
+	u32 val;
+	u32 mask;
+
+	if (pin_regmap[pin].pmux_regoff == PMUX_UNSUPPORT)
+		return;
+
+	switch (pin_regmap[pin].pmux_base) {
+	case PMUX_BASE_ISO:
+		addr = pctl->iso_membase + pin_regmap[pin].pmux_regoff;
+		break;
+	default:
+		RTK_PINCTRL_ERR("[%s] Unknow pmux_base", __func__);
+		return;
+	}
+	RTK_PINCTRL_DBG("[%s] Addr(0x%08llx), bit=%u, config=%u",
+		__func__, (u64)addr, pin_regmap[pin].pmux_regbit, config);
+
+	val = readl(addr);
+	mask =	pin_regmap[pin].pmux_regbitmsk << pin_regmap[pin].pmux_regbit;
+	writel(((val & ~mask) | (config << pin_regmap[pin].pmux_regbit)), addr);
+
+	RTK_PINCTRL_DBG("[%s] Addr(0x%08llx) final_val=0x%08x",
+			__func__, (u64)addr, readl(addr));
+
+}
+
+static struct RTK_pinctrl_group *
+RTK_pinctrl_find_group_by_name(struct RTK_pinctrl *pctl, const char *group)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s] name = %s", __func__, group);
+	for (i = 0; i < pctl->ngroups; i++) {
+		struct RTK_pinctrl_group *grp = pctl->groups + i;
+
+		if (!strcmp(grp->name, group))
+			return grp;
+	}
+
+	return NULL;
+}
+
+static struct RTK_pinctrl_function *
+RTK_pinctrl_find_function_by_name(struct RTK_pinctrl *pctl,
+				    const char *name)
+{
+	struct RTK_pinctrl_function *func = pctl->functions;
+	int i;
+	/*RTK_PINCTRL_DBG("[%s]", __func__);*/
+	for (i = 0; i < pctl->nfunctions; i++) {
+		if (!func[i].name)
+			break;
+
+		if (!strcmp(func[i].name, name))
+			return func + i;
+	}
+
+	return NULL;
+}
+
+static struct RTK_desc_function *
+RTK_pinctrl_desc_find_function_by_name(struct RTK_pinctrl *pctl,
+					 const char *pin_name,
+					 const char *func_name)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s] pin_name=%s, func_name=%s",
+			__func__, pin_name, func_name);
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+
+		if (!strcmp(pin->pin.name, pin_name)) {
+			struct RTK_desc_function *func = pin->functions;
+
+			while (func->name) {
+				if (!strcmp(func->name, func_name))
+					return func;
+
+				func++;
+			}
+		}
+	}
+
+	return NULL;
+}
+
+static int RTK_pctrl_get_groups_count(struct pinctrl_dev *pctldev)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] pctl->ngroups=%d",
+			__func__, pctl->ngroups);
+	return pctl->ngroups;
+}
+
+static const char *RTK_pctrl_get_group_name(struct pinctrl_dev *pctldev,
+					      unsigned int group)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	/*RTK_PINCTRL_DBG("[%s] group.name=%s",
+	 *		__func__, pctl->groups[group].name);
+	 */
+	return pctl->groups[group].name;
+}
+
+static int RTK_pctrl_get_group_pins(struct pinctrl_dev *pctldev,
+				      unsigned int group,
+				      const unsigned int **pins,
+				      unsigned int *num_pins)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*pins = (unsigned int *)&pctl->groups[group].pin;
+	*num_pins = 1;
+
+	return 0;
+}
+
+static int RTK_pctrl_dt_node_to_map(struct pinctrl_dev *pctldev,
+				      struct device_node *node,
+				      struct pinctrl_map **map,
+				      unsigned int *num_maps)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	unsigned long *pinconfig;
+	struct property *prop;
+	const char *function;
+	const char *group;
+	int ret, nmaps, i = 0;
+	u32 val;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+
+	*map = NULL;
+	*num_maps = 0;
+
+	ret = of_property_read_string(node, "realtek,function", &function);
+	if (ret) {
+		printk(
+			"missing realtek,function property in node %s\n",
+			node->name);
+		return -EINVAL;
+	}
+
+	nmaps = of_property_count_strings(node, "realtek,pins") * 2;
+	if (nmaps < 0) {
+		printk(
+			"missing realtek,pins property in node %s\n",
+			node->name);
+		return -EINVAL;
+	}
+
+	*map = kmalloc_array(nmaps, sizeof(struct pinctrl_map), GFP_KERNEL);
+	if (!map)
+		return -ENOMEM;
+
+	of_property_for_each_string(node, "realtek,pins", prop, group) {
+		struct RTK_pinctrl_group *grp =
+			RTK_pinctrl_find_group_by_name(pctl, group);
+		int j = 0, configlen = 0;
+
+		if (!grp) {
+			printk("unknown pin %s", group);
+			continue;
+		}
+
+		if (!RTK_pinctrl_desc_find_function_by_name(pctl,
+							      grp->name,
+							      function)) {
+			printk("unsupported function %s on pin %s",
+				function, group);
+			continue;
+		}
+
+		(*map)[i].type = PIN_MAP_TYPE_MUX_GROUP;
+		(*map)[i].data.mux.group = group;
+		(*map)[i].data.mux.function = function;
+
+		i++;
+
+		(*map)[i].type = PIN_MAP_TYPE_CONFIGS_GROUP;
+		(*map)[i].data.configs.group_or_pin = group;
+
+		if (of_find_property(node, "realtek,schmitt", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,drive", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,pull_en", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,pull_sel", NULL))
+			configlen++;
+
+		RTK_PINCTRL_DBG("[%s] configlen %d", __func__, configlen);
+
+		if (configlen) {
+			pinconfig = kcalloc(configlen,
+					sizeof(*pinconfig), GFP_KERNEL);
+		} else {
+			/* Prevent failed to register map default*/
+			configlen = 1;
+			pinconfig = kzalloc(1 * sizeof(*pinconfig), GFP_KERNEL);
+			pinconfig[j++] = pinconf_to_config_packed
+						(PIN_CONFIG_END, 0);
+		}
+
+		if (!of_property_read_u32(node, "realtek,schmitt", &val)) {
+			u16 schmitt_enable;
+
+			if (val == 0)
+				schmitt_enable = 0;
+			else
+				schmitt_enable = 1;
+
+			pinconfig[j++] = pinconf_to_config_packed
+					(PIN_CONFIG_INPUT_SCHMITT_ENABLE,
+					schmitt_enable);
+		}
+
+		if (!of_property_read_u32(node, "realtek,drive", &val)) {
+			pinconfig[j++] = pinconf_to_config_packed
+					(PIN_CONFIG_DRIVE_STRENGTH, val);
+		}
+
+		if (!of_property_read_u32(node, "realtek,pull_en", &val)) {
+			enum pin_config_param pull = PIN_CONFIG_END;
+
+			if (val == 0)
+				pull = PIN_CONFIG_BIAS_DISABLE;
+			else if (val == 1)
+				pull = PIN_CONFIG_DRIVE_PUSH_PULL;
+			pinconfig[j++] = pinconf_to_config_packed(pull, 0);
+		}
+
+		if (!of_property_read_u32(node, "realtek,pull_sel", &val)) {
+			enum pin_config_param pull = PIN_CONFIG_END;
+
+			if (val == 0)
+				pull = PIN_CONFIG_BIAS_PULL_DOWN;
+			else if (val == 1)
+				pull = PIN_CONFIG_BIAS_PULL_UP;
+			pinconfig[j++] = pinconf_to_config_packed(pull, 1);
+		}
+
+		(*map)[i].data.configs.configs = pinconfig;
+		(*map)[i].data.configs.num_configs = configlen;
+
+		i++;
+	}
+
+	*num_maps = nmaps;
+
+	return 0;
+}
+
+static void RTK_pctrl_dt_free_map(struct pinctrl_dev *pctldev,
+				    struct pinctrl_map *map,
+				    unsigned int num_maps)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	for (i = 0; i < num_maps; i++) {
+		if (map[i].type == PIN_MAP_TYPE_CONFIGS_GROUP)
+			kfree(map[i].data.configs.configs);
+	}
+
+	kfree(map);
+}
+
+static void RTK_pctrl_dbg_show(struct pinctrl_dev *pctldev, struct seq_file *s,
+			  unsigned offset)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_desc_function *func = rtk_pins[offset].functions;
+	void __iomem *addr;
+	u32 val;
+	u32 mask;
+	u8 pin_val;
+	int is_map;
+
+	if(pin_regmap[offset].pmux_regoff == PMUX_UNSUPPORT)
+		return;
+
+	switch (pin_regmap[offset].pmux_base) {
+	case PMUX_BASE_ISO:
+		addr = pctl->iso_membase + pin_regmap[offset].pmux_regoff;
+		break;
+	default:
+		RTK_PINCTRL_ERR("[%s] Unknow pmux_base", __func__);
+		return;
+	}
+	val = readl(addr);
+	mask =pin_regmap[offset].pmux_regbitmsk << pin_regmap[offset].pmux_regbit;
+	pin_val = (val & mask) >> pin_regmap[offset].pmux_regbit;
+
+	is_map = 0;
+	seq_printf(s, "function: ");
+	while (func->name) {
+		if (func->muxval == pin_val) {
+			is_map = 1;
+			seq_printf(s, "[%s] ",func->name);
+		} else {
+			seq_printf(s, "%s ",func->name);
+		}
+		func++;
+	}
+	if (!is_map)
+		seq_printf(s, "[not defined] ");
+}
+
+
+static const struct pinctrl_ops RTK_pctrl_ops = {
+	.dt_node_to_map		= RTK_pctrl_dt_node_to_map,
+	.dt_free_map		= RTK_pctrl_dt_free_map,
+	.get_groups_count	= RTK_pctrl_get_groups_count,
+	.get_group_name		= RTK_pctrl_get_group_name,
+	.get_group_pins		= RTK_pctrl_get_group_pins,
+	.pin_dbg_show		= RTK_pctrl_dbg_show,
+};
+
+static int RTK_pconf_parse_conf(struct pinctrl_dev *pctldev,
+	unsigned int pin, enum pin_config_param param,
+	enum pin_config_param arg)
+{
+	void __iomem *addr;
+	u8 set_val;
+	u16 strength;
+	u32 val, mask;
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	int pconf_pulsel, pconf_pulen, pconf_schm, pconf_curr;
+
+	RTK_PINCTRL_DBG("[%s] pin=%u, config_param=%u, config_argument=%u",
+			__func__, pin, param, arg);
+
+	if (pin_regmap[pin].pcof_regoff == PCOF_UNSUPPORT)
+		return 0;
+
+	pconf_schm = RTK_PCONF_SCHM;
+	pconf_curr = RTK_PCONF_CURR;
+	if ((pin == 55) || (pin == 104)) {
+		pconf_pulsel = 0;
+		pconf_pulen = 1;
+	} else {
+		pconf_pulsel = RTK_PCONF_PULSEL;
+		pconf_pulen = RTK_PCONF_PULEN;
+	}
+
+	switch (pin_regmap[pin].pmux_base) {
+		case PMUX_BASE_ISO:
+			addr = pctl->iso_membase + pin_regmap[pin].pcof_regoff;
+			break;
+		default:
+			RTK_PINCTRL_ERR("[%s] Unknow pmux_base\n", __func__);
+			return -EINVAL;
+	}
+
+	switch (param) {
+	case PIN_CONFIG_INPUT_SCHMITT:
+		break;
+	case PIN_CONFIG_INPUT_SCHMITT_ENABLE:
+		set_val = arg;
+		if (set_val)
+			set_val = 1;
+		else
+			set_val = 0;
+
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + pconf_schm);
+		writel(((val & ~mask)|
+			(set_val <<
+			(pin_regmap[pin].pcof_regbit + pconf_schm))),
+			addr);
+		break;
+	case PIN_CONFIG_DRIVE_STRENGTH:
+		strength = arg;
+		switch (pin_regmap[pin].pcof_cur_strgh) {
+		case PADDRI_4_8:
+			if (strength == 4)
+				set_val = 0;
+			else if (strength == 8)
+				set_val = 1;
+			else
+				return -EINVAL;
+			break;
+		case PADDRI_2_4:
+			if (strength == 2)
+				set_val = 0;
+			else if (strength == 4)
+				set_val = 1;
+			else
+				return -EINVAL;
+			break;
+		case PADDRI_UNSUPPORT:
+		default:
+			return -EINVAL;
+		}
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + pconf_curr);
+		writel(((val & ~mask)|
+			(set_val <<
+			(pin_regmap[pin].pcof_regbit + pconf_curr))),
+			addr);
+		break;
+	case PIN_CONFIG_DRIVE_PUSH_PULL:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + pconf_pulen);
+		writel(((val & ~mask)|
+			(1 << (pin_regmap[pin].pcof_regbit + pconf_pulen))),
+			addr);
+		break;
+	case PIN_CONFIG_BIAS_DISABLE:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + pconf_pulen);
+		writel(((val & ~mask)|
+			(0 << (pin_regmap[pin].pcof_regbit + pconf_pulen))),
+			addr);
+		break;
+	case PIN_CONFIG_BIAS_PULL_UP:
+		if (pin == 52) {
+			val = readl(addr - 0x4);
+			mask =	1 << 31;
+			writel((val & ~mask)|
+				(1 << 31),
+				addr - 0x4);
+		} else if (pin == 61) {
+			val = readl(addr + 0x4);
+			mask = 1 << 0;
+			writel((val & ~mask)|
+				(1 << 0),
+				addr + 0x4);
+		} else {
+			val = readl(addr);
+			mask = 1 << (pin_regmap[pin].pcof_regbit + pconf_pulsel);
+			writel(((val & ~mask)|
+				(1 << (pin_regmap[pin].pcof_regbit + pconf_pulsel))),
+				addr);
+		}
+		break;
+	case PIN_CONFIG_BIAS_PULL_DOWN:
+		if (pin == 52) {
+			val = readl(addr - 0x4);
+			mask =	1 << 31;
+			writel((val & ~mask)|
+				(0 << 31),
+				addr - 0x4);
+		} else if (pin == 61) {
+			val = readl(addr + 0x4);
+			mask =	1 << 0;
+			writel((val & ~mask)|
+				(0 << 0),
+				addr + 0x4);
+		} else {
+			val = readl(addr);
+			mask =	1 << (pin_regmap[pin].pcof_regbit + pconf_pulsel);
+			writel(((val & ~mask)|
+				(0 << (pin_regmap[pin].pcof_regbit + pconf_pulsel))),
+				addr);
+		}
+		break;
+	default:
+		break;
+	}
+
+	return 0;
+}
+
+static int RTK_pconf_group_get(struct pinctrl_dev *pctldev,
+				 unsigned int group,
+				 unsigned long *config)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*config = pctl->groups[group].config;
+
+	return 0;
+}
+
+static int RTK_pconf_group_set(struct pinctrl_dev *pctldev,
+				 unsigned int group,
+				 unsigned long *configs,
+				 unsigned int num_configs)
+{
+	u32 i;
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = &pctl->groups[group];
+
+	RTK_PINCTRL_DBG("[%s] g->pin=%d, g->name =%s, num_configs = %u",
+				__func__, g->pin, g->name, num_configs);
+
+	if (pin_regmap[g->pin].pcof_regoff == PCOF_UNSUPPORT) {
+		RTK_PINCTRL_DBG(
+			"[%s] g->pin(%d) g->name(%s) not support pin config"
+			, __func__, g->pin, g->name);
+		g->config = configs[num_configs-1];
+		return 0;
+	}
+
+	for (i = 0; i < num_configs; i++) {
+		RTK_pconf_parse_conf(pctldev, g->pin,
+			pinconf_to_config_param(configs[i]),
+			pinconf_to_config_argument(configs[i]));
+
+		g->config = configs[i];
+	}
+
+	return 0;
+}
+
+static const struct pinconf_ops RTK_pconf_ops = {
+	.pin_config_group_get	= RTK_pconf_group_get,
+	.pin_config_group_set	= RTK_pconf_group_set,
+};
+
+static int RTK_pmx_get_funcs_cnt(struct pinctrl_dev *pctldev)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] pctl->nfunctions =%d",
+			__func__, pctl->nfunctions);
+	return pctl->nfunctions;
+}
+
+static const char *RTK_pmx_get_func_name(struct pinctrl_dev *pctldev,
+					   unsigned int function)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] function[%d] = %s", __func__,
+			function, pctl->functions[function].name);
+	return pctl->functions[function].name;
+}
+
+static int RTK_pmx_get_func_groups(struct pinctrl_dev *pctldev,
+				     unsigned int function,
+				     const char * const **groups,
+				     unsigned int * const num_groups)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*groups = pctl->functions[function].groups;
+	*num_groups = pctl->functions[function].ngroups;
+
+	return 0;
+}
+
+static int RTK_pmx_enable(struct pinctrl_dev *pctldev,
+			    unsigned int function,
+			    unsigned int group)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = pctl->groups + group;
+	struct RTK_pinctrl_function *func = pctl->functions + function;
+	struct RTK_desc_function *desc =
+		RTK_pinctrl_desc_find_function_by_name(pctl,
+							 g->name,
+							 func->name);
+	RTK_PINCTRL_DBG("[%s] g->name=%s, func->name=%s",
+				__func__, g->name, func->name);
+	if (!desc)
+		return -EINVAL;
+
+	RTK_pmx_set(pctldev, g->pin, desc->muxval);
+
+	return 0;
+}
+
+void gpio_pinctrl_control(struct gpio_chip *gc, int gpio,
+	int direction, int value)
+{
+	struct device_node *np = gc->of_node;
+	struct of_phandle_args pinspec;
+	struct pinctrl_dev *pctldev;
+	int ret, pin;
+
+	ret = of_parse_phandle_with_fixed_args(np, "gpio-ranges", 3,
+					0, &pinspec);
+	if (ret)
+		RTK_PINCTRL_ERR("Can't get pinspec");
+
+	pctldev = of_pinctrl_get(pinspec.np);
+	pin = gpio + pinspec.args[1];
+
+	if (direction) {
+		if (value == 0 || value == 1) {
+			RTK_pconf_parse_conf(pctldev, pin, PIN_CONFIG_BIAS_DISABLE, 0);
+		} else if (value == 2 || value == 3) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_UP, 0);
+		} else if (value == 4 || value == 5) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_DOWN, 0);
+		}
+	} else {
+		if (value == 1) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_UP, 0);
+		} else if (value == 0) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_DOWN, 0);
+		} else if (value == 2) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_DISABLE, 0);
+		}
+	}
+}
+
+static int
+RTK_pmx_gpio_request_enable(struct pinctrl_dev *pctldev,
+				    struct pinctrl_gpio_range *range,
+				    unsigned int offset)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = pctl->groups + offset;
+	struct RTK_desc_function *desc;
+	const char *func;
+	int ret;
+
+	func = "gpio";
+	RTK_PINCTRL_DBG("[%s] gpio_offset=%u", __func__, offset);
+	desc = RTK_pinctrl_desc_find_function_by_name(pctl,
+							g->name,
+							func);
+	if (!desc) {
+		ret = -EINVAL;
+		RTK_PINCTRL_ERR(
+			"Set gpio pinmux fail, Pin(%s) offset=%u\n"
+			, g->name, offset);
+		goto error;
+	}
+
+	RTK_pmx_set(pctldev, offset, desc->muxval);
+
+	ret = 0;
+
+error:
+	return ret;
+}
+
+static void
+RTK_pmx_gpio_disable_free(struct pinctrl_dev *pctldev,
+				    struct pinctrl_gpio_range *range,
+				    unsigned int offset)
+{
+	RTK_PINCTRL_DBG("[%s]", __func__);
+/*TODO : need to add gpio related api*/
+}
+
+
+
+static const struct pinmux_ops RTK_pmx_ops = {
+	.get_functions_count = RTK_pmx_get_funcs_cnt,
+	.get_function_name = RTK_pmx_get_func_name,
+	.get_function_groups = RTK_pmx_get_func_groups,
+	.set_mux = RTK_pmx_enable,
+	.gpio_request_enable = RTK_pmx_gpio_request_enable,
+	.gpio_disable_free = RTK_pmx_gpio_disable_free,
+};
+
+static struct pinctrl_desc RTK_pctrl_desc = {
+	.confops	= &RTK_pconf_ops,
+	.pctlops	= &RTK_pctrl_ops,
+	.pmxops		= &RTK_pmx_ops,
+};
+
+
+static const struct of_device_id RTK_pinctrl_match[] = {
+	{ .compatible = "realtek,rtk13xx-pinctrl",
+		.data = (void *)&rtk13xx_pinctrl_data },
+	{ /* Sentinel */ },
+};
+MODULE_DEVICE_TABLE(of, RTK_pinctrl_match);
+
+static int RTK_pinctrl_add_function(struct RTK_pinctrl *pctl,
+					const char *name)
+{
+	struct RTK_pinctrl_function *func = pctl->functions;
+
+	while (func->name) {
+		/* function already there */
+		if (strcmp(func->name, name) == 0) {
+			func->ngroups++;
+			return -EEXIST;
+		}
+		func++;
+	}
+
+	func->name = name;
+	func->ngroups = 1;
+
+	pctl->nfunctions++;
+
+	return 0;
+}
+
+static int RTK_pinctrl_build_state(struct platform_device *pdev)
+{
+	struct RTK_pinctrl *pctl = platform_get_drvdata(pdev);
+	int i;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	pctl->ngroups = pctl->desc->npins;
+
+	/* Allocate groups */
+	pctl->groups = devm_kzalloc(&pdev->dev,
+				    pctl->ngroups * sizeof(*pctl->groups),
+				    GFP_KERNEL);
+	if (!pctl->groups)
+		return -ENOMEM;
+
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_pinctrl_group *group = pctl->groups + i;
+
+		group->name = pin->pin.name;
+		group->pin = pin->pin.number;
+	}
+
+	/*
+	 * We suppose that we won't have any more functions than pins,
+	 * we'll reallocate that later anyway
+	 */
+	pctl->functions = devm_kzalloc(&pdev->dev,
+				pctl->desc->npins * sizeof(*pctl->functions),
+				GFP_KERNEL);
+	if (!pctl->functions)
+		return -ENOMEM;
+
+	/* Count functions and their associated groups */
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_desc_function *func = pin->functions;
+
+		while (func->name) {
+			RTK_pinctrl_add_function(pctl, func->name);
+			func++;
+		}
+	}
+
+	pctl->functions = krealloc(pctl->functions,
+				pctl->nfunctions * sizeof(*pctl->functions),
+				GFP_KERNEL);
+
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_desc_function *func = pin->functions;
+
+		while (func->name) {
+			struct RTK_pinctrl_function *func_item;
+			const char **func_grp;
+
+			func_item = RTK_pinctrl_find_function_by_name(pctl,
+								func->name);
+			if (!func_item)
+				return -EINVAL;
+
+			if (!func_item->groups) {
+				func_item->groups =
+					devm_kzalloc(&pdev->dev,
+						func_item->ngroups *
+						sizeof(*func_item->groups),
+						GFP_KERNEL);
+				if (!func_item->groups)
+					return -ENOMEM;
+			}
+
+			func_grp = func_item->groups;
+			while (*func_grp)
+				func_grp++;
+
+			*func_grp = pin->pin.name;
+			func++;
+		}
+	}
+
+	return 0;
+}
+
+static int RTK_pinctrl_probe(struct platform_device *pdev)
+{
+	struct device_node *node = pdev->dev.of_node;
+	const struct of_device_id *device;
+	struct pinctrl_pin_desc *pins;
+	struct RTK_pinctrl *pctl;
+	int i, ret;
+
+	RTK_PINCTRL_INF("driver init");
+
+	pctl = devm_kzalloc(&pdev->dev, sizeof(*pctl), GFP_KERNEL);
+	if (!pctl)
+		return -ENOMEM;
+	platform_set_drvdata(pdev, pctl);
+
+	pctl->iso_membase = of_iomap(node, 0);
+	if (!pctl->iso_membase) {
+		RTK_PINCTRL_ERR("of_iomap iso_membase fail");
+		return -ENOMEM;
+	}
+
+	RTK_PINCTRL_DBG("iso_membase(0x%p)", pctl->iso_membase);
+
+	device = of_match_device(RTK_pinctrl_match, &pdev->dev);
+	if (!device) {
+		RTK_PINCTRL_ERR("of_match_device fail");
+		return -ENODEV;
+	}
+
+	pctl->desc = (struct RTK_pinctrl_desc *)device->data;
+
+	ret = RTK_pinctrl_build_state(pdev);
+	if (ret) {
+		RTK_PINCTRL_ERR("RTK_pinctrl_build_state fail");
+		return ret;
+	}
+
+	pins = devm_kzalloc(&pdev->dev,
+			    pctl->desc->npins * sizeof(*pins),
+			    GFP_KERNEL);
+	if (!pins) {
+		RTK_PINCTRL_ERR("[%s]devm_kzalloc fail", __func__);
+		return -ENOMEM;
+	}
+
+	for (i = 0; i < pctl->desc->npins; i++)
+		pins[i] = pctl->desc->pins[i].pin;
+
+	RTK_pctrl_desc.name = dev_name(&pdev->dev);
+	RTK_pctrl_desc.owner = THIS_MODULE;
+	RTK_pctrl_desc.pins = pins;
+	RTK_pctrl_desc.npins = pctl->desc->npins;
+	pctl->dev = &pdev->dev;
+	pctl->pctl_dev = pinctrl_register(&RTK_pctrl_desc,
+					  &pdev->dev, pctl);
+	if (!pctl->pctl_dev) {
+		RTK_PINCTRL_ERR("register pinctrl driver fail");
+		return -EINVAL;
+	}
+
+	RTK_PINCTRL_INF("init done");
+
+	return 0;
+}
+
+int RTK_pinctrl_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct RTK_pinctrl *pctl;
+	void __iomem *addr;
+	unsigned int i;
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		RTK_PINCTRL_INF("skip %s under DomU", __func__);
+		return 0;
+	}
+#endif
+	RTK_PINCTRL_INF("Enter %s", __func__);
+
+	pctl = platform_get_drvdata(pdev);
+
+	pinctrl_reg_values = kcalloc(ARRAY_SIZE(pinmux_reg_list), sizeof(u32),
+				GFP_KERNEL);
+
+	for (i = 0; i < ARRAY_SIZE(pinmux_reg_list); i++) {
+		switch (pinmux_reg_list[i].reg_base) {
+		case PMUX_BASE_ISO:
+			addr = pctl->iso_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+
+		default:
+			RTK_PINCTRL_ERR("[%s] Unknow reg_base\n",
+					__func__);
+			return -EINVAL;
+		}
+		/*Store pinmux registers*/
+		pinctrl_reg_values[i] = readl(addr);
+	}
+
+	RTK_PINCTRL_INF("Exit %s", __func__);
+	return 0;
+}
+
+int RTK_pinctrl_resume(struct platform_device *pdev)
+{
+	struct RTK_pinctrl *pctl;
+	void __iomem *addr;
+	unsigned int i;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		RTK_PINCTRL_INF("skip %s under DomU", __func__);
+		return 0;
+	}
+#endif
+	RTK_PINCTRL_INF("Enter %s", __func__);
+
+	pctl = platform_get_drvdata(pdev);
+
+	for (i = 0; i < ARRAY_SIZE(pinmux_reg_list); i++) {
+		switch (pinmux_reg_list[i].reg_base) {
+		case PMUX_BASE_ISO:
+			addr = pctl->iso_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		default:
+			RTK_PINCTRL_ERR("[%s] Unknow reg_base\n",
+					__func__);
+			return -EINVAL;
+		}
+		/*Restore pinmux registers*/
+		writel(pinctrl_reg_values[i], addr);
+	}
+
+	kfree(pinctrl_reg_values);
+
+	RTK_PINCTRL_INF("Exit %s", __func__);
+	return 0;
+}
+
+static struct platform_driver RTK_pinctrl_driver = {
+	.probe = RTK_pinctrl_probe,
+	.driver = {
+		.name = "rtk-pinctrl",
+		.owner = THIS_MODULE,
+		.of_match_table = RTK_pinctrl_match,
+	},
+	.suspend = RTK_pinctrl_suspend,
+	.resume = RTK_pinctrl_resume,
+};
+
+static int  rtk_pinctrl_init(void)
+{
+	return platform_driver_register(&RTK_pinctrl_driver);
+}
+postcore_initcall(rtk_pinctrl_init);
+
+MODULE_DESCRIPTION("RTK pinctrl driver");
+MODULE_LICENSE("GPL");
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd13xx.h b/drivers/pinctrl/realtek/pinctrl-rtd13xx.h
new file mode 100644
index 00000000..b33ca6f
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd13xx.h
@@ -0,0 +1,906 @@
+/*
+ * Realtek pin controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#ifndef __PINCTRL_RTK13xx_H
+#define __PINCTRL_RTK13xx_H
+
+#include <linux/kernel.h>
+#include <linux/pinctrl/pinctrl.h>
+
+//#define RTK_PINCTRL_DEBUG
+#ifdef RTK_PINCTRL_DEBUG
+#define RTK_PINCTRL_DBG(fmt, ...) pr_info("[PINCTRL] " fmt "\n", ## __VA_ARGS__)
+#else
+#define RTK_PINCTRL_DBG(fmt, ...) do {} while (0)
+#endif
+
+#define RTK_PINCTRL_INF(fmt, ...) pr_info("[PINCTRL] " fmt "\n", ## __VA_ARGS__)
+#define RTK_PINCTRL_ERR(fmt, ...) pr_err("[PINCTRL Error] " fmt "\n", ## __VA_ARGS__)
+
+#define P_ISO_BASE			 0
+
+#define RTK_PCONF_SCHM		2
+#define RTK_PCONF_PULEN		0
+#define RTK_PCONF_PULSEL	1
+#define RTK_PCONF_CURR		-1
+
+
+/* ISO muxpad1*/
+#define RTK_PINCTRL_PIN_gpio_0				PINCTRL_PIN(P_ISO_BASE + 0, "gpio_0")
+#define RTK_PINCTRL_PIN_gpio_1				PINCTRL_PIN(P_ISO_BASE + 1, "gpio_1")
+#define RTK_PINCTRL_PIN_gpio_2				PINCTRL_PIN(P_ISO_BASE + 2, "gpio_2")
+#define RTK_PINCTRL_PIN_gpio_3				PINCTRL_PIN(P_ISO_BASE + 3, "gpio_3")
+#define RTK_PINCTRL_PIN_gpio_4				PINCTRL_PIN(P_ISO_BASE + 4, "gpio_4")
+#define RTK_PINCTRL_PIN_gpio_5				PINCTRL_PIN(P_ISO_BASE + 5, "gpio_5")
+#define RTK_PINCTRL_PIN_gpio_6				PINCTRL_PIN(P_ISO_BASE + 6, "gpio_6")
+#define RTK_PINCTRL_PIN_gpio_7				PINCTRL_PIN(P_ISO_BASE + 7, "gpio_7")
+#define RTK_PINCTRL_PIN_gpio_8				PINCTRL_PIN(P_ISO_BASE + 8, "gpio_8")
+#define RTK_PINCTRL_PIN_gpio_9				PINCTRL_PIN(P_ISO_BASE + 9, "gpio_9")
+#define RTK_PINCTRL_PIN_gpio_10				PINCTRL_PIN(P_ISO_BASE + 10, "gpio_10")
+#define RTK_PINCTRL_PIN_gpio_11				PINCTRL_PIN(P_ISO_BASE + 11, "gpio_11")
+
+/* ISO muxpad2*/
+#define RTK_PINCTRL_PIN_gpio_12				PINCTRL_PIN(P_ISO_BASE + 12, "gpio_12")
+#define RTK_PINCTRL_PIN_gpio_13				PINCTRL_PIN(P_ISO_BASE + 13, "gpio_13")
+#define RTK_PINCTRL_PIN_gpio_14				PINCTRL_PIN(P_ISO_BASE + 14, "gpio_14")
+#define RTK_PINCTRL_PIN_gpio_15				PINCTRL_PIN(P_ISO_BASE + 15, "gpio_15")
+#define RTK_PINCTRL_PIN_gpio_16				PINCTRL_PIN(P_ISO_BASE + 16, "gpio_16")
+#define RTK_PINCTRL_PIN_gpio_17				PINCTRL_PIN(P_ISO_BASE + 17, "gpio_17")
+#define RTK_PINCTRL_PIN_gpio_18				PINCTRL_PIN(P_ISO_BASE + 18, "gpio_18")
+#define RTK_PINCTRL_PIN_gpio_19				PINCTRL_PIN(P_ISO_BASE + 19, "gpio_19")
+#define RTK_PINCTRL_PIN_gpio_20				PINCTRL_PIN(P_ISO_BASE + 20, "gpio_20")
+#define RTK_PINCTRL_PIN_gpio_21				PINCTRL_PIN(P_ISO_BASE + 21, "gpio_21")
+#define RTK_PINCTRL_PIN_gpio_22				PINCTRL_PIN(P_ISO_BASE + 22, "gpio_22")
+#define RTK_PINCTRL_PIN_gpio_23				PINCTRL_PIN(P_ISO_BASE + 23, "gpio_23")
+#define RTK_PINCTRL_PIN_usb_cc2				PINCTRL_PIN(P_ISO_BASE + 24, "usb_cc2")
+#define RTK_PINCTRL_PIN_gpio_25				PINCTRL_PIN(P_ISO_BASE + 25, "gpio_25")
+#define RTK_PINCTRL_PIN_gpio_26				PINCTRL_PIN(P_ISO_BASE + 26, "gpio_26")
+#define RTK_PINCTRL_PIN_gpio_27				PINCTRL_PIN(P_ISO_BASE + 27, "gpio_27")
+
+/* ISO muxpad3*/
+#define RTK_PINCTRL_PIN_gpio_28				PINCTRL_PIN(P_ISO_BASE + 28, "gpio_28")
+#define RTK_PINCTRL_PIN_gpio_29				PINCTRL_PIN(P_ISO_BASE + 29, "gpio_29")
+#define RTK_PINCTRL_PIN_gpio_30				PINCTRL_PIN(P_ISO_BASE + 30, "gpio_30")
+#define RTK_PINCTRL_PIN_gpio_31				PINCTRL_PIN(P_ISO_BASE + 31, "gpio_31")
+#define RTK_PINCTRL_PIN_gpio_32				PINCTRL_PIN(P_ISO_BASE + 32, "gpio_32")
+#define RTK_PINCTRL_PIN_gpio_33				PINCTRL_PIN(P_ISO_BASE + 33, "gpio_33")
+#define RTK_PINCTRL_PIN_gpio_34				PINCTRL_PIN(P_ISO_BASE + 34, "gpio_34")
+#define RTK_PINCTRL_PIN_gpio_35				PINCTRL_PIN(P_ISO_BASE + 35, "gpio_35")
+#define RTK_PINCTRL_PIN_hif_data			PINCTRL_PIN(P_ISO_BASE + 36, "hif_data")
+#define RTK_PINCTRL_PIN_hif_en				PINCTRL_PIN(P_ISO_BASE + 37, "hif_en")
+#define RTK_PINCTRL_PIN_hif_rdy				PINCTRL_PIN(P_ISO_BASE + 38, "hif_rdy")
+
+/* ISO muxpad4*/
+#define RTK_PINCTRL_PIN_hif_clk				PINCTRL_PIN(P_ISO_BASE + 39, "hif_clk")
+#define RTK_PINCTRL_PIN_gpio_40				PINCTRL_PIN(P_ISO_BASE + 40, "gpio_40")
+#define RTK_PINCTRL_PIN_gpio_41				PINCTRL_PIN(P_ISO_BASE + 41, "gpio_41")
+#define RTK_PINCTRL_PIN_gpio_42				PINCTRL_PIN(P_ISO_BASE + 42, "gpio_42")
+#define RTK_PINCTRL_PIN_gpio_43				PINCTRL_PIN(P_ISO_BASE + 43, "gpio_43")
+#define RTK_PINCTRL_PIN_gpio_44				PINCTRL_PIN(P_ISO_BASE + 44, "gpio_44")
+#define RTK_PINCTRL_PIN_gpio_45				PINCTRL_PIN(P_ISO_BASE + 45, "gpio_45")
+#define RTK_PINCTRL_PIN_gpio_46				PINCTRL_PIN(P_ISO_BASE + 46, "gpio_46")
+#define RTK_PINCTRL_PIN_gpio_47				PINCTRL_PIN(P_ISO_BASE + 47, "gpio_47")
+#define RTK_PINCTRL_PIN_gpio_48				PINCTRL_PIN(P_ISO_BASE + 48, "gpio_48")
+#define RTK_PINCTRL_PIN_gpio_49				PINCTRL_PIN(P_ISO_BASE + 49, "gpio_49")
+#define RTK_PINCTRL_PIN_gpio_50				PINCTRL_PIN(P_ISO_BASE + 50, "gpio_50")
+#define RTK_PINCTRL_PIN_usb_cc1				PINCTRL_PIN(P_ISO_BASE + 51, "usb_cc1")
+#define RTK_PINCTRL_PIN_gpio_52				PINCTRL_PIN(P_ISO_BASE + 52, "gpio_52")
+#define RTK_PINCTRL_PIN_gpio_53				PINCTRL_PIN(P_ISO_BASE + 53, "gpio_53")
+#define RTK_PINCTRL_PIN_ir_rx				PINCTRL_PIN(P_ISO_BASE + 54, "ir_rx")
+#define RTK_PINCTRL_PIN_ur0_rx				PINCTRL_PIN(P_ISO_BASE + 55, "ur0_rx")
+
+/* ISO muxpad5*/
+#define RTK_PINCTRL_PIN_ur0_tx				PINCTRL_PIN(P_ISO_BASE + 56, "ur0_tx")
+#define RTK_PINCTRL_PIN_gpio_57				PINCTRL_PIN(P_ISO_BASE + 57, "gpio_57")
+#define RTK_PINCTRL_PIN_gpio_58				PINCTRL_PIN(P_ISO_BASE + 58, "gpio_58")
+#define RTK_PINCTRL_PIN_gpio_59				PINCTRL_PIN(P_ISO_BASE + 59, "gpio_59")
+#define RTK_PINCTRL_PIN_gpio_60				PINCTRL_PIN(P_ISO_BASE + 60, "gpio_60")
+#define RTK_PINCTRL_PIN_gpio_61				PINCTRL_PIN(P_ISO_BASE + 61, "gpio_61")
+#define RTK_PINCTRL_PIN_gpio_62				PINCTRL_PIN(P_ISO_BASE + 62, "gpio_62")
+#define RTK_PINCTRL_PIN_gpio_63				PINCTRL_PIN(P_ISO_BASE + 63, "gpio_63")
+#define RTK_PINCTRL_PIN_gpio_64				PINCTRL_PIN(P_ISO_BASE + 64, "gpio_64")
+#define RTK_PINCTRL_PIN_gpio_65				PINCTRL_PIN(P_ISO_BASE + 65, "gpio_65")
+#define RTK_PINCTRL_PIN_gpio_66				PINCTRL_PIN(P_ISO_BASE + 66, "gpio_66")
+#define RTK_PINCTRL_PIN_gpio_67				PINCTRL_PIN(P_ISO_BASE + 67, "gpio_67")
+#define RTK_PINCTRL_PIN_gpio_68				PINCTRL_PIN(P_ISO_BASE + 68, "gpio_68")
+#define RTK_PINCTRL_PIN_gpio_69				PINCTRL_PIN(P_ISO_BASE + 69, "gpio_69")
+
+/*ISO muxpad6*/
+#define RTK_PINCTRL_PIN_gpio_70				PINCTRL_PIN(P_ISO_BASE + 70, "gpio_70")
+#define RTK_PINCTRL_PIN_gpio_71				PINCTRL_PIN(P_ISO_BASE + 71, "gpio_71")
+#define RTK_PINCTRL_PIN_gpio_72				PINCTRL_PIN(P_ISO_BASE + 72, "gpio_72")
+#define RTK_PINCTRL_PIN_gpio_73				PINCTRL_PIN(P_ISO_BASE + 73, "gpio_73")
+#define RTK_PINCTRL_PIN_gpio_74				PINCTRL_PIN(P_ISO_BASE + 74, "gpio_74")
+#define RTK_PINCTRL_PIN_gpio_75				PINCTRL_PIN(P_ISO_BASE + 75, "gpio_75")
+#define RTK_PINCTRL_PIN_gpio_76				PINCTRL_PIN(P_ISO_BASE + 76, "gpio_76")
+
+/* ISO muxpad0*/
+#define RTK_PINCTRL_PIN_emmc_cmd			PINCTRL_PIN(P_ISO_BASE + 77, "emmc_cmd")
+#define RTK_PINCTRL_PIN_spi_ce_n			PINCTRL_PIN(P_ISO_BASE + 78, "spi_ce_n")
+#define RTK_PINCTRL_PIN_spi_sck				PINCTRL_PIN(P_ISO_BASE + 79, "spi_sck")
+#define RTK_PINCTRL_PIN_spi_so				PINCTRL_PIN(P_ISO_BASE + 80, "spi_so")
+#define RTK_PINCTRL_PIN_spi_si				PINCTRL_PIN(P_ISO_BASE + 81, "spi_si")
+#define RTK_PINCTRL_PIN_emmc_rst_n			PINCTRL_PIN(P_ISO_BASE + 82, "emmc_rst_n")
+#define RTK_PINCTRL_PIN_emmc_dd_sb			PINCTRL_PIN(P_ISO_BASE + 83, "emmc_dd_sb")
+#define RTK_PINCTRL_PIN_emmc_clk			PINCTRL_PIN(P_ISO_BASE + 84, "emmc_clk")
+#define RTK_PINCTRL_PIN_emmc_data_0			PINCTRL_PIN(P_ISO_BASE + 85, "emmc_data_0")
+#define RTK_PINCTRL_PIN_emmc_data_1			PINCTRL_PIN(P_ISO_BASE + 86, "emmc_data_1")
+#define RTK_PINCTRL_PIN_emmc_data_2			PINCTRL_PIN(P_ISO_BASE + 87, "emmc_data_2")
+#define RTK_PINCTRL_PIN_emmc_data_3			PINCTRL_PIN(P_ISO_BASE + 88, "emmc_data_3")
+#define RTK_PINCTRL_PIN_emmc_data_4			PINCTRL_PIN(P_ISO_BASE + 89, "emmc_data_4")
+#define RTK_PINCTRL_PIN_emmc_data_5			PINCTRL_PIN(P_ISO_BASE + 90, "emmc_data_5")
+#define RTK_PINCTRL_PIN_emmc_data_6			PINCTRL_PIN(P_ISO_BASE + 91, "emmc_data_6")
+#define RTK_PINCTRL_PIN_emmc_data_7			PINCTRL_PIN(P_ISO_BASE + 92, "emmc_data_7")
+
+/*ISO muxpad8*/
+#define RTK_PINCTRL_PIN_ur2_loc				PINCTRL_PIN(P_ISO_BASE + 93, "ur2_loc")
+#define RTK_PINCTRL_PIN_gspi_loc			PINCTRL_PIN(P_ISO_BASE + 94, "gspi_loc")
+#define RTK_PINCTRL_PIN_sdio_loc			PINCTRL_PIN(P_ISO_BASE + 95, "sdio_loc")
+#define RTK_PINCTRL_PIN_hi_loc				PINCTRL_PIN(P_ISO_BASE + 96, "hi_loc")
+#define RTK_PINCTRL_PIN_hi_width			PINCTRL_PIN(P_ISO_BASE + 97, "hi_width")
+#define RTK_PINCTRL_PIN_debug_p2s_enable		PINCTRL_PIN(P_ISO_BASE + 98, "debug_p2s_enable")
+#define RTK_PINCTRL_PIN_sf_en				PINCTRL_PIN(P_ISO_BASE + 99, "sf_en")
+#define RTK_PINCTRL_PIN_arm_trace_dbg_en		PINCTRL_PIN(P_ISO_BASE + 100, "arm_trace_dbg_en")
+#define RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc0	PINCTRL_PIN(P_ISO_BASE + 101, "pwm_01_open_drain_en_loc0")
+#define RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc0	PINCTRL_PIN(P_ISO_BASE + 102, "pwm_23_open_drain_en_loc0")
+#define RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc1	PINCTRL_PIN(P_ISO_BASE + 103, "pwm_01_open_drain_en_loc1")
+#define RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc1	PINCTRL_PIN(P_ISO_BASE + 104, "pwm_23_open_drain_en_loc1")
+#define RTK_PINCTRL_PIN_ejtag_acpu_loc			PINCTRL_PIN(P_ISO_BASE + 105, "ejtag_acpu_loc")
+#define RTK_PINCTRL_PIN_ejtag_vcpu_loc			PINCTRL_PIN(P_ISO_BASE + 106, "ejtag_vcpu_loc")
+#define RTK_PINCTRL_PIN_ejtag_scpu_loc			PINCTRL_PIN(P_ISO_BASE + 107, "ejtag_scpu_loc")
+#define RTK_PINCTRL_PIN_dmic_loc			PINCTRL_PIN(P_ISO_BASE + 108, "dmic_loc")
+#define RTK_PINCTRL_PIN_iso_gspi_loc			PINCTRL_PIN(P_ISO_BASE + 109, "iso_gspi_loc")
+
+
+
+
+enum PMUX_BASE_TYPE {
+	PMUX_BASE_ISO,
+	PMUX_BASE_MISC
+};
+
+struct rtk_pin_regmap {
+	u8 pmux_base;
+	u16 pmux_regoff;
+	u16 pmux_regbit;
+	u16 pmux_regbitmsk;
+	u16 pcof_regoff;
+	u16 pcof_regbit;
+	u16 pcof_cur_strgh;/*0 : 2&4mA   1:4&8mA*/
+};
+
+struct rtk_pinmux_reg {
+	u8 reg_base;
+	u16 reg_offset;
+};
+
+#define PADDRI_4_8 1
+#define PADDRI_2_4 0
+#define PADDRI_UNSUPPORT 0xFFFF
+
+#define PCOF_UNSUPPORT 0xFFFF
+#define PMUX_UNSUPPORT 0xFF
+
+static const struct rtk_pinmux_reg pinmux_reg_list[] = {
+	/*ISO muxpad*/
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x000},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x004},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x008},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x00c},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x010},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x014},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x018},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x120},
+	/*ISO  pfunc*/
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x01C},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x020},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x024},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x028},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x030},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x034},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x038},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x03C},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x040},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x044},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x048},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x04C},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x050},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x054},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x058},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x05C},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x060},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x064},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x068},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x06C},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x070},
+};
+
+static const struct rtk_pin_regmap pin_regmap[] = {
+	/*GPIO*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  0, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x038, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 0, "gpio_0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  1, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x038, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 1, "gpio_1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  3, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x03C, .pcof_regbit =  1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 2, "gpio_2")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  6, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x03C, .pcof_regbit =  5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 3, "gpio_3")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  9, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x03C, .pcof_regbit =  9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 4, "gpio_4")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 12, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x03C, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 5, "gpio_5")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 15, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x03C, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 6, "gpio_6")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 18, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x03C, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 7, "gpio_7")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 19, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x03C, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 8, "gpio_8")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x03C, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 9, "gpio_9")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 25, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x040, .pcof_regbit =  1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 10, "gpio_10")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 28, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x040, .pcof_regbit =  5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 11, "gpio_11")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit =  0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x040, .pcof_regbit =  9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 12, "gpio_12")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit =  2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x040, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 13, "gpio_13")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit =  4, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x040, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 14, "gpio_14")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit =  7, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x040, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 15, "gpio_15")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 10, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x040, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 16, "gpio_16")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 11, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x040, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 17, "gpio_17")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 12, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x044, .pcof_regbit =  1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 18, "gpio_18")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 15, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x044, .pcof_regbit =  5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 19, "gpio_19")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 18, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x044, .pcof_regbit =  9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 20, "gpio_20")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 21, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x044, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 21, "gpio_21")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 23, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x044, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 22, "gpio_22")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 25, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x044, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 23, "gpio_23")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 27, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 24, "usb_cc2")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 28, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x044, .pcof_regbit = 27, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 25, "gpio_25")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 30, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x048, .pcof_regbit =  1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 26, "gpio_26")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 31, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x048, .pcof_regbit =  5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 27, "gpio_27")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  0, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x048, .pcof_regbit =  9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 28, "gpio_28")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  1, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x048, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 29, "gpio_29")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  2, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x048, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 30, "gpio_30")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  3, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x048, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 31, "gpio_31")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  6, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x04C, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 32, "gpio_32")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  9, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x04C, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 33, "gpio_33")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 12, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x04C, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 34, "gpio_34")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 15, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x050, .pcof_regbit =  1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 35, "gpio_35")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 17, .pmux_regbitmsk = 0xF,	.pcof_regoff = 0x050, .pcof_regbit =  4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 36, "hif_data")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 21, .pmux_regbitmsk = 0xF,	.pcof_regoff = 0x050, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 37, "hif_en")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 25, .pmux_regbitmsk = 0xF,	.pcof_regoff = 0x054, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 38, "hif_rdy")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit =  0, .pmux_regbitmsk = 0xF,	.pcof_regoff = 0x054, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 39, "hif_clk")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit =  4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x058, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 40, "gpio_40")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit =  6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x058, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 41, "gpio_41")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit =  8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x05C, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 42, "gpio_42")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x05C, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 43, "gpio_43")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x060, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 44, "gpio_44")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x060, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 45, "gpio_45")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x060, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 46, "gpio_46")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x060, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 47, "gpio_47")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 20, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x064, .pcof_regbit =  1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 48, "gpio_48")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 21, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x064, .pcof_regbit =  5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 49, "gpio_49")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x064, .pcof_regbit =  9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 50, "gpio_50")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 24, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 51, "usb_cc1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 25, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x064, .pcof_regbit = 15, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 52, "gpio_52")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 27, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x064, .pcof_regbit = 19, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 53, "gpio_53")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 29, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x064, .pcof_regbit = 23, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 54, "ir_rx")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit = 31, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x064, .pcof_regbit = 27, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 55, "ur0_rx")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit =  0, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x068, .pcof_regbit =  1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 56, "ur0_tx")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit =  1, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x068, .pcof_regbit =  5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 57, "gpio_57")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit =  3, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x068, .pcof_regbit =  9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 58, "gpio_58")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit =  5, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x068, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 59, "gpio_59")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit =  7, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x068, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 60, "gpio_60")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit =  9, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x068, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 61, "gpio_61")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 11, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x068, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 62, "gpio_62")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 13, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x068, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 63, "gpio_63")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 15, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x06C, .pcof_regbit =  1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 64, "gpio_64")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 17, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x06C, .pcof_regbit =  5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 65, "gpio_65")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 18, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x06C, .pcof_regbit =  9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 66, "gpio_66")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 21, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x06C, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 67, "gpio_67")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 24, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x06C, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 68, "gpio_68")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x014, .pmux_regbit = 27, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x06C, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 69, "gpio_69")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit =  0, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x06C, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 70, "gpio_70")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit =  3, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x070, .pcof_regbit =  1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 71, "gpio_71")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit =  6, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x070, .pcof_regbit =  6, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 72, "gpio_72")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit =  9, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x070, .pcof_regbit = 11, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 73, "gpio_73")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 12, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x070, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 74, "gpio_74")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 15, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x070, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 75, "gpio_75")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x018, .pmux_regbit = 17, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x070, .pcof_regbit = 26, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 76, "gpio_76")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit =  6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x020, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 77, "emmc_cmd")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 24, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x034, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 78, "spi_ce_n")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 26, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x034, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 79, "spi_sck")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 28, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x038, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 80, "spi_so")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 30, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x038, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 81, "spi_si")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit =  0, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x01C, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 82, "emmc_rst_n")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit =  2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x01C, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 83, "emmc_dd_sb")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit =  4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x020, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 84, "emmc_clk")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit =  8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 85, "emmc_data_0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 86, "emmc_data_1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 12, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 87, "emmc_data_2")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 14, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 88, "emmc_data_3")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 16, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 89, "emmc_data_4")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 18, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 90, "emmc_data_5")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 20, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x030, .pcof_regbit =  0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 91, "emmc_data_6")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x030, .pcof_regbit = 12, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 92, "emmc_data_7")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit =  0, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 93, "ur2_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit =  2, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 94, "gspi_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit =  4, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 95, "sdio_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit =  6, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 96, "hi_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit =  8, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 97, "hi_width")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 10, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 98, "debug_p2s_enable")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 11, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 99, "sf_en")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 12, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 100, "arm_trace_dbg_en")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 13, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 101, "pwm_01_open_drain_en_loc0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 14, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 102, "pwm_23_open_drain_en_loc0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 15, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 103, "pwm_01_open_drain_en_loc1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 16, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 104, "pwm_23_open_drain_en_loc1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 17, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 105, "ejtag_acpu_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 19, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 106, "ejtag_vcpu_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 21, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 107, "ejtag_scpu_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 24, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 108, "dmic_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x120, .pmux_regbit = 26, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 109, "iso_gspi_loc")*/
+};
+
+
+struct RTK_desc_function {
+	const char	*name;
+	u8		muxval;
+};
+
+struct RTK_desc_pin {
+	struct pinctrl_pin_desc		pin;
+	struct RTK_desc_function	*functions;
+};
+
+struct RTK_pinctrl_desc {
+	const struct RTK_desc_pin	*pins;
+	int				npins;
+	struct pinctrl_gpio_range	*ranges;
+	int				nranges;
+};
+
+struct RTK_pinctrl_function {
+	const char	*name;
+	const char	**groups;
+	unsigned int	ngroups;
+};
+
+struct RTK_pinctrl_group {
+	const char	*name;
+	unsigned long	config;
+	unsigned int	pin;
+};
+
+struct RTK_pinctrl {
+/*
+ *	void __iomem			*sb2_membase;
+ *	void __iomem			*disp_membase;
+ *	void __iomem			*cr_membase;
+ *	void __iomem			*iso_membase;
+ *	struct gpio_chip		*chip;
+ */
+	void __iomem			*iso_membase;
+	struct RTK_pinctrl_desc	*desc;
+	struct device			*dev;
+	struct RTK_pinctrl_function	*functions;
+	unsigned int			nfunctions;
+	struct RTK_pinctrl_group	*groups;
+	unsigned int			ngroups;
+	struct pinctrl_dev		*pctl_dev;
+};
+
+#define RTK_PIN(_pin, ...)					\
+	{							\
+		.pin = _pin,					\
+		.functions = (struct RTK_desc_function[]){	\
+			__VA_ARGS__, { } },			\
+	}
+
+#define RTK_FUNCTION(_val, _name)				\
+	{							\
+		.name = _name,					\
+		.muxval = _val,					\
+	}
+
+
+static const struct RTK_desc_pin rtk_pins[] = {
+	/*GPIO*/
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_0,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "emmc_spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "standby_dbg"),
+		RTK_FUNCTION(0x3, "emmc_spi"),
+		RTK_FUNCTION(0x4, "sc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x7, "vcpu_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "standby_dbg"),
+		RTK_FUNCTION(0x3, "emmc_spi"),
+		RTK_FUNCTION(0x4, "sc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x7, "vcpu_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_4,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "emmc_spi"),
+		RTK_FUNCTION(0x4, "sc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x7, "vcpu_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_5,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "emmc_spi"),
+		RTK_FUNCTION(0x4, "sc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x7, "vcpu_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_6,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "emmc_spi"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x7, "vcpu_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_7,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_8,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1"),
+		RTK_FUNCTION(0x3, "gspi_loc1"),
+		RTK_FUNCTION(0x5, "iso_gspi_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_9,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1"),
+		RTK_FUNCTION(0x3, "gspi_loc1"),
+		RTK_FUNCTION(0x5, "iso_gspi_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_10,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1"),
+		RTK_FUNCTION(0x3, "gspi_loc1"),
+		RTK_FUNCTION(0x5, "iso_gspi_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_11,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1"),
+		RTK_FUNCTION(0x2, "rtc_dig"),
+		RTK_FUNCTION(0x3, "gspi_loc1"),
+		RTK_FUNCTION(0x4, "rtc_ana"),
+		RTK_FUNCTION(0x5, "iso_gspi_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_12,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c0"),
+		RTK_FUNCTION(0x2, "pwm0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_13,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c0"),
+		RTK_FUNCTION(0x2, "pwm1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_14,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "etn_led"),
+		RTK_FUNCTION(0x2, "pwm2"),
+		RTK_FUNCTION(0x3, "etn_phy"),
+		RTK_FUNCTION(0x4, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_15,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "etn_led"),
+		RTK_FUNCTION(0x2, "pwm3"),
+		RTK_FUNCTION(0x3, "etn_phy"),
+		RTK_FUNCTION(0x4, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_16,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_17,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_18,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "sc0"),
+		RTK_FUNCTION(0x3, "gspi_loc0"),
+		RTK_FUNCTION(0x5, "iso_gspi_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_19,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "sc0"),
+		RTK_FUNCTION(0x3, "gspi_loc0"),
+		RTK_FUNCTION(0x5, "iso_gspi_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_20,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "pwm0"),
+		RTK_FUNCTION(0x3, "gspi_loc0"),
+		RTK_FUNCTION(0x3, "sc0"),
+		RTK_FUNCTION(0x5, "iso_gspi_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_21,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "qam_agc_if"),
+		RTK_FUNCTION(0x2, "pwm1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_22,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "pwm2")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_23,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "pwm3")),
+	RTK_PIN(RTK_PINCTRL_PIN_usb_cc2,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio24*/
+		RTK_FUNCTION(0x1, "usb_cc2")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_25,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc1"),
+		RTK_FUNCTION(0x2, "pcie1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_26,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_27,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_28,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_29,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "i2c5")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_30,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_31,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "sc0"),
+		RTK_FUNCTION(0x3, "gspi_loc0"),
+		RTK_FUNCTION(0x5, "iso_gspi_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_32,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio32*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "ai_loc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "acpu_ejtag_loc1"),
+		RTK_FUNCTION(0x7, "vcpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_33,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio33*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "ai_loc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "acpu_ejtag_loc1"),
+		RTK_FUNCTION(0x7, "vcpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_34,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "ai_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_35,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x3, "dmic_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_hif_data,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio36*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "tdm_ai_loc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "acpu_ejtag_loc1"),
+		RTK_FUNCTION(0x7, "vcpu_ejtag_loc1"),
+		RTK_FUNCTION(0x8, "ai_loc1"),
+		RTK_FUNCTION(0x9, "hi")),
+	RTK_PIN(RTK_PINCTRL_PIN_hif_en,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio37*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "tdm_ai_loc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "acpu_ejtag_loc1"),
+		RTK_FUNCTION(0x7, "vcpu_ejtag_loc1"),
+		RTK_FUNCTION(0x8, "ai_loc1"),
+		RTK_FUNCTION(0x9, "hi")),
+	RTK_PIN(RTK_PINCTRL_PIN_hif_rdy,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio38*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "tdm_ai_loc1"),
+		RTK_FUNCTION(0x8, "ai_loc1"),
+		RTK_FUNCTION(0x9, "hi")),
+	RTK_PIN(RTK_PINCTRL_PIN_hif_clk,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio39*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "tdm_ai_loc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "acpu_ejtag_loc1"),
+		RTK_FUNCTION(0x7, "vcpu_ejtag_loc1"),
+		RTK_FUNCTION(0x8, "ai_loc1"),
+		RTK_FUNCTION(0x9, "hi")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_40,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_41,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_42,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_43,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_44,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_45,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_46,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c5"),
+		RTK_FUNCTION(0x2, "pcie0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_47,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "dc_fan")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_48,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_49,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_50,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "spdif"),
+		RTK_FUNCTION(0x2, "test_loop_dis")),
+	RTK_PIN(RTK_PINCTRL_PIN_usb_cc1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "usb_cc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_52,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test_loc0"),
+		RTK_FUNCTION(0x2, "debug_p2s"),
+		RTK_FUNCTION(0x3, "pcie2")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_53,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio53*/
+		RTK_FUNCTION(0x1, "pll_test_loc0"),
+		RTK_FUNCTION(0x2, "debug_p2s")),
+	RTK_PIN(RTK_PINCTRL_PIN_ir_rx,
+		RTK_FUNCTION(0x0, "gpio"),  /*gpio54*/
+		RTK_FUNCTION(0x1, "ir_rx"),
+		RTK_FUNCTION(0x2, "standby_dbg")),
+	RTK_PIN(RTK_PINCTRL_PIN_ur0_rx,
+		RTK_FUNCTION(0x0, "gpio"),  /*gpio55*/
+		RTK_FUNCTION(0x1, "uart0")),
+	RTK_PIN(RTK_PINCTRL_PIN_ur0_tx,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio56*/
+		RTK_FUNCTION(0x1, "uart0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_57,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tdm_ai_loc0"),
+		RTK_FUNCTION(0x2, "ai_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_58,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tdm_ai_loc0"),
+		RTK_FUNCTION(0x2, "ai_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_59,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tdm_ai_loc0"),
+		RTK_FUNCTION(0x2, "ai_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_60,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "tdm_ai_loc0"),
+		RTK_FUNCTION(0x2, "ai_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_61,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ai_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_62,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ai_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_63,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ai_loc0"),
+		RTK_FUNCTION(0x2, "i2c3"),
+		RTK_FUNCTION(0x3, "dmic_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_64,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "i2c3"),
+		RTK_FUNCTION(0x3, "dmic_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_65,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_66,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0"),
+		RTK_FUNCTION(0x4, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_67,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0"),
+		RTK_FUNCTION(0x4, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_68,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0"),
+		RTK_FUNCTION(0x4, "ao"),
+		RTK_FUNCTION(0x5, "rmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_69,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0"),
+		RTK_FUNCTION(0x3, "tp1"),
+		RTK_FUNCTION(0x4, "ao"),
+		RTK_FUNCTION(0x5, "rmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_70,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0"),
+		RTK_FUNCTION(0x3, "tp1"),
+		RTK_FUNCTION(0x4, "ao"),
+		RTK_FUNCTION(0x5, "rmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_71,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0"),
+		RTK_FUNCTION(0x3, "tp1"),
+		RTK_FUNCTION(0x4, "ao"),
+		RTK_FUNCTION(0x5, "rmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_72,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0"),
+		RTK_FUNCTION(0x3, "tp1"),
+		RTK_FUNCTION(0x4, "ao"),
+		RTK_FUNCTION(0x5, "rmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_73,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0"),
+		RTK_FUNCTION(0x5, "rmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_74,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0"),
+		RTK_FUNCTION(0x5, "rmii")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_75,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_76,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "rgmii"),
+		RTK_FUNCTION(0x2, "tp0")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_cmd,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio77*/
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc_cmd")),
+	RTK_PIN(RTK_PINCTRL_PIN_spi_ce_n,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio78*/
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "spi"),
+		RTK_FUNCTION(0x3, "pmic")),
+	RTK_PIN(RTK_PINCTRL_PIN_spi_sck,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio79*/
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "spi"),
+		RTK_FUNCTION(0x3, "spdif")),
+	RTK_PIN(RTK_PINCTRL_PIN_spi_so,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio80*/
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_spi_si,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio81*/
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "spi")),
+
+	/*OTHERS*/
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_rst_n,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_dd_sb,
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_clk,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_0,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "nf_spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_1,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "nf_spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_2,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "nf_spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_3,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "nf_spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_4,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "nf_spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_5,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc"),
+		RTK_FUNCTION(0x3, "nf_spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_6,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_7,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+
+	RTK_PIN(RTK_PINCTRL_PIN_ur2_loc,
+		RTK_FUNCTION(0x0, "uart2_disable"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "uart2_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gspi_loc,
+		RTK_FUNCTION(0x0, "gspi_disable"),
+		RTK_FUNCTION(0x1, "gspi_loc0"),
+		RTK_FUNCTION(0x2, "gspi_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_sdio_loc,
+		RTK_FUNCTION(0x0, "sdio_disable"),
+		RTK_FUNCTION(0x1, "sdio_loc0"),
+		RTK_FUNCTION(0x2, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_hi_loc,
+		RTK_FUNCTION(0x0, "hi_loc_disable"),
+		RTK_FUNCTION(0x1, "hi_loc0"),
+		RTK_FUNCTION(0x2, "hi_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_hi_width,
+		RTK_FUNCTION(0x0, "hi_width_disable"),
+		RTK_FUNCTION(0x1, "hi_width_1bit"),
+		RTK_FUNCTION(0x2, "hi_width_8bit"),
+		RTK_FUNCTION(0x3, "hi_width_16bit")),
+	RTK_PIN(RTK_PINCTRL_PIN_debug_p2s_enable,
+		RTK_FUNCTION(0x0, "p2s_disable"),
+		RTK_FUNCTION(0x1, "debug_p2s")),
+	RTK_PIN(RTK_PINCTRL_PIN_sf_en,
+		RTK_FUNCTION(0x0, "sf_disable"),
+		RTK_FUNCTION(0x1, "sf_enable")),
+	RTK_PIN(RTK_PINCTRL_PIN_arm_trace_dbg_en,
+		RTK_FUNCTION(0x0, "arm_trace_debug_disable"),
+		RTK_FUNCTION(0x1, "arm_trace_debug_enable")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc0,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc0,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc1,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc1,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_ejtag_acpu_loc,
+		RTK_FUNCTION(0x0, "acpu_ejtag_disable"),
+		RTK_FUNCTION(0x1, "acpu_ejtag_loc0"),
+		RTK_FUNCTION(0x2, "acpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_ejtag_vcpu_loc,
+		RTK_FUNCTION(0x0, "vcpu_ejtag_disable"),
+		RTK_FUNCTION(0x1, "vcpu_ejtag_loc0"),
+		RTK_FUNCTION(0x2, "vcpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_ejtag_scpu_loc,
+		RTK_FUNCTION(0x0, "scpu_ejtag_disable"),
+		RTK_FUNCTION(0x1, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x2, "scpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_dmic_loc,
+		RTK_FUNCTION(0x1, "dmic_loc0"),
+		RTK_FUNCTION(0x2, "dmic_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_iso_gspi_loc,
+		RTK_FUNCTION(0x1, "iso_gspi_loc0"),
+		RTK_FUNCTION(0x2, "iso_gspi_loc1")),
+
+};
+
+void gpio_pinctrl_control(struct gpio_chip *gc, int gpio, int direction, int value);
+
+#endif /* __PINCTRL_RTK13xx_H */
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd16xx.c b/drivers/pinctrl/realtek/pinctrl-rtd16xx.c
new file mode 100644
index 00000000..c931b58
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd16xx.c
@@ -0,0 +1,1016 @@
+/*
+ * Realtek pin controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include "pinctrl-rtd16xx.h"
+#include <linux/io.h>
+#include <linux/clk.h>
+#include <linux/gpio.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_device.h>
+#include <linux/pinctrl/consumer.h>
+#include <linux/pinctrl/machine.h>
+#include <linux/pinctrl/pinctrl.h>
+#include <linux/pinctrl/pinconf-generic.h>
+#include <linux/pinctrl/pinmux.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include "../core.h"
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+static u32 *pinctrl_reg_values;
+
+static const struct RTK_pinctrl_desc rtk16xx_pinctrl_data = {
+	.pins = rtk_pins,
+	.npins = ARRAY_SIZE(rtk_pins),
+};
+
+static void RTK_pmx_set(struct pinctrl_dev *pctldev,
+	unsigned int pin, u8 config)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	void __iomem *addr;
+	u32 val;
+	u32 mask;
+
+	if (pin_regmap[pin].pmux_regoff == PMUX_UNSUPPORT)
+		return;
+
+	switch (pin_regmap[pin].pmux_base) {
+	case PMUX_BASE_ISO:
+		addr = pctl->iso_membase + pin_regmap[pin].pmux_regoff;
+		break;
+	case PMUX_BASE_MISC:
+		addr = pctl->misc_membase + pin_regmap[pin].pmux_regoff;
+		break;
+	default:
+		RTK_PINCTRL_ERR("[%s] Unknow pmux_base", __func__);
+		return;
+	}
+	RTK_PINCTRL_DBG("[%s] Addr(0x%08llx), bit=%u, config=%u",
+		__func__, (u64)addr, pin_regmap[pin].pmux_regbit, config);
+
+	val = readl(addr);
+	mask =	pin_regmap[pin].pmux_regbitmsk << pin_regmap[pin].pmux_regbit;
+	writel(((val & ~mask) | (config << pin_regmap[pin].pmux_regbit)), addr);
+
+	RTK_PINCTRL_DBG("[%s] Addr(0x%08llx) final_val=0x%08x",
+			__func__, (u64)addr, readl(addr));
+
+}
+
+static struct RTK_pinctrl_group *
+RTK_pinctrl_find_group_by_name(struct RTK_pinctrl *pctl, const char *group)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s] name = %s", __func__, group);
+	for (i = 0; i < pctl->ngroups; i++) {
+		struct RTK_pinctrl_group *grp = pctl->groups + i;
+
+		if (!strcmp(grp->name, group))
+			return grp;
+	}
+
+	return NULL;
+}
+
+static struct RTK_pinctrl_function *
+RTK_pinctrl_find_function_by_name(struct RTK_pinctrl *pctl,
+				    const char *name)
+{
+	struct RTK_pinctrl_function *func = pctl->functions;
+	int i;
+	/*RTK_PINCTRL_DBG("[%s]", __func__);*/
+	for (i = 0; i < pctl->nfunctions; i++) {
+		if (!func[i].name)
+			break;
+
+		if (!strcmp(func[i].name, name))
+			return func + i;
+	}
+
+	return NULL;
+}
+
+static struct RTK_desc_function *
+RTK_pinctrl_desc_find_function_by_name(struct RTK_pinctrl *pctl,
+					 const char *pin_name,
+					 const char *func_name)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s] pin_name=%s, func_name=%s",
+			__func__, pin_name, func_name);
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+
+		if (!strcmp(pin->pin.name, pin_name)) {
+			struct RTK_desc_function *func = pin->functions;
+
+			while (func->name) {
+				if (!strcmp(func->name, func_name))
+					return func;
+
+				func++;
+			}
+		}
+	}
+
+	return NULL;
+}
+
+static int RTK_pctrl_get_groups_count(struct pinctrl_dev *pctldev)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] pctl->ngroups=%d",
+			__func__, pctl->ngroups);
+	return pctl->ngroups;
+}
+
+static const char *RTK_pctrl_get_group_name(struct pinctrl_dev *pctldev,
+					      unsigned int group)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	/*RTK_PINCTRL_DBG("[%s] group.name=%s",
+	 *		__func__, pctl->groups[group].name);
+	 */
+	return pctl->groups[group].name;
+}
+
+static int RTK_pctrl_get_group_pins(struct pinctrl_dev *pctldev,
+				      unsigned int group,
+				      const unsigned int **pins,
+				      unsigned int *num_pins)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*pins = (unsigned int *)&pctl->groups[group].pin;
+	*num_pins = 1;
+
+	return 0;
+}
+
+static int RTK_pctrl_dt_node_to_map(struct pinctrl_dev *pctldev,
+				      struct device_node *node,
+				      struct pinctrl_map **map,
+				      unsigned int *num_maps)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	unsigned long *pinconfig;
+	struct property *prop;
+	const char *function;
+	const char *group;
+	int ret, nmaps, i = 0;
+	u32 val;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+
+	*map = NULL;
+	*num_maps = 0;
+
+	ret = of_property_read_string(node, "realtek,function", &function);
+	if (ret) {
+		printk(
+			"missing realtek,function property in node %s\n",
+			node->name);
+		return -EINVAL;
+	}
+
+	nmaps = of_property_count_strings(node, "realtek,pins") * 2;
+	if (nmaps < 0) {
+		printk(
+			"missing realtek,pins property in node %s\n",
+			node->name);
+		return -EINVAL;
+	}
+
+	*map = kmalloc_array(nmaps, sizeof(struct pinctrl_map), GFP_KERNEL);
+	if (!map)
+		return -ENOMEM;
+
+	of_property_for_each_string(node, "realtek,pins", prop, group) {
+		struct RTK_pinctrl_group *grp =
+			RTK_pinctrl_find_group_by_name(pctl, group);
+		int j = 0, configlen = 0;
+
+		if (!grp) {
+			printk("unknown pin %s", group);
+			continue;
+		}
+
+		if (!RTK_pinctrl_desc_find_function_by_name(pctl,
+							      grp->name,
+							      function)) {
+			printk("unsupported function %s on pin %s",
+				function, group);
+			continue;
+		}
+
+		(*map)[i].type = PIN_MAP_TYPE_MUX_GROUP;
+		(*map)[i].data.mux.group = group;
+		(*map)[i].data.mux.function = function;
+
+		i++;
+
+		(*map)[i].type = PIN_MAP_TYPE_CONFIGS_GROUP;
+		(*map)[i].data.configs.group_or_pin = group;
+
+		if (of_find_property(node, "realtek,schmitt", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,drive", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,pull_en", NULL))
+			configlen++;
+		if (of_find_property(node, "realtek,pull_sel", NULL))
+			configlen++;
+
+		RTK_PINCTRL_DBG("[%s] configlen %d", __func__, configlen);
+
+		if (configlen) {
+			pinconfig = kcalloc(configlen,
+					sizeof(*pinconfig), GFP_KERNEL);
+		} else {
+			/* Prevent failed to register map default*/
+			configlen = 1;
+			pinconfig = kzalloc(1 * sizeof(*pinconfig), GFP_KERNEL);
+			pinconfig[j++] = pinconf_to_config_packed
+						(PIN_CONFIG_END, 0);
+		}
+
+		if (!of_property_read_u32(node, "realtek,schmitt", &val)) {
+			u16 schmitt_enable;
+
+			if (val == 0)
+				schmitt_enable = 0;
+			else
+				schmitt_enable = 1;
+
+			pinconfig[j++] = pinconf_to_config_packed
+					(PIN_CONFIG_INPUT_SCHMITT_ENABLE,
+					schmitt_enable);
+		}
+
+		if (!of_property_read_u32(node, "realtek,drive", &val)) {
+			pinconfig[j++] = pinconf_to_config_packed
+					(PIN_CONFIG_DRIVE_STRENGTH, val);
+		}
+
+		if (!of_property_read_u32(node, "realtek,pull_en", &val)) {
+			enum pin_config_param pull = PIN_CONFIG_END;
+
+			if (val == 0)
+				pull = PIN_CONFIG_BIAS_DISABLE;
+			else if (val == 1)
+				pull = PIN_CONFIG_DRIVE_PUSH_PULL;
+			pinconfig[j++] = pinconf_to_config_packed(pull, 0);
+		}
+
+		if (!of_property_read_u32(node, "realtek,pull_sel", &val)) {
+			enum pin_config_param pull = PIN_CONFIG_END;
+
+			if (val == 0)
+				pull = PIN_CONFIG_BIAS_PULL_DOWN;
+			else if (val == 1)
+				pull = PIN_CONFIG_BIAS_PULL_UP;
+			pinconfig[j++] = pinconf_to_config_packed(pull, 1);
+		}
+
+		(*map)[i].data.configs.configs = pinconfig;
+		(*map)[i].data.configs.num_configs = configlen;
+
+		i++;
+	}
+
+	*num_maps = nmaps;
+
+	return 0;
+}
+
+static void RTK_pctrl_dt_free_map(struct pinctrl_dev *pctldev,
+				    struct pinctrl_map *map,
+				    unsigned int num_maps)
+{
+	int i;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	for (i = 0; i < num_maps; i++) {
+		if (map[i].type == PIN_MAP_TYPE_CONFIGS_GROUP)
+			kfree(map[i].data.configs.configs);
+	}
+
+	kfree(map);
+}
+
+static void RTK_pctrl_dbg_show(struct pinctrl_dev *pctldev, struct seq_file *s,
+			  unsigned offset)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_desc_function *func = rtk_pins[offset].functions;
+	void __iomem *addr;
+	u32 val;
+	u32 mask;
+	u8 pin_val;
+	int is_map;
+
+	if(pin_regmap[offset].pmux_regoff == PMUX_UNSUPPORT)
+		return;
+
+	switch (pin_regmap[offset].pmux_base) {
+	case PMUX_BASE_ISO:
+		addr = pctl->iso_membase + pin_regmap[offset].pmux_regoff;
+		break;
+	case PMUX_BASE_MISC:
+		addr = pctl->misc_membase + pin_regmap[offset].pmux_regoff;
+		break;
+	default:
+		RTK_PINCTRL_ERR("[%s] Unknow pmux_base", __func__);
+		return;
+	}
+	val = readl(addr);
+	mask =pin_regmap[offset].pmux_regbitmsk << pin_regmap[offset].pmux_regbit;
+	pin_val = (val & mask) >> pin_regmap[offset].pmux_regbit;
+
+	is_map = 0;
+	seq_printf(s, "function: ");
+	while (func->name) {
+		if (func->muxval == pin_val) {
+			is_map = 1;
+			seq_printf(s, "[%s] ",func->name);
+		} else {
+			seq_printf(s, "%s ",func->name);
+		}
+		func++;
+	}
+	if (!is_map)
+		seq_printf(s, "[not defined] ");
+}
+
+
+static const struct pinctrl_ops RTK_pctrl_ops = {
+	.dt_node_to_map		= RTK_pctrl_dt_node_to_map,
+	.dt_free_map		= RTK_pctrl_dt_free_map,
+	.get_groups_count	= RTK_pctrl_get_groups_count,
+	.get_group_name		= RTK_pctrl_get_group_name,
+	.get_group_pins		= RTK_pctrl_get_group_pins,
+	.pin_dbg_show		= RTK_pctrl_dbg_show,
+};
+
+static int RTK_pconf_parse_conf(struct pinctrl_dev *pctldev,
+	unsigned int pin, enum pin_config_param param,
+	enum pin_config_param arg)
+{
+	void __iomem *addr;
+	u8 set_val;
+	u16 strength;
+	u32 val, mask;
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	int pconf_pulsel, pconf_pulen, pconf_schm, pconf_curr;
+
+	RTK_PINCTRL_DBG("[%s] pin=%u, config_param=%u, config_argument=%u",
+			__func__, pin, param, arg);
+
+	if (pin_regmap[pin].pcof_regoff == PCOF_UNSUPPORT)
+		return 0;
+
+	pconf_schm = RTK_PCONF_SCHM;
+	pconf_curr = RTK_PCONF_CURR;
+	if ((pin == 55) || (pin == 104)) {
+		pconf_pulsel = 0;
+		pconf_pulen = 1;
+	} else {
+		pconf_pulsel = RTK_PCONF_PULSEL;
+		pconf_pulen = RTK_PCONF_PULEN;
+	}
+
+	switch (pin_regmap[pin].pmux_base) {
+		case PMUX_BASE_ISO:
+			addr = pctl->iso_membase + pin_regmap[pin].pcof_regoff;
+			break;
+		case PMUX_BASE_MISC:
+			addr = pctl->misc_membase + pin_regmap[pin].pcof_regoff;
+			break;
+		default:
+			RTK_PINCTRL_ERR("[%s] Unknow pmux_base\n", __func__);
+			return -EINVAL;
+	}
+
+	switch (param) {
+	case PIN_CONFIG_INPUT_SCHMITT:
+		break;
+	case PIN_CONFIG_INPUT_SCHMITT_ENABLE:
+		set_val = arg;
+		if (set_val)
+			set_val = 1;
+		else
+			set_val = 0;
+
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + pconf_schm);
+		writel(((val & ~mask)|
+			(set_val <<
+			(pin_regmap[pin].pcof_regbit + pconf_schm))),
+			addr);
+		break;
+	case PIN_CONFIG_DRIVE_STRENGTH:
+		strength = arg;
+		switch (pin_regmap[pin].pcof_cur_strgh) {
+		case PADDRI_4_8:
+			if (strength == 4)
+				set_val = 0;
+			else if (strength == 8)
+				set_val = 1;
+			else
+				return -EINVAL;
+			break;
+		case PADDRI_2_4:
+			if (strength == 2)
+				set_val = 0;
+			else if (strength == 4)
+				set_val = 1;
+			else
+				return -EINVAL;
+			break;
+		case PADDRI_UNSUPPORT:
+		default:
+			return -EINVAL;
+		}
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + pconf_curr);
+		writel(((val & ~mask)|
+			(set_val <<
+			(pin_regmap[pin].pcof_regbit + pconf_curr))),
+			addr);
+		break;
+	case PIN_CONFIG_DRIVE_PUSH_PULL:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + pconf_pulen);
+		writel(((val & ~mask)|
+			(1 << (pin_regmap[pin].pcof_regbit + pconf_pulen))),
+			addr);
+		break;
+	case PIN_CONFIG_BIAS_DISABLE:
+		val = readl(addr);
+		mask = 1 << (pin_regmap[pin].pcof_regbit + pconf_pulen);
+		writel(((val & ~mask)|
+			(0 << (pin_regmap[pin].pcof_regbit + pconf_pulen))),
+			addr);
+		break;
+	case PIN_CONFIG_BIAS_PULL_UP:
+		if (pin == 52) {
+			val = readl(addr - 0x4);
+			mask =	1 << 31;
+			writel((val & ~mask)|
+				(1 << 31),
+				addr - 0x4);
+		} else if (pin == 61) {
+			val = readl(addr + 0x4);
+			mask = 1 << 0;
+			writel((val & ~mask)|
+				(1 << 0),
+				addr + 0x4);
+		} else {
+			val = readl(addr);
+			mask = 1 << (pin_regmap[pin].pcof_regbit + pconf_pulsel);
+			writel(((val & ~mask)|
+				(1 << (pin_regmap[pin].pcof_regbit + pconf_pulsel))),
+				addr);
+		}
+		break;
+	case PIN_CONFIG_BIAS_PULL_DOWN:
+		if (pin == 52) {
+			val = readl(addr - 0x4);
+			mask =	1 << 31;
+			writel((val & ~mask)|
+				(0 << 31),
+				addr - 0x4);
+		} else if (pin == 61) {
+			val = readl(addr + 0x4);
+			mask =	1 << 0;
+			writel((val & ~mask)|
+				(0 << 0),
+				addr + 0x4);
+		} else {
+			val = readl(addr);
+			mask =	1 << (pin_regmap[pin].pcof_regbit + pconf_pulsel);
+			writel(((val & ~mask)|
+				(0 << (pin_regmap[pin].pcof_regbit + pconf_pulsel))),
+				addr);
+		}
+		break;
+	default:
+		break;
+	}
+
+	return 0;
+}
+
+static int RTK_pconf_group_get(struct pinctrl_dev *pctldev,
+				 unsigned int group,
+				 unsigned long *config)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*config = pctl->groups[group].config;
+
+	return 0;
+}
+
+static int RTK_pconf_group_set(struct pinctrl_dev *pctldev,
+				 unsigned int group,
+				 unsigned long *configs,
+				 unsigned int num_configs)
+{
+	u32 i;
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = &pctl->groups[group];
+
+	RTK_PINCTRL_DBG("[%s] g->pin=%d, g->name =%s, num_configs = %u",
+				__func__, g->pin, g->name, num_configs);
+
+	if (pin_regmap[g->pin].pcof_regoff == PCOF_UNSUPPORT) {
+		RTK_PINCTRL_DBG(
+			"[%s] g->pin(%d) g->name(%s) not support pin config"
+			, __func__, g->pin, g->name);
+		g->config = configs[num_configs-1];
+		return 0;
+	}
+
+	for (i = 0; i < num_configs; i++) {
+		RTK_pconf_parse_conf(pctldev, g->pin,
+			pinconf_to_config_param(configs[i]),
+			pinconf_to_config_argument(configs[i]));
+
+		g->config = configs[i];
+	}
+
+	return 0;
+}
+
+static const struct pinconf_ops RTK_pconf_ops = {
+	.pin_config_group_get	= RTK_pconf_group_get,
+	.pin_config_group_set	= RTK_pconf_group_set,
+};
+
+static int RTK_pmx_get_funcs_cnt(struct pinctrl_dev *pctldev)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] pctl->nfunctions =%d",
+			__func__, pctl->nfunctions);
+	return pctl->nfunctions;
+}
+
+static const char *RTK_pmx_get_func_name(struct pinctrl_dev *pctldev,
+					   unsigned int function)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s] function[%d] = %s", __func__,
+			function, pctl->functions[function].name);
+	return pctl->functions[function].name;
+}
+
+static int RTK_pmx_get_func_groups(struct pinctrl_dev *pctldev,
+				     unsigned int function,
+				     const char * const **groups,
+				     unsigned int * const num_groups)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	*groups = pctl->functions[function].groups;
+	*num_groups = pctl->functions[function].ngroups;
+
+	return 0;
+}
+
+static int RTK_pmx_enable(struct pinctrl_dev *pctldev,
+			    unsigned int function,
+			    unsigned int group)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = pctl->groups + group;
+	struct RTK_pinctrl_function *func = pctl->functions + function;
+	struct RTK_desc_function *desc =
+		RTK_pinctrl_desc_find_function_by_name(pctl,
+							 g->name,
+							 func->name);
+	RTK_PINCTRL_DBG("[%s] g->name=%s, func->name=%s",
+				__func__, g->name, func->name);
+	if (!desc)
+		return -EINVAL;
+
+	RTK_pmx_set(pctldev, g->pin, desc->muxval);
+
+	return 0;
+}
+
+void gpio_pinctrl_control(struct gpio_chip *gc, int gpio,
+	int direction, int value)
+{
+	struct device_node *np = gc->of_node;
+	struct of_phandle_args pinspec;
+	struct pinctrl_dev *pctldev;
+	int ret, pin;
+
+	ret = of_parse_phandle_with_fixed_args(np, "gpio-ranges", 3,
+					0, &pinspec);
+	if (ret)
+		RTK_PINCTRL_ERR("Can't get pinspec");
+
+	pctldev = of_pinctrl_get(pinspec.np);
+	pin = gpio + pinspec.args[1];
+
+	if (direction) {
+		if (value == 0 || value == 1) {
+			RTK_pconf_parse_conf(pctldev, pin, PIN_CONFIG_BIAS_DISABLE, 0);
+		} else if (value == 2 || value == 3) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_UP, 0);
+		} else if (value == 4 || value == 5) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_DOWN, 0);
+		}
+	} else {
+		if (value == 1) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_UP, 0);
+		} else if (value == 0) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_DRIVE_PUSH_PULL, 0);
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_PULL_DOWN, 0);
+		} else if (value == 2) {
+			RTK_pconf_parse_conf(pctldev, pin,
+				PIN_CONFIG_BIAS_DISABLE, 0);
+		}
+	}
+}
+
+static int
+RTK_pmx_gpio_request_enable(struct pinctrl_dev *pctldev,
+				    struct pinctrl_gpio_range *range,
+				    unsigned int offset)
+{
+	struct RTK_pinctrl *pctl = pinctrl_dev_get_drvdata(pctldev);
+	struct RTK_pinctrl_group *g = pctl->groups + offset;
+	struct RTK_desc_function *desc;
+	const char *func;
+	int ret;
+
+	func = "gpio";
+	RTK_PINCTRL_DBG("[%s] gpio_offset=%u", __func__, offset);
+	desc = RTK_pinctrl_desc_find_function_by_name(pctl,
+							g->name,
+							func);
+	if (!desc) {
+		ret = -EINVAL;
+		RTK_PINCTRL_ERR(
+			"Set gpio pinmux fail, Pin(%s) offset=%u\n"
+			, g->name, offset);
+		goto error;
+	}
+
+	RTK_pmx_set(pctldev, offset, desc->muxval);
+
+	ret = 0;
+
+error:
+	return ret;
+}
+
+static void
+RTK_pmx_gpio_disable_free(struct pinctrl_dev *pctldev,
+				    struct pinctrl_gpio_range *range,
+				    unsigned int offset)
+{
+	RTK_PINCTRL_DBG("[%s]", __func__);
+/*TODO : need to add gpio related api*/
+}
+
+
+
+static const struct pinmux_ops RTK_pmx_ops = {
+	.get_functions_count = RTK_pmx_get_funcs_cnt,
+	.get_function_name = RTK_pmx_get_func_name,
+	.get_function_groups = RTK_pmx_get_func_groups,
+	.set_mux = RTK_pmx_enable,
+	.gpio_request_enable = RTK_pmx_gpio_request_enable,
+	.gpio_disable_free = RTK_pmx_gpio_disable_free,
+};
+
+static struct pinctrl_desc RTK_pctrl_desc = {
+	.confops	= &RTK_pconf_ops,
+	.pctlops	= &RTK_pctrl_ops,
+	.pmxops		= &RTK_pmx_ops,
+};
+
+
+static const struct of_device_id RTK_pinctrl_match[] = {
+	{ .compatible = "realtek,rtk16xx-pinctrl",
+		.data = (void *)&rtk16xx_pinctrl_data },
+	{ /* Sentinel */ },
+};
+MODULE_DEVICE_TABLE(of, RTK_pinctrl_match);
+
+static int RTK_pinctrl_add_function(struct RTK_pinctrl *pctl,
+					const char *name)
+{
+	struct RTK_pinctrl_function *func = pctl->functions;
+
+	while (func->name) {
+		/* function already there */
+		if (strcmp(func->name, name) == 0) {
+			func->ngroups++;
+			return -EEXIST;
+		}
+		func++;
+	}
+
+	func->name = name;
+	func->ngroups = 1;
+
+	pctl->nfunctions++;
+
+	return 0;
+}
+
+static int RTK_pinctrl_build_state(struct platform_device *pdev)
+{
+	struct RTK_pinctrl *pctl = platform_get_drvdata(pdev);
+	int i;
+
+	RTK_PINCTRL_DBG("[%s]", __func__);
+	pctl->ngroups = pctl->desc->npins;
+
+	/* Allocate groups */
+	pctl->groups = devm_kzalloc(&pdev->dev,
+				    pctl->ngroups * sizeof(*pctl->groups),
+				    GFP_KERNEL);
+	if (!pctl->groups)
+		return -ENOMEM;
+
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_pinctrl_group *group = pctl->groups + i;
+
+		group->name = pin->pin.name;
+		group->pin = pin->pin.number;
+	}
+
+	/*
+	 * We suppose that we won't have any more functions than pins,
+	 * we'll reallocate that later anyway
+	 */
+	pctl->functions = devm_kzalloc(&pdev->dev,
+				pctl->desc->npins * sizeof(*pctl->functions),
+				GFP_KERNEL);
+	if (!pctl->functions)
+		return -ENOMEM;
+
+	/* Count functions and their associated groups */
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_desc_function *func = pin->functions;
+
+		while (func->name) {
+			RTK_pinctrl_add_function(pctl, func->name);
+			func++;
+		}
+	}
+
+	pctl->functions = krealloc(pctl->functions,
+				pctl->nfunctions * sizeof(*pctl->functions),
+				GFP_KERNEL);
+
+	for (i = 0; i < pctl->desc->npins; i++) {
+		const struct RTK_desc_pin *pin = pctl->desc->pins + i;
+		struct RTK_desc_function *func = pin->functions;
+
+		while (func->name) {
+			struct RTK_pinctrl_function *func_item;
+			const char **func_grp;
+
+			func_item = RTK_pinctrl_find_function_by_name(pctl,
+								func->name);
+			if (!func_item)
+				return -EINVAL;
+
+			if (!func_item->groups) {
+				func_item->groups =
+					devm_kzalloc(&pdev->dev,
+						func_item->ngroups *
+						sizeof(*func_item->groups),
+						GFP_KERNEL);
+				if (!func_item->groups)
+					return -ENOMEM;
+			}
+
+			func_grp = func_item->groups;
+			while (*func_grp)
+				func_grp++;
+
+			*func_grp = pin->pin.name;
+			func++;
+		}
+	}
+
+	return 0;
+}
+
+static int RTK_pinctrl_probe(struct platform_device *pdev)
+{
+	struct device_node *node = pdev->dev.of_node;
+	const struct of_device_id *device;
+	struct pinctrl_pin_desc *pins;
+	struct RTK_pinctrl *pctl;
+	int i, ret;
+
+	RTK_PINCTRL_INF("driver init");
+
+	pctl = devm_kzalloc(&pdev->dev, sizeof(*pctl), GFP_KERNEL);
+	if (!pctl)
+		return -ENOMEM;
+	platform_set_drvdata(pdev, pctl);
+
+	pctl->iso_membase = of_iomap(node, 0);
+	if (!pctl->iso_membase) {
+		RTK_PINCTRL_ERR("of_iomap iso_membase fail");
+		return -ENOMEM;
+	}
+
+	RTK_PINCTRL_DBG("iso_membase(0x%p)", pctl->iso_membase);
+
+	pctl->misc_membase = of_iomap(node, 1);
+	if (!pctl->misc_membase) {
+		RTK_PINCTRL_ERR("of_iomap misc_membase fail");
+		return -ENOMEM;
+	}
+
+	RTK_PINCTRL_DBG("misc_membase(0x%p)", pctl->misc_membase);
+
+	device = of_match_device(RTK_pinctrl_match, &pdev->dev);
+	if (!device) {
+		RTK_PINCTRL_ERR("of_match_device fail");
+		return -ENODEV;
+	}
+
+	pctl->desc = (struct RTK_pinctrl_desc *)device->data;
+
+	ret = RTK_pinctrl_build_state(pdev);
+	if (ret) {
+		RTK_PINCTRL_ERR("RTK_pinctrl_build_state fail");
+		return ret;
+	}
+
+	pins = devm_kzalloc(&pdev->dev,
+			    pctl->desc->npins * sizeof(*pins),
+			    GFP_KERNEL);
+	if (!pins) {
+		RTK_PINCTRL_ERR("[%s]devm_kzalloc fail", __func__);
+		return -ENOMEM;
+	}
+
+	for (i = 0; i < pctl->desc->npins; i++)
+		pins[i] = pctl->desc->pins[i].pin;
+
+	RTK_pctrl_desc.name = dev_name(&pdev->dev);
+	RTK_pctrl_desc.owner = THIS_MODULE;
+	RTK_pctrl_desc.pins = pins;
+	RTK_pctrl_desc.npins = pctl->desc->npins;
+	pctl->dev = &pdev->dev;
+	pctl->pctl_dev = pinctrl_register(&RTK_pctrl_desc,
+					  &pdev->dev, pctl);
+	if (!pctl->pctl_dev) {
+		RTK_PINCTRL_ERR("register pinctrl driver fail");
+		return -EINVAL;
+	}
+
+	RTK_PINCTRL_INF("init done");
+
+	return 0;
+}
+
+int RTK_pinctrl_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct RTK_pinctrl *pctl;
+	void __iomem *addr;
+	unsigned int i;
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		RTK_PINCTRL_INF("skip %s under DomU", __func__);
+		return 0;
+	}
+#endif
+	RTK_PINCTRL_INF("Enter %s", __func__);
+
+	pctl = platform_get_drvdata(pdev);
+
+	pinctrl_reg_values = kcalloc(ARRAY_SIZE(pinmux_reg_list), sizeof(u32),
+				GFP_KERNEL);
+
+	for (i = 0; i < ARRAY_SIZE(pinmux_reg_list); i++) {
+		switch (pinmux_reg_list[i].reg_base) {
+		case PMUX_BASE_ISO:
+			addr = pctl->iso_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		case PMUX_BASE_MISC:
+			addr = pctl->misc_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		default:
+			RTK_PINCTRL_ERR("[%s] Unknow reg_base\n",
+					__func__);
+			return -EINVAL;
+		}
+		/*Store pinmux registers*/
+		pinctrl_reg_values[i] = readl(addr);
+	}
+
+	RTK_PINCTRL_INF("Exit %s", __func__);
+	return 0;
+}
+
+int RTK_pinctrl_resume(struct platform_device *pdev)
+{
+	struct RTK_pinctrl *pctl;
+	void __iomem *addr;
+	unsigned int i;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		RTK_PINCTRL_INF("skip %s under DomU", __func__);
+		return 0;
+	}
+#endif
+	RTK_PINCTRL_INF("Enter %s", __func__);
+
+	pctl = platform_get_drvdata(pdev);
+
+	for (i = 0; i < ARRAY_SIZE(pinmux_reg_list); i++) {
+		switch (pinmux_reg_list[i].reg_base) {
+		case PMUX_BASE_ISO:
+			addr = pctl->iso_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		case PMUX_BASE_MISC:
+			addr = pctl->misc_membase +
+				pinmux_reg_list[i].reg_offset;
+			break;
+		default:
+			RTK_PINCTRL_ERR("[%s] Unknow reg_base\n",
+					__func__);
+			return -EINVAL;
+		}
+		/*Restore pinmux registers*/
+		writel(pinctrl_reg_values[i], addr);
+	}
+
+	kfree(pinctrl_reg_values);
+
+	RTK_PINCTRL_INF("Exit %s", __func__);
+	return 0;
+}
+
+static struct platform_driver RTK_pinctrl_driver = {
+	.probe = RTK_pinctrl_probe,
+	.driver = {
+		.name = "rtk-pinctrl",
+		.owner = THIS_MODULE,
+		.of_match_table = RTK_pinctrl_match,
+	},
+	.suspend = RTK_pinctrl_suspend,
+	.resume = RTK_pinctrl_resume,
+};
+
+static int  rtk_pinctrl_init(void)
+{
+	return platform_driver_register(&RTK_pinctrl_driver);
+}
+postcore_initcall(rtk_pinctrl_init);
+
+MODULE_DESCRIPTION("RTK pinctrl driver");
+MODULE_LICENSE("GPL");
diff --git a/drivers/pinctrl/realtek/pinctrl-rtd16xx.h b/drivers/pinctrl/realtek/pinctrl-rtd16xx.h
new file mode 100644
index 00000000..b64ea8e
--- /dev/null
+++ b/drivers/pinctrl/realtek/pinctrl-rtd16xx.h
@@ -0,0 +1,896 @@
+/*
+ * Realtek pin controller driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#ifndef __PINCTRL_RTK16xx_H
+#define __PINCTRL_RTK16xx_H
+
+#include <linux/kernel.h>
+#include <linux/pinctrl/pinctrl.h>
+
+//#define RTK_PINCTRL_DEBUG
+#ifdef RTK_PINCTRL_DEBUG
+#define RTK_PINCTRL_DBG(fmt, ...) pr_info("[PINCTRL] " fmt "\n", ## __VA_ARGS__)
+#else
+#define RTK_PINCTRL_DBG(fmt, ...) do {} while (0)
+#endif
+
+#define RTK_PINCTRL_INF(fmt, ...) pr_info("[PINCTRL] " fmt "\n", ## __VA_ARGS__)
+#define RTK_PINCTRL_ERR(fmt, ...) pr_err("[PINCTRL Error] " fmt "\n", ## __VA_ARGS__)
+
+#define P_ISO_BASE			 0
+
+#define RTK_PCONF_SCHM		2
+#define RTK_PCONF_PULEN		0
+#define RTK_PCONF_PULSEL	1
+#define RTK_PCONF_CURR		-1
+
+
+/* ISO muxpad0*/
+#define RTK_PINCTRL_PIN_gpio_0				PINCTRL_PIN(P_ISO_BASE + 0, "gpio_0")
+#define RTK_PINCTRL_PIN_gpio_1				PINCTRL_PIN(P_ISO_BASE + 1, "gpio_1")
+#define RTK_PINCTRL_PIN_gpio_2				PINCTRL_PIN(P_ISO_BASE + 2, "gpio_2")
+#define RTK_PINCTRL_PIN_gpio_3				PINCTRL_PIN(P_ISO_BASE + 3, "gpio_3")
+#define RTK_PINCTRL_PIN_gpio_4				PINCTRL_PIN(P_ISO_BASE + 4, "gpio_4")
+#define RTK_PINCTRL_PIN_gpio_5				PINCTRL_PIN(P_ISO_BASE + 5, "gpio_5")
+#define RTK_PINCTRL_PIN_gpio_6				PINCTRL_PIN(P_ISO_BASE + 6, "gpio_6")
+#define RTK_PINCTRL_PIN_gpio_7				PINCTRL_PIN(P_ISO_BASE + 7, "gpio_7")
+#define RTK_PINCTRL_PIN_gpio_8				PINCTRL_PIN(P_ISO_BASE + 8, "gpio_8")
+#define RTK_PINCTRL_PIN_gpio_9				PINCTRL_PIN(P_ISO_BASE + 9, "gpio_9")
+#define RTK_PINCTRL_PIN_gpio_10				PINCTRL_PIN(P_ISO_BASE + 10, "gpio_10")
+#define RTK_PINCTRL_PIN_gpio_11				PINCTRL_PIN(P_ISO_BASE + 11, "gpio_11")
+#define RTK_PINCTRL_PIN_gpio_12				PINCTRL_PIN(P_ISO_BASE + 12, "gpio_12")
+#define RTK_PINCTRL_PIN_gpio_13				PINCTRL_PIN(P_ISO_BASE + 13, "gpio_13")
+#define RTK_PINCTRL_PIN_gpio_14				PINCTRL_PIN(P_ISO_BASE + 14, "gpio_14")
+#define RTK_PINCTRL_PIN_gpio_15				PINCTRL_PIN(P_ISO_BASE + 15, "gpio_15")
+#define RTK_PINCTRL_PIN_gpio_16				PINCTRL_PIN(P_ISO_BASE + 16, "gpio_16")
+#define RTK_PINCTRL_PIN_gpio_17				PINCTRL_PIN(P_ISO_BASE + 17, "gpio_17")
+
+/* ISO muxpad1*/
+#define RTK_PINCTRL_PIN_gpio_18				PINCTRL_PIN(P_ISO_BASE + 18, "gpio_18")
+#define RTK_PINCTRL_PIN_gpio_19				PINCTRL_PIN(P_ISO_BASE + 19, "gpio_19")
+#define RTK_PINCTRL_PIN_gpio_20				PINCTRL_PIN(P_ISO_BASE + 20, "gpio_20")
+#define RTK_PINCTRL_PIN_gpio_21				PINCTRL_PIN(P_ISO_BASE + 21, "gpio_21")
+#define RTK_PINCTRL_PIN_gpio_22				PINCTRL_PIN(P_ISO_BASE + 22, "gpio_22")
+#define RTK_PINCTRL_PIN_gpio_23				PINCTRL_PIN(P_ISO_BASE + 23, "gpio_23")
+#define RTK_PINCTRL_PIN_gpio_25				PINCTRL_PIN(P_ISO_BASE + 25, "gpio_25")
+#define RTK_PINCTRL_PIN_gpio_26				PINCTRL_PIN(P_ISO_BASE + 26, "gpio_26")
+#define RTK_PINCTRL_PIN_gpio_27				PINCTRL_PIN(P_ISO_BASE + 27, "gpio_27")
+#define RTK_PINCTRL_PIN_gpio_28				PINCTRL_PIN(P_ISO_BASE + 28, "gpio_28")
+#define RTK_PINCTRL_PIN_gpio_29				PINCTRL_PIN(P_ISO_BASE + 29, "gpio_29")
+#define RTK_PINCTRL_PIN_gpio_30				PINCTRL_PIN(P_ISO_BASE + 30, "gpio_30")
+#define RTK_PINCTRL_PIN_gpio_31				PINCTRL_PIN(P_ISO_BASE + 31, "gpio_31")
+#define RTK_PINCTRL_PIN_gpio_34				PINCTRL_PIN(P_ISO_BASE + 34, "gpio_34")
+#define RTK_PINCTRL_PIN_gpio_35				PINCTRL_PIN(P_ISO_BASE + 35, "gpio_35")
+
+
+/* ISO muxpad2*/
+#define RTK_PINCTRL_PIN_gpio_40				PINCTRL_PIN(P_ISO_BASE + 40, "gpio_40")
+#define RTK_PINCTRL_PIN_gpio_41				PINCTRL_PIN(P_ISO_BASE + 41, "gpio_41")
+#define RTK_PINCTRL_PIN_gpio_42				PINCTRL_PIN(P_ISO_BASE + 42, "gpio_42")
+#define RTK_PINCTRL_PIN_gpio_43				PINCTRL_PIN(P_ISO_BASE + 43, "gpio_43")
+#define RTK_PINCTRL_PIN_gpio_44				PINCTRL_PIN(P_ISO_BASE + 44, "gpio_44")
+#define RTK_PINCTRL_PIN_gpio_45				PINCTRL_PIN(P_ISO_BASE + 45, "gpio_45")
+#define RTK_PINCTRL_PIN_gpio_46				PINCTRL_PIN(P_ISO_BASE + 46, "gpio_46")
+#define RTK_PINCTRL_PIN_gpio_47				PINCTRL_PIN(P_ISO_BASE + 47, "gpio_47")
+#define RTK_PINCTRL_PIN_gpio_48				PINCTRL_PIN(P_ISO_BASE + 48, "gpio_48")
+#define RTK_PINCTRL_PIN_gpio_49				PINCTRL_PIN(P_ISO_BASE + 49, "gpio_49")
+#define RTK_PINCTRL_PIN_gpio_50				PINCTRL_PIN(P_ISO_BASE + 50, "gpio_50")
+#define RTK_PINCTRL_PIN_gpio_51				PINCTRL_PIN(P_ISO_BASE + 51, "gpio_51")
+
+/* ISO muxpad3*/
+#define RTK_PINCTRL_PIN_gpio_52				PINCTRL_PIN(P_ISO_BASE + 52, "gpio_52")
+#define RTK_PINCTRL_PIN_ir_rx				PINCTRL_PIN(P_ISO_BASE + 53, "ir_rx")
+#define RTK_PINCTRL_PIN_ur0_rx				PINCTRL_PIN(P_ISO_BASE + 54, "ur0_rx")
+#define RTK_PINCTRL_PIN_ur0_tx				PINCTRL_PIN(P_ISO_BASE + 55, "ur0_tx")
+#define RTK_PINCTRL_PIN_gpio_57				PINCTRL_PIN(P_ISO_BASE + 57, "gpio_57")
+#define RTK_PINCTRL_PIN_gpio_58				PINCTRL_PIN(P_ISO_BASE + 58, "gpio_58")
+#define RTK_PINCTRL_PIN_gpio_59				PINCTRL_PIN(P_ISO_BASE + 59, "gpio_59")
+#define RTK_PINCTRL_PIN_gpio_60				PINCTRL_PIN(P_ISO_BASE + 60, "gpio_60")
+#define RTK_PINCTRL_PIN_gpio_61				PINCTRL_PIN(P_ISO_BASE + 61, "gpio_61")
+#define RTK_PINCTRL_PIN_gpio_62				PINCTRL_PIN(P_ISO_BASE + 62, "gpio_62")
+#define RTK_PINCTRL_PIN_gpio_63				PINCTRL_PIN(P_ISO_BASE + 63, "gpio_63")
+#define RTK_PINCTRL_PIN_gpio_64				PINCTRL_PIN(P_ISO_BASE + 64, "gpio_64")
+#define RTK_PINCTRL_PIN_gpio_65				PINCTRL_PIN(P_ISO_BASE + 65, "gpio_65")
+#define RTK_PINCTRL_PIN_gpio_66				PINCTRL_PIN(P_ISO_BASE + 66, "gpio_66")
+#define RTK_PINCTRL_PIN_gpio_67				PINCTRL_PIN(P_ISO_BASE + 67, "gpio_67")
+#define RTK_PINCTRL_PIN_gpio_68				PINCTRL_PIN(P_ISO_BASE + 68, "gpio_68")
+#define RTK_PINCTRL_PIN_gpio_85				PINCTRL_PIN(P_ISO_BASE + 85, "gpio_85")
+
+/* ISO muxpad4*/
+#define RTK_PINCTRL_PIN_usb_cc1				PINCTRL_PIN(P_ISO_BASE + 56, "usb_cc1")
+#define RTK_PINCTRL_PIN_usb_cc2				PINCTRL_PIN(P_ISO_BASE + 69, "usb_cc2")
+
+
+/*ISO muxpad6*/
+#define RTK_PINCTRL_PIN_ur2_loc				PINCTRL_PIN(P_ISO_BASE + 86, "ur2_loc")
+#define RTK_PINCTRL_PIN_gspi_loc			PINCTRL_PIN(P_ISO_BASE + 87, "gspi_loc")
+#define RTK_PINCTRL_PIN_sdio_loc			PINCTRL_PIN(P_ISO_BASE + 88, "sdio_loc")
+#define RTK_PINCTRL_PIN_hi_loc				PINCTRL_PIN(P_ISO_BASE + 89, "hi_loc")
+#define RTK_PINCTRL_PIN_hi_width			PINCTRL_PIN(P_ISO_BASE + 90, "hi_width")
+#define RTK_PINCTRL_PIN_debug_p2s_enable		PINCTRL_PIN(P_ISO_BASE + 91, "debug_p2s_enable")
+#define RTK_PINCTRL_PIN_sf_en				PINCTRL_PIN(P_ISO_BASE + 92, "sf_en")
+#define RTK_PINCTRL_PIN_arm_trace_dbg_en		PINCTRL_PIN(P_ISO_BASE + 93, "arm_trace_dbg_en")
+#define RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc0	PINCTRL_PIN(P_ISO_BASE + 94, "pwm_01_open_drain_en_loc0")
+#define RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc0	PINCTRL_PIN(P_ISO_BASE + 95, "pwm_23_open_drain_en_loc0")
+#define RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc1	PINCTRL_PIN(P_ISO_BASE + 96, "pwm_01_open_drain_en_loc1")
+#define RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc1	PINCTRL_PIN(P_ISO_BASE + 97, "pwm_23_open_drain_en_loc1")
+#define RTK_PINCTRL_PIN_ejtag_avcpu_loc			PINCTRL_PIN(P_ISO_BASE + 98, "ejtag_avcpu_loc")
+#define RTK_PINCTRL_PIN_ejtag_scpu_loc			PINCTRL_PIN(P_ISO_BASE + 99, "ejtag_scpu_loc")
+#define RTK_PINCTRL_PIN_i2c_tg				PINCTRL_PIN(P_ISO_BASE + 100, "i2c_tg")
+#define RTK_PINCTRL_PIN_dmic_loc			PINCTRL_PIN(P_ISO_BASE + 101, "dmic_loc")
+
+/*MISC muxpad0*/
+#define RTK_PINCTRL_PIN_demod_agc			PINCTRL_PIN(P_ISO_BASE + 24, "demod_agc")
+#define RTK_PINCTRL_PIN_emmc_rst			PINCTRL_PIN(P_ISO_BASE + 102, "emmc_rst")
+#define RTK_PINCTRL_PIN_emmc_dd_sb			PINCTRL_PIN(P_ISO_BASE + 103, "emmc_dd_sb")
+#define RTK_PINCTRL_PIN_emmc_clk			PINCTRL_PIN(P_ISO_BASE + 104, "emmc_clk")
+#define RTK_PINCTRL_PIN_emmc_cmd			PINCTRL_PIN(P_ISO_BASE + 105, "emmc_cmd")
+#define RTK_PINCTRL_PIN_emmc_data_0			PINCTRL_PIN(P_ISO_BASE + 106, "emmc_data_0")
+#define RTK_PINCTRL_PIN_emmc_data_1			PINCTRL_PIN(P_ISO_BASE + 107, "emmc_data_1")
+#define RTK_PINCTRL_PIN_emmc_data_2			PINCTRL_PIN(P_ISO_BASE + 108, "emmc_data_2")
+#define RTK_PINCTRL_PIN_emmc_data_3			PINCTRL_PIN(P_ISO_BASE + 109, "emmc_data_3")
+#define RTK_PINCTRL_PIN_emmc_data_4			PINCTRL_PIN(P_ISO_BASE + 110, "emmc_data_4")
+#define RTK_PINCTRL_PIN_emmc_data_5			PINCTRL_PIN(P_ISO_BASE + 111, "emmc_data_5")
+#define RTK_PINCTRL_PIN_emmc_data_6			PINCTRL_PIN(P_ISO_BASE + 112, "emmc_data_6")
+#define RTK_PINCTRL_PIN_emmc_data_7			PINCTRL_PIN(P_ISO_BASE + 113, "emmc_data_7")
+#define RTK_PINCTRL_PIN_hif_data_0			PINCTRL_PIN(P_ISO_BASE + 81, "hif_data_0")
+#define RTK_PINCTRL_PIN_hif_rdy				PINCTRL_PIN(P_ISO_BASE + 82, "hif_rdy")
+#define RTK_PINCTRL_PIN_hif_clk				PINCTRL_PIN(P_ISO_BASE + 83, "hif_clk")
+
+/*MISC muxpad1*/
+#define RTK_PINCTRL_PIN_hif_en				PINCTRL_PIN(P_ISO_BASE + 84, "hif_en")
+#define RTK_PINCTRL_PIN_sd3_cmd				PINCTRL_PIN(P_ISO_BASE + 32, "sd3_cmd")
+#define RTK_PINCTRL_PIN_sd3_clk				PINCTRL_PIN(P_ISO_BASE + 33, "sd3_clk")
+#define RTK_PINCTRL_PIN_sd3_data_0			PINCTRL_PIN(P_ISO_BASE + 36, "sd3_data_0")
+#define RTK_PINCTRL_PIN_sd3_data_1			PINCTRL_PIN(P_ISO_BASE + 37, "sd3_data_1")
+#define RTK_PINCTRL_PIN_sd3_data_2			PINCTRL_PIN(P_ISO_BASE + 38, "sd3_data_2")
+#define RTK_PINCTRL_PIN_sd3_data_3			PINCTRL_PIN(P_ISO_BASE + 39, "sd3_data_3")
+#define RTK_PINCTRL_PIN_tp_sync				PINCTRL_PIN(P_ISO_BASE + 70, "tp_sync")
+#define RTK_PINCTRL_PIN_tp_valid			PINCTRL_PIN(P_ISO_BASE + 71, "tp_valid")
+#define RTK_PINCTRL_PIN_tp_clk				PINCTRL_PIN(P_ISO_BASE + 72, "tp_clk")
+#define RTK_PINCTRL_PIN_tp_data_0			PINCTRL_PIN(P_ISO_BASE + 73, "tp_data_0")
+
+
+/*MISC muxpad2*/
+#define RTK_PINCTRL_PIN_tp_data_1			PINCTRL_PIN(P_ISO_BASE + 74, "tp_data_1")
+#define RTK_PINCTRL_PIN_tp_data_2			PINCTRL_PIN(P_ISO_BASE + 75, "tp_data_2")
+#define RTK_PINCTRL_PIN_tp_data_3			PINCTRL_PIN(P_ISO_BASE + 76, "tp_data_3")
+#define RTK_PINCTRL_PIN_tp_data_4			PINCTRL_PIN(P_ISO_BASE + 77, "tp_data_4")
+#define RTK_PINCTRL_PIN_tp_data_5			PINCTRL_PIN(P_ISO_BASE + 78, "tp_data_5")
+#define RTK_PINCTRL_PIN_tp_data_6			PINCTRL_PIN(P_ISO_BASE + 79, "tp_data_6")
+#define RTK_PINCTRL_PIN_tp_data_7			PINCTRL_PIN(P_ISO_BASE + 80, "tp_data_7")
+
+
+
+enum PMUX_BASE_TYPE {
+	PMUX_BASE_ISO,
+	PMUX_BASE_MISC
+};
+
+struct rtk_pin_regmap {
+	u8 pmux_base;
+	u16 pmux_regoff;
+	u16 pmux_regbit;
+	u16 pmux_regbitmsk;
+	u16 pcof_regoff;
+	u16 pcof_regbit;
+	u16 pcof_cur_strgh;/*0 : 2&4mA   1:4&8mA*/
+};
+
+struct rtk_pinmux_reg {
+	u8 reg_base;
+	u16 reg_offset;
+};
+
+#define PADDRI_4_8 1
+#define PADDRI_2_4 0
+#define PADDRI_UNSUPPORT 0xFFFF
+
+#define PCOF_UNSUPPORT 0xFFFF
+#define PMUX_UNSUPPORT 0xFF
+
+static const struct rtk_pinmux_reg pinmux_reg_list[] = {
+	/*ISO muxpad*/
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x000},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x004},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x008},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x00c},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x010},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x048},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x04C},
+	/*ISO  pfunc*/
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x014},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x018},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x01C},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x020},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x024},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x028},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x02C},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x030},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x034},
+	{.reg_base = PMUX_BASE_ISO, .reg_offset = 0x038},
+	/*MISC muxpad*/
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x000},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x004},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x008},
+	/*MISC  pfunc*/
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x00C},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x010},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x014},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x018},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x01C},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x020},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x024},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x028},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x02C},
+	{.reg_base = PMUX_BASE_MISC, .reg_offset = 0x030},
+};
+
+static const struct rtk_pin_regmap pin_regmap[] = {
+	/*GPIO*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit =  0, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x014, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 0, "gpio_0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit =  1, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x014, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 1, "gpio_1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit =  2, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x014, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 2, "gpio_2")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit =  5, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x014, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 3, "gpio_3")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit =  8, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x014, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 4, "gpio_4")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 11, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x014, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 5, "gpio_5")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 14, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x014, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 6, "gpio_6")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 17, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x014, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 7, "gpio_7")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 18, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x018, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 8, "gpio_8")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 19, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x018, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 9, "gpio_9")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 20, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x018, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 10, "gpio_10")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 21, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x018, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 11, "gpio_11")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 22, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x018, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 12, "gpio_12")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 24, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x018, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 13, "gpio_13")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 26, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x018, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 14, "gpio_14")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 28, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x018, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 15, "gpio_15")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 30, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x01C, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 16, "gpio_16")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x000, .pmux_regbit = 31, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x01C, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 17, "gpio_17")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  0, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x01C, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 18, "gpio_18")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  1, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x01C, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 19, "gpio_19")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  2, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x01C, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 20, "gpio_20")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  4, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x01C, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 21, "gpio_21")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  6, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x01C, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 22, "gpio_22")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit =  8, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x01C, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 23, "gpio_23")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x000, .pmux_regbit =  0, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x00C, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 24, "demod_agc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 10, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x020, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 25, "gpio_25")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 13, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x020, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 26, "gpio_26")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 16, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x020, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 27, "gpio_27")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 19, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x020, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 28, "gpio_28")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 22, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x020, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 29, "gpio_29")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 25, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x020, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 30, "gpio_30")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 26, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x020, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 31, "gpio_31")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit =  3, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x00C, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 32, "sd3_cmd")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit =  6, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x00C, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 33, "sd3_clk")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 27, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x020, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 34, "gpio_34")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x004, .pmux_regbit = 29, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 35, "gpio_35")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit =  9, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x00C, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 36, "sd3_data_0")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit = 12, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x010, .pcof_regbit = 8, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 37, "sd3_data_1")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit = 15, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x010, .pcof_regbit = 20, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 38, "sd3_data_2")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit = 17, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x014, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 39, "sd3_data_3")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit =  0, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x024, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 40, "gpio_40")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit =  3, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x024, .pcof_regbit = 15, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 41, "gpio_41")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit =  6, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x024, .pcof_regbit = 26, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 42, "gpio_42")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit =  9, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x028, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 43, "gpio_43")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 12, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x028, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 44, "gpio_44")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 15, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x028, .pcof_regbit = 27, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 45, "gpio_45")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 18, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x02C, .pcof_regbit = 7, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 46, "gpio_46")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 21, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 11, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 47, "gpio_47")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 23, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x02C, .pcof_regbit = 15, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 48, "gpio_48")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 24, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x02C, .pcof_regbit = 19, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 49, "gpio_49")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 25, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 23, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 50, "gpio_50")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x008, .pmux_regbit = 27, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x02C, .pcof_regbit = 27, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 51, "gpio_51")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  0, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x030, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 52, "gpio_52")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  3, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x030, .pcof_regbit = 3, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 53, "ir_rx")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  5, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x030, .pcof_regbit = 7, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 54, "ur0_rx")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  6, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x030, .pcof_regbit = 11, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 55, "ur0_tx")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit =  0, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 56, "usb_cc1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit =  7, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x030, .pcof_regbit = 15, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 57, "gpio_57")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 10, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x030, .pcof_regbit = 19, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 58, "gpio_58")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 12, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x030, .pcof_regbit = 23, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 59, "gpio_59")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 15, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x030, .pcof_regbit = 27, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 60, "gpio_60")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 18, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x030, .pcof_regbit = 31, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 61, "gpio_61")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 21, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x034, .pcof_regbit = 3, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 62, "gpio_62")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 24, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x034, .pcof_regbit = 7, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 63, "gpio_63")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 25, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x034, .pcof_regbit = 11, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 64, "gpio_64")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 26, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x034, .pcof_regbit = 15, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 65, "gpio_65")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 28, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x034, .pcof_regbit = 19, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 66, "gpio_66")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 29, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x034, .pcof_regbit = 23, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 67, "gpio_67")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 30, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x034, .pcof_regbit = 27, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 68, "gpio_68")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x010, .pmux_regbit =  1, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 69, "usb_cc2")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit = 20, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x014, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 70, "tp_sync")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit = 23, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x014, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 71, "tp_valid")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit = 26, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x014, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 72, "tp_clk")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit = 29, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x014, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 73, "tp_data_0")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x008, .pmux_regbit =  0, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x014, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 74, "tp_data_1")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x008, .pmux_regbit =  3, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x018, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 75, "tp_data_2")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x008, .pmux_regbit =  6, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x018, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 76, "tp_data_3")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x008, .pmux_regbit =  9, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x018, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 77, "tp_data_4")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x008, .pmux_regbit = 12, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x018, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 78, "tp_data_5")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x008, .pmux_regbit = 15, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x018, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 79, "tp_data_6")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x008, .pmux_regbit = 18, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x018, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 80, "tp_data_7")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x000, .pmux_regbit = 25, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 81, "hif_data_0")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x000, .pmux_regbit = 27, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x02C, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 82, "hif_rdy")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x000, .pmux_regbit = 29, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x030, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 83, "hif_clk")*/
+	{.pmux_base = PMUX_BASE_MISC,.pmux_regoff = 0x004, .pmux_regbit =  0, .pmux_regbitmsk = 0x7,	.pcof_regoff = 0x030, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 84, "hif_en")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x00C, .pmux_regbit = 31, .pmux_regbitmsk = 0x1,	.pcof_regoff = 0x038, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_4_8}, /*(P_ISO_BASE + 85, "gpio_85")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit =  0, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 86, "ur2_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit =  2, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 87, "gspi_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit =  4, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 88, "sdio_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit =  6, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 89, "hi_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit =  8, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 90, "hi_width")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 10, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 91, "debug_p2s_enable")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 11, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 92, "sf_en")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 12, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 93, "arm_trace_dbg_en")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 13, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 94, "pwm_01_open_drain_en_loc0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 14, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 95, "pwm_23_open_drain_en_loc0")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 15, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 96, "pwm_01_open_drain_en_loc1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 16, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 97, "pwm_23_open_drain_en_loc1")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 17, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 98, "ejtag_avcpu_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 21, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 99, "ejtag_scpu_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 23, .pmux_regbitmsk = 0x1,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 100, "ejtag_scpu_loc")*/
+	{.pmux_base = PMUX_BASE_ISO, .pmux_regoff = 0x048, .pmux_regbit = 24, .pmux_regbitmsk = 0x3,	.pcof_regoff = PCOF_UNSUPPORT, .pcof_regbit = 0, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 101, "i2c_tg")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit =  1, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x018, .pcof_regbit = 24, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 102, "emmc_rst")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit =  3, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x01C, .pcof_regbit = 4, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 103, "emmc_dd_sb")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit =  5, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x01C, .pcof_regbit = 16, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 104, "emmc_clk")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit =  7, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x01C, .pcof_regbit = 28, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 105, "emmc_cmd")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit =  9, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x020, .pcof_regbit = 9, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 106, "emmc_data_0")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit = 11, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x020, .pcof_regbit = 21, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 107, "emmc_data_1")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit = 13, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 1, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 108, "emmc_data_2")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit = 15, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 13, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 109, "emmc_data_3")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit = 17, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x024, .pcof_regbit = 25, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 110, "emmc_data_4")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit = 19, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit = 5, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 111, "emmc_data_5")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit = 21, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit = 17, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 112, "emmc_data_6")*/
+	{.pmux_base = PMUX_BASE_MISC, .pmux_regoff = 0x000, .pmux_regbit = 23, .pmux_regbitmsk = 0x3,	.pcof_regoff = 0x028, .pcof_regbit = 29, .pcof_cur_strgh = PADDRI_UNSUPPORT}, /*(P_ISO_BASE + 113, "emmc_data_7")*/
+};
+
+
+struct RTK_desc_function {
+	const char	*name;
+	u8		muxval;
+};
+
+struct RTK_desc_pin {
+	struct pinctrl_pin_desc		pin;
+	struct RTK_desc_function	*functions;
+};
+
+struct RTK_pinctrl_desc {
+	const struct RTK_desc_pin	*pins;
+	int				npins;
+	struct pinctrl_gpio_range	*ranges;
+	int				nranges;
+};
+
+struct RTK_pinctrl_function {
+	const char	*name;
+	const char	**groups;
+	unsigned int	ngroups;
+};
+
+struct RTK_pinctrl_group {
+	const char	*name;
+	unsigned long	config;
+	unsigned int	pin;
+};
+
+struct RTK_pinctrl {
+/*
+ *	void __iomem			*sb2_membase;
+ *	void __iomem			*disp_membase;
+ *	void __iomem			*cr_membase;
+ *	void __iomem			*iso_membase;
+ *	struct gpio_chip		*chip;
+ */
+	void __iomem			*iso_membase;
+	void __iomem			*misc_membase;
+	struct RTK_pinctrl_desc	*desc;
+	struct device			*dev;
+	struct RTK_pinctrl_function	*functions;
+	unsigned int			nfunctions;
+	struct RTK_pinctrl_group	*groups;
+	unsigned int			ngroups;
+	struct pinctrl_dev		*pctl_dev;
+};
+
+#define RTK_PIN(_pin, ...)					\
+	{							\
+		.pin = _pin,					\
+		.functions = (struct RTK_desc_function[]){	\
+			__VA_ARGS__, { } },			\
+	}
+
+#define RTK_FUNCTION(_val, _name)				\
+	{							\
+		.name = _name,					\
+		.muxval = _val,					\
+	}
+
+
+static const struct RTK_desc_pin rtk_pins[] = {
+	/*GPIO*/
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_0,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_1,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_2,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "standby_dbg"),
+		RTK_FUNCTION(0x3, "gspi_loc0"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "lx_ejtag_loc0"),
+		RTK_FUNCTION(0x7, "vfd")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_3,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "standby_dbg"),
+		RTK_FUNCTION(0x3, "gspi_loc0"),
+		RTK_FUNCTION(0x4, "scan_debug"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "lx_ejtag_loc0"),
+		RTK_FUNCTION(0x7, "vfd")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_4,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x3, "gspi_loc0"),
+		RTK_FUNCTION(0x4, "scan_debug"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "lx_ejtag_loc0"),
+		RTK_FUNCTION(0x7, "vfd")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_5,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "i2c5"),
+		RTK_FUNCTION(0x3, "gspi_loc0"),
+		RTK_FUNCTION(0x4, "scan_debug"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "lx_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_6,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "i2c5"),
+		RTK_FUNCTION(0x4, "scan_debug"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x6, "lx_ejtag_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_7,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_8,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_9,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_10,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_11,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_12,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c0"),
+		RTK_FUNCTION(0x2, "pwm0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_13,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c0"),
+		RTK_FUNCTION(0x2, "pwm1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_14,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "etn_led"),
+		RTK_FUNCTION(0x2, "pwm2")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_15,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "etn_led"),
+		RTK_FUNCTION(0x2, "pwm3")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_16,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_17,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_18,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c2")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_19,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "i2c2")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_20,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "pwm0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_21,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "spdif"),
+		RTK_FUNCTION(0x2, "pwm1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_22,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "pwm2")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_23,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "pwm3")),
+	RTK_PIN(RTK_PINCTRL_PIN_demod_agc,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio24*/
+		RTK_FUNCTION(0x1, "qam_agc_if")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_25,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc1"),
+		RTK_FUNCTION(0x2, "rtc_dig"),
+		RTK_FUNCTION(0x3, "gspi_loc1"),
+		RTK_FUNCTION(0x4, "rtc_ana"),
+		RTK_FUNCTION(0x5, "spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_26,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc1"),
+		RTK_FUNCTION(0x3, "gspi_loc1"),
+		RTK_FUNCTION(0x5, "spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_27,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc1"),
+		RTK_FUNCTION(0x3, "gspi_loc1"),
+		RTK_FUNCTION(0x5, "spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_28,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "uart2_loc1"),
+		RTK_FUNCTION(0x3, "gspi_loc1"),
+		RTK_FUNCTION(0x5, "spi")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_29,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "gphy"),
+		RTK_FUNCTION(0x4, "extphy")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_30,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_31,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_sd3_cmd,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio32*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x4, "sc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "lx_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_sd3_clk,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio33*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x4, "sc1"),
+		RTK_FUNCTION(0x5, "scpu_main2"),
+		RTK_FUNCTION(0x6, "lx_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_34,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "i2c3")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_35,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "i2c3")),
+	RTK_PIN(RTK_PINCTRL_PIN_sd3_data_0,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio36*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x4, "sc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "lx_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_sd3_data_1,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio37*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x4, "sc1"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "lx_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_sd3_data_2,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio38*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_sd3_data_3,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio39*/
+		RTK_FUNCTION(0x1, "sd"),
+		RTK_FUNCTION(0x2, "sdio_loc0"),
+		RTK_FUNCTION(0x5, "scpu_ejtag_loc1"),
+		RTK_FUNCTION(0x6, "lx_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_40,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "tdm_ai_loc1"),
+		RTK_FUNCTION(0x5, "ai_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_41,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "tdm_ai_loc1"),
+		RTK_FUNCTION(0x5, "ai_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_42,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "tdm_ai_loc1"),
+		RTK_FUNCTION(0x5, "ai_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_43,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x4, "tdm_ai_loc1"),
+		RTK_FUNCTION(0x5, "ai_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_44,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x5, "ai_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_45,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x2, "sdio_loc1"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x5, "ai_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_46,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pcie0"),
+		RTK_FUNCTION(0x3, "gphy"),
+		RTK_FUNCTION(0x4, "extphy")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_47,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "ir_tx"),
+		RTK_FUNCTION(0x2, "dc_fan_sensor")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_48,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_49,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_50,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "spdif"),
+		RTK_FUNCTION(0x2, "test_loop_dis")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_51,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test_loc0"),
+		RTK_FUNCTION(0x2, "debug_p2s"),
+		RTK_FUNCTION(0x3, "etn_led"),
+		RTK_FUNCTION(0x4, "scan_debug")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_52,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pll_test_loc0"),
+		RTK_FUNCTION(0x2, "debug_p2s"),
+		RTK_FUNCTION(0x4, "scan_debug")),
+	RTK_PIN(RTK_PINCTRL_PIN_ir_rx,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio53*/
+		RTK_FUNCTION(0x1, "ir_rx"),
+		RTK_FUNCTION(0x2, "standby_dbg")),
+	RTK_PIN(RTK_PINCTRL_PIN_ur0_rx,
+		RTK_FUNCTION(0x0, "gpio"),  /*gpio54*/
+		RTK_FUNCTION(0x1, "uart0")),
+	RTK_PIN(RTK_PINCTRL_PIN_ur0_tx,
+		RTK_FUNCTION(0x0, "gpio"),  /*gpio55*/
+		RTK_FUNCTION(0x1, "uart0")),
+	RTK_PIN(RTK_PINCTRL_PIN_usb_cc1,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "usb_cc1")), /*gpio56*/
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_57,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "dmic_loc1"),
+		RTK_FUNCTION(0x5, "ai_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_58,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "dmic_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_59,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "dmic_loc0"),
+		RTK_FUNCTION(0x4, "sc0"),
+		RTK_FUNCTION(0x5, "ai_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_60,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "dmic_loc0"),
+		RTK_FUNCTION(0x4, "sc0"),
+		RTK_FUNCTION(0x5, "ai_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_61,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "dmic_loc0"),
+		RTK_FUNCTION(0x4, "sc0"),
+		RTK_FUNCTION(0x5, "ai_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_62,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x3, "dmic_loc0"),
+		RTK_FUNCTION(0x4, "sc0"),
+		RTK_FUNCTION(0x5, "ai_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_63,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_64,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_65,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pcie1"),
+		RTK_FUNCTION(0x2, "hdd_pwr")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_66,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "pcie1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_67,
+		RTK_FUNCTION(0x0, "gpio")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_68,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "spdif")),
+	RTK_PIN(RTK_PINCTRL_PIN_usb_cc2,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio69*/
+		RTK_FUNCTION(0x1, "usb_cc2")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_sync,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio70*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x2, "tdm_ai_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc0"),
+		RTK_FUNCTION(0x5, "ai_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_valid,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio71*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x2, "tdm_ai_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc0"),
+		RTK_FUNCTION(0x4, "scan_debug"),
+		RTK_FUNCTION(0x5, "ai_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_clk,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio72*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x2, "tdm_ai_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc0"),
+		RTK_FUNCTION(0x5, "ai_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_data_0,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio73*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x2, "tdm_ai_loc0"),
+		RTK_FUNCTION(0x3, "dmic_loc0")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_data_1,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio74*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x2, "tp1"),
+		RTK_FUNCTION(0x5, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_data_2,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio75*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x2, "tp1"),
+		RTK_FUNCTION(0x5, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_data_3,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio76*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x2, "tp1"),
+		RTK_FUNCTION(0x5, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_data_4,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio77*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x2, "tp1"),
+		RTK_FUNCTION(0x5, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_data_5,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio78*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x5, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_data_6,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio79*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x5, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_tp_data_7,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio80*/
+		RTK_FUNCTION(0x1, "tp0"),
+		RTK_FUNCTION(0x5, "ao")),
+	RTK_PIN(RTK_PINCTRL_PIN_hif_data_0,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio81*/
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "hi")),
+	RTK_PIN(RTK_PINCTRL_PIN_hif_rdy,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio82*/
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "hi")),
+	RTK_PIN(RTK_PINCTRL_PIN_hif_clk,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio83*/
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "hi"),
+		RTK_FUNCTION(0x3, "i2c4")),
+	RTK_PIN(RTK_PINCTRL_PIN_hif_en,
+		RTK_FUNCTION(0x0, "gpio"),/*gpio84*/
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "hi"),
+		RTK_FUNCTION(0x3, "i2c4"),
+		RTK_FUNCTION(0x4, "edp")),
+	RTK_PIN(RTK_PINCTRL_PIN_gpio_85,
+		RTK_FUNCTION(0x0, "gpio"),
+		RTK_FUNCTION(0x1, "spdif")),
+
+	/*OTHERS*/
+	RTK_PIN(RTK_PINCTRL_PIN_ur2_loc,
+		RTK_FUNCTION(0x0, "uart2_disable"),
+		RTK_FUNCTION(0x1, "uart2_loc0"),
+		RTK_FUNCTION(0x2, "uart2_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_gspi_loc,
+		RTK_FUNCTION(0x0, "gspi_disable"),
+		RTK_FUNCTION(0x1, "gspi_loc0"),
+		RTK_FUNCTION(0x2, "gspi_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_sdio_loc,
+		RTK_FUNCTION(0x0, "sdio_disable"),
+		RTK_FUNCTION(0x1, "sdio_loc0"),
+		RTK_FUNCTION(0x2, "sdio_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_hi_loc,
+		RTK_FUNCTION(0x0, "hi_loc_disable"),
+		RTK_FUNCTION(0x1, "hi_loc0"),
+		RTK_FUNCTION(0x2, "hi_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_hi_width,
+		RTK_FUNCTION(0x0, "hi_width_disable"),
+		RTK_FUNCTION(0x1, "hi_width_1bit"),
+		RTK_FUNCTION(0x2, "hi_width_8bit"),
+		RTK_FUNCTION(0x3, "hi_width_16bit")),
+	RTK_PIN(RTK_PINCTRL_PIN_debug_p2s_enable,
+		RTK_FUNCTION(0x0, "p2s_disable"),
+		RTK_FUNCTION(0x1, "debug_p2s")),
+	RTK_PIN(RTK_PINCTRL_PIN_sf_en,
+		RTK_FUNCTION(0x0, "sf_disable"),
+		RTK_FUNCTION(0x1, "sf_enable")),
+	RTK_PIN(RTK_PINCTRL_PIN_arm_trace_dbg_en,
+		RTK_FUNCTION(0x0, "arm_trace_debug_disable"),
+		RTK_FUNCTION(0x1, "arm_trace_debug_enable")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc0,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc0,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_01_open_drain_en_loc1,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_pwm_23_open_drain_en_loc1,
+		RTK_FUNCTION(0x0, "pwm_normal"),
+		RTK_FUNCTION(0x1, "pwm_open_drain")),
+	RTK_PIN(RTK_PINCTRL_PIN_ejtag_avcpu_loc,
+		RTK_FUNCTION(0x0, "lx_ejtag_disable"),
+		RTK_FUNCTION(0x1, "lx_ejtag_loc0"),
+		RTK_FUNCTION(0x2, "lx_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_ejtag_scpu_loc,
+		RTK_FUNCTION(0x0, "scpu_ejtag_disable"),
+		RTK_FUNCTION(0x1, "scpu_ejtag_loc0"),
+		RTK_FUNCTION(0x2, "scpu_ejtag_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_i2c_tg,
+		RTK_FUNCTION(0x1, "i2c_tg_disable"),
+		RTK_FUNCTION(0x2, "i2c_tg_enable")),
+	RTK_PIN(RTK_PINCTRL_PIN_dmic_loc,
+		RTK_FUNCTION(0x1, "dmic_loc0"),
+		RTK_FUNCTION(0x2, "dmic_loc1")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_rst,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_dd_sb,
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_clk,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_cmd,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_0,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_1,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_2,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_3,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_4,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_5,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_6,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+	RTK_PIN(RTK_PINCTRL_PIN_emmc_data_7,
+		RTK_FUNCTION(0x1, "nf"),
+		RTK_FUNCTION(0x2, "emmc")),
+
+};
+
+void gpio_pinctrl_control(struct gpio_chip *gc, int gpio, int direction, int value);
+
+#endif /* __PINCTRL_RTK16xx_H */
diff --git a/drivers/platform/goldfish/Makefile b/drivers/platform/goldfish/Makefile
index d348712..277a820 100644
--- a/drivers/platform/goldfish/Makefile
+++ b/drivers/platform/goldfish/Makefile
@@ -2,4 +2,5 @@
 # Makefile for Goldfish platform specific drivers
 #
 obj-$(CONFIG_GOLDFISH_BUS)	+= pdev_bus.o
-obj-$(CONFIG_GOLDFISH_PIPE)	+= goldfish_pipe.o
+obj-$(CONFIG_GOLDFISH_PIPE)	+= goldfish_pipe_all.o
+goldfish_pipe_all-objs := goldfish_pipe.o goldfish_pipe_v2.o
diff --git a/drivers/platform/goldfish/goldfish_pipe.c b/drivers/platform/goldfish/goldfish_pipe.c
index 1aba2c7..91e0a56 100644
--- a/drivers/platform/goldfish/goldfish_pipe.c
+++ b/drivers/platform/goldfish/goldfish_pipe.c
@@ -15,52 +15,11 @@
  *
  */
 
-/* This source file contains the implementation of a special device driver
- * that intends to provide a *very* fast communication channel between the
- * guest system and the QEMU emulator.
- *
- * Usage from the guest is simply the following (error handling simplified):
- *
- *    int  fd = open("/dev/qemu_pipe",O_RDWR);
- *    .... write() or read() through the pipe.
- *
- * This driver doesn't deal with the exact protocol used during the session.
- * It is intended to be as simple as something like:
- *
- *    // do this _just_ after opening the fd to connect to a specific
- *    // emulator service.
- *    const char*  msg = "<pipename>";
- *    if (write(fd, msg, strlen(msg)+1) < 0) {
- *       ... could not connect to <pipename> service
- *       close(fd);
- *    }
- *
- *    // after this, simply read() and write() to communicate with the
- *    // service. Exact protocol details left as an exercise to the reader.
- *
- * This driver is very fast because it doesn't copy any data through
- * intermediate buffers, since the emulator is capable of translating
- * guest user addresses into host ones.
- *
- * Note that we must however ensure that each user page involved in the
- * exchange is properly mapped during a transfer.
+/* This source file contains the implementation of the legacy version of
+ * a goldfish pipe device driver. See goldfish_pipe_v2.c for the current
+ * version.
  */
-
-#include <linux/module.h>
-#include <linux/interrupt.h>
-#include <linux/kernel.h>
-#include <linux/spinlock.h>
-#include <linux/miscdevice.h>
-#include <linux/platform_device.h>
-#include <linux/poll.h>
-#include <linux/sched.h>
-#include <linux/bitops.h>
-#include <linux/slab.h>
-#include <linux/io.h>
-#include <linux/goldfish.h>
-#include <linux/dma-mapping.h>
-#include <linux/mm.h>
-#include <linux/acpi.h>
+#include "goldfish_pipe.h"
 
 /*
  * IMPORTANT: The following constants must match the ones used and defined
@@ -110,29 +69,15 @@
 #define PIPE_WAKE_READ         (1 << 1)  /* pipe can now be read from */
 #define PIPE_WAKE_WRITE        (1 << 2)  /* pipe can now be written to */
 
-struct access_params {
-	unsigned long channel;
-	u32 size;
-	unsigned long address;
-	u32 cmd;
-	u32 result;
-	/* reserved for future extension */
-	u32 flags;
-};
+#define MAX_PAGES_TO_GRAB 32
 
-/* The global driver data. Holds a reference to the i/o page used to
- * communicate with the emulator, and a wake queue for blocked tasks
- * waiting to be awoken.
- */
-struct goldfish_pipe_dev {
-	spinlock_t lock;
-	unsigned char __iomem *base;
-	struct access_params *aps;
-	int irq;
-	u32 version;
-};
+#define DEBUG 0
 
-static struct goldfish_pipe_dev   pipe_dev[1];
+#if DEBUG
+#define DPRINT(...) { printk(KERN_ERR __VA_ARGS__); }
+#else
+#define DPRINT(...)
+#endif
 
 /* This data type models a given pipe instance */
 struct goldfish_pipe {
@@ -142,6 +87,15 @@ struct goldfish_pipe {
 	wait_queue_head_t wake_queue;
 };
 
+struct access_params {
+	unsigned long channel;
+	u32 size;
+	unsigned long address;
+	u32 cmd;
+	u32 result;
+	/* reserved for future extension */
+	u32 flags;
+};
 
 /* Bit flags for the 'flags' field */
 enum {
@@ -231,8 +185,10 @@ static int setup_access_params_addr(struct platform_device *pdev,
 	if (valid_batchbuffer_addr(dev, aps)) {
 		dev->aps = aps;
 		return 0;
-	} else
+	} else {
+		devm_kfree(&pdev->dev, aps);
 		return -1;
+	}
 }
 
 /* A value that will not be set by qemu emulator */
@@ -269,6 +225,7 @@ static ssize_t goldfish_pipe_read_write(struct file *filp, char __user *buffer,
 	struct goldfish_pipe *pipe = filp->private_data;
 	struct goldfish_pipe_dev *dev = pipe->dev;
 	unsigned long address, address_end;
+	struct page* pages[MAX_PAGES_TO_GRAB] = {};
 	int count = 0, ret = -EINVAL;
 
 	/* If the emulator already closed the pipe, no need to go further */
@@ -293,45 +250,61 @@ static ssize_t goldfish_pipe_read_write(struct file *filp, char __user *buffer,
 
 	while (address < address_end) {
 		unsigned long page_end = (address & PAGE_MASK) + PAGE_SIZE;
-		unsigned long next     = page_end < address_end ? page_end
-								: address_end;
-		unsigned long avail    = next - address;
-		int status, wakeBit;
-		struct page *page;
-
-		/* Either vaddr or paddr depending on the device version */
-		unsigned long xaddr;
+		unsigned long next, avail;
+		int status, wakeBit, page_i, num_contiguous_pages;
+		long first_page, last_page, requested_pages;
+		unsigned long xaddr, xaddr_prev, xaddr_i;
 
 		/*
-		 * We grab the pages on a page-by-page basis in case user
-		 * space gives us a potentially huge buffer but the read only
-		 * returns a small amount, then there's no need to pin that
-		 * much memory to the process.
+		 * Attempt to grab multiple physically contiguous pages.
 		 */
-		down_read(&current->mm->mmap_sem);
-		ret = get_user_pages(address, 1, is_write ? 0 : FOLL_WRITE,
-				&page, NULL);
-		up_read(&current->mm->mmap_sem);
-		if (ret < 0)
-			break;
+		first_page = address & PAGE_MASK;
+		last_page = (address_end - 1) & PAGE_MASK;
+		requested_pages = ((last_page - first_page) >> PAGE_SHIFT) + 1;
+		if (requested_pages > MAX_PAGES_TO_GRAB) {
+			requested_pages = MAX_PAGES_TO_GRAB;
+		}
+		ret = get_user_pages_fast(first_page, requested_pages,
+				!is_write, pages);
+
+		DPRINT("%s: requested pages: %d %d %p\n", __FUNCTION__,
+			ret, requested_pages, first_page);
+		if (ret == 0) {
+			DPRINT("%s: error: (requested pages == 0) (wanted %d)\n",
+					__FUNCTION__, requested_pages);
+			mutex_unlock(&pipe->lock);
+			return ret;
+		}
+		if (ret < 0) {
+			DPRINT("%s: (requested pages < 0) %d \n",
+					__FUNCTION__, requested_pages);
+			mutex_unlock(&pipe->lock);
+			return ret;
+		}
 
-		if (dev->version) {
-			/* Device version 1 or newer (qemu-android) expects the
-			 * physical address.
-			 */
-			xaddr = page_to_phys(page) | (address & ~PAGE_MASK);
-		} else {
-			/* Device version 0 (classic emulator) expects the
-			 * virtual address.
-			 */
-			xaddr = address;
+		xaddr = page_to_phys(pages[0]) | (address & ~PAGE_MASK);
+		xaddr_prev = xaddr;
+		num_contiguous_pages = ret == 0 ? 0 : 1;
+		for (page_i = 1; page_i < ret; page_i++) {
+			xaddr_i = page_to_phys(pages[page_i]) | (address & ~PAGE_MASK);
+			if (xaddr_i == xaddr_prev + PAGE_SIZE) {
+				page_end += PAGE_SIZE;
+				xaddr_prev = xaddr_i;
+				num_contiguous_pages++;
+			} else {
+				DPRINT("%s: discontinuous page boundary: %d pages instead\n",
+						__FUNCTION__, page_i);
+				break;
+			}
 		}
+		next = page_end < address_end ? page_end : address_end;
+		avail = next - address;
 
 		/* Now, try to transfer the bytes in the current page */
 		spin_lock_irqsave(&dev->lock, irq_flags);
 		if (access_with_param(dev,
-				is_write ? CMD_WRITE_BUFFER : CMD_READ_BUFFER,
-				xaddr, avail, pipe, &status)) {
+					is_write ? CMD_WRITE_BUFFER : CMD_READ_BUFFER,
+					xaddr, avail, pipe, &status)) {
 			gf_write_ptr(pipe, dev->base + PIPE_REG_CHANNEL,
 				     dev->base + PIPE_REG_CHANNEL_HIGH);
 			writel(avail, dev->base + PIPE_REG_SIZE);
@@ -344,9 +317,13 @@ static ssize_t goldfish_pipe_read_write(struct file *filp, char __user *buffer,
 		}
 		spin_unlock_irqrestore(&dev->lock, irq_flags);
 
-		if (status > 0 && !is_write)
-			set_page_dirty(page);
-		put_page(page);
+		for (page_i = 0; page_i < ret; page_i++) {
+			if (status > 0 && !is_write &&
+				page_i < num_contiguous_pages) {
+				set_page_dirty(pages[page_i]);
+			}
+			put_page(pages[page_i]);
+		}
 
 		if (status > 0) { /* Correct transfer */
 			count += status;
@@ -368,7 +345,7 @@ static ssize_t goldfish_pipe_read_write(struct file *filp, char __user *buffer,
 			 */
 			if (status != PIPE_ERROR_AGAIN)
 				pr_info_ratelimited("goldfish_pipe: backend returned error %d on %s\n",
-					status, is_write ? "write" : "read");
+						status, is_write ? "write" : "read");
 			ret = 0;
 			break;
 		}
@@ -378,7 +355,7 @@ static ssize_t goldfish_pipe_read_write(struct file *filp, char __user *buffer,
 		 * non-blocking mode, just return the error code.
 		 */
 		if (status != PIPE_ERROR_AGAIN ||
-			(filp->f_flags & O_NONBLOCK) != 0) {
+				(filp->f_flags & O_NONBLOCK) != 0) {
 			ret = goldfish_pipe_error_convert(status);
 			break;
 		}
@@ -392,7 +369,7 @@ static ssize_t goldfish_pipe_read_write(struct file *filp, char __user *buffer,
 
 		/* Tell the emulator we're going to wait for a wake event */
 		goldfish_cmd(pipe,
-			is_write ? CMD_WAKE_ON_WRITE : CMD_WAKE_ON_READ);
+				is_write ? CMD_WAKE_ON_WRITE : CMD_WAKE_ON_READ);
 
 		/* Unlock the pipe, then wait for the wake signal */
 		mutex_unlock(&pipe->lock);
@@ -538,6 +515,8 @@ static int goldfish_pipe_open(struct inode *inode, struct file *file)
 
 	pipe->dev = dev;
 	mutex_init(&pipe->lock);
+	DPRINT("%s: call. pipe_dev pipe_dev=0x%lx new_pipe_addr=0x%lx file=0x%lx\n", __FUNCTION__, pipe_dev, pipe, file);
+	// spin lock init, write head of list, i guess
 	init_waitqueue_head(&pipe->wake_queue);
 
 	/*
@@ -560,6 +539,7 @@ static int goldfish_pipe_release(struct inode *inode, struct file *filp)
 {
 	struct goldfish_pipe *pipe = filp->private_data;
 
+	DPRINT("%s: call. pipe=0x%lx file=0x%lx\n", __FUNCTION__, pipe, filp);
 	/* The guest is closing the channel, so tell the emulator right now */
 	goldfish_cmd(pipe, CMD_CLOSE);
 	kfree(pipe);
@@ -576,98 +556,33 @@ static int goldfish_pipe_release(struct inode *inode, struct file *filp)
 	.release = goldfish_pipe_release,
 };
 
-static struct miscdevice goldfish_pipe_device = {
+static struct miscdevice goldfish_pipe_dev = {
 	.minor = MISC_DYNAMIC_MINOR,
 	.name = "goldfish_pipe",
 	.fops = &goldfish_pipe_fops,
 };
 
-static int goldfish_pipe_probe(struct platform_device *pdev)
+int goldfish_pipe_device_init_v1(struct platform_device *pdev)
 {
-	int err;
-	struct resource *r;
 	struct goldfish_pipe_dev *dev = pipe_dev;
-
-	/* not thread safe, but this should not happen */
-	WARN_ON(dev->base != NULL);
-
-	spin_lock_init(&dev->lock);
-
-	r = platform_get_resource(pdev, IORESOURCE_MEM, 0);
-	if (r == NULL || resource_size(r) < PAGE_SIZE) {
-		dev_err(&pdev->dev, "can't allocate i/o page\n");
-		return -EINVAL;
-	}
-	dev->base = devm_ioremap(&pdev->dev, r->start, PAGE_SIZE);
-	if (dev->base == NULL) {
-		dev_err(&pdev->dev, "ioremap failed\n");
-		return -EINVAL;
-	}
-
-	r = platform_get_resource(pdev, IORESOURCE_IRQ, 0);
-	if (r == NULL) {
-		err = -EINVAL;
-		goto error;
-	}
-	dev->irq = r->start;
-
-	err = devm_request_irq(&pdev->dev, dev->irq, goldfish_pipe_interrupt,
+	int err = devm_request_irq(&pdev->dev, dev->irq, goldfish_pipe_interrupt,
 				IRQF_SHARED, "goldfish_pipe", dev);
 	if (err) {
-		dev_err(&pdev->dev, "unable to allocate IRQ\n");
-		goto error;
+		dev_err(&pdev->dev, "unable to allocate IRQ for v1\n");
+		return err;
 	}
 
-	err = misc_register(&goldfish_pipe_device);
+	err = misc_register(&goldfish_pipe_dev);
 	if (err) {
-		dev_err(&pdev->dev, "unable to register device\n");
-		goto error;
+		dev_err(&pdev->dev, "unable to register v1 device\n");
+		return err;
 	}
-	setup_access_params_addr(pdev, dev);
 
-	/* Although the pipe device in the classic Android emulator does not
-	 * recognize the 'version' register, it won't treat this as an error
-	 * either and will simply return 0, which is fine.
-	 */
-	dev->version = readl(dev->base + PIPE_REG_VERSION);
+	setup_access_params_addr(pdev, dev);
 	return 0;
-
-error:
-	dev->base = NULL;
-	return err;
 }
 
-static int goldfish_pipe_remove(struct platform_device *pdev)
+void goldfish_pipe_device_deinit_v1(struct platform_device *pdev)
 {
-	struct goldfish_pipe_dev *dev = pipe_dev;
-	misc_deregister(&goldfish_pipe_device);
-	dev->base = NULL;
-	return 0;
+    misc_deregister(&goldfish_pipe_dev);
 }
-
-static const struct acpi_device_id goldfish_pipe_acpi_match[] = {
-	{ "GFSH0003", 0 },
-	{ },
-};
-MODULE_DEVICE_TABLE(acpi, goldfish_pipe_acpi_match);
-
-static const struct of_device_id goldfish_pipe_of_match[] = {
-	{ .compatible = "google,android-pipe", },
-	{},
-};
-MODULE_DEVICE_TABLE(of, goldfish_pipe_of_match);
-
-static struct platform_driver goldfish_pipe = {
-	.probe = goldfish_pipe_probe,
-	.remove = goldfish_pipe_remove,
-	.driver = {
-		.name = "goldfish_pipe",
-		.owner = THIS_MODULE,
-		.of_match_table = goldfish_pipe_of_match,
-		.acpi_match_table = ACPI_PTR(goldfish_pipe_acpi_match),
-	}
-};
-
-module_platform_driver(goldfish_pipe);
-MODULE_AUTHOR("David Turner <digit@google.com>");
-MODULE_LICENSE("GPL");
diff --git a/drivers/platform/goldfish/goldfish_pipe.h b/drivers/platform/goldfish/goldfish_pipe.h
new file mode 100644
index 00000000..6cd1b63
--- /dev/null
+++ b/drivers/platform/goldfish/goldfish_pipe.h
@@ -0,0 +1,92 @@
+/*
+ * Copyright (C) 2016 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+#ifndef GOLDFISH_PIPE_H
+#define GOLDFISH_PIPE_H
+
+#include <linux/module.h>
+#include <linux/interrupt.h>
+#include <linux/kernel.h>
+#include <linux/spinlock.h>
+#include <linux/miscdevice.h>
+#include <linux/platform_device.h>
+#include <linux/poll.h>
+#include <linux/sched.h>
+#include <linux/bitops.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/goldfish.h>
+#include <linux/dma-mapping.h>
+#include <linux/mm.h>
+#include <linux/acpi.h>
+
+
+/* Initialize the legacy version of the pipe device driver */
+int goldfish_pipe_device_init_v1(struct platform_device *pdev);
+
+/* Deinitialize the legacy version of the pipe device driver */
+void goldfish_pipe_device_deinit_v1(struct platform_device *pdev);
+
+/* Forward declarations for the device struct */
+struct goldfish_pipe;
+struct goldfish_pipe_device_buffers;
+
+/* The global driver data. Holds a reference to the i/o page used to
+ * communicate with the emulator, and a wake queue for blocked tasks
+ * waiting to be awoken.
+ */
+struct goldfish_pipe_dev {
+	/*
+	 * Global device spinlock. Protects the following members:
+	 *  - pipes, pipes_capacity
+	 *  - [*pipes, *pipes + pipes_capacity) - array data
+	 *  - first_signalled_pipe,
+	 *      goldfish_pipe::prev_signalled,
+	 *      goldfish_pipe::next_signalled,
+	 *      goldfish_pipe::signalled_flags - all singnalled-related fields,
+	 *                                       in all allocated pipes
+	 *  - open_command_params - PIPE_CMD_OPEN-related buffers
+	 *
+	 * It looks like a lot of different fields, but the trick is that the only
+	 * operation that happens often is the signalled pipes array manipulation.
+	 * That's why it's OK for now to keep the rest of the fields under the same
+	 * lock. If we notice too much contention because of PIPE_CMD_OPEN,
+	 * then we should add a separate lock there.
+	 */
+	spinlock_t lock;
+
+	/*
+	 * Array of the pipes of |pipes_capacity| elements,
+	 * indexed by goldfish_pipe::id
+	 */
+	struct goldfish_pipe **pipes;
+	u32 pipes_capacity;
+
+	/* Pointers to the buffers host uses for interaction with this driver */
+	struct goldfish_pipe_dev_buffers *buffers;
+
+	/* Head of a doubly linked list of signalled pipes */
+	struct goldfish_pipe *first_signalled_pipe;
+
+	/* Some device-specific data */
+	int irq;
+	int version;
+	unsigned char __iomem *base;
+
+	/* v1-specific access parameters */
+	struct access_params *aps;
+};
+
+extern struct goldfish_pipe_dev pipe_dev[1];
+
+#endif /* GOLDFISH_PIPE_H */
diff --git a/drivers/platform/goldfish/goldfish_pipe_v2.c b/drivers/platform/goldfish/goldfish_pipe_v2.c
new file mode 100644
index 00000000..ad373ed
--- /dev/null
+++ b/drivers/platform/goldfish/goldfish_pipe_v2.c
@@ -0,0 +1,889 @@
+/*
+ * Copyright (C) 2012 Intel, Inc.
+ * Copyright (C) 2013 Intel, Inc.
+ * Copyright (C) 2014 Linaro Limited
+ * Copyright (C) 2011-2016 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+/* This source file contains the implementation of a special device driver
+ * that intends to provide a *very* fast communication channel between the
+ * guest system and the QEMU emulator.
+ *
+ * Usage from the guest is simply the following (error handling simplified):
+ *
+ *    int  fd = open("/dev/qemu_pipe",O_RDWR);
+ *    .... write() or read() through the pipe.
+ *
+ * This driver doesn't deal with the exact protocol used during the session.
+ * It is intended to be as simple as something like:
+ *
+ *    // do this _just_ after opening the fd to connect to a specific
+ *    // emulator service.
+ *    const char*  msg = "<pipename>";
+ *    if (write(fd, msg, strlen(msg)+1) < 0) {
+ *       ... could not connect to <pipename> service
+ *       close(fd);
+ *    }
+ *
+ *    // after this, simply read() and write() to communicate with the
+ *    // service. Exact protocol details left as an exercise to the reader.
+ *
+ * This driver is very fast because it doesn't copy any data through
+ * intermediate buffers, since the emulator is capable of translating
+ * guest user addresses into host ones.
+ *
+ * Note that we must however ensure that each user page involved in the
+ * exchange is properly mapped during a transfer.
+ */
+
+#include "goldfish_pipe.h"
+
+
+/*
+ * Update this when something changes in the driver's behavior so the host
+ * can benefit from knowing it
+ */
+enum {
+	PIPE_DRIVER_VERSION = 2,
+	PIPE_CURRENT_DEVICE_VERSION = 2
+};
+
+/*
+ * IMPORTANT: The following constants must match the ones used and defined
+ * in external/qemu/hw/goldfish_pipe.c in the Android source tree.
+ */
+
+/* List of bitflags returned in status of CMD_POLL command */
+enum PipePollFlags {
+	PIPE_POLL_IN	= 1 << 0,
+	PIPE_POLL_OUT	= 1 << 1,
+	PIPE_POLL_HUP	= 1 << 2
+};
+
+/* Possible status values used to signal errors - see goldfish_pipe_error_convert */
+enum PipeErrors {
+	PIPE_ERROR_INVAL  = -1,
+	PIPE_ERROR_AGAIN  = -2,
+	PIPE_ERROR_NOMEM  = -3,
+	PIPE_ERROR_IO     = -4
+};
+
+/* Bit-flags used to signal events from the emulator */
+enum PipeWakeFlags {
+	PIPE_WAKE_CLOSED = 1 << 0,  /* emulator closed pipe */
+	PIPE_WAKE_READ   = 1 << 1,  /* pipe can now be read from */
+	PIPE_WAKE_WRITE  = 1 << 2  /* pipe can now be written to */
+};
+
+/* Bit flags for the 'flags' field */
+enum PipeFlagsBits {
+	BIT_CLOSED_ON_HOST = 0,  /* pipe closed by host */
+	BIT_WAKE_ON_WRITE  = 1,  /* want to be woken on writes */
+	BIT_WAKE_ON_READ   = 2,  /* want to be woken on reads */
+};
+
+enum PipeRegs {
+	PIPE_REG_CMD = 0,
+
+	PIPE_REG_SIGNAL_BUFFER_HIGH = 4,
+	PIPE_REG_SIGNAL_BUFFER = 8,
+	PIPE_REG_SIGNAL_BUFFER_COUNT = 12,
+
+	PIPE_REG_OPEN_BUFFER_HIGH = 20,
+	PIPE_REG_OPEN_BUFFER = 24,
+
+	PIPE_REG_VERSION = 36,
+
+	PIPE_REG_GET_SIGNALLED = 48,
+};
+
+enum PipeCmdCode {
+	PIPE_CMD_OPEN = 1,	/* to be used by the pipe device itself */
+	PIPE_CMD_CLOSE,
+	PIPE_CMD_POLL,
+	PIPE_CMD_WRITE,
+	PIPE_CMD_WAKE_ON_WRITE,
+	PIPE_CMD_READ,
+	PIPE_CMD_WAKE_ON_READ,
+
+	/*
+	 * TODO(zyy): implement a deferred read/write execution to allow parallel
+	 *  processing of pipe operations on the host.
+	*/
+	PIPE_CMD_WAKE_ON_DONE_IO,
+};
+
+enum {
+	MAX_BUFFERS_PER_COMMAND = 336,
+	MAX_SIGNALLED_PIPES = 64,
+	INITIAL_PIPES_CAPACITY = 64
+};
+
+struct goldfish_pipe_dev;
+struct goldfish_pipe;
+struct goldfish_pipe_command;
+
+/* A per-pipe command structure, shared with the host */
+struct goldfish_pipe_command {
+	s32 cmd;		/* PipeCmdCode, guest -> host */
+	s32 id;			/* pipe id, guest -> host */
+	s32 status;		/* command execution status, host -> guest */
+	s32 reserved;	/* to pad to 64-bit boundary */
+	union {
+		/* Parameters for PIPE_CMD_{READ,WRITE} */
+		struct {
+			u32 buffers_count;					/* number of buffers, guest -> host */
+			s32 consumed_size;					/* number of consumed bytes, host -> guest */
+			u64 ptrs[MAX_BUFFERS_PER_COMMAND]; 	/* buffer pointers, guest -> host */
+			u32 sizes[MAX_BUFFERS_PER_COMMAND];	/* buffer sizes, guest -> host */
+		} rw_params;
+	};
+};
+
+/* A single signalled pipe information */
+struct signalled_pipe_buffer {
+	u32 id;
+	u32 flags;
+};
+
+/* Parameters for the PIPE_CMD_OPEN command */
+struct open_command_param {
+	u64 command_buffer_ptr;
+	u32 rw_params_max_count;
+};
+
+/* Device-level set of buffers shared with the host */
+struct goldfish_pipe_dev_buffers {
+	struct open_command_param open_command_params;
+	struct signalled_pipe_buffer signalled_pipe_buffers[MAX_SIGNALLED_PIPES];
+};
+
+/* This data type models a given pipe instance */
+struct goldfish_pipe {
+	u32 id;							/* pipe ID - index into goldfish_pipe_dev::pipes array */
+	unsigned long flags;			/* The wake flags pipe is waiting for
+									 * Note: not protected with any lock, uses atomic operations
+									 *  and barriers to make it thread-safe.
+									 */
+	unsigned long signalled_flags;	/* wake flags host have signalled,
+									 *  - protected by goldfish_pipe_dev::lock */
+
+	struct goldfish_pipe_command *command_buffer;	/* A pointer to command buffer */
+
+	/* doubly linked list of signalled pipes, protected by goldfish_pipe_dev::lock */
+	struct goldfish_pipe *prev_signalled;
+	struct goldfish_pipe *next_signalled;
+
+	/*
+	 * A pipe's own lock. Protects the following:
+	 *  - *command_buffer - makes sure a command can safely write its parameters
+	 *    to the host and read the results back.
+	 */
+	struct mutex lock;
+
+	wait_queue_head_t wake_queue;	/* A wake queue for sleeping until host signals an event */
+	struct goldfish_pipe_dev *dev;	/* Pointer to the parent goldfish_pipe_dev instance */
+};
+
+struct goldfish_pipe_dev pipe_dev[1] = {};
+
+static int goldfish_cmd_locked(struct goldfish_pipe *pipe, enum PipeCmdCode cmd)
+{
+	pipe->command_buffer->cmd = cmd;
+	pipe->command_buffer->status = PIPE_ERROR_INVAL;	/* failure by default */
+	writel(pipe->id, pipe->dev->base + PIPE_REG_CMD);
+	return pipe->command_buffer->status;
+}
+
+static int goldfish_cmd(struct goldfish_pipe *pipe, enum PipeCmdCode cmd)
+{
+	int status;
+	if (mutex_lock_interruptible(&pipe->lock))
+		return PIPE_ERROR_IO;
+	status = goldfish_cmd_locked(pipe, cmd);
+	mutex_unlock(&pipe->lock);
+	return status;
+}
+
+/*
+ * This function converts an error code returned by the emulator through
+ * the PIPE_REG_STATUS i/o register into a valid negative errno value.
+ */
+static int goldfish_pipe_error_convert(int status)
+{
+	switch (status) {
+	case PIPE_ERROR_AGAIN:
+		return -EAGAIN;
+	case PIPE_ERROR_NOMEM:
+		return -ENOMEM;
+	case PIPE_ERROR_IO:
+		return -EIO;
+	default:
+		return -EINVAL;
+	}
+}
+
+static int pin_user_pages(unsigned long first_page, unsigned long last_page,
+	unsigned last_page_size, int is_write,
+	struct page *pages[MAX_BUFFERS_PER_COMMAND], unsigned *iter_last_page_size)
+{
+	int ret;
+	int requested_pages = ((last_page - first_page) >> PAGE_SHIFT) + 1;
+	if (requested_pages > MAX_BUFFERS_PER_COMMAND) {
+		requested_pages = MAX_BUFFERS_PER_COMMAND;
+		*iter_last_page_size = PAGE_SIZE;
+	} else {
+		*iter_last_page_size = last_page_size;
+	}
+
+	ret = get_user_pages_fast(
+			first_page, requested_pages, !is_write, pages);
+	if (ret <= 0)
+		return -EFAULT;
+	if (ret < requested_pages)
+		*iter_last_page_size = PAGE_SIZE;
+	return ret;
+
+}
+
+static void release_user_pages(struct page **pages, int pages_count,
+	int is_write, s32 consumed_size)
+{
+	int i;
+	for (i = 0; i < pages_count; i++) {
+		if (!is_write && consumed_size > 0) {
+			set_page_dirty(pages[i]);
+		}
+		put_page(pages[i]);
+	}
+}
+
+/* Populate the call parameters, merging adjacent pages together */
+static void populate_rw_params(
+	struct page **pages, int pages_count,
+	unsigned long address, unsigned long address_end,
+	unsigned long first_page, unsigned long last_page,
+	unsigned iter_last_page_size, int is_write,
+	struct goldfish_pipe_command *command)
+{
+	/*
+	 * Process the first page separately - it's the only page that
+	 * needs special handling for its start address.
+	 */
+	unsigned long xaddr = page_to_phys(pages[0]);
+	unsigned long xaddr_prev = xaddr;
+	int buffer_idx = 0;
+	int i = 1;
+	int size_on_page = first_page == last_page
+			? (int)(address_end - address)
+			: (PAGE_SIZE - (address & ~PAGE_MASK));
+	command->rw_params.ptrs[0] = (u64)(xaddr | (address & ~PAGE_MASK));
+	command->rw_params.sizes[0] = size_on_page;
+	for (; i < pages_count; ++i) {
+		xaddr = page_to_phys(pages[i]);
+		size_on_page = (i == pages_count - 1) ? iter_last_page_size : PAGE_SIZE;
+		if (xaddr == xaddr_prev + PAGE_SIZE) {
+			command->rw_params.sizes[buffer_idx] += size_on_page;
+		} else {
+			++buffer_idx;
+			command->rw_params.ptrs[buffer_idx] = (u64)xaddr;
+			command->rw_params.sizes[buffer_idx] = size_on_page;
+		}
+		xaddr_prev = xaddr;
+	}
+	command->rw_params.buffers_count = buffer_idx + 1;
+}
+
+static int transfer_max_buffers(struct goldfish_pipe* pipe,
+	unsigned long address, unsigned long address_end, int is_write,
+	unsigned long last_page, unsigned int last_page_size,
+	s32* consumed_size, int* status)
+{
+	struct page *pages[MAX_BUFFERS_PER_COMMAND];
+	unsigned long first_page = address & PAGE_MASK;
+	unsigned int iter_last_page_size;
+	int pages_count = pin_user_pages(first_page, last_page,
+			last_page_size, is_write,
+			pages, &iter_last_page_size);
+	if (pages_count < 0)
+		return pages_count;
+
+	/* Serialize access to the pipe command buffers */
+	if (mutex_lock_interruptible(&pipe->lock))
+		return -ERESTARTSYS;
+
+	populate_rw_params(pages, pages_count, address, address_end,
+		first_page, last_page, iter_last_page_size, is_write,
+		pipe->command_buffer);
+
+	/* Transfer the data */
+	*status = goldfish_cmd_locked(pipe,
+						is_write ? PIPE_CMD_WRITE : PIPE_CMD_READ);
+
+	*consumed_size = pipe->command_buffer->rw_params.consumed_size;
+
+	mutex_unlock(&pipe->lock);
+
+	release_user_pages(pages, pages_count, is_write, *consumed_size);
+
+	return 0;
+}
+
+static int wait_for_host_signal(struct goldfish_pipe *pipe, int is_write)
+{
+	u32 wakeBit = is_write ? BIT_WAKE_ON_WRITE : BIT_WAKE_ON_READ;
+	set_bit(wakeBit, &pipe->flags);
+
+	/* Tell the emulator we're going to wait for a wake event */
+	(void)goldfish_cmd(pipe,
+			is_write ? PIPE_CMD_WAKE_ON_WRITE : PIPE_CMD_WAKE_ON_READ);
+
+	while (test_bit(wakeBit, &pipe->flags)) {
+		if (wait_event_interruptible(
+				pipe->wake_queue,
+				!test_bit(wakeBit, &pipe->flags)))
+			return -ERESTARTSYS;
+
+		if (test_bit(BIT_CLOSED_ON_HOST, &pipe->flags))
+			return -EIO;
+	}
+
+	return 0;
+}
+
+static ssize_t goldfish_pipe_read_write(struct file *filp,
+	char __user *buffer, size_t bufflen, int is_write)
+{
+	struct goldfish_pipe *pipe = filp->private_data;
+	int count = 0, ret = -EINVAL;
+	unsigned long address, address_end, last_page;
+	unsigned int last_page_size;
+
+	/* If the emulator already closed the pipe, no need to go further */
+	if (unlikely(test_bit(BIT_CLOSED_ON_HOST, &pipe->flags)))
+		return -EIO;
+	/* Null reads or writes succeeds */
+	if (unlikely(bufflen == 0))
+		return 0;
+	/* Check the buffer range for access */
+	if (unlikely(!access_ok(is_write ? VERIFY_WRITE : VERIFY_READ,
+			buffer, bufflen)))
+		return -EFAULT;
+
+	address = (unsigned long)buffer;
+	address_end = address + bufflen;
+	last_page = (address_end - 1) & PAGE_MASK;
+	last_page_size = ((address_end - 1) & ~PAGE_MASK) + 1;
+
+	while (address < address_end) {
+		s32 consumed_size;
+		int status;
+		ret = transfer_max_buffers(pipe, address, address_end, is_write,
+				last_page, last_page_size, &consumed_size, &status);
+		if (ret < 0)
+			break;
+
+		if (consumed_size > 0) {
+			/* No matter what's the status, we've transfered something */
+			count += consumed_size;
+			address += consumed_size;
+		}
+		if (status > 0)
+			continue;
+		if (status == 0) {
+			/* EOF */
+			ret = 0;
+			break;
+		}
+		if (count > 0) {
+			/*
+			 * An error occured, but we already transfered
+			 * something on one of the previous iterations.
+			 * Just return what we already copied and log this
+			 * err.
+			 */
+			if (status != PIPE_ERROR_AGAIN)
+				pr_info_ratelimited("goldfish_pipe: backend error %d on %s\n",
+									status, is_write ? "write" : "read");
+			break;
+		}
+
+		/*
+		 * If the error is not PIPE_ERROR_AGAIN, or if we are in
+		 * non-blocking mode, just return the error code.
+		 */
+		if (status != PIPE_ERROR_AGAIN || (filp->f_flags & O_NONBLOCK) != 0) {
+			ret = goldfish_pipe_error_convert(status);
+			break;
+		}
+
+		status = wait_for_host_signal(pipe, is_write);
+		if (status < 0)
+			return status;
+	}
+
+	if (count > 0)
+		return count;
+	return ret;
+}
+
+static ssize_t goldfish_pipe_read(struct file *filp, char __user *buffer,
+				size_t bufflen, loff_t *ppos)
+{
+	return goldfish_pipe_read_write(filp, buffer, bufflen, /* is_write */ 0);
+}
+
+static ssize_t goldfish_pipe_write(struct file *filp,
+				const char __user *buffer, size_t bufflen,
+				loff_t *ppos)
+{
+	return goldfish_pipe_read_write(filp,
+			/* cast away the const */(char __user *)buffer, bufflen,
+			/* is_write */ 1);
+}
+
+static unsigned int goldfish_pipe_poll(struct file *filp, poll_table *wait)
+{
+	struct goldfish_pipe *pipe = filp->private_data;
+	unsigned int mask = 0;
+	int status;
+
+	poll_wait(filp, &pipe->wake_queue, wait);
+
+	status = goldfish_cmd(pipe, PIPE_CMD_POLL);
+	if (status < 0) {
+		return -ERESTARTSYS;
+	}
+
+	if (status & PIPE_POLL_IN)
+		mask |= POLLIN | POLLRDNORM;
+	if (status & PIPE_POLL_OUT)
+		mask |= POLLOUT | POLLWRNORM;
+	if (status & PIPE_POLL_HUP)
+		mask |= POLLHUP;
+	if (test_bit(BIT_CLOSED_ON_HOST, &pipe->flags))
+		mask |= POLLERR;
+
+	return mask;
+}
+
+static void signalled_pipes_add_locked(struct goldfish_pipe_dev *dev,
+	u32 id, u32 flags)
+{
+	struct goldfish_pipe *pipe;
+
+	BUG_ON(id >= dev->pipes_capacity);
+
+	pipe = dev->pipes[id];
+	if (!pipe)
+		return;
+	pipe->signalled_flags |= flags;
+
+	if (pipe->prev_signalled || pipe->next_signalled
+		|| dev->first_signalled_pipe == pipe)
+		return;	/* already in the list */
+	pipe->next_signalled = dev->first_signalled_pipe;
+	if (dev->first_signalled_pipe) {
+		dev->first_signalled_pipe->prev_signalled = pipe;
+	}
+	dev->first_signalled_pipe = pipe;
+}
+
+static void signalled_pipes_remove_locked(struct goldfish_pipe_dev *dev,
+	struct goldfish_pipe *pipe) {
+	if (pipe->prev_signalled)
+		pipe->prev_signalled->next_signalled = pipe->next_signalled;
+	if (pipe->next_signalled)
+		pipe->next_signalled->prev_signalled = pipe->prev_signalled;
+	if (pipe == dev->first_signalled_pipe)
+		dev->first_signalled_pipe = pipe->next_signalled;
+	pipe->prev_signalled = NULL;
+	pipe->next_signalled = NULL;
+}
+
+static struct goldfish_pipe *signalled_pipes_pop_front(struct goldfish_pipe_dev *dev,
+		int *wakes)
+{
+	struct goldfish_pipe *pipe;
+	unsigned long flags;
+	spin_lock_irqsave(&dev->lock, flags);
+
+	pipe = dev->first_signalled_pipe;
+	if (pipe) {
+		*wakes = pipe->signalled_flags;
+		pipe->signalled_flags = 0;
+		/*
+		 * This is an optimized version of signalled_pipes_remove_locked() -
+		 * we want to make it as fast as possible to wake the sleeping pipe
+		 * operations faster
+		 */
+		dev->first_signalled_pipe = pipe->next_signalled;
+		if (dev->first_signalled_pipe)
+			dev->first_signalled_pipe->prev_signalled = NULL;
+		pipe->next_signalled = NULL;
+	}
+
+	spin_unlock_irqrestore(&dev->lock, flags);
+	return pipe;
+}
+
+static void goldfish_interrupt_task(unsigned long unused)
+{
+	struct goldfish_pipe_dev *dev = pipe_dev;
+	/* Iterate over the signalled pipes and wake them one by one */
+	struct goldfish_pipe *pipe;
+	int wakes;
+	while ((pipe = signalled_pipes_pop_front(dev, &wakes)) != NULL) {
+		if (wakes & PIPE_WAKE_CLOSED) {
+			pipe->flags = 1 << BIT_CLOSED_ON_HOST;
+		} else {
+			if (wakes & PIPE_WAKE_READ)
+				clear_bit(BIT_WAKE_ON_READ, &pipe->flags);
+			if (wakes & PIPE_WAKE_WRITE)
+				clear_bit(BIT_WAKE_ON_WRITE, &pipe->flags);
+		}
+		/*
+		 * wake_up_interruptible() implies a write barrier, so don't explicitly
+		 * add another one here.
+		 */
+		wake_up_interruptible(&pipe->wake_queue);
+	}
+}
+DECLARE_TASKLET(goldfish_interrupt_tasklet, goldfish_interrupt_task, 0);
+
+/*
+ * The general idea of the interrupt handling:
+ *
+ *  1. device raises an interrupt if there's at least one signalled pipe
+ *  2. IRQ handler reads the signalled pipes and their count from the device
+ *  3. device writes them into a shared buffer and returns the count
+ *      it only resets the IRQ if it has returned all signalled pipes,
+ *      otherwise it leaves it raised, so IRQ handler will be called
+ *      again for the next chunk
+ *  4. IRQ handler adds all returned pipes to the device's signalled pipes list
+ *  5. IRQ handler launches a tasklet to process the signalled pipes from the
+ *      list in a separate context
+ */
+static irqreturn_t goldfish_pipe_interrupt(int irq, void *dev_id)
+{
+	u32 count;
+	u32 i;
+	unsigned long flags;
+	struct goldfish_pipe_dev *dev = dev_id;
+	if (dev != pipe_dev)
+		return IRQ_NONE;
+
+	/* Request the signalled pipes from the device */
+	spin_lock_irqsave(&dev->lock, flags);
+
+	count = readl(dev->base + PIPE_REG_GET_SIGNALLED);
+	if (count == 0) {
+		spin_unlock_irqrestore(&dev->lock, flags);
+		return IRQ_NONE;
+	}
+	if (count > MAX_SIGNALLED_PIPES)
+		count = MAX_SIGNALLED_PIPES;
+
+	for (i = 0; i < count; ++i)
+		signalled_pipes_add_locked(dev,
+			dev->buffers->signalled_pipe_buffers[i].id,
+			dev->buffers->signalled_pipe_buffers[i].flags);
+
+	spin_unlock_irqrestore(&dev->lock, flags);
+
+	tasklet_schedule(&goldfish_interrupt_tasklet);
+	return IRQ_HANDLED;
+}
+
+static int get_free_pipe_id_locked(struct goldfish_pipe_dev *dev)
+{
+	int id;
+	for (id = 0; id < dev->pipes_capacity; ++id)
+		if (!dev->pipes[id])
+			return id;
+
+	{
+		/* Reallocate the array */
+		u32 new_capacity = 2 * dev->pipes_capacity;
+		struct goldfish_pipe **pipes =
+				kcalloc(new_capacity, sizeof(*pipes),
+					GFP_ATOMIC);
+		if (!pipes)
+			return -ENOMEM;
+		memcpy(pipes, dev->pipes, sizeof(*pipes) * dev->pipes_capacity);
+		kfree(dev->pipes);
+		dev->pipes = pipes;
+		id = dev->pipes_capacity;
+		dev->pipes_capacity = new_capacity;
+	}
+	return id;
+}
+
+/**
+ *	goldfish_pipe_open - open a channel to the AVD
+ *	@inode: inode of device
+ *	@file: file struct of opener
+ *
+ *	Create a new pipe link between the emulator and the use application.
+ *	Each new request produces a new pipe.
+ *
+ *	Note: we use the pipe ID as a mux. All goldfish emulations are 32bit
+ *	right now so this is fine. A move to 64bit will need this addressing
+ */
+static int goldfish_pipe_open(struct inode *inode, struct file *file)
+{
+	struct goldfish_pipe_dev *dev = pipe_dev;
+	unsigned long flags;
+	int id;
+	int status;
+
+	/* Allocate new pipe kernel object */
+	struct goldfish_pipe *pipe = kzalloc(sizeof(*pipe), GFP_KERNEL);
+	if (pipe == NULL)
+		return -ENOMEM;
+
+	pipe->dev = dev;
+	mutex_init(&pipe->lock);
+	init_waitqueue_head(&pipe->wake_queue);
+
+	/*
+	 * Command buffer needs to be allocated on its own page to make sure it is
+	 * physically contiguous in host's address space.
+	 */
+	pipe->command_buffer =
+			(struct goldfish_pipe_command*)__get_free_page(GFP_KERNEL);
+	if (!pipe->command_buffer) {
+		status = -ENOMEM;
+		goto err_pipe;
+	}
+
+	spin_lock_irqsave(&dev->lock, flags);
+
+	id = get_free_pipe_id_locked(dev);
+	if (id < 0) {
+		status = id;
+		goto err_id_locked;
+	}
+
+	dev->pipes[id] = pipe;
+	pipe->id = id;
+	pipe->command_buffer->id = id;
+
+	/* Now tell the emulator we're opening a new pipe. */
+	dev->buffers->open_command_params.rw_params_max_count =
+			MAX_BUFFERS_PER_COMMAND;
+	dev->buffers->open_command_params.command_buffer_ptr =
+			(u64)(unsigned long)__pa(pipe->command_buffer);
+	status = goldfish_cmd_locked(pipe, PIPE_CMD_OPEN);
+	spin_unlock_irqrestore(&dev->lock, flags);
+	if (status < 0)
+		goto err_cmd;
+	/* All is done, save the pipe into the file's private data field */
+	file->private_data = pipe;
+	return 0;
+
+err_cmd:
+	spin_lock_irqsave(&dev->lock, flags);
+	dev->pipes[id] = NULL;
+err_id_locked:
+	spin_unlock_irqrestore(&dev->lock, flags);
+	free_page((unsigned long)pipe->command_buffer);
+err_pipe:
+	kfree(pipe);
+	return status;
+}
+
+static int goldfish_pipe_release(struct inode *inode, struct file *filp)
+{
+	unsigned long flags;
+	struct goldfish_pipe *pipe = filp->private_data;
+	struct goldfish_pipe_dev *dev = pipe->dev;
+
+	/* The guest is closing the channel, so tell the emulator right now */
+	(void)goldfish_cmd(pipe, PIPE_CMD_CLOSE);
+
+	spin_lock_irqsave(&dev->lock, flags);
+	dev->pipes[pipe->id] = NULL;
+	signalled_pipes_remove_locked(dev, pipe);
+	spin_unlock_irqrestore(&dev->lock, flags);
+
+	filp->private_data = NULL;
+	free_page((unsigned long)pipe->command_buffer);
+	kfree(pipe);
+	return 0;
+}
+
+static const struct file_operations goldfish_pipe_fops = {
+	.owner = THIS_MODULE,
+	.read = goldfish_pipe_read,
+	.write = goldfish_pipe_write,
+	.poll = goldfish_pipe_poll,
+	.open = goldfish_pipe_open,
+	.release = goldfish_pipe_release,
+};
+
+static struct miscdevice goldfish_pipe_dev = {
+	.minor = MISC_DYNAMIC_MINOR,
+	.name = "goldfish_pipe",
+	.fops = &goldfish_pipe_fops,
+};
+
+static int goldfish_pipe_device_init_v2(struct platform_device *pdev)
+{
+	char *page;
+	struct goldfish_pipe_dev *dev = pipe_dev;
+	int err = devm_request_irq(&pdev->dev, dev->irq, goldfish_pipe_interrupt,
+				IRQF_SHARED, "goldfish_pipe", dev);
+	if (err) {
+		dev_err(&pdev->dev, "unable to allocate IRQ for v2\n");
+		return err;
+	}
+
+	err = misc_register(&goldfish_pipe_dev);
+	if (err) {
+		dev_err(&pdev->dev, "unable to register v2 device\n");
+		return err;
+	}
+
+	dev->first_signalled_pipe = NULL;
+	dev->pipes_capacity = INITIAL_PIPES_CAPACITY;
+	dev->pipes = kcalloc(dev->pipes_capacity, sizeof(*dev->pipes), GFP_KERNEL);
+	if (!dev->pipes)
+		return -ENOMEM;
+
+	/*
+	 * We're going to pass two buffers, open_command_params and
+	 * signalled_pipe_buffers, to the host. This means each of those buffers
+	 * needs to be contained in a single physical page. The easiest choice is
+	 * to just allocate a page and place the buffers in it.
+	 */
+	BUG_ON(sizeof(*dev->buffers) > PAGE_SIZE);
+	page = (char*)__get_free_page(GFP_KERNEL);
+	if (!page) {
+		kfree(dev->pipes);
+		return -ENOMEM;
+	}
+	dev->buffers = (struct goldfish_pipe_dev_buffers*)page;
+
+	/* Send the buffer addresses to the host */
+	{
+		u64 paddr = __pa(&dev->buffers->signalled_pipe_buffers);
+		writel((u32)(unsigned long)(paddr >> 32), dev->base + PIPE_REG_SIGNAL_BUFFER_HIGH);
+		writel((u32)(unsigned long)paddr, dev->base + PIPE_REG_SIGNAL_BUFFER);
+		writel((u32)MAX_SIGNALLED_PIPES, dev->base + PIPE_REG_SIGNAL_BUFFER_COUNT);
+
+		paddr = __pa(&dev->buffers->open_command_params);
+		writel((u32)(unsigned long)(paddr >> 32), dev->base + PIPE_REG_OPEN_BUFFER_HIGH);
+		writel((u32)(unsigned long)paddr, dev->base + PIPE_REG_OPEN_BUFFER);
+	}
+	return 0;
+}
+
+static void goldfish_pipe_device_deinit_v2(struct platform_device *pdev) {
+	struct goldfish_pipe_dev *dev = pipe_dev;
+	misc_deregister(&goldfish_pipe_dev);
+	kfree(dev->pipes);
+	free_page((unsigned long)dev->buffers);
+}
+
+static int goldfish_pipe_probe(struct platform_device *pdev)
+{
+	int err;
+	struct resource *r;
+	struct goldfish_pipe_dev *dev = pipe_dev;
+
+	BUG_ON(sizeof(struct goldfish_pipe_command) > PAGE_SIZE);
+
+	/* not thread safe, but this should not happen */
+	WARN_ON(dev->base != NULL);
+
+	spin_lock_init(&dev->lock);
+
+	r = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (r == NULL || resource_size(r) < PAGE_SIZE) {
+		dev_err(&pdev->dev, "can't allocate i/o page\n");
+		return -EINVAL;
+	}
+	dev->base = devm_ioremap(&pdev->dev, r->start, PAGE_SIZE);
+	if (dev->base == NULL) {
+		dev_err(&pdev->dev, "ioremap failed\n");
+		return -EINVAL;
+	}
+
+	r = platform_get_resource(pdev, IORESOURCE_IRQ, 0);
+	if (r == NULL) {
+		err = -EINVAL;
+		goto error;
+	}
+	dev->irq = r->start;
+
+	/*
+	 * Exchange the versions with the host device
+	 *
+	 * Note: v1 driver used to not report its version, so we write it before
+	 *  reading device version back: this allows the host implementation to
+	 *  detect the old driver (if there was no version write before read).
+	 */
+	writel((u32)PIPE_DRIVER_VERSION, dev->base + PIPE_REG_VERSION);
+	dev->version = readl(dev->base + PIPE_REG_VERSION);
+	if (dev->version < PIPE_CURRENT_DEVICE_VERSION) {
+		/* initialize the old device version */
+		err = goldfish_pipe_device_init_v1(pdev);
+	} else {
+		/* Host device supports the new interface */
+		err = goldfish_pipe_device_init_v2(pdev);
+	}
+	if (!err)
+		return 0;
+
+error:
+	dev->base = NULL;
+	return err;
+}
+
+static int goldfish_pipe_remove(struct platform_device *pdev)
+{
+	struct goldfish_pipe_dev *dev = pipe_dev;
+	if (dev->version < PIPE_CURRENT_DEVICE_VERSION)
+		goldfish_pipe_device_deinit_v1(pdev);
+	else
+		goldfish_pipe_device_deinit_v2(pdev);
+	dev->base = NULL;
+	return 0;
+}
+
+static const struct acpi_device_id goldfish_pipe_acpi_match[] = {
+	{ "GFSH0003", 0 },
+	{ },
+};
+MODULE_DEVICE_TABLE(acpi, goldfish_pipe_acpi_match);
+
+static const struct of_device_id goldfish_pipe_of_match[] = {
+	{ .compatible = "google,android-pipe", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, goldfish_pipe_of_match);
+
+static struct platform_driver goldfish_pipe_driver = {
+	.probe = goldfish_pipe_probe,
+	.remove = goldfish_pipe_remove,
+	.driver = {
+		.name = "goldfish_pipe",
+		.of_match_table = goldfish_pipe_of_match,
+		.acpi_match_table = ACPI_PTR(goldfish_pipe_acpi_match),
+	}
+};
+
+module_platform_driver(goldfish_pipe_driver);
+MODULE_AUTHOR("David Turner <digit@google.com>");
+MODULE_LICENSE("GPL");
diff --git a/drivers/platform/x86/thinkpad_acpi.c b/drivers/platform/x86/thinkpad_acpi.c
index b65ce75..60ee94e 100644
--- a/drivers/platform/x86/thinkpad_acpi.c
+++ b/drivers/platform/x86/thinkpad_acpi.c
@@ -9526,7 +9526,7 @@ static void __init thinkpad_acpi_init_banner(void)
 	},
 };
 
-static int __init set_ibm_param(const char *val, struct kernel_param *kp)
+static int __init set_ibm_param(const char *val, const struct kernel_param *kp)
 {
 	unsigned int i;
 	struct ibm_struct *ibm;
diff --git a/drivers/power/reset/Kconfig b/drivers/power/reset/Kconfig
index 02e46bb..c5f9b9d 100644
--- a/drivers/power/reset/Kconfig
+++ b/drivers/power/reset/Kconfig
@@ -208,5 +208,11 @@ config SYSCON_REBOOT_MODE
 	  register, then the bootloader can read it to take different
 	  action according to the mode.
 
+config POWER_RESET_G22XX_POWEROFF
+	tristate "GMT G22xx Poweroff Driver"
+	depends on MFD_G22XX
+	help
+	  This driver support for GMT G22xx PMIC Poweroff.
+
 endif
 
diff --git a/drivers/power/reset/Makefile b/drivers/power/reset/Makefile
index 1be307c..b380b46 100644
--- a/drivers/power/reset/Makefile
+++ b/drivers/power/reset/Makefile
@@ -24,3 +24,4 @@ obj-$(CONFIG_POWER_RESET_RMOBILE) += rmobile-reset.o
 obj-$(CONFIG_POWER_RESET_ZX) += zx-reboot.o
 obj-$(CONFIG_REBOOT_MODE) += reboot-mode.o
 obj-$(CONFIG_SYSCON_REBOOT_MODE) += syscon-reboot-mode.o
+obj-$(CONFIG_POWER_RESET_G22XX_POWEROFF) += g22xx-poweroff.o
diff --git a/drivers/power/reset/g22xx-poweroff.c b/drivers/power/reset/g22xx-poweroff.c
new file mode 100644
index 00000000..8e2998c
--- /dev/null
+++ b/drivers/power/reset/g22xx-poweroff.c
@@ -0,0 +1,119 @@
+/*
+ * GMT-G22xx series PMIC Poweroff Driver
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/platform_device.h>
+#include <linux/regmap.h>
+#include <linux/slab.h>
+#include <linux/mfd/g22xx.h>
+#include <linux/mfd/g2227.h>
+
+struct g22xx_poweroff_data {
+	struct device *dev;
+	struct g22xx_device *gdev;
+	struct regmap_field *off;
+};
+
+static struct g22xx_poweroff_data *poweroff_data;
+
+static void g22xx_pm_power_off(void)
+{
+	dev_emerg(poweroff_data->dev, "set softoff\n");
+	regmap_field_write(poweroff_data->off, 1);
+	for (;;)
+		;
+}
+
+static int g22xx_poweroff_probe(struct platform_device *pdev)
+{
+	struct g22xx_poweroff_data *pdata;
+	struct device *dev = &pdev->dev;
+	struct g22xx_device *gdev = dev_get_drvdata(dev->parent);
+	int ret;
+	struct reg_field map = REG_FIELD(G2227_REG_SYS_CONTROL,
+				 G2227_SOFTOFF_SHIFT,
+				 G2227_SOFTOFF_SHIFT + G2227_SOFTOFF_WIDTH - 1);
+
+	if (!dev->of_node || !of_device_is_available(dev->of_node))
+		return -ENODEV;
+
+	if (!gdev) {
+		dev_err(dev, "no parent device\n");
+		return -EINVAL;
+	}
+
+	if (!of_device_is_system_power_controller(dev->of_node)) {
+		dev_info(dev, "not a system power controller\n");
+		return 0;
+	}
+
+	if (pm_power_off) {
+		dev_err(dev, "pm_power_off is already assigned with %pf\n",
+			pm_power_off);
+		return -EINVAL;
+	}
+
+	pdata = devm_kzalloc(dev, sizeof(*pdata), GFP_KERNEL);
+	if (!pdata)
+		return -ENOMEM;
+
+	pdata->dev = dev;
+	pdata->gdev = gdev;
+	pdata->off = devm_regmap_field_alloc(dev, gdev->regmap, map);
+	if (IS_ERR(pdata->off)) {
+		ret = PTR_ERR(pdata->off);
+		dev_err(dev, "failed to create regmap field: %d\n", ret);
+		return ret;
+	}
+
+	poweroff_data = pdata;
+	pm_power_off = g22xx_pm_power_off;
+	platform_set_drvdata(pdev, poweroff_data);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+static int g22xx_poweroff_remove(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+
+	platform_set_drvdata(pdev, NULL);
+	pm_power_off = NULL;
+	poweroff_data = NULL;
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+static const struct of_device_id g22xx_poweroff_ids[] = {
+	{ .compatible = "gmt,g22xx-poweroff", },
+	{}
+};
+static struct platform_driver g22xx_poweroff_driver = {
+	.probe = g22xx_poweroff_probe,
+	.remove = g22xx_poweroff_remove,
+	.driver = {
+		.name = "g22xx-poweroff",
+		.of_match_table = g22xx_poweroff_ids,
+	},
+};
+module_platform_driver(g22xx_poweroff_driver);
+
diff --git a/drivers/power/supply/Kconfig b/drivers/power/supply/Kconfig
index 76806a0..3a5363f 100644
--- a/drivers/power/supply/Kconfig
+++ b/drivers/power/supply/Kconfig
@@ -511,4 +511,10 @@ config AXP20X_POWER
 	  This driver provides support for the power supply features of
 	  AXP20x PMIC.
 
+config RTD1XXX_POWER
+	tristate "RTD1XXX power supply driver"
+	default y
+	help
+	  This driver provides support for the power supply to make Android happy.
+
 endif # POWER_SUPPLY
diff --git a/drivers/power/supply/Makefile b/drivers/power/supply/Makefile
index 36c599d..9f17f51 100644
--- a/drivers/power/supply/Makefile
+++ b/drivers/power/supply/Makefile
@@ -72,3 +72,5 @@ obj-$(CONFIG_CHARGER_TPS65090)	+= tps65090-charger.o
 obj-$(CONFIG_CHARGER_TPS65217)	+= tps65217_charger.o
 obj-$(CONFIG_AXP288_FUEL_GAUGE) += axp288_fuel_gauge.o
 obj-$(CONFIG_AXP288_CHARGER)	+= axp288_charger.o
+obj-$(CONFIG_RTD1XXX_POWER)     += rtd1xxx_ac.o
+obj-$(CONFIG_RTD1XXX_POWER)     += rtd1xxx_battery.o
diff --git a/drivers/power/supply/power_supply_sysfs.c b/drivers/power/supply/power_supply_sysfs.c
index bcde8d1..fdb824f 100644
--- a/drivers/power/supply/power_supply_sysfs.c
+++ b/drivers/power/supply/power_supply_sysfs.c
@@ -107,7 +107,10 @@ static ssize_t power_supply_show_property(struct device *dev,
 	else if (off >= POWER_SUPPLY_PROP_MODEL_NAME)
 		return sprintf(buf, "%s\n", value.strval);
 
-	return sprintf(buf, "%d\n", value.intval);
+	if (off == POWER_SUPPLY_PROP_CHARGE_COUNTER_EXT)
+		return sprintf(buf, "%lld\n", value.int64val);
+	else
+		return sprintf(buf, "%d\n", value.intval);
 }
 
 static ssize_t power_supply_store_property(struct device *dev,
@@ -198,6 +201,12 @@ static ssize_t power_supply_store_property(struct device *dev,
 	POWER_SUPPLY_ATTR(scope),
 	POWER_SUPPLY_ATTR(charge_term_current),
 	POWER_SUPPLY_ATTR(calibrate),
+	/* Local extensions */
+	POWER_SUPPLY_ATTR(usb_hc),
+	POWER_SUPPLY_ATTR(usb_otg),
+	POWER_SUPPLY_ATTR(charge_enabled),
+	/* Local extensions of type int64_t */
+	POWER_SUPPLY_ATTR(charge_counter_ext),
 	/* Properties of type `const char *' */
 	POWER_SUPPLY_ATTR(model_name),
 	POWER_SUPPLY_ATTR(manufacturer),
diff --git a/drivers/power/supply/rtd1xxx_ac.c b/drivers/power/supply/rtd1xxx_ac.c
new file mode 100644
index 00000000..a390688
--- /dev/null
+++ b/drivers/power/supply/rtd1xxx_ac.c
@@ -0,0 +1,91 @@
+/*
+ * AC driver for RTD1xxx
+ *
+ * Copyright (c) 
+ *
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/of.h>
+#include <linux/platform_device.h>
+#include <linux/power_supply.h>
+
+struct power_supply *ac;
+
+static int rtd1xxx_ac_get_prop(struct power_supply *psy,
+				enum power_supply_property psp,
+				union power_supply_propval *val)
+{
+	int ret = 0;
+
+	switch (psp) {
+	case POWER_SUPPLY_PROP_ONLINE:
+
+		val->intval = 1;
+		break;	
+	default:
+		pr_err("%s %d \n", __func__, __LINE__);
+
+		ret = -ENODEV;
+		break;
+	}
+	return ret;
+}
+static enum power_supply_property rtd1xxx_ac_props[] = {
+
+	POWER_SUPPLY_PROP_ONLINE,
+};
+
+static const struct power_supply_desc ac_desc = {
+	.name		= "rtd1xxx-ac",
+	.type		= POWER_SUPPLY_TYPE_MAINS,
+	.properties	= rtd1xxx_ac_props,
+	.num_properties	= ARRAY_SIZE(rtd1xxx_ac_props),
+	.get_property	= rtd1xxx_ac_get_prop,
+};
+
+
+static struct platform_device *pdev;
+
+
+static int __init rtd1xxx_ac_init(void)
+{
+	int ret = 0;
+	pdev = platform_device_register_simple("rtd1xxx-ac",
+                                                   0, NULL, 0);
+	if (IS_ERR(pdev)) {
+		ret = PTR_ERR(pdev);
+		pr_err("%s platform_device_register_simple \n", __func__);
+		goto out;
+	}
+
+	ac = power_supply_register(&pdev->dev, &ac_desc, NULL);
+	if (IS_ERR(ac)) {
+		ret = PTR_ERR(ac);
+		pr_err("%s power_supply_register err \n", __func__);
+		ac = NULL;
+		goto out;
+	}
+
+out:
+	return ret;
+}
+
+static void rtd1xxx_ac_exit(void)
+{
+	power_supply_unregister(ac);
+	platform_device_unregister(pdev);
+}
+
+
+module_init(rtd1xxx_ac_init);
+module_exit(rtd1xxx_ac_exit);
+
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("AC power supply driver for RTD1xxx ");
+MODULE_ALIAS("platform:rtd1xxx-ac");
diff --git a/drivers/power/supply/rtd1xxx_battery.c b/drivers/power/supply/rtd1xxx_battery.c
new file mode 100644
index 00000000..d5f91d3
--- /dev/null
+++ b/drivers/power/supply/rtd1xxx_battery.c
@@ -0,0 +1,146 @@
+/*
+ * Battery driver for RTD1xxx
+ *
+ * Copyright (c) 
+ *
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/of.h>
+#include <linux/platform_device.h>
+#include <linux/power_supply.h>
+
+struct power_supply *battery;
+
+static int rtd1xxx_bat_get_prop(struct power_supply *psy,
+				enum power_supply_property psp,
+				union power_supply_propval *val)
+{
+	int ret = 0;
+
+	switch (psp) {
+ 	case POWER_SUPPLY_PROP_PRESENT:
+
+		val->intval = 0;
+		break;
+	case POWER_SUPPLY_PROP_CAPACITY:
+
+		val->intval = 100;
+		break;
+	case POWER_SUPPLY_PROP_STATUS:
+
+		val->intval = POWER_SUPPLY_STATUS_CHARGING;
+		break;
+	case POWER_SUPPLY_PROP_HEALTH:
+
+		val->intval = POWER_SUPPLY_HEALTH_GOOD;
+		break;
+	case POWER_SUPPLY_PROP_TECHNOLOGY:
+
+		val->intval = POWER_SUPPLY_TECHNOLOGY_LION;
+		break;
+	case POWER_SUPPLY_PROP_TEMP:
+
+		val->intval = 310; //0.1°C
+		break;
+	case POWER_SUPPLY_PROP_CHARGE_COUNTER:
+
+		val->intval = 4000000;
+		break;
+	case POWER_SUPPLY_PROP_CYCLE_COUNT:
+
+		val->intval = 9;
+		break;
+	case POWER_SUPPLY_PROP_VOLTAGE_NOW:
+
+		val->intval = 5000000; //uvolts
+		break;
+	case POWER_SUPPLY_PROP_CHARGE_FULL:
+
+		val->intval = 4000000; //uAh
+		break;
+	case POWER_SUPPLY_PROP_CURRENT_NOW:
+
+		val->intval = 400;
+		break;
+	case POWER_SUPPLY_PROP_CURRENT_AVG:
+
+		val->intval = 400;
+		break;
+	default:
+		pr_err("%s %d \n", __func__, __LINE__);
+
+		ret = -ENODEV;
+		break;
+	}
+	return ret;
+}
+static enum power_supply_property rtd1xxx_battery_props[] = {
+
+	POWER_SUPPLY_PROP_PRESENT,
+	POWER_SUPPLY_PROP_CAPACITY,
+	POWER_SUPPLY_PROP_STATUS,
+	POWER_SUPPLY_PROP_HEALTH,
+	POWER_SUPPLY_PROP_TECHNOLOGY,
+    POWER_SUPPLY_PROP_TEMP,
+    POWER_SUPPLY_PROP_CHARGE_COUNTER,
+    POWER_SUPPLY_PROP_CYCLE_COUNT,
+    POWER_SUPPLY_PROP_VOLTAGE_NOW,
+    POWER_SUPPLY_PROP_CHARGE_FULL,
+    POWER_SUPPLY_PROP_CURRENT_NOW,
+    POWER_SUPPLY_PROP_CURRENT_AVG,
+};
+
+static const struct power_supply_desc battery_desc = {
+	.name		= "rtd1xxx-battery",
+	.type		= POWER_SUPPLY_TYPE_BATTERY,
+	.properties	= rtd1xxx_battery_props,
+	.num_properties	= ARRAY_SIZE(rtd1xxx_battery_props),
+	.get_property	= rtd1xxx_bat_get_prop,
+};
+
+
+static struct platform_device *pdev;
+
+
+static int __init rtd1xxx_battery_init(void)
+{
+	int ret = 0;
+	pdev = platform_device_register_simple("rtd1xxx-battery",
+                                                   0, NULL, 0);
+	if (IS_ERR(pdev)) {
+		ret = PTR_ERR(pdev);
+		pr_err("%s platform_device_register_simple \n", __func__);
+		goto out;
+	}
+
+	battery = power_supply_register(&pdev->dev, &battery_desc, NULL);
+	if (IS_ERR(battery)) {
+		ret = PTR_ERR(battery);
+		pr_err("%s power_supply_register err \n", __func__);
+		battery = NULL;
+		goto out;
+	}
+
+out:
+	return ret;
+}
+
+static void rtd1xxx_battery_exit(void)
+{
+	power_supply_unregister(battery);
+	platform_device_unregister(pdev);
+}
+
+
+module_init(rtd1xxx_battery_init);
+module_exit(rtd1xxx_battery_exit);
+
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Battery power supply driver for RTD1xxx ");
+MODULE_ALIAS("platform:rtd1xxx-battery");
diff --git a/drivers/pwm/Kconfig b/drivers/pwm/Kconfig
index bf01288..6decb5a 100644
--- a/drivers/pwm/Kconfig
+++ b/drivers/pwm/Kconfig
@@ -358,6 +358,20 @@ config PWM_ROCKCHIP
 	  Generic PWM framework driver for the PWM controller found on
 	  Rockchip SoCs.
 
+menuconfig PWM_RTK
+    tristate "Realtek PWM support"
+    depends on RTK_PLATFORM
+    default n
+    help
+      Say Y, if you want to enable PWM feature on Realtek platform.
+
+config RTK_PWM_DEBUG
+    bool "Enable debug message"
+    depends on PWM_RTK
+    default n
+    help
+      Enable RTK PWM driver debug message
+
 config PWM_SAMSUNG
 	tristate "Samsung PWM support"
 	depends on PLAT_SAMSUNG || ARCH_EXYNOS
diff --git a/drivers/pwm/Makefile b/drivers/pwm/Makefile
index 1194c54..4f892ee 100644
--- a/drivers/pwm/Makefile
+++ b/drivers/pwm/Makefile
@@ -34,6 +34,7 @@ obj-$(CONFIG_PWM_PXA)		+= pwm-pxa.o
 obj-$(CONFIG_PWM_RCAR)		+= pwm-rcar.o
 obj-$(CONFIG_PWM_RENESAS_TPU)	+= pwm-renesas-tpu.o
 obj-$(CONFIG_PWM_ROCKCHIP)	+= pwm-rockchip.o
+obj-$(CONFIG_PWM_RTK)		+= pwm-rtk.o
 obj-$(CONFIG_PWM_SAMSUNG)	+= pwm-samsung.o
 obj-$(CONFIG_PWM_SPEAR)		+= pwm-spear.o
 obj-$(CONFIG_PWM_STI)		+= pwm-sti.o
diff --git a/drivers/pwm/pwm-rtk.c b/drivers/pwm/pwm-rtk.c
new file mode 100644
index 00000000..f831ec3
--- /dev/null
+++ b/drivers/pwm/pwm-rtk.c
@@ -0,0 +1,1192 @@
+/*
+ * Realtek pulse-width-modulation controller driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ */
+
+#include <linux/clk.h>
+#include <linux/err.h>
+#include <linux/io.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/pwm.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/sysfs.h>
+#include <linux/pinctrl/consumer.h>
+
+// RTK define here
+#define RTK_DEF_PWM_IDX     (0)     // default use PWM idx set to 0
+
+#define RTK_ADDR_PWM_OCD    (0x0)
+#define RTK_ADDR_PWM_CD     (0x4)
+#define RTK_ADDR_PWM_CSD    (0x8)
+
+#define RTK_PWM_OCD_SHIFT       (8)
+#define RTK_PWM_CD_SHIFT        (8)
+#define RTK_PWM_CSD_SHIFT       (4)
+
+#define RTK_PWM_OCD_MASK       (0xff)
+#define RTK_PWM_CD_MASK        (0xff)
+#define RTK_PWM_CSD_MASK       (0xf)
+
+#define RTK_PWM_OCD_DEFAULT      	(0xff)
+#define RTK_PWM_CD_DEFAULT       	(0x1)
+#define RTK_PWM_CSD_DEFAULT     	(0x1)
+
+#define NUM_PWM 4
+#define DEV_NAME "[RTK_PWM]"
+
+#ifdef CONFIG_RTK_PWM_DEBUG
+#define PWM_DEBUG(args...) pr_info(args);
+#else
+#define PWM_DEBUG(args...)
+#endif /* RTK_PWM_DEBUG */
+
+struct RTK119X_pwm_map {
+	int duty_rate;
+	int ocd_data;
+	int cd_data;
+};
+
+struct pwm_child_dev {
+	struct device   dev;
+	int             dev_registered;
+	int             loc;
+	struct pinctrl  *pin;
+	struct pinctrl_state *enable_state;
+	struct pinctrl_state *disable_state;
+};
+
+struct rtd1295_pwm_chip {
+	struct pwm_chip		chip;
+	struct device		*dev;
+	void __iomem		*mmio_pwm_reg_base;
+	spinlock_t	lock;
+	int			proc_id;
+	int			base_freq;
+	int			out_freq[NUM_PWM]; //Hz
+	int			duty_rate[NUM_PWM];
+	int			enable[NUM_PWM];
+	int			clksrc_div[NUM_PWM];
+	int			clkout_div[NUM_PWM];
+	int			clk_duty[NUM_PWM];
+	struct pwm_child_dev    childs[NUM_PWM];
+};
+
+ssize_t pwm_show_dutyRate0(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_dutyRate0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_enable0(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_enable0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_clksrcDiv0(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_clksrcDiv0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_clkoutDiv0(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_clkoutDiv0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_out_freq0(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_out_freq0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_dutyRate1(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_dutyRate1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_enable1(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_enable1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_clksrcDiv1(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_clksrcDiv1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_clkoutDiv1(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_clkoutDiv1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_out_freq1(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_out_freq1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_dutyRate2(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_dutyRate2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_enable2(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_enable2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_clksrcDiv2(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_clksrcDiv2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_clkoutDiv2(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_clkoutDiv2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_out_freq2(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_out_freq2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_dutyRate3(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_dutyRate3(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_enable3(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_enable3(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_clksrcDiv3(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_clksrcDiv3(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_clkoutDiv3(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_clkoutDiv3(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+ssize_t pwm_show_out_freq3(struct device *dev, struct device_attribute *attr, char *buf);
+ssize_t pwm_store_out_freq3(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count);
+
+static DEVICE_ATTR(dutyRate0, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_dutyRate0, pwm_store_dutyRate0);
+static DEVICE_ATTR(enable0, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_enable0, pwm_store_enable0);
+static DEVICE_ATTR(clksrcDiv0, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_clksrcDiv0, pwm_store_clksrcDiv0);
+static DEVICE_ATTR(clkoutDiv0, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_clkoutDiv0, pwm_store_clkoutDiv0);
+static DEVICE_ATTR(out_freq0, S_IRUGO, pwm_show_out_freq0, pwm_store_out_freq0);
+
+static DEVICE_ATTR(dutyRate1, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_dutyRate1, pwm_store_dutyRate1);
+static DEVICE_ATTR(enable1, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_enable1, pwm_store_enable1);
+static DEVICE_ATTR(clksrcDiv1, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_clksrcDiv1, pwm_store_clksrcDiv1);
+static DEVICE_ATTR(clkoutDiv1, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_clkoutDiv1, pwm_store_clkoutDiv1);
+static DEVICE_ATTR(out_freq1, S_IRUGO, pwm_show_out_freq1, pwm_store_out_freq1);
+
+static DEVICE_ATTR(dutyRate2, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_dutyRate2, pwm_store_dutyRate2);
+static DEVICE_ATTR(enable2, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_enable2, pwm_store_enable2);
+static DEVICE_ATTR(clksrcDiv2, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_clksrcDiv2, pwm_store_clksrcDiv2);
+static DEVICE_ATTR(clkoutDiv2, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_clkoutDiv2, pwm_store_clkoutDiv2);
+static DEVICE_ATTR(out_freq2, S_IRUGO, pwm_show_out_freq2, pwm_store_out_freq2);
+
+static DEVICE_ATTR(dutyRate3, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_dutyRate3, pwm_store_dutyRate3);
+static DEVICE_ATTR(enable3, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_enable3, pwm_store_enable3);
+static DEVICE_ATTR(clksrcDiv3, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_clksrcDiv3, pwm_store_clksrcDiv3);
+static DEVICE_ATTR(clkoutDiv3, ((S_IRUGO | S_IWUGO) & ~S_IWOTH), pwm_show_clkoutDiv3, pwm_store_clkoutDiv3);
+static DEVICE_ATTR(out_freq3, S_IRUGO, pwm_show_out_freq3, pwm_store_out_freq3);
+
+static struct attribute *pwm_dev_attrs[] = {
+	&dev_attr_dutyRate0.attr,
+	&dev_attr_enable0.attr,
+	&dev_attr_clksrcDiv0.attr,
+	&dev_attr_clkoutDiv0.attr,
+	&dev_attr_out_freq0.attr,
+	&dev_attr_dutyRate1.attr,
+	&dev_attr_enable1.attr,
+	&dev_attr_clksrcDiv1.attr,
+	&dev_attr_clkoutDiv1.attr,
+	&dev_attr_out_freq1.attr,
+	&dev_attr_dutyRate2.attr,
+	&dev_attr_enable2.attr,
+	&dev_attr_clksrcDiv2.attr,
+	&dev_attr_clkoutDiv2.attr,
+	&dev_attr_out_freq2.attr,
+	&dev_attr_dutyRate3.attr,
+	&dev_attr_enable3.attr,
+	&dev_attr_clksrcDiv3.attr,
+	&dev_attr_clkoutDiv3.attr,
+	&dev_attr_out_freq3.attr,
+	NULL,
+};
+
+static struct attribute_group pwm_dev_attr_group = {
+	.attrs		= pwm_dev_attrs,
+};
+
+static inline struct rtd1295_pwm_chip *to_rtd1295_pwm_chip(struct pwm_chip *chip)
+{
+	return container_of(chip, struct rtd1295_pwm_chip, chip);
+}
+
+#define to_pwm_device(d) return container_of(d, struct rtd1295_pwm_chip, chip);
+
+int set_real_freq_by_target_freq(struct rtd1295_pwm_chip *pc, int hwpwm, int target_freq) {
+	int base_freq = pc->base_freq;
+	int real_freq;
+	int ocd, csd, div, opt_div;
+	div = base_freq / target_freq;
+
+	{
+		// give a div to get max ocd and min csd
+		int min_ocd = 0;
+		int max_ocd = 255;
+		int min_csd = 0;
+		int max_csd = 15;
+		int i;
+		// find max bit
+		for (i = 0; i < 32; i++) {
+			if ((div << i) & BIT(31)) {
+				break;
+			}
+		}
+		csd = (32 - (i + 8)) - 1;
+		if (csd > max_csd) csd = max_csd;
+		else if (csd < min_csd) csd = min_csd;
+
+		ocd = (div >> (csd + 1)) - 1;
+		if (ocd > max_ocd) ocd = max_ocd;
+		else if (ocd < min_ocd) ocd = min_ocd;
+
+		opt_div = BIT(csd + 1)*(ocd + 1);
+		PWM_DEBUG("%s target_div=%d, real_div=%d, osd=%d, ocd=%d\n", DEV_NAME, div, opt_div, csd, ocd);
+	}
+
+	real_freq = base_freq / opt_div;
+	pc->clkout_div[hwpwm] = ocd;
+	pc->clksrc_div[hwpwm] = csd;
+
+	pc->out_freq[hwpwm] = real_freq;
+
+	PWM_DEBUG("%s hwpwm=%d, target_freq=%d, real_freq=%d, osd=%d, ocd=%d\n",
+		DEV_NAME, hwpwm, target_freq, pc->out_freq[hwpwm], pc->clksrc_div[hwpwm], pc->clkout_div[hwpwm]);
+
+	return real_freq;
+}
+
+int set_real_period_by_target_period(struct rtd1295_pwm_chip *pc, int hwpwm, int target_period_ns) {
+	int base_ns = 1000000000;
+	int real_period_ns;
+	int target_freq, real_freq;
+
+	target_freq = base_ns / target_period_ns;
+	real_freq = set_real_freq_by_target_freq(pc, hwpwm, target_freq);
+	real_period_ns = base_ns / real_freq;
+
+	PWM_DEBUG("%s hwpwm=%d, target_period_ns=%d (freq=%d), real_period_ns=%d (real_freq=%d), osd=%d, ocd=%d\n",
+		DEV_NAME, hwpwm, target_period_ns, target_freq, real_period_ns, real_freq,
+		pc->clksrc_div[hwpwm], pc->clkout_div[hwpwm]);
+
+	return real_period_ns;
+}
+
+int set_real_freq_by_target_div(struct rtd1295_pwm_chip *pc, int hwpwm, int clksrc_div, int clkout_div) {
+	int base_freq = pc->base_freq;
+	int real_freq, div;
+
+	div = BIT(clksrc_div + 1) * (clkout_div + 1);
+	real_freq = base_freq / div;
+
+	pc->clkout_div[hwpwm] = clkout_div;
+	pc->clksrc_div[hwpwm] = clksrc_div;
+
+	pc->out_freq[hwpwm] = real_freq;
+
+	PWM_DEBUG("%s real_freq=%d, osd=%d, ocd=%d\n",
+			DEV_NAME, pc->out_freq[hwpwm], pc->clksrc_div[hwpwm], pc->clkout_div[hwpwm]);
+
+	return real_freq;
+}
+
+int set_clk_duty(struct rtd1295_pwm_chip *pc, int hwpwm, int duty_rate) {
+	int clkout_div = pc->clkout_div[hwpwm];
+	if (duty_rate < 0) duty_rate = 0;
+	if (duty_rate > 100) duty_rate = 100;
+
+	pc->duty_rate[hwpwm] = duty_rate;
+	pc->clk_duty[hwpwm] = (duty_rate * (clkout_div + 1) / 100) - 1;
+
+	if (pc->clk_duty[hwpwm] < 0) pc->clk_duty[hwpwm] = 0;
+	if (pc->clk_duty[hwpwm] > clkout_div) pc->clk_duty[hwpwm] = clkout_div;
+
+	return 0;
+}
+
+static void pwm_set_register(struct rtd1295_pwm_chip *pc, int hwpwm)
+{
+	u32 value;
+	int clkout_div = 0;
+	int clk_duty = 0;
+	int clksrc_div = 0;
+	if(pc==NULL) {
+		pr_err("%s %s -- parameter error!-- \n", DEV_NAME, __func__);
+		return;
+	}
+
+	if (pc->enable[hwpwm] && pc->duty_rate[hwpwm]) {
+		clkout_div = pc->clkout_div[hwpwm];
+		clk_duty = pc->clk_duty[hwpwm];
+		clksrc_div = pc->clksrc_div[hwpwm];
+	}
+
+	PWM_DEBUG("%s %s -- set index %d OCD=%d,CD=%d,CSD=%d\n",
+		DEV_NAME, __func__, hwpwm, clkout_div, clk_duty, clksrc_div);
+
+	spin_lock(&pc->lock);
+	value = readl(pc->mmio_pwm_reg_base + RTK_ADDR_PWM_OCD);
+	value &= ~(RTK_PWM_OCD_MASK << (hwpwm*RTK_PWM_OCD_SHIFT));
+	value |= clkout_div << (hwpwm*RTK_PWM_OCD_SHIFT);
+	writel(value, pc->mmio_pwm_reg_base + RTK_ADDR_PWM_OCD);
+
+	value = readl(pc->mmio_pwm_reg_base + RTK_ADDR_PWM_CD);
+	value &= ~(RTK_PWM_CD_MASK << (hwpwm*RTK_PWM_CD_SHIFT));
+	value |= clk_duty << (hwpwm*RTK_PWM_CD_SHIFT);
+	writel(value, pc->mmio_pwm_reg_base + RTK_ADDR_PWM_CD);
+
+	value = readl(pc->mmio_pwm_reg_base + RTK_ADDR_PWM_CSD);
+	value &= ~(RTK_PWM_CSD_MASK << (hwpwm*RTK_PWM_CSD_SHIFT));
+	value |= clksrc_div << (hwpwm*RTK_PWM_CSD_SHIFT);
+	writel(value, pc->mmio_pwm_reg_base + RTK_ADDR_PWM_CSD);
+	spin_unlock(&pc->lock);
+
+	PWM_DEBUG("%s %s -- done! \n", DEV_NAME, __func__);
+}
+
+static int rtd1295_pwm_config(struct pwm_chip *chip, struct pwm_device *pwm,
+			    int duty_ns, int period_ns)
+{
+	struct rtd1295_pwm_chip *pc = to_rtd1295_pwm_chip(chip);
+	int real_period_ns, duty_rate;
+
+	PWM_DEBUG("%s %s ---- hwpwm=%d, enable=%d duty_ns=%d period_ns=%d\n",
+		DEV_NAME, __func__, pwm->hwpwm, pc->enable[pwm->hwpwm], duty_ns, period_ns);
+	real_period_ns = set_real_period_by_target_period(pc, pwm->hwpwm, period_ns);
+	duty_rate = duty_ns *100 / period_ns;
+
+	set_clk_duty(pc, pwm->hwpwm, duty_rate);
+
+	pwm_set_register(pc, pwm->hwpwm);
+
+	return 0;
+}
+
+static int rtk_pwm_enable_pins(struct rtd1295_pwm_chip *pwm, int index);
+static void rtk_pwm_disable_pins(struct rtd1295_pwm_chip *pwm, int index);
+
+static int rtd1295_pwm_enable(struct pwm_chip *chip, struct pwm_device *pwm)
+{
+	struct rtd1295_pwm_chip *pc = to_rtd1295_pwm_chip(chip);
+
+	PWM_DEBUG("%s %s ---- hwpwm=%d, enable=%d \n",
+		DEV_NAME, __func__, pwm->hwpwm, pc->enable[pwm->hwpwm]);
+
+	rtk_pwm_enable_pins(pc, pwm->hwpwm);
+
+	pc->enable[pwm->hwpwm] = 1;
+	pwm_set_register(pc, pwm->hwpwm);
+
+	return 0;
+}
+
+static void rtd1295_pwm_disable(struct pwm_chip *chip, struct pwm_device *pwm)
+{
+	struct rtd1295_pwm_chip *pc = to_rtd1295_pwm_chip(chip);
+
+	PWM_DEBUG("%s %s ---- disable PWM[%d] now !\n",
+		DEV_NAME, __func__, pwm->hwpwm);
+	pc->enable[pwm->hwpwm] = 0;
+	pwm_set_register(pc, pwm->hwpwm);
+
+	rtk_pwm_disable_pins(pc, pwm->hwpwm);
+}
+
+static const struct pwm_ops rtd1295_pwm_ops = {
+	.config = rtd1295_pwm_config,
+	.enable = rtd1295_pwm_enable,
+	.disable = rtd1295_pwm_disable,
+	.owner = THIS_MODULE,
+};
+
+/** define show/store API for each file here **/
+static ssize_t pwm_show_dutyRate(struct device *dev, struct device_attribute *attr, char *buf, int hwpwm)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+
+	PWM_DEBUG("%s %s called : hwpwm=%d, dutyRate=> pc->dutyRate=[%d]--- \n",
+		DEV_NAME, __func__, hwpwm, pc->duty_rate[hwpwm]);
+
+	return sprintf(buf, "%d%%\n", pc->duty_rate[hwpwm]);
+}
+
+static ssize_t pwm_store_dutyRate(struct device *dev, struct device_attribute *attr, const char *buf, size_t count, int hwpwm)
+{
+	int value=0;
+	int ret=-1;
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+
+	PWM_DEBUG("%s %s called : hwpwm=%d, count:%ld ",
+		DEV_NAME, __func__, hwpwm, count);
+
+	if( count < 1 ) {
+		pr_err("%s %s , count is too small, return \n",
+			DEV_NAME, __func__);
+		return count;
+	}
+	ret = kstrtoint(buf, 10, &value);
+	if ( ret != 0 ) {
+		pr_err("%s %s , parse buf error! ret=%d \n",
+			DEV_NAME, __func__, ret);
+		return count;
+	}
+	PWM_DEBUG("%s value:[%d] \n", DEV_NAME, value);
+	if( value < 0 || value > 100 ) {
+		pr_err("%s %s  ====  input should between 0 ~ 100 \n",
+			DEV_NAME, __func__);
+		return count;
+	}
+	if( pc->duty_rate[hwpwm] == value ) {
+		pr_err(" %s %s -- dutyRate value is not change, return! \n",
+			DEV_NAME, __func__);
+		return count;
+	}
+	else {
+		pr_err("%s %s -- assign [%d] to duty_rate now! \n",
+			DEV_NAME, __func__, value);
+
+		set_clk_duty(pc, hwpwm, value);
+		pwm_set_register(pc, hwpwm);
+	}
+
+	return count;
+}
+
+static ssize_t pwm_show_enable(struct device *dev, struct device_attribute *attr, char *buf, int hwpwm)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+
+	PWM_DEBUG("%s %s : hwpwm=%d, enable=%d---- \n",
+		DEV_NAME, __func__, hwpwm, pc->enable[hwpwm]);
+
+	return sprintf(buf, "%d\n", pc->enable[hwpwm]);
+}
+
+static ssize_t pwm_store_enable(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count, int hwpwm)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+	int value=0;
+
+	if(buf ==NULL) {
+		pr_err("%s %s	====  buffer is null, return \n",
+			DEV_NAME, __func__);
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	if( pc->enable[hwpwm] == value ) {
+		pr_err("%s %s	====  the same, do nothing (hwpwm=%d, value=%d) \n",
+			DEV_NAME, __func__, hwpwm, value);
+		return count;
+	}
+
+	pc->enable[hwpwm] = value;
+	pwm_set_register(pc, hwpwm);
+
+	PWM_DEBUG("%s %s  ====  done \n",
+		DEV_NAME, __func__);
+	return count;
+}
+
+static ssize_t pwm_show_clksrcDiv(struct device *dev, struct device_attribute *attr, char *buf, int hwpwm)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+
+	PWM_DEBUG("%s %s called : hwpwm=%d, clksrc_div=%d---- \n",
+		DEV_NAME, __func__, hwpwm, pc->clksrc_div[hwpwm]);
+
+	return sprintf(buf, "%d\n", pc->clksrc_div[hwpwm]);
+}
+
+static ssize_t pwm_store_clksrcDiv(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count, int hwpwm)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+
+	int value=0;
+	if(buf ==NULL) {
+		pr_err("%s %s  ====  buffer is null, return \n",
+			DEV_NAME, __func__);
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	if(value < 0 || value > 15) {
+		pr_err("%s %s  ====  input should between 0 ~ 15 \n",
+			DEV_NAME, __func__);
+		return count;
+	}
+
+	if(pc->clksrc_div[hwpwm] == value) {
+		pr_err("%s %s  ====  hwpwm=%d, input is the same=%d, do nothing! \n",
+			DEV_NAME, __func__, hwpwm, value);
+		return count;
+	}
+
+	set_real_freq_by_target_div(pc, hwpwm, value, pc->clkout_div[hwpwm]);
+
+	pwm_set_register(pc, hwpwm);
+
+	PWM_DEBUG("%s %s  ====  done (hwpwm=%d, value=%d) \n",
+		DEV_NAME, __func__, hwpwm, value);
+	return count;
+}
+
+static ssize_t pwm_show_clkoutDiv(struct device *dev, struct device_attribute *attr, char *buf, int hwpwm)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+
+	PWM_DEBUG("%s %s : hwpwm=%d, clkout_div=%d---- \n",
+		DEV_NAME, __func__, hwpwm, pc->clkout_div[hwpwm]);
+
+	return sprintf(buf, "%d\n", pc->clkout_div[hwpwm]);
+}
+
+static ssize_t pwm_store_clkoutDiv(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count, int hwpwm)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+
+	int value=0;
+	if(buf ==NULL) {
+		pr_err("%s %s  ====  buffer is null, return \n",
+			DEV_NAME, __func__);
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	if(value < 0 || value > 255) {
+		pr_err("%s %s  ====  input should between 0 ~ 255 \n",
+			DEV_NAME, __func__);
+		return count;
+	}
+
+	if(pc->clkout_div[hwpwm] == value) {
+		pr_err("%s %s  ====  hwpwm=%d, input is the same=%d, do nothing! \n",
+			DEV_NAME, __func__, hwpwm, value);
+		return count;
+	}
+
+	set_real_freq_by_target_div(pc, hwpwm, pc->clksrc_div[hwpwm], value);
+
+	pwm_set_register(pc, hwpwm);
+
+	PWM_DEBUG("%s %s  ====  done (hwpwm=%d, value=%d) \n",
+		DEV_NAME, __func__, hwpwm, value);
+	return count;
+}
+
+static ssize_t pwm_show_out_freq(struct device *dev, struct device_attribute *attr, char *buf, int hwpwm)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+
+	PWM_DEBUG("%s %s : hwpwm=%d, out_freq=%dHz---- \n",
+		DEV_NAME, __func__, hwpwm, pc->out_freq[hwpwm]);
+
+	return sprintf(buf, "%dHz\n", pc->out_freq[hwpwm]);
+}
+
+static ssize_t pwm_store_out_freq(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count, int hwpwm)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+
+	int value=0;
+	if(buf ==NULL) {
+		pr_err("%s %s  ====  buffer is null, return \n", DEV_NAME, __func__);
+		return count;
+	}
+	sscanf(buf, "%d", &value);
+
+	if(value < 0 || value > 27000000) {
+		pr_err("%s %s  ====  input should between 0 ~ 27MHz \n",
+			DEV_NAME, __func__);
+		return count;
+	}
+
+	if(pc->out_freq[hwpwm] == value) {
+		pr_err("%s %s  ====  hwpwm=%d, input is the same=%d, do nothing! \n",
+			DEV_NAME, __func__, hwpwm, value);
+		return count;
+	}
+
+	set_real_freq_by_target_freq(pc, hwpwm, value);
+
+	/* update CD since OCD is changed */
+	set_clk_duty(pc, hwpwm, pc->duty_rate[hwpwm]);
+
+	pwm_set_register(pc, hwpwm);
+
+	PWM_DEBUG("%s %s  ====  done (hwpwm=%d, value=%d) \n",
+		DEV_NAME, __func__, hwpwm, value);
+	return count;
+}
+
+
+ssize_t pwm_show_dutyRate0(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_dutyRate(dev, attr, buf, 0);
+}
+
+ssize_t pwm_store_dutyRate0(struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+	return pwm_store_dutyRate(dev, attr, buf, count, 0);
+}
+
+ssize_t pwm_show_enable0(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_enable(dev, attr, buf, 0);
+}
+
+ssize_t pwm_store_enable0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_enable(dev, attr, buf, count, 0);
+}
+
+ssize_t pwm_show_clksrcDiv0(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_clksrcDiv(dev, attr, buf, 0);
+}
+
+ssize_t pwm_store_clksrcDiv0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_clksrcDiv(dev, attr, buf, count, 0);
+}
+
+ssize_t pwm_show_clkoutDiv0(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_clkoutDiv(dev, attr, buf, 0);
+}
+
+ssize_t pwm_store_clkoutDiv0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_clkoutDiv(dev, attr, buf, count, 0);
+}
+
+ssize_t pwm_show_out_freq0(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_out_freq(dev, attr, buf, 0);
+}
+
+ssize_t pwm_store_out_freq0(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_out_freq(dev, attr, buf, count, 0);
+}
+
+ssize_t pwm_show_dutyRate1(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_dutyRate(dev, attr, buf, 1);
+}
+
+ssize_t pwm_store_dutyRate1(struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+	return pwm_store_dutyRate(dev, attr, buf, count, 1);
+}
+
+ssize_t pwm_show_enable1(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_enable(dev, attr, buf, 1);
+}
+
+ssize_t pwm_store_enable1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_enable(dev, attr, buf, count, 1);
+}
+
+ssize_t pwm_show_clksrcDiv1(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_clksrcDiv(dev, attr, buf, 1);
+}
+
+ssize_t pwm_store_clksrcDiv1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_clksrcDiv(dev, attr, buf, count, 1);
+}
+
+ssize_t pwm_show_clkoutDiv1(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_clkoutDiv(dev, attr, buf, 1);
+}
+
+ssize_t pwm_store_clkoutDiv1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_clkoutDiv(dev, attr, buf, count, 1);
+}
+
+ssize_t pwm_show_out_freq1(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_out_freq(dev, attr, buf, 1);
+}
+
+ssize_t pwm_store_out_freq1(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_out_freq(dev, attr, buf, count, 1);
+}
+
+ssize_t pwm_show_dutyRate2(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_dutyRate(dev, attr, buf, 2);
+}
+
+ssize_t pwm_store_dutyRate2(struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+	return pwm_store_dutyRate(dev, attr, buf, count, 2);
+}
+
+ssize_t pwm_show_enable2(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_enable(dev, attr, buf, 2);
+}
+
+ssize_t pwm_store_enable2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_enable(dev, attr, buf, count, 2);
+}
+
+ssize_t pwm_show_clksrcDiv2(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_clksrcDiv(dev, attr, buf, 2);
+}
+
+ssize_t pwm_store_clksrcDiv2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_clksrcDiv(dev, attr, buf, count, 2);
+}
+
+ssize_t pwm_show_clkoutDiv2(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_clkoutDiv(dev, attr, buf, 2);
+}
+
+ssize_t pwm_store_clkoutDiv2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_clkoutDiv(dev, attr, buf, count, 2);
+}
+
+ssize_t pwm_show_out_freq2(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_out_freq(dev, attr, buf, 2);
+}
+
+ssize_t pwm_store_out_freq2(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_out_freq(dev, attr, buf, count, 2);
+}
+
+ssize_t pwm_show_dutyRate3(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_dutyRate(dev, attr, buf, 3);
+}
+
+ssize_t pwm_store_dutyRate3(struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+	return pwm_store_dutyRate(dev, attr, buf, count, 3);
+}
+
+ssize_t pwm_show_enable3(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_enable(dev, attr, buf, 3);
+}
+
+ssize_t pwm_store_enable3(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_enable(dev, attr, buf, count, 3);
+}
+
+ssize_t pwm_show_clksrcDiv3(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_clksrcDiv(dev, attr, buf, 3);
+}
+
+ssize_t pwm_store_clksrcDiv3(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_clksrcDiv(dev, attr, buf, count, 3);
+}
+
+ssize_t pwm_show_clkoutDiv3(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_clkoutDiv(dev, attr, buf, 3);
+}
+
+ssize_t pwm_store_clkoutDiv3(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_clkoutDiv(dev, attr, buf, count, 3);
+}
+
+ssize_t pwm_show_out_freq3(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	return pwm_show_out_freq(dev, attr, buf, 3);
+}
+
+ssize_t pwm_store_out_freq3(struct device *dev, struct device_attribute *attr,
+			 const char *buf, size_t count)
+{
+	return pwm_store_out_freq(dev, attr, buf, count, 3);
+}
+
+static int rtk_pwm_enable_pins(struct rtd1295_pwm_chip *pwm, int index)
+{
+	struct pwm_child_dev *child;
+	int ret;
+
+	if (index >= NUM_PWM)
+		return -EINVAL;
+
+	child = &pwm->childs[index];
+	if (!child->pin)
+		return 0;
+
+	ret = pinctrl_select_state(child->pin, child->enable_state);
+	if (ret) {
+		dev_err(&child->dev, "failed to select pin state: %d\n", ret);
+		return ret;
+	}
+
+	return 0;
+}
+
+static void rtk_pwm_disable_pins(struct rtd1295_pwm_chip *pwm, int index)
+{
+	struct pwm_child_dev *child;
+	int ret;
+
+	if (index >= NUM_PWM)
+		return;
+
+	child = &pwm->childs[index];
+	if (!child->pin)
+		return;
+
+	ret = pinctrl_select_state(child->pin, child->disable_state);
+	if (ret) {
+		dev_err(&child->dev, "failed to select pin state: %d\n", ret);
+		return;
+	}
+}
+
+static int rtk_pwm_child_dev_init_pinctrl(struct pwm_child_dev *child)
+{
+	char state_name[40];
+	struct device *dev = &child->dev;
+	struct device_node *np = dev->of_node;
+
+	child->pin = devm_pinctrl_get(&child->dev);
+	if (IS_ERR(child->pin)) {
+		dev_warn(dev, "failed to get pinctrl: %ld\n", PTR_ERR(child->pin));
+		child->pin = NULL;
+		return 0;
+	}
+
+	if (of_property_read_u32(np, "default-loc", &child->loc))
+		child->loc = 0;
+
+	sprintf(state_name, "loc-%d-enable", child->loc);
+	child->enable_state = pinctrl_lookup_state(child->pin, state_name);
+	if (IS_ERR(child->enable_state)) {
+		dev_warn(dev, "failed to get pin_state %s: %ld\n", state_name, PTR_ERR(child->enable_state));
+		goto put_pinctrl;
+	}
+
+	sprintf(state_name, "loc-%d-disable", child->loc);
+	child->disable_state = pinctrl_lookup_state(child->pin, state_name);
+	if (IS_ERR(child->disable_state)) {
+		dev_warn(dev, "failed to get pin_state %s: %ld\n", state_name, PTR_ERR(child->disable_state));
+		goto put_pinctrl;
+	}
+	return 0;
+
+put_pinctrl:
+	devm_pinctrl_put(child->pin);
+	child->pin = NULL;
+	return 0;
+}
+
+static int rtk_pwm_create_subdevices(struct rtd1295_pwm_chip *pwm)
+{
+	char name[40];
+	struct pwm_child_dev *child;
+	struct device_node *pp, *cp;
+	int i = 0;
+	int err;
+
+	pp = pwm->dev->of_node;
+	for_each_child_of_node(pp, cp) {
+		int index = i;
+
+		if (WARN_ON(i >= NUM_PWM))
+			continue;
+
+		child = &pwm->childs[index];
+		i++;
+
+		sprintf(name, "%s.%d", dev_name(pwm->dev), index);
+		child->dev.of_node = cp;
+		child->dev.init_name = name;
+		child->dev.parent = pwm->dev;
+		err = device_register(&child->dev);
+		if (err) {
+			pr_warn("%s.%d: failed to register device: %d\n",
+				dev_name(pwm->dev), index, err);
+			continue;
+		}
+
+		child->dev_registered = 1;
+		rtk_pwm_child_dev_init_pinctrl(child);
+	}
+
+	return 0;
+}
+
+static void rtk_pwm_destroy_subdevices(struct rtd1295_pwm_chip *pwm)
+{
+	struct pwm_child_dev *child;
+	int i;
+
+	for (i = 0; i < NUM_PWM; i++) {
+		child = &pwm->childs[i];
+
+		if (!child->dev_registered)
+			continue;
+		device_unregister(&child->dev);
+	}
+}
+
+static int rtd1295_pwm_probe(struct platform_device *pdev)
+{
+	struct rtd1295_pwm_chip *pwm;
+	struct device_node *node = pdev->dev.of_node;
+	struct device_node *pwm0, *pwm1, *pwm2, *pwm3;
+	int ret=0;
+	u32 val=0;
+	int i;
+
+	PWM_DEBUG("%s %s ---- \n", DEV_NAME, __func__);
+
+	pwm = devm_kzalloc(&pdev->dev, sizeof(*pwm), GFP_KERNEL);
+	if (!pwm) {
+		dev_err(&pdev->dev, "failed to allocate memory\n");
+		return -ENOMEM;
+	}
+	pwm->proc_id = pdev->id;
+	pwm->dev = &pdev->dev;
+
+	platform_set_drvdata(pdev, pwm);
+
+	pwm->mmio_pwm_reg_base = of_iomap(node, 0);
+
+	spin_lock_init(&pwm->lock);
+
+	pwm->base_freq = 27000000;
+	for (i=0; i<NUM_PWM; i++) {
+		pwm->out_freq[i] = 0;
+		pwm->enable[i] = 0;
+		pwm->clkout_div[i] = RTK_PWM_OCD_MASK;
+		pwm->clksrc_div[i] = RTK_PWM_CD_DEFAULT;
+		pwm->clk_duty[i] = RTK_PWM_CSD_DEFAULT;
+		pwm->duty_rate[i] = 0;
+	}
+
+	pwm0 = of_get_child_by_name(node, "pwm_0");
+	if (!pwm0) {
+		dev_err(&pdev->dev, "could not find [pwm_0] sub-node\n");
+		return -EINVAL;
+	}
+
+	pwm1 = of_get_child_by_name(node, "pwm_1");
+	if (!pwm1) {
+		dev_err(&pdev->dev, "could not find [pwm_1] sub-node\n");
+		return -EINVAL;
+	}
+
+	pwm2 = of_get_child_by_name(node, "pwm_2");
+	if (!pwm2) {
+		dev_err(&pdev->dev, "could not find [pwm_2] sub-node\n");
+		return -EINVAL;
+	}
+
+	pwm3 = of_get_child_by_name(node, "pwm_3");
+	if (!pwm3) {
+		dev_err(&pdev->dev, "could not find [pwm_3] sub-node\n");
+		return -EINVAL;
+	}
+
+	/* PWM0 */
+	if (!of_property_read_u32(pwm0, "clkout_div", &val))
+		pwm->clkout_div[0] = val;
+
+	if (!of_property_read_u32(pwm0, "clksrc_div", &val))
+		pwm->clksrc_div[0] = val;
+
+	set_real_freq_by_target_div(pwm, 0, pwm->clksrc_div[0], pwm->clkout_div[0]);
+
+	if (!of_property_read_u32(pwm0, "enable", &val))
+		pwm->enable[0] = val;
+
+	if(!of_property_read_u32(pwm0, "duty_rate", &val))
+		set_clk_duty(pwm, 0, val);
+
+	pr_info("%s %s - hwpwm=(%d) enable=(%d) duty_rate=(%d) clksrc_div=(%d) clkout_div=(%d)---  \n",
+		DEV_NAME, __func__, 0, pwm->enable[0], pwm->duty_rate[0], pwm->clksrc_div[0], pwm->clkout_div[0]);
+	pr_info("%s %s - defualt output frequence = %dHz ---  \n",
+		DEV_NAME, __func__, pwm->out_freq[0]);
+
+	/* PWM1 */
+	if (!of_property_read_u32(pwm1, "clkout_div", &val))
+		pwm->clkout_div[1] = val;
+
+	if (!of_property_read_u32(pwm1, "clksrc_div", &val))
+		pwm->clksrc_div[1] = val;
+
+	set_real_freq_by_target_div(pwm, 1, pwm->clksrc_div[1], pwm->clkout_div[1]);
+
+	if (!of_property_read_u32(pwm1, "enable", &val))
+		pwm->enable[1] = val;
+
+	if(!of_property_read_u32(pwm1, "duty_rate", &val))
+		set_clk_duty(pwm, 1, val);
+
+	pr_info("%s %s - hwpwm=(%d) enable=(%d) duty_rate=(%d) clksrc_div=(%d) clkout_div=(%d)---  \n",
+		DEV_NAME, __func__, 1, pwm->enable[1], pwm->duty_rate[1], pwm->clksrc_div[1], pwm->clkout_div[1]);
+	pr_info("%s %s - defualt output frequence = %dHz ---  \n",
+		DEV_NAME, __func__, pwm->out_freq[1]);
+
+	/* PWM2 */
+	if (!of_property_read_u32(pwm2, "clkout_div", &val))
+		pwm->clkout_div[2] = val;
+
+	if (!of_property_read_u32(pwm2, "clksrc_div", &val))
+		pwm->clksrc_div[2] = val;
+
+	set_real_freq_by_target_div(pwm, 2, pwm->clksrc_div[2], pwm->clkout_div[2]);
+
+	if (!of_property_read_u32(pwm2, "enable", &val))
+		pwm->enable[2] = val;
+
+	if(!of_property_read_u32(pwm2, "duty_rate", &val))
+		set_clk_duty(pwm, 2, val);
+
+	pr_info("%s %s - hwpwm=(%d) enable=(%d) duty_rate=(%d) clksrc_div=(%d) clkout_div=(%d)---  \n",
+		DEV_NAME, __func__, 2, pwm->enable[2], pwm->duty_rate[2], pwm->clksrc_div[2], pwm->clkout_div[2]);
+	pr_info("%s %s - defualt output frequence = %dHz ---  \n",
+		DEV_NAME, __func__, pwm->out_freq[2]);
+
+	/* PWM3 */
+	if (!of_property_read_u32(pwm3, "clkout_div", &val))
+		pwm->clkout_div[3] = val;
+
+	if (!of_property_read_u32(pwm3, "clksrc_div", &val))
+		pwm->clksrc_div[3] = val;
+
+	set_real_freq_by_target_div(pwm, 3, pwm->clksrc_div[3], pwm->clkout_div[3]);
+
+	if (!of_property_read_u32(pwm3, "enable", &val))
+		pwm->enable[3] = val;
+
+	if(!of_property_read_u32(pwm3, "duty_rate", &val))
+		set_clk_duty(pwm, 3, val);
+
+	pr_info("%s %s - hwpwm=(%d) enable=(%d) duty_rate=(%d) clksrc_div=(%d) clkout_div=(%d)---  \n",
+		DEV_NAME, __func__, 3, pwm->enable[3], pwm->duty_rate[3], pwm->clksrc_div[3], pwm->clkout_div[3]);
+	pr_info("%s %s - defualt output frequence = %dHz ---  \n",
+		DEV_NAME, __func__, pwm->out_freq[3]);
+
+	pwm->chip.dev = &pdev->dev;
+	pwm->chip.ops = &rtd1295_pwm_ops;
+	pwm->chip.base = 0; // -1;
+	pwm->chip.npwm = NUM_PWM;
+	pwm->chip.can_sleep = true;
+
+	ret = sysfs_create_group(&pdev->dev.kobj, &pwm_dev_attr_group);
+	if (ret < 0) {
+		dev_err(&pdev->dev, "sysfs_create_group() failed: %d\n", ret);
+		return ret;
+	}
+
+	rtk_pwm_create_subdevices(pwm);
+
+	ret = pwmchip_add(&pwm->chip);
+	if (ret < 0) {
+		dev_err(&pdev->dev, "pwmchip_add() failed: %d\n", ret);
+		sysfs_remove_group(&pdev->dev.kobj, &pwm_dev_attr_group);
+		return ret;
+	}
+
+	for (i=0; i<NUM_PWM; i++)
+		pwm_set_register(pwm, i);
+
+	PWM_DEBUG("%s %s --  done! !\n", DEV_NAME, __func__);
+
+	return 0;
+}
+
+static int rtd1295_pwm_remove(struct platform_device *pdev)
+{
+	struct rtd1295_pwm_chip *pc = platform_get_drvdata(pdev);
+	int i;
+
+	rtk_pwm_destroy_subdevices(pc);
+
+	for (i=0; i<NUM_PWM; i++) {
+		pc->enable[i] = 0;
+		pwm_set_register(pc, i);
+	}
+	sysfs_remove_group(&pdev->dev.kobj, &pwm_dev_attr_group);
+
+	PWM_DEBUG("%s %s ---- \n", DEV_NAME, __func__);
+
+	return pwmchip_remove(&pc->chip);
+}
+
+static const struct of_device_id rtd1295_pwm_of_match[] = {
+	{ .compatible = "Realtek,rtd1295-pwm" },
+	{ }
+};
+MODULE_DEVICE_TABLE(of, rtd1295_pwm_of_match);
+
+static struct platform_driver rtd1295_pwm_platform_driver = {
+	.driver = {
+		.name		= "pwm",
+		.owner		= THIS_MODULE,
+		.of_match_table = of_match_ptr(rtd1295_pwm_of_match),
+	},
+	.probe = rtd1295_pwm_probe,
+	.remove = rtd1295_pwm_remove,
+};
+module_platform_driver(rtd1295_pwm_platform_driver);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("REALTEK Corporation");
+MODULE_ALIAS("platform:rtd1295-pwm");
diff --git a/drivers/regulator/Kconfig b/drivers/regulator/Kconfig
index 936f7cc..05c47a2 100644
--- a/drivers/regulator/Kconfig
+++ b/drivers/regulator/Kconfig
@@ -878,5 +878,97 @@ config REGULATOR_WM8994
 	  This driver provides support for the voltage regulators on the
 	  WM8994 CODEC.
 
+config REGULATOR_G22XX_CORE
+	tristate
+	help
+	  GMT G2227/G2237 common codes
+
+config REGULATOR_G2227
+	tristate "GMT G2227 Power regulators"
+	depends on MFD_G2227_I2C
+	select REGULATOR_G22XX_CORE
+	help
+	  This driver provides support for the voltage regulators on the
+	  GMT G2227 PMIC.
+
+config REGULATOR_G2237
+	tristate "GMT G2237 Power regulators"
+	depends on MFD_G2237_I2C
+	select REGULATOR_G22XX_CORE
+	help
+	  This driver provides support for the voltage regulators on the
+	  GMT G2237 PMIC.
+
+config REGULATOR_REALTEK_PWM
+	tristate "Realtek Generic PWM Regulator Driver"
+	depends on PWM
+	help
+	  This driver provides support for a simple PMW voltage regulator
+
+config REGULATOR_RTKGPIO
+	tristate "RTK GPIO Power regulators"
+	help
+	  This driver provides support for the voltage regulators on the
+	  RTK GPIO REGULATOR.
+
+config REGULATOR_SY8827E
+	tristate "SILERGY SY8827E Power regulator"
+	depends on I2C
+	select RTK_REGMAP_I2C
+	help
+	  This driver provides support for the voltage regulators on the
+	  Silergy SY8827E.
+
+config REGULATOR_APW888X_CORE
+	tristate
+
+config REGULATOR_APW8889
+	tristate "ANPEC APW8889 Power regulators"
+	depends on MFD_APW8889_I2C
+	select REGULATOR_APW888X_CORE
+	help
+	  This driver provides support for the voltage regulators on the
+	  Anpec APW8889.
+
+config REGULATOR_APW8886
+	tristate "ANPEC APW8886 Power regulators"
+	depends on MFD_APW8886_I2C
+	select REGULATOR_APW888X_CORE
+	help
+	  This driver provides support for the voltage regulators on the
+	  Anpec APW8886.
+
+config REGULATOR_I2C_SELECTOR
+	tristate "I2C selector regualtors"
+	select MFD_APW8889_I2C
+	select REGULATOR_APW8889
+	select MFD_G2237_I2C
+	select REGULATOR_G2237
+
+config XEN_REGDEV_FRONTEND
+	tristate "Xen regulator device frontend driver"
+	depends on XEN
+	select XEN_XENBUS_FRONTEND
+	default y
+	help
+	  This driver implements the front-end of the Xen virtual regulator
+	  device driver. It communicates with a back-end driver in another
+	  domain which drives the actual regulator device.
+
+config XEN_REGDEV_BACKEND
+	tristate "Xen backend regulator device"
+	depends on XEN_BACKEND
+	help
+	  The regulator-device backend driver allows the kernel to export its
+	  regulator devices to other guests via a high-performance shared-memory
+	  interface. The corresponding Linux frontend driver is enabled by the
+	  XEN_REGDEV_FRONTEND configuration option.
+
+config REGULATOR_RTD119X_GPIO
+	tristate "Realtek RTD-119x GPIO regulators"
+	help
+	  This driver provides support for the voltage regulator on the
+	  RTD-119x Platform.
+
 endif
 
diff --git a/drivers/regulator/Makefile b/drivers/regulator/Makefile
index 2142a5d..8cfc6bc 100644
--- a/drivers/regulator/Makefile
+++ b/drivers/regulator/Makefile
@@ -112,6 +112,18 @@ obj-$(CONFIG_REGULATOR_WM831X) += wm831x-ldo.o
 obj-$(CONFIG_REGULATOR_WM8350) += wm8350-regulator.o
 obj-$(CONFIG_REGULATOR_WM8400) += wm8400-regulator.o
 obj-$(CONFIG_REGULATOR_WM8994) += wm8994-regulator.o
-
-
+obj-$(CONFIG_REGULATOR_G22XX_CORE) += g22xx-regulator-core.o
+obj-$(CONFIG_REGULATOR_G2227) += g2227-regulator.o
+obj-$(CONFIG_REGULATOR_G2237) += g2237-regulator.o
+obj-$(CONFIG_REGULATOR_RTKGPIO) += rtkgpio-regulator.o
+obj-$(CONFIG_REGULATOR_REALTEK_PWM) += rtk-pwm-regulator.o
+obj-$(CONFIG_REGULATOR_SY8827E) += sy8827e-regulator.o
+obj-$(CONFIG_REGULATOR_APW888X_CORE) += apw888x-regulator-core.o
+obj-$(CONFIG_REGULATOR_APW8889) += apw8889-regulator.o
+obj-$(CONFIG_REGULATOR_APW8886) += apw8886-regulator.o
+obj-$(CONFIG_XEN_REGDEV_FRONTEND) += xen-regfront.o
+obj-$(CONFIG_XEN_REGDEV_BACKEND) += xen-regback/
+obj-$(CONFIG_REGULATOR_RTD119X_GPIO) += rtd119x-gpio-regulator.o
 ccflags-$(CONFIG_REGULATOR_DEBUG) += -DDEBUG
+
+obj-$(CONFIG_REGULATOR_I2C_SELECTOR) += i2c-selector.o
diff --git a/drivers/regulator/apw8886-regulator.c b/drivers/regulator/apw8886-regulator.c
new file mode 100644
index 00000000..59ff567
--- /dev/null
+++ b/drivers/regulator/apw8886-regulator.c
@@ -0,0 +1,222 @@
+/*
+ * apw8886-regulator.c - Anpec APW8886 Regulator sriver
+ *
+ * Copyright (C) 2018-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/platform_device.h>
+#include <linux/module.h>
+#include <linux/list.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/regmap.h>
+#include <linux/suspend.h>
+#include <linux/mfd/apw888x.h>
+#include <linux/mfd/apw8886.h>
+#include "apw888x-regulator.h"
+
+/* regulator id */
+enum {
+	APW8886_ID_DC1 = 0,
+	APW8886_ID_DC2,
+	APW8886_ID_DC3,
+	APW8886_ID_DC4,
+	APW8886_ID_DC5,
+	APW8886_ID_LDO1,
+	APW8886_ID_MAX
+};
+
+#define APW8886_DESC(_id, _name, _min_uV, _uV_step, _n_volt, _type)\
+{                                                                  \
+	.desc = {                                                  \
+		.owner       = THIS_MODULE,                        \
+		.type        = REGULATOR_VOLTAGE,                  \
+		.ops         = &apw888x_regulator_ops,             \
+		.name        = _name,                              \
+		.of_match    = _name,                              \
+		.n_voltages  = _n_volt,                            \
+		.min_uV      = _min_uV,                            \
+		.uV_step     = _uV_step,                           \
+		.id          = APW8886_ID_ ## _id,                 \
+		.vsel_reg    = APW8886_REG_ ## _id ## _NRMVOLT,    \
+		.vsel_mask   = APW8886_ ## _id ## _NRMVOLT_MASK,   \
+		.enable_reg  = APW8886_REG_ONOFF,                  \
+		.enable_mask = APW8886_ ## _id ## _ON_MASK,        \
+		.enable_val  = APW8886_ ## _id ## _ON_MASK,        \
+		.of_parse_cb = apw888x_regulator_of_parse_cb,      \
+		.of_map_mode = apw888x_regulator_ ## _type ##_of_map_mode, \
+	},                                                         \
+	.nmode_reg  = APW8886_REG_ ## _id ## _MODE,                \
+	.nmode_mask = APW8886_ ## _id ## _NRMMODE_MASK,            \
+	.smode_reg  = APW8886_REG_ ## _id ## _MODE,                \
+	.smode_mask = APW8886_ ## _id ## _SLPMODE_MASK,            \
+	.svsel_reg  = APW8886_REG_ ## _id ## _SLPVOLT,             \
+	.svsel_mask = APW8886_ ## _id ## _SLPVOLT_MASK,            \
+}
+
+#define APW8886_DESC_CLP(_id, _name, _min_uV, _uV_step, _n_volt, _type) \
+{                                                                  \
+	.desc = {                                                  \
+		.owner       = THIS_MODULE,                        \
+		.type        = REGULATOR_VOLTAGE,                  \
+		.ops         = &apw888x_regulator_ops,             \
+		.name        = _name,                              \
+		.of_match    = _name,                              \
+		.n_voltages  = _n_volt,                            \
+		.min_uV      = _min_uV,                            \
+		.uV_step     = _uV_step,                           \
+		.id          = APW8886_ID_ ## _id,                 \
+		.vsel_reg    = APW8886_REG_ ## _id ## _NRMVOLT,    \
+		.vsel_mask   = APW8886_ ## _id ## _NRMVOLT_MASK,   \
+		.enable_reg  = APW8886_REG_ONOFF,                  \
+		.enable_mask = APW8886_ ## _id ## _ON_MASK,        \
+		.enable_val  = APW8886_ ## _id ## _ON_MASK,        \
+		.of_parse_cb = apw888x_regulator_of_parse_cb,      \
+		.of_map_mode = apw888x_regulator_ ## _type ##_of_map_mode, \
+	},                                                         \
+	.nmode_reg  = APW8886_REG_ ## _id ## _MODE,                \
+	.nmode_mask = APW8886_ ## _id ## _NRMMODE_MASK,            \
+	.smode_reg  = APW8886_REG_ ## _id ## _MODE,                \
+	.smode_mask = APW8886_ ## _id ## _SLPMODE_MASK,            \
+	.svsel_reg  = APW8886_REG_ ## _id ## _SLPVOLT,             \
+	.svsel_mask = APW8886_ ## _id ## _SLPVOLT_MASK,            \
+	.clamp_reg  = APW8886_REG_CLAMP,                           \
+	.clamp_mask = APW8886_ ## _id ## _CLAMP_MASK,              \
+}
+
+#define APW8886_DESC_FIXED_UV(_id, _name, _fixed_uV)               \
+{                                                                  \
+	.desc = {                                                  \
+		.owner       = THIS_MODULE,                        \
+		.type        = REGULATOR_VOLTAGE,                  \
+		.ops         = &apw888x_regulator_fixed_uV_ops,    \
+		.name        = _name,                              \
+		.of_match    = _name,                              \
+		.n_voltages  = 1,                                  \
+		.fixed_uV    = _fixed_uV,                          \
+		.id          = APW8886_ID_ ## _id,                 \
+		.enable_reg  = APW8886_REG_ONOFF,                  \
+		.enable_mask = APW8886_ ## _id ## _ON_MASK,        \
+		.enable_val  = APW8886_ ## _id ## _ON_MASK,        \
+		.of_parse_cb = apw888x_regulator_of_parse_cb,      \
+		.of_map_mode = apw888x_regulator_dc_of_map_mode,   \
+	},                                                         \
+	.nmode_reg  = APW8886_REG_ ## _id ## _MODE,                \
+	.nmode_mask = APW8886_ ## _id ## _NRMMODE_MASK,            \
+	.smode_reg  = APW8886_REG_ ## _id ## _MODE,                \
+	.smode_mask = APW8886_ ## _id ## _SLPMODE_MASK,            \
+}
+
+static struct apw888x_regulator_desc desc[] = {
+	[APW8886_ID_DC1]  = APW8886_DESC(DC1, "dc1", 2200000, 25000, 64, dc),
+	[APW8886_ID_DC2]  = APW8886_DESC_CLP(DC2, "dc2", 550000, 12500, 64, dc),
+	[APW8886_ID_DC3]  = APW8886_DESC_CLP(DC3, "dc3", 550000, 12500, 64, dc),
+	[APW8886_ID_DC4]  = APW8886_DESC(DC4, "dc4", 800000, 20000, 64, dc),
+	[APW8886_ID_DC5]  = APW8886_DESC_FIXED_UV(DC5, "dc5", 0),
+	[APW8886_ID_LDO1] = APW8886_DESC(LDO1, "ldo1", 1780000, 40000, 32, ldo),
+};
+
+/* pm */
+static int apw8886_regulator_suspend(struct device *dev)
+{
+	struct apw888x_regulator_data *pos;
+	struct apw888x_regulator_device *ardev = dev_get_drvdata(dev);
+
+#ifdef CONFIG_SUSPEND
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY)
+		goto done;
+#endif
+
+	dev_info(dev, "Enter %s\n", __func__);
+	list_for_each_entry(pos, &ardev->list, list)
+		apw888x_prepare_suspend_state(pos->rdev, 0);
+	regulator_suspend_prepare(PM_SUSPEND_MEM);
+	dev_info(dev, "Exit %s\n", __func__);
+done:
+	return 0;
+}
+
+static const struct dev_pm_ops apw8886_regulator_pm_ops = {
+	.suspend = apw8886_regulator_suspend,
+};
+
+static int apw8886_regulator_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct apw888x_device *adev = dev_get_drvdata(dev->parent);
+	struct apw888x_regulator_device *ardev;
+	int i, ret;
+
+	ardev = devm_kzalloc(dev, sizeof(*ardev), GFP_KERNEL);
+	if (!ardev)
+		return -ENOMEM;
+	ardev->dev = dev;
+	INIT_LIST_HEAD(&ardev->list);
+	ardev->regmap = adev->regmap;
+
+	for (i = 0; i < ARRAY_SIZE(desc); i++) {
+		ret = apw888x_regulator_register(ardev, &desc[i]);
+		if (ret) {
+			dev_err(dev, "Failed to register %s: %d\n",
+				desc[i].desc.name, ret);
+			return ret;
+		}
+	}
+
+	platform_set_drvdata(pdev, ardev);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static void apw8886_regulator_shutdown(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct apw888x_regulator_device *ardev = platform_get_drvdata(pdev);
+	struct apw888x_regulator_data *pos;
+
+	dev_info(dev, "Enter %s\n", __func__);
+	list_for_each_entry(pos, &ardev->list, list)
+		apw888x_prepare_suspend_state(pos->rdev, 1);
+	regulator_suspend_prepare(PM_SUSPEND_MEM);
+	dev_info(dev, "Exit %s\n", __func__);
+}
+
+static const struct of_device_id apw8886_regulator_ids[] = {
+	{ .compatible = "anpec,apw8886-regulator", },
+	{}
+};
+MODULE_DEVICE_TABLE(of, apw8886_regulator_ids);
+
+static struct platform_driver apw8886_regulator_driver = {
+	.driver = {
+		.name = "apw8886-regulator",
+		.owner = THIS_MODULE,
+		.pm = &apw8886_regulator_pm_ops,
+		.of_match_table = apw8886_regulator_ids,
+	},
+	.probe    = apw8886_regulator_probe,
+	.shutdown = apw8886_regulator_shutdown,
+};
+module_platform_driver(apw8886_regulator_driver);
+
+MODULE_DESCRIPTION("Anpec APW8886 Regulator Driver");
+MODULE_AUTHOR("Cheng-Yu Lee <cylee12@realtek.com>");
+MODULE_LICENSE("GPL");
+
+
diff --git a/drivers/regulator/apw8889-regulator.c b/drivers/regulator/apw8889-regulator.c
new file mode 100644
index 00000000..d34ce5f
--- /dev/null
+++ b/drivers/regulator/apw8889-regulator.c
@@ -0,0 +1,237 @@
+/*
+ * apw8889-regulator.c - Anpec APW8889 Regulator sriver
+ *
+ * Copyright (C) 2018-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/platform_device.h>
+#include <linux/module.h>
+#include <linux/list.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/regmap.h>
+#include <linux/suspend.h>
+#include <linux/mfd/apw888x.h>
+#include <linux/mfd/apw8889.h>
+#include "apw888x-regulator.h"
+
+/* regulator id */
+enum {
+	APW8889_ID_DC1 = 0,
+	APW8889_ID_DC2,
+	APW8889_ID_DC3,
+	APW8889_ID_DC4,
+	APW8889_ID_DC5,
+	APW8889_ID_DC6,
+	APW8889_ID_LDO1,
+	APW8889_ID_MAX
+};
+
+#define APW8889_DESC(_id, _name, _min_uV, _uV_step, _n_volt, _type)\
+{                                                                  \
+	.desc = {                                                  \
+		.owner       = THIS_MODULE,                        \
+		.type        = REGULATOR_VOLTAGE,                  \
+		.ops         = &apw888x_regulator_ops,             \
+		.name        = _name,                              \
+		.of_match    = _name,                              \
+		.n_voltages  = _n_volt,                            \
+		.min_uV      = _min_uV,                            \
+		.uV_step     = _uV_step,                           \
+		.id          = APW8889_ID_ ## _id,                 \
+		.vsel_reg    = APW8889_REG_ ## _id ## _NRMVOLT,    \
+		.vsel_mask   = APW8889_ ## _id ## _NRMVOLT_MASK,   \
+		.enable_reg  = APW8889_REG_ONOFF,                  \
+		.enable_mask = APW8889_ ## _id ## _ON_MASK,        \
+		.enable_val  = APW8889_ ## _id ## _ON_MASK,        \
+		.of_parse_cb = apw888x_regulator_of_parse_cb,      \
+		.of_map_mode = apw888x_regulator_ ## _type ##_of_map_mode, \
+	},                                                         \
+	.nmode_reg  = APW8889_REG_ ## _id ## _MODE,                \
+	.nmode_mask = APW8889_ ## _id ## _NRMMODE_MASK,            \
+	.smode_reg  = APW8889_REG_ ## _id ## _MODE,                \
+	.smode_mask = APW8889_ ## _id ## _SLPMODE_MASK,            \
+	.svsel_reg  = APW8889_REG_ ## _id ## _SLPVOLT,             \
+	.svsel_mask = APW8889_ ## _id ## _SLPVOLT_MASK,            \
+	.dischg_reg = APW8889_REG_DISCHG,                          \
+	.dischg_mask = APW8889_ ## _id ## _DISCHG_MASK,            \
+}
+
+#define APW8889_DESC_CLP(_id, _name, _min_uV, _uV_step, _n_volt, _type) \
+{                                                                  \
+	.desc = {                                                  \
+		.owner       = THIS_MODULE,                        \
+		.type        = REGULATOR_VOLTAGE,                  \
+		.ops         = &apw888x_regulator_ops,             \
+		.name        = _name,                              \
+		.of_match    = _name,                              \
+		.n_voltages  = _n_volt,                            \
+		.min_uV      = _min_uV,                            \
+		.uV_step     = _uV_step,                           \
+		.id          = APW8889_ID_ ## _id,                 \
+		.vsel_reg    = APW8889_REG_ ## _id ## _NRMVOLT,    \
+		.vsel_mask   = APW8889_ ## _id ## _NRMVOLT_MASK,   \
+		.enable_reg  = APW8889_REG_ONOFF,                  \
+		.enable_mask = APW8889_ ## _id ## _ON_MASK,        \
+		.enable_val  = APW8889_ ## _id ## _ON_MASK,        \
+		.of_parse_cb = apw888x_regulator_of_parse_cb,      \
+		.of_map_mode = apw888x_regulator_ ## _type ##_of_map_mode, \
+	},                                                         \
+	.nmode_reg  = APW8889_REG_ ## _id ## _MODE,                \
+	.nmode_mask = APW8889_ ## _id ## _NRMMODE_MASK,            \
+	.smode_reg  = APW8889_REG_ ## _id ## _MODE,                \
+	.smode_mask = APW8889_ ## _id ## _SLPMODE_MASK,            \
+	.svsel_reg  = APW8889_REG_ ## _id ## _SLPVOLT,             \
+	.svsel_mask = APW8889_ ## _id ## _SLPVOLT_MASK,            \
+	.clamp_reg  = APW8889_REG_CLAMP,                           \
+	.clamp_mask = APW8889_ ## _id ## _CLAMP_MASK,              \
+	.dischg_reg = APW8889_REG_DISCHG,                          \
+	.dischg_mask = APW8889_ ## _id ## _DISCHG_MASK,            \
+}
+
+#define APW8889_DESC_FIXED_UV(_id, _name, _fixed_uV)               \
+{                                                                  \
+	.desc = {                                                  \
+		.owner       = THIS_MODULE,                        \
+		.type        = REGULATOR_VOLTAGE,                  \
+		.ops         = &apw888x_regulator_fixed_uV_ops,    \
+		.name        = _name,                              \
+		.of_match    = _name,                              \
+		.n_voltages  = 1,                                  \
+		.fixed_uV    = _fixed_uV,                          \
+		.id          = APW8889_ID_ ## _id,                 \
+		.enable_reg  = APW8889_REG_ONOFF,                  \
+		.enable_mask = APW8889_ ## _id ## _ON_MASK,        \
+		.enable_val  = APW8889_ ## _id ## _ON_MASK,        \
+		.of_parse_cb = apw888x_regulator_of_parse_cb,      \
+		.of_map_mode = apw888x_regulator_dc_of_map_mode,   \
+	},                                                         \
+	.nmode_reg  = APW8889_REG_ ## _id ## _MODE,                \
+	.nmode_mask = APW8889_ ## _id ## _NRMMODE_MASK,            \
+	.smode_reg  = APW8889_REG_ ## _id ## _MODE,                \
+	.smode_mask = APW8889_ ## _id ## _SLPMODE_MASK,            \
+	.dischg_reg = APW8889_REG_DISCHG,                          \
+	.dischg_mask = APW8889_ ## _id ## _DISCHG_MASK,            \
+}
+
+static struct apw888x_regulator_desc desc[] = {
+	[APW8889_ID_DC1]  = APW8889_DESC(DC1, "dc1", 2200000, 25000, 64, dc),
+	[APW8889_ID_DC2]  = APW8889_DESC_CLP(DC2, "dc2", 550000, 12500, 64, dc),
+	[APW8889_ID_DC3]  = APW8889_DESC_CLP(DC3, "dc3", 550000, 12500, 64, dc),
+	[APW8889_ID_DC4]  = APW8889_DESC_CLP(DC4, "dc4", 550000, 12500, 64, dc),
+	[APW8889_ID_DC5]  = APW8889_DESC_FIXED_UV(DC5, "dc5", 0),
+	[APW8889_ID_DC6]  = APW8889_DESC(DC6, "dc6",  800000, 20000, 64, dc),
+	[APW8889_ID_LDO1] = APW8889_DESC(LDO1, "ldo1", 1780000, 40000, 32, ldo),
+};
+
+/* pm */
+static int apw8889_regulator_suspend(struct device *dev)
+{
+	struct apw888x_regulator_data *pos;
+	struct apw888x_regulator_device *ardev = dev_get_drvdata(dev);
+
+#ifdef CONFIG_SUSPEND
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY)
+		goto done;
+#endif
+
+	dev_info(dev, "Enter %s\n", __func__);
+	list_for_each_entry(pos, &ardev->list, list)
+		apw888x_prepare_suspend_state(pos->rdev, 0);
+	regulator_suspend_prepare(PM_SUSPEND_MEM);
+	dev_info(dev, "Exit %s\n", __func__);
+done:
+	return 0;
+}
+
+static const struct dev_pm_ops apw8889_regulator_pm_ops = {
+	.suspend = apw8889_regulator_suspend,
+};
+
+static int apw8889_regulator_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct apw888x_device *adev = dev_get_drvdata(dev->parent);
+	struct apw888x_regulator_device *ardev;
+	int i, ret;
+
+	ardev = devm_kzalloc(dev, sizeof(*ardev), GFP_KERNEL);
+	if (!ardev)
+		return -ENOMEM;
+	ardev->dev = dev;
+	INIT_LIST_HEAD(&ardev->list);
+	ardev->regmap = adev->regmap;
+
+	regcache_cache_bypass(ardev->regmap, true);
+	ret = regmap_write(ardev->regmap, APW8889_REG_DISCHG, 0xfd);
+	if (ret)
+		dev_warn(dev, "failed to reset dischg: %d\n", ret);
+	regcache_cache_bypass(ardev->regmap, false);
+
+
+	for (i = 0; i < ARRAY_SIZE(desc); i++) {
+		ret = apw888x_regulator_register(ardev, &desc[i]);
+		if (ret) {
+			dev_err(dev, "Failed to register %s: %d\n",
+				desc[i].desc.name, ret);
+			return ret;
+		}
+	}
+
+	platform_set_drvdata(pdev, ardev);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static void apw8889_regulator_shutdown(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct apw888x_regulator_device *ardev = platform_get_drvdata(pdev);
+	struct apw888x_regulator_data *pos;
+
+	dev_info(dev, "Enter %s\n", __func__);
+	list_for_each_entry(pos, &ardev->list, list)
+		apw888x_prepare_suspend_state(pos->rdev, 1);
+	regulator_suspend_prepare(PM_SUSPEND_MEM);
+	dev_info(dev, "Exit %s\n", __func__);
+}
+
+static const struct of_device_id apw8889_regulator_ids[] = {
+	{ .compatible = "anpec,apw8889-regulator", },
+	{}
+};
+MODULE_DEVICE_TABLE(of, apw8889_regulator_ids);
+
+static struct platform_driver apw8889_regulator_driver = {
+	.driver = {
+		.name = "apw8889-regulator",
+		.owner = THIS_MODULE,
+		.pm = &apw8889_regulator_pm_ops,
+		.of_match_table = apw8889_regulator_ids,
+	},
+	.probe    = apw8889_regulator_probe,
+	.shutdown = apw8889_regulator_shutdown,
+};
+module_platform_driver(apw8889_regulator_driver);
+
+MODULE_DESCRIPTION("Anpec APW8889 Regulator Driver");
+MODULE_AUTHOR("Cheng-Yu Lee <cylee12@realtek.com>");
+MODULE_LICENSE("GPL");
+
+
diff --git a/drivers/regulator/apw888x-regulator-core.c b/drivers/regulator/apw888x-regulator-core.c
new file mode 100644
index 00000000..daf6c93
--- /dev/null
+++ b/drivers/regulator/apw888x-regulator-core.c
@@ -0,0 +1,418 @@
+ /*
+ * apw888x-regulator-core.c - Anpec APW888X Series PMIC common code
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/module.h>
+#include <linux/list.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/regmap.h>
+#include <linux/suspend.h>
+#include <linux/of.h>
+#include <linux/mfd/apw888x.h>
+#include <dt-bindings/regulator/anpec,apw888x.h>
+#include "apw888x-regulator.h"
+
+int apw888x_regulator_of_parse_cb(struct device_node *np,
+				  const struct regulator_desc *desc,
+				  struct regulator_config *config)
+{
+	struct apw888x_regulator_data *data = config->driver_data;
+	struct device_node *child;
+	unsigned int val;
+
+	child = of_get_child_by_name(np, "regulator-state-coldboot");
+	if (!child)
+		child = of_get_child_by_name(np, "regulator-state-mem");
+	if (child) {
+		struct regulator_state *state = &data->state_coldboot;
+
+		if (of_property_read_bool(child, "regulator-on-in-suspend"))
+			state->enabled = true;
+
+		if (of_property_read_bool(child, "regulator-off-in-suspend"))
+			state->disabled = true;
+
+		if (!of_property_read_u32(child, "regulator-suspend-microvolt",
+			&val))
+			state->uV = val;
+	}
+
+	if (desc->n_voltages == 1 && desc->fixed_uV == 0) {
+		u32 min = 0, max = 0;
+
+		of_property_read_u32(np, "regulator-min-microvolt", &min);
+		of_property_read_u32(np, "regulator-max-microvolt", &max);
+		WARN_ON(min != max);
+		data->fixed_uV = max;
+	}
+
+	if (of_find_property(np, "apw888x-discharge-disable", NULL))
+		data->flags |= APW888X_DISCHARGE_DISABLE;
+
+	return 0;
+}
+
+unsigned int apw888x_regulator_dc_of_map_mode(unsigned int mode)
+{
+	switch (mode) {
+	case APW8889_DC_MODE_FORCE_PWM:
+		return REGULATOR_MODE_FAST;
+	default:
+		break;
+	}
+	return REGULATOR_MODE_NORMAL;
+}
+
+unsigned int apw888x_regulator_ldo_of_map_mode(unsigned int mode)
+{
+	return REGULATOR_MODE_NORMAL;
+}
+
+/* regulator_ops */
+static int apw888x_regulator_set_mode_regmap(struct regulator_dev *rdev,
+					     unsigned int mode)
+{
+	struct apw888x_regulator_data *data = rdev_get_drvdata(rdev);
+	struct apw888x_regulator_desc *gd = data->desc;
+	unsigned int val = 0;
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	if (!data->nmode)
+		return -EINVAL;
+
+	if (apw888x_regulator_type_is_ldo(gd))
+		val = 0;
+	else
+		val = (mode & REGULATOR_MODE_FAST) ? 2 : 0;
+
+	dev_dbg(rdev_get_dev(rdev), "%s: val=%02x\n", __func__, val);
+	return regmap_field_write(data->nmode, val);
+}
+
+static unsigned int apw888x_regulator_get_mode_regmap(struct regulator_dev *rdev)
+{
+	struct apw888x_regulator_data *data = rdev_get_drvdata(rdev);
+	struct apw888x_regulator_desc *gd = data->desc;
+	unsigned int val;
+	int ret;
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	if (!data->nmode)
+		return -EINVAL;
+
+	ret = regmap_field_read(data->nmode, &val);
+	if (ret)
+		return 0;
+
+	dev_dbg(rdev_get_dev(rdev), "%s: val=%02x\n", __func__, val);
+
+	if (apw888x_regulator_type_is_ldo(gd) && val == 2)
+		return REGULATOR_MODE_IDLE;
+	else if (val == 2)
+		return REGULATOR_MODE_FAST;
+	return REGULATOR_MODE_NORMAL;
+}
+
+
+static int apw888x_set_suspend_enable(struct regulator_dev *rdev)
+{
+	struct apw888x_regulator_data *data = rdev_get_drvdata(rdev);
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	regmap_field_write(data->smode, 0x2);
+	return 0;
+}
+
+static int apw888x_set_suspend_disable(struct regulator_dev *rdev)
+{
+	struct apw888x_regulator_data *data = rdev_get_drvdata(rdev);
+	struct device *dev = rdev_get_dev(rdev);
+
+	dev_dbg(dev, "%s\n", __func__);
+	if (!data->smode)
+		return -EINVAL;
+	regmap_field_write(data->smode, 0x3);
+
+	if (data->dischg && (data->flags & APW888X_DISCHARGE_DISABLE)) {
+		dev_info(dev, "%s: set dischg disabled\n", __func__);
+		regmap_field_write(data->dischg, 0);
+	}
+	return 0;
+}
+
+static int apw888x_set_suspend_voltage(struct regulator_dev *rdev,
+				       int uV)
+{
+	struct apw888x_regulator_data *data = rdev_get_drvdata(rdev);
+	int vsel;
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	vsel = regulator_map_voltage_iterate(rdev, uV, uV);
+	if (vsel < 0)
+		return -EINVAL;
+
+	if (!data->smode || !data->svsel)
+		return -EINVAL;
+
+	regmap_field_write(data->smode, 0x2);
+	regmap_field_write(data->svsel, vsel);
+	return 0;
+}
+
+static int apw888x_regulator_get_voltage_fixed(struct regulator_dev *rdev)
+{
+	struct apw888x_regulator_data *data = rdev_get_drvdata(rdev);
+
+	if (data->fixed_uV)
+		return data->fixed_uV;
+	return -EINVAL;
+}
+
+static int apw888x_regulator_set_clamp_en(struct regulator_dev *rdev,
+					  int enable)
+{
+	struct apw888x_regulator_data *data = rdev_get_drvdata(rdev);
+
+	if (!data->clamp)
+		return -EINVAL;
+	dev_dbg(rdev_get_dev(rdev), "%s: set clamp_en val=%x\n",
+		__func__, enable);
+	return regmap_field_write(data->clamp, enable);
+}
+
+static int apw888x_regulator_get_clamp_en(struct regulator_dev *rdev)
+{
+	struct apw888x_regulator_data *data = rdev_get_drvdata(rdev);
+	unsigned int enable;
+	int ret;
+
+	if (!data->clamp)
+		return -EINVAL;
+	ret = regmap_field_read(data->clamp, &enable);
+	if (!ret)
+		dev_dbg(rdev_get_dev(rdev), "%s: get clamp_en val=%x\n",
+			__func__, enable);
+	return ret ? ret : enable;
+}
+
+static int apw888x_regulator_set_voltage_sel_regmap(struct regulator_dev *rdev,
+						    unsigned sel)
+{
+	struct apw888x_regulator_data *data = rdev_get_drvdata(rdev);
+
+	if (data->clamp)
+		apw888x_regulator_set_clamp_en(rdev, sel < 0x34);
+	return regulator_set_voltage_sel_regmap(rdev, sel);
+}
+
+const struct regulator_ops apw888x_regulator_ops = {
+	.list_voltage         = regulator_list_voltage_linear,
+	.map_voltage          = regulator_map_voltage_linear,
+	.set_voltage_sel      = apw888x_regulator_set_voltage_sel_regmap,
+	.get_voltage_sel      = regulator_get_voltage_sel_regmap,
+	.enable               = regulator_enable_regmap,
+	.disable              = regulator_disable_regmap,
+	.is_enabled           = regulator_is_enabled_regmap,
+	.get_mode             = apw888x_regulator_get_mode_regmap,
+	.set_mode             = apw888x_regulator_set_mode_regmap,
+	.set_suspend_voltage  = apw888x_set_suspend_voltage,
+	.set_suspend_enable   = apw888x_set_suspend_enable,
+	.set_suspend_disable  = apw888x_set_suspend_disable,
+};
+
+const struct regulator_ops apw888x_regulator_fixed_uV_ops = {
+	.enable               = regulator_enable_regmap,
+	.disable              = regulator_disable_regmap,
+	.is_enabled           = regulator_is_enabled_regmap,
+	.get_mode             = apw888x_regulator_get_mode_regmap,
+	.set_mode             = apw888x_regulator_set_mode_regmap,
+	.set_suspend_voltage  = apw888x_set_suspend_voltage,
+	.set_suspend_enable   = apw888x_set_suspend_enable,
+	.set_suspend_disable  = apw888x_set_suspend_disable,
+	.get_voltage          = apw888x_regulator_get_voltage_fixed,
+};
+
+/* helper function */
+/*
+ * apw888x_prepare_suspend_state - prepare apw888x suspend state, copy the correct
+ *                                state into state_mem of decs, then call
+ *                                regulator_suspend_prepare() to do regulator
+ *                                suspend.
+ *
+ * @rdev:        regulator device
+ * @is_coldboot: state selection
+ */
+void apw888x_prepare_suspend_state(struct regulator_dev *rdev,
+				   int is_coldboot)
+{
+	struct apw888x_regulator_data *data = rdev_get_drvdata(rdev);
+	struct regulator_state *state;
+
+	state = &rdev->constraints->state_mem;
+	*state = is_coldboot ? data->state_coldboot : data->state_mem;
+
+	dev_info(rdev_get_dev(rdev), "%s: state={enabled=%d, disabled=%d, mode=%d, uV=%d}, is_coldboot=%d\n",
+		__func__, state->enabled, state->disabled, state->mode,
+		state->uV, is_coldboot);
+}
+
+static struct regmap_field *create_regmap_field(struct apw888x_regulator_device *ardev,
+	u32 reg, u32 mask)
+{
+	u32 msb = fls(mask) - 1;
+	u32 lsb = ffs(mask) - 1;
+	struct reg_field map = REG_FIELD(reg, lsb, msb);
+	struct regmap_field *rmap;
+
+	if (reg == 0 && mask == 0)
+		return NULL;
+
+	dev_dbg(ardev->dev, "reg=%02x, mask=%02x, lsb=%d, msb=%d\n",
+		reg, mask, lsb, msb);
+	rmap = devm_regmap_field_alloc(ardev->dev, ardev->regmap, map);
+	if (IS_ERR(rmap)) {
+		dev_err(ardev->dev, "regmap_field_alloc() for (reg=%02x, mask=%02x) returns %ld\n",
+			reg, mask, PTR_ERR(rmap));
+	}
+	return rmap;
+}
+
+static inline void setup_regulator_state(struct regulator_state *state)
+{
+	/*
+	 * copy state_mem to data for mem/coldboot switching. if there is no
+	 * sleep uV and mode, set the state to enable
+	 */
+	if (state->uV != 0)
+		return;
+	if (state->disabled)
+		return;
+	state->enabled = true;
+}
+
+#define APW888X_DC_MODE_MASK    (REGULATOR_MODE_NORMAL | REGULATOR_MODE_FAST)
+#define APW888X_LDO_MODE_MASK   (REGULATOR_MODE_NORMAL)
+
+static ssize_t apw888x_regulator_clamp_en_store(struct device *dev,
+						struct device_attribute *attr,
+						const char *buf,
+						size_t count)
+{
+	return -EINVAL;
+}
+
+static ssize_t apw888x_regulator_clamp_en_show(struct device *dev,
+					       struct device_attribute *attr,
+					       char *buf)
+{
+
+	struct regulator_dev *rdev = dev_get_drvdata(dev);
+	int val = apw888x_regulator_get_clamp_en(rdev);
+
+	switch (val) {
+	case 1:
+		return sprintf(buf, "enable\n");
+	case 0:
+		return sprintf(buf, "disable\n");
+	case -EINVAL:
+		return sprintf(buf, "invalid\n");
+	}
+	return sprintf(buf, "unknown\n");
+}
+
+static DEVICE_ATTR(clamp_en, 0644,
+		   apw888x_regulator_clamp_en_show,
+		   apw888x_regulator_clamp_en_store);
+
+static struct attribute *apw888x_regulator_dev_attrs[] = {
+	&dev_attr_clamp_en.attr,
+	NULL
+};
+
+static const struct attribute_group apw888x_regulator_dev_group = {
+	.name = "apw888x",
+	.attrs = apw888x_regulator_dev_attrs,
+};
+
+static int apw888x_regulator_add_sysfs(struct device *dev)
+{
+	return sysfs_create_group(&dev->kobj, &apw888x_regulator_dev_group);
+}
+
+int apw888x_regulator_register(struct apw888x_regulator_device *ardev,
+			       struct apw888x_regulator_desc *gd)
+{
+	struct device *dev = ardev->dev;
+	struct apw888x_regulator_data *data;
+	struct regulator_config config = {};
+	struct regulation_constraints *c;
+
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	data->desc = gd;
+
+	data->nmode = create_regmap_field(ardev, gd->nmode_reg, gd->nmode_mask);
+	if (IS_ERR(data->nmode))
+		return PTR_ERR(data->nmode);
+	data->smode = create_regmap_field(ardev, gd->smode_reg, gd->smode_mask);
+	if (IS_ERR(data->smode))
+		return PTR_ERR(data->smode);
+	data->svsel = create_regmap_field(ardev, gd->svsel_reg, gd->svsel_mask);
+	if (IS_ERR(data->svsel))
+		return PTR_ERR(data->svsel);
+	data->dischg = create_regmap_field(ardev, gd->dischg_reg,
+		gd->dischg_mask);
+	if (IS_ERR(data->dischg))
+		return PTR_ERR(data->dischg);
+
+	if (gd->clamp_reg) {
+		data->clamp = create_regmap_field(ardev, gd->clamp_reg, gd->clamp_mask);
+		if (IS_ERR(data->clamp))
+			return PTR_ERR(data->clamp);
+	}
+
+	config.dev         = ardev->dev;
+	config.regmap      = ardev->regmap;
+	config.driver_data = data;
+
+	data->rdev = devm_regulator_register(dev, &gd->desc, &config);
+	if (IS_ERR(data->rdev))
+		return PTR_ERR(data->rdev);
+
+	apw888x_regulator_add_sysfs(rdev_get_dev(data->rdev));
+	apw888x_regulator_set_clamp_en(data->rdev, 1);
+
+	c = data->rdev->constraints;
+	/* setup regulator state */
+	setup_regulator_state(&c->state_mem);
+	data->state_mem = c->state_mem;
+	setup_regulator_state(&data->state_coldboot);
+	/* enable change mode */
+	c->valid_ops_mask |= REGULATOR_CHANGE_MODE;
+	c->valid_modes_mask |= apw888x_regulator_type_is_ldo(data->desc) ?
+		APW888X_LDO_MODE_MASK : APW888X_DC_MODE_MASK;
+	list_add_tail(&data->list, &ardev->list);
+	return 0;
+}
+
diff --git a/drivers/regulator/apw888x-regulator.h b/drivers/regulator/apw888x-regulator.h
new file mode 100644
index 00000000..254f4f2
--- /dev/null
+++ b/drivers/regulator/apw888x-regulator.h
@@ -0,0 +1,107 @@
+ /*
+ * apw888x-regulator.h
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __APW888X_REGULATOR_H
+#define __APW888X_REGULATOR_H
+
+#include <linux/list.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/regmap.h>
+#include <linux/suspend.h>
+#include <linux/mfd/apw888x.h>
+
+struct apw888x_regulator_desc {
+	struct regulator_desc desc;
+	u8 nmode_reg;
+	u8 nmode_mask;
+	u8 smode_reg;
+	u8 smode_mask;
+	u8 svsel_reg;
+	u8 svsel_mask;
+	u8 clamp_reg;
+	u8 clamp_mask;
+	u8 dischg_reg;
+	u8 dischg_mask;
+};
+
+struct apw888x_regulator_device {
+	struct device *dev;
+	struct regmap *regmap;
+	struct list_head list;
+};
+
+struct apw888x_regulator_data {
+	struct list_head list;
+	struct regulator_dev *rdev;
+	struct apw888x_regulator_desc *desc;
+
+	struct regmap_field *svsel;
+	struct regmap_field *smode;
+	struct regmap_field *nmode;
+	struct regmap_field *clamp;
+	struct regmap_field *dischg;
+
+	struct regulator_state state_mem;
+	struct regulator_state state_coldboot;
+
+	u32 fixed_uV;
+	u32 flags;
+};
+
+#define APW888X_DISCHARGE_DISABLE       (0x1)
+
+int apw888x_regulator_of_parse_cb(struct device_node *np,
+				  const struct regulator_desc *desc,
+				  struct regulator_config *config);
+unsigned int apw888x_regulator_dc_of_map_mode(unsigned int mode);
+unsigned int apw888x_regulator_ldo_of_map_mode(unsigned int mode);
+
+static inline int apw888x_regulator_type_is_ldo(struct apw888x_regulator_desc *gd)
+{
+	return gd->desc.of_map_mode == apw888x_regulator_ldo_of_map_mode;
+}
+
+extern const struct regulator_ops apw888x_regulator_ops;
+extern const struct regulator_ops apw888x_regulator_fixed_uV_ops;
+
+/* helper function */
+/*
+ * apw888x_prepare_suspend_state - prepare apw888x suspend state, copy the correct
+ *                                 state into state_mem of decs, then call
+ *                                 regulator_suspend_prepare() to do regulator
+ *                                 suspend.
+ *
+ * @rdev:        regulator device
+ * @is_coldboot: state selection
+ */
+void apw888x_prepare_suspend_state(struct regulator_dev *rdev,
+				   int is_coldboot);
+
+#define APW888X_DC_MODE_MASK    (REGULATOR_MODE_NORMAL | REGULATOR_MODE_FAST)
+#define APW888X_LDO_MODE_MASK   (REGULATOR_MODE_NORMAL)
+
+int apw888x_regulator_register(struct apw888x_regulator_device *ardev,
+			       struct apw888x_regulator_desc *gd);
+
+#endif /* __APW888X_REGULATOR_H */
diff --git a/drivers/regulator/core.c b/drivers/regulator/core.c
index 178fcda..e19f256 100644
--- a/drivers/regulator/core.c
+++ b/drivers/regulator/core.c
@@ -39,6 +39,9 @@
 #include "dummy.h"
 #include "internal.h"
 
+#define SYSFS_RW_uV_EN      //Add by Simon 2014/1/6
+#define SYSFS_RW_OPMODE
+
 #define rdev_crit(rdev, fmt, ...)					\
 	pr_crit("%s: " fmt, rdev_get_name(rdev), ##__VA_ARGS__)
 #define rdev_err(rdev, fmt, ...)					\
@@ -323,6 +326,10 @@ static int regulator_mode_constrain(struct regulator_dev *rdev, int *mode)
 	return -EINVAL;
 }
 
+#ifdef CONFIG_REGULATOR_G2227
+#define SYSFS_RW_uV_EN
+#endif
+
 static ssize_t regulator_uV_show(struct device *dev,
 				struct device_attribute *attr, char *buf)
 {
@@ -335,7 +342,41 @@ static ssize_t regulator_uV_show(struct device *dev,
 
 	return ret;
 }
+#ifdef SYSFS_RW_uV_EN
+static ssize_t regulator_uV_write(struct device *dev, struct device_attribute *attr,
+			const char *buf, size_t count)
+{
+	struct regulator_dev *rdev = dev_get_drvdata(dev);
+	unsigned long voltage;
+	unsigned int min_uV, max_uV;
+	char *endp;
+	int ret, i;
+
+	mutex_lock(&rdev->mutex);
+	endp = (char *)(buf + count);
+	voltage = simple_strtoul(buf, &endp, 10);
+	min_uV = max_uV = (int)voltage;
+
+	ret = regulator_check_voltage(rdev, &min_uV, &max_uV);
+	if (ret < 0)
+		goto out;
+
+	ret = _regulator_do_set_voltage(rdev, min_uV, max_uV);
+	if (ret < 0) {
+		rdev_err(rdev, "unsupportable voltage: support list--\n");
+		for(i=0; i<rdev->desc->n_voltages; i++)
+			rdev_err(rdev, "%d\n", rdev->desc->ops->list_voltage(rdev, i));
+	}
+
+out:
+	mutex_unlock(&rdev->mutex);
+
+	return count;
+}
+static DEVICE_ATTR(microvolts, S_IRUSR | S_IWUSR, regulator_uV_show, regulator_uV_write);
+#else
 static DEVICE_ATTR(microvolts, 0444, regulator_uV_show, NULL);
+#endif
 
 static ssize_t regulator_uA_show(struct device *dev,
 				struct device_attribute *attr, char *buf)
@@ -370,6 +411,56 @@ static ssize_t regulator_print_opmode(char *buf, int mode)
 	return sprintf(buf, "unknown\n");
 }
 
+static __maybe_unused ssize_t regulator_opmode_store(struct device *dev, struct device_attribute *attr,
+            const char *buf, size_t count)
+{
+    struct regulator_dev *rdev = dev_get_drvdata(dev);
+    int mode = REGULATOR_MODE_NORMAL;
+    int ret;
+    int regulator_curr_mode;
+
+    if (!strncmp(buf, "fast", sizeof("fast") - 1))
+        mode = REGULATOR_MODE_FAST;
+    else if (!strncmp(buf, "normal", sizeof("normal") - 1))
+        mode = REGULATOR_MODE_NORMAL;
+    else if (!strncmp(buf, "idle", sizeof("idle") - 1))
+        mode = REGULATOR_MODE_IDLE;
+    else if (!strncmp(buf, "standby", sizeof("standby") - 1))
+        mode = REGULATOR_MODE_STANDBY;
+    else
+        return -EINVAL;
+
+    mutex_lock(&rdev->mutex);
+
+    /* sanity check */
+    if (!rdev->desc->ops->set_mode) {
+        ret = -EINVAL;
+        goto out;
+    }
+
+    /* return if the same mode is requested */
+    if (rdev->desc->ops->get_mode) {
+        regulator_curr_mode = rdev->desc->ops->get_mode(rdev);
+        if (regulator_curr_mode == mode) {
+            ret = 0;
+            goto out;
+        }
+    }
+
+    /* constraints check */
+    ret = regulator_mode_constrain(rdev, &mode);
+    if (ret < 0)
+        goto out;
+
+    ret = rdev->desc->ops->set_mode(rdev, mode);
+out:
+    mutex_unlock(&rdev->mutex);
+
+    if (ret)
+        return ret;
+    return count;
+}
+
 static ssize_t regulator_opmode_show(struct device *dev,
 				    struct device_attribute *attr, char *buf)
 {
@@ -377,7 +468,13 @@ static ssize_t regulator_opmode_show(struct device *dev,
 
 	return regulator_print_opmode(buf, _regulator_get_mode(rdev));
 }
+
+
+#ifdef SYSFS_RW_OPMODE
+static DEVICE_ATTR(opmode, S_IRUSR | S_IWUSR, regulator_opmode_show, regulator_opmode_store);
+#else
 static DEVICE_ATTR(opmode, 0444, regulator_opmode_show, NULL);
+#endif
 
 static ssize_t regulator_print_state(char *buf, int state)
 {
diff --git a/drivers/regulator/g2227-regulator.c b/drivers/regulator/g2227-regulator.c
new file mode 100644
index 00000000..9f8ce7e
--- /dev/null
+++ b/drivers/regulator/g2227-regulator.c
@@ -0,0 +1,232 @@
+/*
+ * GMT-G2227 PMIC Regulator driver
+ *
+ * Copyright (C) 2016-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *      Simon Hsu <simon_hsu@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/platform_device.h>
+#include <linux/module.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/regmap.h>
+#include <linux/suspend.h>
+#include <linux/mfd/g2227.h>
+#include <soc/realtek/rtk_chip.h>
+#include "g22xx-regulator.h"
+
+/* regulator id */
+enum g2227_regulator_id {
+	G2227_ID_DC1 = 0,
+	G2227_ID_DC2,
+	G2227_ID_DC3,
+	G2227_ID_DC4,
+	G2227_ID_DC5,
+	G2227_ID_DC6,
+	G2227_ID_LDO2,
+	G2227_ID_LDO3,
+	G2227_ID_MAX
+};
+
+/* voltage table */
+static const unsigned int dcdc1_vtbl[] = {
+	3000000, 3100000, 3200000, 3300000,
+};
+
+static const unsigned int dcdcx_vtbl[] = {
+	 800000,  812500,  825000,  837500,  850000,  862500,  875000,  887500,
+	 900000,  912500,  925000,  937500,  950000,  962500,  975000,  987500,
+	1000000, 1012500, 1025000, 1037500, 1050000, 1062500, 1075000, 1087500,
+	1100000, 1112500, 1125000, 1137500, 1150000, 1162500, 1175000, 1187500,
+};
+
+static const unsigned int ldo_vtbl[] = {
+	 800000,  850000,  900000,  950000, 1000000, 1100000, 1200000, 1300000,
+	1500000, 1600000, 1800000, 1900000, 2500000, 2600000, 3000000, 3100000,
+};
+
+#define G2227_DESC(_id, _name, _vtbl, _type)                       \
+{                                                                  \
+	.desc = {                                                  \
+		.owner       = THIS_MODULE,                        \
+		.type        = REGULATOR_VOLTAGE,                  \
+		.ops         = &g22xx_regulator_ops,               \
+		.name        = _name,                              \
+		.of_match    = _name,                              \
+		.n_voltages  = ARRAY_SIZE(_vtbl),                  \
+		.volt_table  = _vtbl,                              \
+		.id          = G2227_ID_ ## _id,                   \
+		.vsel_reg    = G2227_REG_ ## _id ## _NRMVOLT,      \
+		.vsel_mask   = G2227_ ## _id ## _NRMVOLT_MASK,     \
+		.enable_reg  = G2227_REG_ONOFF,                    \
+		.enable_mask = G2227_ ## _id ## _ON_MASK,          \
+		.enable_val  = G2227_ ## _id ## _ON_MASK,          \
+		.of_map_mode = g22xx_regulator_ ## _type ##_of_map_mode, \
+		.of_parse_cb = g22xx_regulator_of_parse_cb,        \
+	},                                                         \
+	.nmode_reg  = G2227_REG_ ## _id ## _MODE,                  \
+	.nmode_mask = G2227_ ## _id ## _NRMMODE_MASK,              \
+	.smode_reg  = G2227_REG_ ## _id ## _MODE,                  \
+	.smode_mask = G2227_ ## _id ## _SLPMODE_MASK,              \
+	.svsel_reg  = G2227_REG_ ## _id ## _SLPVOLT,               \
+	.svsel_mask = G2227_ ## _id ## _SLPVOLT_MASK,              \
+}
+
+#define G2227_DESC_FIXED_UV(_id, _name, _fixed_uV)                 \
+{                                                                  \
+	.desc = {                                                  \
+		.owner       = THIS_MODULE,                        \
+		.type        = REGULATOR_VOLTAGE,                  \
+		.ops         = &g22xx_regulator_fixed_uV_ops,      \
+		.name        = _name,                              \
+		.of_match    = _name,                              \
+		.n_voltages  = 1,                                  \
+		.fixed_uV    = _fixed_uV,                          \
+		.id          = G2227_ID_ ## _id,                   \
+		.enable_reg  = G2227_REG_ONOFF,                    \
+		.enable_mask = G2227_ ## _id ## _ON_MASK,          \
+		.enable_val  = G2227_ ## _id ## _ON_MASK,          \
+		.of_map_mode = g22xx_regulator_dc_of_map_mode,     \
+		.of_parse_cb = g22xx_regulator_of_parse_cb,        \
+	},                                                         \
+	.nmode_reg  = G2227_REG_ ## _id ## _MODE,                  \
+	.nmode_mask = G2227_ ## _id ## _NRMMODE_MASK,              \
+	.smode_reg  = G2227_REG_ ## _id ## _MODE,                  \
+	.smode_mask = G2227_ ## _id ## _SLPMODE_MASK,              \
+}
+
+/* regulator_desc */
+static struct g22xx_regulator_desc desc[G2227_ID_MAX] = {
+	[G2227_ID_DC1]  = G2227_DESC(DC1,  "dc1",  dcdc1_vtbl, dc),
+	[G2227_ID_DC2]  = G2227_DESC(DC2,  "dc2",  dcdcx_vtbl, dc),
+	[G2227_ID_DC3]  = G2227_DESC(DC3,  "dc3",  dcdcx_vtbl, dc),
+	[G2227_ID_DC4]  = G2227_DESC_FIXED_UV(DC4, "dc4", 0),
+	[G2227_ID_DC5]  = G2227_DESC(DC5,  "dc5",  dcdcx_vtbl, dc),
+	[G2227_ID_DC6]  = G2227_DESC(DC6,  "dc6",  dcdcx_vtbl, dc),
+	[G2227_ID_LDO2] = G2227_DESC(LDO2, "ldo2", ldo_vtbl,   ldo),
+	[G2227_ID_LDO3] = G2227_DESC(LDO3, "ldo3", ldo_vtbl,   ldo),
+};
+
+
+/* pm */
+static int g2227_regulator_suspend(struct device *dev)
+{
+	struct g22xx_regulator_device *grdev = dev_get_drvdata(dev);
+	struct g22xx_regulator_data *pos;
+
+#ifdef CONFIG_SUSPEND
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY)
+		goto done;
+#endif
+
+	dev_info(dev, "Enter %s\n", __func__);
+	list_for_each_entry(pos, &grdev->list, list)
+		g22xx_prepare_suspend_state(pos->rdev, 0);
+	regulator_suspend_prepare(PM_SUSPEND_MEM);
+	dev_info(dev, "Exit %s\n", __func__);
+done:
+	return 0;
+}
+
+static const struct dev_pm_ops g2227_regulator_pm_ops = {
+	.suspend = g2227_regulator_suspend,
+};
+
+static int g2227_regulator_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct g22xx_device *gdev = dev_get_drvdata(dev->parent);
+	struct g22xx_regulator_device *grdev;
+	int i, ret;
+	int chip_rev;
+
+	grdev = devm_kzalloc(dev, sizeof(*grdev), GFP_KERNEL);
+	if (!grdev)
+		return -ENOMEM;
+
+	grdev->regmap = gdev->regmap;
+	grdev->dev = dev;
+	INIT_LIST_HEAD(&grdev->list);
+	chip_rev = get_rtd_chip_revision();
+
+	for (i = 0; i < ARRAY_SIZE(desc); i++) {
+		struct regulator_dev *rdev;
+
+		rdev = g22xx_regulator_register(grdev, &desc[i]);
+		if (IS_ERR(rdev)) {
+			ret = PTR_ERR(rdev);
+			dev_err(dev, "failed to register %s: %d\n",
+				desc[i].desc.name, ret);
+			return ret;
+		}
+#ifdef CONFIG_ARCH_RTD129x
+		/* workaround */
+		if (desc[i].desc.id == G2227_ID_DC6 &&
+		   (chip_rev == RTD_CHIP_A00 || chip_rev == RTD_CHIP_B00)) {
+			struct g22xx_regulator_data *data
+				= rdev_get_drvdata(rdev);
+
+			BUG_ON(!data);
+			data->state_mem.enabled = true;
+			data->state_mem.disabled = false;
+		}
+#endif
+	}
+
+	platform_set_drvdata(pdev, grdev);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static void g2227_regulator_shutdown(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct g22xx_regulator_device *grdev = platform_get_drvdata(pdev);
+	struct g22xx_regulator_data *pos;
+
+	dev_info(dev, "Enter %s\n", __func__);
+	list_for_each_entry(pos, &grdev->list, list)
+		g22xx_prepare_suspend_state(pos->rdev, 1);
+	regulator_suspend_prepare(PM_SUSPEND_MEM);
+	dev_info(dev, "Exit %s\n", __func__);
+}
+
+
+static const struct of_device_id g2227_regulator_ids[] = {
+	{ .compatible = "gmt,g2227-regulator", },
+	{}
+};
+MODULE_DEVICE_TABLE(i2c, g2227_regulator_ids);
+
+static struct platform_driver g2227_regulator_driver = {
+	.driver = {
+		.name = "g2227-regulator",
+		.owner = THIS_MODULE,
+		.pm = &g2227_regulator_pm_ops,
+		.of_match_table = g2227_regulator_ids,
+	},
+	.probe    = g2227_regulator_probe,
+	.shutdown = g2227_regulator_shutdown,
+};
+module_platform_driver(g2227_regulator_driver);
+
+MODULE_DESCRIPTION("GMT G2237 Regulator Driver");
+MODULE_AUTHOR("Simon Hsu <simon_hsu@realtek.com>");
+MODULE_AUTHOR("Cheng-Yu Lee <cylee12@realtek.com>");
+MODULE_LICENSE("GPL");
diff --git a/drivers/regulator/g2237-regulator.c b/drivers/regulator/g2237-regulator.c
new file mode 100644
index 00000000..7d67bbc
--- /dev/null
+++ b/drivers/regulator/g2237-regulator.c
@@ -0,0 +1,226 @@
+/*
+ * GMT-G2237 PMIC Regulator driver
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/platform_device.h>
+#include <linux/module.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/regmap.h>
+#include <linux/suspend.h>
+#include <linux/mfd/g2237.h>
+#include "g22xx-regulator.h"
+
+/* regulator id */
+enum {
+	G2237_ID_DC1 = 0,
+	G2237_ID_DC2,
+	G2237_ID_DC3,
+	G2237_ID_DC4,
+	G2237_ID_DC5,
+	G2237_ID_LDO1,
+	G2237_ID_MAX
+};
+
+/* voltage table */
+static const unsigned int dc1_vtbl[] = {
+	2200000, 2300000, 2400000, 2500000,
+	2600000, 2700000, 2800000, 2900000,
+	3000000, 3100000, 3200000, 3300000,
+	3400000, 3500000, 3600000, 3700000,
+};
+
+static const unsigned int dcx_vtbl[] = {
+	 800000,  812500,  825000,  837500,
+	 850000,  862500,  875000,  887500,
+	 900000,  912500,  925000,  937500,
+	 950000,  962500,  975000,  987500,
+	1000000, 1012500, 1025000, 1037500,
+	1050000, 1062500, 1075000, 1087500,
+	1100000, 1112500, 1125000, 1137500,
+	1150000, 1162500, 1175000, 1187500,
+};
+
+static const unsigned int dc5_vtbl[] = {
+	 800000,  850000,  900000,  950000,
+	1000000, 1050000, 1100000, 1200000,
+	1300000, 1500000, 1600000, 1700000,
+	1800000, 1900000, 2000000, 2500000,
+};
+
+static const unsigned int ldo1_vtbl[] = {
+	2200000, 2300000, 2400000, 2500000,
+	2600000, 2700000, 2800000, 2900000,
+	3000000, 3000000, 3000000, 3000000,
+	3000000, 3000000, 3000000, 3000000,
+};
+
+#define G2237_DESC(_id, _name, _vtbl, _type)                       \
+{                                                                  \
+	.desc = {                                                  \
+		.owner       = THIS_MODULE,                        \
+		.type        = REGULATOR_VOLTAGE,                  \
+		.ops         = &g22xx_regulator_ops,               \
+		.name        = _name,                              \
+		.of_match    = _name,                              \
+		.n_voltages  = ARRAY_SIZE(_vtbl),                  \
+		.volt_table  = _vtbl,                              \
+		.id          = G2237_ID_ ## _id,                   \
+		.vsel_reg    = G2237_REG_ ## _id ## _NRMVOLT,      \
+		.vsel_mask   = G2237_ ## _id ## _NRMVOLT_MASK,     \
+		.enable_reg  = G2237_REG_ONOFF,                    \
+		.enable_mask = G2237_ ## _id ## _ON_MASK,          \
+		.enable_val  = G2237_ ## _id ## _ON_MASK,          \
+		.of_map_mode = g22xx_regulator_ ## _type ##_of_map_mode, \
+		.of_parse_cb = g22xx_regulator_of_parse_cb,        \
+	},                                                         \
+	.nmode_reg  = G2237_REG_ ## _id ## _MODE,                  \
+	.nmode_mask = G2237_ ## _id ## _NRMMODE_MASK,              \
+	.smode_reg  = G2237_REG_ ## _id ## _MODE,                  \
+	.smode_mask = G2237_ ## _id ## _SLPMODE_MASK,              \
+	.svsel_reg  = G2237_REG_ ## _id ## _SLPVOLT,               \
+	.svsel_mask = G2237_ ## _id ## _SLPVOLT_MASK,              \
+}
+
+#define G2237_DESC_FIXED_UV(_id, _name, _fixed_uV)                 \
+{                                                                  \
+	.desc = {                                                  \
+		.owner       = THIS_MODULE,                        \
+		.type        = REGULATOR_VOLTAGE,                  \
+		.ops         = &g22xx_regulator_fixed_uV_ops,      \
+		.name        = _name,                              \
+		.of_match    = _name,                              \
+		.n_voltages  = 1,                                  \
+		.fixed_uV    = _fixed_uV,                          \
+		.id          = G2237_ID_ ## _id,                   \
+		.enable_reg  = G2237_REG_ONOFF,                    \
+		.enable_mask = G2237_ ## _id ## _ON_MASK,          \
+		.enable_val  = G2237_ ## _id ## _ON_MASK,          \
+		.of_map_mode = g22xx_regulator_dc_of_map_mode,     \
+		.of_parse_cb = g22xx_regulator_of_parse_cb,        \
+	},                                                         \
+	.nmode_reg  = G2237_REG_ ## _id ## _MODE,                  \
+	.nmode_mask = G2237_ ## _id ## _NRMMODE_MASK,              \
+	.smode_reg  = G2237_REG_ ## _id ## _MODE,                  \
+	.smode_mask = G2237_ ## _id ## _SLPMODE_MASK,              \
+}
+
+/* regulator_desc */
+static struct g22xx_regulator_desc desc[G2237_ID_MAX] = {
+	[G2237_ID_DC1]  = G2237_DESC(DC1,  "dc1",  dc1_vtbl, dc),
+	[G2237_ID_DC2]  = G2237_DESC(DC2,  "dc2",  dcx_vtbl, dc),
+	[G2237_ID_DC3]  = G2237_DESC(DC3,  "dc3",  dcx_vtbl, dc),
+	[G2237_ID_DC4]  = G2237_DESC_FIXED_UV(DC4, "dc4", 0),
+	[G2237_ID_DC5]  = G2237_DESC(DC5,  "dc5",  dc5_vtbl, dc),
+	[G2237_ID_LDO1] = G2237_DESC(LDO1, "ldo1", ldo1_vtbl,  ldo),
+};
+
+/* pm */
+static int g2237_regulator_suspend(struct device *dev)
+{
+	struct g22xx_regulator_device *grdev = dev_get_drvdata(dev);
+	struct g22xx_regulator_data *pos;
+
+#ifdef CONFIG_SUSPEND
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY)
+		goto done;
+#endif
+
+	dev_info(dev, "Enter %s\n", __func__);
+	list_for_each_entry(pos, &grdev->list, list)
+		g22xx_prepare_suspend_state(pos->rdev, 0);
+	regulator_suspend_prepare(PM_SUSPEND_MEM);
+	dev_info(dev, "Exit %s\n", __func__);
+done:
+	return 0;
+}
+
+static const struct dev_pm_ops g2237_regulator_pm_ops = {
+	.suspend = g2237_regulator_suspend,
+};
+
+static int g2237_regulator_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct g22xx_device *gdev = dev_get_drvdata(dev->parent);
+	struct g22xx_regulator_device *grdev;
+	int i, ret;
+
+	grdev = devm_kzalloc(dev, sizeof(*grdev), GFP_KERNEL);
+	if (!grdev)
+		return -ENOMEM;
+
+	grdev->regmap = gdev->regmap;
+	grdev->dev = dev;
+	INIT_LIST_HEAD(&grdev->list);
+
+	for (i = 0; i < ARRAY_SIZE(desc); i++) {
+		struct regulator_dev *rdev;
+
+		rdev = g22xx_regulator_register(grdev, &desc[i]);
+		if (IS_ERR(rdev)) {
+			ret = PTR_ERR(rdev);
+			dev_err(dev, "failed to register %s: %d\n",
+				desc[i].desc.name, ret);
+			return ret;
+		}
+	}
+
+	platform_set_drvdata(pdev, grdev);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static void g2237_regulator_shutdown(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct g22xx_regulator_device *grdev = dev_get_drvdata(dev);
+	struct g22xx_regulator_data *pos;
+
+	dev_info(dev, "Enter %s\n", __func__);
+	list_for_each_entry(pos, &grdev->list, list)
+		g22xx_prepare_suspend_state(pos->rdev, 1);
+	regulator_suspend_prepare(PM_SUSPEND_MEM);
+	dev_info(dev, "Exit %s\n", __func__);
+}
+
+static const struct of_device_id g2237_regulator_ids[] = {
+	{ .compatible = "gmt,g2237-regulator", },
+	{}
+};
+MODULE_DEVICE_TABLE(i2c, g2237_regulator_ids);
+
+static struct platform_driver g2237_regulator_driver = {
+	.driver = {
+		.name = "g2237-regulator",
+		.owner = THIS_MODULE,
+		.pm = &g2237_regulator_pm_ops,
+		.of_match_table = g2237_regulator_ids,
+	},
+	.probe    = g2237_regulator_probe,
+	.shutdown = g2237_regulator_shutdown,
+};
+module_platform_driver(g2237_regulator_driver);
+
+MODULE_DESCRIPTION("GMT G2237 Regulator Driver");
+MODULE_AUTHOR("Cheng-Yu Lee <cylee12@realtek.com>");
+MODULE_LICENSE("GPL");
+
diff --git a/drivers/regulator/g22xx-regulator-core.c b/drivers/regulator/g22xx-regulator-core.c
new file mode 100644
index 00000000..6f2e2b7
--- /dev/null
+++ b/drivers/regulator/g22xx-regulator-core.c
@@ -0,0 +1,328 @@
+/*
+ * GMT-G22XX serise PMIC regulator core functions
+ *
+ * Copyright (C) 2018-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/bitops.h>
+#include <linux/of.h>
+#include <linux/regmap.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/suspend.h>
+#include <linux/sysfs.h>
+#include <linux/uaccess.h>
+#include "g22xx-regulator.h"
+
+/* of_parse_cb */
+int g22xx_regulator_of_parse_cb(struct device_node *np,
+	const struct regulator_desc *desc, struct regulator_config *config)
+{
+	struct g22xx_regulator_data *data = config->driver_data;
+	struct device_node *child;
+	unsigned int val;
+
+	child = of_get_child_by_name(np, "regulator-state-coldboot");
+	if (!child)
+		child = of_get_child_by_name(np, "regulator-state-mem");
+	if (child) {
+		struct regulator_state *state = &data->state_coldboot;
+
+		if (of_property_read_bool(child, "regulator-on-in-suspend"))
+			state->enabled = true;
+
+		if (of_property_read_bool(child, "regulator-off-in-suspend"))
+			state->disabled = true;
+
+		if (!of_property_read_u32(child, "regulator-suspend-microvolt",
+			&val))
+			state->uV = val;
+	}
+
+	if (desc->n_voltages == 1 && desc->fixed_uV == 0) {
+		u32 min = 0, max = 0;
+
+		of_property_read_u32(np, "regulator-min-microvolt", &min);
+		of_property_read_u32(np, "regulator-max-microvolt", &max);
+		WARN_ON(min != max);
+		data->fixed_uV = max;
+	}
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(g22xx_regulator_of_parse_cb);
+
+unsigned int g22xx_regulator_dc_of_map_mode(unsigned int mode)
+{
+	switch (mode) {
+	case G22XX_DC_MODE_FORCE_PWM:
+		return REGULATOR_MODE_FAST;
+	default:
+		break;
+	}
+	return REGULATOR_MODE_NORMAL;
+}
+EXPORT_SYMBOL_GPL(g22xx_regulator_dc_of_map_mode);
+
+unsigned int g22xx_regulator_ldo_of_map_mode(unsigned int mode)
+{
+	switch (mode) {
+	case G22XX_LDO_MODE_ECO:
+		return REGULATOR_MODE_IDLE;
+	default:
+		break;
+	}
+	return REGULATOR_MODE_NORMAL;
+}
+EXPORT_SYMBOL_GPL(g22xx_regulator_ldo_of_map_mode);
+
+/* regulator_ops */
+static int g22xx_regulator_set_mode_regmap(struct regulator_dev *rdev,
+	unsigned int mode)
+{
+	struct g22xx_regulator_data *data = rdev_get_drvdata(rdev);
+	struct g22xx_regulator_desc *gd = data->gd;
+	unsigned int val = 0;
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	if (!data->nmode)
+		return -EINVAL;
+
+	if (g22xx_regulator_type_is_ldo(gd))
+		val = (mode & REGULATOR_MODE_IDLE) ? 2 : 0;
+	else
+		val =  (mode & REGULATOR_MODE_FAST) ? 2 : 0;
+
+	dev_dbg(rdev_get_dev(rdev), "%s: val=%02x\n", __func__, val);
+	return regmap_field_write(data->nmode, val);
+}
+
+static unsigned int g22xx_regulator_get_mode_regmap(struct regulator_dev *rdev)
+{
+	struct g22xx_regulator_data *data = rdev_get_drvdata(rdev);
+	struct g22xx_regulator_desc *gd = data->gd;
+	unsigned int val;
+	int ret;
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	if (!data->nmode)
+		return -EINVAL;
+
+	ret = regmap_field_read(data->nmode, &val);
+	if (ret)
+		return 0;
+
+	dev_dbg(rdev_get_dev(rdev), "%s: val=%02x\n", __func__, val);
+
+	if (g22xx_regulator_type_is_ldo(gd) && val == 2)
+		return REGULATOR_MODE_IDLE;
+	else if (val == 2)
+		return REGULATOR_MODE_FAST;
+	return REGULATOR_MODE_NORMAL;
+}
+
+
+static int g22xx_set_suspend_enable(struct regulator_dev *rdev)
+{
+	struct g22xx_regulator_data *data = rdev_get_drvdata(rdev);
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	regmap_field_write(data->smode, 0x1);
+	return 0;
+}
+
+static int g22xx_set_suspend_disable(struct regulator_dev *rdev)
+{
+	struct g22xx_regulator_data *data = rdev_get_drvdata(rdev);
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	if (!data->smode)
+		return -EINVAL;
+	regmap_field_write(data->smode, 0x3);
+	return 0;
+}
+
+static int g22xx_set_suspend_voltage(struct regulator_dev *rdev,
+	int uV)
+{
+	struct g22xx_regulator_data *data = rdev_get_drvdata(rdev);
+	int vsel;
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	vsel = regulator_map_voltage_iterate(rdev, uV, uV);
+	if (vsel < 0)
+		return -EINVAL;
+
+	if (!data->smode || !data->svsel)
+		return -EINVAL;
+
+	regmap_field_write(data->smode, 0x2);
+	regmap_field_write(data->svsel, vsel);
+	return 0;
+}
+
+static int g22xx_regulator_get_voltage_fixed(struct regulator_dev *rdev)
+{
+	struct g22xx_regulator_data *data = rdev_get_drvdata(rdev);
+
+	if (data->fixed_uV)
+		return data->fixed_uV;
+	return -EINVAL;
+}
+
+const struct regulator_ops g22xx_regulator_ops = {
+	.list_voltage         = regulator_list_voltage_table,
+	.map_voltage          = regulator_map_voltage_iterate,
+	.set_voltage_sel      = regulator_set_voltage_sel_regmap,
+	.get_voltage_sel      = regulator_get_voltage_sel_regmap,
+	.enable               = regulator_enable_regmap,
+	.disable              = regulator_disable_regmap,
+	.is_enabled           = regulator_is_enabled_regmap,
+	.get_mode             = g22xx_regulator_get_mode_regmap,
+	.set_mode             = g22xx_regulator_set_mode_regmap,
+	.set_suspend_voltage  = g22xx_set_suspend_voltage,
+	.set_suspend_enable   = g22xx_set_suspend_enable,
+	.set_suspend_disable  = g22xx_set_suspend_disable,
+};
+EXPORT_SYMBOL_GPL(g22xx_regulator_ops);
+
+const struct regulator_ops g22xx_regulator_fixed_uV_ops = {
+	.enable               = regulator_enable_regmap,
+	.disable              = regulator_disable_regmap,
+	.is_enabled           = regulator_is_enabled_regmap,
+	.get_mode             = g22xx_regulator_get_mode_regmap,
+	.set_mode             = g22xx_regulator_set_mode_regmap,
+	.set_suspend_voltage  = g22xx_set_suspend_voltage,
+	.set_suspend_enable   = g22xx_set_suspend_enable,
+	.set_suspend_disable  = g22xx_set_suspend_disable,
+	.get_voltage          = g22xx_regulator_get_voltage_fixed,
+};
+EXPORT_SYMBOL_GPL(g22xx_regulator_fixed_uV_ops);
+
+/* helper function */
+/*
+ * g22xx_prepare_suspend_state - prepare g22xx suspend state, copy the correct
+ *                               state into state_mem of decs, then call
+ *                               regulator_suspend_prepare() to do regulator
+ *                               suspend.
+ *
+ * @rdev:        regulator device
+ * @is_coldboot: state selection
+ */
+void g22xx_prepare_suspend_state(struct regulator_dev *rdev,
+	int is_coldboot)
+{
+	struct g22xx_regulator_data *data = rdev_get_drvdata(rdev);
+	struct regulator_state *state;
+
+	state = &rdev->constraints->state_mem;
+	*state = is_coldboot ? data->state_coldboot : data->state_mem;
+
+	dev_info(rdev_get_dev(rdev), "%s: state={enabled=%d, disabled=%d, mode=%d, uV=%d}, is_coldboot=%d\n",
+		__func__, state->enabled, state->disabled, state->mode,
+		state->uV, is_coldboot);
+}
+EXPORT_SYMBOL_GPL(g22xx_prepare_suspend_state);
+
+static struct regmap_field *create_regmap_field(
+		struct g22xx_regulator_device *grdev,
+		u32 reg,
+		u32 mask)
+{
+	u32 msb = fls(mask) - 1;
+	u32 lsb = ffs(mask) - 1;
+	struct reg_field map = REG_FIELD(reg, lsb, msb);
+	struct regmap_field *rmap;
+
+	if (reg == 0 && mask == 0)
+		return NULL;
+
+	dev_dbg(grdev->dev, "reg=%02x, mask=%02x, lsb=%d, msb=%d\n",
+		reg, mask, lsb, msb);
+	rmap = devm_regmap_field_alloc(grdev->dev, grdev->regmap, map);
+	if (IS_ERR(rmap)) {
+		dev_err(grdev->dev, "regmap_field_alloc() for (reg=%02x, mask=%02x) returns %ld\n",
+			reg, mask, PTR_ERR(rmap));
+	}
+	return rmap;
+}
+
+struct regulator_dev *g22xx_regulator_register(
+		struct g22xx_regulator_device *grdev,
+		struct g22xx_regulator_desc *gd)
+{
+	struct device *dev = grdev->dev;
+	struct g22xx_regulator_data *data;
+	struct regulator_config config = {};
+	struct regulation_constraints *c;
+
+
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return ERR_PTR(-ENOMEM);
+
+	data->gd = gd;
+
+	data->nmode = create_regmap_field(grdev, gd->nmode_reg, gd->nmode_mask);
+	if (IS_ERR(data->nmode))
+		return ERR_CAST(data->nmode);
+	data->smode = create_regmap_field(grdev, gd->smode_reg, gd->smode_mask);
+	if (IS_ERR(data->smode))
+		return ERR_CAST(data->smode);
+	data->svsel = create_regmap_field(grdev, gd->svsel_reg, gd->svsel_mask);
+	if (IS_ERR(data->svsel))
+		return ERR_CAST(data->svsel);
+
+	config.dev         = grdev->dev;
+	config.regmap      = grdev->regmap;
+	config.driver_data = data;
+
+	data->rdev = devm_regulator_register(dev, &gd->desc, &config);
+	if (IS_ERR(data->rdev))
+		return data->rdev;
+
+	c = data->rdev->constraints;
+
+	/*
+	 * copy state_mem to data for mem/coldboot switching. if there is no
+	 * sleep uV and mode, set the state to enable
+	 */
+	data->state_mem = c->state_mem;
+	if (data->state_mem.uV == 0 && data->state_mem.disabled == 0) {
+		data->state_mem.enabled = true;
+		c->state_mem = data->state_mem;
+	}
+	if (data->state_coldboot.uV == 0 && data->state_coldboot.disabled == 0)
+		data->state_coldboot.enabled = true;
+
+	/* enable change mode */
+	c->valid_modes_mask |= REGULATOR_MODE_NORMAL;
+	if (g22xx_regulator_type_is_ldo(data->gd))
+		c->valid_modes_mask |= REGULATOR_MODE_IDLE;
+	else
+		c->valid_modes_mask |= REGULATOR_MODE_FAST;
+	c->valid_ops_mask |= REGULATOR_CHANGE_MODE;
+
+	list_add_tail(&data->list, &grdev->list);
+
+	return data->rdev;
+}
+EXPORT_SYMBOL_GPL(g22xx_regulator_register);
+
+
diff --git a/drivers/regulator/g22xx-regulator.h b/drivers/regulator/g22xx-regulator.h
new file mode 100644
index 00000000..3c530c9
--- /dev/null
+++ b/drivers/regulator/g22xx-regulator.h
@@ -0,0 +1,86 @@
+/*
+ * G22XX series PMIC regulator common
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __G22XX_REGULATOR_H
+#define __G22XX_REGULATOR_H
+
+#include <linux/i2c.h>
+#include <linux/bitops.h>
+#include <linux/list.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/regmap.h>
+#include <soc/realtek/rtk_regmap.h>
+#include <dt-bindings/regulator/gmt,g22xx.h>
+#include <linux/mfd/g22xx.h>
+
+struct g22xx_regulator_desc {
+	struct regulator_desc desc;
+	u8 nmode_reg;
+	u8 nmode_mask;
+	u8 smode_reg;
+	u8 smode_mask;
+	u8 svsel_reg;
+	u8 svsel_mask;
+};
+
+struct g22xx_regulator_data {
+	struct list_head list;
+	struct regulator_dev *rdev;
+	struct g22xx_regulator_desc *gd;
+
+	struct regmap_field *svsel;
+	struct regmap_field *nmode;
+	struct regmap_field *smode;
+
+	struct regulator_state state_mem;
+	struct regulator_state state_coldboot;
+
+	u32 fixed_uV;
+};
+
+struct g22xx_regulator_device {
+	struct device *dev;
+	struct regmap *regmap;
+	struct list_head list;
+};
+
+extern const struct regulator_ops g22xx_regulator_ops;
+extern const struct regulator_ops g22xx_regulator_fixed_uV_ops;
+
+int g22xx_regulator_of_parse_cb(struct device_node *np,
+				const struct regulator_desc *desc,
+				struct regulator_config *config);
+unsigned int g22xx_regulator_dc_of_map_mode(unsigned int mode);
+unsigned int g22xx_regulator_ldo_of_map_mode(unsigned int mode);
+void g22xx_prepare_suspend_state(struct regulator_dev *rdev, int is_coldboot);
+struct regulator_dev *g22xx_regulator_register(
+		struct g22xx_regulator_device *grdev,
+		struct g22xx_regulator_desc *gd);
+
+static inline int g22xx_regulator_type_is_ldo(struct g22xx_regulator_desc *gd)
+{
+	return gd->desc.of_map_mode == g22xx_regulator_ldo_of_map_mode;
+}
+
+
+#endif
diff --git a/drivers/regulator/i2c-selector.c b/drivers/regulator/i2c-selector.c
new file mode 100644
index 00000000..f9f62b2
--- /dev/null
+++ b/drivers/regulator/i2c-selector.c
@@ -0,0 +1,206 @@
+/*
+ * selector.c - i2c regulator selector
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ * Copyright (C) 2018 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#define pr_fmt(fmt) "selector: " fmt
+
+#include <linux/i2c.h>
+#include <linux/module.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/suspend.h>
+#include <linux/mfd/g2237.h>
+#include "internal.h"
+
+extern struct i2c_driver g2237_i2c_driver;
+extern struct i2c_driver apw8889_i2c_driver;
+enum {
+	I2C_SELECTOR_DRIVER_G2237,
+	I2C_SELECTOR_DRIVER_APW8889,
+};
+
+static struct i2c_driver selector_driver;
+
+static int selector_read_reg(struct i2c_client *i2c, u8 reg, u8 *val)
+{
+	struct i2c_msg xfer[2];
+	int ret = 0;
+
+	xfer[0].addr = i2c->addr;
+	xfer[0].flags = 0;
+	xfer[0].len = 1;
+	xfer[0].buf = &reg;
+
+	xfer[1].addr = i2c->addr;
+	xfer[1].flags = I2C_M_RD;
+	xfer[1].len = 1;
+	xfer[1].buf = val;
+
+	ret = i2c_transfer(i2c->adapter, xfer, 2);
+	if (ret == 2)
+		return 0;
+	else if (ret < 0)
+		return ret;
+	else
+		return -EIO;
+}
+
+static int selector_get_selection(struct i2c_client *client)
+{
+	u8 val;
+
+	selector_read_reg(client, G2237_REG_CHIP_ID, &val);
+	if (val == 0x25)
+		return I2C_SELECTOR_DRIVER_G2237;
+	else
+		return I2C_SELECTOR_DRIVER_APW8889;
+}
+
+static int selector_match_from_sibling(struct i2c_client *client,
+				       struct i2c_driver *selection_drv,
+				       struct device_node **out_np,
+				       const struct i2c_device_id **out_id)
+{
+	struct device *dev = &client->dev;
+	struct device_node *parent = dev->parent->of_node;
+	struct device_node *child;
+	char modalias[I2C_NAME_SIZE];
+	const struct i2c_device_id *id = selection_drv->id_table;
+	int ret;
+
+	while (id->name[0]) {
+		for_each_child_of_node(parent, child) {
+			ret = of_modalias_node(child, modalias, sizeof(modalias));
+			if (ret)
+				continue;
+			dev_dbg(dev, "%s: compare id=%s modalias=%s\n", child->name,
+				id->name, modalias);
+			if (!strcmp(id->name, modalias)) {
+				*out_np = child;
+				*out_id = id;
+				return 0;
+			}
+		}
+		id++;
+	}
+	return -EINVAL;
+}
+
+static void selector_update_selector_driver(struct i2c_driver *drv,
+					    const struct i2c_driver *src)
+{
+	WARN_ON(drv->driver.pm);
+	WARN_ON(drv->shutdown);
+	WARN_ON(drv->remove);
+
+	drv->driver.pm = src->driver.pm;
+	drv->shutdown  = src->shutdown;
+	drv->remove    = src->remove;
+}
+
+static void selector_replace_rdev_np(struct device *dev,
+				     struct device_node *selector_np,
+				     const char *selection_id)
+{
+	struct device_node *saved_np = dev->of_node;
+	struct device_node *child;
+	struct regulator *reg;
+
+	for_each_child_of_node(selector_np, child) {
+		if (!of_device_is_compatible(child, "supply-selector"))
+			continue;
+
+		dev->of_node = child;
+		reg = regulator_get(dev, selection_id);
+		if (IS_ERR(reg)) {
+			dev_err(dev, "regulator_get() with supply-name %s returns %ld\n",
+				selection_id, PTR_ERR(reg));
+			continue;
+		}
+
+		mutex_lock(&reg->rdev->mutex);
+		reg->rdev->dev.of_node = child;
+		mutex_unlock(&reg->rdev->mutex);
+
+		regulator_put(reg);
+	}
+
+	dev->of_node = saved_np;
+}
+
+static int selector_probe(struct i2c_client *client,
+			  const struct i2c_device_id *id)
+{
+	struct device *dev = &client->dev;
+	struct device_node *np = dev->of_node;
+	struct device_node *selection_np;
+	const struct i2c_device_id *selection_id;
+	struct i2c_driver *selection_driver = NULL;
+	int ret;
+
+	dev_info(dev, "%s\n", __func__);
+
+	switch (selector_get_selection(client))
+	{
+	case I2C_SELECTOR_DRIVER_G2237:
+		selection_driver = &g2237_i2c_driver;
+		break;
+	case I2C_SELECTOR_DRIVER_APW8889:
+		selection_driver = &apw8889_i2c_driver;
+		break;
+	}
+	if (!selection_driver) {
+		dev_err(dev, "no selection_driver\n");
+		return -ENODEV;
+	}
+
+	ret = selector_match_from_sibling(client, selection_driver,
+		&selection_np, &selection_id);
+	if (ret) {
+		dev_err(dev, "selector_match_from_sibling() returns %d\n", ret);
+		return ret;
+	}
+
+	dev_info(dev, "driver=%s\n", selection_driver->driver.name);
+	dev_info(dev, "id=%s\n", selection_id->name);
+	dev_info(dev, "device_node=%s\n", selection_np->name);
+
+	selector_update_selector_driver(&selector_driver, selection_driver);
+
+	/* update device */
+	dev->of_node = selection_np;
+
+	/* probe */
+	ret = selection_driver->probe(client, selection_id);
+	if (ret)
+		return ret;
+
+	selector_replace_rdev_np(dev, np, selection_id->name);
+	return 0;
+}
+
+static const struct i2c_device_id selector_ids[] = {
+	{"regulator-selector", 0},
+	{}
+};
+MODULE_DEVICE_TABLE(i2c, selector_ids);
+
+static struct i2c_driver selector_driver = {
+	.driver = {
+		.name = "reg-sel",
+		.owner = THIS_MODULE,
+	},
+	.id_table = selector_ids,
+	.probe    = selector_probe,
+};
+module_i2c_driver(selector_driver);
+
+MODULE_DESCRIPTION("Regulator Selector Driver");
+MODULE_AUTHOR("Cheng-Yu Lee <cylee12@realtek.com>");
+MODULE_LICENSE("GPL");
diff --git a/drivers/regulator/rtd119x-gpio-regulator.c b/drivers/regulator/rtd119x-gpio-regulator.c
new file mode 100644
index 00000000..b24226e
--- /dev/null
+++ b/drivers/regulator/rtd119x-gpio-regulator.c
@@ -0,0 +1,168 @@
+/*
+ * Pheonix GPIO Regulator
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ * Copyright (C) 2018 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#include <linux/delay.h>
+#include <linux/module.h>
+#include <linux/of_gpio.h>
+#include <linux/platform_device.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/of_regulator.h>
+
+struct rtd119x_regulator_data {
+	struct regulator_desc desc;
+	struct regulator_dev *rdev;
+	int gpio[2];
+	int sel;
+};
+
+static const int vtbl[] = {
+	900000, 1050000, 1200000,
+};
+
+static const int gpio_val_tbl[] = {
+	0, 1, 3,
+};
+
+static int rtd119x_gpio_list_voltage(struct regulator_dev *rdev,
+	unsigned int sel)
+{
+	if (!rdev->desc->volt_table) {
+		BUG_ON(!rdev->desc->volt_table);
+		return -EINVAL;
+	}
+
+	dev_dbg(rdev_get_dev(rdev), "%s: sel=%d\n", __func__, sel);
+
+	if (sel >= rdev->desc->n_voltages)
+		return -EINVAL;
+
+	return rdev->desc->volt_table[sel];
+}
+
+static int rtd119x_gpio_get_voltage_sel(struct regulator_dev *rdev)
+{
+	struct rtd119x_regulator_data *data = rdev_get_drvdata(rdev);
+
+	dev_dbg(rdev_get_dev(rdev), "%s: sel=%d\n", __func__, data->sel);
+	return data->sel;
+}
+
+static int rtd119x_gpio_set_voltage_sel(struct regulator_dev *rdev,
+	unsigned sel)
+{
+	struct rtd119x_regulator_data *data = rdev_get_drvdata(rdev);
+	int prev_sel = data->sel;
+	unsigned char val[2];
+
+	val[0] = gpio_val_tbl[sel] & 0x1;
+	val[1] = (gpio_val_tbl[sel] >> 1) & 0x1;
+
+	if (prev_sel < sel) {
+		gpio_set_value(data->gpio[0], val[0]);
+		if (prev_sel == 0 && sel == 2)
+			udelay(20);
+		gpio_set_value(data->gpio[1], val[1]);
+	} else {
+		gpio_set_value(data->gpio[1], val[1]);
+		if (prev_sel == 2 && sel == 0)
+			udelay(20);
+		gpio_set_value(data->gpio[0], val[0]);
+	}
+	data->sel = sel;
+	return 0;
+}
+
+static struct regulator_ops rtd119x_gpio_regulator_ops = {
+	.list_voltage    = rtd119x_gpio_list_voltage,
+	.set_voltage_sel = rtd119x_gpio_set_voltage_sel,
+	.get_voltage_sel = rtd119x_gpio_get_voltage_sel,
+};
+
+static const struct regulator_desc common_desc = {
+	.ops        = &rtd119x_gpio_regulator_ops,
+	.n_voltages = ARRAY_SIZE(vtbl),
+	.volt_table = vtbl,
+	.type       = REGULATOR_VOLTAGE,
+	.owner      = THIS_MODULE,
+};
+
+static int rtd119x_gpio_regulator_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	struct rtd119x_regulator_data *data;
+	struct regulator_config cfg = {};
+	const struct regulator_init_data *init_data;
+	int ret;
+
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	data->gpio[0] = of_get_gpio(np, 0);
+	data->gpio[1] = of_get_gpio(np, 1);
+	if (!data->gpio[0] || !data->gpio[1])
+		return -ENOMEM;
+
+	ret = devm_gpio_request(dev, data->gpio[0], "voltage control-0");
+	if (ret) {
+		dev_err(dev, "gpio_request() returns %d for gpio-0\n", ret);
+		return ret;
+	}
+
+	ret = devm_gpio_request(dev, data->gpio[1], "voltage control-1");
+	if (ret) {
+		dev_err(dev, "gpio_request() returns %d for gpio-1\n", ret);
+		return ret;
+	}
+
+	data->sel = 2;
+	memcpy(&data->desc, &common_desc, sizeof(struct regulator_desc));
+	data->desc.name = devm_kstrdup(dev, np->name, GFP_KERNEL);
+
+	init_data = of_get_regulator_init_data(dev, np, &data->desc);
+	if (!init_data) {
+		dev_err(dev, "of_get_regulator_init_data() returns NULL\n");
+		return -EINVAL;
+	}
+
+	cfg.of_node     = np;
+	cfg.dev         = dev;
+	cfg.init_data   = init_data;
+	cfg.driver_data = data;
+
+	data->rdev = devm_regulator_register(dev, &data->desc, &cfg);
+	if (IS_ERR(data->rdev)) {
+		ret = PTR_ERR(data->rdev);
+		dev_err(dev, "regulator_register() returns %d\n", ret);
+		return ret;
+	}
+	return 0;
+}
+
+
+static struct of_device_id rtd119x_gpio_regulator_ids[] = {
+	{ .compatible = "realtek,rtd119x-gpio-regulator" },
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtd119x_gpio_regulator_id);
+
+static struct platform_driver rtd119x_gpio_regulator_driver = {
+	.probe  = rtd119x_gpio_regulator_probe,
+	.driver	= {
+		.name	= "rtd119x-gpio-regulator",
+		.of_match_table = rtd119x_gpio_regulator_ids,
+	},
+};
+module_platform_driver(rtd119x_gpio_regulator_driver);
+
+MODULE_DESCRIPTION("GPIO Regulator for RTD-119x Platform");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtd119x-gpio-regulator");
diff --git a/drivers/regulator/rtk-pwm-regulator.c b/drivers/regulator/rtk-pwm-regulator.c
new file mode 100644
index 00000000..7808703
--- /dev/null
+++ b/drivers/regulator/rtk-pwm-regulator.c
@@ -0,0 +1,237 @@
+/*
+ * rtk-pwm-regulator.c - Realtek PWM Regulator Driver
+ *
+ * Copyright (C) 2018,2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+#include <linux/module.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/pwm.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/of_regulator.h>
+#include <linux/regulator/machine.h>
+#include <linux/slab.h>
+
+struct pwm_voltage {
+	unsigned int volt;
+	unsigned int duty;
+	unsigned int period;
+};
+
+struct pwm_regulator_data {
+	struct regulator_desc desc;
+	const struct regulator_init_data *init_data;
+	struct pwm_device *pwm;
+	struct pwm_voltage *volt_table;
+	int n_volts;
+	int sel;
+};
+
+static int rtk_pwm_regulator_get_voltage(struct regulator_dev *rdev)
+{
+	struct pwm_regulator_data *data = rdev_get_drvdata(rdev);
+
+	return data->volt_table[data->sel].volt;
+}
+
+static int rtk_pwm_regulator_set_voltage(struct regulator_dev *rdev,
+	int min_uV, int max_uV, unsigned *selector)
+{
+	struct pwm_regulator_data *data = rdev_get_drvdata(rdev);
+	struct pwm_voltage *p = NULL;
+	int i;
+	int best_volt = INT_MAX;
+
+	for (i = 0; i < data->n_volts; i++) {
+		if (data->volt_table[i].volt < best_volt &&
+			data->volt_table[i].volt >= min_uV &&
+			data->volt_table[i].volt <= max_uV) {
+			p = &data->volt_table[i];
+			best_volt = data->volt_table[i].volt;
+			if (selector)
+				*selector = i;
+		}
+	}
+
+	if (!p)
+		return -EINVAL;
+
+	pwm_config(data->pwm, p->duty, p->period);
+	data->sel = *selector;
+
+	return 0;
+}
+
+static int rtk_pwm_regulator_list_voltage(struct regulator_dev *rdev,
+	unsigned selector)
+{
+	struct pwm_regulator_data *data = rdev_get_drvdata(rdev);
+
+	if (selector >= data->n_volts)
+		return -EINVAL;
+
+	return data->volt_table[selector].volt;
+}
+
+static int rtk_pwm_regulator_enable(struct regulator_dev *dev)
+{
+	struct pwm_regulator_data *data = rdev_get_drvdata(dev);
+
+	return pwm_enable(data->pwm);
+}
+
+static int rtk_pwm_regulator_disable(struct regulator_dev *dev)
+{
+	struct pwm_regulator_data *data = rdev_get_drvdata(dev);
+
+	pwm_disable(data->pwm);
+	return 0;
+}
+static struct regulator_ops rtk_pwm_regulator_ops  = {
+	.list_voltage = rtk_pwm_regulator_list_voltage,
+	.set_voltage  = rtk_pwm_regulator_set_voltage,
+	.get_voltage  = rtk_pwm_regulator_get_voltage,
+	.enable       = rtk_pwm_regulator_enable,
+	.disable      = rtk_pwm_regulator_disable,
+};
+
+static const struct regulator_desc common_desc = {
+	.owner       = THIS_MODULE,
+	.name        = "rtk-pwm-regulator",
+	.ops         = &rtk_pwm_regulator_ops,
+	.type        = REGULATOR_VOLTAGE,
+	.supply_name = "pwm",
+};
+
+static int of_parse_voltage_table(struct device *dev, struct device_node *np,
+	struct pwm_regulator_data *data)
+{
+	unsigned int len = 0;
+	int i;
+	struct pwm_voltage *pvolt;
+	int prop_len;
+	const unsigned int *prop_val;
+
+	prop_val = of_get_property(np, "voltage-table", &prop_len);
+	prop_len /= sizeof(unsigned int);
+	if (!prop_val || (prop_len / 3) == 0 || (prop_len % 3) != 0)
+		return -EINVAL;
+
+	len = prop_len / 3;
+	pvolt = devm_kcalloc(dev, sizeof(*data->volt_table), len, GFP_KERNEL);
+	if (!pvolt)
+		return -ENOMEM;
+
+	for (i = 0; i < len; i++) {
+		pvolt[i].volt   = of_read_number(prop_val++, 1);
+		pvolt[i].duty   = of_read_number(prop_val++, 1);
+		pvolt[i].period = of_read_number(prop_val++, 1);
+
+		dev_dbg(dev, "%s: volt_table[%d]: v=%d d=%d p=%d\n", __func__,
+			i, pvolt[i].volt, pvolt[i].duty, pvolt[i].period);
+	}
+
+	data->volt_table = pvolt;
+	data->n_volts = len;
+	return 0;
+}
+
+static int of_config_pwm_regulator(struct device *dev, struct device_node *np,
+	struct pwm_regulator_data *data)
+{
+	const struct regulator_init_data *init_data;
+	int ret;
+
+	data->pwm = devm_of_pwm_get(dev, np, NULL);
+	if (IS_ERR(data->pwm)) {
+		ret = PTR_ERR(data->pwm);
+		if (ret != -EPROBE_DEFER)
+			dev_err(dev, "failed to get pwm: %d\n", ret);
+		return ret;
+	}
+
+	init_data = of_get_regulator_init_data(dev, np, &data->desc);
+	if (!init_data) {
+		dev_err(dev, "failed to get regulator_init_data\n");
+		return -ENOMEM;
+	}
+	data->init_data = init_data;
+
+	ret = of_parse_voltage_table(dev, np, data);
+	if (ret) {
+		dev_err(dev, "failed to parse voltage-table: %d\n", ret);
+		return ret;
+	}
+
+	return 0;
+}
+
+static int rtk_pwm_regulator_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct pwm_regulator_data *data;
+	struct regulator_config config = { 0 };
+	struct regulator_dev *rdev;
+	int ret;
+
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	memcpy(&data->desc, &common_desc, sizeof(common_desc));
+
+	ret = of_config_pwm_regulator(dev, dev->of_node, data);
+	if (ret)
+		return ret;
+
+	config.of_node     = dev->of_node;
+	config.dev         = dev;
+	config.driver_data = data;
+	config.init_data   = data->init_data;
+
+	ret = pwm_adjust_config(data->pwm);
+	if (ret)
+		return ret;
+
+	rdev = devm_regulator_register(dev, &data->desc, &config);
+	if (IS_ERR(rdev)) {
+		ret = PTR_ERR(rdev);
+		dev_err(dev, "failed to register regulator: %d\n", ret);
+		return ret;
+	}
+
+	dev_info(dev, "initialized");
+	return 0;
+}
+
+static const struct of_device_id rtk_pwm_regulator_ids[] = {
+	{.compatible = "realtek,pwm-regulator" },
+	{}
+};
+
+static struct platform_driver rtk_pwm_regulator_driver = {
+	.probe  = rtk_pwm_regulator_probe,
+	.driver = {
+		.name   = "rtk-pwm-regulator",
+		.owner  = THIS_MODULE,
+		.of_match_table = of_match_ptr(rtk_pwm_regulator_ids),
+	},
+};
+module_platform_driver(rtk_pwm_regulator_driver);
+
diff --git a/drivers/regulator/rtkgpio-regulator.c b/drivers/regulator/rtkgpio-regulator.c
new file mode 100644
index 00000000..c60fc35
--- /dev/null
+++ b/drivers/regulator/rtkgpio-regulator.c
@@ -0,0 +1,139 @@
+#include <linux/module.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/of_regulator.h>
+#include <linux/platform_device.h>
+#include <linux/of_gpio.h>
+#include <linux/delay.h>
+#include <linux/of_address.h>
+
+static struct of_regulator_match rtkgpio_matches[] = {
+	{ .name = "rtkgpio_regulator", .driver_data = NULL, },
+};
+
+int gpio0, gpio1, voltage;
+static const unsigned int rtkgpio_dcdc_map[] = {
+	0, 2, 3,
+};
+
+static int rtkgpio_list_voltage(struct regulator_dev *rdev, unsigned int sel)
+{	
+	if (!rdev->desc->volt_table) {
+		BUG_ON(!rdev->desc->volt_table);
+		return -EINVAL;
+	}
+
+	if (sel >= rdev->desc->n_voltages)
+		return -EINVAL;
+
+	return rdev->desc->volt_table[sel];
+}
+static int rtkgpio_get_voltage_sel(struct regulator_dev *rdev)
+{
+	return voltage;
+}
+
+static int rtkgpio_set_voltage_sel(struct regulator_dev *rdev, unsigned sel)
+{
+//	struct rtk_pmic_dev *pmic_dev = rdev_get_drvdata(rdev);
+	unsigned char val;
+
+	val = rtkgpio_dcdc_map[sel];
+	gpio_set_value(gpio0, val&0x1);
+	gpio_set_value(gpio1, (val&0x2)>>1);
+
+	voltage = sel;	
+	return 0;
+}
+
+static struct regulator_ops rtkgpio_regulator_ops = {
+	.list_voltage = rtkgpio_list_voltage,
+	.set_voltage_sel = rtkgpio_set_voltage_sel,
+	.get_voltage_sel = rtkgpio_get_voltage_sel,
+//	.enable = gmt_g2227_enable,
+//	.disable = gmt_g2227_disable,
+//	.is_enabled = regulator_is_enabled_regmap,
+};
+
+static const unsigned int rtkgpio_dcdc1_vtbl[] = {
+	850000, 950000, 1050000,
+};
+
+
+static struct regulator_desc rtkgpio_regulator_desc[] = {
+	{
+		.name = "rtkgpio_regulator",
+		.id = 0,
+		.ops = &rtkgpio_regulator_ops,
+		.n_voltages = ARRAY_SIZE(rtkgpio_dcdc1_vtbl),
+		.volt_table = rtkgpio_dcdc1_vtbl,
+		.type = REGULATOR_VOLTAGE,
+		.owner = THIS_MODULE,
+//		.vsel_reg = 0x13,
+//		.vsel_mask = 0xC0,
+//		.enable_reg = 0x5,
+//		.enable_mask = 1 << 7,
+	},
+};
+
+static int rtkgpio_regulator_probe(struct platform_device *pdev)
+{
+	struct regulator_config cfg = { };
+	struct of_regulator_match *match;
+	struct regulator_dev *rdev;
+	struct device *dev = &pdev->dev;
+
+	gpio0 = of_get_gpio(dev->of_node, 0);
+	gpio1 = of_get_gpio(dev->of_node, 1);
+
+	if(gpio_request(gpio0, dev->of_node->name))
+		printk(KERN_ERR "gpio_request gpio0 fail\n");
+
+	if(gpio_request(gpio1, dev->of_node->name))
+		printk(KERN_ERR "gpio_request gpio1 fail\n");
+
+	voltage = 1;	//default 950000
+
+	match = rtkgpio_matches;
+	of_regulator_match(dev, dev->of_node, match, ARRAY_SIZE(rtkgpio_matches));
+	
+	cfg.dev = dev;
+	cfg.init_data = match[0].init_data;
+	cfg.driver_data = dev_get_drvdata(&pdev->dev);
+
+	rdev = devm_regulator_register(dev, &rtkgpio_regulator_desc[0], &cfg);
+	return 0;
+}
+
+
+static struct of_device_id rtkgpio_regulator_id[] = {
+	{ .compatible = "rtkgpio-regulator" },
+	{ /* Sentinel */ },
+};
+MODULE_DEVICE_TABLE(of, rtkgpio_regulator_id);
+
+static struct platform_driver rtkgpio_regulator_driver = {
+	.probe = rtkgpio_regulator_probe,
+//	.remove = rtkgpio_regulator_remove,
+	.driver		= {
+		.name	= "rtkgpio-regulator",
+		.of_match_table = rtkgpio_regulator_id,
+	},
+};
+
+static int __init rtkgpio_regulator_init(void)
+{
+	return platform_driver_register(&rtkgpio_regulator_driver);
+}
+subsys_initcall(rtkgpio_regulator_init);
+
+static void __exit rtkgpio_regulator_exit(void)
+{
+	platform_driver_unregister(&rtkgpio_regulator_driver);
+}
+module_exit(rtkgpio_regulator_exit);
+
+/* Module information */
+MODULE_AUTHOR("Simon Hsu");
+MODULE_DESCRIPTION("RTK GPIO voltage and current regulator driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtk-gpio-regulator");
diff --git a/drivers/regulator/sy8827e-regulator.c b/drivers/regulator/sy8827e-regulator.c
new file mode 100644
index 00000000..720a967
--- /dev/null
+++ b/drivers/regulator/sy8827e-regulator.c
@@ -0,0 +1,415 @@
+/*
+ * sy8827e-regulator.c - Silergy-SY8827E Regulator Driver
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ * Copyright (C) 2018 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#define pr_fmt(fmt) "sy8827e: " fmt
+
+#include <linux/i2c.h>
+#include <linux/module.h>
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/regulator/of_regulator.h>
+#include <linux/regulator/sy8827e.h>
+#include <linux/regmap.h>
+#include <linux/suspend.h>
+#include <soc/realtek/rtk_regmap.h>
+
+struct sy8827e_data {
+	const struct regulator_init_data *init_data;
+	struct regmap *regmap;
+	struct i2c_client *client;
+	struct device *dev;
+	struct regulator_dev *rdev;
+
+	struct regulator_state state_suspend;
+	struct regulator_state state_coldboot;
+
+	struct regmap_field *nmode;
+	struct regmap_field *smode;
+	struct regmap_field *svsel;
+	struct regmap_field *sen;
+};
+
+static void sy8827e_regulator_prepare_state_suspend(struct sy8827e_data *data,
+	int is_coldboot)
+{
+	struct regulator_state *state;
+
+	state = &data->rdev->constraints->state_mem;
+	*state = is_coldboot ? data->state_coldboot : data->state_suspend;
+}
+
+/* of_map_mode */
+static unsigned int sy8827e_regulator_of_map_mode(unsigned int mode)
+{
+	if (mode == 1)
+		return REGULATOR_MODE_FAST;
+	return REGULATOR_MODE_NORMAL;
+}
+
+static unsigned int sy8827e_regulator_get_mode(struct regulator_dev *rdev)
+{
+	struct sy8827e_data *data = rdev_get_drvdata(rdev);
+	unsigned int val;
+	int ret;
+
+	ret = regmap_field_read(data->nmode, &val);
+	if (ret)
+		return ret;
+	return val == 1 ? REGULATOR_MODE_FAST : REGULATOR_MODE_NORMAL;
+}
+
+static int sy8827e_regulator_set_mode(struct regulator_dev *rdev,
+	unsigned int mode)
+{
+	struct sy8827e_data *data = rdev_get_drvdata(rdev);
+	unsigned int val = 0;
+
+	if (mode & REGULATOR_MODE_FAST)
+		val = 1;
+	regmap_field_write(data->nmode, val);
+	return 0;
+}
+
+static int sy8827e_regulator_set_suspend_voltage(struct regulator_dev *rdev,
+	int uV)
+{
+	struct sy8827e_data *data = rdev_get_drvdata(rdev);
+	int vsel;
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	vsel = regulator_map_voltage_linear(rdev, uV, uV);
+	if (vsel < 0)
+		return -EINVAL;
+
+	regmap_field_write(data->sen, 1);
+	regmap_field_write(data->svsel, vsel);
+	return 0;
+}
+
+static int sy8827e_regulator_set_suspend_enable(struct regulator_dev *rdev)
+{
+	struct sy8827e_data *data = rdev_get_drvdata(rdev);
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	regmap_field_write(data->sen, 1);
+	return 0;
+}
+
+static int sy8827e_regulator_set_suspend_disable(struct regulator_dev *rdev)
+{
+	struct sy8827e_data *data = rdev_get_drvdata(rdev);
+
+	dev_dbg(rdev_get_dev(rdev), "%s\n", __func__);
+	regmap_field_write(data->sen, 0);
+	return 0;
+}
+
+
+static const struct regulator_ops sy8827e_regulator_ops = {
+	.get_voltage_sel     = regulator_get_voltage_sel_regmap,
+	.set_voltage_sel     = regulator_set_voltage_sel_regmap,
+	.list_voltage        = regulator_list_voltage_linear,
+	.map_voltage         = regulator_map_voltage_linear,
+	.enable              = regulator_enable_regmap,
+	.disable             = regulator_disable_regmap,
+	.is_enabled          = regulator_is_enabled_regmap,
+	.get_mode            = sy8827e_regulator_get_mode,
+	.set_mode            = sy8827e_regulator_set_mode,
+	.set_suspend_voltage = sy8827e_regulator_set_suspend_voltage,
+	.set_suspend_enable  = sy8827e_regulator_set_suspend_enable,
+	.set_suspend_disable = sy8827e_regulator_set_suspend_disable,
+};
+
+static const struct regulator_desc sy8827e_desc = {
+	.owner           = THIS_MODULE,
+	.name            = "silergy-sy8827e",
+	.ops             = &sy8827e_regulator_ops,
+	.type            = REGULATOR_VOLTAGE,
+	.of_map_mode     = sy8827e_regulator_of_map_mode,
+	.min_uV          = 712500,
+	.uV_step         = 12500,
+	.n_voltages      = 64,
+	.vsel_reg        = SY8827E_REG_VSEL0,
+	.vsel_mask       = SY8827E_NSEL0_MASK,
+	.enable_reg      = SY8827E_REG_VSEL0,
+	.enable_mask     = SY8827E_BUCK_EN0_MASK,
+	.enable_val      = SY8827E_BUCK_EN0_MASK,
+	.disable_val     = 0,
+};
+
+/* regmap */
+static const struct reg_default sy8827e_regmap_defaults[] = {
+	{ .reg = SY8827E_REG_VSEL0, .def = 0x97, },
+	{ .reg = SY8827E_REG_VSEL1, .def = 0x97, },
+};
+
+static bool sy8827e_regmap_writeable_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case SY8827E_REG_VSEL0:
+	case SY8827E_REG_VSEL1:
+		return true;
+	}
+	return false;
+}
+
+static bool sy8827e_regmap_readable_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case SY8827E_REG_VSEL0:
+	case SY8827E_REG_VSEL1:
+	case SY8827E_REG_ID0:
+	case SY8827E_REG_ID1:
+		return true;
+	}
+	return false;
+}
+
+static bool sy8827e_regmap_volatile_reg(struct device *dev, unsigned int reg)
+{
+	switch (reg) {
+	case SY8827E_REG_ID0:
+	case SY8827E_REG_ID1:
+		return true;
+	}
+	return false;
+}
+
+static const struct regmap_config sy8827e_regmap_config = {
+	.reg_bits         = 8,
+	.val_bits         = 8,
+	.max_register     = 0x05,
+	.cache_type       = REGCACHE_FLAT,
+	.reg_defaults     = sy8827e_regmap_defaults,
+	.num_reg_defaults = ARRAY_SIZE(sy8827e_regmap_defaults),
+	.writeable_reg    = sy8827e_regmap_writeable_reg,
+	.readable_reg     = sy8827e_regmap_readable_reg,
+	.volatile_reg     = sy8827e_regmap_volatile_reg,
+};
+
+/* pm */
+static int sy8827e_regulator_suspend(struct device *dev)
+{
+	struct sy8827e_data *data = dev_get_drvdata(dev);
+
+#ifdef CONFIG_SUSPEND
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY)
+		goto done;
+#endif
+	dev_info(dev, "Enter %s\n", __func__);
+	sy8827e_regulator_prepare_state_suspend(data, 0);
+	regulator_suspend_prepare(PM_SUSPEND_MEM);
+	dev_info(dev, "Exit %s\n", __func__);
+done:
+	return 0;
+}
+
+static const struct dev_pm_ops sy8827e_regulator_pm_ops = {
+	.suspend = sy8827e_regulator_suspend,
+};
+
+static int of_parse_regulator_state(struct device_node *np,
+	struct regulator_state *state)
+{
+	unsigned int val;
+
+	if (!np)
+		return -ENOENT;
+
+	if (of_property_read_bool(np, "regulator-on-in-suspend"))
+		state->enabled = true;
+
+	if (of_property_read_bool(np, "regulator-off-in-suspend"))
+		state->disabled = true;
+
+	if (!of_property_read_u32(np, "regulator-suspend-microvolt", &val))
+		state->uV = val;
+
+	/* if no config */
+	if (state->uV == 0 && state->disabled == 0)
+		state->enabled = true;
+
+	return 0;
+}
+
+static int of_config_sy8827e_regulator(struct device *dev,
+	struct device_node *np, struct sy8827e_data *data)
+{
+	const struct regulator_init_data *init_data;
+	struct device_node *child;
+
+	init_data = of_get_regulator_init_data(dev, np, &sy8827e_desc);
+	if (!init_data)	{
+		dev_err(dev, "failed to get regulator_init_data\n");
+		return -ENOMEM;
+	}
+	data->init_data = init_data;
+
+	child = of_get_child_by_name(np, "regulator-state-mem");
+	if (child)
+		of_parse_regulator_state(child, &data->state_suspend);
+
+	child = of_get_child_by_name(np, "regulator-state-coldboot");
+	if (child)
+		of_parse_regulator_state(child, &data->state_coldboot);
+	else
+		data->state_coldboot = data->state_suspend;
+
+	return 0;
+}
+
+static struct regmap_field *create_regmap_field(struct sy8827e_data *data,
+        u32 reg, u32 mask)
+{
+	u32 msb = fls(mask) - 1;
+	u32 lsb = ffs(mask) - 1;
+	struct reg_field map = REG_FIELD(reg, lsb, msb);
+	struct regmap_field *rmap;
+
+	if (reg == 0 && mask == 0)
+		return NULL;
+	dev_dbg(data->dev, "reg=%02x, mask=%02x, lsb=%d, msb=%d\n",
+		reg, mask, lsb, msb);
+	rmap = devm_regmap_field_alloc(data->dev, data->regmap, map);
+	if (IS_ERR(rmap)) {
+		dev_err(data->dev, "failed to alloc regmap_field (reg=%02x, mask=%02x): %ld\n",
+			reg, mask, PTR_ERR(rmap));
+	}
+	return rmap;
+}
+
+static int sy8827e_init_regmap_fields(struct sy8827e_data *data)
+{
+	data->sen = create_regmap_field(data, SY8827E_REG_VSEL1, SY8827E_BUCK_EN1_MASK);
+	if (IS_ERR(data->sen))
+		return PTR_ERR(data->sen);
+	data->svsel = create_regmap_field(data, SY8827E_REG_VSEL1, SY8827E_NSEL1_MASK);
+	if (IS_ERR(data->svsel))
+		return PTR_ERR(data->svsel);
+	data->smode = create_regmap_field(data, SY8827E_REG_VSEL1, SY8827E_MODE1_MASK);
+	if (IS_ERR(data->smode))
+		return PTR_ERR(data->smode);
+	data->nmode = create_regmap_field(data, SY8827E_REG_VSEL0, SY8827E_MODE0_MASK);
+	if (IS_ERR(data->nmode))
+		return PTR_ERR(data->nmode);
+	return 0;
+}
+
+
+static int sy8827e_regulator_probe(struct i2c_client *client,
+	const struct i2c_device_id *id)
+{
+	struct device *dev = &client->dev;
+	struct device_node *np = dev->of_node;
+	struct sy8827e_data *data;
+	struct regulator_config config = { 0 };
+	struct regmap *regmap;
+	struct regulation_constraints *c;
+	int ret;
+	u32 chip_id, rev;
+
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	regmap = devm_rtk_regmap_init_i2c(client, &sy8827e_regmap_config);
+	if (IS_ERR(regmap))
+		return -EINVAL;
+
+	data->regmap = regmap;
+	data->client = client;
+	data->dev    = dev;
+
+	ret = regmap_read(data->regmap, SY8827E_REG_ID0, &chip_id);
+	if (ret) {
+		dev_err(dev, "failed to read chip_id: %d\n", ret);
+		return ret;
+	}
+	if (chip_id != 0x88) {
+		dev_err(dev, "chip_id(%02x) not match\n", chip_id);
+		return -EINVAL;
+	}
+	regmap_read(data->regmap, SY8827E_REG_ID1, &rev);
+	dev_info(dev, "sy8827e(%02x) rev%d\n", chip_id, rev);
+
+	ret = of_config_sy8827e_regulator(dev, np, data);
+	if (ret) {
+		dev_err(dev, "of_config_sy8827e_regulator() returns %d\n", ret);
+		return ret;
+	}
+
+	/* if not config from dt */
+	if (data->state_suspend.uV == 0 && data->state_suspend.disabled == 0)
+		data->state_suspend.enabled = true;
+	if (data->state_coldboot.uV == 0 && data->state_coldboot.disabled == 0)
+		data->state_coldboot.enabled = true;
+
+	ret = sy8827e_init_regmap_fields(data);
+	if (ret) {
+		dev_err(dev, "sy8827e_init_regmap_fields() returns %d\n", ret);
+		return ret;
+	}
+
+	/* enable opmode */
+	c = (void *)&data->init_data->constraints;
+	c->valid_modes_mask |= REGULATOR_MODE_NORMAL | REGULATOR_MODE_FAST;
+	c->valid_ops_mask |= REGULATOR_CHANGE_MODE;
+
+	config.of_node     = np;
+	config.dev         = dev;
+	config.driver_data = data;
+	config.init_data   = data->init_data;
+	config.regmap      = regmap;
+
+	data->rdev = devm_regulator_register(dev, &sy8827e_desc, &config);
+	if (IS_ERR(data->rdev)) {
+		ret = PTR_ERR(data->rdev);
+		dev_err(dev, "regulator_register() returns %d\n", ret);
+		return ret;
+	}
+
+	i2c_set_clientdata(client, data);
+
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static void sy8827e_regulator_shutdown(struct i2c_client *client)
+{
+	struct device *dev = &client->dev;
+	struct sy8827e_data *data = i2c_get_clientdata(client);
+
+	dev_info(dev, "enter %s\n", __func__);
+	sy8827e_regulator_prepare_state_suspend(data, 1);
+	regulator_suspend_prepare(PM_SUSPEND_MEM);
+	dev_info(dev, "exit %s\n", __func__);
+}
+
+static const struct i2c_device_id sy8827e_regulator_ids[] = {
+	{"sy8827e", 0},
+	{}
+};
+MODULE_DEVICE_TABLE(i2c, sy8827e_regulator_ids);
+
+static struct i2c_driver sy8827e_regulator_driver = {
+	.driver = {
+		.name = "silergy-sy8827e",
+		.owner = THIS_MODULE,
+		.pm = &sy8827e_regulator_pm_ops,
+	},
+	.id_table = sy8827e_regulator_ids,
+	.probe    = sy8827e_regulator_probe,
+	.shutdown = sy8827e_regulator_shutdown,
+};
+module_i2c_driver(sy8827e_regulator_driver);
+
+MODULE_DESCRIPTION("Silergy-SY8827E Regulator Driver");
+MODULE_AUTHOR("Cheng-Yu Lee <cylee12@realtek.com>");
+MODULE_LICENSE("GPL");
diff --git a/drivers/regulator/xen-regback/Makefile b/drivers/regulator/xen-regback/Makefile
new file mode 100644
index 00000000..1dd9276
--- /dev/null
+++ b/drivers/regulator/xen-regback/Makefile
@@ -0,0 +1 @@
+obj-y += xenbus.o regback.o 
diff --git a/drivers/regulator/xen-regback/common.h b/drivers/regulator/xen-regback/common.h
new file mode 100644
index 00000000..d2725cf
--- /dev/null
+++ b/drivers/regulator/xen-regback/common.h
@@ -0,0 +1,29 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ * Copyright (C) 2017 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __XEN_REGBACK_COMMON_H__
+#define __XEN_REGBACK_COMMON_H__
+
+int xen_regif_xenbus_init(void);
+
+struct device;
+
+#define VREG_MAX_REGULATOR_SIZE 10
+
+void vreg_reset(void);
+int vreg_regulator_get(struct device *dev, const char *name);
+void vreg_regulator_put(int id);
+int vreg_regulator_set_volt(int id, int vsel);
+int vreg_regulator_get_volt(int id);
+int vreg_regulator_count_voltages(int id);
+int vreg_regulator_list_voltage(int id, int sel);
+int vreg_regulator_get_constraints(int id, int csel);
+
+
+#endif /* __XEN_REGBACK_COMMON_H__ */
diff --git a/drivers/regulator/xen-regback/regback.c b/drivers/regulator/xen-regback/regback.c
new file mode 100644
index 00000000..add1db5
--- /dev/null
+++ b/drivers/regulator/xen-regback/regback.c
@@ -0,0 +1,146 @@
+/*
+ * regback.c - xen regulator backend driver
+ *
+ * Copyright (C) 2016 Realtek Semiconductor Corporation
+ * Copyright (C) 2016 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#define pr_fmt(fmt) "regif-be: " fmt
+
+#include <linux/regulator/consumer.h>
+#include <linux/regulator/machine.h>
+#include <linux/regulator/driver.h>
+#include <linux/list.h>
+#include <xen/xen.h>
+#include "regif.h"
+#include "common.h"
+#include "../internal.h"
+
+struct vreg_info {
+	int id;
+	struct regulator *regulator;
+	char name[REGIF_NAME_LENGTH];
+};
+
+static int vreg_list_count = 0;
+static struct vreg_info vreg_list[VREG_MAX_REGULATOR_SIZE];
+#define vreg_to_regulator(_id)  (vreg_list[(_id)].regulator)
+
+void vreg_reset(void)
+{
+	int i;
+	vreg_list_count = 0;
+	for (i = 0; i < VREG_MAX_REGULATOR_SIZE; i++) {
+		vreg_list[i].id = 0;
+		vreg_list[i].regulator = NULL;
+		vreg_list[i].name[0] = 0;
+	}
+}
+
+int vreg_regulator_get(struct device *dev, const char *name)
+{
+	struct regulator *regulator;
+	int i;
+
+	/* list is full */
+	if (vreg_list_count >= VREG_MAX_REGULATOR_SIZE) {
+		WARN_ON(1);
+		return -ENOSPC;
+	}
+
+	/* find an existing resource */
+	for (i = 0; i < vreg_list_count; i++)
+		if (strcmp(name, vreg_list[i].name) == 0 &&
+			vreg_list[i].regulator != NULL)
+			return i;
+
+	/* if not existed, try to get */
+	regulator = devm_regulator_get(dev, name);
+	if (IS_ERR_OR_NULL(regulator))
+		return -EINVAL;
+
+	/* add to the list */
+	i = vreg_list_count;
+	vreg_list[i].id = i;
+	vreg_list[i].regulator = regulator;
+	strncpy(vreg_list[i].name, name, REGIF_NAME_LENGTH);
+	vreg_list_count ++;
+
+	return vreg_list[i].id;
+}
+
+void vreg_regulator_put(int id)
+{
+	struct regulator *regulator = vreg_to_regulator(id);
+	regulator_put(regulator);
+	vreg_list[id].regulator = NULL;
+}
+
+int vreg_regulator_set_volt(int id, int vsel)
+{
+	struct regulator *regulator = vreg_to_regulator(id);
+	int ret;
+
+	ret = regulator_list_voltage(regulator, vsel);
+	return regulator_set_voltage(regulator, ret, ret);
+}
+
+int vreg_regulator_get_volt(int id)
+{
+	struct regulator *regulator = vreg_to_regulator(id);
+	return regulator_get_voltage(regulator);
+}
+
+int vreg_regulator_count_voltages(int id)
+{
+	struct regulator *regulator = vreg_to_regulator(id);
+	return regulator_count_voltages(regulator);
+}
+
+int vreg_regulator_list_voltage(int id, int sel)
+{
+	struct regulator *regulator = vreg_to_regulator(id);
+	return regulator_list_voltage(regulator, sel);
+}
+
+int vreg_regulator_get_constraints(int id, int csel)
+{
+	struct regulator *regulator = vreg_to_regulator(id);
+	int ret = -1;
+	switch (csel) {
+	case VREG_CONSTRAINTS_MAX_VOLT:
+		ret = regulator->rdev->constraints->max_uV;
+		break;
+	case VREG_CONSTRAINTS_MIN_VOLT:
+		ret = regulator->rdev->constraints->min_uV;
+		break;
+	case VREG_CONSTRAINTS_BOOT_ON:
+		ret = regulator_is_enabled(regulator);
+		break;
+	case VREG_CONSTRAINTS_ALWAYS_ON:
+		ret = regulator->rdev->constraints->always_on;
+		break;
+	case VREG_CONSTRAINTS_VALID_OPS:
+		ret = regulator->rdev->constraints->valid_ops_mask;
+		break;
+	}
+	return ret;
+}
+
+static int __init xen_regif_init(void)
+{
+	if (!xen_domain())
+		return -ENODEV;
+
+	/* only exists in dom0 */
+	if (!xen_initial_domain())
+		return -ENODEV;
+
+	return xen_regif_xenbus_init();
+}
+late_initcall(xen_regif_init);
+
diff --git a/drivers/regulator/xen-regback/regif.h b/drivers/regulator/xen-regback/regif.h
new file mode 100644
index 00000000..87539c7
--- /dev/null
+++ b/drivers/regulator/xen-regback/regif.h
@@ -0,0 +1,85 @@
+/*
+ * regif - xen regulator device interface
+ *
+ * Copyright (C) 2016 Realtek Semiconductor Corporation
+ * Copyright (C) 2016 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifndef __XEN_PUBLIC_IO_REGIF_H__
+#define __XEN_PUBLIC_IO_REGIF_H__
+
+#include <xen/interface/io/ring.h>
+
+#define REGIF_OP_BIND_NAME         0
+#define REGIF_OP_GET_N_VOLTAGES    1
+#define REGIF_OP_GET_VOLT_TABLE_N  2
+#define REGIF_OP_GET_CONSTRAINTS   3
+#define REGIF_OP_SET_VOLT          4
+#define REGIF_OP_GET_VOLT          5
+
+static const char *regif_op_strings [] = {
+	[REGIF_OP_BIND_NAME] = "bind_name",
+	[REGIF_OP_GET_N_VOLTAGES] = "get_n_voltages",
+	[REGIF_OP_GET_VOLT_TABLE_N] = "get_volt_table_n",
+	[REGIF_OP_GET_CONSTRAINTS] = "get_constraints",
+	[REGIF_OP_SET_VOLT] = "set_volt",
+	[REGIF_OP_GET_VOLT] = "get_volt",
+};
+
+static inline const char *regif_op_string(int op)
+{
+	return regif_op_strings[op];
+}
+
+
+#define VREG_CONSTRAINTS_MAX_VOLT   0
+#define VREG_CONSTRAINTS_MIN_VOLT   1
+#define VREG_CONSTRAINTS_ALWAYS_ON  2
+#define VREG_CONSTRAINTS_BOOT_ON    3
+#define VREG_CONSTRAINTS_VALID_OPS  4
+
+#define REGIF_OK       0
+#define REGIF_ERROR    1
+
+#define REGIF_NAME_LENGTH        20
+
+struct regif_request {
+	int req_id;
+
+	int op;
+	int rdev_id;
+	union {
+		/* dummy */
+		int dummy;
+		/* regulator name */
+		char regulator_name[REGIF_NAME_LENGTH];
+		/* voltage selector */
+		int vsel;
+		/* constraint selector */
+		int csel;
+	};
+
+};
+
+struct regif_response {
+	int rsp_id;
+	int req_id;
+
+	int op;
+	int rdev_id;
+	int retval;
+	int errval;
+};
+
+/*  DEFINE the following structures for ring
+ *   struct regif_sring
+ *   struct regif_front_ring
+ *   struct regif_back_ring
+ */
+DEFINE_RING_TYPES(regif, struct regif_request, struct regif_response);
+
+
+#endif /* __XEN_PUBLIC_IO_BLKIF_H__ */
diff --git a/drivers/regulator/xen-regback/xenbus.c b/drivers/regulator/xen-regback/xenbus.c
new file mode 100644
index 00000000..9f72a4c
--- /dev/null
+++ b/drivers/regulator/xen-regback/xenbus.c
@@ -0,0 +1,317 @@
+/*
+ * xenbus.c - xenbus for regulator backend driver
+ *
+ * Copyright (C) 2016 Realtek Semiconductor Corporation
+ * Copyright (C) 2016 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#define pr_fmt(fmt) "regif-be: " fmt
+
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <linux/kthread.h>
+#include <xen/xen.h>
+#include <xen/events.h>
+#include <xen/xenbus.h>
+#include "regif.h"
+#include "common.h"
+
+#define PR_REQ(_req, _fmt, ...) \
+	pr_debug("%d: %s " _fmt, (_req)->req_id, regif_op_string((_req)->op), __VA_ARGS__);
+
+struct regif_back_info {
+	struct xenbus_device *dev;
+
+	struct regif_back_ring ring;
+	void * ringp;
+	unsigned int irq;
+
+	struct task_struct *regifd;
+	wait_queue_head_t wq;
+
+	int ring_connected;
+
+	struct mutex lock;
+	int rsp_id;
+
+};
+
+static inline void ring_create_rsp(struct regif_back_info *info, int req_id, int ret, int err)
+{
+	struct regif_response *rsp;
+
+	rsp = RING_GET_RESPONSE(&info->ring, info->ring.rsp_prod_pvt++);
+	rsp->rsp_id = info->rsp_id++;
+	rsp->req_id = req_id;
+	rsp->retval = ret;
+	rsp->errval = err;
+}
+
+static inline void ring_push_rsp(struct regif_back_info *info)
+{
+	int notify;
+
+	RING_PUSH_RESPONSES_AND_CHECK_NOTIFY(&info->ring, notify);
+	if (notify)
+		notify_remote_via_irq(info->irq);
+}
+
+static inline void ring_send_rsp(struct regif_back_info *info, int req_id, int ret, int err)
+{
+	ring_create_rsp(info, req_id, ret, err);
+	ring_push_rsp(info);
+}
+
+
+static int regif_work_to_do(struct regif_back_info *info)
+{
+	if (!info->ring_connected)
+		return 0;
+
+	if (likely(RING_HAS_UNCONSUMED_REQUESTS(&info->ring)))
+		return 1;
+
+	return 0;
+}
+
+static int regif_kthread(void *arg)
+{
+	struct regif_back_info *info = arg;
+
+	pr_info("%s\n", __func__);
+
+	while (!kthread_should_stop()) {
+		wait_event_interruptible(info->wq,
+			regif_work_to_do(info) || kthread_should_stop());
+
+		while (regif_work_to_do(info)) {
+			int rp = info->ring.sring->req_prod;
+			int rc = info->ring.req_cons;
+			struct regif_request *req;
+			int err;
+			int ret;
+
+			if (rc == rp)
+				break;
+
+			while (rc != rp) {
+				req = RING_GET_REQUEST(&info->ring, rc);
+				rc ++;
+				err = REGIF_OK;
+				ret = 0;
+
+				switch(req->op) {
+				case REGIF_OP_BIND_NAME:
+				    PR_REQ(req, "name = %s\n", req->regulator_name);
+				    ret = vreg_regulator_get(&info->dev->dev, req->regulator_name);
+				    break;
+
+				case REGIF_OP_GET_N_VOLTAGES:
+				    PR_REQ(req, "rdev_id = %d\n", req->rdev_id);
+				    ret = vreg_regulator_count_voltages(req->rdev_id);
+				    break;
+
+				case REGIF_OP_GET_VOLT_TABLE_N:
+				    PR_REQ(req, "rdev_id = %d, vsel = %d\n", req->rdev_id, req->vsel);
+				    ret = vreg_regulator_list_voltage(req->rdev_id, req->vsel);
+				    break;
+
+				case REGIF_OP_GET_CONSTRAINTS:
+				    PR_REQ(req, "rdev_id = %d, csel = %d\n", req->rdev_id, req->csel);
+				    ret = vreg_regulator_get_constraints(req->rdev_id, req->csel);
+				    break;
+
+				case REGIF_OP_SET_VOLT:
+				    PR_REQ(req, "rdev_id = %d, vsel = %d\n", req->rdev_id, req->vsel);
+				    ret = vreg_regulator_set_volt(req->rdev_id, req->vsel);
+				    break;
+
+				case REGIF_OP_GET_VOLT:
+				    PR_REQ(req, "rdev_id = %d\n", req->rdev_id);
+				    ret = vreg_regulator_get_volt(req->rdev_id);
+				    break;
+				}
+
+				ring_send_rsp(info, req->req_id, ret, err);
+			}
+
+			info->ring.req_cons = rc;
+			info->ring.sring->req_event = rc + 1;
+		}
+	}
+
+	return 0;
+}
+
+
+static irqreturn_t regif_back_interrupt(int irq, void *dev_id)
+{
+	struct regif_back_info *info = dev_id;
+	wake_up(&info->wq);
+	return IRQ_HANDLED;
+}
+
+static int connect_ring(struct regif_back_info *info)
+{
+	unsigned int evtchn;
+	unsigned int ring_ref;
+	grant_ref_t gref;
+	struct regif_sring *sring;
+	int ret;
+	const char * msg;
+
+	msg = "xenbus_scanf::event-channel";
+	ret = xenbus_scanf(XBT_NIL, info->dev->otherend, "event-channel", "%u", &evtchn);
+	if (ret < 0)
+		goto error;
+
+	msg = "xenbus_scanf::ring-ref";
+	ret = xenbus_scanf(XBT_NIL, info->dev->otherend, "ring-ref", "%u", &ring_ref);
+	if (ret < 0)
+		goto error;
+
+	msg = "xenbus_map_ring_valloc";
+	gref = ring_ref;
+	ret = xenbus_map_ring_valloc(info->dev, &gref, 1, &info->ringp);
+	if (ret)
+		goto error;
+	sring = (struct regif_sring *)info->ringp;
+	BACK_RING_INIT(&info->ring, sring, PAGE_SIZE);
+
+
+	msg = "bind_interdomain_evtchn_to_irqhandler";
+	ret = bind_interdomain_evtchn_to_irqhandler(info->dev->otherend_id, evtchn,
+		regif_back_interrupt, 0, "regif-backend", info);
+	if (ret < 0)
+		goto unmap;
+	info->irq = ret;
+
+	info->ring_connected = 1;
+	return 0;
+unmap:
+	xenbus_unmap_ring_vfree(info->dev, info->ringp);
+error:
+	pr_err("Failed at %s: %d\n", msg, ret);
+	return ret;
+}
+
+static void disconnect_ring(struct regif_back_info *info)
+{
+	if (info->irq) {
+		unbind_from_irqhandler(info->irq, info);
+		info->irq = 0;
+	}
+
+	if (info->ringp) {
+		xenbus_unmap_ring_vfree(info->dev, info->ringp);
+		info->ringp = NULL;
+	}
+
+	info->ring_connected = 0;
+}
+
+static void frontend_changed(struct xenbus_device *dev,
+	enum xenbus_state frontend_state)
+{
+	struct regif_back_info *info = dev_get_drvdata(&dev->dev);
+
+	pr_info("%s: FE %s BE %s\n", __func__, xenbus_strstate(frontend_state), xenbus_strstate(dev->state));
+
+	switch (frontend_state) {
+	case XenbusStateInitialising:
+		if (dev->state == XenbusStateClosed) {
+			xenbus_switch_state(dev, XenbusStateInitWait);
+		}
+		break;
+
+	case XenbusStateInitialised:
+	case XenbusStateConnected:
+		if (dev->state == XenbusStateConnected)
+			break;
+
+		if(connect_ring(info))
+			break;
+
+		xenbus_switch_state(dev, XenbusStateConnected);
+		break;
+
+	case XenbusStateClosing:
+		xenbus_switch_state(dev, XenbusStateClosing);
+		break;
+
+	case XenbusStateClosed:
+		vreg_reset();
+		disconnect_ring(info);
+		xenbus_switch_state(dev, XenbusStateClosed);
+		if (xenbus_dev_is_online(dev))
+			break;
+	case XenbusStateUnknown:
+		device_unregister(&dev->dev);
+		break;
+
+	default:
+		break;
+	}
+}
+
+static int regif_back_probe(struct xenbus_device *dev,
+	const struct xenbus_device_id *id)
+{
+	int ret;
+	struct regif_back_info *info;
+
+	info = kzalloc(sizeof(*info), GFP_KERNEL);
+	if (!info) {
+		return -ENOMEM;
+	}
+
+	info->dev = dev;
+	dev_set_drvdata(&dev->dev, info);
+
+	init_waitqueue_head(&info->wq);
+	info->regifd = kthread_run(regif_kthread, info, "%s", "regif-back");
+
+	ret = xenbus_switch_state(dev, XenbusStateInitWait);
+	if (ret)
+		pr_err("Failed to xenbus_switch_state: %d\n", ret);
+
+	return 0;
+}
+
+static int regif_back_remove(struct xenbus_device *dev)
+{
+	struct regif_back_info *info = dev_get_drvdata(&dev->dev);
+
+	pr_info("%s\n", __func__);
+
+	kthread_stop(info->regifd);
+	vreg_reset();
+	disconnect_ring(info);
+	kfree(info);
+	dev_set_drvdata(&dev->dev, NULL);
+	return 0;
+}
+
+
+static const struct xenbus_device_id regif_back_ids[] = {
+	{ "vreg" },
+	{ "" }
+};
+
+static struct xenbus_driver regif_back_driver = {
+	.ids = regif_back_ids,
+	.probe = regif_back_probe,
+	.remove = regif_back_remove,
+	.otherend_changed = frontend_changed,
+};
+
+
+int xen_regif_xenbus_init(void)
+{
+	return xenbus_register_backend(&regif_back_driver);
+}
+
diff --git a/drivers/regulator/xen-regfront.c b/drivers/regulator/xen-regfront.c
new file mode 100644
index 00000000..368727d
--- /dev/null
+++ b/drivers/regulator/xen-regfront.c
@@ -0,0 +1,603 @@
+/*
+ * xen-regfront.c - xen regulator frontend driver
+ *
+ * Copyright (C) 2016 Realtek Semiconductor Corporation
+ * Copyright (C) 2016 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#define pr_fmt(fmt) "regif-fe: " fmt
+
+#include <linux/regulator/driver.h>
+#include <linux/regulator/machine.h>
+#include <linux/regulator/of_regulator.h>
+#include <linux/mutex.h>
+#include <linux/module.h>
+#include <linux/delay.h>
+#include <linux/of.h>
+#include <xen/xen.h>
+#include <xen/events.h>
+#include <xen/xenbus.h>
+#include <xen/grant_table.h>
+#include "xen-regback/regif.h"
+
+#define DEBUG 0
+
+#if DEBUG
+#define PR_DEBUG(...) pr_err(__VA_ARGS__);
+#else
+#define PR_DEBUG(...)
+#endif
+
+struct regif_front_info {
+	struct xenbus_device *dev;
+
+	struct regif_front_ring ring;
+	int ring_ref;
+	unsigned int evtchn;
+	unsigned int irq;
+
+	int connected;
+
+	struct mutex lock;
+	volatile int wait_done;
+	int req_id;
+
+	char name_buf[1024];
+};
+
+static LIST_HEAD(regif_list);
+
+struct regif_regulator {
+	struct list_head list;
+	struct regif_front_info *info;
+	struct regulator_dev *rdev;
+	struct regulator_desc desc;
+	unsigned int *volt_table;
+};
+
+static inline struct regif_request *ring_new_req(struct regif_front_info *info)
+{
+	struct regif_request *req = RING_GET_REQUEST(&info->ring, info->ring.req_prod_pvt);
+	info->ring.req_prod_pvt++;
+	req->req_id = info->req_id++;
+	return req;
+}
+
+static inline void ring_push_req(struct regif_front_info *info)
+{
+	int notify;
+	info->wait_done = 0;
+
+	RING_PUSH_REQUESTS_AND_CHECK_NOTIFY(&info->ring, notify);
+	if (notify)
+		notify_remote_via_irq(info->irq);
+}
+
+static inline int ring_wait_rsp(struct regif_front_info *info)
+{
+#define RETRY_CONUNT 2000
+	int i;
+	for (i = 0; i < RETRY_CONUNT; i++) {
+		if (info->wait_done)
+			return i;
+		udelay(100);
+	}
+	pr_info("%s timeout\n", __func__);
+	return -EINVAL;
+}
+
+static inline struct regif_response * ring_get_rsp(struct regif_front_info *info)
+{
+	struct regif_response *rsp = RING_GET_RESPONSE(&info->ring, info->ring.rsp_cons++);
+	int more_to_do;
+
+again:
+	RING_FINAL_CHECK_FOR_RESPONSES(&info->ring, more_to_do);
+	if (more_to_do) {
+		struct regif_response *rsp_1 =
+			RING_GET_RESPONSE(&info->ring, info->ring.rsp_cons++);
+
+		pr_info("multiple response\n");
+		pr_info("rsp_id  = %d\n", rsp_1->rsp_id);
+		pr_info("req_id  = %d\n", rsp_1->req_id);
+		pr_info("op      = %s\n", regif_op_string(rsp_1->op));
+		pr_info("rdev_id = %d\n", rsp_1->rdev_id);
+		pr_info("retval  = %d\n", rsp_1->retval);
+		pr_info("errval  = %d\n", rsp_1->errval);
+
+		goto again;
+	}
+
+	return rsp;
+}
+
+static struct regif_response *ring_send_req_ang_get_rsp(struct regif_front_info *info)
+{
+	ring_push_req(info);
+	if (ring_wait_rsp(info) < 0)
+		return NULL;
+	return ring_get_rsp(info);
+}
+
+/**
+ * GET_FROM_BE - a helper macro
+ * @_info: fe info
+ * @_op: REGIF_OP_*
+ * @_id: rdev_id
+ * @_sel_name: member name to be set, if no value use 'dummy'
+ * @_sel_val: value of @_sel_name to be set
+ * @_fail_label: goto this label when failed
+ */
+#define GET_FROM_BE(_info, _op, _id, _sel_name, _sel_val, _fail_label)  \
+({                                              \
+	struct regif_request *_req;                 \
+	struct regif_response *_rsp;                \
+	_req = ring_new_req(_info);                 \
+	_req->op = _op;                             \
+	_req->rdev_id = _id;                        \
+	_req->_sel_name = _sel_val;                 \
+				                                \
+	_rsp = ring_send_req_ang_get_rsp(_info);    \
+	if (!_rsp)                                  \
+		goto _fail_label;                       \
+	PR_DEBUG("id = %d, op = %s, sel = %s/%d, ret = %d \n", _id, regif_op_string(_op), #_sel_val, _sel_val, _rsp->retval); \
+				                                \
+	_rsp->retval;                               \
+})
+
+static int regif_front_set_voltage_sel(struct regulator_dev *rdev, unsigned sel)
+{
+	struct regif_front_info *info = rdev_get_drvdata(rdev);
+	int ret = 0;
+
+	if (!info->connected)
+		return -EPERM;
+
+	mutex_lock(&info->lock);
+	ret = GET_FROM_BE(info, REGIF_OP_SET_VOLT, rdev->desc->id,
+		vsel, sel, fail);
+fail:
+	mutex_unlock(&info->lock);
+
+	return 0;
+}
+
+static int regif_front_get_voltage(struct regulator_dev *rdev)
+{
+	struct regif_front_info *info = rdev_get_drvdata(rdev);
+	int ret = -EINVAL;
+
+	if (!info->connected)
+		return -EPERM;
+
+	mutex_lock(&info->lock);
+	ret = GET_FROM_BE(info, REGIF_OP_GET_VOLT, rdev->desc->id,
+		dummy, 0, fail);
+fail:
+	mutex_unlock(&info->lock);
+
+	return ret;
+}
+
+static struct regulator_ops frontend_regulator_ops = {
+	.list_voltage    = regulator_list_voltage_table,
+	.map_voltage     = regulator_map_voltage_iterate,
+	.set_voltage_sel = regif_front_set_voltage_sel,
+	.get_voltage     = regif_front_get_voltage,
+};
+
+struct regulator_dev *regif_regulator_register(struct xenbus_device *dev,
+	const char *name,
+	const struct regulator_config *config)
+{
+	const char *msg;
+	struct regif_front_info *info = dev_get_drvdata(&dev->dev);
+	struct regif_regulator *rr;
+	struct regulator_dev *rdev = NULL;
+	int rdev_id;
+
+	struct regulator_config cfg;
+	struct regulator_init_data init_data;
+
+	struct regif_request *req;
+	struct regif_response *rsp;
+	int i;
+	struct device_node *child;
+	unsigned int ivolt;
+
+
+	if (!info->connected)
+		return NULL;
+
+	rr = kzalloc(sizeof(*rr), GFP_KERNEL);
+	if (!rr)
+		return ERR_PTR(-ENOMEM);
+
+	mutex_lock(&info->lock);
+
+	msg = "get::id";
+	req = ring_new_req(info);
+	req->op = REGIF_OP_BIND_NAME;
+	strncpy(req->regulator_name, name, REGIF_NAME_LENGTH);
+
+	rsp = ring_send_req_ang_get_rsp(info);
+	if (!rsp)
+		goto fail;
+	rdev_id = rsp->retval;
+
+	msg = "get::n_voltages";
+	rr->desc.n_voltages = GET_FROM_BE(info, REGIF_OP_GET_N_VOLTAGES, rdev_id, dummy, 0, fail);
+
+	msg = "alloc::volt_table";
+	rr->volt_table = kzalloc(sizeof(*rr->volt_table) * rr->desc.n_voltages,
+		GFP_KERNEL);
+	if (!rr->volt_table)
+		goto fail;
+
+	msg = "get::volt_table";
+	for (i = 0; i < rr->desc.n_voltages; i++)
+	{
+		rr->volt_table[i] = GET_FROM_BE(info, REGIF_OP_GET_VOLT_TABLE_N, rdev_id, vsel, i, fail);
+	}
+
+
+	rr->desc.name  = name;
+	rr->desc.id    = rdev_id;
+	rr->desc.type  = REGULATOR_VOLTAGE,
+	rr->desc.owner = THIS_MODULE,
+	rr->desc.ops   = &frontend_regulator_ops;
+	rr->desc.volt_table = rr->volt_table;
+
+	memcpy(&cfg, config, sizeof(cfg));
+	if (cfg.init_data) {
+		memcpy(&init_data, cfg.init_data, sizeof(init_data));
+	} else {
+		memset(&init_data, 0, sizeof(init_data));
+	}
+	cfg.init_data = &init_data;
+
+	for_each_child_of_node(dev->dev.of_node, child) {
+		const char *match_name = of_get_property(child, "regulator-compatible", NULL);
+		if (!match_name)
+			match_name = child->name;
+
+		if (strcmp(name, match_name))
+			continue;
+
+		cfg.of_node = child;
+		break;
+	}
+
+	/* try get name from of_node */
+	if (cfg.of_node) {
+		init_data.constraints.name =
+			of_get_property(cfg.of_node, "regulator-name", NULL);
+	}
+
+	if (!init_data.constraints.name)
+		init_data.constraints.name = name;
+
+	msg = "get::constraints";
+	init_data.constraints.max_uV = GET_FROM_BE(info, REGIF_OP_GET_CONSTRAINTS,
+		rdev_id, csel, VREG_CONSTRAINTS_MAX_VOLT, fail);
+	init_data.constraints.min_uV = GET_FROM_BE(info, REGIF_OP_GET_CONSTRAINTS,
+		rdev_id, csel, VREG_CONSTRAINTS_MIN_VOLT, fail);
+	init_data.constraints.boot_on = GET_FROM_BE(info, REGIF_OP_GET_CONSTRAINTS,
+		rdev_id, csel, VREG_CONSTRAINTS_BOOT_ON, fail);
+	init_data.constraints.always_on = GET_FROM_BE(info, REGIF_OP_GET_CONSTRAINTS,
+		rdev_id, csel, VREG_CONSTRAINTS_ALWAYS_ON, fail);
+	init_data.constraints.valid_ops_mask = GET_FROM_BE(info, REGIF_OP_GET_CONSTRAINTS,
+		rdev_id, csel, VREG_CONSTRAINTS_VALID_OPS, fail);
+
+	mutex_unlock(&info->lock);
+
+	rdev = devm_regulator_register(&dev->dev, &rr->desc, &cfg);
+	if (IS_ERR_OR_NULL(rdev))
+		goto fail_unlocked;
+
+	rr->rdev = rdev;
+	list_add(&rr->list, &regif_list);
+
+	/* regulator is ready now */
+	if (!of_property_read_u32(cfg.of_node, "regulator-init-microvolt",
+		&ivolt)) {
+		int ret;
+
+		ret = regulator_map_voltage_iterate(rdev, ivolt, ivolt);
+		pr_info("init-microvolt = %u, sel = %d\n", ivolt, ret);
+		ret = regif_front_set_voltage_sel(rdev, ret);
+		if (ret)
+			pr_err("set init-volt returns %d\n", ret);
+   }
+
+
+	return rdev;
+fail:
+	mutex_unlock(&info->lock);
+fail_unlocked:
+	if (rr->volt_table)
+		kfree(rr->volt_table);
+
+	if (rr)
+		kfree(rr);
+	return rdev;;
+}
+
+static void free_regulators(void)
+{
+	struct list_head * it = NULL;
+	list_for_each(it, &regif_list) {
+		struct regif_regulator * rr = list_entry(it, struct regif_regulator, list);
+		regulator_unregister(rr->rdev);
+		if (rr->volt_table)
+			kfree(rr->volt_table);
+		kfree(rr);
+	}
+	INIT_LIST_HEAD(&regif_list);
+}
+
+static irqreturn_t regif_front_interrupt(int irq, void *dev_id)
+{
+	struct regif_front_info *info = dev_id;
+
+	info->wait_done = 1;
+
+	return IRQ_HANDLED;
+}
+
+static void init_regulator(struct xenbus_device *dev)
+{
+	struct regif_front_info *info = dev_get_drvdata(&dev->dev);
+	int err;
+	char *s, *n;
+	int final;
+
+	/* get a list */
+	xenbus_scanf(XBT_NIL, dev->nodename, "regulator", "%s", info->name_buf);
+	pr_info("regulator(s) = %s\n",  info->name_buf);
+
+	/* attach to DT, so child nodes can be found when register */
+	dev->dev.of_node = of_find_compatible_node(NULL, NULL, "xen,vreg");
+
+	final = 0;
+	for (s = n = info->name_buf; !final; n++)
+	{
+		struct regulator_config cfg = {};
+		struct regulator_dev *rdev;
+
+		if (*n == 0)
+			final = 1;
+		if (*n == ':')
+			*n = 0;
+		if (*n != 0)
+			continue;
+
+		cfg.dev = &dev->dev;
+		cfg.driver_data = info;
+
+		rdev = regif_regulator_register(dev, s, &cfg);
+		if (IS_ERR_OR_NULL(rdev)) {
+			err = PTR_ERR(rdev);
+			dev_err(&dev->dev, "Failed to register regulator : %d\n", err);
+		}
+
+		s = n + 1;
+	}
+}
+
+static void free_ring(struct xenbus_device *dev)
+{
+	struct regif_front_info *info = dev_get_drvdata(&dev->dev);
+
+	if (info->irq) {
+		unbind_from_irqhandler(info->irq, info);
+		info->irq = 0;
+	}
+
+	if (info->evtchn) {
+		xenbus_free_evtchn(dev, info->evtchn);
+		info->evtchn = 0;
+	}
+
+	if (info->ring_ref != 0) {
+		gnttab_end_foreign_access(info->ring_ref, 0, (unsigned long)info->ring.sring);
+		info->ring_ref = 0;
+	}
+
+	info->connected = 0;
+}
+
+
+static int setup_ring(struct xenbus_device *dev)
+{
+	struct regif_front_info *info = dev_get_drvdata(&dev->dev);
+	struct regif_sring *sring;
+	unsigned long ring_size = PAGE_SIZE;
+	int err;
+	grant_ref_t gref;
+	const char *msg;
+
+	sring = (struct regif_sring *)__get_free_pages(GFP_NOIO | __GFP_HIGH, get_order(ring_size));
+	if (!sring) {
+		return -ENOMEM;
+	}
+
+	SHARED_RING_INIT(sring);
+	FRONT_RING_INIT(&info->ring, sring, ring_size);
+
+	msg = "xenbus_grant_ring";
+	err = xenbus_grant_ring(dev, info->ring.sring, 1, &gref);
+	if (err)
+		goto fail;
+	info->ring_ref = gref;
+
+	msg = "xenbus_alloc_evtchn";
+	err = xenbus_alloc_evtchn(dev, &info->evtchn);
+	if (err)
+		goto fail;
+
+	msg = "bind_evtchn_to_irqhandler";
+	err = bind_evtchn_to_irqhandler(info->evtchn, regif_front_interrupt, 0, "regif", info);
+	if (err <= 0)
+		goto fail;
+	info->irq = err;
+
+	return 0;
+fail:
+	xenbus_dev_fatal(dev, err, "%s\n", msg );
+	free_ring(dev);
+	return err;
+}
+
+
+static int talk_to_backend(struct xenbus_device *dev)
+{
+	struct regif_front_info *info = dev_get_drvdata(&dev->dev);
+	struct xenbus_transaction xbt;
+	int err;
+	const char *msg;
+
+	msg = "setup_ring";
+	err = setup_ring(dev);
+	if (err)
+		goto destroy_ring;
+again:
+	msg = "xenbus_transaction_start";
+	err = xenbus_transaction_start(&xbt);
+	if (err)
+		goto destroy_ring;
+
+	msg = "xenbus_printf::event-channel";
+	err = xenbus_printf(xbt, dev->nodename, "event-channel", "%u", info->evtchn);
+	if (err)
+		goto abort_transaction;
+
+	msg = "xenbus_printf::ring-ref";
+	err = xenbus_printf(xbt, dev->nodename, "ring-ref", "%u", info->ring_ref);
+	if (err)
+		goto abort_transaction;
+
+	msg = "xenbus_transaction_end";
+	err = xenbus_transaction_end(xbt, 0);
+	if (err == -EAGAIN)
+		goto again;
+	if (err)
+		goto destroy_ring;
+
+	xenbus_switch_state(dev, XenbusStateInitialised);
+
+	info->connected = 1;
+
+	return 0;
+
+abort_transaction:
+	xenbus_transaction_end(xbt, 1);
+	xenbus_dev_fatal(dev, err, "%s", msg);
+destroy_ring:
+	free_ring(dev);
+	return err;
+}
+
+static void backend_changed(struct xenbus_device *dev,
+	enum xenbus_state backend_state)
+{
+	struct regif_front_info __maybe_unused *info = dev_get_drvdata(&dev->dev);
+
+	pr_info("%s: BE %s FE %s\n", __func__, xenbus_strstate(backend_state), xenbus_strstate(dev->state));
+
+	switch (backend_state) {
+	case XenbusStateInitWait:
+		if (dev->state != XenbusStateInitialising)
+			break;
+
+		if (talk_to_backend(dev))
+			break;
+		break;
+
+	case XenbusStateConnected:
+		if (dev->state == XenbusStateConnected)
+			break;
+
+		init_regulator(dev);
+
+		xenbus_switch_state(dev, XenbusStateConnected);
+		break;
+
+	case XenbusStateClosed:
+		if (dev->state == XenbusStateClosed)
+			break;
+	case XenbusStateClosing:
+		free_regulators();
+		free_ring(dev);
+		xenbus_frontend_closed(dev);
+		break;
+
+	default:
+		if (dev->state != XenbusStateClosed)
+			break;
+		xenbus_switch_state(dev, XenbusStateInitialising);
+		break;
+	}
+}
+
+static int regif_front_probe(struct xenbus_device *dev,
+	const struct xenbus_device_id *id)
+{
+	struct regif_front_info *info;
+
+	info  = devm_kzalloc(&dev->dev, sizeof(*info), GFP_KERNEL);
+	if (!info) {
+		return -ENOMEM;
+	}
+
+	info->dev = dev;
+	mutex_init(&info->lock);
+	dev_set_drvdata(&dev->dev, info);
+
+	return 0;
+}
+
+static int regif_front_remove(struct xenbus_device *dev)
+{
+	struct regif_front_info *info = dev_get_drvdata(&dev->dev);
+
+	free_ring(dev);
+
+	kfree(info);
+	dev_set_drvdata(&dev->dev, NULL);
+	return 0;
+}
+
+static const struct xenbus_device_id regif_front_ids[] = {
+	{ "vreg" },
+	{ "" }
+};
+
+static struct xenbus_driver regif_front_driver = {
+	.ids    = regif_front_ids,
+	.probe  = regif_front_probe,
+	.remove = regif_front_remove,
+	.otherend_changed = backend_changed,
+};
+
+static __init int regif_front_init(void)
+{
+	if (!xen_domain())
+		return -ENODEV;
+
+	//if (xen_initial_domain())
+	//    return -ENODEV;
+
+	return xenbus_register_frontend(&regif_front_driver);
+}
+module_init(regif_front_init);
+
+static __exit void regif_front_exit(void)
+{
+	 xenbus_unregister_driver(&regif_front_driver);
+}
+module_exit(regif_front_exit);
diff --git a/drivers/rtc/Kconfig b/drivers/rtc/Kconfig
index 0723c97..f893a2a 100644
--- a/drivers/rtc/Kconfig
+++ b/drivers/rtc/Kconfig
@@ -1202,6 +1202,17 @@ config RTC_DRV_ZYNQMP
 	  If you say yes here you get support for the RTC controller found on
 	  Xilinx Zynq Ultrascale+ MPSoC.
 
+config RTC_DRV_RTK
+    tristate "Realtek RTC"
+    depends on RTK_PLATFORM
+    help
+      Realtek  RTC support.
+
+config RTC_DRV_SW
+	tristate "Realtek SW RTC"
+	help
+	  Realtek SW RTC
+
 comment "on-CPU RTC drivers"
 
 config RTC_DRV_ASM9260
diff --git a/drivers/rtc/Makefile b/drivers/rtc/Makefile
index 1ac694a..bb9fb3e 100644
--- a/drivers/rtc/Makefile
+++ b/drivers/rtc/Makefile
@@ -165,3 +165,5 @@ obj-$(CONFIG_RTC_DRV_WM8350)	+= rtc-wm8350.o
 obj-$(CONFIG_RTC_DRV_X1205)	+= rtc-x1205.o
 obj-$(CONFIG_RTC_DRV_XGENE)	+= rtc-xgene.o
 obj-$(CONFIG_RTC_DRV_ZYNQMP)	+= rtc-zynqmp.o
+obj-$(CONFIG_RTC_DRV_RTK)	+= rtc-rtk.o
+obj-$(CONFIG_RTC_DRV_SW)	+= rtc-sw.o
diff --git a/drivers/rtc/rtc-palmas.c b/drivers/rtc/rtc-palmas.c
index 4bcfb88..34aea38 100644
--- a/drivers/rtc/rtc-palmas.c
+++ b/drivers/rtc/rtc-palmas.c
@@ -45,6 +45,42 @@ struct palmas_rtc {
 /* Total number of RTC registers needed to set time*/
 #define PALMAS_NUM_TIME_REGS	(PALMAS_YEARS_REG - PALMAS_SECONDS_REG + 1)
 
+/*
+ * Special bin2bcd mapping to deal with bcd storage of year.
+ *
+ *   0-69                -> 0xD0
+ *  70-99  (1970 - 1999) -> 0xD0 - 0xF9 (correctly rolls to 0x00)
+ * 100-199 (2000 - 2099) -> 0x00 - 0x99 (does not roll to 0xA0 :-( )
+ * 200-229 (2100 - 2129) -> 0xA0 - 0xC9 (really for completeness)
+ * 230-                  -> 0xC9
+ *
+ * Confirmed: the only transition that does not work correctly for this rtc
+ * clock is the transition from 2099 to 2100, it proceeds to 2000. We will
+ * accept this issue since the clock retains and transitions the year correctly
+ * in all other conditions.
+ */
+static unsigned char year_bin2bcd(int val)
+{
+	if (val < 70)
+		return 0xD0;
+	if (val < 100)
+		return bin2bcd(val - 20) | 0x80; /* KISS leverage of bin2bcd */
+	if (val >= 230)
+		return 0xC9;
+	if (val >= 200)
+		return bin2bcd(val - 180) | 0x80;
+	return bin2bcd(val - 100);
+}
+
+static int year_bcd2bin(unsigned char val)
+{
+	if (val >= 0xD0)
+		return bcd2bin(val & 0x7F) + 20;
+	if (val >= 0xA0)
+		return bcd2bin(val & 0x7F) + 180;
+	return bcd2bin(val) + 100;
+}
+
 static int palmas_rtc_read_time(struct device *dev, struct rtc_time *tm)
 {
 	unsigned char rtc_data[PALMAS_NUM_TIME_REGS];
@@ -71,7 +107,7 @@ static int palmas_rtc_read_time(struct device *dev, struct rtc_time *tm)
 	tm->tm_hour = bcd2bin(rtc_data[2]);
 	tm->tm_mday = bcd2bin(rtc_data[3]);
 	tm->tm_mon = bcd2bin(rtc_data[4]) - 1;
-	tm->tm_year = bcd2bin(rtc_data[5]) + 100;
+	tm->tm_year = year_bcd2bin(rtc_data[5]);
 
 	return ret;
 }
@@ -87,7 +123,7 @@ static int palmas_rtc_set_time(struct device *dev, struct rtc_time *tm)
 	rtc_data[2] = bin2bcd(tm->tm_hour);
 	rtc_data[3] = bin2bcd(tm->tm_mday);
 	rtc_data[4] = bin2bcd(tm->tm_mon + 1);
-	rtc_data[5] = bin2bcd(tm->tm_year - 100);
+	rtc_data[5] = year_bin2bcd(tm->tm_year);
 
 	/* Stop RTC while updating the RTC time registers */
 	ret = palmas_update_bits(palmas, PALMAS_RTC_BASE, PALMAS_RTC_CTRL_REG,
@@ -142,7 +178,7 @@ static int palmas_rtc_read_alarm(struct device *dev, struct rtc_wkalrm *alm)
 	alm->time.tm_hour = bcd2bin(alarm_data[2]);
 	alm->time.tm_mday = bcd2bin(alarm_data[3]);
 	alm->time.tm_mon = bcd2bin(alarm_data[4]) - 1;
-	alm->time.tm_year = bcd2bin(alarm_data[5]) + 100;
+	alm->time.tm_year = year_bcd2bin(alarm_data[5]);
 
 	ret = palmas_read(palmas, PALMAS_RTC_BASE, PALMAS_RTC_INTERRUPTS_REG,
 			&int_val);
@@ -173,7 +209,7 @@ static int palmas_rtc_set_alarm(struct device *dev, struct rtc_wkalrm *alm)
 	alarm_data[2] = bin2bcd(alm->time.tm_hour);
 	alarm_data[3] = bin2bcd(alm->time.tm_mday);
 	alarm_data[4] = bin2bcd(alm->time.tm_mon + 1);
-	alarm_data[5] = bin2bcd(alm->time.tm_year - 100);
+	alarm_data[5] = year_bin2bcd(alm->time.tm_year);
 
 	ret = palmas_bulk_write(palmas, PALMAS_RTC_BASE,
 		PALMAS_ALARM_SECONDS_REG, alarm_data, PALMAS_NUM_TIME_REGS);
diff --git a/drivers/rtc/rtc-rtk.c b/drivers/rtc/rtc-rtk.c
new file mode 100644
index 00000000..4937302
--- /dev/null
+++ b/drivers/rtc/rtc-rtk.c
@@ -0,0 +1,637 @@
+/*
+ * rtc-rtk.c - Realtek real timer clock driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/fs.h>
+#include <linux/err.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/rtc.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+#include "rtc-rtk.h"
+
+#define RTC_TEST 0
+
+#define DEV_NAME "[RTK_RTC]"
+#define REG_RTCSEC 0x00
+#define REG_RTCMIN 0x04
+#define REG_RTCHR 0x08
+#define REG_RTCDATE_LOW 0x0C
+#define REG_RTCDATE_HIGH 0x10
+#define REG_ALARMMIN 0x14
+#define REG_ALARMHR 0x18
+#define REG_ALARMDATE_LOW 0x1C
+#define REG_ALARMDATE_HIGH 0x20
+#define REG_RTCSTOP 0x24
+#define REG_RTCACR 0x28
+#define REG_RTCEN 0x2C
+#define REG_RTCCR 0x30
+#define REG_RTCACR2 0x34
+
+#define REG_ISO_ISR 0x00
+#define REG_ISO_RTC 0x34
+
+#define LEAPS_THRU_END_OF(y) ((y)/4 - (y)/100 + (y)/400)
+
+static void __iomem *rtk_rtc_base;
+static void __iomem *rtk_iso_base;
+static struct clk *rtc_clk;
+static struct reset_control *rtc_rstc;
+static int rtc_irq;
+static struct timer_list rtc_alarm_sec_timer;
+static int rtc_alarm_sec_left;
+
+static long rtk_base_year;
+static int rtk_bias;
+
+DEFINE_SPINLOCK(rtk_rtc_lock);
+
+static void rtk_rtc_check_rtcacr(struct device *dev)
+{
+	unsigned long flags;
+	unsigned int val;
+	unsigned int sec;
+	unsigned int min;
+	unsigned int hr;
+	unsigned int date_low;
+	unsigned int date_high;
+
+	spin_lock_irqsave(&rtk_rtc_lock, flags);
+
+	val = readl(rtk_rtc_base + REG_RTCACR);
+	dev_info(dev, "rtk_rtc rtcacr = 0x%x\n", val);
+
+
+	if ((val & 0x80) == 0x80)
+		goto err;
+
+	dev_info(dev, "rtk_rtc set rtcacr\n");
+	writel(0x80, rtk_rtc_base + REG_RTCACR);
+
+	/* we set sefault 0 , 0 , 0 , 0 */
+	writel(0x40, rtk_rtc_base + REG_RTCCR);
+	writel(0x0, rtk_rtc_base + REG_RTCCR);
+	writel(rtk_bias, rtk_rtc_base + REG_RTCACR2);
+	writel(0, rtk_rtc_base + REG_RTCMIN);
+	writel(0, rtk_rtc_base + REG_RTCHR);
+	writel(0, rtk_rtc_base + REG_RTCDATE_LOW);
+	writel(0, rtk_rtc_base + REG_RTCDATE_HIGH);
+
+	sec = readl(rtk_rtc_base + REG_RTCSEC);
+	min = readl(rtk_rtc_base + REG_RTCMIN);
+	hr = readl(rtk_rtc_base + REG_RTCHR);
+	date_low = readl(rtk_rtc_base + REG_RTCDATE_LOW);
+	date_high = readl(rtk_rtc_base + REG_RTCDATE_HIGH);
+
+	dev_info(dev, "rtcacr 2 REG_SEC = 0x%x\n", sec);
+	dev_info(dev, "rtcacr 2 REG_MIN = 0x%x\n", min);
+	dev_info(dev, "rtcacr 2 REG_HR = 0x%x\n", hr);
+	dev_info(dev, "rtcacr 2 REG_DATA_LOW = 0x%x\n", date_low);
+	dev_info(dev, "rtcacr 2 REG_DATE_HIGH = 0x%x\n", date_high);
+
+err:
+	spin_unlock_irqrestore(&rtk_rtc_lock, flags);
+}
+
+static void rtk_rtc_enable(struct device *dev, int en)
+{
+	unsigned long flags;
+	unsigned int sec;
+	unsigned int min;
+	unsigned int hr;
+	unsigned int date_low;
+	unsigned int date_high;
+
+	spin_lock_irqsave(&rtk_rtc_lock, flags);
+
+	if (rtk_rtc_base == NULL)
+		goto err;
+
+	if (!en) {
+		dev_err(dev, "rtk_rtc_disable");
+		writel(0x00, rtk_rtc_base + REG_RTCEN);
+
+	} else if ((readl(rtk_rtc_base + REG_RTCEN) & 0xff) != 0x5A) {
+		dev_err(dev, "rtk_rtc_enable");
+		writel(0x5A, rtk_rtc_base + REG_RTCEN);
+	} else {
+		dev_err(dev, "rtk_rtc already enabled ");
+	}
+
+	sec = readl(rtk_rtc_base + REG_RTCSEC);
+	min = readl(rtk_rtc_base + REG_RTCMIN);
+	hr = readl(rtk_rtc_base + REG_RTCHR);
+	date_low = readl(rtk_rtc_base + REG_RTCDATE_LOW);
+	date_high = readl(rtk_rtc_base + REG_RTCDATE_HIGH);
+
+	dev_info(dev, "enable REG_SEC = 0x%x\n", sec);
+	dev_info(dev, "enable REG_MIN = 0x%x\n", min);
+	dev_info(dev, "enable REG_HR = 0x%x\n", hr);
+	dev_info(dev, "enable REG_DATA_LOW = 0x%x\n", date_low);
+	dev_info(dev, "enable REG_DATE_HIGH = 0x%x\n", date_high);
+
+err:
+	spin_unlock_irqrestore(&rtk_rtc_lock, flags);
+}
+
+static void venus_rtc_alarm_aie_enable(int state)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&rtk_rtc_lock, flags);
+	if (state) {
+		writel(0x2000, rtk_iso_base + REG_ISO_ISR);
+		writel(0x1, rtk_iso_base + REG_ISO_RTC);
+	} else {
+		writel(0, rtk_iso_base + REG_ISO_RTC);
+		writel(0, rtk_rtc_base + REG_ALARMMIN);
+		writel(0, rtk_rtc_base + REG_ALARMHR);
+		writel(0, rtk_rtc_base + REG_ALARMDATE_LOW);
+		writel(0, rtk_rtc_base + REG_ALARMDATE_HIGH);
+	}
+
+	spin_unlock_irqrestore(&rtk_rtc_lock, flags);
+}
+
+static int venus_rtc_alarm_aie_state(void)
+{
+	unsigned long flags;
+	int ret;
+
+	spin_lock_irqsave(&rtk_rtc_lock, flags);
+	ret = readl(rtk_iso_base + REG_ISO_RTC) && 0x1;
+	spin_unlock_irqrestore(&rtk_rtc_lock, flags);
+
+	return ret;
+}
+
+static void venus_rtc_read_alarm_persistent_clock(struct timespec *ts)
+{
+	int day, hour, min;
+	int ret;
+	unsigned long flags;
+	unsigned long cur_time;
+
+	ret = venus_rtc_alarm_aie_state();
+	if (ret) {
+		spin_lock_irqsave(&rtk_rtc_lock, flags);
+		min = readl(rtk_rtc_base + REG_ALARMMIN);
+		hour = readl(rtk_rtc_base + REG_ALARMHR);
+		day = readl(rtk_rtc_base + REG_ALARMDATE_LOW);
+		day += readl(rtk_rtc_base + REG_ALARMDATE_HIGH) << 8;
+		spin_unlock_irqrestore(&rtk_rtc_lock, flags);
+	} else {
+		min = 0;
+		hour = 0;
+		day = 0;
+	}
+
+	cur_time = mktime(rtk_base_year + 1900, 1, 1, 0, 0, 0);
+	ts->tv_sec = ((day * 24 + hour) * 60 + min) * 60 + cur_time;
+	ts->tv_nsec = 0;
+}
+
+static int venus_rtc_set_alarm_mmss(unsigned long nowtime)
+{
+	unsigned long flags;
+	int day, hour, min, hms;
+	unsigned long off_sec;
+	unsigned long base_sec = mktime(rtk_base_year + 1900, 1, 1, 0, 0, 0);
+
+	off_sec = nowtime - base_sec;
+	if (base_sec > nowtime)
+		return -EINVAL;
+
+	day = off_sec / (24*60*60);
+	hms = off_sec % (24*60*60);
+	hour = hms / 3600;
+	min = (hms % 3600) / 60;
+
+	if (day > 16383)
+		return -EOVERFLOW;
+
+	/* irq are locally disabled here, but I still like to use
+	 * spin_lock_irqsave
+	 */
+	spin_lock_irqsave(&rtk_rtc_lock, flags);
+	writel(min, rtk_rtc_base + REG_ALARMMIN);
+	writel(hour, rtk_rtc_base + REG_ALARMHR);
+	writel(day & 0x00ff, rtk_rtc_base + REG_ALARMDATE_LOW);
+	writel((day & 0x3f00) >> 8, rtk_rtc_base + REG_ALARMDATE_HIGH);
+	spin_unlock_irqrestore(&rtk_rtc_lock, flags);
+
+	return 0;
+}
+
+static void rtk_read_persistent_clock(struct device *dev, struct timespec *ts)
+{
+	unsigned int retried = 0;
+	unsigned int day, hour, min, sec;
+	unsigned long flags;
+	unsigned long cur_time;
+
+	spin_lock_irqsave(&rtk_rtc_lock, flags);
+retry:
+	/*One unit represents half second */
+	sec = readl(rtk_rtc_base + REG_RTCSEC) >> 1;
+	min = readl(rtk_rtc_base + REG_RTCMIN);
+	hour = readl(rtk_rtc_base + REG_RTCHR);
+	day = readl(rtk_rtc_base + REG_RTCDATE_LOW);
+	day += readl(rtk_rtc_base + REG_RTCDATE_HIGH)<<8;
+	dev_dbg(dev, "sec=0x%x , min=0x%x . day=0x%x\n", sec, min, day);
+
+	if (sec == 0 && !retried) {
+		retried++;
+		goto retry;
+	}
+	spin_unlock_irqrestore(&rtk_rtc_lock, flags);
+
+	cur_time = mktime(rtk_base_year + 1900, 1, 1, 0, 0, 0);
+	ts->tv_sec = ((day * 24 + hour) * 60 + min) * 60 + sec + cur_time;
+	ts->tv_nsec = 0;
+}
+
+static int rtc_mips_set_mmss(struct device *dev, unsigned long nowtime)
+{
+	unsigned long flags;
+	int day, hour, min, sec, hms;
+	unsigned long off_sec;
+	unsigned long base_sec = mktime(rtk_base_year + 1900, 1, 1, 0, 0, 0);
+
+	off_sec = nowtime - base_sec;
+	if (base_sec > nowtime)
+		return -EINVAL;
+
+	day = off_sec / (24 * 60 * 60);
+	hms = off_sec % (24 * 60 * 60);
+	hour = hms / 3600;
+	min = (hms % 3600) / 60;
+	sec = ((hms % 3600) % 60) * 2; /* One unit represents half second */
+
+	if (day > 16383)
+		return -EOVERFLOW;
+
+	rtk_rtc_enable(dev, 0);
+
+	/* irq are locally disabled here, but I still like to use
+	 * spin_lock_irqsave
+	 */
+	spin_lock_irqsave(&rtk_rtc_lock, flags);
+
+	writel(sec, rtk_rtc_base + REG_RTCSEC);
+	writel(min, rtk_rtc_base + REG_RTCMIN);
+	writel(hour, rtk_rtc_base + REG_RTCHR);
+	writel((day & 0xFF), rtk_rtc_base + REG_RTCDATE_LOW);
+	writel(((day >> 8) & 0x7F), rtk_rtc_base + REG_RTCDATE_HIGH);
+
+	spin_unlock_irqrestore(&rtk_rtc_lock, flags);
+
+	rtk_rtc_enable(dev, 1);
+
+	return 0;
+}
+
+/* rtc_class_ops */
+static int rtk_rtc_gettime(struct device *dev, struct rtc_time *tm)
+{
+	struct timespec ts;
+
+	rtk_read_persistent_clock(dev, &ts);
+	rtc_time_to_tm(ts.tv_sec, tm);
+	dev_dbg(dev, "time read as %04d.%02d.%02d %02d:%02d:%02d",
+		1900+tm->tm_year,
+		tm->tm_mon,
+		tm->tm_mday,
+		tm->tm_hour,
+		tm->tm_min,
+		tm->tm_sec);
+
+	return rtc_valid_tm(tm);
+}
+
+static int rtk_rtc_settime(struct device *dev, struct rtc_time *tm)
+{
+	unsigned long cur_sec;
+
+	dev_dbg(dev, "set time %04d.%02d.%02d %02d:%02d:%02d",
+		1900+tm->tm_year,
+		tm->tm_mon,
+		tm->tm_mday,
+		tm->tm_hour,
+		tm->tm_min,
+		tm->tm_sec);
+
+	cur_sec = mktime(tm->tm_year + 1900,
+			tm->tm_mon + 1,
+			tm->tm_mday,
+			tm->tm_hour,
+			tm->tm_min,
+			tm->tm_sec);
+	return rtc_mips_set_mmss(dev, cur_sec);
+}
+
+static void rtk_rtc_start_alarm_timer(struct timer_list *timer,
+				     int expires_sec)
+{
+	long expires = get_jiffies_64() + msecs_to_jiffies(expires_sec * 1000);
+	if (!timer_pending(timer)) {
+		timer->expires = expires;
+		add_timer(timer);
+	} else
+		mod_timer(timer, expires);
+}
+
+static void rtk_rtc_stop_alarm_timer(struct timer_list *timer)
+{
+	if (timer_pending(timer))
+		del_timer(timer);
+}
+
+static int rtk_rtc_getalarm(struct device *dev, struct rtc_wkalrm *alrm)
+{
+	struct timespec ts;
+
+	venus_rtc_read_alarm_persistent_clock(&ts);
+	rtc_time_to_tm(ts.tv_sec, &alrm->time);
+	alrm->time.tm_sec = rtc_alarm_sec_left;
+	alrm->enabled = venus_rtc_alarm_aie_state();
+
+	return 0;
+}
+
+static int rtk_rtc_setalarm(struct device *dev, struct rtc_wkalrm *alrm)
+{
+	unsigned long tar_sec;
+	unsigned long cur_sec;
+	unsigned long delta;
+	struct timespec ts;
+	int ret = 0;
+
+	rtk_read_persistent_clock(dev, &ts);
+	cur_sec = ts.tv_sec;
+
+	venus_rtc_alarm_aie_enable(0);
+
+	tar_sec = mktime(alrm->time.tm_year + 1900, alrm->time.tm_mon + 1,
+			 alrm->time.tm_mday, alrm->time.tm_hour,
+			 alrm->time.tm_min, alrm->time.tm_sec);
+	if (tar_sec < cur_sec) {
+		ret = -EINVAL;
+		goto done;
+	}
+
+	ret = venus_rtc_set_alarm_mmss(tar_sec);
+	if (ret)
+		goto done;
+	rtc_alarm_sec_left = alrm->time.tm_sec;
+
+	dev_dbg(dev, "%s: cur=%ld, tar=%ld\n", __func__, cur_sec, tar_sec);
+	delta = tar_sec - cur_sec;
+	if (delta < 60)
+		rtk_rtc_start_alarm_timer(&rtc_alarm_sec_timer, (int)delta);
+done:
+	if (alrm->enabled)
+		venus_rtc_alarm_aie_enable(1);
+	return ret;
+}
+
+static int rtk_rtc_setaie(struct device *dev, unsigned int enabled)
+{
+	if (!enabled)
+		rtk_rtc_stop_alarm_timer(&rtc_alarm_sec_timer);
+	venus_rtc_alarm_aie_enable(enabled);
+	return 0;
+}
+
+static void rtk_rtc_alarm_timeout(unsigned long arg)
+{
+	struct platform_device *pdev = (void *)arg;
+	struct rtc_device *rtc = platform_get_drvdata(pdev);
+
+	rtc_update_irq(rtc, 1, RTC_IRQF | RTC_AF);
+}
+
+static irqreturn_t rtk_rtc_irq_handler(int irq, void *data)
+{
+	struct platform_device *pdev = data;
+	struct rtc_device *rtc = platform_get_drvdata(pdev);
+
+	writel(0x2000, rtk_iso_base + REG_ISO_ISR);
+	if (rtc_alarm_sec_left == 0)
+		rtc_update_irq(rtc, 1, RTC_IRQF | RTC_AF);
+	else
+		rtk_rtc_start_alarm_timer(&rtc_alarm_sec_timer, rtc_alarm_sec_left);
+
+	return IRQ_HANDLED;
+}
+
+static const struct rtc_class_ops rtk_rtc_ops = {
+	.read_time = rtk_rtc_gettime,
+	.set_time = rtk_rtc_settime,
+	.read_alarm = rtk_rtc_getalarm,
+	.set_alarm = rtk_rtc_setalarm,
+	.alarm_irq_enable = rtk_rtc_setaie,
+};
+
+__maybe_unused
+static const struct rtc_class_ops rtk_rtc_noalarm_ops = {
+	.read_time = rtk_rtc_gettime,
+	.set_time = rtk_rtc_settime,
+};
+
+static int rtk_rtc_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct rtc_device *rtc;
+	const struct rtc_class_ops *ops = &rtk_rtc_ops;
+	struct resource *res;
+	int ret;
+	const u32 *prop;
+
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	rtk_rtc_base = devm_ioremap_resource(dev, res);
+	if (IS_ERR(rtk_rtc_base))
+		return PTR_ERR(rtk_rtc_base);
+
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 1);
+	rtk_iso_base = devm_ioremap_resource(dev, res);
+	if (IS_ERR(rtk_iso_base))
+		return PTR_ERR(rtk_iso_base);
+
+	/*
+	 * The rstn and clk_en of rtc should be set for RTD-119x,
+	 * and clk_en should be set for RTD-129x.
+	 */
+	rtc_clk = devm_clk_get(dev, NULL);
+	if (IS_ERR(rtc_clk)) {
+		dev_dbg(dev, "failed to get clk: %ld\n", PTR_ERR(rtc_clk));
+		rtc_clk = NULL;
+	}
+
+	rtc_rstc = devm_reset_control_get(dev, NULL);
+	if (IS_ERR(rtc_rstc)) {
+		dev_dbg(dev, "failed to get reset control: %ld\n", PTR_ERR(rtc_rstc));
+		rtc_rstc = NULL;
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "rtc-base-year", NULL);
+	if (prop)
+		rtk_base_year = of_read_number(prop, 1);
+	else
+		rtk_base_year = 1900;
+
+	dev_info(dev, "rtk_base_year = %ld\n", rtk_base_year);
+	rtk_base_year -= 1900;
+
+	prop = of_get_property(pdev->dev.of_node, "rtc-bias", NULL);
+	if (prop)
+		rtk_bias = of_read_number(prop, 1);
+	else
+		rtk_bias = 0x2;
+
+	rtc_irq = platform_get_irq(pdev, 0);
+	if (rtc_irq < 0) {
+		dev_warn(dev, "failed to get irq: %d\n", rtc_irq);
+		ops = &rtk_rtc_noalarm_ops;
+		goto skip_alarm;
+	}
+
+	ret = devm_request_threaded_irq(dev, rtc_irq, NULL, rtk_rtc_irq_handler,
+					IRQF_ONESHOT, dev_name(dev), pdev);
+	if (ret) {
+		dev_warn(dev, "failed to request irq%d: %d\n", rtc_irq, ret);
+		ops = &rtk_rtc_noalarm_ops;
+		goto skip_alarm;
+	}
+
+	init_timer(&rtc_alarm_sec_timer);
+	rtc_alarm_sec_timer.function = rtk_rtc_alarm_timeout;
+	rtc_alarm_sec_timer.data = (unsigned long)pdev;
+skip_alarm:
+
+	clk_prepare_enable(rtc_clk);
+	if (rtc_rstc)
+		reset_control_deassert(rtc_rstc);
+
+	rtk_rtc_check_rtcacr(&pdev->dev);
+	rtk_rtc_enable(&pdev->dev, 1);
+
+#if RTC_TEST
+	{
+		struct rtc_time tm;
+
+		tm.tm_year = 115;
+		tm.tm_mon = 2;
+		tm.tm_mday = 28;
+		tm.tm_hour = 12;
+		tm.tm_min = 0;
+		tm.tm_sec = 1;
+
+		rtk_rtc_settime(&pdev->dev, &tm);
+	}
+
+	{
+		struct rtc_wkalrm alrm;
+
+		alrm.time.tm_year = 116;
+		alrm.time.tm_mon = 2;
+		alrm.time.tm_mday = 29;
+		alrm.time.tm_hour = 13;
+		alrm.time.tm_min = 1;
+		alrm.time.tm_sec = 2;
+
+		dev_err(dev, "alrm set as %04d.%02d.%02d %02d:%02d:%02d",
+			1900+alrm.time.tm_year,
+			alrm.time.tm_mon,
+			alrm.time.tm_mday,
+			alrm.time.tm_hour,
+			alrm.time.tm_min,
+			alrm.time.tm_sec);
+
+		rtk_rtc_setalarm(&pdev->dev, &alrm);
+	}
+
+	{
+		struct rtc_wkalrm alrm;
+
+		rtk_rtc_getalarm(&pdev->dev, &alrm);
+
+		dev_err(dev, "alrm read as %04d.%02d.%02d %02d:%02d:%02d",
+			1900+alrm.time.tm_year,
+			alrm.time.tm_mon,
+			alrm.time.tm_mday,
+			alrm.time.tm_hour,
+			alrm.time.tm_min,
+			alrm.time.tm_sec);
+	}
+#endif /* RTC_TEST */
+
+	device_init_wakeup(&pdev->dev, true);
+
+	rtc = devm_rtc_device_register(&pdev->dev, "rtc", ops,
+		THIS_MODULE);
+	if (IS_ERR(rtc)) {
+		dev_err(dev, "cannot attach rtc");
+		ret = PTR_ERR(rtc);
+		goto err_nortc;
+	}
+
+	platform_set_drvdata(pdev, rtc);
+	dev_info(dev, "initialized\n");
+
+	return 0;
+
+err_nortc:
+	if (rtc_rstc)
+		reset_control_assert(rtc_rstc);
+	clk_disable_unprepare(rtc_clk);
+	return ret;
+}
+
+static int  rtk_rtc_remove(struct platform_device *pdev)
+{
+	struct rtc_device *rtc = platform_get_drvdata(pdev);
+
+	dev_info(&pdev->dev, "%s %s", __FILE__, __func__);
+	rtk_rtc_stop_alarm_timer(&rtc_alarm_sec_timer);
+	devm_rtc_device_unregister(&pdev->dev, rtc);
+
+	if (rtc_rstc)
+		reset_control_assert(rtc_rstc);
+	clk_disable_unprepare(rtc_clk);
+
+	platform_set_drvdata(pdev, NULL);
+
+	return 0;
+}
+
+static const struct of_device_id rtk_rtc_ids[] = {
+	{ .compatible = "realtek,rtk-rtc" },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtd1295_watchdog_match);
+
+static struct platform_driver rtk_rtc_driver = {
+	.probe = rtk_rtc_probe,
+	.remove = rtk_rtc_remove,
+	.driver = {
+		.name = DEV_NAME,
+		.of_match_table	= rtk_rtc_ids,
+	},
+};
+
+module_platform_driver(rtk_rtc_driver);
diff --git a/drivers/rtc/rtc-rtk.h b/drivers/rtc/rtc-rtk.h
new file mode 100644
index 00000000..36ca8144
--- /dev/null
+++ b/drivers/rtc/rtc-rtk.h
@@ -0,0 +1,43 @@
+/*
+ * rtc-rtk.h - Realtek real timer clock driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef DRIVERS_RTC_RTC_RTD1295_H_
+#define DRIVERS_RTC_RTC_RTD1295_H_
+
+#define dbg_fmt(fmt) fmt
+
+#define dbg_err(fmt, ...) \
+	printk(KERN_ERR RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_emerg(fmt, ...) \
+	printk(KERN_EMERG RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_alert(fmt, ...) \
+	printk(KERN_ALERT RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_crit(fmt, ...) \
+	printk(KERN_CRIT RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_warning(fmt, ...) \
+	printk(KERN_WARNING RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_warn dbg_warning
+
+#define dbg_info(fmt, ...) \
+	printk(KERN_INFO CYAN dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_notice(fmt, ...) \
+	printk(KERN_NOTICE CYAN dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_cont(fmt, ...) \
+	printk(KERN_CONT CYAN fmt NONE"\n", ##__VA_ARGS__)
+
+#endif /* DRIVERS_RTC_RTC_RTD1295_H_ */
diff --git a/drivers/rtc/rtc-sw.c b/drivers/rtc/rtc-sw.c
new file mode 100644
index 00000000..6a72c1b
--- /dev/null
+++ b/drivers/rtc/rtc-sw.c
@@ -0,0 +1,252 @@
+/*
+ * rtc-sw.c - Realtek SW RTC driver
+ *
+ * Copyright (c) 2018 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/err.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/platform_device.h>
+#include <linux/rtc.h>
+#include <linux/jiffies.h>
+#include <linux/spinlock.h>
+#include <linux/slab.h>
+
+#define TIME_2014_01_01       1388534400
+#define SW_RTC_DEFAULT_TIME   TIME_2014_01_01
+
+
+struct sw_rtc_data {
+	struct rtc_device *rtc;
+
+	struct rtc_time time;
+	u64 last_jiffies;
+	spinlock_t lock;
+
+	struct rtc_time time_alarm;
+	struct timer_list timer;
+};
+
+static void sw_rtc_alarm_timeout(unsigned long arg)
+{
+	struct sw_rtc_data *data = (struct sw_rtc_data *)arg;
+	unsigned long events = RTC_IRQF | RTC_AF;
+
+	rtc_update_irq(data->rtc, 1, events);
+}
+
+static struct sw_rtc_data *create_sw_rtc(void)
+{
+	struct sw_rtc_data *data;
+
+	data = kzalloc(sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return NULL;
+
+	spin_lock_init(&data->lock);
+	rtc_time_to_tm(SW_RTC_DEFAULT_TIME, &data->time);
+	data->last_jiffies = get_jiffies_64();
+
+	init_timer(&data->timer);
+	data->timer.function = sw_rtc_alarm_timeout;
+	data->timer.data = (unsigned long)data;
+	data->time_alarm = data->time;
+	return data;
+}
+
+static void destroy_sw_rtc(struct sw_rtc_data *data)
+{
+	if (timer_pending(&data->timer))
+		del_timer(&data->timer);
+	kfree(data);
+}
+
+static void sw_rtc_update_tm(struct sw_rtc_data *data, struct rtc_time *tm)
+{
+	spin_lock(&data->lock);
+	data->time = *tm;
+	data->last_jiffies = get_jiffies_64();
+	spin_unlock(&data->lock);
+}
+
+static void sw_rtc_get_tm(struct sw_rtc_data *data, struct rtc_time *tm)
+{
+	time64_t time;
+	u64 cur_jiffies = get_jiffies_64();
+	u64 delta;
+
+	spin_lock(&data->lock);
+	delta = cur_jiffies - data->last_jiffies;
+	time = rtc_tm_to_time64(&data->time);
+	spin_unlock(&data->lock);
+
+	time += jiffies_to_msecs(delta) / 1000;
+	rtc_time64_to_tm(time, tm);
+}
+
+static int sw_rtc_read_time(struct device *dev, struct rtc_time *tm)
+{
+	struct sw_rtc_data *data = dev_get_drvdata(dev);
+
+	sw_rtc_get_tm(data, tm);
+	return rtc_valid_tm(tm);
+}
+
+static int sw_rtc_set_time(struct device *dev, struct rtc_time *tm)
+{
+	struct sw_rtc_data *data = dev_get_drvdata(dev);
+
+	sw_rtc_update_tm(data, tm);
+	return 0;
+}
+
+static int sw_rtc_read_alarm(struct device *dev, struct rtc_wkalrm *alrm)
+{
+	struct sw_rtc_data *data = dev_get_drvdata(dev);
+
+	alrm->time = data->time_alarm;
+	alrm->enabled = timer_pending(&data->timer);
+	alrm->pending = 0;
+
+	return 0;
+}
+
+static int sw_rtc_alarm_start(struct sw_rtc_data *data)
+{
+	struct rtc_time curr;
+	time64_t t_cur, t_alarm, delta;
+
+	sw_rtc_get_tm(data, &curr);
+
+	t_cur = rtc_tm_to_time64(&curr);
+	t_alarm = rtc_tm_to_time64(&data->time_alarm);
+
+	if (t_cur >= t_alarm)
+		return -EINVAL;
+	delta = t_alarm - t_cur;
+
+	data->timer.expires = get_jiffies_64() + msecs_to_jiffies(delta * 1000);
+	add_timer(&data->timer);
+	return 0;
+}
+
+static int sw_rtc_set_alarm(struct device *dev,
+	struct rtc_wkalrm *alrm)
+{
+	struct sw_rtc_data *data = dev_get_drvdata(dev);
+
+	data->time_alarm = alrm->time;
+	if (timer_pending(&data->timer)) {
+		del_timer(&data->timer);
+		sw_rtc_alarm_start(data);
+	}
+
+	return 0;
+}
+
+static int sw_rtc_alarm_irq_enable(struct device *dev, unsigned int enable)
+{
+	struct sw_rtc_data *data = dev_get_drvdata(dev);
+
+	if (enable) {
+		if (timer_pending(&data->timer))
+			del_timer(&data->timer);
+		sw_rtc_alarm_start(data);
+
+	} else {
+		if (timer_pending(&data->timer))
+			del_timer(&data->timer);
+	}
+	return 0;
+}
+
+static const struct rtc_class_ops sw_rtc_ops = {
+	.read_time = sw_rtc_read_time,
+	.set_time = sw_rtc_set_time,
+	.read_alarm = sw_rtc_read_alarm,
+	.set_alarm = sw_rtc_set_alarm,
+	.alarm_irq_enable = sw_rtc_alarm_irq_enable,
+};
+
+static int sw_rtc_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct sw_rtc_data *data;
+	int ret = 0;
+
+	data = create_sw_rtc();
+	if (!data) {
+		dev_err(dev, "fail to create_sw_rtc\n");
+		return -ENOMEM;
+	}
+
+	dev_set_drvdata(dev, data);
+	device_init_wakeup(dev, true);
+
+	data->rtc = devm_rtc_device_register(&pdev->dev, "rtc-sw", &sw_rtc_ops,
+		THIS_MODULE);
+	if (IS_ERR(data->rtc)) {
+		ret = PTR_ERR(data->rtc);
+		dev_err(dev, "rtc_device_register() returns %d\n", ret);
+		return ret;
+	}
+
+	dev_info(dev, "initialized\n");
+	return ret;
+}
+
+static int  sw_rtc_remove(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct sw_rtc_data *data = dev_get_drvdata(dev);
+
+	destroy_sw_rtc(data);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+static struct platform_driver sw_rtc_driver = {
+	.probe = sw_rtc_probe,
+	.remove = sw_rtc_remove,
+	.driver = {
+		.owner = THIS_MODULE,
+		.name = "rtk-sw-rtc",
+	},
+};
+
+static struct platform_device *sw_rtc_dev;
+
+static int __init sw_rtc_init(void)
+{
+	int ret;
+
+	ret = platform_driver_register(&sw_rtc_driver);
+	if (ret) {
+		pr_err("%s: platform_driver_register() returns %d\n", __func__, ret);
+		return ret;
+	}
+
+	sw_rtc_dev = platform_device_register_simple("rtk-sw-rtc", 0, NULL, 0);
+	if (IS_ERR(sw_rtc_dev)) {
+		ret = PTR_ERR(sw_rtc_dev);
+		pr_err("%s: platform_driver_register() returns %d\n", __func__, ret);
+		platform_driver_unregister(&sw_rtc_driver);
+		return ret;
+	}
+	return 0;
+}
+module_init(sw_rtc_init);
+
+static void __exit sw_rtc_exit(void)
+{
+	platform_device_unregister(sw_rtc_dev);
+	platform_driver_unregister(&sw_rtc_driver);
+}
+module_exit(sw_rtc_exit);
+
diff --git a/drivers/scsi/fcoe/fcoe_transport.c b/drivers/scsi/fcoe/fcoe_transport.c
index 375c536..c5eb0c4 100644
--- a/drivers/scsi/fcoe/fcoe_transport.c
+++ b/drivers/scsi/fcoe/fcoe_transport.c
@@ -32,13 +32,13 @@
 MODULE_DESCRIPTION("FIP discovery protocol and FCoE transport for FCoE HBAs");
 MODULE_LICENSE("GPL v2");
 
-static int fcoe_transport_create(const char *, struct kernel_param *);
-static int fcoe_transport_destroy(const char *, struct kernel_param *);
+static int fcoe_transport_create(const char *, const struct kernel_param *);
+static int fcoe_transport_destroy(const char *, const struct kernel_param *);
 static int fcoe_transport_show(char *buffer, const struct kernel_param *kp);
 static struct fcoe_transport *fcoe_transport_lookup(struct net_device *device);
 static struct fcoe_transport *fcoe_netdev_map_lookup(struct net_device *device);
-static int fcoe_transport_enable(const char *, struct kernel_param *);
-static int fcoe_transport_disable(const char *, struct kernel_param *);
+static int fcoe_transport_enable(const char *, const struct kernel_param *);
+static int fcoe_transport_disable(const char *, const struct kernel_param *);
 static int libfcoe_device_notification(struct notifier_block *notifier,
 				    ulong event, void *ptr);
 
@@ -865,7 +865,8 @@ ssize_t fcoe_ctlr_destroy_store(struct bus_type *bus,
  *
  * Returns: 0 for success
  */
-static int fcoe_transport_create(const char *buffer, struct kernel_param *kp)
+static int fcoe_transport_create(const char *buffer,
+				 const struct kernel_param *kp)
 {
 	int rc = -ENODEV;
 	struct net_device *netdev = NULL;
@@ -930,7 +931,8 @@ static int fcoe_transport_create(const char *buffer, struct kernel_param *kp)
  *
  * Returns: 0 for success
  */
-static int fcoe_transport_destroy(const char *buffer, struct kernel_param *kp)
+static int fcoe_transport_destroy(const char *buffer,
+				  const struct kernel_param *kp)
 {
 	int rc = -ENODEV;
 	struct net_device *netdev = NULL;
@@ -974,7 +976,8 @@ static int fcoe_transport_destroy(const char *buffer, struct kernel_param *kp)
  *
  * Returns: 0 for success
  */
-static int fcoe_transport_disable(const char *buffer, struct kernel_param *kp)
+static int fcoe_transport_disable(const char *buffer,
+				  const struct kernel_param *kp)
 {
 	int rc = -ENODEV;
 	struct net_device *netdev = NULL;
@@ -1008,7 +1011,8 @@ static int fcoe_transport_disable(const char *buffer, struct kernel_param *kp)
  *
  * Returns: 0 for success
  */
-static int fcoe_transport_enable(const char *buffer, struct kernel_param *kp)
+static int fcoe_transport_enable(const char *buffer,
+				 const struct kernel_param *kp)
 {
 	int rc = -ENODEV;
 	struct net_device *netdev = NULL;
diff --git a/drivers/scsi/mpt3sas/mpt3sas_base.c b/drivers/scsi/mpt3sas/mpt3sas_base.c
index a1a5ceb..8e83e34 100644
--- a/drivers/scsi/mpt3sas/mpt3sas_base.c
+++ b/drivers/scsi/mpt3sas/mpt3sas_base.c
@@ -105,7 +105,7 @@
  *
  */
 static int
-_scsih_set_fwfault_debug(const char *val, struct kernel_param *kp)
+_scsih_set_fwfault_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret = param_set_int(val, kp);
 	struct MPT3SAS_ADAPTER *ioc;
diff --git a/drivers/scsi/mpt3sas/mpt3sas_scsih.c b/drivers/scsi/mpt3sas/mpt3sas_scsih.c
index ec48c01..caa0045 100644
--- a/drivers/scsi/mpt3sas/mpt3sas_scsih.c
+++ b/drivers/scsi/mpt3sas/mpt3sas_scsih.c
@@ -281,7 +281,7 @@ struct _scsi_io_transfer {
  * Note: The logging levels are defined in mpt3sas_debug.h.
  */
 static int
-_scsih_set_debug_level(const char *val, struct kernel_param *kp)
+_scsih_set_debug_level(const char *val, const struct kernel_param *kp)
 {
 	int ret = param_set_int(val, kp);
 	struct MPT3SAS_ADAPTER *ioc;
diff --git a/drivers/scsi/sd.c b/drivers/scsi/sd.c
index f8b6bf5..4864275 100644
--- a/drivers/scsi/sd.c
+++ b/drivers/scsi/sd.c
@@ -3108,6 +3108,17 @@ static int sd_probe(struct device *dev)
 		goto out_put;
 	}
 
+#if 0//#ifdef CONFIG_AHCI_RTK
+	if( sdp->host && sdp->host->hostt ) {
+		if( strncmp(sdp->host->hostt->name, "ahci", 4 ) == 0 ) {
+			error = sd_format_disk_name("sata", index, gd->disk_name, DISK_NAME_LEN);
+		}
+		else {
+			error = sd_format_disk_name("sd", index, gd->disk_name, DISK_NAME_LEN);
+		}
+	}
+	else
+#endif
 	error = sd_format_disk_name("sd", index, gd->disk_name, DISK_NAME_LEN);
 	if (error) {
 		sdev_printk(KERN_WARNING, sdp, "SCSI disk (sd) name length exceeded.\n");
diff --git a/drivers/scsi/ufs/ufshcd.c b/drivers/scsi/ufs/ufshcd.c
index f857086..d0f6f2c 100644
--- a/drivers/scsi/ufs/ufshcd.c
+++ b/drivers/scsi/ufs/ufshcd.c
@@ -41,6 +41,7 @@
 #include <linux/devfreq.h>
 #include <linux/nls.h>
 #include <linux/of.h>
+#include <linux/blkdev.h>
 #include "ufshcd.h"
 #include "ufs_quirks.h"
 #include "unipro.h"
@@ -1469,6 +1470,17 @@ static int ufshcd_queuecommand(struct Scsi_Host *host, struct scsi_cmnd *cmd)
 		clear_bit_unlock(tag, &hba->lrb_in_use);
 		goto out;
 	}
+
+	/* IO svc time latency histogram */
+	if (hba != NULL && cmd->request != NULL) {
+		if (hba->latency_hist_enabled &&
+		    (cmd->request->cmd_type == REQ_TYPE_FS)) {
+			cmd->request->lat_hist_io_start = ktime_get();
+			cmd->request->lat_hist_enabled = 1;
+		} else
+			cmd->request->lat_hist_enabled = 0;
+	}
+
 	WARN_ON(hba->clk_gating.state != CLKS_ON);
 
 	lrbp = &hba->lrb[tag];
@@ -3677,6 +3689,7 @@ static void __ufshcd_transfer_req_compl(struct ufs_hba *hba,
 	struct scsi_cmnd *cmd;
 	int result;
 	int index;
+	struct request *req;
 
 	for_each_set_bit(index, &completed_reqs, hba->nutrs) {
 		lrbp = &hba->lrb[index];
@@ -3688,6 +3701,22 @@ static void __ufshcd_transfer_req_compl(struct ufs_hba *hba,
 			/* Mark completed command as NULL in LRB */
 			lrbp->cmd = NULL;
 			clear_bit_unlock(index, &hba->lrb_in_use);
+			req = cmd->request;
+			if (req) {
+				/* Update IO svc time latency histogram */
+				if (req->lat_hist_enabled) {
+					ktime_t completion;
+					u_int64_t delta_us;
+
+					completion = ktime_get();
+					delta_us = ktime_us_delta(completion,
+						  req->lat_hist_io_start);
+					blk_update_latency_hist(
+						(rq_data_dir(req) == READ) ?
+						&hba->io_lat_read :
+						&hba->io_lat_write, delta_us);
+				}
+			}
 			/* Do not touch lrbp after scsi done */
 			cmd->scsi_done(cmd);
 			__ufshcd_release(hba);
@@ -6467,6 +6496,61 @@ int ufshcd_shutdown(struct ufs_hba *hba)
 }
 EXPORT_SYMBOL(ufshcd_shutdown);
 
+/*
+ * Values permitted 0, 1, 2.
+ * 0 -> Disable IO latency histograms (default)
+ * 1 -> Enable IO latency histograms
+ * 2 -> Zero out IO latency histograms
+ */
+static ssize_t
+latency_hist_store(struct device *dev, struct device_attribute *attr,
+		   const char *buf, size_t count)
+{
+	struct ufs_hba *hba = dev_get_drvdata(dev);
+	long value;
+
+	if (kstrtol(buf, 0, &value))
+		return -EINVAL;
+	if (value == BLK_IO_LAT_HIST_ZERO) {
+		memset(&hba->io_lat_read, 0, sizeof(hba->io_lat_read));
+		memset(&hba->io_lat_write, 0, sizeof(hba->io_lat_write));
+	} else if (value == BLK_IO_LAT_HIST_ENABLE ||
+		 value == BLK_IO_LAT_HIST_DISABLE)
+		hba->latency_hist_enabled = value;
+	return count;
+}
+
+ssize_t
+latency_hist_show(struct device *dev, struct device_attribute *attr,
+		  char *buf)
+{
+	struct ufs_hba *hba = dev_get_drvdata(dev);
+	size_t written_bytes;
+
+	written_bytes = blk_latency_hist_show("Read", &hba->io_lat_read,
+			buf, PAGE_SIZE);
+	written_bytes += blk_latency_hist_show("Write", &hba->io_lat_write,
+			buf + written_bytes, PAGE_SIZE - written_bytes);
+
+	return written_bytes;
+}
+
+static DEVICE_ATTR(latency_hist, S_IRUGO | S_IWUSR,
+		   latency_hist_show, latency_hist_store);
+
+static void
+ufshcd_init_latency_hist(struct ufs_hba *hba)
+{
+	if (device_create_file(hba->dev, &dev_attr_latency_hist))
+		dev_err(hba->dev, "Failed to create latency_hist sysfs entry\n");
+}
+
+static void
+ufshcd_exit_latency_hist(struct ufs_hba *hba)
+{
+	device_create_file(hba->dev, &dev_attr_latency_hist);
+}
+
 /**
  * ufshcd_remove - de-allocate SCSI host and host memory space
  *		data structure memory
@@ -6482,6 +6566,7 @@ void ufshcd_remove(struct ufs_hba *hba)
 	scsi_host_put(hba->host);
 
 	ufshcd_exit_clk_gating(hba);
+	ufshcd_exit_latency_hist(hba);
 	if (ufshcd_is_clkscaling_enabled(hba))
 		devfreq_remove_device(hba->devfreq);
 	ufshcd_hba_exit(hba);
@@ -6798,6 +6883,8 @@ int ufshcd_init(struct ufs_hba *hba, void __iomem *mmio_base, unsigned int irq)
 	/* Hold auto suspend until async scan completes */
 	pm_runtime_get_sync(dev);
 
+	ufshcd_init_latency_hist(hba);
+
 	/*
 	 * We are assuming that device wasn't put in sleep/power-down
 	 * state exclusively during the boot stage before kernel.
@@ -6814,6 +6901,7 @@ int ufshcd_init(struct ufs_hba *hba, void __iomem *mmio_base, unsigned int irq)
 	scsi_remove_host(hba->host);
 exit_gating:
 	ufshcd_exit_clk_gating(hba);
+	ufshcd_exit_latency_hist(hba);
 out_disable:
 	hba->is_irq_enabled = false;
 	scsi_host_put(host);
diff --git a/drivers/scsi/ufs/ufshcd.h b/drivers/scsi/ufs/ufshcd.h
index 6dbd2e1..096e667 100644
--- a/drivers/scsi/ufs/ufshcd.h
+++ b/drivers/scsi/ufs/ufshcd.h
@@ -575,6 +575,10 @@ struct ufs_hba {
 	bool is_urgent_bkops_lvl_checked;
 
 	struct ufs_desc_size desc_size;
+
+	int latency_hist_enabled;
+	struct io_latency_state io_lat_read;
+	struct io_latency_state io_lat_write;
 };
 
 /* Returns true if clocks can be gated. Otherwise false */
diff --git a/drivers/smartcard/Kconfig b/drivers/smartcard/Kconfig
new file mode 100755
index 00000000..60d7c78
--- /dev/null
+++ b/drivers/smartcard/Kconfig
@@ -0,0 +1,15 @@
+# drivers/cec/Kconfig
+
+menu "Smart Crad Interface Support"
+
+config SMARTCARD
+	tristate "Smart Card Interface Support"
+	default n
+	help
+	  Say Y here if you want to support smart card on your platform 
+	
+source drivers/smartcard/core/Kconfig
+source drivers/smartcard/adapter/Kconfig
+
+endmenu
+	
diff --git a/drivers/smartcard/Makefile b/drivers/smartcard/Makefile
new file mode 100755
index 00000000..5e37692
--- /dev/null
+++ b/drivers/smartcard/Makefile
@@ -0,0 +1,3 @@
+#obj-$(CONFIG_SMARTCARD)+= core/ adapter/
+#obj-$(CONFIG_SMARTCARD)+= core/ adapter/
+obj-y			+= core/ adapter/
diff --git a/drivers/smartcard/adapter/Kconfig b/drivers/smartcard/adapter/Kconfig
new file mode 100755
index 00000000..7b7a46b
--- /dev/null
+++ b/drivers/smartcard/adapter/Kconfig
@@ -0,0 +1,27 @@
+# drivers/Kconfig
+
+comment"Smart Card Interface"
+	depends on SMARTCARD
+
+config MARS_SMARTCARD_IFD
+	tristate "Smart Card Interface for Saturn(1886 only), Darwin, Macarthur & Nike"
+	depends on SMARTCARD && (REALTEK_SATURN || REALTEK_DARWIN || REALTEK_MACARTHUR || REALTEK_NIKE)
+	default n
+	help
+	  If you want to use smart card on Saturn, Darwin and Macarthur board, say Y.
+
+config GPIO_SMARTCARD_IFD
+	tristate "GPIO Smart Card Interface"
+	depends on SMARTCARD && REALTEK_DMP_VENUS
+	select REALTEK_PWM
+	default n
+	help
+	  If you want to use gpio based smart card on board, say Y.
+
+config ICAM_SMARTCARD_IFD
+	tristate "ICAM Smart Card Interface for Nike"
+	depends on SMARTCARD && (REALTEK_NIKE)
+	default n
+	help
+	  If you want to use ICAM smart card interface on Nike platform, say Y.
+
diff --git a/drivers/smartcard/adapter/Makefile b/drivers/smartcard/adapter/Makefile
new file mode 100755
index 00000000..5e35b87
--- /dev/null
+++ b/drivers/smartcard/adapter/Makefile
@@ -0,0 +1,19 @@
+#EXTRA_CFLAGS += -I ../core/
+
+mars_scd-objs = scd_mars.o \
+                scd_mars_priv.o
+
+#obj-$(CONFIG_MARS_SMARTCARD_IFD) += mars_scd.o
+obj-y				 += mars_scd.o
+
+
+gpio_scd-objs = scd_gpio.o \
+                scd_gpio_priv.o
+
+obj-$(CONFIG_GPIO_SMARTCARD_IFD) += gpio_scd.o
+
+icam_scd-objs = scd_icam.o \
+                scd_icam_priv.o
+
+obj-$(CONFIG_ICAM_SMARTCARD_IFD) += icam_scd.o
+
diff --git a/drivers/smartcard/adapter/scd_gpio.c b/drivers/smartcard/adapter/scd_gpio.c
new file mode 100644
index 00000000..c3ffbac
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_gpio.c
@@ -0,0 +1,426 @@
+/* ------------------------------------------------------------------------- 
+   scd_mars.c  scd driver for Realtek Neptune/Mars           
+   ------------------------------------------------------------------------- 
+    Copyright (C) 2008 Kevin Wang <kevin_wang@realtek.com.tw>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    
+----------------------------------------------------------------------------
+Update List :
+----------------------------------------------------------------------------
+    1.0     |   20090312    |   Kevin Wang  | 1) create phase
+----------------------------------------------------------------------------*/
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/jiffies.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <asm/io.h>
+#include "scd_gpio_priv.h"
+
+MODULE_LICENSE("GPL");
+
+
+/*------------------------------------------------------------------
+ * Func : ops_probe
+ *
+ * Desc : probe a scd device
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static 
+int ops_probe(scd_device* dev)
+{    
+    gpio_scd* p_scd;
+    
+    if ((dev->id & 0xFFFFFFFC)!=0x12830000)
+        return -ENODEV;                         
+                
+    p_scd = gpio_scd_open((dev->id & 0x3));
+    
+    if (p_scd==NULL)
+        return -ENOMEM;
+   
+    scd_set_drvdata(dev, p_scd);    // attach it to the scd_device
+    return 0;     
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_remove
+ *
+ * Desc : this function will be invoked when a smart card device which 
+ *        associated with this driver has been removed
+ *
+ * Parm : dev : smart card device to be removed
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+static 
+void ops_remove(scd_device* dev)
+{       
+    gpio_scd_close((gpio_scd*) scd_get_drvdata(dev));
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_enable
+ *
+ * Desc : enable IFD
+ *
+ * Parm : dev    : ifd device
+ *        on_off : 0      : disable IFD 
+ *                 others : enable IFD
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static 
+int ops_enable(scd_device* dev, unsigned char on_off)
+{    
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);
+    return gpio_scd_enable(p_this, on_off);        
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_set_param
+ *
+ * Desc : set param of IFD
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static 
+int ops_set_param(
+    scd_device*             dev, 
+    unsigned long           id,
+    unsigned long           val
+    )
+{    
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);
+    int ret= SC_SUCCESS; 
+        
+    switch(id) 
+    {        
+    case SC_PARAM_VCC_LVL:
+        ret = gpio_scd_set_vcc_lvl(p_this, (SC_VCC_LVL) val);   
+        break;
+        
+    case SC_PARAM_CLOCK:
+        ret = gpio_scd_set_clock(p_this, (unsigned long) val);        
+        break;
+        
+    case SC_PARAM_ETU:
+        ret = gpio_scd_set_etu(p_this, (unsigned long) val); 
+        break;
+        
+    case SC_PARAM_CONV:
+        ret = gpio_scd_set_convention(p_this, (SC_CONV) val);   
+        break;
+        
+    case SC_PARAM_PARITY:
+        ret = gpio_scd_set_parity(p_this, (SC_PARITY) val);   
+        break;
+        
+    case SC_PARAM_GUARD_INTERVAL:
+        // do nothing        
+        break;
+        
+    default:
+        ret = SC_FAIL;        
+    }
+            
+    return ret;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_get_param
+ *
+ * Desc : get param of IFD
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static 
+int ops_get_param(
+    scd_device*             dev, 
+    unsigned long           id,                                
+    unsigned long*          p_val
+    )
+{    
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);
+    int ret = SC_SUCCESS;    
+        
+    switch(id) 
+    {        
+    case SC_PARAM_VCC_LVL:
+        ret = gpio_scd_get_vcc_lvl(p_this, (SC_VCC_LVL*) p_val);   
+        break;
+        
+    case SC_PARAM_CLOCK:        
+        ret = gpio_scd_get_clock(p_this,  p_val);        
+        break;
+        
+    case SC_PARAM_ETU:
+        ret = gpio_scd_get_etu(p_this, p_val); 
+        break;
+        
+    case SC_PARAM_CONV:
+        ret = gpio_scd_get_convention(p_this, (SC_CONV*) p_val);   
+        break;
+        
+    case SC_PARAM_PARITY:
+        ret = gpio_scd_get_parity(p_this, (SC_PARITY*) p_val);   
+        break;
+        
+    case SC_PARAM_GUARD_INTERVAL:
+        *p_val = 2;
+        break;
+        
+    default:
+        ret = SC_FAIL;        
+    }
+    
+    return ret;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_activate
+ *
+ * Desc : activate ICC via reset procedure
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_activate(scd_device* dev)
+{            
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);    
+    return gpio_scd_activate(p_this);    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_deactivate
+ *
+ * Desc : deactivate icc
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_deactivate(scd_device* dev)
+{            
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);    
+    return gpio_scd_deactivate(p_this);    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_reset
+ *
+ * Desc : reset a scd device 
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_reset(scd_device* dev)
+{            
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);          
+    return gpio_scd_reset(p_this);    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_get_atr
+ *
+ * Desc : get atr from a scd device 
+ *
+ * Parm : dev 
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_get_atr(scd_device* dev, scd_atr* p_atr)
+{
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);              
+    return gpio_scd_get_atr(p_this, p_atr);            
+}
+
+
+/*------------------------------------------------------------------
+ * Func : ops_get_card_status
+ *
+ * Desc : get card status of IFD 
+ *
+ * Parm : dev 
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_get_card_status(scd_device* dev)
+{    
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);    
+    return gpio_scd_get_card_status(p_this);
+}
+
+
+  
+/*------------------------------------------------------------------
+ * Func : ops_poll_card_status
+ *
+ * Desc : poll card status
+ *
+ * Parm : dev  :   
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_poll_card_status(scd_device* dev)
+{
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);    
+    return gpio_scd_poll_card_status(p_this);    
+}
+
+  
+/*------------------------------------------------------------------
+ * Func : ops_xmit
+ *
+ * Desc : xmit data via smart card bus
+ *
+ * Parm : dev  :   
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_xmit(scd_device* dev, unsigned char* p_data, unsigned int len)
+{   
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);    
+    return gpio_scd_xmit(p_this, p_data, len);     
+}                                 
+              
+              
+  
+/*------------------------------------------------------------------
+ * Func : ops_read
+ *
+ * Desc : read data via smart card bus
+ *
+ * Parm : dev  :   
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_read(scd_device* dev, unsigned char* p_data, unsigned int len)
+{   
+    gpio_scd* p_this = (gpio_scd*) scd_get_drvdata(dev);
+    return gpio_scd_read(p_this, p_data, len);
+}                                 
+                                                                  
+
+static scd_device gpio_scd_controller[1] = 
+{
+    {
+        .id   = ID_MARS_SCD(0),
+        .name = "gpio_scd_0"
+    },
+};
+
+
+static scd_driver gpio_scd_driver = 
+{    
+    .name               = "gpio_scd",
+    .probe              = ops_probe,
+    .remove             = ops_remove,        
+    .suspend            = NULL,
+    .resume             = NULL,
+    .enable             = ops_enable,
+    .set_param          = ops_set_param,
+    .get_param          = ops_get_param,    
+    .activate           = ops_activate,
+    .deactivate         = ops_deactivate,
+    .reset              = ops_reset,
+    .get_atr            = ops_get_atr,
+    .get_card_status    = ops_get_card_status,
+    .poll_card_status   = ops_poll_card_status,
+    .xmit               = ops_xmit,
+    .read               = ops_read,
+};
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_module_init
+ *
+ * Desc : init gpio smart card interface driver
+ *
+ * Parm : N/A
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static int __init gpio_scd_module_init(void)
+{                        
+    SC_INFO("gpio scd module init\n");        
+                                
+    if (register_scd_driver(&gpio_scd_driver)!=0)
+        return -EFAULT;                                        
+
+    register_scd_device(&gpio_scd_controller[0]);          // register scd device
+                            
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_module_exit
+ *
+ * Desc : uninit gpio smart card interface driver
+ *
+ * Parm : N/A
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static void __exit gpio_scd_module_exit(void)
+{            
+    unregister_scd_device(&gpio_scd_controller[0]);    
+    unregister_scd_driver(&gpio_scd_driver);
+}
+
+
+module_init(gpio_scd_module_init);
+module_exit(gpio_scd_module_exit);
diff --git a/drivers/smartcard/adapter/scd_gpio_priv.c b/drivers/smartcard/adapter/scd_gpio_priv.c
new file mode 100755
index 00000000..62905ba
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_gpio_priv.c
@@ -0,0 +1,1585 @@
+/* ------------------------------------------------------------------------- 
+   scd_gpio.c  scd driver for Realtek Neptune/Mars           
+   ------------------------------------------------------------------------- 
+    Copyright (C) 2008 Kevin Wang <kevin_wang@realtek.com.tw>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    
+----------------------------------------------------------------------------
+Update List :
+----------------------------------------------------------------------------
+    1.0     |   20090312    |   Kevin Wang  | 1) create phase
+----------------------------------------------------------------------------*/
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/jiffies.h>
+#include <linux/time.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <asm/io.h>
+#include <platform.h>
+#include <asm/mach-rtk_dmp/venus_gpio.h>
+#include <asm/mach-rtk_dmp/venus_pwm.h>
+#include "scd_gpio_priv.h"
+#include "scd_gpio_priv_config.h"
+#include "scd_mars_reg.h"
+
+MODULE_LICENSE("GPL");
+
+/* Basic operation */
+
+#if 1
+
+#define rtd_inb(offset)             (*(volatile unsigned char  *)(offset))
+#define rtd_inw(offset)             (*(volatile unsigned short *)(offset))
+#define rtd_inl(offset)             (*(volatile unsigned long  *)(offset))
+#define rtd_outb(offset,val)        (*(volatile unsigned char  *)(offset) = val)
+#define rtd_outw(offset,val)        (*(volatile unsigned short *)(offset) = val)
+#define rtd_outl(offset,val)        (*(volatile unsigned long  *)(offset) = val)
+
+#else
+
+#define rtd_inb(offset)             (*(volatile unsigned char  *)(offset))
+#define rtd_inw(offset)             (*(volatile unsigned short *)(offset))
+#define rtd_inl(offset)             (*(volatile unsigned long  *)(offset))
+#define rtd_outb(offset,val)        do { (*(volatile unsigned char  *)(offset) = val); printk("write reg=%08x, val=%08x\n", offset, (unsigned long) val); }while(0)
+#define rtd_outw(offset,val)        do { (*(volatile unsigned short *)(offset) = val); printk("write reg=%08x, val=%08x\n", offset, (unsigned long) val); }while(0)
+#define rtd_outl(offset,val)        do { (*(volatile unsigned long  *)(offset) = val); printk("write reg=%08x, val=%08x\n", offset, (unsigned long) val); }while(0)
+
+#endif
+
+#define rtd_mask_outl(offset, mask, val)   rtd_outl(offset, (rtd_inl(offset) & ~(mask))|((val) & (mask)))        
+
+
+#define DBG_CHAR(x)                 rtd_outl(0xb8007800, x)
+
+#ifdef GPIO_SCD_RX_DBG_EN
+#define GPIO_SCD_RX_DBG(x)          DBG_CHAR(x)
+#else
+#define GPIO_SCD_RX_DBG(x)          
+#endif
+
+#define SET_MIS_ISR(val)            rtd_outl(MIS_ISR, val)
+#define GET_MIS_ISR()               rtd_inl(MIS_ISR)
+#define MISC_IRQ                    3
+
+#define MAX_SC_CLK                   5000000
+#define MIN_SC_CLK                   1000000    
+
+
+typedef enum {
+    UART_PARITY_NONE = 0,
+    UART_PARITY_ODD,
+    UART_PARITY_EVEN,    
+}UART_PARITY;
+
+typedef enum {    
+    UART_STB_1BIS,
+    UART_STB_2BIS,    
+}UART_STB;
+
+#define ULCR_DLAB          (1 << 7)
+
+#define ULCR_BRK           (1 << 6)
+
+#define ULCR_EPS(x)        ((x & 0x3) <<4)
+  #define ULCR_EPS_ODD      ULCR_EPS(0)
+  #define ULCR_EPS_EVEN     ULCR_EPS(1)
+  #define ULCR_EPS_MARK     ULCR_EPS(0)
+  #define ULCR_EPS_SPACE    ULCR_EPS(1)
+  
+#define ULCR_PEN(x)         ((x & 0x1) <<3)
+
+#define ULCR_STB(x)        ((x & 0x1) <<2)
+  #define ULCR_STB_1BITS     ULCR_STB(0)  
+  #define ULCR_STB_2BITS     ULCR_STB(1)  
+  
+#define ULCR_WLS(x)        ((x & 0x3))
+  #define ULCR_WLS_5BITS     ULCR_WLS(0)  
+  #define ULCR_WLS_6BITS     ULCR_WLS(1)  
+  #define ULCR_WLS_7BITS     ULCR_WLS(2)  
+  #define ULCR_WLS_8BITS     ULCR_WLS(3)  
+
+
+#define SA_SHIRQ IRQF_SHARED
+
+int venus_uart_config(unsigned long baud_rate, UART_PARITY parity, UART_STB stop_bits)
+{    
+    unsigned long div = 27000000/ baud_rate;
+    unsigned long lcr = ULCR_WLS_8BITS;
+    
+    switch(parity)
+    {
+    case UART_PARITY_NONE:
+        lcr |= ULCR_PEN(0);
+        break;
+        
+    case UART_PARITY_ODD:
+        lcr |= ULCR_PEN(1) | ULCR_EPS_ODD;
+        break;
+        
+    case UART_PARITY_EVEN:
+        lcr |= ULCR_PEN(1) | ULCR_EPS_EVEN;
+        break;                
+    }
+    
+    if (stop_bits==UART_STB_1BIS)
+        lcr |= ULCR_STB_1BITS;
+    else
+        lcr |= ULCR_STB_2BITS;
+    
+    rtd_outl(0xb801bc0c, rtd_inl(0xb801bc0c) | ULCR_DLAB);
+    rtd_outl(0xb801bc00, div & 0xff);
+    rtd_outl(0xb801bc04, (div >> 8) & 0xff);        
+    rtd_outl(0xb801bc0c, (rtd_inl(0xb801bc0c) & ULCR_BRK) | lcr);            
+    
+    //SC_INFO("UART1 Baud=%ld, Div=%lx\n", baud_rate, div);
+
+    return 0;    
+}
+
+
+int venus_uart_tx_break(unsigned char on)
+{
+    if (on)
+        rtd_outl(0xb801bc0c, rtd_inl(0xb801bc0c) | ULCR_BRK);
+    else
+        rtd_outl(0xb801bc0c, rtd_inl(0xb801bc0c) & ~ULCR_BRK);
+
+    return 0;
+}
+
+
+int venus_uart_enable(unsigned char on)
+{       
+    if (on) {
+        rtd_outl(0xb801bc08, 0x6);
+        rtd_outl(0xb801bc04, 0x1);    
+        rtd_outl(0xb801bc08, 0x1);   // enable rx fifo...
+    }
+    else {
+        //venus_uart_tx_break(1);
+        rtd_outl(0xb801bc04, 0);  
+        rtd_outl(0xb801bc08, 0x6);  
+    }
+    return 0;
+}
+
+
+int venus_uart_read(unsigned char* buff, unsigned int len)
+{
+    int rx_len = 0;
+        
+    while(rtd_inl(0xb801bc14) & 0x1 && rx_len < len) {
+        //DBG_CHAR('*');
+        buff[rx_len++] = (rtd_inl(0xb801bc00) & 0xff);    
+    }
+    return rx_len;
+}
+
+
+int venus_uart_write(unsigned char* buff, unsigned int len)
+{    
+    int i;
+    
+    while(len)
+    {
+        for (i=0; i<32 && len; i++) {
+            rtd_outl(0xb801bc00, *(buff++));
+            len--;
+        }
+                    
+        while(((rtd_inl(0xb801bc14)>>5) & 0x3)!=0x3);            
+    }
+        
+    udelay(1000);    
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_timer
+ *
+ * Desc : timer of mars scd
+ *
+ * Parm : arg : input param 
+ *         
+ * Retn : IRQ_NONE, IRQ_HANDLED
+ *------------------------------------------------------------------*/
+static void gpio_scd_timer(unsigned long arg)        
+{   
+    gpio_scd* p_this = (gpio_scd*) arg;
+        
+    if (gpio_scd_card_detect(p_this)) {
+        //SC_WARNING("SC%d - gpio_scd_timer, pull high rst...\n", p_this->id);
+        _gpio_scd_reset(p_this, 0);
+    }    
+}
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_set_state
+ *
+ * Desc : 
+ *
+ * Parm : p_this : handle of gpio cec 
+ *         
+ * Retn : N/A  
+ *------------------------------------------------------------------*/
+int gpio_scd_set_state(
+    gpio_scd*               p_this, 
+    IFD_FSM                 fsm
+    )
+{
+    unsigned char id = p_this->id;
+    
+    if (p_this->fsm == fsm)
+        return 0;
+        
+    switch(fsm)
+    {       
+    case IFD_FSM_DISABLE:
+    
+        SC_INFO("SC%d - FSM = DISABLE\n", id);        
+        
+        // Deactivate flow : should be complete within 100ms
+        // 1. Pull RST down
+        // 2. Disable Clock Output
+        // 3. Disable VCC         
+        _gpio_scd_reset(p_this, 1);
+        _gpio_scd_card_detect_enable(p_this, 0);
+        _gpio_scd_io_mode(p_this, SCD_IO_OFF);
+        _gpio_scd_clock_enable(p_this, 0);        
+        _gpio_scd_vcc_enable(p_this, 0);
+        gpio_scd_set_vcc_lvl(p_this, SC_VCC_3V);
+        gpio_scd_set_etu(p_this, 372);
+        gpio_scd_set_clock(p_this, 1000000);
+        gpio_scd_set_convention(p_this, SC_AUTO_CONV);
+        gpio_scd_set_parity(p_this, SC_PARITY_EVEN);
+        p_this->atr.length = -1;
+        break;        
+        
+    case IFD_FSM_DEACTIVATE:
+    
+        SC_INFO("SC%d - FSM = DEACTIVATE\n", id);                
+        _gpio_scd_reset(p_this, 1);
+        gpio_scd_set_etu(p_this, 372);
+        _gpio_scd_io_mode(p_this, SCD_IO_OFF);
+        _gpio_scd_clock_enable(p_this, 0);
+        _gpio_scd_card_detect_enable(p_this, 1);        
+        _gpio_scd_vcc_enable(p_this, 0);        
+        p_this->atr.length = -1;
+        kfifo_reset(&p_this->rx_fifo);   
+        break;
+        
+    case IFD_FSM_RESET:
+
+        p_this->atr.length = -1;        
+        if (!gpio_scd_card_detect(p_this))
+        {
+            SC_WARNING("SC%d - RESET gpio scd failed, no ICC exist\n", id);                            
+            gpio_scd_set_state(p_this, IFD_FSM_DEACTIVATE);
+            return -1;
+        }
+                                                                
+        kfifo_reset(&p_this->rx_fifo);   
+        _gpio_scd_vcc_enable(p_this, 1);
+        _gpio_scd_pwrsel(p_this, p_this->vcc_5v_en);
+        _gpio_scd_clock_enable(p_this, 1);        // output clock
+        gpio_scd_set_etu(p_this, 372);
+        _gpio_scd_io_mode(p_this, SCD_IO_RECV); 
+        _gpio_scd_card_detect_enable(p_this, 1);
+        _gpio_scd_reset(p_this, 1);                
+        if (p_this->auto_conv_en)
+            p_this->conv = SC_AUTO_CONV;                 
+        
+        init_timer(&p_this->timer);
+        p_this->timer.data     = (unsigned long)p_this;
+        p_this->timer.function = gpio_scd_timer;
+        p_this->timer.expires  = jiffies + ((40000 * 100) / p_this->clock_freq) + 2;        
+        add_timer(&p_this->timer);              
+        
+        printk("interval = %ld jiffies\n", ((40000 * 100) / p_this->clock_freq));  
+        
+        p_this->atr_timeout = jiffies + HZ;                    
+        
+        SC_INFO("SC%d - FSM = RESET & ATR\n", id);
+        break;
+          
+    case IFD_FSM_ACTIVATE:    
+        SC_INFO("SC%d - FSM = ACTIVATE\n", id);
+        break;
+
+    default:
+    case IFD_FSM_UNKNOWN:
+        break;                    
+    }    
+    
+    p_this->fsm = fsm;     
+    p_this->card_status_change = 1;
+    wake_up_interruptible(&p_this->wq);             
+    
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_fsm_reset
+ *
+ * Desc : 
+ *
+ * Parm : p_this : handle of mars cec 
+ *         
+ * Retn : N/A  
+ *------------------------------------------------------------------*/
+void gpio_scd_fsm_reset(gpio_scd* p_this)
+{    
+    unsigned long event  = p_this->event;    
+    int rx_len;
+       
+    //printk("SC_RISR=%08lx\n", event);
+                                            
+    if ((event & SC_RXP_INT) || !gpio_scd_card_detect(p_this) || time_after(jiffies, p_this->atr_timeout))
+        goto err_atr_failed;        
+    
+    if (p_this->atr.length== -1 && (event & SC_RCV_INT)) 
+        p_this->atr.length = 0;         // got ATR
+            
+    if (kfifo_len(&p_this->rx_fifo))  
+    {                                   
+        if (p_this->atr.length<0)
+        {
+            kfifo_reset(&p_this->rx_fifo);            
+            goto end_proc;           
+        }
+
+        // receive atr :                
+        rx_len = kfifo_out_locked(&p_this->rx_fifo, 
+                                  &p_this->atr.data[p_this->atr.length], 
+                                  sizeof(p_this->atr.data) - p_this->atr.length, 
+                                  &p_this->rx_fifo_lock);
+
+        SC_INT_DBG("fifo_len=%d, atr_remain=%d, p_this->atr.lengt=%d\n", 
+                kfifo_len(&p_this->rx_fifo), 
+                sizeof(p_this->atr.data - p_this->atr.length),
+                p_this->atr.length);    
+                
+        if (rx_len > 0)
+        {                            
+            p_this->atr.length += rx_len;
+
+            // check atr 
+            if (is_atr_complete(&p_this->atr))
+            {            
+                SC_INFO("SC%d - Got ATR Completed\n", p_this->id);
+                
+                if (decompress_atr(&p_this->atr, &p_this->atr_info)<0)
+                    goto err_atr_failed;
+                      
+                gpio_scd_set_state(p_this, IFD_FSM_ACTIVATE);       // jump to active state
+            }
+        }
+    }       
+    
+end_proc:    
+    p_this->event = 0;
+    return; 
+    
+err_atr_failed:
+
+    if (!gpio_scd_card_detect(p_this))
+    {
+        SC_WARNING("SC%d - RESET ICC failed, no ICC detected\n", p_this->id);
+    }    
+    
+    if (event & SC_RXP_INT)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, RX Parity Error\n", p_this->id);
+    }
+    
+    if (time_after(jiffies, p_this->atr_timeout))
+    {        
+        SC_WARNING("SC%d - RESET ICC failed, timeout\n", p_this->id);                   
+    }    
+    
+    if (p_this->atr.length <0)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, wait ATR failed\n", p_this->id); 
+    }
+    else if (p_this->atr.length >= MAX_ATR_SIZE)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, atr length %d more then %d\n", p_this->id, p_this->atr.length, MAX_ATR_SIZE); 
+    }
+    else if (!is_atr_complete(&p_this->atr))
+    {
+        SC_WARNING("SC%d - RESET ICC failed, incomplete atr\n", p_this->id); 
+    }
+    else if (decompress_atr(&p_this->atr, &p_this->atr_info)<0)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, decompress atr failed\n", p_this->id); 
+    }
+    else
+    {
+        SC_WARNING("SC%d - RESET ICC failed, parse protocol faield\n", p_this->id); 
+    }              
+    
+    gpio_scd_set_state(p_this, IFD_FSM_DEACTIVATE);
+    
+    goto end_proc;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_work
+ *
+ * Desc : gpio scd work routine
+ *
+ * Parm : p_this : handle of gpio scd
+ *         
+ * Retn : N/A  
+ *------------------------------------------------------------------*/
+void gpio_scd_work(gpio_scd* p_this)
+{    
+    if (p_this->event & SC_CPRES_INT)            
+    {           
+        if (gpio_scd_card_detect(p_this))         
+        {
+            SC_INFO("SC%d - ICC detected!!\n", p_this->id);                         
+        }
+        else  
+        {
+            SC_INFO("SC%d - ICC removed!!\n", p_this->id);              
+            gpio_scd_set_state(p_this, IFD_FSM_DEACTIVATE);            
+        }
+            
+        p_this->card_status_change = 1;
+        wake_up_interruptible(&p_this->wq); 
+    }            
+        
+    switch (p_this->fsm)
+    {                   
+    case IFD_FSM_RESET:    gpio_scd_fsm_reset(p_this);  break;
+    default:
+        break;
+    }            
+
+    p_this->event = 0;  
+}
+
+
+
+unsigned char _inverse_bit_order(unsigned char in)
+{
+    unsigned char out = 0;
+    int i=0;
+    
+    for (i=0; i<8; i++) 
+    {
+        if (in & 0x1)
+            out |= 1<<(7-i);
+            
+        in >>=1;
+    }        
+    return out;        
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_isr
+ *
+ * Desc : isr of gpio scd
+ *
+ * Parm : gid    : gpio id
+ *        assert : assert or deassert
+ *        dev_id : device id
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void gpio_scd_isr(
+    VENUS_GPIO_ID           gid, 
+    unsigned char           assert, 
+    void*                   dev_id
+    )
+{    
+    gpio_scd* p_this = (gpio_scd*) dev_id;
+    unsigned long flag;    
+             
+    spin_lock_irqsave(&p_this->lock, flag);      
+
+    if (gid==p_this->pin_card_detect)
+    {
+        p_this->event |= SC_CPRES_INT;     // setup event                
+
+        gpio_scd_work(p_this);        
+    }
+    
+    spin_unlock_irqrestore(&p_this->lock, flag);       
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_isr
+ *
+ * Desc : isr of gpio scd
+ *
+ * Parm : p_this : handle of gpio scd 
+ *        dev_id : handle of the gpio_scd
+ *        regs   :
+ *         
+ * Retn : IRQ_NONE, IRQ_HANDLED
+ *------------------------------------------------------------------*/
+static irqreturn_t
+gpio_scd_io_isr(
+    int                     this_irq, 
+    void*                   dev_id
+    )
+{   
+    gpio_scd* p_this = (gpio_scd*) dev_id;
+    unsigned char sdata;             
+    unsigned char tx_data;          
+    unsigned long event = GET_MIS_ISR() & 0x8;            
+    unsigned long flag;    
+                                 
+    if (!event)
+        return IRQ_NONE;                
+        
+    spin_lock_irqsave(&p_this->lock, flag);   
+            
+    //printk("MIS ISR=%08x, status=%08x, ier=%08x\n", event, rtd_inl(0xb801bc14), rtd_inl(0xb801bc04));                         
+                    
+    if (rtd_inl(0xb801bc14) & 0x1)
+    {
+        // read data....
+        while(venus_uart_read(&sdata, 1))                
+        {            
+            if (p_this->conv==SC_AUTO_CONV)                         
+            {        
+                if (sdata==0x3B)                
+                    p_this->conv = SC_DIRECT_CONV;
+                else if ((~_inverse_bit_order(sdata) & 0xFF)==0x3F)
+                    p_this->conv = SC_INVERSE_CONV;
+                else
+                {
+                    SC_WARNING("invalid TS %02x, drop it...\n", sdata);  
+                    continue; // drop it
+                }
+            }
+
+            //printk("> %02x\n", sdata);  
+            
+            if (p_this->conv==SC_INVERSE_CONV)
+                sdata = ~_inverse_bit_order(sdata) & 0xFF;           
+
+            //printk("%02x\n", sdata);
+            
+            if (kfifo_out_locked(&p_this->tx_fifo, &tx_data, 1, &p_this->tx_fifo_lock)==1 && tx_data==sdata)
+                continue;       // tx data... ignore it...                                                        
+                            
+            if (kfifo_in_locked(&p_this->rx_fifo, &sdata, 1, &p_this->rx_fifo_lock)<1)                            
+                p_this->event |= SC_RX_FOVER_INT;
+
+            p_this->event |= SC_RCV_INT;
+        }            
+                
+        gpio_scd_work(p_this);        
+    }
+    
+    SET_MIS_ISR(event);         
+               
+    spin_unlock_irqrestore(&p_this->lock, flag); 
+    
+    return IRQ_HANDLED;    
+}
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_enable
+ *
+ * Desc : enable gpio smart card interface
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int gpio_scd_enable(gpio_scd* p_this, unsigned char on_off)
+{
+    if (on_off)        
+    {
+        if (p_this->fsm==IFD_FSM_DISABLE)
+            return gpio_scd_set_state(p_this, IFD_FSM_DEACTIVATE);
+    }
+    else    
+        return gpio_scd_set_state(p_this, IFD_FSM_DISABLE);    
+    
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_set_clock
+ *
+ * Desc : set clock frequency of gpio smart card interface
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *        clk      : clock (in HZ)
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int gpio_scd_set_clock(gpio_scd* p_this, unsigned long clk)
+{           
+    if (clk > MAX_SC_CLK) {
+        SC_WARNING("clock %lu out of range, using minimum value to instead %lu\n", 
+                    (unsigned long)clk, (unsigned long)MAX_SC_CLK);        
+        clk = MAX_SC_CLK;
+    }
+        
+    if (clk < MIN_SC_CLK) {
+        SC_WARNING("clock %lu out of range, using minimum value to instead %lu\n", 
+                    (unsigned long)clk, (unsigned long)MIN_SC_CLK);
+        clk = MIN_SC_CLK;
+    }
+    
+    p_this->clock_freq = clk;    
+    _gpio_scd_clock_config(p_this);      
+    _gpio_scd_io_config(p_this);
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_set_etu
+ *
+ * Desc : set etu of gpio smart card interface
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *        etu      : cycles
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int gpio_scd_set_etu(gpio_scd* p_this, unsigned long etu)
+{                 
+    p_this->etu = etu;
+    _gpio_scd_io_config(p_this);   
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_set_parity
+ *
+ * Desc : set parity of gpio smart card interface
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *        parity   : 
+ *           SC_PARITY_NONE
+ *           SC_PARITY_ODD 
+ *           SC_PARITY_EVEN 
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int gpio_scd_set_parity(gpio_scd* p_this, SC_PARITY parity)
+{        
+    p_this->parity = parity;                                
+    _gpio_scd_io_config(p_this);                              
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_set_convention
+ *
+ * Desc : set convention setting of gpio smart card interface
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *        conv     : convention
+ *          SC_AUTO_CONV : Auto Convention
+ *          SC_DIRECT_CONV : Direct Convention
+ *          SC_CONV_INVERSE : Inverse Convention
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int gpio_scd_set_convention(gpio_scd* p_this, SC_CONV conv)
+{    
+    if (conv==SC_AUTO_CONV)
+        p_this->auto_conv_en = 1;    
+    else
+    {
+        p_this->auto_conv_en = 0;       
+        p_this->conv = conv;        
+    }
+    
+    return 0;    
+}
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_activate
+ *
+ * Desc : activate an ICC
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/        
+int gpio_scd_activate(gpio_scd* p_this)
+{
+    switch(p_this->fsm)
+    {
+    case IFD_FSM_DISABLE:
+        SC_WARNING("activate ICC failed, please enable IFD first\n");
+        return -1;
+        
+    case IFD_FSM_DEACTIVATE:
+    
+        if (gpio_scd_reset(p_this)==0)
+        {
+            SC_INFO("activate ICC success\n");
+            return 0;
+        }
+        else
+        {
+            SC_WARNING("activate ICC failed\n");
+            return -1;
+        }
+        break;            
+        
+    case IFD_FSM_RESET:
+        SC_INFO("ICC has is reseting\n");
+        return 0;
+        
+    case IFD_FSM_ACTIVATE:
+        SC_INFO("ICC has been activated already\n");
+        return 0;
+        
+    default:        
+        SC_WARNING("activate ICC failed, unknown state\n");
+        return -1;
+    } 
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_deactivate
+ *
+ * Desc : deactivate an ICC
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/        
+int gpio_scd_deactivate(gpio_scd* p_this)
+{    
+    if (p_this->fsm != IFD_FSM_DISABLE)
+    {
+        gpio_scd_set_state(p_this, IFD_FSM_DISABLE);
+        gpio_scd_set_state(p_this, IFD_FSM_DEACTIVATE);
+    }
+    return 0;
+}
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_reset
+ *
+ * Desc : reset gpio smart card interface
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/        
+int gpio_scd_reset(gpio_scd* p_this)
+{        
+    unsigned long t;
+    
+    if (gpio_scd_set_state(p_this, IFD_FSM_RESET))
+        return -1;
+    
+    t = jiffies + (HZ<<1);
+    
+    while(!time_after(jiffies,t) && p_this->fsm == IFD_FSM_RESET)    {        
+        msleep(100);    
+    }
+    
+    if (p_this->fsm!=IFD_FSM_ACTIVATE)
+    {
+        SC_WARNING("SC%d - Reset ICC failed\n", p_this->id);
+        gpio_scd_set_state(p_this, IFD_FSM_DEACTIVATE);
+        return -1;     
+    }
+        
+    SC_INFO("SC%d - Reset ICC Complete\n", p_this->id);
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_get_atr
+ *
+ * Desc : s mars smart card interface
+ *
+ * Parm : p_this   : handle of mars scd  
+ *        p_atr    : atr output buffer
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/        
+int gpio_scd_get_atr(gpio_scd* p_this, scd_atr* p_atr)
+{        
+    if (p_this->fsm != IFD_FSM_ACTIVATE)
+    {    
+        p_atr->length = -1;  
+        return -1;
+    }
+    
+    p_atr->length = p_this->atr.length;
+    memcpy(p_atr->data, p_this->atr.data, p_this->atr.length);    
+    return 0;    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_card_detect
+ *
+ * Desc : get card status
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *         
+ * Retn : 0 : no icc exists, others : icc exists
+ *------------------------------------------------------------------*/   
+int gpio_scd_card_detect(gpio_scd* p_this)
+{               
+    return _gpio_scd_card_detect_status(p_this);
+}
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_get_card_status
+ *
+ * Desc : get card status
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *         
+ * Retn : 0 : no icc exists, others : icc exists
+ *------------------------------------------------------------------*/   
+int gpio_scd_get_card_status(gpio_scd* p_this)
+{               
+    switch(p_this->fsm) {       
+    case IFD_FSM_DISABLE:   return SC_CARD_REMOVED;                
+    case IFD_FSM_DEACTIVATE:      return gpio_scd_card_detect(p_this) ? SC_CARD_DEACTIVATE : SC_CARD_REMOVED;                        
+    case IFD_FSM_RESET:     return SC_CARD_RESET;                                                            
+    case IFD_FSM_ACTIVATE:  return SC_CARD_ACTIVATE;                
+    default:                return SC_CARD_UNKNOWN;
+    }
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_poll_card_status
+ *
+ * Desc : poll card status change
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/   
+int gpio_scd_poll_card_status(gpio_scd* p_this)
+{       
+    p_this->card_status_change = 0;
+    wait_event_interruptible(p_this->wq, p_this->card_status_change); 
+    return gpio_scd_get_card_status(p_this);     
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_xmit
+ *
+ * Desc : xmit data via smart card bus
+ *
+ * Parm : p_this   : handle of gpio scd  
+ *        scb      : data to be xmit
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+int gpio_scd_xmit(gpio_scd* p_this, unsigned char* p_data, unsigned int len)
+{    
+    int i;
+    
+    if (p_this->fsm==IFD_FSM_ACTIVATE)
+    {
+        venus_uart_enable(1);
+        _gpio_scd_io_mode(p_this, SCD_IO_XMIT); // TX mode
+        kfifo_in_locked(&p_this->tx_fifo, p_data, len, &p_this->tx_fifo_lock);             
+
+        for (i=0; i<len; i++) 
+        {
+            if (p_this->conv==SC_INVERSE_CONV)
+                p_data[i] = ~_inverse_bit_order(p_data[i]) & 0xFF;       
+        }
+                                    
+        venus_uart_write(p_data, len);    
+        _gpio_scd_io_mode(p_this, SCD_IO_RECV); // TX mode    
+        return SC_SUCCESS;
+    }
+    
+    return SC_ERR_ICC_DEACTIVATE;
+}                        
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_read
+ *
+ * Desc : read data via smart card bus
+ *
+ * Parm : p_this   : handle of gpio scd   
+ *         
+ * Retn : sc_buff
+ *------------------------------------------------------------------*/        
+int gpio_scd_read(gpio_scd* p_this, unsigned char* data, unsigned int len)
+{    
+    if (p_this->fsm==IFD_FSM_ACTIVATE)    
+        return kfifo_out_locked(&p_this->rx_fifo, data, len, &p_this->rx_fifo_lock);
+    
+    return SC_ERR_ICC_DEACTIVATE;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_open
+ *
+ * Desc : open a gpio scd device
+ *
+ * Parm : id  : channel id
+ *         
+ * Retn : handle of gpio scd
+ *------------------------------------------------------------------*/
+gpio_scd* gpio_scd_open(unsigned char id)
+{           
+    gpio_scd* p_this;
+    
+    if (id >= 1) {
+        SC_WARNING("scd : open gpio scd failed, invalid id - %d\n", id);
+        return NULL;
+    }                       
+        
+    p_this = (gpio_scd*) kmalloc(sizeof(gpio_scd), GFP_KERNEL);    
+    
+    if (p_this)
+    {
+        memset(p_this, 0, sizeof(gpio_scd));        
+  
+        p_this->id               = id;
+        p_this->fsm              = IFD_FSM_UNKNOWN;
+        p_this->atr.length       = -1;        
+        if (kfifo_alloc(&p_this->rx_fifo, 512, GFP_KERNEL)<0)
+        {
+            SC_WARNING("scd : open gpio scd(%d) failed, create rx fifo failed\n", id);
+            kfree(p_this);
+            return NULL;
+        }
+        
+        if (kfifo_alloc(&p_this->tx_fifo, 512, GFP_KERNEL)<0)
+        {
+            SC_WARNING("scd : open gpio scd(%d) failed, create rx fifo failed\n", id);
+            kfree(p_this);
+            return NULL;
+        }
+                
+        spin_lock_init(&p_this->rx_fifo_lock);
+        spin_lock_init(&p_this->tx_fifo_lock);        
+        init_waitqueue_head(&p_this->wq);                        
+        
+        // pin assignment ---
+        p_this->pin_clk          = GPIO_SCD_CLK_GPIO;      
+        p_this->pin_card_detect  = GPIO_SCD_CD_GPIO;      
+        p_this->pin_reset        = GPIO_SCD_RST_GPIO;            
+        p_this->pin_uart_tx      = GPIO_SCD_DATAOUT_GPIO;
+        p_this->pin_uart_rx      = GPIO_SCD_DATAIN_GPIO;                
+#ifdef USE_TDA8024            
+        p_this->pin_cmd_vcc      = GPIO_SCD_CMD_VCC_GPIO;
+        p_this->pin_power_sel    = GPIO_SCD_PWR_SEL_GPIO;
+#endif        
+        p_this->pwm_id           = 0;
+        
+        // configurations ---
+        p_this->clock_freq       = 1000000;             
+        p_this->clock_en         = 0;
+        p_this->etu              = 372;        // default etu = 372     
+        p_this->parity           = SC_PARITY_EVEN;    
+        p_this->auto_conv_en     = 1;
+        p_this->vcc_5v_en        = 0;
+        p_this->conv             = SC_AUTO_CONV;
+
+        if (_gpio_scd_clock_init(p_this)<0 ||
+            _gpio_scd_reset_init(p_this)<0 ||
+            _gpio_scd_card_detect_init(p_this) <0 ||
+            _gpio_scd_vcc_init(p_this) < 0 ||
+            _gpio_scd_pwrsel_init(p_this) < 0 ||
+            _gpio_scd_io_init(p_this)<0)
+        {
+            SC_WARNING("scd : open gpio scd failed, init io pin failed\n"); 
+            kfree(p_this);          
+            return NULL;
+        }        
+                    
+        gpio_scd_set_state(p_this, IFD_FSM_DISABLE);
+    }        
+    else
+        SC_WARNING("scd : open gpio scd failed, out of memory\n");   
+        
+    return p_this;
+}    
+
+
+/*------------------------------------------------------------------
+ * Func : gpio_scd_close
+ *
+ * Desc : close a gpio scd device
+ *
+ * Parm : p_this  : gpio scd to be close
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void gpio_scd_close(gpio_scd* p_this)
+{   
+    gpio_scd_set_state(p_this, IFD_FSM_DISABLE);    
+    _gpio_scd_io_uninit(p_this);
+    _gpio_scd_reset_uninit(p_this);
+    _gpio_scd_card_detect_uninit(p_this);      
+    kfifo_free(&p_this->rx_fifo);
+    wake_up(&p_this->wq);   
+    kfree(p_this);        
+}    
+
+
+//////////////////////////////////////////////////////////////////
+// Low Level API
+//////////////////////////////////////////////////////////////////
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_io_mode
+ *
+ * Desc : set io mode
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *        mode    : 
+ *          SCD_IO_OFF  : Disable IO Pin (output low)
+ *          SCD_IO_RECV : Rx mode
+ *          SCD_IO_XMIT : Tx mode
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void _gpio_scd_io_mode(gpio_scd* p_this, SCD_IO_MODE mode)
+{
+#ifdef SPI_UART       
+    switch(mode)
+    {
+    case SCD_IO_OFF:        
+        //rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0xF<<2)) | (0x6<<2));   // GPIO[2] = GPIO, GPIO[1] = UART1_TX
+        rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0xF<<2)) | (0xA<<2));     // GPIO[2] = UART1_RX, GPIO[1] = UART1_TX       
+        venus_uart_enable(1);
+        break;
+        
+    case SCD_IO_RECV:       
+        //rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0xF<<2)) | (0x9<<2));   // GPIO[2] = UART1_RX, GPIO[1] = Input GPIO
+        rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0xF<<2)) | (0xA<<2));     // GPIO[2] = UART1_RX, GPIO[1] = UART1_TX           
+        venus_uart_enable(1);                
+        kfifo_reset(&p_this->rx_fifo);            
+        break;
+        
+    case SCD_IO_XMIT:
+        //rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0xF<<2)) | (0x9<<2));   // GPIO[2] = GPIO, GPIO[1] = UART1_TX
+        rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0xF<<2)) | (0xA<<2));     // GPIO[2] = UART1_RX, GPIO[1] = UART1_TX    
+        venus_uart_enable(1);          
+        kfifo_reset(&p_this->rx_fifo);                  
+        break;
+
+    default:
+        break;                
+    }
+    
+#else
+
+    switch(mode)
+    {
+    case SCD_IO_OFF:
+        venus_uart_tx_break(0);
+  #ifdef SPI_UART_TX
+        rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0x7003C)) | (0x70018));     // GPIO[1] = UART1_TX, GPIO[57:58] = GPIO        
+  #else        
+        rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0x7003C)) | (0x40014));     // GPIO[57] = UART1_RX GPIO[58] = UART1_TX 
+  #endif        
+        venus_uart_enable(0);      
+        kfifo_reset(&p_this->rx_fifo);     
+        kfifo_reset(&p_this->tx_fifo);   
+        break;
+        
+    case SCD_IO_RECV:
+        //venus_uart_tx_break(0);
+        //venus_uart_enable(0);             
+        rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0x7003C)) | (0x40014));     // GPIO[57] = UART1_RX GPIO[58] = UART1_TX 
+        venus_uart_enable(1);       
+        //kfifo_reset(&p_this->rx_fifo);                  
+        break;
+        
+    case SCD_IO_XMIT:
+        //venus_uart_tx_break(0);
+        //venus_uart_enable(0);
+        kfifo_reset(&p_this->tx_fifo);     // clear tx fifo
+            
+  #ifdef SPI_UART_TX
+        rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0x7003C)) | (0x70018));     // GPIO[1] = UART1_TX, GPIO[57:58]
+  #else        
+        rtd_outl(0xb8000378, (rtd_inl(0xb8000378) & ~(0x7003C)) | (0x40014));     // GPIO[57] = UART1_RX GPIO[58] = UART1_TX 
+  #endif        
+        venus_uart_enable(1);              
+        kfifo_reset(&p_this->rx_fifo);   
+        break;
+
+    default:
+        break;                
+    }
+    
+#endif
+    
+//    printk("mode = %d, 0xb8000378=%08lx\n", mode, rtd_inl(0xb8000378));
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_io_config
+ *
+ * Desc : config io pin prarmeter
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void _gpio_scd_io_config(gpio_scd* p_this)
+{    
+    //SC_INFO("SC%d - baud rate=%ld (etu=%ld, freq=%ld Hz)\n", 
+    //    p_this->id, p_this->clock_freq / p_this->etu,
+    //    p_this->etu, p_this->clock_freq);                        
+        
+    venus_uart_config(p_this->clock_freq/p_this->etu, 
+                     (p_this->parity==SC_PARITY_EVEN) ? UART_PARITY_EVEN : 
+                     (p_this->parity==SC_PARITY_ODD) ? UART_PARITY_ODD : UART_PARITY_NONE, 
+                     UART_STB_2BIS);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_io_init
+ *
+ * Desc : init io pin
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+int _gpio_scd_io_init(gpio_scd* p_this)
+{   
+    int ret = 0;     
+        
+    rtd_outl(0xb8000380, 0);    
+    venus_gpio_set_dir(p_this->pin_uart_rx, 0);
+    venus_gpio_set_dir(p_this->pin_uart_tx, 0);
+    _gpio_scd_io_mode(p_this, SCD_IO_OFF);    
+
+    if (request_irq(MISC_IRQ, gpio_scd_io_isr, SA_SHIRQ, "SCD_IO", (void *) p_this) < 0) 
+    {
+        SC_WARNING("scd : init scd io pin failed, unable to request irq#%d\n", MISC_IRQ); 
+        ret = -1;
+    }        
+
+    _gpio_scd_io_config(p_this);
+
+    return ret;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_io_uninit
+ *
+ * Desc : uninit io pin
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void _gpio_scd_io_uninit(gpio_scd* p_this)
+{    
+    _gpio_scd_io_mode(p_this, SCD_IO_OFF);               
+    free_irq(MISC_IRQ, (void *) p_this);
+}
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_card_detect_init
+ *
+ * Desc : init card detect pin
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *         
+ * Retn : 0 : success, others: failed
+ *------------------------------------------------------------------*/
+int _gpio_scd_card_detect_init(gpio_scd* p_this)
+{
+    if ((rtd_inl(GPIO_SCD_CD_PINMUX_REG) & GPIO_SCD_CD_PINMUX_MASK) != GPIO_SCD_CD_PINMUX_VAL)
+    {
+        printk("_gpio_scd_card_detect_init failed, pin has been programed for another application\n");
+        
+#ifdef FORCE_SET_PINMUX
+        rtd_mask_outl(GPIO_SCD_CD_PINMUX_REG, GPIO_SCD_CD_PINMUX_MASK, GPIO_SCD_CD_PINMUX_VAL);
+#else   
+        return -1;     
+#endif                       
+    }
+    venus_gpio_set_irq_enable(p_this->pin_card_detect, 0);
+    venus_gpio_set_dir(p_this->pin_card_detect, 0); 
+    venus_gpio_set_debounce(p_this->pin_card_detect, VENUS_GPIO_DEBOUNCE_1ms); 
+    venus_gpio_set_irq_polarity(p_this->pin_card_detect, 1);
+    return venus_gpio_request_irq(p_this->pin_card_detect, gpio_scd_isr, "SCD", p_this); 
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_card_detect_uninit
+ *
+ * Desc : uninit card detect pin
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void _gpio_scd_card_detect_uninit(gpio_scd* p_this)
+{
+    venus_gpio_set_dir(p_this->pin_card_detect, 0); 
+    venus_gpio_set_irq_enable(p_this->pin_card_detect, 0);      
+    venus_gpio_free_irq(p_this->pin_card_detect, p_this);  
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_card_detect_enable
+ *
+ * Desc : enable card detect feature
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *        On : 0 : disable, others : enable
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void _gpio_scd_card_detect_enable(gpio_scd* p_this, unsigned char on)
+{
+    venus_gpio_set_irq_enable(p_this->pin_card_detect, (on) ? 1 : 0);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_card_detect_status
+ *
+ * Desc : get card detect status
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *         
+ * Retn : 0 : no card, 1 : card exists
+ *------------------------------------------------------------------*/
+int _gpio_scd_card_detect_status(gpio_scd* p_this)
+{
+   return venus_gpio_input(p_this->pin_card_detect) ? 1 : 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_reset_init
+ *
+ * Desc : init reset pin
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *         
+ * Retn : 0 : success, others : failed
+ *------------------------------------------------------------------*/
+int _gpio_scd_reset_init(gpio_scd* p_this)
+{
+    if ((rtd_inl(GPIO_SCD_RST_PINMUX_REG) & GPIO_SCD_RST_PINMUX_MASK) != GPIO_SCD_RST_PINMUX_VAL)
+    {
+        printk("_gpio_scd_reset_init failed, pin has been programed for another application\n");        
+#ifdef FORCE_SET_PINMUX
+        rtd_mask_outl(GPIO_SCD_RST_PINMUX_REG, GPIO_SCD_RST_PINMUX_MASK, GPIO_SCD_RST_PINMUX_VAL);
+#else   
+        return -1;     
+#endif           
+    }
+    venus_gpio_output(p_this->pin_reset, 0);
+    venus_gpio_set_dir(p_this->pin_reset, 1);
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_reset_uninit
+ *
+ * Desc : uninit reset pin
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void _gpio_scd_reset_uninit(gpio_scd* p_this)
+{
+    venus_gpio_output(p_this->pin_reset, 0);
+    venus_gpio_set_dir(p_this->pin_reset, 0);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_reset
+ *
+ * Desc : do reset
+ *
+ * Parm : p_this  : handle of GPIO SCD
+ *        on      : 0 : clear reset flag, others : set reset flag
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void _gpio_scd_reset(gpio_scd* p_this, unsigned char on)
+{
+    venus_gpio_output(p_this->pin_reset, (on) ? 0 : 1);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_clock_init
+ *
+ * Desc : enable clock output
+ *
+ * Parm : p_this  : handle of gpio scd  
+ *        on      : enable (in HZ)
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int _gpio_scd_clock_init(gpio_scd* p_this)
+{           
+    switch(rtd_inl(GPIO_SCD_CLK_PINMUX_REG) & GPIO_SCD_CLK_PINMUX_MASK)
+    {
+    case GPIO_SCD_CLK_PINMUX_VAL_IO:
+    case GPIO_SCD_CLK_PINMUX_VAL_PWM:
+        break;
+        
+    default:                 
+        printk("_gpio_scd_clock_init failed, clk pin has been programed for another application\n");
+        
+#ifdef FORCE_SET_PINMUX
+        rtd_mask_outl(GPIO_SCD_CLK_PINMUX_REG, GPIO_SCD_CLK_PINMUX_MASK, GPIO_SCD_CLK_PINMUX_VAL_PWM);
+        break;
+#else
+        return -1;        
+#endif        
+    }
+
+    _gpio_scd_clock_enable(p_this, 0);
+    _gpio_scd_clock_config(p_this);        
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_clock_config
+ *
+ * Desc : enable clock output
+ *
+ * Parm : p_this  : handle of gpio scd  
+ *        on      : enable (in HZ)
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int _gpio_scd_clock_config(gpio_scd* p_this)
+{           
+    return venus_pwm_ctrl(p_this->pwm_id, p_this->clock_freq, 50);;
+}
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_clock_enable
+ *
+ * Desc : enable clock output
+ *
+ * Parm : p_this  : handle of gpio scd  
+ *        on      : enable clock
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int _gpio_scd_clock_enable(gpio_scd* p_this, unsigned char on)
+{           
+    unsigned long val;
+    venus_gpio_output(p_this->pin_clk, 0);
+    venus_gpio_set_dir(p_this->pin_clk, 1);
+    
+    val = rtd_inl(GPIO_SCD_CLK_PINMUX_REG) & ~GPIO_SCD_CLK_PINMUX_MASK;
+    
+    if (on)    
+        val |= GPIO_SCD_CLK_PINMUX_VAL_PWM;       // PWM mode   
+    else
+        val |= GPIO_SCD_CLK_PINMUX_VAL_IO;        // GPIO mode        
+        
+    rtd_outl(GPIO_SCD_CLK_PINMUX_REG, val);                     
+
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_vcc_init
+ *
+ * Desc : init vcc output pad
+ *
+ * Parm : p_this  : handle of gpio scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int _gpio_scd_vcc_init(gpio_scd* p_this)
+{
+#ifdef USE_TDA8024       
+
+    if ((rtd_inl(GPIO_SCD_CMD_VCC_PINMUX_REG) & GPIO_SCD_CMD_VCC_PINMUX_MASK) != GPIO_SCD_CMD_VCC_PINMUX_VAL)
+    {
+        printk("_gpio_scd_vcc_init failed, pin has been programed for another application\n");
+        
+#ifdef FORCE_SET_PINMUX
+        rtd_mask_outl(GPIO_SCD_CMD_VCC_PINMUX_REG, GPIO_SCD_CMD_VCC_PINMUX_MASK, GPIO_SCD_CMD_VCC_PINMUX_VAL);
+#else
+        return -1;        
+#endif           
+    }
+    
+    venus_gpio_output(p_this->pin_cmd_vcc, 0);
+    venus_gpio_set_dir(p_this->pin_cmd_vcc, 1);    // 1: disable VCC
+#endif        
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_vcc_enable
+ *
+ * Desc : enable vcc output
+ *
+ * Parm : p_this  : handle of gpio scd  
+ *        on      : enable vcc
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int _gpio_scd_vcc_enable(gpio_scd* p_this, unsigned char on)
+{
+#ifdef USE_TDA8024    
+    venus_gpio_output(p_this->pin_cmd_vcc, (on) ? 0 : 1);   // 0: Enable VCC 1: Disable VCC
+#endif        
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_pwrsel_init
+ *
+ * Desc : init power select output pad
+ *
+ * Parm : p_this  : handle of gpio scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int _gpio_scd_pwrsel_init(gpio_scd* p_this)
+{
+#ifdef USE_TDA8024       
+
+    if ((rtd_inl(GPIO_SCD_PWR_SEL_PINMUX_REG) & GPIO_SCD_PWR_SEL_PINMUX_MASK) != GPIO_SCD_PWR_SEL_PINMUX_VAL)
+    {
+        printk("_gpio_scd_vcc_init failed, pin has been programed for another application\n");
+        
+#ifdef FORCE_SET_PINMUX
+        rtd_mask_outl(GPIO_SCD_PWR_SEL_PINMUX_REG, GPIO_SCD_PWR_SEL_PINMUX_MASK, GPIO_SCD_PWR_SEL_PINMUX_VAL);
+#else
+        return -1;        
+#endif           
+    }
+    
+    venus_gpio_output(p_this->pin_power_sel, 0);
+    venus_gpio_set_dir(p_this->pin_power_sel, 1);
+#endif        
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : _gpio_scd_pwrsel
+ *
+ * Desc : select power
+ *
+ * Parm : p_this  : handle of gpio scd  
+ *        power   : select power
+ *          1 : 5V
+ *          0 : 3.3V
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int _gpio_scd_pwrsel(gpio_scd* p_this, unsigned char power)
+{
+#ifdef USE_TDA8024    
+    venus_gpio_output(p_this->pin_power_sel, (power) ? 1 : 0); 
+#endif        
+    return 0;
+}
+
diff --git a/drivers/smartcard/adapter/scd_gpio_priv.h b/drivers/smartcard/adapter/scd_gpio_priv.h
new file mode 100644
index 00000000..1f85d352
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_gpio_priv.h
@@ -0,0 +1,176 @@
+/*
+ * scd_gpio_priv.h - smartcard driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef __SCD_GPIO_PRIV_H__
+#define __SCD_GPIO_PRIV_H__
+
+#include <linux/wait.h>
+#include <linux/timer.h>
+#include <linux/interrupt.h>
+#include <linux/kfifo.h>
+#include <asm/mach-rtk_dmp/venus_gpio.h>
+#include "../core/scd.h"
+#include "../core/scd_atr.h"
+
+#define ID_MARS_SCD(x)          (0x12830000 | (x & 0x3))
+#define RX_RING_LENGTH  32
+#define TX_RING_LENGTH  32
+
+#define USE_TDA8024
+
+typedef enum {    
+    IFD_FSM_UNKNOWN,
+    IFD_FSM_DISABLE,        // function disabled
+    IFD_FSM_DEACTIVATE,     // function enabled but not reset the card yet
+    IFD_FSM_RESET,          // reset the card and waiting for ATR
+    IFD_FSM_ACTIVATE,       // reset the card and waiting for ATR   
+}IFD_FSM; 
+
+
+
+typedef struct gpio_scd_tag   gpio_scd;
+
+struct gpio_scd_tag
+{    
+    unsigned char       id;         // channel id       
+    IFD_FSM             fsm;        // finate state machine of ifd
+    unsigned long       event;
+    unsigned char       card_status_change;    
+    
+    //pin assignment    
+    VENUS_GPIO_ID       pin_card_detect;     // card detect pin
+    VENUS_GPIO_ID       pin_reset;           // reset pin
+    VENUS_GPIO_ID       pin_uart_tx;         
+    VENUS_GPIO_ID       pin_uart_rx;         
+    VENUS_GPIO_ID       pin_clk;             // clock
+#ifdef USE_TDA8024    
+    VENUS_GPIO_ID       pin_cmd_vcc;         // command vcc
+    VENUS_GPIO_ID       pin_power_sel;       // power sel
+#endif
+    int                 pwm_id;              // pwm pin
+    
+    unsigned char       clock_en : 1;   
+    unsigned char       auto_conv_en : 1;  
+    unsigned char       vcc_5v_en : 1;  
+    unsigned long       clock_freq;     
+    
+    // config               
+    unsigned long       etu;    
+    SC_PARITY           parity;
+    SC_CONV             conv;   
+            
+    // atr              
+    scd_atr             atr;               // current atr
+    scd_atr_info        atr_info;          // current atr
+    unsigned long       atr_timeout;    
+    // tx queue
+    wait_queue_head_t       wq;
+    struct kfifo            rx_fifo;
+    spinlock_t              rx_fifo_lock;	    
+    struct tasklet_struct   rx_task;         
+    struct kfifo            tx_fifo;
+    spinlock_t              tx_fifo_lock;	          
+        
+    struct timer_list   timer;	                
+    spinlock_t          lock;	    
+};
+
+extern gpio_scd* gpio_scd_open(unsigned char id);
+extern void gpio_scd_close(gpio_scd* p_this);
+
+extern int gpio_scd_enable            (gpio_scd* p_this, unsigned char on_off);       
+extern int gpio_scd_set_clock         (gpio_scd* p_this, unsigned long clock);
+extern int gpio_scd_set_etu           (gpio_scd* p_this, unsigned long etu);
+static int gpio_scd_set_vcc_lvl       (gpio_scd* p_this, SC_VCC_LVL lvl);
+extern int gpio_scd_set_parity        (gpio_scd* p_this, SC_PARITY parity);
+extern int gpio_scd_set_convention    (gpio_scd* p_this, SC_CONV conv);
+
+static int inline gpio_scd_get_clock(gpio_scd* p_this, unsigned long* p_clock)
+{
+    *p_clock = p_this->clock_freq;
+    return SC_SUCCESS;
+}
+
+static int inline gpio_scd_get_etu(gpio_scd* p_this, unsigned long* p_etu)
+{    
+    *p_etu = p_this->etu; 
+    return SC_SUCCESS;   
+}
+
+static int inline gpio_scd_get_parity(gpio_scd* p_this, SC_PARITY* p_parity)
+{
+    *p_parity = p_this->parity;
+    return SC_SUCCESS;
+}
+
+static int inline gpio_scd_get_convention(gpio_scd* p_this, SC_CONV* p_conv)
+{
+    *p_conv = (p_this->auto_conv_en) ? SC_AUTO_CONV : p_this->conv;
+    return SC_SUCCESS;
+}
+
+static int inline gpio_scd_set_vcc_lvl(gpio_scd* p_this, SC_VCC_LVL lvl)
+{
+    p_this->vcc_5v_en = (lvl==SC_VCC_5V) ? 1 : 0;
+    return SC_SUCCESS;
+}
+
+static int inline gpio_scd_get_vcc_lvl(gpio_scd* p_this, SC_VCC_LVL* p_lvl)
+{
+    *p_lvl = (p_this->vcc_5v_en) ? SC_VCC_5V : SC_VCC_3V;
+    return SC_SUCCESS;             
+}
+
+extern int gpio_scd_activate          (gpio_scd* p_this);         
+extern int gpio_scd_deactivate        (gpio_scd* p_this);         
+extern int gpio_scd_reset             (gpio_scd* p_this);        
+extern int gpio_scd_get_atr           (gpio_scd* p_this, scd_atr* p_atr); 
+extern int gpio_scd_card_detect       (gpio_scd* p_this);
+extern int gpio_scd_get_card_status   (gpio_scd* p_this);
+extern int gpio_scd_poll_card_status  (gpio_scd* p_this);
+extern int gpio_scd_xmit              (gpio_scd* p_this, unsigned char* p_data, unsigned int len);    		    
+extern int gpio_scd_read              (gpio_scd* p_this, unsigned char* p_data, unsigned int len);
+
+////////////////////////////////////////////////
+// Internal APIs
+////////////////////////////////////////////////
+
+typedef enum {
+    SCD_IO_OFF,
+    SCD_IO_RECV,
+    SCD_IO_XMIT,
+}SCD_IO_MODE;
+
+int  _gpio_scd_io_init(gpio_scd* p_this);
+void _gpio_scd_io_uninit(gpio_scd* p_this);
+void _gpio_scd_io_mode(gpio_scd* p_this, SCD_IO_MODE mode);
+void _gpio_scd_io_config(gpio_scd* p_this);
+
+int  _gpio_scd_card_detect_init(gpio_scd* p_this);
+void _gpio_scd_card_detect_uninit(gpio_scd* p_this);
+void _gpio_scd_card_detect_enable(gpio_scd* p_this, unsigned char on);
+int  _gpio_scd_card_detect_status(gpio_scd* p_this);
+
+int  _gpio_scd_reset_init(gpio_scd* p_this);
+void _gpio_scd_reset_uninit(gpio_scd* p_this);
+void _gpio_scd_reset(gpio_scd* p_this, unsigned char on);
+
+int  _gpio_scd_clock_init(gpio_scd* p_this);
+int  _gpio_scd_clock_config(gpio_scd* p_this);
+int  _gpio_scd_clock_enable(gpio_scd* p_this, unsigned char on);
+
+int  _gpio_scd_vcc_init(gpio_scd* p_this);
+int  _gpio_scd_vcc_enable(gpio_scd* p_this, unsigned char on);
+
+int  _gpio_scd_pwrsel_init(gpio_scd* p_this);
+int  _gpio_scd_pwrsel(gpio_scd* p_this, unsigned char power);
+
+
+#endif //__SCD_MARS_PRIV_H__
diff --git a/drivers/smartcard/adapter/scd_gpio_priv_config.h b/drivers/smartcard/adapter/scd_gpio_priv_config.h
new file mode 100644
index 00000000..a681c27
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_gpio_priv_config.h
@@ -0,0 +1,110 @@
+/*
+ * scd_gpio_priv_config.h - smartcard driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+
+#ifndef __SCD_GPIO_PRIV_CONFIG_H__
+#define __SCD_GPIO_PRIV_CONFIG_H__
+
+//#define SPI_UART
+//#define SPI_UART_TX
+#define FORCE_SET_PINMUX
+
+// clock
+#define GPIO_SCD_CLK_GPIO           venus_gpio_id(MIS_GPIO, 4)
+#define GPIO_SCD_CLK_PINMUX_REG     0xb8000378
+#define GPIO_SCD_CLK_PINMUX_MASK    (0x7<<8)
+#define GPIO_SCD_CLK_PINMUX_VAL_IO  (0x4<<8)
+#define GPIO_SCD_CLK_PINMUX_VAL_PWM (0x6<<8)
+
+// Card Detect
+//#define GPIO_SCD_CD_GPIO           venus_gpio_id(MIS_GPIO, 5)
+//#define GPIO_SCD_CD_PINMUX_REG     0xb8000378
+//#define GPIO_SCD_CD_PINMUX_MASK    (0x7<<8)
+//#define GPIO_SCD_CD_PINMUX_VAL     (0x4<<8)
+
+#define GPIO_SCD_CD_GPIO           venus_gpio_id(MIS_GPIO, 122)
+#define GPIO_SCD_CD_PINMUX_REG     0xb800037c
+#define GPIO_SCD_CD_PINMUX_MASK    (0x3<<21)
+#define GPIO_SCD_CD_PINMUX_VAL     (0)
+
+// Reset
+//#define GPIO_SCD_RST_GPIO           venus_gpio_id(MIS_GPIO, 121)
+//#define GPIO_SCD_RST_PINMUX_REG     0xb800037C
+//#define GPIO_SCD_RST_PINMUX_MASK    (0x3<<15)
+//#define GPIO_SCD_RST_PINMUX_VAL     (0)   
+    
+#define GPIO_SCD_RST_GPIO           venus_gpio_id(MIS_GPIO, 60)
+#define GPIO_SCD_RST_PINMUX_REG     0xb800037C
+#define GPIO_SCD_RST_PINMUX_MASK    (0x3<<19)
+#define GPIO_SCD_RST_PINMUX_VAL     (0)   
+
+//#define GPIO_SCD_RST_GPIO             venus_gpio_id(MIS_GPIO, 120)   
+//#define GPIO_SCD_RST_PINMUX_REG       0xb800037C
+//#define GPIO_SCD_RST_PINMUX_MASK      (0x3<<17)
+//#define GPIO_SCD_RST_PINMUX_VAL       (0)
+
+    
+// IO    
+#ifdef SPI_UART     
+
+    #define GPIO_SCD_DATAOUT_GPIO               venus_gpio_id(MIS_GPIO, 1)
+    #define GPIO_SCD_DATAOUT_PINMUX_REG         0xb8000378
+    #define GPIO_SCD_DATAOUT_PINMUX_MASK        (0x3<<2)
+    #define GPIO_SCD_DATAOUT_PINMUX_VAL_GPIO    (0x1<<2)
+    #define GPIO_SCD_DATAOUT_PINMUX_VAL_UART    (0x2<<2)
+    
+    #define GPIO_SCD_DATAIN_GPIO                venus_gpio_id(MIS_GPIO, 2)
+    #define GPIO_SCD_DATAIN_PINMUX_REG          0xb8000378
+    #define GPIO_SCD_DATAIN_PINMUX_MASK         (0x3<<4)
+    #define GPIO_SCD_DATAIN_PINMUX_VAL_GPIO     (0x1<<4)    
+    #define GPIO_SCD_DATAIN_PINMUX_VAL_UART     (0x2<<4)    
+         
+#else        
+
+  #ifdef SPI_UART_TX
+    #define GPIO_SCD_DATAOUT_GPIO               venus_gpio_id(MIS_GPIO, 1)
+    #define GPIO_SCD_DATAOUT_PINMUX_REG         0xb8000378
+    #define GPIO_SCD_DATAOUT_PINMUX_MASK        (0x3<<2)
+    #define GPIO_SCD_DATAOUT_PINMUX_VAL_GPIO    (0x1<<2)  
+    #define GPIO_SCD_DATAOUT_PINMUX_VAL_UART    (0x2<<2)      
+  #else        
+    #define GPIO_SCD_DATAOUT_GPIO               venus_gpio_id(MIS_GPIO, 58)
+    #define GPIO_SCD_DATAOUT_PINMUX_REG         0xb8000378
+    #define GPIO_SCD_DATAOUT_PINMUX_MASK        (0x7<<16)
+    #define GPIO_SCD_DATAOUT_PINMUX_VAL_GPIO    (0x7<<16)  
+    #define GPIO_SCD_DATAOUT_PINMUX_VAL_UART    (0x4<<16)  
+  #endif                
+    #define GPIO_SCD_DATAIN_GPIO                venus_gpio_id(MIS_GPIO, 57)
+    #define GPIO_SCD_DATAIN_PINMUX_REG          0xb8000378
+    #define GPIO_SCD_DATAIN_PINMUX_MASK         (0x7<<16)
+    #define GPIO_SCD_DATAIN_PINMUX_VAL_GPIO     (0x7<<16)                 
+    #define GPIO_SCD_DATAIN_PINMUX_VAL_UART     (0x4<<16)                 
+#endif                
+
+
+// CMD_VCC
+#ifdef USE_TDA8024
+//#define GPIO_SCD_CMD_VCC_GPIO           venus_gpio_id(MIS_GPIO, 120)   
+//#define GPIO_SCD_CMD_VCC_PINMUX_REG     0xb800037C
+//#define GPIO_SCD_CMD_VCC_PINMUX_MASK    (0x3<<17)
+//#define GPIO_SCD_CMD_VCC_PINMUX_VAL     (0)
+
+#define GPIO_SCD_CMD_VCC_GPIO           venus_gpio_id(MIS_GPIO, 121)
+#define GPIO_SCD_CMD_VCC_PINMUX_REG     0xb800037C
+#define GPIO_SCD_CMD_VCC_PINMUX_MASK    (0x3<<15)
+#define GPIO_SCD_CMD_VCC_PINMUX_VAL     (0)   
+
+#define GPIO_SCD_PWR_SEL_GPIO           venus_gpio_id(MIS_GPIO, 5)
+#define GPIO_SCD_PWR_SEL_PINMUX_REG     0xb8000378
+#define GPIO_SCD_PWR_SEL_PINMUX_MASK    (0x7<<11)
+#define GPIO_SCD_PWR_SEL_PINMUX_VAL     (0x4<<11)   
+#endif
+
+#endif // __SCD_GPIO_PRIV_CONFIG_H__
diff --git a/drivers/smartcard/adapter/scd_icam.c b/drivers/smartcard/adapter/scd_icam.c
new file mode 100644
index 00000000..7f57351
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_icam.c
@@ -0,0 +1,437 @@
+/* ------------------------------------------------------------------------- 
+   scd_icam.c  scd driver for Realtek Neptune/Mars           
+   ------------------------------------------------------------------------- 
+    Copyright (C) 2008 Kevin Wang <kevin_wang@realtek.com.tw>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    
+----------------------------------------------------------------------------
+Update List :
+----------------------------------------------------------------------------
+    1.0     |   20090312    |   Kevin Wang  | 1) create phase
+----------------------------------------------------------------------------*/
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/jiffies.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <asm/io.h>
+#include "scd_icam_priv.h"
+
+MODULE_LICENSE("GPL");
+
+
+/*------------------------------------------------------------------
+ * Func : ops_probe
+ *
+ * Desc : probe a scd device
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static 
+int ops_probe(scd_device* dev)
+{    
+    icam_scd* p_scd;
+    
+    if ((dev->id & 0xFFFFFFFF)!=ICAM_SCD_ID)
+        return -ENODEV;                            
+                
+    p_scd = icam_scd_open();
+    
+    if (p_scd==NULL)
+        return -ENOMEM;
+   
+    scd_set_drvdata(dev, p_scd);    // attach it to the scd_device
+    return 0;     
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_remove
+ *
+ * Desc : this function will be invoked when a smart card device which 
+ *        associated with this driver has been removed
+ *
+ * Parm : dev : smart card device to be removed
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+static 
+void ops_remove(scd_device* dev)
+{       
+    icam_scd_close((icam_scd*) scd_get_drvdata(dev));
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_enable
+ *
+ * Desc : enable IFD
+ *
+ * Parm : dev    : ifd device
+ *        on_off : 0      : disable IFD 
+ *                 others : enable IFD
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static 
+int ops_enable(scd_device* dev, unsigned char on_off)
+{    
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);
+    return icam_scd_enable(p_this, on_off);        
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_set_param
+ *
+ * Desc : set param of IFD
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static 
+int ops_set_param(
+    scd_device*             dev, 
+    unsigned long           id,
+    unsigned long           val
+    )
+{    
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);
+    int ret= SC_SUCCESS; 
+        
+    switch(id) 
+    {        
+    case SC_PARAM_VCC_LVL:
+        ret = icam_scd_set_vcc_level(p_this, (SC_VCC_LVL) val);   
+        break;
+        
+    case SC_PARAM_CLOCK:
+        ret = icam_scd_set_clock(p_this, (unsigned long) val);        
+        break;
+        
+    case SC_PARAM_ETU:
+        ret = icam_scd_set_etu(p_this, (unsigned long) val); 
+        break;
+        
+    case SC_PARAM_CONV:
+        ret = icam_scd_set_convention(p_this, (SC_CONV) val);   
+        break;
+        
+    case SC_PARAM_PARITY:
+        // do nothing...        
+        break;
+        
+    case SC_PARAM_GUARD_INTERVAL:
+        ret = icam_scd_set_guard_interval(p_this, val);   
+        break;
+        
+    case SC_PARAM_FLOW_CONTROL:
+        ret = icam_scd_set_flow_control(p_this, val);   
+        break;        
+        
+    case SC_PARAM_EXTENDED_IO_CONTROL:
+        ret = icam_scd_set_uart_command(p_this, val);   
+        break;         
+        
+    default:
+        ret = SC_FAIL;        
+    }
+            
+    return ret;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_get_param
+ *
+ * Desc : get param of IFD
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static 
+int ops_get_param(
+    scd_device*             dev, 
+    unsigned long           id,                                
+    unsigned long*          p_val
+    )
+{    
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);
+    int ret = SC_SUCCESS;    
+        
+    switch(id) 
+    {        
+    case SC_PARAM_VCC_LVL:
+        ret = icam_scd_get_vcc_level(p_this, (SC_VCC_LVL*) p_val);   
+        break;
+        
+    case SC_PARAM_CLOCK:        
+        ret = icam_scd_get_clock(p_this,  p_val);        
+        break;
+        
+    case SC_PARAM_ETU:
+        ret = icam_scd_get_etu(p_this, p_val); 
+        break;
+        
+    case SC_PARAM_CONV:
+        ret = icam_scd_get_convention(p_this, (SC_CONV*) p_val);   
+        break;
+        
+    case SC_PARAM_PARITY:
+        *p_val = SC_PARITY_EVEN;        
+        break;
+        
+    case SC_PARAM_GUARD_INTERVAL:        
+        ret = icam_scd_get_guard_interval(p_this, p_val);   
+        break;        
+        
+    case SC_PARAM_EXTENDED_IO_CONTROL:
+        ret = icam_scd_get_uart_command(p_this, p_val);   
+        break;                
+        
+    default:
+        ret = SC_FAIL;        
+    }
+    
+    return ret;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_activate
+ *
+ * Desc : activate ICC via reset procedure
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_activate(scd_device* dev)
+{            
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);    
+    return icam_scd_activate(p_this);    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_deactivate
+ *
+ * Desc : deactivate icc
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_deactivate(scd_device* dev)
+{            
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);    
+    return icam_scd_deactivate(p_this);    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_reset
+ *
+ * Desc : reset a scd device 
+ *
+ * Parm : dev
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_reset(scd_device* dev)
+{            
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);    
+    return icam_scd_reset(p_this);    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_get_atr
+ *
+ * Desc : get atr from a scd device 
+ *
+ * Parm : dev 
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_get_atr(scd_device* dev, scd_atr* p_atr)
+{
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);              
+    return icam_scd_get_atr(p_this, p_atr);            
+}
+
+
+/*------------------------------------------------------------------
+ * Func : ops_get_card_status
+ *
+ * Desc : get card status of IFD 
+ *
+ * Parm : dev 
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_get_card_status(scd_device* dev)
+{    
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);    
+    return icam_scd_get_card_status(p_this);
+}
+
+
+  
+/*------------------------------------------------------------------
+ * Func : ops_poll_card_status
+ *
+ * Desc : poll card status
+ *
+ * Parm : dev  :   
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_poll_card_status(scd_device* dev)
+{
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);    
+    return icam_scd_poll_card_status(p_this);    
+}
+
+  
+/*------------------------------------------------------------------
+ * Func : ops_xmit
+ *
+ * Desc : xmit data via smart card bus
+ *
+ * Parm : dev  :   
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_xmit(scd_device* dev, unsigned char* p_data, unsigned int len)
+{   
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);    
+    return icam_scd_xmit(p_this, p_data, len);     
+}                                 
+              
+              
+  
+/*------------------------------------------------------------------
+ * Func : ops_read
+ *
+ * Desc : read data via smart card bus
+ *
+ * Parm : dev  :   
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+static 
+int ops_read(scd_device* dev, unsigned char* p_data, unsigned int len)
+{   
+    icam_scd* p_this = (icam_scd*) scd_get_drvdata(dev);
+    return icam_scd_read(p_this, p_data, len);
+}
+                                                                  
+
+static scd_device icam_scd_controller[1] = 
+{
+    {
+        .id   = ICAM_SCD_ID,
+        .name = "icam_scd_0"
+    },
+};
+
+
+static scd_driver icam_scd_driver = 
+{    
+    .name               = "icam_scd",
+    .probe              = ops_probe,
+    .remove             = ops_remove,        
+    .suspend            = NULL,
+    .resume             = NULL,
+    .enable             = ops_enable,
+    .set_param          = ops_set_param,
+    .get_param          = ops_get_param,    
+    .activate           = ops_activate,
+    .deactivate         = ops_deactivate,
+    .reset              = ops_reset,
+    .get_atr            = ops_get_atr,
+    .get_card_status    = ops_get_card_status,
+    .poll_card_status   = ops_poll_card_status,
+    .xmit               = ops_xmit,
+    .read               = ops_read,
+};
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_module_init
+ *
+ * Desc : init icam smart card interface driver
+ *
+ * Parm : N/A
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static int __init icam_scd_module_init(void)
+{                        
+    SC_INFO("icam scd module init\n");        
+                                
+    if (register_scd_driver(&icam_scd_driver)!=0)
+        return -EFAULT;                                        
+
+    register_scd_device(&icam_scd_controller[0]);          // register scd device                            
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_module_exit
+ *
+ * Desc : uninit icam smart card interface driver
+ *
+ * Parm : N/A
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static void __exit icam_scd_module_exit(void)
+{            
+    unregister_scd_device(&icam_scd_controller[0]);
+    unregister_scd_driver(&icam_scd_driver);
+}
+
+
+module_init(icam_scd_module_init);
+module_exit(icam_scd_module_exit);
diff --git a/drivers/smartcard/adapter/scd_icam_priv.c b/drivers/smartcard/adapter/scd_icam_priv.c
new file mode 100644
index 00000000..2fc4fa7
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_icam_priv.c
@@ -0,0 +1,1184 @@
+/* ------------------------------------------------------------------------- 
+   scd_icam.c  scd driver for Realtek Nike ICAM
+   ------------------------------------------------------------------------- 
+    Copyright (C) 2008 Kevin Wang <kevin_wang@realtek.com.tw>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    
+----------------------------------------------------------------------------
+Update List :
+----------------------------------------------------------------------------
+    1.0     |   20090312    |   Kevin Wang  | 1) create phase
+----------------------------------------------------------------------------*/
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/jiffies.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <asm/io.h>
+#include <platform.h>
+#include <asm/mach-rtk_dmp/platform.h>
+#include <nike.h>
+#include "scd_icam_priv.h"
+
+MODULE_LICENSE("GPL");
+
+
+#define SA_SHIRQ IRQF_SHARED
+#define ICAM_IRQ 5
+
+#define _readl(x)                      readl(x) 
+//#define _writel(x,y)                   do { printk("wr_reg(%lx)=%lx\n", y, x); writel(x,y);} while(0)
+#define _writel(x,y)                   writel(x,y) 
+#define GET_NDS_SC_CKSEL(h)            readl((volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_NDS_SC_CKSEL))
+#define SET_NDS_SC_CKSEL(h,v)          _writel(v, (volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_NDS_SC_CKSEL))
+
+#define GET_ICAM_UART_DATA(h)          readl((volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_DATA))        
+#define GET_ICAM_UART_CTRL_STAT(h)     readl((volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_CTRL_STAT))
+#define GET_ICAM_UART_BAUD_RATE_L(h)   readl((volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_BAUD_RATE_L))   
+#define GET_ICAM_UART_BAUD_RATE_H(h)   readl((volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_BAUD_RATE_H))  
+#define GET_ICAM_UART_COM(h)           readl((volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_COM))           
+#define GET_ICAM_UART_INT(h)           readl((volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_INT))            
+#define GET_ICAM_UART_GUARD_TIME(h)    readl((volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_GUARD_TIME))
+#define SET_ICAM_UART_DATA(h,v)        _writel(v, (volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_DATA))        
+#define SET_ICAM_UART_CTRL_STAT(h,v)   _writel(v, (volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_CTRL_STAT))
+#define SET_ICAM_UART_BAUD_RATE_L(h,v) _writel(v, (volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_BAUD_RATE_L))   
+#define SET_ICAM_UART_BAUD_RATE_H(h,v) _writel(v, (volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_BAUD_RATE_H))  
+#define SET_ICAM_UART_COM(h,v)         _writel(v, (volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_COM))           
+#define SET_ICAM_UART_INT(h,v)         _writel(v, (volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_INT))            
+#define SET_ICAM_UART_GUARD_TIME(h,v)  _writel(v, (volatile unsigned int*)(NIKE_IO_PORT_BASE + NIKE_ICAM_UART_GUARD_TIME))
+
+
+
+#define NDS_CLOCK_SOURCE        27000000
+#define NDS_ICAM_SYSTEM_CLOCK   202500000
+#define IFD_MODOLE              "NIKE_ICAM_SMC"
+    
+#ifdef ISR_POLLING  
+#define ISR_POLLING_INTERVAL        (HZ>>2)
+static void icam_scd_timer(unsigned long arg);
+#endif
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_set_state
+ *
+ * Desc : 
+ *
+ * Parm : p_this : handle of icam smartcard ifd 
+ *         
+ * Retn : N/A  
+ *------------------------------------------------------------------*/
+int icam_scd_set_state(
+    icam_scd*               p_this, 
+    IFD_FSM                 fsm
+    )
+{
+    unsigned char id = p_this->id;
+    
+    if (p_this->fsm == fsm)
+        return 0;
+        
+    switch(fsm)
+    {       
+    case IFD_FSM_DISABLE:        
+        SC_INFO("SC%d - FSM = DISABLE\n", id);
+        icam_scd_set_vcc(p_this, 0);    
+        icam_scd_set_vcc_level(p_this, SC_VCC_3V);
+        icam_scd_set_clock(p_this, LOWEST_CLOCK);       
+        icam_scd_set_etu(p_this, 372);
+        icam_scd_set_convention(p_this, SC_DIRECT_CONV);
+        icam_scd_set_guard_interval(p_this, 2);
+        SET_ICAM_UART_INT(p_this, GET_ICAM_UART_INT(p_this) | ICAM_UART_RESET_INT);       // clear interrupts        
+        SET_ICAM_UART_INT(p_this, 0);
+        p_this->atr.length = 0;         
+        break;
+        
+    case IFD_FSM_DEACTIVATE:        
+        SC_INFO("SC%d - FSM = IDEL\n", id);                                      
+        icam_scd_set_vcc(p_this, 0);
+        p_this->atr.length = 0;
+        kfifo_reset(&p_this->rx_fifo);
+        SET_ICAM_UART_INT(p_this, GET_ICAM_UART_INT(p_this) | ICAM_UART_RESET_INT);       // clear interrupts        
+        SET_ICAM_UART_INT(p_this, ICAM_UART_INT_DETECT);     // start card detect        
+        break;
+        
+    case IFD_FSM_RESET:      
+               
+        p_this->atr.length = 0;
+                                            
+        if (!icam_scd_card_detect(p_this))
+        {
+            SC_WARNING("SC%d - RESET icam scd failed, no ICC exist\n", id);                            
+            icam_scd_set_state(p_this, IFD_FSM_DEACTIVATE);
+            return SC_ERR_NO_ICC;
+        }
+                                    
+        kfifo_reset(&p_this->rx_fifo);
+        
+        icam_scd_set_etu(p_this, 372);
+        icam_scd_set_vcc(p_this, 1);
+                
+        SET_ICAM_UART_CTRL_STAT(p_this, p_this->uart_ctrl); 
+        
+        SET_ICAM_UART_INT(p_this, ICAM_UART_INT_RX | ICAM_UART_RX_OVERFLOW | ICAM_UART_RX_PARITY_ERR | 
+                                  ICAM_UART_INT_DETECT);
+        udelay(100);        
+        SET_ICAM_UART_INT(p_this, GET_ICAM_UART_INT(p_this) | ICAM_UART_RESET_INT);       // clear interrupts                
+        SET_ICAM_UART_CTRL_STAT(p_this, p_this->uart_ctrl | ICAM_UART_CTRL_RESET_MASK);
+        p_this->atr_timeout = jiffies + HZ;                            
+        SC_INFO("SC%d - FSM = RESET & ATR\n", id);        
+        break;
+        
+    case IFD_FSM_ACTIVE:
+        
+        SC_INFO("SC%d - FSM = ACTIVATE\n", id);        
+        SET_ICAM_UART_INT(p_this, ICAM_UART_INT_RX | ICAM_UART_RX_OVERFLOW | ICAM_UART_RX_PARITY_ERR | 
+                                  ICAM_UART_INT_DETECT);        
+        break;
+
+    default:
+    case IFD_FSM_UNKNOWN:
+        break;                    
+    }    
+    
+    p_this->fsm = fsm;             
+    
+    p_this->card_status_change = 1;    
+    wake_up(&p_this->wq);             
+    
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_work
+ *
+ * Desc : icam scd work routine
+ *
+ * Parm : p_this : handle of icam cec 
+ *         
+ * Retn : N/A  
+ *------------------------------------------------------------------*/
+void icam_scd_work(icam_scd* p_this)
+{
+    unsigned long status = GET_ICAM_UART_INT(p_this);      
+    unsigned char val; 
+
+    
+    
+    SET_ICAM_UART_INT(p_this, status | ICAM_UART_RESET_INT);       // clear interrupts        
+                
+    if (status & ICAM_UART_STATUS_RX_READY)      
+    {
+        val = GET_ICAM_UART_DATA(p_this);
+        //SC_INFO("SC%d - Read %02x!!\n", p_this->id, val); 
+        
+        //printk(KERN_DEBUG "%02x\n", val);
+        
+        if (p_this->uart_ctrl & ICAM_UART_CTRL_MANUAL_FLOW_CTRL_ON)
+        {
+            SET_ICAM_UART_CTRL_STAT(p_this, p_this->uart_ctrl &~ICAM_UART_CTRL_MANUAL_FLOW_CTRL_ON);             
+            SET_ICAM_UART_CTRL_STAT(p_this, p_this->uart_ctrl | ICAM_UART_CTRL_MANUAL_FLOW_CTRL_ON); 
+        }
+        
+        switch (p_this->fsm)
+        {       
+        case IFD_FSM_RESET:
+            
+            if (p_this->atr.length >= MAX_ATR_SIZE)
+                goto err_atr_failed;
+                                      
+            p_this->atr.data[p_this->atr.length] = val;
+                    
+            if (p_this->atr.length==0)
+            {                
+                switch(p_this->atr.data[0])
+                {
+                case 0x3B:
+                    //SC_INFO("SC%d - Direct Convention (%02x)\n", p_this->id, p_this->atr.data[0]);
+                    p_this->atr.length++;
+                    break;
+                    
+                case 0x3F:
+                    p_this->atr.data[0] = 0x3F;
+                    //SC_INFO("SC%d - Inverse Convention (%02x)\n", p_this->id, p_this->atr.data[0]);
+                    p_this->atr.length++;
+                    break;
+                                
+                default:
+                    //SC_WARNING("SC%d - unknown TS (%02x)\n", p_this->id, p_this->atr.data[0]);
+                    break;                     
+                }                   
+            }
+            else                
+                p_this->atr.length++;
+                    
+            SC_INT_DBG("p_this->atr.length=%d\n", p_this->atr.length);
+            
+            // check atr 
+            if (is_atr_complete(&p_this->atr))
+            {            
+                SC_INFO("SC%d - Got ATR Completed\n", p_this->id);
+                
+                if (decompress_atr(&p_this->atr, &p_this->atr_info)<0)
+                    goto err_atr_failed;                                                           
+    
+                icam_scd_set_state(p_this, IFD_FSM_ACTIVE);       // jump to active state
+            }
+
+            break;            
+            
+        case IFD_FSM_ACTIVE:
+            
+            if (kfifo_in_locked(&p_this->rx_fifo, &val, 1, &p_this->rx_fifo_lock)<1)
+            {
+                SC_WARNING("icam_scd_fsm_active : fifo over flow... flush data...\n");   
+                kfifo_reset(&p_this->rx_fifo);
+            }
+            break;
+            
+        default:
+            break;
+        }
+    }
+    
+    if (status & ICAM_UART_INT_DETECT)            
+    {           
+        if (icam_scd_card_detect(p_this)) 
+        {
+            SC_INFO("SC%d - ICC detected!!\n", p_this->id);             
+        }
+        else 
+        {
+            icam_scd_set_state(p_this, IFD_FSM_DEACTIVATE);
+            SC_INFO("SC%d - ICC removed!!\n", p_this->id);              
+        }
+            
+        p_this->card_status_change = 1;            
+        wake_up(&p_this->wq);           
+    }
+    
+    if (status & ICAM_UART_RX_OVERFLOW)
+    {
+        SC_INFO("SC%d - Rx Overflow!!\n", p_this->id); 
+    }
+    
+    if (status & ICAM_UART_TX_PARITY_ERR)
+    {
+        SC_INFO("SC%d - Tx Parity Error!!\n", p_this->id); 
+    }
+    
+    if (status & ICAM_UART_RX_PARITY_ERR)
+    {
+        SC_INFO("SC%d - Rx Parity Error!!\n", p_this->id); 
+    }
+        
+    return;
+    
+//---------------------------    
+err_atr_failed:
+    
+    if (time_after(jiffies, p_this->atr_timeout))
+    {        
+        SC_WARNING("SC%d - RESET ICC failed, timeout\n", p_this->id);                   
+    }    
+    
+    if (p_this->atr.length <0)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, wait ATR failed\n", p_this->id); 
+    }
+    else if (p_this->atr.length >= MAX_ATR_SIZE)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, atr length %d more then %d\n", p_this->id, p_this->atr.length, MAX_ATR_SIZE); 
+    }
+    else if (!is_atr_complete(&p_this->atr))
+    {
+        SC_WARNING("SC%d - RESET ICC failed, incomplete atr\n", p_this->id); 
+    }
+    else if (decompress_atr(&p_this->atr, &p_this->atr_info)<0)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, decompress atr failed\n", p_this->id); 
+    }
+    else
+    {
+        SC_WARNING("SC%d - RESET ICC failed, parse protocol faield\n", p_this->id); 
+    }
+                                                                
+    icam_scd_set_state(p_this, IFD_FSM_DEACTIVATE);    
+}
+
+
+
+#ifdef ISR_POLLING     
+/*------------------------------------------------------------------
+ * Func : icam_scd_timer
+ *
+ * Desc : timer of icam scd
+ *
+ * Parm : arg : input param 
+ *         
+ * Retn : IRQ_NONE, IRQ_HANDLED
+ *------------------------------------------------------------------*/
+static void icam_scd_timer(unsigned long arg)        
+{   
+    icam_scd* p_this = (icam_scd*) arg;                   
+
+    if (GET_ICAM_UART_INT(p_this))           
+        icam_scd_work(p_this);
+        
+    mod_timer(&p_this->timer, jiffies + ISR_POLLING_INTERVAL);
+}
+
+#else
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_isr
+ *
+ * Desc : isr of icam scd
+ *
+ * Parm : p_this : handle of icam scd 
+ *        dev_id : handle of the icam_scd
+ *        regs   :
+ *         
+ * Retn : IRQ_NONE, IRQ_HANDLED
+ *------------------------------------------------------------------*/
+static irqreturn_t
+icam_scd_isr(
+    int                     this_irq, 
+    void*                   dev_id
+    )
+{   
+    icam_scd* p_this = (icam_scd*) dev_id;
+    unsigned long flag;                     
+         
+    spin_lock_irqsave(&p_this->lock, flag);         
+
+    icam_scd_work(p_this);        
+                                          
+    spin_unlock_irqrestore(&p_this->lock, flag);                               
+                      
+    return IRQ_HANDLED;    
+}
+
+
+#endif
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_enable
+ *
+ * Desc : enable icam smart card interface
+ *
+ * Parm : p_this   : handle of icam scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_enable(icam_scd* p_this, unsigned char on_off)
+{
+    int ret = 0;
+    if (on_off)        
+    {
+        if (p_this->fsm==IFD_FSM_DISABLE)
+        {
+            ret =  icam_scd_set_state(p_this, IFD_FSM_DEACTIVATE);
+            msleep(200);   // fix bug of get card status fail on darwin platform....
+        }
+    }
+    else    
+        ret =  icam_scd_set_state(p_this, IFD_FSM_DISABLE);    
+    
+    return ret;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_set_vcc
+ *
+ * Desc : enable/disable vcc output
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        clk      : clock (in HZ)
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_set_vcc(icam_scd* p_this, unsigned char on)
+{
+    if (on)
+    {
+        p_this->uart_ctrl &= ~(ICAM_UART_CTRL_VCC_MASK | ICAM_UART_CTRL_3V5V_MASK);
+        p_this->uart_ctrl |=  (ICAM_UART_CTRL_VCC_ON | p_this->vcc_sel);
+    }
+    else
+    {            
+        p_this->uart_ctrl &= ~(ICAM_UART_CTRL_VCC_MASK|ICAM_UART_CTRL_3V5V_MASK);        
+        p_this->uart_ctrl |=  (ICAM_UART_CTRL_VCC_OFF | p_this->vcc_sel);                    
+    }
+    
+    SC_INFO("icam_scd_set_vcc=%d, uart_ctrl=%lx\n", on, p_this->uart_ctrl);
+    SET_ICAM_UART_CTRL_STAT(p_this, p_this->uart_ctrl);     
+   
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_set_vcc_level
+ *
+ * Desc : set vcc output level
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        vcc_5v   : clock (in HZ)
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_set_vcc_level(icam_scd* p_this, SC_VCC_LVL lvl)
+{     
+    p_this->vcc_sel = (lvl==SC_VCC_5V) ? ICAM_UART_CTRL_3V5V_OFF : ICAM_UART_CTRL_3V5V_ON;    
+    return 0;
+}
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_get_vcc_level
+ *
+ * Desc : get vcc output level
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        vcc_5v   : clock (in HZ)
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_get_vcc_level(icam_scd* p_this, SC_VCC_LVL* p_lvl)
+{     
+    *p_lvl = (p_this->vcc_sel==ICAM_UART_CTRL_3V5V_OFF) ? SC_VCC_5V : SC_VCC_3V;     
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_set_convention
+ *
+ * Desc : set convention
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        conv     : conv
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_set_convention(icam_scd* p_this, SC_CONV convention)
+{
+    switch (convention)
+    {
+    case SC_INVERSE_CONV:
+        SC_INFO("Set Convention = Inverse\n");        
+        p_this->uart_ctrl &= ~ICAM_UART_CTRL_CONV_MASK;
+        p_this->uart_ctrl |=  ICAM_UART_CTRL_INVERSE_CONV;  
+        break;   
+            
+    case SC_AUTO_CONV:                
+    case SC_DIRECT_CONV:    
+        SC_INFO("Set Convention = Direct\n");
+        p_this->uart_ctrl &= ~ICAM_UART_CTRL_CONV_MASK;
+        p_this->uart_ctrl |=  ICAM_UART_CTRL_DIRECT_CONV;                   
+        break;
+        
+    default:
+        SC_WARNING("unkonwn convention %d\n", convention);
+        return -1;                            
+    }   
+        
+    SC_INFO("icam_scd_set_convention=%d, uart_ctrl=%lx\n", convention, p_this->uart_ctrl);
+        
+    SET_ICAM_UART_CTRL_STAT(p_this, p_this->uart_ctrl);    
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_get_convention
+ *
+ * Desc : get convention
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        p_conv   : convention output
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_get_convention(icam_scd* p_this, SC_CONV* p_conv)
+{    
+    *p_conv = ((p_this->uart_ctrl & ICAM_UART_CTRL_CONV_MASK)==ICAM_UART_CTRL_DIRECT_CONV) ? SC_DIRECT_CONV : SC_INVERSE_CONV;      
+    printk("*p_conv=%d\n", *p_conv);
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_set_clock
+ *
+ * Desc : set clock frequency of icam smart card interface
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        clk      : clock (in HZ)
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_set_clock(icam_scd* p_this, unsigned long clk)
+{
+    switch(clk)
+    {
+    case HIGHEST_CLOCK:
+        SET_NDS_SC_CKSEL(p_this, NDS_SC_CKSEL_DIV_2);     // divided by 2
+        break;
+    case MEDIUM_CLOCK:
+        SET_NDS_SC_CKSEL(p_this, NDS_SC_CKSEL_DIV_4);     // divided by 4
+        break;        
+    case LOWEST_CLOCK:
+        SET_NDS_SC_CKSEL(p_this, NDS_SC_CKSEL_DIV_6);     // divided by 6
+        break;
+    default:
+        SC_WARNING("unsupportted clock frequency - %lu\n", clk);
+        return -1;
+    }    
+    
+    icam_scd_set_etu(p_this, p_this->etu);  // update etu
+    return 0;    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_get_clock
+ *
+ * Desc : get clock frequency of icam smart card interface
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        p_clock  : clock (in HZ)
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_get_clock(icam_scd* p_this, unsigned long* p_clock)
+{    
+    *p_clock = 0;
+    switch(GET_NDS_SC_CKSEL(p_this))
+    {
+    case NDS_SC_CKSEL_DIV_2: *p_clock = NDS_CLOCK_SOURCE / 2; break;
+    case NDS_SC_CKSEL_DIV_4: *p_clock = NDS_CLOCK_SOURCE / 4; break;                
+    case NDS_SC_CKSEL_DIV_6: *p_clock = NDS_CLOCK_SOURCE / 6; break; 
+    case NDS_SC_CKSEL_DIV_8: *p_clock = NDS_CLOCK_SOURCE / 8; break;          
+    default:
+        SC_WARNING("Get clock freq failed, unknown clock divisor - %d\n", GET_NDS_SC_CKSEL(p_this));
+        return -1;
+    }   
+        
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_set_etu
+ *
+ * Desc : set etu of icam smart card interface
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        etu      : cycles
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_set_etu(icam_scd* p_this, unsigned long etu)
+{    
+    unsigned long div;       
+    unsigned long sclk;       
+    
+    icam_scd_get_clock(p_this, &sclk);
+    div = (NDS_ICAM_SYSTEM_CLOCK/1000) * etu;
+    div = div / (sclk/1000);
+    
+    if (div <2 || div > 0xFFFF)
+    {
+        SC_WARNING("Set etu failed, invalid divider - %lu\n", div);
+        return -1;
+    }                     
+    
+    p_this->etu = etu;                
+    div -= 2;                
+    SET_ICAM_UART_BAUD_RATE_H(p_this, (div >>8) & 0xFF);    
+    SET_ICAM_UART_BAUD_RATE_L(p_this, (div) & 0xFF);        
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_get_etu
+ *
+ * Desc : set etu of icam smart card interface
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        etu      : cycles
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_get_etu(icam_scd* p_this, unsigned long* p_etu)
+{    
+    *p_etu = p_this->etu;
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_set_guard_interval
+ *
+ * Desc : set guard interval of icam smart card interface
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        guard_interval : guard interval in etu
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_set_guard_interval(icam_scd* p_this, unsigned long guard_interval)
+{    
+    if (guard_interval > 0xFF)
+    {
+        SC_WARNING("Set etu failed, invald guard interval - %lu\n", guard_interval);
+        return -1;
+    }         
+    
+    p_this->guard_time = (unsigned char) guard_interval;
+        
+    SET_ICAM_UART_GUARD_TIME(p_this, guard_interval);        
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_get_guard_interval
+ *
+ * Desc : set guard interval
+ *
+ * Parm : p_this : handle of icam scd  
+ *        p_guard_interval : guard interval output
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_get_guard_interval(icam_scd* p_this, unsigned long* p_guard_interval)
+{    
+    *p_guard_interval = p_this->guard_time;                        
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_set_flow_control
+ *
+ * Desc : enable/disable flow control function
+ *
+ * Parm : p_this : handle of icam scd  
+ *        on  : enable /disable flow control
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_set_flow_control(icam_scd* p_this, unsigned char on)
+{    
+    if (on)
+        p_this->uart_ctrl |= ICAM_UART_CTRL_MANUAL_FLOW_CTRL_ON;
+    else            
+        p_this->uart_ctrl &=~ICAM_UART_CTRL_MANUAL_FLOW_CTRL_ON;
+ 
+    SC_INFO("icam_scd_set_flow_control=%d, uart_ctrl=%lx\n", on, p_this->uart_ctrl);
+ 
+    SET_ICAM_UART_CTRL_STAT(p_this, p_this->uart_ctrl);             
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_set_uart_command
+ *
+ * Desc : set uart command function
+ *
+ * Parm : p_this : handle of icam scd  
+ *        io_mask  : io mask
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_set_uart_command(icam_scd* p_this, unsigned long io_mask)
+{    
+    unsigned long io_mode = io_mask & SC_IO_CTRL_IO_MASK;
+    unsigned long uart_cmd = 0;
+        
+    switch(io_mode)
+    {
+    case SC_IO_CTRL_IO_C7:
+        
+        uart_cmd = ICAM_UART_COM_MODE_IO_C7;        
+        
+        if (io_mask & SC_IO_CTRL_C7_ON) 
+        {
+            SC_WARNING("Set UART command failed, C7 can not be programed both as IO and GPIO\n");            
+            return -1;
+        }     
+        
+        if (io_mask & SC_IO_CTRL_C4_ON)
+            uart_cmd |= ICAM_UART_COM_MODE_C4_ON;
+            
+        if (io_mask & SC_IO_CTRL_C8_ON)        
+            uart_cmd |= ICAM_UART_COM_MODE_C8_ON;
+        break;
+        
+    case SC_IO_CTRL_IO_C4:
+        
+        uart_cmd = ICAM_UART_COM_MODE_IO_C4;   
+        
+        if (io_mask & SC_IO_CTRL_C4_ON) 
+        {
+            SC_WARNING("Set UART command failed, C4 can not be programed both as IO and GPIO\n");            
+            return -1;
+        }   
+                  
+        break;
+        
+    case SC_IO_CTRL_IO_C8:   
+             
+        uart_cmd = ICAM_UART_COM_MODE_IO_C8; 
+        
+        if (io_mask & SC_IO_CTRL_C8_ON) 
+        {
+            SC_WARNING("Set UART command failed, C8 can not be programed both as IO and GPIO\n");            
+            return -1;
+        }                     
+        break;            
+        
+    default:
+        SC_WARNING("Set UART command failed, unknown io mode - %08lx\n", io_mode);
+        return -1;
+    }
+    
+    SET_ICAM_UART_COM(p_this, uart_cmd);                
+    return 0;
+}
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_get_uart_command
+ *
+ * Desc : get uart command function
+ *
+ * Parm : p_this : handle of icam scd  
+ *        p_io_mask : io mask output
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/ 
+int icam_scd_get_uart_command(icam_scd* p_this, unsigned long* p_io_mask)
+{    
+    unsigned long uart_com = GET_ICAM_UART_COM(p_this);
+    
+    *p_io_mask = 0;    
+    
+    if (uart_com & ICAM_UART_COM_MODE_C4_ON)
+        *p_io_mask |= SC_IO_CTRL_C4_ON;    
+        
+    if (uart_com & ICAM_UART_COM_MODE_C8_ON)
+        *p_io_mask |= SC_IO_CTRL_C8_ON;  
+                        
+    switch (uart_com & ICAM_UART_COM_MODE_MASK)
+    {
+    case ICAM_UART_COM_MODE_IO_C7:
+        *p_io_mask |= SC_IO_CTRL_IO_C7;  
+        break;
+        
+    case ICAM_UART_COM_MODE_IO_C4:
+        *p_io_mask |= SC_IO_CTRL_IO_C4;  
+        break;
+                
+    case ICAM_UART_COM_MODE_IO_C8:
+        *p_io_mask |= SC_IO_CTRL_IO_C8;  
+        break;        
+        
+    default:        
+        SC_WARNING("Get UART command failed, unknown io mode - %08lx\n", uart_com & ICAM_UART_COM_MODE_MASK);
+        return -1;               
+    }               
+    
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_activate
+ *
+ * Desc : activate an ICC
+ *
+ * Parm : p_this   : handle of icam scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/        
+int icam_scd_activate(icam_scd* p_this)
+{    
+    switch(p_this->fsm)
+    {
+    case IFD_FSM_DISABLE:
+        SC_WARNING("activate ICC failed, please enable IFD first\n");
+        return SC_ERR_IFD_DISABLED;
+        
+    case IFD_FSM_DEACTIVATE:        
+    
+        if (icam_scd_reset(p_this)==0)
+        {
+            SC_INFO("activate ICC success\n");
+            return SC_SUCCESS;
+        }
+        else
+        {
+            SC_WARNING("activate ICC failed\n");
+            return SC_ERR_NO_ICC;
+        }
+        break;            
+        
+    case IFD_FSM_RESET:
+        SC_INFO("ICC has is reseting\n");
+        return SC_SUCCESS;
+        
+    case IFD_FSM_ACTIVE:
+        SC_INFO("ICC has been activated already\n");
+        return SC_SUCCESS;
+        
+    default:        
+        SC_WARNING("activate ICC failed, unknown state\n");
+        return SC_FAIL;
+    } 
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_deactivate
+ *
+ * Desc : deactivate an ICC
+ *
+ * Parm : p_this   : handle of icam scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/        
+int icam_scd_deactivate(icam_scd* p_this)
+{    
+    if (p_this->fsm != IFD_FSM_DISABLE)
+    {
+        //icam_scd_set_state(p_this, IFD_FSM_DISABLE);
+        icam_scd_set_state(p_this, IFD_FSM_DEACTIVATE);
+    }
+    return 0;
+}
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_reset
+ *
+ * Desc : reset icam smart card interface
+ *
+ * Parm : p_this   : handle of icam scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/        
+int icam_scd_reset(icam_scd* p_this)
+{
+    unsigned long t;
+    
+    if (icam_scd_set_state(p_this, IFD_FSM_RESET))
+        return SC_FAIL;
+    
+    t = jiffies + (HZ);
+    
+    while(!time_after(jiffies,t) && p_this->fsm == IFD_FSM_RESET)    
+        msleep(100);    
+    
+    if (p_this->fsm!=IFD_FSM_ACTIVE)
+    {
+        SC_WARNING("SC%d - Reset ICC failed\n", p_this->id);
+        icam_scd_set_state(p_this, IFD_FSM_DEACTIVATE);
+        return SC_ERR_ATR_TIMEOUT;     
+    }
+        
+    SC_INFO("SC%d - Reset ICC Complete, atr_len=%d\n", p_this->id, p_this->atr.length);
+    return SC_SUCCESS;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_get_atr
+ *
+ * Desc : s icam smart card interface
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        p_atr    : atr output buffer
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/        
+int icam_scd_get_atr(icam_scd* p_this, scd_atr* p_atr)
+{        
+    if (p_this->fsm != IFD_FSM_ACTIVE)
+    {    
+        p_atr->length = -1;  
+        return -1;
+    }
+                
+    p_atr->length = p_this->atr.length;
+    memcpy(p_atr->data, p_this->atr.data, p_this->atr.length);    
+    return 0;    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_card_detect
+ *
+ * Desc : get card status
+ *
+ * Parm : p_this   : handle of icam scd  
+ *         
+ * Retn : 0 : no icc exists, others : icc exists
+ *------------------------------------------------------------------*/   
+int icam_scd_card_detect(icam_scd* p_this)
+{                              
+    return (GET_ICAM_UART_CTRL_STAT(p_this) & ICAM_UART_STATUS_DETECT) ? 1 : 0;                        
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_get_card_status
+ *
+ * Desc : get card status
+ *
+ * Parm : p_this   : handle of icam scd  
+ *         
+ * Retn : 0 : no icc exists, others : icc exists
+ *------------------------------------------------------------------*/   
+int icam_scd_get_card_status(icam_scd* p_this)
+{
+    switch(p_this->fsm) {       
+    case IFD_FSM_DISABLE:   return SC_CARD_REMOVED;                
+    case IFD_FSM_DEACTIVATE:      return icam_scd_card_detect(p_this) ? SC_CARD_DEACTIVATE : SC_CARD_REMOVED;                        
+    case IFD_FSM_RESET:     return SC_CARD_RESET;                                                            
+    case IFD_FSM_ACTIVE:    return SC_CARD_ACTIVATE;                
+    default:                return SC_CARD_UNKNOWN;
+    }    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_poll_card_status
+ *
+ * Desc : poll card status change
+ *
+ * Parm : p_this   : handle of icam scd  
+ *         
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/   
+int icam_scd_poll_card_status(icam_scd* p_this)
+{               
+    p_this->card_status_change = 0;
+    wait_event_interruptible(p_this->wq, p_this->card_status_change); 
+    return icam_scd_get_card_status(p_this);     
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_xmit
+ *
+ * Desc : xmit data via smart card bus
+ *
+ * Parm : p_this   : handle of icam scd  
+ *        scb      : data to be xmit
+ *         
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/        
+int icam_scd_xmit(icam_scd* p_this, unsigned char* p_data, unsigned int len)
+{            
+    unsigned long status;
+   
+    if (icam_scd_card_detect(p_this)==0)
+        return SC_ERR_NO_ICC;
+        
+    if (p_this->fsm != IFD_FSM_ACTIVE)        
+        return SC_ERR_ICC_DEACTIVATE;   
+        
+    while(len)
+    {
+        status = GET_ICAM_UART_CTRL_STAT(p_this);        
+        
+        if ((status & ICAM_UART_STATUS_DETECT)==0)                    
+            return SC_ERR_NO_ICC;        
+
+        if (GET_ICAM_UART_INT(p_this) & ICAM_UART_TX_PARITY_ERR)
+        {
+            SC_WARNING("SC%d - Tx Parity Error!!\n", p_this->id); 
+        } 
+             
+        if (status & ICAM_UART_STATUS_TX_READY)
+        {
+            SET_ICAM_UART_DATA(p_this, *p_data++);
+            len--;
+        }
+        
+        udelay(10);        
+    }
+            
+    return 0;            
+}                        
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_read
+ *
+ * Desc : read data via smart card bus
+ *
+ * Parm : p_this   : handle of icam scd   
+ *         
+ * Retn : sc_buff
+ *------------------------------------------------------------------*/        
+int icam_scd_read(icam_scd* p_this, unsigned char* data, unsigned int len)
+{    
+    if (icam_scd_card_detect(p_this)==0)
+        return SC_ERR_NO_ICC;
+            
+    if (p_this->fsm != IFD_FSM_ACTIVE)
+        return SC_ERR_ICC_DEACTIVATE;    
+            
+    return kfifo_out_locked(&p_this->rx_fifo, data, len, &p_this->rx_fifo_lock);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_open
+ *
+ * Desc : open a icam scd device
+ *
+ * Parm : id  : channel id
+ *         
+ * Retn : handle of icam scd
+ *------------------------------------------------------------------*/
+icam_scd* icam_scd_open()
+{           
+    icam_scd* p_this;    
+       
+    p_this = (icam_scd*) kmalloc(sizeof(icam_scd), GFP_KERNEL);    
+             
+    if (p_this)
+    {
+        memset(p_this, 0, sizeof(icam_scd));        
+  
+        p_this->id               = 0;
+        p_this->fsm              = IFD_FSM_UNKNOWN;        
+        p_this->atr.length       = -1;        
+        
+        if (kfifo_alloc(&p_this->rx_fifo, 1024, GFP_KERNEL)<0)
+        {
+            SC_WARNING("scd : open %s scd(%d) failed, create rx fifo failed\n", IFD_MODOLE, p_this->id);
+            kfree(p_this);
+            return NULL;
+        }
+        
+        spin_lock_init(&p_this->lock);
+        spin_lock_init(&p_this->rx_fifo_lock);
+        init_waitqueue_head(&p_this->wq);                        
+        
+        // configurations ---                
+        p_this->uart_ctrl = ICAM_UART_CTRL_3V5V_OFF | ICAM_UART_CTRL_DIRECT_CONV | 
+                            ICAM_UART_CTRL_VCC_OFF  | ICAM_UART_CTRL_AUTO_FLOW_CTRL_OFF;
+        p_this->vcc_sel   = ICAM_UART_CTRL_3V5V_ON;   
+        p_this->etu       = 372;     
+                        
+        SET_ICAM_UART_CTRL_STAT(p_this, p_this->uart_ctrl);
+                
+        icam_scd_set_clock(p_this, LOWEST_CLOCK);
+        
+        icam_scd_set_etu(p_this, 372);
+        
+        icam_scd_set_guard_interval(p_this, 2);
+        
+        // Set All Register to the initial value            
+        // Set Interrupt or IRQ        
+        SC_INFO("Request IRQ #%d\n", ICAM_IRQ);             
+    
+        if (request_irq(ICAM_IRQ, icam_scd_isr, SA_SHIRQ, "ICAM SCD", (void *) p_this) < 0) 
+        {
+            SC_WARNING("scd : open %s scd failed, unable to request irq#%d\n", IFD_MODOLE, ICAM_IRQ); 
+            kfree(p_this);          
+            return NULL;
+        }                      
+                
+        icam_scd_set_state(p_this, IFD_FSM_DISABLE);
+    }        
+    else
+        SC_WARNING("scd : open icam scd failed, out of memory\n");   
+        
+    return p_this;
+}    
+
+
+/*------------------------------------------------------------------
+ * Func : icam_scd_close
+ *
+ * Desc : close a icam scd device
+ *
+ * Parm : p_this  : icam scd to be close
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void icam_scd_close(icam_scd* p_this)
+{
+#ifdef ISR_POLLING             
+    del_timer(&p_this->timer);      // register timer
+#else
+    free_irq(ICAM_IRQ ,p_this);    
+#endif    
+
+    kfifo_free(&p_this->rx_fifo);
+    icam_scd_set_state(p_this, IFD_FSM_DISABLE);    
+    wake_up(&p_this->wq);   
+    kfree(p_this);        
+}    
+
diff --git a/drivers/smartcard/adapter/scd_icam_priv.h b/drivers/smartcard/adapter/scd_icam_priv.h
new file mode 100644
index 00000000..e68d924
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_icam_priv.h
@@ -0,0 +1,106 @@
+/*
+ * scd_icam_priv.h - smartcard driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef __SCD_MARS_PRIV_H__
+#define __SCD_MARS_PRIV_H__
+
+#include <linux/wait.h>
+#include <linux/timer.h>
+#include <linux/spinlock.h>
+#include <linux/kfifo.h>
+#include "../core/scd.h"
+#include "../core/scd_atr.h"
+#include <asm/mach-rtk_dmp/venus_gpio.h>
+
+#define ICAM_SCD_ID          (0x4943414D)
+
+#define MISC_IRQ        3
+#define RX_RING_LENGTH  32
+#define TX_RING_LENGTH  32
+
+
+#define LOWEST_CLOCK      4500000
+#define MEDIUM_CLOCK      6750000
+#define HIGHEST_CLOCK    13500000
+
+typedef enum {    
+    IFD_FSM_UNKNOWN,
+    IFD_FSM_DISABLE,        // function disabled
+    IFD_FSM_DEACTIVATE,     // function enabled but not reset the card yet
+    IFD_FSM_RESET,          // reset the card and waiting for ATR
+    IFD_FSM_ACTIVE,         // card activated
+}IFD_FSM; 
+
+
+//#define ISR_POLLING
+
+typedef struct icam_scd_tag   icam_scd;
+
+struct icam_scd_tag
+{    
+    unsigned char       id;         // channel id       
+    IFD_FSM             fsm;        // finate state machine of ifd
+	unsigned char       card_status_change;
+    
+    // config           
+    unsigned char       cmd_vcc_polarity : 1;    
+    unsigned char       pwr_sel_polarity : 1;        
+    unsigned long       uart_ctrl;  
+    unsigned long       vcc_sel;
+    unsigned long       etu;
+    unsigned char       guard_time;
+    
+	// atr              
+	scd_atr             atr;               // current atr
+	scd_atr_info        atr_info;          // current atr
+	unsigned long       atr_timeout;
+	    
+    wait_queue_head_t   wq;
+    struct kfifo        rx_fifo;
+    spinlock_t          rx_fifo_lock;    
+    spinlock_t          lock;	
+};
+
+extern icam_scd* icam_scd_open(void);
+extern void icam_scd_close(icam_scd* p_this);
+
+extern int icam_scd_enable           (icam_scd* p_this, unsigned char on_off);       
+extern int icam_scd_set_clock        (icam_scd* p_this, unsigned long clock);
+extern int icam_scd_get_clock        (icam_scd* p_this, unsigned long* p_clock);
+
+extern int icam_scd_set_etu          (icam_scd* p_this, unsigned long etu);
+extern int icam_scd_get_etu          (icam_scd* p_this, unsigned long* p_etu);
+
+extern int icam_scd_set_vcc          (icam_scd* p_this, unsigned char on);
+extern int icam_scd_set_vcc_level    (icam_scd* p_this, SC_VCC_LVL lvl);
+extern int icam_scd_get_vcc_level    (icam_scd* p_this, SC_VCC_LVL* p_lvl);
+
+extern int icam_scd_set_convention   (icam_scd* p_this, SC_CONV conv);
+extern int icam_scd_get_convention   (icam_scd* p_this, SC_CONV* p_conv);
+
+extern int icam_scd_set_guard_interval(icam_scd* p_this, unsigned long guard_interval);
+extern int icam_scd_get_guard_interval(icam_scd* p_this, unsigned long* p_guard_interval);
+
+extern int icam_scd_set_flow_control(icam_scd* p_this, unsigned char on);
+
+extern int icam_scd_set_uart_command(icam_scd* p_this, unsigned long io_mask);
+extern int icam_scd_get_uart_command(icam_scd* p_this, unsigned long* p_io_mask);
+
+extern int icam_scd_activate         (icam_scd* p_this);         
+extern int icam_scd_deactivate       (icam_scd* p_this);         
+extern int icam_scd_reset            (icam_scd* p_this);         
+extern int icam_scd_get_atr          (icam_scd* p_this, scd_atr* p_atr);    
+extern int icam_scd_card_detect      (icam_scd* p_this);
+extern int icam_scd_get_card_status  (icam_scd* p_this);
+extern int icam_scd_poll_card_status (icam_scd* p_this);
+extern int icam_scd_xmit             (icam_scd* p_this, unsigned char* p_data, unsigned int len);    		    
+extern int icam_scd_read             (icam_scd* p_this, unsigned char* p_data, unsigned int len);
+    
+#endif //__SCD_MARS_PRIV_H__
diff --git a/drivers/smartcard/adapter/scd_mars.c b/drivers/smartcard/adapter/scd_mars.c
new file mode 100755
index 00000000..95d290c
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_mars.c
@@ -0,0 +1,563 @@
+/* -------------------------------------------------------------------------
+   scd_mars.c  scd driver for Realtek Neptune/Mars
+   -------------------------------------------------------------------------
+    Copyright (C) 2008 Kevin Wang <kevin_wang@realtek.com.tw>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+----------------------------------------------------------------------------
+Update List :
+----------------------------------------------------------------------------
+    1.0     |   20090312    |   Kevin Wang  | 1) create phase
+----------------------------------------------------------------------------*/
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/jiffies.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <asm/io.h>
+#include "scd_mars_priv.h"
+#include "scd_mars_reg.h"
+
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_platform.h>
+#include <linux/of_gpio.h>
+
+#include <linux/platform_device.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+MODULE_LICENSE("GPL");
+
+MARS_DTS_INFO_T dts_info;
+
+/*------------------------------------------------------------------
+ * Func : ops_probe
+ *
+ * Desc : probe a scd device
+ *
+ * Parm : dev
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_probe(scd_device* dev)
+{
+    mars_scd* p_scd;
+
+    if ((dev->id & 0xFFFFFFFC)!=0x12830000)
+        return -ENODEV;
+
+    p_scd = mars_scd_open((dev->id & 0x3));
+
+    if (p_scd==NULL)
+        return -ENOMEM;
+
+    scd_set_drvdata(dev, p_scd);    // attach it to the scd_device
+
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_remove
+ *
+ * Desc : this function will be invoked when a smart card device which
+ *        associated with this driver has been removed
+ *
+ * Parm : dev : smart card device to be removed
+ *
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+static
+void ops_remove(scd_device* dev)
+{
+    mars_scd_close((mars_scd*) scd_get_drvdata(dev));
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_enable
+ *
+ * Desc : enable IFD
+ *
+ * Parm : dev    : ifd device
+ *        on_off : 0      : disable IFD
+ *                 others : enable IFD
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_enable(scd_device* dev, unsigned char on_off)
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    return mars_scd_enable(p_this, on_off);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_set_param
+ *
+ * Desc : set param of IFD
+ *
+ * Parm : dev
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_set_param(
+    scd_device*             dev,
+    unsigned long           id,
+    unsigned long           val
+    )
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    int ret = SC_SUCCESS;
+
+    switch(id)
+    {
+    case SC_PARAM_VCC_LVL:
+        ret = mars_scd_set_vcc_lvl(p_this, (SC_VCC_LVL) val);
+        break;
+
+    case SC_PARAM_CLOCK:
+        ret = mars_scd_set_clock(p_this, (unsigned long) val);
+        break;
+
+    case SC_PARAM_ETU:
+        ret = mars_scd_set_etu(p_this, (unsigned long) val);
+        break;
+
+    case SC_PARAM_CONV:
+        ret = mars_scd_set_convention(p_this, (SC_CONV) val);
+        break;
+
+    case SC_PARAM_PARITY:
+        ret = mars_scd_set_parity(p_this, (unsigned char) val);
+        break;
+
+    case SC_PARAM_GUARD_INTERVAL:
+		ret = mars_scd_set_guard_interval(p_this, val);
+        // do nothing
+        break;
+    case SC_PARAM_BWI:
+		ret = mars_scd_set_bwi(p_this, val);
+		break;
+
+    case SC_PARAM_CWI:
+		ret = mars_scd_set_cwi(p_this, val);
+		break;
+
+    default:
+        ret = SC_FAIL;
+    }
+
+    return ret;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_get_param
+ *
+ * Desc : get param of IFD
+ *
+ * Parm : dev
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_get_param(
+    scd_device*             dev,
+    unsigned long           id,
+    unsigned long*          p_val
+    )
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    int ret = SC_SUCCESS;
+
+    switch(id)
+    {
+    case SC_PARAM_VCC_LVL:
+        ret = mars_scd_get_vcc_lvl(p_this, (SC_VCC_LVL*) p_val);
+        break;
+
+    case SC_PARAM_CLOCK:
+        ret = mars_scd_get_clock(p_this,  p_val);
+        break;
+
+    case SC_PARAM_ETU:
+        ret = mars_scd_get_etu(p_this, p_val);
+        break;
+
+    case SC_PARAM_CONV:
+        ret = mars_scd_get_convention(p_this, (SC_CONV*) p_val);
+        break;
+
+    case SC_PARAM_PARITY:
+        ret = mars_scd_get_parity(p_this, (SC_PARITY*) p_val);
+        break;
+
+    case SC_PARAM_GUARD_INTERVAL:
+        //*p_val = 2;
+        ret = mars_scd_get_guard_interval(p_this, p_val);
+        break;
+      case SC_PARAM_BWI:
+		ret = mars_scd_get_bwi(p_this, p_val);
+		break;
+
+    case SC_PARAM_CWI:
+		ret = mars_scd_get_cwi(p_this, p_val);
+		break;
+
+    default:
+        ret = SC_FAIL;
+    }
+
+    return ret;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_activate
+ *
+ * Desc : activate ICC via reset procedure
+ *
+ * Parm : dev
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_activate(scd_device* dev)
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    return mars_scd_activate(p_this);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_deactivate
+ *
+ * Desc : deactivate icc
+ *
+ * Parm : dev
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_deactivate(scd_device* dev)
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    return mars_scd_deactivate(p_this);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_reset
+ *
+ * Desc : reset a scd device
+ *
+ * Parm : dev
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_reset(scd_device* dev)
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    return mars_scd_reset(p_this);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_get_atr
+ *
+ * Desc : get atr from a scd device
+ *
+ * Parm : dev
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_get_atr(scd_device* dev, scd_atr* p_atr)
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    return mars_scd_get_atr(p_this, p_atr);
+}
+
+
+/*------------------------------------------------------------------
+ * Func : ops_get_card_status
+ *
+ * Desc : get card status of IFD
+ *
+ * Parm : dev
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_get_card_status(scd_device* dev)
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    return mars_scd_get_card_status(p_this);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_poll_card_status
+ *
+ * Desc : poll card status
+ *
+ * Parm : dev  :
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_poll_card_status(scd_device* dev)
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    return mars_scd_poll_card_status(p_this);
+}
+
+
+/*------------------------------------------------------------------
+ * Func : ops_xmit
+ *
+ * Desc : xmit data via smart card bus
+ *
+ * Parm : dev  :
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_xmit(scd_device* dev, unsigned char* p_data, unsigned int len)
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    return mars_scd_xmit(p_this, p_data, len);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : ops_read
+ *
+ * Desc : read data via smart card bus
+ *
+ * Parm : dev  :
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+static
+int ops_read(scd_device* dev, unsigned char* p_data, unsigned int len)
+{
+    mars_scd* p_this = (mars_scd*) scd_get_drvdata(dev);
+    return mars_scd_read(p_this, p_data, len);
+}
+
+
+static scd_device mars_scd_controller[2] =
+{
+    {
+        .id   = ID_MARS_SCD(0),
+        .name = "mars_scd_0"
+    },
+    {
+        .id   = ID_MARS_SCD(1),
+        .name = "mars_scd_1"
+    },
+};
+
+
+static scd_driver mars_scd_driver =
+{
+    .name               = "mars_scd",
+    .probe              = ops_probe,
+    .remove             = ops_remove,
+    .suspend            = NULL,
+    .resume             = NULL,
+    .enable             = ops_enable,
+    .set_param          = ops_set_param,
+    .get_param          = ops_get_param,
+    .activate           = ops_activate,
+    .deactivate         = ops_deactivate,
+    .reset              = ops_reset,
+    .get_atr            = ops_get_atr,
+    .get_card_status    = ops_get_card_status,
+    .poll_card_status   = ops_poll_card_status,
+    .xmit               = ops_xmit,
+    .read               = ops_read,
+};
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_module_init
+ *
+ * Desc : init mars smart card interface driver
+ *
+ * Parm : N/A
+ *
+ * Retn : 0 : success, others fail
+ *------------------------------------------------------------------*/
+static int mars_scd_module_init(void)
+{
+    SC_INFO("mars scd module init\n");
+
+    if (register_scd_driver(&mars_scd_driver)!=0)
+        return -EFAULT;
+
+    register_scd_device(&mars_scd_controller[0]);          // register scd device
+    //register_scd_device(&mars_scd_controller[1]);          // register scd device
+
+    return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_module_exit
+ *
+ * Desc : uninit mars smart card interface driver
+ *
+ * Parm : N/A
+ *
+ * Retn : 0 : success, others fail
+ *------------------------------------------------------------------*/
+static void mars_scd_module_exit(void)
+{
+    SC_INFO("mars scd module init\n");
+
+    unregister_scd_device(&mars_scd_controller[0]);
+    //unregister_scd_device(&mars_scd_controller[1]);
+    unregister_scd_driver(&mars_scd_driver);
+}
+
+static int rtk_smc_probe(struct platform_device *pdev)
+{
+    struct clk *div_clk = NULL;
+    struct device_node *ls_ic_node;
+    unsigned int val = 0;
+
+    memset(&dts_info, 0, sizeof(dts_info));
+
+    dts_info.misc = of_iomap(pdev->dev.of_node, 0);
+    if (!dts_info.misc) {
+        printk(KERN_ERR "gpio iomap fail.\n");
+        return -EINVAL;
+    }
+
+    dts_info.base = of_iomap(pdev->dev.of_node, 1);
+    if (!dts_info.base) {
+        printk(KERN_ERR "base iomap fail.\n");
+        return -EINVAL;
+    }
+
+    dts_info.irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+    if (dts_info.irq < 0) {
+        printk(KERN_ERR "smc no irq.\n");
+        return -EINVAL;
+    }
+
+    if(of_property_read_u32(pdev->dev.of_node, "smc-num", &dts_info.id)){
+        printk(KERN_ERR "Get SMC ID fail.\n");
+        return -EINVAL;
+    }
+
+    div_clk = of_clk_get_by_name(pdev->dev.of_node, "clk_en_misc_sc");
+    if(div_clk != NULL){
+        printk(KERN_ERR "clk_prepare_enable(div_clk)....\n");
+        clk_prepare_enable(div_clk);
+    }
+
+    dts_info.clk = clk_get(&pdev->dev, NULL);
+    if (IS_ERR(dts_info.clk)){
+        dev_err(&pdev->dev, "could not get clk\n");
+	    return -EINVAL;
+    }
+
+    dts_info.rstc = reset_control_get(&pdev->dev, NULL);
+    if (IS_ERR_OR_NULL(dts_info.rstc)) {
+        dev_err(&pdev->dev, "could not get reset_control\n");
+	    return -EINVAL;
+    }
+
+    /* Get gpio config */
+    ls_ic_node = of_get_child_by_name(pdev->dev.of_node, "lsic_control");
+    if (!ls_ic_node) {
+        dev_err(&pdev->dev, "could not find [ls_ic_node] sub-node\n");
+        return -EINVAL;
+    }
+
+    if (!of_property_read_u32(ls_ic_node, "cmd_vcc_en", &val))
+        dts_info.cmd_vcc_en = val;
+    if (!of_property_read_u32(ls_ic_node, "cmd_vcc_polarity", &val))
+        dts_info.cmd_vcc_polarity = val;
+
+    dts_info.pin_cmd_vcc = of_get_named_gpio(ls_ic_node, "pin_cmd_vcc", 0);
+
+    if (!of_property_read_u32(ls_ic_node, "pwr_sel_en", &val))
+        dts_info.pwr_sel_en = val;
+    if (!of_property_read_u32(ls_ic_node, "pwr_sel_polarity", &val))
+        dts_info.pwr_sel_polarity = val;
+
+    dts_info.pin_cmd_vcc = of_get_named_gpio(ls_ic_node, "pin_cmd_vcc", 0);
+    dts_info.pin_pwr_sel = of_get_named_gpio(ls_ic_node, "pin_pwr_sel", 0);
+
+    if(mars_scd_module_init() != 0){
+        printk(KERN_ERR "register driver fail.\n");
+        return -EINVAL;
+    }
+
+    return 0;
+}
+
+static int rtk_smc_remove(struct platform_device *pdev)
+{
+    mars_scd_module_exit();
+
+    return 0;
+}
+
+/* Match table for of_platform binding */
+static const struct of_device_id rtk_smc_of_match[] = {
+    { .compatible = "Realtek,rtk-smc", },
+    {},
+};
+MODULE_DEVICE_TABLE(of, rtk_smc_of_match);
+
+static struct platform_driver rtk_smc_driver = {
+    .probe          = rtk_smc_probe,
+    .remove         = rtk_smc_remove,
+    .driver         = {
+        .name   = "rtk_smc",
+        .owner  = THIS_MODULE,
+
+        .of_match_table = of_match_ptr(rtk_smc_of_match),
+    },
+};
+module_platform_driver(rtk_smc_driver);
+
+MODULE_DESCRIPTION("Realtek Smart Card Driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtk_smc");
diff --git a/drivers/smartcard/adapter/scd_mars_priv.c b/drivers/smartcard/adapter/scd_mars_priv.c
new file mode 100755
index 00000000..8e3bdd4
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_mars_priv.c
@@ -0,0 +1,1764 @@
+/* -------------------------------------------------------------------------
+   scd_mars.c  scd driver for Realtek Neptune/Mars
+   -------------------------------------------------------------------------
+    Copyright (C) 2008 Kevin Wang <kevin_wang@realtek.com.tw>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+----------------------------------------------------------------------------
+Update List :
+----------------------------------------------------------------------------
+    1.0     |   20090312    |   Kevin Wang  | 1) create phase
+----------------------------------------------------------------------------*/
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/jiffies.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <asm/io.h>
+#include "scd_mars_priv.h"
+#include "scd_mars_reg.h"
+
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_platform.h>
+#include <linux/of_gpio.h>
+
+#include <linux/platform_device.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+
+
+MODULE_LICENSE("GPL");
+
+extern MARS_DTS_INFO_T dts_info;
+
+#define SA_SHIRQ IRQF_SHARED
+
+/* Basic operation */
+
+#if 1
+
+#define rtd_inb(offset)             (*(volatile unsigned char  *)(offset))
+#define rtd_inw(offset)             (*(volatile unsigned short *)(offset))
+#define rtd_inl(offset)             readl(offset)
+#define rtd_outb(offset,val)        (*(volatile unsigned char  *)(offset) = val)
+#define rtd_outw(offset,val)        (*(volatile unsigned short *)(offset) = val)
+#define rtd_outl(offset,val)        writel(val, offset)
+
+#else
+
+#define rtd_inb(offset)             (*(volatile unsigned char  *)(offset))
+#define rtd_inw(offset)             (*(volatile unsigned short *)(offset))
+#define rtd_inl(offset)             (*(volatile unsigned long  *)(offset))
+#define rtd_outb(offset,val)        do { (*(volatile unsigned char  *)(offset) = val); printk("  @write reg=%08x, val=%08x\n", offset, (unsigned long) val); }while(0)
+#define rtd_outw(offset,val)        do { (*(volatile unsigned short *)(offset) = val); printk("  @write reg=%08x, val=%08x\n", offset, (unsigned long) val); }while(0)
+#define rtd_outl(offset,val)        do { (*(volatile unsigned long  *)(offset) = val); printk("  @write reg=%08x, val=%08x\n", offset, (unsigned long) val); }while(0)
+
+#endif
+
+#define DBG_CHAR(x)                 rtd_outl(0xb8007800, x)
+
+
+static const unsigned long          SC_BASE[]={SC_BASE0};
+static const unsigned long          MIS_SC_ISR[]={MIS_SC0_INT};
+
+#define SET_MIS_ISR(misc, val)      rtd_outl(misc, val)
+#define SET_SCFP(base, val)         rtd_outl(base + SCFP,    val)
+#define SET_SCCR(base, val)         rtd_outl(base + SCCR,    val)
+#define SET_SCPCR(base, val)        rtd_outl(base + SCPCR,   val)
+#define SET_SC_TXFIFO(base, val)    rtd_outl(base + SCTXFIFO,val)
+#define SET_SCFCR(base, val)        rtd_outl(base + SCFCR,   val)
+#define SET_SCIRSR(base, val)       rtd_outl(base + SCIRSR,  val)
+#define SET_SCIRER(base, val)       rtd_outl(base + SCIRER,  val)
+
+
+#define GET_MIS_ISR(misc)           rtd_inl(misc)
+#define GET_SCFP(base)              rtd_inl(base + SCFP)
+#define GET_SCCR(base)              rtd_inl(base + SCCR)
+#define GET_SCPCR(base)             rtd_inl(base + SCPCR)
+#define GET_SC_TXLENR(base)         rtd_inl(base + SCTXLENR)
+#define GET_SC_RXFIFO(base)         rtd_inl(base + SCRXFIFO)
+#define GET_SC_RXLENR(base)         rtd_inl(base + SCRXLENR)
+#define GET_SCFCR(base)             rtd_inl(base + SCFCR)
+#define GET_SCIRSR(base)            rtd_inl(base + SCIRSR)
+#define GET_SCIRER(base)            rtd_inl(base + SCIRER)
+
+#define MAX_SC_CLK                   8000000
+#define MIN_SC_CLK                   1000000
+
+#define TX_RX_DEPTH			40
+
+#ifdef ISR_POLLING
+#define ISR_POLLING_INTERVAL        (HZ)
+static void mars_scd_timer(unsigned long arg);
+#endif
+
+extern char *parse_token(const char *parsed_string, const char *token);
+
+/// clk/etu to lookup table
+#define ENABLE_CLK_ETU_LOOKUP_TABLE
+
+#if defined(ENABLE_CLK_ETU_LOOKUP_TABLE)
+typedef enum {
+    SC_CLK_9000000 = 0,
+    SC_CLK_4500000,
+
+    // add new supported clk above.
+    SC_CLK_LIST_MAX
+}SC_CLK_LIST_e;
+
+//based on 7816-3 TA1, F/D
+// It dosn't means driver support etu setting if enable these etu eum....
+typedef enum {
+    //SC_ETU_8,
+    //SC_ETU_12,
+    SC_ETU_16,
+    //SC_ETU_24,
+    SC_ETU_31,
+    SC_ETU_32,
+    //SC_ETU_48,
+    //SC_ETU_62,
+    //SC_ETU_64,
+    //SC_ETU_93,
+    //SC_ETU_96,
+    //SC_ETU_128,
+    //SC_ETU_186,
+    //SC_ETU_192,
+    //SC_ETU_256,
+    //SC_ETU_279,
+    SC_ETU_372,
+    //SC_ETU_384,
+    //SC_ETU_465,
+    //SC_ETU_512,
+    //SC_ETU_558,
+    //SC_ETU_744,
+    //SC_ETU_768,
+    //SC_ETU_930,
+    //SC_ETU_1024,
+    //SC_ETU_1116,
+    //SC_ETU_1488,
+    //SC_ETU_1536,
+    //SC_ETU_1860,
+    //SC_ETU_2048,
+
+    // add new supported etu above.
+    SC_ETU_LIST_MAX,
+}SC_ETU_LIST_e;
+
+typedef enum
+{
+    MAR_SCD_BAUDDIV2_31 = 31,  // HW IP dependent
+    MAR_SCD_BAUDDIV2_32 = 32,
+    MAR_SCD_BAUDDIV2_39 = 39,
+
+    MAR_SCD_BAUDDIV2_UNSUPPORTED = 0xFF,
+} MAR_SCD_BAUDDIV2_LIST_e;
+
+typedef struct
+{
+    unsigned char           pre_clock_div;      // pre_clock divider
+    unsigned char           clock_div;          // clock divider
+    unsigned char           baud_div1;
+    MAR_SCD_BAUDDIV2_LIST_e e_baud_div2;
+}MAR_SCD_ETU_t;
+
+typedef struct
+{
+    MAR_SCD_ETU_t           etu_list[SC_ETU_LIST_MAX];
+}MAR_SCD_CLK_LIST_t;
+
+#define GET_BAUDDIV2_HW_VALUE(x, e)  \
+    do { \
+        switch((e)) \
+        { \
+        case MAR_SCD_BAUDDIV2_31: (x) = 0x0; break; \
+        case MAR_SCD_BAUDDIV2_32: (x) = 0x1; break; \
+        case MAR_SCD_BAUDDIV2_39: (x) = 0x10; break; \
+        default: SC_WARNING("unsupported BD2 (%d)\n", (e) ); \
+        } \
+    } while(0)
+
+static MAR_SCD_CLK_LIST_t clk_info[] =
+{
+    [SC_CLK_9000000] = {
+        .etu_list = {
+            [SC_ETU_16]   = {.pre_clock_div= 0, .clock_div= 0, .baud_div1= 0, .e_baud_div2=MAR_SCD_BAUDDIV2_UNSUPPORTED},
+            [SC_ETU_31]   = {.pre_clock_div= 3, .clock_div= 1, .baud_div1= 1, .e_baud_div2=MAR_SCD_BAUDDIV2_31},
+            [SC_ETU_32]   = {.pre_clock_div= 3, .clock_div= 1, .baud_div1= 1, .e_baud_div2=MAR_SCD_BAUDDIV2_32},
+            [SC_ETU_372]  = {.pre_clock_div= 3, .clock_div= 1, .baud_div1=12, .e_baud_div2=MAR_SCD_BAUDDIV2_31},
+        },
+    },
+    [SC_CLK_4500000] = {
+        .etu_list = {
+            [SC_ETU_16]   = {.pre_clock_div= 3, .clock_div= 2, .baud_div1= 1, .e_baud_div2=MAR_SCD_BAUDDIV2_32},
+            [SC_ETU_31]   = {.pre_clock_div= 6, .clock_div= 1, .baud_div1= 1, .e_baud_div2=MAR_SCD_BAUDDIV2_31},
+            [SC_ETU_32]   = {.pre_clock_div= 6, .clock_div= 1, .baud_div1= 1, .e_baud_div2=MAR_SCD_BAUDDIV2_32},
+            [SC_ETU_372]  = {.pre_clock_div= 6, .clock_div= 1, .baud_div1=12, .e_baud_div2=MAR_SCD_BAUDDIV2_31},
+        },
+    },
+};
+
+static int mars_scd_set_clock_by_table(mars_scd* p_this, unsigned long clk)
+{
+    unsigned long val;
+    unsigned long bd2 = 0;
+    SC_ETU_LIST_e eETU;
+    MAR_SCD_ETU_t *pCurETU = NULL;
+
+    mars_scd_get_etu(p_this, &val);
+    switch(val)
+    {
+    case 16:    eETU = SC_ETU_16;    break;
+    case 31:    eETU = SC_ETU_31;    break;
+    case 32:    eETU = SC_ETU_32;    break;
+    case 372:
+    default:    // default to 372
+        eETU = SC_ETU_372;
+        break;
+    }
+
+    switch(clk)
+    {
+    case 9000000:
+        pCurETU = &(clk_info[SC_CLK_9000000].etu_list[eETU]);
+        break;
+    case 4500000:
+        pCurETU = &(clk_info[SC_CLK_4500000].etu_list[eETU]);
+        break;
+    default:
+        SC_WARNING("Unsupported sc_clk(%lu)\n", clk);
+        return -1;
+    }
+
+    // make sure whether this etu is supported....
+    if(MAR_SCD_BAUDDIV2_UNSUPPORTED == pCurETU->e_baud_div2)
+    {
+        SC_WARNING("Unsupported sc_clk for etu=%lu\n", val);
+        return -1;
+    }
+
+    p_this->pre_clock_div = pCurETU->pre_clock_div;
+    p_this->clock_div     = pCurETU->clock_div;
+    p_this->baud_div1     = pCurETU->baud_div1;
+    p_this->baud_div2     = pCurETU->e_baud_div2;
+    GET_BAUDDIV2_HW_VALUE(bd2, pCurETU->e_baud_div2);
+
+    val = GET_SCFP(p_this->base) & ~SC_PRE_CLKDIV_MASK & ~SC_CLKDIV_MASK & ~SC_BAUDDIV_MASK;
+    val |= ( SC_PRE_CLKDIV((p_this->pre_clock_div-1)) |
+             SC_CLKDIV((p_this->clock_div-1)) |
+             SC_BAUDDIV2(bd2) |
+             SC_BAUDDIV1((p_this->baud_div1-1)) );
+
+
+    SC_INFO("clk(%lu), (0x%08x)->(0x%08lx), (%d, %d, %lu, %lu)\n",
+        clk, GET_SCFP(p_this->base), val,
+        p_this->pre_clock_div, p_this->clock_div, p_this->baud_div1, p_this->baud_div2);
+    SET_SCFP(p_this->base, val);
+    return 0;
+}
+
+static int mars_scd_set_etu_by_table(mars_scd* p_this, unsigned long etu)
+{
+    unsigned long clk;
+    unsigned long val;
+    unsigned long bd2 = 0;
+    MAR_SCD_CLK_LIST_t *pCurClk = NULL;
+    MAR_SCD_ETU_t      *pCurETU = NULL;
+
+    mars_scd_get_clock(p_this, &clk);
+    switch(clk)
+    {
+    case 9000000:
+        pCurClk = &(clk_info[SC_CLK_9000000]);
+        break;
+    case 4500000:
+        pCurClk = &(clk_info[SC_CLK_4500000]);
+        break;
+    default:
+        SC_WARNING("unsupported clk(%lu)\n", clk);
+        return -1;
+    }
+
+    switch(etu)
+    {
+    case 372:
+        pCurETU = &(pCurClk->etu_list[SC_ETU_372]);
+        break;
+    case 32:
+        pCurETU = &(pCurClk->etu_list[SC_ETU_32]);
+        break;
+    case 31:
+        pCurETU = &(pCurClk->etu_list[SC_ETU_31]);
+        break;
+    case 16:
+        pCurETU = &(pCurClk->etu_list[SC_ETU_16]);
+        break;
+    default:
+        SC_WARNING("unsupported etu(%lu)\n", etu);
+        return -2;
+    }
+
+    p_this->pre_clock_div = pCurETU->pre_clock_div;
+    p_this->clock_div     = pCurETU->clock_div;
+    p_this->baud_div1     = pCurETU->baud_div1;
+    p_this->baud_div2     = pCurETU->e_baud_div2;
+    GET_BAUDDIV2_HW_VALUE(bd2, pCurETU->e_baud_div2);
+
+    val = GET_SCFP(p_this->base) & ~SC_PRE_CLKDIV_MASK & ~SC_CLKDIV_MASK & ~SC_BAUDDIV_MASK;
+    val |= ( SC_PRE_CLKDIV((p_this->pre_clock_div-1)) |
+             SC_CLKDIV((p_this->clock_div-1)) |
+             SC_BAUDDIV2(bd2) |
+             SC_BAUDDIV1((p_this->baud_div1-1)) );
+
+    SC_INFO("etu(%lu), (0x%08x)->(0x%08lx), (%d, %d, %lu, %lu)\n",
+        etu, GET_SCFP(p_this->base), val,
+        p_this->pre_clock_div, p_this->clock_div, p_this->baud_div1, p_this->baud_div2);
+
+    SET_SCFP(p_this->base, val);
+
+    return 0;
+}
+#endif //ENABLE_CLK_ETU_LOOKUP_TABLE
+/*------------------------------------------------------------------
+ * Func : mars_scd_power_enable
+ *
+ * Desc : enable power for SMC
+ *
+ * Parm : p_this : handle of mars smartcard ifd
+ *        on     : enable / disable power
+ *
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+#define MARS_SCD_POWER_ENABLE(_p, _on) \
+    do { \
+        SC_INFO("power enable to (%d) @ %d\n", (_on), __LINE__); \
+        mars_scd_power_enable( (_p), (_on) ); \
+    } while(0)
+
+void mars_scd_power_enable(
+    mars_scd*               p_this,
+    unsigned char           on
+    )
+{
+    unsigned char val = (on) ? ((p_this->cmd_vcc_polarity) ? 1 :0) : ((p_this->cmd_vcc_polarity) ? 0 :1);
+
+    if (p_this->cmd_vcc_en)
+    {
+        //SC_INFO("SC%d - power enable=%d, %s_GPIO[%d]=%d\n",
+        //p_this->id, on, gpio_type(p_this->pin_cmd_vcc), gpio_idx(p_this->pin_cmd_vcc), val);
+     	gpio_direction_output(p_this->pin_cmd_vcc, val);
+    }
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_power_select
+ *
+ * Desc : enable power select for SMC
+ *
+ * Parm : p_this : handle of mars smartcard ifd
+ *        on     : enable / disable power select pin
+ *
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void mars_scd_power_select(
+    mars_scd*               p_this,
+    unsigned char           on
+    )
+{
+    unsigned char val = (on) ? ((p_this->pwr_sel_polarity) ? 1 :0) : ((p_this->pwr_sel_polarity) ? 0 :1);
+
+    if (p_this->pwr_sel_en)
+    {
+        //SC_INFO("SC%d - power select=%d, %s_GPIO[%d]=%d\n",
+        //p_this->id, on, gpio_type(p_this->pin_pwr_sel), gpio_idx(p_this->pin_pwr_sel), val);
+        gpio_direction_output(p_this->pin_pwr_sel, val);
+    }
+}
+
+#define MARS_SCD_SET_STATE(_p, _state, _ret) \
+        do { \
+            SC_INFO("FSM=%d enter @ %d\n", (_state), __LINE__); \
+            (_ret) = mars_scd_set_state((_p), (_state)); \
+            SC_INFO("FSM=%d done\n", (_state)); \
+        } while(0)
+/*------------------------------------------------------------------
+ * Func : mars_scd_set_state
+ *
+ * Desc :
+ *
+ * Parm : p_this : handle of mars smartcard ifd
+ *
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+int mars_scd_set_state(mars_scd *p_this, IFD_FSM fsm)
+{
+    void __iomem *base = p_this->base;
+    unsigned char id = p_this->id;
+    int ret = 0;
+    if (p_this->fsm == fsm)
+        return 0;
+
+    switch(fsm)
+    {
+    case IFD_FSM_DISABLE:
+
+        SC_INFO("SC%d - FSM = DISABLE\n", id);
+
+        SET_SCFP(base, SC_CLK_EN(0)    |
+                        SC_CLKDIV((p_this->clock_div-1))|
+                        SC_BAUDDIV2(0)  |                    // fixed to 31
+                        SC_BAUDDIV1((p_this->baud_div1-1))|
+                        SC_PRE_CLKDIV((p_this->pre_clock_div-1)));
+
+        SET_SCPCR(base, SC_TXGRDT(2)    |
+                        SC_CWI(0)       |
+                        SC_BWI(0)       |
+                        SC_WWI(0)       |
+                        SC_BGT(0x16)    |
+                        SC_EDC_EN(0)    |
+                        SC_CRC(0)       |
+                        SC_PROTOCOL_T(0)|
+                        SC_T0RTY(0)     |
+                        SC_T0RTY_CNT(0));
+
+        SET_SCCR  (base, SC_FIFO_RST(1) | SC_SCEN(0) | SC_AUTO_ATR(1) | SC_CONV(0) | SC_PS(p_this->parity));
+        SET_SCIRER(base, 0);                  // Disable ISR
+        SET_SCIRSR(base, 0xFFFFFFFF);
+        MARS_SCD_POWER_ENABLE(p_this, 0);
+        p_this->atr.length = -1;
+        break;
+
+    case IFD_FSM_DEACTIVATE:
+        SC_INFO("SC%d - FSM = IDEL\n", id);
+        // - begin - add to fix Nagxx ICC Test 11 - Paired 5040.2 deactivate with extra clk issue
+        //MARS_SCD_POWER_ENABLE(p_this, 0);
+        udelay(100);
+        // - end - add to fix Nagxx ICC Test 11 - Paired 5040.2 deactivate with extra clk issue
+        mars_scd_set_etu(p_this, 372);
+        mars_scd_set_parity(p_this, 1);
+
+        SET_SCFP(base, SC_CLK_EN(1) |
+                       SC_CLKDIV((p_this->clock_div-1))|
+                       SC_BAUDDIV2(0) |                    // fixed to 31
+                       SC_BAUDDIV1((p_this->baud_div1-1))|
+                       SC_PRE_CLKDIV((p_this->pre_clock_div-1)));
+
+        SET_SCCR(base, SC_FIFO_RST(0) | SC_SCEN(0) | SC_AUTO_ATR(1) | SC_CONV(0) |SC_PS(p_this->parity));
+        udelay(1000);
+        SET_SCCR(base, SC_FIFO_RST(0) | SC_SCEN(1) | SC_AUTO_ATR(1) | SC_CONV(0) |SC_PS(p_this->parity) | (1<<19));
+        SET_SCIRER(base, SC_CPRES_INT);
+        SET_SCIRSR(base, 0xFFFFFFFF);
+        MARS_SCD_POWER_ENABLE(p_this, 0);
+        p_this->atr.length = -1;
+        kfifo_reset(&p_this->rx_fifo);
+#if 0
+        SC_INFO("SC%d - FSM = IDEL\n", id);
+        mars_scd_set_etu(p_this, 372);
+        mars_scd_set_parity(p_this, 1);
+
+        SET_SCCR  (base, SC_FIFO_RST(0) | SC_SCEN(1) | SC_AUTO_ATR(1) | SC_CONV(0) |SC_PS(p_this->parity));
+        SET_SCIRER(base, SC_CPRES_INT);
+        SET_SCIRSR(base, 0xFFFFFFFF);
+        MARS_SCD_POWER_ENABLE(p_this, 0);
+        p_this->atr.length = -1;
+        kfifo_reset(&p_this->rx_fifo);
+#endif
+        break;
+
+    case IFD_FSM_RESET:
+
+        p_this->atr.length = -1;
+
+        if (!mars_scd_card_detect(p_this))
+        {
+            SC_WARNING("SC%d - RESET mars scd failed, no ICC exist\n", id);
+            MARS_SCD_SET_STATE(p_this, IFD_FSM_DEACTIVATE, ret);
+            return SC_ERR_NO_ICC;
+        }
+
+        mars_scd_power_select(p_this, p_this->vcc_5v);
+        MARS_SCD_POWER_ENABLE(p_this, 1);   // Power On
+        udelay(1000);
+        mars_scd_set_etu(p_this, 372);
+        mars_scd_set_parity(p_this, 1);
+        kfifo_reset(&p_this->rx_fifo);
+
+        SET_SCIRER(base, SC_CPRES_INT    |
+                        SC_ATRS_INT     |
+                        SC_RXP_INT      |
+                        SC_RCV_INT      |
+                        SC_RX_FOVER_INT);
+
+        SET_SCCR  (base, 0);
+
+        SET_SCCR  (base, SC_FIFO_RST(1)  |        // pull reset pin
+                        SC_RST(1)       |
+                        SC_SCEN(1)      |
+                        SC_AUTO_ATR(1)  |
+                        SC_CONV(0)      |
+                        SC_PS(p_this->parity));
+
+        p_this->atr_timeout = jiffies + HZ;
+
+        SC_INFO("SC%d - FSM = RESET & ATR\n", id);
+
+        break;
+
+    case IFD_FSM_ACTIVE:
+        SC_INFO("SC%d - FSM = ACTIVATE\n", id);
+
+        SET_SCIRER(base, SC_CPRES_INT    |
+                        SC_ATRS_INT     |
+                        SC_RXP_INT      |
+                        SC_RCV_INT      |
+                        SC_RX_FOVER_INT);
+        break;
+
+    default:
+    case IFD_FSM_UNKNOWN:
+        break;
+    }
+
+    p_this->fsm = fsm;
+
+    p_this->card_status_change = 1;
+    wake_up(&p_this->wq);
+
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_fsm_reset
+ *
+ * Desc :
+ *
+ * Parm : p_this : handle of mars cec
+ *
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void mars_scd_fsm_reset(mars_scd* p_this)
+{
+    unsigned long event  = GET_SCIRSR(p_this->base);
+    unsigned long rx_len = 0;
+    unsigned long i      = 0;
+    int ret = 0;
+    SC_INT_DBG("mars_scd_fsm_reset : SC_RISR=%08lx\n", event);
+
+    if ((event & SC_RXP_INT) || !(event & SC_PRES)|| time_after(jiffies, p_this->atr_timeout))
+        goto err_atr_failed;
+
+    if (event & SC_ATRS_INT)
+    {
+        SC_INT_DBG("mars_scd_fsm_reset : Got ATR INT, reset ATR buffer\n");
+
+        if (p_this->atr.length== -1)
+            p_this->atr.length = 0;         // got ATR
+    }
+
+    if (event & SC_RCV_INT)
+    {
+        SC_INT_DBG("mars_scd_fsm_reset : Got RCV INT, p_this->atr.length==%d, rx_len=%d\n", p_this->atr.length, GET_SC_RXLENR(p_this->base));
+
+        if (p_this->atr.length<0)
+        {
+            // unwanted data, drop it
+            rx_len = GET_SC_RXLENR(p_this->base);
+
+            for (i=0; i<rx_len; i++)
+                GET_SC_RXFIFO(p_this->base);
+
+            goto end_proc;
+        }
+
+        // receive atr :
+        while(GET_SC_RXLENR(p_this->base))
+        {
+            if (p_this->atr.length >= MAX_ATR_SIZE)
+                goto err_atr_failed;
+
+            p_this->atr.data[p_this->atr.length] = GET_SC_RXFIFO(p_this->base);
+
+            if (p_this->atr.length==0)
+            {
+                switch(p_this->atr.data[0])
+                {
+                case 0x3B:
+                    SC_INFO("SC%d - Direct Convention (%02x)\n", p_this->id, p_this->atr.data[0]);
+                    break;
+
+                case 0x03:
+                     p_this->atr.data[0] = 0x3F;
+                     SC_INFO("SC%d - Inverse Convention (%02x)\n", p_this->id, p_this->atr.data[0]);
+                     break;
+
+                default:
+                    SC_WARNING("SC%d - unknown TS (%02x)\n", p_this->id, p_this->atr.data[0]);
+                    break;
+                }
+            }
+
+            p_this->atr.length++;
+
+	     //wake_up(&p_this->wq);  //ATR do not use wq
+        }
+
+        SC_INT_DBG("mars_scd_fsm_reset : p_this->atr.length=%d\n", p_this->atr.length);
+
+        // check atr
+        if (is_atr_complete(&p_this->atr))
+        {
+            SC_INFO("SC%d - Got ATR Completed\n", p_this->id);
+
+            if (decompress_atr(&p_this->atr, &p_this->atr_info)<0)
+                goto err_atr_failed;
+
+            MARS_SCD_SET_STATE(p_this, IFD_FSM_ACTIVE, ret);       // jump to active state
+        }
+    }
+
+end_proc:
+    SET_SCIRSR(p_this->base, event);
+    return;
+
+err_atr_failed:
+
+    if (!(event & SC_PRES))
+    {
+        SC_WARNING("SC%d - RESET ICC failed, no ICC detected\n", p_this->id);
+    }
+
+    if (event & SC_RXP_INT)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, RX Parity Error\n", p_this->id);
+    }
+
+    if (time_after(jiffies, p_this->atr_timeout))
+    {
+        SC_WARNING("SC%d - RESET ICC failed, timeout\n", p_this->id);
+    }
+
+    if (p_this->atr.length <0)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, wait ATR failed\n", p_this->id);
+    }
+    else if (p_this->atr.length >= MAX_ATR_SIZE)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, atr length %d more then %d\n", p_this->id, p_this->atr.length, MAX_ATR_SIZE);
+    }
+    else if (!is_atr_complete(&p_this->atr))
+    {
+        SC_WARNING("SC%d - RESET ICC failed, incomplete atr\n", p_this->id);
+    }
+    else if (decompress_atr(&p_this->atr, &p_this->atr_info)<0)
+    {
+        SC_WARNING("SC%d - RESET ICC failed, decompress atr failed\n", p_this->id);
+    }
+    else
+    {
+        SC_WARNING("SC%d - RESET ICC failed, parse protocol faield\n", p_this->id);
+    }
+
+    MARS_SCD_SET_STATE(p_this, IFD_FSM_DEACTIVATE, ret);
+    goto end_proc;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_fsm_active
+ *
+ * Desc :
+ *
+ * Parm : p_this : handle of mars cec
+ *
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void mars_scd_fsm_active(mars_scd* p_this)
+{
+    int ret;
+    unsigned long event = GET_SCIRSR(p_this->base) & GET_SCIRER(p_this->base);
+    unsigned char i;
+    unsigned char len;
+    unsigned char buff[TX_RX_DEPTH];
+
+    if (mars_scd_card_detect(p_this)==0)
+    {
+        MARS_SCD_SET_STATE(p_this, IFD_FSM_DEACTIVATE, ret);
+        goto end_proc;
+    }
+
+    if (event & SC_RCV_INT && p_this->tx_status == SC_TX_DONE)  //RX received at least one character
+   {
+	    if ((len = GET_SC_RXLENR(p_this->base)))
+	    {
+	        for (i=0; i<len; i++)
+	        {
+	            buff[i] = GET_SC_RXFIFO(p_this->base);
+	        }
+		SC_INFO("RX Receive~~  event=%lu  len=%d  buf=0x%x \n",event,len,buff[0]);
+	        if (kfifo_in_locked(&p_this->rx_fifo, buff, len, &p_this->rx_fifo_lock)<len)
+	        {
+	            SC_WARNING("mars_scd_fsm_active : fifo over flow... flush data...\n");
+	            kfifo_reset(&p_this->rx_fifo);
+	        }
+
+		  wake_up(&p_this->wq);
+	    }
+
+	    if (event & SC_RX_FOVER_INT)
+	    {
+	        SC_WARNING("Rx over flow!\n");
+	        SET_SCCR(p_this->base, GET_SCCR(p_this->base) | SC_FIFO_RST(1));
+	    }
+    }
+
+#if 1
+	if (event & SC_RCV_INT && p_this->tx_status != SC_TX_DONE)
+	{
+		SC_WARNING("RX Receive~~  event=%lu  \n",event);
+		SET_SCCR(p_this->base, GET_SCCR(p_this->base) | SC_FIFO_RST(1));
+	}
+#endif
+
+    if (event & SC_TXEMPTY_INT)
+    {
+        int tx_data_len = kfifo_len(&p_this->tx_fifo);      // get number of data to xmit
+        if (tx_data_len)
+        {
+            unsigned char tx_buff[TX_RX_DEPTH];
+
+            tx_data_len = kfifo_out(&p_this->tx_fifo, tx_buff, sizeof(tx_buff));
+
+            SC_INFO("Send %d Bytes!\n", tx_data_len);
+            for(i=0; i<tx_data_len; i++)
+                SET_SC_TXFIFO(p_this->base, tx_buff[i]);
+
+		    SET_SCCR(p_this->base, GET_SCCR(p_this->base) | SC_TX_GO(1));          // Start Xmit
+        }
+        else
+        {
+		SC_INFO("TX Done~~  \n");
+            SET_SCIRER(p_this->base, GET_SCIRER(p_this->base) & ~SC_TXEMPTY_INT);
+            p_this->tx_status = SC_TX_DONE;
+            wake_up(&p_this->wq);                               // wakeup queue
+        }
+    }
+
+end_proc:
+    SET_SCIRSR(p_this->base, event);
+}
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_work
+ *
+ * Desc : mars scd work routine
+ *
+ * Parm : p_this : handle of mars cec
+ *
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void mars_scd_work(mars_scd* p_this)
+{
+    int ret;
+    void __iomem *base = p_this->base;
+    unsigned long status = GET_SCIRSR(base) & GET_SCIRER(base);
+
+    SC_INFO("SC%d - work!!  FSM--%d  \n", p_this->id,p_this->fsm);
+
+    if (status & SC_CPRES_INT)
+    {
+        if (mars_scd_card_detect(p_this))
+        {
+            SC_INFO("SC%d - ICC detected!! fsm=%d\n", p_this->id, p_this->fsm);
+        }
+        else
+        {
+            MARS_SCD_SET_STATE(p_this, IFD_FSM_DEACTIVATE, ret);
+            SC_INFO("SC%d - ICC removed!!\n", p_this->id);
+        }
+
+        p_this->card_status_change = 1;
+        wake_up(&p_this->wq);
+    }
+
+    switch (p_this->fsm)
+    {
+    case IFD_FSM_RESET:    mars_scd_fsm_reset(p_this);  break;
+    case IFD_FSM_ACTIVE:   mars_scd_fsm_active(p_this); break;
+    default:
+        break;
+    }
+
+    SET_SCIRSR(base, status);
+}
+
+
+
+#ifdef ISR_POLLING
+/*------------------------------------------------------------------
+ * Func : mars_scd_timer
+ *
+ * Desc : timer of mars scd
+ *
+ * Parm : arg : input param
+ *
+ * Retn : IRQ_NONE, IRQ_HANDLED
+ *------------------------------------------------------------------*/
+static void mars_scd_timer(unsigned long arg)
+{
+    mars_scd* p_this = (mars_scd*) arg;
+
+    unsigned long event = GET_MIS_ISR(dts_info.misc+0xC) & MIS_SC_ISR[p_this->id];
+
+    if (event)
+        mars_scd_work(p_this);
+
+    SET_MIS_ISR(dts_info.misc+0xC, event);
+
+    mod_timer(&p_this->timer, jiffies + ISR_POLLING_INTERVAL);
+}
+
+#else
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_isr
+ *
+ * Desc : isr of mars scd
+ *
+ * Parm : p_this : handle of mars scd
+ *        dev_id : handle of the mars_scd
+ *        regs   :
+ *
+ * Retn : IRQ_NONE, IRQ_HANDLED
+ *------------------------------------------------------------------*/
+static irqreturn_t mars_scd_isr(int this_irq, void *dev_id)
+{
+   // printk(KERN_ERR "[%s]:[%s] this_irq:[%d] -- [0x%x]\n", __FILE__, __func__, this_irq, readl(dts_info.misc + 0x80));
+
+    mars_scd* p_this = (mars_scd*) dev_id;
+    unsigned long flag;
+    unsigned long event = GET_MIS_ISR(dts_info.misc+0xC) & MIS_SC_ISR[p_this->id];
+
+    spin_lock_irqsave(&p_this->lock, flag);
+
+    if (event)
+        mars_scd_work(p_this);
+
+    SC_INT_DBG("MIS ISR=%08x\n", GET_MIS_ISR(dts_info.misc+0xC));
+
+    SET_MIS_ISR(dts_info.misc+0xC, event);
+
+    spin_unlock_irqrestore(&p_this->lock, flag);
+
+    return IRQ_HANDLED;
+}
+
+
+#endif
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_enable
+ *
+ * Desc : enable mars smart card interface
+ *
+ * Parm : p_this   : handle of mars scd
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_enable(mars_scd* p_this, unsigned char on_off)
+{
+    int ret = 0;
+    if (on_off)
+    {
+        if (p_this->fsm==IFD_FSM_DISABLE)
+        {
+            MARS_SCD_SET_STATE(p_this, IFD_FSM_DEACTIVATE, ret);
+            msleep(200);   // fix bug of get card status fail on darwin platform....
+        }
+    }
+    else
+    {
+        MARS_SCD_SET_STATE(p_this, IFD_FSM_DISABLE, ret);
+    }
+    return ret;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_set_clock
+ *
+ * Desc : set clock frequency of mars smart card interface
+ *
+ * Parm : p_this   : handle of mars scd
+ *        clk      : clock (in HZ)
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_set_clock(mars_scd* p_this, unsigned long clk)
+{
+    unsigned long val;
+    unsigned long div = SYSTEM_CLK / clk / p_this->clock_div;
+
+#if defined(ENABLE_CLK_ETU_LOOKUP_TABLE)
+    if( 0 == mars_scd_set_clock_by_table(p_this, clk) ) // set ok by table!!!
+    {
+        return 0;
+    }
+    else
+    {
+        SC_WARNING("set clock by pre_clock_div only !!!\n");
+    }
+#endif // ENABLE_CLK_ETU_LOOKUP_TABLE
+
+    if (clk > MAX_SC_CLK)
+    {
+        SC_WARNING("clock %lu out of range, using minimum value to instead %lu\n", (unsigned long)clk, (unsigned long)MAX_SC_CLK);
+        clk = MAX_SC_CLK;
+    }
+
+    if (clk < MIN_SC_CLK)
+    {
+        SC_WARNING("clock %lu out of range, using minimum value to instead %lu\n", (unsigned long)clk, (unsigned long)MIN_SC_CLK);
+        clk = MIN_SC_CLK;
+    }
+
+    p_this->pre_clock_div = div;
+
+    val  = GET_SCFP(p_this->base) & ~SC_PRE_CLKDIV_MASK;
+
+    val |= SC_PRE_CLKDIV((p_this->pre_clock_div-1));  // oo add to sync clk config
+
+    SET_SCFP(p_this->base, val);
+
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_get_clock
+ *
+ * Desc : get clock frequency of mars smart card interface
+ *
+ * Parm : p_this   : handle of mars scd
+ *        p_clock  : clock (in HZ)
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_get_clock(mars_scd* p_this, unsigned long* p_clock)
+{
+    *p_clock = SYSTEM_CLK / (p_this->pre_clock_div) / (p_this->clock_div);
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_set_etu
+ *
+ * Desc : set etu of mars smart card interface
+ *
+ * Parm : p_this   : handle of mars scd
+ *        etu      : cycles
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_set_etu(mars_scd* p_this, unsigned long etu)
+{
+    unsigned long val = (etu % 31);
+    unsigned char div2 = 0;
+
+#if defined(ENABLE_CLK_ETU_LOOKUP_TABLE)
+    if( 0 == mars_scd_set_etu_by_table(p_this, etu) )
+    {
+        return 0;
+    }
+    else
+    {
+        SC_WARNING("set etu by BaudDiv1 & BaudDiv2 only !!!\n");
+    }
+#endif // ENABLE_CLK_ETU_LOOKUP_TABLE
+
+    p_this->baud_div2 = 31;
+
+    if ((etu % 39) < val)
+    {
+        div2 = 2;
+        p_this->baud_div2 = 39;
+        val = (etu % 39);
+    }
+
+    if ((etu % 32) < val)
+    {
+        div2 = 1;
+        p_this->baud_div2 = 32;
+        val = (etu % 32);
+    }
+
+    p_this->baud_div1 = etu * p_this->clock_div / p_this->baud_div2;
+    val = GET_SCFP(p_this->base) & ~SC_BAUDDIV_MASK;
+    val |= SC_BAUDDIV1((p_this->baud_div1-1)) | SC_BAUDDIV2(div2);
+
+    SC_INFO("ETU = %lu. Baud Div2=%lu, Div1 = %lu\n", etu, p_this->baud_div2 ,p_this->baud_div1);
+    SET_SCFP(p_this->base, val);
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_get_etu
+ *
+ * Desc : set etu of mars smart card interface
+ *
+ * Parm : p_this   : handle of mars scd
+ *        etu      : cycles
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_get_etu(mars_scd* p_this, unsigned long* p_etu)
+{
+    *p_etu = (p_this->baud_div2 * p_this->baud_div1) / p_this->clock_div;
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_set_parity
+ *
+ * Desc : set parity of mars smart card interface
+ *
+ * Parm : p_this   : handle of mars scd
+ *        parity   : 0 : off,  others on
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_set_parity(mars_scd* p_this, SC_PARITY parity)
+{
+    switch(parity)
+    {
+    case SC_PARITY_NONE:
+        p_this->parity = 0;
+        break;
+
+    case SC_PARITY_ODD:
+    case SC_PARITY_EVEN:
+        p_this->parity = 1;
+        break;
+    default:
+        return SC_FAIL;
+    }
+
+    if (p_this->parity)
+        SET_SCCR(p_this->base, GET_SCCR(p_this->base) | SC_PS(p_this->parity));
+    else
+        SET_SCCR(p_this->base, GET_SCCR(p_this->base) & ~SC_PS(p_this->parity));
+
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_get_parity
+ *
+ * Desc : get parity setting of mars smart card interface
+ *
+ * Parm : p_this   : handle of mars scd
+ *        p_parity   : 0 : off,  others on
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_get_parity(mars_scd* p_this, SC_PARITY* p_parity)
+{
+    *p_parity = (p_this->parity) ? SC_PARITY_EVEN : SC_PARITY_NONE;
+    return 0;
+}
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_set_bwi
+ *
+ * Desc : set Block Waiting Integer
+ *
+ * Parm : p_this   : handle of mars scd
+ *        bwi : Block Waiting Integer
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_set_bwi(mars_scd* p_this, unsigned long bwi)
+{
+	if(bwi>0xF)
+		bwi = 0xF;
+    SET_SCPCR(p_this->base, (GET_SCPCR(p_this->base) & ~SC_BWI(0xF)) | SC_BWI(bwi));
+    return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_get_bwi
+ *
+ * Desc : set Block Waiting Integer
+ *
+ * Parm : p_this : handle of mars scd
+ *        p_bwi : Block Waiting Integer
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_get_bwi(mars_scd* p_this, unsigned long* p_bwi)
+{
+    *p_bwi = (GET_SCPCR(p_this->base) >> 16) & 0x0F;
+    return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_set_cwi
+ *
+ * Desc : set Character Waiting Integer
+ *
+ * Parm : p_this   : handle of mars scd
+ *        cwi : Character Waiting Integer
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_set_cwi(mars_scd* p_this, unsigned long cwi)
+{
+	if(cwi>0xF)
+		cwi = 0xF;
+    SET_SCPCR(p_this->base, (GET_SCPCR(p_this->base) & ~SC_CWI(0xF)) | SC_CWI(cwi));
+    return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_get_cwi
+ *
+ * Desc : set Character Waiting Integer
+ *
+ * Parm : p_this : handle of mars scd
+ *        p_cwi : Character Waiting Integer
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_get_cwi(mars_scd* p_this, unsigned long* p_cwi)
+{
+    *p_cwi = (GET_SCPCR(p_this->base) >> 20) & 0x0F;
+    return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_set_guard_interval
+ *
+ * Desc : set guard interval of icam smart card interface
+ *
+ * Parm : p_this   : handle of mars scd
+ *        guard_interval : guard interval in etu
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_set_guard_interval(mars_scd* p_this, unsigned long guard_interval)
+{
+
+    if (guard_interval >= 0xFF)
+        guard_interval = 0xFE;
+/* marked for Nagra ICC
+    if (guard_interval<2)
+        guard_interval = 2;
+*/
+    SET_SCPCR(p_this->base, (GET_SCPCR(p_this->base) & ~SC_TXGRDT(0xFF)) | SC_TXGRDT(guard_interval));
+    return 0;
+}
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_get_guard_interval
+ *
+ * Desc : set guard interval
+ *
+ * Parm : p_this : handle of mars scd
+ *        p_guard_interval : guard interval output
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_get_guard_interval(mars_scd* p_this, unsigned long* p_guard_interval)
+{
+    unsigned long guard_time = (GET_SCPCR(p_this->base) >> 24) & 0xFF;
+    //marked for Nagra ICC
+	//*p_guard_interval = (guard_time<0xFF) ? guard_time : 2;
+    *p_guard_interval = guard_time;
+	return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_activate
+ *
+ * Desc : activate an ICC
+ *
+ * Parm : p_this   : handle of mars scd
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_activate(mars_scd* p_this)
+{
+    switch(p_this->fsm)
+    {
+    case IFD_FSM_DISABLE:
+        SC_WARNING("activate ICC failed, please enable IFD first\n");
+        return SC_ERR_IFD_DISABLED;
+
+    case IFD_FSM_DEACTIVATE:
+
+        if (mars_scd_reset(p_this)==0)
+        {
+            SC_INFO("activate ICC success\n");
+            return SC_SUCCESS;
+        }
+        else
+        {
+            SC_WARNING("activate ICC failed\n");
+            return SC_ERR_NO_ICC;
+        }
+        break;
+
+    case IFD_FSM_RESET:
+        SC_INFO("ICC has is reseting\n");
+        return SC_SUCCESS;
+
+    case IFD_FSM_ACTIVE:
+        SC_INFO("ICC has been activated already\n");
+        return SC_SUCCESS;
+
+    default:
+        SC_WARNING("activate ICC failed, unknown state\n");
+        return SC_FAIL;
+    }
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_deactivate
+ *
+ * Desc : deactivate an ICC
+ *
+ * Parm : p_this   : handle of mars scd
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_deactivate(mars_scd* p_this)
+{int ret;
+    if (p_this->fsm != IFD_FSM_DISABLE)
+    {
+        MARS_SCD_SET_STATE(p_this, IFD_FSM_DISABLE, ret);
+        MARS_SCD_SET_STATE(p_this, IFD_FSM_DEACTIVATE, ret);
+    }
+    return 0;
+}
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_reset
+ *
+ * Desc : reset mars smart card interface
+ *
+ * Parm : p_this   : handle of mars scd
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_reset(mars_scd* p_this)
+{
+    unsigned long t;
+int ret;
+    wait_event_interruptible_timeout(p_this->wq,  p_this->fsm == IFD_FSM_DEACTIVATE, HZ>>1);    // wait for DEACTIVATE state , otherwise reset will be failed
+
+    MARS_SCD_SET_STATE(p_this, IFD_FSM_RESET, ret);
+    if (ret)
+        return SC_FAIL;
+
+    t = jiffies + (HZ<<1);
+
+    while(!time_after(jiffies,t) && p_this->fsm == IFD_FSM_RESET){
+        //printk(KERN_ERR "...");
+        msleep(100);
+    }
+    //printk(KERN_ERR "\n");
+
+    if (p_this->fsm != IFD_FSM_ACTIVE)
+    {
+        SC_WARNING("SC%d - Reset ICC failed\n", p_this->id);
+        MARS_SCD_SET_STATE(p_this, IFD_FSM_DEACTIVATE, ret);
+        return SC_ERR_ATR_TIMEOUT;
+    }
+
+    SC_INFO("SC%d - Reset ICC Complete, atr_len=%d\n", p_this->id, p_this->atr.length);
+    return SC_SUCCESS;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_get_atr
+ *
+ * Desc : s mars smart card interface
+ *
+ * Parm : p_this   : handle of mars scd
+ *        p_atr    : atr output buffer
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_get_atr(mars_scd* p_this, scd_atr* p_atr)
+{
+    if (p_this->fsm != IFD_FSM_ACTIVE)
+    {
+        p_atr->length = -1;
+        return -1;
+    }
+
+    p_atr->length = p_this->atr.length;
+    memcpy(p_atr->data, p_this->atr.data, p_this->atr.length);
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_card_detect
+ *
+ * Desc : get card status
+ *
+ * Parm : p_this   : handle of mars scd
+ *
+ * Retn : 0 : no icc exists, others : icc exists
+ *------------------------------------------------------------------*/
+int mars_scd_card_detect(mars_scd* p_this)
+{
+    return (GET_SCIRSR(p_this->base) & SC_PRES) ? 1 : 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_get_card_status
+ *
+ * Desc : get card status
+ *
+ * Parm : p_this   : handle of mars scd
+ *
+ * Retn : 0 : no icc exists, others : icc exists
+ *------------------------------------------------------------------*/
+int mars_scd_get_card_status(mars_scd* p_this)
+{
+    switch(p_this->fsm) {
+    case IFD_FSM_DISABLE:   return SC_CARD_REMOVED;
+    case IFD_FSM_DEACTIVATE:      return mars_scd_card_detect(p_this) ? SC_CARD_DEACTIVATE : SC_CARD_REMOVED;
+    case IFD_FSM_RESET:     return SC_CARD_RESET;
+    case IFD_FSM_ACTIVE:    return SC_CARD_ACTIVATE;
+    default:                return SC_CARD_UNKNOWN;
+    }
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_poll_card_status
+ *
+ * Desc : poll card status change
+ *
+ * Parm : p_this   : handle of mars scd
+ *
+ * Retn : 0 : for success, others : fail
+ *------------------------------------------------------------------*/
+int mars_scd_poll_card_status(mars_scd* p_this)
+{
+    p_this->card_status_change = 0;
+    wait_event_interruptible(p_this->wq, p_this->card_status_change);
+    return mars_scd_get_card_status(p_this);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_xmit
+ *
+ * Desc : xmit data via smart card bus
+ *
+ * Parm : p_this   : handle of mars scd
+ *        scb      : data to be xmit
+ *
+ * Retn : SC_SUCCESS / SC_FAIL
+ *------------------------------------------------------------------*/
+int mars_scd_xmit(mars_scd* p_this, unsigned char* p_data, unsigned int len)
+{
+
+    unsigned char id = p_this->id;
+    void __iomem *base = p_this->base;
+    unsigned char tx_buff[TX_RX_DEPTH];
+    unsigned char tx_data_len;
+    int i;
+    SC_WARNING("0x%08x:0x%08x:0x%08x:  \n",GET_SCFP(base),GET_SCCR(base),GET_SCPCR(base));
+    if (mars_scd_card_detect(p_this)==0)
+        return SC_ERR_NO_ICC;
+
+    if (p_this->fsm != IFD_FSM_ACTIVE)
+        return SC_ERR_ICC_DEACTIVATE;
+
+    kfifo_reset(&p_this->rx_fifo);
+
+    kfifo_reset(&p_this->tx_fifo);
+
+    if (kfifo_in(&p_this->tx_fifo, p_data, len)<len)
+    {
+        SC_WARNING("[SC%d] xmit data failed, tx fifo overflow\n", id);
+        return SC_FAIL;
+    }
+
+    // load tx data
+    tx_data_len = kfifo_out(&p_this->tx_fifo, tx_buff, sizeof(tx_buff));
+
+    for(i=0; i<tx_data_len; i++)
+        SET_SC_TXFIFO(base, tx_buff[i]);
+
+    //SC_WARNING("Send %d Bytes!\n", tx_data_len);
+
+    // kick-off
+    p_this->tx_status = 0;
+
+    SET_SCIRER(base, GET_SCIRER(base) | SC_TXEMPTY_INT);   // enable Tx empty interrupt
+
+    SET_SCCR(base, GET_SCCR(base) | SC_TX_GO(1));          // Start Xmit
+
+//for the most INF of 254byte(add NAD,PCB,LEN,EDC is 258byte<32byte*16),the timeout must be 16 times of timer
+    wait_event_interruptible_timeout(p_this->wq, (p_this->tx_status & SC_TX_DONE), HZ);
+
+    SET_SCIRER(base, GET_SCIRER(base) & ~SC_TXEMPTY_INT);   // disable Tx empty interrupt
+
+    if ((p_this->tx_status & SC_TX_DONE)==0)
+    {
+        SC_WARNING("[SC%d] xmit data failed, tx timeout\n", id);
+        SET_SCCR(base, GET_SCCR(base) & ~SC_TX_GO(1));      // stop Xmit
+        return SC_FAIL;
+    }
+    return SC_SUCCESS;
+}
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_read
+ *
+ * Desc : read data via smart card bus
+ *
+ * Parm : p_this   : handle of mars scd
+ *
+ * Retn : sc_buff
+ *------------------------------------------------------------------*/
+int mars_scd_read(mars_scd* p_this, unsigned char* data, unsigned int len)
+{
+    if (mars_scd_card_detect(p_this)==0)
+        return SC_ERR_NO_ICC;
+
+    wait_event_interruptible_timeout(p_this->wq, kfifo_len(&p_this->rx_fifo) >=len || (p_this->fsm != IFD_FSM_ACTIVE), HZ>>2);
+
+    if (p_this->fsm != IFD_FSM_ACTIVE)
+        return SC_ERR_ICC_DEACTIVATE;
+
+   return  kfifo_out_locked(&p_this->rx_fifo, data, len, &p_this->rx_fifo_lock);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_load_gpio_config
+ *
+ * Desc : Load Gpio Config
+ *
+ * Parm : p_this   : handle of mars scd
+ *
+ * Retn : sc_buff
+ *------------------------------------------------------------------*/
+static void mars_scd_load_gpio_config(mars_scd* p_this)
+{
+    /**************************************
+     * SCx Command format
+     **************************************
+        : cmd_vcc_en        (0: no cmd_vcc_gpio, 1: with cmd_vcc_gpio)
+        : cmd_vcc_polarity  (0: negative, 1: positive)
+        : cmd_vcc_gpio_type (0: MISC, 1: ISO)
+        : --
+        : pwr_sel_en        (0: no cmd_vcc_gpio, 1: with cmd_vcc_gpio)
+        : pwr_sel_polarity  (0: negative, 1: positive)
+        : pwr_sel_gpio_type (0: MISC, 1: ISO)
+        : --
+        : cmd_vcc_gpio
+        : pwr_sel_gpio
+     **************************************/
+
+    p_this->cmd_vcc_en       = dts_info.cmd_vcc_en;
+    p_this->cmd_vcc_polarity = dts_info.cmd_vcc_polarity;
+    p_this->pin_cmd_vcc      = dts_info.pin_cmd_vcc;
+
+    p_this->pwr_sel_en       = dts_info.pwr_sel_en;
+    p_this->pwr_sel_polarity = dts_info.pwr_sel_polarity;
+    p_this->pin_pwr_sel      = dts_info.pin_pwr_sel;
+
+#if(1)
+    if(p_this->vcc_5v != p_this->pwr_sel_polarity)
+    {
+        SC_WARNING("SC%d = default pwr changed to %s\n",
+            p_this->id, p_this->pwr_sel_polarity ? "5v" : "3v");
+        p_this->vcc_5v = p_this->pwr_sel_polarity;
+    }
+#endif
+
+    SC_INFO("SC%d - cmd_vcc(en=%d, polarity=%d, pin=%s_GPIO[%d]), pwr_sel(en=%d,polarity=%d,pin=%s_GPIO[%d])\n",
+            p_this->id,
+            p_this->cmd_vcc_en,
+            p_this->cmd_vcc_polarity,
+            gpio_type(gpio_group(p_this->pin_cmd_vcc)),
+            gpio_idx(p_this->pin_cmd_vcc),
+            p_this->pwr_sel_en,
+            p_this->pwr_sel_polarity,
+            gpio_type(gpio_group(p_this->pin_pwr_sel)),
+            gpio_idx(p_this->pin_pwr_sel));
+}
+
+
+/*------------------------------------------------------------------
+ * Func : mars_clk_reset_ctrl
+ *
+ * Desc :
+ *
+ * Parm :
+ *
+ * Retn :
+ *------------------------------------------------------------------*/
+static int mars_clk_reset_ctrl(SCD_CLK_CTL enable)
+{
+    if(enable == CTL_ENABLE){
+        reset_control_deassert(dts_info.rstc);
+        clk_prepare_enable(dts_info.clk);
+    }else{
+        clk_disable_unprepare(dts_info.clk);
+        reset_control_assert(dts_info.rstc);
+    }
+    return 0;
+}
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_open
+ *
+ * Desc : open a mars scd device
+ *
+ * Parm : id  : channel id
+ *
+ * Retn : handle of mars scd
+ *------------------------------------------------------------------*/
+mars_scd* mars_scd_open(unsigned char id)
+{
+    mars_scd* p_this;
+    //void __iomem *gpio = ioremap(0x9801B000, 0x120);
+    int ret = 0;
+
+    if (id >= MAX_IFD_CNT) {
+        SC_WARNING("scd : open %s scd failed, invalid id - %d\n", IFD_MODOLE, id);
+        return NULL;
+    }
+
+    p_this = (mars_scd*) kmalloc(sizeof(mars_scd), GFP_KERNEL);
+
+    if (p_this)
+    {
+        memset(p_this, 0, sizeof(mars_scd));
+
+        p_this->base    = dts_info.base;
+        p_this->id      = dts_info.id;
+        p_this->fsm     = IFD_FSM_UNKNOWN;
+        p_this->atr.length = -1;
+
+        if (kfifo_alloc(&p_this->rx_fifo, 1024, GFP_KERNEL)<0)
+        {
+            SC_WARNING("scd : open %s scd(%d) failed, create rx fifo failed\n", IFD_MODOLE, id);
+            kfree(p_this);
+            return NULL;
+        }
+
+        if (kfifo_alloc(&p_this->tx_fifo, 1024, GFP_KERNEL)<0)
+        {
+            SC_WARNING("scd : open %s scd(%d) failed, create tx fifo failed\n", IFD_MODOLE, id);
+            kfifo_free(&p_this->rx_fifo);
+            kfree(p_this);
+            return NULL;
+        }
+
+        mars_clk_reset_ctrl(CTL_ENABLE);
+#if 0
+        /* reset smartcart crt */
+        writel(readl(dts_info.crt + 0x4) | (0x1 << 29), dts_info.crt + 0x4);
+
+        /* enable clock */
+        writel(readl(dts_info.crt + 0x10) | (0x1 << 6), dts_info.crt + 0x10);
+
+        /* set padmux */
+        writel(readl(dts_info.padmux + 0x314) | 0xFF0000, dts_info.padmux + 0x314);
+#endif
+        /* set misc interrupt */
+        writel(readl(dts_info.misc + 0x80) | (0x1 << 24), dts_info.misc + 0x80);
+        //writel(readl(dts_info.misc + 0x80) & 0xFEFFFFFF , dts_info.misc + 0x80);
+        //writel(readl(dts_info.misc + 0x80) | (0x1 << 24), dts_info.misc + 0x80);
+
+        spin_lock_init(&p_this->lock);
+        spin_lock_init(&p_this->rx_fifo_lock);
+        init_waitqueue_head(&p_this->wq);
+
+        p_this->clock_div        = 1;
+        p_this->pre_clock_div    = (unsigned char)(SYSTEM_CLK/3000000);
+        p_this->baud_div1        = 12;        // default etu = 372 = 31 * 12
+        p_this->baud_div2        = 31;
+        p_this->parity           = 1;
+        p_this->vcc_5v           = 0;
+
+        mars_scd_load_gpio_config(p_this);
+#if 1
+        if (p_this->cmd_vcc_en)
+        {
+            //venus_gpio_output(p_this->pin_cmd_vcc, (p_this->cmd_vcc_polarity) ? 0 : 1);     // power off
+            //venus_gpio_set_dir(p_this->pin_cmd_vcc, 1);   // set power ping to output mode
+            //gpio_direction_output(p_this->pin_cmd_vcc, (p_this->cmd_vcc_polarity) ? 0 : 1);
+            MARS_SCD_POWER_ENABLE(p_this, 0);
+        }
+
+        if (p_this->pwr_sel_en)
+        {
+            //venus_gpio_output(p_this->pin_pwr_sel, (p_this->pwr_sel_polarity) ? 0 : 1);     // 3.3v
+            //venus_gpio_set_dir(p_this->pin_pwr_sel, 1);   // set power ping to output mode
+            //gpio_direction_output(p_this->pin_pwr_sel, (p_this->pwr_sel_polarity) ? 0 : 1);
+            mars_scd_power_select(p_this, p_this->vcc_5v);
+        }
+#endif
+#if 0
+        /* set gpio */
+        printk(KERN_ERR "gpio+110:[0x%x]\n", readl(gpio + 0x110));
+        printk(KERN_ERR "gpio+100:[0x%x]\n", readl(gpio + 0x100));
+        writel(readl(gpio + 0x110) | 0x1000, gpio + 0x110);
+        writel(readl(gpio + 0x100) | 0x1800, gpio + 0x100);
+        writel(readl(gpio + 0x110) | 0x1800, gpio + 0x110);
+        writel(readl(gpio + 0x110) & 0xFFFFF7FF, gpio + 0x110);
+        printk(KERN_ERR "gpio+110:[0x%x]\n", readl(gpio + 0x110));
+        printk(KERN_ERR "gpio+100:[0x%x]\n", readl(gpio + 0x100));
+#endif
+        // Set All Register to the initial value
+        SET_SCFP(p_this->base, SC_CLK_EN(1)    |
+                            SC_CLKDIV((p_this->clock_div-1))|
+                            SC_BAUDDIV2(0)  |                    // fixed to 31
+                            SC_BAUDDIV1((p_this->baud_div1-1))|
+                            SC_PRE_CLKDIV((p_this->pre_clock_div-1)));
+
+        SET_SCCR(p_this->base, SC_FIFO_RST(1)  |
+                            SC_SCEN(1)      |
+                            SC_AUTO_ATR(1)  |
+                            SC_CONV(0)      |
+                            SC_PS(0));
+
+        SET_SCPCR(p_this->base,SC_TXGRDT(2)    |
+                            SC_CWI(0)       |
+                            SC_BWI(0)       |
+                            SC_WWI(0)       |
+                            SC_BGT(0x16)    |
+                            SC_EDC_EN(0)    |
+                            SC_CRC(0)       |
+                            SC_PROTOCOL_T(0)|
+                            SC_T0RTY(0)     |
+                            SC_T0RTY_CNT(0) );
+
+        SET_SCIRER(p_this->base, 0);
+
+        SET_SCIRSR(p_this->base, 0xFFFFFFFF);
+
+#ifdef ISR_POLLING
+        init_timer(&p_this->timer);
+        p_this->timer.data     = (unsigned long)p_this;
+        p_this->timer.function = mars_scd_timer;
+        p_this->timer.expires  = jiffies + ISR_POLLING_INTERVAL;
+        add_timer(&p_this->timer);      // register timer
+#else
+        p_this->irq = dts_info.irq;
+        //if (request_irq(p_this->irq, mars_scd_isr, SA_SHIRQ, "MARS SCD", (void *) p_this) < 0)
+        if (request_irq(p_this->irq, mars_scd_isr, IRQF_SHARED, "MARS SCD", (void *) p_this) < 0)
+        {
+            SC_WARNING("scd : open %s scd failed, unable to request irq#%d\n", IFD_MODOLE, p_this->irq);
+            kfifo_free(&p_this->tx_fifo);
+            kfifo_free(&p_this->rx_fifo);
+            kfree(p_this);
+            return NULL;
+        }
+
+        printk(KERN_ERR "scd : open %s scd and request irq#%d successfully.\n", IFD_MODOLE, p_this->irq);
+#endif
+        MARS_SCD_SET_STATE(p_this, IFD_FSM_DISABLE, ret);
+    }
+    else{
+        SC_WARNING("scd : open mars scd failed\n");
+        return NULL;
+    }
+    return p_this;
+}
+
+
+/*------------------------------------------------------------------
+ * Func : mars_scd_close
+ *
+ * Desc : close a mars scd device
+ *
+ * Parm : p_this  : mars scd to be close
+ *
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void mars_scd_close(mars_scd* p_this)
+{int ret =0;
+#ifdef ISR_POLLING
+    del_timer(&p_this->timer);      // register timer
+#else
+    free_irq(MISC_IRQ ,p_this);
+#endif
+
+    kfifo_free(&p_this->rx_fifo);
+    kfifo_free(&p_this->tx_fifo);
+    MARS_SCD_SET_STATE(p_this, IFD_FSM_DISABLE, ret);
+    wake_up(&p_this->wq);
+    kfree(p_this);
+}
+
+
diff --git a/drivers/smartcard/adapter/scd_mars_priv.h b/drivers/smartcard/adapter/scd_mars_priv.h
new file mode 100755
index 00000000..65364b7
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_mars_priv.h
@@ -0,0 +1,170 @@
+/*
+ * scd_mars_priv.h - smartcard driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef __SCD_MARS_PRIV_H__
+#define __SCD_MARS_PRIV_H__
+
+#include <linux/wait.h>
+#include <linux/timer.h>
+#include <linux/spinlock.h>
+#include <linux/kfifo.h>
+#include <soc/realtek/venus_gpio.h>
+#include "../core/scd.h"
+#include "../core/scd_atr.h"
+
+#define ID_MARS_SCD(x)          (0x12830000 | (x & 0x3))
+#define MARS_SCD_CHANNEL(id)    (id & 0x03)
+
+#define MISC_IRQ        3
+#define RX_RING_LENGTH  32
+#define TX_RING_LENGTH  32
+
+
+typedef enum {    
+    IFD_FSM_UNKNOWN,
+    IFD_FSM_DISABLE,        // function disabled
+    IFD_FSM_DEACTIVATE,     // function enabled but not reset the card yet
+    IFD_FSM_RESET,          // reset the card and waiting for ATR
+    IFD_FSM_ACTIVE,         // card activated
+}IFD_FSM; 
+
+//#define ISR_POLLING
+
+struct clk;
+struct reset_control;
+
+typedef struct mars_dts_info
+{
+    //void __iomem        *crt;
+    //void __iomem        *padmux;
+    void __iomem        *misc;
+    void __iomem        *base;
+#if 0
+    void __iomem        *crt;
+    void __iomem        *pinmux;
+    void __iomem        *gpio;
+#endif
+    unsigned int        irq;
+    unsigned int        id;
+    unsigned char       cmd_vcc_en;
+    unsigned char       cmd_vcc_polarity;
+    unsigned char       pwr_sel_en;
+    unsigned char       pwr_sel_polarity;
+    VENUS_GPIO_ID       pin_cmd_vcc;         // command vcc
+    VENUS_GPIO_ID       pin_pwr_sel;         // power sel
+
+    struct clk *clk;
+    struct reset_control *rstc;
+}MARS_DTS_INFO_T;
+
+typedef struct mars_scd_tag   mars_scd;
+
+struct mars_scd_tag
+{    
+    unsigned int        id;         // channel id      
+    void __iomem 	    *base;
+    unsigned int	    irq;  
+    IFD_FSM             fsm;        // finate state machine of ifd
+	unsigned char       card_status_change;
+	unsigned char       tx_status;
+	#define SC_TX_DONE          0x1	
+	#define SC_TX_PARITY_ERROR  0x2
+    
+    // config
+    unsigned char       clock_div;          // clock divider
+    unsigned char       pre_clock_div;      // pre_clock divider
+    unsigned long       baud_div1; 
+    unsigned long       baud_div2;    
+    unsigned char       parity;
+    
+    unsigned char       vcc_5v : 1;
+    unsigned char       cmd_vcc_en : 1;
+    unsigned char       cmd_vcc_polarity : 1;
+    unsigned char       pwr_sel_en : 1;    
+    unsigned char       pwr_sel_polarity : 1;
+    VENUS_GPIO_ID       pin_cmd_vcc;         // command vcc
+    VENUS_GPIO_ID       pin_pwr_sel;         // power sel    
+
+	// atr              
+	scd_atr             atr;               // current atr
+	scd_atr_info        atr_info;          // current atr
+	unsigned long       atr_timeout;
+	    
+    wait_queue_head_t   wq;
+    struct kfifo        rx_fifo;
+    struct kfifo        tx_fifo;
+    spinlock_t          rx_fifo_lock;
+    
+#ifdef ISR_POLLING    
+    struct timer_list   timer;
+#endif
+
+    spinlock_t          lock;
+    struct list_head    list;	
+};
+
+typedef enum {
+    CTL_DISABLE = 0,
+    CTL_ENABLE  = 1
+} SCD_CLK_CTL;
+
+extern mars_scd* mars_scd_open(unsigned char id);
+extern void mars_scd_close(mars_scd* p_this);
+
+extern int mars_scd_enable           (mars_scd* p_this, unsigned char on_off);       
+extern int mars_scd_set_clock        (mars_scd* p_this, unsigned long clock);
+extern int mars_scd_set_etu          (mars_scd* p_this, unsigned long etu);
+extern int mars_scd_set_parity       (mars_scd* p_this, SC_PARITY parity);
+
+extern int mars_scd_get_clock        (mars_scd* p_this, unsigned long* p_clock);
+extern int mars_scd_get_etu          (mars_scd* p_this, unsigned long* p_etu);
+extern int mars_scd_get_parity       (mars_scd* p_this, SC_PARITY* p_parity);
+
+extern int mars_scd_set_bwi(mars_scd* p_this, unsigned long bwi);
+extern int mars_scd_get_bwi(mars_scd* p_this, unsigned long* p_bwi);
+extern int mars_scd_set_cwi(mars_scd* p_this, unsigned long cwi);
+extern int mars_scd_get_cwi(mars_scd* p_this, unsigned long* p_cwi);
+extern int mars_scd_set_guard_interval(mars_scd* p_this, unsigned long guard_interval);
+extern int mars_scd_get_guard_interval(mars_scd* p_this, unsigned long* p_guard_interval);
+
+static int inline mars_scd_set_vcc_lvl(mars_scd* p_this, SC_VCC_LVL lvl)
+{        
+    p_this->vcc_5v = (lvl==SC_VCC_5V) ? 1 : 0;
+    return SC_SUCCESS;
+}
+
+static int inline mars_scd_get_vcc_lvl(mars_scd* p_this, SC_VCC_LVL* p_lvl)
+{
+    *p_lvl = (p_this->vcc_5v) ? SC_VCC_5V : SC_VCC_3V;
+    return SC_SUCCESS;
+}
+
+static int inline mars_scd_set_convention(mars_scd* p_this, SC_CONV conv)
+{    
+    return SC_SUCCESS;
+}
+
+static int inline mars_scd_get_convention(mars_scd* p_this, SC_CONV* p_conv)
+{
+    *p_conv = SC_AUTO_CONV;
+    return SC_SUCCESS;
+}
+
+extern int mars_scd_activate         (mars_scd* p_this);         
+extern int mars_scd_deactivate       (mars_scd* p_this);         
+extern int mars_scd_reset            (mars_scd* p_this);         
+extern int mars_scd_get_atr          (mars_scd* p_this, scd_atr* p_atr);    
+extern int mars_scd_card_detect      (mars_scd* p_this);
+extern int mars_scd_get_card_status  (mars_scd* p_this);
+extern int mars_scd_poll_card_status (mars_scd* p_this);
+extern int mars_scd_xmit             (mars_scd* p_this, unsigned char* p_data, unsigned int len);    		    
+extern int mars_scd_read             (mars_scd* p_this, unsigned char* p_data, unsigned int len);
+    
+#endif //__SCD_MARS_PRIV_H__
diff --git a/drivers/smartcard/adapter/scd_mars_reg.h b/drivers/smartcard/adapter/scd_mars_reg.h
new file mode 100755
index 00000000..eb8a513
--- /dev/null
+++ b/drivers/smartcard/adapter/scd_mars_reg.h
@@ -0,0 +1,117 @@
+/*
+ * scd_mars_reg.h - smartcard driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef __MARS_SCD_REG_H__
+#define __MARS_SCD_REG_H__
+                                 
+#define MIS_ISR                (0xb801b00c)
+#define MIS_SC0_INT            (0x00000001<<24)
+                                                                 
+
+
+#define MAX_IFD_CNT             1
+#define IFD_MODOLE              "Kylin"
+#define SC_BASE0                0x9801BE00
+#define MIS_SC0_INT            (0x00000001<<24)
+#define SYSTEM_CLK              27000000
+
+
+#define SCFP                    0x0000      /* Smartcard Carrier Frequency Programmer*/
+#define SCCR                    0x0004      /* Smartcard Control Register */
+#define SCPCR                   0x0008      /* Smartcard Protocol Control Register */
+#define SCTXFIFO                0x000C      /* Smartcard Transmit FIFO Register */
+#define SCTXLENR                0x0010      /* Smartcard Txmit Length Register */
+#define SCRXFIFO                0x0014      /* Smartcard Receive FIFO Register */
+#define SCRXLENR                0x0018      /* Smartcard Receive Length Register */
+#define SCFCR                   0x001C      /* Smartcard Flow Control Register */
+#define SCIRSR                  0x0020      /* Smartcard Interrupt Status Register */
+#define SCIRER                  0x0024      /* Smartcard Interrupt Enable Register */
+
+// SC_FP - SC Frequency Programmer
+#define SC_CLK_EN(x)            ((x & 0x00000001)<<24)
+#define SC_CLKDIV(x)            ((x & 0x0000003F)<<18)
+#define SC_BAUDDIV2(x)          ((x & 0x00000003)<<16)
+#define SC_BAUDDIV1(x)          ((x & 0x000000FF)<<8)
+#define SC_PRE_CLKDIV(x)        ((x & 0x000000FF))
+#define SC_CLKDIV_MASK          SC_CLKDIV(0x3F)
+#define SC_BAUDDIV2_MASK        SC_BAUDDIV2(0x3)
+#define SC_BAUDDIV1_MASK        SC_BAUDDIV1(0xFF)
+#define SC_BAUDDIV_MASK         (SC_BAUDDIV1_MASK | SC_BAUDDIV2_MASK)
+#define SC_PRE_CLKDIV_MASK      SC_PRE_CLKDIV(0xFF)
+
+#define SC_CLK_EN_VAL(x)        ((x << 24) & 0x00000001)
+#define SC_CLKDIV_VAL(x)        ((x << 18) & 0x0000003F)
+#define SC_BAUDDIV2_VAL(x)      ((x << 16) & 0x00000003)
+#define SC_BAUDDIV1_VAL(x)      ((x <<  8) & 0x000000FF)
+#define SC_PRE_CLKDIV_VAL(x)    ((x & 0x000000FF))
+
+// SC_CR - SC Control Register
+#define SC_FIFO_RST(x)          ((x & 0x00000001)<<31)
+#define SC_RST(x)               ((x & 0x00000001)<<30)
+#define SC_SCEN(x)              ((x & 0x00000001)<<29)
+#define SC_TX_GO(x)             ((x & 0x00000001)<<28)
+#define SC_AUTO_ATR(x)          ((x & 0x00000001)<<27)
+#define SC_CONV(x)              ((x & 0x00000001)<<26)
+#define SC_CLK_STOP(x)          ((x & 0x00000001)<<25)
+#define SC_PS(x)                ((x & 0x00000001)<<24)
+
+#define SC_PS_VAL(x)            ((x >> 24) & 0x00000001)
+
+
+// SCPCR - SC Protocol control Register 
+#define SC_TXGRDT(x)          ((x & 0x000000FF)<<24)
+#define SC_CWI(x)             ((x & 0x0000000F)<<20)
+#define SC_BWI(x)             ((x & 0x0000000F)<<16)
+#define SC_WWI(x)             ((x & 0x0000000F)<<12)
+#define SC_BGT(x)             ((x & 0x0000001F)<<7)
+#define SC_EDC_EN(x)          ((x & 0x00000001)<<6)
+#define SC_CRC(x)             ((x & 0x00000001)<<5)
+#define SC_PROTOCOL_T(x)      ((x & 0x00000001)<<4)
+#define SC_T0RTY(x)           ((x & 0x00000001)<<3)
+#define SC_T0RTY_CNT(x)       ((x & 0x00000007))
+
+#define MASK_SC_TXGRDT        SC_TXGRDT(0xFF)
+#define MASK_SC_CWI           SC_CWI(0xF)
+#define MASK_SC_BWI           SC_BWI(0xF)
+#define MASK_SC_WWI           SC_WWI(0xF)
+#define MASK_SC_BGT           SC_BGT(0x1F)
+#define MASK_SC_EDC_EN        SC_EDC_EN(1)
+#define MASK_SC_EDC_TYPE      SC_EDC_TYPE(1)
+#define MASK_SC_PROTOCOL      SC_PROTOCOL(1)
+#define MASK_SC_T0RTY         SC_T0RTY(1)
+#define MASK_SC_T0RTY_CNT     SC_T0RTY_CNT(1)
+
+// SC_FCR - Flow Control Register
+#define SC_RXFLOW(x)          ((x & 0x00000001)<<1)
+#define SC_FLOW_EN(x)         ((x & 0x00000001))
+
+
+// SCIRSR & SCIRER - SC Interrupt Status/Enable Register
+#define SC_DRDY_INT           0x00000001
+#define SC_RCV_INT            0x00000002
+#define SC_BWT_INT            0x00000004
+#define SC_WWT_INT            0x00000008
+#define SC_RLEN_INT           0x00000010
+#define SC_CWT_INT            0x00000020
+#define SC_BGT_INT            0x00000040
+#define SC_ATRS_INT           0x00000080
+#define SC_RXP_INT            0x00000100
+#define SC_RX_FOVER_INT       0x00000200
+#define SC_EDCERR_INT         0x00000400
+#define SC_TXEMPTY_INT        0x00000800
+#define SC_TXDONE_INT         0x00001000
+#define SC_TXP_INT            0x00002000
+#define SC_TXFLOW_INT         0x00004000
+#define SC_CPRES_INT          0x00008000
+#define SC_PRES               0x00010000
+
+
+#endif  //__MARS_SCD_REG_H__
+
diff --git a/drivers/smartcard/core/Kconfig b/drivers/smartcard/core/Kconfig
new file mode 100755
index 00000000..da0ba44
--- /dev/null
+++ b/drivers/smartcard/core/Kconfig
@@ -0,0 +1,23 @@
+# drivers/smartcard/core/Kconfig
+	
+config SMARTCARD_CHARDEV
+	bool "Smart Card Device Interface"
+	depends on SMARTCARD
+	select SMARTCARD_DEV_FILE
+	help
+	  Say Y here to use smart card device files, usually found in the /dev/smartcard/
+	  directory on your system.  They make it possible to have user-space
+	  programs use the smart card reader.	  
+	
+config SMARTCARD_DEV_FILE	
+	bool
+	depends on SMARTCARD
+	default n
+
+config SMARTCARD_DEBUG
+	bool "Smart Card Debug Mode"
+	depends on SMARTCARD
+	default n
+	help 
+	  If you want to enable smart card debug message, say Y.
+
diff --git a/drivers/smartcard/core/Makefile b/drivers/smartcard/core/Makefile
new file mode 100755
index 00000000..1ff2030
--- /dev/null
+++ b/drivers/smartcard/core/Makefile
@@ -0,0 +1,7 @@
+scd-objs = scd_core.o \
+            scd_buff.o \
+            scd_dev.o \
+            scd_atr.o                    
+
+#obj-$(CONFIG_SMARTCARD)  += scd.o
+obj-y			  += scd.o 
diff --git a/drivers/smartcard/core/scd.h b/drivers/smartcard/core/scd.h
new file mode 100755
index 00000000..40254c7
--- /dev/null
+++ b/drivers/smartcard/core/scd.h
@@ -0,0 +1,175 @@
+#ifndef __SCD_H__
+#define __SCD_H__
+
+#include <linux/device.h>
+#include "scd_debug.h"
+#include "scd_atr.h"
+#include "scd_buff.h"
+
+extern struct bus_type scd_bus_type;
+
+#define MAX_SCD_DEVICE     4
+
+//-------------------------------------------------------
+// data structure
+//-------------------------------------------------------
+typedef enum {
+    SC_VCC_3V = 0,
+    SC_VCC_5V,    
+}SC_VCC_LVL;
+
+typedef enum {
+    SC_AUTO_CONV = 0,
+    SC_DIRECT_CONV,
+    SC_INVERSE_CONV,    
+}SC_CONV;
+
+typedef enum {
+    SC_PARITY_NONE = 0,
+    SC_PARITY_ODD,
+    SC_PARITY_EVEN,    
+}SC_PARITY;
+
+typedef enum {
+    SC_CARD_REMOVED = 0,        // ICC does not exist
+    SC_CARD_DEACTIVATE,         // ICC exists, but has not been activated
+    SC_CARD_RESET,              // ICC is reseting and waiting for ATR
+    SC_CARD_RESET_TIMEOUT,      // ICC Reset failed, due to no ATR responsed
+    SC_CARD_ACTIVATE,           // ICC has been activated successfully
+    SC_CARD_UNKNOWN,            // ICC has some error...
+}SC_CARD_STATUS;
+
+typedef enum {
+    SC_SUCCESS = 0,
+    SC_FAIL = -1,
+    SC_ERR_NO_ICC = -2 ,  
+    SC_ERR_ICC_DEACTIVATE = -3,    
+    SC_ERR_IFD_DISABLED = -4,       
+    SC_ERR_ATR_TIMEOUT = -5,   
+}SC_RET;
+
+typedef enum {
+    SC_PARAM_VCC_LVL = 0,
+    SC_PARAM_CLOCK,
+    SC_PARAM_ETU,
+    SC_PARAM_CONV,
+    SC_PARAM_PARITY,
+    SC_PARAM_GUARD_INTERVAL,
+    SC_PARAM_FLOW_CONTROL,             // used for SMC with Flow Control (ICAM SMC)
+    SC_PARAM_EXTENDED_IO_CONTROL,      // used for SMC with Extend IO Control (ICAM SMC)    
+    SC_PARAM_RESETTIMEOUT,
+    SC_PARAM_ENABLE_BYPASSATR,
+    SC_PARAM_BWI,
+    SC_PARAM_CWI
+}SC_PARAMETER_ID;
+
+#define SC_IO_CTRL_IO_C7    0x80       // Use C7 as IO Pin, C4, C8 = Bidirectional GPIO
+#define SC_IO_CTRL_IO_C4    0x40       // Use C4 as IO Pin, C7, C8 = Bidirectional GPIO
+#define SC_IO_CTRL_IO_C8    0x20       // Use C8 as IO Pin, C7, C4 = Bidirectional GPIO  
+#define SC_IO_CTRL_IO_MASK  (SC_IO_CTRL_IO_C7|SC_IO_CTRL_IO_C4|SC_IO_CTRL_IO_C8)  
+#define SC_IO_CTRL_C7_ON    0x08       // C7 output High (only valid if C7 is in GPIO mode)
+#define SC_IO_CTRL_C4_ON    0x04       // C4 output High (only valid if C4 is in GPIO mode)   
+#define SC_IO_CTRL_C8_ON    0x02       // C8 output High (only valid if C8 is in GPIO mode)   
+
+typedef struct {
+    unsigned long long  id;         // parameter id
+    unsigned long  long val;        // parameter val
+}scd_param;
+
+//-------------------------------------------------------
+// device
+//-------------------------------------------------------
+typedef struct 
+{
+    unsigned long   id;
+    char*           name;
+    struct device   dev;
+}scd_device;
+
+
+
+#define to_scd_device(x)  container_of(x, scd_device, dev) 
+
+static inline void *scd_get_drvdata (scd_device *device)
+{
+    return dev_get_drvdata(&device->dev);
+}
+ 
+static inline void
+scd_set_drvdata (scd_device *device, void *data)
+{
+    struct device *dev = &device->dev;
+    dev_set_drvdata(dev, data);
+}
+
+extern int  register_scd_device(scd_device* device);
+extern void unregister_scd_device(scd_device* device);
+
+
+
+//-------------------------------------------------------
+// driver
+//-------------------------------------------------------
+
+typedef struct 
+{
+    char*                       name;
+    
+    struct device_driver        drv;    
+    
+    //--------- ops
+    
+    int     (*probe)            (scd_device*        dev);
+    
+    void    (*remove)           (scd_device*        dev);    
+        
+    int     (*enable)           (scd_device*        dev, 
+                                 unsigned char      on_off);
+                                         
+    int     (*set_param)        (scd_device*        dev, 
+                                 unsigned long      param_id,                                
+                                 unsigned long      val);
+                                 
+    int     (*get_param)        (scd_device*        dev, 
+                                 unsigned long      param_id,                                
+                                 unsigned long*     p_val);                                 
+
+    //---------         
+    int     (*activate)         (scd_device*        dev);
+
+    int     (*deactivate)       (scd_device*        dev);
+
+    int     (*reset)            (scd_device*        dev);
+    
+    int     (*get_atr)          (scd_device*        dev, 
+                                 scd_atr*           p_atr);
+    
+    int     (*get_card_status)  (scd_device*        dev);
+    
+    int     (*poll_card_status) (scd_device*        dev);
+    
+    int     (*xmit)             (scd_device*        dev, 
+                                 unsigned char*     p_data,
+                                 unsigned int       len);    
+    
+    int     (*read)             (scd_device*        dev,
+                                 unsigned char*     p_data, 
+                                 unsigned int       len);   
+
+    //--------- power management ------------
+    int     (*suspend)          (scd_device* dev);
+    
+    int     (*resume)           (scd_device* dev);
+    
+    
+}scd_driver;
+
+
+#define to_scd_driver(x)  container_of(x, scd_driver, drv) 
+
+extern int  register_scd_driver(scd_driver* driver);
+extern void unregister_scd_driver(scd_driver* driver);
+
+
+#endif  //__SCD_CORE_H__
+
diff --git a/drivers/smartcard/core/scd_atr.c b/drivers/smartcard/core/scd_atr.c
new file mode 100755
index 00000000..ae3f11e
--- /dev/null
+++ b/drivers/smartcard/core/scd_atr.c
@@ -0,0 +1,225 @@
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include "scd_atr.h"
+#include "scd_debug.h"
+
+MODULE_LICENSE("GPL");
+
+
+//#define COMPRESS_ATR_DEBUG_EN
+
+/*------------------------------------------------------------------
+ * Func : is_atr_crc_ok
+ *
+ * Desc : check is the atr_complete or not
+ *
+ * Parm : scd_atr : atr to check 
+ *         
+ * Retn : 1 : complete, 0 : not complete  
+ *------------------------------------------------------------------*/
+int is_atr_crc_ok(scd_atr* p_atr)
+{    
+    int i;
+    unsigned char crc = 0;
+        
+    for (i=1; i<p_atr->length; i++) // from T0 to TCK
+    {
+        crc ^= p_atr->data[i];     
+    }        
+    
+    return (crc==0) ? 1 : 0;        
+}
+
+
+/*------------------------------------------------------------------
+ * Func : is_atr_complete
+ *
+ * Desc : check is the atr_complete or not
+ *
+ * Parm : scd_atr : atr to check 
+ *         
+ * Retn : 1 : complete, 0 : not complete  
+ *------------------------------------------------------------------*/
+int is_atr_complete(scd_atr* p_atr)
+{    
+    unsigned char  TS    = 0;
+    unsigned char  T0    = 0;
+    unsigned char  TD1   = 0;
+    unsigned char  TD2   = 0;    
+    unsigned char  nHistoryByte = 0;
+    unsigned char  T1Len = 0;
+    unsigned char  T2Len = 0;
+    unsigned char  T3Len = 0;
+    unsigned char  T     = 0;       
+                    
+    if (p_atr->length < 3)
+        return 0;
+    
+    //-------- header complete ---------
+    TS = p_atr->data[0];
+    
+    if ((TS!=0x3B) && (TS!=0x3F))      
+        return 1;    
+            
+    T0 = p_atr->data[1];
+    
+    nHistoryByte = T0 & 0xF;
+         
+    T1Len = ((T0 >> 4) & 0x01) +
+            ((T0 >> 5) & 0x01) +
+            ((T0 >> 6) & 0x01) +
+            ((T0 >> 7) & 0x01) ;                                                            
+                            
+    if (p_atr->length <  2 + T1Len)
+        return 0;
+        
+    //-------- TX1 complete ------------
+        
+    if (T0 & 0x80)         
+    {           
+        // TD1 exists - find length of TD2
+        TD1 = p_atr->data[1 + T1Len];
+        T2Len = ((TD1 >> 4) & 0x01) +
+                ((TD1 >> 5) & 0x01) +
+                ((TD1 >> 6) & 0x01) +
+                ((TD1 >> 7) & 0x01) ; 
+                
+        T   = TD1 & 0xF;                                      
+    }
+    
+    if (p_atr->length <  2 + T1Len + T2Len)
+        return 0;
+    
+    //-------- TX2 complete ------------
+    
+    if (TD1 & 0x80)     
+    {             
+        // TD2 exists - find length of TD3
+        TD2   = p_atr->data[1 + T1Len + T2Len];
+        T3Len = ((TD2 >> 4) & 0x01)+
+                ((TD2 >> 5) & 0x01)+
+                ((TD2 >> 6) & 0x01)+
+                ((TD2 >> 7) & 0x01);                                                                                                        
+    }                        
+    
+    //-------- TX3 & header complete ------------    
+    switch(T)
+    {
+    case 0:
+    case 15:    
+        // for T=0 or T=15, TCK should be absent
+        if (p_atr->length <  2 + T1Len + T2Len + T3Len + nHistoryByte)
+            return 0;
+            
+        return 1;                    
+        
+    default:
+        if (p_atr->length <  3 + T1Len + T2Len + T3Len + nHistoryByte)
+            return 0;
+                
+        return (!is_atr_crc_ok(p_atr)) ? -1 : 1;                                  
+    }
+}
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : decompress_atr
+ *
+ * Desc : decompress_atr
+ *
+ * Parm : scd_atr : atr to check 
+ *         
+ * Retn : 1 : success, others : failed  
+ *------------------------------------------------------------------*/
+int decompress_atr(scd_atr* p_atr, scd_atr_info* p_info)
+{
+    unsigned char id = 0;
+    unsigned char i  = 0;
+    int ret = is_atr_complete(p_atr);
+    
+    switch (ret)
+    {    
+    case 0:
+        SC_WARNING("Incomplete ATR\n");
+        return -1;
+    case -1:
+        SC_WARNING("ATR CRC Error\n");
+        //return -1;                    
+    }            
+                
+#ifdef COMPRESS_ATR_DEBUG_EN
+    SC_ATR_DBG("ATR Len = %d\n", p_atr->length);
+    SC_ATR_DBG("ATR = ");
+    for (i=0; i<p_atr->length; i++)    
+        SC_ATR_DBG(" %02x\n", p_atr->data[i]);
+#endif
+        
+    memset(p_info, 0, sizeof(*p_info));
+            
+    p_info->TS = p_atr->data[id++];
+        
+    p_info->T0 = p_atr->data[id++];        
+    
+    for (i=0; i<4; i++)    
+        if (p_info->T0 & (0x10 << i))
+            p_info->T1[i] = p_atr->data[id++];        
+    
+    for (i=0; i<4; i++)    
+        if (p_info->T1[3] & (0x10 << i))
+            p_info->T2[i] = p_atr->data[id++];        
+    
+    for (i=0; i<4; i++)    
+        if (p_info->T2[3] & (0x10 << i))
+            p_info->T3[i] = p_atr->data[id++];        
+           
+    switch (p_info->T1[3] & 0xF)
+    {           
+    case 0:
+    case 15:
+        if ((p_atr->length - id) != (p_info->T0 & 0xF))
+        {
+            SC_WARNING("too much history bytes %d/%d \n", p_atr->length - id, p_info->T0 & 0xF);
+            return -1;
+        }
+        break;
+    default:
+        if ((p_atr->length - id -1) != (p_info->T0 & 0xF))
+        {
+            SC_WARNING("too much history bytes %d/%d \n", p_atr->length - id -1, p_info->T0 & 0xF);
+            return -1;
+        }        
+    }
+    memcpy(p_info->History, &p_atr->data[id], (p_info->T0 & 0xF));
+    
+    p_info->TCK = p_atr->data[p_atr->length-1];
+                                        
+    return 0;                                
+}
+
+
+
+
+
+/*------------------------------------------------------------------
+ * Func : is_atr_complete
+ *
+ * Desc : check is the atr_complete or not
+ *
+ * Parm : scd_atr : atr to check 
+ *         
+ * Retn : 1 : complete, 0 : not complete  
+ *------------------------------------------------------------------*/
+void init_atr(scd_atr* p_atr)
+{    
+    memset(p_atr, 0, sizeof(scd_atr));
+    p_atr->length        = 0;            
+}
+
+
+
+EXPORT_SYMBOL(init_atr);
+EXPORT_SYMBOL(decompress_atr);
+EXPORT_SYMBOL(is_atr_complete);
+
diff --git a/drivers/smartcard/core/scd_atr.h b/drivers/smartcard/core/scd_atr.h
new file mode 100755
index 00000000..2e8e4d1
--- /dev/null
+++ b/drivers/smartcard/core/scd_atr.h
@@ -0,0 +1,92 @@
+#ifndef __SCD_ATR_H__
+#define __SCD_ATR_H__
+
+typedef struct 
+{
+    unsigned char status;           // parse status
+    unsigned char progress;         // parse progress
+    
+    unsigned char T1Len;
+    unsigned char T2Len;
+    unsigned char T3Len;
+    unsigned char nHistoryBytes;
+    
+    //----------  info          
+    unsigned char TS;
+    unsigned char T0;
+    unsigned char T1[4];    
+    unsigned char T2[4];
+    unsigned char T3[4];    
+    unsigned char History[16];
+    unsigned char TCK;                        
+}scd_atr_info;
+
+
+#define get_ta1(p_atr_info)        (p_atr_info->T1[0])
+#define get_tb1(p_atr_info)        (p_atr_info->T1[1])
+#define get_tc1(p_atr_info)        (p_atr_info->T1[2])
+#define get_td1(p_atr_info)        (p_atr_info->T1[3]) 
+
+#define get_ta2(p_atr_info)        (p_atr_info->T2[0])
+#define get_tb2(p_atr_info)        (p_atr_info->T2[1])
+#define get_tc2(p_atr_info)        (p_atr_info->T2[2])
+#define get_td2(p_atr_info)        (p_atr_info->T2[3])
+
+#define get_ta3(p_atr_info)        (p_atr_info->T3[0])
+#define get_tb3(p_atr_info)        (p_atr_info->T3[1])
+#define get_tc3(p_atr_info)        (p_atr_info->T3[2])
+#define get_td3(p_atr_info)        (p_atr_info->T3[3])
+
+#define has_ta1(p_atr_info)        (p_atr_info->T0 & 0x10)
+#define has_tb1(p_atr_info)        (p_atr_info->T0 & 0x20)
+#define has_tc1(p_atr_info)        (p_atr_info->T0 & 0x40)
+#define has_td1(p_atr_info)        (p_atr_info->T0 & 0x80)
+
+#define has_ta2(p_atr_info)        (has_td1(p_atr_info) && (get_td1(p_atr_info) & 0x10))
+#define has_tb2(p_atr_info)        (has_td1(p_atr_info) && (get_td1(p_atr_info) & 0x20))
+#define has_tc2(p_atr_info)        (has_td1(p_atr_info) && (get_td1(p_atr_info) & 0x40))
+#define has_td2(p_atr_info)        (has_td1(p_atr_info) && (get_td1(p_atr_info) & 0x80))
+
+#define has_ta3(p_atr_info)        (has_td2(p_atr_info) && (get_td2(p_atr_info) & 0x10))
+#define has_tb3(p_atr_info)        (has_td2(p_atr_info) && (get_td2(p_atr_info) & 0x20))
+#define has_tc3(p_atr_info)        (has_td2(p_atr_info) && (get_td2(p_atr_info) & 0x40))
+#define has_td3(p_atr_info)        (has_td2(p_atr_info) && (get_td2(p_atr_info) & 0x80))
+
+#define ta1_f(p_atr_info)          ((get_ta1(p_info)>>4)& 0xF)
+#define ta1_d(p_atr_info)          (get_ta1(p_info) & 0xF)
+#define tc1_n(p_atr_info)          (get_tc1(p_atr_info) & 0xFF)
+#define td1_protocol(p_atr_info)   (get_td1(p_atr_info) & 0xF)
+
+#define td2_protocol(p_atr_info)   (get_td2(p_atr_info) & 0xF)
+#define td2_wi(p_atr_info)         (get_tc2(p_atr_info) & 0xFF)
+
+#define ta3_ifsc(p_atr_info)       (get_ta3(p_atr_info) & 0xFF)
+#define tb3_cwi(p_atr_info)        (get_td3(p_atr_info) & 0xF)
+#define tb3_bwi(p_atr_info)        ((get_td3(p_atr_info)>>4) & 0xF)
+
+typedef struct 
+{
+    int           length;
+    #define MAX_ATR_SIZE    128    
+    unsigned char data[MAX_ATR_SIZE];    
+}scd_atr;
+
+
+#define ATR_COMPLETE        0x80
+
+
+typedef enum {
+    VALID_ATR,
+    INVALID_ATR,
+    INCOMPLETE_ATR,
+}atr_status;
+
+
+extern int  is_atr_complete(scd_atr* p_atr);
+extern int  decompress_atr(scd_atr* p_atr, scd_atr_info* p_info);
+extern void init_atr(scd_atr* p_atr);
+
+#define SC_ATR_DBG          printk
+
+#endif  //__SCD_ATR_H__
+
diff --git a/drivers/smartcard/core/scd_buff.c b/drivers/smartcard/core/scd_buff.c
new file mode 100755
index 00000000..dc77924
--- /dev/null
+++ b/drivers/smartcard/core/scd_buff.c
@@ -0,0 +1,243 @@
+/* ------------------------------------------------------------------------- */
+/* sc_buff.c  smart card buffer                                             */
+/* ------------------------------------------------------------------------- */
+/*   Copyright (C) 2008 Kevin Wang <kevin_wang@realtek.com.tw>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    
+------------------------------------------------------------------------- 
+Update List :
+-------------------------------------------------------------------------     
+    1.1     |   20081211    | Add Spinlock Protection
+-------------------------------------------------------------------------*/
+#include <linux/kernel.h>
+#include <linux/slab.h>
+#include <linux/module.h>
+#include "scd_buff.h"
+
+MODULE_LICENSE("GPL");
+
+void scb_queue_head_init(sc_buff_head *head)
+{    
+    spin_lock_init(&head->lock);
+    INIT_LIST_HEAD(&head->list);      
+    head->qlen = 0;
+}
+
+
+void scb_queue_head(sc_buff_head *head, sc_buff* scb)
+{
+    unsigned long flags;
+    spin_lock_irqsave(&head->lock, flags);
+    
+    list_add(&scb->list,&head->list);
+    head->qlen++;
+    
+    spin_unlock_irqrestore(&head->lock, flags);
+}
+
+
+void scb_queue_tail(sc_buff_head *head, sc_buff* scb)
+{
+    unsigned long flags;
+    spin_lock_irqsave(&head->lock, flags);
+        
+    list_add_tail(&scb->list,&head->list);
+    head->qlen++;
+    
+    spin_unlock_irqrestore(&head->lock, flags);    
+}
+
+
+sc_buff *scb_dequeue(sc_buff_head *head)
+{    
+    sc_buff* scb = NULL; 
+    unsigned long flags;
+    spin_lock_irqsave(&head->lock, flags);
+        
+    if (!list_empty(&head->list))
+    {
+        scb = list_entry(head->list.next, sc_buff, list);        
+        list_del_init(&scb->list);                    
+        head->qlen--;
+    }    
+    
+    spin_unlock_irqrestore(&head->lock, flags);        
+    
+    return scb;
+}
+
+sc_buff *scb_dequeue_tail(sc_buff_head *head)
+{
+    sc_buff* scb = NULL; 
+    unsigned long flags;
+    spin_lock_irqsave(&head->lock, flags);
+        
+    
+    if (!list_empty(&head->list))
+    {
+        scb = list_entry(head->list.prev, sc_buff, list);        
+        list_del_init(&scb->list);                    
+        head->qlen--;
+    }
+    
+    spin_unlock_irqrestore(&head->lock, flags);            
+    
+    return scb;
+}
+
+
+unsigned int scb_queue_len(const sc_buff_head *head)
+{
+    return head->qlen;
+}
+
+
+void scb_queue_purge(sc_buff_head *head)
+{
+    sc_buff *scb;
+    unsigned long flags;
+    spin_lock_irqsave(&head->lock, flags);
+        
+    while ((scb = scb_dequeue(head)) != NULL)
+        kfree_scb(scb);
+        
+    spin_unlock_irqrestore(&head->lock, flags);                    
+}
+
+
+void init_scb(sc_buff* scb, unsigned char* p_buff, size_t size)
+{
+    if (scb)
+    {
+        INIT_LIST_HEAD(&scb->list);
+        init_completion(&scb->complete);        
+        scb->status = 0; 
+        scb->flags  = 0;
+        scb->head   = ((unsigned char*) scb) + sizeof(sc_buff);
+        scb->data   = scb->head;
+        scb->tail   = scb->head;
+        scb->end    = scb->head + size;
+        scb->len    = 0;            
+    }            
+}
+
+
+sc_buff* alloc_scb(size_t size)
+{        
+    sc_buff* scb = (sc_buff*) kmalloc(sizeof(sc_buff) + size, GFP_KERNEL);
+        
+    init_scb(scb, ((unsigned char*) scb) + sizeof(sc_buff), size);            
+    
+    return scb;
+}
+
+
+void kfree_scb(sc_buff* scb)
+{    
+    if (scb)       
+        kfree(scb);
+}
+
+
+#define CHECK_BOUNDRARY(scb)         do {\
+                                        if (scb->tail > scb->end)  \
+                                            printk(KERN_WARNING "scb over panic:  scb=%p scb->tail (%p) > scb->end (%p)\n", scb, scb->tail, scb->end);  \
+                                        if (scb->data < scb->head) \
+                                            printk(KERN_WARNING "scb under panic: scb=%p scb->data (%p) < scb->head (%p)\n", scb, scb->data, scb->head);  \
+                                     }while(0)
+
+
+ 
+int scb_tailroom(const sc_buff *scb)
+{
+    return scb->end - scb->tail;
+}
+ 
+
+// add data from tail of buffer
+void scb_reserve(sc_buff* scb, unsigned int len)
+{
+    scb->data += len;
+    scb->tail += len;        
+    CHECK_BOUNDRARY(scb);
+}
+
+
+// add data from tail of buffer
+unsigned char* scb_put(sc_buff* scb, unsigned int len)
+{
+    unsigned char* ptr = scb->tail;            
+    scb->tail += len;
+    scb->len  += len;
+    CHECK_BOUNDRARY(scb);                            
+    return ptr;
+}
+
+// add data from start of buffer
+unsigned char* scb_push(sc_buff *scb, unsigned int len)
+{    
+    scb->data -= len;
+    scb->len  += len;
+    CHECK_BOUNDRARY(scb);            
+    return scb->data;
+}
+
+
+// remove data from start of buffer
+unsigned char* scb_pull(sc_buff *scb, unsigned int len)
+{
+    if (len <= scb->len)            
+    {
+        scb->data += len;
+        scb->len  -= len;
+        return scb->data;    
+    }
+    return NULL;    
+}
+ 
+
+void scb_trim(sc_buff *scb, unsigned int len)
+{
+    if (scb->len > len)
+    {
+        scb->len  = len;
+        scb->tail = scb->data + len;
+    }    
+}
+
+
+void scb_purge(sc_buff* scb)
+{
+    scb->data = scb->head;
+    scb->tail = scb->head;    
+    scb->len  = 0;    
+}
+
+EXPORT_SYMBOL(scb_queue_head_init);
+EXPORT_SYMBOL(scb_queue_head);
+EXPORT_SYMBOL(scb_queue_tail);
+EXPORT_SYMBOL(scb_dequeue);
+EXPORT_SYMBOL(scb_dequeue_tail);
+EXPORT_SYMBOL(scb_queue_purge);
+EXPORT_SYMBOL(scb_queue_len);
+EXPORT_SYMBOL(alloc_scb);
+EXPORT_SYMBOL(kfree_scb);
+EXPORT_SYMBOL(scb_reserve);
+EXPORT_SYMBOL(scb_put);
+EXPORT_SYMBOL(scb_push);
+EXPORT_SYMBOL(scb_pull);
+EXPORT_SYMBOL(scb_trim);
+EXPORT_SYMBOL(scb_purge);
+EXPORT_SYMBOL(scb_tailroom);
diff --git a/drivers/smartcard/core/scd_buff.h b/drivers/smartcard/core/scd_buff.h
new file mode 100755
index 00000000..0ee7b95
--- /dev/null
+++ b/drivers/smartcard/core/scd_buff.h
@@ -0,0 +1,78 @@
+#ifndef __SC_BUFF_H__
+#define __SC_BUFF_H__
+
+#include <linux/list.h>
+#include <linux/spinlock.h>
+#include <linux/completion.h>
+
+#define RX_BUFFER_SIZE      64
+
+typedef struct {    
+    struct list_head    list;    
+    unsigned char       status;   
+    
+#define WAIT_XMIT       0xff
+#define XMIT_OK         0x00
+#define XMIT_FAIL       0x01    
+#define XMIT_TIMEOUT    0x02
+#define XMIT_ABORT      0x03
+  
+    unsigned char       flags;    
+#define NONBLOCK        0x80    
+    struct completion   complete;        
+    unsigned char*      head;          
+    unsigned char*      data;          
+    unsigned char*      tail;          
+    unsigned char*      end;    
+    unsigned char       len;        
+}sc_buff;
+
+
+typedef struct {
+    spinlock_t          lock;
+    struct list_head    list;     
+    unsigned int        qlen;                   
+}sc_buff_head;
+
+void            scb_queue_head_init(sc_buff_head *head);
+
+void            scb_queue_head  (sc_buff_head *head, sc_buff* scb);
+
+void            scb_queue_tail  (sc_buff_head *head, sc_buff* scb);
+
+sc_buff*        scb_dequeue     (sc_buff_head *head);
+
+sc_buff*        scb_dequeue_tail(sc_buff_head *head);
+
+void            scb_queue_purge (sc_buff_head *head);
+
+unsigned int    scb_queue_len   (const sc_buff_head *head);
+
+sc_buff*        alloc_scb(size_t size);
+
+void            kfree_scb(sc_buff* scb);
+
+void            init_scb(sc_buff* buff, unsigned char* p_buff, size_t size);
+
+void            scb_reserve (sc_buff* scb, unsigned int len);
+
+unsigned char*  scb_put     (sc_buff* scb, unsigned int len);
+
+unsigned char*  scb_push    (sc_buff* scb, unsigned int len);
+
+unsigned char*  scb_pull    (sc_buff* scb, unsigned int len);
+
+void            scb_trim    (sc_buff *scb, unsigned int len);
+
+void            scb_purge   (sc_buff* scb);
+
+int             scb_tailroom(const sc_buff* scb);
+
+
+
+
+
+
+#endif  //__SC_BUFF_H__
+
+
diff --git a/drivers/smartcard/core/scd_core.c b/drivers/smartcard/core/scd_core.c
new file mode 100755
index 00000000..b95764c
--- /dev/null
+++ b/drivers/smartcard/core/scd_core.c
@@ -0,0 +1,408 @@
+#include <linux/slab.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/device.h>
+#include <linux/delay.h>
+#include <linux/sched.h>
+#include <linux/wait.h>
+#include "scd.h"
+
+MODULE_LICENSE("GPL");
+
+#ifdef CONFIG_SMARTCARD_DEV_FILE
+#include "scd_dev.h"
+#endif  
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_bus_match
+ *
+ * Desc : scd dev exit function
+ *
+ * Parm : dev    : device
+ *        driver : driver
+ *         
+ * Retn : 1 : device & driver matched, 0 : device & driver not matched
+ *------------------------------------------------------------------*/
+int scd_bus_match(
+    struct device*          dev, 
+    struct device_driver*   drv
+    )
+{        
+    // scd bus have no idea to match device & driver, return 1 to pass all     
+    return 1;
+}
+
+
+/*------------------------------------------------------------------
+ * Func : scd_bus_suspend
+ *
+ * Desc : suspend scd dev
+ *
+ * Parm : dev    : device to be suspend 
+ *        state  : event : power state
+ *               PM_EVENT_ON      0
+ *               PM_EVENT_FREEZE  1
+ *               PM_EVENT_SUSPEND 2
+ *         
+ * Retn : 0
+ *------------------------------------------------------------------*/
+int scd_bus_suspend(struct device * dev, pm_message_t state)
+{    
+    scd_device* p_dev = to_scd_device(dev);
+    scd_driver* p_drv = to_scd_driver(dev->driver);    
+    return (p_drv->suspend) ? p_drv->suspend(p_dev) : 0;
+}
+
+
+/*------------------------------------------------------------------
+ * Func : scd_bus_resume
+ *
+ * Desc : resume scd bus
+ *
+ * Parm : dev    : device to be resumed 
+ *         
+ * Retn : 0
+ *------------------------------------------------------------------*/
+int scd_bus_resume(struct device * dev)
+{
+    scd_device* p_dev = to_scd_device(dev);
+    scd_driver* p_drv = to_scd_driver(dev->driver);    
+    return (p_drv->resume) ? p_drv->resume(p_dev) : 0;
+}
+
+
+
+struct bus_type scd_bus_type = {
+    .name    = "smartcard",
+    .match   = scd_bus_match,    
+    .suspend = scd_bus_suspend,    
+    .resume  = scd_bus_resume,    
+};
+
+
+
+/*------------------------------------------------------------------
+ * Func : register_scd_device
+ *
+ * Desc : register scd device
+ *
+ * Parm : device    : scd device to be registered
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void scd_device_release(struct device* dev)
+{    
+    scd_device* p_dev = to_scd_device(dev);
+    
+    SC_INFO("scd dev %s released\n", p_dev->name);    
+}
+
+
+//////////////////////////////////////////////////////////////////////////////
+//                                                                          //
+//                            scd_device                                    //
+//                                                                          //
+//////////////////////////////////////////////////////////////////////////////
+
+static scd_device* scd_device_list[MAX_SCD_DEVICE] = {0};
+
+/*------------------------------------------------------------------
+ * Func : register_scd_device
+ *
+ * Desc : register scd device
+ *
+ * Parm : device    : scd device to be registered
+ *         
+ * Retn : 0
+ *------------------------------------------------------------------*/
+int register_scd_device(scd_device* device)
+{
+    struct device* dev = &device->dev;
+    int i;
+    
+    for (i=0; i<MAX_SCD_DEVICE; i++)
+    {
+        if (scd_device_list[i]==NULL)
+        {                   
+            SC_INFO("register scd device '%s' (%p) to scd%d\n", device->name, dev, i);                
+            
+            dev_set_name(dev, "scd%d", i);     
+    
+            dev->bus = &scd_bus_type;
+    
+            dev->release  = scd_device_release;             
+            
+            if (device_register(dev)<0) 
+            {
+                SC_INFO("register scd device '%s' (%p) to scd%d failed\n", device->name, dev, i);
+                return -1;
+            }
+            
+            scd_device_list[i] = device;
+
+            return 0;
+        }
+    }
+    
+    SC_INFO("register scd device '%s' (%p) failed, no more free entry\n", device->name, dev);
+                       
+    return -1;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : unregister_scd_device
+ *
+ * Desc : unregister scd device
+ *
+ * Parm : device : scd device to be unregistered
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void unregister_scd_device(scd_device* device)
+{    
+    int i;
+        
+    for (i=0; i<MAX_SCD_DEVICE; i++)
+    {
+        if (scd_device_list[i]==device)   
+        { 
+            device_unregister(&device->dev);
+            scd_device_list[i] = NULL;
+        }
+    }
+}
+
+
+
+//////////////////////////////////////////////////////////////////////////////
+//                                                                          //
+//                            scd_driver                                    //
+//                                                                          //
+//////////////////////////////////////////////////////////////////////////////
+
+
+/*------------------------------------------------------------------
+ * Func : scd_drv_probe
+ *
+ * Desc : probe scd device
+ *
+ * Parm : dev : scd device to be probed
+ *         
+ * Retn : 0 : if supportted, others : failed
+ *------------------------------------------------------------------*/
+int scd_drv_probe(struct device * dev)
+{
+    scd_device* p_dev = to_scd_device(dev);    
+    scd_driver* p_drv = to_scd_driver(dev->driver);    
+    SC_INFO("probe : scd_dev '%s' (%p), scd_drv '%s' (%p)\n", p_dev->name, dev,p_drv->name, dev->driver);    
+    
+    if (!p_drv->probe)
+        return -ENODEV;
+        
+    if (p_drv->probe(p_dev)==0)        
+    {
+#ifdef CONFIG_SMARTCARD_DEV_FILE
+        create_scd_dev_node(p_dev);
+#endif        
+        return 0;    
+    }
+
+    return -ENODEV;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_drv_remove
+ *
+ * Desc : this function was used to inform the scd driver that a scd 
+ *        device has been removed
+ *
+ * Parm : dev : scd device to be removed
+ *         
+ * Retn : 0 for success, others failed
+ *------------------------------------------------------------------*/
+int scd_drv_remove(struct device * dev)
+{
+    scd_device* p_dev = to_scd_device(dev);    
+    scd_driver* p_drv = to_scd_driver(dev->driver);
+    
+    SC_INFO("remove smart card device '%s'\n", p_dev->name);
+    
+    if (p_drv->remove) 
+        p_drv->remove(p_dev);
+        
+#ifdef CONFIG_SMARTCARD_DEV_FILE   
+    create_scd_dev_node(p_dev);
+#endif  
+        
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_drv_shutdown
+ *
+ * Desc : this function was used to short down a scd device 
+ *
+ * Parm : dev : scd device to be shut down
+ *         
+ * Retn : 0 for success, others failed
+ *------------------------------------------------------------------*/
+void scd_drv_shutdown(struct device * dev)
+{
+    scd_device* p_dev = to_scd_device(dev);    
+    scd_driver* p_drv = to_scd_driver(dev->driver);    
+    
+    SC_INFO("shotdown smart card device '%s'\n", p_dev->name);            
+    
+    if (p_drv->enable)
+        p_drv->enable(p_dev, 0);    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_drv_suspend
+ *
+ * Desc : this function was used to suspend a scd device 
+ *
+ * Parm : dev : scd device to be suspend
+ *         
+ * Retn : 0 for success, others failed
+ *------------------------------------------------------------------*/
+int scd_drv_suspend(struct device * dev, pm_message_t state)
+{
+    scd_device* p_dev = to_scd_device(dev);    
+    scd_driver*  p_drv = to_scd_driver(dev->driver);    
+    
+    SC_INFO("suspend scd_dev '%s'\n", p_dev->name);
+    return (p_drv->suspend) ? p_drv->suspend(p_dev) : 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_drv_resume
+ *
+ * Desc : this function was used to resume a scd device 
+ *
+ * Parm : dev : scd device to be suspend
+ *         
+ * Retn : 0 for success, others failed
+ *------------------------------------------------------------------*/
+int scd_drv_resume(struct device * dev)
+{
+    scd_device* p_dev = to_scd_device(dev);    
+    scd_driver*  p_drv = to_scd_driver(dev->driver);    
+    
+    SC_INFO("resume scd_dev '%s'\n", p_dev->name);
+        
+    return (p_drv->resume) ? p_drv->resume(p_dev) : 0;    
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : register_scd_driver
+ *
+ * Desc : register scd device driver
+ *
+ * Parm : driver    : scd device driver to be registered
+ *         
+ * Retn : 0
+ *------------------------------------------------------------------*/
+int register_scd_driver(scd_driver* driver)
+{
+    struct device_driver* drv = &driver->drv;
+    
+    drv->name     = driver->name;
+    drv->bus      = &scd_bus_type;
+    drv->probe    = scd_drv_probe;
+    drv->remove   = scd_drv_remove;
+    drv->shutdown = scd_drv_shutdown;
+    drv->suspend  = scd_drv_suspend;
+    drv->resume   = scd_drv_resume;
+    
+    SC_INFO("register scd driver '%s' (%p)\n", drv->name, drv);
+        
+    return driver_register(drv);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : unregister_scd_driver
+ *
+ * Desc : unregister scd driver
+ *
+ * Parm : driver : scd driver to be unregistered
+ *         
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void unregister_scd_driver(scd_driver* driver)
+{   
+    struct device_driver* drv = &driver->drv;    
+    SC_INFO("unregister scd driver '%s' (%p)\n", drv->name, &driver->drv); 
+    driver_unregister(&driver->drv);
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_dev_module_init
+ *
+ * Desc : scd dev init function
+ *
+ * Parm : N/A
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static int __init scd_core_init(void)
+{                 
+    SC_INFO("%s, register scd_bus %p\n",__FUNCTION__, &scd_bus_type);
+        
+#ifdef CONFIG_SMARTCARD_DEV_FILE
+    scd_dev_module_init();
+#endif        
+        
+    return bus_register(&scd_bus_type);     // register scd bus type            
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_dev_module_exit
+ *
+ * Desc : scd dev module exit function
+ *
+ * Parm : N/A
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static void __exit scd_core_exit(void)
+{       
+
+#ifdef CONFIG_SMARTCARD_DEV_FILE
+    scd_dev_module_exit();
+#endif            
+    
+    bus_unregister(&scd_bus_type);        // unregister scd bus    
+}
+
+
+
+module_init(scd_core_init);
+module_exit(scd_core_exit);
+
+
+EXPORT_SYMBOL(register_scd_device);
+EXPORT_SYMBOL(unregister_scd_device);
+
+EXPORT_SYMBOL(register_scd_driver);
+EXPORT_SYMBOL(unregister_scd_driver);
diff --git a/drivers/smartcard/core/scd_debug.h b/drivers/smartcard/core/scd_debug.h
new file mode 100755
index 00000000..0e427e2
--- /dev/null
+++ b/drivers/smartcard/core/scd_debug.h
@@ -0,0 +1,42 @@
+#ifndef __SCD_DEBUG_H__
+#define __SCD_DEBUG_H__
+
+
+//-- scd debug messages
+//#define CONFIG_SMARTCARD_DBG
+//#define CONFIG_SCD_INT_DBG
+//#define CONFIG_SCD_TX_DBG
+//#define CONFIG_SCD_RX_DBG
+//#define CONFIG_SCD_INFO
+//#define CONFIG_SCD_WARNING
+
+#ifdef  CONFIG_SMARTCARD_DBG
+#define SC_TRACE                   printk(KERN_WARNING "[SCD] TRACE, " fmt, ## args)  
+#else
+#define SC_TRACE(args...)    
+#endif
+
+
+#ifdef  CONFIG_SCD_INT_DBG
+#define SC_INT_DBG(fmt, args...)        printk(KERN_WARNING "[SCD] INT, " fmt, ## args)  
+#else
+#define SC_INT_DBG(args...)    
+#endif
+
+#ifdef CONFIG_SCD_INFO
+#define SC_INFO(fmt, args...)           printk(KERN_WARNING "[SCD] Info, " fmt, ## args)  
+#else
+#define SC_INFO(fmt, args...) 
+#endif
+
+#ifdef CONFIG_SCD_WARNING
+#define SC_WARNING(fmt, args...)        printk(KERN_EMERG "[SCD] Warning, " fmt, ## args)  
+#else
+#define SC_WARNING(fmt, args...)  
+#endif
+
+
+#endif  //__SCD_DEBUG_H__
+
+
+
diff --git a/drivers/smartcard/core/scd_dev.c b/drivers/smartcard/core/scd_dev.c
new file mode 100755
index 00000000..afe9739
--- /dev/null
+++ b/drivers/smartcard/core/scd_dev.c
@@ -0,0 +1,429 @@
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <linux/fs.h>
+#include <linux/cdev.h>
+#include <asm-generic/uaccess.h>
+#include "scd.h"
+#include "scd_dev.h"
+
+
+
+#define MAX_SCD_CNT     2
+static scd_dev          node_list[MAX_SCD_CNT];
+static dev_t            devno_base;
+static struct class *   scd_dev_class = NULL;
+
+void mars_scd_dumpdata(unsigned char* p_data, unsigned int len);
+
+void mars_scd_dumpdata(unsigned char* p_data, unsigned int len)
+{
+	int i = 0;
+	for(i=0;i<len;++i)
+	{
+		SC_INFO("data[%d] = 0x%x \n",i,p_data[i]);
+	}
+	SC_INFO("dump data end ~~   \n");
+}
+
+
+/*------------------------------------------------------------------
+ * Func : create_scd_dev_node
+ *
+ * Desc : create a scd device node
+ *
+ * Parm : device : handle of scd device
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+int create_scd_dev_node(scd_device* device)
+{               
+    int i;    
+    
+    for (i=0; i<MAX_SCD_CNT; i++)
+    {
+        if (node_list[i].device==NULL)
+        {
+            if (cdev_add(&node_list[i].cdev, devno_base + i, 1)<0)
+            {
+                SC_WARNING("scd warning : register character dev failed\n");    
+                return -1;
+            }
+   
+            node_list[i].device = device_create(
+                            scd_dev_class,      // class 
+                            NULL,               // parent
+                            devno_base + i,     // dev number
+                            device,             // driver data
+                            "scd-%d",            // device name
+                            i);                 // device id;                        
+            
+            return 0;
+        }
+    }
+    
+    return -1;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : remove_scd_dev_node
+ *
+ * Desc : remove a scd device node
+ *
+ * Parm : device : scd device to be unregistered
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+void remove_scd_dev_node(scd_device* device)
+{   
+    int i = 0;
+    
+    for (i=0; i<MAX_SCD_CNT; i++)
+    {
+        if (node_list[i].device && dev_get_drvdata(node_list[i].device)==(void*)device)
+        {
+            device_destroy(scd_dev_class, devno_base + i);       // remove device     
+            cdev_del(&node_list[i].cdev);
+            node_list[i].device = NULL;
+            return;
+        }
+    }
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_dev_open
+ *
+ * Desc : open function of scd dev
+ *
+ * Parm : inode : inode of dev
+ *        file  : context of file
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static 
+int scd_dev_open(struct inode *inode, struct file *file)
+{
+    unsigned int i = iminor(inode);    
+    scd_device*  dev = NULL;
+    
+    if (!node_list[i].device)
+        return -ENODEV;     
+    
+    dev = (scd_device*) dev_get_drvdata(node_list[i].device);
+    
+    if (dev)
+    {
+        scd_driver* drv = (scd_driver*) to_scd_driver(dev->dev.driver);                
+        file->private_data = dev;
+        drv->enable(dev, 1);
+        return 0;
+    }
+    
+    return -ENODEV;     
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_dev_release
+ *
+ * Desc : release function of scd dev
+ *
+ * Parm : inode : inode of dev
+ *        file  : context of file
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static 
+int scd_dev_release(
+    struct inode*           inode, 
+    struct file*            file
+    )
+{    
+    scd_device* dev = (scd_device*) file->private_data;
+    
+    if (dev) {
+        scd_driver* drv = (scd_driver*) to_scd_driver(dev->dev.driver);                
+        drv->enable(dev, 0);
+    }
+                
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_dev_read
+ *
+ * Desc : read function of scd dev
+ *
+ * Parm : file  : context of file
+ *        buff  : rx buffer addr
+ *        size  : rx buffer size
+ *        ofst  : read offset 
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static 
+ssize_t scd_dev_read(
+    struct file*            file,
+    char __user*            buff, 
+    size_t                  size,
+    loff_t*                 ofst           
+    )    
+{
+    scd_device* dev = (scd_device*) file->private_data;    
+    scd_driver* drv = (scd_driver*) to_scd_driver(dev->dev.driver);    
+    unsigned char tmp[512];
+    int ret;     
+    
+    if (size > sizeof(tmp))
+        size = sizeof(tmp); 
+        
+    ret = drv->read(dev, tmp, size); 
+	//SC_WARNING("read data~~  size=%d ret=%d \n",size,ret);
+    
+    if (ret > 0)
+    {
+		mars_scd_dumpdata(tmp, ret);
+        if (copy_to_user((unsigned char __user *) buff, tmp, ret)<0) 
+        {
+            SC_WARNING("read message failed, copy to user failed\n");
+            return -EFAULT;
+        }
+    }
+    
+    return ret;              
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_dev_write
+ *
+ * Desc : write function of scd dev
+ *
+ * Parm : file  : context of file
+ *        buff  : tx buffer addr
+ *        size  : tx buffer size
+ *        ofst  : write offset 
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static 
+ssize_t scd_dev_write(
+    struct file*            file,
+    const char __user*      buff, 
+    size_t                  size,
+    loff_t*                 ofst           
+    )    
+{
+    scd_device* dev = (scd_device*) file->private_data;    
+    scd_driver* drv = (scd_driver*) to_scd_driver(dev->dev.driver);        
+    unsigned char tmp[512]; 
+
+    if (copy_from_user(tmp, (unsigned char __user *)buff, size)) {
+        SC_WARNING("write message failed, copy data from user space failed\n");        
+        return -EFAULT;
+    }    
+	SC_INFO("write data start~~  \n");
+	mars_scd_dumpdata(tmp,size);
+    return drv->xmit(dev, tmp, size);     
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_dev_ioctl
+ *
+ * Desc : ioctl function of scd dev
+ *
+ * Parm : 
+ *        file  : context of file
+ *        cmd   : control command
+ *        arg   : arguments
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static 
+long scd_dev_ioctl(
+    struct file*            file,
+    unsigned int            cmd, 
+    unsigned long           arg
+    )
+{    
+    scd_device* dev = (scd_device*) file->private_data; 
+    scd_driver* drv;    
+    scd_atr     atr;
+    scd_atr*    p_atr;
+    sc_msg_buff buff;    
+    int         i;
+    scd_param   param;
+    scd_ifd_param ifd_param;
+    int         ret;
+    
+    if (!dev)
+        return -ENODEV;     
+        
+    drv = (scd_driver*) to_scd_driver(dev->dev.driver);            
+        
+    switch (cmd)
+    {
+    case SCD_SETPARAM:                
+        
+        if (copy_from_user(&ifd_param, (scd_ifd_param __user *)arg, sizeof(ifd_param)))
+            return -EFAULT;
+            
+        ret  = drv->set_param(dev, SC_PARAM_CLOCK, ifd_param.clk);
+        ret |= drv->set_param(dev, SC_PARAM_ETU,   ifd_param.etu);         
+        return ret;
+    
+    case SCD_GETPARAM:                
+                
+        if (drv->get_param(dev, SC_PARAM_CLOCK, &ifd_param.clk)<0)
+            return -EFAULT;
+            
+        if (drv->get_param(dev, SC_PARAM_ETU, &ifd_param.etu)<0)
+            return -EFAULT;           
+
+        return copy_to_user((scd_ifd_param __user *)arg, &ifd_param, sizeof(ifd_param));            
+                                
+    case SCD_SETPARAM_EX:                
+        
+        if (copy_from_user(&param, (scd_param __user *)arg, sizeof(param)))
+            return -EFAULT;
+                                               
+        return drv->set_param(dev, param.id, param.val);            
+        
+    case SCD_GETPARAM_EX:                   
+        if (copy_from_user(&param, (scd_param __user *)arg, sizeof(param)))
+            return -EFAULT;                 
+        if (drv->get_param(dev, param.id, (unsigned long *)&param.val)<0)
+            return -EFAULT;
+        return copy_to_user((scd_param __user *)arg, &param, sizeof(param));
+                
+	case SCD_ACTIVE:                    return drv->activate(dev);
+	case SCD_DEACTIVE:                return drv->deactivate(dev);	        
+	case SCD_RESET:                     return drv->reset(dev);     	          
+	case SCD_GET_CARD_STATUS:           return drv->get_card_status(dev);
+    case SCD_POLL_CARD_STATUS_CHANGE:   return drv->poll_card_status(dev);
+    case SCD_GET_ATR:
+        
+        if (drv->get_atr(dev, &atr))    
+            return -1;        
+                
+        p_atr = (scd_atr *)arg;                                                           
+            
+        put_user(atr.length, &p_atr->length);
+                
+        for(i=0; i < atr.length; i++)        
+            put_user(atr.data[i], &p_atr->data[i]);        
+            
+        return 0;
+
+    case SCD_READ:          
+        
+        if (copy_from_user(&buff, (sc_msg_buff __user *)arg, sizeof(sc_msg_buff)))
+            return -EFAULT;
+	//SC_WARNING("Read data length = %d  \n",buff.length);
+        return scd_dev_read(file, buff.p_data, buff.length, 0);
+    
+    case SCD_WRITE:                             
+        
+        if (copy_from_user(&buff, (sc_msg_buff __user *)arg, sizeof(sc_msg_buff)))
+            return -EFAULT;
+                    
+        return scd_dev_write(file, buff.p_data, buff.length, 0);
+
+            
+    default:        
+        return -EFAULT;          
+    }
+    
+    return 0;          
+}
+
+static long scd_dev_compat_ioctl(struct file* file,unsigned int cmd, unsigned long arg)
+{
+	 if (!file->f_op->unlocked_ioctl)
+                return -ENOTTY;
+#if defined(CONFIG_CPU_V7)
+	return file->f_op->unlocked_ioctl(file, cmd, arg);
+#else
+	return file->f_op->unlocked_ioctl(file, cmd,(unsigned long)compat_ptr(arg));
+#endif /* CONFIG_CPU_V7 */
+
+}
+
+static struct file_operations scd_dev_fops = 
+{
+    .owner      = THIS_MODULE,  
+    .unlocked_ioctl	= scd_dev_ioctl,
+    .compat_ioctl	= scd_dev_compat_ioctl,
+    .open       = scd_dev_open,
+    .read       = scd_dev_read,
+    .write      = scd_dev_write,
+    .release    = scd_dev_release,
+};
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_dev_module_init
+ *
+ * Desc : scd dev init function
+ *
+ * Parm : N/A
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+int __init scd_dev_module_init(void)
+{        
+    int i;
+    if (alloc_chrdev_region(&devno_base, 0, MAX_SCD_CNT, "smartcard")!=0)    
+        return -EFAULT;
+
+    scd_dev_class = class_create(THIS_MODULE, "scd-dev");
+           
+    for (i=0; i<MAX_SCD_CNT; i++) 
+    {   
+        cdev_init(&node_list[i].cdev, &scd_dev_fops);        
+        node_list[i].device = NULL;        
+    }
+        
+    return 0;
+}
+
+
+
+/*------------------------------------------------------------------
+ * Func : scd_dev_module_exit
+ *
+ * Desc : scd dev module exit function
+ *
+ * Parm : N/A
+ *         
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+void __exit scd_dev_module_exit(void)
+{   
+    int i = 0;            
+    
+    for (i=0; i<MAX_SCD_CNT; i++)    
+    {
+        if (node_list[i].device)
+            remove_scd_dev_node((scd_device*)dev_get_drvdata(node_list[i].device));
+    }
+    
+    unregister_chrdev_region(devno_base, MAX_SCD_CNT);
+    
+    class_destroy(scd_dev_class);
+}
diff --git a/drivers/smartcard/core/scd_dev.h b/drivers/smartcard/core/scd_dev.h
new file mode 100755
index 00000000..b7eec8a
--- /dev/null
+++ b/drivers/smartcard/core/scd_dev.h
@@ -0,0 +1,45 @@
+#ifndef __SCD_DEV_H__
+#define __SCD_DEV_H__
+
+#include <linux/cdev.h>
+#include "scd.h"
+
+#define SCD_IFD_ENABLE          0x7300
+#define SCD_RESET               0x7301
+#define SCD_SETPARAM            0x7302  
+#define SCD_GETPARAM            0x7303
+#define SCD_DEACTIVE            0x7306
+#define SCD_ACTIVE              0x7307
+#define SCD_GET_ATR             0x7309
+#define SCD_READ                0x730a
+#define SCD_WRITE               0x730b
+#define SCD_GET_CARD_STATUS     0x730d
+#define SCD_POLL_CARD_STATUS_CHANGE 0x730e
+
+#define SCD_SETPARAM_EX         0x7310  
+#define SCD_GETPARAM_EX         0x7311
+
+typedef struct {    
+    unsigned long clk;
+    unsigned long etu;                            
+}scd_ifd_param;
+
+typedef struct{                
+    unsigned char*  p_data;
+    unsigned int    length;
+}sc_msg_buff;
+
+
+typedef struct{        
+    struct cdev     cdev;
+    struct device*  device;
+}scd_dev;
+
+extern int  create_scd_dev_node(scd_device* dev);
+extern void remove_scd_dev_node(scd_device* dev);
+
+extern int scd_dev_module_init(void);
+extern void scd_dev_module_exit(void);
+
+#endif  //__SCD_DEV_H__
+
diff --git a/drivers/soc/Kconfig b/drivers/soc/Kconfig
index e6e90e8..5ca3efc 100644
--- a/drivers/soc/Kconfig
+++ b/drivers/soc/Kconfig
@@ -12,5 +12,6 @@ source "drivers/soc/tegra/Kconfig"
 source "drivers/soc/ti/Kconfig"
 source "drivers/soc/ux500/Kconfig"
 source "drivers/soc/versatile/Kconfig"
+source "drivers/soc/realtek/Kconfig"
 
 endmenu
diff --git a/drivers/soc/Makefile b/drivers/soc/Makefile
index 50c23d0..78f9476 100644
--- a/drivers/soc/Makefile
+++ b/drivers/soc/Makefile
@@ -16,3 +16,4 @@ obj-$(CONFIG_ARCH_TEGRA)	+= tegra/
 obj-$(CONFIG_SOC_TI)		+= ti/
 obj-$(CONFIG_ARCH_U8500)	+= ux500/
 obj-$(CONFIG_PLAT_VERSATILE)	+= versatile/
+obj-$(CONFIG_RTK_PLATFORM)      += realtek/
diff --git a/drivers/soc/realtek/Kconfig b/drivers/soc/realtek/Kconfig
new file mode 100644
index 00000000..14f2166
--- /dev/null
+++ b/drivers/soc/realtek/Kconfig
@@ -0,0 +1,116 @@
+config RTD119X
+	bool "Realtek RTD119X SoC family specific drivers"
+	depends on ARCH_RTD119X
+	default y
+	help
+	  Realtek RTD119X SoC family specific support.
+
+	  If unsure, say N.
+
+if RTD119X
+source "drivers/soc/realtek/rtd119x/Kconfig"
+source "drivers/soc/realtek/common/Kconfig"
+endif
+
+config RTD129x
+	bool "Realtek RTD129x SoC family specific drivers"
+	depends on ARCH_RTD129x
+	default y
+	help
+	  Realtek RTD129x SoC family specific support.
+
+	  If unsure, say N.
+
+if RTD129x
+source "drivers/soc/realtek/rtd129x/Kconfig"
+source "drivers/soc/realtek/common/Kconfig"
+endif # RTD129x
+
+config RTD129x_FPGA
+	bool "Realtek RTD129x FPGA"
+	depends on ARCH_RTD129x
+	select RTK_PLATFORM_FPGA
+	default n
+	help
+	   FPGA without boot code.
+
+config RTD139x
+	bool "Realtek RTD139x SoC family specific drivers"
+	depends on ARCH_RTD139x
+	default y
+	help
+	  Realtek RTD139x SoC family specific support.
+
+	  If unsure, say N.
+
+if RTD139x
+source "drivers/soc/realtek/rtd139x/Kconfig"
+source "drivers/soc/realtek/common/Kconfig"
+endif # RTD139x
+
+config RTD139x_FPGA
+	bool "Realtek RTD139x FPGA"
+	depends on ARCH_RTD139x
+	select RTK_PLATFORM_FPGA
+	default n
+	help
+	   FPGA without boot code.
+
+config RTD16xx
+	bool "Realtek RTD16xx SoC family specific drivers"
+	depends on ARCH_RTD16xx
+	default y
+	help
+	  Realtek RTD16xx SoC family specific support.
+
+	  If unsure, say N.
+
+if RTD16xx
+source "drivers/soc/realtek/rtd16xx/Kconfig"
+source "drivers/soc/realtek/common/Kconfig"
+endif # RTD16xx
+
+config RTD16xx_FPGA
+	bool "Realtek RTD16xx FPGA"
+	depends on ARCH_RTD16xx
+	select RTK_PLATFORM_FPGA
+	default n
+	help
+	  FPGA without boot code.
+
+config RTD13xx
+	bool "Realtek RTD13xx SoC family specific drivers"
+	depends on ARCH_RTD13xx
+	default y
+	help
+	  Realtek RTD13xx SoC family specific support.
+
+	  If unsure, say N.
+
+if RTD13xx
+source "drivers/soc/realtek/rtd13xx/Kconfig"
+source "drivers/soc/realtek/common/Kconfig"
+endif # RTD13xx
+
+config RTD13xx_FPGA
+	bool "Realtek RTD13xx FPGA"
+	depends on ARCH_RTD13xx
+	select RTK_PLATFORM_FPGA
+	default n
+	help
+	  FPGA without boot code.
+
+config RTK_PLATFORM_FPGA
+	def_bool n
+
+config RTK_XEN_SUPPORT
+	bool "Realtek XEN support"
+	depends on XEN
+	default n
+	help
+	  Realtek XEN utility support.
+
+if RTK_XEN_SUPPORT
+source "drivers/soc/realtek/xen/Kconfig"
+
+endif
diff --git a/drivers/soc/realtek/Makefile b/drivers/soc/realtek/Makefile
new file mode 100644
index 00000000..679be93
--- /dev/null
+++ b/drivers/soc/realtek/Makefile
@@ -0,0 +1,6 @@
+obj-$(CONFIG_ARCH_RTD119X)	+= rtd119x/ common/
+obj-$(CONFIG_ARCH_RTD129x)	+= rtd129x/ common/
+obj-$(CONFIG_ARCH_RTD139x)	+= rtd139x/ common/
+obj-$(CONFIG_ARCH_RTD16xx)	= rtd16xx/ common/
+obj-$(CONFIG_ARCH_RTD13xx)	+= rtd13xx/ common/
+obj-$(CONFIG_RTK_XEN_SUPPORT)	+= xen/
diff --git a/drivers/soc/realtek/common/Kconfig b/drivers/soc/realtek/common/Kconfig
new file mode 100644
index 00000000..766cce27
--- /dev/null
+++ b/drivers/soc/realtek/common/Kconfig
@@ -0,0 +1,138 @@
+config RTK_SB2_SECURITY_DEBG
+	bool "Realtek system bridge security mode debug"
+	depends on HAVE_ARM_SMCCC
+	default n
+	help
+	  Enable helper functions for Realtek system bridge security mode debug. If unsure, say N.
+
+config RTK_RBUS_BARRIER
+	bool "Realtek rbus barrier"
+	depends on RTK_MEM_REMAP && (ARCH_RTD119X || ARCH_RTD129x || ARCH_RTD139x)
+	default y
+	help
+	  Enable helper functions for R-bus barrier. If unsure, say N.
+
+config RTK_MEM_REMAP
+	bool "Realtek memory remap"
+	default y
+	help
+	  Enable helper functions for static ioremap. If unsure, say N.
+
+config RTK_ACPU_RELOAD
+	bool "Realtek dynamic ACPU reload"
+	default n
+	help
+	  Dynamic ACPU stop/start mechanism. If unsure, say N.
+
+config RTK_IPCSHM_RESET
+	bool "Dynamic IPC share memory reset"
+	depends on RTK_ACPU_RELOAD
+	default n
+	help
+	  Reset IPC_SHM when performing dynamic ACPU stop/start. If unsure, say N.
+
+config RTK_REGMAP_I2C
+	bool
+	select REGMAP
+
+config RTK_REGMAP_MMIO
+	bool
+	select REGMAP
+
+config RTK_REGMAP_SECURE_MMIO
+	bool
+	select RTK_REGMAP_MMIO
+	depends on HAVE_ARM_SMCCC
+
+config RTK_MMIO
+	bool
+	select REGMAP_MMIO
+
+config RTK_MMIO_SECURE
+	bool
+	select RTK_MMIO
+	select RTK_REGMAP_SECURE_MMIO
+
+config RTK_MCP
+	bool "Realtek MCP driver"
+	default n
+	help
+	  Realtek MCP driver
+
+config RTK_VMX_ULTRA
+	bool "VMX ultra boot enable"
+	default n
+	select RTK_VMX_DRM
+        select DM_VERITY_FEC
+	help
+	  Set VMX ultra boot enable.
+
+config RTK_VMX_ULTRA_RAMFS_VENDOR
+	bool "VMX ultra boot enable ramfs vendor"
+	default n
+	help
+	  Set VMX ultra ramfs vendor enable.
+
+config RTK_VMX_DRM
+	bool "VMX DRM"
+	default n
+	help
+	  Enable VMX DRM.
+
+config RTK_DEMOD
+	tristate "Realtek Demod Device Driver"
+	default y
+	depends on ARCH_RTD16xx
+	help
+	  This driver provides PM and userspace driver interface of Demod.
+
+config RTK_TP
+	tristate "Realtek TP Device Driver"
+	default y
+	depends on ARCH_RTD16xx
+	help
+	  This driver provides PM and userspace driver interface of TP.
+
+config RTK_R2RDSC
+	tristate "Realtek R2RDSC Device Driver"
+	default y
+	depends on ARCH_RTD16xx
+	help
+	  This driver provides PM and userspace driver interface of R2RDSC.
+
+config RTK_DCSYS
+	tristate "Realtek DCSYS Device Drviver"
+	depends on RTK_PERFCNT
+	help
+	  This driver provides support of multiple comsumers for using PC.
+
+config RTK_DMC
+	tristate "Realtek DMC Device Driver"
+	depends on RTK_PERFCNT
+	help
+	  This driver provides support of multiple comsumers for using PC,
+	  and safty DMC register access.
+
+config RTK_AVCPU_LOG
+	bool "Realtek AVCPU share memory logging system"
+	depends on RTK_RPC
+	help
+	  Enable AVCPU share memory logging read from userspace
+	  via device node.
+
+config RTK_USB_CTRL_MANAGER
+	tristate "RTK Multiple USB Host/Device Controller Manager"
+	default y if USB_OHCI_RTK || USB_EHCI_RTK || USB_DWC3_RTK
+	---help---
+	  The Realtek chips are Multiple host/peripheral USB controllers.
+	  Enable the driver to control clock, reset and usb power gpio.
+
+source "drivers/soc/realtek/common/Kconfig.workaround"
+source "drivers/soc/realtek/common/rpc/Kconfig"
+source "drivers/soc/realtek/common/pwrctrl/Kconfig"
+source "drivers/soc/realtek/common/hse/Kconfig"
+source "drivers/soc/realtek/common/debug/Kconfig"
+source "drivers/soc/realtek/common/dvfs/Kconfig"
+source "drivers/soc/realtek/common/perfcnt/Kconfig"
+source "drivers/soc/realtek/common/info/Kconfig"
+source "drivers/soc/realtek/common/buflock/Kconfig"
diff --git a/drivers/soc/realtek/common/Kconfig.workaround b/drivers/soc/realtek/common/Kconfig.workaround
new file mode 100644
index 00000000..31b94ad
--- /dev/null
+++ b/drivers/soc/realtek/common/Kconfig.workaround
@@ -0,0 +1,4 @@
+config RTK_WORKAROUND_MALI_UTGARD_PM_RUNTIME_KEEP_ON
+	bool
+	depends on ARCH_RTD139x
+	default y
diff --git a/drivers/soc/realtek/common/Makefile b/drivers/soc/realtek/common/Makefile
new file mode 100644
index 00000000..90faf34
--- /dev/null
+++ b/drivers/soc/realtek/common/Makefile
@@ -0,0 +1,26 @@
+obj-y += rtk_memory_remap.o rtk_barrier.o rtk_sb2_dbg.o rtk_dc_sys_dbg.o
+obj-y += rtk_chip.o
+obj-y += dummy_uctrl.o
+obj-y += rtk_sb2_sem.o
+obj-$(CONFIG_RTK_RPC) += rpc/
+obj-$(CONFIG_RTK_REGMAP_I2C) += rtk_regmap-i2c.o
+obj-$(CONFIG_RTK_REGMAP_MMIO) += rtk_regmap-mmio.o
+obj-$(CONFIG_RTK_MMIO) += rtk_mmio.o
+obj-$(CONFIG_RTK_MMIO_SECURE) += rtk_mmio-secure.o
+obj-$(CONFIG_ION_RTK) += rtk_ion_of.o
+obj-$(CONFIG_RTK_MCP) += rtk_mcp.o rtk_sha1.o
+obj-y += dvfs/
+obj-y += pwrctrl/
+obj-y += info/
+obj-$(CONFIG_RTK_HSE) += hse/
+obj-$(CONFIG_RTK_DEMOD) += rtk_demod.o
+obj-$(CONFIG_RTK_TP) += rtk_tp.o
+obj-$(CONFIG_RTK_R2RDSC) += rtk_r2rdsc.o
+obj-$(CONFIG_RTK_DCSYS) += rtk_dcsys.o
+obj-$(CONFIG_RTK_DMC) += rtk_dmc.o
+obj-$(CONFIG_RTK_PERFCNT) += perfcnt/
+obj-$(CONFIG_RTK_AVCPU_LOG) += rtk_avcpulog.o
+obj-y += debug/
+
+obj-$(CONFIG_RTK_USB_CTRL_MANAGER)	+= rtk-usb-manager.o
+obj-$(CONFIG_RTK_BUFLOCK) += buflock/
diff --git a/drivers/soc/realtek/common/buflock/Kconfig b/drivers/soc/realtek/common/buflock/Kconfig
new file mode 100644
index 00000000..83f9ed2
--- /dev/null
+++ b/drivers/soc/realtek/common/buflock/Kconfig
@@ -0,0 +1,7 @@
+config RTK_BUFLOCK
+	bool "Realtek BUFLOCK driver"
+	depends on RTK_MEM_REMAP
+	default n
+	help
+	  Realtek BUFLOCK driver
+
diff --git a/drivers/soc/realtek/common/buflock/Makefile b/drivers/soc/realtek/common/buflock/Makefile
new file mode 100644
index 00000000..3ab25bd
--- /dev/null
+++ b/drivers/soc/realtek/common/buflock/Makefile
@@ -0,0 +1,8 @@
+MODULE_NAME := buflock
+
+ccflags-y := -I$(obj)/inc
+ccflags-y += -I$(obj)/uapi
+ccflags-y += -DMODULE_NAME='"$(MODULE_NAME)"'
+
+obj-y   := $(MODULE_NAME).o
+$(MODULE_NAME)-objs := src/buflock.o
diff --git a/drivers/soc/realtek/common/buflock/src/buflock.c b/drivers/soc/realtek/common/buflock/src/buflock.c
new file mode 100644
index 00000000..ed86ea8
--- /dev/null
+++ b/drivers/soc/realtek/common/buflock/src/buflock.c
@@ -0,0 +1,876 @@
+#include <linux/kref.h>
+#include <linux/cdev.h>
+#include <linux/device.h>
+#include <linux/mutex.h>
+#include <linux/kthread.h>
+#include <linux/ktime.h>
+#include <linux/wait.h>
+#include <linux/slab.h>
+#include <linux/uaccess.h>
+#include <linux/module.h>
+
+#include "buflock.h"
+
+#include "../../../../../drivers/staging/android/ion/ion.h"
+#include "../../../../../drivers/staging/android/uapi/ion_rtk.h"
+extern struct ion_device *rtk_phoenix_ion_device;
+
+#define OFFSET_FROM_ID(id) (id * 4)
+
+#define MODULE_TAG "buflock :"
+
+struct buflock_module; /* main module */
+struct buflock_client; /* fd */
+struct buflock_handle; /* slot */
+
+struct buflock_handle {
+    struct buflock_module * module;
+    struct kref             ref;
+    struct list_head        list; /* module->handles */
+    struct mutex            mutex;
+
+    size_t                  id;
+    unsigned int            fwid;
+    buflock_status_t *      pStatus;
+
+
+    void            (*destroy)      (struct kref *kref);
+    unsigned int    (*getFWID)      (struct buflock_handle * handle);
+    void            (*get)          (struct buflock_handle * handle);
+    void            (*put)          (struct buflock_handle * handle);
+    int             (*setStatus)    (struct buflock_handle * handle, buflock_status_t status);
+    buflock_status_t(*getStatus)    (struct buflock_handle * handle);
+};
+
+struct buflock_slot {
+    struct buflock_handle * handle;
+    struct list_head        list; /* client->list */
+    struct mutex            mutex;
+};
+
+struct buflock_client {
+    struct buflock_module * module;
+    struct mutex            mutex;
+    struct list_head        slots; /* buflock_slot */
+    struct list_head        list; /* module->clients */
+
+    /*  client info. */
+    pid_t                   pid; 
+    pid_t                   tgid;
+    char                    task_comm[TASK_COMM_LEN];
+};
+
+struct buflock_module {
+    struct mutex            handles_lock;
+    struct list_head        handles;
+    struct list_head        free_handles;
+    wait_queue_head_t       free_queue;
+
+    struct mutex            clients_lock;
+    struct list_head        clients; /* buflock_client */
+
+    struct task_struct      *kthread;
+
+    dev_t                   dev_num;
+    struct device *         device;
+    struct cdev             dev;
+    struct class *          dev_class;
+
+    buflock_status_t *      pStatusMemory;
+    unsigned int            uStatusPhyAddr;
+
+    unsigned int            release_loop_ms;
+    size_t                  max_handles;
+
+    struct ion_client *     ion_client;
+    struct ion_handle *     ion_handle;
+};
+
+static struct buflock_handle *  buflock_handle_create               (struct buflock_module * module, size_t id, buflock_fwid_t fwid, buflock_status_t * pStatus);
+static void                     buflock_handle_destroy              (struct kref *kref);
+static unsigned int             buflock_handle_get_fwid             (struct buflock_handle * handle);
+static void                     buflock_handle_get                  (struct buflock_handle * handle);
+static void                     buflock_handle_put                  (struct buflock_handle * handle);
+static int                      buflock_handle_setStatus            (struct buflock_handle * handle, buflock_status_t status);
+static buflock_status_t         buflock_handle_getStatus            (struct buflock_handle * handle);
+static size_t                   buflock_module_get_unused_id_unlock (struct buflock_module * module);
+static struct buflock_handle *  buflock_module_handle_create        (struct buflock_module * module);
+static struct buflock_handle *  buflock_module_handle_get_by_fwid   (struct buflock_module * module, buflock_fwid_t fwid);
+static void                     buflock_module_handle_destroy       (struct kref *kref);
+static int                      buflock_fops_open                   (struct inode *inode, struct file *file);
+static int                      buflock_fops_close                  (struct inode *inode, struct file *file);
+static ssize_t                  buflock_fops_read                   (struct file *file, char *buf, size_t size, loff_t *f_pos);
+static ssize_t                  buflock_fops_write                  (struct file *file, const char *buf, size_t size, loff_t *f_pos);
+static long                     buflock_fops_ioctl                  (struct file *file, unsigned int cmd, unsigned long arg);
+
+static struct file_operations buflock_fops = {
+    .owner                  = THIS_MODULE,
+    .open                   = buflock_fops_open,
+    .release                = buflock_fops_close,
+    .read                   = buflock_fops_read,
+    .write                  = buflock_fops_write,
+    .unlocked_ioctl         = buflock_fops_ioctl,
+    .compat_ioctl           = buflock_fops_ioctl,
+};
+
+static char * getStatusStr (buflock_status_t st) {
+    switch (st) {
+        case E_BUFLOCK_ST_LOCK      : return "LOCK" ;
+        case E_BUFLOCK_ST_UNLOCK    : return "UNLOCK" ;
+        case E_BUFLOCK_ST_RELEASE   : return "RELEASE" ;
+        case E_BUFLOCK_ST_NORMAL    : return "NORMAL" ;
+        case E_BUFLOCK_ST_TOUCH     : return "TOUCH" ;
+        case E_BUFLOCK_ST_ERROR     : return "ERROR" ;
+        default: return "ERROR2";
+    };
+}
+
+static struct buflock_handle * buflock_handle_create(struct buflock_module * module,
+        size_t id, buflock_fwid_t fwid, buflock_status_t * pStatus)
+{
+    struct buflock_handle * ret = NULL;
+    do {
+        ret = (struct buflock_handle *) kzalloc(sizeof(struct buflock_handle), GFP_KERNEL);
+
+        kref_init       (&ret->ref);
+        mutex_init      (&ret->mutex);
+        INIT_LIST_HEAD  (&ret->list);
+
+        ret->module     = module;
+        ret->id         = id;
+        ret->fwid       = fwid;
+        ret->pStatus    = pStatus;
+
+        ret->destroy    = buflock_handle_destroy;
+        ret->getFWID    = buflock_handle_get_fwid;
+        ret->get        = buflock_handle_get;
+        ret->put        = buflock_handle_put;
+        ret->setStatus  = buflock_handle_setStatus;
+        ret->getStatus  = buflock_handle_getStatus;
+
+    } while (0);
+    return ret;
+}
+
+static void buflock_handle_destroy(struct kref *kref)
+{
+    struct buflock_handle * handle = container_of(kref, struct buflock_handle, ref);
+    mutex_destroy(&handle->mutex);
+    kfree(handle);
+}
+
+static unsigned int buflock_handle_get_fwid (struct buflock_handle * handle)
+{
+    unsigned int ret;
+    mutex_lock(&handle->mutex);
+    ret = handle->fwid;
+    mutex_unlock(&handle->mutex);
+    return ret;
+}
+
+static void buflock_handle_get(struct buflock_handle * handle)
+{
+    kref_get(&handle->ref);
+}
+
+static void buflock_handle_put(struct buflock_handle * handle)
+{
+    kref_put(&handle->ref, handle->destroy);
+}
+
+static int buflock_handle_setStatus (struct buflock_handle * handle, buflock_status_t status)
+{
+    int ret = -1;
+    mutex_lock(&handle->mutex);
+    if (handle->pStatus) {
+        *handle->pStatus = status;
+        ret = 0;
+    }
+    mutex_unlock(&handle->mutex);
+    return ret;
+}
+
+static buflock_status_t buflock_handle_getStatus(struct buflock_handle * handle)
+{
+    buflock_status_t ret = E_BUFLOCK_ST_ERROR;
+    mutex_lock(&handle->mutex);
+    if (handle->pStatus)
+        ret = *handle->pStatus;
+    mutex_unlock(&handle->mutex);
+    return ret;
+}
+
+/****************************************************************/
+
+static struct buflock_handle * buflock_module_handle_create        (struct buflock_module * module)
+{
+    struct buflock_handle * ret = NULL;
+    mutex_lock(&module->handles_lock);
+    do {
+        size_t              id      = buflock_module_get_unused_id_unlock(module);
+        buflock_fwid_t      fwid    = module->uStatusPhyAddr + OFFSET_FROM_ID(id);
+        buflock_status_t *  pStatus = &module->pStatusMemory[OFFSET_FROM_ID(id)];
+        struct buflock_handle * handle;
+
+        if (id >= module->max_handles)
+            break;
+
+        handle = buflock_handle_create(module, id, fwid, pStatus);
+
+        if (!handle)
+            break;
+
+        handle->module  = module;
+        handle->destroy = buflock_module_handle_destroy;
+        handle->setStatus(handle, E_BUFLOCK_ST_NORMAL);
+        list_add(&handle->list, &module->handles);
+
+        pr_debug("%s [+] handle=%p (id=%zu fwid=%u, status=%s)\n", MODULE_TAG, handle,
+                id, fwid, getStatusStr(handle->getStatus(handle)));
+
+        ret = handle;
+    } while(0);
+    mutex_unlock(&module->handles_lock);
+    return ret;
+}
+
+static size_t buflock_module_get_unused_id_unlock (struct buflock_module * module)
+{
+    size_t ret = 0;
+    struct buflock_handle * handle, * tmp_handle;
+REDISCOVER:
+    list_for_each_entry_safe(handle,  tmp_handle, &module->handles, list) {
+        if (handle && handle->id == ret) {
+            ret++;
+            goto REDISCOVER;
+        }
+    }
+    list_for_each_entry_safe(handle,  tmp_handle, &module->free_handles, list) {
+        if (handle && handle->id == ret) {
+            ret++;
+            goto REDISCOVER;
+        }
+    }
+    return ret;
+}
+
+static void buflock_module_handle_destroy (struct kref *kref)
+{
+    struct buflock_handle * handle = container_of(kref, struct buflock_handle, ref);
+    struct buflock_module * module = handle->module;
+    bool delayed_release = true;
+
+    mutex_lock(&module->handles_lock);
+    list_del(&handle->list);
+
+    pr_debug("%s [-] handle=%p (id=%zu fwid=%u, status=%s)\n", MODULE_TAG, handle,
+            handle->id, handle->getFWID(handle), getStatusStr(handle->getStatus(handle)));
+
+    if (handle->getStatus(handle) != E_BUFLOCK_ST_NORMAL) {
+        handle->setStatus(handle, E_BUFLOCK_ST_UNLOCK);
+        delayed_release = true;
+    }
+
+    if (delayed_release) {
+        list_add(&handle->list, &module->free_handles);
+    } else {
+        buflock_handle_destroy(&handle->ref);
+    }
+
+    wake_up(&module->free_queue);
+    mutex_unlock(&module->handles_lock);
+}
+
+static size_t buflock_module_free_count (struct buflock_module * module)
+{
+    size_t ret = 0;
+    mutex_lock(&module->handles_lock);
+    {
+        struct buflock_handle * handle, * tmp_handle;
+        list_for_each_entry_safe(handle,  tmp_handle, &module->free_handles, list) {
+            if (handle)
+                ret++;
+        }
+    }
+    mutex_unlock(&module->handles_lock);
+    return ret;
+}
+
+static int buflock_module_free_thread(void *data)
+{
+    struct buflock_module * module = (struct buflock_module *)data;
+    size_t free_cnt = 0;
+    for (;;) {
+        if (kthread_should_stop())
+            break;
+
+        wait_event_interruptible_timeout(module->free_queue,
+                (free_cnt != buflock_module_free_count(module)),
+                msecs_to_jiffies(module->release_loop_ms));
+
+        mutex_lock(&module->handles_lock);
+        {
+            struct buflock_handle * handle, * tmp_handle;
+            list_for_each_entry_safe(handle,  tmp_handle, &module->free_handles, list) {
+                if (!handle)
+                    continue;
+                switch (handle->getStatus(handle)) {
+                    case E_BUFLOCK_ST_NORMAL:
+                    case E_BUFLOCK_ST_RELEASE:
+                        handle->setStatus(handle, E_BUFLOCK_ST_NORMAL);
+                        list_del(&handle->list);
+                        buflock_handle_destroy(&handle->ref);
+                        break;
+                    default:
+                        break;
+                }
+            }
+        }
+        mutex_unlock(&module->handles_lock);
+
+        free_cnt = buflock_module_free_count(module);
+    }
+
+    return 0;
+}
+
+static struct buflock_handle * buflock_module_handle_get_by_fwid (struct buflock_module * module, buflock_fwid_t fwid)
+{
+    struct buflock_handle * ret = NULL;
+
+    mutex_lock(&module->handles_lock);
+    {
+        struct buflock_handle * handle, * tmp_handle;
+        list_for_each_entry_safe(handle,  tmp_handle, &module->handles, list) {
+            if (handle && buflock_handle_get_fwid(handle) == fwid) {
+                buflock_handle_get(handle);
+                ret = handle;
+                break;
+            }
+        }
+    }
+    mutex_unlock(&module->handles_lock);
+    return ret;
+}
+
+static struct buflock_module * gModule = NULL;
+static int __init buflock_module_init (void)
+{
+    int ret = -1;
+    do {
+        struct buflock_module * module;
+
+        if (gModule) {
+            ret = 0;
+            break;
+        }
+
+        gModule = (struct buflock_module *) kzalloc(sizeof(struct buflock_module), GFP_KERNEL);
+
+        module = gModule;
+
+        module->release_loop_ms = 5;
+        module->max_handles = 4096;
+        INIT_LIST_HEAD(&module->handles);
+        INIT_LIST_HEAD(&module->free_handles);
+        mutex_init(&module->handles_lock);
+
+        INIT_LIST_HEAD(&module->clients);
+        mutex_init(&module->clients_lock);
+
+        do {
+            ion_phys_addr_t         ion_phyAddr;
+            size_t                  ion_size;
+            unsigned int ion_flag_mask = ION_FLAG_NONCACHED | ION_USAGE_MMAP_NONCACHED;
+            ion_flag_mask |= ION_FLAG_SCPUACC | ION_FLAG_ACPUACC | ION_FLAG_VCPU_FWACC;
+
+            module->ion_client = ion_client_create(rtk_phoenix_ion_device, "buflock");
+            if (IS_ERR(module->ion_client)) {
+                module->ion_client = NULL;
+                break;
+            }
+
+            module->ion_handle = ion_alloc(module->ion_client, sizeof(unsigned int) * module->max_handles,
+                    0 /*align*/, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, ion_flag_mask);
+            if (IS_ERR(module->ion_handle))
+                module->ion_handle = ion_alloc(module->ion_client, sizeof(unsigned int) * module->max_handles,
+                        0 /*align*/, RTK_PHOENIX_ION_HEAP_MEDIA_MASK, ion_flag_mask);
+
+            if (IS_ERR(module->ion_handle)) {
+                ion_client_destroy(module->ion_client);
+                module->ion_handle = NULL;
+                module->ion_client = NULL;
+                break;
+            }
+
+            if (ion_phys(module->ion_client, module->ion_handle, &ion_phyAddr, &ion_size) != 0) {
+                ion_free(module->ion_client, module->ion_handle);
+                ion_client_destroy(module->ion_client);
+                module->ion_handle = NULL;
+                module->ion_client = NULL;
+                break;
+            }
+
+            module->uStatusPhyAddr = (unsigned int) ion_phyAddr;
+            module->pStatusMemory = (buflock_status_t *) ion_map_kernel(module->ion_client, module->ion_handle);
+            break;
+        } while (0);
+
+        if (!module->pStatusMemory) {
+            module->pStatusMemory = (buflock_status_t *) kzalloc(sizeof(unsigned int) * module->max_handles, GFP_KERNEL);
+            module->uStatusPhyAddr = (unsigned int) virt_to_phys(module->pStatusMemory);
+        }
+
+        {
+            cdev_init(&module->dev, &buflock_fops);
+            if (alloc_chrdev_region(&module->dev_num, 0, 1, MODULE_NAME)!=0) {
+                cdev_del(&module->dev);
+                kfree(module);
+                gModule = NULL;
+                break;
+            }
+
+            if (cdev_add(&module->dev, module->dev_num, 1)<0) {
+                cdev_del(&module->dev);
+                kfree(module);
+                gModule = NULL;
+                break;
+            }
+
+            module->dev_class = class_create(THIS_MODULE, MODULE_NAME);
+
+            module->device = device_create(
+                    module->dev_class,     // class
+                    NULL,                  // parent
+                    module->dev_num,       // dev number
+                    NULL,                  // driver data
+                    MODULE_NAME);          // device name
+        }
+
+        init_waitqueue_head(&module->free_queue);
+        module->kthread = kthread_create(buflock_module_free_thread, module, "buflock_release_thread");
+        wake_up_process(module->kthread);
+
+        ret = 0;
+    } while (0);
+    return ret;
+}
+
+static void __exit buflock_module_exit(void)
+{
+    struct buflock_module * module = gModule;
+    if (!module)
+        return;
+
+    kthread_stop(module->kthread);
+
+    {
+        struct buflock_handle * handle, * tmp_handle;
+        list_for_each_entry_safe(handle,  tmp_handle, &module->free_handles, list) {
+            if (handle) {
+                list_del(&handle->list);
+                buflock_handle_destroy(&handle->ref);
+            }
+        }
+
+        list_for_each_entry_safe(handle,  tmp_handle, &module->handles, list) {
+            if (handle) {
+                list_del(&handle->list);
+                buflock_handle_destroy(&handle->ref);
+            }
+        }
+    }
+
+    {
+        device_destroy(module->dev_class, module->device->devt);
+        class_destroy(module->dev_class);
+        cdev_del(&module->dev);
+        unregister_chrdev_region(module->dev_num, 1);
+    }
+
+    if (module->ion_handle) {
+        ion_free(module->ion_client, module->ion_handle);
+
+        if (module->ion_client)
+            ion_client_destroy(module->ion_client);
+    } else if (module->pStatusMemory)
+        kfree(module->pStatusMemory);
+
+    mutex_destroy(&module->handles_lock);
+    mutex_destroy(&module->clients_lock);
+
+    kfree(module);
+    gModule = NULL;
+}
+
+static struct buflock_slot * buflock_slot_create(struct buflock_handle * handle)
+{
+    struct buflock_slot * slot = NULL;
+    do {
+        slot = (struct buflock_slot *)
+            kzalloc(sizeof(struct buflock_slot), GFP_KERNEL);
+
+        mutex_init (&slot->mutex);
+        INIT_LIST_HEAD (&slot->list);
+        slot->handle = handle;
+    } while (0);
+    return slot;
+}
+
+static void buflock_slot_destroy(struct buflock_slot * slot)
+{
+    if (slot->handle)
+        slot->handle->put(slot->handle);
+    kfree(slot);
+}
+
+static struct buflock_client * buflock_client_create(struct buflock_module * module)
+{
+    struct buflock_client * ret = NULL;
+    do {
+        ret = (struct buflock_client *) kzalloc(sizeof(struct buflock_client), GFP_KERNEL);
+        mutex_init      (&ret->mutex);
+        INIT_LIST_HEAD  (&ret->slots);
+        INIT_LIST_HEAD  (&ret->list);
+        ret->module = module;
+
+        {
+            struct task_struct *task;
+            get_task_struct(current->group_leader);
+
+            task_lock(current->group_leader);
+            ret->pid = task_pid_nr(current->group_leader);
+            ret->tgid = task_tgid_nr(current->group_leader);
+            if (current->group_leader->flags & PF_KTHREAD)
+                task = NULL;
+            else
+                task = current->group_leader;
+            task_unlock(current->group_leader);
+
+            if (task)
+                get_task_comm(ret->task_comm, task);
+            else
+                strncpy(ret->task_comm, "KTHREAD", sizeof(ret->task_comm));
+
+            put_task_struct(current->group_leader);
+        }
+    } while (0);
+    return ret;
+}
+
+static void buflock_client_destroy(struct buflock_client * client)
+{
+    mutex_lock(&client->mutex);
+    {
+        struct buflock_slot * slot, * tmp_slot;
+        list_for_each_entry_safe(slot,  tmp_slot, &client->slots, list) {
+            list_del(&slot->list);
+            buflock_slot_destroy(slot);
+        }
+    }
+    mutex_unlock(&client->mutex);
+    mutex_destroy(&client->mutex);
+    kfree(client);
+}
+
+static int buflock_client_alloc_get_fwid (struct buflock_client * client, buflock_fwid_t * fwid)
+{
+    int ret = -1;
+    mutex_lock(&client->mutex);
+    do {
+        struct buflock_handle * handle;
+        struct buflock_slot * slot;
+
+        if (!fwid)
+            break;
+
+        handle = buflock_module_handle_create(client->module);
+
+        if (!handle)
+            break;
+
+        slot = buflock_slot_create(handle);
+
+        if (!slot) {
+            handle->put(handle);
+            break;
+        }
+
+        list_add (&slot->list, &client->slots);
+
+        *fwid = handle->getFWID(handle);
+
+        ret = 0;
+    } while (0);
+    mutex_unlock(&client->mutex);
+    return ret;
+}
+
+static int buflock_client_import_get_fwid (struct buflock_client * client, buflock_fwid_t fwid)
+{
+    int ret = -1;
+    mutex_lock(&client->mutex);
+    do {
+        struct buflock_handle * handle = buflock_module_handle_get_by_fwid(client->module, fwid);
+        struct buflock_slot * slot;
+
+        if (!handle)
+            break;
+
+        slot = buflock_slot_create(handle);
+
+        if (!slot) {
+            handle->put(handle);
+            break;
+        }
+
+        list_add (&slot->list, &client->slots);
+
+        ret = 0;
+    } while (0);
+    mutex_unlock(&client->mutex);
+    return ret;
+}
+
+static int buflock_client_release_get_fwid (struct buflock_client * client, buflock_fwid_t fwid)
+{
+    int ret = -1;
+    mutex_lock(&client->mutex);
+    {
+        struct buflock_slot * slot, * tmp_slot;
+        list_for_each_entry_safe(slot,  tmp_slot, &client->slots, list) {
+            if (slot && slot->handle && slot->handle->getFWID(slot->handle) == fwid) {
+                list_del(&slot->list);
+                buflock_slot_destroy(slot);
+                ret = 0;
+                break;
+            }
+        }
+    }
+    mutex_unlock(&client->mutex);
+    return ret;
+}
+
+static int buflock_client_set_status(struct buflock_client * client,
+        buflock_fwid_t fwid, buflock_status_t status)
+{
+    int ret = -1;
+    mutex_lock(&client->mutex);
+    {
+        struct buflock_slot * slot, * tmp_slot;
+        list_for_each_entry_safe(slot,  tmp_slot, &client->slots, list) {
+            if (slot && slot->handle && slot->handle->getFWID(slot->handle) == fwid) {
+                struct buflock_handle * handle = slot->handle;
+                ret = handle->setStatus(handle, status);
+                break;
+            }
+        }
+    }
+    mutex_unlock(&client->mutex);
+    return ret;
+}
+
+static int buflock_client_get_status(struct buflock_client * client,
+        buflock_fwid_t fwid, buflock_status_t * status)
+{
+    int ret = -1;
+    mutex_lock(&client->mutex);
+    {
+        struct buflock_slot * slot, * tmp_slot;
+        list_for_each_entry_safe(slot,  tmp_slot, &client->slots, list) {
+            if (slot && slot->handle && slot->handle->getFWID(slot->handle) == fwid) {
+                struct buflock_handle * handle = slot->handle;
+                *status = handle->getStatus(handle);
+                ret = 0;
+                break;
+            }
+        }
+    }
+    mutex_unlock(&client->mutex);
+    return ret;
+}
+
+static int buflock_fops_open (struct inode *inode, struct file *file)
+{
+    int ret = -1;
+    do {
+        struct cdev * dev  = inode->i_cdev;
+        struct buflock_module * module = container_of(dev, struct buflock_module, dev);
+        struct buflock_client * client = buflock_client_create(module);
+        if (!client)
+            break;
+
+        mutex_lock(&module->clients_lock);
+        list_add(&client->list, &module->clients);
+        mutex_unlock(&module->clients_lock);
+
+        file->private_data = client;
+        ret = 0;
+    } while (0);
+    return ret;
+}
+
+static int buflock_fops_close (struct inode *inode, struct file *file)
+{
+    struct buflock_client * client = file->private_data;
+    struct buflock_module * module = client->module;
+    if (module) {
+        mutex_lock(&module->clients_lock);
+        list_del(&client->list);
+        mutex_unlock(&module->clients_lock);
+    }
+    buflock_client_destroy(client);
+    return 0;
+}
+
+static ssize_t buflock_fops_read (struct file *file, char *buf, size_t size, loff_t *f_pos)
+{
+    ssize_t ret = 0;
+    struct buflock_client * f_client = file->private_data;
+    struct buflock_module * module = f_client->module;
+    do  {
+        char * str = (char *) kzalloc(size, GFP_KERNEL);
+        char * s = str;
+        if (!s)
+            break;
+
+        s += sprintf(s, "#%s ion(%p) phy=%08zx max=%zu checkloop_ms=%d\n", MODULE_NAME,
+                module->ion_handle, module->uStatusPhyAddr, module->max_handles, module->release_loop_ms);
+
+        s += sprintf(s, "    clients:\n");
+        mutex_lock(&module->clients_lock);
+        {
+            struct buflock_client * client, * tmp_client;
+            list_for_each_entry_safe(client,  tmp_client, &module->clients, list) {
+                if (!client)
+                    continue;
+                s += sprintf(s, "        %u %u [%s]\n", client->pid, client->tgid, client->task_comm);
+                mutex_lock(&client->mutex);
+                {
+                    struct buflock_slot * slot, * tmp_slot;
+                    list_for_each_entry_safe(slot,  tmp_slot, &client->slots, list) {
+                        if (!slot)
+                            continue;
+                        s += sprintf(s, "            %p\n", slot->handle);
+                    }
+                }
+                mutex_unlock(&client->mutex);
+            }
+        }
+        mutex_unlock(&module->clients_lock);
+
+        mutex_lock(&module->handles_lock);
+
+        s += sprintf(s, "    active handle:\n");
+        {
+            struct buflock_handle * handle, * tmp_handle;
+            list_for_each_entry_safe(handle,  tmp_handle, &module->handles, list) {
+                if (!handle)
+                    continue;
+                s += sprintf(s, "        %p (id=%08x, %s)\n", handle,
+                        handle->getFWID(handle), getStatusStr(handle->getStatus(handle)));
+            }
+        }
+
+        s += sprintf(s, "    inactive handle:\n");
+        {
+            struct buflock_handle * handle, * tmp_handle;
+            list_for_each_entry_safe(handle,  tmp_handle, &module->free_handles, list) {
+                if (!handle)
+                    continue;
+                s += sprintf(s, "        %p (id=%08x, %s)\n", handle,
+                        handle->getFWID(handle), getStatusStr(handle->getStatus(handle)));
+            }
+        }
+
+        mutex_unlock(&module->handles_lock);
+
+        ret = simple_read_from_buffer(buf, size, f_pos, str, s-str);
+        kfree(str);
+    } while (0);
+    return ret;
+}
+
+static ssize_t buflock_fops_write (struct file *file, const char *buf, size_t size, loff_t *f_pos)
+{
+    return 0;
+}
+
+static long buflock_fops_ioctl (struct file *file, unsigned int cmd, unsigned long arg)
+{
+    long ret = -1L;
+    struct buflock_client * client = (struct buflock_client *) file->private_data;
+    switch (cmd) {
+        case BUFLOCK_IOC_ALLOC:
+            {
+                struct buflock_alloc_data data;
+
+                if (buflock_client_alloc_get_fwid(client, &data.fwid) != 0)
+                    break;
+
+                if (copy_to_user((void __user *) arg, &data, sizeof(data))) {
+                    buflock_client_release_get_fwid(client, data.fwid);
+                    break;
+                }
+
+                ret = 0;
+            }
+            break;
+        case BUFLOCK_IOC_FREE:
+            {
+                struct buflock_import_data data;
+                if (copy_from_user(&data, (void __user *) arg, sizeof(data)))
+                    break;
+
+                if (buflock_client_release_get_fwid(client, data.fwid) != 0)
+                    break;
+                ret = 0;
+            }
+            break;
+        case BUFLOCK_IOC_IMPORT:
+            {
+                struct buflock_import_data data;
+                if (copy_from_user(&data, (void __user *) arg, sizeof(data)))
+                    break;
+
+                if (buflock_client_import_get_fwid(client, data.fwid) != 0)
+                    break;
+                ret = 0;
+            }
+            break;
+        case BUFLOCK_IOC_SET_STATUS:
+            {
+                struct buflock_status_data data;
+                if (copy_from_user(&data, (void __user *) arg, sizeof(data)))
+                    break;
+
+                if (buflock_client_set_status(client, data.fwid, data.status) != 0)
+                    break;
+                ret = 0;
+            }
+            break;
+        case BUFLOCK_IOC_GET_STATUS:
+            {
+                struct buflock_status_data data;
+                if (copy_from_user(&data, (void __user *) arg, sizeof(data)))
+                    break;
+
+                if (buflock_client_get_status(client, data.fwid, &data.status) != 0)
+                    break;
+
+                if (copy_to_user((void __user *) arg, &data, sizeof(data))) {
+                    buflock_client_release_get_fwid(client, data.fwid);
+                    break;
+                }
+                ret = 0;
+            }
+            break;
+        default:
+            break;
+    }
+    return ret;
+}
+
+module_init(buflock_module_init);
+module_exit(buflock_module_exit);
+MODULE_LICENSE("GPL");
diff --git a/drivers/soc/realtek/common/buflock/uapi/buflock.h b/drivers/soc/realtek/common/buflock/uapi/buflock.h
new file mode 100644
index 00000000..8ca63b4
--- /dev/null
+++ b/drivers/soc/realtek/common/buflock/uapi/buflock.h
@@ -0,0 +1,42 @@
+#ifndef __RTK_BUFLOCK_H__
+#define __RTK_BUFLOCK_H__
+
+#include <linux/ioctl.h>
+
+enum buflock_status {
+    E_BUFLOCK_ST_ERROR,
+    E_BUFLOCK_ST_NORMAL,
+    E_BUFLOCK_ST_TOUCH,
+    E_BUFLOCK_ST_LOCK,
+    E_BUFLOCK_ST_UNLOCK,
+    E_BUFLOCK_ST_RELEASE,
+};
+
+typedef unsigned char   buflock_status_t;
+typedef unsigned int    buflock_fwid_t;
+
+struct buflock_alloc_data {
+    buflock_fwid_t fwid;
+};
+
+struct buflock_import_data {
+    buflock_fwid_t fwid;
+};
+
+struct buflock_free_data {
+    buflock_fwid_t fwid;
+};
+
+struct buflock_status_data {
+    buflock_fwid_t      fwid;
+    buflock_status_t    status;
+};
+
+#define BUFLOCK_IOC_MAGIC       'B'
+#define BUFLOCK_IOC_ALLOC       _IOWR(BUFLOCK_IOC_MAGIC, 1, struct buflock_alloc_data)
+#define BUFLOCK_IOC_FREE        _IOWR(BUFLOCK_IOC_MAGIC, 2, struct buflock_free_data)
+#define BUFLOCK_IOC_IMPORT      _IOWR(BUFLOCK_IOC_MAGIC, 3, struct buflock_import_data)
+#define BUFLOCK_IOC_SET_STATUS  _IOWR(BUFLOCK_IOC_MAGIC, 4, struct buflock_status_data)
+#define BUFLOCK_IOC_GET_STATUS  _IOWR(BUFLOCK_IOC_MAGIC, 5, struct buflock_status_data)
+
+#endif /* __RTK_BUF_LOCK_H__ */
diff --git a/drivers/soc/realtek/common/debug/Kconfig b/drivers/soc/realtek/common/debug/Kconfig
new file mode 100644
index 00000000..5b7bdbd
--- /dev/null
+++ b/drivers/soc/realtek/common/debug/Kconfig
@@ -0,0 +1,6 @@
+config RTK_SRR_READER
+	bool "SRR Reader"
+	depends on HAVE_ARM_SMCCC
+	depends on ARCH_RTD16xx
+	depends on DEBUG_FS
+	default y
diff --git a/drivers/soc/realtek/common/debug/Makefile b/drivers/soc/realtek/common/debug/Makefile
new file mode 100644
index 00000000..8a34544
--- /dev/null
+++ b/drivers/soc/realtek/common/debug/Makefile
@@ -0,0 +1 @@
+obj-$(CONFIG_RTK_SRR_READER) += srr_read.o
diff --git a/drivers/soc/realtek/common/debug/srr_read.c b/drivers/soc/realtek/common/debug/srr_read.c
new file mode 100644
index 00000000..21e83f8
--- /dev/null
+++ b/drivers/soc/realtek/common/debug/srr_read.c
@@ -0,0 +1,65 @@
+/*
+ * srr_read.c -  Simple RBUS Register Reader
+ *
+ * Copyright (C) 2019, Realtek Semiconductor Corporation
+ *                     Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/module.h>
+#include <linux/debugfs.h>
+#include <linux/arm-smccc.h>
+
+MODULE_LICENSE("GPL");
+
+static u32 srr_read_addr;
+#define MAGIC_NUM             0x8400fffe
+#define RBUS_BASE             0x98000000
+#define RBUS_SIZE             0x200000
+
+static int srr_read_debugfs_u64_set(void *data, u64 val)
+{
+	srr_read_addr = 0;
+	if (val > RBUS_SIZE)
+		return -EINVAL;
+	if (val & 0x3)
+		return -EINVAL;
+	srr_read_addr = (u32)(val + RBUS_BASE);
+	return 0;
+}
+
+static int srr_read_debugfs_u64_get(void *data, u64 *val)
+{
+	struct arm_smccc_res res;
+	u32 addr = srr_read_addr;
+
+	if (!addr)
+		return -EINVAL;
+	arm_smccc_smc(MAGIC_NUM, addr, 0, 0, 0, 0, 0, 0, &res);
+	*val = res.a0;
+	return 0;
+}
+
+DEFINE_SIMPLE_ATTRIBUTE(srr_read_file_ops,
+			srr_read_debugfs_u64_get,
+			srr_read_debugfs_u64_set,
+			"%08llx\n");
+
+static __init int srr_read_init(void)
+{
+	debugfs_create_file("srr_read", 0644, NULL, NULL, &srr_read_file_ops);
+	return 0;
+}
+module_init(srr_read_init);
diff --git a/drivers/soc/realtek/common/dummy_uctrl.c b/drivers/soc/realtek/common/dummy_uctrl.c
new file mode 100644
index 00000000..4e57e6c
--- /dev/null
+++ b/drivers/soc/realtek/common/dummy_uctrl.c
@@ -0,0 +1,140 @@
+/*
+ * rtd139x_uctrl.c - Userspace Control Interface for RTD-139x
+ *
+ * Copyright (C) 2016-2017, Realtek Semiconductor Corporation
+ * Copyright (C) 2016-2017  Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#define pr_fmt(fmt) "uctrl: " fmt
+
+#include <linux/platform_device.h>
+#include <linux/fs.h>
+#include <linux/miscdevice.h>
+#include <linux/uaccess.h>
+
+#define RTK_UCTRL_IOCTL_MAGIC 0xEB
+#define RTK_UCTRL_IOCTL_NONE _IO(RTK_UCTRL_IOCTL_MAGIC,  0x00)
+/* v1.0 */
+#define RTK_UCTRL_IOCTL_CLK_EN_TP_SET _IO(RTK_UCTRL_IOCTL_MAGIC, 0x01)
+#define RTK_UCTRL_IOCTL_CLK_EN_TP_CLEAR _IO(RTK_UCTRL_IOCTL_MAGIC, 0x02)
+#define RTK_UCTRL_IOCTL_CLK_EN_TP_STATE \
+	_IOR(RTK_UCTRL_IOCTL_MAGIC, 0x03, unsigned int)
+#define RTK_UCTRL_IOCTL_RSTN_TP_SET _IO(RTK_UCTRL_IOCTL_MAGIC,  0x04)
+#define RTK_UCTRL_IOCTL_RSTN_TP_CLEAR _IO(RTK_UCTRL_IOCTL_MAGIC,  0x05)
+#define RTK_UCTRL_IOCTL_RSTN_TP_STATE \
+	_IOR(RTK_UCTRL_IOCTL_MAGIC, 0x06, unsigned int)
+/* v1.1 */
+#define RTK_UCTRL_IOCTL_GET_VERSION \
+	_IOR(RTK_UCTRL_IOCTL_MAGIC, 0x10, unsigned int)
+#define RTK_UCTRL_IOCTL_SET \
+	_IOW(RTK_UCTRL_IOCTL_MAGIC, 0x11, unsigned int)
+#define RTK_UCTRL_IOCTL_CLEAR \
+	_IOW(RTK_UCTRL_IOCTL_MAGIC, 0x12, unsigned int)
+#define RTK_UCTRL_IOCTL_STATE \
+	_IOWR(RTK_UCTRL_IOCTL_MAGIC, 0x13, unsigned int)
+
+static long rtk_uctrl_ioctl(struct file *filp, unsigned int cmd,
+	unsigned long arg)
+{
+	int ret = 0;
+	int state = 1;
+
+	switch (cmd) {
+	case RTK_UCTRL_IOCTL_CLK_EN_TP_SET:
+	case RTK_UCTRL_IOCTL_CLK_EN_TP_CLEAR:
+	case RTK_UCTRL_IOCTL_RSTN_TP_SET:
+	case RTK_UCTRL_IOCTL_RSTN_TP_CLEAR:
+		return -EINVAL;
+	case RTK_UCTRL_IOCTL_SET:
+	case RTK_UCTRL_IOCTL_CLEAR:
+		break;
+	default:
+		ret = copy_to_user((unsigned int __user *)arg,
+			&state, sizeof(unsigned int));
+		break;
+	}
+
+
+	return ret;
+}
+
+static long rtk_uctrl_compact_ioctl(struct file *filp, unsigned int cmd,
+	unsigned long arg)
+{
+	return rtk_uctrl_ioctl(filp, cmd, (unsigned long)arg);
+}
+
+static int rtk_uctrl_open(struct inode *inode, struct file *filp)
+{
+	return 0;
+}
+
+
+static int rtk_uctrl_release(struct inode *inode, struct file *filp)
+{
+	return 0;
+}
+
+static const struct file_operations rtk_uctrl_fops = {
+	.owner          = THIS_MODULE,
+	.open           = rtk_uctrl_open,
+	.unlocked_ioctl = rtk_uctrl_ioctl,
+	.compat_ioctl   = rtk_uctrl_compact_ioctl,
+	.release        = rtk_uctrl_release,
+};
+
+static struct miscdevice mdev;
+
+static int rtk_uctrl_probe(struct platform_device *pdev)
+{
+	int ret;
+	struct device *dev = &pdev->dev;
+
+	mdev.minor  = MISC_DYNAMIC_MINOR;
+	mdev.name   = "uctrl";
+	mdev.fops   = &rtk_uctrl_fops;
+	mdev.parent = NULL;
+
+	ret = misc_register(&mdev);
+	if (ret) {
+		pr_err("Failed to register misc device: %d\n", ret);
+		return ret;
+	}
+
+	dev_info(dev, "initialized\n");
+
+	return 0;
+}
+
+static struct platform_driver rtk_uctrl_driver = {
+	.probe = rtk_uctrl_probe,
+	.driver = {
+		.name = "rtk-uctrl",
+	},
+};
+
+static int __init rtk_uctrl_init(void)
+{
+	int ret;
+	struct platform_device *pdev;
+
+	ret = platform_driver_register(&rtk_uctrl_driver);
+	if (ret) {
+		pr_err("%s: platform_driver_register() returns %d\n", __func__, ret);
+		return ret;
+	}
+
+	pdev = platform_device_register_simple("rtk-uctrl", 0, NULL, 0);
+	if (IS_ERR(pdev)) {
+		ret = PTR_ERR(pdev);
+		pr_err("%s: platform_driver_register() returns %d\n", __func__, ret);
+		platform_driver_unregister(&rtk_uctrl_driver);
+		return ret;
+	}
+	return 0;
+}
+late_initcall(rtk_uctrl_init);
diff --git a/drivers/soc/realtek/common/dvfs/Kconfig b/drivers/soc/realtek/common/dvfs/Kconfig
new file mode 100644
index 00000000..51b50f4
--- /dev/null
+++ b/drivers/soc/realtek/common/dvfs/Kconfig
@@ -0,0 +1,26 @@
+config RTK_CPU_CACHE_SUPPLY_COORDINATOR
+	bool "Realtek CPU cache supply coordinator"
+	depends on REGULATOR_G2227
+	depends on ARCH_RTD129x
+	default y
+
+config RTK_CPU_SUPPLY_ENHANCER
+	bool "Realtek CPU supply enhancer"
+	depends on ARCH_RTD139x
+	default y
+
+config RTK_CPU_HIGH_LOAD_BOOSTER
+	bool "Realtek CPU high-load booster"
+	default n
+
+config RTK_CPU_VOLT_SEL
+	bool "Add OPP prop extn to CPU device"
+	default y
+
+config RTK_CPU_VOLT_SEL_CHIP_REV
+	bool
+	default y if ARCH_RTD139x
+
+config RTK_CPU_VOLT_SEL_DSS
+	bool
+	default y if ARCH_RTD16xx
diff --git a/drivers/soc/realtek/common/dvfs/Makefile b/drivers/soc/realtek/common/dvfs/Makefile
new file mode 100644
index 00000000..8a76ef0
--- /dev/null
+++ b/drivers/soc/realtek/common/dvfs/Makefile
@@ -0,0 +1,5 @@
+obj-$(CONFIG_RTK_SECURE_DVFS) += secure_dvfs.o
+obj-$(CONFIG_RTK_CPU_CACHE_SUPPLY_COORDINATOR) += cpu-cache-supp-coord.o
+obj-$(CONFIG_RTK_CPU_SUPPLY_ENHANCER) += cpu-supp-enh.o
+obj-$(CONFIG_RTK_CPU_HIGH_LOAD_BOOSTER) += cpu-hlb.o
+obj-$(CONFIG_RTK_CPU_VOLT_SEL) += cpu-volt-sel.o
diff --git a/drivers/soc/realtek/common/dvfs/cpu-cache-supp-coord.c b/drivers/soc/realtek/common/dvfs/cpu-cache-supp-coord.c
new file mode 100644
index 00000000..470ee81
--- /dev/null
+++ b/drivers/soc/realtek/common/dvfs/cpu-cache-supp-coord.c
@@ -0,0 +1,125 @@
+/*
+ * Realtek CPU cache supply coordinator
+ *
+ * Copyright (c) 2019, Realtek Semiconductor Corporation
+ *
+ * Author:
+ *        Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#define pr_fmt(fmt) "rtk-ccsc: " fmt
+#include <linux/cpufreq.h>
+#include <linux/platform_device.h>
+#include <linux/module.h>
+#include <linux/regulator/consumer.h>
+#include <linux/slab.h>
+
+struct rtk_ccsc_data {
+	struct device *dev;
+	struct notifier_block nb;
+	struct regulator *supply;
+};
+
+static int rtk_ccsc_cb(struct notifier_block *nb, unsigned long action, void *p)
+{
+	struct rtk_ccsc_data *data = container_of(nb, struct rtk_ccsc_data, nb);
+	struct pre_voltage_change_data *pvcd = p;
+	int target_uV;
+	int ret;
+
+	if (action != REGULATOR_EVENT_PRE_VOLTAGE_CHANGE)
+		return  NOTIFY_DONE;
+
+	if (pvcd->min_uV > 1050000)
+		target_uV = 1000000;
+	else if (pvcd->min_uV > 1000000)
+		target_uV = 950000;
+	else
+		target_uV = 900000;
+
+	ret = regulator_set_voltage(data->supply, target_uV, target_uV);
+	if (ret)
+		dev_warn(data->dev, "failed to set supply: %d\n", ret);
+
+	return NOTIFY_OK;
+}
+
+static int rtk_ccsc_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct rtk_ccsc_data *data;
+	struct regulator *cpu_supply;
+	int ret;
+
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	data->dev = dev;
+	data->supply = devm_regulator_get_optional(dev, "ldo3");
+	ret = PTR_ERR(data->supply);
+	if (ret < 0) {
+		if (ret == -EPROBE_DEFER || ret == -ENODEV) {
+			dev_dbg(dev, "ldo3: not ready\n");
+			return -EPROBE_DEFER;
+		}
+		dev_err(dev, "failed to get regulator: %d\n", ret);
+		return ret;
+	}
+
+	data->nb.notifier_call = rtk_ccsc_cb;
+
+	cpu_supply = regulator_get_optional(dev, "cpudvs");
+	if (IS_ERR(cpu_supply)) {
+		ret = PTR_ERR(cpu_supply);
+		dev_err(dev, "cpu_supply: failed to get regulator: %d\n", ret);
+		return ret;
+	}
+	regulator_register_notifier(cpu_supply, &data->nb);
+	regulator_put(cpu_supply);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static struct platform_driver rtk_ccsc_driver = {
+	.probe = rtk_ccsc_probe,
+	.driver = {
+		.owner = THIS_MODULE,
+		.name = "rtk-ccsc",
+	},
+};
+
+static int __init rtk_ccsc_init(void)
+{
+	int ret;
+	struct platform_device *pdev;
+
+	ret = platform_driver_register(&rtk_ccsc_driver);
+	if (ret) {
+		pr_err("failed to register platform driver: %d\n", ret);
+		return ret;
+	}
+
+	pdev = platform_device_register_simple("rtk-ccsc", PLATFORM_DEVID_NONE, NULL, 0);
+	if (IS_ERR(pdev)) {
+		ret = PTR_ERR(pdev);
+		pr_err("failed to register platform driver: %d\n", ret);
+		platform_driver_unregister(&rtk_ccsc_driver);
+		return ret;
+	}
+	return 0;
+}
+module_init(rtk_ccsc_init);
diff --git a/drivers/soc/realtek/common/dvfs/cpu-hlb.c b/drivers/soc/realtek/common/dvfs/cpu-hlb.c
new file mode 100644
index 00000000..d5816d7
--- /dev/null
+++ b/drivers/soc/realtek/common/dvfs/cpu-hlb.c
@@ -0,0 +1,282 @@
+/*
+ * Realtek CPU high-load booster
+ *
+ * Copyright (c) 2019, Realtek Semiconductor Corporation
+ *
+ * Author:
+ *        Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#define pr_fmt(fmt) "rtk-cpu-hlb: " fmt
+#include <linux/cpufreq.h>
+#include <linux/platform_device.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/cpu.h>
+#include <linux/device.h>
+#include <linux/of.h>
+#include <linux/workqueue.h>
+
+#define CPU_HLB_DEFAULT_BYPASS          (1)
+#define CPU_HLB_DEFAULT_FREQ_THRESHOLD  (1300000)
+#define CPU_HLB_DEFAULT_LOAD_THRESHOLD  (90)
+#define CPU_HLB_DEFAULT_POLLING_TIME    (500)
+
+struct rtk_cpu_hlb_data {
+	struct device *dev;
+	struct delayed_work dwork;
+	struct notifier_block nb;
+
+	/* sysfs */
+	bool bypass;
+	u32 polling_time;
+	u32 load_th;
+	u32 freq_th;
+
+	u32 limit;
+	u32 prev_limit;
+	u64 prev_update_time[CONFIG_NR_CPUS];
+	u64 prev_idle_time[CONFIG_NR_CPUS];
+};
+
+#define CPU_HLB_U32_DEVICE_ATTR(_m)                           \
+static ssize_t _m ## _store(struct device *dev,               \
+			    struct device_attribute *attr,    \
+			    const char *buf,                  \
+			    size_t count)                     \
+{                                                             \
+	struct rtk_cpu_hlb_data *data = dev_get_drvdata(dev); \
+	int ret;                                              \
+	u32 val;                                              \
+\
+	ret = kstrtou32(buf, 10, &val);                       \
+	if (ret)                                              \
+		return ret;                                   \
+	if (val != data->_m) {                                \
+		data->_m = val;                               \
+		cpufreq_update_policy(0);                     \
+	}                                                     \
+	return count;                                         \
+}                                                             \
+static ssize_t _m ##_show(struct device *dev,                 \
+			  struct device_attribute *attr,      \
+			  char *buf)                          \
+{                                                             \
+	struct rtk_cpu_hlb_data *data = dev_get_drvdata(dev); \
+\
+	return snprintf(buf, PAGE_SIZE, "%u\n", data->_m);    \
+}                                                             \
+DEVICE_ATTR_RW(_m)
+
+CPU_HLB_U32_DEVICE_ATTR(polling_time);
+CPU_HLB_U32_DEVICE_ATTR(load_th);
+CPU_HLB_U32_DEVICE_ATTR(freq_th);
+
+static ssize_t bypass_show(struct device *dev,
+			   struct device_attribute *attr,
+			   char *buf)
+{
+	struct rtk_cpu_hlb_data *data = dev_get_drvdata(dev);
+
+	return snprintf(buf, PAGE_SIZE, "%s\n",
+		data->bypass ? "true" : "false");
+}
+static ssize_t bypass_store(struct device *dev,
+			      struct device_attribute *attr,
+			      const char *buf,
+			      size_t count)
+{
+	struct rtk_cpu_hlb_data *data = dev_get_drvdata(dev);
+	int ret;
+	bool val;
+
+	ret = kstrtobool(buf, &val);
+	if (ret)
+		return ret;
+
+	if (val != data->bypass) {
+		data->bypass = val;
+		cpufreq_update_policy(0);
+	}
+	return count;
+}
+DEVICE_ATTR_RW(bypass);
+
+static struct attribute *hlb_attrs[] = {
+	&dev_attr_bypass.attr,
+	&dev_attr_polling_time.attr,
+	&dev_attr_load_th.attr,
+	&dev_attr_freq_th.attr,
+	NULL
+};
+
+static struct attribute_group hlb_attr_group = {
+	.name = "hlb",
+	.attrs = hlb_attrs,
+};
+
+static int
+rtk_cpu_hlb_cb(struct notifier_block *nb, unsigned long action, void *p)
+{
+	struct rtk_cpu_hlb_data *data = container_of(nb,
+		struct rtk_cpu_hlb_data, nb);
+	struct cpufreq_policy *policy = p;
+
+	if (data->bypass)
+		return NOTIFY_DONE;
+
+	if (action != CPUFREQ_ADJUST)
+		return NOTIFY_DONE;
+
+	if (data->limit == 1)
+		cpufreq_verify_within_limits(policy, 0, data->freq_th);
+	return NOTIFY_OK;
+}
+
+static void rtk_cpu_hlb_load_worker(struct work_struct *work)
+{
+	int cpu = cpumask_first(cpu_online_mask);
+	struct rtk_cpu_hlb_data *data = container_of(work,
+		struct rtk_cpu_hlb_data, dwork.work);
+	u32 max_load = 0;
+	struct cpufreq_policy *policy;
+	u32 j;
+
+	if (data->bypass)
+		goto done;
+
+	policy = cpufreq_cpu_get(cpu);
+	if (!policy) {
+		dev_err(data->dev, "can't get cpu policy, worker stop\n");
+		return;
+	}
+	for_each_cpu(j, policy->cpus) {
+		u64 update, idle;
+		u32 d_update, d_idle;
+		u32 load;
+
+		idle = get_cpu_idle_time(j, &update, 0);
+
+		d_idle = idle - data->prev_idle_time[j];
+		data->prev_idle_time[j] = idle;
+		d_update = update - data->prev_update_time[j];
+		data->prev_update_time[j] = update;
+
+		load = 100 * (d_update - d_idle) / d_update;
+		if (load > max_load)
+			max_load = load;
+	}
+	cpufreq_cpu_put(policy);
+
+	dev_dbg(data->dev, "max_load=%u\n", max_load);
+	data->prev_limit = data->limit;
+	data->limit = max_load <= data->load_th;
+	if (data->prev_limit != data->limit)
+		cpufreq_update_policy(cpu);
+done:
+	queue_delayed_work(system_freezable_wq, &data->dwork,
+		msecs_to_jiffies(data->polling_time));
+}
+
+static int rtk_cpu_hlb_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct rtk_cpu_hlb_data *data;
+	int ret;
+
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	data->dev = dev;
+	data->bypass       = CPU_HLB_DEFAULT_BYPASS;
+	data->polling_time = CPU_HLB_DEFAULT_POLLING_TIME;
+	data->load_th      = CPU_HLB_DEFAULT_LOAD_THRESHOLD;
+	data->freq_th      = CPU_HLB_DEFAULT_FREQ_THRESHOLD;
+
+	ret = sysfs_create_group(&dev->kobj, &hlb_attr_group);
+	if (ret) {
+		dev_err(dev, "sysfs_create_group() returns %d\n", ret);
+		return ret;
+	}
+
+	data->nb.notifier_call = rtk_cpu_hlb_cb;
+	cpufreq_register_notifier(&data->nb, CPUFREQ_POLICY_NOTIFIER);
+
+	INIT_DELAYED_WORK(&data->dwork, rtk_cpu_hlb_load_worker);
+	rtk_cpu_hlb_load_worker(&data->dwork.work);
+
+	platform_set_drvdata(pdev, data);
+	dev_info(dev, "bypass=%d, polling-ms=%u, load_th=%u, freq_th=%u\n",
+		data->bypass, data->polling_time, data->load_th, data->freq_th);
+	dev_info(dev, "initialized\n");
+	return 0;
+
+}
+
+static int rtk_cpu_hlb_remove(struct platform_device *pdev)
+{
+	struct rtk_cpu_hlb_data *data = platform_get_drvdata(pdev);
+	struct device *dev = &pdev->dev;
+
+	cancel_delayed_work(&data->dwork);
+	cpufreq_unregister_notifier(&data->nb, CPUFREQ_POLICY_NOTIFIER);
+	sysfs_remove_group(&dev->kobj, &hlb_attr_group);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+
+static struct platform_driver rtk_cpu_hlb_driver = {
+	.driver = {
+		.owner = THIS_MODULE,
+		.name = "rtk-cpu-hlb",
+	},
+	.probe = rtk_cpu_hlb_probe,
+	.remove = rtk_cpu_hlb_remove,
+};
+
+static struct platform_device *rtk_cpu_hlb_pdev;
+
+static int __init rtk_cpu_hlb_init(void)
+{
+	int ret;
+
+	ret = platform_driver_register(&rtk_cpu_hlb_driver);
+	if (ret) {
+		pr_err("failed to register platform driver: %d\n", ret);
+		return ret;
+	}
+
+	rtk_cpu_hlb_pdev = platform_device_register_simple("rtk-cpu-hlb",
+							   PLATFORM_DEVID_NONE,
+							   NULL, 0);
+	if (IS_ERR(rtk_cpu_hlb_pdev)) {
+		ret = PTR_ERR(rtk_cpu_hlb_pdev);
+		pr_err("failed to register platform driver: %d\n", ret);
+		platform_driver_unregister(&rtk_cpu_hlb_driver);
+		return ret;
+	}
+	return 0;
+}
+module_init(rtk_cpu_hlb_init);
+
+static void __exit rtk_cpu_hlb_exit(void)
+{
+	platform_device_unregister(rtk_cpu_hlb_pdev);
+	platform_driver_unregister(&rtk_cpu_hlb_driver);
+}
+module_exit(rtk_cpu_hlb_exit);
diff --git a/drivers/soc/realtek/common/dvfs/cpu-supp-enh.c b/drivers/soc/realtek/common/dvfs/cpu-supp-enh.c
new file mode 100644
index 00000000..dfbe7ef
--- /dev/null
+++ b/drivers/soc/realtek/common/dvfs/cpu-supp-enh.c
@@ -0,0 +1,113 @@
+/*
+ * Realtek CPU supply enhancer
+ *
+ * Copyright (c) 2019, Realtek Semiconductor Corporation
+ *
+ * Author:
+ *        Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#define pr_fmt(fmt) "rtk-cse: " fmt
+#include <linux/cpufreq.h>
+#include <linux/platform_device.h>
+#include <linux/module.h>
+#include <linux/regulator/consumer.h>
+#include <linux/slab.h>
+
+struct rtk_cse_data {
+	struct device *dev;
+	struct notifier_block nb;
+	struct regulator *supply;
+};
+
+static int rtk_cse_cb(struct notifier_block *nb, unsigned long action, void *p)
+{
+	struct rtk_cse_data *data = container_of(nb, struct rtk_cse_data, nb);
+	struct cpufreq_freqs *freqs = p;
+	int ret = 0;
+
+	if (action != CPUFREQ_PRECHANGE)
+		return NOTIFY_DONE;
+
+	ret = regulator_set_mode(data->supply, freqs->new >= 1000000 ?
+		REGULATOR_MODE_FAST : REGULATOR_MODE_NORMAL);
+	if (ret)
+		dev_err(data->dev, "failed to set mode: %d\n", ret);
+	return NOTIFY_OK;
+}
+
+static int rtk_cse_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct rtk_cse_data *data;
+	int ret;
+
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	data->dev = dev;
+	data->supply = regulator_get_optional(dev, "cpudvs");
+	if (IS_ERR(data->supply)) {
+		ret = PTR_ERR(data->supply);
+		if (ret == -EPROBE_DEFER || ret == -ENODEV) {
+			dev_dbg(dev, "cpudvs: not ready\n");
+			return -EPROBE_DEFER;
+		}
+		dev_err(dev, "failed to get regulator %d\n", ret);
+		return ret;
+	}
+
+	ret = regulator_get_mode(data->supply);
+	if (ret < 0 || !(ret & REGULATOR_MODE_FAST)) {
+		dev_info(dev, "cpudvs: not support fast mode\n");
+		return 0;
+	}
+	data->nb.notifier_call = rtk_cse_cb;
+	cpufreq_register_notifier(&data->nb, CPUFREQ_TRANSITION_NOTIFIER);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static struct platform_driver rtk_cse_driver = {
+	.probe = rtk_cse_probe,
+	.driver = {
+		.owner = THIS_MODULE,
+		.name = "rtk-cse",
+	},
+};
+
+static int __init rtk_cse_init(void)
+{
+	int ret;
+	struct platform_device *pdev;
+
+	ret = platform_driver_register(&rtk_cse_driver);
+	if (ret) {
+		pr_err("failed to register platform driver: %d\n", ret);
+		return ret;
+	}
+
+	pdev = platform_device_register_simple("rtk-cse", PLATFORM_DEVID_NONE, NULL, 0);
+	if (IS_ERR(pdev)) {
+		ret = PTR_ERR(pdev);
+		pr_err("failed to register platform device: %d\n", ret);
+		platform_driver_unregister(&rtk_cse_driver);
+		return ret;
+	}
+	return 0;
+}
+module_init(rtk_cse_init);
diff --git a/drivers/soc/realtek/common/dvfs/cpu-volt-sel.c b/drivers/soc/realtek/common/dvfs/cpu-volt-sel.c
new file mode 100644
index 00000000..21d2add
--- /dev/null
+++ b/drivers/soc/realtek/common/dvfs/cpu-volt-sel.c
@@ -0,0 +1,158 @@
+/*
+ * Realtek CPU volt sel
+ *
+ * Copyright (c) 2019, Realtek Semiconductor Corporation
+ *
+ * Author:
+ *        Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#define pr_fmt(fmt) "cpu-volt-sel: " fmt
+
+#include <linux/cpu.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/pm_opp.h>
+#include <linux/module.h>
+#include <soc/realtek/rtk_chip.h>
+#include <soc/realtek/rtk_event.h>
+#include <linux/clk.h>
+#include <linux/notifier.h>
+
+__maybe_unused
+static int __chip_rev_to_prop_name(char *name, size_t size)
+{
+	unsigned int val;
+
+	val = get_rtd_chip_revision();
+	if ((val & 0xFFF) == 0) {
+		pr_err("%s: invalid chip revision\n", __func__);
+		return -EINVAL;
+	}
+	snprintf(name, size, "%x", val);
+	return 0;
+}
+
+#define DSS7      0xA28
+
+static const struct of_device_id rtk_scpu_wrapper_ids[] __initconst = {
+	{.compatible = "Realtek,rtk-scpu_wrapper"},
+	{}
+};
+
+__maybe_unused
+static int __dss_to_prop_name(char *name, size_t size)
+{
+	struct device_node *np;
+	void *base;
+	unsigned int val;
+
+	np = of_find_matching_node(NULL, rtk_scpu_wrapper_ids);
+	if (!np) {
+		pr_err("%s: failed to find device node\n", __func__);
+		return -ENODEV;
+	}
+
+	base = of_iomap(np, 0);
+	if (!base) {
+		pr_err("%s: failed to ioremap\n", __func__);
+		return -ENOMEM;
+	}
+
+	val = readl(base + DSS7) & 0xfffff;
+	BUG_ON(val > 26000);
+	if (val > 23000)
+		snprintf(name, size, "ss");
+	else
+		snprintf(name, size, "tt");
+	iounmap(base);
+	return 0;
+}
+
+static int cpu_dev_set_prop_name(void)
+{
+	struct device *dev;
+	char buf[20];
+	int ret;
+
+	/*
+	 * NOTE: arm64 register cpu device in topology_init(),
+	 *       which is in subsys_initcall.
+	 */
+	dev = get_cpu_device(0);
+	if (!dev) {
+		pr_err("failed to get cpu device\n");
+		return -EINVAL;
+	}
+
+#if defined(CONFIG_RTK_CPU_VOLT_SEL_CHIP_REV)
+	ret = __chip_rev_to_prop_name(buf, sizeof(buf));
+#elif defined(CONFIG_RTK_CPU_VOLT_SEL_DSS)
+	ret = __dss_to_prop_name(buf, sizeof(buf));
+#else
+	ret = -EINVAL;
+#endif
+	if (ret)
+		return ret;
+
+	pr_info("dev_pm_opp_set_prop_name: name=%s\n", buf);
+
+	dev_pm_opp_set_prop_name(dev, buf);
+	return 0;
+}
+
+static int cpu_volt_sel_cb(struct notifier_block *nb, unsigned long event,
+			   void *data)
+{
+	struct clk *clk;
+	bool match;
+
+	if (event != CLK_EVENT_REGISTERED)
+		return NOTIFY_DONE;
+
+	clk = clk_get(NULL, "pll_scpu");
+	if (IS_ERR_OR_NULL(clk))
+		return NOTIFY_DONE;
+
+	match = clk_is_match(clk, data);
+	clk_put(clk);
+
+	if (!match)
+		return NOTIFY_DONE;
+
+	cpu_dev_set_prop_name();
+
+	return NOTIFY_OK;
+}
+
+struct notifier_block cpu_volt_sel_nb = {
+	.notifier_call = cpu_volt_sel_cb,
+};
+
+static __init int cpu_volt_sel_init(void)
+{
+	struct clk *clk;
+
+	clk = clk_get(NULL, "pll_scpu");
+	if (IS_ERR_OR_NULL(clk)) {
+		pr_info("pll_scpu not ready: register rtk-clk-event\n");
+		rtk_clk_notifier_register(&cpu_volt_sel_nb);
+		return 0;
+	}
+	clk_put(clk);
+	return cpu_dev_set_prop_name();
+}
+subsys_initcall_sync(cpu_volt_sel_init);
diff --git a/drivers/soc/realtek/common/dvfs/secure_dvfs.c b/drivers/soc/realtek/common/dvfs/secure_dvfs.c
new file mode 100644
index 00000000..685603e
--- /dev/null
+++ b/drivers/soc/realtek/common/dvfs/secure_dvfs.c
@@ -0,0 +1,16 @@
+#include <linux/init.h>
+
+static bool secure_dvfs_disabled;
+static int __init secure_dvfs_disabled_setup(char *__unused)
+{
+	secure_dvfs_disabled = true;
+	return 0;
+}
+__setup("secure_dvfs_disabled", secure_dvfs_disabled_setup);
+
+
+bool secure_dvfs_is_disabled(void)
+{
+	return secure_dvfs_disabled;
+}
+
diff --git a/drivers/soc/realtek/common/hse/Kconfig b/drivers/soc/realtek/common/hse/Kconfig
new file mode 100644
index 00000000..c754465
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/Kconfig
@@ -0,0 +1,29 @@
+
+config RTK_HSE
+	bool "Realtek Highspeed Streaming Engine driver"
+	default y if ARCH_RTD139x || ARCH_RTD16xx
+	help
+	  Enable Realtek HSE driver. If unsure, say N.
+
+config RTK_HSE_TESTBUF_EXPORT
+	bool "Reserve a testbuf to export"
+	default n
+
+config RTK_HSE_SELFTEST
+	bool "Realtek Highspeed Streaming Engine driver Selftest"
+	default n
+	depends on RTK_HSE
+	help
+	  Self-test after HSE driver ready.
+
+config RTK_HSE_HAS_YUY2
+	bool
+	default y if RTK_HSE_SELFTEST
+	depends on RTK_HSE
+	depends on ARCH_RTD16xx || ARCH_RTD13xx
+
+config RTK_HSE_HAS_ROTATE
+	bool
+	default y if RTK_HSE_SELFTEST
+	depends on RTK_HSE
+	depends on ARCH_RTD16xx || ARCH_RTD13xx
diff --git a/drivers/soc/realtek/common/hse/Makefile b/drivers/soc/realtek/common/hse/Makefile
new file mode 100644
index 00000000..474be074
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/Makefile
@@ -0,0 +1,10 @@
+ccflags-y += -I$(src)/include
+obj-y += rtk-hse.o
+
+rtk-hse-y += platform.o
+rtk-hse-y += engine.o
+rtk-hse-y += device.o
+rtk-hse-y += cq.o
+
+rtk-hse-$(CONFIG_RTK_HSE_SELFTEST) += test.o sw_func.o
+
diff --git a/drivers/soc/realtek/common/hse/cq.c b/drivers/soc/realtek/common/hse/cq.c
new file mode 100644
index 00000000..20d75a6
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/cq.c
@@ -0,0 +1,88 @@
+#include <linux/dma-mapping.h>
+#include <linux/slab.h>
+#include "hse.h"
+
+struct hse_command_queue *hse_cq_alloc(struct hse_device *hdev)
+{
+	struct device *dev = hdev->dev;
+	struct hse_command_queue *cq = NULL;
+
+	cq = kzalloc(sizeof(*cq), GFP_KERNEL);
+	if (!cq)
+		return NULL;
+
+	cq->hdev = hdev;
+	cq->size = PAGE_SIZE;
+	cq->virt = dma_alloc_coherent(dev, cq->size, &cq->phys,
+		GFP_KERNEL | GFP_DMA);
+	if (!cq->virt)
+		goto free_cq;
+
+	dev_dbg(hdev->dev, "%s: phys:%pad, virt=%p\n", __func__,
+		&cq->phys, cq->virt);
+	return cq;
+
+free_cq:
+	kfree(cq);
+	return NULL;
+}
+
+void hse_cq_free(struct hse_command_queue *cq)
+{
+	struct device *dev = cq->hdev->dev;
+
+	dma_free_coherent(dev, cq->size, cq->virt, cq->phys);
+	kfree(cq);
+}
+
+static inline void __hse_cq_add_data_one(struct hse_command_queue *cq, u32 data)
+{
+	u32 *ptr = (cq->virt + cq->pos);
+
+	if (cq->pos >= cq->size) {
+		WARN(1, "cq full\n");
+		return;
+	}
+
+	pr_debug("%s: add data=%08x to %p\n", __func__, data, ptr);
+	*ptr++ = data;
+	cq->pos += 4;
+
+	if ((cq->pos % 16) == 0) {
+		u32 tmp;
+
+		ptr -= 4;
+
+		tmp    = ptr[0];
+		ptr[0] = ptr[3];
+		ptr[3] = tmp;
+
+		tmp    = ptr[1];
+		ptr[1] = ptr[2];
+		ptr[2] = tmp;
+	}
+	hse_flush_dcache_area(cq->virt, cq->pos);
+}
+
+
+void hse_cq_add_data(struct hse_command_queue *cq, u32 *data, size_t size)
+{
+	int i;
+
+	for (i = 0; i < size; i++) {
+		__hse_cq_add_data_one(cq, data[i]);
+	}
+}
+
+void hse_cq_pad(struct hse_command_queue *cq)
+{
+	__hse_cq_add_data_one(cq, 0);
+	while (cq->pos % 16)
+		__hse_cq_add_data_one(cq, 0);
+	hse_flush_dcache_area(cq->virt, cq->pos);
+}
+
+void hse_cq_reset(struct hse_command_queue *cq)
+{
+	cq->pos = 0;
+}
diff --git a/drivers/soc/realtek/common/hse/device.c b/drivers/soc/realtek/common/hse/device.c
new file mode 100644
index 00000000..c6386cd
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/device.c
@@ -0,0 +1,177 @@
+#include <linux/module.h>
+#include <linux/fs.h>
+#include <linux/pm_runtime.h>
+#include <linux/slab.h>
+#include <linux/dma-mapping.h>
+#include "hse.h"
+#include "include/hsectl.h"
+
+#include <linux/uaccess.h>
+#include <linux/mm.h>
+
+struct hse_file_data {
+	struct hse_device *hdev;
+	struct hse_command_queue *cq;
+	atomic_t busy;
+};
+
+static int hse_open(struct inode *inode, struct file *filp)
+{
+	struct hse_device *hdev = container_of(filp->private_data,
+		struct hse_device, mdev);
+	struct hse_file_data *data;
+	int ret;
+
+	data = kzalloc(sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	data->hdev = hdev;
+	atomic_set(&data->busy, 0);
+	data->cq = hse_cq_alloc(hdev);
+	if (!data->cq) {
+		ret = -ENOMEM;
+		goto free_data;
+	}
+
+	filp->private_data = data;
+	pm_runtime_get_sync(hdev->dev);
+	return 0;
+free_data:
+	kfree(data);
+	return ret;
+}
+
+static int hse_release(struct inode *inode, struct file *filp)
+{
+	struct hse_file_data *data = filp->private_data;
+	struct hse_command_queue *cq = data->cq;
+
+	pm_runtime_put_sync(cq->hdev->dev);
+	hse_cq_free(cq);
+	kfree(data);
+	return 0;
+}
+
+static const struct vm_operations_struct hse_vm_ops = {
+#ifdef CONFIG_HAVE_IOREMAP_PROT
+        .access = generic_access_phys,
+#endif
+};
+
+#ifdef CONFIG_RTK_HSE_TESTBUF_EXPORT
+static int hse_mmap(struct file *filp, struct vm_area_struct *vma)
+{
+	struct hse_file_data *data = filp->private_data;
+	struct hse_device *hdev = data->hdev;
+	phys_addr_t addr = hdev->test_phys;
+	resource_size_t size = HSE_TEST_BUF_SIZE;
+
+	if (!hdev->test_virt)
+		return -ENOMEM;
+
+	if (vma->vm_end < vma->vm_start)
+		return -EINVAL;
+
+	if ((HSE_TEST_BUF_SIZE >> PAGE_SHIFT) <= vma->vm_pgoff)
+		return -EINVAL;
+
+	if ((vma->vm_end - vma->vm_start) > size)
+		return -EINVAL;
+
+	vma->vm_ops = &hse_vm_ops;
+	vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+	return remap_pfn_range(vma,
+			       vma->vm_start,
+			       (addr >> PAGE_SHIFT) + vma->vm_pgoff,
+			       vma->vm_end - vma->vm_start,
+			       vma->vm_page_prot);
+}
+#endif
+
+
+static long hse_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	struct hse_file_data *data = filp->private_data;
+	struct hse_command_queue *cq = data->cq;
+	int ret;
+	struct hse_cmd c;
+	struct hse_testbuf_info m __maybe_unused;
+	struct hse_engine *eng;
+	int busy;
+
+	switch (cmd) {
+	case HSE_IOCTL_ADD_CMD:
+		busy = atomic_xchg(&data->busy, 1);
+		if (busy)
+			return -EBUSY;
+
+		ret = copy_from_user(&c, (unsigned int __user *)arg, sizeof(c));
+		if (ret)
+			return ret;
+
+		hse_cq_add_data(cq, c.cmds, c.size);
+		atomic_set(&data->busy, 0);
+		break;
+
+	case HSE_IOCTL_START:
+		busy = atomic_xchg(&data->busy, 1);
+		if (busy)
+			return -EBUSY;
+
+		hse_cq_pad(cq);
+		eng = hse_engine_get_any(cq->hdev);
+		if (!eng)
+			return -EBUSY;
+		hse_engine_execute_cq(eng, cq);
+		hse_engine_put(eng);
+		hse_cq_reset(cq);
+		atomic_set(&data->busy, 0);
+		break;
+
+#ifdef CONFIG_RTK_HSE_TESTBUF_EXPORT
+	case HSE_IOCTL_SELFTEST_MEM:
+		if (!data->hdev->test_virt)
+			return -ENOMEM;
+
+		m.phys = data->hdev->test_phys;
+		m.size = HSE_TEST_BUF_SIZE;
+		ret = copy_to_user((void *)arg,  &m, sizeof (m));
+		if (ret)
+			return ret;
+		break;
+#endif
+	}
+
+	return 0;
+}
+
+static long hse_compact_ioctl(struct file *filp, unsigned int cmd,
+			      unsigned long arg)
+{
+	return hse_ioctl(filp, cmd, arg);
+}
+
+const struct file_operations hse_fops = {
+	.owner          = THIS_MODULE,
+	.open           = hse_open,
+	.unlocked_ioctl = hse_ioctl,
+	.compat_ioctl   = hse_compact_ioctl,
+	.release        = hse_release,
+#ifdef CONFIG_RTK_HSE_TESTBUF_EXPORT
+	.mmap           = hse_mmap,
+#endif
+};
+
+#ifdef CONFIG_RTK_HSE_TESTBUF_EXPORT
+int hse_create_testbuf(struct hse_device *hdev)
+{
+	hdev->test_virt = dma_alloc_coherent(hdev->dev, HSE_TEST_BUF_SIZE,
+				             &hdev->test_phys, GFP_KERNEL);
+	if (!hdev->test_virt) {
+		dev_err(hdev->dev, "failed to alloc test_buf\n");
+		return -ENOMEM;
+	}
+	return 0;
+}
+#endif
diff --git a/drivers/soc/realtek/common/hse/engine.c b/drivers/soc/realtek/common/hse/engine.c
new file mode 100644
index 00000000..68caa72
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/engine.c
@@ -0,0 +1,169 @@
+#include <linux/slab.h>
+#include "hse.h"
+#include "asm/cacheflush.h"
+
+static inline int hse_engine_read(struct hse_engine *eng, int offset)
+{
+	return hse_read(eng->hdev, eng->base_offset + offset);
+}
+
+static inline void hse_engine_write(struct hse_engine *eng, int offset,
+	unsigned int val)
+{
+	hse_write(eng->hdev, eng->base_offset + offset, val);
+}
+
+int hse_engine_suspend(struct hse_engine *eng)
+{
+	if (!eng)
+		return -EINVAL;
+
+	// TODO
+
+	return 0;
+}
+
+int hse_engine_resume(struct hse_engine *eng)
+{
+	if (!eng)
+		return -EINVAL;
+
+	// TODO
+
+	return 0;
+}
+
+static void hse_engine_cmd_done(struct hse_engine *eng)
+{
+	eng->cmd_done = true;
+	wake_up_interruptible(&eng->cmd_done_wait);
+}
+
+void hse_engine_check_ints(struct hse_engine *eng)
+{
+	u32 ints;
+
+	ints = hse_engine_read(eng, HSE_REG_ENGINE_OFFSET_INTS);
+	if (ints == 0)
+		return;
+	if (ints & 0x4)
+		eng->status |= HSE_STATUS_IRQ_CMD_ERR;
+	if (ints & 0x2)
+		eng->status |= HSE_STATUS_IRQ_OK;
+
+	/* stop the engine */
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_INTC, 0);
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_Q,    0);
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_INTS, 0x6);
+
+	hse_engine_cmd_done(eng);
+}
+
+void hse_engine_wait(struct hse_engine *eng)
+{
+	int ret;
+
+	ret = wait_event_interruptible_timeout(eng->cmd_done_wait,
+		(eng->cmd_done), msecs_to_jiffies(500));
+	if (ret == 0)
+		eng->status |= HSE_STATUS_TIMEOUT;
+	eng->cmd_done = false;
+}
+
+void hse_engine_execute_cq(struct hse_engine *eng, struct hse_command_queue *cq)
+{
+	struct device *dev = eng->hdev->dev;
+	/* fill the cq */
+	eng->cq = cq;
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_QB, cq->phys);
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_QL, cq->phys + cq->size);
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_QR, cq->phys);
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_QW, cq->phys + cq->pos);
+
+	dev_dbg(dev, "qb = %08x\n", hse_engine_read(eng, HSE_REG_ENGINE_OFFSET_QB));
+	dev_dbg(dev, "ql = %08x\n", hse_engine_read(eng, HSE_REG_ENGINE_OFFSET_QL));
+	dev_dbg(dev, "qr = %08x\n", hse_engine_read(eng, HSE_REG_ENGINE_OFFSET_QR));
+	dev_dbg(dev, "qw = %08x\n", hse_engine_read(eng, HSE_REG_ENGINE_OFFSET_QW));
+
+	/* start the engine */
+	eng->status = 0;
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_INTC, 0x6);
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_Q, 0x1);
+
+	/* wait */
+	hse_engine_wait(eng);
+	// check result
+	if (eng->status & ~HSE_STATUS_IRQ_OK)
+		dev_err(dev, "engine->status=%04x\n", eng->status);
+	dev_dbg(dev, "qb = %08x\n", hse_engine_read(eng, HSE_REG_ENGINE_OFFSET_QB));
+	dev_dbg(dev, "ql = %08x\n", hse_engine_read(eng, HSE_REG_ENGINE_OFFSET_QL));
+	dev_dbg(dev, "qr = %08x\n", hse_engine_read(eng, HSE_REG_ENGINE_OFFSET_QR));
+	dev_dbg(dev, "qw = %08x\n", hse_engine_read(eng, HSE_REG_ENGINE_OFFSET_QW));
+
+	eng->cq = NULL;
+}
+
+struct hse_engine *hse_engine_get_any(struct hse_device *hdev)
+{
+	int i;
+	struct hse_engine *eng, *ret = NULL;
+
+	for (i  = 0; i < HSE_MAX_ENGINES; i++) {
+		eng = hdev->engs[i];
+		if (!eng)
+			continue;
+
+		mutex_lock(&eng->req_lock);
+		if (eng->req == 0) {
+			ret = eng;
+			eng->req = 1;
+		}
+		mutex_unlock(&eng->req_lock);
+		if (ret)
+			break;
+	}
+	return ret;
+}
+
+void hse_engine_put(struct hse_engine *eng)
+{
+	if (!eng)
+		return;
+
+	mutex_lock(&eng->req_lock);
+	eng->req = 0;
+	mutex_unlock(&eng->req_lock);
+}
+
+int hse_engine_init(struct hse_device *hdev, int index)
+{
+	struct hse_engine *eng;
+	struct device *dev = hdev->dev;
+
+	eng = devm_kzalloc(dev, sizeof(*eng), GFP_KERNEL);
+	if (!eng)
+		return -ENOMEM;
+
+	eng->hdev = hdev;
+	eng->base_offset = HSE_REG_ENGINE_BASE(index);
+
+	mutex_init(&eng->req_lock);
+	eng->req = 0;
+	init_waitqueue_head(&eng->cmd_done_wait);
+	eng->cmd_done = false;
+
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_Q,   0);
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_QCL, 0);
+	hse_engine_write(eng, HSE_REG_ENGINE_OFFSET_QCH, 0);
+
+	hdev->engs[index] = eng;
+
+	return 0;
+}
+
+void hse_engine_fini(struct hse_device *hdev, int index)
+{
+	// TODO ...
+}
+
+
diff --git a/drivers/soc/realtek/common/hse/hse.h b/drivers/soc/realtek/common/hse/hse.h
new file mode 100644
index 00000000..fd8b474
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/hse.h
@@ -0,0 +1,139 @@
+#ifndef __SOC_REALTEK_HSE_H__
+#define __SOC_REALTEK_HSE_H__
+
+#include <linux/io.h>
+#include <linux/types.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+#include <linux/wait.h>
+#include <linux/miscdevice.h>
+#include "asm/cacheflush.h"
+
+#define HSE_MAX_ENGINES                 (2)
+#define HSE_TEST_BUF_SIZE               (2 * 1024 * 1024)
+
+#define HSE_REG_ENGINE_BASE(i)          (0x200 + 0x100 * (i))
+#define HSE_REG_ENGINE_OFFSET_QB        0x00
+#define HSE_REG_ENGINE_OFFSET_QL        0x04
+#define HSE_REG_ENGINE_OFFSET_QR        0x08
+#define HSE_REG_ENGINE_OFFSET_QW        0x0C
+#define HSE_REG_ENGINE_OFFSET_Q         0x10
+#define HSE_REG_ENGINE_OFFSET_INTS      0x14
+#define HSE_REG_ENGINE_OFFSET_SWAP      0x18
+#define HSE_REG_ENGINE_OFFSET_QCL       0x1C
+#define HSE_REG_ENGINE_OFFSET_QCH       0x20
+#define HSE_REG_ENGINE_OFFSET_INTC      0x24
+
+#define HSE_REG_BYPASS                  0x41c
+
+enum {
+	HSE_STATUS_IRQ_OK = 0x1,
+	HSE_STATUS_IRQ_CMD_ERR = 0x2,
+	HSE_STATUS_TIMEOUT = 0x4,
+};
+
+struct hse_device;
+struct hse_command_queue;
+
+struct hse_engine {
+	struct hse_device *hdev;
+	int base_offset;
+	unsigned int status;
+	struct mutex req_lock;
+	int req;
+	wait_queue_head_t cmd_done_wait;
+	bool cmd_done;
+	struct hse_command_queue *cq;
+};
+
+
+int hse_engine_init(struct hse_device *hdev, int index);
+void hse_engine_fini(struct hse_device *hdev, int index);
+int hse_engine_suspend(struct hse_engine *eng);
+int hse_engine_resume(struct hse_engine *eng);
+
+struct hse_engine *hse_engine_get_any(struct hse_device *hdev);
+void hse_engine_put(struct hse_engine *eng);
+
+void hse_engine_check_ints(struct hse_engine *eng);
+void hse_engine_execute_cq(struct hse_engine *eng, struct hse_command_queue *cq);
+
+
+struct hse_command_queue {
+	struct hse_device *hdev;
+	dma_addr_t phys;
+	void *virt;
+	size_t size;
+	int pos;
+};
+
+struct hse_command_queue *hse_cq_alloc(struct hse_device *hdev);
+void hse_cq_free(struct hse_command_queue *cq);
+void hse_cq_add_data(struct hse_command_queue *cq, u32 *data, size_t size);
+void hse_cq_pad(struct hse_command_queue *cq);
+void hse_cq_reset(struct hse_command_queue *cq);
+
+
+struct hse_device {
+	struct miscdevice mdev;
+	struct device *dev;
+	struct clk *clk;
+	struct reset_control *rstc;
+	void *base;
+	struct hse_engine *engs[HSE_MAX_ENGINES];
+	unsigned int engine_mask;
+	int irq;
+
+	/* for testbuf */
+#ifdef CONFIG_RTK_HSE_TESTBUF_EXPORT
+	void *test_virt;
+	dma_addr_t test_phys;
+#endif
+};
+
+static inline void hse_write(struct hse_device *hdev, unsigned int offset,
+	u32 val)
+{
+	dev_dbg(hdev->dev, "w: offset=%03x, val=%08x\n", offset, val);
+	writel(val, hdev->base + offset);
+}
+
+static inline int hse_read(struct hse_device *hdev, unsigned int offset)
+{
+	u32 v;
+
+	v = readl(hdev->base + offset);
+	dev_dbg(hdev->dev, "r: offset=%03x, val=%08x\n", offset, v);
+	return v;
+}
+
+extern const struct file_operations hse_fops;
+
+static inline void hse_flush_dcache_area(void *addr, size_t len)
+{
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(addr, len);
+#else
+	__flush_dcache_area(addr, len);
+#endif /* CONFIG_CPU_V7 */
+}
+
+#ifdef CONFIG_RTK_HSE_SELFTEST
+int hse_self_test(struct hse_device *hdev);
+#else
+static inline int hse_self_test(struct hse_device *hdev)
+{
+	return 0;
+}
+#endif
+
+#ifdef CONFIG_RTK_HSE_TESTBUF_EXPORT
+int hse_create_testbuf(struct hse_device *hdev);
+#else
+static inline int hse_create_testbuf(struct hse_device *hdev)
+{
+	return 0;
+}
+#endif
+
+#endif /* __SOC_REALTEK_HSE_H__ */
diff --git a/drivers/soc/realtek/common/hse/include/hse-sw.h b/drivers/soc/realtek/common/hse/include/hse-sw.h
new file mode 100644
index 00000000..9c1eb42
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/include/hse-sw.h
@@ -0,0 +1,26 @@
+#ifndef __HSE_SW_H__
+#define __HSE_SW_H__
+
+#ifdef __KERNEL__
+#include <linux/types.h>
+#else
+#include <stdint.h>
+#endif
+
+void __hse_sw_yuyv2nv12(void *dst0,
+			void *dst1,
+			void *src,
+			uint32_t width,
+			uint32_t height,
+			uint32_t src_pitch,
+			uint32_t dst_pitch);
+
+void __hse_sw_rotate(void *src,
+		     void *dst,
+		     uint32_t mode,
+		     uint32_t width,
+		     uint32_t height,
+		     uint32_t src_pitch,
+		     uint32_t dst_pitch);
+
+#endif /*__HSE_SW_H__ */
diff --git a/drivers/soc/realtek/common/hse/include/hsectl.h b/drivers/soc/realtek/common/hse/include/hsectl.h
new file mode 100644
index 00000000..7160dc7
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/include/hsectl.h
@@ -0,0 +1,30 @@
+#ifndef __HSECTL_H__
+#define __HSECTL_H__
+
+#ifdef __KERNEL__
+#include <linux/types.h>
+#else
+#include <stdint.h>
+#endif
+
+struct hse_cmd {
+	uint32_t size;
+	uint32_t cmds[32];
+};
+
+struct hse_testbuf_info {
+	uint64_t phys;
+	uint64_t size;
+};
+
+#define HSE_IOCTL_VERSION                _IOR('H', 0x00, unsigned int)
+#define HSE_IOCTL_ADD_CMD                _IOW('H', 0x01, struct hse_cmd)
+#define HSE_IOCTL_START                  _IO('H', 0x02)
+#define HSE_IOCTL_SELFTEST_MEM           _IOR('H', 0x03, struct hse_testbuf_info)
+
+
+#define HSE_ROTATE_MODE_90              0
+#define HSE_ROTATE_MODE_180             1
+#define HSE_ROTATE_MODE_270             2
+
+#endif /* __HSECTL_H__ */
diff --git a/drivers/soc/realtek/common/hse/platform.c b/drivers/soc/realtek/common/hse/platform.c
new file mode 100644
index 00000000..d22c2b2
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/platform.c
@@ -0,0 +1,200 @@
+#include <linux/interrupt.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/pm_runtime.h>
+#include <linux/slab.h>
+#include "hse.h"
+
+static int hse_hw_init(struct hse_device *hdev)
+{
+	hse_write(hdev, HSE_REG_BYPASS, 1);
+	return 0;
+}
+
+static int hse_runtime_suspend(struct device *dev)
+{
+	struct hse_device *hdev = dev_get_drvdata(dev);
+	int i;
+
+	dev_dbg(dev, "%s\n", __func__);
+	for (i = 0; i < HSE_MAX_ENGINES; i++)
+		hse_engine_suspend(hdev->engs[i]);
+	clk_disable_unprepare(hdev->clk);
+	reset_control_assert(hdev->rstc);
+
+	return 0;
+}
+
+static int hse_runtime_resume(struct device *dev)
+{
+	struct hse_device *hdev = dev_get_drvdata(dev);
+	int i;
+
+	dev_dbg(dev, "%s\n", __func__);
+	reset_control_deassert(hdev->rstc);
+	clk_prepare_enable(hdev->clk);
+	for (i = 0; i < HSE_MAX_ENGINES; i++)
+		hse_engine_resume(hdev->engs[i]);
+
+	return 0;
+}
+
+static const struct dev_pm_ops hse_pm_ops = {
+	.runtime_suspend = hse_runtime_suspend,
+	.runtime_resume  = hse_runtime_resume,
+};
+
+static irqreturn_t hse_interrupt(int irq, void *dev_id)
+{
+	struct hse_device *hdev = dev_id;
+	int i;
+
+	for (i = 0 ; i < HSE_MAX_ENGINES; i++) {
+		if (!hdev->engs[i])
+			continue;
+		if (!(BIT(i) & hdev->engine_mask))
+			continue;
+		dev_dbg(hdev->dev, "irq:%d fire to engine%d\n", irq, i);
+		hse_engine_check_ints(hdev->engs[i]);
+	}
+	return IRQ_HANDLED;
+}
+
+static int of_parse_engine_mask(struct device_node *np, int *mask)
+{
+	*mask = 0;
+	if (of_find_property(np, "engine-0-enabled", NULL))
+		*mask |= 0x1;
+	if (of_find_property(np, "engine-1-enabled", NULL))
+		*mask |= 0x2;
+
+	return *mask == 0 ? -EINVAL : 0;
+}
+
+static int hse_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	struct hse_device *hdev;
+	struct resource res;
+	int ret;
+	int i;
+
+	hdev = devm_kzalloc(dev, sizeof(*hdev), GFP_KERNEL);
+	if (!hdev)
+		return -ENOMEM;
+
+	platform_set_drvdata(pdev, hdev);
+	hdev->dev = dev;
+
+	ret = of_address_to_resource(np, 0, &res);
+	if (ret) {
+		dev_err(dev, "failed to get recource: %d\n", ret);
+		return -ENODEV;
+	}
+
+	hdev->base = devm_ioremap(dev, res.start, resource_size(&res));
+	if (!hdev->base)
+		return -ENOMEM;
+
+	hdev->clk = devm_clk_get(dev, NULL);
+	if (IS_ERR(hdev->clk)) {
+		ret = PTR_ERR(hdev->clk);
+		dev_err(dev, "failed to get clk: %d\n", ret);
+		return ret;
+	}
+
+	hdev->rstc = devm_reset_control_get(dev, NULL);
+	if (IS_ERR(hdev->rstc)) {
+		ret = PTR_ERR(hdev->rstc);
+		dev_err(dev, "failed to get reset control: %d\n", ret);
+		return ret;
+	}
+
+	ret = of_parse_engine_mask(np, &hdev->engine_mask);
+	if (ret) {
+		dev_err(dev, "no engine enabled\n");
+		return -ENODEV;
+	}
+	dev_dbg(dev, "engine_mask=%x\n", hdev->engine_mask);
+
+	hdev->irq = platform_get_irq(pdev, 0);
+	if (hdev->irq < 0) {
+		ret = hdev->irq;
+		dev_err(dev, "failed to get irq: %d\n", ret);
+		return ret;
+	}
+
+	ret = devm_request_irq(dev, hdev->irq, hse_interrupt, IRQF_SHARED,
+			       dev_name(dev), hdev);
+	if (ret) {
+		dev_err(dev, "failed to request irq: %d\n", ret);
+		return ret;
+	}
+
+	hdev->mdev.minor  = MISC_DYNAMIC_MINOR;
+	hdev->mdev.name   = "hse";
+	hdev->mdev.fops   = &hse_fops;
+	hdev->mdev.parent = NULL;
+	ret = misc_register(&hdev->mdev);
+	if (ret) {
+		dev_err(dev, "failed to register misc device: %d\n", ret);
+		return ret;
+	}
+
+	pm_runtime_set_suspended(dev);
+	pm_runtime_enable(dev);
+
+	pm_runtime_get_sync(dev);
+	hse_hw_init(hdev);
+	for (i = 0; i < HSE_MAX_ENGINES; i++) {
+		if (!(hdev->engine_mask & BIT(i)))
+			continue;
+
+		ret = hse_engine_init(hdev, i);
+		WARN(ret, "engine%d: failed to init: %d\n", i, ret);
+	}
+
+	if (!of_property_read_bool(np, "realtek,device-is-exclusive")) {
+		dev_info(dev, "shared mode\n");
+		pm_runtime_forbid(dev);
+	}
+	pm_runtime_put_sync(dev);
+
+	dev_info(dev, "initialized\n");
+
+	hse_self_test(hdev);
+	hse_create_testbuf(hdev);
+	return 0;
+}
+
+static int hse_remove(struct platform_device *pdev)
+{
+	struct hse_device *hdev = platform_get_drvdata(pdev);
+
+	pm_runtime_disable(hdev->dev);
+	reset_control_assert(hdev->rstc);
+	dev_info(&pdev->dev, "removed\n");
+	return 0;
+}
+
+static const struct of_device_id hse_ids[] = {
+	{ .compatible = "realtek,highspeed-streaming-engine" },
+	{}
+};
+
+static struct platform_driver hse_driver = {
+	.probe  = hse_probe,
+	.remove = hse_remove,
+	.driver = {
+		.name           = "rtk-hse",
+		.owner          = THIS_MODULE,
+		.of_match_table = hse_ids,
+		.pm             = &hse_pm_ops,
+		.probe_type     = PROBE_PREFER_ASYNCHRONOUS,
+	},
+};
+module_platform_driver(hse_driver);
+
diff --git a/drivers/soc/realtek/common/hse/sw_func.c b/drivers/soc/realtek/common/hse/sw_func.c
new file mode 100644
index 00000000..e965b60
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/sw_func.c
@@ -0,0 +1,105 @@
+#include "hsectl.h"
+
+void __hse_sw_yuyv2nv12(void *dst0,
+			void *dst1,
+			void *src,
+			uint32_t width,
+			uint32_t height,
+			uint32_t src_pitch,
+			uint32_t dst_pitch)
+{
+	int i, j, k;
+	int h, w;
+	uint8_t *s0 = src;
+	uint8_t *d0 = dst0;
+	uint8_t *d1 = dst1;
+
+	i = j = k = 0;
+	for (h = 0; h < height; h++) {
+		for (w = 0; w < width; w+=4) {
+			d0[j++] = s0[i++];
+			d1[k++] = s0[i++];
+			d0[j++] = s0[i++];
+			d1[k++] = s0[i++];
+		}
+		i += (src_pitch - width);
+		j += (dst_pitch - width / 2);
+		k += (dst_pitch - width / 2);
+	}
+}
+
+void __hse_sw_rotate(void *src,
+		     void *dst,
+		     uint32_t mode,
+		     uint32_t width,
+		     uint32_t height,
+		     uint32_t src_pitch,
+		     uint32_t dst_pitch)
+{
+	uint32_t x_size;
+	uint32_t y_size;
+	uint32_t x_bound;
+	uint8_t *s = src;
+	uint8_t *d = dst;
+	int i, j;
+
+	switch (mode) {
+	case HSE_ROTATE_MODE_90:
+	case HSE_ROTATE_MODE_270:
+		x_size = dst_pitch;
+		y_size = width;
+		x_bound = height;
+		break;
+	case HSE_ROTATE_MODE_180:
+		x_size = dst_pitch;
+		y_size = height;
+		x_bound = width;
+		break;
+	default:
+		return;
+	}
+
+	if (mode == HSE_ROTATE_MODE_90) {
+		/*
+		i j -> x y
+		0 0 -> 3 0
+		0 1 -> 2 0
+		...
+		1 0 -> 3 1
+		1 1 -> 2 1
+		...
+		*/
+		for (i = 0; i < height; i++)
+			for (j = 0; j < width; j++)
+				d[(y_size - 1 - j) * x_size + i] = s[i * src_pitch + j];
+	}
+	else if (mode == HSE_ROTATE_MODE_270) {
+		/*
+		i j -> x y
+		0 0 -> 0 3
+		0 1 -> 1 3
+		...
+		1 0 -> 0 2
+		1 1 -> 1 2
+		...
+		*/
+		for (i = 0; i < height; i++)
+			for (j = 0; j < width; j++)
+				d[(j) * x_size + width - 1 - i] = s[i * src_pitch + j];
+	}
+	else if (mode == HSE_ROTATE_MODE_180) {
+		/*
+		i j -> x y
+		0 0 -> 3 3
+		0 1 -> 3 2
+		...
+		1 0 -> 2 3
+		1 1 -> 2 2
+		...
+		*/
+		for (i = 0; i < height; i++)
+			for (j = 0; j < width; j++)
+				d[(y_size - 1 - i) * x_size + width - 1 - j] = s[i * src_pitch + j];
+	}
+}
+
diff --git a/drivers/soc/realtek/common/hse/test.c b/drivers/soc/realtek/common/hse/test.c
new file mode 100644
index 00000000..a0aada3
--- /dev/null
+++ b/drivers/soc/realtek/common/hse/test.c
@@ -0,0 +1,738 @@
+#define pr_fmt(fmt)  "hse-test: " fmt
+#include <linux/dma-mapping.h>
+#include <linux/pm_runtime.h>
+#include <linux/debugfs.h>
+#include <linux/list.h>
+#include <linux/slab.h>
+#include <linux/ktime.h>
+#include <soc/realtek/rtk_chip.h>
+#include "hse.h"
+#include "hsectl.h"
+#include "hse-sw.h"
+
+#define CHECK_ARGS(cond, msg) \
+do { \
+	if (cond) { \
+		pr_err("%s: %s\n", __func__, msg); \
+		return -EINVAL; \
+	} \
+} while (0)
+
+
+#define HSE_TEST_MEM_SIZE               (4 * PAGE_SIZE)
+#define HSE_TEST_MAX_MEM_NUM            (6)
+#define HSE_TEST_FILENAME_LENGTH        (100)
+#define HSE_TEST_INVAL                  (0xcc)
+
+/*
+ * Create debug blob files
+ */
+static LIST_HEAD(hse_test_blob_list);
+static struct dentry *hse_test_root;
+
+struct hse_test_blob {
+	struct debugfs_blob_wrapper blob;
+	struct list_head list;
+};
+
+static void hse_test_init_debugfs(void)
+{
+	if (!hse_test_root)
+		hse_test_root = debugfs_create_dir("hse_test", NULL);
+}
+
+static
+void hse_test_create_blob_file(const char *filename, void *data,
+			       unsigned long size)
+{
+	struct hse_test_blob *b;
+
+	pr_err("creating file %s\n", filename);
+
+	b = kzalloc(sizeof(*b), GFP_KERNEL);
+	if (!b) {
+		pr_err("failed to create hse test blob\n");
+		return;
+	}
+
+	b->blob.size = size;
+	b->blob.data = kmemdup(data, size, GFP_KERNEL);
+	if (!b->blob.data) {
+		pr_err("failed to copy data\n");
+		kfree(b);
+		return;
+	}
+
+	list_add(&b->list, &hse_test_blob_list);
+	debugfs_create_blob(filename, 0444, hse_test_root, &b->blob);
+}
+
+/*
+ * test buf
+ */
+struct hse_test_buf {
+	dma_addr_t phys;
+	void *virt;
+	int size;
+};
+
+static inline
+void hse_test_buf_memset(struct hse_test_buf *buf, int val, size_t size,
+			 bool flush)
+{
+	memset(buf->virt, val, size);
+	if (flush)
+		hse_flush_dcache_area(buf->virt, size);
+}
+
+static
+void hse_test_buf_free(struct device *dev, struct hse_test_buf *bufs,
+		       int mem_num)
+{
+	int i;
+
+	for (i = 0; i < mem_num; i++) {
+		if (!bufs[i].virt)
+			continue;
+		dma_free_coherent(dev, bufs[i].size, bufs[i].virt,
+				bufs[i].phys);
+	}
+	kfree(bufs);
+}
+
+static __must_check
+struct hse_test_buf *hse_test_buf_alloc(struct device *dev, size_t mem_num,
+					int size)
+{
+	struct hse_test_buf *bufs;
+	int i;
+
+	bufs = kcalloc(mem_num, sizeof(*bufs), GFP_KERNEL);
+	if (!bufs)
+		return NULL;
+
+	for (i = 0; i < mem_num; i++) {
+		bufs[i].size = size;
+		bufs[i].virt = dma_alloc_coherent(dev, size, &bufs[i].phys,
+			GFP_KERNEL | GFP_DMA);
+		dev_err(dev, "mem%d: phys:%pad, virt=%p\n", i,
+			&bufs[i].phys, bufs[i].virt);
+		if (!bufs[i].virt)
+			goto error;
+	}
+
+	return bufs;
+error:
+	hse_test_buf_free(dev, bufs, mem_num);
+	return NULL;
+}
+
+struct hse_test_obj {
+	int pass;
+	int fail;
+	int total;
+	struct hse_test_buf *bufs;
+	struct hse_engine *eng;
+
+	char test_info[1024];
+	int test_info_size;
+	ktime_t start;
+};
+
+#define TEST_BEGIN(_hobj, _fmt, ...) \
+do { \
+	(_hobj)->test_info_size = sprintf((_hobj)->test_info, _fmt, ##__VA_ARGS__); \
+	pr_err("\n"); \
+	pr_err("### test: %d => " _fmt, ++(_hobj)->total, ##__VA_ARGS__); \
+	(_hobj)->start = ktime_get(); \
+} while (0);
+
+#define TEST_END(_hobj, _ret) \
+do { \
+	s64 delta = ktime_to_us(ktime_sub(ktime_get(), (_hobj)->start)); \
+\
+	pr_err("\n"); \
+	pr_err("  result: %s (takes %lld us)\n", (_ret) ? "failed" : "passed", delta); \
+	if (_ret) \
+		(_hobj)->fail++; \
+	else  \
+		(_hobj)->pass++; \
+} while (0);
+
+static
+void hse_test_obj_create_blob_file(struct hse_test_obj *hobj, const char *name,
+				   void *data, unsigned long size)
+{
+	char n[HSE_TEST_FILENAME_LENGTH];
+
+	sprintf(n, "e%03x-t%03d.%s", hobj->eng->base_offset, hobj->total, name);
+	hse_test_create_blob_file(n, data, size);
+}
+
+static __must_check
+struct hse_test_obj *hse_test_obj_alloc(struct hse_engine *eng)
+{
+	struct hse_test_obj *hobj;
+	struct hse_device *hdev = eng->hdev;
+	struct hse_test_buf *bufs;
+
+	hobj = kzalloc(sizeof(*hobj), GFP_KERNEL);
+	if (!hobj) {
+		pr_err("fail to alloc test_obj\n");
+		return NULL;
+	}
+
+	bufs = hse_test_buf_alloc(hdev->dev, HSE_TEST_MAX_MEM_NUM, HSE_TEST_MEM_SIZE);
+	if (!bufs) {
+		pr_err("failed to alloc buf\n");
+		kfree(hobj);
+		return NULL;
+	}
+
+	hobj->bufs = bufs;
+	hobj->eng = eng;
+	return hobj;
+}
+
+static void hse_test_obj_free(struct hse_test_obj *hobj)
+{
+	hse_test_buf_free(hobj->eng->hdev->dev, hobj->bufs, HSE_TEST_MAX_MEM_NUM);
+	kfree(hobj);
+}
+
+/*
+ * run commands
+ */
+static
+int hse_test_run_cmd(struct hse_engine *eng, uint32_t *cmds, uint32_t size)
+{
+	struct hse_command_queue *cq;
+
+	cq = hse_cq_alloc(eng->hdev);
+	if (!cq)
+		return -ENOMEM;
+
+	hse_cq_add_data(cq, cmds, size);
+	hse_cq_pad(cq);
+	hse_engine_execute_cq(eng, cq);
+	hse_cq_free(cq);
+	return 0;
+}
+
+/*********************************************************************
+ *
+ * copy
+ *
+ *********************************************************************/
+static
+int hse_copy(struct hse_engine *eng, struct hse_test_buf *dst,
+	     struct hse_test_buf *src, uint32_t size)
+{
+	uint32_t cmds[32];
+
+	cmds[0] = 0x1;
+	cmds[1] = size;
+	cmds[2] = dst->phys;
+	cmds[3] = src->phys;
+	return hse_test_run_cmd(eng, cmds, 4);
+}
+
+static
+int hse_copy_verify_result(struct hse_test_obj *hobj, struct hse_test_buf *dst,
+			   struct hse_test_buf *src, uint32_t size)
+{
+	int ret;
+
+	ret = memcmp(dst->virt, src->virt, size);
+	if (!ret)
+		return ret;
+
+	ret = -EINVAL;
+	hse_test_obj_create_blob_file(hobj, "info", hobj->test_info, hobj->test_info_size);
+	hse_test_obj_create_blob_file(hobj, "src", src->virt, size);
+	hse_test_obj_create_blob_file(hobj, "dst", dst->virt, size);
+	return ret;
+}
+
+/*********************************************************************
+ *
+ * xor
+ *
+ *********************************************************************/
+static int hse_xor_verify_args(uint32_t num_srcs, uint32_t size)
+{
+	CHECK_ARGS(num_srcs < 1 || num_srcs > 5, "invalid num_srcs");
+	return 0;
+}
+
+static
+int hse_xor(struct hse_engine *eng, struct hse_test_buf *dst,
+	    struct hse_test_buf *srcs, uint32_t num_srcs, uint32_t size)
+{
+	uint32_t cmds[32];
+	uint32_t i;
+
+	if (hse_xor_verify_args(num_srcs, size))
+		return -EINVAL;
+
+	i = 0;
+	cmds[i++] = 0x01 | ((num_srcs-1) << 16);
+	cmds[i++] = size;
+	cmds[i++] = dst->phys;
+	cmds[i++] = srcs[0].phys;
+	if (num_srcs > 1)
+		cmds[i++] = srcs[1].phys;
+	if (num_srcs > 2)
+		cmds[i++] = srcs[2].phys;
+	if (num_srcs > 3)
+		cmds[i++] = srcs[3].phys;
+	if (num_srcs > 4)
+		cmds[i++] = srcs[4].phys;
+	return hse_test_run_cmd(eng, cmds, i);
+}
+
+static
+int hse_xor_verify_result(struct hse_test_obj *hobj, struct hse_test_buf *dst,
+			  struct hse_test_buf *srcs, uint32_t num_srcs,
+			  uint32_t size)
+{
+	char name[HSE_TEST_FILENAME_LENGTH];
+	u8 *p;
+	int i, j;
+	int ret;
+
+	p = kzalloc(size, GFP_KERNEL);
+	if (!p)
+		return -ENOMEM;
+
+	for (i = 0; i < size; i++) {
+		p[i] = ((u8 *)srcs[0].virt)[i];
+		for (j = 1; j < num_srcs; j++)
+			p[i] ^= ((u8 *)srcs[j].virt)[i];
+	}
+	ret = memcmp(dst->virt, p, size);
+	if (!ret)
+		goto done;
+
+	ret = -EINVAL;
+	hse_test_obj_create_blob_file(hobj, "info", hobj->test_info, hobj->test_info_size);
+	for (i = 0; i < num_srcs; i++) {
+		sprintf(name, "src%d", i);
+		hse_test_obj_create_blob_file(hobj, name, srcs[i].virt, size);
+	}
+	hse_test_obj_create_blob_file(hobj, "dst", dst->virt, size);
+	hse_test_obj_create_blob_file(hobj, "sw", p, size);
+done:
+	kfree(p);
+	return ret;
+}
+
+
+/*********************************************************************
+ *
+ * yuyv2nv12
+ *
+ *********************************************************************/
+static
+int hse_yuyv2nv12_check_args(uint32_t width, uint32_t height,
+			     uint32_t src_pitch, uint32_t dst_pitch)
+{
+	CHECK_ARGS(width & 0xf, "invalid width");
+	CHECK_ARGS(height & 0xf, "invalid height");
+	CHECK_ARGS((src_pitch & 0xf) || src_pitch < width, "invalid src_pitch");
+	CHECK_ARGS((dst_pitch & 0xf) || dst_pitch < width/2,
+		   "invalid dst_pitch");
+	return 0;
+}
+
+static
+int hse_yuyv2nv12(struct hse_engine *eng, struct hse_test_buf *dst0,
+		  struct hse_test_buf *dst1, struct hse_test_buf *src,
+		  uint32_t width, uint32_t height, uint32_t src_pitch,
+		  uint32_t dst_pitch)
+{
+	uint32_t cmds[32];
+
+	if (hse_yuyv2nv12_check_args(width, height, src_pitch, dst_pitch))
+		return -EINVAL;
+
+	cmds[0] = 0x2;
+	cmds[1] = height | (width << 16);
+	cmds[2] = dst_pitch | (src_pitch << 16);
+	cmds[3] = dst0->phys;
+	cmds[4] = dst1->phys;
+	cmds[5] = src->phys;
+	return hse_test_run_cmd(eng, cmds, 6);
+}
+
+static
+int __memcmp_pitch(void *m0, void *m1, uint32_t width, uint32_t height,
+		   uint32_t pitch)
+{
+	int h;
+	int ret;
+
+	for (h = 0; h < height; h++) {
+		ret = memcmp(m0, m1, width);
+		if (ret)
+			return ret;
+		m0 += pitch;
+		m1 += pitch;
+	}
+	return 0;
+}
+
+static
+int hse_yuyv2nv12_verify_result(struct hse_test_obj *hobj,
+				struct hse_test_buf *dst0,
+				struct hse_test_buf *dst1,
+				struct hse_test_buf *src,
+				uint32_t width, uint32_t height,
+				uint32_t src_pitch, uint32_t dst_pitch)
+{
+	u8 *p0, *p1;
+	int ret = 0;
+	uint32_t size = height * dst_pitch;
+
+	p0 = kzalloc(size, GFP_KERNEL);
+	p1 = kzalloc(size, GFP_KERNEL);
+	if (!p0 || !p1) {
+		ret = -ENOMEM;
+		goto done;
+	}
+	memset(p0, HSE_TEST_INVAL, size);
+	memset(p1, HSE_TEST_INVAL, size);
+
+	__hse_sw_yuyv2nv12(p0, p1, src->virt, width, height, src_pitch, dst_pitch);
+
+	ret = __memcmp_pitch(dst0->virt, p0, width / 2, height, dst_pitch);
+	ret |= __memcmp_pitch(dst1->virt, p1, width / 2, height, dst_pitch);
+	if (!ret)
+		goto done;
+
+	ret = -EINVAL;
+	hse_test_obj_create_blob_file(hobj, "info", hobj->test_info, hobj->test_info_size);
+	hse_test_obj_create_blob_file(hobj, "src", src->virt, size);
+	hse_test_obj_create_blob_file(hobj, "dst0", dst0->virt, size);
+	hse_test_obj_create_blob_file(hobj, "dst1", dst1->virt, size);
+	hse_test_obj_create_blob_file(hobj, "sw0", p0, size);
+	hse_test_obj_create_blob_file(hobj, "sw1", p1, size);
+done:
+	kfree(p0);
+	kfree(p1);
+	return ret;
+}
+
+/*********************************************************************
+ *
+ * rotate
+ *
+ *********************************************************************/
+static
+int hse_rotate_check_args(uint32_t mode, uint32_t width, uint32_t height,
+			  uint32_t src_pitch, uint32_t dst_pitch)
+{
+	CHECK_ARGS(mode != HSE_ROTATE_MODE_90 && mode != HSE_ROTATE_MODE_180 &&
+		   mode != HSE_ROTATE_MODE_270, "invalid mode");
+	CHECK_ARGS(width & 0xf, "invalid width");
+	CHECK_ARGS(height & 0xf, "invalid height");
+	CHECK_ARGS(src_pitch & 0xf, "invalid src_pitch");
+	CHECK_ARGS(dst_pitch & 0xf, "invalid dst_pitch");
+	CHECK_ARGS(src_pitch < width, "invalid src_pitch");
+	CHECK_ARGS(mode != HSE_ROTATE_MODE_180 && dst_pitch < height,
+		   "invalid mode and dst_pitch");
+	CHECK_ARGS(mode == HSE_ROTATE_MODE_180 && dst_pitch < width,
+		   "invalid mode and dst_pitch");
+	return 0;
+}
+
+static
+int hse_rotate(struct hse_engine *eng, struct hse_test_buf *dst,
+	       struct hse_test_buf *src, uint32_t mode, uint32_t width,
+	       uint32_t height, uint32_t src_pitch, uint32_t dst_pitch)
+{
+	uint32_t cmds[32];
+
+	if (hse_rotate_check_args(mode, width, height, src_pitch, dst_pitch))
+		return -EINVAL;
+
+	cmds[0] = 0x05 | (mode << 29);
+	cmds[1] = height | (width << 16);
+	cmds[2] = dst_pitch | (src_pitch << 16);
+	cmds[3] = dst->phys;
+	cmds[4] = src->phys;
+	return hse_test_run_cmd(eng, cmds, 5);
+}
+
+static
+int hse_rotate_verify_result(struct hse_test_obj *hobj,
+			     struct hse_test_buf *dst, struct hse_test_buf *src,
+			     uint32_t mode, uint32_t width, uint32_t height,
+			     uint32_t src_pitch, uint32_t dst_pitch)
+{
+	int ret;
+	int size = dst_pitch * (mode == HSE_ROTATE_MODE_180 ? height : width);
+	u8 *p;
+
+	/* emulation */
+	p = kzalloc(size, GFP_KERNEL);
+	if (!p)
+		return -ENOMEM;
+	memset(p, HSE_TEST_INVAL, size);
+
+	__hse_sw_rotate(src->virt, p, mode, width, height, src_pitch, dst_pitch);
+
+	/* compare */
+	ret = memcmp(dst->virt, p, size);
+	if (!ret)
+		goto done;
+
+	ret = -EINVAL;
+	hse_test_obj_create_blob_file(hobj, "info", hobj->test_info, hobj->test_info_size);
+	hse_test_obj_create_blob_file(hobj, "src", src->virt, size);
+	hse_test_obj_create_blob_file(hobj, "dst", dst->virt, size);
+done:
+	kfree(p);
+	return ret;
+}
+
+/*********************************************************************
+ *
+ * test
+ *
+ *********************************************************************/
+static void hse_test_engine_xor(struct hse_test_obj *hobj)
+{
+	struct hse_engine *eng = hobj->eng;
+	struct hse_test_buf *bufs = hobj->bufs;
+	int ret;
+	int i;
+
+	/* prepare data for copy and xor */
+	hse_test_buf_memset(&bufs[1], 0x01, HSE_TEST_MEM_SIZE, 1);
+	hse_test_buf_memset(&bufs[2], 0x02, HSE_TEST_MEM_SIZE, 1);
+	hse_test_buf_memset(&bufs[3], 0x06, HSE_TEST_MEM_SIZE, 1);
+	hse_test_buf_memset(&bufs[4], 0x18, HSE_TEST_MEM_SIZE, 1);
+	hse_test_buf_memset(&bufs[5], 0x30, HSE_TEST_MEM_SIZE, 1);
+
+	/* copy */
+	hse_test_buf_memset(&bufs[0], HSE_TEST_INVAL, HSE_TEST_MEM_SIZE, 1);
+
+	TEST_BEGIN(hobj, "op=copy, size=%u\n", (uint32_t)HSE_TEST_MEM_SIZE);
+	ret = hse_copy(eng, &bufs[0], &bufs[1], HSE_TEST_MEM_SIZE);
+	if (!ret)
+		ret = hse_copy_verify_result(hobj, &bufs[0], &bufs[1], HSE_TEST_MEM_SIZE);
+	TEST_END(hobj, ret);
+
+	/* xor */
+	for (i = 2; i <= 5; i++) {
+		uint32_t xor_num;
+
+		hse_test_buf_memset(&bufs[0], HSE_TEST_INVAL, HSE_TEST_MEM_SIZE, 1);
+
+		xor_num = i;
+		TEST_BEGIN(hobj, "op=xor, size=%u, num=%u\n", (uint32_t)HSE_TEST_MEM_SIZE, xor_num);
+		ret = hse_xor(eng, &bufs[0], &bufs[1], xor_num, HSE_TEST_MEM_SIZE);
+		if (!ret)
+			ret = hse_xor_verify_result(hobj, &bufs[0], &bufs[1], xor_num, HSE_TEST_MEM_SIZE);
+		TEST_END(hobj, ret);
+	}
+}
+
+struct hse_yuyv2nv12_args {
+	uint32_t w;
+	uint32_t h;
+	uint32_t sp;
+	uint32_t dp;
+};
+
+__maybe_unused
+static void hse_test_engine_yuy2(struct hse_test_obj *hobj)
+{
+	struct hse_engine *eng = hobj->eng;
+	struct hse_test_buf *bufs = hobj->bufs;
+	struct hse_yuyv2nv12_args cases[] = {
+		{ 32, 32, 32, 16, },
+		{ 32, 32, 32, 32, },
+		{ 32, 32, 64, 16, },
+		{ 32, 32, 64, 32, },
+	};
+	int ret;
+	int i;
+
+	/* prepare data for yuyv2nv12 */
+	for (i = 0; i < HSE_TEST_MEM_SIZE; i++)
+		((u8 *)bufs[0].virt)[i] = i;
+	hse_flush_dcache_area(bufs[0].virt, HSE_TEST_MEM_SIZE);
+
+	/* yuy2 to nv */
+	for (i = 0; i < ARRAY_SIZE(cases); i++) {
+		uint32_t w = cases[i].w;
+		uint32_t h = cases[i].h;
+		uint32_t sp = cases[i].sp;
+		uint32_t dp = cases[i].dp;
+
+		hse_test_buf_memset(&bufs[1], HSE_TEST_INVAL, HSE_TEST_MEM_SIZE, 1);
+		hse_test_buf_memset(&bufs[2], HSE_TEST_INVAL, HSE_TEST_MEM_SIZE, 1);
+
+		TEST_BEGIN(hobj, "op=yuyv2nv12, w=%u h=%u sp=%u dp=%u\n", w, h, sp, dp);
+		ret = hse_yuyv2nv12(eng, &bufs[1], &bufs[2], &bufs[0], w, h, sp, dp);
+		if (!ret)
+			ret = hse_yuyv2nv12_verify_result(hobj, &bufs[1], &bufs[2], &bufs[0], w, h, sp, dp);
+		TEST_END(hobj, ret);
+
+	}
+}
+
+struct hse_rotate_args {
+	uint32_t m;
+	uint32_t w;
+	uint32_t h;
+	uint32_t sp;
+	uint32_t dp;
+	uint32_t inv;
+};
+
+__maybe_unused
+static void hse_test_engine_rotate(struct hse_test_obj *hobj)
+{
+
+	struct hse_engine *eng = hobj->eng;
+	struct hse_test_buf *bufs = hobj->bufs;
+	struct hse_rotate_args cases[] = {
+		{ HSE_ROTATE_MODE_90,  16,  16,  16,  16, 0, },
+		{ HSE_ROTATE_MODE_90,  64,  32,  64,  32, 0, },
+		{ HSE_ROTATE_MODE_90, 128,  32, 128,  64, 0, },
+		{ HSE_ROTATE_MODE_90,  64,  64,  64,  64, 0, },
+		{ HSE_ROTATE_MODE_90,  64,  64,  64, 128, 0, },
+		{ HSE_ROTATE_MODE_90,  64,  64, 128,  64, 0, },
+		{ HSE_ROTATE_MODE_90,  64,  64, 128,  64, 0, },
+		{ HSE_ROTATE_MODE_90,  64,  64, 128, 128, 0, },
+		{ HSE_ROTATE_MODE_180, 64,  64,  64,  64, 0, },
+		{ HSE_ROTATE_MODE_180, 64,  64,  64, 128, 0, },
+		{ HSE_ROTATE_MODE_180, 64,  64, 128,  64, 0, },
+		{ HSE_ROTATE_MODE_180, 64,  64, 128, 128, 0, },
+		{ HSE_ROTATE_MODE_270, 64,  64,  64,  64, 0, },
+		{ HSE_ROTATE_MODE_270, 64,  64,  64, 128, 0, },
+		{ HSE_ROTATE_MODE_270, 64,  64, 128,  64, 0, },
+		{ HSE_ROTATE_MODE_270, 64,  64, 128, 128, 0, },
+		{ HSE_ROTATE_MODE_90,  32, 128,  32,  64, 1, },
+		{ HSE_ROTATE_MODE_90,  33, 128,  32,  64, 1, },
+		{ 4,  33, 128,  32,  64, 1, },
+	};
+	int ret;
+	int i;
+
+	/* prepare data for rotate */
+	for (i = 0; i < HSE_TEST_MEM_SIZE; i++)
+		((u8 *)bufs[0].virt)[i] = i;
+	hse_flush_dcache_area(bufs[0].virt, HSE_TEST_MEM_SIZE);
+
+	/* rotate */
+	for (i = 0 ; i < ARRAY_SIZE(cases); i++) {
+		uint32_t m = cases[i].m;
+		uint32_t w = cases[i].w;
+		uint32_t h = cases[i].h;
+		uint32_t sp = cases[i].sp;
+		uint32_t dp = cases[i].dp;
+
+		hse_test_buf_memset(&bufs[1], HSE_TEST_INVAL, HSE_TEST_MEM_SIZE, 1);
+
+		TEST_BEGIN(hobj, "op=rotate, m=%u, w=%u h=%u sp=%u dp=%u\n", m, w, h, sp, dp);
+		ret = hse_rotate(eng, &bufs[1], &bufs[0], m, w, h, sp, dp);
+		if (!ret)
+			ret = hse_rotate_verify_result(hobj, &bufs[1], &bufs[0], m, w, h, sp, dp);
+		if (cases[i].inv) {
+			if (ret)
+				ret = 0;
+			else
+				ret = -EINVAL;
+		}
+		TEST_END(hobj, ret);
+	}
+}
+
+static void hse_test_trigger_hw_reset(struct hse_engine *eng)
+{
+	pr_err("\n");
+	pr_err("%s\n", __func__);
+	reset_control_reset(eng->hdev->rstc);
+}
+
+#define HSE_TEST_FLAGS_RESET_BEFORE_ROTATE   BIT(0)
+#define HSE_TEST_FLAGS_RESET_AFTER_ROTATE    BIT(1)
+
+static int hse_test_engine(struct hse_engine *eng)
+{
+	int ret = 0;
+	struct hse_test_obj *hobj;
+	uint32_t test_flags = 0;
+
+#ifdef CONFIG_ARCH_RTD16xx
+	if (get_rtd_chip_revision() == RTD_CHIP_A00)
+		test_flags |= HSE_TEST_FLAGS_RESET_BEFORE_ROTATE |
+			      HSE_TEST_FLAGS_RESET_AFTER_ROTATE;
+#elif defined(CONFIG_ARCH_RTD13xx)
+	test_flags |= HSE_TEST_FLAGS_RESET_AFTER_ROTATE;
+#endif
+
+	pr_err("test engine@%03x\n", eng->base_offset);
+
+	hobj = hse_test_obj_alloc(eng);
+	if (!hobj)
+		return -ENOMEM;
+
+	hse_test_engine_xor(hobj);
+
+#ifdef CONFIG_RTK_HSE_HAS_YUY2
+	hse_test_engine_yuy2(hobj);
+#endif
+
+#ifdef CONFIG_RTK_HSE_HAS_ROTATE
+
+	if (test_flags & HSE_TEST_FLAGS_RESET_BEFORE_ROTATE)
+		hse_test_trigger_hw_reset(eng);
+
+	hse_test_engine_rotate(hobj);
+
+	if (test_flags & HSE_TEST_FLAGS_RESET_AFTER_ROTATE)
+		hse_test_trigger_hw_reset(eng);
+
+	hse_test_engine_xor(hobj);
+#endif
+
+	pr_err("\n");
+	pr_err("### result ###\n");
+	pr_err("### passed: %d, failed: %d, total: %d ###\n",
+		hobj->pass, hobj->fail, hobj->total);
+	pr_err("\n");
+
+	hse_test_obj_free(hobj);
+	return ret;
+}
+
+int hse_self_test(struct hse_device *hdev)
+{
+	struct hse_engine *engs[HSE_MAX_ENGINES] = {0};
+	int i;
+
+	hse_test_init_debugfs();
+
+	pm_runtime_get_sync(hdev->dev);
+	for (i = 0; i < HSE_MAX_ENGINES; i++) {
+		engs[i] = hse_engine_get_any(hdev);
+		if (!engs[i])
+			break;
+	}
+
+	for (i = 0; i < HSE_MAX_ENGINES; i++)
+		if (engs[i]) {
+			hse_test_engine(engs[i]);
+		}
+
+	for (i = 0; i < HSE_MAX_ENGINES; i++)
+		if (engs[i])
+			hse_engine_put(engs[i]);
+        pm_runtime_put_sync(hdev->dev);
+	return 0;
+}
diff --git a/drivers/soc/realtek/common/include/color.h b/drivers/soc/realtek/common/include/color.h
new file mode 100644
index 00000000..e4613fb
--- /dev/null
+++ b/drivers/soc/realtek/common/include/color.h
@@ -0,0 +1,37 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __COLOR_H__
+#define __COLOR_H__
+
+#define NONE			"\033[m"
+#define RED				"\033[0;32;31m"
+#define LIGHT_RED		"\033[1;31m"
+#define GREEN			"\033[0;32;32m"
+#define LIGHT_GREEN		"\033[1;32m"
+#define BLUE			"\033[0;32;34m"
+#define LIGHT_BLUE		"\033[1;34m"
+#define DARY_GRAY		"\033[1;30m"
+#define CYAN			"\033[0;36m"
+#define LIGHT_CYAN		"\033[1;36m"
+#define PURPLE			"\033[0;35m"
+#define LIGHT_PURPLE	"\033[1;35m"
+#define BROWN			"\033[0;33m"
+#define YELLOW			"\033[1;33m"
+#define LIGHT_GRAY		"\033[0;37m"
+#define WHITE			"\033[1;37m"
+
+#define ATTR_OFF		"\033[0m"
+#define BOLD			"\033[1m"
+#define UNDERSCORE		"\033[4m"
+#define BLINK			"\033[5m"
+#define REVERSE			"\033[7m"
+#define CONCEALED		"\033[8m"
+
+#endif /* __COLOR_H__ */
diff --git a/drivers/soc/realtek/common/include/debug.h b/drivers/soc/realtek/common/include/debug.h
new file mode 100644
index 00000000..df753b7
--- /dev/null
+++ b/drivers/soc/realtek/common/include/debug.h
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __DEBUG_RTK_H__
+#define __DEBUG_RTK_H__
+
+#include "color.h"
+
+#define dbg_fmt(fmt) fmt
+
+#define dbg_err(fmt, ...) \
+	printk(KERN_ERR RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_emerg(fmt, ...) \
+	printk(KERN_EMERG RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_alert(fmt, ...) \
+	printk(KERN_ALERT RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_crit(fmt, ...) \
+	printk(KERN_CRIT RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_warning(fmt, ...) \
+	printk(KERN_WARNING RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_warn dbg_warning
+
+#define dbg_info(fmt, ...) \
+	printk(KERN_INFO CYAN dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_notice(fmt, ...) \
+	printk(KERN_NOTICE CYAN dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_cont(fmt, ...) \
+	printk(KERN_CONT CYAN fmt NONE"\n", ##__VA_ARGS__)
+
+#endif /* __DEBUG_RTK_H__ */
diff --git a/drivers/soc/realtek/common/include/rtk_dcsys.h b/drivers/soc/realtek/common/include/rtk_dcsys.h
new file mode 100644
index 00000000..c7d6ef9
--- /dev/null
+++ b/drivers/soc/realtek/common/include/rtk_dcsys.h
@@ -0,0 +1,106 @@
+/*
+ * rtk_dcsys.h
+ *
+ * Copyright (c) 2019 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __RTK_DCSYS_H_INCLUDED
+#define __RTK_DCSYS_H_INCLUDED
+
+#define DCSYS_MISC                      (0x004)
+#define DCSYS_PC_CTRL                   (0x030)
+#define DCSYS_PC_TOTA_MON_NUM_0         (0x034)
+#define DCSYS_PC_TOTA_ACK_NUM_0         (0x038)
+#define DCSYS_PC_TOTA_IDL_NUM_0         (0x03c)
+#define DCSYS_PC_TOTA_MON_NUM_1         (0x040)
+#define DCSYS_PC_TOTA_ACK_NUM_1         (0x044)
+#define DCSYS_PC_TOTA_IDL_NUM_1         (0x048)
+#define DCSYS_PC_SYSH_PROG_CTRL         (0x050)
+#define DCSYS_PC_SYSH_PROG_CTRL_2       (0x500)
+#define DCSYS_PC_SYSH_PROG_CTRL_3       (0x504)
+#define DCSYS_PC_SYS_PROG_CTRL          (0x054)
+#define DCSYS_PC_SYSH_PROG_0_ACC_LAT    (0x060)
+#define DCSYS_PC_SYSH_PROG_0_MAX_LAT    (0x064)
+#define DCSYS_PC_SYSH_PROG_0_REQ_NUM    (0x068)
+#define DCSYS_PC_SYSH_PROG_0_ACK_NUM    (0x06c)
+#define DCSYS_PC_SYSH_PROG_1_ACC_LAT    (0x070)
+#define DCSYS_PC_SYSH_PROG_1_MAX_LAT    (0x074)
+#define DCSYS_PC_SYSH_PROG_1_REQ_NUM    (0x078)
+#define DCSYS_PC_SYSH_PROG_1_ACK_NUM    (0x07c)
+#define DCSYS_PC_SYSH_PROG_2_ACC_LAT    (0x080)
+#define DCSYS_PC_SYSH_PROG_2_MAX_LAT    (0x084)
+#define DCSYS_PC_SYSH_PROG_2_REQ_NUM    (0x088)
+#define DCSYS_PC_SYSH_PROG_2_ACK_NUM    (0x08c)
+#define DCSYS_PC_SYSH_PROG_3_ACC_LAT    (0x510)
+#define DCSYS_PC_SYSH_PROG_3_MAX_LAT    (0x514)
+#define DCSYS_PC_SYSH_PROG_3_REQ_NUM    (0x518)
+#define DCSYS_PC_SYSH_PROG_3_ACK_NUM    (0x51c)
+#define DCSYS_PC_SYSH_PROG_4_ACC_LAT    (0x520)
+#define DCSYS_PC_SYSH_PROG_4_MAX_LAT    (0x524)
+#define DCSYS_PC_SYSH_PROG_4_REQ_NUM    (0x528)
+#define DCSYS_PC_SYSH_PROG_4_ACK_NUM    (0x52c)
+#define DCSYS_PC_SYSH_PROG_5_ACC_LAT    (0x530)
+#define DCSYS_PC_SYSH_PROG_5_MAX_LAT    (0x534)
+#define DCSYS_PC_SYSH_PROG_5_REQ_NUM    (0x538)
+#define DCSYS_PC_SYSH_PROG_5_ACK_NUM    (0x53c)
+#define DCSYS_PC_SYSH_PROG_6_ACC_LAT    (0x540)
+#define DCSYS_PC_SYSH_PROG_6_MAX_LAT    (0x544)
+#define DCSYS_PC_SYSH_PROG_6_REQ_NUM    (0x548)
+#define DCSYS_PC_SYSH_PROG_6_ACK_NUM    (0x54c)
+#define DCSYS_PC_SYSH_PROG_7_ACC_LAT    (0x550)
+#define DCSYS_PC_SYSH_PROG_7_MAX_LAT    (0x554)
+#define DCSYS_PC_SYSH_PROG_7_REQ_NUM    (0x558)
+#define DCSYS_PC_SYSH_PROG_7_ACK_NUM    (0x55c)
+#define DCSYS_PC_SYS_PROG_0_ACC_LAT     (0x090)
+#define DCSYS_PC_SYS_PROG_0_MAX_LAT     (0x094)
+#define DCSYS_PC_SYS_PROG_0_REQ_NUM     (0x098)
+#define DCSYS_PC_SYS_PROG_0_ACK_NUM     (0x09c)
+#define DCSYS_PC_SYS_PROG_1_ACC_LAT     (0x0a0)
+#define DCSYS_PC_SYS_PROG_1_MAX_LAT     (0x0a4)
+#define DCSYS_PC_SYS_PROG_1_REQ_NUM     (0x0a8)
+#define DCSYS_PC_SYS_PROG_1_ACK_NUM     (0x0ac)
+#define DCSYS_PC_SYS_PROG_2_ACC_LAT     (0x0b0)
+#define DCSYS_PC_SYS_PROG_2_MAX_LAT     (0x0b4)
+#define DCSYS_PC_SYS_PROG_2_REQ_NUM     (0x0b8)
+#define DCSYS_PC_SYS_PROG_2_ACK_NUM     (0x0bc)
+#define DCSYS_PC_CMD_ANALYSIS_SEL       (0x560)
+#define DCSYS_PC0_CMD_ANALYSIS_0        (0x564)
+#define DCSYS_PC1_CMD_ANALYSIS_0        (0xA00)
+#define DCSYS_PC2_CMD_ANALYSIS_0        (0xA74)
+#define DCSYS_PC3_CMD_ANALYSIS_0        (0xAE8)
+
+#define DCSYS_PC_SYSH_PROG_0_CTRL       DCSYS_PC_SYSH_PROG_CTRL
+#define DCSYS_PC_SYSH_PROG_0_CTRL_MASK  (0xff)
+#define DCSYS_PC_SYSH_PROG_1_CTRL       DCSYS_PC_SYSH_PROG_CTRL
+#define DCSYS_PC_SYSH_PROG_1_CTRL_MASK  (0xff00)
+#define DCSYS_PC_SYSH_PROG_2_CTRL       DCSYS_PC_SYSH_PROG_CTRL
+#define DCSYS_PC_SYSH_PROG_2_CTRL_MASK  (0xff0000)
+#define DCSYS_PC_SYSH_PROG_3_CTRL       DCSYS_PC_SYSH_PROG_CTRL_2
+#define DCSYS_PC_SYSH_PROG_3_CTRL_MASK  (0xff)
+#define DCSYS_PC_SYSH_PROG_4_CTRL       DCSYS_PC_SYSH_PROG_CTRL_2
+#define DCSYS_PC_SYSH_PROG_4_CTRL_MASK  (0xff00)
+#define DCSYS_PC_SYSH_PROG_5_CTRL       DCSYS_PC_SYSH_PROG_CTRL_2
+#define DCSYS_PC_SYSH_PROG_5_CTRL_MASK  (0xff0000)
+#define DCSYS_PC_SYSH_PROG_6_CTRL       DCSYS_PC_SYSH_PROG_CTRL_3
+#define DCSYS_PC_SYSH_PROG_6_CTRL_MASK  (0xff)
+#define DCSYS_PC_SYSH_PROG_7_CTRL       DCSYS_PC_SYSH_PROG_CTRL_3
+#define DCSYS_PC_SYSH_PROG_7_CTRL_MASK  (0xff00)
+
+#define DCSYS_PC_SYS_PROG_0_CTRL        DCSYS_PC_SYS_PROG_CTRL
+#define DCSYS_PC_SYS_PROG_0_CTRL_MASK   (0xff)
+#define DCSYS_PC_SYS_PROG_1_CTRL        DCSYS_PC_SYS_PROG_CTRL
+#define DCSYS_PC_SYS_PROG_1_CTRL_MASK   (0xff00)
+#define DCSYS_PC_SYS_PROG_2_CTRL        DCSYS_PC_SYS_PROG_CTRL
+#define DCSYS_PC_SYS_PROG_2_CTRL_MASK   (0xff0000)
+
+#define DCSYS_PC_CA_SEL_0_MASK          (0xf)
+#define DCSYS_PC_CA_SEL_1_MASK          (0xf0)
+#define DCSYS_PC_CA_SEL_2_MASK          (0xf00)
+#define DCSYS_PC_CA_SEL_3_MASK          (0xf000)
+
+#endif
diff --git a/drivers/soc/realtek/common/include/rtk_dmc.h b/drivers/soc/realtek/common/include/rtk_dmc.h
new file mode 100644
index 00000000..f17f4f8
--- /dev/null
+++ b/drivers/soc/realtek/common/include/rtk_dmc.h
@@ -0,0 +1,36 @@
+/*
+ * rtk_dmc.h
+ *
+ * Copyright (c) 2019 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __RTK_DMC_H_INCLUDED
+#define __RTK_DMC_H_INCLUDED
+
+#define DMC_OFFSET                      (0x800)
+#define DMC_SCH_INDEX                   (DMC_OFFSET + 0x300)
+#define DMC_SCH_DATA                    (DMC_OFFSET + 0x304)
+
+#define DMC_SYS_CTRL                    (0x30)
+#define DMC_MISC                        (0x31)
+#define DMC_CPU_GPU_AXI_AGENT           (0x32)
+#define DMC_CPU_GPU_SCH                 (0x33)
+#define DMC_RD_BW_ALLOC                 (0x34)
+#define DMC_WR_BW_ALLOC                 (0x35)
+#define DMC_PC_CTRL                     (0x36)
+#define DMC_PC_CPU_REQ_NUM              (0x37)
+#define DMC_PC_CPU_ACC_LAT              (0x38)
+#define DMC_PC_GPU_REQ_NUM              (0x39)
+#define DMC_PC_GPU_ACC_LAT              (0x3a)
+
+static inline bool dmc_valid_reg(u32 reg)
+{
+	return DMC_SYS_CTRL <= reg && reg <= DMC_PC_GPU_ACC_LAT;
+}
+
+#endif
diff --git a/drivers/soc/realtek/common/include/rtk_sb2.h b/drivers/soc/realtek/common/include/rtk_sb2.h
new file mode 100644
index 00000000..818c389
--- /dev/null
+++ b/drivers/soc/realtek/common/include/rtk_sb2.h
@@ -0,0 +1,201 @@
+/*
+ * rtk_sb2.h - bus debug driver
+ *
+ * Copyright (c) 2019 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __RTK_SB2_H_INCLUDED
+#define __RTK_SB2_H_INCLUDED
+
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/bitops.h>
+#include <linux/arm-smccc.h>
+
+/* register definitions */
+#define SB2_HD_SEM                      (0x000)
+#define SB2_INV_INTEN                   (0x004)
+#define SB2_INV_INTSTAT                 (0x008)
+#define SB2_INV_ADDR                    (0x00c)
+#define SB2_DEBUG_REG                   (0x010)
+#define SB2_CHIP_ID                     (0x200)
+#define SB2_CHIP_INFO                   (0x204)
+
+#define SB2_RBUS_ICG1                   (0x308)
+#define SB2_RBUS_ICG2                   (0x30c)
+#define SB2_RBUS_ICG3                   (0x310)
+
+#define SB2_DBG_START_REG0              (0x458)
+#define SB2_DBG_START_REG1              (0x45c)
+#define SB2_DBG_START_REG2              (0x460)
+#define SB2_DBG_START_REG3              (0x464)
+#define SB2_DBG_START_REG4              (0x468)
+#define SB2_DBG_START_REG5              (0x46c)
+#define SB2_DBG_START_REG6              (0x470)
+#define SB2_DBG_START_REG7              (0x474)
+
+#define SB2_DBG_END_REG0                (0x478)
+#define SB2_DBG_END_REG1                (0x47c)
+#define SB2_DBG_END_REG2                (0x480)
+#define SB2_DBG_END_REG3                (0x484)
+#define SB2_DBG_END_REG4                (0x488)
+#define SB2_DBG_END_REG5                (0x48c)
+#define SB2_DBG_END_REG6                (0x490)
+#define SB2_DBG_END_REG7                (0x494)
+
+#define SB2_DBG_CTRL_REG0               (0x498)
+#define SB2_DBG_CTRL_REG1               (0x49c)
+#define SB2_DBG_CTRL_REG2               (0x4a0)
+#define SB2_DBG_CTRL_REG3               (0x4a4)
+#define SB2_DBG_CTRL_REG4               (0x4a8)
+#define SB2_DBG_CTRL_REG5               (0x4ac)
+#define SB2_DBG_CTRL_REG6               (0x4b0)
+#define SB2_DBG_CTRL_REG7               (0x4b4)
+#define SB2_DBG_ADDR_AUDIO              (0x4b8)
+#define SB2_DBG_ADDR_PCPU               (0x4bc)
+#define SB2_DBG_ADDR_SYSTEM             (0x4c0)
+#define SB2_DBG_ADDR1                   (0x4c8)
+#define SB2_DBG_INT                     (0x4E0)
+
+#define SB2_HD_SEM_NEW_0                (0x620)
+#define SB2_HD_SEM_NEW_1                (0x624)
+#define SB2_HD_SEM_NEW_2                (0x628)
+#define SB2_HD_SEM_NEW_3                (0x62c)
+#define SB2_HD_SEM_NEW_4                (0x630)
+#define SB2_HD_SEM_NEW_5                (0x634)
+#define SB2_HD_SEM_NEW_6                (0x638)
+#define SB2_HD_SEM_NEW_7                (0x63c)
+
+/* SB2_INV_INTEN */
+#define SWCIVAIRQ_EN                    BIT(6)
+#define ACIVAIRQ_EN                     BIT(3)
+#define PCIVAIRQ_EN                     BIT(2)
+#define SCIVAIRQ_EN                     BIT(1)
+
+/* SB2_INV_INTSTAT */
+#define SWCIVA_INT                      BIT(4)
+#define ACIVA_INT                       BIT(3)
+#define PCIVA_INT                       BIT(2)
+#define SCIVA_INT                       BIT(1)
+
+#define WRITE_DATA_1                    1
+#define WRITE_DATA_0                    0
+
+#define SB2_DBG_MONITOR_DATA            (BIT(4)|BIT(2))
+#define SB2_DBG_MONITOR_INST            (BIT(4)|BIT(3))
+#define SB2_DBG_MONITOR_READ            (BIT(7)|BIT(5))
+#define SB2_DBG_MONITOR_WRITE           (BIT(7)|BIT(6))
+
+/* SB2_DBG_INT */
+#define SB2_ACPU_INT                    BIT(12)
+#define SB2_PCPU_INT                    BIT(11)
+#define SB2_SCPU_INT                    BIT(10)
+#define SB2_ACPU_INT_EN                 BIT(9)
+#define SB2_PCPU_INT_EN                 BIT(8)
+#define SB2_SCPU_INT_EN                 BIT(7)
+#define SB2_ACPU_NEG_INT                BIT(6)
+#define SB2_PCPU_NEG_INT                BIT(5)
+#define SB2_SCPU_NEG_INT                BIT(4)
+#define SB2_ACPU_NEG_INT_EN             BIT(3)
+#define SB2_PCPU_NEG_INT_EN             BIT(2)
+#define SB2_SCPU_NEG_INT_EN             BIT(1)
+
+/* SB2_DBG_CTRL_REG */
+#define SET_DBG_ACPU_CHK_EN             (3 << 12)
+#define CLR_DBG_ACPU_CHK_EN             (2 << 12)
+#define SET_DBG_SCPU_CHK_EN             (3 << 8)
+#define CLR_DBG_SCPU_CHK_EN             (2 << 8)
+#define SET_DBG_EN                      (3 << 0)
+#define CLR_DBG_EN                      (2 << 0)
+
+
+struct device;
+struct device_node;
+
+struct sb2_data {
+	void *base;
+	phys_addr_t phy;
+	int offset;
+	int irq;
+};
+
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+#define SB2_USE_SMCCALL                (1)
+
+#if defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+#define SB2_SWCIO_RCMD                  0x8400fffe
+#define SB2_SWCIO_WCMD                  0x8400ffff
+#elif defined(CONFIG_ARCH_RTD139x)
+#define SB2_SWCIO_RCMD                  0x8400ff06
+#define SB2_SWCIO_WCMD                  0x8400ff07
+#else
+#error "invalid sb2 smccall cmd"
+#endif
+
+#endif /* CONFIG_RTK_SB2_SECURITY_DEBG */
+
+#ifndef SB2_USE_SMCCALL
+#define SB2_USE_SMCCALL                 (0)
+#endif
+
+static inline int of_sb2_data_init(struct device_node *np,
+				   struct sb2_data *data,
+				   int index)
+{
+	int ret;
+	struct resource res;
+
+	ret = of_address_to_resource(np, index, &res);
+	if (ret)
+		return ret;
+
+	data->base = ioremap(res.start, resource_size(&res));
+	if (!data->base)
+		return -ENOMEM;
+
+	data->phy    = res.start & ~0xfff;
+	data->offset = res.start & 0xfff;
+	return 0;
+}
+
+static inline void sb2_data_fini(struct sb2_data *data)
+{
+	iounmap(data->base);
+}
+
+static inline u32 sb2_read(struct sb2_data *data,
+			   u32 offset)
+{
+	u32 val;
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	struct arm_smccc_res res;
+
+	arm_smccc_smc(SB2_SWCIO_RCMD, (u32)data->phy | (offset + data->offset), 0, 0, 0, 0, 0, 0, &res);
+	val = res.a0;
+#else
+	val = readl(data->base + offset);
+#endif
+	return val;
+}
+
+static inline void sb2_write(struct sb2_data *data,
+			     u32 offset,
+			     u32 val)
+{
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	struct arm_smccc_res res;
+
+	arm_smccc_smc(SB2_SWCIO_WCMD, (u32)data->phy | (offset + data->offset), val, 0, 0, 0, 0, 0, &res);
+#else
+	writel(val, data->base + offset);
+#endif
+}
+
+#endif /* __RTK_SB2_H_INCLUDED */
diff --git a/drivers/soc/realtek/common/info/Kconfig b/drivers/soc/realtek/common/info/Kconfig
new file mode 100644
index 00000000..2aa4ef4
--- /dev/null
+++ b/drivers/soc/realtek/common/info/Kconfig
@@ -0,0 +1,4 @@
+config RTK_INFO_PLL
+	bool "add DebugFs for PLL info"
+	depends on ARCH_RTD139x || ARCH_RTD16xx || ARCH_RTD13xx
+	default y
diff --git a/drivers/soc/realtek/common/info/Makefile b/drivers/soc/realtek/common/info/Makefile
new file mode 100644
index 00000000..3211a6e
--- /dev/null
+++ b/drivers/soc/realtek/common/info/Makefile
@@ -0,0 +1,3 @@
+obj-y += info.o
+
+obj-$(CONFIG_RTK_INFO_PLL) += info-pll.o
diff --git a/drivers/soc/realtek/common/info/info-pll.c b/drivers/soc/realtek/common/info/info-pll.c
new file mode 100644
index 00000000..a257682
--- /dev/null
+++ b/drivers/soc/realtek/common/info/info-pll.c
@@ -0,0 +1,179 @@
+/*
+ * info-pll.c - Dump PLL info form debug registers
+ *
+ * Copyright (C) 2017,2019 Realtek Semiconductor Corporation
+ *
+ * Author
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/bitops.h>
+#include <linux/io.h>
+#include <linux/seq_file.h>
+#include "info.h"
+
+#define DIV_SEL(_v, _h, _l) \
+	(((_v) >> (_l)) & (BIT((_h) - (_l) + 1) - 1))
+
+#define PLL_SHIFT  13
+#define PLL_MASK   (BIT(29 - 13 + 1) - 1)
+#define RETRY_MAX  30000
+
+static int pll_get_freq(unsigned int addr, unsigned int *freq)
+{
+	int ret = 0;
+	void *reg = ioremap(addr, 0x4);
+	int retry = RETRY_MAX;
+
+	writel(0x0, reg);
+	writel(0x1, reg);
+	writel(0x3, reg);
+
+	while (--retry && (readl(reg) & BIT(30)) == 0)
+		;
+
+	if (!retry)
+		ret = -EINVAL;
+	else
+		*freq = ((readl(reg) >> PLL_SHIFT) & PLL_MASK) / 10;
+
+	writel(0x0, reg);
+	iounmap(reg);
+
+	return ret;
+}
+
+static int pll_scpu_get_freq(unsigned int addr, unsigned int *freq)
+{
+	int ret = 0;
+	void *reg = ioremap(addr, 0xC);
+	int retry = RETRY_MAX;
+
+	writel(readl(reg) & ~0x30000, reg);
+	writel(readl(reg) | 0x20000, reg);
+	writel(readl(reg) | 0x30000, reg);
+
+	while (--retry && (readl(reg+8) & BIT(0)) == 0)
+		;
+
+	if (!retry)
+		ret = -EINVAL;
+	else
+		*freq = ((readl(reg + 8) >> 1) & PLL_MASK) / 10;
+
+	writel(readl(reg) & ~0x30000, reg);
+	iounmap(reg);
+
+	return ret;
+}
+
+static void pll_show_one(struct seq_file *s, const char *name, unsigned int addr)
+{
+	unsigned int freq;
+
+	seq_printf(s, "  %-10s ", name);
+
+	if ((addr == 0x9801D700 && pll_scpu_get_freq(addr, &freq)) ||
+		(addr != 0x9801D700 && pll_get_freq(addr, &freq)))
+		seq_puts(s, "unavailable\n");
+	else
+		seq_printf(s, "%4d MHz\n", freq);
+}
+
+static int pll_div(int val)
+{
+	if (val & BIT(1))
+		return (val & BIT(0)) ? 4 : 2;
+	return 1;
+}
+
+static int pll_scpu_div(int val)
+{
+#ifdef CONFIG_ARCH_RTD139x
+	if (val & BIT(7)) {
+		val = (val & ~BIT(7)) >> 2;
+		switch (val) {
+		case 5: case 6: case 7: case 8: case 10: case 13:
+			return val;
+		default:
+			return 3;
+		}
+	} else if (val & BIT(1)) {
+		return (val & BIT(0)) ? 4 : 2;
+	}
+	return 1;
+#elif defined(CONFIG_ARCH_RTD16xx) || defined(CONFIG_ARCH_RTD13xx)
+	if (val & 0x80)
+		return (val & ~0x80) >> 2;
+	return 1;
+#else
+	return -1;
+#endif
+}
+
+static int pll_acpu_div(int val)
+{
+	return 1 << (ffs(~val) - 1);
+}
+
+static unsigned int get_div(void)
+{
+	void *reg = ioremap(0x98000030, 0x4);
+	unsigned int div = readl(reg);
+
+	iounmap(reg);
+	return div;
+}
+
+static int pll_show(struct seq_file *s)
+{
+	unsigned int raw = get_div();
+	unsigned int sel;
+
+	seq_puts(s, "PLL FREQ\n");
+	pll_show_one(s, "PLL_SCPU",  0x9801D700);
+	pll_show_one(s, "PLL_BUS",   0x98000424);
+	pll_show_one(s, "PLL_DCSB",  0x98000428);
+	pll_show_one(s, "PLL_ACPU",  0x9800042C);
+	pll_show_one(s, "PLL_DDSA",  0x98000430);
+#ifdef CONFIG_ARCH_RTD139x
+	pll_show_one(s, "PLL_DDSB",  0x98000434);
+#endif
+	pll_show_one(s, "PLL_GPU",   0x98000438);
+	pll_show_one(s, "PLL_VCPU",  0x9800043C);
+	pll_show_one(s, "PLL_VCPU2", 0x98000440);
+
+	seq_puts(s, "PLL DIV SEL/VAL\n");
+	sel = DIV_SEL(raw, 16, 6);
+	seq_printf(s, "  SCPU SEL = 0x%02x VAL = %2d\n", sel, pll_scpu_div(sel));
+	sel = DIV_SEL(raw, 1, 0);
+	seq_printf(s, "  BUS  SEL = 0x%02x VAL = %2d\n", sel, pll_div(sel));
+	sel = DIV_SEL(raw, 3, 2);
+	seq_printf(s, "  DCSB SEL = 0x%02x VAL = %2d\n", sel, pll_div(sel));
+	sel = DIV_SEL(raw, 26, 22);
+	seq_printf(s, "  ACPU SEL = 0x%02x VAL = %2d\n", sel, pll_acpu_div(sel));
+
+	return 0;
+}
+
+static int pll_init(void)
+{
+	info_dump_create_file("pll", pll_show);
+	return 0;
+}
+late_initcall(pll_init);
+
diff --git a/drivers/soc/realtek/common/info/info.c b/drivers/soc/realtek/common/info/info.c
new file mode 100644
index 00000000..890e035
--- /dev/null
+++ b/drivers/soc/realtek/common/info/info.c
@@ -0,0 +1,80 @@
+/*
+ * info.c - Simple API for dump information in DEBUGFS
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * Author
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/slab.h>
+#include <linux/debugfs.h>
+#include "info.h"
+
+static struct dentry *info_dump_root;
+
+struct info_dump {
+	info_dump_fn_t func;
+};
+
+static int info_dump_show(struct seq_file *s, void *data)
+{
+	struct info_dump *info = s->private;
+
+	return info->func(s);
+}
+
+static int info_dump_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, info_dump_show, inode->i_private);
+}
+
+static const struct file_operations info_dump_fops = {
+	.owner   = THIS_MODULE,
+	.open    = info_dump_open,
+	.read    = seq_read,
+	.release = single_release,
+};
+
+static int __init info_dump_init(void)
+{
+	info_dump_root = debugfs_create_dir("info", NULL);
+	return 0;
+}
+arch_initcall(info_dump_init);
+
+int info_dump_create_file(const char *name, info_dump_fn_t func)
+{
+	struct info_dump *info;
+	struct dentry *d;
+
+	info = kzalloc(sizeof(*info), GFP_KERNEL);
+	if (!info)
+		return -ENOMEM;
+
+	info->func = func;
+
+	d = debugfs_create_file(name, 0644, info_dump_root, info,
+		&info_dump_fops);
+	if (!d) {
+		kfree(info);
+		return -ENOMEM;
+	}
+
+	return 0;
+}
+
diff --git a/drivers/soc/realtek/common/info/info.h b/drivers/soc/realtek/common/info/info.h
new file mode 100644
index 00000000..c074e7b
--- /dev/null
+++ b/drivers/soc/realtek/common/info/info.h
@@ -0,0 +1,21 @@
+/*
+ * info.h
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ * Copyright (C) 2017 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __SOC_REALTEK_INFO_H__
+#define __SOC_REALTEK_INFO_H__
+
+struct seq_file;
+
+typedef	int (*info_dump_fn_t)(struct seq_file *s);
+
+int info_dump_create_file(const char *name, info_dump_fn_t func);
+
+#endif
diff --git a/drivers/soc/realtek/common/perfcnt/Kconfig b/drivers/soc/realtek/common/perfcnt/Kconfig
new file mode 100644
index 00000000..911d12f
--- /dev/null
+++ b/drivers/soc/realtek/common/perfcnt/Kconfig
@@ -0,0 +1,5 @@
+config RTK_PERFCNT
+	bool "Realtek performance counter"
+	help
+	  provides a simple interface to use performance count
+
diff --git a/drivers/soc/realtek/common/perfcnt/Makefile b/drivers/soc/realtek/common/perfcnt/Makefile
new file mode 100644
index 00000000..e158fd5
--- /dev/null
+++ b/drivers/soc/realtek/common/perfcnt/Makefile
@@ -0,0 +1 @@
+obj-y += perfcnt.o
diff --git a/drivers/soc/realtek/common/perfcnt/perfcnt.c b/drivers/soc/realtek/common/perfcnt/perfcnt.c
new file mode 100644
index 00000000..11e441d
--- /dev/null
+++ b/drivers/soc/realtek/common/perfcnt/perfcnt.c
@@ -0,0 +1,285 @@
+/*
+ * Realtek Perfcnt Framework
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2017-2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#include <linux/list.h>
+#include <linux/of.h>
+#include <linux/mutex.h>
+#include <linux/jiffies.h>
+#include <linux/slab.h>
+#include <linux/device.h>
+#include <soc/realtek/perfcnt.h>
+
+static LIST_HEAD(perfcnt_list);
+static DEFINE_MUTEX(perfcnt_lock);
+
+int perfcnt_register(struct perfcnt_device *pcdev)
+{
+	if (!pcdev || !pcdev->dev || !pcdev->np || !pcdev->ops)
+		return -EINVAL;
+
+	if (!pcdev->ops->start || !pcdev->ops->stop || !pcdev->ops->get_data)
+		return -EINVAL;
+
+	mutex_lock(&perfcnt_lock);
+	list_add(&pcdev->list, &perfcnt_list);
+	mutex_unlock(&perfcnt_lock);
+
+	INIT_LIST_HEAD(&pcdev->list_idle);
+	INIT_LIST_HEAD(&pcdev->list_suspend);
+	BLOCKING_INIT_NOTIFIER_HEAD(&pcdev->notifier);
+	return 0;
+}
+EXPORT_SYMBOL_GPL(perfcnt_register);
+
+void perfcnt_unregister(struct perfcnt_device *pcdev)
+{
+	if (!pcdev)
+		return;
+
+	WARN_ON(!list_empty(&pcdev->list_idle));
+	WARN_ON(!list_empty(&pcdev->list_suspend));
+
+	mutex_lock(&perfcnt_lock);
+	list_del(&pcdev->list);
+	mutex_unlock(&perfcnt_lock);
+}
+EXPORT_SYMBOL_GPL(perfcnt_unregister);
+
+static struct perfcnt_device *of_perfcnt_device_get(struct device_node *np,
+						    const char *id)
+{
+	int index = 0;
+	struct perfcnt_device *pos;
+	struct device_node *node;
+
+	if (id)
+		index = of_property_match_string(np, "perfcnt-names", id);
+
+	node = of_parse_phandle(np, "perfcnts", index);
+	if (!node)
+		return ERR_PTR(-EINVAL);
+
+	mutex_lock(&perfcnt_lock);
+	list_for_each_entry(pos, &perfcnt_list, list)
+		if (pos->np == node) {
+			mutex_unlock(&perfcnt_lock);
+			return pos;
+		}
+	mutex_unlock(&perfcnt_lock);
+	return ERR_PTR(-ENODEV);
+}
+
+
+struct perfcnt *perfcnt_get(struct device *dev, const char *id)
+{
+	struct perfcnt_device *pcdev;
+	struct perfcnt *pc;
+
+	pcdev = of_perfcnt_device_get(dev->of_node, id);
+	if (IS_ERR(pcdev))
+		return ERR_CAST(pcdev);
+
+	pc = kzalloc(sizeof(*pc), GFP_KERNEL);
+	if (!pc)
+		return ERR_PTR(-ENOMEM);
+
+	pc->pcdev = pcdev;
+	pc->dev   = dev;
+	list_add(&pc->list, &pcdev->list_idle);
+	return pc;
+}
+EXPORT_SYMBOL_GPL(perfcnt_get);
+
+void perfcnt_put(struct perfcnt *pc)
+{
+	if (!pc)
+		return;
+
+	list_del(&pc->list);
+	kfree(pc);
+}
+EXPORT_SYMBOL_GPL(perfcnt_put);
+
+int perfcnt_start(struct perfcnt *pc)
+{
+	struct perfcnt_device *pcdev = pc->pcdev;
+
+	if (pcdev->cur_pc != pc)
+		return -EBUSY;
+
+	pcdev->is_start = 1;
+	pcdev->time_begin = get_jiffies_64();
+	return pcdev->ops->start(pcdev);
+}
+EXPORT_SYMBOL_GPL(perfcnt_start);
+
+int perfcnt_stop(struct perfcnt *pc)
+{
+	struct perfcnt_device *pcdev = pc->pcdev;
+
+	if (pcdev->cur_pc != pc)
+		return -EBUSY;
+
+	pcdev->is_start = 0;
+	pcdev->time_end = get_jiffies_64();
+	return pcdev->ops->stop(pcdev);
+}
+EXPORT_SYMBOL_GPL(perfcnt_stop);
+
+int perfcnt_last_duration(struct perfcnt *pc, u32 *period_ms)
+{
+	struct perfcnt_device *pcdev = pc->pcdev;
+
+	if (pcdev->cur_pc != pc)
+		return -EBUSY;
+
+	if (pcdev->is_start)
+		return -EINVAL;
+	if (pcdev->time_begin == 0 && pcdev->time_end == 0)
+		return -EINVAL;
+	*period_ms = jiffies_to_msecs(pcdev->time_end - pcdev->time_begin);
+	return 0;
+}
+EXPORT_SYMBOL_GPL(perfcnt_last_duration);
+
+int perfcnt_reset(struct perfcnt *pc)
+{
+	struct perfcnt_device *pcdev = pc->pcdev;
+
+	if (pcdev->cur_pc != pc)
+		return -EBUSY;
+
+	pcdev->is_start = 0;
+	if (pcdev->ops->reset)
+		return pcdev->ops->reset(pcdev);
+	return -EINVAL;
+}
+EXPORT_SYMBOL_GPL(perfcnt_reset);
+
+int perfcnt_set_conf(struct perfcnt *pc, u32 id, u32 conf)
+{
+	struct perfcnt_device *pcdev = pc->pcdev;
+
+	if (pcdev->cur_pc != pc)
+		return -EPERM;
+
+	if (pcdev->ops->set_conf)
+		return pcdev->ops->set_conf(pcdev, id, conf);
+	return -EINVAL;
+}
+EXPORT_SYMBOL_GPL(perfcnt_set_conf);
+
+int perfcnt_get_data(struct perfcnt *pc, u32 id, struct perfcnt_data *data)
+{
+	struct perfcnt_device *pcdev = pc->pcdev;
+
+	if (pcdev->cur_pc != pc)
+		return -EPERM;
+	return pcdev->ops->get_data(pcdev, id, data);
+}
+EXPORT_SYMBOL_GPL(perfcnt_get_data);
+
+int perfcnt_register_notifier(struct perfcnt *pc, struct notifier_block *nb)
+{
+	struct perfcnt_device *pcdev = pc->pcdev;
+
+	return blocking_notifier_chain_register(&pcdev->notifier, nb);
+}
+
+EXPORT_SYMBOL_GPL(perfcnt_register_notifier);
+
+int perfcnt_unregister_notifier(struct perfcnt *pc, struct notifier_block *nb)
+{
+	struct perfcnt_device *pcdev = pc->pcdev;
+
+	return blocking_notifier_chain_unregister(&pcdev->notifier, nb);
+}
+EXPORT_SYMBOL_GPL(perfcnt_unregister_notifier);
+
+static int _notifier_call_chain(struct perfcnt_device *pcdev,
+				unsigned long event,
+				void *data)
+{
+	return blocking_notifier_call_chain(&pcdev->notifier, event, data);
+}
+
+static int perfcnt_device_swap_perfcnts(struct perfcnt_device *pcdev,
+				       struct perfcnt *new_pc,
+				       struct perfcnt *old_pc)
+{
+	struct perfcnt_change_data pccd;
+	int ret;
+
+	pccd.old_pc = old_pc;
+	pccd.new_pc = new_pc;
+	ret = _notifier_call_chain(pcdev, PERFCNT_EVENT_PRE_CHANGE, &pccd);
+	if (ret < 0)
+		pr_warn("%s: PERFCNT_EVENT_PRE_CHANGE returns %d\n", __func__, ret);
+
+	if (old_pc && pcdev->is_start)
+		perfcnt_stop(old_pc);
+
+	pcdev->cur_pc = new_pc;
+	if (old_pc)
+		list_move(&old_pc->list, &pcdev->list_suspend);
+	if (new_pc)
+		list_move(&new_pc->list, &pcdev->list_idle);
+
+	ret = _notifier_call_chain(pcdev, PERFCNT_EVENT_POST_CHANGE, &pccd);
+	if (ret < 0)
+		pr_warn("%s: PERFCNT_EVENT_POST_CHANGE returns %d\n", __func__, ret);
+	return 0;
+}
+
+
+int perfcnt_request(struct perfcnt *new_pc)
+{
+	struct perfcnt_device *pcdev = new_pc->pcdev;
+	struct perfcnt *old_pc = pcdev->cur_pc;
+
+	if (WARN_ON(new_pc == pcdev->cur_pc))
+		return -EINVAL;
+
+	return perfcnt_device_swap_perfcnts(pcdev, new_pc, old_pc);
+}
+EXPORT_SYMBOL_GPL(perfcnt_request);
+
+int perfcnt_release(struct perfcnt *old_pc)
+{
+	struct perfcnt_device *pcdev = old_pc->pcdev;
+	struct perfcnt *new_pc = NULL;
+
+	if (WARN_ON(old_pc != pcdev->cur_pc))
+		return -EINVAL;
+
+	if (!list_empty(&pcdev->list_suspend))
+		new_pc = list_first_entry(&pcdev->list_suspend, struct perfcnt, list);
+
+	return perfcnt_device_swap_perfcnts(pcdev, new_pc, old_pc);
+}
+EXPORT_SYMBOL_GPL(perfcnt_release);
+
+int perfcnt_suspend(struct perfcnt_device *pcdev)
+{
+	if (!pcdev->cur_pc)
+		return 0;
+	return perfcnt_release(pcdev->cur_pc);
+}
+
+int perfcnt_resume(struct perfcnt_device *pcdev)
+{
+	struct perfcnt *new_pc = NULL;
+
+	if (!list_empty(&pcdev->list_suspend))
+		new_pc = list_first_entry(&pcdev->list_suspend, struct perfcnt, list);
+	if (new_pc)
+		return perfcnt_request(new_pc);
+	return 0;
+}
diff --git a/drivers/soc/realtek/common/pwrctrl/Kconfig b/drivers/soc/realtek/common/pwrctrl/Kconfig
new file mode 100644
index 00000000..bbf50b2
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/Kconfig
@@ -0,0 +1,72 @@
+menu "Power Control"
+
+config POWER_CONTROL
+	bool "Power Control Support"
+
+config POWER_CONTROL_DEBUGFS
+	bool "DebugFs for Power Control"
+	depends on POWER_CONTROL
+	default y if POWER_CONTROL
+
+config POWER_CONTROL_REALTEK
+	bool
+
+config POWER_CONTROL_PD_SRAM
+	bool
+
+config POWER_CONTROL_PD_SRAM_CH
+	bool
+
+config POWER_CONTROL_PD_SIMPLE
+	bool
+
+config POWER_CONTROL_RTD129X
+	bool "RTD129X SoC Power Controller"
+	depends on POWER_CONTROL
+	depends on ARCH_RTD129x
+	select PM_GENERIC_DOMAINS
+	select POWER_CONTROL_REALTEK
+	select POWER_CONTROL_PD_SRAM
+	select POWER_CONTROL_PD_SRAM_CH
+	select POWER_CONTROL_PD_SIMPLE
+	default y
+	help
+	  Realtek RTD129x Soc Power Controller Driver.
+
+config POWER_CONTROL_RTD139X
+	bool "RTD139X SoC Power Controller"
+	depends on POWER_CONTROL
+	depends on ARCH_RTD139x
+	select PM_GENERIC_DOMAINS
+	select POWER_CONTROL_REALTEK
+	select POWER_CONTROL_PD_SRAM
+	select POWER_CONTROL_PD_SIMPLE
+	default y
+	help
+	  Realtek RTD139x Soc Power Controller Driver.
+
+config POWER_CONTROL_RTD16XX
+	bool "RTD16XX SoC Power Controller"
+	depends on POWER_CONTROL
+	depends on ARCH_RTD16xx
+	select PM_GENERIC_DOMAINS
+	select POWER_CONTROL_REALTEK
+	select POWER_CONTROL_PD_SRAM
+	select POWER_CONTROL_PD_SIMPLE
+	default y
+	help
+	  Realtek RTD16xx Soc Power Controller Driver.
+
+config POWER_CONTROL_RTD13XX
+	bool "RTD13XX SoC Power Controller"
+	depends on POWER_CONTROL
+	depends on ARCH_RTD13xx
+	select PM_GENERIC_DOMAINS
+	select POWER_CONTROL_REALTEK
+	select POWER_CONTROL_PD_SRAM
+	select POWER_CONTROL_PD_SIMPLE
+	default y
+	help
+	  Realtek RTD13xx Soc Power Controller Driver.
+
+endmenu
diff --git a/drivers/soc/realtek/common/pwrctrl/Makefile b/drivers/soc/realtek/common/pwrctrl/Makefile
new file mode 100644
index 00000000..4b7d5a6
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/Makefile
@@ -0,0 +1,12 @@
+obj-$(CONFIG_POWER_CONTROL)         += pwrctrl_core.o
+obj-$(CONFIG_POWER_CONTROL_REALTEK) += pwrctrl-rtk.o
+
+pwrctrl-rtk-y += pwrctrl-pd.o
+pwrctrl-rtk-$(CONFIG_POWER_CONTROL_PD_SRAM) += pwrctrl-pd-sram.o
+pwrctrl-rtk-$(CONFIG_POWER_CONTROL_PD_SRAM_CH) += pwrctrl-pd-sram_ch.o
+pwrctrl-rtk-$(CONFIG_POWER_CONTROL_PD_SIMPLE) += pwrctrl-pd-simple.o
+
+pwrctrl-rtk-$(CONFIG_POWER_CONTROL_RTD129X) += pwrctrl-rtd129x.o
+pwrctrl-rtk-$(CONFIG_POWER_CONTROL_RTD139X) += pwrctrl-rtd139x.o
+pwrctrl-rtk-$(CONFIG_POWER_CONTROL_RTD16XX) += pwrctrl-rtd16xx.o
+pwrctrl-rtk-$(CONFIG_POWER_CONTROL_RTD13XX) += pwrctrl-rtd13xx.o
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd-simple.c b/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd-simple.c
new file mode 100644
index 00000000..862b07b
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd-simple.c
@@ -0,0 +1,136 @@
+/*
+ * pwrctrl-pd-simple.c - Simple PD
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/io.h>
+#include <linux/spinlock.h>
+#include <linux/slab.h>
+#include <soc/realtek/power-control.h>
+#include "pwrctrl_driver.h"
+#include "pwrctrl-pd.h"
+
+static inline unsigned long simple_power_lock(struct simple_pd *spd)
+{
+	unsigned long flags = 0;
+
+	if (spd->lock)
+		spin_lock_irqsave(spd->lock, flags);
+	return flags;
+}
+
+static inline void simple_power_unlock(struct simple_pd *spd,
+					unsigned long flags)
+{
+	if (spd->lock)
+		spin_unlock_irqrestore(spd->lock, flags);
+}
+
+static int simple_power_on(struct power_control *pwrctrl)
+{
+	struct simple_pd *spd = pc_to_simple_pd(pwrctrl);
+	unsigned long flags;
+	u32 val;
+
+	pr_debug("%s: %s\n", pwrctrl->name, __func__);
+
+	flags = simple_power_lock(spd);
+	val = readl(spd->base + spd->offset);
+	val = (val & ~spd->mask) | (spd->val_on & spd->mask);
+	writel(val, spd->base + spd->offset);
+	simple_power_unlock(spd, flags);
+
+	return 0;
+}
+
+static int simple_power_off(struct power_control *pwrctrl)
+{
+	struct simple_pd *spd = pc_to_simple_pd(pwrctrl);
+	unsigned long flags;
+	u32 val;
+
+	pr_debug("%s: %s\n", pwrctrl->name, __func__);
+
+	flags = simple_power_lock(spd);
+	val = readl(spd->base + spd->offset);
+	val = (val & ~spd->mask) | (spd->val_off & spd->mask);
+	writel(val, spd->base + spd->offset);
+	simple_power_unlock(spd, flags);
+
+	return 0;
+}
+
+static int simple_is_powered_on(struct power_control *pwrctrl)
+{
+	struct simple_pd *spd = pc_to_simple_pd(pwrctrl);
+
+	return (readl(spd->base + spd->offset) & spd->mask) ==
+	       (spd->val_on & spd->mask);
+}
+
+const struct power_control_ops simple_power_ops = {
+	.power_off     = simple_power_off,
+	.power_on      = simple_power_on,
+	.is_powered_on = simple_is_powered_on,
+};
+
+/* power chain */
+int simple_pd_add_power_chain(struct simple_pd *pd,
+			      struct power_control *pwrctrl,
+			      notifier_fn_t func)
+{
+	struct power_chain *pcx;
+	int ret;
+
+	if (!pd->pch) {
+		pd->pch = kzalloc(sizeof(*pd->pch), GFP_KERNEL);
+		if (!pd->pch)
+			return -ENOMEM;
+		INIT_LIST_HEAD(&pd->pch->list);
+	}
+	pcx = kzalloc(sizeof(*pcx), GFP_KERNEL);
+	if (!pcx)
+		return -ENOMEM;
+
+	pcx->self = &pd->core.pc;
+	pcx->ref  = pwrctrl;
+	pcx->power_nb.notifier_call = func;
+	ret = power_control_register_notifier(pcx->ref, &pcx->power_nb);
+	if (ret) {
+		pr_err("%s: power_control_register_notifier() returns %d\n",
+			pcx->ref->name, ret);
+		kfree(pcx);
+		return ret;
+	}
+
+	/* let the ref power-control controls currnet power-control */
+	power_control_get_internal(pcx->self);
+
+	list_add(&pcx->list, &pd->pch->list);
+	return 0;
+}
+
+void simple_pd_remove_power_chains(struct simple_pd *pd)
+{
+	struct power_chain *c, *n;
+
+	if (!pd->pch)
+		return;
+
+	list_for_each_entry_safe(c, n, &pd->pch->list, list) {
+		/* undo power_control_get_internal() */
+		power_control_put_internal(c->self);
+
+		power_control_unregister_notifier(c->ref, &c->power_nb);
+		list_del(&c->list);
+		kfree(c);
+	}
+	kfree(pd->pch);
+	pd->pch = NULL;
+}
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd-sram.c b/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd-sram.c
new file mode 100644
index 00000000..5941682
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd-sram.c
@@ -0,0 +1,239 @@
+/*
+ * pwrctrl-pd-sram.c - SRAM PD
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2017-2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/reset.h>
+#include <linux/spinlock.h>
+#include <soc/realtek/power-control.h>
+#include "pwrctrl_driver.h"
+#include "pwrctrl-pd.h"
+
+static int rtk_sram_power_init(struct power_control *pwrctrl);
+
+static inline unsigned long rtk_sram_power_lock(struct rtk_sram_pd *spd)
+{
+	unsigned long flags = 0;
+
+	if (spd->lock)
+		spin_lock_irqsave(spd->lock, flags);
+	return flags;
+}
+
+static inline void rtk_sram_power_unlock(struct rtk_sram_pd *spd,
+					 unsigned long flags)
+{
+	if (spd->lock)
+		spin_unlock_irqrestore(spd->lock, flags);
+}
+
+#define SRAM_PWR0 0x0
+#define SRAM_PWR1 0x4
+#define SRAM_PWR2 0x8
+#define SRAM_PWR3 0xC
+#define SRAM_PWR4 0x10
+#define SRAM_PWR5 0x14
+#define SRAM_PWR6 0x18
+
+#define sram_wait_for_int(cond, timeout_us)     \
+({                                              \
+	int ret = 0;                            \
+	int retry = timeout_us;                 \
+						\
+	for (;;) {                              \
+		if (cond)                       \
+			break;                  \
+		udelay(1);                      \
+		if (--retry > 0)                \
+			continue;               \
+		ret = -ETIME;                   \
+		break;                          \
+	}                                       \
+						\
+	ret;                                    \
+})
+
+static int rtk_sram_power_on(struct power_control *pwrctrl)
+{
+	struct rtk_sram_pd *spd = pc_to_rtk_sram_pd(pwrctrl);
+	unsigned int val;
+	unsigned long flags;
+	int ret;
+	u32 pwr4, pwr5;
+
+	pr_debug("%s: %s\n", pwrctrl->name, __func__);
+	pwr4 = spd->pwr_offset + SRAM_PWR4;
+	pwr5 = spd->pwr5_offset ? spd->pwr5_offset : (spd->pwr_offset + SRAM_PWR5);
+
+	flags = rtk_sram_power_lock(spd);
+
+	val = (spd->last_sd_ch << 8) | 0x0;
+	writel(val, spd->base + pwr4);
+
+	ret = sram_wait_for_int(readl(spd->base + pwr5) == 0x4, 500);
+	if (ret == -ETIME)
+		pr_warn("%s: %s: sram_int timeout\n", pwrctrl->name, __func__);
+	writel(0x4, spd->base + pwr5);
+
+	rtk_sram_power_unlock(spd, flags);
+	return 0;
+}
+
+static int rtk_sram_power_off(struct power_control *pwrctrl)
+{
+	struct rtk_sram_pd *spd = pc_to_rtk_sram_pd(pwrctrl);
+	unsigned int val;
+	unsigned long flags;
+	int ret;
+	u32 pwr4, pwr5;
+
+	pr_debug("%s: %s\n", pwrctrl->name, __func__);
+	pwr4 = spd->pwr_offset + SRAM_PWR4;
+	pwr5 = spd->pwr5_offset ? spd->pwr5_offset : (spd->pwr_offset + SRAM_PWR5);
+
+	flags = rtk_sram_power_lock(spd);
+
+	val = (spd->last_sd_ch << 8) | 0x1;
+	writel(val, spd->base + pwr4);
+
+	ret = sram_wait_for_int(readl(spd->base + pwr5) == 0x4, 500);
+	if (ret == -ETIME)
+		pr_warn("%s: %s: sram_int timeout\n", pwrctrl->name, __func__);
+	writel(0x4, spd->base + pwr5);
+
+	rtk_sram_power_unlock(spd, flags);
+
+	return 0;
+}
+
+static int rtk_sram_is_powered_on(struct power_control *pwrctrl)
+{
+	struct rtk_sram_pd *spd = pc_to_rtk_sram_pd(pwrctrl);
+	u32 pwr4 = spd->pwr_offset + SRAM_PWR4;
+
+	return (readl(spd->base + pwr4) & 1) == 0;
+}
+
+static int rtk_sram_power_off_unused(struct power_control *pwrctrl)
+{
+	pr_info("%s: %s\n", pwrctrl->name, __func__);
+	return pwrctrl->ops->power_off(pwrctrl);
+}
+
+const struct power_control_ops rtk_sram_power_ops = {
+	.power_off        = rtk_sram_power_off,
+	.power_on         = rtk_sram_power_on,
+	.is_powered_on    = rtk_sram_is_powered_on,
+	.init             = rtk_sram_power_init,
+	.power_off_unused = rtk_sram_power_off_unused,
+};
+
+static void rtk_sram_async_power_off_timeout(unsigned long data)
+{
+	struct power_control *pwrctrl = (struct power_control *)data;
+	struct rtk_sram_pd *spd = pc_to_rtk_sram_pd(pwrctrl);
+
+	__power_control_notify_power_off_start(pwrctrl);
+
+	spin_lock(&spd->timer_lock);
+	pr_debug("%s: %s\n", pwrctrl->name, __func__);
+	rtk_sram_power_off(pwrctrl);
+	spin_unlock(&spd->timer_lock);
+
+	__power_control_notify_power_off_done(pwrctrl);
+}
+
+static int rtk_sram_async_power_off(struct power_control *pwrctrl)
+{
+	struct rtk_sram_pd *spd = pc_to_rtk_sram_pd(pwrctrl);
+	unsigned long flags;
+	u64 expired_jiffies;
+
+	spin_lock_irqsave(&spd->timer_lock, flags);
+
+	pr_debug("%s: %s\n", pwrctrl->name, __func__);
+
+	expired_jiffies = msecs_to_jiffies(spd->expired_time * 1000);
+	if (!timer_pending(&spd->timer)) {
+		spd->timer.expires = get_jiffies_64() + expired_jiffies;
+		add_timer(&spd->timer);
+	} else {
+		mod_timer(&spd->timer, get_jiffies_64() + expired_jiffies);
+	}
+
+	spin_unlock_irqrestore(&spd->timer_lock, flags);
+
+	return 0;
+}
+
+static int rtk_sram_async_power_on(struct power_control *pwrctrl)
+{
+	struct rtk_sram_pd *spd = pc_to_rtk_sram_pd(pwrctrl);
+	unsigned long flags;
+	int ret = 0;
+
+	spin_lock_irqsave(&spd->timer_lock, flags);
+
+	pr_debug("%s: %s\n", pwrctrl->name, __func__);
+	del_timer(&spd->timer);
+	ret = rtk_sram_is_powered_on(pwrctrl);
+	if (ret == 1)
+		goto done;
+	ret = rtk_sram_power_on(pwrctrl);
+done:
+	spin_unlock_irqrestore(&spd->timer_lock, flags);
+	return ret;
+}
+
+static int rtk_sram_async_power_notifier(struct notifier_block *nb,
+					 unsigned long action,
+					 void *unused)
+{
+	struct rtk_sram_pd *spd = container_of(nb, struct rtk_sram_pd, pm_nb);
+	struct power_control *pwrctrl = &spd->core.pc;
+
+	if (action == RTK_PD_PM_SUSPEND_LATE) {
+		pr_debug("%s: %s: power_off\n", pwrctrl->name, __func__);
+		del_timer(&spd->timer);
+		rtk_sram_power_off(pwrctrl);
+		return NOTIFY_OK;
+	}
+
+	return NOTIFY_DONE;
+}
+
+static int rtk_sram_power_init(struct power_control *pwrctrl)
+{
+	struct rtk_sram_pd *spd = pc_to_rtk_sram_pd(pwrctrl);
+
+	if ((spd->core.flags & RTK_PD_NO_GENPD) && pwrctrl->ops == &rtk_sram_async_power_ops) {
+		WARN_ON(spd->expired_time == 0);
+		pr_debug("%s: %s: init_timer\n", pwrctrl->name, __func__);
+		spin_lock_init(&spd->timer_lock);
+		init_timer(&spd->timer);
+		spd->timer.function = rtk_sram_async_power_off_timeout;
+		spd->timer.data = (unsigned long)pwrctrl;
+		spd->pm_nb.notifier_call = rtk_sram_async_power_notifier;
+		pwrctrl->flags |= POWER_CONTROL_FLAG_ASYNC_POWER_OFF;
+		pwrctrl->flags |= POWER_CONTROL_FLAG_SHARED_POWER;
+		pwrctrl_pd_register_pm_notifier(&spd->pm_nb);
+	}
+	return 0;
+}
+
+const struct power_control_ops rtk_sram_async_power_ops = {
+	.power_off        = rtk_sram_async_power_off,
+	.power_on         = rtk_sram_async_power_on,
+	.is_powered_on    = rtk_sram_is_powered_on,
+	.init             = rtk_sram_power_init,
+	.power_off_unused = rtk_sram_power_off_unused,
+};
+
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd-sram_ch.c b/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd-sram_ch.c
new file mode 100644
index 00000000..0d6e016
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd-sram_ch.c
@@ -0,0 +1,103 @@
+/*
+ * pwrctrl-pd-sram_ch.c - SRAM PD by Channel
+ *
+ * Copyright (C) 2017-2018 Realtek Semiconductor Corporation
+ * Copyright (C) 2017-2018 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/reset.h>
+#include <linux/spinlock.h>
+#include <soc/realtek/power-control.h>
+#include "pwrctrl_driver.h"
+#include "pwrctrl-pd.h"
+
+static DEFINE_SPINLOCK(rtk_pc_lock);
+
+#define SRAM_PWR0 0x0
+#define SRAM_PWR1 0x4
+#define SRAM_PWR2 0x8
+#define SRAM_PWR3 0xC
+#define SRAM_PWR4 0x10
+#define SRAM_PWR5 0x14
+#define SRAM_PWR6 0x18
+
+#define sram_reg(_spd) ((_spd)->base + (_spd)->pwr_offset)
+#define sd_reg(_spd) (sram_reg(_spd) + SRAM_PWR2)
+#define mux_reg(_spd) (sram_reg(_spd) + SRAM_PWR3)
+
+static int rtk_sram_ch_power_on(struct power_control *pwrctrl)
+{
+	struct rtk_sram_ch_pd *spd = pc_to_rtk_sram_ch_pd(pwrctrl);
+	unsigned int mask;
+	unsigned int val;
+	unsigned long flags;
+
+	pr_debug("%s: %s\n", __func__, pwrctrl->name);
+
+	mask = (BIT(spd->width)- 1) << spd->shift;
+
+	spin_lock_irqsave(&rtk_pc_lock, flags);
+	val = readl(sd_reg(spd));
+	val &= ~mask;
+	writel(val, sd_reg(spd));
+	spin_unlock_irqrestore(&rtk_pc_lock, flags);
+
+	return 0;
+}
+
+static int rtk_sram_ch_power_off(struct power_control *pwrctrl)
+{
+	struct rtk_sram_ch_pd *spd = pc_to_rtk_sram_ch_pd(pwrctrl);
+	unsigned int mask;
+	unsigned int val;
+	unsigned long flags;
+
+	pr_debug("%s: %s\n", __func__, pwrctrl->name);
+	mask = (BIT(spd->width)- 1) << spd->shift;
+
+	spin_lock_irqsave(&rtk_pc_lock, flags);
+
+	val = readl(mux_reg(spd));
+	val |= mask;
+	writel(val, mux_reg(spd));
+
+	val = readl(sd_reg(spd));
+	val |= mask;
+	writel(val, sd_reg(spd));
+
+	spin_unlock_irqrestore(&rtk_pc_lock, flags);
+
+	return 0;
+}
+
+static int rtk_sram_is_powered_on(struct power_control *pwrctrl)
+{
+	struct rtk_sram_ch_pd *spd = pc_to_rtk_sram_ch_pd(pwrctrl);
+	unsigned int mask;
+	unsigned int val;
+	unsigned long flags;
+	int ret;
+
+	mask = (BIT(spd->width)- 1) << spd->shift;
+
+	spin_lock_irqsave(&rtk_pc_lock, flags);
+	val = readl(sd_reg(spd));
+	ret = (val & mask) == 0;
+	spin_unlock_irqrestore(&rtk_pc_lock, flags);
+
+	return 0;
+}
+
+const struct power_control_ops rtk_sram_ch_power_ops = {
+	.power_off     = rtk_sram_ch_power_off,
+	.power_on      = rtk_sram_ch_power_on,
+	.is_powered_on = rtk_sram_is_powered_on,
+};
+
+
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd.c b/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd.c
new file mode 100644
index 00000000..ff65692
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd.c
@@ -0,0 +1,336 @@
+/*
+ * Generic Power Control as Power Doamin
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2017-2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/of_address.h>
+#include <linux/pm_runtime.h>
+#include <linux/pm_domain.h>
+#include <soc/realtek/power-control.h>
+#include "pwrctrl_driver.h"
+#include "pwrctrl-pd.h"
+
+static LIST_HEAD(pm_list);
+static ATOMIC_NOTIFIER_HEAD(pm_notifier_list);
+
+static int pwrctrl_pd_power_on(struct generic_pm_domain *pd)
+{
+	struct pwrctrl_pd *core = pd_to_pwrctrl_pd(pd);
+
+	pr_debug("%s: %s\n", pd->name, __func__);
+	power_control_power_on(&core->pc);
+
+	return 0;
+}
+
+static int pwrctrl_pd_power_off(struct generic_pm_domain *pd)
+{
+	struct pwrctrl_pd *core = pd_to_pwrctrl_pd(pd);
+
+	pr_debug("%s: %s\n", pd->name, __func__);
+	power_control_power_off(&core->pc);
+
+	return 0;
+}
+
+static int pwrctrl_pd_attach_dev(struct generic_pm_domain *pd,
+				 struct device *dev)
+{
+	pr_debug("%s: attach %s %s\n", pd->name,
+		dev_driver_string(dev), dev_name(dev));
+	return 0;
+}
+
+static void pwrctrl_pd_detach_dev(struct generic_pm_domain *pd,
+				  struct device *dev)
+{
+	pr_debug("%s: detach %s %s\n", pd->name,
+		dev_driver_string(dev), dev_name(dev));
+}
+
+static int  pwrctrl_pd_power_notifier(struct notifier_block *nb,
+				      unsigned long action,
+				      void *unused)
+{
+	struct pwrctrl_pd *core = container_of(nb, struct pwrctrl_pd, debug_nb);
+
+	if (action != RTK_PD_PM_PREPARE && action != RTK_PD_PM_SUSPEND_NOIRQ)
+		return NOTIFY_DONE;
+
+	pr_info("%s: %s: power_state=%d\n", core->pd.name, __func__,
+		power_control_is_powered_on(&core->pc));
+	return NOTIFY_DONE;
+}
+
+void pwrctrl_pd_init(struct device *dev,
+		     struct pwrctrl_pd *pd,
+		     const struct pwrctrl_pd_initdata *data)
+{
+	int is_off = 1;
+
+	/* init */
+	pd->dev = dev;
+	pd->debug_nb.notifier_call = pwrctrl_pd_power_notifier;
+	pwrctrl_pd_register_pm_notifier(&pd->debug_nb);
+
+	if (IS_ENABLED(CONFIG_POWER_CONTROL_PD_SRAM) &&
+	   (pd->pc.ops == &rtk_sram_power_ops ||
+	   pd->pc.ops == &rtk_sram_async_power_ops)) {
+		struct rtk_sram_pd *spd = container_of(pd, struct rtk_sram_pd, core);
+
+		spd->base = data->base;
+	} else if (IS_ENABLED(CONFIG_POWER_CONTROL_PD_ANALOG) &&
+		   pd->pc.ops == &rtk_analog_power_ops) {
+		struct rtk_analog_pd *apd = container_of(pd, struct rtk_analog_pd, core);
+
+		apd->base = data->base;
+		apd->np = data->np;
+	} else if (IS_ENABLED(CONFIG_POWER_CONTROL_PD_SRAM_CH) &&
+		   pd->pc.ops == &rtk_sram_ch_power_ops) {
+		struct rtk_sram_ch_pd *spd = container_of(pd, struct rtk_sram_ch_pd, core);
+
+		spd->base = data->base;
+	} else if (IS_ENABLED(CONFIG_POWER_CONTROL_PD_SIMPLE) &&
+		  pd->pc.ops == &simple_power_ops) {
+		struct simple_pd *spd = container_of(pd, struct simple_pd, core);
+
+		spd->base = data->base;
+	}
+
+	/* setup power-control */
+	power_control_init(&pd->pc);
+	power_control_register(&pd->pc);
+	if (pd->flags & RTK_PD_NO_GENPD) {
+		pr_debug("%s: initialize as power_control %s\n",
+			pd->pd.name, pd->pc.name);
+		return;
+	}
+
+	/* since the power control is managed by genpd, increase the internal
+	 * usage count to prevent power-control framework to control it.
+	 */
+	power_control_get_internal(&pd->pc);
+
+	/* register genpd */
+	is_off = !pd->pc.ops->is_powered_on(&pd->pc);
+	pr_debug("%s: %s: default power is %s\n", pd->pd.name, __func__,
+		is_off ? "off" : "on");
+
+	pd->pd.attach_dev = pwrctrl_pd_attach_dev;
+	pd->pd.detach_dev = pwrctrl_pd_detach_dev;
+	pd->pd.power_on   = pwrctrl_pd_power_on;
+	pd->pd.power_off  = pwrctrl_pd_power_off;
+
+	pm_genpd_init(&pd->pd, NULL, is_off);
+	list_add(&pd->list, &pm_list);
+}
+
+static void pwrctrl_pd_sync(struct device *dev)
+{
+	struct pwrctrl_pd *pd;
+
+	/* sync state */
+	list_for_each_entry(pd, &pm_list, list) {
+		int st = power_control_is_powered_on(&pd->pc);
+
+		if (st < 0)
+			continue;
+
+		if (pd->dev != dev)
+			continue;
+
+		if (pd->pd.status == GPD_STATE_POWER_OFF && st == 1) {
+			pr_debug("%s: %s: power_off\n", pd->pd.name, __func__);
+			power_control_power_off(&pd->pc);
+		}
+
+		if (pd->pd.status == GPD_STATE_ACTIVE && st == 0) {
+			pr_debug("%s: %s: power_on\n", pd->pd.name, __func__);
+			power_control_power_on(&pd->pc);
+		}
+	}
+}
+
+
+int pwrctrl_pd_register_pm_notifier(struct notifier_block *nb)
+{
+	return atomic_notifier_chain_register(&pm_notifier_list, nb);
+}
+
+void pwrctrl_pd_unregister_pm_notifier(struct notifier_block *nb)
+{
+	atomic_notifier_chain_unregister(&pm_notifier_list, nb);
+}
+
+static int __pwrctrl_pd_pm_notify(struct device *dev, int pd_pm_state)
+{
+	return atomic_notifier_call_chain(&pm_notifier_list, pd_pm_state, dev);
+}
+
+void pwrctrl_pd_pm_notify(struct device *dev, int pd_pm_state)
+{
+	int ret;
+	const char *ststr;
+
+	switch (pd_pm_state) {
+	case RTK_PD_PM_RESUME_EARLY:
+		ststr = "resume_early";
+		pwrctrl_pd_sync(dev);
+		break;
+	case RTK_PD_PM_RESUME:
+		ststr = "resume";
+		break;
+	case RTK_PD_PM_PREPARE:
+		ststr = "prepare";
+		break;
+	case RTK_PD_PM_SUSPEND:
+		ststr = "suspend";
+		break;
+	case RTK_PD_PM_SUSPEND_LATE:
+		ststr = "suspend_late";
+		break;
+	case RTK_PD_PM_SUSPEND_NOIRQ:
+		ststr = "suspend_noirq";
+		break;
+	default:
+		dev_err(dev, "unknown state: %d\n", pd_pm_state);
+		return;
+	}
+	ret = __pwrctrl_pd_pm_notify(dev, pd_pm_state);
+	dev_info(dev, "%s: pm_state=%s returns %d\n", __func__, ststr, ret);
+}
+
+/* add power-control of-provider and power-domain of-provider */
+int power_controller_add_of_providers(struct device *dev,
+				      struct power_controller_data *pcd)
+{
+	struct device_node *np = dev->of_node;
+	int i;
+	int ret;
+
+	pcd->pd_data.domains = devm_kcalloc(dev, pcd->num_ppds,
+		sizeof(*pcd->pd_data.domains), GFP_KERNEL);
+	if (!pcd->pd_data.domains)
+		return -ENOMEM;
+	pcd->pd_data.num_domains = pcd->num_ppds;
+
+	pcd->pc_data.controls = devm_kcalloc(dev, pcd->num_ppds,
+		sizeof(*pcd->pc_data.controls), GFP_KERNEL);
+	if (!pcd->pc_data.controls)
+		return -ENOMEM;
+	pcd->pc_data.num_controls = pcd->num_ppds;
+
+
+	for (i = 0; i < pcd->num_ppds; i++) {
+		if (!pcd->ppds[i])
+			continue;
+
+		if (!(pcd->ppds[i]->flags & RTK_PD_NO_GENPD))
+			pcd->pd_data.domains[i] = &pcd->ppds[i]->pd;
+		pcd->pc_data.controls[i] = &pcd->ppds[i]->pc;
+	}
+
+	ret = of_genpd_add_provider_onecell(np, &pcd->pd_data);
+	WARN(ret, "of_genpd_add_provider_onecell() returns %d\n", ret);
+	ret = of_power_control_add_provider(np, of_power_control_xlate_onecell,
+		&pcd->pc_data);
+	WARN(ret, "of_power_control_add_provider() returns %d\n", ret);
+	return 0;
+}
+
+int power_controller_init_pds(struct device *dev,
+			      struct power_controller_data *pcd)
+{
+	struct device_node *np = dev->of_node;
+	struct pwrctrl_pd_initdata data;
+	int i;
+	int ret;
+
+	data.base = of_iomap(np, 0);
+	data.np = np;
+
+	for (i = 0; i < pcd->num_ppds; i++) {
+		if (!pcd->ppds[i])
+			continue;
+
+		if (of_pwrctrl_pd_is_invalid(np, pcd->ppds[i]->pd.name)) {
+			dev_notice(dev, "%s: not in current domain\n",
+				pcd->ppds[i]->pd.name);
+			pcd->ppds[i] = NULL;
+			continue;
+		}
+
+		pwrctrl_pd_init(dev, pcd->ppds[i], &data);
+	}
+
+	ret = power_controller_add_of_providers(dev, pcd);
+	WARN(ret, "power_controller_add_of_providers() returns %d\n", ret);
+
+	if (pcd->ready)
+		pcd->ready(pcd);
+	return 0;
+
+}
+
+static int power_controller_prepare(struct device *dev)
+{
+	dev_info(dev, "Enter %s\n", __func__);
+	pwrctrl_pd_pm_notify(dev, RTK_PD_PM_PREPARE);
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int power_controller_suspend(struct device *dev)
+{
+	dev_info(dev, "Enter %s\n", __func__);
+	pwrctrl_pd_pm_notify(dev, RTK_PD_PM_SUSPEND);
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int power_controller_suspend_late(struct device *dev)
+{
+	dev_info(dev, "Enter %s\n", __func__);
+	pwrctrl_pd_pm_notify(dev, RTK_PD_PM_SUSPEND_LATE);
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int power_controller_suspend_noirq(struct device *dev)
+{
+	dev_info(dev, "Enter %s\n", __func__);
+	pwrctrl_pd_pm_notify(dev, RTK_PD_PM_SUSPEND_NOIRQ);
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int power_controller_resume_early(struct device *dev)
+{
+	dev_info(dev, "Enter %s\n", __func__);
+	pwrctrl_pd_pm_notify(dev, RTK_PD_PM_RESUME_EARLY);
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int power_controller_resume(struct device *dev)
+{
+	dev_info(dev, "Enter %s\n", __func__);
+	pwrctrl_pd_pm_notify(dev, RTK_PD_PM_RESUME);
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+const struct dev_pm_ops power_controller_pm_ops = {
+	SET_SYSTEM_SLEEP_PM_OPS(power_controller_suspend,
+				power_controller_resume)
+	SET_LATE_SYSTEM_SLEEP_PM_OPS(power_controller_suspend_late,
+				     power_controller_resume_early)
+	.prepare = power_controller_prepare,
+	.suspend_noirq = power_controller_suspend_noirq,
+};
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd.h b/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd.h
new file mode 100644
index 00000000..7892c6c
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl-pd.h
@@ -0,0 +1,276 @@
+/*
+ * Power Control as Power Doamin
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2017-2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifndef __POWER_CONTROL_PD_H
+#define __POWER_CONTROL_PD_H
+
+#include <linux/pm_runtime.h>
+#include <linux/pm_domain.h>
+#include <linux/notifier.h>
+#include <linux/spinlock.h>
+#include <linux/timer.h>
+#include <soc/realtek/power-control.h>
+#include "pwrctrl_driver.h"
+
+struct device;
+struct device_node;
+
+/**
+ * struct pwrctrl_pd - core structure
+ *
+ * @pd: interface to genpd
+ * @pc: interface to power_control
+ * @dev: controller device
+ * @list: node to all pd
+ * @debug_nb: debug for pm state
+ * @flags: control flags
+ *
+ * *** flags ***
+ *  RTK_PD_NO_GENPD - don't init as a genpd
+ */
+struct pwrctrl_pd {
+	struct generic_pm_domain pd;
+	struct power_control pc;
+
+	struct device *dev;
+	struct list_head list;
+
+	struct notifier_block debug_nb;
+	unsigned int flags;
+};
+
+/* flags */
+#define RTK_PD_NO_GENPD           BIT(0)
+
+#define pd_to_pwrctrl_pd(_pd) container_of(_pd, struct pwrctrl_pd, pd)
+#define pc_to_pwrctrl_pd(_pc) container_of(_pc, struct pwrctrl_pd, pc)
+
+/* pm notify actions */
+enum {
+	RTK_PD_PM_PREPARE,
+	RTK_PD_PM_SUSPEND,
+	RTK_PD_PM_SUSPEND_LATE,
+	RTK_PD_PM_SUSPEND_NOIRQ,
+	RTK_PD_PM_RESUME_EARLY,
+	RTK_PD_PM_RESUME,
+};
+
+struct pwrctrl_pd_initdata {
+	struct device_node *np;
+	void *base;
+};
+
+void pwrctrl_pd_init(struct device *dev,
+		     struct pwrctrl_pd *pd,
+		     const struct pwrctrl_pd_initdata *data);
+void pwrctrl_pd_pm_notify(struct device *dev, int pd_pm_state);
+int pwrctrl_pd_register_pm_notifier(struct notifier_block *nb);
+void pwrctrl_pd_unregister_pm_notifier(struct notifier_block *nb);
+
+static inline bool of_pwrctrl_pd_is_invalid(struct device_node *np,
+					    const char *name)
+{
+	return of_property_match_string(np, "invalid-power-domains", name) >= 0;
+}
+
+/* sram pd */
+struct rtk_sram_pd {
+	struct pwrctrl_pd core;
+	void *base;
+	unsigned int pwr_offset;
+	unsigned int pwr5_offset;
+	unsigned int last_sd_ch;
+	spinlock_t *lock;
+
+	/* timer data */
+	struct timer_list timer;
+	int expired_time;
+	spinlock_t timer_lock;
+	struct notifier_block pm_nb;
+};
+
+#define pc_to_rtk_sram_pd(_pc) container_of(_pc, struct rtk_sram_pd, core.pc)
+#define pd_to_rtk_sram_pd(_pd) container_of(_pd, struct rtk_sram_pd, core.pd)
+
+extern const struct power_control_ops rtk_sram_power_ops;
+extern const struct power_control_ops rtk_sram_async_power_ops;
+
+/* sram ch pd */
+struct rtk_sram_ch_pd {
+	struct pwrctrl_pd core;
+	void *base;
+	unsigned int flags;
+	unsigned int pwr_offset;
+	int shift;
+	int width;
+};
+
+#define pc_to_rtk_sram_ch_pd(_pc) container_of(_pc, struct rtk_sram_ch_pd, core.pc)
+extern const struct power_control_ops rtk_sram_ch_power_ops;
+
+/* analog pd */
+struct rtk_analog_pd {
+	struct pwrctrl_pd core;
+	void *base;
+	unsigned int pwr_offset;
+	unsigned int flags;
+
+	const char *clk_name;
+	const char *rstn_name;
+	struct device_node *np;
+};
+
+#define pc_to_rtk_analog_pd(_pc) container_of(_pc, struct rtk_analog_pd, core.pc)
+extern const struct power_control_ops rtk_analog_power_ops;
+
+struct power_chain_head;
+
+/* simple pd */
+struct simple_pd {
+	struct pwrctrl_pd core;
+	void *base;
+	unsigned int offset;
+	unsigned int mask;
+	unsigned int val_on;
+	unsigned int val_off;
+	spinlock_t *lock;
+
+	struct power_chain_head *pch;
+};
+
+#define pc_to_simple_pd(_pc) container_of(_pc, struct simple_pd, core.pc)
+extern const struct power_control_ops simple_power_ops;
+
+/* simple pd: power chain */
+int simple_pd_add_power_chain(struct simple_pd *pd,
+			      struct power_control *pwrctrl,
+			      notifier_fn_t func);
+void simple_pd_remove_power_chains(struct simple_pd *pd);
+
+struct power_chain_head {
+	struct list_head list;
+};
+
+struct power_chain {
+	struct list_head list;
+	struct notifier_block power_nb;
+	struct power_control *ref;
+	struct power_control *self;
+};
+
+/* dummy pd */
+struct dummy_pd {
+	struct pwrctrl_pd core;
+	struct device_node *np;
+	int on;
+};
+
+#define pc_to_dummy_pd(_pc) \
+	container_of(_pc, struct dummy_pd, core.pc)
+extern const struct power_control_ops dummy_ops;
+
+/* power-controller */
+struct power_controller_data {
+	struct pwrctrl_pd **ppds;
+	int num_ppds;
+	struct generic_pm_domain **pds;
+	struct genpd_onecell_data pd_data;
+	struct power_control **pcs;
+	struct power_control_onecell_data pc_data;
+	int (*ready)(struct power_controller_data *);
+};
+
+int power_controller_add_of_providers(struct device *dev,
+				      struct power_controller_data *pcd);
+int power_controller_init_pds(struct device *dev,
+			      struct power_controller_data *pcd);
+extern const struct dev_pm_ops power_controller_pm_ops;
+
+/* helper macros */
+
+#define INIT_SRAM_CH_PD(_name, _off, _shift, _width)        \
+{                                                           \
+	.core.pd.name = "sram_ch_" #_name,                  \
+	.core.pc.name = "sram_ch_" #_name,                  \
+	.core.pc.ops =  &rtk_sram_ch_power_ops,             \
+	.pwr_offset = _off,                                 \
+	.shift = _shift,                                    \
+	.width = _width,                                    \
+}
+
+#define INIT_ISO_POWER_CONTROL(_name, _off, _mask, _lock)   \
+{                                                           \
+	.core.pd.name = "iso_" #_name,                      \
+	.core.pc.name = "iso_" #_name,                      \
+	.core.pc.ops = &simple_power_ops,                   \
+	.core.flags = RTK_PD_NO_GENPD,                      \
+	.offset = _off,                                     \
+	.mask = _mask,                                      \
+	.val_on = 0,                                        \
+	.val_off = _mask,                                   \
+	.lock = _lock,                                      \
+}
+
+#define __INIT_SRAM_COMM(_name, _off, _ch, _ops, _flags, _lock) \
+	                                                    \
+	.core.pd.name = #_name,                             \
+	.core.pc.name = #_name,                             \
+	.core.pc.ops = _ops,                                \
+	.core.flags = _flags,                               \
+	.pwr_offset = _off,                                 \
+	.last_sd_ch = _ch,                                  \
+	.lock = _lock,
+
+#define INIT_SRAM_PD(_name, _off, _ch, _lock)               \
+{                                                           \
+	__INIT_SRAM_COMM(sram_ ## _name, _off, _ch,	    \
+		&rtk_sram_power_ops, 0, _lock)              \
+}
+
+#define INIT_SRAM_POWER_CONTROL(_name, _off, _ch,  _lock)   \
+{                                                           \
+	__INIT_SRAM_COMM(pctrl_ ## _name, _off, _ch,        \
+		&rtk_sram_power_ops, RTK_PD_NO_GENPD,       \
+		_lock)                                      \
+}
+
+#define INIT_SRAM_ASYNC_POWER_CONTROL(_name, _off, _ch, _time, _lock) \
+{                                                           \
+	__INIT_SRAM_COMM(pctrl_ ## _name, _off, _ch,        \
+		&rtk_sram_async_power_ops, RTK_PD_NO_GENPD, \
+		_lock)                                      \
+	.expired_time = _time,                              \
+}
+
+#define INIT_SRAM_NC_PD(_name, _off, _off1, _ch, _lock)     \
+{                                                           \
+	__INIT_SRAM_COMM(sram_ ## _name, _off, _ch,	    \
+		&rtk_sram_power_ops, 0, _lock)              \
+	.pwr5_offset = _off1,                               \
+}
+
+#define INIT_SRAM_NC_POWER_CONTROL(_name, _off, _off1, _ch, _lock) \
+{                                                           \
+	__INIT_SRAM_COMM(pctrl_ ## _name, _off, _ch,        \
+		&rtk_sram_power_ops, RTK_PD_NO_GENPD,       \
+		_lock)                                      \
+	.pwr5_offset = _off1,                               \
+}
+
+#define INIT_SRAM_NC_ASYNC_POWER_CONTROL(_name, _off, _off1, _ch, _time, _lock) \
+{                                                           \
+	__INIT_SRAM_COMM(pctrl_ ## _name, _off, _ch,        \
+		&rtk_sram_async_power_ops, RTK_PD_NO_GENPD, \
+		_lock)                                      \
+	.pwr5_offset = _off1,                               \
+	.expired_time = _time,                              \
+}
+
+#endif
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd129x.c b/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd129x.c
new file mode 100644
index 00000000..3c05bc3
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd129x.c
@@ -0,0 +1,172 @@
+/*
+ * Power Controller for RTD-129x SoC
+ *
+ * Copyright (C) 2018,2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/pm_runtime.h>
+#include <linux/pm_domain.h>
+#include <linux/reset.h>
+#include <linux/slab.h>
+#include <linux/spinlock.h>
+#include <linux/suspend.h>
+#include <soc/realtek/power-control.h>
+#include <dt-bindings/power/rtk,power-rtd129x.h>
+#include "pwrctrl_driver.h"
+#include "pwrctrl-pd.h"
+
+/* crt power control items */
+static DEFINE_SPINLOCK(crt_power_lock);
+static struct rtk_sram_pd gpu_pd = INIT_SRAM_NC_ASYNC_POWER_CONTROL(gpu, 0x394, 0x3ac, 0x3, 1, &crt_power_lock);
+static struct rtk_sram_pd ve1_pd = INIT_SRAM_NC_ASYNC_POWER_CONTROL(ve1, 0x380, 0x3a8, 0xf, 10, &crt_power_lock);
+static struct rtk_sram_pd ve2_pd = INIT_SRAM_NC_ASYNC_POWER_CONTROL(ve2, 0x3c0, 0x0, 0xf, 10, &crt_power_lock);
+static struct rtk_sram_pd ve3_pd = INIT_SRAM_NC_ASYNC_POWER_CONTROL(ve3, 0x3e0, 0x0, 0xf, 10, &crt_power_lock);
+static struct rtk_sram_pd nat_pd = INIT_SRAM_NC_PD(nat, 0x420, 0x0, 0xf, &crt_power_lock);
+static struct rtk_sram_ch_pd disp_se_pd = INIT_SRAM_CH_PD(se, 0x360, 5, 3);
+static struct rtk_sram_ch_pd disp_mipi_pd = INIT_SRAM_CH_PD(mipi, 0x360, 8, 1);
+static struct rtk_sram_ch_pd disp_hdmirx_pd = INIT_SRAM_CH_PD(hdmirx, 0x360, 11, 4);
+static struct simple_pd ve1_iso = INIT_ISO_POWER_CONTROL(ve1, 0x400, BIT(1), &crt_power_lock);
+static struct simple_pd ve2_iso = INIT_ISO_POWER_CONTROL(ve2, 0x400, BIT(4), &crt_power_lock);
+static struct simple_pd ve3_iso = INIT_ISO_POWER_CONTROL(ve3, 0x400, BIT(6), &crt_power_lock);
+static struct simple_pd gpu_iso = INIT_ISO_POWER_CONTROL(gpu, 0x400, BIT(3), &crt_power_lock);
+static struct simple_pd nat_iso = INIT_ISO_POWER_CONTROL(nat, 0x400, BIT(18), &crt_power_lock);
+
+#define PD_SIMPLE_ISO_VE1               (PD_MAX)
+#define PD_SIMPLE_ISO_VE2               (PD_MAX+1)
+#define PD_SIMPLE_ISO_VE3               (PD_MAX+2)
+#define PD_SIMPLE_ISO_GPU               (PD_MAX+3)
+#define PD_SIMPLE_ISO_NAT               (PD_MAX+4)
+#define INTERNAL_PD_MAX                 (PD_MAX+5)
+
+static struct pwrctrl_pd *crt_ppds[INTERNAL_PD_MAX] = {
+	[PD_SRAM_VE1]         = &ve1_pd.core,
+	[PD_SRAM_VE2]         = &ve2_pd.core,
+	[PD_SRAM_VE3]         = &ve3_pd.core,
+	[PD_SRAM_NAT]         = &nat_pd.core,
+	[PD_SRAM_GPU]         = &gpu_pd.core,
+	[PD_SRAM_DISP_SE]     = &disp_se_pd.core,
+	[PD_SRAM_DISP_MIPI]   = &disp_mipi_pd.core,
+	[PD_SRAM_DISP_HDMIRX] = &disp_hdmirx_pd.core,
+	[PD_SIMPLE_ISO_VE1]   = &ve1_iso.core,
+	[PD_SIMPLE_ISO_VE2]   = &ve2_iso.core,
+	[PD_SIMPLE_ISO_VE3]   = &ve3_iso.core,
+	[PD_SIMPLE_ISO_GPU]   = &gpu_iso.core,
+	[PD_SIMPLE_ISO_NAT]   = &nat_iso.core,
+};
+
+static int power_chain_callback(struct notifier_block *nb, unsigned long action, void *data)
+{
+	struct power_chain *pcx = container_of(nb, struct power_chain, power_nb);
+	struct power_chain_head *pch = pc_to_simple_pd(pcx->self)->pch;
+
+	if (action != POWER_CONTROL_ACTION_POST_POWER_ON &&
+	    action != POWER_CONTROL_ACTION_PRE_POWER_OFF)
+		return NOTIFY_DONE;
+
+	if (action == POWER_CONTROL_ACTION_POST_POWER_ON) {
+
+		if (power_control_is_powered_on(pcx->self))
+			return NOTIFY_OK;
+
+		pr_debug("%s: %s: power_on\n", pcx->self->name, __func__);
+		power_control_power_on(pcx->self);
+
+	} else if (action == POWER_CONTROL_ACTION_PRE_POWER_OFF) {
+		struct power_chain *ch;
+
+		list_for_each_entry(ch, &pch->list, list) {
+			if (ch->ref == data)
+				continue;
+			if (power_control_is_powered_on(ch->ref))
+				return NOTIFY_OK;
+		}
+		pr_debug("%s: %s: power_off\n", pcx->self->name, __func__);
+		power_control_power_off(pcx->self);
+	}
+
+	return NOTIFY_OK;
+}
+
+static int crt_power_controller_setup_topology(void)
+{
+	simple_pd_add_power_chain(&ve1_iso, &ve1_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&ve2_iso, &ve2_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&ve3_iso, &ve3_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&gpu_iso, &gpu_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&nat_iso, &nat_pd.core.pc, power_chain_callback);
+	return 0;
+}
+
+static int crt_power_controller_ready(struct power_controller_data *data)
+{
+	crt_power_controller_setup_topology();
+	return 0;
+}
+
+static struct power_controller_data crt_data = {
+	.ppds = crt_ppds,
+	.num_ppds = ARRAY_SIZE(crt_ppds),
+	.ready = crt_power_controller_ready,
+};
+
+static const struct of_device_id power_controller_match[];
+
+static int power_controller_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct power_controller_data *pcd;
+	const struct of_device_id *id;
+
+	/* get controller data */
+	id = of_match_node(power_controller_match, dev->of_node);
+	if (!id)
+		return -ENODEV;
+
+	pcd = (struct power_controller_data *)id->data;
+	dev_set_drvdata(dev, pcd);
+	power_controller_init_pds(dev, pcd);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static const struct of_device_id power_controller_match[] = {
+	{.compatible = "realtek,rtd129x-crt-power", .data = &crt_data},
+	{}
+};
+
+static struct platform_driver power_controller_driver = {
+	.probe = power_controller_probe,
+	.driver = {
+		.name = "rtk-rtd129x-power",
+		.of_match_table = power_controller_match,
+		.pm = &power_controller_pm_ops,
+	},
+};
+
+static int __init power_controller_init(void)
+{
+	return platform_driver_register(&power_controller_driver);
+}
+arch_initcall(power_controller_init);
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd139x.c b/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd139x.c
new file mode 100644
index 00000000..b5e1490
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd139x.c
@@ -0,0 +1,176 @@
+/*
+ * Power Controller for RTD-139x SoC
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/pm_runtime.h>
+#include <linux/pm_domain.h>
+#include <linux/reset.h>
+#include <linux/slab.h>
+#include <linux/spinlock.h>
+#include <linux/suspend.h>
+#include <soc/realtek/power-control.h>
+#include <dt-bindings/power/rtk,power-rtd139x.h>
+#include "pwrctrl_driver.h"
+#include "pwrctrl-pd.h"
+
+static DEFINE_SPINLOCK(iso_power_lock);
+static struct rtk_sram_pd gpu_pd = INIT_SRAM_PD(gpu, 0xb60, 7, &iso_power_lock);
+static struct rtk_sram_pd ve1_pd  = INIT_SRAM_ASYNC_POWER_CONTROL(ve1, 0xb00, 0xf, 10, &iso_power_lock);
+static struct rtk_sram_pd ve2_pd  = INIT_SRAM_ASYNC_POWER_CONTROL(ve2, 0xb20, 0xf, 10, &iso_power_lock);
+static struct simple_pd ve1_iso = INIT_ISO_POWER_CONTROL(ve1, 0xfd0, BIT(0), &iso_power_lock);
+static struct simple_pd ve2_iso = INIT_ISO_POWER_CONTROL(ve2, 0xfd0, BIT(1), &iso_power_lock);
+static struct simple_pd gpu_iso = INIT_ISO_POWER_CONTROL(gpu, 0xfd0, BIT(3), &iso_power_lock);
+
+#define PD_MAX                          (RTD139X_PD_MAX)
+#define PD_SIMPLE_ISO_VE1               (PD_MAX)
+#define PD_SIMPLE_ISO_VE2               (PD_MAX+1)
+#define PD_SIMPLE_ISO_VE3               (PD_MAX+2)
+#define PD_SIMPLE_ISO_GPU               (PD_MAX+3)
+#define INTERNAL_PD_MAX                 (PD_MAX+4)
+
+static struct pwrctrl_pd *iso_ppds[INTERNAL_PD_MAX] = {
+	[RTD139X_PD_VE1] = &ve1_pd.core,
+	[RTD139X_PD_VE2] = &ve2_pd.core,
+	[RTD139X_PD_GPU] = &gpu_pd.core,
+	[PD_SIMPLE_ISO_VE1] = &ve1_iso.core,
+	[PD_SIMPLE_ISO_VE2] = &ve2_iso.core,
+	[PD_SIMPLE_ISO_GPU] = &gpu_iso.core,
+};
+
+static int ve1_manual_power_callback(struct notifier_block *nb,
+				   unsigned long action,
+				   void *data)
+{
+	struct rtk_sram_pd *spd = pc_to_rtk_sram_pd(data);
+
+	if (action != POWER_CONTROL_ACTION_PRE_POWER_OFF)
+		return NOTIFY_OK;
+
+	pr_debug("%s: %s\n", spd->core.pc.name, __func__);
+	writel(0x00008000, spd->base + spd->pwr_offset + 0xC);
+	return NOTIFY_DONE;
+}
+
+static struct notifier_block ve1_nb = {
+	.notifier_call = ve1_manual_power_callback,
+};
+
+static int power_chain_callback(struct notifier_block *nb, unsigned long action, void *data)
+{
+	struct power_chain *pcx = container_of(nb, struct power_chain, power_nb);
+	struct power_chain_head *pch = pc_to_simple_pd(pcx->self)->pch;
+
+	if (action != POWER_CONTROL_ACTION_POST_POWER_ON &&
+	    action != POWER_CONTROL_ACTION_PRE_POWER_OFF)
+		return NOTIFY_DONE;
+
+	if (action == POWER_CONTROL_ACTION_POST_POWER_ON) {
+
+		if (power_control_is_powered_on(pcx->self))
+			return NOTIFY_OK;
+
+		pr_debug("%s: %s: power_on\n", pcx->self->name, __func__);
+		power_control_power_on(pcx->self);
+
+	} else if (action == POWER_CONTROL_ACTION_PRE_POWER_OFF) {
+		struct power_chain *ch;
+
+		list_for_each_entry(ch, &pch->list, list) {
+			if (ch->ref == data)
+				continue;
+			if (power_control_is_powered_on(ch->ref))
+				return NOTIFY_OK;
+		}
+		pr_debug("%s: %s: power_off\n", pcx->self->name, __func__);
+		power_control_power_off(pcx->self);
+	}
+
+	return NOTIFY_OK;
+}
+
+static int iso_power_controller_setup_topology(void)
+{
+	simple_pd_add_power_chain(&ve1_iso, &ve1_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&ve2_iso, &ve2_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&gpu_iso, &gpu_pd.core.pc, power_chain_callback);
+	return 0;
+}
+
+static int iso_power_controller_ready(struct power_controller_data *data)
+{
+	ve1_pd.core.pc.flags |= POWER_CONTROL_FLAG_SHARED_POWER;
+	ve2_pd.core.pc.flags |= POWER_CONTROL_FLAG_SHARED_POWER;
+	power_control_register_notifier(&ve1_pd.core.pc, &ve1_nb);
+	iso_power_controller_setup_topology();
+	return 0;
+}
+
+static struct power_controller_data iso_data = {
+	.ppds = iso_ppds,
+	.num_ppds = ARRAY_SIZE(iso_ppds),
+	.ready = iso_power_controller_ready,
+};
+
+static const struct of_device_id power_controller_match[];
+
+static int power_controller_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct power_controller_data *pcd;
+	const struct of_device_id *id;
+
+	/* get controller data */
+	id = of_match_node(power_controller_match, dev->of_node);
+	if (!id)
+		return -ENODEV;
+
+	pcd = (struct power_controller_data *)id->data;
+	dev_set_drvdata(dev, pcd);
+	power_controller_init_pds(dev, pcd);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static const struct of_device_id power_controller_match[] = {
+	{.compatible = "realtek,rtd139x-power-controller", .data = &iso_data},
+	{}
+};
+
+static struct platform_driver power_controller_driver = {
+	.probe = power_controller_probe,
+	.driver = {
+		.name = "rtk-rtd139x-power",
+		.of_match_table = power_controller_match,
+		.pm = &power_controller_pm_ops,
+	},
+};
+
+static int __init power_controller_init(void)
+{
+	return platform_driver_register(&power_controller_driver);
+}
+arch_initcall(power_controller_init);
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd13xx.c b/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd13xx.c
new file mode 100644
index 00000000..9107ee2
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd13xx.c
@@ -0,0 +1,181 @@
+/*
+ * Power Controller for RTD-13xx SoC
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/pm_runtime.h>
+#include <linux/pm_domain.h>
+#include <linux/reset.h>
+#include <linux/slab.h>
+#include <linux/spinlock.h>
+#include <linux/suspend.h>
+#include <soc/realtek/power-control.h>
+#include <dt-bindings/power/rtk,power-rtd13xx.h>
+#include "pwrctrl_driver.h"
+#include "pwrctrl-pd.h"
+
+static DEFINE_SPINLOCK(iso_power_lock);
+static struct rtk_sram_pd gpu_pd = INIT_SRAM_PD(gpu, 0xb60, 0xf, &iso_power_lock);
+static struct rtk_sram_pd ve1_pd = INIT_SRAM_ASYNC_POWER_CONTROL(ve1, 0xb00, 0xf, 10, &iso_power_lock);
+static struct rtk_sram_pd ve2_pd = INIT_SRAM_ASYNC_POWER_CONTROL(ve2, 0xb20, 0xf, 10, &iso_power_lock);
+static struct rtk_sram_pd ve3_pd = INIT_SRAM_ASYNC_POWER_CONTROL(ve3, 0x290, 0xf, 10, &iso_power_lock);
+static struct simple_pd ve1_iso = INIT_ISO_POWER_CONTROL(ve1, 0xfd0, BIT(0), &iso_power_lock);
+static struct simple_pd ve2_iso = INIT_ISO_POWER_CONTROL(ve2, 0xfd0, BIT(1), &iso_power_lock);
+static struct simple_pd ve3_iso = INIT_ISO_POWER_CONTROL(ve3, 0xfd0, BIT(10), &iso_power_lock);
+static struct simple_pd gpu_iso = INIT_ISO_POWER_CONTROL(gpu, 0xfd0, BIT(3), &iso_power_lock);
+
+#define PD_SIMPLE_ISO_VE1               (PD_MAX)
+#define PD_SIMPLE_ISO_VE2               (PD_MAX+1)
+#define PD_SIMPLE_ISO_VE3               (PD_MAX+2)
+#define PD_SIMPLE_ISO_GPU               (PD_MAX+3)
+#define INTERNAL_PD_MAX                 (PD_MAX+4)
+
+static int ve1_manual_power_callback(struct notifier_block *nb,
+				     unsigned long action,
+				     void *data)
+{
+	struct rtk_sram_pd *spd = pc_to_rtk_sram_pd(data);
+
+	if (action != POWER_CONTROL_ACTION_PRE_POWER_OFF)
+		return NOTIFY_OK;
+
+	pr_debug("%s: %s\n", spd->core.pc.name, __func__);
+	writel(0x00008000, spd->base + spd->pwr_offset + 0xC);
+	return NOTIFY_DONE;
+}
+
+static struct notifier_block ve1_nb = {
+	.notifier_call = ve1_manual_power_callback,
+};
+
+static int power_chain_callback(struct notifier_block *nb, unsigned long action, void *data)
+{
+	struct power_chain *pcx = container_of(nb, struct power_chain, power_nb);
+	struct power_chain_head *pch = pc_to_simple_pd(pcx->self)->pch;
+
+	if (action != POWER_CONTROL_ACTION_POST_POWER_ON &&
+	    action != POWER_CONTROL_ACTION_PRE_POWER_OFF)
+		return NOTIFY_DONE;
+
+	if (action == POWER_CONTROL_ACTION_POST_POWER_ON) {
+
+		if (power_control_is_powered_on(pcx->self))
+			return NOTIFY_OK;
+
+		pr_debug("%s: %s: power_on\n", pcx->self->name, __func__);
+		power_control_power_on(pcx->self);
+
+	} else if (action == POWER_CONTROL_ACTION_PRE_POWER_OFF) {
+		struct power_chain *ch;
+
+		list_for_each_entry(ch, &pch->list, list) {
+			if (ch->ref == data)
+				continue;
+			if (power_control_is_powered_on(ch->ref))
+				return NOTIFY_OK;
+		}
+		pr_debug("%s: %s: power_off\n", pcx->self->name, __func__);
+		power_control_power_off(pcx->self);
+	}
+
+	return NOTIFY_OK;
+}
+
+static int iso_power_controller_setup_topology(void)
+{
+	ve2_pd.core.pc.flags |= POWER_CONTROL_FLAG_IGNORE_UNUSED;
+	ve2_iso.core.pc.flags |= POWER_CONTROL_FLAG_IGNORE_UNUSED;
+	simple_pd_add_power_chain(&ve1_iso, &ve1_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&ve2_iso, &ve2_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&ve3_iso, &ve3_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&gpu_iso, &gpu_pd.core.pc, power_chain_callback);
+	return 0;
+}
+
+static struct pwrctrl_pd *iso_ppds[INTERNAL_PD_MAX] = {
+	[PD_SRAM_VE1] = &ve1_pd.core,
+	[PD_SRAM_VE2] = &ve2_pd.core,
+	[PD_SRAM_VE3] = &ve3_pd.core,
+	[PD_SRAM_GPU] = &gpu_pd.core,
+	[PD_SIMPLE_ISO_VE1] = &ve1_iso.core,
+	[PD_SIMPLE_ISO_VE2] = &ve2_iso.core,
+	[PD_SIMPLE_ISO_VE3] = &ve3_iso.core,
+	[PD_SIMPLE_ISO_GPU] = &gpu_iso.core,
+};
+
+static int iso_power_controller_ready(struct power_controller_data *data)
+{
+	power_control_register_notifier(&ve1_pd.core.pc, &ve1_nb);
+	iso_power_controller_setup_topology();
+	return 0;
+}
+
+static struct power_controller_data iso_data = {
+	.ppds = iso_ppds,
+	.num_ppds = ARRAY_SIZE(iso_ppds),
+	.ready = iso_power_controller_ready,
+};
+
+static const struct of_device_id power_controller_match[];
+
+static int power_controller_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct power_controller_data *pcd;
+	const struct of_device_id *id;
+
+	/* get controller data */
+	id = of_match_node(power_controller_match, dev->of_node);
+	if (!id)
+		return -ENODEV;
+
+	pcd = (struct power_controller_data *)id->data;
+	dev_set_drvdata(dev, pcd);
+	power_controller_init_pds(dev, pcd);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static const struct of_device_id power_controller_match[] = {
+	{.compatible = "realtek,rtd13xx-power-controller", .data = &iso_data},
+	{}
+};
+
+static struct platform_driver power_controller_driver = {
+	.probe = power_controller_probe,
+	.driver = {
+		.name = "rtk-rtd13xx-power",
+		.of_match_table = power_controller_match,
+		.pm = &power_controller_pm_ops,
+	},
+};
+
+static int __init power_controller_init(void)
+{
+	return platform_driver_register(&power_controller_driver);
+}
+arch_initcall(power_controller_init);
+
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd16xx.c b/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd16xx.c
new file mode 100644
index 00000000..37f11fd
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl-rtd16xx.c
@@ -0,0 +1,192 @@
+/*
+ * Power Controller for RTD-16xx SoC
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *	Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/pm_runtime.h>
+#include <linux/pm_domain.h>
+#include <linux/reset.h>
+#include <linux/slab.h>
+#include <linux/spinlock.h>
+#include <linux/suspend.h>
+#include <soc/realtek/power-control.h>
+#include <dt-bindings/power/rtk,power-rtd16xx.h>
+#include "pwrctrl_driver.h"
+#include "pwrctrl-pd.h"
+
+static DEFINE_SPINLOCK(iso_power_lock);
+static struct rtk_sram_pd gpu_pd = INIT_SRAM_PD(gpu, 0xb60, 7, &iso_power_lock);
+static struct rtk_sram_pd ve1_pd = INIT_SRAM_ASYNC_POWER_CONTROL(ve1, 0xb00, 0xf, 10, &iso_power_lock);
+static struct rtk_sram_pd ve2_pd = INIT_SRAM_ASYNC_POWER_CONTROL(ve2, 0xb20, 0xf, 10, &iso_power_lock);
+static struct rtk_sram_pd ve3_pd = INIT_SRAM_ASYNC_POWER_CONTROL(ve3, 0x290, 0xf, 10, &iso_power_lock);
+static struct rtk_sram_pd hdmirx_pd = INIT_SRAM_POWER_CONTROL(hdmirx, 0x260, 0xf, &iso_power_lock);
+static struct simple_pd ve1_iso = INIT_ISO_POWER_CONTROL(ve1, 0xfd0, BIT(0), &iso_power_lock);
+static struct simple_pd ve2_iso = INIT_ISO_POWER_CONTROL(ve2, 0xfd0, BIT(1), &iso_power_lock);
+static struct simple_pd ve3_iso = INIT_ISO_POWER_CONTROL(ve3, 0xfd0, BIT(10), &iso_power_lock);
+static struct simple_pd gpu_iso = INIT_ISO_POWER_CONTROL(gpu, 0xfd0, BIT(3), &iso_power_lock);
+static struct simple_pd hdmirx_iso = INIT_ISO_POWER_CONTROL(hdmirx, 0xfd0, BIT(9), &iso_power_lock);
+static struct simple_pd gpu_2_iso = INIT_ISO_POWER_CONTROL(gpu_2, 0x078, BIT(1), &iso_power_lock);
+
+#define PD_SIMPLE_ISO_VE1               (PD_MAX)
+#define PD_SIMPLE_ISO_VE2               (PD_MAX+1)
+#define PD_SIMPLE_ISO_VE3               (PD_MAX+2)
+#define PD_SIMPLE_ISO_GPU               (PD_MAX+3)
+#define PD_SIMPLE_ISO_HDMIRX            (PD_MAX+4)
+#define PD_SIMPLE_ISO_GPU_2             (PD_MAX+5)
+#define INTERNAL_PD_MAX                 (PD_MAX+6)
+
+static int ve1_manual_power_callback(struct notifier_block *nb,
+				   unsigned long action,
+				   void *data)
+{
+	struct rtk_sram_pd *spd = pc_to_rtk_sram_pd(data);
+
+	if (action != POWER_CONTROL_ACTION_PRE_POWER_OFF)
+		return NOTIFY_OK;
+
+	pr_debug("%s: %s\n", spd->core.pc.name, __func__);
+	writel(0x00008000, spd->base + spd->pwr_offset + 0xC);
+	return NOTIFY_DONE;
+}
+
+static struct notifier_block ve1_nb = {
+	.notifier_call = ve1_manual_power_callback,
+};
+
+static int power_chain_callback(struct notifier_block *nb, unsigned long action, void *data)
+{
+	struct power_chain *pcx = container_of(nb, struct power_chain, power_nb);
+	struct power_chain_head *pch = pc_to_simple_pd(pcx->self)->pch;
+
+	if (action != POWER_CONTROL_ACTION_POST_POWER_ON &&
+	    action != POWER_CONTROL_ACTION_PRE_POWER_OFF)
+		return NOTIFY_DONE;
+
+	if (action == POWER_CONTROL_ACTION_POST_POWER_ON) {
+
+		if (power_control_is_powered_on(pcx->self))
+			return NOTIFY_OK;
+
+		pr_debug("%s: %s: power_on\n", pcx->self->name, __func__);
+		power_control_power_on(pcx->self);
+
+	} else if (action == POWER_CONTROL_ACTION_PRE_POWER_OFF) {
+		struct power_chain *ch;
+
+		list_for_each_entry(ch, &pch->list, list) {
+			if (ch->ref == data)
+				continue;
+			if (power_control_is_powered_on(ch->ref))
+				return NOTIFY_OK;
+		}
+		pr_debug("%s: %s: power_off\n", pcx->self->name, __func__);
+		power_control_power_off(pcx->self);
+	}
+
+	return NOTIFY_OK;
+}
+
+static int iso_power_controller_setup_topology(void)
+{
+	simple_pd_add_power_chain(&ve1_iso, &ve1_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&ve2_iso, &ve2_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&ve3_iso, &ve3_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&gpu_iso, &gpu_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&gpu_2_iso, &gpu_pd.core.pc, power_chain_callback);
+	simple_pd_add_power_chain(&hdmirx_iso, &hdmirx_pd.core.pc, power_chain_callback);
+	return 0;
+}
+
+static struct pwrctrl_pd *iso_ppds[INTERNAL_PD_MAX] = {
+	[PD_SRAM_VE1] = &ve1_pd.core,
+	[PD_SRAM_VE2] = &ve2_pd.core,
+	[PD_SRAM_VE3] = &ve3_pd.core,
+	[PD_SRAM_GPU] = &gpu_pd.core,
+	[PD_SRAM_HDMIRX] = &hdmirx_pd.core,
+	[PD_SIMPLE_ISO_VE1] = &ve1_iso.core,
+	[PD_SIMPLE_ISO_VE2] = &ve2_iso.core,
+	[PD_SIMPLE_ISO_VE3] = &ve3_iso.core,
+	[PD_SIMPLE_ISO_GPU] = &gpu_iso.core,
+	[PD_SIMPLE_ISO_GPU_2] = &gpu_2_iso.core,
+	[PD_SIMPLE_ISO_HDMIRX] = &hdmirx_iso.core,
+};
+
+static int iso_power_controller_ready(struct power_controller_data *data)
+{
+	ve1_pd.core.pc.flags |= POWER_CONTROL_FLAG_SHARED_POWER;
+	ve2_pd.core.pc.flags |= POWER_CONTROL_FLAG_SHARED_POWER;
+	ve3_pd.core.pc.flags |= POWER_CONTROL_FLAG_SHARED_POWER;
+	power_control_register_notifier(&ve1_pd.core.pc, &ve1_nb);
+	iso_power_controller_setup_topology();
+	return 0;
+}
+
+static struct power_controller_data iso_data = {
+	.ppds = iso_ppds,
+	.num_ppds = ARRAY_SIZE(iso_ppds),
+	.ready = iso_power_controller_ready,
+};
+
+static const struct of_device_id power_controller_match[];
+
+static int power_controller_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct power_controller_data *pcd;
+	const struct of_device_id *id;
+
+	/* get controller data */
+	id = of_match_node(power_controller_match, dev->of_node);
+	if (!id)
+		return -ENODEV;
+
+	pcd = (struct power_controller_data *)id->data;
+	dev_set_drvdata(dev, pcd);
+	power_controller_init_pds(dev, pcd);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static const struct of_device_id power_controller_match[] = {
+	{.compatible = "realtek,rtd16xx-power-controller", .data = &iso_data},
+	{}
+};
+
+static struct platform_driver power_controller_driver = {
+	.probe = power_controller_probe,
+	.driver = {
+		.name = "rtk-rtd16xx-power",
+		.of_match_table = power_controller_match,
+		.pm = &power_controller_pm_ops,
+	},
+};
+
+static int __init power_controller_init(void)
+{
+	return platform_driver_register(&power_controller_driver);
+}
+arch_initcall(power_controller_init);
+
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl_core.c b/drivers/soc/realtek/common/pwrctrl/pwrctrl_core.c
new file mode 100644
index 00000000..b954284
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl_core.c
@@ -0,0 +1,509 @@
+/*
+ * Power Control core & APIs
+ *
+ * Copyright (C) 2016-2017,2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2016-2017,2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#define pr_fmt(fmt) "power_control: " fmt
+
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/of.h>
+#include <linux/spinlock.h>
+#include <linux/mutex.h>
+#include <linux/debugfs.h>
+#include <linux/notifier.h>
+#include <linux/atomic.h>
+#include <soc/realtek/power-control.h>
+#include "pwrctrl_driver.h"
+
+MODULE_LICENSE("GPL");
+
+static DEFINE_MUTEX(power_control_list_lock);
+static LIST_HEAD(power_control_list);
+static int power_control_add_debugfs(struct power_control *pwrctrl);
+static void power_control_del_debugfs(struct power_control *pwrctrl);
+
+
+int power_control_register_notifier(struct power_control *pwrctrl,
+				    struct notifier_block *nb)
+{
+	return raw_notifier_chain_register(&pwrctrl->notifier_head, nb);
+}
+EXPORT_SYMBOL_GPL(power_control_register_notifier);
+
+void power_control_unregister_notifier(struct power_control *pwrctrl,
+				       struct notifier_block *nb)
+{
+	raw_notifier_chain_unregister(&pwrctrl->notifier_head, nb);
+}
+EXPORT_SYMBOL_GPL(power_control_unregister_notifier);
+
+int __power_control_notify(struct power_control *pwrctrl, int action)
+{
+	return raw_notifier_call_chain(&pwrctrl->notifier_head, action, pwrctrl);
+}
+EXPORT_SYMBOL_GPL(__power_control_notify);
+
+int power_control_power_on(struct power_control *pwrctrl)
+{
+	int ret = 0;
+	int act;
+
+	if (!pwrctrl)
+		return -EINVAL;
+
+	if (pwrctrl->flags & POWER_CONTROL_FLAG_SHARED_POWER) {
+		pr_debug("%s: before on ref:%d\n", pwrctrl->name, atomic_read(&pwrctrl->power_cnt));
+		if (atomic_inc_return(&pwrctrl->power_cnt) != 1)
+			return 0;
+	}
+	__power_control_notify(pwrctrl, POWER_CONTROL_ACTION_PRE_POWER_ON);
+	if (pwrctrl->ops->power_on)
+		ret = pwrctrl->ops->power_on(pwrctrl);
+
+	if (ret < 0)
+		act = POWER_CONTROL_ACTION_POWER_ON_ABORT;
+	else if (ret == 1)
+		act = POWER_CONTROL_ACTION_POWER_ON_IGNORE;
+	else
+		act = POWER_CONTROL_ACTION_POST_POWER_ON;
+
+	__power_control_notify(pwrctrl, act);
+	return ret;
+}
+EXPORT_SYMBOL_GPL(power_control_power_on);
+
+int power_control_power_off(struct power_control *pwrctrl)
+{
+	int ret = 0;
+
+	if (!pwrctrl)
+		return -EINVAL;
+
+	if (pwrctrl->flags & POWER_CONTROL_FLAG_SHARED_POWER) {
+		pr_debug("%s: before off ref:%d\n", pwrctrl->name, atomic_read(&pwrctrl->power_cnt));
+		if (atomic_dec_return(&pwrctrl->power_cnt) != 0)
+			return 0;
+	}
+
+	/* should be notify by implementation */
+	if (!(pwrctrl->flags & POWER_CONTROL_FLAG_ASYNC_POWER_OFF))
+		__power_control_notify(pwrctrl, POWER_CONTROL_ACTION_PRE_POWER_OFF);
+
+	if (pwrctrl->ops->power_off)
+		ret = pwrctrl->ops->power_off(pwrctrl);
+
+	/* should be notify by implementation */
+	if (!(pwrctrl->flags & POWER_CONTROL_FLAG_ASYNC_POWER_OFF))
+		__power_control_notify(pwrctrl, POWER_CONTROL_ACTION_POST_POWER_OFF);
+	return ret;
+}
+EXPORT_SYMBOL_GPL(power_control_power_off);
+
+int __power_control_notify_power_off_start(struct power_control *pwrctrl)
+{
+	__power_control_notify(pwrctrl, POWER_CONTROL_ACTION_PRE_POWER_OFF);
+	return 0;
+}
+EXPORT_SYMBOL_GPL(__power_control_notify_power_off_start);
+
+int __power_control_notify_power_off_done(struct power_control *pwrctrl)
+{
+	__power_control_notify(pwrctrl, POWER_CONTROL_ACTION_POST_POWER_OFF);
+	return 0;
+}
+EXPORT_SYMBOL_GPL(__power_control_notify_power_off_done);
+
+int power_control_is_powered_on(struct power_control *pwrctrl)
+{
+	if (!pwrctrl)
+		return -EINVAL;
+
+	if (pwrctrl->ops->is_powered_on)
+		return pwrctrl->ops->is_powered_on(pwrctrl);
+
+	return -EINVAL;
+}
+EXPORT_SYMBOL_GPL(power_control_is_powered_on);
+
+int power_control_init(struct power_control *pwrctrl)
+{
+	if (WARN_ON(!pwrctrl))
+		return -ENODEV;
+
+	if (pwrctrl->ops->init)
+		return pwrctrl->ops->init(pwrctrl);
+	return -EINVAL;
+}
+EXPORT_SYMBOL_GPL(power_control_init);
+
+int power_control_get_internal(struct power_control *pwrctrl)
+{
+	atomic_inc(&pwrctrl->usage_cnt);
+	return 0;
+}
+
+void power_control_put_internal(struct power_control *pwrctrl)
+{
+	atomic_dec(&pwrctrl->usage_cnt);
+}
+
+static struct power_control *__power_control_get(const char *name)
+{
+	struct power_control *ctrl = NULL;
+
+	list_for_each_entry(ctrl, &power_control_list, list) {
+		if (!strcmp(ctrl->name, name))
+			return ctrl;
+	}
+
+	return NULL;
+}
+
+struct power_control *power_control_get(const char *name)
+{
+	struct power_control *ctrl;
+
+	mutex_lock(&power_control_list_lock);
+	ctrl = __power_control_get(name);
+	mutex_unlock(&power_control_list_lock);
+
+	if (!ctrl)
+		return ctrl;
+
+	atomic_inc(&ctrl->usage_cnt);
+	return ctrl;
+}
+EXPORT_SYMBOL_GPL(power_control_get);
+
+struct of_power_control_provider {
+	struct list_head list;
+	struct device_node *node;
+	power_control_xlate_t xlate;
+	void *data;
+};
+
+static LIST_HEAD(of_power_control_providers);
+static DEFINE_MUTEX(of_power_control_provider_lock);
+
+struct power_control *of_power_control_xlate_simple(struct of_phandle_args *args,
+						    void *data)
+{
+	if (args->args_count != 0)
+		return ERR_PTR(-EINVAL);
+	return data;
+}
+
+struct power_control *of_power_control_xlate_onecell(struct of_phandle_args *args,
+						     void *data)
+{
+	struct power_control_onecell_data *ctrl_data = data;
+	unsigned int idx = args->args[0];
+
+	if (args->args_count != 1)
+		return ERR_PTR(-EINVAL);
+
+	if (idx > ctrl_data->num_controls) {
+		pr_err("%s: invalid index %u\n", __func__, idx);
+		return ERR_PTR(-EINVAL);
+	}
+
+	if (!ctrl_data->controls[idx])
+		return ERR_PTR(-ENOENT);
+
+	return ctrl_data->controls[idx];
+}
+
+int of_power_control_add_provider(struct device_node *np,
+				  power_control_xlate_t xlate,
+				  void *data)
+{
+	struct of_power_control_provider *pp;
+
+	pp = kzalloc(sizeof(*pp), GFP_KERNEL);
+	if (!pp)
+		return -ENOMEM;
+
+	pp->node = np;
+	pp->data = data;
+	pp->xlate = xlate;
+
+	mutex_lock(&of_power_control_provider_lock);
+	list_add(&pp->list, &of_power_control_providers);
+	mutex_unlock(&of_power_control_provider_lock);
+	return 0;
+}
+
+void of_power_control_del_provider(struct device_node *np)
+{
+	struct of_power_control_provider *pp;
+
+	mutex_lock(&of_power_control_provider_lock);
+	list_for_each_entry(pp, &of_power_control_providers, list) {
+		if (pp->node == np) {
+			list_del(&pp->list);
+			of_node_put(pp->node);
+			kfree(pp);
+			break;
+		}
+	}
+	mutex_unlock(&of_power_control_provider_lock);
+}
+
+struct power_control *of_power_control_get_from_provider(struct of_phandle_args *args)
+{
+	struct power_control *ctrl = ERR_PTR(-ENOENT);
+	struct of_power_control_provider *provider;
+
+
+	mutex_lock(&of_power_control_provider_lock);
+	list_for_each_entry(provider, &of_power_control_providers, list) {
+		if (provider->node == args->np)
+			ctrl = provider->xlate(args, provider->data);
+		if (!IS_ERR(ctrl))
+			break;
+	}
+	mutex_unlock(&of_power_control_provider_lock);
+
+	return ctrl;
+}
+
+struct power_control *__of_power_control_get_by_index(struct device_node *node,
+						      int index)
+{
+	struct of_phandle_args args;
+	int ret;
+
+	ret = of_parse_phandle_with_args(node, "powerctrls", "#powerctrl-cells",
+		index, &args);
+	if (ret)
+		return ERR_PTR(ret);
+
+	return of_power_control_get_from_provider(&args);
+}
+
+struct power_control *of_power_control_get_by_index(struct device_node *node,
+						    int index)
+{
+	struct power_control *ctrl = NULL;
+
+	mutex_lock(&power_control_list_lock);
+	ctrl = __of_power_control_get_by_index(node, index);
+	mutex_unlock(&power_control_list_lock);
+
+	if (IS_ERR(ctrl))
+		return ctrl;
+
+	atomic_inc(&ctrl->usage_cnt);
+	return ctrl;
+}
+EXPORT_SYMBOL_GPL(of_power_control_get_by_index);
+
+struct power_control *of_power_control_get(struct device_node *node,
+					   const char *id)
+{
+	int index = 0;
+
+	if (id)
+		index = of_property_match_string(node, "powerctrl-names", id);
+
+	return of_power_control_get_by_index(node, index);
+}
+EXPORT_SYMBOL_GPL(of_power_control_get);
+
+void power_control_put(struct power_control *pwrctrl)
+{
+	atomic_dec(&pwrctrl->usage_cnt);
+}
+EXPORT_SYMBOL_GPL(power_control_put);
+
+int power_control_register(struct power_control *pwrctrl)
+{
+	int ret __maybe_unused;
+
+	if (WARN_ON(!pwrctrl->ops))
+		return -EINVAL;
+
+	if (WARN_ON(!pwrctrl->name))
+		return -EINVAL;
+
+	mutex_lock(&power_control_list_lock);
+	list_add(&pwrctrl->list, &power_control_list);
+	mutex_unlock(&power_control_list_lock);
+
+	atomic_set(&pwrctrl->usage_cnt, 0);
+	atomic_set(&pwrctrl->power_cnt, 0);
+#ifdef CONFIG_POWER_CONTROL_DEBUGFS
+	ret = power_control_add_debugfs(pwrctrl);
+	if (ret)
+		pr_warn("%s: %s: failed to add debugfs: %d\n", pwrctrl->name,
+			__func__, ret);
+#endif
+	RAW_INIT_NOTIFIER_HEAD(&pwrctrl->notifier_head);
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(power_control_register);
+
+void power_control_unregister(struct power_control *pwrctrl)
+{
+	WARN_ON(atomic_read(&pwrctrl->usage_cnt) != 0);
+
+#ifdef CONFIG_POWER_CONTROL_DEBUGFS
+	power_control_del_debugfs(pwrctrl);
+#endif
+
+	mutex_lock(&power_control_list_lock);
+	list_del(&pwrctrl->list);
+	mutex_unlock(&power_control_list_lock);
+}
+EXPORT_SYMBOL_GPL(power_control_unregister);
+
+static bool power_control_ignore_unused;
+static int __init power_control_ignore_unused_setup(char *__unused)
+{
+	power_control_ignore_unused = true;
+	return 0;
+}
+__setup("power_control_ignore_unused", power_control_ignore_unused_setup);
+
+static int power_control_power_off_unused(void)
+{
+	struct power_control *ctrl = NULL;
+
+	if (power_control_ignore_unused) {
+		pr_warn("Not disabling unused power controls\n");
+		return 0;
+	}
+
+	list_for_each_entry(ctrl, &power_control_list, list) {
+		if (ctrl->flags & POWER_CONTROL_FLAG_IGNORE_UNUSED)
+			continue;
+		if (atomic_read(&ctrl->usage_cnt) != 0)
+			continue;
+
+		if (ctrl->ops->power_off_unused)
+			ctrl->ops->power_off_unused(ctrl);
+		else if (ctrl->ops->power_off)
+			ctrl->ops->power_off(ctrl);
+	}
+	return 0;
+}
+late_initcall_sync(power_control_power_off_unused);
+
+#ifdef CONFIG_POWER_CONTROL_DEBUGFS
+static struct dentry *power_control_root;
+
+static int power_control_summary_show(struct seq_file *s, void *data)
+{
+	struct power_control *ctrl;
+	char pow_str[20];
+
+	seq_printf(s, "%-28s %-9s\n", "POWER_CONTROL_NAME", "STATE");
+
+	mutex_lock(&power_control_list_lock);
+
+	list_for_each_entry(ctrl, &power_control_list, list) {
+		int is_powered = power_control_is_powered_on(ctrl);
+
+		if (is_powered < 0)
+			snprintf(pow_str, sizeof(pow_str), "ERRNO(%d)",
+				is_powered);
+		else
+			strncpy(pow_str, is_powered ? "ON" : "OFF",
+				sizeof(pow_str));
+
+		seq_printf(s, "%-28s %-9s\n", ctrl->name, pow_str);
+	}
+
+	mutex_unlock(&power_control_list_lock);
+
+	return 0;
+
+}
+
+static int power_control_summary_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, power_control_summary_show, NULL);
+}
+
+static const struct file_operations power_control_summary_ops = {
+	.owner   = THIS_MODULE,
+	.open    = power_control_summary_open,
+	.read    = seq_read,
+	.release = single_release,
+};
+
+static int __init power_control_debugfs_arch_init(void)
+{
+	power_control_root = debugfs_create_dir("power_control", NULL);
+	if (!power_control_root) {
+		pr_warn("%s: failed to init debugfs\n", __func__);
+		return 0;
+	}
+	debugfs_create_file("power_control_summary", 0444,
+		power_control_root, NULL, &power_control_summary_ops);
+	return 0;
+}
+arch_initcall(power_control_debugfs_arch_init);
+
+static int power_control_power_set(void *data, u64 val)
+{
+	struct power_control *pwrctrl = data;
+	int is_powered = power_control_is_powered_on(pwrctrl);
+	int ret = 0;
+
+	if (val == 1 && is_powered == 0)
+		power_control_power_on(pwrctrl);
+	else if (val == 0 && is_powered == 1)
+		power_control_power_off(pwrctrl);
+	else
+		ret = -EINVAL;
+	return ret;
+}
+static int power_control_power_get(void *data, u64 *val)
+{
+	struct power_control *pwrctrl = data;
+	int is_powered = power_control_is_powered_on(pwrctrl);
+
+	*val = is_powered;
+	return is_powered < 0 ? -EINVAL : 0;
+}
+DEFINE_SIMPLE_ATTRIBUTE(power_control_power_fops,
+			power_control_power_get,
+			power_control_power_set,
+			"%lld\n");
+
+static int power_control_add_debugfs(struct power_control *pwrctrl)
+{
+	struct dentry *d;
+
+	if (!power_control_root)
+		return -ENOENT;
+
+	pwrctrl->debugfs = debugfs_create_dir(pwrctrl->name, power_control_root);
+	if (!pwrctrl->debugfs)
+		return -ENOMEM;
+
+	d = debugfs_create_file("power", 0644, pwrctrl->debugfs, pwrctrl,
+		&power_control_power_fops);
+	if (!d)
+		return -ENOMEM;
+	return 0;
+}
+
+static void power_control_del_debugfs(struct power_control *pwrctrl)
+{
+	if (!pwrctrl->debugfs)
+		return;
+	debugfs_remove_recursive(pwrctrl->debugfs);
+}
+#endif
+
+
diff --git a/drivers/soc/realtek/common/pwrctrl/pwrctrl_driver.h b/drivers/soc/realtek/common/pwrctrl/pwrctrl_driver.h
new file mode 100644
index 00000000..1f50be0
--- /dev/null
+++ b/drivers/soc/realtek/common/pwrctrl/pwrctrl_driver.h
@@ -0,0 +1,76 @@
+/*
+ * power_control_driver.h - for driver implementation
+ *
+ * Copyright (C) 2016,2018,2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2016,2018,2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifndef __POWER_CONTROL_DRIVER_H
+#define __POWER_CONTROL_DRIVER_H
+
+struct device_node;
+struct power_control;
+struct dentry;
+#include <linux/atomic.h>
+#include <linux/list.h>
+#include <linux/notifier.h>
+
+/**
+ * struct power_control_ops
+ */
+struct power_control_ops {
+	int (*power_on)(struct power_control *);
+	int (*power_off)(struct power_control *);
+	int (*is_powered_on)(struct power_control *);
+	int (*init)(struct power_control *);
+	int (*power_off_unused)(struct power_control *);
+};
+
+struct power_control {
+	struct list_head list;
+	const char *name;
+	const struct power_control_ops *ops;
+	struct device_node *of_node;
+
+	atomic_t usage_cnt;
+	unsigned long flags;
+	struct raw_notifier_head notifier_head;
+#ifdef CONFIG_POWER_CONTROL_DEBUGFS
+	struct dentry *debugfs;
+#endif
+	atomic_t power_cnt;
+};
+
+#define POWER_CONTROL_FLAG_ASYNC_POWER_OFF        (0x1)
+#define POWER_CONTROL_FLAG_SHARED_POWER           (0x2)
+#define POWER_CONTROL_FLAG_IGNORE_UNUSED          (0x4)
+
+struct of_phandle_args;
+
+struct power_control_onecell_data {
+	struct power_control **controls;
+	unsigned int num_controls;
+};
+
+typedef struct power_control *(*power_control_xlate_t)(struct of_phandle_args *args, void *data);
+int of_power_control_add_provider(struct device_node *np,
+				  power_control_xlate_t xlate,
+				  void *data);
+void of_power_control_del_provider(struct device_node *np);
+struct power_control *of_power_control_xlate_simple(struct of_phandle_args *args,
+						    void *data);
+struct power_control *of_power_control_xlate_onecell(struct of_phandle_args *args,
+						     void *data);
+struct power_control *of_power_control_get_from_provider(struct of_phandle_args *args);
+
+int power_control_get_internal(struct power_control *pwrctrl);
+void power_control_put_internal(struct power_control *pwrctrl);
+
+int __power_control_notify_power_off_start(struct power_control *pwrctrl);
+int __power_control_notify_power_off_done(struct power_control *pwrctrl);
+
+
+#endif
diff --git a/drivers/soc/realtek/common/rpc/Kconfig b/drivers/soc/realtek/common/rpc/Kconfig
new file mode 100644
index 00000000..97f7d20
--- /dev/null
+++ b/drivers/soc/realtek/common/rpc/Kconfig
@@ -0,0 +1,7 @@
+config RTK_RPC
+	bool "Realtek RPC driver"
+	depends on RTK_MEM_REMAP
+	default y
+	help
+	  Realtek RPC driver with audio CPU
+
diff --git a/drivers/soc/realtek/common/rpc/Makefile b/drivers/soc/realtek/common/rpc/Makefile
new file mode 100644
index 00000000..82c58ea
--- /dev/null
+++ b/drivers/soc/realtek/common/rpc/Makefile
@@ -0,0 +1,8 @@
+ccflags-y	+= -Idrivers/video/fbdev/rtk
+ccflags-y += -I$(srctree)/drivers/staging/android
+ccflags-$(CONFIG_RTK_RPC)	+= -Idrivers/soc/realtek/common
+ccflags-$(CONFIG_RTK_RPC)	+= -Idrivers/soc/realtek/common/include
+obj-$(CONFIG_RTK_RPC)	+= rtk_rpc.o
+obj-$(CONFIG_RTK_RPC)	+= rtk_rpc_intr.o
+obj-$(CONFIG_RTK_RPC)	+= rtk_rpc_poll.o
+obj-$(CONFIG_RTK_RPC)	+= rtk_rpc_kern.o
diff --git a/drivers/soc/realtek/common/rpc/rtk_rpc.c b/drivers/soc/realtek/common/rpc/rtk_rpc.c
new file mode 100644
index 00000000..4b584c1
--- /dev/null
+++ b/drivers/soc/realtek/common/rpc/rtk_rpc.c
@@ -0,0 +1,898 @@
+/*
+ * Realtek RPC driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/slab.h>
+#include <linux/fs.h>
+#include <linux/errno.h>
+#include <linux/types.h>
+#include <linux/proc_fs.h>
+#include <linux/fcntl.h>
+#include <linux/ioctl.h>
+#include <linux/device.h>
+#include <linux/interrupt.h>
+#include <linux/platform_device.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/delay.h>
+#include <linux/sched.h>
+#include <linux/debugfs.h>
+#include <linux/io.h>
+#include <linux/uaccess.h>
+#include <soc/realtek/rtk_ipc_shm.h>
+#include <soc/realtek/avcpu.h>
+
+#include "rtk_rpc.h"
+#include "dc2vo/dc2vo.h"
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+#include "uapi/ion.h"
+#include "ion/ion.h"
+#include "uapi/ion_rtk.h"
+#include <soc/realtek/kernel-rpc.h>
+
+
+
+#ifdef CONFIG_REALTEK_IR
+extern int venus_irtx_getscancode(u32, u32*, u32*);
+#endif /* CONFIG_REALTEK_IR */
+
+//#define SHOW_TASKS_ON_SYSFS
+#define SHOW_TASKS_ON_DEBUGFS
+#define RPC_NAME "RTK_RPC"
+
+#ifdef CONFIG_FB_RTK
+extern spinlock_t gASLock;
+extern void dc_irq_handler(void);
+#else
+static DEFINE_SPINLOCK(gASLock);
+#endif /* CONFIG_FB_RTK */
+
+//#if !defined(CONFIG_FB_RTK) || defined(CONFIG_FB_RTK_FPGA)
+//void __iomem *rpc_common_base = NULL;
+//void __iomem *rpc_rbussync_base = NULL;
+//#endif
+volatile void __iomem *rpc_ringbuf_base;
+volatile void __iomem *rpc_common_base;
+volatile void __iomem *rpc_int_base;
+volatile void __iomem *rpc_acpu_int_flag;
+volatile void __iomem *rpc_vcpu_int_flag;
+volatile void __iomem *rpc_refclk_base;
+
+static int rpc_acpu_irq;
+static int rpc_vcpu_irq;
+int rpc_major;
+
+#ifdef SHOW_TASKS_ON_SYSFS
+static ssize_t show_tasks(struct device *cd, struct device_attribute *attr,
+		char *buf)
+{
+	RPC_DEV_EXTRA *extra = (RPC_DEV_EXTRA *)dev_get_drvdata(cd);
+	RPC_DEV *dev = extra->dev;
+	RPC_PROCESS *curr = (RPC_PROCESS *)extra->currProc;
+	RPC_PROCESS *proc;
+	RPC_THREAD *thread;
+	RPC_HANDLER *handler;
+	struct task_struct *task;
+	ssize_t cnt = 0;
+
+	cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "name: %s\n",
+			extra->name);
+	cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "currProc: %d\n",
+			curr ? curr->pid : 0);
+	cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "nextRpc: %x\n",
+			extra->nextRpc);
+	cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "RingBuf: %x\n",
+			dev->ringBuf);
+	cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "RingStart: %x\n",
+			dev->ringStart);
+	cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "RingIn: %x\n",
+			dev->ringIn);
+	cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "RingOut: %x\n",
+			dev->ringOut);
+	cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "RingEnd: %x\n",
+			dev->ringEnd);
+
+	spin_lock_bh(&extra->lock);
+	list_for_each_entry(proc, &extra->tasks, list) {
+
+		task = find_task_by_vpid(proc->pid);
+
+		cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "\nProcess:%s\n",
+				task ? task->comm : "N/A");
+
+		list_for_each_entry(handler, &proc->handlers, list) {
+			cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt,
+					"\tprogramID:%u\n", handler->programID);
+		}
+
+		cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "\tp:%d\n",
+				proc->pid);
+
+		list_for_each_entry(thread, &proc->threads, list) {
+			cnt += scnprintf(buf + cnt, (ssize_t)PAGE_SIZE - cnt, "\tt:%d\n",
+					thread->pid);
+		}
+	}
+	spin_unlock_bh(&extra->lock);
+	return cnt;
+}
+
+static DEVICE_ATTR(tasks, S_IRUGO, show_tasks, NULL);
+#endif /* SHOW_TASKS_ON_SYSFS */
+
+#ifdef SHOW_TASKS_ON_DEBUGFS
+static int rpc_debug_node_show(struct seq_file *s, void *unused)
+{
+	RPC_DEV_EXTRA *extra = (RPC_DEV_EXTRA *)s->private;
+	RPC_DEV *dev = extra->dev;
+	RPC_PROCESS *curr = (RPC_PROCESS *)extra->currProc;
+	RPC_PROCESS *proc;
+	RPC_THREAD *thread;
+	RPC_HANDLER *handler;
+	struct task_struct *task;
+	int i;
+
+	seq_printf(s, "name: %s\n", extra->name);
+	seq_printf(s, "currProc: %d\n", curr ? curr->pid : 0);
+	seq_printf(s, "nextRpc: %x\n", extra->nextRpc);
+	seq_printf(s, "RingBuf: %x\n", dev->ringBuf);
+	seq_printf(s, "RingStart: %x\n", dev->ringStart);
+	seq_printf(s, "RingIn: %x\n", dev->ringIn);
+	seq_printf(s, "RingOut: %x\n", dev->ringOut);
+	seq_printf(s, "RingEnd: %x\n", dev->ringEnd);
+
+	seq_printf(s, "\nRingBuffer:\n");
+	for (i = 0; i < RPC_RING_SIZE; i += 16) {
+		uint32_t *addr = (uint32_t *)(AVCPU2SCPU(dev->ringStart) + i);
+		seq_printf(s, "%x: %08x %08x %08x %08x\n",
+				dev->ringStart + i,
+				ntohl(*(addr + 0)),
+				ntohl(*(addr + 1)),
+				ntohl(*(addr + 2)),
+				ntohl(*(addr + 3)));
+	}
+
+	spin_lock_bh(&extra->lock);
+	list_for_each_entry(proc, &extra->tasks, list) {
+		task = find_task_by_vpid(proc->pid);
+
+		seq_printf(s, "\nProcess:%s\n", task ? task->comm : "N/A");
+
+		list_for_each_entry(handler, &proc->handlers, list) {
+			seq_printf(s, "\tprogramID:%u\n", handler->programID);
+		}
+
+		seq_printf(s, "\tp:%d\n", proc->pid);
+
+		list_for_each_entry(thread, &proc->threads, list) {
+			seq_printf(s, "\tt:%d\n", thread->pid);
+		}
+	}
+	spin_unlock_bh(&extra->lock);
+	return 0;
+}
+
+static int rpc_debug_node_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rpc_debug_node_show, inode->i_private);
+}
+
+static const struct file_operations rpc_debug_node_ops = {
+	.open = rpc_debug_node_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif /* SHOW_TASKS_ON_DEBUGFS */
+
+static int rpc_event_notify(struct notifier_block *self,
+		unsigned long action, void *data);
+
+static struct notifier_block __maybe_unused rpc_event_notifier = {
+	.notifier_call  = rpc_event_notify,
+};
+
+struct file_operations *rpc_fop_array[] = {
+	&rpc_poll_fops, /* poll */
+	&rpc_intr_fops /* intr */
+};
+
+void **rpc_data_ptr_array[] = {
+	(void **)&rpc_poll_devices, /* poll */
+	(void **)&rpc_intr_devices /* intr */
+};
+
+int rpc_data_size_array[] = {
+	sizeof(RPC_DEV), /* poll */
+	sizeof(RPC_DEV) /* intr */
+};
+
+/*
+ * Finally, the module stuff
+ */
+static struct class *rpc_class;
+
+
+void rpc_set_ir_wakeup_key(uint32_t uScancode, uint32_t uScancode_msk)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	pr_info("[%s] uScancode = 0x%x , uScancode_msk = 0x%x ", RPC_NAME, uScancode, uScancode_msk);
+	/* audio RPC flag for scancode mask */
+	writel(__cpu_to_be32(uScancode_msk), &(ipc->ir_scancode_mask));
+	/* audio RPC flag for scancode key */
+	writel(__cpu_to_be32(uScancode), &(ipc->ir_wakeup_scancode));
+}
+
+void rpc_set_flag(int type, uint32_t flag)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	if (type == RPC_AUDIO) {
+		writel(__cpu_to_be32(flag), &(ipc->audio_rpc_flag));/* audio RPC flag */
+	}
+#ifdef CONFIG_ARCH_RTD13xx
+	else if (type == RPC_VIDEO) {
+		writel(__cpu_to_be32(flag), &(ipc->video_rpc_flag));/* audio RPC flag */
+	}
+#endif
+}
+
+uint32_t rpc_get_flag(int type)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	if (type == RPC_AUDIO) {
+		return __be32_to_cpu(readl(&(ipc->audio_rpc_flag)));
+	}
+#ifdef CONFIG_ARCH_RTD13xx
+	else if (type == RPC_VIDEO) {
+		return __be32_to_cpu(readl(&(ipc->video_rpc_flag)));
+	}
+#endif
+	pr_err("[%s] rpc_get_flag type error!\n", __func__ );
+	return 0xdeaddead;
+}
+
+void rpc_send_interrupt(int type)
+{
+	switch (type) {
+	case RPC_AUDIO:
+		if (rpc_acpu_int_flag != NULL && RPC_HAS_BIT(rpc_acpu_int_flag, AUDIO_RPC_SET_NOTIFY)) {
+			RPC_SET_BIT(rpc_acpu_int_flag, AUDIO_RPC_FEEDBACK_NOTIFY);
+		}
+		pr_debug("[%s] send audio interrupt\n", __func__);
+		writel((RPC_INT_SA | RPC_INT_WRITE_1), rpc_int_base+RPC_SB2_INT);
+		break;
+#ifdef CONFIG_ARCH_RTD13xx
+	case RPC_VIDEO:
+		if (rpc_vcpu_int_flag != NULL && RPC_HAS_BIT(rpc_vcpu_int_flag, VIDEO_RPC_SET_NOTIFY)) {
+			RPC_SET_BIT(rpc_vcpu_int_flag, VIDEO_RPC_FEEDBACK_NOTIFY);
+		}
+		pr_debug("[%s] send video interrupt\n", __func__);
+		writel((RPC_INT_SV | RPC_INT_WRITE_1), rpc_int_base+RPC_SB2_INT);
+		break;
+#endif
+	default:
+		break;
+	}
+
+}
+EXPORT_SYMBOL(rpc_send_interrupt);
+
+void dc2vo_send_interrupt(void)
+{
+	if (rpc_acpu_int_flag != NULL && RPC_HAS_BIT(rpc_acpu_int_flag, VO_DC_SET_NOTIFY)) {
+		RPC_SET_BIT(rpc_acpu_int_flag, VO_DC_FEEDBACK_NOTIFY);
+		/* audio */
+		writel((RPC_INT_SA | RPC_INT_WRITE_1), rpc_int_base+RPC_SB2_INT);
+	}
+}
+EXPORT_SYMBOL(dc2vo_send_interrupt);
+
+static int rpc_event_notify(struct notifier_block *self, unsigned long action,
+		void *data)
+{
+#ifdef CONFIG_REALTEK_AVCPU
+	switch (action) {
+	case AVCPU_SUSPEND:
+		pr_debug("[%s]: AVCPU_SUSPEND...\n", RPC_NAME);
+		//rpc_poll_pause();
+		rpc_poll_suspend();
+		//rpc_intr_pause();
+		rpc_intr_suspend();
+		//rpc_kern_pause();
+		rpc_kern_suspend();
+		mdelay(10);
+		break;
+	case AVCPU_RESUME:
+		pr_debug("[%s]: AVCPU_RESUME...\n", RPC_NAME);
+		rpc_poll_resume();
+		rpc_intr_resume();
+		rpc_kern_resume();
+		break;
+	case AVCPU_RESET_PREPARE:
+		pr_debug("[%s]: AVCPU_RESET_PREPARE...\n", RPC_NAME);
+		rpc_poll_pause();
+		rpc_intr_pause();
+		rpc_kern_pause();
+		mdelay(10);
+		rpc_set_flag(RPC_AUDIO, 0x00000000);
+		break;
+	case AVCPU_RESET_DONE:
+		pr_debug("[%s]: AVCPU_RESET_DONE...\n", RPC_NAME);
+		rpc_poll_init();
+		rpc_intr_init();
+		rpc_kern_init();
+		/* clear the inter-processor interrupts */
+		//*((int *)REG_SB2_CPU_INT) = 0x0000007e;
+		RPC_SET_BIT(rpc_acpu_int_flag, RPC_AUDIO_SET_NOTIFY);
+		//rtk_rpc_wmb(rpc_common_base, RPC_COMM_SIZE);
+		writel(RPC_INT_AS, rpc_int_base+RPC_SB2_INT);
+		writel(RPC_INT_SA, rpc_int_base+RPC_SB2_INT);
+		/* Enable the interrupt from system to audio & video */
+
+		rpc_send_interrupt(RPC_AUDIO);
+		rpc_set_flag(RPC_AUDIO, 0xffffffff);
+
+		break;
+	default:
+		break;
+	}
+#endif /* CONFIG_REALTEK_AVCPU */
+
+	return 0;
+}
+
+#ifdef MY_COPY
+int my_copy_to_user(int *des, int *src, int size)
+{
+	char buf[256];
+	int count = size;
+	void *pSrc = (void *)src;
+	int ret = 0;
+	int i = 0;
+
+	if (size > 256) {
+		BUG();
+	}
+
+	while (size >= 4) {
+		*(int *)&buf[i] = __raw_readl(pSrc);
+		i += 4;
+		pSrc += 4;
+		size -= 4;
+	}
+
+	while (size > 0) {
+		buf[i] = __raw_readb(pSrc);
+		i++;
+		pSrc++;
+		size--;
+	}
+
+	ret = copy_to_user((int *)des, (int *)buf, count);
+
+	return ret;
+}
+
+int my_copy_from_user(volatile void __iomem *des, const void *src, int size)
+{
+
+	char buf[256];
+	int count = size;
+	void *pSrc = (void *)src;
+	int ret = 0;
+	int i = 0;
+	char *csrc, *cdes;
+
+	if (size > 256) {
+		BUG();
+	}
+	pr_debug("[%s] %s(des:%p, src:%p, size:%d) pid:%d tid:%d comm:%s\n",
+			RPC_NAME, __func__, des, src, size, current->tgid,
+			current->pid, current->comm);
+	ret = copy_from_user((unsigned int *)buf, (unsigned int __user *)src, size);
+
+	if(ret!=0){
+		printk("[%s][%s]copy_from_user error: %d bytes\n", RPC_NAME, __func__, ret);
+	}
+
+	cdes = (char *)des;
+	for (i = 0 ; i < size ; i++) {
+		cdes[i] = buf[i];
+	}
+
+	return 0;
+}
+
+
+int my_copy_user(int *des, int *src, int size)
+{
+	char *csrc, *cdes;
+	int i;
+
+	pr_debug("[%s] %s(des:%p, src:%p, size:%d) pid:%d tid:%d comm:%s\n",
+			RPC_NAME, __func__, des, src, size, current->tgid,
+			current->pid, current->comm);
+
+	might_fault();
+
+	if ((unsigned long)des < 0xc0000000 &&
+			access_ok(VERIFY_WRITE, des, size) == 0)
+		BUG();
+
+	if ((unsigned long)src < 0xc0000000 &&
+			access_ok(VERIFY_READ, src, size) == 0)
+		BUG();
+
+	if (((unsigned long)src & 0x3) || ((unsigned long)des & 0x3))
+		pr_warn("[%s] my_copy_user: unaligned happen...\n", RPC_NAME);
+
+	while (size >= 4) {
+		*des++ = *src++;
+		size -= 4;
+	}
+
+	csrc = (char *)src;
+	cdes = (char *)des;
+
+	for (i = 0 ; i < size ; i++)
+		cdes[i] = csrc[i];
+
+	return 0;
+}
+#endif /* MY_COPY */
+
+irqreturn_t rpc_isr(int irq, void *dev_id)
+{
+	int itr;
+
+	//pr_debug("irq number %d...\n", irq);
+
+#ifdef CONFIG_FB_RTK
+	dc_irq_handler();
+#endif /* CONFIG_FB_RTK */
+
+#ifdef CONFIG_ARCH_RTD13xx
+	itr = readl(rpc_int_base+RPC_SB2_INT_ST);
+
+	if (RPC_HAS_BIT(rpc_acpu_int_flag, RPC_AUDIO_FEEDBACK_NOTIFY)) {
+		RPC_RESET_BIT(rpc_acpu_int_flag, RPC_AUDIO_FEEDBACK_NOTIFY);
+	} else if (RPC_HAS_BIT(rpc_vcpu_int_flag, RPC_VIDEO_FEEDBACK_NOTIFY)){
+		RPC_RESET_BIT(rpc_vcpu_int_flag, RPC_VIDEO_FEEDBACK_NOTIFY);
+	} else {
+		/* to clear interrupt, set bit[0] to 0 then we can clear A2S int */
+		if (itr & (RPC_INT_AS))
+			writel(RPC_INT_AS, rpc_int_base + RPC_SB2_INT_ST);
+		if (itr & (RPC_INT_VS))
+			writel(RPC_INT_VS, rpc_int_base + RPC_SB2_INT_ST);
+		return IRQ_HANDLED;
+	}
+
+
+	while ((itr & RPC_INT_AS) || (itr & RPC_INT_VS)) {
+		if (itr & RPC_INT_AS) {
+			/* to clear interrupt, set bit[0] to 0 then we can clear A2S int */
+			writel(RPC_INT_AS, rpc_int_base + RPC_SB2_INT_ST);
+
+			if (rpc_intr_devices[RPC_INTR_DEV_AS_ID1].ringIn != rpc_intr_devices[RPC_INTR_DEV_AS_ID1].ringOut) {
+				pr_debug("[%s] %s intr\n", RPC_NAME, __func__);
+				tasklet_schedule(&(rpc_intr_extra[RPC_INTR_DEV_AS_ID1].tasklet));
+			}
+
+			if (rpc_kern_devices[RPC_KERN_DEV_AS_ID1].ringIn != rpc_kern_devices[RPC_KERN_DEV_AS_ID1].ringOut) {
+				pr_debug("[%s] %s intr\n", RPC_NAME, __func__);
+				wake_up_interruptible(&(rpc_kern_devices[RPC_KERN_DEV_AS_ID1].ptrSync->waitQueue));
+			}
+		}
+		if (itr & RPC_INT_VS) {
+			/* to clear interrupt, set bit[0] to 0 then we can clear A2S int */
+			writel(RPC_INT_VS, rpc_int_base + RPC_SB2_INT_ST);
+
+			if (rpc_intr_devices[RPC_INTR_DEV_V1S_ID3].ringIn != rpc_intr_devices[RPC_INTR_DEV_V1S_ID3].ringOut) {
+				pr_debug("[%s] %s intr\n", RPC_NAME, __func__);
+				tasklet_schedule(&(rpc_intr_extra[RPC_INTR_DEV_V1S_ID3].tasklet));
+			}
+
+			if (rpc_kern_devices[RPC_KERN_DEV_V1S_ID3].ringIn != rpc_kern_devices[RPC_KERN_DEV_V1S_ID3].ringOut) {
+				pr_debug("[%s] %s intr\n", RPC_NAME, __func__);
+				wake_up_interruptible(&(rpc_kern_devices[RPC_KERN_DEV_V1S_ID3].ptrSync->waitQueue));
+			}
+		}
+		itr = readl(rpc_int_base + RPC_SB2_INT_ST);
+	}
+#else
+	itr = readl(rpc_int_base+RPC_SB2_INT);
+	if (!RPC_HAS_BIT(rpc_acpu_int_flag, RPC_AUDIO_FEEDBACK_NOTIFY)) {
+		/* to clear interrupt, set bit[0] to 0 then we can clear A2S int */
+		if (itr & (RPC_INT_AS))
+			writel(RPC_INT_AS, rpc_int_base+RPC_SB2_INT);
+		return IRQ_HANDLED;
+	} else {
+		//unsigned long flags;
+		//spin_lock_irqsave(&gASLock,flags);
+		RPC_RESET_BIT(rpc_acpu_int_flag, RPC_AUDIO_FEEDBACK_NOTIFY);
+		//rtk_rpc_wmb(rpc_common_base, RPC_COMM_SIZE);
+		//spin_unlock_irqrestore(&gASLock,flags);
+	}
+	if (itr & (RPC_INT_AS)) {
+		while (itr & (RPC_INT_AS)) {
+			/* ack the interrupt */
+			if (itr & RPC_INT_AS) {
+				/* to clear interrupt, set bit[0] to 0 then we can clear A2S int */
+				writel(RPC_INT_AS, rpc_int_base+RPC_SB2_INT);
+
+				if (rpc_intr_devices[RPC_INTR_DEV_AS_ID1].ringIn != rpc_intr_devices[RPC_INTR_DEV_AS_ID1].ringOut) {
+					pr_debug("[%s] %s intr\n", RPC_NAME, __func__);
+					tasklet_schedule(&(rpc_intr_extra[RPC_INTR_DEV_AS_ID1].tasklet));
+				}
+
+				if (rpc_kern_devices[RPC_KERN_DEV_AS_ID1].ringIn != rpc_kern_devices[RPC_KERN_DEV_AS_ID1].ringOut) {
+					pr_debug("[%s] %s intr\n", RPC_NAME, __func__);
+					wake_up_interruptible(&(rpc_kern_devices[RPC_KERN_DEV_AS_ID1].ptrSync->waitQueue));
+				}
+			}
+			itr = readl(rpc_int_base + RPC_SB2_INT);
+		}
+	} else {
+		//pr_warn("Not RPC interrupt...\n");
+
+		return IRQ_HANDLED;
+	}
+#endif
+	return IRQ_HANDLED;
+}
+
+static char *rpc_devnode(struct device *dev, umode_t *mode)
+{
+	*mode = 0666;
+	return NULL;
+}
+
+
+static ssize_t kernel_remote_allocate_show(struct class *class, struct class_attribute *attr, char *buf)
+{
+	return sprintf(buf, "%d\n", 1);
+}
+
+static CLASS_ATTR(kernel_remote_allocate, 0444, kernel_remote_allocate_show, NULL);
+
+
+static int __maybe_unused rtk_rpc_probe(struct platform_device *pdev)
+{
+	int result;
+	int i;
+	char buf[16];
+	struct device *dev;
+	struct device_node *np = pdev->dev.of_node;
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+	RPC_DEV_EXTRA *extra;
+	int ret = 0;
+
+#ifdef SHOW_TASKS_ON_DEBUGFS
+	struct dentry *rpcroot;
+#endif /* SHOW_TASKS_ON_DEBUGFS */
+
+#ifdef SHOW_TASKS_ON_DEBUGFS
+	struct dentry *rpcnode;
+#endif /* SHOW_TASKS_ON_DEBUGFS */
+
+	pr_info("[%s] rpc driver initial begin\n", RPC_NAME);
+
+	rpc_refclk_base = ioremap(0x9801B540, 0x8);
+
+	if (WARN_ON(!np))
+		pr_err("[%s] Could not found device node\n", RPC_NAME);
+
+	/* register rpc_poll_fops as default file operation */
+	rpc_major = RPC_MAJOR;
+	result = register_chrdev(rpc_major, RPC_NAME, &rpc_poll_fops);
+	if (result < 0) {
+		pr_debug("[%s] Can't get major %d\n", RPC_NAME, RPC_MAJOR);
+		return result;
+	}
+
+	if (rpc_major == 0)
+		rpc_major = result; /* dynamic */
+
+	pr_debug("[%s] RPC major number: %d\n", RPC_NAME, rpc_major);
+
+	/* update again ipc = IPC_SHM_VIRT */
+	ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	rpc_int_base = of_iomap(np, 0);
+	if (WARN_ON(!rpc_int_base))
+		pr_warn("[%s] Could not map registers for %s\n", RPC_NAME, np->name);
+
+	rpc_acpu_int_flag = &ipc->vo_int_sync;
+#ifdef CONFIG_ARCH_RTD13xx
+	rpc_vcpu_int_flag = &ipc->video_int_sync;
+#else
+	rpc_vcpu_int_flag = NULL;
+#endif
+	result = rpc_poll_init();
+	result = rpc_intr_init();
+	result = rpc_kern_init();
+
+	rpc_class = class_create(THIS_MODULE, "rpc");
+
+	if (IS_ERR(rpc_class))
+		return PTR_ERR(rpc_class);
+
+	rpc_class->devnode = rpc_devnode;
+	ret = class_create_file(rpc_class, &class_attr_kernel_remote_allocate);
+	if (ret) {
+		pr_err("[%s] class_create_file failed!\n", __func__);
+		return -EINVAL;
+	}
+#ifdef SHOW_TASKS_ON_DEBUGFS
+	rpcroot = debugfs_create_dir("rpc", NULL);
+#endif /* SHOW_TASKS_ON_DEBUGFS */
+
+	for (i = 0; i < RPC_NR_DEVS; i++) {
+		extra = ((i % RPC_NR_PAIR) == 0) ? &rpc_poll_extra[i/RPC_NR_PAIR] : &rpc_intr_extra[i/RPC_NR_PAIR];
+		dev = device_create(rpc_class, NULL, MKDEV(rpc_major, i), NULL, "rpc%d", i);
+
+#ifdef SHOW_TASKS_ON_SYSFS
+		device_create_file(dev, &dev_attr_tasks);
+#endif /* SHOW_TASKS_ON_SYSFS */
+
+#ifdef SHOW_TASKS_ON_DEBUGFS
+		sprintf(buf, "rpc%d", i);
+		rpcnode = debugfs_create_file(buf, 0444, rpcroot, extra, &rpc_debug_node_ops);
+#endif /* SHOW_TASKS_ON_DEBUGFS */
+
+		extra->sdev = dev;
+		dev_set_drvdata(dev, extra);
+	}
+
+	device_create(rpc_class, NULL, MKDEV(rpc_major, 100), NULL, "rpc100");
+
+	spin_lock_irq(&gASLock);
+	RPC_SET_BIT(rpc_acpu_int_flag, RPC_AUDIO_SET_NOTIFY);
+#ifdef CONFIG_ARCH_RTD13xx
+	RPC_SET_BIT(rpc_vcpu_int_flag, RPC_VIDEO_SET_NOTIFY);
+#endif
+	//rtk_rpc_wmb(rpc_common_base, RPC_COMM_SIZE);
+	//writel(readl(rpc_acpu_int_flag)|RPC_AUDIO_SET_NOTIFY, rpc_acpu_int_flag);
+	spin_unlock_irq(&gASLock);
+
+
+	rpc_acpu_irq = irq_of_parse_and_map(np, 0);
+
+	if (WARN_ON(!rpc_acpu_irq))
+		pr_warn("[%s] Could not parse ACPU IRQ\n", RPC_NAME);
+	pr_info("[%s] rpc_int_base:%p\n", RPC_NAME, rpc_int_base);
+	pr_info("[%s] acpu_irq:%d\n", RPC_NAME, rpc_acpu_irq);
+
+	result = request_irq(rpc_acpu_irq, rpc_isr, IRQF_SHARED|IRQF_NO_SUSPEND, "a_rpc", (void *)RPC_ID);
+	if (result != 0)
+		pr_err("[%s] Can't get assigned ACPU irq...\n", RPC_NAME);
+
+	/* Enable the interrupt from system to audio & video */
+	rpc_send_interrupt(RPC_AUDIO);
+	rpc_set_flag(RPC_AUDIO, 0xffffffff);
+
+#ifdef CONFIG_ARCH_RTD13xx
+	rpc_vcpu_irq = irq_of_parse_and_map(np, 1);
+
+	if (WARN_ON(!rpc_vcpu_irq))
+		pr_warn("[%s] Could not parse VCPU IRQ\n", RPC_NAME);
+	pr_info("[%s] vcpu_irq:%d\n", RPC_NAME, rpc_vcpu_irq);
+
+	result = request_irq(rpc_vcpu_irq, rpc_isr, IRQF_SHARED|IRQF_NO_SUSPEND, "v_rpc", (void *)RPC_ID);
+	if (result != 0)
+		pr_err("[%s] Can't get assigned VCPU irq...\n", RPC_NAME);
+
+	rpc_send_interrupt(RPC_VIDEO);
+	rpc_set_flag(RPC_VIDEO, 0xffffffff);
+	{
+		int MaxCount = 5000;
+		int wait_time = 0;
+		pr_warn("[%s] wait vcpu ready ", RPC_NAME);
+		while ((rpc_get_flag(RPC_VIDEO) == 0xffffffff) && ((MaxCount--) > 0)) {
+			mdelay(1);
+			if ((++wait_time) == 10) {
+				wait_time = 0;
+			}
+		}
+		while ((--wait_time) > 0)
+			pr_warn(".");
+		pr_warn("[%s] %s (RPC_VIDEO FLAG = 0x%08x)\n", RPC_NAME, (MaxCount > 0) ? "OK" : "timeout", rpc_get_flag(RPC_VIDEO));
+	}
+#endif
+
+#ifdef CONFIG_REALTEK_AVCPU
+	register_avcpu_notifier(&rpc_event_notifier);
+#endif
+
+	pr_info("[%s] rpc driver initial done\n", RPC_NAME);
+
+	return 0;
+}
+
+static int __maybe_unused rtk_rpc_remove(struct platform_device *pdev)
+{
+	return 0;
+}
+
+#ifdef CONFIG_PM
+/*
+ * Disable the interrupt from system to audio & video
+ */
+static int rtk_rpc_pm_suspend(struct device *dev)
+{
+#if 1
+	int MaxCount = 500;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[RTK_RPC] skip %s in DomU\n", __func__);
+		return 0;
+	}
+#endif
+
+	pr_info("[%s] Suspend enter\n", RPC_NAME);
+
+	rpc_set_flag(RPC_AUDIO, 0xdaedffff); /* STOP AUDIO HAS_CHECK */
+
+	while ((rpc_get_flag(RPC_AUDIO) != 0x0) && (MaxCount > 0)) {
+		mdelay(1);
+		MaxCount--;
+	}
+
+	rpc_event_notify(NULL, AVCPU_SUSPEND, NULL); /* STOP SYSTEM RPC */
+
+	RPC_RESET_BIT(rpc_acpu_int_flag, RPC_AUDIO_SET_NOTIFY); /* Disable Interrupt */
+	rtk_rpc_wmb(rpc_common_base, RPC_COMM_SIZE);
+
+	rpc_set_flag(RPC_AUDIO, 0xdeadffff); /* WAIT AUDIO RPC SUSPEND READY */
+
+	while ((rpc_get_flag(RPC_AUDIO) != 0x0) && (MaxCount > 0)) {
+		mdelay(1);
+		MaxCount--;
+	}
+
+	pr_info("[%s] Wait %d ms\n", RPC_NAME, (500 - MaxCount));
+
+#else
+	writel(RPC_INT_SA, rpc_int_base+RPC_SB2_INT_EN);
+	//writel(RPC_INT_SV, (void *)REG_SB2_CPU_INT_EN);
+	//writel(RPC_INT_SV2, (void *)REG_SB2_CPU_INT_EN);
+	//rtd_outl(REG_SB2_CPU_INT_EN, RPC_INT_SA);
+	//rtd_outl(REG_SB2_CPU_INT_EN, RPC_INT_SV);
+	//rtd_outl(REG_SB2_CPU_INT_EN, RPC_INT_SV2);
+#endif
+
+	pr_info("[%s] Suspend exit\n", RPC_NAME);
+
+	return 0;
+}
+
+static void rtk_rpc_pm_shutdown(struct platform_device *pdev)
+{
+#if 1
+	int MaxCount = 500;
+	struct device *dev = &pdev->dev;
+
+	dev_info(dev, "Enter %s\n", __func__);
+
+	rpc_set_flag(RPC_AUDIO, 0xdaedffff); /* STOP AUDIO HAS_CHECK */
+
+	while ((rpc_get_flag(RPC_AUDIO) != 0x0) && (MaxCount > 0)) {
+		mdelay(1);
+		MaxCount--;
+	}
+
+	rpc_event_notify(NULL, AVCPU_SUSPEND, NULL); /* STOP SYSTEM RPC */
+
+	RPC_RESET_BIT(rpc_acpu_int_flag, RPC_AUDIO_SET_NOTIFY); /* Disable Interrupt */
+	rtk_rpc_wmb(rpc_common_base, RPC_COMM_SIZE);
+
+	rpc_set_flag(RPC_AUDIO, 0xdeadffff); /* WAIT AUDIO RPC SUSPEND READY */
+
+	while ((rpc_get_flag(RPC_AUDIO) != 0x0) && (MaxCount > 0)) {
+		mdelay(1);
+		MaxCount--;
+	}
+
+	pr_info("[%s] Wait %d ms\n", RPC_NAME, (500 - MaxCount));
+
+#else
+	writel(RPC_INT_SA, rpc_int_base+RPC_SB2_INT_EN);
+#endif
+
+	dev_info(dev, "Exit %s\n", __func__);
+}
+
+/*
+ * Enable the interrupt from system to audio & video
+ */
+static int rtk_rpc_pm_resume(struct device *dev)
+{
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		printk(KERN_INFO "[RTK_RPC] skip %s in DomU\n", __func__);
+		return 0;
+	}
+#endif
+
+	pr_info("[%s] Resume enter\n", RPC_NAME);
+
+#if 1
+	RPC_SET_BIT(rpc_acpu_int_flag, RPC_AUDIO_SET_NOTIFY);
+	//rtk_rpc_wmb(rpc_common_base, RPC_COMM_SIZE);
+	rpc_set_flag(RPC_AUDIO, 0xffffffff);
+#else
+	writel((RPC_INT_SA | RPC_INT_WRITE_1), rpc_int_base+RPC_SB2_INT_EN);
+	//writel((RPC_INT_SV | RPC_INT_WRITE_1), (void *)REG_SB2_CPU_INT_EN);
+	//writel((RPC_INT_SV2 | RPC_INT_WRITE_1), (void *)REG_SB2_CPU_INT_EN);
+	//rtd_outl(REG_SB2_CPU_INT_EN, (RPC_INT_SA | RPC_INT_WRITE_1));
+	//rtd_outl(REG_SB2_CPU_INT_EN, (RPC_INT_SV | RPC_INT_WRITE_1));
+	//rtd_outl(REG_SB2_CPU_INT_EN, (RPC_INT_SV2 | RPC_INT_WRITE_1));
+#endif
+
+	rpc_event_notify(NULL, AVCPU_RESUME, NULL);
+
+	pr_info("[%s] Resume exit\n", RPC_NAME);
+
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_rpc_pm_ops = {
+	.suspend_late = rtk_rpc_pm_suspend,
+	.resume_early = rtk_rpc_pm_resume,
+	.poweroff = rtk_rpc_pm_suspend,
+#ifdef CONFIG_HIBERNATION
+	.freeze = rtk_rpc_pm_suspend,
+	.thaw = rtk_rpc_pm_resume,
+	.restore = rtk_rpc_pm_resume,
+#endif
+};
+#endif /* CONFIG_PM */
+
+static struct __maybe_unused of_device_id rtk_rpc_ids[] = {
+	{.compatible = "Realtek,rtk-rpc" },
+	{/* Sentinel */ },
+};
+
+static struct platform_driver rtk_rpc_driver = {
+	.probe = rtk_rpc_probe,
+	.remove = rtk_rpc_remove,
+#ifdef CONFIG_PM
+	.shutdown = rtk_rpc_pm_shutdown,
+#endif /* CONFIG_PM */
+	.driver = {
+		.name = "Realtek,rtk-rpc",
+		.bus = &platform_bus_type,
+		.of_match_table = rtk_rpc_ids,
+#ifdef CONFIG_PM
+		.pm = &rtk_rpc_pm_ops,
+#endif /* CONFIG_PM */
+	},
+};
+
+static int rtk_rpc_init(void)
+{
+	return platform_driver_register(&rtk_rpc_driver);
+}
+device_initcall(rtk_rpc_init);
+
+//module_platform_driver(rtk_rpc_driver);
+MODULE_LICENSE("Dual BSD/GPL");
diff --git a/drivers/soc/realtek/common/rpc/rtk_rpc.h b/drivers/soc/realtek/common/rpc/rtk_rpc.h
new file mode 100644
index 00000000..4d0885f
--- /dev/null
+++ b/drivers/soc/realtek/common/rpc/rtk_rpc.h
@@ -0,0 +1,826 @@
+/*
+ * Realtek RPC driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#ifndef _RTK_RPC_H
+#define _RTK_RPC_H
+#include <linux/interrupt.h>
+#include <linux/sched.h>
+#include <asm/current.h>
+#include <asm/barrier.h>
+#include <asm/cacheflush.h>
+#ifdef CONFIG_DEVFS_FS
+#include <linux/devfs_fs_kernel.h>
+#endif
+#include "soc/realtek/memory.h"
+
+#define MY_COPY
+
+extern const char *rpc_name;
+
+#define RPC_SB2_INT 0x0
+#define RPC_SB2_INT_EN 0x4
+#define RPC_SB2_INT_ST 0x8
+
+#define RPC_INT_WRITE_1 1
+#define RPC_INT_SA (1 << 1)
+
+#ifdef CONFIG_ARCH_RTD13xx
+#define RPC_INT_AS (1 << 1)
+#define RPC_INT_VS (1 << 2)
+#define RPC_INT_SV (1 << 2)
+#else
+#define RPC_INT_AS (1 << 3)
+#endif
+
+
+
+#if 0
+#define __read_32bit_caller_register() \
+{ int __res; \
+__asm__ __volatile__( \
+"mov\t%0, lr\n\t" \
+: "=r" (__res)); \
+__res; \
+}
+#endif
+
+#define CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+#define RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID
+
+//#define CONFIG_REALTEK_AVCPU
+
+#define R_PROGRAM 98
+#define AUDIO_SYSTEM 201
+#define AUDIO_AGENT 202
+#define VIDEO_AGENT 300
+
+#define KERNELID 98
+#define REPLYID 99
+#define RPC_AUDIO 0x0
+#define RPC_VIDEO 0x1
+#define RPC_VIDEO2 0x2
+#define RPC_KCPU 0x3
+#define RPC_OK 0
+#define RPC_FAIL -1
+
+#ifndef RPC_ID
+#define RPC_ID 0x5566
+#endif
+
+#ifndef RPC_MAJOR
+#define RPC_MAJOR 240 /* dynamic major by default */
+#endif
+
+#ifndef RPC_NR_DEVS
+
+/*
+ * 2 for S-A,
+ * 2 for A-S,
+ * 2 for S-V1,
+ * 2 for V1-S,
+ * 2 for S-V2,
+ * 2 for V2-S
+ */
+typedef enum {
+	RPC_POLL_DEV_SA_ID0, /* poll audio write */
+	RPC_POLL_DEV_AS_ID1, /*poll audio read */
+	RPC_POLL_DEV_SV1_ID2, /*poll video write */
+	RPC_POLL_DEV_V1S_ID3, /*poll video read */
+//	RPC_POLL_DEV_SV2_ID4,
+//	RPC_POLL_DEV_V2S_ID5,
+	RPC_POLL_DEV_TOTAL
+} NUM_POLL_DEV;
+
+typedef enum {
+	RPC_INTR_DEV_SA_ID0, /* intr audio write */
+	RPC_INTR_DEV_AS_ID1, /*intr audio read */
+	RPC_INTR_DEV_SV1_ID2, /* intr video write */
+	RPC_INTR_DEV_V1S_ID3, /* intr video read */
+//	RPC_INTR_DEV_SV2_ID4,
+//	RPC_INTR_DEV_V2S_ID5,
+	RPC_INTR_DEV_TOTAL
+} NUM_INTR_DEV;
+
+/* total ring buffer number */
+#define RPC_NR_DEVS (RPC_POLL_DEV_TOTAL + RPC_INTR_DEV_TOTAL)
+#endif /* RPC_NR_DEVS */
+
+#ifndef RPC_NR_PAIR
+#define RPC_NR_PAIR 2 /* for interrupt and polling mode */
+#endif /* RPC_NR_PAIR */
+
+#ifndef RPC_NR_KERN_DEVS
+/*
+ * S-A,
+ * A-S,
+ * S-V1,
+ * V1-S,
+ * S-V2,
+ * V2-S
+ */
+typedef enum {
+	RPC_KERN_DEV_SA_ID0, /* kern audio write */
+	RPC_KERN_DEV_AS_ID1, /* kern audio read */
+	RPC_KERN_DEV_SV1_ID2, /* kern video write */
+	RPC_KERN_DEV_V1S_ID3, /* kern video read */
+	//  RPC_KERN_DEV_SV2_ID4,
+	//  RPC_KERN_DEV_V2S_ID5,
+	RPC_NR_KERN_DEVS	/* total ring buffer number */
+} NUM_KERN_DEV;
+
+//#define RPC_NR_KERN_DEVS 6	/* total ring buffer number */
+#endif /* RPC_NR_KERN_DEVS */
+
+//extern void __iomem *rpc_rbussync_base;
+extern volatile void __iomem *rpc_ringbuf_base;
+
+#if 0
+#define rtk_rpc_wmb(start, size) \
+do { \
+smp_mb(); \
+__flush_dcache_area(start, size); \
+writel(0x1234, rpc_rbussync_base); \
+smp_mb(); \
+} while (0)
+#endif
+
+#define rtk_rpc_wmb(start, size) wmb()
+
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+#define AVCPU_NOCACHE 0xa0000000
+#else
+#define AVCPU_NOCACHE 0x0
+#endif
+
+#if 0
+#define AVCPU_SCPU_OFFSET (AVCPU_NOCACHE + RPC_RINGBUF_PHYS - \
+		(unsigned long)RPC_RINGBUF_VIRT)
+#endif
+
+#define AVCPU_SCPU_OFFSET (AVCPU_NOCACHE + RPC_RINGBUF_PHYS \
+- (unsigned long)rpc_ringbuf_base)
+#define AVCPU2SCPU(x) ((char *)(x - AVCPU_SCPU_OFFSET))
+#define SCPU2AVCPU(x) ((unsigned long)x + AVCPU_SCPU_OFFSET)
+#define RPCREAD32(addr) AVCPU2SCPU(addr)
+#define RPCWRITE32(addr, val) \
+do { \
+AVCPU2SCPU(addr) = val; \
+} while (0)
+
+#ifndef RPC_RING_SIZE
+#define RPC_RING_SIZE 512	/* size of ring buffer */
+#endif	/* RPC_RING_SIZE */
+
+#ifndef RPC_POLL_DEV_ADDR
+#define RPC_POLL_DEV_ADDR (AVCPU_NOCACHE + 0x01ffe000)
+#endif	/* RPC_POLL_DEV_ADDR */
+
+#ifndef RPC_INTR_DEV_ADDR
+#define RPC_INTR_DEV_ADDR (RPC_POLL_DEV_ADDR+RPC_RING_SIZE)
+#endif	/* RPC_INTR_DEV_ADDR */
+
+#ifndef RPC_KERN_DEV_ADDR
+#define RPC_KERN_DEV_ADDR (AVCPU_NOCACHE + 0x01fff200)
+#endif	/* RPC_KERN_DEV_ADDR */
+
+#ifndef RPC_RECORD_SIZE
+#define RPC_RECORD_SIZE 64	/* size of ring buffer record */
+#endif	/* RPC_RECORD_SIZE */
+
+#ifndef RPC_POLL_RECORD_ADDR
+#define RPC_POLL_RECORD_ADDR (AVCPU_NOCACHE + 0x01fff000)
+#endif	/* RPC_POLL_RECORD_ADDR */
+
+#ifndef RPC_INTR_RECORD_ADDR
+#define RPC_INTR_RECORD_ADDR (RPC_POLL_RECORD_ADDR+RPC_RECORD_SIZE \
+*(RPC_NR_DEVS/RPC_NR_PAIR))
+#endif	/* RPC_INTR_RECORD_ADDR */
+
+#ifndef RPC_KERN_RECORD_ADDR
+#define RPC_KERN_RECORD_ADDR (AVCPU_NOCACHE + 0x01fffa00)
+#endif	/* RPC_KERN_RECORD_ADDR */
+
+extern struct file_operations rpc_poll_fops;	/* for poll mode */
+extern struct file_operations rpc_intr_fops;	/* for intr mode */
+extern struct file_operations rpc_ctrl_fops;	/* for ctrl mode */
+
+extern struct file_operations *rpc_fop_array[];
+
+/*
+ *struct RPC_STRUCT
+ *@uint32_t programID: program ID defined in IDL file
+ *@uint32_t versionID: version ID defined in IDL file
+ *@uint32_t procedureID: function ID defined in IDL file
+ *@uint32_t taskID: the caller's task ID, assign 0 if NONBLOCK_MODE
+ *@uint32_t sysTID: N/A
+ *@uint32_t sysPID: the callee's task ID
+ *@uint32_t parameterSize: packet's body size
+ *@uint32_t mycontext: return address of reply value
+ */
+typedef struct RPC_STRUCT {
+	uint32_t programID;
+	uint32_t versionID;
+	uint32_t procedureID;
+	uint32_t taskID;
+#ifdef RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID
+	uint32_t sysTID;
+#endif	/* RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID */
+	uint32_t sysPID;
+	uint32_t parameterSize;
+	uint32_t mycontext;
+} RPC_STRUCT;
+
+/*
+ *struct RPC_SYNC_Struct
+ *@wait_queue_head_t waitQueue: for blocking read
+ */
+typedef struct RPC_SYNC_Struct {
+	wait_queue_head_t waitQueue;
+	struct rw_semaphore readSem;
+	struct rw_semaphore writeSem;
+} RPC_SYNC_Struct;
+
+/*
+ *struct RPC_DEV
+ *@uint32_t ringBuf: buffer for interrupt mode
+ *@uint32_t ringStart: pointer to start of ring buffer
+ *@uint32_t ringEnd: pointer to end of ring buffer
+ *@volatile uint32_t ringIn: pointer to where next data will be inserted in
+ *the ring buffer
+ *@volatile uint32_t ringOut: pointer to where next data will
+ *be extracted from the ring buffer
+ */
+
+#ifdef CONFIG_ARCH_RTD119X
+
+typedef struct RPC_DEV { /*size should be 64 bytes*/
+	uint32_t ringBuf;
+	uint32_t ringStart;
+	uint32_t ringEnd;
+	volatile uint32_t ringIn;
+	volatile uint32_t ringOut;
+	/* scpu internal use */
+	RPC_SYNC_Struct *ptrSync;
+	uint32_t reserved1[7];
+} RPC_DEV;
+
+
+#else
+
+typedef struct RPC_DEV { /*size should be 64 bytes*/
+	uint32_t ringBuf;
+	uint32_t ringStart;
+	uint32_t ringEnd;
+	volatile uint32_t ringIn;
+	volatile uint32_t ringOut;
+	/* scpu internal use */
+	uint32_t reserved1;
+	RPC_SYNC_Struct *ptrSync;
+	uint32_t reserved2[8];
+
+#if defined(CONFIG_CPU_V7)
+	uint32_t reserved3;
+#endif
+
+} RPC_DEV;
+
+#endif
+
+/*
+ *struct RPC_DEV_EXTRA
+ *@volatile void *currProc: current process which handles rpc command
+ *@char *name: the rpc device name
+ *@struct list_head tasks: tasks that open this rpc device
+ *@struct tasklet_struct tasklet: schedule a tasklet for bottom half
+ *@volatile uint32_t nextRpc: points to next Rpc
+ *@spinlock_t lock: lock to protect data synchronization
+ *@struct device *sdev: struct device
+ */
+typedef struct RPC_DEV_EXTRA {
+	RPC_DEV	 *dev;
+	volatile void *currProc;
+	char *name;
+	struct list_head tasks;
+	struct tasklet_struct tasklet;
+	volatile uint32_t nextRpc;
+	spinlock_t lock;
+	struct device *sdev;
+} RPC_DEV_EXTRA;
+
+/*
+ * struct RPC_THREAD
+ * maintain a list of threads in the same process
+ */
+typedef struct RPC_THREAD {
+	pid_t pid;
+	struct list_head list;
+} RPC_THREAD;
+
+/*
+ * struct RPC_PROCESS
+ * @struct list_head threads: pids that share the same file descriptor
+ *
+ * maintain a list of processes that use the same RPC device
+ */
+typedef struct RPC_PROCESS {
+	pid_t pid;
+	wait_queue_head_t waitQueue;
+	RPC_DEV	 *dev;
+	RPC_DEV_EXTRA *extra;
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+	struct list_head handlers;
+#endif	/* CONFIG_REALTEK_RPC_PROGRAM_REGISTER */
+	struct list_head threads;
+	struct list_head list;
+    bool bStayActive; // If true, then FW will not be notified when process is destroyed.
+    bool bExit;
+} RPC_PROCESS;
+
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+/*
+ * struct RPC_HANDLER
+ * maintain a list of handlers
+ */
+typedef struct RPC_HANDLER {
+	uint32_t programID;
+	struct list_head list;
+} RPC_HANDLER;
+#endif	/* CONFIG_REALTEK_RPC_PROGRAM_REGISTER */
+
+/*
+ * struct RPC_DBG_FLAG
+ * @uint32_t op: 0:get, 1:set
+ */
+typedef struct RPC_DBG_FLAG {
+	uint32_t op;
+	uint32_t flagValue;
+	uint32_t flagAddr;
+} RPC_DBG_FLAG;
+
+extern int pid_max;
+extern RPC_DEV_EXTRA rpc_intr_extra[RPC_NR_DEVS/RPC_NR_PAIR];
+extern RPC_DEV_EXTRA rpc_poll_extra[RPC_NR_DEVS/RPC_NR_PAIR];
+void rpc_dispatch(unsigned long data);
+
+#ifdef MY_COPY
+//FIXME: accepts SCPU addr
+static inline int my_memcpy(int *des, int *src, int size)
+{
+
+#if defined(CONFIG_CPU_V7)
+	_memcpy_fromio(des, src, size);
+	return 0;
+#else
+	__memcpy_fromio(des, src, size);
+	return 0;
+#endif
+
+}
+#endif
+
+//FIXME: must use the same type of addr (AVCPU addr or SCPU addr)
+static inline int __get_ring_data_size(uint32_t start, uint32_t end,
+		uint32_t in, uint32_t out)
+{
+	int32_t ringsize = end - start;
+	int32_t datasize = (ringsize + in - out) % ringsize;
+
+	pr_debug("%s ringsize:%d datasize:%d start:%x end:%x in:%x out:%x\n",
+			__func__, ringsize, datasize, start, end, in, out);
+	return datasize;
+}
+
+static inline int get_ring_data_size(RPC_DEV *dev)
+{
+	return __get_ring_data_size(dev->ringStart, dev->ringEnd,
+			dev->ringIn, dev->ringOut);
+}
+
+/*
+ * get ring data in buf and return next data pointer
+ */
+//FIXME: out is AVCPU addr
+static inline uint32_t get_ring_data(const char *func, RPC_DEV *dev,
+		uint32_t out, char *buf, int datasize)
+{
+	int size = __get_ring_data_size(dev->ringStart, dev->ringEnd,
+			dev->ringIn, out);
+	int tail = dev->ringEnd - out;
+
+	if (size < datasize) {
+		pr_debug("%s: Size not enough %d < %d\n", func, size, datasize);
+		return 0;
+	}
+
+	if (tail >= datasize) {
+#ifdef MY_COPY
+		my_memcpy((int *)buf, (int *)AVCPU2SCPU(out), datasize);
+#else
+		memcpy(buf, AVCPU2SCPU(out), datasize);
+#endif
+		out += datasize;
+	} else {
+#ifdef MY_COPY
+		my_memcpy((int *)buf, (int *)AVCPU2SCPU(out), tail);
+		my_memcpy((int *)(buf + tail), (int *)AVCPU2SCPU(dev->ringStart),
+				datasize - tail);
+#else
+		memcpy(buf, AVCPU2SCPU(out), tail);
+		memcpy(buf + tail, AVCPU2SCPU(dev->ringStart), datasize - tail);
+#endif
+		out = dev->ringStart + datasize - tail;
+	}
+
+	return out;
+}
+
+static inline void dump_ring_buffer(const char *func, RPC_DEV_EXTRA *extra)
+{
+	int i;
+	RPC_DEV *dev = extra->dev;
+
+	char *bufaddr = AVCPU2SCPU(dev->ringStart);
+	pr_err("==*== %s Start:%p Out:%p next:%p In:%p End:%p size:%d %s ==*==\n",
+			func, AVCPU2SCPU(dev->ringStart),
+			AVCPU2SCPU(dev->ringOut),
+			AVCPU2SCPU(extra->nextRpc),
+			AVCPU2SCPU(dev->ringIn),
+			AVCPU2SCPU(dev->ringEnd),
+			get_ring_data_size(dev),
+			in_atomic() ? "atomic" : "");
+	for (i = 0; i < RPC_RING_SIZE ; i += 16) {
+		uint32_t *addr = (uint32_t *)(bufaddr + i);
+		pr_err("%p: %08x %08x %08x %08x\n",
+				addr, ntohl(*(addr + 0)),
+				ntohl(*(addr + 1)),
+				ntohl(*(addr + 2)),
+				ntohl(*(addr + 3)));
+	}
+}
+
+static inline void convert_rpc_struct(const char *func, RPC_STRUCT *rpc)
+{
+	rpc->programID = ntohl(rpc->programID);
+	rpc->versionID = ntohl(rpc->versionID);
+	rpc->procedureID = ntohl(rpc->procedureID);
+	rpc->taskID = ntohl(rpc->taskID);
+#ifdef RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID
+	rpc->sysTID = ntohl(rpc->sysTID);
+#endif	/* RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID */
+	rpc->sysPID = ntohl(rpc->sysPID);
+	rpc->parameterSize = ntohl(rpc->parameterSize);
+	rpc->mycontext = ntohl(rpc->mycontext);
+}
+
+extern volatile void __iomem *rpc_refclk_base;
+static inline void show_rpc_struct(const char *func, RPC_STRUCT *rpc)
+{
+#ifdef RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID
+	pr_debug("%s: program:%u version:%u procedure:%u taskID:%u sysTID:%u sysPID:%u size:%u context:%x 90k:%u %s\n",
+		func, rpc->programID, rpc->versionID, rpc->procedureID, rpc->taskID, rpc->sysTID, rpc->sysPID,
+		rpc->parameterSize, rpc->mycontext, readl(rpc_refclk_base), in_atomic() ? "atomic" : "");
+#else
+	pr_debug("%s: program:%u version:%u procedure:%u taskID:%u sysPID:%u size:%u context:%x 90k:u %s\n",
+			func, rpc->programID, rpc->versionID, rpc->procedureID, rpc->taskID, rpc->sysPID, rpc->parameterSize,
+			rpc->mycontext, readl(rpc_refclk_base), in_atomic() ? "atomic" : "");
+#endif	/* RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID */
+}
+
+static inline void peek_rpc_struct(const char *func, RPC_DEV *dev)
+{
+	RPC_STRUCT rpc;
+	uint32_t pid;
+	uint32_t arg;
+	uint32_t out = dev->ringOut;
+
+	out = get_ring_data(func, dev, out, (char *)&rpc, sizeof(RPC_STRUCT));
+	if (out == 0)
+		return;
+	convert_rpc_struct(func, &rpc);
+	show_rpc_struct(func, &rpc);
+
+	if (rpc.programID == AUDIO_AGENT && rpc.versionID == 0) {
+		//Parse more information here
+	} else if (rpc.programID == VIDEO_AGENT && rpc.versionID == 0) {
+		//Parse more information here
+	} else if (rpc.programID == R_PROGRAM && rpc.versionID == 0) {
+		out = get_ring_data(func, dev, out, (char *)&arg, sizeof(uint32_t));
+		if (out == 0)
+			return;
+		arg = ntohl(arg);
+		if (rpc.procedureID == 1)
+			pr_debug("%s: alloc %u bytes\n", func, arg);
+		else
+			pr_debug("%s: free addr %x\n", func, arg);
+	} else if (rpc.programID == REPLYID && rpc.versionID == REPLYID) {
+		out = get_ring_data(func, dev, out, (char *)&pid, sizeof(uint32_t));
+		if (out == 0)
+			return;
+		pid = ntohl(pid);
+		pr_debug("%s: reply to taskid:%u\n", func, pid);
+	}
+}
+
+#if 0
+static inline void update_currProc(RPC_DEV_EXTRA *extra, RPC_PROCESS *proc)
+{
+	extra->currProc = proc;
+}
+
+//FIXME: accept AVCPU addr
+static inline void update_nextRpc(RPC_DEV_EXTRA *extra, char *nextRpc)
+{
+	extra->nextRpc = nextRpc;
+}
+
+static inline int rpc_done(RPC_DEV_EXTRA *extra)
+{
+	RPC_DEV *dev = extra->dev;
+
+	return dev->ringOut == extra->nextRpc;
+}
+
+static inline int ring_empty(RPC_DEV *dev)
+{
+	return dev->ringOut == dev->ringIn;
+}
+
+static inline int need_dispatch(RPC_DEV_EXTRA *extra)
+{
+	//size is not zero and previous rpc is done
+	return extra->currProc == NULL && !ring_empty(extra->dev) && rpc_done(extra);
+}
+#else
+#define update_currProc(extra, proc) \
+do { \
+extra->currProc = proc; \
+} while (0)
+
+#define update_nextRpc(extra, next) \
+do { \
+extra->nextRpc = next; \
+} while (0)
+
+#define rpc_done(extra) (extra->dev->ringOut == extra->nextRpc)
+
+#define ring_empty(dev) (dev->ringOut == dev->ringIn)
+
+#define need_dispatch(extra) (extra->currProc == NULL && !ring_empty(extra->dev) && rpc_done(extra))
+#endif
+
+static inline RPC_PROCESS *pick_one_proc(RPC_DEV_EXTRA *extra)
+{
+	RPC_PROCESS *proc = NULL;
+
+	spin_lock_bh(&extra->lock);
+	if (!list_empty(&extra->tasks)) {
+		proc = list_first_entry(&extra->tasks, RPC_PROCESS, list);
+		pr_debug("%s:%d Pick process:%d\n", extra->name, __LINE__, proc->pid);
+	} else {
+		pr_debug("%s:%d No available process\n", extra->name, __LINE__);
+	}
+	spin_unlock_bh(&extra->lock);
+	return proc;
+}
+
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+static inline RPC_PROCESS *pick_supported_proc(RPC_DEV_EXTRA *extra,
+		uint32_t programID)
+{
+	RPC_PROCESS *proc;
+	RPC_HANDLER *handler;
+
+	spin_lock_bh(&extra->lock);
+	list_for_each_entry(proc, &extra->tasks, list) {
+		list_for_each_entry(handler, &proc->handlers, list) {
+			if (handler->programID == programID) {
+				spin_unlock_bh(&extra->lock);
+				pr_debug("%s:%d pid:%d supports programID:%u\n", __func__,
+						__LINE__, proc->pid, programID);
+				return proc;
+			}
+		}
+	}
+	spin_unlock_bh(&extra->lock);
+	pr_debug("%s:%d can't find any process supports programID:%u\n", __func__,
+			__LINE__, programID);
+	return NULL;
+}
+#endif	/* CONFIG_REALTEK_RPC_PROGRAM_REGISTER */
+
+static inline RPC_PROCESS *lookup_by_taskID(RPC_DEV_EXTRA *extra,
+		uint32_t taskID)
+{
+	pid_t pid;
+	RPC_PROCESS *proc = NULL;
+	struct task_struct *task;
+
+	/* sanity check */
+	if (unlikely(taskID >= pid_max)) {
+		pr_err("%s:%d invalid taskID:%u >= pid_max:%d\n", extra->name,
+				__LINE__, taskID, pid_max);
+		return NULL;
+	}
+
+	task = find_task_by_pid_ns(taskID, &init_pid_ns);
+	if (task == NULL) {
+		__WARN_printf("%s:%d can't find_task_by_pid_ns! taskID:%u, thread may be dead\n",
+				extra->name, __LINE__, taskID);
+
+		//BUG();
+
+		/*
+		 * taskID may be dead, use it directly, risky!!
+		 * the same taskID may exist in more than one thread list
+		 */
+		pid = taskID;
+	} else {
+		pid = task->tgid;
+		pr_debug("%s:%d find_task_by_pid_ns taskID:%u => pid:%d tgid:%d comm:%s\n",
+				extra->name, __LINE__, taskID, task->pid, task->tgid, task->comm);
+	}
+
+	spin_lock_bh(&extra->lock);
+	list_for_each_entry(proc, &extra->tasks, list) {
+		pr_debug("%s:%d proc->pid:%d target-pid:%d\n",
+				extra->name, __LINE__, proc->pid, pid);
+
+		if (proc->pid == pid) {
+			spin_unlock_bh(&extra->lock);
+			pr_debug("%s:%d found process:%d\n", extra->name, __LINE__, pid);
+			return proc;
+		} else {
+			RPC_THREAD *thread;
+
+			list_for_each_entry(thread, &proc->threads, list) {
+				if (thread->pid == pid) {
+					spin_unlock_bh(&extra->lock);
+					pr_debug("%s:%d found thread:%d in process:%d\n",
+							extra->name, __LINE__, pid, proc->pid);
+					return proc;
+				}
+			}
+		}
+	}
+	spin_unlock_bh(&extra->lock);
+	pr_err("%s:%d taskID:%u never shows in thread list\n",
+			extra->name, __LINE__, taskID);
+	return NULL;
+}
+
+/* lock before call this function */
+static inline int update_thread_list(RPC_DEV_EXTRA *extra, pid_t pid)
+{
+	RPC_PROCESS *proc = NULL;
+	RPC_PROCESS *proctmp;
+	RPC_THREAD *thread;
+
+	spin_lock_bh(&extra->lock);
+	list_for_each_entry(proctmp, &extra->tasks, list) {
+		/* find the entry in read device task list with the same pid */
+		if (proctmp->pid == pid) {
+			proc = proctmp;
+			break;
+		}
+	}
+	spin_unlock_bh(&extra->lock);
+
+	/* no found, should not happen */
+	if (proc == NULL)
+		return 0;
+
+	/* current thread is main thread or the thread that open this device */
+	if (current->pid == proc->pid)
+		return 0;
+
+	spin_lock_bh(&extra->lock);
+	list_for_each_entry(thread, &proc->threads, list) {
+		/* current is already in thread list */
+		if (thread->pid == current->pid) {
+			spin_unlock_bh(&extra->lock);
+			return 0;
+		}
+	}
+	spin_unlock_bh(&extra->lock);
+
+	/* not found, so add new thread to list */
+	thread = kmalloc(sizeof(RPC_THREAD), GFP_KERNEL);
+	if (thread == NULL) {
+		pr_err("%s: failed to allocate RPC_THREAD\n", __func__);
+		return -ENOMEM;
+	}
+	pr_debug("%s:%d add thread:%s,%d,%d to thread list of process:%d\n",
+			__func__, __LINE__, current->comm, current->pid, current->tgid,
+			proc->pid);
+	thread->pid = current->pid;
+	spin_lock_bh(&extra->lock);
+	list_add(&thread->list, &proc->threads);
+	spin_unlock_bh(&extra->lock);
+
+	return 1;
+}
+
+/* Prototypes for shared functions */
+#ifdef MY_COPY
+int my_copy_to_user(int *des, int *src, int size);
+int my_copy_from_user(volatile void __iomem *des, const void *src, int size);
+
+int my_copy_user(int *des, int *src, int size);
+#endif
+
+int rpc_poll_init(void);
+int rpc_poll_pause(void);
+int rpc_poll_suspend(void);
+int rpc_poll_resume(void);
+void rpc_poll_cleanup(void);
+int rpc_intr_init(void);
+int rpc_intr_pause(void);
+int rpc_intr_suspend(void);
+int rpc_intr_resume(void);
+void rpc_intr_cleanup(void);
+
+int rpc_kern_init(void);
+int rpc_kern_pause(void);
+int rpc_kern_suspend(void);
+int rpc_kern_resume(void);
+ssize_t rpc_kern_read(int opt, char *buf, size_t count);
+ssize_t rpc_kern_write(int opt, const char *buf, size_t count);
+
+#define RPC_DVR_MALLOC 0x1
+#define RPC_DVR_FREE 0x2
+#define RPC_SIO_INIT 0x3
+
+typedef unsigned long (*FUNC_PTR)(unsigned long, unsigned long);
+//int register_kernel_rpc(unsigned long command, FUNC_PTR ptr);
+
+extern volatile RPC_DEV *rpc_poll_devices;
+extern volatile RPC_DEV *rpc_intr_devices;
+extern volatile RPC_DEV *rpc_kern_devices;
+extern volatile void __iomem *rpc_int_base;
+extern void rpc_set_flag(int, uint32_t);
+#ifdef CONFIG_SND_REALTEK
+int RPC_DESTROY_AUDIO_FLOW(int pid);
+#endif
+
+/* Use 'k' as magic number */
+#define RPC_IOC_MAGIC 'k'
+
+/*
+ * S means "Set": through a ptr,
+ * T means "Tell": directly with the argument value
+ * G means "Get": reply by setting through a pointer
+ * Q means "Query": response is on the return value
+ * X means "eXchange": G and S atomically
+ * H means "sHift": T and Q atomically
+ */
+#define RPC_IOCTTIMEOUT _IO(RPC_IOC_MAGIC,  0)
+#define RPC_IOCQTIMEOUT _IO(RPC_IOC_MAGIC,  1)
+#define RPC_IOCTRESET _IO(RPC_IOC_MAGIC,  2)
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+#define RPC_IOCTHANDLER _IO(RPC_IOC_MAGIC, 3)
+#endif
+
+struct S_RPC_IOC_PROCESS_CONFIG_0 {
+    int bStayActive;
+    int reserved[16-1];
+};
+#define RPC_IOC_PROCESS_CONFIG_0 _IOW(RPC_IOC_MAGIC, 4, struct S_RPC_IOC_PROCESS_CONFIG_0)
+#define RPC_IOCTEXITLOOP _IO(RPC_IOC_MAGIC, 5)
+
+#define RPC_DBGREG_GET 0
+#define RPC_DBGREG_SET 1
+#define RPC_IOCTRGETDBGREG_A _IOWR(RPC_IOC_MAGIC, 0x10, RPC_DBG_FLAG)
+#define RPC_IOCTRGETDBGREG_V _IOWR(RPC_IOC_MAGIC, 0x11, RPC_DBG_FLAG)
+
+#define RPC_HAS_BIT(addr, bit) (readl(addr) & bit)
+#define RPC_SET_BIT(addr,bit) (writel((readl(addr)|bit), addr))
+#define RPC_RESET_BIT(addr,bit) (writel((readl(addr)&~bit), addr))
+
+#define VO_DC_SET_NOTIFY (__cpu_to_be32(1U << 16)) /* ACPU write */
+#define VO_DC_FEEDBACK_NOTIFY (__cpu_to_be32(1U << 17))
+#define AUDIO_RPC_SET_NOTIFY (__cpu_to_be32(1U << 24)) /* ACPU write */
+#define AUDIO_RPC_FEEDBACK_NOTIFY (__cpu_to_be32(1U << 25))
+#define VIDEO_RPC_SET_NOTIFY (__cpu_to_be32(1U << 0)) /* VCPU write */
+#define VIDEO_RPC_FEEDBACK_NOTIFY (__cpu_to_be32(1U << 1))
+
+
+
+#define DC_VO_SET_NOTIFY (__cpu_to_be32(1U << 0)) /* SCPU write */
+#define DC_VO_FEEDBACK_NOTIFY (__cpu_to_be32(1U << 1))
+#define RPC_AUDIO_SET_NOTIFY (__cpu_to_be32(1U << 8)) /* SCPU write */
+#define RPC_AUDIO_FEEDBACK_NOTIFY (__cpu_to_be32(1U << 9))
+#define RPC_VIDEO_SET_NOTIFY (__cpu_to_be32(1U << 2)) /* SCPU write */
+#define RPC_VIDEO_FEEDBACK_NOTIFY (__cpu_to_be32(1U << 3))
+
+
+
+
+#endif /* _RTK_RPC_H */
diff --git a/drivers/soc/realtek/common/rpc/rtk_rpc_intr.c b/drivers/soc/realtek/common/rpc/rtk_rpc_intr.c
new file mode 100644
index 00000000..b3c498a
--- /dev/null
+++ b/drivers/soc/realtek/common/rpc/rtk_rpc_intr.c
@@ -0,0 +1,1368 @@
+/*
+ * Realtek RPC driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/slab.h>
+#include <linux/fs.h>
+#include <linux/errno.h>
+#include <linux/types.h>
+#include <linux/proc_fs.h>
+#include <linux/fcntl.h>
+#include <linux/ioctl.h>
+#include <linux/sched.h>
+#include <linux/delay.h>
+#include <linux/freezer.h>
+#include <linux/ratelimit.h>
+#include <linux/io.h>
+#include <linux/uaccess.h>
+#include <linux/kthread.h>
+
+
+#include "rtk_rpc.h"
+#ifdef CONFIG_ION_RTK
+#include "uapi/ion.h"
+#include "ion/ion.h"
+#include "uapi/ion_rtk.h"
+#endif
+/*
+ * dump ring buffer rate limiting:
+ * not more than 1 ring buffer dumping every 3s
+ */
+DEFINE_RATELIMIT_STATE(ring_dump_state, 3 * HZ, 1);
+static DEFINE_SPINLOCK(rpc_alloc_lock);
+
+
+volatile RPC_DEV *rpc_intr_devices;
+int rpc_intr_is_paused;
+int rpc_intr_is_suspend;
+
+int timeout = HZ; //HZ / 40; /* jiffies */
+
+RPC_DEV_EXTRA rpc_intr_extra[RPC_NR_DEVS / RPC_NR_PAIR];
+
+extern void rpc_send_interrupt(int type);
+
+
+
+#ifdef CONFIG_ION_RTK
+struct ion_client *fw_rpc_ion_client;
+extern struct ion_device *rtk_phoenix_ion_device;
+
+typedef struct r_program_entry
+{
+	struct ion_handle *handle;
+	unsigned long phys_addr;
+	struct r_program_entry *next;
+}r_program_entry_t;
+
+static r_program_entry_t *r_program_head = NULL;
+static int r_program_count = 0;
+
+
+struct task_struct *acpu_r_program_kthread;
+wait_queue_head_t acpu_r_program_waitQueue;
+int acpu_r_program_flag = 0;
+
+struct task_struct *vcpu_r_program_kthread;
+wait_queue_head_t vcpu_r_program_waitQueue;
+int vcpu_r_program_flag = 0;
+#endif
+#ifdef CONFIG_ION_RTK
+static void r_program_add(r_program_entry_t * entry)
+{
+	spin_lock_bh(&rpc_alloc_lock);
+	entry->next = r_program_head;
+	r_program_head = entry;
+	r_program_count++;
+	spin_unlock_bh(&rpc_alloc_lock);
+}
+
+static r_program_entry_t *r_program_remove(unsigned long phys_addr)
+{
+	r_program_entry_t *prev = NULL;
+	r_program_entry_t *curr = NULL;
+
+	spin_lock_bh(&rpc_alloc_lock);
+	curr = r_program_head;
+	while (curr != NULL) {
+		if (curr->phys_addr != phys_addr) {
+			prev = curr;
+			curr = curr->next;
+			continue;
+		}
+
+		if (prev == NULL) {
+			r_program_head = curr->next;
+		} else {
+			prev->next = curr->next;
+		}
+		r_program_count--;
+		spin_unlock_bh(&rpc_alloc_lock);
+
+		return curr;
+	}
+	spin_unlock_bh(&rpc_alloc_lock);
+	return NULL;
+}
+
+ssize_t r_program_read(RPC_DEV_EXTRA *extra, RPC_DEV *dev, char *buf, size_t count)
+{
+	int temp, size;
+	size_t r;
+	ssize_t ret = 0;
+	uint32_t ptmp;
+	int rpc_ring_size = dev->ringEnd - dev->ringStart;
+
+	down_write(&dev->ptrSync->readSem);
+
+	if (dev->ringIn > dev->ringOut)
+		size = dev->ringIn - dev->ringOut;
+	else
+		size = rpc_ring_size + dev->ringIn - dev->ringOut;
+
+	pr_debug("%s:%d ==going read== count:%zu avail:%d "
+			"ringOut:%x ringIn:%x nextRPC:%x",
+			extra->name, __LINE__, count, size, dev->ringOut, dev->ringIn,
+			extra->nextRpc);
+	peek_rpc_struct(__func__, dev);
+	if (count > size)
+		count = size;
+	temp = dev->ringEnd - dev->ringOut;
+	rtk_rpc_wmb(AVCPU2SCPU(dev->ringStart), PAGE_ALIGN(rpc_ring_size));
+
+	if (temp >= count) {
+#ifdef MY_COPY
+		r = my_copy_user((int *)buf,
+				(int *)AVCPU2SCPU(dev->ringOut), count);
+#else
+		r = copy_to_user((int *)buf, (int *)AVCPU2SCPU(dev->ringOut), count);
+#endif /* MY_COPY */
+		if (r) {
+			pr_err("%s:%d buf:%p count:%lu EFAULT\n",
+				extra->name, __LINE__, buf, count);
+			ret = -EFAULT;
+			goto out;
+		}
+
+		ret = count;
+		ptmp = dev->ringOut + ((count+3) & 0xfffffffc);
+		if (ptmp == dev->ringEnd)
+			dev->ringOut = dev->ringStart;
+		else
+			dev->ringOut = ptmp;
+
+		//pr_debug("RPC Read is in 1st kind...\n");
+	} else {
+#ifdef MY_COPY
+		r = my_copy_user((int *)buf,
+				(int *)AVCPU2SCPU(dev->ringOut), temp);
+#else
+		r = copy_to_user((int *)buf,
+				(int *)AVCPU2SCPU(dev->ringOut), temp);
+#endif /* MY_COPY */
+
+		if (r) {
+			pr_err("%s:%d buf:%p count:%lu EFAULT\n",
+					extra->name, __LINE__, buf, count);
+			ret = -EFAULT;
+			goto out;
+		}
+
+		count -= temp;
+
+#ifdef MY_COPY
+		r = my_copy_user((int *)(buf+temp),
+				(int *)AVCPU2SCPU(dev->ringStart), count);
+#else
+		r = copy_to_user((int *)(buf+temp),
+				(int *)AVCPU2SCPU(dev->ringStart), count);
+#endif /* MY_COPY */
+
+		if (r) {
+			pr_err("%s:%d buf:%p count:%lu EFAULT\n",
+					extra->name, __LINE__, buf, count);
+			ret = -EFAULT;
+			goto out;
+		}
+		ret = (temp + count);
+		dev->ringOut = dev->ringStart+((count+3) & 0xfffffffc);
+
+		//pr_debug("RPC Read is in 2nd kind...\n");
+	}
+	spin_lock_bh(&extra->lock);
+
+	if (rpc_done(extra)) {
+		pr_debug("%s: Previous RPC is done, unregister myself\n", extra->name);
+		update_currProc(extra, NULL);
+	}
+
+	spin_unlock_bh(&extra->lock);
+
+	if (need_dispatch(extra))
+		tasklet_schedule(&(extra->tasklet));
+	up_write(&dev->ptrSync->readSem);
+	return ret;
+out:
+	pr_err("[%s] read error occur\n", __func__);
+	up_write(&dev->ptrSync->readSem);
+	return ret;
+
+}
+
+
+ssize_t r_program_write(int opt, RPC_DEV_EXTRA *extra, RPC_DEV *dev, char *buf, size_t count)
+{
+
+	int temp, size;
+	size_t r;
+	ssize_t ret = 0;
+	uint32_t ptmp;
+	int rpc_ring_size = dev->ringEnd - dev->ringStart;
+	RPC_STRUCT *rpc;
+
+	rpc = (RPC_STRUCT *)(buf);
+	pr_debug("%s: program:%u version:%u procedure:%u taskID:%u sysTID:%u sysPID:%u size:%u context:%x 90k:%u %s\n",
+			__func__, ntohl(rpc->programID), ntohl(rpc->versionID), ntohl(rpc->procedureID), ntohl(rpc->taskID), ntohl(rpc->sysTID), ntohl(rpc->sysPID),
+			ntohl(rpc->parameterSize),ntohl(rpc->mycontext), readl(rpc_refclk_base), in_atomic() ? "atomic" : "");
+	down_write(&dev->ptrSync->writeSem);
+
+	if (dev->ringIn == dev->ringOut)
+		size = 0;   // the ring is empty
+	else if (dev->ringIn > dev->ringOut)
+		size = dev->ringIn - dev->ringOut;
+	else
+		size = RPC_RING_SIZE + dev->ringIn - dev->ringOut;
+
+	if (count > (RPC_RING_SIZE - size - 1))
+		goto out;
+
+	temp = dev->ringEnd - dev->ringIn;
+	if (temp >= count) {
+#ifdef MY_COPY
+		r = my_copy_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, count);
+#else
+		r = ((int *)AVCPU2SCPU(dev->ringIn) !=
+				memcpy((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, count));
+#endif /* MY_COPY */
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+		ret += count;
+		ptmp = dev->ringIn + ((count+3) & 0xfffffffc);
+
+		//asm("DSB");
+		mb();
+
+		if (ptmp == dev->ringEnd)
+			dev->ringIn = dev->ringStart;
+		else
+			dev->ringIn = ptmp;
+
+		pr_debug("RPC Write is in 1st kind...\n");
+	} else {
+#ifdef MY_COPY
+		r = my_copy_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, temp);
+#else
+		r = ((int *)AVCPU2SCPU(dev->ringIn) !=
+				memcpy((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, temp));
+#endif
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+		count -= temp;
+
+#ifdef MY_COPY
+		r = my_copy_user((int *)AVCPU2SCPU(dev->ringStart),
+				(int *)(buf+temp), count);
+#else
+		r = ((int *)AVCPU2SCPU(dev->ringStart) != memcpy((int *)AVCPU2SCPU(dev->ringStart), (int *)(buf+temp), count));
+#endif
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+		ret += (temp + count);
+
+		//asm("DSB");
+		mb();
+
+		dev->ringIn = dev->ringStart+((count+3) & 0xfffffffc);
+
+		pr_debug("RPC Write is in 2nd kind...\n");
+	}
+
+	rtk_rpc_wmb(AVCPU2SCPU(dev->ringStart),
+			PAGE_ALIGN(rpc_ring_size));
+
+	if (opt == RPC_AUDIO)
+		rpc_send_interrupt(RPC_AUDIO);
+	else if (opt == RPC_VIDEO)
+		rpc_send_interrupt(RPC_VIDEO);
+
+	up_write(&dev->ptrSync->writeSem);
+	return ret;
+out:
+	pr_err("[%s]RingBuf full! RPC FW intr write ringIn pointer is : %p\n", __func__, AVCPU2SCPU(dev->ringIn));
+	up_write(&dev->ptrSync->writeSem);
+	return ret;
+}
+#endif
+
+#ifdef CONFIG_ION_RTK
+void rpc_ion_handler(RPC_DEV_EXTRA *extra)
+{
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t phys_addr;
+	unsigned long reply_value = 0;
+	char tmpbuf[sizeof(RPC_STRUCT) + sizeof(uint32_t)];
+	uint32_t *tmp;
+	char replybuf[sizeof(RPC_STRUCT) + 2*sizeof(uint32_t)];
+	RPC_STRUCT *rpc;
+	RPC_STRUCT *rrpc;
+	unsigned long map_addr;
+	RPC_DEV_EXTRA *extra_w;
+	r_program_entry_t *rpc_entry;
+	int opt = 0;
+
+	if(!strcmp(extra->name, "AudioIntrRead")) {
+		extra_w = &rpc_intr_extra[0];
+		opt = RPC_AUDIO;
+	} else if (!strcmp(extra->name, "Video1IntrRead")){
+		extra_w = &rpc_intr_extra[2];
+		opt = RPC_VIDEO;
+	}
+	pr_debug("[%s] handle %s rpc\n", extra->name);
+	if (r_program_read(extra, extra->dev, (char *) &tmpbuf, sizeof(RPC_STRUCT) + sizeof(uint32_t)) != (sizeof(RPC_STRUCT) + sizeof(uint32_t))) {
+		pr_err("[%s] remote allocate read error...\n", __func__);
+		return;
+	}
+
+	rpc = (RPC_STRUCT *)(tmpbuf);
+
+	//convert_rpc_struct(extra->name, rpc);
+	pr_debug("%s: program:%u version:%u procedure:%u taskID:%u sysTID:%u sysPID:%u size:%u context:%x 90k:%u %s\n",
+			__func__, ntohl(rpc->programID), ntohl(rpc->versionID), ntohl(rpc->procedureID), ntohl(rpc->taskID), ntohl(rpc->sysTID), ntohl(rpc->sysPID),
+			ntohl(rpc->parameterSize), ntohl(rpc->mycontext), readl(rpc_refclk_base), in_atomic() ? "atomic" : "");
+
+    {
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+        const bool match_old_mapping = true;
+#else
+        const bool match_old_mapping = false;
+#endif
+        enum RPC_REMOTE_CMD {
+            RPC_REMOTE_CMD_ALLOC        = 1,
+            RPC_REMOTE_CMD_FREE         = 2,
+            RPC_REMOTE_CMD_ALLOC_SECURE = 3,
+        } remote_cmd;
+
+        size_t align;
+        size_t alloc_val;
+
+        unsigned int fw_send_value;
+        tmp = (uint32_t *)(tmpbuf + sizeof(RPC_STRUCT));
+        fw_send_value = ntohl(*tmp);
+        remote_cmd = (enum RPC_REMOTE_CMD) ntohl(rpc->procedureID);
+
+        switch (remote_cmd) {
+            case RPC_REMOTE_CMD_ALLOC:
+            case RPC_REMOTE_CMD_ALLOC_SECURE:
+                {
+#define FW_ALLOC_SPEC_MASK  0xC0000000
+#define FW_ALLOC_VCPU_FWACC 0x40000000
+#define FW_ALLOC_VCPU_EXTRA 0x80000000
+                    unsigned int ion_alloc_heap_mask =
+                        (remote_cmd == RPC_REMOTE_CMD_ALLOC) ? RTK_PHOENIX_ION_HEAP_MEDIA_MASK : RTK_PHOENIX_ION_HEAP_SECURE_MASK ;
+                    unsigned int ion_alloc_flags =
+                        (remote_cmd == RPC_REMOTE_CMD_ALLOC) ? (ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_ACPUACC) :
+#if (defined(CONFIG_ARCH_RTD139x) && defined(CONFIG_RTK_VMX_DRM))
+                        (ION_FLAG_NONCACHED | ION_FLAG_SECURE_AUDIO)
+#else
+                        (ION_FLAG_NONCACHED  | ION_FLAG_HWIPACC)
+#endif
+                        ;
+                    alloc_val = PAGE_ALIGN(fw_send_value & ~FW_ALLOC_SPEC_MASK);
+
+                    if (fw_send_value & FW_ALLOC_VCPU_FWACC) {
+                        ion_alloc_flags = ION_FLAG_VCPU_FWACC;
+                    } else if (fw_send_value & FW_ALLOC_VCPU_EXTRA) {
+                        handle = ion_alloc(fw_rpc_ion_client, alloc_val, PAGE_SIZE, ion_alloc_heap_mask, ION_FLAG_CMA);
+                        ion_alloc_flags |= ION_USAGE_ALGO_LAST_FIT;
+                    }
+                    if (handle == NULL || IS_ERR(handle))
+                        handle = ion_alloc(fw_rpc_ion_client, alloc_val, PAGE_SIZE, ion_alloc_heap_mask, ion_alloc_flags);
+
+                    rpc->mycontext = htonl(ntohl(rpc->mycontext) & 0xfffffffc);
+
+                    if (IS_ERR(handle)) {
+                        pr_err("[%s] ERROR: ion_alloc fail %d(heap:0x%x flags:0x%x)\n", __func__, (int *) handle, ion_alloc_heap_mask, ion_alloc_flags);
+                        reply_value = -1U;
+                        break;
+                    }
+
+                    if (ion_phys(fw_rpc_ion_client, handle, &phys_addr, &alloc_val) != 0) {
+                        pr_err("[%s] ERROR: ion_phys fail(heap:0x%x flags:0x%x)\n", __func__, ion_alloc_heap_mask, ion_alloc_flags);
+                    }
+                    rpc_entry = kmalloc(sizeof(struct r_program_entry), GFP_KERNEL);
+                    rpc_entry->handle = handle;
+                    rpc_entry->phys_addr = phys_addr;
+                    r_program_add(rpc_entry);
+                    reply_value = phys_addr;
+                    if (match_old_mapping)
+                        reply_value += 0x80000000;
+
+                    pr_debug("[%s] ion_alloc addr : 0x%x (heap:0x%x flags:0x%x)\n", __func__, reply_value, ion_alloc_heap_mask, ion_alloc_flags);
+
+                }
+                break;
+            case RPC_REMOTE_CMD_FREE:
+                {
+                    phys_addr = fw_send_value;
+                    if (match_old_mapping)
+                        phys_addr -= 0x80000000;
+
+                    rpc_entry = r_program_remove(phys_addr);
+
+                    if (rpc_entry) {
+                        ion_free(fw_rpc_ion_client, rpc_entry->handle);
+                        kfree(rpc_entry);
+                        pr_debug("[%s] ion_free addr : 0x%x (reply_value : 0x%lx)\n", __func__, phys_addr, reply_value);
+                        reply_value = 0;
+                    } else {
+                        pr_err("[%s]cannot find rpc_entry to free:phys_addr:%x\n", __func__, phys_addr);
+                        reply_value = -1U;
+#if 0 /* WORKAROUND : Avoid FW deadlock when phys_addr is illegal */
+                        return;
+#endif
+                    }
+
+                    rpc->mycontext = htonl(ntohl(rpc->mycontext) & 0xfffffffc);
+                }
+                break;
+            default:
+                break;
+        }
+    }
+
+
+	/*Reply RPC*/
+	rrpc = (RPC_STRUCT *)replybuf;
+	rrpc->programID = htonl(REPLYID);
+	rrpc->versionID = htonl(REPLYID);
+	rrpc->procedureID = 0;
+	rrpc->taskID = 0;
+#ifdef RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID
+	rrpc->sysTID = 0;
+#endif /* RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID */
+	rrpc->sysPID = 0;
+	rrpc->parameterSize = htonl(2*sizeof(uint32_t));
+	rrpc->mycontext = rpc->mycontext;
+
+	/* fill the parameters... */
+	tmp = (uint32_t *)(replybuf + sizeof(RPC_STRUCT));
+	*(tmp+0) = rpc->taskID; /* FIXME: should be 64bit */
+	*(tmp+1) = htonl(reply_value);
+
+	if (r_program_write(opt, extra_w, extra_w->dev, (char *) &replybuf, sizeof(RPC_STRUCT) + 2*sizeof(uint32_t)) != (sizeof(RPC_STRUCT) + 2*sizeof(uint32_t))) {
+		pr_err("[%s] remote allocate reply error...\n", __func__);
+		return;
+	}
+
+}
+#endif
+#ifdef CONFIG_ION_RTK
+static int acpu_remote_alloc_thread(void * p)
+{
+	RPC_DEV_EXTRA *extra = &rpc_intr_extra[1];
+
+	while (1) {
+		if (wait_event_interruptible(acpu_r_program_waitQueue, acpu_r_program_flag || kthread_should_stop())) {
+			pr_notice("%s got signal or should stop...\n", current->comm);
+			continue;
+		}
+
+		if (kthread_should_stop()) {
+			pr_notice("%s exit...\n", current->comm);
+			break;
+		}
+		spin_lock_bh(&extra->lock);
+		acpu_r_program_flag = 0;
+		spin_unlock_bh(&extra->lock);
+		rpc_ion_handler(extra);
+	}
+	return 0;
+}
+#endif	
+#ifdef CONFIG_ION_RTK
+#ifdef CONFIG_ARCH_RTD13xx
+static int vcpu_remote_alloc_thread(void * p)
+{
+	RPC_DEV_EXTRA *extra = &rpc_intr_extra[3];
+
+	while (1) {
+		if (wait_event_interruptible(vcpu_r_program_waitQueue, vcpu_r_program_flag || kthread_should_stop())) {
+			pr_notice("%s got signal or should stop...\n", current->comm);
+			continue;
+		}
+
+		if (kthread_should_stop()) {
+			pr_notice("%s exit...\n", current->comm);
+			break;
+		}
+		spin_lock_bh(&extra->lock);
+		vcpu_r_program_flag = 0;
+		spin_unlock_bh(&extra->lock);
+		rpc_ion_handler(extra);
+	}
+	return 0;
+}
+#endif
+#endif	
+
+/*
+ * This function may be called by tasklet and rpc_intr_read(),
+ * rpc_poll_read()
+ */
+void rpc_dispatch(unsigned long data)
+{
+	RPC_DEV_EXTRA *extra = (RPC_DEV_EXTRA *) data;
+	RPC_DEV *dev = extra->dev;
+	RPC_PROCESS *proc = NULL;
+	uint32_t out;
+	RPC_STRUCT rpc;
+	int found = 0;
+	uint32_t ringOut = dev->ringOut;
+	uint32_t ringIn = dev->ringIn;
+	uint32_t nextRpc = extra->nextRpc;
+	RPC_PROCESS *curr = (RPC_PROCESS *)extra->currProc;
+
+	pr_debug("==*==*==%s Out:%x next:%x In:%x size:%d %s==*==*==\n",
+			extra->name, ringOut, nextRpc, ringIn, get_ring_data_size(dev), in_atomic() ? "atomic" : "");
+	if (curr != NULL || ringOut == ringIn || ringOut != nextRpc) {
+		pr_debug("%s: unable to disp. currProc:%d Out:%x next:%x "
+				"In:%x size:%d %s\n",
+				extra->name, curr ? curr->pid : 0, ringOut, nextRpc, ringIn,
+				get_ring_data_size(dev), in_atomic() ? "atomic" : "");
+		return;
+	}
+
+	//peek_rpc_struct(extra->name, dev);
+	out = get_ring_data(extra->name, dev, ringOut, (char *) &rpc,
+			sizeof(RPC_STRUCT));
+	if (out == 0)
+		return;
+
+	convert_rpc_struct(extra->name, &rpc);
+	show_rpc_struct(__func__, &rpc);
+
+	switch (rpc.programID) {
+	case R_PROGRAM:
+		pr_debug("%s: program:%u version:%u procedure:%u taskID:%u sysTID:%u sysPID:%u size:%u context:%x 90k:%u %s\n",
+			__func__, rpc.programID, rpc.versionID, rpc.procedureID, rpc.taskID, rpc.sysTID, rpc.sysPID,
+			rpc.parameterSize, rpc.mycontext, readl(rpc_refclk_base), in_atomic() ? "atomic" : "");
+#if CONFIG_ION_RTK   /*audio fw ion remote alloc handled by kernel*/
+		out += rpc.parameterSize;
+		if (out >= dev->ringEnd)
+			out = dev->ringStart + (out - dev->ringEnd);
+		if ((rpc.mycontext & 0x1) == 1) {/*audio remote allocate*/
+			spin_lock_bh(&extra->lock);
+			update_nextRpc(extra, out);
+			acpu_r_program_flag = 1;
+			wake_up_interruptible(&acpu_r_program_waitQueue);
+			spin_unlock_bh(&extra->lock);
+		}
+#ifdef CONFIG_ARCH_RTD13xx
+		else if ((rpc.mycontext & 0x1) == 0){/*video remote allocate*/
+			spin_lock_bh(&extra->lock);
+			update_nextRpc(extra, out);
+			vcpu_r_program_flag = 1;
+			wake_up_interruptible(&vcpu_r_program_waitQueue);
+			spin_unlock_bh(&extra->lock);
+		}
+#endif
+		else {
+			pr_err("[%s] Unknow Request Remote Allocate\n");
+		}
+		return;
+#else
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+		proc = pick_supported_proc(extra, rpc.programID);
+#else
+		proc = pick_one_proc(extra);
+#endif /* CONFIG_REALTEK_RPC_PROGRAM_REGISTER */
+#endif
+		break;
+	case AUDIO_AGENT:
+	case VIDEO_AGENT:
+		proc = NULL;
+		//show_rpc_struct(extra->name, &rpc);
+		/* use sysPID directly */
+		if (rpc.sysPID > 0 && rpc.sysPID < pid_max) {
+			pr_info("lookup by sysPID:%d\n", rpc.sysPID);
+			proc = lookup_by_taskID(extra, rpc.sysPID);
+			if (proc == NULL)
+				show_rpc_struct(extra->name, &rpc);
+#ifdef RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID
+		/* lookup pid by sysTID */
+		} else if (rpc.sysTID > 0 && rpc.sysTID < pid_max) {
+			pr_info("lookup by sysTID:%d\n", rpc.sysTID);
+			proc = lookup_by_taskID(extra, rpc.sysTID);
+			if (proc == NULL)
+				show_rpc_struct(extra->name, &rpc);
+		}
+#endif /* RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID */
+		if (unlikely(proc == NULL)) {
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+			proc = pick_supported_proc(extra, rpc.programID);
+#else
+			proc = pick_one_proc(extra);
+#endif
+		}
+		break;
+	case REPLYID:
+		if (rpc.versionID == REPLYID &&
+				rpc.parameterSize >= sizeof(uint32_t)) {
+			uint32_t taskID;
+			if (get_ring_data(extra->name, dev, out, (char *) &taskID,
+					sizeof(uint32_t)) == 0)
+				return;
+
+			taskID = ntohl(taskID);
+			pr_debug("%s:%d taskID:%u\n", extra->name, __LINE__, taskID);
+			proc = lookup_by_taskID(extra, taskID);
+		}
+		break;
+	default:
+		if (in_atomic() && __ratelimit(&ring_dump_state)) {
+			pr_err("%s:%d invalid programID:%u!!! Out:%x next:%x In:%x\n",
+					__func__, __LINE__, rpc.programID, ringOut, nextRpc,
+					ringIn);
+			show_rpc_struct(extra->name, &rpc);
+			dump_ring_buffer(extra->name, extra);
+		}
+		return;
+		//BUG();
+		//__WARN();
+	}
+
+	if (proc) {
+		found = 1;
+	} else if (__ratelimit(&ring_dump_state)) {
+		pr_err("%s:%d can't find process for handling %s programID:%u\n",
+				extra->name, __LINE__, extra->name, rpc.programID);
+		show_rpc_struct(extra->name, &rpc);
+	}
+
+	out += rpc.parameterSize;
+	if (out >= dev->ringEnd)
+		out = dev->ringStart + (out - dev->ringEnd);
+
+	spin_lock_bh(&extra->lock);
+	if (found) {
+		update_nextRpc(extra, out);
+		update_currProc(extra, proc);
+		wake_up_interruptible(&proc->waitQueue);
+		pr_debug("%s:%d ###Wakeup### proc:%p(%d) process:%p(%d) and \
+				update nextRpc:%x for programID:%u\n",
+				extra->name, __LINE__, proc, proc ? proc->pid : 0,
+				extra->currProc,
+				extra->currProc ? ((RPC_PROCESS *)extra->currProc)->pid : 0,
+				extra->nextRpc, rpc.programID);
+	} else {
+#if 0
+		pr_info("%s: clear %s(%p) current process\n",
+				__func__, extra->name, dev);
+		update_currProc(extra, NULL);
+#endif
+	}
+	spin_unlock_bh(&extra->lock);
+}
+
+int rpc_intr_init(void)
+{
+	static int is_init;
+	int result = 0, i;
+	is_init = 0;
+	int j = 0;
+#ifdef CONFIG_ION_RTK
+	struct ion_handle *handle = NULL;
+	ion_phys_addr_t phys_addr;
+#endif	
+	size_t alloc_val;
+#ifdef CONFIG_ION_RTK
+	fw_rpc_ion_client = ion_client_create(rtk_phoenix_ion_device,
+						"FW_REMOTE_ALLOC");
+#endif	
+	/* Create corresponding structures for each device. */
+	rpc_intr_devices = (RPC_DEV *) AVCPU2SCPU(RPC_INTR_RECORD_ADDR);
+
+	for (i = 0; i < RPC_INTR_DEV_TOTAL; i++) {
+		pr_debug("rpc_intr_device %d addr: %p\n", i, &rpc_intr_devices[i]);
+		rpc_intr_devices[i].ringBuf = RPC_INTR_DEV_ADDR +
+				i * RPC_RING_SIZE * 2;
+
+		/* Initialize pointers... */
+		rpc_intr_devices[i].ringStart = rpc_intr_devices[i].ringBuf;
+		rpc_intr_devices[i].ringEnd = rpc_intr_devices[i].ringBuf
+				+ RPC_RING_SIZE;
+		rpc_intr_devices[i].ringIn = rpc_intr_devices[i].ringBuf;
+		rpc_intr_devices[i].ringOut = rpc_intr_devices[i].ringBuf;
+
+		pr_debug("The %dth intr dev:\n", i);
+		pr_debug("RPC ringStart: %p\n",
+				AVCPU2SCPU(rpc_intr_devices[i].ringStart));
+		pr_debug("RPC ringEnd:   %p\n",
+				AVCPU2SCPU(rpc_intr_devices[i].ringEnd));
+		pr_debug("RPC ringIn:    %p\n",
+				AVCPU2SCPU(rpc_intr_devices[i].ringIn));
+		pr_debug("RPC ringOut:   %p\n",
+				AVCPU2SCPU(rpc_intr_devices[i].ringOut));
+
+		rpc_intr_extra[i].nextRpc = rpc_intr_devices[i].ringOut;
+		rpc_intr_extra[i].currProc = NULL;
+
+		if (!is_init) {
+			rpc_intr_devices[i].ptrSync = kmalloc(sizeof(RPC_SYNC_Struct),
+					GFP_KERNEL);
+			kmemleak_not_leak(rpc_intr_devices[i].ptrSync);
+
+			/* Initialize wait queue... */
+			init_waitqueue_head(&(rpc_intr_devices[i].ptrSync->waitQueue));
+
+			/* Initialize sempahores... */
+			init_rwsem(&rpc_intr_devices[i].ptrSync->readSem);
+			init_rwsem(&rpc_intr_devices[i].ptrSync->writeSem);
+
+			rpc_intr_extra[i].dev = (void *) &rpc_intr_devices[i];
+			INIT_LIST_HEAD(&rpc_intr_extra[i].tasks);
+			tasklet_init(&rpc_intr_extra[i].tasklet, rpc_dispatch,
+					(unsigned long) &rpc_intr_extra[i]);
+			spin_lock_init(&rpc_intr_extra[i].lock);
+			switch (i) {
+			case 0:
+				rpc_intr_extra[i].name = "AudioIntrWrite";
+				break;
+			case 1:
+				rpc_intr_extra[i].name = "AudioIntrRead";
+				break;
+			case 2:
+				rpc_intr_extra[i].name = "Video1IntrWrite";
+				break;
+			case 3:
+				rpc_intr_extra[i].name = "Video1IntrRead";
+				break;
+			case 4:
+				rpc_intr_extra[i].name = "Video2IntrWrite";
+				break;
+			case 5:
+				rpc_intr_extra[i].name = "Video2IntrRead";
+				break;
+			}
+		}
+	}
+#ifdef CONFIG_ION_RTK	
+	init_waitqueue_head(&acpu_r_program_waitQueue);
+	acpu_r_program_kthread = kthread_run(acpu_remote_alloc_thread, (void *)&j, "acpu_r_program");
+
+#ifdef CONFIG_ARCH_RTD13xx
+	init_waitqueue_head(&vcpu_r_program_waitQueue);
+	vcpu_r_program_kthread = kthread_run(vcpu_remote_alloc_thread, (void *)&j, "vcpu_r_program");
+#endif
+#endif	
+	is_init = 1;
+	rpc_intr_is_paused = 0;
+	rpc_intr_is_suspend = 0;
+	pr_info("\033[31m[RTK_RPC]rpc is not paused & suspended\033[m\n");
+
+//fail:
+	return result;
+}
+
+int rpc_intr_pause(void)
+{
+	rpc_intr_is_paused = 1;
+	pr_info("\033[31mrpc is paused\033[m\n");
+	return 0;
+}
+
+int rpc_intr_suspend(void)
+{
+	rpc_intr_is_suspend = 1;
+	pr_info("\033[31mrpc is suspended\033[m\n");
+	return 0;
+}
+
+int rpc_intr_resume(void)
+{
+	rpc_intr_is_suspend = 0;
+	pr_info("\033[31mrpc is not suspended\033[m\n");
+	return 0;
+}
+
+void rpc_intr_cleanup(void)
+{
+	int i;
+
+	/* Clean corresponding structures for each device. */
+	if (rpc_intr_devices) {
+		/* Clean ring buffers. */
+		for (i = 0; i < RPC_INTR_DEV_TOTAL; i++) {
+			//if (rpc_intr_devices[i].ringBuf)
+				//kfree(rpc_intr_devices[i].ringBuf);
+			kfree(rpc_intr_devices[i].ptrSync);
+		}
+		//kfree(rpc_intr_devices);
+	}
+
+	return;
+}
+
+int rpc_intr_open(struct inode *inode, struct file *filp)
+{
+	int minor = MINOR(inode->i_rdev);
+
+	pr_debug("RPC intr open with minor number: %d\n", minor);
+
+	if (!filp->private_data) {
+		RPC_PROCESS *proc = kmalloc(sizeof(RPC_PROCESS), GFP_KERNEL | __GFP_ZERO);
+		if (proc == NULL) {
+			pr_err("%s: failed to allocate RPC_PROCESS", __func__);
+			return -ENOMEM;
+		}
+
+		proc->dev = (RPC_DEV *)&rpc_intr_devices[minor / RPC_NR_PAIR];
+		proc->extra = &rpc_intr_extra[minor / RPC_NR_PAIR];
+		/* current->tgid = process id, current->pid = thread id */
+		proc->pid = current->tgid;
+        proc->bStayActive = false;
+		init_waitqueue_head(&proc->waitQueue);
+		INIT_LIST_HEAD(&proc->threads);
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+		INIT_LIST_HEAD(&proc->handlers);
+#endif
+		spin_lock_bh(&proc->extra->lock);
+		list_add(&proc->list, &proc->extra->tasks);
+		spin_unlock_bh(&proc->extra->lock);
+		pr_debug("%s: Current process pid:%d tgid:%d => %d(%p) for %s(%p)\n",
+				__func__, current->pid, current->tgid, proc->pid,
+				&proc->waitQueue, proc->extra->name, proc->dev);
+
+		filp->private_data = proc;
+		filp->f_pos = (loff_t) minor;
+	}
+
+	/* Before we maybe sleep */
+	//MOD_INC_USE_COUNT;
+
+	return 0; /* success */
+}
+
+int rpc_intr_release(struct inode *inode, struct file *filp)
+{
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+	RPC_HANDLER *handler, *hdltmp;
+#endif /* CONFIG_REALTEK_RPC_PROGRAM_REGISTER */
+	RPC_THREAD *th, *thtmp;
+	int minor = MINOR(inode->i_rdev);
+
+	RPC_PROCESS *proc = filp->private_data;
+	RPC_DEV *dev = proc->dev; /* the first listitem */
+	RPC_DEV_EXTRA *extra = proc->extra;
+
+	if (extra->currProc == proc) {
+		pr_debug("%s: clear %s(%p) current process\n", __func__,
+				proc->extra->name, dev);
+		update_currProc(extra, NULL);
+		 /* intr read device (ugly code)*/
+		if (minor == 3 || minor == 7 || minor == 11) {
+			if (!rpc_done(extra)) {
+				pr_debug("%s: previous rpc hasn't finished, force clear!! ringOut %p => %p\n",
+						__func__, AVCPU2SCPU(dev->ringOut),
+						AVCPU2SCPU(extra->nextRpc));
+				down_write(&dev->ptrSync->readSem);
+				dev->ringOut = extra->nextRpc;
+				up_write(&dev->ptrSync->readSem);
+			}
+		}
+	}
+
+#ifdef CONFIG_SND_REALTEK
+    do {
+        if (rpc_intr_is_paused) {
+            pr_err("rpc is paused, no self destroy: %s\n", current->comm);
+            break;
+        }
+        if (proc->bStayActive) {
+            pr_err("bStayActive is true, no self destroy: %s\n", current->comm);
+            break;
+        }
+        pr_info("self destroy: %s\n", current->comm);
+        RPC_DESTROY_AUDIO_FLOW(current->tgid);
+        break;
+    } while (0);
+#endif /* CONFIG_SND_REALTEK */
+
+	spin_lock_bh(&extra->lock);
+
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+	/* unregister myself from handler list */
+	list_for_each_entry_safe(handler, hdltmp, &proc->handlers, list) {
+		list_del(&handler->list);
+		kfree(handler);
+	}
+#endif /* CONFIG_REALTEK_RPC_PROGRAM_REGISTER */
+
+	list_for_each_entry_safe(th, thtmp, &proc->threads, list) {
+		list_del(&th->list);
+		kfree(th);
+	}
+
+	/* remove myself from task list*/
+	list_del(&proc->list);
+	kfree(proc);
+
+	spin_unlock_bh(&extra->lock);
+
+	pr_debug("RPC intr close with minor number: %d\n", minor);
+
+	//MOD_DEC_USE_COUNT;
+
+	return 0;
+}
+
+/*
+ * We don't need parameter f_pos here...
+ * note:rpc_intr_read support both blocking & nonblocking modes
+ */
+ssize_t rpc_intr_read(struct file *filp, char *buf, size_t count, loff_t *f_pos)
+{
+	RPC_PROCESS *proc = filp->private_data;
+	RPC_DEV *dev = proc->dev; /* the first listitem */
+	RPC_DEV_EXTRA *extra = proc->extra;
+	int temp, size;
+	size_t r;
+	ssize_t ret = 0;
+	uint32_t ptmp;
+	int rpc_ring_size = dev->ringEnd - dev->ringStart;
+	long k;
+
+	//pr_debug("%s:%d thread:%s pid:%d tgid:%d device:%s\n",
+	//__func__, __LINE__, current->comm, current->pid, current->tgid,
+	//extra->name);
+	if (rpc_intr_is_paused) {
+		pr_err("RPCintr: someone access rpc intr during the pause...\n");
+		pr_err("%s:%d buf:%p count:%lu EAGAIN\n", extra->name, __LINE__, buf,
+				count);
+		msleep(1000);
+		return -EAGAIN;
+	}
+
+	if (need_dispatch(extra))
+		tasklet_schedule(&(extra->tasklet));
+	//pr_debug("%s: dev:%p currProc:%p\n",
+		//extra->name, dev, extra->currProc);
+	if ((extra->currProc != proc) || (ring_empty(dev))) {
+		if (filp->f_flags & O_NONBLOCK)
+			goto done;
+
+wait_again:
+
+		k = wait_event_interruptible_timeout(proc->waitQueue,
+			((extra->currProc == proc) && (!ring_empty(dev)) || proc->bExit),
+			timeout);
+		if (k == 0)
+			goto done; /* timeout */
+
+		//if (current->flags & PF_FREEZE) {
+		//refrigerator(PF_FREEZE);
+		//if (!signal_pending(current))
+			//goto wait_again;
+		//}
+
+		if (try_to_freeze()) {
+			if (!signal_pending(current))
+				goto wait_again;
+		}
+
+		if (signal_pending(current)) {
+			pr_debug("RPC deblock because of receiving a signal...\n");
+			goto done;
+		}
+
+		if (proc->bExit) {
+			pr_info("user request to exit\n");
+			goto done;
+		}
+	}
+
+	down_write(&dev->ptrSync->readSem);
+
+	if (dev->ringIn > dev->ringOut)
+		size = dev->ringIn - dev->ringOut;
+	else
+		size = rpc_ring_size + dev->ringIn - dev->ringOut;
+
+	pr_debug("%s:%d ==going read== count:%zu avail:%d "
+			"ringOut:%x ringIn:%x nextRPC:%x",
+			extra->name, __LINE__, count, size, dev->ringOut, dev->ringIn,
+			extra->nextRpc);
+	peek_rpc_struct(__func__, dev);
+
+	if (count > size)
+		count = size;
+
+
+	temp = dev->ringEnd - dev->ringOut;
+	rtk_rpc_wmb(AVCPU2SCPU(dev->ringStart), PAGE_ALIGN(rpc_ring_size));
+
+	if (temp >= count) {
+#ifdef MY_COPY
+		r = my_copy_to_user((int *)buf,
+				(int *)AVCPU2SCPU(dev->ringOut), count);
+#else
+		r = copy_to_user((int *)buf, (int *)AVCPU2SCPU(dev->ringOut), count);
+#endif /* MY_COPY */
+		if (r) {
+			pr_err("%s:%d buf:%p count:%lu EFAULT\n",
+				extra->name, __LINE__, buf, count);
+			ret = -EFAULT;
+			goto out;
+		}
+
+		ret = count;
+		ptmp = dev->ringOut + ((count+3) & 0xfffffffc);
+		if (ptmp == dev->ringEnd)
+			dev->ringOut = dev->ringStart;
+		else
+			dev->ringOut = ptmp;
+
+		//pr_debug("RPC Read is in 1st kind...\n");
+	} else {
+#ifdef MY_COPY
+		r = my_copy_to_user((int *)buf,
+				(int *)AVCPU2SCPU(dev->ringOut), temp);
+#else
+		r = copy_to_user((int *)buf,
+				(int *)AVCPU2SCPU(dev->ringOut), temp);
+#endif /* MY_COPY */
+
+		if (r) {
+			pr_err("%s:%d buf:%p count:%lu EFAULT\n",
+					extra->name, __LINE__, buf, count);
+			ret = -EFAULT;
+			goto out;
+		}
+
+		count -= temp;
+
+#ifdef MY_COPY
+		r = my_copy_to_user((int *)(buf+temp),
+				(int *)AVCPU2SCPU(dev->ringStart), count);
+#else
+		r = copy_to_user((int *)(buf+temp),
+				(int *)AVCPU2SCPU(dev->ringStart), count);
+#endif /* MY_COPY */
+
+		if (r) {
+			pr_err("%s:%d buf:%p count:%lu EFAULT\n",
+					extra->name, __LINE__, buf, count);
+			ret = -EFAULT;
+			goto out;
+		}
+		ret = (temp + count);
+		dev->ringOut = dev->ringStart+((count+3) & 0xfffffffc);
+
+		//pr_debug("RPC Read is in 2nd kind...\n");
+	}
+
+	/*
+	 * NOTE: we do not need spin lock here because we are protected by
+	 * semaphore already
+	 */
+	spin_lock_bh(&extra->lock);
+	if (rpc_done(extra) && extra->currProc == proc) {
+		pr_debug("%s: Previous RPC is done, unregister myself\n", extra->name);
+		update_currProc(extra, NULL);
+	}
+	spin_unlock_bh(&extra->lock);
+
+	/* process next rpc command if any */
+	if (need_dispatch(extra))
+		tasklet_schedule(&(extra->tasklet));
+
+	pr_debug("%s:%d pid:%d tgid:%d count:%lu actual:%ld ringOut:%x "
+			"ringIn:%x nextRpc:%x currProc:%p(%d)\n",
+			extra->name, __LINE__, current->pid, current->tgid, count, ret,
+			dev->ringOut, dev->ringIn, extra->nextRpc, extra->currProc,
+			extra->currProc ? ((RPC_PROCESS *)extra->currProc)->pid : 0);
+out:
+		up_write(&dev->ptrSync->readSem);
+done:
+		//pr_debug("RPC intr ringOut pointer is : 0x%8x\n",
+		//		(int)AVCPU2SCPU(dev->ringOut));
+		//pr_debug("%s:%d pid:%d reads %d bytes\n",
+		//		extra->name, __LINE__, current->pid, ret);
+		return ret;
+}
+
+/*
+ * We don't need parameter f_pos here...
+ * note: rpc_intr_write only support nonblocking mode
+ */
+ssize_t rpc_intr_write(struct file *filp, const char *buf, size_t count,
+		loff_t *f_pos)
+{
+	RPC_PROCESS *proc = filp->private_data;
+	RPC_DEV *dev = proc->dev; /* the first listitem */
+	RPC_DEV_EXTRA *extra = proc->extra;
+	RPC_DEV_EXTRA *rextra = extra + 1;
+	int temp, size;
+	size_t r;
+	ssize_t ret = 0;
+	uint32_t ptmp;
+	int rpc_ring_size = dev->ringEnd - dev->ringStart;
+
+	//pr_debug("%s:%d buf:%p count:%u\n", __func__, __LINE__, buf, count);
+
+	if (rpc_intr_is_paused) {
+		pr_err("RPCintr: someone access rpc intr during the pause...\n");
+		pr_err("%s:%d buf:%p count:%lu EAGAIN\n", __func__, __LINE__, buf,
+				count);
+		msleep(1000);
+		return -EAGAIN;
+	}
+
+	down_write(&dev->ptrSync->writeSem);
+
+#if 1
+	/*
+	 * Threads that share the same file descriptor should have the same tgid
+	 * However, with uClibc pthread library, pthread_create() creates threads
+	 * with pid == tgid So the tgid is not real tgid, we have to maintain the
+	 * thread list that we can lookup later
+	 */
+	if (current->pid != proc->pid)
+		update_thread_list(rextra, proc->pid);
+#endif
+
+	if (ring_empty(dev))
+		size = 0; /* the ring is empty */
+	else if (dev->ringIn > dev->ringOut)
+		size = dev->ringIn - dev->ringOut;
+	else
+		size = rpc_ring_size + dev->ringIn - dev->ringOut;
+
+	//pr_debug("%s: count:%d space:%d\n",
+	//		extra->name, count, rpc_ring_size - size - 1);
+	//pr_debug("%s: pid:%d tgid:%d\n",
+	//		extra->name, current->pid, current->tgid);
+
+	if (count > (rpc_ring_size - size - 1))
+		goto out;
+
+#if 0
+	if (access_ok(VERIFY_READ, buf, sizeof(RPC_STRUCT))) {
+		RPC_STRUCT *rpc = (RPC_STRUCT *)buf;
+		uint32_t programID = ntohl(rpc->programID);
+
+		if (programID == AUDIO_SYSTEM || programID == REPLYID || programID == 97) {
+			rpc->versionID = htonl(readl(rpc_refclk_base));
+		} else {
+			pr_warn("%s: invalid programID:%u\n", __func__, programID);
+		}
+	}
+#endif
+
+	temp = dev->ringEnd - dev->ringIn;
+
+	if (temp >= count) {
+#ifdef MY_COPY
+		r = my_copy_from_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, count);
+#else
+		r = copy_from_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, count);
+#endif /* MY_COPY */
+
+		if (r) {
+			pr_err("%s:%d buf:%p count:%lu EFAULT\n",
+					__func__, __LINE__, buf, count);
+			ret = -EFAULT;
+			goto out;
+		}
+
+		ret += count;
+		ptmp = dev->ringIn + ((count+3) & 0xfffffffc);
+
+		//asm("DSB");
+		mb();
+
+		if (ptmp == dev->ringEnd)
+			dev->ringIn = dev->ringStart;
+		else
+			dev->ringIn = ptmp;
+
+		//pr_debug("RPC Write is in 1st kind...\n");
+	} else {
+#ifdef MY_COPY
+			r = my_copy_from_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, temp);
+#else
+			r = copy_from_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, temp);
+#endif /* MY_COPY */
+			if (r) {
+				pr_err("%s:%d buf:%p count:%lu EFAULT\n",
+				__func__, __LINE__, buf, count);
+				ret = -EFAULT;
+				goto out;
+			}
+			count -= temp;
+
+#ifdef MY_COPY
+			r = my_copy_from_user((int *)AVCPU2SCPU(dev->ringStart), (int *)(buf+temp), count);
+#else
+			r = copy_from_user((int *)AVCPU2SCPU(dev->ringStart), (int *)(buf+temp), count);
+#endif /* MY_COPY */
+			if (r) {
+				pr_err("%s:%d buf:%p count:%lu EFAULT\n",
+						__func__, __LINE__, buf, count);
+				ret = -EFAULT;
+				goto out;
+			}
+			ret += (temp + count);
+
+			//asm("DSB");
+			mb();
+
+			dev->ringIn = dev->ringStart+((count+3) & 0xfffffffc);
+			//pr_debug("RPC Write is in 2nd kind...\n");
+	}
+
+	peek_rpc_struct(__func__, dev);
+	rtk_rpc_wmb(AVCPU2SCPU(dev->ringStart),
+			PAGE_ALIGN(rpc_ring_size));
+
+	/* notify all the processes in the wait queue */
+	//wake_up_interruptible(&dev->waitQueue);
+
+	/* use the "f_pos" of file object to store the device number */
+	temp = (int) *f_pos;
+		//if (temp == 1)
+	if (temp == 1) {
+		rpc_send_interrupt(RPC_AUDIO);
+	} else if (temp == 5) {
+		rpc_send_interrupt(RPC_VIDEO);
+	} else {
+		pr_err("error device number...");
+	}
+
+	pr_debug("%s:%d thread:%s pid:%d tgid:%d device:%s\n",
+			__func__, __LINE__, current->comm, current->pid,
+			current->tgid, extra->name);
+	pr_debug("%s:%d buf:%p count:%lu actual:%ld\n",
+			__func__, __LINE__, buf, count, ret);
+out:
+		//pr_debug("RPC intr ringIn pointer is : 0x%8x\n",
+		//		(int)AVCPU2SCPU(dev->ringIn));
+	up_write(&dev->ptrSync->writeSem);
+	return ret;
+}
+
+long rpc_intr_ioctl(struct file *filp, unsigned int cmd,
+			unsigned long arg)
+{
+		int ret = 0;
+
+		while (rpc_intr_is_suspend) {
+			pr_warn("RPCintr: someone access rpc poll during the suspend!!!...\n");
+			msleep(1000);
+		}
+
+		switch (cmd) {
+		case RPC_IOCTTIMEOUT:
+			timeout = arg;
+			break;
+		case RPC_IOCQTIMEOUT:
+			return timeout;
+		case RPC_IOCTEXITLOOP: {
+			RPC_PROCESS *proc = filp->private_data;
+			proc->bExit = true;
+			wake_up_interruptible(&proc->waitQueue);
+			return 0;
+		}
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+		case RPC_IOCTHANDLER: {
+			int found;
+			RPC_PROCESS *proc = filp->private_data;
+			RPC_DEV_EXTRA *extra = proc->extra;
+			RPC_HANDLER *handler;
+
+			pr_debug("%s:%d : Register handler for programID:%lu\n",
+					__func__, __LINE__, arg);
+			found = 0;
+			list_for_each_entry(handler, &proc->handlers, list) {
+				if (handler->programID == arg) {
+					found = 1;
+					break;
+				}
+			}
+
+			if (found)
+				break;
+
+			/* not found, add to handler list */
+			handler = kmalloc(sizeof(RPC_HANDLER), GFP_KERNEL);
+			if (handler == NULL) {
+				pr_err("%s: failed to allocate RPC_HANDLER", __func__);
+				return -ENOMEM;
+			}
+			handler->programID = arg;
+			spin_lock_bh(&extra->lock);
+			list_add(&handler->list, &proc->handlers);
+			spin_unlock_bh(&extra->lock);
+			pr_debug("%s:%d %s: Add handler pid:%d for programID:%lu\n",
+					__func__, __LINE__, proc->extra->name, proc->pid, arg);
+			break;
+		}
+#endif /* CONFIG_REALTEK_RPC_PROGRAM_REGISTER */
+        case RPC_IOC_PROCESS_CONFIG_0:
+                              {
+                                  RPC_PROCESS *proc = filp->private_data;
+                                  struct S_RPC_IOC_PROCESS_CONFIG_0 config;
+                                  if (copy_from_user(&config, (void __user *)arg, sizeof(struct S_RPC_IOC_PROCESS_CONFIG_0))) {
+                                      pr_err("ERROR! %s cmd:RPC_IOC_PROCESS_CONFIG_0 copy_from_user failed\n", __func__);
+                                      return -ENOMEM;
+                                  }
+                                  if (proc == NULL) {
+                                      pr_err("ERROR! %s cmd:RPC_IOC_PROCESS_CONFIG_0 proc:%p\n", __func__, proc);
+                                      return -ENOMEM;
+                                  }
+                                  proc->bStayActive = (config.bStayActive > 0) ? true : false;
+                                  break;
+                              }
+		default: /* redundant, as cmd was checked against MAXNR */
+			pr_err("%s:%d unsupported ioctl cmd:%x arg:%lx", __func__,
+					__LINE__, cmd, arg);
+			return -ENOTTY;
+		}
+
+		return ret;
+}
+
+struct file_operations rpc_intr_fops = {
+	//.llseek = scull_llseek,
+	.unlocked_ioctl = rpc_intr_ioctl,
+	.compat_ioctl = rpc_intr_ioctl,
+	.read = rpc_intr_read,
+	.write = rpc_intr_write,
+	.open = rpc_intr_open,
+	.release = rpc_intr_release,
+};
diff --git a/drivers/soc/realtek/common/rpc/rtk_rpc_kern.c b/drivers/soc/realtek/common/rpc/rtk_rpc_kern.c
new file mode 100644
index 00000000..69b08bdb
--- /dev/null
+++ b/drivers/soc/realtek/common/rpc/rtk_rpc_kern.c
@@ -0,0 +1,565 @@
+/*
+ * Realtek RPC driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/slab.h>
+#include <linux/fs.h>
+#include <linux/errno.h>
+#include <linux/types.h>
+#include <linux/proc_fs.h>
+#include <linux/fcntl.h>
+#include <linux/ioctl.h>
+#include <linux/sched.h>
+#include <linux/freezer.h>
+#include <linux/delay.h>
+#include <linux/kthread.h>
+#include <linux/io.h>
+#include <linux/uaccess.h>
+
+#include "rtk_rpc.h"
+
+#define TIMEOUT (5*HZ)
+
+static struct radix_tree_root kernel_rpc_tree = RADIX_TREE_INIT(GFP_ATOMIC);
+//static struct semaphore kernel_rpc_sem;
+DECLARE_RWSEM(kernel_rpc_sem);
+
+//static DECLARE_MUTEX(kernel_rpc_sem);
+
+volatile RPC_DEV *rpc_kern_devices;
+struct task_struct *rpc_kthread[RPC_NR_KERN_DEVS/RPC_NR_PAIR] = {NULL};
+static wait_queue_head_t rpc_wq[RPC_NR_KERN_DEVS/RPC_NR_PAIR];
+static uint32_t *rpc_retval[RPC_NR_KERN_DEVS/RPC_NR_PAIR] = {NULL};
+int rpc_kern_is_paused;
+int rpc_kern_is_suspend;
+static int complete_condition[RPC_NR_KERN_DEVS/RPC_NR_PAIR];
+static struct mutex rpc_kern_lock[RPC_NR_KERN_DEVS/RPC_NR_PAIR];
+static int rpc_kernel_thread(void *p);
+
+extern void rpc_send_interrupt(int type);
+
+int rpc_kern_init(void)
+{
+	static int is_init;
+	int result = 0, num;
+	unsigned long i;
+
+	is_init = 0;
+
+	/* Create corresponding structures for each device. */
+	rpc_kern_devices = (RPC_DEV *)AVCPU2SCPU(RPC_KERN_RECORD_ADDR);
+
+	num = RPC_NR_KERN_DEVS;
+	for (i = 0; i < num; i++) {
+		pr_debug("rpc_kern_device %lu addr: %p\n", i, &rpc_kern_devices[i]);
+		rpc_kern_devices[i].ringBuf = RPC_KERN_DEV_ADDR + i*RPC_RING_SIZE;
+
+		/* Initialize pointers... */
+		rpc_kern_devices[i].ringStart = rpc_kern_devices[i].ringBuf;
+		rpc_kern_devices[i].ringEnd =
+				rpc_kern_devices[i].ringBuf + RPC_RING_SIZE;
+		rpc_kern_devices[i].ringIn = rpc_kern_devices[i].ringBuf;
+		rpc_kern_devices[i].ringOut = rpc_kern_devices[i].ringBuf;
+
+		pr_debug("The %luth kern dev:\n", i);
+		pr_debug("RPC ringStart: %p\n",
+				AVCPU2SCPU(rpc_kern_devices[i].ringStart));
+		pr_debug("RPC ringEnd:   %p\n",
+				AVCPU2SCPU(rpc_kern_devices[i].ringEnd));
+		pr_debug("RPC ringIn:	%p\n",
+				AVCPU2SCPU(rpc_kern_devices[i].ringIn));
+		pr_debug("RPC ringOut:   %p\n",
+				AVCPU2SCPU(rpc_kern_devices[i].ringOut));
+		pr_debug("\n");
+
+		if (!is_init) {
+			rpc_kern_devices[i].ptrSync =
+					kmalloc(sizeof(RPC_SYNC_Struct), GFP_KERNEL);
+			kmemleak_not_leak(rpc_kern_devices[i].ptrSync);
+
+			/* Initialize wait queue... */
+			init_waitqueue_head(&(rpc_kern_devices[i].ptrSync->waitQueue));
+
+			/* Initialize sempahores... */
+			init_rwsem(&rpc_kern_devices[i].ptrSync->readSem);
+			init_rwsem(&rpc_kern_devices[i].ptrSync->writeSem);
+		}
+
+		if (i%RPC_NR_PAIR == 1) {
+			if (rpc_kthread[i/RPC_NR_PAIR] == NULL)
+				rpc_kthread[i/RPC_NR_PAIR] =
+						kthread_run(rpc_kernel_thread,
+								(void *)i, "rpc-%lu", i);
+		}
+	}
+	if (!is_init) {
+		for (i = 0; i < RPC_NR_KERN_DEVS/RPC_NR_PAIR; i++) {
+			init_waitqueue_head(&(rpc_wq[i]));
+			mutex_init(&rpc_kern_lock[i]);
+		}
+	}
+	is_init = 1;
+	rpc_kern_is_paused = 0;
+	rpc_kern_is_suspend = 0;
+
+	return result;
+}
+
+int rpc_kern_pause(void)
+{
+	rpc_kern_is_paused = 1;
+	return 0;
+}
+
+int rpc_kern_suspend(void)
+{
+	rpc_kern_is_suspend = 1;
+	return 0;
+}
+
+int rpc_kern_resume(void)
+{
+	rpc_kern_is_suspend = 0;
+	return 0;
+}
+
+ssize_t rpc_kern_read(int opt, char *buf, size_t count)
+{
+	RPC_DEV *dev;
+	int temp, size;
+	size_t r;
+	ssize_t ret = 0;
+	uint32_t ptmp;
+
+	dev = (RPC_DEV *)&rpc_kern_devices[opt*RPC_NR_PAIR+1];
+	pr_debug("read rpc_kern_device: %p\n", dev);
+	down_write(&dev->ptrSync->readSem);
+
+	if (dev->ringIn == dev->ringOut)
+		goto out;   // the ring is empty...
+	else if (dev->ringIn > dev->ringOut)
+		size = dev->ringIn - dev->ringOut;
+	else
+		size = RPC_RING_SIZE + dev->ringIn - dev->ringOut;
+
+	if (count > size)
+		count = size;
+
+	temp = dev->ringEnd - dev->ringOut;
+	if (temp >= count) {
+#ifdef MY_COPY
+		r = my_copy_user((int *)buf,
+				(int *)AVCPU2SCPU(dev->ringOut), count);
+#else
+		r = ((int *)buf !=
+				memcpy((int *)buf, (int *)AVCPU2SCPU(dev->ringOut), count));
+#endif /* MY_COPY */
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+		ret += count;
+		ptmp = dev->ringOut + ((count+3) & 0xfffffffc);
+		if (ptmp == dev->ringEnd)
+			dev->ringOut = dev->ringStart;
+		else
+			dev->ringOut = ptmp;
+
+		pr_debug("RPC Read is in 1st kind...\n");
+	} else {
+#ifdef MY_COPY
+		r = my_copy_user((int *)buf, (int *)AVCPU2SCPU(dev->ringOut), temp);
+#else
+		r = ((int *)buf !=
+				memcpy((int *)buf, (int *)AVCPU2SCPU(dev->ringOut), temp));
+#endif /* MY_COPY */
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+		count -= temp;
+
+#ifdef MY_COPY
+		r = my_copy_user((int *)(buf+temp),
+				(int *)AVCPU2SCPU(dev->ringStart), count);
+#else
+		r = ((int *)(buf+temp) !=
+				memcpy((int *)(buf+temp),
+						(int *)AVCPU2SCPU(dev->ringStart), count));
+#endif /* MY_COPY */
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+		ret += (temp + count);
+		dev->ringOut = dev->ringStart+((count+3) & 0xfffffffc);
+
+		pr_debug("RPC Read is in 2nd kind...\n");
+	}
+out:
+	pr_debug("RPC kern ringOut pointer is : %p\n", AVCPU2SCPU(dev->ringOut));
+	up_write(&dev->ptrSync->readSem);
+	return ret;
+}
+
+ssize_t rpc_kern_write(int opt, const char *buf, size_t count)
+{
+	RPC_DEV *dev;
+	int temp, size;
+	size_t r;
+	ssize_t ret = 0;
+	uint32_t ptmp;
+
+	dev = (RPC_DEV *)&rpc_kern_devices[opt*RPC_NR_PAIR];
+	pr_debug("write rpc_kern_device: %p\n", dev);
+	//pr_debug("[rpc_kern_write] write rpc_kern_device: caller%x, *buf:0x%x\n",
+	//		(unsigned int) __read_32bit_caller_register(),
+	//		*(unsigned int *)buf);
+	down_write(&dev->ptrSync->writeSem);
+
+	if (dev->ringIn == dev->ringOut)
+		size = 0;   // the ring is empty
+	else if (dev->ringIn > dev->ringOut)
+		size = dev->ringIn - dev->ringOut;
+	else
+		size = RPC_RING_SIZE + dev->ringIn - dev->ringOut;
+
+	if (count > (RPC_RING_SIZE - size - 1))
+		goto out;
+
+	temp = dev->ringEnd - dev->ringIn;
+	if (temp >= count) {
+#ifdef MY_COPY
+		r = my_copy_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, count);
+#else
+		r = ((int *)AVCPU2SCPU(dev->ringIn) !=
+				memcpy((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, count));
+#endif /* MY_COPY */
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+		ret += count;
+		ptmp = dev->ringIn + ((count+3) & 0xfffffffc);
+
+		//asm("DSB");
+		mb();
+
+		if (ptmp == dev->ringEnd)
+			dev->ringIn = dev->ringStart;
+		else
+			dev->ringIn = ptmp;
+
+		pr_debug("RPC Write is in 1st kind...\n");
+	} else {
+#ifdef MY_COPY
+		r = my_copy_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, temp);
+#else
+		r = ((int *)AVCPU2SCPU(dev->ringIn) !=
+				memcpy((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, temp));
+#endif
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+		count -= temp;
+
+#ifdef MY_COPY
+		r = my_copy_user((int *)AVCPU2SCPU(dev->ringStart),
+				(int *)(buf+temp), count);
+#else
+		r = ((int *)AVCPU2SCPU(dev->ringStart) != memcpy((int *)AVCPU2SCPU(dev->ringStart), (int *)(buf+temp), count));
+#endif
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+		ret += (temp + count);
+
+		//asm("DSB");
+		mb();
+
+		dev->ringIn = dev->ringStart+((count+3) & 0xfffffffc);
+
+		pr_debug("RPC Write is in 2nd kind...\n");
+	}
+
+	//if (opt == RPC_AUDIO)
+	if (opt == RPC_AUDIO) {
+		rpc_send_interrupt(RPC_AUDIO);
+	} else if (opt == RPC_VIDEO) {
+		rpc_send_interrupt(RPC_VIDEO);
+	} else {
+		pr_err("error device number...\n");
+	}
+out:
+	pr_debug("RPC kern ringIn pointer is : %p\n", AVCPU2SCPU(dev->ringIn));
+	up_write(&dev->ptrSync->writeSem);
+	return ret;
+}
+
+#if 0
+int register_kernel_rpc(unsigned long command, FUNC_PTR ptr)
+{
+	int error;
+
+	error = radix_tree_preload(GFP_KERNEL);
+	if (error == 0) {
+		down_write(&kernel_rpc_sem);
+		error = radix_tree_insert(&kernel_rpc_tree, command, (void *)ptr);
+		if (error)
+			pr_err("RPC: register kernel rpc %ld error...\n", command);
+		up_write(&kernel_rpc_sem);
+		radix_tree_preload_end();
+	}
+
+	return error;
+}
+#endif
+
+uint32_t handle_command(uint32_t command, uint32_t param1, uint32_t param2)
+{
+	FUNC_PTR ptr;
+	int ret = 0;
+
+	pr_info("Handle command %x, param1: %x, param2: %x...\n",
+			command, param1, param2);
+	down_write(&kernel_rpc_sem);
+	ptr = radix_tree_lookup(&kernel_rpc_tree, command);
+	if (ptr)
+		ret = ptr(param1, param2);
+	else
+		pr_err("RPC: lookup kernel rpc %d error...\n", command);
+	up_write(&kernel_rpc_sem);
+
+	return ret;
+}
+
+static int rpc_kernel_thread(void *p)
+{
+	char readbuf[sizeof(RPC_STRUCT) + 3*sizeof(uint32_t)];
+	RPC_DEV *dev;
+	RPC_STRUCT *rpc;
+	uint32_t *tmp;
+	unsigned long idx = (unsigned long)p;
+	unsigned int opt = idx / RPC_NR_PAIR;
+
+	//daemonize(current->comm);
+
+	dev = (RPC_DEV *)&rpc_kern_devices[idx];
+	while (1) {
+		//if (current->flags & PF_FREEZE)
+		//refrigerator(PF_FREEZE);
+		//try_to_freeze();
+
+		//pr_info(" #@# wait %s %x %x \n", current->comm, dev, dev->waitQueue);
+		if (wait_event_interruptible(dev->ptrSync->waitQueue, dev->ringIn !=
+				dev->ringOut || kthread_should_stop())) {
+			pr_notice("%s got signal or should stop...\n", current->comm);
+			continue;
+		}
+		//pr_info(" #@# wakeup %s \n", current->comm);
+
+		if (kthread_should_stop()) {
+			pr_notice("%s exit...\n", current->comm);
+			break;
+		}
+
+		/* read the reply data... */
+		if (rpc_kern_read(opt, readbuf, sizeof(RPC_STRUCT)) !=
+				sizeof(RPC_STRUCT)) {
+			pr_err("ERROR in read kernel RPC...\n");
+			continue;
+		}
+
+		rpc = (RPC_STRUCT *)readbuf;
+		tmp = (uint32_t *)(readbuf + sizeof(RPC_STRUCT));
+		if (rpc->taskID) {
+			/* handle the request... */
+			char replybuf[sizeof(RPC_STRUCT) + 2*sizeof(uint32_t)];
+			uint32_t ret;
+			RPC_STRUCT *rrpc = (RPC_STRUCT *)replybuf;
+
+			/* read the payload... */
+			if (rpc_kern_read(opt, readbuf + sizeof(RPC_STRUCT),
+					3*sizeof(uint32_t)) != 3*sizeof(uint32_t)) {
+				pr_err("ERROR in read payload...\n");
+				continue;
+			}
+
+			ret = handle_command(ntohl(*tmp),
+					ntohl(*(tmp+1)), ntohl(*(tmp+2)));
+
+			/* fill the RPC_STRUCT... */
+			rrpc->programID = htonl(REPLYID);
+			rrpc->versionID = htonl(REPLYID);
+			rrpc->procedureID = 0;
+			rrpc->taskID = 0;
+#ifdef RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID
+			rrpc->sysTID = 0;
+#endif /* RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID */
+			rrpc->sysPID = 0;
+			rrpc->parameterSize = htonl(2*sizeof(uint32_t));
+			rrpc->mycontext = rpc->mycontext;
+
+			/* fill the parameters... */
+			tmp = (uint32_t *)(replybuf + sizeof(RPC_STRUCT));
+			*(tmp+0) = rpc->taskID; /* FIXME: should be 64bit */
+			*(tmp+1) = htonl(ret);
+
+			if (rpc_kern_write(opt, replybuf, sizeof(replybuf)) !=
+					sizeof(replybuf)) {
+				pr_err("ERROR in send kernel RPC...\n");
+				return RPC_FAIL;
+			}
+		} else {
+			/* read the payload... */
+			if (rpc_kern_read(opt, readbuf+sizeof(RPC_STRUCT),
+					2*sizeof(uint32_t)) != 2*sizeof(uint32_t)) {
+				pr_err("ERROR in read payload...\n");
+				continue;
+			}
+
+			/* parse the reply data... */
+#if 0
+			/* FIXME: mycontext should be 64bit */
+			*((uint32_t *)ntohl(rpc->mycontext)) = ntohl(*(tmp+1));
+#else
+			*rpc_retval[opt] = ntohl(*(tmp+1));
+#endif
+			//pr_info("tmp %x opt %d\n", ntohl(*tmp), opt);
+			complete_condition[opt] = 1;
+#if 0
+			/* FIXME: wait_queue_head_t * should be 64bit */
+			//wake_up((wait_queue_head_t *)ntohl(*tmp)); /* ack the sync... */
+#else
+			wake_up(&rpc_wq[opt]); // ack the sync...
+#endif
+		}
+	}
+
+	return 0;
+}
+
+int dump_kern_rpc(void)
+{
+    int i, j;
+    RPC_DEV *dev;
+    for(j = 0; j < RPC_NR_KERN_DEVS/RPC_NR_PAIR; j++){
+        dev = (RPC_DEV *)&rpc_kern_devices[j];
+        pr_info("\nname: KernAudio%s\n", (j % RPC_NR_PAIR == 0) ? "Write" : "Read");
+        pr_info("RingBuf: %x\n", dev->ringBuf);
+        pr_info("RingStart: %x\n", dev->ringStart);
+        pr_info("RingIn: %x\n", dev->ringIn);
+        pr_info("RingOut: %x\n", dev->ringOut);
+        pr_info("RingEnd: %x\n", dev->ringEnd);
+
+        pr_info("RingBuffer:\n");
+        for (i = 0; i < RPC_RING_SIZE; i += 16) {
+            uint32_t *addr = (uint32_t *)(AVCPU2SCPU(dev->ringStart) + i);
+            pr_info("%x: %08x %08x %08x %08x\n",
+                    dev->ringStart + i,
+                    ntohl(*(addr + 0)),
+                    ntohl(*(addr + 1)),
+                    ntohl(*(addr + 2)),
+                    ntohl(*(addr + 3)));
+        }
+    }
+    return 0;
+}
+
+int send_rpc_command(int opt, uint32_t command, uint32_t param1,
+		uint32_t param2, uint32_t *retvalue)
+{
+	char sendbuf[sizeof(RPC_STRUCT) + 3*sizeof(uint32_t)];
+	RPC_STRUCT *rpc = (RPC_STRUCT *)sendbuf;
+	uint32_t *tmp;
+
+	if (rpc_kern_is_paused) {
+		pr_warn("RPCkern: someone access rpc kern during the pause...\n");
+		return RPC_FAIL;
+	}
+
+	mutex_lock(&rpc_kern_lock[opt]);
+
+	while (rpc_kern_is_suspend) {
+		pr_warn("RPCkern: someone access rpc poll during the suspend!!!...\n");
+		msleep(1000);
+	}
+
+	if (rpc_kthread[opt] == 0) {
+		pr_warn("RPCkern: %s is disabled...\n", rpc_kthread[opt]->comm);
+		mutex_unlock(&rpc_kern_lock[opt]);
+		return RPC_FAIL;
+	}
+
+	//pr_info(" #@# sendbuf: %d cmd %x param1 %x param2 %x\n",
+	//		sizeof(sendbuf), command, param1, param2);
+
+	/* fill the RPC_STRUCT... */
+	rpc->programID = htonl(KERNELID);
+	rpc->versionID = htonl(KERNELID);
+	rpc->procedureID = 0;
+#if 0
+	/* FIXME: should be 64bit */
+	/* using taskID to store wait queue address */
+	rpc->taskID = htonl((uint32_t)&rpc_wq[opt]);
+#else
+	//rpc->taskID = 0;
+	rpc->taskID = htonl(current->pid);// 0;
+#endif
+#ifdef RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID
+	rpc->sysTID = 0;
+#endif /* RPC_SUPPORT_MULTI_CALLER_SEND_TID_PID */
+	rpc->sysPID = 0;
+	rpc->parameterSize = htonl(3*sizeof(uint32_t));
+#if 0
+	/* FIXME: mycontext should be 64bit */
+	rpc->mycontext = htonl((uint32_t)retvalue);
+#else
+	rpc->mycontext = 0;
+	rpc_retval[opt] = retvalue;
+#endif
+
+	/* fill the parameters... */
+	tmp = (uint32_t *)(sendbuf+sizeof(RPC_STRUCT));
+	//pr_info(" aaa: %x bbb: %x \n", sendbuf, tmp);
+	*tmp = htonl(command);
+	*(tmp+1) = htonl(param1);
+	*(tmp+2) = htonl(param2);
+
+	complete_condition[opt] = 0;
+	if (rpc_kern_write(opt, sendbuf, sizeof(sendbuf)) != sizeof(sendbuf)) {
+		pr_err("ERROR in send kernel RPC...\n");
+		mutex_unlock(&rpc_kern_lock[opt]);
+		return RPC_FAIL;
+	}
+
+	/* wait the result... */
+	//if (!sleep_on_timeout(&rpc_wq[opt], TIMEOUT)) {
+	if (!wait_event_timeout(rpc_wq[opt], complete_condition[opt], TIMEOUT)) {
+		pr_err("kernel rpc timeout -> disable %s...\n", rpc_kthread[opt]->comm);
+		WARN(1, " #@# sendbuf: size%lu cmd:%x param1:%x param2:%x\n",
+				sizeof(sendbuf), command, param1, param2);
+		dump_kern_rpc();
+
+		kthread_stop(rpc_kthread[opt]);
+		rpc_kthread[opt] = 0;
+		mutex_unlock(&rpc_kern_lock[opt]);
+		return RPC_FAIL;
+	} else {
+		pr_debug(" #@# ret: %d \n", *retvalue);
+		mutex_unlock(&rpc_kern_lock[opt]);
+		return RPC_OK;
+	}
+}
+EXPORT_SYMBOL(send_rpc_command);
diff --git a/drivers/soc/realtek/common/rpc/rtk_rpc_poll.c b/drivers/soc/realtek/common/rpc/rtk_rpc_poll.c
new file mode 100644
index 00000000..ef9f33e
--- /dev/null
+++ b/drivers/soc/realtek/common/rpc/rtk_rpc_poll.c
@@ -0,0 +1,775 @@
+/*
+ * Realtek RPC driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/slab.h>
+#include <linux/fs.h>
+#include <linux/errno.h>
+#include <linux/types.h>
+#include <linux/proc_fs.h>
+#include <linux/fcntl.h>
+#include <linux/ioctl.h>
+#include <linux/delay.h>
+#include <linux/dma-mapping.h>
+#include <linux/uaccess.h>
+
+#include "rtk_rpc.h"
+#ifdef CONFIG_ION_RTK /*ion is unavailable if RTD1295 purenas*/
+#include "../../../../drivers/staging/android/ion/ion.h"
+#include "../../../../drivers/staging/android/uapi/ion_rtk.h"
+extern struct ion_device *rtk_phoenix_ion_device;
+#endif
+
+volatile RPC_DEV *rpc_poll_devices;
+
+#ifdef CONFIG_REALTEK_RPC_KCPU
+volatile RPC_DEV *rpc_poll_kcpu_devices;
+#endif
+
+int rpc_poll_is_paused;
+int rpc_poll_is_suspend;
+
+#ifndef CONFIG_ION_RTK /*ion is unavailable if RTD1295 purenas*/
+static unsigned int *DbgFlag_A;
+static unsigned int phy_DbgFlag_A;
+#endif
+
+#ifdef CONFIG_ION_RTK /*ion is unavailable if RTD1295 purenas*/
+static struct rpc_debug_flag {
+    unsigned int acpu;
+    unsigned int reserve_acpu[127];
+    unsigned int vcpu;
+    unsigned int reserve_vcpu[127];
+};
+
+static struct rpc_debug_flag_memory {
+    struct ion_client * client;
+    struct ion_handle * handle;
+    struct rpc_debug_flag * debug_flag;
+    ion_phys_addr_t         debug_phys;
+    size_t                  debug_size;
+};
+
+static struct rpc_debug_flag_memory * mDebugFlagMemory = NULL;
+static struct rpc_debug_flag_memory * get_debug_flag_memory(void)
+{
+    do {
+        if (mDebugFlagMemory == NULL) {
+            struct rpc_debug_flag_memory * tmp = (struct rpc_debug_flag_memory *) kzalloc(
+                    sizeof(struct rpc_debug_flag_memory), GFP_KERNEL);
+            if (tmp == NULL)
+                break;
+
+            tmp->client = ion_client_create(rtk_phoenix_ion_device, "rtk_rpc");
+            if (IS_ERR(tmp->client)) {
+                kfree(tmp);
+                break;
+            }
+
+            unsigned int ion_flag_mask = ION_FLAG_NONCACHED | ION_USAGE_MMAP_NONCACHED;
+            ion_flag_mask |= ION_FLAG_SCPUACC | ION_FLAG_ACPUACC;
+#ifdef CONFIG_ARCH_RTD13xx
+            ion_flag_mask |= ION_FLAG_VCPU_FWACC;
+#endif
+            tmp->handle = ion_alloc(tmp->client, sizeof(struct rpc_debug_flag), 0 /*align*/,
+                    RTK_PHOENIX_ION_HEAP_AUDIO_MASK, ion_flag_mask);
+
+            if (IS_ERR(tmp->handle))
+                tmp->handle = ion_alloc(tmp->client, sizeof(struct rpc_debug_flag), 0 /*align*/,
+                        RTK_PHOENIX_ION_HEAP_MEDIA_MASK, ion_flag_mask);
+
+            if (IS_ERR(tmp->handle)) {
+                ion_client_destroy(tmp->client);
+                kfree(tmp);
+                break;
+            }
+
+            if (ion_phys(tmp->client, tmp->handle, &tmp->debug_phys, &tmp->debug_size) != 0) {
+                ion_free(tmp->client, tmp->handle);
+                ion_client_destroy(tmp->client);
+                kfree(tmp);
+                break;
+            }
+
+            tmp->debug_flag = (struct rpc_debug_flag *) ion_map_kernel(tmp->client, tmp->handle);
+
+            mDebugFlagMemory = tmp;
+        }
+    } while (0);
+    return mDebugFlagMemory;
+}
+
+static struct rpc_debug_flag * get_debug_flag(void)
+{
+    struct rpc_debug_flag_memory * debug_memory = get_debug_flag_memory();
+    return (debug_memory) ? debug_memory->debug_flag : NULL;
+}
+
+static ion_phys_addr_t * get_debug_flag_phyAddr(void)
+{
+    struct rpc_debug_flag_memory * debug_memory = get_debug_flag_memory();
+    return (debug_memory) ? debug_memory->debug_phys : -1UL;
+}
+#endif
+RPC_DEV_EXTRA rpc_poll_extra[RPC_NR_DEVS/RPC_NR_PAIR];
+
+int rpc_poll_init(void)
+{
+	static int is_init;
+	int result = 0, i;
+
+	is_init = 0;
+
+	/* Create corresponding structures for each device. */
+	rpc_poll_devices = (RPC_DEV *)AVCPU2SCPU(RPC_POLL_RECORD_ADDR);
+
+	for (i = 0; i < RPC_INTR_DEV_TOTAL; i++) {
+		pr_debug("rpc_poll_device %d addr: %p\n", i, &rpc_poll_devices[i]);
+		rpc_poll_devices[i].ringBuf = RPC_POLL_DEV_ADDR + i*RPC_RING_SIZE*2;
+
+		/* Initialize pointers... */
+		rpc_poll_devices[i].ringStart = rpc_poll_devices[i].ringBuf;
+		rpc_poll_devices[i].ringEnd   = rpc_poll_devices[i].ringBuf + RPC_RING_SIZE;
+		rpc_poll_devices[i].ringIn	= rpc_poll_devices[i].ringBuf;
+		rpc_poll_devices[i].ringOut   = rpc_poll_devices[i].ringBuf;
+
+		pr_debug("The %dth poll dev:\n", i);
+		pr_debug("RPC ringStart: %p\n", AVCPU2SCPU(rpc_poll_devices[i].ringStart));
+		pr_debug("RPC ringEnd:   %p\n", AVCPU2SCPU(rpc_poll_devices[i].ringEnd));
+		pr_debug("RPC ringIn:	%p\n", AVCPU2SCPU(rpc_poll_devices[i].ringIn));
+		pr_debug("RPC ringOut:   %p\n", AVCPU2SCPU(rpc_poll_devices[i].ringOut));
+		pr_debug("\n");
+
+		rpc_poll_extra[i].nextRpc = rpc_poll_devices[i].ringOut;
+		rpc_poll_extra[i].currProc = NULL;
+
+		if (!is_init) {
+			rpc_poll_devices[i].ptrSync = kmalloc(sizeof(RPC_SYNC_Struct), GFP_KERNEL);
+			kmemleak_not_leak(rpc_poll_devices[i].ptrSync);
+
+			/* Initialize wait queue... */
+			//init_waitqueue_head(&(rpc_poll_devices[i].ptrSync->waitQueue));
+
+			/* Initialize sempahores... */
+			init_rwsem(&rpc_poll_devices[i].ptrSync->readSem);
+			init_rwsem(&rpc_poll_devices[i].ptrSync->writeSem);
+
+			rpc_poll_extra[i].dev = (void *)&rpc_poll_devices[i];
+			INIT_LIST_HEAD(&rpc_poll_extra[i].tasks);
+			//tasklet_init(&rpc_poll_extra[i].tasklet, rpc_dispatch, (unsigned long)&rpc_poll_extra[i]);
+			spin_lock_init(&rpc_poll_extra[i].lock);
+			switch (i) {
+			case 0:
+				rpc_poll_extra[i].name = "AudioPollWrite";
+				break;
+			case 1:
+				rpc_poll_extra[i].name = "AudioPollRead";
+				break;
+			case 2:
+				rpc_poll_extra[i].name = "Video1PollWrite";
+				break;
+			case 3:
+				rpc_poll_extra[i].name = "Video1PollRead";
+				break;
+			case 4:
+				rpc_poll_extra[i].name = "Video2PollWrite";
+				break;
+			case 5:
+				rpc_poll_extra[i].name = "Video2PollRead";
+				break;
+			}
+		}
+	}
+
+	is_init = 1;
+	rpc_poll_is_paused = 0;
+	rpc_poll_is_suspend = 0;
+
+	return result;
+}
+
+int rpc_poll_pause(void)
+{
+	rpc_poll_is_paused = 1;
+	return 0;
+}
+
+int rpc_poll_suspend(void)
+{
+	rpc_poll_is_suspend = 1;
+	return 0;
+}
+
+int rpc_poll_resume(void)
+{
+	rpc_poll_is_suspend = 0;
+	return 0;
+}
+
+void rpc_poll_cleanup(void)
+{
+	int num = RPC_NR_DEVS/RPC_NR_PAIR, i;
+
+	/* Clean corresponding structures for each device. */
+	if (rpc_poll_devices) {
+		/* Clean ring buffers. */
+		for (i = 0; i < num; i++) {
+			//if (rpc_poll_devices[i].ringBuf)
+			//kfree(rpc_poll_devices[i].ringBuf);
+		}
+		//kfree(rpc_poll_devices);
+	}
+
+	return;
+}
+
+int rpc_poll_open(struct inode *inode, struct file *filp)
+{
+	int minor = MINOR(inode->i_rdev);
+
+	if (minor == 100) {
+		filp->f_op = &rpc_ctrl_fops;
+		return filp->f_op->open(inode, filp); /* dispatch to specific open */
+	}
+
+	/*
+	 * If private data is not valid, we are not using devfs
+	 * so use the minor number to select a new f_op
+	 */
+	if (!filp->private_data && (minor%RPC_NR_PAIR != 0)) {
+		filp->f_op = rpc_fop_array[minor%RPC_NR_PAIR];
+		return filp->f_op->open(inode, filp); /* dispatch to specific open */
+	}
+
+	pr_debug("RPC poll open with minor number: %d\n", minor);
+
+		if (!filp->private_data) {
+			RPC_PROCESS *proc = kmalloc(sizeof(RPC_PROCESS), GFP_KERNEL | __GFP_ZERO);
+
+			if (proc == NULL) {
+				pr_err("%s: failed to allocate RPC_PROCESS", __func__);
+				return -ENOMEM;
+			}
+
+#ifdef CONFIG_REALTEK_RPC_KCPU
+			if (minor >= RPC_NR_DEVS)
+				proc->dev = &rpc_poll_kcpu_devices[(minor-RPC_NR_DEVS)/RPC_NR_PAIR];
+			else
+#endif
+				proc->dev = (RPC_DEV *)&rpc_poll_devices[minor/RPC_NR_PAIR];
+
+			proc->extra = &rpc_poll_extra[minor/RPC_NR_PAIR];
+			/* current->tgid = process id, current->pid = thread id */
+			proc->pid = current->tgid;
+            proc->bStayActive = false;
+
+			init_waitqueue_head(&proc->waitQueue);
+			INIT_LIST_HEAD(&proc->threads);
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+			INIT_LIST_HEAD(&proc->handlers);
+#endif
+			spin_lock_bh(&proc->extra->lock);
+			list_add(&proc->list, &proc->extra->tasks);
+			spin_unlock_bh(&proc->extra->lock);
+			pr_debug("%s: Current process pid:%d tgid:%d => %d(%p) for %s(%p)\n", __func__, current->pid, current->tgid, proc->pid, &proc->waitQueue, proc->extra->name, proc->dev);
+
+			filp->private_data = proc;
+		}
+
+	//MOD_INC_USE_COUNT; /* Before we maybe sleep */
+
+	return 0;
+}
+
+int rpc_poll_release(struct inode *inode, struct file *filp)
+{
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+	RPC_HANDLER *handler, *hdltmp;
+#endif
+	RPC_THREAD *th, *thtmp;
+	int minor = MINOR(inode->i_rdev);
+
+	RPC_PROCESS *proc = filp->private_data;
+	RPC_DEV *dev = proc->dev; /* the first listitem */
+	RPC_DEV_EXTRA *extra = proc->extra;
+
+	if (extra->currProc == proc) {
+		pr_debug("%s: clear %s(%p) current process\n", __func__, proc->extra->name, dev);
+		update_currProc(extra, NULL);
+		if (minor == 2 || minor == 6 || minor == 10) { /* poll read device (ugly code) */
+			if (!rpc_done(extra)) {
+				pr_err("%s: previous rpc hasn't finished, force clear!! ringOut %p => %p\n", __func__,
+				AVCPU2SCPU(dev->ringOut), AVCPU2SCPU(extra->nextRpc));
+				down_write(&dev->ptrSync->readSem);
+				dev->ringOut = extra->nextRpc;
+				up_write(&dev->ptrSync->readSem);
+			}
+		}
+	}
+
+	spin_lock_bh(&extra->lock);
+
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+	//unregister myself from handler list
+	list_for_each_entry_safe(handler, hdltmp, &proc->handlers, list) {
+		list_del(&handler->list);
+		kfree(handler);
+	}
+#endif
+
+	list_for_each_entry_safe(th, thtmp, &proc->threads, list) {
+		list_del(&th->list);
+		kfree(th);
+	}
+
+	/* remove myself from task list */
+	list_del(&proc->list);
+	kfree(proc);
+
+	spin_unlock_bh(&extra->lock);
+
+	pr_debug("RPC poll close with minor number: %d\n", minor);
+
+//	MOD_DEC_USE_COUNT;
+
+	return 0;
+}
+
+/* We don't need parameter f_pos here... */
+ssize_t rpc_poll_read(struct file *filp, char *buf, size_t count,
+	loff_t *f_pos)
+{
+	RPC_PROCESS *proc = filp->private_data;
+	RPC_DEV *dev = proc->dev; /* the first listitem */
+	RPC_DEV_EXTRA *extra = proc->extra;
+	int temp, size;
+	size_t r;
+	ssize_t ret = 0;
+	uint32_t ptmp;
+	int rpc_ring_size = dev->ringEnd - dev->ringStart;
+
+	//pr_debug("%s:%d thread:%s pid:%d tgid:%d device:%s\n", __func__, __LINE__, current->comm, current->pid, current->tgid, extra->name);
+	if (rpc_poll_is_paused) {
+		pr_err("RPCpoll: someone access rpc poll during the pause...\n");
+		pr_err("%s:%d buf:%p count:%lu EAGAIN\n", __func__, __LINE__, buf, count);
+		msleep(1000);
+		return -EAGAIN;
+	}
+
+	while (rpc_poll_is_suspend) {
+		pr_warn("RPCpoll: someone access rpc poll during the suspend!!!...\n");
+		msleep(1000);
+	}
+
+	rtk_rpc_wmb(AVCPU2SCPU(dev->ringStart), PAGE_ALIGN(rpc_ring_size));
+	down_write(&dev->ptrSync->readSem);
+
+	if (need_dispatch(extra)) {
+		tasklet_schedule(&(extra->tasklet));
+	}
+
+	//pr_debug("%s: dev:%s(%p) currProc:%p\n", __func__, extra->name, dev, extra->currProc);
+	if ((extra->currProc != proc) || (ring_empty(dev))) {
+		if (unlikely(!(filp->f_flags & O_NONBLOCK))) {
+			//pr_warn("%s:%d:%s Warning: pid:%d use blocking mode with poll buffer!\n", __func__, __LINE__, extra->name, current->pid);
+		}
+		goto out; //return anyway
+	}
+
+	if (dev->ringIn > dev->ringOut)
+		size = dev->ringIn - dev->ringOut;
+	else
+		size = rpc_ring_size + dev->ringIn - dev->ringOut;
+
+	//pr_debug("%s: %s: count:%lu size:%d\n", __func__, extra->name, count, size);
+	//peek_rpc_struct(__func__, dev);
+	if (count > size)
+			count = size;
+
+	temp = dev->ringEnd - dev->ringOut;
+	if (temp >= count) {
+#ifdef MY_COPY
+		r = my_copy_to_user((int *)buf, (int *)AVCPU2SCPU(dev->ringOut), count);
+#else
+		r = copy_to_user((int *)buf, (int *)AVCPU2SCPU(dev->ringOut), count);
+#endif
+		if (r) {
+			pr_err("%s:%d buf:%p count:%lu EFAULT\n", __func__, __LINE__, buf, count);
+			ret = -EFAULT;
+			goto out;
+		}
+
+		ret += count;
+		ptmp = dev->ringOut + ((count+3) & 0xfffffffc);
+
+		if (ptmp == dev->ringEnd)
+			dev->ringOut = dev->ringStart;
+		else
+			dev->ringOut = ptmp;
+
+		//pr_debug("RPC Read is in 1st kind...\n");
+	} else {
+#ifdef MY_COYP
+		r = my_copy_to_user((int *)buf, (int *)AVCPU2SCPU(dev->ringOut), temp);
+#else
+		r = copy_to_user((int *)buf, (int *)AVCPU2SCPU(dev->ringOut), temp);
+#endif
+		if (r) {
+			pr_err("%s:%d buf:%p count:%lu EFAULT\n", __func__, __LINE__, buf, count);
+			ret = -EFAULT;
+			goto out;
+		}
+
+		count -= temp;
+
+#ifdef MY_COPY
+		r = my_copy_to_user((int *)(buf+temp), (int *)AVCPU2SCPU(dev->ringStart), count);
+#else
+		r = copy_to_user((int *)(buf+temp), (int *)AVCPU2SCPU(dev->ringStart), count);
+#endif
+		if (r) {
+			pr_err("%s:%d buf:%p count:%lu EFAULT\n", __func__, __LINE__, buf, count);
+			ret = -EFAULT;
+			goto out;
+		}
+
+		ret += (temp + count);
+		dev->ringOut = dev->ringStart+((count+3) & 0xfffffffc);
+
+		//pr_debug("RPC Read is in 2nd kind...\n");
+	}
+
+	spin_lock_bh(&extra->lock);
+	if (rpc_done(extra)) {
+		pr_debug("%s: Previous RPC is done, unregister myself\n", __func__);
+		update_currProc(extra, NULL);
+	}
+	spin_unlock_bh(&extra->lock);
+
+	//process next rpc command if any
+	if (need_dispatch(extra))
+		tasklet_schedule(&(extra->tasklet));
+
+	pr_debug("%s:%d buf:%p count:%lu actual:%lu\n", __func__, __LINE__, buf, count, ret);
+
+out:
+	up_write(&dev->ptrSync->readSem);
+	rtk_rpc_wmb(AVCPU2SCPU(dev->ringStart), PAGE_ALIGN(rpc_ring_size));
+	//pr_debug("RPC poll ringOut pointer is : 0x%8x\n", (int)AVCPU2SCPU(dev->ringOut));
+	//pr_debug("%s:%d pid:%d reads %d bytes\n", extra->name, __LINE__, current->pid, ret);
+	return ret;
+}
+
+/* We don't need parameter f_pos here... */
+ssize_t rpc_poll_write(struct file *filp, const char *buf, size_t count,
+	loff_t *f_pos)
+{
+	RPC_PROCESS *proc = filp->private_data;
+	RPC_DEV *dev = proc->dev; /* the first listitem */
+	RPC_DEV_EXTRA *extra = proc->extra;
+	RPC_DEV_EXTRA *rextra = extra + 1;
+	int temp, size;
+	size_t r;
+	ssize_t ret = 0;
+	uint32_t ptmp;
+	int rpc_ring_size = dev->ringEnd - dev->ringStart;
+
+	if (rpc_poll_is_paused) {
+		pr_warn("RPCpoll: someone access rpc poll during the pause...\n");
+		msleep(1000);
+		return -EAGAIN;
+	}
+
+	while (rpc_poll_is_suspend) {
+		pr_warn("RPCpoll: someone access rpc poll during the suspend!!!...\n");
+		msleep(1000);
+	}
+
+	rtk_rpc_wmb(AVCPU2SCPU(dev->ringStart), PAGE_ALIGN(rpc_ring_size));
+	down_write(&dev->ptrSync->writeSem);
+
+#if 1
+	/* Threads that share the same file descriptor should have the same tgid
+	 * However, with uClibc pthread library, pthread_create() creates threads with pid == tgid
+	 * So the tgid is not real tgid, we have to maintain the thread list that we can lookup later
+	 */
+	if (current->pid != proc->pid)
+		update_thread_list(rextra, proc->pid);
+#endif
+
+	if (ring_empty(dev))
+		size = 0;   // the ring is empty
+	else if (dev->ringIn > dev->ringOut)
+		size = dev->ringIn - dev->ringOut;
+	else
+		size = rpc_ring_size + dev->ringIn - dev->ringOut;
+
+	pr_debug("%s: count:%lu space:%d\n", extra->name, count, rpc_ring_size - size - 1);
+	pr_debug("%s: pid:%d tgid:%d\n", extra->name, current->pid, current->tgid);
+
+	if (count > (rpc_ring_size - size - 1))
+		goto out;
+
+	temp = dev->ringEnd - dev->ringIn;
+
+	if (temp >= count) {
+#ifdef MY_COPY
+		r = my_copy_from_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, count);
+#else
+		r = copy_from_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, count);
+#endif
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+
+		ret += count;
+		ptmp = dev->ringIn + ((count+3) & 0xfffffffc);
+
+		//asm("DSB");
+		mb();
+
+		if (ptmp == dev->ringEnd)
+			dev->ringIn = dev->ringStart;
+		else
+			dev->ringIn = ptmp;
+
+		//pr_debug("RPC Write is in 1st kind...\n");
+	} else {
+#ifdef MY_COPY
+		r = my_copy_from_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, temp);
+#else
+		r = copy_from_user((int *)AVCPU2SCPU(dev->ringIn), (int *)buf, temp);
+#endif
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+
+		count -= temp;
+
+#ifdef MY_COPY
+		r = my_copy_from_user((int *)AVCPU2SCPU(dev->ringStart), (int *)(buf+temp), count);
+#else
+		r = copy_from_user((int *)AVCPU2SCPU(dev->ringStart), (int *)(buf+temp), count);
+#endif
+		if (r) {
+			ret = -EFAULT;
+			goto out;
+		}
+
+		ret += (temp + count);
+
+		//asm("DSB");
+		mb();
+
+		dev->ringIn = dev->ringStart+((count+3) & 0xfffffffc);
+		//pr_debug("RPC Write is in 2nd kind...\n");
+	}
+
+	//peek_rpc_struct(extra->name, dev);
+
+out:
+	pr_debug("RPC poll ringIn pointer is : %p\n", AVCPU2SCPU(dev->ringIn));
+	up_write(&dev->ptrSync->writeSem);
+	rtk_rpc_wmb(AVCPU2SCPU(dev->ringStart), PAGE_ALIGN(rpc_ring_size));
+
+	return ret;
+}
+
+long rpc_poll_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	int ret = 0;
+	int found;
+	RPC_PROCESS *proc = filp->private_data;
+	RPC_DEV_EXTRA *extra = proc->extra;
+	RPC_HANDLER *handler;
+
+	while (rpc_poll_is_suspend) {
+		pr_warn("RPCpoll: someone access rpc poll during the suspend!!!...\n");
+		msleep(1000);
+	}
+
+	switch (cmd) {
+#ifdef CONFIG_REALTEK_RPC_PROGRAM_REGISTER
+	case RPC_IOCTHANDLER:
+
+		pr_debug("%s:%d : Register handler for programID:%lu\n", __func__, __LINE__, arg);
+		found = 0;
+		list_for_each_entry(handler, &proc->handlers, list) {
+			if (handler->programID == arg) {
+				found = 1;
+				break;
+			}
+		}
+
+		if (found)
+			break;
+
+		/* not found, add to handler list */
+		handler = kmalloc(sizeof(RPC_HANDLER), GFP_KERNEL);
+		if (handler == NULL) {
+			pr_err("%s: failed to allocate RPC_HANDLER\n", __func__);
+			return -ENOMEM;
+		}
+
+		handler->programID = arg;
+		spin_lock_bh(&extra->lock);
+		list_add(&handler->list, &proc->handlers);
+		spin_unlock_bh(&extra->lock);
+		pr_debug("%s:%d %s: Add handler pid:%d for programID:%lu\n", __func__, __LINE__, proc->extra->name, proc->pid, arg);
+		break;
+#endif
+    case RPC_IOC_PROCESS_CONFIG_0:
+        {
+            struct S_RPC_IOC_PROCESS_CONFIG_0 config;
+
+            if (copy_from_user(&config, (void __user *)arg, sizeof(struct S_RPC_IOC_PROCESS_CONFIG_0))) {
+                pr_err("ERROR! %s cmd:RPC_IOC_PROCESS_CONFIG_0 copy_from_user failed\n", __func__);
+                return -ENOMEM;
+            }
+
+            if (proc == NULL) {
+                pr_err("ERROR! %s cmd:RPC_IOC_PROCESS_CONFIG_0 proc:%p\n", __func__, proc);
+                return -ENOMEM;
+            }
+            proc->bStayActive = (config.bStayActive > 0) ? true : false;
+            break;
+        }
+	default:
+		pr_warn("%s:%d unsupported ioctl cmd:%x arg:%lx\n", __func__, __LINE__, cmd, arg);
+		return -ENOTTY;
+	}
+
+	return ret;
+}
+
+long rpc_ctrl_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	int ret = 0;
+	RPC_DBG_FLAG dFlag;
+
+	while (rpc_poll_is_suspend) {
+		pr_warn("RPCpoll: someone access rpc poll during the suspend!!!...\n");
+		msleep(1000);
+	}
+
+	switch (cmd) {
+	case RPC_IOCTRESET:
+
+		pr_info("[RPC]start reset...\n");
+		rpc_poll_init();
+		rpc_intr_init();
+		rpc_kern_init();
+
+		/* clear the inter-processor interrupts */
+		//*((int *)REG_SB2_CPU_INT) = 0x0000007e;
+		writel(RPC_INT_AS, rpc_int_base+RPC_SB2_INT);
+		writel(RPC_INT_SA, rpc_int_base+RPC_SB2_INT);
+
+		rpc_set_flag(RPC_AUDIO, 0xffffffff);
+
+		pr_info("[RPC]done...\n");
+		break;
+
+	case RPC_IOCTRGETDBGREG_A:
+#ifdef CONFIG_ION_RTK /*ion is unavailable if RTD1295 purenas*/
+	case RPC_IOCTRGETDBGREG_V:
+#endif
+
+		if (copy_from_user(&dFlag, (void __user *)arg, sizeof(dFlag)))
+			return -EFAULT;
+#ifdef CONFIG_ION_RTK /*ion is unavailable if RTD1295 purenas*/		
+        else {
+            unsigned int * puDebugFlag = NULL;
+            struct rpc_debug_flag * debug_flag = get_debug_flag();
+            ion_phys_addr_t debug_flag_phyAddr = get_debug_flag_phyAddr();
+
+            if (debug_flag == NULL || IS_ERR(debug_flag_phyAddr))
+                return -EFAULT;
+
+            if (cmd == RPC_IOCTRGETDBGREG_V) {
+                puDebugFlag = &debug_flag->vcpu;
+                debug_flag_phyAddr = debug_flag_phyAddr + offsetof(struct rpc_debug_flag, vcpu);
+            } else {
+                puDebugFlag = &debug_flag->acpu;
+                debug_flag_phyAddr = debug_flag_phyAddr + offsetof(struct rpc_debug_flag, acpu);
+            }
+#else
+               if (DbgFlag_A == NULL) {
+                       DbgFlag_A = &phy_DbgFlag_A;
+                       //dma_alloc_coherent(NULL, sizeof(unsigned int), &phy_DbgFlag_A, GFP_KERNEL);
+                       *DbgFlag_A = 0;
+                       //pr_info("DbgFlag_A %x\n", *DbgFlag_A);
+               }
+#endif
+#ifdef CONFIG_ION_RTK /*ion is unavailable if RTD1295 purenas*/
+            if (dFlag.op == RPC_DBGREG_SET)
+                *puDebugFlag = dFlag.flagValue;
+            else {
+                dFlag.flagValue = (unsigned int)*puDebugFlag;
+                dFlag.flagAddr = (uint32_t) debug_flag_phyAddr & -1U;
+                if (copy_to_user((void __user *)arg, &dFlag, sizeof(dFlag)))
+                    return -EFAULT;
+            }
+#else
+           if (dFlag.op == RPC_DBGREG_SET) {
+                   //pr_info("\033[0;31;31mIOCTL RPC DEBUG AUDIO op %s Value %x Addr %x \033[m\n", "SET", dFlag.flagValue, dFlag.flagAddr);
+                   *DbgFlag_A = dFlag.flagValue;
+           } else {
+                   dFlag.flagValue = (unsigned int)*DbgFlag_A;
+                   dFlag.flagAddr = (uint32_t)virt_to_phys(&phy_DbgFlag_A);
+                   //pr_info("\033[0;31;31mIOCTL RPC DEBUG AUDIO op %s Value %x Addr %x \033[m\n", "GET", dFlag.flagValue, dFlag.flagAddr);
+                   if (copy_to_user((void __user *)arg, &dFlag, sizeof(dFlag)))
+                           return -EFAULT;
+           }
+           break;            
+#endif
+#ifdef CONFIG_ION_RTK /*ion is unavailable if RTD1295 purenas*/           
+            pr_debug("RPC_DEBUG cmd=%s op=%s phyAddr=0x%08lx flag=0x%08lx",
+                    (cmd == RPC_IOCTRGETDBGREG_V) ? "RPC_IOCTRGETDBGREG_V" : "RPC_IOCTRGETDBGREG_A",
+                    (dFlag.op == RPC_DBGREG_SET) ? "SET" : "GET",
+                    debug_flag_phyAddr, *puDebugFlag);
+        }
+        break;
+#endif        
+	default:
+		pr_warn("[RPC]: error ioctl command...\n");
+		break;
+	}
+
+	return ret;
+}
+
+int rpc_ctrl_open(struct inode *inode, struct file *filp)
+{
+	pr_info("[RPC]open for RPC ioctl...\n");
+
+	return 0;
+}
+
+struct file_operations rpc_poll_fops = {
+	//	llseek:	 scull_llseek,
+	.unlocked_ioctl = rpc_poll_ioctl,
+	.compat_ioctl = rpc_poll_ioctl,
+	.read = rpc_poll_read,
+	.write = rpc_poll_write,
+	.open = rpc_poll_open,
+	.release = rpc_poll_release,
+};
+
+struct file_operations rpc_ctrl_fops = {
+	.unlocked_ioctl = rpc_ctrl_ioctl,
+	.compat_ioctl = rpc_ctrl_ioctl,
+	.open = rpc_ctrl_open,
+};
+
diff --git a/drivers/soc/realtek/common/rtk-usb-manager.c b/drivers/soc/realtek/common/rtk-usb-manager.c
new file mode 100644
index 00000000..8e77b90
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk-usb-manager.c
@@ -0,0 +1,1842 @@
+/*
+ *  rtk-usb-manager.c RTK Manager Driver for All USB.
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+//#define DEBUG
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/io.h>
+#include <linux/usb.h>
+#include <linux/usb/otg.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_gpio.h>
+#include <linux/of_platform.h>
+#include <linux/reset.h>
+#include <linux/clk.h>   // clk_get
+#include <linux/clk-provider.h>
+#include <linux/suspend.h>
+#include <linux/regulator/consumer.h>
+#include <soc/realtek/rtk_chip.h>
+#include <soc/realtek/rtk_usb.h>
+#include <linux/uaccess.h>
+#include <linux/debugfs.h>
+
+#define CRT_SOFT_RESET1 	0x0
+#define CRT_SOFT_RESET2 	0x4
+#define CRT_CLOCK_ENABLE1 	0xc
+
+struct gpio_data {
+	int gpio_num;
+
+	int enable_port;
+	int enable_port_mask; /* bit 0~3 mapping to port 0~3*/
+	/*port GPIO*/
+	/* port power on off */
+	bool power_enable;
+	bool power_low_active;
+
+	struct device_node *node;
+};
+
+struct port_data {
+	int port_num;
+
+	struct gpio_data *power_gpio;
+
+	/* port mapping to host */
+	struct device_node *mac_node;
+	struct device_node *slave_mac_node; /* for ohci */
+	struct device_node *type_c_node;
+
+	int enable;
+	int enable_mask; /* bit 0: master; bit 1: slave */
+	bool is_type_c;
+
+	struct device_node *node;
+};
+
+struct manager_data {
+	void __iomem *crt_base;
+	struct device *dev;
+
+	struct port_data port0;
+	struct port_data port1;
+	struct port_data port2;
+	struct port_data port3;
+
+	/* usb power gpio */
+	struct gpio_data gpio0;
+	struct gpio_data gpio1;
+	struct gpio_data gpio2;
+	struct gpio_data gpio3;
+
+	bool disable_usb;
+
+	bool usb_iso_mode;
+	bool en_usb_storage_reprobe;
+	bool rescue_usb;
+	bool dis_hub_autosuspend;
+
+	struct rtk_usb *rtk_usb;
+
+	struct workqueue_struct *wq_usb_manager;
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	struct dentry *debug_dir;
+#endif
+
+	struct mutex lock;
+};
+
+/* [ROOT_CAUSE]: quirk device result in compatibility issue
+ * [SOLUTION]: clear port power and reset port if got error
+ * commit 42e905e60eaadd3fd8374db23dc644b98080717e
+ */
+extern int RTK_usb_probe_device(struct device *dev);
+extern int RTK_usb_unbind_device(struct device *dev);
+
+int RTK_usb_reprobe_usb_storage(struct usb_device *udev)
+{
+	struct device_node *node;
+	struct platform_device *pdev = NULL;
+	static struct manager_data *data = NULL;
+
+	if (data == NULL) {
+		node = of_find_compatible_node(NULL, NULL,
+		    "Realtek,usb-manager");
+		if (node != NULL)
+			pdev = of_find_device_by_node(node);
+		if (pdev != NULL) {
+			data = platform_get_drvdata(pdev);
+		}
+	}
+	if (data == NULL) {
+		pr_err("%s ERROR no manager_data", __func__);
+		return -ENODEV;
+	}
+
+	/* [ROOT_CAUSE]: quirk device result in compatibility issue
+	 * [SOLUTION]: clear port power and reset port if got error
+	 * commit 42e905e60eaadd3fd8374db23dc644b98080717e
+	 * [DEV_FIX]MediaNAS_V0.1 can't recognise the 5411 hub after power on
+	 * [SOLUTION] dont unbind and probe again after usb_add_device , and set it as quirk device
+	 * commit 75b83399dcf5e38ae39ce16d730f5824fccbb3bf
+	 * [DEV_FIX]xhci hub 2.0  can't be recognize after unplug and plug again
+	 * commit fbb4cc12d549b5193d51e88d6d0bc916a6e4d5d3
+	 * [ROOT_CAUSE] USB hdd can't be mounted cuz scsi not stable during power-on stage
+	 * commit dbb572028226bba6b504ff859fe3f05e5b7efbdf
+	 * [ROOT_CAUSE] USB hdd can't be mounted cuz scsi not stable during power-on stage
+	 * commit 8fa320af443950c0dbc9875546159d9c57cd97f2
+	 * [ROOT_CAUSE]config USB device error ,result in NULL pointer
+	 * commit 0d7ba5cbee8ff84a99f926a0a00128fe9c6c6104
+	 * [ROOT_CAUSE] usb SATA not stable after power on
+	 * commit ba77afca700fa8586607fcfa9091b863f4a3b620
+	 * [ROOT_CAUSE] if se config err , udev->actconfig will be NULL
+	 * commit 2ebede9fe6b6347ecf446a06e958dfd0a671b27d
+	 */
+	//hcy added for quirk HDD
+	if (data->en_usb_storage_reprobe) {
+		int usb_storage = 0;
+		int i;
+
+		if (udev->actconfig) {
+			for (i = 0; i < 1/*udev->actconfig->desc.bNumInterfaces*/; i++) {
+				struct usb_host_config *config = udev->actconfig;
+				struct usb_interface *intf = config->interface[i];
+				struct usb_interface_descriptor *desc;
+				desc = &intf->cur_altsetting->desc;
+
+				dev_info(&udev->dev , "bInterfaceClass = %d "
+					    "(jiffies 0x%2x = %d ms)\n",  desc->bInterfaceClass,
+					    jiffies - INITIAL_JIFFIES,
+					    jiffies_to_msecs(jiffies - INITIAL_JIFFIES));
+				if (desc->bInterfaceClass == USB_CLASS_MASS_STORAGE) {
+					usb_storage = 1;
+					break;
+				}
+			}
+		}
+
+		if ((jiffies - INITIAL_JIFFIES) < 0x400
+			    && (usb_storage ||
+			    udev->descriptor.bDeviceClass == USB_CLASS_MASS_STORAGE)) {
+			msleep(100);
+			dev_info(&udev->dev , "%s unbind-probe dev_name = %s "
+				    "(jiffies= 0x%2x = %d ms)\n", __func__,
+				    dev_name(&udev->dev), jiffies - INITIAL_JIFFIES,
+				    jiffies_to_msecs(jiffies - INITIAL_JIFFIES));
+			RTK_usb_unbind_device(&udev->dev);
+			//hcy added for waiting some scsi HDD stable after power on
+			if (data->rescue_usb) {
+				dev_err(&udev->dev ,"** rescue type **\n");
+				msleep(5000);
+			} else {
+				msleep(10000);
+			}
+
+			dev_info(&udev->dev , "%s bind-probe dev_name = %s "
+				    "(jiffies= 0x%2x = %d ms)\n", __func__,
+				    dev_name(&udev->dev), jiffies - INITIAL_JIFFIES,
+				    jiffies_to_msecs(jiffies - INITIAL_JIFFIES));
+			RTK_usb_probe_device(&udev->dev);
+		}
+	}
+	return 0;
+}
+
+bool RTK_usb_disable_hub_autosuspend(void)
+{
+	struct device_node *node;
+	struct platform_device *pdev = NULL;
+	static struct manager_data *data = NULL;
+
+	if (data == NULL) {
+		node = of_find_compatible_node(NULL, NULL,
+		    "Realtek,usb-manager");
+		if (node != NULL)
+			pdev = of_find_device_by_node(node);
+		if (pdev != NULL) {
+			data = platform_get_drvdata(pdev);
+		}
+	}
+	if (data == NULL) {
+		pr_err("%s ERROR no manager_data", __func__);
+		return false;
+	}
+
+	return data->dis_hub_autosuspend;
+}
+
+int rtk_usb_manager_is_iso_mode(struct device *usb_dev)
+{
+	static struct manager_data *s_data = NULL;
+	struct device_node *node = NULL;
+	struct platform_device *pdev = NULL;
+	struct manager_data *data = NULL;
+	struct device *dev = NULL;
+
+	if (s_data == NULL) {
+		node = of_find_compatible_node(NULL, NULL, "Realtek,usb-manager");
+		if (node != NULL)
+			pdev = of_find_device_by_node(node);
+		if (pdev != NULL)
+			s_data = platform_get_drvdata(pdev);
+	}
+	data = s_data;
+	if (data == NULL) {
+		dev_err(data->dev, "%s ERROR no manager_data", __func__);
+		return -ENODEV;
+	}
+	dev = data->dev;
+	if (data->usb_iso_mode) {
+		dev_dbg(data->dev, "%s is usb_iso_mode", __func__);
+		return 1;
+	} else {
+		dev_dbg(data->dev, "%s Not usb_iso_mode", __func__);
+		return 0;
+	}
+}
+
+int rtk_usb_manager_schedule_work(struct device *usb_dev,
+	    struct work_struct *work) {
+	struct device_node *node = of_find_compatible_node(NULL, NULL,
+		    "Realtek,usb-manager");
+	struct platform_device *pdev = NULL;
+	struct manager_data *data = NULL;
+
+	if (node != NULL)
+		pdev = of_find_device_by_node(node);
+	if (pdev != NULL) {
+		data = platform_get_drvdata(pdev);
+	}
+	if (data == NULL) {
+		pr_err("%s ERROR no manager_data", __func__);
+		return -ENODEV;
+	}
+    dev_dbg(data->dev, "%s Enter ..\n", __func__);
+
+	dev_info(data->dev, "%s for %s", __func__, dev_name(usb_dev));
+
+	if (work == NULL) {
+		dev_err(data->dev, "%s, work is NULL", __func__);
+		return -1;
+	}
+	mutex_lock(&data->lock);
+
+	queue_work(data->wq_usb_manager, work);
+
+	mutex_unlock(&data->lock);
+
+    dev_dbg(data->dev, "%s Exit ..\n", __func__);
+	return 0;
+}
+
+/* enable hw_pm (L4 ICG)
+ *   The hw_pm function will be reset after doing soft_reset, so
+ *   only enable is provided.
+ */
+static __maybe_unused void __rtk_usb_set_hw_pm_enable(struct manager_data *data)
+{
+	struct device *dev = data->dev;
+	bool on = true;
+
+	if (!data->rtk_usb)
+		return;
+
+	dev_dbg(dev, "set usb_hw_pm\n");
+
+	/* for hw_pm, enable is equal to power_off */
+	if (data->port0.port_num >= 0)
+		rtk_usb_set_hw_l4icg_on_off(data->rtk_usb, USB_PORT_0, on);
+	if (data->port1.port_num >= 0)
+		rtk_usb_set_hw_l4icg_on_off(data->rtk_usb, USB_PORT_1, on);
+	if (data->port2.port_num >= 0)
+		rtk_usb_set_hw_l4icg_on_off(data->rtk_usb, USB_PORT_2, on);
+	if (data->port3.port_num >= 0)
+		rtk_usb_set_hw_l4icg_on_off(data->rtk_usb, USB_PORT_3, on);
+}
+
+/* set usb charger power */
+static __maybe_unused void __usb_set_charger_power(
+	    struct manager_data *data, bool power_on)
+{
+	struct device *dev = data->dev;
+	unsigned int val = 0;
+
+	if (!data->rtk_usb)
+		return;
+
+	if (power_on) {
+		if (data->port0.port_num >= 0)
+			val |= BIT(0);
+		if (data->port1.port_num >= 0)
+			val |= BIT(1);
+		if (data->port2.port_num >= 0)
+			val |= BIT(2);
+		if (data->port3.port_num >= 0)
+			val |= BIT(3);
+	}
+
+	dev_dbg(dev, "%s set usb_charger %x\n", __func__, val);
+
+	rtk_usb_set_charger_power(data->rtk_usb, val);
+}
+
+/* set usb power domain */
+static void __usb_set_pd_power(struct manager_data* data, bool power_on)
+{
+	struct device *dev = data->dev;
+
+	if (power_on && !data->disable_usb) {
+		if (!data->rtk_usb)
+			return;
+		rtk_usb_iso_power_ctrl(data->rtk_usb, true);
+	} else {
+		if (!data->rtk_usb)
+			return;
+		rtk_usb_iso_power_ctrl(data->rtk_usb, false);
+	}
+}
+
+static inline struct reset_control *USB_reset_get(struct device *dev,
+	    const char *str)
+{
+	struct reset_control *reset;
+
+	reset = reset_control_get(dev, str);
+	if (IS_ERR(reset)) {
+		dev_dbg(dev, "No controller reset %s\n", str);
+		reset = NULL;
+	}
+	return reset;
+}
+
+static inline void USB_reset_put(struct reset_control *reset)
+{
+	if (reset) {
+		reset_control_put(reset);
+	}
+}
+
+static inline int USB_reset_deassert(struct reset_control *reset)
+{
+	if (!reset) return 0;
+
+	return reset_control_deassert(reset);
+}
+
+static inline int USB_reset_assert(struct reset_control *reset)
+{
+	if (!reset) return 0;
+
+	return reset_control_assert(reset);
+}
+
+static inline struct clk *USB_clk_get(struct device *dev, const char *str)
+{
+	struct clk *clk;
+
+	clk = clk_get(dev, str);
+	if (IS_ERR(clk)) {
+		dev_dbg(dev, "No clk %s\n", str);
+		clk = NULL;
+	}
+	return clk;
+}
+
+static int __usb_init_clock_reset(struct manager_data* data)
+{
+	struct device *dev = data->dev;
+	//void __iomem *crt_reg = data->crt_base;
+	/* GET clock */
+	struct clk *clk_usb_phy0_to_host = USB_clk_get(dev, "clk_en_phy0_to_host");
+	struct clk *clk_usb_phy1_to_host = USB_clk_get(dev, "clk_en_phy1_to_host");
+	struct clk *clk_usb_phy2_to_host = USB_clk_get(dev, "clk_en_phy2_to_host");
+	struct clk *clk_usb_phy3_to_host = USB_clk_get(dev, "clk_en_phy3_to_host");
+	struct clk *clk_usb = USB_clk_get(dev, "clk_en_usb");
+
+	/* GET reset controller */
+	struct reset_control *reset_u2phy0 = USB_reset_get(dev, "u2phy0");
+	struct reset_control *reset_u2phy1 = USB_reset_get(dev, "u2phy1");
+	struct reset_control *reset_u2phy2 = USB_reset_get(dev, "u2phy2");
+	struct reset_control *reset_u2phy3 = USB_reset_get(dev, "u2phy3");
+
+	struct reset_control *reset_u3phy0 = USB_reset_get(dev, "u3phy0");
+	struct reset_control *reset_u3phy1 = USB_reset_get(dev, "u3phy1");
+	struct reset_control *reset_u3phy0_mdio = USB_reset_get(dev, "u3mdio0");
+	struct reset_control *reset_u3phy1_mdio = USB_reset_get(dev, "u3mdio1");
+
+	struct reset_control *reset_usb_host0 = USB_reset_get(dev, "usb_host0");
+	struct reset_control *reset_usb_host1 = USB_reset_get(dev, "usb_host1");
+	struct reset_control *reset_usb_host2 = USB_reset_get(dev, "usb_host2");
+	struct reset_control *reset_usb_host3 = USB_reset_get(dev, "usb_host3");
+	struct reset_control *reset_usb = USB_reset_get(dev, "usb");
+	struct reset_control *reset_type_c = USB_reset_get(dev, "type_c");
+
+	struct reset_control *reset_usb_apply = USB_reset_get(dev, "apply");
+
+	dev_dbg(dev, "Realtek USB init\n");
+
+	USB_reset_assert(reset_u2phy0);
+	USB_reset_assert(reset_u2phy1);
+	USB_reset_assert(reset_u2phy2);
+	USB_reset_assert(reset_u2phy3);
+	USB_reset_assert(reset_u3phy0);
+	USB_reset_assert(reset_u3phy1);
+	USB_reset_assert(reset_u3phy0_mdio);
+	USB_reset_assert(reset_u3phy1_mdio);
+	USB_reset_assert(reset_usb_host0);
+	USB_reset_assert(reset_usb_host1);
+	USB_reset_assert(reset_usb_host2);
+	USB_reset_assert(reset_usb_host3);
+	USB_reset_assert(reset_usb);
+	USB_reset_assert(reset_type_c);
+	wmb();
+
+	// Enable usb phy reset
+	/* DEASSERT: set rstn bit to 1 */
+	dev_dbg(dev, "Realtek USB init: Set phy reset to 1\n");
+	USB_reset_deassert(reset_u2phy0);
+	USB_reset_deassert(reset_u3phy0);
+	USB_reset_deassert(reset_u2phy1);
+	USB_reset_deassert(reset_u2phy2);
+	USB_reset_deassert(reset_u2phy3);
+	USB_reset_deassert(reset_u3phy1);
+
+	USB_reset_deassert(reset_usb_apply);
+
+	udelay(300);
+
+	dev_dbg(dev, "Realtek USB init: Trigger usb clk\n");
+	// Trigger USB clk (enable -> disable)
+	clk_prepare_enable(clk_usb); // = clk_prepare + clk_enable
+	clk_disable_unprepare(clk_usb); // = clk_disable + clk_unprepare
+
+	dev_dbg(dev, "Realtek USB init: Set u3phy mdio reset to 1\n");
+	// Enable USB reset
+	USB_reset_deassert(reset_u3phy0_mdio);
+	USB_reset_deassert(reset_u3phy1_mdio);
+
+	USB_reset_deassert(reset_usb_apply);
+
+	dev_dbg(dev, "Realtek USB init: Set usb reset to 1\n");
+	USB_reset_deassert(reset_usb_host0);
+	USB_reset_deassert(reset_usb_host1);
+	USB_reset_deassert(reset_usb_host2);
+	USB_reset_deassert(reset_usb_host3);
+	USB_reset_deassert(reset_usb);
+	USB_reset_deassert(reset_type_c);
+	dev_dbg(dev, "Realtek USB init: enable usb clk\n");
+
+	// Enable USB clk
+	clk_prepare_enable(clk_usb); // = clk_prepare + clk_enable
+	clk_prepare_enable(clk_usb_phy0_to_host); // = clk_prepare + clk_enable
+	clk_prepare_enable(clk_usb_phy1_to_host); // = clk_prepare + clk_enable
+	clk_prepare_enable(clk_usb_phy2_to_host); // = clk_prepare + clk_enable
+	clk_prepare_enable(clk_usb_phy3_to_host); // = clk_prepare + clk_enable
+
+	dev_info(dev, "Realtek USB init OK\n");
+
+	clk_put(clk_usb);
+	clk_put(clk_usb_phy0_to_host);
+	clk_put(clk_usb_phy1_to_host);
+	clk_put(clk_usb_phy2_to_host);
+	clk_put(clk_usb_phy3_to_host);
+
+	USB_reset_put(reset_u2phy0);
+	USB_reset_put(reset_u2phy1);
+	USB_reset_put(reset_u2phy2);
+	USB_reset_put(reset_u2phy3);
+
+	USB_reset_put(reset_u3phy0);
+	USB_reset_put(reset_u3phy1);
+	USB_reset_put(reset_u3phy0_mdio);
+	USB_reset_put(reset_u3phy1_mdio);
+
+	USB_reset_put(reset_usb_host0);
+	USB_reset_put(reset_usb_host1);
+	USB_reset_put(reset_usb_host2);
+	USB_reset_put(reset_usb_host3);
+	USB_reset_put(reset_usb);
+	USB_reset_put(reset_type_c);
+
+	USB_reset_put(reset_usb_apply);
+
+	return 0;
+}
+
+static int __usb_clear_clock_reset(struct manager_data* data) {
+	struct device *dev = data->dev;
+	//void __iomem *crt_reg = data->crt_base;
+	/* GET clock */
+	struct clk *clk_usb_phy0_to_host = USB_clk_get(dev, "clk_en_phy0_to_host");
+	struct clk *clk_usb_phy1_to_host = USB_clk_get(dev, "clk_en_phy1_to_host");
+	struct clk *clk_usb_phy2_to_host = USB_clk_get(dev, "clk_en_phy2_to_host");
+	struct clk *clk_usb_phy3_to_host = USB_clk_get(dev, "clk_en_phy3_to_host");
+	struct clk *clk_usb = USB_clk_get(dev, "clk_en_usb");
+
+	/* GET reset controller */
+	struct reset_control *reset_u2phy0 = USB_reset_get(dev, "u2phy0");
+	struct reset_control *reset_u2phy1 = USB_reset_get(dev, "u2phy1");
+	struct reset_control *reset_u2phy2 = USB_reset_get(dev, "u2phy2");
+	struct reset_control *reset_u2phy3 = USB_reset_get(dev, "u2phy3");
+
+	struct reset_control *reset_u3phy0 = USB_reset_get(dev, "u3phy0");
+	struct reset_control *reset_u3phy1 = USB_reset_get(dev, "u3phy1");
+	struct reset_control *reset_u3phy0_mdio = USB_reset_get(dev, "u3mdio0");
+	struct reset_control *reset_u3phy1_mdio = USB_reset_get(dev, "u3mdio1");
+
+	struct reset_control *reset_usb_host0 = USB_reset_get(dev, "usb_host0");
+	struct reset_control *reset_usb_host1 = USB_reset_get(dev, "usb_host1");
+	struct reset_control *reset_usb_host2 = USB_reset_get(dev, "usb_host2");
+	struct reset_control *reset_usb_host3 = USB_reset_get(dev, "usb_host3");
+	struct reset_control *reset_usb = USB_reset_get(dev, "usb");
+	struct reset_control *reset_type_c = USB_reset_get(dev, "type_c");
+
+	struct reset_control *reset_usb_apply = USB_reset_get(dev, "apply");
+
+	dev_dbg(dev, "Realtek USB clear clock and reset\n");
+
+	USB_reset_assert(reset_u2phy0);
+	USB_reset_assert(reset_u2phy1);
+	USB_reset_assert(reset_u2phy2);
+	USB_reset_assert(reset_u2phy3);
+	USB_reset_assert(reset_u3phy0);
+	USB_reset_assert(reset_u3phy1);
+	USB_reset_assert(reset_u3phy0_mdio);
+	USB_reset_assert(reset_u3phy1_mdio);
+	USB_reset_assert(reset_usb_host0);
+	USB_reset_assert(reset_usb_host1);
+	USB_reset_assert(reset_usb_host2);
+	USB_reset_assert(reset_usb_host3);
+	USB_reset_assert(reset_usb);
+	USB_reset_assert(reset_type_c);
+	wmb();
+
+	clk_disable_unprepare(clk_usb); // = clk_disable + clk_unprepare
+	clk_disable_unprepare(clk_usb_phy0_to_host); // = clk_disable + clk_unprepare
+	clk_disable_unprepare(clk_usb_phy1_to_host); // = clk_disable + clk_unprepare
+	clk_disable_unprepare(clk_usb_phy2_to_host); // = clk_disable + clk_unprepare
+	clk_disable_unprepare(clk_usb_phy3_to_host); // = clk_disable + clk_unprepare
+
+	dev_info(dev, "Realtek USB clear clock and reset... OK\n");
+
+	clk_put(clk_usb);
+	clk_put(clk_usb_phy0_to_host);
+	clk_put(clk_usb_phy1_to_host);
+	clk_put(clk_usb_phy2_to_host);
+	clk_put(clk_usb_phy3_to_host);
+
+	USB_reset_put(reset_u2phy0);
+	USB_reset_put(reset_u2phy1);
+	USB_reset_put(reset_u2phy2);
+	USB_reset_put(reset_u2phy3);
+
+	USB_reset_put(reset_u3phy0);
+	USB_reset_put(reset_u3phy1);
+	USB_reset_put(reset_u3phy0_mdio);
+	USB_reset_put(reset_u3phy1_mdio);
+
+	USB_reset_put(reset_usb_host0);
+	USB_reset_put(reset_usb_host1);
+	USB_reset_put(reset_usb_host2);
+	USB_reset_put(reset_usb_host3);
+	USB_reset_put(reset_usb);
+	USB_reset_put(reset_type_c);
+
+	USB_reset_put(reset_usb_apply);
+
+	return 0;
+}
+
+__attribute__((weak))
+int rtk_type_c_init(struct rtk_usb *rtk_usb)
+{
+	pr_info("%s no implement by rtk_usb\n", __func__);
+}
+
+__attribute__((weak))
+int rtk_type_c_plug_config(struct rtk_usb *rtk_usb, int dr_mode, int cc)
+{
+	pr_info("%s no implement by rtk_usb\n", __func__);
+}
+
+int rtk_usb_type_c_init(struct device *type_c_dev)
+{
+	static struct manager_data *s_data = NULL;
+	struct device_node *node = NULL;
+	struct platform_device *pdev = NULL;
+	struct manager_data *data = NULL;
+	struct device *dev = NULL;
+
+	if (s_data == NULL) {
+		node = of_find_compatible_node(NULL, NULL, "Realtek,usb-manager");
+		if (node != NULL)
+			pdev = of_find_device_by_node(node);
+		if (pdev != NULL)
+			s_data = platform_get_drvdata(pdev);
+	}
+	data = s_data;
+	if (data == NULL) {
+		dev_err(data->dev, "%s ERROR no manager_data", __func__);
+		return -ENODEV;
+	}
+	dev = data->dev;
+	if (data->rtk_usb)
+		rtk_type_c_init(data->rtk_usb);
+	else
+		dev_info(data->dev, "%s No rtk_usb data", __func__);
+
+	return 0;
+}
+
+int rtk_usb_type_c_plug_config(struct device *type_c_dev,
+	    int dr_mode, int cc)
+{
+	static struct manager_data *s_data = NULL;
+	struct device_node *node = NULL;
+	struct platform_device *pdev = NULL;
+	struct manager_data *data = NULL;
+	struct device *dev = NULL;
+
+	if (s_data == NULL) {
+		node = of_find_compatible_node(NULL, NULL, "Realtek,usb-manager");
+		if (node != NULL)
+			pdev = of_find_device_by_node(node);
+		if (pdev != NULL)
+			s_data = platform_get_drvdata(pdev);
+	}
+	data = s_data;
+	if (data == NULL) {
+		dev_err(data->dev, "%s ERROR no manager_data", __func__);
+		return -ENODEV;
+	}
+	dev = data->dev;
+	if (data->rtk_usb)
+		rtk_type_c_plug_config(data->rtk_usb, dr_mode, cc);
+	else
+		dev_info(data->dev, "%s No rtk_usb data", __func__);
+
+	return 0;
+}
+
+static int __usb_port_power_on_off(struct device *dev,
+	    struct port_data *port, bool on,
+	    struct device_node *node);
+
+int rtk_usb_type_c_power_on_off(struct device *type_c_dev, bool on) {
+	static struct manager_data *s_data = NULL;
+	struct device_node *node = NULL;
+	struct platform_device *pdev = NULL;
+	struct manager_data *data = NULL;
+	int ret;
+
+	if (s_data == NULL) {
+		node = of_find_compatible_node(NULL, NULL, "Realtek,usb-manager");
+		if (node != NULL)
+			pdev = of_find_device_by_node(node);
+		if (pdev != NULL)
+			s_data = platform_get_drvdata(pdev);
+	}
+	data = s_data;
+	if (data == NULL) {
+		dev_err(data->dev, "%s ERROR no manager_data", __func__);
+		return -ENODEV;
+	}
+
+	dev_dbg(data->dev, "%s power %s for %s", __func__,
+			on?"on":"off", dev_name(type_c_dev));
+
+	mutex_lock(&data->lock);
+
+	ret = __usb_port_power_on_off(data->dev, &data->port0, on,
+		    type_c_dev->of_node);
+	if (ret)
+		ret = __usb_port_power_on_off(data->dev, &data->port1, on,
+			    type_c_dev->of_node);
+	if (ret)
+		ret = __usb_port_power_on_off(data->dev, &data->port2, on,
+			    type_c_dev->of_node);
+	if (ret)
+		ret = __usb_port_power_on_off(data->dev, &data->port3, on,
+			    type_c_dev->of_node);
+
+	mutex_unlock(&data->lock);
+
+	return ret;
+}
+
+static int __gpio_on_off(struct device *dev, int port, struct gpio_data *gpio, bool on)
+{
+	int ret = 0;
+	int gpio_num = gpio->gpio_num;
+	int enable_port_mask = gpio->enable_port_mask;
+	bool power_low_active = gpio->power_low_active;
+
+	if (gpio->gpio_num < 0) {
+		dev_dbg(dev, "%s No gpio config\n", __func__);
+		return 0;
+	}
+
+	if (on) {
+		gpio->enable_port |= BIT(port);
+		if ((gpio->enable_port & enable_port_mask) != enable_port_mask) {
+			dev_info(dev, "gpio_num=%d enable_port=0x%x enable_port_mask=0x%x "
+				    " ==> No turn on\n",
+				    gpio->gpio_num, gpio->enable_port, enable_port_mask);
+			return -1;
+		}
+	} else {
+		gpio->enable_port &= ~BIT(port);
+		if (gpio->enable_port != 0) {
+			dev_info(dev, "gpio_num=%d enable_port=0x%x enable_port_mask=0x%x "
+				    " ==> No turn off\n",
+				    gpio->gpio_num, gpio->enable_port, gpio->enable_port_mask);
+			return -1;
+		}
+	}
+
+	if (gpio_is_valid(gpio_num)) {
+		if (gpio_request(gpio_num, "usb_power_gpio")) {   //request gpio
+			dev_err(dev, "%s ERROR Request gpio_num (id=%d) fail\n",
+				   __func__, gpio_num);
+		} else {
+			if (gpio_direction_output(gpio_num, power_low_active?!on:on)) {
+				dev_err(dev, "%s ERROR set gpio fail\n", __func__);
+				ret = -1;
+			} else {
+				dev_info(dev, "%s to set power%s %s by gpio (id=%d) OK\n",
+					    __func__, power_low_active?" (power_low_active)":"",
+					    on?"on":"off", gpio_num);
+				gpio->power_enable = on;
+			}
+			gpio_free(gpio_num);
+		}
+	}
+	return ret;
+}
+
+static int __usb_port_power_on_off(struct device *dev,
+	    struct port_data *port, bool on,
+	    struct device_node *node)
+{
+	struct device_node *usb_node;
+
+	int enable_mask = port->enable_mask;
+
+	if (port->is_type_c) {
+		if (port->type_c_node && node &&
+			    port->type_c_node->phandle == node->phandle) {
+			dev_info(dev, "%s port%d is type_c\n",
+			    __func__, port->port_num);
+			usb_node = port->mac_node;
+		} else {
+			return -1;
+		}
+	} else {
+		usb_node = node;
+	}
+
+	if (port->mac_node && usb_node &&
+		    port->mac_node->phandle == usb_node->phandle) {
+		if (on)
+			port->enable |= BIT(0);
+		else
+			port->enable &= ~BIT(0);
+	} else if (port->slave_mac_node && usb_node &&
+		    port->slave_mac_node->phandle == usb_node->phandle) {
+		if (on)
+			port->enable |= BIT(1);
+		else
+			port->enable &= ~BIT(1);
+	} else {
+		dev_dbg(dev, "%s port%d is not match\n", __func__, port->port_num);
+		return -1;
+	}
+
+	dev_info(dev, "%s port%d power=%s enable=0x%x enable_mask=0x%x\n",
+		    __func__, port->port_num, on?"on":"off",
+		    port->enable, port->enable_mask);
+	if (((port->enable & enable_mask) == enable_mask) ||
+		    (!port->enable && !on)) {
+		if (port->power_gpio)
+			__gpio_on_off(dev, port->port_num, port->power_gpio, on);
+		else
+			dev_info(dev, "%s port%d no gpio\n", __func__, port->port_num);
+	}
+	return 0;
+}
+
+static int __usb_port_suspend(struct manager_data *data) {
+	struct device *dev = data->dev;
+	bool is_suspend = true;
+
+	if (!data->rtk_usb)
+		return;
+
+	dev_info(dev, "%s", __func__);
+	if (data->port0.port_num >= 0) {
+		dev_dbg(dev, "set port 0 phy suspend\n");
+		rtk_usb_port_suspend_resume(data->rtk_usb, USB_PORT_0, is_suspend);
+	}
+	if (data->port1.port_num >= 0) {
+		dev_dbg(dev, "set port 1 phy suspend\n");
+		rtk_usb_port_suspend_resume(data->rtk_usb, USB_PORT_1, is_suspend);
+	}
+	if (data->port2.port_num >= 0) {
+		dev_dbg(dev, "set port 2 phy suspend\n");
+		rtk_usb_port_suspend_resume(data->rtk_usb, USB_PORT_2, is_suspend);
+	}
+	if (data->port3.port_num >= 0) {
+		dev_dbg(dev, "set port 3 phy suspend\n");
+		rtk_usb_port_suspend_resume(data->rtk_usb, USB_PORT_3, is_suspend);
+	}
+	return 0;
+}
+
+static int __usb_port_resume(struct manager_data *data) {
+	struct device *dev = data->dev;
+	//void __iomem *reg_u3_port;
+	//void __iomem *reg_u2_port;
+	bool is_suspend = false;
+
+	if (!data->rtk_usb)
+		return;
+
+	dev_info(dev, "%s", __func__);
+	if (data->port0.port_num >= 0) {
+		dev_dbg(dev, "set port 0 phy resume\n");
+		rtk_usb_port_suspend_resume(data->rtk_usb, USB_PORT_0, is_suspend);
+	}
+	if (data->port1.port_num >= 0) {
+		dev_dbg(dev, "set port 1 phy resume\n");
+		rtk_usb_port_suspend_resume(data->rtk_usb, USB_PORT_1, is_suspend);
+	}
+	if (data->port2.port_num >= 0) {
+		dev_dbg(dev, "set port 2 phy resume\n");
+		rtk_usb_port_suspend_resume(data->rtk_usb, USB_PORT_2, is_suspend);
+	}
+	if (data->port3.port_num >= 0) {
+		dev_dbg(dev, "set port 3 phy resume\n");
+		rtk_usb_port_suspend_resume(data->rtk_usb, USB_PORT_3, is_suspend);
+	}
+	return 0;
+}
+
+static int __usb_port_gpio_off(struct manager_data *data)
+{
+	struct device *dev = data->dev;
+	struct device_node *usb_node;
+	bool off = false;
+
+	dev_info(dev, "%s", __func__);
+	mutex_lock(&data->lock);
+
+	usb_node = data->port0.mac_node;
+	__usb_port_power_on_off(data->dev, &data->port0, off, usb_node);
+	usb_node = data->port0.slave_mac_node;
+	__usb_port_power_on_off(data->dev, &data->port0, off, usb_node);
+
+	usb_node = data->port1.mac_node;
+	__usb_port_power_on_off(data->dev, &data->port1, off, usb_node);
+	usb_node = data->port1.slave_mac_node;
+	__usb_port_power_on_off(data->dev, &data->port1, off, usb_node);
+
+	usb_node = data->port2.mac_node;
+	__usb_port_power_on_off(data->dev, &data->port2, off, usb_node);
+	usb_node = data->port2.slave_mac_node;
+	__usb_port_power_on_off(data->dev, &data->port2, off, usb_node);
+
+	usb_node = data->port3.mac_node;
+	__usb_port_power_on_off(data->dev, &data->port3, off, usb_node);
+	usb_node = data->port3.slave_mac_node;
+	__usb_port_power_on_off(data->dev, &data->port3, off, usb_node);
+
+	mutex_unlock(&data->lock);
+
+	return 0;
+}
+
+static int __usb_port_gpio_on(struct manager_data *data) {
+	struct device *dev = data->dev;
+	struct device_node *usb_node;
+	bool on = true;
+
+	dev_info(dev, "%s", __func__);
+
+	mutex_lock(&data->lock);
+
+	usb_node = data->port0.mac_node;
+	__usb_port_power_on_off(data->dev, &data->port0, on, usb_node);
+	usb_node = data->port0.slave_mac_node;
+	__usb_port_power_on_off(data->dev, &data->port0, on, usb_node);
+
+	usb_node = data->port1.mac_node;
+	__usb_port_power_on_off(data->dev, &data->port1, on, usb_node);
+	usb_node = data->port1.slave_mac_node;
+	__usb_port_power_on_off(data->dev, &data->port1, on, usb_node);
+
+	usb_node = data->port2.mac_node;
+	__usb_port_power_on_off(data->dev, &data->port2, on, usb_node);
+	usb_node = data->port2.slave_mac_node;
+	__usb_port_power_on_off(data->dev, &data->port2, on, usb_node);
+
+	usb_node = data->port3.mac_node;
+	__usb_port_power_on_off(data->dev, &data->port3, on, usb_node);
+	usb_node = data->port3.slave_mac_node;
+	__usb_port_power_on_off(data->dev, &data->port3, on, usb_node);
+
+	mutex_unlock(&data->lock);
+
+	return 0;
+}
+
+int rtk_usb_init_port_power_on(struct device *usb_dev)
+{
+	struct device_node *usb_node = usb_dev->of_node;
+	struct device_node *node = of_find_compatible_node(NULL, NULL,
+		    "Realtek,usb-manager");
+	struct platform_device *pdev = NULL;
+	static struct manager_data *data = NULL;
+	bool on = true;
+
+	if (data == NULL) {
+		if (node != NULL)
+			pdev = of_find_device_by_node(node);
+		if (pdev != NULL) {
+			data = platform_get_drvdata(pdev);
+		}
+	}
+	if (data == NULL) {
+		dev_err(data->dev, "%s ERROR no manager_data", __func__);
+		return -ENODEV;
+	}
+
+	dev_info(data->dev, "%s for %s", __func__, dev_name(usb_dev));
+	mutex_lock(&data->lock);
+
+	__usb_port_power_on_off(data->dev, &data->port0, on, usb_node);
+	__usb_port_power_on_off(data->dev, &data->port1, on, usb_node);
+	__usb_port_power_on_off(data->dev, &data->port2, on, usb_node);
+	__usb_port_power_on_off(data->dev, &data->port3, on, usb_node);
+
+	mutex_unlock(&data->lock);
+	return 0;
+}
+
+static void __usb_gpio_init(struct device *dev, struct gpio_data *gpio)
+{
+	bool off = false;
+
+	gpio->enable_port = 0;
+	__gpio_on_off(dev, -1, gpio, off);
+
+}
+static int rtk_usb_gpio_init(struct manager_data *data)
+{
+	__usb_gpio_init(data->dev, &data->gpio0);
+	__usb_gpio_init(data->dev, &data->gpio1);
+	__usb_gpio_init(data->dev, &data->gpio2);
+	__usb_gpio_init(data->dev, &data->gpio3);
+
+	return 0;
+}
+
+static int rtk_usb_manager_init(struct manager_data *data) {
+	struct device *dev = data->dev;
+
+	dev_dbg(dev, "Realtek USB init ....\n");
+
+	__usb_set_pd_power(data, 1);
+
+	if (data->disable_usb) {
+		dev_err(dev, "Realtek USB No any usb be enabled ....\n");
+		return 0;
+	}
+
+	__usb_init_clock_reset(data);
+
+	rtk_usb_gpio_init(data);
+
+	__rtk_usb_set_hw_pm_enable(data);
+
+	dev_dbg(dev, "Realtek USB init Done\n");
+
+	return 0;
+}
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+static int rtk_port0_power_show(struct seq_file *s, void *unused)
+{
+	struct manager_data		*data = s->private;
+
+	seq_printf(s, "To Control Port 0\n");
+	seq_printf(s, "echo \"on\" > port0_power\n");
+	seq_printf(s, "echo \"off\" > port0_power\n");
+	seq_printf(s, "\n");
+	if (data->port0.power_gpio) {
+		struct gpio_data *gpio = data->port0.power_gpio;
+
+		seq_printf(s, "Now port0 %s\n", gpio->power_enable?"on":"off");
+	} else {
+		seq_printf(s, "port0 No control gpio\n");
+	}
+
+	return 0;
+}
+
+static int rtk_port0_power_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_port0_power_show, inode->i_private);
+}
+
+static ssize_t rtk_port0_power_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct manager_data		*data = s->private;
+	char			buffer[40];
+	char *buf = buffer;
+	struct device_node *usb_node;
+
+	if (copy_from_user(&buffer, ubuf, min_t(size_t, sizeof(buffer) - 1, count)))
+		return -EFAULT;
+
+	mutex_lock(&data->lock);
+	if (!strncmp(buf, "on", 2)) {
+		usb_node = data->port0.mac_node;
+		__usb_port_power_on_off(data->dev, &data->port0, true, usb_node);
+		usb_node = data->port0.slave_mac_node;
+		__usb_port_power_on_off(data->dev, &data->port0, true, usb_node);
+	} else if (!strncmp(buf, "off", 3)) {
+		usb_node = data->port0.mac_node;
+		__usb_port_power_on_off(data->dev, &data->port0, false, usb_node);
+		usb_node = data->port0.slave_mac_node;
+		__usb_port_power_on_off(data->dev, &data->port0, false, usb_node);
+	} else
+		dev_err(data->dev, "UNKNOWN input (%s)", buf);
+
+	mutex_unlock(&data->lock);
+	return count;
+}
+
+static const struct file_operations rtk_port0_power_fops = {
+	.open			= rtk_port0_power_open,
+	.write			= rtk_port0_power_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int rtk_port1_power_show(struct seq_file *s, void *unused)
+{
+	struct manager_data		*data = s->private;
+
+	seq_printf(s, "To Control Port 1 (DWC3 u2host power)\n");
+	seq_printf(s, "echo \"on\" > port1_power\n");
+	seq_printf(s, "echo \"off\" > port1_power\n");
+	seq_printf(s, "\n");
+	if (data->port1.power_gpio) {
+		struct gpio_data *gpio = data->port1.power_gpio;
+
+		seq_printf(s, "Now port1 %s\n", gpio->power_enable?"on":"off");
+	} else {
+		seq_printf(s, "port1 No control gpio\n");
+	}
+	return 0;
+}
+
+static int rtk_port1_power_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_port1_power_show, inode->i_private);
+}
+
+static ssize_t rtk_port1_power_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct manager_data		*data = s->private;
+	char			buffer[40];
+	char *buf = buffer;
+	struct device_node *usb_node;
+
+	if (copy_from_user(&buffer, ubuf, min_t(size_t, sizeof(buffer) - 1, count)))
+		return -EFAULT;
+
+	mutex_lock(&data->lock);
+	if (!strncmp(buf, "on", 2)) {
+		usb_node = data->port1.mac_node;
+		__usb_port_power_on_off(data->dev, &data->port1, true, usb_node);
+		usb_node = data->port1.slave_mac_node;
+		__usb_port_power_on_off(data->dev, &data->port1, true, usb_node);
+	} else if (!strncmp(buf, "off", 3)) {
+		usb_node = data->port1.mac_node;
+		__usb_port_power_on_off(data->dev, &data->port1, false, usb_node);
+		usb_node = data->port1.slave_mac_node;
+		__usb_port_power_on_off(data->dev, &data->port1, false, usb_node);
+	} else
+		dev_err(data->dev, "UNKNOWN input (%s)", buf);
+
+	mutex_unlock(&data->lock);
+	return count;
+}
+
+static const struct file_operations rtk_port1_power_fops = {
+	.open			= rtk_port1_power_open,
+	.write			= rtk_port1_power_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int rtk_port2_power_show(struct seq_file *s, void *unused)
+{
+	struct manager_data		*data = s->private;
+
+	seq_printf(s, "To Control Port 2 (EHCI/OHCI power)\n");
+	seq_printf(s, "echo \"on\" > port2_power\n");
+	seq_printf(s, "echo \"off\" > port2_power\n");
+	seq_printf(s, "\n");
+	if (data->port2.power_gpio) {
+		struct gpio_data *gpio = data->port2.power_gpio;
+
+		seq_printf(s, "Now port2 %s\n", gpio->power_enable?"on":"off");
+	} else {
+		seq_printf(s, "port2 No control gpio\n");
+	}
+	return 0;
+}
+
+static int rtk_port2_power_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_port2_power_show, inode->i_private);
+}
+
+static ssize_t rtk_port2_power_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct manager_data		*data = s->private;
+	char			buffer[40];
+	char *buf = buffer;
+	struct device_node *usb_node;
+
+	if (copy_from_user(&buffer, ubuf, min_t(size_t, sizeof(buffer) - 1, count)))
+		return -EFAULT;
+
+	mutex_lock(&data->lock);
+	if (!strncmp(buf, "on", 2)) {
+		usb_node = data->port2.mac_node;
+		__usb_port_power_on_off(data->dev, &data->port2, true, usb_node);
+		usb_node = data->port2.slave_mac_node;
+		__usb_port_power_on_off(data->dev, &data->port2, true, usb_node);
+
+	} else if (!strncmp(buf, "off", 3)) {
+		usb_node = data->port2.mac_node;
+		__usb_port_power_on_off(data->dev, &data->port2, false, usb_node);
+		usb_node = data->port2.slave_mac_node;
+		__usb_port_power_on_off(data->dev, &data->port2, false, usb_node);
+	} else
+		dev_err(data->dev, "UNKNOWN input (%s)", buf);
+
+	mutex_unlock(&data->lock);
+	return count;
+}
+
+static const struct file_operations rtk_port2_power_fops = {
+	.open			= rtk_port2_power_open,
+	.write			= rtk_port2_power_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int rtk_port3_power_show(struct seq_file *s, void *unused)
+{
+	struct manager_data		*data = s->private;
+
+	seq_printf(s, "To Control Port 3 (DWC3 u3host power)\n");
+	seq_printf(s, "echo \"on\" > port3_power\n");
+	seq_printf(s, "echo \"off\" > port3_power\n");
+	seq_printf(s, "\n");
+	if (data->port3.power_gpio) {
+		struct gpio_data *gpio = data->port3.power_gpio;
+
+		seq_printf(s, "Now port3 %s\n", gpio->power_enable?"on":"off");
+	} else {
+		seq_printf(s, "port3 No control gpio\n");
+	}
+	return 0;
+}
+
+static int rtk_port3_power_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_port3_power_show, inode->i_private);
+}
+
+static ssize_t rtk_port3_power_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct manager_data		*data = s->private;
+	char			buffer[40];
+	char *buf = buffer;
+	struct device_node *usb_node;
+
+	if (copy_from_user(&buffer, ubuf, min_t(size_t, sizeof(buffer) - 1, count)))
+		return -EFAULT;
+
+	mutex_lock(&data->lock);
+	if (!strncmp(buf, "on", 2)) {
+		usb_node = data->port3.mac_node;
+		__usb_port_power_on_off(data->dev, &data->port3, true, usb_node);
+		usb_node = data->port3.slave_mac_node;
+		__usb_port_power_on_off(data->dev, &data->port3, true, usb_node);
+	} else if (!strncmp(buf, "off", 3)) {
+		usb_node = data->port3.mac_node;
+		__usb_port_power_on_off(data->dev, &data->port3, false, usb_node);
+		usb_node = data->port3.slave_mac_node;
+		__usb_port_power_on_off(data->dev, &data->port3, false, usb_node);
+	} else
+		dev_err(data->dev, "UNKNOWN input (%s)", buf);
+
+	mutex_unlock(&data->lock);
+	return count;
+}
+
+static const struct file_operations rtk_port3_power_fops = {
+	.open			= rtk_port3_power_open,
+	.write			= rtk_port3_power_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int rtk_iso_mode_show(struct seq_file *s, void *unused)
+{
+	struct manager_data		*data = s->private;
+
+	mutex_lock(&data->lock);
+
+	seq_printf(s, "usb_iso_mode %s\n", data->usb_iso_mode?"Enable":"Disable");
+
+	mutex_unlock(&data->lock);
+
+	return 0;
+}
+
+static int rtk_iso_mode_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_iso_mode_show, inode->i_private);
+}
+
+static ssize_t rtk_iso_mode_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct manager_data		*data = s->private;
+	char			buffer[40];
+	char *buf = buffer;
+
+	if (copy_from_user(&buffer, ubuf, min_t(size_t, sizeof(buffer) - 1, count)))
+		return -EFAULT;
+
+	mutex_lock(&data->lock);
+	if (!strncmp(buf, "enable", 6)) {
+		data->usb_iso_mode = true;
+	} else if (!strncmp(buf, "disable", 7)) {
+		data->usb_iso_mode = false;
+	} else
+		dev_err(data->dev, "UNKNOWN input (%s)", buf);
+
+	mutex_unlock(&data->lock);
+	return count;
+}
+
+static const struct file_operations rtk_iso_mode_fops = {
+	.open			= rtk_iso_mode_open,
+	.write			= rtk_iso_mode_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static void __debug_dump_gpio_info(struct seq_file *s, struct gpio_data *gpio)
+{
+	if (!gpio)
+		return;
+
+	seq_printf(s, "    gpio info:\n");
+	if (gpio->gpio_num < 0) {
+		seq_printf(s, "        No gpio\n");
+		return;
+	}
+	seq_printf(s, "       gpio_num=%d\n", gpio->gpio_num);
+	seq_printf(s, "       enable_port=0x%x enable_port_mask=0x%x\n",
+		    gpio->enable_port, gpio->enable_port_mask);
+	seq_printf(s, "       power %s%s\n",
+		    gpio->power_enable?"enable":"disable",
+		    gpio->power_low_active?" (power_low_active)":"");
+}
+
+static void __debug_dump_port_info(struct seq_file *s, struct port_data *port)
+{
+	if (port->port_num < 0)
+		return 0;
+
+	seq_printf(s, "port%d info:\n", port->port_num);
+	seq_printf(s, "    port_num=%d\n", port->port_num);
+	seq_printf(s, "    power_gpio@%p\n", port->power_gpio);
+	__debug_dump_gpio_info(s, port->power_gpio);
+	seq_printf(s, "    mac_node=%s\n",
+		    port->mac_node?port->mac_node->name:"NULL");
+	seq_printf(s, "    slave_mac_node=%s\n",
+		    port->slave_mac_node?port->slave_mac_node->name:"NULL");
+	seq_printf(s, "    type_c=%s\n",
+		    port->type_c_node?port->type_c_node->name:"NULL");
+	seq_printf(s, "    enable=0x%x (enable_mask=0x%x)\n",
+		    port->enable, port->enable_mask);
+	seq_printf(s, "    is%s type_c port\n", port->is_type_c?"":" not");
+}
+
+static int rtk_usb_debug_show(struct seq_file *s, void *unused)
+{
+	struct manager_data		*data = s->private;
+
+	seq_printf(s, "rtk usb manager info:\n");
+	__debug_dump_port_info(s, &data->port0);
+	__debug_dump_port_info(s, &data->port1);
+	__debug_dump_port_info(s, &data->port2);
+	__debug_dump_port_info(s, &data->port3);
+
+	return 0;
+}
+
+static int rtk_usb_debug_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_usb_debug_show, inode->i_private);
+}
+
+static const struct file_operations rtk_usb_debug_fops = {
+	.open			= rtk_usb_debug_open,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static inline void create_debug_files(struct manager_data *data) {
+
+	dev_err(data->dev, "%s", __func__);
+
+	data->debug_dir = debugfs_create_dir("usb_manager", usb_debug_root);
+	if (!data->debug_dir) {
+		dev_err(data->dev, "%s Error debug_dir is NULL", __func__);
+		return;
+	}
+
+	if (data->port0.port_num >= 0
+			&& !debugfs_create_file("port0_power", S_IRUGO | S_IWUSR,
+					data->debug_dir, data, &rtk_port0_power_fops))
+		goto file_error;
+
+	if (data->port1.port_num >= 0
+			&& !debugfs_create_file("port1_power", S_IRUGO | S_IWUSR,
+					data->debug_dir, data, &rtk_port1_power_fops))
+		goto file_error;
+
+	if (data->port2.port_num >= 0
+			&& !debugfs_create_file("port2_power", S_IRUGO | S_IWUSR,
+					data->debug_dir, data, &rtk_port2_power_fops))
+		goto file_error;
+
+	if (data->port3.port_num >= 0
+			&& !debugfs_create_file("port3_power", S_IRUGO | S_IWUSR,
+					data->debug_dir, data, &rtk_port3_power_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("usb_iso_mode", S_IRUGO | S_IWUSR,
+					data->debug_dir, data, &rtk_iso_mode_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("debug", S_IRUGO, data->debug_dir, data,
+						&rtk_usb_debug_fops))
+		goto file_error;
+
+	return;
+
+file_error:
+	debugfs_remove_recursive(data->debug_dir);
+}
+#endif //CONFIG_DYNAMIC_DEBUG
+
+static inline int __of_parse_gpio_setting(struct manager_data *data,
+	    struct gpio_data *gpio,
+	    struct device_node *sub_node)
+{
+	int gpio_num;
+
+	if (!sub_node) {
+		gpio->gpio_num = -1;
+		return -1;
+	}
+
+	gpio->node = sub_node;
+
+	gpio_num = of_get_named_gpio(sub_node, "realtek,power-gpio", 0);
+	if (gpio_is_valid(gpio_num)) {
+		gpio->gpio_num = gpio_num;
+ 	} else {
+		gpio->gpio_num = -1;
+		dev_info(data->dev, "%s power-gpio no found\n", __func__);
+		return -1;
+	}
+
+	if (of_property_read_bool(sub_node, "power_low_active")) {
+		gpio->power_low_active = true;
+	} else {
+		gpio->power_low_active = false;
+	}
+
+	return 0;
+}
+
+static int parse_gpio_setting(struct manager_data *data,
+	    struct device_node *node)
+{
+	struct device *dev = data->dev;
+	struct device_node	*sub_node;
+
+	sub_node = of_get_child_by_name(node, "gpio0");
+
+	if (__of_parse_gpio_setting(data, &data->gpio0, sub_node)) {
+		dev_dbg(dev, "node gpio0 no found in dts\n");
+	} else {
+		dev_info(dev, "%s get power-gpio (id=%d) OK\n",
+			    __func__, data->gpio0.gpio_num);
+	}
+
+	sub_node = of_get_child_by_name(node, "gpio1");
+	if (__of_parse_gpio_setting(data, &data->gpio1, sub_node)) {
+		dev_dbg(dev, "node gpio1 no found in dts\n");
+	} else {
+		dev_info(dev, "%s get power-gpio (id=%d) OK\n",
+			    __func__, data->gpio1.gpio_num);
+	}
+
+	sub_node = of_get_child_by_name(node, "gpio2");
+	if (__of_parse_gpio_setting(data, &data->gpio2, sub_node)) {
+		dev_dbg(dev, "node gpio2 no found in dts\n");
+	} else {
+		dev_info(dev, "%s get power-gpio (id=%d) OK\n",
+			    __func__, data->gpio2.gpio_num);
+	}
+
+	sub_node = of_get_child_by_name(node, "gpio3");
+	if (__of_parse_gpio_setting(data, &data->gpio3, sub_node)) {
+		dev_dbg(dev, "node gpio3 no found in dts\n");
+	} else {
+		dev_info(dev, "%s get power-gpio (id=%d) OK\n", __func__,
+			    __func__, data->gpio3.gpio_num);
+	}
+
+	return 0;
+}
+
+static inline struct gpio_data *__of_parse_port_gpio_mapping(
+	    struct manager_data *data,
+	    struct device_node *port_node, int port_num)
+{
+	struct device_node *gpio_node;
+	struct gpio_data *gpio;
+
+	gpio_node = of_parse_phandle(port_node, "gpio", 0);
+
+	gpio = &data->gpio0;
+	if (gpio->gpio_num >= 0 &&
+		    gpio->node &&  gpio_node &&
+		    gpio->node->phandle == gpio_node->phandle) {
+		gpio->enable_port_mask |= BIT(port_num);
+		dev_info(data->dev, "%s port%d mapping gpio_num=%d\n",
+			    __func__, port_num, gpio->gpio_num);
+		return gpio;
+	}
+
+	gpio = &data->gpio1;
+	if (gpio->gpio_num >= 0 &&
+		    gpio->node &&  gpio_node &&
+		    gpio->node->phandle == gpio_node->phandle) {
+		gpio->enable_port_mask |= BIT(port_num);
+		dev_info(data->dev, "%s port%d mapping gpio_num=%d\n",
+			    __func__, port_num, gpio->gpio_num);
+		return gpio;
+	}
+
+	gpio = &data->gpio2;
+	if (gpio->gpio_num >= 0 &&
+		    gpio->node &&  gpio_node &&
+		    gpio->node->phandle == gpio_node->phandle) {
+		gpio->enable_port_mask |= BIT(port_num);
+		dev_info(data->dev, "%s port%d mapping gpio_num=%d\n",
+			    __func__, port_num, gpio->gpio_num);
+		return gpio;
+	}
+
+	gpio = &data->gpio3;
+	if (gpio->gpio_num >= 0 &&
+		    gpio->node &&  gpio_node &&
+		    gpio->node->phandle == gpio_node->phandle) {
+		gpio->enable_port_mask |= BIT(port_num);
+		dev_info(data->dev, "%s port%d mapping gpio_num=%d\n",
+			    __func__, port_num, gpio->gpio_num);
+		return gpio;
+	}
+
+	dev_info(data->dev, "%s port%d No mapping GPIO\n", __func__, port_num);
+	return NULL;
+}
+
+static inline void __of_parse_port_setting(struct manager_data *data,
+	    struct port_data *port,
+	    struct device_node *port_node, int port_num)
+{
+	if (!port_node) {
+		port->port_num = -1;
+		return;
+	}
+	port->port_num = port_num;
+
+	port->mac_node = of_parse_phandle(port_node, "usb", 0);
+	port->slave_mac_node = of_parse_phandle(port_node, "usb", 1);
+	port->type_c_node = of_parse_phandle(port_node, "type_c", 0);
+
+	port->enable = 0;
+	port->enable_mask = 0;
+	port->is_type_c = false;
+
+	if (port->mac_node &&
+		    of_device_is_available(port->mac_node)) {
+		pr_info("mac_node: %s status is okay\n",
+			    port->mac_node->name);
+		port->enable_mask |= BIT(0);
+	}
+	if (port->slave_mac_node &&
+		    of_device_is_available(port->slave_mac_node)) {
+		pr_info("slave_mac_node: %s status is okay\n",
+			    port->slave_mac_node->name);
+		port->enable_mask |= BIT(1);
+	}
+	if (port->type_c_node &&
+		    of_device_is_available(port->type_c_node)) {
+		pr_info("type_c_node: %s status is okay\n",
+			    port->type_c_node->name);
+		port->is_type_c = true;
+	}
+
+	if (port->enable_mask)
+		port->power_gpio = __of_parse_port_gpio_mapping(data,
+			    port_node, port->port_num);
+
+	port->node = port_node;
+}
+
+static int parse_port_setting(struct manager_data *data,
+	    struct device_node *node)
+{
+	struct device_node	*sub_node;
+	struct port_data *port;
+
+	data->disable_usb = true;
+
+	sub_node = of_get_child_by_name(node, "port0");
+	__of_parse_port_setting(data, &data->port0, sub_node, 0);
+	sub_node = of_get_child_by_name(node, "port1");
+	__of_parse_port_setting(data, &data->port1, sub_node, 1);
+	sub_node = of_get_child_by_name(node, "port2");
+	__of_parse_port_setting(data, &data->port2, sub_node, 2);
+	sub_node = of_get_child_by_name(node, "port3");
+	__of_parse_port_setting(data, &data->port3, sub_node, 3);
+
+	if (data->port0.port_num >= 0 || data->port1.port_num >= 0 ||
+		    data->port2.port_num >= 0 || data->port3.port_num >= 0) {
+		data->disable_usb = false;
+	}
+
+	return 0;
+}
+
+static int rtk_usb_manager_probe(struct platform_device *pdev)
+{
+	struct device		*dev = &pdev->dev;
+	struct device_node	*node = dev->of_node;
+	struct device_node	*sub_node;
+	struct device_node	*np;
+	struct manager_data 	*data;
+	unsigned int gpio;
+	int ret = 0;
+	unsigned long probe_time = jiffies;
+
+	dev_info(dev, "ENTER %s", __func__);
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	data->crt_base = of_iomap(pdev->dev.of_node, 0);
+	if (data->crt_base == NULL) {
+		dev_err(&pdev->dev, "error mapping memory for crt_base\n");
+		ret = -EFAULT;
+		goto err1;
+	}
+	data->dev = dev;
+
+	if (node && of_device_is_available(node)) {
+		if (of_property_read_bool(node, "usb_iso_mode"))
+			data->usb_iso_mode = true;
+		else
+			data->usb_iso_mode = false;
+
+		if (of_property_read_bool(node, "en_usb_storage_reprobe"))
+			data->en_usb_storage_reprobe = true;
+		else
+			data->en_usb_storage_reprobe = false;
+
+		if (of_property_read_bool(node, "rescue_usb"))
+			data->rescue_usb = true;
+		else
+			data->rescue_usb = false;
+
+		if (of_property_read_bool(node, "dis_hub_autosuspend"))
+			data->dis_hub_autosuspend = true;
+		else
+			data->dis_hub_autosuspend = false;
+	}
+
+	if (node && of_device_is_available(node)) {
+
+		ret = parse_gpio_setting(data, node);
+
+		ret = parse_port_setting(data, node);
+
+		sub_node = of_get_child_by_name(node, "rtk_usb");
+		if (sub_node) {
+			data->rtk_usb = rtk_usb_soc_init(sub_node);
+		} else {
+			data->rtk_usb = NULL;
+		}
+	}
+
+	mutex_init(&data->lock);
+
+	rtk_usb_manager_init(data);
+
+	platform_set_drvdata(pdev, data);
+
+	data->wq_usb_manager = create_singlethread_workqueue("rtk_usb_manager");
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	create_debug_files(data);
+#endif
+
+	dev_info(&pdev->dev, "%s OK (take %d ms)\n", __func__,
+		    jiffies_to_msecs(jiffies - probe_time));
+	return 0;
+
+err1:
+	dev_err(&pdev->dev, "%s: Probe fail, %d\n", __func__, ret);
+
+	return ret;
+}
+
+static int rtk_usb_manager_remove(struct platform_device *pdev) {
+	dev_info(&pdev->dev, "%s\n", __func__);
+	return 0;
+}
+
+#ifdef CONFIG_OF
+static const struct of_device_id rtk_usb_manager_match[] = {
+	{ .compatible = "Realtek,usb-manager" },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_usb_manager_match);
+#endif
+
+#ifdef CONFIG_PM_SLEEP
+
+static int rtk_usb_manager_prepare(struct device *dev) {
+	struct manager_data *data = dev_get_drvdata(dev);
+	int ret = 0;
+
+	dev_info(dev, "[USB] Enter %s\n", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+	} else {
+		dev_info(dev,  "[USB] %s Suspend mode\n", __func__);
+	}
+	dev_info(dev, "[USB] Exit %s\n", __func__);
+	return ret;
+}
+
+static void rtk_usb_manager_complete(struct device *dev) {
+	struct manager_data *data = dev_get_drvdata(dev);
+
+	dev_info(dev, "[USB] Enter %s\n", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		dev_info(dev, "[USB] %s S1 (Standby mode)\n", __func__);
+	} else {
+		dev_info(dev, "[USB] %s S3 (Suspend-to-RAM mode)\n", __func__);
+	}
+	dev_info(dev, "[USB] Exit %s\n", __func__);
+}
+
+static int rtk_usb_manager_suspend(struct device *dev) {
+	struct manager_data *data = dev_get_drvdata(dev);
+
+	dev_info(dev, "[USB] Enter %s\n", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		dev_info(dev, "[USB] %s S1 (Standby mode)\n", __func__);
+	} else {
+		//For suspend mode
+		dev_info(dev, "[USB] %s S3 (Suspend-to-RAM mode) %susb_iso_mode\n",
+			    __func__, data->usb_iso_mode?"":"NOT ");
+		if (!data->usb_iso_mode) {
+			__usb_port_gpio_off(data);
+			__usb_set_pd_power(data, 0);
+		} else {
+			__usb_port_suspend(data);
+		}
+
+	}
+	dev_info(dev, "[USB] Exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_usb_manager_resume(struct device *dev) {
+	struct manager_data *data = dev_get_drvdata(dev);
+	struct clk *clk_usb = USB_clk_get(NULL, "clk_en_usb");
+
+	dev_info(dev, "[USB] Enter %s\n", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		dev_info(dev, "[USB] %s S1 (Standby mode)\n", __func__);
+	} else {
+		//For suspend mode
+		dev_info(dev, "[USB] %s S3 (Suspend-to-RAM mode) %susb_iso_mode\n",
+			    __func__, data->usb_iso_mode?"":"NOT ");
+
+		if (!data->usb_iso_mode) {
+			__usb_set_pd_power(data, 1);
+
+			clk_disable_unprepare(clk_usb); // = clk_disable + clk_unprepare
+			__usb_init_clock_reset(data);
+
+			__rtk_usb_set_hw_pm_enable(data);
+
+		} else {
+			__usb_port_resume(data);
+		}
+		__usb_port_gpio_on(data);
+	}
+	dev_info(dev, "[USB] Exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_usb_manager_pm_ops = {
+	.prepare = rtk_usb_manager_prepare,
+	.complete = rtk_usb_manager_complete,
+	SET_LATE_SYSTEM_SLEEP_PM_OPS(rtk_usb_manager_suspend, rtk_usb_manager_resume)
+};
+
+#define DEV_PM_OPS	(&rtk_usb_manager_pm_ops)
+#else
+#define DEV_PM_OPS	NULL
+#endif /* CONFIG_PM_SLEEP */
+
+static void rtk_usb_manager_shutdown(struct platform_device *pdev)
+{
+	struct device		*dev = &pdev->dev;
+	struct manager_data *data = dev_get_drvdata(dev);
+
+	dev_info(dev, "[USB] Enter %s S5 (shutdown)\n",
+		    __func__);
+
+	rtk_usb_gpio_init(data);
+	__usb_set_pd_power(data, 0);
+	__usb_clear_clock_reset(data);
+
+	dev_info(dev, "[USB] Exit %s\n", __func__);
+	return 0;
+}
+
+static struct platform_driver rtk_usb_manager_driver = {
+	.probe		= rtk_usb_manager_probe,
+	.remove		= rtk_usb_manager_remove,
+	.driver		= {
+		.name	= "rtk-usb-manager",
+		.of_match_table = of_match_ptr(rtk_usb_manager_match),
+		.pm = DEV_PM_OPS,
+	},
+	.shutdown = rtk_usb_manager_shutdown,
+};
+
+static int __init rtk_usb_manager_driver_init(void) {
+	return platform_driver_register(&(rtk_usb_manager_driver));
+}
+subsys_initcall(rtk_usb_manager_driver_init);
+
+static void __exit rtk_usb_manager_driver_exit(void) {
+	platform_driver_unregister(&(rtk_usb_manager_driver));
+}
+
+MODULE_ALIAS("platform:rtk-usb-manager");
+MODULE_LICENSE("GPL");
diff --git a/drivers/soc/realtek/common/rtk_avcpulog.c b/drivers/soc/realtek/common/rtk_avcpulog.c
new file mode 100644
index 00000000..355f797
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_avcpulog.c
@@ -0,0 +1,549 @@
+/*
+ * rtk_avcpulog.c - avcpu share-memory logging driver
+ *
+ * Copyright (c) 2019 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/types.h>
+#include <linux/fs.h>
+#include <linux/cdev.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/uaccess.h>
+#include <linux/slab.h>
+#include <linux/device.h>
+#include <linux/sched.h>
+#include <linux/workqueue.h>
+#include <linux/completion.h>
+#include <linux/of.h>
+#include <linux/delay.h>
+#include <linux/sched.h>
+#include <linux/platform_device.h>
+#include <asm/io.h>
+#include <soc/realtek/rtk_ipc_shm.h>
+#include <soc/realtek/rtk_sb2_sem.h>
+
+#define MODULE_NAME		"avlog"
+#define MODULE_NUM		1
+#define HWSEM_COMPAT_NAME	"realtek,sb2-sem-avlog"
+#define HWSEM_DEF_TIMEOUT	500 /* msec */
+#define WORK_DEF_DELAY_TIME	500 /* msec */
+
+typedef enum {
+	L_PENDING,
+	L_RUNNING,
+	L_WAITING,
+	L_EXIT,
+	L_ERR,
+} LOG_STAT;
+
+typedef struct {
+	/* static vars */
+	struct class *class;
+	struct device *device;
+	struct cdev cdev;
+	struct sb2_sem *avcpu_sem;
+	struct avcpu_syslog_struct *syslog_p;
+	struct delayed_work log_check_work;
+	void __iomem *log_buf;
+	/* dynamic vars */
+	spinlock_t lock;
+	atomic_t cnt;
+	LOG_STAT stat;
+	struct task_struct *tsk;
+	uint32_t record_start;
+	struct completion completion;
+	/* dynamic vars doesn't require lock */
+	unsigned int hwsem_timeout;
+	unsigned int work_delay;
+} avlog_ctl_t;
+
+/* return value 0 means success getting semaphore with preempt disabled */
+static inline int avlog_hwsem_get(struct sb2_sem *sem, unsigned int timeout)
+{
+	unsigned long jif_timeout;
+
+	jif_timeout = jiffies + msecs_to_jiffies(timeout);
+	while(time_before(jiffies, jif_timeout)) {
+		preempt_disable();
+		/* 1 means lock acquired */
+		if (sb2_sem_try_lock(sem, 0)) {
+			mb();
+			return 0;
+		}
+		preempt_enable();
+		msleep(10);
+	}
+
+	return -1;
+}
+
+static inline int avlog_hwsem_put(struct sb2_sem *sem)
+{
+	/* write barrier to ensure share data updated before release hwsem */
+	wmb();
+	sb2_sem_unlock(sem);
+	preempt_enable();
+	return 0;
+}
+
+static void log_check_work_fn(struct work_struct *work)
+{
+	avlog_ctl_t *ctl = container_of(work, avlog_ctl_t, log_check_work.work);
+	struct sb2_sem *sem = ctl->avcpu_sem;
+	uint32_t log_start, log_end;
+
+	/* wake up reader if fail to get semaphore */
+	if (avlog_hwsem_get(sem, ctl->hwsem_timeout)) {
+		pr_err("%s : timeout waiting for hwsem\n", __func__);
+		spin_lock(&ctl->lock);
+		ctl->stat = L_ERR;
+		spin_unlock(&ctl->lock);
+		complete_all(&ctl->completion);
+		return;
+	}
+
+	/* check if log had updated, if yes wake up reader. If not,
+	   schedule another work and keeps reader sleep */
+	log_start = ctl->syslog_p->log_start;
+	log_end = ctl->syslog_p->log_end;
+	avlog_hwsem_put(sem);
+
+	spin_lock(&ctl->lock);
+
+	/* Don't do anything if current reader is not in waiting stat */\
+	if (ctl->stat != L_WAITING) {
+		spin_unlock(&ctl->lock);
+		return;
+	}
+
+	if (log_start != log_end) {
+		complete_all(&ctl->completion);
+		ctl->stat = L_RUNNING;
+	} else {
+		if (!schedule_delayed_work(&ctl->log_check_work,
+			msecs_to_jiffies(ctl->work_delay))) {
+			/* wake up reader directly or reader may sleep forever */
+			pr_err("%s: fail to schedule work\n", __func__);
+			ctl->stat = L_ERR;
+			complete_all(&ctl->completion);
+		}
+	}
+
+	spin_unlock(&ctl->lock);
+}
+
+static int rtk_avcpu_log_open(struct inode *inode, struct file *filp)
+{
+	avlog_ctl_t *ctl = container_of(inode->i_cdev, avlog_ctl_t, cdev);
+	struct sb2_sem *sem = ctl->avcpu_sem;
+	uint32_t log_start;
+
+	/* hold sem first since we want to record reader-pointer(log_start) */
+	if (avlog_hwsem_get(sem, ctl->hwsem_timeout)) {
+		pr_debug("%s: couldn't get hw-sem for more then %d msec\n",
+			__func__, HWSEM_DEF_TIMEOUT);
+		return -EBUSY;
+	}
+
+	log_start = ctl->syslog_p->log_start;
+	avlog_hwsem_put(sem);
+
+	spin_lock(&ctl->lock);
+
+	/* we assume L_ERR might have chance to recover?? */
+	if (ctl->stat != L_PENDING) {
+		spin_unlock(&ctl->lock);
+		return -EBUSY;
+	}
+
+	ctl->tsk = current;
+	ctl->record_start = log_start;
+	ctl->stat = L_RUNNING;
+	filp->private_data = ctl;
+	atomic_inc(&ctl->cnt);
+	spin_unlock(&ctl->lock);
+
+	return 0;
+}
+
+static int rtk_avcpu_log_release(struct inode *inode, struct file *filp)
+{
+	avlog_ctl_t *ctl = container_of(inode->i_cdev, avlog_ctl_t, cdev);
+
+	spin_lock(&ctl->lock);
+
+	ctl->tsk = NULL;
+	if (ctl->stat != L_ERR)
+		ctl->stat = L_PENDING;
+	spin_unlock(&ctl->lock);
+	atomic_dec(&ctl->cnt);
+
+	if (delayed_work_pending(&ctl->log_check_work))
+		cancel_delayed_work_sync(&ctl->log_check_work);
+
+	return 0;
+}
+
+static ssize_t rtk_avcpu_log_read(struct file *filp, char __user *buf,
+		size_t count, loff_t *f_pos)
+{
+	avlog_ctl_t *ctl = (avlog_ctl_t *)filp->private_data;
+	struct sb2_sem *sem = ctl->avcpu_sem;
+	struct avcpu_syslog_struct *p_syslog = ctl->syslog_p;
+	const char drop_msg[] = "*** LOG DROP ***\n";
+	char *iter = NULL, *tmp_buf = NULL;
+	int err = 0, rcount = 0, log_count = 0, cp_count = 0;
+	unsigned int idx_start, idx_end;
+
+again:
+	/* if reader wake up by any signal under sleep stat,
+	   switch back to running stat since it's not cause by error*/
+	if (signal_pending(current)) {
+		spin_lock(&ctl->lock);
+		if (ctl->stat == L_WAITING)
+			ctl->stat = L_RUNNING;
+		spin_unlock(&ctl->lock);
+		if (delayed_work_pending(&ctl->log_check_work))
+			cancel_delayed_work(&ctl->log_check_work);
+		return -EINTR;
+	}
+
+	if (avlog_hwsem_get(sem, ctl->hwsem_timeout)) {
+		spin_lock(&ctl->lock);
+		ctl->stat = L_ERR;
+		spin_unlock(&ctl->lock);
+		pr_err("%s: fail to get hwsem\n", __func__);
+		return -EBUSY;
+	}
+
+	spin_lock(&ctl->lock);
+
+	if (ctl->stat != L_RUNNING) {
+		spin_unlock(&ctl->lock);
+		avlog_hwsem_put(sem);
+		return -EFAULT;
+	}
+
+	/* log_start & log_end is incremental, need to change policy if overflow happened */
+	if (p_syslog->log_start < ctl->record_start ||
+	    p_syslog->log_end < p_syslog->log_start) {
+		pr_err("%s: log_start:0x%x, log_end:0x%x, record_start:0x%x\n",
+			__func__, p_syslog->log_start, p_syslog->log_end, ctl->record_start);
+		ctl->stat = L_ERR;
+		spin_unlock(&ctl->lock);
+		avlog_hwsem_put(sem);
+		return -ENOSPC;
+	}
+
+	/* Log had been rolled over, return the drop msg directly */
+	if (p_syslog->log_start != ctl->record_start) {
+		if (count <= strlen(drop_msg)) {
+			pr_info("%s: read buf size %d too small\n",
+				__func__, (int)count);
+			cp_count = count -1;
+		} else {
+			cp_count = strlen(drop_msg);
+		}
+
+		pr_debug("%s: drop, record_start:0x%x, log_start:0x%x\n",
+			__func__, ctl->record_start, p_syslog->log_start);
+		ctl->record_start = p_syslog->log_start;
+		spin_unlock(&ctl->lock);
+		avlog_hwsem_put(sem);
+
+		if (copy_to_user(buf, drop_msg, cp_count)) {
+			pr_err("%s: copy fail\n", __func__);
+			return -EFAULT;
+		}
+
+		put_user('\0', buf + cp_count);
+		rcount = cp_count + 1;
+		return rcount;
+	}
+
+	/* Log buf empty, go to sleep until new log came in */
+	if (p_syslog->log_start == p_syslog->log_end) {
+		ctl->stat = L_WAITING;
+		reinit_completion(&ctl->completion);
+		if (!schedule_delayed_work(&ctl->log_check_work,
+			msecs_to_jiffies(ctl->work_delay))) {
+			pr_err("%s: fail to schedule work\n", __func__);
+			ctl->stat = L_ERR;
+			spin_unlock(&ctl->lock);
+			avlog_hwsem_put(sem);
+			return -EFAULT;
+		}
+		spin_unlock(&ctl->lock);
+		avlog_hwsem_put(sem);
+		/* work should switch stat back to L_RUNNING */
+		wait_for_completion_interruptible(&ctl->completion);
+		goto again;
+	}
+
+
+	/* Only emit log if no error or DROP happened */
+	/* Ok, now there is valid log inside log buffer. Try to read
+	   as much as we could */
+	log_count = p_syslog->log_end - p_syslog->log_start;
+	/* make sure if user buffer is enough, if not, fill the buffer */
+	if (log_count > count)
+		cp_count = count;
+	else
+		cp_count = log_count;
+
+	if (!(tmp_buf = kzalloc(count, GFP_ATOMIC))) {
+		pr_err("%s : allocate %d buf fail\n", __func__, (int)count);
+		err = -ENOMEM;
+	}
+
+	/* since log_start/end is incremental, need to figure out the
+	   correct position in the buffer */
+	idx_start = p_syslog->log_start % p_syslog->log_buf_len;
+	idx_end = p_syslog->log_end % p_syslog->log_buf_len;
+
+	while(!err && cp_count) {
+		int tmp_cnt;
+		bool wrap;
+
+		wrap = (cp_count + idx_start >= p_syslog->log_buf_len) ? true : false;
+		tmp_cnt = wrap ? (p_syslog->log_buf_len - idx_start) :
+				cp_count;
+
+		iter = ctl->log_buf + idx_start;
+		pr_debug("%s: tmp_buf:0x%p, rcount:%d, log_buf:0x%p, log_start:0x%x, tmp_cnt:%d\n",
+			__func__, tmp_buf, rcount, ctl->log_buf, idx_start, tmp_cnt);
+		memcpy(tmp_buf + rcount, iter, tmp_cnt);
+		rcount += tmp_cnt;
+		cp_count -= tmp_cnt;
+		idx_start = (idx_start + tmp_cnt) % p_syslog->log_buf_len;
+	}
+
+	p_syslog->log_start += rcount;
+	ctl->record_start = p_syslog->log_start;
+
+	spin_unlock(&ctl->lock);
+	avlog_hwsem_put(sem);
+
+	if (!err) {
+		if (copy_to_user(buf, tmp_buf, rcount)) {
+			pr_err("%s: copy fail\n", __func__);
+			err = -EFAULT;
+		}
+	}
+
+	kfree(tmp_buf);
+	return err ? err : rcount;
+}
+
+static const struct file_operations rtk_avcpu_log_fops = {
+        .owner = THIS_MODULE,
+        .open = rtk_avcpu_log_open,
+        .read = rtk_avcpu_log_read,
+	.release = rtk_avcpu_log_release,
+};
+
+static int __init parse_dtb(avlog_ctl_t *alog_ctl, const struct device_node *node)
+{
+	int ret = 0;
+	unsigned int val = 0;
+	struct device_node *np = NULL;
+	struct sb2_sem *tmp_sem = NULL;
+
+	if (!alog_ctl || !node) {
+		pr_err("%s: error input\n", __func__);
+		return -EFAULT;
+	}
+
+	/* First, we have to get correct HW Semaphoe */
+	np = of_parse_phandle(node, "sync_lock", 0);
+	if (!np || !of_device_is_compatible(np, HWSEM_COMPAT_NAME)) {
+		pr_err("%s: parsing lock fail\n", __func__);
+		return -ENODEV;
+	}
+
+	tmp_sem = sb2_sem_node_to_lock(np);
+        if (IS_ERR(tmp_sem)) {
+                ret = PTR_ERR(tmp_sem);
+		pr_err("%s: get sb2_sem fail\n", __func__);
+		return ret;
+	}
+
+	alog_ctl->avcpu_sem = tmp_sem;
+
+	if (of_property_read_u32(node, "sync_lock_timeout", &val)) {
+		pr_info("%s : use default %u for hwsem_timeout\n",
+			__func__, HWSEM_DEF_TIMEOUT);
+		val = HWSEM_DEF_TIMEOUT;
+	}
+	alog_ctl->hwsem_timeout = val;
+
+	if (of_property_read_u32(node, "log_check_period", &val)) {
+		pr_info("%s : use default %u for work_delay\n",
+			__func__, WORK_DEF_DELAY_TIME);
+		val = WORK_DEF_DELAY_TIME;
+	}
+	alog_ctl->work_delay = val;
+
+	return 0;
+}
+
+static int __init rtk_avcpu_shm_log_probe(struct platform_device *pdev)
+{
+	dev_t dev;
+	struct avcpu_syslog_struct *tmp_syslog_p =
+		(struct avcpu_syslog_struct*)((struct rtk_ipc_shm*)IPC_SHM_VIRT)->printk_buffer;
+	avlog_ctl_t *alog_ctl = NULL;
+	struct class *class = NULL;
+	struct device *device = NULL;
+	struct device_node *np = NULL;
+	int ret = 0;
+
+	pr_debug("%s: alog addr-0x%x, size-0x%x\n",
+		__func__, tmp_syslog_p->log_buf_addr, tmp_syslog_p->log_buf_len);
+
+	/* Check the IPC_SHM part. Related info should be set by bootcode */
+	if (tmp_syslog_p->log_buf_addr == 0 || tmp_syslog_p->log_buf_len == 0)
+		return -EINVAL;
+
+	/* since avlog is a subnode of rtk_avcpu, check if it exist before parsing */
+	np = of_get_child_by_name(pdev->dev.of_node, "avlog");
+	if (!np)
+		return -ENODEV;
+
+	alog_ctl = kzalloc(sizeof(avlog_ctl_t), GFP_KERNEL);
+	if (!alog_ctl) {
+		pr_err("%s: couldn't allocate memory for alog\n", __func__);
+		return -ENOMEM;
+	}
+
+	ret = parse_dtb(alog_ctl, np);
+	if (ret) {
+		pr_err("%s: parse fail\n", __func__);
+		goto fail;
+	}
+
+	/* initialize char device part */
+	if (alloc_chrdev_region(&dev, 0, MODULE_NUM, MODULE_NAME) < 0) {
+		pr_err("%s: fail to reister char-device\n", __func__);
+		ret = -ENODEV;
+		goto fail;
+	}
+
+	cdev_init(&alog_ctl->cdev, &rtk_avcpu_log_fops);
+	alog_ctl->cdev.owner = THIS_MODULE;
+	ret = cdev_add(&alog_ctl->cdev, dev, MODULE_NUM);
+	if (ret) {
+		pr_err("%s: cdev_add with ret %d\n", __func__, ret);
+		goto fail_unregister_chrdev;
+	}
+
+	/* Then, create class and device to spawn node under dev */
+	class = class_create(THIS_MODULE, MODULE_NAME);
+	if (IS_ERR(class)) {
+		ret = PTR_ERR(class);
+		pr_err("%s: class_create with ret %d\n", __func__, ret);
+		goto fail_unregister_chrdev;
+	}
+
+	device = device_create(class, NULL, dev, alog_ctl, MODULE_NAME);
+	if (IS_ERR(device)) {
+		ret = PTR_ERR(device);
+		pr_err("%s: device_create with ret %d\n", __func__, ret);
+		goto fail_class_destroy;
+	}
+
+	/* Now, finish all the rest of init */
+	spin_lock_init(&alog_ctl->lock);
+	alog_ctl->syslog_p = tmp_syslog_p;
+	alog_ctl->log_buf = ioremap_wc(tmp_syslog_p->log_buf_addr, tmp_syslog_p->log_buf_len);
+	if (!alog_ctl->log_buf) {
+		pr_err("%s: fail to ioremap\n", __func__);
+		ret = -ENOMEM;
+		goto fail_class_destroy;
+	}
+	alog_ctl->cdev.owner = THIS_MODULE;
+	alog_ctl->class = class;
+	alog_ctl->device = device;
+	atomic_set(&alog_ctl->cnt, 0);
+	INIT_DELAYED_WORK(&alog_ctl->log_check_work, log_check_work_fn);
+	init_completion(&alog_ctl->completion);
+	alog_ctl->stat = L_PENDING;
+
+	dev_set_drvdata(&pdev->dev, alog_ctl);
+
+	return 0;
+
+fail_class_destroy:
+	class_destroy(class);
+fail_unregister_chrdev:
+	unregister_chrdev_region(dev, MODULE_NUM);
+fail:
+	kfree(alog_ctl);
+
+	return ret;
+}
+
+static int __exit rtk_avcpu_shm_log_remove(struct platform_device *pdev)
+{
+	avlog_ctl_t *ctl = (avlog_ctl_t*)dev_get_drvdata(&pdev->dev);
+	bool all_finish = false;
+	unsigned long timeout;
+
+	if (!ctl)
+		return -ENODEV;
+
+	spin_lock(&ctl->lock);
+	ctl->stat = L_EXIT;
+	if (ctl->tsk)
+		do_send_sig_info(SIGKILL, SEND_SIG_FORCED, ctl->tsk, false);
+	spin_unlock(&ctl->lock);
+
+	/* wait for 1 sec before reader killed */
+	timeout = jiffies + msecs_to_jiffies(1000);
+	while(time_before(jiffies, timeout)) {
+		if (!atomic_read(&ctl->cnt)) {
+			all_finish = true;
+			break;
+		}
+		msleep(20);
+	}
+
+	if (!all_finish) {
+		pr_err("%s:couldn't finish all reader, release fail\n", __func__);
+		return -EBUSY;
+	}
+
+	device_destroy(ctl->class, ctl->device->devt);
+	class_destroy(ctl->class);
+	cdev_del(&ctl->cdev);
+	kfree(ctl);
+
+	return 0;
+}
+
+static struct of_device_id rtk_avcpu_shm_log_ids[] = {
+	{ .compatible = "Realtek,rtk-avcpu" },
+	{ /* Sentinel */ },
+};
+
+static struct platform_driver rtk_avcpu_shm_log_driver = {
+        .probe = rtk_avcpu_shm_log_probe,
+        .remove = rtk_avcpu_shm_log_remove,
+        .driver = {
+                .name = MODULE_NAME,
+                .bus = &platform_bus_type,
+                .owner = THIS_MODULE,
+                .of_match_table = of_match_ptr(rtk_avcpu_shm_log_ids),
+        },
+};
+
+module_platform_driver(rtk_avcpu_shm_log_driver);
+
+MODULE_DESCRIPTION("Realtek AVCPU log driver");
+MODULE_LICENSE("GPL");
diff --git a/drivers/soc/realtek/common/rtk_barrier.c b/drivers/soc/realtek/common/rtk_barrier.c
new file mode 100644
index 00000000..1fde80e
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_barrier.c
@@ -0,0 +1,27 @@
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/delay.h>
+#include <linux/printk.h>
+#include <asm/io.h>
+
+#include <soc/realtek/memory.h>
+#include <soc/realtek/barrier.h>
+
+#define RBUS_SYNC 0x0001A020
+
+int rtk_rbus_barrier_flag;
+
+extern void __iomem *rbus_addr;
+
+void rtk_bus_sync(void)
+{
+	if (rtk_rbus_barrier_flag == 1)
+		writel_relaxed(0x00001234, rbus_addr + RBUS_SYNC);
+
+	dsb(st);
+}
+EXPORT_SYMBOL(rtk_bus_sync);
diff --git a/drivers/soc/realtek/common/rtk_chip.c b/drivers/soc/realtek/common/rtk_chip.c
new file mode 100644
index 00000000..8e7ddaa
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_chip.c
@@ -0,0 +1,70 @@
+/*
+ * rtk_chip.c - chip info ioctl
+ *
+ * Copyright (c) 2018 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/fs.h>
+#include <linux/module.h>
+#include <linux/miscdevice.h>
+#include <linux/uaccess.h>
+
+#include <soc/realtek/rtk_chip.h>
+
+#define RTK_CHIP_IOCTL_GET_ID  _IOR('C', 0x01, unsigned int)
+#define RTK_CHIP_IOCTL_GET_REV _IOR('C', 0x02, unsigned int)
+
+static long rtk_chip_ioctl(struct file *filp, unsigned int cmd,
+	unsigned long arg)
+{
+	int ret = 0;
+	unsigned int val;
+
+	switch (cmd) {
+	case RTK_CHIP_IOCTL_GET_ID:
+		val = get_rtd_chip_id();
+		break;
+	case RTK_CHIP_IOCTL_GET_REV:
+		val = get_rtd_chip_revision();
+		break;
+	}
+
+	ret = copy_to_user((unsigned int __user *)arg,
+		&val, sizeof(unsigned int));
+
+	return ret;
+}
+
+static long rtk_chip_compact_ioctl(struct file *filp, unsigned int cmd,
+	unsigned long arg)
+{
+	return rtk_chip_ioctl(filp, cmd, (unsigned long)arg);
+}
+
+static const struct file_operations rtk_chip_fops = {
+	.owner          = THIS_MODULE,
+	.unlocked_ioctl = rtk_chip_ioctl,
+	.compat_ioctl   = rtk_chip_compact_ioctl,
+};
+
+static struct miscdevice mdev = {
+	.minor  = MISC_DYNAMIC_MINOR,
+	.name   = "chip",
+	.fops   = &rtk_chip_fops,
+};
+
+static int __init chip_info_init(void)
+{
+	int ret;
+
+	ret = misc_register(&mdev);
+	if (ret)
+		pr_err("Failed to register misc device: %d\n", ret);
+	return ret;
+}
+module_init(chip_info_init);
diff --git a/drivers/soc/realtek/common/rtk_dc_sys_dbg.c b/drivers/soc/realtek/common/rtk_dc_sys_dbg.c
new file mode 100755
index 00000000..f173ec4
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_dc_sys_dbg.c
@@ -0,0 +1,452 @@
+/* rtk_dc_sys_dbg.c - DC system bus debug driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/sched.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+
+#include "rtk_dc_sys_dbg.h"
+
+#define DVR_NAME "RTK_DCSYS_DBG"
+
+#define MM_NUM 8
+
+struct config_mt_info {
+	u32 enable;
+	u32 saddr;
+	u32 eaddr;
+	u32 module0;
+	u32 module1;
+	u32 module2;
+	u32 module3;
+	u32 int2cpu;
+	u32 access_type;
+	u32 mode;
+};
+
+struct config_ec_info {
+	u32 err_cmd_en;
+	u32 int2cpu;
+};
+
+struct ec_info {
+	u32 dc_num;
+	u32 over_access;
+	u32 warp_type_err;
+	u32 read_last_err;
+	u32 trap_case;
+	u32 addr;
+	u32 access_dir;
+	u32 protect;
+	u32 size;
+	char *module;
+};
+
+static void ec_show_debug_info(struct ec_info ec)
+{
+	pr_info("[%s] EC Trapped module is %s 0x%x in dc_sys%d, data length %d byte, %s mode cmd, %s \n",
+		DVR_NAME, ec.module, ec.addr, ec.dc_num, ec.size,
+		(ec.protect?"non-protected":"protected"),
+		(ec.access_dir?"read":"write")
+		);
+
+	if (ec.over_access)
+		pr_info("[%s] Over dram access in dc_sys%d\n",
+			DVR_NAME, ec.dc_num);
+
+	switch (ec.trap_case) {
+	case 1:
+		pr_info("[%s] start address is not 16-byte alignment\n",
+			DVR_NAME);
+		break;
+	case 2:
+		pr_info("[%s] burst length is zero\n", DVR_NAME);
+		break;
+	case 4:
+		pr_info("[%s] burst Length is not 16-byte alignment\n",
+			DVR_NAME);
+		break;
+	case 8:
+		pr_info("[%s] wrong wrap mode\n", DVR_NAME);
+		break;
+	default:
+		break;
+	}
+
+	if (ec.read_last_err) {
+		pr_info("[%s] Detect OCP read last different in dc_sys%d\n",
+			DVR_NAME, ec.dc_num);
+	} else if (ec.warp_type_err) {
+		pr_info("[%s] Detect wrap CMD type mismatch in dc_sys%d\n",
+			DVR_NAME, ec.dc_num);
+	}
+}
+
+irqreturn_t isr_dcsys_dbg(int irq, void *pdev)
+{
+	struct ec_info ec0;
+	struct ec_info ec1;
+	u32 int_stat = 0;
+	u32 dc_table = 0;
+	u32 addcmd_hi = 0;
+	u32 addcmd_lo0 = 0;
+	u32 addcmd_lo1 = 0;
+	u32 int_clear = 0;
+	u32 offset = 0;
+	u32 module_id0 = 0;
+	u32 module_id1 = 0;
+	u32 trap_dcsys0 = 0;
+	u32 trap_dcsys1 = 0;
+	u32 ec_int_stat = 0;
+	u32 ec_addcmd_hi = 0;
+	u32 ec_addcmd_lo0 = 0;
+	u32 ec_addcmd_lo1 = 0;
+	u32 size = 0;
+	u32 addr = 0;
+	u32 int1_flag = 0;
+	u32 int2_flag = 0;
+	u32 int3_flag = 0;
+	u32 ec_int0_flag = 0;
+	u32 ec_int1_flag = 0;
+	int i = 0;
+	int j = 0;
+	char *module0 = NULL;
+	char *module1 = NULL;
+
+	/* Error command detection part */
+	ec_int_stat = readl(DC_EC_CTRL);
+
+	ec_int0_flag = (ec_int_stat >> EC_INT0_B20) & 0x1;
+	ec_int1_flag = (ec_int_stat >> EC_INT1_B21) & 0x1;
+	if (ec_int0_flag || ec_int1_flag) {
+		trap_dcsys0 = (ec_int_stat >> EC_EVER_TRAP0_B22) & 0x1;
+		trap_dcsys1 = (ec_int_stat >> EC_EVER_TRAP1_B23) & 0x1;
+
+		ec_addcmd_hi = readl(DC_EC_ADDCMD_HI);
+		ec_addcmd_lo0 = readl(DC_EC_ADDCMD_LO_0);
+		ec_addcmd_lo1 = readl(DC_EC_ADDCMD_LO_1);
+
+		for (j = 0 ; j < MODULE_NUM ; j++) {
+			module_id0 = (ec_addcmd_hi & 0x3FFFF) >> 11;
+			module_id1 = (ec_int_stat & 0x3FFFF) >> 11;
+			if (module_table[j].id == module_id0)
+				module0 = module_table[j].name;
+			else if (module_table[j].id == module_id1)
+				module1 = module_table[j].name;
+		}
+
+		if (trap_dcsys0) {
+			ec0.over_access = (ec_int_stat >> OVER_DCSYS0_B18) & 0x1;
+			ec0.trap_case = (ec_addcmd_hi >> CASE0_B20) & 0xF;
+			ec0.read_last_err = (ec_addcmd_hi >> RD_ERR0_B28) & 0x1;
+			ec0.warp_type_err =
+				(ec_addcmd_hi >> WRAP_ERR0_B30) & 0x1;
+
+			ec0.addr = (ec_addcmd_lo0 >> 2) * 8;
+			ec0.size = (ec_addcmd_hi & 0x1FF) * 8;
+			ec0.protect = (ec_addcmd_lo0 & 0x1);
+			ec0.access_dir = (ec_addcmd_lo0 >> 1) & 0x1;
+			ec0.module = module0;
+			ec0.dc_num = 0;
+
+			ec_show_debug_info(ec0);
+
+		} else if (trap_dcsys1) {
+			ec1.over_access = (ec_int_stat >> OVER_DCSYS1_B19) & 0x3;
+			ec1.trap_case = (ec_addcmd_hi >> CASE1_B24) & 0xF;
+			ec1.read_last_err = (ec_addcmd_hi >> RD_ERR1_B29) & 0x1;
+			ec1.warp_type_err =
+				(ec_addcmd_hi >> WRAP_ERR1_B31) & 0x1;
+
+			ec1.addr = (ec_addcmd_lo1 >> 2) * 8;
+			ec1.size = (ec_int_stat & 0x1FF) * 8;
+			ec1.protect = (ec_addcmd_lo0 & 0x1);
+			ec1.access_dir = (ec_addcmd_lo0 >> 1) & 0x1;
+			ec1.module = module1;
+			ec1.dc_num = 1;
+
+			ec_show_debug_info(ec1);
+		}
+
+		ec_int_stat = readl(DC_EC_CTRL);
+		ec_int_stat = ec_int_stat &
+			~(EC_CTRL_EN(OVER_DCSYS0_B18) |
+			EC_CTRL_EN(OVER_DCSYS1_B19) |
+			EC_CTRL_EN(EC_INT0_B20) |
+			EC_CTRL_EN(EC_INT1_B21) |
+			EC_CTRL_EN(EC_EVER_TRAP0_B22) |
+			EC_CTRL_EN(EC_EVER_TRAP1_B23));
+		writel(ec_int_stat, DC_EC_CTRL);
+	}
+
+	/* Memory trash detection part */
+	trap_dcsys0 = 0;
+	trap_dcsys1 = 0;
+
+	for (i = 0 ; i < MM_NUM ; i++) {
+		offset = i * 4;
+		int_stat = readl(DC_MT_MODE + offset);
+		int1_flag = (int_stat & INT1_TRIG) >> INT1_B13;
+		int2_flag = (int_stat & INT2_TRIG) >> INT2_B11;
+		int3_flag = (int_stat & INT3_TRIG) >> INT3_B9;
+
+		if (int1_flag == 1 || int2_flag == 1 || int3_flag == 1) {
+
+			dc_table = readl(DC_MT_TABLE + offset);
+			addcmd_hi = readl(DC_MT_ADDCMD_HI + offset);
+			addcmd_lo0 = readl(DC_MT_ADDCMD_LO_0 + offset);
+			addcmd_lo1 = readl(DC_MT_ADDCMD_LO_1 + offset);
+
+			for (j = 0 ; j < MODULE_NUM ; j++) {
+				module_id0 = (addcmd_hi >> MOD_ID0_B18) & 0x7F;
+				module_id1 = (addcmd_hi >> MOD_ID1_B25) & 0x7F;
+				if (module_table[j].id == module_id0)
+					module0 = module_table[j].name;
+				else if (module_table[j].id == module_id1)
+					module1 = module_table[j].name;
+			}
+
+			trap_dcsys0 = (dc_table >> 30) & 1;
+			trap_dcsys1 = (dc_table >> 31) & 1;
+
+			if (trap_dcsys0 == 1) {
+				size = (addcmd_hi & 0x3FF) * 8;
+				addr = (addcmd_lo0 >> 2) * 8;
+				pr_info("[%s] Trapped module is %s ",
+					DVR_NAME, module0);
+				pr_info("0x%x in dc_sys0\n",
+					addr);
+				pr_info("[%s] burst length = %d byte\n",
+					DVR_NAME, size);
+			} else if (trap_dcsys1 == 1) {
+				size = ((addcmd_hi >> 9) & 0x3FF) * 8;
+				addr = (addcmd_lo1 >> 2) * 8;
+				pr_info("[%s] Trapped module is %s ",
+					DVR_NAME, module1);
+				pr_info("0x%x in dc_sys1\n",
+					addr);
+				pr_info("[%s] burst length = %d byte\n",
+					DVR_NAME, size);
+			}
+
+			pr_info("\n");
+
+			int_clear = WRITE_EN(W_EN1_B14) |
+				WRITE_EN(W_EN2_B12) |
+				WRITE_EN(W_EN3_B10);
+
+			writel(int_clear, DC_MT_MODE + offset);
+			writel(CLR_EVER_TRAP(dc_table), DC_MT_TABLE + offset);
+		}
+	}
+
+	return IRQ_HANDLED;
+}
+
+static int dcsys_dbg_init(struct platform_device *pdev)
+{
+	struct device_node *np;
+	struct config_mt_info *mt_config;
+	struct config_ec_info *ec_config;
+	int dcsys_irq = 0;
+	int size = 0;
+	int i = 0;
+	u32 offset = 0;
+	u32 tmp = 0;
+	u32 **mt;
+	u32 *ec;
+	char buf[15];
+	int ret;
+
+	if (WARN_ON(!(pdev->dev.of_node))) {
+		pr_err("[%s] Error: No node\n", DVR_NAME);
+		return -ENODEV;
+	}
+
+	np = pdev->dev.of_node;
+
+	DCSYS_BASE = of_iomap(np, 0);
+
+	dcsys_irq = irq_of_parse_and_map(np, 0);
+	if (!dcsys_irq) {
+		pr_err("[%s] irq parse fail\n", DVR_NAME);
+		return -ENXIO;
+	}
+
+	snprintf(buf, sizeof(buf), "err_cmd_detect");
+	size = of_property_count_u32_elems(pdev->dev.of_node, buf);
+	ec = kmalloc_array(size, sizeof(u32), GFP_KERNEL);
+	of_property_read_u32_array(pdev->dev.of_node, buf, ec, size);
+	ec_config = (struct config_ec_info *)ec;
+
+	ret = request_irq(dcsys_irq,
+		isr_dcsys_dbg,
+		IRQF_SHARED,
+		"dcsys_dbg",
+		pdev);
+	if (ret != 0) {
+		pr_err("[%s] irq request fail\n", DVR_NAME);
+		return -ENXIO;
+	}
+
+	if (ec_config->err_cmd_en) {
+		tmp = tmp |
+			EC_CTRL_EN(EC_SWAP_EN_B25) |
+			EC_CTRL_EN(EC_DETECT_EN_B24) |
+			EC_CPU_TYPE(ec_config->int2cpu) |
+			EC_CTRL_EN(EC_INT_EN_B26);
+
+		writel(tmp, DC_EC_CTRL);
+
+		pr_info("[%s] DC_EC_CTRL(0x%x) = %x\n",
+			DVR_NAME,
+			0x98008300,
+			tmp);
+	}
+
+	mt = kmalloc_array(MM_NUM, sizeof(u32*), GFP_KERNEL);
+	size = 0;
+	for (i = 0 ; i < MM_NUM ; i++) {
+		offset = i * 4;
+		snprintf(buf, sizeof(buf), "mt_%d", i);
+
+		size = of_property_count_u32_elems(pdev->dev.of_node, buf);
+		mt[i] = kmalloc_array(size, sizeof(u32), GFP_KERNEL);
+		of_property_read_u32_array(pdev->dev.of_node, buf, mt[i], size);
+
+		mt_config = (struct config_mt_info *) mt[i];
+
+		if (mt_config->enable != 1)
+			continue;
+
+		writel(SADDR(mt_config->saddr), DC_MT_SADDR + offset);
+		writel(EADDR(mt_config->eaddr), DC_MT_EADDR + offset);
+
+		tmp = mt_config->module0 |
+			mt_config->module1 << 7 |
+			mt_config->module2 << 14|
+			mt_config->module3 << 21;
+		writel(tmp, DC_MT_TABLE + offset);
+
+		tmp = WRITE_EN(W_EN_B2) |
+			TRASH_MODE(mt_config->mode) |
+			WRITE_EN(W_EN0_B23) |
+			ACCESS_TYPE(mt_config->access_type, ACCESS_T0_B21) |
+			ACCESS_TYPE(mt_config->access_type, ACCESS_T1_B19) |
+			ACCESS_TYPE(mt_config->access_type, ACCESS_T2_B17) |
+			ACCESS_TYPE(mt_config->access_type, ACCESS_T3_B15) |
+			WRITE_EN(W_EN4_B8) |
+			INIT_EN(INT3_EN_B3) |
+			INIT_EN(INT2_EN_B4) |
+			INIT_EN(INT1_EN_B5) |
+			CPU_TYPE(mt_config->int2cpu);
+
+		writel(tmp, DC_MT_MODE + offset);
+
+		pr_info("[%s] DC_MT_MODE(0x%x) = %x\n",
+			DVR_NAME,
+			0x98008240 + offset,
+			tmp);
+	}
+
+	/* Disable cross range check to get more precise violation info */
+	writel(0x1, DC_MT_MISC);
+
+	for (i = 0 ; i < MM_NUM ; i++)
+		kfree(mt[i]);
+
+	kfree(mt);
+	kfree(ec);
+
+	pr_info("[%s] initialized\n", DVR_NAME);
+
+	return 0;
+}
+
+static int dcsys_dbg_exit(struct platform_device *pdev)
+{
+	struct device_node *np;
+	int sb2_irq;
+
+	pr_info("[%s] Exit\n", DVR_NAME);
+
+	np = pdev->dev.of_node;
+	sb2_irq = irq_of_parse_and_map(np, 0);
+
+	free_irq(sb2_irq, NULL);
+
+	return 0;
+}
+
+int dcsys_dbg_suspend(struct device *dev)
+{
+	pr_info("[%s] Enter\n", DVR_NAME);
+
+	pr_info("[%s] Exit\n", DVR_NAME);
+
+	return 0;
+}
+
+int dcsys_dbg_resume(struct device *dev)
+{
+	pr_info("[%s] Resume enter\n", DVR_NAME);
+
+	pr_info("[%s] Resume exit\n", DVR_NAME);
+
+	return 0;
+}
+
+static const struct dev_pm_ops dcsys_pm_ops = {
+	.suspend_noirq = dcsys_dbg_suspend,
+	.resume_noirq = dcsys_dbg_resume,
+};
+
+static const struct of_device_id rtk_dcsys_match[] = {
+	{.compatible = "realtek,rtk-dcsys-debug"},
+	{},
+};
+
+static struct platform_driver rtk_dcsys_driver = {
+	.probe = dcsys_dbg_init,
+	.remove = dcsys_dbg_exit,
+	.driver = {
+		.name = DVR_NAME,
+		.owner = THIS_MODULE,
+		.pm = &dcsys_pm_ops,
+		.of_match_table = of_match_ptr(rtk_dcsys_match),
+	},
+};
+
+static void __exit rtk_dcsys_exit(void)
+{
+	platform_driver_unregister(&rtk_dcsys_driver);
+}
+module_exit(rtk_dcsys_exit);
+
+static int __init rtk_dcsys_init(void)
+{
+	return platform_driver_register(&rtk_dcsys_driver);
+}
+arch_initcall(rtk_dcsys_init);
+
+MODULE_DESCRIPTION("Realtek DC system bus debug driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:RTK-DCSYS-DBG");
diff --git a/drivers/soc/realtek/common/rtk_dc_sys_dbg.h b/drivers/soc/realtek/common/rtk_dc_sys_dbg.h
new file mode 100644
index 00000000..345f5b8
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_dc_sys_dbg.h
@@ -0,0 +1,631 @@
+/* rtk_dc_sys_dbg.h - DC system bus debug driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+static void __iomem *DCSYS_BASE;
+
+struct module_id {
+	int id;
+	char *name;
+};
+
+#ifdef CONFIG_ARCH_RTD119X
+
+#define MODULE_NUM 17
+
+#define B_VO 0x00
+#define B_SB0 0x01
+#define B_SB1 0x02
+#define B_GPU 0x03
+#define B_CPU 0x04
+#define B_SB2 0x04
+#define B_SB3 0x05
+#define B_VE 0x06
+#define B_SE 0x07
+#define B_MIPI 0x08
+
+//#define M_OSD	0x00	//not inplement in phoenix
+//#define M_V1 0x01	//not inplement in phoenix
+#define M_AIO 0x02
+#define M_CR 0x00
+#define M_CP 0x01
+#define M_USB 0x02
+#define M_NF 0x03
+#define M_ETN 0x06
+#define M_TP 0x07
+#define M_GPU 0x01
+#define M_ACPU 0x00
+#define M_AEE 0x00
+#define M_ADE 0x01
+#define M_MD 0x03
+#define M_JPEG 0x05
+#define M_HIF 0x06
+#define M_VE 0x00
+#define M_SE 0x00
+#define M_MIPI 0x00
+
+#define AIO_ID ((B_SB0 << 3) | M_AIO)
+#define CR_ID ((B_SB1 << 3) | M_CR)
+#define CP_ID ((B_SB1 << 3) | M_CP)
+#define USB_ID ((B_SB1 << 3) | M_USB)
+#define NF_ID ((B_SB1 << 3) | M_NF)
+#define ETN_ID ((B_SB1 << 3) | M_ETN)
+#define TP_ID ((B_SB1 << 3) | M_TP)
+#define GPU_ID ((B_GPU << 3) | M_GPU)
+#define ACPU_ID ((B_SB2 << 3) | M_ACPU)
+#define AEE_ID ((B_SB3 << 3) | M_AEE)
+#define ADE_ID ((B_SB3 << 3) | M_ADE)
+#define MD_ID ((B_SB3 << 3) | M_MD)
+#define JPEG_ID ((B_SB3 << 3) | M_JPEG)
+#define HIF_ID ((B_SB3 << 3) | M_HIF)
+#define VE_ID ((B_VE << 3) | M_VE)
+#define SE_ID ((B_SE << 3) | M_SE)
+#define MIPI_ID ((B_MIPI << 3) | M_MIPI)
+
+struct module_id module_table[MODULE_NUM] = {
+	{AIO_ID, "AIO"},
+	{CR_ID, "CR"},
+	{CP_ID, "CP"},
+	{USB_ID, "USB"},
+	{NF_ID, "NF"},
+	{ETN_ID, "ETN"},
+	{TP_ID, "TP"},
+	{GPU_ID, "GPU"},
+	{ACPU_ID, "ACPU"},
+	{AEE_ID, "AEE"},
+	{ADE_ID, "ADE"},
+	{MD_ID, "MD"},
+	{JPEG_ID, "JPEG"},
+	{HIF_ID, "HIF"},
+	{VE_ID, "VE"},
+	{SE_ID, "SE"},
+	{MIPI_ID, "MIPI"},
+};
+#endif
+
+/* Module ID table*/
+#ifdef CONFIG_ARCH_RTD129x
+
+#define MODULE_NUM 27
+
+#define B_VO 0x00
+#define B_SB0 0x01
+#define B_SB1 0x02
+#define B_GPU 0x03
+#define B_CPU 0x04
+#define B_SB2 0x04
+#define B_SB3 0x05
+#define B_SB4 0x0A
+#define B_VE 0x06
+#define B_SE 0x07
+#define B_MIPI 0x08
+#define B_SATA 0x09
+
+#define M_VO1 0x00
+#define M_AIO 0x02
+#define M_CP 0x01
+#define M_NAT 0x02
+#define M_MD 0x03
+#define M_NAT2 0x04
+#define M_JPEG 0x05
+#define M_TP 0x07
+#define M_GPU 0x01
+#define M_NWC 0x00
+#define M_SWC 0x01
+#define M_ACPU 0x03
+#define M_HIF 0x04
+#define M_AEE 0x00
+#define M_ADE 0x01
+#define M_USB 0x02
+#define M_ETN 0x06
+#define M_CR 0x00
+#define M_NF 0x03
+#define M_PCIE0 0x04
+#define M_PCIE1 0x06
+#define M_VE1 0x00
+#define M_VE2 0x01
+#define M_VE3 0x02
+#define M_SE 0x00
+#define M_MIPI 0x00
+#define M_SATA 0x00
+
+#define VO1_ID ((B_VO << 3) | M_VO1)
+#define AIO_ID ((B_SB0 << 3) | M_AIO)
+#define CP_ID ((B_SB1 << 3) | M_CP)
+#define NAT_ID ((B_SB1 << 3) | M_NAT)
+#define MD_ID ((B_SB1 << 3) | M_MD)
+#define NAT2_ID ((B_SB1 << 3) | M_NAT2)
+#define JPEG_ID ((B_SB1 << 3) | M_JPEG)
+#define TP_ID ((B_SB1 << 3) | M_TP)
+#define GPU_ID ((B_GPU << 3) | M_GPU)
+#define CPU_NWC_ID ((B_CPU << 3) | M_NWC)
+#define CPU_SWC_ID ((B_CPU << 3) | M_SWC)
+#define ACPU_ID ((B_SB2 << 3) | M_ACPU)
+#define HIF_ID ((B_SB2 << 3) | M_HIF)
+#define AEE_ID ((B_SB3 << 3) | M_AEE)
+#define ADE_ID ((B_SB3 << 3) | M_ADE)
+#define USB_ID ((B_SB3 << 3) | M_USB)
+#define ETN_ID ((B_SB3 << 3) | M_ETN)
+#define CR_ID ((B_SB4 << 3) | M_CR)
+#define NF_ID ((B_SB4 << 3) | M_NF)
+#define PCIE0_ID ((B_SB4 << 3) | M_PCIE0)
+#define PCIE1_ID ((B_SB4 << 3) | M_PCIE1)
+#define VE1_ID ((B_VE << 3) | M_VE1)
+#define VE2_ID ((B_VE << 3) | M_VE2)
+#define VE3_ID ((B_VE << 3) | M_VE3)
+#define SE_ID ((B_SE << 3) | M_SE)
+#define MIPI_ID ((B_MIPI << 3) | M_MIPI)
+#define SATA_ID ((B_SATA << 3) | M_SATA)
+
+struct module_id module_table[MODULE_NUM] = {
+	{VO1_ID, "VO1"},
+	{AIO_ID, "AIO"},
+	{CP_ID, "CP"},
+	{NAT_ID, "NAT"},
+	{MD_ID, "MD"},
+	{NAT2_ID, "NAT2"},
+	{JPEG_ID, "JPEG"},
+	{TP_ID, "TP"},
+	{GPU_ID, "GPU"},
+	{CPU_NWC_ID, "SCPU_NWC"},
+	{CPU_SWC_ID, "SCPU_SWC"},
+	{ACPU_ID, "ACPU"},
+	{HIF_ID, "HIF"},
+	{AEE_ID, "AEE"},
+	{ADE_ID, "ADE"},
+	{USB_ID, "USB"},
+	{ETN_ID, "ETN"},
+	{CR_ID, "CR"},
+	{NF_ID, "NF"},
+	{PCIE0_ID, "PCIE0"},
+	{PCIE1_ID, "PCIE1"},
+	{VE1_ID, "VE1"},
+	{VE2_ID, "VE2"},
+	{VE3_ID, "VE3"},
+	{SE_ID, "SE"},
+	{MIPI_ID, "MIPI"},
+	{SATA_ID, "SATA"},
+};
+
+#endif /* CONFIG_ARCH_RTD129x */
+
+#ifdef CONFIG_ARCH_RTD139x
+
+#define MODULE_NUM 28
+
+#define B_VO 0x00
+#define B_SB0 0x01
+#define B_SB1 0x02
+#define B_GPU 0x03
+#define B_CPU 0x04
+#define B_SB2 0x04
+#define B_SB3 0x05
+#define B_SB4 0x0A
+#define B_VE 0x06
+#define B_SE 0x07
+#define B_MIPI 0x08
+#define B_SATA 0x09
+#define B_DIP 0x0B
+#define B_HSE 0x0C
+
+#define M_VO1 0x00
+#define M_AIO 0x02
+#define M_CP 0x01
+#define M_MD 0x03
+#define M_JPEG 0x05
+#define M_TP 0x07
+#define M_GPU 0x01
+#define M_NWC 0x00
+#define M_SWC 0x05
+#define M_ACPU 0x03
+#define M_HIF 0x02
+#define M_AEE 0x00
+#define M_ADE 0x01
+#define M_USB 0x02
+#define M_SD 0x03
+#define M_PCIE 0x04
+#define M_SDIO 0x05
+#define M_ETN 0x06
+#define M_EMMC 0x00
+#define M_NF 0x03
+#define M_VE1 0x00
+#define M_VE2 0x01
+#define M_SE 0x00
+#define M_MIPI 0x00
+#define M_SATA 0x00
+#define M_DIP 0x00
+#define M_HSE_REE 0x00
+#define M_HSE_TEE 0x05
+
+#define VO1_ID ((B_VO << 3) | M_VO1)
+#define AIO_ID ((B_SB0 << 3) | M_AIO)
+#define CP_ID ((B_SB1 << 3) | M_CP)
+#define MD_ID ((B_SB1 << 3) | M_MD)
+#define JPEG_ID ((B_SB1 << 3) | M_JPEG)
+#define TP_ID ((B_SB1 << 3) | M_TP)
+#define GPU_ID ((B_GPU << 3) | M_GPU)
+#define CPU_NWC_ID ((B_CPU << 3) | M_NWC)
+#define CPU_SWC_ID ((B_CPU << 3) | M_SWC)
+#define ACPU_ID ((B_SB2 << 3) | M_ACPU)
+#define HIF_ID ((B_SB2 << 3) | M_HIF)
+#define AEE_ID ((B_SB3 << 3) | M_AEE)
+#define ADE_ID ((B_SB3 << 3) | M_ADE)
+#define USB_ID ((B_SB3 << 3) | M_USB)
+#define SD_ID ((B_SB3 << 3) | M_SD)
+#define PCIE_ID ((B_SB3 << 3) | M_PCIE)
+#define SDIO_ID ((B_SB3 << 3) | M_SDIO)
+#define ETN_ID ((B_SB3 << 3) | M_ETN)
+#define EMMC_ID ((B_SB4 << 3) | M_EMMC)
+#define NF_ID ((B_SB4 << 3) | M_NF)
+#define VE1_ID ((B_VE << 3) | M_VE1)
+#define VE2_ID ((B_VE << 3) | M_VE2)
+#define SE_ID ((B_SE << 3) | M_SE)
+#define MIPI_ID ((B_MIPI << 3) | M_MIPI)
+#define SATA_ID ((B_SATA << 3) | M_SATA)
+#define DIP_ID ((B_DIP << 3) | M_DIP)
+#define HSE_REE_ID ((B_HSE << 3) | M_HSE_REE)
+#define HSE_TEE_ID ((B_HSE << 3) | M_HSE_TEE)
+
+struct module_id module_table[MODULE_NUM] = {
+	{VO1_ID, "VO1"},
+	{AIO_ID, "AIO"},
+	{CP_ID, "CP"},
+	{MD_ID, "MD"},
+	{JPEG_ID, "JPEG"},
+	{TP_ID, "TP"},
+	{GPU_ID, "GPU"},
+	{CPU_NWC_ID, "SCPU_NWC"},
+	{CPU_SWC_ID, "SCPU_SWC"},
+	{ACPU_ID, "ACPU"},
+	{HIF_ID, "HIF"},
+	{AEE_ID, "AEE"},
+	{ADE_ID, "ADE"},
+	{USB_ID, "USB"},
+	{SD_ID, "SD"},
+	{PCIE_ID, "PCIE"},
+	{SDIO_ID, "SDIO"},
+	{ETN_ID, "ETN"},
+	{EMMC_ID, "EMMC"},
+	{NF_ID, "NF"},
+	{VE1_ID, "VE1"},
+	{VE2_ID, "VE2"},
+	{SE_ID, "SE"},
+	{MIPI_ID, "MIPI"},
+	{SATA_ID, "SATA"},
+	{DIP_ID, "DIP"},
+	{HSE_REE_ID, "HSE_REE"},
+	{HSE_TEE_ID, "HSE_TEE"},
+};
+#endif /* CONFIG_ARCH_RTD139x */
+
+#ifdef CONFIG_ARCH_RTD16xx
+
+#define MODULE_NUM 32
+
+#define B_VO 0x00
+#define B_SB0 0x01
+#define B_SB1 0x02
+#define B_GPU 0x03
+#define B_CPU 0x04
+#define B_SB2 0x04
+#define B_SB3 0x05
+#define B_SB4 0x0A
+#define B_VE 0x06
+#define B_SE 0x07
+#define B_MIPI 0x08
+#define B_SATA 0x09
+#define B_DIP 0x0B
+#define B_HSE 0x0C
+
+#define M_VO1 0x00
+#define M_AIO 0x02
+#define M_R2RDSC 0x00
+#define M_CP 0x01
+#define M_AEE 0x02
+#define M_MD 0x03
+#define M_ADE 0x04
+#define M_JPEG 0x05
+#define M_TPB 0x06
+#define M_TP 0x07
+#define M_GPU 0x01
+#define M_NWC 0x00
+#define M_SWC 0x05
+#define M_ACPU 0x03
+#define M_HIF 0x02
+#define M_USB 0x02
+#define M_PCIE 0x04
+#define M_SDIO 0x05
+#define M_ETN 0x06
+#define M_EMMC 0x00
+#define M_SD 0x01
+#define M_PCIE2SATA 0x02
+#define M_NF 0x03
+#define M_TSIO 0x04
+#define M_VE1 0x00
+#define M_VE2 0x01
+#define M_SE 0x00
+#define M_MIPI 0x00
+#define M_SATA 0x00
+#define M_DIP 0x00
+#define M_HSE_REE 0x00
+#define M_HSE_TEE 0x05
+
+#define VO1_ID ((B_VO << 3) | M_VO1)
+#define AIO_ID ((B_SB0 << 3) | M_AIO)
+#define R2RDSC_ID ((B_SB1 << 3) | M_R2RDSC)
+#define CP_ID ((B_SB1 << 3) | M_CP)
+#define AEE_ID ((B_SB1 << 3) | M_AEE)
+#define MD_ID ((B_SB1 << 3) | M_MD)
+#define ADE_ID ((B_SB1 << 3) | M_ADE)
+#define JPEG_ID ((B_SB1 << 3) | M_JPEG)
+#define TPB_ID ((B_SB1 << 3) | M_TPB)
+#define TP_ID ((B_SB1 << 3) | M_TP)
+#define GPU_ID ((B_GPU << 3) | M_GPU)
+#define CPU_NWC_ID ((B_CPU << 3) | M_NWC)
+#define CPU_SWC_ID ((B_CPU << 3) | M_SWC)
+#define ACPU_ID ((B_SB2 << 3) | M_ACPU)
+#define HIF_ID ((B_SB2 << 3) | M_HIF)
+#define USB_ID ((B_SB3 << 3) | M_USB)
+#define PCIE_ID ((B_SB3 << 3) | M_PCIE)
+#define SDIO_ID ((B_SB3 << 3) | M_SDIO)
+#define ETN_ID ((B_SB3 << 3) | M_ETN)
+#define EMMC_ID ((B_SB4 << 3) | M_EMMC)
+#define SD_ID ((B_SB4 << 3) | M_SD)
+#define PCIE2SATA_ID ((B_SB4 << 3) | M_PCIE2SATA)
+#define NF_ID ((B_SB4 << 3) | M_NF)
+#define TSIO_ID ((B_SB4 << 3) | M_TSIO)
+#define VE1_ID ((B_VE << 3) | M_VE1)
+#define VE2_ID ((B_VE << 3) | M_VE2)
+#define SE_ID ((B_SE << 3) | M_SE)
+#define MIPI_ID ((B_MIPI << 3) | M_MIPI)
+#define SATA_ID ((B_SATA << 3) | M_SATA)
+#define DIP_ID ((B_DIP << 3) | M_DIP)
+#define HSE_REE_ID ((B_HSE << 3) | M_HSE_REE)
+#define HSE_TEE_ID ((B_HSE << 3) | M_HSE_TEE)
+
+struct module_id module_table[MODULE_NUM] = {
+	{VO1_ID, "VO1"},
+	{AIO_ID, "AIO"},
+	{R2RDSC_ID, "R2RDSC"},
+	{CP_ID, "CP"},
+	{AEE_ID, "AEE"},
+	{MD_ID, "MD"},
+	{ADE_ID, "ADE"},
+	{JPEG_ID, "JPEG"},
+	{TPB_ID, "TPB"},
+	{TP_ID, "TP"},
+	{GPU_ID, "GPU"},
+	{CPU_NWC_ID, "SCPU_NWC"},
+	{CPU_SWC_ID, "SCPU_SWC"},
+	{ACPU_ID, "ACPU"},
+	{HIF_ID, "HIF"},
+	{USB_ID, "USB"},
+	{PCIE_ID, "PCIE"},
+	{SDIO_ID, "SDIO"},
+	{ETN_ID, "ETN"},
+	{EMMC_ID, "EMMC"},
+	{SD_ID, "SD"},
+	{PCIE2SATA_ID, "PCIE2SATA"},
+	{NF_ID, "NF"},
+	{TSIO_ID, "TSIO"},
+	{VE1_ID, "VE1"},
+	{VE2_ID, "VE2"},
+	{SE_ID, "SE"},
+	{MIPI_ID, "MIPI"},
+	{SATA_ID, "SATA"},
+	{DIP_ID, "DIP"},
+	{HSE_REE_ID, "HSE_REE"},
+	{HSE_TEE_ID, "HSE_TEE"},
+};
+#endif /* CONFIG_ARCH_RTD16xx */
+
+#ifdef CONFIG_ARCH_RTD13xx
+
+#define MODULE_NUM 29
+
+#define B_VO 0x00
+#define B_SB0 0x01
+#define B_SB1 0x02
+#define B_CPU 0x04
+#define B_SB2 0x04
+#define B_SB3 0x05
+#define B_SB4 0x0A
+#define B_SATA 0x09
+#define B_DIP 0x0B
+#define B_HSE 0x0C
+
+#define M_VO1 0x00
+#define M_AIO 0x02
+#define M_R2RDSC 0x00
+#define M_CP 0x01
+#define M_AEE 0x02
+#define M_MD 0x03
+#define M_ADE 0x04
+#define M_JPEG 0x05
+#define M_TPB 0x06
+#define M_TP 0x07
+#define M_NWC 0x00
+#define M_SWC 0x05
+#define M_ACPU 0x03
+#define M_HIF 0x02
+#define M_TPC 0x00
+#define M_SD 0x01
+#define M_USB 0x02
+#define M_PCIE0 0x04
+#define M_SDIO 0x05
+#define M_ETN 0x06
+#define M_EMMC 0x00
+#define M_PCIE1 0x02
+#define M_NF 0x03
+#define M_TSIO 0x04
+#define M_PCIE2 0x05
+#define M_SATA 0x00
+#define M_DIP 0x00
+#define M_HSE_REE 0x00
+#define M_HSE_TEE 0x05
+
+#define VO1_ID ((B_VO << 3) | M_VO1)
+#define AIO_ID ((B_SB0 << 3) | M_AIO)
+#define R2RDSC_ID ((B_SB1 << 3) | M_R2RDSC)
+#define CP_ID ((B_SB1 << 3) | M_CP)
+#define AEE_ID ((B_SB1 << 3) | M_AEE)
+#define MD_ID ((B_SB1 << 3) | M_MD)
+#define ADE_ID ((B_SB1 << 3) | M_ADE)
+#define JPEG_ID ((B_SB1 << 3) | M_JPEG)
+#define TPB_ID ((B_SB1 << 3) | M_TPB)
+#define TP_ID ((B_SB1 << 3) | M_TP)
+#define CPU_NWC_ID ((B_CPU << 3) | M_NWC)
+#define CPU_SWC_ID ((B_CPU << 3) | M_SWC)
+#define ACPU_ID ((B_SB2 << 3) | M_ACPU)
+#define HIF_ID ((B_SB2 << 3) | M_HIF)
+#define TPC_ID ((B_SB3 << 3) | M_TPC)
+#define SD_ID ((B_SB3 << 3) | M_SD)
+#define USB_ID ((B_SB3 << 3) | M_USB)
+#define PCIE0_ID ((B_SB3 << 3) | M_PCIE0)
+#define SDIO_ID ((B_SB3 << 3) | M_SDIO)
+#define ETN_ID ((B_SB3 << 3) | M_ETN)
+#define EMMC_ID ((B_SB4 << 3) | M_EMMC)
+#define PCIE1_ID ((B_SB4 << 3) | M_PCIE1)
+#define NF_ID ((B_SB4 << 3) | M_NF)
+#define TSIO_ID ((B_SB4 << 3) | M_TSIO)
+#define PCIE2_ID ((B_SB4 << 3) | M_PCIE2)
+#define SATA_ID ((B_SATA << 3) | M_SATA)
+#define DIP_ID ((B_DIP << 3) | M_DIP)
+#define HSE_REE_ID ((B_HSE << 3) | M_HSE_REE)
+#define HSE_TEE_ID ((B_HSE << 3) | M_HSE_TEE)
+
+struct module_id module_table[MODULE_NUM] = {
+	{VO1_ID, "VO1"},
+	{AIO_ID, "AIO"},
+	{R2RDSC_ID, "R2RDSC"},
+	{CP_ID, "CP"},
+	{AEE_ID, "AEE"},
+	{MD_ID, "MD"},
+	{ADE_ID, "ADE"},
+	{JPEG_ID, "JPEG"},
+	{TPB_ID, "TPB"},
+	{TP_ID, "TP"},
+	{CPU_NWC_ID, "SCPU_NWC"},
+	{CPU_SWC_ID, "SCPU_SWC"},
+	{ACPU_ID, "ACPU"},
+	{HIF_ID, "HIF"},
+	{TPC_ID, "TPC"},
+	{SD_ID, "SD"},
+	{USB_ID, "USB"},
+	{PCIE0_ID, "PCIE0"},
+	{SDIO_ID, "SDIO"},
+	{ETN_ID, "ETN"},
+	{EMMC_ID, "EMMC"},
+	{PCIE1_ID, "PCIE1"},
+	{NF_ID, "NF"},
+	{TSIO_ID, "TSIO"},
+	{PCIE2_ID, "PCIE2"},
+	{SATA_ID, "SATA"},
+	{DIP_ID, "DIP"},
+	{HSE_REE_ID, "HSE_REE"},
+	{HSE_TEE_ID, "HSE_TEE"},
+};
+#endif /* CONFIG_ARCH_RTD13xx */
+
+
+#define INT2SCPU 0x0
+#define INT2ACPU 0x1
+#define INT2VCPU 0x2
+
+/* Memory trash detection part */
+#define MODE_B0 0
+#define W_EN_B2 2
+#define INT3_EN_B3 3
+#define INT2_EN_B4 4
+#define INT1_EN_B5 5
+#define CPU_B6 6
+#define W_EN4_B8 8
+#define INT3_B9 9
+#define W_EN3_B10 10
+#define INT2_B11 11
+#define W_EN2_B12 12
+#define INT1_B13 13
+#define W_EN1_B14 14
+#define ACCESS_T3_B15 15
+#define ACCESS_T2_B17 17
+#define ACCESS_T1_B19 19
+#define ACCESS_T0_B21 21
+#define W_EN0_B23 23
+
+#define MOD_ID1_B25 25
+#define MOD_ID0_B18 18
+
+#define MEM_TYPE_BIT 30
+#define SADDR_BIT 2
+#define SADDR_MASK 5
+#define EADDR_BIT 2
+#define EADDR_MASK 5
+
+#define TYPE_INVAILD 0x0
+#define TYPE_R 0x1
+#define TYPE_W 0x2
+#define TYPE_RW (TYPE_R|TYPE_W)
+
+#define MODE1 0x1
+#define MODE2 0x2
+#define MODE3 0x3
+
+#define DC_MT_SADDR (DCSYS_BASE + 0x0200)
+#define DC_MT_EADDR (DCSYS_BASE + 0x0220)
+#define DC_MT_MODE (DCSYS_BASE + 0x0240)
+#define DC_MT_TABLE (DCSYS_BASE + 0x0260)
+#define DC_MT_ADDCMD_HI (DCSYS_BASE + 0x0280)
+#define DC_MT_ADDCMD_LO_0 (DCSYS_BASE + 0x02A0)
+#define DC_MT_ADDCMD_LO_1 (DCSYS_BASE + 0x02C0)
+#define DC_MT_MISC (DCSYS_BASE + 0x02E0)
+
+#define WRITE_EN(x) (1 << x)
+#define ACCESS_TYPE(x, n) (x << n)
+#define INIT_EN(x) (1 << x)
+#define CPU_TYPE(x) (x << CPU_B6)
+#define TRASH_MODE(x) (x << MODE_B0)
+#define CLR_EVER_TRAP(x) ((x) & 0x3fffffff)
+
+#define SADDR(x) (1 << MEM_TYPE_BIT | ((x >> SADDR_MASK) << SADDR_BIT))
+#define EADDR(x) ((x >> EADDR_MASK) << EADDR_BIT)
+
+#define INT1_TRIG 0x2000
+#define INT2_TRIG 0x800
+#define INT3_TRIG 0x200
+
+/* Error command detection part */
+#define DC_EC_CTRL (DCSYS_BASE + 0x0300)
+#define DC_EC_ADDCMD_HI (DCSYS_BASE + 0x0304)
+#define DC_EC_ADDCMD_LO_0 (DCSYS_BASE + 0x0308)
+#define DC_EC_ADDCMD_LO_1 (DCSYS_BASE + 0x030C)
+
+#define LARGE_DCSYS1_B30 30
+#define LARGE_DCSYS0_B29 29
+#define EC_INT_CPU_B27 27
+#define EC_INT_EN_B26 26
+#define EC_SWAP_EN_B25 25
+#define EC_DETECT_EN_B24 24
+#define EC_EVER_TRAP1_B23 23
+#define EC_EVER_TRAP0_B22 22
+#define EC_INT1_B21 21
+#define EC_INT0_B20 20
+#define OVER_DCSYS1_B19 19
+#define OVER_DCSYS0_B18 18
+
+#define WRAP_ERR1_B31 31
+#define WRAP_ERR0_B30 30
+#define RD_ERR1_B29 29
+#define RD_ERR0_B28 28
+#define CASE1_B24 24
+#define CASE0_B20 20
+
+#define EC_CTRL_EN(x) (1 << x)
+#define EC_CPU_TYPE(x) (x << EC_INT_CPU_B27)
diff --git a/drivers/soc/realtek/common/rtk_dcsys.c b/drivers/soc/realtek/common/rtk_dcsys.c
new file mode 100644
index 00000000..d654f9c
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_dcsys.c
@@ -0,0 +1,330 @@
+/*
+ * Realtek DCSYS driver
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2017-2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/io.h>
+#include <linux/jiffies.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/miscdevice.h>
+#include <linux/mm.h>
+#include <soc/realtek/perfcnt.h>
+#include <soc/realtek/dcsys.h>
+#include "include/rtk_dcsys.h"
+
+struct dcsys_perfcnt_desc {
+	u32 type;
+	u32 conf_off;
+	u32 conf_mask;
+	u32 data_off;
+};
+
+#define DCSYS_PERFCNT_DESC_TOTAL(_id)                                 \
+{                                                                     \
+	.data_off = DCSYS_PC_TOTA_MON_NUM_ ## _id,                    \
+}
+#define DCSYS_PERFCNT_DESC_SYSH(_id)                                  \
+{                                                                     \
+	.conf_off = DCSYS_PC_SYSH_PROG_ ## _id ## _CTRL,              \
+	.conf_mask = DCSYS_PC_SYSH_PROG_ ## _id ## _CTRL_MASK,        \
+	.data_off = DCSYS_PC_SYSH_PROG_ ## _id ## _ACC_LAT,           \
+}
+#define DCSYS_PERFCNT_DESC_SYS(_id)                                   \
+{                                                                     \
+	.conf_off = DCSYS_PC_SYS_PROG_ ## _id ## _CTRL,               \
+	.conf_mask = DCSYS_PC_SYS_PROG_ ## _id ## _CTRL_MASK,         \
+	.data_off = DCSYS_PC_SYS_PROG_ ## _id ## _ACC_LAT,            \
+}
+
+static const struct dcsys_perfcnt_desc pcdev_descs[] = {
+	[DCSYS_PERFCNT_ID_TOTAL_0] = DCSYS_PERFCNT_DESC_TOTAL(0),
+	[DCSYS_PERFCNT_ID_TOTAL_1] = DCSYS_PERFCNT_DESC_TOTAL(1),
+	[DCSYS_PERFCNT_ID_SYSH_0]  = DCSYS_PERFCNT_DESC_SYSH(0),
+	[DCSYS_PERFCNT_ID_SYSH_1]  = DCSYS_PERFCNT_DESC_SYSH(1),
+	[DCSYS_PERFCNT_ID_SYSH_2]  = DCSYS_PERFCNT_DESC_SYSH(2),
+	[DCSYS_PERFCNT_ID_SYSH_3]  = DCSYS_PERFCNT_DESC_SYSH(3),
+	[DCSYS_PERFCNT_ID_SYSH_4]  = DCSYS_PERFCNT_DESC_SYSH(4),
+	[DCSYS_PERFCNT_ID_SYSH_5]  = DCSYS_PERFCNT_DESC_SYSH(5),
+	[DCSYS_PERFCNT_ID_SYSH_6]  = DCSYS_PERFCNT_DESC_SYSH(6),
+	[DCSYS_PERFCNT_ID_SYSH_7]  = DCSYS_PERFCNT_DESC_SYSH(7),
+	[DCSYS_PERFCNT_ID_SYS_0]   = DCSYS_PERFCNT_DESC_SYS(0),
+	[DCSYS_PERFCNT_ID_SYS_1]   = DCSYS_PERFCNT_DESC_SYS(1),
+	[DCSYS_PERFCNT_ID_SYS_2]   = DCSYS_PERFCNT_DESC_SYS(2),
+};
+
+struct dcsys_device {
+	struct miscdevice     mdev;
+	struct perfcnt_device pcdev;
+	const struct dcsys_perfcnt_desc
+	                      *desc;
+	struct device         *dev;
+
+	void                  *internal_addr;
+	phys_addr_t           addr;
+	resource_size_t       size;
+	u32                   open_cnt;
+	struct mutex          lock;
+};
+
+static u32 dcsys_read(struct dcsys_device *dcdev, u32 offset)
+{
+	u32 val;
+
+	val = readl(dcdev->internal_addr + offset);
+	dev_dbg(dcdev->dev, "%s: off=%03x, val=%08x\n", __func__, offset, val);
+	return val;
+}
+
+static void dcsys_write(struct dcsys_device *dcdev, u32 offset, u32 val)
+{
+	dev_dbg(dcdev->dev, "%s: off=%03x, val=%08x\n", __func__, offset, val);
+	writel(val, dcdev->internal_addr + offset);
+}
+
+static void dcsys_update_bits(struct dcsys_device *dcdev,
+			      u32 offset,
+			      u32 mask,
+			      u32 val)
+{
+	u32 rval;
+
+	dev_dbg(dcdev->dev, "%s: off=%03x, mask=%08x, val=%08x\n", __func__,
+		offset, mask, val);
+	rval = readl(dcdev->internal_addr + offset);
+	rval = (rval & ~mask) | (val & mask);
+	writel(rval, dcdev->internal_addr + offset);
+}
+
+
+static int dcsys_perfcnt_start(struct perfcnt_device *pcdev)
+{
+	struct dcsys_device *dcdev = container_of(pcdev, struct dcsys_device, pcdev);
+
+	dcsys_write(dcdev, DCSYS_PC_CTRL, 0);
+	dcsys_write(dcdev, DCSYS_PC_CTRL, 1);
+	return 0;
+}
+
+static int dcsys_perfcnt_stop(struct perfcnt_device *pcdev)
+{
+	struct dcsys_device *dcdev = container_of(pcdev, struct dcsys_device, pcdev);
+
+	dcsys_write(dcdev, DCSYS_PC_CTRL, 0);
+	return 0;
+}
+
+static int dcsys_perfcnt_reset(struct perfcnt_device *pcdev)
+{
+	struct dcsys_device *dcdev = container_of(pcdev, struct dcsys_device, pcdev);
+
+	dcsys_write(dcdev, DCSYS_PC_CTRL, 0);
+	return 0;
+}
+
+static int dcsys_perfcnt_set_conf(struct perfcnt_device *pcdev, u32 id, u32 conf)
+{
+	struct dcsys_device *dcdev = container_of(pcdev, struct dcsys_device, pcdev);
+	const struct dcsys_perfcnt_desc *d = &dcdev->desc[id];
+
+	switch (id) {
+	default:
+		return -EINVAL;
+	case DCSYS_PERFCNT_ID_SYSH_0 ... DCSYS_PERFCNT_ID_SYSH_7:
+	case DCSYS_PERFCNT_ID_SYS_0 ... DCSYS_PERFCNT_ID_SYS_2:
+		break;
+	}
+	dcsys_update_bits(dcdev, d->conf_off, d->conf_mask, conf << (ffs(d->conf_mask) - 1));
+	return 0;
+}
+
+static int dcsys_perfcnt_get_data(struct perfcnt_device *pcdev, u32 id, struct perfcnt_data *data)
+{
+	struct dcsys_device *dcdev = container_of(pcdev, struct dcsys_device, pcdev);
+	const struct dcsys_perfcnt_desc *d = &dcdev->desc[id];
+	u32 size = 0;
+	int i;
+
+	switch (id) {
+	case DCSYS_PERFCNT_ID_TOTAL_0:
+	case DCSYS_PERFCNT_ID_TOTAL_1:
+		size = 3;
+		break;
+	case DCSYS_PERFCNT_ID_SYSH_0 ... DCSYS_PERFCNT_ID_SYSH_7:
+	case DCSYS_PERFCNT_ID_SYS_0 ... DCSYS_PERFCNT_ID_SYS_2:
+		size = 4;
+		break;
+	}
+
+	for (i = 0; i < size; i++)
+		data->data[i] = dcsys_read(dcdev, d->data_off + i * 4);
+	return 0;
+}
+
+static const struct perfcnt_ops dcsys_prefcnt_ops = {
+	.start    = dcsys_perfcnt_start,
+	.stop     = dcsys_perfcnt_stop,
+	.reset    = dcsys_perfcnt_reset,
+	.set_conf = dcsys_perfcnt_set_conf,
+	.get_data = dcsys_perfcnt_get_data,
+};
+
+static int dcsys_open(struct inode *inode, struct file *filp)
+{
+	struct dcsys_device *dcdev = container_of(filp->private_data,
+		struct dcsys_device, mdev);
+
+	mutex_lock(&dcdev->lock);
+	if (dcdev->open_cnt != 0) {
+		mutex_unlock(&dcdev->lock);
+		return -EBUSY;
+	}
+
+	dcdev->open_cnt = 1;
+	perfcnt_suspend(&dcdev->pcdev);
+	mutex_unlock(&dcdev->lock);
+	return 0;
+}
+
+static int dcsys_release(struct inode *inode, struct file *filp)
+{
+	struct dcsys_device *dcdev = container_of(filp->private_data,
+		struct dcsys_device, mdev);
+
+	mutex_lock(&dcdev->lock);
+	dcdev->open_cnt = 0;
+	perfcnt_resume(&dcdev->pcdev);
+	mutex_unlock(&dcdev->lock);
+	return 0;
+}
+
+static const struct vm_operations_struct dcsys_vm_ops = {
+#ifdef CONFIG_HAVE_IOREMAP_PROT
+	.access = generic_access_phys,
+#endif
+};
+
+static int dcsys_mmap(struct file *filp, struct vm_area_struct *vma)
+{
+	struct dcsys_device *dcdev = container_of(filp->private_data,
+		struct dcsys_device, mdev);
+
+	if (vma->vm_end < vma->vm_start)
+		return -EINVAL;
+
+	if (dcdev->addr & ~PAGE_MASK)
+		return -EINVAL;
+
+	if (vma->vm_end - vma->vm_start > dcdev->size)
+		return -EINVAL;
+
+	if (vma->vm_pgoff > (dcdev->size >> PAGE_SHIFT))
+		return -EINVAL;
+
+	vma->vm_ops = &dcsys_vm_ops;
+	vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+
+	return remap_pfn_range(vma,
+			       vma->vm_start,
+			       dcdev->addr >> PAGE_SHIFT,
+			       vma->vm_end - vma->vm_start,
+			       vma->vm_page_prot);
+}
+
+
+static const struct file_operations dcsys_fops = {
+	.owner         = THIS_MODULE,
+	.open          = dcsys_open,
+	.release       = dcsys_release,
+	.mmap          = dcsys_mmap,
+};
+
+static int dcsys_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	struct dcsys_device *dcdev;
+	struct resource res;
+	int ret;
+
+	dcdev = devm_kzalloc(dev, sizeof(*dcdev), GFP_KERNEL);
+	if (!dcdev)
+		return -ENOMEM;
+
+	ret = of_address_to_resource(np, 0, &res);
+	if (ret) {
+		dev_err(dev, "of_address_to_resource() returns %d\n", ret);
+		return ret;
+	}
+
+	mutex_init(&dcdev->lock);
+        dcdev->addr = res.start;
+	dcdev->size = ALIGN(resource_size(&res), PAGE_SIZE);
+	dcdev->internal_addr = devm_ioremap(dev, res.start, resource_size(&res));
+	if (!dcdev->internal_addr) {
+		dev_err(dev, "ioremap() returns NULL\n");
+		return -ENOMEM;
+	}
+
+	dcdev->desc   = pcdev_descs;
+	dcdev->pcdev.dev = dev;
+	dcdev->pcdev.np  = np;
+	dcdev->pcdev.ops = &dcsys_prefcnt_ops;
+	ret = perfcnt_register(&dcdev->pcdev);
+	if (ret) {
+		dev_err(dev, "perfcnt_register() returns %d\n", ret);
+		return ret;
+	}
+
+	dcdev->mdev.minor  = MISC_DYNAMIC_MINOR;
+	dcdev->mdev.name   = "dcsys";
+	dcdev->mdev.fops   = &dcsys_fops;
+	dcdev->mdev.parent = dev;
+	ret = misc_register(&dcdev->mdev);
+	if (ret) {
+		dev_err(dev, "misc_register() returns %d\n", ret);
+		goto error;
+	}
+
+	platform_set_drvdata(pdev, dcdev);
+	dev_info(dev, "initialized\n");
+	return 0;
+error:
+	perfcnt_unregister(&dcdev->pcdev);
+	return ret;
+}
+
+static int dcsys_remove(struct platform_device *pdev)
+{
+	struct dcsys_device *dcdev = platform_get_drvdata(pdev);
+
+	misc_deregister(&dcdev->mdev);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+static const struct of_device_id dcsys_ids[] = {
+	{ .compatible = "realtek,dcsys", },
+	{}
+};
+
+static struct platform_driver dcsys_driver = {
+	.probe  = dcsys_probe,
+	.remove = dcsys_remove,
+	.driver = {
+		.owner = THIS_MODULE,
+		.name   = "rtk-dcsys",
+		.of_match_table = dcsys_ids,
+	},
+};
+module_platform_driver(dcsys_driver);
+
diff --git a/drivers/soc/realtek/common/rtk_demod.c b/drivers/soc/realtek/common/rtk_demod.c
new file mode 100644
index 00000000..1c5ea5e
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_demod.c
@@ -0,0 +1,290 @@
+/*
+ * Realtek Demod Driver
+ *
+ * Copyright (C) 2018-2019 Realtek Semiconductor Corp.
+ *
+ * Author:
+ *   Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/miscdevice.h>
+#include <linux/slab.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/list.h>
+#include <linux/pm_runtime.h>
+#include <linux/mm.h>
+
+struct rtk_demod_device {
+	struct miscdevice     mdev;
+	struct device         *dev;
+	/* pm */
+	atomic_t              open_cnt;
+	struct clk            *pll;
+	struct clk            *clk;
+	struct reset_control  *rstc;
+
+	/* map */
+	void                  *internal_addr;
+	phys_addr_t           addr;
+	resource_size_t       size;
+};
+
+struct rtk_demod_ctx {
+	struct rtk_demod_device *dmdev;
+};
+
+static int rtk_demod_open(struct inode *inode, struct file *filp)
+{
+	struct rtk_demod_device *dmdev = container_of(filp->private_data,
+						      struct rtk_demod_device,
+						      mdev);
+	struct rtk_demod_ctx *ctx;
+
+	ctx = kzalloc(sizeof(*ctx), GFP_KERNEL);
+	if (!ctx)
+		return -ENOMEM;
+	ctx->dmdev = dmdev;
+	filp->private_data = ctx;
+
+	atomic_inc(&dmdev->open_cnt);
+	pm_runtime_get_sync(dmdev->dev);
+
+	return 0;
+}
+
+static int rtk_demod_release(struct inode *inode, struct file *filp)
+{
+	struct rtk_demod_ctx *ctx = filp->private_data;
+	struct rtk_demod_device *dmdev = ctx->dmdev;
+
+	pm_runtime_put_sync(dmdev->dev);
+	atomic_dec(&dmdev->open_cnt);
+	kfree(ctx);
+	return 0;
+}
+
+static const struct vm_operations_struct rtk_demod_vm_ops = {
+#ifdef CONFIG_HAVE_IOREMAP_PROT
+	.access = generic_access_phys,
+#endif
+};
+
+static int rtk_demod_mmap(struct file *filp, struct vm_area_struct *vma)
+{
+	struct rtk_demod_ctx *ctx = filp->private_data;
+	struct rtk_demod_device *dmdev = ctx->dmdev;
+
+	if (vma->vm_end < vma->vm_start)
+		return -EINVAL;
+
+	if (dmdev->addr & ~PAGE_MASK)
+		return -EINVAL;
+
+	if (vma->vm_end - vma->vm_start > dmdev->size)
+		return -EINVAL;
+
+	if (vma->vm_pgoff > (dmdev->size >> PAGE_SHIFT))
+		return -EINVAL;
+
+	vma->vm_ops  = &rtk_demod_vm_ops;
+	vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+
+	return remap_pfn_range(vma,
+			       vma->vm_start,
+			       dmdev->addr >> PAGE_SHIFT,
+			       vma->vm_end - vma->vm_start,
+			       vma->vm_page_prot);
+}
+
+
+static const struct file_operations rtk_demod_fops = {
+	.owner         = THIS_MODULE,
+	.open          = rtk_demod_open,
+	.release       = rtk_demod_release,
+	.mmap          = rtk_demod_mmap,
+};
+
+static void rtk_demod_power_on(struct rtk_demod_device *dmdev)
+{
+	clk_prepare_enable(dmdev->clk);
+	clk_prepare_enable(dmdev->pll);
+	reset_control_deassert(dmdev->rstc);
+}
+
+static void rtk_demod_power_off(struct rtk_demod_device *dmdev)
+{
+	 reset_control_assert(dmdev->rstc);
+	 clk_disable_unprepare(dmdev->clk);
+	 clk_disable_unprepare(dmdev->pll);
+}
+
+static int rtk_demod_runtime_resume(struct device *dev)
+{
+	struct rtk_demod_device *dmdev = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "enter %s\n", __func__);
+	rtk_demod_power_on(dmdev);
+	dev_dbg(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_demod_runtime_suspend(struct device *dev)
+{
+	struct rtk_demod_device *dmdev = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "enter %s\n", __func__);
+	rtk_demod_power_off(dmdev);
+	dev_dbg(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_demod_resume(struct device *dev)
+{
+	struct rtk_demod_device *dmdev = dev_get_drvdata(dev);
+
+	if (atomic_read(&dmdev->open_cnt) == 0)
+		return 0;
+
+	dev_info(dev, "enter %s\n", __func__);
+	rtk_demod_power_on(dmdev);
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_demod_suspend(struct device *dev)
+{
+	struct rtk_demod_device *dmdev = dev_get_drvdata(dev);
+
+	if (atomic_read(&dmdev->open_cnt) == 0)
+		return 0;
+
+	dev_info(dev, "enter %s\n", __func__);
+	rtk_demod_power_off(dmdev);
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_demod_pm_ops = {
+	.runtime_suspend = rtk_demod_runtime_suspend,
+	.runtime_resume  = rtk_demod_runtime_resume,
+	.suspend         = rtk_demod_suspend,
+	.resume          = rtk_demod_resume,
+};
+
+static int rtk_demod_probe(struct platform_device *pdev)
+{
+	struct rtk_demod_device *dmdev;
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	int ret;
+	struct resource res;
+
+	dmdev = devm_kzalloc(dev, sizeof(*dmdev), GFP_KERNEL);
+	if (!dmdev)
+		return -ENOMEM;
+
+	dmdev->dev = dev;
+
+	dmdev->clk = devm_clk_get(dev, "cablerx");
+	if (IS_ERR(dmdev->clk)) {
+		ret = PTR_ERR(dmdev->clk);
+		dev_err(dev, "cablerx: failed to get clk: %d\n", ret);
+		return ret;
+	}
+
+	dmdev->pll = devm_clk_get(dev, "pll");
+	if (IS_ERR(dmdev->pll)) {
+		ret = PTR_ERR(dmdev->pll);
+		dev_err(dev, "pll: failed to get clk: %d\n", ret);
+		return ret;
+	}
+
+	dmdev->rstc = devm_reset_control_get(dev, NULL);
+	if (IS_ERR(dmdev->rstc)) {
+		ret = PTR_ERR(dmdev->rstc);
+		dev_err(dev, "failed to get reset_control: %d\n", ret);
+		return ret;
+	}
+
+	ret = of_address_to_resource(np, 0, &res);
+	if (ret) {
+		dev_err(dev, "failed to get address: %d\n", ret);
+		return ret;
+	}
+
+	atomic_set(&dmdev->open_cnt, 0);
+
+	dmdev->addr = res.start;
+	dmdev->size = ALIGN(resource_size(&res), PAGE_SIZE);
+	dmdev->internal_addr = devm_ioremap(dev, res.start,
+		resource_size(&res));
+	if (!dmdev->internal_addr) {
+		dev_err(dev, "failed to ioremap\n");
+		return -ENOMEM;
+	}
+
+	dmdev->mdev.minor  = MISC_DYNAMIC_MINOR;
+	dmdev->mdev.name   = "demod";
+	dmdev->mdev.fops   = &rtk_demod_fops;
+	dmdev->mdev.parent = dev;
+	ret = misc_register(&dmdev->mdev);
+	if (ret) {
+		dev_err(dev, "failed to register misc device: %d\n", ret);
+		return ret;
+	}
+
+	platform_set_drvdata(pdev, dmdev);
+	pm_runtime_set_suspended(dev);
+	pm_runtime_enable(dev);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static int rtk_demod_remove(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct rtk_demod_device *dmdev = platform_get_drvdata(pdev);
+
+	pm_runtime_disable(dev);
+	platform_set_drvdata(pdev, NULL);
+	misc_deregister(&dmdev->mdev);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+
+static const struct of_device_id rtk_demod_ids[] = {
+	{ .compatible = "realtek,demod" },
+	{}
+};
+
+static struct platform_driver rtk_demod_driver = {
+	.probe = rtk_demod_probe,
+	.remove = rtk_demod_remove,
+	.driver = {
+		.owner = THIS_MODULE,
+		.name = "rtk-demod",
+		.of_match_table = rtk_demod_ids,
+		.pm = &rtk_demod_pm_ops,
+	},
+};
+module_platform_driver(rtk_demod_driver);
diff --git a/drivers/soc/realtek/common/rtk_dmc.c b/drivers/soc/realtek/common/rtk_dmc.c
new file mode 100644
index 00000000..8466302
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_dmc.c
@@ -0,0 +1,346 @@
+/*
+ * Realtek DMC driver
+ *
+ * Copyright (C) 2017-2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2017-2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/io.h>
+#include <linux/jiffies.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/miscdevice.h>
+#include <linux/uaccess.h>
+#include <soc/realtek/perfcnt.h>
+#include <soc/realtek/dmc.h>
+#include "include/rtk_dmc.h"
+
+struct dmc_device {
+	struct miscdevice     mdev;
+	struct perfcnt_device pcdev;
+	struct device         *dev;
+
+	void                  *base;
+	u32                   open_cnt;
+	struct mutex          lock;
+
+	int                   sysfs_reg;
+};
+
+static DEFINE_SPINLOCK(dmc_lock);
+
+static u32 dmc_read(struct dmc_device *dmcdev, u32 offset)
+{
+	u32 val;
+	unsigned long flags;
+
+	spin_lock_irqsave(&dmc_lock, flags);
+	writel(offset, dmcdev->base + DMC_SCH_INDEX);
+	val = readl(dmcdev->base + DMC_SCH_DATA);
+	spin_unlock_irqrestore(&dmc_lock, flags);
+
+	dev_dbg(dmcdev->dev, "%s: off=%03x, val=%08x\n", __func__, offset, val);
+	return val;
+}
+
+static void dmc_write(struct dmc_device *dmcdev, u32 offset, u32 val)
+{
+	unsigned long flags;
+
+	dev_dbg(dmcdev->dev, "%s: off=%03x, val=%08x\n", __func__, offset, val);
+
+	spin_lock_irqsave(&dmc_lock, flags);
+	writel(offset, dmcdev->base + DMC_SCH_INDEX);
+	writel(val, dmcdev->base + DMC_SCH_DATA);
+	spin_unlock_irqrestore(&dmc_lock, flags);
+}
+
+static int dmc_perfcnt_start(struct perfcnt_device *pcdev)
+{
+	struct dmc_device *dmcdev = container_of(pcdev, struct dmc_device, pcdev);
+
+	dmc_write(dmcdev, DMC_PC_CTRL, 0x2);
+	dmc_write(dmcdev, DMC_PC_CTRL, 0x1);
+	return 0;
+}
+
+static int dmc_perfcnt_stop(struct perfcnt_device *pcdev)
+{
+	struct dmc_device *dmcdev = container_of(pcdev, struct dmc_device, pcdev);
+
+	dmc_write(dmcdev, DMC_PC_CTRL, 0x0);
+	return 0;
+}
+
+static int dmc_perfcnt_reset(struct perfcnt_device *pcdev)
+{
+	struct dmc_device *dmcdev = container_of(pcdev, struct dmc_device, pcdev);
+
+	dmc_write(dmcdev, DMC_PC_CTRL, 0x2);
+	dmc_write(dmcdev, DMC_PC_CTRL, 0x0);
+	return 0;
+}
+
+static int dmc_perfcnt_get_data(struct perfcnt_device *pcdev, u32 id, struct perfcnt_data *data)
+{
+	struct dmc_device *dmcdev = container_of(pcdev, struct dmc_device, pcdev);
+
+	switch (id) {
+	case DMC_PERFCNT_ID_CPU:
+		data->data[0] = dmc_read(dmcdev, DMC_PC_CPU_REQ_NUM);
+		data->data[1] = dmc_read(dmcdev, DMC_PC_CPU_ACC_LAT);
+		break;
+
+	case DMC_PERFCNT_ID_GPU:
+		data->data[0] = dmc_read(dmcdev, DMC_PC_GPU_REQ_NUM);
+		data->data[1] = dmc_read(dmcdev, DMC_PC_GPU_ACC_LAT);
+		break;
+	}
+	return 0;
+}
+
+static const struct perfcnt_ops dmc_prefcnt_ops = {
+	.start    = dmc_perfcnt_start,
+	.stop     = dmc_perfcnt_stop,
+	.reset    = dmc_perfcnt_reset,
+	.get_data = dmc_perfcnt_get_data,
+};
+
+static int dmc_open(struct inode *inode, struct file *filp)
+{
+	struct dmc_device *dmcdev = container_of(filp->private_data,
+		struct dmc_device, mdev);
+
+	mutex_lock(&dmcdev->lock);
+	if (dmcdev->open_cnt != 0) {
+		mutex_unlock(&dmcdev->lock);
+		return -EBUSY;
+	}
+
+	dmcdev->open_cnt = 1;
+	perfcnt_suspend(&dmcdev->pcdev);
+	mutex_unlock(&dmcdev->lock);
+	return 0;
+}
+
+static int dmc_release(struct inode *inode, struct file *filp)
+{
+	struct dmc_device *dmcdev = container_of(filp->private_data,
+		struct dmc_device, mdev);
+
+	mutex_lock(&dmcdev->lock);
+	dmcdev->open_cnt = 0;
+	perfcnt_resume(&dmcdev->pcdev);
+	mutex_unlock(&dmcdev->lock);
+	return 0;
+}
+
+struct dmc_rw_data {
+	u32 reg;
+	u32 val;
+};
+
+#define DMC_IOCTL_REG_READ    _IOWR(0xD3, 0x1, struct dmc_rw_data)
+#define DMC_IOCTL_REG_WRITE   _IOW(0xD3, 0x02, struct dmc_rw_data)
+static long dmc_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	struct dmc_device *dmcdev = container_of(filp->private_data,
+	                struct dmc_device, mdev);
+	struct dmc_rw_data d;
+
+	if (copy_from_user(&d, (int __user *)arg, sizeof(d)))
+		return -EFAULT;
+
+	if (!dmc_valid_reg(d.reg))
+		return -EINVAL;
+
+	switch (cmd)
+	{
+	case DMC_IOCTL_REG_READ:
+		d.val = dmc_read(dmcdev, d.reg);
+		if (copy_to_user((int __user *)arg, &d, sizeof(d)))
+			return -EFAULT;
+		break;
+	case DMC_IOCTL_REG_WRITE:
+		dmc_write(dmcdev, d.reg, d.val);
+		break;
+	}
+	return 0;
+}
+
+static long dmc_compact_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	dmc_ioctl(filp, cmd, arg);
+	return 0;
+}
+
+static const struct file_operations dmc_fops = {
+	.owner         = THIS_MODULE,
+	.open          = dmc_open,
+	.release       = dmc_release,
+	.compat_ioctl  = dmc_compact_ioctl,
+	.unlocked_ioctl = dmc_ioctl,
+};
+
+static ssize_t reg_store(struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+	struct dmc_device *dmcdev = dev_get_drvdata(dev);
+	int ret;
+	unsigned int val;
+
+	ret = kstrtouint(buf, 0, &val);
+	if (ret)
+		return ret;
+
+	if (!dmc_valid_reg(val))
+		return -EINVAL;
+
+	dmcdev->sysfs_reg = val;
+	return count;
+}
+
+static ssize_t reg_show(struct device *dev, struct device_attribute *attr, char * const buf)
+{
+	struct dmc_device *dmcdev = dev_get_drvdata(dev);
+
+	if (!dmc_valid_reg(dmcdev->sysfs_reg))
+		return -EINVAL;
+
+	return scnprintf(buf, PAGE_SIZE, "0x%2x\n", dmcdev->sysfs_reg);
+}
+static DEVICE_ATTR(reg, 0644, reg_show, reg_store);
+
+static ssize_t reg_val_store(struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+	struct dmc_device *dmcdev = dev_get_drvdata(dev);
+	int ret;
+	unsigned int val;
+
+	if (!dmc_valid_reg(dmcdev->sysfs_reg))
+		return -EINVAL;
+
+	ret = kstrtouint(buf, 0, &val);
+	if (ret)
+		return ret;
+
+	dmc_write(dmcdev, dmcdev->sysfs_reg, val);
+	return count;
+}
+
+static ssize_t reg_val_show(struct device *dev, struct device_attribute *attr, char * const buf)
+{
+	struct dmc_device *dmcdev = dev_get_drvdata(dev);
+
+	if (!dmc_valid_reg(dmcdev->sysfs_reg))
+		return -EINVAL;
+
+	return scnprintf(buf, PAGE_SIZE, "0x%08x\n", dmc_read(dmcdev, dmcdev->sysfs_reg));
+}
+static DEVICE_ATTR(reg_val, 0644, reg_val_show, reg_val_store);
+
+static struct attribute *dmc_attrs[] = {
+	&dev_attr_reg.attr,
+	&dev_attr_reg_val.attr,
+	NULL
+};
+
+static const struct attribute_group dmc_attr_group = {
+	.attrs = dmc_attrs,
+};
+
+static int dmc_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	struct dmc_device *dmcdev;
+	struct resource res;
+	int ret;
+
+	dmcdev = devm_kzalloc(dev, sizeof(*dmcdev), GFP_KERNEL);
+	if (!dmcdev)
+		return -ENOMEM;
+
+	ret = of_address_to_resource(np, 0, &res);
+	if (ret) {
+		dev_err(dev, "of_address_to_resource() returns %d\n", ret);
+		return ret;
+	}
+
+	mutex_init(&dmcdev->lock);
+	dmcdev->base = devm_ioremap(dev, res.start, resource_size(&res));
+	if (!dmcdev->base) {
+		dev_err(dev, "ioremap() returns NULL\n");
+		return -ENOMEM;
+	}
+
+	ret = sysfs_create_group(&dev->kobj, &dmc_attr_group);
+	if (ret) {
+		dev_err(dev, "sysfs_create_group() returns %d\n", ret);
+		return ret;
+	}
+
+	dmcdev->pcdev.dev = dev;
+	dmcdev->pcdev.np  = np;
+	dmcdev->pcdev.ops = &dmc_prefcnt_ops;
+	ret = perfcnt_register(&dmcdev->pcdev);
+	if (ret) {
+		dev_err(dev, "perfcnt_register() returns %d\n", ret);
+		goto remove_sysfs;
+	}
+
+	dmcdev->mdev.minor  = MISC_DYNAMIC_MINOR;
+	dmcdev->mdev.name   = "dmc";
+	dmcdev->mdev.fops   = &dmc_fops;
+	dmcdev->mdev.parent = dev;
+	ret = misc_register(&dmcdev->mdev);
+	if (ret) {
+		dev_err(dev, "misc_register() returns %d\n", ret);
+		goto unregister_prefcnt;
+	}
+
+	platform_set_drvdata(pdev, dmcdev);
+	dev_info(dev, "initialized\n");
+	return 0;
+
+unregister_prefcnt:
+	perfcnt_unregister(&dmcdev->pcdev);
+remove_sysfs:
+	sysfs_remove_group(&dev->kobj, &dmc_attr_group);
+	return ret;
+}
+
+static int dmc_remove(struct platform_device *pdev)
+{
+	struct dmc_device *dmcdev = platform_get_drvdata(pdev);
+	struct device *dev = &pdev->dev;
+
+	misc_deregister(&dmcdev->mdev);
+	perfcnt_unregister(&dmcdev->pcdev);
+	sysfs_remove_group(&dev->kobj, &dmc_attr_group);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+static const struct of_device_id dmc_ids[] = {
+	{ .compatible = "realtek,dmc", },
+	{}
+};
+
+static struct platform_driver dmc_driver = {
+	.probe  = dmc_probe,
+	.remove = dmc_remove,
+	.driver = {
+		.owner = THIS_MODULE,
+		.name   = "rtk-dmc",
+		.of_match_table = dmc_ids,
+	},
+};
+module_platform_driver(dmc_driver);
+
diff --git a/drivers/soc/realtek/common/rtk_ion_of.c b/drivers/soc/realtek/common/rtk_ion_of.c
new file mode 100644
index 00000000..9f22e78
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_ion_of.c
@@ -0,0 +1,428 @@
+#include <linux/version.h>
+#include <linux/err.h>
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/init.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/dma-contiguous.h>
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(3, 10, 9)
+#include "../../drivers/staging/android/ion/ion.h"
+#include "../../drivers/staging/android/uapi/ion.h"
+#include "../../drivers/staging/android/ion/ion_priv.h"
+#include "../../drivers/staging/android/ion/realtek/ion_rtk_carveout_heap.h"
+#include "../../drivers/staging/android/uapi/ion_rtk.h"
+#else
+#include <linux/ion.h>
+#include "../../drivers/gpu/ion/ion_priv.h"
+#endif
+
+#include "include/debug.h"
+#include "soc/realtek/memory.h"
+#include "../../../../mm/cma.h"
+
+struct ion_device *rtk_phoenix_ion_device;
+EXPORT_SYMBOL(rtk_phoenix_ion_device);
+
+static int num_heaps;
+static struct ion_heap **heaps;
+
+struct ion_heap_desc {
+	unsigned int id;
+	enum ion_heap_type type;
+	const char *name;
+	unsigned int permission_type;
+};
+
+enum ion_heap_ids {
+	INVALID_HEAP_ID = -1,
+	ION_HEAP_TYPE_SYSTEM_ID = 0,
+	ION_HEAP_TYPE_SYSTEM_CONTIG_ID = 1,
+	ION_HEAP_TYPE_CARVEOUT_ID = 2,
+	ION_HEAP_TYPE_CHUNK_ID = 3,
+	ION_HEAP_TYPE_DMA_ID = 4,
+	ION_HEAP_TYPE_CUSTOM_ID = 5,
+	RTK_PHOENIX_ION_HEAP_TYPE_TILER_ID = 6,
+	RTK_PHOENIX_ION_HEAP_TYPE_MEDIA_ID = 7,
+	RTK_PHOENIX_ION_HEAP_TYPE_AUDIO_ID = 8,
+	RTK_PHOENIX_ION_HEAP_TYPE_SECURE_ID = 9,
+	ION_CP_MM_HEAP_ID = 4,
+	ION_RPC_HEAP_ID	 = 15,
+	ION_AUDIO_HEAP_ID = 16,
+	ION_MM_HEAP_ID	 = 29,
+	ION_SYSTEM_HEAP_ID = 30,
+	/* bit reserved for secure flag */
+	ION_HEAP_ID_RESERVED = 31
+};
+
+#define ION_VMALLOC_HEAP_NAME "vmalloc"
+#define ION_RPC_HEAP_NAME "rpc"
+#define ION_AUDIO_HEAP_NAME "audio"
+#define ION_MM_HEAP_NAME "multimedia"
+
+static struct ion_heap_desc ion_heap_meta[] = {
+	{
+		.type = ION_HEAP_TYPE_SYSTEM,
+		.name = "System",
+		.id = ION_HEAP_TYPE_SYSTEM_ID,
+	},
+	{
+		.type = ION_HEAP_TYPE_SYSTEM_CONTIG,
+		.name = "SystemContig",
+		.id = ION_HEAP_TYPE_SYSTEM_CONTIG_ID,
+	},
+	{
+		.type = RTK_PHOENIX_ION_HEAP_TYPE_TILER,
+		.id = RTK_PHOENIX_ION_HEAP_TYPE_TILER_ID,
+		.name = "NativeWindow",
+	},
+	{
+		.type = RTK_PHOENIX_ION_HEAP_TYPE_MEDIA,
+		.id = RTK_PHOENIX_ION_HEAP_TYPE_MEDIA_ID,
+		.name = "Media",
+	},
+	{
+		.type = RTK_PHOENIX_ION_HEAP_TYPE_AUDIO,
+		.id = RTK_PHOENIX_ION_HEAP_TYPE_AUDIO_ID,
+		.name = "Audio",
+	},
+	{
+		.type = RTK_PHOENIX_ION_HEAP_TYPE_SECURE,
+		.id = RTK_PHOENIX_ION_HEAP_TYPE_SECURE_ID,
+		.name = "Secure",
+	},
+	{
+		.type = ION_HEAP_TYPE_DMA,
+		.id = ION_HEAP_TYPE_DMA_ID,
+		.name = "DMA",
+	},
+	/*
+		{
+			.id = ION_SYSTEM_HEAP_ID,
+			.type	= ION_HEAP_TYPE_SYSTEM,
+			.name = ION_VMALLOC_HEAP_NAME,
+		},
+	*/
+	{
+		.id = ION_RPC_HEAP_ID,
+		.type	= ION_HEAP_TYPE_DMA,
+		.name = ION_RPC_HEAP_NAME,
+	},
+	{
+		.id = ION_AUDIO_HEAP_ID,
+		.type	= ION_HEAP_TYPE_DMA,
+		.name = ION_AUDIO_HEAP_NAME,
+	},
+	{
+		.id = ION_MM_HEAP_ID,
+		.type	= ION_HEAP_TYPE_DMA,
+		.name = ION_MM_HEAP_NAME,
+	},
+};
+
+static int rtk_ion_populate_heap(struct ion_platform_heap *heap)
+{
+	unsigned int i;
+	int ret = -EINVAL;
+	unsigned int len = ARRAY_SIZE(ion_heap_meta);
+
+	for (i = 0 ; i < len ; i++) {
+		if (ion_heap_meta[i].id == heap->id) {
+			heap->name = ion_heap_meta[i].name;
+			heap->type = ion_heap_meta[i].type;
+			ret = 0;
+			break;
+		}
+	}
+	if (ret)
+		dbg_err("%s: unable to populate heap, error: %d", __func__, ret);
+
+	return ret;
+}
+
+static struct ion_platform_data *rtk_ion_parse_dt(const struct device_node *dt_node)
+{
+	struct ion_platform_data *pdata = 0;
+	struct ion_platform_heap *heap_data = 0;
+	struct device_node *node;
+	uint32_t val = 0;
+	int ret = 0;
+	uint32_t num_heaps = 0;
+
+	for_each_child_of_node(dt_node, node)
+	num_heaps++;
+	if (!num_heaps)
+		return ERR_PTR(-EINVAL);
+
+	pdata = kzalloc(sizeof(struct ion_platform_data), GFP_KERNEL);
+	if (!pdata)
+		return ERR_PTR(-ENOMEM);
+
+	pdata->nr = num_heaps;
+
+	pdata->heaps = kcalloc(num_heaps, sizeof(struct ion_platform_heap), GFP_KERNEL);
+	if (!pdata->heaps) {
+		ret = -ENOMEM;
+		goto free_pdata;
+	}
+
+	heap_data = pdata->heaps;
+	for_each_child_of_node(dt_node, node) {
+		ret = of_property_read_u32(node, "reg", &val);
+		if (ret) {
+			dbg_err("%s: unable to find reg key", __func__);
+			goto free_heaps;
+		}
+		heap_data->id = val;
+		ret = rtk_ion_populate_heap(heap_data);
+		if (ret)
+			goto free_heaps;
+
+#if 0
+		ret = of_property_read_u32(node, "rtk,memory-reserve-base", &val);
+		heap_data->base = (!ret) ? val : 0;
+
+		ret = of_property_read_u32(node, "rtk,memory-reservation-size", &val);
+		heap_data->size = (!ret) ? val : 0;
+#else
+		heap_data->base = 0;
+		heap_data->size = 0;
+		heap_data->priv = NULL;
+
+		{
+#define COLUMN 3
+			const u32 *prop;
+			int err,size,i;
+			struct list_head * pools = kzalloc(sizeof(struct list_head), GFP_KERNEL);
+			bool use_cma_pools = of_find_property(node, "rtk,use-cma-pools", NULL) ? true : false;
+			int cma_pool_flags = RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | RTK_FLAG_HWIPACC; /* defaule */
+			bool skip_dma_default_array = of_find_property(node, "rtk,cma-pools-skip-dma-default-array", NULL) ? true : false;
+
+			INIT_LIST_HEAD(pools);
+			prop = of_get_property(node, "rtk,memory-reserve", &size);
+			err = size % (sizeof(u32) * COLUMN);
+			if ((prop) && (!err)) {
+				int counter = size / (sizeof(u32) * COLUMN);
+				for (i=0; i<counter; i+=1) {
+					struct ion_rtk_priv_pool * pool = kzalloc(sizeof(struct ion_rtk_priv_pool), GFP_KERNEL);
+					pool->type  = RTK_CARVEOUT_GEN_POOL_TYPE;
+					pool->base  = (ion_phys_addr_t)((u32)of_read_number(prop, 1 + (i*COLUMN)));
+					pool->size  = (size_t)((u32)of_read_number(prop, 2 + (i*COLUMN)));
+					pool->flags = (unsigned long)((u32)of_read_number(prop, 3 + (i*COLUMN)));
+					list_add(&pool->list,pools);
+				}
+				heap_data->priv = (void *) pools;
+			}
+
+			if (use_cma_pools && of_find_property(node, "rtk,cma-pool-flags", NULL)) {
+				unsigned int flags;
+				if (of_property_read_u32(node, "rtk,cma-pool-flags", &flags) == 0 && flags != 0) {
+					cma_pool_flags = flags;
+				}
+			}
+
+			/*** legacy ***/
+			if (heap_data->id == RTK_PHOENIX_ION_HEAP_TYPE_MEDIA_ID && !of_find_property(node, "rtk,use-cma-pools", NULL)) {
+				use_cma_pools = true;
+				if (cma_area_count == 1) {
+					cma_pool_flags = RTK_FLAG_SCPUACC | RTK_FLAG_NONCACHED | RTK_FLAG_HWIPACC;
+				} else {
+					skip_dma_default_array = true;
+				}
+			}
+
+			if (use_cma_pools) {
+				for (i=0; i < cma_area_count; i+=1) {
+					struct ion_rtk_priv_pool * pool;
+					if (skip_dma_default_array && &cma_areas[i] == dma_contiguous_default_area) {
+						pr_debug("ion_of : Do not add dma_contiguous_default_area to the pool list. (cma_area_count=%d)\n",
+								cma_area_count);
+						continue;
+					}
+					pool = kzalloc(sizeof(struct ion_rtk_priv_pool), GFP_KERNEL);
+					pool->type  = RTK_CARVEOUT_CMA_POOL_TYPE;
+					pool->cma_pool = &cma_areas[i];
+					pool->base  = cma_get_base(pool->cma_pool);
+					pool->size  = cma_get_size(pool->cma_pool);
+					pool->flags = cma_pool_flags;
+					list_add(&pool->list,pools);
+				}
+			}
+			if( heap_data->priv == NULL ) {
+				heap_data->priv = (void *) pools;
+			}
+		}
+#endif
+		heap_data++;
+	}
+	return pdata;
+
+free_heaps:
+	kfree(pdata->heaps);
+free_pdata:
+	kfree(pdata);
+	return ERR_PTR(ret);
+}
+
+static int rtk_ion_probe(struct platform_device *pdev)
+{
+	struct ion_platform_data *pdata;
+	struct ion_platform_heap *heap_data;
+	unsigned int pdata_needs_freed;
+	int err = -1;
+	int i;
+
+	dbg_info("%s %s",__FILE__, __func__);
+	if (pdev->dev.of_node) {
+		pdata = rtk_ion_parse_dt(pdev->dev.of_node);
+		if (IS_ERR(pdata)) {
+			err = PTR_ERR(pdata);
+			goto out;
+		}
+		pdata_needs_freed = 1;
+	}
+	else {
+		pdata = pdev->dev.platform_data;
+		pdata_needs_freed = 0;
+	}
+
+	num_heaps = pdata->nr;
+
+	dbg_info("%s %s nr_heaps:%d",__FILE__, __func__, num_heaps);
+
+	//heaps = kcalloc(pdata->nr, sizeof(struct ion_heap*), GFP_KERNEL);
+	heaps = devm_kzalloc(&pdev->dev,
+						 sizeof(struct ion_heap *) * pdata->nr,
+						 GFP_KERNEL);
+	if (!heaps) {
+		err = -ENOMEM;
+		goto out;
+	}
+
+	rtk_phoenix_ion_device = ion_device_create(rtk_phoenix_ion_ioctl);
+	if (IS_ERR_OR_NULL(rtk_phoenix_ion_device)) {
+		err = PTR_ERR(rtk_phoenix_ion_device);
+		goto freeheaps;
+	}
+	/* create the heaps as specified in the board file */
+	heap_data = pdata->heaps;
+	for (i = 0; i < num_heaps; i++) {
+#if 1
+		if(heap_data->type == ION_HEAP_TYPE_DMA) {
+			if (heap_data->priv) {
+				struct list_head * pools = (struct list_head *) heap_data->priv;
+				struct ion_rtk_priv_pool * pool, * tmp_pool;
+				list_for_each_entry_safe(pool, tmp_pool,  pools, list) {
+					list_del(&pool->list);
+					kfree(pool);
+				}
+				kfree(pools);
+			}
+			heap_data->priv = NULL;
+		} else if (heap_data->type == ION_HEAP_TYPE_CARVEOUT)
+#else
+		if ((heap_data->type == ION_HEAP_TYPE_CARVEOUT) ||
+				(heap_data->type == ION_HEAP_TYPE_DMA) )
+#endif
+		{
+			if (heap_data->priv) {
+				struct list_head * pools = (struct list_head *) heap_data->priv;
+				struct ion_rtk_priv_pool * pool;
+				list_for_each_entry(pool, pools, list) {
+					if (pool->base == 0 && pool->type == RTK_CARVEOUT_GEN_POOL_TYPE) {
+						struct page *page = dma_alloc_from_contiguous(&(pdev->dev), pool->size >> PAGE_SHIFT, get_order(pool->size));
+						pool->base = page_to_phys(page);
+					}
+				}
+
+			}
+		}
+
+		heaps[i] = ion_heap_create(heap_data);
+
+		if (IS_ERR_OR_NULL(heaps[i])) {
+			heaps[i] = 0;
+			continue;
+		}
+
+		ion_device_add_heap(rtk_phoenix_ion_device, heaps[i]);
+
+		if (heap_data->priv) {
+			struct list_head * pools = (struct list_head *) heap_data->priv;
+			struct ion_rtk_priv_pool * pool, * tmp_pool;
+			list_for_each_entry_safe(pool, tmp_pool,  pools, list) {
+
+				dbg_info("%s: adding heap %s of type %d with %lx@%lx (type:%s)", __func__, heap_data->name,
+						 heap_data->type, pool->base, pool->size,
+						 (pool->type == RTK_CARVEOUT_GEN_POOL_TYPE)?"GEN_POOL":
+						 (pool->type == RTK_CARVEOUT_CMA_POOL_TYPE)?"CMA_POOL":"Unknown");
+
+				list_del(&pool->list);
+				kfree(pool);
+			}
+			kfree(pools);
+		}
+		heap_data++;
+	}
+
+	if (pdata_needs_freed) {
+		kfree(pdata->heaps);
+		kfree(pdata);
+	}
+
+	platform_set_drvdata(pdev, rtk_phoenix_ion_device);
+	return 0;
+
+freeheaps:
+	kfree(heaps);
+out:
+	return err;
+}
+
+static int rtk_ion_remove(struct platform_device *pdev)
+{
+	struct ion_device *rtk_phoenix_ion_device = platform_get_drvdata(pdev);
+	int i;
+
+	for (i = 0; i < num_heaps; i++)
+		ion_heap_destroy(heaps[i]);
+
+	ion_device_destroy(rtk_phoenix_ion_device);
+	kfree(heaps);
+	return 0;
+}
+
+static struct of_device_id rtk_ion_ids[] = {
+	{ .compatible = "Realtek,rtk-ion" },
+	{ /* Sentinel */ },
+};
+
+static struct platform_driver rtk_ion_driver = {
+	.probe = rtk_ion_probe,
+	.remove = rtk_ion_remove,
+	.driver = {
+		.name = "ion-rtk",
+		.of_match_table = rtk_ion_ids,
+	},
+};
+
+#if 1
+static int __init rtk_ion_init(void)
+{
+	return platform_driver_register(&rtk_ion_driver);
+}
+
+static void __exit rtk_ion_exit(void)
+{
+	platform_driver_unregister(&rtk_ion_driver);
+}
+
+fs_initcall(rtk_ion_init);
+module_exit(rtk_ion_exit);
+#else
+module_platform_driver(rtk_ion_driver);
+#endif
+
diff --git a/drivers/soc/realtek/common/rtk_mcp.c b/drivers/soc/realtek/common/rtk_mcp.c
new file mode 100644
index 00000000..5c04896
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_mcp.c
@@ -0,0 +1,1049 @@
+/*
+ * rtk_mcp.c - MCP driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/init.h>
+#include <linux/platform_device.h>
+#include <linux/fs.h>
+#include <linux/cdev.h>
+#include <linux/dma-mapping.h>
+#include <linux/device.h>
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/uaccess.h>
+#include <linux/compat.h>
+#include <linux/io.h>
+#include <asm/mutex.h>
+
+#include "rtk_mcp.h"
+
+#define MCP_DEVICE_NAME "mcp"
+
+static void __iomem *RTK_MCP_BASE;
+static void __iomem *RTK_TP_BASE;
+
+static struct platform_device* local_pdev;
+static struct device* mcp_device;
+static struct cdev mcp_dev;
+static dev_t devno;
+struct class * mcp_dev_class = NULL;
+
+static DEFINE_SPINLOCK(mcp_buffer_lock);
+static DEFINE_MUTEX(mcp_mutex);
+
+#define _mcp_map_single(p_data, len, dir) dma_map_single(mcp_device, (void*) p_data, (size_t) len, dir)
+#define _mcp_unmap_single(p_data, len, dir) dma_unmap_single(mcp_device, (dma_addr_t) p_data, (size_t) len, dir)
+//#define nop() __asm__ __volatile__("mov\tr0,r0\t@ nop\n\t");
+//#define nop() __asm__ __volatile__("nop");
+
+void mcp_dump_all_regieters(void);
+void mcp_dump_descriptor(mcp_desc *p_desc);
+void mcp_dump_mem(unsigned char* data, unsigned int len);
+void MCP_AES_128_ECB_DataEncryptTest(void);
+
+int mcp_do_command(
+	mcp_desc* p_desc,
+	int n_desc
+);
+
+int MCP_AES_Encryption(
+	unsigned char mode,
+	unsigned char key[16],
+	unsigned char iv[16],
+	unsigned char* p_in,
+	unsigned char* p_out,
+	unsigned long len
+);
+
+/*
+ * writeSRAM
+ * Parameter :
+ * id : offset in cw
+ * data : data array to be written
+ * cnt : entry count for data writing in SRAM
+ * Return :
+ * true : successful
+ * false : false
+ */
+unsigned char writeSRAM(unsigned int id, unsigned int data[8], unsigned int cnt)
+{
+	int i=0, y=0;
+
+#if 0
+	if ((id & 0x7f) > 0){
+		printf("*** %s %s %d\n", __FILE__, __FUNCTION__, __LINE__ );
+			return FALSE;
+	}
+	if (((id + cnt) & 0x7f) > 0){
+		printf("*** %s %s %d\n", __FILE__, __FUNCTION__, __LINE__ );
+			return FALSE;
+	}
+#endif
+
+	for (i = 0 ; i < cnt ; i++){
+		//dbg_info("%s %s %d==>data: %x",__FILE__, __func__,__LINE__,data[y]);
+		SET_TP_KEYINFO_0(data[y++], RTK_TP_BASE);
+		//dbg_info("%s %s %d==>data: %x",__FILE__, __func__,__LINE__,data[y]);
+		SET_TP_KEYINFO_1(data[y++], RTK_TP_BASE);
+		SET_TP_KEY_CTRL((id+i) | 0x80, RTK_TP_BASE);  // write 8 bytes
+		nop();nop();nop();nop();nop();nop();nop();nop();nop();nop();nop();nop();nop();nop();nop();nop();
+	}
+
+	SET_TP_KEYINFO_0(0x0, RTK_TP_BASE);
+	SET_TP_KEYINFO_1(0x0, RTK_TP_BASE);
+	return 0;
+}
+
+/* MISC */
+/*------------------------------------------------------------------ 
+ * Func : mcp_malloc
+ * Desc : allocate memory 
+ * Parm : size : size of data
+ * Retn : start address of data
+ *------------------------------------------------------------------*/
+void* mcp_malloc(unsigned long size)
+{
+#ifdef USE_DVR_MALLOC
+	if (system_state == SYSTEM_BOOTING)
+		return (void*) kmalloc(size, GFP_KERNEL);
+	else
+		return (size >= PAGE_SIZE) ? (void*) dvr_malloc(size) : (void*) kmalloc(size, GFP_KERNEL);
+#else
+	return (size >= PAGE_SIZE) ? (void*) __get_free_pages(GFP_KERNEL, get_order(size)) : (void*) kmalloc(size, GFP_KERNEL);
+#endif
+}
+
+/*------------------------------------------------------------------ 
+ * Func : mcp_free
+ * Desc : release memory 
+ * Parm : addr : Start address of data
+ *           size : size of data
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void mcp_free(void* addr, unsigned long size)
+{
+	if (system_state == SYSTEM_BOOTING) {
+		kfree(addr) ;
+		return;
+	}
+
+	if (size >= PAGE_SIZE)
+#ifdef USE_DVR_MALLOC
+		dvr_free(addr);
+#else
+		free_pages((unsigned long)addr, get_order(size));
+#endif
+	else
+		kfree(addr);
+}
+
+/***************************************************************************
+ File Operations
+****************************************************************************/
+
+/*------------------------------------------------------------------
+ * Func : mcp_dev_open
+ * Desc : open function of mcp dev
+ * Parm : inode : inode of dev
+ *        file  : context of file
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static int mcp_dev_open(struct inode *inode, struct file *file)
+{
+	//mcp_warning("mcp_dev_open\n");
+
+	file->private_data = mcp_malloc(sizeof(mcp_desc) * MCP_DESC_ENTRY_COUNT);
+	if (file->private_data == NULL){
+		mcp_warning("open mcp failed - allocate mcp descriptor buffer failed\n");
+		return -ENOMEM;
+	}
+
+	return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mcp_dev_release
+ * Desc : release function of mcp dev
+ * Parm : inode : inode of dev
+ *        file  : context of file
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static int mcp_dev_release(struct inode* inode, struct file* file)
+{
+	if (file->private_data)
+		mcp_free(file->private_data, sizeof(mcp_desc) * MCP_DESC_ENTRY_COUNT);
+	return 0;
+}
+
+#if 0 //Defined but not used
+typedef struct {
+	compat_uint_t flags;
+	compat_uint_t key[6];
+	compat_uint_t iv[4];
+	compat_uint_t data_in; // data in : physical address
+	compat_uint_t data_out; // data out : physical address
+	compat_uint_t length; // data length
+}compat_mcp_desc_t;
+
+static int compat_get_mcp_desc_data(compat_mcp_desc_t __user *data32, mcp_desc __user *data)
+{
+	//compat_uint_t s;
+	compat_uint_t c;
+	compat_uint_t b[6];
+	compat_uint_t k[4];
+	compat_uint_t t;
+	compat_uint_t p;
+	compat_uint_t q;
+	
+	int err;
+
+	err = get_user(c, &data32->flags);
+	err |= put_user(c, &data->flags);
+	err |= copy_from_user(b, data32->key, sizeof(b));
+	err |= copy_to_user(data->key, b, sizeof(b));
+	err |= copy_from_user(k, data32->iv, sizeof(k));
+	err |= copy_to_user(data->iv, k, sizeof(k));
+	err |= get_user(t, &data32->data_in);
+	err |= put_user(t, &data->data_in);
+	err |= get_user(p, &data32->data_out);
+	err |= put_user(p, &data->data_out);
+	err |= get_user(q, &data32->length);
+	err |= put_user(q, &data->length);
+
+	return err;
+}
+
+static int compat_put_mcp_desc_data(compat_mcp_desc_t __user *data32, mcp_desc __user *data)
+{
+	//compat_uint_t s;
+	compat_uint_t c;
+	compat_uint_t b[6];
+	compat_uint_t k[4];
+	compat_uint_t t;
+	compat_uint_t p;
+	compat_uint_t q;
+	
+	int err;
+
+	err = get_user(c, &data->flags);
+	err |= put_user(c, &data32->flags);
+	err |= copy_from_user(b, data->key, sizeof(b));
+	err |= copy_to_user(data32->key, b, sizeof(b));
+	err |= copy_from_user(k, data->iv, sizeof(k));
+	err |= copy_to_user(data32->iv, k, sizeof(k));
+	err |= get_user(t, &data->data_in);
+	err |= put_user(t, &data32->data_in);
+	err |= get_user(p, &data->data_out);
+	err |= put_user(p, &data32->data_out);
+	err |= get_user(q, &data->length);
+	err |= put_user(q, &data32->length);
+
+	return err;
+}
+#endif
+
+/*------------------------------------------------------------------
+ * Func : mcp_dev_ioctl
+ * Desc : ioctl function of mcp dev
+ * Parm : inode : inode of dev
+ * file : context o	le
+ * cmd : control command
+ * arg : arguments
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static long compat_mcp_dev_ioctl(struct file* file, unsigned int cmd, unsigned long arg)
+{
+	mcp_desc_set desc_set;
+	//mcp_desc* desc_list = (mcp_desc*) KSEG1ADDR(file->private_data);
+	mcp_desc*	desc_list = (mcp_desc*)(file->private_data);
+	mcp_desc*	p_desc;
+	int	 n_desc;
+
+#if !defined(CONFIG_CPU_V7)
+	void __user *arg64;
+#endif /* CONFIG_CPU_V7 */
+
+	int key_cnt = 0;
+
+	//mcp_info("[MCP] =====>compat_mcp_dev_ioctl:\n");
+
+	switch (cmd){
+	case MCP_IOCTL_DO_COMMAND:
+
+#if !defined(CONFIG_CPU_V7)
+		arg64 = compat_ptr(arg);
+
+		if(copy_from_user(&desc_set, (void *)arg64, sizeof(mcp_desc_set))){
+			mcp_warning("do ioctl command failed - copy desc_set from user failed 1\n");
+			return -EFAULT;
+		}
+		p_desc = compat_ptr(desc_set.p_desc);
+#else
+		if(copy_from_user(&desc_set, (void *)arg, sizeof(mcp_desc_set))){
+			mcp_warning("do ioctl command failed - copy desc_set from user failed 1\n");
+			return -EFAULT;
+		}
+		p_desc = desc_set.p_desc;
+#endif /* CONFIG_CPU_V7 */
+
+		while(desc_set.n_desc){
+			n_desc = (desc_set.n_desc >= MCP_DESC_ENTRY_COUNT) ? MCP_DESC_ENTRY_COUNT : desc_set.n_desc;
+
+			if(copy_from_user(desc_list, (void *)p_desc, sizeof(mcp_desc) * n_desc)){
+				mcp_warning("do ioctl command failed - copy desc from user failed 2\n");
+				return -EFAULT;
+			}
+
+			if(desc_list->flags & ((0x1) << 13)){
+				mcp_info("%s %s %d==>flags s:%x\n", __FILE__, __func__, __LINE__, desc_list->flags);
+
+				if(desc_list->flags & ((0x1) << 3)){
+					mcp_info("%s %s %d==>AES 192 mode key in CW\n", __FILE__, __func__, __LINE__);
+					key_cnt=3;
+				}else{
+					mcp_info("%s %s %d==>AES 256 mode key in CW\n", __FILE__, __func__, __LINE__);
+					key_cnt=4;
+				}
+
+				// write key from cw offset 0x00
+				if(writeSRAM(0, desc_list->key, key_cnt) == -1){
+					mcp_warning("%s %s %d==>writeSRAM fail\n",__FILE__, __func__,__LINE__);
+					return  -EFAULT;
+				}
+				desc_list->key[0]=0x0;
+			}
+
+			if(mcp_do_command(desc_list, n_desc) < 0){
+				mcp_warning("do command failed\n");
+				return -EFAULT;
+			}
+
+			p_desc += n_desc;
+			desc_set.n_desc -= n_desc;
+		}
+		break;
+
+	/* for testing only */
+	case MCP_IOCTL_TEST_AES_H:
+		//MCP_AES_H_DataHashTest();
+		break;
+
+	default:
+		mcp_warning("do ioctl command failed - unknown ioctl command(%d)\n", cmd);
+		return -EFAULT;
+	}
+
+	return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mcp_dev_ioctl
+ * Desc : ioctl function of mcp dev
+ * Parm : inode : inode of dev
+ * file : context of file
+ * cmd : control command
+ * arg : arguments
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+static long mcp_dev_ioctl(struct file* file, unsigned int cmd, unsigned long arg)
+{
+	mcp_desc_set desc_set;
+	//mcp_desc* desc_list = (mcp_desc*) KSEG1ADDR(file->private_data);
+	mcp_desc*	desc_list = (mcp_desc*)(file->private_data);
+	mcp_desc*	p_desc;
+	int	 n_desc;
+
+	int key_cnt = 0;
+
+	//mcp_info("[MCP] =====>mcp_dev_ioctl:\n");
+
+	switch (cmd){
+	case MCP_IOCTL_DO_COMMAND:
+		if(copy_from_user(&desc_set, (mcp_desc_set __user *)arg, sizeof(mcp_desc_set))){
+			mcp_warning("do ioctl command failed - copy desc_set from user failed 1\n");
+			return -EFAULT;
+		}
+		p_desc = desc_set.p_desc;
+
+		while(desc_set.n_desc){
+			n_desc = (desc_set.n_desc >= MCP_DESC_ENTRY_COUNT) ? MCP_DESC_ENTRY_COUNT : desc_set.n_desc;
+
+			if (copy_from_user(desc_list, (mcp_desc __user *)p_desc, sizeof(mcp_desc) * n_desc)){
+				mcp_warning("do ioctl command failed - copy desc from user failed 2\n");
+				return -EFAULT;
+			}
+
+			if(desc_list->flags & ((0x1) << 13)){
+				mcp_info("%s %s %d==>flags s:%x\n", __FILE__, __func__, __LINE__, desc_list->flags);
+
+				if(desc_list->flags & ((0x1) << 3)){
+					mcp_info("%s %s %d==>AES 192 mode key in CW\n", __FILE__, __func__, __LINE__);
+					key_cnt=3;
+				} else {
+					mcp_info("%s %s %d==>AES 256 mode key in CW\n", __FILE__, __func__, __LINE__);
+					key_cnt=4;
+				}
+
+				// write key from cw offset 0x00
+				if (writeSRAM(0, desc_list->key, key_cnt) == -1){
+					mcp_warning("%s %s %d==>writeSRAM fail\n",__FILE__, __func__,__LINE__);
+					return  -EFAULT;
+				}
+				desc_list->key[0]=0x0;
+			}
+
+			if (mcp_do_command(desc_list, n_desc) < 0){
+				mcp_warning("do command failed\n");
+				return -EFAULT;
+			}
+			p_desc += n_desc;
+			desc_set.n_desc -= n_desc;
+		}
+		break;
+
+	/* for testing only */
+	case MCP_IOCTL_TEST_AES_H:
+		//MCP_AES_H_DataHashTest();
+		break;
+
+	default:
+		mcp_warning("do ioctl command failed - unknown ioctl command(%d)\n", cmd);
+		return -EFAULT;
+	}
+
+	return 0;
+}
+
+static struct file_operations mcp_ops =
+{
+	.owner = THIS_MODULE,
+	//.ioctl = mcp_dev_ioctl,
+	.unlocked_ioctl = mcp_dev_ioctl,
+	.compat_ioctl = compat_mcp_dev_ioctl,
+	.open = mcp_dev_open,
+	.release = mcp_dev_release,
+};
+
+/*------------------------------------------------------------------
+ * Func : _mcp_load_otp
+ * Desc : load otp key
+ * Parm : N/A
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+static void _mcp_load_otp(void)
+{
+	int i = 0;
+
+	SET_MCP_OTP_LOAD(1, RTK_MCP_BASE);
+
+	while(GET_MCP_OTP_LOAD(RTK_MCP_BASE)){
+		if(i++ > 100){
+			mcp_warning("Load OTP Key Timeout\n");
+		}
+
+		udelay(10);
+	}
+}
+
+/*------------------------------------------------------------------
+ * Func : _mcp_phy_init
+ * Desc : init mcp engine
+ * Parm : N/A
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+static int _mcp_phy_init(void)
+{
+#ifdef CONFIG_ARCH_RTD139x
+	unsigned int cur_value;
+#endif
+
+
+	//_mcp_load_otp();
+	SET_MCP_CTRL(MCP_GO, RTK_MCP_BASE); // dessert go bit
+	SET_MCP_EN(0xFE, RTK_MCP_BASE); // disable all interrupts
+	SET_MCP_STATUS(0xFE, RTK_MCP_BASE); // clear interrupts status
+	SET_MCP_BASE (0, RTK_MCP_BASE);
+	SET_MCP_LIMIT(0, RTK_MCP_BASE);
+	SET_MCP_RDPTR(0, RTK_MCP_BASE);
+	SET_MCP_WRPTR(0, RTK_MCP_BASE);
+
+#ifdef CONFIG_ARCH_RTD139x
+	/* auto power management */
+	cur_value = GET_PWM_CTRL(RTK_MCP_BASE);
+	cur_value |= (1 << 22) | (1 << 23) | (1 << 24) | (1 << 25) | (1 << 27) | (1 << 28);
+	SET_PWM_CTRL(cur_value, RTK_MCP_BASE);
+#endif
+
+	return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mcp_init
+ * Desc : init mcp engine
+ * Parm : N/A
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+static int mcp_init(void)
+{
+	if (_mcp_phy_init()<0)
+		return -1;
+
+#if 0//def MCP_INTERRUPT_ENABLE
+	if (request_irq(MCP_IRQ, mcp_isr, SA_INTERRUPT | SA_SHIRQ, "MCP", &mcp_wait_queue) < 0){
+		mcp_warning("Request irq %d failed\n", MCP_IRQ);
+		return -ENODEV;
+	}
+#endif
+
+	return 0;
+}
+
+/*------------------------------------------------------------------
+ * Func : mcp_uninit
+ * Desc : uninit mcp engine
+ * Parm : N/A
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+static void mcp_uninit(void)
+{
+	SET_MCP_CTRL(MCP_GO, RTK_MCP_BASE); // dessert go bit
+	SET_MCP_EN(0xFE, RTK_MCP_BASE); // disable all interrupts
+	msleep(10); // wait for hw stop
+	SET_MCP_BASE (0, RTK_MCP_BASE);
+	SET_MCP_LIMIT(0, RTK_MCP_BASE);
+	SET_MCP_RDPTR(0, RTK_MCP_BASE);
+	SET_MCP_WRPTR(0, RTK_MCP_BASE);
+#if 0 //def MCP_INTERRUPT_ENABLE
+	free_irq(MCP_IRQ, &mcp_wait_queue);
+#endif
+}
+
+/*---------------------------------------------------------------------- 
+ * Func : mcp_dump_mem 
+ * Desc : dump data in memory
+ * Parm : data : start address of data
+ * len : length of data
+ * Retn : N/A
+ *----------------------------------------------------------------------*/ 
+void mcp_dump_mem(unsigned char* data, unsigned int len)
+{
+	int i;
+	for (i = 0 ; i < len ; i++){
+		if ((i & 0xF)==0)
+			printk("\n %04x | ", i);
+		printk("%02x ", data[i]);
+	}
+	printk("\n");
+}
+
+/*---------------------------------------------------------------------- 
+ * Func : mcp_dump_all_registers 
+ * Desc : dump mcp registers
+ * Parm : N/A
+ * Retn : N/A
+ *----------------------------------------------------------------------*/ 
+void mcp_dump_all_registers(void)
+{
+	mcp_info("****** MCP Registers ******\n");
+	mcp_info("MCP_CTRL addr:0x%x, value:0x%x\n", MCP_CTRL, GET_MCP_CTRL(RTK_MCP_BASE));
+	mcp_info("MCP_STATUS addr:0x%x, value:0x%x\n", MCP_STATUS, GET_MCP_STATUS(RTK_MCP_BASE));
+	mcp_info("MCP_EN addr:0x%x, value:0x%x\n", MCP_EN, GET_MCP_EN(RTK_MCP_BASE));
+	mcp_info("MCP_BASE addr:0x%p, value:0x%x\n", RTK_MCP_BASE, GET_MCP_BASE(RTK_MCP_BASE));
+	mcp_info("MCP_LIMIT addr:0x%x, value:0x%x\n", MCP_LIMIT, GET_MCP_LIMIT(RTK_MCP_BASE));
+	mcp_info("MCP_RDPTR addr:0x%x, value:0x%x\n", MCP_RDPTR, GET_MCP_RDPTR(RTK_MCP_BASE));
+	mcp_info("MCP_WRPTR addr:0x%x, value:0x%x\n", MCP_WRPTR, GET_MCP_WRPTR(RTK_MCP_BASE));
+	mcp_info("MCP_DES_COUNT addr:0x%x, value:0x%x\n", MCP_DES_COUNT, GET_MCP_DES_COUNT(RTK_MCP_BASE));
+	mcp_info("MCP_DES_COMPARE addr:0x%x, value:0x%x\n", MCP_DES_COMPARE, GET_MCP_DES_COMPARE(RTK_MCP_BASE));
+}
+
+/*---------------------------------------------------------------------- 
+ * Func : mcp_dump_descriptor 
+ * Desc : dump mcp descriptor
+ * Parm : p_desc: pointer  to descriptor
+ * Retn : N/A
+ *----------------------------------------------------------------------*/ 
+void mcp_dump_descriptor(mcp_desc *p_desc)
+{
+	int i = 0;
+
+	mcp_info("****** MCP Descriptor ******\n");
+	mcp_info("p_desc->flags:0x%0x\n", p_desc->flags);
+
+	for(i = 0 ; i < sizeof(p_desc->key)/sizeof(p_desc->key[0]) ; i++){
+		mcp_info("p_desc->key[%d]:0x%0x\n", i, p_desc->key[i]);
+	}
+
+	for(i = 0 ; i < sizeof(p_desc->iv)/sizeof(p_desc->iv[0]) ; i++){
+		mcp_info("p_desc->iv[%d]:0x%0x\n", i, p_desc->iv[i]);
+	}
+
+	mcp_info("p_desc->data_in:0x%0x\n", p_desc->data_in);
+	mcp_info("p_desc->data_out:0x%0x\n", p_desc->data_out);
+	mcp_info("p_desc->length:0x%0x\n", p_desc->length);
+}
+
+/*------------------------------------------------------------------ 
+ * Func : _mcp_set_desc_buffer
+ * Desc : set descriptors buffer
+ * Parm : base  : base address of descriptor buffer
+ * limit : limit address of descriptor buffer
+ * rp : read pointer of descriptor buffer
+ * wp : write pointer of descriptor buffer
+ * Retn : 0
+ *------------------------------------------------------------------*/
+int _mcp_set_desc_buffer(unsigned long	 base, unsigned long limit, unsigned long rp, unsigned long wp)
+{
+	unsigned long event;
+
+	spin_lock_irqsave(&mcp_buffer_lock, event);
+	SET_MCP_BASE (base, RTK_MCP_BASE);
+	SET_MCP_LIMIT(limit, RTK_MCP_BASE);
+	SET_MCP_RDPTR(rp, RTK_MCP_BASE);
+	SET_MCP_WRPTR(wp, RTK_MCP_BASE);
+	spin_unlock_irqrestore(&mcp_buffer_lock, event);
+
+	return 0;
+}
+
+/*------------------------------------------------------------------ 
+ * Func : _mcp_start_xfer
+ * Desc : Start Xfer
+ * Parm : N/A
+ * Retn : S_OK /  S_FALSE 
+ *------------------------------------------------------------------*/
+int _mcp_start_xfer(void)
+{
+	int ret = -1;
+	int WaitTime = 0x3FF << 2;
+	int wiat_clear_timeout = 0;
+
+	SET_MCP_DES_COUNT(0x0, RTK_MCP_BASE);   // descriptor in ddr
+	SET_MCP_CTRL(MCP_CLEAR | MCP_WRITE_DATA, RTK_MCP_BASE);	// issue clear
+
+	while ((GET_MCP_CTRL(RTK_MCP_BASE) & MCP_CLEAR) && wiat_clear_timeout++ < 30);
+
+	if (GET_MCP_CTRL(RTK_MCP_BASE) & MCP_CLEAR){
+		mcp_warning("wait clear bit deassert timeout,  force unset clear bit, (CTRL=%08x, STATUS=%08x)\n", GET_MCP_CTRL(RTK_MCP_BASE), GET_MCP_STATUS(RTK_MCP_BASE));
+		SET_MCP_CTRL(MCP_CLEAR, RTK_MCP_BASE);	// issue clear
+		mcp_warning("CTRL=%08x, STATUS=%08x)\n",GET_MCP_CTRL(RTK_MCP_BASE), GET_MCP_STATUS(RTK_MCP_BASE));
+	}
+
+	SET_MCP_EN(0xFE, RTK_MCP_BASE);
+	SET_MCP_STATUS(0xFE, RTK_MCP_BASE);	// clear status
+
+	//mcp_info("before go:\n");
+	//mcp_dump_all_registers();
+
+	SET_MCP_CTRL(MCP_GO | MCP_WRITE_DATA, RTK_MCP_BASE);
+
+	while (WaitTime--){
+		mcp_debug("STATUS=%08x, CTRL=%08x\n",GET_MCP_STATUS(RTK_MCP_BASE), GET_MCP_CTRL(RTK_MCP_BASE));
+		if (!(GET_MCP_CTRL(RTK_MCP_BASE) & MCP_GO)) {
+			//mcp_info("ctrl break\n");
+			break;
+		}
+
+		if (GET_MCP_STATUS(RTK_MCP_BASE)&0x6) {
+			//mcp_info("status break\n");
+			break;
+		}
+
+		msleep(1);
+	}
+#ifdef CONFIG_ARCH_RTD16xx
+	ret = ((GET_MCP_STATUS(RTK_MCP_BASE) & ~(MCP_RING_EMPTY | MCP_COMPARE|MCP_KL_DONE|MCP_K_KL_DONE))) ? -1 : 0;
+#else
+	ret = ((GET_MCP_STATUS(RTK_MCP_BASE) & ~(MCP_RING_EMPTY | MCP_COMPARE))) ? -1 : 0;
+#endif
+	//mcp_info("after go:\n");
+	//mcp_dump_all_registers();
+
+	if (ret <0)
+		mcp_warning("do mcp command failed, (MCP_Status %08x)\n", GET_MCP_STATUS(RTK_MCP_BASE));
+
+	SET_MCP_CTRL(MCP_GO, RTK_MCP_BASE); // clear go bit
+	SET_MCP_STATUS(0xFE, RTK_MCP_BASE); // clear ring empty
+
+	return ret;
+}
+
+/*------------------------------------------------------------------ 
+ * Func : mcp_do_command 
+ * Desc : Do Command
+ * Parm : p_desc : number of Descriptor to be Execute
+ * n_desc : number of Descriptor to be Execute
+ * Retn : 0 : success, others fail  
+ *------------------------------------------------------------------*/
+int mcp_do_command(mcp_desc* p_desc, int n_desc)
+{
+	int	 ret = 0;
+	int	 len = sizeof(mcp_desc) * n_desc;
+
+	int	 i, j;
+	unsigned long desc_dma_vaddr;
+	dma_addr_t desc_dma;
+	mcp_desc *p_desc_vaddr;
+
+	if(n_desc){
+		mutex_lock(&mcp_mutex);
+
+		desc_dma_vaddr = (unsigned long)dma_alloc_coherent(&local_pdev->dev, n_desc * sizeof(mcp_desc) + sizeof(mcp_desc), &desc_dma, GFP_ATOMIC|GFP_DMA);
+
+		if (desc_dma_vaddr){
+
+			p_desc_vaddr = (mcp_desc *)desc_dma_vaddr;
+
+			for (i = 0; i < n_desc ; i++){
+				p_desc_vaddr->flags = p_desc->flags;
+
+				for (j = 0 ; j < sizeof(p_desc->key) / sizeof(p_desc->key[0]) ; j++) {
+					p_desc_vaddr->key[j] = p_desc->key[j];
+				}
+
+				for (j = 0 ; j < sizeof(p_desc->iv) / sizeof(p_desc->iv[0]) ; j++) {
+					p_desc_vaddr->iv[j] = p_desc->iv[j];
+				}
+
+				p_desc_vaddr->data_in = p_desc->data_in;
+				p_desc_vaddr->data_out = p_desc->data_out;
+				p_desc_vaddr->length = p_desc->length;
+#ifdef MCP_DEBUG_EN
+				mcp_dump_descriptor(p_desc_vaddr);
+#else
+				mcp_info("Do command, flags:0x%0x\n", p_desc->flags);
+#endif
+				p_desc_vaddr++;
+				p_desc++;
+			}
+
+			p_desc_vaddr = p_desc_vaddr - n_desc;
+			p_desc = p_desc - n_desc;
+
+			_mcp_set_desc_buffer(desc_dma, desc_dma + len + sizeof(mcp_desc), desc_dma, desc_dma + len);
+
+			ret = _mcp_start_xfer();
+		}else{
+			mcp_warning("no dma buffer for descriptor!\n");
+			ret = -1;   // error, no dma buffer for descriptor
+		}
+
+		dma_free_coherent(&local_pdev->dev, n_desc * sizeof(mcp_desc), (void *)desc_dma_vaddr, desc_dma);
+
+		mutex_unlock(&mcp_mutex);
+	}
+
+	return ret;
+}
+
+/********************************************************************************
+ AES
+ ********************************************************************************/
+/*------------------------------------------------------------------
+ * Func : MCP_AES_DESC_INIT
+ * Desc : Init AES Descriptor
+ * Parm : pDesc : Descriptor to be Load
+ * EnDe : Encryption/Descryption
+ * 0 for Decryption / 1 for Encryption
+ * Mode : Operation Mode
+ * Key : Key Value
+ * IV : Initial Vector
+ * Retn : S_OK /  S_FALSE 
+ *------------------------------------------------------------------*/
+int MCP_AES_DESC_INIT(mcp_desc*	 pDesc, unsigned char EnDe, unsigned char Mode, unsigned char Key[16], unsigned char IV[16])
+{
+	memset(pDesc, 0, sizeof(mcp_desc));
+
+	switch (Mode){
+	case MCP_BCM_ECB:
+	case MCP_BCM_CBC:
+	case MCP_BCM_CTR:
+		pDesc->flags = MARS_MCP_MODE(MCP_ALGO_AES) | MARS_MCP_BCM(Mode) | MARS_MCP_ENC(EnDe);
+
+		if(Key){
+			pDesc->key[0]  = (Key[ 0]<<24) + (Key[ 1]<<16) + (Key[ 2]<<8) + Key[ 3];
+			pDesc->key[1]  = (Key[ 4]<<24) + (Key[ 5]<<16) + (Key[ 6]<<8) + Key[ 7];
+			pDesc->key[2]  = (Key[ 8]<<24) + (Key[ 9]<<16) + (Key[10]<<8) + Key[11];
+			pDesc->key[3]  = (Key[12]<<24) + (Key[13]<<16) + (Key[14]<<8) + Key[15];
+		}else
+			pDesc->flags |= MARS_MCP_KEY_SEL(MCP_KEY_SEL_OTP);
+
+		if(IV){
+			pDesc->iv[0]   = (IV[ 0]<<24) + (IV[ 1]<<16) + (IV[ 2]<<8) + IV[ 3];
+			pDesc->iv[1]   = (IV[ 4]<<24) + (IV[ 5]<<16) + (IV[ 6]<<8) + IV[ 7];
+			pDesc->iv[2]   = (IV[ 8]<<24) + (IV[ 9]<<16) + (IV[10]<<8) + IV[11];
+			pDesc->iv[3]   = (IV[12]<<24) + (IV[13]<<16) + (IV[14]<<8) + IV[15];
+		}
+		return 0;
+	default:
+		mcp_warning("Init AES descriptor failed - invalid mode (%d)\n", Mode);
+		return -1;
+	}
+}
+
+/*------------------------------------------------------------------
+ * Func : MCP_AES_Decryption
+ * Desc : Do AES Decryption
+ * Parm : mode : Operation Mode
+ * key : Key Value
+ * iv : Initial Vector
+ * p_in : Data In
+ * p_out : Data Out
+ * len : Data Length
+ * Retn : 0 for success, others failed
+ *------------------------------------------------------------------*/
+int MCP_AES_Decryption(unsigned char Mode, unsigned char Key[16], unsigned char IV[16], unsigned char* p_in, unsigned char* p_out, unsigned long len)
+{
+	mcp_desc desc;
+	int	 ret;
+	//dma_addr_t  addr1;
+	//dma_addr_t  addr2;
+
+	MCP_AES_DESC_INIT(&desc, 0, Mode, Key, IV);
+
+	//addr1 = _mcp_map_single(p_in, len, DMA_TO_DEVICE);
+	//addr2 = _mcp_map_single(p_out, len, DMA_FROM_DEVICE);
+
+	desc.data_in = p_in;
+	desc.data_out = p_out;
+	desc.length = len & ~0xF;
+
+	ret = mcp_do_command(&desc, 1);
+
+	//_mcp_unmap_single(addr1, len, DMA_TO_DEVICE);
+	//_mcp_unmap_single(addr2, len, DMA_FROM_DEVICE);
+
+	return ret;
+}
+
+/*------------------------------------------------------------------
+ * Func : MCP_AES_Encryption
+ * Desc : Do AES Encryption
+ * Parm : mode : Operation Mode
+ * key : Key Value
+ * iv : Initial Vector
+ * p_in : Data In
+ * p_out : Data Out
+ * len : Data Length
+ * Retn : 0 for success, others failed
+ *------------------------------------------------------------------*/
+int MCP_AES_Encryption(unsigned char mode, unsigned char key[16], unsigned char iv[16], unsigned char* p_in, unsigned char* p_out, unsigned long len)
+{
+	mcp_desc desc;
+	int ret;
+	//dma_addr_t  addr1;
+	//dma_addr_t  addr2;
+
+	MCP_AES_DESC_INIT(&desc, 1, mode, key, iv);
+
+	//addr1 = _mcp_map_single(p_in, len, DMA_TO_DEVICE);
+	//addr2 = _mcp_map_single(p_out, len, DMA_FROM_DEVICE);
+
+	desc.data_in = p_in;
+	desc.data_out = p_out;
+	desc.length = len & ~0xF;
+
+	ret = mcp_do_command(&desc, 1);
+
+	//_mcp_unmap_single(addr1, len, DMA_TO_DEVICE);
+	//_mcp_unmap_single(addr2, len, DMA_FROM_DEVICE);
+
+	return ret;
+}
+
+void MCP_SHA256_DESC_INIT(mcp_desc *pDesc, unsigned int iv[8])
+{
+	memset(pDesc, 0, sizeof(mcp_desc));
+
+	pDesc->flags = MARS_MCP_MODE(MCP_ALGO_SHA256);
+
+	if (iv == NULL) {
+		pDesc->key[0] = SHA256_H0;
+		pDesc->key[1] = SHA256_H1;
+		pDesc->key[2] = SHA256_H2;
+		pDesc->key[3] = SHA256_H3;
+		pDesc->key[4] = SHA256_H4;
+		pDesc->key[5] = SHA256_H5;
+		pDesc->iv[0] = SHA256_H6;
+		pDesc->iv[1] = SHA256_H7;
+	}
+	else {
+		pDesc->key[0] = iv[0];
+		pDesc->key[1] = iv[1];
+		pDesc->key[2] = iv[2];
+		pDesc->key[3] = iv[3];
+		pDesc->key[4] = iv[4];
+		pDesc->key[5] = iv[5];
+		pDesc->iv[0] = iv[6];
+		pDesc->iv[1] = iv[7];
+	}
+}
+
+int MCP_SHA256(unsigned char *p_in, unsigned char *p_out, unsigned long len, unsigned int iv[8])
+{
+	mcp_desc    desc;
+	int         ret;
+
+	MCP_SHA256_DESC_INIT(&desc, iv);
+
+	desc.data_in  = p_in;
+	desc.data_out = p_out;
+	desc.length   = len;
+
+	ret = mcp_do_command(&desc, 1);
+
+	return ret;
+}
+
+EXPORT_SYMBOL(MCP_SHA256);
+
+/*------------------------------------------------------------------ 
+ * Func : MCP_AES_128_ECB_DataEncryptTest
+ * Desc : Test AES 128 ECB
+ * Parm : N/A
+ * Retn : N/A
+ *------------------------------------------------------------------*/
+void MCP_AES_128_ECB_DataEncryptTest(void)
+{
+	unsigned char Data[16]={0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88,
+										 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff, 0x00};
+	unsigned char Key[16];
+
+	unsigned long data_dma_vaddr;
+	dma_addr_t data_dma_phyaddr;
+	unsigned char *pData = NULL;
+	int i = 0;
+
+	data_dma_vaddr = (unsigned long)dma_alloc_coherent(&local_pdev->dev, sizeof(Data), &data_dma_phyaddr, GFP_ATOMIC|GFP_DMA);
+
+	if (data_dma_vaddr) {
+		memset(Key, 'b', sizeof(Key));
+
+		pData = (unsigned char *)data_dma_vaddr;
+
+		for (i = 0; i < sizeof(Data); i++) {
+			pData[i] = Data[i];
+		}
+
+		MCP_AES_ECB_Encryption(Key, (unsigned char *)data_dma_phyaddr, (unsigned char *)data_dma_phyaddr, 16);
+
+		mcp_dump_data_with_text(pData, 16, "encrypted value : ");
+
+		MCP_AES_ECB_Decryption(Key, (unsigned char *)data_dma_phyaddr, (unsigned char *)data_dma_phyaddr, 16);
+
+		mcp_dump_data_with_text(pData, 16, "decrypted value : ");
+	}else{
+		mcp_warning("test dma alloc fail");
+	}
+
+	dma_free_coherent(&local_pdev->dev, sizeof(Data), (void *)data_dma_vaddr, data_dma_phyaddr);
+}
+
+static int mcp_probe(struct platform_device *pdev)
+{
+	local_pdev = pdev;
+
+	printk(KERN_INFO "[RTK MCP] MCP driver initial begin.\n");
+
+	RTK_MCP_BASE = of_iomap(pdev->dev.of_node, 0);
+	if (!MCP_BASE) {
+		dev_err(&pdev->dev, "no mcp address\n");
+		return -EINVAL;
+	}
+
+	RTK_TP_BASE = of_iomap(pdev->dev.of_node, 1);
+	if (!RTK_TP_BASE) {
+		dev_err(&pdev->dev, "no tp address\n");
+		return -EINVAL;
+	}
+
+	printk(KERN_INFO "[RTK MCP] MCP Base: 0x%p\n", RTK_MCP_BASE);
+	printk(KERN_INFO "[RTK MCP] TP Base: 0x%p\n", RTK_TP_BASE);
+
+	 if (mcp_init()<0)
+		 return -ENODEV;
+
+	 cdev_init(&mcp_dev, &mcp_ops);
+
+	if (alloc_chrdev_region(&devno, 0, 1, MCP_DEVICE_NAME) != 0){
+		cdev_del(&mcp_dev);
+		printk("%s %s %d",__FILE__, __func__,__LINE__);
+		return -EFAULT;
+	}
+
+	if (cdev_add(&mcp_dev, devno, 1) < 0)
+		return -EFAULT;
+
+	mcp_dev_class = class_create(THIS_MODULE, MCP_DEVICE_NAME); // create a new class for mcp
+
+	mcp_device = device_create(mcp_dev_class, NULL, devno, NULL, "mcp_core");
+
+	printk(KERN_INFO "[RTK MCP] MCP driver initial done.\n");
+
+	return 0;
+}
+
+static int mcp_remove(struct platform_device *dev)
+{
+	printk(KERN_INFO "[RTK MCP] MCP driver remove begin.\n");
+
+	device_destroy(mcp_dev_class, mcp_device->devt);
+
+	cdev_del(&mcp_dev);
+
+	unregister_chrdev_region(devno, 1);
+
+	mcp_uninit();
+
+	printk(KERN_INFO "[RTK MCP] MCP driver remove done.\n");
+
+	return 0;
+}
+
+static int mcp_suspend(struct platform_device *dev, pm_message_t state)
+{
+	printk(KERN_INFO "[RTK MCP] Suspend Enter\n");
+	printk(KERN_INFO "[RTK MCP] Suspend Exit\n");
+	return 0;
+}
+
+static int mcp_resume(struct platform_device *dev)
+{
+	printk(KERN_INFO "[RTK MCP] Resume Enter\n");
+	printk(KERN_INFO "[RTK MCP] Resume Exit\n");
+	return 0;
+}
+
+static struct of_device_id rtk_mcp_ids[] = {
+	{ .compatible = "Realtek,rtk-mcp" },
+	{ /* Sentinel */ },
+};
+
+static struct platform_driver rtk_mcp_driver = {
+	.probe = mcp_probe,
+	.remove = mcp_remove,
+	.suspend = mcp_suspend,
+	.resume = mcp_resume,
+	.driver = {
+		.name = "RTK_MCP",
+		.owner = THIS_MODULE,
+		.of_match_table = of_match_ptr(rtk_mcp_ids),
+	},
+};
+
+module_platform_driver(rtk_mcp_driver);
diff --git a/drivers/soc/realtek/common/rtk_mcp.h b/drivers/soc/realtek/common/rtk_mcp.h
new file mode 100644
index 00000000..1715643
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_mcp.h
@@ -0,0 +1,174 @@
+/*
+ * rtk_mcp.h - MCP driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#define CP_REG_BASE 0x0
+#define TP_REG_BASE 0x0
+#define CP_OTP_LOAD (CP_REG_BASE + 0x19c)
+
+/* for SCPU */
+/* MCP General Registers */
+#define MCP_CTRL (CP_REG_BASE + 0x100)
+#define MCP_STATUS (CP_REG_BASE + 0x104)
+#define MCP_EN (CP_REG_BASE + 0x108)
+
+/* MCP Ring-Buffer Registers */
+#define MCP_BASE (CP_REG_BASE + 0x10c)
+#define MCP_LIMIT (CP_REG_BASE + 0x110)
+#define MCP_RDPTR (CP_REG_BASE + 0x114)
+#define MCP_WRPTR (CP_REG_BASE + 0x118)
+#define MCP_DES_COUNT (CP_REG_BASE + 0x134)
+#define MCP_DES_COMPARE (CP_REG_BASE + 0x138)
+
+/* MCP Ini_Key Registers */
+#define MCP_DES_INI_KEY (CP_REG_BASE + 0x11C)
+#define MCP_AES_INI_KEY (CP_REG_BASE + 0x124)
+
+/* CP Power Management */
+#define PWM_CTRL (CP_REG_BASE + 0x1e0)
+
+/* TP registers */
+#define TP_KEY_INFO_0 (TP_REG_BASE + 0x58)
+#define TP_KEY_INFO_1 (TP_REG_BASE + 0x5c)
+#define TP_KEY_CTRL (TP_REG_BASE + 0x60)
+
+#if 1
+
+#define SET_TP_KEY_CTRL(x,y) writel((x), (volatile unsigned int*) (TP_KEY_CTRL+y))
+#define SET_TP_KEYINFO_0(x,y) writel((x), (volatile unsigned int*) (TP_KEY_INFO_0+y))
+#define SET_TP_KEYINFO_1(x,y) writel((x), (volatile unsigned int*) (TP_KEY_INFO_1+y))
+
+#define SET_MCP_CTRL(x,y) writel((x), (volatile unsigned int*) (MCP_CTRL+y))
+#define SET_MCP_STATUS(x,y) writel((x), (volatile unsigned int*) (MCP_STATUS+y))
+#define SET_MCP_EN(x,y) writel((x), (volatile unsigned int*) (MCP_EN+y))
+#define SET_MCP_BASE(x,y) writel((x), (volatile unsigned int*) (MCP_BASE+y))
+#define SET_MCP_LIMIT(x,y) writel((x), (volatile unsigned int*) (MCP_LIMIT+y))
+#define SET_MCP_RDPTR(x,y) writel((x), (volatile unsigned int*) (MCP_RDPTR+y))
+#define SET_MCP_WRPTR(x,y) writel((x), (volatile unsigned int*) (MCP_WRPTR+y))
+#define SET_MCP_OTP_LOAD(x,y) writel((x), (volatile unsigned int*) (CP_OTP_LOAD+y)) /* for Jupiter only */
+#define SET_MCP_DES_COUNT(x,y) writel((x), (volatile unsigned int*) (MCP_DES_COUNT+y))
+#define SET_MCP_DES_COMPARE(x,y) writel((x), (volatile unsigned int*) (MCP_DES_COMPARE+y))
+
+#define SET_PWM_CTRL(x,y) writel((x), (volatile unsigned int*) (PWM_CTRL+y))
+
+#define GET_MCP_CTRL(y) readl((volatile unsigned int*) (MCP_CTRL+y))
+#define GET_MCP_STATUS(y) readl((volatile unsigned int*) (MCP_STATUS+y))
+#define GET_MCP_EN(y) readl((volatile unsigned int*) (MCP_EN+y))
+#define GET_MCP_BASE(y) readl((volatile unsigned int*) (MCP_BASE+y))
+#define GET_MCP_LIMIT(y) readl((volatile unsigned int*) (MCP_LIMIT+y))
+#define GET_MCP_RDPTR(y) readl((volatile unsigned int*) (MCP_RDPTR+y))
+#define GET_MCP_WRPTR(y) readl((volatile unsigned int*) (MCP_WRPTR+y))
+#define GET_MCP_OTP_LOAD(y) readl((volatile unsigned int*) (CP_OTP_LOAD+y)) /* for Jupiter only */
+#define GET_MCP_DES_COUNT(y) readl((volatile unsigned int*) (MCP_DES_COUNT+y))
+#define GET_MCP_DES_COMPARE(y) readl((volatile unsigned int*) (MCP_DES_COMPARE+y))
+
+#define GET_PWM_CTRL(y) readl((volatile unsigned int*) (PWM_CTRL+y))
+
+#endif
+
+//for IOCTL
+#define MCP_DESC_ENTRY_COUNT 64
+#define MCP_IOCTL_DO_COMMAND 0x70000001
+#define MCP_IOCTL_TEST_AES_H 0x71000001
+
+#define MCP_BCM_ECB 0x0
+#define MCP_BCM_CBC 0x1
+#define MCP_BCM_CTR 0x2
+
+#define MCP_WRITE_DATA (0x01)
+#define MCP_RING_EMPTY (0x01 <<1)
+#define MCP_ERROR (0x01 <<2)
+#define MCP_COMPARE (0x01 <<3)
+#ifdef CONFIG_ARCH_RTD16xx
+#define MCP_KL_DONE (0x01 <<20)
+#define MCP_K_KL_DONE (0x01 <<13)
+#endif
+
+#define MCP_GO (0x01<<1)
+#define MCP_IDEL (0x01<<2)
+#define MCP_SWAP (0x01<<3)
+#define MCP_CLEAR (0x01<<4)
+
+// Descriptor Definition
+#define MARS_MCP_MODE(x) (x & 0x1F)
+
+#define MCP_ALGO_DES 0x00
+#define MCP_ALGO_3DES 0x01
+#define MCP_ALGO_RC4 0x02
+#define MCP_ALGO_MD5 0x03
+#define MCP_ALGO_SHA_1 0x04
+#define MCP_ALGO_AES 0x05
+#define MCP_ALGO_AES_G 0x06
+#define MCP_ALGO_AES_H 0x07
+#define MCP_ALGO_CMAC 0x08
+#define MCP_ALGO_SHA256 0x0b
+
+#define MARS_MCP_BCM(x) ((x & 0x3) << 6)
+#define MCP_BCM_ECB 0x0
+#define MCP_BCM_CBC 0x1
+#define MCP_BCM_CTR 0x2
+
+#define MARS_MCP_ENC(x) ((x & 0x1) << 5)
+
+#define MARS_MCP_KEY_SEL(x) ((x & 0x1) << 12)
+#define MCP_KEY_SEL_OTP 0x1
+#define MCP_KEY_SEL_DESC 0x0
+
+#define MARS_MCP_IV_SEL(x) ((x & 0x1) << 11)
+#define MCP_IV_SEL_REG 0x1
+#define MCP_IV_SEL_DESC 0x0
+
+#define MCP_AES_ECB_Decryption(key, p_in, p_out, len) MCP_AES_Decryption(MCP_BCM_ECB, key, NULL, p_in, p_out, len)
+#define MCP_AES_ECB_Encryption(key, p_in, p_out, len) MCP_AES_Encryption(MCP_BCM_ECB, key, NULL, p_in, p_out, len)
+
+#define mcp_dump_data_with_text(data, len ,fmt, args...)  do {\
+								printk(fmt, ## args);\
+								mcp_dump_mem(data, len);\
+								}while(0)
+
+/* Debug */
+//#define MCP_DEBUG_EN
+#ifdef MCP_DEBUG_EN
+#define mcp_debug(fmt, args...) printk("[MCP] Debug, " fmt, ## args)
+#else
+#define mcp_debug(fmt, args...)
+#endif
+
+#define mcp_info(fmt, args...) printk("[MCP] " fmt, ## args)
+#define mcp_warning(fmt, args...) pr_err("[MCP] Warning, " fmt, ## args)
+
+typedef struct {
+	uint32_t flags;
+	uint32_t key[6];
+	uint32_t iv[4];
+	uint32_t data_in; /* data in : physical address */
+	uint32_t data_out; /* data out : physical address */
+	uint32_t length; /* data length */
+}mcp_desc;
+
+typedef struct {
+	union {
+		mcp_desc __user *p_desc;
+		uint64_t padding_p_desc;
+	};
+
+	uint32_t n_desc;
+	int32_t reserved;
+}mcp_desc_set;
+
+/* 256 bit SHA256 initial vector */
+#define SHA256_H0		0x6A09E667
+#define SHA256_H1		0xBB67AE85
+#define SHA256_H2		0x3C6EF372
+#define SHA256_H3		0xA54FF53A
+#define SHA256_H4		0x510E527F
+#define SHA256_H5		0x9B05688C
+#define SHA256_H6		0x1F83D9AB
+#define SHA256_H7		0x5BE0CD19
diff --git a/drivers/soc/realtek/common/rtk_memory_remap.c b/drivers/soc/realtek/common/rtk_memory_remap.c
new file mode 100644
index 00000000..8db8eef
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_memory_remap.c
@@ -0,0 +1,241 @@
+/*
+ * rtk_memory_remap.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/atomic.h>
+#include <linux/dmi.h>
+#include <linux/efi.h>
+#include <linux/export.h>
+#include <linux/memblock.h>
+#include <linux/mm_types.h>
+#include <linux/bootmem.h>
+#include <linux/of.h>
+#include <linux/of_fdt.h>
+#include <linux/of_address.h>
+#include <linux/of_reserved_mem.h>
+#include <linux/preempt.h>
+#include <linux/rbtree.h>
+#include <linux/rwsem.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/spinlock.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/mmu_context.h>
+#include <asm/cacheflush.h>
+#include <asm/tlbflush.h>
+#include <asm/mmu.h>
+#include <asm/pgtable.h>
+
+#include <soc/realtek/memory.h>
+
+#define DRIVER_NAME "RTK_MEM_REMAP"
+
+#ifdef CONFIG_RTK_RPC
+extern volatile void __iomem *rpc_ringbuf_base;
+extern volatile void __iomem *rpc_common_base;
+#endif /* CONFIG_RTK_RPC */
+
+#ifdef CONFIG_RTK_RBUS_BARRIER
+extern void __iomem *rbus_addr;
+extern int rtk_rbus_barrier_flag;
+#endif /* CONFIG_RTK_RBUS_BARRIER */
+
+extern struct of_device_id __rtk_mem_remap_of_table[];
+
+#if 0 // enable if FDT use property "mem_remap" - start
+
+static const struct of_device_id __rtk_mem_remap_of_table_sentinel
+	__used __section(__rtk_mem_remap_of_table_end);
+
+#ifdef CONFIG_RTK_RBUS_BARRIER
+static void rtk_get_rbus_addr(struct device_node *np)
+{
+	rbus_addr = of_iomap(np, 0);
+	if (rbus_addr)
+	rtk_rbus_barrier_flag = 1;
+}
+#endif /* CONFIG_RTK_RBUS_BARRIER */
+
+#define REALTEK_MAP_OF_DECLARE(name, compat, fn) \
+	OF_DECLARE_1(rtk_mem_remap, name, compat, fn)
+
+static void rtk_mem_remap_init(struct device_node *np)
+{
+#ifdef CONFIG_RTK_RBUS_BARRIER
+	rtk_get_rbus_addr(np);
+#endif /* CONFIG_RTK_RBUS_BARRIER */
+
+#ifdef CONFIG_RTK_RPC
+	rpc_ringbuf_base = (void *)(u64)of_iomap(np, 5);
+	rpc_common_base = (void *)(u64)of_iomap(np, 1);
+#endif /* CONFIG_RTK_RPC */
+
+	pr_info("[%s] initialized\n", DRIVER_NAME);
+}
+
+static void rtk_mem_remap_parent_init(struct device_node *np)
+{
+	struct device_node *child;
+#ifdef CONFIG_RTK_RBUS_BARRIER
+	child = of_get_child_by_name(np, "rbus");
+	if (child)
+		rbus_addr = of_iomap(child, 0);
+
+	if (rbus_addr)
+		rtk_rbus_barrier_flag = 1;
+#endif /* CONFIG_RTK_RBUS_BARRIER */
+
+#ifdef CONFIG_RTK_RPC
+	child = of_get_child_by_name(np, "ringbuf");
+	if (child)
+		rpc_ringbuf_base = of_iomap(child, 0);
+
+	child = of_get_child_by_name(np, "common");
+	if (child)
+		rpc_common_base = of_iomap(child, 0);
+#endif /* CONFIG_RTK_RPC */
+
+	pr_info("[%s] initialized\n", DRIVER_NAME);
+}
+
+void __init rtk_mem_remap_of_init(void)
+{
+	struct device_node *np;
+	unsigned int rtk_mem_remap = 0;
+
+	for_each_compatible_node(np, NULL, "Realtek,rtk1295-mem_remap") {
+		if (of_get_child_count(np) >= 3) {
+			rtk_mem_remap_parent_init(np);
+			rtk_mem_remap++;
+			break;
+		}
+		rtk_mem_remap_init(np);
+		rtk_mem_remap++;
+	}
+
+	if (!rtk_mem_remap)
+		pr_crit("%s: no matching rtk_mem_remap found\n", __func__);
+}
+
+REALTEK_MAP_OF_DECLARE(realtek_memory_remap, "Realtek,rtk1295-mem_remap", rtk_mem_remap_init);
+
+#endif // enable if FDT use property "mem_remap" - end
+
+#define VT100_NONE	"\033[m\n"
+#define VT100_LIGHT_RED	"\033[1;31m"
+#define MYDBG_LEVEL	KERN_INFO
+
+void __init rsvmem_remap(struct reserved_mem *rmem)
+{
+	unsigned long node = rmem->fdt_node;
+	void * ret_iomap;
+	const char *type;
+	const char *save_remap_name;
+	printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, rmem->name %s"
+		VT100_NONE, __FUNCTION__, __LINE__, rmem->name);
+	type = of_get_flat_dt_prop(node, "compatible", NULL);
+	if (!type) {
+		printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, no compatible prop"
+			VT100_NONE, __FUNCTION__, __LINE__);
+		return;
+	}
+	printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, type %s"
+		VT100_NONE, __FUNCTION__, __LINE__, type);
+	if( strcmp(type, "rsvmem-remap") != 0 ) {
+		printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, value is not match"
+			VT100_NONE, __FUNCTION__, __LINE__);
+		return;
+	}
+	if( !rmem->size ) {
+		printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, size is zero"
+			VT100_NONE, __FUNCTION__, __LINE__);
+		return;
+	}
+	printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, ioremap(%llx,%llx)"
+		VT100_NONE, __FUNCTION__, __LINE__, rmem->base, rmem->size);
+	ret_iomap = ioremap(rmem->base, rmem->size);;
+	if( !ret_iomap ) {
+		printk(KERN_ERR VT100_LIGHT_RED "%s %d, ioremap(%llx,%llx)"
+			VT100_NONE, __FUNCTION__, __LINE__,
+			rmem->base, rmem->size);
+		printk(KERN_ERR VT100_LIGHT_RED "%s %d, ioremap failed"
+			VT100_NONE, __FUNCTION__, __LINE__);
+
+		return;
+	}
+	printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, remap addr %p"
+		VT100_NONE, __FUNCTION__, __LINE__, ret_iomap);
+
+	save_remap_name = of_get_flat_dt_prop(node, "save_remap_name", NULL);
+	if (!save_remap_name) {
+		printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, no save_remap_name prop"
+			VT100_NONE, __FUNCTION__, __LINE__);
+		return;
+	}
+	printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, save_remap_name %s"
+		VT100_NONE, __FUNCTION__, __LINE__, save_remap_name);
+
+	if( strcmp(save_remap_name, "rbus") == 0 ) {
+		printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, save rbus_addr"
+			VT100_NONE, __FUNCTION__, __LINE__);
+#ifdef CONFIG_RTK_RBUS_BARRIER
+		rbus_addr = ret_iomap;
+#endif
+		if (of_get_flat_dt_prop(node, "rtk_rbus_barrier_flag", NULL) ) {
+			printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, "
+				"set rtk_rbus_barrier_flag to 1"
+				VT100_NONE, __FUNCTION__, __LINE__);
+#ifdef CONFIG_RTK_RBUS_BARRIER
+			rtk_rbus_barrier_flag = 1;
+#endif
+		}
+	}
+	if( strcmp(save_remap_name, "common") == 0 ) {
+		printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, save rpc_common_base"
+			VT100_NONE, __FUNCTION__, __LINE__);
+#ifdef CONFIG_RTK_RPC
+		rpc_common_base = ret_iomap;
+#endif
+	}
+	if( strcmp(save_remap_name, "ringbuf") == 0 ) {
+		printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, save rpc_ringbuf_base"
+			VT100_NONE, __FUNCTION__, __LINE__);
+#ifdef CONFIG_RTK_RPC
+		rpc_ringbuf_base = ret_iomap;
+#endif
+	}
+	printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, init %s/%s done"
+		VT100_NONE, __FUNCTION__, __LINE__, rmem->name, save_remap_name);
+}
+
+void __init rtk_mem_remap_of_init_by_DT(struct reserved_mem *rmem, int rmem_count)
+{
+	int i;
+	printk(MYDBG_LEVEL VT100_LIGHT_RED "rmem_count: %d"
+		VT100_NONE, rmem_count);
+	for (i = 0; i < rmem_count; i++) {
+		printk(MYDBG_LEVEL "\n");
+		rsvmem_remap(&rmem[i]);
+	}
+}
+
+static void __init rsvmem_remap_setup(struct reserved_mem *rmem)
+{
+#if 1
+	printk(MYDBG_LEVEL VT100_LIGHT_RED "%s %d, not remap %s now"
+		VT100_NONE, __FUNCTION__, __LINE__, rmem->name);
+#else
+	// can not remap due to mm not ready
+	rsvmem_remap(rmem);
+#endif
+}
+
+RESERVEDMEM_OF_DECLARE(rsvmem_remap, "rsvmem-remap", rsvmem_remap_setup);
diff --git a/drivers/soc/realtek/common/rtk_mmio-secure.c b/drivers/soc/realtek/common/rtk_mmio-secure.c
new file mode 100644
index 00000000..1293508
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_mmio-secure.c
@@ -0,0 +1,72 @@
+/*
+ * rtk_mmio-secure.c
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/regmap.h>
+#include <linux/io.h>
+#include <soc/realtek/rtk_regmap.h>
+
+static struct secure_register_desc crt_reg_desc[] = {
+#ifdef CONFIG_RTK_MMIO_SECURE_RTD16XX_GENERIC_CRT
+	DEFINE_REG_SMCCC_PHYS(0x014, 0x8400ffff, 0x8400fffe),
+	DEFINE_REG_SMCCC_PHYS(0x06c, 0x8400ffff, 0x8400fffe),
+	DEFINE_REG_SMCCC_PHYS(0x084, 0x8400ffff, 0x8400fffe),
+	DEFINE_REG_SMCCC_PHYS(0x088, 0x8400ffff, 0x8400fffe),
+#endif
+#ifdef CONFIG_RTK_MMIO_SECURE_RTD13XX_GENERIC_CRT
+	DEFINE_REG_SMCCC_PHYS(0x014, 0x8400ffff, 0x8400fffe),
+	DEFINE_REG_SMCCC_PHYS(0x06c, 0x8400ffff, 0x8400fffe),
+	DEFINE_REG_SMCCC_PHYS(0x084, 0x8400ffff, 0x8400fffe),
+	DEFINE_REG_SMCCC_PHYS(0x088, 0x8400ffff, 0x8400fffe),
+	DEFINE_REG_SMCCC_PHYS(0x094, 0x8400ffff, 0x8400fffe),
+	DEFINE_REG_SMCCC_PHYS(0x454, 0x8400ffff, 0x8400fffe),
+	DEFINE_REG_SMCCC_PHYS(0x458, 0x8400ffff, 0x8400fffe),
+#endif
+	DEFINE_REG_INVALID
+};
+
+static struct rtk_regmap_config crt_config = {
+	.addr = 0x98000000,
+	.descs = crt_reg_desc,
+	.num_descs = ARRAY_SIZE(crt_reg_desc),
+	.config = {
+		.reg_bits = 32,
+		.val_bits = 32,
+		.reg_stride = 4,
+	},
+};
+
+static struct rtk_regmap_config *configs[] = {
+	&crt_config,
+	NULL
+};
+
+struct rtk_regmap_config *rtk_mmio_match_config_by_addr(unsigned long addr)
+{
+	struct rtk_regmap_config **p;
+
+	for (p = configs; *p != NULL; p++)
+		if ((*p)->addr == addr)
+			return *p;
+	return NULL;
+}
+
diff --git a/drivers/soc/realtek/common/rtk_mmio.c b/drivers/soc/realtek/common/rtk_mmio.c
new file mode 100644
index 00000000..f4748e2
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_mmio.c
@@ -0,0 +1,203 @@
+/*
+ * rtk_mmio.c - Realtek Regmap-MMIO API.
+ *              This file is based on drivers/mfd/syscon.c.
+ *
+ * Copyright (C) 2017,2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/slab.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/list.h>
+#include <linux/regmap.h>
+#include <linux/io.h>
+#include <soc/realtek/rtk_sb2_sem.h>
+#include <soc/realtek/rtk_regmap.h>
+#include <soc/realtek/rtk_mmio.h>
+
+struct regmap_sb2_lock_data {
+	struct sb2_sem *sb2lock;
+	spinlock_t spinlock;
+	unsigned long flags;
+};
+
+static void regmap_sb2_lock(void *data)
+__acquires(&data->spinlock)
+{
+	unsigned long flags;
+	struct regmap_sb2_lock_data *lock = data;
+
+	spin_lock_irqsave(&lock->spinlock, flags);
+	lock->flags = flags;
+	sb2_sem_lock(lock->sb2lock, SB2_SEM_NO_WARNING);
+}
+
+static void regmap_sb2_unlock(void *data)
+__releases(&data->spinlock)
+{
+	struct regmap_sb2_lock_data *lock = data;
+
+	sb2_sem_unlock(lock->sb2lock);
+	spin_unlock_irqrestore(&lock->spinlock, lock->flags);
+}
+
+struct rtk_mmio {
+	struct list_head list;
+	struct regmap *regmap;
+	struct device_node *np;
+	struct resource res;
+	const char *name;
+	struct regmap_config *cfg;
+};
+
+#define __addr(_m) ((unsigned long)((_m)->res.start))
+#define mmio_err(_m, _fmt, ...) \
+	pr_err("rtk-mmio %lx.%s: " _fmt, __addr(_m), (_m)->name, ##__VA_ARGS__)
+#define mmio_warn(_m, _fmt, ...) \
+	pr_warn("rtk-mmio %lx.%s: " _fmt, __addr(_m), (_m)->name, ##__VA_ARGS__)
+#define mmio_info(_m, _fmt, ...) \
+	pr_info("rtk-mmio %lx.%s: " _fmt, __addr(_m), (_m)->name, ##__VA_ARGS__)
+
+static struct regmap_config common_config = {
+	.reg_bits = 32,
+	.val_bits = 32,
+	.reg_stride = 4,
+};
+
+static LIST_HEAD(mmio_list);
+static DEFINE_SPINLOCK(mmio_list_lock);
+
+static struct rtk_mmio *create_rtk_mmio(struct device_node *np)
+{
+	struct rtk_mmio *mmio;
+	struct regmap *regmap;
+	struct regmap_config cfg = common_config;
+	void __iomem *reg;
+	struct sb2_sem *sb2lock = NULL;
+	struct regmap_sb2_lock_data *lock = NULL;
+	int ret;
+	struct rtk_regmap_config *conf = NULL;
+
+	if (!of_device_is_compatible(np, "realtek,mmio")) {
+		pr_err("%s: not realtek,mmio\n", np->name);
+		return ERR_PTR(-EINVAL);
+	}
+
+	mmio = kzalloc(sizeof(*mmio), GFP_KERNEL);
+	if (!mmio)
+		return ERR_PTR(-ENOMEM);
+	mmio->name = np->name;
+
+	ret = of_address_to_resource(np, 0, &mmio->res);
+	if (ret) {
+		mmio_err(mmio, "failed to get resource: %d\n", ret);
+		goto free_mem;
+	}
+
+	reg = ioremap(mmio->res.start, resource_size(&mmio->res));
+	if (!reg) {
+		mmio_err(mmio, "failed to ioremap\n");
+		ret = -ENOMEM;
+		goto free_mem;
+	}
+
+	/* secure regster accese */
+	conf = rtk_mmio_match_config_by_addr(mmio->res.start);
+	if (conf) {
+		mmio_info(mmio, "use secure config\n");
+		mmio->cfg = &conf->config;
+		mmio->cfg->max_register = resource_size(&mmio->res) - 1;
+	} else {
+		mmio->cfg = &cfg;
+		mmio->cfg->name = np->name;
+		mmio->cfg->max_register = resource_size(&mmio->res) - 1;
+	}
+
+	/* hwsemaphore */
+	sb2lock = of_sb2_sem_get(np, 0);
+	if (IS_ERR(sb2lock)) {
+		mmio_info(mmio, "failed to get hw semaphore: %ld\n",
+			PTR_ERR(sb2lock));
+		sb2lock = NULL;
+	}
+	if (sb2lock) {
+		mmio_info(mmio, "use hw semaphore\n");
+
+		lock = kzalloc(sizeof(*lock), GFP_KERNEL);
+		if (!lock) {
+			ret = -ENOMEM;
+			mmio_err(mmio, "failed to alloc lock data\n");
+			goto free_mem;
+		}
+		spin_lock_init(&lock->spinlock);
+		lock->sb2lock = sb2lock;
+
+		mmio->cfg->lock_arg = lock;
+		mmio->cfg->lock = regmap_sb2_lock;
+		mmio->cfg->unlock = regmap_sb2_unlock;
+	}
+
+
+	if (conf)
+		regmap = rtk_regmap_init_secure_mmio(NULL, reg, conf);
+	else
+		regmap = regmap_init_mmio(NULL, reg, mmio->cfg);
+	if (IS_ERR(regmap)) {
+		ret = PTR_ERR(regmap);
+		mmio_err(mmio, "failed to init regmap: %d\n", ret);
+		goto free_mem;
+	}
+
+	mmio->np = np;
+	mmio->regmap = regmap;
+
+	spin_lock(&mmio_list_lock);
+	list_add_tail(&mmio->list, &mmio_list);
+	spin_unlock(&mmio_list_lock);
+
+	return mmio;
+
+free_mem:
+	kfree(lock);
+	kfree(mmio);
+	return ERR_PTR(ret);
+}
+
+struct regmap *rtk_mmio_node_to_regmap(struct device_node *np)
+{
+	struct rtk_mmio *mmio = NULL, *p;
+
+	spin_lock(&mmio_list_lock);
+	list_for_each_entry(p, &mmio_list, list)
+		if (p->np == np) {
+			mmio = p;
+			break;
+		}
+	spin_unlock(&mmio_list_lock);
+
+	if (!mmio)
+		mmio = create_rtk_mmio(np);
+
+	if (IS_ERR(mmio))
+		return ERR_CAST(mmio);
+
+	return mmio->regmap;
+}
+
diff --git a/drivers/soc/realtek/common/rtk_r2rdsc.c b/drivers/soc/realtek/common/rtk_r2rdsc.c
new file mode 100644
index 00000000..d00b713
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_r2rdsc.c
@@ -0,0 +1,284 @@
+/*
+ * Realtek R2RDSC Driver
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corp.
+ *
+ * Author:
+ *   Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/miscdevice.h>
+#include <linux/slab.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/list.h>
+#include <linux/pm_runtime.h>
+#include <linux/mm.h>
+
+struct rtk_r2rdsc_device {
+	struct miscdevice     mdev;
+	struct device         *dev;
+	/* pm */
+	atomic_t              open_cnt;
+
+	struct clk            *clk_r2rdsc;
+	struct reset_control  *rstc_r2rdsc;
+
+	/* map */
+	void                  *base_r2rdsc;
+	phys_addr_t           addr_r2rdsc;
+	resource_size_t       size_r2rdsc;
+};
+
+struct rtk_r2rdsc_ctx {
+	struct rtk_r2rdsc_device *rrdev;
+};
+
+static int rtk_r2rdsc_open(struct inode *inode, struct file *filp)
+{
+	struct rtk_r2rdsc_device *rrdev = container_of(filp->private_data,
+						      struct rtk_r2rdsc_device,
+						      mdev);
+	struct rtk_r2rdsc_ctx *ctx;
+
+	ctx = kzalloc(sizeof(*ctx), GFP_KERNEL);
+	if (!ctx)
+		return -ENOMEM;
+	ctx->rrdev = rrdev;
+	filp->private_data = ctx;
+
+	atomic_inc(&rrdev->open_cnt);
+	pm_runtime_get_sync(rrdev->dev);
+
+	return 0;
+}
+
+static int rtk_r2rdsc_release(struct inode *inode, struct file *filp)
+{
+	struct rtk_r2rdsc_ctx *ctx = filp->private_data;
+	struct rtk_r2rdsc_device *rrdev = ctx->rrdev;
+
+	pm_runtime_put_sync(rrdev->dev);
+	atomic_dec(&rrdev->open_cnt);
+	kfree(ctx);
+	return 0;
+}
+
+static const struct vm_operations_struct rtk_r2rdsc_vm_ops = {
+#ifdef CONFIG_HAVE_IOREMAP_PROT
+	.access = generic_access_phys,
+#endif
+};
+
+static int rtk_r2rdsc_mmap(struct file *filp, struct vm_area_struct *vma)
+{
+	struct rtk_r2rdsc_ctx *ctx = filp->private_data;
+	struct rtk_r2rdsc_device *rrdev = ctx->rrdev;
+	phys_addr_t addr;
+	resource_size_t size;
+
+
+	if (vma->vm_end < vma->vm_start)
+		return -EINVAL;
+
+	addr = rrdev->addr_r2rdsc;
+	size = rrdev->size_r2rdsc;
+
+	if (addr & ~PAGE_MASK)
+		return -EINVAL;
+
+	if ((vma->vm_end - vma->vm_start) > size)
+		return -EINVAL;
+
+	vma->vm_ops = &rtk_r2rdsc_vm_ops;
+	vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+
+	return remap_pfn_range(vma,
+			       vma->vm_start,
+			       addr >> PAGE_SHIFT,
+			       vma->vm_end - vma->vm_start,
+			       vma->vm_page_prot);
+}
+
+
+static const struct file_operations rtk_r2rdsc_fops = {
+	.owner         = THIS_MODULE,
+	.open          = rtk_r2rdsc_open,
+	.release       = rtk_r2rdsc_release,
+	.mmap          = rtk_r2rdsc_mmap,
+};
+
+static void rtk_r2rdsc_power_on(struct rtk_r2rdsc_device *rrdev)
+{
+	clk_prepare_enable(rrdev->clk_r2rdsc);
+	reset_control_deassert(rrdev->rstc_r2rdsc);
+}
+
+static void rtk_r2rdsc_power_off(struct rtk_r2rdsc_device *rrdev)
+{
+	 reset_control_assert(rrdev->rstc_r2rdsc);
+	 clk_disable_unprepare(rrdev->clk_r2rdsc);
+}
+
+static int rtk_r2rdsc_runtime_resume(struct device *dev)
+{
+	struct rtk_r2rdsc_device *rrdev = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "enter %s\n", __func__);
+	rtk_r2rdsc_power_on(rrdev);
+	dev_dbg(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_r2rdsc_runtime_suspend(struct device *dev)
+{
+	struct rtk_r2rdsc_device *rrdev = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "enter %s\n", __func__);
+	rtk_r2rdsc_power_off(rrdev);
+	dev_dbg(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_r2rdsc_resume(struct device *dev)
+{
+	struct rtk_r2rdsc_device *rrdev = dev_get_drvdata(dev);
+
+	if (atomic_read(&rrdev->open_cnt) == 0)
+		return 0;
+
+	dev_info(dev, "enter %s\n", __func__);
+	rtk_r2rdsc_power_on(rrdev);
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_r2rdsc_suspend(struct device *dev)
+{
+	struct rtk_r2rdsc_device *rrdev = dev_get_drvdata(dev);
+
+	if (atomic_read(&rrdev->open_cnt) == 0)
+		return 0;
+
+	dev_info(dev, "enter %s\n", __func__);
+	rtk_r2rdsc_power_off(rrdev);
+	dev_info(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_r2rdsc_pm_ops = {
+	.runtime_suspend = rtk_r2rdsc_runtime_suspend,
+	.runtime_resume  = rtk_r2rdsc_runtime_resume,
+	.suspend         = rtk_r2rdsc_suspend,
+	.resume          = rtk_r2rdsc_resume,
+};
+
+static int rtk_r2rdsc_probe(struct platform_device *pdev)
+{
+	struct rtk_r2rdsc_device *rrdev;
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	int ret;
+	struct resource res;
+
+	rrdev = devm_kzalloc(dev, sizeof(*rrdev), GFP_KERNEL);
+	if (!rrdev)
+		return -ENOMEM;
+
+	rrdev->dev = dev;
+
+	/* get r2rdsc resources */
+	rrdev->clk_r2rdsc = devm_clk_get(dev, "r2rdsc");
+	if (IS_ERR(rrdev->clk_r2rdsc)) {
+		ret = PTR_ERR(rrdev->clk_r2rdsc);
+		dev_err(dev, "r2rdsc: failed to get clk: %d\n", ret);
+		return ret;
+	}
+
+	rrdev->rstc_r2rdsc = devm_reset_control_get(dev, "r2rdsc");
+	if (IS_ERR(rrdev->rstc_r2rdsc)) {
+		ret = PTR_ERR(rrdev->rstc_r2rdsc);
+		dev_err(dev, "failed to get reset_control: %d\n", ret);
+		return ret;
+	}
+
+	ret = of_address_to_resource(np, 0, &res);
+	if (ret) {
+		dev_err(dev, "r2rdsc: failed to get address: %d\n", ret);
+		return ret;
+	}
+
+	rrdev->addr_r2rdsc = res.start;
+	rrdev->size_r2rdsc = ALIGN(resource_size(&res), PAGE_SIZE);
+	rrdev->base_r2rdsc = devm_ioremap(dev, res.start, resource_size(&res));
+	if (!rrdev->base_r2rdsc) {
+		dev_err(dev, "r2rdsc: failed to ioremap\n");
+		return -ENOMEM;
+	}
+
+	atomic_set(&rrdev->open_cnt, 0);
+	rrdev->mdev.minor  = MISC_DYNAMIC_MINOR;
+	rrdev->mdev.name   = "r2rdsc";
+	rrdev->mdev.fops   = &rtk_r2rdsc_fops;
+	rrdev->mdev.parent = dev;
+	ret = misc_register(&rrdev->mdev);
+	if (ret) {
+		dev_err(dev, "failed to register misc device: %d\n", ret);
+		return ret;
+	}
+
+	platform_set_drvdata(pdev, rrdev);
+	pm_runtime_set_suspended(dev);
+	pm_runtime_enable(dev);
+	dev_info(dev, "initialized\n");
+
+	return 0;
+}
+
+static int rtk_r2rdsc_remove(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct rtk_r2rdsc_device *rrdev = platform_get_drvdata(pdev);
+
+	pm_runtime_disable(dev);
+	platform_set_drvdata(pdev, NULL);
+	misc_deregister(&rrdev->mdev);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+
+static const struct of_device_id rtk_r2rdsc_ids[] = {
+	{ .compatible = "realtek,r2rdsc" },
+	{}
+};
+
+static struct platform_driver rtk_r2rdsc_driver = {
+	.probe = rtk_r2rdsc_probe,
+	.remove = rtk_r2rdsc_remove,
+	.driver = {
+		.owner = THIS_MODULE,
+		.name = "rtk-r2rdsc",
+		.of_match_table = rtk_r2rdsc_ids,
+		.pm = &rtk_r2rdsc_pm_ops,
+	},
+};
+module_platform_driver(rtk_r2rdsc_driver);
diff --git a/drivers/soc/realtek/common/rtk_regmap-i2c.c b/drivers/soc/realtek/common/rtk_regmap-i2c.c
new file mode 100644
index 00000000..d4f8ebb
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_regmap-i2c.c
@@ -0,0 +1,94 @@
+/*
+ * rtk_regmap_i2c.c - Realtek Regmap I2C bus
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ * Copyright (C) 2017 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/i2c.h>
+#include <linux/module.h>
+#include <linux/regmap.h>
+
+#define to_bytep(_p)  ((unsigned char *)(_p))
+
+static int rtk_regmap_i2c_write(void *context, const void *data, size_t count)
+{
+	struct i2c_client *i2c = context;
+	int ret = 0;
+
+	pr_debug("%s: reg=%02x val=%02x\n", __func__,
+		to_bytep(data)[0], to_bytep(data)[1]);
+
+	ret = i2c_master_send(i2c, data, count);
+
+	if (ret == count)
+		return 0;
+	else if (ret < 0)
+		return ret;
+	else
+		return -EIO;
+}
+
+static int rtk_regmap_i2c_read(void *context, const void *reg, size_t reg_size,
+	void *val, size_t val_size)
+{
+	struct i2c_client *i2c = context;
+	unsigned char _reg = *(unsigned char *)reg;
+	struct i2c_msg xfer[2];
+	int ret = 0;
+
+	xfer[0].addr = i2c->addr;
+	xfer[0].flags = 0;
+	xfer[0].len = reg_size;
+	xfer[0].buf = &_reg;
+
+	xfer[1].addr = i2c->addr;
+	xfer[1].flags = I2C_M_RD;
+	xfer[1].len = val_size;
+	xfer[1].buf = val;
+
+	ret = i2c_transfer(i2c->adapter, xfer, 2);
+
+	pr_debug("%s: reg=%02x val=%02x ret=%d\n", __func__,
+		_reg, to_bytep(val)[0], ret);
+
+	if (ret == 2)
+		return 0;
+	else if (ret < 0)
+		return ret;
+	else
+		return -EIO;
+}
+
+static struct regmap_bus rtk_regmap_regmap_bus = {
+	.write = rtk_regmap_i2c_write,
+	.read  = rtk_regmap_i2c_read,
+};
+
+struct regmap *__rtk_regmap_init_i2c(struct i2c_client *client,
+				     const struct regmap_config *config,
+				     struct lock_class_key *lock_key,
+				     const char *lock_name)
+{
+
+	return __regmap_init(&client->dev, &rtk_regmap_regmap_bus, client,
+		config, lock_key, lock_name);
+}
+EXPORT_SYMBOL_GPL(__rtk_regmap_init_i2c);
+
+struct regmap *__devm_rtk_regmap_init_i2c(struct i2c_client *client,
+					  const struct regmap_config *config,
+					  struct lock_class_key *lock_key,
+					  const char *lock_name)
+{
+
+	return __devm_regmap_init(&client->dev, &rtk_regmap_regmap_bus,
+		client, config, lock_key, lock_name);
+}
+EXPORT_SYMBOL_GPL(__devm_rtk_regmap_init_i2c);
+
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/soc/realtek/common/rtk_regmap-mmio.c b/drivers/soc/realtek/common/rtk_regmap-mmio.c
new file mode 100644
index 00000000..f2fa51d
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_regmap-mmio.c
@@ -0,0 +1,301 @@
+/*
+ * This file is based on 'drivers/base/regmap/regmap-mmio.c'
+ *
+ * Copyright (c) 2018, Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms and conditions of the GNU General Public License,
+ * version 2, as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+ * more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/err.h>
+#include <linux/io.h>
+#include <linux/module.h>
+#include <linux/regmap.h>
+#include <linux/slab.h>
+#include <linux/arm-smccc.h>
+#include <soc/realtek/rtk_regmap.h>
+
+#define RTK_REGMAP_NAME_LENGTH          30
+
+struct rtk_regmap_mmio_context {
+	void __iomem *regs;
+	const struct secure_register_desc *descs;
+	u32 num_descs;
+	u32 addr;
+	char name[RTK_REGMAP_NAME_LENGTH];
+};
+
+enum {
+	SWC_READ,
+	SWC_WRITE,
+};
+
+#ifdef CONFIG_RTK_REGMAP_SECURE_MMIO
+
+static void swc_write(struct rtk_regmap_mmio_context *ctx,
+		      const struct secure_register_desc *desc,
+		      u32 val)
+{
+	struct arm_smccc_res res;
+
+	switch (desc->fmt) {
+	case SMCCC_FMT_CMD:
+		arm_smccc_smc(desc->wcmd, val, 0, 0, 0, 0, 0, 0, &res);
+		break;
+	case SMCCC_FMT_CMD_PHYS:
+		arm_smccc_smc(desc->wcmd, ctx->addr + desc->offset, val, 0, 0,
+			0, 0, 0, &res);
+		break;
+	}
+}
+
+static u32 swc_read(struct rtk_regmap_mmio_context *ctx,
+		    const struct secure_register_desc *desc)
+{
+	struct arm_smccc_res res;
+
+	switch (desc->fmt) {
+	case SMCCC_FMT_CMD:
+		arm_smccc_smc(desc->rcmd, 0, 0, 0, 0, 0, 0, 0, &res);
+		break;
+	case SMCCC_FMT_CMD_PHYS:
+		arm_smccc_smc(desc->rcmd, ctx->addr + desc->offset, 0, 0, 0, 0,
+			0, 0, &res);
+		break;
+	}
+	return res.a0;
+}
+
+static const
+struct secure_register_desc *find_desc(struct rtk_regmap_mmio_context *ctx,
+				       u32 reg,
+				       u32 type)
+{
+	u32 i;
+
+	if (!ctx->descs)
+		return NULL;
+
+	for (i = 0; i < ctx->num_descs; i++) {
+		const struct secure_register_desc *desc = &ctx->descs[i];
+
+		if (desc->offset == reg) {
+			switch (type) {
+			case SWC_READ:
+				return desc->rcmd ? desc : NULL;
+			case SWC_WRITE:
+				return desc->wcmd ? desc : NULL;
+			default:
+				return NULL;
+			}
+		}
+	}
+	return NULL;
+}
+
+#else
+
+static void swc_write(struct rtk_regmap_mmio_context *ctx,
+		      const struct secure_register_desc *desc,
+		      u32 val)
+{
+	BUG();
+}
+
+static u32 swc_read(struct rtk_regmap_mmio_context *ctx,
+		    const struct secure_register_desc *desc)
+{
+	BUG();
+	return 0;
+}
+
+static inline const
+struct secure_register_desc *find_desc(struct rtk_regmap_mmio_context *ctx,
+				       u32 reg,
+				       u32 type)
+{
+	return NULL;
+}
+
+#endif /* CONFIG_RTK_REGMAP_SECURE_MMIO */
+
+static int rtk_regmap_mmio_write(void *context,
+				 unsigned int reg,
+				 unsigned int val)
+{
+	struct rtk_regmap_mmio_context *ctx = context;
+	const struct secure_register_desc *desc = NULL;
+
+	desc = find_desc(ctx, reg, SWC_WRITE);
+	pr_debug("%s: type=W, off=%03x, val=%08x, flag=%c\n",
+		ctx->name, reg, val, desc != NULL ? 'S' : '-');
+	if (desc)
+		swc_write(ctx, desc, val);
+	else
+		writel(val, ctx->regs + reg);
+	return 0;
+}
+
+static int rtk_regmap_mmio_read(void *context,
+				unsigned int reg,
+				unsigned int *val)
+{
+	struct rtk_regmap_mmio_context *ctx = context;
+	const struct secure_register_desc *desc = NULL;
+
+	desc = find_desc(ctx, reg, SWC_READ);
+	if (desc)
+		*val = swc_read(ctx, desc);
+	else
+		*val = readl(ctx->regs + reg);
+	pr_debug("%s: type=R, off=%03x, val=%08x, flag=%c\n",
+		ctx->name, reg, *val, desc != NULL ? 'S' : '-');
+	return 0;
+}
+
+static void rtk_regmap_mmio_free_context(void *context)
+{
+	struct rtk_regmap_mmio_context *ctx = context;
+
+	kfree(ctx->descs);
+	kfree(ctx);
+}
+
+static const struct regmap_bus rtk_regmap_mmio = {
+	.fast_io      = true,
+	.reg_write    = rtk_regmap_mmio_write,
+	.reg_read     = rtk_regmap_mmio_read,
+	.free_context = rtk_regmap_mmio_free_context,
+};
+
+static struct rtk_regmap_mmio_context *
+regmap_mmio_gen_context(struct device *dev,
+			void __iomem *regs,
+			const struct regmap_config *config)
+{
+	struct rtk_regmap_mmio_context *ctx;
+
+	BUG_ON(config->reg_bits != 32);
+	BUG_ON(config->pad_bits);
+	BUG_ON(config->reg_stride != 4);
+
+	ctx = kzalloc(sizeof(*ctx), GFP_KERNEL);
+	if (!ctx)
+		return ERR_PTR(-ENOMEM);
+
+	if (config->name)
+		strlcpy(ctx->name, config->name, sizeof(ctx->name));
+	ctx->regs = regs;
+
+	return ctx;
+}
+
+struct regmap *__rtk_regmap_init_mmio(struct device *dev,
+				      void __iomem *regs,
+				      const struct regmap_config *config,
+				      struct lock_class_key *lock_key,
+				      const char *lock_name)
+{
+	struct rtk_regmap_mmio_context *ctx;
+
+	ctx = regmap_mmio_gen_context(dev, regs, config);
+	if (IS_ERR(ctx))
+		return ERR_CAST(ctx);
+
+	return __regmap_init(dev, &rtk_regmap_mmio, ctx, config, lock_key,
+		lock_name);
+}
+EXPORT_SYMBOL_GPL(__rtk_regmap_init_mmio);
+
+struct regmap *__devm_rtk_regmap_init_mmio(struct device *dev,
+					   void __iomem *regs,
+					   const struct regmap_config *config,
+					   struct lock_class_key *lock_key,
+					   const char *lock_name)
+{
+	struct rtk_regmap_mmio_context *ctx;
+
+	ctx = regmap_mmio_gen_context(dev, regs, config);
+	if (IS_ERR(ctx))
+		return ERR_CAST(ctx);
+
+	return __devm_regmap_init(dev, &rtk_regmap_mmio, ctx, config,
+		lock_key, lock_name);
+}
+EXPORT_SYMBOL_GPL(__devm_rtk_regmap_init_mmio);
+
+static struct rtk_regmap_mmio_context *
+regmap_secure_mmio_gen_context(struct device *dev,
+			       void __iomem *regs,
+			       const struct rtk_regmap_config *config)
+{
+	struct rtk_regmap_mmio_context *ctx;
+
+	ctx = regmap_mmio_gen_context(dev, regs, &config->config);
+	if (IS_ERR(ctx))
+		return ctx;
+	if (!config->config.name)
+		snprintf(ctx->name, sizeof(ctx->name), "regmap-mmio.%x",
+			config->addr);
+
+	ctx->addr = config->addr;
+	ctx->num_descs = config->num_descs;
+	ctx->descs = kmemdup(config->descs,
+		sizeof(*config->descs) * config->num_descs, GFP_KERNEL);
+	if (!ctx->descs) {
+		rtk_regmap_mmio_free_context(ctx);
+		return ERR_PTR(-ENOMEM);
+	}
+
+	return ctx;
+}
+
+struct regmap *
+__rtk_regmap_init_secure_mmio(struct device *dev,
+			      void __iomem *regs,
+			      const struct rtk_regmap_config *config,
+			      struct lock_class_key *lock_key,
+			      const char *lock_name)
+{
+	struct rtk_regmap_mmio_context *ctx;
+
+	ctx = regmap_secure_mmio_gen_context(dev, regs, config);
+	if (IS_ERR(ctx))
+		return ERR_CAST(ctx);
+
+	return __regmap_init(dev, &rtk_regmap_mmio, ctx, &config->config,
+		lock_key, lock_name);
+}
+EXPORT_SYMBOL_GPL(__rtk_regmap_init_secure_mmio);
+
+struct regmap *
+__devm_rtk_regmap_init_secure_mmio(struct device *dev,
+				   void __iomem *regs,
+				   const struct rtk_regmap_config *config,
+				   struct lock_class_key *lock_key,
+				   const char *lock_name)
+{
+	struct rtk_regmap_mmio_context *ctx;
+
+	ctx = regmap_secure_mmio_gen_context(dev, regs, config);
+	if (IS_ERR(ctx))
+		return ERR_CAST(ctx);
+
+	return __devm_regmap_init(dev, &rtk_regmap_mmio, ctx, &config->config,
+		lock_key, lock_name);
+}
+EXPORT_SYMBOL_GPL(__devm_rtk_regmap_init_secure_mmio);
+
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/soc/realtek/common/rtk_sb2_dbg.c b/drivers/soc/realtek/common/rtk_sb2_dbg.c
new file mode 100644
index 00000000..f32e2e3
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_sb2_dbg.c
@@ -0,0 +1,418 @@
+/*
+ * rtk_sb2_dbg.c - bus debug driver
+ *
+ * Copyright (c) 2017-2019 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/notifier.h>
+#include <linux/ktime.h>
+#include <linux/debugfs.h>
+#include <asm/system_misc.h>
+
+#include <soc/realtek/rtk_sb2_dbg.h>
+#include "include/rtk_sb2.h"
+
+#define DRIVER_NAME "RTK_SB2_DBG"
+#define sb2_info(fmt, ...)  pr_info("[%s] " fmt, DRIVER_NAME, ##__VA_ARGS__)
+#define sb2_err(fmt, ...)   pr_err("[%s] " fmt, DRIVER_NAME, ##__VA_ARGS__)
+#define sb2_err_hl(fmt, ...)   pr_err("\033[0;31m[%s] " fmt "\033[m\n", DRIVER_NAME, ##__VA_ARGS__)
+#define sb2_dbg(fmt, ...)   pr_debug("[%s] " fmt, DRIVER_NAME, ##__VA_ARGS__)
+
+static int sb2_default_handler_enable = 1;
+static struct sb2_data *sb2_data;
+static ATOMIC_NOTIFIER_HEAD(sb2_dbg_notifier);
+static ATOMIC_NOTIFIER_HEAD(sb2_inv_notifier);
+static const char *inv_cpu_str[] = {
+	[SB2_INV_SCPU_SWC] = "SCPU security world",
+	[SB2_INV_SCPU]     = "SCPU",
+	[SB2_INV_ACPU]     = "ACPU",
+	[SB2_INV_PCPU]     = "PCPU",
+};
+
+
+int sb2_dbg_register_dbg_notifier(struct notifier_block *nb)
+{
+	return atomic_notifier_chain_register(&sb2_dbg_notifier, nb);
+}
+EXPORT_SYMBOL_GPL(sb2_dbg_register_dbg_notifier);
+
+int sb2_dbg_unregister_dbg_notifier(struct notifier_block *nb)
+{
+	return atomic_notifier_chain_unregister(&sb2_dbg_notifier, nb);
+}
+EXPORT_SYMBOL_GPL(sb2_dbg_unregister_dbg_notifier);
+
+static void __notify_dbg_int(struct sb2_dbg_event_data *data)
+{
+	atomic_notifier_call_chain(&sb2_dbg_notifier, 0, data);
+}
+
+int sb2_dbg_register_inv_notifier(struct notifier_block *nb)
+{
+	return atomic_notifier_chain_register(&sb2_inv_notifier, nb);
+}
+EXPORT_SYMBOL_GPL(sb2_dbg_register_inv_notifier);
+
+int sb2_dbg_unregister_inv_notifier(struct notifier_block *nb)
+{
+	return atomic_notifier_chain_unregister(&sb2_inv_notifier, nb);
+}
+EXPORT_SYMBOL_GPL(sb2_dbg_unregister_inv_notifier);
+
+static void __notify_inv_int(struct sb2_inv_event_data *data)
+{
+	atomic_notifier_call_chain(&sb2_inv_notifier, 0, data);
+}
+
+static int sb2_dbg_default_inv_callback(struct notifier_block *nb, unsigned long action, void *data)
+{
+	struct sb2_inv_event_data *d = data;
+
+	if (!sb2_default_handler_enable)
+		return NOTIFY_DONE;
+
+	sb2_err("sb2 get int 0x%08x from SB2_INV_INTSTAT\n", d->raw_ints);
+	sb2_err_hl("Invalid access issued by %s", inv_cpu_str[d->inv_cpu]);
+	sb2_err_hl("Invalid address is 0x%x", d->addr);
+	sb2_err("Timeout threshold(0x%08x)\n", d->timeout_th);
+	return NOTIFY_OK;
+}
+
+static struct notifier_block sb2_dbg_default_inv_nb = {
+	.notifier_call = sb2_dbg_default_inv_callback,
+	.priority = -1,
+};
+
+static int sb2_dbg_default_dbg_callback(struct notifier_block *nb, unsigned long action, void *data)
+{
+	struct sb2_dbg_event_data *d = data;
+
+	if (!sb2_default_handler_enable)
+		return NOTIFY_DONE;
+
+	sb2_err("sb2 get int 0x%08x from SB2_DBG_INT\n", d->raw_ints);
+	return NOTIFY_OK;
+}
+
+static struct notifier_block sb2_dbg_default_dbg_nb = {
+	.notifier_call = sb2_dbg_default_dbg_callback,
+	.priority = -1,
+};
+
+void sb2_dbg_disable_default_handlers(void)
+{
+	sb2_default_handler_enable = 0;
+}
+EXPORT_SYMBOL_GPL(sb2_dbg_add_default_handlers);
+
+void sb2_dbg_enable_default_handlers(void)
+{
+	sb2_default_handler_enable = 1;
+}
+EXPORT_SYMBOL_GPL(sb2_dbg_remove_default_handlers);
+
+int sb2_dbg_ready(void)
+{
+	return sb2_data != NULL;
+}
+EXPORT_SYMBOL_GPL(sb2_dbg_ready);
+
+int sb2_dbg_disable_mem_monitor(int i)
+{
+	if (!sb2_dbg_ready())
+		return -ENODEV;
+
+	sb2_write(sb2_data, SB2_DBG_CTRL_REG0 + i * 4,
+		CLR_DBG_ACPU_CHK_EN | CLR_DBG_SCPU_CHK_EN | CLR_DBG_EN);
+	return 0;
+}
+EXPORT_SYMBOL(sb2_dbg_disable_mem_monitor);
+
+static int sb2_dbg_set_mem_monitor(int i, u32 start, u32 end, u32 flags)
+{
+	if (!sb2_dbg_ready())
+		return -ENODEV;
+
+	/* disable this set first */
+	sb2_dbg_disable_mem_monitor(i);
+
+	sb2_info("%s: dbg%d addr %08x-%08x flag %08x\n", __func__,
+		i, start, end, flags);
+	sb2_write(sb2_data, SB2_DBG_START_REG0 + i * 4, start);
+	sb2_write(sb2_data, SB2_DBG_END_REG0 + i * 4, end);
+	sb2_write(sb2_data, SB2_DBG_CTRL_REG0 + i * 4,  flags);
+	return 0;
+}
+
+/*
+ * which: 0~7, which register set
+ * d_i: SB2_DBG_MONITOR_DATA|SB2_DBG_MONITOR_INST
+ * r_w: SB2_DBG_MONITOR_READ|SB2_DBG_MONITOR_WRITE
+ */
+int sb2_dbg_scpu_monitor(int which, u32 start, u32 end, u32 d_i, u32 r_w)
+{
+	return sb2_dbg_set_mem_monitor(which, start, end,
+		CLR_DBG_ACPU_CHK_EN | SET_DBG_SCPU_CHK_EN | SET_DBG_EN |
+		d_i | r_w);
+}
+EXPORT_SYMBOL(sb2_dbg_scpu_monitor);
+
+int sb2_dbg_acpu_monitor(int which, u32 start, u32 end, u32 d_i, u32 r_w)
+{
+	return sb2_dbg_set_mem_monitor(which, start, end,
+		SET_DBG_ACPU_CHK_EN | CLR_DBG_SCPU_CHK_EN | SET_DBG_EN |
+		d_i | r_w);
+}
+EXPORT_SYMBOL(sb2_dbg_acpu_monitor);
+
+static irqreturn_t sb2_dbg_int_handler(int irq, void *id)
+{
+	struct platform_device *pdev = id;
+	struct sb2_data *data = platform_get_drvdata(pdev);
+	u32 val;
+	u32 intr;
+	ktime_t cur = ktime_get();
+
+	intr = sb2_read(data, SB2_DBG_INT);
+	if (intr & (SB2_SCPU_NEG_INT | SB2_SCPU_INT | SB2_ACPU_NEG_INT | SB2_ACPU_INT)) {
+		struct sb2_dbg_event_data d;
+
+		/* clear ints */
+		sb2_write(data, SB2_DBG_INT, SB2_SCPU_INT_EN | SB2_ACPU_INT_EN | WRITE_DATA_1);
+
+		d.raw_ints = intr;
+		d.cur_time = cur;
+		val = sb2_read(data, SB2_DBG_ADDR1);
+		if (intr & SB2_SCPU_INT) {
+			d.cpu = SB2_DBG_SOURCE_SCPU;
+			d.addr = sb2_read(data, SB2_DBG_ADDR_SYSTEM);
+			val >>= 2;
+		} else if (intr & SB2_ACPU_INT) {
+			d.cpu = SB2_DBG_SOURCE_ACPU;
+			d.addr = sb2_read(data, SB2_DBG_ADDR_AUDIO);
+			val >>= 4;
+		} else if (intr & SB2_PCPU_INT) {
+			d.cpu = SB2_DBG_SOURCE_PCPU;
+			d.addr = sb2_read(data, SB2_DBG_ADDR_PCPU);
+			val >>= 6;
+		}
+		d.rw = (val & 0x2) ? SB2_DBG_ACCESS_WRITE : SB2_DBG_ACCESS_READ;
+		d.di = (val & 0x1) ? SB2_DBG_ACCESS_DATA : SB2_DBG_ACCESS_INSTRUCTION;
+		__notify_dbg_int(&d);
+
+		return IRQ_HANDLED;
+	}
+
+	intr = sb2_read(data, SB2_INV_INTSTAT);
+	if (intr & (SWCIVA_INT | ACIVA_INT | SCIVA_INT | PCIVA_INT)) {
+		struct sb2_inv_event_data d;
+
+		/* clear ints */
+		sb2_write(data, SB2_INV_INTSTAT, SWCIVA_INT | ACIVA_INT | SCIVA_INT | PCIVA_INT | WRITE_DATA_0);
+
+		d.raw_ints   = intr;
+		d.cur_time   = cur;
+		d.addr       = sb2_read(data, SB2_INV_ADDR);
+		d.timeout_th = sb2_read(data, SB2_DEBUG_REG);
+		if (intr & SWCIVA_INT)
+			d.inv_cpu = SB2_INV_SCPU_SWC;
+		else if (intr & ACIVA_INT)
+			d.inv_cpu = SB2_INV_ACPU;
+		else if (intr & SCIVA_INT)
+			d.inv_cpu = SB2_INV_SCPU;
+		else if (intr & PCIVA_INT)
+			d.inv_cpu = SB2_INV_PCPU;
+		__notify_inv_int(&d);
+
+		return IRQ_HANDLED;
+	}
+	return IRQ_NONE;
+}
+
+static void sb2_set_l4_icg(struct sb2_data *data)
+{
+	if (IS_ENABLED(CONFIG_ARCH_RTD139x)) {
+		sb2_write(data, SB2_RBUS_ICG1, 0xffffffff);
+		sb2_write(data, SB2_RBUS_ICG2, 0x000fe7ff);
+		sb2_write(data, SB2_RBUS_ICG3, 0x03ff003f);
+	} else if (IS_ENABLED(CONFIG_ARCH_RTD16xx)) {
+		sb2_write(data, SB2_RBUS_ICG1, 0xffffffff);
+		sb2_write(data, SB2_RBUS_ICG2, 0xffffffff);
+		sb2_write(data, SB2_RBUS_ICG3, 0xf73f007f);
+	}
+}
+
+static void sb2_enable_interrupt(struct sb2_data *data)
+{
+	/* Enable SB2 interrupt */
+	sb2_write(data, SB2_DBG_INT, SB2_ACPU_INT_EN | SB2_SCPU_INT_EN | SB2_PCPU_INT_EN | WRITE_DATA_1);
+	sb2_write(data, SB2_INV_INTSTAT, SWCIVA_INT | ACIVA_INT | SCIVA_INT | PCIVA_INT | WRITE_DATA_0);
+	sb2_write(data, SB2_INV_INTEN, SWCIVAIRQ_EN | ACIVAIRQ_EN | SCIVAIRQ_EN | PCIVAIRQ_EN | WRITE_DATA_1 | sb2_read(data, SB2_INV_INTEN));
+}
+
+static void sb2_disable_interrupt(struct sb2_data *data)
+{
+	sb2_write(data, SB2_DBG_INT, 0);
+}
+
+static int sb2_dbg_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct sb2_data *data;
+	struct device_node *np = dev->of_node;
+	int ret;
+
+	sb2_info("%s\n", __func__);
+
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	data->irq = irq_of_parse_and_map(np, 0);
+	if (!data->irq) {
+		sb2_err("failed to parse irq\n");
+		return -ENXIO;
+	}
+
+	ret = devm_request_irq(dev, data->irq, sb2_dbg_int_handler, IRQF_SHARED, "sb2_dbg", pdev);
+	if (ret) {
+		sb2_err("request_irq() returns %d\n", ret);
+		return -ENXIO;
+	}
+
+	ret = of_sb2_data_init(np, data, 0);
+	if (ret) {
+		sb2_err("of_sb2_data_init() returns %d\n", ret);
+		return ret;
+	}
+	sb2_data = data;
+
+	sb2_info("info 0x%x\n", sb2_read(data, SB2_CHIP_INFO));
+	sb2_info("use smc %x\n", SB2_USE_SMCCALL);
+
+	sb2_dbg_register_dbg_notifier(&sb2_dbg_default_dbg_nb);
+	sb2_dbg_register_inv_notifier(&sb2_dbg_default_inv_nb);
+	debugfs_create_u32("sb2_default_handlers_enable", 0644, NULL,
+			   &sb2_default_handler_enable);
+
+	platform_set_drvdata(pdev, data);
+	sb2_set_l4_icg(data);
+	sb2_enable_interrupt(data);
+	return 0;
+}
+
+static int sb2_dbg_remove(struct platform_device *pdev)
+{
+	struct sb2_data *data = platform_get_drvdata(pdev);
+
+	sb2_info("%s\n", __func__);
+	sb2_disable_interrupt(data);
+	sb2_data_fini(data);
+	sb2_data = NULL;
+	return 0;
+}
+
+static int sb2_dbg_suspend(struct device *dev)
+{
+	struct sb2_data *data = dev_get_drvdata(dev);
+
+	sb2_info("Enter %s\n", __func__);
+	sb2_disable_interrupt(data);
+	sb2_info("Exit %s\n", __func__);
+	return 0;
+}
+
+static int sb2_dbg_resume(struct device *dev)
+{
+	struct sb2_data *data = dev_get_drvdata(dev);
+
+	sb2_info("Enter %s\n", __func__);
+	sb2_enable_interrupt(data);
+	sb2_info("Exit %s\n", __func__);
+	return 0;
+}
+
+static struct dev_pm_ops sb2_pm_ops = {
+	.suspend_noirq = sb2_dbg_suspend,
+	.resume_noirq  = sb2_dbg_resume,
+};
+
+static const struct of_device_id rtk_sb2_match[] = {
+	{.compatible = "Realtek,rtk-sb2"},
+	{.compatible = "realtek,sysbrg2"},
+	{},
+};
+
+static struct platform_driver rtk_sb2_driver = {
+	.probe  = sb2_dbg_probe,
+	.remove = sb2_dbg_remove,
+	.driver = {
+		.owner          = THIS_MODULE,
+		.name           = DRIVER_NAME,
+		.pm             = &sb2_pm_ops,
+		.of_match_table = of_match_ptr(rtk_sb2_match),
+	},
+};
+
+static void __exit rtk_sb2_exit(void)
+{
+	platform_driver_unregister(&rtk_sb2_driver);
+}
+module_exit(rtk_sb2_exit);
+
+static int __init rtk_sb2_init(void)
+{
+	return platform_driver_register(&rtk_sb2_driver);
+}
+arch_initcall(rtk_sb2_init);
+
+MODULE_DESCRIPTION("Realtek SB2 driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtk-sb2");
+
+#if 0
+static int sb2_dbg_acpu_monitor_callback(struct notifier_block *nb, unsigned long action, void *data)
+{
+	struct sb2_dbg_event_data *d = data;
+	struct pt_regs *regs;
+	char buf[200];
+
+	regs = get_irq_regs();
+	sprintf(buf, "Memory 0x%08x trashed by %sCPU with %s %s\n", d->addr,
+		(d->cpu == SB2_DBG_SOURCE_SCPU) ? "S" : "A",
+		(d->di == SB2_DBG_ACCESS_DATA) ? "D" : "I",
+		(d->rw == SB2_DBG_ACCESS_WRITE) ? "W" : "R");
+	die(buf, regs, 0);
+	return NOTIFY_OK;
+}
+
+struct notifier_block sb2_dbg_acpu_monitor_nb = {
+	.notifier_call = sb2_dbg_acpu_monitor_callback,
+};
+
+static int __init sb2_dbg_init_acpu_monitor(void)
+{
+	sb2_info("memory monitor 0x98013b00 - 0x98013c00\n");
+	sb2_dbg_acpu_monitor(4, 0x98013b00, 0x98013c00,
+		SB2_DBG_MONITOR_DATA | SB2_DBG_MONITOR_INST,
+		SB2_DBG_MONITOR_READ | SB2_DBG_MONITOR_WRITE);
+	sb2_dbg_register_dbg_notifier(&sb2_dbg_acpu_monitor_nb);
+	return 0;
+}
+late_initcall(sb2_dbg_init_acpu_monitor);
+#endif
diff --git a/drivers/soc/realtek/common/rtk_sb2_dbg_v2.c b/drivers/soc/realtek/common/rtk_sb2_dbg_v2.c
new file mode 100644
index 00000000..7e0fb8f
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_sb2_dbg_v2.c
@@ -0,0 +1,384 @@
+/*
+ * rtk_sb2_dbg.c - bus debug driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/sched.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/delay.h>
+#include <asm/system_misc.h>
+
+#include "include/reg_sb2.h"
+
+#define DRIVER_NAME "RTK_SB2_DBG"
+
+static void __iomem *iobase;
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+static void swc_write(u32 value, u32 address)
+{
+	asm volatile("mov x1, %0" : :"r"(address): "cc");
+	asm volatile("mov x2, %0" : :"r"(value) : "cc");
+	asm volatile("ldr x0, =0x8400ff07" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	udelay(5);
+}
+
+static u32 swc_read(u32 address)
+{
+	u32 tmp;
+
+	asm volatile("mov x1, %0" : :"r"(address): "cc");
+	asm volatile("ldr x0, =0x8400ff06" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("mov %0, x0" : "=r"(tmp): : "cc");
+	udelay(5);
+	return tmp;
+}
+#endif /* TEE*/
+
+irqreturn_t isr_sb2_dbg(int irq, void *pdev)
+{
+	struct pt_regs *regs;
+	u32 intr;
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	intr = swc_read(0x9801A000 | 0x4E0);
+#else
+	intr = readl(SB2_DBG_INT);
+#endif
+
+	regs = get_irq_regs();
+
+	if (intr & ((1 << 4) | (1 << 10) | (1 << 6) | (1 << 12))) {
+		u32 cause, addr, s_a_cpu;
+		char buf[128];
+
+		pr_err("[%s] sb2 get int 0x%08x from SB2_DBG_INT\n", DRIVER_NAME, intr);
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+		swc_write((1 << 9) | (1 << 7) | 1, 0x9801A4E0);
+#else
+		writel((1 << 9) | (1 << 7) | 1, SB2_DBG_INT);
+#endif
+
+		s_a_cpu = (intr & (1<<10)) ? 1 : 2;	/* SCPU:1, ACPU:2 */
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+		addr = (s_a_cpu == 1) ?
+			swc_read(0x9801A000 | 0x4C0) :
+			swc_read(0x9801A000 | 0x4B8);
+#else
+		addr = (s_a_cpu == 1) ? readl(SB2_DBG_ADDR_SYSTEM) :
+			readl(SB2_DBG_ADDR_AUDIO);
+#endif
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+		cause = swc_read(0x9801A000 | 0x4C8);
+#else
+		cause = readl(SB2_DBG_ADDR1);
+#endif
+		cause = (s_a_cpu == 1) ? (cause >> 2) : (cause >> 4);
+
+		sprintf(buf, "Memory 0x%08x trashed by %sCPU with %s %s\n", addr,
+				(s_a_cpu == 1) ? "S" : "A",
+				(cause & 1) ? "D" : "I", 
+				(cause & 2) ? "W" : "R");
+
+		die(buf, regs, 0);
+
+		return IRQ_HANDLED;
+	}
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	intr = swc_read(0x9801A000 | 0x008);
+#else
+	intr = readl(SB2_INV_INTSTAT);
+#endif
+
+	if (intr & (SWCIVA_INT | ACIVA_INT | SCIVA_INT | PCIVA_INT)) {
+
+		pr_err("[%s] sb2 get int 0x%08x from SB2_INV_INTSTAT\n", DRIVER_NAME, intr);
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+		swc_write(SWCIVA_INT | ACIVA_INT | SCIVA_INT | PCIVA_INT | WRITE_DATA_0, 0x9801A000 | 0x008);
+#else
+		writel( SWCIVA_INT | ACIVA_INT | SCIVA_INT | PCIVA_INT | WRITE_DATA_0, SB2_INV_INTSTAT);
+#endif
+
+		if (intr & SWCIVA_INT)
+			pr_err("\033[0;31m[%s] Invalid access issued by SCPU security world\033[m\n", DRIVER_NAME) ;
+		else if (intr & ACIVA_INT)
+			pr_err("\033[0;31m[%s] Invalid access issued by ACPU\033[m\n", DRIVER_NAME) ;
+		else if (intr & SCIVA_INT)
+			pr_err("\033[0;31m[%s] Invalid access issued by SCPU\033[m\n", DRIVER_NAME) ;
+		else if (intr & PCIVA_INT)
+			pr_err("\033[0;31m[%s] Invalid access issued by PCPU\033[m\n", DRIVER_NAME) ;
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+		pr_err("\033[0;31m[%s] Invalid address is 0x%x \033[m\n", DRIVER_NAME, swc_read(0x9801A000 | 0x00c));
+		pr_err("[%s] Timeout threshold(0x%08x)\n", DRIVER_NAME, swc_read(0x9801A000 | 0x010));
+#else
+		pr_err("\033[0;31m[%s] Invalid address is 0x%x \033[m\n", DRIVER_NAME, readl(SB2_INV_ADDR));
+		pr_err("[%s] Timeout threshold(0x%08x)\n", DRIVER_NAME, readl(SB2_DEBUG_REG));
+		//show_regs(regs);
+#endif
+
+		return IRQ_HANDLED;
+
+	}
+	return IRQ_NONE;
+}
+
+void sb2_dbg_scpu_monitor(int which, u32 start, u32 end, u32 d_i, u32 r_w);
+void sb2_dbg_acpu_monitor(int which, u32 start, u32 end, u32 d_i, u32 r_w);
+
+static int set_l4_icg(void *base)
+{
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	if (IS_ENABLED(CONFIG_ARCH_RTD139x)) {
+		swc_write(0xffffffff, 0x9801A000 | 0x308);
+		swc_write(0x000fe7ff, 0x9801A000 | 0x30C);
+		swc_write(0x03ff003f, 0x9801A000 | 0x310);
+	}
+#else
+	if (IS_ENABLED(CONFIG_ARCH_RTD139x)) {
+		writel(0xffffffff, base + 0x308);
+		writel(0x000fe7ff, base + 0x30C);
+		writel(0x03ff003f, base + 0x310);
+	}
+#endif
+
+	return 0;
+}
+
+static int sb2_dbg_init(struct platform_device *pdev)
+{
+	struct device_node *np;
+	int sb2_irq;
+
+	if (WARN_ON(!(pdev->dev.of_node))){
+		pr_err("[%s] Error: No node\n", DRIVER_NAME);
+		return -ENODEV;
+	}
+
+	np = pdev->dev.of_node;
+
+	iobase = of_iomap(np, 0);
+
+	sb2_irq = irq_of_parse_and_map(np, 0);
+
+	set_l4_icg(iobase);
+
+	if (!sb2_irq) {
+		pr_err("[%s] irq parse fail\n", DRIVER_NAME);
+		return -ENXIO;
+	}
+
+	if (request_irq(sb2_irq, isr_sb2_dbg, IRQF_SHARED, "sb2_dbg", pdev) != 0){
+		pr_err("[%s] irq request fail\n", DRIVER_NAME);
+		return -ENXIO;
+	}
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	pr_info("[%s] Info 0x%x\n", DRIVER_NAME, swc_read(0x9801A000 | 0x204));
+#else
+	pr_info("[%s] Info 0x%x\n", DRIVER_NAME, readl(iobase + 0x204));
+#endif
+
+	pr_info("[%s] memory monitor 0x98013b00 - 0x98013c00\n", DRIVER_NAME);
+	sb2_dbg_acpu_monitor(4, 0x98013b00, 0x98013c00, SB2_DBG_MONITOR_DATA|SB2_DBG_MONITOR_INST, SB2_DBG_MONITOR_READ|SB2_DBG_MONITOR_WRITE);
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	/* Enable SB2 interrupt */
+	swc_write(SB2_ACPU_INT_EN | SB2_SCPU_INT_EN | SB2_PCPU_INT_EN | WRITE_DATA_1, 0x9801A000 | 0x4E0);
+	swc_write(SWCIVA_INT | ACIVA_INT | SCIVA_INT | PCIVA_INT | WRITE_DATA_0 , 0x9801A000 | 0x008);
+	swc_write(SWCIVAIRQ_EN | ACIVAIRQ_EN | SCIVAIRQ_EN | PCIVAIRQ_EN | WRITE_DATA_1 | swc_read(0x9801A000 | 0x004), 0x9801A000 | 0x004);
+#else
+	/* Enable SB2 interrupt */
+	writel(SB2_ACPU_INT_EN | SB2_SCPU_INT_EN | SB2_PCPU_INT_EN | WRITE_DATA_1, SB2_DBG_INT);
+	writel(SWCIVA_INT | ACIVA_INT | SCIVA_INT | PCIVA_INT | WRITE_DATA_0 , SB2_INV_INTSTAT);
+	writel(SWCIVAIRQ_EN | ACIVAIRQ_EN | SCIVAIRQ_EN | PCIVAIRQ_EN | WRITE_DATA_1 | readl(SB2_INV_INTEN), SB2_INV_INTEN);
+#endif
+	pr_info("[%s] initialized\n", DRIVER_NAME);
+
+	return 0;
+}
+
+static int sb2_dbg_exit(struct platform_device *pdev)
+{
+	struct device_node *np;
+	int sb2_irq;
+
+	pr_info("[%s] Exit\n", DRIVER_NAME);
+
+	np = pdev->dev.of_node;
+	sb2_irq = irq_of_parse_and_map(np, 0);
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	swc_write(0x0 , 0x9801A000 | 0x4E0);
+#else
+	/* Disable  SB2 interrupt */
+	writel(0x0 , SB2_DBG_INT);
+#endif
+
+	free_irq(sb2_irq, NULL);
+
+	return 0;
+}
+
+int sb2_dbg_suspend(struct device *dev)
+{
+	pr_info("[%s] Enter\n", DRIVER_NAME);
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	swc_write(0x0 , 0x9801A000 | 0x4E0);
+#else
+	/* Disable  SB2 interrupt */
+	writel(0x0 , SB2_DBG_INT);
+#endif
+
+	pr_info("[%s] Exit\n", DRIVER_NAME);
+
+	return 0;
+}
+
+int sb2_dbg_resume(struct device *dev)
+{
+	pr_info("[%s] Resume enter\n", DRIVER_NAME);
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	/* Enable SB2 interrupt */
+	swc_write(SB2_ACPU_INT_EN | SB2_SCPU_INT_EN | SB2_PCPU_INT_EN | WRITE_DATA_1, 0x9801A000 | 0x4E0);
+	swc_write(SWCIVA_INT | ACIVA_INT | SCIVA_INT | PCIVA_INT | WRITE_DATA_0 , 0x9801A000 | 0x008);
+	swc_write(SWCIVAIRQ_EN | ACIVAIRQ_EN | SCIVAIRQ_EN | PCIVAIRQ_EN | WRITE_DATA_1 | swc_read(0x9801A000 | 0x004), 0x9801A000 | 0x004);
+#else
+	/* Enable SB2 interrupt */
+	writel(SB2_ACPU_INT_EN | SB2_SCPU_INT_EN | SB2_PCPU_INT_EN | WRITE_DATA_1, SB2_DBG_INT);
+	writel(SWCIVA_INT | ACIVA_INT | SCIVA_INT | PCIVA_INT | WRITE_DATA_0 , SB2_INV_INTSTAT);
+	writel(SWCIVAIRQ_EN | ACIVAIRQ_EN | SCIVAIRQ_EN | PCIVAIRQ_EN | WRITE_DATA_1 | readl(SB2_INV_INTEN), SB2_INV_INTEN);
+#endif
+	pr_info("[%s] Resume exit\n", DRIVER_NAME);
+
+	return 0;
+}
+
+void sb2_dbg_disable_mem_monitor(int which)
+{
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	swc_write((1 << 13) | (1 << 9) | (1 << 1), 0x9801A000 | 0x498 | (which * 4));
+#else
+	u32 *reg_ctrl = (u32 *) SB2_DBG_CTRL_REG0;
+
+	reg_ctrl += which;
+
+	writel((1 << 13) | (1 << 9) | (1 << 1), reg_ctrl);
+#endif
+}
+EXPORT_SYMBOL(sb2_dbg_disable_mem_monitor);
+
+static void sb2_dbg_set_mem_monitor(int which, u32 start, u32 end, u32 flags)
+{
+
+#ifndef CONFIG_RTK_SB2_SECURITY_DEBG
+	u32 *reg_start, *reg_end, *reg_ctrl;
+#endif
+
+	/* disable this set first */
+	sb2_dbg_disable_mem_monitor(which);
+
+#ifdef CONFIG_RTK_SB2_SECURITY_DEBG
+	swc_write(start, 0x9801A000 | 0x458 | (which * 4));
+	swc_write(end, 0x9801A000 | 0x478 | (which * 4));
+	swc_write(flags, 0x9801A000 | 0x498 | (which * 4));
+#else
+	reg_start = ((u32 *) SB2_DBG_START_REG0) + which;
+	reg_end = ((u32 *) SB2_DBG_END_REG0) + which;
+	reg_ctrl = ((u32 *) SB2_DBG_CTRL_REG0) + which;
+
+	writel(start, reg_start);
+	writel(end, reg_end);
+	writel(flags, reg_ctrl);
+#endif
+	/*
+	pr_info("sb2 0x%08x=0x%08x\n", (u32)reg_ctrl, readl(reg_ctrl));
+	pr_info("sb2 0x%08x=0x%08x\n", (u32)reg_start, readl(reg_start));
+	pr_info("sb2 0x%08x=0x%08x\n", (u32)reg_end, readl(reg_end));
+	pr_info("sb2 0x%08x=0x%08x\n", (u32)SB2_DBG_INT, readl(SB2_DBG_INT));
+	*/
+}
+
+/*
+ * which: 0~7, which register set
+ * d_i: SB2_DBG_MONITOR_DATA|SB2_DBG_MONITOR_INST
+ * r_w: SB2_DBG_MONITOR_READ|SB2_DBG_MONITOR_WRITE
+ */
+void sb2_dbg_scpu_monitor(int which, u32 start, u32 end, u32 d_i, u32 r_w)
+{
+	sb2_dbg_set_mem_monitor(which, start, end, (1 << 13) | (3 << 8) | d_i | r_w | 3);
+}
+EXPORT_SYMBOL(sb2_dbg_scpu_monitor);
+
+void sb2_dbg_acpu_monitor(int which, u32 start, u32 end, u32 d_i, u32 r_w)
+{
+	sb2_dbg_set_mem_monitor(which, start, end, (3 << 12) | (1 << 9) | d_i | r_w | 3);
+}
+EXPORT_SYMBOL(sb2_dbg_acpu_monitor);
+
+static struct dev_pm_ops sb2_pm_ops = {
+	.suspend_noirq = sb2_dbg_suspend,
+	.resume_noirq = sb2_dbg_resume,
+};
+
+static const struct of_device_id rtk_sb2_match[] = {
+	{.compatible = "Realtek,rtk-sb2"},
+	{},
+};
+
+static struct platform_driver rtk129x_sb2_driver = {
+	.probe = sb2_dbg_init,
+	.remove = sb2_dbg_exit,
+	.driver = {
+		.name = DRIVER_NAME,
+		.owner = THIS_MODULE,
+		.pm = &sb2_pm_ops,
+		.of_match_table = of_match_ptr(rtk_sb2_match),
+	},
+};
+
+static void __exit rtk_sb2_exit(void)
+{
+	platform_driver_unregister(&rtk129x_sb2_driver);
+}
+module_exit(rtk_sb2_exit);
+
+static int __init rtk_sb2_init(void)
+{
+	return platform_driver_register(&rtk129x_sb2_driver);
+}
+arch_initcall(rtk_sb2_init);
+
+MODULE_DESCRIPTION("Realtek SB2 driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtk129x-sb2");
+
diff --git a/drivers/soc/realtek/common/rtk_sb2_sem.c b/drivers/soc/realtek/common/rtk_sb2_sem.c
new file mode 100644
index 00000000..fa650a5
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_sb2_sem.c
@@ -0,0 +1,270 @@
+/*
+ * rtk_sb2_sem.c - Realtek SB2 HW semaphore API
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ * Copyright (C) 2017 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/idr.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/slab.h>
+#include <linux/spinlock.h>
+#include <linux/list.h>
+#include <linux/miscdevice.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/err.h>
+#include <soc/realtek/rtk_sb2_sem.h>
+
+
+#define SB2_SEM_TRYLOCK_MAX 1024
+#define SB2_SEM_RETRY_MAX 10
+
+struct sb2_sem {
+	int id;
+	struct list_head list;
+	struct device_node *np;
+	void __iomem *reg;
+};
+
+int sb2_sem_try_lock(struct sb2_sem *sem, unsigned int flags)
+{
+	unsigned int val;
+
+	if (IS_ERR_OR_NULL(sem))
+		return -EINVAL;
+
+	val = readl(sem->reg);
+	return val;
+
+}
+
+void sb2_sem_lock(struct sb2_sem *sem, unsigned int flags)
+{
+	int i;
+	unsigned int val;
+	int cnt  = 0;
+
+	if (IS_ERR_OR_NULL(sem))
+		return;
+
+retry:
+	for (i = 0; i < SB2_SEM_TRYLOCK_MAX; i++) {
+		val = sb2_sem_try_lock(sem, flags);
+		if (val)
+			return;
+	}
+
+	if (flags & SB2_SEM_TIMEOUT_INFINITY)
+		goto retry;
+
+	if (!(flags & SB2_SEM_NO_WARNING))
+		pr_warn("sb2-sem: trylock fail\n");
+	cnt++;
+	if (cnt < SB2_SEM_RETRY_MAX)
+		goto retry;
+
+	if (!(flags & SB2_SEM_NO_WARNING))
+		pr_warn("sb2-sem: ignore lock\n");
+}
+
+void sb2_sem_unlock(struct sb2_sem *sem)
+{
+	if (IS_ERR_OR_NULL(sem))
+		return;
+
+	writel(0, sem->reg);
+}
+
+static LIST_HEAD(sb2_list);
+static DEFINE_SPINLOCK(sb2_list_lock);
+
+struct sb2_sem *sb2_sem_get(unsigned int index)
+{
+	struct sb2_sem *sb2 = ERR_PTR(-EINVAL), *p;
+
+	spin_lock(&sb2_list_lock);
+	list_for_each_entry(p, &sb2_list, list)
+		if (!index--) {
+			sb2 = p;
+			break;
+		}
+	spin_unlock(&sb2_list_lock);
+
+	return sb2;
+}
+static struct sb2_sem *create_sb2_sem(struct device_node *np)
+{
+	struct sb2_sem *sb2;
+
+	sb2 = kzalloc(sizeof(*sb2), GFP_KERNEL);
+	if (!sb2)
+		return ERR_PTR(-ENOMEM);
+
+	sb2->np = np;
+	sb2->reg = of_iomap(np, 0);
+
+	spin_lock(&sb2_list_lock);
+	list_add_tail(&sb2->list, &sb2_list);
+	spin_unlock(&sb2_list_lock);
+
+	return sb2;
+}
+
+struct sb2_sem *sb2_sem_node_to_lock(struct device_node *np)
+{
+	struct sb2_sem *sb2 = NULL, *p;
+
+	spin_lock(&sb2_list_lock);
+	list_for_each_entry(p, &sb2_list, list)
+		if (p->np == np) {
+			sb2 = p;
+			break;
+		}
+	spin_unlock(&sb2_list_lock);
+
+	if (!sb2)
+		sb2 = create_sb2_sem(np);
+
+	return sb2;
+}
+
+static __init int init_sb2_sem(void)
+{
+	struct device_node *np;
+
+	for_each_compatible_node(np, NULL, "realtek,sb2-sem") {
+		sb2_sem_node_to_lock(np);
+	}
+	return 0;
+}
+early_initcall(init_sb2_sem);
+
+struct sb2_sem_priv {
+	int id;
+	struct sb2_sem *sem;
+	struct miscdevice mdev;
+};
+
+static DEFINE_IDR(num_idr);
+
+static int sb2_sem_open(struct inode *inode, struct file *filp)
+{
+	struct sb2_sem_priv *priv = container_of(filp->private_data,
+		struct sb2_sem_priv, mdev);
+	struct device *dev = priv->mdev.this_device;
+	int ret;
+
+	dev_dbg(dev, "%s\n", __func__);
+
+	ret = sb2_sem_try_lock(priv->sem, 0);
+
+	dev_dbg(dev, "%s: returns %d\n", __func__, ret);
+
+	return ret ? 0 : -EAGAIN;
+}
+
+static int sb2_sem_release(struct inode *inode, struct file *filp)
+{
+	struct sb2_sem_priv *priv = container_of(filp->private_data,
+		struct sb2_sem_priv, mdev);
+	struct device *dev = priv->mdev.this_device;
+
+	dev_dbg(dev, "%s\n", __func__);
+
+	sb2_sem_unlock(priv->sem);
+
+	return 0;
+}
+
+static const struct file_operations sb2_sem_fops = {
+	.owner = THIS_MODULE,
+	.open = sb2_sem_open,
+	.release = sb2_sem_release,
+};
+
+#define DEV_NAME_LENGTH 20
+
+static int sb2_sem_probe(struct platform_device *pdev)
+{
+	struct device_node *np = pdev->dev.of_node;
+	struct sb2_sem *sem;
+	struct sb2_sem_priv *priv;
+	int id;
+	int ret;
+	char name[DEV_NAME_LENGTH];
+
+	dev_info(&pdev->dev, "[SB2-SEM] %s\n", __func__);
+
+	sem = sb2_sem_node_to_lock(np);
+	if (IS_ERR(sem))
+		return PTR_ERR(sem);
+
+	priv = kzalloc(sizeof(*priv), GFP_KERNEL);
+	if (!priv)
+		return -ENOMEM;
+
+	id = of_alias_get_id(np, "hwsem");
+	if (id >= 0)
+		ret = idr_alloc(&num_idr, priv, id, id + 1, GFP_KERNEL);
+	else
+		ret = idr_alloc(&num_idr, priv, 0, 0, GFP_KERNEL);
+
+	dev_dbg(&pdev->dev, "%s: alias = %d, idr = %d\n", __func__, id, ret);
+
+	if (ret < 0)
+		goto free_priv;
+
+	snprintf(name, DEV_NAME_LENGTH, "hwsem%d", ret);
+
+	priv->id = ret;
+	priv->sem = sem;
+	priv->mdev.minor  = MISC_DYNAMIC_MINOR;
+	priv->mdev.name   = kstrdup(name, GFP_KERNEL);
+	priv->mdev.fops   = &sb2_sem_fops;
+	priv->mdev.parent = NULL;
+
+	ret = misc_register(&priv->mdev);
+	if (ret) {
+		dev_err(&pdev->dev, "%s: failed to misc_register %s: %d\n",
+			__func__, priv->mdev.name, ret);
+		goto free_idr;
+	}
+
+	return 0;
+free_idr:
+	kfree(priv->mdev.name);
+	idr_remove(&num_idr, priv->id);
+free_priv:
+	kfree(priv);
+
+	return ret;
+}
+
+static const struct of_device_id sb2_sem_ids[] = {
+	 { .compatible = "realtek,sb2-sem-dev" },
+	 {}
+};
+
+
+static struct platform_driver sb2_sem_drv = {
+	.driver = {
+		.name = "rtk-sb2-sem",
+		.owner = THIS_MODULE,
+		.of_match_table = sb2_sem_ids,
+	},
+	.probe = sb2_sem_probe,
+};
+
+static int __init sb2_sem_drv_init(void)
+{
+	return platform_driver_register(&sb2_sem_drv);
+}
+device_initcall(sb2_sem_drv_init);
+
diff --git a/drivers/soc/realtek/common/rtk_sha1.c b/drivers/soc/realtek/common/rtk_sha1.c
new file mode 100644
index 00000000..c214646
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_sha1.c
@@ -0,0 +1,381 @@
+/*
+ * rtk_sha1.c - sha1 API
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/slab.h>
+#include <linux/kernel.h>
+#include <linux/delay.h>
+#include <linux/mm.h>
+#include <asm/mutex.h>
+#include <asm/io.h>
+
+#include <soc/realtek/rtk_sha1.h>
+
+
+/*
+ * sftware base SHA1 tool
+ * porting form http://svn.ghostscript.com/jbig2dec/trunk/sha1.c
+ * jinncheng@realtek.com
+*/
+
+/*
+SHA-1 in C
+By Steve Reid <sreid@sea-to-sky.net>
+100% Public Domain
+
+-----------------
+Modified 7/98
+By James H. Brown <jbrown@burgoyne.com>
+Still 100% Public Domain
+
+Corrected a problem which generated improper hash values on 16 bit machines
+Routine SHA1Update changed from
+	void SHA1Update(SHA1_CTX* context, unsigned char* data, unsigned int
+len)
+to
+	void SHA1Update(SHA1_CTX* context, unsigned char* data, unsigned
+long len)
+
+The 'len' parameter was declared an int which works fine on 32 bit machines.
+However, on 16 bit machines an int is too small for the shifts being done
+against
+it.  This caused the hash function to generate incorrect values if len was
+greater than 8191 (8K - 1) due to the 'len << 3' on line 3 of SHA1Update().
+
+Since the file IO in main() reads 16K at a time, any file 8K or larger would
+be guaranteed to generate the wrong hash (e.g. Test Vector #3, a million
+"a"s).
+
+I also changed the declaration of variables i & j in SHA1Update to
+unsigned long from unsigned int for the same reason.
+
+These changes should make no difference to any 32 bit implementations since
+an
+int and a long are the same size in those environments.
+
+--
+I also corrected a few compiler warnings generated by Borland C.
+1. Added #include <process.h> for exit() prototype
+2. Removed unused variable 'j' in SHA1Final
+3. Changed exit(0) to return(0) at end of main.
+
+ALL changes I made can be located by searching for comments containing 'JHB'
+-----------------
+Modified 8/98
+By Steve Reid <sreid@sea-to-sky.net>
+Still 100% public domain
+
+1- Removed #include <process.h> and used return() instead of exit()
+2- Fixed overwriting of finalcount in SHA1Final() (discovered by Chris Hall)
+3- Changed email address from steve@edmweb.com to sreid@sea-to-sky.net
+
+-----------------
+Modified 4/01
+By Saul Kravitz <Saul.Kravitz@celera.com>
+Still 100% PD
+Modified to run on Compaq Alpha hardware.
+
+-----------------
+Modified 07/2002
+By Ralph Giles <giles@ghostscript.com>
+Still 100% public domain
+modified for use with stdint types, autoconf
+code cleanup, removed attribution comments
+switched SHA1Final() argument order for consistency
+use SHA1_ prefix for public api
+move public api to sha1.h
+*/
+
+/*
+Test Vectors (from FIPS PUB 180-1)
+"abc"
+  A9993E36 4706816A BA3E2571 7850C26C 9CD0D89D
+"abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"
+  84983E44 1C3BD26E BAAE4AA1 F95129E5 E54670F1
+A million repetitions of "a"
+  34AA973C D4C4DAA4 F61EEB2B DBAD2731 6534016F
+*/
+
+void SHA1_Transform(unsigned int state[5], const unsigned char buffer[64]);
+
+#define rol(value, bits) (((value) << (bits)) | ((value) >> (32 - (bits))))
+
+/* blk0() and blk() perform the initial expand. */
+/* I got the idea of expanding during the round function from SSLeay */
+/* FIXME: can we do this in an endian-proof way? */
+#ifdef WORDS_BIGENDIAN
+#define blk0(i) block->l[i]
+#else
+#define blk0(i) (block->l[i] = (rol(block->l[i],24)&0xFF00FF00)|(rol(block->l[i],8)&0x00FF00FF))
+#endif
+
+#define blk(i) (block->l[i&15] = rol( \
+			block->l[(i+13)&15]^ \
+			block->l[(i+8)&15]^ \
+			block->l[(i+2)&15]^ \
+			block->l[i&15],1) )
+
+/* (R0+R1), R2, R3, R4 are the different operations used in SHA1 */
+#define R0(v,w,x,y,z,i) z+=((w&(x^y))^y)+blk0(i)+0x5A827999+rol(v,5);w=rol(w,30);
+#define R1(v,w,x,y,z,i) z+=((w&(x^y))^y)+blk(i)+0x5A827999+rol(v,5);w=rol(w,30);
+#define R2(v,w,x,y,z,i) z+=(w^x^y)+blk(i)+0x6ED9EBA1+rol(v,5);w=rol(w,30);
+#define R3(v,w,x,y,z,i) z+=(((w|x)&y)|(w&x))+blk(i)+0x8F1BBCDC+rol(v,5);w=rol(w,30);
+#define R4(v,w,x,y,z,i) z+=(w^x^y)+blk(i)+0xCA62C1D6+rol(v,5);w=rol(w,30);
+
+#ifdef VERBOSE  /* SAK */
+	void SHAPrintContext(SHA1_CTX *context, char *msg){
+	  printk("%s (%d,%d) %x %x %x %x %x\n",
+		 msg,
+		 context->count[0], context->count[1],
+		 context->state[0],
+		 context->state[1],
+		 context->state[2],
+		 context->state[3],
+		 context->state[4]);
+	}
+#endif /* VERBOSE */
+
+/* Hash a single 512-bit block. This is the core of the algorithm. */
+void SHA1_Transform(unsigned int state[5], const unsigned char buffer[64])
+{
+	unsigned int a, b, c, d, e;
+	typedef union {
+		unsigned char c[64];
+		unsigned int l[16];
+	} CHAR64LONG16;
+	CHAR64LONG16* block;
+
+#ifdef SHA1HANDSOFF
+	static unsigned char workspace[64];
+	block = (CHAR64LONG16*)workspace;
+	memcpy(block, buffer, 64);
+#else
+	block = (CHAR64LONG16*)buffer;
+#endif
+
+	/* Copy context->state[] to working vars */
+	a = state[0];
+	b = state[1];
+	c = state[2];
+	d = state[3];
+	e = state[4];
+
+	/* 4 rounds of 20 operations each. Loop unrolled. */
+	R0(a,b,c,d,e, 0); R0(e,a,b,c,d, 1); R0(d,e,a,b,c, 2); R0(c,d,e,a,b, 3);
+	R0(b,c,d,e,a, 4); R0(a,b,c,d,e, 5); R0(e,a,b,c,d, 6); R0(d,e,a,b,c, 7);
+	R0(c,d,e,a,b, 8); R0(b,c,d,e,a, 9); R0(a,b,c,d,e,10); R0(e,a,b,c,d,11);
+	R0(d,e,a,b,c,12); R0(c,d,e,a,b,13); R0(b,c,d,e,a,14); R0(a,b,c,d,e,15);
+	R1(e,a,b,c,d,16); R1(d,e,a,b,c,17); R1(c,d,e,a,b,18); R1(b,c,d,e,a,19);
+	R2(a,b,c,d,e,20); R2(e,a,b,c,d,21); R2(d,e,a,b,c,22); R2(c,d,e,a,b,23);
+	R2(b,c,d,e,a,24); R2(a,b,c,d,e,25); R2(e,a,b,c,d,26); R2(d,e,a,b,c,27);
+	R2(c,d,e,a,b,28); R2(b,c,d,e,a,29); R2(a,b,c,d,e,30); R2(e,a,b,c,d,31);
+	R2(d,e,a,b,c,32); R2(c,d,e,a,b,33); R2(b,c,d,e,a,34); R2(a,b,c,d,e,35);
+	R2(e,a,b,c,d,36); R2(d,e,a,b,c,37); R2(c,d,e,a,b,38); R2(b,c,d,e,a,39);
+	R3(a,b,c,d,e,40); R3(e,a,b,c,d,41); R3(d,e,a,b,c,42); R3(c,d,e,a,b,43);
+	R3(b,c,d,e,a,44); R3(a,b,c,d,e,45); R3(e,a,b,c,d,46); R3(d,e,a,b,c,47);
+	R3(c,d,e,a,b,48); R3(b,c,d,e,a,49); R3(a,b,c,d,e,50); R3(e,a,b,c,d,51);
+	R3(d,e,a,b,c,52); R3(c,d,e,a,b,53); R3(b,c,d,e,a,54); R3(a,b,c,d,e,55);
+	R3(e,a,b,c,d,56); R3(d,e,a,b,c,57); R3(c,d,e,a,b,58); R3(b,c,d,e,a,59);
+	R4(a,b,c,d,e,60); R4(e,a,b,c,d,61); R4(d,e,a,b,c,62); R4(c,d,e,a,b,63);
+	R4(b,c,d,e,a,64); R4(a,b,c,d,e,65); R4(e,a,b,c,d,66); R4(d,e,a,b,c,67);
+	R4(c,d,e,a,b,68); R4(b,c,d,e,a,69); R4(a,b,c,d,e,70); R4(e,a,b,c,d,71);
+	R4(d,e,a,b,c,72); R4(c,d,e,a,b,73); R4(b,c,d,e,a,74); R4(a,b,c,d,e,75);
+	R4(e,a,b,c,d,76); R4(d,e,a,b,c,77); R4(c,d,e,a,b,78); R4(b,c,d,e,a,79);
+
+	/* Add the working vars back into context.state[] */
+	state[0] += a;
+	state[1] += b;
+	state[2] += c;
+	state[3] += d;
+	state[4] += e;
+
+	/* Wipe variables */
+	a = b = c = d = e = 0;
+}
+
+
+/* SHA1Init - Initialize new context */
+void SHA1_Init(SHA1_CTX* context)
+{
+	/* SHA1 initialization constants */
+	context->state[0] = 0x67452301;
+	context->state[1] = 0xEFCDAB89;
+	context->state[2] = 0x98BADCFE;
+	context->state[3] = 0x10325476;
+	context->state[4] = 0xC3D2E1F0;
+	context->count[0] = context->count[1] = 0;
+}
+
+
+/* Run your data through this. */
+void SHA1_Update(SHA1_CTX* context, const unsigned char * data, const size_t len)
+{
+	size_t i, j;
+
+#ifdef VERBOSE
+	SHAPrintContext(context, "before");
+#endif
+
+	j = (context->count[0] >> 3) & 63;
+	if ((context->count[0] += len << 3) < (len << 3)) {
+		context->count[1]++;
+	}
+	context->count[1] += (len >> 29);
+	if ((j + len) > 63) {
+		memcpy(&context->buffer[j], data, (i = 64-j));
+		SHA1_Transform(context->state, context->buffer);
+		for ( ; i + 63 < len; i += 64) {
+			SHA1_Transform(context->state, data + i);
+		}
+		j = 0;
+	}
+	else {
+		i = 0;
+	}
+	memcpy(&context->buffer[j], &data[i], len - i);
+
+#ifdef VERBOSE
+	SHAPrintContext(context, "after ");
+#endif
+}
+
+
+/* Add padding and return the message digest. */
+void SHA1_Final(SHA1_CTX* context, unsigned char digest[SHA1_DIGEST_SIZE])
+{
+	unsigned int i;
+	unsigned char  finalcount[8];
+
+	for (i = 0; i < 8; i++) {
+		finalcount[i] = (unsigned char)((context->count[(i >= 4 ? 0 : 1)]
+		 >> ((3-(i & 3)) * 8) ) & 255);  /* Endian independent */
+	}
+	SHA1_Update(context, (unsigned char *)"\200", 1);
+	while ((context->count[0] & 504) != 448) {
+		SHA1_Update(context, (unsigned char *)"\0", 1);
+	}
+	SHA1_Update(context, finalcount, 8);  /* Should cause a SHA1_Transform() */
+	for (i = 0; i < SHA1_DIGEST_SIZE; i++) {
+		digest[i] = (unsigned char)
+		 ((context->state[i>>2] >> ((3-(i & 3)) * 8) ) & 255);
+	}
+
+	/* Wipe variables */
+	i = 0;
+	memset(context->buffer, 0, 64);
+	memset(context->state, 0, 20);
+	memset(context->count, 0, 8);
+	memset(finalcount, 0, 8);   /* SWR */
+
+#ifdef SHA1HANDSOFF  /* make SHA1Transform overwrite its own static vars */
+	SHA1_Transform(context->state, context->buffer);
+#endif
+}
+
+int MCP_SHA1_Get_Hash(
+	unsigned char * source,
+	unsigned int source_len,
+	unsigned char * hash )
+{
+	SHA1_CTX context;
+	unsigned char digest[SHA1_DIGEST_SIZE];
+	void * tmp_buffer;
+
+	//printk(KERN_INFO "*** %s %d, source_len %d\n", __FILE__, __LINE__, source_len);
+
+	tmp_buffer = kmalloc(source_len, GFP_KERNEL);
+	if( !tmp_buffer ) {
+		printk(KERN_WARNING "%s %d, alloc memory %d faild\n", __FILE__, __LINE__, source_len);
+		return -ENOMEM;
+	}
+
+	memcpy( tmp_buffer, source, source_len );
+
+	SHA1_Init(&context);
+	SHA1_Update(&context, tmp_buffer, source_len);
+	SHA1_Final(&context, digest);
+
+	if( tmp_buffer ) {
+		kfree(tmp_buffer);
+	}
+
+	//printk(KERN_INFO "*** %s %d\n", __FILE__, __LINE__);
+
+	//MCP_SHA1_dump_hex(digest, SHA1_DIGEST_SIZE);
+
+	memcpy( hash, digest, SHA1_DIGEST_SIZE );
+
+	return 0;
+}
+
+#if 0 // sample code for SHA1
+
+void MCP_SHA1_dump_hex( unsigned char * pbuf, unsigned int len )
+{
+	int i, j;
+	printk(KERN_INFO "********************************************************************\n");
+	for( i = 0; i < len; i++ ) {
+		if( i && !( i & 0xF ) ) {
+			printk("\n");
+		}
+		printk(" %02x", pbuf[i]);
+	}
+	printk("\n");
+	printk(KERN_INFO "********************************************************************\n");
+}
+
+void MCP_Sha1_test( void )
+{
+	void * data_buffer;
+	unsigned char sha1[SHA1_DIGEST_SIZE];
+
+	data_buffer = kmalloc(32<<10, GFP_KERNEL);
+	if( !data_buffer ) {
+		printk(KERN_WARNING "%s %d, alloc memory 32K faild\n", __FILE__, __LINE__);
+		return;
+	}
+	printk(KERN_INFO "%s %d, data_buffer vaddr 0x%08x\n", __FILE__, __LINE__, (unsigned int)data_buffer);
+	printk(KERN_INFO "%s %d, data_buffer paddr 0x%08x\n", __FILE__, __LINE__, (unsigned int)__pa(data_buffer));
+
+	memset( data_buffer, '0', 32<<10 );
+
+	MCP_SHA1_Get_Hash(data_buffer, 20, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 40, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 60, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 64, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 128, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 256, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 512, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 1024, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 2048, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 4096, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 8192, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 16<<10, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+	MCP_SHA1_Get_Hash(data_buffer, 32<<10, sha1);
+	MCP_SHA1_dump_hex(sha1,SHA1_DIGEST_SIZE);
+
+	if( data_buffer ) {
+		kfree(data_buffer);
+	}
+}
+#endif
+
diff --git a/drivers/soc/realtek/common/rtk_tp.c b/drivers/soc/realtek/common/rtk_tp.c
new file mode 100644
index 00000000..4018d33
--- /dev/null
+++ b/drivers/soc/realtek/common/rtk_tp.c
@@ -0,0 +1,327 @@
+/*
+ * Realtek TP Driver
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corp.
+ *
+ * Author:
+ *   Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/miscdevice.h>
+#include <linux/slab.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/list.h>
+#include <linux/pm_runtime.h>
+#include <linux/mm.h>
+
+struct rtk_tp_device {
+	struct miscdevice     mdev;
+	struct device         *dev;
+	/* pm */
+	atomic_t              open_cnt;
+
+	struct clk            *clk_tp;
+	struct clk            *clk_tpb;
+	struct reset_control  *rstc_tp;
+	struct reset_control  *rstc_tpb;
+
+	/* map */
+	void                  *base_tp;
+	phys_addr_t           addr_tp;
+	resource_size_t       size_tp;
+	void                  *base_tpb;
+	phys_addr_t           addr_tpb;
+	resource_size_t       size_tpb;
+};
+
+struct rtk_tp_ctx {
+	struct rtk_tp_device *tpdev;
+};
+
+static int rtk_tp_open(struct inode *inode, struct file *filp)
+{
+	struct rtk_tp_device *tpdev = container_of(filp->private_data,
+						      struct rtk_tp_device,
+						      mdev);
+	struct rtk_tp_ctx *ctx;
+
+	ctx = kzalloc(sizeof(*ctx), GFP_KERNEL);
+	if (!ctx)
+		return -ENOMEM;
+	ctx->tpdev = tpdev;
+	filp->private_data = ctx;
+
+	atomic_inc(&tpdev->open_cnt);
+	pm_runtime_get_sync(tpdev->dev);
+
+	return 0;
+}
+
+static int rtk_tp_release(struct inode *inode, struct file *filp)
+{
+	struct rtk_tp_ctx *ctx = filp->private_data;
+	struct rtk_tp_device *tpdev = ctx->tpdev;
+
+	pm_runtime_put_sync(tpdev->dev);
+	atomic_dec(&tpdev->open_cnt);
+	kfree(ctx);
+	return 0;
+}
+
+static const struct vm_operations_struct rtk_tp_vm_ops = {
+#ifdef CONFIG_HAVE_IOREMAP_PROT
+	.access = generic_access_phys,
+#endif
+};
+
+static int rtk_tp_mmap(struct file *filp, struct vm_area_struct *vma)
+{
+	struct rtk_tp_ctx *ctx = filp->private_data;
+	struct rtk_tp_device *tpdev = ctx->tpdev;
+	phys_addr_t addr;
+	resource_size_t size;
+
+
+	if (vma->vm_end < vma->vm_start)
+		return -EINVAL;
+
+	if (vma->vm_pgoff == 0) {
+		addr = tpdev->addr_tp;
+		size = tpdev->size_tp;
+	} else if (vma->vm_pgoff == 1) {
+		addr = tpdev->addr_tpb;
+		size = tpdev->size_tpb;
+	} else
+		return -E2BIG;
+
+	if (addr & ~PAGE_MASK)
+		return -EINVAL;
+
+	if ((vma->vm_end - vma->vm_start) > size)
+		return -EINVAL;
+
+	vma->vm_ops = &rtk_tp_vm_ops;
+	vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+
+	return remap_pfn_range(vma,
+			       vma->vm_start,
+			       addr >> PAGE_SHIFT,
+			       vma->vm_end - vma->vm_start,
+			       vma->vm_page_prot);
+}
+
+
+static const struct file_operations rtk_tp_fops = {
+	.owner         = THIS_MODULE,
+	.open          = rtk_tp_open,
+	.release       = rtk_tp_release,
+	.mmap          = rtk_tp_mmap,
+};
+
+static void rtk_tp_power_on(struct rtk_tp_device *tpdev)
+{
+	clk_prepare_enable(tpdev->clk_tp);
+	clk_prepare_enable(tpdev->clk_tpb);
+	reset_control_deassert(tpdev->rstc_tp);
+	reset_control_deassert(tpdev->rstc_tpb);
+}
+
+static void rtk_tp_power_off(struct rtk_tp_device *tpdev)
+{
+	 reset_control_assert(tpdev->rstc_tpb);
+	 reset_control_assert(tpdev->rstc_tp);
+	 clk_disable_unprepare(tpdev->clk_tpb);
+	 clk_disable_unprepare(tpdev->clk_tp);
+}
+
+static int rtk_tp_runtime_resume(struct device *dev)
+{
+	struct rtk_tp_device *tpdev = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "enter %s\n", __func__);
+	rtk_tp_power_on(tpdev);
+	dev_dbg(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_tp_runtime_suspend(struct device *dev)
+{
+	struct rtk_tp_device *tpdev = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "enter %s\n", __func__);
+	rtk_tp_power_off(tpdev);
+	dev_dbg(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_tp_resume(struct device *dev)
+{
+	struct rtk_tp_device *tpdev = dev_get_drvdata(dev);
+
+	if (atomic_read(&tpdev->open_cnt) == 0)
+		return 0;
+
+	dev_info(dev, "enter %s\n", __func__);
+	rtk_tp_power_on(tpdev);
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_tp_suspend(struct device *dev)
+{
+	struct rtk_tp_device *tpdev = dev_get_drvdata(dev);
+
+	if (atomic_read(&tpdev->open_cnt) == 0)
+		return 0;
+
+	dev_info(dev, "enter %s\n", __func__);
+	rtk_tp_power_off(tpdev);
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_tp_pm_ops = {
+	.runtime_suspend = rtk_tp_runtime_suspend,
+	.runtime_resume  = rtk_tp_runtime_resume,
+	.suspend         = rtk_tp_suspend,
+	.resume          = rtk_tp_resume,
+};
+
+static int rtk_tp_probe(struct platform_device *pdev)
+{
+	struct rtk_tp_device *tpdev;
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	int ret;
+	struct resource res;
+
+	tpdev = devm_kzalloc(dev, sizeof(*tpdev), GFP_KERNEL);
+	if (!tpdev)
+		return -ENOMEM;
+
+	tpdev->dev = dev;
+
+	/* get tp resources */
+	tpdev->clk_tp = devm_clk_get(dev, "tp");
+	if (IS_ERR(tpdev->clk_tp)) {
+		ret = PTR_ERR(tpdev->clk_tp);
+		dev_err(dev, "tp: failed to get clk: %d\n", ret);
+		return ret;
+	}
+
+	tpdev->rstc_tp = devm_reset_control_get(dev, "tp");
+	if (IS_ERR(tpdev->rstc_tp)) {
+		ret = PTR_ERR(tpdev->rstc_tp);
+		dev_err(dev, "tp: failed to get reset_control: %d\n", ret);
+		return ret;
+	}
+
+	ret = of_address_to_resource(np, 0, &res);
+	if (ret) {
+		dev_err(dev, "tp: failed to get address: %d\n", ret);
+		return ret;
+	}
+
+	tpdev->addr_tp = res.start;
+	tpdev->size_tp = ALIGN(resource_size(&res), PAGE_SIZE);
+	tpdev->base_tp = devm_ioremap(dev, res.start, resource_size(&res));
+	if (!tpdev->base_tp) {
+		dev_err(dev, "tp: failed to ioremap\n");
+		return -ENOMEM;
+	}
+
+	/* get tpb resources */
+	tpdev->clk_tpb = devm_clk_get(dev, "tpb");
+	if (IS_ERR(tpdev->clk_tpb)) {
+		ret = PTR_ERR(tpdev->clk_tpb);
+		dev_err(dev, "tpb: failed to get clk: %d\n", ret);
+		return ret;
+	}
+
+	tpdev->rstc_tpb = devm_reset_control_get(dev, "tpb");
+	if (IS_ERR(tpdev->rstc_tpb)) {
+		ret = PTR_ERR(tpdev->rstc_tpb);
+		dev_err(dev, "tpb: failed to get reset_control: %d\n", ret);
+		return ret;
+	}
+
+	ret = of_address_to_resource(np, 1, &res);
+	if (ret) {
+		dev_err(dev, "tpb: failed to get address: %d\n", ret);
+		return ret;
+	}
+	tpdev->addr_tpb = res.start;
+	tpdev->size_tpb = ALIGN(resource_size(&res), PAGE_SIZE);
+	tpdev->base_tpb = devm_ioremap(dev, res.start, resource_size(&res));
+	if (!tpdev->base_tpb) {
+		dev_err(dev, "tpb: failed to ioremap\n");
+		return -ENOMEM;
+	}
+
+	atomic_set(&tpdev->open_cnt, 0);
+	tpdev->mdev.minor  = MISC_DYNAMIC_MINOR;
+	tpdev->mdev.name   = "tp";
+	tpdev->mdev.fops   = &rtk_tp_fops;
+	tpdev->mdev.parent = dev;
+	ret = misc_register(&tpdev->mdev);
+	if (ret) {
+		dev_err(dev, "failed to register misc device: %d\n", ret);
+		return ret;
+	}
+
+	platform_set_drvdata(pdev, tpdev);
+	pm_runtime_set_suspended(dev);
+	pm_runtime_enable(dev);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static int rtk_tp_remove(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct rtk_tp_device *tpdev = platform_get_drvdata(pdev);
+
+	pm_runtime_disable(dev);
+	platform_set_drvdata(pdev, NULL);
+	misc_deregister(&tpdev->mdev);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+
+static const struct of_device_id rtk_tp_ids[] = {
+	{ .compatible = "realtek,tp" },
+	{}
+};
+
+static struct platform_driver rtk_tp_driver = {
+	.probe = rtk_tp_probe,
+	.remove = rtk_tp_remove,
+	.driver = {
+		.owner = THIS_MODULE,
+		.name = "rtk-tp",
+		.of_match_table = rtk_tp_ids,
+		.pm = &rtk_tp_pm_ops,
+
+	},
+};
+module_platform_driver(rtk_tp_driver);
diff --git a/drivers/soc/realtek/rtd119x/Kconfig b/drivers/soc/realtek/rtd119x/Kconfig
new file mode 100644
index 00000000..3b5f63f
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/Kconfig
@@ -0,0 +1,18 @@
+comment "RTD119X Device Drivers"
+
+menu "Realtek NAS support"
+	depends on ARCH_RTD119X
+
+config SENDFILE_PATCH
+	bool "Reverse sendfile patch"
+	default n
+	help
+	Use patched sendfile syscall to improve write performance on NAS.
+
+endmenu
+
+config SCPU_SRAMCTL_RTD119X
+	bool "SCPU Wraper SRAM Control"
+	default y if ARCH_RTD119X
+
+source "drivers/soc/realtek/rtd119x/rtk_ve/Kconfig"
diff --git a/drivers/soc/realtek/rtd119x/Makefile b/drivers/soc/realtek/rtd119x/Makefile
new file mode 100644
index 00000000..b0ad704
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/Makefile
@@ -0,0 +1,7 @@
+obj-$(CONFIG_ARCH_RTD119X)		+= rtd119x_restart.o
+obj-$(CONFIG_HOTPLUG_CPU)		+= rtd119x_hotplug.o
+obj-$(CONFIG_ARCH_RTD119X)		+= rtk_chip.o
+obj-$(CONFIG_ARCH_RTD119X)		+= rtk_usb.o
+obj-$(CONFIG_SUSPEND)			+= rtd119x_suspend.o rtd119x_resume.o rtd119x_ip_power.o
+obj-$(CONFIG_RTK_CODEC)			+= rtk_ve/
+obj-$(CONFIG_SCPU_SRAMCTL_RTD119X)      += rtd119x_scpu_sramctl.o
diff --git a/drivers/soc/realtek/rtd119x/avcpu.h b/drivers/soc/realtek/rtd119x/avcpu.h
new file mode 100644
index 00000000..f52ade5
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/avcpu.h
@@ -0,0 +1,193 @@
+#ifndef _LINUX_AVCPU_H
+#define _LINUX_AVCPU_H
+
+#include <generated/autoconf.h>
+#include <linux/module.h>
+#include <linux/kernel.h>
+
+#define AUDIO_CPU               1
+#define VIDEO_CPU_1             2
+#define VIDEO_CPU_2             3
+
+#define AUDIO_ENTRY_ADDR        (PAGE_OFFSET+0xe0)
+#define VIDEO_ENTRY_ADDR_1      (PAGE_OFFSET+0xe4)
+#define VIDEO_ENTRY_ADDR_2      (PAGE_OFFSET+0xdc)
+
+#define AVCPU_MAJOR             241
+
+#define AVCPU_SUSPEND           100
+#define AVCPU_RESUME            101
+#define AVCPU_RESET_PREPARE     102
+#define AVCPU_RESET_DONE        103
+
+#define AVSTAT_NORMAL   0
+#define AVSTAT_SUSPEND  1
+#define AVSTAT_RESUME   2
+#define AVSTAT_RESETAV  3
+
+#define FW_DESC_TABLE_V1_T_VERSION_1            0x1
+#define FW_DESC_TABLE_V1_T_VERSION_11           0x11
+#define FW_DESC_TABLE_V1_T_VERSION_21           0x21
+
+int register_avcpu_notifier(struct notifier_block *nb);
+int unregister_avcpu_notifier(struct notifier_block *nb);
+
+int resetav_lock(int is_suspend);
+int resetav_unlock(int is_suspend);
+
+int load_av_image(char *, unsigned int, char *, unsigned int, char *, unsigned int);
+
+typedef enum {
+    FW_TYPE_RESERVED = 0,
+    FW_TYPE_BOOTCODE,
+    FW_TYPE_KERNEL,
+    FW_TYPE_RESCUE_DT,
+    FW_TYPE_KERNEL_DT,
+    FW_TYPE_RESCUE_ROOTFS,
+    FW_TYPE_KERNEL_ROOTFS,
+    FW_TYPE_AUDIO,
+    FW_TYPE_AUDIO_FILE,
+    FW_TYPE_VIDEO_FILE,
+    FW_TYPE_EXT4,
+    FW_TYPE_UBIFS,
+    FW_TYPE_SQUASH,
+    FW_TYPE_EXT3,
+    FW_TYPE_ODD,
+    FW_TYPE_YAFFS2,
+    FW_TYPE_ISO,
+    FW_TYPE_SWAP,
+    FW_TYPE_NTFS,
+    FW_TYPE_JFFS2,
+    FW_TYPE_IMAGE_FILE,
+    FW_TYPE_VIDEO,
+    FW_TYPE_VIDEO2,
+    FW_TYPE_ECPU,
+    FW_TYPE_UNKNOWN
+} fw_type_code_t;
+
+typedef enum {
+    RTK_PLAT_ERR_OK = 0,
+    RTK_PLAT_ERR_PARSE_FW_DESC,
+    RTK_PLAT_ERR_READ_FW_IMG,
+    RTK_PLAT_ERR_READ_KERNEL_IMG,
+    RTK_PLAT_ERR_READ_RESCUE_IMG,
+    RTK_PLAT_ERR_BOOT,
+} rtk_plat_err_t;
+
+typedef enum {
+    FS_TYPE_JFFS2 = 0,
+    FS_TYPE_YAFFS2,
+    FS_TYPE_SQUASH,
+    FS_TYPE_RAWFILE,
+    FS_TYPE_EXT4,
+    FS_TYPE_UBIFS,
+    FS_TYPE_NONE,
+    FS_TYPE_UNKOWN
+} rtk_part_fw_type_t;
+
+typedef struct {
+    char            *audio_image;
+    unsigned int        audio_start;
+    char            *video_image_1;
+    unsigned int        video_start_1;
+    char            *video_image_2;
+    unsigned int        video_start_2;
+} resetav_struct;
+
+typedef struct {
+    unsigned int    timeout; //in ms
+    int             status;
+} status_struct;
+
+typedef struct {
+    wait_queue_head_t   status_wq;
+    int                 status;
+} avcpu_info;
+
+typedef struct {
+    u8          signature[8];
+    u32         checksum;
+    u8          version;    //0x00
+    u8          reserved[15];
+    u32         length;
+} __attribute__((packed)) fw_desc_table_t;
+
+typedef struct {
+    u8          signature[8];
+    u32         checksum;
+    u8          version;    //0x01
+    u8          reserved[7];
+    u32         paddings;
+    u32         part_list_len;
+    u32         fw_list_len;
+} __attribute__((packed)) fw_desc_table_v1_t;
+
+typedef struct {
+    u8          type;
+    u8          reserved:7,
+                ro:1;
+    u64         length;
+    u8          fw_count;
+    u8          fw_type;
+    //#ifdef CONFIG_SYS_RTK_EMMC_FLASH
+#if 1
+    u8   emmc_partIdx;
+    u8   reserved_1[3];
+#else
+    u8   reserved_1[4];
+#endif
+    u8          mount_point[32];
+} __attribute__((packed)) part_desc_entry_v1_t;
+
+typedef struct {
+    u8          type;
+    u8          reserved:6,
+                lzma:1,
+                ro:1;
+    u32         version;
+    u32         target_addr;
+    u32         offset;
+    u32         length;
+    u32         paddings;
+    u32         checksum;
+    u8          reserved_1[6];
+} __attribute__((packed)) fw_desc_entry_v1_t;
+
+typedef struct {
+    fw_desc_entry_v1_t  v1;
+    u32         act_size;
+    u8          hash[32];
+    u8          part_num;
+    u8          reserved[27];
+} __attribute__((packed)) fw_desc_entry_v11_t;
+
+typedef struct {
+    fw_desc_entry_v1_t v1;
+    u32         act_size;
+    u8          part_num;
+    u8          RSA_sign[256];
+    u8          reserved[27];
+} __attribute__((packed)) fw_desc_entry_v21_t;
+
+/*
+ * Ioctl definitions
+ */
+
+/* Use 'c' as magic number */
+#define AVCPU_IOC_MAGIC  'c'
+
+/*
+ * S means "Set"                : through a ptr,
+ * T means "Tell"               : directly with the argument value
+ * G means "Get"                : reply by setting through a pointer
+ * Q means "Query"              : response is on the return value
+ * X means "eXchange"           : G and S atomically
+ * H means "sHift"              : T and Q atomically
+ */
+#define AVCPU_IOCTRESET     _IOW(AVCPU_IOC_MAGIC, 1, resetav_struct)
+#define AVCPU_IOCTSTOP      _IO(AVCPU_IOC_MAGIC, 2)
+#define AVCPU_IOCTSTART     _IO(AVCPU_IOC_MAGIC, 3)
+#define AVCPU_IOCGSTATUS    _IOR(AVCPU_IOC_MAGIC, 4, status_struct)
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd119x/include/color.h b/drivers/soc/realtek/rtd119x/include/color.h
new file mode 100644
index 00000000..63b9d40
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/include/color.h
@@ -0,0 +1,28 @@
+#ifndef __COLOR_H__
+#define __COLOR_H__
+
+#define NONE			"\033[m"
+#define RED				"\033[0;32;31m"
+#define LIGHT_RED		"\033[1;31m"
+#define GREEN			"\033[0;32;32m"
+#define LIGHT_GREEN		"\033[1;32m"
+#define BLUE			"\033[0;32;34m"
+#define LIGHT_BLUE		"\033[1;34m"
+#define DARY_GRAY		"\033[1;30m"
+#define CYAN			"\033[0;36m"
+#define LIGHT_CYAN		"\033[1;36m"
+#define PURPLE			"\033[0;35m"
+#define LIGHT_PURPLE	"\033[1;35m"
+#define BROWN			"\033[0;33m"
+#define YELLOW			"\033[1;33m"
+#define LIGHT_GRAY		"\033[0;37m"
+#define WHITE			"\033[1;37m"
+
+#define ATTR_OFF		"\033[0m"
+#define BOLD			"\033[1m"
+#define UNDERSCORE		"\033[4m"
+#define BLINK			"\033[5m"
+#define REVERSE			"\033[7m"
+#define CONCEALED		"\033[8m"
+
+#endif /* __COLOR_H__ */
diff --git a/drivers/soc/realtek/rtd119x/include/debug.h b/drivers/soc/realtek/rtd119x/include/debug.h
new file mode 100644
index 00000000..47b28fd
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/include/debug.h
@@ -0,0 +1,34 @@
+#ifndef __DEBUG_RTK_H__
+#define __DEBUG_RTK_H__
+
+#include "color.h"
+
+#define dbg_fmt(fmt) fmt
+
+#define dbg_err(fmt, ...) \
+	printk(KERN_ERR RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_emerg(fmt, ...) \
+	printk(KERN_EMERG RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_alert(fmt, ...) \
+	printk(KERN_ALERT RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_crit(fmt, ...) \
+	printk(KERN_CRIT RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_warning(fmt, ...) \
+	printk(KERN_WARNING RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_warn dbg_warning
+
+#define dbg_info(fmt, ...) \
+	printk(KERN_INFO CYAN dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_notice(fmt, ...) \
+	printk(KERN_NOTICE CYAN dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_cont(fmt, ...) \
+	printk(KERN_CONT CYAN fmt NONE"\n", ##__VA_ARGS__)
+
+#endif /* __DEBUG_RTK_H__ */
diff --git a/drivers/soc/realtek/rtd119x/include/reg_sb2.h b/drivers/soc/realtek/rtd119x/include/reg_sb2.h
new file mode 100644
index 00000000..682f671
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/include/reg_sb2.h
@@ -0,0 +1,78 @@
+#ifndef _REG_SB2_H_INCLUDED_
+#define _REG_SB2_H_INCLUDED_
+
+#define SB2_OFFSET		0x0001A000
+
+#define	CHIP_ID			0x00000200
+#define CHIP_REV		0x00000204
+
+#define RBUS_SB2_BASE_PHYS	(RBUS_BASE_PHYS + SB2_OFFSET)
+#define RBUS_SB2_PHYS(pa)	(RBUS_BASE_PHYS + SB2_OFFSET + pa)
+
+#define SB2_IO_ADDR(pa)		(IOMEM(RBUS_BASE_VIRT) + SB2_OFFSET + pa)
+
+#define get_cpu_id()		readl(SB2_IO_ADDR(CHIP_ID))
+#define get_cpu_revision()	readl(SB2_IO_ADDR(CHIP_REV))
+
+#define is_revinfo_0		(get_cpu_revision()==0x00000000)
+#define is_revinfo_1		(get_cpu_revision()==0x00010000)
+#define is_revinfo_2		(get_cpu_revision()==0x00020000)
+
+#define SB2_INV_INTEN		(iobase + 0x004)
+#define SB2_INV_INTSTAT		(iobase + 0x008)
+#define SB2_INV_ADDR		(iobase + 0x00c)
+
+#define SWCIVAIRQ_EN		(1<<6)
+#define ACIVAIRQ_EN		(1<<3)
+#define SCIVAIRQ_EN             (1<<1)
+
+#define SWCIVA_INT		(1<<4)
+#define ACIVA_INT		(1<<3)
+#define SCIVA_INT		(1<<1)
+
+#define WRITE_DATA_1		(1<<0)
+#define WRITE_DATA_0		(0<<0)
+
+#define SB2_DBG_START_REG0	(iobase + 0x458)
+#define SB2_DBG_START_REG1	(iobase + 0x45c)
+#define SB2_DBG_START_REG2	(iobase + 0x460)
+#define SB2_DBG_START_REG3	(iobase + 0x464)
+#define SB2_DBG_START_REG4	(iobase + 0x468)
+#define SB2_DBG_START_REG5	(iobase + 0x46c)
+#define SB2_DBG_START_REG6	(iobase + 0x470)
+#define SB2_DBG_START_REG7	(iobase + 0x474)
+
+#define SB2_DBG_END_REG0	(iobase + 0x478)
+#define SB2_DBG_END_REG1	(iobase + 0x47c)
+#define SB2_DBG_END_REG2	(iobase + 0x480)
+#define SB2_DBG_END_REG3	(iobase + 0x484)
+#define SB2_DBG_END_REG4	(iobase + 0x488)
+#define SB2_DBG_END_REG5	(iobase + 0x48c)
+#define SB2_DBG_END_REG6	(iobase + 0x490)
+#define SB2_DBG_END_REG7	(iobase + 0x494)
+
+#define SB2_DBG_CTRL_REG0	(iobase + 0x498)
+#define SB2_DBG_CTRL_REG1	(iobase + 0x49c)
+#define SB2_DBG_CTRL_REG2	(iobase + 0x4a0)
+#define SB2_DBG_CTRL_REG3	(iobase + 0x4a4)
+#define SB2_DBG_CTRL_REG4	(iobase + 0x4a8)
+#define SB2_DBG_CTRL_REG5	(iobase + 0x4ac)
+#define SB2_DBG_CTRL_REG6	(iobase + 0x4b0)
+#define SB2_DBG_CTRL_REG7	(iobase + 0x4b4)
+#define SB2_DBG_ADDR_AUDIO	(iobase + 0x4b8)
+#define SB2_DBG_ADDR_SYSTEM	(iobase + 0x4c0)
+#define SB2_DBG_ADDR1		(iobase + 0x4c8)
+#define SB2_DBG_INT		(iobase + 0x4E0)
+
+#define SB2_DBG_MONITOR_DATA	((1<<4)|(1<<2))
+#define SB2_DBG_MONITOR_INST	((1<<4)|(1<<3))
+#define SB2_DBG_MONITOR_READ	((1<<7)|(1<<5))
+#define SB2_DBG_MONITOR_WRITE	((1<<7)|(1<<6))
+
+//SB2_DBG_INT
+#define SB2_ACPU_INT_EN		(1<<9)
+#define SB2_SCPU_INT_EN		(1<<7)
+#define SB2_ACPU_NEG_INT_EN	(1<<3)
+#define SB2_SCPU_NEG_INT_EN	(1<<1)
+
+#endif
diff --git a/drivers/soc/realtek/rtd119x/rtd119x_hotplug.c b/drivers/soc/realtek/rtd119x/rtd119x_hotplug.c
new file mode 100644
index 00000000..736e049
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtd119x_hotplug.c
@@ -0,0 +1,77 @@
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/smp.h>
+
+#include <asm/cacheflush.h>
+#include <asm/cp15.h>
+#include <asm/smp_plat.h>
+
+static inline void cpu_enter_lowpower(void)
+{
+    unsigned int v;
+
+    asm volatile(
+        "	mrc p15, 0, %0, c1, c0, 0\n"
+        "	bic	%0, %0, %1\n"
+        "	mcr	p15, 0, %0, c1, c0, 0\n"
+        : "=&r" (v)
+        : "Ir" (CR_C)
+        : "cc");
+
+    flush_cache_louis();
+
+    asm volatile(
+        /*
+        * Turn off coherency
+        */
+        "	mrc	p15, 0, %0, c1, c0, 1\n"
+        "	bic	%0, %0, %1\n"
+        "	mcr	p15, 0, %0, c1, c0, 1\n"
+        : "=&r" (v)
+        : "Ir" (0x40)
+        : "cc");
+
+    isb();
+    dsb();
+}
+
+static inline void cpu_leave_lowpower(void)
+{
+    unsigned int v;
+
+    asm volatile(
+        "mrc	p15, 0, %0, c1, c0, 0\n"
+        "	orr	%0, %0, %1\n"
+        "	mcr	p15, 0, %0, c1, c0, 0\n"
+        "	mrc	p15, 0, %0, c1, c0, 1\n"
+        "	orr	%0, %0, %2\n"
+        "	mcr	p15, 0, %0, c1, c0, 1\n"
+        : "=&r" (v)
+        : "Ir" (CR_C), "Ir" (0x40)
+        : "cc");
+}
+
+static inline void platform_do_lowpower(unsigned int cpu)
+{
+    for (;;) {
+        /*
+         * here's the WFI
+         */
+        asm("wfi"
+            :
+            :
+            : "memory", "cc");
+        if (pen_release == cpu_logical_map(cpu)) {
+            break;
+        }
+        pr_debug("CPU%u: spurious wakeup call\n", cpu);
+    }
+}
+
+void __ref rtk119x_cpu_die(unsigned int cpu)
+{
+    cpu_enter_lowpower();
+    platform_do_lowpower(cpu);
+
+    cpu_leave_lowpower();
+}
diff --git a/drivers/soc/realtek/rtd119x/rtd119x_ip_power.c b/drivers/soc/realtek/rtd119x/rtd119x_ip_power.c
new file mode 100755
index 00000000..2ecf8af
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtd119x_ip_power.c
@@ -0,0 +1,389 @@
+#include <linux/pm.h>
+#include <linux/suspend.h>
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/cpu.h>
+#include <linux/delay.h>
+
+#include <asm/io.h>
+#include <asm/system_misc.h>
+//#include "include/reg.h"
+
+#define RTK_VIRT_ADDR_MAP(addr) (RBUS_BASE_VIRT + ((unsigned int)addr - RBUS_BASE_PHYS))
+//#define WRITE_REG_INT32U(addr,val)  *(volatile unsigned int *) RTK_VIRT_ADDR_MAP(addr) = (unsigned int)(val)
+#define WRITE_REG_INT32U(addr,val)  writel(val, IOMEM(RTK_VIRT_ADDR_MAP(addr)))
+//#define READ_REG_INT32U(addr)       *(volatile unsigned int *) RTK_VIRT_ADDR_MAP(addr)
+#define READ_REG_INT32U(addr)       readl(IOMEM(RTK_VIRT_ADDR_MAP(addr)))
+#define rtd_outl(addr,val)          WRITE_REG_INT32U(addr,val)
+#define _sync(x)
+
+__maybe_unused static int debug    = 1;
+__maybe_unused static int warning  = 1;
+__maybe_unused static int info     = 1;
+#define dprintk(msg...) if (debug)   { printk(KERN_DEBUG    "D/IP_POWER: " msg); }
+#define eprintk(msg...) if (1)       { printk(KERN_ERR      "E/IP_POWER: " msg); }
+#define wprintk(msg...) if (warning) { printk(KERN_WARNING  "W/IP_POWER: " msg); }
+#define iprintk(msg...) if (info)    { printk(KERN_INFO     "I/IP_POWER: " msg); }
+
+typedef enum {
+    ip_on = 0,
+    ip_off,
+} ip_state_t;
+
+void rtd_clearbits(unsigned int addr,unsigned int mask)
+{
+    unsigned int temp = READ_REG_INT32U(addr);
+    WRITE_REG_INT32U(addr,(temp & ~mask));
+}
+
+void rtd_setbits(unsigned int addr,unsigned int mask)
+{
+    unsigned int temp = READ_REG_INT32U(addr);
+    WRITE_REG_INT32U(addr,(temp | mask));
+}
+
+int VideoDAC_A_power(ip_state_t state)
+{
+    int err = 1;
+    if (state == ip_off) {
+        dprintk("VideoDAC_A off\n");
+        //rtd_clearbits(0x18018200,0x780000);       //A~C
+        rtd_clearbits(0x180183a0,0xc0000000);   //current DAC disable
+        //rtd_outl(0x180188bc,0x7);             //power down
+        err = 0;
+    } else if (state == ip_on) {
+        dprintk("VideoDAC_A on\n");
+        rtd_setbits(0x180183a0,0xc0000000);   //current DAC disable
+        err = 0;
+    } else {
+        eprintk("[%s] %d\n",__func__,__LINE__);
+    }
+    return err;
+}
+
+int AudioDAC_power(ip_state_t state)
+{
+    int err = 1;
+    if (state == ip_off) {
+        dprintk("AudioDAC off\n");
+        //Turn off Audio DAC
+        rtd_outl(0x18006604,0xaaa00);           //AO DAC power down
+        _sync();
+        rtd_clearbits(0x18000010,0xe0000);      //Audio DAC (da,mod,codec) clock disable
+        err = 0;
+    } else if (state == ip_on) {
+        dprintk("AudioDAC on\n");
+        rtd_setbits(0x18000010,0xe0000);        //clock enable
+        err = 0;
+    } else {
+        eprintk("[%s] %d\n",__func__,__LINE__);
+    }
+    return err;
+}
+
+int AVCPU_power(ip_state_t state)
+{
+#if 1
+    return 0;
+#else
+    int err = 1;
+    if (state == ip_off) {
+        rtd_setbits(0x18007030,(BIT(2)|BIT(3)));
+        err = 0;
+    } else if (state == ip_on) {
+        unsigned int temp = READ_REG_INT32U(0x18007030);
+        temp &= ~BIT(2);
+        temp |= BIT(3);
+        WRITE_REG_INT32U(0x18007030,temp);
+        err = 0;
+    } else {
+        eprintk("[%s] %d\n",__func__,__LINE__);
+    }
+    return err;
+#endif
+}
+
+/**********************************************************************/
+void SDIO_power_off(void)
+{
+	dprintk("SDIO off\n");
+	//Turn off SDIO (clock from USB)
+	rtd_clearbits(0x18000004,0x1000);				//SDIO reset
+	rtd_clearbits(0x1800000c,0x44000000);	//SDIO/SDIO_IP clock disable
+}
+
+void GSPI_power_off(void)
+{
+	dprintk("GSPI off\n");
+	//Turn off GSPI
+	rtd_clearbits(0x18000000,0x8);				//GSPI reset
+	rtd_clearbits(0x1800000c,0x8);				//GSPI clock disable
+}
+
+void eMMC_power_off(void)
+{
+	dprintk("eMMC off\n");
+	//Turn off eMMC
+	rtd_clearbits(0x18000004,0x800);			//eMMC reset
+	rtd_clearbits(0x1800000c,0x11000000);	//eMMC/eMMC_IP clock disable
+	rtd_clearbits(0x180001f4,0x1);				//eMMC clock disable
+}
+
+void CardReader_power_off(void)
+{
+	dprintk("CardReader off\n");
+	//Turn off Card Reader
+	rtd_clearbits(0x18000004,0x400);			//Card Reader reset
+	rtd_clearbits(0x1800000c,0x82000000);	//Card Reader/SD_IP clock disable
+	rtd_clearbits(0x180001e4,0x1);				//Card Reader clock disable
+}
+
+void CP_RNG_power_off(void)
+{
+	dprintk("CP_RNG off\n");
+	//Turn off CP, RNG
+	rtd_clearbits(0x18000000,0x2000000);	//CP reset
+	rtd_clearbits(0x1800000c,0x80000);	//CP clock disable
+	rtd_clearbits(0x18000000,0x2);				//RNG reset
+}
+
+void MD_power_off(void)
+{
+	dprintk("MD off\n");
+	//Turn off MD
+	rtd_clearbits(0x18000000,0x4000000);	//MD reset
+	rtd_clearbits(0x1800000c,0x100000);		//MD clock disable
+}
+
+void AE_power_off(void)
+{
+	dprintk("AE off\n");
+	//Turn off AE
+	rtd_clearbits(0x18000000,0x10000000);	//AE reset
+}
+
+void VCPU_VE1_VE2_GPU_power_off(void)
+{
+	dprintk("VCPU_VE1_VE2_GPU off\n");
+	//Turn off VCPU VE1,VE2,GPU
+	rtd_clearbits(0x18000000,0x60000);		//VE1 264.JPEG reset
+	rtd_clearbits(0x1800000c,0x3000);			//VE1 264.JPEG clock disable
+	rtd_clearbits(0x18000000,0x20);				//VE2 265 reset
+	rtd_clearbits(0x1800000c,0x20000000);	//VE2 265 clock disable
+	rtd_outl(0x18000118,0x00000004);		//VCPU PLL off
+	rtd_clearbits(0x18000000,0x00010000);	//GPU reset
+	rtd_clearbits(0x1800000c,0x00000800);	//GPU clock disable
+	rtd_setbits(0x180001c4,0x4);					//GPU PLL off
+}
+
+void VO_TVE_power_off(void)
+{
+	dprintk("VO_TVE off\n");
+	//Turn off display VO, TVE
+	rtd_clearbits(0x18000000,0x100000);		//VO reset
+	rtd_clearbits(0x1800000c,0x8000);			//VO clock disable
+	rtd_clearbits(0x18000000,0x80000);		//TVE reset
+	rtd_clearbits(0x1800000c,0x4000);			//TVE clock disable
+	rtd_outl(0x18000180,0x4);				//Display SD2 (DDSB)PLL off 432
+	//rtd_clearbits(0x18000128)=0x00000004		//Display SD1(DDSA) PLL can't turn off 432 (NAND Cardreader)
+}
+
+void VideoDAC_A_power_off(void)
+{
+	dprintk("VideoDAC_A off\n");
+	//Turn off Video DAC A
+	//rtd_clearbits(0x18018200,0x780000);		//A~C
+	rtd_clearbits(0x180183a0,0xc0000000);	//current DAC disable
+	//rtd_outl(0x180188bc,0x7);				//power down
+}
+
+void TP_power_off(void)
+{
+	dprintk("TP off\n");
+	//Turn off TP
+	rtd_clearbits(0x18000000,0x8000000);	//TP reset
+	rtd_clearbits(0x1800000c,0x200000);		//TP clock disable
+}
+
+void SE_power_off(void)
+{
+	dprintk("SE off\n");
+	//Turn off SE
+	rtd_clearbits(0x18000000,0x400000);		//SE reset
+	rtd_clearbits(0x1800000c,0x20000);		//SE clock disable
+}
+
+void HDMITx_power_off(void)
+{
+	dprintk("HDMITx/MHLTx off\n");
+	//Turn off HDMI Tx
+	rtd_clearbits(0x18000000,0x1000);			//HDMI Tx reset
+	rtd_clearbits(0x1800000c,0x100);			//HDMI Tx clock disable
+	rtd_clearbits(0x18000010,0x100000);		//AO for HDMI clock disable
+	rtd_outl(0x18000190,0x0);				//HDMI Tx MAC,PHY power down
+	rtd_clearbits(0x18007088,0xc);		//AO for HDMI clock disable
+}
+
+void Audio_I2S_power_off(void)
+{
+	dprintk("Audio_I2S off\n");
+	//Turn off Audio I2S in/out
+	rtd_clearbits(0x18000010,0xc00000);		//I2S clock disable
+}
+
+void AudioDAC_power_off(void)
+{
+	dprintk("AudioDAC off\n");
+	//Turn off Audio DAC
+	rtd_outl(0x18006604,0xaaa00);		//AO DAC power down
+	_sync();
+	rtd_clearbits(0x18000010,0xe0000);		//Audio DAC (da,mod,codec) clock disable
+}
+
+void SPDIF_power_off(void)
+{
+	dprintk("SPDIF off\n");
+	//Turn off SPDIF
+	rtd_clearbits(0x18000010,0x200000);		//SPDIF
+}
+
+void HDMIRx_power_off(void)
+{
+	dprintk("HDMIRx/MHLRx off\n");
+	//Turn off HDMI Rx (flow PLL?)
+	rtd_clearbits(0x18000000,0x800);			//HDMI Rx reset
+	rtd_clearbits(0x1800000c,0x2);				//HDMI Rx clock disable
+}
+
+void LVDS_power_off(void)
+{
+	dprintk("LVDS off\n");
+	//Turn off LVDS (flow, PLL?)
+	rtd_clearbits(0x18000000,0x200000);	//LVDS reset
+	rtd_clearbits(0x1800000c,0x10000);		//LVDS clock disable
+	rtd_setbits(0x18000024,0x420000);	//LVDS clock selection PLLLVDS
+}
+
+void MIPI_power_off(void)
+{
+	dprintk("MIPI off\n");
+	//Turn off MIPI
+	rtd_clearbits(0x18000000,0x40000000);//MIPI reset
+	rtd_clearbits(0x1800000c,0x8000000);	//MIPI clock disable
+}
+
+void LSADC_power_off(void)
+{
+	dprintk("LSADC off\n");
+	//Turn off LSADC
+	rtd_outl(0x1801bc28,0x0);					//LSADC power down
+}
+
+void ALL_AV_power_off(void)
+{
+	dprintk("all AV off\n");
+	//Turn off all AV
+	rtd_clearbits(0x18000000,0x8000);			//AIO reset
+	rtd_clearbits(0x1800000c,0x400);			//AIO clock disable
+}
+//ISO	block
+
+void ETN_power_off(void)
+{
+	dprintk("ETN off\n");
+	//Turn off ETN & PHY
+	rtd_clearbits(0x18007088,0x600);			//ISO ETN ISO reset
+	rtd_clearbits(0x1800708c,0x1800);			//ISO ETN clock disable
+	rtd_clearbits(0x18000000,0x4000);			//CRT ETN reset
+	rtd_clearbits(0x1800000c,0x200);			//CRT ETN clock disable
+	rtd_outl(0x1800705c,0x0);				//ISO APHY/DPHY isolation
+	rtd_outl(0x18007074,0x09d81153);	//Turn off PLL_ETN
+}
+
+void VFD_power_off(void)
+{
+	dprintk("VFD off\n");
+	//Turn off VFD
+	rtd_clearbits(0x18007088,0x1);				//ISO VFD ISO reset
+	rtd_clearbits(0x1800708c,0x2);				//ISO VFD clock disable
+}
+
+void CBUS_power_off(void)
+{
+	dprintk("CBUS off\n");
+	//Turn off CBUS
+	rtd_clearbits(0x18007088,0x2060);			//ISO CBUS reset
+	rtd_clearbits(0x1800708c,0x78);				//ISO CBUS clock disable
+}
+
+void CEC_power_off(void)
+{
+	dprintk("CEC off\n");
+	//Turn off CEC
+	rtd_clearbits(0x18007088,0xc);			//ISO CEC reset
+	rtd_clearbits(0x1800708c,0x4);				//ISO CEC clock disable
+}
+
+void IR_power_off(void)
+{
+	rtd_clearbits(0x18007088,0x2);				//ISO IR reset
+}
+
+/**********************************************************************/
+
+int rtk_ip_power_off(void)
+{
+    int err = 0;
+    err = VideoDAC_A_power(ip_off);
+    if (err) goto ERROR;
+    err = AudioDAC_power(ip_off);
+    /* Test to power down*/
+    // HDMITx_power_off();
+    // HDMIRx_power_off();
+    // SDIO_power_off();
+    // GSPI_power_off();
+    // eMMC_power_off();
+    // CardReader_power_off();
+    // CP_RNG_power_off();
+    // MD_power_off();
+    // AE_power_off();
+    // VCPU_VE1_VE2_GPU_power_off();
+    // VO_TVE_power_off();
+    // TP_power_off();
+    // SE_power_off();
+    // Audio_I2S_power_off();
+    // SPDIF_power_off();
+    // LVDS_power_off();
+    // MIPI_power_off();
+    // LSADC_power_off();
+    // ALL_AV_power_off();
+    // ETN_power_off();
+    // VFD_power_off();
+    // CBUS_power_off();
+    // CEC_power_off();
+    // IR_power_off();
+ERROR:
+    return err;
+}
+
+int rtk_ip_power_on(void)
+{
+    int err = 0;
+    err = VideoDAC_A_power(ip_on);
+    if (err) goto ERROR;
+    err = AudioDAC_power(ip_on);
+ERROR:
+    return err;
+}
+
+void rtk_cpu_power_up(int cpu)
+{
+	return 0;
+}
+EXPORT_SYMBOL(rtk_cpu_power_up);
+
+void rtk_cpu_power_down(int cpu)
+{
+	return 0;
+}
+EXPORT_SYMBOL(rtk_cpu_power_down);
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd119x/rtd119x_ip_power.h b/drivers/soc/realtek/rtd119x/rtd119x_ip_power.h
new file mode 100644
index 00000000..81f418b
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtd119x_ip_power.h
@@ -0,0 +1,5 @@
+#ifndef __RTK_IP_POWER_H__
+#define __RTK_IP_POWER_H__
+int rtk_ip_power_off(void);
+int rtk_ip_power_on(void);
+#endif
diff --git a/drivers/soc/realtek/rtd119x/rtd119x_restart.c b/drivers/soc/realtek/rtd119x/rtd119x_restart.c
new file mode 100644
index 00000000..0845d09
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtd119x_restart.c
@@ -0,0 +1,129 @@
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/delay.h>
+
+#include <asm/io.h>
+#include <asm/system_misc.h>
+
+static void __iomem * wdt_base;
+static int wdt_oe;
+static void __iomem * rst_ctrl_base;
+unsigned int rst_ctrl_reg_offset = 0;
+
+#define WDT_CLR		4
+#define WDT_CTL		0
+#define WDT_OVERFLOW	0xC
+#define WDT_NMI         8
+#define WDT_RSTB_CNT	0x40
+#define WDT_OE		0x44
+
+#define RESET_MAGIC	0xAABBCC00
+
+typedef enum{
+	RESET_ACTION_NO_ACTION = 0,
+	RESET_ACTION_FASTBOOT,
+	RESET_ACTION_ABNORMAL = 0xff,
+}RESET_ACTION;
+
+static void setup_restart_action(RESET_ACTION action)
+{
+	unsigned int reset_action = RESET_MAGIC;
+
+	if (!rst_ctrl_base) {
+		pr_err("%s, Skip set reset action\n", __func__);
+		return;
+	}
+
+	switch (action) {
+		case RESET_ACTION_FASTBOOT:
+			reset_action |= RESET_ACTION_FASTBOOT;
+			break;
+		default:
+			break;
+	}
+
+	writel(reset_action, rst_ctrl_base + rst_ctrl_reg_offset);
+}
+
+void rtk_machine_restart(char mode, const char *cmd)
+{
+	if (cmd) {
+		if (!strncmp("bootloader", cmd, 11)) {
+			setup_restart_action(RESET_ACTION_FASTBOOT);
+		} else {
+			setup_restart_action(RESET_ACTION_NO_ACTION);
+		}
+	} else {
+		setup_restart_action(RESET_ACTION_NO_ACTION);
+	}
+
+	if (wdt_oe >= 0)
+		writel(wdt_oe, wdt_base + WDT_OE);
+
+	writel(0x00800000, wdt_base + WDT_RSTB_CNT);
+	writel(BIT(0), wdt_base + WDT_CLR);
+	writel(0x00800000, wdt_base + WDT_OVERFLOW);
+	writel(0x000000FF, wdt_base + WDT_CTL);
+	while (1)
+		mdelay(100);
+}
+
+static struct of_device_id rtk_restart_ids[] = {
+	{.compatible = "Realtek,rtk-watchdog", .data = rtk_machine_restart},
+	{}
+};
+
+static struct of_device_id rtk_reset_control_ids[] = {
+	{.compatible = "Realtek,rtk-rstctrl"},
+	{}
+};
+
+static int rtk_setup_restart(void)
+{
+	const struct of_device_id *of_id;
+	struct device_node *np;
+
+	/* setup Watchdog */
+	np = of_find_matching_node(NULL, rtk_restart_ids);
+	if (WARN(!np, "Unable to setup watchdog restart"))
+		return 1;
+
+	wdt_base = of_iomap(np, 0);
+	WARN(!wdt_base, "failed to map IO base for watchdog");
+
+	if (of_property_read_u32_index(np, "rst-oe", 0, &wdt_oe))
+		wdt_oe = -1;
+
+	of_id = of_match_node(rtk_restart_ids, np);
+	WARN(!of_id, "restart not available");
+
+	arm_pm_restart = of_id->data;
+
+#ifdef CONFIG_ARCH_RTD129X
+	/* setup Reset Control */
+	np = of_find_matching_node(NULL, rtk_reset_control_ids);
+	if (WARN(!np, "Unable to setup reset-control"))
+		return 1;
+
+	rst_ctrl_base = of_iomap(np, 0);
+	WARN(!rst_ctrl_base, "failed to map IO base for reset-control");
+
+	if (of_property_read_u32_index(np, "rst-reg-offset", 0, &rst_ctrl_reg_offset)) {
+		pr_err("reset-control rst-reg-offset not defined");
+		rst_ctrl_base = NULL;
+		return 1;
+	}
+
+	printk("rst-control : base %p, offset 0x%x\n", rst_ctrl_base, rst_ctrl_reg_offset);
+	setup_restart_action(RESET_ACTION_ABNORMAL);
+
+#endif
+	return 0;
+}
+
+arch_initcall(rtk_setup_restart);
diff --git a/drivers/soc/realtek/rtd119x/rtd119x_resume.S b/drivers/soc/realtek/rtd119x/rtd119x_resume.S
new file mode 100644
index 00000000..d192fa6
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtd119x_resume.S
@@ -0,0 +1,9 @@
+#include <linux/linkage.h>
+#include <linux/init.h>
+#include <asm/asm-offsets.h>
+#include <asm/hardware/cache-l2x0.h>
+
+ENTRY(v7_cpu_resume)
+    bl  v7_invalidate_l1
+    b   cpu_resume
+ENDPROC(v7_cpu_resume)
diff --git a/drivers/soc/realtek/rtd119x/rtd119x_scpu_sramctl.c b/drivers/soc/realtek/rtd119x/rtd119x_scpu_sramctl.c
new file mode 100644
index 00000000..24e1b59
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtd119x_scpu_sramctl.c
@@ -0,0 +1,210 @@
+/*
+ * Pheonix SCPU wrapper SRAM control
+ *
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ * Copyright (C) 2018 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#include <linux/cpufreq.h>
+#include <linux/device.h>
+#include <linux/io.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/regulator/consumer.h>
+#include <linux/slab.h>
+
+#define SRAM_RME      0x480
+#define SRAM_RM       0x484
+#define L2_SRAM_RME   0x48c
+#define L2_SRAM_RM    0x490
+
+struct scpu_sramctl_data {
+	struct device *dev;
+	void *base;
+	struct notifier_block volt_trans_nb;
+	struct notifier_block freq_trans_nb;
+	int cpu;
+	int new_freq;
+	int old_volt;
+};
+
+static void scpu_sramctl_rm_init(struct scpu_sramctl_data *sscd)
+{
+	dev_dbg(sscd->dev, "%s\n", __func__);
+	writel(0x01111111, sscd->base + SRAM_RM);
+	writel(0x00000011, sscd->base + L2_SRAM_RM);
+}
+
+static void scpu_sramctl_rm_enable(struct scpu_sramctl_data *sscd)
+{
+	dev_dbg(sscd->dev, "%s\n", __func__);
+	writel(0x0000007f, sscd->base + SRAM_RME);
+	writel(0x00000003, sscd->base + L2_SRAM_RME);
+}
+
+static void scpu_sramctl_rm_diable(struct scpu_sramctl_data *sscd)
+{
+	dev_dbg(sscd->dev, "%s\n", __func__);
+	writel(0x00000000, sscd->base + SRAM_RME);
+	writel(0x00000000, sscd->base + L2_SRAM_RME);
+}
+
+/*
+ *  using cpufreq/regulator to record freq/volt change
+ *
+ *  event order:
+ *    CPUFREQ_PRECHANGE
+ *    REGULATOR_EVENT_PRE_VOLTAGE_CHANGE
+ *    CPUFREQ_POSTCHANGE
+ */
+
+static int scpu_sramctl_freq_notifier(struct notifier_block *nb,
+	unsigned long action, void *data)
+{
+	struct scpu_sramctl_data *sscd = container_of(nb,
+		struct scpu_sramctl_data, freq_trans_nb);
+	struct cpufreq_freqs *freqs = data;
+	int new_freq;
+	int old_volt;
+
+	switch (action) {
+	case CPUFREQ_PRECHANGE:
+		sscd->new_freq = freqs->new;
+
+		/* save the cpu id, to prevent multiple postchange */
+		sscd->cpu = freqs->cpu;
+		break;
+
+	case CPUFREQ_POSTCHANGE:
+		if (freqs->cpu != sscd->cpu)
+			return NOTIFY_DONE;
+
+		new_freq = freqs->new;
+		old_volt = sscd->old_volt;
+
+		/* clear saved voltage */
+		sscd->old_volt = 0;
+
+		dev_dbg(sscd->dev, "%s: cpu%d: new_freq=%d, old_volt=%d\n",
+			__func__, freqs->cpu, new_freq, old_volt);
+		if (new_freq > 450000 && old_volt == 900000)
+			scpu_sramctl_rm_diable(sscd);
+		break;
+
+	default:
+		return NOTIFY_DONE;
+	}
+	return NOTIFY_OK;
+}
+
+static int scpu_sramctl_volt_notifier(struct notifier_block *nb,
+	unsigned long action, void *data)
+{
+	struct scpu_sramctl_data *sscd = container_of(nb,
+		struct scpu_sramctl_data, volt_trans_nb);
+	struct pre_voltage_change_data *vdata = data;
+	int new_freq;
+	int new_volt;
+
+	if (action != REGULATOR_EVENT_PRE_VOLTAGE_CHANGE)
+		return NOTIFY_DONE;
+
+	sscd->old_volt = vdata->old_uV;
+
+	new_freq = sscd->new_freq;
+	new_volt = vdata->min_uV;
+	dev_dbg(sscd->dev, "%s: new_freq=%d, new_volt=%d\n",
+		__func__, new_freq, new_volt);
+	if (new_freq < 450000 && new_volt == 900000)
+		scpu_sramctl_rm_enable(sscd);
+
+	return NOTIFY_OK;
+}
+
+static struct scpu_sramctl_data *sscdp;
+
+int scpu_sramctl_init(struct device *dev)
+{
+	struct scpu_sramctl_data *sscd;
+	struct regulator *supply;
+	int ret;
+
+	BUG_ON(sscdp != NULL);
+	sscd = kzalloc(sizeof(*sscd), GFP_KERNEL);
+	if (!sscd)
+		return -ENOMEM;
+
+	sscd->dev = dev;
+	sscd->volt_trans_nb.notifier_call = scpu_sramctl_volt_notifier;
+	sscd->freq_trans_nb.notifier_call = scpu_sramctl_freq_notifier;
+	sscd->base = of_iomap(dev->of_node, 0);
+	if (!sscd->base) {
+		ret = -ENOMEM;
+		goto free_sscd;
+	}
+
+	supply = regulator_get_optional(dev, "cpu");
+	if (IS_ERR(supply)) {
+		ret = PTR_ERR(supply);
+		goto unmap;
+	}
+	regulator_register_notifier(supply, &sscd->volt_trans_nb);
+	regulator_put(supply);
+
+	cpufreq_register_notifier(&sscd->freq_trans_nb,
+		CPUFREQ_TRANSITION_NOTIFIER);
+
+	sscdp = sscd;
+	scpu_sramctl_rm_init(sscd);
+	return 0;
+unmap:
+	iounmap(sscd->base);
+free_sscd:
+	kfree(sscd);
+
+	return ret;
+}
+
+int scpu_sramctl_fini(struct device *dev)
+{
+	struct scpu_sramctl_data *sscd = sscdp;
+	struct regulator *supply;
+
+	if (!sscd)
+		return -EINVAL;
+	cpufreq_unregister_notifier(&sscd->freq_trans_nb,
+		CPUFREQ_TRANSITION_NOTIFIER);
+	supply = regulator_get_optional(dev, "cpu");
+	regulator_unregister_notifier(supply, &sscd->volt_trans_nb);
+	regulator_put(supply);
+	iounmap(sscd->base);
+	kfree(sscd);
+	sscdp = NULL;
+	return 0;
+}
+
+static int scpu_sramctl_probe(struct platform_device *pdev)
+{
+	dev_info(&pdev->dev, "%s\n", __func__);
+	return scpu_sramctl_init(&pdev->dev);
+}
+
+static struct of_device_id scpu_sramctl_ids[] = {
+	{ .compatible = "realtek,scpu-sramctl" },
+	{}
+};
+
+static struct platform_driver scpu_sramctl_driver = {
+	.probe  = scpu_sramctl_probe,
+	.driver = {
+		.name   = "rtd119x-scpu-sramctl",
+		.of_match_table = scpu_sramctl_ids,
+	},
+};
+module_platform_driver(scpu_sramctl_driver);
+
diff --git a/drivers/soc/realtek/rtd119x/rtd119x_suspend.c b/drivers/soc/realtek/rtd119x/rtd119x_suspend.c
new file mode 100755
index 00000000..e532ccd
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtd119x_suspend.c
@@ -0,0 +1,1370 @@
+#include <linux/pm.h>
+#include <linux/suspend.h>
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/cpu.h>
+#include <linux/delay.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+#include <linux/reboot.h>
+#include <linux/clocksource.h>
+#include <linux/clockchips.h>
+#include <linux/cpu_pm.h>
+#include <linux/vmalloc.h>
+#include <linux/tick.h>
+#include <linux/slab.h>
+//#include <mach/gpio.h>
+#include <asm/io.h>
+#include <asm/system_misc.h>
+#include <asm/cacheflush.h>
+#include <asm/psci.h>
+#include <asm/suspend.h>
+
+#include "rtd119x_ip_power.h"
+#include "rtd119x_suspend.h"
+
+__maybe_unused static int   debug               = 1;
+__maybe_unused static int   warning             = 1;
+__maybe_unused static int   info                = 1;
+
+static int                  suspend_version     = 2;
+static enum _suspend_mode   suspend_mode        = SUSPEND_TO_COOLBOOT;
+#if 1 // legacy
+static int                  wifi_gpio           = -1;
+#endif
+
+unsigned int pm_state;
+
+/*
+wakelock count mode:
+0: original mode
+1: deep sleep mode
+*/
+unsigned int pm_wakelock_mode;
+
+/*
+ * some sync mechanism between kernel suspend
+ * and android wakelock control
+ */
+unsigned int pm_block_wakelock;
+
+extern void rtk119x_prepare_cpus(unsigned int max_cpus);
+extern void rtk_clocksource_suspend(void);
+extern void rtk_clocksource_resume(void);
+extern int arch_timer_suspend(void);
+extern void arch_timer_resume(void);
+
+extern volatile void __iomem *rpc_ringbuf_base;
+extern volatile void __iomem *rpc_common_base;
+
+#define dprintk(msg...) if (debug)   { printk(KERN_DEBUG    "D/SUSPEND: " msg); }
+#define eprintk(msg...) if (1)       { printk(KERN_ERR      "E/SUSPEND: " msg); }
+#define wprintk(msg...) if (warning) { printk(KERN_WARNING  "W/SUSPEND: " msg); }
+#define iprintk(msg...) if (info)    { printk(KERN_INFO     "I/SUSPEND: " msg); }
+
+#define SUSPEND_VERSION_MASK(v)     ((v&0xffff) << 16)
+#define BT_WAKEUP_IGPIO(n)	        (0x1 << n)//n:0 to 20
+#define RTK_VIRT_ADDR_MAP(addr)     (RBUS_BASE_VIRT + ((unsigned int)addr - RBUS_BASE_PHYS))
+#define WRITE_REG_INT32U(addr,val)  writel(val, IOMEM(RTK_VIRT_ADDR_MAP(addr)))
+
+static void hexdump(char *note, unsigned char *buf, unsigned int len)
+{
+	if (debug) {
+		printk(KERN_CRIT "%s\n", note);
+		print_hex_dump(KERN_CONT, "", DUMP_PREFIX_OFFSET,
+				16, 1,
+				buf, len, false);
+	}
+}
+
+void acpu_set_flag(uint32_t flag)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	writel(__cpu_to_be32(SUSPEND_VERSION_MASK(suspend_version)), &(ipc->suspend_mask));
+    if (suspend_version == 1)
+        writel(__cpu_to_be32(flag), &(ipc->suspend_flag));
+    else
+        writel(__cpu_to_be32(flag | AUTHOR_MASK(AUTHOR_SCPU)), &(ipc->suspend_flag));
+}
+
+void notify_acpu(enum _notify_flag flag)
+{
+    switch (flag) {
+        case NOTIFY_SUSPEND_TO_RAM:
+        case NOTIFY_SUSPEND_TO_COOLBOOT:
+        case NOTIFY_SUSPEND_TO_WFI:
+            if (suspend_version == 1) {
+                acpu_set_flag(0x000018ff); //suspend
+                return;
+            }
+            break;
+        case NOTIFY_RESUME_PLATFORM:
+            if (suspend_version == 1) {
+                acpu_set_flag(0x00000000);
+                return;
+            }
+            break;
+        default:
+            break;
+    }
+    if (suspend_version == 1)
+        return;
+    acpu_set_flag(NOTIFY_MASK(flag));
+}
+
+void acpu_set_bt_wakeup_host(int igpio_num,bool active_high)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+	dprintk("%s: igpio_num(%d) active_level(%u)\n",__func__,igpio_num,active_high);
+	if(active_high)
+		writel(__cpu_to_be32(0xEA800000|BT_WAKEUP_IGPIO(igpio_num)), &(ipc->bt_wakeup_flag));
+	else
+		writel(__cpu_to_be32(0xEA000000|BT_WAKEUP_IGPIO(igpio_num)), &(ipc->bt_wakeup_flag));
+}
+
+#define rtk_suspend_shm_func(_name, _offset, _def)                                  \
+void rtk_suspend_##_name##_set(unsigned int val)                                    \
+{                                                                                   \
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;             \
+    writel(__cpu_to_be32(SUSPEND_MAGIC_MASK | _def##_MASK(val)), &(ipc->_offset));   \
+}                                                                                   \
+unsigned int rtk_suspend_##_name##_get(void)                                        \
+{                                                                                   \
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;             \
+    unsigned int val = __be32_to_cpu(readl(&(ipc->_offset)));                       \
+    if (SUSPEND_MAGIC_GET(val) != SUSPEND_MAGIC_KEY) {                              \
+        eprintk("[%s] Error! val = 0x%08x\n", __func__, val);                       \
+        return -1;                                                                  \
+    }                                                                               \
+    return _def##_GET(val);                                                         \
+}
+
+rtk_suspend_shm_func(wakeup_flags,                  suspend_wakeup_flag,                WAKEUP_FLAGS);
+rtk_suspend_shm_func(resume_state,                  acpu_resume_state,                  RESUME_STATE);
+rtk_suspend_shm_func(resume_data,                   acpu_resume_state,                  RESUME_DATA);
+rtk_suspend_shm_func(gpio_wakeup_en,                gpio_wakeup_enable,                 GPIO_WAKEUP_EN);
+rtk_suspend_shm_func(gpio_wakeup_act,               gpio_wakeup_activity,               GPIO_WAKEUP_ACT);
+rtk_suspend_shm_func(gpio_output_change_en,         gpio_output_change_enable,          GPIO_OUTPUT_CHANGE_EN);
+rtk_suspend_shm_func(gpio_output_change_act,        gpio_output_change_activity,        GPIO_OUTPUT_CHANGE_ACT);
+rtk_suspend_shm_func(timer_sec,                     audio_reciprocal_timer_sec,         AUDIO_RECIPROCAL_TIMER);
+
+static int suspend_mode_stored = 0;
+
+int rtk_set_suspend_mode(const char *buf, int *n)
+{
+    const char *p;
+    int len;
+    int ret = 0;
+    char *mode = "mem\n";
+
+    p = memchr(buf, '\n', *n);
+    len = p ? p - buf : *n;
+
+    if (strncmp(buf, "standby", len) == 0) {
+        pr_debug("[RTD119x_PM] GET state = standby\n");
+        pr_debug("[RTD119x_PM] SET state = mem, suepend_mode = wfi\n");
+        suspend_mode = SUSPEND_TO_WFI;
+        mode = NULL;
+    } else if (strncmp(buf, "sleep", len) == 0) {
+        pr_debug("[RTD119x_PM] GET state = sleep\n");
+        pr_debug("[RTD119x_PM] SET state = mem, suepend_mode = ram\n");
+        suspend_mode = SUSPEND_TO_RAM;
+    } else if (strncmp(buf, "off", len) == 0) {
+         pr_debug("[RTD119x_PM] GET state = off\n");
+         pr_debug("[RTD119x_PM] SET state = mem, suepend_mode = coolboot\n");
+        suspend_mode = SUSPEND_TO_COOLBOOT;
+    } else if (strncmp(buf, "mem", len) == 0) {
+        if (suspend_mode_stored) {
+            pr_info("[RTD119x_PM] GET state = mem, suepend_mode = %s\n", rtk_suspend_states[suspend_mode]);
+            pr_info("[RTD119x_PM] compatible mode: suepend_mode will be reset AFTER THIS SUSPEND\n");
+        } else {
+            pr_debug("[RTD119x_PM] GET state = mem\n");
+            pr_debug("[RTD119x_PM] SET state = mem, suepend_mode = ram\n");
+            suspend_mode = SUSPEND_TO_RAM;
+        }
+    } else
+        return 0;
+
+    suspend_mode_stored = 0;
+
+    if (mode) {
+        *n = strlen(mode);
+        strncpy((char *)buf, mode, *n);
+    }
+
+    return ret;
+}
+EXPORT_SYMBOL(rtk_set_suspend_mode);
+
+int rtk_suspend_wakeup_etn(void)
+{
+    void __iomem * reg;
+
+    /* Release reset */
+    reg = IOMEM(RTK_VIRT_ADDR_MAP(0x18000000));
+    writel(readl(reg) | BIT(14), reg);
+
+    __delay(100);
+
+    /* Turn on clock */
+    reg = IOMEM(RTK_VIRT_ADDR_MAP(0x1800000c));
+    writel(readl(reg) | BIT(9), reg);
+
+    return 0;
+}
+
+int rtk_suspend_wakeup_acpu(void)
+{
+    WRITE_REG_INT32U(0x1801a138, 0x00000000);
+    __delay(1000);
+    WRITE_REG_INT32U(0x18000328, 0x00000008);
+    WRITE_REG_INT32U(0x18000320, 0x0000ace7);
+    WRITE_REG_INT32U(0x18000328, 0x0000000c);
+    __delay(1000);
+    return 0;
+}
+
+struct _memory_verified_handle {
+    unsigned char * memAddress;
+    size_t memByte;
+};
+
+typedef struct _memory_verified_handle * memory_verified_handle_t;
+
+unsigned char memory_verified_datagen(int i)
+{
+    return (unsigned char) (i & 0xff);
+}
+
+struct _memory_verified_handle * memory_verified_handle_create(size_t byte)
+{
+    int i;
+    struct _memory_verified_handle * handle =
+        (struct _memory_verified_handle *) kmalloc(sizeof(struct _memory_verified_handle), GFP_KERNEL);
+
+    if (!handle)
+        return NULL;
+
+    /*
+     * > 32KB : vmalloc
+     * < 32KB : kmalloc
+     */
+    if (byte > 0x8000)
+        handle->memAddress = (char *) vmalloc(byte);
+    else
+        handle->memAddress = (char *) kmalloc(byte, GFP_KERNEL);
+
+    if (!handle->memAddress) {
+        kfree(handle);
+        return NULL;
+    }
+
+    for (i=0; i<byte; i++)
+        handle->memAddress[i] = memory_verified_datagen(i);
+
+    handle->memByte = byte;
+
+    return handle;
+}
+
+int memory_verified_release(struct _memory_verified_handle * handle)
+{
+    int ret = 0,i;
+    if (!handle) {
+        eprintk("[%s] handle is NULL!!!\n",__func__);
+        return -1;
+    }
+
+    if (!handle->memByte) {
+        ret = -2;
+        eprintk("[%s] handle %p (memByte = %ld, memAddress = 0x%08x)\n",
+                __func__, (void *) handle, (long int) handle->memByte, (unsigned int) handle->memAddress);
+        if (handle->memAddress)
+            goto free1;
+        else
+            goto free0;
+    }
+
+    for (i=0; i < handle->memByte; i++) {
+        unsigned char data = memory_verified_datagen(i);
+        if (handle->memAddress[i] != data) {
+            eprintk("[%s] handle %p memAddress[0x%x] => 0x%x != 0x%x (%ld bytes at 0x%08x)\n",
+                    __func__, (void *) handle, i, handle->memAddress[i], data,
+                    (long int) handle->memByte, (unsigned int) handle->memAddress);
+            ret = -4;
+#if 0
+            {
+                unsigned int startByte = (i & ~0xfUL);
+                unsigned int sizeByte = 0xf0;
+                if ((startByte + sizeByte) > handle->memByte)
+                    sizeByte = handle->memByte - startByte;
+                eprintk("memory phyAddt 0x%08x\n", virt_to_phys(&handle->memAddress[i]));
+                hexdump("memory verified error\n", &handle->memAddress[startByte], sizeByte);
+            }
+#endif
+        }
+
+    }
+
+#if 1
+    if (ret == -4) {
+        eprintk("memory phyAddt 0x%08x\n", virt_to_phys(handle->memAddress))
+        hexdump("memory verified error\n", handle->memAddress, handle->memByte);
+    }
+#endif
+
+free1:
+    kfree(handle->memAddress);
+free0:
+    kfree(handle);
+
+    return ret;
+}
+
+int rtk_suspend_valid(suspend_state_t state)
+{
+    return state == PM_SUSPEND_MEM;
+}
+
+static int notrace rtk_iso_suspend(unsigned long param)
+{
+    enum _suspend_mode mode = (enum _suspend_mode)param;
+
+    // TEDTED
+    //arch_timer_suspend();
+
+    iprintk("[%s] flush cache...\n", __func__);
+    flush_cache_all();                  
+    outer_flush_all();
+    //outer_disable();
+
+    dsb_sev();
+
+    iprintk("[%s] Ready to suspend! (mode:%d)", __func__, mode);
+    if (mode == SUSPEND_TO_COOLBOOT)
+        notify_acpu(NOTIFY_SUSPEND_TO_COOLBOOT);
+    else if (mode == SUSPEND_TO_RAM)
+        notify_acpu(NOTIFY_SUSPEND_TO_RAM);
+    else {
+        eprintk("[%s] Suspend Mode Not Support : %d\n",__func__,mode);
+        BUG();
+    }
+
+    //v7_exit_coherency_flush(louis);
+
+    {
+        int MaxCounter = 100,i = 0;
+        for (i=MaxCounter; i>0; i--) {
+            __delay(10000000);
+            //asm("WFI");
+        }
+    }
+
+    BUG();
+
+    return  -EINVAL;
+}
+
+enum irq_report_state {
+    IRQ_REPORT_PREPARE,
+    IRQ_REPORT_PRINT,
+};
+
+static void rtk_suspend_irq_report(enum irq_report_state state)
+{
+    int i;
+    static unsigned int data [32];
+    void __iomem * interrupt_state = IOMEM(0xff011200);
+
+    switch (state) {
+        case IRQ_REPORT_PREPARE:
+            for (i=0;i <32; i++)
+                data[i] = *(volatile unsigned int *)(interrupt_state + (i * 4));
+            break;
+        case IRQ_REPORT_PRINT:
+            for (i=0;i <32; i++) {
+                unsigned int temp = 
+                    *(volatile unsigned int *)(interrupt_state + (i * 4));
+                if (temp != data[i]) {
+                    int j,irq = i * 32;
+                    wprintk("[%s] Interrupt Addr:0x%08x State: 0x%08x => 0x%08x\n",
+                            __func__, (unsigned int)(interrupt_state + (i*4)),
+                            data[i], temp);
+                    for (j=0; j<32; j++) {
+                        unsigned int mask = 0x1U << j;
+                        if (mask & temp)
+                            wprintk("[%s] IRQ: %d\n",__func__,(irq+j));
+                    }
+                }
+            }
+            break;
+        default:
+            eprintk("[%s] Unknow CMD! %d\n", __func__, state);
+    }
+}
+
+static int rtk_suspend_to_wfi(void)
+{
+    notify_acpu(NOTIFY_SUSPEND_TO_WFI);
+
+    rtk_suspend_irq_report(IRQ_REPORT_PREPARE);
+
+    iprintk("[%s] wait for interrupt...............\n", __func__);
+    asm("WFI");
+
+    rtk_suspend_irq_report(IRQ_REPORT_PRINT);
+
+    return 0;
+}
+
+static int rtk_suspend_to_ram(void)
+{
+    const int  MEM_VERIFIED_CNT = 20;
+    int ret = 0, i;
+    memory_verified_handle_t mem_vhandle[MEM_VERIFIED_CNT];
+    void __iomem * resumeAddr   = IOMEM(RTK_VIRT_ADDR_MAP(ISO_DUMMY1));
+    unsigned int ISODummy1Data  = readl(resumeAddr);
+
+    iprintk("[%s] cpu resume vaddr:0x%08x paddr:0x%08x\n", __func__,
+            (unsigned int)v7_cpu_resume,(unsigned int)virt_to_phys(v7_cpu_resume));
+
+    hexdump("v7_cpu_resume", (unsigned char *) v7_cpu_resume, 0x100);
+    writel(virt_to_phys(v7_cpu_resume), resumeAddr);
+
+    BUG_ON(!irqs_disabled());
+
+    cpu_pm_enter();
+
+#ifdef CONFIG_ARM_ARCH_TIMER
+    
+    //TEDTED
+    //rtk_clocksource_suspend();
+	//clocksource_suspend();
+    //clockevents_suspend();
+    //arch_timer_suspend();
+#endif
+
+    for (i=0; i<MEM_VERIFIED_CNT; i++)
+        mem_vhandle[i] = memory_verified_handle_create(0x4000);
+
+    rtk_suspend_irq_report(IRQ_REPORT_PREPARE);
+
+    ret = cpu_suspend((unsigned long)SUSPEND_TO_RAM, rtk_iso_suspend);
+
+    if (ret)
+        return ret;
+
+    /* Restore iso dummy data */
+    writel(ISODummy1Data, resumeAddr);
+
+    //writel(0xFFFFFFFE, IOMEM(0xfe007008));
+    writel(readl(IOMEM(0xfe007418)) | BIT(0), IOMEM(0xfe007418));
+    writel(readl(IOMEM(0xfe007410)) & ~BIT(10), IOMEM(0xfe007410));
+
+#ifdef CONFIG_ARM_ARCH_TIMER
+    
+    // TEDTED
+    //arch_timer_resume();
+    //rtk_clocksource_resume();
+    writel(0x1, IOMEM(0xff018000));
+#endif
+
+    rtk_suspend_irq_report(IRQ_REPORT_PRINT);
+
+    rtk_suspend_wakeup_acpu();
+    rtk_suspend_wakeup_etn();
+
+    writel(readl(IOMEM(0xfe01d100)) & ~BIT(5), IOMEM(0xfe01d100));		// wrap_a7 issue nCORERESET
+    //mcpm_cpu_powered_up();
+
+    cpu_pm_exit();
+    //clockevents_resume();
+	//clocksource_resume();
+
+    rtk119x_prepare_cpus(NR_CPUS);
+    outer_resume();
+
+    iprintk("[%s] resume memory verifying ... state 0\n", __func__);
+    for (i=0; i<MEM_VERIFIED_CNT; i++)
+        memory_verified_release(mem_vhandle[i]);
+
+
+    iprintk("[%s] resume memory verifying ... state 1\n", __func__);
+    for (i=0; i<MEM_VERIFIED_CNT; i++)
+        mem_vhandle[i] = memory_verified_handle_create(0x4000);
+
+    for (i=0; i<MEM_VERIFIED_CNT; i++)
+        memory_verified_release(mem_vhandle[i]);
+
+	dsb_sev();
+    return ret;
+}
+
+static int rtk_suspend_to_coolboot(void)
+{
+    int ret = 0;
+    ret = cpu_suspend((unsigned long)SUSPEND_TO_COOLBOOT, rtk_iso_suspend);
+    return ret;
+}
+
+void rtk_suspend_gpip_output_change_suspend(void)
+{
+    int i;
+    unsigned int val = rtk_suspend_gpio_output_change_en_get();
+    for (i=0;i<SUSPEND_ISO_GPIO_SIZE;i++) {
+        unsigned int mask = 0x1U << i;
+
+        if (!(val & mask))
+            continue;
+
+        iprintk("[%s] gpio:%d set ouput =>  %s\n", __func__, i+SUSPEND_ISO_GPIO_BASE, 
+                (rtk_suspend_gpio_output_change_act_get() & mask) ? "HIGH" : "LOW")
+
+        gpio_direction_output(i+SUSPEND_ISO_GPIO_BASE,
+                (rtk_suspend_gpio_output_change_act_get() & mask) ? 1 : 0 );
+    }
+}
+
+void rtk_suspend_gpip_output_change_resume(void)
+{
+    int i;
+    unsigned int val = rtk_suspend_gpio_output_change_en_get();
+    for (i=0;i<SUSPEND_ISO_GPIO_SIZE;i++) {
+        unsigned int mask = 0x1U << i;
+
+        if (!(val & mask))
+            continue;
+
+        iprintk("[%s] gpio:%d set ouput =>  %s\n", __func__, i+SUSPEND_ISO_GPIO_BASE,
+                (rtk_suspend_gpio_output_change_act_get() & mask) ? "LOW" : "HIGH")
+
+        gpio_direction_output(i+SUSPEND_ISO_GPIO_BASE,
+                (rtk_suspend_gpio_output_change_act_get() & mask) ? 0 : 1 );
+    }
+}
+
+static int rtk_suspend_enter(suspend_state_t suspend_state)
+{
+    int ret = 0;
+    iprintk("[%s]\n",__func__);
+
+    if (!rtk_suspend_valid(suspend_state)) {
+        eprintk("[%s] suspend_state:%d not support!\n", __func__, (int) suspend_state);
+        return  -EINVAL;
+    }
+
+    switch(suspend_state) {
+        case PM_SUSPEND_MEM:
+
+            iprintk("[%s] rtk_ip_power_off() ...\n", __func__);
+            
+            rtk_ip_power_off();
+
+#if 1 // legacy
+            if (wifi_gpio != -1) {
+                iprintk("[%s] wifi gpio : POWER DOWN ...\n", __func__);
+                gpio_direction_output(wifi_gpio, 0);
+            }
+#endif
+
+            rtk_suspend_gpip_output_change_suspend();
+
+            if (suspend_mode == SUSPEND_TO_WFI)
+                ret = rtk_suspend_to_wfi();
+            else if (suspend_mode == SUSPEND_TO_COOLBOOT)
+                ret = rtk_suspend_to_coolboot();
+            else if (suspend_mode == SUSPEND_TO_RAM)
+                ret = rtk_suspend_to_ram();
+            else
+                BUG();
+
+            if (ret) {
+                eprintk("[%s] ERROR!!!!! to suspend! (%d)\n",__func__,ret);
+                BUG();
+                break;
+            }
+
+            iprintk("[%s] platform resume ...\n", __func__);
+            notify_acpu(NOTIFY_RESUME_PLATFORM);
+
+#if 1 // legacy
+            if (wifi_gpio != -1)
+                gpio_direction_output(wifi_gpio, 1);	//power up
+#endif
+            rtk_suspend_gpip_output_change_resume();
+
+            rtk_ip_power_on();
+
+            break;
+        default:
+            ret = -EINVAL;
+            break;
+    }
+    return  ret;
+}
+
+static int rtk_suspend_begin(suspend_state_t suspend_state)
+{
+    dprintk("%s\n",__func__);
+
+    if (!rtk_suspend_valid(suspend_state)) {
+        eprintk("[%s] suspend_state:%d not support!\n", __func__, (int) suspend_state);
+        return  -EINVAL;
+    }
+
+    switch(suspend_state) {
+        case PM_SUSPEND_MEM:
+            cpu_idle_poll_ctrl(true);
+            break;
+        default:
+            return  -EINVAL;
+    }
+	return 0;
+}
+
+static void rtk_suspend_end(void)
+{
+    dprintk("%s\n",__func__);
+    notify_acpu(NOTIFY_RESUME_END);
+	cpu_idle_poll_ctrl(false);
+}
+
+struct platform_suspend_ops rtk_suspend_ops = {
+	.begin		= rtk_suspend_begin,
+	.end		= rtk_suspend_end,
+	.enter		= rtk_suspend_enter,
+	.valid		= rtk_suspend_valid,
+};
+
+#ifdef CONFIG_NAS_GPIO_SHUTDOWN
+extern unsigned char *gpio_shutdown_list;
+static void rtk_nas_poweroff(void)
+{
+    int i, value;
+
+    for (i=0; i<ARCH_NR_GPIOS; i++){
+        value = (int)(gpio_shutdown_list[i]);
+        if(0 == value)
+            continue;
+        gpio_free(i);
+        if(gpio_request(i, NULL)){
+            dprintk("[%s]GPIO %d request error\n",__func__, i);
+            continue;
+        }
+        gpio_direction_output(i, value-1);
+        gpio_free(i);
+    }
+
+    /* machine_halt() */
+    local_irq_disable();
+    while (1);
+
+    return;
+}
+#else
+static void rtk_poweroff_to_suspend_prepare(void)
+{
+    printk(KERN_INFO "[RTD119x_PM] Power off to Suspend Prepare.\n");
+
+    suspend_mode = SUSPEND_TO_COOLBOOT;
+    pm_suspend(PM_SUSPEND_MEM);
+    return;
+};
+
+static void rtk_poweroff_to_suspend(void)
+{
+    printk(KERN_INFO "[RTD119x_PM] Power off to Suspend.\n");
+    return;
+};
+#endif
+
+int __init rtk_suspend_init(void)
+{
+    struct device_node  *p_suspend_nd       = NULL;
+	struct device_node  *p_bt_wakeup_nd     = NULL;
+
+    acpu_set_flag(0x00000000);
+    rtk_suspend_wakeup_flags_set(0);
+    rtk_suspend_resume_state_set(RESUME_NONE);
+    rtk_suspend_resume_data_set(0);
+    rtk_suspend_gpio_wakeup_en_set(0);
+    rtk_suspend_gpio_wakeup_act_set(0);
+    rtk_suspend_gpio_output_change_en_set(0);
+    rtk_suspend_gpio_output_change_act_set(0);
+    rtk_suspend_timer_sec_set(0);
+
+	p_suspend_nd = of_find_compatible_node(NULL, NULL, "Realtek,suspend");
+
+    if (p_suspend_nd && of_device_is_available(p_suspend_nd)) {
+        const u32 *prop;
+        int size;
+
+        {
+            int cnt_wakeup_gpio_en = 0;
+            int cnt_wakeup_gpio_act = 0;
+            int cnt_wakeup_gpio_list    = of_gpio_named_count(p_suspend_nd, "wakeup-gpio-list");
+            const u32 * prop_en         = of_get_property(p_suspend_nd, "wakeup-gpio-enable", &cnt_wakeup_gpio_en);
+            const u32 * prop_act        = of_get_property(p_suspend_nd, "wakeup-gpio-activity", &cnt_wakeup_gpio_act);
+
+            cnt_wakeup_gpio_en  /= sizeof(u32);
+            cnt_wakeup_gpio_act /= sizeof(u32);
+
+            iprintk("[%s:%d] wakeup-gpio Cnt: en(%d) act(%d) list(%d)\n", __func__, __LINE__,
+                    cnt_wakeup_gpio_en,
+                    cnt_wakeup_gpio_act,
+                    cnt_wakeup_gpio_list);
+
+            if (cnt_wakeup_gpio_en != 0
+                    && (cnt_wakeup_gpio_en == cnt_wakeup_gpio_act)
+                    && (cnt_wakeup_gpio_act == cnt_wakeup_gpio_list))
+            {
+                int i;
+                for (i=0;i<cnt_wakeup_gpio_list;i++) {
+
+                    int en  = of_read_number(prop_en,   1 + i);
+                    int act = of_read_number(prop_act,  1 + i);
+                    int wakeup_gpio = of_get_named_gpio(p_suspend_nd, "wakeup-gpio-list", i);
+                    int gpio_iso_num = wakeup_gpio - SUSPEND_ISO_GPIO_BASE;
+
+                    if (!en) {
+                        wprintk("[%s] wakeup-gpio[%d] States is disable! (en:%d act:%d gpio:%d)\n",
+                                __func__, i, en, act, wakeup_gpio);
+                        continue;
+                    }
+
+                    if (!gpio_is_valid(wakeup_gpio)) {
+                        eprintk("[%s] wakeup-gpio[%d] Validation failed! (en:%d act:%d gpio:%d)\n",
+                                __func__, i, en, act, wakeup_gpio);
+                        continue;
+                    }
+
+                    if(gpio_request(wakeup_gpio, p_suspend_nd->name)) {
+                        eprintk("[%s] wakeup-gpio[%d] Request failed! (en:%d act:%d gpio:%d)\n",
+                                __func__, i, en, act, wakeup_gpio);
+                        continue;
+                    }
+
+                    if (gpio_iso_num < 0 || gpio_iso_num >= SUSPEND_ISO_GPIO_SIZE) {
+                        eprintk("[%s] wakeup-gpio[%d] Out of iso range! (en:%d act:%d gpio:%d)\n",
+                                __func__, i, en, act, wakeup_gpio);
+                        continue;
+                    }
+
+                    iprintk("[%s] wakeup-gpio[%d] Successful registration! (en:%d act:%d gpio:%d)\n",
+                            __func__, i, en, act, wakeup_gpio);
+
+                    {
+                        unsigned int val;
+                        val = rtk_suspend_gpio_wakeup_en_get();
+                        if (val == -1U)
+                            val = 0;
+                        if (en)
+                            val |= (0x1U << gpio_iso_num);
+                        else
+                            val &= ~(0x1U << gpio_iso_num);
+                        rtk_suspend_gpio_wakeup_en_set(val);
+
+                        val = rtk_suspend_gpio_wakeup_act_get();
+                        if (act)
+                            val |= (0x1U << gpio_iso_num);
+                        else
+                            val &= ~(0x1U << gpio_iso_num);
+                        rtk_suspend_gpio_wakeup_act_set(val);
+                    }
+
+
+                }
+
+            }
+        }
+
+
+        {
+            int cnt_output_change_gpio_en = 0;
+            int cnt_output_change_gpio_act = 0;
+            int cnt_output_change_gpio_list     = of_gpio_named_count(p_suspend_nd, "gpio-output-change-list");
+            const u32 * prop_en                 = of_get_property(p_suspend_nd,     "gpio-output-change-enable", &cnt_output_change_gpio_en);
+            const u32 * prop_act                = of_get_property(p_suspend_nd,     "gpio-output-change-activity", &cnt_output_change_gpio_act);
+
+            cnt_output_change_gpio_en  /= sizeof(u32);
+            cnt_output_change_gpio_act /= sizeof(u32);
+
+            iprintk("[%s:%d] gpio-output-change Cnt: en(%d) act(%d) list(%d)\n", __func__, __LINE__,
+                    cnt_output_change_gpio_en,
+                    cnt_output_change_gpio_act,
+                    cnt_output_change_gpio_list);
+
+            if (cnt_output_change_gpio_en != 0
+                    && (cnt_output_change_gpio_en == cnt_output_change_gpio_act)
+                    && (cnt_output_change_gpio_act == cnt_output_change_gpio_list))
+            {
+                int i;
+                for (i=0;i<cnt_output_change_gpio_list;i++) {
+                    int en  = of_read_number(prop_en,   1 + i);
+                    int act = of_read_number(prop_act,  1 + i);
+                    int output_change_gpio = of_get_named_gpio(p_suspend_nd, "gpio-output-change-list", i);
+                    int gpio_iso_num = output_change_gpio - SUSPEND_ISO_GPIO_BASE;
+
+                    if (!en) {
+                        wprintk("[%s] gpio-output-change[%d] States is disable! (en:%d act:%d gpio:%d)\n",
+                                __func__, i, en, act, output_change_gpio);
+                        continue;
+                    }
+
+                    if (!gpio_is_valid(output_change_gpio)) {
+                        eprintk("[%s] gpio-output-change[%d] Validation failed! (en:%d act:%d gpio:%d)\n",
+                                __func__, i, en, act, output_change_gpio);
+                        continue;
+                    }
+
+                    if(gpio_request(output_change_gpio, p_suspend_nd->name)) {
+                        eprintk("[%s] gpio-output-change[%d] Request failed! (en:%d act:%d gpio:%d)\n",
+                                __func__, i, en, act, output_change_gpio);
+                        continue;
+                    }
+
+                    if (gpio_iso_num < 0 || gpio_iso_num >= SUSPEND_ISO_GPIO_SIZE) {
+                        eprintk("[%s] gpio-output-change[%d] Out of iso range! (en:%d act:%d gpio:%d)\n",
+                                __func__, i, en, act, output_change_gpio);
+                        continue;
+                    }
+
+                    iprintk("[%s] gpio-output-change[%d] Successful registration! (en:%d act:%d gpio:%d)\n",
+                            __func__, i, en, act, output_change_gpio);
+
+                    {
+                        unsigned int val;
+                        val = rtk_suspend_gpio_output_change_en_get();
+                        if (val == -1U)
+                            val = 0;
+                        if (en)
+                            val |= (0x1U << gpio_iso_num);
+                        else
+                            val &= ~(0x1U << gpio_iso_num);
+                        rtk_suspend_gpio_output_change_en_set(val);
+
+                        val = rtk_suspend_gpio_output_change_act_get();
+                        if (act)
+                            val |= (0x1U << gpio_iso_num);
+                        else
+                            val &= ~(0x1U << gpio_iso_num);
+                        rtk_suspend_gpio_output_change_act_set(val);
+#if 1 // legacy
+                        acpu_set_bt_wakeup_host(gpio_iso_num,(act)?1:0);
+#endif
+                    }
+                }
+            }
+        }
+
+#if 0 // legacy
+        /*
+         * WiFi GPIO
+         */
+        wifi_gpio = of_get_named_gpio(p_suspend_nd, "realtek,wifi-gpio", 0);
+        if (gpio_is_valid(wifi_gpio)) {
+            if(gpio_request(wifi_gpio, p_suspend_nd->name))
+                eprintk("%s ERROR Request wifi gpio fail\n",__func__);
+        } else {
+            wprintk("%s ERROR wifi gpio is not valid\n",__func__);
+        }
+#endif
+
+        /*
+         * Suspend Mode
+         */
+        prop = of_get_property(p_suspend_nd, "suspend-mode", &size);
+        if (prop) {
+            int temp = of_read_number(prop,1);
+            if (temp > MAX_SUSPEND_MODE || temp < 0) {
+                eprintk("[%s] set suspend-mode error! %d (default:%d) \n",__func__,temp,(int)suspend_mode);
+            } else {
+                suspend_mode = temp;
+                iprintk("[%s] set suspend-mode = %s\n",__func__, rtk_suspend_states[suspend_mode]);
+            }
+        }
+
+        /*
+         * wakeup flags
+         */
+        prop = of_get_property(p_suspend_nd, "wakeup-flags", &size);
+        if (prop) {
+            int temp = of_read_number(prop,1);
+            if (temp < 0) {
+                eprintk("[%s] set wakeup-flags error! 0x%x\n", __func__, temp);
+                rtk_suspend_wakeup_flags_set(fWAKEUP_ON_IR|fWAKEUP_ON_GPIO|fWAKEUP_ON_ALARM|fWAKEUP_ON_CEC);
+                iprintk("[%s] wakeup flags set default : 0x%x\n", __func__, rtk_suspend_wakeup_flags_get());
+            } else {
+                rtk_suspend_wakeup_flags_set(temp);
+                iprintk("[%s] set set wakeup-flags = 0x%x\n",__func__, rtk_suspend_wakeup_flags_get());
+            }
+        } else {
+            rtk_suspend_wakeup_flags_set(fWAKEUP_ON_IR|fWAKEUP_ON_GPIO|fWAKEUP_ON_ALARM|fWAKEUP_ON_CEC);
+            iprintk("[%s] wakeup flags set default : 0x%x\n", __func__, rtk_suspend_wakeup_flags_get());
+        }
+    }
+
+#if 1 // legacy
+	p_bt_wakeup_nd = of_find_compatible_node(NULL, NULL, "Realtek,bt_wakeup_host");
+
+    if (p_bt_wakeup_nd && of_device_is_available(p_bt_wakeup_nd)) {
+        int bt_wakeup_gpio = of_get_named_gpio(p_bt_wakeup_nd, "realtek,bt-wakeup-gpio", 0);
+        const char *activity_level;
+        if (!gpio_is_valid(bt_wakeup_gpio))
+        {
+            //BUG();
+            eprintk("%s ERROR bt_wakeup_host gpio is not valid\n",__func__);
+        }
+        if(gpio_request(bt_wakeup_gpio, p_bt_wakeup_nd->name))
+        {
+            //BUG();
+            eprintk("%s ERROR Request bt_wakeup_host gpio fail\n",__func__);
+        }
+        if(of_property_read_string(p_bt_wakeup_nd, "activity_level", &activity_level) < 0)
+        {
+			//BUG();
+			eprintk("%s ERROR get bt_wakeup_host activity level fail\n",__func__);
+        }
+        else
+        {
+			if(bt_wakeup_gpio>=60)
+			{
+				if (!strcmp(activity_level, "low"))
+					acpu_set_bt_wakeup_host(bt_wakeup_gpio-60,0);
+				else
+					acpu_set_bt_wakeup_host(bt_wakeup_gpio-60,1);
+			}
+		}
+    }
+#endif
+
+	suspend_set_ops(&rtk_suspend_ops);
+
+#ifdef CONFIG_NAS_GPIO_SHUTDOWN
+	pm_power_off = rtk_nas_poweroff;
+#else
+  pm_power_off_prepare = rtk_poweroff_to_suspend_prepare;
+  pm_power_off = rtk_poweroff_to_suspend;
+#endif
+
+	return 0;
+}
+
+arch_initcall(rtk_suspend_init);
+
+#ifdef CONFIG_SYSFS
+#define RTK_SUSPEND_ATTR(_name)             \
+{                                           \
+    .attr = {.name = #_name, .mode = 0644}, \
+    .show =  rtk_suspend_##_name##_show,    \
+    .store = rtk_suspend_##_name##_store,   \
+}
+
+static enum _suspend_mode rtk_suspend_decode_mode(const char *buf, size_t n)
+{
+	const char * const *s;
+	char *p;
+	int len;
+    int i;
+
+	p = memchr(buf, '\n', n);
+	len = p ? p - buf : n;
+
+    for (i=0;i<MAX_SUSPEND_MODE;i++) {
+        s = &rtk_suspend_states[i];
+        if (*s && len == strlen(*s) && !strncmp(buf, *s, len))
+            return i;
+    }
+
+	return MAX_SUSPEND_MODE;
+}
+
+static ssize_t rtk_suspend_mode_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    int i,n = 0;
+    for (i=0;i<MAX_SUSPEND_MODE;i++) {
+        if (i == suspend_mode)
+            n += sprintf(buf+n, "=> ");
+        else
+            n += sprintf(buf+n, "   ");
+        n += sprintf(buf+n, "%s\n",rtk_suspend_states[i]);
+    }
+    n += sprintf(buf+n, "\n");
+    return n;
+}
+
+static ssize_t rtk_suspend_mode_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+    enum _suspend_mode mode = rtk_suspend_decode_mode(buf,count);
+    if (mode < MAX_SUSPEND_MODE) {
+        suspend_mode = mode;
+        return count;
+    }
+    return -ENOMEM;
+}
+
+static enum _suspend_wakeup rtk_suspend_decode_wakeup(const char *buf, size_t n)
+{
+	const char * const *s;
+	char *p;
+	int len;
+    int i;
+
+	p = memchr(buf, '\n', n);
+	len = p ? p - buf : n;
+
+    for (i=0;i<eWAKEUP_ON_MAX;i++) {
+        s = &rtk_suspend_wakeup_states[i];
+        if (*s && len == strlen(*s) && !strncmp(buf, *s, len))
+            return i;
+    }
+
+	return eWAKEUP_ON_MAX;
+}
+
+static ssize_t rtk_suspend_wakeup_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    int i,n = 0;
+    unsigned int val = rtk_suspend_wakeup_flags_get();
+    for (i=0;i<eWAKEUP_ON_MAX;i++) {
+
+        if (val & (0x1U << i))
+            n += sprintf(buf+n, " * ");
+        else
+            n += sprintf(buf+n, "   ");
+        n += sprintf(buf+n, "%s\n", rtk_suspend_wakeup_states[i]);
+    }
+    n += sprintf(buf+n, "\n");
+    return n;
+}
+
+static ssize_t rtk_suspend_wakeup_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+    enum _suspend_wakeup wakeup = rtk_suspend_decode_wakeup(buf,count);
+    if (wakeup < eWAKEUP_ON_MAX) {
+        rtk_suspend_wakeup_flags_set(rtk_suspend_wakeup_flags_get() ^ (0x1U << wakeup));
+        return count;
+    }
+    return -ENOMEM;
+}
+
+static ssize_t rtk_suspend_resume_state_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    unsigned int val = rtk_suspend_resume_state_get();
+    if (val >= RESUME_MAX_STATE)
+        return sprintf(buf, "(not ready)\n");
+
+    if (val == RESUME_GPIO)
+        return sprintf(buf, " %s %d\n",rtk_suspend_resume_states[val], rtk_suspend_resume_data_get() + SUSPEND_ISO_GPIO_BASE);
+    else
+        return sprintf(buf, " %s %d\n",rtk_suspend_resume_states[val], rtk_suspend_resume_data_get());
+}
+
+static ssize_t rtk_suspend_resume_state_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+    return count;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_en_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    int i,n = 0;
+    unsigned int val = rtk_suspend_gpio_wakeup_en_get();
+    if (val == -1U)
+        return sprintf(buf, "(not ready)\n");
+
+    n += sprintf(buf+n, " En | GPIO(ISO)\n");
+    n += sprintf(buf+n, " ---+----------\n");
+    for (i=0;i<SUSPEND_ISO_GPIO_SIZE;i++) {
+        if (val & (0x1U << i))
+            n += sprintf(buf+n, "  * |  %d\n",i);
+        else
+            n += sprintf(buf+n, "    |  %d\n",i);
+    }
+    n += sprintf(buf+n, "\n");
+    return n;
+
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_en_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+    long val;
+    int ret = kstrtol(buf, 10, &val);
+    if (ret < 0)
+        return -ENOMEM;
+
+    if (val >= SUSPEND_ISO_GPIO_SIZE)
+        return -ENOMEM;
+
+#if 0
+    return count;
+#endif
+
+    rtk_suspend_gpio_wakeup_en_set(rtk_suspend_gpio_wakeup_en_get() ^ (0x1U << val));
+
+    return count;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_act_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    int i,n = 0;
+    unsigned int val = rtk_suspend_gpio_wakeup_act_get();
+    if (val == -1U)
+        return sprintf(buf, "(not ready)\n");
+
+    n += sprintf(buf+n, " Act| GPIO(ISO)\n");
+    n += sprintf(buf+n, " ---+----------\n");
+    for (i=0;i<SUSPEND_ISO_GPIO_SIZE;i++) {
+        if (!(rtk_suspend_gpio_wakeup_en_get() &  (0x1U << i)))
+            n += sprintf(buf+n, "    |  %d\n",i);
+        else if (val & (0x1U << i))
+            n += sprintf(buf+n, "  H |  %d\n",i);
+        else
+            n += sprintf(buf+n, "  L |  %d\n",i);
+    }
+    n += sprintf(buf+n, "\n");
+
+    return n;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_act_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+    long val;
+    int ret = kstrtol(buf, 10, &val);
+    if (ret < 0)
+        return -ENOMEM;
+
+    if (val >= SUSPEND_ISO_GPIO_SIZE)
+        return -ENOMEM;
+
+#if 0
+    return count;
+#endif
+
+    if (rtk_suspend_gpio_wakeup_en_get() &  (0x1U << val))
+        rtk_suspend_gpio_wakeup_act_set(rtk_suspend_gpio_wakeup_act_get() ^ (0x1U << val));
+
+    return count;
+}
+
+static ssize_t rtk_suspend_gpio_output_change_en_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    int i,n = 0;
+    unsigned int val = rtk_suspend_gpio_output_change_en_get();
+    if (val == -1U)
+        return sprintf(buf, "(not ready)\n");
+
+    n += sprintf(buf+n, " En | GPIO(ISO)\n");
+    n += sprintf(buf+n, " ---+----------\n");
+    for (i=0;i<SUSPEND_ISO_GPIO_SIZE;i++) {
+        if (val & (0x1U << i))
+            n += sprintf(buf+n, "  * |  %d\n",i);
+        else
+            n += sprintf(buf+n, "    |  %d\n",i);
+    }
+    n += sprintf(buf+n, "\n");
+    return n;
+
+}
+
+static ssize_t rtk_suspend_gpio_output_change_en_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+    long val;
+    int ret = kstrtol(buf, 10, &val);
+    if (ret < 0)
+        return -ENOMEM;
+
+    if (val >= SUSPEND_ISO_GPIO_SIZE)
+        return -ENOMEM;
+
+#if 0
+    return count;
+#endif
+
+    rtk_suspend_gpio_output_change_en_set(rtk_suspend_gpio_output_change_en_get() ^ (0x1U << val));
+
+    return count;
+}
+
+static ssize_t rtk_suspend_gpio_output_change_act_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    int i,n = 0;
+    unsigned int val = rtk_suspend_gpio_output_change_act_get();
+    if (val == -1U)
+        return sprintf(buf, "(not ready)\n");
+
+    n += sprintf(buf+n, " Act| GPIO(ISO)\n");
+    n += sprintf(buf+n, " ---+----------\n");
+    for (i=0;i<SUSPEND_ISO_GPIO_SIZE;i++) {
+        if (!(rtk_suspend_gpio_output_change_en_get() &  (0x1U << i)))
+            n += sprintf(buf+n, "    |  %d\n",i);
+        else if (val & (0x1U << i))
+            n += sprintf(buf+n, "  H |  %d\n",i);
+        else
+            n += sprintf(buf+n, "  L |  %d\n",i);
+    }
+    n += sprintf(buf+n, "\n");
+
+    return n;
+}
+
+static ssize_t rtk_suspend_gpio_output_change_act_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+    long val;
+    int ret = kstrtol(buf, 10, &val);
+    if (ret < 0)
+        return -ENOMEM;
+
+    if (val >= SUSPEND_ISO_GPIO_SIZE)
+        return -ENOMEM;
+
+#if 0
+    return count;
+#endif
+
+    if (rtk_suspend_gpio_output_change_en_get() &  (0x1U << val))
+        rtk_suspend_gpio_output_change_act_set(rtk_suspend_gpio_output_change_act_get() ^ (0x1U << val));
+
+    return count;
+}
+
+static ssize_t rtk_suspend_timer_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    return sprintf(buf, " %d sec (reciprocal timer)\n", rtk_suspend_timer_sec_get());
+}
+
+static ssize_t rtk_suspend_timer_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+    long val;
+    int ret = kstrtol(buf, 10, &val);
+    if (ret < 0)
+        return -ENOMEM;
+
+    if (val > (AUDIO_RECIPROCAL_TIMER_GET(-1UL)))
+        return -ENOMEM;
+
+    rtk_suspend_timer_sec_set(val);
+    return count;
+}
+
+static struct kobj_attribute rtk_suspend_mode_attr                          = RTK_SUSPEND_ATTR(mode);
+static struct kobj_attribute rtk_suspend_wakeup_attr                        = RTK_SUSPEND_ATTR(wakeup);
+static struct kobj_attribute rtk_suspend_resume_state_attr                  = RTK_SUSPEND_ATTR(resume_state);
+static struct kobj_attribute rtk_suspend_gpio_wakeup_en_attr                = RTK_SUSPEND_ATTR(gpio_wakeup_en);
+static struct kobj_attribute rtk_suspend_gpio_wakeup_act_attr               = RTK_SUSPEND_ATTR(gpio_wakeup_act);
+static struct kobj_attribute rtk_suspend_gpio_output_change_en_attr         = RTK_SUSPEND_ATTR(gpio_output_change_en);
+static struct kobj_attribute rtk_suspend_gpio_output_change_act_attr        = RTK_SUSPEND_ATTR(gpio_output_change_act);
+static struct kobj_attribute rtk_suspend_timer_attr                         = RTK_SUSPEND_ATTR(timer);
+
+static struct attribute *rtk_suspend_attrs[] = {
+	&rtk_suspend_mode_attr.attr,
+	&rtk_suspend_wakeup_attr.attr,
+	&rtk_suspend_resume_state_attr.attr,
+	&rtk_suspend_gpio_wakeup_en_attr.attr,
+	&rtk_suspend_gpio_wakeup_act_attr.attr,
+	&rtk_suspend_gpio_output_change_en_attr.attr,
+	&rtk_suspend_gpio_output_change_act_attr.attr,
+	&rtk_suspend_timer_attr.attr,
+    NULL,
+};
+
+static struct attribute_group rtk_suspend_attr_group = {
+	.attrs = rtk_suspend_attrs,
+};
+
+static struct kobject *rtk_suspend_kobj;
+
+static ssize_t pm_state_show(struct device *dev, struct device_attribute *attr,
+       char *buf)
+{
+       return sprintf(buf, "%d\n", pm_state);
+}
+
+static ssize_t pm_state_store(struct device *dev,
+       struct device_attribute *attr, const char *buf, size_t count)
+{
+       long val;
+       int ret = kstrtol(buf, 10, &val);
+
+       if (ret < 0)
+               return -ENOMEM;
+
+       pm_state = val;
+
+       return count;;
+}
+
+static ssize_t pm_wakelock_mode_show(struct device *dev, struct device_attribute *attr,
+       char *buf)
+{
+       return sprintf(buf, "%d\n", pm_wakelock_mode);
+}
+
+static ssize_t pm_wakelock_mode_store(struct device *dev,
+       struct device_attribute *attr, const char *buf, size_t count)
+{
+       long val;
+       int ret = kstrtol(buf, 10, &val);
+
+       if (ret < 0)
+               return -ENOMEM;
+
+       pm_wakelock_mode = val;
+
+       return count;;
+}
+
+static struct device_attribute pm_state_attr =
+       __ATTR(pm_state, (S_IRUGO|S_IWUSR|S_IWGRP),
+       pm_state_show, pm_state_store);
+
+static struct device_attribute pm_wakelock_mode_attr =
+       __ATTR(pm_wakelock_mode, (S_IRUGO|S_IWUSR|S_IWGRP),
+       pm_wakelock_mode_show, pm_wakelock_mode_store);
+
+struct class *rtk_pm_class;
+struct device *rtk_pm_dev;
+
+static int __init suspend_sysfs_init(void)
+{
+    int ret;
+
+    pm_state = 0;
+    pm_wakelock_mode = 0;
+
+    rtk_pm_class = class_create(THIS_MODULE, "rtk_pm");
+    if (IS_ERR(rtk_pm_class))
+	return PTR_ERR(rtk_pm_class);
+
+    rtk_pm_dev =  device_create(rtk_pm_class, NULL,
+	MKDEV(0, 1), NULL, "android_control");
+
+    if (IS_ERR(rtk_pm_dev))
+	return PTR_ERR(rtk_pm_dev);
+
+    ret = device_create_file(rtk_pm_dev, &pm_state_attr);
+    if (ret < 0) {
+	device_destroy(rtk_pm_class, MKDEV(0, 1));
+	return -1;
+    }
+
+    ret = device_create_file(rtk_pm_dev, &pm_wakelock_mode_attr);
+    if (ret < 0) {
+        device_destroy(rtk_pm_class, MKDEV(0, 1));
+	return -1;
+    }
+
+    rtk_suspend_kobj = kobject_create_and_add("suspend", kernel_kobj);
+    if (!rtk_suspend_kobj)
+        return -ENOMEM;
+    ret = sysfs_create_group(rtk_suspend_kobj, &rtk_suspend_attr_group);
+    if (ret)
+        kobject_put(rtk_suspend_kobj);
+    return ret;
+}
+
+module_init(suspend_sysfs_init)
+#endif
diff --git a/drivers/soc/realtek/rtd119x/rtd119x_suspend.h b/drivers/soc/realtek/rtd119x/rtd119x_suspend.h
new file mode 100644
index 00000000..c1e06ce
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtd119x_suspend.h
@@ -0,0 +1,157 @@
+#ifndef __ASM_ARCH_RTK119X_PM_H__
+#define __ASM_ARCH_RTK119X_PM_H__
+
+#include <soc/realtek/rtk_ipc_shm.h>
+
+#define ISO_DUMMY1  0x18007054
+#define ISO_DUMMY2  0x18007058
+
+#define SETMASK(bits, pos)		    (((-1U) >> (32-bits))  << (pos))
+#define CLRMASK(bits, pos)		    (~(SETMASK(bits, pos)))
+#define SET_VAL(val,bits,pos)       ((val << pos) & SETMASK(bits, pos))
+#define GET_VAL(reg,bits,pos)       ((reg & SETMASK(bits, pos)) >> pos)
+
+#define AUTHOR_SHIFFT           30
+#define AUTHOR_BITS             2
+#define AUTHOR_MASK(val)        SET_VAL(val,AUTHOR_BITS,AUTHOR_SHIFFT)
+#define AUTHOR_GET(reg)         GET_VAL(reg,AUTHOR_BITS,AUTHOR_SHIFFT)
+#define AUTHOR_IS_SCPU(reg)     (AUTHOR_GET(reg) == AUTHOR_SCPU)
+#define AUTHOR_IS_ACPU(reg)     (AUTHOR_GET(reg) == AUTHOR_ACPU)
+
+#define NOTIFY_SHIFFT           0
+#define NOTIFY_BITS             8
+#define NOTIFY_MASK(val)        SET_VAL(val,NOTIFY_BITS,NOTIFY_SHIFFT)
+#define NOTIFY_GET(reg)         GET_VAL(reg,NOTIFY_BITS,NOTIFY_SHIFFT)
+
+#define SUSPEND_ISO_GPIO_BASE                   60
+#define SUSPEND_ISO_GPIO_SIZE                   21
+
+#define SUSPEND_MAGIC_KEY                       0xEA
+#define SUSPEND_MAGIC_SHIFFT                    24
+#define SUSPEND_MAGIC_BITS                      8
+#define SUSPEND_MAGIC_MASK                      (SUSPEND_MAGIC_KEY << SUSPEND_MAGIC_SHIFFT)
+#define SUSPEND_MAGIC_GET(val)                  GET_VAL(val, 8, 24)
+
+#define WAKEUP_FLAGS_SHIFFT                     0
+#define WAKEUP_FLAGS_BITS                       (eWAKEUP_ON_MAX)
+#define WAKEUP_FLAGS_MASK(val)                  SET_VAL(val, WAKEUP_FLAGS_BITS, WAKEUP_FLAGS_SHIFFT)
+#define WAKEUP_FLAGS_GET(reg)                   GET_VAL(reg, WAKEUP_FLAGS_BITS, WAKEUP_FLAGS_SHIFFT)
+
+#define RESUME_STATE_SHIFFT                     16
+#define RESUME_STATE_BITS                       8
+#define RESUME_STATE_MASK(val)                  SET_VAL(val, RESUME_STATE_BITS, RESUME_STATE_SHIFFT)
+#define RESUME_STATE_GET(reg)                   GET_VAL(reg, RESUME_STATE_BITS, RESUME_STATE_SHIFFT)
+
+#define RESUME_DATA_SHIFFT                      0
+#define RESUME_DATA_BITS                        16
+#define RESUME_DATA_MASK(val)                   SET_VAL(val, RESUME_DATA_BITS, RESUME_DATA_SHIFFT)
+#define RESUME_DATA_GET(reg)                    GET_VAL(reg, RESUME_DATA_BITS, RESUME_DATA_SHIFFT)
+
+#define GPIO_WAKEUP_EN_SHIFFT                   0
+#define GPIO_WAKEUP_EN_BITS                     21
+#define GPIO_WAKEUP_EN_MASK(val)                SET_VAL(val, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+#define GPIO_WAKEUP_EN_GET(reg)                 GET_VAL(reg, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+
+#define GPIO_WAKEUP_ACT_SHIFFT                  0
+#define GPIO_WAKEUP_ACT_BITS                    21
+#define GPIO_WAKEUP_ACT_MASK(val)               SET_VAL(val, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+#define GPIO_WAKEUP_ACT_GET(reg)                GET_VAL(reg, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_EN_SHIFFT            0
+#define GPIO_OUTPUT_CHANGE_EN_BITS              21
+#define GPIO_OUTPUT_CHANGE_EN_MASK(val)         SET_VAL(val, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN_GET(reg)          GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT_SHIFFT           0
+#define GPIO_OUTPUT_CHANGE_ACT_BITS             21
+#define GPIO_OUTPUT_CHANGE_ACT_MASK(val)        SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT_GET(reg)         GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+
+#define AUDIO_RECIPROCAL_TIMER_SHIFFT           0
+#define AUDIO_RECIPROCAL_TIMER_BITS             24
+#define AUDIO_RECIPROCAL_TIMER_MASK(val)        SET_VAL(val, AUDIO_RECIPROCAL_TIMER_BITS, AUDIO_RECIPROCAL_TIMER_SHIFFT)
+#define AUDIO_RECIPROCAL_TIMER_GET(reg)         GET_VAL(reg, AUDIO_RECIPROCAL_TIMER_BITS, AUDIO_RECIPROCAL_TIMER_SHIFFT)
+
+enum {
+    AUTHOR_SCPU = 0x1,
+    AUTHOR_ACPU,
+};
+
+enum _notify_flag{
+    NOTIFY_NONE,
+    NOTIFY_SUSPEND_TO_RAM = 0x01,
+    NOTIFY_SUSPEND_TO_COOLBOOT,
+    NOTIFY_SUSPEND_TO_WFI,
+
+    NOTIFY_RESUME_PLATFORM = 0x10,
+    NOTIFY_RESUME_END,
+    NOTIFY_SCPU_READY,
+    NOTIFY_ACPU_READY,
+};
+
+enum _suspend_mode {
+    SUSPEND_TO_RAM,
+    SUSPEND_TO_COOLBOOT,
+    SUSPEND_TO_WFI,
+    MAX_SUSPEND_MODE,
+};
+
+const char *const rtk_suspend_states[MAX_SUSPEND_MODE] = {
+    [SUSPEND_TO_RAM]        = "ram",
+    [SUSPEND_TO_COOLBOOT]   = "coolboot",
+    [SUSPEND_TO_WFI]        = "wfi",
+};
+
+enum _suspend_wakeup {
+    eWAKEUP_ON_LAN,
+    eWAKEUP_ON_IR,
+    eWAKEUP_ON_GPIO,
+    eWAKEUP_ON_ALARM,
+    eWAKEUP_ON_TIMER,
+    eWAKEUP_ON_CEC,
+    eWAKEUP_ON_MAX,
+};
+
+const char *const rtk_suspend_wakeup_states[eWAKEUP_ON_MAX] = {
+    [eWAKEUP_ON_LAN]        = "lan",
+    [eWAKEUP_ON_IR]         = "ir",
+    [eWAKEUP_ON_GPIO]       = "gpio",
+    [eWAKEUP_ON_ALARM]      = "alarm",
+    [eWAKEUP_ON_TIMER]      = "timer",
+    [eWAKEUP_ON_CEC]        = "cec",
+};
+
+enum _wakeup_flags {
+    fWAKEUP_ON_LAN          = 0x1U << eWAKEUP_ON_LAN,
+    fWAKEUP_ON_IR           = 0x1U << eWAKEUP_ON_IR,
+    fWAKEUP_ON_GPIO         = 0x1U << eWAKEUP_ON_GPIO,
+    fWAKEUP_ON_ALARM        = 0x1U << eWAKEUP_ON_ALARM,
+    fWAKEUP_ON_TIMER        = 0x1U << eWAKEUP_ON_TIMER,
+    fWAKEUP_ON_CEC          = 0x1U << eWAKEUP_ON_CEC,
+};
+
+enum _RESUME_STATE {
+    RESUME_NONE     = 0,
+    RESUME_UNKNOW,
+    RESUME_IR,
+    RESUME_GPIO,
+    RESUME_LAN,
+    RESUME_ALARM,
+    RESUME_TIMER,
+    RESUME_CEC,
+    RESUME_MAX_STATE,
+};
+
+const char *const rtk_suspend_resume_states[RESUME_MAX_STATE] = {
+    [RESUME_NONE]        = "none",
+    [RESUME_UNKNOW]      = "unknow",
+    [RESUME_IR]          = "ir",
+    [RESUME_GPIO]        = "gpio",
+    [RESUME_LAN]         = "lan",
+    [RESUME_ALARM]       = "alarm",
+    [RESUME_TIMER]       = "timer",
+    [RESUME_CEC]         = "cec",
+};
+
+extern void v7_cpu_resume(void);
+#endif
diff --git a/drivers/soc/realtek/rtd119x/rtk_chip.c b/drivers/soc/realtek/rtd119x/rtk_chip.c
new file mode 100644
index 00000000..293d13f
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_chip.c
@@ -0,0 +1,49 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <soc/realtek/rtk_chip.h>
+#include <linux/module.h>
+#include <linux/io.h>
+
+#define SB2_BASE_ADDR   0x1801A000
+#define CHIP_ID         0x00000200
+#define CHIP_REV        0x00000204
+
+#define RTD119X_CHIP_A (0x00000000)	//realtek phoenix naming version method is different from kylin & hercules
+#define RTD119X_CHIP_B (0x00010000)
+#define RTD119X_CHIP_C (0x00020000)
+#define RTD119X_CHIP_D (0x00030000)
+
+int get_rtd_chip_id(void) {
+        int chip_id = CHIP_ID_RTD1195;
+        return chip_id;
+}
+EXPORT_SYMBOL(get_rtd_chip_id);
+
+int get_rtd_chip_revision(void) {
+        void __iomem *chip_revision_addr = ioremap(SB2_BASE_ADDR + CHIP_REV, 0x4);
+
+        int val = readl(chip_revision_addr);
+
+        __iounmap(chip_revision_addr);
+
+        switch (val) {
+        case (RTD119X_CHIP_A):
+                return RTD_CHIP_A00;
+        case (RTD119X_CHIP_B):
+                return RTD_CHIP_A01;
+	case (RTD119X_CHIP_C):
+                return RTD_CHIP_B00;
+	case (RTD119X_CHIP_D):
+                return RTD_CHIP_B01;
+        default:
+                printk("%s: Not define chip revision 0x%x\n", __func__, val);
+        }
+        return 0;
+}
+EXPORT_SYMBOL(get_rtd_chip_revision);
diff --git a/drivers/soc/realtek/rtd119x/rtk_usb.c b/drivers/soc/realtek/rtd119x/rtk_usb.c
new file mode 100644
index 00000000..44a0fa4
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_usb.c
@@ -0,0 +1,82 @@
+/*
+ * rtk_usb.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <soc/realtek/power-control.h>
+#include <soc/realtek/rtk_usb.h>
+#include <soc/realtek/rtk_chip.h>
+
+struct rtk_usb {
+	struct power_ctrl_reg {
+	} power_ctrl_reg;
+
+	bool usb_power_cut;
+};
+
+static struct rtk_usb *rtk_usb;
+
+/* set usb charger power */
+void rtk_usb_set_charger_power(struct rtk_usb *rtk_usb, unsigned int val)
+{
+	if (!rtk_usb) return;
+}
+
+int rtk_usb_set_hw_l4icg_on_off(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool on)
+{
+	if (!rtk_usb)
+		return 0;
+
+	return 0;
+}
+
+static int __isolate_phy_from_a_to_d(struct rtk_usb *rtk_usb)
+{
+	/* isolate UPHY A->D */
+	if (!rtk_usb) return 0;
+
+	return 0;
+}
+
+int rtk_usb_iso_power_ctrl(struct rtk_usb *rtk_usb,
+	    bool power_on)
+{
+	if (!rtk_usb) return 0;
+
+	return 0;
+}
+
+int rtk_usb_port_suspend_resume(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool is_suspend)
+{
+	if (!rtk_usb) return 0;
+
+	return 0;
+}
+
+struct rtk_usb *rtk_usb_soc_init(struct device_node *sub_node)
+{
+	if (!rtk_usb)
+		rtk_usb = kzalloc(sizeof(struct rtk_usb), GFP_KERNEL);
+
+	return rtk_usb;
+}
+
+int rtk_usb_soc_free(struct rtk_usb **rtk_usb)
+{
+	if (*rtk_usb) {
+		kfree(*rtk_usb);
+		*rtk_usb = NULL;
+	}
+	return 0;
+}
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/Kconfig b/drivers/soc/realtek/rtd119x/rtk_ve/Kconfig
new file mode 100644
index 00000000..165ab8d
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/Kconfig
@@ -0,0 +1,23 @@
+#
+# Realtek codec configuration
+#
+
+menuconfig RTK_CODEC
+	bool "Realtek Codec"
+	default n
+
+if RTK_CODEC
+
+config RTK_RESERVE_MEMORY
+	bool "RTK Reserve Memory for Video/Image Codec"
+	default y
+
+config VIDEO_CODEC
+	bool "RTK Video Codec"
+	default y
+
+config IMAGE_CODEC
+	bool "RTK Image Codec"
+	default y
+
+endif # RTK_CODEC
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/Makefile b/drivers/soc/realtek/rtd119x/rtk_ve/Makefile
new file mode 100644
index 00000000..8a99790
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/Makefile
@@ -0,0 +1,7 @@
+#
+# Makefile for the Realtek codec drivers.
+#
+
+obj-$(CONFIG_RTK_CODEC)		+= puwrap.o
+obj-$(CONFIG_VIDEO_CODEC)	+= vdi/
+obj-$(CONFIG_IMAGE_CODEC)	+= jdi/
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/config.h b/drivers/soc/realtek/rtd119x/rtk_ve/config.h
new file mode 100644
index 00000000..0724c9e
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/config.h
@@ -0,0 +1,62 @@
+//------------------------------------------------------------------------------
+// File: config.h
+//
+// Copyright (c) 2006, Chips & Media.  All rights reserved.
+// This file should be modified by some developers of C&M according to product version.
+//------------------------------------------------------------------------------
+
+
+#ifndef __CONFIG_H__
+#define __CONFIG_H__
+
+
+#if defined(_WIN32) || defined(__WIN32__) || defined(_WIN64) || defined(WIN32) || defined(__MINGW32__)
+#	define PLATFORM_WIN32
+#elif defined(linux) || defined(__linux) || defined(ANDROID)
+#	define PLATFORM_LINUX
+#else
+#	define PLATFORM_NON_OS
+#endif
+
+
+#if defined(_MSC_VER)
+#	include <windows.h>
+#	define inline _inline
+#elif defined(__GNUC__)
+#elif defined(__ARMCC__)
+#else
+#  error "Unknown compiler."
+#endif
+
+#define API_VERSION_MAJOR       5
+#define API_VERSION_MINOR       3
+#define API_VERSION_PATCH       1
+#define API_VERSION             ((API_VERSION_MAJOR<<16) | (API_VERSION_MINOR<<8) | API_VERSION_PATCH)
+
+
+#if defined(PLATFORM_NON_OS) || defined (ANDROID) || defined(MFHMFT_EXPORTS)
+//#define SUPPORT_FFMPEG_DEMUX
+#else
+#define SUPPORT_FFMPEG_DEMUX
+#endif
+
+
+//#define REPORT_PERFORMANCE
+
+
+//#define SUPPORT_MEM_PROTECT
+
+#define PROJECT_ROOT	"../../../../"
+// do not define BIT_CODE_FILE_PATH in case of multiple product support. becuase wave410 and coda980 has different firmware binary format. 
+#define CORE_0_BIT_CODE_FILE_PATH   "../../../design/firmware/michelangel.bin"	// for wave410
+#define CORE_1_BIT_CODE_FILE_PATH   "../../../../design/asm_s/out/coda980.out"	// for coda9xx
+
+
+
+
+
+
+
+#endif	/* __CONFIG_H__ */
+
+
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/jdi/Makefile b/drivers/soc/realtek/rtd119x/rtk_ve/jdi/Makefile
new file mode 100644
index 00000000..14d0e31
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/jdi/Makefile
@@ -0,0 +1,3 @@
+# rtk_jcodec
+
+obj-$(CONFIG_IMAGE_CODEC) += jpu.o
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jmm.h b/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jmm.h
new file mode 100644
index 00000000..0c95201
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jmm.h
@@ -0,0 +1,646 @@
+#ifndef __JPU_MM_H__
+#define __JPU_MM_H__
+
+
+typedef unsigned long long  jmem_key_t;
+
+#define JMEM_PAGE_SIZE           (16*1024)
+#define MAKE_KEY(_a, _b)        (((jmem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key)      (_key>>32)
+
+typedef struct page_struct {
+	int             pageno;
+	unsigned long   addr;
+	int             used;
+	int             alloc_pages;
+	int             first_pageno;
+} page_t;
+
+
+typedef struct avl_node_struct {
+	jmem_key_t   key;
+	int     height;
+	page_t* page;
+	struct avl_node_struct* left;
+	struct avl_node_struct* right;
+} avl_node_t;
+
+
+typedef struct _jpu_mm_struct {
+	avl_node_t*     free_tree;
+	avl_node_t*     alloc_tree;
+	page_t*         page_list;
+	int             num_pages;
+	unsigned long   base_addr;
+	unsigned long   mem_size;
+	int             free_page_count;
+	int             alloc_page_count;
+} jpu_mm_t;
+
+
+
+#define VMEM_P_ALLOC(_x)         kmalloc(_x, GFP_KERNEL)
+#define VMEM_P_FREE(_x)          kfree(_x)
+
+#define VMEM_ASSERT(_exp)        if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/ }
+#define VMEM_HEIGHT(_tree)       (_tree==NULL ? -1 : _tree->height)
+
+
+#define MAX(_a, _b)         (_a >= _b ? _a : _b)
+
+typedef enum {
+    LEFT,
+    RIGHT
+} rotation_dir_t;
+
+
+
+typedef struct avl_node_data_struct {
+    int     key;
+    page_t* page;
+} avl_node_data_t;
+
+static avl_node_t*
+make_avl_node(
+    jmem_key_t key,
+    page_t* page
+    )
+{
+    avl_node_t* node = (avl_node_t*)VMEM_P_ALLOC(sizeof(avl_node_t));
+    node->key     = key;
+    node->page    = page;
+    node->height  = 0;
+    node->left    = NULL;
+    node->right   = NULL;
+
+    return node;
+}
+
+
+static int
+get_balance_factor(
+    avl_node_t* tree
+    )
+{
+    int factor = 0;
+    if (tree) {
+        factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+    }
+
+    return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *      A                      B
+ *       \                    / \
+ *        B         =>       A   C
+ *       /  \                 \
+ *      D    C                 D
+ *
+ */
+static avl_node_t*
+rotation_left(
+    avl_node_t* tree
+    )
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+    
+    rchild = tree->right;
+    if (rchild == NULL) {
+        return tree;
+    }
+
+    lchild = rchild->left;
+    rchild->left = tree;
+    tree->right = lchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+    return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *         A                  B
+ *       \                  /  \
+ *      B         =>       D    A
+ *    /  \                     /
+ *   D    C                   C
+ *
+ */
+static avl_node_t*
+rotation_right(
+    avl_node_t* tree
+    )
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    lchild = tree->left;
+    if (lchild == NULL) return NULL;
+
+    rchild = lchild->right;
+    lchild->right = tree;
+    tree->left = rchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+    return lchild;
+}
+
+static avl_node_t*
+do_balance(
+    avl_node_t* tree
+    )
+{
+    int bfactor = 0, child_bfactor;       /* balancing factor */
+
+    bfactor = get_balance_factor(tree);
+
+    if (bfactor >= 2) {
+        child_bfactor = get_balance_factor(tree->right);
+        if (child_bfactor == 1 || child_bfactor == 0) {
+            tree = rotation_left(tree);
+        } else if (child_bfactor == -1) {
+            tree->right = rotation_right(tree->right);
+            tree        = rotation_left(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    } else if (bfactor <= -2) {
+        child_bfactor = get_balance_factor(tree->left);
+        if (child_bfactor == -1 || child_bfactor == 0) {
+            tree = rotation_right(tree);
+        } else if (child_bfactor == 1) {
+            tree->left = rotation_left(tree->left);
+            tree       = rotation_right(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    }
+    
+    return tree;
+}
+static avl_node_t*
+unlink_end_node(
+    avl_node_t* tree,
+    int dir,
+    avl_node_t** found_node
+    )
+{
+    avl_node_t* node;
+    *found_node = NULL;
+
+    if (tree == NULL) return NULL;
+
+    if (dir == LEFT) {
+        if (tree->left == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    } else {
+        if (tree->right == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    }
+
+    if (dir == LEFT) {
+        node = tree->left;
+        tree->left = unlink_end_node(tree->left, LEFT, found_node);
+        if (tree->left == NULL) {
+            tree->left = (*found_node)->right;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    } else {
+        node = tree->right;
+        tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+        if (tree->right == NULL) {
+            tree->right = (*found_node)->left;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    }
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return do_balance(tree);
+}
+
+
+static avl_node_t*
+avltree_insert(
+    avl_node_t* tree,
+    jmem_key_t key,
+    page_t* page
+    )
+{
+    if (tree == NULL) {
+        tree = make_avl_node(key, page);
+    } else {
+        if (key >= tree->key) {
+            tree->right = avltree_insert(tree->right, key, page);
+        } else {
+            tree->left  = avltree_insert(tree->left, key, page);
+        }
+    }
+
+    tree = do_balance(tree);
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return tree;
+}
+
+static avl_node_t*
+do_unlink(
+    avl_node_t* tree
+    )
+{
+    avl_node_t* node;
+    avl_node_t* end_node;
+    node = unlink_end_node(tree->right, LEFT, &end_node);
+    if (node) {
+        tree->right = node;
+    } else {
+        node = unlink_end_node(tree->left, RIGHT, &end_node);
+        if (node) tree->left = node;
+    }
+
+    if (node == NULL) {
+        node = tree->right ? tree->right : tree->left;
+        end_node = node;
+    }
+
+    if (end_node) {
+        end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+        end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+        end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+    } 
+
+    tree = end_node;
+
+    return tree;
+}
+
+static avl_node_t*
+avltree_remove(
+    avl_node_t* tree,
+    avl_node_t** found_node,
+    jmem_key_t key
+    )
+{
+    *found_node = NULL;
+    if (tree == NULL) {
+        printk(KERN_INFO "failed to find key %d\n", (int)key);
+        return NULL;
+    } 
+
+    if (key == tree->key) {
+        *found_node = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = avltree_remove(tree->right, found_node, key);
+    } else {
+        tree->left  = avltree_remove(tree->left, found_node, key);
+    }
+
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+void
+jpu_avltree_free(
+    avl_node_t* tree
+    )
+{
+    if (tree == NULL) return;
+    if (tree->left == NULL && tree->right == NULL) {
+        VMEM_P_FREE(tree);
+        return;
+    }
+
+    jpu_avltree_free(tree->left);
+    tree->left = NULL;
+    jpu_avltree_free(tree->right);
+    tree->right = NULL;
+}
+
+
+
+
+static avl_node_t*
+remove_approx_value(
+    avl_node_t* tree,
+    avl_node_t** found,
+    jmem_key_t key
+    )
+{
+    *found = NULL;
+    if (tree == NULL) {
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = remove_approx_value(tree->right, found, key);
+    } else {
+        tree->left  = remove_approx_value(tree->left, found, key);
+        if (*found == NULL) {
+            *found = tree;
+            tree = do_unlink(tree);
+        }
+    }
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+static void
+set_blocks_free(
+	jpu_mm_t *mm,
+    int pageno,
+    int npages
+    )
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    VMEM_ASSERT(npages);
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+    last_page   = &mm->page_list[last_pageno];    
+    last_page->first_pageno = pageno;
+
+    mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void
+set_blocks_alloc(
+	jpu_mm_t *mm,
+    int pageno,
+    int npages
+    )
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 1;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+
+    last_page   = &mm->page_list[last_pageno];    
+    last_page->first_pageno = pageno;
+
+    mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int
+jmem_init(
+	jpu_mm_t* mm, 
+	unsigned long addr,
+    unsigned long size
+    )
+{
+    int i;
+	
+	
+    mm->base_addr  = (addr+(JMEM_PAGE_SIZE-1))&~(JMEM_PAGE_SIZE-1);
+    mm->mem_size   = size&~JMEM_PAGE_SIZE;
+    mm->num_pages  = mm->mem_size/JMEM_PAGE_SIZE;
+    mm->page_list  = (page_t*)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = mm->num_pages;
+    mm->alloc_page_count = 0;
+
+    for (i=0; i<mm->num_pages; i++) {
+        mm->page_list[i].pageno       = i;
+        mm->page_list[i].addr         = mm->base_addr + i*JMEM_PAGE_SIZE;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    set_blocks_free(mm, 0, mm->num_pages);
+	
+    return 0;
+}
+
+int
+jmem_exit(
+	jpu_mm_t* mm
+    )
+{
+	if (mm == NULL) {
+        printk(KERN_INFO "vmem_exit: invalid handle\n");
+        return -1;
+    }
+
+    if (mm->free_tree) {
+        jpu_avltree_free(mm->free_tree);
+    }
+    if (mm->alloc_tree) {
+        jpu_avltree_free(mm->alloc_tree);
+    }
+
+    VMEM_P_FREE(mm->page_list);
+	
+	mm->base_addr  = 0;
+	mm->mem_size   = 0;
+	mm->num_pages  = 0;
+	mm->page_list  = NULL;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = 0;
+	mm->alloc_page_count = 0;
+    return 0;
+}
+
+unsigned long
+jmem_alloc(
+	jpu_mm_t* mm,
+    int size,
+	unsigned long pid
+    )
+{
+    avl_node_t* node;
+    page_t*     free_page;
+    int         npages, free_size;
+    int         alloc_pageno;
+    unsigned long  ptr;
+	
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_alloc: invalid handle\n");
+		return -1;
+	}
+
+    if (size <= 0) return -1;
+
+	npages = (size + JMEM_PAGE_SIZE -1)/JMEM_PAGE_SIZE;
+
+    mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+    if (node == NULL) {
+        return -1;
+    }
+    free_page = node->page;
+    free_size = KEY_TO_VALUE(node->key);
+
+    alloc_pageno = free_page->pageno;
+    set_blocks_alloc(mm, alloc_pageno, npages);
+    if (npages != free_size) {
+        int free_pageno = alloc_pageno + npages;
+        set_blocks_free(mm, free_pageno, (free_size-npages));
+    }
+
+    VMEM_P_FREE(node);
+
+    ptr = mm->page_list[alloc_pageno].addr;
+    mm->alloc_page_count += npages;
+    mm->free_page_count  -= npages;
+
+
+    return ptr;
+}
+
+int
+jmem_free(
+	jpu_mm_t* mm,
+    unsigned long ptr,
+	unsigned long pid
+    )
+{
+    unsigned long addr;
+    avl_node_t* found;
+    page_t* page;
+    int pageno, prev_free_pageno, next_free_pageno;
+    int prev_size, next_size;
+    int merge_page_no, merge_page_size, free_page_size;
+	
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_free: invalid handle\n");
+		return -1;
+	}
+
+    addr = ptr;
+
+    mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+    if (found == NULL) {
+        printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+        VMEM_ASSERT(0);
+        return -1;
+    }
+
+    /* find previous free block */
+    page = found->page;
+    pageno = page->pageno;
+    free_page_size = page->alloc_pages;
+    prev_free_pageno = pageno-1;
+    prev_size = -1;
+    if (prev_free_pageno >= 0) {
+        if (mm->page_list[prev_free_pageno].used == 0) {
+            prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+            prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+        }
+    }
+
+    /* find next free block */
+    next_free_pageno = pageno + page->alloc_pages;
+    next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+    next_size = -1;
+    if (next_free_pageno >= 0) {
+        if (mm->page_list[next_free_pageno].used == 0) {
+            next_size = mm->page_list[next_free_pageno].alloc_pages;
+        }
+    }
+    VMEM_P_FREE(found);
+
+    /* merge */
+    merge_page_no = page->pageno;
+    merge_page_size = page->alloc_pages;
+    if (prev_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_no = found->page->pageno;
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+    if (next_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+
+    page->alloc_pages  = 0;
+    page->first_pageno = -1;
+
+    set_blocks_free(mm, merge_page_no, merge_page_size);
+
+    mm->alloc_page_count -= free_page_size;
+    mm->free_page_count  += free_page_size;
+
+    return 0;
+}
+
+
+
+#endif /* __JPU_MM_H__ */
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jpu.c b/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jpu.c
new file mode 100644
index 00000000..3f477c5
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jpu.c
@@ -0,0 +1,1043 @@
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h> 
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/miscdevice.h>
+#include "jpuconfig.h"
+
+#include "jpu.h"
+#include "../puwrap.h"
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+extern unsigned int pu_alloc_dma_buffer(unsigned int size, unsigned long long *phys_addr, unsigned long *base);
+extern void pu_free_dma_buffer(unsigned long base, unsigned long long phys_addr);
+#endif
+extern void *pu_get_drv_context(void);
+
+
+// definitions to be changed as customer  configuration
+//#define JPU_SUPPORT_CLOCK_CONTROL				/if you want to have clock gating scheme frame by frame
+//#define JPU_SUPPORT_ISR
+//#define JPU_SUPPORT_PLATFORM_DRIVER_REGISTER	//if the platform driver knows the name of this driver. JPU_PLATFORM_DEVICE_NAME 
+//#define JPU_SUPPORT_RESERVED_VIDEO_MEMORY		//if this driver knows the dedicated video memory address
+
+#define JPU_PLATFORM_DEVICE_NAME "rtk_jpu"
+#define JPU_CLK_NAME "jpeg"
+#define JPU_DEV_NAME "jpu"
+
+#define JPU_BASE_ADDR 0x18044000
+#define JPU_REG_SIZE 0x4000
+
+#define JPU_VIRT_ADDR_MAP(addr)	(RBUS_BASE_VIRT + ((u32)addr - RBUS_BASE_PHYS))
+#define JPU_WRITE_REG_INT32U(addr,val)	writel(val, IOMEM(JPU_VIRT_ADDR_MAP(addr)))
+
+#define JPU_CLOCK_REG_BASE		0x18000000
+#define JPU_CLOCK_ENABLE_REG		0x1800000c
+
+
+//#ifdef JPU_SUPPORT_ISR
+#define JPU_IRQ_NUM 83			
+//#endif
+
+#ifndef VM_RESERVED	// for kernel up to 3.7.0 version
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+typedef struct jpu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long interrupt_reason;
+} jpu_drv_context_t;
+
+
+/* To track the allocated memory buffer */
+typedef struct jpudrv_buffer_pool_t {
+	struct list_head list;
+	struct jpudrv_buffer_t jb;
+	struct file *filp;
+} jpudrv_buffer_pool_t;
+
+/* To track the instance index and buffer in instance pool */
+typedef struct jpudrv_instanace_list_t {
+	struct list_head list;
+	unsigned long inst_idx;
+	struct file *filp;
+} jpudrv_instanace_list_t;
+
+
+typedef struct jpudrv_instance_pool_t {
+	unsigned char jpgInstPool[MAX_NUM_INSTANCE][MAX_INST_HANDLE_SIZE];
+} jpudrv_instance_pool_t;
+
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#define JPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)
+#define JPU_DRAM_PHYSICAL_BASE (0x8AA00000)
+#include "jmm.h"
+static jpu_mm_t s_jmem;	
+static jpudrv_buffer_t s_image_memory = {0};
+#endif
+
+
+static int jpu_hw_reset(void);
+static void jpu_clk_disable(struct clk *clk);
+static int jpu_clk_enable(struct clk *clk);
+static struct clk *jpu_clk_get(struct device *dev);
+static void jpu_clk_put(struct clk *clk);
+// end customer definition
+
+static jpudrv_buffer_t s_jpu_instance_pool = {0};
+static jpu_drv_context_t s_jpu_drv_context;
+#if 0
+static int s_jpu_major;
+static struct class *s_jpu_class = NULL;
+static struct device *s_jpu_dev = NULL;
+static struct cdev s_jpu_cdev;
+#else
+static struct miscdevice s_jpu_dev;
+#endif
+static int s_jpu_open_count;
+static struct clk *s_jpu_clk;
+//#ifdef JPU_SUPPORT_ISR
+static int s_jpu_irq = JPU_IRQ_NUM;
+static atomic_t s_interrupt_flag;
+//#endif
+static u32 s_jpu_reg_phy_base = JPU_BASE_ADDR;
+static void __iomem *s_jpu_reg_virt_base;
+
+
+static wait_queue_head_t s_interrupt_wait_q;
+
+
+static spinlock_t s_jpu_lock = __SPIN_LOCK_UNLOCKED(s_jpu_lock);
+static DEFINE_SEMAPHORE(s_jpu_sem);
+static struct list_head s_jbp_head = LIST_HEAD_INIT(s_jbp_head);
+static struct list_head s_jpu_inst_list_head = LIST_HEAD_INIT(s_jpu_inst_list_head);
+
+/* implement to power management functions */
+#define	ReadJpuRegister(addr)			*(volatile unsigned int *)(s_jpu_reg_virt_base + addr)
+#define	WriteJpuRegister(addr, val)		*(volatile unsigned int *)(s_jpu_reg_virt_base + addr) = (unsigned int)val;	
+
+static int jpu_alloc_dma_buffer(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	jb->phys_addr = (unsigned long long)jmem_alloc(&s_jmem, jb->size, 0);
+	if ((unsigned long)jb->phys_addr  == (unsigned long)-1)
+	{
+		printk(KERN_ERR "[JPUDRV] Physical memory allocation error size=%d\n", jb->size);
+		return -1;
+	}
+
+	jb->base = (unsigned long)(s_image_memory.base + (jb->phys_addr - s_image_memory.phys_addr));
+#elif CONFIG_RTK_RESERVE_MEMORY
+	unsigned int ret;
+	ret = pu_alloc_dma_buffer(jb->size, &jb->phys_addr, &jb->base);
+	if(ret == -1)
+	{
+		printk(KERN_ERR "[JPUDRV] Physical memory allocation error size=%d\n", jb->size);
+		return -1;
+	}
+#else
+	jb->base = (unsigned long)dma_alloc_coherent(NULL, PAGE_ALIGN(jb->size), (dma_addr_t *) (&jb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(jb->base) == NULL) 
+	{
+		printk(KERN_ERR "[JPUDRV] Physical memory allocation error size=%d\n", jb->size);
+		return -1;
+	}
+#endif
+	printk("[JPUDRV] base:0x%08x, phy_addr:0x%08x, size:%d\n", jb->base, (unsigned long)jb->phys_addr, jb->size);
+	return 0;
+}
+
+static void jpu_free_dma_buffer(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (jb->base) 
+		jmem_free(&s_jmem, jb->phys_addr, 0);
+#elif CONFIG_RTK_RESERVE_MEMORY
+	pu_free_dma_buffer(jb->base, jb->phys_addr);
+#else
+	if (jb->base) 
+	{
+		dma_free_coherent(0, PAGE_ALIGN(jb->size), (void *)jb->base, jb->phys_addr);
+	}
+#endif
+}
+
+static int jpu_free_instances(struct file *filp) 
+{
+	u32 inst_idx;
+	jpudrv_instanace_list_t *jil, *n;
+	jpudrv_instance_pool_t *jip;
+
+	list_for_each_entry_safe(jil, n, &s_jpu_inst_list_head, list) 
+	{
+		if (jil->filp == filp)
+		{
+			inst_idx = jil->inst_idx;
+			jip = (jpudrv_instance_pool_t *)s_jpu_instance_pool.base;
+			if (jip)
+				memset(&jip->jpgInstPool[inst_idx], 0x00, 4);	// only first 4 byte is key point to free the corresponding instance.				
+			s_jpu_open_count--;
+			list_del(&jil->list);
+			kfree(jil);		
+		}
+	}
+
+	return 1;
+}
+
+static int jpu_free_buffers(struct file *filp)
+{
+	jpudrv_buffer_pool_t *pool, *n;
+	jpudrv_buffer_t jb;
+
+	list_for_each_entry_safe(pool, n, &s_jbp_head, list) 
+	{
+		if (pool->filp == filp)
+		{
+			jb = pool->jb;
+			if (jb.base) 
+			{
+				jpu_free_dma_buffer(&jb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+		
+	}
+
+	return 0;
+}
+
+void jpu_irq_handler2(void *dev_id)
+{
+	pu_drv_context_t *dev = (pu_drv_context_t *)dev_id;
+	disable_irq_nosync(s_jpu_irq); //Fuchun 20140407 wait IP vendor reply that how to fix this
+
+	dev->jpu_interrupt_reason = ReadJpuRegister(0x004); //MJPEG_PIC_STATUS_REG
+	//WriteJpuRegister(0x004, dev->jpu_interrupt_reason);
+	atomic_set(&s_interrupt_flag, 1);
+	//printk(KERN_INFO "jpu_irq_handler2, status:0x%08x, dev:%p\n", dev->jpu_interrupt_reason, dev);
+	wake_up_interruptible(&s_interrupt_wait_q);
+}
+
+#ifdef JPU_SUPPORT_ISR
+static irqreturn_t jpu_irq_handler(int irq, void *dev_id)
+{
+	jpu_drv_context_t *dev = (jpu_drv_context_t *)dev_id;
+
+	disable_irq_nosync(s_jpu_irq);
+	
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN);	// notify the interrupt to userspace
+	
+	
+	atomic_set(&s_interrupt_flag, 1);
+	//printk(KERN_INFO "jpu_irq_handler\n");	
+	wake_up_interruptible(&s_interrupt_wait_q);
+	
+	return IRQ_HANDLED;
+}
+#endif
+
+static int jpu_open(struct inode *inode, struct file *filp)
+{
+	spin_lock(&s_jpu_lock);
+
+#ifdef JPU_SUPPORT_ISR
+	filp->private_data = (void *)(&s_jpu_drv_context);
+#else
+	void *drv_context = pu_get_drv_context();
+	filp->private_data = (void *)(drv_context);
+#endif
+	spin_unlock(&s_jpu_lock);
+	return 0;
+}
+
+static long jpu_ioctl(struct file *filp, u_int cmd, u_long arg)
+{
+	int ret = 0;
+	struct pu_drv_context_t *dev = (struct pu_drv_context_t *)filp->private_data;
+
+	switch (cmd) 
+	{
+	case JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+		{
+			jpudrv_buffer_pool_t *jbp;
+
+			down(&s_jpu_sem);
+
+			jbp = kzalloc(sizeof(*jbp), GFP_KERNEL);
+			if (!jbp)
+			{
+				up(&s_jpu_sem);
+				return -ENOMEM;
+			}
+
+			ret = copy_from_user(&(jbp->jb), (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+			if (ret) 
+			{
+				kfree(jbp);
+				up(&s_jpu_sem);
+				return -EFAULT;
+			}
+
+			ret = jpu_alloc_dma_buffer(&(jbp->jb));
+			if (ret == -1) 
+			{
+				ret = -ENOMEM;
+				kfree(jbp);
+				up(&s_jpu_sem);
+				break;
+			}
+
+			ret = copy_to_user((void __user *)arg, &(jbp->jb), sizeof(jpudrv_buffer_t));
+			if (ret) 
+			{
+				kfree(jbp);
+				ret = -EFAULT;
+				up(&s_jpu_sem);
+				break;
+			}
+
+			jbp->filp = filp;
+			spin_lock(&s_jpu_lock);
+			list_add(&jbp->list, &s_jbp_head);
+			spin_unlock(&s_jpu_lock);		
+
+			up(&s_jpu_sem);
+
+		}
+		break;
+	case JDI_IOCTL_FREE_PHYSICALMEMORY:
+		{
+
+			jpudrv_buffer_pool_t *jbp, *n;
+			jpudrv_buffer_t jb;
+
+			down(&s_jpu_sem);
+
+			ret = copy_from_user(&jb, (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+			if (ret)
+			{
+				up(&s_jpu_sem);
+				return -EACCES;
+			}
+
+			if (jb.base) 
+				jpu_free_dma_buffer(&jb);
+
+			spin_lock(&s_jpu_lock);
+			list_for_each_entry_safe(jbp, n, &s_jbp_head, list) 
+			{
+				if (jbp->jb.base == jb.base) 
+				{
+					list_del(&jbp->list);
+					kfree(jbp);
+					break;
+				}
+			}
+			spin_unlock(&s_jpu_lock);
+
+			up(&s_jpu_sem);
+
+		}
+		break;
+
+	case JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+		{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+			if (s_image_memory.base != 0) 
+			{
+				ret = copy_to_user((void __user *)arg, &s_image_memory, sizeof(jpudrv_buffer_t));
+				if (ret != 0) 
+					ret = -EFAULT;
+			} 
+			else
+			{
+				ret = -EFAULT;
+			}			
+#endif
+		}
+		break;
+
+//#ifdef JPU_SUPPORT_ISR
+	case JDI_IOCTL_WAIT_INTERRUPT:
+		{
+			jpudrv_intr_info_t info;
+
+			ret = copy_from_user(&info, (jpudrv_intr_info_t*)arg, sizeof(jpudrv_intr_info_t));
+			if (ret != 0)
+				return -EFAULT;
+			//printk("[JPUDRV] JDI_IOCTL_WAIT_INTERRUPT\n");
+			smp_rmb();
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q, atomic_read(&s_interrupt_flag) != 0, msecs_to_jiffies(info.timeout));
+			if (!ret)
+			{
+				ret = -ETIME;
+				//printk("[JPUDRV] JDI_IOCTL_WAIT_INTERRUPT fail\n");
+				break;
+			} 
+			
+			if (signal_pending(current)) 
+			{
+				ret = -ERESTARTSYS;
+				break;
+			} 
+			
+			atomic_set(&s_interrupt_flag, 0);
+			info.intr_reason = dev->jpu_interrupt_reason;
+			ret = copy_to_user((void __user *)arg, &info, sizeof(jpudrv_intr_info_t));
+			if (ret != 0)
+				return -EFAULT;
+
+			//printk("[JPUDRV] JDI_IOCTL_WAIT_INTERRUPT done, info.intr_reason:0x%x\n", info.intr_reason);
+		}
+		break;
+//#endif	//JPU_SUPPORT_ISR
+
+	case JDI_IOCTL_ENABLE_INTERRUPT:
+		{
+			enable_irq(s_jpu_irq);
+		}
+		break;
+
+	case JDI_IOCTL_SET_CLOCK_GATE:
+		{
+			u32 clkgate;
+			
+			if (get_user(clkgate, (u32 __user *) arg))
+				return -EFAULT;
+			
+#ifdef JPU_SUPPORT_CLOCK_CONTROL	
+			if (clkgate)
+				jpu_clk_enable(s_jpu_clk);
+			else
+				jpu_clk_disable(s_jpu_clk);
+#endif
+			
+		}
+		break;
+        case JDI_IOCTL_SET_CLOCK_ENABLE:
+		{
+			u32 clkgate;
+			u32 clk_en_val;
+			
+			if (get_user(clkgate, (u32 __user *) arg))
+				return -EFAULT;
+
+			clk_en_val = readl(IOMEM(JPU_VIRT_ADDR_MAP(JPU_CLOCK_ENABLE_REG)));
+			if (clkgate)
+				clk_en_val |= (1 << 13);
+			else
+				clk_en_val &= ~(1 << 13);
+			JPU_WRITE_REG_INT32U(JPU_CLOCK_ENABLE_REG, clk_en_val);
+			__delay(100);
+		}
+		break;
+	case JDI_IOCTL_GET_INSTANCE_POOL:
+		{
+			down(&s_jpu_sem);
+			
+			if (s_jpu_instance_pool.base != 0) 
+			{
+				ret = copy_to_user((void __user *)arg, &s_jpu_instance_pool, sizeof(jpudrv_buffer_t));
+				if (ret != 0) 
+					ret = -EFAULT;
+			} 
+			else
+			{
+				ret = copy_from_user(&s_jpu_instance_pool, (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+				if (ret == 0)
+				{
+					if (jpu_alloc_dma_buffer(&s_jpu_instance_pool) != -1)
+					{
+						memset((void *)s_jpu_instance_pool.base, 0x0, s_jpu_instance_pool.size); 
+						ret = copy_to_user((void __user *)arg, &s_jpu_instance_pool, sizeof(jpudrv_buffer_t));
+						if (ret == 0)
+						{
+							// success to get memory for instance pool
+							up(&s_jpu_sem);
+							break;
+						}
+					}
+				}
+				
+				ret = -EFAULT;
+			}
+			up(&s_jpu_sem);
+		}
+		break;
+	case JDI_IOCTL_OPEN_INSTANCE:
+		{
+			u32 inst_idx;
+			jpudrv_instanace_list_t *jil;
+
+			jil = kzalloc(sizeof(*jil), GFP_KERNEL);
+			if (!jil)
+				return -ENOMEM;
+
+			if (get_user(inst_idx, (u32 __user *) arg))
+				return -EFAULT;
+
+			jil->inst_idx = inst_idx;
+			jil->filp = filp;
+			spin_lock(&s_jpu_lock);
+			list_add(&jil->list, &s_jpu_inst_list_head);
+			s_jpu_open_count++;
+			spin_unlock(&s_jpu_lock);
+
+		}
+		break;
+	case JDI_IOCTL_CLOSE_INSTANCE:
+		{
+			u32 inst_idx;
+			jpudrv_instanace_list_t *jil, *n;
+
+			if (get_user(inst_idx, (u32 __user *) arg))
+				return -EFAULT;
+
+			spin_lock(&s_jpu_lock);
+
+			list_for_each_entry_safe(jil, n, &s_jpu_inst_list_head, list) 
+			{
+				if (jil->inst_idx == inst_idx)
+				{
+					s_jpu_open_count--;
+					list_del(&jil->list);
+					kfree(jil);
+					printk(KERN_INFO "[JPUDRV] JDI_IOCTL_CLOSE_INSTANCE inst_idx=%d, open_count=%d\n", (int)inst_idx, s_jpu_open_count);
+					break;
+				}
+			}
+			spin_unlock(&s_jpu_lock);
+		}
+		break;
+	case JDI_IOCTL_GET_INSTANCE_NUM:
+		{
+			down(&s_jpu_sem);
+
+			ret = copy_to_user((void __user *)arg, &s_jpu_open_count, sizeof(int));
+			if (ret != 0) 
+				ret = -EFAULT;
+
+			//printk(KERN_INFO "[JPUDRV] VDI_IOCTL_GET_INSTANCE_NUM open_count=%d\n", s_vpu_open_count);
+
+			up(&s_jpu_sem);
+		}
+		break;
+	case JDI_IOCTL_RESET:
+		{
+			jpu_hw_reset();
+		}
+		break;
+	default:
+		{
+			printk(KERN_ERR "No such IOCTL, cmd is %d\n", cmd);
+		}
+		break;
+	}
+	return ret;
+}
+
+static ssize_t jpu_read(struct file *filp, char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static ssize_t jpu_write(struct file *filp, const char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static int jpu_release(struct inode *inode, struct file *filp)
+{
+	printk(KERN_INFO "jpu_release s_jpu_open_count=%d\n", s_jpu_open_count);	
+
+	spin_lock(&s_jpu_lock);
+
+
+	if (s_jpu_open_count > 0) 
+	{
+		/* found and free the not handled buffer by user applications */
+		jpu_free_buffers(filp);		
+
+		/* found and free the not closed instance by user applications */
+		jpu_free_instances(filp);
+	}
+
+	spin_unlock(&s_jpu_lock);
+
+	return 0;
+}
+
+
+static int jpu_fasync(int fd, struct file *filp, int mode)
+{
+	struct jpu_drv_context_t *dev = (struct jpu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+
+static int jpu_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	pfn = s_jpu_reg_phy_base >> PAGE_SHIFT;
+	
+	return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int jpu_map_to_physical_memory(struct file *fp, struct vm_area_struct *vm)
+{
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int jpu_map_to_instance_pool_memory(struct file *fp, struct vm_area_struct *vm)
+{
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+/*!
+ * @brief memory map interface for jpu file operation
+ * @return  0 on success or negative error code on error
+ */
+static int jpu_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+	if (vm->vm_pgoff) 
+	{
+		if(vm->vm_pgoff == (s_jpu_instance_pool.phys_addr>>PAGE_SHIFT))
+			return  jpu_map_to_instance_pool_memory(fp, vm);
+
+		return jpu_map_to_physical_memory(fp, vm);
+	}
+	else
+		return jpu_map_to_register(fp, vm);
+	
+}
+
+struct file_operations jpu_fops = {
+	.owner = THIS_MODULE,
+	.open = jpu_open,
+	.read = jpu_read,
+	.write = jpu_write,
+	.unlocked_ioctl = jpu_ioctl,
+	.release = jpu_release,
+	.fasync = jpu_fasync,
+	.mmap = jpu_mmap,
+};
+
+static int jpu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+
+	struct resource *res = NULL;
+	printk(KERN_INFO "jpu_probe\n");	
+
+	if (pdev)
+		res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+
+	if (res) 	// if platform driver is implemented
+	{
+		s_jpu_reg_phy_base = res->start;
+		s_jpu_reg_virt_base = ioremap(res->start, res->end - res->start);
+		printk(KERN_INFO "[JPUDRV] : 1 jpu base address get from platform driver base addr=0x%u, virtualbase=0x%p\n", s_jpu_reg_phy_base , s_jpu_reg_virt_base);		
+	}
+	else
+	{
+		s_jpu_reg_virt_base = ioremap(s_jpu_reg_phy_base, JPU_REG_SIZE);
+		printk(KERN_INFO "[JPUDRV] : 2 jpu base address get from defined value base addr=0x%u, virtualbase=0x%p\n", s_jpu_reg_phy_base, s_jpu_reg_virt_base);		
+	}
+	
+#if 0
+	/* get the major number of the character device */
+	if ((alloc_chrdev_region(&s_jpu_major, 0, 1, JPU_DEV_NAME)) < 0)
+	{
+		err = -EBUSY;
+		printk(KERN_ERR "could not allocate major number\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	s_jpu_class = class_create(THIS_MODULE, JPU_DEV_NAME);
+	if (IS_ERR(s_jpu_class))
+	{
+		err = -EBUSY;
+		printk(KERN_ERR "could not create class\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	s_jpu_dev = device_create(s_jpu_class, NULL, MKDEV(s_jpu_major, 0), NULL, JPU_DEV_NAME);
+	if (IS_ERR(s_jpu_dev))
+	{
+		err = -EBUSY;
+		printk(KERN_ERR "could not create device\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	/* initialize the device structure and register the device with the kernel */
+	cdev_init(&s_jpu_cdev, &jpu_fops);
+	if ((cdev_add(&s_jpu_cdev, s_jpu_major, 1)) < 0)
+	{
+		err = -EBUSY;
+		printk(KERN_ERR "could not allocate chrdev\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+#else
+	s_jpu_dev.minor = MISC_DYNAMIC_MINOR;
+	s_jpu_dev.name = JPU_DEV_NAME;
+	s_jpu_dev.fops = &jpu_fops;
+	s_jpu_dev.parent = NULL;
+	if (misc_register(&s_jpu_dev)) {
+	       printk("jpu: failed to register misc device.");
+	       goto ERROR_PROVE_DEVICE;
+	}
+#endif
+
+	if (pdev)
+		s_jpu_clk = jpu_clk_get(&pdev->dev);
+	else
+		s_jpu_clk = jpu_clk_get(NULL);
+	
+	if (!s_jpu_clk) {
+		printk(KERN_ERR "[JPUDRV] : fail to get clock controller, but, do not treat as error, \n");			
+	}
+	else {
+		printk(KERN_INFO "[JPUDRV] : get clock controller s_jpu_clk=0x%p\n", s_jpu_clk);					
+	}
+	
+#ifdef JPU_SUPPORT_CLOCK_CONTROL	
+	jpu_clk_enable(s_jpu_clk);
+#endif
+
+	
+#ifdef JPU_SUPPORT_ISR	
+	if(pdev)
+		res = platform_get_resource(pdev, IORESOURCE_IRQ, 0);
+	if (res) 	// if platform driver is implemented
+	{
+		s_jpu_irq = res->start;
+		printk(KERN_INFO "[JPUDRV] : 1 jpu irq number get from platform driver irq=0x%x\n", s_jpu_irq );		
+	}
+	else
+	{
+		printk(KERN_INFO "[JPUDRV] : 2 jpu irq number get from defined value irq=0x%x\n", s_jpu_irq );
+	}
+
+
+	err = request_irq(s_jpu_irq, jpu_irq_handler, 0, "JPU_CODEC", (void *)(&s_jpu_drv_context));
+	if (err)
+	{
+		printk(KERN_ERR "[JPUDRV] :  fail to register interrupt handler\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+#endif
+
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	s_image_memory.size = JPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+	s_image_memory.phys_addr = JPU_DRAM_PHYSICAL_BASE;
+	s_image_memory.base = (unsigned long)ioremap(s_image_memory.phys_addr, PAGE_ALIGN(s_image_memory.size));
+	if (!s_image_memory.base)
+	{	
+		printk(KERN_ERR "[JPUDRV] :  fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", (int)s_image_memory.phys_addr, (int)s_image_memory.base, (int)s_image_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+	if (jmem_init(&s_jmem, s_image_memory.phys_addr, s_image_memory.size) < 0)
+	{
+		printk(KERN_ERR "[JPUDRV] :  fail to init vmem system\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+	printk(KERN_INFO "[JPUDRV] success to probe jpu device with reserved video memory phys_addr=0x%x, base = 0x%x\n",(int) s_image_memory.phys_addr, (int)s_image_memory.base);
+#else
+	printk(KERN_INFO "[JPUDRV] success to probe jpu device with non reserved video memory\n");
+#endif	
+				
+
+
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+#if 0
+	if (s_jpu_dev)
+	{
+		device_destroy(s_jpu_class, MKDEV(s_jpu_major, 0));
+		s_jpu_dev = NULL;
+	}
+
+	if (s_jpu_class)
+	{
+		class_destroy(s_jpu_class);
+		s_jpu_class = NULL;
+	}
+
+	if (s_jpu_major)
+		unregister_chrdev_region(s_jpu_major, 1);
+#else
+	misc_deregister(&s_jpu_dev);
+#endif
+
+	if (s_jpu_reg_virt_base)
+		iounmap(s_jpu_reg_virt_base);
+
+	return err;
+}
+
+static int jpu_remove(struct platform_device *pdev)
+{
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER	
+
+	printk(KERN_INFO "jpu_remove\n");
+
+	if (s_jpu_instance_pool.base)
+	{
+		jpu_free_dma_buffer(&s_jpu_instance_pool);
+		s_jpu_instance_pool.base = 0;
+	}
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_image_memory.base) 
+	{
+		iounmap((void *)s_image_memory.base);
+		s_image_memory.base = 0;
+		jmem_exit(&s_jmem);		
+	}	
+#endif	
+
+#if 0
+	if (s_jpu_dev)
+	{
+		device_destroy(s_jpu_class, MKDEV(s_jpu_major, 0));
+		s_jpu_dev = NULL;
+	}
+
+	if (s_jpu_class)
+	{
+		class_destroy(s_jpu_class);
+		s_jpu_class = NULL;
+	}
+
+	cdev_del(&s_jpu_cdev);
+	if (s_jpu_major > 0)
+	{
+		unregister_chrdev_region(s_jpu_major, 1);
+		s_jpu_major = 0;
+	}
+#else
+	misc_deregister(&s_jpu_dev);
+#endif
+
+#ifdef JPU_SUPPORT_ISR
+	if (s_jpu_irq)
+		free_irq(s_jpu_irq, &s_jpu_drv_context);		
+#endif
+
+	if (s_jpu_reg_virt_base)
+		iounmap(s_jpu_reg_virt_base);
+
+	jpu_clk_put(s_jpu_clk);	
+		
+#endif //JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+static int jpu_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	jpu_clk_disable(s_jpu_clk);
+	return 0;
+
+}
+
+static int jpu_resume(struct platform_device *pdev)
+{
+	jpu_clk_enable(s_jpu_clk);
+
+	return 0;
+}
+#else
+#define	jpu_suspend	NULL
+#define	jpu_resume	NULL
+#endif				/* !CONFIG_PM */
+
+static struct platform_driver jpu_driver = {
+	.driver = {
+		   .name = JPU_PLATFORM_DEVICE_NAME,
+		   },
+	.probe = jpu_probe,
+	.remove = jpu_remove,
+	.suspend    = NULL,//TODO: jpu_suspend,
+	.resume     = NULL,//TODO: jpu_resume,
+};
+
+static int __init jpu_init(void)
+{
+	int res;
+	res = 0;
+	printk(KERN_INFO "jpu_init\n");	
+	init_waitqueue_head(&s_interrupt_wait_q);
+	s_jpu_instance_pool.base = 0;	
+
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	res = platform_driver_register(&jpu_driver);
+#else
+	res = platform_driver_register(&jpu_driver);
+	res = jpu_probe(NULL);
+#endif
+
+	printk(KERN_INFO "end jpu_init result=0x%x\n", res);	
+	return res;
+}
+
+static void __exit jpu_exit(void)
+{
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER	
+	printk(KERN_INFO "jpu_exit\n");
+#else	
+	if (s_jpu_instance_pool.base)
+	{
+		jpu_free_dma_buffer(&s_jpu_instance_pool);
+		s_jpu_instance_pool.base = 0;
+	}
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_image_memory.base) 
+	{
+		iounmap((void *)s_image_memory.base);
+		s_image_memory.base = 0;
+	}
+#endif		
+
+#if 0
+	if (s_jpu_dev)
+	{
+		device_destroy(s_jpu_class, MKDEV(s_jpu_major, 0));
+		s_jpu_dev = NULL;
+	}
+
+	if (s_jpu_class)
+	{
+		class_destroy(s_jpu_class);
+		s_jpu_class = NULL;
+	}
+
+	cdev_del(&s_jpu_cdev);
+	if (s_jpu_major > 0)
+	{
+		unregister_chrdev_region(s_jpu_major, 1);
+		s_jpu_major = 0;
+	}
+#else
+	misc_deregister(&s_jpu_dev);
+#endif
+
+#ifdef JPU_SUPPORT_ISR
+	if (s_jpu_irq)
+		free_irq(s_jpu_irq, &s_jpu_drv_context);		
+#endif	
+	
+	jpu_clk_put(s_jpu_clk);
+
+	
+	if (s_jpu_reg_virt_base) {
+		iounmap(s_jpu_reg_virt_base);
+		s_jpu_reg_virt_base = (void *)0x00;
+	}
+
+#endif //JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	platform_driver_unregister(&jpu_driver);
+	
+	return;
+}
+
+MODULE_AUTHOR("A customer using C&M JPU, Inc.");
+MODULE_DESCRIPTION("JPU linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(jpu_init);
+module_exit(jpu_exit);
+
+int jpu_hw_reset(void)
+{
+	u32 reset_value = 0;
+	u32 reset_bit = 0;
+	u32 clk_en_val = 0;
+	u32 clk_en_bit = 0;
+
+	reset_bit = 1 << 18;
+	clk_en_bit = 1 << 13;
+
+	// disable clock gatting
+	clk_en_val = readl(IOMEM(JPU_VIRT_ADDR_MAP(JPU_CLOCK_ENABLE_REG)));
+	clk_en_val &= ~clk_en_bit;
+	JPU_WRITE_REG_INT32U(JPU_CLOCK_ENABLE_REG, clk_en_val);
+	__delay(100);
+
+	// reset jpu bit to 0
+	reset_value = readl(IOMEM(JPU_VIRT_ADDR_MAP(JPU_CLOCK_REG_BASE)));
+	reset_value &= ~reset_bit;
+	JPU_WRITE_REG_INT32U(JPU_CLOCK_REG_BASE, reset_value);
+	__delay(100);
+
+	// reset jpu bit to 1
+	reset_value = readl(IOMEM(JPU_VIRT_ADDR_MAP(JPU_CLOCK_REG_BASE)));
+	reset_value |= reset_bit;
+	JPU_WRITE_REG_INT32U(JPU_CLOCK_REG_BASE, reset_value);
+	__delay(100);
+
+	// enable clock gatting
+	clk_en_val = readl(IOMEM(JPU_VIRT_ADDR_MAP(JPU_CLOCK_ENABLE_REG)));
+	clk_en_val |= clk_en_bit;
+	JPU_WRITE_REG_INT32U(JPU_CLOCK_ENABLE_REG, clk_en_val);
+	__delay(100);
+
+	printk(KERN_INFO "request jpu reset from application. \n");
+	return 0;
+}
+
+
+struct clk *jpu_clk_get(struct device *dev)
+{
+	return clk_get(dev, JPU_CLK_NAME);
+}
+void jpu_clk_put(struct clk *clk)
+{
+	if (clk)
+		clk_put(clk);
+}
+int jpu_clk_enable(struct clk *clk)
+{
+	if (clk) {
+		printk(KERN_INFO "jpu_clk_enable\n");	
+		return clk_enable(clk);
+	}
+	return 0;
+}
+
+void jpu_clk_disable(struct clk *clk)
+{
+	if (clk) {
+		printk(KERN_INFO "jpu_clk_disable\n");	
+		clk_disable(clk);
+	}
+}
+
+
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jpu.h b/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jpu.h
new file mode 100644
index 00000000..ae742fb
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jpu.h
@@ -0,0 +1,37 @@
+
+
+#ifndef __JPU_DRV_H__
+#define __JPU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+#define JDI_IOCTL_MAGIC  'J'
+
+
+#define JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY			_IO(JDI_IOCTL_MAGIC, 0)
+#define JDI_IOCTL_FREE_PHYSICALMEMORY			_IO(JDI_IOCTL_MAGIC, 1)
+#define JDI_IOCTL_WAIT_INTERRUPT			_IO(JDI_IOCTL_MAGIC, 2)
+#define JDI_IOCTL_SET_CLOCK_GATE			_IO(JDI_IOCTL_MAGIC, 3)
+#define JDI_IOCTL_RESET						_IO(JDI_IOCTL_MAGIC, 4)
+#define JDI_IOCTL_GET_INSTANCE_POOL			_IO(JDI_IOCTL_MAGIC, 5)
+#define JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO			_IO(JDI_IOCTL_MAGIC, 6)
+#define JDI_IOCTL_OPEN_INSTANCE				_IO(JDI_IOCTL_MAGIC, 7)
+#define JDI_IOCTL_CLOSE_INSTANCE			_IO(JDI_IOCTL_MAGIC, 8)
+#define JDI_IOCTL_GET_INSTANCE_NUM			_IO(JDI_IOCTL_MAGIC, 9)
+#define JDI_IOCTL_ENABLE_INTERRUPT			_IO(JDI_IOCTL_MAGIC, 10)
+#define JDI_IOCTL_SET_CLOCK_ENABLE			_IO(JDI_IOCTL_MAGIC, 11)
+
+typedef struct jpudrv_buffer_t {
+	unsigned int size;
+	unsigned long long phys_addr;
+	unsigned long base;							/* kernel logical address in use kernel */
+	unsigned long virt_addr;				/* virtual user space address */
+} jpudrv_buffer_t;
+
+typedef struct jpudrv_intr_info_t {
+	unsigned int timeout;
+	int intr_reason;
+} jpudrv_intr_info_t;
+
+#endif
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jpuconfig.h b/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jpuconfig.h
new file mode 100644
index 00000000..29e8233
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/jdi/jpuconfig.h
@@ -0,0 +1,45 @@
+//------------------------------------------------------------------------------
+// File: jpuconfig.h
+//
+// Copyright (c) 2006, Chips & Media.  All rights reserved.
+// This file should be modified by some customers according to their SOC configuration.
+//------------------------------------------------------------------------------
+
+#ifndef _JPU_CONFIG_H_
+#define _JPU_CONFIG_H_
+
+//#include "../config.h"
+//#include "jputypes.h"
+
+#define MAX_NUM_INSTANCE				8
+#define MAX_INST_HANDLE_SIZE	        (12*1024)
+
+#define JPU_FRAME_ENDIAN			JDI_LITTLE_ENDIAN
+#define JPU_STREAM_ENDIAN			JDI_LITTLE_ENDIAN
+
+#define	JPU_CHROMA_INTERLEAVE			1		// 0 (chroma separate mode), 1 (chroma interleave mode) 
+
+
+#define JPU_INTERRUPT_TIMEOUT_MS	5000
+
+#define	JPU_STUFFING_BYTE_FF   		0		// 0 : ON ("0xFF"), 1 : OFF ("0x00") for stuffing
+
+#define	JPU_PARTIAL_DECODE			1		// 0 : OFF, 1 : ON
+
+#define MAX_MJPG_PIC_WIDTH   32768
+#define MAX_MJPG_PIC_HEIGHT  32768
+
+
+#define MAX_FRAME				(19*MAX_NUM_INSTANCE) // For AVC decoder, 16(reference) + 2(current) + 1(rotator)
+
+#define STREAM_FILL_SIZE		0x10000
+#define STREAM_END_SIZE			0
+
+#define JPU_GBU_SIZE			512
+
+#define	STREAM_BUF_SIZE			0x200000
+
+#define JPU_CHECK_WRITE_RESPONSE_BVALID_SIGNAL 0
+
+
+#endif	/* _JPU_CONFIG_H_ */
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/puwrap.c b/drivers/soc/realtek/rtd119x/rtk_ve/puwrap.c
new file mode 100644
index 00000000..198471c
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/puwrap.c
@@ -0,0 +1,479 @@
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h> 
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/dma-buf.h>
+#include <linux/module.h>
+#include "puwrap.h"
+
+#ifdef CONFIG_VIDEO_CODEC
+extern void vpu_irq_handler2(int core_num, void *dev_id);
+#endif
+#ifdef CONFIG_IMAGE_CODEC
+extern void jpu_irq_handler2(void *dev_id);
+#endif
+
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#define USE_ION_ALLOCATOR
+#ifdef USE_ION_ALLOCATOR
+#define NUM_ION_STRUCT 256
+#include "../../../../staging/android/ion/ion.h"
+#include "../../../../staging/android/uapi/ion_rtk.h"
+struct rtkdrv_ion_buffer_t{
+	unsigned int size;
+	unsigned int inUse;
+	unsigned long long phys_addr;
+	unsigned long long dmabuf;
+	unsigned long pIonHandle;
+};
+static DEFINE_MUTEX(s_pu_mutex);
+extern struct ion_device *rtk_phoenix_ion_device;
+struct ion_client *pu_client = NULL;
+struct rtkdrv_ion_buffer_t pu_ion_buffer[NUM_ION_STRUCT];
+#else /* else USE_ION_ALLOCATOR */
+typedef struct rtkdrv_buffer_t {
+	unsigned int size;
+	unsigned long long phys_addr;
+	unsigned long base;							/* kernel logical address in use kernel */
+	unsigned long virt_addr;				/* virtual user space address */
+} rtkdrv_buffer_t;
+
+#define RTK_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)
+#define RTK_DRAM_PHYSICAL_BASE 0x06000000
+#include "rtk_mm.h"
+static rtk_mm_t s_mem;	
+static rtkdrv_buffer_t s_memory = {0};
+#endif /* endif USE_ION_ALLOCATOR */
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+
+#define PU_PLATFORM_DEVICE_NAME "rtk_puwrap"
+#define PU_REG_BASE_ADDR 0x18047000
+#define PU_REG_SIZE 0xC00
+#define PU_IRQ_NUM 83//(23+32)
+
+#define PU_REG_INT_STS 0x20
+
+#define INT_980	(1<<0)
+#define INT_855	(1<<1)
+#define INT_410	(1<<2)
+
+
+static pu_drv_context_t s_pu_drv_context;
+static u32 s_pu_reg_phy_addr = PU_REG_BASE_ADDR;
+static void __iomem *s_pu_reg_virt_addr;
+static int s_pu_irq = PU_IRQ_NUM;
+static int bLowMem = 0;
+#define ReadRegister(addr)		__raw_readl(s_pu_reg_virt_addr + addr)
+#define WriteRegister(addr, val)	__raw_writel(val, (s_pu_reg_virt_addr + addr))
+
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+int pu_alloc_dma_buffer(unsigned int size, unsigned long *phys_addr, unsigned long *base, unsigned int mem_type)
+{
+    if (!size)
+        return -1;
+
+#ifdef USE_ION_ALLOCATOR
+    unsigned int i;
+    struct ion_handle *handle;
+    struct dma_buf *dmabuf;
+    ion_phys_addr_t dat;
+    size_t len;
+    int heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+    int flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+
+    mutex_lock(&s_pu_mutex);
+    for (i = 0; i < NUM_ION_STRUCT; i++)
+    {
+        if (pu_ion_buffer[i].inUse == 0)
+            break;
+    }
+    if (i == NUM_ION_STRUCT)
+    {
+        printk(KERN_ERR "[PUWRAP] NUM_ION_STRUCT is too small!!!");
+        mutex_unlock(&s_pu_mutex);
+        return -1;
+    }
+    heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+    flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+
+    handle = ion_alloc(pu_client, size, 1024, heap, flags);
+    if (IS_ERR(handle))
+    {
+        printk(KERN_ERR "[PUWRAP] ion_alloc allocation error size=%d\n", size);
+        mutex_unlock(&s_pu_mutex);
+        return -1;
+    }
+
+    if(ion_phys(pu_client, handle, &dat, &len) != 0)
+    {
+        printk(KERN_ERR "[PUWRAP] ion_alloc allocation error size=%d\n", size);
+        mutex_unlock(&s_pu_mutex);
+        return -1;
+    }
+
+    *base = (unsigned long)ion_map_kernel(pu_client, handle);
+    *phys_addr = (unsigned long)dat;
+    dmabuf = ion_share_dma_buf(pu_client, handle);
+
+    pu_ion_buffer[i].size = size;
+    pu_ion_buffer[i].inUse = 1;
+    pu_ion_buffer[i].phys_addr = (unsigned long)*phys_addr;
+    pu_ion_buffer[i].dmabuf = (unsigned long)dmabuf;
+    pu_ion_buffer[i].pIonHandle = (unsigned long)handle;
+
+    mutex_unlock(&s_pu_mutex);
+
+#else /* else USE_ION_ALLOCATOR */
+    *phys_addr = (unsigned long)vmem_alloc(&s_mem, size, 0);
+    if (*phys_addr  == (unsigned long)-1)
+    {
+        printk(KERN_ERR "[PUWRAP] Physical memory allocation error size=%d\n", size);
+        return -1;
+    }
+
+    *base = (unsigned long)(s_memory.base + (*phys_addr - s_memory.phys_addr));
+#endif /* endif USE_ION_ALLOCATOR */
+    //printk("[PUWARP] base:0x%lx, phy_addr:0x%lx, size:%d\n", *base, (unsigned long)*phys_addr, size);
+
+    return 0;
+}
+
+void pu_free_dma_buffer(unsigned long base, unsigned long phys_addr)
+{
+    if (!base)
+        return;
+
+#ifdef USE_ION_ALLOCATOR
+    unsigned int i;
+    struct ion_handle *handle;
+    struct dma_buf *dmabuf;
+    mutex_lock(&s_pu_mutex);
+
+    for (i = 0; i < NUM_ION_STRUCT; i++)
+    {
+        if (pu_ion_buffer[i].phys_addr == phys_addr)
+            break;
+    }
+    if (i == NUM_ION_STRUCT)
+    {
+        printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+        mutex_unlock(&s_pu_mutex);
+        return;
+    }
+
+    dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+    if (dmabuf != NULL)
+    {
+        dma_buf_put(dmabuf);
+        pu_ion_buffer[i].dmabuf = NULL;
+    }
+
+    handle = (struct ion_handle *)pu_ion_buffer[i].pIonHandle;
+    if(handle != NULL)
+    {
+        ion_unmap_kernel(pu_client, handle);
+        ion_free(pu_client, handle);
+    }
+    memset(&pu_ion_buffer[i], 0, sizeof(struct rtkdrv_ion_buffer_t));
+    mutex_unlock(&s_pu_mutex);
+#else
+    vmem_free(&s_mem, (unsigned long)phys_addr, 0);
+#endif
+}
+
+int pu_mmap_dma_buffer(struct vm_area_struct *vm)
+{
+#ifdef USE_ION_ALLOCATOR
+    u32 i;
+    int ret = 0;
+    struct dma_buf *dmabuf;
+    unsigned long phys_addr = (unsigned long)(vm->vm_pgoff << PAGE_SHIFT);
+    mutex_lock(&s_pu_mutex);
+
+    for (i = 0; i < NUM_ION_STRUCT; i++)
+    {
+        if (pu_ion_buffer[i].phys_addr == phys_addr)
+            break;
+    }
+    if (i == NUM_ION_STRUCT)
+    {
+        printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+        mutex_unlock(&s_pu_mutex);
+        return -EINVAL;
+    }
+
+    dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+    ret = dma_buf_mmap(dmabuf, vm, 0);
+
+    mutex_unlock(&s_pu_mutex);
+
+    return ret;
+#else
+    return -EINVAL;
+#endif
+}
+
+#endif //#ifdef CONFIG_RTK_RESERVE_MEMORY
+
+void *pu_get_drv_context(void)
+{
+        return (void *)&s_pu_drv_context;
+}
+
+
+static irqreturn_t pu_irq_handler(int irq, void *dev_id)
+{
+	pu_drv_context_t *dev = (pu_drv_context_t *)dev_id;
+	volatile unsigned int reg_val;
+
+	//printk(KERN_INFO "[PUWRAP] pu_irq_handler\n");	
+
+	reg_val = ReadRegister(PU_REG_INT_STS);
+	//printk("reg_val:0x%08x\n", reg_val);
+#ifdef CONFIG_VIDEO_CODEC
+	if(reg_val & INT_980)
+	{
+		vpu_irq_handler2(0, dev_id); //enable core 0. (coda980)
+	}
+	if(reg_val & INT_410)
+	{
+		vpu_irq_handler2(1, dev_id); //enable core 1. (wave410)
+	}
+#endif
+#ifdef CONFIG_IMAGE_CODEC
+	if(reg_val & INT_855)
+	{
+		jpu_irq_handler2(dev_id); //enable coda855j.
+	}
+#endif
+
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN);	// notify the interrupt to user space
+	
+
+	return IRQ_HANDLED;
+}
+
+
+static int pu_fasync(int fd, struct file *filp, int mode)
+{
+	struct pu_drv_context_t *dev = (struct pu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+
+struct file_operations pu_fops = {
+	.owner = THIS_MODULE,
+	.fasync = pu_fasync,
+};
+
+
+static const struct of_device_id rtk_pu_dt_match[] = {
+    { .compatible = "Realtek,rtk1195-pu_pll" },
+    {}
+};
+MODULE_DEVICE_TABLE(of, rtk_pu_dt_match);
+
+static int pu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+	struct resource *res=NULL;
+	printk(KERN_INFO "[PUWRAP] pu_probe\n");
+
+	if ((int)(get_num_physpages() << PAGE_SHIFT) <= 0x20000000) //512MB
+	{
+		printk(KERN_INFO "[PUWRAP] board %luM\n", (int)(get_num_physpages() >> (20 - PAGE_SHIFT)));
+		bLowMem = 1;
+	}
+
+	if(pdev)
+		res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (res) 	// if platform driver is implemented
+	{
+		s_pu_reg_phy_addr = res->start;
+		s_pu_reg_virt_addr = ioremap(res->start, res->end - res->start);
+		printk(KERN_INFO "[PUWRAP] : 1 pu base address get from platform driver physical base addr=0x%x, virtual base=0x%x\n", (int)s_pu_reg_phy_addr , (int)s_pu_reg_virt_addr);		
+	}
+	else
+	{
+		s_pu_reg_virt_addr = ioremap(s_pu_reg_phy_addr, PU_REG_SIZE);
+		printk(KERN_INFO "[PUWRAP] : 2 pu base address get from defined value physical base addr=0x%x, virtual base=0x%x\n", (int)s_pu_reg_phy_addr, (int)s_pu_reg_virt_addr);
+		
+	}
+
+	if(pdev)
+		res = platform_get_resource(pdev, IORESOURCE_IRQ, 0);
+	if (res) 	// if platform driver is implemented
+	{
+		s_pu_irq = res->start;
+		printk(KERN_INFO "[PUWRAP] : 1 pu irq number get from platform driver irq=0x%x\n", s_pu_irq );		
+	}
+	else
+	{
+		printk(KERN_INFO "[PUWRAP] : 2 pu irq number get from defined value irq=0x%x\n", s_pu_irq );
+	}
+
+	err = request_irq(s_pu_irq, pu_irq_handler, IRQF_SHARED, "pu_wrapper", (void *)(&s_pu_drv_context));
+	if (err)
+	{
+		printk(KERN_ERR "[PUWRAP] :  fail to register interrupt handler\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifdef USE_ION_ALLOCATOR
+	pu_client = ion_client_create(rtk_phoenix_ion_device, "PUDriver");
+	memset(pu_ion_buffer, 0, sizeof(struct rtkdrv_ion_buffer_t)*NUM_ION_STRUCT);
+	printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device with USE_ION_ALLOCATOR\n");
+#else /* else USE_ION_ALLOCATOR */
+	if(pdev)
+		res = platform_get_resource(pdev, IORESOURCE_MEM, 1);
+	if(res)
+	{
+		s_memory.size = res->end - res->start;
+		s_memory.phys_addr = res->start;
+	}
+	else
+	{
+		s_memory.size = RTK_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+		s_memory.phys_addr = RTK_DRAM_PHYSICAL_BASE;
+	}
+
+	s_memory.base = (unsigned long)ioremap(s_memory.phys_addr, PAGE_ALIGN(s_memory.size));
+	if (!s_memory.base)
+	{	
+		printk(KERN_ERR "[PUWRAP] :  fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", (int)s_memory.phys_addr, (int)s_memory.base, (int)s_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+	if (rtk_mem_init(&s_mem, s_memory.phys_addr, s_memory.size) < 0)
+	{
+		printk(KERN_ERR "[PUWRAP] :  fail to init vmem system\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+	printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device with reserved video memory phys_addr=0x%x, base = 0x%x\n", (int) s_memory.phys_addr, (int)s_memory.base);
+#endif /* endif USE_ION_ALLOCATOR */
+#else /* else CONFIG_RTK_RESERVE_MEMORY */
+	printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device\n");
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+	
+	
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+	if (s_pu_reg_virt_addr)
+		iounmap(s_pu_reg_virt_addr);
+
+	return err;
+}
+
+static int pu_remove(struct platform_device *pdev)
+{
+	printk(KERN_INFO "[PUWRAP] pu_remove\n");
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifdef USE_ION_ALLOCATOR
+	if(pu_client != NULL)
+	{
+		ion_client_destroy(pu_client);
+		pu_client = NULL;
+	}
+#else /* else USE_ION_ALLOCATOR */
+	if (s_memory.base) 
+	{
+		iounmap((void *)s_memory.base);
+		s_memory.base = 0;
+		rtk_mem_exit(&s_mem);		
+	}
+#endif /* endif USE_ION_ALLOCATOR */
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+	if (s_pu_irq)
+		free_irq(s_pu_irq, &s_pu_drv_context);
+
+	if (s_pu_reg_virt_addr)
+		iounmap(s_pu_reg_virt_addr);
+
+	return 0;
+}
+
+
+static struct platform_driver pu_driver = {
+	.driver = {
+		   .name = PU_PLATFORM_DEVICE_NAME,
+		   .owner  = THIS_MODULE,
+		   .of_match_table = rtk_pu_dt_match,
+		   },
+	.probe = pu_probe,
+	.remove = pu_remove,
+};
+
+static ssize_t pu_memsize_show(struct kobject *kobj, struct kobject_attribute *attr, char *buf)
+{
+	return sprintf(buf, "%d\n", (int)(get_num_physpages() << PAGE_SHIFT));
+}
+
+static struct kobj_attribute pu_memsize_attr =
+	__ATTR(pu_memsize, 0644, pu_memsize_show, NULL);
+
+static struct attribute *pu_attrs[] = {
+	&pu_memsize_attr.attr,
+	NULL,
+};
+
+static struct attribute_group rtk_pu_attr_group = {
+	.attrs = pu_attrs,
+};
+
+static struct kobject *pu_kobj;
+
+static int __init pu_init(void)
+{
+	int res;
+
+	pu_kobj = kobject_create_and_add("rtk_pu", kernel_kobj);
+	if (pu_kobj)
+	{
+		res = sysfs_create_group(pu_kobj, &rtk_pu_attr_group);
+		if (res)
+			printk(KERN_WARNING "[PUWRAP] %d: unable to create sysfs entry\n", __LINE__);
+	}
+	else
+		printk(KERN_WARNING "[PUWRAP] %d: unable to create sysfs entry\n", __LINE__);
+
+	printk(KERN_INFO "[PUWRAP] begin pu_init\n");
+	res = platform_driver_register(&pu_driver);
+	printk(KERN_INFO "[PUWRAP] end pu_init result=0x%x\n", res);
+	return res;
+}
+
+static void __exit pu_exit(void)
+{
+	printk(KERN_INFO "[PUWRAP] pu_exit\n");
+	platform_driver_unregister(&pu_driver);
+	return;
+}
+MODULE_AUTHOR("RTK Wrapper for JPU & VPU, Inc.");
+MODULE_DESCRIPTION("PU WRAPPER linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(pu_init);
+module_exit(pu_exit);
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/puwrap.h b/drivers/soc/realtek/rtd119x/rtk_ve/puwrap.h
new file mode 100644
index 00000000..b0a4741
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/puwrap.h
@@ -0,0 +1,18 @@
+
+
+#ifndef __PU_DRV_H__
+#define __PU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+
+#define PDI_IOCTL_MAGIC  'V'
+
+typedef struct pu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long jpu_interrupt_reason;
+	unsigned long vpu_interrupt_reason;
+} pu_drv_context_t;
+
+#endif
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/rtk_mm.h b/drivers/soc/realtek/rtd119x/rtk_ve/rtk_mm.h
new file mode 100644
index 00000000..4c94e5e
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/rtk_mm.h
@@ -0,0 +1,646 @@
+#ifndef __RTK_MM_H__
+#define __RTK_MM_H__
+
+
+typedef unsigned long long  mem_key_t;
+
+#define MEM_PAGE_SIZE           (16*1024)
+#define MAKE_KEY(_a, _b)        (((mem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key)      (_key>>32)
+
+typedef struct page_struct {
+	int             pageno;
+	unsigned long   addr;
+	int             used;
+	int             alloc_pages;
+	int             first_pageno;
+} page_t;
+
+
+typedef struct avl_node_struct {
+	mem_key_t   key;
+	int     height;
+	page_t* page;
+	struct avl_node_struct* left;
+	struct avl_node_struct* right;
+} avl_node_t;
+
+
+typedef struct _rtk_mm_struct {
+	avl_node_t*     free_tree;
+	avl_node_t*     alloc_tree;
+	page_t*         page_list;
+	int             num_pages;
+	unsigned long   base_addr;
+	unsigned long   mem_size;
+	int             free_page_count;
+	int             alloc_page_count;
+} rtk_mm_t;
+
+
+
+#define VMEM_P_ALLOC(_x)         kmalloc(_x, GFP_KERNEL)
+#define VMEM_P_FREE(_x)          kfree(_x)
+
+#define VMEM_ASSERT(_exp)        if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/ }
+#define VMEM_HEIGHT(_tree)       (_tree==NULL ? -1 : _tree->height)
+
+
+#define MAX(_a, _b)         (_a >= _b ? _a : _b)
+
+typedef enum {
+    LEFT,
+    RIGHT
+} rotation_dir_t;
+
+
+
+typedef struct avl_node_data_struct {
+    int     key;
+    page_t* page;
+} avl_node_data_t;
+
+static avl_node_t*
+make_avl_node(
+    mem_key_t key,
+    page_t* page
+    )
+{
+    avl_node_t* node = (avl_node_t*)VMEM_P_ALLOC(sizeof(avl_node_t));
+    node->key     = key;
+    node->page    = page;
+    node->height  = 0;
+    node->left    = NULL;
+    node->right   = NULL;
+
+    return node;
+}
+
+
+static int
+get_balance_factor(
+    avl_node_t* tree
+    )
+{
+    int factor = 0;
+    if (tree) {
+        factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+    }
+
+    return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *      A                      B
+ *       \                    / \
+ *        B         =>       A   C
+ *       /  \                 \
+ *      D    C                 D
+ *
+ */
+static avl_node_t*
+rotation_left(
+    avl_node_t* tree
+    )
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+    
+    rchild = tree->right;
+    if (rchild == NULL) {
+        return tree;
+    }
+
+    lchild = rchild->left;
+    rchild->left = tree;
+    tree->right = lchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+    return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *         A                  B
+ *       \                  /  \
+ *      B         =>       D    A
+ *    /  \                     /
+ *   D    C                   C
+ *
+ */
+static avl_node_t*
+rotation_right(
+    avl_node_t* tree
+    )
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    lchild = tree->left;
+    if (lchild == NULL) return NULL;
+
+    rchild = lchild->right;
+    lchild->right = tree;
+    tree->left = rchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+    return lchild;
+}
+
+static avl_node_t*
+do_balance(
+    avl_node_t* tree
+    )
+{
+    int bfactor = 0, child_bfactor;       /* balancing factor */
+
+    bfactor = get_balance_factor(tree);
+
+    if (bfactor >= 2) {
+        child_bfactor = get_balance_factor(tree->right);
+        if (child_bfactor == 1 || child_bfactor == 0) {
+            tree = rotation_left(tree);
+        } else if (child_bfactor == -1) {
+            tree->right = rotation_right(tree->right);
+            tree        = rotation_left(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    } else if (bfactor <= -2) {
+        child_bfactor = get_balance_factor(tree->left);
+        if (child_bfactor == -1 || child_bfactor == 0) {
+            tree = rotation_right(tree);
+        } else if (child_bfactor == 1) {
+            tree->left = rotation_left(tree->left);
+            tree       = rotation_right(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    }
+    
+    return tree;
+}
+static avl_node_t*
+unlink_end_node(
+    avl_node_t* tree,
+    int dir,
+    avl_node_t** found_node
+    )
+{
+    avl_node_t* node;
+    *found_node = NULL;
+
+    if (tree == NULL) return NULL;
+
+    if (dir == LEFT) {
+        if (tree->left == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    } else {
+        if (tree->right == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    }
+
+    if (dir == LEFT) {
+        node = tree->left;
+        tree->left = unlink_end_node(tree->left, LEFT, found_node);
+        if (tree->left == NULL) {
+            tree->left = (*found_node)->right;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    } else {
+        node = tree->right;
+        tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+        if (tree->right == NULL) {
+            tree->right = (*found_node)->left;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    }
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return do_balance(tree);
+}
+
+
+static avl_node_t*
+avltree_insert(
+    avl_node_t* tree,
+    mem_key_t key,
+    page_t* page
+    )
+{
+    if (tree == NULL) {
+        tree = make_avl_node(key, page);
+    } else {
+        if (key >= tree->key) {
+            tree->right = avltree_insert(tree->right, key, page);
+        } else {
+            tree->left  = avltree_insert(tree->left, key, page);
+        }
+    }
+
+    tree = do_balance(tree);
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return tree;
+}
+
+static avl_node_t*
+do_unlink(
+    avl_node_t* tree
+    )
+{
+    avl_node_t* node;
+    avl_node_t* end_node;
+    node = unlink_end_node(tree->right, LEFT, &end_node);
+    if (node) {
+        tree->right = node;
+    } else {
+        node = unlink_end_node(tree->left, RIGHT, &end_node);
+        if (node) tree->left = node;
+    }
+
+    if (node == NULL) {
+        node = tree->right ? tree->right : tree->left;
+        end_node = node;
+    }
+
+    if (end_node) {
+        end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+        end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+        end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+    } 
+
+    tree = end_node;
+
+    return tree;
+}
+
+static avl_node_t*
+avltree_remove(
+    avl_node_t* tree,
+    avl_node_t** found_node,
+    mem_key_t key
+    )
+{
+    *found_node = NULL;
+    if (tree == NULL) {
+        printk(KERN_INFO "failed to find key %d\n", (int)key);
+        return NULL;
+    } 
+
+    if (key == tree->key) {
+        *found_node = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = avltree_remove(tree->right, found_node, key);
+    } else {
+        tree->left  = avltree_remove(tree->left, found_node, key);
+    }
+
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+void
+rtk_avltree_free(
+    avl_node_t* tree
+    )
+{
+    if (tree == NULL) return;
+    if (tree->left == NULL && tree->right == NULL) {
+        VMEM_P_FREE(tree);
+        return;
+    }
+
+    rtk_avltree_free(tree->left);
+    tree->left = NULL;
+    rtk_avltree_free(tree->right);
+    tree->right = NULL;
+}
+
+
+
+
+static avl_node_t*
+remove_approx_value(
+    avl_node_t* tree,
+    avl_node_t** found,
+    mem_key_t key
+    )
+{
+    *found = NULL;
+    if (tree == NULL) {
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = remove_approx_value(tree->right, found, key);
+    } else {
+        tree->left  = remove_approx_value(tree->left, found, key);
+        if (*found == NULL) {
+            *found = tree;
+            tree = do_unlink(tree);
+        }
+    }
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+static void
+set_blocks_free(
+	rtk_mm_t *mm,
+    int pageno,
+    int npages
+    )
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    VMEM_ASSERT(npages);
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+    last_page   = &mm->page_list[last_pageno];    
+    last_page->first_pageno = pageno;
+
+    mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void
+set_blocks_alloc(
+	rtk_mm_t *mm,
+    int pageno,
+    int npages
+    )
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 1;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+
+    last_page   = &mm->page_list[last_pageno];    
+    last_page->first_pageno = pageno;
+
+    mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int
+rtk_mem_init(
+	rtk_mm_t* mm, 
+	unsigned long addr,
+    unsigned long size
+    )
+{
+    int i;
+	
+	
+    mm->base_addr  = (addr+(MEM_PAGE_SIZE-1))&~(MEM_PAGE_SIZE-1);
+    mm->mem_size   = size&~MEM_PAGE_SIZE;
+    mm->num_pages  = mm->mem_size/MEM_PAGE_SIZE;
+    mm->page_list  = (page_t*)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = mm->num_pages;
+    mm->alloc_page_count = 0;
+
+    for (i=0; i<mm->num_pages; i++) {
+        mm->page_list[i].pageno       = i;
+        mm->page_list[i].addr         = mm->base_addr + i*MEM_PAGE_SIZE;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    set_blocks_free(mm, 0, mm->num_pages);
+	
+    return 0;
+}
+
+int
+rtk_mem_exit(
+	rtk_mm_t* mm
+    )
+{
+	if (mm == NULL) {
+        printk(KERN_INFO "vmem_exit: invalid handle\n");
+        return -1;
+    }
+
+    if (mm->free_tree) {
+        rtk_avltree_free(mm->free_tree);
+    }
+    if (mm->alloc_tree) {
+        rtk_avltree_free(mm->alloc_tree);
+    }
+
+    VMEM_P_FREE(mm->page_list);
+	
+	mm->base_addr  = 0;
+	mm->mem_size   = 0;
+	mm->num_pages  = 0;
+	mm->page_list  = NULL;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = 0;
+	mm->alloc_page_count = 0;
+    return 0;
+}
+
+unsigned long
+rtk_mem_alloc(
+	rtk_mm_t* mm,
+    int size,
+	unsigned long pid
+    )
+{
+    avl_node_t* node;
+    page_t*     free_page;
+    int         npages, free_size;
+    int         alloc_pageno;
+    unsigned long  ptr;
+	
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_alloc: invalid handle\n");
+		return -1;
+	}
+
+    if (size <= 0) return -1;
+
+	npages = (size + MEM_PAGE_SIZE -1)/MEM_PAGE_SIZE;
+
+    mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+    if (node == NULL) {
+        return -1;
+    }
+    free_page = node->page;
+    free_size = KEY_TO_VALUE(node->key);
+
+    alloc_pageno = free_page->pageno;
+    set_blocks_alloc(mm, alloc_pageno, npages);
+    if (npages != free_size) {
+        int free_pageno = alloc_pageno + npages;
+        set_blocks_free(mm, free_pageno, (free_size-npages));
+    }
+
+    VMEM_P_FREE(node);
+
+    ptr = mm->page_list[alloc_pageno].addr;
+    mm->alloc_page_count += npages;
+    mm->free_page_count  -= npages;
+
+
+    return ptr;
+}
+
+int
+rtk_mem_free(
+	rtk_mm_t* mm,
+    unsigned long ptr,
+	unsigned long pid
+    )
+{
+    unsigned long addr;
+    avl_node_t* found;
+    page_t* page;
+    int pageno, prev_free_pageno, next_free_pageno;
+    int prev_size, next_size;
+    int merge_page_no, merge_page_size, free_page_size;
+	
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_free: invalid handle\n");
+		return -1;
+	}
+
+    addr = ptr;
+
+    mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+    if (found == NULL) {
+        printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+        VMEM_ASSERT(0);
+        return -1;
+    }
+
+    /* find previous free block */
+    page = found->page;
+    pageno = page->pageno;
+    free_page_size = page->alloc_pages;
+    prev_free_pageno = pageno-1;
+    prev_size = -1;
+    if (prev_free_pageno >= 0) {
+        if (mm->page_list[prev_free_pageno].used == 0) {
+            prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+            prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+        }
+    }
+
+    /* find next free block */
+    next_free_pageno = pageno + page->alloc_pages;
+    next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+    next_size = -1;
+    if (next_free_pageno >= 0) {
+        if (mm->page_list[next_free_pageno].used == 0) {
+            next_size = mm->page_list[next_free_pageno].alloc_pages;
+        }
+    }
+    VMEM_P_FREE(found);
+
+    /* merge */
+    merge_page_no = page->pageno;
+    merge_page_size = page->alloc_pages;
+    if (prev_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_no = found->page->pageno;
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+    if (next_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+
+    page->alloc_pages  = 0;
+    page->first_pageno = -1;
+
+    set_blocks_free(mm, merge_page_no, merge_page_size);
+
+    mm->alloc_page_count -= free_page_size;
+    mm->free_page_count  += free_page_size;
+
+    return 0;
+}
+
+
+
+#endif /* __RTK_MM_H__ */
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/vdi/Makefile b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/Makefile
new file mode 100644
index 00000000..76dfa13
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/Makefile
@@ -0,0 +1,3 @@
+# rtk_vcodec
+
+obj-$(CONFIG_VIDEO_CODEC) += vpu.o
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vmm.h b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vmm.h
new file mode 100644
index 00000000..86a26cb
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vmm.h
@@ -0,0 +1,676 @@
+#ifndef __VIDEO_MEMORY_MANAGEMENT_H__
+#define __VIDEO_MEMORY_MANAGEMENT_H__
+
+
+typedef struct _video_mm_info_struct {
+	unsigned long   total_pages; 
+	unsigned long   alloc_pages; 
+	unsigned long   free_pages;
+	unsigned long   page_size;
+} vmem_info_t;
+
+typedef unsigned long long  vmem_key_t;
+
+#define VMEM_PAGE_SIZE           (16*1024)
+#define MAKE_KEY(_a, _b)        (((vmem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key)      (_key>>32)
+
+typedef struct page_struct {
+	int             pageno;
+	unsigned long   addr;
+	int             used;
+	int             alloc_pages;
+	int             first_pageno;
+} page_t;
+
+
+typedef struct avl_node_struct {
+	vmem_key_t   key;
+	int     height;
+	page_t* page;
+	struct avl_node_struct* left;
+	struct avl_node_struct* right;
+} avl_node_t;
+
+
+typedef struct _video_mm_struct {
+	avl_node_t*     free_tree;
+	avl_node_t*     alloc_tree;
+	page_t*         page_list;
+	int             num_pages;
+	unsigned long   base_addr;
+	unsigned long   mem_size;
+	int             free_page_count;
+	int             alloc_page_count;
+} video_mm_t;
+
+
+
+#define VMEM_P_ALLOC(_x)         kmalloc(_x, GFP_KERNEL)
+#define VMEM_P_FREE(_x)          kfree(_x)
+
+#define VMEM_ASSERT(_exp)        if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/ }
+#define VMEM_HEIGHT(_tree)       (_tree==NULL ? -1 : _tree->height)
+
+
+#define MAX(_a, _b)         (_a >= _b ? _a : _b)
+
+typedef enum {
+    LEFT,
+    RIGHT
+} rotation_dir_t;
+
+
+
+typedef struct avl_node_data_struct {
+    int     key;
+    page_t* page;
+} avl_node_data_t;
+
+static avl_node_t*
+make_avl_node(
+    vmem_key_t key,
+    page_t* page
+    )
+{
+    avl_node_t* node = (avl_node_t*)VMEM_P_ALLOC(sizeof(avl_node_t));
+    node->key     = key;
+    node->page    = page;
+    node->height  = 0;
+    node->left    = NULL;
+    node->right   = NULL;
+
+    return node;
+}
+
+
+static int
+get_balance_factor(
+    avl_node_t* tree
+    )
+{
+    int factor = 0;
+    if (tree) {
+        factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+    }
+
+    return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *      A                      B
+ *       \                    / \
+ *        B         =>       A   C
+ *       /  \                 \
+ *      D    C                 D
+ *
+ */
+static avl_node_t*
+rotation_left(
+    avl_node_t* tree
+    )
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+    
+    rchild = tree->right;
+    if (rchild == NULL) {
+        return tree;
+    }
+
+    lchild = rchild->left;
+    rchild->left = tree;
+    tree->right = lchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+    return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *         A                  B
+ *       \                  /  \
+ *      B         =>       D    A
+ *    /  \                     /
+ *   D    C                   C
+ *
+ */
+static avl_node_t*
+rotation_right(
+    avl_node_t* tree
+    )
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    lchild = tree->left;
+    if (lchild == NULL) return NULL;
+
+    rchild = lchild->right;
+    lchild->right = tree;
+    tree->left = rchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+    return lchild;
+}
+
+static avl_node_t*
+do_balance(
+    avl_node_t* tree
+    )
+{
+    int bfactor = 0, child_bfactor;       /* balancing factor */
+
+    bfactor = get_balance_factor(tree);
+
+    if (bfactor >= 2) {
+        child_bfactor = get_balance_factor(tree->right);
+        if (child_bfactor == 1 || child_bfactor == 0) {
+            tree = rotation_left(tree);
+        } else if (child_bfactor == -1) {
+            tree->right = rotation_right(tree->right);
+            tree        = rotation_left(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    } else if (bfactor <= -2) {
+        child_bfactor = get_balance_factor(tree->left);
+        if (child_bfactor == -1 || child_bfactor == 0) {
+            tree = rotation_right(tree);
+        } else if (child_bfactor == 1) {
+            tree->left = rotation_left(tree->left);
+            tree       = rotation_right(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    }
+    
+    return tree;
+}
+static avl_node_t*
+unlink_end_node(
+    avl_node_t* tree,
+    int dir,
+    avl_node_t** found_node
+    )
+{
+    avl_node_t* node;
+    *found_node = NULL;
+
+    if (tree == NULL) return NULL;
+
+    if (dir == LEFT) {
+        if (tree->left == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    } else {
+        if (tree->right == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    }
+
+    if (dir == LEFT) {
+        node = tree->left;
+        tree->left = unlink_end_node(tree->left, LEFT, found_node);
+        if (tree->left == NULL) {
+            tree->left = (*found_node)->right;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    } else {
+        node = tree->right;
+        tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+        if (tree->right == NULL) {
+            tree->right = (*found_node)->left;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    }
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return do_balance(tree);
+}
+
+
+static avl_node_t*
+avltree_insert(
+    avl_node_t* tree,
+    vmem_key_t key,
+    page_t* page
+    )
+{
+    if (tree == NULL) {
+        tree = make_avl_node(key, page);
+    } else {
+        if (key >= tree->key) {
+            tree->right = avltree_insert(tree->right, key, page);
+        } else {
+            tree->left  = avltree_insert(tree->left, key, page);
+        }
+    }
+
+    tree = do_balance(tree);
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return tree;
+}
+
+static avl_node_t*
+do_unlink(
+    avl_node_t* tree
+    )
+{
+    avl_node_t* node;
+    avl_node_t* end_node;
+    node = unlink_end_node(tree->right, LEFT, &end_node);
+    if (node) {
+        tree->right = node;
+    } else {
+        node = unlink_end_node(tree->left, RIGHT, &end_node);
+        if (node) tree->left = node;
+    }
+
+    if (node == NULL) {
+        node = tree->right ? tree->right : tree->left;
+        end_node = node;
+    }
+
+    if (end_node) {
+        end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+        end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+        end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+    } 
+
+    tree = end_node;
+
+    return tree;
+}
+
+static avl_node_t*
+avltree_remove(
+    avl_node_t* tree,
+    avl_node_t** found_node,
+    vmem_key_t key
+    )
+{
+    *found_node = NULL;
+    if (tree == NULL) {
+        printk(KERN_INFO "failed to find key %d\n", (int)key);
+        return NULL;
+    } 
+
+    if (key == tree->key) {
+        *found_node = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = avltree_remove(tree->right, found_node, key);
+    } else {
+        tree->left  = avltree_remove(tree->left, found_node, key);
+    }
+
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+void
+avltree_free(
+    avl_node_t* tree
+    )
+{
+    if (tree == NULL) return;
+    if (tree->left == NULL && tree->right == NULL) {
+        VMEM_P_FREE(tree);
+        return;
+    }
+
+    avltree_free(tree->left);
+    tree->left = NULL;
+    avltree_free(tree->right);
+    tree->right = NULL;
+}
+
+
+
+
+static avl_node_t*
+remove_approx_value(
+    avl_node_t* tree,
+    avl_node_t** found,
+    vmem_key_t key
+    )
+{
+    *found = NULL;
+    if (tree == NULL) {
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = remove_approx_value(tree->right, found, key);
+    } else {
+        tree->left  = remove_approx_value(tree->left, found, key);
+        if (*found == NULL) {
+            *found = tree;
+            tree = do_unlink(tree);
+        }
+    }
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+static void
+set_blocks_free(
+	video_mm_t *mm,
+    int pageno,
+    int npages
+    )
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    VMEM_ASSERT(npages);
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+    last_page   = &mm->page_list[last_pageno];    
+    last_page->first_pageno = pageno;
+
+    mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void
+set_blocks_alloc(
+	video_mm_t *mm,
+    int pageno,
+    int npages
+    )
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 1;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+
+    last_page   = &mm->page_list[last_pageno];    
+    last_page->first_pageno = pageno;
+
+    mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int
+vmem_init(
+	video_mm_t* mm, 
+	unsigned long addr,
+    unsigned long size
+    )
+{
+    int i;
+	
+	
+    mm->base_addr  = (addr+(VMEM_PAGE_SIZE-1))&~(VMEM_PAGE_SIZE-1);
+    mm->mem_size   = size&~VMEM_PAGE_SIZE;
+    mm->num_pages  = mm->mem_size/VMEM_PAGE_SIZE;
+    mm->page_list  = (page_t*)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = mm->num_pages;
+    mm->alloc_page_count = 0;
+
+    for (i=0; i<mm->num_pages; i++) {
+        mm->page_list[i].pageno       = i;
+        mm->page_list[i].addr         = mm->base_addr + i*VMEM_PAGE_SIZE;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    set_blocks_free(mm, 0, mm->num_pages);
+	
+    return 0;
+}
+
+int
+vmem_exit(
+	video_mm_t* mm
+    )
+{
+	if (mm == NULL) {
+        printk(KERN_INFO "vmem_exit: invalid handle\n");
+        return -1;
+    }
+
+    if (mm->free_tree) {
+        avltree_free(mm->free_tree);
+    }
+    if (mm->alloc_tree) {
+        avltree_free(mm->alloc_tree);
+    }
+
+    VMEM_P_FREE(mm->page_list);
+	
+	mm->base_addr  = 0;
+	mm->mem_size   = 0;
+	mm->num_pages  = 0;
+	mm->page_list  = NULL;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = 0;
+	mm->alloc_page_count = 0;
+    return 0;
+}
+
+unsigned long
+vmem_alloc(
+	video_mm_t* mm,
+    int size,
+	unsigned long pid
+    )
+{
+    avl_node_t* node;
+    page_t*     free_page;
+    int         npages, free_size;
+    int         alloc_pageno;
+    unsigned long  ptr;
+	
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_alloc: invalid handle\n");
+		return -1;
+	}
+
+    if (size <= 0) return -1;
+
+	npages = (size + VMEM_PAGE_SIZE -1)/VMEM_PAGE_SIZE;
+
+    mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+    if (node == NULL) {
+        return -1;
+    }
+    free_page = node->page;
+    free_size = KEY_TO_VALUE(node->key);
+
+    alloc_pageno = free_page->pageno;
+    set_blocks_alloc(mm, alloc_pageno, npages);
+    if (npages != free_size) {
+        int free_pageno = alloc_pageno + npages;
+        set_blocks_free(mm, free_pageno, (free_size-npages));
+    }
+
+    VMEM_P_FREE(node);
+
+    ptr = mm->page_list[alloc_pageno].addr;
+    mm->alloc_page_count += npages;
+    mm->free_page_count  -= npages;
+
+
+    return ptr;
+}
+
+int
+vmem_free(
+	video_mm_t* mm,
+    unsigned long ptr,
+	unsigned long pid
+    )
+{
+    unsigned long addr;
+    avl_node_t* found;
+    page_t* page;
+    int pageno, prev_free_pageno, next_free_pageno;
+    int prev_size, next_size;
+    int merge_page_no, merge_page_size, free_page_size;
+	
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_free: invalid handle\n");
+		return -1;
+	}
+
+    addr = ptr;
+
+    mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+    if (found == NULL) {
+        printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+        VMEM_ASSERT(0);
+        return -1;
+    }
+
+    /* find previous free block */
+    page = found->page;
+    pageno = page->pageno;
+    free_page_size = page->alloc_pages;
+    prev_free_pageno = pageno-1;
+    prev_size = -1;
+    if (prev_free_pageno >= 0) {
+        if (mm->page_list[prev_free_pageno].used == 0) {
+            prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+            prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+        }
+    }
+
+    /* find next free block */
+    next_free_pageno = pageno + page->alloc_pages;
+    next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+    next_size = -1;
+    if (next_free_pageno >= 0) {
+        if (mm->page_list[next_free_pageno].used == 0) {
+            next_size = mm->page_list[next_free_pageno].alloc_pages;
+        }
+    }
+    VMEM_P_FREE(found);
+
+    /* merge */
+    merge_page_no = page->pageno;
+    merge_page_size = page->alloc_pages;
+    if (prev_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_no = found->page->pageno;
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+    if (next_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+
+    page->alloc_pages  = 0;
+    page->first_pageno = -1;
+
+    set_blocks_free(mm, merge_page_no, merge_page_size);
+
+    mm->alloc_page_count -= free_page_size;
+    mm->free_page_count  += free_page_size;
+
+    return 0;
+}
+
+int
+vmem_get_info(
+	video_mm_t* mm,
+    vmem_info_t* info
+    )
+{
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_get_info: invalid handle\n");
+		return -1;
+	}
+
+    if (info == NULL) {
+        return -1;
+    }
+
+    info->total_pages = mm->num_pages;
+    info->alloc_pages = mm->alloc_page_count;
+    info->free_pages  = mm->free_page_count;
+    info->page_size   = VMEM_PAGE_SIZE;
+
+    return 0;
+}
+
+
+
+#endif /* __VIDEO_MEMORY_MANAGEMENT_H__ */
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vpu.c b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vpu.c
new file mode 100644
index 00000000..5e643ea
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vpu.c
@@ -0,0 +1,1923 @@
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h> 
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/module.h>
+#include <linux/miscdevice.h>
+#include "vpuconfig.h"
+
+#include "vpu.h"
+#include "../puwrap.h"
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+extern unsigned int pu_alloc_dma_buffer(unsigned int size, unsigned long long *phys_addr, unsigned long *base);
+extern void pu_free_dma_buffer(unsigned long base, unsigned long long phys_addr);
+#endif
+extern void *pu_get_drv_context(void);
+
+// definitions to be changed as customer  configuration
+#define VPU_HACK_CLOCK_CONTROL
+//#define VPU_SUPPORT_CLOCK_CONTROL				//if you want to have clock gating scheme frame by frame
+//#define VPU_SUPPORT_ISR						//if the driver want to use interrupt service from kernel ISR //Fuchun 20131112 disabled, move to puwrap.c
+//#define VPU_SUPPORT_PLATFORM_DRIVER_REGISTER	//if the platform driver knows the name of this driver. VPU_PLATFORM_DEVICE_NAME 
+//#define VPU_SUPPORT_RESERVED_VIDEO_MEMORY		//if this driver knows the dedicated video memory address 
+
+#define VPU_PLATFORM_DEVICE_NAME "rtk_vpu"
+#define VPU_CLK_NAME "vpu_clk"
+#define VPU_DEV_NAME "vpu"
+
+// if the platform driver knows this driver. the definition of VPU_REG_BASE_ADDR and VPU_REG_SIZE are not meaningful
+#define VPU_REG_BASE_ADDR 0x18040000
+#define VPU_REG_SIZE 0x4000*3//(0x4000*MAX_NUM_VPU_CORE) //Fuchun 20131101, because coda855j's registers between coda980 and wave410
+
+#define VPU_VIRT_ADDR_MAP(addr)	(RBUS_BASE_VIRT + ((u32)addr - RBUS_BASE_PHYS))
+#define VPU_WRITE_REG_INT32U(addr,val)	writel(val, IOMEM(VPU_VIRT_ADDR_MAP(addr)))
+
+#define VPU_CLOCK_REG_BASE		0x18000000
+#define VPU_CLOCK_ENABLE_REG		0x1800000c
+#define VPU_CLOCK_PLL_REG		0x18000114
+#define VPU_CLOCK_PLL2_REG		0x18000118
+#define VPU_BONDING_REG		0x18007028
+
+//#ifdef VPU_SUPPORT_ISR
+#define VPU_IRQ_NUM 83//(23+32)
+//#endif
+
+
+#ifndef VM_RESERVED
+#define VM_RESERVED (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+typedef struct vpu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long interrupt_reason;
+} vpu_drv_context_t;
+
+/* To track the allocated memory buffer */
+typedef struct vpudrv_buffer_pool_t {
+	struct list_head list;
+	struct vpudrv_buffer_t vb;
+	struct file *filp;
+} vpudrv_buffer_pool_t;
+
+/* To track the instance index and buffer in instance pool */
+typedef struct vpudrv_instanace_list_t {
+	struct list_head list;
+	unsigned long inst_idx;
+	unsigned long core_idx;
+	struct file *filp;
+} vpudrv_instanace_list_t;
+
+typedef struct vpudrv_instance_pool_t {
+	unsigned char codecInstPool[MAX_NUM_INSTANCE][MAX_INST_HANDLE_SIZE];
+	void*         pendingInst;
+	int           pendingInstIdxPlus1;
+} vpudrv_instance_pool_t;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#define VPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)//(62*1024*1024)
+#define VPU_DRAM_PHYSICAL_BASE 0x06000000//0x86C00000
+#include "vmm.h"
+static video_mm_t s_vmem;	
+static vpudrv_buffer_t s_video_memory = {0};
+#endif //VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+
+
+static int vpu_hw_reset(u32 coreIdx);
+static void vpu_clk_disable(struct clk *clk);
+static int vpu_clk_enable(struct clk *clk);
+static struct clk *vpu_clk_get(struct device *dev, int coreIdx);
+static void vpu_clk_put(struct clk *clk);
+#ifdef CONFIG_PM
+static int vpu_suspend(struct platform_device *pdev, pm_message_t state);
+static int vpu_resume(struct platform_device *pdev);
+#endif
+// end customer definition
+static vpudrv_buffer_t s_instance_pool = {0};
+static vpudrv_buffer_t s_common_memory = {0};
+static vpu_drv_context_t s_vpu_drv_context;
+#if 0
+static int s_vpu_major;
+static struct class *s_vpu_class = NULL;
+static struct device *s_vpu_dev = NULL;
+static struct cdev s_vpu_cdev;
+#else
+static struct miscdevice s_vpu_dev;
+#endif
+static int s_vpu_open_ref_count;
+static int s_vpu_fourk_info_value = 0;
+static int s_vpu_fourk_info_instidx_plus1 = 0;
+static int s_vpu_fourk_info_coreidx = 0;
+static int s_vpu_fourk_info_enable[MAX_NUM_VPU_CORE][MAX_NUM_INSTANCE] = {0};
+static struct clk *s_vpu_clk_980;
+static struct clk *s_vpu_clk_410;
+static struct clk *s_vpu_clk_vpll;
+//#ifdef VPU_SUPPORT_ISR
+static int s_vpu_irq = VPU_IRQ_NUM;
+//#endif
+static u32 s_vpu_reg_phy_addr = VPU_REG_BASE_ADDR;
+static void __iomem *s_vpu_reg_virt_addr;
+
+static atomic_t s_interrupt_flag;
+static wait_queue_head_t s_interrupt_wait_q;
+
+static spinlock_t s_vpu_lock = __SPIN_LOCK_UNLOCKED(s_vpu_lock);
+static DEFINE_SEMAPHORE(s_vpu_sem);
+static struct list_head s_vbp_head = LIST_HEAD_INIT(s_vbp_head);
+static struct list_head s_inst_list_head = LIST_HEAD_INIT(s_inst_list_head);
+
+
+static vpu_bit_firmware_info_t s_bit_firmware_info[MAX_NUM_VPU_CORE];
+
+#ifdef CONFIG_PM
+/* implement to power management functions */
+#define BIT_BASE				0x0000
+#define BIT_CODE_RUN		(BIT_BASE + 0x000)
+#define BIT_CODE_DOWN		(BIT_BASE + 0x004)
+#define BIT_INT_CLEAR		(BIT_BASE + 0x00C)
+#define BIT_INT_STS			(BIT_BASE + 0x010)
+#define BIT_CODE_RESET		(BIT_BASE + 0x014)
+#define BIT_INT_REASON		(BIT_BASE + 0x174)
+#define BIT_BUSY_FLAG		(BIT_BASE + 0x160)
+#define BIT_RUN_COMMAND	(BIT_BASE + 0x164)
+#define BIT_RUN_INDEX		(BIT_BASE + 0x168)
+#define BIT_RUN_COD_STD	(BIT_BASE + 0x16C)
+
+/* WAVE4 registers */
+#define W4_REG_BASE				0x0000
+#define W4_VPU_INT_REASON_CLEAR	(W4_REG_BASE + 0x0034)
+#define W4_VPU_INT_CLEAR			(W4_REG_BASE + 0x003C)
+#define W4_VPU_INT_STS				(W4_REG_BASE + 0x0044)
+#define W4_VPU_INT_REASON			(W4_REG_BASE + 0x004c)
+
+#define W4_RET_SUCCESS				(W4_REG_BASE + 0x0110)
+#define W4_RET_FAIL_REASON		(W4_REG_BASE + 0x0114)
+
+/* WAVE4 INIT, WAKEUP */
+#define W4_PO_CONF					(W4_REG_BASE + 0x0000)
+#define W4_VCPU_CUR_PC				(W4_REG_BASE + 0x0004)
+
+#define W4_VPU_INT_ENABLE			(W4_REG_BASE + 0x0048)
+
+#define W4_RESET_REQ				(W4_REG_BASE + 0x0050)
+#define W4_RESET_STATUS			(W4_REG_BASE + 0x0054)
+
+#define W4_VPU_REMAP_CTRL			(W4_REG_BASE + 0x0060)
+#define W4_VPU_REMAP_VADDR		(W4_REG_BASE + 0x0064)
+#define W4_VPU_REMAP_PADDR		(W4_REG_BASE + 0x0068)
+#define W4_VPU_REMAP_PROC_START	(W4_REG_BASE + 0x006C)
+#define W4_VPU_BUSY_STATUS		(W4_REG_BASE + 0x0070)
+
+#define W4_REMAP_CODE_INDEX             0
+enum {
+    W4_INT_INIT_VPU          = 0,
+    W4_INT_DEC_PIC_HDR       = 1,
+    W4_INT_FINI_SEQ          = 2,
+    W4_INT_DEC_PIC           = 3,
+    W4_INT_SET_FRAMEBUF      = 4,
+    W4_INT_FLUSH_DEC         = 5,
+    W4_INT_GET_FW_VERSION    = 9,
+    W4_INT_QUERY_DEC         = 10,
+    W4_INT_SLEEP_VPU         = 11,
+    W4_INT_WAKEUP_VPU        = 12,
+    W4_INT_CHANGE_INT        = 13,       
+    W4_INT_CREATE_INSTANCE   = 14, 
+    W4_INT_BSBUF_EMPTY       = 15,   /*!<< Bitstream buffer empty */
+};
+
+#define W4_HW_OPTION				(W4_REG_BASE + 0x0124)
+#define W4_CODE_SIZE				(W4_REG_BASE + 0x011C)
+/* Note: W4_INIT_CODE_BASE_ADDR should be aligned to 4KB */
+#define W4_ADDR_CODE_BASE			(W4_REG_BASE + 0x0118)
+#define W4_CODE_PARAM				(W4_REG_BASE + 0x0120)
+/* Note: W4_INIT_STACK_BASE_ADDR should be aligned to 4KB */
+#define W4_ADDR_STACK_BASE		(W4_REG_BASE + 0x012C)
+#define W4_STACK_SIZE				(W4_REG_BASE + 0x0130)
+#define W4_INIT_VPU_TIME_OUT_CNT	(W4_REG_BASE + 0x0134)
+
+/* WAVE4 Wave4BitIssueCommand */
+#define W4_CORE_INDEX				(W4_REG_BASE + 0x0104)
+#define W4_INST_INDEX				(W4_REG_BASE + 0x0108)
+#define W4_COMMAND				(W4_REG_BASE + 0x0100)
+#define W4_VPU_HOST_INT_REQ		(W4_REG_BASE + 0x0038)
+
+/* Product register */
+#define VPU_PRODUCT_CODE_REGISTER	(BIT_BASE + 0x1044)
+
+
+static u32	s_vpu_reg_store[MAX_NUM_VPU_CORE][64];
+#if defined(CODA7L) || defined(CODA851)
+static u32 s_run_index;
+static u32 s_run_codstd;
+#endif
+#endif
+
+//------------------------------------------------------------------------------
+// common struct and definition
+//------------------------------------------------------------------------------
+typedef enum {
+    STD_AVC,
+    STD_VC1,
+    STD_MPEG2,
+    STD_MPEG4,
+    STD_H263,
+    STD_DIV3,
+    STD_RV,
+    STD_AVS,
+    STD_THO = 9,
+    STD_VP3,
+    STD_VP8,
+    STD_HEVC,
+    STD_MAX
+} CodStd;
+
+#define ENABLE_RM		(1 << 7)
+#define ENABLE_DIVX	(1 << 6)
+#define DISABLE_265	(1 << 5)
+
+static u32 support_codec_types = (1<<STD_AVC) | (1<<STD_VC1) | (1<<STD_MPEG2) | (1<<STD_MPEG4) | (1<<STD_H263) | (1<<STD_AVS) | (1<<STD_THO) | (1<<STD_VP8);
+
+
+#define ReadVpuRegister(addr, core)		*(volatile unsigned int *)(s_vpu_reg_virt_addr + s_bit_firmware_info[core].reg_base_offset + addr)
+#define WriteVpuRegister(addr, val, core)	*(volatile unsigned int *)(s_vpu_reg_virt_addr + s_bit_firmware_info[core].reg_base_offset + addr) = (unsigned int)val;
+#define WriteVpu(addr, val)				*(volatile unsigned int *)(addr) = (unsigned int)val;
+
+
+static int vpu_alloc_dma_buffer(vpudrv_buffer_t *vb)
+{
+	unsigned int ret;
+	if (!vb)
+		return -1;
+	
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	vb->phys_addr = (unsigned long long)vmem_alloc(&s_vmem, vb->size, 0);
+	if ((unsigned long)vb->phys_addr  == (unsigned long)-1)
+	{
+		printk(KERN_ERR "[VPUDRV] Physical memory allocation error size=%d\n", vb->size);
+		return -1;
+	}
+
+	vb->base = (unsigned long)(s_video_memory.base + (vb->phys_addr - s_video_memory.phys_addr));
+#elif CONFIG_RTK_RESERVE_MEMORY
+	ret = pu_alloc_dma_buffer(vb->size, &vb->phys_addr, &vb->base);
+	if(ret == -1)
+	{
+		printk(KERN_ERR "[VPUDRV] Physical memory allocation error size=%d\n", vb->size);
+		return -1;
+	}
+#else
+	vb->base = (unsigned long)dma_alloc_coherent(NULL, PAGE_ALIGN(vb->size), (dma_addr_t *) (&vb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(vb->base) == NULL) 
+	{
+		printk(KERN_ERR "[VPUDRV] Physical memory allocation error size=%d\n", vb->size);
+		return -1;
+	}
+#endif
+	printk("[VPUDRV] base:0x%x, phy_addr:0x%x, size:%d\n", vb->base, (unsigned long)vb->phys_addr, vb->size);
+	return 0;
+}
+
+static void vpu_free_dma_buffer(vpudrv_buffer_t *vb)
+{
+	if (!vb)
+		return;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (vb->base) 
+		vmem_free(&s_vmem, vb->phys_addr, 0);
+#elif CONFIG_RTK_RESERVE_MEMORY
+	pu_free_dma_buffer(vb->base, vb->phys_addr);
+#else
+	if (vb->base) 
+		dma_free_coherent(0, PAGE_ALIGN(vb->size), (void *)vb->base, vb->phys_addr);
+#endif
+}
+
+static int vpu_free_instances(struct file *filp) 
+{
+	vpudrv_instanace_list_t *vil, *n;
+	vpudrv_instance_pool_t *vip;
+	int instance_pool_size_per_core;
+
+	printk("[VPUDRV] vpu_free_instances\n");
+
+	instance_pool_size_per_core = (s_instance_pool.size/MAX_NUM_VPU_CORE); // s_instance_pool.size  assigned to the size of all core once call VDI_IOCTL_GET_INSTANCE_POOL by user.
+
+	list_for_each_entry_safe(vil, n, &s_inst_list_head, list) 
+	{
+		if (vil->filp == filp)
+		{
+			vip = (vpudrv_instance_pool_t *)(s_instance_pool.base + (instance_pool_size_per_core*vil->core_idx));
+			if (vip)
+			{
+				if (vil->inst_idx == (vip->pendingInstIdxPlus1-1) && vip->pendingInst != 0)
+				{
+					printk(KERN_WARNING "[VPUDRV] vil->inst_idx:%d, vil->core_idx:%d is pending, clear in here\n", vil->inst_idx, vil->core_idx);
+					vip->pendingInst = 0;
+					vip->pendingInstIdxPlus1 = 0;
+				}
+				memset(&vip->codecInstPool[vil->inst_idx], 0x00, 4);	// only first 4 byte is key point to free the corresponding instance.
+
+				if (vil->inst_idx == (s_vpu_fourk_info_instidx_plus1-1) && s_vpu_fourk_info_value == 1)
+				{
+					s_vpu_fourk_info_value = 0;
+					s_vpu_fourk_info_instidx_plus1 = 0;
+					s_vpu_fourk_info_coreidx = 0;
+				}
+			}
+			s_vpu_open_ref_count--;
+			s_vpu_fourk_info_enable[vil->core_idx][vil->inst_idx] = 0;
+			list_del(&vil->list);
+			kfree(vil);		
+		}
+	}
+
+	return 1;
+}
+
+static int vpu_free_buffers(struct file *filp)
+{
+	vpudrv_buffer_pool_t *pool, *n;
+	vpudrv_buffer_t vb;
+
+	printk(KERN_INFO "[VPUDRV] vpu_free_buffers\n");
+
+	list_for_each_entry_safe(pool, n, &s_vbp_head, list) 
+	{
+		if (pool->filp == filp)
+		{
+			vb = pool->vb;
+			if (vb.base) 
+			{
+				vpu_free_dma_buffer(&vb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+		
+	}
+
+	return 0;
+}
+
+void vpu_irq_handler2(int core_num, void *dev_id)
+{
+	//printk(KERN_INFO "[VPUDRV] vpu_irq_handler2, core_num:%d\n", core_num);
+	pu_drv_context_t *dev = (pu_drv_context_t *)dev_id;
+
+	if (s_bit_firmware_info[core_num].size == 0) // it means that we didn't get an information the current core from API layer. No core activated.
+		return;
+
+	//printk("BIT_INT_STS:0x%08x, WAVE4_VPU_INT_STS:0x%08x\n", ReadVpuRegister(BIT_INT_STS, 0), ReadVpuRegister(WAVE4_VPU_INT_STS, 1));
+
+	if(core_num == 0 && ReadVpuRegister(BIT_INT_STS, core_num))
+	{
+		dev->vpu_interrupt_reason = ReadVpuRegister(BIT_INT_REASON, core_num);
+		//printk("@@ In[%s][%d]  reason:%d @@\n", __func__, __LINE__, dev->vpu_interrupt_reason);
+		WriteVpuRegister(BIT_INT_REASON, 0, core_num);
+		WriteVpuRegister(BIT_INT_CLEAR, 0x1, core_num); 
+	}
+	else if(core_num == 1 && ReadVpuRegister(W4_VPU_INT_STS, core_num))
+	{
+		dev->vpu_interrupt_reason = ReadVpuRegister(W4_VPU_INT_REASON, core_num);
+		//printk("@@ In[%s][%d]  reason:%d @@\n", __func__, __LINE__, dev->vpu_interrupt_reason);
+		WriteVpuRegister(W4_VPU_INT_REASON_CLEAR, dev->vpu_interrupt_reason, core_num);
+		WriteVpuRegister(W4_VPU_INT_CLEAR, 0x1, core_num);
+	}
+
+	atomic_set(&s_interrupt_flag, 1);
+	wake_up_interruptible(&s_interrupt_wait_q);
+}
+
+#ifdef VPU_SUPPORT_ISR
+static irqreturn_t vpu_irq_handler(int irq, void *dev_id)
+{
+	vpu_drv_context_t *dev = (vpu_drv_context_t *)dev_id;
+
+	// this can be removed. it also work in VPU_WaitInterrupt of API function
+	int core;
+	int product_code;
+
+	printk(KERN_INFO "[VPUDRV] vpu_irq_handler\n");	
+
+	for (core=0; core<MAX_NUM_VPU_CORE; core++)
+	{
+		if (s_bit_firmware_info[core].size == 0) // it means that we didn't get an information the current core from API layer. No core activated.
+			continue;
+		product_code = ReadVpuRegister(VPU_PRODUCT_CODE_REGISTER, core);
+		if (product_code == WAVE410_CODE) {
+			if (ReadVpuRegister(W4_VPU_INT_STS, 1)) {
+				WriteVpuRegister(W4_VPU_INT_CLEAR, 0x1, 1);
+			}
+		}
+		else {
+			if (ReadVpuRegister(BIT_INT_STS, 0)) {
+				WriteVpuRegister(BIT_INT_CLEAR, 0x1, 0); 
+			}
+		}
+	}
+	
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN);	// notify the interrupt to user space
+	
+	atomic_set(&s_interrupt_flag, 1);
+	wake_up_interruptible(&s_interrupt_wait_q);
+	return IRQ_HANDLED;
+}
+#endif
+
+static int vpu_open(struct inode *inode, struct file *filp)
+{
+	spin_lock(&s_vpu_lock);
+#ifdef VPU_SUPPORT_ISR
+	filp->private_data = (void *)(&s_vpu_drv_context);
+#else
+	void *drv_context = pu_get_drv_context();
+	filp->private_data = (void *)(drv_context);
+#endif
+	spin_unlock(&s_vpu_lock);
+	return 0;
+}
+
+//static int vpu_ioctl(struct inode *inode, struct file *filp, u_int cmd, u_long arg) // for kernel 2.6.9 of C&M
+static long vpu_ioctl(struct file *filp, u_int cmd, u_long arg)
+{
+	int ret = 0; 
+	struct pu_drv_context_t *dev = (struct pu_drv_context_t *)filp->private_data;
+
+	switch (cmd) 
+	{
+	case VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+		{
+			vpudrv_buffer_pool_t *vbp;
+
+			down(&s_vpu_sem);
+
+			vbp = kzalloc(sizeof(*vbp), GFP_KERNEL);
+			if (!vbp)
+			{
+				up(&s_vpu_sem);
+				return -ENOMEM;
+			}
+
+			ret = copy_from_user(&(vbp->vb), (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret) 
+			{
+				kfree(vbp);
+				up(&s_vpu_sem);
+				return -EFAULT;
+			}
+
+			ret = vpu_alloc_dma_buffer(&(vbp->vb));
+			if (ret == -1) 
+			{
+				ret = -ENOMEM;
+				kfree(vbp);
+				up(&s_vpu_sem);
+				break;
+			}			
+			ret = copy_to_user((void __user *)arg, &(vbp->vb), sizeof(vpudrv_buffer_t));
+			if (ret) 
+			{
+				kfree(vbp);
+				ret = -EFAULT;
+				up(&s_vpu_sem);
+				break;
+			}
+
+			vbp->filp = filp;
+			spin_lock(&s_vpu_lock);
+			list_add(&vbp->list, &s_vbp_head);
+			spin_unlock(&s_vpu_lock);		
+
+			up(&s_vpu_sem);
+		}
+		break;
+	case VDI_IOCTL_FREE_PHYSICALMEMORY:
+		{
+
+			vpudrv_buffer_pool_t *vbp, *n;
+			vpudrv_buffer_t vb;
+
+			down(&s_vpu_sem);
+
+			ret = copy_from_user(&vb, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret)
+			{
+				up(&s_vpu_sem);
+				return -EACCES;
+			}
+
+			if (vb.base) 
+				vpu_free_dma_buffer(&vb);
+
+			spin_lock(&s_vpu_lock);
+			list_for_each_entry_safe(vbp, n, &s_vbp_head, list) 
+			{
+				if (vbp->vb.base == vb.base) 
+				{
+					list_del(&vbp->list);
+					kfree(vbp);
+					break;
+				}
+			}
+			spin_unlock(&s_vpu_lock);
+
+			up(&s_vpu_sem);
+
+		}
+		break;
+	case VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+		{
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+			if (s_video_memory.base != 0) 
+			{
+				ret = copy_to_user((void __user *)arg, &s_video_memory, sizeof(vpudrv_buffer_t));
+				if (ret != 0) 
+					ret = -EFAULT;
+			} 
+			else
+			{
+				ret = -EFAULT;
+			}
+#endif
+		}
+		break;
+	case VDI_IOCTL_WAIT_INTERRUPT:
+		{
+			vpudrv_intr_info_t info;
+
+			//printk("[VPUDRV] ioctl VDI_IOCTL_WAIT_INTERRUPT\n");
+			ret = copy_from_user(&info, (vpudrv_intr_info_t*)arg, sizeof(vpudrv_intr_info_t));
+			if (ret != 0)
+				return -EFAULT;
+
+			smp_rmb();
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q, atomic_read(&s_interrupt_flag) != 0, msecs_to_jiffies(info.timeout));
+			if (!ret)
+			{
+				ret = -ETIME;
+				//printk("[VPUDRV] ioctl VDI_IOCTL_WAIT_INTERRUPT fail\n");
+				break;
+			}
+			//printk("[VPUDRV] ioctl VDI_IOCTL_WAIT_INTERRUPT success\n");
+
+			if (signal_pending(current))
+			{
+				ret = -ERESTARTSYS;
+				break;
+			}
+
+			atomic_set(&s_interrupt_flag, 0);
+			info.intr_reason = dev->vpu_interrupt_reason;
+			ret = copy_to_user((void __user *)arg, &info, sizeof(vpudrv_intr_info_t));
+			if (ret != 0)
+				return -EFAULT;
+		}
+		break;
+	case VDI_IOCTL_ENABLE_INTERRUPT:
+		{
+			enable_irq(s_vpu_irq);
+		}
+		break;
+	case VDI_IOCTL_SET_CLOCK_GATE:
+		{
+			u32 clkgate;
+
+			if (get_user(clkgate, (u32 __user *) arg))
+				return -EFAULT;
+#ifdef VPU_SUPPORT_CLOCK_CONTROL
+			if (clkgate)
+				vpu_clk_enable(s_vpu_clk);
+			else
+				vpu_clk_disable(s_vpu_clk);
+#endif
+		}
+		break;
+	case VDI_IOCTL_GET_INSTANCE_POOL:
+		{
+			down(&s_vpu_sem);
+
+			if (s_instance_pool.base != 0) 
+			{
+				ret = copy_to_user((void __user *)arg, &s_instance_pool, sizeof(vpudrv_buffer_t));
+				if (ret != 0) 
+					ret = -EFAULT;
+			} 
+			else
+			{
+				ret = copy_from_user(&s_instance_pool, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+				if (ret == 0)
+				{
+					if (vpu_alloc_dma_buffer(&s_instance_pool) != -1)
+					{
+						memset((void *)s_instance_pool.base, 0x0, s_instance_pool.size); // clearing memory.
+						ret = copy_to_user((void __user *)arg, &s_instance_pool, sizeof(vpudrv_buffer_t));
+						if (ret == 0)
+						{
+							// success to get memory for instance pool
+							up(&s_vpu_sem);
+							break;
+						}
+					}
+				
+				}
+				ret = -EFAULT;
+			}
+			
+			up(&s_vpu_sem);
+		
+		}
+		break;
+	case VDI_IOCTL_GET_COMMON_MEMORY:
+		{
+			if (s_common_memory.base != 0) 
+			{
+				ret = copy_to_user((void __user *)arg, &s_common_memory, sizeof(vpudrv_buffer_t));
+				if (ret != 0) 
+					ret = -EFAULT;
+			} 
+			else
+			{
+				ret = copy_from_user(&s_common_memory, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+				if (ret == 0)
+				{
+					if (vpu_alloc_dma_buffer(&s_common_memory) != -1)
+					{
+						ret = copy_to_user((void __user *)arg, &s_common_memory, sizeof(vpudrv_buffer_t));
+						if (ret == 0)
+						{
+							// success to get memory for common memory
+							break;
+						}
+					}	
+				}
+
+				ret = -EFAULT;
+			}
+
+		}
+		break;
+	case VDI_IOCTL_OPEN_INSTANCE:
+		{
+			vpudrv_inst_info_t inst_info;
+			vpudrv_instanace_list_t *vil, *n;
+
+			vil = kzalloc(sizeof(*vil), GFP_KERNEL);
+			if (!vil)
+				return -ENOMEM;
+
+			if (copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t)))
+			{
+				kfree(vil);
+				return -EFAULT;
+			}
+
+			vil->inst_idx = inst_info.inst_idx;
+			vil->core_idx = inst_info.core_idx;
+			vil->filp = filp;
+			spin_lock(&s_vpu_lock);
+			list_add(&vil->list, &s_inst_list_head);
+
+			inst_info.inst_open_count = 0; // counting the current open instance number
+			list_for_each_entry_safe(vil, n, &s_inst_list_head, list) 
+			{
+				if (vil->core_idx == inst_info.core_idx)
+					inst_info.inst_open_count++;
+			}
+			spin_unlock(&s_vpu_lock);			
+
+			s_vpu_open_ref_count++; //flag just for that vpu is in opened or closed
+
+			if (copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t)))
+				return -EFAULT;
+
+			printk("[VPUDRV] VDI_IOCTL_OPEN_INSTANCE core_idx=%d, inst_idx=%d, s_vpu_open_ref_count=%d, inst_open_count=%d\n", (int)inst_info.core_idx, (int)inst_info.inst_idx, s_vpu_open_ref_count, inst_info.inst_open_count);
+		}
+		break;
+	case VDI_IOCTL_CLOSE_INSTANCE:
+		{
+			vpudrv_inst_info_t inst_info;
+			vpudrv_instanace_list_t *vil, *n;
+
+			if (copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t)))
+				return -EFAULT;
+
+			spin_lock(&s_vpu_lock);
+
+			list_for_each_entry_safe(vil, n, &s_inst_list_head, list) 
+			{
+				if (vil->inst_idx == inst_info.inst_idx && vil->core_idx == inst_info.core_idx)
+				{
+					list_del(&vil->list);
+					kfree(vil);
+					break;
+				}
+			}
+
+			inst_info.inst_open_count = 0; // counting the current open instance number
+			list_for_each_entry_safe(vil, n, &s_inst_list_head, list) 
+			{
+				if (vil->core_idx == inst_info.core_idx)
+					inst_info.inst_open_count++;
+			}
+			spin_unlock(&s_vpu_lock);
+			
+			s_vpu_open_ref_count--; // flag just for that vpu is in opened or closed
+
+			if (copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t)))
+				return -EFAULT;
+
+			printk("[VPUDRV] VDI_IOCTL_CLOSE_INSTANCE core_idx=%d, inst_idx=%d, s_vpu_open_ref_count=%d, inst_open_count=%d\n", (int)inst_info.core_idx, (int)inst_info.inst_idx, s_vpu_open_ref_count, inst_info.inst_open_count);
+		}
+		break;
+	case VDI_IOCTL_GET_INSTANCE_NUM:
+		{
+			vpudrv_inst_info_t inst_info;
+			vpudrv_instanace_list_t *vil, *n;
+			
+			ret = copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t));
+			if (ret != 0) 
+				break;
+
+			inst_info.inst_open_count = 0;
+
+			spin_lock(&s_vpu_lock);
+			list_for_each_entry_safe(vil, n, &s_inst_list_head, list) 
+			{
+				if (vil->core_idx == inst_info.core_idx)
+					inst_info.inst_open_count++;					
+			}
+			spin_unlock(&s_vpu_lock);		
+			
+			ret = copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t));
+
+			printk("[VPUDRV] VDI_IOCTL_GET_INSTANCE_NUM core_idx=%d, inst_idx=%d, open_count=%d\n", (int)inst_info.core_idx, (int)inst_info.inst_idx, inst_info.inst_open_count);
+
+		}
+		break;
+	case VDI_IOCTL_RESET:
+		{
+			u32 coreIdx;
+			if (get_user(coreIdx, (u32 __user *) arg))
+				return -EFAULT;
+			vpu_hw_reset(coreIdx);
+		}
+		break;
+	/*
+		VPU Clock setting value
+		0x0860E600      //432MHz
+		0x0869C600      //418.5MHz
+		0x0860D600      //405MHz
+		0x0860A600      //324MHz
+		0x08695600      //310.5MHz
+		0x08609600      //297MHz
+		0x08693600      //283.5MHz
+		0x08607600      //243MHz
+		0x08606600      //216MHz
+	*/
+	case VDI_IOCTL_SET_CLOCK:
+		{
+			vpu_clock_info_t clockInfo;
+			ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+			if (ret == 0)
+			{
+				u32 clk_en_val, ve_en_val;
+				printk(KERN_INFO "[VPUDRV] VDI_IOCTL_SET_CLOCK value:0x%08x\n", clockInfo.value);
+				clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+				ve_en_val = clk_en_val & (1 << 29 | 1 << 12);
+				VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, (clk_en_val & ~ve_en_val)); //Disable clock gating
+				VPU_WRITE_REG_INT32U(VPU_CLOCK_PLL_REG, clockInfo.value);
+#if 0
+				VPU_WRITE_REG_INT32U(VPU_CLOCK_PLL2_REG, 0x5); //Power On
+				VPU_WRITE_REG_INT32U(VPU_CLOCK_PLL2_REG, 0x7); //Release Reset
+				__delay(100);
+				VPU_WRITE_REG_INT32U(VPU_CLOCK_PLL2_REG, 0x3); //Release Reset
+#else
+				__delay(100);
+#endif
+				clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+				VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, (clk_en_val | ve_en_val)); //Enable clock gating
+				break;
+			}
+
+			ret = -EFAULT;
+		}
+		break;
+	case VDI_IOCTL_GET_CLOCK:
+		{
+			vpu_clock_info_t clockInfo;
+			clockInfo.value = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_PLL_REG)));
+			printk(KERN_INFO "[VPUDRV] VDI_IOCTL_GET_CLOCK value:0x%08x\n", clockInfo.value);
+			ret = copy_to_user((vpu_clock_info_t *)arg, &clockInfo, sizeof(vpu_clock_info_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		}
+		break;
+	/*
+		Clock Enable
+		1 << 29    clk_en_ve_h265
+		1 << 13    clk_en_ve_jpeg
+		1 << 12    clk_en_ve_h264
+	*/
+	case VDI_IOCTL_SET_CLOCK_ENABLE:
+		{
+			vpu_clock_info_t clockInfo;
+			ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+			if (ret == 0)
+			{
+				unsigned int clk_en_val;
+				//printk(KERN_INFO "[VPUDRV]  VDI_IOCTL_SET_CLOCK_ENABLE value:0x%08x\n", clockInfo.value);
+				clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+				clk_en_val |= clockInfo.value;
+				VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, clk_en_val);
+				__delay(100);
+				break;
+			}
+
+			ret = -EFAULT;
+		}
+		break;
+	case VDI_IOCTL_SET_CLOCK_DISABLE:
+		{
+			vpu_clock_info_t clockInfo;
+			ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+			if (ret == 0)
+			{
+				u32 clk_en_val;
+				//printk(KERN_INFO "[VPUDRV]  VDI_IOCTL_SET_CLOCK_DISABLE value:0x%08x\n", clockInfo.value);
+				clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+				clk_en_val &= ~(clockInfo.value);
+				VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, clk_en_val);
+				__delay(100);
+				break;
+			}
+
+			ret = -EFAULT;
+		}
+		break;
+	case VDI_IOCTL_GET_SUPPORT_TYPE:
+		{
+			ret = put_user(support_codec_types, (u32 __user *)arg);
+			if (ret != 0)
+				ret = -EFAULT;
+		}
+		break;
+	case VDI_IOCTL_FOURK_INFO:
+		{
+			vpudrv_fourk_info_t fourkInfo;
+			ret = copy_from_user(&fourkInfo, (vpudrv_fourk_info_t *)arg, sizeof(vpudrv_fourk_info_t));
+			if (ret == 0)
+			{
+				spin_lock(&s_vpu_lock);
+				switch(fourkInfo.setvalue)
+				{
+					case FOURK_SET_PENDING:
+					{
+						s_vpu_fourk_info_value = fourkInfo.value;
+						if (s_vpu_fourk_info_value == 1)
+						{
+							s_vpu_fourk_info_instidx_plus1 = (fourkInfo.inst_idx+1);
+							s_vpu_fourk_info_coreidx = fourkInfo.core_idx;
+						}
+						else
+						{
+							s_vpu_fourk_info_instidx_plus1 = 0;
+							s_vpu_fourk_info_coreidx = 0;
+						}
+						printk(KERN_INFO "[FOURK_SET_PENDING] s_vpu_fourk_info_value:%d, inst_idx:%d\n", s_vpu_fourk_info_value, fourkInfo.inst_idx);
+						break;
+					}
+					case FOURK_GET_PENDING:
+					{
+						if (fourkInfo.core_idx == s_vpu_fourk_info_coreidx && fourkInfo.inst_idx == (s_vpu_fourk_info_instidx_plus1-1))
+							fourkInfo.value = 0;
+						else
+							fourkInfo.value = s_vpu_fourk_info_value;
+						printk(KERN_INFO "[FOURK_GET_PENDING] inst_idx:%d, value:%d\n", fourkInfo.inst_idx, fourkInfo.value);
+						ret = copy_to_user((vpudrv_fourk_info_t *)arg, &fourkInfo, sizeof(vpudrv_fourk_info_t));
+						if (ret != 0)
+							ret = -EFAULT;
+						break;
+					}
+					case FOURK_SET_INSTANCE_TYPE:
+					{
+						s_vpu_fourk_info_enable[fourkInfo.core_idx][fourkInfo.inst_idx] = fourkInfo.value;
+						printk(KERN_INFO "[FOURK_SET_INSTANCE_TYPE] inst_idx:%d, value:%d\n", fourkInfo.inst_idx, fourkInfo.value);
+						break;
+					}
+					case FOURK_GET_INSTANCE_NUM:
+					{
+						unsigned int i, j;
+						unsigned int totalNum = 0;
+						for (i = 0; i < MAX_NUM_VPU_CORE; i++)
+						{
+							for (j = 0; j < MAX_NUM_INSTANCE; j++)
+							{
+								totalNum += s_vpu_fourk_info_enable[i][j];
+							}
+						}
+						fourkInfo.value = totalNum;
+						printk(KERN_INFO "[FOURK_GET_INSTANCE_NUM] inst_idx:%d, value:%d\n", fourkInfo.inst_idx, fourkInfo.value);
+						ret = copy_to_user((vpudrv_fourk_info_t *)arg, &fourkInfo, sizeof(vpudrv_fourk_info_t));
+						if (ret != 0)
+							ret = -EFAULT;
+						break;
+					}
+					case FOURK_GET_INSTIDX:
+					{
+						printk(KERN_INFO "[FOURK_GET_INSTIDX] inst_idx:%d, (s_vpu_fourk_info_instidx_plus1-1):%d\n", fourkInfo.inst_idx, (s_vpu_fourk_info_instidx_plus1-1));
+						fourkInfo.inst_idx = (s_vpu_fourk_info_instidx_plus1-1);
+						ret = copy_to_user((vpudrv_fourk_info_t *)arg, &fourkInfo, sizeof(vpudrv_fourk_info_t));
+						if (ret != 0)
+							ret = -EFAULT;
+						break;
+					}
+					default:
+					{
+						printk(KERN_ERR "[VPUDRV] No such setvalue, fourkInfo.setvalue is %d\n", fourkInfo.setvalue);
+						break;
+					}
+				}
+				spin_unlock(&s_vpu_lock);
+				break;
+			}
+
+			ret = -EFAULT;
+		}
+#ifdef CONFIG_PM
+	case VDI_IOCTL_SLEEP:
+		{
+			pm_message_t msg;
+			vpu_suspend(NULL, msg);
+			break;
+		}
+	case VDI_IOCTL_WAKEUP:
+		vpu_resume(NULL);
+		break;
+#endif
+	default:
+		{
+			printk(KERN_ERR "[VPUDRV] No such IOCTL, cmd is %d\n", cmd);
+		}
+		break;
+	}
+	return ret;
+}
+
+static ssize_t vpu_read(struct file *filp, char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static ssize_t vpu_write(struct file *filp, const char __user *buf, size_t len, loff_t *ppos)
+{
+	printk(KERN_INFO "[VPUDRV] vpu_write len=%d\n", (int)len);
+	if ( !buf )
+	{
+		printk(KERN_ERR "[VPUDRV] vpu_write buf = NULL error \n");
+		return -EFAULT;
+	}
+
+	if (len == sizeof(vpu_bit_firmware_info_t))
+	{
+		vpu_bit_firmware_info_t *bit_firmware_info;
+
+		bit_firmware_info = kzalloc(sizeof(vpu_bit_firmware_info_t), GFP_KERNEL);
+		if (!bit_firmware_info)
+		{
+			printk(KERN_ERR "[VPUDRV] vpu_write  bit_firmware_info allocation error \n");
+			return -EFAULT;
+		}
+
+		if (copy_from_user(bit_firmware_info, buf, len)) {
+			printk(KERN_ERR "[VPUDRV] vpu_write copy_from_user error for bit_firmware_info\n");
+			kfree(bit_firmware_info);
+			return -EFAULT;		
+		}
+
+		if (bit_firmware_info->size == sizeof(vpu_bit_firmware_info_t))
+		{
+			printk("[VPUDRV] vpu_write set bit_firmware_info coreIdx=0x%x, reg_base_offset=0x%x size=0x%x, bit_code[0]=0x%x\n",
+			bit_firmware_info->core_idx, (int)bit_firmware_info->reg_base_offset, bit_firmware_info->size, bit_firmware_info->bit_code[0]); 
+
+			if (bit_firmware_info->core_idx > MAX_NUM_VPU_CORE)
+			{
+				printk(KERN_ERR "[VPUDRV] vpu_write coreIdx[%d] is exceeded than MAX_NUM_VPU_CORE[%d]\n", bit_firmware_info->core_idx, MAX_NUM_VPU_CORE);
+				kfree(bit_firmware_info);
+				return -ENODEV;
+			}
+    
+			memcpy((void *)&s_bit_firmware_info[bit_firmware_info->core_idx], bit_firmware_info, sizeof(vpu_bit_firmware_info_t));
+			kfree(bit_firmware_info);
+			return len;
+		}
+
+		kfree(bit_firmware_info);
+	}
+
+	return -1;
+}
+
+static int vpu_release(struct inode *inode, struct file *filp)
+{
+	printk(KERN_INFO "[VPUDRV] vpu_release open_count=%d\n", s_vpu_open_ref_count);
+
+	spin_lock(&s_vpu_lock);
+
+		/* found and free the not handled buffer by user applications */
+		vpu_free_buffers(filp);		
+
+		/* found and free the not closed instance by user applications */
+		vpu_free_instances(filp);
+
+	spin_unlock(&s_vpu_lock);
+
+	return 0;
+}
+
+
+static int vpu_fasync(int fd, struct file *filp, int mode)
+{
+	struct vpu_drv_context_t *dev = (struct vpu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+
+static int vpu_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	pfn = s_vpu_reg_phy_addr >> PAGE_SHIFT;
+
+	return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+
+static int vpu_map_to_physical_memory(struct file *fp, struct vm_area_struct *vm)
+{
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot); 
+
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+static int vpu_map_to_instance_pool_memory(struct file *fp, struct vm_area_struct *vm)
+{
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+/*!
+ * @brief memory map interface for vpu file operation
+ * @return  0 on success or negative error code on error
+ */
+static int vpu_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+	if (vm->vm_pgoff) 
+	{
+		if(vm->vm_pgoff == (s_instance_pool.phys_addr>>PAGE_SHIFT))
+			return  vpu_map_to_instance_pool_memory(fp, vm);
+	
+		return vpu_map_to_physical_memory(fp, vm);
+	}
+	else
+		return vpu_map_to_register(fp, vm);
+}
+
+struct file_operations vpu_fops = {
+	.owner = THIS_MODULE,
+	.open = vpu_open,
+	.read = vpu_read,
+	.write = vpu_write,
+	//.ioctl = vpu_ioctl, // for kernel 2.6.9 of C&M
+	.unlocked_ioctl = vpu_ioctl,
+	.release = vpu_release,
+	.fasync = vpu_fasync,
+	.mmap = vpu_mmap,
+};
+
+
+
+
+static int vpu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+	struct resource *res=NULL;
+	printk(KERN_INFO "[VPUDRV] vpu_probe\n");
+
+	if(pdev)
+		res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (res) 	// if platform driver is implemented
+	{
+		s_vpu_reg_phy_addr = res->start;
+		s_vpu_reg_virt_addr = ioremap(res->start, res->end - res->start);
+		printk(KERN_INFO "[VPUDRV] : 1 vpu base address get from platform driver physical base addr=0x%x, virtual base=0x%x\n", (int)s_vpu_reg_phy_addr , (int)s_vpu_reg_virt_addr);		
+	}
+	else
+	{
+		s_vpu_reg_virt_addr = ioremap(s_vpu_reg_phy_addr, VPU_REG_SIZE);
+		printk(KERN_INFO "[VPUDRV] : 2 vpu base address get from defined value physical base addr=0x%x, virtual base=0x%x\n", (int)s_vpu_reg_phy_addr, (int)s_vpu_reg_virt_addr);
+		
+	}
+
+#if 1
+	u32 bonding_value;
+	bonding_value = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_BONDING_REG)));
+
+	if (bonding_value & ENABLE_RM)
+		support_codec_types |= (1<<STD_RV);
+	if (bonding_value & ENABLE_DIVX)
+		support_codec_types |= (1 << STD_DIV3);
+	if ((bonding_value & DISABLE_265) == 0)
+		support_codec_types |= (1 << STD_HEVC);
+
+	//printk(KERN_INFO "[VPUDRV] BONDING_VALUE : 0x%08x, support_codec_types : 0x%08x\n", bonding_value, support_codec_types);
+#endif
+
+#if 0
+	/* get the major number of the character device */
+	if ((alloc_chrdev_region(&s_vpu_major, 0, 1, VPU_DEV_NAME)) < 0)
+	{
+		err = -EBUSY;
+		printk(KERN_ERR "could not allocate major number\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	s_vpu_class = class_create(THIS_MODULE, VPU_DEV_NAME);
+	if (IS_ERR(s_vpu_class))
+	{
+		err = -EBUSY;
+		printk(KERN_ERR "could not create class\n");
+
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	s_vpu_dev = device_create(s_vpu_class, NULL, MKDEV(s_vpu_major, 0), NULL, VPU_DEV_NAME);
+	if (IS_ERR(s_vpu_dev))
+	{
+		err = -EBUSY;
+		printk(KERN_ERR "could not create device\n");
+
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	/* initialize the device structure and register the device with the kernel */
+	cdev_init(&s_vpu_cdev, &vpu_fops);
+	if ((cdev_add(&s_vpu_cdev, s_vpu_major, 1)) < 0)
+	{
+		err = -EBUSY;
+		printk(KERN_ERR "could not allocate chrdev\n");
+
+		goto ERROR_PROVE_DEVICE;
+	}
+#else
+	s_vpu_dev.minor = MISC_DYNAMIC_MINOR;
+	s_vpu_dev.name = VPU_DEV_NAME;
+	s_vpu_dev.fops = &vpu_fops;
+	s_vpu_dev.parent = NULL;
+	if (misc_register(&s_vpu_dev)) {
+		printk("vpu: failed to register misc device.");
+		goto ERROR_PROVE_DEVICE;
+	}
+#endif
+
+	if (pdev)
+		s_vpu_clk_980 = vpu_clk_get(&pdev->dev, 0);
+	else
+		s_vpu_clk_980 = vpu_clk_get(NULL, 0);
+
+	if (!s_vpu_clk_980)
+		printk(KERN_ERR "[VPUDRV] : fail to get clock controller, but, do not treat as error, coreIdx=0\n");
+	else
+		printk(KERN_INFO "[VPUDRV] : get clock controller s_vpu_clk_980=0x%x\n", (int)s_vpu_clk_980);
+
+	if (pdev)
+		s_vpu_clk_410 = vpu_clk_get(&pdev->dev, 1);
+	else
+		s_vpu_clk_410 = vpu_clk_get(NULL, 1);
+
+	if (!s_vpu_clk_410)
+		printk(KERN_ERR "[VPUDRV] : fail to get clock controller, but, do not treat as error, coreIdx=1\n");
+	else
+		printk(KERN_INFO "[VPUDRV] : get clock controller s_vpu_clk_410=0x%x\n", (int)s_vpu_clk_410);
+
+	s_vpu_clk_vpll = clk_get(NULL, "vpll");
+	if (!s_vpu_clk_vpll)
+		printk(KERN_ERR "[VPUDRV] : fail to get clock controller, but, do not treat as error, coreIdx=vpll\n");
+	else
+		printk(KERN_INFO "[VPUDRV] : get clock controller s_vpu_clk_vpll=0x%x\n", (int)s_vpu_clk_vpll);
+
+#ifdef VPU_SUPPORT_CLOCK_CONTROL
+	vpu_clk_enable(s_vpu_clk_980);
+	vpu_clk_enable(s_vpu_clk_410);
+#endif
+
+
+#ifdef VPU_SUPPORT_ISR
+	if(pdev)
+		res = platform_get_resource(pdev, IORESOURCE_IRQ, 0);
+	if (res) 	// if platform driver is implemented
+	{
+		s_vpu_irq = res->start;
+		printk(KERN_INFO "[VPUDRV] : 1 vpu irq number get from platform driver irq=0x%x\n", s_vpu_irq );		
+	}
+	else
+	{
+		printk(KERN_INFO "[VPUDRV] : 2 vpu irq number get from defined value irq=0x%x\n", s_vpu_irq );
+	}
+
+
+	err = request_irq(s_vpu_irq, vpu_irq_handler, 0, "VPU_CODEC_IRQ", (void *)(&s_vpu_drv_context));
+	if (err)
+	{
+		printk(KERN_ERR "[VPUDRV] :  fail to register interrupt handler\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+#endif
+	
+	
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	s_video_memory.size = VPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+	s_video_memory.phys_addr = VPU_DRAM_PHYSICAL_BASE;
+	s_video_memory.base = (unsigned long)ioremap(s_video_memory.phys_addr, PAGE_ALIGN(s_video_memory.size));
+	if (!s_video_memory.base)
+	{	
+		printk(KERN_ERR "[VPUDRV] :  fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", (int)s_video_memory.phys_addr, (int)s_video_memory.base, (int)s_video_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+	
+	if (vmem_init(&s_vmem, s_video_memory.phys_addr, s_video_memory.size) < 0)
+	{
+		printk(KERN_ERR "[VPUDRV] :  fail to init vmem system\n");
+		goto ERROR_PROVE_DEVICE;
+	}
+	printk(KERN_INFO "[VPUDRV] success to probe vpu device with reserved video memory phys_addr=0x%x, base = 0x%x\n",(int) s_video_memory.phys_addr, (int)s_video_memory.base);
+#else
+	printk(KERN_INFO "[VPUDRV] success to probe vpu device with non reserved video memory\n");
+#endif	
+	
+	
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+#if 0
+	if (s_vpu_dev)
+	{
+		device_destroy(s_vpu_class, MKDEV(s_vpu_major, 0));
+		s_vpu_dev = NULL;
+	}
+
+	if (s_vpu_class)
+	{
+		class_destroy(s_vpu_class);
+		s_vpu_class = NULL;
+	}
+
+	if (s_vpu_major)
+		unregister_chrdev_region(s_vpu_major, 1);
+#else
+	misc_deregister(&s_vpu_dev);
+#endif
+
+	if (s_vpu_reg_virt_addr)
+		iounmap(s_vpu_reg_virt_addr);
+
+	return err;
+}
+
+static int vpu_remove(struct platform_device *pdev)
+{
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER	
+
+	printk(KERN_INFO "[VPUDRV] vpu_remove\n");
+	if (s_instance_pool.base) 
+	{
+		vpu_free_dma_buffer(&s_instance_pool);
+		s_instance_pool.base = 0;
+	}
+
+
+	if (s_common_memory.base)
+	{
+		vpu_free_dma_buffer(&s_common_memory);
+		s_common_memory.base = 0;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_video_memory.base) 
+	{
+		iounmap((void *)s_video_memory.base);
+		s_video_memory.base = 0;
+
+		vmem_exit(&s_vmem);		
+	}
+#endif
+
+#if 0
+	if (s_vpu_dev)
+	{
+		device_destroy(s_vpu_class, MKDEV(s_vpu_major, 0));
+		s_vpu_dev = NULL;
+	}
+
+	if (s_vpu_class)
+	{
+		class_destroy(s_vpu_class);
+		s_vpu_class = NULL;
+	}
+
+	if (s_vpu_major > 0)
+	{
+		cdev_del(&s_vpu_cdev);
+		unregister_chrdev_region(s_vpu_major, 1);
+		s_vpu_major = 0;
+	}
+#else
+	misc_deregister(&s_vpu_dev);
+#endif
+
+#ifdef VPU_SUPPORT_ISR	
+	if (s_vpu_irq)
+		free_irq(s_vpu_irq, &s_vpu_drv_context);
+#endif
+
+	if (s_vpu_reg_virt_addr)
+		iounmap(s_vpu_reg_virt_addr);
+
+	vpu_clk_put(s_vpu_clk_980);
+	vpu_clk_put(s_vpu_clk_410);
+#endif //VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	return 0;
+}
+
+#define WAVE4_STACK_SIZE		(8*1024)       /* DO NOT CHANGE */
+#define W4_MAX_CODE_BUF_SIZE	(512*1024)
+#define W4_CMD_INIT_VPU		(0x0001)
+#define W4_CMD_SLEEP_VPU		(0x0400)
+#define W4_CMD_WAKEUP_VPU	(0x0800)
+
+static void Wave4BitIssueCommand(Uint32 cmd)
+{
+	WriteVpuRegister(W4_VPU_BUSY_STATUS, 1, 1);
+	WriteVpuRegister(W4_CORE_INDEX,  0, 1);
+	//coreIdx = ReadVpuRegister(W4_VPU_BUSY_STATUS, 1);
+	//coreIdx = 0;
+	WriteVpuRegister(W4_INST_INDEX,  0, 1);
+	WriteVpuRegister(W4_COMMAND, cmd, 1);
+	WriteVpuRegister(W4_VPU_HOST_INT_REQ, 1, 1);
+
+	return;
+}
+
+#ifdef CONFIG_PM
+static int vpu_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	int i;
+	int core;
+	unsigned long timeout = jiffies + HZ;	// vpu wait timeout to 1sec
+
+	printk(KERN_INFO "[VPUDRV] vpu_suspend\n");
+#ifdef VPU_HACK_CLOCK_CONTROL
+	unsigned int clk_en_val;
+	clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+	clk_en_val |= (1 << 12 | 1 << 29);
+	VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, clk_en_val);
+	__delay(100);
+#else
+	vpu_clk_enable(s_vpu_clk_980);
+	vpu_clk_enable(s_vpu_clk_410);
+#endif
+
+	for (core=0; core<MAX_NUM_VPU_CORE; core++)
+	{
+		if (s_bit_firmware_info[core].size == 0)
+			continue;
+
+		if (core == 0)
+		{
+			while (ReadVpuRegister(BIT_BUSY_FLAG, core))
+			{
+				if (time_after(jiffies, timeout))
+				{
+					printk("In[%s][%d] BUSY timeout\n", __func__, __LINE__);
+					goto DONE_SUSPEND;
+				}
+			}
+
+#if defined(CODA7L) || defined(CODA851)
+			s_run_index = ReadVpuRegister(BIT_RUN_INDEX, core);
+			s_run_codstd = ReadVpuRegister(BIT_RUN_COD_STD, core);
+			WriteVpuRegister(BIT_BUSY_FLAG, 1, core);
+			WriteVpuRegister(BIT_RUN_COMMAND, VPU_SLEEP, core);
+
+			while (ReadVpuRegister(BIT_BUSY_FLAG, core))
+			{
+				if (time_after(jiffies, timeout))
+					goto DONE_SUSPEND;
+			}
+#endif
+
+			for ( i = 0 ; i < 64 ; i++)
+			{
+				s_vpu_reg_store[core][i] = ReadVpuRegister(BIT_BASE+(0x100+(i * 4)), core);
+			}
+		}
+		else
+		{
+			while (ReadVpuRegister(W4_VPU_BUSY_STATUS, core))
+			{
+				if (time_after(jiffies, timeout))
+				{
+					printk("In[%s][%d] BUSY timeout\n", __func__, __LINE__);
+					goto DONE_SUSPEND;
+				}
+			}
+
+			Wave4BitIssueCommand(W4_CMD_SLEEP_VPU);
+
+			while (ReadVpuRegister(W4_VPU_BUSY_STATUS, core) || ReadVpuRegister(W4_VPU_INT_STS, core))
+			{
+				if (time_after(jiffies, timeout))
+				{
+					printk("In[%s][%d] SLEEP_VPU BUSY timeout\n", __func__, __LINE__);
+					goto DONE_SUSPEND;
+				}
+			}
+
+			if (ReadVpuRegister(W4_RET_SUCCESS, core) == 0)
+			{
+				printk("SLEEP_VPU failed [0x%x]\n", ReadVpuRegister(W4_RET_FAIL_REASON, core));
+				goto DONE_SUSPEND;
+			}
+		}
+	}
+
+#ifdef VPU_HACK_CLOCK_CONTROL
+	clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+	clk_en_val &= ~(1 << 12 | 1 << 29);
+	VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, clk_en_val);
+	__delay(100);
+#else
+	vpu_clk_disable(s_vpu_clk_410);
+	vpu_clk_disable(s_vpu_clk_980);
+#endif
+	printk(KERN_INFO "[VPUDRV] vpu_suspend end\n");
+	
+	return 0;
+
+DONE_SUSPEND:
+#ifdef VPU_HACK_CLOCK_CONTROL
+	clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+	clk_en_val &= ~(1 << 12 | 1 << 29);
+	VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, clk_en_val);
+	__delay(100);
+#else
+	vpu_clk_disable(s_vpu_clk_410);
+	vpu_clk_disable(s_vpu_clk_980);
+#endif
+	return -EAGAIN;
+
+}
+
+static int vpu_resume(struct platform_device *pdev)
+{
+	int i;
+	int core;
+	u32 val;
+	unsigned long timeout = jiffies + HZ;	// vpu wait timeout to 1sec
+	unsigned long   code_base;
+	unsigned long   code_phys;
+	Uint32          code_size;
+	unsigned long   stack_base;
+	Uint32          stack_size;
+	Uint32          remap_size;
+	int             regVal;
+	Uint32          hwOption  = 0;
+	Uint32          *bitcode;
+
+	printk(KERN_INFO "[VPUDRV] vpu_resume\n");
+#ifdef VPU_HACK_CLOCK_CONTROL
+	unsigned int clk_en_val;
+	clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+	clk_en_val |= (1 << 12 | 1 << 29);
+	VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, clk_en_val);
+	__delay(100);
+#else
+	vpu_clk_enable(s_vpu_clk_980);
+	vpu_clk_enable(s_vpu_clk_410);
+#endif
+	WriteVpuRegister(0x7000, 0x13, core); //RTK wrapper for VE
+	
+	for (core=0; core<MAX_NUM_VPU_CORE; core++)
+	{
+		if (s_bit_firmware_info[core].size == 0)
+			continue;
+
+		if (core == 0)
+		{
+			WriteVpuRegister(BIT_CODE_RUN, 0, core);
+
+			//---- LOAD BOOT CODE
+			for( i = 0; i <512; i++ ) 
+			{
+				val = s_bit_firmware_info[core].bit_code[i];
+				WriteVpuRegister(BIT_CODE_DOWN, ((i << 16) | val), core);			
+			}
+
+			for (i = 0 ; i < 64 ; i++) 
+				WriteVpuRegister(BIT_BASE+(0x100+(i * 4)), s_vpu_reg_store[core][i], core);
+
+			WriteVpuRegister(BIT_BUSY_FLAG, 1, core);
+			WriteVpuRegister(BIT_CODE_RESET, 1, core);
+			WriteVpuRegister(BIT_CODE_RUN, 1, core);
+
+			while (ReadVpuRegister(BIT_BUSY_FLAG, core))
+			{
+				if (time_after(jiffies, timeout))
+				{
+					printk("In[%s][%d] BIT_CODE_RUN BUSY timeout\n", __func__, __LINE__);
+					goto DONE_WAKEUP;
+				}
+			}
+
+#if defined(CODA7L) || defined(CODA851)
+			WriteVpuRegister(BIT_BUSY_FLAG, 1, core);
+			WriteVpuRegister(BIT_RUN_INDEX,   s_run_index, core);
+			WriteVpuRegister(BIT_RUN_COD_STD, s_run_codstd, core);
+			WriteVpuRegister(BIT_RUN_COMMAND, VPU_WAKE, core);	
+
+			while (ReadVpuRegister(BIT_BUSY_FLAG, core))
+			{
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+#endif
+		}
+		else
+		{
+			code_base = s_common_memory.base+(core*SIZE_COMMON);
+			code_phys = (unsigned long)(s_common_memory.phys_addr+(core*SIZE_COMMON));
+			/* ALIGN TO 4KB */
+			code_size = (W4_MAX_CODE_BUF_SIZE&~0xfff);
+			bitcode = (unsigned int *)s_bit_firmware_info[core].bit_code;
+			if (code_size < s_bit_firmware_info[core].size*2) {
+				goto DONE_WAKEUP;
+			}
+			stack_base = code_phys + code_size;
+			stack_size = WAVE4_STACK_SIZE;
+
+#if 0
+			//---- LOAD BOOT CODE
+			for( i = 0; i < 256 ; i++ )
+			{
+				val = bitcode[i];
+				WriteVpu(code_base+(i*4), val);
+			}
+#endif
+#if 1
+			regVal = 0;
+			WriteVpuRegister(W4_PO_CONF, regVal, core);
+
+			/* Reset All blocks */
+			regVal = 0x7ffffff;
+			WriteVpuRegister(W4_RESET_REQ, regVal, core);    // Reset All blocks
+
+			/* Waiting reset done */
+			while (ReadVpuRegister(W4_RESET_STATUS, core))
+			{
+				if (time_after(jiffies, timeout))
+				{
+					printk("In[%s][%d] W4_RESET_REQ BUSY timeoutn", __func__, __LINE__);
+					goto DONE_WAKEUP;
+				}
+			}
+
+			WriteVpuRegister(W4_RESET_REQ, 0, core);
+
+			/* remap page size */
+			remap_size = (code_size >> 12) &0x1ff;
+			regVal = 0x80000000 | (W4_REMAP_CODE_INDEX<<12) | (0xf<<16) | (1<<11) | remap_size;
+			WriteVpuRegister(W4_VPU_REMAP_CTRL,     regVal, core);
+			WriteVpuRegister(W4_VPU_REMAP_VADDR,    0x00000000, core);    /* DO NOT CHANGE! */
+			WriteVpuRegister(W4_VPU_REMAP_PADDR,    code_phys, core);
+			WriteVpuRegister(W4_ADDR_CODE_BASE,     code_phys, core);
+			WriteVpuRegister(W4_CODE_SIZE,          code_size, core);
+			WriteVpuRegister(W4_CODE_PARAM,         0xf, core);
+			WriteVpuRegister(W4_INIT_VPU_TIME_OUT_CNT,   0xffff, core);
+
+			/* Stack */
+			WriteVpuRegister(W4_ADDR_STACK_BASE, stack_base, core);
+			WriteVpuRegister(W4_STACK_SIZE,      stack_size, core);
+			WriteVpuRegister(W4_HW_OPTION, hwOption, core);
+
+			/* Interrupt */
+			regVal  = (1<<W4_INT_DEC_PIC_HDR);
+			regVal |= (1<<W4_INT_DEC_PIC);
+			regVal |= (1<<W4_INT_QUERY_DEC);
+			regVal |= (1<<W4_INT_SLEEP_VPU);
+			regVal |= (1<<W4_INT_BSBUF_EMPTY);
+
+			WriteVpuRegister(W4_VPU_INT_ENABLE,  regVal, core);
+
+			Wave4BitIssueCommand(W4_CMD_INIT_VPU);
+			WriteVpuRegister(W4_VPU_REMAP_PROC_START, 1, core);
+#else
+			//for ( i = 0 ; i < 64 ; i++)
+			//	WriteVpuRegister(W4_REG_BASE + 0x100 + (i * 4), s_vpu_reg_store[core][i], core);
+
+			//WriteVpuRegister(W4_SET_CUR_SP, s_vpu_sp_store[core], core);
+
+
+			WriteVpuRegister(W4_ADDR_CODE_BASE,     code_base, core);
+			WriteVpuRegister(W4_CODE_SIZE,          code_size, core);
+			WriteVpuRegister(W4_CODE_PARAM,         0, core);
+			/* Stack */
+			WriteVpuRegister(W4_ADDR_STACK_BASE, stack_base, core);
+			WriteVpuRegister(W4_VPU_STACK_SIZE,  stack_size, core);
+
+			Wave4BitIssueCommand(W4_CMD_WAKEUP_VPU );
+#endif
+			while (ReadVpuRegister(W4_VPU_BUSY_STATUS, core) || ReadVpuRegister(W4_VPU_INT_STS, core))
+			{
+				if (time_after(jiffies, timeout))
+				{
+					printk("In[%s][%d] W4_CMD_INIT_VPU BUSY timeout\n", __func__, __LINE__);
+					goto DONE_WAKEUP;
+				}
+			}
+
+			if (ReadVpuRegister(W4_RET_SUCCESS, core) == 0)
+			{
+				printk("WAKEUP_VPU failed [0x%x]\n", ReadVpuRegister(W4_RET_FAIL_REASON, core));
+				goto DONE_WAKEUP;
+			}
+		}
+	}
+
+	if (s_vpu_open_ref_count == 0)
+	{
+#ifdef VPU_HACK_CLOCK_CONTROL
+		clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+		clk_en_val &= ~(1 << 12 | 1 << 29);
+		VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, clk_en_val);
+		__delay(100);
+#else
+		vpu_clk_disable(s_vpu_clk_410);
+		vpu_clk_disable(s_vpu_clk_980);
+#endif
+	}
+
+DONE_WAKEUP:
+
+	if (s_vpu_open_ref_count > 0)
+	{
+#ifdef VPU_HACK_CLOCK_CONTROL
+		clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+		clk_en_val |= (1 << 12 | 1 << 29);
+		VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, clk_en_val);
+		__delay(100);
+#else
+		vpu_clk_enable(s_vpu_clk_980);
+		vpu_clk_enable(s_vpu_clk_410);
+#endif
+	}
+
+	printk(KERN_INFO "[VPUDRV] vpu_resume end\n");
+
+	return 0;
+}
+#else
+#define	vpu_suspend	NULL
+#define	vpu_resume	NULL
+#endif				/* !CONFIG_PM */
+
+static struct platform_driver vpu_driver = {
+	.driver = {
+		   .name = VPU_PLATFORM_DEVICE_NAME,
+		   },
+	.probe = vpu_probe,
+	.remove = vpu_remove,
+	.suspend    = vpu_suspend,
+	.resume     = vpu_resume,
+};
+
+
+static int __init vpu_init(void)
+{
+	int res;
+
+	printk(KERN_INFO "[VPUDRV] begin vpu_init\n");	
+	init_waitqueue_head(&s_interrupt_wait_q);
+	s_common_memory.base = 0;
+	s_instance_pool.base = 0;
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	res = platform_driver_register(&vpu_driver);
+#else
+	res = platform_driver_register(&vpu_driver);
+	res = vpu_probe(NULL);
+#endif
+	printk(KERN_INFO "[VPUDRV] end vpu_init result=0x%x\n", res);	
+	return res;
+}
+
+static void __exit vpu_exit(void)
+{
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER	
+	printk(KERN_INFO "[VPUDRV] vpu_exit\n");
+	platform_driver_unregister(&vpu_driver);
+#else	
+	
+	vpu_clk_put(s_vpu_clk_980);
+	vpu_clk_put(s_vpu_clk_410);
+
+	if (s_instance_pool.base) 
+	{
+		vpu_free_dma_buffer(&s_instance_pool);
+		s_instance_pool.base = 0;
+	}
+
+
+	if (s_common_memory.base)
+	{
+		vpu_free_dma_buffer(&s_common_memory);
+		s_common_memory.base = 0;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_video_memory.base) 
+	{
+		iounmap((void *)s_video_memory.base);
+		s_video_memory.base = 0;
+
+		vmem_exit(&s_vmem);
+	}
+#endif
+
+#if 0
+	if (s_vpu_dev)
+	{
+		device_destroy(s_vpu_class, MKDEV(s_vpu_major, 0));
+		s_vpu_dev = NULL;
+	}
+
+	if (s_vpu_class)
+	{
+		class_destroy(s_vpu_class);
+		s_vpu_class = NULL;
+	}
+
+
+	if (s_vpu_major > 0)
+	{
+		cdev_del(&s_vpu_cdev);
+		unregister_chrdev_region(s_vpu_major, 1);
+		s_vpu_major = 0;
+	}
+#else
+	misc_deregister(&s_vpu_dev);
+#endif
+
+#ifdef VPU_SUPPORT_ISR	
+	if (s_vpu_irq)
+		free_irq(s_vpu_irq, &s_vpu_drv_context);
+#endif
+
+	if (s_vpu_reg_virt_addr) {
+		iounmap(s_vpu_reg_virt_addr);
+		s_vpu_reg_virt_addr = (void *)0x00;
+	}
+
+#endif
+
+	platform_driver_unregister(&vpu_driver);
+	return;
+}
+
+MODULE_AUTHOR("A customer using C&M VPU, Inc.");
+MODULE_DESCRIPTION("VPU linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(vpu_init);
+module_exit(vpu_exit);
+
+/*
+	reset bit
+	1 << 18    reset bit of VE_JPEG
+	1 << 17    reset bit of VE_H264
+	1 << 5     reset bit of VE_H265
+*/
+int vpu_hw_reset(u32 coreIdx)
+{
+	u32 reset_value = 0;
+	u32 reset_bit = 0;
+	u32 clk_en_val = 0;
+	u32 clk_en_bit = 0;
+
+	if (coreIdx == 0)
+	{
+		reset_bit = 1 << 17;
+		clk_en_bit = 1 << 12;
+	}
+	else
+	{
+		reset_bit = 1 << 5;
+		clk_en_bit = 1 << 29;
+	}
+
+	// disable clock gatting
+	clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+	clk_en_val &= ~clk_en_bit;
+	VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, clk_en_val);
+	__delay(100);
+
+	// reset vpu bit to 0
+	reset_value = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_REG_BASE)));
+	reset_value &= ~reset_bit;
+	VPU_WRITE_REG_INT32U(VPU_CLOCK_REG_BASE, reset_value);
+	__delay(100);
+
+	// reset vpu bit to 1
+	reset_value = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_REG_BASE)));
+	reset_value |= reset_bit;
+	VPU_WRITE_REG_INT32U(VPU_CLOCK_REG_BASE, reset_value);
+	__delay(100);
+
+	// enable clock gatting
+	clk_en_val = readl(IOMEM(VPU_VIRT_ADDR_MAP(VPU_CLOCK_ENABLE_REG)));
+	clk_en_val |= clk_en_bit;
+	VPU_WRITE_REG_INT32U(VPU_CLOCK_ENABLE_REG, clk_en_val);
+	__delay(100);
+
+	printk(KERN_INFO "[VPUDRV] request vpu reset from application. \n");
+	return 0;
+}
+
+
+struct clk *vpu_clk_get(struct device *dev, int coreIdx)
+{
+	if (coreIdx == 0)
+		return clk_get(dev, "h264");
+	else
+		return clk_get(dev, "h265");
+	//return clk_get(dev, VPU_CLK_NAME);
+}
+void vpu_clk_put(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk)))
+		clk_put(clk);
+}
+int vpu_clk_enable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))){
+		// the bellow is for C&M EVB.
+	  /*
+		{
+			struct clk *s_vpuext_clk = NULL;
+			s_vpuext_clk = clk_get(NULL, "vcore");
+			if (s_vpuext_clk)
+			{
+				printk(KERN_INFO "[VPUDRV] vcore clk=%p\n", s_vpuext_clk);	
+				clk_enable(s_vpuext_clk);
+			}
+
+			printk(KERN_INFO "[VPUDRV] vbus clk=%p\n", s_vpuext_clk);	
+			if (s_vpuext_clk)
+			{
+				s_vpuext_clk = clk_get(NULL, "vbus");
+				clk_enable(s_vpuext_clk);
+			}
+		}
+		*/
+		// for C&M EVB.
+
+		printk(KERN_INFO "[VPUDRV] vpu_clk_enable\n");	
+		return clk_enable(clk);
+	}
+
+	return 0;
+}
+
+void vpu_clk_disable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))){
+		printk(KERN_INFO "[VPUDRV] vpu_clk_disable\n");	
+		clk_disable(clk);
+	}
+}
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vpu.h b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vpu.h
new file mode 100644
index 00000000..81e0871
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vpu.h
@@ -0,0 +1,77 @@
+
+
+#ifndef __VPU_DRV_H__
+#define __VPU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+
+#define VDI_IOCTL_MAGIC  'V'
+#define VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY	_IO(VDI_IOCTL_MAGIC, 0)
+#define VDI_IOCTL_FREE_PHYSICALMEMORY		_IO(VDI_IOCTL_MAGIC, 1)
+#define VDI_IOCTL_WAIT_INTERRUPT			_IO(VDI_IOCTL_MAGIC, 2)
+#define VDI_IOCTL_SET_CLOCK_GATE			_IO(VDI_IOCTL_MAGIC, 3)
+#define VDI_IOCTL_RESET						_IO(VDI_IOCTL_MAGIC, 4)
+#define VDI_IOCTL_GET_INSTANCE_POOL			_IO(VDI_IOCTL_MAGIC, 5)
+#define VDI_IOCTL_GET_COMMON_MEMORY			_IO(VDI_IOCTL_MAGIC, 6)
+#define VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(VDI_IOCTL_MAGIC, 8)
+#define VDI_IOCTL_OPEN_INSTANCE				_IO(VDI_IOCTL_MAGIC, 9)
+#define VDI_IOCTL_CLOSE_INSTANCE			_IO(VDI_IOCTL_MAGIC, 10)
+#define VDI_IOCTL_GET_INSTANCE_NUM			_IO(VDI_IOCTL_MAGIC, 11)
+#define VDI_IOCTL_ENABLE_INTERRUPT			_IO(VDI_IOCTL_MAGIC, 12)
+#define VDI_IOCTL_SET_CLOCK					_IO(VDI_IOCTL_MAGIC, 13)
+#define VDI_IOCTL_GET_CLOCK					_IO(VDI_IOCTL_MAGIC, 14)
+#define VDI_IOCTL_SET_CLOCK_ENABLE			_IO(VDI_IOCTL_MAGIC, 15)
+#define VDI_IOCTL_SET_CLOCK_DISABLE			_IO(VDI_IOCTL_MAGIC, 16)
+#define VDI_IOCTL_GET_SUPPORT_TYPE			_IO(VDI_IOCTL_MAGIC, 17)
+#define VDI_IOCTL_FOURK_INFO				_IO(VDI_IOCTL_MAGIC, 18)
+#define VDI_IOCTL_SLEEP						_IO(VDI_IOCTL_MAGIC, 19)
+#define VDI_IOCTL_WAKEUP					_IO(VDI_IOCTL_MAGIC, 20)
+
+typedef enum {
+	FOURK_SET_PENDING,	/* 0 */
+	FOURK_GET_PENDING,
+	FOURK_SET_INSTANCE_TYPE,
+	FOURK_GET_INSTANCE_NUM,
+    FOURK_GET_INSTIDX,
+} FOURK_CODE;
+	
+
+typedef struct vpudrv_buffer_t {
+	unsigned int size;
+	unsigned long long phys_addr;
+	unsigned long base;							/* kernel logical address in use kernel */
+	unsigned long virt_addr;				/* virtual user space address */
+} vpudrv_buffer_t;
+
+typedef struct vpu_bit_firmware_info_t {
+	unsigned int size;						// size of this structure
+	unsigned int core_idx;
+	unsigned long reg_base_offset;
+	unsigned short bit_code[512];
+} vpu_bit_firmware_info_t;
+
+typedef struct vpu_clock_info_t{
+	unsigned int value;
+} vpu_clock_info_t;
+
+typedef struct vpudrv_inst_info_t {
+	unsigned int core_idx;
+	unsigned int inst_idx;
+	int inst_open_count;	// for output only
+} vpudrv_inst_info_t;
+
+typedef struct vpudrv_intr_info_t {
+	unsigned int timeout;
+	int intr_reason;
+} vpudrv_intr_info_t;
+
+typedef struct vpudrv_fourk_info_t {
+	unsigned int core_idx;
+	unsigned int inst_idx;
+	FOURK_CODE setvalue;
+	int value;
+} vpudrv_fourk_info_t;
+
+#endif
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vpuconfig.h b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vpuconfig.h
new file mode 100644
index 00000000..c2a80b5
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vpuconfig.h
@@ -0,0 +1,80 @@
+//--=========================================================================--
+//  This file is a part of VPU Reference API project
+//-----------------------------------------------------------------------------
+//
+//       This confidential and proprietary software may be used only
+//     as authorized by a licensing agreement from Chips&Media Inc.
+//     In the event of publication, the following notice is applicable:
+//
+//            (C) COPYRIGHT 2006 - 2011  CHIPS&MEDIA INC.
+//                      ALL RIGHTS RESERVED
+//
+//       The entire notice above must be reproduced on all authorized
+//       copies.
+//		This file should be modified by some customers according to their SOC configuration.
+//--=========================================================================--
+
+#ifndef _VPU_CONFIG_H_
+#define _VPU_CONFIG_H_
+#include "../config.h"
+#include "vputypes.h"
+
+
+#define BODA7503_CODE                   0x7503
+#define CODA7542_CODE                   0x7542
+#define BODA950_CODE                    0x9500
+#define CODA960_CODE                    0x9600
+#define CODA980_CODE                    0x9800
+#define WAVE320_CODE                    0x3200
+#define WAVE410_CODE                    0x4100          /* Wave410 version 1: Single vcore */
+#define WAVE412_CODE                    0x4102          /* Wave410 version 2: Multi vcore */
+
+#define MAX_INST_HANDLE_SIZE	        (32*1024)
+#define MAX_NUM_INSTANCE 4
+#define MAX_NUM_VPU_CORE 2
+
+#define MAX_ENC_AVC_PIC_WIDTH           4096
+#define MAX_ENC_AVC_PIC_HEIGHT          2304
+#define MAX_ENC_PIC_WIDTH               4096
+#define MAX_ENC_PIC_HEIGHT              2304
+#define MIN_ENC_PIC_WIDTH               96
+#define MIN_ENC_PIC_HEIGHT              16
+#define MAX_DEC_PIC_WIDTH               4096
+#define MAX_DEC_PIC_HEIGHT              2304
+
+//  Application specific configuration
+#define VPU_ENC_TIMEOUT                 5000
+#define VPU_DEC_TIMEOUT                 5000
+#define VPU_BUSY_CHECK_TIMEOUT          5000
+
+
+// codec specific configuration
+#define VPU_REORDER_ENABLE              1   // it can be set to 1 to handle reordering DPB in host side.
+#define CBCR_INTERLEAVE			        1 //[default 1 for BW checking with Viedo Conformance] 0 (chroma separate mode), 1 (chroma interleave mode) // if the type of tiledmap uses the kind of MB_RASTER_MAP. must set to enable CBCR_INTERLEAVE
+#define VPU_ENABLE_BWB			        1
+#define VPU_REPORT_USERDATA		        0
+
+#define HOST_ENDIAN                     VDI_LITTLE_ENDIAN
+#define VPU_FRAME_ENDIAN                HOST_ENDIAN
+#define VPU_STREAM_ENDIAN               HOST_ENDIAN
+#define VPU_USER_DATA_ENDIAN            HOST_ENDIAN
+
+#define W410_VPU_FRAME_ENDIAN		VDI_128BIT_LITTLE_ENDIAN
+#define W410_VPU_STREAM_ENDIAN		VDI_128BIT_LITTLE_ENDIAN
+
+#define DRAM_BUS_WIDTH                  16
+
+/************************************************************************/
+/* VPU COMMON MEMORY                                                    */
+/************************************************************************/
+#define SIZE_COMMON                     (2*1024*1024)
+
+//=====4. VPU REPORT MEMORY  ======================//
+#define SIZE_REPORT_BUF                 (0x10000)
+
+#define STREAM_END_SIZE                 0
+#define STREAM_END_SET_FLAG             0
+#define STREAM_END_CLEAR_FLAG           -1
+
+#endif  /* _VPU_CONFIG_H_ */
+
diff --git a/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vputypes.h b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vputypes.h
new file mode 100644
index 00000000..d544bd0
--- /dev/null
+++ b/drivers/soc/realtek/rtd119x/rtk_ve/vdi/vputypes.h
@@ -0,0 +1,59 @@
+//--=========================================================================--
+//  This file is a part of VPU Reference API project
+//-----------------------------------------------------------------------------
+//
+//       This confidential and proprietary software may be used only
+//     as authorized by a licensing agreement from Chips&Media Inc.
+//     In the event of publication, the following notice is applicable:
+//
+//            (C) COPYRIGHT 2006 - 2013  CHIPS&MEDIA INC.
+//                      ALL RIGHTS RESERVED
+//
+//       The entire notice above must be reproduced on all authorized
+//       copies.
+//
+//--=========================================================================--
+
+#ifndef _VPU_TYPES_H_
+#define _VPU_TYPES_H_
+
+typedef unsigned char	Uint8;
+typedef unsigned int	Uint32;
+typedef unsigned short	Uint16;
+typedef char	        Int8;
+typedef int	            Int32;
+typedef short	        Int16;
+#if defined(_MSC_VER)
+typedef unsigned _int64 Uint64;
+typedef _int64 Int64;
+#else
+typedef unsigned long long Uint64;
+typedef long long Int64;
+#endif
+#ifndef PhysicalAddress
+typedef Uint32 PhysicalAddress;
+#endif
+#ifndef BYTE
+typedef unsigned char   BYTE;
+#endif
+#ifndef BOOL
+typedef int BOOL;
+#endif
+#ifndef TRUE
+#define TRUE            1
+#endif /* TRUE */
+#ifndef FALSE
+#define FALSE           0
+#endif /* FALSE */
+#ifndef NULL
+#define NULL	0
+#endif
+
+
+#ifndef UNREFERENCED_PARAMETER
+#define UNREFERENCED_PARAMETER(P) { (P) = (P); }
+#endif
+
+
+
+#endif	/* _VPU_TYPES_H_ */
diff --git a/drivers/soc/realtek/rtd129x/Kconfig b/drivers/soc/realtek/rtd129x/Kconfig
new file mode 100644
index 00000000..2e016ee
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/Kconfig
@@ -0,0 +1,19 @@
+menu "RTD129x Device Drivers"
+
+config RTK_SW_LOCK_API
+	bool "Realtek SW LOCK API"
+	default y
+	help
+	  Realtek SW LOCK API driver
+
+config RTK_FAN
+	bool "Realtek Fan driver"
+	default n
+	help
+	  Realtek Fan driver
+
+source "drivers/soc/realtek/rtd129x/cwmp/Kconfig"
+source "drivers/soc/realtek/rtd129x/rtk_ve/Kconfig"
+source "drivers/soc/realtek/rtd129x/hw_nat/Kconfig"
+
+endmenu #RTD129x Device Drivers
diff --git a/drivers/soc/realtek/rtd129x/Makefile b/drivers/soc/realtek/rtd129x/Makefile
new file mode 100644
index 00000000..735d432
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/Makefile
@@ -0,0 +1,11 @@
+obj-$(CONFIG_ARCH_RTD129x) += rtd129x_spin_table.o rtd129x_cpu_hotplug.o rtd129x_cpu_wrapper.o rtd129x_restart.o
+obj-$(CONFIG_ARCH_RTD129x) += rtk_chip.o
+obj-$(CONFIG_ARCH_RTD129x) += rtk_usb.o
+obj-$(CONFIG_SUSPEND) += rtd129x_suspend.o
+obj-$(CONFIG_RTK_SW_LOCK_API) += rtd129x_lockapi.o
+obj-$(CONFIG_RTK_FAN) += rtd129x_fan.o
+obj-$(CONFIG_RTK_ACPU_RELOAD) += avcpu.o
+
+obj-$(CONFIG_RTK_CWMP_TREE) += cwmp/
+obj-$(CONFIG_RTK_CODEC) += rtk_ve/
+obj-$(CONFIG_RTD_1295_HWNAT) += hw_nat/
diff --git a/drivers/soc/realtek/rtd129x/avcpu.c b/drivers/soc/realtek/rtd129x/avcpu.c
new file mode 100644
index 00000000..b575b12
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/avcpu.c
@@ -0,0 +1,849 @@
+/*
+ * Realtek Audio & Video cpu driver
+ *
+ * Copyright (c) 2011 EJ Hsu <ejhsu@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License.
+ *
+ * History:
+ *
+ * 2011-12-02:  EJ Hsu: first version
+ * 2013-05-02:  EJ Hsu: port to arm platform
+ */
+
+#include <generated/autoconf.h>
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/device.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/fs.h>
+#include <linux/sched.h>
+#include <linux/platform_device.h>
+#include <linux/mtd/mtd.h>
+#include <linux/delay.h>
+#include <asm/uaccess.h>
+#include <asm/cacheflush.h>
+#include <asm/io.h>
+#include <soc/realtek/memory.h>
+#include <soc/realtek/rtk_ipc_shm.h>
+#include <soc/realtek/avcpu.h>
+
+
+#define CRT_BASE	0x98000000
+#define EMMC_FW_TABLE_OFFSET  0x620000
+
+#define HEADER_OFFSET         EMMC_FW_TABLE_OFFSET//0x2000000
+#define EMMC_BLOCK_SIZE       (0x200)
+
+#define MIPS_KSEG0BASE 0x80000000
+
+#define BYTE(d,n)       (((d) >> ((n) << 3)) & 0xFF)
+#define SWAPEND32(d)    ((BYTE(d,0) << 24) | (BYTE(d,1) << 16) | (BYTE(d,2) << 8) | (BYTE(d,3) << 0))
+#define SWAPEND64(d)    ((BYTE(d,0) << 56) | (BYTE(d,1) << 48) | (BYTE(d,2) << 40)| (BYTE(d,3) << 32) |\
+        (BYTE(d,4) << 24) | (BYTE(d,5) << 16) | (BYTE(d,6) << 8) | (BYTE(d,7) << 0))
+
+#define BE32_TO_CPU(value)      (value)
+#define CPU_TO_BE32(value)      SWAPEND32(value)
+#define BE64_TO_CPU(value)      (value)
+#define CPU_TO_BE64(value)      SWAPEND64(value)
+
+//#define av_be32_to_cpu(x)   htonl(x)
+
+#define DEVICE_EMMC             1
+#define BLK_READ_SIZE		SZ_256K
+
+static void __iomem *crt_base = NULL;
+static void __iomem *rpc_base = NULL;
+
+#define AVCPU_IPC_SHM	(rpc_base + 0xc4)
+
+#ifdef CONFIG_PM
+static int avcpu_suspend(struct platform_device *dev, pm_message_t state);
+static int avcpu_resume(struct platform_device *dev);
+#endif
+
+static BLOCKING_NOTIFIER_HEAD(avcpu_chain_head);
+
+static avcpu_info avpriv;
+static struct class *avcpu_class = NULL;
+static struct cdev avcpu_cdev;
+static struct platform_device *avcpu_platform_devs = NULL;
+static struct platform_driver avcpu_device_driver = {
+#ifdef CONFIG_PM
+    .suspend        = avcpu_suspend,
+    .resume         = avcpu_resume,
+#endif
+    .driver = {
+        .name       = "avcpu",
+        .bus        = &platform_bus_type,
+    },
+};
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+extern void rtk_xen_acpu_notify(int state);
+#endif //CONFIG_RTK_XEN_SUPPORT
+
+static int avcpu_ipc_shm_reset(void)
+{
+    int ret = 0;
+    struct rtk_ipc_shm old_shm = {0};
+    struct rtk_ipc_shm new_shm = {0};
+
+    memcpy(&old_shm, AVCPU_IPC_SHM, sizeof(struct rtk_ipc_shm));
+
+    /* start to copy some static variable from old shm */
+    new_shm.sys_assign_serial = old_shm.sys_assign_serial;
+    new_shm.pov_boot_vd_std_ptr = old_shm.pov_boot_vd_std_ptr; // maybe this item should be changed since it's one-step info?
+    new_shm.u_boot_version_magic = old_shm.u_boot_version_magic;
+    new_shm.u_boot_version_info = old_shm.u_boot_version_info;
+
+    memcpy_toio(AVCPU_IPC_SHM, &new_shm, sizeof(struct rtk_ipc_shm));
+
+    return ret;
+}
+
+int register_avcpu_notifier(struct notifier_block *nb)
+{
+    return blocking_notifier_chain_register(&avcpu_chain_head, nb);
+}
+EXPORT_SYMBOL_GPL(register_avcpu_notifier);
+
+int unregister_avcpu_notifier(struct notifier_block *nb)
+{
+    return blocking_notifier_chain_unregister(&avcpu_chain_head, nb);
+}
+EXPORT_SYMBOL_GPL(unregister_avcpu_notifier);
+
+int avcpu_notifier_call_chain(unsigned long val)
+{
+    return (blocking_notifier_call_chain(&avcpu_chain_head, val, NULL) == NOTIFY_BAD) ? -EINVAL : 0;
+}
+
+#ifdef CONFIG_PM
+static int avcpu_suspend(struct platform_device *dev, pm_message_t state)
+{
+#if 1
+    avcpu_notifier_call_chain(AVCPU_SUSPEND);
+#else
+    avpriv.status = AVSTAT_SUSPEND;
+    pr_info("\033[33m%s status:%d\033[m\n", __func__, avpriv.status);
+    //avcpu_notifier_call_chain(AVCPU_SUSPEND);
+    //avcpu_notifier_call_chain(AVCPU_RESET_PREPARE);
+    //resetav_lock(1);
+    //load_av_image(NULL, 0, NULL, 0, NULL, 0);
+#endif
+    return 0;
+}
+
+static int avcpu_resume(struct platform_device *dev)
+{
+#if 1
+    avcpu_notifier_call_chain(AVCPU_RESUME);
+#else
+    avpriv.status = AVSTAT_RESUME;
+    pr_info("\033[33m%s status:%d\033[m\n", __func__, avpriv.status);
+    wake_up_interruptible(&avpriv.status_wq);
+    //resetav_unlock(1);
+    //avcpu_notifier_call_chain(AVCPU_RESET_DONE);
+    //avcpu_notifier_call_chain(AVCPU_RESUME);
+#endif
+    return 0;
+}
+#endif
+
+static int avcpu_reset(resetav_struct *rs)
+{
+    blocking_notifier_call_chain(&avcpu_chain_head, AVCPU_RESET_PREPARE, NULL);
+    //resetav_lock(0);
+    load_av_image(rs->audio_image, rs->audio_start,
+            rs->video_image_1, rs->video_start_1, rs->video_image_2, rs->video_start_2);
+    //resetav_unlock(0);
+    blocking_notifier_call_chain(&avcpu_chain_head, AVCPU_RESET_DONE, NULL);
+    avpriv.status = AVSTAT_NORMAL;
+    pr_info("\033[33m%s:%d status:%d\033[m\n", __func__, __LINE__, avpriv.status);
+    return 0;
+}
+
+static int avcpu_stop(void)
+{
+    unsigned int mask = 0;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+    // Notify ACPU if not in idle state
+    struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+    unsigned int reg = __be32_to_cpu(readl(&ipc->xen_domu_boot_st));
+
+    if (XEN_DOMU_BOOT_ST_AUTHOR_GET(reg) != XEN_DOMU_BOOT_ST_AUTHOR_SCPU ||
+        XEN_DOMU_BOOT_ST_STATE_GET(reg) != XEN_DOMU_BOOT_ST_STATE_SCPU_WAIT_DONE) {
+        pr_info("Notify ACPU enter idle before take it off...\n");
+        rtk_xen_acpu_notify(XEN_DOMU_BOOT_ST_STATE_SCPU_POWOFF);
+    }
+#endif //CONFIG_RTK_XEN_SUPPORT
+
+    blocking_notifier_call_chain(&avcpu_chain_head, AVCPU_RESET_PREPARE, NULL);
+
+    writel(0x4, crt_base + 0x264); //PLL_VODMA2
+    writel(0x0, crt_base + 0x24);  //DISP_PLL_DIV2
+    writel(0x0, crt_base + 0x190); //PLL_HDMI
+    wmb();
+
+    /* Turn off CLK */
+    writel(readl(crt_base + 0x10) & ~BIT(4), crt_base + 0x10); //CLK : ACPU
+    mask = ~(unsigned int)(BIT(17) | BIT(15) | BIT(14) | BIT(8));
+    writel(readl(crt_base + 0x0c) & mask, crt_base + 0x0c); //CLK : SE, VO, TVE, HDMI
+    wmb();
+
+    /* Hold RST */
+    writel(readl(crt_base + 0x04) & ~BIT(0), crt_base + 0x04); //RST : ACPU
+    mask = ~(unsigned int)(BIT(28) | BIT(22) | BIT(20) | BIT(19) | BIT(12));
+    writel(readl(crt_base) & mask, crt_base); // RST : AE, SE, VO, TVE, HDMI
+    writel(readl(crt_base + 0x50) & ~BIT(15), crt_base + 0x50); //RST : DISP
+    wmb();
+    pr_info("\033[33mstop avcpu\033[m\n");
+    return 0;
+}
+
+static int avcpu_start(void)
+{
+    writel(readl(crt_base + 0x04) | BIT(0), crt_base + 0x04);
+    wmb();
+    mdelay(50);
+    writel(readl(crt_base + 0x10) | BIT(4), crt_base + 0x10);
+    wmb();
+    pr_info("\033[33mstart avcpu\033[m\n");
+    return 0;
+}
+
+int avcpu_alive(void)
+{
+    int ret = 0;
+
+    ret = !!(readl(crt_base + 0x04) & BIT(0));
+    ret &= !!(readl(crt_base + 0x10) & BIT(4));
+    ret &= !!(readl(crt_base + 0x0c) & BIT(15));
+
+    return ret;
+}
+
+long avcpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+    //avcpu_info *info = (avcpu_info *)filp->private_data;
+    resetav_struct rs;
+    int ret = 0;
+
+    switch (cmd) {
+        case AVCPU_IOCTRESET:
+            ret = copy_from_user(&rs, (void *)arg, sizeof(rs));
+            if (ret != 0)
+                break;
+            avcpu_reset(&rs);
+            break;
+        case AVCPU_IOCTSTOP:
+            avcpu_stop();
+            break;
+        case AVCPU_IOCTSTART:
+            avcpu_start();
+            break;
+        case AVCPU_IOCGSTATUS:
+            {
+                status_struct *st = (status_struct *)arg;
+                ret = wait_event_interruptible_timeout(avpriv.status_wq, (avpriv.status >= AVSTAT_RESUME), st->timeout * HZ / 1000);
+                st->status = avpriv.status;
+                if(avpriv.status == AVSTAT_RESUME)
+                    avpriv.status = AVSTAT_RESETAV;
+                //pr_debug("\033[33m%s:%d status:%d\033[m\n", __func__, __LINE__, avpriv.status);
+                break;
+            }
+        case AVCPU_IOCGALIVE:
+            if(!avcpu_alive()) {
+                pr_info("AVCPU not up!\n");
+                ret = -1;
+            }
+            break;
+        default:
+            ret = -EINVAL;
+            break;
+    };
+
+    return ret;
+}
+
+struct file_operations avcpu_fops = {
+    .owner                  = THIS_MODULE,
+    .unlocked_ioctl         = avcpu_ioctl,
+};
+
+static char *avcpu_devnode(struct device *dev, umode_t *mode)
+{
+    return NULL;
+}
+
+static unsigned int get_device_type(void)
+{
+    return DEVICE_EMMC;
+}
+
+static int load_av_from_file(int cpu, char *load_file, unsigned int load_addr)
+{
+#if 1
+    pr_err("avcpu: load from file not supported yet!\n");
+    return -1;
+#else
+    struct file *file;
+    int file_size;
+
+    printk("avcpu: load cpu %d from file %s to %x...\n", cpu, load_file, load_addr);
+    file = filp_open(load_file, O_RDONLY, 0444);
+    if (IS_ERR(file))
+        return PTR_ERR(file);
+    file_size = file->f_dentry->d_inode->i_size;
+    printk("file: %p size: %d \n", file, file_size);
+    if (kernel_read(file, 0, (char *)load_addr, file_size) != file_size)
+        BUG();
+    filp_close(file, 0);
+
+    switch (cpu) {
+        case AUDIO_CPU:
+            *((unsigned long *)AUDIO_ENTRY_ADDR) = htonl(load_addr);
+            printk("audio entry value: %08lx \n", *((unsigned long *)AUDIO_ENTRY_ADDR));
+            break;
+        case VIDEO_CPU_1:
+            *((unsigned long *)VIDEO_ENTRY_ADDR_1) = htonl(load_addr);
+            printk("video 1 entry value: %08lx \n", *((unsigned long *)VIDEO_ENTRY_ADDR_1));
+            break;
+        case VIDEO_CPU_2:
+            *((unsigned long *)VIDEO_ENTRY_ADDR_2) = htonl(load_addr);
+            printk("video 2 entry value: %08lx \n", *((unsigned long *)VIDEO_ENTRY_ADDR_2));
+            break;
+        default:
+            printk("avcpu: unknown cpu...\n");
+            return -ENODEV;
+    }
+
+    // flush the data cache...
+#ifdef CONFIG_MIPS
+    data_cache_flush(load_addr, file_size);
+#endif
+
+    return 0;
+#endif
+}
+
+#ifdef CONFIG_MMC_RTK_EMMC
+extern int mmc_fast_read(unsigned int, unsigned int, unsigned char *);
+#else
+int mmc_fast_read( unsigned int blk_addr,
+        unsigned int data_size,
+        unsigned char * buffer )
+{
+    /*TODO : avcpu porting by victor 20140211*/
+    return -1;
+}
+#endif
+
+static int read_emmc_data(unsigned int blk_offset, size_t size, void *buf)
+{
+    int ret = 0;
+    unsigned int blk_end = 0;
+    size_t blk_read_size = 0;
+
+    size = (size + (EMMC_BLOCK_SIZE -1)) & ~(EMMC_BLOCK_SIZE - 1);
+    blk_end = blk_offset + (size / EMMC_BLOCK_SIZE);
+    blk_read_size = BLK_READ_SIZE / EMMC_BLOCK_SIZE;
+    pr_info("avcpu: %s offset: %x, size: %lx, buf: %p \n", __func__, blk_offset, size / EMMC_BLOCK_SIZE, buf);
+
+    while (blk_offset < blk_end) {
+        if (blk_end - blk_offset < (BLK_READ_SIZE / EMMC_BLOCK_SIZE))
+            blk_read_size = blk_end - blk_offset;
+        if ((ret = mmc_fast_read(blk_offset, blk_read_size, buf)) < 0)
+            break;
+        blk_offset += BLK_READ_SIZE / EMMC_BLOCK_SIZE;
+        buf += BLK_READ_SIZE;
+    }
+
+    return ret;
+}
+
+int read_emmc_data_to_ioremap(unsigned long offset, unsigned int size, void  __iomem *ioptr)
+{
+	int ret = 0;
+	void *buf = NULL;
+	unsigned long read_end = offset + size;
+	unsigned int read_size = 0;
+	unsigned int read_left = 0;
+
+	if (!size) {
+		pr_err("bad size\n");
+		return -EINVAL;
+	}
+
+	if (!ioptr) {
+		pr_err("bad ioptr\n");
+		return -EINVAL;
+	}
+
+	if (!(buf = (void*)__get_free_page(GFP_KERNEL))) {
+		pr_err("couldn't allocate page\n");
+		return -ENOMEM;
+	}
+
+	/* only read 1 PAGE in each iteration since mmc_fast_rw only
+	   supports physical-continuous buffer */
+	do {
+		read_left = read_end - offset;
+		if (read_left >= PAGE_SIZE)
+			read_size = PAGE_SIZE;
+		else
+			read_size = ALIGN(read_left, EMMC_BLOCK_SIZE);
+
+		ret = read_emmc_data(offset / EMMC_BLOCK_SIZE, read_size, buf);
+		if (ret < 0)
+			goto out;
+
+		memcpy_toio(ioptr, buf, PAGE_SIZE);
+		offset += PAGE_SIZE;
+		ioptr += PAGE_SIZE;
+	} while (offset < read_end);
+out:
+	free_page((unsigned long)buf);
+	return ret;
+}
+
+unsigned long mips_to_arm(unsigned long addr)
+{
+    return (unsigned long)__va(addr & 0x1fffffff);
+}
+
+//#define DUBUG_FW_DESC_TABLE
+#ifdef DUBUG_FW_DESC_TABLE
+void dump_fw_desc_table_v1(fw_desc_table_v1_t *fw_desc_table_v1)
+{
+    if (fw_desc_table_v1 != NULL) {
+        printk("## Fw Desc Table ##############################\n");
+        printk("## fw_desc_table_v1                = 0x%08lx\n", (unsigned long)fw_desc_table_v1);
+        printk("## fw_desc_table_v1->signature     = %s\n", fw_desc_table_v1->signature);
+        printk("## fw_desc_table_v1->checksum      = 0x%08x\n", fw_desc_table_v1->checksum);
+        printk("## fw_desc_table_v1->version       = 0x%08x\n", fw_desc_table_v1->version);
+        printk("## fw_desc_table_v1->paddings      = 0x%08x\n", fw_desc_table_v1->paddings);
+        printk("## fw_desc_table_v1->part_list_len = 0x%08x\n", fw_desc_table_v1->part_list_len);
+        printk("## fw_desc_table_v1->fw_list_len   = 0x%08x\n", fw_desc_table_v1->fw_list_len);
+        printk("###############################################\n\n");
+    }
+    else {
+        printk("[ERR] %s:%d fw_desc_table_v1 is NULL.\n", __FUNCTION__, __LINE__);
+    }
+}
+
+void dump_part_desc_entry_v1(part_desc_entry_v1_t *part_entry)
+{
+    if (part_entry != NULL) {
+        printk("## Part Desc Entry ############################\n");
+        printk("## part_entry                      = 0x%08lx\n", (unsigned long)part_entry);
+        printk("## part_entry->type                = 0x%08x\n", part_entry->type);
+        printk("## part_entry->ro                  = 0x%08x\n", part_entry->ro);
+        printk("## part_entry->length              = %llu\n", part_entry->length);
+        printk("## part_entry->fw_count            = 0x%08x\n", part_entry->fw_count);
+        printk("## part_entry->fw_type             = 0x%08x\n", part_entry->fw_type);
+        printk("###############################################\n\n");
+    }
+    else {
+        printk("[ERR] %s:%d part_entry is NULL.\n", __FUNCTION__, __LINE__);
+    }
+}
+
+void dump_fw_desc_entry_v1(fw_desc_entry_v1_t *fw_entry)
+{
+    if (fw_entry != NULL) {
+        printk("## Fw Desc Entry ##############################\n");
+        printk("## fw_entry                        = 0x%08lx\n", (unsigned long)fw_entry);
+        printk("## fw_entry->type                  = 0x%08x\n", fw_entry->type);
+        printk("## fw_entry->lzma                  = 0x%08x\n", fw_entry->lzma);
+        printk("## fw_entry->ro                    = 0x%08x\n", fw_entry->ro);
+        printk("## fw_entry->version               = 0x%08x\n", fw_entry->version);
+        printk("## fw_entry->target_addr           = 0x%08x\n", fw_entry->target_addr);
+        printk("## fw_entry->offset                = 0x%08x\n", fw_entry->offset);
+        printk("## fw_entry->length                = 0x%08x\n", fw_entry->length);
+        printk("## fw_entry->paddings              = 0x%08x\n", fw_entry->paddings);
+        printk("## fw_entry->checksum              = 0x%08x\n", fw_entry->checksum);
+        printk("###############################################\n\n");
+    }
+    else {
+        printk("[ERR] %s:%d fw_entry is NULL.\n", __FUNCTION__, __LINE__);
+    }
+}
+
+void dump_fw_desc_entry_v2(fw_desc_entry_v2_t *fw_entry)
+{
+    int i;
+
+    if (fw_entry != NULL) {
+        printf("## Fw Desc Entry ##############################\n");
+        printf("## fw_entry                        = 0x%08x\n", fw_entry);
+        printf("## fw_entry->type                  = 0x%08x\n", fw_entry->type);
+        printf("## fw_entry->lzma                  = 0x%08x\n", fw_entry->lzma);
+        printf("## fw_entry->ro                    = 0x%08x\n", fw_entry->ro);
+        printf("## fw_entry->version               = 0x%08x\n", fw_entry->version);
+        printf("## fw_entry->target_addr           = 0x%08x\n", fw_entry->target_addr);
+        printf("## fw_entry->offset                = 0x%08lx\n", fw_entry->offset);
+        printf("## fw_entry->length                = 0x%08x\n", fw_entry->length);
+        printf("## fw_entry->paddings              = 0x%08x\n", fw_entry->paddings);
+        printf("## fw_entry->sha_hash              = ");
+        for (i = 0 ; i < 32 ; i++)
+            printf("%02x", fw_entry->sha_hash[i]);
+        printf("\n");
+        printf("###############################################\n\n");
+    } else {
+        printf("[ERR] %s:%d fw_entry is NULL.\n", __FUNCTION__, __LINE__);
+    }
+}
+#endif
+
+
+int load_av_from_emmc(char *audio_image, unsigned int audio_start,
+        char *video_image_1, unsigned int video_start_1, char *video_image_2, unsigned int video_start_2)
+{
+    fw_desc_table_v1_t *fw_desc_table_v1;
+    void *fw_entry = NULL, *audio_fw_entry = NULL, *fw_desc_ptr = NULL;
+    //fw_desc_entry_v1_t *fw_entry_v1;
+    //fw_desc_entry_v11_t *fw_entry_v11;
+    //fw_desc_entry_v21_t *fw_entry_v21;
+    //fw_desc_entry_v2_t *fw_entry_v2;
+    //fw_desc_entry_v12_t *fw_entry_v12;
+    //fw_desc_entry_v22_t *fw_entry_v22;
+    part_desc_entry_v1_t *part_entry;
+    unsigned int part_count = 0;
+    unsigned long fw_desc_table_base = 0;
+    unsigned int fw_entry_num = 0;
+    unsigned int fw_entry_size = 0;
+    unsigned char fw_desc_version;
+    //unsigned int eMMC_bootcode_area_size = 0x220000;        // eMMC bootcode area size
+    unsigned int eMMC_fw_desc_table_start = 0x620000;
+    unsigned char *ptr = NULL;
+    int i, ret = 0;
+    unsigned int __iomem *afwPtr = NULL;
+    /* common data in both V1/V2 */
+    unsigned char entry_type = 0;
+    unsigned int entry_target_addr = 0, audio_fw_target_addr = 0;
+    u64 entry_offset = 0, audio_fw_offset = 0;
+    unsigned int entry_length = 0, audio_fw_length = 0;
+
+    fw_desc_table_base = __get_free_page(GFP_KERNEL);
+    if (!fw_desc_table_base) {
+        pr_info("avcpu: can not allocate enough memory...\n");
+        return -ENOMEM;
+    }
+
+    ret = read_emmc_data(HEADER_OFFSET / EMMC_BLOCK_SIZE, PAGE_SIZE, (void *)fw_desc_table_base);
+    if (ret < 0)
+        goto out;
+
+    fw_desc_table_v1 = (fw_desc_table_v1_t*)fw_desc_table_base;
+    ptr = (unsigned char *)fw_desc_table_base;
+    printk("%.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x\n", ptr[0], ptr[1], ptr[2], ptr[3], ptr[4], ptr[5], ptr[6], ptr[7]); 
+
+    printk("avcpu: fw_desc_table_v1->signature = %s \n", fw_desc_table_v1->signature);
+    printk("avcpu: fw_desc_table_v1->version = 0x%x \n", fw_desc_table_v1->version);
+    printk("avcpu: fw_desc_table_v1->paddings = %d!!\n", fw_desc_table_v1->paddings);
+    fw_desc_version = fw_desc_table_v1->version;
+#ifdef DUBUG_FW_DESC_TABLE
+    dump_fw_desc_table_v1(fw_desc_table_v1);
+#endif
+
+    /* Check partition existence */
+    if (fw_desc_table_v1->part_list_len == 0) {
+        printk("[ERR] %s:No partition found!\n", __FUNCTION__);
+    } else {
+        part_count = fw_desc_table_v1->part_list_len / sizeof(part_desc_entry_v1_t);
+    }
+
+    printk("avcpu: part_count = %d\n", part_count);
+
+    switch (fw_desc_version) {
+        case FW_DESC_TABLE_V1_T_VERSION_1:
+            fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v1_t);
+            fw_entry_size = sizeof(fw_desc_entry_v1_t);
+            break;
+        case FW_DESC_TABLE_V1_T_VERSION_11:
+            fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v11_t);
+            fw_entry_size = sizeof(fw_desc_entry_v11_t);
+            break;
+        case FW_DESC_TABLE_V1_T_VERSION_21:
+            fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v21_t);
+            fw_entry_size = sizeof(fw_desc_entry_v21_t);
+            break;
+        case FW_DESC_TABLE_V2_T_VERSION_2:
+            fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v2_t);
+            fw_entry_size = sizeof(fw_desc_entry_v2_t);
+            break;
+        case FW_DESC_TABLE_V2_T_VERSION_12:
+            fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v12_t);
+            fw_entry_size = sizeof(fw_desc_entry_v12_t);
+            break;
+        case FW_DESC_TABLE_V2_T_VERSION_22:
+            fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v22_t);
+            fw_entry_size = sizeof(fw_desc_entry_v22_t);
+            break;
+        default:
+            printk("**** Error fw_desc_version 0x%x\n", fw_desc_version);
+            ret = RTK_PLAT_ERR_PARSE_FW_DESC;
+            goto out;
+    }
+
+    printk("[INFO] fw desc table base: 0x%08x, count: %d\n", eMMC_fw_desc_table_start, fw_entry_num);
+
+    part_entry = (part_desc_entry_v1_t *)((unsigned long)fw_desc_table_base + sizeof(fw_desc_table_v1_t));
+    fw_entry = (void*)((unsigned long)fw_desc_table_base + sizeof(fw_desc_table_v1_t) + fw_desc_table_v1->part_list_len);
+
+    for (i = 0; i < part_count; i++)
+    {
+        part_entry[i].length = BE32_TO_CPU(part_entry[i].length);
+        printk("===> i=%d  part_entry[%d].type=%d\n", i, i, part_entry[i].type);
+#ifdef DUBUG_FW_DESC_TABLE
+        dump_part_desc_entry_v1(&(part_entry[i]));
+#endif
+    }
+
+    /* Parse firmware entries and compute fw_total_len */
+    printk("@@@@ fw_desc_table_v1->version = 0x%.8x\n", fw_desc_table_v1->version);
+
+    for (i = 0 ; i < fw_entry_num ; i++) {
+        fw_desc_ptr = (void*)fw_entry + (i * fw_entry_size);
+        FW_ENTRY_MEMBER_GET(entry_type, fw_desc_ptr, type, fw_desc_version);
+        FW_ENTRY_MEMBER_GET(entry_target_addr, fw_desc_ptr, target_addr, fw_desc_version);
+        FW_ENTRY_MEMBER_GET(entry_offset, fw_desc_ptr, offset, fw_desc_version);
+        FW_ENTRY_MEMBER_GET(entry_length, fw_desc_ptr, length, fw_desc_version);
+
+        printk("[OK] fw_entry[%d], type=%d, offset = 0x%lx, length = 0x%x, target_addr:0x%x\n",
+                i, entry_type, (unsigned long)entry_offset, entry_length, entry_target_addr);
+
+        if (entry_type == FW_TYPE_AUDIO) {
+            audio_fw_entry = fw_desc_ptr;
+            audio_fw_target_addr = entry_target_addr;
+            audio_fw_offset = entry_offset;
+            audio_fw_length = entry_length;
+            printk("##### got fw_entry[%d].type == FW_TYPE_AUDIO ###\n", i);
+            printk("avcpu: Audio FW found\n");
+        }
+#ifdef DUBUG_FW_DESC_TABLE
+        if (FW_DESC_BASE_VERSION(fw_desc_version) == 1)
+            dump_fw_desc_entry_v1((fw_desc_entry_v1_t*)fw_desc_ptr);
+        else if (FW_DESC_BASE_VERSION(fw_desc_version) == 2)
+            dump_fw_desc_entry_v2((fw_desc_entry_v2_t*)fw_desc_ptr);
+#endif //DUBUG_FW_DESC_TABLE
+    }
+
+    printk("====> audio_image=0x%.8lx audio_start=0x%.8x\n", (unsigned long)audio_image, audio_start);
+
+    if (audio_image) {
+        if ((ret = load_av_from_file(AUDIO_CPU, audio_image, audio_start))) {
+            printk("avcpu: load audio image error %d...\n", ret);
+            goto out;
+        }
+    } else {
+        if (audio_fw_entry == NULL) {
+            printk("avcpu: can not find audio firmware from NAND flash...\n");
+            ret = -ENODEV;
+            goto out;
+        }
+        printk("avcpu: audio_fw_entry->offset = 0x%lx \n", (unsigned long)audio_fw_offset);
+        printk("avcpu: audio_fw_entry->length = 0x%x \n", audio_fw_length);
+        printk("avcpu: audio_fw_entry->target_addr = 0x%x \n", audio_fw_target_addr);
+
+        // currently we only support align access...
+        if (audio_fw_offset & (EMMC_BLOCK_SIZE - 1))
+            BUG();
+
+#ifdef CONFIG_RTK_IPCSHM_RESET // perform IPC_SHM reset before setting entry value
+       printk("avcpu: reseting IPC share-mem\n");
+       if ((ret = avcpu_ipc_shm_reset()) != 0) {
+           pr_err("avcpu: error occured during reset IPC_SHM\n");
+           goto out;
+       }
+#endif
+        writel(CPU_TO_BE32(audio_fw_target_addr | MIPS_KSEG0BASE), rpc_base + 0xe0);
+        printk("audio entry value: %08x \n", *((unsigned int *)(rpc_base + 0xe0)));
+
+        if (!(afwPtr = ioremap(audio_fw_target_addr, audio_fw_length))) {
+            pr_err("avcpu: ioremap fail for ACPU FW region!\n");
+            ret = -EFAULT;
+            goto out;
+        }
+
+	ret = read_emmc_data_to_ioremap(audio_fw_offset, audio_fw_length, (void *)(afwPtr));
+
+        if (ret < 0)
+            goto out;
+
+        printk("ret: %x length: %x \n", ret * EMMC_BLOCK_SIZE, audio_fw_length);
+
+        if (FW_DESC_EXT_VERSION(fw_desc_version) != 0) {
+            printk("%s, extend version 0x%x, not supported YET!!\n", __func__, FW_DESC_EXT_VERSION(fw_desc_version));
+            ret = RTK_PLAT_ERR_PARSE_FW_DESC;
+            goto out;
+        }
+        //dmac_flush_range((void *)afwPtr, audio_fw_entry->length);
+        //outer_flush_range(afwPtr, audio_fw_entry->length);
+        // flush the data cache...
+        //#ifdef CONFIG_MIPS
+        //      data_cache_flush(audio_fw_entry->target_addr, audio_fw_entry->length);
+        //#endif
+    }
+
+    //  dmac_flush_range((void *)PAGE_OFFSET, (void *)(PAGE_OFFSET + PAGE_SIZE));
+    //      outer_flush_range(0, 0 + PAGE_SIZE);
+
+out:
+    free_page(fw_desc_table_base);
+
+    if (afwPtr)
+        iounmap(afwPtr);
+
+    return ret;
+}
+
+int load_av_image(char *audio_image, unsigned int audio_start,
+        char *video_image_1, unsigned int video_start_1, char *video_image_2, unsigned int video_start_2)
+{
+    unsigned int flash_type;
+    int ret;
+
+    flash_type = get_device_type();
+    printk("avcpu: flash_type: %d \n", flash_type);
+
+    // load firmware image
+    if ((audio_image != 0) && (video_image_1 != 0) && (video_image_2 != 0)) {
+        if ((ret = load_av_from_file(AUDIO_CPU, audio_image, audio_start)))
+            printk("avcpu: load audio image error %d...\n", ret);
+    } else if (flash_type == DEVICE_EMMC) {
+        load_av_from_emmc(audio_image, audio_start, video_image_1, video_start_1, video_image_2, video_start_2);
+    } else {
+        printk("avcpu: unsupported operation...\n");
+        BUG();
+    }
+
+    return 0;
+}
+
+static ssize_t store_reset_cmd(struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+    unsigned long val;
+    char *endp;
+
+    if(count == 0)
+        return -EINVAL;
+
+    val = simple_strtoul(buf, &endp, 16);
+    if(endp == buf)
+        return -EINVAL;
+
+    if(val != 0x20141209)
+        return -EINVAL;
+
+    avpriv.status = AVSTAT_RESUME;
+    pr_info("\033[33m%s status:%d\033[m\n", __func__, avpriv.status);
+    wake_up_interruptible(&avpriv.status_wq);
+
+    return count;
+}
+
+static DEVICE_ATTR(reset, S_IWUSR, NULL, store_reset_cmd);
+
+static int avcpu_init(void)
+{
+    int result;
+    struct device *avdev = NULL;
+    dev_t dev = MKDEV(AVCPU_MAJOR, 0);
+
+    printk("avcpu: audio & video cpu driver for Realtek Media Processors\n");
+
+    if (!(crt_base = ioremap(CRT_BASE, PAGE_SIZE))) {
+        pr_err("avcpu: ioremap CRT fail!\n");
+        return -1;
+    }
+
+    if (!(rpc_base = ioremap(RPC_COMM_PHYS, PAGE_SIZE))) {
+        pr_err("avcpu: ioremap CRT fail!\n");
+        return -1;
+    }
+
+    result = register_chrdev_region(dev, 1, "avcpu");
+    if (result < 0) {
+        printk("avcpu: can not get chrdev region...\n");
+        return result;
+    }
+
+    avcpu_class = class_create(THIS_MODULE, "avcpu");
+    if (IS_ERR(avcpu_class)) {
+        printk("avcpu: can not create class...\n");
+        result = PTR_ERR(avcpu_class);
+        goto fail_class_create;
+    }
+
+    avcpu_class->devnode = avcpu_devnode;
+
+    avcpu_platform_devs = platform_device_register_simple("avcpu", -1, NULL, 0);
+    if (platform_driver_register(&avcpu_device_driver) != 0) {
+        printk("avcpu: can not register platform driver...\n");
+        result = -EINVAL;
+        goto fail_platform_driver_register;
+    }
+
+    cdev_init(&avcpu_cdev, &avcpu_fops);
+    avcpu_cdev.owner = THIS_MODULE;
+    avcpu_cdev.ops = &avcpu_fops;
+    result = cdev_add(&avcpu_cdev, dev, 1);
+    if (result < 0) {
+        printk("avcpu: can not add character device...\n");
+        goto fail_cdev_init;
+    }
+    avdev = device_create(avcpu_class, NULL, dev, NULL, "avcpu");
+    device_create_file(avdev, &dev_attr_reset);
+
+    memset(&avpriv, 0, sizeof(avpriv));
+    init_waitqueue_head(&avpriv.status_wq);
+
+    return 0;
+
+fail_cdev_init:
+    platform_driver_unregister(&avcpu_device_driver);
+fail_platform_driver_register:
+    platform_device_unregister(avcpu_platform_devs);
+    avcpu_platform_devs = NULL;
+    class_destroy(avcpu_class);
+fail_class_create:
+    avcpu_class = NULL;
+    unregister_chrdev_region(dev, 1);
+    return result;
+}
+
+static void avcpu_exit(void)
+{
+    dev_t dev = MKDEV(AVCPU_MAJOR, 0);
+
+    //  if ((avcpu_platform_devs == NULL) || (class_destroy == NULL))
+    if (avcpu_platform_devs == NULL)    //TODO : fix compile warming by victor 20140211
+        BUG();
+
+    if (crt_base)
+        iounmap(crt_base);
+
+    if (rpc_base)
+        iounmap(rpc_base);
+
+    device_destroy(avcpu_class, dev);
+    cdev_del(&avcpu_cdev);
+
+    platform_driver_unregister(&avcpu_device_driver);
+    platform_device_unregister(avcpu_platform_devs);
+    avcpu_platform_devs = NULL;
+
+    class_destroy(avcpu_class);
+    avcpu_class = NULL;
+
+    unregister_chrdev_region(dev, 1);
+}
+
+late_initcall(avcpu_init);
+module_exit(avcpu_exit);
diff --git a/drivers/soc/realtek/rtd129x/cwmp/Kconfig b/drivers/soc/realtek/rtd129x/cwmp/Kconfig
new file mode 100644
index 00000000..8b7d8a3
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/cwmp/Kconfig
@@ -0,0 +1,7 @@
+
+config RTK_CWMP_TREE
+	tristate "Realtek CWMP support"
+	default n
+	help
+	  Realtek CWMP Tree support.
+
diff --git a/drivers/soc/realtek/rtd129x/cwmp/Makefile b/drivers/soc/realtek/rtd129x/cwmp/Makefile
new file mode 100644
index 00000000..5f6a64d
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/cwmp/Makefile
@@ -0,0 +1,5 @@
+#
+# Makefile for the Realtek cwmp drivers.
+#
+
+obj-$(CONFIG_RTK_CWMP_TREE)		+= cwmp_tree.o
diff --git a/drivers/soc/realtek/rtd129x/cwmp/cwmp_km.h b/drivers/soc/realtek/rtd129x/cwmp/cwmp_km.h
new file mode 100644
index 00000000..de50b58
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/cwmp/cwmp_km.h
@@ -0,0 +1,92 @@
+#ifndef CWMP_KERNEL_H
+#define CWMP_KERNEL_H
+
+#include <linux/scatterlist.h>
+#include "cwmp_um.h"
+
+#define MODULE_NAME                 "cwmp_tree"
+
+#define CWMP_TREE_COMM_LEN            256
+#define CWMP_TREE_FILE_PERMISSION     660
+//#define CWMP_TREE_STRING_LEN          CWMP_TREE_COMM_LEN
+#define CWMP_TREE_STRING_LEN          1024
+
+struct CWMP_FileNode;
+struct CWMP_DirNode;
+struct CWMP_CmdData;
+
+struct CWMP_FileNode {
+    struct kobj_attribute       mKattr;
+    struct CWMP_DirNode *         mParent;
+    char                        mCommName [CWMP_TREE_COMM_LEN];
+    char                        mStringData [CWMP_TREE_STRING_LEN];
+    struct list_head            list;
+};
+
+struct CWMP_FileNode *            CWMP_FileNode_new         (struct CWMP_DirNode * parent, char * name, umode_t permission);
+void                            CWMP_FileNode_delete      (struct CWMP_FileNode * node);
+char *                          CWMP_FileNode_GetName     (struct CWMP_FileNode * node);
+struct CWMP_DirNode *             CWMP_FileNode_GetParent   (struct CWMP_FileNode * node);
+char *                          CWMP_FileNode_GetString   (struct CWMP_FileNode * node);
+struct list_head *              CWMP_FileNode_GetList     (struct CWMP_FileNode * node);
+
+struct CWMP_DirNode {
+    struct kobject *            mKobj;
+    struct CWMP_DirNode *         mParent;
+    char                        mCommName [CWMP_TREE_COMM_LEN];
+    struct list_head            mChildDir_list;
+    struct list_head            mChildFile_list;
+    struct list_head            list;
+};
+
+struct CWMP_DirNode *             CWMP_DirNode_new          (struct CWMP_DirNode * parent, char * name);
+void                            CWMP_DirNode_delete       (struct CWMP_DirNode * node);
+char *                          CWMP_DirNode_GetName      (struct CWMP_DirNode * node);
+struct list_head *              CWMP_DirNode_GetList      (struct CWMP_DirNode * node);
+struct kobject *                CWMP_DirNode_GetKobject   (struct CWMP_DirNode * node);
+struct CWMP_DirNode *             CWMP_DirNode_GetParent    (struct CWMP_DirNode * node);
+int                             CWMP_DirNode_CreateDir    (struct CWMP_DirNode * node, char * child_name);
+int                             CWMP_DirNode_CreateFile   (struct CWMP_DirNode * node, char * child_name, umode_t permission);
+int                             CWMP_DirNode_RemoveDir    (struct CWMP_DirNode * node, char * child_name);
+int                             CWMP_DirNode_RemoveFile   (struct CWMP_DirNode * node, char * child_name);
+struct CWMP_DirNode *             CWMP_DirNode_FindDir      (struct CWMP_DirNode * node, char * child_name);
+struct CWMP_FileNode *            CWMP_DirNode_FindFile     (struct CWMP_DirNode * node, char * child_name);
+
+enum CWMP_Node_Type {
+    IS_NULL = 0,
+    IS_DIR,
+    IS_FILE,
+};
+
+enum CWMP_CmdData_Type {
+    CWMP_CmdData_Type_Dir,
+    CWMP_CmdData_Type_File,
+};
+
+struct CWMP_CmdData {
+    char                        mCommName [CWMP_TREE_COMM_LEN];
+    enum CWMP_CmdData_Type        mType;
+    struct CWMP_CmdData *         next;
+};
+
+struct CWMP_CmdData *             CWMP_CmdData_new          (char * path, enum cwmp_um_cmd user_cmd);
+void                            CWMP_CmdData_delete       (struct CWMP_CmdData * cmd);
+char *                          CWMP_CmdData_GetName      (struct CWMP_CmdData * cmd);
+bool                            CWMP_CmdData_IsLast       (struct CWMP_CmdData * cmd);
+bool                            CWMP_CmdData_IsFile       (struct CWMP_CmdData * cmd);
+bool                            CWMP_CmdData_IsDir        (struct CWMP_CmdData * cmd);
+
+struct CWMP_FileNode *            CWMP_Cmd_FindFile         (struct CWMP_DirNode * parent, struct CWMP_CmdData * cmd);
+struct CWMP_DirNode *             CWMP_Cmd_FindDir          (struct CWMP_DirNode * parent, struct CWMP_CmdData * cmd);
+int                             CWMP_Cmd_CreateNode       (struct CWMP_DirNode * parent, struct CWMP_CmdData * cmd);
+void                            CWMP_Cmd_RemoveNode       (struct CWMP_DirNode * parent, struct CWMP_CmdData * cmd);
+int                             CWMP_SendCmd              (char * path, enum cwmp_um_cmd user_cmd, char * value);
+
+int                             cwmp_open                 (struct inode *inode, struct file *filp);
+int                             cwmp_close                (struct inode *inode, struct file *filp);
+ssize_t                         cwmp_read                 (struct file *filp, char *buf, size_t size, loff_t *f_pos);
+ssize_t                         cwmp_write                (struct file *filp, const char *buf, size_t size, loff_t *f_pos);
+long                            cwmp_ioctl                (struct file *filp, unsigned int cmd, unsigned long arg);
+long cwmp_ioctl_compat (struct file *filp, unsigned int cmd, unsigned long arg);
+
+#endif /* End of CWMP_KERNEL_H */
diff --git a/drivers/soc/realtek/rtd129x/cwmp/cwmp_tree.c b/drivers/soc/realtek/rtd129x/cwmp/cwmp_tree.c
new file mode 100644
index 00000000..ddb5d3c
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/cwmp/cwmp_tree.c
@@ -0,0 +1,715 @@
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/console.h>
+#include <linux/interrupt.h>
+#include <linux/uaccess.h>
+#include <linux/printk.h>
+#include <linux/slab.h>
+#include <linux/fs.h>
+#include <linux/cdev.h>
+#include <linux/device.h>
+#include <linux/compat.h>
+#include <asm-generic/string.h>
+
+#include "cwmp_km.h"
+
+static struct CWMP_Module {
+    struct CWMP_DirNode * top;
+} * gModule = NULL;
+
+static DEFINE_MUTEX(cwmp_lock);
+
+static ssize_t CWMP_FileNode_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf) {
+    struct CWMP_FileNode * node = container_of(attr, struct CWMP_FileNode, mKattr);
+    int n = 0;
+    n += sprintf(buf+n, "%s", CWMP_FileNode_GetString(node));
+    return n;
+}
+
+static ssize_t CWMP_FileNode_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count) {
+    struct CWMP_FileNode * node = container_of(attr, struct CWMP_FileNode, mKattr);
+    memcpy(CWMP_FileNode_GetString(node), buf, count);
+    return count;
+}
+
+struct CWMP_FileNode *            CWMP_FileNode_new         (struct CWMP_DirNode * parent, char * name, umode_t permission) {
+    struct CWMP_FileNode * node = (struct CWMP_FileNode *) kzalloc(sizeof(struct CWMP_FileNode), GFP_KERNEL);
+    if (!node)
+        goto err;
+
+    sprintf(node->mCommName, "%s", name);
+
+    node->mParent               = parent;
+    node->mKattr.attr.mode      = permission;
+    node->mKattr.attr.name      = node->mCommName;
+    node->mKattr.show           = CWMP_FileNode_show;
+    node->mKattr.store          = CWMP_FileNode_store;
+
+    INIT_LIST_HEAD(&node->list);
+
+    if (sysfs_create_file(CWMP_DirNode_GetKobject(node->mParent), &(node->mKattr.attr)) != 0)
+        goto err;
+
+    return node;
+err:
+    if (node)
+        kfree(node);
+    return NULL;
+}
+
+void                            CWMP_FileNode_delete      (struct CWMP_FileNode * node) {
+    if (node) {
+        sysfs_remove_file(CWMP_DirNode_GetKobject(node->mParent), &(node->mKattr.attr));
+        kfree(node);
+    }
+}
+
+char *                          CWMP_FileNode_GetName     (struct CWMP_FileNode * node) {
+    if (node)
+        return &node->mCommName[0];
+    return NULL;
+}
+
+struct CWMP_DirNode *             CWMP_FileNode_GetParent   (struct CWMP_FileNode * node) {
+    if (node) {
+        return node->mParent;
+    }
+    return NULL;
+}
+
+char *                          CWMP_FileNode_GetString   (struct CWMP_FileNode * node) {
+    if (node)
+        return &node->mStringData[0];
+    return NULL;
+}
+
+struct list_head *              CWMP_FileNode_GetList     (struct CWMP_FileNode * node) {
+    if (node)
+        return &node->list;
+    return NULL;
+}
+
+struct CWMP_DirNode *             CWMP_DirNode_new          (struct CWMP_DirNode * parent, char * name) {
+    struct CWMP_DirNode * node = (struct CWMP_DirNode *) kzalloc(sizeof(struct CWMP_DirNode), GFP_KERNEL);
+    if (!node)
+        goto err;
+
+    sprintf(node->mCommName, "%s", name);
+    node->mParent   = parent;
+    node->mKobj     = kobject_create_and_add(node->mCommName, CWMP_DirNode_GetKobject(node->mParent));
+    if (!node->mKobj)
+        goto err;
+
+    INIT_LIST_HEAD(&node->mChildDir_list);
+    INIT_LIST_HEAD(&node->mChildFile_list);
+    INIT_LIST_HEAD(&node->list);
+    return node;
+err:
+    if (node)
+        kfree(node);
+    return NULL;
+}
+
+void                            CWMP_DirNode_delete       (struct CWMP_DirNode * node) {
+    if (node) {
+        {
+            struct CWMP_FileNode * pFileHandler, * tmp_pFileHandler;
+            list_for_each_entry_safe(pFileHandler, tmp_pFileHandler, &node->mChildFile_list, list) {
+                list_del(CWMP_FileNode_GetList(pFileHandler));
+                CWMP_FileNode_delete(pFileHandler);
+            }
+        }
+        {
+            struct CWMP_DirNode * pDirHandler, * tmp_pDirHandler;
+            list_for_each_entry_safe(pDirHandler, tmp_pDirHandler, &node->mChildDir_list, list) {
+                list_del(CWMP_DirNode_GetList(pDirHandler));
+                CWMP_DirNode_delete(pDirHandler);
+            }
+        }
+        //kobject_cleanup(node->mKobj);
+        //kobject_put(node->mKobj);
+        kobject_del(node->mKobj);
+        kfree(node);
+    }
+}
+
+char *                          CWMP_DirNode_GetName      (struct CWMP_DirNode * node) {
+    if (node) {
+        return &node->mCommName[0];
+    }
+    return NULL;
+}
+
+struct list_head *              CWMP_DirNode_GetList      (struct CWMP_DirNode * node) {
+    if (node)
+        return &node->list;
+    return NULL;
+}
+
+struct kobject *                CWMP_DirNode_GetKobject   (struct CWMP_DirNode * node) {
+    if (node) {
+        return node->mKobj;
+    }
+    return NULL;
+}
+
+struct CWMP_DirNode *             CWMP_DirNode_GetParent    (struct CWMP_DirNode * node) {
+    if (node) {
+        return node->mParent;
+    }
+    return NULL;
+}
+
+int                             CWMP_DirNode_CreateDir    (struct CWMP_DirNode * node, char * child_name) {
+    if (CWMP_DirNode_FindFile(node, child_name) != NULL ||
+            CWMP_DirNode_FindDir(node, child_name) != NULL)
+        goto err;
+
+    if (node) {
+        struct CWMP_DirNode * child = CWMP_DirNode_new(node, child_name);
+        if (!child)
+            goto err;
+        list_add(CWMP_DirNode_GetList(child), &node->mChildDir_list);
+        return 0;
+    }
+err:
+    return -1;
+}
+
+int                             CWMP_DirNode_CreateFile   (struct CWMP_DirNode * node, char * child_name, umode_t permission) {
+    if (CWMP_DirNode_FindFile(node, child_name) != NULL ||
+            CWMP_DirNode_FindDir(node, child_name) != NULL)
+        goto err;
+
+    if (node) {
+        struct CWMP_FileNode * child = CWMP_FileNode_new(node, child_name, permission);
+        if (!child)
+            goto err;
+        list_add(CWMP_FileNode_GetList(child), &node->mChildFile_list);
+        return 0;
+    }
+err:
+    return -1;
+
+}
+
+int                             CWMP_DirNode_RemoveDir    (struct CWMP_DirNode * node, char * child_name) {
+    if (node) {
+        struct CWMP_DirNode * child = CWMP_DirNode_FindDir(node, child_name);
+        if (child) {
+            list_del(CWMP_DirNode_GetList(child));
+            CWMP_DirNode_delete(child);
+            return 0;
+        }
+    }
+    return -1;
+}
+
+int                             CWMP_DirNode_RemoveFile   (struct CWMP_DirNode * node, char * child_name) {
+    if (node) {
+        struct CWMP_FileNode * child = CWMP_DirNode_FindFile(node, child_name);
+        if (child) {
+            list_del(CWMP_FileNode_GetList(child));
+            CWMP_FileNode_delete(child);
+            return 0;
+        }
+    }
+    return -1;
+}
+
+struct CWMP_DirNode *             CWMP_DirNode_FindDir      (struct CWMP_DirNode * node, char * child_name) {
+    if (node) {
+        bool meet = false;
+        struct CWMP_DirNode * pDirHandler;
+        list_for_each_entry(pDirHandler, &node->mChildDir_list, list) {
+            if (strcmp(child_name, CWMP_DirNode_GetName(pDirHandler)) == 0) {
+                meet = true;
+                break;
+            }
+        }
+        if (meet)
+            return pDirHandler;
+
+    }
+    return NULL;
+}
+
+struct CWMP_FileNode *            CWMP_DirNode_FindFile     (struct CWMP_DirNode * node, char * child_name) {
+    if (node) {
+        bool meet = false;
+        struct CWMP_FileNode * pFileHandler;
+        list_for_each_entry(pFileHandler, &node->mChildFile_list, list) {
+            if (strcmp(child_name, CWMP_FileNode_GetName(pFileHandler)) == 0) {
+                meet = true;
+                break;
+            }
+        }
+        if (meet)
+            return pFileHandler;
+    }
+    return NULL;
+}
+
+struct CWMP_DirNode *             CWMP_DirNode_CreateTOP          (struct kobject * parent, char * name) {
+    struct CWMP_DirNode * node = (struct CWMP_DirNode *) kzalloc(sizeof(struct CWMP_DirNode), GFP_KERNEL);
+    if (!node)
+        goto err;
+
+    sprintf(node->mCommName, "%s", name);
+    node->mParent   = NULL;
+    node->mKobj     = kobject_create_and_add(node->mCommName, parent);
+    if (!node->mKobj)
+        goto err;
+
+    INIT_LIST_HEAD(&node->mChildDir_list);
+    INIT_LIST_HEAD(&node->mChildFile_list);
+    INIT_LIST_HEAD(&node->list);
+    return node;
+err:
+    if (node)
+        kfree(node);
+    return NULL;
+}
+
+void                            CWMP_DirNode_RemoveTOP       (struct CWMP_DirNode * node) {
+    return CWMP_DirNode_delete(node);
+}
+
+struct CWMP_CmdData *             CWMP_CmdData_new          (char * path, enum cwmp_um_cmd user_cmd) {
+    struct CWMP_CmdData * cmdHeader = (struct CWMP_CmdData *) kzalloc(sizeof(struct CWMP_CmdData), GFP_KERNEL);
+
+    if (!cmdHeader)
+        goto err;
+
+    {
+        char * path_in = path;
+        struct CWMP_CmdData * target = NULL;
+        const char *delim = ".";
+        char * pch;
+        pch = strsep(&path_in, delim);
+        while (pch != NULL) {
+            if (strlen(pch) != 0) {
+                if (target == NULL) {
+                    target = cmdHeader;
+                } else {
+                    target->next = (struct CWMP_CmdData *) kzalloc(sizeof(struct CWMP_CmdData), GFP_KERNEL);
+                    target = target->next;
+                }
+
+                if (!target)
+                    goto err;
+
+                sprintf(target->mCommName, "%s", pch);
+                target->mType = CWMP_CmdData_Type_Dir;
+            }
+            pch = strsep (&path_in, delim);
+        }
+
+        switch (user_cmd) {
+            case eCreateFileNode:
+            case eDeleteFileNode:
+            case eWriteValue:
+            case eReadValue:
+                target->mType = CWMP_CmdData_Type_File;
+                break;
+            default:
+                break;
+        }
+    }
+
+    return cmdHeader;
+err:
+    if (cmdHeader)
+        CWMP_CmdData_delete(cmdHeader);
+    return NULL;
+}
+
+void                            CWMP_CmdData_delete       (struct CWMP_CmdData * cmd) {
+    if (cmd) {
+        if (cmd->next)
+            CWMP_CmdData_delete(cmd->next);
+        kfree(cmd);
+    }
+}
+
+char *                          CWMP_CmdData_GetName      (struct CWMP_CmdData * cmd) {
+    if (cmd) {
+        return &cmd->mCommName[0];
+    }
+    return NULL;
+}
+
+bool                            CWMP_CmdData_IsLast       (struct CWMP_CmdData * cmd) {
+    if (cmd)
+        return (cmd->next == NULL) ? true : false;
+    return true;
+}
+
+bool                            CWMP_CmdData_IsFile       (struct CWMP_CmdData * cmd) {
+    if (cmd) {
+        if (CWMP_CmdData_IsLast(cmd) && cmd->mType == CWMP_CmdData_Type_File)
+            return true;
+    }
+    return false;
+}
+
+bool                            CWMP_CmdData_IsDir        (struct CWMP_CmdData * cmd) {
+    if (cmd) {
+        if (!CWMP_CmdData_IsLast(cmd) || cmd->mType == CWMP_CmdData_Type_Dir)
+            return true;
+    }
+    return false;
+}
+
+
+struct CWMP_FileNode *            CWMP_Cmd_FindFile         (struct CWMP_DirNode * parent, struct CWMP_CmdData * cmd) {
+    struct CWMP_FileNode * target = NULL;
+    //printk("[%s:%d]...\n", __FUNCTION__, __LINE__);
+    if (parent && cmd) {
+        struct CWMP_DirNode * node = parent;
+        struct CWMP_CmdData * tmp_cmd = cmd;
+
+        do {
+
+            if (!node || !tmp_cmd)
+                break;
+
+            if (CWMP_CmdData_IsLast(tmp_cmd)) {
+                if (CWMP_CmdData_IsFile(tmp_cmd))
+                    target = CWMP_DirNode_FindFile(node, CWMP_CmdData_GetName(tmp_cmd));
+                break;
+            }
+
+            /* into the next dir */
+            node = CWMP_DirNode_FindDir(node, CWMP_CmdData_GetName(tmp_cmd));
+            tmp_cmd = tmp_cmd->next;
+        } while (tmp_cmd != NULL);
+    }
+    return target;
+}
+
+struct CWMP_DirNode *             CWMP_Cmd_FindDir          (struct CWMP_DirNode * parent, struct CWMP_CmdData * cmd) {
+    struct CWMP_DirNode * target = NULL;
+    if (parent && cmd) {
+        struct CWMP_DirNode * node = parent;
+        struct CWMP_CmdData * tmp_cmd = cmd;
+
+        do {
+
+            if (!node || !tmp_cmd)
+                break;
+
+            if (CWMP_CmdData_IsLast(tmp_cmd)) {
+                if (CWMP_CmdData_IsDir(tmp_cmd))
+                    target = CWMP_DirNode_FindDir(node, CWMP_CmdData_GetName(tmp_cmd));
+                break;
+            }
+
+            /* into the next dir */
+            node = CWMP_DirNode_FindDir(node, CWMP_CmdData_GetName(tmp_cmd));
+            tmp_cmd = tmp_cmd->next;
+        } while (tmp_cmd != NULL);
+    }
+    return target;
+}
+
+int                             CWMP_Cmd_CreateNode       (struct CWMP_DirNode * parent, struct CWMP_CmdData * cmd) {
+    if (parent && cmd) {
+        struct CWMP_DirNode * node = parent;
+        struct CWMP_CmdData * tmp_cmd = cmd;
+        do {
+            if (!tmp_cmd)
+                return 0; //break;
+
+            if (CWMP_CmdData_IsDir(tmp_cmd)) {
+                struct CWMP_DirNode * tmp;
+                CWMP_DirNode_CreateDir(node, CWMP_CmdData_GetName(tmp_cmd));
+                tmp = CWMP_DirNode_FindDir(node, CWMP_CmdData_GetName(tmp_cmd));
+                if (tmp) {
+                    node = tmp;
+                    tmp_cmd = tmp_cmd->next;
+                    continue;
+                } else
+                    goto err;
+            }
+
+            if (CWMP_CmdData_IsFile(tmp_cmd)) {
+                CWMP_DirNode_CreateFile(node, CWMP_CmdData_GetName(tmp_cmd), CWMP_TREE_FILE_PERMISSION);
+                return 0;
+            }
+        } while (tmp_cmd != NULL);
+    }
+    return 0;
+err:
+    return -1;
+}
+
+void                            CWMP_Cmd_RemoveNode       (struct CWMP_DirNode * parent, struct CWMP_CmdData * cmd) {
+    struct CWMP_FileNode *    f_node = CWMP_Cmd_FindFile(parent, cmd);
+    struct CWMP_DirNode *     d_node = CWMP_Cmd_FindDir(parent, cmd);
+    //mutex_lock(&cwmp_lock);
+    if (f_node) {
+        CWMP_DirNode_RemoveFile(CWMP_FileNode_GetParent(f_node), CWMP_FileNode_GetName(f_node));
+    }
+    if (d_node) {
+        CWMP_DirNode_RemoveDir(CWMP_DirNode_GetParent(d_node), CWMP_DirNode_GetName(d_node));
+    }
+    //mutex_unlock(&cwmp_lock);
+}
+
+int CWMP_Cmd_Write (struct CWMP_DirNode * parent, struct CWMP_CmdData * cmd, char * value) {
+    int ret = -1;
+    struct CWMP_FileNode * f_node;
+    //printk("[%s:%d]...\n", __FUNCTION__, __LINE__);
+    if (parent && cmd && value) {
+        struct CWMP_DirNode * node = parent;
+        struct CWMP_CmdData * tmp_cmd = cmd;
+        ret = CWMP_Cmd_CreateNode(node, tmp_cmd);
+        if (ret >= 0) {
+            //mutex_lock(&cwmp_lock);
+            f_node = CWMP_Cmd_FindFile(node, tmp_cmd);
+            if (f_node) {
+                //printk("[%s:%d] f_node=%s\n", __FUNCTION__, __LINE__, CWMP_FileNode_GetName(f_node));
+                //printk("[%s:%d] string length=%ld\n", __FUNCTION__, __LINE__, (long)strlen(value));
+                memcpy(CWMP_FileNode_GetString(f_node), value, strlen(value));
+            } else {
+                ret = -2;
+            }
+            //mutex_unlock(&cwmp_lock);
+        }
+    }
+    //printk("[%s:%d].End, ret=%d\n", __FUNCTION__, __LINE__, ret);
+    return ret;
+}
+
+int CWMP_Cmd_Read (struct CWMP_DirNode * parent, struct CWMP_CmdData * cmd, char * value) {
+    int ret = -1;
+    char buf[CWMP_TREE_STRING_LEN];
+    struct CWMP_FileNode * f_node;
+    int len = 0;
+    //printk("[%s:%d]...\n", __FUNCTION__, __LINE__);
+    if (parent && cmd) {
+        struct CWMP_DirNode * node = parent;
+        struct CWMP_CmdData * tmp_cmd = cmd;
+        //mutex_lock(&cwmp_lock);
+        f_node = CWMP_Cmd_FindFile(node, tmp_cmd);
+        if (f_node) {
+            //printk("[%s:%d] f_node=%s\n", __FUNCTION__, __LINE__, CWMP_FileNode_GetName(f_node));
+            len = sprintf(buf, "%s", CWMP_FileNode_GetString(f_node));
+            buf[len] = '\0';
+            //printk("[%s:%d] content=%s(%d)\n", __FUNCTION__, __LINE__, buf, len);
+            if (copy_to_user(value, buf, len)) {
+                printk("[%s:%d] copy data to user space FAIL!\n", __FUNCTION__, __LINE__);
+            } else {
+                ret = len;
+            }
+        //} else {
+        //    printk("[%s:%d] file not found?...\n", __FUNCTION__, __LINE__);
+        }
+        //mutex_unlock(&cwmp_lock);
+    }
+    //printk("[%s:%d].End, ret=%d\n", __FUNCTION__, __LINE__, ret);
+    return ret;
+}
+
+int                             CWMP_SendCmd              (char * path, enum cwmp_um_cmd user_cmd, char * value) {
+    int ret = -1;
+    struct CWMP_CmdData * cmdData;
+    //struct CWMP_CmdData * cmdData = CWMP_CmdData_new(path, user_cmd);
+    cmdData = CWMP_CmdData_new(path, user_cmd);
+    if (!cmdData)
+        goto err;
+
+    mutex_lock(&cwmp_lock);
+    switch (user_cmd) {
+        case eCreateFileNode:
+        case eCreateDirNode:
+            ret = CWMP_Cmd_CreateNode(gModule->top, cmdData);
+            break;
+        case eDeleteFileNode:
+        case eDeleteDirNode:
+            CWMP_Cmd_RemoveNode(gModule->top, cmdData);
+            ret = 0;
+            break;
+        case eWriteValue:
+            ret = CWMP_Cmd_Write(gModule->top, cmdData, value);
+            break;
+        case eReadValue:
+            ret = CWMP_Cmd_Read(gModule->top, cmdData, value);
+            break;
+        default:
+            break;
+    }
+    mutex_unlock(&cwmp_lock);
+
+    CWMP_CmdData_delete(cmdData);
+    return ret;
+err:
+    if (cmdData)
+        CWMP_CmdData_delete(cmdData);
+    return ret;
+}
+
+int         cwmp_open     (struct inode *inode, struct file *filp) {
+    return 0;
+}
+
+int         cwmp_close    (struct inode *inode, struct file *filp) {
+    return 0;
+}
+
+ssize_t     cwmp_read     (struct file *filp, char *buf, size_t size, loff_t *f_pos) {
+    return 0;
+}
+
+ssize_t     cwmp_write    (struct file *filp, const char *buf, size_t size, loff_t *f_pos) {
+    return size;
+}
+
+long        cwmp_ioctl    (struct file *filp, unsigned int cmd, unsigned long arg) {
+    int ret = -1;
+    //printk("[%s:%d] Got an ioctl command (%ld), CWMP_IOC_SENDCMD=%ld\n", __FUNCTION__, __LINE__, (unsigned long)cmd, CWMP_IOC_SENDCMD);
+    switch (cmd) {
+        case CWMP_IOC_SENDCMD:
+            {
+                struct cwmp_um_config config;
+                char inPath[1024];
+                memset(inPath, 0x0, sizeof(inPath));
+                memset((void *) &config, 0 , sizeof(struct cwmp_um_config));
+                ret = (int) copy_from_user(&config, (void *) arg, sizeof(struct cwmp_um_config));
+                if (ret != 0) {
+                    printk("[%s:%d] copy_from_user return failed!(%d)\n", __FUNCTION__, __LINE__, ret);
+                    break;
+                }
+                sscanf(config.path, "%s", inPath);
+                ret = CWMP_SendCmd(inPath, config.cmd, config.value);
+                if (ret < 0) {
+                    printk("[%s:%d] CWMP_SendCmd return failed!(%d)\n", __FUNCTION__, __LINE__, ret);
+                }
+                break;
+            }
+        default:
+            break;
+    }
+    return ret;
+}
+
+#ifdef CONFIG_COMPAT
+struct cwmp_um_config32 {
+    enum cwmp_um_cmd cmd;
+    compat_uptr_t path;
+    compat_uptr_t value;
+};
+
+#define CWMP_IOC_SENDCMD32  _IOWR(CWMP_IOC_MAGIC, 1, struct cwmp_um_config32)
+
+long cwmp_ioctl_compat (struct file *filp, unsigned int cmd, unsigned long arg) {
+    struct cwmp_um_config config;
+    struct cwmp_um_config32 * config32 = (struct cwmp_um_config32 *)arg;
+    compat_uptr_t path_ptr, value_ptr;
+    int ret = -1;
+    char inPath[1024];
+
+    //printk("[%s:%d] Got an ioctl command (%ld), CWMP_IOC_SENDCMD=%ld, CWMP_IOC_SENDCMD32=%ld\n", __FUNCTION__, __LINE__, (unsigned long)cmd, CWMP_IOC_SENDCMD, CWMP_IOC_SENDCMD32);
+    memset((void *) &config, 0 , sizeof(struct cwmp_um_config));
+    memset(inPath, 0x0, sizeof(inPath));
+
+    switch (cmd) {
+        case CWMP_IOC_SENDCMD32:
+            if (get_user(config.cmd, &config32->cmd)
+                || get_user(path_ptr, &config32->path)
+                || get_user(value_ptr, &config32->value))
+                    return -EFAULT;
+            config.path = compat_ptr(path_ptr);
+            config.value = compat_ptr(value_ptr);
+            sscanf(config.path, "%s", inPath);
+
+            //printk("[%s:%d] cmd=%d, path=%s(%p)(size=%d), value=%s(%p)(size=%d)\n", __FUNCTION__, __LINE__, config.cmd, config.path, config.path, (int)strlen(config.path), config.value, config.value, (int)strlen(config.value));
+
+            ret = CWMP_SendCmd(inPath, config.cmd, config.value);
+            if (ret < 0) {
+                printk("[%s:%d] CWMP_SendCmd return failed!(%d)\n", __FUNCTION__, __LINE__, ret);
+            }
+            break;
+        default:
+            break;
+    }
+
+    return ret;
+}
+#endif
+
+static dev_t            cwmp_dev_num = 0;
+static struct device*   cwmp_device;
+static struct cdev      cwmp_dev;
+struct class *          cwmp_dev_class = NULL;
+static struct file_operations cwmp_fops = {
+    .owner                  = THIS_MODULE,
+    .open                   = cwmp_open,
+    .release                = cwmp_close,
+    .read                   = cwmp_read,
+    .write                  = cwmp_write,
+    .unlocked_ioctl         = cwmp_ioctl,
+#ifdef CONFIG_COMPAT
+    .compat_ioctl           = cwmp_ioctl_compat,
+#endif
+};
+
+static int cwmp_module_init (void) {
+    gModule = (struct CWMP_Module *) kzalloc(sizeof(struct CWMP_Module), GFP_KERNEL);
+    if (!gModule)
+        goto err;
+
+    gModule->top = CWMP_DirNode_CreateTOP(kernel_kobj, MODULE_NAME);
+    if (!gModule->top)
+        goto err;
+
+    {
+        cdev_init(&cwmp_dev, &cwmp_fops);
+        if (alloc_chrdev_region(&cwmp_dev_num, 0, 1, MODULE_NAME)!=0) {
+            cdev_del(&cwmp_dev);
+            goto err;
+        }
+
+        if (cdev_add(&cwmp_dev, cwmp_dev_num, 1)<0) {
+            goto err;
+        }
+
+        cwmp_dev_class = class_create(THIS_MODULE, MODULE_NAME);
+
+        cwmp_device = device_create(
+                cwmp_dev_class,       // class
+                NULL,               // parent
+                cwmp_dev_num,         // dev number
+                NULL,               // driver data
+                MODULE_NAME);       // device name
+    }
+
+    return 0;
+err:
+    if (gModule) {
+        if (gModule->top)
+            CWMP_DirNode_RemoveTOP(gModule->top);
+        kfree(gModule);
+    }
+    return -1;
+}
+
+static void cwmp_module_exit(void) {
+    {
+        device_destroy(cwmp_dev_class, cwmp_device->devt);
+        class_destroy(cwmp_dev_class);
+        cdev_del(&cwmp_dev);
+        unregister_chrdev_region(cwmp_dev_num, 1);
+    }
+
+    if (gModule) {
+        if (gModule->top)
+            CWMP_DirNode_RemoveTOP(gModule->top);
+        kfree(gModule);
+    }
+}
+
+module_init(cwmp_module_init);
+module_exit(cwmp_module_exit);
+MODULE_LICENSE("GPL");
diff --git a/drivers/soc/realtek/rtd129x/cwmp/cwmp_um.h b/drivers/soc/realtek/rtd129x/cwmp/cwmp_um.h
new file mode 100644
index 00000000..e646783
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/cwmp/cwmp_um.h
@@ -0,0 +1,25 @@
+#ifndef CWMP_UM_H
+#define CWMP_UM_H
+#include <linux/ioctl.h>
+
+enum cwmp_um_cmd {
+    eCreateFileNode,
+    eCreateDirNode,
+    eDeleteFileNode,
+    eDeleteDirNode,
+    eWriteValue,
+    eReadValue,
+    eMaxUmCmd,
+};
+
+struct cwmp_um_config {
+    enum cwmp_um_cmd cmd;
+    char * path;
+    char * value;
+};
+
+#define CWMP_IOC_MAGIC  't'
+#define CWMP_IOC_SENDCMD  _IOWR(CWMP_IOC_MAGIC, 1, struct cwmp_um_config)
+//#define CWMP_IOC_SENDCMD  _IO(CWMP_IOC_MAGIC, 1)
+
+#endif /* End of CWMP_UM_H */
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/Makefile b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/Makefile
new file mode 100644
index 00000000..2c51bbb
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/Makefile
@@ -0,0 +1,63 @@
+#
+# Makefile for the Tulip ethernet driver
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definitions are now in the main makefile...
+#Add mips16 Support
+
+#DIR_RTLASIC = $(srctree)/drivers/soc/realtek/rtd129x/hw_nat/
+
+ifeq ($(CONFIG_RTK_IPTABLES_FAST_PATH),m)
+EXTRA_CFLAGS += -DCONFIG_FAST_PATH_MODULE
+EXTRA_CFLAGS += -DCONFIG_RTK_IPTABLES_FAST_PATH
+endif
+
+ifdef CONFIG_RTL865X_KERNEL_MIPS16_LAYERDRIVER
+	CFLAGS_rtl865xC_layer2asic.o	= -mips16
+	CFLAGS_rtl865xC_tblAsicDrv.o	= -mips16
+	CFLAGS_rtl865xC_tblBasicDrv.o	= -mips16
+	CFLAGS_rtl865xC_hs.o		= -mips16
+	CFLAGS_rtl8651_tblAsicDrv_cmd.o		= -mips16
+endif
+
+obj-y := \
+	rtl865x_asicBasic.o \
+	rtl865x_asicCom.o \
+	rtl865x_asicL2.o \
+	rtl865xC_hs.o
+
+	ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER_L3
+		obj-y += rtl865x_asicL3.o
+	endif
+
+	ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER_L4
+		obj-y += rtl865x_asicL4.o
+	endif
+
+	ifdef CONFIG_RTD_1295_HWNAT
+		obj-y += rtd129x_clk.o
+	endif
+
+#obj-$(CONFIG_RTL865X_CLE) += rtl8651_tblAsicDrv_cmd.o
+
+
+EXTRA_CFLAGS += -O1 -DRTL_TBLDRV -D__linux__ -DRTL865X_OVER_KERNEL -DRTL865X_OVER_LINUX -Werror
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/AsicDriver
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/l2Driver
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/common
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/cle
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)
+
+ifeq ($(CONFIG_RTL865X_MODULE_ROMEDRV),y)
+	EXTRA_CFLAGS += -D__KERNEL__
+	EXTRA_CFLAGS += -G 0 asdfasdfasdfasdfasdfasdfasdfasdfasdf
+	EXTRA_CFLAGS += -DMODULE asdfasdf
+	EXTRA_CFLAGS += -mlong-calls
+	EXTRA_CFLAGS += -DEXPORT_SYMTAB
+	EXTRA_CFLAGS += -DCONFIG_RTL865X_MODULE_INTERNAL
+endif
+
+EXTRA_AFLAGS += $(EXTRA_CFLAGS)
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/asicRegs.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/asicRegs.h
new file mode 100644
index 00000000..c2fc40b
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/asicRegs.h
@@ -0,0 +1,42 @@
+/*
+* ----------------------------------------------------------------
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* $Header: /home1/sub1/tmp/cvs2svn/skylark/skylark/skylark/linux-2.6.x/drivers/net/re865x/AsicDriver/asicRegs.h,v 1.1 2007-12-21 10:29:24 davidhsu Exp $
+*
+* Abstract: ASIC specific definitions -- common part.
+*
+* $Author: davidhsu $
+*
+* -----------------------------------------------------------------
+*	The following definitions are shared by 865xB/865xC series IC.
+* -----------------------------------------------------------------
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+//#include <rtl_types.h>
+
+/*********************************************************************
+ **                                                                 **
+ **    Common Parts -- Add Common Definitions Here !                **
+ **                                                                 **
+ *********************************************************************/
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#define UNCACHED_ADDRESS(x) ((void *)(0x20000000 | (uint32)x ))
+#define CACHED_ADDRESS(x) ((void*)(~0x20000000 & (uint32)x ))
+#define PHYSICAL_ADDRESS(x) (((uint32)x) & 0x1fffffff)
+#define KSEG0_ADDRESS(x) ((void*)(PHYSICAL_ADDRESS(x) | 0x80000000))
+#define KSEG1_ADDRESS(x) ((void*)(PHYSICAL_ADDRESS(x) | 0xA0000000))
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+/*********************************************************************
+ **                                                                 **
+ ** IC-Dependent Part --Add in the Specific Definitions in its file **
+ **                                                                 **
+ *********************************************************************/
+#include "rtl865xc_asicregs.h"
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/asicTabs.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/asicTabs.h
new file mode 100644
index 00000000..1a08e7c
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/asicTabs.h
@@ -0,0 +1,24 @@
+/*
+* ----------------------------------------------------------------
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* $Header: /home1/sub1/tmp/cvs2svn/skylark/skylark/skylark/linux-2.6.x/drivers/net/re865x/AsicDriver/asicTabs.h,v 1.1 2007-12-21 10:29:24 davidhsu Exp $
+*
+* Abstract: ASIC table field definitions.
+*
+* $Author: davidhsu $
+*
+* ---------------------------------------------------------------
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef _ASICTABS_H
+#define _ASICTABS_H
+
+
+#endif /*_ASICTABS_H*/
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/crt_sys_reg.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/crt_sys_reg.h
new file mode 100644
index 00000000..c1be3d6
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/crt_sys_reg.h
@@ -0,0 +1,9313 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+/**************************************************************
+// Spec Version                  : 4.0.6
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/7/22 11:18:38
+***************************************************************/
+
+
+#ifndef _SYS_REG_H_INCLUDED_
+#define _SYS_REG_H_INCLUDED_
+#ifdef  _SYS_USE_STRUCT
+typedef struct
+{
+unsigned int     rstn_rsa:1;
+unsigned int     rstn_mipi:1;
+unsigned int     rstn_nf:1;
+unsigned int     rstn_ae:1;
+unsigned int     rstn_tp:1;
+unsigned int     rstn_md:1;
+unsigned int     rstn_cp:1;
+unsigned int     rstn_dc_phy:1;
+unsigned int     rstn_dcu:1;
+unsigned int     rstn_se:1;
+unsigned int     rstn_lvds:1;
+unsigned int     rstn_vo:1;
+unsigned int     rstn_tve:1;
+unsigned int     rstn_gpu:1;
+unsigned int     rstn_aio:1;
+unsigned int     rstn_etn:1;
+unsigned int     rstn_ve3:1;
+unsigned int     rstn_ve2:1;
+unsigned int     rstn_ve1:1;
+unsigned int     rstn_hdmi:1;
+unsigned int     sata_func_exist_0:1;
+unsigned int     rstn_sata_phy_pow_0:1;
+unsigned int     rstn_usb_phy1:1;
+unsigned int     rstn_usb_phy0:1;
+unsigned int     rstn_sata_phy_0:1;
+unsigned int     rstn_usb:1;
+unsigned int     rstn_sata_0:1;
+unsigned int     rstn_usb3_p0_mdio:1;
+unsigned int     rstn_gspi:1;
+unsigned int     rstn_usb3_phy0_pow:1;
+unsigned int     rstn_nat:1;
+unsigned int     rstn_misc:1;
+}SYS_SOFT_RESET1;
+
+typedef struct
+{
+unsigned int     rstn_sds_phy:1;
+unsigned int     rstn_cbus_tx:1;
+unsigned int     rstn_misc_sc:1;
+unsigned int     rstn_ur1:1;
+unsigned int     rstn_ur2:1;
+unsigned int     rstn_i2c_1:1;
+unsigned int     rstn_i2c_2:1;
+unsigned int     rstn_i2c_3:1;
+unsigned int     rstn_i2c_4:1;
+unsigned int     rstn_pcie1_nonstich:1;
+unsigned int     rstn_pcie1_power:1;
+unsigned int     rstn_pcie1_core:1;
+unsigned int     rstn_pcie1_stitch:1;
+unsigned int     rstn_i2c_5:1;
+unsigned int     rstn_pcie1:1;
+unsigned int     rstn_pcie1_phy:1;
+unsigned int     rstn_pcie0_nonstich:1;
+unsigned int     rstn_pcie0_power:1;
+unsigned int     rstn_pcie0_core:1;
+unsigned int     rstn_sdio:1;
+unsigned int     rstn_emmc:1;
+unsigned int     rstn_cr:1;
+unsigned int     rstn_pcr_cnt:1;
+unsigned int     rstn_pcie0:1;
+unsigned int     rstn_pcie0_phy:1;
+unsigned int     rstn_pcie0_stitch:1;
+unsigned int     rstn_usb3_p1_mdio:1;
+unsigned int     rstn_usb3_phy1_pow:1;
+unsigned int     rstn_usb_phy2:1;
+unsigned int     rstn_usb_phy3:1;
+unsigned int     rstn_jpeg:1;
+unsigned int     rstn_acpu:1;
+}SYS_SOFT_RESET2;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     rstn_sb2:1;
+}SYS_SOFT_RESET3;
+
+typedef struct
+{
+unsigned int     clk_en_sd_ip:1;
+unsigned int     clk_en_sdio:1;
+unsigned int     clk_en_ve3:1;
+unsigned int     clk_en_emmc_ip:1;
+unsigned int     clk_en_mipi:1;
+unsigned int     clk_en_sdio_ip:1;
+unsigned int     clk_en_cr:1;
+unsigned int     clk_en_emmc:1;
+unsigned int     clk_en_nf:1;
+unsigned int     clk_en_rsa:1;
+unsigned int     clk_en_tp:1;
+unsigned int     clk_en_md:1;
+unsigned int     clk_en_cp:1;
+unsigned int     clk_en_dcu:1;
+unsigned int     clk_en_se:1;
+unsigned int     clk_en_lvds:1;
+unsigned int     clk_en_vo:1;
+unsigned int     clk_en_tve:1;
+unsigned int     clk_en_ve2:1;
+unsigned int     clk_en_ve1:1;
+unsigned int     clk_en_gpu:1;
+unsigned int     clk_en_aio:1;
+unsigned int     clk_en_etn:1;
+unsigned int     clk_en_hdmi:1;
+unsigned int     clk_en_sata_alive_0:1;
+unsigned int     clk_en_iso_misc:1;
+unsigned int     clk_en_pcr:1;
+unsigned int     clk_en_usb:1;
+unsigned int     clk_en_gspi:1;
+unsigned int     clk_en_sata_0:1;
+unsigned int     clk_en_pcie0:1;
+unsigned int     clk_en_misc:1;
+}SYS_CLOCK_ENABLE1;
+
+typedef struct
+{
+unsigned int     clk_en_dcphy_1:1;
+unsigned int     clk_en_dcphy_0:1;
+unsigned int     clk_en_fan:1;
+unsigned int     clk_en_ur1:1;
+unsigned int     clk_en_ur2:1;
+unsigned int     clk_en_sata_alive_1:1;
+unsigned int     clk_en_sata_1:1;
+unsigned int     clk_en_hdmirx:1;
+unsigned int     clk_en_aio_mclk:1;
+unsigned int     clk_en_aio_i2s:1;
+unsigned int     clk_en_aio_spdif:1;
+unsigned int     clk_en_aio_hdmi:1;
+unsigned int     clk_en_aio_da:1;
+unsigned int     clk_en_aio_mod:1;
+unsigned int     clk_en_aio_au_codec:1;
+unsigned int     clk_en_misc_i2c_1:1;
+unsigned int     clk_en_misc_i2c_2:1;
+unsigned int     clk_en_misc_i2c_3:1;
+unsigned int     clk_en_misc_i2c_4:1;
+unsigned int     reserved_0:1;
+unsigned int     reserved_1:1;
+unsigned int     clk_en_misc_rtc:1;
+unsigned int     reserved_2:2;
+unsigned int     clk_en_cbus_tx:1;
+unsigned int     clk_en_misc_sc:1;
+unsigned int     clk_en_pcie1:1;
+unsigned int     clk_en_acpu:1;
+unsigned int     clk_en_jpeg:1;
+unsigned int     clk_en_scpu:1;
+unsigned int     clk_en_misc_i2c_5:1;
+unsigned int     clk_en_nat:1;
+}SYS_CLOCK_ENABLE2;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     reserved_group1_ck_en:1;
+}SYS_GROUP1_CK_EN;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     scpu_sclk_sel:1;
+unsigned int     sclk_sel_sysh:1;
+unsigned int     sclk_sel:1;
+}SYS_GROUP1_CK_SEL;
+
+typedef struct
+{
+unsigned int     reserved_0:19;
+unsigned int     write_en5:1;
+unsigned int     clk_tve_p_vo_clk_sel2:1;
+unsigned int     write_en4:1;
+unsigned int     clk_tve_p_vo_clk_sel:1;
+unsigned int     write_en3:1;
+unsigned int     hdmi_phy_ckinv:1;
+unsigned int     write_en2:1;
+unsigned int     reserved_1:2;
+unsigned int     dac2_ckinv:1;
+unsigned int     dac1_ckinv:1;
+unsigned int     write_en1:1;
+unsigned int     tveck_mix_sel:1;
+}SYS_TVE_CK_SEL;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en2:1;
+unsigned int     dac2_div:5;
+unsigned int     write_en1:1;
+unsigned int     dac1_div:5;
+}SYS_DISP_PLL_DIV;
+
+typedef struct
+{
+unsigned int     reserved_0:5;
+unsigned int     write_en11:1;
+unsigned int     sel_prefifo_din:1;
+unsigned int     write_en10:1;
+unsigned int     sel_pllhdmi_mhl:1;
+unsigned int     write_en9:1;
+unsigned int     clk_lvds_sel:5;
+unsigned int     write_en8:1;
+unsigned int     sel_plldisp_clk2:1;
+unsigned int     write_en7:1;
+unsigned int     sel_pllhdmi_clk:1;
+unsigned int     write_en6:1;
+unsigned int     hdmi_pxl_repeat:1;
+unsigned int     write_en5:1;
+unsigned int     hdmi_phy_clk_sel:1;
+unsigned int     write_en4:1;
+unsigned int     hdmi_div:3;
+unsigned int     write_en3:1;
+unsigned int     tve_div:4;
+}SYS_DISP_PLL_DIV2;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     nat_clk_sel:1;
+unsigned int     dds_clk_sel:1;
+}SYS_DDS_VIDEO_CK_SEL;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     mipi_div:2;
+unsigned int     vo_div:2;
+unsigned int     reserved_1:1;
+unsigned int     audio_use_sysclk:1;
+}SYS_AUDIO_CLK_CTL;
+
+typedef struct
+{
+unsigned int     reserved_0:23;
+unsigned int     scpu_freq_sel:2;
+unsigned int     reserved_1:2;
+unsigned int     acpu_freq_sel:2;
+unsigned int     reserved_2:2;
+unsigned int     bus_freq_sel:1;
+}SYS_PLL_DIV;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     emmc_div_sel:2;
+unsigned int     reserved_1:6;
+unsigned int     cr_div_sel:2;
+unsigned int     reserved_2:6;
+unsigned int     sdio_div_sel:2;
+unsigned int     reserved_3:4;
+unsigned int     nf_div_sel:4;
+}SYS_NF_CKSEL;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     nds_sc_div:3;
+}SYS_NDS_SC_CKSEL;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     ref_bypass_mode_dcphy_1:1;
+unsigned int     ref_bypass_mode_dcphy_0:1;
+}SYS_DCPHY_CKSEL;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     clk_camera1_sel:2;
+unsigned int     clk_camera0_sel:2;
+}SYS_MISC_CKSEL;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     CLKTRC_SEL:2;
+}SYS_SCPU_CKSEL;
+
+typedef struct
+{
+unsigned int     reserved_0:23;
+unsigned int     clk_ve2_bpu_sel:3;
+unsigned int     clk_ve3_sel:2;
+unsigned int     clk_ve2_sel:2;
+unsigned int     clk_ve1_sel:2;
+}SYS_VE_CKSEL;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     rstn_disp:1;
+unsigned int     rstn_pcie1_phy_mdio:1;
+unsigned int     rstn_pcie0_phy_mdio:1;
+unsigned int     rstn_hdmirx_wrap:1;
+unsigned int     rstn_fan:1;
+unsigned int     rstn_sata_1:1;
+unsigned int     rstn_sata_phy_1:1;
+unsigned int     sata_func_exist_1:1;
+unsigned int     rstn_sata_phy_pow_1:1;
+unsigned int     rstn_cbusrx:1;
+unsigned int     rstn_hdmirx:1;
+unsigned int     rstn_dcphy_ssc_dig:1;
+unsigned int     rstn_dcphy_ldo:1;
+unsigned int     rstn_dcphy_ptr:1;
+unsigned int     rstn_dcphy_alert_rx:1;
+unsigned int     rstn_dcphy_crt:1;
+}SYS_SOFT_RESET4;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     mclk_sel:3;
+unsigned int     fs:4;
+unsigned int     clken:1;
+}SYS_AIO_O_PCM_CK_CTL;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     fs:4;
+unsigned int     clken:1;
+}SYS_AIO_O_RAW_CK_CTL;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     fs:4;
+unsigned int     clken:1;
+}SYS_AIO_O_RAW2_CK_CTL;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     write_en2:1;
+unsigned int     dds_rstn:1;
+}SYS_APS_CTL;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     mclk_sel:3;
+unsigned int     fs:4;
+unsigned int     clken:1;
+}SYS_AIO_I_PCM_CK_CTL;
+
+typedef struct
+{
+unsigned int     reserved_0:11;
+unsigned int     REG_LDO18V_SEL:2;
+unsigned int     REG_LDO10V_SEL:2;
+unsigned int     REG_TESTSEL_PLLA:1;
+unsigned int     reserved_1:1;
+unsigned int     REG_WD_SET_PLLA:1;
+unsigned int     REG_WD_RST_PLLA:1;
+unsigned int     REG_SEL_CCO_PLLA:1;
+unsigned int     REG_SCPU_DBUG_EN_PLLA:1;
+unsigned int     REG_LPF_RS_PLLA:3;
+unsigned int     REG_LPF_CS_PLLA:2;
+unsigned int     REG_ICP_PLLA:3;
+unsigned int     REG_DIV_PREDIV_BPS_PLLA:1;
+unsigned int     REG_DIV_PREDIV_SEL_PLLA:2;
+}SYS_PLL_SCPU0;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     REG_OEB_PLLA:1;
+unsigned int     SCPU_RSTB_PLLA:1;
+unsigned int     SCPU_POW_PLLA:1;
+}SYS_PLL_SCPU1;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     REG_PLLACPU_PDIV:2;
+unsigned int     REG_PLLACPU_LPF_RS:3;
+unsigned int     REG_PLLACPU_LPF_CS:2;
+unsigned int     REG_PLLACPU_ICP:3;
+unsigned int     REG_PLLACPU_WDRST:1;
+unsigned int     REG_PLLACPU_WDSET:1;
+unsigned int     REG_PLLACPU_TESTSEL:1;
+unsigned int     REG_PLLACPU_SEL_CCO:1;
+unsigned int     REG_PLLACPU_PDIV_BPS:1;
+unsigned int     REG_PLLACPU_DBUG_EN:1;
+unsigned int     reserved_1:3;
+}SYS_PLL_ACPU1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     REG_PLLACPU_OEB:1;
+unsigned int     REG_PLLACPU_RSTB:1;
+unsigned int     REG_PLLACPU_POW:1;
+}SYS_PLL_ACPU2;
+
+typedef struct
+{
+unsigned int     reserved_0:9;
+unsigned int     REG_PLLVCPU_WDRST:1;
+unsigned int     REG_PLLVCPU_WDSET:1;
+unsigned int     REG_PLLVCPU_CS:2;
+unsigned int     REG_PLLVCPU_O:2;
+unsigned int     REG_PLLVCPU_RS:3;
+unsigned int     REG_PLLVCPU_N:2;
+unsigned int     REG_PLLVCPU_M:8;
+unsigned int     REG_PLLVCPU_IP:3;
+unsigned int     REG_PLLVCPU_TST:1;
+}SYS_PLL_VE1_1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     REG_PLLVCPU_OEB:1;
+unsigned int     REG_PLLVCPU_RSTB:1;
+unsigned int     REG_PLLVCPU_POW:1;
+}SYS_PLL_VE1_2;
+
+typedef struct
+{
+unsigned int     reserved_0:7;
+unsigned int     REG_PLLDDSA_WDMODE:2;
+unsigned int     REG_PLLDDSA_RS:3;
+unsigned int     REG_PLLDDSA_O:2;
+unsigned int     REG_PLLDDSA_N:2;
+unsigned int     REG_PLLDDSA_IP:4;
+unsigned int     REG_PLLDDSA_CS:2;
+unsigned int     REG_PLLDDSA_CP:2;
+unsigned int     REG_PLLDDSA_VCORB:1;
+unsigned int     REG_PLLDDSA_TST:1;
+unsigned int     REG_PLLDDSA_PSTST:1;
+unsigned int     reserved_1:5;
+}SYS_PLL_DDSA1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     REG_PLLDDSA_OEB:1;
+unsigned int     REG_PLLDDSA_RSTB:1;
+unsigned int     REG_PLLDDSA_POW:1;
+}SYS_PLL_DDSA2;
+
+typedef struct
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en11:1;
+unsigned int     psaud_1a_phase_sel:1;
+unsigned int     psaud_2a_phase_sel:1;
+unsigned int     write_en10:1;
+unsigned int     pcr_a_smooth_en:1;
+unsigned int     write_en9:1;
+unsigned int     pcr_a_phase_sel:1;
+unsigned int     write_en8:1;
+unsigned int     pcr_a_ctl_en:1;
+unsigned int     reserved_1:9;
+unsigned int     write_en3:1;
+unsigned int     REG_PSAUD1A_FUPDN:1;
+unsigned int     REG_PSAUD1A_DIV:1;
+unsigned int     write_en2:1;
+unsigned int     REG_PSAUD1A_TST:1;
+unsigned int     REG_PSAUD1A_PSEN:1;
+unsigned int     write_en1:1;
+unsigned int     REG_PSAUD2A_FUPDN:1;
+unsigned int     REG_PSAUD2A_DIV:1;
+unsigned int     REG_PSAUD2A_TST:1;
+unsigned int     REG_PSAUD2A_PSEN:1;
+}SYS_PLL_PSAUDA1;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     REG_PSAUD1A_OEB:1;
+unsigned int     REG_PSAUD1A_RSTB:1;
+unsigned int     REG_PSAUD2A_OEB:1;
+unsigned int     REG_PSAUD2A_RSTB:1;
+}SYS_PLL_PSAUDA2;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     reserved_pll_disp_hd1:1;
+}SYS_PLL_DISP_HD1;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     reserved_pll_disp_hd2:1;
+}SYS_PLL_DISP_HD2;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_PLLTST_POW:1;
+unsigned int     reserved_1:4;
+}SYS_PLL1_TEST;
+
+typedef struct
+{
+unsigned int     reserved_0:5;
+unsigned int     REG_PLLBUS_RESER:8;
+unsigned int     REG_PLLBUS_PDIV:2;
+unsigned int     REG_PLLBUS_LPF_RS:3;
+unsigned int     REG_PLLBUS_LPF_CS:2;
+unsigned int     REG_PLLBUS_ICP:3;
+unsigned int     REG_PLLBUS_WDSET:1;
+unsigned int     REG_PLLBUS_WDRST:1;
+unsigned int     REG_PLLBUS_TESTSEL:1;
+unsigned int     REG_PLLBUS_SEL_CCO:1;
+unsigned int     REG_PLLBUS_PDIV_BPS:1;
+unsigned int     REG_PLLBUS_DBUG_EN:1;
+unsigned int     reserved_1:3;
+}SYS_PLL_BUS1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     REG_PLLBUS_OEB:1;
+unsigned int     REG_PLLBUS_RSTB:1;
+unsigned int     REG_PLLBUS_POW:1;
+}SYS_PLL_BUS2;
+
+typedef struct
+{
+unsigned int     reserved_0:17;
+unsigned int     REG_EDPPLL_WDO:1;
+unsigned int     REG_PIXELPLL_WDO:1;
+unsigned int     REG_PLLGPU_WDOUT:1;
+unsigned int     reserved_1:1;
+unsigned int     REG_PLLBUS_WDOUT_H:1;
+unsigned int     reserved_2:1;
+unsigned int     REG_PLLVODMA_WDOUT:1;
+unsigned int     REG_PLLVCPU_WDOUT_2:1;
+unsigned int     REG_PLLBUS_WDOUT:1;
+unsigned int     reserved_3:1;
+unsigned int     REG_PLLDDSB_WDOUT:1;
+unsigned int     REG_PLLDDSA_WDOUT:1;
+unsigned int     REG_PLLVCPU_WDOUT:1;
+unsigned int     REG_PLLACPU_WDOUT:1;
+unsigned int     reserved_4:1;
+}SYS_PLL_WDOUT;
+
+typedef struct
+{
+unsigned int     reserved_0:7;
+unsigned int     REG_PLLDDSB_WDMODE:2;
+unsigned int     REG_PLLDDSB_RS:3;
+unsigned int     REG_PLLDDSB_O:2;
+unsigned int     REG_PLLDDSB_N:2;
+unsigned int     REG_PLLDDSB_IP:4;
+unsigned int     REG_PLLDDSB_CS:2;
+unsigned int     REG_PLLDDSB_CP:2;
+unsigned int     REG_PLLDDSB_VCORB:1;
+unsigned int     REG_PLLDDSB_TST:1;
+unsigned int     REG_PLLDDSB_PSTST:1;
+unsigned int     reserved_1:5;
+}SYS_PLL_DDSB1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     REG_PLLDDSB_OEB:1;
+unsigned int     REG_PLLDDSB_RSTB:1;
+unsigned int     REG_PLLDDSB_POW:1;
+}SYS_PLL_DDSB2;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en10:1;
+unsigned int     pcr_b_smooth_en:1;
+unsigned int     write_en9:1;
+unsigned int     pcr_b_phase_sel:1;
+unsigned int     write_en8:1;
+unsigned int     pcr_b_ctl_en:1;
+unsigned int     reserved_1:9;
+unsigned int     write_en3:1;
+unsigned int     REG_PSAUD1B_FUPDN:1;
+unsigned int     REG_PSAUD1B_DIV:1;
+unsigned int     write_en2:1;
+unsigned int     REG_PSAUD1B_TST:1;
+unsigned int     REG_PSAUD1B_PSEN:1;
+unsigned int     write_en1:1;
+unsigned int     REG_PSAUD2B_FUPDN:1;
+unsigned int     REG_PSAUD2B_DIV:1;
+unsigned int     REG_PSAUD2B_TST:1;
+unsigned int     REG_PSAUD2B_PSEN:1;
+}SYS_PLL_PSAUDB1;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     REG_PSAUD1B_OEB:1;
+unsigned int     REG_PSAUD1B_RSTB:1;
+unsigned int     REG_PSAUD2B_OEB:1;
+unsigned int     REG_PSAUD2B_RSTB:1;
+}SYS_PLL_PSAUDB2;
+
+typedef struct
+{
+unsigned int     reserved_0:23;
+unsigned int     PLLDISP_OEB:1;
+unsigned int     PLLDISP_VCORSTB:1;
+unsigned int     REG_PLL_MHL3_DIV_EN:1;
+unsigned int     REG_PLLDISP_RSTB:1;
+unsigned int     REG_PLLDISP_POW:1;
+unsigned int     REG_TMDS_POW:1;
+unsigned int     REG_PLL_RSTB:1;
+unsigned int     REG_PLL_POW:1;
+unsigned int     REG_HDMI_CK_EN:1;
+}SYS_PLL_HDMI;
+
+typedef struct
+{
+unsigned int     reserved_0:9;
+unsigned int     REG_ICO_PDIV2:3;
+unsigned int     REG_TMDS_DIV:4;
+unsigned int     REG_PLLDISP_N:2;
+unsigned int     REG_PLLDISP_K:2;
+unsigned int     REG_PIXEL_DIV:8;
+unsigned int     REG_PLL_M2:2;
+unsigned int     REG_PLL_M1:2;
+}SYS_PLL_HDMI2;
+
+typedef struct
+{
+unsigned int     reserved_0:19;
+unsigned int     phsel1:5;
+unsigned int     phsel0:5;
+unsigned int     phrstb_dly_sel:1;
+unsigned int     phrt0:1;
+unsigned int     bias_en:1;
+}SYS_PLL_SDIO1;
+
+typedef struct
+{
+unsigned int     reserved_0:5;
+unsigned int     en_cpnew:1;
+unsigned int     ssc_div_ext_f:8;
+unsigned int     ssc_div_f_sel:1;
+unsigned int     ssc_8x_en:1;
+unsigned int     ssc_depth:3;
+unsigned int     sscpll_rs:3;
+unsigned int     sscpll_icp:5;
+unsigned int     sscpll_cs1:2;
+unsigned int     reg_tune11:2;
+unsigned int     sscldo_en:1;
+}SYS_PLL_SDIO2;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     ssc_div_n:10;
+unsigned int     reserved_1:1;
+unsigned int     ssc_step_in:7;
+unsigned int     ssc_tbase:8;
+}SYS_PLL_SDIO3;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     ssc_pll_pow:1;
+unsigned int     ssc_pll_rstb:1;
+unsigned int     ssc_rstb:1;
+}SYS_PLL_SDIO4;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     REG_PLLBUS_PDIV_H:2;
+unsigned int     REG_PLLBUS_LPF_RS_H:3;
+unsigned int     REG_PLLBUS_LPF_CS_H:2;
+unsigned int     REG_PLLBUS_ICP_H:3;
+unsigned int     REG_PLLBUS_WDSET_H:1;
+unsigned int     REG_PLLBUS_WDRST_H:1;
+unsigned int     REG_PLLBUS_TESTSEL_H:1;
+unsigned int     REG_PLLBUS_SEL_CCO_H:1;
+unsigned int     REG_PLLBUS_PDIV_BPS_H:1;
+unsigned int     REG_PLLBUS_DBUG_EN_H:1;
+unsigned int     reserved_1:3;
+}SYS_PLL_BUSH1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     REG_PLLBUS_OEB_H:1;
+unsigned int     REG_PLLBUS_RSTB_H:1;
+unsigned int     REG_PLLBUS_POW_H:1;
+}SYS_PLL_BUSH2;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     REG_PLLGPU_PDIV:2;
+unsigned int     REG_PLLGPU_LPF_RS:3;
+unsigned int     REG_PLLGPU_LPF_CS:2;
+unsigned int     REG_PLLGPU_ICP:3;
+unsigned int     REG_PLLGPU_WDRST:1;
+unsigned int     REG_PLLGPU_WDSET:1;
+unsigned int     REG_PLLGPU_TESTSEL:1;
+unsigned int     REG_PLLGPU_SEL_CCO:1;
+unsigned int     REG_PLLGPU_PDIV_BPS:1;
+unsigned int     REG_PLLGPU_DBUG_EN:1;
+unsigned int     reserved_1:3;
+}SYS_PLL_GPU1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     REG_PLLGPU_OEB:1;
+unsigned int     REG_PLLGPU_RSTB:1;
+unsigned int     REG_PLLGPU_POW:1;
+}SYS_PLL_GPU2;
+
+typedef struct
+{
+unsigned int     reserved_0:9;
+unsigned int     REG_PLLVCPU_WDRST_2:1;
+unsigned int     REG_PLLVCPU_WDSET_2:1;
+unsigned int     REG_PLLVCPU_CS_2:2;
+unsigned int     REG_PLLVCPU_O_2:2;
+unsigned int     REG_PLLVCPU_RS_2:3;
+unsigned int     REG_PLLVCPU_N_2:2;
+unsigned int     REG_PLLVCPU_M_2:8;
+unsigned int     REG_PLLVCPU_IP_2:3;
+unsigned int     REG_PLLVCPU_TST_2:1;
+}SYS_PLL_VE2_1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     REG_PLLVCPU_OEB_2:1;
+unsigned int     REG_PLLVCPU_RSTB_2:1;
+unsigned int     REG_PLLVCPU_POW_2:1;
+}SYS_PLL_VE2_2;
+
+typedef struct
+{
+unsigned int     reserved_0:17;
+unsigned int     reg_sel3318:2;
+unsigned int     phsel1:5;
+unsigned int     phsel0:5;
+unsigned int     phrstb_dly_sel:1;
+unsigned int     phrt0:1;
+unsigned int     bias_en:1;
+}SYS_PLL_SD1;
+
+typedef struct
+{
+unsigned int     reserved_0:5;
+unsigned int     en_cpnew:1;
+unsigned int     ssc_div_ext_f:8;
+unsigned int     ssc_div_f_sel:1;
+unsigned int     ssc_8x_en:1;
+unsigned int     ssc_depth:3;
+unsigned int     sscpll_rs:3;
+unsigned int     sscpll_icp:5;
+unsigned int     sscpll_cs1:2;
+unsigned int     reg_tune11:2;
+unsigned int     sscldo_en:1;
+}SYS_PLL_SD2;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     ssc_div_n:10;
+unsigned int     reserved_1:1;
+unsigned int     ssc_step_in:7;
+unsigned int     ssc_tbase:8;
+}SYS_PLL_SD3;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     ssc_pll_pow:1;
+unsigned int     ssc_pll_rstb:1;
+unsigned int     ssc_rstb:1;
+}SYS_PLL_SD4;
+
+typedef struct
+{
+unsigned int     reserved_0:19;
+unsigned int     phsel1:5;
+unsigned int     phsel0:5;
+unsigned int     phrstb_dly_sel:1;
+unsigned int     phrt0:1;
+unsigned int     bias_en:1;
+}SYS_PLL_EMMC1;
+
+typedef struct
+{
+unsigned int     reserved_0:5;
+unsigned int     en_cpnew:1;
+unsigned int     ssc_div_ext_f:8;
+unsigned int     ssc_div_f_sel:1;
+unsigned int     ssc_8x_en:1;
+unsigned int     ssc_depth:3;
+unsigned int     sscpll_rs:3;
+unsigned int     sscpll_icp:5;
+unsigned int     sscpll_cs1:2;
+unsigned int     reg_tune11:2;
+unsigned int     sscldo_en:1;
+}SYS_PLL_EMMC2;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     ssc_div_n:10;
+unsigned int     reserved_1:1;
+unsigned int     ssc_step_in:7;
+unsigned int     ssc_tbase:8;
+}SYS_PLL_EMMC3;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     ssc_pll_pow:1;
+unsigned int     ssc_pll_rstb:1;
+unsigned int     ssc_rstb:1;
+}SYS_PLL_EMMC4;
+
+typedef struct
+{
+unsigned int     reserved_0:18;
+unsigned int     REG_TEST_SEL:2;
+unsigned int     POR_VSET:1;
+unsigned int     REG_PLLDDSB_CKIN_SEL:1;
+unsigned int     REG_PLLDISP_SEL:2;
+unsigned int     REG_HDMITX_27M_SEL:2;
+unsigned int     REG_PLLGPU_BYPASS_PI:1;
+unsigned int     REG_PLLDDSB_BYPASS_PI:1;
+unsigned int     REG_PLLDDSA_BYPASS_PI:1;
+unsigned int     REG_PLLBUS_BYPASS_PI_H:1;
+unsigned int     REG_PLLBUS_BYPASS_PI:1;
+unsigned int     REG_PLLACPU_BYPASS_PI:1;
+}SYS_PLL_OTHER;
+
+typedef struct
+{
+unsigned int     time_rdy_ckout:2;
+unsigned int     time2_rst_width:2;
+unsigned int     pcr_rst_n:1;
+unsigned int     time0_ck:3;
+unsigned int     f390k:2;
+unsigned int     pll_en:1;
+unsigned int     en_wdog:1;
+unsigned int     ssc_ckinv:1;
+unsigned int     fcode:11;
+unsigned int     ncode:8;
+}SYS_PLL_HDMI_SD1;
+
+typedef struct
+{
+unsigned int     bypass_pi:1;
+unsigned int     en_pi_debug:1;
+unsigned int     hs_oc_stop_diff:2;
+unsigned int     reserved_0:2;
+unsigned int     sel_oc_mode:2;
+unsigned int     reserved_1:2;
+unsigned int     oc_done_delay:6;
+unsigned int     reserved_2:1;
+unsigned int     pi_cur_sel:3;
+unsigned int     oc_step_set:10;
+unsigned int     sdm_order:1;
+unsigned int     oc_en:1;
+}SYS_PLL_HDMI_SD2;
+
+typedef struct
+{
+unsigned int     load_fcw:1;
+unsigned int     reserved_0:3;
+unsigned int     fmod:1;
+unsigned int     fcode_debug:11;
+unsigned int     ncode_debug:8;
+unsigned int     reserved_1:6;
+unsigned int     clkrdy:1;
+unsigned int     oc_done:1;
+}SYS_PLL_HDMI_SD3;
+
+typedef struct
+{
+unsigned int     reserved_0:12;
+unsigned int     ssc_en:1;
+unsigned int     fcode_ssc:11;
+unsigned int     ncode_ssc:8;
+}SYS_PLL_HDMI_SD4;
+
+typedef struct
+{
+unsigned int     reserved_0:8;
+unsigned int     RSTB_HDMITX:1;
+unsigned int     gran_auto_rst:1;
+unsigned int     dot_gran:3;
+unsigned int     gran_est:19;
+}SYS_PLL_HDMI_SD5;
+
+typedef struct
+{
+unsigned int     REG_PLL_RESERVED:8;
+unsigned int     reserved_0:13;
+unsigned int     REG_LDO2V_SEL:2;
+unsigned int     REG_LDO2V_POW:1;
+unsigned int     reserved_1:8;
+}SYS_BG_CTL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     POR_VDD_D10_OVER:1;
+}SYS_POR_DET;
+
+typedef struct
+{
+unsigned int     reserved_0:2;
+unsigned int     REG_BYPASS_PI:1;
+unsigned int     REG_P2S_LDO_SEL:2;
+unsigned int     REG_P2S_MODE:2;
+unsigned int     REG_TSPC_SEL:1;
+unsigned int     REG_MHL_MODE:1;
+unsigned int     REG_HDMI_MODE:1;
+unsigned int     REG_HDMICK_SEL:1;
+unsigned int     REG_PLL_TST_POW:1;
+unsigned int     REG_PLL_LDO_V18_SEL:2;
+unsigned int     REG_PLL_LDO_LV_SEL:2;
+unsigned int     REG_TST_DIV:3;
+unsigned int     REG_PLL_RS:3;
+unsigned int     REG_PLL_WDSET:1;
+unsigned int     REG_PLL_WDRST:1;
+unsigned int     REG_PLL_VCOGAIN:1;
+unsigned int     REG_PLL_EXT_LDO_LV:1;
+unsigned int     REG_PLL_CKSEL:2;
+unsigned int     REG_PLL_CS:2;
+unsigned int     REG_PLL_CP:2;
+}SYS_PLL_HDMI_LDO1;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     REG_TMDS_RSELCK:2;
+unsigned int     REG_TMDS_RSELC:2;
+unsigned int     REG_TMDS_RSELB:2;
+unsigned int     REG_TMDS_RSELA:2;
+unsigned int     REG_TMDS_CSELCK:2;
+unsigned int     REG_TMDS_CSELC:2;
+unsigned int     REG_TMDS_CSELB:2;
+unsigned int     REG_TMDS_CSELA:2;
+unsigned int     REG_TMDS_POWMHLCK_B:1;
+unsigned int     REG_TMDS_POWMHLCK_A:1;
+unsigned int     REG_TMDS_POWCK:1;
+unsigned int     REG_TMDS_POWC:1;
+unsigned int     REG_TMDS_POWB:1;
+unsigned int     REG_TMDS_POWA:1;
+unsigned int     REG_TMDS_EMCK:1;
+unsigned int     REG_TMDS_EMC:1;
+unsigned int     REG_TMDS_EMB:1;
+unsigned int     REG_TMDS_EMA:1;
+}SYS_PLL_HDMI_LDO2;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     REG_PLL_CKIN_SEL:2;
+unsigned int     REG_PLL_TSPC_SEL:1;
+unsigned int     REG_PCR_27M_SEL:1;
+unsigned int     REG_TMDS_IDRVCK:3;
+unsigned int     REG_TMDS_IDRVC:3;
+unsigned int     REG_TMDS_IDRVB:3;
+unsigned int     REG_TMDS_IDRVA:3;
+unsigned int     REG_TMDS_SRMHLCK:2;
+unsigned int     REG_TMDS_SRCK:2;
+unsigned int     REG_TMDS_SRC:2;
+unsigned int     REG_TMDS_SRB:2;
+unsigned int     REG_TMDS_SRA:2;
+}SYS_PLL_HDMI_LDO3;
+
+typedef struct
+{
+unsigned int     reserved_0:2;
+unsigned int     REG_PLLDISP_DDSEN:1;
+unsigned int     REG_PLLDISP_CS:2;
+unsigned int     REG_PLLDISP_CP:2;
+unsigned int     REG_PLLDISP_C3:2;
+unsigned int     REG_TEST_LDO_SEL:2;
+unsigned int     REG_TESTSIG_SEL:2;
+unsigned int     REG_PLL_IP:4;
+unsigned int     REG_TMDS_IMHLCK:3;
+unsigned int     REG_TMDS_IEMCK:3;
+unsigned int     REG_TMDS_IEMC:3;
+unsigned int     REG_TMDS_IEMB:3;
+unsigned int     REG_TMDS_IEMA:3;
+}SYS_PLL_HDMI_LDO4;
+
+typedef struct
+{
+unsigned int     REG_HDMITX_RESERVE:16;
+unsigned int     REG_PLLDISP_LDOSEL:2;
+unsigned int     REG_PLLDISP_SSC_ENL:1;
+unsigned int     REG_PLLDISP_WDMODE:2;
+unsigned int     REG_PLLDISP_RS:3;
+unsigned int     REG_PLLDISP_R3:3;
+unsigned int     REG_PLLDISP_PSTST:1;
+unsigned int     REG_PLLDISP_IP:4;
+}SYS_PLL_HDMI_LDO5;
+
+typedef struct
+{
+unsigned int     REG_EDPPLL_LDOPOW:1;
+unsigned int     reserved_0:1;
+unsigned int     REG_EDPPLL_LDOSEL:2;
+unsigned int     REG_EDPPLL_LDOV10POW:1;
+unsigned int     reserved_1:1;
+unsigned int     REG_EDPPLL_LDOV10SEL:2;
+unsigned int     reserved_2:2;
+unsigned int     REG_EDPPLL_CS:2;
+unsigned int     reserved_3:1;
+unsigned int     REG_EDPPLL_RS:3;
+unsigned int     REG_EDPPLL_CP:1;
+unsigned int     REG_EDPPLL_IP:3;
+unsigned int     REG_EDPPLL_DIV10X:1;
+unsigned int     reserved_4:1;
+unsigned int     REG_EDPPLL_WDRST:1;
+unsigned int     REG_EDPPLL_WDSET:1;
+unsigned int     REG_EDPPLL_N:2;
+unsigned int     REG_EDPPLL_DIV_P:2;
+unsigned int     REG_EDPPLL_TEST:1;
+unsigned int     REG_EDPPLL_INCF:1;
+unsigned int     REG_EDPPLL_PI_BPS:1;
+unsigned int     REG_BIAS_POW:1;
+}SYS_PLL_EDP1;
+
+typedef struct
+{
+unsigned int     reserved_0:22;
+unsigned int     REG_EDPPLL_RESERVED:8;
+unsigned int     REG_EDPPLL_RSTB:1;
+unsigned int     REG_EDPPLL_POW:1;
+}SYS_PLL_EDP2;
+
+typedef struct
+{
+unsigned int     REG_PIXELPLL_LDOPOW:1;
+unsigned int     reserved_0:1;
+unsigned int     REG_PIXELPLL_LDOSEL:2;
+unsigned int     reserved_1:1;
+unsigned int     REG_PIXELPLL_RS:3;
+unsigned int     reserved_2:1;
+unsigned int     REG_PIXELPLL_IP:3;
+unsigned int     REG_PIXELPLL_CP:2;
+unsigned int     REG_PIXELPLL_CS:2;
+unsigned int     reserved_3:1;
+unsigned int     REG_PIXELPLL_RSTB:1;
+unsigned int     REG_PIXELPLL_WDRST:1;
+unsigned int     REG_PIXELPLL_WDSET:1;
+unsigned int     REG_PIXELPLL_BPSIN:1;
+unsigned int     REG_PIXELPLL_N:3;
+unsigned int     REG_PIXELPLL_VCORSTB:1;
+unsigned int     reserved_4:1;
+unsigned int     REG_PIXELPLL_O:2;
+unsigned int     REG_PIXELPLL_TEST:1;
+unsigned int     REG_PIXELPLL_FREEZE:1;
+unsigned int     REG_PIXELPLL_BPSPI:1;
+unsigned int     reserved_5:1;
+}SYS_PLL_PIXEL1;
+
+typedef struct
+{
+unsigned int     reserved_0:19;
+unsigned int     REG_PIXELPLL_RESER:4;
+unsigned int     REG_PIXELPLL_RESERVED:8;
+unsigned int     REG_PIXELPLL_POW:1;
+}SYS_PLL_PIXEL2;
+
+typedef struct
+{
+unsigned int     reserved_0:9;
+unsigned int     REG_PLLVODMA_WDRST:1;
+unsigned int     REG_PLLVODMA_WDSET:1;
+unsigned int     REG_PLLVODMA_CS:2;
+unsigned int     REG_PLLVODMA_O:2;
+unsigned int     REG_PLLVODMA_RS:3;
+unsigned int     REG_PLLVODMA_N:2;
+unsigned int     REG_PLLVODMA_M:8;
+unsigned int     REG_PLLVODMA_IP:3;
+unsigned int     REG_PLLVODMA_TST:1;
+}SYS_PLL_VODMA1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     REG_PLLVODMA_OEB:1;
+unsigned int     REG_PLLVODMA_RSTB:1;
+unsigned int     REG_PLLVODMA_POW:1;
+}SYS_PLL_VODMA2;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     testmode:1;
+unsigned int     nf_sel:1;
+unsigned int     boot_sel:1;
+}SYS_CHIP_INFO2;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     reserved_scpu_l2:1;
+}SYS_SCPU_L2;
+
+typedef struct
+{
+unsigned int     scpu_boot_info:32;
+}SYS_PWDN_CTRL;
+
+typedef struct
+{
+unsigned int     acpu_boot_info:32;
+}SYS_PWDN_CTRL2;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     write_en2:1;
+unsigned int     scpu_boot_info_valid:1;
+unsigned int     write_en1:1;
+unsigned int     scpu_sw_rst:1;
+}SYS_PWDN_CTRL3;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     acpu_boot_info_valid:1;
+}SYS_PWDN_CTRL4;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     write_en3:1;
+unsigned int     hdmirx_at_speed_pll_done:1;
+unsigned int     write_en2:1;
+unsigned int     dac_test:1;
+unsigned int     write_en1:1;
+unsigned int     scpu_config_done:1;
+}SYS_AT_SPEED;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     reserved_ana_ctrl:1;
+}SYS_ANA_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     reserved_tp_demod_ctrl:1;
+}SYS_TP_DEMOD_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     reserved_phy_func:1;
+}SYS_PHY_FUNC;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     analogy_mode_sel:4;
+}SYS_ANLG;
+
+typedef struct
+{
+unsigned int     reserved_0:22;
+unsigned int     REG_TEST_EN:1;
+unsigned int     REG_PLLTST_EN:1;
+unsigned int     REG_PLLTST_DIV32:1;
+unsigned int     REG_PLLTST_DIV16:1;
+unsigned int     REG_PLLTST_SEL:4;
+unsigned int     REG_PLLTST_DIV:2;
+}SYS_PLL_TEST1;
+
+typedef struct
+{
+unsigned int     reserved_0:21;
+unsigned int     REG_VDDMUX_SEL:1;
+unsigned int     REG_VDD_MUX1:4;
+unsigned int     REG_VDD_MUX2:4;
+unsigned int     REG_VDDMUX_EN:1;
+unsigned int     REG_TEST_OUT_EN:1;
+}SYS_LSADC_PG;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     scan_occ_chain_sel:1;
+}SYS_SCAN_CTRL;
+
+typedef struct
+{
+unsigned int     L2H_DELAY_CYCLE:32;
+}SYS_DISP_SRAM_PWR0;
+
+typedef struct
+{
+unsigned int     H2L_DELAY_CYCLE:32;
+}SYS_DISP_SRAM_PWR1;
+
+typedef struct
+{
+unsigned int     SD_REG:32;
+}SYS_DISP_SRAM_PWR2;
+
+typedef struct
+{
+unsigned int     MUX_REG:32;
+}SYS_DISP_SRAM_PWR3;
+
+typedef struct
+{
+unsigned int     CTRL:32;
+}SYS_DISP_SRAM_PWR4;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     disp_sram_int:1;
+unsigned int     reserved_1:1;
+unsigned int     write_data:1;
+}SYS_DISP_SRAM_PWR5;
+
+typedef struct
+{
+unsigned int     last_delay_cycle:32;
+}SYS_DISP_SRAM_PWR6;
+
+typedef struct
+{
+unsigned int     pg_switch_info:32;
+}SYS_DISP_SRAM_PWR7;
+
+typedef struct
+{
+unsigned int     L2H_DELAY_CYCLE:32;
+}SYS_VE1_SRAM_PWR0;
+
+typedef struct
+{
+unsigned int     H2L_DELAY_CYCLE:32;
+}SYS_VE1_SRAM_PWR1;
+
+typedef struct
+{
+unsigned int     SD_REG:32;
+}SYS_VE1_SRAM_PWR2;
+
+typedef struct
+{
+unsigned int     MUX_REG:32;
+}SYS_VE1_SRAM_PWR3;
+
+typedef struct
+{
+unsigned int     CTRL:32;
+}SYS_VE1_SRAM_PWR4;
+
+typedef struct
+{
+unsigned int     L2H_DELAY_CYCLE:32;
+}SYS_GPU_SRAM_PWR0;
+
+typedef struct
+{
+unsigned int     H2L_DELAY_CYCLE:32;
+}SYS_GPU_SRAM_PWR1;
+
+typedef struct
+{
+unsigned int     SD_REG:32;
+}SYS_GPU_SRAM_PWR2;
+
+typedef struct
+{
+unsigned int     MUX_REG:32;
+}SYS_GPU_SRAM_PWR3;
+
+typedef struct
+{
+unsigned int     CTRL:32;
+}SYS_GPU_SRAM_PWR4;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     ve1_sram_int:1;
+unsigned int     reserved_1:1;
+unsigned int     write_data:1;
+}SYS_VE1_SRAM_PWR5;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     gpu_sram_int:1;
+unsigned int     reserved_1:1;
+unsigned int     write_data:1;
+}SYS_GPU_SRAM_PWR5;
+
+typedef struct
+{
+unsigned int     last_delay_cycle:32;
+}SYS_VE1_SRAM_PWR6;
+
+typedef struct
+{
+unsigned int     last_delay_cycle:32;
+}SYS_GPU_SRAM_PWR6;
+
+typedef struct
+{
+unsigned int     pg_switch_info:32;
+}SYS_VE1_SRAM_PWR7;
+
+typedef struct
+{
+unsigned int     pg_switch_info:32;
+}SYS_GPU_SRAM_PWR7;
+
+typedef struct
+{
+unsigned int     L2H_DELAY_CYCLE:32;
+}SYS_VE2_SRAM_PWR0;
+
+typedef struct
+{
+unsigned int     H2L_DELAY_CYCLE:32;
+}SYS_VE2_SRAM_PWR1;
+
+typedef struct
+{
+unsigned int     SD_REG:32;
+}SYS_VE2_SRAM_PWR2;
+
+typedef struct
+{
+unsigned int     MUX_REG:32;
+}SYS_VE2_SRAM_PWR3;
+
+typedef struct
+{
+unsigned int     CTRL:32;
+}SYS_VE2_SRAM_PWR4;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     ve2_sram_int:1;
+unsigned int     reserved_1:1;
+unsigned int     write_data:1;
+}SYS_VE2_SRAM_PWR5;
+
+typedef struct
+{
+unsigned int     last_delay_cycle:32;
+}SYS_VE2_SRAM_PWR6;
+
+typedef struct
+{
+unsigned int     pg_switch_info:32;
+}SYS_VE2_SRAM_PWR7;
+
+typedef struct
+{
+unsigned int     L2H_DELAY_CYCLE:32;
+}SYS_VE3_SRAM_PWR0;
+
+typedef struct
+{
+unsigned int     H2L_DELAY_CYCLE:32;
+}SYS_VE3_SRAM_PWR1;
+
+typedef struct
+{
+unsigned int     SD_REG:32;
+}SYS_VE3_SRAM_PWR2;
+
+typedef struct
+{
+unsigned int     MUX_REG:32;
+}SYS_VE3_SRAM_PWR3;
+
+typedef struct
+{
+unsigned int     CTRL:32;
+}SYS_VE3_SRAM_PWR4;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     ve3_sram_int:1;
+unsigned int     reserved_1:1;
+unsigned int     write_data:1;
+}SYS_VE3_SRAM_PWR5;
+
+typedef struct
+{
+unsigned int     last_delay_cycle:32;
+}SYS_VE3_SRAM_PWR6;
+
+typedef struct
+{
+unsigned int     pg_switch_info:32;
+}SYS_VE3_SRAM_PWR7;
+
+typedef struct
+{
+unsigned int     reserved_0:12;
+unsigned int     nat_sram_int_mask:1;
+unsigned int     iso_nat:1;
+unsigned int     vetop_rm:4;
+unsigned int     vetop_rme:1;
+unsigned int     vetop_sd:1;
+unsigned int     vetop_ds:1;
+unsigned int     vetop_ls:1;
+unsigned int     disp_sram_int_mask:1;
+unsigned int     iso_disp:1;
+unsigned int     ve3_sram_int_mask:1;
+unsigned int     iso_ve3:1;
+unsigned int     ve2_sram_int_mask:1;
+unsigned int     iso_ve2:1;
+unsigned int     ve1_sram_int_mask:1;
+unsigned int     gpu_sram_int_mask:1;
+unsigned int     iso_gpu:1;
+unsigned int     iso_ve1:1;
+}SYS_POWER_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:17;
+unsigned int     vprob_plltest_sel_loc1:5;
+unsigned int     vprob_plltest_sel_loc0:5;
+unsigned int     vprob_ea_loc1:1;
+unsigned int     vprob_ea_loc0:1;
+unsigned int     reserved_1:3;
+}SYS_PLL_PROB;
+
+typedef struct
+{
+unsigned int     reserved_0:23;
+unsigned int     crt_dbg_en:1;
+unsigned int     crt_dbg_sel0:4;
+unsigned int     crt_dbg_sel1:4;
+}SYS_CRT_DEBUG;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     reserved_debug:1;
+}SYS_DEBUG;
+
+typedef struct
+{
+unsigned int     rbus_protect:32;
+}SYS_MBIST;
+
+typedef struct
+{
+unsigned int     reserved_0:25;
+unsigned int     dvsorting:1;
+unsigned int     pcie1_bak_sel:1;
+unsigned int     pcie0_bak_sel:1;
+unsigned int     plldiv_sel:4;
+}SYS_PLLDIV;
+
+typedef struct
+{
+unsigned int     L2H_DELAY_CYCLE:32;
+}SYS_NAT_SRAM_PWR0;
+
+typedef struct
+{
+unsigned int     H2L_DELAY_CYCLE:32;
+}SYS_NAT_SRAM_PWR1;
+
+typedef struct
+{
+unsigned int     SD_REG:32;
+}SYS_NAT_SRAM_PWR2;
+
+typedef struct
+{
+unsigned int     MUX_REG:32;
+}SYS_NAT_SRAM_PWR3;
+
+typedef struct
+{
+unsigned int     CTRL:32;
+}SYS_NAT_SRAM_PWR4;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     nat_sram_int:1;
+unsigned int     reserved_1:1;
+unsigned int     write_data:1;
+}SYS_NAT_SRAM_PWR5;
+
+typedef struct
+{
+unsigned int     last_delay_cycle:32;
+}SYS_NAT_SRAM_PWR6;
+
+typedef struct
+{
+unsigned int     pg_switch_info:32;
+}SYS_NAT_SRAM_PWR7;
+
+typedef struct
+{
+unsigned int     dmyreg0_rst0:32;
+}SYS_DUMMY0;
+
+typedef struct
+{
+unsigned int     dmyreg1_rst0:32;
+}SYS_DUMMY1;
+
+typedef struct
+{
+unsigned int     dmyreg2_rst1:32;
+}SYS_DUMMY2;
+
+typedef struct
+{
+unsigned int     dmyreg3_rst1:32;
+}SYS_DUMMY3;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_CKSSC_INV_SCPU:1;
+unsigned int     REG_GRAN_AUTO_RST_SCPU:1;
+unsigned int     RSTB_SCPU:1;
+unsigned int     EN_SSC_SCPU:1;
+unsigned int     OC_EN_SCPU:1;
+}SYS_PLL_SSC_DIG_SCPU0;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_T_SCPU:8;
+unsigned int     FCODE_T_SCPU:11;
+}SYS_PLL_SSC_DIG_SCPU1;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     REG_BYPASS_DIVN:1;
+unsigned int     REG_OC_STEP_SET_SCPU:10;
+unsigned int     REG_SEL_OC_MODE_SCPU:2;
+unsigned int     REG_HS_OC_STOP_DIFF_SCPU:2;
+unsigned int     REG_OC_DONE_DELAY_SCPU:6;
+unsigned int     REG_PI_CUR_SEL_SCPU:2;
+unsigned int     REG_BYPASS_PI_SCPU:1;
+unsigned int     REG_SDM_ORDER_SCPU:1;
+unsigned int     REG_EN_PI_DEBUG_SCPU:1;
+unsigned int     reserved_1:2;
+}SYS_PLL_SSC_DIG_SCPU2;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_SSC_SCPU:8;
+unsigned int     FCODE_SSC_SCPU:11;
+}SYS_PLL_SSC_DIG_SCPU3;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     GRAN_EST_SCPU:19;
+}SYS_PLL_SSC_DIG_SCPU4;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     FCW_SSC_DEFAULT_SCPU:19;
+}SYS_PLL_SSC_DIG_SCPU5;
+
+typedef struct
+{
+unsigned int     reserved_0:17;
+unsigned int     LOOP_PI_ISEL_SCPU:2;
+unsigned int     PHSEL_SCPU:5;
+unsigned int     DIVN_SCPU:8;
+}SYS_PLL_SSC_DIG_SCPU_DBG1;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     load_FCW_SCPU:1;
+unsigned int     OC_DONE_SCPU:1;
+unsigned int     FMOD_SCPU:1;
+unsigned int     NCODE_DEBUG_SCPU:8;
+unsigned int     FCODE_DEBUG_SCPU:11;
+}SYS_PLL_SSC_DIG_SCPU_DBG2;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_CKSSC_INV_BUS:1;
+unsigned int     REG_GRAN_AUTO_RST_BUS:1;
+unsigned int     RSTB_BUS:1;
+unsigned int     EN_SSC_BUS:1;
+unsigned int     OC_EN_BUS:1;
+}SYS_PLL_SSC_DIG_BUS0;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_T_BUS:8;
+unsigned int     FCODE_T_BUS:11;
+}SYS_PLL_SSC_DIG_BUS1;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     REG_BYPASS_DIVN:1;
+unsigned int     REG_OC_STEP_SET_BUS:10;
+unsigned int     REG_SEL_OC_MODE_BUS:2;
+unsigned int     REG_HS_OC_STOP_DIFF_BUS:2;
+unsigned int     REG_OC_DONE_DELAY_BUS:6;
+unsigned int     REG_BYPASS_PI_BUS:1;
+unsigned int     REG_SDM_ORDER_BUS:1;
+unsigned int     REG_PI_CUR_SEL_BUS:3;
+unsigned int     REG_EN_PI_DEBUG_BUS:1;
+unsigned int     reserved_1:1;
+}SYS_PLL_SSC_DIG_BUS2;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_SSC_BUS:8;
+unsigned int     FCODE_SSC_BUS:11;
+}SYS_PLL_SSC_DIG_BUS3;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     GRAN_EST_BUS:19;
+}SYS_PLL_SSC_DIG_BUS4;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     FCW_SSC_DEFAULT_BUS:19;
+}SYS_PLL_SSC_DIG_BUS5;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     LOOP_PI_ISEL_BUS:3;
+unsigned int     PHSEL_BUS:5;
+unsigned int     DIVN_BUS:8;
+}SYS_PLL_SSC_DIG_BUS_DBG1;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     load_FCW_BUS:1;
+unsigned int     OC_DONE_BUS:1;
+unsigned int     FMOD_BUS:1;
+unsigned int     NCODE_DEBUG_BUS:8;
+unsigned int     FCODE_DEBUG_BUS:11;
+}SYS_PLL_SSC_DIG_BUS_DBG2;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_CKSSC_INV_BUS_H:1;
+unsigned int     REG_GRAN_AUTO_RST_BUS_H:1;
+unsigned int     RSTB_BUS_H:1;
+unsigned int     EN_SSC_BUS_H:1;
+unsigned int     OC_EN_BUS_H:1;
+}SYS_PLL_SSC_DIG_BUSH0;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_T_BUS_H:8;
+unsigned int     FCODE_T_BUS_H:11;
+}SYS_PLL_SSC_DIG_BUSH1;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     REG_BYPASS_DIVN:1;
+unsigned int     REG_OC_STEP_SET_BUS_H:10;
+unsigned int     REG_SEL_OC_MODE_BUS_H:2;
+unsigned int     REG_HS_OC_STOP_DIFF_BUS_H:2;
+unsigned int     REG_OC_DONE_DELAY_BUS_H:6;
+unsigned int     REG_BYPASS_PI_BUS_H:1;
+unsigned int     REG_SDM_ORDER_BUS_H:1;
+unsigned int     REG_PI_CUR_SEL_BUS_H:3;
+unsigned int     REG_EN_PI_DEBUG_BUS_H:1;
+unsigned int     reserved_1:1;
+}SYS_PLL_SSC_DIG_BUSH2;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_SSC_BUS_H:8;
+unsigned int     FCODE_SSC_BUS_H:11;
+}SYS_PLL_SSC_DIG_BUSH3;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     GRAN_EST_BUS_H:19;
+}SYS_PLL_SSC_DIG_BUSH4;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     FCW_SSC_DEFAULT_BUS_H:19;
+}SYS_PLL_SSC_DIG_BUSH5;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     LOOP_PI_ISEL_BUS_H:3;
+unsigned int     PHSEL_BUS_H:5;
+unsigned int     DIVN_BUS_H:8;
+}SYS_PLL_SSC_DIG_BUSH_DBG1;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     load_FCW_BUS_H:1;
+unsigned int     OC_DONE_BUS_H:1;
+unsigned int     FMOD_BUS_H:1;
+unsigned int     NCODE_DEBUG_BUS_H:8;
+unsigned int     FCODE_DEBUG_BUS_H:11;
+}SYS_PLL_SSC_DIG_BUSH_DBG2;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_CKSSC_INV_DDSA:1;
+unsigned int     REG_GRAN_AUTO_RST_DDSA:1;
+unsigned int     RSTB_DDSA:1;
+unsigned int     EN_SSC_DDSA:1;
+unsigned int     OC_EN_DDSA:1;
+}SYS_PLL_SSC_DIG_DDSA0;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     REG_PLLDDSA_ICO_PDIV2:3;
+unsigned int     NCODE_T_DDSA:8;
+unsigned int     FCODE_T_DDSA:11;
+}SYS_PLL_SSC_DIG_DDSA1;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     REG_BYPASS_DIVN:1;
+unsigned int     REG_OC_STEP_SET_DDSA:10;
+unsigned int     REG_SEL_OC_MODE_DDSA:2;
+unsigned int     REG_HS_OC_STOP_DIFF_DDSA:2;
+unsigned int     REG_OC_DONE_DELAY_DDSA:6;
+unsigned int     REG_BYPASS_PI_DDSA:1;
+unsigned int     REG_SDM_ORDER_DDSA:1;
+unsigned int     REG_PI_CUR_SEL_DDSA:3;
+unsigned int     REG_EN_PI_DEBUG_DDSA:1;
+unsigned int     reserved_1:1;
+}SYS_PLL_SSC_DIG_DDSA2;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_SSC_DDSA:8;
+unsigned int     FCODE_SSC_DDSA:11;
+}SYS_PLL_SSC_DIG_DDSA3;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     GRAN_EST_DDSA:19;
+}SYS_PLL_SSC_DIG_DDSA4;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     FCW_SSC_DEFAULT_DDSA:19;
+}SYS_PLL_SSC_DIG_DDSA5;
+
+typedef struct
+{
+unsigned int     reserved_0:15;
+unsigned int     LOOP_PI_ISEL_DDSA:3;
+unsigned int     PHSEL_DDSA:6;
+unsigned int     DIVN_DDSA:8;
+}SYS_PLL_SSC_DIG_DDSA_DBG1;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     load_FCW_DDSA:1;
+unsigned int     OC_DONE_DDSA:1;
+unsigned int     FMOD_DDSA:1;
+unsigned int     NCODE_DEBUG_DDSA:8;
+unsigned int     FCODE_DEBUG_DDSA:11;
+}SYS_PLL_SSC_DIG_DDSA_DBG2;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_CKSSC_INV_DDSB:1;
+unsigned int     REG_GRAN_AUTO_RST_DDSB:1;
+unsigned int     RSTB_DDSB:1;
+unsigned int     EN_SSC_DDSB:1;
+unsigned int     OC_EN_DDSB:1;
+}SYS_PLL_SSC_DIG_DDSB0;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     REG_PLLDDSB_ICO_PDIV2:3;
+unsigned int     NCODE_T_DDSB:8;
+unsigned int     FCODE_T_DDSB:11;
+}SYS_PLL_SSC_DIG_DDSB1;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     REG_BYPASS_DIVN:1;
+unsigned int     REG_OC_STEP_SET_DDSB:10;
+unsigned int     REG_SEL_OC_MODE_DDSB:2;
+unsigned int     REG_HS_OC_STOP_DIFF_DDSB:2;
+unsigned int     REG_OC_DONE_DELAY_DDSB:6;
+unsigned int     REG_BYPASS_PI_DDSB:1;
+unsigned int     REG_SDM_ORDER_DDSB:1;
+unsigned int     REG_PI_CUR_SEL_DDSB:3;
+unsigned int     REG_EN_PI_DEBUG_DDSB:1;
+unsigned int     reserved_1:1;
+}SYS_PLL_SSC_DIG_DDSB2;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_SSC_DDSB:8;
+unsigned int     FCODE_SSC_DDSB:11;
+}SYS_PLL_SSC_DIG_DDSB3;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     GRAN_EST_DDSB:19;
+}SYS_PLL_SSC_DIG_DDSB4;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     FCW_SSC_DEFAULT_DDSB:19;
+}SYS_PLL_SSC_DIG_DDSB5;
+
+typedef struct
+{
+unsigned int     reserved_0:15;
+unsigned int     LOOP_PI_ISEL_DDSB:3;
+unsigned int     PHSEL_DDSB:6;
+unsigned int     DIVN_DDSB:8;
+}SYS_PLL_SSC_DIG_DDSB_DBG1;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     load_FCW_DDSB:1;
+unsigned int     OC_DONE_DDSB:1;
+unsigned int     FMOD_DDSB:1;
+unsigned int     NCODE_DEBUG_DDSB:8;
+unsigned int     FCODE_DEBUG_DDSB:11;
+}SYS_PLL_SSC_DIG_DDSB_DBG2;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_CKSSC_INV_GPU:1;
+unsigned int     REG_GRAN_AUTO_RST_GPU:1;
+unsigned int     RSTB_GPU:1;
+unsigned int     EN_SSC_GPU:1;
+unsigned int     OC_EN_GPU:1;
+}SYS_PLL_SSC_DIG_GPU0;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_T_GPU:8;
+unsigned int     FCODE_T_GPU:11;
+}SYS_PLL_SSC_DIG_GPU1;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     REG_BYPASS_DIVN:1;
+unsigned int     REG_OC_STEP_SET_GPU:10;
+unsigned int     REG_SEL_OC_MODE_GPU:2;
+unsigned int     REG_HS_OC_STOP_DIFF_GPU:2;
+unsigned int     REG_OC_DONE_DELAY_GPU:6;
+unsigned int     REG_BYPASS_PI_GPU:1;
+unsigned int     REG_SDM_ORDER_GPU:1;
+unsigned int     REG_PI_CUR_SEL_GPU:3;
+unsigned int     REG_EN_PI_DEBUG_GPU:1;
+unsigned int     reserved_1:1;
+}SYS_PLL_SSC_DIG_GPU2;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_SSC_GPU:8;
+unsigned int     FCODE_SSC_GPU:11;
+}SYS_PLL_SSC_DIG_GPU3;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     GRAN_EST_GPU:19;
+}SYS_PLL_SSC_DIG_GPU4;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     FCW_SSC_DEFAULT_GPU:19;
+}SYS_PLL_SSC_DIG_GPU5;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     LOOP_PI_ISEL_GPU:3;
+unsigned int     PHSEL_GPU:5;
+unsigned int     DIVN_GPU:8;
+}SYS_PLL_SSC_DIG_GPU_DBG1;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     load_FCW_GPU:1;
+unsigned int     OC_DONE_GPU:1;
+unsigned int     FMOD_GPU:1;
+unsigned int     NCODE_DEBUG_GPU:8;
+unsigned int     FCODE_DEBUG_GPU:11;
+}SYS_PLL_SSC_DIG_GPU_DBG2;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_CKSSC_INV_ACPU:1;
+unsigned int     REG_GRAN_AUTO_RST_ACPU:1;
+unsigned int     RSTB_ACPU:1;
+unsigned int     EN_SSC_ACPU:1;
+unsigned int     OC_EN_ACPU:1;
+}SYS_PLL_SSC_DIG_ACPU0;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_T_ACPU:8;
+unsigned int     FCODE_T_ACPU:11;
+}SYS_PLL_SSC_DIG_ACPU1;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     REG_BYPASS_DIVN:1;
+unsigned int     REG_OC_STEP_SET_ACPU:10;
+unsigned int     REG_SEL_OC_MODE_ACPU:2;
+unsigned int     REG_HS_OC_STOP_DIFF_ACPU:2;
+unsigned int     REG_OC_DONE_DELAY_ACPU:6;
+unsigned int     REG_BYPASS_PI_ACPU:1;
+unsigned int     REG_SDM_ORDER_ACPU:1;
+unsigned int     REG_PI_CUR_SEL_ACPU:3;
+unsigned int     REG_EN_PI_DEBUG_ACPU:1;
+unsigned int     reserved_1:1;
+}SYS_PLL_SSC_DIG_ACPU2;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_SSC_ACPU:8;
+unsigned int     FCODE_SSC_ACPU:11;
+}SYS_PLL_SSC_DIG_ACPU3;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     GRAN_EST_ACPU:19;
+}SYS_PLL_SSC_DIG_ACPU4;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     FCW_SSC_DEFAULT_ACPU:19;
+}SYS_PLL_SSC_DIG_ACPU5;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     LOOP_PI_ISEL_ACPU:3;
+unsigned int     PHSEL_ACPU:5;
+unsigned int     DIVN_ACPU:8;
+}SYS_PLL_SSC_DIG_ACPU_DBG1;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     load_FCW_ACPU:1;
+unsigned int     OC_DONE_ACPU:1;
+unsigned int     FMOD_ACPU:1;
+unsigned int     NCODE_DEBUG_ACPU:8;
+unsigned int     FCODE_DEBUG_ACPU:11;
+}SYS_PLL_SSC_DIG_ACPU_DBG2;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_CKSSC_INV_EDP:1;
+unsigned int     REG_GRAN_AUTO_RST_EDP:1;
+unsigned int     RSTB_EDP:1;
+unsigned int     EN_SSC_EDP:1;
+unsigned int     OC_EN_EDP:1;
+}SYS_PLL_SSC_DIG_EDP0;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_T_EDP:8;
+unsigned int     FCODE_T_EDP:11;
+}SYS_PLL_SSC_DIG_EDP1;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     REG_BYPASS_DIVN:1;
+unsigned int     REG_OC_STEP_SET_EDP:10;
+unsigned int     REG_SEL_OC_MODE_EDP:2;
+unsigned int     REG_HS_OC_STOP_DIFF_EDP:2;
+unsigned int     REG_OC_DONE_DELAY_EDP:6;
+unsigned int     REG_PI_CUR_SEL_EDP:2;
+unsigned int     REG_BYPASS_PI_EDP:1;
+unsigned int     REG_SDM_ORDER_EDP:1;
+unsigned int     REG_EN_PI_DEBUG_EDP:1;
+unsigned int     reserved_1:2;
+}SYS_PLL_SSC_DIG_EDP2;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_SSC_EDP:8;
+unsigned int     FCODE_SSC_EDP:11;
+}SYS_PLL_SSC_DIG_EDP3;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     GRAN_EST_EDP:19;
+}SYS_PLL_SSC_DIG_EDP4;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     FCW_SSC_DEFAULT_EDP:19;
+}SYS_PLL_SSC_DIG_EDP5;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     LOOP_PI_ISEL_EDP:2;
+unsigned int     PHSEL_EDP:6;
+unsigned int     DIVN_EDP:8;
+}SYS_PLL_SSC_DIG_EDP_DBG1;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     load_FCW_EDP:1;
+unsigned int     OC_DONE_EDP:1;
+unsigned int     FMOD_EDP:1;
+unsigned int     NCODE_DEBUG_EDP:8;
+unsigned int     FCODE_DEBUG_EDP:11;
+}SYS_PLL_SSC_DIG_EDP_DBG2;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_CKSSC_INV_PIXEL:1;
+unsigned int     REG_GRAN_AUTO_RST_PIXEL:1;
+unsigned int     RSTB_PIXEL:1;
+unsigned int     EN_SSC_PIXEL:1;
+unsigned int     OC_EN_PIXEL:1;
+}SYS_PLL_SSC_DIG_PIXEL0;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_T_PIXEL:8;
+unsigned int     FCODE_T_PIXEL:11;
+}SYS_PLL_SSC_DIG_PIXEL1;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     REG_BYPASS_DIVN:1;
+unsigned int     REG_OC_STEP_SET_PIXEL:10;
+unsigned int     REG_SEL_OC_MODE_PIXEL:2;
+unsigned int     REG_HS_OC_STOP_DIFF_PIXEL:2;
+unsigned int     REG_OC_DONE_DELAY_PIXEL:6;
+unsigned int     REG_PI_CUR_SEL_PIXEL:2;
+unsigned int     REG_BYPASS_PI_PIXEL:1;
+unsigned int     REG_SDM_ORDER_PIXEL:1;
+unsigned int     REG_EN_PI_DEBUG_PIXEL:1;
+unsigned int     reserved_1:2;
+}SYS_PLL_SSC_DIG_PIXEL2;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     NCODE_SSC_PIXEL:8;
+unsigned int     FCODE_SSC_PIXEL:11;
+}SYS_PLL_SSC_DIG_PIXEL3;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     GRAN_EST_PIXEL:19;
+}SYS_PLL_SSC_DIG_PIXEL4;
+
+typedef struct
+{
+unsigned int     reserved_0:13;
+unsigned int     FCW_SSC_DEFAULT_PIXEL:19;
+}SYS_PLL_SSC_DIG_PIXEL5;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     LOOP_PI_ISEL_PIXEL:2;
+unsigned int     PHSEL_PIXEL:6;
+unsigned int     DIVN_PIXEL:8;
+}SYS_PLL_SSC_DIG_PIXEL_DBG1;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     load_FCW_PIXEL:1;
+unsigned int     OC_DONE_PIXEL:1;
+unsigned int     FMOD_PIXEL:1;
+unsigned int     NCODE_DEBUG_PIXEL:8;
+unsigned int     FCODE_DEBUG_PIXEL:11;
+}SYS_PLL_SSC_DIG_PIXEL_DBG2;
+
+typedef struct
+{
+unsigned int     reserved_0:12;
+unsigned int     REG_BYPASS_DIVN:1;
+unsigned int     FCW_SSC_DEFAULT_HDMITX:19;
+}SYS_PLL_HDMI_SD6;
+
+#endif
+
+#define SYS_SOFT_RESET1                                                              0x98000000
+#define SYS_SOFT_RESET1_reg_addr                                                     "0xD8000000"
+#define SYS_SOFT_RESET1_reg                                                          0xD8000000
+#define set_SYS_SOFT_RESET1_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET1_reg)=data)
+#define get_SYS_SOFT_RESET1_reg   (*((volatile unsigned int*) SYS_SOFT_RESET1_reg))
+#define SYS_SOFT_RESET1_inst_adr                                                     "0x0000"
+#define SYS_SOFT_RESET1_inst                                                         0x0000
+#define SYS_SOFT_RESET1_rstn_rsa_shift                                               (31)
+#define SYS_SOFT_RESET1_rstn_rsa_mask                                                (0x80000000)
+#define SYS_SOFT_RESET1_rstn_rsa(data)                                               (0x80000000&((data)<<31))
+#define SYS_SOFT_RESET1_rstn_rsa_src(data)                                           ((0x80000000&(data))>>31)
+#define SYS_SOFT_RESET1_get_rstn_rsa(data)                                           ((0x80000000&(data))>>31)
+#define SYS_SOFT_RESET1_rstn_mipi_shift                                              (30)
+#define SYS_SOFT_RESET1_rstn_mipi_mask                                               (0x40000000)
+#define SYS_SOFT_RESET1_rstn_mipi(data)                                              (0x40000000&((data)<<30))
+#define SYS_SOFT_RESET1_rstn_mipi_src(data)                                          ((0x40000000&(data))>>30)
+#define SYS_SOFT_RESET1_get_rstn_mipi(data)                                          ((0x40000000&(data))>>30)
+#define SYS_SOFT_RESET1_rstn_nf_shift                                                (29)
+#define SYS_SOFT_RESET1_rstn_nf_mask                                                 (0x20000000)
+#define SYS_SOFT_RESET1_rstn_nf(data)                                                (0x20000000&((data)<<29))
+#define SYS_SOFT_RESET1_rstn_nf_src(data)                                            ((0x20000000&(data))>>29)
+#define SYS_SOFT_RESET1_get_rstn_nf(data)                                            ((0x20000000&(data))>>29)
+#define SYS_SOFT_RESET1_rstn_ae_shift                                                (28)
+#define SYS_SOFT_RESET1_rstn_ae_mask                                                 (0x10000000)
+#define SYS_SOFT_RESET1_rstn_ae(data)                                                (0x10000000&((data)<<28))
+#define SYS_SOFT_RESET1_rstn_ae_src(data)                                            ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET1_get_rstn_ae(data)                                            ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET1_rstn_tp_shift                                                (27)
+#define SYS_SOFT_RESET1_rstn_tp_mask                                                 (0x08000000)
+#define SYS_SOFT_RESET1_rstn_tp(data)                                                (0x08000000&((data)<<27))
+#define SYS_SOFT_RESET1_rstn_tp_src(data)                                            ((0x08000000&(data))>>27)
+#define SYS_SOFT_RESET1_get_rstn_tp(data)                                            ((0x08000000&(data))>>27)
+#define SYS_SOFT_RESET1_rstn_md_shift                                                (26)
+#define SYS_SOFT_RESET1_rstn_md_mask                                                 (0x04000000)
+#define SYS_SOFT_RESET1_rstn_md(data)                                                (0x04000000&((data)<<26))
+#define SYS_SOFT_RESET1_rstn_md_src(data)                                            ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET1_get_rstn_md(data)                                            ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET1_rstn_cp_shift                                                (25)
+#define SYS_SOFT_RESET1_rstn_cp_mask                                                 (0x02000000)
+#define SYS_SOFT_RESET1_rstn_cp(data)                                                (0x02000000&((data)<<25))
+#define SYS_SOFT_RESET1_rstn_cp_src(data)                                            ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET1_get_rstn_cp(data)                                            ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET1_rstn_dc_phy_shift                                            (24)
+#define SYS_SOFT_RESET1_rstn_dc_phy_mask                                             (0x01000000)
+#define SYS_SOFT_RESET1_rstn_dc_phy(data)                                            (0x01000000&((data)<<24))
+#define SYS_SOFT_RESET1_rstn_dc_phy_src(data)                                        ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET1_get_rstn_dc_phy(data)                                        ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET1_rstn_dcu_shift                                               (23)
+#define SYS_SOFT_RESET1_rstn_dcu_mask                                                (0x00800000)
+#define SYS_SOFT_RESET1_rstn_dcu(data)                                               (0x00800000&((data)<<23))
+#define SYS_SOFT_RESET1_rstn_dcu_src(data)                                           ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET1_get_rstn_dcu(data)                                           ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET1_rstn_se_shift                                                (22)
+#define SYS_SOFT_RESET1_rstn_se_mask                                                 (0x00400000)
+#define SYS_SOFT_RESET1_rstn_se(data)                                                (0x00400000&((data)<<22))
+#define SYS_SOFT_RESET1_rstn_se_src(data)                                            ((0x00400000&(data))>>22)
+#define SYS_SOFT_RESET1_get_rstn_se(data)                                            ((0x00400000&(data))>>22)
+#define SYS_SOFT_RESET1_rstn_lvds_shift                                              (21)
+#define SYS_SOFT_RESET1_rstn_lvds_mask                                               (0x00200000)
+#define SYS_SOFT_RESET1_rstn_lvds(data)                                              (0x00200000&((data)<<21))
+#define SYS_SOFT_RESET1_rstn_lvds_src(data)                                          ((0x00200000&(data))>>21)
+#define SYS_SOFT_RESET1_get_rstn_lvds(data)                                          ((0x00200000&(data))>>21)
+#define SYS_SOFT_RESET1_rstn_vo_shift                                                (20)
+#define SYS_SOFT_RESET1_rstn_vo_mask                                                 (0x00100000)
+#define SYS_SOFT_RESET1_rstn_vo(data)                                                (0x00100000&((data)<<20))
+#define SYS_SOFT_RESET1_rstn_vo_src(data)                                            ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET1_get_rstn_vo(data)                                            ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET1_rstn_tve_shift                                               (19)
+#define SYS_SOFT_RESET1_rstn_tve_mask                                                (0x00080000)
+#define SYS_SOFT_RESET1_rstn_tve(data)                                               (0x00080000&((data)<<19))
+#define SYS_SOFT_RESET1_rstn_tve_src(data)                                           ((0x00080000&(data))>>19)
+#define SYS_SOFT_RESET1_get_rstn_tve(data)                                           ((0x00080000&(data))>>19)
+#define SYS_SOFT_RESET1_rstn_gpu_shift                                               (18)
+#define SYS_SOFT_RESET1_rstn_gpu_mask                                                (0x00040000)
+#define SYS_SOFT_RESET1_rstn_gpu(data)                                               (0x00040000&((data)<<18))
+#define SYS_SOFT_RESET1_rstn_gpu_src(data)                                           ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET1_get_rstn_gpu(data)                                           ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET1_rstn_aio_shift                                               (17)
+#define SYS_SOFT_RESET1_rstn_aio_mask                                                (0x00020000)
+#define SYS_SOFT_RESET1_rstn_aio(data)                                               (0x00020000&((data)<<17))
+#define SYS_SOFT_RESET1_rstn_aio_src(data)                                           ((0x00020000&(data))>>17)
+#define SYS_SOFT_RESET1_get_rstn_aio(data)                                           ((0x00020000&(data))>>17)
+#define SYS_SOFT_RESET1_rstn_etn_shift                                               (16)
+#define SYS_SOFT_RESET1_rstn_etn_mask                                                (0x00010000)
+#define SYS_SOFT_RESET1_rstn_etn(data)                                               (0x00010000&((data)<<16))
+#define SYS_SOFT_RESET1_rstn_etn_src(data)                                           ((0x00010000&(data))>>16)
+#define SYS_SOFT_RESET1_get_rstn_etn(data)                                           ((0x00010000&(data))>>16)
+#define SYS_SOFT_RESET1_rstn_ve3_shift                                               (15)
+#define SYS_SOFT_RESET1_rstn_ve3_mask                                                (0x00008000)
+#define SYS_SOFT_RESET1_rstn_ve3(data)                                               (0x00008000&((data)<<15))
+#define SYS_SOFT_RESET1_rstn_ve3_src(data)                                           ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET1_get_rstn_ve3(data)                                           ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET1_rstn_ve2_shift                                               (14)
+#define SYS_SOFT_RESET1_rstn_ve2_mask                                                (0x00004000)
+#define SYS_SOFT_RESET1_rstn_ve2(data)                                               (0x00004000&((data)<<14))
+#define SYS_SOFT_RESET1_rstn_ve2_src(data)                                           ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET1_get_rstn_ve2(data)                                           ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET1_rstn_ve1_shift                                               (13)
+#define SYS_SOFT_RESET1_rstn_ve1_mask                                                (0x00002000)
+#define SYS_SOFT_RESET1_rstn_ve1(data)                                               (0x00002000&((data)<<13))
+#define SYS_SOFT_RESET1_rstn_ve1_src(data)                                           ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET1_get_rstn_ve1(data)                                           ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET1_rstn_hdmi_shift                                              (12)
+#define SYS_SOFT_RESET1_rstn_hdmi_mask                                               (0x00001000)
+#define SYS_SOFT_RESET1_rstn_hdmi(data)                                              (0x00001000&((data)<<12))
+#define SYS_SOFT_RESET1_rstn_hdmi_src(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET1_get_rstn_hdmi(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET1_sata_func_exist_0_shift                                      (11)
+#define SYS_SOFT_RESET1_sata_func_exist_0_mask                                       (0x00000800)
+#define SYS_SOFT_RESET1_sata_func_exist_0(data)                                      (0x00000800&((data)<<11))
+#define SYS_SOFT_RESET1_sata_func_exist_0_src(data)                                  ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET1_get_sata_func_exist_0(data)                                  ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET1_rstn_sata_phy_pow_0_shift                                    (10)
+#define SYS_SOFT_RESET1_rstn_sata_phy_pow_0_mask                                     (0x00000400)
+#define SYS_SOFT_RESET1_rstn_sata_phy_pow_0(data)                                    (0x00000400&((data)<<10))
+#define SYS_SOFT_RESET1_rstn_sata_phy_pow_0_src(data)                                ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET1_get_rstn_sata_phy_pow_0(data)                                ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET1_rstn_usb_phy1_shift                                          (9)
+#define SYS_SOFT_RESET1_rstn_usb_phy1_mask                                           (0x00000200)
+#define SYS_SOFT_RESET1_rstn_usb_phy1(data)                                          (0x00000200&((data)<<9))
+#define SYS_SOFT_RESET1_rstn_usb_phy1_src(data)                                      ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET1_get_rstn_usb_phy1(data)                                      ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET1_rstn_usb_phy0_shift                                          (8)
+#define SYS_SOFT_RESET1_rstn_usb_phy0_mask                                           (0x00000100)
+#define SYS_SOFT_RESET1_rstn_usb_phy0(data)                                          (0x00000100&((data)<<8))
+#define SYS_SOFT_RESET1_rstn_usb_phy0_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET1_get_rstn_usb_phy0(data)                                      ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET1_rstn_sata_phy_0_shift                                        (7)
+#define SYS_SOFT_RESET1_rstn_sata_phy_0_mask                                         (0x00000080)
+#define SYS_SOFT_RESET1_rstn_sata_phy_0(data)                                        (0x00000080&((data)<<7))
+#define SYS_SOFT_RESET1_rstn_sata_phy_0_src(data)                                    ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET1_get_rstn_sata_phy_0(data)                                    ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET1_rstn_usb_shift                                               (6)
+#define SYS_SOFT_RESET1_rstn_usb_mask                                                (0x00000040)
+#define SYS_SOFT_RESET1_rstn_usb(data)                                               (0x00000040&((data)<<6))
+#define SYS_SOFT_RESET1_rstn_usb_src(data)                                           ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET1_get_rstn_usb(data)                                           ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET1_rstn_sata_0_shift                                            (5)
+#define SYS_SOFT_RESET1_rstn_sata_0_mask                                             (0x00000020)
+#define SYS_SOFT_RESET1_rstn_sata_0(data)                                            (0x00000020&((data)<<5))
+#define SYS_SOFT_RESET1_rstn_sata_0_src(data)                                        ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET1_get_rstn_sata_0(data)                                        ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio_shift                                      (4)
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio_mask                                       (0x00000010)
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio(data)                                      (0x00000010&((data)<<4))
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio_src(data)                                  ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET1_get_rstn_usb3_p0_mdio(data)                                  ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET1_rstn_gspi_shift                                              (3)
+#define SYS_SOFT_RESET1_rstn_gspi_mask                                               (0x00000008)
+#define SYS_SOFT_RESET1_rstn_gspi(data)                                              (0x00000008&((data)<<3))
+#define SYS_SOFT_RESET1_rstn_gspi_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET1_get_rstn_gspi(data)                                          ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET1_rstn_usb3_phy0_pow_shift                                     (2)
+#define SYS_SOFT_RESET1_rstn_usb3_phy0_pow_mask                                      (0x00000004)
+#define SYS_SOFT_RESET1_rstn_usb3_phy0_pow(data)                                     (0x00000004&((data)<<2))
+#define SYS_SOFT_RESET1_rstn_usb3_phy0_pow_src(data)                                 ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET1_get_rstn_usb3_phy0_pow(data)                                 ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET1_rstn_nat_shift                                               (1)
+#define SYS_SOFT_RESET1_rstn_nat_mask                                                (0x00000002)
+#define SYS_SOFT_RESET1_rstn_nat(data)                                               (0x00000002&((data)<<1))
+#define SYS_SOFT_RESET1_rstn_nat_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET1_get_rstn_nat(data)                                           ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET1_rstn_misc_shift                                              (0)
+#define SYS_SOFT_RESET1_rstn_misc_mask                                               (0x00000001)
+#define SYS_SOFT_RESET1_rstn_misc(data)                                              (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET1_rstn_misc_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET1_get_rstn_misc(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_SOFT_RESET2                                                              0x98000004
+#define SYS_SOFT_RESET2_reg_addr                                                     "0xD8000004"
+#define SYS_SOFT_RESET2_reg                                                          0xD8000004
+#define set_SYS_SOFT_RESET2_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET2_reg)=data)
+#define get_SYS_SOFT_RESET2_reg   (*((volatile unsigned int*) SYS_SOFT_RESET2_reg))
+#define SYS_SOFT_RESET2_inst_adr                                                     "0x0001"
+#define SYS_SOFT_RESET2_inst                                                         0x0001
+#define SYS_SOFT_RESET2_rstn_sds_phy_shift                                           (31)
+#define SYS_SOFT_RESET2_rstn_sds_phy_mask                                            (0x80000000)
+#define SYS_SOFT_RESET2_rstn_sds_phy(data)                                           (0x80000000&((data)<<31))
+#define SYS_SOFT_RESET2_rstn_sds_phy_src(data)                                       ((0x80000000&(data))>>31)
+#define SYS_SOFT_RESET2_get_rstn_sds_phy(data)                                       ((0x80000000&(data))>>31)
+#define SYS_SOFT_RESET2_rstn_cbus_tx_shift                                           (30)
+#define SYS_SOFT_RESET2_rstn_cbus_tx_mask                                            (0x40000000)
+#define SYS_SOFT_RESET2_rstn_cbus_tx(data)                                           (0x40000000&((data)<<30))
+#define SYS_SOFT_RESET2_rstn_cbus_tx_src(data)                                       ((0x40000000&(data))>>30)
+#define SYS_SOFT_RESET2_get_rstn_cbus_tx(data)                                       ((0x40000000&(data))>>30)
+#define SYS_SOFT_RESET2_rstn_misc_sc_shift                                           (29)
+#define SYS_SOFT_RESET2_rstn_misc_sc_mask                                            (0x20000000)
+#define SYS_SOFT_RESET2_rstn_misc_sc(data)                                           (0x20000000&((data)<<29))
+#define SYS_SOFT_RESET2_rstn_misc_sc_src(data)                                       ((0x20000000&(data))>>29)
+#define SYS_SOFT_RESET2_get_rstn_misc_sc(data)                                       ((0x20000000&(data))>>29)
+#define SYS_SOFT_RESET2_rstn_ur1_shift                                               (28)
+#define SYS_SOFT_RESET2_rstn_ur1_mask                                                (0x10000000)
+#define SYS_SOFT_RESET2_rstn_ur1(data)                                               (0x10000000&((data)<<28))
+#define SYS_SOFT_RESET2_rstn_ur1_src(data)                                           ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET2_get_rstn_ur1(data)                                           ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET2_rstn_ur2_shift                                               (27)
+#define SYS_SOFT_RESET2_rstn_ur2_mask                                                (0x08000000)
+#define SYS_SOFT_RESET2_rstn_ur2(data)                                               (0x08000000&((data)<<27))
+#define SYS_SOFT_RESET2_rstn_ur2_src(data)                                           ((0x08000000&(data))>>27)
+#define SYS_SOFT_RESET2_get_rstn_ur2(data)                                           ((0x08000000&(data))>>27)
+#define SYS_SOFT_RESET2_rstn_i2c_1_shift                                             (26)
+#define SYS_SOFT_RESET2_rstn_i2c_1_mask                                              (0x04000000)
+#define SYS_SOFT_RESET2_rstn_i2c_1(data)                                             (0x04000000&((data)<<26))
+#define SYS_SOFT_RESET2_rstn_i2c_1_src(data)                                         ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET2_get_rstn_i2c_1(data)                                         ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET2_rstn_i2c_2_shift                                             (25)
+#define SYS_SOFT_RESET2_rstn_i2c_2_mask                                              (0x02000000)
+#define SYS_SOFT_RESET2_rstn_i2c_2(data)                                             (0x02000000&((data)<<25))
+#define SYS_SOFT_RESET2_rstn_i2c_2_src(data)                                         ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET2_get_rstn_i2c_2(data)                                         ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET2_rstn_i2c_3_shift                                             (24)
+#define SYS_SOFT_RESET2_rstn_i2c_3_mask                                              (0x01000000)
+#define SYS_SOFT_RESET2_rstn_i2c_3(data)                                             (0x01000000&((data)<<24))
+#define SYS_SOFT_RESET2_rstn_i2c_3_src(data)                                         ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET2_get_rstn_i2c_3(data)                                         ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET2_rstn_i2c_4_shift                                             (23)
+#define SYS_SOFT_RESET2_rstn_i2c_4_mask                                              (0x00800000)
+#define SYS_SOFT_RESET2_rstn_i2c_4(data)                                             (0x00800000&((data)<<23))
+#define SYS_SOFT_RESET2_rstn_i2c_4_src(data)                                         ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET2_get_rstn_i2c_4(data)                                         ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET2_rstn_pcie1_nonstich_shift                                    (22)
+#define SYS_SOFT_RESET2_rstn_pcie1_nonstich_mask                                     (0x00400000)
+#define SYS_SOFT_RESET2_rstn_pcie1_nonstich(data)                                    (0x00400000&((data)<<22))
+#define SYS_SOFT_RESET2_rstn_pcie1_nonstich_src(data)                                ((0x00400000&(data))>>22)
+#define SYS_SOFT_RESET2_get_rstn_pcie1_nonstich(data)                                ((0x00400000&(data))>>22)
+#define SYS_SOFT_RESET2_rstn_pcie1_power_shift                                       (21)
+#define SYS_SOFT_RESET2_rstn_pcie1_power_mask                                        (0x00200000)
+#define SYS_SOFT_RESET2_rstn_pcie1_power(data)                                       (0x00200000&((data)<<21))
+#define SYS_SOFT_RESET2_rstn_pcie1_power_src(data)                                   ((0x00200000&(data))>>21)
+#define SYS_SOFT_RESET2_get_rstn_pcie1_power(data)                                   ((0x00200000&(data))>>21)
+#define SYS_SOFT_RESET2_rstn_pcie1_core_shift                                        (20)
+#define SYS_SOFT_RESET2_rstn_pcie1_core_mask                                         (0x00100000)
+#define SYS_SOFT_RESET2_rstn_pcie1_core(data)                                        (0x00100000&((data)<<20))
+#define SYS_SOFT_RESET2_rstn_pcie1_core_src(data)                                    ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET2_get_rstn_pcie1_core(data)                                    ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET2_rstn_pcie1_stitch_shift                                      (19)
+#define SYS_SOFT_RESET2_rstn_pcie1_stitch_mask                                       (0x00080000)
+#define SYS_SOFT_RESET2_rstn_pcie1_stitch(data)                                      (0x00080000&((data)<<19))
+#define SYS_SOFT_RESET2_rstn_pcie1_stitch_src(data)                                  ((0x00080000&(data))>>19)
+#define SYS_SOFT_RESET2_get_rstn_pcie1_stitch(data)                                  ((0x00080000&(data))>>19)
+#define SYS_SOFT_RESET2_rstn_i2c_5_shift                                             (18)
+#define SYS_SOFT_RESET2_rstn_i2c_5_mask                                              (0x00040000)
+#define SYS_SOFT_RESET2_rstn_i2c_5(data)                                             (0x00040000&((data)<<18))
+#define SYS_SOFT_RESET2_rstn_i2c_5_src(data)                                         ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET2_get_rstn_i2c_5(data)                                         ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET2_rstn_pcie1_shift                                             (17)
+#define SYS_SOFT_RESET2_rstn_pcie1_mask                                              (0x00020000)
+#define SYS_SOFT_RESET2_rstn_pcie1(data)                                             (0x00020000&((data)<<17))
+#define SYS_SOFT_RESET2_rstn_pcie1_src(data)                                         ((0x00020000&(data))>>17)
+#define SYS_SOFT_RESET2_get_rstn_pcie1(data)                                         ((0x00020000&(data))>>17)
+#define SYS_SOFT_RESET2_rstn_pcie1_phy_shift                                         (16)
+#define SYS_SOFT_RESET2_rstn_pcie1_phy_mask                                          (0x00010000)
+#define SYS_SOFT_RESET2_rstn_pcie1_phy(data)                                         (0x00010000&((data)<<16))
+#define SYS_SOFT_RESET2_rstn_pcie1_phy_src(data)                                     ((0x00010000&(data))>>16)
+#define SYS_SOFT_RESET2_get_rstn_pcie1_phy(data)                                     ((0x00010000&(data))>>16)
+#define SYS_SOFT_RESET2_rstn_pcie0_nonstich_shift                                    (15)
+#define SYS_SOFT_RESET2_rstn_pcie0_nonstich_mask                                     (0x00008000)
+#define SYS_SOFT_RESET2_rstn_pcie0_nonstich(data)                                    (0x00008000&((data)<<15))
+#define SYS_SOFT_RESET2_rstn_pcie0_nonstich_src(data)                                ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET2_get_rstn_pcie0_nonstich(data)                                ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET2_rstn_pcie0_power_shift                                       (14)
+#define SYS_SOFT_RESET2_rstn_pcie0_power_mask                                        (0x00004000)
+#define SYS_SOFT_RESET2_rstn_pcie0_power(data)                                       (0x00004000&((data)<<14))
+#define SYS_SOFT_RESET2_rstn_pcie0_power_src(data)                                   ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET2_get_rstn_pcie0_power(data)                                   ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET2_rstn_pcie0_core_shift                                        (13)
+#define SYS_SOFT_RESET2_rstn_pcie0_core_mask                                         (0x00002000)
+#define SYS_SOFT_RESET2_rstn_pcie0_core(data)                                        (0x00002000&((data)<<13))
+#define SYS_SOFT_RESET2_rstn_pcie0_core_src(data)                                    ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET2_get_rstn_pcie0_core(data)                                    ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET2_rstn_sdio_shift                                              (12)
+#define SYS_SOFT_RESET2_rstn_sdio_mask                                               (0x00001000)
+#define SYS_SOFT_RESET2_rstn_sdio(data)                                              (0x00001000&((data)<<12))
+#define SYS_SOFT_RESET2_rstn_sdio_src(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET2_get_rstn_sdio(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET2_rstn_emmc_shift                                              (11)
+#define SYS_SOFT_RESET2_rstn_emmc_mask                                               (0x00000800)
+#define SYS_SOFT_RESET2_rstn_emmc(data)                                              (0x00000800&((data)<<11))
+#define SYS_SOFT_RESET2_rstn_emmc_src(data)                                          ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET2_get_rstn_emmc(data)                                          ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET2_rstn_cr_shift                                                (10)
+#define SYS_SOFT_RESET2_rstn_cr_mask                                                 (0x00000400)
+#define SYS_SOFT_RESET2_rstn_cr(data)                                                (0x00000400&((data)<<10))
+#define SYS_SOFT_RESET2_rstn_cr_src(data)                                            ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET2_get_rstn_cr(data)                                            ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET2_rstn_pcr_cnt_shift                                           (9)
+#define SYS_SOFT_RESET2_rstn_pcr_cnt_mask                                            (0x00000200)
+#define SYS_SOFT_RESET2_rstn_pcr_cnt(data)                                           (0x00000200&((data)<<9))
+#define SYS_SOFT_RESET2_rstn_pcr_cnt_src(data)                                       ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET2_get_rstn_pcr_cnt(data)                                       ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET2_rstn_pcie0_shift                                             (8)
+#define SYS_SOFT_RESET2_rstn_pcie0_mask                                              (0x00000100)
+#define SYS_SOFT_RESET2_rstn_pcie0(data)                                             (0x00000100&((data)<<8))
+#define SYS_SOFT_RESET2_rstn_pcie0_src(data)                                         ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET2_get_rstn_pcie0(data)                                         ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET2_rstn_pcie0_phy_shift                                         (7)
+#define SYS_SOFT_RESET2_rstn_pcie0_phy_mask                                          (0x00000080)
+#define SYS_SOFT_RESET2_rstn_pcie0_phy(data)                                         (0x00000080&((data)<<7))
+#define SYS_SOFT_RESET2_rstn_pcie0_phy_src(data)                                     ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET2_get_rstn_pcie0_phy(data)                                     ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET2_rstn_pcie0_stitch_shift                                      (6)
+#define SYS_SOFT_RESET2_rstn_pcie0_stitch_mask                                       (0x00000040)
+#define SYS_SOFT_RESET2_rstn_pcie0_stitch(data)                                      (0x00000040&((data)<<6))
+#define SYS_SOFT_RESET2_rstn_pcie0_stitch_src(data)                                  ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET2_get_rstn_pcie0_stitch(data)                                  ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET2_rstn_usb3_p1_mdio_shift                                      (5)
+#define SYS_SOFT_RESET2_rstn_usb3_p1_mdio_mask                                       (0x00000020)
+#define SYS_SOFT_RESET2_rstn_usb3_p1_mdio(data)                                      (0x00000020&((data)<<5))
+#define SYS_SOFT_RESET2_rstn_usb3_p1_mdio_src(data)                                  ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET2_get_rstn_usb3_p1_mdio(data)                                  ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET2_rstn_usb3_phy1_pow_shift                                     (4)
+#define SYS_SOFT_RESET2_rstn_usb3_phy1_pow_mask                                      (0x00000010)
+#define SYS_SOFT_RESET2_rstn_usb3_phy1_pow(data)                                     (0x00000010&((data)<<4))
+#define SYS_SOFT_RESET2_rstn_usb3_phy1_pow_src(data)                                 ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET2_get_rstn_usb3_phy1_pow(data)                                 ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET2_rstn_usb_phy2_shift                                          (3)
+#define SYS_SOFT_RESET2_rstn_usb_phy2_mask                                           (0x00000008)
+#define SYS_SOFT_RESET2_rstn_usb_phy2(data)                                          (0x00000008&((data)<<3))
+#define SYS_SOFT_RESET2_rstn_usb_phy2_src(data)                                      ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET2_get_rstn_usb_phy2(data)                                      ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET2_rstn_usb_phy3_shift                                          (2)
+#define SYS_SOFT_RESET2_rstn_usb_phy3_mask                                           (0x00000004)
+#define SYS_SOFT_RESET2_rstn_usb_phy3(data)                                          (0x00000004&((data)<<2))
+#define SYS_SOFT_RESET2_rstn_usb_phy3_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET2_get_rstn_usb_phy3(data)                                      ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET2_rstn_jpeg_shift                                              (1)
+#define SYS_SOFT_RESET2_rstn_jpeg_mask                                               (0x00000002)
+#define SYS_SOFT_RESET2_rstn_jpeg(data)                                              (0x00000002&((data)<<1))
+#define SYS_SOFT_RESET2_rstn_jpeg_src(data)                                          ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET2_get_rstn_jpeg(data)                                          ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET2_rstn_acpu_shift                                              (0)
+#define SYS_SOFT_RESET2_rstn_acpu_mask                                               (0x00000001)
+#define SYS_SOFT_RESET2_rstn_acpu(data)                                              (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET2_rstn_acpu_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET2_get_rstn_acpu(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_SOFT_RESET3                                                              0x98000008
+#define SYS_SOFT_RESET3_reg_addr                                                     "0xD8000008"
+#define SYS_SOFT_RESET3_reg                                                          0xD8000008
+#define set_SYS_SOFT_RESET3_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET3_reg)=data)
+#define get_SYS_SOFT_RESET3_reg   (*((volatile unsigned int*) SYS_SOFT_RESET3_reg))
+#define SYS_SOFT_RESET3_inst_adr                                                     "0x0002"
+#define SYS_SOFT_RESET3_inst                                                         0x0002
+#define SYS_SOFT_RESET3_rstn_sb2_shift                                               (0)
+#define SYS_SOFT_RESET3_rstn_sb2_mask                                                (0x00000001)
+#define SYS_SOFT_RESET3_rstn_sb2(data)                                               (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET3_rstn_sb2_src(data)                                           ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET3_get_rstn_sb2(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SYS_CLOCK_ENABLE1                                                            0x9800000C
+#define SYS_CLOCK_ENABLE1_reg_addr                                                   "0xD800000C"
+#define SYS_CLOCK_ENABLE1_reg                                                        0xD800000C
+#define set_SYS_CLOCK_ENABLE1_reg(data)   (*((volatile unsigned int*) SYS_CLOCK_ENABLE1_reg)=data)
+#define get_SYS_CLOCK_ENABLE1_reg   (*((volatile unsigned int*) SYS_CLOCK_ENABLE1_reg))
+#define SYS_CLOCK_ENABLE1_inst_adr                                                   "0x0003"
+#define SYS_CLOCK_ENABLE1_inst                                                       0x0003
+#define SYS_CLOCK_ENABLE1_clk_en_sd_ip_shift                                         (31)
+#define SYS_CLOCK_ENABLE1_clk_en_sd_ip_mask                                          (0x80000000)
+#define SYS_CLOCK_ENABLE1_clk_en_sd_ip(data)                                         (0x80000000&((data)<<31))
+#define SYS_CLOCK_ENABLE1_clk_en_sd_ip_src(data)                                     ((0x80000000&(data))>>31)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sd_ip(data)                                     ((0x80000000&(data))>>31)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_shift                                          (30)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_mask                                           (0x40000000)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio(data)                                          (0x40000000&((data)<<30))
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_src(data)                                      ((0x40000000&(data))>>30)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sdio(data)                                      ((0x40000000&(data))>>30)
+#define SYS_CLOCK_ENABLE1_clk_en_ve3_shift                                           (29)
+#define SYS_CLOCK_ENABLE1_clk_en_ve3_mask                                            (0x20000000)
+#define SYS_CLOCK_ENABLE1_clk_en_ve3(data)                                           (0x20000000&((data)<<29))
+#define SYS_CLOCK_ENABLE1_clk_en_ve3_src(data)                                       ((0x20000000&(data))>>29)
+#define SYS_CLOCK_ENABLE1_get_clk_en_ve3(data)                                       ((0x20000000&(data))>>29)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_ip_shift                                       (28)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_ip_mask                                        (0x10000000)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_ip(data)                                       (0x10000000&((data)<<28))
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_ip_src(data)                                   ((0x10000000&(data))>>28)
+#define SYS_CLOCK_ENABLE1_get_clk_en_emmc_ip(data)                                   ((0x10000000&(data))>>28)
+#define SYS_CLOCK_ENABLE1_clk_en_mipi_shift                                          (27)
+#define SYS_CLOCK_ENABLE1_clk_en_mipi_mask                                           (0x08000000)
+#define SYS_CLOCK_ENABLE1_clk_en_mipi(data)                                          (0x08000000&((data)<<27))
+#define SYS_CLOCK_ENABLE1_clk_en_mipi_src(data)                                      ((0x08000000&(data))>>27)
+#define SYS_CLOCK_ENABLE1_get_clk_en_mipi(data)                                      ((0x08000000&(data))>>27)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_ip_shift                                       (26)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_ip_mask                                        (0x04000000)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_ip(data)                                       (0x04000000&((data)<<26))
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_ip_src(data)                                   ((0x04000000&(data))>>26)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sdio_ip(data)                                   ((0x04000000&(data))>>26)
+#define SYS_CLOCK_ENABLE1_clk_en_cr_shift                                            (25)
+#define SYS_CLOCK_ENABLE1_clk_en_cr_mask                                             (0x02000000)
+#define SYS_CLOCK_ENABLE1_clk_en_cr(data)                                            (0x02000000&((data)<<25))
+#define SYS_CLOCK_ENABLE1_clk_en_cr_src(data)                                        ((0x02000000&(data))>>25)
+#define SYS_CLOCK_ENABLE1_get_clk_en_cr(data)                                        ((0x02000000&(data))>>25)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_shift                                          (24)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_mask                                           (0x01000000)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc(data)                                          (0x01000000&((data)<<24))
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_src(data)                                      ((0x01000000&(data))>>24)
+#define SYS_CLOCK_ENABLE1_get_clk_en_emmc(data)                                      ((0x01000000&(data))>>24)
+#define SYS_CLOCK_ENABLE1_clk_en_nf_shift                                            (23)
+#define SYS_CLOCK_ENABLE1_clk_en_nf_mask                                             (0x00800000)
+#define SYS_CLOCK_ENABLE1_clk_en_nf(data)                                            (0x00800000&((data)<<23))
+#define SYS_CLOCK_ENABLE1_clk_en_nf_src(data)                                        ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE1_get_clk_en_nf(data)                                        ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE1_clk_en_rsa_shift                                           (22)
+#define SYS_CLOCK_ENABLE1_clk_en_rsa_mask                                            (0x00400000)
+#define SYS_CLOCK_ENABLE1_clk_en_rsa(data)                                           (0x00400000&((data)<<22))
+#define SYS_CLOCK_ENABLE1_clk_en_rsa_src(data)                                       ((0x00400000&(data))>>22)
+#define SYS_CLOCK_ENABLE1_get_clk_en_rsa(data)                                       ((0x00400000&(data))>>22)
+#define SYS_CLOCK_ENABLE1_clk_en_tp_shift                                            (21)
+#define SYS_CLOCK_ENABLE1_clk_en_tp_mask                                             (0x00200000)
+#define SYS_CLOCK_ENABLE1_clk_en_tp(data)                                            (0x00200000&((data)<<21))
+#define SYS_CLOCK_ENABLE1_clk_en_tp_src(data)                                        ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE1_get_clk_en_tp(data)                                        ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE1_clk_en_md_shift                                            (20)
+#define SYS_CLOCK_ENABLE1_clk_en_md_mask                                             (0x00100000)
+#define SYS_CLOCK_ENABLE1_clk_en_md(data)                                            (0x00100000&((data)<<20))
+#define SYS_CLOCK_ENABLE1_clk_en_md_src(data)                                        ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE1_get_clk_en_md(data)                                        ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE1_clk_en_cp_shift                                            (19)
+#define SYS_CLOCK_ENABLE1_clk_en_cp_mask                                             (0x00080000)
+#define SYS_CLOCK_ENABLE1_clk_en_cp(data)                                            (0x00080000&((data)<<19))
+#define SYS_CLOCK_ENABLE1_clk_en_cp_src(data)                                        ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE1_get_clk_en_cp(data)                                        ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE1_clk_en_dcu_shift                                           (18)
+#define SYS_CLOCK_ENABLE1_clk_en_dcu_mask                                            (0x00040000)
+#define SYS_CLOCK_ENABLE1_clk_en_dcu(data)                                           (0x00040000&((data)<<18))
+#define SYS_CLOCK_ENABLE1_clk_en_dcu_src(data)                                       ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE1_get_clk_en_dcu(data)                                       ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE1_clk_en_se_shift                                            (17)
+#define SYS_CLOCK_ENABLE1_clk_en_se_mask                                             (0x00020000)
+#define SYS_CLOCK_ENABLE1_clk_en_se(data)                                            (0x00020000&((data)<<17))
+#define SYS_CLOCK_ENABLE1_clk_en_se_src(data)                                        ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE1_get_clk_en_se(data)                                        ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE1_clk_en_lvds_shift                                          (16)
+#define SYS_CLOCK_ENABLE1_clk_en_lvds_mask                                           (0x00010000)
+#define SYS_CLOCK_ENABLE1_clk_en_lvds(data)                                          (0x00010000&((data)<<16))
+#define SYS_CLOCK_ENABLE1_clk_en_lvds_src(data)                                      ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE1_get_clk_en_lvds(data)                                      ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE1_clk_en_vo_shift                                            (15)
+#define SYS_CLOCK_ENABLE1_clk_en_vo_mask                                             (0x00008000)
+#define SYS_CLOCK_ENABLE1_clk_en_vo(data)                                            (0x00008000&((data)<<15))
+#define SYS_CLOCK_ENABLE1_clk_en_vo_src(data)                                        ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE1_get_clk_en_vo(data)                                        ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE1_clk_en_tve_shift                                           (14)
+#define SYS_CLOCK_ENABLE1_clk_en_tve_mask                                            (0x00004000)
+#define SYS_CLOCK_ENABLE1_clk_en_tve(data)                                           (0x00004000&((data)<<14))
+#define SYS_CLOCK_ENABLE1_clk_en_tve_src(data)                                       ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE1_get_clk_en_tve(data)                                       ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE1_clk_en_ve2_shift                                           (13)
+#define SYS_CLOCK_ENABLE1_clk_en_ve2_mask                                            (0x00002000)
+#define SYS_CLOCK_ENABLE1_clk_en_ve2(data)                                           (0x00002000&((data)<<13))
+#define SYS_CLOCK_ENABLE1_clk_en_ve2_src(data)                                       ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE1_get_clk_en_ve2(data)                                       ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE1_clk_en_ve1_shift                                           (12)
+#define SYS_CLOCK_ENABLE1_clk_en_ve1_mask                                            (0x00001000)
+#define SYS_CLOCK_ENABLE1_clk_en_ve1(data)                                           (0x00001000&((data)<<12))
+#define SYS_CLOCK_ENABLE1_clk_en_ve1_src(data)                                       ((0x00001000&(data))>>12)
+#define SYS_CLOCK_ENABLE1_get_clk_en_ve1(data)                                       ((0x00001000&(data))>>12)
+#define SYS_CLOCK_ENABLE1_clk_en_gpu_shift                                           (11)
+#define SYS_CLOCK_ENABLE1_clk_en_gpu_mask                                            (0x00000800)
+#define SYS_CLOCK_ENABLE1_clk_en_gpu(data)                                           (0x00000800&((data)<<11))
+#define SYS_CLOCK_ENABLE1_clk_en_gpu_src(data)                                       ((0x00000800&(data))>>11)
+#define SYS_CLOCK_ENABLE1_get_clk_en_gpu(data)                                       ((0x00000800&(data))>>11)
+#define SYS_CLOCK_ENABLE1_clk_en_aio_shift                                           (10)
+#define SYS_CLOCK_ENABLE1_clk_en_aio_mask                                            (0x00000400)
+#define SYS_CLOCK_ENABLE1_clk_en_aio(data)                                           (0x00000400&((data)<<10))
+#define SYS_CLOCK_ENABLE1_clk_en_aio_src(data)                                       ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE1_get_clk_en_aio(data)                                       ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE1_clk_en_etn_shift                                           (9)
+#define SYS_CLOCK_ENABLE1_clk_en_etn_mask                                            (0x00000200)
+#define SYS_CLOCK_ENABLE1_clk_en_etn(data)                                           (0x00000200&((data)<<9))
+#define SYS_CLOCK_ENABLE1_clk_en_etn_src(data)                                       ((0x00000200&(data))>>9)
+#define SYS_CLOCK_ENABLE1_get_clk_en_etn(data)                                       ((0x00000200&(data))>>9)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi_shift                                          (8)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi_mask                                           (0x00000100)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi(data)                                          (0x00000100&((data)<<8))
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_CLOCK_ENABLE1_get_clk_en_hdmi(data)                                      ((0x00000100&(data))>>8)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_alive_0_shift                                  (7)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_alive_0_mask                                   (0x00000080)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_alive_0(data)                                  (0x00000080&((data)<<7))
+#define SYS_CLOCK_ENABLE1_clk_en_sata_alive_0_src(data)                              ((0x00000080&(data))>>7)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sata_alive_0(data)                              ((0x00000080&(data))>>7)
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc_shift                                      (6)
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc_mask                                       (0x00000040)
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc(data)                                      (0x00000040&((data)<<6))
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc_src(data)                                  ((0x00000040&(data))>>6)
+#define SYS_CLOCK_ENABLE1_get_clk_en_iso_misc(data)                                  ((0x00000040&(data))>>6)
+#define SYS_CLOCK_ENABLE1_clk_en_pcr_shift                                           (5)
+#define SYS_CLOCK_ENABLE1_clk_en_pcr_mask                                            (0x00000020)
+#define SYS_CLOCK_ENABLE1_clk_en_pcr(data)                                           (0x00000020&((data)<<5))
+#define SYS_CLOCK_ENABLE1_clk_en_pcr_src(data)                                       ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE1_get_clk_en_pcr(data)                                       ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE1_clk_en_usb_shift                                           (4)
+#define SYS_CLOCK_ENABLE1_clk_en_usb_mask                                            (0x00000010)
+#define SYS_CLOCK_ENABLE1_clk_en_usb(data)                                           (0x00000010&((data)<<4))
+#define SYS_CLOCK_ENABLE1_clk_en_usb_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE1_get_clk_en_usb(data)                                       ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE1_clk_en_gspi_shift                                          (3)
+#define SYS_CLOCK_ENABLE1_clk_en_gspi_mask                                           (0x00000008)
+#define SYS_CLOCK_ENABLE1_clk_en_gspi(data)                                          (0x00000008&((data)<<3))
+#define SYS_CLOCK_ENABLE1_clk_en_gspi_src(data)                                      ((0x00000008&(data))>>3)
+#define SYS_CLOCK_ENABLE1_get_clk_en_gspi(data)                                      ((0x00000008&(data))>>3)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_0_shift                                        (2)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_0_mask                                         (0x00000004)
+#define SYS_CLOCK_ENABLE1_clk_en_sata_0(data)                                        (0x00000004&((data)<<2))
+#define SYS_CLOCK_ENABLE1_clk_en_sata_0_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sata_0(data)                                    ((0x00000004&(data))>>2)
+#define SYS_CLOCK_ENABLE1_clk_en_pcie0_shift                                         (1)
+#define SYS_CLOCK_ENABLE1_clk_en_pcie0_mask                                          (0x00000002)
+#define SYS_CLOCK_ENABLE1_clk_en_pcie0(data)                                         (0x00000002&((data)<<1))
+#define SYS_CLOCK_ENABLE1_clk_en_pcie0_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE1_get_clk_en_pcie0(data)                                     ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE1_clk_en_misc_shift                                          (0)
+#define SYS_CLOCK_ENABLE1_clk_en_misc_mask                                           (0x00000001)
+#define SYS_CLOCK_ENABLE1_clk_en_misc(data)                                          (0x00000001&((data)<<0))
+#define SYS_CLOCK_ENABLE1_clk_en_misc_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_CLOCK_ENABLE1_get_clk_en_misc(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_CLOCK_ENABLE2                                                            0x98000010
+#define SYS_CLOCK_ENABLE2_reg_addr                                                   "0xD8000010"
+#define SYS_CLOCK_ENABLE2_reg                                                        0xD8000010
+#define set_SYS_CLOCK_ENABLE2_reg(data)   (*((volatile unsigned int*) SYS_CLOCK_ENABLE2_reg)=data)
+#define get_SYS_CLOCK_ENABLE2_reg   (*((volatile unsigned int*) SYS_CLOCK_ENABLE2_reg))
+#define SYS_CLOCK_ENABLE2_inst_adr                                                   "0x0004"
+#define SYS_CLOCK_ENABLE2_inst                                                       0x0004
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_1_shift                                       (31)
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_1_mask                                        (0x80000000)
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_1(data)                                       (0x80000000&((data)<<31))
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_1_src(data)                                   ((0x80000000&(data))>>31)
+#define SYS_CLOCK_ENABLE2_get_clk_en_dcphy_1(data)                                   ((0x80000000&(data))>>31)
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_0_shift                                       (30)
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_0_mask                                        (0x40000000)
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_0(data)                                       (0x40000000&((data)<<30))
+#define SYS_CLOCK_ENABLE2_clk_en_dcphy_0_src(data)                                   ((0x40000000&(data))>>30)
+#define SYS_CLOCK_ENABLE2_get_clk_en_dcphy_0(data)                                   ((0x40000000&(data))>>30)
+#define SYS_CLOCK_ENABLE2_clk_en_fan_shift                                           (29)
+#define SYS_CLOCK_ENABLE2_clk_en_fan_mask                                            (0x20000000)
+#define SYS_CLOCK_ENABLE2_clk_en_fan(data)                                           (0x20000000&((data)<<29))
+#define SYS_CLOCK_ENABLE2_clk_en_fan_src(data)                                       ((0x20000000&(data))>>29)
+#define SYS_CLOCK_ENABLE2_get_clk_en_fan(data)                                       ((0x20000000&(data))>>29)
+#define SYS_CLOCK_ENABLE2_clk_en_ur1_shift                                           (28)
+#define SYS_CLOCK_ENABLE2_clk_en_ur1_mask                                            (0x10000000)
+#define SYS_CLOCK_ENABLE2_clk_en_ur1(data)                                           (0x10000000&((data)<<28))
+#define SYS_CLOCK_ENABLE2_clk_en_ur1_src(data)                                       ((0x10000000&(data))>>28)
+#define SYS_CLOCK_ENABLE2_get_clk_en_ur1(data)                                       ((0x10000000&(data))>>28)
+#define SYS_CLOCK_ENABLE2_clk_en_ur2_shift                                           (27)
+#define SYS_CLOCK_ENABLE2_clk_en_ur2_mask                                            (0x08000000)
+#define SYS_CLOCK_ENABLE2_clk_en_ur2(data)                                           (0x08000000&((data)<<27))
+#define SYS_CLOCK_ENABLE2_clk_en_ur2_src(data)                                       ((0x08000000&(data))>>27)
+#define SYS_CLOCK_ENABLE2_get_clk_en_ur2(data)                                       ((0x08000000&(data))>>27)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_alive_1_shift                                  (26)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_alive_1_mask                                   (0x04000000)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_alive_1(data)                                  (0x04000000&((data)<<26))
+#define SYS_CLOCK_ENABLE2_clk_en_sata_alive_1_src(data)                              ((0x04000000&(data))>>26)
+#define SYS_CLOCK_ENABLE2_get_clk_en_sata_alive_1(data)                              ((0x04000000&(data))>>26)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_1_shift                                        (25)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_1_mask                                         (0x02000000)
+#define SYS_CLOCK_ENABLE2_clk_en_sata_1(data)                                        (0x02000000&((data)<<25))
+#define SYS_CLOCK_ENABLE2_clk_en_sata_1_src(data)                                    ((0x02000000&(data))>>25)
+#define SYS_CLOCK_ENABLE2_get_clk_en_sata_1(data)                                    ((0x02000000&(data))>>25)
+#define SYS_CLOCK_ENABLE2_clk_en_hdmirx_shift                                        (24)
+#define SYS_CLOCK_ENABLE2_clk_en_hdmirx_mask                                         (0x01000000)
+#define SYS_CLOCK_ENABLE2_clk_en_hdmirx(data)                                        (0x01000000&((data)<<24))
+#define SYS_CLOCK_ENABLE2_clk_en_hdmirx_src(data)                                    ((0x01000000&(data))>>24)
+#define SYS_CLOCK_ENABLE2_get_clk_en_hdmirx(data)                                    ((0x01000000&(data))>>24)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk_shift                                      (23)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk_mask                                       (0x00800000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk(data)                                      (0x00800000&((data)<<23))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk_src(data)                                  ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_mclk(data)                                  ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s_shift                                       (22)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s_mask                                        (0x00400000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s(data)                                       (0x00400000&((data)<<22))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s_src(data)                                   ((0x00400000&(data))>>22)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_i2s(data)                                   ((0x00400000&(data))>>22)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif_shift                                     (21)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif_mask                                      (0x00200000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif(data)                                     (0x00200000&((data)<<21))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif_src(data)                                 ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_spdif(data)                                 ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi_shift                                      (20)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi_mask                                       (0x00100000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi(data)                                      (0x00100000&((data)<<20))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi_src(data)                                  ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_hdmi(data)                                  ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da_shift                                        (19)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da_mask                                         (0x00080000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da(data)                                        (0x00080000&((data)<<19))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da_src(data)                                    ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_da(data)                                    ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod_shift                                       (18)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod_mask                                        (0x00040000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod(data)                                       (0x00040000&((data)<<18))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod_src(data)                                   ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_mod(data)                                   ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec_shift                                  (17)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec_mask                                   (0x00020000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec(data)                                  (0x00020000&((data)<<17))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec_src(data)                              ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_au_codec(data)                              ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1_shift                                    (16)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1_mask                                     (0x00010000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1(data)                                    (0x00010000&((data)<<16))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1_src(data)                                ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_1(data)                                ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2_shift                                    (15)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2_mask                                     (0x00008000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2(data)                                    (0x00008000&((data)<<15))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2_src(data)                                ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_2(data)                                ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3_shift                                    (14)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3_mask                                     (0x00004000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3(data)                                    (0x00004000&((data)<<14))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3_src(data)                                ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_3(data)                                ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4_shift                                    (13)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4_mask                                     (0x00002000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4(data)                                    (0x00002000&((data)<<13))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4_src(data)                                ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_4(data)                                ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc_shift                                      (10)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc_mask                                       (0x00000400)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc(data)                                      (0x00000400&((data)<<10))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc_src(data)                                  ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_rtc(data)                                  ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE2_clk_en_cbus_tx_shift                                       (7)
+#define SYS_CLOCK_ENABLE2_clk_en_cbus_tx_mask                                        (0x00000080)
+#define SYS_CLOCK_ENABLE2_clk_en_cbus_tx(data)                                       (0x00000080&((data)<<7))
+#define SYS_CLOCK_ENABLE2_clk_en_cbus_tx_src(data)                                   ((0x00000080&(data))>>7)
+#define SYS_CLOCK_ENABLE2_get_clk_en_cbus_tx(data)                                   ((0x00000080&(data))>>7)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_sc_shift                                       (6)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_sc_mask                                        (0x00000040)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_sc(data)                                       (0x00000040&((data)<<6))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_sc_src(data)                                   ((0x00000040&(data))>>6)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_sc(data)                                   ((0x00000040&(data))>>6)
+#define SYS_CLOCK_ENABLE2_clk_en_pcie1_shift                                         (5)
+#define SYS_CLOCK_ENABLE2_clk_en_pcie1_mask                                          (0x00000020)
+#define SYS_CLOCK_ENABLE2_clk_en_pcie1(data)                                         (0x00000020&((data)<<5))
+#define SYS_CLOCK_ENABLE2_clk_en_pcie1_src(data)                                     ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE2_get_clk_en_pcie1(data)                                     ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE2_clk_en_acpu_shift                                          (4)
+#define SYS_CLOCK_ENABLE2_clk_en_acpu_mask                                           (0x00000010)
+#define SYS_CLOCK_ENABLE2_clk_en_acpu(data)                                          (0x00000010&((data)<<4))
+#define SYS_CLOCK_ENABLE2_clk_en_acpu_src(data)                                      ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE2_get_clk_en_acpu(data)                                      ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE2_clk_en_jpeg_shift                                          (3)
+#define SYS_CLOCK_ENABLE2_clk_en_jpeg_mask                                           (0x00000008)
+#define SYS_CLOCK_ENABLE2_clk_en_jpeg(data)                                          (0x00000008&((data)<<3))
+#define SYS_CLOCK_ENABLE2_clk_en_jpeg_src(data)                                      ((0x00000008&(data))>>3)
+#define SYS_CLOCK_ENABLE2_get_clk_en_jpeg(data)                                      ((0x00000008&(data))>>3)
+#define SYS_CLOCK_ENABLE2_clk_en_scpu_shift                                          (2)
+#define SYS_CLOCK_ENABLE2_clk_en_scpu_mask                                           (0x00000004)
+#define SYS_CLOCK_ENABLE2_clk_en_scpu(data)                                          (0x00000004&((data)<<2))
+#define SYS_CLOCK_ENABLE2_clk_en_scpu_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_CLOCK_ENABLE2_get_clk_en_scpu(data)                                      ((0x00000004&(data))>>2)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5_shift                                    (1)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5_mask                                     (0x00000002)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5(data)                                    (0x00000002&((data)<<1))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5_src(data)                                ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_5(data)                                ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE2_clk_en_nat_shift                                           (0)
+#define SYS_CLOCK_ENABLE2_clk_en_nat_mask                                            (0x00000001)
+#define SYS_CLOCK_ENABLE2_clk_en_nat(data)                                           (0x00000001&((data)<<0))
+#define SYS_CLOCK_ENABLE2_clk_en_nat_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_CLOCK_ENABLE2_get_clk_en_nat(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_GROUP1_CK_EN                                                             0x98000014
+#define SYS_GROUP1_CK_EN_reg_addr                                                    "0xD8000014"
+#define SYS_GROUP1_CK_EN_reg                                                         0xD8000014
+#define set_SYS_GROUP1_CK_EN_reg(data)   (*((volatile unsigned int*) SYS_GROUP1_CK_EN_reg)=data)
+#define get_SYS_GROUP1_CK_EN_reg   (*((volatile unsigned int*) SYS_GROUP1_CK_EN_reg))
+#define SYS_GROUP1_CK_EN_inst_adr                                                    "0x0005"
+#define SYS_GROUP1_CK_EN_inst                                                        0x0005
+#define SYS_GROUP1_CK_EN_reserved_group1_ck_en_shift                                 (0)
+#define SYS_GROUP1_CK_EN_reserved_group1_ck_en_mask                                  (0x00000001)
+#define SYS_GROUP1_CK_EN_reserved_group1_ck_en(data)                                 (0x00000001&((data)<<0))
+#define SYS_GROUP1_CK_EN_reserved_group1_ck_en_src(data)                             ((0x00000001&(data))>>0)
+#define SYS_GROUP1_CK_EN_get_reserved_group1_ck_en(data)                             ((0x00000001&(data))>>0)
+
+
+#define SYS_GROUP1_CK_SEL                                                            0x98000018
+#define SYS_GROUP1_CK_SEL_reg_addr                                                   "0xD8000018"
+#define SYS_GROUP1_CK_SEL_reg                                                        0xD8000018
+#define set_SYS_GROUP1_CK_SEL_reg(data)   (*((volatile unsigned int*) SYS_GROUP1_CK_SEL_reg)=data)
+#define get_SYS_GROUP1_CK_SEL_reg   (*((volatile unsigned int*) SYS_GROUP1_CK_SEL_reg))
+#define SYS_GROUP1_CK_SEL_inst_adr                                                   "0x0006"
+#define SYS_GROUP1_CK_SEL_inst                                                       0x0006
+#define SYS_GROUP1_CK_SEL_scpu_sclk_sel_shift                                        (2)
+#define SYS_GROUP1_CK_SEL_scpu_sclk_sel_mask                                         (0x00000004)
+#define SYS_GROUP1_CK_SEL_scpu_sclk_sel(data)                                        (0x00000004&((data)<<2))
+#define SYS_GROUP1_CK_SEL_scpu_sclk_sel_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_GROUP1_CK_SEL_get_scpu_sclk_sel(data)                                    ((0x00000004&(data))>>2)
+#define SYS_GROUP1_CK_SEL_sclk_sel_sysh_shift                                        (1)
+#define SYS_GROUP1_CK_SEL_sclk_sel_sysh_mask                                         (0x00000002)
+#define SYS_GROUP1_CK_SEL_sclk_sel_sysh(data)                                        (0x00000002&((data)<<1))
+#define SYS_GROUP1_CK_SEL_sclk_sel_sysh_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_GROUP1_CK_SEL_get_sclk_sel_sysh(data)                                    ((0x00000002&(data))>>1)
+#define SYS_GROUP1_CK_SEL_sclk_sel_shift                                             (0)
+#define SYS_GROUP1_CK_SEL_sclk_sel_mask                                              (0x00000001)
+#define SYS_GROUP1_CK_SEL_sclk_sel(data)                                             (0x00000001&((data)<<0))
+#define SYS_GROUP1_CK_SEL_sclk_sel_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_GROUP1_CK_SEL_get_sclk_sel(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_TVE_CK_SEL                                                               0x9800001C
+#define SYS_TVE_CK_SEL_reg_addr                                                      "0xD800001C"
+#define SYS_TVE_CK_SEL_reg                                                           0xD800001C
+#define set_SYS_TVE_CK_SEL_reg(data)   (*((volatile unsigned int*) SYS_TVE_CK_SEL_reg)=data)
+#define get_SYS_TVE_CK_SEL_reg   (*((volatile unsigned int*) SYS_TVE_CK_SEL_reg))
+#define SYS_TVE_CK_SEL_inst_adr                                                      "0x0007"
+#define SYS_TVE_CK_SEL_inst                                                          0x0007
+#define SYS_TVE_CK_SEL_write_en5_shift                                               (12)
+#define SYS_TVE_CK_SEL_write_en5_mask                                                (0x00001000)
+#define SYS_TVE_CK_SEL_write_en5(data)                                               (0x00001000&((data)<<12))
+#define SYS_TVE_CK_SEL_write_en5_src(data)                                           ((0x00001000&(data))>>12)
+#define SYS_TVE_CK_SEL_get_write_en5(data)                                           ((0x00001000&(data))>>12)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2_shift                                   (11)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2_mask                                    (0x00000800)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2(data)                                   (0x00000800&((data)<<11))
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2_src(data)                               ((0x00000800&(data))>>11)
+#define SYS_TVE_CK_SEL_get_clk_tve_p_vo_clk_sel2(data)                               ((0x00000800&(data))>>11)
+#define SYS_TVE_CK_SEL_write_en4_shift                                               (10)
+#define SYS_TVE_CK_SEL_write_en4_mask                                                (0x00000400)
+#define SYS_TVE_CK_SEL_write_en4(data)                                               (0x00000400&((data)<<10))
+#define SYS_TVE_CK_SEL_write_en4_src(data)                                           ((0x00000400&(data))>>10)
+#define SYS_TVE_CK_SEL_get_write_en4(data)                                           ((0x00000400&(data))>>10)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel_shift                                    (9)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel_mask                                     (0x00000200)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel(data)                                    (0x00000200&((data)<<9))
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel_src(data)                                ((0x00000200&(data))>>9)
+#define SYS_TVE_CK_SEL_get_clk_tve_p_vo_clk_sel(data)                                ((0x00000200&(data))>>9)
+#define SYS_TVE_CK_SEL_write_en3_shift                                               (8)
+#define SYS_TVE_CK_SEL_write_en3_mask                                                (0x00000100)
+#define SYS_TVE_CK_SEL_write_en3(data)                                               (0x00000100&((data)<<8))
+#define SYS_TVE_CK_SEL_write_en3_src(data)                                           ((0x00000100&(data))>>8)
+#define SYS_TVE_CK_SEL_get_write_en3(data)                                           ((0x00000100&(data))>>8)
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv_shift                                          (7)
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv_mask                                           (0x00000080)
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv(data)                                          (0x00000080&((data)<<7))
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv_src(data)                                      ((0x00000080&(data))>>7)
+#define SYS_TVE_CK_SEL_get_hdmi_phy_ckinv(data)                                      ((0x00000080&(data))>>7)
+#define SYS_TVE_CK_SEL_write_en2_shift                                               (6)
+#define SYS_TVE_CK_SEL_write_en2_mask                                                (0x00000040)
+#define SYS_TVE_CK_SEL_write_en2(data)                                               (0x00000040&((data)<<6))
+#define SYS_TVE_CK_SEL_write_en2_src(data)                                           ((0x00000040&(data))>>6)
+#define SYS_TVE_CK_SEL_get_write_en2(data)                                           ((0x00000040&(data))>>6)
+#define SYS_TVE_CK_SEL_dac2_ckinv_shift                                              (3)
+#define SYS_TVE_CK_SEL_dac2_ckinv_mask                                               (0x00000008)
+#define SYS_TVE_CK_SEL_dac2_ckinv(data)                                              (0x00000008&((data)<<3))
+#define SYS_TVE_CK_SEL_dac2_ckinv_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_TVE_CK_SEL_get_dac2_ckinv(data)                                          ((0x00000008&(data))>>3)
+#define SYS_TVE_CK_SEL_dac1_ckinv_shift                                              (2)
+#define SYS_TVE_CK_SEL_dac1_ckinv_mask                                               (0x00000004)
+#define SYS_TVE_CK_SEL_dac1_ckinv(data)                                              (0x00000004&((data)<<2))
+#define SYS_TVE_CK_SEL_dac1_ckinv_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_TVE_CK_SEL_get_dac1_ckinv(data)                                          ((0x00000004&(data))>>2)
+#define SYS_TVE_CK_SEL_write_en1_shift                                               (1)
+#define SYS_TVE_CK_SEL_write_en1_mask                                                (0x00000002)
+#define SYS_TVE_CK_SEL_write_en1(data)                                               (0x00000002&((data)<<1))
+#define SYS_TVE_CK_SEL_write_en1_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_TVE_CK_SEL_get_write_en1(data)                                           ((0x00000002&(data))>>1)
+#define SYS_TVE_CK_SEL_tveck_mix_sel_shift                                           (0)
+#define SYS_TVE_CK_SEL_tveck_mix_sel_mask                                            (0x00000001)
+#define SYS_TVE_CK_SEL_tveck_mix_sel(data)                                           (0x00000001&((data)<<0))
+#define SYS_TVE_CK_SEL_tveck_mix_sel_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_TVE_CK_SEL_get_tveck_mix_sel(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_DISP_PLL_DIV                                                             0x98000020
+#define SYS_DISP_PLL_DIV_reg_addr                                                    "0xD8000020"
+#define SYS_DISP_PLL_DIV_reg                                                         0xD8000020
+#define set_SYS_DISP_PLL_DIV_reg(data)   (*((volatile unsigned int*) SYS_DISP_PLL_DIV_reg)=data)
+#define get_SYS_DISP_PLL_DIV_reg   (*((volatile unsigned int*) SYS_DISP_PLL_DIV_reg))
+#define SYS_DISP_PLL_DIV_inst_adr                                                    "0x0008"
+#define SYS_DISP_PLL_DIV_inst                                                        0x0008
+#define SYS_DISP_PLL_DIV_write_en2_shift                                             (11)
+#define SYS_DISP_PLL_DIV_write_en2_mask                                              (0x00000800)
+#define SYS_DISP_PLL_DIV_write_en2(data)                                             (0x00000800&((data)<<11))
+#define SYS_DISP_PLL_DIV_write_en2_src(data)                                         ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV_get_write_en2(data)                                         ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV_dac2_div_shift                                              (6)
+#define SYS_DISP_PLL_DIV_dac2_div_mask                                               (0x000007C0)
+#define SYS_DISP_PLL_DIV_dac2_div(data)                                              (0x000007C0&((data)<<6))
+#define SYS_DISP_PLL_DIV_dac2_div_src(data)                                          ((0x000007C0&(data))>>6)
+#define SYS_DISP_PLL_DIV_get_dac2_div(data)                                          ((0x000007C0&(data))>>6)
+#define SYS_DISP_PLL_DIV_write_en1_shift                                             (5)
+#define SYS_DISP_PLL_DIV_write_en1_mask                                              (0x00000020)
+#define SYS_DISP_PLL_DIV_write_en1(data)                                             (0x00000020&((data)<<5))
+#define SYS_DISP_PLL_DIV_write_en1_src(data)                                         ((0x00000020&(data))>>5)
+#define SYS_DISP_PLL_DIV_get_write_en1(data)                                         ((0x00000020&(data))>>5)
+#define SYS_DISP_PLL_DIV_dac1_div_shift                                              (0)
+#define SYS_DISP_PLL_DIV_dac1_div_mask                                               (0x0000001F)
+#define SYS_DISP_PLL_DIV_dac1_div(data)                                              (0x0000001F&((data)<<0))
+#define SYS_DISP_PLL_DIV_dac1_div_src(data)                                          ((0x0000001F&(data))>>0)
+#define SYS_DISP_PLL_DIV_get_dac1_div(data)                                          ((0x0000001F&(data))>>0)
+
+
+#define SYS_DISP_PLL_DIV2                                                            0x98000024
+#define SYS_DISP_PLL_DIV2_reg_addr                                                   "0xD8000024"
+#define SYS_DISP_PLL_DIV2_reg                                                        0xD8000024
+#define set_SYS_DISP_PLL_DIV2_reg(data)   (*((volatile unsigned int*) SYS_DISP_PLL_DIV2_reg)=data)
+#define get_SYS_DISP_PLL_DIV2_reg   (*((volatile unsigned int*) SYS_DISP_PLL_DIV2_reg))
+#define SYS_DISP_PLL_DIV2_inst_adr                                                   "0x0009"
+#define SYS_DISP_PLL_DIV2_inst                                                       0x0009
+#define SYS_DISP_PLL_DIV2_write_en11_shift                                           (26)
+#define SYS_DISP_PLL_DIV2_write_en11_mask                                            (0x04000000)
+#define SYS_DISP_PLL_DIV2_write_en11(data)                                           (0x04000000&((data)<<26))
+#define SYS_DISP_PLL_DIV2_write_en11_src(data)                                       ((0x04000000&(data))>>26)
+#define SYS_DISP_PLL_DIV2_get_write_en11(data)                                       ((0x04000000&(data))>>26)
+#define SYS_DISP_PLL_DIV2_sel_prefifo_din_shift                                      (25)
+#define SYS_DISP_PLL_DIV2_sel_prefifo_din_mask                                       (0x02000000)
+#define SYS_DISP_PLL_DIV2_sel_prefifo_din(data)                                      (0x02000000&((data)<<25))
+#define SYS_DISP_PLL_DIV2_sel_prefifo_din_src(data)                                  ((0x02000000&(data))>>25)
+#define SYS_DISP_PLL_DIV2_get_sel_prefifo_din(data)                                  ((0x02000000&(data))>>25)
+#define SYS_DISP_PLL_DIV2_write_en10_shift                                           (24)
+#define SYS_DISP_PLL_DIV2_write_en10_mask                                            (0x01000000)
+#define SYS_DISP_PLL_DIV2_write_en10(data)                                           (0x01000000&((data)<<24))
+#define SYS_DISP_PLL_DIV2_write_en10_src(data)                                       ((0x01000000&(data))>>24)
+#define SYS_DISP_PLL_DIV2_get_write_en10(data)                                       ((0x01000000&(data))>>24)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl_shift                                      (23)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl_mask                                       (0x00800000)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl(data)                                      (0x00800000&((data)<<23))
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl_src(data)                                  ((0x00800000&(data))>>23)
+#define SYS_DISP_PLL_DIV2_get_sel_pllhdmi_mhl(data)                                  ((0x00800000&(data))>>23)
+#define SYS_DISP_PLL_DIV2_write_en9_shift                                            (22)
+#define SYS_DISP_PLL_DIV2_write_en9_mask                                             (0x00400000)
+#define SYS_DISP_PLL_DIV2_write_en9(data)                                            (0x00400000&((data)<<22))
+#define SYS_DISP_PLL_DIV2_write_en9_src(data)                                        ((0x00400000&(data))>>22)
+#define SYS_DISP_PLL_DIV2_get_write_en9(data)                                        ((0x00400000&(data))>>22)
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel_shift                                         (17)
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel_mask                                          (0x003E0000)
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel(data)                                         (0x003E0000&((data)<<17))
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel_src(data)                                     ((0x003E0000&(data))>>17)
+#define SYS_DISP_PLL_DIV2_get_clk_lvds_sel(data)                                     ((0x003E0000&(data))>>17)
+#define SYS_DISP_PLL_DIV2_write_en8_shift                                            (16)
+#define SYS_DISP_PLL_DIV2_write_en8_mask                                             (0x00010000)
+#define SYS_DISP_PLL_DIV2_write_en8(data)                                            (0x00010000&((data)<<16))
+#define SYS_DISP_PLL_DIV2_write_en8_src(data)                                        ((0x00010000&(data))>>16)
+#define SYS_DISP_PLL_DIV2_get_write_en8(data)                                        ((0x00010000&(data))>>16)
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2_shift                                     (15)
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2_mask                                      (0x00008000)
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2(data)                                     (0x00008000&((data)<<15))
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2_src(data)                                 ((0x00008000&(data))>>15)
+#define SYS_DISP_PLL_DIV2_get_sel_plldisp_clk2(data)                                 ((0x00008000&(data))>>15)
+#define SYS_DISP_PLL_DIV2_write_en7_shift                                            (14)
+#define SYS_DISP_PLL_DIV2_write_en7_mask                                             (0x00004000)
+#define SYS_DISP_PLL_DIV2_write_en7(data)                                            (0x00004000&((data)<<14))
+#define SYS_DISP_PLL_DIV2_write_en7_src(data)                                        ((0x00004000&(data))>>14)
+#define SYS_DISP_PLL_DIV2_get_write_en7(data)                                        ((0x00004000&(data))>>14)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk_shift                                      (13)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk_mask                                       (0x00002000)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk(data)                                      (0x00002000&((data)<<13))
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk_src(data)                                  ((0x00002000&(data))>>13)
+#define SYS_DISP_PLL_DIV2_get_sel_pllhdmi_clk(data)                                  ((0x00002000&(data))>>13)
+#define SYS_DISP_PLL_DIV2_write_en6_shift                                            (12)
+#define SYS_DISP_PLL_DIV2_write_en6_mask                                             (0x00001000)
+#define SYS_DISP_PLL_DIV2_write_en6(data)                                            (0x00001000&((data)<<12))
+#define SYS_DISP_PLL_DIV2_write_en6_src(data)                                        ((0x00001000&(data))>>12)
+#define SYS_DISP_PLL_DIV2_get_write_en6(data)                                        ((0x00001000&(data))>>12)
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat_shift                                      (11)
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat_mask                                       (0x00000800)
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat(data)                                      (0x00000800&((data)<<11))
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat_src(data)                                  ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV2_get_hdmi_pxl_repeat(data)                                  ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV2_write_en5_shift                                            (10)
+#define SYS_DISP_PLL_DIV2_write_en5_mask                                             (0x00000400)
+#define SYS_DISP_PLL_DIV2_write_en5(data)                                            (0x00000400&((data)<<10))
+#define SYS_DISP_PLL_DIV2_write_en5_src(data)                                        ((0x00000400&(data))>>10)
+#define SYS_DISP_PLL_DIV2_get_write_en5(data)                                        ((0x00000400&(data))>>10)
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel_shift                                     (9)
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel_mask                                      (0x00000200)
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel(data)                                     (0x00000200&((data)<<9))
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel_src(data)                                 ((0x00000200&(data))>>9)
+#define SYS_DISP_PLL_DIV2_get_hdmi_phy_clk_sel(data)                                 ((0x00000200&(data))>>9)
+#define SYS_DISP_PLL_DIV2_write_en4_shift                                            (8)
+#define SYS_DISP_PLL_DIV2_write_en4_mask                                             (0x00000100)
+#define SYS_DISP_PLL_DIV2_write_en4(data)                                            (0x00000100&((data)<<8))
+#define SYS_DISP_PLL_DIV2_write_en4_src(data)                                        ((0x00000100&(data))>>8)
+#define SYS_DISP_PLL_DIV2_get_write_en4(data)                                        ((0x00000100&(data))>>8)
+#define SYS_DISP_PLL_DIV2_hdmi_div_shift                                             (5)
+#define SYS_DISP_PLL_DIV2_hdmi_div_mask                                              (0x000000E0)
+#define SYS_DISP_PLL_DIV2_hdmi_div(data)                                             (0x000000E0&((data)<<5))
+#define SYS_DISP_PLL_DIV2_hdmi_div_src(data)                                         ((0x000000E0&(data))>>5)
+#define SYS_DISP_PLL_DIV2_get_hdmi_div(data)                                         ((0x000000E0&(data))>>5)
+#define SYS_DISP_PLL_DIV2_write_en3_shift                                            (4)
+#define SYS_DISP_PLL_DIV2_write_en3_mask                                             (0x00000010)
+#define SYS_DISP_PLL_DIV2_write_en3(data)                                            (0x00000010&((data)<<4))
+#define SYS_DISP_PLL_DIV2_write_en3_src(data)                                        ((0x00000010&(data))>>4)
+#define SYS_DISP_PLL_DIV2_get_write_en3(data)                                        ((0x00000010&(data))>>4)
+#define SYS_DISP_PLL_DIV2_tve_div_shift                                              (0)
+#define SYS_DISP_PLL_DIV2_tve_div_mask                                               (0x0000000F)
+#define SYS_DISP_PLL_DIV2_tve_div(data)                                              (0x0000000F&((data)<<0))
+#define SYS_DISP_PLL_DIV2_tve_div_src(data)                                          ((0x0000000F&(data))>>0)
+#define SYS_DISP_PLL_DIV2_get_tve_div(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define SYS_DDS_VIDEO_CK_SEL                                                         0x98000028
+#define SYS_DDS_VIDEO_CK_SEL_reg_addr                                                "0xD8000028"
+#define SYS_DDS_VIDEO_CK_SEL_reg                                                     0xD8000028
+#define set_SYS_DDS_VIDEO_CK_SEL_reg(data)   (*((volatile unsigned int*) SYS_DDS_VIDEO_CK_SEL_reg)=data)
+#define get_SYS_DDS_VIDEO_CK_SEL_reg   (*((volatile unsigned int*) SYS_DDS_VIDEO_CK_SEL_reg))
+#define SYS_DDS_VIDEO_CK_SEL_inst_adr                                                "0x000A"
+#define SYS_DDS_VIDEO_CK_SEL_inst                                                    0x000A
+#define SYS_DDS_VIDEO_CK_SEL_nat_clk_sel_shift                                       (1)
+#define SYS_DDS_VIDEO_CK_SEL_nat_clk_sel_mask                                        (0x00000002)
+#define SYS_DDS_VIDEO_CK_SEL_nat_clk_sel(data)                                       (0x00000002&((data)<<1))
+#define SYS_DDS_VIDEO_CK_SEL_nat_clk_sel_src(data)                                   ((0x00000002&(data))>>1)
+#define SYS_DDS_VIDEO_CK_SEL_get_nat_clk_sel(data)                                   ((0x00000002&(data))>>1)
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel_shift                                       (0)
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel_mask                                        (0x00000001)
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel(data)                                       (0x00000001&((data)<<0))
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_DDS_VIDEO_CK_SEL_get_dds_clk_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_AUDIO_CLK_CTL                                                            0x9800002C
+#define SYS_AUDIO_CLK_CTL_reg_addr                                                   "0xD800002C"
+#define SYS_AUDIO_CLK_CTL_reg                                                        0xD800002C
+#define set_SYS_AUDIO_CLK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AUDIO_CLK_CTL_reg)=data)
+#define get_SYS_AUDIO_CLK_CTL_reg   (*((volatile unsigned int*) SYS_AUDIO_CLK_CTL_reg))
+#define SYS_AUDIO_CLK_CTL_inst_adr                                                   "0x000B"
+#define SYS_AUDIO_CLK_CTL_inst                                                       0x000B
+#define SYS_AUDIO_CLK_CTL_mipi_div_shift                                             (4)
+#define SYS_AUDIO_CLK_CTL_mipi_div_mask                                              (0x00000030)
+#define SYS_AUDIO_CLK_CTL_mipi_div(data)                                             (0x00000030&((data)<<4))
+#define SYS_AUDIO_CLK_CTL_mipi_div_src(data)                                         ((0x00000030&(data))>>4)
+#define SYS_AUDIO_CLK_CTL_get_mipi_div(data)                                         ((0x00000030&(data))>>4)
+#define SYS_AUDIO_CLK_CTL_vo_div_shift                                               (2)
+#define SYS_AUDIO_CLK_CTL_vo_div_mask                                                (0x0000000C)
+#define SYS_AUDIO_CLK_CTL_vo_div(data)                                               (0x0000000C&((data)<<2))
+#define SYS_AUDIO_CLK_CTL_vo_div_src(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_AUDIO_CLK_CTL_get_vo_div(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk_shift                                     (0)
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk_mask                                      (0x00000001)
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk(data)                                     (0x00000001&((data)<<0))
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk_src(data)                                 ((0x00000001&(data))>>0)
+#define SYS_AUDIO_CLK_CTL_get_audio_use_sysclk(data)                                 ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DIV                                                                  0x98000030
+#define SYS_PLL_DIV_reg_addr                                                         "0xD8000030"
+#define SYS_PLL_DIV_reg                                                              0xD8000030
+#define set_SYS_PLL_DIV_reg(data)   (*((volatile unsigned int*) SYS_PLL_DIV_reg)=data)
+#define get_SYS_PLL_DIV_reg   (*((volatile unsigned int*) SYS_PLL_DIV_reg))
+#define SYS_PLL_DIV_inst_adr                                                         "0x000C"
+#define SYS_PLL_DIV_inst                                                             0x000C
+#define SYS_PLL_DIV_scpu_freq_sel_shift                                              (7)
+#define SYS_PLL_DIV_scpu_freq_sel_mask                                               (0x00000180)
+#define SYS_PLL_DIV_scpu_freq_sel(data)                                              (0x00000180&((data)<<7))
+#define SYS_PLL_DIV_scpu_freq_sel_src(data)                                          ((0x00000180&(data))>>7)
+#define SYS_PLL_DIV_get_scpu_freq_sel(data)                                          ((0x00000180&(data))>>7)
+#define SYS_PLL_DIV_acpu_freq_sel_shift                                              (3)
+#define SYS_PLL_DIV_acpu_freq_sel_mask                                               (0x00000018)
+#define SYS_PLL_DIV_acpu_freq_sel(data)                                              (0x00000018&((data)<<3))
+#define SYS_PLL_DIV_acpu_freq_sel_src(data)                                          ((0x00000018&(data))>>3)
+#define SYS_PLL_DIV_get_acpu_freq_sel(data)                                          ((0x00000018&(data))>>3)
+#define SYS_PLL_DIV_bus_freq_sel_shift                                               (0)
+#define SYS_PLL_DIV_bus_freq_sel_mask                                                (0x00000001)
+#define SYS_PLL_DIV_bus_freq_sel(data)                                               (0x00000001&((data)<<0))
+#define SYS_PLL_DIV_bus_freq_sel_src(data)                                           ((0x00000001&(data))>>0)
+#define SYS_PLL_DIV_get_bus_freq_sel(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SYS_NF_CKSEL                                                                 0x98000038
+#define SYS_NF_CKSEL_reg_addr                                                        "0xD8000038"
+#define SYS_NF_CKSEL_reg                                                             0xD8000038
+#define set_SYS_NF_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_NF_CKSEL_reg)=data)
+#define get_SYS_NF_CKSEL_reg   (*((volatile unsigned int*) SYS_NF_CKSEL_reg))
+#define SYS_NF_CKSEL_inst_adr                                                        "0x000E"
+#define SYS_NF_CKSEL_inst                                                            0x000E
+#define SYS_NF_CKSEL_emmc_div_sel_shift                                              (24)
+#define SYS_NF_CKSEL_emmc_div_sel_mask                                               (0x03000000)
+#define SYS_NF_CKSEL_emmc_div_sel(data)                                              (0x03000000&((data)<<24))
+#define SYS_NF_CKSEL_emmc_div_sel_src(data)                                          ((0x03000000&(data))>>24)
+#define SYS_NF_CKSEL_get_emmc_div_sel(data)                                          ((0x03000000&(data))>>24)
+#define SYS_NF_CKSEL_cr_div_sel_shift                                                (16)
+#define SYS_NF_CKSEL_cr_div_sel_mask                                                 (0x00030000)
+#define SYS_NF_CKSEL_cr_div_sel(data)                                                (0x00030000&((data)<<16))
+#define SYS_NF_CKSEL_cr_div_sel_src(data)                                            ((0x00030000&(data))>>16)
+#define SYS_NF_CKSEL_get_cr_div_sel(data)                                            ((0x00030000&(data))>>16)
+#define SYS_NF_CKSEL_sdio_div_sel_shift                                              (8)
+#define SYS_NF_CKSEL_sdio_div_sel_mask                                               (0x00000300)
+#define SYS_NF_CKSEL_sdio_div_sel(data)                                              (0x00000300&((data)<<8))
+#define SYS_NF_CKSEL_sdio_div_sel_src(data)                                          ((0x00000300&(data))>>8)
+#define SYS_NF_CKSEL_get_sdio_div_sel(data)                                          ((0x00000300&(data))>>8)
+#define SYS_NF_CKSEL_nf_div_sel_shift                                                (0)
+#define SYS_NF_CKSEL_nf_div_sel_mask                                                 (0x0000000F)
+#define SYS_NF_CKSEL_nf_div_sel(data)                                                (0x0000000F&((data)<<0))
+#define SYS_NF_CKSEL_nf_div_sel_src(data)                                            ((0x0000000F&(data))>>0)
+#define SYS_NF_CKSEL_get_nf_div_sel(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define SYS_NDS_SC_CKSEL                                                             0x9800003C
+#define SYS_NDS_SC_CKSEL_reg_addr                                                    "0xD800003C"
+#define SYS_NDS_SC_CKSEL_reg                                                         0xD800003C
+#define set_SYS_NDS_SC_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_NDS_SC_CKSEL_reg)=data)
+#define get_SYS_NDS_SC_CKSEL_reg   (*((volatile unsigned int*) SYS_NDS_SC_CKSEL_reg))
+#define SYS_NDS_SC_CKSEL_inst_adr                                                    "0x000F"
+#define SYS_NDS_SC_CKSEL_inst                                                        0x000F
+#define SYS_NDS_SC_CKSEL_nds_sc_div_shift                                            (0)
+#define SYS_NDS_SC_CKSEL_nds_sc_div_mask                                             (0x00000007)
+#define SYS_NDS_SC_CKSEL_nds_sc_div(data)                                            (0x00000007&((data)<<0))
+#define SYS_NDS_SC_CKSEL_nds_sc_div_src(data)                                        ((0x00000007&(data))>>0)
+#define SYS_NDS_SC_CKSEL_get_nds_sc_div(data)                                        ((0x00000007&(data))>>0)
+
+
+#define SYS_DCPHY_CKSEL                                                              0x98000040
+#define SYS_DCPHY_CKSEL_reg_addr                                                     "0xD8000040"
+#define SYS_DCPHY_CKSEL_reg                                                          0xD8000040
+#define set_SYS_DCPHY_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_DCPHY_CKSEL_reg)=data)
+#define get_SYS_DCPHY_CKSEL_reg   (*((volatile unsigned int*) SYS_DCPHY_CKSEL_reg))
+#define SYS_DCPHY_CKSEL_inst_adr                                                     "0x0010"
+#define SYS_DCPHY_CKSEL_inst                                                         0x0010
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_1_shift                                (1)
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_1_mask                                 (0x00000002)
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_1(data)                                (0x00000002&((data)<<1))
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_1_src(data)                            ((0x00000002&(data))>>1)
+#define SYS_DCPHY_CKSEL_get_ref_bypass_mode_dcphy_1(data)                            ((0x00000002&(data))>>1)
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_0_shift                                (0)
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_0_mask                                 (0x00000001)
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_0(data)                                (0x00000001&((data)<<0))
+#define SYS_DCPHY_CKSEL_ref_bypass_mode_dcphy_0_src(data)                            ((0x00000001&(data))>>0)
+#define SYS_DCPHY_CKSEL_get_ref_bypass_mode_dcphy_0(data)                            ((0x00000001&(data))>>0)
+
+
+#define SYS_MISC_CKSEL                                                               0x98000044
+#define SYS_MISC_CKSEL_reg_addr                                                      "0xD8000044"
+#define SYS_MISC_CKSEL_reg                                                           0xD8000044
+#define set_SYS_MISC_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_MISC_CKSEL_reg)=data)
+#define get_SYS_MISC_CKSEL_reg   (*((volatile unsigned int*) SYS_MISC_CKSEL_reg))
+#define SYS_MISC_CKSEL_inst_adr                                                      "0x0011"
+#define SYS_MISC_CKSEL_inst                                                          0x0011
+#define SYS_MISC_CKSEL_clk_camera1_sel_shift                                         (2)
+#define SYS_MISC_CKSEL_clk_camera1_sel_mask                                          (0x0000000C)
+#define SYS_MISC_CKSEL_clk_camera1_sel(data)                                         (0x0000000C&((data)<<2))
+#define SYS_MISC_CKSEL_clk_camera1_sel_src(data)                                     ((0x0000000C&(data))>>2)
+#define SYS_MISC_CKSEL_get_clk_camera1_sel(data)                                     ((0x0000000C&(data))>>2)
+#define SYS_MISC_CKSEL_clk_camera0_sel_shift                                         (0)
+#define SYS_MISC_CKSEL_clk_camera0_sel_mask                                          (0x00000003)
+#define SYS_MISC_CKSEL_clk_camera0_sel(data)                                         (0x00000003&((data)<<0))
+#define SYS_MISC_CKSEL_clk_camera0_sel_src(data)                                     ((0x00000003&(data))>>0)
+#define SYS_MISC_CKSEL_get_clk_camera0_sel(data)                                     ((0x00000003&(data))>>0)
+
+
+#define SYS_SCPU_CKSEL                                                               0x98000048
+#define SYS_SCPU_CKSEL_reg_addr                                                      "0xD8000048"
+#define SYS_SCPU_CKSEL_reg                                                           0xD8000048
+#define set_SYS_SCPU_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_SCPU_CKSEL_reg)=data)
+#define get_SYS_SCPU_CKSEL_reg   (*((volatile unsigned int*) SYS_SCPU_CKSEL_reg))
+#define SYS_SCPU_CKSEL_inst_adr                                                      "0x0012"
+#define SYS_SCPU_CKSEL_inst                                                          0x0012
+#define SYS_SCPU_CKSEL_CLKTRC_SEL_shift                                              (0)
+#define SYS_SCPU_CKSEL_CLKTRC_SEL_mask                                               (0x00000003)
+#define SYS_SCPU_CKSEL_CLKTRC_SEL(data)                                              (0x00000003&((data)<<0))
+#define SYS_SCPU_CKSEL_CLKTRC_SEL_src(data)                                          ((0x00000003&(data))>>0)
+#define SYS_SCPU_CKSEL_get_CLKTRC_SEL(data)                                          ((0x00000003&(data))>>0)
+
+
+#define SYS_VE_CKSEL                                                                 0x9800004C
+#define SYS_VE_CKSEL_reg_addr                                                        "0xD800004C"
+#define SYS_VE_CKSEL_reg                                                             0xD800004C
+#define set_SYS_VE_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_VE_CKSEL_reg)=data)
+#define get_SYS_VE_CKSEL_reg   (*((volatile unsigned int*) SYS_VE_CKSEL_reg))
+#define SYS_VE_CKSEL_inst_adr                                                        "0x0013"
+#define SYS_VE_CKSEL_inst                                                            0x0013
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel_shift                                           (6)
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel_mask                                            (0x000001C0)
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel(data)                                           (0x000001C0&((data)<<6))
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel_src(data)                                       ((0x000001C0&(data))>>6)
+#define SYS_VE_CKSEL_get_clk_ve2_bpu_sel(data)                                       ((0x000001C0&(data))>>6)
+#define SYS_VE_CKSEL_clk_ve3_sel_shift                                               (4)
+#define SYS_VE_CKSEL_clk_ve3_sel_mask                                                (0x00000030)
+#define SYS_VE_CKSEL_clk_ve3_sel(data)                                               (0x00000030&((data)<<4))
+#define SYS_VE_CKSEL_clk_ve3_sel_src(data)                                           ((0x00000030&(data))>>4)
+#define SYS_VE_CKSEL_get_clk_ve3_sel(data)                                           ((0x00000030&(data))>>4)
+#define SYS_VE_CKSEL_clk_ve2_sel_shift                                               (2)
+#define SYS_VE_CKSEL_clk_ve2_sel_mask                                                (0x0000000C)
+#define SYS_VE_CKSEL_clk_ve2_sel(data)                                               (0x0000000C&((data)<<2))
+#define SYS_VE_CKSEL_clk_ve2_sel_src(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_VE_CKSEL_get_clk_ve2_sel(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_VE_CKSEL_clk_ve1_sel_shift                                               (0)
+#define SYS_VE_CKSEL_clk_ve1_sel_mask                                                (0x00000003)
+#define SYS_VE_CKSEL_clk_ve1_sel(data)                                               (0x00000003&((data)<<0))
+#define SYS_VE_CKSEL_clk_ve1_sel_src(data)                                           ((0x00000003&(data))>>0)
+#define SYS_VE_CKSEL_get_clk_ve1_sel(data)                                           ((0x00000003&(data))>>0)
+
+
+#define SYS_SOFT_RESET4                                                              0x98000050
+#define SYS_SOFT_RESET4_reg_addr                                                     "0xD8000050"
+#define SYS_SOFT_RESET4_reg                                                          0xD8000050
+#define set_SYS_SOFT_RESET4_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET4_reg)=data)
+#define get_SYS_SOFT_RESET4_reg   (*((volatile unsigned int*) SYS_SOFT_RESET4_reg))
+#define SYS_SOFT_RESET4_inst_adr                                                     "0x0014"
+#define SYS_SOFT_RESET4_inst                                                         0x0014
+#define SYS_SOFT_RESET4_rstn_disp_shift                                              (15)
+#define SYS_SOFT_RESET4_rstn_disp_mask                                               (0x00008000)
+#define SYS_SOFT_RESET4_rstn_disp(data)                                              (0x00008000&((data)<<15))
+#define SYS_SOFT_RESET4_rstn_disp_src(data)                                          ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET4_get_rstn_disp(data)                                          ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET4_rstn_pcie1_phy_mdio_shift                                    (14)
+#define SYS_SOFT_RESET4_rstn_pcie1_phy_mdio_mask                                     (0x00004000)
+#define SYS_SOFT_RESET4_rstn_pcie1_phy_mdio(data)                                    (0x00004000&((data)<<14))
+#define SYS_SOFT_RESET4_rstn_pcie1_phy_mdio_src(data)                                ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET4_get_rstn_pcie1_phy_mdio(data)                                ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET4_rstn_pcie0_phy_mdio_shift                                    (13)
+#define SYS_SOFT_RESET4_rstn_pcie0_phy_mdio_mask                                     (0x00002000)
+#define SYS_SOFT_RESET4_rstn_pcie0_phy_mdio(data)                                    (0x00002000&((data)<<13))
+#define SYS_SOFT_RESET4_rstn_pcie0_phy_mdio_src(data)                                ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET4_get_rstn_pcie0_phy_mdio(data)                                ((0x00002000&(data))>>13)
+#define SYS_SOFT_RESET4_rstn_hdmirx_wrap_shift                                       (12)
+#define SYS_SOFT_RESET4_rstn_hdmirx_wrap_mask                                        (0x00001000)
+#define SYS_SOFT_RESET4_rstn_hdmirx_wrap(data)                                       (0x00001000&((data)<<12))
+#define SYS_SOFT_RESET4_rstn_hdmirx_wrap_src(data)                                   ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET4_get_rstn_hdmirx_wrap(data)                                   ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET4_rstn_fan_shift                                               (11)
+#define SYS_SOFT_RESET4_rstn_fan_mask                                                (0x00000800)
+#define SYS_SOFT_RESET4_rstn_fan(data)                                               (0x00000800&((data)<<11))
+#define SYS_SOFT_RESET4_rstn_fan_src(data)                                           ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET4_get_rstn_fan(data)                                           ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET4_rstn_sata_1_shift                                            (10)
+#define SYS_SOFT_RESET4_rstn_sata_1_mask                                             (0x00000400)
+#define SYS_SOFT_RESET4_rstn_sata_1(data)                                            (0x00000400&((data)<<10))
+#define SYS_SOFT_RESET4_rstn_sata_1_src(data)                                        ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET4_get_rstn_sata_1(data)                                        ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET4_rstn_sata_phy_1_shift                                        (9)
+#define SYS_SOFT_RESET4_rstn_sata_phy_1_mask                                         (0x00000200)
+#define SYS_SOFT_RESET4_rstn_sata_phy_1(data)                                        (0x00000200&((data)<<9))
+#define SYS_SOFT_RESET4_rstn_sata_phy_1_src(data)                                    ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET4_get_rstn_sata_phy_1(data)                                    ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET4_sata_func_exist_1_shift                                      (8)
+#define SYS_SOFT_RESET4_sata_func_exist_1_mask                                       (0x00000100)
+#define SYS_SOFT_RESET4_sata_func_exist_1(data)                                      (0x00000100&((data)<<8))
+#define SYS_SOFT_RESET4_sata_func_exist_1_src(data)                                  ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET4_get_sata_func_exist_1(data)                                  ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET4_rstn_sata_phy_pow_1_shift                                    (7)
+#define SYS_SOFT_RESET4_rstn_sata_phy_pow_1_mask                                     (0x00000080)
+#define SYS_SOFT_RESET4_rstn_sata_phy_pow_1(data)                                    (0x00000080&((data)<<7))
+#define SYS_SOFT_RESET4_rstn_sata_phy_pow_1_src(data)                                ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET4_get_rstn_sata_phy_pow_1(data)                                ((0x00000080&(data))>>7)
+#define SYS_SOFT_RESET4_rstn_cbusrx_shift                                            (6)
+#define SYS_SOFT_RESET4_rstn_cbusrx_mask                                             (0x00000040)
+#define SYS_SOFT_RESET4_rstn_cbusrx(data)                                            (0x00000040&((data)<<6))
+#define SYS_SOFT_RESET4_rstn_cbusrx_src(data)                                        ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET4_get_rstn_cbusrx(data)                                        ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET4_rstn_hdmirx_shift                                            (5)
+#define SYS_SOFT_RESET4_rstn_hdmirx_mask                                             (0x00000020)
+#define SYS_SOFT_RESET4_rstn_hdmirx(data)                                            (0x00000020&((data)<<5))
+#define SYS_SOFT_RESET4_rstn_hdmirx_src(data)                                        ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET4_get_rstn_hdmirx(data)                                        ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET4_rstn_dcphy_ssc_dig_shift                                     (4)
+#define SYS_SOFT_RESET4_rstn_dcphy_ssc_dig_mask                                      (0x00000010)
+#define SYS_SOFT_RESET4_rstn_dcphy_ssc_dig(data)                                     (0x00000010&((data)<<4))
+#define SYS_SOFT_RESET4_rstn_dcphy_ssc_dig_src(data)                                 ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET4_get_rstn_dcphy_ssc_dig(data)                                 ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET4_rstn_dcphy_ldo_shift                                         (3)
+#define SYS_SOFT_RESET4_rstn_dcphy_ldo_mask                                          (0x00000008)
+#define SYS_SOFT_RESET4_rstn_dcphy_ldo(data)                                         (0x00000008&((data)<<3))
+#define SYS_SOFT_RESET4_rstn_dcphy_ldo_src(data)                                     ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET4_get_rstn_dcphy_ldo(data)                                     ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET4_rstn_dcphy_ptr_shift                                         (2)
+#define SYS_SOFT_RESET4_rstn_dcphy_ptr_mask                                          (0x00000004)
+#define SYS_SOFT_RESET4_rstn_dcphy_ptr(data)                                         (0x00000004&((data)<<2))
+#define SYS_SOFT_RESET4_rstn_dcphy_ptr_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET4_get_rstn_dcphy_ptr(data)                                     ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET4_rstn_dcphy_alert_rx_shift                                    (1)
+#define SYS_SOFT_RESET4_rstn_dcphy_alert_rx_mask                                     (0x00000002)
+#define SYS_SOFT_RESET4_rstn_dcphy_alert_rx(data)                                    (0x00000002&((data)<<1))
+#define SYS_SOFT_RESET4_rstn_dcphy_alert_rx_src(data)                                ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET4_get_rstn_dcphy_alert_rx(data)                                ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET4_rstn_dcphy_crt_shift                                         (0)
+#define SYS_SOFT_RESET4_rstn_dcphy_crt_mask                                          (0x00000001)
+#define SYS_SOFT_RESET4_rstn_dcphy_crt(data)                                         (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET4_rstn_dcphy_crt_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET4_get_rstn_dcphy_crt(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_O_PCM_CK_CTL                                                         0x98000070
+#define SYS_AIO_O_PCM_CK_CTL_reg_addr                                                "0xD8000070"
+#define SYS_AIO_O_PCM_CK_CTL_reg                                                     0xD8000070
+#define set_SYS_AIO_O_PCM_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_O_PCM_CK_CTL_reg)=data)
+#define get_SYS_AIO_O_PCM_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_O_PCM_CK_CTL_reg))
+#define SYS_AIO_O_PCM_CK_CTL_inst_adr                                                "0x001C"
+#define SYS_AIO_O_PCM_CK_CTL_inst                                                    0x001C
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel_shift                                          (5)
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel_mask                                           (0x000000E0)
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel(data)                                          (0x000000E0&((data)<<5))
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel_src(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_O_PCM_CK_CTL_get_mclk_sel(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_O_PCM_CK_CTL_fs_shift                                                (1)
+#define SYS_AIO_O_PCM_CK_CTL_fs_mask                                                 (0x0000001E)
+#define SYS_AIO_O_PCM_CK_CTL_fs(data)                                                (0x0000001E&((data)<<1))
+#define SYS_AIO_O_PCM_CK_CTL_fs_src(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_PCM_CK_CTL_get_fs(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_PCM_CK_CTL_clken_shift                                             (0)
+#define SYS_AIO_O_PCM_CK_CTL_clken_mask                                              (0x00000001)
+#define SYS_AIO_O_PCM_CK_CTL_clken(data)                                             (0x00000001&((data)<<0))
+#define SYS_AIO_O_PCM_CK_CTL_clken_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_AIO_O_PCM_CK_CTL_get_clken(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_O_RAW_CK_CTL                                                         0x98000074
+#define SYS_AIO_O_RAW_CK_CTL_reg_addr                                                "0xD8000074"
+#define SYS_AIO_O_RAW_CK_CTL_reg                                                     0xD8000074
+#define set_SYS_AIO_O_RAW_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_O_RAW_CK_CTL_reg)=data)
+#define get_SYS_AIO_O_RAW_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_O_RAW_CK_CTL_reg))
+#define SYS_AIO_O_RAW_CK_CTL_inst_adr                                                "0x001D"
+#define SYS_AIO_O_RAW_CK_CTL_inst                                                    0x001D
+#define SYS_AIO_O_RAW_CK_CTL_fs_shift                                                (1)
+#define SYS_AIO_O_RAW_CK_CTL_fs_mask                                                 (0x0000001E)
+#define SYS_AIO_O_RAW_CK_CTL_fs(data)                                                (0x0000001E&((data)<<1))
+#define SYS_AIO_O_RAW_CK_CTL_fs_src(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW_CK_CTL_get_fs(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW_CK_CTL_clken_shift                                             (0)
+#define SYS_AIO_O_RAW_CK_CTL_clken_mask                                              (0x00000001)
+#define SYS_AIO_O_RAW_CK_CTL_clken(data)                                             (0x00000001&((data)<<0))
+#define SYS_AIO_O_RAW_CK_CTL_clken_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_AIO_O_RAW_CK_CTL_get_clken(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_O_RAW2_CK_CTL                                                        0x98000078
+#define SYS_AIO_O_RAW2_CK_CTL_reg_addr                                               "0xD8000078"
+#define SYS_AIO_O_RAW2_CK_CTL_reg                                                    0xD8000078
+#define set_SYS_AIO_O_RAW2_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_O_RAW2_CK_CTL_reg)=data)
+#define get_SYS_AIO_O_RAW2_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_O_RAW2_CK_CTL_reg))
+#define SYS_AIO_O_RAW2_CK_CTL_inst_adr                                               "0x001E"
+#define SYS_AIO_O_RAW2_CK_CTL_inst                                                   0x001E
+#define SYS_AIO_O_RAW2_CK_CTL_fs_shift                                               (1)
+#define SYS_AIO_O_RAW2_CK_CTL_fs_mask                                                (0x0000001E)
+#define SYS_AIO_O_RAW2_CK_CTL_fs(data)                                               (0x0000001E&((data)<<1))
+#define SYS_AIO_O_RAW2_CK_CTL_fs_src(data)                                           ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW2_CK_CTL_get_fs(data)                                           ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW2_CK_CTL_clken_shift                                            (0)
+#define SYS_AIO_O_RAW2_CK_CTL_clken_mask                                             (0x00000001)
+#define SYS_AIO_O_RAW2_CK_CTL_clken(data)                                            (0x00000001&((data)<<0))
+#define SYS_AIO_O_RAW2_CK_CTL_clken_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_AIO_O_RAW2_CK_CTL_get_clken(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_APS_CTL                                                                  0x9800007C
+#define SYS_APS_CTL_reg_addr                                                         "0xD800007C"
+#define SYS_APS_CTL_reg                                                              0xD800007C
+#define set_SYS_APS_CTL_reg(data)   (*((volatile unsigned int*) SYS_APS_CTL_reg)=data)
+#define get_SYS_APS_CTL_reg   (*((volatile unsigned int*) SYS_APS_CTL_reg))
+#define SYS_APS_CTL_inst_adr                                                         "0x001F"
+#define SYS_APS_CTL_inst                                                             0x001F
+#define SYS_APS_CTL_write_en2_shift                                                  (1)
+#define SYS_APS_CTL_write_en2_mask                                                   (0x00000002)
+#define SYS_APS_CTL_write_en2(data)                                                  (0x00000002&((data)<<1))
+#define SYS_APS_CTL_write_en2_src(data)                                              ((0x00000002&(data))>>1)
+#define SYS_APS_CTL_get_write_en2(data)                                              ((0x00000002&(data))>>1)
+#define SYS_APS_CTL_dds_rstn_shift                                                   (0)
+#define SYS_APS_CTL_dds_rstn_mask                                                    (0x00000001)
+#define SYS_APS_CTL_dds_rstn(data)                                                   (0x00000001&((data)<<0))
+#define SYS_APS_CTL_dds_rstn_src(data)                                               ((0x00000001&(data))>>0)
+#define SYS_APS_CTL_get_dds_rstn(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_I_PCM_CK_CTL                                                         0x98000080
+#define SYS_AIO_I_PCM_CK_CTL_reg_addr                                                "0xD8000080"
+#define SYS_AIO_I_PCM_CK_CTL_reg                                                     0xD8000080
+#define set_SYS_AIO_I_PCM_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_I_PCM_CK_CTL_reg)=data)
+#define get_SYS_AIO_I_PCM_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_I_PCM_CK_CTL_reg))
+#define SYS_AIO_I_PCM_CK_CTL_inst_adr                                                "0x0020"
+#define SYS_AIO_I_PCM_CK_CTL_inst                                                    0x0020
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel_shift                                          (5)
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel_mask                                           (0x000000E0)
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel(data)                                          (0x000000E0&((data)<<5))
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel_src(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_I_PCM_CK_CTL_get_mclk_sel(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_I_PCM_CK_CTL_fs_shift                                                (1)
+#define SYS_AIO_I_PCM_CK_CTL_fs_mask                                                 (0x0000001E)
+#define SYS_AIO_I_PCM_CK_CTL_fs(data)                                                (0x0000001E&((data)<<1))
+#define SYS_AIO_I_PCM_CK_CTL_fs_src(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_I_PCM_CK_CTL_get_fs(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_I_PCM_CK_CTL_clken_shift                                             (0)
+#define SYS_AIO_I_PCM_CK_CTL_clken_mask                                              (0x00000001)
+#define SYS_AIO_I_PCM_CK_CTL_clken(data)                                             (0x00000001&((data)<<0))
+#define SYS_AIO_I_PCM_CK_CTL_clken_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_AIO_I_PCM_CK_CTL_get_clken(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SCPU0                                                                0x98000100
+#define SYS_PLL_SCPU0_reg_addr                                                       "0xD8000100"
+#define SYS_PLL_SCPU0_reg                                                            0xD8000100
+#define set_SYS_PLL_SCPU0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SCPU0_reg)=data)
+#define get_SYS_PLL_SCPU0_reg   (*((volatile unsigned int*) SYS_PLL_SCPU0_reg))
+#define SYS_PLL_SCPU0_inst_adr                                                       "0x0040"
+#define SYS_PLL_SCPU0_inst                                                           0x0040
+#define SYS_PLL_SCPU0_REG_LDO18V_SEL_shift                                           (19)
+#define SYS_PLL_SCPU0_REG_LDO18V_SEL_mask                                            (0x00180000)
+#define SYS_PLL_SCPU0_REG_LDO18V_SEL(data)                                           (0x00180000&((data)<<19))
+#define SYS_PLL_SCPU0_REG_LDO18V_SEL_src(data)                                       ((0x00180000&(data))>>19)
+#define SYS_PLL_SCPU0_get_REG_LDO18V_SEL(data)                                       ((0x00180000&(data))>>19)
+#define SYS_PLL_SCPU0_REG_LDO10V_SEL_shift                                           (17)
+#define SYS_PLL_SCPU0_REG_LDO10V_SEL_mask                                            (0x00060000)
+#define SYS_PLL_SCPU0_REG_LDO10V_SEL(data)                                           (0x00060000&((data)<<17))
+#define SYS_PLL_SCPU0_REG_LDO10V_SEL_src(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_SCPU0_get_REG_LDO10V_SEL(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_SCPU0_REG_TESTSEL_PLLA_shift                                         (16)
+#define SYS_PLL_SCPU0_REG_TESTSEL_PLLA_mask                                          (0x00010000)
+#define SYS_PLL_SCPU0_REG_TESTSEL_PLLA(data)                                         (0x00010000&((data)<<16))
+#define SYS_PLL_SCPU0_REG_TESTSEL_PLLA_src(data)                                     ((0x00010000&(data))>>16)
+#define SYS_PLL_SCPU0_get_REG_TESTSEL_PLLA(data)                                     ((0x00010000&(data))>>16)
+#define SYS_PLL_SCPU0_REG_WD_SET_PLLA_shift                                          (14)
+#define SYS_PLL_SCPU0_REG_WD_SET_PLLA_mask                                           (0x00004000)
+#define SYS_PLL_SCPU0_REG_WD_SET_PLLA(data)                                          (0x00004000&((data)<<14))
+#define SYS_PLL_SCPU0_REG_WD_SET_PLLA_src(data)                                      ((0x00004000&(data))>>14)
+#define SYS_PLL_SCPU0_get_REG_WD_SET_PLLA(data)                                      ((0x00004000&(data))>>14)
+#define SYS_PLL_SCPU0_REG_WD_RST_PLLA_shift                                          (13)
+#define SYS_PLL_SCPU0_REG_WD_RST_PLLA_mask                                           (0x00002000)
+#define SYS_PLL_SCPU0_REG_WD_RST_PLLA(data)                                          (0x00002000&((data)<<13))
+#define SYS_PLL_SCPU0_REG_WD_RST_PLLA_src(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PLL_SCPU0_get_REG_WD_RST_PLLA(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PLL_SCPU0_REG_SEL_CCO_PLLA_shift                                         (12)
+#define SYS_PLL_SCPU0_REG_SEL_CCO_PLLA_mask                                          (0x00001000)
+#define SYS_PLL_SCPU0_REG_SEL_CCO_PLLA(data)                                         (0x00001000&((data)<<12))
+#define SYS_PLL_SCPU0_REG_SEL_CCO_PLLA_src(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PLL_SCPU0_get_REG_SEL_CCO_PLLA(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PLL_SCPU0_REG_SCPU_DBUG_EN_PLLA_shift                                    (11)
+#define SYS_PLL_SCPU0_REG_SCPU_DBUG_EN_PLLA_mask                                     (0x00000800)
+#define SYS_PLL_SCPU0_REG_SCPU_DBUG_EN_PLLA(data)                                    (0x00000800&((data)<<11))
+#define SYS_PLL_SCPU0_REG_SCPU_DBUG_EN_PLLA_src(data)                                ((0x00000800&(data))>>11)
+#define SYS_PLL_SCPU0_get_REG_SCPU_DBUG_EN_PLLA(data)                                ((0x00000800&(data))>>11)
+#define SYS_PLL_SCPU0_REG_LPF_RS_PLLA_shift                                          (8)
+#define SYS_PLL_SCPU0_REG_LPF_RS_PLLA_mask                                           (0x00000700)
+#define SYS_PLL_SCPU0_REG_LPF_RS_PLLA(data)                                          (0x00000700&((data)<<8))
+#define SYS_PLL_SCPU0_REG_LPF_RS_PLLA_src(data)                                      ((0x00000700&(data))>>8)
+#define SYS_PLL_SCPU0_get_REG_LPF_RS_PLLA(data)                                      ((0x00000700&(data))>>8)
+#define SYS_PLL_SCPU0_REG_LPF_CS_PLLA_shift                                          (6)
+#define SYS_PLL_SCPU0_REG_LPF_CS_PLLA_mask                                           (0x000000C0)
+#define SYS_PLL_SCPU0_REG_LPF_CS_PLLA(data)                                          (0x000000C0&((data)<<6))
+#define SYS_PLL_SCPU0_REG_LPF_CS_PLLA_src(data)                                      ((0x000000C0&(data))>>6)
+#define SYS_PLL_SCPU0_get_REG_LPF_CS_PLLA(data)                                      ((0x000000C0&(data))>>6)
+#define SYS_PLL_SCPU0_REG_ICP_PLLA_shift                                             (3)
+#define SYS_PLL_SCPU0_REG_ICP_PLLA_mask                                              (0x00000038)
+#define SYS_PLL_SCPU0_REG_ICP_PLLA(data)                                             (0x00000038&((data)<<3))
+#define SYS_PLL_SCPU0_REG_ICP_PLLA_src(data)                                         ((0x00000038&(data))>>3)
+#define SYS_PLL_SCPU0_get_REG_ICP_PLLA(data)                                         ((0x00000038&(data))>>3)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_BPS_PLLA_shift                                  (2)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_BPS_PLLA_mask                                   (0x00000004)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_BPS_PLLA(data)                                  (0x00000004&((data)<<2))
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_BPS_PLLA_src(data)                              ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU0_get_REG_DIV_PREDIV_BPS_PLLA(data)                              ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_SEL_PLLA_shift                                  (0)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_SEL_PLLA_mask                                   (0x00000003)
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_SEL_PLLA(data)                                  (0x00000003&((data)<<0))
+#define SYS_PLL_SCPU0_REG_DIV_PREDIV_SEL_PLLA_src(data)                              ((0x00000003&(data))>>0)
+#define SYS_PLL_SCPU0_get_REG_DIV_PREDIV_SEL_PLLA(data)                              ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_SCPU1                                                                0x98000104
+#define SYS_PLL_SCPU1_reg_addr                                                       "0xD8000104"
+#define SYS_PLL_SCPU1_reg                                                            0xD8000104
+#define set_SYS_PLL_SCPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SCPU1_reg)=data)
+#define get_SYS_PLL_SCPU1_reg   (*((volatile unsigned int*) SYS_PLL_SCPU1_reg))
+#define SYS_PLL_SCPU1_inst_adr                                                       "0x0041"
+#define SYS_PLL_SCPU1_inst                                                           0x0041
+#define SYS_PLL_SCPU1_REG_OEB_PLLA_shift                                             (2)
+#define SYS_PLL_SCPU1_REG_OEB_PLLA_mask                                              (0x00000004)
+#define SYS_PLL_SCPU1_REG_OEB_PLLA(data)                                             (0x00000004&((data)<<2))
+#define SYS_PLL_SCPU1_REG_OEB_PLLA_src(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU1_get_REG_OEB_PLLA(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU1_SCPU_RSTB_PLLA_shift                                           (1)
+#define SYS_PLL_SCPU1_SCPU_RSTB_PLLA_mask                                            (0x00000002)
+#define SYS_PLL_SCPU1_SCPU_RSTB_PLLA(data)                                           (0x00000002&((data)<<1))
+#define SYS_PLL_SCPU1_SCPU_RSTB_PLLA_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_SCPU1_get_SCPU_RSTB_PLLA(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_SCPU1_SCPU_POW_PLLA_shift                                            (0)
+#define SYS_PLL_SCPU1_SCPU_POW_PLLA_mask                                             (0x00000001)
+#define SYS_PLL_SCPU1_SCPU_POW_PLLA(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_SCPU1_SCPU_POW_PLLA_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_SCPU1_get_SCPU_POW_PLLA(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_ACPU1                                                                0x9800010C
+#define SYS_PLL_ACPU1_reg_addr                                                       "0xD800010C"
+#define SYS_PLL_ACPU1_reg                                                            0xD800010C
+#define set_SYS_PLL_ACPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_ACPU1_reg)=data)
+#define get_SYS_PLL_ACPU1_reg   (*((volatile unsigned int*) SYS_PLL_ACPU1_reg))
+#define SYS_PLL_ACPU1_inst_adr                                                       "0x0043"
+#define SYS_PLL_ACPU1_inst                                                           0x0043
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_shift                                         (17)
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_mask                                          (0x00060000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV(data)                                         (0x00060000&((data)<<17))
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_src(data)                                     ((0x00060000&(data))>>17)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_PDIV(data)                                     ((0x00060000&(data))>>17)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_RS_shift                                       (14)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_RS_mask                                        (0x0001C000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_RS(data)                                       (0x0001C000&((data)<<14))
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_RS_src(data)                                   ((0x0001C000&(data))>>14)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_LPF_RS(data)                                   ((0x0001C000&(data))>>14)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_CS_shift                                       (12)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_CS_mask                                        (0x00003000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_CS(data)                                       (0x00003000&((data)<<12))
+#define SYS_PLL_ACPU1_REG_PLLACPU_LPF_CS_src(data)                                   ((0x00003000&(data))>>12)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_LPF_CS(data)                                   ((0x00003000&(data))>>12)
+#define SYS_PLL_ACPU1_REG_PLLACPU_ICP_shift                                          (9)
+#define SYS_PLL_ACPU1_REG_PLLACPU_ICP_mask                                           (0x00000E00)
+#define SYS_PLL_ACPU1_REG_PLLACPU_ICP(data)                                          (0x00000E00&((data)<<9))
+#define SYS_PLL_ACPU1_REG_PLLACPU_ICP_src(data)                                      ((0x00000E00&(data))>>9)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_ICP(data)                                      ((0x00000E00&(data))>>9)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST_shift                                        (8)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST_mask                                         (0x00000100)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST(data)                                        (0x00000100&((data)<<8))
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_WDRST(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET_shift                                        (7)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET_mask                                         (0x00000080)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET(data)                                        (0x00000080&((data)<<7))
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET_src(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_WDSET(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_ACPU1_REG_PLLACPU_TESTSEL_shift                                      (6)
+#define SYS_PLL_ACPU1_REG_PLLACPU_TESTSEL_mask                                       (0x00000040)
+#define SYS_PLL_ACPU1_REG_PLLACPU_TESTSEL(data)                                      (0x00000040&((data)<<6))
+#define SYS_PLL_ACPU1_REG_PLLACPU_TESTSEL_src(data)                                  ((0x00000040&(data))>>6)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_TESTSEL(data)                                  ((0x00000040&(data))>>6)
+#define SYS_PLL_ACPU1_REG_PLLACPU_SEL_CCO_shift                                      (5)
+#define SYS_PLL_ACPU1_REG_PLLACPU_SEL_CCO_mask                                       (0x00000020)
+#define SYS_PLL_ACPU1_REG_PLLACPU_SEL_CCO(data)                                      (0x00000020&((data)<<5))
+#define SYS_PLL_ACPU1_REG_PLLACPU_SEL_CCO_src(data)                                  ((0x00000020&(data))>>5)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_SEL_CCO(data)                                  ((0x00000020&(data))>>5)
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_BPS_shift                                     (4)
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_BPS_mask                                      (0x00000010)
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_BPS(data)                                     (0x00000010&((data)<<4))
+#define SYS_PLL_ACPU1_REG_PLLACPU_PDIV_BPS_src(data)                                 ((0x00000010&(data))>>4)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_PDIV_BPS(data)                                 ((0x00000010&(data))>>4)
+#define SYS_PLL_ACPU1_REG_PLLACPU_DBUG_EN_shift                                      (3)
+#define SYS_PLL_ACPU1_REG_PLLACPU_DBUG_EN_mask                                       (0x00000008)
+#define SYS_PLL_ACPU1_REG_PLLACPU_DBUG_EN(data)                                      (0x00000008&((data)<<3))
+#define SYS_PLL_ACPU1_REG_PLLACPU_DBUG_EN_src(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_DBUG_EN(data)                                  ((0x00000008&(data))>>3)
+
+
+#define SYS_PLL_ACPU2                                                                0x98000110
+#define SYS_PLL_ACPU2_reg_addr                                                       "0xD8000110"
+#define SYS_PLL_ACPU2_reg                                                            0xD8000110
+#define set_SYS_PLL_ACPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_ACPU2_reg)=data)
+#define get_SYS_PLL_ACPU2_reg   (*((volatile unsigned int*) SYS_PLL_ACPU2_reg))
+#define SYS_PLL_ACPU2_inst_adr                                                       "0x0044"
+#define SYS_PLL_ACPU2_inst                                                           0x0044
+#define SYS_PLL_ACPU2_REG_PLLACPU_OEB_shift                                          (2)
+#define SYS_PLL_ACPU2_REG_PLLACPU_OEB_mask                                           (0x00000004)
+#define SYS_PLL_ACPU2_REG_PLLACPU_OEB(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_ACPU2_REG_PLLACPU_OEB_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_ACPU2_get_REG_PLLACPU_OEB(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_ACPU2_REG_PLLACPU_RSTB_shift                                         (1)
+#define SYS_PLL_ACPU2_REG_PLLACPU_RSTB_mask                                          (0x00000002)
+#define SYS_PLL_ACPU2_REG_PLLACPU_RSTB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_ACPU2_REG_PLLACPU_RSTB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_ACPU2_get_REG_PLLACPU_RSTB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_ACPU2_REG_PLLACPU_POW_shift                                          (0)
+#define SYS_PLL_ACPU2_REG_PLLACPU_POW_mask                                           (0x00000001)
+#define SYS_PLL_ACPU2_REG_PLLACPU_POW(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_ACPU2_REG_PLLACPU_POW_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_ACPU2_get_REG_PLLACPU_POW(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VE1_1                                                                0x98000114
+#define SYS_PLL_VE1_1_reg_addr                                                       "0xD8000114"
+#define SYS_PLL_VE1_1_reg                                                            0xD8000114
+#define set_SYS_PLL_VE1_1_reg(data)   (*((volatile unsigned int*) SYS_PLL_VE1_1_reg)=data)
+#define get_SYS_PLL_VE1_1_reg   (*((volatile unsigned int*) SYS_PLL_VE1_1_reg))
+#define SYS_PLL_VE1_1_inst_adr                                                       "0x0045"
+#define SYS_PLL_VE1_1_inst                                                           0x0045
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDRST_shift                                        (22)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDRST_mask                                         (0x00400000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDRST(data)                                        (0x00400000&((data)<<22))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDRST_src(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_WDRST(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDSET_shift                                        (21)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDSET_mask                                         (0x00200000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDSET(data)                                        (0x00200000&((data)<<21))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_WDSET_src(data)                                    ((0x00200000&(data))>>21)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_WDSET(data)                                    ((0x00200000&(data))>>21)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_CS_shift                                           (19)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_CS_mask                                            (0x00180000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_CS(data)                                           (0x00180000&((data)<<19))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_CS_src(data)                                       ((0x00180000&(data))>>19)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_CS(data)                                       ((0x00180000&(data))>>19)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_O_shift                                            (17)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_O_mask                                             (0x00060000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_O(data)                                            (0x00060000&((data)<<17))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_O_src(data)                                        ((0x00060000&(data))>>17)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_O(data)                                        ((0x00060000&(data))>>17)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_RS_shift                                           (14)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_RS_mask                                            (0x0001C000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_RS(data)                                           (0x0001C000&((data)<<14))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_RS_src(data)                                       ((0x0001C000&(data))>>14)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_RS(data)                                       ((0x0001C000&(data))>>14)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_N_shift                                            (12)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_N_mask                                             (0x00003000)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_N(data)                                            (0x00003000&((data)<<12))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_N_src(data)                                        ((0x00003000&(data))>>12)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_N(data)                                        ((0x00003000&(data))>>12)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_M_shift                                            (4)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_M_mask                                             (0x00000FF0)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_M(data)                                            (0x00000FF0&((data)<<4))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_M_src(data)                                        ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_M(data)                                        ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_IP_shift                                           (1)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_IP_mask                                            (0x0000000E)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_IP(data)                                           (0x0000000E&((data)<<1))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_IP_src(data)                                       ((0x0000000E&(data))>>1)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_IP(data)                                       ((0x0000000E&(data))>>1)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_TST_shift                                          (0)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_TST_mask                                           (0x00000001)
+#define SYS_PLL_VE1_1_REG_PLLVCPU_TST(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_VE1_1_REG_PLLVCPU_TST_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_VE1_1_get_REG_PLLVCPU_TST(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VE1_2                                                                0x98000118
+#define SYS_PLL_VE1_2_reg_addr                                                       "0xD8000118"
+#define SYS_PLL_VE1_2_reg                                                            0xD8000118
+#define set_SYS_PLL_VE1_2_reg(data)   (*((volatile unsigned int*) SYS_PLL_VE1_2_reg)=data)
+#define get_SYS_PLL_VE1_2_reg   (*((volatile unsigned int*) SYS_PLL_VE1_2_reg))
+#define SYS_PLL_VE1_2_inst_adr                                                       "0x0046"
+#define SYS_PLL_VE1_2_inst                                                           0x0046
+#define SYS_PLL_VE1_2_REG_PLLVCPU_OEB_shift                                          (2)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_OEB_mask                                           (0x00000004)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_OEB(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_VE1_2_REG_PLLVCPU_OEB_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_VE1_2_get_REG_PLLVCPU_OEB(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_RSTB_shift                                         (1)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_RSTB_mask                                          (0x00000002)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_RSTB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_VE1_2_REG_PLLVCPU_RSTB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_VE1_2_get_REG_PLLVCPU_RSTB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_POW_shift                                          (0)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_POW_mask                                           (0x00000001)
+#define SYS_PLL_VE1_2_REG_PLLVCPU_POW(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_VE1_2_REG_PLLVCPU_POW_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_VE1_2_get_REG_PLLVCPU_POW(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DDSA1                                                                0x98000120
+#define SYS_PLL_DDSA1_reg_addr                                                       "0xD8000120"
+#define SYS_PLL_DDSA1_reg                                                            0xD8000120
+#define set_SYS_PLL_DDSA1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDSA1_reg)=data)
+#define get_SYS_PLL_DDSA1_reg   (*((volatile unsigned int*) SYS_PLL_DDSA1_reg))
+#define SYS_PLL_DDSA1_inst_adr                                                       "0x0048"
+#define SYS_PLL_DDSA1_inst                                                           0x0048
+#define SYS_PLL_DDSA1_REG_PLLDDSA_WDMODE_shift                                       (23)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_WDMODE_mask                                        (0x01800000)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_WDMODE(data)                                       (0x01800000&((data)<<23))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_WDMODE_src(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_WDMODE(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_RS_shift                                           (20)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_RS_mask                                            (0x00700000)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_RS(data)                                           (0x00700000&((data)<<20))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_RS_src(data)                                       ((0x00700000&(data))>>20)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_RS(data)                                       ((0x00700000&(data))>>20)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_O_shift                                            (18)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_O_mask                                             (0x000C0000)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_O(data)                                            (0x000C0000&((data)<<18))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_O_src(data)                                        ((0x000C0000&(data))>>18)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_O(data)                                        ((0x000C0000&(data))>>18)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_N_shift                                            (16)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_N_mask                                             (0x00030000)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_N(data)                                            (0x00030000&((data)<<16))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_N_src(data)                                        ((0x00030000&(data))>>16)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_N(data)                                        ((0x00030000&(data))>>16)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_IP_shift                                           (12)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_IP_mask                                            (0x0000F000)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_IP(data)                                           (0x0000F000&((data)<<12))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_IP_src(data)                                       ((0x0000F000&(data))>>12)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_IP(data)                                       ((0x0000F000&(data))>>12)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CS_shift                                           (10)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CS_mask                                            (0x00000C00)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CS(data)                                           (0x00000C00&((data)<<10))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CS_src(data)                                       ((0x00000C00&(data))>>10)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_CS(data)                                       ((0x00000C00&(data))>>10)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CP_shift                                           (8)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CP_mask                                            (0x00000300)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CP(data)                                           (0x00000300&((data)<<8))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_CP_src(data)                                       ((0x00000300&(data))>>8)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_CP(data)                                       ((0x00000300&(data))>>8)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_VCORB_shift                                        (7)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_VCORB_mask                                         (0x00000080)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_VCORB(data)                                        (0x00000080&((data)<<7))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_VCORB_src(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_VCORB(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_TST_shift                                          (6)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_TST_mask                                           (0x00000040)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_TST(data)                                          (0x00000040&((data)<<6))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_TST_src(data)                                      ((0x00000040&(data))>>6)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_TST(data)                                      ((0x00000040&(data))>>6)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_PSTST_shift                                        (5)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_PSTST_mask                                         (0x00000020)
+#define SYS_PLL_DDSA1_REG_PLLDDSA_PSTST(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_DDSA1_REG_PLLDDSA_PSTST_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_DDSA1_get_REG_PLLDDSA_PSTST(data)                                    ((0x00000020&(data))>>5)
+
+
+#define SYS_PLL_DDSA2                                                                0x98000128
+#define SYS_PLL_DDSA2_reg_addr                                                       "0xD8000128"
+#define SYS_PLL_DDSA2_reg                                                            0xD8000128
+#define set_SYS_PLL_DDSA2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDSA2_reg)=data)
+#define get_SYS_PLL_DDSA2_reg   (*((volatile unsigned int*) SYS_PLL_DDSA2_reg))
+#define SYS_PLL_DDSA2_inst_adr                                                       "0x004A"
+#define SYS_PLL_DDSA2_inst                                                           0x004A
+#define SYS_PLL_DDSA2_REG_PLLDDSA_OEB_shift                                          (2)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_OEB_mask                                           (0x00000004)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_OEB(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_DDSA2_REG_PLLDDSA_OEB_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DDSA2_get_REG_PLLDDSA_OEB(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_RSTB_shift                                         (1)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_RSTB_mask                                          (0x00000002)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_RSTB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_DDSA2_REG_PLLDDSA_RSTB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DDSA2_get_REG_PLLDDSA_RSTB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_POW_shift                                          (0)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_POW_mask                                           (0x00000001)
+#define SYS_PLL_DDSA2_REG_PLLDDSA_POW(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_DDSA2_REG_PLLDDSA_POW_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_DDSA2_get_REG_PLLDDSA_POW(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PSAUDA1                                                              0x98000130
+#define SYS_PLL_PSAUDA1_reg_addr                                                     "0xD8000130"
+#define SYS_PLL_PSAUDA1_reg                                                          0xD8000130
+#define set_SYS_PLL_PSAUDA1_reg(data)   (*((volatile unsigned int*) SYS_PLL_PSAUDA1_reg)=data)
+#define get_SYS_PLL_PSAUDA1_reg   (*((volatile unsigned int*) SYS_PLL_PSAUDA1_reg))
+#define SYS_PLL_PSAUDA1_inst_adr                                                     "0x004C"
+#define SYS_PLL_PSAUDA1_inst                                                         0x004C
+#define SYS_PLL_PSAUDA1_write_en11_shift                                             (28)
+#define SYS_PLL_PSAUDA1_write_en11_mask                                              (0x10000000)
+#define SYS_PLL_PSAUDA1_write_en11(data)                                             (0x10000000&((data)<<28))
+#define SYS_PLL_PSAUDA1_write_en11_src(data)                                         ((0x10000000&(data))>>28)
+#define SYS_PLL_PSAUDA1_get_write_en11(data)                                         ((0x10000000&(data))>>28)
+#define SYS_PLL_PSAUDA1_psaud_1a_phase_sel_shift                                     (27)
+#define SYS_PLL_PSAUDA1_psaud_1a_phase_sel_mask                                      (0x08000000)
+#define SYS_PLL_PSAUDA1_psaud_1a_phase_sel(data)                                     (0x08000000&((data)<<27))
+#define SYS_PLL_PSAUDA1_psaud_1a_phase_sel_src(data)                                 ((0x08000000&(data))>>27)
+#define SYS_PLL_PSAUDA1_get_psaud_1a_phase_sel(data)                                 ((0x08000000&(data))>>27)
+#define SYS_PLL_PSAUDA1_psaud_2a_phase_sel_shift                                     (26)
+#define SYS_PLL_PSAUDA1_psaud_2a_phase_sel_mask                                      (0x04000000)
+#define SYS_PLL_PSAUDA1_psaud_2a_phase_sel(data)                                     (0x04000000&((data)<<26))
+#define SYS_PLL_PSAUDA1_psaud_2a_phase_sel_src(data)                                 ((0x04000000&(data))>>26)
+#define SYS_PLL_PSAUDA1_get_psaud_2a_phase_sel(data)                                 ((0x04000000&(data))>>26)
+#define SYS_PLL_PSAUDA1_write_en10_shift                                             (25)
+#define SYS_PLL_PSAUDA1_write_en10_mask                                              (0x02000000)
+#define SYS_PLL_PSAUDA1_write_en10(data)                                             (0x02000000&((data)<<25))
+#define SYS_PLL_PSAUDA1_write_en10_src(data)                                         ((0x02000000&(data))>>25)
+#define SYS_PLL_PSAUDA1_get_write_en10(data)                                         ((0x02000000&(data))>>25)
+#define SYS_PLL_PSAUDA1_pcr_a_smooth_en_shift                                        (24)
+#define SYS_PLL_PSAUDA1_pcr_a_smooth_en_mask                                         (0x01000000)
+#define SYS_PLL_PSAUDA1_pcr_a_smooth_en(data)                                        (0x01000000&((data)<<24))
+#define SYS_PLL_PSAUDA1_pcr_a_smooth_en_src(data)                                    ((0x01000000&(data))>>24)
+#define SYS_PLL_PSAUDA1_get_pcr_a_smooth_en(data)                                    ((0x01000000&(data))>>24)
+#define SYS_PLL_PSAUDA1_write_en9_shift                                              (23)
+#define SYS_PLL_PSAUDA1_write_en9_mask                                               (0x00800000)
+#define SYS_PLL_PSAUDA1_write_en9(data)                                              (0x00800000&((data)<<23))
+#define SYS_PLL_PSAUDA1_write_en9_src(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PLL_PSAUDA1_get_write_en9(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PLL_PSAUDA1_pcr_a_phase_sel_shift                                        (22)
+#define SYS_PLL_PSAUDA1_pcr_a_phase_sel_mask                                         (0x00400000)
+#define SYS_PLL_PSAUDA1_pcr_a_phase_sel(data)                                        (0x00400000&((data)<<22))
+#define SYS_PLL_PSAUDA1_pcr_a_phase_sel_src(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_PSAUDA1_get_pcr_a_phase_sel(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_PSAUDA1_write_en8_shift                                              (21)
+#define SYS_PLL_PSAUDA1_write_en8_mask                                               (0x00200000)
+#define SYS_PLL_PSAUDA1_write_en8(data)                                              (0x00200000&((data)<<21))
+#define SYS_PLL_PSAUDA1_write_en8_src(data)                                          ((0x00200000&(data))>>21)
+#define SYS_PLL_PSAUDA1_get_write_en8(data)                                          ((0x00200000&(data))>>21)
+#define SYS_PLL_PSAUDA1_pcr_a_ctl_en_shift                                           (20)
+#define SYS_PLL_PSAUDA1_pcr_a_ctl_en_mask                                            (0x00100000)
+#define SYS_PLL_PSAUDA1_pcr_a_ctl_en(data)                                           (0x00100000&((data)<<20))
+#define SYS_PLL_PSAUDA1_pcr_a_ctl_en_src(data)                                       ((0x00100000&(data))>>20)
+#define SYS_PLL_PSAUDA1_get_pcr_a_ctl_en(data)                                       ((0x00100000&(data))>>20)
+#define SYS_PLL_PSAUDA1_write_en3_shift                                              (10)
+#define SYS_PLL_PSAUDA1_write_en3_mask                                               (0x00000400)
+#define SYS_PLL_PSAUDA1_write_en3(data)                                              (0x00000400&((data)<<10))
+#define SYS_PLL_PSAUDA1_write_en3_src(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PLL_PSAUDA1_get_write_en3(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_FUPDN_shift                                      (9)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_FUPDN_mask                                       (0x00000200)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_FUPDN(data)                                      (0x00000200&((data)<<9))
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_FUPDN_src(data)                                  ((0x00000200&(data))>>9)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD1A_FUPDN(data)                                  ((0x00000200&(data))>>9)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_DIV_shift                                        (8)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_DIV_mask                                         (0x00000100)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_DIV(data)                                        (0x00000100&((data)<<8))
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_DIV_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD1A_DIV(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_PSAUDA1_write_en2_shift                                              (7)
+#define SYS_PLL_PSAUDA1_write_en2_mask                                               (0x00000080)
+#define SYS_PLL_PSAUDA1_write_en2(data)                                              (0x00000080&((data)<<7))
+#define SYS_PLL_PSAUDA1_write_en2_src(data)                                          ((0x00000080&(data))>>7)
+#define SYS_PLL_PSAUDA1_get_write_en2(data)                                          ((0x00000080&(data))>>7)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_TST_shift                                        (6)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_TST_mask                                         (0x00000040)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_TST(data)                                        (0x00000040&((data)<<6))
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_TST_src(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD1A_TST(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_PSEN_shift                                       (5)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_PSEN_mask                                        (0x00000020)
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_PSEN(data)                                       (0x00000020&((data)<<5))
+#define SYS_PLL_PSAUDA1_REG_PSAUD1A_PSEN_src(data)                                   ((0x00000020&(data))>>5)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD1A_PSEN(data)                                   ((0x00000020&(data))>>5)
+#define SYS_PLL_PSAUDA1_write_en1_shift                                              (4)
+#define SYS_PLL_PSAUDA1_write_en1_mask                                               (0x00000010)
+#define SYS_PLL_PSAUDA1_write_en1(data)                                              (0x00000010&((data)<<4))
+#define SYS_PLL_PSAUDA1_write_en1_src(data)                                          ((0x00000010&(data))>>4)
+#define SYS_PLL_PSAUDA1_get_write_en1(data)                                          ((0x00000010&(data))>>4)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_FUPDN_shift                                      (3)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_FUPDN_mask                                       (0x00000008)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_FUPDN(data)                                      (0x00000008&((data)<<3))
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_FUPDN_src(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD2A_FUPDN(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_DIV_shift                                        (2)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_DIV_mask                                         (0x00000004)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_DIV(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_DIV_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD2A_DIV(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_TST_shift                                        (1)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_TST_mask                                         (0x00000002)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_TST(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_TST_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD2A_TST(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_PSEN_shift                                       (0)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_PSEN_mask                                        (0x00000001)
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_PSEN(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_PSAUDA1_REG_PSAUD2A_PSEN_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_PSAUDA1_get_REG_PSAUD2A_PSEN(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PSAUDA2                                                              0x98000134
+#define SYS_PLL_PSAUDA2_reg_addr                                                     "0xD8000134"
+#define SYS_PLL_PSAUDA2_reg                                                          0xD8000134
+#define set_SYS_PLL_PSAUDA2_reg(data)   (*((volatile unsigned int*) SYS_PLL_PSAUDA2_reg)=data)
+#define get_SYS_PLL_PSAUDA2_reg   (*((volatile unsigned int*) SYS_PLL_PSAUDA2_reg))
+#define SYS_PLL_PSAUDA2_inst_adr                                                     "0x004D"
+#define SYS_PLL_PSAUDA2_inst                                                         0x004D
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_OEB_shift                                        (3)
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_OEB_mask                                         (0x00000008)
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_OEB(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_OEB_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDA2_get_REG_PSAUD1A_OEB(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_RSTB_shift                                       (2)
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_RSTB_mask                                        (0x00000004)
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_RSTB(data)                                       (0x00000004&((data)<<2))
+#define SYS_PLL_PSAUDA2_REG_PSAUD1A_RSTB_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDA2_get_REG_PSAUD1A_RSTB(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_OEB_shift                                        (1)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_OEB_mask                                         (0x00000002)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_OEB(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_OEB_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDA2_get_REG_PSAUD2A_OEB(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_RSTB_shift                                       (0)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_RSTB_mask                                        (0x00000001)
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_RSTB(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_PSAUDA2_REG_PSAUD2A_RSTB_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_PSAUDA2_get_REG_PSAUD2A_RSTB(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_HD1                                                             0x98000138
+#define SYS_PLL_DISP_HD1_reg_addr                                                    "0xD8000138"
+#define SYS_PLL_DISP_HD1_reg                                                         0xD8000138
+#define set_SYS_PLL_DISP_HD1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_HD1_reg)=data)
+#define get_SYS_PLL_DISP_HD1_reg   (*((volatile unsigned int*) SYS_PLL_DISP_HD1_reg))
+#define SYS_PLL_DISP_HD1_inst_adr                                                    "0x004E"
+#define SYS_PLL_DISP_HD1_inst                                                        0x004E
+#define SYS_PLL_DISP_HD1_reserved_pll_disp_hd1_shift                                 (0)
+#define SYS_PLL_DISP_HD1_reserved_pll_disp_hd1_mask                                  (0x00000001)
+#define SYS_PLL_DISP_HD1_reserved_pll_disp_hd1(data)                                 (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_HD1_reserved_pll_disp_hd1_src(data)                             ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_HD1_get_reserved_pll_disp_hd1(data)                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_HD2                                                             0x9800013c
+#define SYS_PLL_DISP_HD2_reg_addr                                                    "0xD800013C"
+#define SYS_PLL_DISP_HD2_reg                                                         0xD800013C
+#define set_SYS_PLL_DISP_HD2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_HD2_reg)=data)
+#define get_SYS_PLL_DISP_HD2_reg   (*((volatile unsigned int*) SYS_PLL_DISP_HD2_reg))
+#define SYS_PLL_DISP_HD2_inst_adr                                                    "0x004F"
+#define SYS_PLL_DISP_HD2_inst                                                        0x004F
+#define SYS_PLL_DISP_HD2_reserved_pll_disp_hd2_shift                                 (0)
+#define SYS_PLL_DISP_HD2_reserved_pll_disp_hd2_mask                                  (0x00000001)
+#define SYS_PLL_DISP_HD2_reserved_pll_disp_hd2(data)                                 (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_HD2_reserved_pll_disp_hd2_src(data)                             ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_HD2_get_reserved_pll_disp_hd2(data)                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL1_TEST                                                                0x98000140
+#define SYS_PLL1_TEST_reg_addr                                                       "0xD8000140"
+#define SYS_PLL1_TEST_reg                                                            0xD8000140
+#define set_SYS_PLL1_TEST_reg(data)   (*((volatile unsigned int*) SYS_PLL1_TEST_reg)=data)
+#define get_SYS_PLL1_TEST_reg   (*((volatile unsigned int*) SYS_PLL1_TEST_reg))
+#define SYS_PLL1_TEST_inst_adr                                                       "0x0050"
+#define SYS_PLL1_TEST_inst                                                           0x0050
+#define SYS_PLL1_TEST_REG_PLLTST_POW_shift                                           (4)
+#define SYS_PLL1_TEST_REG_PLLTST_POW_mask                                            (0x00000010)
+#define SYS_PLL1_TEST_REG_PLLTST_POW(data)                                           (0x00000010&((data)<<4))
+#define SYS_PLL1_TEST_REG_PLLTST_POW_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PLL1_TEST_get_REG_PLLTST_POW(data)                                       ((0x00000010&(data))>>4)
+
+
+#define SYS_PLL_BUS1                                                                 0x98000164
+#define SYS_PLL_BUS1_reg_addr                                                        "0xD8000164"
+#define SYS_PLL_BUS1_reg                                                             0xD8000164
+#define set_SYS_PLL_BUS1_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUS1_reg)=data)
+#define get_SYS_PLL_BUS1_reg   (*((volatile unsigned int*) SYS_PLL_BUS1_reg))
+#define SYS_PLL_BUS1_inst_adr                                                        "0x0059"
+#define SYS_PLL_BUS1_inst                                                            0x0059
+#define SYS_PLL_BUS1_REG_PLLBUS_RESER_shift                                          (19)
+#define SYS_PLL_BUS1_REG_PLLBUS_RESER_mask                                           (0x07F80000)
+#define SYS_PLL_BUS1_REG_PLLBUS_RESER(data)                                          (0x07F80000&((data)<<19))
+#define SYS_PLL_BUS1_REG_PLLBUS_RESER_src(data)                                      ((0x07F80000&(data))>>19)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_RESER(data)                                      ((0x07F80000&(data))>>19)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_shift                                           (17)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_mask                                            (0x00060000)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV(data)                                           (0x00060000&((data)<<17))
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_src(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_PDIV(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_RS_shift                                         (14)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_RS_mask                                          (0x0001C000)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_RS(data)                                         (0x0001C000&((data)<<14))
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_RS_src(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_LPF_RS(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_CS_shift                                         (12)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_CS_mask                                          (0x00003000)
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_CS(data)                                         (0x00003000&((data)<<12))
+#define SYS_PLL_BUS1_REG_PLLBUS_LPF_CS_src(data)                                     ((0x00003000&(data))>>12)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_LPF_CS(data)                                     ((0x00003000&(data))>>12)
+#define SYS_PLL_BUS1_REG_PLLBUS_ICP_shift                                            (9)
+#define SYS_PLL_BUS1_REG_PLLBUS_ICP_mask                                             (0x00000E00)
+#define SYS_PLL_BUS1_REG_PLLBUS_ICP(data)                                            (0x00000E00&((data)<<9))
+#define SYS_PLL_BUS1_REG_PLLBUS_ICP_src(data)                                        ((0x00000E00&(data))>>9)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_ICP(data)                                        ((0x00000E00&(data))>>9)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDSET_shift                                          (8)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDSET_mask                                           (0x00000100)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDSET(data)                                          (0x00000100&((data)<<8))
+#define SYS_PLL_BUS1_REG_PLLBUS_WDSET_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_WDSET(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDRST_shift                                          (7)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDRST_mask                                           (0x00000080)
+#define SYS_PLL_BUS1_REG_PLLBUS_WDRST(data)                                          (0x00000080&((data)<<7))
+#define SYS_PLL_BUS1_REG_PLLBUS_WDRST_src(data)                                      ((0x00000080&(data))>>7)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_WDRST(data)                                      ((0x00000080&(data))>>7)
+#define SYS_PLL_BUS1_REG_PLLBUS_TESTSEL_shift                                        (6)
+#define SYS_PLL_BUS1_REG_PLLBUS_TESTSEL_mask                                         (0x00000040)
+#define SYS_PLL_BUS1_REG_PLLBUS_TESTSEL(data)                                        (0x00000040&((data)<<6))
+#define SYS_PLL_BUS1_REG_PLLBUS_TESTSEL_src(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_TESTSEL(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_BUS1_REG_PLLBUS_SEL_CCO_shift                                        (5)
+#define SYS_PLL_BUS1_REG_PLLBUS_SEL_CCO_mask                                         (0x00000020)
+#define SYS_PLL_BUS1_REG_PLLBUS_SEL_CCO(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_BUS1_REG_PLLBUS_SEL_CCO_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_SEL_CCO(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_BPS_shift                                       (4)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_BPS_mask                                        (0x00000010)
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_BPS(data)                                       (0x00000010&((data)<<4))
+#define SYS_PLL_BUS1_REG_PLLBUS_PDIV_BPS_src(data)                                   ((0x00000010&(data))>>4)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_PDIV_BPS(data)                                   ((0x00000010&(data))>>4)
+#define SYS_PLL_BUS1_REG_PLLBUS_DBUG_EN_shift                                        (3)
+#define SYS_PLL_BUS1_REG_PLLBUS_DBUG_EN_mask                                         (0x00000008)
+#define SYS_PLL_BUS1_REG_PLLBUS_DBUG_EN(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_BUS1_REG_PLLBUS_DBUG_EN_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_BUS1_get_REG_PLLBUS_DBUG_EN(data)                                    ((0x00000008&(data))>>3)
+
+
+#define SYS_PLL_BUS2                                                                 0x9800016C
+#define SYS_PLL_BUS2_reg_addr                                                        "0xD800016C"
+#define SYS_PLL_BUS2_reg                                                             0xD800016C
+#define set_SYS_PLL_BUS2_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUS2_reg)=data)
+#define get_SYS_PLL_BUS2_reg   (*((volatile unsigned int*) SYS_PLL_BUS2_reg))
+#define SYS_PLL_BUS2_inst_adr                                                        "0x005B"
+#define SYS_PLL_BUS2_inst                                                            0x005B
+#define SYS_PLL_BUS2_REG_PLLBUS_OEB_shift                                            (2)
+#define SYS_PLL_BUS2_REG_PLLBUS_OEB_mask                                             (0x00000004)
+#define SYS_PLL_BUS2_REG_PLLBUS_OEB(data)                                            (0x00000004&((data)<<2))
+#define SYS_PLL_BUS2_REG_PLLBUS_OEB_src(data)                                        ((0x00000004&(data))>>2)
+#define SYS_PLL_BUS2_get_REG_PLLBUS_OEB(data)                                        ((0x00000004&(data))>>2)
+#define SYS_PLL_BUS2_REG_PLLBUS_RSTB_shift                                           (1)
+#define SYS_PLL_BUS2_REG_PLLBUS_RSTB_mask                                            (0x00000002)
+#define SYS_PLL_BUS2_REG_PLLBUS_RSTB(data)                                           (0x00000002&((data)<<1))
+#define SYS_PLL_BUS2_REG_PLLBUS_RSTB_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_BUS2_get_REG_PLLBUS_RSTB(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_BUS2_REG_PLLBUS_POW_shift                                            (0)
+#define SYS_PLL_BUS2_REG_PLLBUS_POW_mask                                             (0x00000001)
+#define SYS_PLL_BUS2_REG_PLLBUS_POW(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_BUS2_REG_PLLBUS_POW_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_BUS2_get_REG_PLLBUS_POW(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_WDOUT                                                                0x98000170
+#define SYS_PLL_WDOUT_reg_addr                                                       "0xD8000170"
+#define SYS_PLL_WDOUT_reg                                                            0xD8000170
+#define set_SYS_PLL_WDOUT_reg(data)   (*((volatile unsigned int*) SYS_PLL_WDOUT_reg)=data)
+#define get_SYS_PLL_WDOUT_reg   (*((volatile unsigned int*) SYS_PLL_WDOUT_reg))
+#define SYS_PLL_WDOUT_inst_adr                                                       "0x005C"
+#define SYS_PLL_WDOUT_inst                                                           0x005C
+#define SYS_PLL_WDOUT_REG_EDPPLL_WDO_shift                                           (14)
+#define SYS_PLL_WDOUT_REG_EDPPLL_WDO_mask                                            (0x00004000)
+#define SYS_PLL_WDOUT_REG_EDPPLL_WDO(data)                                           (0x00004000&((data)<<14))
+#define SYS_PLL_WDOUT_REG_EDPPLL_WDO_src(data)                                       ((0x00004000&(data))>>14)
+#define SYS_PLL_WDOUT_get_REG_EDPPLL_WDO(data)                                       ((0x00004000&(data))>>14)
+#define SYS_PLL_WDOUT_REG_PIXELPLL_WDO_shift                                         (13)
+#define SYS_PLL_WDOUT_REG_PIXELPLL_WDO_mask                                          (0x00002000)
+#define SYS_PLL_WDOUT_REG_PIXELPLL_WDO(data)                                         (0x00002000&((data)<<13))
+#define SYS_PLL_WDOUT_REG_PIXELPLL_WDO_src(data)                                     ((0x00002000&(data))>>13)
+#define SYS_PLL_WDOUT_get_REG_PIXELPLL_WDO(data)                                     ((0x00002000&(data))>>13)
+#define SYS_PLL_WDOUT_REG_PLLGPU_WDOUT_shift                                         (12)
+#define SYS_PLL_WDOUT_REG_PLLGPU_WDOUT_mask                                          (0x00001000)
+#define SYS_PLL_WDOUT_REG_PLLGPU_WDOUT(data)                                         (0x00001000&((data)<<12))
+#define SYS_PLL_WDOUT_REG_PLLGPU_WDOUT_src(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PLL_WDOUT_get_REG_PLLGPU_WDOUT(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_H_shift                                       (10)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_H_mask                                        (0x00000400)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_H(data)                                       (0x00000400&((data)<<10))
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_H_src(data)                                   ((0x00000400&(data))>>10)
+#define SYS_PLL_WDOUT_get_REG_PLLBUS_WDOUT_H(data)                                   ((0x00000400&(data))>>10)
+#define SYS_PLL_WDOUT_REG_PLLVODMA_WDOUT_shift                                       (8)
+#define SYS_PLL_WDOUT_REG_PLLVODMA_WDOUT_mask                                        (0x00000100)
+#define SYS_PLL_WDOUT_REG_PLLVODMA_WDOUT(data)                                       (0x00000100&((data)<<8))
+#define SYS_PLL_WDOUT_REG_PLLVODMA_WDOUT_src(data)                                   ((0x00000100&(data))>>8)
+#define SYS_PLL_WDOUT_get_REG_PLLVODMA_WDOUT(data)                                   ((0x00000100&(data))>>8)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_2_shift                                      (7)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_2_mask                                       (0x00000080)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_2(data)                                      (0x00000080&((data)<<7))
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_2_src(data)                                  ((0x00000080&(data))>>7)
+#define SYS_PLL_WDOUT_get_REG_PLLVCPU_WDOUT_2(data)                                  ((0x00000080&(data))>>7)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_shift                                         (6)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_mask                                          (0x00000040)
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT(data)                                         (0x00000040&((data)<<6))
+#define SYS_PLL_WDOUT_REG_PLLBUS_WDOUT_src(data)                                     ((0x00000040&(data))>>6)
+#define SYS_PLL_WDOUT_get_REG_PLLBUS_WDOUT(data)                                     ((0x00000040&(data))>>6)
+#define SYS_PLL_WDOUT_REG_PLLDDSB_WDOUT_shift                                        (4)
+#define SYS_PLL_WDOUT_REG_PLLDDSB_WDOUT_mask                                         (0x00000010)
+#define SYS_PLL_WDOUT_REG_PLLDDSB_WDOUT(data)                                        (0x00000010&((data)<<4))
+#define SYS_PLL_WDOUT_REG_PLLDDSB_WDOUT_src(data)                                    ((0x00000010&(data))>>4)
+#define SYS_PLL_WDOUT_get_REG_PLLDDSB_WDOUT(data)                                    ((0x00000010&(data))>>4)
+#define SYS_PLL_WDOUT_REG_PLLDDSA_WDOUT_shift                                        (3)
+#define SYS_PLL_WDOUT_REG_PLLDDSA_WDOUT_mask                                         (0x00000008)
+#define SYS_PLL_WDOUT_REG_PLLDDSA_WDOUT(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_WDOUT_REG_PLLDDSA_WDOUT_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_WDOUT_get_REG_PLLDDSA_WDOUT(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_shift                                        (2)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_mask                                         (0x00000004)
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_WDOUT_REG_PLLVCPU_WDOUT_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_WDOUT_get_REG_PLLVCPU_WDOUT(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_WDOUT_REG_PLLACPU_WDOUT_shift                                        (1)
+#define SYS_PLL_WDOUT_REG_PLLACPU_WDOUT_mask                                         (0x00000002)
+#define SYS_PLL_WDOUT_REG_PLLACPU_WDOUT(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_WDOUT_REG_PLLACPU_WDOUT_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_WDOUT_get_REG_PLLACPU_WDOUT(data)                                    ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_DDSB1                                                                0x98000174
+#define SYS_PLL_DDSB1_reg_addr                                                       "0xD8000174"
+#define SYS_PLL_DDSB1_reg                                                            0xD8000174
+#define set_SYS_PLL_DDSB1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDSB1_reg)=data)
+#define get_SYS_PLL_DDSB1_reg   (*((volatile unsigned int*) SYS_PLL_DDSB1_reg))
+#define SYS_PLL_DDSB1_inst_adr                                                       "0x005D"
+#define SYS_PLL_DDSB1_inst                                                           0x005D
+#define SYS_PLL_DDSB1_REG_PLLDDSB_WDMODE_shift                                       (23)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_WDMODE_mask                                        (0x01800000)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_WDMODE(data)                                       (0x01800000&((data)<<23))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_WDMODE_src(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_WDMODE(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_RS_shift                                           (20)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_RS_mask                                            (0x00700000)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_RS(data)                                           (0x00700000&((data)<<20))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_RS_src(data)                                       ((0x00700000&(data))>>20)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_RS(data)                                       ((0x00700000&(data))>>20)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_O_shift                                            (18)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_O_mask                                             (0x000C0000)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_O(data)                                            (0x000C0000&((data)<<18))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_O_src(data)                                        ((0x000C0000&(data))>>18)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_O(data)                                        ((0x000C0000&(data))>>18)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_N_shift                                            (16)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_N_mask                                             (0x00030000)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_N(data)                                            (0x00030000&((data)<<16))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_N_src(data)                                        ((0x00030000&(data))>>16)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_N(data)                                        ((0x00030000&(data))>>16)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_IP_shift                                           (12)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_IP_mask                                            (0x0000F000)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_IP(data)                                           (0x0000F000&((data)<<12))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_IP_src(data)                                       ((0x0000F000&(data))>>12)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_IP(data)                                       ((0x0000F000&(data))>>12)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CS_shift                                           (10)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CS_mask                                            (0x00000C00)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CS(data)                                           (0x00000C00&((data)<<10))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CS_src(data)                                       ((0x00000C00&(data))>>10)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_CS(data)                                       ((0x00000C00&(data))>>10)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CP_shift                                           (8)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CP_mask                                            (0x00000300)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CP(data)                                           (0x00000300&((data)<<8))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_CP_src(data)                                       ((0x00000300&(data))>>8)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_CP(data)                                       ((0x00000300&(data))>>8)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_VCORB_shift                                        (7)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_VCORB_mask                                         (0x00000080)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_VCORB(data)                                        (0x00000080&((data)<<7))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_VCORB_src(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_VCORB(data)                                    ((0x00000080&(data))>>7)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_TST_shift                                          (6)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_TST_mask                                           (0x00000040)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_TST(data)                                          (0x00000040&((data)<<6))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_TST_src(data)                                      ((0x00000040&(data))>>6)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_TST(data)                                      ((0x00000040&(data))>>6)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_PSTST_shift                                        (5)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_PSTST_mask                                         (0x00000020)
+#define SYS_PLL_DDSB1_REG_PLLDDSB_PSTST(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_DDSB1_REG_PLLDDSB_PSTST_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_DDSB1_get_REG_PLLDDSB_PSTST(data)                                    ((0x00000020&(data))>>5)
+
+
+#define SYS_PLL_DDSB2                                                                0x98000178
+#define SYS_PLL_DDSB2_reg_addr                                                       "0xD8000178"
+#define SYS_PLL_DDSB2_reg                                                            0xD8000178
+#define set_SYS_PLL_DDSB2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDSB2_reg)=data)
+#define get_SYS_PLL_DDSB2_reg   (*((volatile unsigned int*) SYS_PLL_DDSB2_reg))
+#define SYS_PLL_DDSB2_inst_adr                                                       "0x005E"
+#define SYS_PLL_DDSB2_inst                                                           0x005E
+#define SYS_PLL_DDSB2_REG_PLLDDSB_OEB_shift                                          (2)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_OEB_mask                                           (0x00000004)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_OEB(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_DDSB2_REG_PLLDDSB_OEB_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DDSB2_get_REG_PLLDDSB_OEB(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_RSTB_shift                                         (1)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_RSTB_mask                                          (0x00000002)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_RSTB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_DDSB2_REG_PLLDDSB_RSTB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DDSB2_get_REG_PLLDDSB_RSTB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_POW_shift                                          (0)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_POW_mask                                           (0x00000001)
+#define SYS_PLL_DDSB2_REG_PLLDDSB_POW(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_DDSB2_REG_PLLDDSB_POW_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_DDSB2_get_REG_PLLDDSB_POW(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PSAUDB1                                                              0x98000188
+#define SYS_PLL_PSAUDB1_reg_addr                                                     "0xD8000188"
+#define SYS_PLL_PSAUDB1_reg                                                          0xD8000188
+#define set_SYS_PLL_PSAUDB1_reg(data)   (*((volatile unsigned int*) SYS_PLL_PSAUDB1_reg)=data)
+#define get_SYS_PLL_PSAUDB1_reg   (*((volatile unsigned int*) SYS_PLL_PSAUDB1_reg))
+#define SYS_PLL_PSAUDB1_inst_adr                                                     "0x0062"
+#define SYS_PLL_PSAUDB1_inst                                                         0x0062
+#define SYS_PLL_PSAUDB1_write_en10_shift                                             (25)
+#define SYS_PLL_PSAUDB1_write_en10_mask                                              (0x02000000)
+#define SYS_PLL_PSAUDB1_write_en10(data)                                             (0x02000000&((data)<<25))
+#define SYS_PLL_PSAUDB1_write_en10_src(data)                                         ((0x02000000&(data))>>25)
+#define SYS_PLL_PSAUDB1_get_write_en10(data)                                         ((0x02000000&(data))>>25)
+#define SYS_PLL_PSAUDB1_pcr_b_smooth_en_shift                                        (24)
+#define SYS_PLL_PSAUDB1_pcr_b_smooth_en_mask                                         (0x01000000)
+#define SYS_PLL_PSAUDB1_pcr_b_smooth_en(data)                                        (0x01000000&((data)<<24))
+#define SYS_PLL_PSAUDB1_pcr_b_smooth_en_src(data)                                    ((0x01000000&(data))>>24)
+#define SYS_PLL_PSAUDB1_get_pcr_b_smooth_en(data)                                    ((0x01000000&(data))>>24)
+#define SYS_PLL_PSAUDB1_write_en9_shift                                              (23)
+#define SYS_PLL_PSAUDB1_write_en9_mask                                               (0x00800000)
+#define SYS_PLL_PSAUDB1_write_en9(data)                                              (0x00800000&((data)<<23))
+#define SYS_PLL_PSAUDB1_write_en9_src(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PLL_PSAUDB1_get_write_en9(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PLL_PSAUDB1_pcr_b_phase_sel_shift                                        (22)
+#define SYS_PLL_PSAUDB1_pcr_b_phase_sel_mask                                         (0x00400000)
+#define SYS_PLL_PSAUDB1_pcr_b_phase_sel(data)                                        (0x00400000&((data)<<22))
+#define SYS_PLL_PSAUDB1_pcr_b_phase_sel_src(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_PSAUDB1_get_pcr_b_phase_sel(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_PSAUDB1_write_en8_shift                                              (21)
+#define SYS_PLL_PSAUDB1_write_en8_mask                                               (0x00200000)
+#define SYS_PLL_PSAUDB1_write_en8(data)                                              (0x00200000&((data)<<21))
+#define SYS_PLL_PSAUDB1_write_en8_src(data)                                          ((0x00200000&(data))>>21)
+#define SYS_PLL_PSAUDB1_get_write_en8(data)                                          ((0x00200000&(data))>>21)
+#define SYS_PLL_PSAUDB1_pcr_b_ctl_en_shift                                           (20)
+#define SYS_PLL_PSAUDB1_pcr_b_ctl_en_mask                                            (0x00100000)
+#define SYS_PLL_PSAUDB1_pcr_b_ctl_en(data)                                           (0x00100000&((data)<<20))
+#define SYS_PLL_PSAUDB1_pcr_b_ctl_en_src(data)                                       ((0x00100000&(data))>>20)
+#define SYS_PLL_PSAUDB1_get_pcr_b_ctl_en(data)                                       ((0x00100000&(data))>>20)
+#define SYS_PLL_PSAUDB1_write_en3_shift                                              (10)
+#define SYS_PLL_PSAUDB1_write_en3_mask                                               (0x00000400)
+#define SYS_PLL_PSAUDB1_write_en3(data)                                              (0x00000400&((data)<<10))
+#define SYS_PLL_PSAUDB1_write_en3_src(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PLL_PSAUDB1_get_write_en3(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_FUPDN_shift                                      (9)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_FUPDN_mask                                       (0x00000200)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_FUPDN(data)                                      (0x00000200&((data)<<9))
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_FUPDN_src(data)                                  ((0x00000200&(data))>>9)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD1B_FUPDN(data)                                  ((0x00000200&(data))>>9)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_DIV_shift                                        (8)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_DIV_mask                                         (0x00000100)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_DIV(data)                                        (0x00000100&((data)<<8))
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_DIV_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD1B_DIV(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_PSAUDB1_write_en2_shift                                              (7)
+#define SYS_PLL_PSAUDB1_write_en2_mask                                               (0x00000080)
+#define SYS_PLL_PSAUDB1_write_en2(data)                                              (0x00000080&((data)<<7))
+#define SYS_PLL_PSAUDB1_write_en2_src(data)                                          ((0x00000080&(data))>>7)
+#define SYS_PLL_PSAUDB1_get_write_en2(data)                                          ((0x00000080&(data))>>7)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_TST_shift                                        (6)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_TST_mask                                         (0x00000040)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_TST(data)                                        (0x00000040&((data)<<6))
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_TST_src(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD1B_TST(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_PSEN_shift                                       (5)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_PSEN_mask                                        (0x00000020)
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_PSEN(data)                                       (0x00000020&((data)<<5))
+#define SYS_PLL_PSAUDB1_REG_PSAUD1B_PSEN_src(data)                                   ((0x00000020&(data))>>5)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD1B_PSEN(data)                                   ((0x00000020&(data))>>5)
+#define SYS_PLL_PSAUDB1_write_en1_shift                                              (4)
+#define SYS_PLL_PSAUDB1_write_en1_mask                                               (0x00000010)
+#define SYS_PLL_PSAUDB1_write_en1(data)                                              (0x00000010&((data)<<4))
+#define SYS_PLL_PSAUDB1_write_en1_src(data)                                          ((0x00000010&(data))>>4)
+#define SYS_PLL_PSAUDB1_get_write_en1(data)                                          ((0x00000010&(data))>>4)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_FUPDN_shift                                      (3)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_FUPDN_mask                                       (0x00000008)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_FUPDN(data)                                      (0x00000008&((data)<<3))
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_FUPDN_src(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD2B_FUPDN(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_DIV_shift                                        (2)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_DIV_mask                                         (0x00000004)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_DIV(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_DIV_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD2B_DIV(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_TST_shift                                        (1)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_TST_mask                                         (0x00000002)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_TST(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_TST_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD2B_TST(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_PSEN_shift                                       (0)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_PSEN_mask                                        (0x00000001)
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_PSEN(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_PSAUDB1_REG_PSAUD2B_PSEN_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_PSAUDB1_get_REG_PSAUD2B_PSEN(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PSAUDB2                                                              0x9800018C
+#define SYS_PLL_PSAUDB2_reg_addr                                                     "0xD800018C"
+#define SYS_PLL_PSAUDB2_reg                                                          0xD800018C
+#define set_SYS_PLL_PSAUDB2_reg(data)   (*((volatile unsigned int*) SYS_PLL_PSAUDB2_reg)=data)
+#define get_SYS_PLL_PSAUDB2_reg   (*((volatile unsigned int*) SYS_PLL_PSAUDB2_reg))
+#define SYS_PLL_PSAUDB2_inst_adr                                                     "0x0063"
+#define SYS_PLL_PSAUDB2_inst                                                         0x0063
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_OEB_shift                                        (3)
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_OEB_mask                                         (0x00000008)
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_OEB(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_OEB_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDB2_get_REG_PSAUD1B_OEB(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_RSTB_shift                                       (2)
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_RSTB_mask                                        (0x00000004)
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_RSTB(data)                                       (0x00000004&((data)<<2))
+#define SYS_PLL_PSAUDB2_REG_PSAUD1B_RSTB_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDB2_get_REG_PSAUD1B_RSTB(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_OEB_shift                                        (1)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_OEB_mask                                         (0x00000002)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_OEB(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_OEB_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDB2_get_REG_PSAUD2B_OEB(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_RSTB_shift                                       (0)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_RSTB_mask                                        (0x00000001)
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_RSTB(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_PSAUDB2_REG_PSAUD2B_RSTB_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_PSAUDB2_get_REG_PSAUD2B_RSTB(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI                                                                 0x98000190
+#define SYS_PLL_HDMI_reg_addr                                                        "0xD8000190"
+#define SYS_PLL_HDMI_reg                                                             0xD8000190
+#define set_SYS_PLL_HDMI_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_reg)=data)
+#define get_SYS_PLL_HDMI_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_reg))
+#define SYS_PLL_HDMI_inst_adr                                                        "0x0064"
+#define SYS_PLL_HDMI_inst                                                            0x0064
+#define SYS_PLL_HDMI_PLLDISP_OEB_shift                                               (8)
+#define SYS_PLL_HDMI_PLLDISP_OEB_mask                                                (0x00000100)
+#define SYS_PLL_HDMI_PLLDISP_OEB(data)                                               (0x00000100&((data)<<8))
+#define SYS_PLL_HDMI_PLLDISP_OEB_src(data)                                           ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_get_PLLDISP_OEB(data)                                           ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_PLLDISP_VCORSTB_shift                                           (7)
+#define SYS_PLL_HDMI_PLLDISP_VCORSTB_mask                                            (0x00000080)
+#define SYS_PLL_HDMI_PLLDISP_VCORSTB(data)                                           (0x00000080&((data)<<7))
+#define SYS_PLL_HDMI_PLLDISP_VCORSTB_src(data)                                       ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_get_PLLDISP_VCORSTB(data)                                       ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_REG_PLL_MHL3_DIV_EN_shift                                       (6)
+#define SYS_PLL_HDMI_REG_PLL_MHL3_DIV_EN_mask                                        (0x00000040)
+#define SYS_PLL_HDMI_REG_PLL_MHL3_DIV_EN(data)                                       (0x00000040&((data)<<6))
+#define SYS_PLL_HDMI_REG_PLL_MHL3_DIV_EN_src(data)                                   ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_get_REG_PLL_MHL3_DIV_EN(data)                                   ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_REG_PLLDISP_RSTB_shift                                          (5)
+#define SYS_PLL_HDMI_REG_PLLDISP_RSTB_mask                                           (0x00000020)
+#define SYS_PLL_HDMI_REG_PLLDISP_RSTB(data)                                          (0x00000020&((data)<<5))
+#define SYS_PLL_HDMI_REG_PLLDISP_RSTB_src(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PLL_HDMI_get_REG_PLLDISP_RSTB(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PLL_HDMI_REG_PLLDISP_POW_shift                                           (4)
+#define SYS_PLL_HDMI_REG_PLLDISP_POW_mask                                            (0x00000010)
+#define SYS_PLL_HDMI_REG_PLLDISP_POW(data)                                           (0x00000010&((data)<<4))
+#define SYS_PLL_HDMI_REG_PLLDISP_POW_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_get_REG_PLLDISP_POW(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_REG_TMDS_POW_shift                                              (3)
+#define SYS_PLL_HDMI_REG_TMDS_POW_mask                                               (0x00000008)
+#define SYS_PLL_HDMI_REG_TMDS_POW(data)                                              (0x00000008&((data)<<3))
+#define SYS_PLL_HDMI_REG_TMDS_POW_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI_get_REG_TMDS_POW(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI_REG_PLL_RSTB_shift                                              (2)
+#define SYS_PLL_HDMI_REG_PLL_RSTB_mask                                               (0x00000004)
+#define SYS_PLL_HDMI_REG_PLL_RSTB(data)                                              (0x00000004&((data)<<2))
+#define SYS_PLL_HDMI_REG_PLL_RSTB_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_HDMI_get_REG_PLL_RSTB(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_HDMI_REG_PLL_POW_shift                                               (1)
+#define SYS_PLL_HDMI_REG_PLL_POW_mask                                                (0x00000002)
+#define SYS_PLL_HDMI_REG_PLL_POW(data)                                               (0x00000002&((data)<<1))
+#define SYS_PLL_HDMI_REG_PLL_POW_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_get_REG_PLL_POW(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN_shift                                            (0)
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN_mask                                             (0x00000001)
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_HDMI_get_REG_HDMI_CK_EN(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI2                                                                0x98000194
+#define SYS_PLL_HDMI2_reg_addr                                                       "0xD8000194"
+#define SYS_PLL_HDMI2_reg                                                            0xD8000194
+#define set_SYS_PLL_HDMI2_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI2_reg)=data)
+#define get_SYS_PLL_HDMI2_reg   (*((volatile unsigned int*) SYS_PLL_HDMI2_reg))
+#define SYS_PLL_HDMI2_inst_adr                                                       "0x0065"
+#define SYS_PLL_HDMI2_inst                                                           0x0065
+#define SYS_PLL_HDMI2_REG_ICO_PDIV2_shift                                            (20)
+#define SYS_PLL_HDMI2_REG_ICO_PDIV2_mask                                             (0x00700000)
+#define SYS_PLL_HDMI2_REG_ICO_PDIV2(data)                                            (0x00700000&((data)<<20))
+#define SYS_PLL_HDMI2_REG_ICO_PDIV2_src(data)                                        ((0x00700000&(data))>>20)
+#define SYS_PLL_HDMI2_get_REG_ICO_PDIV2(data)                                        ((0x00700000&(data))>>20)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV_shift                                             (16)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV_mask                                              (0x000F0000)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV(data)                                             (0x000F0000&((data)<<16))
+#define SYS_PLL_HDMI2_REG_TMDS_DIV_src(data)                                         ((0x000F0000&(data))>>16)
+#define SYS_PLL_HDMI2_get_REG_TMDS_DIV(data)                                         ((0x000F0000&(data))>>16)
+#define SYS_PLL_HDMI2_REG_PLLDISP_N_shift                                            (14)
+#define SYS_PLL_HDMI2_REG_PLLDISP_N_mask                                             (0x0000C000)
+#define SYS_PLL_HDMI2_REG_PLLDISP_N(data)                                            (0x0000C000&((data)<<14))
+#define SYS_PLL_HDMI2_REG_PLLDISP_N_src(data)                                        ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI2_get_REG_PLLDISP_N(data)                                        ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI2_REG_PLLDISP_K_shift                                            (12)
+#define SYS_PLL_HDMI2_REG_PLLDISP_K_mask                                             (0x00003000)
+#define SYS_PLL_HDMI2_REG_PLLDISP_K(data)                                            (0x00003000&((data)<<12))
+#define SYS_PLL_HDMI2_REG_PLLDISP_K_src(data)                                        ((0x00003000&(data))>>12)
+#define SYS_PLL_HDMI2_get_REG_PLLDISP_K(data)                                        ((0x00003000&(data))>>12)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV_shift                                            (4)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV_mask                                             (0x00000FF0)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV(data)                                            (0x00000FF0&((data)<<4))
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV_src(data)                                        ((0x00000FF0&(data))>>4)
+#define SYS_PLL_HDMI2_get_REG_PIXEL_DIV(data)                                        ((0x00000FF0&(data))>>4)
+#define SYS_PLL_HDMI2_REG_PLL_M2_shift                                               (2)
+#define SYS_PLL_HDMI2_REG_PLL_M2_mask                                                (0x0000000C)
+#define SYS_PLL_HDMI2_REG_PLL_M2(data)                                               (0x0000000C&((data)<<2))
+#define SYS_PLL_HDMI2_REG_PLL_M2_src(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI2_get_REG_PLL_M2(data)                                           ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI2_REG_PLL_M1_shift                                               (0)
+#define SYS_PLL_HDMI2_REG_PLL_M1_mask                                                (0x00000003)
+#define SYS_PLL_HDMI2_REG_PLL_M1(data)                                               (0x00000003&((data)<<0))
+#define SYS_PLL_HDMI2_REG_PLL_M1_src(data)                                           ((0x00000003&(data))>>0)
+#define SYS_PLL_HDMI2_get_REG_PLL_M1(data)                                           ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_SDIO1                                                                0x980001A0
+#define SYS_PLL_SDIO1_reg_addr                                                       "0xD80001A0"
+#define SYS_PLL_SDIO1_reg                                                            0xD80001A0
+#define set_SYS_PLL_SDIO1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SDIO1_reg)=data)
+#define get_SYS_PLL_SDIO1_reg   (*((volatile unsigned int*) SYS_PLL_SDIO1_reg))
+#define SYS_PLL_SDIO1_inst_adr                                                       "0x0068"
+#define SYS_PLL_SDIO1_inst                                                           0x0068
+#define SYS_PLL_SDIO1_phsel1_shift                                                   (8)
+#define SYS_PLL_SDIO1_phsel1_mask                                                    (0x00001F00)
+#define SYS_PLL_SDIO1_phsel1(data)                                                   (0x00001F00&((data)<<8))
+#define SYS_PLL_SDIO1_phsel1_src(data)                                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SDIO1_get_phsel1(data)                                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SDIO1_phsel0_shift                                                   (3)
+#define SYS_PLL_SDIO1_phsel0_mask                                                    (0x000000F8)
+#define SYS_PLL_SDIO1_phsel0(data)                                                   (0x000000F8&((data)<<3))
+#define SYS_PLL_SDIO1_phsel0_src(data)                                               ((0x000000F8&(data))>>3)
+#define SYS_PLL_SDIO1_get_phsel0(data)                                               ((0x000000F8&(data))>>3)
+#define SYS_PLL_SDIO1_phrstb_dly_sel_shift                                           (2)
+#define SYS_PLL_SDIO1_phrstb_dly_sel_mask                                            (0x00000004)
+#define SYS_PLL_SDIO1_phrstb_dly_sel(data)                                           (0x00000004&((data)<<2))
+#define SYS_PLL_SDIO1_phrstb_dly_sel_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_SDIO1_get_phrstb_dly_sel(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_SDIO1_phrt0_shift                                                    (1)
+#define SYS_PLL_SDIO1_phrt0_mask                                                     (0x00000002)
+#define SYS_PLL_SDIO1_phrt0(data)                                                    (0x00000002&((data)<<1))
+#define SYS_PLL_SDIO1_phrt0_src(data)                                                ((0x00000002&(data))>>1)
+#define SYS_PLL_SDIO1_get_phrt0(data)                                                ((0x00000002&(data))>>1)
+#define SYS_PLL_SDIO1_bias_en_shift                                                  (0)
+#define SYS_PLL_SDIO1_bias_en_mask                                                   (0x00000001)
+#define SYS_PLL_SDIO1_bias_en(data)                                                  (0x00000001&((data)<<0))
+#define SYS_PLL_SDIO1_bias_en_src(data)                                              ((0x00000001&(data))>>0)
+#define SYS_PLL_SDIO1_get_bias_en(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SDIO2                                                                0x980001A4
+#define SYS_PLL_SDIO2_reg_addr                                                       "0xD80001A4"
+#define SYS_PLL_SDIO2_reg                                                            0xD80001A4
+#define set_SYS_PLL_SDIO2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SDIO2_reg)=data)
+#define get_SYS_PLL_SDIO2_reg   (*((volatile unsigned int*) SYS_PLL_SDIO2_reg))
+#define SYS_PLL_SDIO2_inst_adr                                                       "0x0069"
+#define SYS_PLL_SDIO2_inst                                                           0x0069
+#define SYS_PLL_SDIO2_en_cpnew_shift                                                 (26)
+#define SYS_PLL_SDIO2_en_cpnew_mask                                                  (0x04000000)
+#define SYS_PLL_SDIO2_en_cpnew(data)                                                 (0x04000000&((data)<<26))
+#define SYS_PLL_SDIO2_en_cpnew_src(data)                                             ((0x04000000&(data))>>26)
+#define SYS_PLL_SDIO2_get_en_cpnew(data)                                             ((0x04000000&(data))>>26)
+#define SYS_PLL_SDIO2_ssc_div_ext_f_shift                                            (18)
+#define SYS_PLL_SDIO2_ssc_div_ext_f_mask                                             (0x03FC0000)
+#define SYS_PLL_SDIO2_ssc_div_ext_f(data)                                            (0x03FC0000&((data)<<18))
+#define SYS_PLL_SDIO2_ssc_div_ext_f_src(data)                                        ((0x03FC0000&(data))>>18)
+#define SYS_PLL_SDIO2_get_ssc_div_ext_f(data)                                        ((0x03FC0000&(data))>>18)
+#define SYS_PLL_SDIO2_ssc_div_f_sel_shift                                            (17)
+#define SYS_PLL_SDIO2_ssc_div_f_sel_mask                                             (0x00020000)
+#define SYS_PLL_SDIO2_ssc_div_f_sel(data)                                            (0x00020000&((data)<<17))
+#define SYS_PLL_SDIO2_ssc_div_f_sel_src(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PLL_SDIO2_get_ssc_div_f_sel(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PLL_SDIO2_ssc_8x_en_shift                                                (16)
+#define SYS_PLL_SDIO2_ssc_8x_en_mask                                                 (0x00010000)
+#define SYS_PLL_SDIO2_ssc_8x_en(data)                                                (0x00010000&((data)<<16))
+#define SYS_PLL_SDIO2_ssc_8x_en_src(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_SDIO2_get_ssc_8x_en(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_SDIO2_ssc_depth_shift                                                (13)
+#define SYS_PLL_SDIO2_ssc_depth_mask                                                 (0x0000E000)
+#define SYS_PLL_SDIO2_ssc_depth(data)                                                (0x0000E000&((data)<<13))
+#define SYS_PLL_SDIO2_ssc_depth_src(data)                                            ((0x0000E000&(data))>>13)
+#define SYS_PLL_SDIO2_get_ssc_depth(data)                                            ((0x0000E000&(data))>>13)
+#define SYS_PLL_SDIO2_sscpll_rs_shift                                                (10)
+#define SYS_PLL_SDIO2_sscpll_rs_mask                                                 (0x00001C00)
+#define SYS_PLL_SDIO2_sscpll_rs(data)                                                (0x00001C00&((data)<<10))
+#define SYS_PLL_SDIO2_sscpll_rs_src(data)                                            ((0x00001C00&(data))>>10)
+#define SYS_PLL_SDIO2_get_sscpll_rs(data)                                            ((0x00001C00&(data))>>10)
+#define SYS_PLL_SDIO2_sscpll_icp_shift                                               (5)
+#define SYS_PLL_SDIO2_sscpll_icp_mask                                                (0x000003E0)
+#define SYS_PLL_SDIO2_sscpll_icp(data)                                               (0x000003E0&((data)<<5))
+#define SYS_PLL_SDIO2_sscpll_icp_src(data)                                           ((0x000003E0&(data))>>5)
+#define SYS_PLL_SDIO2_get_sscpll_icp(data)                                           ((0x000003E0&(data))>>5)
+#define SYS_PLL_SDIO2_sscpll_cs1_shift                                               (3)
+#define SYS_PLL_SDIO2_sscpll_cs1_mask                                                (0x00000018)
+#define SYS_PLL_SDIO2_sscpll_cs1(data)                                               (0x00000018&((data)<<3))
+#define SYS_PLL_SDIO2_sscpll_cs1_src(data)                                           ((0x00000018&(data))>>3)
+#define SYS_PLL_SDIO2_get_sscpll_cs1(data)                                           ((0x00000018&(data))>>3)
+#define SYS_PLL_SDIO2_reg_tune11_shift                                               (1)
+#define SYS_PLL_SDIO2_reg_tune11_mask                                                (0x00000006)
+#define SYS_PLL_SDIO2_reg_tune11(data)                                               (0x00000006&((data)<<1))
+#define SYS_PLL_SDIO2_reg_tune11_src(data)                                           ((0x00000006&(data))>>1)
+#define SYS_PLL_SDIO2_get_reg_tune11(data)                                           ((0x00000006&(data))>>1)
+#define SYS_PLL_SDIO2_sscldo_en_shift                                                (0)
+#define SYS_PLL_SDIO2_sscldo_en_mask                                                 (0x00000001)
+#define SYS_PLL_SDIO2_sscldo_en(data)                                                (0x00000001&((data)<<0))
+#define SYS_PLL_SDIO2_sscldo_en_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_PLL_SDIO2_get_sscldo_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SDIO3                                                                0x980001A8
+#define SYS_PLL_SDIO3_reg_addr                                                       "0xD80001A8"
+#define SYS_PLL_SDIO3_reg                                                            0xD80001A8
+#define set_SYS_PLL_SDIO3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SDIO3_reg)=data)
+#define get_SYS_PLL_SDIO3_reg   (*((volatile unsigned int*) SYS_PLL_SDIO3_reg))
+#define SYS_PLL_SDIO3_inst_adr                                                       "0x006A"
+#define SYS_PLL_SDIO3_inst                                                           0x006A
+#define SYS_PLL_SDIO3_ssc_div_n_shift                                                (16)
+#define SYS_PLL_SDIO3_ssc_div_n_mask                                                 (0x03FF0000)
+#define SYS_PLL_SDIO3_ssc_div_n(data)                                                (0x03FF0000&((data)<<16))
+#define SYS_PLL_SDIO3_ssc_div_n_src(data)                                            ((0x03FF0000&(data))>>16)
+#define SYS_PLL_SDIO3_get_ssc_div_n(data)                                            ((0x03FF0000&(data))>>16)
+#define SYS_PLL_SDIO3_ssc_step_in_shift                                              (8)
+#define SYS_PLL_SDIO3_ssc_step_in_mask                                               (0x00007F00)
+#define SYS_PLL_SDIO3_ssc_step_in(data)                                              (0x00007F00&((data)<<8))
+#define SYS_PLL_SDIO3_ssc_step_in_src(data)                                          ((0x00007F00&(data))>>8)
+#define SYS_PLL_SDIO3_get_ssc_step_in(data)                                          ((0x00007F00&(data))>>8)
+#define SYS_PLL_SDIO3_ssc_tbase_shift                                                (0)
+#define SYS_PLL_SDIO3_ssc_tbase_mask                                                 (0x000000FF)
+#define SYS_PLL_SDIO3_ssc_tbase(data)                                                (0x000000FF&((data)<<0))
+#define SYS_PLL_SDIO3_ssc_tbase_src(data)                                            ((0x000000FF&(data))>>0)
+#define SYS_PLL_SDIO3_get_ssc_tbase(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SDIO4                                                                0x980001AC
+#define SYS_PLL_SDIO4_reg_addr                                                       "0xD80001AC"
+#define SYS_PLL_SDIO4_reg                                                            0xD80001AC
+#define set_SYS_PLL_SDIO4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SDIO4_reg)=data)
+#define get_SYS_PLL_SDIO4_reg   (*((volatile unsigned int*) SYS_PLL_SDIO4_reg))
+#define SYS_PLL_SDIO4_inst_adr                                                       "0x006B"
+#define SYS_PLL_SDIO4_inst                                                           0x006B
+#define SYS_PLL_SDIO4_ssc_pll_pow_shift                                              (2)
+#define SYS_PLL_SDIO4_ssc_pll_pow_mask                                               (0x00000004)
+#define SYS_PLL_SDIO4_ssc_pll_pow(data)                                              (0x00000004&((data)<<2))
+#define SYS_PLL_SDIO4_ssc_pll_pow_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_SDIO4_get_ssc_pll_pow(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_SDIO4_ssc_pll_rstb_shift                                             (1)
+#define SYS_PLL_SDIO4_ssc_pll_rstb_mask                                              (0x00000002)
+#define SYS_PLL_SDIO4_ssc_pll_rstb(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_SDIO4_ssc_pll_rstb_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SDIO4_get_ssc_pll_rstb(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SDIO4_ssc_rstb_shift                                                 (0)
+#define SYS_PLL_SDIO4_ssc_rstb_mask                                                  (0x00000001)
+#define SYS_PLL_SDIO4_ssc_rstb(data)                                                 (0x00000001&((data)<<0))
+#define SYS_PLL_SDIO4_ssc_rstb_src(data)                                             ((0x00000001&(data))>>0)
+#define SYS_PLL_SDIO4_get_ssc_rstb(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_BUSH1                                                                0x980001B0
+#define SYS_PLL_BUSH1_reg_addr                                                       "0xD80001B0"
+#define SYS_PLL_BUSH1_reg                                                            0xD80001B0
+#define set_SYS_PLL_BUSH1_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUSH1_reg)=data)
+#define get_SYS_PLL_BUSH1_reg   (*((volatile unsigned int*) SYS_PLL_BUSH1_reg))
+#define SYS_PLL_BUSH1_inst_adr                                                       "0x006C"
+#define SYS_PLL_BUSH1_inst                                                           0x006C
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_H_shift                                        (17)
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_H_mask                                         (0x00060000)
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_H(data)                                        (0x00060000&((data)<<17))
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_H_src(data)                                    ((0x00060000&(data))>>17)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_PDIV_H(data)                                    ((0x00060000&(data))>>17)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_RS_H_shift                                      (14)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_RS_H_mask                                       (0x0001C000)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_RS_H(data)                                      (0x0001C000&((data)<<14))
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_RS_H_src(data)                                  ((0x0001C000&(data))>>14)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_LPF_RS_H(data)                                  ((0x0001C000&(data))>>14)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_CS_H_shift                                      (12)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_CS_H_mask                                       (0x00003000)
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_CS_H(data)                                      (0x00003000&((data)<<12))
+#define SYS_PLL_BUSH1_REG_PLLBUS_LPF_CS_H_src(data)                                  ((0x00003000&(data))>>12)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_LPF_CS_H(data)                                  ((0x00003000&(data))>>12)
+#define SYS_PLL_BUSH1_REG_PLLBUS_ICP_H_shift                                         (9)
+#define SYS_PLL_BUSH1_REG_PLLBUS_ICP_H_mask                                          (0x00000E00)
+#define SYS_PLL_BUSH1_REG_PLLBUS_ICP_H(data)                                         (0x00000E00&((data)<<9))
+#define SYS_PLL_BUSH1_REG_PLLBUS_ICP_H_src(data)                                     ((0x00000E00&(data))>>9)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_ICP_H(data)                                     ((0x00000E00&(data))>>9)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDSET_H_shift                                       (8)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDSET_H_mask                                        (0x00000100)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDSET_H(data)                                       (0x00000100&((data)<<8))
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDSET_H_src(data)                                   ((0x00000100&(data))>>8)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_WDSET_H(data)                                   ((0x00000100&(data))>>8)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDRST_H_shift                                       (7)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDRST_H_mask                                        (0x00000080)
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDRST_H(data)                                       (0x00000080&((data)<<7))
+#define SYS_PLL_BUSH1_REG_PLLBUS_WDRST_H_src(data)                                   ((0x00000080&(data))>>7)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_WDRST_H(data)                                   ((0x00000080&(data))>>7)
+#define SYS_PLL_BUSH1_REG_PLLBUS_TESTSEL_H_shift                                     (6)
+#define SYS_PLL_BUSH1_REG_PLLBUS_TESTSEL_H_mask                                      (0x00000040)
+#define SYS_PLL_BUSH1_REG_PLLBUS_TESTSEL_H(data)                                     (0x00000040&((data)<<6))
+#define SYS_PLL_BUSH1_REG_PLLBUS_TESTSEL_H_src(data)                                 ((0x00000040&(data))>>6)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_TESTSEL_H(data)                                 ((0x00000040&(data))>>6)
+#define SYS_PLL_BUSH1_REG_PLLBUS_SEL_CCO_H_shift                                     (5)
+#define SYS_PLL_BUSH1_REG_PLLBUS_SEL_CCO_H_mask                                      (0x00000020)
+#define SYS_PLL_BUSH1_REG_PLLBUS_SEL_CCO_H(data)                                     (0x00000020&((data)<<5))
+#define SYS_PLL_BUSH1_REG_PLLBUS_SEL_CCO_H_src(data)                                 ((0x00000020&(data))>>5)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_SEL_CCO_H(data)                                 ((0x00000020&(data))>>5)
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_BPS_H_shift                                    (4)
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_BPS_H_mask                                     (0x00000010)
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_BPS_H(data)                                    (0x00000010&((data)<<4))
+#define SYS_PLL_BUSH1_REG_PLLBUS_PDIV_BPS_H_src(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_PDIV_BPS_H(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_BUSH1_REG_PLLBUS_DBUG_EN_H_shift                                     (3)
+#define SYS_PLL_BUSH1_REG_PLLBUS_DBUG_EN_H_mask                                      (0x00000008)
+#define SYS_PLL_BUSH1_REG_PLLBUS_DBUG_EN_H(data)                                     (0x00000008&((data)<<3))
+#define SYS_PLL_BUSH1_REG_PLLBUS_DBUG_EN_H_src(data)                                 ((0x00000008&(data))>>3)
+#define SYS_PLL_BUSH1_get_REG_PLLBUS_DBUG_EN_H(data)                                 ((0x00000008&(data))>>3)
+
+
+#define SYS_PLL_BUSH2                                                                0x980001B8
+#define SYS_PLL_BUSH2_reg_addr                                                       "0xD80001B8"
+#define SYS_PLL_BUSH2_reg                                                            0xD80001B8
+#define set_SYS_PLL_BUSH2_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUSH2_reg)=data)
+#define get_SYS_PLL_BUSH2_reg   (*((volatile unsigned int*) SYS_PLL_BUSH2_reg))
+#define SYS_PLL_BUSH2_inst_adr                                                       "0x006E"
+#define SYS_PLL_BUSH2_inst                                                           0x006E
+#define SYS_PLL_BUSH2_REG_PLLBUS_OEB_H_shift                                         (2)
+#define SYS_PLL_BUSH2_REG_PLLBUS_OEB_H_mask                                          (0x00000004)
+#define SYS_PLL_BUSH2_REG_PLLBUS_OEB_H(data)                                         (0x00000004&((data)<<2))
+#define SYS_PLL_BUSH2_REG_PLLBUS_OEB_H_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_BUSH2_get_REG_PLLBUS_OEB_H(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_BUSH2_REG_PLLBUS_RSTB_H_shift                                        (1)
+#define SYS_PLL_BUSH2_REG_PLLBUS_RSTB_H_mask                                         (0x00000002)
+#define SYS_PLL_BUSH2_REG_PLLBUS_RSTB_H(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_BUSH2_REG_PLLBUS_RSTB_H_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_BUSH2_get_REG_PLLBUS_RSTB_H(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_BUSH2_REG_PLLBUS_POW_H_shift                                         (0)
+#define SYS_PLL_BUSH2_REG_PLLBUS_POW_H_mask                                          (0x00000001)
+#define SYS_PLL_BUSH2_REG_PLLBUS_POW_H(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_BUSH2_REG_PLLBUS_POW_H_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_BUSH2_get_REG_PLLBUS_POW_H(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_GPU1                                                                 0x980001C0
+#define SYS_PLL_GPU1_reg_addr                                                        "0xD80001C0"
+#define SYS_PLL_GPU1_reg                                                             0xD80001C0
+#define set_SYS_PLL_GPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_GPU1_reg)=data)
+#define get_SYS_PLL_GPU1_reg   (*((volatile unsigned int*) SYS_PLL_GPU1_reg))
+#define SYS_PLL_GPU1_inst_adr                                                        "0x0070"
+#define SYS_PLL_GPU1_inst                                                            0x0070
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_shift                                           (17)
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_mask                                            (0x00060000)
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV(data)                                           (0x00060000&((data)<<17))
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_src(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_PDIV(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_RS_shift                                         (14)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_RS_mask                                          (0x0001C000)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_RS(data)                                         (0x0001C000&((data)<<14))
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_RS_src(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_LPF_RS(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_CS_shift                                         (12)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_CS_mask                                          (0x00003000)
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_CS(data)                                         (0x00003000&((data)<<12))
+#define SYS_PLL_GPU1_REG_PLLGPU_LPF_CS_src(data)                                     ((0x00003000&(data))>>12)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_LPF_CS(data)                                     ((0x00003000&(data))>>12)
+#define SYS_PLL_GPU1_REG_PLLGPU_ICP_shift                                            (9)
+#define SYS_PLL_GPU1_REG_PLLGPU_ICP_mask                                             (0x00000E00)
+#define SYS_PLL_GPU1_REG_PLLGPU_ICP(data)                                            (0x00000E00&((data)<<9))
+#define SYS_PLL_GPU1_REG_PLLGPU_ICP_src(data)                                        ((0x00000E00&(data))>>9)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_ICP(data)                                        ((0x00000E00&(data))>>9)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST_shift                                          (8)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST_mask                                           (0x00000100)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST(data)                                          (0x00000100&((data)<<8))
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_WDRST(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET_shift                                          (7)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET_mask                                           (0x00000080)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET(data)                                          (0x00000080&((data)<<7))
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET_src(data)                                      ((0x00000080&(data))>>7)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_WDSET(data)                                      ((0x00000080&(data))>>7)
+#define SYS_PLL_GPU1_REG_PLLGPU_TESTSEL_shift                                        (6)
+#define SYS_PLL_GPU1_REG_PLLGPU_TESTSEL_mask                                         (0x00000040)
+#define SYS_PLL_GPU1_REG_PLLGPU_TESTSEL(data)                                        (0x00000040&((data)<<6))
+#define SYS_PLL_GPU1_REG_PLLGPU_TESTSEL_src(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_TESTSEL(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_GPU1_REG_PLLGPU_SEL_CCO_shift                                        (5)
+#define SYS_PLL_GPU1_REG_PLLGPU_SEL_CCO_mask                                         (0x00000020)
+#define SYS_PLL_GPU1_REG_PLLGPU_SEL_CCO(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_GPU1_REG_PLLGPU_SEL_CCO_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_SEL_CCO(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_BPS_shift                                       (4)
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_BPS_mask                                        (0x00000010)
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_BPS(data)                                       (0x00000010&((data)<<4))
+#define SYS_PLL_GPU1_REG_PLLGPU_PDIV_BPS_src(data)                                   ((0x00000010&(data))>>4)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_PDIV_BPS(data)                                   ((0x00000010&(data))>>4)
+#define SYS_PLL_GPU1_REG_PLLGPU_DBUG_EN_shift                                        (3)
+#define SYS_PLL_GPU1_REG_PLLGPU_DBUG_EN_mask                                         (0x00000008)
+#define SYS_PLL_GPU1_REG_PLLGPU_DBUG_EN(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_GPU1_REG_PLLGPU_DBUG_EN_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_DBUG_EN(data)                                    ((0x00000008&(data))>>3)
+
+
+#define SYS_PLL_GPU2                                                                 0x980001C4
+#define SYS_PLL_GPU2_reg_addr                                                        "0xD80001C4"
+#define SYS_PLL_GPU2_reg                                                             0xD80001C4
+#define set_SYS_PLL_GPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_GPU2_reg)=data)
+#define get_SYS_PLL_GPU2_reg   (*((volatile unsigned int*) SYS_PLL_GPU2_reg))
+#define SYS_PLL_GPU2_inst_adr                                                        "0x0071"
+#define SYS_PLL_GPU2_inst                                                            0x0071
+#define SYS_PLL_GPU2_REG_PLLGPU_OEB_shift                                            (2)
+#define SYS_PLL_GPU2_REG_PLLGPU_OEB_mask                                             (0x00000004)
+#define SYS_PLL_GPU2_REG_PLLGPU_OEB(data)                                            (0x00000004&((data)<<2))
+#define SYS_PLL_GPU2_REG_PLLGPU_OEB_src(data)                                        ((0x00000004&(data))>>2)
+#define SYS_PLL_GPU2_get_REG_PLLGPU_OEB(data)                                        ((0x00000004&(data))>>2)
+#define SYS_PLL_GPU2_REG_PLLGPU_RSTB_shift                                           (1)
+#define SYS_PLL_GPU2_REG_PLLGPU_RSTB_mask                                            (0x00000002)
+#define SYS_PLL_GPU2_REG_PLLGPU_RSTB(data)                                           (0x00000002&((data)<<1))
+#define SYS_PLL_GPU2_REG_PLLGPU_RSTB_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_GPU2_get_REG_PLLGPU_RSTB(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_GPU2_REG_PLLGPU_POW_shift                                            (0)
+#define SYS_PLL_GPU2_REG_PLLGPU_POW_mask                                             (0x00000001)
+#define SYS_PLL_GPU2_REG_PLLGPU_POW(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_GPU2_REG_PLLGPU_POW_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_GPU2_get_REG_PLLGPU_POW(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VE2_1                                                                0x980001D0
+#define SYS_PLL_VE2_1_reg_addr                                                       "0xD80001D0"
+#define SYS_PLL_VE2_1_reg                                                            0xD80001D0
+#define set_SYS_PLL_VE2_1_reg(data)   (*((volatile unsigned int*) SYS_PLL_VE2_1_reg)=data)
+#define get_SYS_PLL_VE2_1_reg   (*((volatile unsigned int*) SYS_PLL_VE2_1_reg))
+#define SYS_PLL_VE2_1_inst_adr                                                       "0x0074"
+#define SYS_PLL_VE2_1_inst                                                           0x0074
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDRST_2_shift                                      (22)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDRST_2_mask                                       (0x00400000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDRST_2(data)                                      (0x00400000&((data)<<22))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDRST_2_src(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_WDRST_2(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDSET_2_shift                                      (21)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDSET_2_mask                                       (0x00200000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDSET_2(data)                                      (0x00200000&((data)<<21))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_WDSET_2_src(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_WDSET_2(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_CS_2_shift                                         (19)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_CS_2_mask                                          (0x00180000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_CS_2(data)                                         (0x00180000&((data)<<19))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_CS_2_src(data)                                     ((0x00180000&(data))>>19)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_CS_2(data)                                     ((0x00180000&(data))>>19)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_O_2_shift                                          (17)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_O_2_mask                                           (0x00060000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_O_2(data)                                          (0x00060000&((data)<<17))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_O_2_src(data)                                      ((0x00060000&(data))>>17)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_O_2(data)                                      ((0x00060000&(data))>>17)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_RS_2_shift                                         (14)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_RS_2_mask                                          (0x0001C000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_RS_2(data)                                         (0x0001C000&((data)<<14))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_RS_2_src(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_RS_2(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_N_2_shift                                          (12)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_N_2_mask                                           (0x00003000)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_N_2(data)                                          (0x00003000&((data)<<12))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_N_2_src(data)                                      ((0x00003000&(data))>>12)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_N_2(data)                                      ((0x00003000&(data))>>12)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_M_2_shift                                          (4)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_M_2_mask                                           (0x00000FF0)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_M_2(data)                                          (0x00000FF0&((data)<<4))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_M_2_src(data)                                      ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_M_2(data)                                      ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_IP_2_shift                                         (1)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_IP_2_mask                                          (0x0000000E)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_IP_2(data)                                         (0x0000000E&((data)<<1))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_IP_2_src(data)                                     ((0x0000000E&(data))>>1)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_IP_2(data)                                     ((0x0000000E&(data))>>1)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_TST_2_shift                                        (0)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_TST_2_mask                                         (0x00000001)
+#define SYS_PLL_VE2_1_REG_PLLVCPU_TST_2(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_VE2_1_REG_PLLVCPU_TST_2_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_VE2_1_get_REG_PLLVCPU_TST_2(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VE2_2                                                                0x980001D4
+#define SYS_PLL_VE2_2_reg_addr                                                       "0xD80001D4"
+#define SYS_PLL_VE2_2_reg                                                            0xD80001D4
+#define set_SYS_PLL_VE2_2_reg(data)   (*((volatile unsigned int*) SYS_PLL_VE2_2_reg)=data)
+#define get_SYS_PLL_VE2_2_reg   (*((volatile unsigned int*) SYS_PLL_VE2_2_reg))
+#define SYS_PLL_VE2_2_inst_adr                                                       "0x0075"
+#define SYS_PLL_VE2_2_inst                                                           0x0075
+#define SYS_PLL_VE2_2_REG_PLLVCPU_OEB_2_shift                                        (2)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_OEB_2_mask                                         (0x00000004)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_OEB_2(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_VE2_2_REG_PLLVCPU_OEB_2_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_VE2_2_get_REG_PLLVCPU_OEB_2(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_RSTB_2_shift                                       (1)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_RSTB_2_mask                                        (0x00000002)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_RSTB_2(data)                                       (0x00000002&((data)<<1))
+#define SYS_PLL_VE2_2_REG_PLLVCPU_RSTB_2_src(data)                                   ((0x00000002&(data))>>1)
+#define SYS_PLL_VE2_2_get_REG_PLLVCPU_RSTB_2(data)                                   ((0x00000002&(data))>>1)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_POW_2_shift                                        (0)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_POW_2_mask                                         (0x00000001)
+#define SYS_PLL_VE2_2_REG_PLLVCPU_POW_2(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_VE2_2_REG_PLLVCPU_POW_2_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_VE2_2_get_REG_PLLVCPU_POW_2(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SD1                                                                  0x980001E0
+#define SYS_PLL_SD1_reg_addr                                                         "0xD80001E0"
+#define SYS_PLL_SD1_reg                                                              0xD80001E0
+#define set_SYS_PLL_SD1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD1_reg)=data)
+#define get_SYS_PLL_SD1_reg   (*((volatile unsigned int*) SYS_PLL_SD1_reg))
+#define SYS_PLL_SD1_inst_adr                                                         "0x0078"
+#define SYS_PLL_SD1_inst                                                             0x0078
+#define SYS_PLL_SD1_reg_sel3318_shift                                                (13)
+#define SYS_PLL_SD1_reg_sel3318_mask                                                 (0x00006000)
+#define SYS_PLL_SD1_reg_sel3318(data)                                                (0x00006000&((data)<<13))
+#define SYS_PLL_SD1_reg_sel3318_src(data)                                            ((0x00006000&(data))>>13)
+#define SYS_PLL_SD1_get_reg_sel3318(data)                                            ((0x00006000&(data))>>13)
+#define SYS_PLL_SD1_phsel1_shift                                                     (8)
+#define SYS_PLL_SD1_phsel1_mask                                                      (0x00001F00)
+#define SYS_PLL_SD1_phsel1(data)                                                     (0x00001F00&((data)<<8))
+#define SYS_PLL_SD1_phsel1_src(data)                                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SD1_get_phsel1(data)                                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SD1_phsel0_shift                                                     (3)
+#define SYS_PLL_SD1_phsel0_mask                                                      (0x000000F8)
+#define SYS_PLL_SD1_phsel0(data)                                                     (0x000000F8&((data)<<3))
+#define SYS_PLL_SD1_phsel0_src(data)                                                 ((0x000000F8&(data))>>3)
+#define SYS_PLL_SD1_get_phsel0(data)                                                 ((0x000000F8&(data))>>3)
+#define SYS_PLL_SD1_phrstb_dly_sel_shift                                             (2)
+#define SYS_PLL_SD1_phrstb_dly_sel_mask                                              (0x00000004)
+#define SYS_PLL_SD1_phrstb_dly_sel(data)                                             (0x00000004&((data)<<2))
+#define SYS_PLL_SD1_phrstb_dly_sel_src(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SD1_get_phrstb_dly_sel(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SD1_phrt0_shift                                                      (1)
+#define SYS_PLL_SD1_phrt0_mask                                                       (0x00000002)
+#define SYS_PLL_SD1_phrt0(data)                                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SD1_phrt0_src(data)                                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SD1_get_phrt0(data)                                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SD1_bias_en_shift                                                    (0)
+#define SYS_PLL_SD1_bias_en_mask                                                     (0x00000001)
+#define SYS_PLL_SD1_bias_en(data)                                                    (0x00000001&((data)<<0))
+#define SYS_PLL_SD1_bias_en_src(data)                                                ((0x00000001&(data))>>0)
+#define SYS_PLL_SD1_get_bias_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SD2                                                                  0x980001E4
+#define SYS_PLL_SD2_reg_addr                                                         "0xD80001E4"
+#define SYS_PLL_SD2_reg                                                              0xD80001E4
+#define set_SYS_PLL_SD2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD2_reg)=data)
+#define get_SYS_PLL_SD2_reg   (*((volatile unsigned int*) SYS_PLL_SD2_reg))
+#define SYS_PLL_SD2_inst_adr                                                         "0x0079"
+#define SYS_PLL_SD2_inst                                                             0x0079
+#define SYS_PLL_SD2_en_cpnew_shift                                                   (26)
+#define SYS_PLL_SD2_en_cpnew_mask                                                    (0x04000000)
+#define SYS_PLL_SD2_en_cpnew(data)                                                   (0x04000000&((data)<<26))
+#define SYS_PLL_SD2_en_cpnew_src(data)                                               ((0x04000000&(data))>>26)
+#define SYS_PLL_SD2_get_en_cpnew(data)                                               ((0x04000000&(data))>>26)
+#define SYS_PLL_SD2_ssc_div_ext_f_shift                                              (18)
+#define SYS_PLL_SD2_ssc_div_ext_f_mask                                               (0x03FC0000)
+#define SYS_PLL_SD2_ssc_div_ext_f(data)                                              (0x03FC0000&((data)<<18))
+#define SYS_PLL_SD2_ssc_div_ext_f_src(data)                                          ((0x03FC0000&(data))>>18)
+#define SYS_PLL_SD2_get_ssc_div_ext_f(data)                                          ((0x03FC0000&(data))>>18)
+#define SYS_PLL_SD2_ssc_div_f_sel_shift                                              (17)
+#define SYS_PLL_SD2_ssc_div_f_sel_mask                                               (0x00020000)
+#define SYS_PLL_SD2_ssc_div_f_sel(data)                                              (0x00020000&((data)<<17))
+#define SYS_PLL_SD2_ssc_div_f_sel_src(data)                                          ((0x00020000&(data))>>17)
+#define SYS_PLL_SD2_get_ssc_div_f_sel(data)                                          ((0x00020000&(data))>>17)
+#define SYS_PLL_SD2_ssc_8x_en_shift                                                  (16)
+#define SYS_PLL_SD2_ssc_8x_en_mask                                                   (0x00010000)
+#define SYS_PLL_SD2_ssc_8x_en(data)                                                  (0x00010000&((data)<<16))
+#define SYS_PLL_SD2_ssc_8x_en_src(data)                                              ((0x00010000&(data))>>16)
+#define SYS_PLL_SD2_get_ssc_8x_en(data)                                              ((0x00010000&(data))>>16)
+#define SYS_PLL_SD2_ssc_depth_shift                                                  (13)
+#define SYS_PLL_SD2_ssc_depth_mask                                                   (0x0000E000)
+#define SYS_PLL_SD2_ssc_depth(data)                                                  (0x0000E000&((data)<<13))
+#define SYS_PLL_SD2_ssc_depth_src(data)                                              ((0x0000E000&(data))>>13)
+#define SYS_PLL_SD2_get_ssc_depth(data)                                              ((0x0000E000&(data))>>13)
+#define SYS_PLL_SD2_sscpll_rs_shift                                                  (10)
+#define SYS_PLL_SD2_sscpll_rs_mask                                                   (0x00001C00)
+#define SYS_PLL_SD2_sscpll_rs(data)                                                  (0x00001C00&((data)<<10))
+#define SYS_PLL_SD2_sscpll_rs_src(data)                                              ((0x00001C00&(data))>>10)
+#define SYS_PLL_SD2_get_sscpll_rs(data)                                              ((0x00001C00&(data))>>10)
+#define SYS_PLL_SD2_sscpll_icp_shift                                                 (5)
+#define SYS_PLL_SD2_sscpll_icp_mask                                                  (0x000003E0)
+#define SYS_PLL_SD2_sscpll_icp(data)                                                 (0x000003E0&((data)<<5))
+#define SYS_PLL_SD2_sscpll_icp_src(data)                                             ((0x000003E0&(data))>>5)
+#define SYS_PLL_SD2_get_sscpll_icp(data)                                             ((0x000003E0&(data))>>5)
+#define SYS_PLL_SD2_sscpll_cs1_shift                                                 (3)
+#define SYS_PLL_SD2_sscpll_cs1_mask                                                  (0x00000018)
+#define SYS_PLL_SD2_sscpll_cs1(data)                                                 (0x00000018&((data)<<3))
+#define SYS_PLL_SD2_sscpll_cs1_src(data)                                             ((0x00000018&(data))>>3)
+#define SYS_PLL_SD2_get_sscpll_cs1(data)                                             ((0x00000018&(data))>>3)
+#define SYS_PLL_SD2_reg_tune11_shift                                                 (1)
+#define SYS_PLL_SD2_reg_tune11_mask                                                  (0x00000006)
+#define SYS_PLL_SD2_reg_tune11(data)                                                 (0x00000006&((data)<<1))
+#define SYS_PLL_SD2_reg_tune11_src(data)                                             ((0x00000006&(data))>>1)
+#define SYS_PLL_SD2_get_reg_tune11(data)                                             ((0x00000006&(data))>>1)
+#define SYS_PLL_SD2_sscldo_en_shift                                                  (0)
+#define SYS_PLL_SD2_sscldo_en_mask                                                   (0x00000001)
+#define SYS_PLL_SD2_sscldo_en(data)                                                  (0x00000001&((data)<<0))
+#define SYS_PLL_SD2_sscldo_en_src(data)                                              ((0x00000001&(data))>>0)
+#define SYS_PLL_SD2_get_sscldo_en(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SD3                                                                  0x980001E8
+#define SYS_PLL_SD3_reg_addr                                                         "0xD80001E8"
+#define SYS_PLL_SD3_reg                                                              0xD80001E8
+#define set_SYS_PLL_SD3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD3_reg)=data)
+#define get_SYS_PLL_SD3_reg   (*((volatile unsigned int*) SYS_PLL_SD3_reg))
+#define SYS_PLL_SD3_inst_adr                                                         "0x007A"
+#define SYS_PLL_SD3_inst                                                             0x007A
+#define SYS_PLL_SD3_ssc_div_n_shift                                                  (16)
+#define SYS_PLL_SD3_ssc_div_n_mask                                                   (0x03FF0000)
+#define SYS_PLL_SD3_ssc_div_n(data)                                                  (0x03FF0000&((data)<<16))
+#define SYS_PLL_SD3_ssc_div_n_src(data)                                              ((0x03FF0000&(data))>>16)
+#define SYS_PLL_SD3_get_ssc_div_n(data)                                              ((0x03FF0000&(data))>>16)
+#define SYS_PLL_SD3_ssc_step_in_shift                                                (8)
+#define SYS_PLL_SD3_ssc_step_in_mask                                                 (0x00007F00)
+#define SYS_PLL_SD3_ssc_step_in(data)                                                (0x00007F00&((data)<<8))
+#define SYS_PLL_SD3_ssc_step_in_src(data)                                            ((0x00007F00&(data))>>8)
+#define SYS_PLL_SD3_get_ssc_step_in(data)                                            ((0x00007F00&(data))>>8)
+#define SYS_PLL_SD3_ssc_tbase_shift                                                  (0)
+#define SYS_PLL_SD3_ssc_tbase_mask                                                   (0x000000FF)
+#define SYS_PLL_SD3_ssc_tbase(data)                                                  (0x000000FF&((data)<<0))
+#define SYS_PLL_SD3_ssc_tbase_src(data)                                              ((0x000000FF&(data))>>0)
+#define SYS_PLL_SD3_get_ssc_tbase(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SD4                                                                  0x980001EC
+#define SYS_PLL_SD4_reg_addr                                                         "0xD80001EC"
+#define SYS_PLL_SD4_reg                                                              0xD80001EC
+#define set_SYS_PLL_SD4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD4_reg)=data)
+#define get_SYS_PLL_SD4_reg   (*((volatile unsigned int*) SYS_PLL_SD4_reg))
+#define SYS_PLL_SD4_inst_adr                                                         "0x007B"
+#define SYS_PLL_SD4_inst                                                             0x007B
+#define SYS_PLL_SD4_ssc_pll_pow_shift                                                (2)
+#define SYS_PLL_SD4_ssc_pll_pow_mask                                                 (0x00000004)
+#define SYS_PLL_SD4_ssc_pll_pow(data)                                                (0x00000004&((data)<<2))
+#define SYS_PLL_SD4_ssc_pll_pow_src(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_SD4_get_ssc_pll_pow(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_SD4_ssc_pll_rstb_shift                                               (1)
+#define SYS_PLL_SD4_ssc_pll_rstb_mask                                                (0x00000002)
+#define SYS_PLL_SD4_ssc_pll_rstb(data)                                               (0x00000002&((data)<<1))
+#define SYS_PLL_SD4_ssc_pll_rstb_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_SD4_get_ssc_pll_rstb(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_SD4_ssc_rstb_shift                                                   (0)
+#define SYS_PLL_SD4_ssc_rstb_mask                                                    (0x00000001)
+#define SYS_PLL_SD4_ssc_rstb(data)                                                   (0x00000001&((data)<<0))
+#define SYS_PLL_SD4_ssc_rstb_src(data)                                               ((0x00000001&(data))>>0)
+#define SYS_PLL_SD4_get_ssc_rstb(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EMMC1                                                                0x980001F0
+#define SYS_PLL_EMMC1_reg_addr                                                       "0xD80001F0"
+#define SYS_PLL_EMMC1_reg                                                            0xD80001F0
+#define set_SYS_PLL_EMMC1_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC1_reg)=data)
+#define get_SYS_PLL_EMMC1_reg   (*((volatile unsigned int*) SYS_PLL_EMMC1_reg))
+#define SYS_PLL_EMMC1_inst_adr                                                       "0x007C"
+#define SYS_PLL_EMMC1_inst                                                           0x007C
+#define SYS_PLL_EMMC1_phsel1_shift                                                   (8)
+#define SYS_PLL_EMMC1_phsel1_mask                                                    (0x00001F00)
+#define SYS_PLL_EMMC1_phsel1(data)                                                   (0x00001F00&((data)<<8))
+#define SYS_PLL_EMMC1_phsel1_src(data)                                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_EMMC1_get_phsel1(data)                                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_EMMC1_phsel0_shift                                                   (3)
+#define SYS_PLL_EMMC1_phsel0_mask                                                    (0x000000F8)
+#define SYS_PLL_EMMC1_phsel0(data)                                                   (0x000000F8&((data)<<3))
+#define SYS_PLL_EMMC1_phsel0_src(data)                                               ((0x000000F8&(data))>>3)
+#define SYS_PLL_EMMC1_get_phsel0(data)                                               ((0x000000F8&(data))>>3)
+#define SYS_PLL_EMMC1_phrstb_dly_sel_shift                                           (2)
+#define SYS_PLL_EMMC1_phrstb_dly_sel_mask                                            (0x00000004)
+#define SYS_PLL_EMMC1_phrstb_dly_sel(data)                                           (0x00000004&((data)<<2))
+#define SYS_PLL_EMMC1_phrstb_dly_sel_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC1_get_phrstb_dly_sel(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC1_phrt0_shift                                                    (1)
+#define SYS_PLL_EMMC1_phrt0_mask                                                     (0x00000002)
+#define SYS_PLL_EMMC1_phrt0(data)                                                    (0x00000002&((data)<<1))
+#define SYS_PLL_EMMC1_phrt0_src(data)                                                ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC1_get_phrt0(data)                                                ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC1_bias_en_shift                                                  (0)
+#define SYS_PLL_EMMC1_bias_en_mask                                                   (0x00000001)
+#define SYS_PLL_EMMC1_bias_en(data)                                                  (0x00000001&((data)<<0))
+#define SYS_PLL_EMMC1_bias_en_src(data)                                              ((0x00000001&(data))>>0)
+#define SYS_PLL_EMMC1_get_bias_en(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EMMC2                                                                0x980001F4
+#define SYS_PLL_EMMC2_reg_addr                                                       "0xD80001F4"
+#define SYS_PLL_EMMC2_reg                                                            0xD80001F4
+#define set_SYS_PLL_EMMC2_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC2_reg)=data)
+#define get_SYS_PLL_EMMC2_reg   (*((volatile unsigned int*) SYS_PLL_EMMC2_reg))
+#define SYS_PLL_EMMC2_inst_adr                                                       "0x007D"
+#define SYS_PLL_EMMC2_inst                                                           0x007D
+#define SYS_PLL_EMMC2_en_cpnew_shift                                                 (26)
+#define SYS_PLL_EMMC2_en_cpnew_mask                                                  (0x04000000)
+#define SYS_PLL_EMMC2_en_cpnew(data)                                                 (0x04000000&((data)<<26))
+#define SYS_PLL_EMMC2_en_cpnew_src(data)                                             ((0x04000000&(data))>>26)
+#define SYS_PLL_EMMC2_get_en_cpnew(data)                                             ((0x04000000&(data))>>26)
+#define SYS_PLL_EMMC2_ssc_div_ext_f_shift                                            (18)
+#define SYS_PLL_EMMC2_ssc_div_ext_f_mask                                             (0x03FC0000)
+#define SYS_PLL_EMMC2_ssc_div_ext_f(data)                                            (0x03FC0000&((data)<<18))
+#define SYS_PLL_EMMC2_ssc_div_ext_f_src(data)                                        ((0x03FC0000&(data))>>18)
+#define SYS_PLL_EMMC2_get_ssc_div_ext_f(data)                                        ((0x03FC0000&(data))>>18)
+#define SYS_PLL_EMMC2_ssc_div_f_sel_shift                                            (17)
+#define SYS_PLL_EMMC2_ssc_div_f_sel_mask                                             (0x00020000)
+#define SYS_PLL_EMMC2_ssc_div_f_sel(data)                                            (0x00020000&((data)<<17))
+#define SYS_PLL_EMMC2_ssc_div_f_sel_src(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PLL_EMMC2_get_ssc_div_f_sel(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PLL_EMMC2_ssc_8x_en_shift                                                (16)
+#define SYS_PLL_EMMC2_ssc_8x_en_mask                                                 (0x00010000)
+#define SYS_PLL_EMMC2_ssc_8x_en(data)                                                (0x00010000&((data)<<16))
+#define SYS_PLL_EMMC2_ssc_8x_en_src(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_EMMC2_get_ssc_8x_en(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_EMMC2_ssc_depth_shift                                                (13)
+#define SYS_PLL_EMMC2_ssc_depth_mask                                                 (0x0000E000)
+#define SYS_PLL_EMMC2_ssc_depth(data)                                                (0x0000E000&((data)<<13))
+#define SYS_PLL_EMMC2_ssc_depth_src(data)                                            ((0x0000E000&(data))>>13)
+#define SYS_PLL_EMMC2_get_ssc_depth(data)                                            ((0x0000E000&(data))>>13)
+#define SYS_PLL_EMMC2_sscpll_rs_shift                                                (10)
+#define SYS_PLL_EMMC2_sscpll_rs_mask                                                 (0x00001C00)
+#define SYS_PLL_EMMC2_sscpll_rs(data)                                                (0x00001C00&((data)<<10))
+#define SYS_PLL_EMMC2_sscpll_rs_src(data)                                            ((0x00001C00&(data))>>10)
+#define SYS_PLL_EMMC2_get_sscpll_rs(data)                                            ((0x00001C00&(data))>>10)
+#define SYS_PLL_EMMC2_sscpll_icp_shift                                               (5)
+#define SYS_PLL_EMMC2_sscpll_icp_mask                                                (0x000003E0)
+#define SYS_PLL_EMMC2_sscpll_icp(data)                                               (0x000003E0&((data)<<5))
+#define SYS_PLL_EMMC2_sscpll_icp_src(data)                                           ((0x000003E0&(data))>>5)
+#define SYS_PLL_EMMC2_get_sscpll_icp(data)                                           ((0x000003E0&(data))>>5)
+#define SYS_PLL_EMMC2_sscpll_cs1_shift                                               (3)
+#define SYS_PLL_EMMC2_sscpll_cs1_mask                                                (0x00000018)
+#define SYS_PLL_EMMC2_sscpll_cs1(data)                                               (0x00000018&((data)<<3))
+#define SYS_PLL_EMMC2_sscpll_cs1_src(data)                                           ((0x00000018&(data))>>3)
+#define SYS_PLL_EMMC2_get_sscpll_cs1(data)                                           ((0x00000018&(data))>>3)
+#define SYS_PLL_EMMC2_reg_tune11_shift                                               (1)
+#define SYS_PLL_EMMC2_reg_tune11_mask                                                (0x00000006)
+#define SYS_PLL_EMMC2_reg_tune11(data)                                               (0x00000006&((data)<<1))
+#define SYS_PLL_EMMC2_reg_tune11_src(data)                                           ((0x00000006&(data))>>1)
+#define SYS_PLL_EMMC2_get_reg_tune11(data)                                           ((0x00000006&(data))>>1)
+#define SYS_PLL_EMMC2_sscldo_en_shift                                                (0)
+#define SYS_PLL_EMMC2_sscldo_en_mask                                                 (0x00000001)
+#define SYS_PLL_EMMC2_sscldo_en(data)                                                (0x00000001&((data)<<0))
+#define SYS_PLL_EMMC2_sscldo_en_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_PLL_EMMC2_get_sscldo_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EMMC3                                                                0x980001F8
+#define SYS_PLL_EMMC3_reg_addr                                                       "0xD80001F8"
+#define SYS_PLL_EMMC3_reg                                                            0xD80001F8
+#define set_SYS_PLL_EMMC3_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC3_reg)=data)
+#define get_SYS_PLL_EMMC3_reg   (*((volatile unsigned int*) SYS_PLL_EMMC3_reg))
+#define SYS_PLL_EMMC3_inst_adr                                                       "0x007E"
+#define SYS_PLL_EMMC3_inst                                                           0x007E
+#define SYS_PLL_EMMC3_ssc_div_n_shift                                                (16)
+#define SYS_PLL_EMMC3_ssc_div_n_mask                                                 (0x03FF0000)
+#define SYS_PLL_EMMC3_ssc_div_n(data)                                                (0x03FF0000&((data)<<16))
+#define SYS_PLL_EMMC3_ssc_div_n_src(data)                                            ((0x03FF0000&(data))>>16)
+#define SYS_PLL_EMMC3_get_ssc_div_n(data)                                            ((0x03FF0000&(data))>>16)
+#define SYS_PLL_EMMC3_ssc_step_in_shift                                              (8)
+#define SYS_PLL_EMMC3_ssc_step_in_mask                                               (0x00007F00)
+#define SYS_PLL_EMMC3_ssc_step_in(data)                                              (0x00007F00&((data)<<8))
+#define SYS_PLL_EMMC3_ssc_step_in_src(data)                                          ((0x00007F00&(data))>>8)
+#define SYS_PLL_EMMC3_get_ssc_step_in(data)                                          ((0x00007F00&(data))>>8)
+#define SYS_PLL_EMMC3_ssc_tbase_shift                                                (0)
+#define SYS_PLL_EMMC3_ssc_tbase_mask                                                 (0x000000FF)
+#define SYS_PLL_EMMC3_ssc_tbase(data)                                                (0x000000FF&((data)<<0))
+#define SYS_PLL_EMMC3_ssc_tbase_src(data)                                            ((0x000000FF&(data))>>0)
+#define SYS_PLL_EMMC3_get_ssc_tbase(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_EMMC4                                                                0x980001FC
+#define SYS_PLL_EMMC4_reg_addr                                                       "0xD80001FC"
+#define SYS_PLL_EMMC4_reg                                                            0xD80001FC
+#define set_SYS_PLL_EMMC4_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC4_reg)=data)
+#define get_SYS_PLL_EMMC4_reg   (*((volatile unsigned int*) SYS_PLL_EMMC4_reg))
+#define SYS_PLL_EMMC4_inst_adr                                                       "0x007F"
+#define SYS_PLL_EMMC4_inst                                                           0x007F
+#define SYS_PLL_EMMC4_ssc_pll_pow_shift                                              (2)
+#define SYS_PLL_EMMC4_ssc_pll_pow_mask                                               (0x00000004)
+#define SYS_PLL_EMMC4_ssc_pll_pow(data)                                              (0x00000004&((data)<<2))
+#define SYS_PLL_EMMC4_ssc_pll_pow_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC4_get_ssc_pll_pow(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC4_ssc_pll_rstb_shift                                             (1)
+#define SYS_PLL_EMMC4_ssc_pll_rstb_mask                                              (0x00000002)
+#define SYS_PLL_EMMC4_ssc_pll_rstb(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_EMMC4_ssc_pll_rstb_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC4_get_ssc_pll_rstb(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC4_ssc_rstb_shift                                                 (0)
+#define SYS_PLL_EMMC4_ssc_rstb_mask                                                  (0x00000001)
+#define SYS_PLL_EMMC4_ssc_rstb(data)                                                 (0x00000001&((data)<<0))
+#define SYS_PLL_EMMC4_ssc_rstb_src(data)                                             ((0x00000001&(data))>>0)
+#define SYS_PLL_EMMC4_get_ssc_rstb(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_OTHER                                                                0x98000200
+#define SYS_PLL_OTHER_reg_addr                                                       "0xD8000200"
+#define SYS_PLL_OTHER_reg                                                            0xD8000200
+#define set_SYS_PLL_OTHER_reg(data)   (*((volatile unsigned int*) SYS_PLL_OTHER_reg)=data)
+#define get_SYS_PLL_OTHER_reg   (*((volatile unsigned int*) SYS_PLL_OTHER_reg))
+#define SYS_PLL_OTHER_inst_adr                                                       "0x0080"
+#define SYS_PLL_OTHER_inst                                                           0x0080
+#define SYS_PLL_OTHER_REG_TEST_SEL_shift                                             (12)
+#define SYS_PLL_OTHER_REG_TEST_SEL_mask                                              (0x00003000)
+#define SYS_PLL_OTHER_REG_TEST_SEL(data)                                             (0x00003000&((data)<<12))
+#define SYS_PLL_OTHER_REG_TEST_SEL_src(data)                                         ((0x00003000&(data))>>12)
+#define SYS_PLL_OTHER_get_REG_TEST_SEL(data)                                         ((0x00003000&(data))>>12)
+#define SYS_PLL_OTHER_POR_VSET_shift                                                 (11)
+#define SYS_PLL_OTHER_POR_VSET_mask                                                  (0x00000800)
+#define SYS_PLL_OTHER_POR_VSET(data)                                                 (0x00000800&((data)<<11))
+#define SYS_PLL_OTHER_POR_VSET_src(data)                                             ((0x00000800&(data))>>11)
+#define SYS_PLL_OTHER_get_POR_VSET(data)                                             ((0x00000800&(data))>>11)
+#define SYS_PLL_OTHER_REG_PLLDDSB_CKIN_SEL_shift                                     (10)
+#define SYS_PLL_OTHER_REG_PLLDDSB_CKIN_SEL_mask                                      (0x00000400)
+#define SYS_PLL_OTHER_REG_PLLDDSB_CKIN_SEL(data)                                     (0x00000400&((data)<<10))
+#define SYS_PLL_OTHER_REG_PLLDDSB_CKIN_SEL_src(data)                                 ((0x00000400&(data))>>10)
+#define SYS_PLL_OTHER_get_REG_PLLDDSB_CKIN_SEL(data)                                 ((0x00000400&(data))>>10)
+#define SYS_PLL_OTHER_REG_PLLDISP_SEL_shift                                          (8)
+#define SYS_PLL_OTHER_REG_PLLDISP_SEL_mask                                           (0x00000300)
+#define SYS_PLL_OTHER_REG_PLLDISP_SEL(data)                                          (0x00000300&((data)<<8))
+#define SYS_PLL_OTHER_REG_PLLDISP_SEL_src(data)                                      ((0x00000300&(data))>>8)
+#define SYS_PLL_OTHER_get_REG_PLLDISP_SEL(data)                                      ((0x00000300&(data))>>8)
+#define SYS_PLL_OTHER_REG_HDMITX_27M_SEL_shift                                       (6)
+#define SYS_PLL_OTHER_REG_HDMITX_27M_SEL_mask                                        (0x000000C0)
+#define SYS_PLL_OTHER_REG_HDMITX_27M_SEL(data)                                       (0x000000C0&((data)<<6))
+#define SYS_PLL_OTHER_REG_HDMITX_27M_SEL_src(data)                                   ((0x000000C0&(data))>>6)
+#define SYS_PLL_OTHER_get_REG_HDMITX_27M_SEL(data)                                   ((0x000000C0&(data))>>6)
+#define SYS_PLL_OTHER_REG_PLLGPU_BYPASS_PI_shift                                     (5)
+#define SYS_PLL_OTHER_REG_PLLGPU_BYPASS_PI_mask                                      (0x00000020)
+#define SYS_PLL_OTHER_REG_PLLGPU_BYPASS_PI(data)                                     (0x00000020&((data)<<5))
+#define SYS_PLL_OTHER_REG_PLLGPU_BYPASS_PI_src(data)                                 ((0x00000020&(data))>>5)
+#define SYS_PLL_OTHER_get_REG_PLLGPU_BYPASS_PI(data)                                 ((0x00000020&(data))>>5)
+#define SYS_PLL_OTHER_REG_PLLDDSB_BYPASS_PI_shift                                    (4)
+#define SYS_PLL_OTHER_REG_PLLDDSB_BYPASS_PI_mask                                     (0x00000010)
+#define SYS_PLL_OTHER_REG_PLLDDSB_BYPASS_PI(data)                                    (0x00000010&((data)<<4))
+#define SYS_PLL_OTHER_REG_PLLDDSB_BYPASS_PI_src(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_OTHER_get_REG_PLLDDSB_BYPASS_PI(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_OTHER_REG_PLLDDSA_BYPASS_PI_shift                                    (3)
+#define SYS_PLL_OTHER_REG_PLLDDSA_BYPASS_PI_mask                                     (0x00000008)
+#define SYS_PLL_OTHER_REG_PLLDDSA_BYPASS_PI(data)                                    (0x00000008&((data)<<3))
+#define SYS_PLL_OTHER_REG_PLLDDSA_BYPASS_PI_src(data)                                ((0x00000008&(data))>>3)
+#define SYS_PLL_OTHER_get_REG_PLLDDSA_BYPASS_PI(data)                                ((0x00000008&(data))>>3)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_H_shift                                   (2)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_H_mask                                    (0x00000004)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_H(data)                                   (0x00000004&((data)<<2))
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_H_src(data)                               ((0x00000004&(data))>>2)
+#define SYS_PLL_OTHER_get_REG_PLLBUS_BYPASS_PI_H(data)                               ((0x00000004&(data))>>2)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_shift                                     (1)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_mask                                      (0x00000002)
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI(data)                                     (0x00000002&((data)<<1))
+#define SYS_PLL_OTHER_REG_PLLBUS_BYPASS_PI_src(data)                                 ((0x00000002&(data))>>1)
+#define SYS_PLL_OTHER_get_REG_PLLBUS_BYPASS_PI(data)                                 ((0x00000002&(data))>>1)
+#define SYS_PLL_OTHER_REG_PLLACPU_BYPASS_PI_shift                                    (0)
+#define SYS_PLL_OTHER_REG_PLLACPU_BYPASS_PI_mask                                     (0x00000001)
+#define SYS_PLL_OTHER_REG_PLLACPU_BYPASS_PI(data)                                    (0x00000001&((data)<<0))
+#define SYS_PLL_OTHER_REG_PLLACPU_BYPASS_PI_src(data)                                ((0x00000001&(data))>>0)
+#define SYS_PLL_OTHER_get_REG_PLLACPU_BYPASS_PI(data)                                ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD1                                                             0x98000204
+#define SYS_PLL_HDMI_SD1_reg_addr                                                    "0xD8000204"
+#define SYS_PLL_HDMI_SD1_reg                                                         0xD8000204
+#define set_SYS_PLL_HDMI_SD1_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD1_reg)=data)
+#define get_SYS_PLL_HDMI_SD1_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD1_reg))
+#define SYS_PLL_HDMI_SD1_inst_adr                                                    "0x0081"
+#define SYS_PLL_HDMI_SD1_inst                                                        0x0081
+#define SYS_PLL_HDMI_SD1_time_rdy_ckout_shift                                        (30)
+#define SYS_PLL_HDMI_SD1_time_rdy_ckout_mask                                         (0xC0000000)
+#define SYS_PLL_HDMI_SD1_time_rdy_ckout(data)                                        (0xC0000000&((data)<<30))
+#define SYS_PLL_HDMI_SD1_time_rdy_ckout_src(data)                                    ((0xC0000000&(data))>>30)
+#define SYS_PLL_HDMI_SD1_get_time_rdy_ckout(data)                                    ((0xC0000000&(data))>>30)
+#define SYS_PLL_HDMI_SD1_time2_rst_width_shift                                       (28)
+#define SYS_PLL_HDMI_SD1_time2_rst_width_mask                                        (0x30000000)
+#define SYS_PLL_HDMI_SD1_time2_rst_width(data)                                       (0x30000000&((data)<<28))
+#define SYS_PLL_HDMI_SD1_time2_rst_width_src(data)                                   ((0x30000000&(data))>>28)
+#define SYS_PLL_HDMI_SD1_get_time2_rst_width(data)                                   ((0x30000000&(data))>>28)
+#define SYS_PLL_HDMI_SD1_pcr_rst_n_shift                                             (27)
+#define SYS_PLL_HDMI_SD1_pcr_rst_n_mask                                              (0x08000000)
+#define SYS_PLL_HDMI_SD1_pcr_rst_n(data)                                             (0x08000000&((data)<<27))
+#define SYS_PLL_HDMI_SD1_pcr_rst_n_src(data)                                         ((0x08000000&(data))>>27)
+#define SYS_PLL_HDMI_SD1_get_pcr_rst_n(data)                                         ((0x08000000&(data))>>27)
+#define SYS_PLL_HDMI_SD1_time0_ck_shift                                              (24)
+#define SYS_PLL_HDMI_SD1_time0_ck_mask                                               (0x07000000)
+#define SYS_PLL_HDMI_SD1_time0_ck(data)                                              (0x07000000&((data)<<24))
+#define SYS_PLL_HDMI_SD1_time0_ck_src(data)                                          ((0x07000000&(data))>>24)
+#define SYS_PLL_HDMI_SD1_get_time0_ck(data)                                          ((0x07000000&(data))>>24)
+#define SYS_PLL_HDMI_SD1_f390k_shift                                                 (22)
+#define SYS_PLL_HDMI_SD1_f390k_mask                                                  (0x00C00000)
+#define SYS_PLL_HDMI_SD1_f390k(data)                                                 (0x00C00000&((data)<<22))
+#define SYS_PLL_HDMI_SD1_f390k_src(data)                                             ((0x00C00000&(data))>>22)
+#define SYS_PLL_HDMI_SD1_get_f390k(data)                                             ((0x00C00000&(data))>>22)
+#define SYS_PLL_HDMI_SD1_pll_en_shift                                                (21)
+#define SYS_PLL_HDMI_SD1_pll_en_mask                                                 (0x00200000)
+#define SYS_PLL_HDMI_SD1_pll_en(data)                                                (0x00200000&((data)<<21))
+#define SYS_PLL_HDMI_SD1_pll_en_src(data)                                            ((0x00200000&(data))>>21)
+#define SYS_PLL_HDMI_SD1_get_pll_en(data)                                            ((0x00200000&(data))>>21)
+#define SYS_PLL_HDMI_SD1_en_wdog_shift                                               (20)
+#define SYS_PLL_HDMI_SD1_en_wdog_mask                                                (0x00100000)
+#define SYS_PLL_HDMI_SD1_en_wdog(data)                                               (0x00100000&((data)<<20))
+#define SYS_PLL_HDMI_SD1_en_wdog_src(data)                                           ((0x00100000&(data))>>20)
+#define SYS_PLL_HDMI_SD1_get_en_wdog(data)                                           ((0x00100000&(data))>>20)
+#define SYS_PLL_HDMI_SD1_ssc_ckinv_shift                                             (19)
+#define SYS_PLL_HDMI_SD1_ssc_ckinv_mask                                              (0x00080000)
+#define SYS_PLL_HDMI_SD1_ssc_ckinv(data)                                             (0x00080000&((data)<<19))
+#define SYS_PLL_HDMI_SD1_ssc_ckinv_src(data)                                         ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD1_get_ssc_ckinv(data)                                         ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD1_fcode_shift                                                 (8)
+#define SYS_PLL_HDMI_SD1_fcode_mask                                                  (0x0007FF00)
+#define SYS_PLL_HDMI_SD1_fcode(data)                                                 (0x0007FF00&((data)<<8))
+#define SYS_PLL_HDMI_SD1_fcode_src(data)                                             ((0x0007FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD1_get_fcode(data)                                             ((0x0007FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD1_ncode_shift                                                 (0)
+#define SYS_PLL_HDMI_SD1_ncode_mask                                                  (0x000000FF)
+#define SYS_PLL_HDMI_SD1_ncode(data)                                                 (0x000000FF&((data)<<0))
+#define SYS_PLL_HDMI_SD1_ncode_src(data)                                             ((0x000000FF&(data))>>0)
+#define SYS_PLL_HDMI_SD1_get_ncode(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD2                                                             0x98000208
+#define SYS_PLL_HDMI_SD2_reg_addr                                                    "0xD8000208"
+#define SYS_PLL_HDMI_SD2_reg                                                         0xD8000208
+#define set_SYS_PLL_HDMI_SD2_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD2_reg)=data)
+#define get_SYS_PLL_HDMI_SD2_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD2_reg))
+#define SYS_PLL_HDMI_SD2_inst_adr                                                    "0x0082"
+#define SYS_PLL_HDMI_SD2_inst                                                        0x0082
+#define SYS_PLL_HDMI_SD2_bypass_pi_shift                                             (31)
+#define SYS_PLL_HDMI_SD2_bypass_pi_mask                                              (0x80000000)
+#define SYS_PLL_HDMI_SD2_bypass_pi(data)                                             (0x80000000&((data)<<31))
+#define SYS_PLL_HDMI_SD2_bypass_pi_src(data)                                         ((0x80000000&(data))>>31)
+#define SYS_PLL_HDMI_SD2_get_bypass_pi(data)                                         ((0x80000000&(data))>>31)
+#define SYS_PLL_HDMI_SD2_en_pi_debug_shift                                           (30)
+#define SYS_PLL_HDMI_SD2_en_pi_debug_mask                                            (0x40000000)
+#define SYS_PLL_HDMI_SD2_en_pi_debug(data)                                           (0x40000000&((data)<<30))
+#define SYS_PLL_HDMI_SD2_en_pi_debug_src(data)                                       ((0x40000000&(data))>>30)
+#define SYS_PLL_HDMI_SD2_get_en_pi_debug(data)                                       ((0x40000000&(data))>>30)
+#define SYS_PLL_HDMI_SD2_hs_oc_stop_diff_shift                                       (28)
+#define SYS_PLL_HDMI_SD2_hs_oc_stop_diff_mask                                        (0x30000000)
+#define SYS_PLL_HDMI_SD2_hs_oc_stop_diff(data)                                       (0x30000000&((data)<<28))
+#define SYS_PLL_HDMI_SD2_hs_oc_stop_diff_src(data)                                   ((0x30000000&(data))>>28)
+#define SYS_PLL_HDMI_SD2_get_hs_oc_stop_diff(data)                                   ((0x30000000&(data))>>28)
+#define SYS_PLL_HDMI_SD2_sel_oc_mode_shift                                           (24)
+#define SYS_PLL_HDMI_SD2_sel_oc_mode_mask                                            (0x03000000)
+#define SYS_PLL_HDMI_SD2_sel_oc_mode(data)                                           (0x03000000&((data)<<24))
+#define SYS_PLL_HDMI_SD2_sel_oc_mode_src(data)                                       ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_SD2_get_sel_oc_mode(data)                                       ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_SD2_oc_done_delay_shift                                         (16)
+#define SYS_PLL_HDMI_SD2_oc_done_delay_mask                                          (0x003F0000)
+#define SYS_PLL_HDMI_SD2_oc_done_delay(data)                                         (0x003F0000&((data)<<16))
+#define SYS_PLL_HDMI_SD2_oc_done_delay_src(data)                                     ((0x003F0000&(data))>>16)
+#define SYS_PLL_HDMI_SD2_get_oc_done_delay(data)                                     ((0x003F0000&(data))>>16)
+#define SYS_PLL_HDMI_SD2_pi_cur_sel_shift                                            (12)
+#define SYS_PLL_HDMI_SD2_pi_cur_sel_mask                                             (0x00007000)
+#define SYS_PLL_HDMI_SD2_pi_cur_sel(data)                                            (0x00007000&((data)<<12))
+#define SYS_PLL_HDMI_SD2_pi_cur_sel_src(data)                                        ((0x00007000&(data))>>12)
+#define SYS_PLL_HDMI_SD2_get_pi_cur_sel(data)                                        ((0x00007000&(data))>>12)
+#define SYS_PLL_HDMI_SD2_oc_step_set_shift                                           (2)
+#define SYS_PLL_HDMI_SD2_oc_step_set_mask                                            (0x00000FFC)
+#define SYS_PLL_HDMI_SD2_oc_step_set(data)                                           (0x00000FFC&((data)<<2))
+#define SYS_PLL_HDMI_SD2_oc_step_set_src(data)                                       ((0x00000FFC&(data))>>2)
+#define SYS_PLL_HDMI_SD2_get_oc_step_set(data)                                       ((0x00000FFC&(data))>>2)
+#define SYS_PLL_HDMI_SD2_sdm_order_shift                                             (1)
+#define SYS_PLL_HDMI_SD2_sdm_order_mask                                              (0x00000002)
+#define SYS_PLL_HDMI_SD2_sdm_order(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_HDMI_SD2_sdm_order_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_SD2_get_sdm_order(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_SD2_oc_en_shift                                                 (0)
+#define SYS_PLL_HDMI_SD2_oc_en_mask                                                  (0x00000001)
+#define SYS_PLL_HDMI_SD2_oc_en(data)                                                 (0x00000001&((data)<<0))
+#define SYS_PLL_HDMI_SD2_oc_en_src(data)                                             ((0x00000001&(data))>>0)
+#define SYS_PLL_HDMI_SD2_get_oc_en(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD3                                                             0x98000210
+#define SYS_PLL_HDMI_SD3_reg_addr                                                    "0xD8000210"
+#define SYS_PLL_HDMI_SD3_reg                                                         0xD8000210
+#define set_SYS_PLL_HDMI_SD3_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD3_reg)=data)
+#define get_SYS_PLL_HDMI_SD3_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD3_reg))
+#define SYS_PLL_HDMI_SD3_inst_adr                                                    "0x0084"
+#define SYS_PLL_HDMI_SD3_inst                                                        0x0084
+#define SYS_PLL_HDMI_SD3_load_fcw_shift                                              (31)
+#define SYS_PLL_HDMI_SD3_load_fcw_mask                                               (0x80000000)
+#define SYS_PLL_HDMI_SD3_load_fcw(data)                                              (0x80000000&((data)<<31))
+#define SYS_PLL_HDMI_SD3_load_fcw_src(data)                                          ((0x80000000&(data))>>31)
+#define SYS_PLL_HDMI_SD3_get_load_fcw(data)                                          ((0x80000000&(data))>>31)
+#define SYS_PLL_HDMI_SD3_fmod_shift                                                  (27)
+#define SYS_PLL_HDMI_SD3_fmod_mask                                                   (0x08000000)
+#define SYS_PLL_HDMI_SD3_fmod(data)                                                  (0x08000000&((data)<<27))
+#define SYS_PLL_HDMI_SD3_fmod_src(data)                                              ((0x08000000&(data))>>27)
+#define SYS_PLL_HDMI_SD3_get_fmod(data)                                              ((0x08000000&(data))>>27)
+#define SYS_PLL_HDMI_SD3_fcode_debug_shift                                           (16)
+#define SYS_PLL_HDMI_SD3_fcode_debug_mask                                            (0x07FF0000)
+#define SYS_PLL_HDMI_SD3_fcode_debug(data)                                           (0x07FF0000&((data)<<16))
+#define SYS_PLL_HDMI_SD3_fcode_debug_src(data)                                       ((0x07FF0000&(data))>>16)
+#define SYS_PLL_HDMI_SD3_get_fcode_debug(data)                                       ((0x07FF0000&(data))>>16)
+#define SYS_PLL_HDMI_SD3_ncode_debug_shift                                           (8)
+#define SYS_PLL_HDMI_SD3_ncode_debug_mask                                            (0x0000FF00)
+#define SYS_PLL_HDMI_SD3_ncode_debug(data)                                           (0x0000FF00&((data)<<8))
+#define SYS_PLL_HDMI_SD3_ncode_debug_src(data)                                       ((0x0000FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD3_get_ncode_debug(data)                                       ((0x0000FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD3_clkrdy_shift                                                (1)
+#define SYS_PLL_HDMI_SD3_clkrdy_mask                                                 (0x00000002)
+#define SYS_PLL_HDMI_SD3_clkrdy(data)                                                (0x00000002&((data)<<1))
+#define SYS_PLL_HDMI_SD3_clkrdy_src(data)                                            ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_SD3_get_clkrdy(data)                                            ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_SD3_oc_done_shift                                               (0)
+#define SYS_PLL_HDMI_SD3_oc_done_mask                                                (0x00000001)
+#define SYS_PLL_HDMI_SD3_oc_done(data)                                               (0x00000001&((data)<<0))
+#define SYS_PLL_HDMI_SD3_oc_done_src(data)                                           ((0x00000001&(data))>>0)
+#define SYS_PLL_HDMI_SD3_get_oc_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD4                                                             0x9800021c
+#define SYS_PLL_HDMI_SD4_reg_addr                                                    "0xD800021C"
+#define SYS_PLL_HDMI_SD4_reg                                                         0xD800021C
+#define set_SYS_PLL_HDMI_SD4_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD4_reg)=data)
+#define get_SYS_PLL_HDMI_SD4_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD4_reg))
+#define SYS_PLL_HDMI_SD4_inst_adr                                                    "0x0087"
+#define SYS_PLL_HDMI_SD4_inst                                                        0x0087
+#define SYS_PLL_HDMI_SD4_ssc_en_shift                                                (19)
+#define SYS_PLL_HDMI_SD4_ssc_en_mask                                                 (0x00080000)
+#define SYS_PLL_HDMI_SD4_ssc_en(data)                                                (0x00080000&((data)<<19))
+#define SYS_PLL_HDMI_SD4_ssc_en_src(data)                                            ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD4_get_ssc_en(data)                                            ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD4_fcode_ssc_shift                                             (8)
+#define SYS_PLL_HDMI_SD4_fcode_ssc_mask                                              (0x0007FF00)
+#define SYS_PLL_HDMI_SD4_fcode_ssc(data)                                             (0x0007FF00&((data)<<8))
+#define SYS_PLL_HDMI_SD4_fcode_ssc_src(data)                                         ((0x0007FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD4_get_fcode_ssc(data)                                         ((0x0007FF00&(data))>>8)
+#define SYS_PLL_HDMI_SD4_ncode_ssc_shift                                             (0)
+#define SYS_PLL_HDMI_SD4_ncode_ssc_mask                                              (0x000000FF)
+#define SYS_PLL_HDMI_SD4_ncode_ssc(data)                                             (0x000000FF&((data)<<0))
+#define SYS_PLL_HDMI_SD4_ncode_ssc_src(data)                                         ((0x000000FF&(data))>>0)
+#define SYS_PLL_HDMI_SD4_get_ncode_ssc(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD5                                                             0x98000220
+#define SYS_PLL_HDMI_SD5_reg_addr                                                    "0xD8000220"
+#define SYS_PLL_HDMI_SD5_reg                                                         0xD8000220
+#define set_SYS_PLL_HDMI_SD5_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD5_reg)=data)
+#define get_SYS_PLL_HDMI_SD5_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD5_reg))
+#define SYS_PLL_HDMI_SD5_inst_adr                                                    "0x0088"
+#define SYS_PLL_HDMI_SD5_inst                                                        0x0088
+#define SYS_PLL_HDMI_SD5_RSTB_HDMITX_shift                                           (23)
+#define SYS_PLL_HDMI_SD5_RSTB_HDMITX_mask                                            (0x00800000)
+#define SYS_PLL_HDMI_SD5_RSTB_HDMITX(data)                                           (0x00800000&((data)<<23))
+#define SYS_PLL_HDMI_SD5_RSTB_HDMITX_src(data)                                       ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_SD5_get_RSTB_HDMITX(data)                                       ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_SD5_gran_auto_rst_shift                                         (22)
+#define SYS_PLL_HDMI_SD5_gran_auto_rst_mask                                          (0x00400000)
+#define SYS_PLL_HDMI_SD5_gran_auto_rst(data)                                         (0x00400000&((data)<<22))
+#define SYS_PLL_HDMI_SD5_gran_auto_rst_src(data)                                     ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_SD5_get_gran_auto_rst(data)                                     ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_SD5_dot_gran_shift                                              (19)
+#define SYS_PLL_HDMI_SD5_dot_gran_mask                                               (0x00380000)
+#define SYS_PLL_HDMI_SD5_dot_gran(data)                                              (0x00380000&((data)<<19))
+#define SYS_PLL_HDMI_SD5_dot_gran_src(data)                                          ((0x00380000&(data))>>19)
+#define SYS_PLL_HDMI_SD5_get_dot_gran(data)                                          ((0x00380000&(data))>>19)
+#define SYS_PLL_HDMI_SD5_gran_est_shift                                              (0)
+#define SYS_PLL_HDMI_SD5_gran_est_mask                                               (0x0007FFFF)
+#define SYS_PLL_HDMI_SD5_gran_est(data)                                              (0x0007FFFF&((data)<<0))
+#define SYS_PLL_HDMI_SD5_gran_est_src(data)                                          ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_HDMI_SD5_get_gran_est(data)                                          ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_BG_CTL                                                                   0x98000224
+#define SYS_BG_CTL_reg_addr                                                          "0xD8000224"
+#define SYS_BG_CTL_reg                                                               0xD8000224
+#define set_SYS_BG_CTL_reg(data)   (*((volatile unsigned int*) SYS_BG_CTL_reg)=data)
+#define get_SYS_BG_CTL_reg   (*((volatile unsigned int*) SYS_BG_CTL_reg))
+#define SYS_BG_CTL_inst_adr                                                          "0x0089"
+#define SYS_BG_CTL_inst                                                              0x0089
+#define SYS_BG_CTL_REG_PLL_RESERVED_shift                                            (24)
+#define SYS_BG_CTL_REG_PLL_RESERVED_mask                                             (0xFF000000)
+#define SYS_BG_CTL_REG_PLL_RESERVED(data)                                            (0xFF000000&((data)<<24))
+#define SYS_BG_CTL_REG_PLL_RESERVED_src(data)                                        ((0xFF000000&(data))>>24)
+#define SYS_BG_CTL_get_REG_PLL_RESERVED(data)                                        ((0xFF000000&(data))>>24)
+#define SYS_BG_CTL_REG_LDO2V_SEL_shift                                               (9)
+#define SYS_BG_CTL_REG_LDO2V_SEL_mask                                                (0x00000600)
+#define SYS_BG_CTL_REG_LDO2V_SEL(data)                                               (0x00000600&((data)<<9))
+#define SYS_BG_CTL_REG_LDO2V_SEL_src(data)                                           ((0x00000600&(data))>>9)
+#define SYS_BG_CTL_get_REG_LDO2V_SEL(data)                                           ((0x00000600&(data))>>9)
+#define SYS_BG_CTL_REG_LDO2V_POW_shift                                               (8)
+#define SYS_BG_CTL_REG_LDO2V_POW_mask                                                (0x00000100)
+#define SYS_BG_CTL_REG_LDO2V_POW(data)                                               (0x00000100&((data)<<8))
+#define SYS_BG_CTL_REG_LDO2V_POW_src(data)                                           ((0x00000100&(data))>>8)
+#define SYS_BG_CTL_get_REG_LDO2V_POW(data)                                           ((0x00000100&(data))>>8)
+
+
+#define SYS_POR_DET                                                                  0x98000228
+#define SYS_POR_DET_reg_addr                                                         "0xD8000228"
+#define SYS_POR_DET_reg                                                              0xD8000228
+#define set_SYS_POR_DET_reg(data)   (*((volatile unsigned int*) SYS_POR_DET_reg)=data)
+#define get_SYS_POR_DET_reg   (*((volatile unsigned int*) SYS_POR_DET_reg))
+#define SYS_POR_DET_inst_adr                                                         "0x008A"
+#define SYS_POR_DET_inst                                                             0x008A
+#define SYS_POR_DET_POR_VDD_D10_OVER_shift                                           (0)
+#define SYS_POR_DET_POR_VDD_D10_OVER_mask                                            (0x00000001)
+#define SYS_POR_DET_POR_VDD_D10_OVER(data)                                           (0x00000001&((data)<<0))
+#define SYS_POR_DET_POR_VDD_D10_OVER_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_POR_DET_get_POR_VDD_D10_OVER(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI_LDO1                                                            0x98000230
+#define SYS_PLL_HDMI_LDO1_reg_addr                                                   "0xD8000230"
+#define SYS_PLL_HDMI_LDO1_reg                                                        0xD8000230
+#define set_SYS_PLL_HDMI_LDO1_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO1_reg)=data)
+#define get_SYS_PLL_HDMI_LDO1_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO1_reg))
+#define SYS_PLL_HDMI_LDO1_inst_adr                                                   "0x008C"
+#define SYS_PLL_HDMI_LDO1_inst                                                       0x008C
+#define SYS_PLL_HDMI_LDO1_REG_BYPASS_PI_shift                                        (29)
+#define SYS_PLL_HDMI_LDO1_REG_BYPASS_PI_mask                                         (0x20000000)
+#define SYS_PLL_HDMI_LDO1_REG_BYPASS_PI(data)                                        (0x20000000&((data)<<29))
+#define SYS_PLL_HDMI_LDO1_REG_BYPASS_PI_src(data)                                    ((0x20000000&(data))>>29)
+#define SYS_PLL_HDMI_LDO1_get_REG_BYPASS_PI(data)                                    ((0x20000000&(data))>>29)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_LDO_SEL_shift                                      (27)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_LDO_SEL_mask                                       (0x18000000)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_LDO_SEL(data)                                      (0x18000000&((data)<<27))
+#define SYS_PLL_HDMI_LDO1_REG_P2S_LDO_SEL_src(data)                                  ((0x18000000&(data))>>27)
+#define SYS_PLL_HDMI_LDO1_get_REG_P2S_LDO_SEL(data)                                  ((0x18000000&(data))>>27)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_MODE_shift                                         (25)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_MODE_mask                                          (0x06000000)
+#define SYS_PLL_HDMI_LDO1_REG_P2S_MODE(data)                                         (0x06000000&((data)<<25))
+#define SYS_PLL_HDMI_LDO1_REG_P2S_MODE_src(data)                                     ((0x06000000&(data))>>25)
+#define SYS_PLL_HDMI_LDO1_get_REG_P2S_MODE(data)                                     ((0x06000000&(data))>>25)
+#define SYS_PLL_HDMI_LDO1_REG_TSPC_SEL_shift                                         (24)
+#define SYS_PLL_HDMI_LDO1_REG_TSPC_SEL_mask                                          (0x01000000)
+#define SYS_PLL_HDMI_LDO1_REG_TSPC_SEL(data)                                         (0x01000000&((data)<<24))
+#define SYS_PLL_HDMI_LDO1_REG_TSPC_SEL_src(data)                                     ((0x01000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO1_get_REG_TSPC_SEL(data)                                     ((0x01000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO1_REG_MHL_MODE_shift                                         (23)
+#define SYS_PLL_HDMI_LDO1_REG_MHL_MODE_mask                                          (0x00800000)
+#define SYS_PLL_HDMI_LDO1_REG_MHL_MODE(data)                                         (0x00800000&((data)<<23))
+#define SYS_PLL_HDMI_LDO1_REG_MHL_MODE_src(data)                                     ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO1_get_REG_MHL_MODE(data)                                     ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO1_REG_HDMI_MODE_shift                                        (22)
+#define SYS_PLL_HDMI_LDO1_REG_HDMI_MODE_mask                                         (0x00400000)
+#define SYS_PLL_HDMI_LDO1_REG_HDMI_MODE(data)                                        (0x00400000&((data)<<22))
+#define SYS_PLL_HDMI_LDO1_REG_HDMI_MODE_src(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_LDO1_get_REG_HDMI_MODE(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_LDO1_REG_HDMICK_SEL_shift                                       (21)
+#define SYS_PLL_HDMI_LDO1_REG_HDMICK_SEL_mask                                        (0x00200000)
+#define SYS_PLL_HDMI_LDO1_REG_HDMICK_SEL(data)                                       (0x00200000&((data)<<21))
+#define SYS_PLL_HDMI_LDO1_REG_HDMICK_SEL_src(data)                                   ((0x00200000&(data))>>21)
+#define SYS_PLL_HDMI_LDO1_get_REG_HDMICK_SEL(data)                                   ((0x00200000&(data))>>21)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_TST_POW_shift                                      (20)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_TST_POW_mask                                       (0x00100000)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_TST_POW(data)                                      (0x00100000&((data)<<20))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_TST_POW_src(data)                                  ((0x00100000&(data))>>20)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_TST_POW(data)                                  ((0x00100000&(data))>>20)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_V18_SEL_shift                                  (18)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_V18_SEL_mask                                   (0x000C0000)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_V18_SEL(data)                                  (0x000C0000&((data)<<18))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_V18_SEL_src(data)                              ((0x000C0000&(data))>>18)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_LDO_V18_SEL(data)                              ((0x000C0000&(data))>>18)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_LV_SEL_shift                                   (16)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_LV_SEL_mask                                    (0x00030000)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_LV_SEL(data)                                   (0x00030000&((data)<<16))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_LDO_LV_SEL_src(data)                               ((0x00030000&(data))>>16)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_LDO_LV_SEL(data)                               ((0x00030000&(data))>>16)
+#define SYS_PLL_HDMI_LDO1_REG_TST_DIV_shift                                          (13)
+#define SYS_PLL_HDMI_LDO1_REG_TST_DIV_mask                                           (0x0000E000)
+#define SYS_PLL_HDMI_LDO1_REG_TST_DIV(data)                                          (0x0000E000&((data)<<13))
+#define SYS_PLL_HDMI_LDO1_REG_TST_DIV_src(data)                                      ((0x0000E000&(data))>>13)
+#define SYS_PLL_HDMI_LDO1_get_REG_TST_DIV(data)                                      ((0x0000E000&(data))>>13)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_RS_shift                                           (10)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_RS_mask                                            (0x00001C00)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_RS(data)                                           (0x00001C00&((data)<<10))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_RS_src(data)                                       ((0x00001C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_RS(data)                                       ((0x00001C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDSET_shift                                        (9)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDSET_mask                                         (0x00000200)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDSET(data)                                        (0x00000200&((data)<<9))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDSET_src(data)                                    ((0x00000200&(data))>>9)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_WDSET(data)                                    ((0x00000200&(data))>>9)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDRST_shift                                        (8)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDRST_mask                                         (0x00000100)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDRST(data)                                        (0x00000100&((data)<<8))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_WDRST_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_WDRST(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_VCOGAIN_shift                                      (7)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_VCOGAIN_mask                                       (0x00000080)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_VCOGAIN(data)                                      (0x00000080&((data)<<7))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_VCOGAIN_src(data)                                  ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_VCOGAIN(data)                                  ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_EXT_LDO_LV_shift                                   (6)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_EXT_LDO_LV_mask                                    (0x00000040)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_EXT_LDO_LV(data)                                   (0x00000040&((data)<<6))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_EXT_LDO_LV_src(data)                               ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_EXT_LDO_LV(data)                               ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CKSEL_shift                                        (4)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CKSEL_mask                                         (0x00000030)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CKSEL(data)                                        (0x00000030&((data)<<4))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CKSEL_src(data)                                    ((0x00000030&(data))>>4)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_CKSEL(data)                                    ((0x00000030&(data))>>4)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CS_shift                                           (2)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CS_mask                                            (0x0000000C)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CS(data)                                           (0x0000000C&((data)<<2))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CS_src(data)                                       ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_CS(data)                                       ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CP_shift                                           (0)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CP_mask                                            (0x00000003)
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CP(data)                                           (0x00000003&((data)<<0))
+#define SYS_PLL_HDMI_LDO1_REG_PLL_CP_src(data)                                       ((0x00000003&(data))>>0)
+#define SYS_PLL_HDMI_LDO1_get_REG_PLL_CP(data)                                       ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_HDMI_LDO2                                                            0x98000234
+#define SYS_PLL_HDMI_LDO2_reg_addr                                                   "0xD8000234"
+#define SYS_PLL_HDMI_LDO2_reg                                                        0xD8000234
+#define set_SYS_PLL_HDMI_LDO2_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO2_reg)=data)
+#define get_SYS_PLL_HDMI_LDO2_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO2_reg))
+#define SYS_PLL_HDMI_LDO2_inst_adr                                                   "0x008D"
+#define SYS_PLL_HDMI_LDO2_inst                                                       0x008D
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELCK_shift                                      (24)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELCK_mask                                       (0x03000000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELCK(data)                                      (0x03000000&((data)<<24))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELCK_src(data)                                  ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_RSELCK(data)                                  ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELC_shift                                       (22)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELC_mask                                        (0x00C00000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELC(data)                                       (0x00C00000&((data)<<22))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELC_src(data)                                   ((0x00C00000&(data))>>22)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_RSELC(data)                                   ((0x00C00000&(data))>>22)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELB_shift                                       (20)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELB_mask                                        (0x00300000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELB(data)                                       (0x00300000&((data)<<20))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELB_src(data)                                   ((0x00300000&(data))>>20)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_RSELB(data)                                   ((0x00300000&(data))>>20)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELA_shift                                       (18)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELA_mask                                        (0x000C0000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELA(data)                                       (0x000C0000&((data)<<18))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_RSELA_src(data)                                   ((0x000C0000&(data))>>18)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_RSELA(data)                                   ((0x000C0000&(data))>>18)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELCK_shift                                      (16)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELCK_mask                                       (0x00030000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELCK(data)                                      (0x00030000&((data)<<16))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELCK_src(data)                                  ((0x00030000&(data))>>16)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_CSELCK(data)                                  ((0x00030000&(data))>>16)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELC_shift                                       (14)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELC_mask                                        (0x0000C000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELC(data)                                       (0x0000C000&((data)<<14))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELC_src(data)                                   ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_CSELC(data)                                   ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELB_shift                                       (12)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELB_mask                                        (0x00003000)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELB(data)                                       (0x00003000&((data)<<12))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELB_src(data)                                   ((0x00003000&(data))>>12)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_CSELB(data)                                   ((0x00003000&(data))>>12)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELA_shift                                       (10)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELA_mask                                        (0x00000C00)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELA(data)                                       (0x00000C00&((data)<<10))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_CSELA_src(data)                                   ((0x00000C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_CSELA(data)                                   ((0x00000C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_B_shift                                  (9)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_B_mask                                   (0x00000200)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_B(data)                                  (0x00000200&((data)<<9))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_B_src(data)                              ((0x00000200&(data))>>9)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWMHLCK_B(data)                              ((0x00000200&(data))>>9)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_A_shift                                  (8)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_A_mask                                   (0x00000100)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_A(data)                                  (0x00000100&((data)<<8))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWMHLCK_A_src(data)                              ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWMHLCK_A(data)                              ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWCK_shift                                       (7)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWCK_mask                                        (0x00000080)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWCK(data)                                       (0x00000080&((data)<<7))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWCK_src(data)                                   ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWCK(data)                                   ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWC_shift                                        (6)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWC_mask                                         (0x00000040)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWC(data)                                        (0x00000040&((data)<<6))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWC_src(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWC(data)                                    ((0x00000040&(data))>>6)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWB_shift                                        (5)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWB_mask                                         (0x00000020)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWB(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWB_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWB(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWA_shift                                        (4)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWA_mask                                         (0x00000010)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWA(data)                                        (0x00000010&((data)<<4))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_POWA_src(data)                                    ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_POWA(data)                                    ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMCK_shift                                        (3)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMCK_mask                                         (0x00000008)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMCK(data)                                        (0x00000008&((data)<<3))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMCK_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_EMCK(data)                                    ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMC_shift                                         (2)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMC_mask                                          (0x00000004)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMC(data)                                         (0x00000004&((data)<<2))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMC_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_EMC(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMB_shift                                         (1)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMB_mask                                          (0x00000002)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_EMB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMA_shift                                         (0)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMA_mask                                          (0x00000001)
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMA(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_HDMI_LDO2_REG_TMDS_EMA_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_HDMI_LDO2_get_REG_TMDS_EMA(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI_LDO3                                                            0x98000238
+#define SYS_PLL_HDMI_LDO3_reg_addr                                                   "0xD8000238"
+#define SYS_PLL_HDMI_LDO3_reg                                                        0xD8000238
+#define set_SYS_PLL_HDMI_LDO3_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO3_reg)=data)
+#define get_SYS_PLL_HDMI_LDO3_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO3_reg))
+#define SYS_PLL_HDMI_LDO3_inst_adr                                                   "0x008E"
+#define SYS_PLL_HDMI_LDO3_inst                                                       0x008E
+#define SYS_PLL_HDMI_LDO3_REG_PLL_CKIN_SEL_shift                                     (24)
+#define SYS_PLL_HDMI_LDO3_REG_PLL_CKIN_SEL_mask                                      (0x03000000)
+#define SYS_PLL_HDMI_LDO3_REG_PLL_CKIN_SEL(data)                                     (0x03000000&((data)<<24))
+#define SYS_PLL_HDMI_LDO3_REG_PLL_CKIN_SEL_src(data)                                 ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO3_get_REG_PLL_CKIN_SEL(data)                                 ((0x03000000&(data))>>24)
+#define SYS_PLL_HDMI_LDO3_REG_PLL_TSPC_SEL_shift                                     (23)
+#define SYS_PLL_HDMI_LDO3_REG_PLL_TSPC_SEL_mask                                      (0x00800000)
+#define SYS_PLL_HDMI_LDO3_REG_PLL_TSPC_SEL(data)                                     (0x00800000&((data)<<23))
+#define SYS_PLL_HDMI_LDO3_REG_PLL_TSPC_SEL_src(data)                                 ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO3_get_REG_PLL_TSPC_SEL(data)                                 ((0x00800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO3_REG_PCR_27M_SEL_shift                                      (22)
+#define SYS_PLL_HDMI_LDO3_REG_PCR_27M_SEL_mask                                       (0x00400000)
+#define SYS_PLL_HDMI_LDO3_REG_PCR_27M_SEL(data)                                      (0x00400000&((data)<<22))
+#define SYS_PLL_HDMI_LDO3_REG_PCR_27M_SEL_src(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_LDO3_get_REG_PCR_27M_SEL(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVCK_shift                                      (19)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVCK_mask                                       (0x00380000)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVCK(data)                                      (0x00380000&((data)<<19))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVCK_src(data)                                  ((0x00380000&(data))>>19)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_IDRVCK(data)                                  ((0x00380000&(data))>>19)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVC_shift                                       (16)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVC_mask                                        (0x00070000)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVC(data)                                       (0x00070000&((data)<<16))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVC_src(data)                                   ((0x00070000&(data))>>16)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_IDRVC(data)                                   ((0x00070000&(data))>>16)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVB_shift                                       (13)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVB_mask                                        (0x0000E000)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVB(data)                                       (0x0000E000&((data)<<13))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVB_src(data)                                   ((0x0000E000&(data))>>13)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_IDRVB(data)                                   ((0x0000E000&(data))>>13)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVA_shift                                       (10)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVA_mask                                        (0x00001C00)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVA(data)                                       (0x00001C00&((data)<<10))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_IDRVA_src(data)                                   ((0x00001C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_IDRVA(data)                                   ((0x00001C00&(data))>>10)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRMHLCK_shift                                     (8)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRMHLCK_mask                                      (0x00000300)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRMHLCK(data)                                     (0x00000300&((data)<<8))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRMHLCK_src(data)                                 ((0x00000300&(data))>>8)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_SRMHLCK(data)                                 ((0x00000300&(data))>>8)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRCK_shift                                        (6)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRCK_mask                                         (0x000000C0)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRCK(data)                                        (0x000000C0&((data)<<6))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRCK_src(data)                                    ((0x000000C0&(data))>>6)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_SRCK(data)                                    ((0x000000C0&(data))>>6)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRC_shift                                         (4)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRC_mask                                          (0x00000030)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRC(data)                                         (0x00000030&((data)<<4))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRC_src(data)                                     ((0x00000030&(data))>>4)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_SRC(data)                                     ((0x00000030&(data))>>4)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRB_shift                                         (2)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRB_mask                                          (0x0000000C)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRB(data)                                         (0x0000000C&((data)<<2))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRB_src(data)                                     ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_SRB(data)                                     ((0x0000000C&(data))>>2)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRA_shift                                         (0)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRA_mask                                          (0x00000003)
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRA(data)                                         (0x00000003&((data)<<0))
+#define SYS_PLL_HDMI_LDO3_REG_TMDS_SRA_src(data)                                     ((0x00000003&(data))>>0)
+#define SYS_PLL_HDMI_LDO3_get_REG_TMDS_SRA(data)                                     ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_HDMI_LDO4                                                            0x9800023c
+#define SYS_PLL_HDMI_LDO4_reg_addr                                                   "0xD800023C"
+#define SYS_PLL_HDMI_LDO4_reg                                                        0xD800023C
+#define set_SYS_PLL_HDMI_LDO4_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO4_reg)=data)
+#define get_SYS_PLL_HDMI_LDO4_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO4_reg))
+#define SYS_PLL_HDMI_LDO4_inst_adr                                                   "0x008F"
+#define SYS_PLL_HDMI_LDO4_inst                                                       0x008F
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_DDSEN_shift                                    (29)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_DDSEN_mask                                     (0x20000000)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_DDSEN(data)                                    (0x20000000&((data)<<29))
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_DDSEN_src(data)                                ((0x20000000&(data))>>29)
+#define SYS_PLL_HDMI_LDO4_get_REG_PLLDISP_DDSEN(data)                                ((0x20000000&(data))>>29)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CS_shift                                       (27)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CS_mask                                        (0x18000000)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CS(data)                                       (0x18000000&((data)<<27))
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CS_src(data)                                   ((0x18000000&(data))>>27)
+#define SYS_PLL_HDMI_LDO4_get_REG_PLLDISP_CS(data)                                   ((0x18000000&(data))>>27)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CP_shift                                       (25)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CP_mask                                        (0x06000000)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CP(data)                                       (0x06000000&((data)<<25))
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_CP_src(data)                                   ((0x06000000&(data))>>25)
+#define SYS_PLL_HDMI_LDO4_get_REG_PLLDISP_CP(data)                                   ((0x06000000&(data))>>25)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_C3_shift                                       (23)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_C3_mask                                        (0x01800000)
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_C3(data)                                       (0x01800000&((data)<<23))
+#define SYS_PLL_HDMI_LDO4_REG_PLLDISP_C3_src(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO4_get_REG_PLLDISP_C3(data)                                   ((0x01800000&(data))>>23)
+#define SYS_PLL_HDMI_LDO4_REG_TEST_LDO_SEL_shift                                     (21)
+#define SYS_PLL_HDMI_LDO4_REG_TEST_LDO_SEL_mask                                      (0x00600000)
+#define SYS_PLL_HDMI_LDO4_REG_TEST_LDO_SEL(data)                                     (0x00600000&((data)<<21))
+#define SYS_PLL_HDMI_LDO4_REG_TEST_LDO_SEL_src(data)                                 ((0x00600000&(data))>>21)
+#define SYS_PLL_HDMI_LDO4_get_REG_TEST_LDO_SEL(data)                                 ((0x00600000&(data))>>21)
+#define SYS_PLL_HDMI_LDO4_REG_TESTSIG_SEL_shift                                      (19)
+#define SYS_PLL_HDMI_LDO4_REG_TESTSIG_SEL_mask                                       (0x00180000)
+#define SYS_PLL_HDMI_LDO4_REG_TESTSIG_SEL(data)                                      (0x00180000&((data)<<19))
+#define SYS_PLL_HDMI_LDO4_REG_TESTSIG_SEL_src(data)                                  ((0x00180000&(data))>>19)
+#define SYS_PLL_HDMI_LDO4_get_REG_TESTSIG_SEL(data)                                  ((0x00180000&(data))>>19)
+#define SYS_PLL_HDMI_LDO4_REG_PLL_IP_shift                                           (15)
+#define SYS_PLL_HDMI_LDO4_REG_PLL_IP_mask                                            (0x00078000)
+#define SYS_PLL_HDMI_LDO4_REG_PLL_IP(data)                                           (0x00078000&((data)<<15))
+#define SYS_PLL_HDMI_LDO4_REG_PLL_IP_src(data)                                       ((0x00078000&(data))>>15)
+#define SYS_PLL_HDMI_LDO4_get_REG_PLL_IP(data)                                       ((0x00078000&(data))>>15)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IMHLCK_shift                                      (12)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IMHLCK_mask                                       (0x00007000)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IMHLCK(data)                                      (0x00007000&((data)<<12))
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IMHLCK_src(data)                                  ((0x00007000&(data))>>12)
+#define SYS_PLL_HDMI_LDO4_get_REG_TMDS_IMHLCK(data)                                  ((0x00007000&(data))>>12)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMCK_shift                                       (9)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMCK_mask                                        (0x00000E00)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMCK(data)                                       (0x00000E00&((data)<<9))
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMCK_src(data)                                   ((0x00000E00&(data))>>9)
+#define SYS_PLL_HDMI_LDO4_get_REG_TMDS_IEMCK(data)                                   ((0x00000E00&(data))>>9)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMC_shift                                        (6)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMC_mask                                         (0x000001C0)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMC(data)                                        (0x000001C0&((data)<<6))
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMC_src(data)                                    ((0x000001C0&(data))>>6)
+#define SYS_PLL_HDMI_LDO4_get_REG_TMDS_IEMC(data)                                    ((0x000001C0&(data))>>6)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMB_shift                                        (3)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMB_mask                                         (0x00000038)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMB(data)                                        (0x00000038&((data)<<3))
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMB_src(data)                                    ((0x00000038&(data))>>3)
+#define SYS_PLL_HDMI_LDO4_get_REG_TMDS_IEMB(data)                                    ((0x00000038&(data))>>3)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMA_shift                                        (0)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMA_mask                                         (0x00000007)
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMA(data)                                        (0x00000007&((data)<<0))
+#define SYS_PLL_HDMI_LDO4_REG_TMDS_IEMA_src(data)                                    ((0x00000007&(data))>>0)
+#define SYS_PLL_HDMI_LDO4_get_REG_TMDS_IEMA(data)                                    ((0x00000007&(data))>>0)
+
+
+#define SYS_PLL_HDMI_LDO5                                                            0x98000240
+#define SYS_PLL_HDMI_LDO5_reg_addr                                                   "0xD8000240"
+#define SYS_PLL_HDMI_LDO5_reg                                                        0xD8000240
+#define set_SYS_PLL_HDMI_LDO5_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO5_reg)=data)
+#define get_SYS_PLL_HDMI_LDO5_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_LDO5_reg))
+#define SYS_PLL_HDMI_LDO5_inst_adr                                                   "0x0090"
+#define SYS_PLL_HDMI_LDO5_inst                                                       0x0090
+#define SYS_PLL_HDMI_LDO5_REG_HDMITX_RESERVE_shift                                   (16)
+#define SYS_PLL_HDMI_LDO5_REG_HDMITX_RESERVE_mask                                    (0xFFFF0000)
+#define SYS_PLL_HDMI_LDO5_REG_HDMITX_RESERVE(data)                                   (0xFFFF0000&((data)<<16))
+#define SYS_PLL_HDMI_LDO5_REG_HDMITX_RESERVE_src(data)                               ((0xFFFF0000&(data))>>16)
+#define SYS_PLL_HDMI_LDO5_get_REG_HDMITX_RESERVE(data)                               ((0xFFFF0000&(data))>>16)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_LDOSEL_shift                                   (14)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_LDOSEL_mask                                    (0x0000C000)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_LDOSEL(data)                                   (0x0000C000&((data)<<14))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_LDOSEL_src(data)                               ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_LDOSEL(data)                               ((0x0000C000&(data))>>14)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_SSC_ENL_shift                                  (13)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_SSC_ENL_mask                                   (0x00002000)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_SSC_ENL(data)                                  (0x00002000&((data)<<13))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_SSC_ENL_src(data)                              ((0x00002000&(data))>>13)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_SSC_ENL(data)                              ((0x00002000&(data))>>13)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_WDMODE_shift                                   (11)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_WDMODE_mask                                    (0x00001800)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_WDMODE(data)                                   (0x00001800&((data)<<11))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_WDMODE_src(data)                               ((0x00001800&(data))>>11)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_WDMODE(data)                               ((0x00001800&(data))>>11)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_RS_shift                                       (8)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_RS_mask                                        (0x00000700)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_RS(data)                                       (0x00000700&((data)<<8))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_RS_src(data)                                   ((0x00000700&(data))>>8)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_RS(data)                                   ((0x00000700&(data))>>8)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_R3_shift                                       (5)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_R3_mask                                        (0x000000E0)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_R3(data)                                       (0x000000E0&((data)<<5))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_R3_src(data)                                   ((0x000000E0&(data))>>5)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_R3(data)                                   ((0x000000E0&(data))>>5)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_PSTST_shift                                    (4)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_PSTST_mask                                     (0x00000010)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_PSTST(data)                                    (0x00000010&((data)<<4))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_PSTST_src(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_PSTST(data)                                ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_IP_shift                                       (0)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_IP_mask                                        (0x0000000F)
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_IP(data)                                       (0x0000000F&((data)<<0))
+#define SYS_PLL_HDMI_LDO5_REG_PLLDISP_IP_src(data)                                   ((0x0000000F&(data))>>0)
+#define SYS_PLL_HDMI_LDO5_get_REG_PLLDISP_IP(data)                                   ((0x0000000F&(data))>>0)
+
+
+#define SYS_PLL_EDP1                                                                 0x98000248
+#define SYS_PLL_EDP1_reg_addr                                                        "0xD8000248"
+#define SYS_PLL_EDP1_reg                                                             0xD8000248
+#define set_SYS_PLL_EDP1_reg(data)   (*((volatile unsigned int*) SYS_PLL_EDP1_reg)=data)
+#define get_SYS_PLL_EDP1_reg   (*((volatile unsigned int*) SYS_PLL_EDP1_reg))
+#define SYS_PLL_EDP1_inst_adr                                                        "0x0092"
+#define SYS_PLL_EDP1_inst                                                            0x0092
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOPOW_shift                                         (31)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOPOW_mask                                          (0x80000000)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOPOW(data)                                         (0x80000000&((data)<<31))
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOPOW_src(data)                                     ((0x80000000&(data))>>31)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_LDOPOW(data)                                     ((0x80000000&(data))>>31)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOSEL_shift                                         (28)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOSEL_mask                                          (0x30000000)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOSEL(data)                                         (0x30000000&((data)<<28))
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOSEL_src(data)                                     ((0x30000000&(data))>>28)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_LDOSEL(data)                                     ((0x30000000&(data))>>28)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10POW_shift                                      (27)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10POW_mask                                       (0x08000000)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10POW(data)                                      (0x08000000&((data)<<27))
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10POW_src(data)                                  ((0x08000000&(data))>>27)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_LDOV10POW(data)                                  ((0x08000000&(data))>>27)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10SEL_shift                                      (24)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10SEL_mask                                       (0x03000000)
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10SEL(data)                                      (0x03000000&((data)<<24))
+#define SYS_PLL_EDP1_REG_EDPPLL_LDOV10SEL_src(data)                                  ((0x03000000&(data))>>24)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_LDOV10SEL(data)                                  ((0x03000000&(data))>>24)
+#define SYS_PLL_EDP1_REG_EDPPLL_CS_shift                                             (20)
+#define SYS_PLL_EDP1_REG_EDPPLL_CS_mask                                              (0x00300000)
+#define SYS_PLL_EDP1_REG_EDPPLL_CS(data)                                             (0x00300000&((data)<<20))
+#define SYS_PLL_EDP1_REG_EDPPLL_CS_src(data)                                         ((0x00300000&(data))>>20)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_CS(data)                                         ((0x00300000&(data))>>20)
+#define SYS_PLL_EDP1_REG_EDPPLL_RS_shift                                             (16)
+#define SYS_PLL_EDP1_REG_EDPPLL_RS_mask                                              (0x00070000)
+#define SYS_PLL_EDP1_REG_EDPPLL_RS(data)                                             (0x00070000&((data)<<16))
+#define SYS_PLL_EDP1_REG_EDPPLL_RS_src(data)                                         ((0x00070000&(data))>>16)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_RS(data)                                         ((0x00070000&(data))>>16)
+#define SYS_PLL_EDP1_REG_EDPPLL_CP_shift                                             (15)
+#define SYS_PLL_EDP1_REG_EDPPLL_CP_mask                                              (0x00008000)
+#define SYS_PLL_EDP1_REG_EDPPLL_CP(data)                                             (0x00008000&((data)<<15))
+#define SYS_PLL_EDP1_REG_EDPPLL_CP_src(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_CP(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PLL_EDP1_REG_EDPPLL_IP_shift                                             (12)
+#define SYS_PLL_EDP1_REG_EDPPLL_IP_mask                                              (0x00007000)
+#define SYS_PLL_EDP1_REG_EDPPLL_IP(data)                                             (0x00007000&((data)<<12))
+#define SYS_PLL_EDP1_REG_EDPPLL_IP_src(data)                                         ((0x00007000&(data))>>12)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_IP(data)                                         ((0x00007000&(data))>>12)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV10X_shift                                         (11)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV10X_mask                                          (0x00000800)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV10X(data)                                         (0x00000800&((data)<<11))
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV10X_src(data)                                     ((0x00000800&(data))>>11)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_DIV10X(data)                                     ((0x00000800&(data))>>11)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDRST_shift                                          (9)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDRST_mask                                           (0x00000200)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDRST(data)                                          (0x00000200&((data)<<9))
+#define SYS_PLL_EDP1_REG_EDPPLL_WDRST_src(data)                                      ((0x00000200&(data))>>9)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_WDRST(data)                                      ((0x00000200&(data))>>9)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDSET_shift                                          (8)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDSET_mask                                           (0x00000100)
+#define SYS_PLL_EDP1_REG_EDPPLL_WDSET(data)                                          (0x00000100&((data)<<8))
+#define SYS_PLL_EDP1_REG_EDPPLL_WDSET_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_WDSET(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PLL_EDP1_REG_EDPPLL_N_shift                                              (6)
+#define SYS_PLL_EDP1_REG_EDPPLL_N_mask                                               (0x000000C0)
+#define SYS_PLL_EDP1_REG_EDPPLL_N(data)                                              (0x000000C0&((data)<<6))
+#define SYS_PLL_EDP1_REG_EDPPLL_N_src(data)                                          ((0x000000C0&(data))>>6)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_N(data)                                          ((0x000000C0&(data))>>6)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV_P_shift                                          (4)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV_P_mask                                           (0x00000030)
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV_P(data)                                          (0x00000030&((data)<<4))
+#define SYS_PLL_EDP1_REG_EDPPLL_DIV_P_src(data)                                      ((0x00000030&(data))>>4)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_DIV_P(data)                                      ((0x00000030&(data))>>4)
+#define SYS_PLL_EDP1_REG_EDPPLL_TEST_shift                                           (3)
+#define SYS_PLL_EDP1_REG_EDPPLL_TEST_mask                                            (0x00000008)
+#define SYS_PLL_EDP1_REG_EDPPLL_TEST(data)                                           (0x00000008&((data)<<3))
+#define SYS_PLL_EDP1_REG_EDPPLL_TEST_src(data)                                       ((0x00000008&(data))>>3)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_TEST(data)                                       ((0x00000008&(data))>>3)
+#define SYS_PLL_EDP1_REG_EDPPLL_INCF_shift                                           (2)
+#define SYS_PLL_EDP1_REG_EDPPLL_INCF_mask                                            (0x00000004)
+#define SYS_PLL_EDP1_REG_EDPPLL_INCF(data)                                           (0x00000004&((data)<<2))
+#define SYS_PLL_EDP1_REG_EDPPLL_INCF_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_INCF(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_EDP1_REG_EDPPLL_PI_BPS_shift                                         (1)
+#define SYS_PLL_EDP1_REG_EDPPLL_PI_BPS_mask                                          (0x00000002)
+#define SYS_PLL_EDP1_REG_EDPPLL_PI_BPS(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_EDP1_REG_EDPPLL_PI_BPS_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_EDP1_get_REG_EDPPLL_PI_BPS(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_EDP1_REG_BIAS_POW_shift                                              (0)
+#define SYS_PLL_EDP1_REG_BIAS_POW_mask                                               (0x00000001)
+#define SYS_PLL_EDP1_REG_BIAS_POW(data)                                              (0x00000001&((data)<<0))
+#define SYS_PLL_EDP1_REG_BIAS_POW_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_PLL_EDP1_get_REG_BIAS_POW(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EDP2                                                                 0x9800024C
+#define SYS_PLL_EDP2_reg_addr                                                        "0xD800024C"
+#define SYS_PLL_EDP2_reg                                                             0xD800024C
+#define set_SYS_PLL_EDP2_reg(data)   (*((volatile unsigned int*) SYS_PLL_EDP2_reg)=data)
+#define get_SYS_PLL_EDP2_reg   (*((volatile unsigned int*) SYS_PLL_EDP2_reg))
+#define SYS_PLL_EDP2_inst_adr                                                        "0x0093"
+#define SYS_PLL_EDP2_inst                                                            0x0093
+#define SYS_PLL_EDP2_REG_EDPPLL_RESERVED_shift                                       (2)
+#define SYS_PLL_EDP2_REG_EDPPLL_RESERVED_mask                                        (0x000003FC)
+#define SYS_PLL_EDP2_REG_EDPPLL_RESERVED(data)                                       (0x000003FC&((data)<<2))
+#define SYS_PLL_EDP2_REG_EDPPLL_RESERVED_src(data)                                   ((0x000003FC&(data))>>2)
+#define SYS_PLL_EDP2_get_REG_EDPPLL_RESERVED(data)                                   ((0x000003FC&(data))>>2)
+#define SYS_PLL_EDP2_REG_EDPPLL_RSTB_shift                                           (1)
+#define SYS_PLL_EDP2_REG_EDPPLL_RSTB_mask                                            (0x00000002)
+#define SYS_PLL_EDP2_REG_EDPPLL_RSTB(data)                                           (0x00000002&((data)<<1))
+#define SYS_PLL_EDP2_REG_EDPPLL_RSTB_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_EDP2_get_REG_EDPPLL_RSTB(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_EDP2_REG_EDPPLL_POW_shift                                            (0)
+#define SYS_PLL_EDP2_REG_EDPPLL_POW_mask                                             (0x00000001)
+#define SYS_PLL_EDP2_REG_EDPPLL_POW(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_EDP2_REG_EDPPLL_POW_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_EDP2_get_REG_EDPPLL_POW(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PIXEL1                                                               0x98000250
+#define SYS_PLL_PIXEL1_reg_addr                                                      "0xD8000250"
+#define SYS_PLL_PIXEL1_reg                                                           0xD8000250
+#define set_SYS_PLL_PIXEL1_reg(data)   (*((volatile unsigned int*) SYS_PLL_PIXEL1_reg)=data)
+#define get_SYS_PLL_PIXEL1_reg   (*((volatile unsigned int*) SYS_PLL_PIXEL1_reg))
+#define SYS_PLL_PIXEL1_inst_adr                                                      "0x0094"
+#define SYS_PLL_PIXEL1_inst                                                          0x0094
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOPOW_shift                                     (31)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOPOW_mask                                      (0x80000000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOPOW(data)                                     (0x80000000&((data)<<31))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOPOW_src(data)                                 ((0x80000000&(data))>>31)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_LDOPOW(data)                                 ((0x80000000&(data))>>31)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOSEL_shift                                     (28)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOSEL_mask                                      (0x30000000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOSEL(data)                                     (0x30000000&((data)<<28))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_LDOSEL_src(data)                                 ((0x30000000&(data))>>28)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_LDOSEL(data)                                 ((0x30000000&(data))>>28)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RS_shift                                         (24)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RS_mask                                          (0x07000000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RS(data)                                         (0x07000000&((data)<<24))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RS_src(data)                                     ((0x07000000&(data))>>24)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_RS(data)                                     ((0x07000000&(data))>>24)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_IP_shift                                         (20)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_IP_mask                                          (0x00700000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_IP(data)                                         (0x00700000&((data)<<20))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_IP_src(data)                                     ((0x00700000&(data))>>20)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_IP(data)                                     ((0x00700000&(data))>>20)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CP_shift                                         (18)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CP_mask                                          (0x000C0000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CP(data)                                         (0x000C0000&((data)<<18))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CP_src(data)                                     ((0x000C0000&(data))>>18)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_CP(data)                                     ((0x000C0000&(data))>>18)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CS_shift                                         (16)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CS_mask                                          (0x00030000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CS(data)                                         (0x00030000&((data)<<16))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_CS_src(data)                                     ((0x00030000&(data))>>16)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_CS(data)                                     ((0x00030000&(data))>>16)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RSTB_shift                                       (14)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RSTB_mask                                        (0x00004000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RSTB(data)                                       (0x00004000&((data)<<14))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_RSTB_src(data)                                   ((0x00004000&(data))>>14)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_RSTB(data)                                   ((0x00004000&(data))>>14)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDRST_shift                                      (13)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDRST_mask                                       (0x00002000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDRST(data)                                      (0x00002000&((data)<<13))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDRST_src(data)                                  ((0x00002000&(data))>>13)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_WDRST(data)                                  ((0x00002000&(data))>>13)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDSET_shift                                      (12)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDSET_mask                                       (0x00001000)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDSET(data)                                      (0x00001000&((data)<<12))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_WDSET_src(data)                                  ((0x00001000&(data))>>12)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_WDSET(data)                                  ((0x00001000&(data))>>12)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSIN_shift                                      (11)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSIN_mask                                       (0x00000800)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSIN(data)                                      (0x00000800&((data)<<11))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSIN_src(data)                                  ((0x00000800&(data))>>11)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_BPSIN(data)                                  ((0x00000800&(data))>>11)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_N_shift                                          (8)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_N_mask                                           (0x00000700)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_N(data)                                          (0x00000700&((data)<<8))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_N_src(data)                                      ((0x00000700&(data))>>8)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_N(data)                                      ((0x00000700&(data))>>8)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_VCORSTB_shift                                    (7)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_VCORSTB_mask                                     (0x00000080)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_VCORSTB(data)                                    (0x00000080&((data)<<7))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_VCORSTB_src(data)                                ((0x00000080&(data))>>7)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_VCORSTB(data)                                ((0x00000080&(data))>>7)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_O_shift                                          (4)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_O_mask                                           (0x00000030)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_O(data)                                          (0x00000030&((data)<<4))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_O_src(data)                                      ((0x00000030&(data))>>4)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_O(data)                                      ((0x00000030&(data))>>4)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_TEST_shift                                       (3)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_TEST_mask                                        (0x00000008)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_TEST(data)                                       (0x00000008&((data)<<3))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_TEST_src(data)                                   ((0x00000008&(data))>>3)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_TEST(data)                                   ((0x00000008&(data))>>3)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_FREEZE_shift                                     (2)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_FREEZE_mask                                      (0x00000004)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_FREEZE(data)                                     (0x00000004&((data)<<2))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_FREEZE_src(data)                                 ((0x00000004&(data))>>2)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_FREEZE(data)                                 ((0x00000004&(data))>>2)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSPI_shift                                      (1)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSPI_mask                                       (0x00000002)
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSPI(data)                                      (0x00000002&((data)<<1))
+#define SYS_PLL_PIXEL1_REG_PIXELPLL_BPSPI_src(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_PIXEL1_get_REG_PIXELPLL_BPSPI(data)                                  ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_PIXEL2                                                               0x98000254
+#define SYS_PLL_PIXEL2_reg_addr                                                      "0xD8000254"
+#define SYS_PLL_PIXEL2_reg                                                           0xD8000254
+#define set_SYS_PLL_PIXEL2_reg(data)   (*((volatile unsigned int*) SYS_PLL_PIXEL2_reg)=data)
+#define get_SYS_PLL_PIXEL2_reg   (*((volatile unsigned int*) SYS_PLL_PIXEL2_reg))
+#define SYS_PLL_PIXEL2_inst_adr                                                      "0x0095"
+#define SYS_PLL_PIXEL2_inst                                                          0x0095
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESER_shift                                      (9)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESER_mask                                       (0x00001E00)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESER(data)                                      (0x00001E00&((data)<<9))
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESER_src(data)                                  ((0x00001E00&(data))>>9)
+#define SYS_PLL_PIXEL2_get_REG_PIXELPLL_RESER(data)                                  ((0x00001E00&(data))>>9)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESERVED_shift                                   (1)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESERVED_mask                                    (0x000001FE)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESERVED(data)                                   (0x000001FE&((data)<<1))
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_RESERVED_src(data)                               ((0x000001FE&(data))>>1)
+#define SYS_PLL_PIXEL2_get_REG_PIXELPLL_RESERVED(data)                               ((0x000001FE&(data))>>1)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_POW_shift                                        (0)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_POW_mask                                         (0x00000001)
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_POW(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_PIXEL2_REG_PIXELPLL_POW_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_PIXEL2_get_REG_PIXELPLL_POW(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VODMA1                                                               0x98000260
+#define SYS_PLL_VODMA1_reg_addr                                                      "0xD8000260"
+#define SYS_PLL_VODMA1_reg                                                           0xD8000260
+#define set_SYS_PLL_VODMA1_reg(data)   (*((volatile unsigned int*) SYS_PLL_VODMA1_reg)=data)
+#define get_SYS_PLL_VODMA1_reg   (*((volatile unsigned int*) SYS_PLL_VODMA1_reg))
+#define SYS_PLL_VODMA1_inst_adr                                                      "0x0098"
+#define SYS_PLL_VODMA1_inst                                                          0x0098
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDRST_shift                                      (22)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDRST_mask                                       (0x00400000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDRST(data)                                      (0x00400000&((data)<<22))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDRST_src(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_WDRST(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDSET_shift                                      (21)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDSET_mask                                       (0x00200000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDSET(data)                                      (0x00200000&((data)<<21))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_WDSET_src(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_WDSET(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_CS_shift                                         (19)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_CS_mask                                          (0x00180000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_CS(data)                                         (0x00180000&((data)<<19))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_CS_src(data)                                     ((0x00180000&(data))>>19)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_CS(data)                                     ((0x00180000&(data))>>19)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_O_shift                                          (17)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_O_mask                                           (0x00060000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_O(data)                                          (0x00060000&((data)<<17))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_O_src(data)                                      ((0x00060000&(data))>>17)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_O(data)                                      ((0x00060000&(data))>>17)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_RS_shift                                         (14)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_RS_mask                                          (0x0001C000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_RS(data)                                         (0x0001C000&((data)<<14))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_RS_src(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_RS(data)                                     ((0x0001C000&(data))>>14)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_N_shift                                          (12)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_N_mask                                           (0x00003000)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_N(data)                                          (0x00003000&((data)<<12))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_N_src(data)                                      ((0x00003000&(data))>>12)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_N(data)                                      ((0x00003000&(data))>>12)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_M_shift                                          (4)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_M_mask                                           (0x00000FF0)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_M(data)                                          (0x00000FF0&((data)<<4))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_M_src(data)                                      ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_M(data)                                      ((0x00000FF0&(data))>>4)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_IP_shift                                         (1)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_IP_mask                                          (0x0000000E)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_IP(data)                                         (0x0000000E&((data)<<1))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_IP_src(data)                                     ((0x0000000E&(data))>>1)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_IP(data)                                     ((0x0000000E&(data))>>1)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_TST_shift                                        (0)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_TST_mask                                         (0x00000001)
+#define SYS_PLL_VODMA1_REG_PLLVODMA_TST(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_VODMA1_REG_PLLVODMA_TST_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_VODMA1_get_REG_PLLVODMA_TST(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VODMA2                                                               0x98000264
+#define SYS_PLL_VODMA2_reg_addr                                                      "0xD8000264"
+#define SYS_PLL_VODMA2_reg                                                           0xD8000264
+#define set_SYS_PLL_VODMA2_reg(data)   (*((volatile unsigned int*) SYS_PLL_VODMA2_reg)=data)
+#define get_SYS_PLL_VODMA2_reg   (*((volatile unsigned int*) SYS_PLL_VODMA2_reg))
+#define SYS_PLL_VODMA2_inst_adr                                                      "0x0099"
+#define SYS_PLL_VODMA2_inst                                                          0x0099
+#define SYS_PLL_VODMA2_REG_PLLVODMA_OEB_shift                                        (2)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_OEB_mask                                         (0x00000004)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_OEB(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_VODMA2_REG_PLLVODMA_OEB_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_VODMA2_get_REG_PLLVODMA_OEB(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_RSTB_shift                                       (1)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_RSTB_mask                                        (0x00000002)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_RSTB(data)                                       (0x00000002&((data)<<1))
+#define SYS_PLL_VODMA2_REG_PLLVODMA_RSTB_src(data)                                   ((0x00000002&(data))>>1)
+#define SYS_PLL_VODMA2_get_REG_PLLVODMA_RSTB(data)                                   ((0x00000002&(data))>>1)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_POW_shift                                        (0)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_POW_mask                                         (0x00000001)
+#define SYS_PLL_VODMA2_REG_PLLVODMA_POW(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_VODMA2_REG_PLLVODMA_POW_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_VODMA2_get_REG_PLLVODMA_POW(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_CHIP_INFO2                                                               0x98000308
+#define SYS_CHIP_INFO2_reg_addr                                                      "0xD8000308"
+#define SYS_CHIP_INFO2_reg                                                           0xD8000308
+#define set_SYS_CHIP_INFO2_reg(data)   (*((volatile unsigned int*) SYS_CHIP_INFO2_reg)=data)
+#define get_SYS_CHIP_INFO2_reg   (*((volatile unsigned int*) SYS_CHIP_INFO2_reg))
+#define SYS_CHIP_INFO2_inst_adr                                                      "0x00C2"
+#define SYS_CHIP_INFO2_inst                                                          0x00C2
+#define SYS_CHIP_INFO2_testmode_shift                                                (2)
+#define SYS_CHIP_INFO2_testmode_mask                                                 (0x00000004)
+#define SYS_CHIP_INFO2_testmode(data)                                                (0x00000004&((data)<<2))
+#define SYS_CHIP_INFO2_testmode_src(data)                                            ((0x00000004&(data))>>2)
+#define SYS_CHIP_INFO2_get_testmode(data)                                            ((0x00000004&(data))>>2)
+#define SYS_CHIP_INFO2_nf_sel_shift                                                  (1)
+#define SYS_CHIP_INFO2_nf_sel_mask                                                   (0x00000002)
+#define SYS_CHIP_INFO2_nf_sel(data)                                                  (0x00000002&((data)<<1))
+#define SYS_CHIP_INFO2_nf_sel_src(data)                                              ((0x00000002&(data))>>1)
+#define SYS_CHIP_INFO2_get_nf_sel(data)                                              ((0x00000002&(data))>>1)
+#define SYS_CHIP_INFO2_boot_sel_shift                                                (0)
+#define SYS_CHIP_INFO2_boot_sel_mask                                                 (0x00000001)
+#define SYS_CHIP_INFO2_boot_sel(data)                                                (0x00000001&((data)<<0))
+#define SYS_CHIP_INFO2_boot_sel_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_CHIP_INFO2_get_boot_sel(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_SCPU_L2                                                                  0x9800030C
+#define SYS_SCPU_L2_reg_addr                                                         "0xD800030C"
+#define SYS_SCPU_L2_reg                                                              0xD800030C
+#define set_SYS_SCPU_L2_reg(data)   (*((volatile unsigned int*) SYS_SCPU_L2_reg)=data)
+#define get_SYS_SCPU_L2_reg   (*((volatile unsigned int*) SYS_SCPU_L2_reg))
+#define SYS_SCPU_L2_inst_adr                                                         "0x00C3"
+#define SYS_SCPU_L2_inst                                                             0x00C3
+#define SYS_SCPU_L2_reserved_scpu_l2_shift                                           (0)
+#define SYS_SCPU_L2_reserved_scpu_l2_mask                                            (0x00000001)
+#define SYS_SCPU_L2_reserved_scpu_l2(data)                                           (0x00000001&((data)<<0))
+#define SYS_SCPU_L2_reserved_scpu_l2_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_SCPU_L2_get_reserved_scpu_l2(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_PWDN_CTRL                                                                0x98000320
+#define SYS_PWDN_CTRL_reg_addr                                                       "0xD8000320"
+#define SYS_PWDN_CTRL_reg                                                            0xD8000320
+#define set_SYS_PWDN_CTRL_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL_reg)=data)
+#define get_SYS_PWDN_CTRL_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL_reg))
+#define SYS_PWDN_CTRL_inst_adr                                                       "0x00C8"
+#define SYS_PWDN_CTRL_inst                                                           0x00C8
+#define SYS_PWDN_CTRL_scpu_boot_info_shift                                           (0)
+#define SYS_PWDN_CTRL_scpu_boot_info_mask                                            (0xFFFFFFFF)
+#define SYS_PWDN_CTRL_scpu_boot_info(data)                                           (0xFFFFFFFF&((data)<<0))
+#define SYS_PWDN_CTRL_scpu_boot_info_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define SYS_PWDN_CTRL_get_scpu_boot_info(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_PWDN_CTRL2                                                               0x98000324
+#define SYS_PWDN_CTRL2_reg_addr                                                      "0xD8000324"
+#define SYS_PWDN_CTRL2_reg                                                           0xD8000324
+#define set_SYS_PWDN_CTRL2_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL2_reg)=data)
+#define get_SYS_PWDN_CTRL2_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL2_reg))
+#define SYS_PWDN_CTRL2_inst_adr                                                      "0x00C9"
+#define SYS_PWDN_CTRL2_inst                                                          0x00C9
+#define SYS_PWDN_CTRL2_acpu_boot_info_shift                                          (0)
+#define SYS_PWDN_CTRL2_acpu_boot_info_mask                                           (0xFFFFFFFF)
+#define SYS_PWDN_CTRL2_acpu_boot_info(data)                                          (0xFFFFFFFF&((data)<<0))
+#define SYS_PWDN_CTRL2_acpu_boot_info_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define SYS_PWDN_CTRL2_get_acpu_boot_info(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_PWDN_CTRL3                                                               0x98000328
+#define SYS_PWDN_CTRL3_reg_addr                                                      "0xD8000328"
+#define SYS_PWDN_CTRL3_reg                                                           0xD8000328
+#define set_SYS_PWDN_CTRL3_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL3_reg)=data)
+#define get_SYS_PWDN_CTRL3_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL3_reg))
+#define SYS_PWDN_CTRL3_inst_adr                                                      "0x00CA"
+#define SYS_PWDN_CTRL3_inst                                                          0x00CA
+#define SYS_PWDN_CTRL3_write_en2_shift                                               (3)
+#define SYS_PWDN_CTRL3_write_en2_mask                                                (0x00000008)
+#define SYS_PWDN_CTRL3_write_en2(data)                                               (0x00000008&((data)<<3))
+#define SYS_PWDN_CTRL3_write_en2_src(data)                                           ((0x00000008&(data))>>3)
+#define SYS_PWDN_CTRL3_get_write_en2(data)                                           ((0x00000008&(data))>>3)
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid_shift                                    (2)
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid_mask                                     (0x00000004)
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid(data)                                    (0x00000004&((data)<<2))
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid_src(data)                                ((0x00000004&(data))>>2)
+#define SYS_PWDN_CTRL3_get_scpu_boot_info_valid(data)                                ((0x00000004&(data))>>2)
+#define SYS_PWDN_CTRL3_write_en1_shift                                               (1)
+#define SYS_PWDN_CTRL3_write_en1_mask                                                (0x00000002)
+#define SYS_PWDN_CTRL3_write_en1(data)                                               (0x00000002&((data)<<1))
+#define SYS_PWDN_CTRL3_write_en1_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PWDN_CTRL3_get_write_en1(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PWDN_CTRL3_scpu_sw_rst_shift                                             (0)
+#define SYS_PWDN_CTRL3_scpu_sw_rst_mask                                              (0x00000001)
+#define SYS_PWDN_CTRL3_scpu_sw_rst(data)                                             (0x00000001&((data)<<0))
+#define SYS_PWDN_CTRL3_scpu_sw_rst_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_PWDN_CTRL3_get_scpu_sw_rst(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_PWDN_CTRL4                                                               0x9800032C
+#define SYS_PWDN_CTRL4_reg_addr                                                      "0xD800032C"
+#define SYS_PWDN_CTRL4_reg                                                           0xD800032C
+#define set_SYS_PWDN_CTRL4_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL4_reg)=data)
+#define get_SYS_PWDN_CTRL4_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL4_reg))
+#define SYS_PWDN_CTRL4_inst_adr                                                      "0x00CB"
+#define SYS_PWDN_CTRL4_inst                                                          0x00CB
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid_shift                                    (0)
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid_mask                                     (0x00000001)
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid(data)                                    (0x00000001&((data)<<0))
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid_src(data)                                ((0x00000001&(data))>>0)
+#define SYS_PWDN_CTRL4_get_acpu_boot_info_valid(data)                                ((0x00000001&(data))>>0)
+
+
+#define SYS_AT_SPEED                                                                 0x98000330
+#define SYS_AT_SPEED_reg_addr                                                        "0xD8000330"
+#define SYS_AT_SPEED_reg                                                             0xD8000330
+#define set_SYS_AT_SPEED_reg(data)   (*((volatile unsigned int*) SYS_AT_SPEED_reg)=data)
+#define get_SYS_AT_SPEED_reg   (*((volatile unsigned int*) SYS_AT_SPEED_reg))
+#define SYS_AT_SPEED_inst_adr                                                        "0x00CC"
+#define SYS_AT_SPEED_inst                                                            0x00CC
+#define SYS_AT_SPEED_write_en3_shift                                                 (5)
+#define SYS_AT_SPEED_write_en3_mask                                                  (0x00000020)
+#define SYS_AT_SPEED_write_en3(data)                                                 (0x00000020&((data)<<5))
+#define SYS_AT_SPEED_write_en3_src(data)                                             ((0x00000020&(data))>>5)
+#define SYS_AT_SPEED_get_write_en3(data)                                             ((0x00000020&(data))>>5)
+#define SYS_AT_SPEED_hdmirx_at_speed_pll_done_shift                                  (4)
+#define SYS_AT_SPEED_hdmirx_at_speed_pll_done_mask                                   (0x00000010)
+#define SYS_AT_SPEED_hdmirx_at_speed_pll_done(data)                                  (0x00000010&((data)<<4))
+#define SYS_AT_SPEED_hdmirx_at_speed_pll_done_src(data)                              ((0x00000010&(data))>>4)
+#define SYS_AT_SPEED_get_hdmirx_at_speed_pll_done(data)                              ((0x00000010&(data))>>4)
+#define SYS_AT_SPEED_write_en2_shift                                                 (3)
+#define SYS_AT_SPEED_write_en2_mask                                                  (0x00000008)
+#define SYS_AT_SPEED_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define SYS_AT_SPEED_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define SYS_AT_SPEED_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define SYS_AT_SPEED_dac_test_shift                                                  (2)
+#define SYS_AT_SPEED_dac_test_mask                                                   (0x00000004)
+#define SYS_AT_SPEED_dac_test(data)                                                  (0x00000004&((data)<<2))
+#define SYS_AT_SPEED_dac_test_src(data)                                              ((0x00000004&(data))>>2)
+#define SYS_AT_SPEED_get_dac_test(data)                                              ((0x00000004&(data))>>2)
+#define SYS_AT_SPEED_write_en1_shift                                                 (1)
+#define SYS_AT_SPEED_write_en1_mask                                                  (0x00000002)
+#define SYS_AT_SPEED_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define SYS_AT_SPEED_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define SYS_AT_SPEED_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define SYS_AT_SPEED_scpu_config_done_shift                                          (0)
+#define SYS_AT_SPEED_scpu_config_done_mask                                           (0x00000001)
+#define SYS_AT_SPEED_scpu_config_done(data)                                          (0x00000001&((data)<<0))
+#define SYS_AT_SPEED_scpu_config_done_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_AT_SPEED_get_scpu_config_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_ANA_CTRL                                                                 0x98000334
+#define SYS_ANA_CTRL_reg_addr                                                        "0xD8000334"
+#define SYS_ANA_CTRL_reg                                                             0xD8000334
+#define set_SYS_ANA_CTRL_reg(data)   (*((volatile unsigned int*) SYS_ANA_CTRL_reg)=data)
+#define get_SYS_ANA_CTRL_reg   (*((volatile unsigned int*) SYS_ANA_CTRL_reg))
+#define SYS_ANA_CTRL_inst_adr                                                        "0x00CD"
+#define SYS_ANA_CTRL_inst                                                            0x00CD
+#define SYS_ANA_CTRL_reserved_ana_ctrl_shift                                         (0)
+#define SYS_ANA_CTRL_reserved_ana_ctrl_mask                                          (0x00000001)
+#define SYS_ANA_CTRL_reserved_ana_ctrl(data)                                         (0x00000001&((data)<<0))
+#define SYS_ANA_CTRL_reserved_ana_ctrl_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_ANA_CTRL_get_reserved_ana_ctrl(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_TP_DEMOD_CTRL                                                            0x98000338
+#define SYS_TP_DEMOD_CTRL_reg_addr                                                   "0xD8000338"
+#define SYS_TP_DEMOD_CTRL_reg                                                        0xD8000338
+#define set_SYS_TP_DEMOD_CTRL_reg(data)   (*((volatile unsigned int*) SYS_TP_DEMOD_CTRL_reg)=data)
+#define get_SYS_TP_DEMOD_CTRL_reg   (*((volatile unsigned int*) SYS_TP_DEMOD_CTRL_reg))
+#define SYS_TP_DEMOD_CTRL_inst_adr                                                   "0x00CE"
+#define SYS_TP_DEMOD_CTRL_inst                                                       0x00CE
+#define SYS_TP_DEMOD_CTRL_reserved_tp_demod_ctrl_shift                               (0)
+#define SYS_TP_DEMOD_CTRL_reserved_tp_demod_ctrl_mask                                (0x00000001)
+#define SYS_TP_DEMOD_CTRL_reserved_tp_demod_ctrl(data)                               (0x00000001&((data)<<0))
+#define SYS_TP_DEMOD_CTRL_reserved_tp_demod_ctrl_src(data)                           ((0x00000001&(data))>>0)
+#define SYS_TP_DEMOD_CTRL_get_reserved_tp_demod_ctrl(data)                           ((0x00000001&(data))>>0)
+
+
+#define SYS_PHY_FUNC                                                                 0x98000340
+#define SYS_PHY_FUNC_reg_addr                                                        "0xD8000340"
+#define SYS_PHY_FUNC_reg                                                             0xD8000340
+#define set_SYS_PHY_FUNC_reg(data)   (*((volatile unsigned int*) SYS_PHY_FUNC_reg)=data)
+#define get_SYS_PHY_FUNC_reg   (*((volatile unsigned int*) SYS_PHY_FUNC_reg))
+#define SYS_PHY_FUNC_inst_adr                                                        "0x00D0"
+#define SYS_PHY_FUNC_inst                                                            0x00D0
+#define SYS_PHY_FUNC_reserved_phy_func_shift                                         (0)
+#define SYS_PHY_FUNC_reserved_phy_func_mask                                          (0x00000001)
+#define SYS_PHY_FUNC_reserved_phy_func(data)                                         (0x00000001&((data)<<0))
+#define SYS_PHY_FUNC_reserved_phy_func_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PHY_FUNC_get_reserved_phy_func(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_ANLG                                                                     0x98000344
+#define SYS_ANLG_reg_addr                                                            "0xD8000344"
+#define SYS_ANLG_reg                                                                 0xD8000344
+#define set_SYS_ANLG_reg(data)   (*((volatile unsigned int*) SYS_ANLG_reg)=data)
+#define get_SYS_ANLG_reg   (*((volatile unsigned int*) SYS_ANLG_reg))
+#define SYS_ANLG_inst_adr                                                            "0x00D1"
+#define SYS_ANLG_inst                                                                0x00D1
+#define SYS_ANLG_analogy_mode_sel_shift                                              (0)
+#define SYS_ANLG_analogy_mode_sel_mask                                               (0x0000000F)
+#define SYS_ANLG_analogy_mode_sel(data)                                              (0x0000000F&((data)<<0))
+#define SYS_ANLG_analogy_mode_sel_src(data)                                          ((0x0000000F&(data))>>0)
+#define SYS_ANLG_get_analogy_mode_sel(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define SYS_PLL_TEST1                                                                0x98000348
+#define SYS_PLL_TEST1_reg_addr                                                       "0xD8000348"
+#define SYS_PLL_TEST1_reg                                                            0xD8000348
+#define set_SYS_PLL_TEST1_reg(data)   (*((volatile unsigned int*) SYS_PLL_TEST1_reg)=data)
+#define get_SYS_PLL_TEST1_reg   (*((volatile unsigned int*) SYS_PLL_TEST1_reg))
+#define SYS_PLL_TEST1_inst_adr                                                       "0x00D2"
+#define SYS_PLL_TEST1_inst                                                           0x00D2
+#define SYS_PLL_TEST1_REG_TEST_EN_shift                                              (9)
+#define SYS_PLL_TEST1_REG_TEST_EN_mask                                               (0x00000200)
+#define SYS_PLL_TEST1_REG_TEST_EN(data)                                              (0x00000200&((data)<<9))
+#define SYS_PLL_TEST1_REG_TEST_EN_src(data)                                          ((0x00000200&(data))>>9)
+#define SYS_PLL_TEST1_get_REG_TEST_EN(data)                                          ((0x00000200&(data))>>9)
+#define SYS_PLL_TEST1_REG_PLLTST_EN_shift                                            (8)
+#define SYS_PLL_TEST1_REG_PLLTST_EN_mask                                             (0x00000100)
+#define SYS_PLL_TEST1_REG_PLLTST_EN(data)                                            (0x00000100&((data)<<8))
+#define SYS_PLL_TEST1_REG_PLLTST_EN_src(data)                                        ((0x00000100&(data))>>8)
+#define SYS_PLL_TEST1_get_REG_PLLTST_EN(data)                                        ((0x00000100&(data))>>8)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV32_shift                                         (7)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV32_mask                                          (0x00000080)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV32(data)                                         (0x00000080&((data)<<7))
+#define SYS_PLL_TEST1_REG_PLLTST_DIV32_src(data)                                     ((0x00000080&(data))>>7)
+#define SYS_PLL_TEST1_get_REG_PLLTST_DIV32(data)                                     ((0x00000080&(data))>>7)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV16_shift                                         (6)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV16_mask                                          (0x00000040)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV16(data)                                         (0x00000040&((data)<<6))
+#define SYS_PLL_TEST1_REG_PLLTST_DIV16_src(data)                                     ((0x00000040&(data))>>6)
+#define SYS_PLL_TEST1_get_REG_PLLTST_DIV16(data)                                     ((0x00000040&(data))>>6)
+#define SYS_PLL_TEST1_REG_PLLTST_SEL_shift                                           (2)
+#define SYS_PLL_TEST1_REG_PLLTST_SEL_mask                                            (0x0000003C)
+#define SYS_PLL_TEST1_REG_PLLTST_SEL(data)                                           (0x0000003C&((data)<<2))
+#define SYS_PLL_TEST1_REG_PLLTST_SEL_src(data)                                       ((0x0000003C&(data))>>2)
+#define SYS_PLL_TEST1_get_REG_PLLTST_SEL(data)                                       ((0x0000003C&(data))>>2)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV_shift                                           (0)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV_mask                                            (0x00000003)
+#define SYS_PLL_TEST1_REG_PLLTST_DIV(data)                                           (0x00000003&((data)<<0))
+#define SYS_PLL_TEST1_REG_PLLTST_DIV_src(data)                                       ((0x00000003&(data))>>0)
+#define SYS_PLL_TEST1_get_REG_PLLTST_DIV(data)                                       ((0x00000003&(data))>>0)
+
+
+#define SYS_LSADC_PG                                                                 0x9800034c
+#define SYS_LSADC_PG_reg_addr                                                        "0xD800034C"
+#define SYS_LSADC_PG_reg                                                             0xD800034C
+#define set_SYS_LSADC_PG_reg(data)   (*((volatile unsigned int*) SYS_LSADC_PG_reg)=data)
+#define get_SYS_LSADC_PG_reg   (*((volatile unsigned int*) SYS_LSADC_PG_reg))
+#define SYS_LSADC_PG_inst_adr                                                        "0x00D3"
+#define SYS_LSADC_PG_inst                                                            0x00D3
+#define SYS_LSADC_PG_REG_VDDMUX_SEL_shift                                            (10)
+#define SYS_LSADC_PG_REG_VDDMUX_SEL_mask                                             (0x00000400)
+#define SYS_LSADC_PG_REG_VDDMUX_SEL(data)                                            (0x00000400&((data)<<10))
+#define SYS_LSADC_PG_REG_VDDMUX_SEL_src(data)                                        ((0x00000400&(data))>>10)
+#define SYS_LSADC_PG_get_REG_VDDMUX_SEL(data)                                        ((0x00000400&(data))>>10)
+#define SYS_LSADC_PG_REG_VDD_MUX1_shift                                              (6)
+#define SYS_LSADC_PG_REG_VDD_MUX1_mask                                               (0x000003C0)
+#define SYS_LSADC_PG_REG_VDD_MUX1(data)                                              (0x000003C0&((data)<<6))
+#define SYS_LSADC_PG_REG_VDD_MUX1_src(data)                                          ((0x000003C0&(data))>>6)
+#define SYS_LSADC_PG_get_REG_VDD_MUX1(data)                                          ((0x000003C0&(data))>>6)
+#define SYS_LSADC_PG_REG_VDD_MUX2_shift                                              (2)
+#define SYS_LSADC_PG_REG_VDD_MUX2_mask                                               (0x0000003C)
+#define SYS_LSADC_PG_REG_VDD_MUX2(data)                                              (0x0000003C&((data)<<2))
+#define SYS_LSADC_PG_REG_VDD_MUX2_src(data)                                          ((0x0000003C&(data))>>2)
+#define SYS_LSADC_PG_get_REG_VDD_MUX2(data)                                          ((0x0000003C&(data))>>2)
+#define SYS_LSADC_PG_REG_VDDMUX_EN_shift                                             (1)
+#define SYS_LSADC_PG_REG_VDDMUX_EN_mask                                              (0x00000002)
+#define SYS_LSADC_PG_REG_VDDMUX_EN(data)                                             (0x00000002&((data)<<1))
+#define SYS_LSADC_PG_REG_VDDMUX_EN_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_LSADC_PG_get_REG_VDDMUX_EN(data)                                         ((0x00000002&(data))>>1)
+#define SYS_LSADC_PG_REG_TEST_OUT_EN_shift                                           (0)
+#define SYS_LSADC_PG_REG_TEST_OUT_EN_mask                                            (0x00000001)
+#define SYS_LSADC_PG_REG_TEST_OUT_EN(data)                                           (0x00000001&((data)<<0))
+#define SYS_LSADC_PG_REG_TEST_OUT_EN_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_LSADC_PG_get_REG_TEST_OUT_EN(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_SCAN_CTRL                                                                0x98000350
+#define SYS_SCAN_CTRL_reg_addr                                                       "0xD8000350"
+#define SYS_SCAN_CTRL_reg                                                            0xD8000350
+#define set_SYS_SCAN_CTRL_reg(data)   (*((volatile unsigned int*) SYS_SCAN_CTRL_reg)=data)
+#define get_SYS_SCAN_CTRL_reg   (*((volatile unsigned int*) SYS_SCAN_CTRL_reg))
+#define SYS_SCAN_CTRL_inst_adr                                                       "0x00D4"
+#define SYS_SCAN_CTRL_inst                                                           0x00D4
+#define SYS_SCAN_CTRL_scan_occ_chain_sel_shift                                       (0)
+#define SYS_SCAN_CTRL_scan_occ_chain_sel_mask                                        (0x00000001)
+#define SYS_SCAN_CTRL_scan_occ_chain_sel(data)                                       (0x00000001&((data)<<0))
+#define SYS_SCAN_CTRL_scan_occ_chain_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_SCAN_CTRL_get_scan_occ_chain_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR0                                                           0x98000360
+#define SYS_DISP_SRAM_PWR0_reg_addr                                                  "0xD8000360"
+#define SYS_DISP_SRAM_PWR0_reg                                                       0xD8000360
+#define set_SYS_DISP_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR0_reg)=data)
+#define get_SYS_DISP_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR0_reg))
+#define SYS_DISP_SRAM_PWR0_inst_adr                                                  "0x00D8"
+#define SYS_DISP_SRAM_PWR0_inst                                                      0x00D8
+#define SYS_DISP_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                     (0)
+#define SYS_DISP_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                      (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR1                                                           0x98000364
+#define SYS_DISP_SRAM_PWR1_reg_addr                                                  "0xD8000364"
+#define SYS_DISP_SRAM_PWR1_reg                                                       0xD8000364
+#define set_SYS_DISP_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR1_reg)=data)
+#define get_SYS_DISP_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR1_reg))
+#define SYS_DISP_SRAM_PWR1_inst_adr                                                  "0x00D9"
+#define SYS_DISP_SRAM_PWR1_inst                                                      0x00D9
+#define SYS_DISP_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                     (0)
+#define SYS_DISP_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                      (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR2                                                           0x98000368
+#define SYS_DISP_SRAM_PWR2_reg_addr                                                  "0xD8000368"
+#define SYS_DISP_SRAM_PWR2_reg                                                       0xD8000368
+#define set_SYS_DISP_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR2_reg)=data)
+#define get_SYS_DISP_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR2_reg))
+#define SYS_DISP_SRAM_PWR2_inst_adr                                                  "0x00DA"
+#define SYS_DISP_SRAM_PWR2_inst                                                      0x00DA
+#define SYS_DISP_SRAM_PWR2_SD_REG_shift                                              (0)
+#define SYS_DISP_SRAM_PWR2_SD_REG_mask                                               (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR2_SD_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR2_SD_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR2_get_SD_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR3                                                           0x9800036c
+#define SYS_DISP_SRAM_PWR3_reg_addr                                                  "0xD800036C"
+#define SYS_DISP_SRAM_PWR3_reg                                                       0xD800036C
+#define set_SYS_DISP_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR3_reg)=data)
+#define get_SYS_DISP_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR3_reg))
+#define SYS_DISP_SRAM_PWR3_inst_adr                                                  "0x00DB"
+#define SYS_DISP_SRAM_PWR3_inst                                                      0x00DB
+#define SYS_DISP_SRAM_PWR3_MUX_REG_shift                                             (0)
+#define SYS_DISP_SRAM_PWR3_MUX_REG_mask                                              (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR3_MUX_REG(data)                                             (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR3_MUX_REG_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR3_get_MUX_REG(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR4                                                           0x98000370
+#define SYS_DISP_SRAM_PWR4_reg_addr                                                  "0xD8000370"
+#define SYS_DISP_SRAM_PWR4_reg                                                       0xD8000370
+#define set_SYS_DISP_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR4_reg)=data)
+#define get_SYS_DISP_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR4_reg))
+#define SYS_DISP_SRAM_PWR4_inst_adr                                                  "0x00DC"
+#define SYS_DISP_SRAM_PWR4_inst                                                      0x00DC
+#define SYS_DISP_SRAM_PWR4_CTRL_shift                                                (0)
+#define SYS_DISP_SRAM_PWR4_CTRL_mask                                                 (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR4_CTRL(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR4_CTRL_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR4_get_CTRL(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR5                                                           0x98000374
+#define SYS_DISP_SRAM_PWR5_reg_addr                                                  "0xD8000374"
+#define SYS_DISP_SRAM_PWR5_reg                                                       0xD8000374
+#define set_SYS_DISP_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR5_reg)=data)
+#define get_SYS_DISP_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR5_reg))
+#define SYS_DISP_SRAM_PWR5_inst_adr                                                  "0x00DD"
+#define SYS_DISP_SRAM_PWR5_inst                                                      0x00DD
+#define SYS_DISP_SRAM_PWR5_disp_sram_int_shift                                       (2)
+#define SYS_DISP_SRAM_PWR5_disp_sram_int_mask                                        (0x00000004)
+#define SYS_DISP_SRAM_PWR5_disp_sram_int(data)                                       (0x00000004&((data)<<2))
+#define SYS_DISP_SRAM_PWR5_disp_sram_int_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_DISP_SRAM_PWR5_get_disp_sram_int(data)                                   ((0x00000004&(data))>>2)
+#define SYS_DISP_SRAM_PWR5_write_data_shift                                          (0)
+#define SYS_DISP_SRAM_PWR5_write_data_mask                                           (0x00000001)
+#define SYS_DISP_SRAM_PWR5_write_data(data)                                          (0x00000001&((data)<<0))
+#define SYS_DISP_SRAM_PWR5_write_data_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_DISP_SRAM_PWR5_get_write_data(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR6                                                           0x98000378
+#define SYS_DISP_SRAM_PWR6_reg_addr                                                  "0xD8000378"
+#define SYS_DISP_SRAM_PWR6_reg                                                       0xD8000378
+#define set_SYS_DISP_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR6_reg)=data)
+#define get_SYS_DISP_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR6_reg))
+#define SYS_DISP_SRAM_PWR6_inst_adr                                                  "0x00DE"
+#define SYS_DISP_SRAM_PWR6_inst                                                      0x00DE
+#define SYS_DISP_SRAM_PWR6_last_delay_cycle_shift                                    (0)
+#define SYS_DISP_SRAM_PWR6_last_delay_cycle_mask                                     (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR6_last_delay_cycle(data)                                    (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR6_last_delay_cycle_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR6_get_last_delay_cycle(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DISP_SRAM_PWR7                                                           0x9800037c
+#define SYS_DISP_SRAM_PWR7_reg_addr                                                  "0xD800037C"
+#define SYS_DISP_SRAM_PWR7_reg                                                       0xD800037C
+#define set_SYS_DISP_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR7_reg)=data)
+#define get_SYS_DISP_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_DISP_SRAM_PWR7_reg))
+#define SYS_DISP_SRAM_PWR7_inst_adr                                                  "0x00DF"
+#define SYS_DISP_SRAM_PWR7_inst                                                      0x00DF
+#define SYS_DISP_SRAM_PWR7_pg_switch_info_shift                                      (0)
+#define SYS_DISP_SRAM_PWR7_pg_switch_info_mask                                       (0xFFFFFFFF)
+#define SYS_DISP_SRAM_PWR7_pg_switch_info(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_DISP_SRAM_PWR7_pg_switch_info_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_DISP_SRAM_PWR7_get_pg_switch_info(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR0                                                            0x98000380
+#define SYS_VE1_SRAM_PWR0_reg_addr                                                   "0xD8000380"
+#define SYS_VE1_SRAM_PWR0_reg                                                        0xD8000380
+#define set_SYS_VE1_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR0_reg)=data)
+#define get_SYS_VE1_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR0_reg))
+#define SYS_VE1_SRAM_PWR0_inst_adr                                                   "0x00E0"
+#define SYS_VE1_SRAM_PWR0_inst                                                       0x00E0
+#define SYS_VE1_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE1_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR1                                                            0x98000384
+#define SYS_VE1_SRAM_PWR1_reg_addr                                                   "0xD8000384"
+#define SYS_VE1_SRAM_PWR1_reg                                                        0xD8000384
+#define set_SYS_VE1_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR1_reg)=data)
+#define get_SYS_VE1_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR1_reg))
+#define SYS_VE1_SRAM_PWR1_inst_adr                                                   "0x00E1"
+#define SYS_VE1_SRAM_PWR1_inst                                                       0x00E1
+#define SYS_VE1_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE1_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR2                                                            0x98000388
+#define SYS_VE1_SRAM_PWR2_reg_addr                                                   "0xD8000388"
+#define SYS_VE1_SRAM_PWR2_reg                                                        0xD8000388
+#define set_SYS_VE1_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR2_reg)=data)
+#define get_SYS_VE1_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR2_reg))
+#define SYS_VE1_SRAM_PWR2_inst_adr                                                   "0x00E2"
+#define SYS_VE1_SRAM_PWR2_inst                                                       0x00E2
+#define SYS_VE1_SRAM_PWR2_SD_REG_shift                                               (0)
+#define SYS_VE1_SRAM_PWR2_SD_REG_mask                                                (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR2_SD_REG(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR2_SD_REG_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR2_get_SD_REG(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR3                                                            0x9800038c
+#define SYS_VE1_SRAM_PWR3_reg_addr                                                   "0xD800038C"
+#define SYS_VE1_SRAM_PWR3_reg                                                        0xD800038C
+#define set_SYS_VE1_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR3_reg)=data)
+#define get_SYS_VE1_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR3_reg))
+#define SYS_VE1_SRAM_PWR3_inst_adr                                                   "0x00E3"
+#define SYS_VE1_SRAM_PWR3_inst                                                       0x00E3
+#define SYS_VE1_SRAM_PWR3_MUX_REG_shift                                              (0)
+#define SYS_VE1_SRAM_PWR3_MUX_REG_mask                                               (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR3_MUX_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR3_MUX_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR3_get_MUX_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR4                                                            0x98000390
+#define SYS_VE1_SRAM_PWR4_reg_addr                                                   "0xD8000390"
+#define SYS_VE1_SRAM_PWR4_reg                                                        0xD8000390
+#define set_SYS_VE1_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR4_reg)=data)
+#define get_SYS_VE1_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR4_reg))
+#define SYS_VE1_SRAM_PWR4_inst_adr                                                   "0x00E4"
+#define SYS_VE1_SRAM_PWR4_inst                                                       0x00E4
+#define SYS_VE1_SRAM_PWR4_CTRL_shift                                                 (0)
+#define SYS_VE1_SRAM_PWR4_CTRL_mask                                                  (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR4_CTRL(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR4_CTRL_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR4_get_CTRL(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR0                                                            0x98000394
+#define SYS_GPU_SRAM_PWR0_reg_addr                                                   "0xD8000394"
+#define SYS_GPU_SRAM_PWR0_reg                                                        0xD8000394
+#define set_SYS_GPU_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR0_reg)=data)
+#define get_SYS_GPU_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR0_reg))
+#define SYS_GPU_SRAM_PWR0_inst_adr                                                   "0x00E5"
+#define SYS_GPU_SRAM_PWR0_inst                                                       0x00E5
+#define SYS_GPU_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                      (0)
+#define SYS_GPU_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR1                                                            0x98000398
+#define SYS_GPU_SRAM_PWR1_reg_addr                                                   "0xD8000398"
+#define SYS_GPU_SRAM_PWR1_reg                                                        0xD8000398
+#define set_SYS_GPU_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR1_reg)=data)
+#define get_SYS_GPU_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR1_reg))
+#define SYS_GPU_SRAM_PWR1_inst_adr                                                   "0x00E6"
+#define SYS_GPU_SRAM_PWR1_inst                                                       0x00E6
+#define SYS_GPU_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                      (0)
+#define SYS_GPU_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR2                                                            0x9800039c
+#define SYS_GPU_SRAM_PWR2_reg_addr                                                   "0xD800039C"
+#define SYS_GPU_SRAM_PWR2_reg                                                        0xD800039C
+#define set_SYS_GPU_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR2_reg)=data)
+#define get_SYS_GPU_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR2_reg))
+#define SYS_GPU_SRAM_PWR2_inst_adr                                                   "0x00E7"
+#define SYS_GPU_SRAM_PWR2_inst                                                       0x00E7
+#define SYS_GPU_SRAM_PWR2_SD_REG_shift                                               (0)
+#define SYS_GPU_SRAM_PWR2_SD_REG_mask                                                (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR2_SD_REG(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR2_SD_REG_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR2_get_SD_REG(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR3                                                            0x980003a0
+#define SYS_GPU_SRAM_PWR3_reg_addr                                                   "0xD80003A0"
+#define SYS_GPU_SRAM_PWR3_reg                                                        0xD80003A0
+#define set_SYS_GPU_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR3_reg)=data)
+#define get_SYS_GPU_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR3_reg))
+#define SYS_GPU_SRAM_PWR3_inst_adr                                                   "0x00E8"
+#define SYS_GPU_SRAM_PWR3_inst                                                       0x00E8
+#define SYS_GPU_SRAM_PWR3_MUX_REG_shift                                              (0)
+#define SYS_GPU_SRAM_PWR3_MUX_REG_mask                                               (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR3_MUX_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR3_MUX_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR3_get_MUX_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR4                                                            0x980003a4
+#define SYS_GPU_SRAM_PWR4_reg_addr                                                   "0xD80003A4"
+#define SYS_GPU_SRAM_PWR4_reg                                                        0xD80003A4
+#define set_SYS_GPU_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR4_reg)=data)
+#define get_SYS_GPU_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR4_reg))
+#define SYS_GPU_SRAM_PWR4_inst_adr                                                   "0x00E9"
+#define SYS_GPU_SRAM_PWR4_inst                                                       0x00E9
+#define SYS_GPU_SRAM_PWR4_CTRL_shift                                                 (0)
+#define SYS_GPU_SRAM_PWR4_CTRL_mask                                                  (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR4_CTRL(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR4_CTRL_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR4_get_CTRL(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR5                                                            0x980003a8
+#define SYS_VE1_SRAM_PWR5_reg_addr                                                   "0xD80003A8"
+#define SYS_VE1_SRAM_PWR5_reg                                                        0xD80003A8
+#define set_SYS_VE1_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR5_reg)=data)
+#define get_SYS_VE1_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR5_reg))
+#define SYS_VE1_SRAM_PWR5_inst_adr                                                   "0x00EA"
+#define SYS_VE1_SRAM_PWR5_inst                                                       0x00EA
+#define SYS_VE1_SRAM_PWR5_ve1_sram_int_shift                                         (2)
+#define SYS_VE1_SRAM_PWR5_ve1_sram_int_mask                                          (0x00000004)
+#define SYS_VE1_SRAM_PWR5_ve1_sram_int(data)                                         (0x00000004&((data)<<2))
+#define SYS_VE1_SRAM_PWR5_ve1_sram_int_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE1_SRAM_PWR5_get_ve1_sram_int(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE1_SRAM_PWR5_write_data_shift                                           (0)
+#define SYS_VE1_SRAM_PWR5_write_data_mask                                            (0x00000001)
+#define SYS_VE1_SRAM_PWR5_write_data(data)                                           (0x00000001&((data)<<0))
+#define SYS_VE1_SRAM_PWR5_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_VE1_SRAM_PWR5_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR5                                                            0x980003ac
+#define SYS_GPU_SRAM_PWR5_reg_addr                                                   "0xD80003AC"
+#define SYS_GPU_SRAM_PWR5_reg                                                        0xD80003AC
+#define set_SYS_GPU_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR5_reg)=data)
+#define get_SYS_GPU_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR5_reg))
+#define SYS_GPU_SRAM_PWR5_inst_adr                                                   "0x00EB"
+#define SYS_GPU_SRAM_PWR5_inst                                                       0x00EB
+#define SYS_GPU_SRAM_PWR5_gpu_sram_int_shift                                         (2)
+#define SYS_GPU_SRAM_PWR5_gpu_sram_int_mask                                          (0x00000004)
+#define SYS_GPU_SRAM_PWR5_gpu_sram_int(data)                                         (0x00000004&((data)<<2))
+#define SYS_GPU_SRAM_PWR5_gpu_sram_int_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_GPU_SRAM_PWR5_get_gpu_sram_int(data)                                     ((0x00000004&(data))>>2)
+#define SYS_GPU_SRAM_PWR5_write_data_shift                                           (0)
+#define SYS_GPU_SRAM_PWR5_write_data_mask                                            (0x00000001)
+#define SYS_GPU_SRAM_PWR5_write_data(data)                                           (0x00000001&((data)<<0))
+#define SYS_GPU_SRAM_PWR5_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_GPU_SRAM_PWR5_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR6                                                            0x980003b0
+#define SYS_VE1_SRAM_PWR6_reg_addr                                                   "0xD80003B0"
+#define SYS_VE1_SRAM_PWR6_reg                                                        0xD80003B0
+#define set_SYS_VE1_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR6_reg)=data)
+#define get_SYS_VE1_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR6_reg))
+#define SYS_VE1_SRAM_PWR6_inst_adr                                                   "0x00EC"
+#define SYS_VE1_SRAM_PWR6_inst                                                       0x00EC
+#define SYS_VE1_SRAM_PWR6_last_delay_cycle_shift                                     (0)
+#define SYS_VE1_SRAM_PWR6_last_delay_cycle_mask                                      (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR6_last_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR6_last_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR6_get_last_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR6                                                            0x980003b4
+#define SYS_GPU_SRAM_PWR6_reg_addr                                                   "0xD80003B4"
+#define SYS_GPU_SRAM_PWR6_reg                                                        0xD80003B4
+#define set_SYS_GPU_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR6_reg)=data)
+#define get_SYS_GPU_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR6_reg))
+#define SYS_GPU_SRAM_PWR6_inst_adr                                                   "0x00ED"
+#define SYS_GPU_SRAM_PWR6_inst                                                       0x00ED
+#define SYS_GPU_SRAM_PWR6_last_delay_cycle_shift                                     (0)
+#define SYS_GPU_SRAM_PWR6_last_delay_cycle_mask                                      (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR6_last_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR6_last_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR6_get_last_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE1_SRAM_PWR7                                                            0x980003b8
+#define SYS_VE1_SRAM_PWR7_reg_addr                                                   "0xD80003B8"
+#define SYS_VE1_SRAM_PWR7_reg                                                        0xD80003B8
+#define set_SYS_VE1_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR7_reg)=data)
+#define get_SYS_VE1_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_VE1_SRAM_PWR7_reg))
+#define SYS_VE1_SRAM_PWR7_inst_adr                                                   "0x00EE"
+#define SYS_VE1_SRAM_PWR7_inst                                                       0x00EE
+#define SYS_VE1_SRAM_PWR7_pg_switch_info_shift                                       (0)
+#define SYS_VE1_SRAM_PWR7_pg_switch_info_mask                                        (0xFFFFFFFF)
+#define SYS_VE1_SRAM_PWR7_pg_switch_info(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SYS_VE1_SRAM_PWR7_pg_switch_info_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE1_SRAM_PWR7_get_pg_switch_info(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_GPU_SRAM_PWR7                                                            0x980003bc
+#define SYS_GPU_SRAM_PWR7_reg_addr                                                   "0xD80003BC"
+#define SYS_GPU_SRAM_PWR7_reg                                                        0xD80003BC
+#define set_SYS_GPU_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR7_reg)=data)
+#define get_SYS_GPU_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_GPU_SRAM_PWR7_reg))
+#define SYS_GPU_SRAM_PWR7_inst_adr                                                   "0x00EF"
+#define SYS_GPU_SRAM_PWR7_inst                                                       0x00EF
+#define SYS_GPU_SRAM_PWR7_pg_switch_info_shift                                       (0)
+#define SYS_GPU_SRAM_PWR7_pg_switch_info_mask                                        (0xFFFFFFFF)
+#define SYS_GPU_SRAM_PWR7_pg_switch_info(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SYS_GPU_SRAM_PWR7_pg_switch_info_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SYS_GPU_SRAM_PWR7_get_pg_switch_info(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR0                                                            0x980003c0
+#define SYS_VE2_SRAM_PWR0_reg_addr                                                   "0xD80003C0"
+#define SYS_VE2_SRAM_PWR0_reg                                                        0xD80003C0
+#define set_SYS_VE2_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR0_reg)=data)
+#define get_SYS_VE2_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR0_reg))
+#define SYS_VE2_SRAM_PWR0_inst_adr                                                   "0x00F0"
+#define SYS_VE2_SRAM_PWR0_inst                                                       0x00F0
+#define SYS_VE2_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE2_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR1                                                            0x980003c4
+#define SYS_VE2_SRAM_PWR1_reg_addr                                                   "0xD80003C4"
+#define SYS_VE2_SRAM_PWR1_reg                                                        0xD80003C4
+#define set_SYS_VE2_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR1_reg)=data)
+#define get_SYS_VE2_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR1_reg))
+#define SYS_VE2_SRAM_PWR1_inst_adr                                                   "0x00F1"
+#define SYS_VE2_SRAM_PWR1_inst                                                       0x00F1
+#define SYS_VE2_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE2_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR2                                                            0x980003c8
+#define SYS_VE2_SRAM_PWR2_reg_addr                                                   "0xD80003C8"
+#define SYS_VE2_SRAM_PWR2_reg                                                        0xD80003C8
+#define set_SYS_VE2_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR2_reg)=data)
+#define get_SYS_VE2_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR2_reg))
+#define SYS_VE2_SRAM_PWR2_inst_adr                                                   "0x00F2"
+#define SYS_VE2_SRAM_PWR2_inst                                                       0x00F2
+#define SYS_VE2_SRAM_PWR2_SD_REG_shift                                               (0)
+#define SYS_VE2_SRAM_PWR2_SD_REG_mask                                                (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR2_SD_REG(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR2_SD_REG_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR2_get_SD_REG(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR3                                                            0x980003cc
+#define SYS_VE2_SRAM_PWR3_reg_addr                                                   "0xD80003CC"
+#define SYS_VE2_SRAM_PWR3_reg                                                        0xD80003CC
+#define set_SYS_VE2_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR3_reg)=data)
+#define get_SYS_VE2_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR3_reg))
+#define SYS_VE2_SRAM_PWR3_inst_adr                                                   "0x00F3"
+#define SYS_VE2_SRAM_PWR3_inst                                                       0x00F3
+#define SYS_VE2_SRAM_PWR3_MUX_REG_shift                                              (0)
+#define SYS_VE2_SRAM_PWR3_MUX_REG_mask                                               (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR3_MUX_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR3_MUX_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR3_get_MUX_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR4                                                            0x980003d0
+#define SYS_VE2_SRAM_PWR4_reg_addr                                                   "0xD80003D0"
+#define SYS_VE2_SRAM_PWR4_reg                                                        0xD80003D0
+#define set_SYS_VE2_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR4_reg)=data)
+#define get_SYS_VE2_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR4_reg))
+#define SYS_VE2_SRAM_PWR4_inst_adr                                                   "0x00F4"
+#define SYS_VE2_SRAM_PWR4_inst                                                       0x00F4
+#define SYS_VE2_SRAM_PWR4_CTRL_shift                                                 (0)
+#define SYS_VE2_SRAM_PWR4_CTRL_mask                                                  (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR4_CTRL(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR4_CTRL_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR4_get_CTRL(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR5                                                            0x980003d4
+#define SYS_VE2_SRAM_PWR5_reg_addr                                                   "0xD80003D4"
+#define SYS_VE2_SRAM_PWR5_reg                                                        0xD80003D4
+#define set_SYS_VE2_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR5_reg)=data)
+#define get_SYS_VE2_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR5_reg))
+#define SYS_VE2_SRAM_PWR5_inst_adr                                                   "0x00F5"
+#define SYS_VE2_SRAM_PWR5_inst                                                       0x00F5
+#define SYS_VE2_SRAM_PWR5_ve2_sram_int_shift                                         (2)
+#define SYS_VE2_SRAM_PWR5_ve2_sram_int_mask                                          (0x00000004)
+#define SYS_VE2_SRAM_PWR5_ve2_sram_int(data)                                         (0x00000004&((data)<<2))
+#define SYS_VE2_SRAM_PWR5_ve2_sram_int_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE2_SRAM_PWR5_get_ve2_sram_int(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE2_SRAM_PWR5_write_data_shift                                           (0)
+#define SYS_VE2_SRAM_PWR5_write_data_mask                                            (0x00000001)
+#define SYS_VE2_SRAM_PWR5_write_data(data)                                           (0x00000001&((data)<<0))
+#define SYS_VE2_SRAM_PWR5_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_VE2_SRAM_PWR5_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR6                                                            0x980003d8
+#define SYS_VE2_SRAM_PWR6_reg_addr                                                   "0xD80003D8"
+#define SYS_VE2_SRAM_PWR6_reg                                                        0xD80003D8
+#define set_SYS_VE2_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR6_reg)=data)
+#define get_SYS_VE2_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR6_reg))
+#define SYS_VE2_SRAM_PWR6_inst_adr                                                   "0x00F6"
+#define SYS_VE2_SRAM_PWR6_inst                                                       0x00F6
+#define SYS_VE2_SRAM_PWR6_last_delay_cycle_shift                                     (0)
+#define SYS_VE2_SRAM_PWR6_last_delay_cycle_mask                                      (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR6_last_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR6_last_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR6_get_last_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE2_SRAM_PWR7                                                            0x980003dc
+#define SYS_VE2_SRAM_PWR7_reg_addr                                                   "0xD80003DC"
+#define SYS_VE2_SRAM_PWR7_reg                                                        0xD80003DC
+#define set_SYS_VE2_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR7_reg)=data)
+#define get_SYS_VE2_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_VE2_SRAM_PWR7_reg))
+#define SYS_VE2_SRAM_PWR7_inst_adr                                                   "0x00F7"
+#define SYS_VE2_SRAM_PWR7_inst                                                       0x00F7
+#define SYS_VE2_SRAM_PWR7_pg_switch_info_shift                                       (0)
+#define SYS_VE2_SRAM_PWR7_pg_switch_info_mask                                        (0xFFFFFFFF)
+#define SYS_VE2_SRAM_PWR7_pg_switch_info(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SYS_VE2_SRAM_PWR7_pg_switch_info_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE2_SRAM_PWR7_get_pg_switch_info(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR0                                                            0x980003e0
+#define SYS_VE3_SRAM_PWR0_reg_addr                                                   "0xD80003E0"
+#define SYS_VE3_SRAM_PWR0_reg                                                        0xD80003E0
+#define set_SYS_VE3_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR0_reg)=data)
+#define get_SYS_VE3_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR0_reg))
+#define SYS_VE3_SRAM_PWR0_inst_adr                                                   "0x00F8"
+#define SYS_VE3_SRAM_PWR0_inst                                                       0x00F8
+#define SYS_VE3_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE3_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR1                                                            0x980003e4
+#define SYS_VE3_SRAM_PWR1_reg_addr                                                   "0xD80003E4"
+#define SYS_VE3_SRAM_PWR1_reg                                                        0xD80003E4
+#define set_SYS_VE3_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR1_reg)=data)
+#define get_SYS_VE3_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR1_reg))
+#define SYS_VE3_SRAM_PWR1_inst_adr                                                   "0x00F9"
+#define SYS_VE3_SRAM_PWR1_inst                                                       0x00F9
+#define SYS_VE3_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                      (0)
+#define SYS_VE3_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR2                                                            0x980003e8
+#define SYS_VE3_SRAM_PWR2_reg_addr                                                   "0xD80003E8"
+#define SYS_VE3_SRAM_PWR2_reg                                                        0xD80003E8
+#define set_SYS_VE3_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR2_reg)=data)
+#define get_SYS_VE3_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR2_reg))
+#define SYS_VE3_SRAM_PWR2_inst_adr                                                   "0x00FA"
+#define SYS_VE3_SRAM_PWR2_inst                                                       0x00FA
+#define SYS_VE3_SRAM_PWR2_SD_REG_shift                                               (0)
+#define SYS_VE3_SRAM_PWR2_SD_REG_mask                                                (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR2_SD_REG(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR2_SD_REG_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR2_get_SD_REG(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR3                                                            0x980003ec
+#define SYS_VE3_SRAM_PWR3_reg_addr                                                   "0xD80003EC"
+#define SYS_VE3_SRAM_PWR3_reg                                                        0xD80003EC
+#define set_SYS_VE3_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR3_reg)=data)
+#define get_SYS_VE3_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR3_reg))
+#define SYS_VE3_SRAM_PWR3_inst_adr                                                   "0x00FB"
+#define SYS_VE3_SRAM_PWR3_inst                                                       0x00FB
+#define SYS_VE3_SRAM_PWR3_MUX_REG_shift                                              (0)
+#define SYS_VE3_SRAM_PWR3_MUX_REG_mask                                               (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR3_MUX_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR3_MUX_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR3_get_MUX_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR4                                                            0x980003f0
+#define SYS_VE3_SRAM_PWR4_reg_addr                                                   "0xD80003F0"
+#define SYS_VE3_SRAM_PWR4_reg                                                        0xD80003F0
+#define set_SYS_VE3_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR4_reg)=data)
+#define get_SYS_VE3_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR4_reg))
+#define SYS_VE3_SRAM_PWR4_inst_adr                                                   "0x00FC"
+#define SYS_VE3_SRAM_PWR4_inst                                                       0x00FC
+#define SYS_VE3_SRAM_PWR4_CTRL_shift                                                 (0)
+#define SYS_VE3_SRAM_PWR4_CTRL_mask                                                  (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR4_CTRL(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR4_CTRL_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR4_get_CTRL(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR5                                                            0x980003f4
+#define SYS_VE3_SRAM_PWR5_reg_addr                                                   "0xD80003F4"
+#define SYS_VE3_SRAM_PWR5_reg                                                        0xD80003F4
+#define set_SYS_VE3_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR5_reg)=data)
+#define get_SYS_VE3_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR5_reg))
+#define SYS_VE3_SRAM_PWR5_inst_adr                                                   "0x00FD"
+#define SYS_VE3_SRAM_PWR5_inst                                                       0x00FD
+#define SYS_VE3_SRAM_PWR5_ve3_sram_int_shift                                         (2)
+#define SYS_VE3_SRAM_PWR5_ve3_sram_int_mask                                          (0x00000004)
+#define SYS_VE3_SRAM_PWR5_ve3_sram_int(data)                                         (0x00000004&((data)<<2))
+#define SYS_VE3_SRAM_PWR5_ve3_sram_int_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE3_SRAM_PWR5_get_ve3_sram_int(data)                                     ((0x00000004&(data))>>2)
+#define SYS_VE3_SRAM_PWR5_write_data_shift                                           (0)
+#define SYS_VE3_SRAM_PWR5_write_data_mask                                            (0x00000001)
+#define SYS_VE3_SRAM_PWR5_write_data(data)                                           (0x00000001&((data)<<0))
+#define SYS_VE3_SRAM_PWR5_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_VE3_SRAM_PWR5_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR6                                                            0x980003f8
+#define SYS_VE3_SRAM_PWR6_reg_addr                                                   "0xD80003F8"
+#define SYS_VE3_SRAM_PWR6_reg                                                        0xD80003F8
+#define set_SYS_VE3_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR6_reg)=data)
+#define get_SYS_VE3_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR6_reg))
+#define SYS_VE3_SRAM_PWR6_inst_adr                                                   "0x00FE"
+#define SYS_VE3_SRAM_PWR6_inst                                                       0x00FE
+#define SYS_VE3_SRAM_PWR6_last_delay_cycle_shift                                     (0)
+#define SYS_VE3_SRAM_PWR6_last_delay_cycle_mask                                      (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR6_last_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR6_last_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR6_get_last_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_VE3_SRAM_PWR7                                                            0x980003fc
+#define SYS_VE3_SRAM_PWR7_reg_addr                                                   "0xD80003FC"
+#define SYS_VE3_SRAM_PWR7_reg                                                        0xD80003FC
+#define set_SYS_VE3_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR7_reg)=data)
+#define get_SYS_VE3_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_VE3_SRAM_PWR7_reg))
+#define SYS_VE3_SRAM_PWR7_inst_adr                                                   "0x00FF"
+#define SYS_VE3_SRAM_PWR7_inst                                                       0x00FF
+#define SYS_VE3_SRAM_PWR7_pg_switch_info_shift                                       (0)
+#define SYS_VE3_SRAM_PWR7_pg_switch_info_mask                                        (0xFFFFFFFF)
+#define SYS_VE3_SRAM_PWR7_pg_switch_info(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SYS_VE3_SRAM_PWR7_pg_switch_info_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SYS_VE3_SRAM_PWR7_get_pg_switch_info(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_POWER_CTRL                                                               0x98000400
+#define SYS_POWER_CTRL_reg_addr                                                      "0xD8000400"
+#define SYS_POWER_CTRL_reg                                                           0xD8000400
+#define set_SYS_POWER_CTRL_reg(data)   (*((volatile unsigned int*) SYS_POWER_CTRL_reg)=data)
+#define get_SYS_POWER_CTRL_reg   (*((volatile unsigned int*) SYS_POWER_CTRL_reg))
+#define SYS_POWER_CTRL_inst_adr                                                      "0x0000"
+#define SYS_POWER_CTRL_inst                                                          0x0000
+#define SYS_POWER_CTRL_nat_sram_int_mask_shift                                       (19)
+#define SYS_POWER_CTRL_nat_sram_int_mask_mask                                        (0x00080000)
+#define SYS_POWER_CTRL_nat_sram_int_mask(data)                                       (0x00080000&((data)<<19))
+#define SYS_POWER_CTRL_nat_sram_int_mask_src(data)                                   ((0x00080000&(data))>>19)
+#define SYS_POWER_CTRL_get_nat_sram_int_mask(data)                                   ((0x00080000&(data))>>19)
+#define SYS_POWER_CTRL_iso_nat_shift                                                 (18)
+#define SYS_POWER_CTRL_iso_nat_mask                                                  (0x00040000)
+#define SYS_POWER_CTRL_iso_nat(data)                                                 (0x00040000&((data)<<18))
+#define SYS_POWER_CTRL_iso_nat_src(data)                                             ((0x00040000&(data))>>18)
+#define SYS_POWER_CTRL_get_iso_nat(data)                                             ((0x00040000&(data))>>18)
+#define SYS_POWER_CTRL_vetop_rm_shift                                                (14)
+#define SYS_POWER_CTRL_vetop_rm_mask                                                 (0x0003C000)
+#define SYS_POWER_CTRL_vetop_rm(data)                                                (0x0003C000&((data)<<14))
+#define SYS_POWER_CTRL_vetop_rm_src(data)                                            ((0x0003C000&(data))>>14)
+#define SYS_POWER_CTRL_get_vetop_rm(data)                                            ((0x0003C000&(data))>>14)
+#define SYS_POWER_CTRL_vetop_rme_shift                                               (13)
+#define SYS_POWER_CTRL_vetop_rme_mask                                                (0x00002000)
+#define SYS_POWER_CTRL_vetop_rme(data)                                               (0x00002000&((data)<<13))
+#define SYS_POWER_CTRL_vetop_rme_src(data)                                           ((0x00002000&(data))>>13)
+#define SYS_POWER_CTRL_get_vetop_rme(data)                                           ((0x00002000&(data))>>13)
+#define SYS_POWER_CTRL_vetop_sd_shift                                                (12)
+#define SYS_POWER_CTRL_vetop_sd_mask                                                 (0x00001000)
+#define SYS_POWER_CTRL_vetop_sd(data)                                                (0x00001000&((data)<<12))
+#define SYS_POWER_CTRL_vetop_sd_src(data)                                            ((0x00001000&(data))>>12)
+#define SYS_POWER_CTRL_get_vetop_sd(data)                                            ((0x00001000&(data))>>12)
+#define SYS_POWER_CTRL_vetop_ds_shift                                                (11)
+#define SYS_POWER_CTRL_vetop_ds_mask                                                 (0x00000800)
+#define SYS_POWER_CTRL_vetop_ds(data)                                                (0x00000800&((data)<<11))
+#define SYS_POWER_CTRL_vetop_ds_src(data)                                            ((0x00000800&(data))>>11)
+#define SYS_POWER_CTRL_get_vetop_ds(data)                                            ((0x00000800&(data))>>11)
+#define SYS_POWER_CTRL_vetop_ls_shift                                                (10)
+#define SYS_POWER_CTRL_vetop_ls_mask                                                 (0x00000400)
+#define SYS_POWER_CTRL_vetop_ls(data)                                                (0x00000400&((data)<<10))
+#define SYS_POWER_CTRL_vetop_ls_src(data)                                            ((0x00000400&(data))>>10)
+#define SYS_POWER_CTRL_get_vetop_ls(data)                                            ((0x00000400&(data))>>10)
+#define SYS_POWER_CTRL_disp_sram_int_mask_shift                                      (9)
+#define SYS_POWER_CTRL_disp_sram_int_mask_mask                                       (0x00000200)
+#define SYS_POWER_CTRL_disp_sram_int_mask(data)                                      (0x00000200&((data)<<9))
+#define SYS_POWER_CTRL_disp_sram_int_mask_src(data)                                  ((0x00000200&(data))>>9)
+#define SYS_POWER_CTRL_get_disp_sram_int_mask(data)                                  ((0x00000200&(data))>>9)
+#define SYS_POWER_CTRL_iso_disp_shift                                                (8)
+#define SYS_POWER_CTRL_iso_disp_mask                                                 (0x00000100)
+#define SYS_POWER_CTRL_iso_disp(data)                                                (0x00000100&((data)<<8))
+#define SYS_POWER_CTRL_iso_disp_src(data)                                            ((0x00000100&(data))>>8)
+#define SYS_POWER_CTRL_get_iso_disp(data)                                            ((0x00000100&(data))>>8)
+#define SYS_POWER_CTRL_ve3_sram_int_mask_shift                                       (7)
+#define SYS_POWER_CTRL_ve3_sram_int_mask_mask                                        (0x00000080)
+#define SYS_POWER_CTRL_ve3_sram_int_mask(data)                                       (0x00000080&((data)<<7))
+#define SYS_POWER_CTRL_ve3_sram_int_mask_src(data)                                   ((0x00000080&(data))>>7)
+#define SYS_POWER_CTRL_get_ve3_sram_int_mask(data)                                   ((0x00000080&(data))>>7)
+#define SYS_POWER_CTRL_iso_ve3_shift                                                 (6)
+#define SYS_POWER_CTRL_iso_ve3_mask                                                  (0x00000040)
+#define SYS_POWER_CTRL_iso_ve3(data)                                                 (0x00000040&((data)<<6))
+#define SYS_POWER_CTRL_iso_ve3_src(data)                                             ((0x00000040&(data))>>6)
+#define SYS_POWER_CTRL_get_iso_ve3(data)                                             ((0x00000040&(data))>>6)
+#define SYS_POWER_CTRL_ve2_sram_int_mask_shift                                       (5)
+#define SYS_POWER_CTRL_ve2_sram_int_mask_mask                                        (0x00000020)
+#define SYS_POWER_CTRL_ve2_sram_int_mask(data)                                       (0x00000020&((data)<<5))
+#define SYS_POWER_CTRL_ve2_sram_int_mask_src(data)                                   ((0x00000020&(data))>>5)
+#define SYS_POWER_CTRL_get_ve2_sram_int_mask(data)                                   ((0x00000020&(data))>>5)
+#define SYS_POWER_CTRL_iso_ve2_shift                                                 (4)
+#define SYS_POWER_CTRL_iso_ve2_mask                                                  (0x00000010)
+#define SYS_POWER_CTRL_iso_ve2(data)                                                 (0x00000010&((data)<<4))
+#define SYS_POWER_CTRL_iso_ve2_src(data)                                             ((0x00000010&(data))>>4)
+#define SYS_POWER_CTRL_get_iso_ve2(data)                                             ((0x00000010&(data))>>4)
+#define SYS_POWER_CTRL_ve1_sram_int_mask_shift                                       (3)
+#define SYS_POWER_CTRL_ve1_sram_int_mask_mask                                        (0x00000008)
+#define SYS_POWER_CTRL_ve1_sram_int_mask(data)                                       (0x00000008&((data)<<3))
+#define SYS_POWER_CTRL_ve1_sram_int_mask_src(data)                                   ((0x00000008&(data))>>3)
+#define SYS_POWER_CTRL_get_ve1_sram_int_mask(data)                                   ((0x00000008&(data))>>3)
+#define SYS_POWER_CTRL_gpu_sram_int_mask_shift                                       (2)
+#define SYS_POWER_CTRL_gpu_sram_int_mask_mask                                        (0x00000004)
+#define SYS_POWER_CTRL_gpu_sram_int_mask(data)                                       (0x00000004&((data)<<2))
+#define SYS_POWER_CTRL_gpu_sram_int_mask_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_POWER_CTRL_get_gpu_sram_int_mask(data)                                   ((0x00000004&(data))>>2)
+#define SYS_POWER_CTRL_iso_gpu_shift                                                 (1)
+#define SYS_POWER_CTRL_iso_gpu_mask                                                  (0x00000002)
+#define SYS_POWER_CTRL_iso_gpu(data)                                                 (0x00000002&((data)<<1))
+#define SYS_POWER_CTRL_iso_gpu_src(data)                                             ((0x00000002&(data))>>1)
+#define SYS_POWER_CTRL_get_iso_gpu(data)                                             ((0x00000002&(data))>>1)
+#define SYS_POWER_CTRL_iso_ve1_shift                                                 (0)
+#define SYS_POWER_CTRL_iso_ve1_mask                                                  (0x00000001)
+#define SYS_POWER_CTRL_iso_ve1(data)                                                 (0x00000001&((data)<<0))
+#define SYS_POWER_CTRL_iso_ve1_src(data)                                             ((0x00000001&(data))>>0)
+#define SYS_POWER_CTRL_get_iso_ve1(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_PROB                                                                 0x98000408
+#define SYS_PLL_PROB_reg_addr                                                        "0xD8000408"
+#define SYS_PLL_PROB_reg                                                             0xD8000408
+#define set_SYS_PLL_PROB_reg(data)   (*((volatile unsigned int*) SYS_PLL_PROB_reg)=data)
+#define get_SYS_PLL_PROB_reg   (*((volatile unsigned int*) SYS_PLL_PROB_reg))
+#define SYS_PLL_PROB_inst_adr                                                        "0x0002"
+#define SYS_PLL_PROB_inst                                                            0x0002
+#define SYS_PLL_PROB_vprob_plltest_sel_loc1_shift                                    (10)
+#define SYS_PLL_PROB_vprob_plltest_sel_loc1_mask                                     (0x00007C00)
+#define SYS_PLL_PROB_vprob_plltest_sel_loc1(data)                                    (0x00007C00&((data)<<10))
+#define SYS_PLL_PROB_vprob_plltest_sel_loc1_src(data)                                ((0x00007C00&(data))>>10)
+#define SYS_PLL_PROB_get_vprob_plltest_sel_loc1(data)                                ((0x00007C00&(data))>>10)
+#define SYS_PLL_PROB_vprob_plltest_sel_loc0_shift                                    (5)
+#define SYS_PLL_PROB_vprob_plltest_sel_loc0_mask                                     (0x000003E0)
+#define SYS_PLL_PROB_vprob_plltest_sel_loc0(data)                                    (0x000003E0&((data)<<5))
+#define SYS_PLL_PROB_vprob_plltest_sel_loc0_src(data)                                ((0x000003E0&(data))>>5)
+#define SYS_PLL_PROB_get_vprob_plltest_sel_loc0(data)                                ((0x000003E0&(data))>>5)
+#define SYS_PLL_PROB_vprob_ea_loc1_shift                                             (4)
+#define SYS_PLL_PROB_vprob_ea_loc1_mask                                              (0x00000010)
+#define SYS_PLL_PROB_vprob_ea_loc1(data)                                             (0x00000010&((data)<<4))
+#define SYS_PLL_PROB_vprob_ea_loc1_src(data)                                         ((0x00000010&(data))>>4)
+#define SYS_PLL_PROB_get_vprob_ea_loc1(data)                                         ((0x00000010&(data))>>4)
+#define SYS_PLL_PROB_vprob_ea_loc0_shift                                             (3)
+#define SYS_PLL_PROB_vprob_ea_loc0_mask                                              (0x00000008)
+#define SYS_PLL_PROB_vprob_ea_loc0(data)                                             (0x00000008&((data)<<3))
+#define SYS_PLL_PROB_vprob_ea_loc0_src(data)                                         ((0x00000008&(data))>>3)
+#define SYS_PLL_PROB_get_vprob_ea_loc0(data)                                         ((0x00000008&(data))>>3)
+
+
+#define SYS_CRT_DEBUG                                                                0x98000410
+#define SYS_CRT_DEBUG_reg_addr                                                       "0xD8000410"
+#define SYS_CRT_DEBUG_reg                                                            0xD8000410
+#define set_SYS_CRT_DEBUG_reg(data)   (*((volatile unsigned int*) SYS_CRT_DEBUG_reg)=data)
+#define get_SYS_CRT_DEBUG_reg   (*((volatile unsigned int*) SYS_CRT_DEBUG_reg))
+#define SYS_CRT_DEBUG_inst_adr                                                       "0x0004"
+#define SYS_CRT_DEBUG_inst                                                           0x0004
+#define SYS_CRT_DEBUG_crt_dbg_en_shift                                               (8)
+#define SYS_CRT_DEBUG_crt_dbg_en_mask                                                (0x00000100)
+#define SYS_CRT_DEBUG_crt_dbg_en(data)                                               (0x00000100&((data)<<8))
+#define SYS_CRT_DEBUG_crt_dbg_en_src(data)                                           ((0x00000100&(data))>>8)
+#define SYS_CRT_DEBUG_get_crt_dbg_en(data)                                           ((0x00000100&(data))>>8)
+#define SYS_CRT_DEBUG_crt_dbg_sel0_shift                                             (4)
+#define SYS_CRT_DEBUG_crt_dbg_sel0_mask                                              (0x000000F0)
+#define SYS_CRT_DEBUG_crt_dbg_sel0(data)                                             (0x000000F0&((data)<<4))
+#define SYS_CRT_DEBUG_crt_dbg_sel0_src(data)                                         ((0x000000F0&(data))>>4)
+#define SYS_CRT_DEBUG_get_crt_dbg_sel0(data)                                         ((0x000000F0&(data))>>4)
+#define SYS_CRT_DEBUG_crt_dbg_sel1_shift                                             (0)
+#define SYS_CRT_DEBUG_crt_dbg_sel1_mask                                              (0x0000000F)
+#define SYS_CRT_DEBUG_crt_dbg_sel1(data)                                             (0x0000000F&((data)<<0))
+#define SYS_CRT_DEBUG_crt_dbg_sel1_src(data)                                         ((0x0000000F&(data))>>0)
+#define SYS_CRT_DEBUG_get_crt_dbg_sel1(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define SYS_DEBUG                                                                    0x98000414
+#define SYS_DEBUG_reg_addr                                                           "0xD8000414"
+#define SYS_DEBUG_reg                                                                0xD8000414
+#define set_SYS_DEBUG_reg(data)   (*((volatile unsigned int*) SYS_DEBUG_reg)=data)
+#define get_SYS_DEBUG_reg   (*((volatile unsigned int*) SYS_DEBUG_reg))
+#define SYS_DEBUG_inst_adr                                                           "0x0005"
+#define SYS_DEBUG_inst                                                               0x0005
+#define SYS_DEBUG_reserved_debug_shift                                               (0)
+#define SYS_DEBUG_reserved_debug_mask                                                (0x00000001)
+#define SYS_DEBUG_reserved_debug(data)                                               (0x00000001&((data)<<0))
+#define SYS_DEBUG_reserved_debug_src(data)                                           ((0x00000001&(data))>>0)
+#define SYS_DEBUG_get_reserved_debug(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SYS_MBIST                                                                    0x98000418
+#define SYS_MBIST_reg_addr                                                           "0xD8000418"
+#define SYS_MBIST_reg                                                                0xD8000418
+#define set_SYS_MBIST_reg(data)   (*((volatile unsigned int*) SYS_MBIST_reg)=data)
+#define get_SYS_MBIST_reg   (*((volatile unsigned int*) SYS_MBIST_reg))
+#define SYS_MBIST_inst_adr                                                           "0x0006"
+#define SYS_MBIST_inst                                                               0x0006
+#define SYS_MBIST_rbus_protect_shift                                                 (0)
+#define SYS_MBIST_rbus_protect_mask                                                  (0xFFFFFFFF)
+#define SYS_MBIST_rbus_protect(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_MBIST_rbus_protect_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_MBIST_get_rbus_protect(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_PLLDIV                                                                   0x9800041c
+#define SYS_PLLDIV_reg_addr                                                          "0xD800041C"
+#define SYS_PLLDIV_reg                                                               0xD800041C
+#define set_SYS_PLLDIV_reg(data)   (*((volatile unsigned int*) SYS_PLLDIV_reg)=data)
+#define get_SYS_PLLDIV_reg   (*((volatile unsigned int*) SYS_PLLDIV_reg))
+#define SYS_PLLDIV_inst_adr                                                          "0x0007"
+#define SYS_PLLDIV_inst                                                              0x0007
+#define SYS_PLLDIV_dvsorting_shift                                                   (6)
+#define SYS_PLLDIV_dvsorting_mask                                                    (0x00000040)
+#define SYS_PLLDIV_dvsorting(data)                                                   (0x00000040&((data)<<6))
+#define SYS_PLLDIV_dvsorting_src(data)                                               ((0x00000040&(data))>>6)
+#define SYS_PLLDIV_get_dvsorting(data)                                               ((0x00000040&(data))>>6)
+#define SYS_PLLDIV_pcie1_bak_sel_shift                                               (5)
+#define SYS_PLLDIV_pcie1_bak_sel_mask                                                (0x00000020)
+#define SYS_PLLDIV_pcie1_bak_sel(data)                                               (0x00000020&((data)<<5))
+#define SYS_PLLDIV_pcie1_bak_sel_src(data)                                           ((0x00000020&(data))>>5)
+#define SYS_PLLDIV_get_pcie1_bak_sel(data)                                           ((0x00000020&(data))>>5)
+#define SYS_PLLDIV_pcie0_bak_sel_shift                                               (4)
+#define SYS_PLLDIV_pcie0_bak_sel_mask                                                (0x00000010)
+#define SYS_PLLDIV_pcie0_bak_sel(data)                                               (0x00000010&((data)<<4))
+#define SYS_PLLDIV_pcie0_bak_sel_src(data)                                           ((0x00000010&(data))>>4)
+#define SYS_PLLDIV_get_pcie0_bak_sel(data)                                           ((0x00000010&(data))>>4)
+#define SYS_PLLDIV_plldiv_sel_shift                                                  (0)
+#define SYS_PLLDIV_plldiv_sel_mask                                                   (0x0000000F)
+#define SYS_PLLDIV_plldiv_sel(data)                                                  (0x0000000F&((data)<<0))
+#define SYS_PLLDIV_plldiv_sel_src(data)                                              ((0x0000000F&(data))>>0)
+#define SYS_PLLDIV_get_plldiv_sel(data)                                              ((0x0000000F&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR0                                                            0x98000420
+#define SYS_NAT_SRAM_PWR0_reg_addr                                                   "0xD8000420"
+#define SYS_NAT_SRAM_PWR0_reg                                                        0xD8000420
+#define set_SYS_NAT_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR0_reg)=data)
+#define get_SYS_NAT_SRAM_PWR0_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR0_reg))
+#define SYS_NAT_SRAM_PWR0_inst_adr                                                   "0x0008"
+#define SYS_NAT_SRAM_PWR0_inst                                                       0x0008
+#define SYS_NAT_SRAM_PWR0_L2H_DELAY_CYCLE_shift                                      (0)
+#define SYS_NAT_SRAM_PWR0_L2H_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR0_L2H_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR0_L2H_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR0_get_L2H_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR1                                                            0x98000424
+#define SYS_NAT_SRAM_PWR1_reg_addr                                                   "0xD8000424"
+#define SYS_NAT_SRAM_PWR1_reg                                                        0xD8000424
+#define set_SYS_NAT_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR1_reg)=data)
+#define get_SYS_NAT_SRAM_PWR1_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR1_reg))
+#define SYS_NAT_SRAM_PWR1_inst_adr                                                   "0x0009"
+#define SYS_NAT_SRAM_PWR1_inst                                                       0x0009
+#define SYS_NAT_SRAM_PWR1_H2L_DELAY_CYCLE_shift                                      (0)
+#define SYS_NAT_SRAM_PWR1_H2L_DELAY_CYCLE_mask                                       (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR1_H2L_DELAY_CYCLE(data)                                      (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR1_H2L_DELAY_CYCLE_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR1_get_H2L_DELAY_CYCLE(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR2                                                            0x98000428
+#define SYS_NAT_SRAM_PWR2_reg_addr                                                   "0xD8000428"
+#define SYS_NAT_SRAM_PWR2_reg                                                        0xD8000428
+#define set_SYS_NAT_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR2_reg)=data)
+#define get_SYS_NAT_SRAM_PWR2_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR2_reg))
+#define SYS_NAT_SRAM_PWR2_inst_adr                                                   "0x000A"
+#define SYS_NAT_SRAM_PWR2_inst                                                       0x000A
+#define SYS_NAT_SRAM_PWR2_SD_REG_shift                                               (0)
+#define SYS_NAT_SRAM_PWR2_SD_REG_mask                                                (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR2_SD_REG(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR2_SD_REG_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR2_get_SD_REG(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR3                                                            0x9800042c
+#define SYS_NAT_SRAM_PWR3_reg_addr                                                   "0xD800042C"
+#define SYS_NAT_SRAM_PWR3_reg                                                        0xD800042C
+#define set_SYS_NAT_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR3_reg)=data)
+#define get_SYS_NAT_SRAM_PWR3_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR3_reg))
+#define SYS_NAT_SRAM_PWR3_inst_adr                                                   "0x000B"
+#define SYS_NAT_SRAM_PWR3_inst                                                       0x000B
+#define SYS_NAT_SRAM_PWR3_MUX_REG_shift                                              (0)
+#define SYS_NAT_SRAM_PWR3_MUX_REG_mask                                               (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR3_MUX_REG(data)                                              (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR3_MUX_REG_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR3_get_MUX_REG(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR4                                                            0x98000430
+#define SYS_NAT_SRAM_PWR4_reg_addr                                                   "0xD8000430"
+#define SYS_NAT_SRAM_PWR4_reg                                                        0xD8000430
+#define set_SYS_NAT_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR4_reg)=data)
+#define get_SYS_NAT_SRAM_PWR4_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR4_reg))
+#define SYS_NAT_SRAM_PWR4_inst_adr                                                   "0x000C"
+#define SYS_NAT_SRAM_PWR4_inst                                                       0x000C
+#define SYS_NAT_SRAM_PWR4_CTRL_shift                                                 (0)
+#define SYS_NAT_SRAM_PWR4_CTRL_mask                                                  (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR4_CTRL(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR4_CTRL_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR4_get_CTRL(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR5                                                            0x98000434
+#define SYS_NAT_SRAM_PWR5_reg_addr                                                   "0xD8000434"
+#define SYS_NAT_SRAM_PWR5_reg                                                        0xD8000434
+#define set_SYS_NAT_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR5_reg)=data)
+#define get_SYS_NAT_SRAM_PWR5_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR5_reg))
+#define SYS_NAT_SRAM_PWR5_inst_adr                                                   "0x000D"
+#define SYS_NAT_SRAM_PWR5_inst                                                       0x000D
+#define SYS_NAT_SRAM_PWR5_nat_sram_int_shift                                         (2)
+#define SYS_NAT_SRAM_PWR5_nat_sram_int_mask                                          (0x00000004)
+#define SYS_NAT_SRAM_PWR5_nat_sram_int(data)                                         (0x00000004&((data)<<2))
+#define SYS_NAT_SRAM_PWR5_nat_sram_int_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_NAT_SRAM_PWR5_get_nat_sram_int(data)                                     ((0x00000004&(data))>>2)
+#define SYS_NAT_SRAM_PWR5_write_data_shift                                           (0)
+#define SYS_NAT_SRAM_PWR5_write_data_mask                                            (0x00000001)
+#define SYS_NAT_SRAM_PWR5_write_data(data)                                           (0x00000001&((data)<<0))
+#define SYS_NAT_SRAM_PWR5_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_NAT_SRAM_PWR5_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR6                                                            0x98000438
+#define SYS_NAT_SRAM_PWR6_reg_addr                                                   "0xD8000438"
+#define SYS_NAT_SRAM_PWR6_reg                                                        0xD8000438
+#define set_SYS_NAT_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR6_reg)=data)
+#define get_SYS_NAT_SRAM_PWR6_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR6_reg))
+#define SYS_NAT_SRAM_PWR6_inst_adr                                                   "0x000E"
+#define SYS_NAT_SRAM_PWR6_inst                                                       0x000E
+#define SYS_NAT_SRAM_PWR6_last_delay_cycle_shift                                     (0)
+#define SYS_NAT_SRAM_PWR6_last_delay_cycle_mask                                      (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR6_last_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR6_last_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR6_get_last_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_NAT_SRAM_PWR7                                                            0x9800043c
+#define SYS_NAT_SRAM_PWR7_reg_addr                                                   "0xD800043C"
+#define SYS_NAT_SRAM_PWR7_reg                                                        0xD800043C
+#define set_SYS_NAT_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR7_reg)=data)
+#define get_SYS_NAT_SRAM_PWR7_reg   (*((volatile unsigned int*) SYS_NAT_SRAM_PWR7_reg))
+#define SYS_NAT_SRAM_PWR7_inst_adr                                                   "0x000F"
+#define SYS_NAT_SRAM_PWR7_inst                                                       0x000F
+#define SYS_NAT_SRAM_PWR7_pg_switch_info_shift                                       (0)
+#define SYS_NAT_SRAM_PWR7_pg_switch_info_mask                                        (0xFFFFFFFF)
+#define SYS_NAT_SRAM_PWR7_pg_switch_info(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SYS_NAT_SRAM_PWR7_pg_switch_info_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SYS_NAT_SRAM_PWR7_get_pg_switch_info(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DUMMY0                                                                   0x98000450
+#define SYS_DUMMY0_reg_addr                                                          "0xD8000450"
+#define SYS_DUMMY0_reg                                                               0xD8000450
+#define set_SYS_DUMMY0_reg(data)   (*((volatile unsigned int*) SYS_DUMMY0_reg)=data)
+#define get_SYS_DUMMY0_reg   (*((volatile unsigned int*) SYS_DUMMY0_reg))
+#define SYS_DUMMY0_inst_adr                                                          "0x0014"
+#define SYS_DUMMY0_inst                                                              0x0014
+#define SYS_DUMMY0_dmyreg0_rst0_shift                                                (0)
+#define SYS_DUMMY0_dmyreg0_rst0_mask                                                 (0xFFFFFFFF)
+#define SYS_DUMMY0_dmyreg0_rst0(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SYS_DUMMY0_dmyreg0_rst0_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SYS_DUMMY0_get_dmyreg0_rst0(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DUMMY1                                                                   0x98000454
+#define SYS_DUMMY1_reg_addr                                                          "0xD8000454"
+#define SYS_DUMMY1_reg                                                               0xD8000454
+#define set_SYS_DUMMY1_reg(data)   (*((volatile unsigned int*) SYS_DUMMY1_reg)=data)
+#define get_SYS_DUMMY1_reg   (*((volatile unsigned int*) SYS_DUMMY1_reg))
+#define SYS_DUMMY1_inst_adr                                                          "0x0015"
+#define SYS_DUMMY1_inst                                                              0x0015
+#define SYS_DUMMY1_dmyreg1_rst0_shift                                                (0)
+#define SYS_DUMMY1_dmyreg1_rst0_mask                                                 (0xFFFFFFFF)
+#define SYS_DUMMY1_dmyreg1_rst0(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SYS_DUMMY1_dmyreg1_rst0_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SYS_DUMMY1_get_dmyreg1_rst0(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DUMMY2                                                                   0x98000458
+#define SYS_DUMMY2_reg_addr                                                          "0xD8000458"
+#define SYS_DUMMY2_reg                                                               0xD8000458
+#define set_SYS_DUMMY2_reg(data)   (*((volatile unsigned int*) SYS_DUMMY2_reg)=data)
+#define get_SYS_DUMMY2_reg   (*((volatile unsigned int*) SYS_DUMMY2_reg))
+#define SYS_DUMMY2_inst_adr                                                          "0x0016"
+#define SYS_DUMMY2_inst                                                              0x0016
+#define SYS_DUMMY2_dmyreg2_rst1_shift                                                (0)
+#define SYS_DUMMY2_dmyreg2_rst1_mask                                                 (0xFFFFFFFF)
+#define SYS_DUMMY2_dmyreg2_rst1(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SYS_DUMMY2_dmyreg2_rst1_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SYS_DUMMY2_get_dmyreg2_rst1(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_DUMMY3                                                                   0x9800045c
+#define SYS_DUMMY3_reg_addr                                                          "0xD800045C"
+#define SYS_DUMMY3_reg                                                               0xD800045C
+#define set_SYS_DUMMY3_reg(data)   (*((volatile unsigned int*) SYS_DUMMY3_reg)=data)
+#define get_SYS_DUMMY3_reg   (*((volatile unsigned int*) SYS_DUMMY3_reg))
+#define SYS_DUMMY3_inst_adr                                                          "0x0017"
+#define SYS_DUMMY3_inst                                                              0x0017
+#define SYS_DUMMY3_dmyreg3_rst1_shift                                                (0)
+#define SYS_DUMMY3_dmyreg3_rst1_mask                                                 (0xFFFFFFFF)
+#define SYS_DUMMY3_dmyreg3_rst1(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SYS_DUMMY3_dmyreg3_rst1_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SYS_DUMMY3_get_dmyreg3_rst1(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU0                                                        0x98000500
+#define SYS_PLL_SSC_DIG_SCPU0_reg_addr                                               "0xD8000500"
+#define SYS_PLL_SSC_DIG_SCPU0_reg                                                    0xD8000500
+#define set_SYS_PLL_SSC_DIG_SCPU0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU0_reg))
+#define SYS_PLL_SSC_DIG_SCPU0_inst_adr                                               "0x0040"
+#define SYS_PLL_SSC_DIG_SCPU0_inst                                                   0x0040
+#define SYS_PLL_SSC_DIG_SCPU0_REG_CKSSC_INV_SCPU_shift                               (4)
+#define SYS_PLL_SSC_DIG_SCPU0_REG_CKSSC_INV_SCPU_mask                                (0x00000010)
+#define SYS_PLL_SSC_DIG_SCPU0_REG_CKSSC_INV_SCPU(data)                               (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_SCPU0_REG_CKSSC_INV_SCPU_src(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_SCPU0_get_REG_CKSSC_INV_SCPU(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_SCPU0_REG_GRAN_AUTO_RST_SCPU_shift                           (3)
+#define SYS_PLL_SSC_DIG_SCPU0_REG_GRAN_AUTO_RST_SCPU_mask                            (0x00000008)
+#define SYS_PLL_SSC_DIG_SCPU0_REG_GRAN_AUTO_RST_SCPU(data)                           (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_SCPU0_REG_GRAN_AUTO_RST_SCPU_src(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_SCPU0_get_REG_GRAN_AUTO_RST_SCPU(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_SCPU0_RSTB_SCPU_shift                                        (2)
+#define SYS_PLL_SSC_DIG_SCPU0_RSTB_SCPU_mask                                         (0x00000004)
+#define SYS_PLL_SSC_DIG_SCPU0_RSTB_SCPU(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_SCPU0_RSTB_SCPU_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_SCPU0_get_RSTB_SCPU(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_SCPU0_EN_SSC_SCPU_shift                                      (1)
+#define SYS_PLL_SSC_DIG_SCPU0_EN_SSC_SCPU_mask                                       (0x00000002)
+#define SYS_PLL_SSC_DIG_SCPU0_EN_SSC_SCPU(data)                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_SCPU0_EN_SSC_SCPU_src(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_SCPU0_get_EN_SSC_SCPU(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_SCPU0_OC_EN_SCPU_shift                                       (0)
+#define SYS_PLL_SSC_DIG_SCPU0_OC_EN_SCPU_mask                                        (0x00000001)
+#define SYS_PLL_SSC_DIG_SCPU0_OC_EN_SCPU(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU0_OC_EN_SCPU_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU0_get_OC_EN_SCPU(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU1                                                        0x98000504
+#define SYS_PLL_SSC_DIG_SCPU1_reg_addr                                               "0xD8000504"
+#define SYS_PLL_SSC_DIG_SCPU1_reg                                                    0xD8000504
+#define set_SYS_PLL_SSC_DIG_SCPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU1_reg))
+#define SYS_PLL_SSC_DIG_SCPU1_inst_adr                                               "0x0041"
+#define SYS_PLL_SSC_DIG_SCPU1_inst                                                   0x0041
+#define SYS_PLL_SSC_DIG_SCPU1_NCODE_T_SCPU_shift                                     (11)
+#define SYS_PLL_SSC_DIG_SCPU1_NCODE_T_SCPU_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_SCPU1_NCODE_T_SCPU(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_SCPU1_NCODE_T_SCPU_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU1_get_NCODE_T_SCPU(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU1_FCODE_T_SCPU_shift                                     (0)
+#define SYS_PLL_SSC_DIG_SCPU1_FCODE_T_SCPU_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_SCPU1_FCODE_T_SCPU(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU1_FCODE_T_SCPU_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU1_get_FCODE_T_SCPU(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU2                                                        0x98000508
+#define SYS_PLL_SSC_DIG_SCPU2_reg_addr                                               "0xD8000508"
+#define SYS_PLL_SSC_DIG_SCPU2_reg                                                    0xD8000508
+#define set_SYS_PLL_SSC_DIG_SCPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU2_reg))
+#define SYS_PLL_SSC_DIG_SCPU2_inst_adr                                               "0x0042"
+#define SYS_PLL_SSC_DIG_SCPU2_inst                                                   0x0042
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_DIVN_shift                                  (27)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_DIVN_mask                                   (0x08000000)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_DIVN(data)                                  (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_DIVN_src(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_BYPASS_DIVN(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_STEP_SET_SCPU_shift                             (17)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_STEP_SET_SCPU_mask                              (0x07FE0000)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_STEP_SET_SCPU(data)                             (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_STEP_SET_SCPU_src(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_OC_STEP_SET_SCPU(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SEL_OC_MODE_SCPU_shift                             (15)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SEL_OC_MODE_SCPU_mask                              (0x00018000)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SEL_OC_MODE_SCPU(data)                             (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SEL_OC_MODE_SCPU_src(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_SEL_OC_MODE_SCPU(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_HS_OC_STOP_DIFF_SCPU_shift                         (13)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_HS_OC_STOP_DIFF_SCPU_mask                          (0x00006000)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_HS_OC_STOP_DIFF_SCPU(data)                         (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_HS_OC_STOP_DIFF_SCPU_src(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_HS_OC_STOP_DIFF_SCPU(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_DONE_DELAY_SCPU_shift                           (7)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_DONE_DELAY_SCPU_mask                            (0x00001F80)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_DONE_DELAY_SCPU(data)                           (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_OC_DONE_DELAY_SCPU_src(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_OC_DONE_DELAY_SCPU(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_PI_CUR_SEL_SCPU_shift                              (5)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_PI_CUR_SEL_SCPU_mask                               (0x00000060)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_PI_CUR_SEL_SCPU(data)                              (0x00000060&((data)<<5))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_PI_CUR_SEL_SCPU_src(data)                          ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_PI_CUR_SEL_SCPU(data)                          ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_PI_SCPU_shift                               (4)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_PI_SCPU_mask                                (0x00000010)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_PI_SCPU(data)                               (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_BYPASS_PI_SCPU_src(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_BYPASS_PI_SCPU(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SDM_ORDER_SCPU_shift                               (3)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SDM_ORDER_SCPU_mask                                (0x00000008)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SDM_ORDER_SCPU(data)                               (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_SDM_ORDER_SCPU_src(data)                           ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_SDM_ORDER_SCPU(data)                           ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_EN_PI_DEBUG_SCPU_shift                             (2)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_EN_PI_DEBUG_SCPU_mask                              (0x00000004)
+#define SYS_PLL_SSC_DIG_SCPU2_REG_EN_PI_DEBUG_SCPU(data)                             (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_SCPU2_REG_EN_PI_DEBUG_SCPU_src(data)                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_SCPU2_get_REG_EN_PI_DEBUG_SCPU(data)                         ((0x00000004&(data))>>2)
+
+
+#define SYS_PLL_SSC_DIG_SCPU3                                                        0x9800050C
+#define SYS_PLL_SSC_DIG_SCPU3_reg_addr                                               "0xD800050C"
+#define SYS_PLL_SSC_DIG_SCPU3_reg                                                    0xD800050C
+#define set_SYS_PLL_SSC_DIG_SCPU3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU3_reg))
+#define SYS_PLL_SSC_DIG_SCPU3_inst_adr                                               "0x0043"
+#define SYS_PLL_SSC_DIG_SCPU3_inst                                                   0x0043
+#define SYS_PLL_SSC_DIG_SCPU3_NCODE_SSC_SCPU_shift                                   (11)
+#define SYS_PLL_SSC_DIG_SCPU3_NCODE_SSC_SCPU_mask                                    (0x0007F800)
+#define SYS_PLL_SSC_DIG_SCPU3_NCODE_SSC_SCPU(data)                                   (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_SCPU3_NCODE_SSC_SCPU_src(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU3_get_NCODE_SSC_SCPU(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU3_FCODE_SSC_SCPU_shift                                   (0)
+#define SYS_PLL_SSC_DIG_SCPU3_FCODE_SSC_SCPU_mask                                    (0x000007FF)
+#define SYS_PLL_SSC_DIG_SCPU3_FCODE_SSC_SCPU(data)                                   (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU3_FCODE_SSC_SCPU_src(data)                               ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU3_get_FCODE_SSC_SCPU(data)                               ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU4                                                        0x98000510
+#define SYS_PLL_SSC_DIG_SCPU4_reg_addr                                               "0xD8000510"
+#define SYS_PLL_SSC_DIG_SCPU4_reg                                                    0xD8000510
+#define set_SYS_PLL_SSC_DIG_SCPU4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU4_reg))
+#define SYS_PLL_SSC_DIG_SCPU4_inst_adr                                               "0x0044"
+#define SYS_PLL_SSC_DIG_SCPU4_inst                                                   0x0044
+#define SYS_PLL_SSC_DIG_SCPU4_GRAN_EST_SCPU_shift                                    (0)
+#define SYS_PLL_SSC_DIG_SCPU4_GRAN_EST_SCPU_mask                                     (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_SCPU4_GRAN_EST_SCPU(data)                                    (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU4_GRAN_EST_SCPU_src(data)                                ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU4_get_GRAN_EST_SCPU(data)                                ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU5                                                        0x98000514
+#define SYS_PLL_SSC_DIG_SCPU5_reg_addr                                               "0xD8000514"
+#define SYS_PLL_SSC_DIG_SCPU5_reg                                                    0xD8000514
+#define set_SYS_PLL_SSC_DIG_SCPU5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU5_reg))
+#define SYS_PLL_SSC_DIG_SCPU5_inst_adr                                               "0x0045"
+#define SYS_PLL_SSC_DIG_SCPU5_inst                                                   0x0045
+#define SYS_PLL_SSC_DIG_SCPU5_FCW_SSC_DEFAULT_SCPU_shift                             (0)
+#define SYS_PLL_SSC_DIG_SCPU5_FCW_SSC_DEFAULT_SCPU_mask                              (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_SCPU5_FCW_SSC_DEFAULT_SCPU(data)                             (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU5_FCW_SSC_DEFAULT_SCPU_src(data)                         ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU5_get_FCW_SSC_DEFAULT_SCPU(data)                         ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU_DBG1                                                    0x98000518
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_reg_addr                                           "0xD8000518"
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_reg                                                0xD8000518
+#define set_SYS_PLL_SSC_DIG_SCPU_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU_DBG1_reg))
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_inst_adr                                           "0x0046"
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_inst                                               0x0046
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_LOOP_PI_ISEL_SCPU_shift                            (13)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_LOOP_PI_ISEL_SCPU_mask                             (0x00006000)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_LOOP_PI_ISEL_SCPU(data)                            (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_LOOP_PI_ISEL_SCPU_src(data)                        ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_get_LOOP_PI_ISEL_SCPU(data)                        ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_PHSEL_SCPU_shift                                   (8)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_PHSEL_SCPU_mask                                    (0x00001F00)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_PHSEL_SCPU(data)                                   (0x00001F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_PHSEL_SCPU_src(data)                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_get_PHSEL_SCPU(data)                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_DIVN_SCPU_shift                                    (0)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_DIVN_SCPU_mask                                     (0x000000FF)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_DIVN_SCPU(data)                                    (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_DIVN_SCPU_src(data)                                ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU_DBG1_get_DIVN_SCPU(data)                                ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_SCPU_DBG2                                                    0x9800051C
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_reg_addr                                           "0xD800051C"
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_reg                                                0xD800051C
+#define set_SYS_PLL_SSC_DIG_SCPU_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_SCPU_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_SCPU_DBG2_reg))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_inst_adr                                           "0x0047"
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_inst                                               0x0047
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_load_FCW_SCPU_shift                                (21)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_load_FCW_SCPU_mask                                 (0x00200000)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_load_FCW_SCPU(data)                                (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_load_FCW_SCPU_src(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_get_load_FCW_SCPU(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_OC_DONE_SCPU_shift                                 (20)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_OC_DONE_SCPU_mask                                  (0x00100000)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_OC_DONE_SCPU(data)                                 (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_OC_DONE_SCPU_src(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_get_OC_DONE_SCPU(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FMOD_SCPU_shift                                    (19)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FMOD_SCPU_mask                                     (0x00080000)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FMOD_SCPU(data)                                    (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FMOD_SCPU_src(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_get_FMOD_SCPU(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_NCODE_DEBUG_SCPU_shift                             (11)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_NCODE_DEBUG_SCPU_mask                              (0x0007F800)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_NCODE_DEBUG_SCPU(data)                             (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_NCODE_DEBUG_SCPU_src(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_get_NCODE_DEBUG_SCPU(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FCODE_DEBUG_SCPU_shift                             (0)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FCODE_DEBUG_SCPU_mask                              (0x000007FF)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FCODE_DEBUG_SCPU(data)                             (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_FCODE_DEBUG_SCPU_src(data)                         ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_SCPU_DBG2_get_FCODE_DEBUG_SCPU(data)                         ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS0                                                         0x98000520
+#define SYS_PLL_SSC_DIG_BUS0_reg_addr                                                "0xD8000520"
+#define SYS_PLL_SSC_DIG_BUS0_reg                                                     0xD8000520
+#define set_SYS_PLL_SSC_DIG_BUS0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS0_reg))
+#define SYS_PLL_SSC_DIG_BUS0_inst_adr                                                "0x0048"
+#define SYS_PLL_SSC_DIG_BUS0_inst                                                    0x0048
+#define SYS_PLL_SSC_DIG_BUS0_REG_CKSSC_INV_BUS_shift                                 (4)
+#define SYS_PLL_SSC_DIG_BUS0_REG_CKSSC_INV_BUS_mask                                  (0x00000010)
+#define SYS_PLL_SSC_DIG_BUS0_REG_CKSSC_INV_BUS(data)                                 (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_BUS0_REG_CKSSC_INV_BUS_src(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_BUS0_get_REG_CKSSC_INV_BUS(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_BUS0_REG_GRAN_AUTO_RST_BUS_shift                             (3)
+#define SYS_PLL_SSC_DIG_BUS0_REG_GRAN_AUTO_RST_BUS_mask                              (0x00000008)
+#define SYS_PLL_SSC_DIG_BUS0_REG_GRAN_AUTO_RST_BUS(data)                             (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_BUS0_REG_GRAN_AUTO_RST_BUS_src(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_BUS0_get_REG_GRAN_AUTO_RST_BUS(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_BUS0_RSTB_BUS_shift                                          (2)
+#define SYS_PLL_SSC_DIG_BUS0_RSTB_BUS_mask                                           (0x00000004)
+#define SYS_PLL_SSC_DIG_BUS0_RSTB_BUS(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_BUS0_RSTB_BUS_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUS0_get_RSTB_BUS(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUS0_EN_SSC_BUS_shift                                        (1)
+#define SYS_PLL_SSC_DIG_BUS0_EN_SSC_BUS_mask                                         (0x00000002)
+#define SYS_PLL_SSC_DIG_BUS0_EN_SSC_BUS(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_BUS0_EN_SSC_BUS_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUS0_get_EN_SSC_BUS(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUS0_OC_EN_BUS_shift                                         (0)
+#define SYS_PLL_SSC_DIG_BUS0_OC_EN_BUS_mask                                          (0x00000001)
+#define SYS_PLL_SSC_DIG_BUS0_OC_EN_BUS(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS0_OC_EN_BUS_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS0_get_OC_EN_BUS(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS1                                                         0x98000524
+#define SYS_PLL_SSC_DIG_BUS1_reg_addr                                                "0xD8000524"
+#define SYS_PLL_SSC_DIG_BUS1_reg                                                     0xD8000524
+#define set_SYS_PLL_SSC_DIG_BUS1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS1_reg))
+#define SYS_PLL_SSC_DIG_BUS1_inst_adr                                                "0x0049"
+#define SYS_PLL_SSC_DIG_BUS1_inst                                                    0x0049
+#define SYS_PLL_SSC_DIG_BUS1_NCODE_T_BUS_shift                                       (11)
+#define SYS_PLL_SSC_DIG_BUS1_NCODE_T_BUS_mask                                        (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUS1_NCODE_T_BUS(data)                                       (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUS1_NCODE_T_BUS_src(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS1_get_NCODE_T_BUS(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS1_FCODE_T_BUS_shift                                       (0)
+#define SYS_PLL_SSC_DIG_BUS1_FCODE_T_BUS_mask                                        (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUS1_FCODE_T_BUS(data)                                       (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS1_FCODE_T_BUS_src(data)                                   ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS1_get_FCODE_T_BUS(data)                                   ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS2                                                         0x98000528
+#define SYS_PLL_SSC_DIG_BUS2_reg_addr                                                "0xD8000528"
+#define SYS_PLL_SSC_DIG_BUS2_reg                                                     0xD8000528
+#define set_SYS_PLL_SSC_DIG_BUS2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS2_reg))
+#define SYS_PLL_SSC_DIG_BUS2_inst_adr                                                "0x004A"
+#define SYS_PLL_SSC_DIG_BUS2_inst                                                    0x004A
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_DIVN_shift                                   (27)
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_DIVN_mask                                    (0x08000000)
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_DIVN(data)                                   (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_DIVN_src(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_BYPASS_DIVN(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_STEP_SET_BUS_shift                               (17)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_STEP_SET_BUS_mask                                (0x07FE0000)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_STEP_SET_BUS(data)                               (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_STEP_SET_BUS_src(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_OC_STEP_SET_BUS(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SEL_OC_MODE_BUS_shift                               (15)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SEL_OC_MODE_BUS_mask                                (0x00018000)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SEL_OC_MODE_BUS(data)                               (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_BUS2_REG_SEL_OC_MODE_BUS_src(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_SEL_OC_MODE_BUS(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_BUS2_REG_HS_OC_STOP_DIFF_BUS_shift                           (13)
+#define SYS_PLL_SSC_DIG_BUS2_REG_HS_OC_STOP_DIFF_BUS_mask                            (0x00006000)
+#define SYS_PLL_SSC_DIG_BUS2_REG_HS_OC_STOP_DIFF_BUS(data)                           (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_BUS2_REG_HS_OC_STOP_DIFF_BUS_src(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_HS_OC_STOP_DIFF_BUS(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_DONE_DELAY_BUS_shift                             (7)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_DONE_DELAY_BUS_mask                              (0x00001F80)
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_DONE_DELAY_BUS(data)                             (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_BUS2_REG_OC_DONE_DELAY_BUS_src(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_OC_DONE_DELAY_BUS(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_PI_BUS_shift                                 (6)
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_PI_BUS_mask                                  (0x00000040)
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_PI_BUS(data)                                 (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_BUS2_REG_BYPASS_PI_BUS_src(data)                             ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_BYPASS_PI_BUS(data)                             ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SDM_ORDER_BUS_shift                                 (5)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SDM_ORDER_BUS_mask                                  (0x00000020)
+#define SYS_PLL_SSC_DIG_BUS2_REG_SDM_ORDER_BUS(data)                                 (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_BUS2_REG_SDM_ORDER_BUS_src(data)                             ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_SDM_ORDER_BUS(data)                             ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_BUS2_REG_PI_CUR_SEL_BUS_shift                                (2)
+#define SYS_PLL_SSC_DIG_BUS2_REG_PI_CUR_SEL_BUS_mask                                 (0x0000001C)
+#define SYS_PLL_SSC_DIG_BUS2_REG_PI_CUR_SEL_BUS(data)                                (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_BUS2_REG_PI_CUR_SEL_BUS_src(data)                            ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_PI_CUR_SEL_BUS(data)                            ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUS2_REG_EN_PI_DEBUG_BUS_shift                               (1)
+#define SYS_PLL_SSC_DIG_BUS2_REG_EN_PI_DEBUG_BUS_mask                                (0x00000002)
+#define SYS_PLL_SSC_DIG_BUS2_REG_EN_PI_DEBUG_BUS(data)                               (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_BUS2_REG_EN_PI_DEBUG_BUS_src(data)                           ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUS2_get_REG_EN_PI_DEBUG_BUS(data)                           ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_BUS3                                                         0x9800052C
+#define SYS_PLL_SSC_DIG_BUS3_reg_addr                                                "0xD800052C"
+#define SYS_PLL_SSC_DIG_BUS3_reg                                                     0xD800052C
+#define set_SYS_PLL_SSC_DIG_BUS3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS3_reg))
+#define SYS_PLL_SSC_DIG_BUS3_inst_adr                                                "0x004B"
+#define SYS_PLL_SSC_DIG_BUS3_inst                                                    0x004B
+#define SYS_PLL_SSC_DIG_BUS3_NCODE_SSC_BUS_shift                                     (11)
+#define SYS_PLL_SSC_DIG_BUS3_NCODE_SSC_BUS_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUS3_NCODE_SSC_BUS(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUS3_NCODE_SSC_BUS_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS3_get_NCODE_SSC_BUS(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS3_FCODE_SSC_BUS_shift                                     (0)
+#define SYS_PLL_SSC_DIG_BUS3_FCODE_SSC_BUS_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUS3_FCODE_SSC_BUS(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS3_FCODE_SSC_BUS_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS3_get_FCODE_SSC_BUS(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS4                                                         0x98000530
+#define SYS_PLL_SSC_DIG_BUS4_reg_addr                                                "0xD8000530"
+#define SYS_PLL_SSC_DIG_BUS4_reg                                                     0xD8000530
+#define set_SYS_PLL_SSC_DIG_BUS4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS4_reg))
+#define SYS_PLL_SSC_DIG_BUS4_inst_adr                                                "0x004C"
+#define SYS_PLL_SSC_DIG_BUS4_inst                                                    0x004C
+#define SYS_PLL_SSC_DIG_BUS4_GRAN_EST_BUS_shift                                      (0)
+#define SYS_PLL_SSC_DIG_BUS4_GRAN_EST_BUS_mask                                       (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_BUS4_GRAN_EST_BUS(data)                                      (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS4_GRAN_EST_BUS_src(data)                                  ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS4_get_GRAN_EST_BUS(data)                                  ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS5                                                         0x98000534
+#define SYS_PLL_SSC_DIG_BUS5_reg_addr                                                "0xD8000534"
+#define SYS_PLL_SSC_DIG_BUS5_reg                                                     0xD8000534
+#define set_SYS_PLL_SSC_DIG_BUS5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS5_reg))
+#define SYS_PLL_SSC_DIG_BUS5_inst_adr                                                "0x004D"
+#define SYS_PLL_SSC_DIG_BUS5_inst                                                    0x004D
+#define SYS_PLL_SSC_DIG_BUS5_FCW_SSC_DEFAULT_BUS_shift                               (0)
+#define SYS_PLL_SSC_DIG_BUS5_FCW_SSC_DEFAULT_BUS_mask                                (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_BUS5_FCW_SSC_DEFAULT_BUS(data)                               (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS5_FCW_SSC_DEFAULT_BUS_src(data)                           ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS5_get_FCW_SSC_DEFAULT_BUS(data)                           ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS_DBG1                                                     0x98000538
+#define SYS_PLL_SSC_DIG_BUS_DBG1_reg_addr                                            "0xD8000538"
+#define SYS_PLL_SSC_DIG_BUS_DBG1_reg                                                 0xD8000538
+#define set_SYS_PLL_SSC_DIG_BUS_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS_DBG1_reg))
+#define SYS_PLL_SSC_DIG_BUS_DBG1_inst_adr                                            "0x004E"
+#define SYS_PLL_SSC_DIG_BUS_DBG1_inst                                                0x004E
+#define SYS_PLL_SSC_DIG_BUS_DBG1_LOOP_PI_ISEL_BUS_shift                              (13)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_LOOP_PI_ISEL_BUS_mask                               (0x0000E000)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_LOOP_PI_ISEL_BUS(data)                              (0x0000E000&((data)<<13))
+#define SYS_PLL_SSC_DIG_BUS_DBG1_LOOP_PI_ISEL_BUS_src(data)                          ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_get_LOOP_PI_ISEL_BUS(data)                          ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_PHSEL_BUS_shift                                     (8)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_PHSEL_BUS_mask                                      (0x00001F00)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_PHSEL_BUS(data)                                     (0x00001F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_BUS_DBG1_PHSEL_BUS_src(data)                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_get_PHSEL_BUS(data)                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_DIVN_BUS_shift                                      (0)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_DIVN_BUS_mask                                       (0x000000FF)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_DIVN_BUS(data)                                      (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS_DBG1_DIVN_BUS_src(data)                                  ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS_DBG1_get_DIVN_BUS(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUS_DBG2                                                     0x9800053C
+#define SYS_PLL_SSC_DIG_BUS_DBG2_reg_addr                                            "0xD800053C"
+#define SYS_PLL_SSC_DIG_BUS_DBG2_reg                                                 0xD800053C
+#define set_SYS_PLL_SSC_DIG_BUS_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUS_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUS_DBG2_reg))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_inst_adr                                            "0x004F"
+#define SYS_PLL_SSC_DIG_BUS_DBG2_inst                                                0x004F
+#define SYS_PLL_SSC_DIG_BUS_DBG2_load_FCW_BUS_shift                                  (21)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_load_FCW_BUS_mask                                   (0x00200000)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_load_FCW_BUS(data)                                  (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_load_FCW_BUS_src(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_get_load_FCW_BUS(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_OC_DONE_BUS_shift                                   (20)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_OC_DONE_BUS_mask                                    (0x00100000)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_OC_DONE_BUS(data)                                   (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_OC_DONE_BUS_src(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_get_OC_DONE_BUS(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FMOD_BUS_shift                                      (19)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FMOD_BUS_mask                                       (0x00080000)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FMOD_BUS(data)                                      (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FMOD_BUS_src(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_get_FMOD_BUS(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_NCODE_DEBUG_BUS_shift                               (11)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_NCODE_DEBUG_BUS_mask                                (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_NCODE_DEBUG_BUS(data)                               (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_NCODE_DEBUG_BUS_src(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_get_NCODE_DEBUG_BUS(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FCODE_DEBUG_BUS_shift                               (0)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FCODE_DEBUG_BUS_mask                                (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FCODE_DEBUG_BUS(data)                               (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUS_DBG2_FCODE_DEBUG_BUS_src(data)                           ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUS_DBG2_get_FCODE_DEBUG_BUS(data)                           ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH0                                                        0x98000540
+#define SYS_PLL_SSC_DIG_BUSH0_reg_addr                                               "0xD8000540"
+#define SYS_PLL_SSC_DIG_BUSH0_reg                                                    0xD8000540
+#define set_SYS_PLL_SSC_DIG_BUSH0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH0_reg))
+#define SYS_PLL_SSC_DIG_BUSH0_inst_adr                                               "0x0050"
+#define SYS_PLL_SSC_DIG_BUSH0_inst                                                   0x0050
+#define SYS_PLL_SSC_DIG_BUSH0_REG_CKSSC_INV_BUS_H_shift                              (4)
+#define SYS_PLL_SSC_DIG_BUSH0_REG_CKSSC_INV_BUS_H_mask                               (0x00000010)
+#define SYS_PLL_SSC_DIG_BUSH0_REG_CKSSC_INV_BUS_H(data)                              (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_BUSH0_REG_CKSSC_INV_BUS_H_src(data)                          ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_BUSH0_get_REG_CKSSC_INV_BUS_H(data)                          ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_BUSH0_REG_GRAN_AUTO_RST_BUS_H_shift                          (3)
+#define SYS_PLL_SSC_DIG_BUSH0_REG_GRAN_AUTO_RST_BUS_H_mask                           (0x00000008)
+#define SYS_PLL_SSC_DIG_BUSH0_REG_GRAN_AUTO_RST_BUS_H(data)                          (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_BUSH0_REG_GRAN_AUTO_RST_BUS_H_src(data)                      ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_BUSH0_get_REG_GRAN_AUTO_RST_BUS_H(data)                      ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_BUSH0_RSTB_BUS_H_shift                                       (2)
+#define SYS_PLL_SSC_DIG_BUSH0_RSTB_BUS_H_mask                                        (0x00000004)
+#define SYS_PLL_SSC_DIG_BUSH0_RSTB_BUS_H(data)                                       (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_BUSH0_RSTB_BUS_H_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUSH0_get_RSTB_BUS_H(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUSH0_EN_SSC_BUS_H_shift                                     (1)
+#define SYS_PLL_SSC_DIG_BUSH0_EN_SSC_BUS_H_mask                                      (0x00000002)
+#define SYS_PLL_SSC_DIG_BUSH0_EN_SSC_BUS_H(data)                                     (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_BUSH0_EN_SSC_BUS_H_src(data)                                 ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUSH0_get_EN_SSC_BUS_H(data)                                 ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUSH0_OC_EN_BUS_H_shift                                      (0)
+#define SYS_PLL_SSC_DIG_BUSH0_OC_EN_BUS_H_mask                                       (0x00000001)
+#define SYS_PLL_SSC_DIG_BUSH0_OC_EN_BUS_H(data)                                      (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH0_OC_EN_BUS_H_src(data)                                  ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH0_get_OC_EN_BUS_H(data)                                  ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH1                                                        0x98000544
+#define SYS_PLL_SSC_DIG_BUSH1_reg_addr                                               "0xD8000544"
+#define SYS_PLL_SSC_DIG_BUSH1_reg                                                    0xD8000544
+#define set_SYS_PLL_SSC_DIG_BUSH1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH1_reg))
+#define SYS_PLL_SSC_DIG_BUSH1_inst_adr                                               "0x0051"
+#define SYS_PLL_SSC_DIG_BUSH1_inst                                                   0x0051
+#define SYS_PLL_SSC_DIG_BUSH1_NCODE_T_BUS_H_shift                                    (11)
+#define SYS_PLL_SSC_DIG_BUSH1_NCODE_T_BUS_H_mask                                     (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUSH1_NCODE_T_BUS_H(data)                                    (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUSH1_NCODE_T_BUS_H_src(data)                                ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH1_get_NCODE_T_BUS_H(data)                                ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH1_FCODE_T_BUS_H_shift                                    (0)
+#define SYS_PLL_SSC_DIG_BUSH1_FCODE_T_BUS_H_mask                                     (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUSH1_FCODE_T_BUS_H(data)                                    (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH1_FCODE_T_BUS_H_src(data)                                ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH1_get_FCODE_T_BUS_H(data)                                ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH2                                                        0x98000548
+#define SYS_PLL_SSC_DIG_BUSH2_reg_addr                                               "0xD8000548"
+#define SYS_PLL_SSC_DIG_BUSH2_reg                                                    0xD8000548
+#define set_SYS_PLL_SSC_DIG_BUSH2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH2_reg))
+#define SYS_PLL_SSC_DIG_BUSH2_inst_adr                                               "0x0052"
+#define SYS_PLL_SSC_DIG_BUSH2_inst                                                   0x0052
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_DIVN_shift                                  (27)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_DIVN_mask                                   (0x08000000)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_DIVN(data)                                  (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_DIVN_src(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_BYPASS_DIVN(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_STEP_SET_BUS_H_shift                            (17)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_STEP_SET_BUS_H_mask                             (0x07FE0000)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_STEP_SET_BUS_H(data)                            (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_STEP_SET_BUS_H_src(data)                        ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_OC_STEP_SET_BUS_H(data)                        ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SEL_OC_MODE_BUS_H_shift                            (15)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SEL_OC_MODE_BUS_H_mask                             (0x00018000)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SEL_OC_MODE_BUS_H(data)                            (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SEL_OC_MODE_BUS_H_src(data)                        ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_SEL_OC_MODE_BUS_H(data)                        ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_HS_OC_STOP_DIFF_BUS_H_shift                        (13)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_HS_OC_STOP_DIFF_BUS_H_mask                         (0x00006000)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_HS_OC_STOP_DIFF_BUS_H(data)                        (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_HS_OC_STOP_DIFF_BUS_H_src(data)                    ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_HS_OC_STOP_DIFF_BUS_H(data)                    ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_DONE_DELAY_BUS_H_shift                          (7)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_DONE_DELAY_BUS_H_mask                           (0x00001F80)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_DONE_DELAY_BUS_H(data)                          (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_OC_DONE_DELAY_BUS_H_src(data)                      ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_OC_DONE_DELAY_BUS_H(data)                      ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_PI_BUS_H_shift                              (6)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_PI_BUS_H_mask                               (0x00000040)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_PI_BUS_H(data)                              (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_BYPASS_PI_BUS_H_src(data)                          ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_BYPASS_PI_BUS_H(data)                          ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SDM_ORDER_BUS_H_shift                              (5)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SDM_ORDER_BUS_H_mask                               (0x00000020)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SDM_ORDER_BUS_H(data)                              (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_SDM_ORDER_BUS_H_src(data)                          ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_SDM_ORDER_BUS_H(data)                          ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_PI_CUR_SEL_BUS_H_shift                             (2)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_PI_CUR_SEL_BUS_H_mask                              (0x0000001C)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_PI_CUR_SEL_BUS_H(data)                             (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_PI_CUR_SEL_BUS_H_src(data)                         ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_PI_CUR_SEL_BUS_H(data)                         ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_EN_PI_DEBUG_BUS_H_shift                            (1)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_EN_PI_DEBUG_BUS_H_mask                             (0x00000002)
+#define SYS_PLL_SSC_DIG_BUSH2_REG_EN_PI_DEBUG_BUS_H(data)                            (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_BUSH2_REG_EN_PI_DEBUG_BUS_H_src(data)                        ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_BUSH2_get_REG_EN_PI_DEBUG_BUS_H(data)                        ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_BUSH3                                                        0x9800054C
+#define SYS_PLL_SSC_DIG_BUSH3_reg_addr                                               "0xD800054C"
+#define SYS_PLL_SSC_DIG_BUSH3_reg                                                    0xD800054C
+#define set_SYS_PLL_SSC_DIG_BUSH3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH3_reg))
+#define SYS_PLL_SSC_DIG_BUSH3_inst_adr                                               "0x0053"
+#define SYS_PLL_SSC_DIG_BUSH3_inst                                                   0x0053
+#define SYS_PLL_SSC_DIG_BUSH3_NCODE_SSC_BUS_H_shift                                  (11)
+#define SYS_PLL_SSC_DIG_BUSH3_NCODE_SSC_BUS_H_mask                                   (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUSH3_NCODE_SSC_BUS_H(data)                                  (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUSH3_NCODE_SSC_BUS_H_src(data)                              ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH3_get_NCODE_SSC_BUS_H(data)                              ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH3_FCODE_SSC_BUS_H_shift                                  (0)
+#define SYS_PLL_SSC_DIG_BUSH3_FCODE_SSC_BUS_H_mask                                   (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUSH3_FCODE_SSC_BUS_H(data)                                  (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH3_FCODE_SSC_BUS_H_src(data)                              ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH3_get_FCODE_SSC_BUS_H(data)                              ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH4                                                        0x98000550
+#define SYS_PLL_SSC_DIG_BUSH4_reg_addr                                               "0xD8000550"
+#define SYS_PLL_SSC_DIG_BUSH4_reg                                                    0xD8000550
+#define set_SYS_PLL_SSC_DIG_BUSH4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH4_reg))
+#define SYS_PLL_SSC_DIG_BUSH4_inst_adr                                               "0x0054"
+#define SYS_PLL_SSC_DIG_BUSH4_inst                                                   0x0054
+#define SYS_PLL_SSC_DIG_BUSH4_GRAN_EST_BUS_H_shift                                   (0)
+#define SYS_PLL_SSC_DIG_BUSH4_GRAN_EST_BUS_H_mask                                    (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_BUSH4_GRAN_EST_BUS_H(data)                                   (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH4_GRAN_EST_BUS_H_src(data)                               ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH4_get_GRAN_EST_BUS_H(data)                               ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH5                                                        0x98000554
+#define SYS_PLL_SSC_DIG_BUSH5_reg_addr                                               "0xD8000554"
+#define SYS_PLL_SSC_DIG_BUSH5_reg                                                    0xD8000554
+#define set_SYS_PLL_SSC_DIG_BUSH5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH5_reg))
+#define SYS_PLL_SSC_DIG_BUSH5_inst_adr                                               "0x0055"
+#define SYS_PLL_SSC_DIG_BUSH5_inst                                                   0x0055
+#define SYS_PLL_SSC_DIG_BUSH5_FCW_SSC_DEFAULT_BUS_H_shift                            (0)
+#define SYS_PLL_SSC_DIG_BUSH5_FCW_SSC_DEFAULT_BUS_H_mask                             (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_BUSH5_FCW_SSC_DEFAULT_BUS_H(data)                            (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH5_FCW_SSC_DEFAULT_BUS_H_src(data)                        ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH5_get_FCW_SSC_DEFAULT_BUS_H(data)                        ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH_DBG1                                                    0x98000558
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_reg_addr                                           "0xD8000558"
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_reg                                                0xD8000558
+#define set_SYS_PLL_SSC_DIG_BUSH_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH_DBG1_reg))
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_inst_adr                                           "0x0056"
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_inst                                               0x0056
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_LOOP_PI_ISEL_BUS_H_shift                           (13)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_LOOP_PI_ISEL_BUS_H_mask                            (0x0000E000)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_LOOP_PI_ISEL_BUS_H(data)                           (0x0000E000&((data)<<13))
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_LOOP_PI_ISEL_BUS_H_src(data)                       ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_get_LOOP_PI_ISEL_BUS_H(data)                       ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_PHSEL_BUS_H_shift                                  (8)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_PHSEL_BUS_H_mask                                   (0x00001F00)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_PHSEL_BUS_H(data)                                  (0x00001F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_PHSEL_BUS_H_src(data)                              ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_get_PHSEL_BUS_H(data)                              ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_DIVN_BUS_H_shift                                   (0)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_DIVN_BUS_H_mask                                    (0x000000FF)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_DIVN_BUS_H(data)                                   (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_DIVN_BUS_H_src(data)                               ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH_DBG1_get_DIVN_BUS_H(data)                               ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_BUSH_DBG2                                                    0x9800055C
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_reg_addr                                           "0xD800055C"
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_reg                                                0xD800055C
+#define set_SYS_PLL_SSC_DIG_BUSH_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_BUSH_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_BUSH_DBG2_reg))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_inst_adr                                           "0x0057"
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_inst                                               0x0057
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_load_FCW_BUS_H_shift                               (21)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_load_FCW_BUS_H_mask                                (0x00200000)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_load_FCW_BUS_H(data)                               (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_load_FCW_BUS_H_src(data)                           ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_get_load_FCW_BUS_H(data)                           ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_OC_DONE_BUS_H_shift                                (20)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_OC_DONE_BUS_H_mask                                 (0x00100000)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_OC_DONE_BUS_H(data)                                (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_OC_DONE_BUS_H_src(data)                            ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_get_OC_DONE_BUS_H(data)                            ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FMOD_BUS_H_shift                                   (19)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FMOD_BUS_H_mask                                    (0x00080000)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FMOD_BUS_H(data)                                   (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FMOD_BUS_H_src(data)                               ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_get_FMOD_BUS_H(data)                               ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_NCODE_DEBUG_BUS_H_shift                            (11)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_NCODE_DEBUG_BUS_H_mask                             (0x0007F800)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_NCODE_DEBUG_BUS_H(data)                            (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_NCODE_DEBUG_BUS_H_src(data)                        ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_get_NCODE_DEBUG_BUS_H(data)                        ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FCODE_DEBUG_BUS_H_shift                            (0)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FCODE_DEBUG_BUS_H_mask                             (0x000007FF)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FCODE_DEBUG_BUS_H(data)                            (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_FCODE_DEBUG_BUS_H_src(data)                        ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_BUSH_DBG2_get_FCODE_DEBUG_BUS_H(data)                        ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA0                                                        0x98000560
+#define SYS_PLL_SSC_DIG_DDSA0_reg_addr                                               "0xD8000560"
+#define SYS_PLL_SSC_DIG_DDSA0_reg                                                    0xD8000560
+#define set_SYS_PLL_SSC_DIG_DDSA0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA0_reg))
+#define SYS_PLL_SSC_DIG_DDSA0_inst_adr                                               "0x0058"
+#define SYS_PLL_SSC_DIG_DDSA0_inst                                                   0x0058
+#define SYS_PLL_SSC_DIG_DDSA0_REG_CKSSC_INV_DDSA_shift                               (4)
+#define SYS_PLL_SSC_DIG_DDSA0_REG_CKSSC_INV_DDSA_mask                                (0x00000010)
+#define SYS_PLL_SSC_DIG_DDSA0_REG_CKSSC_INV_DDSA(data)                               (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_DDSA0_REG_CKSSC_INV_DDSA_src(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_DDSA0_get_REG_CKSSC_INV_DDSA(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_DDSA0_REG_GRAN_AUTO_RST_DDSA_shift                           (3)
+#define SYS_PLL_SSC_DIG_DDSA0_REG_GRAN_AUTO_RST_DDSA_mask                            (0x00000008)
+#define SYS_PLL_SSC_DIG_DDSA0_REG_GRAN_AUTO_RST_DDSA(data)                           (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_DDSA0_REG_GRAN_AUTO_RST_DDSA_src(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_DDSA0_get_REG_GRAN_AUTO_RST_DDSA(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_DDSA0_RSTB_DDSA_shift                                        (2)
+#define SYS_PLL_SSC_DIG_DDSA0_RSTB_DDSA_mask                                         (0x00000004)
+#define SYS_PLL_SSC_DIG_DDSA0_RSTB_DDSA(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_DDSA0_RSTB_DDSA_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSA0_get_RSTB_DDSA(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSA0_EN_SSC_DDSA_shift                                      (1)
+#define SYS_PLL_SSC_DIG_DDSA0_EN_SSC_DDSA_mask                                       (0x00000002)
+#define SYS_PLL_SSC_DIG_DDSA0_EN_SSC_DDSA(data)                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_DDSA0_EN_SSC_DDSA_src(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSA0_get_EN_SSC_DDSA(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSA0_OC_EN_DDSA_shift                                       (0)
+#define SYS_PLL_SSC_DIG_DDSA0_OC_EN_DDSA_mask                                        (0x00000001)
+#define SYS_PLL_SSC_DIG_DDSA0_OC_EN_DDSA(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA0_OC_EN_DDSA_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA0_get_OC_EN_DDSA(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA1                                                        0x98000564
+#define SYS_PLL_SSC_DIG_DDSA1_reg_addr                                               "0xD8000564"
+#define SYS_PLL_SSC_DIG_DDSA1_reg                                                    0xD8000564
+#define set_SYS_PLL_SSC_DIG_DDSA1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA1_reg))
+#define SYS_PLL_SSC_DIG_DDSA1_inst_adr                                               "0x0059"
+#define SYS_PLL_SSC_DIG_DDSA1_inst                                                   0x0059
+#define SYS_PLL_SSC_DIG_DDSA1_REG_PLLDDSA_ICO_PDIV2_shift                            (19)
+#define SYS_PLL_SSC_DIG_DDSA1_REG_PLLDDSA_ICO_PDIV2_mask                             (0x00380000)
+#define SYS_PLL_SSC_DIG_DDSA1_REG_PLLDDSA_ICO_PDIV2(data)                            (0x00380000&((data)<<19))
+#define SYS_PLL_SSC_DIG_DDSA1_REG_PLLDDSA_ICO_PDIV2_src(data)                        ((0x00380000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSA1_get_REG_PLLDDSA_ICO_PDIV2(data)                        ((0x00380000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSA1_NCODE_T_DDSA_shift                                     (11)
+#define SYS_PLL_SSC_DIG_DDSA1_NCODE_T_DDSA_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSA1_NCODE_T_DDSA(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSA1_NCODE_T_DDSA_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA1_get_NCODE_T_DDSA(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA1_FCODE_T_DDSA_shift                                     (0)
+#define SYS_PLL_SSC_DIG_DDSA1_FCODE_T_DDSA_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSA1_FCODE_T_DDSA(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA1_FCODE_T_DDSA_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA1_get_FCODE_T_DDSA(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA2                                                        0x98000568
+#define SYS_PLL_SSC_DIG_DDSA2_reg_addr                                               "0xD8000568"
+#define SYS_PLL_SSC_DIG_DDSA2_reg                                                    0xD8000568
+#define set_SYS_PLL_SSC_DIG_DDSA2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA2_reg))
+#define SYS_PLL_SSC_DIG_DDSA2_inst_adr                                               "0x005A"
+#define SYS_PLL_SSC_DIG_DDSA2_inst                                                   0x005A
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_DIVN_shift                                  (27)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_DIVN_mask                                   (0x08000000)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_DIVN(data)                                  (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_DIVN_src(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_BYPASS_DIVN(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_STEP_SET_DDSA_shift                             (17)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_STEP_SET_DDSA_mask                              (0x07FE0000)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_STEP_SET_DDSA(data)                             (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_STEP_SET_DDSA_src(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_OC_STEP_SET_DDSA(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SEL_OC_MODE_DDSA_shift                             (15)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SEL_OC_MODE_DDSA_mask                              (0x00018000)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SEL_OC_MODE_DDSA(data)                             (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SEL_OC_MODE_DDSA_src(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_SEL_OC_MODE_DDSA(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_HS_OC_STOP_DIFF_DDSA_shift                         (13)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_HS_OC_STOP_DIFF_DDSA_mask                          (0x00006000)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_HS_OC_STOP_DIFF_DDSA(data)                         (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_HS_OC_STOP_DIFF_DDSA_src(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_HS_OC_STOP_DIFF_DDSA(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_DONE_DELAY_DDSA_shift                           (7)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_DONE_DELAY_DDSA_mask                            (0x00001F80)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_DONE_DELAY_DDSA(data)                           (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_OC_DONE_DELAY_DDSA_src(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_OC_DONE_DELAY_DDSA(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_PI_DDSA_shift                               (6)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_PI_DDSA_mask                                (0x00000040)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_PI_DDSA(data)                               (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_BYPASS_PI_DDSA_src(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_BYPASS_PI_DDSA(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SDM_ORDER_DDSA_shift                               (5)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SDM_ORDER_DDSA_mask                                (0x00000020)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SDM_ORDER_DDSA(data)                               (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_SDM_ORDER_DDSA_src(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_SDM_ORDER_DDSA(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_PI_CUR_SEL_DDSA_shift                              (2)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_PI_CUR_SEL_DDSA_mask                               (0x0000001C)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_PI_CUR_SEL_DDSA(data)                              (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_PI_CUR_SEL_DDSA_src(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_PI_CUR_SEL_DDSA(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_EN_PI_DEBUG_DDSA_shift                             (1)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_EN_PI_DEBUG_DDSA_mask                              (0x00000002)
+#define SYS_PLL_SSC_DIG_DDSA2_REG_EN_PI_DEBUG_DDSA(data)                             (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_DDSA2_REG_EN_PI_DEBUG_DDSA_src(data)                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSA2_get_REG_EN_PI_DEBUG_DDSA(data)                         ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_DDSA3                                                        0x9800056C
+#define SYS_PLL_SSC_DIG_DDSA3_reg_addr                                               "0xD800056C"
+#define SYS_PLL_SSC_DIG_DDSA3_reg                                                    0xD800056C
+#define set_SYS_PLL_SSC_DIG_DDSA3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA3_reg))
+#define SYS_PLL_SSC_DIG_DDSA3_inst_adr                                               "0x005B"
+#define SYS_PLL_SSC_DIG_DDSA3_inst                                                   0x005B
+#define SYS_PLL_SSC_DIG_DDSA3_NCODE_SSC_DDSA_shift                                   (11)
+#define SYS_PLL_SSC_DIG_DDSA3_NCODE_SSC_DDSA_mask                                    (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSA3_NCODE_SSC_DDSA(data)                                   (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSA3_NCODE_SSC_DDSA_src(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA3_get_NCODE_SSC_DDSA(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA3_FCODE_SSC_DDSA_shift                                   (0)
+#define SYS_PLL_SSC_DIG_DDSA3_FCODE_SSC_DDSA_mask                                    (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSA3_FCODE_SSC_DDSA(data)                                   (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA3_FCODE_SSC_DDSA_src(data)                               ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA3_get_FCODE_SSC_DDSA(data)                               ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA4                                                        0x98000570
+#define SYS_PLL_SSC_DIG_DDSA4_reg_addr                                               "0xD8000570"
+#define SYS_PLL_SSC_DIG_DDSA4_reg                                                    0xD8000570
+#define set_SYS_PLL_SSC_DIG_DDSA4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA4_reg))
+#define SYS_PLL_SSC_DIG_DDSA4_inst_adr                                               "0x005C"
+#define SYS_PLL_SSC_DIG_DDSA4_inst                                                   0x005C
+#define SYS_PLL_SSC_DIG_DDSA4_GRAN_EST_DDSA_shift                                    (0)
+#define SYS_PLL_SSC_DIG_DDSA4_GRAN_EST_DDSA_mask                                     (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_DDSA4_GRAN_EST_DDSA(data)                                    (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA4_GRAN_EST_DDSA_src(data)                                ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA4_get_GRAN_EST_DDSA(data)                                ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA5                                                        0x98000574
+#define SYS_PLL_SSC_DIG_DDSA5_reg_addr                                               "0xD8000574"
+#define SYS_PLL_SSC_DIG_DDSA5_reg                                                    0xD8000574
+#define set_SYS_PLL_SSC_DIG_DDSA5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA5_reg))
+#define SYS_PLL_SSC_DIG_DDSA5_inst_adr                                               "0x005D"
+#define SYS_PLL_SSC_DIG_DDSA5_inst                                                   0x005D
+#define SYS_PLL_SSC_DIG_DDSA5_FCW_SSC_DEFAULT_DDSA_shift                             (0)
+#define SYS_PLL_SSC_DIG_DDSA5_FCW_SSC_DEFAULT_DDSA_mask                              (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_DDSA5_FCW_SSC_DEFAULT_DDSA(data)                             (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA5_FCW_SSC_DEFAULT_DDSA_src(data)                         ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA5_get_FCW_SSC_DEFAULT_DDSA(data)                         ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA_DBG1                                                    0x98000578
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_reg_addr                                           "0xD8000578"
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_reg                                                0xD8000578
+#define set_SYS_PLL_SSC_DIG_DDSA_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA_DBG1_reg))
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_inst_adr                                           "0x005E"
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_inst                                               0x005E
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_LOOP_PI_ISEL_DDSA_shift                            (14)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_LOOP_PI_ISEL_DDSA_mask                             (0x0001C000)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_LOOP_PI_ISEL_DDSA(data)                            (0x0001C000&((data)<<14))
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_LOOP_PI_ISEL_DDSA_src(data)                        ((0x0001C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_get_LOOP_PI_ISEL_DDSA(data)                        ((0x0001C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_PHSEL_DDSA_shift                                   (8)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_PHSEL_DDSA_mask                                    (0x00003F00)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_PHSEL_DDSA(data)                                   (0x00003F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_PHSEL_DDSA_src(data)                               ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_get_PHSEL_DDSA(data)                               ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_DIVN_DDSA_shift                                    (0)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_DIVN_DDSA_mask                                     (0x000000FF)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_DIVN_DDSA(data)                                    (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_DIVN_DDSA_src(data)                                ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA_DBG1_get_DIVN_DDSA(data)                                ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSA_DBG2                                                    0x9800057C
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_reg_addr                                           "0xD800057C"
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_reg                                                0xD800057C
+#define set_SYS_PLL_SSC_DIG_DDSA_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSA_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSA_DBG2_reg))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_inst_adr                                           "0x005F"
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_inst                                               0x005F
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_load_FCW_DDSA_shift                                (21)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_load_FCW_DDSA_mask                                 (0x00200000)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_load_FCW_DDSA(data)                                (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_load_FCW_DDSA_src(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_get_load_FCW_DDSA(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_OC_DONE_DDSA_shift                                 (20)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_OC_DONE_DDSA_mask                                  (0x00100000)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_OC_DONE_DDSA(data)                                 (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_OC_DONE_DDSA_src(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_get_OC_DONE_DDSA(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FMOD_DDSA_shift                                    (19)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FMOD_DDSA_mask                                     (0x00080000)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FMOD_DDSA(data)                                    (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FMOD_DDSA_src(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_get_FMOD_DDSA(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_NCODE_DEBUG_DDSA_shift                             (11)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_NCODE_DEBUG_DDSA_mask                              (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_NCODE_DEBUG_DDSA(data)                             (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_NCODE_DEBUG_DDSA_src(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_get_NCODE_DEBUG_DDSA(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FCODE_DEBUG_DDSA_shift                             (0)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FCODE_DEBUG_DDSA_mask                              (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FCODE_DEBUG_DDSA(data)                             (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_FCODE_DEBUG_DDSA_src(data)                         ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSA_DBG2_get_FCODE_DEBUG_DDSA(data)                         ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB0                                                        0x98000580
+#define SYS_PLL_SSC_DIG_DDSB0_reg_addr                                               "0xD8000580"
+#define SYS_PLL_SSC_DIG_DDSB0_reg                                                    0xD8000580
+#define set_SYS_PLL_SSC_DIG_DDSB0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB0_reg))
+#define SYS_PLL_SSC_DIG_DDSB0_inst_adr                                               "0x0060"
+#define SYS_PLL_SSC_DIG_DDSB0_inst                                                   0x0060
+#define SYS_PLL_SSC_DIG_DDSB0_REG_CKSSC_INV_DDSB_shift                               (4)
+#define SYS_PLL_SSC_DIG_DDSB0_REG_CKSSC_INV_DDSB_mask                                (0x00000010)
+#define SYS_PLL_SSC_DIG_DDSB0_REG_CKSSC_INV_DDSB(data)                               (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_DDSB0_REG_CKSSC_INV_DDSB_src(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_DDSB0_get_REG_CKSSC_INV_DDSB(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_DDSB0_REG_GRAN_AUTO_RST_DDSB_shift                           (3)
+#define SYS_PLL_SSC_DIG_DDSB0_REG_GRAN_AUTO_RST_DDSB_mask                            (0x00000008)
+#define SYS_PLL_SSC_DIG_DDSB0_REG_GRAN_AUTO_RST_DDSB(data)                           (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_DDSB0_REG_GRAN_AUTO_RST_DDSB_src(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_DDSB0_get_REG_GRAN_AUTO_RST_DDSB(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_DDSB0_RSTB_DDSB_shift                                        (2)
+#define SYS_PLL_SSC_DIG_DDSB0_RSTB_DDSB_mask                                         (0x00000004)
+#define SYS_PLL_SSC_DIG_DDSB0_RSTB_DDSB(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_DDSB0_RSTB_DDSB_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSB0_get_RSTB_DDSB(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSB0_EN_SSC_DDSB_shift                                      (1)
+#define SYS_PLL_SSC_DIG_DDSB0_EN_SSC_DDSB_mask                                       (0x00000002)
+#define SYS_PLL_SSC_DIG_DDSB0_EN_SSC_DDSB(data)                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_DDSB0_EN_SSC_DDSB_src(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSB0_get_EN_SSC_DDSB(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSB0_OC_EN_DDSB_shift                                       (0)
+#define SYS_PLL_SSC_DIG_DDSB0_OC_EN_DDSB_mask                                        (0x00000001)
+#define SYS_PLL_SSC_DIG_DDSB0_OC_EN_DDSB(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB0_OC_EN_DDSB_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB0_get_OC_EN_DDSB(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB1                                                        0x98000584
+#define SYS_PLL_SSC_DIG_DDSB1_reg_addr                                               "0xD8000584"
+#define SYS_PLL_SSC_DIG_DDSB1_reg                                                    0xD8000584
+#define set_SYS_PLL_SSC_DIG_DDSB1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB1_reg))
+#define SYS_PLL_SSC_DIG_DDSB1_inst_adr                                               "0x0061"
+#define SYS_PLL_SSC_DIG_DDSB1_inst                                                   0x0061
+#define SYS_PLL_SSC_DIG_DDSB1_REG_PLLDDSB_ICO_PDIV2_shift                            (19)
+#define SYS_PLL_SSC_DIG_DDSB1_REG_PLLDDSB_ICO_PDIV2_mask                             (0x00380000)
+#define SYS_PLL_SSC_DIG_DDSB1_REG_PLLDDSB_ICO_PDIV2(data)                            (0x00380000&((data)<<19))
+#define SYS_PLL_SSC_DIG_DDSB1_REG_PLLDDSB_ICO_PDIV2_src(data)                        ((0x00380000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSB1_get_REG_PLLDDSB_ICO_PDIV2(data)                        ((0x00380000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSB1_NCODE_T_DDSB_shift                                     (11)
+#define SYS_PLL_SSC_DIG_DDSB1_NCODE_T_DDSB_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSB1_NCODE_T_DDSB(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSB1_NCODE_T_DDSB_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB1_get_NCODE_T_DDSB(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB1_FCODE_T_DDSB_shift                                     (0)
+#define SYS_PLL_SSC_DIG_DDSB1_FCODE_T_DDSB_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSB1_FCODE_T_DDSB(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB1_FCODE_T_DDSB_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB1_get_FCODE_T_DDSB(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB2                                                        0x98000588
+#define SYS_PLL_SSC_DIG_DDSB2_reg_addr                                               "0xD8000588"
+#define SYS_PLL_SSC_DIG_DDSB2_reg                                                    0xD8000588
+#define set_SYS_PLL_SSC_DIG_DDSB2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB2_reg))
+#define SYS_PLL_SSC_DIG_DDSB2_inst_adr                                               "0x0062"
+#define SYS_PLL_SSC_DIG_DDSB2_inst                                                   0x0062
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_DIVN_shift                                  (27)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_DIVN_mask                                   (0x08000000)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_DIVN(data)                                  (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_DIVN_src(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_BYPASS_DIVN(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_STEP_SET_DDSB_shift                             (17)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_STEP_SET_DDSB_mask                              (0x07FE0000)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_STEP_SET_DDSB(data)                             (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_STEP_SET_DDSB_src(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_OC_STEP_SET_DDSB(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SEL_OC_MODE_DDSB_shift                             (15)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SEL_OC_MODE_DDSB_mask                              (0x00018000)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SEL_OC_MODE_DDSB(data)                             (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SEL_OC_MODE_DDSB_src(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_SEL_OC_MODE_DDSB(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_HS_OC_STOP_DIFF_DDSB_shift                         (13)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_HS_OC_STOP_DIFF_DDSB_mask                          (0x00006000)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_HS_OC_STOP_DIFF_DDSB(data)                         (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_HS_OC_STOP_DIFF_DDSB_src(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_HS_OC_STOP_DIFF_DDSB(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_DONE_DELAY_DDSB_shift                           (7)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_DONE_DELAY_DDSB_mask                            (0x00001F80)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_DONE_DELAY_DDSB(data)                           (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_OC_DONE_DELAY_DDSB_src(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_OC_DONE_DELAY_DDSB(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_PI_DDSB_shift                               (6)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_PI_DDSB_mask                                (0x00000040)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_PI_DDSB(data)                               (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_BYPASS_PI_DDSB_src(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_BYPASS_PI_DDSB(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SDM_ORDER_DDSB_shift                               (5)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SDM_ORDER_DDSB_mask                                (0x00000020)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SDM_ORDER_DDSB(data)                               (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_SDM_ORDER_DDSB_src(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_SDM_ORDER_DDSB(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_PI_CUR_SEL_DDSB_shift                              (2)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_PI_CUR_SEL_DDSB_mask                               (0x0000001C)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_PI_CUR_SEL_DDSB(data)                              (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_PI_CUR_SEL_DDSB_src(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_PI_CUR_SEL_DDSB(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_EN_PI_DEBUG_DDSB_shift                             (1)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_EN_PI_DEBUG_DDSB_mask                              (0x00000002)
+#define SYS_PLL_SSC_DIG_DDSB2_REG_EN_PI_DEBUG_DDSB(data)                             (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_DDSB2_REG_EN_PI_DEBUG_DDSB_src(data)                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_DDSB2_get_REG_EN_PI_DEBUG_DDSB(data)                         ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_DDSB3                                                        0x9800058C
+#define SYS_PLL_SSC_DIG_DDSB3_reg_addr                                               "0xD800058C"
+#define SYS_PLL_SSC_DIG_DDSB3_reg                                                    0xD800058C
+#define set_SYS_PLL_SSC_DIG_DDSB3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB3_reg))
+#define SYS_PLL_SSC_DIG_DDSB3_inst_adr                                               "0x0063"
+#define SYS_PLL_SSC_DIG_DDSB3_inst                                                   0x0063
+#define SYS_PLL_SSC_DIG_DDSB3_NCODE_SSC_DDSB_shift                                   (11)
+#define SYS_PLL_SSC_DIG_DDSB3_NCODE_SSC_DDSB_mask                                    (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSB3_NCODE_SSC_DDSB(data)                                   (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSB3_NCODE_SSC_DDSB_src(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB3_get_NCODE_SSC_DDSB(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB3_FCODE_SSC_DDSB_shift                                   (0)
+#define SYS_PLL_SSC_DIG_DDSB3_FCODE_SSC_DDSB_mask                                    (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSB3_FCODE_SSC_DDSB(data)                                   (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB3_FCODE_SSC_DDSB_src(data)                               ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB3_get_FCODE_SSC_DDSB(data)                               ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB4                                                        0x98000590
+#define SYS_PLL_SSC_DIG_DDSB4_reg_addr                                               "0xD8000590"
+#define SYS_PLL_SSC_DIG_DDSB4_reg                                                    0xD8000590
+#define set_SYS_PLL_SSC_DIG_DDSB4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB4_reg))
+#define SYS_PLL_SSC_DIG_DDSB4_inst_adr                                               "0x0064"
+#define SYS_PLL_SSC_DIG_DDSB4_inst                                                   0x0064
+#define SYS_PLL_SSC_DIG_DDSB4_GRAN_EST_DDSB_shift                                    (0)
+#define SYS_PLL_SSC_DIG_DDSB4_GRAN_EST_DDSB_mask                                     (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_DDSB4_GRAN_EST_DDSB(data)                                    (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB4_GRAN_EST_DDSB_src(data)                                ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB4_get_GRAN_EST_DDSB(data)                                ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB5                                                        0x98000594
+#define SYS_PLL_SSC_DIG_DDSB5_reg_addr                                               "0xD8000594"
+#define SYS_PLL_SSC_DIG_DDSB5_reg                                                    0xD8000594
+#define set_SYS_PLL_SSC_DIG_DDSB5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB5_reg))
+#define SYS_PLL_SSC_DIG_DDSB5_inst_adr                                               "0x0065"
+#define SYS_PLL_SSC_DIG_DDSB5_inst                                                   0x0065
+#define SYS_PLL_SSC_DIG_DDSB5_FCW_SSC_DEFAULT_DDSB_shift                             (0)
+#define SYS_PLL_SSC_DIG_DDSB5_FCW_SSC_DEFAULT_DDSB_mask                              (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_DDSB5_FCW_SSC_DEFAULT_DDSB(data)                             (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB5_FCW_SSC_DEFAULT_DDSB_src(data)                         ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB5_get_FCW_SSC_DEFAULT_DDSB(data)                         ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB_DBG1                                                    0x98000598
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_reg_addr                                           "0xD8000598"
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_reg                                                0xD8000598
+#define set_SYS_PLL_SSC_DIG_DDSB_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB_DBG1_reg))
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_inst_adr                                           "0x0066"
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_inst                                               0x0066
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_LOOP_PI_ISEL_DDSB_shift                            (14)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_LOOP_PI_ISEL_DDSB_mask                             (0x0001C000)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_LOOP_PI_ISEL_DDSB(data)                            (0x0001C000&((data)<<14))
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_LOOP_PI_ISEL_DDSB_src(data)                        ((0x0001C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_get_LOOP_PI_ISEL_DDSB(data)                        ((0x0001C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_PHSEL_DDSB_shift                                   (8)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_PHSEL_DDSB_mask                                    (0x00003F00)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_PHSEL_DDSB(data)                                   (0x00003F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_PHSEL_DDSB_src(data)                               ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_get_PHSEL_DDSB(data)                               ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_DIVN_DDSB_shift                                    (0)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_DIVN_DDSB_mask                                     (0x000000FF)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_DIVN_DDSB(data)                                    (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_DIVN_DDSB_src(data)                                ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB_DBG1_get_DIVN_DDSB(data)                                ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_DDSB_DBG2                                                    0x9800059C
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_reg_addr                                           "0xD800059C"
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_reg                                                0xD800059C
+#define set_SYS_PLL_SSC_DIG_DDSB_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_DDSB_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_DDSB_DBG2_reg))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_inst_adr                                           "0x0067"
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_inst                                               0x0067
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_load_FCW_DDSB_shift                                (21)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_load_FCW_DDSB_mask                                 (0x00200000)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_load_FCW_DDSB(data)                                (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_load_FCW_DDSB_src(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_get_load_FCW_DDSB(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_OC_DONE_DDSB_shift                                 (20)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_OC_DONE_DDSB_mask                                  (0x00100000)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_OC_DONE_DDSB(data)                                 (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_OC_DONE_DDSB_src(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_get_OC_DONE_DDSB(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FMOD_DDSB_shift                                    (19)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FMOD_DDSB_mask                                     (0x00080000)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FMOD_DDSB(data)                                    (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FMOD_DDSB_src(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_get_FMOD_DDSB(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_NCODE_DEBUG_DDSB_shift                             (11)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_NCODE_DEBUG_DDSB_mask                              (0x0007F800)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_NCODE_DEBUG_DDSB(data)                             (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_NCODE_DEBUG_DDSB_src(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_get_NCODE_DEBUG_DDSB(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FCODE_DEBUG_DDSB_shift                             (0)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FCODE_DEBUG_DDSB_mask                              (0x000007FF)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FCODE_DEBUG_DDSB(data)                             (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_FCODE_DEBUG_DDSB_src(data)                         ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_DDSB_DBG2_get_FCODE_DEBUG_DDSB(data)                         ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU0                                                         0x980005A0
+#define SYS_PLL_SSC_DIG_GPU0_reg_addr                                                "0xD80005A0"
+#define SYS_PLL_SSC_DIG_GPU0_reg                                                     0xD80005A0
+#define set_SYS_PLL_SSC_DIG_GPU0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU0_reg))
+#define SYS_PLL_SSC_DIG_GPU0_inst_adr                                                "0x0068"
+#define SYS_PLL_SSC_DIG_GPU0_inst                                                    0x0068
+#define SYS_PLL_SSC_DIG_GPU0_REG_CKSSC_INV_GPU_shift                                 (4)
+#define SYS_PLL_SSC_DIG_GPU0_REG_CKSSC_INV_GPU_mask                                  (0x00000010)
+#define SYS_PLL_SSC_DIG_GPU0_REG_CKSSC_INV_GPU(data)                                 (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_GPU0_REG_CKSSC_INV_GPU_src(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_GPU0_get_REG_CKSSC_INV_GPU(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_GPU0_REG_GRAN_AUTO_RST_GPU_shift                             (3)
+#define SYS_PLL_SSC_DIG_GPU0_REG_GRAN_AUTO_RST_GPU_mask                              (0x00000008)
+#define SYS_PLL_SSC_DIG_GPU0_REG_GRAN_AUTO_RST_GPU(data)                             (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_GPU0_REG_GRAN_AUTO_RST_GPU_src(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_GPU0_get_REG_GRAN_AUTO_RST_GPU(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_GPU0_RSTB_GPU_shift                                          (2)
+#define SYS_PLL_SSC_DIG_GPU0_RSTB_GPU_mask                                           (0x00000004)
+#define SYS_PLL_SSC_DIG_GPU0_RSTB_GPU(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_GPU0_RSTB_GPU_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_GPU0_get_RSTB_GPU(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_GPU0_EN_SSC_GPU_shift                                        (1)
+#define SYS_PLL_SSC_DIG_GPU0_EN_SSC_GPU_mask                                         (0x00000002)
+#define SYS_PLL_SSC_DIG_GPU0_EN_SSC_GPU(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_GPU0_EN_SSC_GPU_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_GPU0_get_EN_SSC_GPU(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_GPU0_OC_EN_GPU_shift                                         (0)
+#define SYS_PLL_SSC_DIG_GPU0_OC_EN_GPU_mask                                          (0x00000001)
+#define SYS_PLL_SSC_DIG_GPU0_OC_EN_GPU(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU0_OC_EN_GPU_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU0_get_OC_EN_GPU(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU1                                                         0x980005A4
+#define SYS_PLL_SSC_DIG_GPU1_reg_addr                                                "0xD80005A4"
+#define SYS_PLL_SSC_DIG_GPU1_reg                                                     0xD80005A4
+#define set_SYS_PLL_SSC_DIG_GPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU1_reg))
+#define SYS_PLL_SSC_DIG_GPU1_inst_adr                                                "0x0069"
+#define SYS_PLL_SSC_DIG_GPU1_inst                                                    0x0069
+#define SYS_PLL_SSC_DIG_GPU1_NCODE_T_GPU_shift                                       (11)
+#define SYS_PLL_SSC_DIG_GPU1_NCODE_T_GPU_mask                                        (0x0007F800)
+#define SYS_PLL_SSC_DIG_GPU1_NCODE_T_GPU(data)                                       (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_GPU1_NCODE_T_GPU_src(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU1_get_NCODE_T_GPU(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU1_FCODE_T_GPU_shift                                       (0)
+#define SYS_PLL_SSC_DIG_GPU1_FCODE_T_GPU_mask                                        (0x000007FF)
+#define SYS_PLL_SSC_DIG_GPU1_FCODE_T_GPU(data)                                       (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU1_FCODE_T_GPU_src(data)                                   ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU1_get_FCODE_T_GPU(data)                                   ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU2                                                         0x980005A8
+#define SYS_PLL_SSC_DIG_GPU2_reg_addr                                                "0xD80005A8"
+#define SYS_PLL_SSC_DIG_GPU2_reg                                                     0xD80005A8
+#define set_SYS_PLL_SSC_DIG_GPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU2_reg))
+#define SYS_PLL_SSC_DIG_GPU2_inst_adr                                                "0x006A"
+#define SYS_PLL_SSC_DIG_GPU2_inst                                                    0x006A
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_DIVN_shift                                   (27)
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_DIVN_mask                                    (0x08000000)
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_DIVN(data)                                   (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_DIVN_src(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_BYPASS_DIVN(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_STEP_SET_GPU_shift                               (17)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_STEP_SET_GPU_mask                                (0x07FE0000)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_STEP_SET_GPU(data)                               (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_STEP_SET_GPU_src(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_OC_STEP_SET_GPU(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SEL_OC_MODE_GPU_shift                               (15)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SEL_OC_MODE_GPU_mask                                (0x00018000)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SEL_OC_MODE_GPU(data)                               (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_GPU2_REG_SEL_OC_MODE_GPU_src(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_SEL_OC_MODE_GPU(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_GPU2_REG_HS_OC_STOP_DIFF_GPU_shift                           (13)
+#define SYS_PLL_SSC_DIG_GPU2_REG_HS_OC_STOP_DIFF_GPU_mask                            (0x00006000)
+#define SYS_PLL_SSC_DIG_GPU2_REG_HS_OC_STOP_DIFF_GPU(data)                           (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_GPU2_REG_HS_OC_STOP_DIFF_GPU_src(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_HS_OC_STOP_DIFF_GPU(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_DONE_DELAY_GPU_shift                             (7)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_DONE_DELAY_GPU_mask                              (0x00001F80)
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_DONE_DELAY_GPU(data)                             (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_GPU2_REG_OC_DONE_DELAY_GPU_src(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_OC_DONE_DELAY_GPU(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_PI_GPU_shift                                 (6)
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_PI_GPU_mask                                  (0x00000040)
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_PI_GPU(data)                                 (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_GPU2_REG_BYPASS_PI_GPU_src(data)                             ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_BYPASS_PI_GPU(data)                             ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SDM_ORDER_GPU_shift                                 (5)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SDM_ORDER_GPU_mask                                  (0x00000020)
+#define SYS_PLL_SSC_DIG_GPU2_REG_SDM_ORDER_GPU(data)                                 (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_GPU2_REG_SDM_ORDER_GPU_src(data)                             ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_SDM_ORDER_GPU(data)                             ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_GPU2_REG_PI_CUR_SEL_GPU_shift                                (2)
+#define SYS_PLL_SSC_DIG_GPU2_REG_PI_CUR_SEL_GPU_mask                                 (0x0000001C)
+#define SYS_PLL_SSC_DIG_GPU2_REG_PI_CUR_SEL_GPU(data)                                (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_GPU2_REG_PI_CUR_SEL_GPU_src(data)                            ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_PI_CUR_SEL_GPU(data)                            ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_GPU2_REG_EN_PI_DEBUG_GPU_shift                               (1)
+#define SYS_PLL_SSC_DIG_GPU2_REG_EN_PI_DEBUG_GPU_mask                                (0x00000002)
+#define SYS_PLL_SSC_DIG_GPU2_REG_EN_PI_DEBUG_GPU(data)                               (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_GPU2_REG_EN_PI_DEBUG_GPU_src(data)                           ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_GPU2_get_REG_EN_PI_DEBUG_GPU(data)                           ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_GPU3                                                         0x980005AC
+#define SYS_PLL_SSC_DIG_GPU3_reg_addr                                                "0xD80005AC"
+#define SYS_PLL_SSC_DIG_GPU3_reg                                                     0xD80005AC
+#define set_SYS_PLL_SSC_DIG_GPU3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU3_reg))
+#define SYS_PLL_SSC_DIG_GPU3_inst_adr                                                "0x006B"
+#define SYS_PLL_SSC_DIG_GPU3_inst                                                    0x006B
+#define SYS_PLL_SSC_DIG_GPU3_NCODE_SSC_GPU_shift                                     (11)
+#define SYS_PLL_SSC_DIG_GPU3_NCODE_SSC_GPU_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_GPU3_NCODE_SSC_GPU(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_GPU3_NCODE_SSC_GPU_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU3_get_NCODE_SSC_GPU(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU3_FCODE_SSC_GPU_shift                                     (0)
+#define SYS_PLL_SSC_DIG_GPU3_FCODE_SSC_GPU_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_GPU3_FCODE_SSC_GPU(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU3_FCODE_SSC_GPU_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU3_get_FCODE_SSC_GPU(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU4                                                         0x980005B0
+#define SYS_PLL_SSC_DIG_GPU4_reg_addr                                                "0xD80005B0"
+#define SYS_PLL_SSC_DIG_GPU4_reg                                                     0xD80005B0
+#define set_SYS_PLL_SSC_DIG_GPU4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU4_reg))
+#define SYS_PLL_SSC_DIG_GPU4_inst_adr                                                "0x006C"
+#define SYS_PLL_SSC_DIG_GPU4_inst                                                    0x006C
+#define SYS_PLL_SSC_DIG_GPU4_GRAN_EST_GPU_shift                                      (0)
+#define SYS_PLL_SSC_DIG_GPU4_GRAN_EST_GPU_mask                                       (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_GPU4_GRAN_EST_GPU(data)                                      (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU4_GRAN_EST_GPU_src(data)                                  ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU4_get_GRAN_EST_GPU(data)                                  ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU5                                                         0x980005B4
+#define SYS_PLL_SSC_DIG_GPU5_reg_addr                                                "0xD80005B4"
+#define SYS_PLL_SSC_DIG_GPU5_reg                                                     0xD80005B4
+#define set_SYS_PLL_SSC_DIG_GPU5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU5_reg))
+#define SYS_PLL_SSC_DIG_GPU5_inst_adr                                                "0x006D"
+#define SYS_PLL_SSC_DIG_GPU5_inst                                                    0x006D
+#define SYS_PLL_SSC_DIG_GPU5_FCW_SSC_DEFAULT_GPU_shift                               (0)
+#define SYS_PLL_SSC_DIG_GPU5_FCW_SSC_DEFAULT_GPU_mask                                (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_GPU5_FCW_SSC_DEFAULT_GPU(data)                               (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU5_FCW_SSC_DEFAULT_GPU_src(data)                           ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU5_get_FCW_SSC_DEFAULT_GPU(data)                           ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU_DBG1                                                     0x980005B8
+#define SYS_PLL_SSC_DIG_GPU_DBG1_reg_addr                                            "0xD80005B8"
+#define SYS_PLL_SSC_DIG_GPU_DBG1_reg                                                 0xD80005B8
+#define set_SYS_PLL_SSC_DIG_GPU_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU_DBG1_reg))
+#define SYS_PLL_SSC_DIG_GPU_DBG1_inst_adr                                            "0x006E"
+#define SYS_PLL_SSC_DIG_GPU_DBG1_inst                                                0x006E
+#define SYS_PLL_SSC_DIG_GPU_DBG1_LOOP_PI_ISEL_GPU_shift                              (13)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_LOOP_PI_ISEL_GPU_mask                               (0x0000E000)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_LOOP_PI_ISEL_GPU(data)                              (0x0000E000&((data)<<13))
+#define SYS_PLL_SSC_DIG_GPU_DBG1_LOOP_PI_ISEL_GPU_src(data)                          ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_get_LOOP_PI_ISEL_GPU(data)                          ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_PHSEL_GPU_shift                                     (8)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_PHSEL_GPU_mask                                      (0x00001F00)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_PHSEL_GPU(data)                                     (0x00001F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_GPU_DBG1_PHSEL_GPU_src(data)                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_get_PHSEL_GPU(data)                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_DIVN_GPU_shift                                      (0)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_DIVN_GPU_mask                                       (0x000000FF)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_DIVN_GPU(data)                                      (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU_DBG1_DIVN_GPU_src(data)                                  ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU_DBG1_get_DIVN_GPU(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_GPU_DBG2                                                     0x980005BC
+#define SYS_PLL_SSC_DIG_GPU_DBG2_reg_addr                                            "0xD80005BC"
+#define SYS_PLL_SSC_DIG_GPU_DBG2_reg                                                 0xD80005BC
+#define set_SYS_PLL_SSC_DIG_GPU_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_GPU_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_GPU_DBG2_reg))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_inst_adr                                            "0x006F"
+#define SYS_PLL_SSC_DIG_GPU_DBG2_inst                                                0x006F
+#define SYS_PLL_SSC_DIG_GPU_DBG2_load_FCW_GPU_shift                                  (21)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_load_FCW_GPU_mask                                   (0x00200000)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_load_FCW_GPU(data)                                  (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_load_FCW_GPU_src(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_get_load_FCW_GPU(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_OC_DONE_GPU_shift                                   (20)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_OC_DONE_GPU_mask                                    (0x00100000)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_OC_DONE_GPU(data)                                   (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_OC_DONE_GPU_src(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_get_OC_DONE_GPU(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FMOD_GPU_shift                                      (19)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FMOD_GPU_mask                                       (0x00080000)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FMOD_GPU(data)                                      (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FMOD_GPU_src(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_get_FMOD_GPU(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_NCODE_DEBUG_GPU_shift                               (11)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_NCODE_DEBUG_GPU_mask                                (0x0007F800)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_NCODE_DEBUG_GPU(data)                               (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_NCODE_DEBUG_GPU_src(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_get_NCODE_DEBUG_GPU(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FCODE_DEBUG_GPU_shift                               (0)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FCODE_DEBUG_GPU_mask                                (0x000007FF)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FCODE_DEBUG_GPU(data)                               (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_GPU_DBG2_FCODE_DEBUG_GPU_src(data)                           ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_GPU_DBG2_get_FCODE_DEBUG_GPU(data)                           ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU0                                                        0x980005C0
+#define SYS_PLL_SSC_DIG_ACPU0_reg_addr                                               "0xD80005C0"
+#define SYS_PLL_SSC_DIG_ACPU0_reg                                                    0xD80005C0
+#define set_SYS_PLL_SSC_DIG_ACPU0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU0_reg))
+#define SYS_PLL_SSC_DIG_ACPU0_inst_adr                                               "0x0070"
+#define SYS_PLL_SSC_DIG_ACPU0_inst                                                   0x0070
+#define SYS_PLL_SSC_DIG_ACPU0_REG_CKSSC_INV_ACPU_shift                               (4)
+#define SYS_PLL_SSC_DIG_ACPU0_REG_CKSSC_INV_ACPU_mask                                (0x00000010)
+#define SYS_PLL_SSC_DIG_ACPU0_REG_CKSSC_INV_ACPU(data)                               (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_ACPU0_REG_CKSSC_INV_ACPU_src(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_ACPU0_get_REG_CKSSC_INV_ACPU(data)                           ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_ACPU0_REG_GRAN_AUTO_RST_ACPU_shift                           (3)
+#define SYS_PLL_SSC_DIG_ACPU0_REG_GRAN_AUTO_RST_ACPU_mask                            (0x00000008)
+#define SYS_PLL_SSC_DIG_ACPU0_REG_GRAN_AUTO_RST_ACPU(data)                           (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_ACPU0_REG_GRAN_AUTO_RST_ACPU_src(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_ACPU0_get_REG_GRAN_AUTO_RST_ACPU(data)                       ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_ACPU0_RSTB_ACPU_shift                                        (2)
+#define SYS_PLL_SSC_DIG_ACPU0_RSTB_ACPU_mask                                         (0x00000004)
+#define SYS_PLL_SSC_DIG_ACPU0_RSTB_ACPU(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_ACPU0_RSTB_ACPU_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_ACPU0_get_RSTB_ACPU(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_ACPU0_EN_SSC_ACPU_shift                                      (1)
+#define SYS_PLL_SSC_DIG_ACPU0_EN_SSC_ACPU_mask                                       (0x00000002)
+#define SYS_PLL_SSC_DIG_ACPU0_EN_SSC_ACPU(data)                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_ACPU0_EN_SSC_ACPU_src(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_ACPU0_get_EN_SSC_ACPU(data)                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_ACPU0_OC_EN_ACPU_shift                                       (0)
+#define SYS_PLL_SSC_DIG_ACPU0_OC_EN_ACPU_mask                                        (0x00000001)
+#define SYS_PLL_SSC_DIG_ACPU0_OC_EN_ACPU(data)                                       (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU0_OC_EN_ACPU_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU0_get_OC_EN_ACPU(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU1                                                        0x980005C4
+#define SYS_PLL_SSC_DIG_ACPU1_reg_addr                                               "0xD80005C4"
+#define SYS_PLL_SSC_DIG_ACPU1_reg                                                    0xD80005C4
+#define set_SYS_PLL_SSC_DIG_ACPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU1_reg))
+#define SYS_PLL_SSC_DIG_ACPU1_inst_adr                                               "0x0071"
+#define SYS_PLL_SSC_DIG_ACPU1_inst                                                   0x0071
+#define SYS_PLL_SSC_DIG_ACPU1_NCODE_T_ACPU_shift                                     (11)
+#define SYS_PLL_SSC_DIG_ACPU1_NCODE_T_ACPU_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_ACPU1_NCODE_T_ACPU(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_ACPU1_NCODE_T_ACPU_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU1_get_NCODE_T_ACPU(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU1_FCODE_T_ACPU_shift                                     (0)
+#define SYS_PLL_SSC_DIG_ACPU1_FCODE_T_ACPU_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_ACPU1_FCODE_T_ACPU(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU1_FCODE_T_ACPU_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU1_get_FCODE_T_ACPU(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU2                                                        0x980005C8
+#define SYS_PLL_SSC_DIG_ACPU2_reg_addr                                               "0xD80005C8"
+#define SYS_PLL_SSC_DIG_ACPU2_reg                                                    0xD80005C8
+#define set_SYS_PLL_SSC_DIG_ACPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU2_reg))
+#define SYS_PLL_SSC_DIG_ACPU2_inst_adr                                               "0x0072"
+#define SYS_PLL_SSC_DIG_ACPU2_inst                                                   0x0072
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_DIVN_shift                                  (27)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_DIVN_mask                                   (0x08000000)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_DIVN(data)                                  (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_DIVN_src(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_BYPASS_DIVN(data)                              ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_STEP_SET_ACPU_shift                             (17)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_STEP_SET_ACPU_mask                              (0x07FE0000)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_STEP_SET_ACPU(data)                             (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_STEP_SET_ACPU_src(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_OC_STEP_SET_ACPU(data)                         ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SEL_OC_MODE_ACPU_shift                             (15)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SEL_OC_MODE_ACPU_mask                              (0x00018000)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SEL_OC_MODE_ACPU(data)                             (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SEL_OC_MODE_ACPU_src(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_SEL_OC_MODE_ACPU(data)                         ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_HS_OC_STOP_DIFF_ACPU_shift                         (13)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_HS_OC_STOP_DIFF_ACPU_mask                          (0x00006000)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_HS_OC_STOP_DIFF_ACPU(data)                         (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_HS_OC_STOP_DIFF_ACPU_src(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_HS_OC_STOP_DIFF_ACPU(data)                     ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_DONE_DELAY_ACPU_shift                           (7)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_DONE_DELAY_ACPU_mask                            (0x00001F80)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_DONE_DELAY_ACPU(data)                           (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_OC_DONE_DELAY_ACPU_src(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_OC_DONE_DELAY_ACPU(data)                       ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_PI_ACPU_shift                               (6)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_PI_ACPU_mask                                (0x00000040)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_PI_ACPU(data)                               (0x00000040&((data)<<6))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_BYPASS_PI_ACPU_src(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_BYPASS_PI_ACPU(data)                           ((0x00000040&(data))>>6)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SDM_ORDER_ACPU_shift                               (5)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SDM_ORDER_ACPU_mask                                (0x00000020)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SDM_ORDER_ACPU(data)                               (0x00000020&((data)<<5))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_SDM_ORDER_ACPU_src(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_SDM_ORDER_ACPU(data)                           ((0x00000020&(data))>>5)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_PI_CUR_SEL_ACPU_shift                              (2)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_PI_CUR_SEL_ACPU_mask                               (0x0000001C)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_PI_CUR_SEL_ACPU(data)                              (0x0000001C&((data)<<2))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_PI_CUR_SEL_ACPU_src(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_PI_CUR_SEL_ACPU(data)                          ((0x0000001C&(data))>>2)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_EN_PI_DEBUG_ACPU_shift                             (1)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_EN_PI_DEBUG_ACPU_mask                              (0x00000002)
+#define SYS_PLL_SSC_DIG_ACPU2_REG_EN_PI_DEBUG_ACPU(data)                             (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_ACPU2_REG_EN_PI_DEBUG_ACPU_src(data)                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_ACPU2_get_REG_EN_PI_DEBUG_ACPU(data)                         ((0x00000002&(data))>>1)
+
+
+#define SYS_PLL_SSC_DIG_ACPU3                                                        0x980005CC
+#define SYS_PLL_SSC_DIG_ACPU3_reg_addr                                               "0xD80005CC"
+#define SYS_PLL_SSC_DIG_ACPU3_reg                                                    0xD80005CC
+#define set_SYS_PLL_SSC_DIG_ACPU3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU3_reg))
+#define SYS_PLL_SSC_DIG_ACPU3_inst_adr                                               "0x0073"
+#define SYS_PLL_SSC_DIG_ACPU3_inst                                                   0x0073
+#define SYS_PLL_SSC_DIG_ACPU3_NCODE_SSC_ACPU_shift                                   (11)
+#define SYS_PLL_SSC_DIG_ACPU3_NCODE_SSC_ACPU_mask                                    (0x0007F800)
+#define SYS_PLL_SSC_DIG_ACPU3_NCODE_SSC_ACPU(data)                                   (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_ACPU3_NCODE_SSC_ACPU_src(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU3_get_NCODE_SSC_ACPU(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU3_FCODE_SSC_ACPU_shift                                   (0)
+#define SYS_PLL_SSC_DIG_ACPU3_FCODE_SSC_ACPU_mask                                    (0x000007FF)
+#define SYS_PLL_SSC_DIG_ACPU3_FCODE_SSC_ACPU(data)                                   (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU3_FCODE_SSC_ACPU_src(data)                               ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU3_get_FCODE_SSC_ACPU(data)                               ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU4                                                        0x980005D0
+#define SYS_PLL_SSC_DIG_ACPU4_reg_addr                                               "0xD80005D0"
+#define SYS_PLL_SSC_DIG_ACPU4_reg                                                    0xD80005D0
+#define set_SYS_PLL_SSC_DIG_ACPU4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU4_reg))
+#define SYS_PLL_SSC_DIG_ACPU4_inst_adr                                               "0x0074"
+#define SYS_PLL_SSC_DIG_ACPU4_inst                                                   0x0074
+#define SYS_PLL_SSC_DIG_ACPU4_GRAN_EST_ACPU_shift                                    (0)
+#define SYS_PLL_SSC_DIG_ACPU4_GRAN_EST_ACPU_mask                                     (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_ACPU4_GRAN_EST_ACPU(data)                                    (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU4_GRAN_EST_ACPU_src(data)                                ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU4_get_GRAN_EST_ACPU(data)                                ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU5                                                        0x980005D4
+#define SYS_PLL_SSC_DIG_ACPU5_reg_addr                                               "0xD80005D4"
+#define SYS_PLL_SSC_DIG_ACPU5_reg                                                    0xD80005D4
+#define set_SYS_PLL_SSC_DIG_ACPU5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU5_reg))
+#define SYS_PLL_SSC_DIG_ACPU5_inst_adr                                               "0x0075"
+#define SYS_PLL_SSC_DIG_ACPU5_inst                                                   0x0075
+#define SYS_PLL_SSC_DIG_ACPU5_FCW_SSC_DEFAULT_ACPU_shift                             (0)
+#define SYS_PLL_SSC_DIG_ACPU5_FCW_SSC_DEFAULT_ACPU_mask                              (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_ACPU5_FCW_SSC_DEFAULT_ACPU(data)                             (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU5_FCW_SSC_DEFAULT_ACPU_src(data)                         ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU5_get_FCW_SSC_DEFAULT_ACPU(data)                         ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU_DBG1                                                    0x980005D8
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_reg_addr                                           "0xD80005D8"
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_reg                                                0xD80005D8
+#define set_SYS_PLL_SSC_DIG_ACPU_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU_DBG1_reg))
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_inst_adr                                           "0x0076"
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_inst                                               0x0076
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_LOOP_PI_ISEL_ACPU_shift                            (13)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_LOOP_PI_ISEL_ACPU_mask                             (0x0000E000)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_LOOP_PI_ISEL_ACPU(data)                            (0x0000E000&((data)<<13))
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_LOOP_PI_ISEL_ACPU_src(data)                        ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_get_LOOP_PI_ISEL_ACPU(data)                        ((0x0000E000&(data))>>13)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_PHSEL_ACPU_shift                                   (8)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_PHSEL_ACPU_mask                                    (0x00001F00)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_PHSEL_ACPU(data)                                   (0x00001F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_PHSEL_ACPU_src(data)                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_get_PHSEL_ACPU(data)                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_DIVN_ACPU_shift                                    (0)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_DIVN_ACPU_mask                                     (0x000000FF)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_DIVN_ACPU(data)                                    (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_DIVN_ACPU_src(data)                                ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU_DBG1_get_DIVN_ACPU(data)                                ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_ACPU_DBG2                                                    0x980005DC
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_reg_addr                                           "0xD80005DC"
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_reg                                                0xD80005DC
+#define set_SYS_PLL_SSC_DIG_ACPU_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_ACPU_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_ACPU_DBG2_reg))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_inst_adr                                           "0x0077"
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_inst                                               0x0077
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_load_FCW_ACPU_shift                                (21)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_load_FCW_ACPU_mask                                 (0x00200000)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_load_FCW_ACPU(data)                                (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_load_FCW_ACPU_src(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_get_load_FCW_ACPU(data)                            ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_OC_DONE_ACPU_shift                                 (20)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_OC_DONE_ACPU_mask                                  (0x00100000)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_OC_DONE_ACPU(data)                                 (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_OC_DONE_ACPU_src(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_get_OC_DONE_ACPU(data)                             ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FMOD_ACPU_shift                                    (19)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FMOD_ACPU_mask                                     (0x00080000)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FMOD_ACPU(data)                                    (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FMOD_ACPU_src(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_get_FMOD_ACPU(data)                                ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_NCODE_DEBUG_ACPU_shift                             (11)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_NCODE_DEBUG_ACPU_mask                              (0x0007F800)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_NCODE_DEBUG_ACPU(data)                             (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_NCODE_DEBUG_ACPU_src(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_get_NCODE_DEBUG_ACPU(data)                         ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FCODE_DEBUG_ACPU_shift                             (0)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FCODE_DEBUG_ACPU_mask                              (0x000007FF)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FCODE_DEBUG_ACPU(data)                             (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_FCODE_DEBUG_ACPU_src(data)                         ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_ACPU_DBG2_get_FCODE_DEBUG_ACPU(data)                         ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP0                                                         0x980005E0
+#define SYS_PLL_SSC_DIG_EDP0_reg_addr                                                "0xD80005E0"
+#define SYS_PLL_SSC_DIG_EDP0_reg                                                     0xD80005E0
+#define set_SYS_PLL_SSC_DIG_EDP0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP0_reg))
+#define SYS_PLL_SSC_DIG_EDP0_inst_adr                                                "0x0078"
+#define SYS_PLL_SSC_DIG_EDP0_inst                                                    0x0078
+#define SYS_PLL_SSC_DIG_EDP0_REG_CKSSC_INV_EDP_shift                                 (4)
+#define SYS_PLL_SSC_DIG_EDP0_REG_CKSSC_INV_EDP_mask                                  (0x00000010)
+#define SYS_PLL_SSC_DIG_EDP0_REG_CKSSC_INV_EDP(data)                                 (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_EDP0_REG_CKSSC_INV_EDP_src(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_EDP0_get_REG_CKSSC_INV_EDP(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_EDP0_REG_GRAN_AUTO_RST_EDP_shift                             (3)
+#define SYS_PLL_SSC_DIG_EDP0_REG_GRAN_AUTO_RST_EDP_mask                              (0x00000008)
+#define SYS_PLL_SSC_DIG_EDP0_REG_GRAN_AUTO_RST_EDP(data)                             (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_EDP0_REG_GRAN_AUTO_RST_EDP_src(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_EDP0_get_REG_GRAN_AUTO_RST_EDP(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_EDP0_RSTB_EDP_shift                                          (2)
+#define SYS_PLL_SSC_DIG_EDP0_RSTB_EDP_mask                                           (0x00000004)
+#define SYS_PLL_SSC_DIG_EDP0_RSTB_EDP(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_EDP0_RSTB_EDP_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_EDP0_get_RSTB_EDP(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_EDP0_EN_SSC_EDP_shift                                        (1)
+#define SYS_PLL_SSC_DIG_EDP0_EN_SSC_EDP_mask                                         (0x00000002)
+#define SYS_PLL_SSC_DIG_EDP0_EN_SSC_EDP(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_EDP0_EN_SSC_EDP_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_EDP0_get_EN_SSC_EDP(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_EDP0_OC_EN_EDP_shift                                         (0)
+#define SYS_PLL_SSC_DIG_EDP0_OC_EN_EDP_mask                                          (0x00000001)
+#define SYS_PLL_SSC_DIG_EDP0_OC_EN_EDP(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP0_OC_EN_EDP_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP0_get_OC_EN_EDP(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP1                                                         0x980005E4
+#define SYS_PLL_SSC_DIG_EDP1_reg_addr                                                "0xD80005E4"
+#define SYS_PLL_SSC_DIG_EDP1_reg                                                     0xD80005E4
+#define set_SYS_PLL_SSC_DIG_EDP1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP1_reg))
+#define SYS_PLL_SSC_DIG_EDP1_inst_adr                                                "0x0079"
+#define SYS_PLL_SSC_DIG_EDP1_inst                                                    0x0079
+#define SYS_PLL_SSC_DIG_EDP1_NCODE_T_EDP_shift                                       (11)
+#define SYS_PLL_SSC_DIG_EDP1_NCODE_T_EDP_mask                                        (0x0007F800)
+#define SYS_PLL_SSC_DIG_EDP1_NCODE_T_EDP(data)                                       (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_EDP1_NCODE_T_EDP_src(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP1_get_NCODE_T_EDP(data)                                   ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP1_FCODE_T_EDP_shift                                       (0)
+#define SYS_PLL_SSC_DIG_EDP1_FCODE_T_EDP_mask                                        (0x000007FF)
+#define SYS_PLL_SSC_DIG_EDP1_FCODE_T_EDP(data)                                       (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP1_FCODE_T_EDP_src(data)                                   ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP1_get_FCODE_T_EDP(data)                                   ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP2                                                         0x980005E8
+#define SYS_PLL_SSC_DIG_EDP2_reg_addr                                                "0xD80005E8"
+#define SYS_PLL_SSC_DIG_EDP2_reg                                                     0xD80005E8
+#define set_SYS_PLL_SSC_DIG_EDP2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP2_reg))
+#define SYS_PLL_SSC_DIG_EDP2_inst_adr                                                "0x007A"
+#define SYS_PLL_SSC_DIG_EDP2_inst                                                    0x007A
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_DIVN_shift                                   (27)
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_DIVN_mask                                    (0x08000000)
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_DIVN(data)                                   (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_DIVN_src(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_BYPASS_DIVN(data)                               ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_STEP_SET_EDP_shift                               (17)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_STEP_SET_EDP_mask                                (0x07FE0000)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_STEP_SET_EDP(data)                               (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_STEP_SET_EDP_src(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_OC_STEP_SET_EDP(data)                           ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SEL_OC_MODE_EDP_shift                               (15)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SEL_OC_MODE_EDP_mask                                (0x00018000)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SEL_OC_MODE_EDP(data)                               (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_EDP2_REG_SEL_OC_MODE_EDP_src(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_SEL_OC_MODE_EDP(data)                           ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_EDP2_REG_HS_OC_STOP_DIFF_EDP_shift                           (13)
+#define SYS_PLL_SSC_DIG_EDP2_REG_HS_OC_STOP_DIFF_EDP_mask                            (0x00006000)
+#define SYS_PLL_SSC_DIG_EDP2_REG_HS_OC_STOP_DIFF_EDP(data)                           (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_EDP2_REG_HS_OC_STOP_DIFF_EDP_src(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_HS_OC_STOP_DIFF_EDP(data)                       ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_DONE_DELAY_EDP_shift                             (7)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_DONE_DELAY_EDP_mask                              (0x00001F80)
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_DONE_DELAY_EDP(data)                             (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_EDP2_REG_OC_DONE_DELAY_EDP_src(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_OC_DONE_DELAY_EDP(data)                         ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_EDP2_REG_PI_CUR_SEL_EDP_shift                                (5)
+#define SYS_PLL_SSC_DIG_EDP2_REG_PI_CUR_SEL_EDP_mask                                 (0x00000060)
+#define SYS_PLL_SSC_DIG_EDP2_REG_PI_CUR_SEL_EDP(data)                                (0x00000060&((data)<<5))
+#define SYS_PLL_SSC_DIG_EDP2_REG_PI_CUR_SEL_EDP_src(data)                            ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_PI_CUR_SEL_EDP(data)                            ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_PI_EDP_shift                                 (4)
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_PI_EDP_mask                                  (0x00000010)
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_PI_EDP(data)                                 (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_EDP2_REG_BYPASS_PI_EDP_src(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_BYPASS_PI_EDP(data)                             ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SDM_ORDER_EDP_shift                                 (3)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SDM_ORDER_EDP_mask                                  (0x00000008)
+#define SYS_PLL_SSC_DIG_EDP2_REG_SDM_ORDER_EDP(data)                                 (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_EDP2_REG_SDM_ORDER_EDP_src(data)                             ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_SDM_ORDER_EDP(data)                             ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_EDP2_REG_EN_PI_DEBUG_EDP_shift                               (2)
+#define SYS_PLL_SSC_DIG_EDP2_REG_EN_PI_DEBUG_EDP_mask                                (0x00000004)
+#define SYS_PLL_SSC_DIG_EDP2_REG_EN_PI_DEBUG_EDP(data)                               (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_EDP2_REG_EN_PI_DEBUG_EDP_src(data)                           ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_EDP2_get_REG_EN_PI_DEBUG_EDP(data)                           ((0x00000004&(data))>>2)
+
+
+#define SYS_PLL_SSC_DIG_EDP3                                                         0x980005EC
+#define SYS_PLL_SSC_DIG_EDP3_reg_addr                                                "0xD80005EC"
+#define SYS_PLL_SSC_DIG_EDP3_reg                                                     0xD80005EC
+#define set_SYS_PLL_SSC_DIG_EDP3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP3_reg))
+#define SYS_PLL_SSC_DIG_EDP3_inst_adr                                                "0x007B"
+#define SYS_PLL_SSC_DIG_EDP3_inst                                                    0x007B
+#define SYS_PLL_SSC_DIG_EDP3_NCODE_SSC_EDP_shift                                     (11)
+#define SYS_PLL_SSC_DIG_EDP3_NCODE_SSC_EDP_mask                                      (0x0007F800)
+#define SYS_PLL_SSC_DIG_EDP3_NCODE_SSC_EDP(data)                                     (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_EDP3_NCODE_SSC_EDP_src(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP3_get_NCODE_SSC_EDP(data)                                 ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP3_FCODE_SSC_EDP_shift                                     (0)
+#define SYS_PLL_SSC_DIG_EDP3_FCODE_SSC_EDP_mask                                      (0x000007FF)
+#define SYS_PLL_SSC_DIG_EDP3_FCODE_SSC_EDP(data)                                     (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP3_FCODE_SSC_EDP_src(data)                                 ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP3_get_FCODE_SSC_EDP(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP4                                                         0x980005F0
+#define SYS_PLL_SSC_DIG_EDP4_reg_addr                                                "0xD80005F0"
+#define SYS_PLL_SSC_DIG_EDP4_reg                                                     0xD80005F0
+#define set_SYS_PLL_SSC_DIG_EDP4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP4_reg))
+#define SYS_PLL_SSC_DIG_EDP4_inst_adr                                                "0x007C"
+#define SYS_PLL_SSC_DIG_EDP4_inst                                                    0x007C
+#define SYS_PLL_SSC_DIG_EDP4_GRAN_EST_EDP_shift                                      (0)
+#define SYS_PLL_SSC_DIG_EDP4_GRAN_EST_EDP_mask                                       (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_EDP4_GRAN_EST_EDP(data)                                      (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP4_GRAN_EST_EDP_src(data)                                  ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP4_get_GRAN_EST_EDP(data)                                  ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP5                                                         0x980005F4
+#define SYS_PLL_SSC_DIG_EDP5_reg_addr                                                "0xD80005F4"
+#define SYS_PLL_SSC_DIG_EDP5_reg                                                     0xD80005F4
+#define set_SYS_PLL_SSC_DIG_EDP5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP5_reg))
+#define SYS_PLL_SSC_DIG_EDP5_inst_adr                                                "0x007D"
+#define SYS_PLL_SSC_DIG_EDP5_inst                                                    0x007D
+#define SYS_PLL_SSC_DIG_EDP5_FCW_SSC_DEFAULT_EDP_shift                               (0)
+#define SYS_PLL_SSC_DIG_EDP5_FCW_SSC_DEFAULT_EDP_mask                                (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_EDP5_FCW_SSC_DEFAULT_EDP(data)                               (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP5_FCW_SSC_DEFAULT_EDP_src(data)                           ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP5_get_FCW_SSC_DEFAULT_EDP(data)                           ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP_DBG1                                                     0x980005F8
+#define SYS_PLL_SSC_DIG_EDP_DBG1_reg_addr                                            "0xD80005F8"
+#define SYS_PLL_SSC_DIG_EDP_DBG1_reg                                                 0xD80005F8
+#define set_SYS_PLL_SSC_DIG_EDP_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP_DBG1_reg))
+#define SYS_PLL_SSC_DIG_EDP_DBG1_inst_adr                                            "0x007E"
+#define SYS_PLL_SSC_DIG_EDP_DBG1_inst                                                0x007E
+#define SYS_PLL_SSC_DIG_EDP_DBG1_LOOP_PI_ISEL_EDP_shift                              (14)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_LOOP_PI_ISEL_EDP_mask                               (0x0000C000)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_LOOP_PI_ISEL_EDP(data)                              (0x0000C000&((data)<<14))
+#define SYS_PLL_SSC_DIG_EDP_DBG1_LOOP_PI_ISEL_EDP_src(data)                          ((0x0000C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_get_LOOP_PI_ISEL_EDP(data)                          ((0x0000C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_PHSEL_EDP_shift                                     (8)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_PHSEL_EDP_mask                                      (0x00003F00)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_PHSEL_EDP(data)                                     (0x00003F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_EDP_DBG1_PHSEL_EDP_src(data)                                 ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_get_PHSEL_EDP(data)                                 ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_DIVN_EDP_shift                                      (0)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_DIVN_EDP_mask                                       (0x000000FF)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_DIVN_EDP(data)                                      (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP_DBG1_DIVN_EDP_src(data)                                  ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP_DBG1_get_DIVN_EDP(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_EDP_DBG2                                                     0x980005FC
+#define SYS_PLL_SSC_DIG_EDP_DBG2_reg_addr                                            "0xD80005FC"
+#define SYS_PLL_SSC_DIG_EDP_DBG2_reg                                                 0xD80005FC
+#define set_SYS_PLL_SSC_DIG_EDP_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_EDP_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_EDP_DBG2_reg))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_inst_adr                                            "0x007F"
+#define SYS_PLL_SSC_DIG_EDP_DBG2_inst                                                0x007F
+#define SYS_PLL_SSC_DIG_EDP_DBG2_load_FCW_EDP_shift                                  (21)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_load_FCW_EDP_mask                                   (0x00200000)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_load_FCW_EDP(data)                                  (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_load_FCW_EDP_src(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_get_load_FCW_EDP(data)                              ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_OC_DONE_EDP_shift                                   (20)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_OC_DONE_EDP_mask                                    (0x00100000)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_OC_DONE_EDP(data)                                   (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_OC_DONE_EDP_src(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_get_OC_DONE_EDP(data)                               ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FMOD_EDP_shift                                      (19)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FMOD_EDP_mask                                       (0x00080000)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FMOD_EDP(data)                                      (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FMOD_EDP_src(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_get_FMOD_EDP(data)                                  ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_NCODE_DEBUG_EDP_shift                               (11)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_NCODE_DEBUG_EDP_mask                                (0x0007F800)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_NCODE_DEBUG_EDP(data)                               (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_NCODE_DEBUG_EDP_src(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_get_NCODE_DEBUG_EDP(data)                           ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FCODE_DEBUG_EDP_shift                               (0)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FCODE_DEBUG_EDP_mask                                (0x000007FF)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FCODE_DEBUG_EDP(data)                               (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_EDP_DBG2_FCODE_DEBUG_EDP_src(data)                           ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_EDP_DBG2_get_FCODE_DEBUG_EDP(data)                           ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL0                                                       0x98000600
+#define SYS_PLL_SSC_DIG_PIXEL0_reg_addr                                              "0xD8000600"
+#define SYS_PLL_SSC_DIG_PIXEL0_reg                                                   0xD8000600
+#define set_SYS_PLL_SSC_DIG_PIXEL0_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL0_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL0_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL0_reg))
+#define SYS_PLL_SSC_DIG_PIXEL0_inst_adr                                              "0x0080"
+#define SYS_PLL_SSC_DIG_PIXEL0_inst                                                  0x0080
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_CKSSC_INV_PIXEL_shift                             (4)
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_CKSSC_INV_PIXEL_mask                              (0x00000010)
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_CKSSC_INV_PIXEL(data)                             (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_CKSSC_INV_PIXEL_src(data)                         ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_PIXEL0_get_REG_CKSSC_INV_PIXEL(data)                         ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_GRAN_AUTO_RST_PIXEL_shift                         (3)
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_GRAN_AUTO_RST_PIXEL_mask                          (0x00000008)
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_GRAN_AUTO_RST_PIXEL(data)                         (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_PIXEL0_REG_GRAN_AUTO_RST_PIXEL_src(data)                     ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_PIXEL0_get_REG_GRAN_AUTO_RST_PIXEL(data)                     ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_PIXEL0_RSTB_PIXEL_shift                                      (2)
+#define SYS_PLL_SSC_DIG_PIXEL0_RSTB_PIXEL_mask                                       (0x00000004)
+#define SYS_PLL_SSC_DIG_PIXEL0_RSTB_PIXEL(data)                                      (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_PIXEL0_RSTB_PIXEL_src(data)                                  ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_PIXEL0_get_RSTB_PIXEL(data)                                  ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_PIXEL0_EN_SSC_PIXEL_shift                                    (1)
+#define SYS_PLL_SSC_DIG_PIXEL0_EN_SSC_PIXEL_mask                                     (0x00000002)
+#define SYS_PLL_SSC_DIG_PIXEL0_EN_SSC_PIXEL(data)                                    (0x00000002&((data)<<1))
+#define SYS_PLL_SSC_DIG_PIXEL0_EN_SSC_PIXEL_src(data)                                ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_PIXEL0_get_EN_SSC_PIXEL(data)                                ((0x00000002&(data))>>1)
+#define SYS_PLL_SSC_DIG_PIXEL0_OC_EN_PIXEL_shift                                     (0)
+#define SYS_PLL_SSC_DIG_PIXEL0_OC_EN_PIXEL_mask                                      (0x00000001)
+#define SYS_PLL_SSC_DIG_PIXEL0_OC_EN_PIXEL(data)                                     (0x00000001&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL0_OC_EN_PIXEL_src(data)                                 ((0x00000001&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL0_get_OC_EN_PIXEL(data)                                 ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL1                                                       0x98000604
+#define SYS_PLL_SSC_DIG_PIXEL1_reg_addr                                              "0xD8000604"
+#define SYS_PLL_SSC_DIG_PIXEL1_reg                                                   0xD8000604
+#define set_SYS_PLL_SSC_DIG_PIXEL1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL1_reg))
+#define SYS_PLL_SSC_DIG_PIXEL1_inst_adr                                              "0x0081"
+#define SYS_PLL_SSC_DIG_PIXEL1_inst                                                  0x0081
+#define SYS_PLL_SSC_DIG_PIXEL1_NCODE_T_PIXEL_shift                                   (11)
+#define SYS_PLL_SSC_DIG_PIXEL1_NCODE_T_PIXEL_mask                                    (0x0007F800)
+#define SYS_PLL_SSC_DIG_PIXEL1_NCODE_T_PIXEL(data)                                   (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_PIXEL1_NCODE_T_PIXEL_src(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL1_get_NCODE_T_PIXEL(data)                               ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL1_FCODE_T_PIXEL_shift                                   (0)
+#define SYS_PLL_SSC_DIG_PIXEL1_FCODE_T_PIXEL_mask                                    (0x000007FF)
+#define SYS_PLL_SSC_DIG_PIXEL1_FCODE_T_PIXEL(data)                                   (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL1_FCODE_T_PIXEL_src(data)                               ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL1_get_FCODE_T_PIXEL(data)                               ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL2                                                       0x98000608
+#define SYS_PLL_SSC_DIG_PIXEL2_reg_addr                                              "0xD8000608"
+#define SYS_PLL_SSC_DIG_PIXEL2_reg                                                   0xD8000608
+#define set_SYS_PLL_SSC_DIG_PIXEL2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL2_reg))
+#define SYS_PLL_SSC_DIG_PIXEL2_inst_adr                                              "0x0082"
+#define SYS_PLL_SSC_DIG_PIXEL2_inst                                                  0x0082
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_DIVN_shift                                 (27)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_DIVN_mask                                  (0x08000000)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_DIVN(data)                                 (0x08000000&((data)<<27))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_DIVN_src(data)                             ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_BYPASS_DIVN(data)                             ((0x08000000&(data))>>27)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_STEP_SET_PIXEL_shift                           (17)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_STEP_SET_PIXEL_mask                            (0x07FE0000)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_STEP_SET_PIXEL(data)                           (0x07FE0000&((data)<<17))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_STEP_SET_PIXEL_src(data)                       ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_OC_STEP_SET_PIXEL(data)                       ((0x07FE0000&(data))>>17)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SEL_OC_MODE_PIXEL_shift                           (15)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SEL_OC_MODE_PIXEL_mask                            (0x00018000)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SEL_OC_MODE_PIXEL(data)                           (0x00018000&((data)<<15))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SEL_OC_MODE_PIXEL_src(data)                       ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_SEL_OC_MODE_PIXEL(data)                       ((0x00018000&(data))>>15)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_HS_OC_STOP_DIFF_PIXEL_shift                       (13)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_HS_OC_STOP_DIFF_PIXEL_mask                        (0x00006000)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_HS_OC_STOP_DIFF_PIXEL(data)                       (0x00006000&((data)<<13))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_HS_OC_STOP_DIFF_PIXEL_src(data)                   ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_HS_OC_STOP_DIFF_PIXEL(data)                   ((0x00006000&(data))>>13)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_DONE_DELAY_PIXEL_shift                         (7)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_DONE_DELAY_PIXEL_mask                          (0x00001F80)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_DONE_DELAY_PIXEL(data)                         (0x00001F80&((data)<<7))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_OC_DONE_DELAY_PIXEL_src(data)                     ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_OC_DONE_DELAY_PIXEL(data)                     ((0x00001F80&(data))>>7)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_PI_CUR_SEL_PIXEL_shift                            (5)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_PI_CUR_SEL_PIXEL_mask                             (0x00000060)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_PI_CUR_SEL_PIXEL(data)                            (0x00000060&((data)<<5))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_PI_CUR_SEL_PIXEL_src(data)                        ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_PI_CUR_SEL_PIXEL(data)                        ((0x00000060&(data))>>5)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_PI_PIXEL_shift                             (4)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_PI_PIXEL_mask                              (0x00000010)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_PI_PIXEL(data)                             (0x00000010&((data)<<4))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_BYPASS_PI_PIXEL_src(data)                         ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_BYPASS_PI_PIXEL(data)                         ((0x00000010&(data))>>4)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SDM_ORDER_PIXEL_shift                             (3)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SDM_ORDER_PIXEL_mask                              (0x00000008)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SDM_ORDER_PIXEL(data)                             (0x00000008&((data)<<3))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_SDM_ORDER_PIXEL_src(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_SDM_ORDER_PIXEL(data)                         ((0x00000008&(data))>>3)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_EN_PI_DEBUG_PIXEL_shift                           (2)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_EN_PI_DEBUG_PIXEL_mask                            (0x00000004)
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_EN_PI_DEBUG_PIXEL(data)                           (0x00000004&((data)<<2))
+#define SYS_PLL_SSC_DIG_PIXEL2_REG_EN_PI_DEBUG_PIXEL_src(data)                       ((0x00000004&(data))>>2)
+#define SYS_PLL_SSC_DIG_PIXEL2_get_REG_EN_PI_DEBUG_PIXEL(data)                       ((0x00000004&(data))>>2)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL3                                                       0x9800060C
+#define SYS_PLL_SSC_DIG_PIXEL3_reg_addr                                              "0xD800060C"
+#define SYS_PLL_SSC_DIG_PIXEL3_reg                                                   0xD800060C
+#define set_SYS_PLL_SSC_DIG_PIXEL3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL3_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL3_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL3_reg))
+#define SYS_PLL_SSC_DIG_PIXEL3_inst_adr                                              "0x0083"
+#define SYS_PLL_SSC_DIG_PIXEL3_inst                                                  0x0083
+#define SYS_PLL_SSC_DIG_PIXEL3_NCODE_SSC_PIXEL_shift                                 (11)
+#define SYS_PLL_SSC_DIG_PIXEL3_NCODE_SSC_PIXEL_mask                                  (0x0007F800)
+#define SYS_PLL_SSC_DIG_PIXEL3_NCODE_SSC_PIXEL(data)                                 (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_PIXEL3_NCODE_SSC_PIXEL_src(data)                             ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL3_get_NCODE_SSC_PIXEL(data)                             ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL3_FCODE_SSC_PIXEL_shift                                 (0)
+#define SYS_PLL_SSC_DIG_PIXEL3_FCODE_SSC_PIXEL_mask                                  (0x000007FF)
+#define SYS_PLL_SSC_DIG_PIXEL3_FCODE_SSC_PIXEL(data)                                 (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL3_FCODE_SSC_PIXEL_src(data)                             ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL3_get_FCODE_SSC_PIXEL(data)                             ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL4                                                       0x98000610
+#define SYS_PLL_SSC_DIG_PIXEL4_reg_addr                                              "0xD8000610"
+#define SYS_PLL_SSC_DIG_PIXEL4_reg                                                   0xD8000610
+#define set_SYS_PLL_SSC_DIG_PIXEL4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL4_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL4_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL4_reg))
+#define SYS_PLL_SSC_DIG_PIXEL4_inst_adr                                              "0x0084"
+#define SYS_PLL_SSC_DIG_PIXEL4_inst                                                  0x0084
+#define SYS_PLL_SSC_DIG_PIXEL4_GRAN_EST_PIXEL_shift                                  (0)
+#define SYS_PLL_SSC_DIG_PIXEL4_GRAN_EST_PIXEL_mask                                   (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_PIXEL4_GRAN_EST_PIXEL(data)                                  (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL4_GRAN_EST_PIXEL_src(data)                              ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL4_get_GRAN_EST_PIXEL(data)                              ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL5                                                       0x98000614
+#define SYS_PLL_SSC_DIG_PIXEL5_reg_addr                                              "0xD8000614"
+#define SYS_PLL_SSC_DIG_PIXEL5_reg                                                   0xD8000614
+#define set_SYS_PLL_SSC_DIG_PIXEL5_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL5_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL5_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL5_reg))
+#define SYS_PLL_SSC_DIG_PIXEL5_inst_adr                                              "0x0085"
+#define SYS_PLL_SSC_DIG_PIXEL5_inst                                                  0x0085
+#define SYS_PLL_SSC_DIG_PIXEL5_FCW_SSC_DEFAULT_PIXEL_shift                           (0)
+#define SYS_PLL_SSC_DIG_PIXEL5_FCW_SSC_DEFAULT_PIXEL_mask                            (0x0007FFFF)
+#define SYS_PLL_SSC_DIG_PIXEL5_FCW_SSC_DEFAULT_PIXEL(data)                           (0x0007FFFF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL5_FCW_SSC_DEFAULT_PIXEL_src(data)                       ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL5_get_FCW_SSC_DEFAULT_PIXEL(data)                       ((0x0007FFFF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1                                                   0x98000618
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_reg_addr                                          "0xD8000618"
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_reg                                               0xD8000618
+#define set_SYS_PLL_SSC_DIG_PIXEL_DBG1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL_DBG1_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL_DBG1_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL_DBG1_reg))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_inst_adr                                          "0x0086"
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_inst                                              0x0086
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_LOOP_PI_ISEL_PIXEL_shift                          (14)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_LOOP_PI_ISEL_PIXEL_mask                           (0x0000C000)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_LOOP_PI_ISEL_PIXEL(data)                          (0x0000C000&((data)<<14))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_LOOP_PI_ISEL_PIXEL_src(data)                      ((0x0000C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_get_LOOP_PI_ISEL_PIXEL(data)                      ((0x0000C000&(data))>>14)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_PHSEL_PIXEL_shift                                 (8)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_PHSEL_PIXEL_mask                                  (0x00003F00)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_PHSEL_PIXEL(data)                                 (0x00003F00&((data)<<8))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_PHSEL_PIXEL_src(data)                             ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_get_PHSEL_PIXEL(data)                             ((0x00003F00&(data))>>8)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_DIVN_PIXEL_shift                                  (0)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_DIVN_PIXEL_mask                                   (0x000000FF)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_DIVN_PIXEL(data)                                  (0x000000FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_DIVN_PIXEL_src(data)                              ((0x000000FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG1_get_DIVN_PIXEL(data)                              ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2                                                   0x9800061C
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_reg_addr                                          "0xD800061C"
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_reg                                               0xD800061C
+#define set_SYS_PLL_SSC_DIG_PIXEL_DBG2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL_DBG2_reg)=data)
+#define get_SYS_PLL_SSC_DIG_PIXEL_DBG2_reg   (*((volatile unsigned int*) SYS_PLL_SSC_DIG_PIXEL_DBG2_reg))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_inst_adr                                          "0x0087"
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_inst                                              0x0087
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_load_FCW_PIXEL_shift                              (21)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_load_FCW_PIXEL_mask                               (0x00200000)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_load_FCW_PIXEL(data)                              (0x00200000&((data)<<21))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_load_FCW_PIXEL_src(data)                          ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_get_load_FCW_PIXEL(data)                          ((0x00200000&(data))>>21)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_OC_DONE_PIXEL_shift                               (20)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_OC_DONE_PIXEL_mask                                (0x00100000)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_OC_DONE_PIXEL(data)                               (0x00100000&((data)<<20))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_OC_DONE_PIXEL_src(data)                           ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_get_OC_DONE_PIXEL(data)                           ((0x00100000&(data))>>20)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FMOD_PIXEL_shift                                  (19)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FMOD_PIXEL_mask                                   (0x00080000)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FMOD_PIXEL(data)                                  (0x00080000&((data)<<19))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FMOD_PIXEL_src(data)                              ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_get_FMOD_PIXEL(data)                              ((0x00080000&(data))>>19)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_NCODE_DEBUG_PIXEL_shift                           (11)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_NCODE_DEBUG_PIXEL_mask                            (0x0007F800)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_NCODE_DEBUG_PIXEL(data)                           (0x0007F800&((data)<<11))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_NCODE_DEBUG_PIXEL_src(data)                       ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_get_NCODE_DEBUG_PIXEL(data)                       ((0x0007F800&(data))>>11)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FCODE_DEBUG_PIXEL_shift                           (0)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FCODE_DEBUG_PIXEL_mask                            (0x000007FF)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FCODE_DEBUG_PIXEL(data)                           (0x000007FF&((data)<<0))
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_FCODE_DEBUG_PIXEL_src(data)                       ((0x000007FF&(data))>>0)
+#define SYS_PLL_SSC_DIG_PIXEL_DBG2_get_FCODE_DEBUG_PIXEL(data)                       ((0x000007FF&(data))>>0)
+
+
+#define SYS_PLL_HDMI_SD6                                                             0x98000620
+#define SYS_PLL_HDMI_SD6_reg_addr                                                    "0xD8000620"
+#define SYS_PLL_HDMI_SD6_reg                                                         0xD8000620
+#define set_SYS_PLL_HDMI_SD6_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_SD6_reg)=data)
+#define get_SYS_PLL_HDMI_SD6_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_SD6_reg))
+#define SYS_PLL_HDMI_SD6_inst_adr                                                    "0x0088"
+#define SYS_PLL_HDMI_SD6_inst                                                        0x0088
+#define SYS_PLL_HDMI_SD6_REG_BYPASS_DIVN_shift                                       (19)
+#define SYS_PLL_HDMI_SD6_REG_BYPASS_DIVN_mask                                        (0x00080000)
+#define SYS_PLL_HDMI_SD6_REG_BYPASS_DIVN(data)                                       (0x00080000&((data)<<19))
+#define SYS_PLL_HDMI_SD6_REG_BYPASS_DIVN_src(data)                                   ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD6_get_REG_BYPASS_DIVN(data)                                   ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI_SD6_FCW_SSC_DEFAULT_HDMITX_shift                                (0)
+#define SYS_PLL_HDMI_SD6_FCW_SSC_DEFAULT_HDMITX_mask                                 (0x0007FFFF)
+#define SYS_PLL_HDMI_SD6_FCW_SSC_DEFAULT_HDMITX(data)                                (0x0007FFFF&((data)<<0))
+#define SYS_PLL_HDMI_SD6_FCW_SSC_DEFAULT_HDMITX_src(data)                            ((0x0007FFFF&(data))>>0)
+#define SYS_PLL_HDMI_SD6_get_FCW_SSC_DEFAULT_HDMITX(data)                            ((0x0007FFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/iso_reg.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/iso_reg.h
new file mode 100644
index 00000000..3603f5d
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/iso_reg.h
@@ -0,0 +1,11810 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+/**************************************************************
+// Spec Version                  : 0.1.4
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/7/3 10:28:8
+***************************************************************/
+
+
+#ifndef _ISO_REG_H_INCLUDED_
+#define _ISO_REG_H_INCLUDED_
+#ifdef  _ISO_USE_STRUCT
+typedef struct
+{
+unsigned int     i2c1_req_int:1;
+unsigned int     porb_av_cen_int:1;
+unsigned int     porb_dv_cen_int:1;
+unsigned int     reserved_0:4;
+unsigned int     usb_int:1;
+unsigned int     etn_int:1;
+unsigned int     cbus_int:1;
+unsigned int     iso_misc_int:1;
+unsigned int     gpioda_int:1;
+unsigned int     gpioa_int:1;
+unsigned int     reserved_1:5;
+unsigned int     rtc_alarm_int:1;
+unsigned int     rtc_hsec_int:1;
+unsigned int     i2c1_int:1;
+unsigned int     reserved_2:1;
+unsigned int     tc4_int:1;
+unsigned int     i2c0_int:1;
+unsigned int     wdog_nmi_int:1;
+unsigned int     reserved_3:1;
+unsigned int     irda_int:1;
+unsigned int     reserved_4:2;
+unsigned int     ur0_int:1;
+unsigned int     tc3_int:1;
+unsigned int     write_data:1;
+}ISO_ISR;
+
+typedef struct
+{
+unsigned int     i2c1_req_int:1;
+unsigned int     porb_av_cen_int:1;
+unsigned int     porb_dv_cen_int:1;
+unsigned int     reserved_0:8;
+unsigned int     gpioda_int:1;
+unsigned int     gpioa_int:1;
+unsigned int     reserved_1:5;
+unsigned int     rtc_alarm_int:1;
+unsigned int     rtc_hsec_int:1;
+unsigned int     reserved_2:2;
+unsigned int     tc4_int:1;
+unsigned int     reserved_3:1;
+unsigned int     wdog_nmi_int:1;
+unsigned int     reserved_4:1;
+unsigned int     irda_int:1;
+unsigned int     reserved_5:3;
+unsigned int     tc3_int:1;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR;
+
+typedef struct
+{
+unsigned int     int30_a:1;
+unsigned int     int29_a:1;
+unsigned int     int28_a:1;
+unsigned int     int27_a:1;
+unsigned int     int26_a:1;
+unsigned int     int25_a:1;
+unsigned int     int24_a:1;
+unsigned int     int23_a:1;
+unsigned int     int22_a:1;
+unsigned int     int21_a:1;
+unsigned int     int20_a:1;
+unsigned int     int19_a:1;
+unsigned int     int18_a:1;
+unsigned int     int17_a:1;
+unsigned int     int16_a:1;
+unsigned int     int15_a:1;
+unsigned int     int14_a:1;
+unsigned int     int13_a:1;
+unsigned int     int12_a:1;
+unsigned int     int11_a:1;
+unsigned int     int10_a:1;
+unsigned int     int9_a:1;
+unsigned int     int8_a:1;
+unsigned int     int7_a:1;
+unsigned int     int6_a:1;
+unsigned int     int5_a:1;
+unsigned int     int4_a:1;
+unsigned int     int3_a:1;
+unsigned int     int2_a:1;
+unsigned int     int1_a:1;
+unsigned int     int0_a:1;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_GPA0;
+
+typedef struct
+{
+unsigned int     int30_da:1;
+unsigned int     int29_da:1;
+unsigned int     int28_da:1;
+unsigned int     int27_da:1;
+unsigned int     int26_da:1;
+unsigned int     int25_da:1;
+unsigned int     int24_da:1;
+unsigned int     int23_da:1;
+unsigned int     int22_da:1;
+unsigned int     int21_da:1;
+unsigned int     int20_da:1;
+unsigned int     int19_da:1;
+unsigned int     int18_da:1;
+unsigned int     int17_da:1;
+unsigned int     int16_da:1;
+unsigned int     int15_da:1;
+unsigned int     int14_da:1;
+unsigned int     int13_da:1;
+unsigned int     int12_da:1;
+unsigned int     int11_da:1;
+unsigned int     int10_da:1;
+unsigned int     int9_da:1;
+unsigned int     int8_da:1;
+unsigned int     int7_da:1;
+unsigned int     int6_da:1;
+unsigned int     int5_da:1;
+unsigned int     int4_da:1;
+unsigned int     int3_da:1;
+unsigned int     int2_da:1;
+unsigned int     int1_da:1;
+unsigned int     int0_da:1;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_GPDA0;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     int34_a:1;
+unsigned int     int33_a:1;
+unsigned int     int32_a:1;
+unsigned int     int31_a:1;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_GPA1;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     int34_da:1;
+unsigned int     int33_da:1;
+unsigned int     int32_da:1;
+unsigned int     int31_da:1;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_GPDA1;
+
+typedef struct
+{
+unsigned int     gp_int:31;
+unsigned int     reserved_0:1;
+}ISO_FAST_INT_EN_0;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     gp_int:4;
+unsigned int     reserved_1:1;
+}ISO_FAST_INT_EN_1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     gpioda_int:1;
+unsigned int     gpioa_int:1;
+unsigned int     write_data:1;
+}ISO_FAST_ISR;
+
+typedef struct
+{
+unsigned int     dmy:32;
+}ISO_RESERVED_USE_3;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en2:1;
+unsigned int     reserved_1:2;
+unsigned int     sel:5;
+unsigned int     write_en1:1;
+unsigned int     reserved_2:2;
+unsigned int     enable:1;
+}ISO_REG_DBG;
+
+typedef struct
+{
+unsigned int     write_en5:1;
+unsigned int     standby_dbg_sel:7;
+unsigned int     write_en4:1;
+unsigned int     reserved_0:2;
+unsigned int     standby_dbg_en:1;
+unsigned int     write_en3:1;
+unsigned int     reserved_1:3;
+unsigned int     sel1:4;
+unsigned int     write_en2:1;
+unsigned int     reserved_2:3;
+unsigned int     sel0:4;
+unsigned int     write_en1:1;
+unsigned int     reserved_3:2;
+unsigned int     enable:1;
+}ISO_DBG;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     testmode:1;
+unsigned int     boot_sel:1;
+unsigned int     bound_opt:14;
+}ISO_CHIP_INFO1;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     pow_latch:26;
+}ISO_CHIP_INFO2;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     pow_latch_ori:26;
+}ISO_CHIP_INFO3;
+
+typedef struct
+{
+unsigned int     reserved_0:14;
+unsigned int     write_en9:1;
+unsigned int     iso_rst_wd_mask:1;
+unsigned int     write_en8:1;
+unsigned int     dc_phy_cke_pd:1;
+unsigned int     write_en7:1;
+unsigned int     iso_mis_clk_en:1;
+unsigned int     write_en6:1;
+unsigned int     iso_rbus_sel:1;
+unsigned int     write_en5:1;
+unsigned int     iso_rst_mask:1;
+unsigned int     write_en4:1;
+unsigned int     clk_osc_on_en:1;
+unsigned int     write_en3:1;
+unsigned int     crt_sw_rstn:1;
+unsigned int     write_en2:1;
+unsigned int     iso_clk_sel:1;
+unsigned int     write_en1:1;
+unsigned int     ejtag_en:1;
+}ISO_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     hsec_sync:1;
+unsigned int     hsec_int_en:1;
+unsigned int     alarm_int_en:1;
+}ISO_RTC;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     bi_bypass:1;
+unsigned int     iso_ctrl_en1:1;
+unsigned int     iso_ctrl_en0:1;
+}ISO_CELL;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     top_vdd_on:1;
+unsigned int     scpu_vdd_on:1;
+}ISO_POWER;
+
+typedef struct
+{
+unsigned int     i2c1_req:1;
+unsigned int     porb_av_cen:1;
+unsigned int     porb_dv_cen:1;
+unsigned int     reserved_0:6;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     gpioda:1;
+unsigned int     gpioa:1;
+unsigned int     reserved_3:5;
+unsigned int     rtc_alarm:1;
+unsigned int     rtc_hsec:1;
+unsigned int     i2c1:1;
+unsigned int     reserved_4:1;
+unsigned int     reserved_5:1;
+unsigned int     i2c0:1;
+unsigned int     reserved_6:2;
+unsigned int     irda:1;
+unsigned int     reserved_7:2;
+unsigned int     ur0:1;
+unsigned int     reserved_8:2;
+}ISO_SCPU_INT_EN;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     dcp_ctrl3:1;
+unsigned int     dcp_ctrl2:1;
+unsigned int     dcp_ctrl1:1;
+unsigned int     dcp_ctrl0:1;
+}ISO_USB;
+
+typedef struct
+{
+unsigned int     i2c1_req:1;
+unsigned int     reserved_0:8;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     gpioda:1;
+unsigned int     gpioa:1;
+unsigned int     reserved_3:5;
+unsigned int     rtc_alarm:1;
+unsigned int     rtc_hsec:1;
+unsigned int     i2c1:1;
+unsigned int     reserved_4:1;
+unsigned int     reserved_5:1;
+unsigned int     i2c0:1;
+unsigned int     reserved_6:2;
+unsigned int     irda:1;
+unsigned int     reserved_7:2;
+unsigned int     ur0:1;
+unsigned int     reserved_8:2;
+}ISO_ACPU_INT_EN;
+
+typedef struct
+{
+unsigned int     acpu_boot_info:32;
+}ISO_CPU_ST1;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     acpu_boot_info_valid:1;
+}ISO_CPU_ST1V;
+
+typedef struct
+{
+unsigned int     rvd31:1;
+unsigned int     rvd30:1;
+unsigned int     rvd29:1;
+unsigned int     rvd28:1;
+unsigned int     rvd27:1;
+unsigned int     rvd26:1;
+unsigned int     rvd25:1;
+unsigned int     rvd24:1;
+unsigned int     rvd23:1;
+unsigned int     rvd22:1;
+unsigned int     rvd21:1;
+unsigned int     rvd20:1;
+unsigned int     rvd19:1;
+unsigned int     rvd18:1;
+unsigned int     rvd17:1;
+unsigned int     rvd16:1;
+unsigned int     rvd15:1;
+unsigned int     rvd14:1;
+unsigned int     rvd13:1;
+unsigned int     rvd12:1;
+unsigned int     rvd11:1;
+unsigned int     rvd10:1;
+unsigned int     rvd9:1;
+unsigned int     rvd8:1;
+unsigned int     rvd7:1;
+unsigned int     rvd6:1;
+unsigned int     rvd5:1;
+unsigned int     rvd4:1;
+unsigned int     rvd3:1;
+unsigned int     rvd2:1;
+unsigned int     rvd1:1;
+unsigned int     rvd0:1;
+}ISO_DUMMY1;
+
+typedef struct
+{
+unsigned int     rvd31:1;
+unsigned int     rvd30:1;
+unsigned int     rvd29:1;
+unsigned int     rvd28:1;
+unsigned int     rvd27:1;
+unsigned int     rvd26:1;
+unsigned int     rvd25:1;
+unsigned int     rvd24:1;
+unsigned int     rvd23:1;
+unsigned int     rvd22:1;
+unsigned int     rvd21:1;
+unsigned int     rvd20:1;
+unsigned int     rvd19:1;
+unsigned int     rvd18:1;
+unsigned int     rvd17:1;
+unsigned int     rvd16:1;
+unsigned int     rvd15:1;
+unsigned int     rvd14:1;
+unsigned int     rvd13:1;
+unsigned int     rvd12:1;
+unsigned int     rvd11:1;
+unsigned int     rvd10:1;
+unsigned int     rvd9:1;
+unsigned int     rvd8:1;
+unsigned int     rvd7:1;
+unsigned int     rvd6:1;
+unsigned int     rvd5:1;
+unsigned int     rvd4:1;
+unsigned int     rvd3:1;
+unsigned int     rvd2:1;
+unsigned int     rvd1:1;
+unsigned int     rvd0:1;
+}ISO_DUMMY2;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     sel_xtal25m_cen_l:1;
+unsigned int     en_pll_27m_tiehalf_cen:1;
+unsigned int     pow_ldo_27m_pll_cen:1;
+unsigned int     pow_pll_27m_en_cen:1;
+unsigned int     reserved_1:2;
+unsigned int     gphy_mdio_outside_ctrl_en:1;
+unsigned int     etn_gphy_switch_nat:1;
+unsigned int     reserved_2:1;
+unsigned int     etn_efuse_default:1;
+unsigned int     powercut_ana_d2a_isolate_b:1;
+unsigned int     powercut_ana_a2d_isolate_b:1;
+}ISO_POWERCUT_ETN;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     etn_bpsgphy_mode:1;
+unsigned int     etn_ocd_mode:1;
+}ISO_ETN_TESTIO;
+
+typedef struct
+{
+unsigned int     dmy:32;
+}ISO_RESERVED_USE_0;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     timer:1;
+unsigned int     reserved_1:1;
+unsigned int     ir_main:1;
+unsigned int     ir_tx:1;
+unsigned int     ir_raw:1;
+}ISO_LPI;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     cnt_wait_pwr:16;
+}ISO_WD;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     plletn_wdout:1;
+}ISO_PLL_WDOUT;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     plletn_oeb:1;
+unsigned int     plletn_rstb:1;
+unsigned int     plletn_o:4;
+unsigned int     plletn_m:7;
+unsigned int     plletn_ldo_pow:1;
+unsigned int     plletn_pow:1;
+unsigned int     plletn_ldo_sel:2;
+unsigned int     plletn_wdmode:2;
+unsigned int     plletn_n:2;
+unsigned int     plletn_lf_rs:2;
+unsigned int     plletn_lf_cp:2;
+unsigned int     plletn_ip:3;
+}ISO_PLL_ETN;
+
+typedef struct
+{
+unsigned int     dmy:32;
+}ISO_RESERVED_USE_1;
+
+typedef struct
+{
+unsigned int     dmy:32;
+}ISO_RESERVED_USE_2;
+
+typedef struct
+{
+unsigned int     dmy1:20;
+unsigned int     reserved_0:3;
+unsigned int     en:1;
+unsigned int     reserved_1:3;
+unsigned int     sel:5;
+}ISO_I2C1_SDA_DEL;
+
+typedef struct
+{
+unsigned int     dmy1:20;
+unsigned int     reserved_0:3;
+unsigned int     en:1;
+unsigned int     reserved_1:3;
+unsigned int     sel:5;
+}ISO_I2C0_SDA_DEL;
+
+typedef struct
+{
+unsigned int     reserved_0:18;
+unsigned int     rstn_cbus:1;
+unsigned int     rstn_i2c_1:1;
+unsigned int     rstn_i2c_0:1;
+unsigned int     rstn_gphy:1;
+unsigned int     rstn_gmac:1;
+unsigned int     rstn_ur0:1;
+unsigned int     rstn_efuse:1;
+unsigned int     rstn_cbusrx:1;
+unsigned int     rstn_cbustx:1;
+unsigned int     rstn_dp:1;
+unsigned int     rstn_cec1:1;
+unsigned int     rstn_cec0:1;
+unsigned int     rstn_ir:1;
+unsigned int     reserved_1:1;
+}ISO_SOFT_RESET;
+
+typedef struct
+{
+unsigned int     reserved_0:19;
+unsigned int     clk_en_etn_sys:1;
+unsigned int     clk_en_etn_250m:1;
+unsigned int     clk_en_i2c1:1;
+unsigned int     clk_en_i2c0:1;
+unsigned int     clk_en_misc_ur0:1;
+unsigned int     clk_en_misc_ir:1;
+unsigned int     clk_en_cbus_osc:1;
+unsigned int     clk_en_cbus_sys:1;
+unsigned int     clk_en_cbustx_sys:1;
+unsigned int     clk_en_cbusrx_sys:1;
+unsigned int     clk_en_misc_cec0:1;
+unsigned int     reserved_1:1;
+unsigned int     clk_en_misc_mix:1;
+}ISO_CLOCK_ENABLE;
+
+typedef struct
+{
+unsigned int     reserved_0:7;
+unsigned int     rd_only_0_en:1;
+unsigned int     reserved_1:2;
+unsigned int     blk_protect_0_wpro_en:1;
+unsigned int     reserved_2:2;
+unsigned int     blk_protect_0_en:1;
+unsigned int     reserved_3:8;
+unsigned int     protect_0_wpro_en:1;
+unsigned int     reserved_4:8;
+unsigned int     protect_0_en:1;
+}ISO_DC_0;
+
+typedef struct
+{
+unsigned int     mem_saddr0:22;
+unsigned int     reserved_0:10;
+}ISO_DC_1;
+
+typedef struct
+{
+unsigned int     mem_eaddr0:22;
+unsigned int     reserved_0:10;
+}ISO_DC_2;
+
+typedef struct
+{
+unsigned int     blk_saddr0:22;
+unsigned int     reserved_0:10;
+}ISO_DC_3;
+
+typedef struct
+{
+unsigned int     blk_eaddr0:22;
+unsigned int     reserved_0:10;
+}ISO_DC_4;
+
+typedef struct
+{
+unsigned int     ro_saddr0:22;
+unsigned int     reserved_0:10;
+}ISO_DC_5;
+
+typedef struct
+{
+unsigned int     ro_eaddr0:22;
+unsigned int     reserved_0:10;
+}ISO_DC_6;
+
+typedef struct
+{
+unsigned int     reserved_0:7;
+unsigned int     md_tee_protect_en:1;
+unsigned int     reserved_1:7;
+unsigned int     cp_tee_protect_en:1;
+unsigned int     reserved_2:7;
+unsigned int     vo_protect_en:1;
+unsigned int     reserved_3:5;
+unsigned int     tp_tee_protect_en:1;
+unsigned int     cr_tee_protect_en:1;
+unsigned int     nf_tee_protect_en:1;
+}ISO_DC_7;
+
+typedef struct
+{
+unsigned int     reserved_0:7;
+unsigned int     scpu_tee_protect_en:1;
+unsigned int     reserved_1:7;
+unsigned int     acpu_protect_en:1;
+unsigned int     reserved_2:7;
+unsigned int     video_protect_en:1;
+unsigned int     reserved_3:7;
+unsigned int     audio_protect_en:1;
+}ISO_DC_8;
+
+typedef struct
+{
+unsigned int     reserved_0:17;
+unsigned int     scpu_tee_blk_protect_en:1;
+unsigned int     reserved_1:1;
+unsigned int     acpu_blk_protect_en:1;
+unsigned int     reserved_2:1;
+unsigned int     video_blk_protect_en:1;
+unsigned int     reserved_3:1;
+unsigned int     audio_blk_protect_en:1;
+unsigned int     reserved_4:1;
+unsigned int     md_tee_blk_protect_en:1;
+unsigned int     reserved_5:1;
+unsigned int     cp_tee_blk_protect_en:1;
+unsigned int     tp_tee_blk_protect_en:1;
+unsigned int     vo_blk_protect_en:1;
+unsigned int     cr_tee_blk_protect_en:1;
+unsigned int     nf_tee_blk_protect_en:1;
+}ISO_DC_9;
+
+typedef struct
+{
+unsigned int     reserved_0:3;
+unsigned int     scpu_tee_ro_protect_en:1;
+unsigned int     reserved_1:3;
+unsigned int     acpu_ro_protect_en:1;
+unsigned int     reserved_2:3;
+unsigned int     video_ro_protect_en:1;
+unsigned int     reserved_3:3;
+unsigned int     audio_ro_protect_en:1;
+unsigned int     reserved_4:3;
+unsigned int     md_tee_ro_protect_en:1;
+unsigned int     reserved_5:3;
+unsigned int     cp_tee_ro_protect_en:1;
+unsigned int     reserved_6:3;
+unsigned int     vo_ro_protect_en:1;
+unsigned int     reserved_7:1;
+unsigned int     tp_tee_ro_protect_en:1;
+unsigned int     cr_tee_ro_protect_en:1;
+unsigned int     nf_tee_ro_protect_en:1;
+}ISO_DC_A;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     xtal_pad_drv:2;
+}ISO_PLL_XTAL_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     int_option:1;
+}ISO_HDMI_RX;
+
+typedef struct
+{
+unsigned int     reserved_0:18;
+unsigned int     reg_reserve:2;
+unsigned int     reg_tc_emb:3;
+unsigned int     reg_fref_sel:1;
+unsigned int     s_emb:7;
+unsigned int     rstb_emb:1;
+}ISO_PLL_ETN_OSC;
+
+typedef struct
+{
+unsigned int     int_30:1;
+unsigned int     int_29:1;
+unsigned int     int_28:1;
+unsigned int     int_27:1;
+unsigned int     int_26:1;
+unsigned int     int_25:1;
+unsigned int     int_24:1;
+unsigned int     int_23:1;
+unsigned int     int_22:1;
+unsigned int     int_21:1;
+unsigned int     int_20:1;
+unsigned int     int_19:1;
+unsigned int     int_18:1;
+unsigned int     int_17:1;
+unsigned int     int_16:1;
+unsigned int     int_15:1;
+unsigned int     int_14:1;
+unsigned int     int_13:1;
+unsigned int     int_12:1;
+unsigned int     int_11:1;
+unsigned int     int_10:1;
+unsigned int     int_9:1;
+unsigned int     int_8:1;
+unsigned int     int_7:1;
+unsigned int     int_6:1;
+unsigned int     int_5:1;
+unsigned int     int_4:1;
+unsigned int     int_3:1;
+unsigned int     int_2:1;
+unsigned int     int_1:1;
+unsigned int     int_0:1;
+unsigned int     write_data:1;
+}ISO_FAST_ISR_GPIO0_A;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     int_34:1;
+unsigned int     int_33:1;
+unsigned int     int_32:1;
+unsigned int     int_31:1;
+unsigned int     write_data:1;
+}ISO_FAST_ISR_GPIO1_A;
+
+typedef struct
+{
+unsigned int     int_30:1;
+unsigned int     int_29:1;
+unsigned int     int_28:1;
+unsigned int     int_27:1;
+unsigned int     int_26:1;
+unsigned int     int_25:1;
+unsigned int     int_24:1;
+unsigned int     int_23:1;
+unsigned int     int_22:1;
+unsigned int     int_21:1;
+unsigned int     int_20:1;
+unsigned int     int_19:1;
+unsigned int     int_18:1;
+unsigned int     int_17:1;
+unsigned int     int_16:1;
+unsigned int     int_15:1;
+unsigned int     int_14:1;
+unsigned int     int_13:1;
+unsigned int     int_12:1;
+unsigned int     int_11:1;
+unsigned int     int_10:1;
+unsigned int     int_9:1;
+unsigned int     int_8:1;
+unsigned int     int_7:1;
+unsigned int     int_6:1;
+unsigned int     int_5:1;
+unsigned int     int_4:1;
+unsigned int     int_3:1;
+unsigned int     int_2:1;
+unsigned int     int_1:1;
+unsigned int     int_0:1;
+unsigned int     write_data:1;
+}ISO_FAST_ISR_GPIO0_DA;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     int_34:1;
+unsigned int     int_33:1;
+unsigned int     int_32:1;
+unsigned int     int_31:1;
+unsigned int     write_data:1;
+}ISO_FAST_ISR_GPIO1_DA;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     int_en:1;
+unsigned int     en:1;
+}ISO_I2C1_REQ_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     val:16;
+}ISO_I2C1_REQ_START;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     val:16;
+}ISO_I2C1_REQ_SCL_LCNT;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     val:16;
+}ISO_I2C1_REQ_STOP;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     dv_cen_int_en:1;
+unsigned int     dv_cen_ha:1;
+unsigned int     reserved_1:2;
+unsigned int     av_cen_int_en:1;
+unsigned int     av_cen_ha:1;
+}ISO_POR_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:7;
+unsigned int     reg_iso_por:1;
+unsigned int     reserved_1:2;
+unsigned int     reg_gpu_por:2;
+unsigned int     reserved_2:2;
+unsigned int     reg_scpu_mem_por:2;
+unsigned int     reserved_3:2;
+unsigned int     reg_scpu_por:2;
+unsigned int     reserved_4:2;
+unsigned int     reg_dvth_por:2;
+unsigned int     reserved_5:2;
+unsigned int     reg_avth_por:2;
+unsigned int     reserved_6:2;
+unsigned int     reg_d10_por:2;
+}ISO_POR_VTH;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     porb_dv_cen_l:1;
+unsigned int     reserved_1:3;
+unsigned int     porb_av_cen_l:1;
+}ISO_POR_DATAI;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     write_en2:1;
+unsigned int     dv_cen:3;
+unsigned int     write_en1:1;
+unsigned int     av_cen:3;
+}ISO_POR_DEB;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     ve_fo_block_nwc:1;
+unsigned int     tp_block_nwc:1;
+unsigned int     usb2sram_ctrl:1;
+unsigned int     ve_encode_block_nwc:1;
+unsigned int     ve_block_nwc:1;
+unsigned int     vo_block_nwc:1;
+unsigned int     dc_mem_port_lock:1;
+unsigned int     secure_rbus:1;
+}ISO_SB2_0;
+
+typedef struct
+{
+unsigned int     reserved_0:17;
+unsigned int     reg_emb_i_sel:1;
+unsigned int     reg_emb_cap_sel:2;
+unsigned int     reg_bg_rbgloop2:3;
+unsigned int     reg_bg_rbg:3;
+unsigned int     reg_bg_rbg2:2;
+unsigned int     reg_bg_envbgup:1;
+unsigned int     reg_ck_dummy:1;
+unsigned int     reg_bg_dummy:1;
+unsigned int     reg_en_emb:1;
+}ISO_MBIAS;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     reg_por15n_1:1;
+unsigned int     reg_por15n_0:1;
+unsigned int     reg_pwdpad15n_1:1;
+unsigned int     reg_pwdpad15n_0:1;
+}ISO_DDR_IO_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     reg_pwdpad3_disp:1;
+}ISO_DISP_IO_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     iso_sb3_req_mask_reg:1;
+}ISO_SB3_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:25;
+unsigned int     tmux_dbg_sel:7;
+}ISO_ISO_TMUX_DBG;
+
+typedef struct
+{
+unsigned int     dummy:32;
+}ISO_ISO_MODE_REG;
+
+typedef struct
+{
+unsigned int     l2h_delay_cycle:32;
+}ISO_USB0_SRAM_PWR0;
+
+typedef struct
+{
+unsigned int     h2l_delay_cycle:32;
+}ISO_USB0_SRAM_PWR1;
+
+typedef struct
+{
+unsigned int     sd_reg:32;
+}ISO_USB0_SRAM_PWR2;
+
+typedef struct
+{
+unsigned int     mux_reg:32;
+}ISO_USB0_SRAM_PWR3;
+
+typedef struct
+{
+unsigned int     ctrl:32;
+}ISO_USB0_SRAM_PWR4;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     ve3_sram_int_mask:1;
+unsigned int     reserved_1:1;
+unsigned int     ve3_sram_int:1;
+unsigned int     reserved_2:1;
+unsigned int     write_data:1;
+}ISO_USB0_SRAM_PWR5;
+
+typedef struct
+{
+unsigned int     last_delay_cycle:32;
+}ISO_USB0_SRAM_PWR6;
+
+typedef struct
+{
+unsigned int     pg_switch_info:32;
+}ISO_USB0_SRAM_PWR7;
+
+typedef struct
+{
+unsigned int     l2h_delay_cycle:32;
+}ISO_USB1_SRAM_PWR0;
+
+typedef struct
+{
+unsigned int     h2l_delay_cycle:32;
+}ISO_USB1_SRAM_PWR1;
+
+typedef struct
+{
+unsigned int     sd_reg:32;
+}ISO_USB1_SRAM_PWR2;
+
+typedef struct
+{
+unsigned int     mux_reg:32;
+}ISO_USB1_SRAM_PWR3;
+
+typedef struct
+{
+unsigned int     ctrl:32;
+}ISO_USB1_SRAM_PWR4;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     ve3_sram_int_mask:1;
+unsigned int     reserved_1:1;
+unsigned int     ve3_sram_int:1;
+unsigned int     reserved_2:1;
+unsigned int     write_data:1;
+}ISO_USB1_SRAM_PWR5;
+
+typedef struct
+{
+unsigned int     last_delay_cycle:32;
+}ISO_USB1_SRAM_PWR6;
+
+typedef struct
+{
+unsigned int     pg_switch_info:32;
+}ISO_USB1_SRAM_PWR7;
+
+typedef struct
+{
+unsigned int     iso_usb_u2phy_hst_dcp_en_3:1;
+unsigned int     iso_usb_u2phy_hst_dcp_en_2:1;
+unsigned int     iso_usb_u2phy_hst_dcp_en_1:1;
+unsigned int     iso_usb_u2phy_hst_dcp_en_0:1;
+unsigned int     iso_usb_u2phy_lf_pd_r_en_3:1;
+unsigned int     iso_usb_u2phy_lf_pd_r_en_2:1;
+unsigned int     iso_usb_u2phy_lf_pd_r_en_1:1;
+unsigned int     iso_usb_u2phy_lf_pd_r_en_0:1;
+unsigned int     iso_usb_u2phy_reg_ldo_pw_3:1;
+unsigned int     iso_usb_u2phy_reg_ldo_pw_2:1;
+unsigned int     iso_usb_u2phy_reg_ldo_pw_1:1;
+unsigned int     iso_usb_u2phy_reg_ldo_pw_0:1;
+unsigned int     iso_usb_u2phy_by_paa_on_3:1;
+unsigned int     iso_usb_u2phy_by_paa_on_2:1;
+unsigned int     iso_usb_u2phy_by_paa_on_1:1;
+unsigned int     iso_usb_u2phy_by_paa_on_0:1;
+unsigned int     reserved_0:6;
+unsigned int     iso_usb_p3_isoctrl_en:1;
+unsigned int     iso_usb_p012_isoctrl_en:1;
+unsigned int     reserved_1:1;
+unsigned int     iso_usb_u2phy_pg_en:1;
+unsigned int     iso_usb_u3phy_p1_pg_en:1;
+unsigned int     iso_usb_u3phy_p0_pg_en:1;
+unsigned int     reserved_2:2;
+unsigned int     iso_usb_p3_pg_en:1;
+unsigned int     iso_usb_p012_pg_en:1;
+}ISO_USB_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     so_etn_sram_ls_gap:2;
+unsigned int     so_etn_clk_en_gap:2;
+unsigned int     so_etn_pwr_ctrl_sw_rst:1;
+unsigned int     iso_etn_pwr_ctrl_en:1;
+}ISO_ETN_DBUS_CTRL;
+
+typedef struct
+{
+unsigned int     iso_etn_drom_golden:32;
+}ISO_ETN_BIST_DROM_GOLDEN;
+
+typedef struct
+{
+unsigned int     iso_etn_irom_golden:32;
+}ISO_ETN_BIST_IROM_GOLDEN;
+
+typedef struct
+{
+unsigned int     iso_etn_ftr_rom_golden:32;
+}ISO_ETN_BIST_FTR_ROM_GOLDEN;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     osc_count_limit:12;
+unsigned int     reserved_1:7;
+unsigned int     xtal_off:1;
+unsigned int     dco_sel:1;
+unsigned int     cal_enable:1;
+}ISO_DCO_0;
+
+typedef struct
+{
+unsigned int     reserved_0:7;
+unsigned int     dco_count_latch:12;
+unsigned int     xtal_count_latch:12;
+unsigned int     dco_cal_done:1;
+}ISO_DCO_1;
+
+typedef struct
+{
+unsigned int     gpdir:32;
+}ISO_GPDIR;
+
+typedef struct
+{
+unsigned int     gpdato:32;
+}ISO_GPDATO;
+
+typedef struct
+{
+unsigned int     gpdati:32;
+}ISO_GPDATI;
+
+typedef struct
+{
+unsigned int     gp:32;
+}ISO_GPIE;
+
+typedef struct
+{
+unsigned int     gpha:32;
+}ISO_GPDP;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     write_en1:1;
+unsigned int     clk1:3;
+}ISO_GPDEB;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     gpdir_1:3;
+}ISO_GPDIR_1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     gpdato_1:3;
+}ISO_GPDATO_1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     gpdati_1:3;
+}ISO_GPDATI_1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     gp_1:3;
+}ISO_GPIE_1;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     gpha_1:3;
+}ISO_GPDP_1;
+
+typedef struct
+{
+unsigned int     i2c_scl_0_smt:1;
+unsigned int     i2c_scl_0_e2:1;
+unsigned int     i2c_scl_0_pud_en:1;
+unsigned int     i2c_scl_0_pud_sel:1;
+unsigned int     i2c_sda_0_smt:1;
+unsigned int     i2c_sda_0_e2:1;
+unsigned int     i2c_sda_0_pud_en:1;
+unsigned int     i2c_sda_0_pud_sel:1;
+unsigned int     iso_gpio_7_smt:1;
+unsigned int     iso_gpio_7_e2:1;
+unsigned int     iso_gpio_7_pud_en:1;
+unsigned int     iso_gpio_7_pud_sel:1;
+unsigned int     iso_gpio_5_smt:1;
+unsigned int     iso_gpio_5_e2:1;
+unsigned int     iso_gpio_5_pud_en:1;
+unsigned int     iso_gpio_5_pud_sel:1;
+unsigned int     iso_gpio_4_smt:1;
+unsigned int     iso_gpio_4_e2:1;
+unsigned int     iso_gpio_4_pud_en:1;
+unsigned int     iso_gpio_4_pud_sel:1;
+unsigned int     ir_rx_smt:1;
+unsigned int     ir_rx_e2:1;
+unsigned int     ir_rx_pud_en:1;
+unsigned int     ir_rx_pud_sel:1;
+unsigned int     iso_gpio_3_smt:1;
+unsigned int     iso_gpio_3_e2:1;
+unsigned int     iso_gpio_3_pud_en:1;
+unsigned int     iso_gpio_3_pud_sel:1;
+unsigned int     iso_gpio_2_smt:1;
+unsigned int     iso_gpio_2_e2:1;
+unsigned int     iso_gpio_2_pud_en:1;
+unsigned int     iso_gpio_2_pud_sel:1;
+}ISO_PFUNC0;
+
+typedef struct
+{
+unsigned int     etn_led_rxtx_smt:1;
+unsigned int     etn_led_rxtx_e2:1;
+unsigned int     etn_led_rxtx_pud_en:1;
+unsigned int     etn_led_rxtx_pud_sel:1;
+unsigned int     etn_led_link_smt:1;
+unsigned int     etn_led_link_e2:1;
+unsigned int     etn_led_link_pud_en:1;
+unsigned int     etn_led_link_pud_sel:1;
+unsigned int     ur0_tx_smt:1;
+unsigned int     ur0_tx_e2:1;
+unsigned int     ur0_tx_pud_en:1;
+unsigned int     ur0_tx_pud_sel:1;
+unsigned int     ur0_rx_smt:1;
+unsigned int     ur0_rx_e2:1;
+unsigned int     ur0_rx_pud_en:1;
+unsigned int     ur0_rx_pud_sel:1;
+unsigned int     ur1_cts_n_smt:1;
+unsigned int     ur1_cts_n_e2:1;
+unsigned int     ur1_cts_n_pud_en:1;
+unsigned int     ur1_cts_n_pud_sel:1;
+unsigned int     ur1_rts_n_smt:1;
+unsigned int     ur1_rts_n_e2:1;
+unsigned int     ur1_rts_n_pud_en:1;
+unsigned int     ur1_rts_n_pud_sel:1;
+unsigned int     ur1_tx_smt:1;
+unsigned int     ur1_tx_e2:1;
+unsigned int     ur1_tx_pud_en:1;
+unsigned int     ur1_tx_pud_sel:1;
+unsigned int     ur1_rx_smt:1;
+unsigned int     ur1_rx_e2:1;
+unsigned int     ur1_rx_pud_en:1;
+unsigned int     ur1_rx_pud_sel:1;
+}ISO_PFUNC1;
+
+typedef struct
+{
+unsigned int     i2c_scl_1_smt:1;
+unsigned int     i2c_scl_1_e2:1;
+unsigned int     i2c_scl_1_pud_en:1;
+unsigned int     i2c_scl_1_pud_sel:1;
+unsigned int     i2c_sda_1_smt:1;
+unsigned int     i2c_sda_1_e2:1;
+unsigned int     i2c_sda_1_pud_en:1;
+unsigned int     i2c_sda_1_pud_sel:1;
+unsigned int     ir_tx_smt:1;
+unsigned int     ir_tx_e2:1;
+unsigned int     ir_tx_pud_en:1;
+unsigned int     ir_tx_pud_sel:1;
+unsigned int     i2c_scl_6_smt:1;
+unsigned int     i2c_scl_6_e2:1;
+unsigned int     i2c_scl_6_pud_en:1;
+unsigned int     i2c_scl_6_pud_sel:1;
+unsigned int     i2c_sda_6_smt:1;
+unsigned int     i2c_sda_6_e2:1;
+unsigned int     i2c_sda_6_pud_en:1;
+unsigned int     i2c_sda_6_pud_sel:1;
+unsigned int     boot_sel_pud_en:1;
+unsigned int     boot_sel_pud_sel:1;
+unsigned int     testmode_pud_en:1;
+unsigned int     testmode_pud_sel:1;
+unsigned int     standby1_smt:1;
+unsigned int     standby1_e2:1;
+unsigned int     standby1_pud_en:1;
+unsigned int     standby1_pud_sel:1;
+unsigned int     standby_smt:1;
+unsigned int     standby_e2:1;
+unsigned int     standby_pud_en:1;
+unsigned int     standby_pud_sel:1;
+}ISO_PFUNC2;
+
+typedef struct
+{
+unsigned int     nat_led_3_smt:1;
+unsigned int     nat_led_3_e2:1;
+unsigned int     nat_led_3_pud_en:1;
+unsigned int     nat_led_3_pud_sel:1;
+unsigned int     nat_led_2_smt:1;
+unsigned int     nat_led_2_e2:1;
+unsigned int     nat_led_2_pud_en:1;
+unsigned int     nat_led_2_pud_sel:1;
+unsigned int     nat_led_1_smt:1;
+unsigned int     nat_led_1_e2:1;
+unsigned int     nat_led_1_pud_en:1;
+unsigned int     nat_led_1_pud_sel:1;
+unsigned int     nat_led_0_smt:1;
+unsigned int     nat_led_0_e2:1;
+unsigned int     nat_led_0_pud_en:1;
+unsigned int     nat_led_0_pud_sel:1;
+unsigned int     hdmi_hpd_smt:1;
+unsigned int     hdmi_hpd_e2:1;
+unsigned int     hdmi_hpd_pud_en:1;
+unsigned int     hdmi_hpd_pud_sel:1;
+unsigned int     reset_n_pud_en:1;
+unsigned int     reset_n_pud_sel:1;
+unsigned int     reserved_0:2;
+unsigned int     boption12_en:1;
+unsigned int     boption12_sel:1;
+unsigned int     boption11_en:1;
+unsigned int     boption11_sel:1;
+unsigned int     boption10_en:1;
+unsigned int     boption10_sel:1;
+unsigned int     boption2_en:1;
+unsigned int     boption2_sel:1;
+}ISO_PFUNC3;
+
+typedef struct
+{
+unsigned int     reserved_0:2;
+unsigned int     etn_led_rxtx:2;
+unsigned int     etn_led_link:2;
+unsigned int     i2c_sda_0:2;
+unsigned int     i2c_scl_0:2;
+unsigned int     ur1_rts_n:2;
+unsigned int     ur1_cts_n:2;
+unsigned int     ur1_tx:2;
+unsigned int     ur1_rx:2;
+unsigned int     ur0_tx:2;
+unsigned int     ur0_rx:2;
+unsigned int     ir_tx:2;
+unsigned int     ir_rx:2;
+unsigned int     iso_gpio_7:2;
+unsigned int     iso_gpio_5:2;
+unsigned int     iso_gpio_4:2;
+}ISO_MUXPAD0;
+
+typedef struct
+{
+unsigned int     ur2_loc:2;
+unsigned int     ejtag_avcpu_loc:2;
+unsigned int     pwm_01_open_drain_en_loc1:1;
+unsigned int     pwm_23_open_drain_en_loc1:1;
+unsigned int     pwm_01_open_drain_en_loc0:1;
+unsigned int     pwm_23_open_drain_en_loc0:1;
+unsigned int     nat_led_3:2;
+unsigned int     nat_led_2:2;
+unsigned int     nat_led_1:2;
+unsigned int     nat_led_0:2;
+unsigned int     i2c_sda_1:2;
+unsigned int     i2c_scl_1:2;
+unsigned int     iso_gpio_3:3;
+unsigned int     iso_gpio_2:3;
+unsigned int     hdmi_hpd:2;
+unsigned int     i2c_sda_6:2;
+unsigned int     i2c_scl_6:2;
+}ISO_MUXPAD1;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     boot_sel_smt:1;
+unsigned int     testmode_smt:1;
+unsigned int     reset_n_smt:1;
+unsigned int     reserved_1:1;
+unsigned int     boption12_smt:1;
+unsigned int     boption11_smt:1;
+unsigned int     boption10_smt:1;
+unsigned int     boption2_smt:1;
+unsigned int     iso_gpio_25_smt:1;
+unsigned int     iso_gpio_25_e2:1;
+unsigned int     iso_gpio_25_pud_en:1;
+unsigned int     iso_gpio_25_pud_sel:1;
+unsigned int     iso_gpio_24_smt:1;
+unsigned int     iso_gpio_24_e2:1;
+unsigned int     iso_gpio_24_pud_en:1;
+unsigned int     iso_gpio_24_pud_sel:1;
+unsigned int     iso_gpio_23_smt:1;
+unsigned int     iso_gpio_23_e2:1;
+unsigned int     iso_gpio_23_pud_en:1;
+unsigned int     iso_gpio_23_pud_sel:1;
+unsigned int     iso_gpio_22_smt:1;
+unsigned int     iso_gpio_22_e2:1;
+unsigned int     iso_gpio_22_pud_en:1;
+unsigned int     iso_gpio_22_pud_sel:1;
+unsigned int     iso_gpio_21_smt:1;
+unsigned int     iso_gpio_21_e2:1;
+unsigned int     iso_gpio_21_pud_en:1;
+unsigned int     iso_gpio_21_pud_sel:1;
+}ISO_PFUNC4;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     i2c_tg_enable:1;
+unsigned int     reserved_1:1;
+unsigned int     iso_gpio_34:2;
+unsigned int     iso_gpio_33:2;
+unsigned int     iso_gpio_25:2;
+unsigned int     iso_gpio_24:2;
+unsigned int     iso_gpio_23:2;
+unsigned int     iso_gpio_22:2;
+unsigned int     iso_gpio_21:2;
+}ISO_MUXPAD2;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     wd_rset_smt:1;
+unsigned int     wd_rset_e2:1;
+unsigned int     wd_rset_pud_en:1;
+unsigned int     wd_rset_pud_sel:1;
+unsigned int     iso_gpio_34_smt:1;
+unsigned int     iso_gpio_34_e2:1;
+unsigned int     iso_gpio_34_pud_en:1;
+unsigned int     iso_gpio_34_pud_sel:1;
+unsigned int     iso_gpio_33_smt:1;
+unsigned int     iso_gpio_33_e2:1;
+unsigned int     iso_gpio_33_pud_en:1;
+unsigned int     iso_gpio_33_pud_sel:1;
+}ISO_PFUNC5;
+
+typedef struct
+{
+unsigned int     irrbl:8;
+unsigned int     irrml:8;
+unsigned int     irrdzl:8;
+unsigned int     irrdol:8;
+}ISO_IR_PSR;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     irrdl:6;
+unsigned int     irrrl:8;
+unsigned int     irrsl:8;
+}ISO_IR_PER;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     irfd:16;
+}ISO_IR_SF;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     iriotcdp:16;
+}ISO_IR_DPIR;
+
+typedef struct
+{
+unsigned int     irsr:1;
+unsigned int     reserved_0:5;
+unsigned int     rcmm_en:1;
+unsigned int     toshiba_en:1;
+unsigned int     irednm:1;
+unsigned int     reserved_1:1;
+unsigned int     iredn:6;
+unsigned int     reserved_2:1;
+unsigned int     raw_fifo_ov:1;
+unsigned int     raw_fifo_val:1;
+unsigned int     raw_en:1;
+unsigned int     mlae:1;
+unsigned int     irie:1;
+unsigned int     irres:1;
+unsigned int     irue:1;
+unsigned int     ircm:1;
+unsigned int     irbme:1;
+unsigned int     irdpm:1;
+unsigned int     irdn:5;
+}ISO_IR_CR;
+
+typedef struct
+{
+unsigned int     irrp:32;
+}ISO_IR_RP;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     slen_big:1;
+unsigned int     blen_big:1;
+unsigned int     raw_fifo_ov:1;
+unsigned int     raw_fifo_val:1;
+unsigned int     irrf:1;
+unsigned int     irdvf:1;
+}ISO_IR_SR;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     stop_sample:1;
+unsigned int     stop_time:16;
+unsigned int     reserved_1:1;
+unsigned int     write_en1:1;
+unsigned int     fifo_thr:6;
+}ISO_IR_RAW_CTRL;
+
+typedef struct
+{
+unsigned int     dat:32;
+}ISO_IR_RAW_FF;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     cnt:16;
+}ISO_IR_RAW_SAMPLE_TIME;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     val:6;
+}ISO_IR_RAW_WL;
+
+typedef struct
+{
+unsigned int     reserved_0:8;
+unsigned int     len:8;
+unsigned int     clk:16;
+}ISO_IR_RAW_DEB;
+
+typedef struct
+{
+unsigned int     irrbl:8;
+unsigned int     irrml:8;
+unsigned int     irrdzl:8;
+unsigned int     irrdol:8;
+}ISO_IR_PSR_UP;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     irrrl:8;
+unsigned int     irrsl:8;
+}ISO_IR_PER_UP;
+
+typedef struct
+{
+unsigned int     reserved_0:23;
+unsigned int     rc6_en:1;
+unsigned int     irtr:8;
+}ISO_IR_CTRL_RC6;
+
+typedef struct
+{
+unsigned int     irrp:32;
+}ISO_IR_RP2;
+
+typedef struct
+{
+unsigned int     irtx_en:1;
+unsigned int     reserved_0:20;
+unsigned int     iact_lvl:1;
+unsigned int     modulation:1;
+unsigned int     endian:1;
+unsigned int     dummy:2;
+unsigned int     fifoout_inv:1;
+unsigned int     irtxout_inv:1;
+unsigned int     reserved_1:3;
+unsigned int     start:1;
+}ISO_IRTX_CFG;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     irtx_fd:16;
+}ISO_IRTX_TIM;
+
+typedef struct
+{
+unsigned int     reserved_0:12;
+unsigned int     pwm_clksrc_div:4;
+unsigned int     pwm_clk_duty:8;
+unsigned int     pwm_clk_div:8;
+}ISO_IRTX_PWM_SETTING;
+
+typedef struct
+{
+unsigned int     reserved_0:18;
+unsigned int     data_thr:6;
+unsigned int     reserved_1:5;
+unsigned int     fin_en:1;
+unsigned int     emp_en:1;
+unsigned int     req_en:1;
+}ISO_IRTX_INT_EN;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     fin_flag:1;
+unsigned int     emp_flag:1;
+unsigned int     req_flag:1;
+}ISO_IRTX_INT_ST;
+
+typedef struct
+{
+unsigned int     fifo_rst:1;
+unsigned int     reserved_0:19;
+unsigned int     valid_len:4;
+unsigned int     wrp:4;
+unsigned int     rdp:4;
+}ISO_IRTX_FIFO_ST;
+
+typedef struct
+{
+unsigned int     data:32;
+}ISO_IRTX_FIFO;
+
+typedef struct
+{
+unsigned int     len_11:8;
+unsigned int     len_10:8;
+unsigned int     len_01:8;
+unsigned int     len_00:8;
+}ISO_IRRCMM_TIMING;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     dec_by_min_max:1;
+}ISO_IR_CR1;
+
+typedef struct
+{
+unsigned int     rcmm_ap_max:8;
+unsigned int     rcmm_ap_min:8;
+unsigned int     rcmm_kb_max:8;
+unsigned int     rcmm_kb_min:8;
+}ISO_IRRCMM_APKB;
+
+typedef struct
+{
+unsigned int     rcmm_apoint:1;
+unsigned int     rcmm_kboard:1;
+unsigned int     remote_cnt_lead_high:14;
+unsigned int     remote_cnt_lead_low:16;
+}ISO_IRRXRCLFIFO;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     set:1;
+}ISO_DRM_ST;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_DRM_SECURE_CLK;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_DRM_ELAPSED;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST1;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST2;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     clk_div_en:1;
+unsigned int     clk_sel:1;
+}ISO_DRM_CTRL;
+
+typedef struct
+{
+unsigned int     init:32;
+}ISO_DRM_CLK_DIV;
+
+typedef struct
+{
+unsigned int     tc3tvr:32;
+}ISO_TC3TVR;
+
+typedef struct
+{
+unsigned int     tc3cvr:32;
+}ISO_TC3CVR;
+
+typedef struct
+{
+unsigned int     tc3en:1;
+unsigned int     tc3mode:1;
+unsigned int     tc3pause:1;
+unsigned int     rvda:5;
+unsigned int     reserved_0:24;
+}ISO_TC3CR;
+
+typedef struct
+{
+unsigned int     tc3ie:1;
+unsigned int     reserved_0:31;
+}ISO_TC3ICR;
+
+typedef struct
+{
+unsigned int     tc4tvr:32;
+}ISO_TC4TVR;
+
+typedef struct
+{
+unsigned int     tc4cvr:32;
+}ISO_TC4CVR;
+
+typedef struct
+{
+unsigned int     tc4en:1;
+unsigned int     tc4mode:1;
+unsigned int     tc4pause:1;
+unsigned int     rvda:5;
+unsigned int     reserved_0:24;
+}ISO_TC4CR;
+
+typedef struct
+{
+unsigned int     tc4ie:1;
+unsigned int     reserved_0:31;
+}ISO_TC4ICR;
+
+typedef struct
+{
+unsigned int     dat:32;
+}ISO_NORST;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST3;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST4;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST5;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST6;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST7;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST8;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST9;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST10;
+
+typedef struct
+{
+unsigned int     wd_int_en:1;
+unsigned int     reserved_0:15;
+unsigned int     nmic:4;
+unsigned int     wdc:4;
+unsigned int     wden:8;
+}ISO_TCWCR;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     wdclr:1;
+}ISO_TCWTR;
+
+typedef struct
+{
+unsigned int     sel:32;
+}ISO_TCWNMI;
+
+typedef struct
+{
+unsigned int     sel:32;
+}ISO_TCWOV;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     set:1;
+}ISO_DRM_ST_SWC;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_DRM_SECURE_CLK_SWC;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_DRM_ELAPSED_SWC;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     clk_div_en:1;
+unsigned int     clk_sel:1;
+}ISO_DRM_CTRL_SWC;
+
+typedef struct
+{
+unsigned int     init:32;
+}ISO_DRM_CLK_DIV_SWC;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST_SWC;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST1_SWC;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST2_SWC;
+
+typedef struct
+{
+unsigned int     val:32;
+}ISO_COLD_RST3_SWC;
+
+typedef struct
+{
+unsigned int     dat:32;
+}ISO_NORST_SWC;
+
+typedef struct
+{
+unsigned int     dat:32;
+}ISO_NORST1_SWC;
+
+typedef struct
+{
+unsigned int     dat:32;
+}ISO_NORST2_SWC;
+
+typedef struct
+{
+unsigned int     sel:32;
+}ISO_TCWOV_RSTB_CNT;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     dmy:1;
+unsigned int     oe:1;
+}ISO_TCWOV_RSTB_PAD;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     scpu_boot_info_valid:1;
+}ISO_CPU_ST2V;
+
+typedef struct
+{
+unsigned int     scpu_boot_info:32;
+}ISO_CPU_ST2;
+
+typedef struct
+{
+unsigned int     reserved_0:18;
+unsigned int     write_enable3:1;
+unsigned int     sel1:5;
+unsigned int     write_enable2:1;
+unsigned int     sel0:5;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}ISO_ACPU_DBG;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     analogy_mode_in:1;
+}ISO_ANLG;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     dll:8;
+}ISO_U0RBR_THR_DLL;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     dlh:8;
+}ISO_U0IER_DLH;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     fifo16:2;
+unsigned int     reserved_1:2;
+unsigned int     iid:4;
+}ISO_U0IIR_FCR;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     dlab:1;
+unsigned int     brk:1;
+unsigned int     reserved_1:1;
+unsigned int     eps:1;
+unsigned int     pen:1;
+unsigned int     stb:1;
+unsigned int     wls:2;
+}ISO_U0LCR;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     afce:1;
+unsigned int     loop:1;
+unsigned int     reserved_1:2;
+unsigned int     rts:1;
+unsigned int     dtr:1;
+}ISO_U0MCR;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     rfe:1;
+unsigned int     temt:1;
+unsigned int     thre:1;
+unsigned int     bi:1;
+unsigned int     fe:1;
+unsigned int     pe:1;
+unsigned int     oe:1;
+unsigned int     dr:1;
+}ISO_U0LSR;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     dcd:1;
+unsigned int     ri:1;
+unsigned int     dsr:1;
+unsigned int     cts:1;
+unsigned int     ddcd:1;
+unsigned int     teri:1;
+unsigned int     ddsr:1;
+unsigned int     dcts:1;
+}ISO_U0MSR;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     scr:8;
+}ISO_U0SCR;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     rbd:8;
+}ISO_U0SRBR;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     far:1;
+}ISO_U0FAR;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     far:8;
+}ISO_U0TFR;
+
+typedef struct
+{
+unsigned int     reserved_0:22;
+unsigned int     rffe:1;
+unsigned int     rfpf:1;
+unsigned int     rfwd:8;
+}ISO_U0RFW;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     busy:1;
+}ISO_U0USR;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     tfl:8;
+}ISO_U0TFL;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     rfl:8;
+}ISO_U0RFL;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     xfr:1;
+unsigned int     rfr:1;
+unsigned int     ur:1;
+}ISO_U0SRR;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     sbcr:1;
+}ISO_U0SBCR;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     sdmam:1;
+}ISO_U0SDMAM;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     sfe:1;
+}ISO_U0SFE;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     srt:2;
+}ISO_U0SRT;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     stet:2;
+}ISO_U0STET;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     htx:1;
+}ISO_U0HTX;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     dmasa:1;
+}ISO_U0DMASA;
+
+typedef struct
+{
+unsigned int     reserved_0:8;
+unsigned int     fifo_mode:8;
+unsigned int     reserved_1:2;
+unsigned int     dma_extra:1;
+unsigned int     uart_add_encoded_params:1;
+unsigned int     shadow:1;
+unsigned int     fifo_stat:1;
+unsigned int     fifo_access:1;
+unsigned int     additional_feat:1;
+unsigned int     sir_lp_mode:1;
+unsigned int     sir_mode:1;
+unsigned int     thre_mode:1;
+unsigned int     afce_mode:1;
+unsigned int     reserved_2:2;
+unsigned int     apb_data_width:2;
+}ISO_U0CPR;
+
+typedef struct
+{
+unsigned int     ucv:32;
+}ISO_U0UCV;
+
+typedef struct
+{
+unsigned int     ctr:32;
+}ISO_U0CTR;
+
+typedef struct
+{
+unsigned int     reserved_0:25;
+unsigned int     ic_slave_disable:1;
+unsigned int     ic_restart_en:1;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     ic_10bitaddr_slave:1;
+unsigned int     speed:2;
+unsigned int     master_mode:1;
+}ISO_IC0_CON;
+
+typedef struct
+{
+unsigned int     reserved_0:19;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     special:1;
+unsigned int     gc_or_start:1;
+unsigned int     ic_tar:10;
+}ISO_IC0_TAR;
+
+typedef struct
+{
+unsigned int     reserved_0:22;
+unsigned int     ic_sar:10;
+}ISO_IC0_SAR;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     ic_hs_mar:3;
+}ISO_IC0_HS_MADDR;
+
+typedef struct
+{
+unsigned int     reserved_0:21;
+unsigned int     restart:1;
+unsigned int     stop:1;
+unsigned int     cmd:1;
+unsigned int     dat:8;
+}ISO_IC0_DATA_CMD;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_hcnt:16;
+}ISO_IC0_SS_SCL_HCNT;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_lcnt:16;
+}ISO_IC0_SS_SCL_LCNT;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_hcnt:16;
+}ISO_IC0_FS_SCL_HCNT;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_lcnt:16;
+}ISO_IC0_FS_SCL_LCNT;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     r_gen_call:1;
+unsigned int     r_start_det:1;
+unsigned int     r_stop_det:1;
+unsigned int     r_activity:1;
+unsigned int     r_rx_done:1;
+unsigned int     r_tx_abrt:1;
+unsigned int     r_rd_req:1;
+unsigned int     r_tx_empty:1;
+unsigned int     r_tx_over:1;
+unsigned int     r_rx_full:1;
+unsigned int     r_rx_over:1;
+unsigned int     r_rx_under:1;
+}ISO_IC0_INTR_STAT;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     m_gen_call:1;
+unsigned int     m_start_det:1;
+unsigned int     m_stop_det:1;
+unsigned int     m_activity:1;
+unsigned int     m_rx_done:1;
+unsigned int     m_tx_abrt:1;
+unsigned int     m_rd_req:1;
+unsigned int     m_tx_empty:1;
+unsigned int     m_tx_over:1;
+unsigned int     m_rx_full:1;
+unsigned int     m_rx_over:1;
+unsigned int     m_rx_under:1;
+}ISO_IC0_INTR_MASK;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     gen_call:1;
+unsigned int     start_det:1;
+unsigned int     stop_det:1;
+unsigned int     activity:1;
+unsigned int     rx_done:1;
+unsigned int     tx_abrt:1;
+unsigned int     rd_req:1;
+unsigned int     tx_empty:1;
+unsigned int     tx_over:1;
+unsigned int     rx_full:1;
+unsigned int     rx_over:1;
+unsigned int     rx_under:1;
+}ISO_IC0_RAW_INTR_STAT;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     rx_tl:8;
+}ISO_IC0_RX_TL;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     tx_tl:8;
+}ISO_IC0_TX_TL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_intr:1;
+}ISO_IC0_CLR_INTR;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_under:1;
+}ISO_IC0_CLR_RX_UNDER;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_over:1;
+}ISO_IC0_CLR_RX_OVER;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_over:1;
+}ISO_IC0_CLR_TX_OVER;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rd_req:1;
+}ISO_IC0_CLR_RD_REQ;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_abrt:1;
+}ISO_IC0_CLR_TX_ABRT;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_done:1;
+}ISO_IC0_CLR_RX_DONE;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_activity:1;
+}ISO_IC0_CLR_ACTIVITY;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_stop_det:1;
+}ISO_IC0_CLR_STOP_DET;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_start_det:1;
+}ISO_IC0_CLR_START_DET;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_gen_call:1;
+}ISO_IC0_CLR_GEN_CALL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}ISO_IC0_ENABLE;
+
+typedef struct
+{
+unsigned int     reserved_0:25;
+unsigned int     slv_activity:1;
+unsigned int     mst_activity:1;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     activity:1;
+}ISO_IC0_STATUS;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     txflr:4;
+}ISO_IC0_TXFLR;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     rxflr:4;
+}ISO_IC0_RXFLR;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_sda_hold:16;
+}ISO_IC0_SDA_HOLD;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     abrt_slvrd_intx:1;
+unsigned int     abrt_slv_arblost:1;
+unsigned int     abrt_slvflush_txfifo:1;
+unsigned int     arb_lost:1;
+unsigned int     arb_master_dis:1;
+unsigned int     abrt_10b_rd_norstrt:1;
+unsigned int     abrt_sbyte_norstrt:1;
+unsigned int     abrt_hs_norstrt:1;
+unsigned int     abrt_sbyte_ackdet:1;
+unsigned int     abrt_hs_ackdet:1;
+unsigned int     abrt_gcall_read:1;
+unsigned int     abrt_gcall_noack:1;
+unsigned int     abrt_txdata_noack:1;
+unsigned int     abrt_10addr2_noack:1;
+unsigned int     abrt_10addr1_noack:1;
+unsigned int     abrt_7b_addr_noack:1;
+}ISO_IC0_TX_ABRT_SOURCE;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     nack:1;
+}ISO_IC0_SLV_DATA_NACK_ONLY;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     tdmae:1;
+unsigned int     rdmae:1;
+}ISO_IC0_DMA_CR;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     dmatdl:3;
+}ISO_IC0_DMA_TDLR;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     dmardl:4;
+}ISO_IC0_DMA_RDLR;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     sda_setup:8;
+}ISO_IC0_SDA_SETUP;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     ack_gen_call:1;
+}ISO_IC0_ACK_GENERAL_CALL;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     slv_rx_data_lost:1;
+unsigned int     slv_disabled_whi:1;
+unsigned int     ic_en:1;
+}ISO_IC0_ENABLE_STATUS;
+
+typedef struct
+{
+unsigned int     reserved_0:8;
+unsigned int     tx_buffer_depth:8;
+unsigned int     rx_buffer_depth:8;
+unsigned int     add_encoded_params:1;
+unsigned int     has_dma:1;
+unsigned int     intr_io:1;
+unsigned int     hc_count_values:1;
+unsigned int     max_speed_mode:2;
+unsigned int     apb_data_width:2;
+}ISO_IC0_COMP_PARAM_1;
+
+typedef struct
+{
+unsigned int     ic_comp_version:32;
+}ISO_IC0_COMP_VERSION;
+
+typedef struct
+{
+unsigned int     ic_comp_type:32;
+}ISO_IC0_COMP_TYPE;
+
+typedef struct
+{
+unsigned int     reserved_0:25;
+unsigned int     ic_slave_disable:1;
+unsigned int     ic_restart_en:1;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     ic_10bitaddr_slave:1;
+unsigned int     speed:2;
+unsigned int     master_mode:1;
+}ISO_IC1_CON;
+
+typedef struct
+{
+unsigned int     reserved_0:19;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     special:1;
+unsigned int     gc_or_start:1;
+unsigned int     ic_tar:10;
+}ISO_IC1_TAR;
+
+typedef struct
+{
+unsigned int     reserved_0:22;
+unsigned int     ic_sar:10;
+}ISO_IC1_SAR;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     ic_hs_mar:3;
+}ISO_IC1_HS_MADDR;
+
+typedef struct
+{
+unsigned int     reserved_0:21;
+unsigned int     restart:1;
+unsigned int     stop:1;
+unsigned int     cmd:1;
+unsigned int     dat:8;
+}ISO_IC1_DATA_CMD;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_hcnt:16;
+}ISO_IC1_SS_SCL_HCNT;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_lcnt:16;
+}ISO_IC1_SS_SCL_LCNT;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_hcnt:16;
+}ISO_IC1_FS_SCL_HCNT;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_lcnt:16;
+}ISO_IC1_FS_SCL_LCNT;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     r_gen_call:1;
+unsigned int     r_start_det:1;
+unsigned int     r_stop_det:1;
+unsigned int     r_activity:1;
+unsigned int     r_rx_done:1;
+unsigned int     r_tx_abrt:1;
+unsigned int     r_rd_req:1;
+unsigned int     r_tx_empty:1;
+unsigned int     r_tx_over:1;
+unsigned int     r_rx_full:1;
+unsigned int     r_rx_over:1;
+unsigned int     r_rx_under:1;
+}ISO_IC1_INTR_STAT;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     m_gen_call:1;
+unsigned int     m_start_det:1;
+unsigned int     m_stop_det:1;
+unsigned int     m_activity:1;
+unsigned int     m_rx_done:1;
+unsigned int     m_tx_abrt:1;
+unsigned int     m_rd_req:1;
+unsigned int     m_tx_empty:1;
+unsigned int     m_tx_over:1;
+unsigned int     m_rx_full:1;
+unsigned int     m_rx_over:1;
+unsigned int     m_rx_under:1;
+}ISO_IC1_INTR_MASK;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     gen_call:1;
+unsigned int     start_det:1;
+unsigned int     stop_det:1;
+unsigned int     activity:1;
+unsigned int     rx_done:1;
+unsigned int     tx_abrt:1;
+unsigned int     rd_req:1;
+unsigned int     tx_empty:1;
+unsigned int     tx_over:1;
+unsigned int     rx_full:1;
+unsigned int     rx_over:1;
+unsigned int     rx_under:1;
+}ISO_IC1_RAW_INTR_STAT;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     rx_tl:8;
+}ISO_IC1_RX_TL;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     tx_tl:8;
+}ISO_IC1_TX_TL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_intr:1;
+}ISO_IC1_CLR_INTR;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_under:1;
+}ISO_IC1_CLR_RX_UNDER;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_over:1;
+}ISO_IC1_CLR_RX_OVER;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_over:1;
+}ISO_IC1_CLR_TX_OVER;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rd_req:1;
+}ISO_IC1_CLR_RD_REQ;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_abrt:1;
+}ISO_IC1_CLR_TX_ABRT;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_done:1;
+}ISO_IC1_CLR_RX_DONE;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_activity:1;
+}ISO_IC1_CLR_ACTIVITY;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_stop_det:1;
+}ISO_IC1_CLR_STOP_DET;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_start_det:1;
+}ISO_IC1_CLR_START_DET;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_gen_call:1;
+}ISO_IC1_CLR_GEN_CALL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}ISO_IC1_ENABLE;
+
+typedef struct
+{
+unsigned int     reserved_0:25;
+unsigned int     slv_activity:1;
+unsigned int     mst_activity:1;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     activity:1;
+}ISO_IC1_STATUS;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     txflr:4;
+}ISO_IC1_TXFLR;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     rxflr:4;
+}ISO_IC1_RXFLR;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_sda_hold:16;
+}ISO_IC1_SDA_HOLD;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     abrt_slvrd_intx:1;
+unsigned int     abrt_slv_arblost:1;
+unsigned int     abrt_slvflush_txfifo:1;
+unsigned int     arb_lost:1;
+unsigned int     arb_master_dis:1;
+unsigned int     abrt_10b_rd_norstrt:1;
+unsigned int     abrt_sbyte_norstrt:1;
+unsigned int     abrt_hs_norstrt:1;
+unsigned int     abrt_sbyte_ackdet:1;
+unsigned int     abrt_hs_ackdet:1;
+unsigned int     abrt_gcall_read:1;
+unsigned int     abrt_gcall_noack:1;
+unsigned int     abrt_txdata_noack:1;
+unsigned int     abrt_10addr2_noack:1;
+unsigned int     abrt_10addr1_noack:1;
+unsigned int     abrt_7b_addr_noack:1;
+}ISO_IC1_TX_ABRT_SOURCE;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     nack:1;
+}ISO_IC1_SLV_DATA_NACK_ONLY;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     tdmae:1;
+unsigned int     rdmae:1;
+}ISO_IC1_DMA_CR;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     dmatdl:3;
+}ISO_IC1_DMA_TDLR;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     dmardl:4;
+}ISO_IC1_DMA_RDLR;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     sda_setup:8;
+}ISO_IC1_SDA_SETUP;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     ack_gen_call:1;
+}ISO_IC1_ACK_GENERAL_CALL;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     slv_rx_data_lost:1;
+unsigned int     slv_disabled_whi:1;
+unsigned int     ic_en:1;
+}ISO_IC1_ENABLE_STATUS;
+
+typedef struct
+{
+unsigned int     reserved_0:8;
+unsigned int     tx_buffer_depth:8;
+unsigned int     rx_buffer_depth:8;
+unsigned int     add_encoded_params:1;
+unsigned int     has_dma:1;
+unsigned int     intr_io:1;
+unsigned int     hc_count_values:1;
+unsigned int     max_speed_mode:2;
+unsigned int     apb_data_width:2;
+}ISO_IC1_COMP_PARAM_1;
+
+typedef struct
+{
+unsigned int     ic_comp_version:32;
+}ISO_IC1_COMP_VERSION;
+
+typedef struct
+{
+unsigned int     ic_comp_type:32;
+}ISO_IC1_COMP_TYPE;
+
+typedef struct
+{
+unsigned int     3:8;
+unsigned int     2:8;
+unsigned int     1:8;
+unsigned int     0:8;
+}ISO_PWM_OCD;
+
+typedef struct
+{
+unsigned int     3:8;
+unsigned int     2:8;
+unsigned int     1:8;
+unsigned int     0:8;
+}ISO_PWM_CD;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     3:4;
+unsigned int     2:4;
+unsigned int     1:4;
+unsigned int     0:4;
+}ISO_PWM_CSD;
+
+#endif
+
+#define ISO_ISR                                                                      0x98007000
+#define ISO_ISR_reg_addr                                                             "0xD8007000"
+#define ISO_ISR_reg                                                                  0xD8007000
+#define set_ISO_ISR_reg(data)   (*((volatile unsigned int*) ISO_ISR_reg)=data)
+#define get_ISO_ISR_reg   (*((volatile unsigned int*) ISO_ISR_reg))
+#define ISO_ISR_inst_adr                                                             "0x0000"
+#define ISO_ISR_inst                                                                 0x0000
+#define ISO_ISR_i2c1_req_int_shift                                                   (31)
+#define ISO_ISR_i2c1_req_int_mask                                                    (0x80000000)
+#define ISO_ISR_i2c1_req_int(data)                                                   (0x80000000&((data)<<31))
+#define ISO_ISR_i2c1_req_int_src(data)                                               ((0x80000000&(data))>>31)
+#define ISO_ISR_get_i2c1_req_int(data)                                               ((0x80000000&(data))>>31)
+#define ISO_ISR_porb_av_cen_int_shift                                                (30)
+#define ISO_ISR_porb_av_cen_int_mask                                                 (0x40000000)
+#define ISO_ISR_porb_av_cen_int(data)                                                (0x40000000&((data)<<30))
+#define ISO_ISR_porb_av_cen_int_src(data)                                            ((0x40000000&(data))>>30)
+#define ISO_ISR_get_porb_av_cen_int(data)                                            ((0x40000000&(data))>>30)
+#define ISO_ISR_porb_dv_cen_int_shift                                                (29)
+#define ISO_ISR_porb_dv_cen_int_mask                                                 (0x20000000)
+#define ISO_ISR_porb_dv_cen_int(data)                                                (0x20000000&((data)<<29))
+#define ISO_ISR_porb_dv_cen_int_src(data)                                            ((0x20000000&(data))>>29)
+#define ISO_ISR_get_porb_dv_cen_int(data)                                            ((0x20000000&(data))>>29)
+#define ISO_ISR_usb_int_shift                                                        (24)
+#define ISO_ISR_usb_int_mask                                                         (0x01000000)
+#define ISO_ISR_usb_int(data)                                                        (0x01000000&((data)<<24))
+#define ISO_ISR_usb_int_src(data)                                                    ((0x01000000&(data))>>24)
+#define ISO_ISR_get_usb_int(data)                                                    ((0x01000000&(data))>>24)
+#define ISO_ISR_etn_int_shift                                                        (23)
+#define ISO_ISR_etn_int_mask                                                         (0x00800000)
+#define ISO_ISR_etn_int(data)                                                        (0x00800000&((data)<<23))
+#define ISO_ISR_etn_int_src(data)                                                    ((0x00800000&(data))>>23)
+#define ISO_ISR_get_etn_int(data)                                                    ((0x00800000&(data))>>23)
+#define ISO_ISR_cbus_int_shift                                                       (22)
+#define ISO_ISR_cbus_int_mask                                                        (0x00400000)
+#define ISO_ISR_cbus_int(data)                                                       (0x00400000&((data)<<22))
+#define ISO_ISR_cbus_int_src(data)                                                   ((0x00400000&(data))>>22)
+#define ISO_ISR_get_cbus_int(data)                                                   ((0x00400000&(data))>>22)
+#define ISO_ISR_iso_misc_int_shift                                                   (21)
+#define ISO_ISR_iso_misc_int_mask                                                    (0x00200000)
+#define ISO_ISR_iso_misc_int(data)                                                   (0x00200000&((data)<<21))
+#define ISO_ISR_iso_misc_int_src(data)                                               ((0x00200000&(data))>>21)
+#define ISO_ISR_get_iso_misc_int(data)                                               ((0x00200000&(data))>>21)
+#define ISO_ISR_gpioda_int_shift                                                     (20)
+#define ISO_ISR_gpioda_int_mask                                                      (0x00100000)
+#define ISO_ISR_gpioda_int(data)                                                     (0x00100000&((data)<<20))
+#define ISO_ISR_gpioda_int_src(data)                                                 ((0x00100000&(data))>>20)
+#define ISO_ISR_get_gpioda_int(data)                                                 ((0x00100000&(data))>>20)
+#define ISO_ISR_gpioa_int_shift                                                      (19)
+#define ISO_ISR_gpioa_int_mask                                                       (0x00080000)
+#define ISO_ISR_gpioa_int(data)                                                      (0x00080000&((data)<<19))
+#define ISO_ISR_gpioa_int_src(data)                                                  ((0x00080000&(data))>>19)
+#define ISO_ISR_get_gpioa_int(data)                                                  ((0x00080000&(data))>>19)
+#define ISO_ISR_rtc_alarm_int_shift                                                  (13)
+#define ISO_ISR_rtc_alarm_int_mask                                                   (0x00002000)
+#define ISO_ISR_rtc_alarm_int(data)                                                  (0x00002000&((data)<<13))
+#define ISO_ISR_rtc_alarm_int_src(data)                                              ((0x00002000&(data))>>13)
+#define ISO_ISR_get_rtc_alarm_int(data)                                              ((0x00002000&(data))>>13)
+#define ISO_ISR_rtc_hsec_int_shift                                                   (12)
+#define ISO_ISR_rtc_hsec_int_mask                                                    (0x00001000)
+#define ISO_ISR_rtc_hsec_int(data)                                                   (0x00001000&((data)<<12))
+#define ISO_ISR_rtc_hsec_int_src(data)                                               ((0x00001000&(data))>>12)
+#define ISO_ISR_get_rtc_hsec_int(data)                                               ((0x00001000&(data))>>12)
+#define ISO_ISR_i2c1_int_shift                                                       (11)
+#define ISO_ISR_i2c1_int_mask                                                        (0x00000800)
+#define ISO_ISR_i2c1_int(data)                                                       (0x00000800&((data)<<11))
+#define ISO_ISR_i2c1_int_src(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_ISR_get_i2c1_int(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_ISR_tc4_int_shift                                                        (9)
+#define ISO_ISR_tc4_int_mask                                                         (0x00000200)
+#define ISO_ISR_tc4_int(data)                                                        (0x00000200&((data)<<9))
+#define ISO_ISR_tc4_int_src(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_ISR_get_tc4_int(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_ISR_i2c0_int_shift                                                       (8)
+#define ISO_ISR_i2c0_int_mask                                                        (0x00000100)
+#define ISO_ISR_i2c0_int(data)                                                       (0x00000100&((data)<<8))
+#define ISO_ISR_i2c0_int_src(data)                                                   ((0x00000100&(data))>>8)
+#define ISO_ISR_get_i2c0_int(data)                                                   ((0x00000100&(data))>>8)
+#define ISO_ISR_wdog_nmi_int_shift                                                   (7)
+#define ISO_ISR_wdog_nmi_int_mask                                                    (0x00000080)
+#define ISO_ISR_wdog_nmi_int(data)                                                   (0x00000080&((data)<<7))
+#define ISO_ISR_wdog_nmi_int_src(data)                                               ((0x00000080&(data))>>7)
+#define ISO_ISR_get_wdog_nmi_int(data)                                               ((0x00000080&(data))>>7)
+#define ISO_ISR_irda_int_shift                                                       (5)
+#define ISO_ISR_irda_int_mask                                                        (0x00000020)
+#define ISO_ISR_irda_int(data)                                                       (0x00000020&((data)<<5))
+#define ISO_ISR_irda_int_src(data)                                                   ((0x00000020&(data))>>5)
+#define ISO_ISR_get_irda_int(data)                                                   ((0x00000020&(data))>>5)
+#define ISO_ISR_ur0_int_shift                                                        (2)
+#define ISO_ISR_ur0_int_mask                                                         (0x00000004)
+#define ISO_ISR_ur0_int(data)                                                        (0x00000004&((data)<<2))
+#define ISO_ISR_ur0_int_src(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_ISR_get_ur0_int(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_ISR_tc3_int_shift                                                        (1)
+#define ISO_ISR_tc3_int_mask                                                         (0x00000002)
+#define ISO_ISR_tc3_int(data)                                                        (0x00000002&((data)<<1))
+#define ISO_ISR_tc3_int_src(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_ISR_get_tc3_int(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_ISR_write_data_shift                                                     (0)
+#define ISO_ISR_write_data_mask                                                      (0x00000001)
+#define ISO_ISR_write_data(data)                                                     (0x00000001&((data)<<0))
+#define ISO_ISR_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define ISO_ISR_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR                                                                 0x98007004
+#define ISO_UMSK_ISR_reg_addr                                                        "0xD8007004"
+#define ISO_UMSK_ISR_reg                                                             0xD8007004
+#define set_ISO_UMSK_ISR_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_reg)=data)
+#define get_ISO_UMSK_ISR_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_reg))
+#define ISO_UMSK_ISR_inst_adr                                                        "0x0001"
+#define ISO_UMSK_ISR_inst                                                            0x0001
+#define ISO_UMSK_ISR_i2c1_req_int_shift                                              (31)
+#define ISO_UMSK_ISR_i2c1_req_int_mask                                               (0x80000000)
+#define ISO_UMSK_ISR_i2c1_req_int(data)                                              (0x80000000&((data)<<31))
+#define ISO_UMSK_ISR_i2c1_req_int_src(data)                                          ((0x80000000&(data))>>31)
+#define ISO_UMSK_ISR_get_i2c1_req_int(data)                                          ((0x80000000&(data))>>31)
+#define ISO_UMSK_ISR_porb_av_cen_int_shift                                           (30)
+#define ISO_UMSK_ISR_porb_av_cen_int_mask                                            (0x40000000)
+#define ISO_UMSK_ISR_porb_av_cen_int(data)                                           (0x40000000&((data)<<30))
+#define ISO_UMSK_ISR_porb_av_cen_int_src(data)                                       ((0x40000000&(data))>>30)
+#define ISO_UMSK_ISR_get_porb_av_cen_int(data)                                       ((0x40000000&(data))>>30)
+#define ISO_UMSK_ISR_porb_dv_cen_int_shift                                           (29)
+#define ISO_UMSK_ISR_porb_dv_cen_int_mask                                            (0x20000000)
+#define ISO_UMSK_ISR_porb_dv_cen_int(data)                                           (0x20000000&((data)<<29))
+#define ISO_UMSK_ISR_porb_dv_cen_int_src(data)                                       ((0x20000000&(data))>>29)
+#define ISO_UMSK_ISR_get_porb_dv_cen_int(data)                                       ((0x20000000&(data))>>29)
+#define ISO_UMSK_ISR_gpioda_int_shift                                                (20)
+#define ISO_UMSK_ISR_gpioda_int_mask                                                 (0x00100000)
+#define ISO_UMSK_ISR_gpioda_int(data)                                                (0x00100000&((data)<<20))
+#define ISO_UMSK_ISR_gpioda_int_src(data)                                            ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_get_gpioda_int(data)                                            ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_gpioa_int_shift                                                 (19)
+#define ISO_UMSK_ISR_gpioa_int_mask                                                  (0x00080000)
+#define ISO_UMSK_ISR_gpioa_int(data)                                                 (0x00080000&((data)<<19))
+#define ISO_UMSK_ISR_gpioa_int_src(data)                                             ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_get_gpioa_int(data)                                             ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_rtc_alarm_int_shift                                             (13)
+#define ISO_UMSK_ISR_rtc_alarm_int_mask                                              (0x00002000)
+#define ISO_UMSK_ISR_rtc_alarm_int(data)                                             (0x00002000&((data)<<13))
+#define ISO_UMSK_ISR_rtc_alarm_int_src(data)                                         ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_get_rtc_alarm_int(data)                                         ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_rtc_hsec_int_shift                                              (12)
+#define ISO_UMSK_ISR_rtc_hsec_int_mask                                               (0x00001000)
+#define ISO_UMSK_ISR_rtc_hsec_int(data)                                              (0x00001000&((data)<<12))
+#define ISO_UMSK_ISR_rtc_hsec_int_src(data)                                          ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_get_rtc_hsec_int(data)                                          ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_tc4_int_shift                                                   (9)
+#define ISO_UMSK_ISR_tc4_int_mask                                                    (0x00000200)
+#define ISO_UMSK_ISR_tc4_int(data)                                                   (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_tc4_int_src(data)                                               ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_get_tc4_int(data)                                               ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_wdog_nmi_int_shift                                              (7)
+#define ISO_UMSK_ISR_wdog_nmi_int_mask                                               (0x00000080)
+#define ISO_UMSK_ISR_wdog_nmi_int(data)                                              (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_wdog_nmi_int_src(data)                                          ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_get_wdog_nmi_int(data)                                          ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_irda_int_shift                                                  (5)
+#define ISO_UMSK_ISR_irda_int_mask                                                   (0x00000020)
+#define ISO_UMSK_ISR_irda_int(data)                                                  (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_irda_int_src(data)                                              ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_get_irda_int(data)                                              ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_tc3_int_shift                                                   (1)
+#define ISO_UMSK_ISR_tc3_int_mask                                                    (0x00000002)
+#define ISO_UMSK_ISR_tc3_int(data)                                                   (0x00000002&((data)<<1))
+#define ISO_UMSK_ISR_tc3_int_src(data)                                               ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_get_tc3_int(data)                                               ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_write_data_shift                                                (0)
+#define ISO_UMSK_ISR_write_data_mask                                                 (0x00000001)
+#define ISO_UMSK_ISR_write_data(data)                                                (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_GPA0                                                            0x98007008
+#define ISO_UMSK_ISR_GPA0_reg_addr                                                   "0xD8007008"
+#define ISO_UMSK_ISR_GPA0_reg                                                        0xD8007008
+#define set_ISO_UMSK_ISR_GPA0_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_GPA0_reg)=data)
+#define get_ISO_UMSK_ISR_GPA0_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_GPA0_reg))
+#define ISO_UMSK_ISR_GPA0_inst_adr                                                   "0x0002"
+#define ISO_UMSK_ISR_GPA0_inst                                                       0x0002
+#define ISO_UMSK_ISR_GPA0_int30_a_shift                                              (31)
+#define ISO_UMSK_ISR_GPA0_int30_a_mask                                               (0x80000000)
+#define ISO_UMSK_ISR_GPA0_int30_a(data)                                              (0x80000000&((data)<<31))
+#define ISO_UMSK_ISR_GPA0_int30_a_src(data)                                          ((0x80000000&(data))>>31)
+#define ISO_UMSK_ISR_GPA0_get_int30_a(data)                                          ((0x80000000&(data))>>31)
+#define ISO_UMSK_ISR_GPA0_int29_a_shift                                              (30)
+#define ISO_UMSK_ISR_GPA0_int29_a_mask                                               (0x40000000)
+#define ISO_UMSK_ISR_GPA0_int29_a(data)                                              (0x40000000&((data)<<30))
+#define ISO_UMSK_ISR_GPA0_int29_a_src(data)                                          ((0x40000000&(data))>>30)
+#define ISO_UMSK_ISR_GPA0_get_int29_a(data)                                          ((0x40000000&(data))>>30)
+#define ISO_UMSK_ISR_GPA0_int28_a_shift                                              (29)
+#define ISO_UMSK_ISR_GPA0_int28_a_mask                                               (0x20000000)
+#define ISO_UMSK_ISR_GPA0_int28_a(data)                                              (0x20000000&((data)<<29))
+#define ISO_UMSK_ISR_GPA0_int28_a_src(data)                                          ((0x20000000&(data))>>29)
+#define ISO_UMSK_ISR_GPA0_get_int28_a(data)                                          ((0x20000000&(data))>>29)
+#define ISO_UMSK_ISR_GPA0_int27_a_shift                                              (28)
+#define ISO_UMSK_ISR_GPA0_int27_a_mask                                               (0x10000000)
+#define ISO_UMSK_ISR_GPA0_int27_a(data)                                              (0x10000000&((data)<<28))
+#define ISO_UMSK_ISR_GPA0_int27_a_src(data)                                          ((0x10000000&(data))>>28)
+#define ISO_UMSK_ISR_GPA0_get_int27_a(data)                                          ((0x10000000&(data))>>28)
+#define ISO_UMSK_ISR_GPA0_int26_a_shift                                              (27)
+#define ISO_UMSK_ISR_GPA0_int26_a_mask                                               (0x08000000)
+#define ISO_UMSK_ISR_GPA0_int26_a(data)                                              (0x08000000&((data)<<27))
+#define ISO_UMSK_ISR_GPA0_int26_a_src(data)                                          ((0x08000000&(data))>>27)
+#define ISO_UMSK_ISR_GPA0_get_int26_a(data)                                          ((0x08000000&(data))>>27)
+#define ISO_UMSK_ISR_GPA0_int25_a_shift                                              (26)
+#define ISO_UMSK_ISR_GPA0_int25_a_mask                                               (0x04000000)
+#define ISO_UMSK_ISR_GPA0_int25_a(data)                                              (0x04000000&((data)<<26))
+#define ISO_UMSK_ISR_GPA0_int25_a_src(data)                                          ((0x04000000&(data))>>26)
+#define ISO_UMSK_ISR_GPA0_get_int25_a(data)                                          ((0x04000000&(data))>>26)
+#define ISO_UMSK_ISR_GPA0_int24_a_shift                                              (25)
+#define ISO_UMSK_ISR_GPA0_int24_a_mask                                               (0x02000000)
+#define ISO_UMSK_ISR_GPA0_int24_a(data)                                              (0x02000000&((data)<<25))
+#define ISO_UMSK_ISR_GPA0_int24_a_src(data)                                          ((0x02000000&(data))>>25)
+#define ISO_UMSK_ISR_GPA0_get_int24_a(data)                                          ((0x02000000&(data))>>25)
+#define ISO_UMSK_ISR_GPA0_int23_a_shift                                              (24)
+#define ISO_UMSK_ISR_GPA0_int23_a_mask                                               (0x01000000)
+#define ISO_UMSK_ISR_GPA0_int23_a(data)                                              (0x01000000&((data)<<24))
+#define ISO_UMSK_ISR_GPA0_int23_a_src(data)                                          ((0x01000000&(data))>>24)
+#define ISO_UMSK_ISR_GPA0_get_int23_a(data)                                          ((0x01000000&(data))>>24)
+#define ISO_UMSK_ISR_GPA0_int22_a_shift                                              (23)
+#define ISO_UMSK_ISR_GPA0_int22_a_mask                                               (0x00800000)
+#define ISO_UMSK_ISR_GPA0_int22_a(data)                                              (0x00800000&((data)<<23))
+#define ISO_UMSK_ISR_GPA0_int22_a_src(data)                                          ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_GPA0_get_int22_a(data)                                          ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_GPA0_int21_a_shift                                              (22)
+#define ISO_UMSK_ISR_GPA0_int21_a_mask                                               (0x00400000)
+#define ISO_UMSK_ISR_GPA0_int21_a(data)                                              (0x00400000&((data)<<22))
+#define ISO_UMSK_ISR_GPA0_int21_a_src(data)                                          ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_GPA0_get_int21_a(data)                                          ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_GPA0_int20_a_shift                                              (21)
+#define ISO_UMSK_ISR_GPA0_int20_a_mask                                               (0x00200000)
+#define ISO_UMSK_ISR_GPA0_int20_a(data)                                              (0x00200000&((data)<<21))
+#define ISO_UMSK_ISR_GPA0_int20_a_src(data)                                          ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_GPA0_get_int20_a(data)                                          ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_GPA0_int19_a_shift                                              (20)
+#define ISO_UMSK_ISR_GPA0_int19_a_mask                                               (0x00100000)
+#define ISO_UMSK_ISR_GPA0_int19_a(data)                                              (0x00100000&((data)<<20))
+#define ISO_UMSK_ISR_GPA0_int19_a_src(data)                                          ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_GPA0_get_int19_a(data)                                          ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_GPA0_int18_a_shift                                              (19)
+#define ISO_UMSK_ISR_GPA0_int18_a_mask                                               (0x00080000)
+#define ISO_UMSK_ISR_GPA0_int18_a(data)                                              (0x00080000&((data)<<19))
+#define ISO_UMSK_ISR_GPA0_int18_a_src(data)                                          ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_GPA0_get_int18_a(data)                                          ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_GPA0_int17_a_shift                                              (18)
+#define ISO_UMSK_ISR_GPA0_int17_a_mask                                               (0x00040000)
+#define ISO_UMSK_ISR_GPA0_int17_a(data)                                              (0x00040000&((data)<<18))
+#define ISO_UMSK_ISR_GPA0_int17_a_src(data)                                          ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_GPA0_get_int17_a(data)                                          ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_GPA0_int16_a_shift                                              (17)
+#define ISO_UMSK_ISR_GPA0_int16_a_mask                                               (0x00020000)
+#define ISO_UMSK_ISR_GPA0_int16_a(data)                                              (0x00020000&((data)<<17))
+#define ISO_UMSK_ISR_GPA0_int16_a_src(data)                                          ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_GPA0_get_int16_a(data)                                          ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_GPA0_int15_a_shift                                              (16)
+#define ISO_UMSK_ISR_GPA0_int15_a_mask                                               (0x00010000)
+#define ISO_UMSK_ISR_GPA0_int15_a(data)                                              (0x00010000&((data)<<16))
+#define ISO_UMSK_ISR_GPA0_int15_a_src(data)                                          ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_GPA0_get_int15_a(data)                                          ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_GPA0_int14_a_shift                                              (15)
+#define ISO_UMSK_ISR_GPA0_int14_a_mask                                               (0x00008000)
+#define ISO_UMSK_ISR_GPA0_int14_a(data)                                              (0x00008000&((data)<<15))
+#define ISO_UMSK_ISR_GPA0_int14_a_src(data)                                          ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_GPA0_get_int14_a(data)                                          ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_GPA0_int13_a_shift                                              (14)
+#define ISO_UMSK_ISR_GPA0_int13_a_mask                                               (0x00004000)
+#define ISO_UMSK_ISR_GPA0_int13_a(data)                                              (0x00004000&((data)<<14))
+#define ISO_UMSK_ISR_GPA0_int13_a_src(data)                                          ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_GPA0_get_int13_a(data)                                          ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_GPA0_int12_a_shift                                              (13)
+#define ISO_UMSK_ISR_GPA0_int12_a_mask                                               (0x00002000)
+#define ISO_UMSK_ISR_GPA0_int12_a(data)                                              (0x00002000&((data)<<13))
+#define ISO_UMSK_ISR_GPA0_int12_a_src(data)                                          ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_GPA0_get_int12_a(data)                                          ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_GPA0_int11_a_shift                                              (12)
+#define ISO_UMSK_ISR_GPA0_int11_a_mask                                               (0x00001000)
+#define ISO_UMSK_ISR_GPA0_int11_a(data)                                              (0x00001000&((data)<<12))
+#define ISO_UMSK_ISR_GPA0_int11_a_src(data)                                          ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_GPA0_get_int11_a(data)                                          ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_GPA0_int10_a_shift                                              (11)
+#define ISO_UMSK_ISR_GPA0_int10_a_mask                                               (0x00000800)
+#define ISO_UMSK_ISR_GPA0_int10_a(data)                                              (0x00000800&((data)<<11))
+#define ISO_UMSK_ISR_GPA0_int10_a_src(data)                                          ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_GPA0_get_int10_a(data)                                          ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_GPA0_int9_a_shift                                               (10)
+#define ISO_UMSK_ISR_GPA0_int9_a_mask                                                (0x00000400)
+#define ISO_UMSK_ISR_GPA0_int9_a(data)                                               (0x00000400&((data)<<10))
+#define ISO_UMSK_ISR_GPA0_int9_a_src(data)                                           ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_GPA0_get_int9_a(data)                                           ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_GPA0_int8_a_shift                                               (9)
+#define ISO_UMSK_ISR_GPA0_int8_a_mask                                                (0x00000200)
+#define ISO_UMSK_ISR_GPA0_int8_a(data)                                               (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_GPA0_int8_a_src(data)                                           ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_GPA0_get_int8_a(data)                                           ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_GPA0_int7_a_shift                                               (8)
+#define ISO_UMSK_ISR_GPA0_int7_a_mask                                                (0x00000100)
+#define ISO_UMSK_ISR_GPA0_int7_a(data)                                               (0x00000100&((data)<<8))
+#define ISO_UMSK_ISR_GPA0_int7_a_src(data)                                           ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_GPA0_get_int7_a(data)                                           ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_GPA0_int6_a_shift                                               (7)
+#define ISO_UMSK_ISR_GPA0_int6_a_mask                                                (0x00000080)
+#define ISO_UMSK_ISR_GPA0_int6_a(data)                                               (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_GPA0_int6_a_src(data)                                           ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_GPA0_get_int6_a(data)                                           ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_GPA0_int5_a_shift                                               (6)
+#define ISO_UMSK_ISR_GPA0_int5_a_mask                                                (0x00000040)
+#define ISO_UMSK_ISR_GPA0_int5_a(data)                                               (0x00000040&((data)<<6))
+#define ISO_UMSK_ISR_GPA0_int5_a_src(data)                                           ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_GPA0_get_int5_a(data)                                           ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_GPA0_int4_a_shift                                               (5)
+#define ISO_UMSK_ISR_GPA0_int4_a_mask                                                (0x00000020)
+#define ISO_UMSK_ISR_GPA0_int4_a(data)                                               (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_GPA0_int4_a_src(data)                                           ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_GPA0_get_int4_a(data)                                           ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_GPA0_int3_a_shift                                               (4)
+#define ISO_UMSK_ISR_GPA0_int3_a_mask                                                (0x00000010)
+#define ISO_UMSK_ISR_GPA0_int3_a(data)                                               (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_GPA0_int3_a_src(data)                                           ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPA0_get_int3_a(data)                                           ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPA0_int2_a_shift                                               (3)
+#define ISO_UMSK_ISR_GPA0_int2_a_mask                                                (0x00000008)
+#define ISO_UMSK_ISR_GPA0_int2_a(data)                                               (0x00000008&((data)<<3))
+#define ISO_UMSK_ISR_GPA0_int2_a_src(data)                                           ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPA0_get_int2_a(data)                                           ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPA0_int1_a_shift                                               (2)
+#define ISO_UMSK_ISR_GPA0_int1_a_mask                                                (0x00000004)
+#define ISO_UMSK_ISR_GPA0_int1_a(data)                                               (0x00000004&((data)<<2))
+#define ISO_UMSK_ISR_GPA0_int1_a_src(data)                                           ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPA0_get_int1_a(data)                                           ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPA0_int0_a_shift                                               (1)
+#define ISO_UMSK_ISR_GPA0_int0_a_mask                                                (0x00000002)
+#define ISO_UMSK_ISR_GPA0_int0_a(data)                                               (0x00000002&((data)<<1))
+#define ISO_UMSK_ISR_GPA0_int0_a_src(data)                                           ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPA0_get_int0_a(data)                                           ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPA0_write_data_shift                                           (0)
+#define ISO_UMSK_ISR_GPA0_write_data_mask                                            (0x00000001)
+#define ISO_UMSK_ISR_GPA0_write_data(data)                                           (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_GPA0_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_GPA0_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_GPDA0                                                           0x9800700C
+#define ISO_UMSK_ISR_GPDA0_reg_addr                                                  "0xD800700C"
+#define ISO_UMSK_ISR_GPDA0_reg                                                       0xD800700C
+#define set_ISO_UMSK_ISR_GPDA0_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_GPDA0_reg)=data)
+#define get_ISO_UMSK_ISR_GPDA0_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_GPDA0_reg))
+#define ISO_UMSK_ISR_GPDA0_inst_adr                                                  "0x0003"
+#define ISO_UMSK_ISR_GPDA0_inst                                                      0x0003
+#define ISO_UMSK_ISR_GPDA0_int30_da_shift                                            (31)
+#define ISO_UMSK_ISR_GPDA0_int30_da_mask                                             (0x80000000)
+#define ISO_UMSK_ISR_GPDA0_int30_da(data)                                            (0x80000000&((data)<<31))
+#define ISO_UMSK_ISR_GPDA0_int30_da_src(data)                                        ((0x80000000&(data))>>31)
+#define ISO_UMSK_ISR_GPDA0_get_int30_da(data)                                        ((0x80000000&(data))>>31)
+#define ISO_UMSK_ISR_GPDA0_int29_da_shift                                            (30)
+#define ISO_UMSK_ISR_GPDA0_int29_da_mask                                             (0x40000000)
+#define ISO_UMSK_ISR_GPDA0_int29_da(data)                                            (0x40000000&((data)<<30))
+#define ISO_UMSK_ISR_GPDA0_int29_da_src(data)                                        ((0x40000000&(data))>>30)
+#define ISO_UMSK_ISR_GPDA0_get_int29_da(data)                                        ((0x40000000&(data))>>30)
+#define ISO_UMSK_ISR_GPDA0_int28_da_shift                                            (29)
+#define ISO_UMSK_ISR_GPDA0_int28_da_mask                                             (0x20000000)
+#define ISO_UMSK_ISR_GPDA0_int28_da(data)                                            (0x20000000&((data)<<29))
+#define ISO_UMSK_ISR_GPDA0_int28_da_src(data)                                        ((0x20000000&(data))>>29)
+#define ISO_UMSK_ISR_GPDA0_get_int28_da(data)                                        ((0x20000000&(data))>>29)
+#define ISO_UMSK_ISR_GPDA0_int27_da_shift                                            (28)
+#define ISO_UMSK_ISR_GPDA0_int27_da_mask                                             (0x10000000)
+#define ISO_UMSK_ISR_GPDA0_int27_da(data)                                            (0x10000000&((data)<<28))
+#define ISO_UMSK_ISR_GPDA0_int27_da_src(data)                                        ((0x10000000&(data))>>28)
+#define ISO_UMSK_ISR_GPDA0_get_int27_da(data)                                        ((0x10000000&(data))>>28)
+#define ISO_UMSK_ISR_GPDA0_int26_da_shift                                            (27)
+#define ISO_UMSK_ISR_GPDA0_int26_da_mask                                             (0x08000000)
+#define ISO_UMSK_ISR_GPDA0_int26_da(data)                                            (0x08000000&((data)<<27))
+#define ISO_UMSK_ISR_GPDA0_int26_da_src(data)                                        ((0x08000000&(data))>>27)
+#define ISO_UMSK_ISR_GPDA0_get_int26_da(data)                                        ((0x08000000&(data))>>27)
+#define ISO_UMSK_ISR_GPDA0_int25_da_shift                                            (26)
+#define ISO_UMSK_ISR_GPDA0_int25_da_mask                                             (0x04000000)
+#define ISO_UMSK_ISR_GPDA0_int25_da(data)                                            (0x04000000&((data)<<26))
+#define ISO_UMSK_ISR_GPDA0_int25_da_src(data)                                        ((0x04000000&(data))>>26)
+#define ISO_UMSK_ISR_GPDA0_get_int25_da(data)                                        ((0x04000000&(data))>>26)
+#define ISO_UMSK_ISR_GPDA0_int24_da_shift                                            (25)
+#define ISO_UMSK_ISR_GPDA0_int24_da_mask                                             (0x02000000)
+#define ISO_UMSK_ISR_GPDA0_int24_da(data)                                            (0x02000000&((data)<<25))
+#define ISO_UMSK_ISR_GPDA0_int24_da_src(data)                                        ((0x02000000&(data))>>25)
+#define ISO_UMSK_ISR_GPDA0_get_int24_da(data)                                        ((0x02000000&(data))>>25)
+#define ISO_UMSK_ISR_GPDA0_int23_da_shift                                            (24)
+#define ISO_UMSK_ISR_GPDA0_int23_da_mask                                             (0x01000000)
+#define ISO_UMSK_ISR_GPDA0_int23_da(data)                                            (0x01000000&((data)<<24))
+#define ISO_UMSK_ISR_GPDA0_int23_da_src(data)                                        ((0x01000000&(data))>>24)
+#define ISO_UMSK_ISR_GPDA0_get_int23_da(data)                                        ((0x01000000&(data))>>24)
+#define ISO_UMSK_ISR_GPDA0_int22_da_shift                                            (23)
+#define ISO_UMSK_ISR_GPDA0_int22_da_mask                                             (0x00800000)
+#define ISO_UMSK_ISR_GPDA0_int22_da(data)                                            (0x00800000&((data)<<23))
+#define ISO_UMSK_ISR_GPDA0_int22_da_src(data)                                        ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_GPDA0_get_int22_da(data)                                        ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_GPDA0_int21_da_shift                                            (22)
+#define ISO_UMSK_ISR_GPDA0_int21_da_mask                                             (0x00400000)
+#define ISO_UMSK_ISR_GPDA0_int21_da(data)                                            (0x00400000&((data)<<22))
+#define ISO_UMSK_ISR_GPDA0_int21_da_src(data)                                        ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_GPDA0_get_int21_da(data)                                        ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_GPDA0_int20_da_shift                                            (21)
+#define ISO_UMSK_ISR_GPDA0_int20_da_mask                                             (0x00200000)
+#define ISO_UMSK_ISR_GPDA0_int20_da(data)                                            (0x00200000&((data)<<21))
+#define ISO_UMSK_ISR_GPDA0_int20_da_src(data)                                        ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_GPDA0_get_int20_da(data)                                        ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_GPDA0_int19_da_shift                                            (20)
+#define ISO_UMSK_ISR_GPDA0_int19_da_mask                                             (0x00100000)
+#define ISO_UMSK_ISR_GPDA0_int19_da(data)                                            (0x00100000&((data)<<20))
+#define ISO_UMSK_ISR_GPDA0_int19_da_src(data)                                        ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_GPDA0_get_int19_da(data)                                        ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_GPDA0_int18_da_shift                                            (19)
+#define ISO_UMSK_ISR_GPDA0_int18_da_mask                                             (0x00080000)
+#define ISO_UMSK_ISR_GPDA0_int18_da(data)                                            (0x00080000&((data)<<19))
+#define ISO_UMSK_ISR_GPDA0_int18_da_src(data)                                        ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_GPDA0_get_int18_da(data)                                        ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_GPDA0_int17_da_shift                                            (18)
+#define ISO_UMSK_ISR_GPDA0_int17_da_mask                                             (0x00040000)
+#define ISO_UMSK_ISR_GPDA0_int17_da(data)                                            (0x00040000&((data)<<18))
+#define ISO_UMSK_ISR_GPDA0_int17_da_src(data)                                        ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_GPDA0_get_int17_da(data)                                        ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_GPDA0_int16_da_shift                                            (17)
+#define ISO_UMSK_ISR_GPDA0_int16_da_mask                                             (0x00020000)
+#define ISO_UMSK_ISR_GPDA0_int16_da(data)                                            (0x00020000&((data)<<17))
+#define ISO_UMSK_ISR_GPDA0_int16_da_src(data)                                        ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_GPDA0_get_int16_da(data)                                        ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_GPDA0_int15_da_shift                                            (16)
+#define ISO_UMSK_ISR_GPDA0_int15_da_mask                                             (0x00010000)
+#define ISO_UMSK_ISR_GPDA0_int15_da(data)                                            (0x00010000&((data)<<16))
+#define ISO_UMSK_ISR_GPDA0_int15_da_src(data)                                        ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_GPDA0_get_int15_da(data)                                        ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_GPDA0_int14_da_shift                                            (15)
+#define ISO_UMSK_ISR_GPDA0_int14_da_mask                                             (0x00008000)
+#define ISO_UMSK_ISR_GPDA0_int14_da(data)                                            (0x00008000&((data)<<15))
+#define ISO_UMSK_ISR_GPDA0_int14_da_src(data)                                        ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_GPDA0_get_int14_da(data)                                        ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_GPDA0_int13_da_shift                                            (14)
+#define ISO_UMSK_ISR_GPDA0_int13_da_mask                                             (0x00004000)
+#define ISO_UMSK_ISR_GPDA0_int13_da(data)                                            (0x00004000&((data)<<14))
+#define ISO_UMSK_ISR_GPDA0_int13_da_src(data)                                        ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_GPDA0_get_int13_da(data)                                        ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_GPDA0_int12_da_shift                                            (13)
+#define ISO_UMSK_ISR_GPDA0_int12_da_mask                                             (0x00002000)
+#define ISO_UMSK_ISR_GPDA0_int12_da(data)                                            (0x00002000&((data)<<13))
+#define ISO_UMSK_ISR_GPDA0_int12_da_src(data)                                        ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_GPDA0_get_int12_da(data)                                        ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_GPDA0_int11_da_shift                                            (12)
+#define ISO_UMSK_ISR_GPDA0_int11_da_mask                                             (0x00001000)
+#define ISO_UMSK_ISR_GPDA0_int11_da(data)                                            (0x00001000&((data)<<12))
+#define ISO_UMSK_ISR_GPDA0_int11_da_src(data)                                        ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_GPDA0_get_int11_da(data)                                        ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_GPDA0_int10_da_shift                                            (11)
+#define ISO_UMSK_ISR_GPDA0_int10_da_mask                                             (0x00000800)
+#define ISO_UMSK_ISR_GPDA0_int10_da(data)                                            (0x00000800&((data)<<11))
+#define ISO_UMSK_ISR_GPDA0_int10_da_src(data)                                        ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_GPDA0_get_int10_da(data)                                        ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_GPDA0_int9_da_shift                                             (10)
+#define ISO_UMSK_ISR_GPDA0_int9_da_mask                                              (0x00000400)
+#define ISO_UMSK_ISR_GPDA0_int9_da(data)                                             (0x00000400&((data)<<10))
+#define ISO_UMSK_ISR_GPDA0_int9_da_src(data)                                         ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_GPDA0_get_int9_da(data)                                         ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_GPDA0_int8_da_shift                                             (9)
+#define ISO_UMSK_ISR_GPDA0_int8_da_mask                                              (0x00000200)
+#define ISO_UMSK_ISR_GPDA0_int8_da(data)                                             (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_GPDA0_int8_da_src(data)                                         ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_GPDA0_get_int8_da(data)                                         ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_GPDA0_int7_da_shift                                             (8)
+#define ISO_UMSK_ISR_GPDA0_int7_da_mask                                              (0x00000100)
+#define ISO_UMSK_ISR_GPDA0_int7_da(data)                                             (0x00000100&((data)<<8))
+#define ISO_UMSK_ISR_GPDA0_int7_da_src(data)                                         ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_GPDA0_get_int7_da(data)                                         ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_GPDA0_int6_da_shift                                             (7)
+#define ISO_UMSK_ISR_GPDA0_int6_da_mask                                              (0x00000080)
+#define ISO_UMSK_ISR_GPDA0_int6_da(data)                                             (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_GPDA0_int6_da_src(data)                                         ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_GPDA0_get_int6_da(data)                                         ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_GPDA0_int5_da_shift                                             (6)
+#define ISO_UMSK_ISR_GPDA0_int5_da_mask                                              (0x00000040)
+#define ISO_UMSK_ISR_GPDA0_int5_da(data)                                             (0x00000040&((data)<<6))
+#define ISO_UMSK_ISR_GPDA0_int5_da_src(data)                                         ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_GPDA0_get_int5_da(data)                                         ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_GPDA0_int4_da_shift                                             (5)
+#define ISO_UMSK_ISR_GPDA0_int4_da_mask                                              (0x00000020)
+#define ISO_UMSK_ISR_GPDA0_int4_da(data)                                             (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_GPDA0_int4_da_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_GPDA0_get_int4_da(data)                                         ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_GPDA0_int3_da_shift                                             (4)
+#define ISO_UMSK_ISR_GPDA0_int3_da_mask                                              (0x00000010)
+#define ISO_UMSK_ISR_GPDA0_int3_da(data)                                             (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_GPDA0_int3_da_src(data)                                         ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPDA0_get_int3_da(data)                                         ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPDA0_int2_da_shift                                             (3)
+#define ISO_UMSK_ISR_GPDA0_int2_da_mask                                              (0x00000008)
+#define ISO_UMSK_ISR_GPDA0_int2_da(data)                                             (0x00000008&((data)<<3))
+#define ISO_UMSK_ISR_GPDA0_int2_da_src(data)                                         ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPDA0_get_int2_da(data)                                         ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPDA0_int1_da_shift                                             (2)
+#define ISO_UMSK_ISR_GPDA0_int1_da_mask                                              (0x00000004)
+#define ISO_UMSK_ISR_GPDA0_int1_da(data)                                             (0x00000004&((data)<<2))
+#define ISO_UMSK_ISR_GPDA0_int1_da_src(data)                                         ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPDA0_get_int1_da(data)                                         ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPDA0_int0_da_shift                                             (1)
+#define ISO_UMSK_ISR_GPDA0_int0_da_mask                                              (0x00000002)
+#define ISO_UMSK_ISR_GPDA0_int0_da(data)                                             (0x00000002&((data)<<1))
+#define ISO_UMSK_ISR_GPDA0_int0_da_src(data)                                         ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPDA0_get_int0_da(data)                                         ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPDA0_write_data_shift                                          (0)
+#define ISO_UMSK_ISR_GPDA0_write_data_mask                                           (0x00000001)
+#define ISO_UMSK_ISR_GPDA0_write_data(data)                                          (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_GPDA0_write_data_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_GPDA0_get_write_data(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_GPA1                                                            0x980070E0
+#define ISO_UMSK_ISR_GPA1_reg_addr                                                   "0xD80070E0"
+#define ISO_UMSK_ISR_GPA1_reg                                                        0xD80070E0
+#define set_ISO_UMSK_ISR_GPA1_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_GPA1_reg)=data)
+#define get_ISO_UMSK_ISR_GPA1_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_GPA1_reg))
+#define ISO_UMSK_ISR_GPA1_inst_adr                                                   "0x0038"
+#define ISO_UMSK_ISR_GPA1_inst                                                       0x0038
+#define ISO_UMSK_ISR_GPA1_int34_a_shift                                              (4)
+#define ISO_UMSK_ISR_GPA1_int34_a_mask                                               (0x00000010)
+#define ISO_UMSK_ISR_GPA1_int34_a(data)                                              (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_GPA1_int34_a_src(data)                                          ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPA1_get_int34_a(data)                                          ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPA1_int33_a_shift                                              (3)
+#define ISO_UMSK_ISR_GPA1_int33_a_mask                                               (0x00000008)
+#define ISO_UMSK_ISR_GPA1_int33_a(data)                                              (0x00000008&((data)<<3))
+#define ISO_UMSK_ISR_GPA1_int33_a_src(data)                                          ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPA1_get_int33_a(data)                                          ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPA1_int32_a_shift                                              (2)
+#define ISO_UMSK_ISR_GPA1_int32_a_mask                                               (0x00000004)
+#define ISO_UMSK_ISR_GPA1_int32_a(data)                                              (0x00000004&((data)<<2))
+#define ISO_UMSK_ISR_GPA1_int32_a_src(data)                                          ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPA1_get_int32_a(data)                                          ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPA1_int31_a_shift                                              (1)
+#define ISO_UMSK_ISR_GPA1_int31_a_mask                                               (0x00000002)
+#define ISO_UMSK_ISR_GPA1_int31_a(data)                                              (0x00000002&((data)<<1))
+#define ISO_UMSK_ISR_GPA1_int31_a_src(data)                                          ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPA1_get_int31_a(data)                                          ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPA1_write_data_shift                                           (0)
+#define ISO_UMSK_ISR_GPA1_write_data_mask                                            (0x00000001)
+#define ISO_UMSK_ISR_GPA1_write_data(data)                                           (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_GPA1_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_GPA1_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_GPDA1                                                           0x980070E4
+#define ISO_UMSK_ISR_GPDA1_reg_addr                                                  "0xD80070E4"
+#define ISO_UMSK_ISR_GPDA1_reg                                                       0xD80070E4
+#define set_ISO_UMSK_ISR_GPDA1_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_GPDA1_reg)=data)
+#define get_ISO_UMSK_ISR_GPDA1_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_GPDA1_reg))
+#define ISO_UMSK_ISR_GPDA1_inst_adr                                                  "0x0039"
+#define ISO_UMSK_ISR_GPDA1_inst                                                      0x0039
+#define ISO_UMSK_ISR_GPDA1_int34_da_shift                                            (4)
+#define ISO_UMSK_ISR_GPDA1_int34_da_mask                                             (0x00000010)
+#define ISO_UMSK_ISR_GPDA1_int34_da(data)                                            (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_GPDA1_int34_da_src(data)                                        ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPDA1_get_int34_da(data)                                        ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPDA1_int33_da_shift                                            (3)
+#define ISO_UMSK_ISR_GPDA1_int33_da_mask                                             (0x00000008)
+#define ISO_UMSK_ISR_GPDA1_int33_da(data)                                            (0x00000008&((data)<<3))
+#define ISO_UMSK_ISR_GPDA1_int33_da_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPDA1_get_int33_da(data)                                        ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPDA1_int32_da_shift                                            (2)
+#define ISO_UMSK_ISR_GPDA1_int32_da_mask                                             (0x00000004)
+#define ISO_UMSK_ISR_GPDA1_int32_da(data)                                            (0x00000004&((data)<<2))
+#define ISO_UMSK_ISR_GPDA1_int32_da_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPDA1_get_int32_da(data)                                        ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPDA1_int31_da_shift                                            (1)
+#define ISO_UMSK_ISR_GPDA1_int31_da_mask                                             (0x00000002)
+#define ISO_UMSK_ISR_GPDA1_int31_da(data)                                            (0x00000002&((data)<<1))
+#define ISO_UMSK_ISR_GPDA1_int31_da_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPDA1_get_int31_da(data)                                        ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPDA1_write_data_shift                                          (0)
+#define ISO_UMSK_ISR_GPDA1_write_data_mask                                           (0x00000001)
+#define ISO_UMSK_ISR_GPDA1_write_data(data)                                          (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_GPDA1_write_data_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_GPDA1_get_write_data(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_FAST_INT_EN_0                                                            0x98007010
+#define ISO_FAST_INT_EN_0_reg_addr                                                   "0xD8007010"
+#define ISO_FAST_INT_EN_0_reg                                                        0xD8007010
+#define set_ISO_FAST_INT_EN_0_reg(data)   (*((volatile unsigned int*) ISO_FAST_INT_EN_0_reg)=data)
+#define get_ISO_FAST_INT_EN_0_reg   (*((volatile unsigned int*) ISO_FAST_INT_EN_0_reg))
+#define ISO_FAST_INT_EN_0_inst_adr                                                   "0x0004"
+#define ISO_FAST_INT_EN_0_inst                                                       0x0004
+#define ISO_FAST_INT_EN_0_gp_int_shift                                               (1)
+#define ISO_FAST_INT_EN_0_gp_int_mask                                                (0xFFFFFFFE)
+#define ISO_FAST_INT_EN_0_gp_int(data)                                               (0xFFFFFFFE&((data)<<1))
+#define ISO_FAST_INT_EN_0_gp_int_src(data)                                           ((0xFFFFFFFE&(data))>>1)
+#define ISO_FAST_INT_EN_0_get_gp_int(data)                                           ((0xFFFFFFFE&(data))>>1)
+
+
+#define ISO_FAST_INT_EN_1                                                            0x98007014
+#define ISO_FAST_INT_EN_1_reg_addr                                                   "0xD8007014"
+#define ISO_FAST_INT_EN_1_reg                                                        0xD8007014
+#define set_ISO_FAST_INT_EN_1_reg(data)   (*((volatile unsigned int*) ISO_FAST_INT_EN_1_reg)=data)
+#define get_ISO_FAST_INT_EN_1_reg   (*((volatile unsigned int*) ISO_FAST_INT_EN_1_reg))
+#define ISO_FAST_INT_EN_1_inst_adr                                                   "0x0005"
+#define ISO_FAST_INT_EN_1_inst                                                       0x0005
+#define ISO_FAST_INT_EN_1_gp_int_shift                                               (1)
+#define ISO_FAST_INT_EN_1_gp_int_mask                                                (0x0000001E)
+#define ISO_FAST_INT_EN_1_gp_int(data)                                               (0x0000001E&((data)<<1))
+#define ISO_FAST_INT_EN_1_gp_int_src(data)                                           ((0x0000001E&(data))>>1)
+#define ISO_FAST_INT_EN_1_get_gp_int(data)                                           ((0x0000001E&(data))>>1)
+
+
+#define ISO_FAST_ISR                                                                 0x98007018
+#define ISO_FAST_ISR_reg_addr                                                        "0xD8007018"
+#define ISO_FAST_ISR_reg                                                             0xD8007018
+#define set_ISO_FAST_ISR_reg(data)   (*((volatile unsigned int*) ISO_FAST_ISR_reg)=data)
+#define get_ISO_FAST_ISR_reg   (*((volatile unsigned int*) ISO_FAST_ISR_reg))
+#define ISO_FAST_ISR_inst_adr                                                        "0x0006"
+#define ISO_FAST_ISR_inst                                                            0x0006
+#define ISO_FAST_ISR_gpioda_int_shift                                                (2)
+#define ISO_FAST_ISR_gpioda_int_mask                                                 (0x00000004)
+#define ISO_FAST_ISR_gpioda_int(data)                                                (0x00000004&((data)<<2))
+#define ISO_FAST_ISR_gpioda_int_src(data)                                            ((0x00000004&(data))>>2)
+#define ISO_FAST_ISR_get_gpioda_int(data)                                            ((0x00000004&(data))>>2)
+#define ISO_FAST_ISR_gpioa_int_shift                                                 (1)
+#define ISO_FAST_ISR_gpioa_int_mask                                                  (0x00000002)
+#define ISO_FAST_ISR_gpioa_int(data)                                                 (0x00000002&((data)<<1))
+#define ISO_FAST_ISR_gpioa_int_src(data)                                             ((0x00000002&(data))>>1)
+#define ISO_FAST_ISR_get_gpioa_int(data)                                             ((0x00000002&(data))>>1)
+#define ISO_FAST_ISR_write_data_shift                                                (0)
+#define ISO_FAST_ISR_write_data_mask                                                 (0x00000001)
+#define ISO_FAST_ISR_write_data(data)                                                (0x00000001&((data)<<0))
+#define ISO_FAST_ISR_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_FAST_ISR_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_RESERVED_USE_3                                                           0x9800701C
+#define ISO_RESERVED_USE_3_reg_addr                                                  "0xD800701C"
+#define ISO_RESERVED_USE_3_reg                                                       0xD800701C
+#define set_ISO_RESERVED_USE_3_reg(data)   (*((volatile unsigned int*) ISO_RESERVED_USE_3_reg)=data)
+#define get_ISO_RESERVED_USE_3_reg   (*((volatile unsigned int*) ISO_RESERVED_USE_3_reg))
+#define ISO_RESERVED_USE_3_inst_adr                                                  "0x0007"
+#define ISO_RESERVED_USE_3_inst                                                      0x0007
+#define ISO_RESERVED_USE_3_dmy_shift                                                 (0)
+#define ISO_RESERVED_USE_3_dmy_mask                                                  (0xFFFFFFFF)
+#define ISO_RESERVED_USE_3_dmy(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_RESERVED_USE_3_dmy_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_RESERVED_USE_3_get_dmy(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_REG_DBG                                                                  0x98007020
+#define ISO_REG_DBG_reg_addr                                                         "0xD8007020"
+#define ISO_REG_DBG_reg                                                              0xD8007020
+#define set_ISO_REG_DBG_reg(data)   (*((volatile unsigned int*) ISO_REG_DBG_reg)=data)
+#define get_ISO_REG_DBG_reg   (*((volatile unsigned int*) ISO_REG_DBG_reg))
+#define ISO_REG_DBG_inst_adr                                                         "0x0008"
+#define ISO_REG_DBG_inst                                                             0x0008
+#define ISO_REG_DBG_write_en2_shift                                                  (11)
+#define ISO_REG_DBG_write_en2_mask                                                   (0x00000800)
+#define ISO_REG_DBG_write_en2(data)                                                  (0x00000800&((data)<<11))
+#define ISO_REG_DBG_write_en2_src(data)                                              ((0x00000800&(data))>>11)
+#define ISO_REG_DBG_get_write_en2(data)                                              ((0x00000800&(data))>>11)
+#define ISO_REG_DBG_sel_shift                                                        (4)
+#define ISO_REG_DBG_sel_mask                                                         (0x000001F0)
+#define ISO_REG_DBG_sel(data)                                                        (0x000001F0&((data)<<4))
+#define ISO_REG_DBG_sel_src(data)                                                    ((0x000001F0&(data))>>4)
+#define ISO_REG_DBG_get_sel(data)                                                    ((0x000001F0&(data))>>4)
+#define ISO_REG_DBG_write_en1_shift                                                  (3)
+#define ISO_REG_DBG_write_en1_mask                                                   (0x00000008)
+#define ISO_REG_DBG_write_en1(data)                                                  (0x00000008&((data)<<3))
+#define ISO_REG_DBG_write_en1_src(data)                                              ((0x00000008&(data))>>3)
+#define ISO_REG_DBG_get_write_en1(data)                                              ((0x00000008&(data))>>3)
+#define ISO_REG_DBG_enable_shift                                                     (0)
+#define ISO_REG_DBG_enable_mask                                                      (0x00000001)
+#define ISO_REG_DBG_enable(data)                                                     (0x00000001&((data)<<0))
+#define ISO_REG_DBG_enable_src(data)                                                 ((0x00000001&(data))>>0)
+#define ISO_REG_DBG_get_enable(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define ISO_DBG                                                                      0x98007024
+#define ISO_DBG_reg_addr                                                             "0xD8007024"
+#define ISO_DBG_reg                                                                  0xD8007024
+#define set_ISO_DBG_reg(data)   (*((volatile unsigned int*) ISO_DBG_reg)=data)
+#define get_ISO_DBG_reg   (*((volatile unsigned int*) ISO_DBG_reg))
+#define ISO_DBG_inst_adr                                                             "0x0009"
+#define ISO_DBG_inst                                                                 0x0009
+#define ISO_DBG_write_en5_shift                                                      (31)
+#define ISO_DBG_write_en5_mask                                                       (0x80000000)
+#define ISO_DBG_write_en5(data)                                                      (0x80000000&((data)<<31))
+#define ISO_DBG_write_en5_src(data)                                                  ((0x80000000&(data))>>31)
+#define ISO_DBG_get_write_en5(data)                                                  ((0x80000000&(data))>>31)
+#define ISO_DBG_standby_dbg_sel_shift                                                (24)
+#define ISO_DBG_standby_dbg_sel_mask                                                 (0x7F000000)
+#define ISO_DBG_standby_dbg_sel(data)                                                (0x7F000000&((data)<<24))
+#define ISO_DBG_standby_dbg_sel_src(data)                                            ((0x7F000000&(data))>>24)
+#define ISO_DBG_get_standby_dbg_sel(data)                                            ((0x7F000000&(data))>>24)
+#define ISO_DBG_write_en4_shift                                                      (23)
+#define ISO_DBG_write_en4_mask                                                       (0x00800000)
+#define ISO_DBG_write_en4(data)                                                      (0x00800000&((data)<<23))
+#define ISO_DBG_write_en4_src(data)                                                  ((0x00800000&(data))>>23)
+#define ISO_DBG_get_write_en4(data)                                                  ((0x00800000&(data))>>23)
+#define ISO_DBG_standby_dbg_en_shift                                                 (20)
+#define ISO_DBG_standby_dbg_en_mask                                                  (0x00100000)
+#define ISO_DBG_standby_dbg_en(data)                                                 (0x00100000&((data)<<20))
+#define ISO_DBG_standby_dbg_en_src(data)                                             ((0x00100000&(data))>>20)
+#define ISO_DBG_get_standby_dbg_en(data)                                             ((0x00100000&(data))>>20)
+#define ISO_DBG_write_en3_shift                                                      (19)
+#define ISO_DBG_write_en3_mask                                                       (0x00080000)
+#define ISO_DBG_write_en3(data)                                                      (0x00080000&((data)<<19))
+#define ISO_DBG_write_en3_src(data)                                                  ((0x00080000&(data))>>19)
+#define ISO_DBG_get_write_en3(data)                                                  ((0x00080000&(data))>>19)
+#define ISO_DBG_sel1_shift                                                           (12)
+#define ISO_DBG_sel1_mask                                                            (0x0000F000)
+#define ISO_DBG_sel1(data)                                                           (0x0000F000&((data)<<12))
+#define ISO_DBG_sel1_src(data)                                                       ((0x0000F000&(data))>>12)
+#define ISO_DBG_get_sel1(data)                                                       ((0x0000F000&(data))>>12)
+#define ISO_DBG_write_en2_shift                                                      (11)
+#define ISO_DBG_write_en2_mask                                                       (0x00000800)
+#define ISO_DBG_write_en2(data)                                                      (0x00000800&((data)<<11))
+#define ISO_DBG_write_en2_src(data)                                                  ((0x00000800&(data))>>11)
+#define ISO_DBG_get_write_en2(data)                                                  ((0x00000800&(data))>>11)
+#define ISO_DBG_sel0_shift                                                           (4)
+#define ISO_DBG_sel0_mask                                                            (0x000000F0)
+#define ISO_DBG_sel0(data)                                                           (0x000000F0&((data)<<4))
+#define ISO_DBG_sel0_src(data)                                                       ((0x000000F0&(data))>>4)
+#define ISO_DBG_get_sel0(data)                                                       ((0x000000F0&(data))>>4)
+#define ISO_DBG_write_en1_shift                                                      (3)
+#define ISO_DBG_write_en1_mask                                                       (0x00000008)
+#define ISO_DBG_write_en1(data)                                                      (0x00000008&((data)<<3))
+#define ISO_DBG_write_en1_src(data)                                                  ((0x00000008&(data))>>3)
+#define ISO_DBG_get_write_en1(data)                                                  ((0x00000008&(data))>>3)
+#define ISO_DBG_enable_shift                                                         (0)
+#define ISO_DBG_enable_mask                                                          (0x00000001)
+#define ISO_DBG_enable(data)                                                         (0x00000001&((data)<<0))
+#define ISO_DBG_enable_src(data)                                                     ((0x00000001&(data))>>0)
+#define ISO_DBG_get_enable(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_CHIP_INFO1                                                               0x98007028
+#define ISO_CHIP_INFO1_reg_addr                                                      "0xD8007028"
+#define ISO_CHIP_INFO1_reg                                                           0xD8007028
+#define set_ISO_CHIP_INFO1_reg(data)   (*((volatile unsigned int*) ISO_CHIP_INFO1_reg)=data)
+#define get_ISO_CHIP_INFO1_reg   (*((volatile unsigned int*) ISO_CHIP_INFO1_reg))
+#define ISO_CHIP_INFO1_inst_adr                                                      "0x000A"
+#define ISO_CHIP_INFO1_inst                                                          0x000A
+#define ISO_CHIP_INFO1_testmode_shift                                                (15)
+#define ISO_CHIP_INFO1_testmode_mask                                                 (0x00008000)
+#define ISO_CHIP_INFO1_testmode(data)                                                (0x00008000&((data)<<15))
+#define ISO_CHIP_INFO1_testmode_src(data)                                            ((0x00008000&(data))>>15)
+#define ISO_CHIP_INFO1_get_testmode(data)                                            ((0x00008000&(data))>>15)
+#define ISO_CHIP_INFO1_boot_sel_shift                                                (14)
+#define ISO_CHIP_INFO1_boot_sel_mask                                                 (0x00004000)
+#define ISO_CHIP_INFO1_boot_sel(data)                                                (0x00004000&((data)<<14))
+#define ISO_CHIP_INFO1_boot_sel_src(data)                                            ((0x00004000&(data))>>14)
+#define ISO_CHIP_INFO1_get_boot_sel(data)                                            ((0x00004000&(data))>>14)
+#define ISO_CHIP_INFO1_bound_opt_shift                                               (0)
+#define ISO_CHIP_INFO1_bound_opt_mask                                                (0x00003FFF)
+#define ISO_CHIP_INFO1_bound_opt(data)                                               (0x00003FFF&((data)<<0))
+#define ISO_CHIP_INFO1_bound_opt_src(data)                                           ((0x00003FFF&(data))>>0)
+#define ISO_CHIP_INFO1_get_bound_opt(data)                                           ((0x00003FFF&(data))>>0)
+
+
+#define ISO_CHIP_INFO2                                                               0x9800702C
+#define ISO_CHIP_INFO2_reg_addr                                                      "0xD800702C"
+#define ISO_CHIP_INFO2_reg                                                           0xD800702C
+#define set_ISO_CHIP_INFO2_reg(data)   (*((volatile unsigned int*) ISO_CHIP_INFO2_reg)=data)
+#define get_ISO_CHIP_INFO2_reg   (*((volatile unsigned int*) ISO_CHIP_INFO2_reg))
+#define ISO_CHIP_INFO2_inst_adr                                                      "0x000B"
+#define ISO_CHIP_INFO2_inst                                                          0x000B
+#define ISO_CHIP_INFO2_pow_latch_shift                                               (0)
+#define ISO_CHIP_INFO2_pow_latch_mask                                                (0x03FFFFFF)
+#define ISO_CHIP_INFO2_pow_latch(data)                                               (0x03FFFFFF&((data)<<0))
+#define ISO_CHIP_INFO2_pow_latch_src(data)                                           ((0x03FFFFFF&(data))>>0)
+#define ISO_CHIP_INFO2_get_pow_latch(data)                                           ((0x03FFFFFF&(data))>>0)
+
+
+#define ISO_CHIP_INFO3                                                               0x98007340
+#define ISO_CHIP_INFO3_reg_addr                                                      "0xD8007340"
+#define ISO_CHIP_INFO3_reg                                                           0xD8007340
+#define set_ISO_CHIP_INFO3_reg(data)   (*((volatile unsigned int*) ISO_CHIP_INFO3_reg)=data)
+#define get_ISO_CHIP_INFO3_reg   (*((volatile unsigned int*) ISO_CHIP_INFO3_reg))
+#define ISO_CHIP_INFO3_inst_adr                                                      "0x00D0"
+#define ISO_CHIP_INFO3_inst                                                          0x00D0
+#define ISO_CHIP_INFO3_pow_latch_ori_shift                                           (0)
+#define ISO_CHIP_INFO3_pow_latch_ori_mask                                            (0x03FFFFFF)
+#define ISO_CHIP_INFO3_pow_latch_ori(data)                                           (0x03FFFFFF&((data)<<0))
+#define ISO_CHIP_INFO3_pow_latch_ori_src(data)                                       ((0x03FFFFFF&(data))>>0)
+#define ISO_CHIP_INFO3_get_pow_latch_ori(data)                                       ((0x03FFFFFF&(data))>>0)
+
+
+#define ISO_CTRL                                                                     0x98007030
+#define ISO_CTRL_reg_addr                                                            "0xD8007030"
+#define ISO_CTRL_reg                                                                 0xD8007030
+#define set_ISO_CTRL_reg(data)   (*((volatile unsigned int*) ISO_CTRL_reg)=data)
+#define get_ISO_CTRL_reg   (*((volatile unsigned int*) ISO_CTRL_reg))
+#define ISO_CTRL_inst_adr                                                            "0x000C"
+#define ISO_CTRL_inst                                                                0x000C
+#define ISO_CTRL_write_en9_shift                                                     (17)
+#define ISO_CTRL_write_en9_mask                                                      (0x00020000)
+#define ISO_CTRL_write_en9(data)                                                     (0x00020000&((data)<<17))
+#define ISO_CTRL_write_en9_src(data)                                                 ((0x00020000&(data))>>17)
+#define ISO_CTRL_get_write_en9(data)                                                 ((0x00020000&(data))>>17)
+#define ISO_CTRL_iso_rst_wd_mask_shift                                               (16)
+#define ISO_CTRL_iso_rst_wd_mask_mask                                                (0x00010000)
+#define ISO_CTRL_iso_rst_wd_mask(data)                                               (0x00010000&((data)<<16))
+#define ISO_CTRL_iso_rst_wd_mask_src(data)                                           ((0x00010000&(data))>>16)
+#define ISO_CTRL_get_iso_rst_wd_mask(data)                                           ((0x00010000&(data))>>16)
+#define ISO_CTRL_write_en8_shift                                                     (15)
+#define ISO_CTRL_write_en8_mask                                                      (0x00008000)
+#define ISO_CTRL_write_en8(data)                                                     (0x00008000&((data)<<15))
+#define ISO_CTRL_write_en8_src(data)                                                 ((0x00008000&(data))>>15)
+#define ISO_CTRL_get_write_en8(data)                                                 ((0x00008000&(data))>>15)
+#define ISO_CTRL_dc_phy_cke_pd_shift                                                 (14)
+#define ISO_CTRL_dc_phy_cke_pd_mask                                                  (0x00004000)
+#define ISO_CTRL_dc_phy_cke_pd(data)                                                 (0x00004000&((data)<<14))
+#define ISO_CTRL_dc_phy_cke_pd_src(data)                                             ((0x00004000&(data))>>14)
+#define ISO_CTRL_get_dc_phy_cke_pd(data)                                             ((0x00004000&(data))>>14)
+#define ISO_CTRL_write_en7_shift                                                     (13)
+#define ISO_CTRL_write_en7_mask                                                      (0x00002000)
+#define ISO_CTRL_write_en7(data)                                                     (0x00002000&((data)<<13))
+#define ISO_CTRL_write_en7_src(data)                                                 ((0x00002000&(data))>>13)
+#define ISO_CTRL_get_write_en7(data)                                                 ((0x00002000&(data))>>13)
+#define ISO_CTRL_iso_mis_clk_en_shift                                                (12)
+#define ISO_CTRL_iso_mis_clk_en_mask                                                 (0x00001000)
+#define ISO_CTRL_iso_mis_clk_en(data)                                                (0x00001000&((data)<<12))
+#define ISO_CTRL_iso_mis_clk_en_src(data)                                            ((0x00001000&(data))>>12)
+#define ISO_CTRL_get_iso_mis_clk_en(data)                                            ((0x00001000&(data))>>12)
+#define ISO_CTRL_write_en6_shift                                                     (11)
+#define ISO_CTRL_write_en6_mask                                                      (0x00000800)
+#define ISO_CTRL_write_en6(data)                                                     (0x00000800&((data)<<11))
+#define ISO_CTRL_write_en6_src(data)                                                 ((0x00000800&(data))>>11)
+#define ISO_CTRL_get_write_en6(data)                                                 ((0x00000800&(data))>>11)
+#define ISO_CTRL_iso_rbus_sel_shift                                                  (10)
+#define ISO_CTRL_iso_rbus_sel_mask                                                   (0x00000400)
+#define ISO_CTRL_iso_rbus_sel(data)                                                  (0x00000400&((data)<<10))
+#define ISO_CTRL_iso_rbus_sel_src(data)                                              ((0x00000400&(data))>>10)
+#define ISO_CTRL_get_iso_rbus_sel(data)                                              ((0x00000400&(data))>>10)
+#define ISO_CTRL_write_en5_shift                                                     (9)
+#define ISO_CTRL_write_en5_mask                                                      (0x00000200)
+#define ISO_CTRL_write_en5(data)                                                     (0x00000200&((data)<<9))
+#define ISO_CTRL_write_en5_src(data)                                                 ((0x00000200&(data))>>9)
+#define ISO_CTRL_get_write_en5(data)                                                 ((0x00000200&(data))>>9)
+#define ISO_CTRL_iso_rst_mask_shift                                                  (8)
+#define ISO_CTRL_iso_rst_mask_mask                                                   (0x00000100)
+#define ISO_CTRL_iso_rst_mask(data)                                                  (0x00000100&((data)<<8))
+#define ISO_CTRL_iso_rst_mask_src(data)                                              ((0x00000100&(data))>>8)
+#define ISO_CTRL_get_iso_rst_mask(data)                                              ((0x00000100&(data))>>8)
+#define ISO_CTRL_write_en4_shift                                                     (7)
+#define ISO_CTRL_write_en4_mask                                                      (0x00000080)
+#define ISO_CTRL_write_en4(data)                                                     (0x00000080&((data)<<7))
+#define ISO_CTRL_write_en4_src(data)                                                 ((0x00000080&(data))>>7)
+#define ISO_CTRL_get_write_en4(data)                                                 ((0x00000080&(data))>>7)
+#define ISO_CTRL_clk_osc_on_en_shift                                                 (6)
+#define ISO_CTRL_clk_osc_on_en_mask                                                  (0x00000040)
+#define ISO_CTRL_clk_osc_on_en(data)                                                 (0x00000040&((data)<<6))
+#define ISO_CTRL_clk_osc_on_en_src(data)                                             ((0x00000040&(data))>>6)
+#define ISO_CTRL_get_clk_osc_on_en(data)                                             ((0x00000040&(data))>>6)
+#define ISO_CTRL_write_en3_shift                                                     (5)
+#define ISO_CTRL_write_en3_mask                                                      (0x00000020)
+#define ISO_CTRL_write_en3(data)                                                     (0x00000020&((data)<<5))
+#define ISO_CTRL_write_en3_src(data)                                                 ((0x00000020&(data))>>5)
+#define ISO_CTRL_get_write_en3(data)                                                 ((0x00000020&(data))>>5)
+#define ISO_CTRL_crt_sw_rstn_shift                                                   (4)
+#define ISO_CTRL_crt_sw_rstn_mask                                                    (0x00000010)
+#define ISO_CTRL_crt_sw_rstn(data)                                                   (0x00000010&((data)<<4))
+#define ISO_CTRL_crt_sw_rstn_src(data)                                               ((0x00000010&(data))>>4)
+#define ISO_CTRL_get_crt_sw_rstn(data)                                               ((0x00000010&(data))>>4)
+#define ISO_CTRL_write_en2_shift                                                     (3)
+#define ISO_CTRL_write_en2_mask                                                      (0x00000008)
+#define ISO_CTRL_write_en2(data)                                                     (0x00000008&((data)<<3))
+#define ISO_CTRL_write_en2_src(data)                                                 ((0x00000008&(data))>>3)
+#define ISO_CTRL_get_write_en2(data)                                                 ((0x00000008&(data))>>3)
+#define ISO_CTRL_iso_clk_sel_shift                                                   (2)
+#define ISO_CTRL_iso_clk_sel_mask                                                    (0x00000004)
+#define ISO_CTRL_iso_clk_sel(data)                                                   (0x00000004&((data)<<2))
+#define ISO_CTRL_iso_clk_sel_src(data)                                               ((0x00000004&(data))>>2)
+#define ISO_CTRL_get_iso_clk_sel(data)                                               ((0x00000004&(data))>>2)
+#define ISO_CTRL_write_en1_shift                                                     (1)
+#define ISO_CTRL_write_en1_mask                                                      (0x00000002)
+#define ISO_CTRL_write_en1(data)                                                     (0x00000002&((data)<<1))
+#define ISO_CTRL_write_en1_src(data)                                                 ((0x00000002&(data))>>1)
+#define ISO_CTRL_get_write_en1(data)                                                 ((0x00000002&(data))>>1)
+#define ISO_CTRL_ejtag_en_shift                                                      (0)
+#define ISO_CTRL_ejtag_en_mask                                                       (0x00000001)
+#define ISO_CTRL_ejtag_en(data)                                                      (0x00000001&((data)<<0))
+#define ISO_CTRL_ejtag_en_src(data)                                                  ((0x00000001&(data))>>0)
+#define ISO_CTRL_get_ejtag_en(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_RTC                                                                      0x98007034
+#define ISO_RTC_reg_addr                                                             "0xD8007034"
+#define ISO_RTC_reg                                                                  0xD8007034
+#define set_ISO_RTC_reg(data)   (*((volatile unsigned int*) ISO_RTC_reg)=data)
+#define get_ISO_RTC_reg   (*((volatile unsigned int*) ISO_RTC_reg))
+#define ISO_RTC_inst_adr                                                             "0x000D"
+#define ISO_RTC_inst                                                                 0x000D
+#define ISO_RTC_hsec_sync_shift                                                      (2)
+#define ISO_RTC_hsec_sync_mask                                                       (0x00000004)
+#define ISO_RTC_hsec_sync(data)                                                      (0x00000004&((data)<<2))
+#define ISO_RTC_hsec_sync_src(data)                                                  ((0x00000004&(data))>>2)
+#define ISO_RTC_get_hsec_sync(data)                                                  ((0x00000004&(data))>>2)
+#define ISO_RTC_hsec_int_en_shift                                                    (1)
+#define ISO_RTC_hsec_int_en_mask                                                     (0x00000002)
+#define ISO_RTC_hsec_int_en(data)                                                    (0x00000002&((data)<<1))
+#define ISO_RTC_hsec_int_en_src(data)                                                ((0x00000002&(data))>>1)
+#define ISO_RTC_get_hsec_int_en(data)                                                ((0x00000002&(data))>>1)
+#define ISO_RTC_alarm_int_en_shift                                                   (0)
+#define ISO_RTC_alarm_int_en_mask                                                    (0x00000001)
+#define ISO_RTC_alarm_int_en(data)                                                   (0x00000001&((data)<<0))
+#define ISO_RTC_alarm_int_en_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_RTC_get_alarm_int_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_CELL                                                                     0x98007038
+#define ISO_CELL_reg_addr                                                            "0xD8007038"
+#define ISO_CELL_reg                                                                 0xD8007038
+#define set_ISO_CELL_reg(data)   (*((volatile unsigned int*) ISO_CELL_reg)=data)
+#define get_ISO_CELL_reg   (*((volatile unsigned int*) ISO_CELL_reg))
+#define ISO_CELL_inst_adr                                                            "0x000E"
+#define ISO_CELL_inst                                                                0x000E
+#define ISO_CELL_bi_bypass_shift                                                     (2)
+#define ISO_CELL_bi_bypass_mask                                                      (0x00000004)
+#define ISO_CELL_bi_bypass(data)                                                     (0x00000004&((data)<<2))
+#define ISO_CELL_bi_bypass_src(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_CELL_get_bi_bypass(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_CELL_iso_ctrl_en1_shift                                                  (1)
+#define ISO_CELL_iso_ctrl_en1_mask                                                   (0x00000002)
+#define ISO_CELL_iso_ctrl_en1(data)                                                  (0x00000002&((data)<<1))
+#define ISO_CELL_iso_ctrl_en1_src(data)                                              ((0x00000002&(data))>>1)
+#define ISO_CELL_get_iso_ctrl_en1(data)                                              ((0x00000002&(data))>>1)
+#define ISO_CELL_iso_ctrl_en0_shift                                                  (0)
+#define ISO_CELL_iso_ctrl_en0_mask                                                   (0x00000001)
+#define ISO_CELL_iso_ctrl_en0(data)                                                  (0x00000001&((data)<<0))
+#define ISO_CELL_iso_ctrl_en0_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_CELL_get_iso_ctrl_en0(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_POWER                                                                    0x9800703C
+#define ISO_POWER_reg_addr                                                           "0xD800703C"
+#define ISO_POWER_reg                                                                0xD800703C
+#define set_ISO_POWER_reg(data)   (*((volatile unsigned int*) ISO_POWER_reg)=data)
+#define get_ISO_POWER_reg   (*((volatile unsigned int*) ISO_POWER_reg))
+#define ISO_POWER_inst_adr                                                           "0x000F"
+#define ISO_POWER_inst                                                               0x000F
+#define ISO_POWER_top_vdd_on_shift                                                   (1)
+#define ISO_POWER_top_vdd_on_mask                                                    (0x00000002)
+#define ISO_POWER_top_vdd_on(data)                                                   (0x00000002&((data)<<1))
+#define ISO_POWER_top_vdd_on_src(data)                                               ((0x00000002&(data))>>1)
+#define ISO_POWER_get_top_vdd_on(data)                                               ((0x00000002&(data))>>1)
+#define ISO_POWER_scpu_vdd_on_shift                                                  (0)
+#define ISO_POWER_scpu_vdd_on_mask                                                   (0x00000001)
+#define ISO_POWER_scpu_vdd_on(data)                                                  (0x00000001&((data)<<0))
+#define ISO_POWER_scpu_vdd_on_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_POWER_get_scpu_vdd_on(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_SCPU_INT_EN                                                              0x98007040
+#define ISO_SCPU_INT_EN_reg_addr                                                     "0xD8007040"
+#define ISO_SCPU_INT_EN_reg                                                          0xD8007040
+#define set_ISO_SCPU_INT_EN_reg(data)   (*((volatile unsigned int*) ISO_SCPU_INT_EN_reg)=data)
+#define get_ISO_SCPU_INT_EN_reg   (*((volatile unsigned int*) ISO_SCPU_INT_EN_reg))
+#define ISO_SCPU_INT_EN_inst_adr                                                     "0x0010"
+#define ISO_SCPU_INT_EN_inst                                                         0x0010
+#define ISO_SCPU_INT_EN_i2c1_req_shift                                               (31)
+#define ISO_SCPU_INT_EN_i2c1_req_mask                                                (0x80000000)
+#define ISO_SCPU_INT_EN_i2c1_req(data)                                               (0x80000000&((data)<<31))
+#define ISO_SCPU_INT_EN_i2c1_req_src(data)                                           ((0x80000000&(data))>>31)
+#define ISO_SCPU_INT_EN_get_i2c1_req(data)                                           ((0x80000000&(data))>>31)
+#define ISO_SCPU_INT_EN_porb_av_cen_shift                                            (30)
+#define ISO_SCPU_INT_EN_porb_av_cen_mask                                             (0x40000000)
+#define ISO_SCPU_INT_EN_porb_av_cen(data)                                            (0x40000000&((data)<<30))
+#define ISO_SCPU_INT_EN_porb_av_cen_src(data)                                        ((0x40000000&(data))>>30)
+#define ISO_SCPU_INT_EN_get_porb_av_cen(data)                                        ((0x40000000&(data))>>30)
+#define ISO_SCPU_INT_EN_porb_dv_cen_shift                                            (29)
+#define ISO_SCPU_INT_EN_porb_dv_cen_mask                                             (0x20000000)
+#define ISO_SCPU_INT_EN_porb_dv_cen(data)                                            (0x20000000&((data)<<29))
+#define ISO_SCPU_INT_EN_porb_dv_cen_src(data)                                        ((0x20000000&(data))>>29)
+#define ISO_SCPU_INT_EN_get_porb_dv_cen(data)                                        ((0x20000000&(data))>>29)
+#define ISO_SCPU_INT_EN_gpioda_shift                                                 (20)
+#define ISO_SCPU_INT_EN_gpioda_mask                                                  (0x00100000)
+#define ISO_SCPU_INT_EN_gpioda(data)                                                 (0x00100000&((data)<<20))
+#define ISO_SCPU_INT_EN_gpioda_src(data)                                             ((0x00100000&(data))>>20)
+#define ISO_SCPU_INT_EN_get_gpioda(data)                                             ((0x00100000&(data))>>20)
+#define ISO_SCPU_INT_EN_gpioa_shift                                                  (19)
+#define ISO_SCPU_INT_EN_gpioa_mask                                                   (0x00080000)
+#define ISO_SCPU_INT_EN_gpioa(data)                                                  (0x00080000&((data)<<19))
+#define ISO_SCPU_INT_EN_gpioa_src(data)                                              ((0x00080000&(data))>>19)
+#define ISO_SCPU_INT_EN_get_gpioa(data)                                              ((0x00080000&(data))>>19)
+#define ISO_SCPU_INT_EN_rtc_alarm_shift                                              (13)
+#define ISO_SCPU_INT_EN_rtc_alarm_mask                                               (0x00002000)
+#define ISO_SCPU_INT_EN_rtc_alarm(data)                                              (0x00002000&((data)<<13))
+#define ISO_SCPU_INT_EN_rtc_alarm_src(data)                                          ((0x00002000&(data))>>13)
+#define ISO_SCPU_INT_EN_get_rtc_alarm(data)                                          ((0x00002000&(data))>>13)
+#define ISO_SCPU_INT_EN_rtc_hsec_shift                                               (12)
+#define ISO_SCPU_INT_EN_rtc_hsec_mask                                                (0x00001000)
+#define ISO_SCPU_INT_EN_rtc_hsec(data)                                               (0x00001000&((data)<<12))
+#define ISO_SCPU_INT_EN_rtc_hsec_src(data)                                           ((0x00001000&(data))>>12)
+#define ISO_SCPU_INT_EN_get_rtc_hsec(data)                                           ((0x00001000&(data))>>12)
+#define ISO_SCPU_INT_EN_i2c1_shift                                                   (11)
+#define ISO_SCPU_INT_EN_i2c1_mask                                                    (0x00000800)
+#define ISO_SCPU_INT_EN_i2c1(data)                                                   (0x00000800&((data)<<11))
+#define ISO_SCPU_INT_EN_i2c1_src(data)                                               ((0x00000800&(data))>>11)
+#define ISO_SCPU_INT_EN_get_i2c1(data)                                               ((0x00000800&(data))>>11)
+#define ISO_SCPU_INT_EN_i2c0_shift                                                   (8)
+#define ISO_SCPU_INT_EN_i2c0_mask                                                    (0x00000100)
+#define ISO_SCPU_INT_EN_i2c0(data)                                                   (0x00000100&((data)<<8))
+#define ISO_SCPU_INT_EN_i2c0_src(data)                                               ((0x00000100&(data))>>8)
+#define ISO_SCPU_INT_EN_get_i2c0(data)                                               ((0x00000100&(data))>>8)
+#define ISO_SCPU_INT_EN_irda_shift                                                   (5)
+#define ISO_SCPU_INT_EN_irda_mask                                                    (0x00000020)
+#define ISO_SCPU_INT_EN_irda(data)                                                   (0x00000020&((data)<<5))
+#define ISO_SCPU_INT_EN_irda_src(data)                                               ((0x00000020&(data))>>5)
+#define ISO_SCPU_INT_EN_get_irda(data)                                               ((0x00000020&(data))>>5)
+#define ISO_SCPU_INT_EN_ur0_shift                                                    (2)
+#define ISO_SCPU_INT_EN_ur0_mask                                                     (0x00000004)
+#define ISO_SCPU_INT_EN_ur0(data)                                                    (0x00000004&((data)<<2))
+#define ISO_SCPU_INT_EN_ur0_src(data)                                                ((0x00000004&(data))>>2)
+#define ISO_SCPU_INT_EN_get_ur0(data)                                                ((0x00000004&(data))>>2)
+
+
+#define ISO_USB                                                                      0x98007044
+#define ISO_USB_reg_addr                                                             "0xD8007044"
+#define ISO_USB_reg                                                                  0xD8007044
+#define set_ISO_USB_reg(data)   (*((volatile unsigned int*) ISO_USB_reg)=data)
+#define get_ISO_USB_reg   (*((volatile unsigned int*) ISO_USB_reg))
+#define ISO_USB_inst_adr                                                             "0x0011"
+#define ISO_USB_inst                                                                 0x0011
+#define ISO_USB_dcp_ctrl3_shift                                                      (3)
+#define ISO_USB_dcp_ctrl3_mask                                                       (0x00000008)
+#define ISO_USB_dcp_ctrl3(data)                                                      (0x00000008&((data)<<3))
+#define ISO_USB_dcp_ctrl3_src(data)                                                  ((0x00000008&(data))>>3)
+#define ISO_USB_get_dcp_ctrl3(data)                                                  ((0x00000008&(data))>>3)
+#define ISO_USB_dcp_ctrl2_shift                                                      (2)
+#define ISO_USB_dcp_ctrl2_mask                                                       (0x00000004)
+#define ISO_USB_dcp_ctrl2(data)                                                      (0x00000004&((data)<<2))
+#define ISO_USB_dcp_ctrl2_src(data)                                                  ((0x00000004&(data))>>2)
+#define ISO_USB_get_dcp_ctrl2(data)                                                  ((0x00000004&(data))>>2)
+#define ISO_USB_dcp_ctrl1_shift                                                      (1)
+#define ISO_USB_dcp_ctrl1_mask                                                       (0x00000002)
+#define ISO_USB_dcp_ctrl1(data)                                                      (0x00000002&((data)<<1))
+#define ISO_USB_dcp_ctrl1_src(data)                                                  ((0x00000002&(data))>>1)
+#define ISO_USB_get_dcp_ctrl1(data)                                                  ((0x00000002&(data))>>1)
+#define ISO_USB_dcp_ctrl0_shift                                                      (0)
+#define ISO_USB_dcp_ctrl0_mask                                                       (0x00000001)
+#define ISO_USB_dcp_ctrl0(data)                                                      (0x00000001&((data)<<0))
+#define ISO_USB_dcp_ctrl0_src(data)                                                  ((0x00000001&(data))>>0)
+#define ISO_USB_get_dcp_ctrl0(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_ACPU_INT_EN                                                              0x98007048
+#define ISO_ACPU_INT_EN_reg_addr                                                     "0xD8007048"
+#define ISO_ACPU_INT_EN_reg                                                          0xD8007048
+#define set_ISO_ACPU_INT_EN_reg(data)   (*((volatile unsigned int*) ISO_ACPU_INT_EN_reg)=data)
+#define get_ISO_ACPU_INT_EN_reg   (*((volatile unsigned int*) ISO_ACPU_INT_EN_reg))
+#define ISO_ACPU_INT_EN_inst_adr                                                     "0x0012"
+#define ISO_ACPU_INT_EN_inst                                                         0x0012
+#define ISO_ACPU_INT_EN_i2c1_req_shift                                               (31)
+#define ISO_ACPU_INT_EN_i2c1_req_mask                                                (0x80000000)
+#define ISO_ACPU_INT_EN_i2c1_req(data)                                               (0x80000000&((data)<<31))
+#define ISO_ACPU_INT_EN_i2c1_req_src(data)                                           ((0x80000000&(data))>>31)
+#define ISO_ACPU_INT_EN_get_i2c1_req(data)                                           ((0x80000000&(data))>>31)
+#define ISO_ACPU_INT_EN_gpioda_shift                                                 (20)
+#define ISO_ACPU_INT_EN_gpioda_mask                                                  (0x00100000)
+#define ISO_ACPU_INT_EN_gpioda(data)                                                 (0x00100000&((data)<<20))
+#define ISO_ACPU_INT_EN_gpioda_src(data)                                             ((0x00100000&(data))>>20)
+#define ISO_ACPU_INT_EN_get_gpioda(data)                                             ((0x00100000&(data))>>20)
+#define ISO_ACPU_INT_EN_gpioa_shift                                                  (19)
+#define ISO_ACPU_INT_EN_gpioa_mask                                                   (0x00080000)
+#define ISO_ACPU_INT_EN_gpioa(data)                                                  (0x00080000&((data)<<19))
+#define ISO_ACPU_INT_EN_gpioa_src(data)                                              ((0x00080000&(data))>>19)
+#define ISO_ACPU_INT_EN_get_gpioa(data)                                              ((0x00080000&(data))>>19)
+#define ISO_ACPU_INT_EN_rtc_alarm_shift                                              (13)
+#define ISO_ACPU_INT_EN_rtc_alarm_mask                                               (0x00002000)
+#define ISO_ACPU_INT_EN_rtc_alarm(data)                                              (0x00002000&((data)<<13))
+#define ISO_ACPU_INT_EN_rtc_alarm_src(data)                                          ((0x00002000&(data))>>13)
+#define ISO_ACPU_INT_EN_get_rtc_alarm(data)                                          ((0x00002000&(data))>>13)
+#define ISO_ACPU_INT_EN_rtc_hsec_shift                                               (12)
+#define ISO_ACPU_INT_EN_rtc_hsec_mask                                                (0x00001000)
+#define ISO_ACPU_INT_EN_rtc_hsec(data)                                               (0x00001000&((data)<<12))
+#define ISO_ACPU_INT_EN_rtc_hsec_src(data)                                           ((0x00001000&(data))>>12)
+#define ISO_ACPU_INT_EN_get_rtc_hsec(data)                                           ((0x00001000&(data))>>12)
+#define ISO_ACPU_INT_EN_i2c1_shift                                                   (11)
+#define ISO_ACPU_INT_EN_i2c1_mask                                                    (0x00000800)
+#define ISO_ACPU_INT_EN_i2c1(data)                                                   (0x00000800&((data)<<11))
+#define ISO_ACPU_INT_EN_i2c1_src(data)                                               ((0x00000800&(data))>>11)
+#define ISO_ACPU_INT_EN_get_i2c1(data)                                               ((0x00000800&(data))>>11)
+#define ISO_ACPU_INT_EN_i2c0_shift                                                   (8)
+#define ISO_ACPU_INT_EN_i2c0_mask                                                    (0x00000100)
+#define ISO_ACPU_INT_EN_i2c0(data)                                                   (0x00000100&((data)<<8))
+#define ISO_ACPU_INT_EN_i2c0_src(data)                                               ((0x00000100&(data))>>8)
+#define ISO_ACPU_INT_EN_get_i2c0(data)                                               ((0x00000100&(data))>>8)
+#define ISO_ACPU_INT_EN_irda_shift                                                   (5)
+#define ISO_ACPU_INT_EN_irda_mask                                                    (0x00000020)
+#define ISO_ACPU_INT_EN_irda(data)                                                   (0x00000020&((data)<<5))
+#define ISO_ACPU_INT_EN_irda_src(data)                                               ((0x00000020&(data))>>5)
+#define ISO_ACPU_INT_EN_get_irda(data)                                               ((0x00000020&(data))>>5)
+#define ISO_ACPU_INT_EN_ur0_shift                                                    (2)
+#define ISO_ACPU_INT_EN_ur0_mask                                                     (0x00000004)
+#define ISO_ACPU_INT_EN_ur0(data)                                                    (0x00000004&((data)<<2))
+#define ISO_ACPU_INT_EN_ur0_src(data)                                                ((0x00000004&(data))>>2)
+#define ISO_ACPU_INT_EN_get_ur0(data)                                                ((0x00000004&(data))>>2)
+
+
+#define ISO_CPU_ST1                                                                  0x9800704C
+#define ISO_CPU_ST1_reg_addr                                                         "0xD800704C"
+#define ISO_CPU_ST1_reg                                                              0xD800704C
+#define set_ISO_CPU_ST1_reg(data)   (*((volatile unsigned int*) ISO_CPU_ST1_reg)=data)
+#define get_ISO_CPU_ST1_reg   (*((volatile unsigned int*) ISO_CPU_ST1_reg))
+#define ISO_CPU_ST1_inst_adr                                                         "0x0013"
+#define ISO_CPU_ST1_inst                                                             0x0013
+#define ISO_CPU_ST1_acpu_boot_info_shift                                             (0)
+#define ISO_CPU_ST1_acpu_boot_info_mask                                              (0xFFFFFFFF)
+#define ISO_CPU_ST1_acpu_boot_info(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ISO_CPU_ST1_acpu_boot_info_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ISO_CPU_ST1_get_acpu_boot_info(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_CPU_ST1V                                                                 0x98007050
+#define ISO_CPU_ST1V_reg_addr                                                        "0xD8007050"
+#define ISO_CPU_ST1V_reg                                                             0xD8007050
+#define set_ISO_CPU_ST1V_reg(data)   (*((volatile unsigned int*) ISO_CPU_ST1V_reg)=data)
+#define get_ISO_CPU_ST1V_reg   (*((volatile unsigned int*) ISO_CPU_ST1V_reg))
+#define ISO_CPU_ST1V_inst_adr                                                        "0x0014"
+#define ISO_CPU_ST1V_inst                                                            0x0014
+#define ISO_CPU_ST1V_acpu_boot_info_valid_shift                                      (0)
+#define ISO_CPU_ST1V_acpu_boot_info_valid_mask                                       (0x00000001)
+#define ISO_CPU_ST1V_acpu_boot_info_valid(data)                                      (0x00000001&((data)<<0))
+#define ISO_CPU_ST1V_acpu_boot_info_valid_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_CPU_ST1V_get_acpu_boot_info_valid(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_DUMMY1                                                                   0x98007054
+#define ISO_DUMMY1_reg_addr                                                          "0xD8007054"
+#define ISO_DUMMY1_reg                                                               0xD8007054
+#define set_ISO_DUMMY1_reg(data)   (*((volatile unsigned int*) ISO_DUMMY1_reg)=data)
+#define get_ISO_DUMMY1_reg   (*((volatile unsigned int*) ISO_DUMMY1_reg))
+#define ISO_DUMMY1_inst_adr                                                          "0x0015"
+#define ISO_DUMMY1_inst                                                              0x0015
+#define ISO_DUMMY1_rvd31_shift                                                       (31)
+#define ISO_DUMMY1_rvd31_mask                                                        (0x80000000)
+#define ISO_DUMMY1_rvd31(data)                                                       (0x80000000&((data)<<31))
+#define ISO_DUMMY1_rvd31_src(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_DUMMY1_get_rvd31(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_DUMMY1_rvd30_shift                                                       (30)
+#define ISO_DUMMY1_rvd30_mask                                                        (0x40000000)
+#define ISO_DUMMY1_rvd30(data)                                                       (0x40000000&((data)<<30))
+#define ISO_DUMMY1_rvd30_src(data)                                                   ((0x40000000&(data))>>30)
+#define ISO_DUMMY1_get_rvd30(data)                                                   ((0x40000000&(data))>>30)
+#define ISO_DUMMY1_rvd29_shift                                                       (29)
+#define ISO_DUMMY1_rvd29_mask                                                        (0x20000000)
+#define ISO_DUMMY1_rvd29(data)                                                       (0x20000000&((data)<<29))
+#define ISO_DUMMY1_rvd29_src(data)                                                   ((0x20000000&(data))>>29)
+#define ISO_DUMMY1_get_rvd29(data)                                                   ((0x20000000&(data))>>29)
+#define ISO_DUMMY1_rvd28_shift                                                       (28)
+#define ISO_DUMMY1_rvd28_mask                                                        (0x10000000)
+#define ISO_DUMMY1_rvd28(data)                                                       (0x10000000&((data)<<28))
+#define ISO_DUMMY1_rvd28_src(data)                                                   ((0x10000000&(data))>>28)
+#define ISO_DUMMY1_get_rvd28(data)                                                   ((0x10000000&(data))>>28)
+#define ISO_DUMMY1_rvd27_shift                                                       (27)
+#define ISO_DUMMY1_rvd27_mask                                                        (0x08000000)
+#define ISO_DUMMY1_rvd27(data)                                                       (0x08000000&((data)<<27))
+#define ISO_DUMMY1_rvd27_src(data)                                                   ((0x08000000&(data))>>27)
+#define ISO_DUMMY1_get_rvd27(data)                                                   ((0x08000000&(data))>>27)
+#define ISO_DUMMY1_rvd26_shift                                                       (26)
+#define ISO_DUMMY1_rvd26_mask                                                        (0x04000000)
+#define ISO_DUMMY1_rvd26(data)                                                       (0x04000000&((data)<<26))
+#define ISO_DUMMY1_rvd26_src(data)                                                   ((0x04000000&(data))>>26)
+#define ISO_DUMMY1_get_rvd26(data)                                                   ((0x04000000&(data))>>26)
+#define ISO_DUMMY1_rvd25_shift                                                       (25)
+#define ISO_DUMMY1_rvd25_mask                                                        (0x02000000)
+#define ISO_DUMMY1_rvd25(data)                                                       (0x02000000&((data)<<25))
+#define ISO_DUMMY1_rvd25_src(data)                                                   ((0x02000000&(data))>>25)
+#define ISO_DUMMY1_get_rvd25(data)                                                   ((0x02000000&(data))>>25)
+#define ISO_DUMMY1_rvd24_shift                                                       (24)
+#define ISO_DUMMY1_rvd24_mask                                                        (0x01000000)
+#define ISO_DUMMY1_rvd24(data)                                                       (0x01000000&((data)<<24))
+#define ISO_DUMMY1_rvd24_src(data)                                                   ((0x01000000&(data))>>24)
+#define ISO_DUMMY1_get_rvd24(data)                                                   ((0x01000000&(data))>>24)
+#define ISO_DUMMY1_rvd23_shift                                                       (23)
+#define ISO_DUMMY1_rvd23_mask                                                        (0x00800000)
+#define ISO_DUMMY1_rvd23(data)                                                       (0x00800000&((data)<<23))
+#define ISO_DUMMY1_rvd23_src(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_DUMMY1_get_rvd23(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_DUMMY1_rvd22_shift                                                       (22)
+#define ISO_DUMMY1_rvd22_mask                                                        (0x00400000)
+#define ISO_DUMMY1_rvd22(data)                                                       (0x00400000&((data)<<22))
+#define ISO_DUMMY1_rvd22_src(data)                                                   ((0x00400000&(data))>>22)
+#define ISO_DUMMY1_get_rvd22(data)                                                   ((0x00400000&(data))>>22)
+#define ISO_DUMMY1_rvd21_shift                                                       (21)
+#define ISO_DUMMY1_rvd21_mask                                                        (0x00200000)
+#define ISO_DUMMY1_rvd21(data)                                                       (0x00200000&((data)<<21))
+#define ISO_DUMMY1_rvd21_src(data)                                                   ((0x00200000&(data))>>21)
+#define ISO_DUMMY1_get_rvd21(data)                                                   ((0x00200000&(data))>>21)
+#define ISO_DUMMY1_rvd20_shift                                                       (20)
+#define ISO_DUMMY1_rvd20_mask                                                        (0x00100000)
+#define ISO_DUMMY1_rvd20(data)                                                       (0x00100000&((data)<<20))
+#define ISO_DUMMY1_rvd20_src(data)                                                   ((0x00100000&(data))>>20)
+#define ISO_DUMMY1_get_rvd20(data)                                                   ((0x00100000&(data))>>20)
+#define ISO_DUMMY1_rvd19_shift                                                       (19)
+#define ISO_DUMMY1_rvd19_mask                                                        (0x00080000)
+#define ISO_DUMMY1_rvd19(data)                                                       (0x00080000&((data)<<19))
+#define ISO_DUMMY1_rvd19_src(data)                                                   ((0x00080000&(data))>>19)
+#define ISO_DUMMY1_get_rvd19(data)                                                   ((0x00080000&(data))>>19)
+#define ISO_DUMMY1_rvd18_shift                                                       (18)
+#define ISO_DUMMY1_rvd18_mask                                                        (0x00040000)
+#define ISO_DUMMY1_rvd18(data)                                                       (0x00040000&((data)<<18))
+#define ISO_DUMMY1_rvd18_src(data)                                                   ((0x00040000&(data))>>18)
+#define ISO_DUMMY1_get_rvd18(data)                                                   ((0x00040000&(data))>>18)
+#define ISO_DUMMY1_rvd17_shift                                                       (17)
+#define ISO_DUMMY1_rvd17_mask                                                        (0x00020000)
+#define ISO_DUMMY1_rvd17(data)                                                       (0x00020000&((data)<<17))
+#define ISO_DUMMY1_rvd17_src(data)                                                   ((0x00020000&(data))>>17)
+#define ISO_DUMMY1_get_rvd17(data)                                                   ((0x00020000&(data))>>17)
+#define ISO_DUMMY1_rvd16_shift                                                       (16)
+#define ISO_DUMMY1_rvd16_mask                                                        (0x00010000)
+#define ISO_DUMMY1_rvd16(data)                                                       (0x00010000&((data)<<16))
+#define ISO_DUMMY1_rvd16_src(data)                                                   ((0x00010000&(data))>>16)
+#define ISO_DUMMY1_get_rvd16(data)                                                   ((0x00010000&(data))>>16)
+#define ISO_DUMMY1_rvd15_shift                                                       (15)
+#define ISO_DUMMY1_rvd15_mask                                                        (0x00008000)
+#define ISO_DUMMY1_rvd15(data)                                                       (0x00008000&((data)<<15))
+#define ISO_DUMMY1_rvd15_src(data)                                                   ((0x00008000&(data))>>15)
+#define ISO_DUMMY1_get_rvd15(data)                                                   ((0x00008000&(data))>>15)
+#define ISO_DUMMY1_rvd14_shift                                                       (14)
+#define ISO_DUMMY1_rvd14_mask                                                        (0x00004000)
+#define ISO_DUMMY1_rvd14(data)                                                       (0x00004000&((data)<<14))
+#define ISO_DUMMY1_rvd14_src(data)                                                   ((0x00004000&(data))>>14)
+#define ISO_DUMMY1_get_rvd14(data)                                                   ((0x00004000&(data))>>14)
+#define ISO_DUMMY1_rvd13_shift                                                       (13)
+#define ISO_DUMMY1_rvd13_mask                                                        (0x00002000)
+#define ISO_DUMMY1_rvd13(data)                                                       (0x00002000&((data)<<13))
+#define ISO_DUMMY1_rvd13_src(data)                                                   ((0x00002000&(data))>>13)
+#define ISO_DUMMY1_get_rvd13(data)                                                   ((0x00002000&(data))>>13)
+#define ISO_DUMMY1_rvd12_shift                                                       (12)
+#define ISO_DUMMY1_rvd12_mask                                                        (0x00001000)
+#define ISO_DUMMY1_rvd12(data)                                                       (0x00001000&((data)<<12))
+#define ISO_DUMMY1_rvd12_src(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_DUMMY1_get_rvd12(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_DUMMY1_rvd11_shift                                                       (11)
+#define ISO_DUMMY1_rvd11_mask                                                        (0x00000800)
+#define ISO_DUMMY1_rvd11(data)                                                       (0x00000800&((data)<<11))
+#define ISO_DUMMY1_rvd11_src(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_DUMMY1_get_rvd11(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_DUMMY1_rvd10_shift                                                       (10)
+#define ISO_DUMMY1_rvd10_mask                                                        (0x00000400)
+#define ISO_DUMMY1_rvd10(data)                                                       (0x00000400&((data)<<10))
+#define ISO_DUMMY1_rvd10_src(data)                                                   ((0x00000400&(data))>>10)
+#define ISO_DUMMY1_get_rvd10(data)                                                   ((0x00000400&(data))>>10)
+#define ISO_DUMMY1_rvd9_shift                                                        (9)
+#define ISO_DUMMY1_rvd9_mask                                                         (0x00000200)
+#define ISO_DUMMY1_rvd9(data)                                                        (0x00000200&((data)<<9))
+#define ISO_DUMMY1_rvd9_src(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_DUMMY1_get_rvd9(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_DUMMY1_rvd8_shift                                                        (8)
+#define ISO_DUMMY1_rvd8_mask                                                         (0x00000100)
+#define ISO_DUMMY1_rvd8(data)                                                        (0x00000100&((data)<<8))
+#define ISO_DUMMY1_rvd8_src(data)                                                    ((0x00000100&(data))>>8)
+#define ISO_DUMMY1_get_rvd8(data)                                                    ((0x00000100&(data))>>8)
+#define ISO_DUMMY1_rvd7_shift                                                        (7)
+#define ISO_DUMMY1_rvd7_mask                                                         (0x00000080)
+#define ISO_DUMMY1_rvd7(data)                                                        (0x00000080&((data)<<7))
+#define ISO_DUMMY1_rvd7_src(data)                                                    ((0x00000080&(data))>>7)
+#define ISO_DUMMY1_get_rvd7(data)                                                    ((0x00000080&(data))>>7)
+#define ISO_DUMMY1_rvd6_shift                                                        (6)
+#define ISO_DUMMY1_rvd6_mask                                                         (0x00000040)
+#define ISO_DUMMY1_rvd6(data)                                                        (0x00000040&((data)<<6))
+#define ISO_DUMMY1_rvd6_src(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_DUMMY1_get_rvd6(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_DUMMY1_rvd5_shift                                                        (5)
+#define ISO_DUMMY1_rvd5_mask                                                         (0x00000020)
+#define ISO_DUMMY1_rvd5(data)                                                        (0x00000020&((data)<<5))
+#define ISO_DUMMY1_rvd5_src(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_DUMMY1_get_rvd5(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_DUMMY1_rvd4_shift                                                        (4)
+#define ISO_DUMMY1_rvd4_mask                                                         (0x00000010)
+#define ISO_DUMMY1_rvd4(data)                                                        (0x00000010&((data)<<4))
+#define ISO_DUMMY1_rvd4_src(data)                                                    ((0x00000010&(data))>>4)
+#define ISO_DUMMY1_get_rvd4(data)                                                    ((0x00000010&(data))>>4)
+#define ISO_DUMMY1_rvd3_shift                                                        (3)
+#define ISO_DUMMY1_rvd3_mask                                                         (0x00000008)
+#define ISO_DUMMY1_rvd3(data)                                                        (0x00000008&((data)<<3))
+#define ISO_DUMMY1_rvd3_src(data)                                                    ((0x00000008&(data))>>3)
+#define ISO_DUMMY1_get_rvd3(data)                                                    ((0x00000008&(data))>>3)
+#define ISO_DUMMY1_rvd2_shift                                                        (2)
+#define ISO_DUMMY1_rvd2_mask                                                         (0x00000004)
+#define ISO_DUMMY1_rvd2(data)                                                        (0x00000004&((data)<<2))
+#define ISO_DUMMY1_rvd2_src(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_DUMMY1_get_rvd2(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_DUMMY1_rvd1_shift                                                        (1)
+#define ISO_DUMMY1_rvd1_mask                                                         (0x00000002)
+#define ISO_DUMMY1_rvd1(data)                                                        (0x00000002&((data)<<1))
+#define ISO_DUMMY1_rvd1_src(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_DUMMY1_get_rvd1(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_DUMMY1_rvd0_shift                                                        (0)
+#define ISO_DUMMY1_rvd0_mask                                                         (0x00000001)
+#define ISO_DUMMY1_rvd0(data)                                                        (0x00000001&((data)<<0))
+#define ISO_DUMMY1_rvd0_src(data)                                                    ((0x00000001&(data))>>0)
+#define ISO_DUMMY1_get_rvd0(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_DUMMY2                                                                   0x98007058
+#define ISO_DUMMY2_reg_addr                                                          "0xD8007058"
+#define ISO_DUMMY2_reg                                                               0xD8007058
+#define set_ISO_DUMMY2_reg(data)   (*((volatile unsigned int*) ISO_DUMMY2_reg)=data)
+#define get_ISO_DUMMY2_reg   (*((volatile unsigned int*) ISO_DUMMY2_reg))
+#define ISO_DUMMY2_inst_adr                                                          "0x0016"
+#define ISO_DUMMY2_inst                                                              0x0016
+#define ISO_DUMMY2_rvd31_shift                                                       (31)
+#define ISO_DUMMY2_rvd31_mask                                                        (0x80000000)
+#define ISO_DUMMY2_rvd31(data)                                                       (0x80000000&((data)<<31))
+#define ISO_DUMMY2_rvd31_src(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_DUMMY2_get_rvd31(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_DUMMY2_rvd30_shift                                                       (30)
+#define ISO_DUMMY2_rvd30_mask                                                        (0x40000000)
+#define ISO_DUMMY2_rvd30(data)                                                       (0x40000000&((data)<<30))
+#define ISO_DUMMY2_rvd30_src(data)                                                   ((0x40000000&(data))>>30)
+#define ISO_DUMMY2_get_rvd30(data)                                                   ((0x40000000&(data))>>30)
+#define ISO_DUMMY2_rvd29_shift                                                       (29)
+#define ISO_DUMMY2_rvd29_mask                                                        (0x20000000)
+#define ISO_DUMMY2_rvd29(data)                                                       (0x20000000&((data)<<29))
+#define ISO_DUMMY2_rvd29_src(data)                                                   ((0x20000000&(data))>>29)
+#define ISO_DUMMY2_get_rvd29(data)                                                   ((0x20000000&(data))>>29)
+#define ISO_DUMMY2_rvd28_shift                                                       (28)
+#define ISO_DUMMY2_rvd28_mask                                                        (0x10000000)
+#define ISO_DUMMY2_rvd28(data)                                                       (0x10000000&((data)<<28))
+#define ISO_DUMMY2_rvd28_src(data)                                                   ((0x10000000&(data))>>28)
+#define ISO_DUMMY2_get_rvd28(data)                                                   ((0x10000000&(data))>>28)
+#define ISO_DUMMY2_rvd27_shift                                                       (27)
+#define ISO_DUMMY2_rvd27_mask                                                        (0x08000000)
+#define ISO_DUMMY2_rvd27(data)                                                       (0x08000000&((data)<<27))
+#define ISO_DUMMY2_rvd27_src(data)                                                   ((0x08000000&(data))>>27)
+#define ISO_DUMMY2_get_rvd27(data)                                                   ((0x08000000&(data))>>27)
+#define ISO_DUMMY2_rvd26_shift                                                       (26)
+#define ISO_DUMMY2_rvd26_mask                                                        (0x04000000)
+#define ISO_DUMMY2_rvd26(data)                                                       (0x04000000&((data)<<26))
+#define ISO_DUMMY2_rvd26_src(data)                                                   ((0x04000000&(data))>>26)
+#define ISO_DUMMY2_get_rvd26(data)                                                   ((0x04000000&(data))>>26)
+#define ISO_DUMMY2_rvd25_shift                                                       (25)
+#define ISO_DUMMY2_rvd25_mask                                                        (0x02000000)
+#define ISO_DUMMY2_rvd25(data)                                                       (0x02000000&((data)<<25))
+#define ISO_DUMMY2_rvd25_src(data)                                                   ((0x02000000&(data))>>25)
+#define ISO_DUMMY2_get_rvd25(data)                                                   ((0x02000000&(data))>>25)
+#define ISO_DUMMY2_rvd24_shift                                                       (24)
+#define ISO_DUMMY2_rvd24_mask                                                        (0x01000000)
+#define ISO_DUMMY2_rvd24(data)                                                       (0x01000000&((data)<<24))
+#define ISO_DUMMY2_rvd24_src(data)                                                   ((0x01000000&(data))>>24)
+#define ISO_DUMMY2_get_rvd24(data)                                                   ((0x01000000&(data))>>24)
+#define ISO_DUMMY2_rvd23_shift                                                       (23)
+#define ISO_DUMMY2_rvd23_mask                                                        (0x00800000)
+#define ISO_DUMMY2_rvd23(data)                                                       (0x00800000&((data)<<23))
+#define ISO_DUMMY2_rvd23_src(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_DUMMY2_get_rvd23(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_DUMMY2_rvd22_shift                                                       (22)
+#define ISO_DUMMY2_rvd22_mask                                                        (0x00400000)
+#define ISO_DUMMY2_rvd22(data)                                                       (0x00400000&((data)<<22))
+#define ISO_DUMMY2_rvd22_src(data)                                                   ((0x00400000&(data))>>22)
+#define ISO_DUMMY2_get_rvd22(data)                                                   ((0x00400000&(data))>>22)
+#define ISO_DUMMY2_rvd21_shift                                                       (21)
+#define ISO_DUMMY2_rvd21_mask                                                        (0x00200000)
+#define ISO_DUMMY2_rvd21(data)                                                       (0x00200000&((data)<<21))
+#define ISO_DUMMY2_rvd21_src(data)                                                   ((0x00200000&(data))>>21)
+#define ISO_DUMMY2_get_rvd21(data)                                                   ((0x00200000&(data))>>21)
+#define ISO_DUMMY2_rvd20_shift                                                       (20)
+#define ISO_DUMMY2_rvd20_mask                                                        (0x00100000)
+#define ISO_DUMMY2_rvd20(data)                                                       (0x00100000&((data)<<20))
+#define ISO_DUMMY2_rvd20_src(data)                                                   ((0x00100000&(data))>>20)
+#define ISO_DUMMY2_get_rvd20(data)                                                   ((0x00100000&(data))>>20)
+#define ISO_DUMMY2_rvd19_shift                                                       (19)
+#define ISO_DUMMY2_rvd19_mask                                                        (0x00080000)
+#define ISO_DUMMY2_rvd19(data)                                                       (0x00080000&((data)<<19))
+#define ISO_DUMMY2_rvd19_src(data)                                                   ((0x00080000&(data))>>19)
+#define ISO_DUMMY2_get_rvd19(data)                                                   ((0x00080000&(data))>>19)
+#define ISO_DUMMY2_rvd18_shift                                                       (18)
+#define ISO_DUMMY2_rvd18_mask                                                        (0x00040000)
+#define ISO_DUMMY2_rvd18(data)                                                       (0x00040000&((data)<<18))
+#define ISO_DUMMY2_rvd18_src(data)                                                   ((0x00040000&(data))>>18)
+#define ISO_DUMMY2_get_rvd18(data)                                                   ((0x00040000&(data))>>18)
+#define ISO_DUMMY2_rvd17_shift                                                       (17)
+#define ISO_DUMMY2_rvd17_mask                                                        (0x00020000)
+#define ISO_DUMMY2_rvd17(data)                                                       (0x00020000&((data)<<17))
+#define ISO_DUMMY2_rvd17_src(data)                                                   ((0x00020000&(data))>>17)
+#define ISO_DUMMY2_get_rvd17(data)                                                   ((0x00020000&(data))>>17)
+#define ISO_DUMMY2_rvd16_shift                                                       (16)
+#define ISO_DUMMY2_rvd16_mask                                                        (0x00010000)
+#define ISO_DUMMY2_rvd16(data)                                                       (0x00010000&((data)<<16))
+#define ISO_DUMMY2_rvd16_src(data)                                                   ((0x00010000&(data))>>16)
+#define ISO_DUMMY2_get_rvd16(data)                                                   ((0x00010000&(data))>>16)
+#define ISO_DUMMY2_rvd15_shift                                                       (15)
+#define ISO_DUMMY2_rvd15_mask                                                        (0x00008000)
+#define ISO_DUMMY2_rvd15(data)                                                       (0x00008000&((data)<<15))
+#define ISO_DUMMY2_rvd15_src(data)                                                   ((0x00008000&(data))>>15)
+#define ISO_DUMMY2_get_rvd15(data)                                                   ((0x00008000&(data))>>15)
+#define ISO_DUMMY2_rvd14_shift                                                       (14)
+#define ISO_DUMMY2_rvd14_mask                                                        (0x00004000)
+#define ISO_DUMMY2_rvd14(data)                                                       (0x00004000&((data)<<14))
+#define ISO_DUMMY2_rvd14_src(data)                                                   ((0x00004000&(data))>>14)
+#define ISO_DUMMY2_get_rvd14(data)                                                   ((0x00004000&(data))>>14)
+#define ISO_DUMMY2_rvd13_shift                                                       (13)
+#define ISO_DUMMY2_rvd13_mask                                                        (0x00002000)
+#define ISO_DUMMY2_rvd13(data)                                                       (0x00002000&((data)<<13))
+#define ISO_DUMMY2_rvd13_src(data)                                                   ((0x00002000&(data))>>13)
+#define ISO_DUMMY2_get_rvd13(data)                                                   ((0x00002000&(data))>>13)
+#define ISO_DUMMY2_rvd12_shift                                                       (12)
+#define ISO_DUMMY2_rvd12_mask                                                        (0x00001000)
+#define ISO_DUMMY2_rvd12(data)                                                       (0x00001000&((data)<<12))
+#define ISO_DUMMY2_rvd12_src(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_DUMMY2_get_rvd12(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_DUMMY2_rvd11_shift                                                       (11)
+#define ISO_DUMMY2_rvd11_mask                                                        (0x00000800)
+#define ISO_DUMMY2_rvd11(data)                                                       (0x00000800&((data)<<11))
+#define ISO_DUMMY2_rvd11_src(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_DUMMY2_get_rvd11(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_DUMMY2_rvd10_shift                                                       (10)
+#define ISO_DUMMY2_rvd10_mask                                                        (0x00000400)
+#define ISO_DUMMY2_rvd10(data)                                                       (0x00000400&((data)<<10))
+#define ISO_DUMMY2_rvd10_src(data)                                                   ((0x00000400&(data))>>10)
+#define ISO_DUMMY2_get_rvd10(data)                                                   ((0x00000400&(data))>>10)
+#define ISO_DUMMY2_rvd9_shift                                                        (9)
+#define ISO_DUMMY2_rvd9_mask                                                         (0x00000200)
+#define ISO_DUMMY2_rvd9(data)                                                        (0x00000200&((data)<<9))
+#define ISO_DUMMY2_rvd9_src(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_DUMMY2_get_rvd9(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_DUMMY2_rvd8_shift                                                        (8)
+#define ISO_DUMMY2_rvd8_mask                                                         (0x00000100)
+#define ISO_DUMMY2_rvd8(data)                                                        (0x00000100&((data)<<8))
+#define ISO_DUMMY2_rvd8_src(data)                                                    ((0x00000100&(data))>>8)
+#define ISO_DUMMY2_get_rvd8(data)                                                    ((0x00000100&(data))>>8)
+#define ISO_DUMMY2_rvd7_shift                                                        (7)
+#define ISO_DUMMY2_rvd7_mask                                                         (0x00000080)
+#define ISO_DUMMY2_rvd7(data)                                                        (0x00000080&((data)<<7))
+#define ISO_DUMMY2_rvd7_src(data)                                                    ((0x00000080&(data))>>7)
+#define ISO_DUMMY2_get_rvd7(data)                                                    ((0x00000080&(data))>>7)
+#define ISO_DUMMY2_rvd6_shift                                                        (6)
+#define ISO_DUMMY2_rvd6_mask                                                         (0x00000040)
+#define ISO_DUMMY2_rvd6(data)                                                        (0x00000040&((data)<<6))
+#define ISO_DUMMY2_rvd6_src(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_DUMMY2_get_rvd6(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_DUMMY2_rvd5_shift                                                        (5)
+#define ISO_DUMMY2_rvd5_mask                                                         (0x00000020)
+#define ISO_DUMMY2_rvd5(data)                                                        (0x00000020&((data)<<5))
+#define ISO_DUMMY2_rvd5_src(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_DUMMY2_get_rvd5(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_DUMMY2_rvd4_shift                                                        (4)
+#define ISO_DUMMY2_rvd4_mask                                                         (0x00000010)
+#define ISO_DUMMY2_rvd4(data)                                                        (0x00000010&((data)<<4))
+#define ISO_DUMMY2_rvd4_src(data)                                                    ((0x00000010&(data))>>4)
+#define ISO_DUMMY2_get_rvd4(data)                                                    ((0x00000010&(data))>>4)
+#define ISO_DUMMY2_rvd3_shift                                                        (3)
+#define ISO_DUMMY2_rvd3_mask                                                         (0x00000008)
+#define ISO_DUMMY2_rvd3(data)                                                        (0x00000008&((data)<<3))
+#define ISO_DUMMY2_rvd3_src(data)                                                    ((0x00000008&(data))>>3)
+#define ISO_DUMMY2_get_rvd3(data)                                                    ((0x00000008&(data))>>3)
+#define ISO_DUMMY2_rvd2_shift                                                        (2)
+#define ISO_DUMMY2_rvd2_mask                                                         (0x00000004)
+#define ISO_DUMMY2_rvd2(data)                                                        (0x00000004&((data)<<2))
+#define ISO_DUMMY2_rvd2_src(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_DUMMY2_get_rvd2(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_DUMMY2_rvd1_shift                                                        (1)
+#define ISO_DUMMY2_rvd1_mask                                                         (0x00000002)
+#define ISO_DUMMY2_rvd1(data)                                                        (0x00000002&((data)<<1))
+#define ISO_DUMMY2_rvd1_src(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_DUMMY2_get_rvd1(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_DUMMY2_rvd0_shift                                                        (0)
+#define ISO_DUMMY2_rvd0_mask                                                         (0x00000001)
+#define ISO_DUMMY2_rvd0(data)                                                        (0x00000001&((data)<<0))
+#define ISO_DUMMY2_rvd0_src(data)                                                    ((0x00000001&(data))>>0)
+#define ISO_DUMMY2_get_rvd0(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_POWERCUT_ETN                                                             0x9800705C
+#define ISO_POWERCUT_ETN_reg_addr                                                    "0xD800705C"
+#define ISO_POWERCUT_ETN_reg                                                         0xD800705C
+#define set_ISO_POWERCUT_ETN_reg(data)   (*((volatile unsigned int*) ISO_POWERCUT_ETN_reg)=data)
+#define get_ISO_POWERCUT_ETN_reg   (*((volatile unsigned int*) ISO_POWERCUT_ETN_reg))
+#define ISO_POWERCUT_ETN_inst_adr                                                    "0x0017"
+#define ISO_POWERCUT_ETN_inst                                                        0x0017
+#define ISO_POWERCUT_ETN_sel_xtal25m_cen_l_shift                                     (11)
+#define ISO_POWERCUT_ETN_sel_xtal25m_cen_l_mask                                      (0x00000800)
+#define ISO_POWERCUT_ETN_sel_xtal25m_cen_l(data)                                     (0x00000800&((data)<<11))
+#define ISO_POWERCUT_ETN_sel_xtal25m_cen_l_src(data)                                 ((0x00000800&(data))>>11)
+#define ISO_POWERCUT_ETN_get_sel_xtal25m_cen_l(data)                                 ((0x00000800&(data))>>11)
+#define ISO_POWERCUT_ETN_en_pll_27m_tiehalf_cen_shift                                (10)
+#define ISO_POWERCUT_ETN_en_pll_27m_tiehalf_cen_mask                                 (0x00000400)
+#define ISO_POWERCUT_ETN_en_pll_27m_tiehalf_cen(data)                                (0x00000400&((data)<<10))
+#define ISO_POWERCUT_ETN_en_pll_27m_tiehalf_cen_src(data)                            ((0x00000400&(data))>>10)
+#define ISO_POWERCUT_ETN_get_en_pll_27m_tiehalf_cen(data)                            ((0x00000400&(data))>>10)
+#define ISO_POWERCUT_ETN_pow_ldo_27m_pll_cen_shift                                   (9)
+#define ISO_POWERCUT_ETN_pow_ldo_27m_pll_cen_mask                                    (0x00000200)
+#define ISO_POWERCUT_ETN_pow_ldo_27m_pll_cen(data)                                   (0x00000200&((data)<<9))
+#define ISO_POWERCUT_ETN_pow_ldo_27m_pll_cen_src(data)                               ((0x00000200&(data))>>9)
+#define ISO_POWERCUT_ETN_get_pow_ldo_27m_pll_cen(data)                               ((0x00000200&(data))>>9)
+#define ISO_POWERCUT_ETN_pow_pll_27m_en_cen_shift                                    (8)
+#define ISO_POWERCUT_ETN_pow_pll_27m_en_cen_mask                                     (0x00000100)
+#define ISO_POWERCUT_ETN_pow_pll_27m_en_cen(data)                                    (0x00000100&((data)<<8))
+#define ISO_POWERCUT_ETN_pow_pll_27m_en_cen_src(data)                                ((0x00000100&(data))>>8)
+#define ISO_POWERCUT_ETN_get_pow_pll_27m_en_cen(data)                                ((0x00000100&(data))>>8)
+#define ISO_POWERCUT_ETN_gphy_mdio_outside_ctrl_en_shift                             (5)
+#define ISO_POWERCUT_ETN_gphy_mdio_outside_ctrl_en_mask                              (0x00000020)
+#define ISO_POWERCUT_ETN_gphy_mdio_outside_ctrl_en(data)                             (0x00000020&((data)<<5))
+#define ISO_POWERCUT_ETN_gphy_mdio_outside_ctrl_en_src(data)                         ((0x00000020&(data))>>5)
+#define ISO_POWERCUT_ETN_get_gphy_mdio_outside_ctrl_en(data)                         ((0x00000020&(data))>>5)
+#define ISO_POWERCUT_ETN_etn_gphy_switch_nat_shift                                   (4)
+#define ISO_POWERCUT_ETN_etn_gphy_switch_nat_mask                                    (0x00000010)
+#define ISO_POWERCUT_ETN_etn_gphy_switch_nat(data)                                   (0x00000010&((data)<<4))
+#define ISO_POWERCUT_ETN_etn_gphy_switch_nat_src(data)                               ((0x00000010&(data))>>4)
+#define ISO_POWERCUT_ETN_get_etn_gphy_switch_nat(data)                               ((0x00000010&(data))>>4)
+#define ISO_POWERCUT_ETN_etn_efuse_default_shift                                     (2)
+#define ISO_POWERCUT_ETN_etn_efuse_default_mask                                      (0x00000004)
+#define ISO_POWERCUT_ETN_etn_efuse_default(data)                                     (0x00000004&((data)<<2))
+#define ISO_POWERCUT_ETN_etn_efuse_default_src(data)                                 ((0x00000004&(data))>>2)
+#define ISO_POWERCUT_ETN_get_etn_efuse_default(data)                                 ((0x00000004&(data))>>2)
+#define ISO_POWERCUT_ETN_powercut_ana_d2a_isolate_b_shift                            (1)
+#define ISO_POWERCUT_ETN_powercut_ana_d2a_isolate_b_mask                             (0x00000002)
+#define ISO_POWERCUT_ETN_powercut_ana_d2a_isolate_b(data)                            (0x00000002&((data)<<1))
+#define ISO_POWERCUT_ETN_powercut_ana_d2a_isolate_b_src(data)                        ((0x00000002&(data))>>1)
+#define ISO_POWERCUT_ETN_get_powercut_ana_d2a_isolate_b(data)                        ((0x00000002&(data))>>1)
+#define ISO_POWERCUT_ETN_powercut_ana_a2d_isolate_b_shift                            (0)
+#define ISO_POWERCUT_ETN_powercut_ana_a2d_isolate_b_mask                             (0x00000001)
+#define ISO_POWERCUT_ETN_powercut_ana_a2d_isolate_b(data)                            (0x00000001&((data)<<0))
+#define ISO_POWERCUT_ETN_powercut_ana_a2d_isolate_b_src(data)                        ((0x00000001&(data))>>0)
+#define ISO_POWERCUT_ETN_get_powercut_ana_a2d_isolate_b(data)                        ((0x00000001&(data))>>0)
+
+
+#define ISO_ETN_TESTIO                                                               0x98007060
+#define ISO_ETN_TESTIO_reg_addr                                                      "0xD8007060"
+#define ISO_ETN_TESTIO_reg                                                           0xD8007060
+#define set_ISO_ETN_TESTIO_reg(data)   (*((volatile unsigned int*) ISO_ETN_TESTIO_reg)=data)
+#define get_ISO_ETN_TESTIO_reg   (*((volatile unsigned int*) ISO_ETN_TESTIO_reg))
+#define ISO_ETN_TESTIO_inst_adr                                                      "0x0018"
+#define ISO_ETN_TESTIO_inst                                                          0x0018
+#define ISO_ETN_TESTIO_etn_bpsgphy_mode_shift                                        (1)
+#define ISO_ETN_TESTIO_etn_bpsgphy_mode_mask                                         (0x00000002)
+#define ISO_ETN_TESTIO_etn_bpsgphy_mode(data)                                        (0x00000002&((data)<<1))
+#define ISO_ETN_TESTIO_etn_bpsgphy_mode_src(data)                                    ((0x00000002&(data))>>1)
+#define ISO_ETN_TESTIO_get_etn_bpsgphy_mode(data)                                    ((0x00000002&(data))>>1)
+#define ISO_ETN_TESTIO_etn_ocd_mode_shift                                            (0)
+#define ISO_ETN_TESTIO_etn_ocd_mode_mask                                             (0x00000001)
+#define ISO_ETN_TESTIO_etn_ocd_mode(data)                                            (0x00000001&((data)<<0))
+#define ISO_ETN_TESTIO_etn_ocd_mode_src(data)                                        ((0x00000001&(data))>>0)
+#define ISO_ETN_TESTIO_get_etn_ocd_mode(data)                                        ((0x00000001&(data))>>0)
+
+
+#define ISO_RESERVED_USE_0                                                           0x98007064
+#define ISO_RESERVED_USE_0_reg_addr                                                  "0xD8007064"
+#define ISO_RESERVED_USE_0_reg                                                       0xD8007064
+#define set_ISO_RESERVED_USE_0_reg(data)   (*((volatile unsigned int*) ISO_RESERVED_USE_0_reg)=data)
+#define get_ISO_RESERVED_USE_0_reg   (*((volatile unsigned int*) ISO_RESERVED_USE_0_reg))
+#define ISO_RESERVED_USE_0_inst_adr                                                  "0x0019"
+#define ISO_RESERVED_USE_0_inst                                                      0x0019
+#define ISO_RESERVED_USE_0_dmy_shift                                                 (0)
+#define ISO_RESERVED_USE_0_dmy_mask                                                  (0xFFFFFFFF)
+#define ISO_RESERVED_USE_0_dmy(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_RESERVED_USE_0_dmy_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_RESERVED_USE_0_get_dmy(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_LPI                                                                      0x98007068
+#define ISO_LPI_reg_addr                                                             "0xD8007068"
+#define ISO_LPI_reg                                                                  0xD8007068
+#define set_ISO_LPI_reg(data)   (*((volatile unsigned int*) ISO_LPI_reg)=data)
+#define get_ISO_LPI_reg   (*((volatile unsigned int*) ISO_LPI_reg))
+#define ISO_LPI_inst_adr                                                             "0x001A"
+#define ISO_LPI_inst                                                                 0x001A
+#define ISO_LPI_timer_shift                                                          (4)
+#define ISO_LPI_timer_mask                                                           (0x00000010)
+#define ISO_LPI_timer(data)                                                          (0x00000010&((data)<<4))
+#define ISO_LPI_timer_src(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_LPI_get_timer(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_LPI_ir_main_shift                                                        (2)
+#define ISO_LPI_ir_main_mask                                                         (0x00000004)
+#define ISO_LPI_ir_main(data)                                                        (0x00000004&((data)<<2))
+#define ISO_LPI_ir_main_src(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_LPI_get_ir_main(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_LPI_ir_tx_shift                                                          (1)
+#define ISO_LPI_ir_tx_mask                                                           (0x00000002)
+#define ISO_LPI_ir_tx(data)                                                          (0x00000002&((data)<<1))
+#define ISO_LPI_ir_tx_src(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_LPI_get_ir_tx(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_LPI_ir_raw_shift                                                         (0)
+#define ISO_LPI_ir_raw_mask                                                          (0x00000001)
+#define ISO_LPI_ir_raw(data)                                                         (0x00000001&((data)<<0))
+#define ISO_LPI_ir_raw_src(data)                                                     ((0x00000001&(data))>>0)
+#define ISO_LPI_get_ir_raw(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_WD                                                                       0x9800706C
+#define ISO_WD_reg_addr                                                              "0xD800706C"
+#define ISO_WD_reg                                                                   0xD800706C
+#define set_ISO_WD_reg(data)   (*((volatile unsigned int*) ISO_WD_reg)=data)
+#define get_ISO_WD_reg   (*((volatile unsigned int*) ISO_WD_reg))
+#define ISO_WD_inst_adr                                                              "0x001B"
+#define ISO_WD_inst                                                                  0x001B
+#define ISO_WD_cnt_wait_pwr_shift                                                    (0)
+#define ISO_WD_cnt_wait_pwr_mask                                                     (0x0000FFFF)
+#define ISO_WD_cnt_wait_pwr(data)                                                    (0x0000FFFF&((data)<<0))
+#define ISO_WD_cnt_wait_pwr_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define ISO_WD_get_cnt_wait_pwr(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_PLL_WDOUT                                                                0x98007070
+#define ISO_PLL_WDOUT_reg_addr                                                       "0xD8007070"
+#define ISO_PLL_WDOUT_reg                                                            0xD8007070
+#define set_ISO_PLL_WDOUT_reg(data)   (*((volatile unsigned int*) ISO_PLL_WDOUT_reg)=data)
+#define get_ISO_PLL_WDOUT_reg   (*((volatile unsigned int*) ISO_PLL_WDOUT_reg))
+#define ISO_PLL_WDOUT_inst_adr                                                       "0x001C"
+#define ISO_PLL_WDOUT_inst                                                           0x001C
+#define ISO_PLL_WDOUT_plletn_wdout_shift                                             (0)
+#define ISO_PLL_WDOUT_plletn_wdout_mask                                              (0x00000001)
+#define ISO_PLL_WDOUT_plletn_wdout(data)                                             (0x00000001&((data)<<0))
+#define ISO_PLL_WDOUT_plletn_wdout_src(data)                                         ((0x00000001&(data))>>0)
+#define ISO_PLL_WDOUT_get_plletn_wdout(data)                                         ((0x00000001&(data))>>0)
+
+
+#define ISO_PLL_ETN                                                                  0x98007074
+#define ISO_PLL_ETN_reg_addr                                                         "0xD8007074"
+#define ISO_PLL_ETN_reg                                                              0xD8007074
+#define set_ISO_PLL_ETN_reg(data)   (*((volatile unsigned int*) ISO_PLL_ETN_reg)=data)
+#define get_ISO_PLL_ETN_reg   (*((volatile unsigned int*) ISO_PLL_ETN_reg))
+#define ISO_PLL_ETN_inst_adr                                                         "0x001D"
+#define ISO_PLL_ETN_inst                                                             0x001D
+#define ISO_PLL_ETN_plletn_oeb_shift                                                 (27)
+#define ISO_PLL_ETN_plletn_oeb_mask                                                  (0x08000000)
+#define ISO_PLL_ETN_plletn_oeb(data)                                                 (0x08000000&((data)<<27))
+#define ISO_PLL_ETN_plletn_oeb_src(data)                                             ((0x08000000&(data))>>27)
+#define ISO_PLL_ETN_get_plletn_oeb(data)                                             ((0x08000000&(data))>>27)
+#define ISO_PLL_ETN_plletn_rstb_shift                                                (26)
+#define ISO_PLL_ETN_plletn_rstb_mask                                                 (0x04000000)
+#define ISO_PLL_ETN_plletn_rstb(data)                                                (0x04000000&((data)<<26))
+#define ISO_PLL_ETN_plletn_rstb_src(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PLL_ETN_get_plletn_rstb(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PLL_ETN_plletn_o_shift                                                   (22)
+#define ISO_PLL_ETN_plletn_o_mask                                                    (0x03C00000)
+#define ISO_PLL_ETN_plletn_o(data)                                                   (0x03C00000&((data)<<22))
+#define ISO_PLL_ETN_plletn_o_src(data)                                               ((0x03C00000&(data))>>22)
+#define ISO_PLL_ETN_get_plletn_o(data)                                               ((0x03C00000&(data))>>22)
+#define ISO_PLL_ETN_plletn_m_shift                                                   (15)
+#define ISO_PLL_ETN_plletn_m_mask                                                    (0x003F8000)
+#define ISO_PLL_ETN_plletn_m(data)                                                   (0x003F8000&((data)<<15))
+#define ISO_PLL_ETN_plletn_m_src(data)                                               ((0x003F8000&(data))>>15)
+#define ISO_PLL_ETN_get_plletn_m(data)                                               ((0x003F8000&(data))>>15)
+#define ISO_PLL_ETN_plletn_ldo_pow_shift                                             (14)
+#define ISO_PLL_ETN_plletn_ldo_pow_mask                                              (0x00004000)
+#define ISO_PLL_ETN_plletn_ldo_pow(data)                                             (0x00004000&((data)<<14))
+#define ISO_PLL_ETN_plletn_ldo_pow_src(data)                                         ((0x00004000&(data))>>14)
+#define ISO_PLL_ETN_get_plletn_ldo_pow(data)                                         ((0x00004000&(data))>>14)
+#define ISO_PLL_ETN_plletn_pow_shift                                                 (13)
+#define ISO_PLL_ETN_plletn_pow_mask                                                  (0x00002000)
+#define ISO_PLL_ETN_plletn_pow(data)                                                 (0x00002000&((data)<<13))
+#define ISO_PLL_ETN_plletn_pow_src(data)                                             ((0x00002000&(data))>>13)
+#define ISO_PLL_ETN_get_plletn_pow(data)                                             ((0x00002000&(data))>>13)
+#define ISO_PLL_ETN_plletn_ldo_sel_shift                                             (11)
+#define ISO_PLL_ETN_plletn_ldo_sel_mask                                              (0x00001800)
+#define ISO_PLL_ETN_plletn_ldo_sel(data)                                             (0x00001800&((data)<<11))
+#define ISO_PLL_ETN_plletn_ldo_sel_src(data)                                         ((0x00001800&(data))>>11)
+#define ISO_PLL_ETN_get_plletn_ldo_sel(data)                                         ((0x00001800&(data))>>11)
+#define ISO_PLL_ETN_plletn_wdmode_shift                                              (9)
+#define ISO_PLL_ETN_plletn_wdmode_mask                                               (0x00000600)
+#define ISO_PLL_ETN_plletn_wdmode(data)                                              (0x00000600&((data)<<9))
+#define ISO_PLL_ETN_plletn_wdmode_src(data)                                          ((0x00000600&(data))>>9)
+#define ISO_PLL_ETN_get_plletn_wdmode(data)                                          ((0x00000600&(data))>>9)
+#define ISO_PLL_ETN_plletn_n_shift                                                   (7)
+#define ISO_PLL_ETN_plletn_n_mask                                                    (0x00000180)
+#define ISO_PLL_ETN_plletn_n(data)                                                   (0x00000180&((data)<<7))
+#define ISO_PLL_ETN_plletn_n_src(data)                                               ((0x00000180&(data))>>7)
+#define ISO_PLL_ETN_get_plletn_n(data)                                               ((0x00000180&(data))>>7)
+#define ISO_PLL_ETN_plletn_lf_rs_shift                                               (5)
+#define ISO_PLL_ETN_plletn_lf_rs_mask                                                (0x00000060)
+#define ISO_PLL_ETN_plletn_lf_rs(data)                                               (0x00000060&((data)<<5))
+#define ISO_PLL_ETN_plletn_lf_rs_src(data)                                           ((0x00000060&(data))>>5)
+#define ISO_PLL_ETN_get_plletn_lf_rs(data)                                           ((0x00000060&(data))>>5)
+#define ISO_PLL_ETN_plletn_lf_cp_shift                                               (3)
+#define ISO_PLL_ETN_plletn_lf_cp_mask                                                (0x00000018)
+#define ISO_PLL_ETN_plletn_lf_cp(data)                                               (0x00000018&((data)<<3))
+#define ISO_PLL_ETN_plletn_lf_cp_src(data)                                           ((0x00000018&(data))>>3)
+#define ISO_PLL_ETN_get_plletn_lf_cp(data)                                           ((0x00000018&(data))>>3)
+#define ISO_PLL_ETN_plletn_ip_shift                                                  (0)
+#define ISO_PLL_ETN_plletn_ip_mask                                                   (0x00000007)
+#define ISO_PLL_ETN_plletn_ip(data)                                                  (0x00000007&((data)<<0))
+#define ISO_PLL_ETN_plletn_ip_src(data)                                              ((0x00000007&(data))>>0)
+#define ISO_PLL_ETN_get_plletn_ip(data)                                              ((0x00000007&(data))>>0)
+
+
+#define ISO_RESERVED_USE_1                                                           0x98007078
+#define ISO_RESERVED_USE_1_reg_addr                                                  "0xD8007078"
+#define ISO_RESERVED_USE_1_reg                                                       0xD8007078
+#define set_ISO_RESERVED_USE_1_reg(data)   (*((volatile unsigned int*) ISO_RESERVED_USE_1_reg)=data)
+#define get_ISO_RESERVED_USE_1_reg   (*((volatile unsigned int*) ISO_RESERVED_USE_1_reg))
+#define ISO_RESERVED_USE_1_inst_adr                                                  "0x001E"
+#define ISO_RESERVED_USE_1_inst                                                      0x001E
+#define ISO_RESERVED_USE_1_dmy_shift                                                 (0)
+#define ISO_RESERVED_USE_1_dmy_mask                                                  (0xFFFFFFFF)
+#define ISO_RESERVED_USE_1_dmy(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_RESERVED_USE_1_dmy_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_RESERVED_USE_1_get_dmy(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_RESERVED_USE_2                                                           0x9800707C
+#define ISO_RESERVED_USE_2_reg_addr                                                  "0xD800707C"
+#define ISO_RESERVED_USE_2_reg                                                       0xD800707C
+#define set_ISO_RESERVED_USE_2_reg(data)   (*((volatile unsigned int*) ISO_RESERVED_USE_2_reg)=data)
+#define get_ISO_RESERVED_USE_2_reg   (*((volatile unsigned int*) ISO_RESERVED_USE_2_reg))
+#define ISO_RESERVED_USE_2_inst_adr                                                  "0x001F"
+#define ISO_RESERVED_USE_2_inst                                                      0x001F
+#define ISO_RESERVED_USE_2_dmy_shift                                                 (0)
+#define ISO_RESERVED_USE_2_dmy_mask                                                  (0xFFFFFFFF)
+#define ISO_RESERVED_USE_2_dmy(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_RESERVED_USE_2_dmy_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_RESERVED_USE_2_get_dmy(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_I2C1_SDA_DEL                                                             0x98007080
+#define ISO_I2C1_SDA_DEL_reg_addr                                                    "0xD8007080"
+#define ISO_I2C1_SDA_DEL_reg                                                         0xD8007080
+#define set_ISO_I2C1_SDA_DEL_reg(data)   (*((volatile unsigned int*) ISO_I2C1_SDA_DEL_reg)=data)
+#define get_ISO_I2C1_SDA_DEL_reg   (*((volatile unsigned int*) ISO_I2C1_SDA_DEL_reg))
+#define ISO_I2C1_SDA_DEL_inst_adr                                                    "0x0020"
+#define ISO_I2C1_SDA_DEL_inst                                                        0x0020
+#define ISO_I2C1_SDA_DEL_dmy1_shift                                                  (12)
+#define ISO_I2C1_SDA_DEL_dmy1_mask                                                   (0xFFFFF000)
+#define ISO_I2C1_SDA_DEL_dmy1(data)                                                  (0xFFFFF000&((data)<<12))
+#define ISO_I2C1_SDA_DEL_dmy1_src(data)                                              ((0xFFFFF000&(data))>>12)
+#define ISO_I2C1_SDA_DEL_get_dmy1(data)                                              ((0xFFFFF000&(data))>>12)
+#define ISO_I2C1_SDA_DEL_en_shift                                                    (8)
+#define ISO_I2C1_SDA_DEL_en_mask                                                     (0x00000100)
+#define ISO_I2C1_SDA_DEL_en(data)                                                    (0x00000100&((data)<<8))
+#define ISO_I2C1_SDA_DEL_en_src(data)                                                ((0x00000100&(data))>>8)
+#define ISO_I2C1_SDA_DEL_get_en(data)                                                ((0x00000100&(data))>>8)
+#define ISO_I2C1_SDA_DEL_sel_shift                                                   (0)
+#define ISO_I2C1_SDA_DEL_sel_mask                                                    (0x0000001F)
+#define ISO_I2C1_SDA_DEL_sel(data)                                                   (0x0000001F&((data)<<0))
+#define ISO_I2C1_SDA_DEL_sel_src(data)                                               ((0x0000001F&(data))>>0)
+#define ISO_I2C1_SDA_DEL_get_sel(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define ISO_I2C0_SDA_DEL                                                             0x98007084
+#define ISO_I2C0_SDA_DEL_reg_addr                                                    "0xD8007084"
+#define ISO_I2C0_SDA_DEL_reg                                                         0xD8007084
+#define set_ISO_I2C0_SDA_DEL_reg(data)   (*((volatile unsigned int*) ISO_I2C0_SDA_DEL_reg)=data)
+#define get_ISO_I2C0_SDA_DEL_reg   (*((volatile unsigned int*) ISO_I2C0_SDA_DEL_reg))
+#define ISO_I2C0_SDA_DEL_inst_adr                                                    "0x0021"
+#define ISO_I2C0_SDA_DEL_inst                                                        0x0021
+#define ISO_I2C0_SDA_DEL_dmy1_shift                                                  (12)
+#define ISO_I2C0_SDA_DEL_dmy1_mask                                                   (0xFFFFF000)
+#define ISO_I2C0_SDA_DEL_dmy1(data)                                                  (0xFFFFF000&((data)<<12))
+#define ISO_I2C0_SDA_DEL_dmy1_src(data)                                              ((0xFFFFF000&(data))>>12)
+#define ISO_I2C0_SDA_DEL_get_dmy1(data)                                              ((0xFFFFF000&(data))>>12)
+#define ISO_I2C0_SDA_DEL_en_shift                                                    (8)
+#define ISO_I2C0_SDA_DEL_en_mask                                                     (0x00000100)
+#define ISO_I2C0_SDA_DEL_en(data)                                                    (0x00000100&((data)<<8))
+#define ISO_I2C0_SDA_DEL_en_src(data)                                                ((0x00000100&(data))>>8)
+#define ISO_I2C0_SDA_DEL_get_en(data)                                                ((0x00000100&(data))>>8)
+#define ISO_I2C0_SDA_DEL_sel_shift                                                   (0)
+#define ISO_I2C0_SDA_DEL_sel_mask                                                    (0x0000001F)
+#define ISO_I2C0_SDA_DEL_sel(data)                                                   (0x0000001F&((data)<<0))
+#define ISO_I2C0_SDA_DEL_sel_src(data)                                               ((0x0000001F&(data))>>0)
+#define ISO_I2C0_SDA_DEL_get_sel(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define ISO_SOFT_RESET                                                               0x98007088
+#define ISO_SOFT_RESET_reg_addr                                                      "0xD8007088"
+#define ISO_SOFT_RESET_reg                                                           0xD8007088
+#define set_ISO_SOFT_RESET_reg(data)   (*((volatile unsigned int*) ISO_SOFT_RESET_reg)=data)
+#define get_ISO_SOFT_RESET_reg   (*((volatile unsigned int*) ISO_SOFT_RESET_reg))
+#define ISO_SOFT_RESET_inst_adr                                                      "0x0022"
+#define ISO_SOFT_RESET_inst                                                          0x0022
+#define ISO_SOFT_RESET_rstn_cbus_shift                                               (13)
+#define ISO_SOFT_RESET_rstn_cbus_mask                                                (0x00002000)
+#define ISO_SOFT_RESET_rstn_cbus(data)                                               (0x00002000&((data)<<13))
+#define ISO_SOFT_RESET_rstn_cbus_src(data)                                           ((0x00002000&(data))>>13)
+#define ISO_SOFT_RESET_get_rstn_cbus(data)                                           ((0x00002000&(data))>>13)
+#define ISO_SOFT_RESET_rstn_i2c_1_shift                                              (12)
+#define ISO_SOFT_RESET_rstn_i2c_1_mask                                               (0x00001000)
+#define ISO_SOFT_RESET_rstn_i2c_1(data)                                              (0x00001000&((data)<<12))
+#define ISO_SOFT_RESET_rstn_i2c_1_src(data)                                          ((0x00001000&(data))>>12)
+#define ISO_SOFT_RESET_get_rstn_i2c_1(data)                                          ((0x00001000&(data))>>12)
+#define ISO_SOFT_RESET_rstn_i2c_0_shift                                              (11)
+#define ISO_SOFT_RESET_rstn_i2c_0_mask                                               (0x00000800)
+#define ISO_SOFT_RESET_rstn_i2c_0(data)                                              (0x00000800&((data)<<11))
+#define ISO_SOFT_RESET_rstn_i2c_0_src(data)                                          ((0x00000800&(data))>>11)
+#define ISO_SOFT_RESET_get_rstn_i2c_0(data)                                          ((0x00000800&(data))>>11)
+#define ISO_SOFT_RESET_rstn_gphy_shift                                               (10)
+#define ISO_SOFT_RESET_rstn_gphy_mask                                                (0x00000400)
+#define ISO_SOFT_RESET_rstn_gphy(data)                                               (0x00000400&((data)<<10))
+#define ISO_SOFT_RESET_rstn_gphy_src(data)                                           ((0x00000400&(data))>>10)
+#define ISO_SOFT_RESET_get_rstn_gphy(data)                                           ((0x00000400&(data))>>10)
+#define ISO_SOFT_RESET_rstn_gmac_shift                                               (9)
+#define ISO_SOFT_RESET_rstn_gmac_mask                                                (0x00000200)
+#define ISO_SOFT_RESET_rstn_gmac(data)                                               (0x00000200&((data)<<9))
+#define ISO_SOFT_RESET_rstn_gmac_src(data)                                           ((0x00000200&(data))>>9)
+#define ISO_SOFT_RESET_get_rstn_gmac(data)                                           ((0x00000200&(data))>>9)
+#define ISO_SOFT_RESET_rstn_ur0_shift                                                (8)
+#define ISO_SOFT_RESET_rstn_ur0_mask                                                 (0x00000100)
+#define ISO_SOFT_RESET_rstn_ur0(data)                                                (0x00000100&((data)<<8))
+#define ISO_SOFT_RESET_rstn_ur0_src(data)                                            ((0x00000100&(data))>>8)
+#define ISO_SOFT_RESET_get_rstn_ur0(data)                                            ((0x00000100&(data))>>8)
+#define ISO_SOFT_RESET_rstn_efuse_shift                                              (7)
+#define ISO_SOFT_RESET_rstn_efuse_mask                                               (0x00000080)
+#define ISO_SOFT_RESET_rstn_efuse(data)                                              (0x00000080&((data)<<7))
+#define ISO_SOFT_RESET_rstn_efuse_src(data)                                          ((0x00000080&(data))>>7)
+#define ISO_SOFT_RESET_get_rstn_efuse(data)                                          ((0x00000080&(data))>>7)
+#define ISO_SOFT_RESET_rstn_cbusrx_shift                                             (6)
+#define ISO_SOFT_RESET_rstn_cbusrx_mask                                              (0x00000040)
+#define ISO_SOFT_RESET_rstn_cbusrx(data)                                             (0x00000040&((data)<<6))
+#define ISO_SOFT_RESET_rstn_cbusrx_src(data)                                         ((0x00000040&(data))>>6)
+#define ISO_SOFT_RESET_get_rstn_cbusrx(data)                                         ((0x00000040&(data))>>6)
+#define ISO_SOFT_RESET_rstn_cbustx_shift                                             (5)
+#define ISO_SOFT_RESET_rstn_cbustx_mask                                              (0x00000020)
+#define ISO_SOFT_RESET_rstn_cbustx(data)                                             (0x00000020&((data)<<5))
+#define ISO_SOFT_RESET_rstn_cbustx_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_SOFT_RESET_get_rstn_cbustx(data)                                         ((0x00000020&(data))>>5)
+#define ISO_SOFT_RESET_rstn_dp_shift                                                 (4)
+#define ISO_SOFT_RESET_rstn_dp_mask                                                  (0x00000010)
+#define ISO_SOFT_RESET_rstn_dp(data)                                                 (0x00000010&((data)<<4))
+#define ISO_SOFT_RESET_rstn_dp_src(data)                                             ((0x00000010&(data))>>4)
+#define ISO_SOFT_RESET_get_rstn_dp(data)                                             ((0x00000010&(data))>>4)
+#define ISO_SOFT_RESET_rstn_cec1_shift                                               (3)
+#define ISO_SOFT_RESET_rstn_cec1_mask                                                (0x00000008)
+#define ISO_SOFT_RESET_rstn_cec1(data)                                               (0x00000008&((data)<<3))
+#define ISO_SOFT_RESET_rstn_cec1_src(data)                                           ((0x00000008&(data))>>3)
+#define ISO_SOFT_RESET_get_rstn_cec1(data)                                           ((0x00000008&(data))>>3)
+#define ISO_SOFT_RESET_rstn_cec0_shift                                               (2)
+#define ISO_SOFT_RESET_rstn_cec0_mask                                                (0x00000004)
+#define ISO_SOFT_RESET_rstn_cec0(data)                                               (0x00000004&((data)<<2))
+#define ISO_SOFT_RESET_rstn_cec0_src(data)                                           ((0x00000004&(data))>>2)
+#define ISO_SOFT_RESET_get_rstn_cec0(data)                                           ((0x00000004&(data))>>2)
+#define ISO_SOFT_RESET_rstn_ir_shift                                                 (1)
+#define ISO_SOFT_RESET_rstn_ir_mask                                                  (0x00000002)
+#define ISO_SOFT_RESET_rstn_ir(data)                                                 (0x00000002&((data)<<1))
+#define ISO_SOFT_RESET_rstn_ir_src(data)                                             ((0x00000002&(data))>>1)
+#define ISO_SOFT_RESET_get_rstn_ir(data)                                             ((0x00000002&(data))>>1)
+
+
+#define ISO_CLOCK_ENABLE                                                             0x9800708C
+#define ISO_CLOCK_ENABLE_reg_addr                                                    "0xD800708C"
+#define ISO_CLOCK_ENABLE_reg                                                         0xD800708C
+#define set_ISO_CLOCK_ENABLE_reg(data)   (*((volatile unsigned int*) ISO_CLOCK_ENABLE_reg)=data)
+#define get_ISO_CLOCK_ENABLE_reg   (*((volatile unsigned int*) ISO_CLOCK_ENABLE_reg))
+#define ISO_CLOCK_ENABLE_inst_adr                                                    "0x0023"
+#define ISO_CLOCK_ENABLE_inst                                                        0x0023
+#define ISO_CLOCK_ENABLE_clk_en_etn_sys_shift                                        (12)
+#define ISO_CLOCK_ENABLE_clk_en_etn_sys_mask                                         (0x00001000)
+#define ISO_CLOCK_ENABLE_clk_en_etn_sys(data)                                        (0x00001000&((data)<<12))
+#define ISO_CLOCK_ENABLE_clk_en_etn_sys_src(data)                                    ((0x00001000&(data))>>12)
+#define ISO_CLOCK_ENABLE_get_clk_en_etn_sys(data)                                    ((0x00001000&(data))>>12)
+#define ISO_CLOCK_ENABLE_clk_en_etn_250m_shift                                       (11)
+#define ISO_CLOCK_ENABLE_clk_en_etn_250m_mask                                        (0x00000800)
+#define ISO_CLOCK_ENABLE_clk_en_etn_250m(data)                                       (0x00000800&((data)<<11))
+#define ISO_CLOCK_ENABLE_clk_en_etn_250m_src(data)                                   ((0x00000800&(data))>>11)
+#define ISO_CLOCK_ENABLE_get_clk_en_etn_250m(data)                                   ((0x00000800&(data))>>11)
+#define ISO_CLOCK_ENABLE_clk_en_i2c1_shift                                           (10)
+#define ISO_CLOCK_ENABLE_clk_en_i2c1_mask                                            (0x00000400)
+#define ISO_CLOCK_ENABLE_clk_en_i2c1(data)                                           (0x00000400&((data)<<10))
+#define ISO_CLOCK_ENABLE_clk_en_i2c1_src(data)                                       ((0x00000400&(data))>>10)
+#define ISO_CLOCK_ENABLE_get_clk_en_i2c1(data)                                       ((0x00000400&(data))>>10)
+#define ISO_CLOCK_ENABLE_clk_en_i2c0_shift                                           (9)
+#define ISO_CLOCK_ENABLE_clk_en_i2c0_mask                                            (0x00000200)
+#define ISO_CLOCK_ENABLE_clk_en_i2c0(data)                                           (0x00000200&((data)<<9))
+#define ISO_CLOCK_ENABLE_clk_en_i2c0_src(data)                                       ((0x00000200&(data))>>9)
+#define ISO_CLOCK_ENABLE_get_clk_en_i2c0(data)                                       ((0x00000200&(data))>>9)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ur0_shift                                       (8)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ur0_mask                                        (0x00000100)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ur0(data)                                       (0x00000100&((data)<<8))
+#define ISO_CLOCK_ENABLE_clk_en_misc_ur0_src(data)                                   ((0x00000100&(data))>>8)
+#define ISO_CLOCK_ENABLE_get_clk_en_misc_ur0(data)                                   ((0x00000100&(data))>>8)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ir_shift                                        (7)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ir_mask                                         (0x00000080)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ir(data)                                        (0x00000080&((data)<<7))
+#define ISO_CLOCK_ENABLE_clk_en_misc_ir_src(data)                                    ((0x00000080&(data))>>7)
+#define ISO_CLOCK_ENABLE_get_clk_en_misc_ir(data)                                    ((0x00000080&(data))>>7)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_osc_shift                                       (6)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_osc_mask                                        (0x00000040)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_osc(data)                                       (0x00000040&((data)<<6))
+#define ISO_CLOCK_ENABLE_clk_en_cbus_osc_src(data)                                   ((0x00000040&(data))>>6)
+#define ISO_CLOCK_ENABLE_get_clk_en_cbus_osc(data)                                   ((0x00000040&(data))>>6)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_sys_shift                                       (5)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_sys_mask                                        (0x00000020)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_sys(data)                                       (0x00000020&((data)<<5))
+#define ISO_CLOCK_ENABLE_clk_en_cbus_sys_src(data)                                   ((0x00000020&(data))>>5)
+#define ISO_CLOCK_ENABLE_get_clk_en_cbus_sys(data)                                   ((0x00000020&(data))>>5)
+#define ISO_CLOCK_ENABLE_clk_en_cbustx_sys_shift                                     (4)
+#define ISO_CLOCK_ENABLE_clk_en_cbustx_sys_mask                                      (0x00000010)
+#define ISO_CLOCK_ENABLE_clk_en_cbustx_sys(data)                                     (0x00000010&((data)<<4))
+#define ISO_CLOCK_ENABLE_clk_en_cbustx_sys_src(data)                                 ((0x00000010&(data))>>4)
+#define ISO_CLOCK_ENABLE_get_clk_en_cbustx_sys(data)                                 ((0x00000010&(data))>>4)
+#define ISO_CLOCK_ENABLE_clk_en_cbusrx_sys_shift                                     (3)
+#define ISO_CLOCK_ENABLE_clk_en_cbusrx_sys_mask                                      (0x00000008)
+#define ISO_CLOCK_ENABLE_clk_en_cbusrx_sys(data)                                     (0x00000008&((data)<<3))
+#define ISO_CLOCK_ENABLE_clk_en_cbusrx_sys_src(data)                                 ((0x00000008&(data))>>3)
+#define ISO_CLOCK_ENABLE_get_clk_en_cbusrx_sys(data)                                 ((0x00000008&(data))>>3)
+#define ISO_CLOCK_ENABLE_clk_en_misc_cec0_shift                                      (2)
+#define ISO_CLOCK_ENABLE_clk_en_misc_cec0_mask                                       (0x00000004)
+#define ISO_CLOCK_ENABLE_clk_en_misc_cec0(data)                                      (0x00000004&((data)<<2))
+#define ISO_CLOCK_ENABLE_clk_en_misc_cec0_src(data)                                  ((0x00000004&(data))>>2)
+#define ISO_CLOCK_ENABLE_get_clk_en_misc_cec0(data)                                  ((0x00000004&(data))>>2)
+#define ISO_CLOCK_ENABLE_clk_en_misc_mix_shift                                       (0)
+#define ISO_CLOCK_ENABLE_clk_en_misc_mix_mask                                        (0x00000001)
+#define ISO_CLOCK_ENABLE_clk_en_misc_mix(data)                                       (0x00000001&((data)<<0))
+#define ISO_CLOCK_ENABLE_clk_en_misc_mix_src(data)                                   ((0x00000001&(data))>>0)
+#define ISO_CLOCK_ENABLE_get_clk_en_misc_mix(data)                                   ((0x00000001&(data))>>0)
+
+
+#define ISO_DC_0                                                                     0x98007090
+#define ISO_DC_0_reg_addr                                                            "0xD8007090"
+#define ISO_DC_0_reg                                                                 0xD8007090
+#define set_ISO_DC_0_reg(data)   (*((volatile unsigned int*) ISO_DC_0_reg)=data)
+#define get_ISO_DC_0_reg   (*((volatile unsigned int*) ISO_DC_0_reg))
+#define ISO_DC_0_inst_adr                                                            "0x0024"
+#define ISO_DC_0_inst                                                                0x0024
+#define ISO_DC_0_rd_only_0_en_shift                                                  (24)
+#define ISO_DC_0_rd_only_0_en_mask                                                   (0x01000000)
+#define ISO_DC_0_rd_only_0_en(data)                                                  (0x01000000&((data)<<24))
+#define ISO_DC_0_rd_only_0_en_src(data)                                              ((0x01000000&(data))>>24)
+#define ISO_DC_0_get_rd_only_0_en(data)                                              ((0x01000000&(data))>>24)
+#define ISO_DC_0_blk_protect_0_wpro_en_shift                                         (21)
+#define ISO_DC_0_blk_protect_0_wpro_en_mask                                          (0x00200000)
+#define ISO_DC_0_blk_protect_0_wpro_en(data)                                         (0x00200000&((data)<<21))
+#define ISO_DC_0_blk_protect_0_wpro_en_src(data)                                     ((0x00200000&(data))>>21)
+#define ISO_DC_0_get_blk_protect_0_wpro_en(data)                                     ((0x00200000&(data))>>21)
+#define ISO_DC_0_blk_protect_0_en_shift                                              (18)
+#define ISO_DC_0_blk_protect_0_en_mask                                               (0x00040000)
+#define ISO_DC_0_blk_protect_0_en(data)                                              (0x00040000&((data)<<18))
+#define ISO_DC_0_blk_protect_0_en_src(data)                                          ((0x00040000&(data))>>18)
+#define ISO_DC_0_get_blk_protect_0_en(data)                                          ((0x00040000&(data))>>18)
+#define ISO_DC_0_protect_0_wpro_en_shift                                             (9)
+#define ISO_DC_0_protect_0_wpro_en_mask                                              (0x00000200)
+#define ISO_DC_0_protect_0_wpro_en(data)                                             (0x00000200&((data)<<9))
+#define ISO_DC_0_protect_0_wpro_en_src(data)                                         ((0x00000200&(data))>>9)
+#define ISO_DC_0_get_protect_0_wpro_en(data)                                         ((0x00000200&(data))>>9)
+#define ISO_DC_0_protect_0_en_shift                                                  (0)
+#define ISO_DC_0_protect_0_en_mask                                                   (0x00000001)
+#define ISO_DC_0_protect_0_en(data)                                                  (0x00000001&((data)<<0))
+#define ISO_DC_0_protect_0_en_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_DC_0_get_protect_0_en(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_DC_1                                                                     0x98007094
+#define ISO_DC_1_reg_addr                                                            "0xD8007094"
+#define ISO_DC_1_reg                                                                 0xD8007094
+#define set_ISO_DC_1_reg(data)   (*((volatile unsigned int*) ISO_DC_1_reg)=data)
+#define get_ISO_DC_1_reg   (*((volatile unsigned int*) ISO_DC_1_reg))
+#define ISO_DC_1_inst_adr                                                            "0x0025"
+#define ISO_DC_1_inst                                                                0x0025
+#define ISO_DC_1_mem_saddr0_shift                                                    (10)
+#define ISO_DC_1_mem_saddr0_mask                                                     (0xFFFFFC00)
+#define ISO_DC_1_mem_saddr0(data)                                                    (0xFFFFFC00&((data)<<10))
+#define ISO_DC_1_mem_saddr0_src(data)                                                ((0xFFFFFC00&(data))>>10)
+#define ISO_DC_1_get_mem_saddr0(data)                                                ((0xFFFFFC00&(data))>>10)
+
+
+#define ISO_DC_2                                                                     0x98007098
+#define ISO_DC_2_reg_addr                                                            "0xD8007098"
+#define ISO_DC_2_reg                                                                 0xD8007098
+#define set_ISO_DC_2_reg(data)   (*((volatile unsigned int*) ISO_DC_2_reg)=data)
+#define get_ISO_DC_2_reg   (*((volatile unsigned int*) ISO_DC_2_reg))
+#define ISO_DC_2_inst_adr                                                            "0x0026"
+#define ISO_DC_2_inst                                                                0x0026
+#define ISO_DC_2_mem_eaddr0_shift                                                    (10)
+#define ISO_DC_2_mem_eaddr0_mask                                                     (0xFFFFFC00)
+#define ISO_DC_2_mem_eaddr0(data)                                                    (0xFFFFFC00&((data)<<10))
+#define ISO_DC_2_mem_eaddr0_src(data)                                                ((0xFFFFFC00&(data))>>10)
+#define ISO_DC_2_get_mem_eaddr0(data)                                                ((0xFFFFFC00&(data))>>10)
+
+
+#define ISO_DC_3                                                                     0x9800709C
+#define ISO_DC_3_reg_addr                                                            "0xD800709C"
+#define ISO_DC_3_reg                                                                 0xD800709C
+#define set_ISO_DC_3_reg(data)   (*((volatile unsigned int*) ISO_DC_3_reg)=data)
+#define get_ISO_DC_3_reg   (*((volatile unsigned int*) ISO_DC_3_reg))
+#define ISO_DC_3_inst_adr                                                            "0x0027"
+#define ISO_DC_3_inst                                                                0x0027
+#define ISO_DC_3_blk_saddr0_shift                                                    (10)
+#define ISO_DC_3_blk_saddr0_mask                                                     (0xFFFFFC00)
+#define ISO_DC_3_blk_saddr0(data)                                                    (0xFFFFFC00&((data)<<10))
+#define ISO_DC_3_blk_saddr0_src(data)                                                ((0xFFFFFC00&(data))>>10)
+#define ISO_DC_3_get_blk_saddr0(data)                                                ((0xFFFFFC00&(data))>>10)
+
+
+#define ISO_DC_4                                                                     0x980070A0
+#define ISO_DC_4_reg_addr                                                            "0xD80070A0"
+#define ISO_DC_4_reg                                                                 0xD80070A0
+#define set_ISO_DC_4_reg(data)   (*((volatile unsigned int*) ISO_DC_4_reg)=data)
+#define get_ISO_DC_4_reg   (*((volatile unsigned int*) ISO_DC_4_reg))
+#define ISO_DC_4_inst_adr                                                            "0x0028"
+#define ISO_DC_4_inst                                                                0x0028
+#define ISO_DC_4_blk_eaddr0_shift                                                    (10)
+#define ISO_DC_4_blk_eaddr0_mask                                                     (0xFFFFFC00)
+#define ISO_DC_4_blk_eaddr0(data)                                                    (0xFFFFFC00&((data)<<10))
+#define ISO_DC_4_blk_eaddr0_src(data)                                                ((0xFFFFFC00&(data))>>10)
+#define ISO_DC_4_get_blk_eaddr0(data)                                                ((0xFFFFFC00&(data))>>10)
+
+
+#define ISO_DC_5                                                                     0x980070A4
+#define ISO_DC_5_reg_addr                                                            "0xD80070A4"
+#define ISO_DC_5_reg                                                                 0xD80070A4
+#define set_ISO_DC_5_reg(data)   (*((volatile unsigned int*) ISO_DC_5_reg)=data)
+#define get_ISO_DC_5_reg   (*((volatile unsigned int*) ISO_DC_5_reg))
+#define ISO_DC_5_inst_adr                                                            "0x0029"
+#define ISO_DC_5_inst                                                                0x0029
+#define ISO_DC_5_ro_saddr0_shift                                                     (10)
+#define ISO_DC_5_ro_saddr0_mask                                                      (0xFFFFFC00)
+#define ISO_DC_5_ro_saddr0(data)                                                     (0xFFFFFC00&((data)<<10))
+#define ISO_DC_5_ro_saddr0_src(data)                                                 ((0xFFFFFC00&(data))>>10)
+#define ISO_DC_5_get_ro_saddr0(data)                                                 ((0xFFFFFC00&(data))>>10)
+
+
+#define ISO_DC_6                                                                     0x980070A8
+#define ISO_DC_6_reg_addr                                                            "0xD80070A8"
+#define ISO_DC_6_reg                                                                 0xD80070A8
+#define set_ISO_DC_6_reg(data)   (*((volatile unsigned int*) ISO_DC_6_reg)=data)
+#define get_ISO_DC_6_reg   (*((volatile unsigned int*) ISO_DC_6_reg))
+#define ISO_DC_6_inst_adr                                                            "0x002A"
+#define ISO_DC_6_inst                                                                0x002A
+#define ISO_DC_6_ro_eaddr0_shift                                                     (10)
+#define ISO_DC_6_ro_eaddr0_mask                                                      (0xFFFFFC00)
+#define ISO_DC_6_ro_eaddr0(data)                                                     (0xFFFFFC00&((data)<<10))
+#define ISO_DC_6_ro_eaddr0_src(data)                                                 ((0xFFFFFC00&(data))>>10)
+#define ISO_DC_6_get_ro_eaddr0(data)                                                 ((0xFFFFFC00&(data))>>10)
+
+
+#define ISO_DC_7                                                                     0x980070AC
+#define ISO_DC_7_reg_addr                                                            "0xD80070AC"
+#define ISO_DC_7_reg                                                                 0xD80070AC
+#define set_ISO_DC_7_reg(data)   (*((volatile unsigned int*) ISO_DC_7_reg)=data)
+#define get_ISO_DC_7_reg   (*((volatile unsigned int*) ISO_DC_7_reg))
+#define ISO_DC_7_inst_adr                                                            "0x002B"
+#define ISO_DC_7_inst                                                                0x002B
+#define ISO_DC_7_md_tee_protect_en_shift                                             (24)
+#define ISO_DC_7_md_tee_protect_en_mask                                              (0x01000000)
+#define ISO_DC_7_md_tee_protect_en(data)                                             (0x01000000&((data)<<24))
+#define ISO_DC_7_md_tee_protect_en_src(data)                                         ((0x01000000&(data))>>24)
+#define ISO_DC_7_get_md_tee_protect_en(data)                                         ((0x01000000&(data))>>24)
+#define ISO_DC_7_cp_tee_protect_en_shift                                             (16)
+#define ISO_DC_7_cp_tee_protect_en_mask                                              (0x00010000)
+#define ISO_DC_7_cp_tee_protect_en(data)                                             (0x00010000&((data)<<16))
+#define ISO_DC_7_cp_tee_protect_en_src(data)                                         ((0x00010000&(data))>>16)
+#define ISO_DC_7_get_cp_tee_protect_en(data)                                         ((0x00010000&(data))>>16)
+#define ISO_DC_7_vo_protect_en_shift                                                 (8)
+#define ISO_DC_7_vo_protect_en_mask                                                  (0x00000100)
+#define ISO_DC_7_vo_protect_en(data)                                                 (0x00000100&((data)<<8))
+#define ISO_DC_7_vo_protect_en_src(data)                                             ((0x00000100&(data))>>8)
+#define ISO_DC_7_get_vo_protect_en(data)                                             ((0x00000100&(data))>>8)
+#define ISO_DC_7_tp_tee_protect_en_shift                                             (2)
+#define ISO_DC_7_tp_tee_protect_en_mask                                              (0x00000004)
+#define ISO_DC_7_tp_tee_protect_en(data)                                             (0x00000004&((data)<<2))
+#define ISO_DC_7_tp_tee_protect_en_src(data)                                         ((0x00000004&(data))>>2)
+#define ISO_DC_7_get_tp_tee_protect_en(data)                                         ((0x00000004&(data))>>2)
+#define ISO_DC_7_cr_tee_protect_en_shift                                             (1)
+#define ISO_DC_7_cr_tee_protect_en_mask                                              (0x00000002)
+#define ISO_DC_7_cr_tee_protect_en(data)                                             (0x00000002&((data)<<1))
+#define ISO_DC_7_cr_tee_protect_en_src(data)                                         ((0x00000002&(data))>>1)
+#define ISO_DC_7_get_cr_tee_protect_en(data)                                         ((0x00000002&(data))>>1)
+#define ISO_DC_7_nf_tee_protect_en_shift                                             (0)
+#define ISO_DC_7_nf_tee_protect_en_mask                                              (0x00000001)
+#define ISO_DC_7_nf_tee_protect_en(data)                                             (0x00000001&((data)<<0))
+#define ISO_DC_7_nf_tee_protect_en_src(data)                                         ((0x00000001&(data))>>0)
+#define ISO_DC_7_get_nf_tee_protect_en(data)                                         ((0x00000001&(data))>>0)
+
+
+#define ISO_DC_8                                                                     0x980070B0
+#define ISO_DC_8_reg_addr                                                            "0xD80070B0"
+#define ISO_DC_8_reg                                                                 0xD80070B0
+#define set_ISO_DC_8_reg(data)   (*((volatile unsigned int*) ISO_DC_8_reg)=data)
+#define get_ISO_DC_8_reg   (*((volatile unsigned int*) ISO_DC_8_reg))
+#define ISO_DC_8_inst_adr                                                            "0x002C"
+#define ISO_DC_8_inst                                                                0x002C
+#define ISO_DC_8_scpu_tee_protect_en_shift                                           (24)
+#define ISO_DC_8_scpu_tee_protect_en_mask                                            (0x01000000)
+#define ISO_DC_8_scpu_tee_protect_en(data)                                           (0x01000000&((data)<<24))
+#define ISO_DC_8_scpu_tee_protect_en_src(data)                                       ((0x01000000&(data))>>24)
+#define ISO_DC_8_get_scpu_tee_protect_en(data)                                       ((0x01000000&(data))>>24)
+#define ISO_DC_8_acpu_protect_en_shift                                               (16)
+#define ISO_DC_8_acpu_protect_en_mask                                                (0x00010000)
+#define ISO_DC_8_acpu_protect_en(data)                                               (0x00010000&((data)<<16))
+#define ISO_DC_8_acpu_protect_en_src(data)                                           ((0x00010000&(data))>>16)
+#define ISO_DC_8_get_acpu_protect_en(data)                                           ((0x00010000&(data))>>16)
+#define ISO_DC_8_video_protect_en_shift                                              (8)
+#define ISO_DC_8_video_protect_en_mask                                               (0x00000100)
+#define ISO_DC_8_video_protect_en(data)                                              (0x00000100&((data)<<8))
+#define ISO_DC_8_video_protect_en_src(data)                                          ((0x00000100&(data))>>8)
+#define ISO_DC_8_get_video_protect_en(data)                                          ((0x00000100&(data))>>8)
+#define ISO_DC_8_audio_protect_en_shift                                              (0)
+#define ISO_DC_8_audio_protect_en_mask                                               (0x00000001)
+#define ISO_DC_8_audio_protect_en(data)                                              (0x00000001&((data)<<0))
+#define ISO_DC_8_audio_protect_en_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_DC_8_get_audio_protect_en(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_DC_9                                                                     0x980070B4
+#define ISO_DC_9_reg_addr                                                            "0xD80070B4"
+#define ISO_DC_9_reg                                                                 0xD80070B4
+#define set_ISO_DC_9_reg(data)   (*((volatile unsigned int*) ISO_DC_9_reg)=data)
+#define get_ISO_DC_9_reg   (*((volatile unsigned int*) ISO_DC_9_reg))
+#define ISO_DC_9_inst_adr                                                            "0x002D"
+#define ISO_DC_9_inst                                                                0x002D
+#define ISO_DC_9_scpu_tee_blk_protect_en_shift                                       (14)
+#define ISO_DC_9_scpu_tee_blk_protect_en_mask                                        (0x00004000)
+#define ISO_DC_9_scpu_tee_blk_protect_en(data)                                       (0x00004000&((data)<<14))
+#define ISO_DC_9_scpu_tee_blk_protect_en_src(data)                                   ((0x00004000&(data))>>14)
+#define ISO_DC_9_get_scpu_tee_blk_protect_en(data)                                   ((0x00004000&(data))>>14)
+#define ISO_DC_9_acpu_blk_protect_en_shift                                           (12)
+#define ISO_DC_9_acpu_blk_protect_en_mask                                            (0x00001000)
+#define ISO_DC_9_acpu_blk_protect_en(data)                                           (0x00001000&((data)<<12))
+#define ISO_DC_9_acpu_blk_protect_en_src(data)                                       ((0x00001000&(data))>>12)
+#define ISO_DC_9_get_acpu_blk_protect_en(data)                                       ((0x00001000&(data))>>12)
+#define ISO_DC_9_video_blk_protect_en_shift                                          (10)
+#define ISO_DC_9_video_blk_protect_en_mask                                           (0x00000400)
+#define ISO_DC_9_video_blk_protect_en(data)                                          (0x00000400&((data)<<10))
+#define ISO_DC_9_video_blk_protect_en_src(data)                                      ((0x00000400&(data))>>10)
+#define ISO_DC_9_get_video_blk_protect_en(data)                                      ((0x00000400&(data))>>10)
+#define ISO_DC_9_audio_blk_protect_en_shift                                          (8)
+#define ISO_DC_9_audio_blk_protect_en_mask                                           (0x00000100)
+#define ISO_DC_9_audio_blk_protect_en(data)                                          (0x00000100&((data)<<8))
+#define ISO_DC_9_audio_blk_protect_en_src(data)                                      ((0x00000100&(data))>>8)
+#define ISO_DC_9_get_audio_blk_protect_en(data)                                      ((0x00000100&(data))>>8)
+#define ISO_DC_9_md_tee_blk_protect_en_shift                                         (6)
+#define ISO_DC_9_md_tee_blk_protect_en_mask                                          (0x00000040)
+#define ISO_DC_9_md_tee_blk_protect_en(data)                                         (0x00000040&((data)<<6))
+#define ISO_DC_9_md_tee_blk_protect_en_src(data)                                     ((0x00000040&(data))>>6)
+#define ISO_DC_9_get_md_tee_blk_protect_en(data)                                     ((0x00000040&(data))>>6)
+#define ISO_DC_9_cp_tee_blk_protect_en_shift                                         (4)
+#define ISO_DC_9_cp_tee_blk_protect_en_mask                                          (0x00000010)
+#define ISO_DC_9_cp_tee_blk_protect_en(data)                                         (0x00000010&((data)<<4))
+#define ISO_DC_9_cp_tee_blk_protect_en_src(data)                                     ((0x00000010&(data))>>4)
+#define ISO_DC_9_get_cp_tee_blk_protect_en(data)                                     ((0x00000010&(data))>>4)
+#define ISO_DC_9_tp_tee_blk_protect_en_shift                                         (3)
+#define ISO_DC_9_tp_tee_blk_protect_en_mask                                          (0x00000008)
+#define ISO_DC_9_tp_tee_blk_protect_en(data)                                         (0x00000008&((data)<<3))
+#define ISO_DC_9_tp_tee_blk_protect_en_src(data)                                     ((0x00000008&(data))>>3)
+#define ISO_DC_9_get_tp_tee_blk_protect_en(data)                                     ((0x00000008&(data))>>3)
+#define ISO_DC_9_vo_blk_protect_en_shift                                             (2)
+#define ISO_DC_9_vo_blk_protect_en_mask                                              (0x00000004)
+#define ISO_DC_9_vo_blk_protect_en(data)                                             (0x00000004&((data)<<2))
+#define ISO_DC_9_vo_blk_protect_en_src(data)                                         ((0x00000004&(data))>>2)
+#define ISO_DC_9_get_vo_blk_protect_en(data)                                         ((0x00000004&(data))>>2)
+#define ISO_DC_9_cr_tee_blk_protect_en_shift                                         (1)
+#define ISO_DC_9_cr_tee_blk_protect_en_mask                                          (0x00000002)
+#define ISO_DC_9_cr_tee_blk_protect_en(data)                                         (0x00000002&((data)<<1))
+#define ISO_DC_9_cr_tee_blk_protect_en_src(data)                                     ((0x00000002&(data))>>1)
+#define ISO_DC_9_get_cr_tee_blk_protect_en(data)                                     ((0x00000002&(data))>>1)
+#define ISO_DC_9_nf_tee_blk_protect_en_shift                                         (0)
+#define ISO_DC_9_nf_tee_blk_protect_en_mask                                          (0x00000001)
+#define ISO_DC_9_nf_tee_blk_protect_en(data)                                         (0x00000001&((data)<<0))
+#define ISO_DC_9_nf_tee_blk_protect_en_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_DC_9_get_nf_tee_blk_protect_en(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_DC_A                                                                     0x980070B8
+#define ISO_DC_A_reg_addr                                                            "0xD80070B8"
+#define ISO_DC_A_reg                                                                 0xD80070B8
+#define set_ISO_DC_A_reg(data)   (*((volatile unsigned int*) ISO_DC_A_reg)=data)
+#define get_ISO_DC_A_reg   (*((volatile unsigned int*) ISO_DC_A_reg))
+#define ISO_DC_A_inst_adr                                                            "0x002E"
+#define ISO_DC_A_inst                                                                0x002E
+#define ISO_DC_A_scpu_tee_ro_protect_en_shift                                        (28)
+#define ISO_DC_A_scpu_tee_ro_protect_en_mask                                         (0x10000000)
+#define ISO_DC_A_scpu_tee_ro_protect_en(data)                                        (0x10000000&((data)<<28))
+#define ISO_DC_A_scpu_tee_ro_protect_en_src(data)                                    ((0x10000000&(data))>>28)
+#define ISO_DC_A_get_scpu_tee_ro_protect_en(data)                                    ((0x10000000&(data))>>28)
+#define ISO_DC_A_acpu_ro_protect_en_shift                                            (24)
+#define ISO_DC_A_acpu_ro_protect_en_mask                                             (0x01000000)
+#define ISO_DC_A_acpu_ro_protect_en(data)                                            (0x01000000&((data)<<24))
+#define ISO_DC_A_acpu_ro_protect_en_src(data)                                        ((0x01000000&(data))>>24)
+#define ISO_DC_A_get_acpu_ro_protect_en(data)                                        ((0x01000000&(data))>>24)
+#define ISO_DC_A_video_ro_protect_en_shift                                           (20)
+#define ISO_DC_A_video_ro_protect_en_mask                                            (0x00100000)
+#define ISO_DC_A_video_ro_protect_en(data)                                           (0x00100000&((data)<<20))
+#define ISO_DC_A_video_ro_protect_en_src(data)                                       ((0x00100000&(data))>>20)
+#define ISO_DC_A_get_video_ro_protect_en(data)                                       ((0x00100000&(data))>>20)
+#define ISO_DC_A_audio_ro_protect_en_shift                                           (16)
+#define ISO_DC_A_audio_ro_protect_en_mask                                            (0x00010000)
+#define ISO_DC_A_audio_ro_protect_en(data)                                           (0x00010000&((data)<<16))
+#define ISO_DC_A_audio_ro_protect_en_src(data)                                       ((0x00010000&(data))>>16)
+#define ISO_DC_A_get_audio_ro_protect_en(data)                                       ((0x00010000&(data))>>16)
+#define ISO_DC_A_md_tee_ro_protect_en_shift                                          (12)
+#define ISO_DC_A_md_tee_ro_protect_en_mask                                           (0x00001000)
+#define ISO_DC_A_md_tee_ro_protect_en(data)                                          (0x00001000&((data)<<12))
+#define ISO_DC_A_md_tee_ro_protect_en_src(data)                                      ((0x00001000&(data))>>12)
+#define ISO_DC_A_get_md_tee_ro_protect_en(data)                                      ((0x00001000&(data))>>12)
+#define ISO_DC_A_cp_tee_ro_protect_en_shift                                          (8)
+#define ISO_DC_A_cp_tee_ro_protect_en_mask                                           (0x00000100)
+#define ISO_DC_A_cp_tee_ro_protect_en(data)                                          (0x00000100&((data)<<8))
+#define ISO_DC_A_cp_tee_ro_protect_en_src(data)                                      ((0x00000100&(data))>>8)
+#define ISO_DC_A_get_cp_tee_ro_protect_en(data)                                      ((0x00000100&(data))>>8)
+#define ISO_DC_A_vo_ro_protect_en_shift                                              (4)
+#define ISO_DC_A_vo_ro_protect_en_mask                                               (0x00000010)
+#define ISO_DC_A_vo_ro_protect_en(data)                                              (0x00000010&((data)<<4))
+#define ISO_DC_A_vo_ro_protect_en_src(data)                                          ((0x00000010&(data))>>4)
+#define ISO_DC_A_get_vo_ro_protect_en(data)                                          ((0x00000010&(data))>>4)
+#define ISO_DC_A_tp_tee_ro_protect_en_shift                                          (2)
+#define ISO_DC_A_tp_tee_ro_protect_en_mask                                           (0x00000004)
+#define ISO_DC_A_tp_tee_ro_protect_en(data)                                          (0x00000004&((data)<<2))
+#define ISO_DC_A_tp_tee_ro_protect_en_src(data)                                      ((0x00000004&(data))>>2)
+#define ISO_DC_A_get_tp_tee_ro_protect_en(data)                                      ((0x00000004&(data))>>2)
+#define ISO_DC_A_cr_tee_ro_protect_en_shift                                          (1)
+#define ISO_DC_A_cr_tee_ro_protect_en_mask                                           (0x00000002)
+#define ISO_DC_A_cr_tee_ro_protect_en(data)                                          (0x00000002&((data)<<1))
+#define ISO_DC_A_cr_tee_ro_protect_en_src(data)                                      ((0x00000002&(data))>>1)
+#define ISO_DC_A_get_cr_tee_ro_protect_en(data)                                      ((0x00000002&(data))>>1)
+#define ISO_DC_A_nf_tee_ro_protect_en_shift                                          (0)
+#define ISO_DC_A_nf_tee_ro_protect_en_mask                                           (0x00000001)
+#define ISO_DC_A_nf_tee_ro_protect_en(data)                                          (0x00000001&((data)<<0))
+#define ISO_DC_A_nf_tee_ro_protect_en_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_DC_A_get_nf_tee_ro_protect_en(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_PLL_XTAL_CTRL                                                            0x980070BC
+#define ISO_PLL_XTAL_CTRL_reg_addr                                                   "0xD80070BC"
+#define ISO_PLL_XTAL_CTRL_reg                                                        0xD80070BC
+#define set_ISO_PLL_XTAL_CTRL_reg(data)   (*((volatile unsigned int*) ISO_PLL_XTAL_CTRL_reg)=data)
+#define get_ISO_PLL_XTAL_CTRL_reg   (*((volatile unsigned int*) ISO_PLL_XTAL_CTRL_reg))
+#define ISO_PLL_XTAL_CTRL_inst_adr                                                   "0x002F"
+#define ISO_PLL_XTAL_CTRL_inst                                                       0x002F
+#define ISO_PLL_XTAL_CTRL_xtal_pad_drv_shift                                         (0)
+#define ISO_PLL_XTAL_CTRL_xtal_pad_drv_mask                                          (0x00000003)
+#define ISO_PLL_XTAL_CTRL_xtal_pad_drv(data)                                         (0x00000003&((data)<<0))
+#define ISO_PLL_XTAL_CTRL_xtal_pad_drv_src(data)                                     ((0x00000003&(data))>>0)
+#define ISO_PLL_XTAL_CTRL_get_xtal_pad_drv(data)                                     ((0x00000003&(data))>>0)
+
+
+#define ISO_HDMI_RX                                                                  0x980070C4
+#define ISO_HDMI_RX_reg_addr                                                         "0xD80070C4"
+#define ISO_HDMI_RX_reg                                                              0xD80070C4
+#define set_ISO_HDMI_RX_reg(data)   (*((volatile unsigned int*) ISO_HDMI_RX_reg)=data)
+#define get_ISO_HDMI_RX_reg   (*((volatile unsigned int*) ISO_HDMI_RX_reg))
+#define ISO_HDMI_RX_inst_adr                                                         "0x0031"
+#define ISO_HDMI_RX_inst                                                             0x0031
+#define ISO_HDMI_RX_int_option_shift                                                 (0)
+#define ISO_HDMI_RX_int_option_mask                                                  (0x00000001)
+#define ISO_HDMI_RX_int_option(data)                                                 (0x00000001&((data)<<0))
+#define ISO_HDMI_RX_int_option_src(data)                                             ((0x00000001&(data))>>0)
+#define ISO_HDMI_RX_get_int_option(data)                                             ((0x00000001&(data))>>0)
+
+
+#define ISO_PLL_ETN_OSC                                                              0x980070CC
+#define ISO_PLL_ETN_OSC_reg_addr                                                     "0xD80070CC"
+#define ISO_PLL_ETN_OSC_reg                                                          0xD80070CC
+#define set_ISO_PLL_ETN_OSC_reg(data)   (*((volatile unsigned int*) ISO_PLL_ETN_OSC_reg)=data)
+#define get_ISO_PLL_ETN_OSC_reg   (*((volatile unsigned int*) ISO_PLL_ETN_OSC_reg))
+#define ISO_PLL_ETN_OSC_inst_adr                                                     "0x0033"
+#define ISO_PLL_ETN_OSC_inst                                                         0x0033
+#define ISO_PLL_ETN_OSC_reg_reserve_shift                                            (12)
+#define ISO_PLL_ETN_OSC_reg_reserve_mask                                             (0x00003000)
+#define ISO_PLL_ETN_OSC_reg_reserve(data)                                            (0x00003000&((data)<<12))
+#define ISO_PLL_ETN_OSC_reg_reserve_src(data)                                        ((0x00003000&(data))>>12)
+#define ISO_PLL_ETN_OSC_get_reg_reserve(data)                                        ((0x00003000&(data))>>12)
+#define ISO_PLL_ETN_OSC_reg_tc_emb_shift                                             (9)
+#define ISO_PLL_ETN_OSC_reg_tc_emb_mask                                              (0x00000E00)
+#define ISO_PLL_ETN_OSC_reg_tc_emb(data)                                             (0x00000E00&((data)<<9))
+#define ISO_PLL_ETN_OSC_reg_tc_emb_src(data)                                         ((0x00000E00&(data))>>9)
+#define ISO_PLL_ETN_OSC_get_reg_tc_emb(data)                                         ((0x00000E00&(data))>>9)
+#define ISO_PLL_ETN_OSC_reg_fref_sel_shift                                           (8)
+#define ISO_PLL_ETN_OSC_reg_fref_sel_mask                                            (0x00000100)
+#define ISO_PLL_ETN_OSC_reg_fref_sel(data)                                           (0x00000100&((data)<<8))
+#define ISO_PLL_ETN_OSC_reg_fref_sel_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_PLL_ETN_OSC_get_reg_fref_sel(data)                                       ((0x00000100&(data))>>8)
+#define ISO_PLL_ETN_OSC_s_emb_shift                                                  (1)
+#define ISO_PLL_ETN_OSC_s_emb_mask                                                   (0x000000FE)
+#define ISO_PLL_ETN_OSC_s_emb(data)                                                  (0x000000FE&((data)<<1))
+#define ISO_PLL_ETN_OSC_s_emb_src(data)                                              ((0x000000FE&(data))>>1)
+#define ISO_PLL_ETN_OSC_get_s_emb(data)                                              ((0x000000FE&(data))>>1)
+#define ISO_PLL_ETN_OSC_rstb_emb_shift                                               (0)
+#define ISO_PLL_ETN_OSC_rstb_emb_mask                                                (0x00000001)
+#define ISO_PLL_ETN_OSC_rstb_emb(data)                                               (0x00000001&((data)<<0))
+#define ISO_PLL_ETN_OSC_rstb_emb_src(data)                                           ((0x00000001&(data))>>0)
+#define ISO_PLL_ETN_OSC_get_rstb_emb(data)                                           ((0x00000001&(data))>>0)
+
+
+#define ISO_FAST_ISR_GPIO0_A                                                         0x980070E8
+#define ISO_FAST_ISR_GPIO0_A_reg_addr                                                "0xD80070E8"
+#define ISO_FAST_ISR_GPIO0_A_reg                                                     0xD80070E8
+#define set_ISO_FAST_ISR_GPIO0_A_reg(data)   (*((volatile unsigned int*) ISO_FAST_ISR_GPIO0_A_reg)=data)
+#define get_ISO_FAST_ISR_GPIO0_A_reg   (*((volatile unsigned int*) ISO_FAST_ISR_GPIO0_A_reg))
+#define ISO_FAST_ISR_GPIO0_A_inst_adr                                                "0x003A"
+#define ISO_FAST_ISR_GPIO0_A_inst                                                    0x003A
+#define ISO_FAST_ISR_GPIO0_A_int_30_shift                                            (31)
+#define ISO_FAST_ISR_GPIO0_A_int_30_mask                                             (0x80000000)
+#define ISO_FAST_ISR_GPIO0_A_int_30(data)                                            (0x80000000&((data)<<31))
+#define ISO_FAST_ISR_GPIO0_A_int_30_src(data)                                        ((0x80000000&(data))>>31)
+#define ISO_FAST_ISR_GPIO0_A_get_int_30(data)                                        ((0x80000000&(data))>>31)
+#define ISO_FAST_ISR_GPIO0_A_int_29_shift                                            (30)
+#define ISO_FAST_ISR_GPIO0_A_int_29_mask                                             (0x40000000)
+#define ISO_FAST_ISR_GPIO0_A_int_29(data)                                            (0x40000000&((data)<<30))
+#define ISO_FAST_ISR_GPIO0_A_int_29_src(data)                                        ((0x40000000&(data))>>30)
+#define ISO_FAST_ISR_GPIO0_A_get_int_29(data)                                        ((0x40000000&(data))>>30)
+#define ISO_FAST_ISR_GPIO0_A_int_28_shift                                            (29)
+#define ISO_FAST_ISR_GPIO0_A_int_28_mask                                             (0x20000000)
+#define ISO_FAST_ISR_GPIO0_A_int_28(data)                                            (0x20000000&((data)<<29))
+#define ISO_FAST_ISR_GPIO0_A_int_28_src(data)                                        ((0x20000000&(data))>>29)
+#define ISO_FAST_ISR_GPIO0_A_get_int_28(data)                                        ((0x20000000&(data))>>29)
+#define ISO_FAST_ISR_GPIO0_A_int_27_shift                                            (28)
+#define ISO_FAST_ISR_GPIO0_A_int_27_mask                                             (0x10000000)
+#define ISO_FAST_ISR_GPIO0_A_int_27(data)                                            (0x10000000&((data)<<28))
+#define ISO_FAST_ISR_GPIO0_A_int_27_src(data)                                        ((0x10000000&(data))>>28)
+#define ISO_FAST_ISR_GPIO0_A_get_int_27(data)                                        ((0x10000000&(data))>>28)
+#define ISO_FAST_ISR_GPIO0_A_int_26_shift                                            (27)
+#define ISO_FAST_ISR_GPIO0_A_int_26_mask                                             (0x08000000)
+#define ISO_FAST_ISR_GPIO0_A_int_26(data)                                            (0x08000000&((data)<<27))
+#define ISO_FAST_ISR_GPIO0_A_int_26_src(data)                                        ((0x08000000&(data))>>27)
+#define ISO_FAST_ISR_GPIO0_A_get_int_26(data)                                        ((0x08000000&(data))>>27)
+#define ISO_FAST_ISR_GPIO0_A_int_25_shift                                            (26)
+#define ISO_FAST_ISR_GPIO0_A_int_25_mask                                             (0x04000000)
+#define ISO_FAST_ISR_GPIO0_A_int_25(data)                                            (0x04000000&((data)<<26))
+#define ISO_FAST_ISR_GPIO0_A_int_25_src(data)                                        ((0x04000000&(data))>>26)
+#define ISO_FAST_ISR_GPIO0_A_get_int_25(data)                                        ((0x04000000&(data))>>26)
+#define ISO_FAST_ISR_GPIO0_A_int_24_shift                                            (25)
+#define ISO_FAST_ISR_GPIO0_A_int_24_mask                                             (0x02000000)
+#define ISO_FAST_ISR_GPIO0_A_int_24(data)                                            (0x02000000&((data)<<25))
+#define ISO_FAST_ISR_GPIO0_A_int_24_src(data)                                        ((0x02000000&(data))>>25)
+#define ISO_FAST_ISR_GPIO0_A_get_int_24(data)                                        ((0x02000000&(data))>>25)
+#define ISO_FAST_ISR_GPIO0_A_int_23_shift                                            (24)
+#define ISO_FAST_ISR_GPIO0_A_int_23_mask                                             (0x01000000)
+#define ISO_FAST_ISR_GPIO0_A_int_23(data)                                            (0x01000000&((data)<<24))
+#define ISO_FAST_ISR_GPIO0_A_int_23_src(data)                                        ((0x01000000&(data))>>24)
+#define ISO_FAST_ISR_GPIO0_A_get_int_23(data)                                        ((0x01000000&(data))>>24)
+#define ISO_FAST_ISR_GPIO0_A_int_22_shift                                            (23)
+#define ISO_FAST_ISR_GPIO0_A_int_22_mask                                             (0x00800000)
+#define ISO_FAST_ISR_GPIO0_A_int_22(data)                                            (0x00800000&((data)<<23))
+#define ISO_FAST_ISR_GPIO0_A_int_22_src(data)                                        ((0x00800000&(data))>>23)
+#define ISO_FAST_ISR_GPIO0_A_get_int_22(data)                                        ((0x00800000&(data))>>23)
+#define ISO_FAST_ISR_GPIO0_A_int_21_shift                                            (22)
+#define ISO_FAST_ISR_GPIO0_A_int_21_mask                                             (0x00400000)
+#define ISO_FAST_ISR_GPIO0_A_int_21(data)                                            (0x00400000&((data)<<22))
+#define ISO_FAST_ISR_GPIO0_A_int_21_src(data)                                        ((0x00400000&(data))>>22)
+#define ISO_FAST_ISR_GPIO0_A_get_int_21(data)                                        ((0x00400000&(data))>>22)
+#define ISO_FAST_ISR_GPIO0_A_int_20_shift                                            (21)
+#define ISO_FAST_ISR_GPIO0_A_int_20_mask                                             (0x00200000)
+#define ISO_FAST_ISR_GPIO0_A_int_20(data)                                            (0x00200000&((data)<<21))
+#define ISO_FAST_ISR_GPIO0_A_int_20_src(data)                                        ((0x00200000&(data))>>21)
+#define ISO_FAST_ISR_GPIO0_A_get_int_20(data)                                        ((0x00200000&(data))>>21)
+#define ISO_FAST_ISR_GPIO0_A_int_19_shift                                            (20)
+#define ISO_FAST_ISR_GPIO0_A_int_19_mask                                             (0x00100000)
+#define ISO_FAST_ISR_GPIO0_A_int_19(data)                                            (0x00100000&((data)<<20))
+#define ISO_FAST_ISR_GPIO0_A_int_19_src(data)                                        ((0x00100000&(data))>>20)
+#define ISO_FAST_ISR_GPIO0_A_get_int_19(data)                                        ((0x00100000&(data))>>20)
+#define ISO_FAST_ISR_GPIO0_A_int_18_shift                                            (19)
+#define ISO_FAST_ISR_GPIO0_A_int_18_mask                                             (0x00080000)
+#define ISO_FAST_ISR_GPIO0_A_int_18(data)                                            (0x00080000&((data)<<19))
+#define ISO_FAST_ISR_GPIO0_A_int_18_src(data)                                        ((0x00080000&(data))>>19)
+#define ISO_FAST_ISR_GPIO0_A_get_int_18(data)                                        ((0x00080000&(data))>>19)
+#define ISO_FAST_ISR_GPIO0_A_int_17_shift                                            (18)
+#define ISO_FAST_ISR_GPIO0_A_int_17_mask                                             (0x00040000)
+#define ISO_FAST_ISR_GPIO0_A_int_17(data)                                            (0x00040000&((data)<<18))
+#define ISO_FAST_ISR_GPIO0_A_int_17_src(data)                                        ((0x00040000&(data))>>18)
+#define ISO_FAST_ISR_GPIO0_A_get_int_17(data)                                        ((0x00040000&(data))>>18)
+#define ISO_FAST_ISR_GPIO0_A_int_16_shift                                            (17)
+#define ISO_FAST_ISR_GPIO0_A_int_16_mask                                             (0x00020000)
+#define ISO_FAST_ISR_GPIO0_A_int_16(data)                                            (0x00020000&((data)<<17))
+#define ISO_FAST_ISR_GPIO0_A_int_16_src(data)                                        ((0x00020000&(data))>>17)
+#define ISO_FAST_ISR_GPIO0_A_get_int_16(data)                                        ((0x00020000&(data))>>17)
+#define ISO_FAST_ISR_GPIO0_A_int_15_shift                                            (16)
+#define ISO_FAST_ISR_GPIO0_A_int_15_mask                                             (0x00010000)
+#define ISO_FAST_ISR_GPIO0_A_int_15(data)                                            (0x00010000&((data)<<16))
+#define ISO_FAST_ISR_GPIO0_A_int_15_src(data)                                        ((0x00010000&(data))>>16)
+#define ISO_FAST_ISR_GPIO0_A_get_int_15(data)                                        ((0x00010000&(data))>>16)
+#define ISO_FAST_ISR_GPIO0_A_int_14_shift                                            (15)
+#define ISO_FAST_ISR_GPIO0_A_int_14_mask                                             (0x00008000)
+#define ISO_FAST_ISR_GPIO0_A_int_14(data)                                            (0x00008000&((data)<<15))
+#define ISO_FAST_ISR_GPIO0_A_int_14_src(data)                                        ((0x00008000&(data))>>15)
+#define ISO_FAST_ISR_GPIO0_A_get_int_14(data)                                        ((0x00008000&(data))>>15)
+#define ISO_FAST_ISR_GPIO0_A_int_13_shift                                            (14)
+#define ISO_FAST_ISR_GPIO0_A_int_13_mask                                             (0x00004000)
+#define ISO_FAST_ISR_GPIO0_A_int_13(data)                                            (0x00004000&((data)<<14))
+#define ISO_FAST_ISR_GPIO0_A_int_13_src(data)                                        ((0x00004000&(data))>>14)
+#define ISO_FAST_ISR_GPIO0_A_get_int_13(data)                                        ((0x00004000&(data))>>14)
+#define ISO_FAST_ISR_GPIO0_A_int_12_shift                                            (13)
+#define ISO_FAST_ISR_GPIO0_A_int_12_mask                                             (0x00002000)
+#define ISO_FAST_ISR_GPIO0_A_int_12(data)                                            (0x00002000&((data)<<13))
+#define ISO_FAST_ISR_GPIO0_A_int_12_src(data)                                        ((0x00002000&(data))>>13)
+#define ISO_FAST_ISR_GPIO0_A_get_int_12(data)                                        ((0x00002000&(data))>>13)
+#define ISO_FAST_ISR_GPIO0_A_int_11_shift                                            (12)
+#define ISO_FAST_ISR_GPIO0_A_int_11_mask                                             (0x00001000)
+#define ISO_FAST_ISR_GPIO0_A_int_11(data)                                            (0x00001000&((data)<<12))
+#define ISO_FAST_ISR_GPIO0_A_int_11_src(data)                                        ((0x00001000&(data))>>12)
+#define ISO_FAST_ISR_GPIO0_A_get_int_11(data)                                        ((0x00001000&(data))>>12)
+#define ISO_FAST_ISR_GPIO0_A_int_10_shift                                            (11)
+#define ISO_FAST_ISR_GPIO0_A_int_10_mask                                             (0x00000800)
+#define ISO_FAST_ISR_GPIO0_A_int_10(data)                                            (0x00000800&((data)<<11))
+#define ISO_FAST_ISR_GPIO0_A_int_10_src(data)                                        ((0x00000800&(data))>>11)
+#define ISO_FAST_ISR_GPIO0_A_get_int_10(data)                                        ((0x00000800&(data))>>11)
+#define ISO_FAST_ISR_GPIO0_A_int_9_shift                                             (10)
+#define ISO_FAST_ISR_GPIO0_A_int_9_mask                                              (0x00000400)
+#define ISO_FAST_ISR_GPIO0_A_int_9(data)                                             (0x00000400&((data)<<10))
+#define ISO_FAST_ISR_GPIO0_A_int_9_src(data)                                         ((0x00000400&(data))>>10)
+#define ISO_FAST_ISR_GPIO0_A_get_int_9(data)                                         ((0x00000400&(data))>>10)
+#define ISO_FAST_ISR_GPIO0_A_int_8_shift                                             (9)
+#define ISO_FAST_ISR_GPIO0_A_int_8_mask                                              (0x00000200)
+#define ISO_FAST_ISR_GPIO0_A_int_8(data)                                             (0x00000200&((data)<<9))
+#define ISO_FAST_ISR_GPIO0_A_int_8_src(data)                                         ((0x00000200&(data))>>9)
+#define ISO_FAST_ISR_GPIO0_A_get_int_8(data)                                         ((0x00000200&(data))>>9)
+#define ISO_FAST_ISR_GPIO0_A_int_7_shift                                             (8)
+#define ISO_FAST_ISR_GPIO0_A_int_7_mask                                              (0x00000100)
+#define ISO_FAST_ISR_GPIO0_A_int_7(data)                                             (0x00000100&((data)<<8))
+#define ISO_FAST_ISR_GPIO0_A_int_7_src(data)                                         ((0x00000100&(data))>>8)
+#define ISO_FAST_ISR_GPIO0_A_get_int_7(data)                                         ((0x00000100&(data))>>8)
+#define ISO_FAST_ISR_GPIO0_A_int_6_shift                                             (7)
+#define ISO_FAST_ISR_GPIO0_A_int_6_mask                                              (0x00000080)
+#define ISO_FAST_ISR_GPIO0_A_int_6(data)                                             (0x00000080&((data)<<7))
+#define ISO_FAST_ISR_GPIO0_A_int_6_src(data)                                         ((0x00000080&(data))>>7)
+#define ISO_FAST_ISR_GPIO0_A_get_int_6(data)                                         ((0x00000080&(data))>>7)
+#define ISO_FAST_ISR_GPIO0_A_int_5_shift                                             (6)
+#define ISO_FAST_ISR_GPIO0_A_int_5_mask                                              (0x00000040)
+#define ISO_FAST_ISR_GPIO0_A_int_5(data)                                             (0x00000040&((data)<<6))
+#define ISO_FAST_ISR_GPIO0_A_int_5_src(data)                                         ((0x00000040&(data))>>6)
+#define ISO_FAST_ISR_GPIO0_A_get_int_5(data)                                         ((0x00000040&(data))>>6)
+#define ISO_FAST_ISR_GPIO0_A_int_4_shift                                             (5)
+#define ISO_FAST_ISR_GPIO0_A_int_4_mask                                              (0x00000020)
+#define ISO_FAST_ISR_GPIO0_A_int_4(data)                                             (0x00000020&((data)<<5))
+#define ISO_FAST_ISR_GPIO0_A_int_4_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_FAST_ISR_GPIO0_A_get_int_4(data)                                         ((0x00000020&(data))>>5)
+#define ISO_FAST_ISR_GPIO0_A_int_3_shift                                             (4)
+#define ISO_FAST_ISR_GPIO0_A_int_3_mask                                              (0x00000010)
+#define ISO_FAST_ISR_GPIO0_A_int_3(data)                                             (0x00000010&((data)<<4))
+#define ISO_FAST_ISR_GPIO0_A_int_3_src(data)                                         ((0x00000010&(data))>>4)
+#define ISO_FAST_ISR_GPIO0_A_get_int_3(data)                                         ((0x00000010&(data))>>4)
+#define ISO_FAST_ISR_GPIO0_A_int_2_shift                                             (3)
+#define ISO_FAST_ISR_GPIO0_A_int_2_mask                                              (0x00000008)
+#define ISO_FAST_ISR_GPIO0_A_int_2(data)                                             (0x00000008&((data)<<3))
+#define ISO_FAST_ISR_GPIO0_A_int_2_src(data)                                         ((0x00000008&(data))>>3)
+#define ISO_FAST_ISR_GPIO0_A_get_int_2(data)                                         ((0x00000008&(data))>>3)
+#define ISO_FAST_ISR_GPIO0_A_int_1_shift                                             (2)
+#define ISO_FAST_ISR_GPIO0_A_int_1_mask                                              (0x00000004)
+#define ISO_FAST_ISR_GPIO0_A_int_1(data)                                             (0x00000004&((data)<<2))
+#define ISO_FAST_ISR_GPIO0_A_int_1_src(data)                                         ((0x00000004&(data))>>2)
+#define ISO_FAST_ISR_GPIO0_A_get_int_1(data)                                         ((0x00000004&(data))>>2)
+#define ISO_FAST_ISR_GPIO0_A_int_0_shift                                             (1)
+#define ISO_FAST_ISR_GPIO0_A_int_0_mask                                              (0x00000002)
+#define ISO_FAST_ISR_GPIO0_A_int_0(data)                                             (0x00000002&((data)<<1))
+#define ISO_FAST_ISR_GPIO0_A_int_0_src(data)                                         ((0x00000002&(data))>>1)
+#define ISO_FAST_ISR_GPIO0_A_get_int_0(data)                                         ((0x00000002&(data))>>1)
+#define ISO_FAST_ISR_GPIO0_A_write_data_shift                                        (0)
+#define ISO_FAST_ISR_GPIO0_A_write_data_mask                                         (0x00000001)
+#define ISO_FAST_ISR_GPIO0_A_write_data(data)                                        (0x00000001&((data)<<0))
+#define ISO_FAST_ISR_GPIO0_A_write_data_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_FAST_ISR_GPIO0_A_get_write_data(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_FAST_ISR_GPIO1_A                                                         0x980070EC
+#define ISO_FAST_ISR_GPIO1_A_reg_addr                                                "0xD80070EC"
+#define ISO_FAST_ISR_GPIO1_A_reg                                                     0xD80070EC
+#define set_ISO_FAST_ISR_GPIO1_A_reg(data)   (*((volatile unsigned int*) ISO_FAST_ISR_GPIO1_A_reg)=data)
+#define get_ISO_FAST_ISR_GPIO1_A_reg   (*((volatile unsigned int*) ISO_FAST_ISR_GPIO1_A_reg))
+#define ISO_FAST_ISR_GPIO1_A_inst_adr                                                "0x003B"
+#define ISO_FAST_ISR_GPIO1_A_inst                                                    0x003B
+#define ISO_FAST_ISR_GPIO1_A_int_34_shift                                            (4)
+#define ISO_FAST_ISR_GPIO1_A_int_34_mask                                             (0x00000010)
+#define ISO_FAST_ISR_GPIO1_A_int_34(data)                                            (0x00000010&((data)<<4))
+#define ISO_FAST_ISR_GPIO1_A_int_34_src(data)                                        ((0x00000010&(data))>>4)
+#define ISO_FAST_ISR_GPIO1_A_get_int_34(data)                                        ((0x00000010&(data))>>4)
+#define ISO_FAST_ISR_GPIO1_A_int_33_shift                                            (3)
+#define ISO_FAST_ISR_GPIO1_A_int_33_mask                                             (0x00000008)
+#define ISO_FAST_ISR_GPIO1_A_int_33(data)                                            (0x00000008&((data)<<3))
+#define ISO_FAST_ISR_GPIO1_A_int_33_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_FAST_ISR_GPIO1_A_get_int_33(data)                                        ((0x00000008&(data))>>3)
+#define ISO_FAST_ISR_GPIO1_A_int_32_shift                                            (2)
+#define ISO_FAST_ISR_GPIO1_A_int_32_mask                                             (0x00000004)
+#define ISO_FAST_ISR_GPIO1_A_int_32(data)                                            (0x00000004&((data)<<2))
+#define ISO_FAST_ISR_GPIO1_A_int_32_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_FAST_ISR_GPIO1_A_get_int_32(data)                                        ((0x00000004&(data))>>2)
+#define ISO_FAST_ISR_GPIO1_A_int_31_shift                                            (1)
+#define ISO_FAST_ISR_GPIO1_A_int_31_mask                                             (0x00000002)
+#define ISO_FAST_ISR_GPIO1_A_int_31(data)                                            (0x00000002&((data)<<1))
+#define ISO_FAST_ISR_GPIO1_A_int_31_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_FAST_ISR_GPIO1_A_get_int_31(data)                                        ((0x00000002&(data))>>1)
+#define ISO_FAST_ISR_GPIO1_A_write_data_shift                                        (0)
+#define ISO_FAST_ISR_GPIO1_A_write_data_mask                                         (0x00000001)
+#define ISO_FAST_ISR_GPIO1_A_write_data(data)                                        (0x00000001&((data)<<0))
+#define ISO_FAST_ISR_GPIO1_A_write_data_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_FAST_ISR_GPIO1_A_get_write_data(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_FAST_ISR_GPIO0_DA                                                        0x980070F8
+#define ISO_FAST_ISR_GPIO0_DA_reg_addr                                               "0xD80070F8"
+#define ISO_FAST_ISR_GPIO0_DA_reg                                                    0xD80070F8
+#define set_ISO_FAST_ISR_GPIO0_DA_reg(data)   (*((volatile unsigned int*) ISO_FAST_ISR_GPIO0_DA_reg)=data)
+#define get_ISO_FAST_ISR_GPIO0_DA_reg   (*((volatile unsigned int*) ISO_FAST_ISR_GPIO0_DA_reg))
+#define ISO_FAST_ISR_GPIO0_DA_inst_adr                                               "0x003E"
+#define ISO_FAST_ISR_GPIO0_DA_inst                                                   0x003E
+#define ISO_FAST_ISR_GPIO0_DA_int_30_shift                                           (31)
+#define ISO_FAST_ISR_GPIO0_DA_int_30_mask                                            (0x80000000)
+#define ISO_FAST_ISR_GPIO0_DA_int_30(data)                                           (0x80000000&((data)<<31))
+#define ISO_FAST_ISR_GPIO0_DA_int_30_src(data)                                       ((0x80000000&(data))>>31)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_30(data)                                       ((0x80000000&(data))>>31)
+#define ISO_FAST_ISR_GPIO0_DA_int_29_shift                                           (30)
+#define ISO_FAST_ISR_GPIO0_DA_int_29_mask                                            (0x40000000)
+#define ISO_FAST_ISR_GPIO0_DA_int_29(data)                                           (0x40000000&((data)<<30))
+#define ISO_FAST_ISR_GPIO0_DA_int_29_src(data)                                       ((0x40000000&(data))>>30)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_29(data)                                       ((0x40000000&(data))>>30)
+#define ISO_FAST_ISR_GPIO0_DA_int_28_shift                                           (29)
+#define ISO_FAST_ISR_GPIO0_DA_int_28_mask                                            (0x20000000)
+#define ISO_FAST_ISR_GPIO0_DA_int_28(data)                                           (0x20000000&((data)<<29))
+#define ISO_FAST_ISR_GPIO0_DA_int_28_src(data)                                       ((0x20000000&(data))>>29)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_28(data)                                       ((0x20000000&(data))>>29)
+#define ISO_FAST_ISR_GPIO0_DA_int_27_shift                                           (28)
+#define ISO_FAST_ISR_GPIO0_DA_int_27_mask                                            (0x10000000)
+#define ISO_FAST_ISR_GPIO0_DA_int_27(data)                                           (0x10000000&((data)<<28))
+#define ISO_FAST_ISR_GPIO0_DA_int_27_src(data)                                       ((0x10000000&(data))>>28)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_27(data)                                       ((0x10000000&(data))>>28)
+#define ISO_FAST_ISR_GPIO0_DA_int_26_shift                                           (27)
+#define ISO_FAST_ISR_GPIO0_DA_int_26_mask                                            (0x08000000)
+#define ISO_FAST_ISR_GPIO0_DA_int_26(data)                                           (0x08000000&((data)<<27))
+#define ISO_FAST_ISR_GPIO0_DA_int_26_src(data)                                       ((0x08000000&(data))>>27)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_26(data)                                       ((0x08000000&(data))>>27)
+#define ISO_FAST_ISR_GPIO0_DA_int_25_shift                                           (26)
+#define ISO_FAST_ISR_GPIO0_DA_int_25_mask                                            (0x04000000)
+#define ISO_FAST_ISR_GPIO0_DA_int_25(data)                                           (0x04000000&((data)<<26))
+#define ISO_FAST_ISR_GPIO0_DA_int_25_src(data)                                       ((0x04000000&(data))>>26)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_25(data)                                       ((0x04000000&(data))>>26)
+#define ISO_FAST_ISR_GPIO0_DA_int_24_shift                                           (25)
+#define ISO_FAST_ISR_GPIO0_DA_int_24_mask                                            (0x02000000)
+#define ISO_FAST_ISR_GPIO0_DA_int_24(data)                                           (0x02000000&((data)<<25))
+#define ISO_FAST_ISR_GPIO0_DA_int_24_src(data)                                       ((0x02000000&(data))>>25)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_24(data)                                       ((0x02000000&(data))>>25)
+#define ISO_FAST_ISR_GPIO0_DA_int_23_shift                                           (24)
+#define ISO_FAST_ISR_GPIO0_DA_int_23_mask                                            (0x01000000)
+#define ISO_FAST_ISR_GPIO0_DA_int_23(data)                                           (0x01000000&((data)<<24))
+#define ISO_FAST_ISR_GPIO0_DA_int_23_src(data)                                       ((0x01000000&(data))>>24)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_23(data)                                       ((0x01000000&(data))>>24)
+#define ISO_FAST_ISR_GPIO0_DA_int_22_shift                                           (23)
+#define ISO_FAST_ISR_GPIO0_DA_int_22_mask                                            (0x00800000)
+#define ISO_FAST_ISR_GPIO0_DA_int_22(data)                                           (0x00800000&((data)<<23))
+#define ISO_FAST_ISR_GPIO0_DA_int_22_src(data)                                       ((0x00800000&(data))>>23)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_22(data)                                       ((0x00800000&(data))>>23)
+#define ISO_FAST_ISR_GPIO0_DA_int_21_shift                                           (22)
+#define ISO_FAST_ISR_GPIO0_DA_int_21_mask                                            (0x00400000)
+#define ISO_FAST_ISR_GPIO0_DA_int_21(data)                                           (0x00400000&((data)<<22))
+#define ISO_FAST_ISR_GPIO0_DA_int_21_src(data)                                       ((0x00400000&(data))>>22)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_21(data)                                       ((0x00400000&(data))>>22)
+#define ISO_FAST_ISR_GPIO0_DA_int_20_shift                                           (21)
+#define ISO_FAST_ISR_GPIO0_DA_int_20_mask                                            (0x00200000)
+#define ISO_FAST_ISR_GPIO0_DA_int_20(data)                                           (0x00200000&((data)<<21))
+#define ISO_FAST_ISR_GPIO0_DA_int_20_src(data)                                       ((0x00200000&(data))>>21)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_20(data)                                       ((0x00200000&(data))>>21)
+#define ISO_FAST_ISR_GPIO0_DA_int_19_shift                                           (20)
+#define ISO_FAST_ISR_GPIO0_DA_int_19_mask                                            (0x00100000)
+#define ISO_FAST_ISR_GPIO0_DA_int_19(data)                                           (0x00100000&((data)<<20))
+#define ISO_FAST_ISR_GPIO0_DA_int_19_src(data)                                       ((0x00100000&(data))>>20)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_19(data)                                       ((0x00100000&(data))>>20)
+#define ISO_FAST_ISR_GPIO0_DA_int_18_shift                                           (19)
+#define ISO_FAST_ISR_GPIO0_DA_int_18_mask                                            (0x00080000)
+#define ISO_FAST_ISR_GPIO0_DA_int_18(data)                                           (0x00080000&((data)<<19))
+#define ISO_FAST_ISR_GPIO0_DA_int_18_src(data)                                       ((0x00080000&(data))>>19)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_18(data)                                       ((0x00080000&(data))>>19)
+#define ISO_FAST_ISR_GPIO0_DA_int_17_shift                                           (18)
+#define ISO_FAST_ISR_GPIO0_DA_int_17_mask                                            (0x00040000)
+#define ISO_FAST_ISR_GPIO0_DA_int_17(data)                                           (0x00040000&((data)<<18))
+#define ISO_FAST_ISR_GPIO0_DA_int_17_src(data)                                       ((0x00040000&(data))>>18)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_17(data)                                       ((0x00040000&(data))>>18)
+#define ISO_FAST_ISR_GPIO0_DA_int_16_shift                                           (17)
+#define ISO_FAST_ISR_GPIO0_DA_int_16_mask                                            (0x00020000)
+#define ISO_FAST_ISR_GPIO0_DA_int_16(data)                                           (0x00020000&((data)<<17))
+#define ISO_FAST_ISR_GPIO0_DA_int_16_src(data)                                       ((0x00020000&(data))>>17)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_16(data)                                       ((0x00020000&(data))>>17)
+#define ISO_FAST_ISR_GPIO0_DA_int_15_shift                                           (16)
+#define ISO_FAST_ISR_GPIO0_DA_int_15_mask                                            (0x00010000)
+#define ISO_FAST_ISR_GPIO0_DA_int_15(data)                                           (0x00010000&((data)<<16))
+#define ISO_FAST_ISR_GPIO0_DA_int_15_src(data)                                       ((0x00010000&(data))>>16)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_15(data)                                       ((0x00010000&(data))>>16)
+#define ISO_FAST_ISR_GPIO0_DA_int_14_shift                                           (15)
+#define ISO_FAST_ISR_GPIO0_DA_int_14_mask                                            (0x00008000)
+#define ISO_FAST_ISR_GPIO0_DA_int_14(data)                                           (0x00008000&((data)<<15))
+#define ISO_FAST_ISR_GPIO0_DA_int_14_src(data)                                       ((0x00008000&(data))>>15)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_14(data)                                       ((0x00008000&(data))>>15)
+#define ISO_FAST_ISR_GPIO0_DA_int_13_shift                                           (14)
+#define ISO_FAST_ISR_GPIO0_DA_int_13_mask                                            (0x00004000)
+#define ISO_FAST_ISR_GPIO0_DA_int_13(data)                                           (0x00004000&((data)<<14))
+#define ISO_FAST_ISR_GPIO0_DA_int_13_src(data)                                       ((0x00004000&(data))>>14)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_13(data)                                       ((0x00004000&(data))>>14)
+#define ISO_FAST_ISR_GPIO0_DA_int_12_shift                                           (13)
+#define ISO_FAST_ISR_GPIO0_DA_int_12_mask                                            (0x00002000)
+#define ISO_FAST_ISR_GPIO0_DA_int_12(data)                                           (0x00002000&((data)<<13))
+#define ISO_FAST_ISR_GPIO0_DA_int_12_src(data)                                       ((0x00002000&(data))>>13)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_12(data)                                       ((0x00002000&(data))>>13)
+#define ISO_FAST_ISR_GPIO0_DA_int_11_shift                                           (12)
+#define ISO_FAST_ISR_GPIO0_DA_int_11_mask                                            (0x00001000)
+#define ISO_FAST_ISR_GPIO0_DA_int_11(data)                                           (0x00001000&((data)<<12))
+#define ISO_FAST_ISR_GPIO0_DA_int_11_src(data)                                       ((0x00001000&(data))>>12)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_11(data)                                       ((0x00001000&(data))>>12)
+#define ISO_FAST_ISR_GPIO0_DA_int_10_shift                                           (11)
+#define ISO_FAST_ISR_GPIO0_DA_int_10_mask                                            (0x00000800)
+#define ISO_FAST_ISR_GPIO0_DA_int_10(data)                                           (0x00000800&((data)<<11))
+#define ISO_FAST_ISR_GPIO0_DA_int_10_src(data)                                       ((0x00000800&(data))>>11)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_10(data)                                       ((0x00000800&(data))>>11)
+#define ISO_FAST_ISR_GPIO0_DA_int_9_shift                                            (10)
+#define ISO_FAST_ISR_GPIO0_DA_int_9_mask                                             (0x00000400)
+#define ISO_FAST_ISR_GPIO0_DA_int_9(data)                                            (0x00000400&((data)<<10))
+#define ISO_FAST_ISR_GPIO0_DA_int_9_src(data)                                        ((0x00000400&(data))>>10)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_9(data)                                        ((0x00000400&(data))>>10)
+#define ISO_FAST_ISR_GPIO0_DA_int_8_shift                                            (9)
+#define ISO_FAST_ISR_GPIO0_DA_int_8_mask                                             (0x00000200)
+#define ISO_FAST_ISR_GPIO0_DA_int_8(data)                                            (0x00000200&((data)<<9))
+#define ISO_FAST_ISR_GPIO0_DA_int_8_src(data)                                        ((0x00000200&(data))>>9)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_8(data)                                        ((0x00000200&(data))>>9)
+#define ISO_FAST_ISR_GPIO0_DA_int_7_shift                                            (8)
+#define ISO_FAST_ISR_GPIO0_DA_int_7_mask                                             (0x00000100)
+#define ISO_FAST_ISR_GPIO0_DA_int_7(data)                                            (0x00000100&((data)<<8))
+#define ISO_FAST_ISR_GPIO0_DA_int_7_src(data)                                        ((0x00000100&(data))>>8)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_7(data)                                        ((0x00000100&(data))>>8)
+#define ISO_FAST_ISR_GPIO0_DA_int_6_shift                                            (7)
+#define ISO_FAST_ISR_GPIO0_DA_int_6_mask                                             (0x00000080)
+#define ISO_FAST_ISR_GPIO0_DA_int_6(data)                                            (0x00000080&((data)<<7))
+#define ISO_FAST_ISR_GPIO0_DA_int_6_src(data)                                        ((0x00000080&(data))>>7)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_6(data)                                        ((0x00000080&(data))>>7)
+#define ISO_FAST_ISR_GPIO0_DA_int_5_shift                                            (6)
+#define ISO_FAST_ISR_GPIO0_DA_int_5_mask                                             (0x00000040)
+#define ISO_FAST_ISR_GPIO0_DA_int_5(data)                                            (0x00000040&((data)<<6))
+#define ISO_FAST_ISR_GPIO0_DA_int_5_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_5(data)                                        ((0x00000040&(data))>>6)
+#define ISO_FAST_ISR_GPIO0_DA_int_4_shift                                            (5)
+#define ISO_FAST_ISR_GPIO0_DA_int_4_mask                                             (0x00000020)
+#define ISO_FAST_ISR_GPIO0_DA_int_4(data)                                            (0x00000020&((data)<<5))
+#define ISO_FAST_ISR_GPIO0_DA_int_4_src(data)                                        ((0x00000020&(data))>>5)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_4(data)                                        ((0x00000020&(data))>>5)
+#define ISO_FAST_ISR_GPIO0_DA_int_3_shift                                            (4)
+#define ISO_FAST_ISR_GPIO0_DA_int_3_mask                                             (0x00000010)
+#define ISO_FAST_ISR_GPIO0_DA_int_3(data)                                            (0x00000010&((data)<<4))
+#define ISO_FAST_ISR_GPIO0_DA_int_3_src(data)                                        ((0x00000010&(data))>>4)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_3(data)                                        ((0x00000010&(data))>>4)
+#define ISO_FAST_ISR_GPIO0_DA_int_2_shift                                            (3)
+#define ISO_FAST_ISR_GPIO0_DA_int_2_mask                                             (0x00000008)
+#define ISO_FAST_ISR_GPIO0_DA_int_2(data)                                            (0x00000008&((data)<<3))
+#define ISO_FAST_ISR_GPIO0_DA_int_2_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_2(data)                                        ((0x00000008&(data))>>3)
+#define ISO_FAST_ISR_GPIO0_DA_int_1_shift                                            (2)
+#define ISO_FAST_ISR_GPIO0_DA_int_1_mask                                             (0x00000004)
+#define ISO_FAST_ISR_GPIO0_DA_int_1(data)                                            (0x00000004&((data)<<2))
+#define ISO_FAST_ISR_GPIO0_DA_int_1_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_1(data)                                        ((0x00000004&(data))>>2)
+#define ISO_FAST_ISR_GPIO0_DA_int_0_shift                                            (1)
+#define ISO_FAST_ISR_GPIO0_DA_int_0_mask                                             (0x00000002)
+#define ISO_FAST_ISR_GPIO0_DA_int_0(data)                                            (0x00000002&((data)<<1))
+#define ISO_FAST_ISR_GPIO0_DA_int_0_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_FAST_ISR_GPIO0_DA_get_int_0(data)                                        ((0x00000002&(data))>>1)
+#define ISO_FAST_ISR_GPIO0_DA_write_data_shift                                       (0)
+#define ISO_FAST_ISR_GPIO0_DA_write_data_mask                                        (0x00000001)
+#define ISO_FAST_ISR_GPIO0_DA_write_data(data)                                       (0x00000001&((data)<<0))
+#define ISO_FAST_ISR_GPIO0_DA_write_data_src(data)                                   ((0x00000001&(data))>>0)
+#define ISO_FAST_ISR_GPIO0_DA_get_write_data(data)                                   ((0x00000001&(data))>>0)
+
+
+#define ISO_FAST_ISR_GPIO1_DA                                                        0x980070FC
+#define ISO_FAST_ISR_GPIO1_DA_reg_addr                                               "0xD80070FC"
+#define ISO_FAST_ISR_GPIO1_DA_reg                                                    0xD80070FC
+#define set_ISO_FAST_ISR_GPIO1_DA_reg(data)   (*((volatile unsigned int*) ISO_FAST_ISR_GPIO1_DA_reg)=data)
+#define get_ISO_FAST_ISR_GPIO1_DA_reg   (*((volatile unsigned int*) ISO_FAST_ISR_GPIO1_DA_reg))
+#define ISO_FAST_ISR_GPIO1_DA_inst_adr                                               "0x003F"
+#define ISO_FAST_ISR_GPIO1_DA_inst                                                   0x003F
+#define ISO_FAST_ISR_GPIO1_DA_int_34_shift                                           (4)
+#define ISO_FAST_ISR_GPIO1_DA_int_34_mask                                            (0x00000010)
+#define ISO_FAST_ISR_GPIO1_DA_int_34(data)                                           (0x00000010&((data)<<4))
+#define ISO_FAST_ISR_GPIO1_DA_int_34_src(data)                                       ((0x00000010&(data))>>4)
+#define ISO_FAST_ISR_GPIO1_DA_get_int_34(data)                                       ((0x00000010&(data))>>4)
+#define ISO_FAST_ISR_GPIO1_DA_int_33_shift                                           (3)
+#define ISO_FAST_ISR_GPIO1_DA_int_33_mask                                            (0x00000008)
+#define ISO_FAST_ISR_GPIO1_DA_int_33(data)                                           (0x00000008&((data)<<3))
+#define ISO_FAST_ISR_GPIO1_DA_int_33_src(data)                                       ((0x00000008&(data))>>3)
+#define ISO_FAST_ISR_GPIO1_DA_get_int_33(data)                                       ((0x00000008&(data))>>3)
+#define ISO_FAST_ISR_GPIO1_DA_int_32_shift                                           (2)
+#define ISO_FAST_ISR_GPIO1_DA_int_32_mask                                            (0x00000004)
+#define ISO_FAST_ISR_GPIO1_DA_int_32(data)                                           (0x00000004&((data)<<2))
+#define ISO_FAST_ISR_GPIO1_DA_int_32_src(data)                                       ((0x00000004&(data))>>2)
+#define ISO_FAST_ISR_GPIO1_DA_get_int_32(data)                                       ((0x00000004&(data))>>2)
+#define ISO_FAST_ISR_GPIO1_DA_int_31_shift                                           (1)
+#define ISO_FAST_ISR_GPIO1_DA_int_31_mask                                            (0x00000002)
+#define ISO_FAST_ISR_GPIO1_DA_int_31(data)                                           (0x00000002&((data)<<1))
+#define ISO_FAST_ISR_GPIO1_DA_int_31_src(data)                                       ((0x00000002&(data))>>1)
+#define ISO_FAST_ISR_GPIO1_DA_get_int_31(data)                                       ((0x00000002&(data))>>1)
+#define ISO_FAST_ISR_GPIO1_DA_write_data_shift                                       (0)
+#define ISO_FAST_ISR_GPIO1_DA_write_data_mask                                        (0x00000001)
+#define ISO_FAST_ISR_GPIO1_DA_write_data(data)                                       (0x00000001&((data)<<0))
+#define ISO_FAST_ISR_GPIO1_DA_write_data_src(data)                                   ((0x00000001&(data))>>0)
+#define ISO_FAST_ISR_GPIO1_DA_get_write_data(data)                                   ((0x00000001&(data))>>0)
+
+
+#define ISO_I2C1_REQ_CTRL                                                            0x98007200
+#define ISO_I2C1_REQ_CTRL_reg_addr                                                   "0xD8007200"
+#define ISO_I2C1_REQ_CTRL_reg                                                        0xD8007200
+#define set_ISO_I2C1_REQ_CTRL_reg(data)   (*((volatile unsigned int*) ISO_I2C1_REQ_CTRL_reg)=data)
+#define get_ISO_I2C1_REQ_CTRL_reg   (*((volatile unsigned int*) ISO_I2C1_REQ_CTRL_reg))
+#define ISO_I2C1_REQ_CTRL_inst_adr                                                   "0x0080"
+#define ISO_I2C1_REQ_CTRL_inst                                                       0x0080
+#define ISO_I2C1_REQ_CTRL_int_en_shift                                               (1)
+#define ISO_I2C1_REQ_CTRL_int_en_mask                                                (0x00000002)
+#define ISO_I2C1_REQ_CTRL_int_en(data)                                               (0x00000002&((data)<<1))
+#define ISO_I2C1_REQ_CTRL_int_en_src(data)                                           ((0x00000002&(data))>>1)
+#define ISO_I2C1_REQ_CTRL_get_int_en(data)                                           ((0x00000002&(data))>>1)
+#define ISO_I2C1_REQ_CTRL_en_shift                                                   (0)
+#define ISO_I2C1_REQ_CTRL_en_mask                                                    (0x00000001)
+#define ISO_I2C1_REQ_CTRL_en(data)                                                   (0x00000001&((data)<<0))
+#define ISO_I2C1_REQ_CTRL_en_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_I2C1_REQ_CTRL_get_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_I2C1_REQ_START                                                           0x98007204
+#define ISO_I2C1_REQ_START_reg_addr                                                  "0xD8007204"
+#define ISO_I2C1_REQ_START_reg                                                       0xD8007204
+#define set_ISO_I2C1_REQ_START_reg(data)   (*((volatile unsigned int*) ISO_I2C1_REQ_START_reg)=data)
+#define get_ISO_I2C1_REQ_START_reg   (*((volatile unsigned int*) ISO_I2C1_REQ_START_reg))
+#define ISO_I2C1_REQ_START_inst_adr                                                  "0x0081"
+#define ISO_I2C1_REQ_START_inst                                                      0x0081
+#define ISO_I2C1_REQ_START_val_shift                                                 (0)
+#define ISO_I2C1_REQ_START_val_mask                                                  (0x0000FFFF)
+#define ISO_I2C1_REQ_START_val(data)                                                 (0x0000FFFF&((data)<<0))
+#define ISO_I2C1_REQ_START_val_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define ISO_I2C1_REQ_START_get_val(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_I2C1_REQ_SCL_LCNT                                                        0x98007208
+#define ISO_I2C1_REQ_SCL_LCNT_reg_addr                                               "0xD8007208"
+#define ISO_I2C1_REQ_SCL_LCNT_reg                                                    0xD8007208
+#define set_ISO_I2C1_REQ_SCL_LCNT_reg(data)   (*((volatile unsigned int*) ISO_I2C1_REQ_SCL_LCNT_reg)=data)
+#define get_ISO_I2C1_REQ_SCL_LCNT_reg   (*((volatile unsigned int*) ISO_I2C1_REQ_SCL_LCNT_reg))
+#define ISO_I2C1_REQ_SCL_LCNT_inst_adr                                               "0x0082"
+#define ISO_I2C1_REQ_SCL_LCNT_inst                                                   0x0082
+#define ISO_I2C1_REQ_SCL_LCNT_val_shift                                              (0)
+#define ISO_I2C1_REQ_SCL_LCNT_val_mask                                               (0x0000FFFF)
+#define ISO_I2C1_REQ_SCL_LCNT_val(data)                                              (0x0000FFFF&((data)<<0))
+#define ISO_I2C1_REQ_SCL_LCNT_val_src(data)                                          ((0x0000FFFF&(data))>>0)
+#define ISO_I2C1_REQ_SCL_LCNT_get_val(data)                                          ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_I2C1_REQ_STOP                                                            0x9800720C
+#define ISO_I2C1_REQ_STOP_reg_addr                                                   "0xD800720C"
+#define ISO_I2C1_REQ_STOP_reg                                                        0xD800720C
+#define set_ISO_I2C1_REQ_STOP_reg(data)   (*((volatile unsigned int*) ISO_I2C1_REQ_STOP_reg)=data)
+#define get_ISO_I2C1_REQ_STOP_reg   (*((volatile unsigned int*) ISO_I2C1_REQ_STOP_reg))
+#define ISO_I2C1_REQ_STOP_inst_adr                                                   "0x0083"
+#define ISO_I2C1_REQ_STOP_inst                                                       0x0083
+#define ISO_I2C1_REQ_STOP_val_shift                                                  (0)
+#define ISO_I2C1_REQ_STOP_val_mask                                                   (0x0000FFFF)
+#define ISO_I2C1_REQ_STOP_val(data)                                                  (0x0000FFFF&((data)<<0))
+#define ISO_I2C1_REQ_STOP_val_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define ISO_I2C1_REQ_STOP_get_val(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_POR_CTRL                                                                 0x98007210
+#define ISO_POR_CTRL_reg_addr                                                        "0xD8007210"
+#define ISO_POR_CTRL_reg                                                             0xD8007210
+#define set_ISO_POR_CTRL_reg(data)   (*((volatile unsigned int*) ISO_POR_CTRL_reg)=data)
+#define get_ISO_POR_CTRL_reg   (*((volatile unsigned int*) ISO_POR_CTRL_reg))
+#define ISO_POR_CTRL_inst_adr                                                        "0x0084"
+#define ISO_POR_CTRL_inst                                                            0x0084
+#define ISO_POR_CTRL_dv_cen_int_en_shift                                             (5)
+#define ISO_POR_CTRL_dv_cen_int_en_mask                                              (0x00000020)
+#define ISO_POR_CTRL_dv_cen_int_en(data)                                             (0x00000020&((data)<<5))
+#define ISO_POR_CTRL_dv_cen_int_en_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_POR_CTRL_get_dv_cen_int_en(data)                                         ((0x00000020&(data))>>5)
+#define ISO_POR_CTRL_dv_cen_ha_shift                                                 (4)
+#define ISO_POR_CTRL_dv_cen_ha_mask                                                  (0x00000010)
+#define ISO_POR_CTRL_dv_cen_ha(data)                                                 (0x00000010&((data)<<4))
+#define ISO_POR_CTRL_dv_cen_ha_src(data)                                             ((0x00000010&(data))>>4)
+#define ISO_POR_CTRL_get_dv_cen_ha(data)                                             ((0x00000010&(data))>>4)
+#define ISO_POR_CTRL_av_cen_int_en_shift                                             (1)
+#define ISO_POR_CTRL_av_cen_int_en_mask                                              (0x00000002)
+#define ISO_POR_CTRL_av_cen_int_en(data)                                             (0x00000002&((data)<<1))
+#define ISO_POR_CTRL_av_cen_int_en_src(data)                                         ((0x00000002&(data))>>1)
+#define ISO_POR_CTRL_get_av_cen_int_en(data)                                         ((0x00000002&(data))>>1)
+#define ISO_POR_CTRL_av_cen_ha_shift                                                 (0)
+#define ISO_POR_CTRL_av_cen_ha_mask                                                  (0x00000001)
+#define ISO_POR_CTRL_av_cen_ha(data)                                                 (0x00000001&((data)<<0))
+#define ISO_POR_CTRL_av_cen_ha_src(data)                                             ((0x00000001&(data))>>0)
+#define ISO_POR_CTRL_get_av_cen_ha(data)                                             ((0x00000001&(data))>>0)
+
+
+#define ISO_POR_VTH                                                                  0x98007214
+#define ISO_POR_VTH_reg_addr                                                         "0xD8007214"
+#define ISO_POR_VTH_reg                                                              0xD8007214
+#define set_ISO_POR_VTH_reg(data)   (*((volatile unsigned int*) ISO_POR_VTH_reg)=data)
+#define get_ISO_POR_VTH_reg   (*((volatile unsigned int*) ISO_POR_VTH_reg))
+#define ISO_POR_VTH_inst_adr                                                         "0x0085"
+#define ISO_POR_VTH_inst                                                             0x0085
+#define ISO_POR_VTH_reg_iso_por_shift                                                (24)
+#define ISO_POR_VTH_reg_iso_por_mask                                                 (0x01000000)
+#define ISO_POR_VTH_reg_iso_por(data)                                                (0x01000000&((data)<<24))
+#define ISO_POR_VTH_reg_iso_por_src(data)                                            ((0x01000000&(data))>>24)
+#define ISO_POR_VTH_get_reg_iso_por(data)                                            ((0x01000000&(data))>>24)
+#define ISO_POR_VTH_reg_gpu_por_shift                                                (20)
+#define ISO_POR_VTH_reg_gpu_por_mask                                                 (0x00300000)
+#define ISO_POR_VTH_reg_gpu_por(data)                                                (0x00300000&((data)<<20))
+#define ISO_POR_VTH_reg_gpu_por_src(data)                                            ((0x00300000&(data))>>20)
+#define ISO_POR_VTH_get_reg_gpu_por(data)                                            ((0x00300000&(data))>>20)
+#define ISO_POR_VTH_reg_scpu_mem_por_shift                                           (16)
+#define ISO_POR_VTH_reg_scpu_mem_por_mask                                            (0x00030000)
+#define ISO_POR_VTH_reg_scpu_mem_por(data)                                           (0x00030000&((data)<<16))
+#define ISO_POR_VTH_reg_scpu_mem_por_src(data)                                       ((0x00030000&(data))>>16)
+#define ISO_POR_VTH_get_reg_scpu_mem_por(data)                                       ((0x00030000&(data))>>16)
+#define ISO_POR_VTH_reg_scpu_por_shift                                               (12)
+#define ISO_POR_VTH_reg_scpu_por_mask                                                (0x00003000)
+#define ISO_POR_VTH_reg_scpu_por(data)                                               (0x00003000&((data)<<12))
+#define ISO_POR_VTH_reg_scpu_por_src(data)                                           ((0x00003000&(data))>>12)
+#define ISO_POR_VTH_get_reg_scpu_por(data)                                           ((0x00003000&(data))>>12)
+#define ISO_POR_VTH_reg_dvth_por_shift                                               (8)
+#define ISO_POR_VTH_reg_dvth_por_mask                                                (0x00000300)
+#define ISO_POR_VTH_reg_dvth_por(data)                                               (0x00000300&((data)<<8))
+#define ISO_POR_VTH_reg_dvth_por_src(data)                                           ((0x00000300&(data))>>8)
+#define ISO_POR_VTH_get_reg_dvth_por(data)                                           ((0x00000300&(data))>>8)
+#define ISO_POR_VTH_reg_avth_por_shift                                               (4)
+#define ISO_POR_VTH_reg_avth_por_mask                                                (0x00000030)
+#define ISO_POR_VTH_reg_avth_por(data)                                               (0x00000030&((data)<<4))
+#define ISO_POR_VTH_reg_avth_por_src(data)                                           ((0x00000030&(data))>>4)
+#define ISO_POR_VTH_get_reg_avth_por(data)                                           ((0x00000030&(data))>>4)
+#define ISO_POR_VTH_reg_d10_por_shift                                                (0)
+#define ISO_POR_VTH_reg_d10_por_mask                                                 (0x00000003)
+#define ISO_POR_VTH_reg_d10_por(data)                                                (0x00000003&((data)<<0))
+#define ISO_POR_VTH_reg_d10_por_src(data)                                            ((0x00000003&(data))>>0)
+#define ISO_POR_VTH_get_reg_d10_por(data)                                            ((0x00000003&(data))>>0)
+
+
+#define ISO_POR_DATAI                                                                0x98007218
+#define ISO_POR_DATAI_reg_addr                                                       "0xD8007218"
+#define ISO_POR_DATAI_reg                                                            0xD8007218
+#define set_ISO_POR_DATAI_reg(data)   (*((volatile unsigned int*) ISO_POR_DATAI_reg)=data)
+#define get_ISO_POR_DATAI_reg   (*((volatile unsigned int*) ISO_POR_DATAI_reg))
+#define ISO_POR_DATAI_inst_adr                                                       "0x0086"
+#define ISO_POR_DATAI_inst                                                           0x0086
+#define ISO_POR_DATAI_porb_dv_cen_l_shift                                            (4)
+#define ISO_POR_DATAI_porb_dv_cen_l_mask                                             (0x00000010)
+#define ISO_POR_DATAI_porb_dv_cen_l(data)                                            (0x00000010&((data)<<4))
+#define ISO_POR_DATAI_porb_dv_cen_l_src(data)                                        ((0x00000010&(data))>>4)
+#define ISO_POR_DATAI_get_porb_dv_cen_l(data)                                        ((0x00000010&(data))>>4)
+#define ISO_POR_DATAI_porb_av_cen_l_shift                                            (0)
+#define ISO_POR_DATAI_porb_av_cen_l_mask                                             (0x00000001)
+#define ISO_POR_DATAI_porb_av_cen_l(data)                                            (0x00000001&((data)<<0))
+#define ISO_POR_DATAI_porb_av_cen_l_src(data)                                        ((0x00000001&(data))>>0)
+#define ISO_POR_DATAI_get_porb_av_cen_l(data)                                        ((0x00000001&(data))>>0)
+
+
+#define ISO_POR_DEB                                                                  0x9800721C
+#define ISO_POR_DEB_reg_addr                                                         "0xD800721C"
+#define ISO_POR_DEB_reg                                                              0xD800721C
+#define set_ISO_POR_DEB_reg(data)   (*((volatile unsigned int*) ISO_POR_DEB_reg)=data)
+#define get_ISO_POR_DEB_reg   (*((volatile unsigned int*) ISO_POR_DEB_reg))
+#define ISO_POR_DEB_inst_adr                                                         "0x0087"
+#define ISO_POR_DEB_inst                                                             0x0087
+#define ISO_POR_DEB_write_en2_shift                                                  (7)
+#define ISO_POR_DEB_write_en2_mask                                                   (0x00000080)
+#define ISO_POR_DEB_write_en2(data)                                                  (0x00000080&((data)<<7))
+#define ISO_POR_DEB_write_en2_src(data)                                              ((0x00000080&(data))>>7)
+#define ISO_POR_DEB_get_write_en2(data)                                              ((0x00000080&(data))>>7)
+#define ISO_POR_DEB_dv_cen_shift                                                     (4)
+#define ISO_POR_DEB_dv_cen_mask                                                      (0x00000070)
+#define ISO_POR_DEB_dv_cen(data)                                                     (0x00000070&((data)<<4))
+#define ISO_POR_DEB_dv_cen_src(data)                                                 ((0x00000070&(data))>>4)
+#define ISO_POR_DEB_get_dv_cen(data)                                                 ((0x00000070&(data))>>4)
+#define ISO_POR_DEB_write_en1_shift                                                  (3)
+#define ISO_POR_DEB_write_en1_mask                                                   (0x00000008)
+#define ISO_POR_DEB_write_en1(data)                                                  (0x00000008&((data)<<3))
+#define ISO_POR_DEB_write_en1_src(data)                                              ((0x00000008&(data))>>3)
+#define ISO_POR_DEB_get_write_en1(data)                                              ((0x00000008&(data))>>3)
+#define ISO_POR_DEB_av_cen_shift                                                     (0)
+#define ISO_POR_DEB_av_cen_mask                                                      (0x00000007)
+#define ISO_POR_DEB_av_cen(data)                                                     (0x00000007&((data)<<0))
+#define ISO_POR_DEB_av_cen_src(data)                                                 ((0x00000007&(data))>>0)
+#define ISO_POR_DEB_get_av_cen(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define ISO_SB2_0                                                                    0x98007F00
+#define ISO_SB2_0_reg_addr                                                           "0xD8007F00"
+#define ISO_SB2_0_reg                                                                0xD8007F00
+#define set_ISO_SB2_0_reg(data)   (*((volatile unsigned int*) ISO_SB2_0_reg)=data)
+#define get_ISO_SB2_0_reg   (*((volatile unsigned int*) ISO_SB2_0_reg))
+#define ISO_SB2_0_inst_adr                                                           "0x00C0"
+#define ISO_SB2_0_inst                                                               0x00C0
+#define ISO_SB2_0_ve_fo_block_nwc_shift                                              (7)
+#define ISO_SB2_0_ve_fo_block_nwc_mask                                               (0x00000080)
+#define ISO_SB2_0_ve_fo_block_nwc(data)                                              (0x00000080&((data)<<7))
+#define ISO_SB2_0_ve_fo_block_nwc_src(data)                                          ((0x00000080&(data))>>7)
+#define ISO_SB2_0_get_ve_fo_block_nwc(data)                                          ((0x00000080&(data))>>7)
+#define ISO_SB2_0_tp_block_nwc_shift                                                 (6)
+#define ISO_SB2_0_tp_block_nwc_mask                                                  (0x00000040)
+#define ISO_SB2_0_tp_block_nwc(data)                                                 (0x00000040&((data)<<6))
+#define ISO_SB2_0_tp_block_nwc_src(data)                                             ((0x00000040&(data))>>6)
+#define ISO_SB2_0_get_tp_block_nwc(data)                                             ((0x00000040&(data))>>6)
+#define ISO_SB2_0_usb2sram_ctrl_shift                                                (5)
+#define ISO_SB2_0_usb2sram_ctrl_mask                                                 (0x00000020)
+#define ISO_SB2_0_usb2sram_ctrl(data)                                                (0x00000020&((data)<<5))
+#define ISO_SB2_0_usb2sram_ctrl_src(data)                                            ((0x00000020&(data))>>5)
+#define ISO_SB2_0_get_usb2sram_ctrl(data)                                            ((0x00000020&(data))>>5)
+#define ISO_SB2_0_ve_encode_block_nwc_shift                                          (4)
+#define ISO_SB2_0_ve_encode_block_nwc_mask                                           (0x00000010)
+#define ISO_SB2_0_ve_encode_block_nwc(data)                                          (0x00000010&((data)<<4))
+#define ISO_SB2_0_ve_encode_block_nwc_src(data)                                      ((0x00000010&(data))>>4)
+#define ISO_SB2_0_get_ve_encode_block_nwc(data)                                      ((0x00000010&(data))>>4)
+#define ISO_SB2_0_ve_block_nwc_shift                                                 (3)
+#define ISO_SB2_0_ve_block_nwc_mask                                                  (0x00000008)
+#define ISO_SB2_0_ve_block_nwc(data)                                                 (0x00000008&((data)<<3))
+#define ISO_SB2_0_ve_block_nwc_src(data)                                             ((0x00000008&(data))>>3)
+#define ISO_SB2_0_get_ve_block_nwc(data)                                             ((0x00000008&(data))>>3)
+#define ISO_SB2_0_vo_block_nwc_shift                                                 (2)
+#define ISO_SB2_0_vo_block_nwc_mask                                                  (0x00000004)
+#define ISO_SB2_0_vo_block_nwc(data)                                                 (0x00000004&((data)<<2))
+#define ISO_SB2_0_vo_block_nwc_src(data)                                             ((0x00000004&(data))>>2)
+#define ISO_SB2_0_get_vo_block_nwc(data)                                             ((0x00000004&(data))>>2)
+#define ISO_SB2_0_dc_mem_port_lock_shift                                             (1)
+#define ISO_SB2_0_dc_mem_port_lock_mask                                              (0x00000002)
+#define ISO_SB2_0_dc_mem_port_lock(data)                                             (0x00000002&((data)<<1))
+#define ISO_SB2_0_dc_mem_port_lock_src(data)                                         ((0x00000002&(data))>>1)
+#define ISO_SB2_0_get_dc_mem_port_lock(data)                                         ((0x00000002&(data))>>1)
+#define ISO_SB2_0_secure_rbus_shift                                                  (0)
+#define ISO_SB2_0_secure_rbus_mask                                                   (0x00000001)
+#define ISO_SB2_0_secure_rbus(data)                                                  (0x00000001&((data)<<0))
+#define ISO_SB2_0_secure_rbus_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_SB2_0_get_secure_rbus(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_MBIAS                                                                    0x98007F04
+#define ISO_MBIAS_reg_addr                                                           "0xD8007F04"
+#define ISO_MBIAS_reg                                                                0xD8007F04
+#define set_ISO_MBIAS_reg(data)   (*((volatile unsigned int*) ISO_MBIAS_reg)=data)
+#define get_ISO_MBIAS_reg   (*((volatile unsigned int*) ISO_MBIAS_reg))
+#define ISO_MBIAS_inst_adr                                                           "0x00C1"
+#define ISO_MBIAS_inst                                                               0x00C1
+#define ISO_MBIAS_reg_emb_i_sel_shift                                                (14)
+#define ISO_MBIAS_reg_emb_i_sel_mask                                                 (0x00004000)
+#define ISO_MBIAS_reg_emb_i_sel(data)                                                (0x00004000&((data)<<14))
+#define ISO_MBIAS_reg_emb_i_sel_src(data)                                            ((0x00004000&(data))>>14)
+#define ISO_MBIAS_get_reg_emb_i_sel(data)                                            ((0x00004000&(data))>>14)
+#define ISO_MBIAS_reg_emb_cap_sel_shift                                              (12)
+#define ISO_MBIAS_reg_emb_cap_sel_mask                                               (0x00003000)
+#define ISO_MBIAS_reg_emb_cap_sel(data)                                              (0x00003000&((data)<<12))
+#define ISO_MBIAS_reg_emb_cap_sel_src(data)                                          ((0x00003000&(data))>>12)
+#define ISO_MBIAS_get_reg_emb_cap_sel(data)                                          ((0x00003000&(data))>>12)
+#define ISO_MBIAS_reg_bg_rbgloop2_shift                                              (9)
+#define ISO_MBIAS_reg_bg_rbgloop2_mask                                               (0x00000E00)
+#define ISO_MBIAS_reg_bg_rbgloop2(data)                                              (0x00000E00&((data)<<9))
+#define ISO_MBIAS_reg_bg_rbgloop2_src(data)                                          ((0x00000E00&(data))>>9)
+#define ISO_MBIAS_get_reg_bg_rbgloop2(data)                                          ((0x00000E00&(data))>>9)
+#define ISO_MBIAS_reg_bg_rbg_shift                                                   (6)
+#define ISO_MBIAS_reg_bg_rbg_mask                                                    (0x000001C0)
+#define ISO_MBIAS_reg_bg_rbg(data)                                                   (0x000001C0&((data)<<6))
+#define ISO_MBIAS_reg_bg_rbg_src(data)                                               ((0x000001C0&(data))>>6)
+#define ISO_MBIAS_get_reg_bg_rbg(data)                                               ((0x000001C0&(data))>>6)
+#define ISO_MBIAS_reg_bg_rbg2_shift                                                  (4)
+#define ISO_MBIAS_reg_bg_rbg2_mask                                                   (0x00000030)
+#define ISO_MBIAS_reg_bg_rbg2(data)                                                  (0x00000030&((data)<<4))
+#define ISO_MBIAS_reg_bg_rbg2_src(data)                                              ((0x00000030&(data))>>4)
+#define ISO_MBIAS_get_reg_bg_rbg2(data)                                              ((0x00000030&(data))>>4)
+#define ISO_MBIAS_reg_bg_envbgup_shift                                               (3)
+#define ISO_MBIAS_reg_bg_envbgup_mask                                                (0x00000008)
+#define ISO_MBIAS_reg_bg_envbgup(data)                                               (0x00000008&((data)<<3))
+#define ISO_MBIAS_reg_bg_envbgup_src(data)                                           ((0x00000008&(data))>>3)
+#define ISO_MBIAS_get_reg_bg_envbgup(data)                                           ((0x00000008&(data))>>3)
+#define ISO_MBIAS_reg_ck_dummy_shift                                                 (2)
+#define ISO_MBIAS_reg_ck_dummy_mask                                                  (0x00000004)
+#define ISO_MBIAS_reg_ck_dummy(data)                                                 (0x00000004&((data)<<2))
+#define ISO_MBIAS_reg_ck_dummy_src(data)                                             ((0x00000004&(data))>>2)
+#define ISO_MBIAS_get_reg_ck_dummy(data)                                             ((0x00000004&(data))>>2)
+#define ISO_MBIAS_reg_bg_dummy_shift                                                 (1)
+#define ISO_MBIAS_reg_bg_dummy_mask                                                  (0x00000002)
+#define ISO_MBIAS_reg_bg_dummy(data)                                                 (0x00000002&((data)<<1))
+#define ISO_MBIAS_reg_bg_dummy_src(data)                                             ((0x00000002&(data))>>1)
+#define ISO_MBIAS_get_reg_bg_dummy(data)                                             ((0x00000002&(data))>>1)
+#define ISO_MBIAS_reg_en_emb_shift                                                   (0)
+#define ISO_MBIAS_reg_en_emb_mask                                                    (0x00000001)
+#define ISO_MBIAS_reg_en_emb(data)                                                   (0x00000001&((data)<<0))
+#define ISO_MBIAS_reg_en_emb_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_MBIAS_get_reg_en_emb(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_DDR_IO_CTRL                                                              0x98007F08
+#define ISO_DDR_IO_CTRL_reg_addr                                                     "0xD8007F08"
+#define ISO_DDR_IO_CTRL_reg                                                          0xD8007F08
+#define set_ISO_DDR_IO_CTRL_reg(data)   (*((volatile unsigned int*) ISO_DDR_IO_CTRL_reg)=data)
+#define get_ISO_DDR_IO_CTRL_reg   (*((volatile unsigned int*) ISO_DDR_IO_CTRL_reg))
+#define ISO_DDR_IO_CTRL_inst_adr                                                     "0x00C2"
+#define ISO_DDR_IO_CTRL_inst                                                         0x00C2
+#define ISO_DDR_IO_CTRL_reg_por15n_1_shift                                           (3)
+#define ISO_DDR_IO_CTRL_reg_por15n_1_mask                                            (0x00000008)
+#define ISO_DDR_IO_CTRL_reg_por15n_1(data)                                           (0x00000008&((data)<<3))
+#define ISO_DDR_IO_CTRL_reg_por15n_1_src(data)                                       ((0x00000008&(data))>>3)
+#define ISO_DDR_IO_CTRL_get_reg_por15n_1(data)                                       ((0x00000008&(data))>>3)
+#define ISO_DDR_IO_CTRL_reg_por15n_0_shift                                           (2)
+#define ISO_DDR_IO_CTRL_reg_por15n_0_mask                                            (0x00000004)
+#define ISO_DDR_IO_CTRL_reg_por15n_0(data)                                           (0x00000004&((data)<<2))
+#define ISO_DDR_IO_CTRL_reg_por15n_0_src(data)                                       ((0x00000004&(data))>>2)
+#define ISO_DDR_IO_CTRL_get_reg_por15n_0(data)                                       ((0x00000004&(data))>>2)
+#define ISO_DDR_IO_CTRL_reg_pwdpad15n_1_shift                                        (1)
+#define ISO_DDR_IO_CTRL_reg_pwdpad15n_1_mask                                         (0x00000002)
+#define ISO_DDR_IO_CTRL_reg_pwdpad15n_1(data)                                        (0x00000002&((data)<<1))
+#define ISO_DDR_IO_CTRL_reg_pwdpad15n_1_src(data)                                    ((0x00000002&(data))>>1)
+#define ISO_DDR_IO_CTRL_get_reg_pwdpad15n_1(data)                                    ((0x00000002&(data))>>1)
+#define ISO_DDR_IO_CTRL_reg_pwdpad15n_0_shift                                        (0)
+#define ISO_DDR_IO_CTRL_reg_pwdpad15n_0_mask                                         (0x00000001)
+#define ISO_DDR_IO_CTRL_reg_pwdpad15n_0(data)                                        (0x00000001&((data)<<0))
+#define ISO_DDR_IO_CTRL_reg_pwdpad15n_0_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_DDR_IO_CTRL_get_reg_pwdpad15n_0(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_DISP_IO_CTRL                                                             0x98007F0C
+#define ISO_DISP_IO_CTRL_reg_addr                                                    "0xD8007F0C"
+#define ISO_DISP_IO_CTRL_reg                                                         0xD8007F0C
+#define set_ISO_DISP_IO_CTRL_reg(data)   (*((volatile unsigned int*) ISO_DISP_IO_CTRL_reg)=data)
+#define get_ISO_DISP_IO_CTRL_reg   (*((volatile unsigned int*) ISO_DISP_IO_CTRL_reg))
+#define ISO_DISP_IO_CTRL_inst_adr                                                    "0x00C3"
+#define ISO_DISP_IO_CTRL_inst                                                        0x00C3
+#define ISO_DISP_IO_CTRL_reg_pwdpad3_disp_shift                                      (0)
+#define ISO_DISP_IO_CTRL_reg_pwdpad3_disp_mask                                       (0x00000001)
+#define ISO_DISP_IO_CTRL_reg_pwdpad3_disp(data)                                      (0x00000001&((data)<<0))
+#define ISO_DISP_IO_CTRL_reg_pwdpad3_disp_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_DISP_IO_CTRL_get_reg_pwdpad3_disp(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_SB3_CTRL                                                                 0x98007f10
+#define ISO_SB3_CTRL_reg_addr                                                        "0xD8007F10"
+#define ISO_SB3_CTRL_reg                                                             0xD8007F10
+#define set_ISO_SB3_CTRL_reg(data)   (*((volatile unsigned int*) ISO_SB3_CTRL_reg)=data)
+#define get_ISO_SB3_CTRL_reg   (*((volatile unsigned int*) ISO_SB3_CTRL_reg))
+#define ISO_SB3_CTRL_inst_adr                                                        "0x00C4"
+#define ISO_SB3_CTRL_inst                                                            0x00C4
+#define ISO_SB3_CTRL_iso_sb3_req_mask_reg_shift                                      (0)
+#define ISO_SB3_CTRL_iso_sb3_req_mask_reg_mask                                       (0x00000001)
+#define ISO_SB3_CTRL_iso_sb3_req_mask_reg(data)                                      (0x00000001&((data)<<0))
+#define ISO_SB3_CTRL_iso_sb3_req_mask_reg_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_SB3_CTRL_get_iso_sb3_req_mask_reg(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_ISO_TMUX_DBG                                                             0x98007f14
+#define ISO_ISO_TMUX_DBG_reg_addr                                                    "0xD8007F14"
+#define ISO_ISO_TMUX_DBG_reg                                                         0xD8007F14
+#define set_ISO_ISO_TMUX_DBG_reg(data)   (*((volatile unsigned int*) ISO_ISO_TMUX_DBG_reg)=data)
+#define get_ISO_ISO_TMUX_DBG_reg   (*((volatile unsigned int*) ISO_ISO_TMUX_DBG_reg))
+#define ISO_ISO_TMUX_DBG_inst_adr                                                    "0x00C5"
+#define ISO_ISO_TMUX_DBG_inst                                                        0x00C5
+#define ISO_ISO_TMUX_DBG_tmux_dbg_sel_shift                                          (0)
+#define ISO_ISO_TMUX_DBG_tmux_dbg_sel_mask                                           (0x0000007F)
+#define ISO_ISO_TMUX_DBG_tmux_dbg_sel(data)                                          (0x0000007F&((data)<<0))
+#define ISO_ISO_TMUX_DBG_tmux_dbg_sel_src(data)                                      ((0x0000007F&(data))>>0)
+#define ISO_ISO_TMUX_DBG_get_tmux_dbg_sel(data)                                      ((0x0000007F&(data))>>0)
+
+
+#define ISO_ISO_MODE_REG_0                                                           0x98007F20
+#define ISO_ISO_MODE_REG_1                                                           0x98007F24
+#define ISO_ISO_MODE_REG_2                                                           0x98007F28
+#define ISO_ISO_MODE_REG_3                                                           0x98007F2C
+#define ISO_ISO_MODE_REG_4                                                           0x98007F30
+#define ISO_ISO_MODE_REG_5                                                           0x98007F34
+#define ISO_ISO_MODE_REG_6                                                           0x98007F38
+#define ISO_ISO_MODE_REG_7                                                           0x98007F3C
+#define ISO_ISO_MODE_REG_8                                                           0x98007F40
+#define ISO_ISO_MODE_REG_9                                                           0x98007F44
+#define ISO_ISO_MODE_REG_10                                                           0x98007F48
+#define ISO_ISO_MODE_REG_11                                                           0x98007F4C
+#define ISO_ISO_MODE_REG_12                                                           0x98007F50
+#define ISO_ISO_MODE_REG_13                                                           0x98007F54
+#define ISO_ISO_MODE_REG_14                                                           0x98007F58
+#define ISO_ISO_MODE_REG_15                                                           0x98007F5C
+#define ISO_ISO_MODE_REG_16                                                           0x98007F60
+#define ISO_ISO_MODE_REG_17                                                           0x98007F64
+#define ISO_ISO_MODE_REG_18                                                           0x98007F68
+#define ISO_ISO_MODE_REG_19                                                           0x98007F6C
+#define ISO_ISO_MODE_REG_0_reg_addr                                                  "0xD8007F20"
+#define ISO_ISO_MODE_REG_1_reg_addr                                                  "0xD8007F24"
+#define ISO_ISO_MODE_REG_2_reg_addr                                                  "0xD8007F28"
+#define ISO_ISO_MODE_REG_3_reg_addr                                                  "0xD8007F2C"
+#define ISO_ISO_MODE_REG_4_reg_addr                                                  "0xD8007F30"
+#define ISO_ISO_MODE_REG_5_reg_addr                                                  "0xD8007F34"
+#define ISO_ISO_MODE_REG_6_reg_addr                                                  "0xD8007F38"
+#define ISO_ISO_MODE_REG_7_reg_addr                                                  "0xD8007F3C"
+#define ISO_ISO_MODE_REG_8_reg_addr                                                  "0xD8007F40"
+#define ISO_ISO_MODE_REG_9_reg_addr                                                  "0xD8007F44"
+#define ISO_ISO_MODE_REG_10_reg_addr                                                  "0xD8007F48"
+#define ISO_ISO_MODE_REG_11_reg_addr                                                  "0xD8007F4C"
+#define ISO_ISO_MODE_REG_12_reg_addr                                                  "0xD8007F50"
+#define ISO_ISO_MODE_REG_13_reg_addr                                                  "0xD8007F54"
+#define ISO_ISO_MODE_REG_14_reg_addr                                                  "0xD8007F58"
+#define ISO_ISO_MODE_REG_15_reg_addr                                                  "0xD8007F5C"
+#define ISO_ISO_MODE_REG_16_reg_addr                                                  "0xD8007F60"
+#define ISO_ISO_MODE_REG_17_reg_addr                                                  "0xD8007F64"
+#define ISO_ISO_MODE_REG_18_reg_addr                                                  "0xD8007F68"
+#define ISO_ISO_MODE_REG_19_reg_addr                                                  "0xD8007F6C"
+#define ISO_ISO_MODE_REG_0_reg                                                       0xD8007F20
+#define ISO_ISO_MODE_REG_1_reg                                                       0xD8007F24
+#define ISO_ISO_MODE_REG_2_reg                                                       0xD8007F28
+#define ISO_ISO_MODE_REG_3_reg                                                       0xD8007F2C
+#define ISO_ISO_MODE_REG_4_reg                                                       0xD8007F30
+#define ISO_ISO_MODE_REG_5_reg                                                       0xD8007F34
+#define ISO_ISO_MODE_REG_6_reg                                                       0xD8007F38
+#define ISO_ISO_MODE_REG_7_reg                                                       0xD8007F3C
+#define ISO_ISO_MODE_REG_8_reg                                                       0xD8007F40
+#define ISO_ISO_MODE_REG_9_reg                                                       0xD8007F44
+#define ISO_ISO_MODE_REG_10_reg                                                       0xD8007F48
+#define ISO_ISO_MODE_REG_11_reg                                                       0xD8007F4C
+#define ISO_ISO_MODE_REG_12_reg                                                       0xD8007F50
+#define ISO_ISO_MODE_REG_13_reg                                                       0xD8007F54
+#define ISO_ISO_MODE_REG_14_reg                                                       0xD8007F58
+#define ISO_ISO_MODE_REG_15_reg                                                       0xD8007F5C
+#define ISO_ISO_MODE_REG_16_reg                                                       0xD8007F60
+#define ISO_ISO_MODE_REG_17_reg                                                       0xD8007F64
+#define ISO_ISO_MODE_REG_18_reg                                                       0xD8007F68
+#define ISO_ISO_MODE_REG_19_reg                                                       0xD8007F6C
+#define set_ISO_ISO_MODE_REG_0_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_0_reg)=data)
+#define set_ISO_ISO_MODE_REG_1_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_1_reg)=data)
+#define set_ISO_ISO_MODE_REG_2_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_2_reg)=data)
+#define set_ISO_ISO_MODE_REG_3_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_3_reg)=data)
+#define set_ISO_ISO_MODE_REG_4_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_4_reg)=data)
+#define set_ISO_ISO_MODE_REG_5_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_5_reg)=data)
+#define set_ISO_ISO_MODE_REG_6_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_6_reg)=data)
+#define set_ISO_ISO_MODE_REG_7_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_7_reg)=data)
+#define set_ISO_ISO_MODE_REG_8_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_8_reg)=data)
+#define set_ISO_ISO_MODE_REG_9_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_9_reg)=data)
+#define set_ISO_ISO_MODE_REG_10_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_10_reg)=data)
+#define set_ISO_ISO_MODE_REG_11_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_11_reg)=data)
+#define set_ISO_ISO_MODE_REG_12_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_12_reg)=data)
+#define set_ISO_ISO_MODE_REG_13_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_13_reg)=data)
+#define set_ISO_ISO_MODE_REG_14_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_14_reg)=data)
+#define set_ISO_ISO_MODE_REG_15_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_15_reg)=data)
+#define set_ISO_ISO_MODE_REG_16_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_16_reg)=data)
+#define set_ISO_ISO_MODE_REG_17_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_17_reg)=data)
+#define set_ISO_ISO_MODE_REG_18_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_18_reg)=data)
+#define set_ISO_ISO_MODE_REG_19_reg(data)   (*((volatile unsigned int*) ISO_ISO_MODE_REG_19_reg)=data)
+#define get_ISO_ISO_MODE_REG_0_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_0_reg))
+#define get_ISO_ISO_MODE_REG_1_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_1_reg))
+#define get_ISO_ISO_MODE_REG_2_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_2_reg))
+#define get_ISO_ISO_MODE_REG_3_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_3_reg))
+#define get_ISO_ISO_MODE_REG_4_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_4_reg))
+#define get_ISO_ISO_MODE_REG_5_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_5_reg))
+#define get_ISO_ISO_MODE_REG_6_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_6_reg))
+#define get_ISO_ISO_MODE_REG_7_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_7_reg))
+#define get_ISO_ISO_MODE_REG_8_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_8_reg))
+#define get_ISO_ISO_MODE_REG_9_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_9_reg))
+#define get_ISO_ISO_MODE_REG_10_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_10_reg))
+#define get_ISO_ISO_MODE_REG_11_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_11_reg))
+#define get_ISO_ISO_MODE_REG_12_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_12_reg))
+#define get_ISO_ISO_MODE_REG_13_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_13_reg))
+#define get_ISO_ISO_MODE_REG_14_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_14_reg))
+#define get_ISO_ISO_MODE_REG_15_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_15_reg))
+#define get_ISO_ISO_MODE_REG_16_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_16_reg))
+#define get_ISO_ISO_MODE_REG_17_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_17_reg))
+#define get_ISO_ISO_MODE_REG_18_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_18_reg))
+#define get_ISO_ISO_MODE_REG_19_reg   (*((volatile unsigned int*) ISO_ISO_MODE_REG_19_reg))
+#define ISO_ISO_MODE_REG_0_inst_adr                                                  "0x00C8"
+#define ISO_ISO_MODE_REG_1_inst_adr                                                  "0x00C9"
+#define ISO_ISO_MODE_REG_2_inst_adr                                                  "0x00CA"
+#define ISO_ISO_MODE_REG_3_inst_adr                                                  "0x00CB"
+#define ISO_ISO_MODE_REG_4_inst_adr                                                  "0x00CC"
+#define ISO_ISO_MODE_REG_5_inst_adr                                                  "0x00CD"
+#define ISO_ISO_MODE_REG_6_inst_adr                                                  "0x00CE"
+#define ISO_ISO_MODE_REG_7_inst_adr                                                  "0x00CF"
+#define ISO_ISO_MODE_REG_8_inst_adr                                                  "0x00D0"
+#define ISO_ISO_MODE_REG_9_inst_adr                                                  "0x00D1"
+#define ISO_ISO_MODE_REG_10_inst_adr                                                  "0x00D2"
+#define ISO_ISO_MODE_REG_11_inst_adr                                                  "0x00D3"
+#define ISO_ISO_MODE_REG_12_inst_adr                                                  "0x00D4"
+#define ISO_ISO_MODE_REG_13_inst_adr                                                  "0x00D5"
+#define ISO_ISO_MODE_REG_14_inst_adr                                                  "0x00D6"
+#define ISO_ISO_MODE_REG_15_inst_adr                                                  "0x00D7"
+#define ISO_ISO_MODE_REG_16_inst_adr                                                  "0x00D8"
+#define ISO_ISO_MODE_REG_17_inst_adr                                                  "0x00D9"
+#define ISO_ISO_MODE_REG_18_inst_adr                                                  "0x00DA"
+#define ISO_ISO_MODE_REG_19_inst_adr                                                  "0x00DB"
+#define ISO_ISO_MODE_REG_0_inst                                                      0x00C8
+#define ISO_ISO_MODE_REG_1_inst                                                      0x00C9
+#define ISO_ISO_MODE_REG_2_inst                                                      0x00CA
+#define ISO_ISO_MODE_REG_3_inst                                                      0x00CB
+#define ISO_ISO_MODE_REG_4_inst                                                      0x00CC
+#define ISO_ISO_MODE_REG_5_inst                                                      0x00CD
+#define ISO_ISO_MODE_REG_6_inst                                                      0x00CE
+#define ISO_ISO_MODE_REG_7_inst                                                      0x00CF
+#define ISO_ISO_MODE_REG_8_inst                                                      0x00D0
+#define ISO_ISO_MODE_REG_9_inst                                                      0x00D1
+#define ISO_ISO_MODE_REG_10_inst                                                      0x00D2
+#define ISO_ISO_MODE_REG_11_inst                                                      0x00D3
+#define ISO_ISO_MODE_REG_12_inst                                                      0x00D4
+#define ISO_ISO_MODE_REG_13_inst                                                      0x00D5
+#define ISO_ISO_MODE_REG_14_inst                                                      0x00D6
+#define ISO_ISO_MODE_REG_15_inst                                                      0x00D7
+#define ISO_ISO_MODE_REG_16_inst                                                      0x00D8
+#define ISO_ISO_MODE_REG_17_inst                                                      0x00D9
+#define ISO_ISO_MODE_REG_18_inst                                                      0x00DA
+#define ISO_ISO_MODE_REG_19_inst                                                      0x00DB
+#define ISO_ISO_MODE_REG_dummy_shift                                                 (0)
+#define ISO_ISO_MODE_REG_dummy_mask                                                  (0xFFFFFFFF)
+#define ISO_ISO_MODE_REG_dummy(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_ISO_MODE_REG_dummy_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_ISO_MODE_REG_get_dummy(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB0_SRAM_PWR0                                                           0x98007f70
+#define ISO_USB0_SRAM_PWR0_reg_addr                                                  "0xD8007F70"
+#define ISO_USB0_SRAM_PWR0_reg                                                       0xD8007F70
+#define set_ISO_USB0_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR0_reg)=data)
+#define get_ISO_USB0_SRAM_PWR0_reg   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR0_reg))
+#define ISO_USB0_SRAM_PWR0_inst_adr                                                  "0x00DC"
+#define ISO_USB0_SRAM_PWR0_inst                                                      0x00DC
+#define ISO_USB0_SRAM_PWR0_l2h_delay_cycle_shift                                     (0)
+#define ISO_USB0_SRAM_PWR0_l2h_delay_cycle_mask                                      (0xFFFFFFFF)
+#define ISO_USB0_SRAM_PWR0_l2h_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_USB0_SRAM_PWR0_l2h_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB0_SRAM_PWR0_get_l2h_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB0_SRAM_PWR1                                                           0x98007f74
+#define ISO_USB0_SRAM_PWR1_reg_addr                                                  "0xD8007F74"
+#define ISO_USB0_SRAM_PWR1_reg                                                       0xD8007F74
+#define set_ISO_USB0_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR1_reg)=data)
+#define get_ISO_USB0_SRAM_PWR1_reg   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR1_reg))
+#define ISO_USB0_SRAM_PWR1_inst_adr                                                  "0x00DD"
+#define ISO_USB0_SRAM_PWR1_inst                                                      0x00DD
+#define ISO_USB0_SRAM_PWR1_h2l_delay_cycle_shift                                     (0)
+#define ISO_USB0_SRAM_PWR1_h2l_delay_cycle_mask                                      (0xFFFFFFFF)
+#define ISO_USB0_SRAM_PWR1_h2l_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_USB0_SRAM_PWR1_h2l_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB0_SRAM_PWR1_get_h2l_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB0_SRAM_PWR2                                                           0x98007f78
+#define ISO_USB0_SRAM_PWR2_reg_addr                                                  "0xD8007F78"
+#define ISO_USB0_SRAM_PWR2_reg                                                       0xD8007F78
+#define set_ISO_USB0_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR2_reg)=data)
+#define get_ISO_USB0_SRAM_PWR2_reg   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR2_reg))
+#define ISO_USB0_SRAM_PWR2_inst_adr                                                  "0x00DE"
+#define ISO_USB0_SRAM_PWR2_inst                                                      0x00DE
+#define ISO_USB0_SRAM_PWR2_sd_reg_shift                                              (0)
+#define ISO_USB0_SRAM_PWR2_sd_reg_mask                                               (0xFFFFFFFF)
+#define ISO_USB0_SRAM_PWR2_sd_reg(data)                                              (0xFFFFFFFF&((data)<<0))
+#define ISO_USB0_SRAM_PWR2_sd_reg_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB0_SRAM_PWR2_get_sd_reg(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB0_SRAM_PWR3                                                           0x98007f7c
+#define ISO_USB0_SRAM_PWR3_reg_addr                                                  "0xD8007F7C"
+#define ISO_USB0_SRAM_PWR3_reg                                                       0xD8007F7C
+#define set_ISO_USB0_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR3_reg)=data)
+#define get_ISO_USB0_SRAM_PWR3_reg   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR3_reg))
+#define ISO_USB0_SRAM_PWR3_inst_adr                                                  "0x00DF"
+#define ISO_USB0_SRAM_PWR3_inst                                                      0x00DF
+#define ISO_USB0_SRAM_PWR3_mux_reg_shift                                             (0)
+#define ISO_USB0_SRAM_PWR3_mux_reg_mask                                              (0xFFFFFFFF)
+#define ISO_USB0_SRAM_PWR3_mux_reg(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ISO_USB0_SRAM_PWR3_mux_reg_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB0_SRAM_PWR3_get_mux_reg(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB0_SRAM_PWR4                                                           0x98007f80
+#define ISO_USB0_SRAM_PWR4_reg_addr                                                  "0xD8007F80"
+#define ISO_USB0_SRAM_PWR4_reg                                                       0xD8007F80
+#define set_ISO_USB0_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR4_reg)=data)
+#define get_ISO_USB0_SRAM_PWR4_reg   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR4_reg))
+#define ISO_USB0_SRAM_PWR4_inst_adr                                                  "0x00E0"
+#define ISO_USB0_SRAM_PWR4_inst                                                      0x00E0
+#define ISO_USB0_SRAM_PWR4_ctrl_shift                                                (0)
+#define ISO_USB0_SRAM_PWR4_ctrl_mask                                                 (0xFFFFFFFF)
+#define ISO_USB0_SRAM_PWR4_ctrl(data)                                                (0xFFFFFFFF&((data)<<0))
+#define ISO_USB0_SRAM_PWR4_ctrl_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB0_SRAM_PWR4_get_ctrl(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB0_SRAM_PWR5                                                           0x98007f84
+#define ISO_USB0_SRAM_PWR5_reg_addr                                                  "0xD8007F84"
+#define ISO_USB0_SRAM_PWR5_reg                                                       0xD8007F84
+#define set_ISO_USB0_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR5_reg)=data)
+#define get_ISO_USB0_SRAM_PWR5_reg   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR5_reg))
+#define ISO_USB0_SRAM_PWR5_inst_adr                                                  "0x00E1"
+#define ISO_USB0_SRAM_PWR5_inst                                                      0x00E1
+#define ISO_USB0_SRAM_PWR5_ve3_sram_int_mask_shift                                   (4)
+#define ISO_USB0_SRAM_PWR5_ve3_sram_int_mask_mask                                    (0x00000010)
+//#define ISO_USB0_SRAM_PWR5_ve3_sram_int_mask(data)                                   (0x00000010&((data)<<4))
+#define ISO_USB0_SRAM_PWR5_ve3_sram_int_mask_src(data)                               ((0x00000010&(data))>>4)
+#define ISO_USB0_SRAM_PWR5_get_ve3_sram_int_mask(data)                               ((0x00000010&(data))>>4)
+#define ISO_USB0_SRAM_PWR5_ve3_sram_int_shift                                        (2)
+//#define ISO_USB0_SRAM_PWR5_ve3_sram_int_mask                                         (0x00000004)
+#define ISO_USB0_SRAM_PWR5_ve3_sram_int(data)                                        (0x00000004&((data)<<2))
+#define ISO_USB0_SRAM_PWR5_ve3_sram_int_src(data)                                    ((0x00000004&(data))>>2)
+#define ISO_USB0_SRAM_PWR5_get_ve3_sram_int(data)                                    ((0x00000004&(data))>>2)
+#define ISO_USB0_SRAM_PWR5_write_data_shift                                          (0)
+#define ISO_USB0_SRAM_PWR5_write_data_mask                                           (0x00000001)
+#define ISO_USB0_SRAM_PWR5_write_data(data)                                          (0x00000001&((data)<<0))
+#define ISO_USB0_SRAM_PWR5_write_data_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_USB0_SRAM_PWR5_get_write_data(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_USB0_SRAM_PWR6                                                           0x98007f88
+#define ISO_USB0_SRAM_PWR6_reg_addr                                                  "0xD8007F88"
+#define ISO_USB0_SRAM_PWR6_reg                                                       0xD8007F88
+#define set_ISO_USB0_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR6_reg)=data)
+#define get_ISO_USB0_SRAM_PWR6_reg   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR6_reg))
+#define ISO_USB0_SRAM_PWR6_inst_adr                                                  "0x00E2"
+#define ISO_USB0_SRAM_PWR6_inst                                                      0x00E2
+#define ISO_USB0_SRAM_PWR6_last_delay_cycle_shift                                    (0)
+#define ISO_USB0_SRAM_PWR6_last_delay_cycle_mask                                     (0xFFFFFFFF)
+#define ISO_USB0_SRAM_PWR6_last_delay_cycle(data)                                    (0xFFFFFFFF&((data)<<0))
+#define ISO_USB0_SRAM_PWR6_last_delay_cycle_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB0_SRAM_PWR6_get_last_delay_cycle(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB0_SRAM_PWR7                                                           0x98007f8c
+#define ISO_USB0_SRAM_PWR7_reg_addr                                                  "0xD8007F8C"
+#define ISO_USB0_SRAM_PWR7_reg                                                       0xD8007F8C
+#define set_ISO_USB0_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR7_reg)=data)
+#define get_ISO_USB0_SRAM_PWR7_reg   (*((volatile unsigned int*) ISO_USB0_SRAM_PWR7_reg))
+#define ISO_USB0_SRAM_PWR7_inst_adr                                                  "0x00E3"
+#define ISO_USB0_SRAM_PWR7_inst                                                      0x00E3
+#define ISO_USB0_SRAM_PWR7_pg_switch_info_shift                                      (0)
+#define ISO_USB0_SRAM_PWR7_pg_switch_info_mask                                       (0xFFFFFFFF)
+#define ISO_USB0_SRAM_PWR7_pg_switch_info(data)                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_USB0_SRAM_PWR7_pg_switch_info_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB0_SRAM_PWR7_get_pg_switch_info(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB1_SRAM_PWR0                                                           0x98007f90
+#define ISO_USB1_SRAM_PWR0_reg_addr                                                  "0xD8007F90"
+#define ISO_USB1_SRAM_PWR0_reg                                                       0xD8007F90
+#define set_ISO_USB1_SRAM_PWR0_reg(data)   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR0_reg)=data)
+#define get_ISO_USB1_SRAM_PWR0_reg   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR0_reg))
+#define ISO_USB1_SRAM_PWR0_inst_adr                                                  "0x00E4"
+#define ISO_USB1_SRAM_PWR0_inst                                                      0x00E4
+#define ISO_USB1_SRAM_PWR0_l2h_delay_cycle_shift                                     (0)
+#define ISO_USB1_SRAM_PWR0_l2h_delay_cycle_mask                                      (0xFFFFFFFF)
+#define ISO_USB1_SRAM_PWR0_l2h_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_USB1_SRAM_PWR0_l2h_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB1_SRAM_PWR0_get_l2h_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB1_SRAM_PWR1                                                           0x98007f94
+#define ISO_USB1_SRAM_PWR1_reg_addr                                                  "0xD8007F94"
+#define ISO_USB1_SRAM_PWR1_reg                                                       0xD8007F94
+#define set_ISO_USB1_SRAM_PWR1_reg(data)   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR1_reg)=data)
+#define get_ISO_USB1_SRAM_PWR1_reg   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR1_reg))
+#define ISO_USB1_SRAM_PWR1_inst_adr                                                  "0x00E5"
+#define ISO_USB1_SRAM_PWR1_inst                                                      0x00E5
+#define ISO_USB1_SRAM_PWR1_h2l_delay_cycle_shift                                     (0)
+#define ISO_USB1_SRAM_PWR1_h2l_delay_cycle_mask                                      (0xFFFFFFFF)
+#define ISO_USB1_SRAM_PWR1_h2l_delay_cycle(data)                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_USB1_SRAM_PWR1_h2l_delay_cycle_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB1_SRAM_PWR1_get_h2l_delay_cycle(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB1_SRAM_PWR2                                                           0x98007f98
+#define ISO_USB1_SRAM_PWR2_reg_addr                                                  "0xD8007F98"
+#define ISO_USB1_SRAM_PWR2_reg                                                       0xD8007F98
+#define set_ISO_USB1_SRAM_PWR2_reg(data)   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR2_reg)=data)
+#define get_ISO_USB1_SRAM_PWR2_reg   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR2_reg))
+#define ISO_USB1_SRAM_PWR2_inst_adr                                                  "0x00E6"
+#define ISO_USB1_SRAM_PWR2_inst                                                      0x00E6
+#define ISO_USB1_SRAM_PWR2_sd_reg_shift                                              (0)
+#define ISO_USB1_SRAM_PWR2_sd_reg_mask                                               (0xFFFFFFFF)
+#define ISO_USB1_SRAM_PWR2_sd_reg(data)                                              (0xFFFFFFFF&((data)<<0))
+#define ISO_USB1_SRAM_PWR2_sd_reg_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB1_SRAM_PWR2_get_sd_reg(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB1_SRAM_PWR3                                                           0x98007f9c
+#define ISO_USB1_SRAM_PWR3_reg_addr                                                  "0xD8007F9C"
+#define ISO_USB1_SRAM_PWR3_reg                                                       0xD8007F9C
+#define set_ISO_USB1_SRAM_PWR3_reg(data)   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR3_reg)=data)
+#define get_ISO_USB1_SRAM_PWR3_reg   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR3_reg))
+#define ISO_USB1_SRAM_PWR3_inst_adr                                                  "0x00E7"
+#define ISO_USB1_SRAM_PWR3_inst                                                      0x00E7
+#define ISO_USB1_SRAM_PWR3_mux_reg_shift                                             (0)
+#define ISO_USB1_SRAM_PWR3_mux_reg_mask                                              (0xFFFFFFFF)
+#define ISO_USB1_SRAM_PWR3_mux_reg(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ISO_USB1_SRAM_PWR3_mux_reg_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB1_SRAM_PWR3_get_mux_reg(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB1_SRAM_PWR4                                                           0x98007fa0
+#define ISO_USB1_SRAM_PWR4_reg_addr                                                  "0xD8007FA0"
+#define ISO_USB1_SRAM_PWR4_reg                                                       0xD8007FA0
+#define set_ISO_USB1_SRAM_PWR4_reg(data)   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR4_reg)=data)
+#define get_ISO_USB1_SRAM_PWR4_reg   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR4_reg))
+#define ISO_USB1_SRAM_PWR4_inst_adr                                                  "0x00E8"
+#define ISO_USB1_SRAM_PWR4_inst                                                      0x00E8
+#define ISO_USB1_SRAM_PWR4_ctrl_shift                                                (0)
+#define ISO_USB1_SRAM_PWR4_ctrl_mask                                                 (0xFFFFFFFF)
+#define ISO_USB1_SRAM_PWR4_ctrl(data)                                                (0xFFFFFFFF&((data)<<0))
+#define ISO_USB1_SRAM_PWR4_ctrl_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB1_SRAM_PWR4_get_ctrl(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB1_SRAM_PWR5                                                           0x98007fa4
+#define ISO_USB1_SRAM_PWR5_reg_addr                                                  "0xD8007FA4"
+#define ISO_USB1_SRAM_PWR5_reg                                                       0xD8007FA4
+#define set_ISO_USB1_SRAM_PWR5_reg(data)   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR5_reg)=data)
+#define get_ISO_USB1_SRAM_PWR5_reg   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR5_reg))
+#define ISO_USB1_SRAM_PWR5_inst_adr                                                  "0x00E9"
+#define ISO_USB1_SRAM_PWR5_inst                                                      0x00E9
+#define ISO_USB1_SRAM_PWR5_ve3_sram_int_mask_shift                                   (4)
+#define ISO_USB1_SRAM_PWR5_ve3_sram_int_mask_mask                                    (0x00000010)
+//#define ISO_USB1_SRAM_PWR5_ve3_sram_int_mask(data)                                   (0x00000010&((data)<<4))
+#define ISO_USB1_SRAM_PWR5_ve3_sram_int_mask_src(data)                               ((0x00000010&(data))>>4)
+#define ISO_USB1_SRAM_PWR5_get_ve3_sram_int_mask(data)                               ((0x00000010&(data))>>4)
+#define ISO_USB1_SRAM_PWR5_ve3_sram_int_shift                                        (2)
+//#define ISO_USB1_SRAM_PWR5_ve3_sram_int_mask                                         (0x00000004)
+#define ISO_USB1_SRAM_PWR5_ve3_sram_int(data)                                        (0x00000004&((data)<<2))
+#define ISO_USB1_SRAM_PWR5_ve3_sram_int_src(data)                                    ((0x00000004&(data))>>2)
+#define ISO_USB1_SRAM_PWR5_get_ve3_sram_int(data)                                    ((0x00000004&(data))>>2)
+#define ISO_USB1_SRAM_PWR5_write_data_shift                                          (0)
+#define ISO_USB1_SRAM_PWR5_write_data_mask                                           (0x00000001)
+#define ISO_USB1_SRAM_PWR5_write_data(data)                                          (0x00000001&((data)<<0))
+#define ISO_USB1_SRAM_PWR5_write_data_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_USB1_SRAM_PWR5_get_write_data(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_USB1_SRAM_PWR6                                                           0x98007fa8
+#define ISO_USB1_SRAM_PWR6_reg_addr                                                  "0xD8007FA8"
+#define ISO_USB1_SRAM_PWR6_reg                                                       0xD8007FA8
+#define set_ISO_USB1_SRAM_PWR6_reg(data)   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR6_reg)=data)
+#define get_ISO_USB1_SRAM_PWR6_reg   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR6_reg))
+#define ISO_USB1_SRAM_PWR6_inst_adr                                                  "0x00EA"
+#define ISO_USB1_SRAM_PWR6_inst                                                      0x00EA
+#define ISO_USB1_SRAM_PWR6_last_delay_cycle_shift                                    (0)
+#define ISO_USB1_SRAM_PWR6_last_delay_cycle_mask                                     (0xFFFFFFFF)
+#define ISO_USB1_SRAM_PWR6_last_delay_cycle(data)                                    (0xFFFFFFFF&((data)<<0))
+#define ISO_USB1_SRAM_PWR6_last_delay_cycle_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB1_SRAM_PWR6_get_last_delay_cycle(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB1_SRAM_PWR7                                                           0x98007fac
+#define ISO_USB1_SRAM_PWR7_reg_addr                                                  "0xD8007FAC"
+#define ISO_USB1_SRAM_PWR7_reg                                                       0xD8007FAC
+#define set_ISO_USB1_SRAM_PWR7_reg(data)   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR7_reg)=data)
+#define get_ISO_USB1_SRAM_PWR7_reg   (*((volatile unsigned int*) ISO_USB1_SRAM_PWR7_reg))
+#define ISO_USB1_SRAM_PWR7_inst_adr                                                  "0x00EB"
+#define ISO_USB1_SRAM_PWR7_inst                                                      0x00EB
+#define ISO_USB1_SRAM_PWR7_pg_switch_info_shift                                      (0)
+#define ISO_USB1_SRAM_PWR7_pg_switch_info_mask                                       (0xFFFFFFFF)
+#define ISO_USB1_SRAM_PWR7_pg_switch_info(data)                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_USB1_SRAM_PWR7_pg_switch_info_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_USB1_SRAM_PWR7_get_pg_switch_info(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_USB_CTRL                                                                 0x98007FB0
+#define ISO_USB_CTRL_reg_addr                                                        "0xD8007FB0"
+#define ISO_USB_CTRL_reg                                                             0xD8007FB0
+#define set_ISO_USB_CTRL_reg(data)   (*((volatile unsigned int*) ISO_USB_CTRL_reg)=data)
+#define get_ISO_USB_CTRL_reg   (*((volatile unsigned int*) ISO_USB_CTRL_reg))
+#define ISO_USB_CTRL_inst_adr                                                        "0x00EC"
+#define ISO_USB_CTRL_inst                                                            0x00EC
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_3_shift                                (31)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_3_mask                                 (0x80000000)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_3(data)                                (0x80000000&((data)<<31))
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_3_src(data)                            ((0x80000000&(data))>>31)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_hst_dcp_en_3(data)                            ((0x80000000&(data))>>31)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_2_shift                                (30)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_2_mask                                 (0x40000000)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_2(data)                                (0x40000000&((data)<<30))
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_2_src(data)                            ((0x40000000&(data))>>30)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_hst_dcp_en_2(data)                            ((0x40000000&(data))>>30)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_1_shift                                (29)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_1_mask                                 (0x20000000)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_1(data)                                (0x20000000&((data)<<29))
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_1_src(data)                            ((0x20000000&(data))>>29)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_hst_dcp_en_1(data)                            ((0x20000000&(data))>>29)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_0_shift                                (28)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_0_mask                                 (0x10000000)
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_0(data)                                (0x10000000&((data)<<28))
+#define ISO_USB_CTRL_iso_usb_u2phy_hst_dcp_en_0_src(data)                            ((0x10000000&(data))>>28)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_hst_dcp_en_0(data)                            ((0x10000000&(data))>>28)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_3_shift                                (27)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_3_mask                                 (0x08000000)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_3(data)                                (0x08000000&((data)<<27))
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_3_src(data)                            ((0x08000000&(data))>>27)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_lf_pd_r_en_3(data)                            ((0x08000000&(data))>>27)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_2_shift                                (26)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_2_mask                                 (0x04000000)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_2(data)                                (0x04000000&((data)<<26))
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_2_src(data)                            ((0x04000000&(data))>>26)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_lf_pd_r_en_2(data)                            ((0x04000000&(data))>>26)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_1_shift                                (25)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_1_mask                                 (0x02000000)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_1(data)                                (0x02000000&((data)<<25))
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_1_src(data)                            ((0x02000000&(data))>>25)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_lf_pd_r_en_1(data)                            ((0x02000000&(data))>>25)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_0_shift                                (24)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_0_mask                                 (0x01000000)
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_0(data)                                (0x01000000&((data)<<24))
+#define ISO_USB_CTRL_iso_usb_u2phy_lf_pd_r_en_0_src(data)                            ((0x01000000&(data))>>24)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_lf_pd_r_en_0(data)                            ((0x01000000&(data))>>24)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_3_shift                                (23)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_3_mask                                 (0x00800000)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_3(data)                                (0x00800000&((data)<<23))
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_3_src(data)                            ((0x00800000&(data))>>23)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_reg_ldo_pw_3(data)                            ((0x00800000&(data))>>23)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_2_shift                                (22)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_2_mask                                 (0x00400000)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_2(data)                                (0x00400000&((data)<<22))
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_2_src(data)                            ((0x00400000&(data))>>22)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_reg_ldo_pw_2(data)                            ((0x00400000&(data))>>22)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_1_shift                                (21)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_1_mask                                 (0x00200000)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_1(data)                                (0x00200000&((data)<<21))
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_1_src(data)                            ((0x00200000&(data))>>21)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_reg_ldo_pw_1(data)                            ((0x00200000&(data))>>21)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_0_shift                                (20)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_0_mask                                 (0x00100000)
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_0(data)                                (0x00100000&((data)<<20))
+#define ISO_USB_CTRL_iso_usb_u2phy_reg_ldo_pw_0_src(data)                            ((0x00100000&(data))>>20)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_reg_ldo_pw_0(data)                            ((0x00100000&(data))>>20)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_3_shift                                 (19)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_3_mask                                  (0x00080000)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_3(data)                                 (0x00080000&((data)<<19))
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_3_src(data)                             ((0x00080000&(data))>>19)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_by_paa_on_3(data)                             ((0x00080000&(data))>>19)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_2_shift                                 (18)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_2_mask                                  (0x00040000)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_2(data)                                 (0x00040000&((data)<<18))
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_2_src(data)                             ((0x00040000&(data))>>18)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_by_paa_on_2(data)                             ((0x00040000&(data))>>18)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_1_shift                                 (17)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_1_mask                                  (0x00020000)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_1(data)                                 (0x00020000&((data)<<17))
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_1_src(data)                             ((0x00020000&(data))>>17)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_by_paa_on_1(data)                             ((0x00020000&(data))>>17)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_0_shift                                 (16)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_0_mask                                  (0x00010000)
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_0(data)                                 (0x00010000&((data)<<16))
+#define ISO_USB_CTRL_iso_usb_u2phy_by_paa_on_0_src(data)                             ((0x00010000&(data))>>16)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_by_paa_on_0(data)                             ((0x00010000&(data))>>16)
+#define ISO_USB_CTRL_iso_usb_p3_isoctrl_en_shift                                     (9)
+#define ISO_USB_CTRL_iso_usb_p3_isoctrl_en_mask                                      (0x00000200)
+#define ISO_USB_CTRL_iso_usb_p3_isoctrl_en(data)                                     (0x00000200&((data)<<9))
+#define ISO_USB_CTRL_iso_usb_p3_isoctrl_en_src(data)                                 ((0x00000200&(data))>>9)
+#define ISO_USB_CTRL_get_iso_usb_p3_isoctrl_en(data)                                 ((0x00000200&(data))>>9)
+#define ISO_USB_CTRL_iso_usb_p012_isoctrl_en_shift                                   (8)
+#define ISO_USB_CTRL_iso_usb_p012_isoctrl_en_mask                                    (0x00000100)
+#define ISO_USB_CTRL_iso_usb_p012_isoctrl_en(data)                                   (0x00000100&((data)<<8))
+#define ISO_USB_CTRL_iso_usb_p012_isoctrl_en_src(data)                               ((0x00000100&(data))>>8)
+#define ISO_USB_CTRL_get_iso_usb_p012_isoctrl_en(data)                               ((0x00000100&(data))>>8)
+#define ISO_USB_CTRL_iso_usb_u2phy_pg_en_shift                                       (6)
+#define ISO_USB_CTRL_iso_usb_u2phy_pg_en_mask                                        (0x00000040)
+#define ISO_USB_CTRL_iso_usb_u2phy_pg_en(data)                                       (0x00000040&((data)<<6))
+#define ISO_USB_CTRL_iso_usb_u2phy_pg_en_src(data)                                   ((0x00000040&(data))>>6)
+#define ISO_USB_CTRL_get_iso_usb_u2phy_pg_en(data)                                   ((0x00000040&(data))>>6)
+#define ISO_USB_CTRL_iso_usb_u3phy_p1_pg_en_shift                                    (5)
+#define ISO_USB_CTRL_iso_usb_u3phy_p1_pg_en_mask                                     (0x00000020)
+#define ISO_USB_CTRL_iso_usb_u3phy_p1_pg_en(data)                                    (0x00000020&((data)<<5))
+#define ISO_USB_CTRL_iso_usb_u3phy_p1_pg_en_src(data)                                ((0x00000020&(data))>>5)
+#define ISO_USB_CTRL_get_iso_usb_u3phy_p1_pg_en(data)                                ((0x00000020&(data))>>5)
+#define ISO_USB_CTRL_iso_usb_u3phy_p0_pg_en_shift                                    (4)
+#define ISO_USB_CTRL_iso_usb_u3phy_p0_pg_en_mask                                     (0x00000010)
+#define ISO_USB_CTRL_iso_usb_u3phy_p0_pg_en(data)                                    (0x00000010&((data)<<4))
+#define ISO_USB_CTRL_iso_usb_u3phy_p0_pg_en_src(data)                                ((0x00000010&(data))>>4)
+#define ISO_USB_CTRL_get_iso_usb_u3phy_p0_pg_en(data)                                ((0x00000010&(data))>>4)
+#define ISO_USB_CTRL_iso_usb_p3_pg_en_shift                                          (1)
+#define ISO_USB_CTRL_iso_usb_p3_pg_en_mask                                           (0x00000002)
+#define ISO_USB_CTRL_iso_usb_p3_pg_en(data)                                          (0x00000002&((data)<<1))
+#define ISO_USB_CTRL_iso_usb_p3_pg_en_src(data)                                      ((0x00000002&(data))>>1)
+#define ISO_USB_CTRL_get_iso_usb_p3_pg_en(data)                                      ((0x00000002&(data))>>1)
+#define ISO_USB_CTRL_iso_usb_p012_pg_en_shift                                        (0)
+#define ISO_USB_CTRL_iso_usb_p012_pg_en_mask                                         (0x00000001)
+#define ISO_USB_CTRL_iso_usb_p012_pg_en(data)                                        (0x00000001&((data)<<0))
+#define ISO_USB_CTRL_iso_usb_p012_pg_en_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_USB_CTRL_get_iso_usb_p012_pg_en(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_ETN_DBUS_CTRL                                                            0x98007FC0
+#define ISO_ETN_DBUS_CTRL_reg_addr                                                   "0xD8007FC0"
+#define ISO_ETN_DBUS_CTRL_reg                                                        0xD8007FC0
+#define set_ISO_ETN_DBUS_CTRL_reg(data)   (*((volatile unsigned int*) ISO_ETN_DBUS_CTRL_reg)=data)
+#define get_ISO_ETN_DBUS_CTRL_reg   (*((volatile unsigned int*) ISO_ETN_DBUS_CTRL_reg))
+#define ISO_ETN_DBUS_CTRL_inst_adr                                                   "0x00F0"
+#define ISO_ETN_DBUS_CTRL_inst                                                       0x00F0
+#define ISO_ETN_DBUS_CTRL_so_etn_sram_ls_gap_shift                                   (4)
+#define ISO_ETN_DBUS_CTRL_so_etn_sram_ls_gap_mask                                    (0x00000030)
+#define ISO_ETN_DBUS_CTRL_so_etn_sram_ls_gap(data)                                   (0x00000030&((data)<<4))
+#define ISO_ETN_DBUS_CTRL_so_etn_sram_ls_gap_src(data)                               ((0x00000030&(data))>>4)
+#define ISO_ETN_DBUS_CTRL_get_so_etn_sram_ls_gap(data)                               ((0x00000030&(data))>>4)
+#define ISO_ETN_DBUS_CTRL_so_etn_clk_en_gap_shift                                    (2)
+#define ISO_ETN_DBUS_CTRL_so_etn_clk_en_gap_mask                                     (0x0000000C)
+#define ISO_ETN_DBUS_CTRL_so_etn_clk_en_gap(data)                                    (0x0000000C&((data)<<2))
+#define ISO_ETN_DBUS_CTRL_so_etn_clk_en_gap_src(data)                                ((0x0000000C&(data))>>2)
+#define ISO_ETN_DBUS_CTRL_get_so_etn_clk_en_gap(data)                                ((0x0000000C&(data))>>2)
+#define ISO_ETN_DBUS_CTRL_so_etn_pwr_ctrl_sw_rst_shift                               (1)
+#define ISO_ETN_DBUS_CTRL_so_etn_pwr_ctrl_sw_rst_mask                                (0x00000002)
+#define ISO_ETN_DBUS_CTRL_so_etn_pwr_ctrl_sw_rst(data)                               (0x00000002&((data)<<1))
+#define ISO_ETN_DBUS_CTRL_so_etn_pwr_ctrl_sw_rst_src(data)                           ((0x00000002&(data))>>1)
+#define ISO_ETN_DBUS_CTRL_get_so_etn_pwr_ctrl_sw_rst(data)                           ((0x00000002&(data))>>1)
+#define ISO_ETN_DBUS_CTRL_iso_etn_pwr_ctrl_en_shift                                  (0)
+#define ISO_ETN_DBUS_CTRL_iso_etn_pwr_ctrl_en_mask                                   (0x00000001)
+#define ISO_ETN_DBUS_CTRL_iso_etn_pwr_ctrl_en(data)                                  (0x00000001&((data)<<0))
+#define ISO_ETN_DBUS_CTRL_iso_etn_pwr_ctrl_en_src(data)                              ((0x00000001&(data))>>0)
+#define ISO_ETN_DBUS_CTRL_get_iso_etn_pwr_ctrl_en(data)                              ((0x00000001&(data))>>0)
+
+
+#define ISO_ETN_BIST_DROM_GOLDEN                                                     0x98007FC4
+#define ISO_ETN_BIST_DROM_GOLDEN_reg_addr                                            "0xD8007FC4"
+#define ISO_ETN_BIST_DROM_GOLDEN_reg                                                 0xD8007FC4
+#define set_ISO_ETN_BIST_DROM_GOLDEN_reg(data)   (*((volatile unsigned int*) ISO_ETN_BIST_DROM_GOLDEN_reg)=data)
+#define get_ISO_ETN_BIST_DROM_GOLDEN_reg   (*((volatile unsigned int*) ISO_ETN_BIST_DROM_GOLDEN_reg))
+#define ISO_ETN_BIST_DROM_GOLDEN_inst_adr                                            "0x00F1"
+#define ISO_ETN_BIST_DROM_GOLDEN_inst                                                0x00F1
+#define ISO_ETN_BIST_DROM_GOLDEN_iso_etn_drom_golden_shift                           (0)
+#define ISO_ETN_BIST_DROM_GOLDEN_iso_etn_drom_golden_mask                            (0xFFFFFFFF)
+#define ISO_ETN_BIST_DROM_GOLDEN_iso_etn_drom_golden(data)                           (0xFFFFFFFF&((data)<<0))
+#define ISO_ETN_BIST_DROM_GOLDEN_iso_etn_drom_golden_src(data)                       ((0xFFFFFFFF&(data))>>0)
+#define ISO_ETN_BIST_DROM_GOLDEN_get_iso_etn_drom_golden(data)                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_ETN_BIST_IROM_GOLDEN                                                     0x98007FC8
+#define ISO_ETN_BIST_IROM_GOLDEN_reg_addr                                            "0xD8007FC8"
+#define ISO_ETN_BIST_IROM_GOLDEN_reg                                                 0xD8007FC8
+#define set_ISO_ETN_BIST_IROM_GOLDEN_reg(data)   (*((volatile unsigned int*) ISO_ETN_BIST_IROM_GOLDEN_reg)=data)
+#define get_ISO_ETN_BIST_IROM_GOLDEN_reg   (*((volatile unsigned int*) ISO_ETN_BIST_IROM_GOLDEN_reg))
+#define ISO_ETN_BIST_IROM_GOLDEN_inst_adr                                            "0x00F2"
+#define ISO_ETN_BIST_IROM_GOLDEN_inst                                                0x00F2
+#define ISO_ETN_BIST_IROM_GOLDEN_iso_etn_irom_golden_shift                           (0)
+#define ISO_ETN_BIST_IROM_GOLDEN_iso_etn_irom_golden_mask                            (0xFFFFFFFF)
+#define ISO_ETN_BIST_IROM_GOLDEN_iso_etn_irom_golden(data)                           (0xFFFFFFFF&((data)<<0))
+#define ISO_ETN_BIST_IROM_GOLDEN_iso_etn_irom_golden_src(data)                       ((0xFFFFFFFF&(data))>>0)
+#define ISO_ETN_BIST_IROM_GOLDEN_get_iso_etn_irom_golden(data)                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_ETN_BIST_FTR_ROM_GOLDEN                                                  0x98007FCC
+#define ISO_ETN_BIST_FTR_ROM_GOLDEN_reg_addr                                         "0xD8007FCC"
+#define ISO_ETN_BIST_FTR_ROM_GOLDEN_reg                                              0xD8007FCC
+#define set_ISO_ETN_BIST_FTR_ROM_GOLDEN_reg(data)   (*((volatile unsigned int*) ISO_ETN_BIST_FTR_ROM_GOLDEN_reg)=data)
+#define get_ISO_ETN_BIST_FTR_ROM_GOLDEN_reg   (*((volatile unsigned int*) ISO_ETN_BIST_FTR_ROM_GOLDEN_reg))
+#define ISO_ETN_BIST_FTR_ROM_GOLDEN_inst_adr                                         "0x00F3"
+#define ISO_ETN_BIST_FTR_ROM_GOLDEN_inst                                             0x00F3
+#define ISO_ETN_BIST_FTR_ROM_GOLDEN_iso_etn_ftr_rom_golden_shift                     (0)
+#define ISO_ETN_BIST_FTR_ROM_GOLDEN_iso_etn_ftr_rom_golden_mask                      (0xFFFFFFFF)
+#define ISO_ETN_BIST_FTR_ROM_GOLDEN_iso_etn_ftr_rom_golden(data)                     (0xFFFFFFFF&((data)<<0))
+#define ISO_ETN_BIST_FTR_ROM_GOLDEN_iso_etn_ftr_rom_golden_src(data)                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_ETN_BIST_FTR_ROM_GOLDEN_get_iso_etn_ftr_rom_golden(data)                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DCO_0                                                                    0x980070F0
+#define ISO_DCO_0_reg_addr                                                           "0xD80070F0"
+#define ISO_DCO_0_reg                                                                0xD80070F0
+#define set_ISO_DCO_0_reg(data)   (*((volatile unsigned int*) ISO_DCO_0_reg)=data)
+#define get_ISO_DCO_0_reg   (*((volatile unsigned int*) ISO_DCO_0_reg))
+#define ISO_DCO_0_inst_adr                                                           "0x003C"
+#define ISO_DCO_0_inst                                                               0x003C
+#define ISO_DCO_0_osc_count_limit_shift                                              (10)
+#define ISO_DCO_0_osc_count_limit_mask                                               (0x003FFC00)
+#define ISO_DCO_0_osc_count_limit(data)                                              (0x003FFC00&((data)<<10))
+#define ISO_DCO_0_osc_count_limit_src(data)                                          ((0x003FFC00&(data))>>10)
+#define ISO_DCO_0_get_osc_count_limit(data)                                          ((0x003FFC00&(data))>>10)
+#define ISO_DCO_0_xtal_off_shift                                                     (2)
+#define ISO_DCO_0_xtal_off_mask                                                      (0x00000004)
+#define ISO_DCO_0_xtal_off(data)                                                     (0x00000004&((data)<<2))
+#define ISO_DCO_0_xtal_off_src(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_DCO_0_get_xtal_off(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_DCO_0_dco_sel_shift                                                      (1)
+#define ISO_DCO_0_dco_sel_mask                                                       (0x00000002)
+#define ISO_DCO_0_dco_sel(data)                                                      (0x00000002&((data)<<1))
+#define ISO_DCO_0_dco_sel_src(data)                                                  ((0x00000002&(data))>>1)
+#define ISO_DCO_0_get_dco_sel(data)                                                  ((0x00000002&(data))>>1)
+#define ISO_DCO_0_cal_enable_shift                                                   (0)
+#define ISO_DCO_0_cal_enable_mask                                                    (0x00000001)
+#define ISO_DCO_0_cal_enable(data)                                                   (0x00000001&((data)<<0))
+#define ISO_DCO_0_cal_enable_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_DCO_0_get_cal_enable(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_DCO_1                                                                    0x980070F4
+#define ISO_DCO_1_reg_addr                                                           "0xD80070F4"
+#define ISO_DCO_1_reg                                                                0xD80070F4
+#define set_ISO_DCO_1_reg(data)   (*((volatile unsigned int*) ISO_DCO_1_reg)=data)
+#define get_ISO_DCO_1_reg   (*((volatile unsigned int*) ISO_DCO_1_reg))
+#define ISO_DCO_1_inst_adr                                                           "0x003D"
+#define ISO_DCO_1_inst                                                               0x003D
+#define ISO_DCO_1_dco_count_latch_shift                                              (13)
+#define ISO_DCO_1_dco_count_latch_mask                                               (0x01FFE000)
+#define ISO_DCO_1_dco_count_latch(data)                                              (0x01FFE000&((data)<<13))
+#define ISO_DCO_1_dco_count_latch_src(data)                                          ((0x01FFE000&(data))>>13)
+#define ISO_DCO_1_get_dco_count_latch(data)                                          ((0x01FFE000&(data))>>13)
+#define ISO_DCO_1_xtal_count_latch_shift                                             (1)
+#define ISO_DCO_1_xtal_count_latch_mask                                              (0x00001FFE)
+#define ISO_DCO_1_xtal_count_latch(data)                                             (0x00001FFE&((data)<<1))
+#define ISO_DCO_1_xtal_count_latch_src(data)                                         ((0x00001FFE&(data))>>1)
+#define ISO_DCO_1_get_xtal_count_latch(data)                                         ((0x00001FFE&(data))>>1)
+#define ISO_DCO_1_dco_cal_done_shift                                                 (0)
+#define ISO_DCO_1_dco_cal_done_mask                                                  (0x00000001)
+#define ISO_DCO_1_dco_cal_done(data)                                                 (0x00000001&((data)<<0))
+#define ISO_DCO_1_dco_cal_done_src(data)                                             ((0x00000001&(data))>>0)
+#define ISO_DCO_1_get_dco_cal_done(data)                                             ((0x00000001&(data))>>0)
+
+
+#define ISO_GPDIR                                                                    0x98007100
+#define ISO_GPDIR_reg_addr                                                           "0xD8007100"
+#define ISO_GPDIR_reg                                                                0xD8007100
+#define set_ISO_GPDIR_reg(data)   (*((volatile unsigned int*) ISO_GPDIR_reg)=data)
+#define get_ISO_GPDIR_reg   (*((volatile unsigned int*) ISO_GPDIR_reg))
+#define ISO_GPDIR_inst_adr                                                           "0x0040"
+#define ISO_GPDIR_inst                                                               0x0040
+#define ISO_GPDIR_gpdir_shift                                                        (0)
+#define ISO_GPDIR_gpdir_mask                                                         (0xFFFFFFFF)
+#define ISO_GPDIR_gpdir(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define ISO_GPDIR_gpdir_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define ISO_GPDIR_get_gpdir(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_GPDATO                                                                   0x98007104
+#define ISO_GPDATO_reg_addr                                                          "0xD8007104"
+#define ISO_GPDATO_reg                                                               0xD8007104
+#define set_ISO_GPDATO_reg(data)   (*((volatile unsigned int*) ISO_GPDATO_reg)=data)
+#define get_ISO_GPDATO_reg   (*((volatile unsigned int*) ISO_GPDATO_reg))
+#define ISO_GPDATO_inst_adr                                                          "0x0041"
+#define ISO_GPDATO_inst                                                              0x0041
+#define ISO_GPDATO_gpdato_shift                                                      (0)
+#define ISO_GPDATO_gpdato_mask                                                       (0xFFFFFFFF)
+#define ISO_GPDATO_gpdato(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_GPDATO_gpdato_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_GPDATO_get_gpdato(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_GPDATI                                                                   0x98007108
+#define ISO_GPDATI_reg_addr                                                          "0xD8007108"
+#define ISO_GPDATI_reg                                                               0xD8007108
+#define set_ISO_GPDATI_reg(data)   (*((volatile unsigned int*) ISO_GPDATI_reg)=data)
+#define get_ISO_GPDATI_reg   (*((volatile unsigned int*) ISO_GPDATI_reg))
+#define ISO_GPDATI_inst_adr                                                          "0x0042"
+#define ISO_GPDATI_inst                                                              0x0042
+#define ISO_GPDATI_gpdati_shift                                                      (0)
+#define ISO_GPDATI_gpdati_mask                                                       (0xFFFFFFFF)
+#define ISO_GPDATI_gpdati(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_GPDATI_gpdati_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_GPDATI_get_gpdati(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_GPIE                                                                     0x9800710C
+#define ISO_GPIE_reg_addr                                                            "0xD800710C"
+#define ISO_GPIE_reg                                                                 0xD800710C
+#define set_ISO_GPIE_reg(data)   (*((volatile unsigned int*) ISO_GPIE_reg)=data)
+#define get_ISO_GPIE_reg   (*((volatile unsigned int*) ISO_GPIE_reg))
+#define ISO_GPIE_inst_adr                                                            "0x0043"
+#define ISO_GPIE_inst                                                                0x0043
+#define ISO_GPIE_gp_shift                                                            (0)
+#define ISO_GPIE_gp_mask                                                             (0xFFFFFFFF)
+#define ISO_GPIE_gp(data)                                                            (0xFFFFFFFF&((data)<<0))
+#define ISO_GPIE_gp_src(data)                                                        ((0xFFFFFFFF&(data))>>0)
+#define ISO_GPIE_get_gp(data)                                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_GPDP                                                                     0x98007110
+#define ISO_GPDP_reg_addr                                                            "0xD8007110"
+#define ISO_GPDP_reg                                                                 0xD8007110
+#define set_ISO_GPDP_reg(data)   (*((volatile unsigned int*) ISO_GPDP_reg)=data)
+#define get_ISO_GPDP_reg   (*((volatile unsigned int*) ISO_GPDP_reg))
+#define ISO_GPDP_inst_adr                                                            "0x0044"
+#define ISO_GPDP_inst                                                                0x0044
+#define ISO_GPDP_gpha_shift                                                          (0)
+#define ISO_GPDP_gpha_mask                                                           (0xFFFFFFFF)
+#define ISO_GPDP_gpha(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define ISO_GPDP_gpha_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define ISO_GPDP_get_gpha(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_GPDEB                                                                    0x98007114
+#define ISO_GPDEB_reg_addr                                                           "0xD8007114"
+#define ISO_GPDEB_reg                                                                0xD8007114
+#define set_ISO_GPDEB_reg(data)   (*((volatile unsigned int*) ISO_GPDEB_reg)=data)
+#define get_ISO_GPDEB_reg   (*((volatile unsigned int*) ISO_GPDEB_reg))
+#define ISO_GPDEB_inst_adr                                                           "0x0045"
+#define ISO_GPDEB_inst                                                               0x0045
+#define ISO_GPDEB_write_en1_shift                                                    (3)
+#define ISO_GPDEB_write_en1_mask                                                     (0x00000008)
+#define ISO_GPDEB_write_en1(data)                                                    (0x00000008&((data)<<3))
+#define ISO_GPDEB_write_en1_src(data)                                                ((0x00000008&(data))>>3)
+#define ISO_GPDEB_get_write_en1(data)                                                ((0x00000008&(data))>>3)
+#define ISO_GPDEB_clk1_shift                                                         (0)
+#define ISO_GPDEB_clk1_mask                                                          (0x00000007)
+#define ISO_GPDEB_clk1(data)                                                         (0x00000007&((data)<<0))
+#define ISO_GPDEB_clk1_src(data)                                                     ((0x00000007&(data))>>0)
+#define ISO_GPDEB_get_clk1(data)                                                     ((0x00000007&(data))>>0)
+
+
+#define ISO_GPDIR_1                                                                  0x98007118
+#define ISO_GPDIR_1_reg_addr                                                         "0xD8007118"
+#define ISO_GPDIR_1_reg                                                              0xD8007118
+#define set_ISO_GPDIR_1_reg(data)   (*((volatile unsigned int*) ISO_GPDIR_1_reg)=data)
+#define get_ISO_GPDIR_1_reg   (*((volatile unsigned int*) ISO_GPDIR_1_reg))
+#define ISO_GPDIR_1_inst_adr                                                         "0x0046"
+#define ISO_GPDIR_1_inst                                                             0x0046
+#define ISO_GPDIR_1_gpdir_1_shift                                                    (0)
+#define ISO_GPDIR_1_gpdir_1_mask                                                     (0x00000007)
+#define ISO_GPDIR_1_gpdir_1(data)                                                    (0x00000007&((data)<<0))
+#define ISO_GPDIR_1_gpdir_1_src(data)                                                ((0x00000007&(data))>>0)
+#define ISO_GPDIR_1_get_gpdir_1(data)                                                ((0x00000007&(data))>>0)
+
+
+#define ISO_GPDATO_1                                                                 0x9800711C
+#define ISO_GPDATO_1_reg_addr                                                        "0xD800711C"
+#define ISO_GPDATO_1_reg                                                             0xD800711C
+#define set_ISO_GPDATO_1_reg(data)   (*((volatile unsigned int*) ISO_GPDATO_1_reg)=data)
+#define get_ISO_GPDATO_1_reg   (*((volatile unsigned int*) ISO_GPDATO_1_reg))
+#define ISO_GPDATO_1_inst_adr                                                        "0x0047"
+#define ISO_GPDATO_1_inst                                                            0x0047
+#define ISO_GPDATO_1_gpdato_1_shift                                                  (0)
+#define ISO_GPDATO_1_gpdato_1_mask                                                   (0x00000007)
+#define ISO_GPDATO_1_gpdato_1(data)                                                  (0x00000007&((data)<<0))
+#define ISO_GPDATO_1_gpdato_1_src(data)                                              ((0x00000007&(data))>>0)
+#define ISO_GPDATO_1_get_gpdato_1(data)                                              ((0x00000007&(data))>>0)
+
+
+#define ISO_GPDATI_1                                                                 0x98007120
+#define ISO_GPDATI_1_reg_addr                                                        "0xD8007120"
+#define ISO_GPDATI_1_reg                                                             0xD8007120
+#define set_ISO_GPDATI_1_reg(data)   (*((volatile unsigned int*) ISO_GPDATI_1_reg)=data)
+#define get_ISO_GPDATI_1_reg   (*((volatile unsigned int*) ISO_GPDATI_1_reg))
+#define ISO_GPDATI_1_inst_adr                                                        "0x0048"
+#define ISO_GPDATI_1_inst                                                            0x0048
+#define ISO_GPDATI_1_gpdati_1_shift                                                  (0)
+#define ISO_GPDATI_1_gpdati_1_mask                                                   (0x00000007)
+#define ISO_GPDATI_1_gpdati_1(data)                                                  (0x00000007&((data)<<0))
+#define ISO_GPDATI_1_gpdati_1_src(data)                                              ((0x00000007&(data))>>0)
+#define ISO_GPDATI_1_get_gpdati_1(data)                                              ((0x00000007&(data))>>0)
+
+
+#define ISO_GPIE_1                                                                   0x98007124
+#define ISO_GPIE_1_reg_addr                                                          "0xD8007124"
+#define ISO_GPIE_1_reg                                                               0xD8007124
+#define set_ISO_GPIE_1_reg(data)   (*((volatile unsigned int*) ISO_GPIE_1_reg)=data)
+#define get_ISO_GPIE_1_reg   (*((volatile unsigned int*) ISO_GPIE_1_reg))
+#define ISO_GPIE_1_inst_adr                                                          "0x0049"
+#define ISO_GPIE_1_inst                                                              0x0049
+#define ISO_GPIE_1_gp_1_shift                                                        (0)
+#define ISO_GPIE_1_gp_1_mask                                                         (0x00000007)
+#define ISO_GPIE_1_gp_1(data)                                                        (0x00000007&((data)<<0))
+#define ISO_GPIE_1_gp_1_src(data)                                                    ((0x00000007&(data))>>0)
+#define ISO_GPIE_1_get_gp_1(data)                                                    ((0x00000007&(data))>>0)
+
+
+#define ISO_GPDP_1                                                                   0x98007128
+#define ISO_GPDP_1_reg_addr                                                          "0xD8007128"
+#define ISO_GPDP_1_reg                                                               0xD8007128
+#define set_ISO_GPDP_1_reg(data)   (*((volatile unsigned int*) ISO_GPDP_1_reg)=data)
+#define get_ISO_GPDP_1_reg   (*((volatile unsigned int*) ISO_GPDP_1_reg))
+#define ISO_GPDP_1_inst_adr                                                          "0x004A"
+#define ISO_GPDP_1_inst                                                              0x004A
+#define ISO_GPDP_1_gpha_1_shift                                                      (0)
+#define ISO_GPDP_1_gpha_1_mask                                                       (0x00000007)
+#define ISO_GPDP_1_gpha_1(data)                                                      (0x00000007&((data)<<0))
+#define ISO_GPDP_1_gpha_1_src(data)                                                  ((0x00000007&(data))>>0)
+#define ISO_GPDP_1_get_gpha_1(data)                                                  ((0x00000007&(data))>>0)
+
+
+#define ISO_PFUNC0                                                                   0x98007300
+#define ISO_PFUNC0_reg_addr                                                          "0xD8007300"
+#define ISO_PFUNC0_reg                                                               0xD8007300
+#define set_ISO_PFUNC0_reg(data)   (*((volatile unsigned int*) ISO_PFUNC0_reg)=data)
+#define get_ISO_PFUNC0_reg   (*((volatile unsigned int*) ISO_PFUNC0_reg))
+#define ISO_PFUNC0_inst_adr                                                          "0x00C0"
+#define ISO_PFUNC0_inst                                                              0x00C0
+#define ISO_PFUNC0_i2c_scl_0_smt_shift                                               (31)
+#define ISO_PFUNC0_i2c_scl_0_smt_mask                                                (0x80000000)
+#define ISO_PFUNC0_i2c_scl_0_smt(data)                                               (0x80000000&((data)<<31))
+#define ISO_PFUNC0_i2c_scl_0_smt_src(data)                                           ((0x80000000&(data))>>31)
+#define ISO_PFUNC0_get_i2c_scl_0_smt(data)                                           ((0x80000000&(data))>>31)
+#define ISO_PFUNC0_i2c_scl_0_e2_shift                                                (30)
+#define ISO_PFUNC0_i2c_scl_0_e2_mask                                                 (0x40000000)
+#define ISO_PFUNC0_i2c_scl_0_e2(data)                                                (0x40000000&((data)<<30))
+#define ISO_PFUNC0_i2c_scl_0_e2_src(data)                                            ((0x40000000&(data))>>30)
+#define ISO_PFUNC0_get_i2c_scl_0_e2(data)                                            ((0x40000000&(data))>>30)
+#define ISO_PFUNC0_i2c_scl_0_pud_en_shift                                            (29)
+#define ISO_PFUNC0_i2c_scl_0_pud_en_mask                                             (0x20000000)
+#define ISO_PFUNC0_i2c_scl_0_pud_en(data)                                            (0x20000000&((data)<<29))
+#define ISO_PFUNC0_i2c_scl_0_pud_en_src(data)                                        ((0x20000000&(data))>>29)
+#define ISO_PFUNC0_get_i2c_scl_0_pud_en(data)                                        ((0x20000000&(data))>>29)
+#define ISO_PFUNC0_i2c_scl_0_pud_sel_shift                                           (28)
+#define ISO_PFUNC0_i2c_scl_0_pud_sel_mask                                            (0x10000000)
+#define ISO_PFUNC0_i2c_scl_0_pud_sel(data)                                           (0x10000000&((data)<<28))
+#define ISO_PFUNC0_i2c_scl_0_pud_sel_src(data)                                       ((0x10000000&(data))>>28)
+#define ISO_PFUNC0_get_i2c_scl_0_pud_sel(data)                                       ((0x10000000&(data))>>28)
+#define ISO_PFUNC0_i2c_sda_0_smt_shift                                               (27)
+#define ISO_PFUNC0_i2c_sda_0_smt_mask                                                (0x08000000)
+#define ISO_PFUNC0_i2c_sda_0_smt(data)                                               (0x08000000&((data)<<27))
+#define ISO_PFUNC0_i2c_sda_0_smt_src(data)                                           ((0x08000000&(data))>>27)
+#define ISO_PFUNC0_get_i2c_sda_0_smt(data)                                           ((0x08000000&(data))>>27)
+#define ISO_PFUNC0_i2c_sda_0_e2_shift                                                (26)
+#define ISO_PFUNC0_i2c_sda_0_e2_mask                                                 (0x04000000)
+#define ISO_PFUNC0_i2c_sda_0_e2(data)                                                (0x04000000&((data)<<26))
+#define ISO_PFUNC0_i2c_sda_0_e2_src(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PFUNC0_get_i2c_sda_0_e2(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PFUNC0_i2c_sda_0_pud_en_shift                                            (25)
+#define ISO_PFUNC0_i2c_sda_0_pud_en_mask                                             (0x02000000)
+#define ISO_PFUNC0_i2c_sda_0_pud_en(data)                                            (0x02000000&((data)<<25))
+#define ISO_PFUNC0_i2c_sda_0_pud_en_src(data)                                        ((0x02000000&(data))>>25)
+#define ISO_PFUNC0_get_i2c_sda_0_pud_en(data)                                        ((0x02000000&(data))>>25)
+#define ISO_PFUNC0_i2c_sda_0_pud_sel_shift                                           (24)
+#define ISO_PFUNC0_i2c_sda_0_pud_sel_mask                                            (0x01000000)
+#define ISO_PFUNC0_i2c_sda_0_pud_sel(data)                                           (0x01000000&((data)<<24))
+#define ISO_PFUNC0_i2c_sda_0_pud_sel_src(data)                                       ((0x01000000&(data))>>24)
+#define ISO_PFUNC0_get_i2c_sda_0_pud_sel(data)                                       ((0x01000000&(data))>>24)
+#define ISO_PFUNC0_iso_gpio_7_smt_shift                                              (23)
+#define ISO_PFUNC0_iso_gpio_7_smt_mask                                               (0x00800000)
+#define ISO_PFUNC0_iso_gpio_7_smt(data)                                              (0x00800000&((data)<<23))
+#define ISO_PFUNC0_iso_gpio_7_smt_src(data)                                          ((0x00800000&(data))>>23)
+#define ISO_PFUNC0_get_iso_gpio_7_smt(data)                                          ((0x00800000&(data))>>23)
+#define ISO_PFUNC0_iso_gpio_7_e2_shift                                               (22)
+#define ISO_PFUNC0_iso_gpio_7_e2_mask                                                (0x00400000)
+#define ISO_PFUNC0_iso_gpio_7_e2(data)                                               (0x00400000&((data)<<22))
+#define ISO_PFUNC0_iso_gpio_7_e2_src(data)                                           ((0x00400000&(data))>>22)
+#define ISO_PFUNC0_get_iso_gpio_7_e2(data)                                           ((0x00400000&(data))>>22)
+#define ISO_PFUNC0_iso_gpio_7_pud_en_shift                                           (21)
+#define ISO_PFUNC0_iso_gpio_7_pud_en_mask                                            (0x00200000)
+#define ISO_PFUNC0_iso_gpio_7_pud_en(data)                                           (0x00200000&((data)<<21))
+#define ISO_PFUNC0_iso_gpio_7_pud_en_src(data)                                       ((0x00200000&(data))>>21)
+#define ISO_PFUNC0_get_iso_gpio_7_pud_en(data)                                       ((0x00200000&(data))>>21)
+#define ISO_PFUNC0_iso_gpio_7_pud_sel_shift                                          (20)
+#define ISO_PFUNC0_iso_gpio_7_pud_sel_mask                                           (0x00100000)
+#define ISO_PFUNC0_iso_gpio_7_pud_sel(data)                                          (0x00100000&((data)<<20))
+#define ISO_PFUNC0_iso_gpio_7_pud_sel_src(data)                                      ((0x00100000&(data))>>20)
+#define ISO_PFUNC0_get_iso_gpio_7_pud_sel(data)                                      ((0x00100000&(data))>>20)
+#define ISO_PFUNC0_iso_gpio_5_smt_shift                                              (19)
+#define ISO_PFUNC0_iso_gpio_5_smt_mask                                               (0x00080000)
+#define ISO_PFUNC0_iso_gpio_5_smt(data)                                              (0x00080000&((data)<<19))
+#define ISO_PFUNC0_iso_gpio_5_smt_src(data)                                          ((0x00080000&(data))>>19)
+#define ISO_PFUNC0_get_iso_gpio_5_smt(data)                                          ((0x00080000&(data))>>19)
+#define ISO_PFUNC0_iso_gpio_5_e2_shift                                               (18)
+#define ISO_PFUNC0_iso_gpio_5_e2_mask                                                (0x00040000)
+#define ISO_PFUNC0_iso_gpio_5_e2(data)                                               (0x00040000&((data)<<18))
+#define ISO_PFUNC0_iso_gpio_5_e2_src(data)                                           ((0x00040000&(data))>>18)
+#define ISO_PFUNC0_get_iso_gpio_5_e2(data)                                           ((0x00040000&(data))>>18)
+#define ISO_PFUNC0_iso_gpio_5_pud_en_shift                                           (17)
+#define ISO_PFUNC0_iso_gpio_5_pud_en_mask                                            (0x00020000)
+#define ISO_PFUNC0_iso_gpio_5_pud_en(data)                                           (0x00020000&((data)<<17))
+#define ISO_PFUNC0_iso_gpio_5_pud_en_src(data)                                       ((0x00020000&(data))>>17)
+#define ISO_PFUNC0_get_iso_gpio_5_pud_en(data)                                       ((0x00020000&(data))>>17)
+#define ISO_PFUNC0_iso_gpio_5_pud_sel_shift                                          (16)
+#define ISO_PFUNC0_iso_gpio_5_pud_sel_mask                                           (0x00010000)
+#define ISO_PFUNC0_iso_gpio_5_pud_sel(data)                                          (0x00010000&((data)<<16))
+#define ISO_PFUNC0_iso_gpio_5_pud_sel_src(data)                                      ((0x00010000&(data))>>16)
+#define ISO_PFUNC0_get_iso_gpio_5_pud_sel(data)                                      ((0x00010000&(data))>>16)
+#define ISO_PFUNC0_iso_gpio_4_smt_shift                                              (15)
+#define ISO_PFUNC0_iso_gpio_4_smt_mask                                               (0x00008000)
+#define ISO_PFUNC0_iso_gpio_4_smt(data)                                              (0x00008000&((data)<<15))
+#define ISO_PFUNC0_iso_gpio_4_smt_src(data)                                          ((0x00008000&(data))>>15)
+#define ISO_PFUNC0_get_iso_gpio_4_smt(data)                                          ((0x00008000&(data))>>15)
+#define ISO_PFUNC0_iso_gpio_4_e2_shift                                               (14)
+#define ISO_PFUNC0_iso_gpio_4_e2_mask                                                (0x00004000)
+#define ISO_PFUNC0_iso_gpio_4_e2(data)                                               (0x00004000&((data)<<14))
+#define ISO_PFUNC0_iso_gpio_4_e2_src(data)                                           ((0x00004000&(data))>>14)
+#define ISO_PFUNC0_get_iso_gpio_4_e2(data)                                           ((0x00004000&(data))>>14)
+#define ISO_PFUNC0_iso_gpio_4_pud_en_shift                                           (13)
+#define ISO_PFUNC0_iso_gpio_4_pud_en_mask                                            (0x00002000)
+#define ISO_PFUNC0_iso_gpio_4_pud_en(data)                                           (0x00002000&((data)<<13))
+#define ISO_PFUNC0_iso_gpio_4_pud_en_src(data)                                       ((0x00002000&(data))>>13)
+#define ISO_PFUNC0_get_iso_gpio_4_pud_en(data)                                       ((0x00002000&(data))>>13)
+#define ISO_PFUNC0_iso_gpio_4_pud_sel_shift                                          (12)
+#define ISO_PFUNC0_iso_gpio_4_pud_sel_mask                                           (0x00001000)
+#define ISO_PFUNC0_iso_gpio_4_pud_sel(data)                                          (0x00001000&((data)<<12))
+#define ISO_PFUNC0_iso_gpio_4_pud_sel_src(data)                                      ((0x00001000&(data))>>12)
+#define ISO_PFUNC0_get_iso_gpio_4_pud_sel(data)                                      ((0x00001000&(data))>>12)
+#define ISO_PFUNC0_ir_rx_smt_shift                                                   (11)
+#define ISO_PFUNC0_ir_rx_smt_mask                                                    (0x00000800)
+#define ISO_PFUNC0_ir_rx_smt(data)                                                   (0x00000800&((data)<<11))
+#define ISO_PFUNC0_ir_rx_smt_src(data)                                               ((0x00000800&(data))>>11)
+#define ISO_PFUNC0_get_ir_rx_smt(data)                                               ((0x00000800&(data))>>11)
+#define ISO_PFUNC0_ir_rx_e2_shift                                                    (10)
+#define ISO_PFUNC0_ir_rx_e2_mask                                                     (0x00000400)
+#define ISO_PFUNC0_ir_rx_e2(data)                                                    (0x00000400&((data)<<10))
+#define ISO_PFUNC0_ir_rx_e2_src(data)                                                ((0x00000400&(data))>>10)
+#define ISO_PFUNC0_get_ir_rx_e2(data)                                                ((0x00000400&(data))>>10)
+#define ISO_PFUNC0_ir_rx_pud_en_shift                                                (9)
+#define ISO_PFUNC0_ir_rx_pud_en_mask                                                 (0x00000200)
+#define ISO_PFUNC0_ir_rx_pud_en(data)                                                (0x00000200&((data)<<9))
+#define ISO_PFUNC0_ir_rx_pud_en_src(data)                                            ((0x00000200&(data))>>9)
+#define ISO_PFUNC0_get_ir_rx_pud_en(data)                                            ((0x00000200&(data))>>9)
+#define ISO_PFUNC0_ir_rx_pud_sel_shift                                               (8)
+#define ISO_PFUNC0_ir_rx_pud_sel_mask                                                (0x00000100)
+#define ISO_PFUNC0_ir_rx_pud_sel(data)                                               (0x00000100&((data)<<8))
+#define ISO_PFUNC0_ir_rx_pud_sel_src(data)                                           ((0x00000100&(data))>>8)
+#define ISO_PFUNC0_get_ir_rx_pud_sel(data)                                           ((0x00000100&(data))>>8)
+#define ISO_PFUNC0_iso_gpio_3_smt_shift                                              (7)
+#define ISO_PFUNC0_iso_gpio_3_smt_mask                                               (0x00000080)
+#define ISO_PFUNC0_iso_gpio_3_smt(data)                                              (0x00000080&((data)<<7))
+#define ISO_PFUNC0_iso_gpio_3_smt_src(data)                                          ((0x00000080&(data))>>7)
+#define ISO_PFUNC0_get_iso_gpio_3_smt(data)                                          ((0x00000080&(data))>>7)
+#define ISO_PFUNC0_iso_gpio_3_e2_shift                                               (6)
+#define ISO_PFUNC0_iso_gpio_3_e2_mask                                                (0x00000040)
+#define ISO_PFUNC0_iso_gpio_3_e2(data)                                               (0x00000040&((data)<<6))
+#define ISO_PFUNC0_iso_gpio_3_e2_src(data)                                           ((0x00000040&(data))>>6)
+#define ISO_PFUNC0_get_iso_gpio_3_e2(data)                                           ((0x00000040&(data))>>6)
+#define ISO_PFUNC0_iso_gpio_3_pud_en_shift                                           (5)
+#define ISO_PFUNC0_iso_gpio_3_pud_en_mask                                            (0x00000020)
+#define ISO_PFUNC0_iso_gpio_3_pud_en(data)                                           (0x00000020&((data)<<5))
+#define ISO_PFUNC0_iso_gpio_3_pud_en_src(data)                                       ((0x00000020&(data))>>5)
+#define ISO_PFUNC0_get_iso_gpio_3_pud_en(data)                                       ((0x00000020&(data))>>5)
+#define ISO_PFUNC0_iso_gpio_3_pud_sel_shift                                          (4)
+#define ISO_PFUNC0_iso_gpio_3_pud_sel_mask                                           (0x00000010)
+#define ISO_PFUNC0_iso_gpio_3_pud_sel(data)                                          (0x00000010&((data)<<4))
+#define ISO_PFUNC0_iso_gpio_3_pud_sel_src(data)                                      ((0x00000010&(data))>>4)
+#define ISO_PFUNC0_get_iso_gpio_3_pud_sel(data)                                      ((0x00000010&(data))>>4)
+#define ISO_PFUNC0_iso_gpio_2_smt_shift                                              (3)
+#define ISO_PFUNC0_iso_gpio_2_smt_mask                                               (0x00000008)
+#define ISO_PFUNC0_iso_gpio_2_smt(data)                                              (0x00000008&((data)<<3))
+#define ISO_PFUNC0_iso_gpio_2_smt_src(data)                                          ((0x00000008&(data))>>3)
+#define ISO_PFUNC0_get_iso_gpio_2_smt(data)                                          ((0x00000008&(data))>>3)
+#define ISO_PFUNC0_iso_gpio_2_e2_shift                                               (2)
+#define ISO_PFUNC0_iso_gpio_2_e2_mask                                                (0x00000004)
+#define ISO_PFUNC0_iso_gpio_2_e2(data)                                               (0x00000004&((data)<<2))
+#define ISO_PFUNC0_iso_gpio_2_e2_src(data)                                           ((0x00000004&(data))>>2)
+#define ISO_PFUNC0_get_iso_gpio_2_e2(data)                                           ((0x00000004&(data))>>2)
+#define ISO_PFUNC0_iso_gpio_2_pud_en_shift                                           (1)
+#define ISO_PFUNC0_iso_gpio_2_pud_en_mask                                            (0x00000002)
+#define ISO_PFUNC0_iso_gpio_2_pud_en(data)                                           (0x00000002&((data)<<1))
+#define ISO_PFUNC0_iso_gpio_2_pud_en_src(data)                                       ((0x00000002&(data))>>1)
+#define ISO_PFUNC0_get_iso_gpio_2_pud_en(data)                                       ((0x00000002&(data))>>1)
+#define ISO_PFUNC0_iso_gpio_2_pud_sel_shift                                          (0)
+#define ISO_PFUNC0_iso_gpio_2_pud_sel_mask                                           (0x00000001)
+#define ISO_PFUNC0_iso_gpio_2_pud_sel(data)                                          (0x00000001&((data)<<0))
+#define ISO_PFUNC0_iso_gpio_2_pud_sel_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_PFUNC0_get_iso_gpio_2_pud_sel(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_PFUNC1                                                                   0x98007304
+#define ISO_PFUNC1_reg_addr                                                          "0xD8007304"
+#define ISO_PFUNC1_reg                                                               0xD8007304
+#define set_ISO_PFUNC1_reg(data)   (*((volatile unsigned int*) ISO_PFUNC1_reg)=data)
+#define get_ISO_PFUNC1_reg   (*((volatile unsigned int*) ISO_PFUNC1_reg))
+#define ISO_PFUNC1_inst_adr                                                          "0x00C1"
+#define ISO_PFUNC1_inst                                                              0x00C1
+#define ISO_PFUNC1_etn_led_rxtx_smt_shift                                            (31)
+#define ISO_PFUNC1_etn_led_rxtx_smt_mask                                             (0x80000000)
+#define ISO_PFUNC1_etn_led_rxtx_smt(data)                                            (0x80000000&((data)<<31))
+#define ISO_PFUNC1_etn_led_rxtx_smt_src(data)                                        ((0x80000000&(data))>>31)
+#define ISO_PFUNC1_get_etn_led_rxtx_smt(data)                                        ((0x80000000&(data))>>31)
+#define ISO_PFUNC1_etn_led_rxtx_e2_shift                                             (30)
+#define ISO_PFUNC1_etn_led_rxtx_e2_mask                                              (0x40000000)
+#define ISO_PFUNC1_etn_led_rxtx_e2(data)                                             (0x40000000&((data)<<30))
+#define ISO_PFUNC1_etn_led_rxtx_e2_src(data)                                         ((0x40000000&(data))>>30)
+#define ISO_PFUNC1_get_etn_led_rxtx_e2(data)                                         ((0x40000000&(data))>>30)
+#define ISO_PFUNC1_etn_led_rxtx_pud_en_shift                                         (29)
+#define ISO_PFUNC1_etn_led_rxtx_pud_en_mask                                          (0x20000000)
+#define ISO_PFUNC1_etn_led_rxtx_pud_en(data)                                         (0x20000000&((data)<<29))
+#define ISO_PFUNC1_etn_led_rxtx_pud_en_src(data)                                     ((0x20000000&(data))>>29)
+#define ISO_PFUNC1_get_etn_led_rxtx_pud_en(data)                                     ((0x20000000&(data))>>29)
+#define ISO_PFUNC1_etn_led_rxtx_pud_sel_shift                                        (28)
+#define ISO_PFUNC1_etn_led_rxtx_pud_sel_mask                                         (0x10000000)
+#define ISO_PFUNC1_etn_led_rxtx_pud_sel(data)                                        (0x10000000&((data)<<28))
+#define ISO_PFUNC1_etn_led_rxtx_pud_sel_src(data)                                    ((0x10000000&(data))>>28)
+#define ISO_PFUNC1_get_etn_led_rxtx_pud_sel(data)                                    ((0x10000000&(data))>>28)
+#define ISO_PFUNC1_etn_led_link_smt_shift                                            (27)
+#define ISO_PFUNC1_etn_led_link_smt_mask                                             (0x08000000)
+#define ISO_PFUNC1_etn_led_link_smt(data)                                            (0x08000000&((data)<<27))
+#define ISO_PFUNC1_etn_led_link_smt_src(data)                                        ((0x08000000&(data))>>27)
+#define ISO_PFUNC1_get_etn_led_link_smt(data)                                        ((0x08000000&(data))>>27)
+#define ISO_PFUNC1_etn_led_link_e2_shift                                             (26)
+#define ISO_PFUNC1_etn_led_link_e2_mask                                              (0x04000000)
+#define ISO_PFUNC1_etn_led_link_e2(data)                                             (0x04000000&((data)<<26))
+#define ISO_PFUNC1_etn_led_link_e2_src(data)                                         ((0x04000000&(data))>>26)
+#define ISO_PFUNC1_get_etn_led_link_e2(data)                                         ((0x04000000&(data))>>26)
+#define ISO_PFUNC1_etn_led_link_pud_en_shift                                         (25)
+#define ISO_PFUNC1_etn_led_link_pud_en_mask                                          (0x02000000)
+#define ISO_PFUNC1_etn_led_link_pud_en(data)                                         (0x02000000&((data)<<25))
+#define ISO_PFUNC1_etn_led_link_pud_en_src(data)                                     ((0x02000000&(data))>>25)
+#define ISO_PFUNC1_get_etn_led_link_pud_en(data)                                     ((0x02000000&(data))>>25)
+#define ISO_PFUNC1_etn_led_link_pud_sel_shift                                        (24)
+#define ISO_PFUNC1_etn_led_link_pud_sel_mask                                         (0x01000000)
+#define ISO_PFUNC1_etn_led_link_pud_sel(data)                                        (0x01000000&((data)<<24))
+#define ISO_PFUNC1_etn_led_link_pud_sel_src(data)                                    ((0x01000000&(data))>>24)
+#define ISO_PFUNC1_get_etn_led_link_pud_sel(data)                                    ((0x01000000&(data))>>24)
+#define ISO_PFUNC1_ur0_tx_smt_shift                                                  (23)
+#define ISO_PFUNC1_ur0_tx_smt_mask                                                   (0x00800000)
+#define ISO_PFUNC1_ur0_tx_smt(data)                                                  (0x00800000&((data)<<23))
+#define ISO_PFUNC1_ur0_tx_smt_src(data)                                              ((0x00800000&(data))>>23)
+#define ISO_PFUNC1_get_ur0_tx_smt(data)                                              ((0x00800000&(data))>>23)
+#define ISO_PFUNC1_ur0_tx_e2_shift                                                   (22)
+#define ISO_PFUNC1_ur0_tx_e2_mask                                                    (0x00400000)
+#define ISO_PFUNC1_ur0_tx_e2(data)                                                   (0x00400000&((data)<<22))
+#define ISO_PFUNC1_ur0_tx_e2_src(data)                                               ((0x00400000&(data))>>22)
+#define ISO_PFUNC1_get_ur0_tx_e2(data)                                               ((0x00400000&(data))>>22)
+#define ISO_PFUNC1_ur0_tx_pud_en_shift                                               (21)
+#define ISO_PFUNC1_ur0_tx_pud_en_mask                                                (0x00200000)
+#define ISO_PFUNC1_ur0_tx_pud_en(data)                                               (0x00200000&((data)<<21))
+#define ISO_PFUNC1_ur0_tx_pud_en_src(data)                                           ((0x00200000&(data))>>21)
+#define ISO_PFUNC1_get_ur0_tx_pud_en(data)                                           ((0x00200000&(data))>>21)
+#define ISO_PFUNC1_ur0_tx_pud_sel_shift                                              (20)
+#define ISO_PFUNC1_ur0_tx_pud_sel_mask                                               (0x00100000)
+#define ISO_PFUNC1_ur0_tx_pud_sel(data)                                              (0x00100000&((data)<<20))
+#define ISO_PFUNC1_ur0_tx_pud_sel_src(data)                                          ((0x00100000&(data))>>20)
+#define ISO_PFUNC1_get_ur0_tx_pud_sel(data)                                          ((0x00100000&(data))>>20)
+#define ISO_PFUNC1_ur0_rx_smt_shift                                                  (19)
+#define ISO_PFUNC1_ur0_rx_smt_mask                                                   (0x00080000)
+#define ISO_PFUNC1_ur0_rx_smt(data)                                                  (0x00080000&((data)<<19))
+#define ISO_PFUNC1_ur0_rx_smt_src(data)                                              ((0x00080000&(data))>>19)
+#define ISO_PFUNC1_get_ur0_rx_smt(data)                                              ((0x00080000&(data))>>19)
+#define ISO_PFUNC1_ur0_rx_e2_shift                                                   (18)
+#define ISO_PFUNC1_ur0_rx_e2_mask                                                    (0x00040000)
+#define ISO_PFUNC1_ur0_rx_e2(data)                                                   (0x00040000&((data)<<18))
+#define ISO_PFUNC1_ur0_rx_e2_src(data)                                               ((0x00040000&(data))>>18)
+#define ISO_PFUNC1_get_ur0_rx_e2(data)                                               ((0x00040000&(data))>>18)
+#define ISO_PFUNC1_ur0_rx_pud_en_shift                                               (17)
+#define ISO_PFUNC1_ur0_rx_pud_en_mask                                                (0x00020000)
+#define ISO_PFUNC1_ur0_rx_pud_en(data)                                               (0x00020000&((data)<<17))
+#define ISO_PFUNC1_ur0_rx_pud_en_src(data)                                           ((0x00020000&(data))>>17)
+#define ISO_PFUNC1_get_ur0_rx_pud_en(data)                                           ((0x00020000&(data))>>17)
+#define ISO_PFUNC1_ur0_rx_pud_sel_shift                                              (16)
+#define ISO_PFUNC1_ur0_rx_pud_sel_mask                                               (0x00010000)
+#define ISO_PFUNC1_ur0_rx_pud_sel(data)                                              (0x00010000&((data)<<16))
+#define ISO_PFUNC1_ur0_rx_pud_sel_src(data)                                          ((0x00010000&(data))>>16)
+#define ISO_PFUNC1_get_ur0_rx_pud_sel(data)                                          ((0x00010000&(data))>>16)
+#define ISO_PFUNC1_ur1_cts_n_smt_shift                                               (15)
+#define ISO_PFUNC1_ur1_cts_n_smt_mask                                                (0x00008000)
+#define ISO_PFUNC1_ur1_cts_n_smt(data)                                               (0x00008000&((data)<<15))
+#define ISO_PFUNC1_ur1_cts_n_smt_src(data)                                           ((0x00008000&(data))>>15)
+#define ISO_PFUNC1_get_ur1_cts_n_smt(data)                                           ((0x00008000&(data))>>15)
+#define ISO_PFUNC1_ur1_cts_n_e2_shift                                                (14)
+#define ISO_PFUNC1_ur1_cts_n_e2_mask                                                 (0x00004000)
+#define ISO_PFUNC1_ur1_cts_n_e2(data)                                                (0x00004000&((data)<<14))
+#define ISO_PFUNC1_ur1_cts_n_e2_src(data)                                            ((0x00004000&(data))>>14)
+#define ISO_PFUNC1_get_ur1_cts_n_e2(data)                                            ((0x00004000&(data))>>14)
+#define ISO_PFUNC1_ur1_cts_n_pud_en_shift                                            (13)
+#define ISO_PFUNC1_ur1_cts_n_pud_en_mask                                             (0x00002000)
+#define ISO_PFUNC1_ur1_cts_n_pud_en(data)                                            (0x00002000&((data)<<13))
+#define ISO_PFUNC1_ur1_cts_n_pud_en_src(data)                                        ((0x00002000&(data))>>13)
+#define ISO_PFUNC1_get_ur1_cts_n_pud_en(data)                                        ((0x00002000&(data))>>13)
+#define ISO_PFUNC1_ur1_cts_n_pud_sel_shift                                           (12)
+#define ISO_PFUNC1_ur1_cts_n_pud_sel_mask                                            (0x00001000)
+#define ISO_PFUNC1_ur1_cts_n_pud_sel(data)                                           (0x00001000&((data)<<12))
+#define ISO_PFUNC1_ur1_cts_n_pud_sel_src(data)                                       ((0x00001000&(data))>>12)
+#define ISO_PFUNC1_get_ur1_cts_n_pud_sel(data)                                       ((0x00001000&(data))>>12)
+#define ISO_PFUNC1_ur1_rts_n_smt_shift                                               (11)
+#define ISO_PFUNC1_ur1_rts_n_smt_mask                                                (0x00000800)
+#define ISO_PFUNC1_ur1_rts_n_smt(data)                                               (0x00000800&((data)<<11))
+#define ISO_PFUNC1_ur1_rts_n_smt_src(data)                                           ((0x00000800&(data))>>11)
+#define ISO_PFUNC1_get_ur1_rts_n_smt(data)                                           ((0x00000800&(data))>>11)
+#define ISO_PFUNC1_ur1_rts_n_e2_shift                                                (10)
+#define ISO_PFUNC1_ur1_rts_n_e2_mask                                                 (0x00000400)
+#define ISO_PFUNC1_ur1_rts_n_e2(data)                                                (0x00000400&((data)<<10))
+#define ISO_PFUNC1_ur1_rts_n_e2_src(data)                                            ((0x00000400&(data))>>10)
+#define ISO_PFUNC1_get_ur1_rts_n_e2(data)                                            ((0x00000400&(data))>>10)
+#define ISO_PFUNC1_ur1_rts_n_pud_en_shift                                            (9)
+#define ISO_PFUNC1_ur1_rts_n_pud_en_mask                                             (0x00000200)
+#define ISO_PFUNC1_ur1_rts_n_pud_en(data)                                            (0x00000200&((data)<<9))
+#define ISO_PFUNC1_ur1_rts_n_pud_en_src(data)                                        ((0x00000200&(data))>>9)
+#define ISO_PFUNC1_get_ur1_rts_n_pud_en(data)                                        ((0x00000200&(data))>>9)
+#define ISO_PFUNC1_ur1_rts_n_pud_sel_shift                                           (8)
+#define ISO_PFUNC1_ur1_rts_n_pud_sel_mask                                            (0x00000100)
+#define ISO_PFUNC1_ur1_rts_n_pud_sel(data)                                           (0x00000100&((data)<<8))
+#define ISO_PFUNC1_ur1_rts_n_pud_sel_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_PFUNC1_get_ur1_rts_n_pud_sel(data)                                       ((0x00000100&(data))>>8)
+#define ISO_PFUNC1_ur1_tx_smt_shift                                                  (7)
+#define ISO_PFUNC1_ur1_tx_smt_mask                                                   (0x00000080)
+#define ISO_PFUNC1_ur1_tx_smt(data)                                                  (0x00000080&((data)<<7))
+#define ISO_PFUNC1_ur1_tx_smt_src(data)                                              ((0x00000080&(data))>>7)
+#define ISO_PFUNC1_get_ur1_tx_smt(data)                                              ((0x00000080&(data))>>7)
+#define ISO_PFUNC1_ur1_tx_e2_shift                                                   (6)
+#define ISO_PFUNC1_ur1_tx_e2_mask                                                    (0x00000040)
+#define ISO_PFUNC1_ur1_tx_e2(data)                                                   (0x00000040&((data)<<6))
+#define ISO_PFUNC1_ur1_tx_e2_src(data)                                               ((0x00000040&(data))>>6)
+#define ISO_PFUNC1_get_ur1_tx_e2(data)                                               ((0x00000040&(data))>>6)
+#define ISO_PFUNC1_ur1_tx_pud_en_shift                                               (5)
+#define ISO_PFUNC1_ur1_tx_pud_en_mask                                                (0x00000020)
+#define ISO_PFUNC1_ur1_tx_pud_en(data)                                               (0x00000020&((data)<<5))
+#define ISO_PFUNC1_ur1_tx_pud_en_src(data)                                           ((0x00000020&(data))>>5)
+#define ISO_PFUNC1_get_ur1_tx_pud_en(data)                                           ((0x00000020&(data))>>5)
+#define ISO_PFUNC1_ur1_tx_pud_sel_shift                                              (4)
+#define ISO_PFUNC1_ur1_tx_pud_sel_mask                                               (0x00000010)
+#define ISO_PFUNC1_ur1_tx_pud_sel(data)                                              (0x00000010&((data)<<4))
+#define ISO_PFUNC1_ur1_tx_pud_sel_src(data)                                          ((0x00000010&(data))>>4)
+#define ISO_PFUNC1_get_ur1_tx_pud_sel(data)                                          ((0x00000010&(data))>>4)
+#define ISO_PFUNC1_ur1_rx_smt_shift                                                  (3)
+#define ISO_PFUNC1_ur1_rx_smt_mask                                                   (0x00000008)
+#define ISO_PFUNC1_ur1_rx_smt(data)                                                  (0x00000008&((data)<<3))
+#define ISO_PFUNC1_ur1_rx_smt_src(data)                                              ((0x00000008&(data))>>3)
+#define ISO_PFUNC1_get_ur1_rx_smt(data)                                              ((0x00000008&(data))>>3)
+#define ISO_PFUNC1_ur1_rx_e2_shift                                                   (2)
+#define ISO_PFUNC1_ur1_rx_e2_mask                                                    (0x00000004)
+#define ISO_PFUNC1_ur1_rx_e2(data)                                                   (0x00000004&((data)<<2))
+#define ISO_PFUNC1_ur1_rx_e2_src(data)                                               ((0x00000004&(data))>>2)
+#define ISO_PFUNC1_get_ur1_rx_e2(data)                                               ((0x00000004&(data))>>2)
+#define ISO_PFUNC1_ur1_rx_pud_en_shift                                               (1)
+#define ISO_PFUNC1_ur1_rx_pud_en_mask                                                (0x00000002)
+#define ISO_PFUNC1_ur1_rx_pud_en(data)                                               (0x00000002&((data)<<1))
+#define ISO_PFUNC1_ur1_rx_pud_en_src(data)                                           ((0x00000002&(data))>>1)
+#define ISO_PFUNC1_get_ur1_rx_pud_en(data)                                           ((0x00000002&(data))>>1)
+#define ISO_PFUNC1_ur1_rx_pud_sel_shift                                              (0)
+#define ISO_PFUNC1_ur1_rx_pud_sel_mask                                               (0x00000001)
+#define ISO_PFUNC1_ur1_rx_pud_sel(data)                                              (0x00000001&((data)<<0))
+#define ISO_PFUNC1_ur1_rx_pud_sel_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_PFUNC1_get_ur1_rx_pud_sel(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_PFUNC2                                                                   0x98007308
+#define ISO_PFUNC2_reg_addr                                                          "0xD8007308"
+#define ISO_PFUNC2_reg                                                               0xD8007308
+#define set_ISO_PFUNC2_reg(data)   (*((volatile unsigned int*) ISO_PFUNC2_reg)=data)
+#define get_ISO_PFUNC2_reg   (*((volatile unsigned int*) ISO_PFUNC2_reg))
+#define ISO_PFUNC2_inst_adr                                                          "0x00C2"
+#define ISO_PFUNC2_inst                                                              0x00C2
+#define ISO_PFUNC2_i2c_scl_1_smt_shift                                               (31)
+#define ISO_PFUNC2_i2c_scl_1_smt_mask                                                (0x80000000)
+#define ISO_PFUNC2_i2c_scl_1_smt(data)                                               (0x80000000&((data)<<31))
+#define ISO_PFUNC2_i2c_scl_1_smt_src(data)                                           ((0x80000000&(data))>>31)
+#define ISO_PFUNC2_get_i2c_scl_1_smt(data)                                           ((0x80000000&(data))>>31)
+#define ISO_PFUNC2_i2c_scl_1_e2_shift                                                (30)
+#define ISO_PFUNC2_i2c_scl_1_e2_mask                                                 (0x40000000)
+#define ISO_PFUNC2_i2c_scl_1_e2(data)                                                (0x40000000&((data)<<30))
+#define ISO_PFUNC2_i2c_scl_1_e2_src(data)                                            ((0x40000000&(data))>>30)
+#define ISO_PFUNC2_get_i2c_scl_1_e2(data)                                            ((0x40000000&(data))>>30)
+#define ISO_PFUNC2_i2c_scl_1_pud_en_shift                                            (29)
+#define ISO_PFUNC2_i2c_scl_1_pud_en_mask                                             (0x20000000)
+#define ISO_PFUNC2_i2c_scl_1_pud_en(data)                                            (0x20000000&((data)<<29))
+#define ISO_PFUNC2_i2c_scl_1_pud_en_src(data)                                        ((0x20000000&(data))>>29)
+#define ISO_PFUNC2_get_i2c_scl_1_pud_en(data)                                        ((0x20000000&(data))>>29)
+#define ISO_PFUNC2_i2c_scl_1_pud_sel_shift                                           (28)
+#define ISO_PFUNC2_i2c_scl_1_pud_sel_mask                                            (0x10000000)
+#define ISO_PFUNC2_i2c_scl_1_pud_sel(data)                                           (0x10000000&((data)<<28))
+#define ISO_PFUNC2_i2c_scl_1_pud_sel_src(data)                                       ((0x10000000&(data))>>28)
+#define ISO_PFUNC2_get_i2c_scl_1_pud_sel(data)                                       ((0x10000000&(data))>>28)
+#define ISO_PFUNC2_i2c_sda_1_smt_shift                                               (27)
+#define ISO_PFUNC2_i2c_sda_1_smt_mask                                                (0x08000000)
+#define ISO_PFUNC2_i2c_sda_1_smt(data)                                               (0x08000000&((data)<<27))
+#define ISO_PFUNC2_i2c_sda_1_smt_src(data)                                           ((0x08000000&(data))>>27)
+#define ISO_PFUNC2_get_i2c_sda_1_smt(data)                                           ((0x08000000&(data))>>27)
+#define ISO_PFUNC2_i2c_sda_1_e2_shift                                                (26)
+#define ISO_PFUNC2_i2c_sda_1_e2_mask                                                 (0x04000000)
+#define ISO_PFUNC2_i2c_sda_1_e2(data)                                                (0x04000000&((data)<<26))
+#define ISO_PFUNC2_i2c_sda_1_e2_src(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PFUNC2_get_i2c_sda_1_e2(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PFUNC2_i2c_sda_1_pud_en_shift                                            (25)
+#define ISO_PFUNC2_i2c_sda_1_pud_en_mask                                             (0x02000000)
+#define ISO_PFUNC2_i2c_sda_1_pud_en(data)                                            (0x02000000&((data)<<25))
+#define ISO_PFUNC2_i2c_sda_1_pud_en_src(data)                                        ((0x02000000&(data))>>25)
+#define ISO_PFUNC2_get_i2c_sda_1_pud_en(data)                                        ((0x02000000&(data))>>25)
+#define ISO_PFUNC2_i2c_sda_1_pud_sel_shift                                           (24)
+#define ISO_PFUNC2_i2c_sda_1_pud_sel_mask                                            (0x01000000)
+#define ISO_PFUNC2_i2c_sda_1_pud_sel(data)                                           (0x01000000&((data)<<24))
+#define ISO_PFUNC2_i2c_sda_1_pud_sel_src(data)                                       ((0x01000000&(data))>>24)
+#define ISO_PFUNC2_get_i2c_sda_1_pud_sel(data)                                       ((0x01000000&(data))>>24)
+#define ISO_PFUNC2_ir_tx_smt_shift                                                   (23)
+#define ISO_PFUNC2_ir_tx_smt_mask                                                    (0x00800000)
+#define ISO_PFUNC2_ir_tx_smt(data)                                                   (0x00800000&((data)<<23))
+#define ISO_PFUNC2_ir_tx_smt_src(data)                                               ((0x00800000&(data))>>23)
+#define ISO_PFUNC2_get_ir_tx_smt(data)                                               ((0x00800000&(data))>>23)
+#define ISO_PFUNC2_ir_tx_e2_shift                                                    (22)
+#define ISO_PFUNC2_ir_tx_e2_mask                                                     (0x00400000)
+#define ISO_PFUNC2_ir_tx_e2(data)                                                    (0x00400000&((data)<<22))
+#define ISO_PFUNC2_ir_tx_e2_src(data)                                                ((0x00400000&(data))>>22)
+#define ISO_PFUNC2_get_ir_tx_e2(data)                                                ((0x00400000&(data))>>22)
+#define ISO_PFUNC2_ir_tx_pud_en_shift                                                (21)
+#define ISO_PFUNC2_ir_tx_pud_en_mask                                                 (0x00200000)
+#define ISO_PFUNC2_ir_tx_pud_en(data)                                                (0x00200000&((data)<<21))
+#define ISO_PFUNC2_ir_tx_pud_en_src(data)                                            ((0x00200000&(data))>>21)
+#define ISO_PFUNC2_get_ir_tx_pud_en(data)                                            ((0x00200000&(data))>>21)
+#define ISO_PFUNC2_ir_tx_pud_sel_shift                                               (20)
+#define ISO_PFUNC2_ir_tx_pud_sel_mask                                                (0x00100000)
+#define ISO_PFUNC2_ir_tx_pud_sel(data)                                               (0x00100000&((data)<<20))
+#define ISO_PFUNC2_ir_tx_pud_sel_src(data)                                           ((0x00100000&(data))>>20)
+#define ISO_PFUNC2_get_ir_tx_pud_sel(data)                                           ((0x00100000&(data))>>20)
+#define ISO_PFUNC2_i2c_scl_6_smt_shift                                               (19)
+#define ISO_PFUNC2_i2c_scl_6_smt_mask                                                (0x00080000)
+#define ISO_PFUNC2_i2c_scl_6_smt(data)                                               (0x00080000&((data)<<19))
+#define ISO_PFUNC2_i2c_scl_6_smt_src(data)                                           ((0x00080000&(data))>>19)
+#define ISO_PFUNC2_get_i2c_scl_6_smt(data)                                           ((0x00080000&(data))>>19)
+#define ISO_PFUNC2_i2c_scl_6_e2_shift                                                (18)
+#define ISO_PFUNC2_i2c_scl_6_e2_mask                                                 (0x00040000)
+#define ISO_PFUNC2_i2c_scl_6_e2(data)                                                (0x00040000&((data)<<18))
+#define ISO_PFUNC2_i2c_scl_6_e2_src(data)                                            ((0x00040000&(data))>>18)
+#define ISO_PFUNC2_get_i2c_scl_6_e2(data)                                            ((0x00040000&(data))>>18)
+#define ISO_PFUNC2_i2c_scl_6_pud_en_shift                                            (17)
+#define ISO_PFUNC2_i2c_scl_6_pud_en_mask                                             (0x00020000)
+#define ISO_PFUNC2_i2c_scl_6_pud_en(data)                                            (0x00020000&((data)<<17))
+#define ISO_PFUNC2_i2c_scl_6_pud_en_src(data)                                        ((0x00020000&(data))>>17)
+#define ISO_PFUNC2_get_i2c_scl_6_pud_en(data)                                        ((0x00020000&(data))>>17)
+#define ISO_PFUNC2_i2c_scl_6_pud_sel_shift                                           (16)
+#define ISO_PFUNC2_i2c_scl_6_pud_sel_mask                                            (0x00010000)
+#define ISO_PFUNC2_i2c_scl_6_pud_sel(data)                                           (0x00010000&((data)<<16))
+#define ISO_PFUNC2_i2c_scl_6_pud_sel_src(data)                                       ((0x00010000&(data))>>16)
+#define ISO_PFUNC2_get_i2c_scl_6_pud_sel(data)                                       ((0x00010000&(data))>>16)
+#define ISO_PFUNC2_i2c_sda_6_smt_shift                                               (15)
+#define ISO_PFUNC2_i2c_sda_6_smt_mask                                                (0x00008000)
+#define ISO_PFUNC2_i2c_sda_6_smt(data)                                               (0x00008000&((data)<<15))
+#define ISO_PFUNC2_i2c_sda_6_smt_src(data)                                           ((0x00008000&(data))>>15)
+#define ISO_PFUNC2_get_i2c_sda_6_smt(data)                                           ((0x00008000&(data))>>15)
+#define ISO_PFUNC2_i2c_sda_6_e2_shift                                                (14)
+#define ISO_PFUNC2_i2c_sda_6_e2_mask                                                 (0x00004000)
+#define ISO_PFUNC2_i2c_sda_6_e2(data)                                                (0x00004000&((data)<<14))
+#define ISO_PFUNC2_i2c_sda_6_e2_src(data)                                            ((0x00004000&(data))>>14)
+#define ISO_PFUNC2_get_i2c_sda_6_e2(data)                                            ((0x00004000&(data))>>14)
+#define ISO_PFUNC2_i2c_sda_6_pud_en_shift                                            (13)
+#define ISO_PFUNC2_i2c_sda_6_pud_en_mask                                             (0x00002000)
+#define ISO_PFUNC2_i2c_sda_6_pud_en(data)                                            (0x00002000&((data)<<13))
+#define ISO_PFUNC2_i2c_sda_6_pud_en_src(data)                                        ((0x00002000&(data))>>13)
+#define ISO_PFUNC2_get_i2c_sda_6_pud_en(data)                                        ((0x00002000&(data))>>13)
+#define ISO_PFUNC2_i2c_sda_6_pud_sel_shift                                           (12)
+#define ISO_PFUNC2_i2c_sda_6_pud_sel_mask                                            (0x00001000)
+#define ISO_PFUNC2_i2c_sda_6_pud_sel(data)                                           (0x00001000&((data)<<12))
+#define ISO_PFUNC2_i2c_sda_6_pud_sel_src(data)                                       ((0x00001000&(data))>>12)
+#define ISO_PFUNC2_get_i2c_sda_6_pud_sel(data)                                       ((0x00001000&(data))>>12)
+#define ISO_PFUNC2_boot_sel_pud_en_shift                                             (11)
+#define ISO_PFUNC2_boot_sel_pud_en_mask                                              (0x00000800)
+#define ISO_PFUNC2_boot_sel_pud_en(data)                                             (0x00000800&((data)<<11))
+#define ISO_PFUNC2_boot_sel_pud_en_src(data)                                         ((0x00000800&(data))>>11)
+#define ISO_PFUNC2_get_boot_sel_pud_en(data)                                         ((0x00000800&(data))>>11)
+#define ISO_PFUNC2_boot_sel_pud_sel_shift                                            (10)
+#define ISO_PFUNC2_boot_sel_pud_sel_mask                                             (0x00000400)
+#define ISO_PFUNC2_boot_sel_pud_sel(data)                                            (0x00000400&((data)<<10))
+#define ISO_PFUNC2_boot_sel_pud_sel_src(data)                                        ((0x00000400&(data))>>10)
+#define ISO_PFUNC2_get_boot_sel_pud_sel(data)                                        ((0x00000400&(data))>>10)
+#define ISO_PFUNC2_testmode_pud_en_shift                                             (9)
+#define ISO_PFUNC2_testmode_pud_en_mask                                              (0x00000200)
+#define ISO_PFUNC2_testmode_pud_en(data)                                             (0x00000200&((data)<<9))
+#define ISO_PFUNC2_testmode_pud_en_src(data)                                         ((0x00000200&(data))>>9)
+#define ISO_PFUNC2_get_testmode_pud_en(data)                                         ((0x00000200&(data))>>9)
+#define ISO_PFUNC2_testmode_pud_sel_shift                                            (8)
+#define ISO_PFUNC2_testmode_pud_sel_mask                                             (0x00000100)
+#define ISO_PFUNC2_testmode_pud_sel(data)                                            (0x00000100&((data)<<8))
+#define ISO_PFUNC2_testmode_pud_sel_src(data)                                        ((0x00000100&(data))>>8)
+#define ISO_PFUNC2_get_testmode_pud_sel(data)                                        ((0x00000100&(data))>>8)
+#define ISO_PFUNC2_standby1_smt_shift                                                (7)
+#define ISO_PFUNC2_standby1_smt_mask                                                 (0x00000080)
+#define ISO_PFUNC2_standby1_smt(data)                                                (0x00000080&((data)<<7))
+#define ISO_PFUNC2_standby1_smt_src(data)                                            ((0x00000080&(data))>>7)
+#define ISO_PFUNC2_get_standby1_smt(data)                                            ((0x00000080&(data))>>7)
+#define ISO_PFUNC2_standby1_e2_shift                                                 (6)
+#define ISO_PFUNC2_standby1_e2_mask                                                  (0x00000040)
+#define ISO_PFUNC2_standby1_e2(data)                                                 (0x00000040&((data)<<6))
+#define ISO_PFUNC2_standby1_e2_src(data)                                             ((0x00000040&(data))>>6)
+#define ISO_PFUNC2_get_standby1_e2(data)                                             ((0x00000040&(data))>>6)
+#define ISO_PFUNC2_standby1_pud_en_shift                                             (5)
+#define ISO_PFUNC2_standby1_pud_en_mask                                              (0x00000020)
+#define ISO_PFUNC2_standby1_pud_en(data)                                             (0x00000020&((data)<<5))
+#define ISO_PFUNC2_standby1_pud_en_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_PFUNC2_get_standby1_pud_en(data)                                         ((0x00000020&(data))>>5)
+#define ISO_PFUNC2_standby1_pud_sel_shift                                            (4)
+#define ISO_PFUNC2_standby1_pud_sel_mask                                             (0x00000010)
+#define ISO_PFUNC2_standby1_pud_sel(data)                                            (0x00000010&((data)<<4))
+#define ISO_PFUNC2_standby1_pud_sel_src(data)                                        ((0x00000010&(data))>>4)
+#define ISO_PFUNC2_get_standby1_pud_sel(data)                                        ((0x00000010&(data))>>4)
+#define ISO_PFUNC2_standby_smt_shift                                                 (3)
+#define ISO_PFUNC2_standby_smt_mask                                                  (0x00000008)
+#define ISO_PFUNC2_standby_smt(data)                                                 (0x00000008&((data)<<3))
+#define ISO_PFUNC2_standby_smt_src(data)                                             ((0x00000008&(data))>>3)
+#define ISO_PFUNC2_get_standby_smt(data)                                             ((0x00000008&(data))>>3)
+#define ISO_PFUNC2_standby_e2_shift                                                  (2)
+#define ISO_PFUNC2_standby_e2_mask                                                   (0x00000004)
+#define ISO_PFUNC2_standby_e2(data)                                                  (0x00000004&((data)<<2))
+#define ISO_PFUNC2_standby_e2_src(data)                                              ((0x00000004&(data))>>2)
+#define ISO_PFUNC2_get_standby_e2(data)                                              ((0x00000004&(data))>>2)
+#define ISO_PFUNC2_standby_pud_en_shift                                              (1)
+#define ISO_PFUNC2_standby_pud_en_mask                                               (0x00000002)
+#define ISO_PFUNC2_standby_pud_en(data)                                              (0x00000002&((data)<<1))
+#define ISO_PFUNC2_standby_pud_en_src(data)                                          ((0x00000002&(data))>>1)
+#define ISO_PFUNC2_get_standby_pud_en(data)                                          ((0x00000002&(data))>>1)
+#define ISO_PFUNC2_standby_pud_sel_shift                                             (0)
+#define ISO_PFUNC2_standby_pud_sel_mask                                              (0x00000001)
+#define ISO_PFUNC2_standby_pud_sel(data)                                             (0x00000001&((data)<<0))
+#define ISO_PFUNC2_standby_pud_sel_src(data)                                         ((0x00000001&(data))>>0)
+#define ISO_PFUNC2_get_standby_pud_sel(data)                                         ((0x00000001&(data))>>0)
+
+
+#define ISO_PFUNC3                                                                   0x9800730C
+#define ISO_PFUNC3_reg_addr                                                          "0xD800730C"
+#define ISO_PFUNC3_reg                                                               0xD800730C
+#define set_ISO_PFUNC3_reg(data)   (*((volatile unsigned int*) ISO_PFUNC3_reg)=data)
+#define get_ISO_PFUNC3_reg   (*((volatile unsigned int*) ISO_PFUNC3_reg))
+#define ISO_PFUNC3_inst_adr                                                          "0x00C3"
+#define ISO_PFUNC3_inst                                                              0x00C3
+#define ISO_PFUNC3_nat_led_3_smt_shift                                               (31)
+#define ISO_PFUNC3_nat_led_3_smt_mask                                                (0x80000000)
+#define ISO_PFUNC3_nat_led_3_smt(data)                                               (0x80000000&((data)<<31))
+#define ISO_PFUNC3_nat_led_3_smt_src(data)                                           ((0x80000000&(data))>>31)
+#define ISO_PFUNC3_get_nat_led_3_smt(data)                                           ((0x80000000&(data))>>31)
+#define ISO_PFUNC3_nat_led_3_e2_shift                                                (30)
+#define ISO_PFUNC3_nat_led_3_e2_mask                                                 (0x40000000)
+#define ISO_PFUNC3_nat_led_3_e2(data)                                                (0x40000000&((data)<<30))
+#define ISO_PFUNC3_nat_led_3_e2_src(data)                                            ((0x40000000&(data))>>30)
+#define ISO_PFUNC3_get_nat_led_3_e2(data)                                            ((0x40000000&(data))>>30)
+#define ISO_PFUNC3_nat_led_3_pud_en_shift                                            (29)
+#define ISO_PFUNC3_nat_led_3_pud_en_mask                                             (0x20000000)
+#define ISO_PFUNC3_nat_led_3_pud_en(data)                                            (0x20000000&((data)<<29))
+#define ISO_PFUNC3_nat_led_3_pud_en_src(data)                                        ((0x20000000&(data))>>29)
+#define ISO_PFUNC3_get_nat_led_3_pud_en(data)                                        ((0x20000000&(data))>>29)
+#define ISO_PFUNC3_nat_led_3_pud_sel_shift                                           (28)
+#define ISO_PFUNC3_nat_led_3_pud_sel_mask                                            (0x10000000)
+#define ISO_PFUNC3_nat_led_3_pud_sel(data)                                           (0x10000000&((data)<<28))
+#define ISO_PFUNC3_nat_led_3_pud_sel_src(data)                                       ((0x10000000&(data))>>28)
+#define ISO_PFUNC3_get_nat_led_3_pud_sel(data)                                       ((0x10000000&(data))>>28)
+#define ISO_PFUNC3_nat_led_2_smt_shift                                               (27)
+#define ISO_PFUNC3_nat_led_2_smt_mask                                                (0x08000000)
+#define ISO_PFUNC3_nat_led_2_smt(data)                                               (0x08000000&((data)<<27))
+#define ISO_PFUNC3_nat_led_2_smt_src(data)                                           ((0x08000000&(data))>>27)
+#define ISO_PFUNC3_get_nat_led_2_smt(data)                                           ((0x08000000&(data))>>27)
+#define ISO_PFUNC3_nat_led_2_e2_shift                                                (26)
+#define ISO_PFUNC3_nat_led_2_e2_mask                                                 (0x04000000)
+#define ISO_PFUNC3_nat_led_2_e2(data)                                                (0x04000000&((data)<<26))
+#define ISO_PFUNC3_nat_led_2_e2_src(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PFUNC3_get_nat_led_2_e2(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PFUNC3_nat_led_2_pud_en_shift                                            (25)
+#define ISO_PFUNC3_nat_led_2_pud_en_mask                                             (0x02000000)
+#define ISO_PFUNC3_nat_led_2_pud_en(data)                                            (0x02000000&((data)<<25))
+#define ISO_PFUNC3_nat_led_2_pud_en_src(data)                                        ((0x02000000&(data))>>25)
+#define ISO_PFUNC3_get_nat_led_2_pud_en(data)                                        ((0x02000000&(data))>>25)
+#define ISO_PFUNC3_nat_led_2_pud_sel_shift                                           (24)
+#define ISO_PFUNC3_nat_led_2_pud_sel_mask                                            (0x01000000)
+#define ISO_PFUNC3_nat_led_2_pud_sel(data)                                           (0x01000000&((data)<<24))
+#define ISO_PFUNC3_nat_led_2_pud_sel_src(data)                                       ((0x01000000&(data))>>24)
+#define ISO_PFUNC3_get_nat_led_2_pud_sel(data)                                       ((0x01000000&(data))>>24)
+#define ISO_PFUNC3_nat_led_1_smt_shift                                               (23)
+#define ISO_PFUNC3_nat_led_1_smt_mask                                                (0x00800000)
+#define ISO_PFUNC3_nat_led_1_smt(data)                                               (0x00800000&((data)<<23))
+#define ISO_PFUNC3_nat_led_1_smt_src(data)                                           ((0x00800000&(data))>>23)
+#define ISO_PFUNC3_get_nat_led_1_smt(data)                                           ((0x00800000&(data))>>23)
+#define ISO_PFUNC3_nat_led_1_e2_shift                                                (22)
+#define ISO_PFUNC3_nat_led_1_e2_mask                                                 (0x00400000)
+#define ISO_PFUNC3_nat_led_1_e2(data)                                                (0x00400000&((data)<<22))
+#define ISO_PFUNC3_nat_led_1_e2_src(data)                                            ((0x00400000&(data))>>22)
+#define ISO_PFUNC3_get_nat_led_1_e2(data)                                            ((0x00400000&(data))>>22)
+#define ISO_PFUNC3_nat_led_1_pud_en_shift                                            (21)
+#define ISO_PFUNC3_nat_led_1_pud_en_mask                                             (0x00200000)
+#define ISO_PFUNC3_nat_led_1_pud_en(data)                                            (0x00200000&((data)<<21))
+#define ISO_PFUNC3_nat_led_1_pud_en_src(data)                                        ((0x00200000&(data))>>21)
+#define ISO_PFUNC3_get_nat_led_1_pud_en(data)                                        ((0x00200000&(data))>>21)
+#define ISO_PFUNC3_nat_led_1_pud_sel_shift                                           (20)
+#define ISO_PFUNC3_nat_led_1_pud_sel_mask                                            (0x00100000)
+#define ISO_PFUNC3_nat_led_1_pud_sel(data)                                           (0x00100000&((data)<<20))
+#define ISO_PFUNC3_nat_led_1_pud_sel_src(data)                                       ((0x00100000&(data))>>20)
+#define ISO_PFUNC3_get_nat_led_1_pud_sel(data)                                       ((0x00100000&(data))>>20)
+#define ISO_PFUNC3_nat_led_0_smt_shift                                               (19)
+#define ISO_PFUNC3_nat_led_0_smt_mask                                                (0x00080000)
+#define ISO_PFUNC3_nat_led_0_smt(data)                                               (0x00080000&((data)<<19))
+#define ISO_PFUNC3_nat_led_0_smt_src(data)                                           ((0x00080000&(data))>>19)
+#define ISO_PFUNC3_get_nat_led_0_smt(data)                                           ((0x00080000&(data))>>19)
+#define ISO_PFUNC3_nat_led_0_e2_shift                                                (18)
+#define ISO_PFUNC3_nat_led_0_e2_mask                                                 (0x00040000)
+#define ISO_PFUNC3_nat_led_0_e2(data)                                                (0x00040000&((data)<<18))
+#define ISO_PFUNC3_nat_led_0_e2_src(data)                                            ((0x00040000&(data))>>18)
+#define ISO_PFUNC3_get_nat_led_0_e2(data)                                            ((0x00040000&(data))>>18)
+#define ISO_PFUNC3_nat_led_0_pud_en_shift                                            (17)
+#define ISO_PFUNC3_nat_led_0_pud_en_mask                                             (0x00020000)
+#define ISO_PFUNC3_nat_led_0_pud_en(data)                                            (0x00020000&((data)<<17))
+#define ISO_PFUNC3_nat_led_0_pud_en_src(data)                                        ((0x00020000&(data))>>17)
+#define ISO_PFUNC3_get_nat_led_0_pud_en(data)                                        ((0x00020000&(data))>>17)
+#define ISO_PFUNC3_nat_led_0_pud_sel_shift                                           (16)
+#define ISO_PFUNC3_nat_led_0_pud_sel_mask                                            (0x00010000)
+#define ISO_PFUNC3_nat_led_0_pud_sel(data)                                           (0x00010000&((data)<<16))
+#define ISO_PFUNC3_nat_led_0_pud_sel_src(data)                                       ((0x00010000&(data))>>16)
+#define ISO_PFUNC3_get_nat_led_0_pud_sel(data)                                       ((0x00010000&(data))>>16)
+#define ISO_PFUNC3_hdmi_hpd_smt_shift                                                (15)
+#define ISO_PFUNC3_hdmi_hpd_smt_mask                                                 (0x00008000)
+#define ISO_PFUNC3_hdmi_hpd_smt(data)                                                (0x00008000&((data)<<15))
+#define ISO_PFUNC3_hdmi_hpd_smt_src(data)                                            ((0x00008000&(data))>>15)
+#define ISO_PFUNC3_get_hdmi_hpd_smt(data)                                            ((0x00008000&(data))>>15)
+#define ISO_PFUNC3_hdmi_hpd_e2_shift                                                 (14)
+#define ISO_PFUNC3_hdmi_hpd_e2_mask                                                  (0x00004000)
+#define ISO_PFUNC3_hdmi_hpd_e2(data)                                                 (0x00004000&((data)<<14))
+#define ISO_PFUNC3_hdmi_hpd_e2_src(data)                                             ((0x00004000&(data))>>14)
+#define ISO_PFUNC3_get_hdmi_hpd_e2(data)                                             ((0x00004000&(data))>>14)
+#define ISO_PFUNC3_hdmi_hpd_pud_en_shift                                             (13)
+#define ISO_PFUNC3_hdmi_hpd_pud_en_mask                                              (0x00002000)
+#define ISO_PFUNC3_hdmi_hpd_pud_en(data)                                             (0x00002000&((data)<<13))
+#define ISO_PFUNC3_hdmi_hpd_pud_en_src(data)                                         ((0x00002000&(data))>>13)
+#define ISO_PFUNC3_get_hdmi_hpd_pud_en(data)                                         ((0x00002000&(data))>>13)
+#define ISO_PFUNC3_hdmi_hpd_pud_sel_shift                                            (12)
+#define ISO_PFUNC3_hdmi_hpd_pud_sel_mask                                             (0x00001000)
+#define ISO_PFUNC3_hdmi_hpd_pud_sel(data)                                            (0x00001000&((data)<<12))
+#define ISO_PFUNC3_hdmi_hpd_pud_sel_src(data)                                        ((0x00001000&(data))>>12)
+#define ISO_PFUNC3_get_hdmi_hpd_pud_sel(data)                                        ((0x00001000&(data))>>12)
+#define ISO_PFUNC3_reset_n_pud_en_shift                                              (11)
+#define ISO_PFUNC3_reset_n_pud_en_mask                                               (0x00000800)
+#define ISO_PFUNC3_reset_n_pud_en(data)                                              (0x00000800&((data)<<11))
+#define ISO_PFUNC3_reset_n_pud_en_src(data)                                          ((0x00000800&(data))>>11)
+#define ISO_PFUNC3_get_reset_n_pud_en(data)                                          ((0x00000800&(data))>>11)
+#define ISO_PFUNC3_reset_n_pud_sel_shift                                             (10)
+#define ISO_PFUNC3_reset_n_pud_sel_mask                                              (0x00000400)
+#define ISO_PFUNC3_reset_n_pud_sel(data)                                             (0x00000400&((data)<<10))
+#define ISO_PFUNC3_reset_n_pud_sel_src(data)                                         ((0x00000400&(data))>>10)
+#define ISO_PFUNC3_get_reset_n_pud_sel(data)                                         ((0x00000400&(data))>>10)
+#define ISO_PFUNC3_boption12_en_shift                                                (7)
+#define ISO_PFUNC3_boption12_en_mask                                                 (0x00000080)
+#define ISO_PFUNC3_boption12_en(data)                                                (0x00000080&((data)<<7))
+#define ISO_PFUNC3_boption12_en_src(data)                                            ((0x00000080&(data))>>7)
+#define ISO_PFUNC3_get_boption12_en(data)                                            ((0x00000080&(data))>>7)
+#define ISO_PFUNC3_boption12_sel_shift                                               (6)
+#define ISO_PFUNC3_boption12_sel_mask                                                (0x00000040)
+#define ISO_PFUNC3_boption12_sel(data)                                               (0x00000040&((data)<<6))
+#define ISO_PFUNC3_boption12_sel_src(data)                                           ((0x00000040&(data))>>6)
+#define ISO_PFUNC3_get_boption12_sel(data)                                           ((0x00000040&(data))>>6)
+#define ISO_PFUNC3_boption11_en_shift                                                (5)
+#define ISO_PFUNC3_boption11_en_mask                                                 (0x00000020)
+#define ISO_PFUNC3_boption11_en(data)                                                (0x00000020&((data)<<5))
+#define ISO_PFUNC3_boption11_en_src(data)                                            ((0x00000020&(data))>>5)
+#define ISO_PFUNC3_get_boption11_en(data)                                            ((0x00000020&(data))>>5)
+#define ISO_PFUNC3_boption11_sel_shift                                               (4)
+#define ISO_PFUNC3_boption11_sel_mask                                                (0x00000010)
+#define ISO_PFUNC3_boption11_sel(data)                                               (0x00000010&((data)<<4))
+#define ISO_PFUNC3_boption11_sel_src(data)                                           ((0x00000010&(data))>>4)
+#define ISO_PFUNC3_get_boption11_sel(data)                                           ((0x00000010&(data))>>4)
+#define ISO_PFUNC3_boption10_en_shift                                                (3)
+#define ISO_PFUNC3_boption10_en_mask                                                 (0x00000008)
+#define ISO_PFUNC3_boption10_en(data)                                                (0x00000008&((data)<<3))
+#define ISO_PFUNC3_boption10_en_src(data)                                            ((0x00000008&(data))>>3)
+#define ISO_PFUNC3_get_boption10_en(data)                                            ((0x00000008&(data))>>3)
+#define ISO_PFUNC3_boption10_sel_shift                                               (2)
+#define ISO_PFUNC3_boption10_sel_mask                                                (0x00000004)
+#define ISO_PFUNC3_boption10_sel(data)                                               (0x00000004&((data)<<2))
+#define ISO_PFUNC3_boption10_sel_src(data)                                           ((0x00000004&(data))>>2)
+#define ISO_PFUNC3_get_boption10_sel(data)                                           ((0x00000004&(data))>>2)
+#define ISO_PFUNC3_boption2_en_shift                                                 (1)
+#define ISO_PFUNC3_boption2_en_mask                                                  (0x00000002)
+#define ISO_PFUNC3_boption2_en(data)                                                 (0x00000002&((data)<<1))
+#define ISO_PFUNC3_boption2_en_src(data)                                             ((0x00000002&(data))>>1)
+#define ISO_PFUNC3_get_boption2_en(data)                                             ((0x00000002&(data))>>1)
+#define ISO_PFUNC3_boption2_sel_shift                                                (0)
+#define ISO_PFUNC3_boption2_sel_mask                                                 (0x00000001)
+#define ISO_PFUNC3_boption2_sel(data)                                                (0x00000001&((data)<<0))
+#define ISO_PFUNC3_boption2_sel_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_PFUNC3_get_boption2_sel(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_MUXPAD0                                                                  0x98007310
+#define ISO_MUXPAD0_reg_addr                                                         "0xD8007310"
+#define ISO_MUXPAD0_reg                                                              0xD8007310
+#define set_ISO_MUXPAD0_reg(data)   (*((volatile unsigned int*) ISO_MUXPAD0_reg)=data)
+#define get_ISO_MUXPAD0_reg   (*((volatile unsigned int*) ISO_MUXPAD0_reg))
+#define ISO_MUXPAD0_inst_adr                                                         "0x00C4"
+#define ISO_MUXPAD0_inst                                                             0x00C4
+#define ISO_MUXPAD0_etn_led_rxtx_shift                                               (28)
+#define ISO_MUXPAD0_etn_led_rxtx_mask                                                (0x30000000)
+#define ISO_MUXPAD0_etn_led_rxtx(data)                                               (0x30000000&((data)<<28))
+#define ISO_MUXPAD0_etn_led_rxtx_src(data)                                           ((0x30000000&(data))>>28)
+#define ISO_MUXPAD0_get_etn_led_rxtx(data)                                           ((0x30000000&(data))>>28)
+#define ISO_MUXPAD0_etn_led_link_shift                                               (26)
+#define ISO_MUXPAD0_etn_led_link_mask                                                (0x0C000000)
+#define ISO_MUXPAD0_etn_led_link(data)                                               (0x0C000000&((data)<<26))
+#define ISO_MUXPAD0_etn_led_link_src(data)                                           ((0x0C000000&(data))>>26)
+#define ISO_MUXPAD0_get_etn_led_link(data)                                           ((0x0C000000&(data))>>26)
+#define ISO_MUXPAD0_i2c_sda_0_shift                                                  (24)
+#define ISO_MUXPAD0_i2c_sda_0_mask                                                   (0x03000000)
+#define ISO_MUXPAD0_i2c_sda_0(data)                                                  (0x03000000&((data)<<24))
+#define ISO_MUXPAD0_i2c_sda_0_src(data)                                              ((0x03000000&(data))>>24)
+#define ISO_MUXPAD0_get_i2c_sda_0(data)                                              ((0x03000000&(data))>>24)
+#define ISO_MUXPAD0_i2c_scl_0_shift                                                  (22)
+#define ISO_MUXPAD0_i2c_scl_0_mask                                                   (0x00C00000)
+#define ISO_MUXPAD0_i2c_scl_0(data)                                                  (0x00C00000&((data)<<22))
+#define ISO_MUXPAD0_i2c_scl_0_src(data)                                              ((0x00C00000&(data))>>22)
+#define ISO_MUXPAD0_get_i2c_scl_0(data)                                              ((0x00C00000&(data))>>22)
+#define ISO_MUXPAD0_ur1_rts_n_shift                                                  (20)
+#define ISO_MUXPAD0_ur1_rts_n_mask                                                   (0x00300000)
+#define ISO_MUXPAD0_ur1_rts_n(data)                                                  (0x00300000&((data)<<20))
+#define ISO_MUXPAD0_ur1_rts_n_src(data)                                              ((0x00300000&(data))>>20)
+#define ISO_MUXPAD0_get_ur1_rts_n(data)                                              ((0x00300000&(data))>>20)
+#define ISO_MUXPAD0_ur1_cts_n_shift                                                  (18)
+#define ISO_MUXPAD0_ur1_cts_n_mask                                                   (0x000C0000)
+#define ISO_MUXPAD0_ur1_cts_n(data)                                                  (0x000C0000&((data)<<18))
+#define ISO_MUXPAD0_ur1_cts_n_src(data)                                              ((0x000C0000&(data))>>18)
+#define ISO_MUXPAD0_get_ur1_cts_n(data)                                              ((0x000C0000&(data))>>18)
+#define ISO_MUXPAD0_ur1_tx_shift                                                     (16)
+#define ISO_MUXPAD0_ur1_tx_mask                                                      (0x00030000)
+#define ISO_MUXPAD0_ur1_tx(data)                                                     (0x00030000&((data)<<16))
+#define ISO_MUXPAD0_ur1_tx_src(data)                                                 ((0x00030000&(data))>>16)
+#define ISO_MUXPAD0_get_ur1_tx(data)                                                 ((0x00030000&(data))>>16)
+#define ISO_MUXPAD0_ur1_rx_shift                                                     (14)
+#define ISO_MUXPAD0_ur1_rx_mask                                                      (0x0000C000)
+#define ISO_MUXPAD0_ur1_rx(data)                                                     (0x0000C000&((data)<<14))
+#define ISO_MUXPAD0_ur1_rx_src(data)                                                 ((0x0000C000&(data))>>14)
+#define ISO_MUXPAD0_get_ur1_rx(data)                                                 ((0x0000C000&(data))>>14)
+#define ISO_MUXPAD0_ur0_tx_shift                                                     (12)
+#define ISO_MUXPAD0_ur0_tx_mask                                                      (0x00003000)
+#define ISO_MUXPAD0_ur0_tx(data)                                                     (0x00003000&((data)<<12))
+#define ISO_MUXPAD0_ur0_tx_src(data)                                                 ((0x00003000&(data))>>12)
+#define ISO_MUXPAD0_get_ur0_tx(data)                                                 ((0x00003000&(data))>>12)
+#define ISO_MUXPAD0_ur0_rx_shift                                                     (10)
+#define ISO_MUXPAD0_ur0_rx_mask                                                      (0x00000C00)
+#define ISO_MUXPAD0_ur0_rx(data)                                                     (0x00000C00&((data)<<10))
+#define ISO_MUXPAD0_ur0_rx_src(data)                                                 ((0x00000C00&(data))>>10)
+#define ISO_MUXPAD0_get_ur0_rx(data)                                                 ((0x00000C00&(data))>>10)
+#define ISO_MUXPAD0_ir_tx_shift                                                      (8)
+#define ISO_MUXPAD0_ir_tx_mask                                                       (0x00000300)
+#define ISO_MUXPAD0_ir_tx(data)                                                      (0x00000300&((data)<<8))
+#define ISO_MUXPAD0_ir_tx_src(data)                                                  ((0x00000300&(data))>>8)
+#define ISO_MUXPAD0_get_ir_tx(data)                                                  ((0x00000300&(data))>>8)
+#define ISO_MUXPAD0_ir_rx_shift                                                      (6)
+#define ISO_MUXPAD0_ir_rx_mask                                                       (0x000000C0)
+#define ISO_MUXPAD0_ir_rx(data)                                                      (0x000000C0&((data)<<6))
+#define ISO_MUXPAD0_ir_rx_src(data)                                                  ((0x000000C0&(data))>>6)
+#define ISO_MUXPAD0_get_ir_rx(data)                                                  ((0x000000C0&(data))>>6)
+#define ISO_MUXPAD0_iso_gpio_7_shift                                                 (4)
+#define ISO_MUXPAD0_iso_gpio_7_mask                                                  (0x00000030)
+#define ISO_MUXPAD0_iso_gpio_7(data)                                                 (0x00000030&((data)<<4))
+#define ISO_MUXPAD0_iso_gpio_7_src(data)                                             ((0x00000030&(data))>>4)
+#define ISO_MUXPAD0_get_iso_gpio_7(data)                                             ((0x00000030&(data))>>4)
+#define ISO_MUXPAD0_iso_gpio_5_shift                                                 (2)
+#define ISO_MUXPAD0_iso_gpio_5_mask                                                  (0x0000000C)
+#define ISO_MUXPAD0_iso_gpio_5(data)                                                 (0x0000000C&((data)<<2))
+#define ISO_MUXPAD0_iso_gpio_5_src(data)                                             ((0x0000000C&(data))>>2)
+#define ISO_MUXPAD0_get_iso_gpio_5(data)                                             ((0x0000000C&(data))>>2)
+#define ISO_MUXPAD0_iso_gpio_4_shift                                                 (0)
+#define ISO_MUXPAD0_iso_gpio_4_mask                                                  (0x00000003)
+#define ISO_MUXPAD0_iso_gpio_4(data)                                                 (0x00000003&((data)<<0))
+#define ISO_MUXPAD0_iso_gpio_4_src(data)                                             ((0x00000003&(data))>>0)
+#define ISO_MUXPAD0_get_iso_gpio_4(data)                                             ((0x00000003&(data))>>0)
+
+
+#define ISO_MUXPAD1                                                                  0x98007314
+#define ISO_MUXPAD1_reg_addr                                                         "0xD8007314"
+#define ISO_MUXPAD1_reg                                                              0xD8007314
+#define set_ISO_MUXPAD1_reg(data)   (*((volatile unsigned int*) ISO_MUXPAD1_reg)=data)
+#define get_ISO_MUXPAD1_reg   (*((volatile unsigned int*) ISO_MUXPAD1_reg))
+#define ISO_MUXPAD1_inst_adr                                                         "0x00C5"
+#define ISO_MUXPAD1_inst                                                             0x00C5
+#define ISO_MUXPAD1_ur2_loc_shift                                                    (30)
+#define ISO_MUXPAD1_ur2_loc_mask                                                     (0xC0000000)
+#define ISO_MUXPAD1_ur2_loc(data)                                                    (0xC0000000&((data)<<30))
+#define ISO_MUXPAD1_ur2_loc_src(data)                                                ((0xC0000000&(data))>>30)
+#define ISO_MUXPAD1_get_ur2_loc(data)                                                ((0xC0000000&(data))>>30)
+#define ISO_MUXPAD1_ejtag_avcpu_loc_shift                                            (28)
+#define ISO_MUXPAD1_ejtag_avcpu_loc_mask                                             (0x30000000)
+#define ISO_MUXPAD1_ejtag_avcpu_loc(data)                                            (0x30000000&((data)<<28))
+#define ISO_MUXPAD1_ejtag_avcpu_loc_src(data)                                        ((0x30000000&(data))>>28)
+#define ISO_MUXPAD1_get_ejtag_avcpu_loc(data)                                        ((0x30000000&(data))>>28)
+#define ISO_MUXPAD1_pwm_01_open_drain_en_loc1_shift                                  (27)
+#define ISO_MUXPAD1_pwm_01_open_drain_en_loc1_mask                                   (0x08000000)
+#define ISO_MUXPAD1_pwm_01_open_drain_en_loc1(data)                                  (0x08000000&((data)<<27))
+#define ISO_MUXPAD1_pwm_01_open_drain_en_loc1_src(data)                              ((0x08000000&(data))>>27)
+#define ISO_MUXPAD1_get_pwm_01_open_drain_en_loc1(data)                              ((0x08000000&(data))>>27)
+#define ISO_MUXPAD1_pwm_23_open_drain_en_loc1_shift                                  (26)
+#define ISO_MUXPAD1_pwm_23_open_drain_en_loc1_mask                                   (0x04000000)
+#define ISO_MUXPAD1_pwm_23_open_drain_en_loc1(data)                                  (0x04000000&((data)<<26))
+#define ISO_MUXPAD1_pwm_23_open_drain_en_loc1_src(data)                              ((0x04000000&(data))>>26)
+#define ISO_MUXPAD1_get_pwm_23_open_drain_en_loc1(data)                              ((0x04000000&(data))>>26)
+#define ISO_MUXPAD1_pwm_01_open_drain_en_loc0_shift                                  (25)
+#define ISO_MUXPAD1_pwm_01_open_drain_en_loc0_mask                                   (0x02000000)
+#define ISO_MUXPAD1_pwm_01_open_drain_en_loc0(data)                                  (0x02000000&((data)<<25))
+#define ISO_MUXPAD1_pwm_01_open_drain_en_loc0_src(data)                              ((0x02000000&(data))>>25)
+#define ISO_MUXPAD1_get_pwm_01_open_drain_en_loc0(data)                              ((0x02000000&(data))>>25)
+#define ISO_MUXPAD1_pwm_23_open_drain_en_loc0_shift                                  (24)
+#define ISO_MUXPAD1_pwm_23_open_drain_en_loc0_mask                                   (0x01000000)
+#define ISO_MUXPAD1_pwm_23_open_drain_en_loc0(data)                                  (0x01000000&((data)<<24))
+#define ISO_MUXPAD1_pwm_23_open_drain_en_loc0_src(data)                              ((0x01000000&(data))>>24)
+#define ISO_MUXPAD1_get_pwm_23_open_drain_en_loc0(data)                              ((0x01000000&(data))>>24)
+#define ISO_MUXPAD1_nat_led_3_shift                                                  (22)
+#define ISO_MUXPAD1_nat_led_3_mask                                                   (0x00C00000)
+#define ISO_MUXPAD1_nat_led_3(data)                                                  (0x00C00000&((data)<<22))
+#define ISO_MUXPAD1_nat_led_3_src(data)                                              ((0x00C00000&(data))>>22)
+#define ISO_MUXPAD1_get_nat_led_3(data)                                              ((0x00C00000&(data))>>22)
+#define ISO_MUXPAD1_nat_led_2_shift                                                  (20)
+#define ISO_MUXPAD1_nat_led_2_mask                                                   (0x00300000)
+#define ISO_MUXPAD1_nat_led_2(data)                                                  (0x00300000&((data)<<20))
+#define ISO_MUXPAD1_nat_led_2_src(data)                                              ((0x00300000&(data))>>20)
+#define ISO_MUXPAD1_get_nat_led_2(data)                                              ((0x00300000&(data))>>20)
+#define ISO_MUXPAD1_nat_led_1_shift                                                  (18)
+#define ISO_MUXPAD1_nat_led_1_mask                                                   (0x000C0000)
+#define ISO_MUXPAD1_nat_led_1(data)                                                  (0x000C0000&((data)<<18))
+#define ISO_MUXPAD1_nat_led_1_src(data)                                              ((0x000C0000&(data))>>18)
+#define ISO_MUXPAD1_get_nat_led_1(data)                                              ((0x000C0000&(data))>>18)
+#define ISO_MUXPAD1_nat_led_0_shift                                                  (16)
+#define ISO_MUXPAD1_nat_led_0_mask                                                   (0x00030000)
+#define ISO_MUXPAD1_nat_led_0(data)                                                  (0x00030000&((data)<<16))
+#define ISO_MUXPAD1_nat_led_0_src(data)                                              ((0x00030000&(data))>>16)
+#define ISO_MUXPAD1_get_nat_led_0(data)                                              ((0x00030000&(data))>>16)
+#define ISO_MUXPAD1_i2c_sda_1_shift                                                  (14)
+#define ISO_MUXPAD1_i2c_sda_1_mask                                                   (0x0000C000)
+#define ISO_MUXPAD1_i2c_sda_1(data)                                                  (0x0000C000&((data)<<14))
+#define ISO_MUXPAD1_i2c_sda_1_src(data)                                              ((0x0000C000&(data))>>14)
+#define ISO_MUXPAD1_get_i2c_sda_1(data)                                              ((0x0000C000&(data))>>14)
+#define ISO_MUXPAD1_i2c_scl_1_shift                                                  (12)
+#define ISO_MUXPAD1_i2c_scl_1_mask                                                   (0x00003000)
+#define ISO_MUXPAD1_i2c_scl_1(data)                                                  (0x00003000&((data)<<12))
+#define ISO_MUXPAD1_i2c_scl_1_src(data)                                              ((0x00003000&(data))>>12)
+#define ISO_MUXPAD1_get_i2c_scl_1(data)                                              ((0x00003000&(data))>>12)
+#define ISO_MUXPAD1_iso_gpio_3_shift                                                 (9)
+#define ISO_MUXPAD1_iso_gpio_3_mask                                                  (0x00000E00)
+#define ISO_MUXPAD1_iso_gpio_3(data)                                                 (0x00000E00&((data)<<9))
+#define ISO_MUXPAD1_iso_gpio_3_src(data)                                             ((0x00000E00&(data))>>9)
+#define ISO_MUXPAD1_get_iso_gpio_3(data)                                             ((0x00000E00&(data))>>9)
+#define ISO_MUXPAD1_iso_gpio_2_shift                                                 (6)
+#define ISO_MUXPAD1_iso_gpio_2_mask                                                  (0x000001C0)
+#define ISO_MUXPAD1_iso_gpio_2(data)                                                 (0x000001C0&((data)<<6))
+#define ISO_MUXPAD1_iso_gpio_2_src(data)                                             ((0x000001C0&(data))>>6)
+#define ISO_MUXPAD1_get_iso_gpio_2(data)                                             ((0x000001C0&(data))>>6)
+#define ISO_MUXPAD1_hdmi_hpd_shift                                                   (4)
+#define ISO_MUXPAD1_hdmi_hpd_mask                                                    (0x00000030)
+#define ISO_MUXPAD1_hdmi_hpd(data)                                                   (0x00000030&((data)<<4))
+#define ISO_MUXPAD1_hdmi_hpd_src(data)                                               ((0x00000030&(data))>>4)
+#define ISO_MUXPAD1_get_hdmi_hpd(data)                                               ((0x00000030&(data))>>4)
+#define ISO_MUXPAD1_i2c_sda_6_shift                                                  (2)
+#define ISO_MUXPAD1_i2c_sda_6_mask                                                   (0x0000000C)
+#define ISO_MUXPAD1_i2c_sda_6(data)                                                  (0x0000000C&((data)<<2))
+#define ISO_MUXPAD1_i2c_sda_6_src(data)                                              ((0x0000000C&(data))>>2)
+#define ISO_MUXPAD1_get_i2c_sda_6(data)                                              ((0x0000000C&(data))>>2)
+#define ISO_MUXPAD1_i2c_scl_6_shift                                                  (0)
+#define ISO_MUXPAD1_i2c_scl_6_mask                                                   (0x00000003)
+#define ISO_MUXPAD1_i2c_scl_6(data)                                                  (0x00000003&((data)<<0))
+#define ISO_MUXPAD1_i2c_scl_6_src(data)                                              ((0x00000003&(data))>>0)
+#define ISO_MUXPAD1_get_i2c_scl_6(data)                                              ((0x00000003&(data))>>0)
+
+
+#define ISO_PFUNC4                                                                   0x98007318
+#define ISO_PFUNC4_reg_addr                                                          "0xD8007318"
+#define ISO_PFUNC4_reg                                                               0xD8007318
+#define set_ISO_PFUNC4_reg(data)   (*((volatile unsigned int*) ISO_PFUNC4_reg)=data)
+#define get_ISO_PFUNC4_reg   (*((volatile unsigned int*) ISO_PFUNC4_reg))
+#define ISO_PFUNC4_inst_adr                                                          "0x00C6"
+#define ISO_PFUNC4_inst                                                              0x00C6
+#define ISO_PFUNC4_boot_sel_smt_shift                                                (27)
+#define ISO_PFUNC4_boot_sel_smt_mask                                                 (0x08000000)
+#define ISO_PFUNC4_boot_sel_smt(data)                                                (0x08000000&((data)<<27))
+#define ISO_PFUNC4_boot_sel_smt_src(data)                                            ((0x08000000&(data))>>27)
+#define ISO_PFUNC4_get_boot_sel_smt(data)                                            ((0x08000000&(data))>>27)
+#define ISO_PFUNC4_testmode_smt_shift                                                (26)
+#define ISO_PFUNC4_testmode_smt_mask                                                 (0x04000000)
+#define ISO_PFUNC4_testmode_smt(data)                                                (0x04000000&((data)<<26))
+#define ISO_PFUNC4_testmode_smt_src(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PFUNC4_get_testmode_smt(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PFUNC4_reset_n_smt_shift                                                 (25)
+#define ISO_PFUNC4_reset_n_smt_mask                                                  (0x02000000)
+#define ISO_PFUNC4_reset_n_smt(data)                                                 (0x02000000&((data)<<25))
+#define ISO_PFUNC4_reset_n_smt_src(data)                                             ((0x02000000&(data))>>25)
+#define ISO_PFUNC4_get_reset_n_smt(data)                                             ((0x02000000&(data))>>25)
+#define ISO_PFUNC4_boption12_smt_shift                                               (23)
+#define ISO_PFUNC4_boption12_smt_mask                                                (0x00800000)
+#define ISO_PFUNC4_boption12_smt(data)                                               (0x00800000&((data)<<23))
+#define ISO_PFUNC4_boption12_smt_src(data)                                           ((0x00800000&(data))>>23)
+#define ISO_PFUNC4_get_boption12_smt(data)                                           ((0x00800000&(data))>>23)
+#define ISO_PFUNC4_boption11_smt_shift                                               (22)
+#define ISO_PFUNC4_boption11_smt_mask                                                (0x00400000)
+#define ISO_PFUNC4_boption11_smt(data)                                               (0x00400000&((data)<<22))
+#define ISO_PFUNC4_boption11_smt_src(data)                                           ((0x00400000&(data))>>22)
+#define ISO_PFUNC4_get_boption11_smt(data)                                           ((0x00400000&(data))>>22)
+#define ISO_PFUNC4_boption10_smt_shift                                               (21)
+#define ISO_PFUNC4_boption10_smt_mask                                                (0x00200000)
+#define ISO_PFUNC4_boption10_smt(data)                                               (0x00200000&((data)<<21))
+#define ISO_PFUNC4_boption10_smt_src(data)                                           ((0x00200000&(data))>>21)
+#define ISO_PFUNC4_get_boption10_smt(data)                                           ((0x00200000&(data))>>21)
+#define ISO_PFUNC4_boption2_smt_shift                                                (20)
+#define ISO_PFUNC4_boption2_smt_mask                                                 (0x00100000)
+#define ISO_PFUNC4_boption2_smt(data)                                                (0x00100000&((data)<<20))
+#define ISO_PFUNC4_boption2_smt_src(data)                                            ((0x00100000&(data))>>20)
+#define ISO_PFUNC4_get_boption2_smt(data)                                            ((0x00100000&(data))>>20)
+#define ISO_PFUNC4_iso_gpio_25_smt_shift                                             (19)
+#define ISO_PFUNC4_iso_gpio_25_smt_mask                                              (0x00080000)
+#define ISO_PFUNC4_iso_gpio_25_smt(data)                                             (0x00080000&((data)<<19))
+#define ISO_PFUNC4_iso_gpio_25_smt_src(data)                                         ((0x00080000&(data))>>19)
+#define ISO_PFUNC4_get_iso_gpio_25_smt(data)                                         ((0x00080000&(data))>>19)
+#define ISO_PFUNC4_iso_gpio_25_e2_shift                                              (18)
+#define ISO_PFUNC4_iso_gpio_25_e2_mask                                               (0x00040000)
+#define ISO_PFUNC4_iso_gpio_25_e2(data)                                              (0x00040000&((data)<<18))
+#define ISO_PFUNC4_iso_gpio_25_e2_src(data)                                          ((0x00040000&(data))>>18)
+#define ISO_PFUNC4_get_iso_gpio_25_e2(data)                                          ((0x00040000&(data))>>18)
+#define ISO_PFUNC4_iso_gpio_25_pud_en_shift                                          (17)
+#define ISO_PFUNC4_iso_gpio_25_pud_en_mask                                           (0x00020000)
+#define ISO_PFUNC4_iso_gpio_25_pud_en(data)                                          (0x00020000&((data)<<17))
+#define ISO_PFUNC4_iso_gpio_25_pud_en_src(data)                                      ((0x00020000&(data))>>17)
+#define ISO_PFUNC4_get_iso_gpio_25_pud_en(data)                                      ((0x00020000&(data))>>17)
+#define ISO_PFUNC4_iso_gpio_25_pud_sel_shift                                         (16)
+#define ISO_PFUNC4_iso_gpio_25_pud_sel_mask                                          (0x00010000)
+#define ISO_PFUNC4_iso_gpio_25_pud_sel(data)                                         (0x00010000&((data)<<16))
+#define ISO_PFUNC4_iso_gpio_25_pud_sel_src(data)                                     ((0x00010000&(data))>>16)
+#define ISO_PFUNC4_get_iso_gpio_25_pud_sel(data)                                     ((0x00010000&(data))>>16)
+#define ISO_PFUNC4_iso_gpio_24_smt_shift                                             (15)
+#define ISO_PFUNC4_iso_gpio_24_smt_mask                                              (0x00008000)
+#define ISO_PFUNC4_iso_gpio_24_smt(data)                                             (0x00008000&((data)<<15))
+#define ISO_PFUNC4_iso_gpio_24_smt_src(data)                                         ((0x00008000&(data))>>15)
+#define ISO_PFUNC4_get_iso_gpio_24_smt(data)                                         ((0x00008000&(data))>>15)
+#define ISO_PFUNC4_iso_gpio_24_e2_shift                                              (14)
+#define ISO_PFUNC4_iso_gpio_24_e2_mask                                               (0x00004000)
+#define ISO_PFUNC4_iso_gpio_24_e2(data)                                              (0x00004000&((data)<<14))
+#define ISO_PFUNC4_iso_gpio_24_e2_src(data)                                          ((0x00004000&(data))>>14)
+#define ISO_PFUNC4_get_iso_gpio_24_e2(data)                                          ((0x00004000&(data))>>14)
+#define ISO_PFUNC4_iso_gpio_24_pud_en_shift                                          (13)
+#define ISO_PFUNC4_iso_gpio_24_pud_en_mask                                           (0x00002000)
+#define ISO_PFUNC4_iso_gpio_24_pud_en(data)                                          (0x00002000&((data)<<13))
+#define ISO_PFUNC4_iso_gpio_24_pud_en_src(data)                                      ((0x00002000&(data))>>13)
+#define ISO_PFUNC4_get_iso_gpio_24_pud_en(data)                                      ((0x00002000&(data))>>13)
+#define ISO_PFUNC4_iso_gpio_24_pud_sel_shift                                         (12)
+#define ISO_PFUNC4_iso_gpio_24_pud_sel_mask                                          (0x00001000)
+#define ISO_PFUNC4_iso_gpio_24_pud_sel(data)                                         (0x00001000&((data)<<12))
+#define ISO_PFUNC4_iso_gpio_24_pud_sel_src(data)                                     ((0x00001000&(data))>>12)
+#define ISO_PFUNC4_get_iso_gpio_24_pud_sel(data)                                     ((0x00001000&(data))>>12)
+#define ISO_PFUNC4_iso_gpio_23_smt_shift                                             (11)
+#define ISO_PFUNC4_iso_gpio_23_smt_mask                                              (0x00000800)
+#define ISO_PFUNC4_iso_gpio_23_smt(data)                                             (0x00000800&((data)<<11))
+#define ISO_PFUNC4_iso_gpio_23_smt_src(data)                                         ((0x00000800&(data))>>11)
+#define ISO_PFUNC4_get_iso_gpio_23_smt(data)                                         ((0x00000800&(data))>>11)
+#define ISO_PFUNC4_iso_gpio_23_e2_shift                                              (10)
+#define ISO_PFUNC4_iso_gpio_23_e2_mask                                               (0x00000400)
+#define ISO_PFUNC4_iso_gpio_23_e2(data)                                              (0x00000400&((data)<<10))
+#define ISO_PFUNC4_iso_gpio_23_e2_src(data)                                          ((0x00000400&(data))>>10)
+#define ISO_PFUNC4_get_iso_gpio_23_e2(data)                                          ((0x00000400&(data))>>10)
+#define ISO_PFUNC4_iso_gpio_23_pud_en_shift                                          (9)
+#define ISO_PFUNC4_iso_gpio_23_pud_en_mask                                           (0x00000200)
+#define ISO_PFUNC4_iso_gpio_23_pud_en(data)                                          (0x00000200&((data)<<9))
+#define ISO_PFUNC4_iso_gpio_23_pud_en_src(data)                                      ((0x00000200&(data))>>9)
+#define ISO_PFUNC4_get_iso_gpio_23_pud_en(data)                                      ((0x00000200&(data))>>9)
+#define ISO_PFUNC4_iso_gpio_23_pud_sel_shift                                         (8)
+#define ISO_PFUNC4_iso_gpio_23_pud_sel_mask                                          (0x00000100)
+#define ISO_PFUNC4_iso_gpio_23_pud_sel(data)                                         (0x00000100&((data)<<8))
+#define ISO_PFUNC4_iso_gpio_23_pud_sel_src(data)                                     ((0x00000100&(data))>>8)
+#define ISO_PFUNC4_get_iso_gpio_23_pud_sel(data)                                     ((0x00000100&(data))>>8)
+#define ISO_PFUNC4_iso_gpio_22_smt_shift                                             (7)
+#define ISO_PFUNC4_iso_gpio_22_smt_mask                                              (0x00000080)
+#define ISO_PFUNC4_iso_gpio_22_smt(data)                                             (0x00000080&((data)<<7))
+#define ISO_PFUNC4_iso_gpio_22_smt_src(data)                                         ((0x00000080&(data))>>7)
+#define ISO_PFUNC4_get_iso_gpio_22_smt(data)                                         ((0x00000080&(data))>>7)
+#define ISO_PFUNC4_iso_gpio_22_e2_shift                                              (6)
+#define ISO_PFUNC4_iso_gpio_22_e2_mask                                               (0x00000040)
+#define ISO_PFUNC4_iso_gpio_22_e2(data)                                              (0x00000040&((data)<<6))
+#define ISO_PFUNC4_iso_gpio_22_e2_src(data)                                          ((0x00000040&(data))>>6)
+#define ISO_PFUNC4_get_iso_gpio_22_e2(data)                                          ((0x00000040&(data))>>6)
+#define ISO_PFUNC4_iso_gpio_22_pud_en_shift                                          (5)
+#define ISO_PFUNC4_iso_gpio_22_pud_en_mask                                           (0x00000020)
+#define ISO_PFUNC4_iso_gpio_22_pud_en(data)                                          (0x00000020&((data)<<5))
+#define ISO_PFUNC4_iso_gpio_22_pud_en_src(data)                                      ((0x00000020&(data))>>5)
+#define ISO_PFUNC4_get_iso_gpio_22_pud_en(data)                                      ((0x00000020&(data))>>5)
+#define ISO_PFUNC4_iso_gpio_22_pud_sel_shift                                         (4)
+#define ISO_PFUNC4_iso_gpio_22_pud_sel_mask                                          (0x00000010)
+#define ISO_PFUNC4_iso_gpio_22_pud_sel(data)                                         (0x00000010&((data)<<4))
+#define ISO_PFUNC4_iso_gpio_22_pud_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define ISO_PFUNC4_get_iso_gpio_22_pud_sel(data)                                     ((0x00000010&(data))>>4)
+#define ISO_PFUNC4_iso_gpio_21_smt_shift                                             (3)
+#define ISO_PFUNC4_iso_gpio_21_smt_mask                                              (0x00000008)
+#define ISO_PFUNC4_iso_gpio_21_smt(data)                                             (0x00000008&((data)<<3))
+#define ISO_PFUNC4_iso_gpio_21_smt_src(data)                                         ((0x00000008&(data))>>3)
+#define ISO_PFUNC4_get_iso_gpio_21_smt(data)                                         ((0x00000008&(data))>>3)
+#define ISO_PFUNC4_iso_gpio_21_e2_shift                                              (2)
+#define ISO_PFUNC4_iso_gpio_21_e2_mask                                               (0x00000004)
+#define ISO_PFUNC4_iso_gpio_21_e2(data)                                              (0x00000004&((data)<<2))
+#define ISO_PFUNC4_iso_gpio_21_e2_src(data)                                          ((0x00000004&(data))>>2)
+#define ISO_PFUNC4_get_iso_gpio_21_e2(data)                                          ((0x00000004&(data))>>2)
+#define ISO_PFUNC4_iso_gpio_21_pud_en_shift                                          (1)
+#define ISO_PFUNC4_iso_gpio_21_pud_en_mask                                           (0x00000002)
+#define ISO_PFUNC4_iso_gpio_21_pud_en(data)                                          (0x00000002&((data)<<1))
+#define ISO_PFUNC4_iso_gpio_21_pud_en_src(data)                                      ((0x00000002&(data))>>1)
+#define ISO_PFUNC4_get_iso_gpio_21_pud_en(data)                                      ((0x00000002&(data))>>1)
+#define ISO_PFUNC4_iso_gpio_21_pud_sel_shift                                         (0)
+#define ISO_PFUNC4_iso_gpio_21_pud_sel_mask                                          (0x00000001)
+#define ISO_PFUNC4_iso_gpio_21_pud_sel(data)                                         (0x00000001&((data)<<0))
+#define ISO_PFUNC4_iso_gpio_21_pud_sel_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_PFUNC4_get_iso_gpio_21_pud_sel(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_MUXPAD2                                                                  0x9800731C
+#define ISO_MUXPAD2_reg_addr                                                         "0xD800731C"
+#define ISO_MUXPAD2_reg                                                              0xD800731C
+#define set_ISO_MUXPAD2_reg(data)   (*((volatile unsigned int*) ISO_MUXPAD2_reg)=data)
+#define get_ISO_MUXPAD2_reg   (*((volatile unsigned int*) ISO_MUXPAD2_reg))
+#define ISO_MUXPAD2_inst_adr                                                         "0x00C7"
+#define ISO_MUXPAD2_inst                                                             0x00C7
+#define ISO_MUXPAD2_i2c_tg_enable_shift                                              (15)
+#define ISO_MUXPAD2_i2c_tg_enable_mask                                               (0x00008000)
+#define ISO_MUXPAD2_i2c_tg_enable(data)                                              (0x00008000&((data)<<15))
+#define ISO_MUXPAD2_i2c_tg_enable_src(data)                                          ((0x00008000&(data))>>15)
+#define ISO_MUXPAD2_get_i2c_tg_enable(data)                                          ((0x00008000&(data))>>15)
+#define ISO_MUXPAD2_iso_gpio_34_shift                                                (12)
+#define ISO_MUXPAD2_iso_gpio_34_mask                                                 (0x00003000)
+#define ISO_MUXPAD2_iso_gpio_34(data)                                                (0x00003000&((data)<<12))
+#define ISO_MUXPAD2_iso_gpio_34_src(data)                                            ((0x00003000&(data))>>12)
+#define ISO_MUXPAD2_get_iso_gpio_34(data)                                            ((0x00003000&(data))>>12)
+#define ISO_MUXPAD2_iso_gpio_33_shift                                                (10)
+#define ISO_MUXPAD2_iso_gpio_33_mask                                                 (0x00000C00)
+#define ISO_MUXPAD2_iso_gpio_33(data)                                                (0x00000C00&((data)<<10))
+#define ISO_MUXPAD2_iso_gpio_33_src(data)                                            ((0x00000C00&(data))>>10)
+#define ISO_MUXPAD2_get_iso_gpio_33(data)                                            ((0x00000C00&(data))>>10)
+#define ISO_MUXPAD2_iso_gpio_25_shift                                                (8)
+#define ISO_MUXPAD2_iso_gpio_25_mask                                                 (0x00000300)
+#define ISO_MUXPAD2_iso_gpio_25(data)                                                (0x00000300&((data)<<8))
+#define ISO_MUXPAD2_iso_gpio_25_src(data)                                            ((0x00000300&(data))>>8)
+#define ISO_MUXPAD2_get_iso_gpio_25(data)                                            ((0x00000300&(data))>>8)
+#define ISO_MUXPAD2_iso_gpio_24_shift                                                (6)
+#define ISO_MUXPAD2_iso_gpio_24_mask                                                 (0x000000C0)
+#define ISO_MUXPAD2_iso_gpio_24(data)                                                (0x000000C0&((data)<<6))
+#define ISO_MUXPAD2_iso_gpio_24_src(data)                                            ((0x000000C0&(data))>>6)
+#define ISO_MUXPAD2_get_iso_gpio_24(data)                                            ((0x000000C0&(data))>>6)
+#define ISO_MUXPAD2_iso_gpio_23_shift                                                (4)
+#define ISO_MUXPAD2_iso_gpio_23_mask                                                 (0x00000030)
+#define ISO_MUXPAD2_iso_gpio_23(data)                                                (0x00000030&((data)<<4))
+#define ISO_MUXPAD2_iso_gpio_23_src(data)                                            ((0x00000030&(data))>>4)
+#define ISO_MUXPAD2_get_iso_gpio_23(data)                                            ((0x00000030&(data))>>4)
+#define ISO_MUXPAD2_iso_gpio_22_shift                                                (2)
+#define ISO_MUXPAD2_iso_gpio_22_mask                                                 (0x0000000C)
+#define ISO_MUXPAD2_iso_gpio_22(data)                                                (0x0000000C&((data)<<2))
+#define ISO_MUXPAD2_iso_gpio_22_src(data)                                            ((0x0000000C&(data))>>2)
+#define ISO_MUXPAD2_get_iso_gpio_22(data)                                            ((0x0000000C&(data))>>2)
+#define ISO_MUXPAD2_iso_gpio_21_shift                                                (0)
+#define ISO_MUXPAD2_iso_gpio_21_mask                                                 (0x00000003)
+#define ISO_MUXPAD2_iso_gpio_21(data)                                                (0x00000003&((data)<<0))
+#define ISO_MUXPAD2_iso_gpio_21_src(data)                                            ((0x00000003&(data))>>0)
+#define ISO_MUXPAD2_get_iso_gpio_21(data)                                            ((0x00000003&(data))>>0)
+
+
+#define ISO_PFUNC5                                                                   0x98007320
+#define ISO_PFUNC5_reg_addr                                                          "0xD8007320"
+#define ISO_PFUNC5_reg                                                               0xD8007320
+#define set_ISO_PFUNC5_reg(data)   (*((volatile unsigned int*) ISO_PFUNC5_reg)=data)
+#define get_ISO_PFUNC5_reg   (*((volatile unsigned int*) ISO_PFUNC5_reg))
+#define ISO_PFUNC5_inst_adr                                                          "0x00C8"
+#define ISO_PFUNC5_inst                                                              0x00C8
+#define ISO_PFUNC5_wd_rset_smt_shift                                                 (11)
+#define ISO_PFUNC5_wd_rset_smt_mask                                                  (0x00000800)
+#define ISO_PFUNC5_wd_rset_smt(data)                                                 (0x00000800&((data)<<11))
+#define ISO_PFUNC5_wd_rset_smt_src(data)                                             ((0x00000800&(data))>>11)
+#define ISO_PFUNC5_get_wd_rset_smt(data)                                             ((0x00000800&(data))>>11)
+#define ISO_PFUNC5_wd_rset_e2_shift                                                  (10)
+#define ISO_PFUNC5_wd_rset_e2_mask                                                   (0x00000400)
+#define ISO_PFUNC5_wd_rset_e2(data)                                                  (0x00000400&((data)<<10))
+#define ISO_PFUNC5_wd_rset_e2_src(data)                                              ((0x00000400&(data))>>10)
+#define ISO_PFUNC5_get_wd_rset_e2(data)                                              ((0x00000400&(data))>>10)
+#define ISO_PFUNC5_wd_rset_pud_en_shift                                              (9)
+#define ISO_PFUNC5_wd_rset_pud_en_mask                                               (0x00000200)
+#define ISO_PFUNC5_wd_rset_pud_en(data)                                              (0x00000200&((data)<<9))
+#define ISO_PFUNC5_wd_rset_pud_en_src(data)                                          ((0x00000200&(data))>>9)
+#define ISO_PFUNC5_get_wd_rset_pud_en(data)                                          ((0x00000200&(data))>>9)
+#define ISO_PFUNC5_wd_rset_pud_sel_shift                                             (8)
+#define ISO_PFUNC5_wd_rset_pud_sel_mask                                              (0x00000100)
+#define ISO_PFUNC5_wd_rset_pud_sel(data)                                             (0x00000100&((data)<<8))
+#define ISO_PFUNC5_wd_rset_pud_sel_src(data)                                         ((0x00000100&(data))>>8)
+#define ISO_PFUNC5_get_wd_rset_pud_sel(data)                                         ((0x00000100&(data))>>8)
+#define ISO_PFUNC5_iso_gpio_34_smt_shift                                             (7)
+#define ISO_PFUNC5_iso_gpio_34_smt_mask                                              (0x00000080)
+#define ISO_PFUNC5_iso_gpio_34_smt(data)                                             (0x00000080&((data)<<7))
+#define ISO_PFUNC5_iso_gpio_34_smt_src(data)                                         ((0x00000080&(data))>>7)
+#define ISO_PFUNC5_get_iso_gpio_34_smt(data)                                         ((0x00000080&(data))>>7)
+#define ISO_PFUNC5_iso_gpio_34_e2_shift                                              (6)
+#define ISO_PFUNC5_iso_gpio_34_e2_mask                                               (0x00000040)
+#define ISO_PFUNC5_iso_gpio_34_e2(data)                                              (0x00000040&((data)<<6))
+#define ISO_PFUNC5_iso_gpio_34_e2_src(data)                                          ((0x00000040&(data))>>6)
+#define ISO_PFUNC5_get_iso_gpio_34_e2(data)                                          ((0x00000040&(data))>>6)
+#define ISO_PFUNC5_iso_gpio_34_pud_en_shift                                          (5)
+#define ISO_PFUNC5_iso_gpio_34_pud_en_mask                                           (0x00000020)
+#define ISO_PFUNC5_iso_gpio_34_pud_en(data)                                          (0x00000020&((data)<<5))
+#define ISO_PFUNC5_iso_gpio_34_pud_en_src(data)                                      ((0x00000020&(data))>>5)
+#define ISO_PFUNC5_get_iso_gpio_34_pud_en(data)                                      ((0x00000020&(data))>>5)
+#define ISO_PFUNC5_iso_gpio_34_pud_sel_shift                                         (4)
+#define ISO_PFUNC5_iso_gpio_34_pud_sel_mask                                          (0x00000010)
+#define ISO_PFUNC5_iso_gpio_34_pud_sel(data)                                         (0x00000010&((data)<<4))
+#define ISO_PFUNC5_iso_gpio_34_pud_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define ISO_PFUNC5_get_iso_gpio_34_pud_sel(data)                                     ((0x00000010&(data))>>4)
+#define ISO_PFUNC5_iso_gpio_33_smt_shift                                             (3)
+#define ISO_PFUNC5_iso_gpio_33_smt_mask                                              (0x00000008)
+#define ISO_PFUNC5_iso_gpio_33_smt(data)                                             (0x00000008&((data)<<3))
+#define ISO_PFUNC5_iso_gpio_33_smt_src(data)                                         ((0x00000008&(data))>>3)
+#define ISO_PFUNC5_get_iso_gpio_33_smt(data)                                         ((0x00000008&(data))>>3)
+#define ISO_PFUNC5_iso_gpio_33_e2_shift                                              (2)
+#define ISO_PFUNC5_iso_gpio_33_e2_mask                                               (0x00000004)
+#define ISO_PFUNC5_iso_gpio_33_e2(data)                                              (0x00000004&((data)<<2))
+#define ISO_PFUNC5_iso_gpio_33_e2_src(data)                                          ((0x00000004&(data))>>2)
+#define ISO_PFUNC5_get_iso_gpio_33_e2(data)                                          ((0x00000004&(data))>>2)
+#define ISO_PFUNC5_iso_gpio_33_pud_en_shift                                          (1)
+#define ISO_PFUNC5_iso_gpio_33_pud_en_mask                                           (0x00000002)
+#define ISO_PFUNC5_iso_gpio_33_pud_en(data)                                          (0x00000002&((data)<<1))
+#define ISO_PFUNC5_iso_gpio_33_pud_en_src(data)                                      ((0x00000002&(data))>>1)
+#define ISO_PFUNC5_get_iso_gpio_33_pud_en(data)                                      ((0x00000002&(data))>>1)
+#define ISO_PFUNC5_iso_gpio_33_pud_sel_shift                                         (0)
+#define ISO_PFUNC5_iso_gpio_33_pud_sel_mask                                          (0x00000001)
+#define ISO_PFUNC5_iso_gpio_33_pud_sel(data)                                         (0x00000001&((data)<<0))
+#define ISO_PFUNC5_iso_gpio_33_pud_sel_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_PFUNC5_get_iso_gpio_33_pud_sel(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_IR_PSR                                                                   0x98007400
+#define ISO_IR_PSR_reg_addr                                                          "0xD8007400"
+#define ISO_IR_PSR_reg                                                               0xD8007400
+#define set_ISO_IR_PSR_reg(data)   (*((volatile unsigned int*) ISO_IR_PSR_reg)=data)
+#define get_ISO_IR_PSR_reg   (*((volatile unsigned int*) ISO_IR_PSR_reg))
+#define ISO_IR_PSR_inst_adr                                                          "0x0000"
+#define ISO_IR_PSR_inst                                                              0x0000
+#define ISO_IR_PSR_irrbl_shift                                                       (24)
+#define ISO_IR_PSR_irrbl_mask                                                        (0xFF000000)
+#define ISO_IR_PSR_irrbl(data)                                                       (0xFF000000&((data)<<24))
+#define ISO_IR_PSR_irrbl_src(data)                                                   ((0xFF000000&(data))>>24)
+#define ISO_IR_PSR_get_irrbl(data)                                                   ((0xFF000000&(data))>>24)
+#define ISO_IR_PSR_irrml_shift                                                       (16)
+#define ISO_IR_PSR_irrml_mask                                                        (0x00FF0000)
+#define ISO_IR_PSR_irrml(data)                                                       (0x00FF0000&((data)<<16))
+#define ISO_IR_PSR_irrml_src(data)                                                   ((0x00FF0000&(data))>>16)
+#define ISO_IR_PSR_get_irrml(data)                                                   ((0x00FF0000&(data))>>16)
+#define ISO_IR_PSR_irrdzl_shift                                                      (8)
+#define ISO_IR_PSR_irrdzl_mask                                                       (0x0000FF00)
+#define ISO_IR_PSR_irrdzl(data)                                                      (0x0000FF00&((data)<<8))
+#define ISO_IR_PSR_irrdzl_src(data)                                                  ((0x0000FF00&(data))>>8)
+#define ISO_IR_PSR_get_irrdzl(data)                                                  ((0x0000FF00&(data))>>8)
+#define ISO_IR_PSR_irrdol_shift                                                      (0)
+#define ISO_IR_PSR_irrdol_mask                                                       (0x000000FF)
+#define ISO_IR_PSR_irrdol(data)                                                      (0x000000FF&((data)<<0))
+#define ISO_IR_PSR_irrdol_src(data)                                                  ((0x000000FF&(data))>>0)
+#define ISO_IR_PSR_get_irrdol(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_PER                                                                   0x98007404
+#define ISO_IR_PER_reg_addr                                                          "0xD8007404"
+#define ISO_IR_PER_reg                                                               0xD8007404
+#define set_ISO_IR_PER_reg(data)   (*((volatile unsigned int*) ISO_IR_PER_reg)=data)
+#define get_ISO_IR_PER_reg   (*((volatile unsigned int*) ISO_IR_PER_reg))
+#define ISO_IR_PER_inst_adr                                                          "0x0001"
+#define ISO_IR_PER_inst                                                              0x0001
+#define ISO_IR_PER_irrdl_shift                                                       (16)
+#define ISO_IR_PER_irrdl_mask                                                        (0x003F0000)
+#define ISO_IR_PER_irrdl(data)                                                       (0x003F0000&((data)<<16))
+#define ISO_IR_PER_irrdl_src(data)                                                   ((0x003F0000&(data))>>16)
+#define ISO_IR_PER_get_irrdl(data)                                                   ((0x003F0000&(data))>>16)
+#define ISO_IR_PER_irrrl_shift                                                       (8)
+#define ISO_IR_PER_irrrl_mask                                                        (0x0000FF00)
+#define ISO_IR_PER_irrrl(data)                                                       (0x0000FF00&((data)<<8))
+#define ISO_IR_PER_irrrl_src(data)                                                   ((0x0000FF00&(data))>>8)
+#define ISO_IR_PER_get_irrrl(data)                                                   ((0x0000FF00&(data))>>8)
+#define ISO_IR_PER_irrsl_shift                                                       (0)
+#define ISO_IR_PER_irrsl_mask                                                        (0x000000FF)
+#define ISO_IR_PER_irrsl(data)                                                       (0x000000FF&((data)<<0))
+#define ISO_IR_PER_irrsl_src(data)                                                   ((0x000000FF&(data))>>0)
+#define ISO_IR_PER_get_irrsl(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_SF                                                                    0x98007408
+#define ISO_IR_SF_reg_addr                                                           "0xD8007408"
+#define ISO_IR_SF_reg                                                                0xD8007408
+#define set_ISO_IR_SF_reg(data)   (*((volatile unsigned int*) ISO_IR_SF_reg)=data)
+#define get_ISO_IR_SF_reg   (*((volatile unsigned int*) ISO_IR_SF_reg))
+#define ISO_IR_SF_inst_adr                                                           "0x0002"
+#define ISO_IR_SF_inst                                                               0x0002
+#define ISO_IR_SF_irfd_shift                                                         (0)
+#define ISO_IR_SF_irfd_mask                                                          (0x0000FFFF)
+#define ISO_IR_SF_irfd(data)                                                         (0x0000FFFF&((data)<<0))
+#define ISO_IR_SF_irfd_src(data)                                                     ((0x0000FFFF&(data))>>0)
+#define ISO_IR_SF_get_irfd(data)                                                     ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IR_DPIR                                                                  0x9800740C
+#define ISO_IR_DPIR_reg_addr                                                         "0xD800740C"
+#define ISO_IR_DPIR_reg                                                              0xD800740C
+#define set_ISO_IR_DPIR_reg(data)   (*((volatile unsigned int*) ISO_IR_DPIR_reg)=data)
+#define get_ISO_IR_DPIR_reg   (*((volatile unsigned int*) ISO_IR_DPIR_reg))
+#define ISO_IR_DPIR_inst_adr                                                         "0x0003"
+#define ISO_IR_DPIR_inst                                                             0x0003
+#define ISO_IR_DPIR_iriotcdp_shift                                                   (0)
+#define ISO_IR_DPIR_iriotcdp_mask                                                    (0x0000FFFF)
+#define ISO_IR_DPIR_iriotcdp(data)                                                   (0x0000FFFF&((data)<<0))
+#define ISO_IR_DPIR_iriotcdp_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define ISO_IR_DPIR_get_iriotcdp(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IR_CR                                                                    0x98007410
+#define ISO_IR_CR_reg_addr                                                           "0xD8007410"
+#define ISO_IR_CR_reg                                                                0xD8007410
+#define set_ISO_IR_CR_reg(data)   (*((volatile unsigned int*) ISO_IR_CR_reg)=data)
+#define get_ISO_IR_CR_reg   (*((volatile unsigned int*) ISO_IR_CR_reg))
+#define ISO_IR_CR_inst_adr                                                           "0x0004"
+#define ISO_IR_CR_inst                                                               0x0004
+#define ISO_IR_CR_irsr_shift                                                         (31)
+#define ISO_IR_CR_irsr_mask                                                          (0x80000000)
+#define ISO_IR_CR_irsr(data)                                                         (0x80000000&((data)<<31))
+#define ISO_IR_CR_irsr_src(data)                                                     ((0x80000000&(data))>>31)
+#define ISO_IR_CR_get_irsr(data)                                                     ((0x80000000&(data))>>31)
+#define ISO_IR_CR_rcmm_en_shift                                                      (25)
+#define ISO_IR_CR_rcmm_en_mask                                                       (0x02000000)
+#define ISO_IR_CR_rcmm_en(data)                                                      (0x02000000&((data)<<25))
+#define ISO_IR_CR_rcmm_en_src(data)                                                  ((0x02000000&(data))>>25)
+#define ISO_IR_CR_get_rcmm_en(data)                                                  ((0x02000000&(data))>>25)
+#define ISO_IR_CR_toshiba_en_shift                                                   (24)
+#define ISO_IR_CR_toshiba_en_mask                                                    (0x01000000)
+#define ISO_IR_CR_toshiba_en(data)                                                   (0x01000000&((data)<<24))
+#define ISO_IR_CR_toshiba_en_src(data)                                               ((0x01000000&(data))>>24)
+#define ISO_IR_CR_get_toshiba_en(data)                                               ((0x01000000&(data))>>24)
+#define ISO_IR_CR_irednm_shift                                                       (23)
+#define ISO_IR_CR_irednm_mask                                                        (0x00800000)
+#define ISO_IR_CR_irednm(data)                                                       (0x00800000&((data)<<23))
+#define ISO_IR_CR_irednm_src(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_IR_CR_get_irednm(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_IR_CR_iredn_shift                                                        (16)
+#define ISO_IR_CR_iredn_mask                                                         (0x003F0000)
+#define ISO_IR_CR_iredn(data)                                                        (0x003F0000&((data)<<16))
+#define ISO_IR_CR_iredn_src(data)                                                    ((0x003F0000&(data))>>16)
+#define ISO_IR_CR_get_iredn(data)                                                    ((0x003F0000&(data))>>16)
+#define ISO_IR_CR_raw_fifo_ov_shift                                                  (14)
+#define ISO_IR_CR_raw_fifo_ov_mask                                                   (0x00004000)
+#define ISO_IR_CR_raw_fifo_ov(data)                                                  (0x00004000&((data)<<14))
+#define ISO_IR_CR_raw_fifo_ov_src(data)                                              ((0x00004000&(data))>>14)
+#define ISO_IR_CR_get_raw_fifo_ov(data)                                              ((0x00004000&(data))>>14)
+#define ISO_IR_CR_raw_fifo_val_shift                                                 (13)
+#define ISO_IR_CR_raw_fifo_val_mask                                                  (0x00002000)
+#define ISO_IR_CR_raw_fifo_val(data)                                                 (0x00002000&((data)<<13))
+#define ISO_IR_CR_raw_fifo_val_src(data)                                             ((0x00002000&(data))>>13)
+#define ISO_IR_CR_get_raw_fifo_val(data)                                             ((0x00002000&(data))>>13)
+#define ISO_IR_CR_raw_en_shift                                                       (12)
+#define ISO_IR_CR_raw_en_mask                                                        (0x00001000)
+#define ISO_IR_CR_raw_en(data)                                                       (0x00001000&((data)<<12))
+#define ISO_IR_CR_raw_en_src(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_IR_CR_get_raw_en(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_IR_CR_mlae_shift                                                         (11)
+#define ISO_IR_CR_mlae_mask                                                          (0x00000800)
+#define ISO_IR_CR_mlae(data)                                                         (0x00000800&((data)<<11))
+#define ISO_IR_CR_mlae_src(data)                                                     ((0x00000800&(data))>>11)
+#define ISO_IR_CR_get_mlae(data)                                                     ((0x00000800&(data))>>11)
+#define ISO_IR_CR_irie_shift                                                         (10)
+#define ISO_IR_CR_irie_mask                                                          (0x00000400)
+#define ISO_IR_CR_irie(data)                                                         (0x00000400&((data)<<10))
+#define ISO_IR_CR_irie_src(data)                                                     ((0x00000400&(data))>>10)
+#define ISO_IR_CR_get_irie(data)                                                     ((0x00000400&(data))>>10)
+#define ISO_IR_CR_irres_shift                                                        (9)
+#define ISO_IR_CR_irres_mask                                                         (0x00000200)
+#define ISO_IR_CR_irres(data)                                                        (0x00000200&((data)<<9))
+#define ISO_IR_CR_irres_src(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_IR_CR_get_irres(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_IR_CR_irue_shift                                                         (8)
+#define ISO_IR_CR_irue_mask                                                          (0x00000100)
+#define ISO_IR_CR_irue(data)                                                         (0x00000100&((data)<<8))
+#define ISO_IR_CR_irue_src(data)                                                     ((0x00000100&(data))>>8)
+#define ISO_IR_CR_get_irue(data)                                                     ((0x00000100&(data))>>8)
+#define ISO_IR_CR_ircm_shift                                                         (7)
+#define ISO_IR_CR_ircm_mask                                                          (0x00000080)
+#define ISO_IR_CR_ircm(data)                                                         (0x00000080&((data)<<7))
+#define ISO_IR_CR_ircm_src(data)                                                     ((0x00000080&(data))>>7)
+#define ISO_IR_CR_get_ircm(data)                                                     ((0x00000080&(data))>>7)
+#define ISO_IR_CR_irbme_shift                                                        (6)
+#define ISO_IR_CR_irbme_mask                                                         (0x00000040)
+#define ISO_IR_CR_irbme(data)                                                        (0x00000040&((data)<<6))
+#define ISO_IR_CR_irbme_src(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_IR_CR_get_irbme(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_IR_CR_irdpm_shift                                                        (5)
+#define ISO_IR_CR_irdpm_mask                                                         (0x00000020)
+#define ISO_IR_CR_irdpm(data)                                                        (0x00000020&((data)<<5))
+#define ISO_IR_CR_irdpm_src(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_IR_CR_get_irdpm(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_IR_CR_irdn_shift                                                         (0)
+#define ISO_IR_CR_irdn_mask                                                          (0x0000001F)
+#define ISO_IR_CR_irdn(data)                                                         (0x0000001F&((data)<<0))
+#define ISO_IR_CR_irdn_src(data)                                                     ((0x0000001F&(data))>>0)
+#define ISO_IR_CR_get_irdn(data)                                                     ((0x0000001F&(data))>>0)
+
+
+#define ISO_IR_RP                                                                    0x98007414
+#define ISO_IR_RP_reg_addr                                                           "0xD8007414"
+#define ISO_IR_RP_reg                                                                0xD8007414
+#define set_ISO_IR_RP_reg(data)   (*((volatile unsigned int*) ISO_IR_RP_reg)=data)
+#define get_ISO_IR_RP_reg   (*((volatile unsigned int*) ISO_IR_RP_reg))
+#define ISO_IR_RP_inst_adr                                                           "0x0005"
+#define ISO_IR_RP_inst                                                               0x0005
+#define ISO_IR_RP_irrp_shift                                                         (0)
+#define ISO_IR_RP_irrp_mask                                                          (0xFFFFFFFF)
+#define ISO_IR_RP_irrp(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define ISO_IR_RP_irrp_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define ISO_IR_RP_get_irrp(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IR_SR                                                                    0x98007418
+#define ISO_IR_SR_reg_addr                                                           "0xD8007418"
+#define ISO_IR_SR_reg                                                                0xD8007418
+#define set_ISO_IR_SR_reg(data)   (*((volatile unsigned int*) ISO_IR_SR_reg)=data)
+#define get_ISO_IR_SR_reg   (*((volatile unsigned int*) ISO_IR_SR_reg))
+#define ISO_IR_SR_inst_adr                                                           "0x0006"
+#define ISO_IR_SR_inst                                                               0x0006
+#define ISO_IR_SR_slen_big_shift                                                     (5)
+#define ISO_IR_SR_slen_big_mask                                                      (0x00000020)
+#define ISO_IR_SR_slen_big(data)                                                     (0x00000020&((data)<<5))
+#define ISO_IR_SR_slen_big_src(data)                                                 ((0x00000020&(data))>>5)
+#define ISO_IR_SR_get_slen_big(data)                                                 ((0x00000020&(data))>>5)
+#define ISO_IR_SR_blen_big_shift                                                     (4)
+#define ISO_IR_SR_blen_big_mask                                                      (0x00000010)
+#define ISO_IR_SR_blen_big(data)                                                     (0x00000010&((data)<<4))
+#define ISO_IR_SR_blen_big_src(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IR_SR_get_blen_big(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IR_SR_raw_fifo_ov_shift                                                  (3)
+#define ISO_IR_SR_raw_fifo_ov_mask                                                   (0x00000008)
+#define ISO_IR_SR_raw_fifo_ov(data)                                                  (0x00000008&((data)<<3))
+#define ISO_IR_SR_raw_fifo_ov_src(data)                                              ((0x00000008&(data))>>3)
+#define ISO_IR_SR_get_raw_fifo_ov(data)                                              ((0x00000008&(data))>>3)
+#define ISO_IR_SR_raw_fifo_val_shift                                                 (2)
+#define ISO_IR_SR_raw_fifo_val_mask                                                  (0x00000004)
+#define ISO_IR_SR_raw_fifo_val(data)                                                 (0x00000004&((data)<<2))
+#define ISO_IR_SR_raw_fifo_val_src(data)                                             ((0x00000004&(data))>>2)
+#define ISO_IR_SR_get_raw_fifo_val(data)                                             ((0x00000004&(data))>>2)
+#define ISO_IR_SR_irrf_shift                                                         (1)
+#define ISO_IR_SR_irrf_mask                                                          (0x00000002)
+#define ISO_IR_SR_irrf(data)                                                         (0x00000002&((data)<<1))
+#define ISO_IR_SR_irrf_src(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_IR_SR_get_irrf(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_IR_SR_irdvf_shift                                                        (0)
+#define ISO_IR_SR_irdvf_mask                                                         (0x00000001)
+#define ISO_IR_SR_irdvf(data)                                                        (0x00000001&((data)<<0))
+#define ISO_IR_SR_irdvf_src(data)                                                    ((0x00000001&(data))>>0)
+#define ISO_IR_SR_get_irdvf(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IR_RAW_CTRL                                                              0x9800741C
+#define ISO_IR_RAW_CTRL_reg_addr                                                     "0xD800741C"
+#define ISO_IR_RAW_CTRL_reg                                                          0xD800741C
+#define set_ISO_IR_RAW_CTRL_reg(data)   (*((volatile unsigned int*) ISO_IR_RAW_CTRL_reg)=data)
+#define get_ISO_IR_RAW_CTRL_reg   (*((volatile unsigned int*) ISO_IR_RAW_CTRL_reg))
+#define ISO_IR_RAW_CTRL_inst_adr                                                     "0x0007"
+#define ISO_IR_RAW_CTRL_inst                                                         0x0007
+#define ISO_IR_RAW_CTRL_write_en2_shift                                              (25)
+#define ISO_IR_RAW_CTRL_write_en2_mask                                               (0x02000000)
+#define ISO_IR_RAW_CTRL_write_en2(data)                                              (0x02000000&((data)<<25))
+#define ISO_IR_RAW_CTRL_write_en2_src(data)                                          ((0x02000000&(data))>>25)
+#define ISO_IR_RAW_CTRL_get_write_en2(data)                                          ((0x02000000&(data))>>25)
+#define ISO_IR_RAW_CTRL_stop_sample_shift                                            (24)
+#define ISO_IR_RAW_CTRL_stop_sample_mask                                             (0x01000000)
+#define ISO_IR_RAW_CTRL_stop_sample(data)                                            (0x01000000&((data)<<24))
+#define ISO_IR_RAW_CTRL_stop_sample_src(data)                                        ((0x01000000&(data))>>24)
+#define ISO_IR_RAW_CTRL_get_stop_sample(data)                                        ((0x01000000&(data))>>24)
+#define ISO_IR_RAW_CTRL_stop_time_shift                                              (8)
+#define ISO_IR_RAW_CTRL_stop_time_mask                                               (0x00FFFF00)
+#define ISO_IR_RAW_CTRL_stop_time(data)                                              (0x00FFFF00&((data)<<8))
+#define ISO_IR_RAW_CTRL_stop_time_src(data)                                          ((0x00FFFF00&(data))>>8)
+#define ISO_IR_RAW_CTRL_get_stop_time(data)                                          ((0x00FFFF00&(data))>>8)
+#define ISO_IR_RAW_CTRL_write_en1_shift                                              (6)
+#define ISO_IR_RAW_CTRL_write_en1_mask                                               (0x00000040)
+#define ISO_IR_RAW_CTRL_write_en1(data)                                              (0x00000040&((data)<<6))
+#define ISO_IR_RAW_CTRL_write_en1_src(data)                                          ((0x00000040&(data))>>6)
+#define ISO_IR_RAW_CTRL_get_write_en1(data)                                          ((0x00000040&(data))>>6)
+#define ISO_IR_RAW_CTRL_fifo_thr_shift                                               (0)
+#define ISO_IR_RAW_CTRL_fifo_thr_mask                                                (0x0000003F)
+#define ISO_IR_RAW_CTRL_fifo_thr(data)                                               (0x0000003F&((data)<<0))
+#define ISO_IR_RAW_CTRL_fifo_thr_src(data)                                           ((0x0000003F&(data))>>0)
+#define ISO_IR_RAW_CTRL_get_fifo_thr(data)                                           ((0x0000003F&(data))>>0)
+
+
+#define ISO_IR_RAW_FF                                                                0x98007420
+#define ISO_IR_RAW_FF_reg_addr                                                       "0xD8007420"
+#define ISO_IR_RAW_FF_reg                                                            0xD8007420
+#define set_ISO_IR_RAW_FF_reg(data)   (*((volatile unsigned int*) ISO_IR_RAW_FF_reg)=data)
+#define get_ISO_IR_RAW_FF_reg   (*((volatile unsigned int*) ISO_IR_RAW_FF_reg))
+#define ISO_IR_RAW_FF_inst_adr                                                       "0x0008"
+#define ISO_IR_RAW_FF_inst                                                           0x0008
+#define ISO_IR_RAW_FF_dat_shift                                                      (0)
+#define ISO_IR_RAW_FF_dat_mask                                                       (0xFFFFFFFF)
+#define ISO_IR_RAW_FF_dat(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_IR_RAW_FF_dat_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_IR_RAW_FF_get_dat(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IR_RAW_SAMPLE_TIME                                                       0x98007424
+#define ISO_IR_RAW_SAMPLE_TIME_reg_addr                                              "0xD8007424"
+#define ISO_IR_RAW_SAMPLE_TIME_reg                                                   0xD8007424
+#define set_ISO_IR_RAW_SAMPLE_TIME_reg(data)   (*((volatile unsigned int*) ISO_IR_RAW_SAMPLE_TIME_reg)=data)
+#define get_ISO_IR_RAW_SAMPLE_TIME_reg   (*((volatile unsigned int*) ISO_IR_RAW_SAMPLE_TIME_reg))
+#define ISO_IR_RAW_SAMPLE_TIME_inst_adr                                              "0x0009"
+#define ISO_IR_RAW_SAMPLE_TIME_inst                                                  0x0009
+#define ISO_IR_RAW_SAMPLE_TIME_cnt_shift                                             (0)
+#define ISO_IR_RAW_SAMPLE_TIME_cnt_mask                                              (0x0000FFFF)
+#define ISO_IR_RAW_SAMPLE_TIME_cnt(data)                                             (0x0000FFFF&((data)<<0))
+#define ISO_IR_RAW_SAMPLE_TIME_cnt_src(data)                                         ((0x0000FFFF&(data))>>0)
+#define ISO_IR_RAW_SAMPLE_TIME_get_cnt(data)                                         ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IR_RAW_WL                                                                0x98007428
+#define ISO_IR_RAW_WL_reg_addr                                                       "0xD8007428"
+#define ISO_IR_RAW_WL_reg                                                            0xD8007428
+#define set_ISO_IR_RAW_WL_reg(data)   (*((volatile unsigned int*) ISO_IR_RAW_WL_reg)=data)
+#define get_ISO_IR_RAW_WL_reg   (*((volatile unsigned int*) ISO_IR_RAW_WL_reg))
+#define ISO_IR_RAW_WL_inst_adr                                                       "0x000A"
+#define ISO_IR_RAW_WL_inst                                                           0x000A
+#define ISO_IR_RAW_WL_val_shift                                                      (0)
+#define ISO_IR_RAW_WL_val_mask                                                       (0x0000003F)
+#define ISO_IR_RAW_WL_val(data)                                                      (0x0000003F&((data)<<0))
+#define ISO_IR_RAW_WL_val_src(data)                                                  ((0x0000003F&(data))>>0)
+#define ISO_IR_RAW_WL_get_val(data)                                                  ((0x0000003F&(data))>>0)
+
+
+#define ISO_IR_RAW_DEB                                                               0x9800742C
+#define ISO_IR_RAW_DEB_reg_addr                                                      "0xD800742C"
+#define ISO_IR_RAW_DEB_reg                                                           0xD800742C
+#define set_ISO_IR_RAW_DEB_reg(data)   (*((volatile unsigned int*) ISO_IR_RAW_DEB_reg)=data)
+#define get_ISO_IR_RAW_DEB_reg   (*((volatile unsigned int*) ISO_IR_RAW_DEB_reg))
+#define ISO_IR_RAW_DEB_inst_adr                                                      "0x000B"
+#define ISO_IR_RAW_DEB_inst                                                          0x000B
+#define ISO_IR_RAW_DEB_len_shift                                                     (16)
+#define ISO_IR_RAW_DEB_len_mask                                                      (0x00FF0000)
+#define ISO_IR_RAW_DEB_len(data)                                                     (0x00FF0000&((data)<<16))
+#define ISO_IR_RAW_DEB_len_src(data)                                                 ((0x00FF0000&(data))>>16)
+#define ISO_IR_RAW_DEB_get_len(data)                                                 ((0x00FF0000&(data))>>16)
+#define ISO_IR_RAW_DEB_clk_shift                                                     (0)
+#define ISO_IR_RAW_DEB_clk_mask                                                      (0x0000FFFF)
+#define ISO_IR_RAW_DEB_clk(data)                                                     (0x0000FFFF&((data)<<0))
+#define ISO_IR_RAW_DEB_clk_src(data)                                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IR_RAW_DEB_get_clk(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IR_PSR_UP                                                                0x98007430
+#define ISO_IR_PSR_UP_reg_addr                                                       "0xD8007430"
+#define ISO_IR_PSR_UP_reg                                                            0xD8007430
+#define set_ISO_IR_PSR_UP_reg(data)   (*((volatile unsigned int*) ISO_IR_PSR_UP_reg)=data)
+#define get_ISO_IR_PSR_UP_reg   (*((volatile unsigned int*) ISO_IR_PSR_UP_reg))
+#define ISO_IR_PSR_UP_inst_adr                                                       "0x000C"
+#define ISO_IR_PSR_UP_inst                                                           0x000C
+#define ISO_IR_PSR_UP_irrbl_shift                                                    (24)
+#define ISO_IR_PSR_UP_irrbl_mask                                                     (0xFF000000)
+#define ISO_IR_PSR_UP_irrbl(data)                                                    (0xFF000000&((data)<<24))
+#define ISO_IR_PSR_UP_irrbl_src(data)                                                ((0xFF000000&(data))>>24)
+#define ISO_IR_PSR_UP_get_irrbl(data)                                                ((0xFF000000&(data))>>24)
+#define ISO_IR_PSR_UP_irrml_shift                                                    (16)
+#define ISO_IR_PSR_UP_irrml_mask                                                     (0x00FF0000)
+#define ISO_IR_PSR_UP_irrml(data)                                                    (0x00FF0000&((data)<<16))
+#define ISO_IR_PSR_UP_irrml_src(data)                                                ((0x00FF0000&(data))>>16)
+#define ISO_IR_PSR_UP_get_irrml(data)                                                ((0x00FF0000&(data))>>16)
+#define ISO_IR_PSR_UP_irrdzl_shift                                                   (8)
+#define ISO_IR_PSR_UP_irrdzl_mask                                                    (0x0000FF00)
+#define ISO_IR_PSR_UP_irrdzl(data)                                                   (0x0000FF00&((data)<<8))
+#define ISO_IR_PSR_UP_irrdzl_src(data)                                               ((0x0000FF00&(data))>>8)
+#define ISO_IR_PSR_UP_get_irrdzl(data)                                               ((0x0000FF00&(data))>>8)
+#define ISO_IR_PSR_UP_irrdol_shift                                                   (0)
+#define ISO_IR_PSR_UP_irrdol_mask                                                    (0x000000FF)
+#define ISO_IR_PSR_UP_irrdol(data)                                                   (0x000000FF&((data)<<0))
+#define ISO_IR_PSR_UP_irrdol_src(data)                                               ((0x000000FF&(data))>>0)
+#define ISO_IR_PSR_UP_get_irrdol(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_PER_UP                                                                0x98007434
+#define ISO_IR_PER_UP_reg_addr                                                       "0xD8007434"
+#define ISO_IR_PER_UP_reg                                                            0xD8007434
+#define set_ISO_IR_PER_UP_reg(data)   (*((volatile unsigned int*) ISO_IR_PER_UP_reg)=data)
+#define get_ISO_IR_PER_UP_reg   (*((volatile unsigned int*) ISO_IR_PER_UP_reg))
+#define ISO_IR_PER_UP_inst_adr                                                       "0x000D"
+#define ISO_IR_PER_UP_inst                                                           0x000D
+#define ISO_IR_PER_UP_irrrl_shift                                                    (8)
+#define ISO_IR_PER_UP_irrrl_mask                                                     (0x0000FF00)
+#define ISO_IR_PER_UP_irrrl(data)                                                    (0x0000FF00&((data)<<8))
+#define ISO_IR_PER_UP_irrrl_src(data)                                                ((0x0000FF00&(data))>>8)
+#define ISO_IR_PER_UP_get_irrrl(data)                                                ((0x0000FF00&(data))>>8)
+#define ISO_IR_PER_UP_irrsl_shift                                                    (0)
+#define ISO_IR_PER_UP_irrsl_mask                                                     (0x000000FF)
+#define ISO_IR_PER_UP_irrsl(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_IR_PER_UP_irrsl_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_IR_PER_UP_get_irrsl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_CTRL_RC6                                                              0x98007438
+#define ISO_IR_CTRL_RC6_reg_addr                                                     "0xD8007438"
+#define ISO_IR_CTRL_RC6_reg                                                          0xD8007438
+#define set_ISO_IR_CTRL_RC6_reg(data)   (*((volatile unsigned int*) ISO_IR_CTRL_RC6_reg)=data)
+#define get_ISO_IR_CTRL_RC6_reg   (*((volatile unsigned int*) ISO_IR_CTRL_RC6_reg))
+#define ISO_IR_CTRL_RC6_inst_adr                                                     "0x000E"
+#define ISO_IR_CTRL_RC6_inst                                                         0x000E
+#define ISO_IR_CTRL_RC6_rc6_en_shift                                                 (8)
+#define ISO_IR_CTRL_RC6_rc6_en_mask                                                  (0x00000100)
+#define ISO_IR_CTRL_RC6_rc6_en(data)                                                 (0x00000100&((data)<<8))
+#define ISO_IR_CTRL_RC6_rc6_en_src(data)                                             ((0x00000100&(data))>>8)
+#define ISO_IR_CTRL_RC6_get_rc6_en(data)                                             ((0x00000100&(data))>>8)
+#define ISO_IR_CTRL_RC6_irtr_shift                                                   (0)
+#define ISO_IR_CTRL_RC6_irtr_mask                                                    (0x000000FF)
+#define ISO_IR_CTRL_RC6_irtr(data)                                                   (0x000000FF&((data)<<0))
+#define ISO_IR_CTRL_RC6_irtr_src(data)                                               ((0x000000FF&(data))>>0)
+#define ISO_IR_CTRL_RC6_get_irtr(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_RP2                                                                   0x9800743C
+#define ISO_IR_RP2_reg_addr                                                          "0xD800743C"
+#define ISO_IR_RP2_reg                                                               0xD800743C
+#define set_ISO_IR_RP2_reg(data)   (*((volatile unsigned int*) ISO_IR_RP2_reg)=data)
+#define get_ISO_IR_RP2_reg   (*((volatile unsigned int*) ISO_IR_RP2_reg))
+#define ISO_IR_RP2_inst_adr                                                          "0x000F"
+#define ISO_IR_RP2_inst                                                              0x000F
+#define ISO_IR_RP2_irrp_shift                                                        (0)
+#define ISO_IR_RP2_irrp_mask                                                         (0xFFFFFFFF)
+#define ISO_IR_RP2_irrp(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define ISO_IR_RP2_irrp_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define ISO_IR_RP2_get_irrp(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IRTX_CFG                                                                 0x98007440
+#define ISO_IRTX_CFG_reg_addr                                                        "0xD8007440"
+#define ISO_IRTX_CFG_reg                                                             0xD8007440
+#define set_ISO_IRTX_CFG_reg(data)   (*((volatile unsigned int*) ISO_IRTX_CFG_reg)=data)
+#define get_ISO_IRTX_CFG_reg   (*((volatile unsigned int*) ISO_IRTX_CFG_reg))
+#define ISO_IRTX_CFG_inst_adr                                                        "0x0010"
+#define ISO_IRTX_CFG_inst                                                            0x0010
+#define ISO_IRTX_CFG_irtx_en_shift                                                   (31)
+#define ISO_IRTX_CFG_irtx_en_mask                                                    (0x80000000)
+#define ISO_IRTX_CFG_irtx_en(data)                                                   (0x80000000&((data)<<31))
+#define ISO_IRTX_CFG_irtx_en_src(data)                                               ((0x80000000&(data))>>31)
+#define ISO_IRTX_CFG_get_irtx_en(data)                                               ((0x80000000&(data))>>31)
+#define ISO_IRTX_CFG_iact_lvl_shift                                                  (10)
+#define ISO_IRTX_CFG_iact_lvl_mask                                                   (0x00000400)
+#define ISO_IRTX_CFG_iact_lvl(data)                                                  (0x00000400&((data)<<10))
+#define ISO_IRTX_CFG_iact_lvl_src(data)                                              ((0x00000400&(data))>>10)
+#define ISO_IRTX_CFG_get_iact_lvl(data)                                              ((0x00000400&(data))>>10)
+#define ISO_IRTX_CFG_modulation_shift                                                (9)
+#define ISO_IRTX_CFG_modulation_mask                                                 (0x00000200)
+#define ISO_IRTX_CFG_modulation(data)                                                (0x00000200&((data)<<9))
+#define ISO_IRTX_CFG_modulation_src(data)                                            ((0x00000200&(data))>>9)
+#define ISO_IRTX_CFG_get_modulation(data)                                            ((0x00000200&(data))>>9)
+#define ISO_IRTX_CFG_endian_shift                                                    (8)
+#define ISO_IRTX_CFG_endian_mask                                                     (0x00000100)
+#define ISO_IRTX_CFG_endian(data)                                                    (0x00000100&((data)<<8))
+#define ISO_IRTX_CFG_endian_src(data)                                                ((0x00000100&(data))>>8)
+#define ISO_IRTX_CFG_get_endian(data)                                                ((0x00000100&(data))>>8)
+#define ISO_IRTX_CFG_dummy_shift                                                     (6)
+#define ISO_IRTX_CFG_dummy_mask                                                      (0x000000C0)
+#define ISO_IRTX_CFG_dummy(data)                                                     (0x000000C0&((data)<<6))
+#define ISO_IRTX_CFG_dummy_src(data)                                                 ((0x000000C0&(data))>>6)
+#define ISO_IRTX_CFG_get_dummy(data)                                                 ((0x000000C0&(data))>>6)
+#define ISO_IRTX_CFG_fifoout_inv_shift                                               (5)
+#define ISO_IRTX_CFG_fifoout_inv_mask                                                (0x00000020)
+#define ISO_IRTX_CFG_fifoout_inv(data)                                               (0x00000020&((data)<<5))
+#define ISO_IRTX_CFG_fifoout_inv_src(data)                                           ((0x00000020&(data))>>5)
+#define ISO_IRTX_CFG_get_fifoout_inv(data)                                           ((0x00000020&(data))>>5)
+#define ISO_IRTX_CFG_irtxout_inv_shift                                               (4)
+#define ISO_IRTX_CFG_irtxout_inv_mask                                                (0x00000010)
+#define ISO_IRTX_CFG_irtxout_inv(data)                                               (0x00000010&((data)<<4))
+#define ISO_IRTX_CFG_irtxout_inv_src(data)                                           ((0x00000010&(data))>>4)
+#define ISO_IRTX_CFG_get_irtxout_inv(data)                                           ((0x00000010&(data))>>4)
+#define ISO_IRTX_CFG_start_shift                                                     (0)
+#define ISO_IRTX_CFG_start_mask                                                      (0x00000001)
+#define ISO_IRTX_CFG_start(data)                                                     (0x00000001&((data)<<0))
+#define ISO_IRTX_CFG_start_src(data)                                                 ((0x00000001&(data))>>0)
+#define ISO_IRTX_CFG_get_start(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define ISO_IRTX_TIM                                                                 0x98007444
+#define ISO_IRTX_TIM_reg_addr                                                        "0xD8007444"
+#define ISO_IRTX_TIM_reg                                                             0xD8007444
+#define set_ISO_IRTX_TIM_reg(data)   (*((volatile unsigned int*) ISO_IRTX_TIM_reg)=data)
+#define get_ISO_IRTX_TIM_reg   (*((volatile unsigned int*) ISO_IRTX_TIM_reg))
+#define ISO_IRTX_TIM_inst_adr                                                        "0x0011"
+#define ISO_IRTX_TIM_inst                                                            0x0011
+#define ISO_IRTX_TIM_irtx_fd_shift                                                   (0)
+#define ISO_IRTX_TIM_irtx_fd_mask                                                    (0x0000FFFF)
+#define ISO_IRTX_TIM_irtx_fd(data)                                                   (0x0000FFFF&((data)<<0))
+#define ISO_IRTX_TIM_irtx_fd_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define ISO_IRTX_TIM_get_irtx_fd(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IRTX_PWM_SETTING                                                         0x98007448
+#define ISO_IRTX_PWM_SETTING_reg_addr                                                "0xD8007448"
+#define ISO_IRTX_PWM_SETTING_reg                                                     0xD8007448
+#define set_ISO_IRTX_PWM_SETTING_reg(data)   (*((volatile unsigned int*) ISO_IRTX_PWM_SETTING_reg)=data)
+#define get_ISO_IRTX_PWM_SETTING_reg   (*((volatile unsigned int*) ISO_IRTX_PWM_SETTING_reg))
+#define ISO_IRTX_PWM_SETTING_inst_adr                                                "0x0012"
+#define ISO_IRTX_PWM_SETTING_inst                                                    0x0012
+#define ISO_IRTX_PWM_SETTING_pwm_clksrc_div_shift                                    (16)
+#define ISO_IRTX_PWM_SETTING_pwm_clksrc_div_mask                                     (0x000F0000)
+#define ISO_IRTX_PWM_SETTING_pwm_clksrc_div(data)                                    (0x000F0000&((data)<<16))
+#define ISO_IRTX_PWM_SETTING_pwm_clksrc_div_src(data)                                ((0x000F0000&(data))>>16)
+#define ISO_IRTX_PWM_SETTING_get_pwm_clksrc_div(data)                                ((0x000F0000&(data))>>16)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_duty_shift                                      (8)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_duty_mask                                       (0x0000FF00)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_duty(data)                                      (0x0000FF00&((data)<<8))
+#define ISO_IRTX_PWM_SETTING_pwm_clk_duty_src(data)                                  ((0x0000FF00&(data))>>8)
+#define ISO_IRTX_PWM_SETTING_get_pwm_clk_duty(data)                                  ((0x0000FF00&(data))>>8)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_div_shift                                       (0)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_div_mask                                        (0x000000FF)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_div(data)                                       (0x000000FF&((data)<<0))
+#define ISO_IRTX_PWM_SETTING_pwm_clk_div_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_IRTX_PWM_SETTING_get_pwm_clk_div(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_IRTX_INT_EN                                                              0x9800744C
+#define ISO_IRTX_INT_EN_reg_addr                                                     "0xD800744C"
+#define ISO_IRTX_INT_EN_reg                                                          0xD800744C
+#define set_ISO_IRTX_INT_EN_reg(data)   (*((volatile unsigned int*) ISO_IRTX_INT_EN_reg)=data)
+#define get_ISO_IRTX_INT_EN_reg   (*((volatile unsigned int*) ISO_IRTX_INT_EN_reg))
+#define ISO_IRTX_INT_EN_inst_adr                                                     "0x0013"
+#define ISO_IRTX_INT_EN_inst                                                         0x0013
+#define ISO_IRTX_INT_EN_data_thr_shift                                               (8)
+#define ISO_IRTX_INT_EN_data_thr_mask                                                (0x00003F00)
+#define ISO_IRTX_INT_EN_data_thr(data)                                               (0x00003F00&((data)<<8))
+#define ISO_IRTX_INT_EN_data_thr_src(data)                                           ((0x00003F00&(data))>>8)
+#define ISO_IRTX_INT_EN_get_data_thr(data)                                           ((0x00003F00&(data))>>8)
+#define ISO_IRTX_INT_EN_fin_en_shift                                                 (2)
+#define ISO_IRTX_INT_EN_fin_en_mask                                                  (0x00000004)
+#define ISO_IRTX_INT_EN_fin_en(data)                                                 (0x00000004&((data)<<2))
+#define ISO_IRTX_INT_EN_fin_en_src(data)                                             ((0x00000004&(data))>>2)
+#define ISO_IRTX_INT_EN_get_fin_en(data)                                             ((0x00000004&(data))>>2)
+#define ISO_IRTX_INT_EN_emp_en_shift                                                 (1)
+#define ISO_IRTX_INT_EN_emp_en_mask                                                  (0x00000002)
+#define ISO_IRTX_INT_EN_emp_en(data)                                                 (0x00000002&((data)<<1))
+#define ISO_IRTX_INT_EN_emp_en_src(data)                                             ((0x00000002&(data))>>1)
+#define ISO_IRTX_INT_EN_get_emp_en(data)                                             ((0x00000002&(data))>>1)
+#define ISO_IRTX_INT_EN_req_en_shift                                                 (0)
+#define ISO_IRTX_INT_EN_req_en_mask                                                  (0x00000001)
+#define ISO_IRTX_INT_EN_req_en(data)                                                 (0x00000001&((data)<<0))
+#define ISO_IRTX_INT_EN_req_en_src(data)                                             ((0x00000001&(data))>>0)
+#define ISO_IRTX_INT_EN_get_req_en(data)                                             ((0x00000001&(data))>>0)
+
+
+#define ISO_IRTX_INT_ST                                                              0x98007450
+#define ISO_IRTX_INT_ST_reg_addr                                                     "0xD8007450"
+#define ISO_IRTX_INT_ST_reg                                                          0xD8007450
+#define set_ISO_IRTX_INT_ST_reg(data)   (*((volatile unsigned int*) ISO_IRTX_INT_ST_reg)=data)
+#define get_ISO_IRTX_INT_ST_reg   (*((volatile unsigned int*) ISO_IRTX_INT_ST_reg))
+#define ISO_IRTX_INT_ST_inst_adr                                                     "0x0014"
+#define ISO_IRTX_INT_ST_inst                                                         0x0014
+#define ISO_IRTX_INT_ST_fin_flag_shift                                               (2)
+#define ISO_IRTX_INT_ST_fin_flag_mask                                                (0x00000004)
+#define ISO_IRTX_INT_ST_fin_flag(data)                                               (0x00000004&((data)<<2))
+#define ISO_IRTX_INT_ST_fin_flag_src(data)                                           ((0x00000004&(data))>>2)
+#define ISO_IRTX_INT_ST_get_fin_flag(data)                                           ((0x00000004&(data))>>2)
+#define ISO_IRTX_INT_ST_emp_flag_shift                                               (1)
+#define ISO_IRTX_INT_ST_emp_flag_mask                                                (0x00000002)
+#define ISO_IRTX_INT_ST_emp_flag(data)                                               (0x00000002&((data)<<1))
+#define ISO_IRTX_INT_ST_emp_flag_src(data)                                           ((0x00000002&(data))>>1)
+#define ISO_IRTX_INT_ST_get_emp_flag(data)                                           ((0x00000002&(data))>>1)
+#define ISO_IRTX_INT_ST_req_flag_shift                                               (0)
+#define ISO_IRTX_INT_ST_req_flag_mask                                                (0x00000001)
+#define ISO_IRTX_INT_ST_req_flag(data)                                               (0x00000001&((data)<<0))
+#define ISO_IRTX_INT_ST_req_flag_src(data)                                           ((0x00000001&(data))>>0)
+#define ISO_IRTX_INT_ST_get_req_flag(data)                                           ((0x00000001&(data))>>0)
+
+
+#define ISO_IRTX_FIFO_ST                                                             0x98007454
+#define ISO_IRTX_FIFO_ST_reg_addr                                                    "0xD8007454"
+#define ISO_IRTX_FIFO_ST_reg                                                         0xD8007454
+#define set_ISO_IRTX_FIFO_ST_reg(data)   (*((volatile unsigned int*) ISO_IRTX_FIFO_ST_reg)=data)
+#define get_ISO_IRTX_FIFO_ST_reg   (*((volatile unsigned int*) ISO_IRTX_FIFO_ST_reg))
+#define ISO_IRTX_FIFO_ST_inst_adr                                                    "0x0015"
+#define ISO_IRTX_FIFO_ST_inst                                                        0x0015
+#define ISO_IRTX_FIFO_ST_fifo_rst_shift                                              (31)
+#define ISO_IRTX_FIFO_ST_fifo_rst_mask                                               (0x80000000)
+#define ISO_IRTX_FIFO_ST_fifo_rst(data)                                              (0x80000000&((data)<<31))
+#define ISO_IRTX_FIFO_ST_fifo_rst_src(data)                                          ((0x80000000&(data))>>31)
+#define ISO_IRTX_FIFO_ST_get_fifo_rst(data)                                          ((0x80000000&(data))>>31)
+#define ISO_IRTX_FIFO_ST_valid_len_shift                                             (8)
+#define ISO_IRTX_FIFO_ST_valid_len_mask                                              (0x00000F00)
+#define ISO_IRTX_FIFO_ST_valid_len(data)                                             (0x00000F00&((data)<<8))
+#define ISO_IRTX_FIFO_ST_valid_len_src(data)                                         ((0x00000F00&(data))>>8)
+#define ISO_IRTX_FIFO_ST_get_valid_len(data)                                         ((0x00000F00&(data))>>8)
+#define ISO_IRTX_FIFO_ST_wrp_shift                                                   (4)
+#define ISO_IRTX_FIFO_ST_wrp_mask                                                    (0x000000F0)
+#define ISO_IRTX_FIFO_ST_wrp(data)                                                   (0x000000F0&((data)<<4))
+#define ISO_IRTX_FIFO_ST_wrp_src(data)                                               ((0x000000F0&(data))>>4)
+#define ISO_IRTX_FIFO_ST_get_wrp(data)                                               ((0x000000F0&(data))>>4)
+#define ISO_IRTX_FIFO_ST_rdp_shift                                                   (0)
+#define ISO_IRTX_FIFO_ST_rdp_mask                                                    (0x0000000F)
+#define ISO_IRTX_FIFO_ST_rdp(data)                                                   (0x0000000F&((data)<<0))
+#define ISO_IRTX_FIFO_ST_rdp_src(data)                                               ((0x0000000F&(data))>>0)
+#define ISO_IRTX_FIFO_ST_get_rdp(data)                                               ((0x0000000F&(data))>>0)
+
+
+#define ISO_IRTX_FIFO                                                                0x98007458
+#define ISO_IRTX_FIFO_reg_addr                                                       "0xD8007458"
+#define ISO_IRTX_FIFO_reg                                                            0xD8007458
+#define set_ISO_IRTX_FIFO_reg(data)   (*((volatile unsigned int*) ISO_IRTX_FIFO_reg)=data)
+#define get_ISO_IRTX_FIFO_reg   (*((volatile unsigned int*) ISO_IRTX_FIFO_reg))
+#define ISO_IRTX_FIFO_inst_adr                                                       "0x0016"
+#define ISO_IRTX_FIFO_inst                                                           0x0016
+#define ISO_IRTX_FIFO_data_shift                                                     (0)
+#define ISO_IRTX_FIFO_data_mask                                                      (0xFFFFFFFF)
+#define ISO_IRTX_FIFO_data(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_IRTX_FIFO_data_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_IRTX_FIFO_get_data(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IRRCMM_TIMING                                                            0x98007460
+#define ISO_IRRCMM_TIMING_reg_addr                                                   "0xD8007460"
+#define ISO_IRRCMM_TIMING_reg                                                        0xD8007460
+#define set_ISO_IRRCMM_TIMING_reg(data)   (*((volatile unsigned int*) ISO_IRRCMM_TIMING_reg)=data)
+#define get_ISO_IRRCMM_TIMING_reg   (*((volatile unsigned int*) ISO_IRRCMM_TIMING_reg))
+#define ISO_IRRCMM_TIMING_inst_adr                                                   "0x0018"
+#define ISO_IRRCMM_TIMING_inst                                                       0x0018
+#define ISO_IRRCMM_TIMING_len_11_shift                                               (24)
+#define ISO_IRRCMM_TIMING_len_11_mask                                                (0xFF000000)
+#define ISO_IRRCMM_TIMING_len_11(data)                                               (0xFF000000&((data)<<24))
+#define ISO_IRRCMM_TIMING_len_11_src(data)                                           ((0xFF000000&(data))>>24)
+#define ISO_IRRCMM_TIMING_get_len_11(data)                                           ((0xFF000000&(data))>>24)
+#define ISO_IRRCMM_TIMING_len_10_shift                                               (16)
+#define ISO_IRRCMM_TIMING_len_10_mask                                                (0x00FF0000)
+#define ISO_IRRCMM_TIMING_len_10(data)                                               (0x00FF0000&((data)<<16))
+#define ISO_IRRCMM_TIMING_len_10_src(data)                                           ((0x00FF0000&(data))>>16)
+#define ISO_IRRCMM_TIMING_get_len_10(data)                                           ((0x00FF0000&(data))>>16)
+#define ISO_IRRCMM_TIMING_len_01_shift                                               (8)
+#define ISO_IRRCMM_TIMING_len_01_mask                                                (0x0000FF00)
+#define ISO_IRRCMM_TIMING_len_01(data)                                               (0x0000FF00&((data)<<8))
+#define ISO_IRRCMM_TIMING_len_01_src(data)                                           ((0x0000FF00&(data))>>8)
+#define ISO_IRRCMM_TIMING_get_len_01(data)                                           ((0x0000FF00&(data))>>8)
+#define ISO_IRRCMM_TIMING_len_00_shift                                               (0)
+#define ISO_IRRCMM_TIMING_len_00_mask                                                (0x000000FF)
+#define ISO_IRRCMM_TIMING_len_00(data)                                               (0x000000FF&((data)<<0))
+#define ISO_IRRCMM_TIMING_len_00_src(data)                                           ((0x000000FF&(data))>>0)
+#define ISO_IRRCMM_TIMING_get_len_00(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_CR1                                                                   0x98007464
+#define ISO_IR_CR1_reg_addr                                                          "0xD8007464"
+#define ISO_IR_CR1_reg                                                               0xD8007464
+#define set_ISO_IR_CR1_reg(data)   (*((volatile unsigned int*) ISO_IR_CR1_reg)=data)
+#define get_ISO_IR_CR1_reg   (*((volatile unsigned int*) ISO_IR_CR1_reg))
+#define ISO_IR_CR1_inst_adr                                                          "0x0019"
+#define ISO_IR_CR1_inst                                                              0x0019
+#define ISO_IR_CR1_dec_by_min_max_shift                                              (0)
+#define ISO_IR_CR1_dec_by_min_max_mask                                               (0x00000001)
+#define ISO_IR_CR1_dec_by_min_max(data)                                              (0x00000001&((data)<<0))
+#define ISO_IR_CR1_dec_by_min_max_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_IR_CR1_get_dec_by_min_max(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_IRRCMM_APKB                                                              0x98007468
+#define ISO_IRRCMM_APKB_reg_addr                                                     "0xD8007468"
+#define ISO_IRRCMM_APKB_reg                                                          0xD8007468
+#define set_ISO_IRRCMM_APKB_reg(data)   (*((volatile unsigned int*) ISO_IRRCMM_APKB_reg)=data)
+#define get_ISO_IRRCMM_APKB_reg   (*((volatile unsigned int*) ISO_IRRCMM_APKB_reg))
+#define ISO_IRRCMM_APKB_inst_adr                                                     "0x001A"
+#define ISO_IRRCMM_APKB_inst                                                         0x001A
+#define ISO_IRRCMM_APKB_rcmm_ap_max_shift                                            (24)
+#define ISO_IRRCMM_APKB_rcmm_ap_max_mask                                             (0xFF000000)
+#define ISO_IRRCMM_APKB_rcmm_ap_max(data)                                            (0xFF000000&((data)<<24))
+#define ISO_IRRCMM_APKB_rcmm_ap_max_src(data)                                        ((0xFF000000&(data))>>24)
+#define ISO_IRRCMM_APKB_get_rcmm_ap_max(data)                                        ((0xFF000000&(data))>>24)
+#define ISO_IRRCMM_APKB_rcmm_ap_min_shift                                            (16)
+#define ISO_IRRCMM_APKB_rcmm_ap_min_mask                                             (0x00FF0000)
+#define ISO_IRRCMM_APKB_rcmm_ap_min(data)                                            (0x00FF0000&((data)<<16))
+#define ISO_IRRCMM_APKB_rcmm_ap_min_src(data)                                        ((0x00FF0000&(data))>>16)
+#define ISO_IRRCMM_APKB_get_rcmm_ap_min(data)                                        ((0x00FF0000&(data))>>16)
+#define ISO_IRRCMM_APKB_rcmm_kb_max_shift                                            (8)
+#define ISO_IRRCMM_APKB_rcmm_kb_max_mask                                             (0x0000FF00)
+#define ISO_IRRCMM_APKB_rcmm_kb_max(data)                                            (0x0000FF00&((data)<<8))
+#define ISO_IRRCMM_APKB_rcmm_kb_max_src(data)                                        ((0x0000FF00&(data))>>8)
+#define ISO_IRRCMM_APKB_get_rcmm_kb_max(data)                                        ((0x0000FF00&(data))>>8)
+#define ISO_IRRCMM_APKB_rcmm_kb_min_shift                                            (0)
+#define ISO_IRRCMM_APKB_rcmm_kb_min_mask                                             (0x000000FF)
+#define ISO_IRRCMM_APKB_rcmm_kb_min(data)                                            (0x000000FF&((data)<<0))
+#define ISO_IRRCMM_APKB_rcmm_kb_min_src(data)                                        ((0x000000FF&(data))>>0)
+#define ISO_IRRCMM_APKB_get_rcmm_kb_min(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define ISO_IRRXRCLFIFO                                                              0x9800746C
+#define ISO_IRRXRCLFIFO_reg_addr                                                     "0xD800746C"
+#define ISO_IRRXRCLFIFO_reg                                                          0xD800746C
+#define set_ISO_IRRXRCLFIFO_reg(data)   (*((volatile unsigned int*) ISO_IRRXRCLFIFO_reg)=data)
+#define get_ISO_IRRXRCLFIFO_reg   (*((volatile unsigned int*) ISO_IRRXRCLFIFO_reg))
+#define ISO_IRRXRCLFIFO_inst_adr                                                     "0x001B"
+#define ISO_IRRXRCLFIFO_inst                                                         0x001B
+#define ISO_IRRXRCLFIFO_rcmm_apoint_shift                                            (31)
+#define ISO_IRRXRCLFIFO_rcmm_apoint_mask                                             (0x80000000)
+#define ISO_IRRXRCLFIFO_rcmm_apoint(data)                                            (0x80000000&((data)<<31))
+#define ISO_IRRXRCLFIFO_rcmm_apoint_src(data)                                        ((0x80000000&(data))>>31)
+#define ISO_IRRXRCLFIFO_get_rcmm_apoint(data)                                        ((0x80000000&(data))>>31)
+#define ISO_IRRXRCLFIFO_rcmm_kboard_shift                                            (30)
+#define ISO_IRRXRCLFIFO_rcmm_kboard_mask                                             (0x40000000)
+#define ISO_IRRXRCLFIFO_rcmm_kboard(data)                                            (0x40000000&((data)<<30))
+#define ISO_IRRXRCLFIFO_rcmm_kboard_src(data)                                        ((0x40000000&(data))>>30)
+#define ISO_IRRXRCLFIFO_get_rcmm_kboard(data)                                        ((0x40000000&(data))>>30)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_high_shift                                   (16)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_high_mask                                    (0x3FFF0000)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_high(data)                                   (0x3FFF0000&((data)<<16))
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_high_src(data)                               ((0x3FFF0000&(data))>>16)
+#define ISO_IRRXRCLFIFO_get_remote_cnt_lead_high(data)                               ((0x3FFF0000&(data))>>16)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_low_shift                                    (0)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_low_mask                                     (0x0000FFFF)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_low(data)                                    (0x0000FFFF&((data)<<0))
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_low_src(data)                                ((0x0000FFFF&(data))>>0)
+#define ISO_IRRXRCLFIFO_get_remote_cnt_lead_low(data)                                ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_DRM_ST                                                                   0x98007600
+#define ISO_DRM_ST_reg_addr                                                          "0xD8007600"
+#define ISO_DRM_ST_reg                                                               0xD8007600
+#define set_ISO_DRM_ST_reg(data)   (*((volatile unsigned int*) ISO_DRM_ST_reg)=data)
+#define get_ISO_DRM_ST_reg   (*((volatile unsigned int*) ISO_DRM_ST_reg))
+#define ISO_DRM_ST_inst_adr                                                          "0x0080"
+#define ISO_DRM_ST_inst                                                              0x0080
+#define ISO_DRM_ST_set_shift                                                         (0)
+#define ISO_DRM_ST_set_mask                                                          (0x00000001)
+#define ISO_DRM_ST_set(data)                                                         (0x00000001&((data)<<0))
+#define ISO_DRM_ST_set_src(data)                                                     ((0x00000001&(data))>>0)
+#define ISO_DRM_ST_get_set(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_DRM_SECURE_CLK                                                           0x98007604
+#define ISO_DRM_SECURE_CLK_reg_addr                                                  "0xD8007604"
+#define ISO_DRM_SECURE_CLK_reg                                                       0xD8007604
+#define set_ISO_DRM_SECURE_CLK_reg(data)   (*((volatile unsigned int*) ISO_DRM_SECURE_CLK_reg)=data)
+#define get_ISO_DRM_SECURE_CLK_reg   (*((volatile unsigned int*) ISO_DRM_SECURE_CLK_reg))
+#define ISO_DRM_SECURE_CLK_inst_adr                                                  "0x0081"
+#define ISO_DRM_SECURE_CLK_inst                                                      0x0081
+#define ISO_DRM_SECURE_CLK_val_shift                                                 (0)
+#define ISO_DRM_SECURE_CLK_val_mask                                                  (0xFFFFFFFF)
+#define ISO_DRM_SECURE_CLK_val(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_SECURE_CLK_val_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_SECURE_CLK_get_val(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DRM_ELAPSED                                                              0x98007608
+#define ISO_DRM_ELAPSED_reg_addr                                                     "0xD8007608"
+#define ISO_DRM_ELAPSED_reg                                                          0xD8007608
+#define set_ISO_DRM_ELAPSED_reg(data)   (*((volatile unsigned int*) ISO_DRM_ELAPSED_reg)=data)
+#define get_ISO_DRM_ELAPSED_reg   (*((volatile unsigned int*) ISO_DRM_ELAPSED_reg))
+#define ISO_DRM_ELAPSED_inst_adr                                                     "0x0082"
+#define ISO_DRM_ELAPSED_inst                                                         0x0082
+#define ISO_DRM_ELAPSED_val_shift                                                    (0)
+#define ISO_DRM_ELAPSED_val_mask                                                     (0xFFFFFFFF)
+#define ISO_DRM_ELAPSED_val(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_ELAPSED_val_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_ELAPSED_get_val(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST                                                                 0x9800760C
+#define ISO_COLD_RST_reg_addr                                                        "0xD800760C"
+#define ISO_COLD_RST_reg                                                             0xD800760C
+#define set_ISO_COLD_RST_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST_reg)=data)
+#define get_ISO_COLD_RST_reg   (*((volatile unsigned int*) ISO_COLD_RST_reg))
+#define ISO_COLD_RST_inst_adr                                                        "0x0083"
+#define ISO_COLD_RST_inst                                                            0x0083
+#define ISO_COLD_RST_val_shift                                                       (0)
+#define ISO_COLD_RST_val_mask                                                        (0xFFFFFFFF)
+#define ISO_COLD_RST_val(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST_val_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST_get_val(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST1                                                                0x98007610
+#define ISO_COLD_RST1_reg_addr                                                       "0xD8007610"
+#define ISO_COLD_RST1_reg                                                            0xD8007610
+#define set_ISO_COLD_RST1_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST1_reg)=data)
+#define get_ISO_COLD_RST1_reg   (*((volatile unsigned int*) ISO_COLD_RST1_reg))
+#define ISO_COLD_RST1_inst_adr                                                       "0x0084"
+#define ISO_COLD_RST1_inst                                                           0x0084
+#define ISO_COLD_RST1_val_shift                                                      (0)
+#define ISO_COLD_RST1_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST1_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST1_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST1_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST2                                                                0x98007614
+#define ISO_COLD_RST2_reg_addr                                                       "0xD8007614"
+#define ISO_COLD_RST2_reg                                                            0xD8007614
+#define set_ISO_COLD_RST2_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST2_reg)=data)
+#define get_ISO_COLD_RST2_reg   (*((volatile unsigned int*) ISO_COLD_RST2_reg))
+#define ISO_COLD_RST2_inst_adr                                                       "0x0085"
+#define ISO_COLD_RST2_inst                                                           0x0085
+#define ISO_COLD_RST2_val_shift                                                      (0)
+#define ISO_COLD_RST2_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST2_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST2_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST2_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DRM_CTRL                                                                 0x98007618
+#define ISO_DRM_CTRL_reg_addr                                                        "0xD8007618"
+#define ISO_DRM_CTRL_reg                                                             0xD8007618
+#define set_ISO_DRM_CTRL_reg(data)   (*((volatile unsigned int*) ISO_DRM_CTRL_reg)=data)
+#define get_ISO_DRM_CTRL_reg   (*((volatile unsigned int*) ISO_DRM_CTRL_reg))
+#define ISO_DRM_CTRL_inst_adr                                                        "0x0086"
+#define ISO_DRM_CTRL_inst                                                            0x0086
+#define ISO_DRM_CTRL_clk_div_en_shift                                                (1)
+#define ISO_DRM_CTRL_clk_div_en_mask                                                 (0x00000002)
+#define ISO_DRM_CTRL_clk_div_en(data)                                                (0x00000002&((data)<<1))
+#define ISO_DRM_CTRL_clk_div_en_src(data)                                            ((0x00000002&(data))>>1)
+#define ISO_DRM_CTRL_get_clk_div_en(data)                                            ((0x00000002&(data))>>1)
+#define ISO_DRM_CTRL_clk_sel_shift                                                   (0)
+#define ISO_DRM_CTRL_clk_sel_mask                                                    (0x00000001)
+#define ISO_DRM_CTRL_clk_sel(data)                                                   (0x00000001&((data)<<0))
+#define ISO_DRM_CTRL_clk_sel_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_DRM_CTRL_get_clk_sel(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_DRM_CLK_DIV                                                              0x9800761c
+#define ISO_DRM_CLK_DIV_reg_addr                                                     "0xD800761C"
+#define ISO_DRM_CLK_DIV_reg                                                          0xD800761C
+#define set_ISO_DRM_CLK_DIV_reg(data)   (*((volatile unsigned int*) ISO_DRM_CLK_DIV_reg)=data)
+#define get_ISO_DRM_CLK_DIV_reg   (*((volatile unsigned int*) ISO_DRM_CLK_DIV_reg))
+#define ISO_DRM_CLK_DIV_inst_adr                                                     "0x0087"
+#define ISO_DRM_CLK_DIV_inst                                                         0x0087
+#define ISO_DRM_CLK_DIV_init_shift                                                   (0)
+#define ISO_DRM_CLK_DIV_init_mask                                                    (0xFFFFFFFF)
+#define ISO_DRM_CLK_DIV_init(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_CLK_DIV_init_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_CLK_DIV_get_init(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TC3TVR                                                                   0x98007620
+#define ISO_TC3TVR_reg_addr                                                          "0xD8007620"
+#define ISO_TC3TVR_reg                                                               0xD8007620
+#define set_ISO_TC3TVR_reg(data)   (*((volatile unsigned int*) ISO_TC3TVR_reg)=data)
+#define get_ISO_TC3TVR_reg   (*((volatile unsigned int*) ISO_TC3TVR_reg))
+#define ISO_TC3TVR_inst_adr                                                          "0x0088"
+#define ISO_TC3TVR_inst                                                              0x0088
+#define ISO_TC3TVR_tc3tvr_shift                                                      (0)
+#define ISO_TC3TVR_tc3tvr_mask                                                       (0xFFFFFFFF)
+#define ISO_TC3TVR_tc3tvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_TC3TVR_tc3tvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_TC3TVR_get_tc3tvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TC3CVR                                                                   0x98007624
+#define ISO_TC3CVR_reg_addr                                                          "0xD8007624"
+#define ISO_TC3CVR_reg                                                               0xD8007624
+#define set_ISO_TC3CVR_reg(data)   (*((volatile unsigned int*) ISO_TC3CVR_reg)=data)
+#define get_ISO_TC3CVR_reg   (*((volatile unsigned int*) ISO_TC3CVR_reg))
+#define ISO_TC3CVR_inst_adr                                                          "0x0089"
+#define ISO_TC3CVR_inst                                                              0x0089
+#define ISO_TC3CVR_tc3cvr_shift                                                      (0)
+#define ISO_TC3CVR_tc3cvr_mask                                                       (0xFFFFFFFF)
+#define ISO_TC3CVR_tc3cvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_TC3CVR_tc3cvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_TC3CVR_get_tc3cvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TC3CR                                                                    0x98007628
+#define ISO_TC3CR_reg_addr                                                           "0xD8007628"
+#define ISO_TC3CR_reg                                                                0xD8007628
+#define set_ISO_TC3CR_reg(data)   (*((volatile unsigned int*) ISO_TC3CR_reg)=data)
+#define get_ISO_TC3CR_reg   (*((volatile unsigned int*) ISO_TC3CR_reg))
+#define ISO_TC3CR_inst_adr                                                           "0x008A"
+#define ISO_TC3CR_inst                                                               0x008A
+#define ISO_TC3CR_tc3en_shift                                                        (31)
+#define ISO_TC3CR_tc3en_mask                                                         (0x80000000)
+#define ISO_TC3CR_tc3en(data)                                                        (0x80000000&((data)<<31))
+#define ISO_TC3CR_tc3en_src(data)                                                    ((0x80000000&(data))>>31)
+#define ISO_TC3CR_get_tc3en(data)                                                    ((0x80000000&(data))>>31)
+#define ISO_TC3CR_tc3mode_shift                                                      (30)
+#define ISO_TC3CR_tc3mode_mask                                                       (0x40000000)
+#define ISO_TC3CR_tc3mode(data)                                                      (0x40000000&((data)<<30))
+#define ISO_TC3CR_tc3mode_src(data)                                                  ((0x40000000&(data))>>30)
+#define ISO_TC3CR_get_tc3mode(data)                                                  ((0x40000000&(data))>>30)
+#define ISO_TC3CR_tc3pause_shift                                                     (29)
+#define ISO_TC3CR_tc3pause_mask                                                      (0x20000000)
+#define ISO_TC3CR_tc3pause(data)                                                     (0x20000000&((data)<<29))
+#define ISO_TC3CR_tc3pause_src(data)                                                 ((0x20000000&(data))>>29)
+#define ISO_TC3CR_get_tc3pause(data)                                                 ((0x20000000&(data))>>29)
+#define ISO_TC3CR_rvda_shift                                                         (24)
+#define ISO_TC3CR_rvda_mask                                                          (0x1F000000)
+#define ISO_TC3CR_rvda(data)                                                         (0x1F000000&((data)<<24))
+#define ISO_TC3CR_rvda_src(data)                                                     ((0x1F000000&(data))>>24)
+#define ISO_TC3CR_get_rvda(data)                                                     ((0x1F000000&(data))>>24)
+
+
+#define ISO_TC3ICR                                                                   0x9800762C
+#define ISO_TC3ICR_reg_addr                                                          "0xD800762C"
+#define ISO_TC3ICR_reg                                                               0xD800762C
+#define set_ISO_TC3ICR_reg(data)   (*((volatile unsigned int*) ISO_TC3ICR_reg)=data)
+#define get_ISO_TC3ICR_reg   (*((volatile unsigned int*) ISO_TC3ICR_reg))
+#define ISO_TC3ICR_inst_adr                                                          "0x008B"
+#define ISO_TC3ICR_inst                                                              0x008B
+#define ISO_TC3ICR_tc3ie_shift                                                       (31)
+#define ISO_TC3ICR_tc3ie_mask                                                        (0x80000000)
+#define ISO_TC3ICR_tc3ie(data)                                                       (0x80000000&((data)<<31))
+#define ISO_TC3ICR_tc3ie_src(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_TC3ICR_get_tc3ie(data)                                                   ((0x80000000&(data))>>31)
+
+
+#define ISO_TC4TVR                                                                   0x98007630
+#define ISO_TC4TVR_reg_addr                                                          "0xD8007630"
+#define ISO_TC4TVR_reg                                                               0xD8007630
+#define set_ISO_TC4TVR_reg(data)   (*((volatile unsigned int*) ISO_TC4TVR_reg)=data)
+#define get_ISO_TC4TVR_reg   (*((volatile unsigned int*) ISO_TC4TVR_reg))
+#define ISO_TC4TVR_inst_adr                                                          "0x008C"
+#define ISO_TC4TVR_inst                                                              0x008C
+#define ISO_TC4TVR_tc4tvr_shift                                                      (0)
+#define ISO_TC4TVR_tc4tvr_mask                                                       (0xFFFFFFFF)
+#define ISO_TC4TVR_tc4tvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_TC4TVR_tc4tvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_TC4TVR_get_tc4tvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TC4CVR                                                                   0x98007634
+#define ISO_TC4CVR_reg_addr                                                          "0xD8007634"
+#define ISO_TC4CVR_reg                                                               0xD8007634
+#define set_ISO_TC4CVR_reg(data)   (*((volatile unsigned int*) ISO_TC4CVR_reg)=data)
+#define get_ISO_TC4CVR_reg   (*((volatile unsigned int*) ISO_TC4CVR_reg))
+#define ISO_TC4CVR_inst_adr                                                          "0x008D"
+#define ISO_TC4CVR_inst                                                              0x008D
+#define ISO_TC4CVR_tc4cvr_shift                                                      (0)
+#define ISO_TC4CVR_tc4cvr_mask                                                       (0xFFFFFFFF)
+#define ISO_TC4CVR_tc4cvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_TC4CVR_tc4cvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_TC4CVR_get_tc4cvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TC4CR                                                                    0x98007638
+#define ISO_TC4CR_reg_addr                                                           "0xD8007638"
+#define ISO_TC4CR_reg                                                                0xD8007638
+#define set_ISO_TC4CR_reg(data)   (*((volatile unsigned int*) ISO_TC4CR_reg)=data)
+#define get_ISO_TC4CR_reg   (*((volatile unsigned int*) ISO_TC4CR_reg))
+#define ISO_TC4CR_inst_adr                                                           "0x008E"
+#define ISO_TC4CR_inst                                                               0x008E
+#define ISO_TC4CR_tc4en_shift                                                        (31)
+#define ISO_TC4CR_tc4en_mask                                                         (0x80000000)
+#define ISO_TC4CR_tc4en(data)                                                        (0x80000000&((data)<<31))
+#define ISO_TC4CR_tc4en_src(data)                                                    ((0x80000000&(data))>>31)
+#define ISO_TC4CR_get_tc4en(data)                                                    ((0x80000000&(data))>>31)
+#define ISO_TC4CR_tc4mode_shift                                                      (30)
+#define ISO_TC4CR_tc4mode_mask                                                       (0x40000000)
+#define ISO_TC4CR_tc4mode(data)                                                      (0x40000000&((data)<<30))
+#define ISO_TC4CR_tc4mode_src(data)                                                  ((0x40000000&(data))>>30)
+#define ISO_TC4CR_get_tc4mode(data)                                                  ((0x40000000&(data))>>30)
+#define ISO_TC4CR_tc4pause_shift                                                     (29)
+#define ISO_TC4CR_tc4pause_mask                                                      (0x20000000)
+#define ISO_TC4CR_tc4pause(data)                                                     (0x20000000&((data)<<29))
+#define ISO_TC4CR_tc4pause_src(data)                                                 ((0x20000000&(data))>>29)
+#define ISO_TC4CR_get_tc4pause(data)                                                 ((0x20000000&(data))>>29)
+#define ISO_TC4CR_rvda_shift                                                         (24)
+#define ISO_TC4CR_rvda_mask                                                          (0x1F000000)
+#define ISO_TC4CR_rvda(data)                                                         (0x1F000000&((data)<<24))
+#define ISO_TC4CR_rvda_src(data)                                                     ((0x1F000000&(data))>>24)
+#define ISO_TC4CR_get_rvda(data)                                                     ((0x1F000000&(data))>>24)
+
+
+#define ISO_TC4ICR                                                                   0x9800763C
+#define ISO_TC4ICR_reg_addr                                                          "0xD800763C"
+#define ISO_TC4ICR_reg                                                               0xD800763C
+#define set_ISO_TC4ICR_reg(data)   (*((volatile unsigned int*) ISO_TC4ICR_reg)=data)
+#define get_ISO_TC4ICR_reg   (*((volatile unsigned int*) ISO_TC4ICR_reg))
+#define ISO_TC4ICR_inst_adr                                                          "0x008F"
+#define ISO_TC4ICR_inst                                                              0x008F
+#define ISO_TC4ICR_tc4ie_shift                                                       (31)
+#define ISO_TC4ICR_tc4ie_mask                                                        (0x80000000)
+#define ISO_TC4ICR_tc4ie(data)                                                       (0x80000000&((data)<<31))
+#define ISO_TC4ICR_tc4ie_src(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_TC4ICR_get_tc4ie(data)                                                   ((0x80000000&(data))>>31)
+
+
+#define ISO_NORST_0                                                                  0x98007640
+#define ISO_NORST_1                                                                  0x98007644
+#define ISO_NORST_2                                                                  0x98007648
+#define ISO_NORST_3                                                                  0x9800764C
+#define ISO_NORST_4                                                                  0x98007650
+#define ISO_NORST_5                                                                  0x98007654
+#define ISO_NORST_6                                                                  0x98007658
+#define ISO_NORST_7                                                                  0x9800765C
+#define ISO_NORST_0_reg_addr                                                         "0xD8007640"
+#define ISO_NORST_1_reg_addr                                                         "0xD8007644"
+#define ISO_NORST_2_reg_addr                                                         "0xD8007648"
+#define ISO_NORST_3_reg_addr                                                         "0xD800764C"
+#define ISO_NORST_4_reg_addr                                                         "0xD8007650"
+#define ISO_NORST_5_reg_addr                                                         "0xD8007654"
+#define ISO_NORST_6_reg_addr                                                         "0xD8007658"
+#define ISO_NORST_7_reg_addr                                                         "0xD800765C"
+#define ISO_NORST_0_reg                                                              0xD8007640
+#define ISO_NORST_1_reg                                                              0xD8007644
+#define ISO_NORST_2_reg                                                              0xD8007648
+#define ISO_NORST_3_reg                                                              0xD800764C
+#define ISO_NORST_4_reg                                                              0xD8007650
+#define ISO_NORST_5_reg                                                              0xD8007654
+#define ISO_NORST_6_reg                                                              0xD8007658
+#define ISO_NORST_7_reg                                                              0xD800765C
+#define set_ISO_NORST_0_reg(data)   (*((volatile unsigned int*) ISO_NORST_0_reg)=data)
+#define set_ISO_NORST_1_reg(data)   (*((volatile unsigned int*) ISO_NORST_1_reg)=data)
+#define set_ISO_NORST_2_reg(data)   (*((volatile unsigned int*) ISO_NORST_2_reg)=data)
+#define set_ISO_NORST_3_reg(data)   (*((volatile unsigned int*) ISO_NORST_3_reg)=data)
+#define set_ISO_NORST_4_reg(data)   (*((volatile unsigned int*) ISO_NORST_4_reg)=data)
+#define set_ISO_NORST_5_reg(data)   (*((volatile unsigned int*) ISO_NORST_5_reg)=data)
+#define set_ISO_NORST_6_reg(data)   (*((volatile unsigned int*) ISO_NORST_6_reg)=data)
+#define set_ISO_NORST_7_reg(data)   (*((volatile unsigned int*) ISO_NORST_7_reg)=data)
+#define get_ISO_NORST_0_reg   (*((volatile unsigned int*) ISO_NORST_0_reg))
+#define get_ISO_NORST_1_reg   (*((volatile unsigned int*) ISO_NORST_1_reg))
+#define get_ISO_NORST_2_reg   (*((volatile unsigned int*) ISO_NORST_2_reg))
+#define get_ISO_NORST_3_reg   (*((volatile unsigned int*) ISO_NORST_3_reg))
+#define get_ISO_NORST_4_reg   (*((volatile unsigned int*) ISO_NORST_4_reg))
+#define get_ISO_NORST_5_reg   (*((volatile unsigned int*) ISO_NORST_5_reg))
+#define get_ISO_NORST_6_reg   (*((volatile unsigned int*) ISO_NORST_6_reg))
+#define get_ISO_NORST_7_reg   (*((volatile unsigned int*) ISO_NORST_7_reg))
+#define ISO_NORST_0_inst_adr                                                         "0x0090"
+#define ISO_NORST_1_inst_adr                                                         "0x0091"
+#define ISO_NORST_2_inst_adr                                                         "0x0092"
+#define ISO_NORST_3_inst_adr                                                         "0x0093"
+#define ISO_NORST_4_inst_adr                                                         "0x0094"
+#define ISO_NORST_5_inst_adr                                                         "0x0095"
+#define ISO_NORST_6_inst_adr                                                         "0x0096"
+#define ISO_NORST_7_inst_adr                                                         "0x0097"
+#define ISO_NORST_0_inst                                                             0x0090
+#define ISO_NORST_1_inst                                                             0x0091
+#define ISO_NORST_2_inst                                                             0x0092
+#define ISO_NORST_3_inst                                                             0x0093
+#define ISO_NORST_4_inst                                                             0x0094
+#define ISO_NORST_5_inst                                                             0x0095
+#define ISO_NORST_6_inst                                                             0x0096
+#define ISO_NORST_7_inst                                                             0x0097
+#define ISO_NORST_dat_shift                                                          (0)
+#define ISO_NORST_dat_mask                                                           (0xFFFFFFFF)
+#define ISO_NORST_dat(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define ISO_NORST_dat_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define ISO_NORST_get_dat(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST3                                                                0x98007660
+#define ISO_COLD_RST3_reg_addr                                                       "0xD8007660"
+#define ISO_COLD_RST3_reg                                                            0xD8007660
+#define set_ISO_COLD_RST3_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST3_reg)=data)
+#define get_ISO_COLD_RST3_reg   (*((volatile unsigned int*) ISO_COLD_RST3_reg))
+#define ISO_COLD_RST3_inst_adr                                                       "0x0098"
+#define ISO_COLD_RST3_inst                                                           0x0098
+#define ISO_COLD_RST3_val_shift                                                      (0)
+#define ISO_COLD_RST3_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST3_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST3_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST3_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST4                                                                0x98007664
+#define ISO_COLD_RST4_reg_addr                                                       "0xD8007664"
+#define ISO_COLD_RST4_reg                                                            0xD8007664
+#define set_ISO_COLD_RST4_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST4_reg)=data)
+#define get_ISO_COLD_RST4_reg   (*((volatile unsigned int*) ISO_COLD_RST4_reg))
+#define ISO_COLD_RST4_inst_adr                                                       "0x0099"
+#define ISO_COLD_RST4_inst                                                           0x0099
+#define ISO_COLD_RST4_val_shift                                                      (0)
+#define ISO_COLD_RST4_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST4_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST4_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST4_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST5                                                                0x98007668
+#define ISO_COLD_RST5_reg_addr                                                       "0xD8007668"
+#define ISO_COLD_RST5_reg                                                            0xD8007668
+#define set_ISO_COLD_RST5_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST5_reg)=data)
+#define get_ISO_COLD_RST5_reg   (*((volatile unsigned int*) ISO_COLD_RST5_reg))
+#define ISO_COLD_RST5_inst_adr                                                       "0x009A"
+#define ISO_COLD_RST5_inst                                                           0x009A
+#define ISO_COLD_RST5_val_shift                                                      (0)
+#define ISO_COLD_RST5_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST5_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST5_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST5_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST6                                                                0x9800766C
+#define ISO_COLD_RST6_reg_addr                                                       "0xD800766C"
+#define ISO_COLD_RST6_reg                                                            0xD800766C
+#define set_ISO_COLD_RST6_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST6_reg)=data)
+#define get_ISO_COLD_RST6_reg   (*((volatile unsigned int*) ISO_COLD_RST6_reg))
+#define ISO_COLD_RST6_inst_adr                                                       "0x009B"
+#define ISO_COLD_RST6_inst                                                           0x009B
+#define ISO_COLD_RST6_val_shift                                                      (0)
+#define ISO_COLD_RST6_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST6_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST6_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST6_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST7                                                                0x98007670
+#define ISO_COLD_RST7_reg_addr                                                       "0xD8007670"
+#define ISO_COLD_RST7_reg                                                            0xD8007670
+#define set_ISO_COLD_RST7_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST7_reg)=data)
+#define get_ISO_COLD_RST7_reg   (*((volatile unsigned int*) ISO_COLD_RST7_reg))
+#define ISO_COLD_RST7_inst_adr                                                       "0x009C"
+#define ISO_COLD_RST7_inst                                                           0x009C
+#define ISO_COLD_RST7_val_shift                                                      (0)
+#define ISO_COLD_RST7_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST7_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST7_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST7_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST8                                                                0x98007674
+#define ISO_COLD_RST8_reg_addr                                                       "0xD8007674"
+#define ISO_COLD_RST8_reg                                                            0xD8007674
+#define set_ISO_COLD_RST8_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST8_reg)=data)
+#define get_ISO_COLD_RST8_reg   (*((volatile unsigned int*) ISO_COLD_RST8_reg))
+#define ISO_COLD_RST8_inst_adr                                                       "0x009D"
+#define ISO_COLD_RST8_inst                                                           0x009D
+#define ISO_COLD_RST8_val_shift                                                      (0)
+#define ISO_COLD_RST8_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST8_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST8_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST8_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST9                                                                0x98007678
+#define ISO_COLD_RST9_reg_addr                                                       "0xD8007678"
+#define ISO_COLD_RST9_reg                                                            0xD8007678
+#define set_ISO_COLD_RST9_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST9_reg)=data)
+#define get_ISO_COLD_RST9_reg   (*((volatile unsigned int*) ISO_COLD_RST9_reg))
+#define ISO_COLD_RST9_inst_adr                                                       "0x009E"
+#define ISO_COLD_RST9_inst                                                           0x009E
+#define ISO_COLD_RST9_val_shift                                                      (0)
+#define ISO_COLD_RST9_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST9_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST9_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST9_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST10                                                               0x9800767C
+#define ISO_COLD_RST10_reg_addr                                                      "0xD800767C"
+#define ISO_COLD_RST10_reg                                                           0xD800767C
+#define set_ISO_COLD_RST10_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST10_reg)=data)
+#define get_ISO_COLD_RST10_reg   (*((volatile unsigned int*) ISO_COLD_RST10_reg))
+#define ISO_COLD_RST10_inst_adr                                                      "0x009F"
+#define ISO_COLD_RST10_inst                                                          0x009F
+#define ISO_COLD_RST10_val_shift                                                     (0)
+#define ISO_COLD_RST10_val_mask                                                      (0xFFFFFFFF)
+#define ISO_COLD_RST10_val(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST10_val_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST10_get_val(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TCWCR                                                                    0x98007680
+#define ISO_TCWCR_reg_addr                                                           "0xD8007680"
+#define ISO_TCWCR_reg                                                                0xD8007680
+#define set_ISO_TCWCR_reg(data)   (*((volatile unsigned int*) ISO_TCWCR_reg)=data)
+#define get_ISO_TCWCR_reg   (*((volatile unsigned int*) ISO_TCWCR_reg))
+#define ISO_TCWCR_inst_adr                                                           "0x00A0"
+#define ISO_TCWCR_inst                                                               0x00A0
+#define ISO_TCWCR_wd_int_en_shift                                                    (31)
+#define ISO_TCWCR_wd_int_en_mask                                                     (0x80000000)
+#define ISO_TCWCR_wd_int_en(data)                                                    (0x80000000&((data)<<31))
+#define ISO_TCWCR_wd_int_en_src(data)                                                ((0x80000000&(data))>>31)
+#define ISO_TCWCR_get_wd_int_en(data)                                                ((0x80000000&(data))>>31)
+#define ISO_TCWCR_nmic_shift                                                         (12)
+#define ISO_TCWCR_nmic_mask                                                          (0x0000F000)
+#define ISO_TCWCR_nmic(data)                                                         (0x0000F000&((data)<<12))
+#define ISO_TCWCR_nmic_src(data)                                                     ((0x0000F000&(data))>>12)
+#define ISO_TCWCR_get_nmic(data)                                                     ((0x0000F000&(data))>>12)
+#define ISO_TCWCR_wdc_shift                                                          (8)
+#define ISO_TCWCR_wdc_mask                                                           (0x00000F00)
+#define ISO_TCWCR_wdc(data)                                                          (0x00000F00&((data)<<8))
+#define ISO_TCWCR_wdc_src(data)                                                      ((0x00000F00&(data))>>8)
+#define ISO_TCWCR_get_wdc(data)                                                      ((0x00000F00&(data))>>8)
+#define ISO_TCWCR_wden_shift                                                         (0)
+#define ISO_TCWCR_wden_mask                                                          (0x000000FF)
+#define ISO_TCWCR_wden(data)                                                         (0x000000FF&((data)<<0))
+#define ISO_TCWCR_wden_src(data)                                                     ((0x000000FF&(data))>>0)
+#define ISO_TCWCR_get_wden(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define ISO_TCWTR                                                                    0x98007684
+#define ISO_TCWTR_reg_addr                                                           "0xD8007684"
+#define ISO_TCWTR_reg                                                                0xD8007684
+#define set_ISO_TCWTR_reg(data)   (*((volatile unsigned int*) ISO_TCWTR_reg)=data)
+#define get_ISO_TCWTR_reg   (*((volatile unsigned int*) ISO_TCWTR_reg))
+#define ISO_TCWTR_inst_adr                                                           "0x00A1"
+#define ISO_TCWTR_inst                                                               0x00A1
+#define ISO_TCWTR_wdclr_shift                                                        (0)
+#define ISO_TCWTR_wdclr_mask                                                         (0x00000001)
+#define ISO_TCWTR_wdclr(data)                                                        (0x00000001&((data)<<0))
+#define ISO_TCWTR_wdclr_src(data)                                                    ((0x00000001&(data))>>0)
+#define ISO_TCWTR_get_wdclr(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_TCWNMI                                                                   0x98007688
+#define ISO_TCWNMI_reg_addr                                                          "0xD8007688"
+#define ISO_TCWNMI_reg                                                               0xD8007688
+#define set_ISO_TCWNMI_reg(data)   (*((volatile unsigned int*) ISO_TCWNMI_reg)=data)
+#define get_ISO_TCWNMI_reg   (*((volatile unsigned int*) ISO_TCWNMI_reg))
+#define ISO_TCWNMI_inst_adr                                                          "0x00A2"
+#define ISO_TCWNMI_inst                                                              0x00A2
+#define ISO_TCWNMI_sel_shift                                                         (0)
+#define ISO_TCWNMI_sel_mask                                                          (0xFFFFFFFF)
+#define ISO_TCWNMI_sel(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define ISO_TCWNMI_sel_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define ISO_TCWNMI_get_sel(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TCWOV                                                                    0x9800768C
+#define ISO_TCWOV_reg_addr                                                           "0xD800768C"
+#define ISO_TCWOV_reg                                                                0xD800768C
+#define set_ISO_TCWOV_reg(data)   (*((volatile unsigned int*) ISO_TCWOV_reg)=data)
+#define get_ISO_TCWOV_reg   (*((volatile unsigned int*) ISO_TCWOV_reg))
+#define ISO_TCWOV_inst_adr                                                           "0x00A3"
+#define ISO_TCWOV_inst                                                               0x00A3
+#define ISO_TCWOV_sel_shift                                                          (0)
+#define ISO_TCWOV_sel_mask                                                           (0xFFFFFFFF)
+#define ISO_TCWOV_sel(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define ISO_TCWOV_sel_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define ISO_TCWOV_get_sel(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DRM_ST_SWC                                                               0x98007690
+#define ISO_DRM_ST_SWC_reg_addr                                                      "0xD8007690"
+#define ISO_DRM_ST_SWC_reg                                                           0xD8007690
+#define set_ISO_DRM_ST_SWC_reg(data)   (*((volatile unsigned int*) ISO_DRM_ST_SWC_reg)=data)
+#define get_ISO_DRM_ST_SWC_reg   (*((volatile unsigned int*) ISO_DRM_ST_SWC_reg))
+#define ISO_DRM_ST_SWC_inst_adr                                                      "0x00A4"
+#define ISO_DRM_ST_SWC_inst                                                          0x00A4
+#define ISO_DRM_ST_SWC_set_shift                                                     (0)
+#define ISO_DRM_ST_SWC_set_mask                                                      (0x00000001)
+#define ISO_DRM_ST_SWC_set(data)                                                     (0x00000001&((data)<<0))
+#define ISO_DRM_ST_SWC_set_src(data)                                                 ((0x00000001&(data))>>0)
+#define ISO_DRM_ST_SWC_get_set(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define ISO_DRM_SECURE_CLK_SWC                                                       0x98007694
+#define ISO_DRM_SECURE_CLK_SWC_reg_addr                                              "0xD8007694"
+#define ISO_DRM_SECURE_CLK_SWC_reg                                                   0xD8007694
+#define set_ISO_DRM_SECURE_CLK_SWC_reg(data)   (*((volatile unsigned int*) ISO_DRM_SECURE_CLK_SWC_reg)=data)
+#define get_ISO_DRM_SECURE_CLK_SWC_reg   (*((volatile unsigned int*) ISO_DRM_SECURE_CLK_SWC_reg))
+#define ISO_DRM_SECURE_CLK_SWC_inst_adr                                              "0x00A5"
+#define ISO_DRM_SECURE_CLK_SWC_inst                                                  0x00A5
+#define ISO_DRM_SECURE_CLK_SWC_val_shift                                             (0)
+#define ISO_DRM_SECURE_CLK_SWC_val_mask                                              (0xFFFFFFFF)
+#define ISO_DRM_SECURE_CLK_SWC_val(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_SECURE_CLK_SWC_val_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_SECURE_CLK_SWC_get_val(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DRM_ELAPSED_SWC                                                          0x98007698
+#define ISO_DRM_ELAPSED_SWC_reg_addr                                                 "0xD8007698"
+#define ISO_DRM_ELAPSED_SWC_reg                                                      0xD8007698
+#define set_ISO_DRM_ELAPSED_SWC_reg(data)   (*((volatile unsigned int*) ISO_DRM_ELAPSED_SWC_reg)=data)
+#define get_ISO_DRM_ELAPSED_SWC_reg   (*((volatile unsigned int*) ISO_DRM_ELAPSED_SWC_reg))
+#define ISO_DRM_ELAPSED_SWC_inst_adr                                                 "0x00A6"
+#define ISO_DRM_ELAPSED_SWC_inst                                                     0x00A6
+#define ISO_DRM_ELAPSED_SWC_val_shift                                                (0)
+#define ISO_DRM_ELAPSED_SWC_val_mask                                                 (0xFFFFFFFF)
+#define ISO_DRM_ELAPSED_SWC_val(data)                                                (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_ELAPSED_SWC_val_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_ELAPSED_SWC_get_val(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DRM_CTRL_SWC                                                             0x9800769C
+#define ISO_DRM_CTRL_SWC_reg_addr                                                    "0xD800769C"
+#define ISO_DRM_CTRL_SWC_reg                                                         0xD800769C
+#define set_ISO_DRM_CTRL_SWC_reg(data)   (*((volatile unsigned int*) ISO_DRM_CTRL_SWC_reg)=data)
+#define get_ISO_DRM_CTRL_SWC_reg   (*((volatile unsigned int*) ISO_DRM_CTRL_SWC_reg))
+#define ISO_DRM_CTRL_SWC_inst_adr                                                    "0x00A7"
+#define ISO_DRM_CTRL_SWC_inst                                                        0x00A7
+#define ISO_DRM_CTRL_SWC_clk_div_en_shift                                            (1)
+#define ISO_DRM_CTRL_SWC_clk_div_en_mask                                             (0x00000002)
+#define ISO_DRM_CTRL_SWC_clk_div_en(data)                                            (0x00000002&((data)<<1))
+#define ISO_DRM_CTRL_SWC_clk_div_en_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_DRM_CTRL_SWC_get_clk_div_en(data)                                        ((0x00000002&(data))>>1)
+#define ISO_DRM_CTRL_SWC_clk_sel_shift                                               (0)
+#define ISO_DRM_CTRL_SWC_clk_sel_mask                                                (0x00000001)
+#define ISO_DRM_CTRL_SWC_clk_sel(data)                                               (0x00000001&((data)<<0))
+#define ISO_DRM_CTRL_SWC_clk_sel_src(data)                                           ((0x00000001&(data))>>0)
+#define ISO_DRM_CTRL_SWC_get_clk_sel(data)                                           ((0x00000001&(data))>>0)
+
+
+#define ISO_DRM_CLK_DIV_SWC                                                          0x980076A0
+#define ISO_DRM_CLK_DIV_SWC_reg_addr                                                 "0xD80076A0"
+#define ISO_DRM_CLK_DIV_SWC_reg                                                      0xD80076A0
+#define set_ISO_DRM_CLK_DIV_SWC_reg(data)   (*((volatile unsigned int*) ISO_DRM_CLK_DIV_SWC_reg)=data)
+#define get_ISO_DRM_CLK_DIV_SWC_reg   (*((volatile unsigned int*) ISO_DRM_CLK_DIV_SWC_reg))
+#define ISO_DRM_CLK_DIV_SWC_inst_adr                                                 "0x00A8"
+#define ISO_DRM_CLK_DIV_SWC_inst                                                     0x00A8
+#define ISO_DRM_CLK_DIV_SWC_init_shift                                               (0)
+#define ISO_DRM_CLK_DIV_SWC_init_mask                                                (0xFFFFFFFF)
+#define ISO_DRM_CLK_DIV_SWC_init(data)                                               (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_CLK_DIV_SWC_init_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_CLK_DIV_SWC_get_init(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST_SWC                                                             0x980076A4
+#define ISO_COLD_RST_SWC_reg_addr                                                    "0xD80076A4"
+#define ISO_COLD_RST_SWC_reg                                                         0xD80076A4
+#define set_ISO_COLD_RST_SWC_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST_SWC_reg)=data)
+#define get_ISO_COLD_RST_SWC_reg   (*((volatile unsigned int*) ISO_COLD_RST_SWC_reg))
+#define ISO_COLD_RST_SWC_inst_adr                                                    "0x00A9"
+#define ISO_COLD_RST_SWC_inst                                                        0x00A9
+#define ISO_COLD_RST_SWC_val_shift                                                   (0)
+#define ISO_COLD_RST_SWC_val_mask                                                    (0xFFFFFFFF)
+#define ISO_COLD_RST_SWC_val(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST_SWC_val_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST_SWC_get_val(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST1_SWC                                                            0x980076A8
+#define ISO_COLD_RST1_SWC_reg_addr                                                   "0xD80076A8"
+#define ISO_COLD_RST1_SWC_reg                                                        0xD80076A8
+#define set_ISO_COLD_RST1_SWC_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST1_SWC_reg)=data)
+#define get_ISO_COLD_RST1_SWC_reg   (*((volatile unsigned int*) ISO_COLD_RST1_SWC_reg))
+#define ISO_COLD_RST1_SWC_inst_adr                                                   "0x00AA"
+#define ISO_COLD_RST1_SWC_inst                                                       0x00AA
+#define ISO_COLD_RST1_SWC_val_shift                                                  (0)
+#define ISO_COLD_RST1_SWC_val_mask                                                   (0xFFFFFFFF)
+#define ISO_COLD_RST1_SWC_val(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST1_SWC_val_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST1_SWC_get_val(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST2_SWC                                                            0x980076AC
+#define ISO_COLD_RST2_SWC_reg_addr                                                   "0xD80076AC"
+#define ISO_COLD_RST2_SWC_reg                                                        0xD80076AC
+#define set_ISO_COLD_RST2_SWC_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST2_SWC_reg)=data)
+#define get_ISO_COLD_RST2_SWC_reg   (*((volatile unsigned int*) ISO_COLD_RST2_SWC_reg))
+#define ISO_COLD_RST2_SWC_inst_adr                                                   "0x00AB"
+#define ISO_COLD_RST2_SWC_inst                                                       0x00AB
+#define ISO_COLD_RST2_SWC_val_shift                                                  (0)
+#define ISO_COLD_RST2_SWC_val_mask                                                   (0xFFFFFFFF)
+#define ISO_COLD_RST2_SWC_val(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST2_SWC_val_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST2_SWC_get_val(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST3_SWC                                                            0x980076B0
+#define ISO_COLD_RST3_SWC_reg_addr                                                   "0xD80076B0"
+#define ISO_COLD_RST3_SWC_reg                                                        0xD80076B0
+#define set_ISO_COLD_RST3_SWC_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST3_SWC_reg)=data)
+#define get_ISO_COLD_RST3_SWC_reg   (*((volatile unsigned int*) ISO_COLD_RST3_SWC_reg))
+#define ISO_COLD_RST3_SWC_inst_adr                                                   "0x00AC"
+#define ISO_COLD_RST3_SWC_inst                                                       0x00AC
+#define ISO_COLD_RST3_SWC_val_shift                                                  (0)
+#define ISO_COLD_RST3_SWC_val_mask                                                   (0xFFFFFFFF)
+#define ISO_COLD_RST3_SWC_val(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST3_SWC_val_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST3_SWC_get_val(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_NORST_SWC                                                                0x980076B4
+#define ISO_NORST_SWC_reg_addr                                                       "0xD80076B4"
+#define ISO_NORST_SWC_reg                                                            0xD80076B4
+#define set_ISO_NORST_SWC_reg(data)   (*((volatile unsigned int*) ISO_NORST_SWC_reg)=data)
+#define get_ISO_NORST_SWC_reg   (*((volatile unsigned int*) ISO_NORST_SWC_reg))
+#define ISO_NORST_SWC_inst_adr                                                       "0x00AD"
+#define ISO_NORST_SWC_inst                                                           0x00AD
+#define ISO_NORST_SWC_dat_shift                                                      (0)
+#define ISO_NORST_SWC_dat_mask                                                       (0xFFFFFFFF)
+#define ISO_NORST_SWC_dat(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_NORST_SWC_dat_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_NORST_SWC_get_dat(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_NORST1_SWC                                                               0x980076B8
+#define ISO_NORST1_SWC_reg_addr                                                      "0xD80076B8"
+#define ISO_NORST1_SWC_reg                                                           0xD80076B8
+#define set_ISO_NORST1_SWC_reg(data)   (*((volatile unsigned int*) ISO_NORST1_SWC_reg)=data)
+#define get_ISO_NORST1_SWC_reg   (*((volatile unsigned int*) ISO_NORST1_SWC_reg))
+#define ISO_NORST1_SWC_inst_adr                                                      "0x00AE"
+#define ISO_NORST1_SWC_inst                                                          0x00AE
+#define ISO_NORST1_SWC_dat_shift                                                     (0)
+#define ISO_NORST1_SWC_dat_mask                                                      (0xFFFFFFFF)
+#define ISO_NORST1_SWC_dat(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_NORST1_SWC_dat_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_NORST1_SWC_get_dat(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_NORST2_SWC                                                               0x980076BC
+#define ISO_NORST2_SWC_reg_addr                                                      "0xD80076BC"
+#define ISO_NORST2_SWC_reg                                                           0xD80076BC
+#define set_ISO_NORST2_SWC_reg(data)   (*((volatile unsigned int*) ISO_NORST2_SWC_reg)=data)
+#define get_ISO_NORST2_SWC_reg   (*((volatile unsigned int*) ISO_NORST2_SWC_reg))
+#define ISO_NORST2_SWC_inst_adr                                                      "0x00AF"
+#define ISO_NORST2_SWC_inst                                                          0x00AF
+#define ISO_NORST2_SWC_dat_shift                                                     (0)
+#define ISO_NORST2_SWC_dat_mask                                                      (0xFFFFFFFF)
+#define ISO_NORST2_SWC_dat(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_NORST2_SWC_dat_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_NORST2_SWC_get_dat(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TCWOV_RSTB_CNT                                                           0x980076C0
+#define ISO_TCWOV_RSTB_CNT_reg_addr                                                  "0xD80076C0"
+#define ISO_TCWOV_RSTB_CNT_reg                                                       0xD80076C0
+#define set_ISO_TCWOV_RSTB_CNT_reg(data)   (*((volatile unsigned int*) ISO_TCWOV_RSTB_CNT_reg)=data)
+#define get_ISO_TCWOV_RSTB_CNT_reg   (*((volatile unsigned int*) ISO_TCWOV_RSTB_CNT_reg))
+#define ISO_TCWOV_RSTB_CNT_inst_adr                                                  "0x00B0"
+#define ISO_TCWOV_RSTB_CNT_inst                                                      0x00B0
+#define ISO_TCWOV_RSTB_CNT_sel_shift                                                 (0)
+#define ISO_TCWOV_RSTB_CNT_sel_mask                                                  (0xFFFFFFFF)
+#define ISO_TCWOV_RSTB_CNT_sel(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_TCWOV_RSTB_CNT_sel_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_TCWOV_RSTB_CNT_get_sel(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TCWOV_RSTB_PAD                                                           0x980076C4
+#define ISO_TCWOV_RSTB_PAD_reg_addr                                                  "0xD80076C4"
+#define ISO_TCWOV_RSTB_PAD_reg                                                       0xD80076C4
+#define set_ISO_TCWOV_RSTB_PAD_reg(data)   (*((volatile unsigned int*) ISO_TCWOV_RSTB_PAD_reg)=data)
+#define get_ISO_TCWOV_RSTB_PAD_reg   (*((volatile unsigned int*) ISO_TCWOV_RSTB_PAD_reg))
+#define ISO_TCWOV_RSTB_PAD_inst_adr                                                  "0x00B1"
+#define ISO_TCWOV_RSTB_PAD_inst                                                      0x00B1
+#define ISO_TCWOV_RSTB_PAD_dmy_shift                                                 (1)
+#define ISO_TCWOV_RSTB_PAD_dmy_mask                                                  (0x00000002)
+#define ISO_TCWOV_RSTB_PAD_dmy(data)                                                 (0x00000002&((data)<<1))
+#define ISO_TCWOV_RSTB_PAD_dmy_src(data)                                             ((0x00000002&(data))>>1)
+#define ISO_TCWOV_RSTB_PAD_get_dmy(data)                                             ((0x00000002&(data))>>1)
+#define ISO_TCWOV_RSTB_PAD_oe_shift                                                  (0)
+#define ISO_TCWOV_RSTB_PAD_oe_mask                                                   (0x00000001)
+#define ISO_TCWOV_RSTB_PAD_oe(data)                                                  (0x00000001&((data)<<0))
+#define ISO_TCWOV_RSTB_PAD_oe_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_TCWOV_RSTB_PAD_get_oe(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_CPU_ST2V                                                                 0x98007738
+#define ISO_CPU_ST2V_reg_addr                                                        "0xD8007738"
+#define ISO_CPU_ST2V_reg                                                             0xD8007738
+#define set_ISO_CPU_ST2V_reg(data)   (*((volatile unsigned int*) ISO_CPU_ST2V_reg)=data)
+#define get_ISO_CPU_ST2V_reg   (*((volatile unsigned int*) ISO_CPU_ST2V_reg))
+#define ISO_CPU_ST2V_inst_adr                                                        "0x00CE"
+#define ISO_CPU_ST2V_inst                                                            0x00CE
+#define ISO_CPU_ST2V_scpu_boot_info_valid_shift                                      (0)
+#define ISO_CPU_ST2V_scpu_boot_info_valid_mask                                       (0x00000001)
+#define ISO_CPU_ST2V_scpu_boot_info_valid(data)                                      (0x00000001&((data)<<0))
+#define ISO_CPU_ST2V_scpu_boot_info_valid_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_CPU_ST2V_get_scpu_boot_info_valid(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_CPU_ST2                                                                  0x9800773C
+#define ISO_CPU_ST2_reg_addr                                                         "0xD800773C"
+#define ISO_CPU_ST2_reg                                                              0xD800773C
+#define set_ISO_CPU_ST2_reg(data)   (*((volatile unsigned int*) ISO_CPU_ST2_reg)=data)
+#define get_ISO_CPU_ST2_reg   (*((volatile unsigned int*) ISO_CPU_ST2_reg))
+#define ISO_CPU_ST2_inst_adr                                                         "0x00CF"
+#define ISO_CPU_ST2_inst                                                             0x00CF
+#define ISO_CPU_ST2_scpu_boot_info_shift                                             (0)
+#define ISO_CPU_ST2_scpu_boot_info_mask                                              (0xFFFFFFFF)
+#define ISO_CPU_ST2_scpu_boot_info(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ISO_CPU_ST2_scpu_boot_info_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ISO_CPU_ST2_get_scpu_boot_info(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_ACPU_DBG                                                                 0x98007740
+#define ISO_ACPU_DBG_reg_addr                                                        "0xD8007740"
+#define ISO_ACPU_DBG_reg                                                             0xD8007740
+#define set_ISO_ACPU_DBG_reg(data)   (*((volatile unsigned int*) ISO_ACPU_DBG_reg)=data)
+#define get_ISO_ACPU_DBG_reg   (*((volatile unsigned int*) ISO_ACPU_DBG_reg))
+#define ISO_ACPU_DBG_inst_adr                                                        "0x00D0"
+#define ISO_ACPU_DBG_inst                                                            0x00D0
+#define ISO_ACPU_DBG_write_enable3_shift                                             (13)
+#define ISO_ACPU_DBG_write_enable3_mask                                              (0x00002000)
+#define ISO_ACPU_DBG_write_enable3(data)                                             (0x00002000&((data)<<13))
+#define ISO_ACPU_DBG_write_enable3_src(data)                                         ((0x00002000&(data))>>13)
+#define ISO_ACPU_DBG_get_write_enable3(data)                                         ((0x00002000&(data))>>13)
+#define ISO_ACPU_DBG_sel1_shift                                                      (8)
+#define ISO_ACPU_DBG_sel1_mask                                                       (0x00001F00)
+#define ISO_ACPU_DBG_sel1(data)                                                      (0x00001F00&((data)<<8))
+#define ISO_ACPU_DBG_sel1_src(data)                                                  ((0x00001F00&(data))>>8)
+#define ISO_ACPU_DBG_get_sel1(data)                                                  ((0x00001F00&(data))>>8)
+#define ISO_ACPU_DBG_write_enable2_shift                                             (7)
+#define ISO_ACPU_DBG_write_enable2_mask                                              (0x00000080)
+#define ISO_ACPU_DBG_write_enable2(data)                                             (0x00000080&((data)<<7))
+#define ISO_ACPU_DBG_write_enable2_src(data)                                         ((0x00000080&(data))>>7)
+#define ISO_ACPU_DBG_get_write_enable2(data)                                         ((0x00000080&(data))>>7)
+#define ISO_ACPU_DBG_sel0_shift                                                      (2)
+#define ISO_ACPU_DBG_sel0_mask                                                       (0x0000007C)
+#define ISO_ACPU_DBG_sel0(data)                                                      (0x0000007C&((data)<<2))
+#define ISO_ACPU_DBG_sel0_src(data)                                                  ((0x0000007C&(data))>>2)
+#define ISO_ACPU_DBG_get_sel0(data)                                                  ((0x0000007C&(data))>>2)
+#define ISO_ACPU_DBG_write_enable1_shift                                             (1)
+#define ISO_ACPU_DBG_write_enable1_mask                                              (0x00000002)
+#define ISO_ACPU_DBG_write_enable1(data)                                             (0x00000002&((data)<<1))
+#define ISO_ACPU_DBG_write_enable1_src(data)                                         ((0x00000002&(data))>>1)
+#define ISO_ACPU_DBG_get_write_enable1(data)                                         ((0x00000002&(data))>>1)
+#define ISO_ACPU_DBG_enable_shift                                                    (0)
+#define ISO_ACPU_DBG_enable_mask                                                     (0x00000001)
+#define ISO_ACPU_DBG_enable(data)                                                    (0x00000001&((data)<<0))
+#define ISO_ACPU_DBG_enable_src(data)                                                ((0x00000001&(data))>>0)
+#define ISO_ACPU_DBG_get_enable(data)                                                ((0x00000001&(data))>>0)
+
+
+#define ISO_ANLG                                                                     0x98007744
+#define ISO_ANLG_reg_addr                                                            "0xD8007744"
+#define ISO_ANLG_reg                                                                 0xD8007744
+#define set_ISO_ANLG_reg(data)   (*((volatile unsigned int*) ISO_ANLG_reg)=data)
+#define get_ISO_ANLG_reg   (*((volatile unsigned int*) ISO_ANLG_reg))
+#define ISO_ANLG_inst_adr                                                            "0x00D1"
+#define ISO_ANLG_inst                                                                0x00D1
+#define ISO_ANLG_analogy_mode_in_shift                                               (0)
+#define ISO_ANLG_analogy_mode_in_mask                                                (0x00000001)
+#define ISO_ANLG_analogy_mode_in(data)                                               (0x00000001&((data)<<0))
+#define ISO_ANLG_analogy_mode_in_src(data)                                           ((0x00000001&(data))>>0)
+#define ISO_ANLG_get_analogy_mode_in(data)                                           ((0x00000001&(data))>>0)
+
+
+#define ISO_U0RBR_THR_DLL                                                            0x98007800
+#define ISO_U0RBR_THR_DLL_reg_addr                                                   "0xD8007800"
+#define ISO_U0RBR_THR_DLL_reg                                                        0xD8007800
+#define set_ISO_U0RBR_THR_DLL_reg(data)   (*((volatile unsigned int*) ISO_U0RBR_THR_DLL_reg)=data)
+#define get_ISO_U0RBR_THR_DLL_reg   (*((volatile unsigned int*) ISO_U0RBR_THR_DLL_reg))
+#define ISO_U0RBR_THR_DLL_inst_adr                                                   "0x0000"
+#define ISO_U0RBR_THR_DLL_inst                                                       0x0000
+#define ISO_U0RBR_THR_DLL_dll_shift                                                  (0)
+#define ISO_U0RBR_THR_DLL_dll_mask                                                   (0x000000FF)
+#define ISO_U0RBR_THR_DLL_dll(data)                                                  (0x000000FF&((data)<<0))
+#define ISO_U0RBR_THR_DLL_dll_src(data)                                              ((0x000000FF&(data))>>0)
+#define ISO_U0RBR_THR_DLL_get_dll(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0IER_DLH                                                                0x98007804
+#define ISO_U0IER_DLH_reg_addr                                                       "0xD8007804"
+#define ISO_U0IER_DLH_reg                                                            0xD8007804
+#define set_ISO_U0IER_DLH_reg(data)   (*((volatile unsigned int*) ISO_U0IER_DLH_reg)=data)
+#define get_ISO_U0IER_DLH_reg   (*((volatile unsigned int*) ISO_U0IER_DLH_reg))
+#define ISO_U0IER_DLH_inst_adr                                                       "0x0001"
+#define ISO_U0IER_DLH_inst                                                           0x0001
+#define ISO_U0IER_DLH_dlh_shift                                                      (0)
+#define ISO_U0IER_DLH_dlh_mask                                                       (0x000000FF)
+#define ISO_U0IER_DLH_dlh(data)                                                      (0x000000FF&((data)<<0))
+#define ISO_U0IER_DLH_dlh_src(data)                                                  ((0x000000FF&(data))>>0)
+#define ISO_U0IER_DLH_get_dlh(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0IIR_FCR                                                                0x98007808
+#define ISO_U0IIR_FCR_reg_addr                                                       "0xD8007808"
+#define ISO_U0IIR_FCR_reg                                                            0xD8007808
+#define set_ISO_U0IIR_FCR_reg(data)   (*((volatile unsigned int*) ISO_U0IIR_FCR_reg)=data)
+#define get_ISO_U0IIR_FCR_reg   (*((volatile unsigned int*) ISO_U0IIR_FCR_reg))
+#define ISO_U0IIR_FCR_inst_adr                                                       "0x0002"
+#define ISO_U0IIR_FCR_inst                                                           0x0002
+#define ISO_U0IIR_FCR_fifo16_shift                                                   (6)
+#define ISO_U0IIR_FCR_fifo16_mask                                                    (0x000000C0)
+#define ISO_U0IIR_FCR_fifo16(data)                                                   (0x000000C0&((data)<<6))
+#define ISO_U0IIR_FCR_fifo16_src(data)                                               ((0x000000C0&(data))>>6)
+#define ISO_U0IIR_FCR_get_fifo16(data)                                               ((0x000000C0&(data))>>6)
+#define ISO_U0IIR_FCR_iid_shift                                                      (0)
+#define ISO_U0IIR_FCR_iid_mask                                                       (0x0000000F)
+#define ISO_U0IIR_FCR_iid(data)                                                      (0x0000000F&((data)<<0))
+#define ISO_U0IIR_FCR_iid_src(data)                                                  ((0x0000000F&(data))>>0)
+#define ISO_U0IIR_FCR_get_iid(data)                                                  ((0x0000000F&(data))>>0)
+
+
+#define ISO_U0LCR                                                                    0x9800780C
+#define ISO_U0LCR_reg_addr                                                           "0xD800780C"
+#define ISO_U0LCR_reg                                                                0xD800780C
+#define set_ISO_U0LCR_reg(data)   (*((volatile unsigned int*) ISO_U0LCR_reg)=data)
+#define get_ISO_U0LCR_reg   (*((volatile unsigned int*) ISO_U0LCR_reg))
+#define ISO_U0LCR_inst_adr                                                           "0x0003"
+#define ISO_U0LCR_inst                                                               0x0003
+#define ISO_U0LCR_dlab_shift                                                         (7)
+#define ISO_U0LCR_dlab_mask                                                          (0x00000080)
+#define ISO_U0LCR_dlab(data)                                                         (0x00000080&((data)<<7))
+#define ISO_U0LCR_dlab_src(data)                                                     ((0x00000080&(data))>>7)
+#define ISO_U0LCR_get_dlab(data)                                                     ((0x00000080&(data))>>7)
+#define ISO_U0LCR_brk_shift                                                          (6)
+#define ISO_U0LCR_brk_mask                                                           (0x00000040)
+#define ISO_U0LCR_brk(data)                                                          (0x00000040&((data)<<6))
+#define ISO_U0LCR_brk_src(data)                                                      ((0x00000040&(data))>>6)
+#define ISO_U0LCR_get_brk(data)                                                      ((0x00000040&(data))>>6)
+#define ISO_U0LCR_eps_shift                                                          (4)
+#define ISO_U0LCR_eps_mask                                                           (0x00000010)
+#define ISO_U0LCR_eps(data)                                                          (0x00000010&((data)<<4))
+#define ISO_U0LCR_eps_src(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0LCR_get_eps(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0LCR_pen_shift                                                          (3)
+#define ISO_U0LCR_pen_mask                                                           (0x00000008)
+#define ISO_U0LCR_pen(data)                                                          (0x00000008&((data)<<3))
+#define ISO_U0LCR_pen_src(data)                                                      ((0x00000008&(data))>>3)
+#define ISO_U0LCR_get_pen(data)                                                      ((0x00000008&(data))>>3)
+#define ISO_U0LCR_stb_shift                                                          (2)
+#define ISO_U0LCR_stb_mask                                                           (0x00000004)
+#define ISO_U0LCR_stb(data)                                                          (0x00000004&((data)<<2))
+#define ISO_U0LCR_stb_src(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0LCR_get_stb(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0LCR_wls_shift                                                          (0)
+#define ISO_U0LCR_wls_mask                                                           (0x00000003)
+#define ISO_U0LCR_wls(data)                                                          (0x00000003&((data)<<0))
+#define ISO_U0LCR_wls_src(data)                                                      ((0x00000003&(data))>>0)
+#define ISO_U0LCR_get_wls(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define ISO_U0MCR                                                                    0x98007810
+#define ISO_U0MCR_reg_addr                                                           "0xD8007810"
+#define ISO_U0MCR_reg                                                                0xD8007810
+#define set_ISO_U0MCR_reg(data)   (*((volatile unsigned int*) ISO_U0MCR_reg)=data)
+#define get_ISO_U0MCR_reg   (*((volatile unsigned int*) ISO_U0MCR_reg))
+#define ISO_U0MCR_inst_adr                                                           "0x0004"
+#define ISO_U0MCR_inst                                                               0x0004
+#define ISO_U0MCR_afce_shift                                                         (5)
+#define ISO_U0MCR_afce_mask                                                          (0x00000020)
+#define ISO_U0MCR_afce(data)                                                         (0x00000020&((data)<<5))
+#define ISO_U0MCR_afce_src(data)                                                     ((0x00000020&(data))>>5)
+#define ISO_U0MCR_get_afce(data)                                                     ((0x00000020&(data))>>5)
+#define ISO_U0MCR_loop_shift                                                         (4)
+#define ISO_U0MCR_loop_mask                                                          (0x00000010)
+#define ISO_U0MCR_loop(data)                                                         (0x00000010&((data)<<4))
+#define ISO_U0MCR_loop_src(data)                                                     ((0x00000010&(data))>>4)
+#define ISO_U0MCR_get_loop(data)                                                     ((0x00000010&(data))>>4)
+#define ISO_U0MCR_rts_shift                                                          (1)
+#define ISO_U0MCR_rts_mask                                                           (0x00000002)
+#define ISO_U0MCR_rts(data)                                                          (0x00000002&((data)<<1))
+#define ISO_U0MCR_rts_src(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_U0MCR_get_rts(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_U0MCR_dtr_shift                                                          (0)
+#define ISO_U0MCR_dtr_mask                                                           (0x00000001)
+#define ISO_U0MCR_dtr(data)                                                          (0x00000001&((data)<<0))
+#define ISO_U0MCR_dtr_src(data)                                                      ((0x00000001&(data))>>0)
+#define ISO_U0MCR_get_dtr(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_U0LSR                                                                    0x98007814
+#define ISO_U0LSR_reg_addr                                                           "0xD8007814"
+#define ISO_U0LSR_reg                                                                0xD8007814
+#define set_ISO_U0LSR_reg(data)   (*((volatile unsigned int*) ISO_U0LSR_reg)=data)
+#define get_ISO_U0LSR_reg   (*((volatile unsigned int*) ISO_U0LSR_reg))
+#define ISO_U0LSR_inst_adr                                                           "0x0005"
+#define ISO_U0LSR_inst                                                               0x0005
+#define ISO_U0LSR_rfe_shift                                                          (7)
+#define ISO_U0LSR_rfe_mask                                                           (0x00000080)
+#define ISO_U0LSR_rfe(data)                                                          (0x00000080&((data)<<7))
+#define ISO_U0LSR_rfe_src(data)                                                      ((0x00000080&(data))>>7)
+#define ISO_U0LSR_get_rfe(data)                                                      ((0x00000080&(data))>>7)
+#define ISO_U0LSR_temt_shift                                                         (6)
+#define ISO_U0LSR_temt_mask                                                          (0x00000040)
+#define ISO_U0LSR_temt(data)                                                         (0x00000040&((data)<<6))
+#define ISO_U0LSR_temt_src(data)                                                     ((0x00000040&(data))>>6)
+#define ISO_U0LSR_get_temt(data)                                                     ((0x00000040&(data))>>6)
+#define ISO_U0LSR_thre_shift                                                         (5)
+#define ISO_U0LSR_thre_mask                                                          (0x00000020)
+#define ISO_U0LSR_thre(data)                                                         (0x00000020&((data)<<5))
+#define ISO_U0LSR_thre_src(data)                                                     ((0x00000020&(data))>>5)
+#define ISO_U0LSR_get_thre(data)                                                     ((0x00000020&(data))>>5)
+#define ISO_U0LSR_bi_shift                                                           (4)
+#define ISO_U0LSR_bi_mask                                                            (0x00000010)
+#define ISO_U0LSR_bi(data)                                                           (0x00000010&((data)<<4))
+#define ISO_U0LSR_bi_src(data)                                                       ((0x00000010&(data))>>4)
+#define ISO_U0LSR_get_bi(data)                                                       ((0x00000010&(data))>>4)
+#define ISO_U0LSR_fe_shift                                                           (3)
+#define ISO_U0LSR_fe_mask                                                            (0x00000008)
+#define ISO_U0LSR_fe(data)                                                           (0x00000008&((data)<<3))
+#define ISO_U0LSR_fe_src(data)                                                       ((0x00000008&(data))>>3)
+#define ISO_U0LSR_get_fe(data)                                                       ((0x00000008&(data))>>3)
+#define ISO_U0LSR_pe_shift                                                           (2)
+#define ISO_U0LSR_pe_mask                                                            (0x00000004)
+#define ISO_U0LSR_pe(data)                                                           (0x00000004&((data)<<2))
+#define ISO_U0LSR_pe_src(data)                                                       ((0x00000004&(data))>>2)
+#define ISO_U0LSR_get_pe(data)                                                       ((0x00000004&(data))>>2)
+#define ISO_U0LSR_oe_shift                                                           (1)
+#define ISO_U0LSR_oe_mask                                                            (0x00000002)
+#define ISO_U0LSR_oe(data)                                                           (0x00000002&((data)<<1))
+#define ISO_U0LSR_oe_src(data)                                                       ((0x00000002&(data))>>1)
+#define ISO_U0LSR_get_oe(data)                                                       ((0x00000002&(data))>>1)
+#define ISO_U0LSR_dr_shift                                                           (0)
+#define ISO_U0LSR_dr_mask                                                            (0x00000001)
+#define ISO_U0LSR_dr(data)                                                           (0x00000001&((data)<<0))
+#define ISO_U0LSR_dr_src(data)                                                       ((0x00000001&(data))>>0)
+#define ISO_U0LSR_get_dr(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_U0MSR                                                                    0x98007818
+#define ISO_U0MSR_reg_addr                                                           "0xD8007818"
+#define ISO_U0MSR_reg                                                                0xD8007818
+#define set_ISO_U0MSR_reg(data)   (*((volatile unsigned int*) ISO_U0MSR_reg)=data)
+#define get_ISO_U0MSR_reg   (*((volatile unsigned int*) ISO_U0MSR_reg))
+#define ISO_U0MSR_inst_adr                                                           "0x0006"
+#define ISO_U0MSR_inst                                                               0x0006
+#define ISO_U0MSR_dcd_shift                                                          (7)
+#define ISO_U0MSR_dcd_mask                                                           (0x00000080)
+#define ISO_U0MSR_dcd(data)                                                          (0x00000080&((data)<<7))
+#define ISO_U0MSR_dcd_src(data)                                                      ((0x00000080&(data))>>7)
+#define ISO_U0MSR_get_dcd(data)                                                      ((0x00000080&(data))>>7)
+#define ISO_U0MSR_ri_shift                                                           (6)
+#define ISO_U0MSR_ri_mask                                                            (0x00000040)
+#define ISO_U0MSR_ri(data)                                                           (0x00000040&((data)<<6))
+#define ISO_U0MSR_ri_src(data)                                                       ((0x00000040&(data))>>6)
+#define ISO_U0MSR_get_ri(data)                                                       ((0x00000040&(data))>>6)
+#define ISO_U0MSR_dsr_shift                                                          (5)
+#define ISO_U0MSR_dsr_mask                                                           (0x00000020)
+#define ISO_U0MSR_dsr(data)                                                          (0x00000020&((data)<<5))
+#define ISO_U0MSR_dsr_src(data)                                                      ((0x00000020&(data))>>5)
+#define ISO_U0MSR_get_dsr(data)                                                      ((0x00000020&(data))>>5)
+#define ISO_U0MSR_cts_shift                                                          (4)
+#define ISO_U0MSR_cts_mask                                                           (0x00000010)
+#define ISO_U0MSR_cts(data)                                                          (0x00000010&((data)<<4))
+#define ISO_U0MSR_cts_src(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0MSR_get_cts(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0MSR_ddcd_shift                                                         (3)
+#define ISO_U0MSR_ddcd_mask                                                          (0x00000008)
+#define ISO_U0MSR_ddcd(data)                                                         (0x00000008&((data)<<3))
+#define ISO_U0MSR_ddcd_src(data)                                                     ((0x00000008&(data))>>3)
+#define ISO_U0MSR_get_ddcd(data)                                                     ((0x00000008&(data))>>3)
+#define ISO_U0MSR_teri_shift                                                         (2)
+#define ISO_U0MSR_teri_mask                                                          (0x00000004)
+#define ISO_U0MSR_teri(data)                                                         (0x00000004&((data)<<2))
+#define ISO_U0MSR_teri_src(data)                                                     ((0x00000004&(data))>>2)
+#define ISO_U0MSR_get_teri(data)                                                     ((0x00000004&(data))>>2)
+#define ISO_U0MSR_ddsr_shift                                                         (1)
+#define ISO_U0MSR_ddsr_mask                                                          (0x00000002)
+#define ISO_U0MSR_ddsr(data)                                                         (0x00000002&((data)<<1))
+#define ISO_U0MSR_ddsr_src(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_U0MSR_get_ddsr(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_U0MSR_dcts_shift                                                         (0)
+#define ISO_U0MSR_dcts_mask                                                          (0x00000001)
+#define ISO_U0MSR_dcts(data)                                                         (0x00000001&((data)<<0))
+#define ISO_U0MSR_dcts_src(data)                                                     ((0x00000001&(data))>>0)
+#define ISO_U0MSR_get_dcts(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_U0SCR                                                                    0x9800781C
+#define ISO_U0SCR_reg_addr                                                           "0xD800781C"
+#define ISO_U0SCR_reg                                                                0xD800781C
+#define set_ISO_U0SCR_reg(data)   (*((volatile unsigned int*) ISO_U0SCR_reg)=data)
+#define get_ISO_U0SCR_reg   (*((volatile unsigned int*) ISO_U0SCR_reg))
+#define ISO_U0SCR_inst_adr                                                           "0x0007"
+#define ISO_U0SCR_inst                                                               0x0007
+#define ISO_U0SCR_scr_shift                                                          (0)
+#define ISO_U0SCR_scr_mask                                                           (0x000000FF)
+#define ISO_U0SCR_scr(data)                                                          (0x000000FF&((data)<<0))
+#define ISO_U0SCR_scr_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ISO_U0SCR_get_scr(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0SRBR_0                                                                 0x98007830
+#define ISO_U0SRBR_1                                                                 0x98007834
+#define ISO_U0SRBR_2                                                                 0x98007838
+#define ISO_U0SRBR_3                                                                 0x9800783C
+#define ISO_U0SRBR_4                                                                 0x98007840
+#define ISO_U0SRBR_5                                                                 0x98007844
+#define ISO_U0SRBR_6                                                                 0x98007848
+#define ISO_U0SRBR_7                                                                 0x9800784C
+#define ISO_U0SRBR_8                                                                 0x98007850
+#define ISO_U0SRBR_9                                                                 0x98007854
+#define ISO_U0SRBR_10                                                                 0x98007858
+#define ISO_U0SRBR_11                                                                 0x9800785C
+#define ISO_U0SRBR_12                                                                 0x98007860
+#define ISO_U0SRBR_13                                                                 0x98007864
+#define ISO_U0SRBR_14                                                                 0x98007868
+#define ISO_U0SRBR_15                                                                 0x9800786C
+#define ISO_U0SRBR_0_reg_addr                                                        "0xD8007830"
+#define ISO_U0SRBR_1_reg_addr                                                        "0xD8007834"
+#define ISO_U0SRBR_2_reg_addr                                                        "0xD8007838"
+#define ISO_U0SRBR_3_reg_addr                                                        "0xD800783C"
+#define ISO_U0SRBR_4_reg_addr                                                        "0xD8007840"
+#define ISO_U0SRBR_5_reg_addr                                                        "0xD8007844"
+#define ISO_U0SRBR_6_reg_addr                                                        "0xD8007848"
+#define ISO_U0SRBR_7_reg_addr                                                        "0xD800784C"
+#define ISO_U0SRBR_8_reg_addr                                                        "0xD8007850"
+#define ISO_U0SRBR_9_reg_addr                                                        "0xD8007854"
+#define ISO_U0SRBR_10_reg_addr                                                        "0xD8007858"
+#define ISO_U0SRBR_11_reg_addr                                                        "0xD800785C"
+#define ISO_U0SRBR_12_reg_addr                                                        "0xD8007860"
+#define ISO_U0SRBR_13_reg_addr                                                        "0xD8007864"
+#define ISO_U0SRBR_14_reg_addr                                                        "0xD8007868"
+#define ISO_U0SRBR_15_reg_addr                                                        "0xD800786C"
+#define ISO_U0SRBR_0_reg                                                             0xD8007830
+#define ISO_U0SRBR_1_reg                                                             0xD8007834
+#define ISO_U0SRBR_2_reg                                                             0xD8007838
+#define ISO_U0SRBR_3_reg                                                             0xD800783C
+#define ISO_U0SRBR_4_reg                                                             0xD8007840
+#define ISO_U0SRBR_5_reg                                                             0xD8007844
+#define ISO_U0SRBR_6_reg                                                             0xD8007848
+#define ISO_U0SRBR_7_reg                                                             0xD800784C
+#define ISO_U0SRBR_8_reg                                                             0xD8007850
+#define ISO_U0SRBR_9_reg                                                             0xD8007854
+#define ISO_U0SRBR_10_reg                                                             0xD8007858
+#define ISO_U0SRBR_11_reg                                                             0xD800785C
+#define ISO_U0SRBR_12_reg                                                             0xD8007860
+#define ISO_U0SRBR_13_reg                                                             0xD8007864
+#define ISO_U0SRBR_14_reg                                                             0xD8007868
+#define ISO_U0SRBR_15_reg                                                             0xD800786C
+#define set_ISO_U0SRBR_0_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_0_reg)=data)
+#define set_ISO_U0SRBR_1_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_1_reg)=data)
+#define set_ISO_U0SRBR_2_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_2_reg)=data)
+#define set_ISO_U0SRBR_3_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_3_reg)=data)
+#define set_ISO_U0SRBR_4_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_4_reg)=data)
+#define set_ISO_U0SRBR_5_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_5_reg)=data)
+#define set_ISO_U0SRBR_6_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_6_reg)=data)
+#define set_ISO_U0SRBR_7_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_7_reg)=data)
+#define set_ISO_U0SRBR_8_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_8_reg)=data)
+#define set_ISO_U0SRBR_9_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_9_reg)=data)
+#define set_ISO_U0SRBR_10_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_10_reg)=data)
+#define set_ISO_U0SRBR_11_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_11_reg)=data)
+#define set_ISO_U0SRBR_12_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_12_reg)=data)
+#define set_ISO_U0SRBR_13_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_13_reg)=data)
+#define set_ISO_U0SRBR_14_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_14_reg)=data)
+#define set_ISO_U0SRBR_15_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_15_reg)=data)
+#define get_ISO_U0SRBR_0_reg   (*((volatile unsigned int*) ISO_U0SRBR_0_reg))
+#define get_ISO_U0SRBR_1_reg   (*((volatile unsigned int*) ISO_U0SRBR_1_reg))
+#define get_ISO_U0SRBR_2_reg   (*((volatile unsigned int*) ISO_U0SRBR_2_reg))
+#define get_ISO_U0SRBR_3_reg   (*((volatile unsigned int*) ISO_U0SRBR_3_reg))
+#define get_ISO_U0SRBR_4_reg   (*((volatile unsigned int*) ISO_U0SRBR_4_reg))
+#define get_ISO_U0SRBR_5_reg   (*((volatile unsigned int*) ISO_U0SRBR_5_reg))
+#define get_ISO_U0SRBR_6_reg   (*((volatile unsigned int*) ISO_U0SRBR_6_reg))
+#define get_ISO_U0SRBR_7_reg   (*((volatile unsigned int*) ISO_U0SRBR_7_reg))
+#define get_ISO_U0SRBR_8_reg   (*((volatile unsigned int*) ISO_U0SRBR_8_reg))
+#define get_ISO_U0SRBR_9_reg   (*((volatile unsigned int*) ISO_U0SRBR_9_reg))
+#define get_ISO_U0SRBR_10_reg   (*((volatile unsigned int*) ISO_U0SRBR_10_reg))
+#define get_ISO_U0SRBR_11_reg   (*((volatile unsigned int*) ISO_U0SRBR_11_reg))
+#define get_ISO_U0SRBR_12_reg   (*((volatile unsigned int*) ISO_U0SRBR_12_reg))
+#define get_ISO_U0SRBR_13_reg   (*((volatile unsigned int*) ISO_U0SRBR_13_reg))
+#define get_ISO_U0SRBR_14_reg   (*((volatile unsigned int*) ISO_U0SRBR_14_reg))
+#define get_ISO_U0SRBR_15_reg   (*((volatile unsigned int*) ISO_U0SRBR_15_reg))
+#define ISO_U0SRBR_0_inst_adr                                                        "0x000C"
+#define ISO_U0SRBR_1_inst_adr                                                        "0x000D"
+#define ISO_U0SRBR_2_inst_adr                                                        "0x000E"
+#define ISO_U0SRBR_3_inst_adr                                                        "0x000F"
+#define ISO_U0SRBR_4_inst_adr                                                        "0x0010"
+#define ISO_U0SRBR_5_inst_adr                                                        "0x0011"
+#define ISO_U0SRBR_6_inst_adr                                                        "0x0012"
+#define ISO_U0SRBR_7_inst_adr                                                        "0x0013"
+#define ISO_U0SRBR_8_inst_adr                                                        "0x0014"
+#define ISO_U0SRBR_9_inst_adr                                                        "0x0015"
+#define ISO_U0SRBR_10_inst_adr                                                        "0x0016"
+#define ISO_U0SRBR_11_inst_adr                                                        "0x0017"
+#define ISO_U0SRBR_12_inst_adr                                                        "0x0018"
+#define ISO_U0SRBR_13_inst_adr                                                        "0x0019"
+#define ISO_U0SRBR_14_inst_adr                                                        "0x001A"
+#define ISO_U0SRBR_15_inst_adr                                                        "0x001B"
+#define ISO_U0SRBR_0_inst                                                            0x000C
+#define ISO_U0SRBR_1_inst                                                            0x000D
+#define ISO_U0SRBR_2_inst                                                            0x000E
+#define ISO_U0SRBR_3_inst                                                            0x000F
+#define ISO_U0SRBR_4_inst                                                            0x0010
+#define ISO_U0SRBR_5_inst                                                            0x0011
+#define ISO_U0SRBR_6_inst                                                            0x0012
+#define ISO_U0SRBR_7_inst                                                            0x0013
+#define ISO_U0SRBR_8_inst                                                            0x0014
+#define ISO_U0SRBR_9_inst                                                            0x0015
+#define ISO_U0SRBR_10_inst                                                            0x0016
+#define ISO_U0SRBR_11_inst                                                            0x0017
+#define ISO_U0SRBR_12_inst                                                            0x0018
+#define ISO_U0SRBR_13_inst                                                            0x0019
+#define ISO_U0SRBR_14_inst                                                            0x001A
+#define ISO_U0SRBR_15_inst                                                            0x001B
+#define ISO_U0SRBR_rbd_shift                                                         (0)
+#define ISO_U0SRBR_rbd_mask                                                          (0x000000FF)
+#define ISO_U0SRBR_rbd(data)                                                         (0x000000FF&((data)<<0))
+#define ISO_U0SRBR_rbd_src(data)                                                     ((0x000000FF&(data))>>0)
+#define ISO_U0SRBR_get_rbd(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0FAR                                                                    0x98007870
+#define ISO_U0FAR_reg_addr                                                           "0xD8007870"
+#define ISO_U0FAR_reg                                                                0xD8007870
+#define set_ISO_U0FAR_reg(data)   (*((volatile unsigned int*) ISO_U0FAR_reg)=data)
+#define get_ISO_U0FAR_reg   (*((volatile unsigned int*) ISO_U0FAR_reg))
+#define ISO_U0FAR_inst_adr                                                           "0x001C"
+#define ISO_U0FAR_inst                                                               0x001C
+#define ISO_U0FAR_far_shift                                                          (0)
+#define ISO_U0FAR_far_mask                                                           (0x00000001)
+#define ISO_U0FAR_far(data)                                                          (0x00000001&((data)<<0))
+#define ISO_U0FAR_far_src(data)                                                      ((0x00000001&(data))>>0)
+#define ISO_U0FAR_get_far(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_U0TFR                                                                    0x98007874
+#define ISO_U0TFR_reg_addr                                                           "0xD8007874"
+#define ISO_U0TFR_reg                                                                0xD8007874
+#define set_ISO_U0TFR_reg(data)   (*((volatile unsigned int*) ISO_U0TFR_reg)=data)
+#define get_ISO_U0TFR_reg   (*((volatile unsigned int*) ISO_U0TFR_reg))
+#define ISO_U0TFR_inst_adr                                                           "0x001D"
+#define ISO_U0TFR_inst                                                               0x001D
+#define ISO_U0TFR_far_shift                                                          (0)
+#define ISO_U0TFR_far_mask                                                           (0x000000FF)
+#define ISO_U0TFR_far(data)                                                          (0x000000FF&((data)<<0))
+#define ISO_U0TFR_far_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ISO_U0TFR_get_far(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0RFW                                                                    0x98007878
+#define ISO_U0RFW_reg_addr                                                           "0xD8007878"
+#define ISO_U0RFW_reg                                                                0xD8007878
+#define set_ISO_U0RFW_reg(data)   (*((volatile unsigned int*) ISO_U0RFW_reg)=data)
+#define get_ISO_U0RFW_reg   (*((volatile unsigned int*) ISO_U0RFW_reg))
+#define ISO_U0RFW_inst_adr                                                           "0x001E"
+#define ISO_U0RFW_inst                                                               0x001E
+#define ISO_U0RFW_rffe_shift                                                         (9)
+#define ISO_U0RFW_rffe_mask                                                          (0x00000200)
+#define ISO_U0RFW_rffe(data)                                                         (0x00000200&((data)<<9))
+#define ISO_U0RFW_rffe_src(data)                                                     ((0x00000200&(data))>>9)
+#define ISO_U0RFW_get_rffe(data)                                                     ((0x00000200&(data))>>9)
+#define ISO_U0RFW_rfpf_shift                                                         (8)
+#define ISO_U0RFW_rfpf_mask                                                          (0x00000100)
+#define ISO_U0RFW_rfpf(data)                                                         (0x00000100&((data)<<8))
+#define ISO_U0RFW_rfpf_src(data)                                                     ((0x00000100&(data))>>8)
+#define ISO_U0RFW_get_rfpf(data)                                                     ((0x00000100&(data))>>8)
+#define ISO_U0RFW_rfwd_shift                                                         (0)
+#define ISO_U0RFW_rfwd_mask                                                          (0x000000FF)
+#define ISO_U0RFW_rfwd(data)                                                         (0x000000FF&((data)<<0))
+#define ISO_U0RFW_rfwd_src(data)                                                     ((0x000000FF&(data))>>0)
+#define ISO_U0RFW_get_rfwd(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0USR                                                                    0x9800787C
+#define ISO_U0USR_reg_addr                                                           "0xD800787C"
+#define ISO_U0USR_reg                                                                0xD800787C
+#define set_ISO_U0USR_reg(data)   (*((volatile unsigned int*) ISO_U0USR_reg)=data)
+#define get_ISO_U0USR_reg   (*((volatile unsigned int*) ISO_U0USR_reg))
+#define ISO_U0USR_inst_adr                                                           "0x001F"
+#define ISO_U0USR_inst                                                               0x001F
+#define ISO_U0USR_rff_shift                                                          (4)
+#define ISO_U0USR_rff_mask                                                           (0x00000010)
+#define ISO_U0USR_rff(data)                                                          (0x00000010&((data)<<4))
+#define ISO_U0USR_rff_src(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0USR_get_rff(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0USR_rfne_shift                                                         (3)
+#define ISO_U0USR_rfne_mask                                                          (0x00000008)
+#define ISO_U0USR_rfne(data)                                                         (0x00000008&((data)<<3))
+#define ISO_U0USR_rfne_src(data)                                                     ((0x00000008&(data))>>3)
+#define ISO_U0USR_get_rfne(data)                                                     ((0x00000008&(data))>>3)
+#define ISO_U0USR_tfe_shift                                                          (2)
+#define ISO_U0USR_tfe_mask                                                           (0x00000004)
+#define ISO_U0USR_tfe(data)                                                          (0x00000004&((data)<<2))
+#define ISO_U0USR_tfe_src(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0USR_get_tfe(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0USR_tfnf_shift                                                         (1)
+#define ISO_U0USR_tfnf_mask                                                          (0x00000002)
+#define ISO_U0USR_tfnf(data)                                                         (0x00000002&((data)<<1))
+#define ISO_U0USR_tfnf_src(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_U0USR_get_tfnf(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_U0USR_busy_shift                                                         (0)
+#define ISO_U0USR_busy_mask                                                          (0x00000001)
+#define ISO_U0USR_busy(data)                                                         (0x00000001&((data)<<0))
+#define ISO_U0USR_busy_src(data)                                                     ((0x00000001&(data))>>0)
+#define ISO_U0USR_get_busy(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_U0TFL                                                                    0x98007880
+#define ISO_U0TFL_reg_addr                                                           "0xD8007880"
+#define ISO_U0TFL_reg                                                                0xD8007880
+#define set_ISO_U0TFL_reg(data)   (*((volatile unsigned int*) ISO_U0TFL_reg)=data)
+#define get_ISO_U0TFL_reg   (*((volatile unsigned int*) ISO_U0TFL_reg))
+#define ISO_U0TFL_inst_adr                                                           "0x0020"
+#define ISO_U0TFL_inst                                                               0x0020
+#define ISO_U0TFL_tfl_shift                                                          (0)
+#define ISO_U0TFL_tfl_mask                                                           (0x000000FF)
+#define ISO_U0TFL_tfl(data)                                                          (0x000000FF&((data)<<0))
+#define ISO_U0TFL_tfl_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ISO_U0TFL_get_tfl(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0RFL                                                                    0x98007884
+#define ISO_U0RFL_reg_addr                                                           "0xD8007884"
+#define ISO_U0RFL_reg                                                                0xD8007884
+#define set_ISO_U0RFL_reg(data)   (*((volatile unsigned int*) ISO_U0RFL_reg)=data)
+#define get_ISO_U0RFL_reg   (*((volatile unsigned int*) ISO_U0RFL_reg))
+#define ISO_U0RFL_inst_adr                                                           "0x0021"
+#define ISO_U0RFL_inst                                                               0x0021
+#define ISO_U0RFL_rfl_shift                                                          (0)
+#define ISO_U0RFL_rfl_mask                                                           (0x000000FF)
+#define ISO_U0RFL_rfl(data)                                                          (0x000000FF&((data)<<0))
+#define ISO_U0RFL_rfl_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ISO_U0RFL_get_rfl(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0SRR                                                                    0x98007888
+#define ISO_U0SRR_reg_addr                                                           "0xD8007888"
+#define ISO_U0SRR_reg                                                                0xD8007888
+#define set_ISO_U0SRR_reg(data)   (*((volatile unsigned int*) ISO_U0SRR_reg)=data)
+#define get_ISO_U0SRR_reg   (*((volatile unsigned int*) ISO_U0SRR_reg))
+#define ISO_U0SRR_inst_adr                                                           "0x0022"
+#define ISO_U0SRR_inst                                                               0x0022
+#define ISO_U0SRR_xfr_shift                                                          (2)
+#define ISO_U0SRR_xfr_mask                                                           (0x00000004)
+#define ISO_U0SRR_xfr(data)                                                          (0x00000004&((data)<<2))
+#define ISO_U0SRR_xfr_src(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0SRR_get_xfr(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0SRR_rfr_shift                                                          (1)
+#define ISO_U0SRR_rfr_mask                                                           (0x00000002)
+#define ISO_U0SRR_rfr(data)                                                          (0x00000002&((data)<<1))
+#define ISO_U0SRR_rfr_src(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_U0SRR_get_rfr(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_U0SRR_ur_shift                                                           (0)
+#define ISO_U0SRR_ur_mask                                                            (0x00000001)
+#define ISO_U0SRR_ur(data)                                                           (0x00000001&((data)<<0))
+#define ISO_U0SRR_ur_src(data)                                                       ((0x00000001&(data))>>0)
+#define ISO_U0SRR_get_ur(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_U0SBCR                                                                   0x98007890
+#define ISO_U0SBCR_reg_addr                                                          "0xD8007890"
+#define ISO_U0SBCR_reg                                                               0xD8007890
+#define set_ISO_U0SBCR_reg(data)   (*((volatile unsigned int*) ISO_U0SBCR_reg)=data)
+#define get_ISO_U0SBCR_reg   (*((volatile unsigned int*) ISO_U0SBCR_reg))
+#define ISO_U0SBCR_inst_adr                                                          "0x0024"
+#define ISO_U0SBCR_inst                                                              0x0024
+#define ISO_U0SBCR_sbcr_shift                                                        (0)
+#define ISO_U0SBCR_sbcr_mask                                                         (0x00000001)
+#define ISO_U0SBCR_sbcr(data)                                                        (0x00000001&((data)<<0))
+#define ISO_U0SBCR_sbcr_src(data)                                                    ((0x00000001&(data))>>0)
+#define ISO_U0SBCR_get_sbcr(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_U0SDMAM                                                                  0x98007894
+#define ISO_U0SDMAM_reg_addr                                                         "0xD8007894"
+#define ISO_U0SDMAM_reg                                                              0xD8007894
+#define set_ISO_U0SDMAM_reg(data)   (*((volatile unsigned int*) ISO_U0SDMAM_reg)=data)
+#define get_ISO_U0SDMAM_reg   (*((volatile unsigned int*) ISO_U0SDMAM_reg))
+#define ISO_U0SDMAM_inst_adr                                                         "0x0025"
+#define ISO_U0SDMAM_inst                                                             0x0025
+#define ISO_U0SDMAM_sdmam_shift                                                      (0)
+#define ISO_U0SDMAM_sdmam_mask                                                       (0x00000001)
+#define ISO_U0SDMAM_sdmam(data)                                                      (0x00000001&((data)<<0))
+#define ISO_U0SDMAM_sdmam_src(data)                                                  ((0x00000001&(data))>>0)
+#define ISO_U0SDMAM_get_sdmam(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_U0SFE                                                                    0x98007898
+#define ISO_U0SFE_reg_addr                                                           "0xD8007898"
+#define ISO_U0SFE_reg                                                                0xD8007898
+#define set_ISO_U0SFE_reg(data)   (*((volatile unsigned int*) ISO_U0SFE_reg)=data)
+#define get_ISO_U0SFE_reg   (*((volatile unsigned int*) ISO_U0SFE_reg))
+#define ISO_U0SFE_inst_adr                                                           "0x0026"
+#define ISO_U0SFE_inst                                                               0x0026
+#define ISO_U0SFE_sfe_shift                                                          (0)
+#define ISO_U0SFE_sfe_mask                                                           (0x00000001)
+#define ISO_U0SFE_sfe(data)                                                          (0x00000001&((data)<<0))
+#define ISO_U0SFE_sfe_src(data)                                                      ((0x00000001&(data))>>0)
+#define ISO_U0SFE_get_sfe(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_U0SRT                                                                    0x9800789C
+#define ISO_U0SRT_reg_addr                                                           "0xD800789C"
+#define ISO_U0SRT_reg                                                                0xD800789C
+#define set_ISO_U0SRT_reg(data)   (*((volatile unsigned int*) ISO_U0SRT_reg)=data)
+#define get_ISO_U0SRT_reg   (*((volatile unsigned int*) ISO_U0SRT_reg))
+#define ISO_U0SRT_inst_adr                                                           "0x0027"
+#define ISO_U0SRT_inst                                                               0x0027
+#define ISO_U0SRT_srt_shift                                                          (0)
+#define ISO_U0SRT_srt_mask                                                           (0x00000003)
+#define ISO_U0SRT_srt(data)                                                          (0x00000003&((data)<<0))
+#define ISO_U0SRT_srt_src(data)                                                      ((0x00000003&(data))>>0)
+#define ISO_U0SRT_get_srt(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define ISO_U0STET                                                                   0x980078A0
+#define ISO_U0STET_reg_addr                                                          "0xD80078A0"
+#define ISO_U0STET_reg                                                               0xD80078A0
+#define set_ISO_U0STET_reg(data)   (*((volatile unsigned int*) ISO_U0STET_reg)=data)
+#define get_ISO_U0STET_reg   (*((volatile unsigned int*) ISO_U0STET_reg))
+#define ISO_U0STET_inst_adr                                                          "0x0028"
+#define ISO_U0STET_inst                                                              0x0028
+#define ISO_U0STET_stet_shift                                                        (0)
+#define ISO_U0STET_stet_mask                                                         (0x00000003)
+#define ISO_U0STET_stet(data)                                                        (0x00000003&((data)<<0))
+#define ISO_U0STET_stet_src(data)                                                    ((0x00000003&(data))>>0)
+#define ISO_U0STET_get_stet(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define ISO_U0HTX                                                                    0x980078A4
+#define ISO_U0HTX_reg_addr                                                           "0xD80078A4"
+#define ISO_U0HTX_reg                                                                0xD80078A4
+#define set_ISO_U0HTX_reg(data)   (*((volatile unsigned int*) ISO_U0HTX_reg)=data)
+#define get_ISO_U0HTX_reg   (*((volatile unsigned int*) ISO_U0HTX_reg))
+#define ISO_U0HTX_inst_adr                                                           "0x0029"
+#define ISO_U0HTX_inst                                                               0x0029
+#define ISO_U0HTX_htx_shift                                                          (0)
+#define ISO_U0HTX_htx_mask                                                           (0x00000001)
+#define ISO_U0HTX_htx(data)                                                          (0x00000001&((data)<<0))
+#define ISO_U0HTX_htx_src(data)                                                      ((0x00000001&(data))>>0)
+#define ISO_U0HTX_get_htx(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_U0DMASA                                                                  0x980078A8
+#define ISO_U0DMASA_reg_addr                                                         "0xD80078A8"
+#define ISO_U0DMASA_reg                                                              0xD80078A8
+#define set_ISO_U0DMASA_reg(data)   (*((volatile unsigned int*) ISO_U0DMASA_reg)=data)
+#define get_ISO_U0DMASA_reg   (*((volatile unsigned int*) ISO_U0DMASA_reg))
+#define ISO_U0DMASA_inst_adr                                                         "0x002A"
+#define ISO_U0DMASA_inst                                                             0x002A
+#define ISO_U0DMASA_dmasa_shift                                                      (0)
+#define ISO_U0DMASA_dmasa_mask                                                       (0x00000001)
+#define ISO_U0DMASA_dmasa(data)                                                      (0x00000001&((data)<<0))
+#define ISO_U0DMASA_dmasa_src(data)                                                  ((0x00000001&(data))>>0)
+#define ISO_U0DMASA_get_dmasa(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_U0CPR                                                                    0x980078F4
+#define ISO_U0CPR_reg_addr                                                           "0xD80078F4"
+#define ISO_U0CPR_reg                                                                0xD80078F4
+#define set_ISO_U0CPR_reg(data)   (*((volatile unsigned int*) ISO_U0CPR_reg)=data)
+#define get_ISO_U0CPR_reg   (*((volatile unsigned int*) ISO_U0CPR_reg))
+#define ISO_U0CPR_inst_adr                                                           "0x003D"
+#define ISO_U0CPR_inst                                                               0x003D
+#define ISO_U0CPR_fifo_mode_shift                                                    (16)
+#define ISO_U0CPR_fifo_mode_mask                                                     (0x00FF0000)
+#define ISO_U0CPR_fifo_mode(data)                                                    (0x00FF0000&((data)<<16))
+#define ISO_U0CPR_fifo_mode_src(data)                                                ((0x00FF0000&(data))>>16)
+#define ISO_U0CPR_get_fifo_mode(data)                                                ((0x00FF0000&(data))>>16)
+#define ISO_U0CPR_dma_extra_shift                                                    (13)
+#define ISO_U0CPR_dma_extra_mask                                                     (0x00002000)
+#define ISO_U0CPR_dma_extra(data)                                                    (0x00002000&((data)<<13))
+#define ISO_U0CPR_dma_extra_src(data)                                                ((0x00002000&(data))>>13)
+#define ISO_U0CPR_get_dma_extra(data)                                                ((0x00002000&(data))>>13)
+#define ISO_U0CPR_uart_add_encoded_params_shift                                      (12)
+#define ISO_U0CPR_uart_add_encoded_params_mask                                       (0x00001000)
+#define ISO_U0CPR_uart_add_encoded_params(data)                                      (0x00001000&((data)<<12))
+#define ISO_U0CPR_uart_add_encoded_params_src(data)                                  ((0x00001000&(data))>>12)
+#define ISO_U0CPR_get_uart_add_encoded_params(data)                                  ((0x00001000&(data))>>12)
+#define ISO_U0CPR_shadow_shift                                                       (11)
+#define ISO_U0CPR_shadow_mask                                                        (0x00000800)
+#define ISO_U0CPR_shadow(data)                                                       (0x00000800&((data)<<11))
+#define ISO_U0CPR_shadow_src(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_U0CPR_get_shadow(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_U0CPR_fifo_stat_shift                                                    (10)
+#define ISO_U0CPR_fifo_stat_mask                                                     (0x00000400)
+#define ISO_U0CPR_fifo_stat(data)                                                    (0x00000400&((data)<<10))
+#define ISO_U0CPR_fifo_stat_src(data)                                                ((0x00000400&(data))>>10)
+#define ISO_U0CPR_get_fifo_stat(data)                                                ((0x00000400&(data))>>10)
+#define ISO_U0CPR_fifo_access_shift                                                  (9)
+#define ISO_U0CPR_fifo_access_mask                                                   (0x00000200)
+#define ISO_U0CPR_fifo_access(data)                                                  (0x00000200&((data)<<9))
+#define ISO_U0CPR_fifo_access_src(data)                                              ((0x00000200&(data))>>9)
+#define ISO_U0CPR_get_fifo_access(data)                                              ((0x00000200&(data))>>9)
+#define ISO_U0CPR_additional_feat_shift                                              (8)
+#define ISO_U0CPR_additional_feat_mask                                               (0x00000100)
+#define ISO_U0CPR_additional_feat(data)                                              (0x00000100&((data)<<8))
+#define ISO_U0CPR_additional_feat_src(data)                                          ((0x00000100&(data))>>8)
+#define ISO_U0CPR_get_additional_feat(data)                                          ((0x00000100&(data))>>8)
+#define ISO_U0CPR_sir_lp_mode_shift                                                  (7)
+#define ISO_U0CPR_sir_lp_mode_mask                                                   (0x00000080)
+#define ISO_U0CPR_sir_lp_mode(data)                                                  (0x00000080&((data)<<7))
+#define ISO_U0CPR_sir_lp_mode_src(data)                                              ((0x00000080&(data))>>7)
+#define ISO_U0CPR_get_sir_lp_mode(data)                                              ((0x00000080&(data))>>7)
+#define ISO_U0CPR_sir_mode_shift                                                     (6)
+#define ISO_U0CPR_sir_mode_mask                                                      (0x00000040)
+#define ISO_U0CPR_sir_mode(data)                                                     (0x00000040&((data)<<6))
+#define ISO_U0CPR_sir_mode_src(data)                                                 ((0x00000040&(data))>>6)
+#define ISO_U0CPR_get_sir_mode(data)                                                 ((0x00000040&(data))>>6)
+#define ISO_U0CPR_thre_mode_shift                                                    (5)
+#define ISO_U0CPR_thre_mode_mask                                                     (0x00000020)
+#define ISO_U0CPR_thre_mode(data)                                                    (0x00000020&((data)<<5))
+#define ISO_U0CPR_thre_mode_src(data)                                                ((0x00000020&(data))>>5)
+#define ISO_U0CPR_get_thre_mode(data)                                                ((0x00000020&(data))>>5)
+#define ISO_U0CPR_afce_mode_shift                                                    (4)
+#define ISO_U0CPR_afce_mode_mask                                                     (0x00000010)
+#define ISO_U0CPR_afce_mode(data)                                                    (0x00000010&((data)<<4))
+#define ISO_U0CPR_afce_mode_src(data)                                                ((0x00000010&(data))>>4)
+#define ISO_U0CPR_get_afce_mode(data)                                                ((0x00000010&(data))>>4)
+#define ISO_U0CPR_apb_data_width_shift                                               (0)
+#define ISO_U0CPR_apb_data_width_mask                                                (0x00000003)
+#define ISO_U0CPR_apb_data_width(data)                                               (0x00000003&((data)<<0))
+#define ISO_U0CPR_apb_data_width_src(data)                                           ((0x00000003&(data))>>0)
+#define ISO_U0CPR_get_apb_data_width(data)                                           ((0x00000003&(data))>>0)
+
+
+#define ISO_U0UCV                                                                    0x980078F8
+#define ISO_U0UCV_reg_addr                                                           "0xD80078F8"
+#define ISO_U0UCV_reg                                                                0xD80078F8
+#define set_ISO_U0UCV_reg(data)   (*((volatile unsigned int*) ISO_U0UCV_reg)=data)
+#define get_ISO_U0UCV_reg   (*((volatile unsigned int*) ISO_U0UCV_reg))
+#define ISO_U0UCV_inst_adr                                                           "0x003E"
+#define ISO_U0UCV_inst                                                               0x003E
+#define ISO_U0UCV_ucv_shift                                                          (0)
+#define ISO_U0UCV_ucv_mask                                                           (0xFFFFFFFF)
+#define ISO_U0UCV_ucv(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define ISO_U0UCV_ucv_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define ISO_U0UCV_get_ucv(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_U0CTR                                                                    0x980078FC
+#define ISO_U0CTR_reg_addr                                                           "0xD80078FC"
+#define ISO_U0CTR_reg                                                                0xD80078FC
+#define set_ISO_U0CTR_reg(data)   (*((volatile unsigned int*) ISO_U0CTR_reg)=data)
+#define get_ISO_U0CTR_reg   (*((volatile unsigned int*) ISO_U0CTR_reg))
+#define ISO_U0CTR_inst_adr                                                           "0x003F"
+#define ISO_U0CTR_inst                                                               0x003F
+#define ISO_U0CTR_ctr_shift                                                          (0)
+#define ISO_U0CTR_ctr_mask                                                           (0xFFFFFFFF)
+#define ISO_U0CTR_ctr(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define ISO_U0CTR_ctr_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define ISO_U0CTR_get_ctr(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IC0_CON                                                                  0x98007D00
+#define ISO_IC0_CON_reg_addr                                                         "0xD8007D00"
+#define ISO_IC0_CON_reg                                                              0xD8007D00
+#define set_ISO_IC0_CON_reg(data)   (*((volatile unsigned int*) ISO_IC0_CON_reg)=data)
+#define get_ISO_IC0_CON_reg   (*((volatile unsigned int*) ISO_IC0_CON_reg))
+#define ISO_IC0_CON_inst_adr                                                         "0x0040"
+#define ISO_IC0_CON_inst                                                             0x0040
+#define ISO_IC0_CON_ic_slave_disable_shift                                           (6)
+#define ISO_IC0_CON_ic_slave_disable_mask                                            (0x00000040)
+#define ISO_IC0_CON_ic_slave_disable(data)                                           (0x00000040&((data)<<6))
+#define ISO_IC0_CON_ic_slave_disable_src(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC0_CON_get_ic_slave_disable(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC0_CON_ic_restart_en_shift                                              (5)
+#define ISO_IC0_CON_ic_restart_en_mask                                               (0x00000020)
+#define ISO_IC0_CON_ic_restart_en(data)                                              (0x00000020&((data)<<5))
+#define ISO_IC0_CON_ic_restart_en_src(data)                                          ((0x00000020&(data))>>5)
+#define ISO_IC0_CON_get_ic_restart_en(data)                                          ((0x00000020&(data))>>5)
+#define ISO_IC0_CON_ic_10bitaddr_master_shift                                        (4)
+#define ISO_IC0_CON_ic_10bitaddr_master_mask                                         (0x00000010)
+#define ISO_IC0_CON_ic_10bitaddr_master(data)                                        (0x00000010&((data)<<4))
+#define ISO_IC0_CON_ic_10bitaddr_master_src(data)                                    ((0x00000010&(data))>>4)
+#define ISO_IC0_CON_get_ic_10bitaddr_master(data)                                    ((0x00000010&(data))>>4)
+#define ISO_IC0_CON_ic_10bitaddr_slave_shift                                         (3)
+#define ISO_IC0_CON_ic_10bitaddr_slave_mask                                          (0x00000008)
+#define ISO_IC0_CON_ic_10bitaddr_slave(data)                                         (0x00000008&((data)<<3))
+#define ISO_IC0_CON_ic_10bitaddr_slave_src(data)                                     ((0x00000008&(data))>>3)
+#define ISO_IC0_CON_get_ic_10bitaddr_slave(data)                                     ((0x00000008&(data))>>3)
+#define ISO_IC0_CON_speed_shift                                                      (1)
+#define ISO_IC0_CON_speed_mask                                                       (0x00000006)
+#define ISO_IC0_CON_speed(data)                                                      (0x00000006&((data)<<1))
+#define ISO_IC0_CON_speed_src(data)                                                  ((0x00000006&(data))>>1)
+#define ISO_IC0_CON_get_speed(data)                                                  ((0x00000006&(data))>>1)
+#define ISO_IC0_CON_master_mode_shift                                                (0)
+#define ISO_IC0_CON_master_mode_mask                                                 (0x00000001)
+#define ISO_IC0_CON_master_mode(data)                                                (0x00000001&((data)<<0))
+#define ISO_IC0_CON_master_mode_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_IC0_CON_get_master_mode(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_TAR                                                                  0x98007D04
+#define ISO_IC0_TAR_reg_addr                                                         "0xD8007D04"
+#define ISO_IC0_TAR_reg                                                              0xD8007D04
+#define set_ISO_IC0_TAR_reg(data)   (*((volatile unsigned int*) ISO_IC0_TAR_reg)=data)
+#define get_ISO_IC0_TAR_reg   (*((volatile unsigned int*) ISO_IC0_TAR_reg))
+#define ISO_IC0_TAR_inst_adr                                                         "0x0041"
+#define ISO_IC0_TAR_inst                                                             0x0041
+#define ISO_IC0_TAR_ic_10bitaddr_master_shift                                        (12)
+#define ISO_IC0_TAR_ic_10bitaddr_master_mask                                         (0x00001000)
+#define ISO_IC0_TAR_ic_10bitaddr_master(data)                                        (0x00001000&((data)<<12))
+#define ISO_IC0_TAR_ic_10bitaddr_master_src(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC0_TAR_get_ic_10bitaddr_master(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC0_TAR_special_shift                                                    (11)
+#define ISO_IC0_TAR_special_mask                                                     (0x00000800)
+#define ISO_IC0_TAR_special(data)                                                    (0x00000800&((data)<<11))
+#define ISO_IC0_TAR_special_src(data)                                                ((0x00000800&(data))>>11)
+#define ISO_IC0_TAR_get_special(data)                                                ((0x00000800&(data))>>11)
+#define ISO_IC0_TAR_gc_or_start_shift                                                (10)
+#define ISO_IC0_TAR_gc_or_start_mask                                                 (0x00000400)
+#define ISO_IC0_TAR_gc_or_start(data)                                                (0x00000400&((data)<<10))
+#define ISO_IC0_TAR_gc_or_start_src(data)                                            ((0x00000400&(data))>>10)
+#define ISO_IC0_TAR_get_gc_or_start(data)                                            ((0x00000400&(data))>>10)
+#define ISO_IC0_TAR_ic_tar_shift                                                     (0)
+#define ISO_IC0_TAR_ic_tar_mask                                                      (0x000003FF)
+#define ISO_IC0_TAR_ic_tar(data)                                                     (0x000003FF&((data)<<0))
+#define ISO_IC0_TAR_ic_tar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define ISO_IC0_TAR_get_ic_tar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define ISO_IC0_SAR                                                                  0x98007D08
+#define ISO_IC0_SAR_reg_addr                                                         "0xD8007D08"
+#define ISO_IC0_SAR_reg                                                              0xD8007D08
+#define set_ISO_IC0_SAR_reg(data)   (*((volatile unsigned int*) ISO_IC0_SAR_reg)=data)
+#define get_ISO_IC0_SAR_reg   (*((volatile unsigned int*) ISO_IC0_SAR_reg))
+#define ISO_IC0_SAR_inst_adr                                                         "0x0042"
+#define ISO_IC0_SAR_inst                                                             0x0042
+#define ISO_IC0_SAR_ic_sar_shift                                                     (0)
+#define ISO_IC0_SAR_ic_sar_mask                                                      (0x000003FF)
+#define ISO_IC0_SAR_ic_sar(data)                                                     (0x000003FF&((data)<<0))
+#define ISO_IC0_SAR_ic_sar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define ISO_IC0_SAR_get_ic_sar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define ISO_IC0_HS_MADDR                                                             0x98007D0C
+#define ISO_IC0_HS_MADDR_reg_addr                                                    "0xD8007D0C"
+#define ISO_IC0_HS_MADDR_reg                                                         0xD8007D0C
+#define set_ISO_IC0_HS_MADDR_reg(data)   (*((volatile unsigned int*) ISO_IC0_HS_MADDR_reg)=data)
+#define get_ISO_IC0_HS_MADDR_reg   (*((volatile unsigned int*) ISO_IC0_HS_MADDR_reg))
+#define ISO_IC0_HS_MADDR_inst_adr                                                    "0x0043"
+#define ISO_IC0_HS_MADDR_inst                                                        0x0043
+#define ISO_IC0_HS_MADDR_ic_hs_mar_shift                                             (0)
+#define ISO_IC0_HS_MADDR_ic_hs_mar_mask                                              (0x00000007)
+#define ISO_IC0_HS_MADDR_ic_hs_mar(data)                                             (0x00000007&((data)<<0))
+#define ISO_IC0_HS_MADDR_ic_hs_mar_src(data)                                         ((0x00000007&(data))>>0)
+#define ISO_IC0_HS_MADDR_get_ic_hs_mar(data)                                         ((0x00000007&(data))>>0)
+
+
+#define ISO_IC0_DATA_CMD                                                             0x98007D10
+#define ISO_IC0_DATA_CMD_reg_addr                                                    "0xD8007D10"
+#define ISO_IC0_DATA_CMD_reg                                                         0xD8007D10
+#define set_ISO_IC0_DATA_CMD_reg(data)   (*((volatile unsigned int*) ISO_IC0_DATA_CMD_reg)=data)
+#define get_ISO_IC0_DATA_CMD_reg   (*((volatile unsigned int*) ISO_IC0_DATA_CMD_reg))
+#define ISO_IC0_DATA_CMD_inst_adr                                                    "0x0044"
+#define ISO_IC0_DATA_CMD_inst                                                        0x0044
+#define ISO_IC0_DATA_CMD_restart_shift                                               (10)
+#define ISO_IC0_DATA_CMD_restart_mask                                                (0x00000400)
+#define ISO_IC0_DATA_CMD_restart(data)                                               (0x00000400&((data)<<10))
+#define ISO_IC0_DATA_CMD_restart_src(data)                                           ((0x00000400&(data))>>10)
+#define ISO_IC0_DATA_CMD_get_restart(data)                                           ((0x00000400&(data))>>10)
+#define ISO_IC0_DATA_CMD_stop_shift                                                  (9)
+#define ISO_IC0_DATA_CMD_stop_mask                                                   (0x00000200)
+#define ISO_IC0_DATA_CMD_stop(data)                                                  (0x00000200&((data)<<9))
+#define ISO_IC0_DATA_CMD_stop_src(data)                                              ((0x00000200&(data))>>9)
+#define ISO_IC0_DATA_CMD_get_stop(data)                                              ((0x00000200&(data))>>9)
+#define ISO_IC0_DATA_CMD_cmd_shift                                                   (8)
+#define ISO_IC0_DATA_CMD_cmd_mask                                                    (0x00000100)
+#define ISO_IC0_DATA_CMD_cmd(data)                                                   (0x00000100&((data)<<8))
+#define ISO_IC0_DATA_CMD_cmd_src(data)                                               ((0x00000100&(data))>>8)
+#define ISO_IC0_DATA_CMD_get_cmd(data)                                               ((0x00000100&(data))>>8)
+#define ISO_IC0_DATA_CMD_dat_shift                                                   (0)
+#define ISO_IC0_DATA_CMD_dat_mask                                                    (0x000000FF)
+#define ISO_IC0_DATA_CMD_dat(data)                                                   (0x000000FF&((data)<<0))
+#define ISO_IC0_DATA_CMD_dat_src(data)                                               ((0x000000FF&(data))>>0)
+#define ISO_IC0_DATA_CMD_get_dat(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC0_SS_SCL_HCNT                                                          0x98007D14
+#define ISO_IC0_SS_SCL_HCNT_reg_addr                                                 "0xD8007D14"
+#define ISO_IC0_SS_SCL_HCNT_reg                                                      0xD8007D14
+#define set_ISO_IC0_SS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) ISO_IC0_SS_SCL_HCNT_reg)=data)
+#define get_ISO_IC0_SS_SCL_HCNT_reg   (*((volatile unsigned int*) ISO_IC0_SS_SCL_HCNT_reg))
+#define ISO_IC0_SS_SCL_HCNT_inst_adr                                                 "0x0045"
+#define ISO_IC0_SS_SCL_HCNT_inst                                                     0x0045
+#define ISO_IC0_SS_SCL_HCNT_ic_ss_scl_hcnt_shift                                     (0)
+#define ISO_IC0_SS_SCL_HCNT_ic_ss_scl_hcnt_mask                                      (0x0000FFFF)
+#define ISO_IC0_SS_SCL_HCNT_ic_ss_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC0_SS_SCL_HCNT_ic_ss_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC0_SS_SCL_HCNT_get_ic_ss_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC0_SS_SCL_LCNT                                                          0x98007D18
+#define ISO_IC0_SS_SCL_LCNT_reg_addr                                                 "0xD8007D18"
+#define ISO_IC0_SS_SCL_LCNT_reg                                                      0xD8007D18
+#define set_ISO_IC0_SS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) ISO_IC0_SS_SCL_LCNT_reg)=data)
+#define get_ISO_IC0_SS_SCL_LCNT_reg   (*((volatile unsigned int*) ISO_IC0_SS_SCL_LCNT_reg))
+#define ISO_IC0_SS_SCL_LCNT_inst_adr                                                 "0x0046"
+#define ISO_IC0_SS_SCL_LCNT_inst                                                     0x0046
+#define ISO_IC0_SS_SCL_LCNT_ic_ss_scl_lcnt_shift                                     (0)
+#define ISO_IC0_SS_SCL_LCNT_ic_ss_scl_lcnt_mask                                      (0x0000FFFF)
+#define ISO_IC0_SS_SCL_LCNT_ic_ss_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC0_SS_SCL_LCNT_ic_ss_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC0_SS_SCL_LCNT_get_ic_ss_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC0_FS_SCL_HCNT                                                          0x98007D1C
+#define ISO_IC0_FS_SCL_HCNT_reg_addr                                                 "0xD8007D1C"
+#define ISO_IC0_FS_SCL_HCNT_reg                                                      0xD8007D1C
+#define set_ISO_IC0_FS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) ISO_IC0_FS_SCL_HCNT_reg)=data)
+#define get_ISO_IC0_FS_SCL_HCNT_reg   (*((volatile unsigned int*) ISO_IC0_FS_SCL_HCNT_reg))
+#define ISO_IC0_FS_SCL_HCNT_inst_adr                                                 "0x0047"
+#define ISO_IC0_FS_SCL_HCNT_inst                                                     0x0047
+#define ISO_IC0_FS_SCL_HCNT_ic_fs_scl_hcnt_shift                                     (0)
+#define ISO_IC0_FS_SCL_HCNT_ic_fs_scl_hcnt_mask                                      (0x0000FFFF)
+#define ISO_IC0_FS_SCL_HCNT_ic_fs_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC0_FS_SCL_HCNT_ic_fs_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC0_FS_SCL_HCNT_get_ic_fs_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC0_FS_SCL_LCNT                                                          0x98007D20
+#define ISO_IC0_FS_SCL_LCNT_reg_addr                                                 "0xD8007D20"
+#define ISO_IC0_FS_SCL_LCNT_reg                                                      0xD8007D20
+#define set_ISO_IC0_FS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) ISO_IC0_FS_SCL_LCNT_reg)=data)
+#define get_ISO_IC0_FS_SCL_LCNT_reg   (*((volatile unsigned int*) ISO_IC0_FS_SCL_LCNT_reg))
+#define ISO_IC0_FS_SCL_LCNT_inst_adr                                                 "0x0048"
+#define ISO_IC0_FS_SCL_LCNT_inst                                                     0x0048
+#define ISO_IC0_FS_SCL_LCNT_ic_fs_scl_lcnt_shift                                     (0)
+#define ISO_IC0_FS_SCL_LCNT_ic_fs_scl_lcnt_mask                                      (0x0000FFFF)
+#define ISO_IC0_FS_SCL_LCNT_ic_fs_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC0_FS_SCL_LCNT_ic_fs_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC0_FS_SCL_LCNT_get_ic_fs_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC0_INTR_STAT                                                            0x98007D2C
+#define ISO_IC0_INTR_STAT_reg_addr                                                   "0xD8007D2C"
+#define ISO_IC0_INTR_STAT_reg                                                        0xD8007D2C
+#define set_ISO_IC0_INTR_STAT_reg(data)   (*((volatile unsigned int*) ISO_IC0_INTR_STAT_reg)=data)
+#define get_ISO_IC0_INTR_STAT_reg   (*((volatile unsigned int*) ISO_IC0_INTR_STAT_reg))
+#define ISO_IC0_INTR_STAT_inst_adr                                                   "0x004B"
+#define ISO_IC0_INTR_STAT_inst                                                       0x004B
+#define ISO_IC0_INTR_STAT_r_gen_call_shift                                           (11)
+#define ISO_IC0_INTR_STAT_r_gen_call_mask                                            (0x00000800)
+#define ISO_IC0_INTR_STAT_r_gen_call(data)                                           (0x00000800&((data)<<11))
+#define ISO_IC0_INTR_STAT_r_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC0_INTR_STAT_get_r_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC0_INTR_STAT_r_start_det_shift                                          (10)
+#define ISO_IC0_INTR_STAT_r_start_det_mask                                           (0x00000400)
+#define ISO_IC0_INTR_STAT_r_start_det(data)                                          (0x00000400&((data)<<10))
+#define ISO_IC0_INTR_STAT_r_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC0_INTR_STAT_get_r_start_det(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC0_INTR_STAT_r_stop_det_shift                                           (9)
+#define ISO_IC0_INTR_STAT_r_stop_det_mask                                            (0x00000200)
+#define ISO_IC0_INTR_STAT_r_stop_det(data)                                           (0x00000200&((data)<<9))
+#define ISO_IC0_INTR_STAT_r_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC0_INTR_STAT_get_r_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC0_INTR_STAT_r_activity_shift                                           (8)
+#define ISO_IC0_INTR_STAT_r_activity_mask                                            (0x00000100)
+#define ISO_IC0_INTR_STAT_r_activity(data)                                           (0x00000100&((data)<<8))
+#define ISO_IC0_INTR_STAT_r_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC0_INTR_STAT_get_r_activity(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC0_INTR_STAT_r_rx_done_shift                                            (7)
+#define ISO_IC0_INTR_STAT_r_rx_done_mask                                             (0x00000080)
+#define ISO_IC0_INTR_STAT_r_rx_done(data)                                            (0x00000080&((data)<<7))
+#define ISO_IC0_INTR_STAT_r_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC0_INTR_STAT_get_r_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC0_INTR_STAT_r_tx_abrt_shift                                            (6)
+#define ISO_IC0_INTR_STAT_r_tx_abrt_mask                                             (0x00000040)
+#define ISO_IC0_INTR_STAT_r_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC0_INTR_STAT_r_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_INTR_STAT_get_r_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_INTR_STAT_r_rd_req_shift                                             (5)
+#define ISO_IC0_INTR_STAT_r_rd_req_mask                                              (0x00000020)
+#define ISO_IC0_INTR_STAT_r_rd_req(data)                                             (0x00000020&((data)<<5))
+#define ISO_IC0_INTR_STAT_r_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC0_INTR_STAT_get_r_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC0_INTR_STAT_r_tx_empty_shift                                           (4)
+#define ISO_IC0_INTR_STAT_r_tx_empty_mask                                            (0x00000010)
+#define ISO_IC0_INTR_STAT_r_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define ISO_IC0_INTR_STAT_r_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC0_INTR_STAT_get_r_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC0_INTR_STAT_r_tx_over_shift                                            (3)
+#define ISO_IC0_INTR_STAT_r_tx_over_mask                                             (0x00000008)
+#define ISO_IC0_INTR_STAT_r_tx_over(data)                                            (0x00000008&((data)<<3))
+#define ISO_IC0_INTR_STAT_r_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC0_INTR_STAT_get_r_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC0_INTR_STAT_r_rx_full_shift                                            (2)
+#define ISO_IC0_INTR_STAT_r_rx_full_mask                                             (0x00000004)
+#define ISO_IC0_INTR_STAT_r_rx_full(data)                                            (0x00000004&((data)<<2))
+#define ISO_IC0_INTR_STAT_r_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC0_INTR_STAT_get_r_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC0_INTR_STAT_r_rx_over_shift                                            (1)
+#define ISO_IC0_INTR_STAT_r_rx_over_mask                                             (0x00000002)
+#define ISO_IC0_INTR_STAT_r_rx_over(data)                                            (0x00000002&((data)<<1))
+#define ISO_IC0_INTR_STAT_r_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC0_INTR_STAT_get_r_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC0_INTR_STAT_r_rx_under_shift                                           (0)
+#define ISO_IC0_INTR_STAT_r_rx_under_mask                                            (0x00000001)
+#define ISO_IC0_INTR_STAT_r_rx_under(data)                                           (0x00000001&((data)<<0))
+#define ISO_IC0_INTR_STAT_r_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_IC0_INTR_STAT_get_r_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_INTR_MASK                                                            0x98007D30
+#define ISO_IC0_INTR_MASK_reg_addr                                                   "0xD8007D30"
+#define ISO_IC0_INTR_MASK_reg                                                        0xD8007D30
+#define set_ISO_IC0_INTR_MASK_reg(data)   (*((volatile unsigned int*) ISO_IC0_INTR_MASK_reg)=data)
+#define get_ISO_IC0_INTR_MASK_reg   (*((volatile unsigned int*) ISO_IC0_INTR_MASK_reg))
+#define ISO_IC0_INTR_MASK_inst_adr                                                   "0x004C"
+#define ISO_IC0_INTR_MASK_inst                                                       0x004C
+#define ISO_IC0_INTR_MASK_m_gen_call_shift                                           (11)
+#define ISO_IC0_INTR_MASK_m_gen_call_mask                                            (0x00000800)
+#define ISO_IC0_INTR_MASK_m_gen_call(data)                                           (0x00000800&((data)<<11))
+#define ISO_IC0_INTR_MASK_m_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC0_INTR_MASK_get_m_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC0_INTR_MASK_m_start_det_shift                                          (10)
+#define ISO_IC0_INTR_MASK_m_start_det_mask                                           (0x00000400)
+#define ISO_IC0_INTR_MASK_m_start_det(data)                                          (0x00000400&((data)<<10))
+#define ISO_IC0_INTR_MASK_m_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC0_INTR_MASK_get_m_start_det(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC0_INTR_MASK_m_stop_det_shift                                           (9)
+#define ISO_IC0_INTR_MASK_m_stop_det_mask                                            (0x00000200)
+#define ISO_IC0_INTR_MASK_m_stop_det(data)                                           (0x00000200&((data)<<9))
+#define ISO_IC0_INTR_MASK_m_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC0_INTR_MASK_get_m_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC0_INTR_MASK_m_activity_shift                                           (8)
+#define ISO_IC0_INTR_MASK_m_activity_mask                                            (0x00000100)
+#define ISO_IC0_INTR_MASK_m_activity(data)                                           (0x00000100&((data)<<8))
+#define ISO_IC0_INTR_MASK_m_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC0_INTR_MASK_get_m_activity(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC0_INTR_MASK_m_rx_done_shift                                            (7)
+#define ISO_IC0_INTR_MASK_m_rx_done_mask                                             (0x00000080)
+#define ISO_IC0_INTR_MASK_m_rx_done(data)                                            (0x00000080&((data)<<7))
+#define ISO_IC0_INTR_MASK_m_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC0_INTR_MASK_get_m_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC0_INTR_MASK_m_tx_abrt_shift                                            (6)
+#define ISO_IC0_INTR_MASK_m_tx_abrt_mask                                             (0x00000040)
+#define ISO_IC0_INTR_MASK_m_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC0_INTR_MASK_m_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_INTR_MASK_get_m_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_INTR_MASK_m_rd_req_shift                                             (5)
+#define ISO_IC0_INTR_MASK_m_rd_req_mask                                              (0x00000020)
+#define ISO_IC0_INTR_MASK_m_rd_req(data)                                             (0x00000020&((data)<<5))
+#define ISO_IC0_INTR_MASK_m_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC0_INTR_MASK_get_m_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC0_INTR_MASK_m_tx_empty_shift                                           (4)
+#define ISO_IC0_INTR_MASK_m_tx_empty_mask                                            (0x00000010)
+#define ISO_IC0_INTR_MASK_m_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define ISO_IC0_INTR_MASK_m_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC0_INTR_MASK_get_m_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC0_INTR_MASK_m_tx_over_shift                                            (3)
+#define ISO_IC0_INTR_MASK_m_tx_over_mask                                             (0x00000008)
+#define ISO_IC0_INTR_MASK_m_tx_over(data)                                            (0x00000008&((data)<<3))
+#define ISO_IC0_INTR_MASK_m_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC0_INTR_MASK_get_m_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC0_INTR_MASK_m_rx_full_shift                                            (2)
+#define ISO_IC0_INTR_MASK_m_rx_full_mask                                             (0x00000004)
+#define ISO_IC0_INTR_MASK_m_rx_full(data)                                            (0x00000004&((data)<<2))
+#define ISO_IC0_INTR_MASK_m_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC0_INTR_MASK_get_m_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC0_INTR_MASK_m_rx_over_shift                                            (1)
+#define ISO_IC0_INTR_MASK_m_rx_over_mask                                             (0x00000002)
+#define ISO_IC0_INTR_MASK_m_rx_over(data)                                            (0x00000002&((data)<<1))
+#define ISO_IC0_INTR_MASK_m_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC0_INTR_MASK_get_m_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC0_INTR_MASK_m_rx_under_shift                                           (0)
+#define ISO_IC0_INTR_MASK_m_rx_under_mask                                            (0x00000001)
+#define ISO_IC0_INTR_MASK_m_rx_under(data)                                           (0x00000001&((data)<<0))
+#define ISO_IC0_INTR_MASK_m_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_IC0_INTR_MASK_get_m_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_RAW_INTR_STAT                                                        0x98007D34
+#define ISO_IC0_RAW_INTR_STAT_reg_addr                                               "0xD8007D34"
+#define ISO_IC0_RAW_INTR_STAT_reg                                                    0xD8007D34
+#define set_ISO_IC0_RAW_INTR_STAT_reg(data)   (*((volatile unsigned int*) ISO_IC0_RAW_INTR_STAT_reg)=data)
+#define get_ISO_IC0_RAW_INTR_STAT_reg   (*((volatile unsigned int*) ISO_IC0_RAW_INTR_STAT_reg))
+#define ISO_IC0_RAW_INTR_STAT_inst_adr                                               "0x004D"
+#define ISO_IC0_RAW_INTR_STAT_inst                                                   0x004D
+#define ISO_IC0_RAW_INTR_STAT_gen_call_shift                                         (11)
+#define ISO_IC0_RAW_INTR_STAT_gen_call_mask                                          (0x00000800)
+#define ISO_IC0_RAW_INTR_STAT_gen_call(data)                                         (0x00000800&((data)<<11))
+#define ISO_IC0_RAW_INTR_STAT_gen_call_src(data)                                     ((0x00000800&(data))>>11)
+#define ISO_IC0_RAW_INTR_STAT_get_gen_call(data)                                     ((0x00000800&(data))>>11)
+#define ISO_IC0_RAW_INTR_STAT_start_det_shift                                        (10)
+#define ISO_IC0_RAW_INTR_STAT_start_det_mask                                         (0x00000400)
+#define ISO_IC0_RAW_INTR_STAT_start_det(data)                                        (0x00000400&((data)<<10))
+#define ISO_IC0_RAW_INTR_STAT_start_det_src(data)                                    ((0x00000400&(data))>>10)
+#define ISO_IC0_RAW_INTR_STAT_get_start_det(data)                                    ((0x00000400&(data))>>10)
+#define ISO_IC0_RAW_INTR_STAT_stop_det_shift                                         (9)
+#define ISO_IC0_RAW_INTR_STAT_stop_det_mask                                          (0x00000200)
+#define ISO_IC0_RAW_INTR_STAT_stop_det(data)                                         (0x00000200&((data)<<9))
+#define ISO_IC0_RAW_INTR_STAT_stop_det_src(data)                                     ((0x00000200&(data))>>9)
+#define ISO_IC0_RAW_INTR_STAT_get_stop_det(data)                                     ((0x00000200&(data))>>9)
+#define ISO_IC0_RAW_INTR_STAT_activity_shift                                         (8)
+#define ISO_IC0_RAW_INTR_STAT_activity_mask                                          (0x00000100)
+#define ISO_IC0_RAW_INTR_STAT_activity(data)                                         (0x00000100&((data)<<8))
+#define ISO_IC0_RAW_INTR_STAT_activity_src(data)                                     ((0x00000100&(data))>>8)
+#define ISO_IC0_RAW_INTR_STAT_get_activity(data)                                     ((0x00000100&(data))>>8)
+#define ISO_IC0_RAW_INTR_STAT_rx_done_shift                                          (7)
+#define ISO_IC0_RAW_INTR_STAT_rx_done_mask                                           (0x00000080)
+#define ISO_IC0_RAW_INTR_STAT_rx_done(data)                                          (0x00000080&((data)<<7))
+#define ISO_IC0_RAW_INTR_STAT_rx_done_src(data)                                      ((0x00000080&(data))>>7)
+#define ISO_IC0_RAW_INTR_STAT_get_rx_done(data)                                      ((0x00000080&(data))>>7)
+#define ISO_IC0_RAW_INTR_STAT_tx_abrt_shift                                          (6)
+#define ISO_IC0_RAW_INTR_STAT_tx_abrt_mask                                           (0x00000040)
+#define ISO_IC0_RAW_INTR_STAT_tx_abrt(data)                                          (0x00000040&((data)<<6))
+#define ISO_IC0_RAW_INTR_STAT_tx_abrt_src(data)                                      ((0x00000040&(data))>>6)
+#define ISO_IC0_RAW_INTR_STAT_get_tx_abrt(data)                                      ((0x00000040&(data))>>6)
+#define ISO_IC0_RAW_INTR_STAT_rd_req_shift                                           (5)
+#define ISO_IC0_RAW_INTR_STAT_rd_req_mask                                            (0x00000020)
+#define ISO_IC0_RAW_INTR_STAT_rd_req(data)                                           (0x00000020&((data)<<5))
+#define ISO_IC0_RAW_INTR_STAT_rd_req_src(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC0_RAW_INTR_STAT_get_rd_req(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC0_RAW_INTR_STAT_tx_empty_shift                                         (4)
+#define ISO_IC0_RAW_INTR_STAT_tx_empty_mask                                          (0x00000010)
+#define ISO_IC0_RAW_INTR_STAT_tx_empty(data)                                         (0x00000010&((data)<<4))
+#define ISO_IC0_RAW_INTR_STAT_tx_empty_src(data)                                     ((0x00000010&(data))>>4)
+#define ISO_IC0_RAW_INTR_STAT_get_tx_empty(data)                                     ((0x00000010&(data))>>4)
+#define ISO_IC0_RAW_INTR_STAT_tx_over_shift                                          (3)
+#define ISO_IC0_RAW_INTR_STAT_tx_over_mask                                           (0x00000008)
+#define ISO_IC0_RAW_INTR_STAT_tx_over(data)                                          (0x00000008&((data)<<3))
+#define ISO_IC0_RAW_INTR_STAT_tx_over_src(data)                                      ((0x00000008&(data))>>3)
+#define ISO_IC0_RAW_INTR_STAT_get_tx_over(data)                                      ((0x00000008&(data))>>3)
+#define ISO_IC0_RAW_INTR_STAT_rx_full_shift                                          (2)
+#define ISO_IC0_RAW_INTR_STAT_rx_full_mask                                           (0x00000004)
+#define ISO_IC0_RAW_INTR_STAT_rx_full(data)                                          (0x00000004&((data)<<2))
+#define ISO_IC0_RAW_INTR_STAT_rx_full_src(data)                                      ((0x00000004&(data))>>2)
+#define ISO_IC0_RAW_INTR_STAT_get_rx_full(data)                                      ((0x00000004&(data))>>2)
+#define ISO_IC0_RAW_INTR_STAT_rx_over_shift                                          (1)
+#define ISO_IC0_RAW_INTR_STAT_rx_over_mask                                           (0x00000002)
+#define ISO_IC0_RAW_INTR_STAT_rx_over(data)                                          (0x00000002&((data)<<1))
+#define ISO_IC0_RAW_INTR_STAT_rx_over_src(data)                                      ((0x00000002&(data))>>1)
+#define ISO_IC0_RAW_INTR_STAT_get_rx_over(data)                                      ((0x00000002&(data))>>1)
+#define ISO_IC0_RAW_INTR_STAT_rx_under_shift                                         (0)
+#define ISO_IC0_RAW_INTR_STAT_rx_under_mask                                          (0x00000001)
+#define ISO_IC0_RAW_INTR_STAT_rx_under(data)                                         (0x00000001&((data)<<0))
+#define ISO_IC0_RAW_INTR_STAT_rx_under_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_IC0_RAW_INTR_STAT_get_rx_under(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_RX_TL                                                                0x98007D38
+#define ISO_IC0_RX_TL_reg_addr                                                       "0xD8007D38"
+#define ISO_IC0_RX_TL_reg                                                            0xD8007D38
+#define set_ISO_IC0_RX_TL_reg(data)   (*((volatile unsigned int*) ISO_IC0_RX_TL_reg)=data)
+#define get_ISO_IC0_RX_TL_reg   (*((volatile unsigned int*) ISO_IC0_RX_TL_reg))
+#define ISO_IC0_RX_TL_inst_adr                                                       "0x004E"
+#define ISO_IC0_RX_TL_inst                                                           0x004E
+#define ISO_IC0_RX_TL_rx_tl_shift                                                    (0)
+#define ISO_IC0_RX_TL_rx_tl_mask                                                     (0x000000FF)
+#define ISO_IC0_RX_TL_rx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_IC0_RX_TL_rx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_IC0_RX_TL_get_rx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC0_TX_TL                                                                0x98007D3C
+#define ISO_IC0_TX_TL_reg_addr                                                       "0xD8007D3C"
+#define ISO_IC0_TX_TL_reg                                                            0xD8007D3C
+#define set_ISO_IC0_TX_TL_reg(data)   (*((volatile unsigned int*) ISO_IC0_TX_TL_reg)=data)
+#define get_ISO_IC0_TX_TL_reg   (*((volatile unsigned int*) ISO_IC0_TX_TL_reg))
+#define ISO_IC0_TX_TL_inst_adr                                                       "0x004F"
+#define ISO_IC0_TX_TL_inst                                                           0x004F
+#define ISO_IC0_TX_TL_tx_tl_shift                                                    (0)
+#define ISO_IC0_TX_TL_tx_tl_mask                                                     (0x000000FF)
+#define ISO_IC0_TX_TL_tx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_IC0_TX_TL_tx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_IC0_TX_TL_get_tx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC0_CLR_INTR                                                             0x98007D40
+#define ISO_IC0_CLR_INTR_reg_addr                                                    "0xD8007D40"
+#define ISO_IC0_CLR_INTR_reg                                                         0xD8007D40
+#define set_ISO_IC0_CLR_INTR_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_INTR_reg)=data)
+#define get_ISO_IC0_CLR_INTR_reg   (*((volatile unsigned int*) ISO_IC0_CLR_INTR_reg))
+#define ISO_IC0_CLR_INTR_inst_adr                                                    "0x0050"
+#define ISO_IC0_CLR_INTR_inst                                                        0x0050
+#define ISO_IC0_CLR_INTR_clr_intr_shift                                              (0)
+#define ISO_IC0_CLR_INTR_clr_intr_mask                                               (0x00000001)
+#define ISO_IC0_CLR_INTR_clr_intr(data)                                              (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_INTR_clr_intr_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_INTR_get_clr_intr(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_RX_UNDER                                                         0x98007D44
+#define ISO_IC0_CLR_RX_UNDER_reg_addr                                                "0xD8007D44"
+#define ISO_IC0_CLR_RX_UNDER_reg                                                     0xD8007D44
+#define set_ISO_IC0_CLR_RX_UNDER_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_RX_UNDER_reg)=data)
+#define get_ISO_IC0_CLR_RX_UNDER_reg   (*((volatile unsigned int*) ISO_IC0_CLR_RX_UNDER_reg))
+#define ISO_IC0_CLR_RX_UNDER_inst_adr                                                "0x0051"
+#define ISO_IC0_CLR_RX_UNDER_inst                                                    0x0051
+#define ISO_IC0_CLR_RX_UNDER_clr_rx_under_shift                                      (0)
+#define ISO_IC0_CLR_RX_UNDER_clr_rx_under_mask                                       (0x00000001)
+#define ISO_IC0_CLR_RX_UNDER_clr_rx_under(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_RX_UNDER_clr_rx_under_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_RX_UNDER_get_clr_rx_under(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_RX_OVER                                                          0x98007D48
+#define ISO_IC0_CLR_RX_OVER_reg_addr                                                 "0xD8007D48"
+#define ISO_IC0_CLR_RX_OVER_reg                                                      0xD8007D48
+#define set_ISO_IC0_CLR_RX_OVER_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_RX_OVER_reg)=data)
+#define get_ISO_IC0_CLR_RX_OVER_reg   (*((volatile unsigned int*) ISO_IC0_CLR_RX_OVER_reg))
+#define ISO_IC0_CLR_RX_OVER_inst_adr                                                 "0x0052"
+#define ISO_IC0_CLR_RX_OVER_inst                                                     0x0052
+#define ISO_IC0_CLR_RX_OVER_clr_rx_over_shift                                        (0)
+#define ISO_IC0_CLR_RX_OVER_clr_rx_over_mask                                         (0x00000001)
+#define ISO_IC0_CLR_RX_OVER_clr_rx_over(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_RX_OVER_clr_rx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_RX_OVER_get_clr_rx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_TX_OVER                                                          0x98007D4C
+#define ISO_IC0_CLR_TX_OVER_reg_addr                                                 "0xD8007D4C"
+#define ISO_IC0_CLR_TX_OVER_reg                                                      0xD8007D4C
+#define set_ISO_IC0_CLR_TX_OVER_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_TX_OVER_reg)=data)
+#define get_ISO_IC0_CLR_TX_OVER_reg   (*((volatile unsigned int*) ISO_IC0_CLR_TX_OVER_reg))
+#define ISO_IC0_CLR_TX_OVER_inst_adr                                                 "0x0053"
+#define ISO_IC0_CLR_TX_OVER_inst                                                     0x0053
+#define ISO_IC0_CLR_TX_OVER_clr_tx_over_shift                                        (0)
+#define ISO_IC0_CLR_TX_OVER_clr_tx_over_mask                                         (0x00000001)
+#define ISO_IC0_CLR_TX_OVER_clr_tx_over(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_TX_OVER_clr_tx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_TX_OVER_get_clr_tx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_RD_REQ                                                           0x98007D50
+#define ISO_IC0_CLR_RD_REQ_reg_addr                                                  "0xD8007D50"
+#define ISO_IC0_CLR_RD_REQ_reg                                                       0xD8007D50
+#define set_ISO_IC0_CLR_RD_REQ_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_RD_REQ_reg)=data)
+#define get_ISO_IC0_CLR_RD_REQ_reg   (*((volatile unsigned int*) ISO_IC0_CLR_RD_REQ_reg))
+#define ISO_IC0_CLR_RD_REQ_inst_adr                                                  "0x0054"
+#define ISO_IC0_CLR_RD_REQ_inst                                                      0x0054
+#define ISO_IC0_CLR_RD_REQ_clr_rd_req_shift                                          (0)
+#define ISO_IC0_CLR_RD_REQ_clr_rd_req_mask                                           (0x00000001)
+#define ISO_IC0_CLR_RD_REQ_clr_rd_req(data)                                          (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_RD_REQ_clr_rd_req_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_RD_REQ_get_clr_rd_req(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_TX_ABRT                                                          0x98007D54
+#define ISO_IC0_CLR_TX_ABRT_reg_addr                                                 "0xD8007D54"
+#define ISO_IC0_CLR_TX_ABRT_reg                                                      0xD8007D54
+#define set_ISO_IC0_CLR_TX_ABRT_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_TX_ABRT_reg)=data)
+#define get_ISO_IC0_CLR_TX_ABRT_reg   (*((volatile unsigned int*) ISO_IC0_CLR_TX_ABRT_reg))
+#define ISO_IC0_CLR_TX_ABRT_inst_adr                                                 "0x0055"
+#define ISO_IC0_CLR_TX_ABRT_inst                                                     0x0055
+#define ISO_IC0_CLR_TX_ABRT_clr_tx_abrt_shift                                        (0)
+#define ISO_IC0_CLR_TX_ABRT_clr_tx_abrt_mask                                         (0x00000001)
+#define ISO_IC0_CLR_TX_ABRT_clr_tx_abrt(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_TX_ABRT_clr_tx_abrt_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_TX_ABRT_get_clr_tx_abrt(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_RX_DONE                                                          0x98007D58
+#define ISO_IC0_CLR_RX_DONE_reg_addr                                                 "0xD8007D58"
+#define ISO_IC0_CLR_RX_DONE_reg                                                      0xD8007D58
+#define set_ISO_IC0_CLR_RX_DONE_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_RX_DONE_reg)=data)
+#define get_ISO_IC0_CLR_RX_DONE_reg   (*((volatile unsigned int*) ISO_IC0_CLR_RX_DONE_reg))
+#define ISO_IC0_CLR_RX_DONE_inst_adr                                                 "0x0056"
+#define ISO_IC0_CLR_RX_DONE_inst                                                     0x0056
+#define ISO_IC0_CLR_RX_DONE_clr_rx_done_shift                                        (0)
+#define ISO_IC0_CLR_RX_DONE_clr_rx_done_mask                                         (0x00000001)
+#define ISO_IC0_CLR_RX_DONE_clr_rx_done(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_RX_DONE_clr_rx_done_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_RX_DONE_get_clr_rx_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_ACTIVITY                                                         0x98007D5C
+#define ISO_IC0_CLR_ACTIVITY_reg_addr                                                "0xD8007D5C"
+#define ISO_IC0_CLR_ACTIVITY_reg                                                     0xD8007D5C
+#define set_ISO_IC0_CLR_ACTIVITY_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_ACTIVITY_reg)=data)
+#define get_ISO_IC0_CLR_ACTIVITY_reg   (*((volatile unsigned int*) ISO_IC0_CLR_ACTIVITY_reg))
+#define ISO_IC0_CLR_ACTIVITY_inst_adr                                                "0x0057"
+#define ISO_IC0_CLR_ACTIVITY_inst                                                    0x0057
+#define ISO_IC0_CLR_ACTIVITY_clr_activity_shift                                      (0)
+#define ISO_IC0_CLR_ACTIVITY_clr_activity_mask                                       (0x00000001)
+#define ISO_IC0_CLR_ACTIVITY_clr_activity(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_ACTIVITY_clr_activity_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_ACTIVITY_get_clr_activity(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_STOP_DET                                                         0x98007D60
+#define ISO_IC0_CLR_STOP_DET_reg_addr                                                "0xD8007D60"
+#define ISO_IC0_CLR_STOP_DET_reg                                                     0xD8007D60
+#define set_ISO_IC0_CLR_STOP_DET_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_STOP_DET_reg)=data)
+#define get_ISO_IC0_CLR_STOP_DET_reg   (*((volatile unsigned int*) ISO_IC0_CLR_STOP_DET_reg))
+#define ISO_IC0_CLR_STOP_DET_inst_adr                                                "0x0058"
+#define ISO_IC0_CLR_STOP_DET_inst                                                    0x0058
+#define ISO_IC0_CLR_STOP_DET_clr_stop_det_shift                                      (0)
+#define ISO_IC0_CLR_STOP_DET_clr_stop_det_mask                                       (0x00000001)
+#define ISO_IC0_CLR_STOP_DET_clr_stop_det(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_STOP_DET_clr_stop_det_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_STOP_DET_get_clr_stop_det(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_START_DET                                                        0x98007D64
+#define ISO_IC0_CLR_START_DET_reg_addr                                               "0xD8007D64"
+#define ISO_IC0_CLR_START_DET_reg                                                    0xD8007D64
+#define set_ISO_IC0_CLR_START_DET_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_START_DET_reg)=data)
+#define get_ISO_IC0_CLR_START_DET_reg   (*((volatile unsigned int*) ISO_IC0_CLR_START_DET_reg))
+#define ISO_IC0_CLR_START_DET_inst_adr                                               "0x0059"
+#define ISO_IC0_CLR_START_DET_inst                                                   0x0059
+#define ISO_IC0_CLR_START_DET_clr_start_det_shift                                    (0)
+#define ISO_IC0_CLR_START_DET_clr_start_det_mask                                     (0x00000001)
+#define ISO_IC0_CLR_START_DET_clr_start_det(data)                                    (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_START_DET_clr_start_det_src(data)                                ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_START_DET_get_clr_start_det(data)                                ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_GEN_CALL                                                         0x98007D68
+#define ISO_IC0_CLR_GEN_CALL_reg_addr                                                "0xD8007D68"
+#define ISO_IC0_CLR_GEN_CALL_reg                                                     0xD8007D68
+#define set_ISO_IC0_CLR_GEN_CALL_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_GEN_CALL_reg)=data)
+#define get_ISO_IC0_CLR_GEN_CALL_reg   (*((volatile unsigned int*) ISO_IC0_CLR_GEN_CALL_reg))
+#define ISO_IC0_CLR_GEN_CALL_inst_adr                                                "0x005A"
+#define ISO_IC0_CLR_GEN_CALL_inst                                                    0x005A
+#define ISO_IC0_CLR_GEN_CALL_clr_gen_call_shift                                      (0)
+#define ISO_IC0_CLR_GEN_CALL_clr_gen_call_mask                                       (0x00000001)
+#define ISO_IC0_CLR_GEN_CALL_clr_gen_call(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_GEN_CALL_clr_gen_call_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_GEN_CALL_get_clr_gen_call(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_ENABLE                                                               0x98007D6C
+#define ISO_IC0_ENABLE_reg_addr                                                      "0xD8007D6C"
+#define ISO_IC0_ENABLE_reg                                                           0xD8007D6C
+#define set_ISO_IC0_ENABLE_reg(data)   (*((volatile unsigned int*) ISO_IC0_ENABLE_reg)=data)
+#define get_ISO_IC0_ENABLE_reg   (*((volatile unsigned int*) ISO_IC0_ENABLE_reg))
+#define ISO_IC0_ENABLE_inst_adr                                                      "0x005B"
+#define ISO_IC0_ENABLE_inst                                                          0x005B
+#define ISO_IC0_ENABLE_enable_shift                                                  (0)
+#define ISO_IC0_ENABLE_enable_mask                                                   (0x00000001)
+#define ISO_IC0_ENABLE_enable(data)                                                  (0x00000001&((data)<<0))
+#define ISO_IC0_ENABLE_enable_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_IC0_ENABLE_get_enable(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_STATUS                                                               0x98007D70
+#define ISO_IC0_STATUS_reg_addr                                                      "0xD8007D70"
+#define ISO_IC0_STATUS_reg                                                           0xD8007D70
+#define set_ISO_IC0_STATUS_reg(data)   (*((volatile unsigned int*) ISO_IC0_STATUS_reg)=data)
+#define get_ISO_IC0_STATUS_reg   (*((volatile unsigned int*) ISO_IC0_STATUS_reg))
+#define ISO_IC0_STATUS_inst_adr                                                      "0x005C"
+#define ISO_IC0_STATUS_inst                                                          0x005C
+#define ISO_IC0_STATUS_slv_activity_shift                                            (6)
+#define ISO_IC0_STATUS_slv_activity_mask                                             (0x00000040)
+#define ISO_IC0_STATUS_slv_activity(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC0_STATUS_slv_activity_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_STATUS_get_slv_activity(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_STATUS_mst_activity_shift                                            (5)
+#define ISO_IC0_STATUS_mst_activity_mask                                             (0x00000020)
+#define ISO_IC0_STATUS_mst_activity(data)                                            (0x00000020&((data)<<5))
+#define ISO_IC0_STATUS_mst_activity_src(data)                                        ((0x00000020&(data))>>5)
+#define ISO_IC0_STATUS_get_mst_activity(data)                                        ((0x00000020&(data))>>5)
+#define ISO_IC0_STATUS_rff_shift                                                     (4)
+#define ISO_IC0_STATUS_rff_mask                                                      (0x00000010)
+#define ISO_IC0_STATUS_rff(data)                                                     (0x00000010&((data)<<4))
+#define ISO_IC0_STATUS_rff_src(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IC0_STATUS_get_rff(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IC0_STATUS_rfne_shift                                                    (3)
+#define ISO_IC0_STATUS_rfne_mask                                                     (0x00000008)
+#define ISO_IC0_STATUS_rfne(data)                                                    (0x00000008&((data)<<3))
+#define ISO_IC0_STATUS_rfne_src(data)                                                ((0x00000008&(data))>>3)
+#define ISO_IC0_STATUS_get_rfne(data)                                                ((0x00000008&(data))>>3)
+#define ISO_IC0_STATUS_tfe_shift                                                     (2)
+#define ISO_IC0_STATUS_tfe_mask                                                      (0x00000004)
+#define ISO_IC0_STATUS_tfe(data)                                                     (0x00000004&((data)<<2))
+#define ISO_IC0_STATUS_tfe_src(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_IC0_STATUS_get_tfe(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_IC0_STATUS_tfnf_shift                                                    (1)
+#define ISO_IC0_STATUS_tfnf_mask                                                     (0x00000002)
+#define ISO_IC0_STATUS_tfnf(data)                                                    (0x00000002&((data)<<1))
+#define ISO_IC0_STATUS_tfnf_src(data)                                                ((0x00000002&(data))>>1)
+#define ISO_IC0_STATUS_get_tfnf(data)                                                ((0x00000002&(data))>>1)
+#define ISO_IC0_STATUS_activity_shift                                                (0)
+#define ISO_IC0_STATUS_activity_mask                                                 (0x00000001)
+#define ISO_IC0_STATUS_activity(data)                                                (0x00000001&((data)<<0))
+#define ISO_IC0_STATUS_activity_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_IC0_STATUS_get_activity(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_TXFLR                                                                0x98007D74
+#define ISO_IC0_TXFLR_reg_addr                                                       "0xD8007D74"
+#define ISO_IC0_TXFLR_reg                                                            0xD8007D74
+#define set_ISO_IC0_TXFLR_reg(data)   (*((volatile unsigned int*) ISO_IC0_TXFLR_reg)=data)
+#define get_ISO_IC0_TXFLR_reg   (*((volatile unsigned int*) ISO_IC0_TXFLR_reg))
+#define ISO_IC0_TXFLR_inst_adr                                                       "0x005D"
+#define ISO_IC0_TXFLR_inst                                                           0x005D
+#define ISO_IC0_TXFLR_txflr_shift                                                    (0)
+#define ISO_IC0_TXFLR_txflr_mask                                                     (0x0000000F)
+#define ISO_IC0_TXFLR_txflr(data)                                                    (0x0000000F&((data)<<0))
+#define ISO_IC0_TXFLR_txflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define ISO_IC0_TXFLR_get_txflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC0_RXFLR                                                                0x98007D78
+#define ISO_IC0_RXFLR_reg_addr                                                       "0xD8007D78"
+#define ISO_IC0_RXFLR_reg                                                            0xD8007D78
+#define set_ISO_IC0_RXFLR_reg(data)   (*((volatile unsigned int*) ISO_IC0_RXFLR_reg)=data)
+#define get_ISO_IC0_RXFLR_reg   (*((volatile unsigned int*) ISO_IC0_RXFLR_reg))
+#define ISO_IC0_RXFLR_inst_adr                                                       "0x005E"
+#define ISO_IC0_RXFLR_inst                                                           0x005E
+#define ISO_IC0_RXFLR_rxflr_shift                                                    (0)
+#define ISO_IC0_RXFLR_rxflr_mask                                                     (0x0000000F)
+#define ISO_IC0_RXFLR_rxflr(data)                                                    (0x0000000F&((data)<<0))
+#define ISO_IC0_RXFLR_rxflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define ISO_IC0_RXFLR_get_rxflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC0_SDA_HOLD                                                             0x98007D7C
+#define ISO_IC0_SDA_HOLD_reg_addr                                                    "0xD8007D7C"
+#define ISO_IC0_SDA_HOLD_reg                                                         0xD8007D7C
+#define set_ISO_IC0_SDA_HOLD_reg(data)   (*((volatile unsigned int*) ISO_IC0_SDA_HOLD_reg)=data)
+#define get_ISO_IC0_SDA_HOLD_reg   (*((volatile unsigned int*) ISO_IC0_SDA_HOLD_reg))
+#define ISO_IC0_SDA_HOLD_inst_adr                                                    "0x005F"
+#define ISO_IC0_SDA_HOLD_inst                                                        0x005F
+#define ISO_IC0_SDA_HOLD_ic_sda_hold_shift                                           (0)
+#define ISO_IC0_SDA_HOLD_ic_sda_hold_mask                                            (0x0000FFFF)
+#define ISO_IC0_SDA_HOLD_ic_sda_hold(data)                                           (0x0000FFFF&((data)<<0))
+#define ISO_IC0_SDA_HOLD_ic_sda_hold_src(data)                                       ((0x0000FFFF&(data))>>0)
+#define ISO_IC0_SDA_HOLD_get_ic_sda_hold(data)                                       ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC0_TX_ABRT_SOURCE                                                       0x98007D80
+#define ISO_IC0_TX_ABRT_SOURCE_reg_addr                                              "0xD8007D80"
+#define ISO_IC0_TX_ABRT_SOURCE_reg                                                   0xD8007D80
+#define set_ISO_IC0_TX_ABRT_SOURCE_reg(data)   (*((volatile unsigned int*) ISO_IC0_TX_ABRT_SOURCE_reg)=data)
+#define get_ISO_IC0_TX_ABRT_SOURCE_reg   (*((volatile unsigned int*) ISO_IC0_TX_ABRT_SOURCE_reg))
+#define ISO_IC0_TX_ABRT_SOURCE_inst_adr                                              "0x0060"
+#define ISO_IC0_TX_ABRT_SOURCE_inst                                                  0x0060
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvrd_intx_shift                                 (15)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvrd_intx_mask                                  (0x00008000)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvrd_intx(data)                                 (0x00008000&((data)<<15))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvrd_intx_src(data)                             ((0x00008000&(data))>>15)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_slvrd_intx(data)                             ((0x00008000&(data))>>15)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slv_arblost_shift                                (14)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slv_arblost_mask                                 (0x00004000)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slv_arblost(data)                                (0x00004000&((data)<<14))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slv_arblost_src(data)                            ((0x00004000&(data))>>14)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_slv_arblost(data)                            ((0x00004000&(data))>>14)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvflush_txfifo_shift                            (13)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvflush_txfifo_mask                             (0x00002000)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvflush_txfifo(data)                            (0x00002000&((data)<<13))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvflush_txfifo_src(data)                        ((0x00002000&(data))>>13)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_slvflush_txfifo(data)                        ((0x00002000&(data))>>13)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_lost_shift                                        (12)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_lost_mask                                         (0x00001000)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_lost(data)                                        (0x00001000&((data)<<12))
+#define ISO_IC0_TX_ABRT_SOURCE_arb_lost_src(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC0_TX_ABRT_SOURCE_get_arb_lost(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_master_dis_shift                                  (11)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_master_dis_mask                                   (0x00000800)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_master_dis(data)                                  (0x00000800&((data)<<11))
+#define ISO_IC0_TX_ABRT_SOURCE_arb_master_dis_src(data)                              ((0x00000800&(data))>>11)
+#define ISO_IC0_TX_ABRT_SOURCE_get_arb_master_dis(data)                              ((0x00000800&(data))>>11)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_shift                             (10)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_mask                              (0x00000400)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10b_rd_norstrt(data)                             (0x00000400&((data)<<10))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_src(data)                         ((0x00000400&(data))>>10)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_10b_rd_norstrt(data)                         ((0x00000400&(data))>>10)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_norstrt_shift                              (9)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_norstrt_mask                               (0x00000200)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_norstrt(data)                              (0x00000200&((data)<<9))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_norstrt_src(data)                          ((0x00000200&(data))>>9)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_sbyte_norstrt(data)                          ((0x00000200&(data))>>9)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_norstrt_shift                                 (8)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_norstrt_mask                                  (0x00000100)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_norstrt(data)                                 (0x00000100&((data)<<8))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_norstrt_src(data)                             ((0x00000100&(data))>>8)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_hs_norstrt(data)                             ((0x00000100&(data))>>8)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_ackdet_shift                               (7)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_ackdet_mask                                (0x00000080)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_ackdet(data)                               (0x00000080&((data)<<7))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_ackdet_src(data)                           ((0x00000080&(data))>>7)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_sbyte_ackdet(data)                           ((0x00000080&(data))>>7)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_ackdet_shift                                  (6)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_ackdet_mask                                   (0x00000040)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_ackdet(data)                                  (0x00000040&((data)<<6))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_ackdet_src(data)                              ((0x00000040&(data))>>6)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_hs_ackdet(data)                              ((0x00000040&(data))>>6)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_read_shift                                 (5)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_read_mask                                  (0x00000020)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_read(data)                                 (0x00000020&((data)<<5))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_read_src(data)                             ((0x00000020&(data))>>5)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_gcall_read(data)                             ((0x00000020&(data))>>5)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_noack_shift                                (4)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_noack_mask                                 (0x00000010)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_noack(data)                                (0x00000010&((data)<<4))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_noack_src(data)                            ((0x00000010&(data))>>4)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_gcall_noack(data)                            ((0x00000010&(data))>>4)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_txdata_noack_shift                               (3)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_txdata_noack_mask                                (0x00000008)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_txdata_noack(data)                               (0x00000008&((data)<<3))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_txdata_noack_src(data)                           ((0x00000008&(data))>>3)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_txdata_noack(data)                           ((0x00000008&(data))>>3)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr2_noack_shift                              (2)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr2_noack_mask                               (0x00000004)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr2_noack(data)                              (0x00000004&((data)<<2))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr2_noack_src(data)                          ((0x00000004&(data))>>2)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_10addr2_noack(data)                          ((0x00000004&(data))>>2)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr1_noack_shift                              (1)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr1_noack_mask                               (0x00000002)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr1_noack(data)                              (0x00000002&((data)<<1))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr1_noack_src(data)                          ((0x00000002&(data))>>1)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_10addr1_noack(data)                          ((0x00000002&(data))>>1)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_7b_addr_noack_shift                              (0)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_7b_addr_noack_mask                               (0x00000001)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_7b_addr_noack(data)                              (0x00000001&((data)<<0))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_7b_addr_noack_src(data)                          ((0x00000001&(data))>>0)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_7b_addr_noack(data)                          ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_SLV_DATA_NACK_ONLY                                                   0x98007D84
+#define ISO_IC0_SLV_DATA_NACK_ONLY_reg_addr                                          "0xD8007D84"
+#define ISO_IC0_SLV_DATA_NACK_ONLY_reg                                               0xD8007D84
+#define set_ISO_IC0_SLV_DATA_NACK_ONLY_reg(data)   (*((volatile unsigned int*) ISO_IC0_SLV_DATA_NACK_ONLY_reg)=data)
+#define get_ISO_IC0_SLV_DATA_NACK_ONLY_reg   (*((volatile unsigned int*) ISO_IC0_SLV_DATA_NACK_ONLY_reg))
+#define ISO_IC0_SLV_DATA_NACK_ONLY_inst_adr                                          "0x0061"
+#define ISO_IC0_SLV_DATA_NACK_ONLY_inst                                              0x0061
+#define ISO_IC0_SLV_DATA_NACK_ONLY_nack_shift                                        (0)
+#define ISO_IC0_SLV_DATA_NACK_ONLY_nack_mask                                         (0x00000001)
+#define ISO_IC0_SLV_DATA_NACK_ONLY_nack(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC0_SLV_DATA_NACK_ONLY_nack_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC0_SLV_DATA_NACK_ONLY_get_nack(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_DMA_CR                                                               0x98007D88
+#define ISO_IC0_DMA_CR_reg_addr                                                      "0xD8007D88"
+#define ISO_IC0_DMA_CR_reg                                                           0xD8007D88
+#define set_ISO_IC0_DMA_CR_reg(data)   (*((volatile unsigned int*) ISO_IC0_DMA_CR_reg)=data)
+#define get_ISO_IC0_DMA_CR_reg   (*((volatile unsigned int*) ISO_IC0_DMA_CR_reg))
+#define ISO_IC0_DMA_CR_inst_adr                                                      "0x0062"
+#define ISO_IC0_DMA_CR_inst                                                          0x0062
+#define ISO_IC0_DMA_CR_tdmae_shift                                                   (1)
+#define ISO_IC0_DMA_CR_tdmae_mask                                                    (0x00000002)
+#define ISO_IC0_DMA_CR_tdmae(data)                                                   (0x00000002&((data)<<1))
+#define ISO_IC0_DMA_CR_tdmae_src(data)                                               ((0x00000002&(data))>>1)
+#define ISO_IC0_DMA_CR_get_tdmae(data)                                               ((0x00000002&(data))>>1)
+#define ISO_IC0_DMA_CR_rdmae_shift                                                   (0)
+#define ISO_IC0_DMA_CR_rdmae_mask                                                    (0x00000001)
+#define ISO_IC0_DMA_CR_rdmae(data)                                                   (0x00000001&((data)<<0))
+#define ISO_IC0_DMA_CR_rdmae_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_IC0_DMA_CR_get_rdmae(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_DMA_TDLR                                                             0x98007D8C
+#define ISO_IC0_DMA_TDLR_reg_addr                                                    "0xD8007D8C"
+#define ISO_IC0_DMA_TDLR_reg                                                         0xD8007D8C
+#define set_ISO_IC0_DMA_TDLR_reg(data)   (*((volatile unsigned int*) ISO_IC0_DMA_TDLR_reg)=data)
+#define get_ISO_IC0_DMA_TDLR_reg   (*((volatile unsigned int*) ISO_IC0_DMA_TDLR_reg))
+#define ISO_IC0_DMA_TDLR_inst_adr                                                    "0x0063"
+#define ISO_IC0_DMA_TDLR_inst                                                        0x0063
+#define ISO_IC0_DMA_TDLR_dmatdl_shift                                                (0)
+#define ISO_IC0_DMA_TDLR_dmatdl_mask                                                 (0x00000007)
+#define ISO_IC0_DMA_TDLR_dmatdl(data)                                                (0x00000007&((data)<<0))
+#define ISO_IC0_DMA_TDLR_dmatdl_src(data)                                            ((0x00000007&(data))>>0)
+#define ISO_IC0_DMA_TDLR_get_dmatdl(data)                                            ((0x00000007&(data))>>0)
+
+
+#define ISO_IC0_DMA_RDLR                                                             0x98007D90
+#define ISO_IC0_DMA_RDLR_reg_addr                                                    "0xD8007D90"
+#define ISO_IC0_DMA_RDLR_reg                                                         0xD8007D90
+#define set_ISO_IC0_DMA_RDLR_reg(data)   (*((volatile unsigned int*) ISO_IC0_DMA_RDLR_reg)=data)
+#define get_ISO_IC0_DMA_RDLR_reg   (*((volatile unsigned int*) ISO_IC0_DMA_RDLR_reg))
+#define ISO_IC0_DMA_RDLR_inst_adr                                                    "0x0064"
+#define ISO_IC0_DMA_RDLR_inst                                                        0x0064
+#define ISO_IC0_DMA_RDLR_dmardl_shift                                                (0)
+#define ISO_IC0_DMA_RDLR_dmardl_mask                                                 (0x0000000F)
+#define ISO_IC0_DMA_RDLR_dmardl(data)                                                (0x0000000F&((data)<<0))
+#define ISO_IC0_DMA_RDLR_dmardl_src(data)                                            ((0x0000000F&(data))>>0)
+#define ISO_IC0_DMA_RDLR_get_dmardl(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC0_SDA_SETUP                                                            0x98007D94
+#define ISO_IC0_SDA_SETUP_reg_addr                                                   "0xD8007D94"
+#define ISO_IC0_SDA_SETUP_reg                                                        0xD8007D94
+#define set_ISO_IC0_SDA_SETUP_reg(data)   (*((volatile unsigned int*) ISO_IC0_SDA_SETUP_reg)=data)
+#define get_ISO_IC0_SDA_SETUP_reg   (*((volatile unsigned int*) ISO_IC0_SDA_SETUP_reg))
+#define ISO_IC0_SDA_SETUP_inst_adr                                                   "0x0065"
+#define ISO_IC0_SDA_SETUP_inst                                                       0x0065
+#define ISO_IC0_SDA_SETUP_sda_setup_shift                                            (0)
+#define ISO_IC0_SDA_SETUP_sda_setup_mask                                             (0x000000FF)
+#define ISO_IC0_SDA_SETUP_sda_setup(data)                                            (0x000000FF&((data)<<0))
+#define ISO_IC0_SDA_SETUP_sda_setup_src(data)                                        ((0x000000FF&(data))>>0)
+#define ISO_IC0_SDA_SETUP_get_sda_setup(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC0_ACK_GENERAL_CALL                                                     0x98007D98
+#define ISO_IC0_ACK_GENERAL_CALL_reg_addr                                            "0xD8007D98"
+#define ISO_IC0_ACK_GENERAL_CALL_reg                                                 0xD8007D98
+#define set_ISO_IC0_ACK_GENERAL_CALL_reg(data)   (*((volatile unsigned int*) ISO_IC0_ACK_GENERAL_CALL_reg)=data)
+#define get_ISO_IC0_ACK_GENERAL_CALL_reg   (*((volatile unsigned int*) ISO_IC0_ACK_GENERAL_CALL_reg))
+#define ISO_IC0_ACK_GENERAL_CALL_inst_adr                                            "0x0066"
+#define ISO_IC0_ACK_GENERAL_CALL_inst                                                0x0066
+#define ISO_IC0_ACK_GENERAL_CALL_ack_gen_call_shift                                  (0)
+#define ISO_IC0_ACK_GENERAL_CALL_ack_gen_call_mask                                   (0x00000001)
+#define ISO_IC0_ACK_GENERAL_CALL_ack_gen_call(data)                                  (0x00000001&((data)<<0))
+#define ISO_IC0_ACK_GENERAL_CALL_ack_gen_call_src(data)                              ((0x00000001&(data))>>0)
+#define ISO_IC0_ACK_GENERAL_CALL_get_ack_gen_call(data)                              ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_ENABLE_STATUS                                                        0x98007D9C
+#define ISO_IC0_ENABLE_STATUS_reg_addr                                               "0xD8007D9C"
+#define ISO_IC0_ENABLE_STATUS_reg                                                    0xD8007D9C
+#define set_ISO_IC0_ENABLE_STATUS_reg(data)   (*((volatile unsigned int*) ISO_IC0_ENABLE_STATUS_reg)=data)
+#define get_ISO_IC0_ENABLE_STATUS_reg   (*((volatile unsigned int*) ISO_IC0_ENABLE_STATUS_reg))
+#define ISO_IC0_ENABLE_STATUS_inst_adr                                               "0x0067"
+#define ISO_IC0_ENABLE_STATUS_inst                                                   0x0067
+#define ISO_IC0_ENABLE_STATUS_slv_rx_data_lost_shift                                 (2)
+#define ISO_IC0_ENABLE_STATUS_slv_rx_data_lost_mask                                  (0x00000004)
+#define ISO_IC0_ENABLE_STATUS_slv_rx_data_lost(data)                                 (0x00000004&((data)<<2))
+#define ISO_IC0_ENABLE_STATUS_slv_rx_data_lost_src(data)                             ((0x00000004&(data))>>2)
+#define ISO_IC0_ENABLE_STATUS_get_slv_rx_data_lost(data)                             ((0x00000004&(data))>>2)
+#define ISO_IC0_ENABLE_STATUS_slv_disabled_whi_shift                                 (1)
+#define ISO_IC0_ENABLE_STATUS_slv_disabled_whi_mask                                  (0x00000002)
+#define ISO_IC0_ENABLE_STATUS_slv_disabled_whi(data)                                 (0x00000002&((data)<<1))
+#define ISO_IC0_ENABLE_STATUS_slv_disabled_whi_src(data)                             ((0x00000002&(data))>>1)
+#define ISO_IC0_ENABLE_STATUS_get_slv_disabled_whi(data)                             ((0x00000002&(data))>>1)
+#define ISO_IC0_ENABLE_STATUS_ic_en_shift                                            (0)
+#define ISO_IC0_ENABLE_STATUS_ic_en_mask                                             (0x00000001)
+#define ISO_IC0_ENABLE_STATUS_ic_en(data)                                            (0x00000001&((data)<<0))
+#define ISO_IC0_ENABLE_STATUS_ic_en_src(data)                                        ((0x00000001&(data))>>0)
+#define ISO_IC0_ENABLE_STATUS_get_ic_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_COMP_PARAM_1                                                         0x98007DF4
+#define ISO_IC0_COMP_PARAM_1_reg_addr                                                "0xD8007DF4"
+#define ISO_IC0_COMP_PARAM_1_reg                                                     0xD8007DF4
+#define set_ISO_IC0_COMP_PARAM_1_reg(data)   (*((volatile unsigned int*) ISO_IC0_COMP_PARAM_1_reg)=data)
+#define get_ISO_IC0_COMP_PARAM_1_reg   (*((volatile unsigned int*) ISO_IC0_COMP_PARAM_1_reg))
+#define ISO_IC0_COMP_PARAM_1_inst_adr                                                "0x007D"
+#define ISO_IC0_COMP_PARAM_1_inst                                                    0x007D
+#define ISO_IC0_COMP_PARAM_1_tx_buffer_depth_shift                                   (16)
+#define ISO_IC0_COMP_PARAM_1_tx_buffer_depth_mask                                    (0x00FF0000)
+#define ISO_IC0_COMP_PARAM_1_tx_buffer_depth(data)                                   (0x00FF0000&((data)<<16))
+#define ISO_IC0_COMP_PARAM_1_tx_buffer_depth_src(data)                               ((0x00FF0000&(data))>>16)
+#define ISO_IC0_COMP_PARAM_1_get_tx_buffer_depth(data)                               ((0x00FF0000&(data))>>16)
+#define ISO_IC0_COMP_PARAM_1_rx_buffer_depth_shift                                   (8)
+#define ISO_IC0_COMP_PARAM_1_rx_buffer_depth_mask                                    (0x0000FF00)
+#define ISO_IC0_COMP_PARAM_1_rx_buffer_depth(data)                                   (0x0000FF00&((data)<<8))
+#define ISO_IC0_COMP_PARAM_1_rx_buffer_depth_src(data)                               ((0x0000FF00&(data))>>8)
+#define ISO_IC0_COMP_PARAM_1_get_rx_buffer_depth(data)                               ((0x0000FF00&(data))>>8)
+#define ISO_IC0_COMP_PARAM_1_add_encoded_params_shift                                (7)
+#define ISO_IC0_COMP_PARAM_1_add_encoded_params_mask                                 (0x00000080)
+#define ISO_IC0_COMP_PARAM_1_add_encoded_params(data)                                (0x00000080&((data)<<7))
+#define ISO_IC0_COMP_PARAM_1_add_encoded_params_src(data)                            ((0x00000080&(data))>>7)
+#define ISO_IC0_COMP_PARAM_1_get_add_encoded_params(data)                            ((0x00000080&(data))>>7)
+#define ISO_IC0_COMP_PARAM_1_has_dma_shift                                           (6)
+#define ISO_IC0_COMP_PARAM_1_has_dma_mask                                            (0x00000040)
+#define ISO_IC0_COMP_PARAM_1_has_dma(data)                                           (0x00000040&((data)<<6))
+#define ISO_IC0_COMP_PARAM_1_has_dma_src(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC0_COMP_PARAM_1_get_has_dma(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC0_COMP_PARAM_1_intr_io_shift                                           (5)
+#define ISO_IC0_COMP_PARAM_1_intr_io_mask                                            (0x00000020)
+#define ISO_IC0_COMP_PARAM_1_intr_io(data)                                           (0x00000020&((data)<<5))
+#define ISO_IC0_COMP_PARAM_1_intr_io_src(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC0_COMP_PARAM_1_get_intr_io(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC0_COMP_PARAM_1_hc_count_values_shift                                   (4)
+#define ISO_IC0_COMP_PARAM_1_hc_count_values_mask                                    (0x00000010)
+#define ISO_IC0_COMP_PARAM_1_hc_count_values(data)                                   (0x00000010&((data)<<4))
+#define ISO_IC0_COMP_PARAM_1_hc_count_values_src(data)                               ((0x00000010&(data))>>4)
+#define ISO_IC0_COMP_PARAM_1_get_hc_count_values(data)                               ((0x00000010&(data))>>4)
+#define ISO_IC0_COMP_PARAM_1_max_speed_mode_shift                                    (2)
+#define ISO_IC0_COMP_PARAM_1_max_speed_mode_mask                                     (0x0000000C)
+#define ISO_IC0_COMP_PARAM_1_max_speed_mode(data)                                    (0x0000000C&((data)<<2))
+#define ISO_IC0_COMP_PARAM_1_max_speed_mode_src(data)                                ((0x0000000C&(data))>>2)
+#define ISO_IC0_COMP_PARAM_1_get_max_speed_mode(data)                                ((0x0000000C&(data))>>2)
+#define ISO_IC0_COMP_PARAM_1_apb_data_width_shift                                    (0)
+#define ISO_IC0_COMP_PARAM_1_apb_data_width_mask                                     (0x00000003)
+#define ISO_IC0_COMP_PARAM_1_apb_data_width(data)                                    (0x00000003&((data)<<0))
+#define ISO_IC0_COMP_PARAM_1_apb_data_width_src(data)                                ((0x00000003&(data))>>0)
+#define ISO_IC0_COMP_PARAM_1_get_apb_data_width(data)                                ((0x00000003&(data))>>0)
+
+
+#define ISO_IC0_COMP_VERSION                                                         0x98007DF8
+#define ISO_IC0_COMP_VERSION_reg_addr                                                "0xD8007DF8"
+#define ISO_IC0_COMP_VERSION_reg                                                     0xD8007DF8
+#define set_ISO_IC0_COMP_VERSION_reg(data)   (*((volatile unsigned int*) ISO_IC0_COMP_VERSION_reg)=data)
+#define get_ISO_IC0_COMP_VERSION_reg   (*((volatile unsigned int*) ISO_IC0_COMP_VERSION_reg))
+#define ISO_IC0_COMP_VERSION_inst_adr                                                "0x007E"
+#define ISO_IC0_COMP_VERSION_inst                                                    0x007E
+#define ISO_IC0_COMP_VERSION_ic_comp_version_shift                                   (0)
+#define ISO_IC0_COMP_VERSION_ic_comp_version_mask                                    (0xFFFFFFFF)
+#define ISO_IC0_COMP_VERSION_ic_comp_version(data)                                   (0xFFFFFFFF&((data)<<0))
+#define ISO_IC0_COMP_VERSION_ic_comp_version_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define ISO_IC0_COMP_VERSION_get_ic_comp_version(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IC0_COMP_TYPE                                                            0x98007DFC
+#define ISO_IC0_COMP_TYPE_reg_addr                                                   "0xD8007DFC"
+#define ISO_IC0_COMP_TYPE_reg                                                        0xD8007DFC
+#define set_ISO_IC0_COMP_TYPE_reg(data)   (*((volatile unsigned int*) ISO_IC0_COMP_TYPE_reg)=data)
+#define get_ISO_IC0_COMP_TYPE_reg   (*((volatile unsigned int*) ISO_IC0_COMP_TYPE_reg))
+#define ISO_IC0_COMP_TYPE_inst_adr                                                   "0x007F"
+#define ISO_IC0_COMP_TYPE_inst                                                       0x007F
+#define ISO_IC0_COMP_TYPE_ic_comp_type_shift                                         (0)
+#define ISO_IC0_COMP_TYPE_ic_comp_type_mask                                          (0xFFFFFFFF)
+#define ISO_IC0_COMP_TYPE_ic_comp_type(data)                                         (0xFFFFFFFF&((data)<<0))
+#define ISO_IC0_COMP_TYPE_ic_comp_type_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define ISO_IC0_COMP_TYPE_get_ic_comp_type(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IC1_CON                                                                  0x98007C00
+#define ISO_IC1_CON_reg_addr                                                         "0xD8007C00"
+#define ISO_IC1_CON_reg                                                              0xD8007C00
+#define set_ISO_IC1_CON_reg(data)   (*((volatile unsigned int*) ISO_IC1_CON_reg)=data)
+#define get_ISO_IC1_CON_reg   (*((volatile unsigned int*) ISO_IC1_CON_reg))
+#define ISO_IC1_CON_inst_adr                                                         "0x0000"
+#define ISO_IC1_CON_inst                                                             0x0000
+#define ISO_IC1_CON_ic_slave_disable_shift                                           (6)
+#define ISO_IC1_CON_ic_slave_disable_mask                                            (0x00000040)
+#define ISO_IC1_CON_ic_slave_disable(data)                                           (0x00000040&((data)<<6))
+#define ISO_IC1_CON_ic_slave_disable_src(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC1_CON_get_ic_slave_disable(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC1_CON_ic_restart_en_shift                                              (5)
+#define ISO_IC1_CON_ic_restart_en_mask                                               (0x00000020)
+#define ISO_IC1_CON_ic_restart_en(data)                                              (0x00000020&((data)<<5))
+#define ISO_IC1_CON_ic_restart_en_src(data)                                          ((0x00000020&(data))>>5)
+#define ISO_IC1_CON_get_ic_restart_en(data)                                          ((0x00000020&(data))>>5)
+#define ISO_IC1_CON_ic_10bitaddr_master_shift                                        (4)
+#define ISO_IC1_CON_ic_10bitaddr_master_mask                                         (0x00000010)
+#define ISO_IC1_CON_ic_10bitaddr_master(data)                                        (0x00000010&((data)<<4))
+#define ISO_IC1_CON_ic_10bitaddr_master_src(data)                                    ((0x00000010&(data))>>4)
+#define ISO_IC1_CON_get_ic_10bitaddr_master(data)                                    ((0x00000010&(data))>>4)
+#define ISO_IC1_CON_ic_10bitaddr_slave_shift                                         (3)
+#define ISO_IC1_CON_ic_10bitaddr_slave_mask                                          (0x00000008)
+#define ISO_IC1_CON_ic_10bitaddr_slave(data)                                         (0x00000008&((data)<<3))
+#define ISO_IC1_CON_ic_10bitaddr_slave_src(data)                                     ((0x00000008&(data))>>3)
+#define ISO_IC1_CON_get_ic_10bitaddr_slave(data)                                     ((0x00000008&(data))>>3)
+#define ISO_IC1_CON_speed_shift                                                      (1)
+#define ISO_IC1_CON_speed_mask                                                       (0x00000006)
+#define ISO_IC1_CON_speed(data)                                                      (0x00000006&((data)<<1))
+#define ISO_IC1_CON_speed_src(data)                                                  ((0x00000006&(data))>>1)
+#define ISO_IC1_CON_get_speed(data)                                                  ((0x00000006&(data))>>1)
+#define ISO_IC1_CON_master_mode_shift                                                (0)
+#define ISO_IC1_CON_master_mode_mask                                                 (0x00000001)
+#define ISO_IC1_CON_master_mode(data)                                                (0x00000001&((data)<<0))
+#define ISO_IC1_CON_master_mode_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_IC1_CON_get_master_mode(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_TAR                                                                  0x98007C04
+#define ISO_IC1_TAR_reg_addr                                                         "0xD8007C04"
+#define ISO_IC1_TAR_reg                                                              0xD8007C04
+#define set_ISO_IC1_TAR_reg(data)   (*((volatile unsigned int*) ISO_IC1_TAR_reg)=data)
+#define get_ISO_IC1_TAR_reg   (*((volatile unsigned int*) ISO_IC1_TAR_reg))
+#define ISO_IC1_TAR_inst_adr                                                         "0x0001"
+#define ISO_IC1_TAR_inst                                                             0x0001
+#define ISO_IC1_TAR_ic_10bitaddr_master_shift                                        (12)
+#define ISO_IC1_TAR_ic_10bitaddr_master_mask                                         (0x00001000)
+#define ISO_IC1_TAR_ic_10bitaddr_master(data)                                        (0x00001000&((data)<<12))
+#define ISO_IC1_TAR_ic_10bitaddr_master_src(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC1_TAR_get_ic_10bitaddr_master(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC1_TAR_special_shift                                                    (11)
+#define ISO_IC1_TAR_special_mask                                                     (0x00000800)
+#define ISO_IC1_TAR_special(data)                                                    (0x00000800&((data)<<11))
+#define ISO_IC1_TAR_special_src(data)                                                ((0x00000800&(data))>>11)
+#define ISO_IC1_TAR_get_special(data)                                                ((0x00000800&(data))>>11)
+#define ISO_IC1_TAR_gc_or_start_shift                                                (10)
+#define ISO_IC1_TAR_gc_or_start_mask                                                 (0x00000400)
+#define ISO_IC1_TAR_gc_or_start(data)                                                (0x00000400&((data)<<10))
+#define ISO_IC1_TAR_gc_or_start_src(data)                                            ((0x00000400&(data))>>10)
+#define ISO_IC1_TAR_get_gc_or_start(data)                                            ((0x00000400&(data))>>10)
+#define ISO_IC1_TAR_ic_tar_shift                                                     (0)
+#define ISO_IC1_TAR_ic_tar_mask                                                      (0x000003FF)
+#define ISO_IC1_TAR_ic_tar(data)                                                     (0x000003FF&((data)<<0))
+#define ISO_IC1_TAR_ic_tar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define ISO_IC1_TAR_get_ic_tar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define ISO_IC1_SAR                                                                  0x98007C08
+#define ISO_IC1_SAR_reg_addr                                                         "0xD8007C08"
+#define ISO_IC1_SAR_reg                                                              0xD8007C08
+#define set_ISO_IC1_SAR_reg(data)   (*((volatile unsigned int*) ISO_IC1_SAR_reg)=data)
+#define get_ISO_IC1_SAR_reg   (*((volatile unsigned int*) ISO_IC1_SAR_reg))
+#define ISO_IC1_SAR_inst_adr                                                         "0x0002"
+#define ISO_IC1_SAR_inst                                                             0x0002
+#define ISO_IC1_SAR_ic_sar_shift                                                     (0)
+#define ISO_IC1_SAR_ic_sar_mask                                                      (0x000003FF)
+#define ISO_IC1_SAR_ic_sar(data)                                                     (0x000003FF&((data)<<0))
+#define ISO_IC1_SAR_ic_sar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define ISO_IC1_SAR_get_ic_sar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define ISO_IC1_HS_MADDR                                                             0x98007C0C
+#define ISO_IC1_HS_MADDR_reg_addr                                                    "0xD8007C0C"
+#define ISO_IC1_HS_MADDR_reg                                                         0xD8007C0C
+#define set_ISO_IC1_HS_MADDR_reg(data)   (*((volatile unsigned int*) ISO_IC1_HS_MADDR_reg)=data)
+#define get_ISO_IC1_HS_MADDR_reg   (*((volatile unsigned int*) ISO_IC1_HS_MADDR_reg))
+#define ISO_IC1_HS_MADDR_inst_adr                                                    "0x0003"
+#define ISO_IC1_HS_MADDR_inst                                                        0x0003
+#define ISO_IC1_HS_MADDR_ic_hs_mar_shift                                             (0)
+#define ISO_IC1_HS_MADDR_ic_hs_mar_mask                                              (0x00000007)
+#define ISO_IC1_HS_MADDR_ic_hs_mar(data)                                             (0x00000007&((data)<<0))
+#define ISO_IC1_HS_MADDR_ic_hs_mar_src(data)                                         ((0x00000007&(data))>>0)
+#define ISO_IC1_HS_MADDR_get_ic_hs_mar(data)                                         ((0x00000007&(data))>>0)
+
+
+#define ISO_IC1_DATA_CMD                                                             0x98007C10
+#define ISO_IC1_DATA_CMD_reg_addr                                                    "0xD8007C10"
+#define ISO_IC1_DATA_CMD_reg                                                         0xD8007C10
+#define set_ISO_IC1_DATA_CMD_reg(data)   (*((volatile unsigned int*) ISO_IC1_DATA_CMD_reg)=data)
+#define get_ISO_IC1_DATA_CMD_reg   (*((volatile unsigned int*) ISO_IC1_DATA_CMD_reg))
+#define ISO_IC1_DATA_CMD_inst_adr                                                    "0x0004"
+#define ISO_IC1_DATA_CMD_inst                                                        0x0004
+#define ISO_IC1_DATA_CMD_restart_shift                                               (10)
+#define ISO_IC1_DATA_CMD_restart_mask                                                (0x00000400)
+#define ISO_IC1_DATA_CMD_restart(data)                                               (0x00000400&((data)<<10))
+#define ISO_IC1_DATA_CMD_restart_src(data)                                           ((0x00000400&(data))>>10)
+#define ISO_IC1_DATA_CMD_get_restart(data)                                           ((0x00000400&(data))>>10)
+#define ISO_IC1_DATA_CMD_stop_shift                                                  (9)
+#define ISO_IC1_DATA_CMD_stop_mask                                                   (0x00000200)
+#define ISO_IC1_DATA_CMD_stop(data)                                                  (0x00000200&((data)<<9))
+#define ISO_IC1_DATA_CMD_stop_src(data)                                              ((0x00000200&(data))>>9)
+#define ISO_IC1_DATA_CMD_get_stop(data)                                              ((0x00000200&(data))>>9)
+#define ISO_IC1_DATA_CMD_cmd_shift                                                   (8)
+#define ISO_IC1_DATA_CMD_cmd_mask                                                    (0x00000100)
+#define ISO_IC1_DATA_CMD_cmd(data)                                                   (0x00000100&((data)<<8))
+#define ISO_IC1_DATA_CMD_cmd_src(data)                                               ((0x00000100&(data))>>8)
+#define ISO_IC1_DATA_CMD_get_cmd(data)                                               ((0x00000100&(data))>>8)
+#define ISO_IC1_DATA_CMD_dat_shift                                                   (0)
+#define ISO_IC1_DATA_CMD_dat_mask                                                    (0x000000FF)
+#define ISO_IC1_DATA_CMD_dat(data)                                                   (0x000000FF&((data)<<0))
+#define ISO_IC1_DATA_CMD_dat_src(data)                                               ((0x000000FF&(data))>>0)
+#define ISO_IC1_DATA_CMD_get_dat(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC1_SS_SCL_HCNT                                                          0x98007C14
+#define ISO_IC1_SS_SCL_HCNT_reg_addr                                                 "0xD8007C14"
+#define ISO_IC1_SS_SCL_HCNT_reg                                                      0xD8007C14
+#define set_ISO_IC1_SS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) ISO_IC1_SS_SCL_HCNT_reg)=data)
+#define get_ISO_IC1_SS_SCL_HCNT_reg   (*((volatile unsigned int*) ISO_IC1_SS_SCL_HCNT_reg))
+#define ISO_IC1_SS_SCL_HCNT_inst_adr                                                 "0x0005"
+#define ISO_IC1_SS_SCL_HCNT_inst                                                     0x0005
+#define ISO_IC1_SS_SCL_HCNT_ic_ss_scl_hcnt_shift                                     (0)
+#define ISO_IC1_SS_SCL_HCNT_ic_ss_scl_hcnt_mask                                      (0x0000FFFF)
+#define ISO_IC1_SS_SCL_HCNT_ic_ss_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC1_SS_SCL_HCNT_ic_ss_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC1_SS_SCL_HCNT_get_ic_ss_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC1_SS_SCL_LCNT                                                          0x98007C18
+#define ISO_IC1_SS_SCL_LCNT_reg_addr                                                 "0xD8007C18"
+#define ISO_IC1_SS_SCL_LCNT_reg                                                      0xD8007C18
+#define set_ISO_IC1_SS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) ISO_IC1_SS_SCL_LCNT_reg)=data)
+#define get_ISO_IC1_SS_SCL_LCNT_reg   (*((volatile unsigned int*) ISO_IC1_SS_SCL_LCNT_reg))
+#define ISO_IC1_SS_SCL_LCNT_inst_adr                                                 "0x0006"
+#define ISO_IC1_SS_SCL_LCNT_inst                                                     0x0006
+#define ISO_IC1_SS_SCL_LCNT_ic_ss_scl_lcnt_shift                                     (0)
+#define ISO_IC1_SS_SCL_LCNT_ic_ss_scl_lcnt_mask                                      (0x0000FFFF)
+#define ISO_IC1_SS_SCL_LCNT_ic_ss_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC1_SS_SCL_LCNT_ic_ss_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC1_SS_SCL_LCNT_get_ic_ss_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC1_FS_SCL_HCNT                                                          0x98007C1C
+#define ISO_IC1_FS_SCL_HCNT_reg_addr                                                 "0xD8007C1C"
+#define ISO_IC1_FS_SCL_HCNT_reg                                                      0xD8007C1C
+#define set_ISO_IC1_FS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) ISO_IC1_FS_SCL_HCNT_reg)=data)
+#define get_ISO_IC1_FS_SCL_HCNT_reg   (*((volatile unsigned int*) ISO_IC1_FS_SCL_HCNT_reg))
+#define ISO_IC1_FS_SCL_HCNT_inst_adr                                                 "0x0007"
+#define ISO_IC1_FS_SCL_HCNT_inst                                                     0x0007
+#define ISO_IC1_FS_SCL_HCNT_ic_fs_scl_hcnt_shift                                     (0)
+#define ISO_IC1_FS_SCL_HCNT_ic_fs_scl_hcnt_mask                                      (0x0000FFFF)
+#define ISO_IC1_FS_SCL_HCNT_ic_fs_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC1_FS_SCL_HCNT_ic_fs_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC1_FS_SCL_HCNT_get_ic_fs_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC1_FS_SCL_LCNT                                                          0x98007C20
+#define ISO_IC1_FS_SCL_LCNT_reg_addr                                                 "0xD8007C20"
+#define ISO_IC1_FS_SCL_LCNT_reg                                                      0xD8007C20
+#define set_ISO_IC1_FS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) ISO_IC1_FS_SCL_LCNT_reg)=data)
+#define get_ISO_IC1_FS_SCL_LCNT_reg   (*((volatile unsigned int*) ISO_IC1_FS_SCL_LCNT_reg))
+#define ISO_IC1_FS_SCL_LCNT_inst_adr                                                 "0x0008"
+#define ISO_IC1_FS_SCL_LCNT_inst                                                     0x0008
+#define ISO_IC1_FS_SCL_LCNT_ic_fs_scl_lcnt_shift                                     (0)
+#define ISO_IC1_FS_SCL_LCNT_ic_fs_scl_lcnt_mask                                      (0x0000FFFF)
+#define ISO_IC1_FS_SCL_LCNT_ic_fs_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC1_FS_SCL_LCNT_ic_fs_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC1_FS_SCL_LCNT_get_ic_fs_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC1_INTR_STAT                                                            0x98007C2C
+#define ISO_IC1_INTR_STAT_reg_addr                                                   "0xD8007C2C"
+#define ISO_IC1_INTR_STAT_reg                                                        0xD8007C2C
+#define set_ISO_IC1_INTR_STAT_reg(data)   (*((volatile unsigned int*) ISO_IC1_INTR_STAT_reg)=data)
+#define get_ISO_IC1_INTR_STAT_reg   (*((volatile unsigned int*) ISO_IC1_INTR_STAT_reg))
+#define ISO_IC1_INTR_STAT_inst_adr                                                   "0x000B"
+#define ISO_IC1_INTR_STAT_inst                                                       0x000B
+#define ISO_IC1_INTR_STAT_r_gen_call_shift                                           (11)
+#define ISO_IC1_INTR_STAT_r_gen_call_mask                                            (0x00000800)
+#define ISO_IC1_INTR_STAT_r_gen_call(data)                                           (0x00000800&((data)<<11))
+#define ISO_IC1_INTR_STAT_r_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC1_INTR_STAT_get_r_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC1_INTR_STAT_r_start_det_shift                                          (10)
+#define ISO_IC1_INTR_STAT_r_start_det_mask                                           (0x00000400)
+#define ISO_IC1_INTR_STAT_r_start_det(data)                                          (0x00000400&((data)<<10))
+#define ISO_IC1_INTR_STAT_r_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC1_INTR_STAT_get_r_start_det(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC1_INTR_STAT_r_stop_det_shift                                           (9)
+#define ISO_IC1_INTR_STAT_r_stop_det_mask                                            (0x00000200)
+#define ISO_IC1_INTR_STAT_r_stop_det(data)                                           (0x00000200&((data)<<9))
+#define ISO_IC1_INTR_STAT_r_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC1_INTR_STAT_get_r_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC1_INTR_STAT_r_activity_shift                                           (8)
+#define ISO_IC1_INTR_STAT_r_activity_mask                                            (0x00000100)
+#define ISO_IC1_INTR_STAT_r_activity(data)                                           (0x00000100&((data)<<8))
+#define ISO_IC1_INTR_STAT_r_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC1_INTR_STAT_get_r_activity(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC1_INTR_STAT_r_rx_done_shift                                            (7)
+#define ISO_IC1_INTR_STAT_r_rx_done_mask                                             (0x00000080)
+#define ISO_IC1_INTR_STAT_r_rx_done(data)                                            (0x00000080&((data)<<7))
+#define ISO_IC1_INTR_STAT_r_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC1_INTR_STAT_get_r_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC1_INTR_STAT_r_tx_abrt_shift                                            (6)
+#define ISO_IC1_INTR_STAT_r_tx_abrt_mask                                             (0x00000040)
+#define ISO_IC1_INTR_STAT_r_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC1_INTR_STAT_r_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC1_INTR_STAT_get_r_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC1_INTR_STAT_r_rd_req_shift                                             (5)
+#define ISO_IC1_INTR_STAT_r_rd_req_mask                                              (0x00000020)
+#define ISO_IC1_INTR_STAT_r_rd_req(data)                                             (0x00000020&((data)<<5))
+#define ISO_IC1_INTR_STAT_r_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC1_INTR_STAT_get_r_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC1_INTR_STAT_r_tx_empty_shift                                           (4)
+#define ISO_IC1_INTR_STAT_r_tx_empty_mask                                            (0x00000010)
+#define ISO_IC1_INTR_STAT_r_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define ISO_IC1_INTR_STAT_r_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC1_INTR_STAT_get_r_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC1_INTR_STAT_r_tx_over_shift                                            (3)
+#define ISO_IC1_INTR_STAT_r_tx_over_mask                                             (0x00000008)
+#define ISO_IC1_INTR_STAT_r_tx_over(data)                                            (0x00000008&((data)<<3))
+#define ISO_IC1_INTR_STAT_r_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC1_INTR_STAT_get_r_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC1_INTR_STAT_r_rx_full_shift                                            (2)
+#define ISO_IC1_INTR_STAT_r_rx_full_mask                                             (0x00000004)
+#define ISO_IC1_INTR_STAT_r_rx_full(data)                                            (0x00000004&((data)<<2))
+#define ISO_IC1_INTR_STAT_r_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC1_INTR_STAT_get_r_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC1_INTR_STAT_r_rx_over_shift                                            (1)
+#define ISO_IC1_INTR_STAT_r_rx_over_mask                                             (0x00000002)
+#define ISO_IC1_INTR_STAT_r_rx_over(data)                                            (0x00000002&((data)<<1))
+#define ISO_IC1_INTR_STAT_r_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC1_INTR_STAT_get_r_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC1_INTR_STAT_r_rx_under_shift                                           (0)
+#define ISO_IC1_INTR_STAT_r_rx_under_mask                                            (0x00000001)
+#define ISO_IC1_INTR_STAT_r_rx_under(data)                                           (0x00000001&((data)<<0))
+#define ISO_IC1_INTR_STAT_r_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_IC1_INTR_STAT_get_r_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_INTR_MASK                                                            0x98007C30
+#define ISO_IC1_INTR_MASK_reg_addr                                                   "0xD8007C30"
+#define ISO_IC1_INTR_MASK_reg                                                        0xD8007C30
+#define set_ISO_IC1_INTR_MASK_reg(data)   (*((volatile unsigned int*) ISO_IC1_INTR_MASK_reg)=data)
+#define get_ISO_IC1_INTR_MASK_reg   (*((volatile unsigned int*) ISO_IC1_INTR_MASK_reg))
+#define ISO_IC1_INTR_MASK_inst_adr                                                   "0x000C"
+#define ISO_IC1_INTR_MASK_inst                                                       0x000C
+#define ISO_IC1_INTR_MASK_m_gen_call_shift                                           (11)
+#define ISO_IC1_INTR_MASK_m_gen_call_mask                                            (0x00000800)
+#define ISO_IC1_INTR_MASK_m_gen_call(data)                                           (0x00000800&((data)<<11))
+#define ISO_IC1_INTR_MASK_m_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC1_INTR_MASK_get_m_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC1_INTR_MASK_m_start_det_shift                                          (10)
+#define ISO_IC1_INTR_MASK_m_start_det_mask                                           (0x00000400)
+#define ISO_IC1_INTR_MASK_m_start_det(data)                                          (0x00000400&((data)<<10))
+#define ISO_IC1_INTR_MASK_m_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC1_INTR_MASK_get_m_start_det(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC1_INTR_MASK_m_stop_det_shift                                           (9)
+#define ISO_IC1_INTR_MASK_m_stop_det_mask                                            (0x00000200)
+#define ISO_IC1_INTR_MASK_m_stop_det(data)                                           (0x00000200&((data)<<9))
+#define ISO_IC1_INTR_MASK_m_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC1_INTR_MASK_get_m_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC1_INTR_MASK_m_activity_shift                                           (8)
+#define ISO_IC1_INTR_MASK_m_activity_mask                                            (0x00000100)
+#define ISO_IC1_INTR_MASK_m_activity(data)                                           (0x00000100&((data)<<8))
+#define ISO_IC1_INTR_MASK_m_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC1_INTR_MASK_get_m_activity(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC1_INTR_MASK_m_rx_done_shift                                            (7)
+#define ISO_IC1_INTR_MASK_m_rx_done_mask                                             (0x00000080)
+#define ISO_IC1_INTR_MASK_m_rx_done(data)                                            (0x00000080&((data)<<7))
+#define ISO_IC1_INTR_MASK_m_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC1_INTR_MASK_get_m_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC1_INTR_MASK_m_tx_abrt_shift                                            (6)
+#define ISO_IC1_INTR_MASK_m_tx_abrt_mask                                             (0x00000040)
+#define ISO_IC1_INTR_MASK_m_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC1_INTR_MASK_m_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC1_INTR_MASK_get_m_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC1_INTR_MASK_m_rd_req_shift                                             (5)
+#define ISO_IC1_INTR_MASK_m_rd_req_mask                                              (0x00000020)
+#define ISO_IC1_INTR_MASK_m_rd_req(data)                                             (0x00000020&((data)<<5))
+#define ISO_IC1_INTR_MASK_m_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC1_INTR_MASK_get_m_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC1_INTR_MASK_m_tx_empty_shift                                           (4)
+#define ISO_IC1_INTR_MASK_m_tx_empty_mask                                            (0x00000010)
+#define ISO_IC1_INTR_MASK_m_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define ISO_IC1_INTR_MASK_m_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC1_INTR_MASK_get_m_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC1_INTR_MASK_m_tx_over_shift                                            (3)
+#define ISO_IC1_INTR_MASK_m_tx_over_mask                                             (0x00000008)
+#define ISO_IC1_INTR_MASK_m_tx_over(data)                                            (0x00000008&((data)<<3))
+#define ISO_IC1_INTR_MASK_m_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC1_INTR_MASK_get_m_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC1_INTR_MASK_m_rx_full_shift                                            (2)
+#define ISO_IC1_INTR_MASK_m_rx_full_mask                                             (0x00000004)
+#define ISO_IC1_INTR_MASK_m_rx_full(data)                                            (0x00000004&((data)<<2))
+#define ISO_IC1_INTR_MASK_m_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC1_INTR_MASK_get_m_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC1_INTR_MASK_m_rx_over_shift                                            (1)
+#define ISO_IC1_INTR_MASK_m_rx_over_mask                                             (0x00000002)
+#define ISO_IC1_INTR_MASK_m_rx_over(data)                                            (0x00000002&((data)<<1))
+#define ISO_IC1_INTR_MASK_m_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC1_INTR_MASK_get_m_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC1_INTR_MASK_m_rx_under_shift                                           (0)
+#define ISO_IC1_INTR_MASK_m_rx_under_mask                                            (0x00000001)
+#define ISO_IC1_INTR_MASK_m_rx_under(data)                                           (0x00000001&((data)<<0))
+#define ISO_IC1_INTR_MASK_m_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_IC1_INTR_MASK_get_m_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_RAW_INTR_STAT                                                        0x98007C34
+#define ISO_IC1_RAW_INTR_STAT_reg_addr                                               "0xD8007C34"
+#define ISO_IC1_RAW_INTR_STAT_reg                                                    0xD8007C34
+#define set_ISO_IC1_RAW_INTR_STAT_reg(data)   (*((volatile unsigned int*) ISO_IC1_RAW_INTR_STAT_reg)=data)
+#define get_ISO_IC1_RAW_INTR_STAT_reg   (*((volatile unsigned int*) ISO_IC1_RAW_INTR_STAT_reg))
+#define ISO_IC1_RAW_INTR_STAT_inst_adr                                               "0x000D"
+#define ISO_IC1_RAW_INTR_STAT_inst                                                   0x000D
+#define ISO_IC1_RAW_INTR_STAT_gen_call_shift                                         (11)
+#define ISO_IC1_RAW_INTR_STAT_gen_call_mask                                          (0x00000800)
+#define ISO_IC1_RAW_INTR_STAT_gen_call(data)                                         (0x00000800&((data)<<11))
+#define ISO_IC1_RAW_INTR_STAT_gen_call_src(data)                                     ((0x00000800&(data))>>11)
+#define ISO_IC1_RAW_INTR_STAT_get_gen_call(data)                                     ((0x00000800&(data))>>11)
+#define ISO_IC1_RAW_INTR_STAT_start_det_shift                                        (10)
+#define ISO_IC1_RAW_INTR_STAT_start_det_mask                                         (0x00000400)
+#define ISO_IC1_RAW_INTR_STAT_start_det(data)                                        (0x00000400&((data)<<10))
+#define ISO_IC1_RAW_INTR_STAT_start_det_src(data)                                    ((0x00000400&(data))>>10)
+#define ISO_IC1_RAW_INTR_STAT_get_start_det(data)                                    ((0x00000400&(data))>>10)
+#define ISO_IC1_RAW_INTR_STAT_stop_det_shift                                         (9)
+#define ISO_IC1_RAW_INTR_STAT_stop_det_mask                                          (0x00000200)
+#define ISO_IC1_RAW_INTR_STAT_stop_det(data)                                         (0x00000200&((data)<<9))
+#define ISO_IC1_RAW_INTR_STAT_stop_det_src(data)                                     ((0x00000200&(data))>>9)
+#define ISO_IC1_RAW_INTR_STAT_get_stop_det(data)                                     ((0x00000200&(data))>>9)
+#define ISO_IC1_RAW_INTR_STAT_activity_shift                                         (8)
+#define ISO_IC1_RAW_INTR_STAT_activity_mask                                          (0x00000100)
+#define ISO_IC1_RAW_INTR_STAT_activity(data)                                         (0x00000100&((data)<<8))
+#define ISO_IC1_RAW_INTR_STAT_activity_src(data)                                     ((0x00000100&(data))>>8)
+#define ISO_IC1_RAW_INTR_STAT_get_activity(data)                                     ((0x00000100&(data))>>8)
+#define ISO_IC1_RAW_INTR_STAT_rx_done_shift                                          (7)
+#define ISO_IC1_RAW_INTR_STAT_rx_done_mask                                           (0x00000080)
+#define ISO_IC1_RAW_INTR_STAT_rx_done(data)                                          (0x00000080&((data)<<7))
+#define ISO_IC1_RAW_INTR_STAT_rx_done_src(data)                                      ((0x00000080&(data))>>7)
+#define ISO_IC1_RAW_INTR_STAT_get_rx_done(data)                                      ((0x00000080&(data))>>7)
+#define ISO_IC1_RAW_INTR_STAT_tx_abrt_shift                                          (6)
+#define ISO_IC1_RAW_INTR_STAT_tx_abrt_mask                                           (0x00000040)
+#define ISO_IC1_RAW_INTR_STAT_tx_abrt(data)                                          (0x00000040&((data)<<6))
+#define ISO_IC1_RAW_INTR_STAT_tx_abrt_src(data)                                      ((0x00000040&(data))>>6)
+#define ISO_IC1_RAW_INTR_STAT_get_tx_abrt(data)                                      ((0x00000040&(data))>>6)
+#define ISO_IC1_RAW_INTR_STAT_rd_req_shift                                           (5)
+#define ISO_IC1_RAW_INTR_STAT_rd_req_mask                                            (0x00000020)
+#define ISO_IC1_RAW_INTR_STAT_rd_req(data)                                           (0x00000020&((data)<<5))
+#define ISO_IC1_RAW_INTR_STAT_rd_req_src(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC1_RAW_INTR_STAT_get_rd_req(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC1_RAW_INTR_STAT_tx_empty_shift                                         (4)
+#define ISO_IC1_RAW_INTR_STAT_tx_empty_mask                                          (0x00000010)
+#define ISO_IC1_RAW_INTR_STAT_tx_empty(data)                                         (0x00000010&((data)<<4))
+#define ISO_IC1_RAW_INTR_STAT_tx_empty_src(data)                                     ((0x00000010&(data))>>4)
+#define ISO_IC1_RAW_INTR_STAT_get_tx_empty(data)                                     ((0x00000010&(data))>>4)
+#define ISO_IC1_RAW_INTR_STAT_tx_over_shift                                          (3)
+#define ISO_IC1_RAW_INTR_STAT_tx_over_mask                                           (0x00000008)
+#define ISO_IC1_RAW_INTR_STAT_tx_over(data)                                          (0x00000008&((data)<<3))
+#define ISO_IC1_RAW_INTR_STAT_tx_over_src(data)                                      ((0x00000008&(data))>>3)
+#define ISO_IC1_RAW_INTR_STAT_get_tx_over(data)                                      ((0x00000008&(data))>>3)
+#define ISO_IC1_RAW_INTR_STAT_rx_full_shift                                          (2)
+#define ISO_IC1_RAW_INTR_STAT_rx_full_mask                                           (0x00000004)
+#define ISO_IC1_RAW_INTR_STAT_rx_full(data)                                          (0x00000004&((data)<<2))
+#define ISO_IC1_RAW_INTR_STAT_rx_full_src(data)                                      ((0x00000004&(data))>>2)
+#define ISO_IC1_RAW_INTR_STAT_get_rx_full(data)                                      ((0x00000004&(data))>>2)
+#define ISO_IC1_RAW_INTR_STAT_rx_over_shift                                          (1)
+#define ISO_IC1_RAW_INTR_STAT_rx_over_mask                                           (0x00000002)
+#define ISO_IC1_RAW_INTR_STAT_rx_over(data)                                          (0x00000002&((data)<<1))
+#define ISO_IC1_RAW_INTR_STAT_rx_over_src(data)                                      ((0x00000002&(data))>>1)
+#define ISO_IC1_RAW_INTR_STAT_get_rx_over(data)                                      ((0x00000002&(data))>>1)
+#define ISO_IC1_RAW_INTR_STAT_rx_under_shift                                         (0)
+#define ISO_IC1_RAW_INTR_STAT_rx_under_mask                                          (0x00000001)
+#define ISO_IC1_RAW_INTR_STAT_rx_under(data)                                         (0x00000001&((data)<<0))
+#define ISO_IC1_RAW_INTR_STAT_rx_under_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_IC1_RAW_INTR_STAT_get_rx_under(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_RX_TL                                                                0x98007C38
+#define ISO_IC1_RX_TL_reg_addr                                                       "0xD8007C38"
+#define ISO_IC1_RX_TL_reg                                                            0xD8007C38
+#define set_ISO_IC1_RX_TL_reg(data)   (*((volatile unsigned int*) ISO_IC1_RX_TL_reg)=data)
+#define get_ISO_IC1_RX_TL_reg   (*((volatile unsigned int*) ISO_IC1_RX_TL_reg))
+#define ISO_IC1_RX_TL_inst_adr                                                       "0x000E"
+#define ISO_IC1_RX_TL_inst                                                           0x000E
+#define ISO_IC1_RX_TL_rx_tl_shift                                                    (0)
+#define ISO_IC1_RX_TL_rx_tl_mask                                                     (0x000000FF)
+#define ISO_IC1_RX_TL_rx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_IC1_RX_TL_rx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_IC1_RX_TL_get_rx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC1_TX_TL                                                                0x98007C3C
+#define ISO_IC1_TX_TL_reg_addr                                                       "0xD8007C3C"
+#define ISO_IC1_TX_TL_reg                                                            0xD8007C3C
+#define set_ISO_IC1_TX_TL_reg(data)   (*((volatile unsigned int*) ISO_IC1_TX_TL_reg)=data)
+#define get_ISO_IC1_TX_TL_reg   (*((volatile unsigned int*) ISO_IC1_TX_TL_reg))
+#define ISO_IC1_TX_TL_inst_adr                                                       "0x000F"
+#define ISO_IC1_TX_TL_inst                                                           0x000F
+#define ISO_IC1_TX_TL_tx_tl_shift                                                    (0)
+#define ISO_IC1_TX_TL_tx_tl_mask                                                     (0x000000FF)
+#define ISO_IC1_TX_TL_tx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_IC1_TX_TL_tx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_IC1_TX_TL_get_tx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC1_CLR_INTR                                                             0x98007C40
+#define ISO_IC1_CLR_INTR_reg_addr                                                    "0xD8007C40"
+#define ISO_IC1_CLR_INTR_reg                                                         0xD8007C40
+#define set_ISO_IC1_CLR_INTR_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_INTR_reg)=data)
+#define get_ISO_IC1_CLR_INTR_reg   (*((volatile unsigned int*) ISO_IC1_CLR_INTR_reg))
+#define ISO_IC1_CLR_INTR_inst_adr                                                    "0x0010"
+#define ISO_IC1_CLR_INTR_inst                                                        0x0010
+#define ISO_IC1_CLR_INTR_clr_intr_shift                                              (0)
+#define ISO_IC1_CLR_INTR_clr_intr_mask                                               (0x00000001)
+#define ISO_IC1_CLR_INTR_clr_intr(data)                                              (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_INTR_clr_intr_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_INTR_get_clr_intr(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_CLR_RX_UNDER                                                         0x98007C44
+#define ISO_IC1_CLR_RX_UNDER_reg_addr                                                "0xD8007C44"
+#define ISO_IC1_CLR_RX_UNDER_reg                                                     0xD8007C44
+#define set_ISO_IC1_CLR_RX_UNDER_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_RX_UNDER_reg)=data)
+#define get_ISO_IC1_CLR_RX_UNDER_reg   (*((volatile unsigned int*) ISO_IC1_CLR_RX_UNDER_reg))
+#define ISO_IC1_CLR_RX_UNDER_inst_adr                                                "0x0011"
+#define ISO_IC1_CLR_RX_UNDER_inst                                                    0x0011
+#define ISO_IC1_CLR_RX_UNDER_clr_rx_under_shift                                      (0)
+#define ISO_IC1_CLR_RX_UNDER_clr_rx_under_mask                                       (0x00000001)
+#define ISO_IC1_CLR_RX_UNDER_clr_rx_under(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_RX_UNDER_clr_rx_under_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_RX_UNDER_get_clr_rx_under(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_CLR_RX_OVER                                                          0x98007C48
+#define ISO_IC1_CLR_RX_OVER_reg_addr                                                 "0xD8007C48"
+#define ISO_IC1_CLR_RX_OVER_reg                                                      0xD8007C48
+#define set_ISO_IC1_CLR_RX_OVER_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_RX_OVER_reg)=data)
+#define get_ISO_IC1_CLR_RX_OVER_reg   (*((volatile unsigned int*) ISO_IC1_CLR_RX_OVER_reg))
+#define ISO_IC1_CLR_RX_OVER_inst_adr                                                 "0x0012"
+#define ISO_IC1_CLR_RX_OVER_inst                                                     0x0012
+#define ISO_IC1_CLR_RX_OVER_clr_rx_over_shift                                        (0)
+#define ISO_IC1_CLR_RX_OVER_clr_rx_over_mask                                         (0x00000001)
+#define ISO_IC1_CLR_RX_OVER_clr_rx_over(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_RX_OVER_clr_rx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_RX_OVER_get_clr_rx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_CLR_TX_OVER                                                          0x98007C4C
+#define ISO_IC1_CLR_TX_OVER_reg_addr                                                 "0xD8007C4C"
+#define ISO_IC1_CLR_TX_OVER_reg                                                      0xD8007C4C
+#define set_ISO_IC1_CLR_TX_OVER_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_TX_OVER_reg)=data)
+#define get_ISO_IC1_CLR_TX_OVER_reg   (*((volatile unsigned int*) ISO_IC1_CLR_TX_OVER_reg))
+#define ISO_IC1_CLR_TX_OVER_inst_adr                                                 "0x0013"
+#define ISO_IC1_CLR_TX_OVER_inst                                                     0x0013
+#define ISO_IC1_CLR_TX_OVER_clr_tx_over_shift                                        (0)
+#define ISO_IC1_CLR_TX_OVER_clr_tx_over_mask                                         (0x00000001)
+#define ISO_IC1_CLR_TX_OVER_clr_tx_over(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_TX_OVER_clr_tx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_TX_OVER_get_clr_tx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_CLR_RD_REQ                                                           0x98007C50
+#define ISO_IC1_CLR_RD_REQ_reg_addr                                                  "0xD8007C50"
+#define ISO_IC1_CLR_RD_REQ_reg                                                       0xD8007C50
+#define set_ISO_IC1_CLR_RD_REQ_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_RD_REQ_reg)=data)
+#define get_ISO_IC1_CLR_RD_REQ_reg   (*((volatile unsigned int*) ISO_IC1_CLR_RD_REQ_reg))
+#define ISO_IC1_CLR_RD_REQ_inst_adr                                                  "0x0014"
+#define ISO_IC1_CLR_RD_REQ_inst                                                      0x0014
+#define ISO_IC1_CLR_RD_REQ_clr_rd_req_shift                                          (0)
+#define ISO_IC1_CLR_RD_REQ_clr_rd_req_mask                                           (0x00000001)
+#define ISO_IC1_CLR_RD_REQ_clr_rd_req(data)                                          (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_RD_REQ_clr_rd_req_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_RD_REQ_get_clr_rd_req(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_CLR_TX_ABRT                                                          0x98007C54
+#define ISO_IC1_CLR_TX_ABRT_reg_addr                                                 "0xD8007C54"
+#define ISO_IC1_CLR_TX_ABRT_reg                                                      0xD8007C54
+#define set_ISO_IC1_CLR_TX_ABRT_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_TX_ABRT_reg)=data)
+#define get_ISO_IC1_CLR_TX_ABRT_reg   (*((volatile unsigned int*) ISO_IC1_CLR_TX_ABRT_reg))
+#define ISO_IC1_CLR_TX_ABRT_inst_adr                                                 "0x0015"
+#define ISO_IC1_CLR_TX_ABRT_inst                                                     0x0015
+#define ISO_IC1_CLR_TX_ABRT_clr_tx_abrt_shift                                        (0)
+#define ISO_IC1_CLR_TX_ABRT_clr_tx_abrt_mask                                         (0x00000001)
+#define ISO_IC1_CLR_TX_ABRT_clr_tx_abrt(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_TX_ABRT_clr_tx_abrt_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_TX_ABRT_get_clr_tx_abrt(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_CLR_RX_DONE                                                          0x98007C58
+#define ISO_IC1_CLR_RX_DONE_reg_addr                                                 "0xD8007C58"
+#define ISO_IC1_CLR_RX_DONE_reg                                                      0xD8007C58
+#define set_ISO_IC1_CLR_RX_DONE_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_RX_DONE_reg)=data)
+#define get_ISO_IC1_CLR_RX_DONE_reg   (*((volatile unsigned int*) ISO_IC1_CLR_RX_DONE_reg))
+#define ISO_IC1_CLR_RX_DONE_inst_adr                                                 "0x0016"
+#define ISO_IC1_CLR_RX_DONE_inst                                                     0x0016
+#define ISO_IC1_CLR_RX_DONE_clr_rx_done_shift                                        (0)
+#define ISO_IC1_CLR_RX_DONE_clr_rx_done_mask                                         (0x00000001)
+#define ISO_IC1_CLR_RX_DONE_clr_rx_done(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_RX_DONE_clr_rx_done_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_RX_DONE_get_clr_rx_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_CLR_ACTIVITY                                                         0x98007C5C
+#define ISO_IC1_CLR_ACTIVITY_reg_addr                                                "0xD8007C5C"
+#define ISO_IC1_CLR_ACTIVITY_reg                                                     0xD8007C5C
+#define set_ISO_IC1_CLR_ACTIVITY_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_ACTIVITY_reg)=data)
+#define get_ISO_IC1_CLR_ACTIVITY_reg   (*((volatile unsigned int*) ISO_IC1_CLR_ACTIVITY_reg))
+#define ISO_IC1_CLR_ACTIVITY_inst_adr                                                "0x0017"
+#define ISO_IC1_CLR_ACTIVITY_inst                                                    0x0017
+#define ISO_IC1_CLR_ACTIVITY_clr_activity_shift                                      (0)
+#define ISO_IC1_CLR_ACTIVITY_clr_activity_mask                                       (0x00000001)
+#define ISO_IC1_CLR_ACTIVITY_clr_activity(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_ACTIVITY_clr_activity_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_ACTIVITY_get_clr_activity(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_CLR_STOP_DET                                                         0x98007C60
+#define ISO_IC1_CLR_STOP_DET_reg_addr                                                "0xD8007C60"
+#define ISO_IC1_CLR_STOP_DET_reg                                                     0xD8007C60
+#define set_ISO_IC1_CLR_STOP_DET_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_STOP_DET_reg)=data)
+#define get_ISO_IC1_CLR_STOP_DET_reg   (*((volatile unsigned int*) ISO_IC1_CLR_STOP_DET_reg))
+#define ISO_IC1_CLR_STOP_DET_inst_adr                                                "0x0018"
+#define ISO_IC1_CLR_STOP_DET_inst                                                    0x0018
+#define ISO_IC1_CLR_STOP_DET_clr_stop_det_shift                                      (0)
+#define ISO_IC1_CLR_STOP_DET_clr_stop_det_mask                                       (0x00000001)
+#define ISO_IC1_CLR_STOP_DET_clr_stop_det(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_STOP_DET_clr_stop_det_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_STOP_DET_get_clr_stop_det(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_CLR_START_DET                                                        0x98007C64
+#define ISO_IC1_CLR_START_DET_reg_addr                                               "0xD8007C64"
+#define ISO_IC1_CLR_START_DET_reg                                                    0xD8007C64
+#define set_ISO_IC1_CLR_START_DET_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_START_DET_reg)=data)
+#define get_ISO_IC1_CLR_START_DET_reg   (*((volatile unsigned int*) ISO_IC1_CLR_START_DET_reg))
+#define ISO_IC1_CLR_START_DET_inst_adr                                               "0x0019"
+#define ISO_IC1_CLR_START_DET_inst                                                   0x0019
+#define ISO_IC1_CLR_START_DET_clr_start_det_shift                                    (0)
+#define ISO_IC1_CLR_START_DET_clr_start_det_mask                                     (0x00000001)
+#define ISO_IC1_CLR_START_DET_clr_start_det(data)                                    (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_START_DET_clr_start_det_src(data)                                ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_START_DET_get_clr_start_det(data)                                ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_CLR_GEN_CALL                                                         0x98007C68
+#define ISO_IC1_CLR_GEN_CALL_reg_addr                                                "0xD8007C68"
+#define ISO_IC1_CLR_GEN_CALL_reg                                                     0xD8007C68
+#define set_ISO_IC1_CLR_GEN_CALL_reg(data)   (*((volatile unsigned int*) ISO_IC1_CLR_GEN_CALL_reg)=data)
+#define get_ISO_IC1_CLR_GEN_CALL_reg   (*((volatile unsigned int*) ISO_IC1_CLR_GEN_CALL_reg))
+#define ISO_IC1_CLR_GEN_CALL_inst_adr                                                "0x001A"
+#define ISO_IC1_CLR_GEN_CALL_inst                                                    0x001A
+#define ISO_IC1_CLR_GEN_CALL_clr_gen_call_shift                                      (0)
+#define ISO_IC1_CLR_GEN_CALL_clr_gen_call_mask                                       (0x00000001)
+#define ISO_IC1_CLR_GEN_CALL_clr_gen_call(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC1_CLR_GEN_CALL_clr_gen_call_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC1_CLR_GEN_CALL_get_clr_gen_call(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_ENABLE                                                               0x98007C6C
+#define ISO_IC1_ENABLE_reg_addr                                                      "0xD8007C6C"
+#define ISO_IC1_ENABLE_reg                                                           0xD8007C6C
+#define set_ISO_IC1_ENABLE_reg(data)   (*((volatile unsigned int*) ISO_IC1_ENABLE_reg)=data)
+#define get_ISO_IC1_ENABLE_reg   (*((volatile unsigned int*) ISO_IC1_ENABLE_reg))
+#define ISO_IC1_ENABLE_inst_adr                                                      "0x001B"
+#define ISO_IC1_ENABLE_inst                                                          0x001B
+#define ISO_IC1_ENABLE_enable_shift                                                  (0)
+#define ISO_IC1_ENABLE_enable_mask                                                   (0x00000001)
+#define ISO_IC1_ENABLE_enable(data)                                                  (0x00000001&((data)<<0))
+#define ISO_IC1_ENABLE_enable_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_IC1_ENABLE_get_enable(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_STATUS                                                               0x98007C70
+#define ISO_IC1_STATUS_reg_addr                                                      "0xD8007C70"
+#define ISO_IC1_STATUS_reg                                                           0xD8007C70
+#define set_ISO_IC1_STATUS_reg(data)   (*((volatile unsigned int*) ISO_IC1_STATUS_reg)=data)
+#define get_ISO_IC1_STATUS_reg   (*((volatile unsigned int*) ISO_IC1_STATUS_reg))
+#define ISO_IC1_STATUS_inst_adr                                                      "0x001C"
+#define ISO_IC1_STATUS_inst                                                          0x001C
+#define ISO_IC1_STATUS_slv_activity_shift                                            (6)
+#define ISO_IC1_STATUS_slv_activity_mask                                             (0x00000040)
+#define ISO_IC1_STATUS_slv_activity(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC1_STATUS_slv_activity_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC1_STATUS_get_slv_activity(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC1_STATUS_mst_activity_shift                                            (5)
+#define ISO_IC1_STATUS_mst_activity_mask                                             (0x00000020)
+#define ISO_IC1_STATUS_mst_activity(data)                                            (0x00000020&((data)<<5))
+#define ISO_IC1_STATUS_mst_activity_src(data)                                        ((0x00000020&(data))>>5)
+#define ISO_IC1_STATUS_get_mst_activity(data)                                        ((0x00000020&(data))>>5)
+#define ISO_IC1_STATUS_rff_shift                                                     (4)
+#define ISO_IC1_STATUS_rff_mask                                                      (0x00000010)
+#define ISO_IC1_STATUS_rff(data)                                                     (0x00000010&((data)<<4))
+#define ISO_IC1_STATUS_rff_src(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IC1_STATUS_get_rff(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IC1_STATUS_rfne_shift                                                    (3)
+#define ISO_IC1_STATUS_rfne_mask                                                     (0x00000008)
+#define ISO_IC1_STATUS_rfne(data)                                                    (0x00000008&((data)<<3))
+#define ISO_IC1_STATUS_rfne_src(data)                                                ((0x00000008&(data))>>3)
+#define ISO_IC1_STATUS_get_rfne(data)                                                ((0x00000008&(data))>>3)
+#define ISO_IC1_STATUS_tfe_shift                                                     (2)
+#define ISO_IC1_STATUS_tfe_mask                                                      (0x00000004)
+#define ISO_IC1_STATUS_tfe(data)                                                     (0x00000004&((data)<<2))
+#define ISO_IC1_STATUS_tfe_src(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_IC1_STATUS_get_tfe(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_IC1_STATUS_tfnf_shift                                                    (1)
+#define ISO_IC1_STATUS_tfnf_mask                                                     (0x00000002)
+#define ISO_IC1_STATUS_tfnf(data)                                                    (0x00000002&((data)<<1))
+#define ISO_IC1_STATUS_tfnf_src(data)                                                ((0x00000002&(data))>>1)
+#define ISO_IC1_STATUS_get_tfnf(data)                                                ((0x00000002&(data))>>1)
+#define ISO_IC1_STATUS_activity_shift                                                (0)
+#define ISO_IC1_STATUS_activity_mask                                                 (0x00000001)
+#define ISO_IC1_STATUS_activity(data)                                                (0x00000001&((data)<<0))
+#define ISO_IC1_STATUS_activity_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_IC1_STATUS_get_activity(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_TXFLR                                                                0x98007C74
+#define ISO_IC1_TXFLR_reg_addr                                                       "0xD8007C74"
+#define ISO_IC1_TXFLR_reg                                                            0xD8007C74
+#define set_ISO_IC1_TXFLR_reg(data)   (*((volatile unsigned int*) ISO_IC1_TXFLR_reg)=data)
+#define get_ISO_IC1_TXFLR_reg   (*((volatile unsigned int*) ISO_IC1_TXFLR_reg))
+#define ISO_IC1_TXFLR_inst_adr                                                       "0x001D"
+#define ISO_IC1_TXFLR_inst                                                           0x001D
+#define ISO_IC1_TXFLR_txflr_shift                                                    (0)
+#define ISO_IC1_TXFLR_txflr_mask                                                     (0x0000000F)
+#define ISO_IC1_TXFLR_txflr(data)                                                    (0x0000000F&((data)<<0))
+#define ISO_IC1_TXFLR_txflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define ISO_IC1_TXFLR_get_txflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC1_RXFLR                                                                0x98007C78
+#define ISO_IC1_RXFLR_reg_addr                                                       "0xD8007C78"
+#define ISO_IC1_RXFLR_reg                                                            0xD8007C78
+#define set_ISO_IC1_RXFLR_reg(data)   (*((volatile unsigned int*) ISO_IC1_RXFLR_reg)=data)
+#define get_ISO_IC1_RXFLR_reg   (*((volatile unsigned int*) ISO_IC1_RXFLR_reg))
+#define ISO_IC1_RXFLR_inst_adr                                                       "0x001E"
+#define ISO_IC1_RXFLR_inst                                                           0x001E
+#define ISO_IC1_RXFLR_rxflr_shift                                                    (0)
+#define ISO_IC1_RXFLR_rxflr_mask                                                     (0x0000000F)
+#define ISO_IC1_RXFLR_rxflr(data)                                                    (0x0000000F&((data)<<0))
+#define ISO_IC1_RXFLR_rxflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define ISO_IC1_RXFLR_get_rxflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC1_SDA_HOLD                                                             0x98007C7C
+#define ISO_IC1_SDA_HOLD_reg_addr                                                    "0xD8007C7C"
+#define ISO_IC1_SDA_HOLD_reg                                                         0xD8007C7C
+#define set_ISO_IC1_SDA_HOLD_reg(data)   (*((volatile unsigned int*) ISO_IC1_SDA_HOLD_reg)=data)
+#define get_ISO_IC1_SDA_HOLD_reg   (*((volatile unsigned int*) ISO_IC1_SDA_HOLD_reg))
+#define ISO_IC1_SDA_HOLD_inst_adr                                                    "0x001F"
+#define ISO_IC1_SDA_HOLD_inst                                                        0x001F
+#define ISO_IC1_SDA_HOLD_ic_sda_hold_shift                                           (0)
+#define ISO_IC1_SDA_HOLD_ic_sda_hold_mask                                            (0x0000FFFF)
+#define ISO_IC1_SDA_HOLD_ic_sda_hold(data)                                           (0x0000FFFF&((data)<<0))
+#define ISO_IC1_SDA_HOLD_ic_sda_hold_src(data)                                       ((0x0000FFFF&(data))>>0)
+#define ISO_IC1_SDA_HOLD_get_ic_sda_hold(data)                                       ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC1_TX_ABRT_SOURCE                                                       0x98007C80
+#define ISO_IC1_TX_ABRT_SOURCE_reg_addr                                              "0xD8007C80"
+#define ISO_IC1_TX_ABRT_SOURCE_reg                                                   0xD8007C80
+#define set_ISO_IC1_TX_ABRT_SOURCE_reg(data)   (*((volatile unsigned int*) ISO_IC1_TX_ABRT_SOURCE_reg)=data)
+#define get_ISO_IC1_TX_ABRT_SOURCE_reg   (*((volatile unsigned int*) ISO_IC1_TX_ABRT_SOURCE_reg))
+#define ISO_IC1_TX_ABRT_SOURCE_inst_adr                                              "0x0020"
+#define ISO_IC1_TX_ABRT_SOURCE_inst                                                  0x0020
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slvrd_intx_shift                                 (15)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slvrd_intx_mask                                  (0x00008000)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slvrd_intx(data)                                 (0x00008000&((data)<<15))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slvrd_intx_src(data)                             ((0x00008000&(data))>>15)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_slvrd_intx(data)                             ((0x00008000&(data))>>15)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slv_arblost_shift                                (14)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slv_arblost_mask                                 (0x00004000)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slv_arblost(data)                                (0x00004000&((data)<<14))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slv_arblost_src(data)                            ((0x00004000&(data))>>14)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_slv_arblost(data)                            ((0x00004000&(data))>>14)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slvflush_txfifo_shift                            (13)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slvflush_txfifo_mask                             (0x00002000)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slvflush_txfifo(data)                            (0x00002000&((data)<<13))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_slvflush_txfifo_src(data)                        ((0x00002000&(data))>>13)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_slvflush_txfifo(data)                        ((0x00002000&(data))>>13)
+#define ISO_IC1_TX_ABRT_SOURCE_arb_lost_shift                                        (12)
+#define ISO_IC1_TX_ABRT_SOURCE_arb_lost_mask                                         (0x00001000)
+#define ISO_IC1_TX_ABRT_SOURCE_arb_lost(data)                                        (0x00001000&((data)<<12))
+#define ISO_IC1_TX_ABRT_SOURCE_arb_lost_src(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC1_TX_ABRT_SOURCE_get_arb_lost(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC1_TX_ABRT_SOURCE_arb_master_dis_shift                                  (11)
+#define ISO_IC1_TX_ABRT_SOURCE_arb_master_dis_mask                                   (0x00000800)
+#define ISO_IC1_TX_ABRT_SOURCE_arb_master_dis(data)                                  (0x00000800&((data)<<11))
+#define ISO_IC1_TX_ABRT_SOURCE_arb_master_dis_src(data)                              ((0x00000800&(data))>>11)
+#define ISO_IC1_TX_ABRT_SOURCE_get_arb_master_dis(data)                              ((0x00000800&(data))>>11)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_shift                             (10)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_mask                              (0x00000400)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10b_rd_norstrt(data)                             (0x00000400&((data)<<10))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_src(data)                         ((0x00000400&(data))>>10)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_10b_rd_norstrt(data)                         ((0x00000400&(data))>>10)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_sbyte_norstrt_shift                              (9)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_sbyte_norstrt_mask                               (0x00000200)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_sbyte_norstrt(data)                              (0x00000200&((data)<<9))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_sbyte_norstrt_src(data)                          ((0x00000200&(data))>>9)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_sbyte_norstrt(data)                          ((0x00000200&(data))>>9)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_hs_norstrt_shift                                 (8)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_hs_norstrt_mask                                  (0x00000100)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_hs_norstrt(data)                                 (0x00000100&((data)<<8))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_hs_norstrt_src(data)                             ((0x00000100&(data))>>8)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_hs_norstrt(data)                             ((0x00000100&(data))>>8)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_sbyte_ackdet_shift                               (7)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_sbyte_ackdet_mask                                (0x00000080)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_sbyte_ackdet(data)                               (0x00000080&((data)<<7))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_sbyte_ackdet_src(data)                           ((0x00000080&(data))>>7)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_sbyte_ackdet(data)                           ((0x00000080&(data))>>7)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_hs_ackdet_shift                                  (6)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_hs_ackdet_mask                                   (0x00000040)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_hs_ackdet(data)                                  (0x00000040&((data)<<6))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_hs_ackdet_src(data)                              ((0x00000040&(data))>>6)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_hs_ackdet(data)                              ((0x00000040&(data))>>6)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_gcall_read_shift                                 (5)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_gcall_read_mask                                  (0x00000020)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_gcall_read(data)                                 (0x00000020&((data)<<5))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_gcall_read_src(data)                             ((0x00000020&(data))>>5)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_gcall_read(data)                             ((0x00000020&(data))>>5)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_gcall_noack_shift                                (4)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_gcall_noack_mask                                 (0x00000010)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_gcall_noack(data)                                (0x00000010&((data)<<4))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_gcall_noack_src(data)                            ((0x00000010&(data))>>4)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_gcall_noack(data)                            ((0x00000010&(data))>>4)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_txdata_noack_shift                               (3)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_txdata_noack_mask                                (0x00000008)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_txdata_noack(data)                               (0x00000008&((data)<<3))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_txdata_noack_src(data)                           ((0x00000008&(data))>>3)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_txdata_noack(data)                           ((0x00000008&(data))>>3)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10addr2_noack_shift                              (2)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10addr2_noack_mask                               (0x00000004)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10addr2_noack(data)                              (0x00000004&((data)<<2))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10addr2_noack_src(data)                          ((0x00000004&(data))>>2)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_10addr2_noack(data)                          ((0x00000004&(data))>>2)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10addr1_noack_shift                              (1)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10addr1_noack_mask                               (0x00000002)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10addr1_noack(data)                              (0x00000002&((data)<<1))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_10addr1_noack_src(data)                          ((0x00000002&(data))>>1)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_10addr1_noack(data)                          ((0x00000002&(data))>>1)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_7b_addr_noack_shift                              (0)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_7b_addr_noack_mask                               (0x00000001)
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_7b_addr_noack(data)                              (0x00000001&((data)<<0))
+#define ISO_IC1_TX_ABRT_SOURCE_abrt_7b_addr_noack_src(data)                          ((0x00000001&(data))>>0)
+#define ISO_IC1_TX_ABRT_SOURCE_get_abrt_7b_addr_noack(data)                          ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_SLV_DATA_NACK_ONLY                                                   0x98007C84
+#define ISO_IC1_SLV_DATA_NACK_ONLY_reg_addr                                          "0xD8007C84"
+#define ISO_IC1_SLV_DATA_NACK_ONLY_reg                                               0xD8007C84
+#define set_ISO_IC1_SLV_DATA_NACK_ONLY_reg(data)   (*((volatile unsigned int*) ISO_IC1_SLV_DATA_NACK_ONLY_reg)=data)
+#define get_ISO_IC1_SLV_DATA_NACK_ONLY_reg   (*((volatile unsigned int*) ISO_IC1_SLV_DATA_NACK_ONLY_reg))
+#define ISO_IC1_SLV_DATA_NACK_ONLY_inst_adr                                          "0x0021"
+#define ISO_IC1_SLV_DATA_NACK_ONLY_inst                                              0x0021
+#define ISO_IC1_SLV_DATA_NACK_ONLY_nack_shift                                        (0)
+#define ISO_IC1_SLV_DATA_NACK_ONLY_nack_mask                                         (0x00000001)
+#define ISO_IC1_SLV_DATA_NACK_ONLY_nack(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC1_SLV_DATA_NACK_ONLY_nack_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC1_SLV_DATA_NACK_ONLY_get_nack(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_DMA_CR                                                               0x98007C88
+#define ISO_IC1_DMA_CR_reg_addr                                                      "0xD8007C88"
+#define ISO_IC1_DMA_CR_reg                                                           0xD8007C88
+#define set_ISO_IC1_DMA_CR_reg(data)   (*((volatile unsigned int*) ISO_IC1_DMA_CR_reg)=data)
+#define get_ISO_IC1_DMA_CR_reg   (*((volatile unsigned int*) ISO_IC1_DMA_CR_reg))
+#define ISO_IC1_DMA_CR_inst_adr                                                      "0x0022"
+#define ISO_IC1_DMA_CR_inst                                                          0x0022
+#define ISO_IC1_DMA_CR_tdmae_shift                                                   (1)
+#define ISO_IC1_DMA_CR_tdmae_mask                                                    (0x00000002)
+#define ISO_IC1_DMA_CR_tdmae(data)                                                   (0x00000002&((data)<<1))
+#define ISO_IC1_DMA_CR_tdmae_src(data)                                               ((0x00000002&(data))>>1)
+#define ISO_IC1_DMA_CR_get_tdmae(data)                                               ((0x00000002&(data))>>1)
+#define ISO_IC1_DMA_CR_rdmae_shift                                                   (0)
+#define ISO_IC1_DMA_CR_rdmae_mask                                                    (0x00000001)
+#define ISO_IC1_DMA_CR_rdmae(data)                                                   (0x00000001&((data)<<0))
+#define ISO_IC1_DMA_CR_rdmae_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_IC1_DMA_CR_get_rdmae(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_DMA_TDLR                                                             0x98007C8C
+#define ISO_IC1_DMA_TDLR_reg_addr                                                    "0xD8007C8C"
+#define ISO_IC1_DMA_TDLR_reg                                                         0xD8007C8C
+#define set_ISO_IC1_DMA_TDLR_reg(data)   (*((volatile unsigned int*) ISO_IC1_DMA_TDLR_reg)=data)
+#define get_ISO_IC1_DMA_TDLR_reg   (*((volatile unsigned int*) ISO_IC1_DMA_TDLR_reg))
+#define ISO_IC1_DMA_TDLR_inst_adr                                                    "0x0023"
+#define ISO_IC1_DMA_TDLR_inst                                                        0x0023
+#define ISO_IC1_DMA_TDLR_dmatdl_shift                                                (0)
+#define ISO_IC1_DMA_TDLR_dmatdl_mask                                                 (0x00000007)
+#define ISO_IC1_DMA_TDLR_dmatdl(data)                                                (0x00000007&((data)<<0))
+#define ISO_IC1_DMA_TDLR_dmatdl_src(data)                                            ((0x00000007&(data))>>0)
+#define ISO_IC1_DMA_TDLR_get_dmatdl(data)                                            ((0x00000007&(data))>>0)
+
+
+#define ISO_IC1_DMA_RDLR                                                             0x98007C90
+#define ISO_IC1_DMA_RDLR_reg_addr                                                    "0xD8007C90"
+#define ISO_IC1_DMA_RDLR_reg                                                         0xD8007C90
+#define set_ISO_IC1_DMA_RDLR_reg(data)   (*((volatile unsigned int*) ISO_IC1_DMA_RDLR_reg)=data)
+#define get_ISO_IC1_DMA_RDLR_reg   (*((volatile unsigned int*) ISO_IC1_DMA_RDLR_reg))
+#define ISO_IC1_DMA_RDLR_inst_adr                                                    "0x0024"
+#define ISO_IC1_DMA_RDLR_inst                                                        0x0024
+#define ISO_IC1_DMA_RDLR_dmardl_shift                                                (0)
+#define ISO_IC1_DMA_RDLR_dmardl_mask                                                 (0x0000000F)
+#define ISO_IC1_DMA_RDLR_dmardl(data)                                                (0x0000000F&((data)<<0))
+#define ISO_IC1_DMA_RDLR_dmardl_src(data)                                            ((0x0000000F&(data))>>0)
+#define ISO_IC1_DMA_RDLR_get_dmardl(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC1_SDA_SETUP                                                            0x98007C94
+#define ISO_IC1_SDA_SETUP_reg_addr                                                   "0xD8007C94"
+#define ISO_IC1_SDA_SETUP_reg                                                        0xD8007C94
+#define set_ISO_IC1_SDA_SETUP_reg(data)   (*((volatile unsigned int*) ISO_IC1_SDA_SETUP_reg)=data)
+#define get_ISO_IC1_SDA_SETUP_reg   (*((volatile unsigned int*) ISO_IC1_SDA_SETUP_reg))
+#define ISO_IC1_SDA_SETUP_inst_adr                                                   "0x0025"
+#define ISO_IC1_SDA_SETUP_inst                                                       0x0025
+#define ISO_IC1_SDA_SETUP_sda_setup_shift                                            (0)
+#define ISO_IC1_SDA_SETUP_sda_setup_mask                                             (0x000000FF)
+#define ISO_IC1_SDA_SETUP_sda_setup(data)                                            (0x000000FF&((data)<<0))
+#define ISO_IC1_SDA_SETUP_sda_setup_src(data)                                        ((0x000000FF&(data))>>0)
+#define ISO_IC1_SDA_SETUP_get_sda_setup(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC1_ACK_GENERAL_CALL                                                     0x98007C98
+#define ISO_IC1_ACK_GENERAL_CALL_reg_addr                                            "0xD8007C98"
+#define ISO_IC1_ACK_GENERAL_CALL_reg                                                 0xD8007C98
+#define set_ISO_IC1_ACK_GENERAL_CALL_reg(data)   (*((volatile unsigned int*) ISO_IC1_ACK_GENERAL_CALL_reg)=data)
+#define get_ISO_IC1_ACK_GENERAL_CALL_reg   (*((volatile unsigned int*) ISO_IC1_ACK_GENERAL_CALL_reg))
+#define ISO_IC1_ACK_GENERAL_CALL_inst_adr                                            "0x0026"
+#define ISO_IC1_ACK_GENERAL_CALL_inst                                                0x0026
+#define ISO_IC1_ACK_GENERAL_CALL_ack_gen_call_shift                                  (0)
+#define ISO_IC1_ACK_GENERAL_CALL_ack_gen_call_mask                                   (0x00000001)
+#define ISO_IC1_ACK_GENERAL_CALL_ack_gen_call(data)                                  (0x00000001&((data)<<0))
+#define ISO_IC1_ACK_GENERAL_CALL_ack_gen_call_src(data)                              ((0x00000001&(data))>>0)
+#define ISO_IC1_ACK_GENERAL_CALL_get_ack_gen_call(data)                              ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_ENABLE_STATUS                                                        0x98007C9C
+#define ISO_IC1_ENABLE_STATUS_reg_addr                                               "0xD8007C9C"
+#define ISO_IC1_ENABLE_STATUS_reg                                                    0xD8007C9C
+#define set_ISO_IC1_ENABLE_STATUS_reg(data)   (*((volatile unsigned int*) ISO_IC1_ENABLE_STATUS_reg)=data)
+#define get_ISO_IC1_ENABLE_STATUS_reg   (*((volatile unsigned int*) ISO_IC1_ENABLE_STATUS_reg))
+#define ISO_IC1_ENABLE_STATUS_inst_adr                                               "0x0027"
+#define ISO_IC1_ENABLE_STATUS_inst                                                   0x0027
+#define ISO_IC1_ENABLE_STATUS_slv_rx_data_lost_shift                                 (2)
+#define ISO_IC1_ENABLE_STATUS_slv_rx_data_lost_mask                                  (0x00000004)
+#define ISO_IC1_ENABLE_STATUS_slv_rx_data_lost(data)                                 (0x00000004&((data)<<2))
+#define ISO_IC1_ENABLE_STATUS_slv_rx_data_lost_src(data)                             ((0x00000004&(data))>>2)
+#define ISO_IC1_ENABLE_STATUS_get_slv_rx_data_lost(data)                             ((0x00000004&(data))>>2)
+#define ISO_IC1_ENABLE_STATUS_slv_disabled_whi_shift                                 (1)
+#define ISO_IC1_ENABLE_STATUS_slv_disabled_whi_mask                                  (0x00000002)
+#define ISO_IC1_ENABLE_STATUS_slv_disabled_whi(data)                                 (0x00000002&((data)<<1))
+#define ISO_IC1_ENABLE_STATUS_slv_disabled_whi_src(data)                             ((0x00000002&(data))>>1)
+#define ISO_IC1_ENABLE_STATUS_get_slv_disabled_whi(data)                             ((0x00000002&(data))>>1)
+#define ISO_IC1_ENABLE_STATUS_ic_en_shift                                            (0)
+#define ISO_IC1_ENABLE_STATUS_ic_en_mask                                             (0x00000001)
+#define ISO_IC1_ENABLE_STATUS_ic_en(data)                                            (0x00000001&((data)<<0))
+#define ISO_IC1_ENABLE_STATUS_ic_en_src(data)                                        ((0x00000001&(data))>>0)
+#define ISO_IC1_ENABLE_STATUS_get_ic_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define ISO_IC1_COMP_PARAM_1                                                         0x98007CF4
+#define ISO_IC1_COMP_PARAM_1_reg_addr                                                "0xD8007CF4"
+#define ISO_IC1_COMP_PARAM_1_reg                                                     0xD8007CF4
+#define set_ISO_IC1_COMP_PARAM_1_reg(data)   (*((volatile unsigned int*) ISO_IC1_COMP_PARAM_1_reg)=data)
+#define get_ISO_IC1_COMP_PARAM_1_reg   (*((volatile unsigned int*) ISO_IC1_COMP_PARAM_1_reg))
+#define ISO_IC1_COMP_PARAM_1_inst_adr                                                "0x003D"
+#define ISO_IC1_COMP_PARAM_1_inst                                                    0x003D
+#define ISO_IC1_COMP_PARAM_1_tx_buffer_depth_shift                                   (16)
+#define ISO_IC1_COMP_PARAM_1_tx_buffer_depth_mask                                    (0x00FF0000)
+#define ISO_IC1_COMP_PARAM_1_tx_buffer_depth(data)                                   (0x00FF0000&((data)<<16))
+#define ISO_IC1_COMP_PARAM_1_tx_buffer_depth_src(data)                               ((0x00FF0000&(data))>>16)
+#define ISO_IC1_COMP_PARAM_1_get_tx_buffer_depth(data)                               ((0x00FF0000&(data))>>16)
+#define ISO_IC1_COMP_PARAM_1_rx_buffer_depth_shift                                   (8)
+#define ISO_IC1_COMP_PARAM_1_rx_buffer_depth_mask                                    (0x0000FF00)
+#define ISO_IC1_COMP_PARAM_1_rx_buffer_depth(data)                                   (0x0000FF00&((data)<<8))
+#define ISO_IC1_COMP_PARAM_1_rx_buffer_depth_src(data)                               ((0x0000FF00&(data))>>8)
+#define ISO_IC1_COMP_PARAM_1_get_rx_buffer_depth(data)                               ((0x0000FF00&(data))>>8)
+#define ISO_IC1_COMP_PARAM_1_add_encoded_params_shift                                (7)
+#define ISO_IC1_COMP_PARAM_1_add_encoded_params_mask                                 (0x00000080)
+#define ISO_IC1_COMP_PARAM_1_add_encoded_params(data)                                (0x00000080&((data)<<7))
+#define ISO_IC1_COMP_PARAM_1_add_encoded_params_src(data)                            ((0x00000080&(data))>>7)
+#define ISO_IC1_COMP_PARAM_1_get_add_encoded_params(data)                            ((0x00000080&(data))>>7)
+#define ISO_IC1_COMP_PARAM_1_has_dma_shift                                           (6)
+#define ISO_IC1_COMP_PARAM_1_has_dma_mask                                            (0x00000040)
+#define ISO_IC1_COMP_PARAM_1_has_dma(data)                                           (0x00000040&((data)<<6))
+#define ISO_IC1_COMP_PARAM_1_has_dma_src(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC1_COMP_PARAM_1_get_has_dma(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC1_COMP_PARAM_1_intr_io_shift                                           (5)
+#define ISO_IC1_COMP_PARAM_1_intr_io_mask                                            (0x00000020)
+#define ISO_IC1_COMP_PARAM_1_intr_io(data)                                           (0x00000020&((data)<<5))
+#define ISO_IC1_COMP_PARAM_1_intr_io_src(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC1_COMP_PARAM_1_get_intr_io(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC1_COMP_PARAM_1_hc_count_values_shift                                   (4)
+#define ISO_IC1_COMP_PARAM_1_hc_count_values_mask                                    (0x00000010)
+#define ISO_IC1_COMP_PARAM_1_hc_count_values(data)                                   (0x00000010&((data)<<4))
+#define ISO_IC1_COMP_PARAM_1_hc_count_values_src(data)                               ((0x00000010&(data))>>4)
+#define ISO_IC1_COMP_PARAM_1_get_hc_count_values(data)                               ((0x00000010&(data))>>4)
+#define ISO_IC1_COMP_PARAM_1_max_speed_mode_shift                                    (2)
+#define ISO_IC1_COMP_PARAM_1_max_speed_mode_mask                                     (0x0000000C)
+#define ISO_IC1_COMP_PARAM_1_max_speed_mode(data)                                    (0x0000000C&((data)<<2))
+#define ISO_IC1_COMP_PARAM_1_max_speed_mode_src(data)                                ((0x0000000C&(data))>>2)
+#define ISO_IC1_COMP_PARAM_1_get_max_speed_mode(data)                                ((0x0000000C&(data))>>2)
+#define ISO_IC1_COMP_PARAM_1_apb_data_width_shift                                    (0)
+#define ISO_IC1_COMP_PARAM_1_apb_data_width_mask                                     (0x00000003)
+#define ISO_IC1_COMP_PARAM_1_apb_data_width(data)                                    (0x00000003&((data)<<0))
+#define ISO_IC1_COMP_PARAM_1_apb_data_width_src(data)                                ((0x00000003&(data))>>0)
+#define ISO_IC1_COMP_PARAM_1_get_apb_data_width(data)                                ((0x00000003&(data))>>0)
+
+
+#define ISO_IC1_COMP_VERSION                                                         0x98007CF8
+#define ISO_IC1_COMP_VERSION_reg_addr                                                "0xD8007CF8"
+#define ISO_IC1_COMP_VERSION_reg                                                     0xD8007CF8
+#define set_ISO_IC1_COMP_VERSION_reg(data)   (*((volatile unsigned int*) ISO_IC1_COMP_VERSION_reg)=data)
+#define get_ISO_IC1_COMP_VERSION_reg   (*((volatile unsigned int*) ISO_IC1_COMP_VERSION_reg))
+#define ISO_IC1_COMP_VERSION_inst_adr                                                "0x003E"
+#define ISO_IC1_COMP_VERSION_inst                                                    0x003E
+#define ISO_IC1_COMP_VERSION_ic_comp_version_shift                                   (0)
+#define ISO_IC1_COMP_VERSION_ic_comp_version_mask                                    (0xFFFFFFFF)
+#define ISO_IC1_COMP_VERSION_ic_comp_version(data)                                   (0xFFFFFFFF&((data)<<0))
+#define ISO_IC1_COMP_VERSION_ic_comp_version_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define ISO_IC1_COMP_VERSION_get_ic_comp_version(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IC1_COMP_TYPE                                                            0x98007CFC
+#define ISO_IC1_COMP_TYPE_reg_addr                                                   "0xD8007CFC"
+#define ISO_IC1_COMP_TYPE_reg                                                        0xD8007CFC
+#define set_ISO_IC1_COMP_TYPE_reg(data)   (*((volatile unsigned int*) ISO_IC1_COMP_TYPE_reg)=data)
+#define get_ISO_IC1_COMP_TYPE_reg   (*((volatile unsigned int*) ISO_IC1_COMP_TYPE_reg))
+#define ISO_IC1_COMP_TYPE_inst_adr                                                   "0x003F"
+#define ISO_IC1_COMP_TYPE_inst                                                       0x003F
+#define ISO_IC1_COMP_TYPE_ic_comp_type_shift                                         (0)
+#define ISO_IC1_COMP_TYPE_ic_comp_type_mask                                          (0xFFFFFFFF)
+#define ISO_IC1_COMP_TYPE_ic_comp_type(data)                                         (0xFFFFFFFF&((data)<<0))
+#define ISO_IC1_COMP_TYPE_ic_comp_type_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define ISO_IC1_COMP_TYPE_get_ic_comp_type(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_PWM_OCD                                                                  0x980070D0
+#define ISO_PWM_OCD_reg_addr                                                         "0xD80070D0"
+#define ISO_PWM_OCD_reg                                                              0xD80070D0
+#define set_ISO_PWM_OCD_reg(data)   (*((volatile unsigned int*) ISO_PWM_OCD_reg)=data)
+#define get_ISO_PWM_OCD_reg   (*((volatile unsigned int*) ISO_PWM_OCD_reg))
+#define ISO_PWM_OCD_inst_adr                                                         "0x0034"
+#define ISO_PWM_OCD_inst                                                             0x0034
+#define ISO_PWM_OCD_3_shift                                                          (24)
+#define ISO_PWM_OCD_3_mask                                                           (0xFF000000)
+#define ISO_PWM_OCD_3(data)                                                          (0xFF000000&((data)<<24))
+#define ISO_PWM_OCD_3_src(data)                                                      ((0xFF000000&(data))>>24)
+#define ISO_PWM_OCD_get_3(data)                                                      ((0xFF000000&(data))>>24)
+#define ISO_PWM_OCD_2_shift                                                          (16)
+#define ISO_PWM_OCD_2_mask                                                           (0x00FF0000)
+#define ISO_PWM_OCD_2(data)                                                          (0x00FF0000&((data)<<16))
+#define ISO_PWM_OCD_2_src(data)                                                      ((0x00FF0000&(data))>>16)
+#define ISO_PWM_OCD_get_2(data)                                                      ((0x00FF0000&(data))>>16)
+#define ISO_PWM_OCD_1_shift                                                          (8)
+#define ISO_PWM_OCD_1_mask                                                           (0x0000FF00)
+#define ISO_PWM_OCD_1(data)                                                          (0x0000FF00&((data)<<8))
+#define ISO_PWM_OCD_1_src(data)                                                      ((0x0000FF00&(data))>>8)
+#define ISO_PWM_OCD_get_1(data)                                                      ((0x0000FF00&(data))>>8)
+#define ISO_PWM_OCD_0_shift                                                          (0)
+#define ISO_PWM_OCD_0_mask                                                           (0x000000FF)
+#define ISO_PWM_OCD_0(data)                                                          (0x000000FF&((data)<<0))
+#define ISO_PWM_OCD_0_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ISO_PWM_OCD_get_0(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_PWM_CD                                                                   0x980070D4
+#define ISO_PWM_CD_reg_addr                                                          "0xD80070D4"
+#define ISO_PWM_CD_reg                                                               0xD80070D4
+#define set_ISO_PWM_CD_reg(data)   (*((volatile unsigned int*) ISO_PWM_CD_reg)=data)
+#define get_ISO_PWM_CD_reg   (*((volatile unsigned int*) ISO_PWM_CD_reg))
+#define ISO_PWM_CD_inst_adr                                                          "0x0035"
+#define ISO_PWM_CD_inst                                                              0x0035
+#define ISO_PWM_CD_3_shift                                                           (24)
+#define ISO_PWM_CD_3_mask                                                            (0xFF000000)
+#define ISO_PWM_CD_3(data)                                                           (0xFF000000&((data)<<24))
+#define ISO_PWM_CD_3_src(data)                                                       ((0xFF000000&(data))>>24)
+#define ISO_PWM_CD_get_3(data)                                                       ((0xFF000000&(data))>>24)
+#define ISO_PWM_CD_2_shift                                                           (16)
+#define ISO_PWM_CD_2_mask                                                            (0x00FF0000)
+#define ISO_PWM_CD_2(data)                                                           (0x00FF0000&((data)<<16))
+#define ISO_PWM_CD_2_src(data)                                                       ((0x00FF0000&(data))>>16)
+#define ISO_PWM_CD_get_2(data)                                                       ((0x00FF0000&(data))>>16)
+#define ISO_PWM_CD_1_shift                                                           (8)
+#define ISO_PWM_CD_1_mask                                                            (0x0000FF00)
+#define ISO_PWM_CD_1(data)                                                           (0x0000FF00&((data)<<8))
+#define ISO_PWM_CD_1_src(data)                                                       ((0x0000FF00&(data))>>8)
+#define ISO_PWM_CD_get_1(data)                                                       ((0x0000FF00&(data))>>8)
+#define ISO_PWM_CD_0_shift                                                           (0)
+#define ISO_PWM_CD_0_mask                                                            (0x000000FF)
+#define ISO_PWM_CD_0(data)                                                           (0x000000FF&((data)<<0))
+#define ISO_PWM_CD_0_src(data)                                                       ((0x000000FF&(data))>>0)
+#define ISO_PWM_CD_get_0(data)                                                       ((0x000000FF&(data))>>0)
+
+
+#define ISO_PWM_CSD                                                                  0x980070D8
+#define ISO_PWM_CSD_reg_addr                                                         "0xD80070D8"
+#define ISO_PWM_CSD_reg                                                              0xD80070D8
+#define set_ISO_PWM_CSD_reg(data)   (*((volatile unsigned int*) ISO_PWM_CSD_reg)=data)
+#define get_ISO_PWM_CSD_reg   (*((volatile unsigned int*) ISO_PWM_CSD_reg))
+#define ISO_PWM_CSD_inst_adr                                                         "0x0036"
+#define ISO_PWM_CSD_inst                                                             0x0036
+#define ISO_PWM_CSD_3_shift                                                          (12)
+#define ISO_PWM_CSD_3_mask                                                           (0x0000F000)
+#define ISO_PWM_CSD_3(data)                                                          (0x0000F000&((data)<<12))
+#define ISO_PWM_CSD_3_src(data)                                                      ((0x0000F000&(data))>>12)
+#define ISO_PWM_CSD_get_3(data)                                                      ((0x0000F000&(data))>>12)
+#define ISO_PWM_CSD_2_shift                                                          (8)
+#define ISO_PWM_CSD_2_mask                                                           (0x00000F00)
+#define ISO_PWM_CSD_2(data)                                                          (0x00000F00&((data)<<8))
+#define ISO_PWM_CSD_2_src(data)                                                      ((0x00000F00&(data))>>8)
+#define ISO_PWM_CSD_get_2(data)                                                      ((0x00000F00&(data))>>8)
+#define ISO_PWM_CSD_1_shift                                                          (4)
+#define ISO_PWM_CSD_1_mask                                                           (0x000000F0)
+#define ISO_PWM_CSD_1(data)                                                          (0x000000F0&((data)<<4))
+#define ISO_PWM_CSD_1_src(data)                                                      ((0x000000F0&(data))>>4)
+#define ISO_PWM_CSD_get_1(data)                                                      ((0x000000F0&(data))>>4)
+#define ISO_PWM_CSD_0_shift                                                          (0)
+#define ISO_PWM_CSD_0_mask                                                           (0x0000000F)
+#define ISO_PWM_CSD_0(data)                                                          (0x0000000F&((data)<<0))
+#define ISO_PWM_CSD_0_src(data)                                                      ((0x0000000F&(data))>>0)
+#define ISO_PWM_CSD_get_0(data)                                                      ((0x0000000F&(data))>>0)
+
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtd129x_clk.c b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtd129x_clk.c
new file mode 100644
index 00000000..c2b0ca2
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtd129x_clk.c
@@ -0,0 +1,946 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+
+#include <linux/clk.h>   // clk_get
+#include <linux/clk-provider.h>
+#include <linux/reset.h> // reset_control_get
+#include <linux/delay.h>
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include <soc/realtek/power-control.h>
+#include <soc/realtek/rtk_cpu.h>
+#include "rtl865x_asicBasic.h"
+#include "rtl865x_asicCom.h"
+#include "rtl865x_asicL2.h"
+#include "asicRegs.h"
+#include "crt_sys_reg.h"
+#include "iso_reg.h"
+#include "sb2_reg.h"
+#include "sata_reg.h"
+
+//#define RTL_DEBUG       1
+#ifdef RTL_DEBUG
+#define DBG(fmt, ...) printk(KERN_ERR "%s:%d: " fmt "\n", \
+			__func__, __LINE__, ## __VA_ARGS__)
+#else
+#define DBG(fmt, ...)
+#endif
+
+#define CLK_SYS_PHYSICAL_BASE	SYS_SOFT_RESET1
+#define CLK_SYS_LEN		0x20000
+extern void __iomem *rtl_hwnat_clk_mmio;
+#define CLK_SYS_READ_MEM32(reg)		READ_MEM32((reg - CLK_SYS_PHYSICAL_BASE + (uintptr_t)rtl_hwnat_clk_mmio))
+#define CLK_SYS_WRITE_MEM32(reg, val)	WRITE_MEM32((reg - CLK_SYS_PHYSICAL_BASE + (uintptr_t)rtl_hwnat_clk_mmio), val)
+
+#define SATA_WRP_PHYSICAL_BASE	SATA_SATA_MAC_IN
+#define SATA_WRP_LEN		0x100
+extern void __iomem *rtl_hwnat_sata_mmio;
+#define SATA_WRP_READ_MEM32(reg)	READ_MEM32((reg - SATA_WRP_PHYSICAL_BASE + (uintptr_t)rtl_hwnat_sata_mmio))
+#define SATA_WRP_WRITE_MEM32(reg, val)	WRITE_MEM32((reg - SATA_WRP_PHYSICAL_BASE + (uintptr_t)rtl_hwnat_sata_mmio), val)
+
+extern rtl8651_tblAsic_ethernet_t	rtl8651AsicEthernetTable[];
+extern uint8 hwnat_mac0_enable; /* 0: interface used by SATA, 1: interface used by NAT */
+extern uint8 hwnat_mac0_mode; /* 0:RGMII to PHY, 1:SGMII to PHY, 2: RGMII to MAC, 3: SGMII to MAC */
+extern uint8 hwnat_mac5_conn_to; /* 0:PHY, 1:MAC */
+extern uint8 hwnat_rgmii_voltage; /* 1:1.8V, 2:2.5V, 3:3.3V */
+extern uint8 hwnat_rgmii_enable; /* 0:disable, 1:enable */
+
+void rtd129x_hwnat_set_sata_pllddsa(struct device *dev)
+{
+	uint32 val;
+	/* GET reset control */
+	struct reset_control *rstc_sata_0 = reset_control_get(dev, "sata_0");
+	struct reset_control *rstc_sata_phy_0 = reset_control_get(dev, "sata_phy_0");
+	struct reset_control *rstc_sata_phy_pow_0 = reset_control_get(dev, "sata_phy_pow_0");
+	struct reset_control *rstc_sata_func_exist_0 = reset_control_get(dev, "sata_func_exist_0");
+	struct reset_control *rstc_sds_phy = reset_control_get(dev, "rstn_sds_phy");
+
+	/* GET clock */
+	struct clk *clk_en_sata_0 = clk_get(dev, "sata_0");
+	struct clk *clk_en_sata_alive_0 = clk_get(dev, "sata_alive_0");
+	struct clk *clk_en_sata_1 = clk_get(dev, "sata_1");
+	struct clk *clk_en_sata_alive_1 = clk_get(dev, "sata_alive_1");
+
+	/* release SATA0 reset */
+	#if 1
+	/* DEASSERT: set rstn bit to 1 */
+	reset_control_deassert(rstc_sata_0);
+	reset_control_deassert(rstc_sata_phy_0);
+	reset_control_deassert(rstc_sata_phy_pow_0);
+	reset_control_deassert(rstc_sata_func_exist_0);
+	#else
+	val = CLK_SYS_READ_MEM32(SYS_SOFT_RESET1);
+	val |= (1 << SYS_SOFT_RESET1_rstn_sata_0_shift);
+	val |= (1 << SYS_SOFT_RESET1_rstn_sata_phy_0_shift);
+	val |= (1 << SYS_SOFT_RESET1_rstn_sata_phy_pow_0_shift);
+	val |= (1 << SYS_SOFT_RESET1_sata_func_exist_0_shift);
+	CLK_SYS_WRITE_MEM32(SYS_SOFT_RESET1, val);
+	#endif
+	mdelay(10);
+
+	/* SATA0 clock enable */
+	#if 1
+	clk_prepare_enable(clk_en_sata_0);
+	clk_prepare_enable(clk_en_sata_alive_0);
+	#else
+	val = CLK_SYS_READ_MEM32(SYS_CLOCK_ENABLE1);
+	val |= (1 << SYS_CLOCK_ENABLE1_clk_en_sata_0_shift);
+	val |= (1 << SYS_CLOCK_ENABLE1_clk_en_sata_alive_0_shift);
+	CLK_SYS_WRITE_MEM32(SYS_CLOCK_ENABLE1, val);
+	#endif
+	mdelay(10);
+
+	/* SATA1 clock enable */
+	#if 1
+	clk_prepare_enable(clk_en_sata_1);
+	clk_prepare_enable(clk_en_sata_alive_1);
+	#else
+	val = CLK_SYS_READ_MEM32(SYS_CLOCK_ENABLE2);
+	val |= (1 << SYS_CLOCK_ENABLE2_clk_en_sata_1_shift);
+	val |= (1 << SYS_CLOCK_ENABLE2_clk_en_sata_alive_1_shift);
+	CLK_SYS_WRITE_MEM32(SYS_CLOCK_ENABLE2, val);
+	#endif
+	mdelay(10);
+
+	/* release SERDES reset */
+	#if 1
+	/* DEASSERT: set rstn bit to 1 */
+	reset_control_deassert(rstc_sds_phy);
+	#else
+	val = CLK_SYS_READ_MEM32(SYS_SOFT_RESET2);
+	val |= (1 << SYS_SOFT_RESET2_rstn_sds_phy_shift);
+	CLK_SYS_WRITE_MEM32(SYS_SOFT_RESET2, val);
+	#endif
+	mdelay(10);
+
+	/* PLL DDSA turn on */
+	CLK_SYS_WRITE_MEM32(SYS_PLL_SSC_DIG_DDSA1, 0x6800);
+
+	val = CLK_SYS_READ_MEM32(SYS_PLL_DDSA2);
+	val |= (1 << SYS_PLL_DDSA2_REG_PLLDDSA_POW_shift);
+	val |= (1 << SYS_PLL_DDSA2_REG_PLLDDSA_RSTB_shift);
+	CLK_SYS_WRITE_MEM32(SYS_PLL_DDSA2, val);
+
+	udelay(1000);
+
+	val = CLK_SYS_READ_MEM32(SYS_PLL_DDSA2);
+	val &= ~(1 << SYS_PLL_DDSA2_REG_PLLDDSA_OEB_shift);
+	CLK_SYS_WRITE_MEM32(SYS_PLL_DDSA2, val);
+
+	udelay(1000);
+
+	val = CLK_SYS_READ_MEM32(SYS_PLL_SSC_DIG_DDSA0);
+	val &= ~(1 << SYS_PLL_SSC_DIG_DDSA0_REG_GRAN_AUTO_RST_DDSA_shift);
+	val |= (1 << SYS_PLL_SSC_DIG_DDSA0_RSTB_DDSA_shift);
+	CLK_SYS_WRITE_MEM32(SYS_PLL_SSC_DIG_DDSA0, val);
+
+	udelay(1000);
+
+	val = CLK_SYS_READ_MEM32(SYS_PLL_SSC_DIG_DDSA0);
+	val |= (1 << SYS_PLL_SSC_DIG_DDSA0_OC_EN_DDSA_shift);
+	CLK_SYS_WRITE_MEM32(SYS_PLL_SSC_DIG_DDSA0, val);
+	mdelay(50);
+
+	reset_control_put(rstc_sata_0);
+	reset_control_put(rstc_sata_phy_0);
+	reset_control_put(rstc_sata_phy_pow_0);
+	reset_control_put(rstc_sata_func_exist_0);
+	reset_control_put(rstc_sds_phy);
+}
+
+void rtd129x_hwnat_set_pllddsb(struct device *dev)
+{
+	uint32 val;
+	struct clk *clk_pllddsb = clk_get(dev, "pll_ddsb");
+
+	/* check if it is alreay set */
+	val = CLK_SYS_READ_MEM32(SYS_PLL_DDSB2);
+	if (SYS_PLL_DDSB2_get_REG_PLLDDSB_OEB(val) == 0 /* enable */) {
+		clk_prepare_enable(clk_pllddsb);
+		return;
+	}
+
+	/* 432MHz */
+	CLK_SYS_WRITE_MEM32(SYS_PLL_SSC_DIG_DDSB1, 0x6800);
+
+	/* PLLDDSB power on */
+	val = CLK_SYS_READ_MEM32(SYS_PLL_DDSB2);
+	val |= 1 << SYS_PLL_DDSB2_REG_PLLDDSB_POW_shift; /* power on */
+	val |= 1 << SYS_PLL_DDSB2_REG_PLLDDSB_RSTB_shift; /* test clock enable */
+	CLK_SYS_WRITE_MEM32(SYS_PLL_DDSB2, val);
+
+	udelay(1000);
+
+	/* CLK_PLLDDSB output enable control */
+	val = CLK_SYS_READ_MEM32(SYS_PLL_DDSB2);
+	val &= ~(1 << SYS_PLL_DDSB2_REG_PLLDDSB_OEB_shift); /* enable */
+	CLK_SYS_WRITE_MEM32(SYS_PLL_DDSB2, val);
+	clk_prepare_enable(clk_pllddsb);
+}
+
+void rtd129x_hwnat_reset_nat(struct device *dev)
+{
+	/* GET clock */
+	struct clk *clk_en_nat = clk_get(dev, "nat");
+
+	/* GET reset control */
+	struct reset_control *rstc_nat = reset_control_get(dev, "nat");
+
+	/* GET power control */
+	struct power_control *pctrl = power_control_get("pctrl_nat");
+
+	clk_disable_unprepare(clk_en_nat);
+	reset_control_assert(rstc_nat);
+
+	power_control_power_off(pctrl);
+
+	mdelay(10);
+
+	power_control_power_on(pctrl);
+
+	reset_control_deassert(rstc_nat);
+	clk_prepare_enable(clk_en_nat);
+
+	reset_control_put(rstc_nat);
+}
+
+void rtd129x_hwnat_set_etn_clk(struct device *dev)
+{
+	uint32 val;
+	/* GET clock */
+	struct clk *clk_en_nat = clk_get(dev, "nat");
+	struct clk *clk_en_etn_sys = clk_get(dev, "etn_sys");
+	struct clk *clk_en_etn_250m = clk_get(dev, "etn_250m");
+
+	/* GET reset control */
+	struct reset_control *rstc_gmac = reset_control_get(dev, "gmac");
+	struct reset_control *rstc_gphy = reset_control_get(dev, "gphy");
+	struct reset_control *rstc_nat = reset_control_get(dev, "nat");
+
+	/* check if it is alreay set */
+	#if 1
+	if (__clk_is_enabled(clk_en_nat) == 1 /* enable */)
+		return;
+	#else
+	val = CLK_SYS_READ_MEM32(SYS_CLOCK_ENABLE2);
+	if (SYS_CLOCK_ENABLE2_get_clk_en_nat(val) == 1 /* enable */)
+		return;
+	#endif
+
+	/* reset bit of gphy */
+	#if 1
+	/* DEASSERT: set rstn bit to 1 */
+	reset_control_deassert(rstc_gmac);
+	reset_control_deassert(rstc_gphy);
+	#else
+	val = CLK_SYS_READ_MEM32(ISO_SOFT_RESET);
+	val |= 1 << ISO_SOFT_RESET_rstn_gmac_shift; /* reset gmac */
+	val |= 1 << ISO_SOFT_RESET_rstn_gphy_shift; /* reset gphy */
+	CLK_SYS_WRITE_MEM32(ISO_SOFT_RESET, val);
+	#endif
+
+	udelay(1000);
+
+	/* Ethernet Boot up bypass gphy ready mode */
+	val = CLK_SYS_READ_MEM32(ISO_ETN_TESTIO);
+	val &= ~(1 << ISO_ETN_TESTIO_etn_bpsgphy_mode_shift); /* no-bypass */
+	CLK_SYS_WRITE_MEM32(ISO_ETN_TESTIO, val);
+
+	/* Ethernet Boot up disable dbus clock gating */
+	val = CLK_SYS_READ_MEM32(ISO_ETN_DBUS_CTRL);
+	val &= ~(1 << ISO_ETN_DBUS_CTRL_iso_etn_pwr_ctrl_en_shift); /* disable */
+	CLK_SYS_WRITE_MEM32(ISO_ETN_DBUS_CTRL, val);
+
+	/* clock enable bit for etn clock & etn 250MHz */
+	#if 1
+	clk_prepare_enable(clk_en_etn_sys);
+	clk_prepare_enable(clk_en_etn_250m);
+	#else
+	val = CLK_SYS_READ_MEM32(ISO_CLOCK_ENABLE);
+	val |= 1 << ISO_CLOCK_ENABLE_clk_en_etn_sys_shift;
+	val |= 1 << ISO_CLOCK_ENABLE_clk_en_etn_250m_shift;
+	CLK_SYS_WRITE_MEM32(ISO_CLOCK_ENABLE, val);
+	#endif
+
+	/* clock enable bit for etn clock & etn 250MHz */
+	#if 1
+	clk_disable_unprepare(clk_en_etn_sys);
+	clk_disable_unprepare(clk_en_etn_250m);
+	#else
+	val = CLK_SYS_READ_MEM32(ISO_CLOCK_ENABLE);
+	val &= ~(1 << ISO_CLOCK_ENABLE_clk_en_etn_sys_shift);
+	val &= ~(1 << ISO_CLOCK_ENABLE_clk_en_etn_250m_shift);
+	CLK_SYS_WRITE_MEM32(ISO_CLOCK_ENABLE, val);
+	#endif
+
+	/* reset bit of gmac */
+	#if 1
+	/* DEASSERT: set rstn bit to 1 */
+	reset_control_deassert(rstc_gmac);
+	#else
+	val = CLK_SYS_READ_MEM32(ISO_SOFT_RESET);
+	val |= 1 << ISO_SOFT_RESET_rstn_gmac_shift;
+	CLK_SYS_WRITE_MEM32(ISO_SOFT_RESET, val);
+	#endif
+
+	udelay(1000);
+
+	/* clock enable bit for NAT */
+	#if 1
+	clk_prepare_enable(clk_en_nat);
+	#else
+	val = CLK_SYS_READ_MEM32(SYS_CLOCK_ENABLE2);
+	val |= 1 << SYS_CLOCK_ENABLE2_clk_en_nat_shift; /* enable */
+	CLK_SYS_WRITE_MEM32(SYS_CLOCK_ENABLE2, val);
+	#endif
+
+	/* clock enable bit for NAT */
+	#if 1
+	clk_disable_unprepare(clk_en_nat);
+	#else
+	val = CLK_SYS_READ_MEM32(SYS_CLOCK_ENABLE2);
+	val &= ~(1 << SYS_CLOCK_ENABLE2_clk_en_nat_shift); /* disable */
+	CLK_SYS_WRITE_MEM32(SYS_CLOCK_ENABLE2, val);
+	#endif
+
+	/* reset bit of NAT */
+	#if 1
+	/* DEASSERT: set rstn bit to 1 */
+	reset_control_deassert(rstc_nat);
+	#else
+	val = CLK_SYS_READ_MEM32(SYS_SOFT_RESET1);
+	val |= (1 << SYS_SOFT_RESET1_rstn_nat_shift); /* reset */
+	CLK_SYS_WRITE_MEM32(SYS_SOFT_RESET1, val);
+	#endif
+
+	/* clock enable bit for NAT */
+	#if 1
+	clk_prepare_enable(clk_en_nat);
+	#else
+	val = CLK_SYS_READ_MEM32(SYS_CLOCK_ENABLE2);
+	val |= 1 << SYS_CLOCK_ENABLE2_clk_en_nat_shift; /* enable */
+	CLK_SYS_WRITE_MEM32(SYS_CLOCK_ENABLE2, val);
+	#endif
+
+	reset_control_put(rstc_gmac);
+	reset_control_put(rstc_gphy);
+	reset_control_put(rstc_nat);
+}
+
+static void set_ext_phy(uint32_t phyid, uint32_t page, uint32_t reg, uint32_t val)
+{
+	/* change to the page */
+	rtl8651_setAsicEthernetPHYReg(phyid, 31, page);
+
+	/* write PHY reg */
+	rtl8651_setAsicEthernetPHYReg(phyid, reg, val);
+
+	/* change to page 0 */
+	rtl8651_setAsicEthernetPHYReg(phyid, 31, 0);
+}
+
+static uint32_t get_ext_phy(uint32_t phyid, uint32_t page, uint32_t reg)
+{
+	uint32_t val;
+
+	/* change to the page */
+	rtl8651_setAsicEthernetPHYReg(phyid, 31, page);
+
+	/* read PHY reg */
+	rtl8651_getAsicEthernetPHYReg(phyid, reg, &val);
+
+	/* change to page 0 */
+	rtl8651_setAsicEthernetPHYReg(phyid, 31, 0);
+
+	return val;
+}
+
+void rtd129x_hwnat_set_rgmii0_init(void)
+{
+	uint32_t val;
+
+	if (hwnat_rgmii_enable > 0) {
+	/* Mux to MDC/MDIO */
+	CLK_SYS_WRITE_MEM32(SB2_MUXPAD_RG0, 0x05555555);
+	}
+
+	/* SB2 spec, 1.8V/2.5V/3.3V */
+	switch (hwnat_rgmii_voltage){
+	case 1: /* 1.8V */
+		/* RGMII0 pad slew-rate control */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG0, 0); /* fast */
+
+		/* RGMII0 TXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG1, 0x44444444); /* 4mA */
+
+		/* RGMII0 RXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG2, 0x24444444); /* 4mA */
+		break;
+	case 2: /* 2.5V */
+		/* RGMII0 pad slew-rate control */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG0, 0); /* fast */
+
+		/* RGMII0 TXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG1, 0x44444444); /* 4mA */
+
+		/* RGMII0 RXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG2, 0x64444444);
+		break;
+	case 3: /* 3.3V */
+	default:
+		/* RGMII0 pad slew-rate control */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG0, 0x3f);
+
+		/* RGMII0 TXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG1, 0);
+
+		/* RGMII0 RXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG2, 0xa4000000);
+	}
+
+	/* switch gphy channel for internal control */
+	val = CLK_SYS_READ_MEM32(ISO_POWERCUT_ETN);
+	val &= ~(1 << ISO_POWERCUT_ETN_gphy_mdio_outside_ctrl_en_shift); /* internal */
+	CLK_SYS_WRITE_MEM32(ISO_POWERCUT_ETN, val);
+
+	/* switch gphy channel for NAT */
+	val = CLK_SYS_READ_MEM32(ISO_POWERCUT_ETN);
+	val |= (1 << ISO_POWERCUT_ETN_etn_gphy_switch_nat_shift); /* NAT */
+	CLK_SYS_WRITE_MEM32(ISO_POWERCUT_ETN, val);
+}
+
+void rtd129x_hwnat_set_rgmii1_init(void)
+{
+	uint32_t val;
+
+	if (hwnat_rgmii_enable > 0) {
+	/* Mux to MDC/MDIO */
+	CLK_SYS_WRITE_MEM32(SB2_MUXPAD_RG1, 0x05555555);
+
+	/* SB2 spec, mux MDC&MDIO pin for RGMII */
+	val = CLK_SYS_READ_MEM32(SB2_MUXPAD_RG0) & ~(0xf << SB2_MUXPAD_RG0_rgmii0_mdio_shift);
+	val |= 0x5 << SB2_MUXPAD_RG0_rgmii0_mdio_shift;
+	CLK_SYS_WRITE_MEM32(SB2_MUXPAD_RG0, val);
+	}
+
+	/* SB2 spec, 1.8V/2.5V/3.3V */
+	switch (hwnat_rgmii_voltage){
+	case 1: /* 1.8V */
+		/* RGMII1 pad slew-rate control */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG3, 0); /* fast */
+
+		/* RGMII1 TXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG4, 0x44444444); /* 4mA */
+
+		/* RGMII1 RXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG5, 0x24004444);
+		break;
+	case 2: /* 2.5V */
+		/* RGMII1 pad slew-rate control */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG3, 0); /* fast */
+
+		/* RGMII1 TXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG4, 0x44444444); /* 4mA */
+
+		/* RGMII1 RXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG5, 0x64004444);
+		break;
+	case 3: /* 3.3V */
+	default:
+		/* RGMII1 pad slew-rate control */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG3, 0x3f);
+
+		/* RGMII1 TXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG4, 0);
+
+		/* RGMII1 RXD pad driven current selection */
+		CLK_SYS_WRITE_MEM32(SB2_PFUNC_RG5, 0xa4000000);
+	}
+
+	/* switch gphy channel for internal control */
+	val = CLK_SYS_READ_MEM32(ISO_POWERCUT_ETN);
+	val &= ~(1 << ISO_POWERCUT_ETN_gphy_mdio_outside_ctrl_en_shift); /* internal */
+	CLK_SYS_WRITE_MEM32(ISO_POWERCUT_ETN, val);
+
+	/* switch gphy channel for NAT */
+	val = CLK_SYS_READ_MEM32(ISO_POWERCUT_ETN);
+	val |= (1 << ISO_POWERCUT_ETN_etn_gphy_switch_nat_shift); /* NAT */
+	CLK_SYS_WRITE_MEM32(ISO_POWERCUT_ETN, val);
+}
+
+static uint32_t rtd129x_hwnat_set_serdes_sgmii_init(void)
+{
+	uint32 val;
+	uint32 cnt;
+
+	/* SB2, PHY select as SGMII */
+	/* RX50 ohms turn on, MBias enable, Band Gap enable */
+	val = CLK_SYS_READ_MEM32(SB2_SATA_PHY_CTRL);
+	val |= (1 << SB2_SATA_PHY_CTRL_sata_bg_en_0_shift);
+	val |= (1 << SB2_SATA_PHY_CTRL_sata_mbias_en_0_shift);
+	val |= (1 << SB2_SATA_PHY_CTRL_sata_rx50_link_0_shift);
+	CLK_SYS_WRITE_MEM32(SB2_SATA_PHY_CTRL, val);
+	mdelay(50);
+	DBG("SB2_SATA_PHY_CTRL 0x%08x = 0x%08x, val = 0x%08x", SB2_SATA_PHY_CTRL, CLK_SYS_READ_MEM32(SB2_SATA_PHY_CTRL), val);
+
+	/* switch to SGMII */
+	val = CLK_SYS_READ_MEM32(SB2_SATA_PHY_CTRL);
+	val &= ~(1 << SB2_SATA_PHY_CTRL_sata_sgmii_sel_shift);
+	CLK_SYS_WRITE_MEM32(SB2_SATA_PHY_CTRL, val);
+	mdelay(200);
+	DBG("SB2_SATA_PHY_CTRL 0x%08x = 0x%08x, val = 0x%08x", SB2_SATA_PHY_CTRL, CLK_SYS_READ_MEM32(SB2_SATA_PHY_CTRL), val);
+
+	/* Beginning of SATA PHY register tuning */
+	/* SATA DPHY control by NAT enable */
+	val = READ_MEM32(NAT_WRP_SERDES);
+	val |= (1 << NAT_WRP_SERDES_sata_phy_mdio_en_shift);
+	WRITE_MEM32(NAT_WRP_SERDES, val);
+	DBG("NAT_WRP_SERDES 0x%lx = 0x%08x, val = 0x%08x", NAT_WRP_SERDES, READ_MEM32(NAT_WRP_SERDES), val);
+
+	/* SATA PHY reg13[8:7]=00, choose 1.25GHz */
+	/* PHY ID 6 means SATA SGMII internal PHY */
+	rtl8651_getAsicEthernetPHYReg(6, 13, &val);
+	val &= ~(3 << 7);
+	rtl8651_setAsicEthernetPHYReg(6, 13, val);
+	mdelay(50);
+	DBG("SATA PHY ID 6 reg 13 = 0x%08x", val);
+
+	/* 5GHz tuning */
+	rtl8651_setAsicEthernetPHYReg(6, 4, 0x52f5);
+	mdelay(50);
+	rtl8651_setAsicEthernetPHYReg(6, 5, 0xead7);
+	mdelay(50);
+	rtl8651_setAsicEthernetPHYReg(6, 6, 0x000c);
+	mdelay(50);
+	rtl8651_setAsicEthernetPHYReg(6, 10, 0xa653);
+	mdelay(50);
+	rtl8651_setAsicEthernetPHYReg(6, 1, 0xa860);
+	mdelay(200);
+	rtl8651_setAsicEthernetPHYReg(7, 0, 0xd433);
+	mdelay(50);
+	rtl8651_setAsicEthernetPHYReg(7, 1, 0x22aa);
+	mdelay(50);
+
+	/* Ending of SATA PHY register tuning */
+	/* SATA DPHY control by SATA enable */
+	val = READ_MEM32(NAT_WRP_SERDES);
+	val &= ~(1 << NAT_WRP_SERDES_sata_phy_mdio_en_shift);
+	WRITE_MEM32(NAT_WRP_SERDES, val);
+	DBG("NAT_WRP_SERDES 0x%lx = 0x%08x, val = 0x%08x", NAT_WRP_SERDES, READ_MEM32(NAT_WRP_SERDES), val);
+
+	/* SERDES IP clock enable */
+	val = READ_MEM32(NAT_WRP_SERDES);
+	val |= (1 << NAT_WRP_SERDES_serdes_clk_en_shift);
+	WRITE_MEM32(NAT_WRP_SERDES, val);
+	mdelay(50);
+	DBG("NAT_WRP_SERDES 0x%lx = 0x%08x, val = 0x%08x", NAT_WRP_SERDES, READ_MEM32(NAT_WRP_SERDES), val);
+
+	/* Sdsif IP clock enable */
+	val = READ_MEM32(NAT_WRP_SERDES);
+	val |= (1 << NAT_WRP_SERDES_sdsif_clk_en_shift);
+	WRITE_MEM32(NAT_WRP_SERDES, val);
+	mdelay(50);
+	DBG("NAT_WRP_SERDES 0x%lx = 0x%08x, val = 0x%08x", NAT_WRP_SERDES, READ_MEM32(NAT_WRP_SERDES), val);
+
+	/* wait for phy ready, clock fine-tuned */
+#define PHY_RETRY_CNT	30
+	for (cnt = 0; cnt < PHY_RETRY_CNT; cnt++) {
+		mdelay(100);
+		val = SATA_WRP_READ_MEM32(SATA_SATA_PHY_MON);
+		if (SATA_SATA_PHY_MON_get_phy_calibrated_0(val) == 1 &&
+			SATA_SATA_PHY_MON_get_phy_rdy_0(val) == 1)
+			break;
+	}
+	if (cnt >= PHY_RETRY_CNT) {
+		printk("Wait SATA_SATA_PHY_MON timeout, val = 0x%08x\n", val);
+		return 1;
+	} else
+		DBG("cnt = %d", cnt);
+
+	/* SERDES/NAT spec, SERDES auto mode */
+	val = READ_MEM32(HWNAT_SERDES_SDS_REG02);
+	val &= ~(3 << 8);
+	WRITE_MEM32(HWNAT_SERDES_SDS_REG02, val);
+
+	/* wait for SERDES link up */
+#define SERDES_RETRY_CNT	30
+	for (cnt = 0; cnt < SERDES_RETRY_CNT; cnt++) {
+		mdelay(100);
+		val = READ_MEM32(SERDES_WRP_SDS_MISC);
+		if ((val & (1 << SERDES_WRP_SDS_MISC_sds_link_ok_sum_shift)) > 0 &&
+			 (val & (1 << SERDES_WRP_SDS_MISC_sds_link_ok_shift)) > 0)
+			break;
+	}
+	if (cnt >= SERDES_RETRY_CNT) {
+		printk("Wait SerDes link timeout, val = 0x%08x\n", val);
+		return 2;
+	} else
+		DBG("cnt = %d", cnt);
+
+	return 0;
+}
+
+static void rtd129x_phy_8211f_init(int phyid, bool flow_ctrl_en)
+{
+	uint32_t val;
+	uint32_t id1, id2;
+
+	/* read PHY ID */
+	rtl8651_getAsicEthernetPHYReg(phyid, 2, &id1);
+	rtl8651_getAsicEthernetPHYReg(phyid, 3, &id2);
+	DBG("PHY ID %d, ID1 0x%x, ID2 0x%x", phyid, id1, id2);
+	if (id1 == 0x1c && id2 == 0xc916) { /* for RTL8211F & RTL8211FS only */
+		/* disable RTL8211F CLK_OUT */
+		val = get_ext_phy(phyid, 0xa43, 25) & ~(1 << 0);
+		set_ext_phy(phyid, 0xa43, 25, val);
+
+		/* enable RTL8211F RXC SSC */
+		set_ext_phy(phyid, 0xc44, 19, 0x5f00);
+		mdelay(50); /* minimum reset time 50mS */
+
+		/* enable RTL8211F system clock SSC */
+		set_ext_phy(phyid, 0xc44, 23, 0x4f00);
+		val = get_ext_phy(phyid, 0xa43, 25) | (1 << 3);
+		set_ext_phy(phyid, 0xa43, 25, val);
+
+		/* use MDC/MDIO to issue SW reset of PHY 8211F */
+		rtl8651_getAsicEthernetPHYReg(phyid, 0, &val);
+		val |= PHY_RESET;
+		rtl8651_setAsicEthernetPHYReg(phyid, 0, val);
+		mdelay(20); /* minimum reset time 20mS */
+	}
+
+	/* read PHY reg 4 */
+	rtl8651_getAsicEthernetPHYReg(phyid, 4, &val);
+
+	if((flow_ctrl_en == true) && ((val & CAPABLE_PAUSE) == 0))
+		val |= CAPABLE_PAUSE;
+	else if((flow_ctrl_en == false) && ((val & CAPABLE_PAUSE) > 0))
+		val &= ~CAPABLE_PAUSE;
+	else
+		return;
+
+	/* write PHY reg 4 */
+	rtl8651_setAsicEthernetPHYReg(phyid, 4, val);
+
+	/* restart auto-negotiation */
+	rtl8651_getAsicEthernetPHYReg(phyid, 0, &val);
+	val |= RESTART_AUTONEGO;
+	rtl8651_setAsicEthernetPHYReg(phyid, 0, val);
+}
+
+#define PORT0_TYPECFG_MASK		(3<<0)
+static uint32_t rtd129x_switch_init(void)
+{
+	uint32_t val, ret = 0;
+
+	/* Disable EEE by default */
+	WRITE_MEM32(EEECR, 0);
+	WRITE_MEM32(EEEABICR1, 0);
+
+	/* clear unused fields */
+	/* arrange embedded PHY ID for MAC1=PHY8, MAC2=PHY9, MAC3=PHYa */
+	val = READ_MEM32(EPIDR) & ~(Port_embPhyID_MASK(1) | Port_embPhyID_MASK(2) | Port_embPhyID_MASK(3));
+	val |= Port_embPhyID(8, 1) | Port_embPhyID(9, 2) | Port_embPhyID(0xa, 3);
+	WRITE_MEM32(EPIDR, val);
+
+	//MAC0
+	if (hwnat_mac0_enable > 0) {
+		if ((hwnat_mac0_mode & 1) == 0 /*RGMII*/) {
+			/* PHYID assignment */
+			/* RGMII1/MAC0 */
+			/* arrange external PHY ID for port 0 */
+			val = READ_MEM32(PCRP0) & ~ExtPHYID_MASK;
+			val |= (rtl8651AsicEthernetTable[0].phyId  << ExtPHYID_OFFSET);
+			WRITE_MEM32(PCRP0, val);
+
+			/* interface assignment */
+			/* NAT spec, embedded SGMII for RTD1295, external RGMII for RTD1296 */
+			val = READ_MEM32(PITCR) & ~PORT0_TYPECFG_MASK;
+			val |= Port0_TypeCfg_GMII_MII_RGMII;
+			WRITE_MEM32(PITCR, val);
+
+			/* RGMII timing tuning */
+			/* tx_dly_mode = 1 */
+			val = get_ext_phy(rtl8651AsicEthernetTable[0].phyId, 0xd08, 17);
+			val |= (1 << 8);
+			set_ext_phy(rtl8651AsicEthernetTable[0].phyId, 0xd08, 17, val);
+
+			/* RGMII mode */
+			val = READ_MEM32(P0GMIICR) & ~CFG_GMAC_MASK;
+			val |= CFG_GMAC_RGMII;
+			WRITE_MEM32(P0GMIICR, val);
+
+			/* external PHY RTL8211F init */
+			rtd129x_phy_8211f_init(rtl8651AsicEthernetTable[0].phyId, true);
+		} else {	/*SGMII*/
+			/* due to Kylin-Cut-A bug, MDC/MDIO interface not working, need to patch */
+			if (get_rtd129x_cpu_revision() == RTD129x_CHIP_REVISION_A00) {
+				/* PHYID assignment */
+				/* SGMII/MAC0 */
+				/* arrange external PHY ID for port 0 */
+				val = READ_MEM32(PCRP0) & ~ExtPHYID_MASK;
+				val |= (rtl8651AsicEthernetTable[0].phyId  << ExtPHYID_OFFSET);
+				WRITE_MEM32(PCRP0, val);
+
+				// NAT spec, external RGMII, for patch MDIO setting
+				val = READ_MEM32(PITCR) & ~PORT0_TYPECFG_MASK;
+				val |= Port0_TypeCfg_GMII_MII_RGMII;
+				WRITE_MEM32(PITCR, val);
+
+				/* external PHY RTL8211F init */
+				rtd129x_phy_8211f_init(rtl8651AsicEthernetTable[0].phyId, true);
+
+				/* external PHY RTL8211FS tuning, enlarge SGMII signal amplitude to be 800mV */
+				set_ext_phy(rtl8651AsicEthernetTable[0].phyId, 0xdcd, 0x10, 0x1176);
+				set_ext_phy(rtl8651AsicEthernetTable[0].phyId, 0xdcd, 0x11, 0xb490);
+
+				/* NAT spec, embedded SGMII */
+				val = READ_MEM32(PITCR) & ~PORT0_TYPECFG_MASK;
+				val |= Port0_TypeCfg_UTP;
+				WRITE_MEM32(PITCR, val);
+
+				/* NAT spec, GMII MAC mode */
+				val = READ_MEM32(P0GMIICR) & ~CFG_GMAC_MASK;
+				val |= CFG_GMAC_GMII_MII_MAC | Conf_done;
+				WRITE_MEM32(P0GMIICR, val);
+
+				/* SerDes init */
+				ret = rtd129x_hwnat_set_serdes_sgmii_init();
+			} else {
+				/* PHYID assignment */
+				/* SGMII/MAC0 */
+				/* arrange embedded PHY ID for port 0 */
+				val = READ_MEM32(EPIDR) & ~Port_embPhyID_MASK(0);
+				val |= Port_embPhyID(rtl8651AsicEthernetTable[0].phyId, 0);
+				WRITE_MEM32(EPIDR, val);
+
+				/* NAT spec, embedded SGMII */
+				val = READ_MEM32(PITCR) & ~PORT0_TYPECFG_MASK;
+				val |= Port0_TypeCfg_UTP;
+				WRITE_MEM32(PITCR, val);
+
+				/* NAT spec, GMII MAC mode */
+				val = READ_MEM32(P0GMIICR) & ~CFG_GMAC_MASK;
+				val |= CFG_GMAC_GMII_MII_MAC | Conf_done;
+				WRITE_MEM32(P0GMIICR, val);
+
+				/* NAT spec, cascade internal MDIO bus and external MDIO bus,
+				   ECO in Kylin A01 to solve */
+				val = READ_MEM32(NAT_WRP_DMY_B);
+				val |= (1 << 2);
+				WRITE_MEM32(NAT_WRP_DMY_B, val);
+
+				/* NAT spec, update link patner ability to sds ability automatically */
+				//WRITE_MEM32(0x981c9100, (READ_MEM32(0x981c9100) | (0x1 << 0)));
+				val = READ_MEM32(NAT_WRP_DMY_A);
+				val |= (1 << 0);
+				WRITE_MEM32(NAT_WRP_DMY_A, val);
+
+				/* SerDes init */
+				ret = rtd129x_hwnat_set_serdes_sgmii_init();
+
+				/* external PHY RTL8211F init */
+				rtd129x_phy_8211f_init(rtl8651AsicEthernetTable[0].phyId, true);
+			}
+		}
+	}
+
+
+	/* GPHY/MAC4 */
+	/* arrange embedded PHYID for port 4 */
+	val = READ_MEM32(EPIDR) & ~Port_embPhyID_MASK(4);
+	val |= Port_embPhyID(rtl8651AsicEthernetTable[4].phyId, 4);
+	WRITE_MEM32(EPIDR, val);
+
+#define PORT4_TYPECFG_MASK		(3<<8)
+	/* NAT spec, choose embedded GMII GPHY */
+	val = READ_MEM32(PITCR) & ~PORT4_TYPECFG_MASK;
+	val |= Port4_TypeCfg_UTP; /* UTP interface */
+	WRITE_MEM32(PITCR, val);
+
+	/* external PHY RTL8211F init */
+	rtd129x_phy_8211f_init(rtl8651AsicEthernetTable[4].phyId, true);
+
+
+	/* RGMII0/MAC5 */
+	/* arrange external RTL8211FS PHYID=PHY1 */
+	val = READ_MEM32(PCRP5) & ~ExtPHYID_MASK;
+	val |= (rtl8651AsicEthernetTable[5].phyId  << ExtPHYID_OFFSET); /* PHY ID 1 */
+	WRITE_MEM32(PCRP5, val);
+
+#define PORT5_TYPECFG_MASK		(3<<10)
+	/* NAT spec, choose external RGMII */
+	val = READ_MEM32(PITCR) & ~PORT5_TYPECFG_MASK;
+	val |= Port5_TypeCfg_GMII_MII_RGMII; /* GMII/MII interface */
+	WRITE_MEM32(PITCR, val);
+
+	/* RGMII mode for RTL8211F */
+	val = READ_MEM32(P5GMIICR) & ~CFG_GMAC_MASK;
+	val |= CFG_GMAC_RGMII;
+	WRITE_MEM32(P5GMIICR, val);
+
+	/* RGMII timing tuning */
+	/* We use PHY TX delay to instead of it */
+
+	/* external PHY RTL8211F init */
+	rtd129x_phy_8211f_init(rtl8651AsicEthernetTable[5].phyId, true);
+
+	/* external PHY RGMII timing tuning */
+	/* tx_dly_mode = 1 */
+	val = get_ext_phy(rtl8651AsicEthernetTable[5].phyId, 0xd08, 17);
+	val |= (1 << 8);
+	set_ext_phy(rtl8651AsicEthernetTable[5].phyId, 0xd08, 17, val);
+
+	return ret;
+}
+
+static uint32_t rtd129x_system_init(struct device *dev)
+{
+	uint32_t val;
+	uint32_t i;
+
+	/* PLLDDSB power on */
+	val = get_rtd129x_cpu_id();
+	if ((val != RTK1295_CPU_ID) && (val != RTK1296_CPU_ID))
+		return val;
+
+	rtd129x_hwnat_set_pllddsb(dev);
+	rtd129x_hwnat_set_etn_clk(dev);
+
+	//MAC0
+	if (hwnat_mac0_enable > 0) {
+		if ((hwnat_mac0_mode & 1) == 0 /*RGMII*/) {
+			rtd129x_hwnat_set_rgmii1_init();
+		} else {	/*SGMII*/
+			/* workaround: set each MAC to force mode */
+			for(i = 0; i < 5; i++) {
+				val = READ_MEM32(PCRP0+i*4) | EnForceMode;
+				WRITE_MEM32(PCRP0+i*4, val);
+			}
+
+			rtd129x_hwnat_set_sata_pllddsa(dev);
+		}
+	}
+
+	//MAC5
+	rtd129x_hwnat_set_rgmii0_init();
+
+	return 0;
+}
+
+#if 0
+static void rtd129x_nic_setting(void)
+{
+	// setting system_based_flow_control_registers
+	WRITE_MEM32(SBFCR0, 0x000001e4);
+	WRITE_MEM32(SBFCR1, 0x01600184);
+	WRITE_MEM32(SBFCR2, 0x00a200e8);
+
+	WRITE_MEM32(FCCR0, 0x3f3f3f3f);
+	WRITE_MEM32(FCCR1, 0x003f3f3f);
+	WRITE_MEM32(PQPLGR, 0x00545454);
+
+	WRITE_MEM32(QRR, 0x0);
+
+	WRITE_MEM32(PBFCR0, 0x00049249);
+
+	WRITE_MEM32(PBFCR0, 0x00610092);
+	WRITE_MEM32(PBFCR1, 0x00610092);
+	WRITE_MEM32(PBFCR2, 0x00610092);
+	WRITE_MEM32(PBFCR3, 0x00610092);
+	WRITE_MEM32(PBFCR4, 0x00610092);
+	WRITE_MEM32(PBFCR5, 0x00610092);
+	WRITE_MEM32(PBFCR6, 0x00610092);
+
+	WRITE_MEM32(QDBFCRP0G0, 0x001a0025);
+	WRITE_MEM32(QDBFCRP0G1, 0x001a0025);
+	WRITE_MEM32(QDBFCRP0G2, 0x001a0025);
+	WRITE_MEM32(QDBFCRP1G0, 0x001a0025);
+	WRITE_MEM32(QDBFCRP1G1, 0x001a0025);
+	WRITE_MEM32(QDBFCRP1G2, 0x001a0025);
+	WRITE_MEM32(QDBFCRP2G0, 0x001a0025);
+	WRITE_MEM32(QDBFCRP2G1, 0x001a0025);
+	WRITE_MEM32(QDBFCRP2G2, 0x001a0025);
+	WRITE_MEM32(QDBFCRP3G0, 0x001a0025);
+	WRITE_MEM32(QDBFCRP3G1, 0x001a0025);
+	WRITE_MEM32(QDBFCRP3G2, 0x001a0025);
+	WRITE_MEM32(QDBFCRP4G0, 0x001a0025);
+	WRITE_MEM32(QDBFCRP4G1, 0x001a0025);
+	WRITE_MEM32(QDBFCRP4G2, 0x001a0025);
+	WRITE_MEM32(QDBFCRP5G0, 0x001a0025);
+	WRITE_MEM32(QDBFCRP5G1, 0x001a0025);
+	WRITE_MEM32(QDBFCRP5G2, 0x001a0025);
+	WRITE_MEM32(QDBFCRP6G0, 0x001a0025);
+	WRITE_MEM32(QDBFCRP6G1, 0x001a0025);
+	WRITE_MEM32(QDBFCRP6G2, 0x001a0025);
+
+	WRITE_MEM32(QPKTFCRP0G0, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP0G1, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP0G2, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP1G0, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP1G1, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP1G2, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP2G0, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP2G1, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP2G2, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP3G0, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP3G1, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP3G2, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP4G0, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP4G1, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP4G2, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP5G0, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP5G1, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP5G2, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP6G0, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP6G1, 0x000f001b);
+	WRITE_MEM32(QPKTFCRP6G2, 0x000f001b);
+
+	WRITE_MEM32(IQFCTCR, 0x009600c8);
+}
+#endif
+
+void rtd129x_hwnat_clk_init(struct device *dev)
+{
+	uint32_t ret = 0;
+	struct power_control *pctrl = power_control_get("pctrl_nat");
+
+	power_control_power_on(pctrl);
+
+	if ((ret = rtd129x_system_init(dev)) != 0) {
+		printk("Unknown RTD129X chip, ID = 0x%08x\n", ret);
+		return;
+	}
+	else
+		DBG("rtd129x_system_init() ok!");
+
+	if ((ret = rtd129x_switch_init()) != 0) {
+		switch(ret) {
+		case 1:
+			printk("Error: SGMII PHY not ready.\n");
+			break;
+		case 2:
+			printk("Error: SGMII link fail.\n");
+			break;
+		default:
+			printk("Error: rtd129x_switch_init() failed with unknown reason.\n");
+		}
+		return;
+	}
+	else
+		DBG("rtd129x_switch_init() ok!");
+
+#if 0
+	rtd129x_nic_setting();
+	DBG("rtd129x_nic_setting() ok!");
+#endif
+}
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865xC_hs.c b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865xC_hs.c
new file mode 100644
index 00000000..0c6cd5b
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865xC_hs.c
@@ -0,0 +1,333 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+//#include "assert.h"
+#include "asicRegs.h"
+//#include "rtl_utils.h"
+//#include "rtl8651_debug.h"
+#include "rtl865xC_hs.h"
+
+
+static int32 convertHsbToSoftware( hsb_t* rawHsb, hsb_param_t* hsb )
+{
+	/* bit-to-bit mapping */
+	hsb->spa = rawHsb->spa;
+	hsb->trigpkt = rawHsb->trigpkt;
+
+#if	defined(CONFIG_RTL_8197F)
+	hsb->ipv4_opt = rawHsb->ipv4_opt;			/* W0[4]		1 */
+	hsb->len = rawHsb->len;						/* W0[18:5]		14 */
+	hsb->ppp_ctrl = rawHsb->ppp_ctrl;			/* W0[19]		1 */
+#else
+	hsb->len = rawHsb->len;						/* W0[19:5]		15 */
+#endif
+
+	hsb->vid = rawHsb->vid;
+	hsb->tagif = rawHsb->tagif;
+	hsb->pppoeif = rawHsb->pppoeif;
+	hsb->sip = rawHsb->sip29_0 | (rawHsb->sip31_30<<30);
+	hsb->sprt = rawHsb->sprt;
+	hsb->dip = rawHsb->dip13_0 | (rawHsb->dip31_14<<14);
+	hsb->dprt = rawHsb->dprt13_0 | (rawHsb->dprt15_14<<14);
+	hsb->ipptl = rawHsb->ipptl;
+	hsb->ipfg = rawHsb->ipfg;
+	hsb->iptos = rawHsb->iptos;
+	hsb->tcpfg = rawHsb->tcpfg;
+	hsb->type = rawHsb->type;
+	hsb->patmatch = rawHsb->patmatch;
+	hsb->ethtype = rawHsb->ethtype;
+#if 1 /* Since the endian is reversed, we must translate it. */
+	hsb->da[5] = rawHsb->da14_0;
+	hsb->da[4] = (rawHsb->da14_0>>8) | (rawHsb->da46_15<<7);
+	hsb->da[3] = rawHsb->da46_15>>1;
+	hsb->da[2] = rawHsb->da46_15>>9;
+	hsb->da[1] = rawHsb->da46_15>>17;
+	hsb->da[0] = (rawHsb->da46_15>>25) | (rawHsb->da47_47<<7);
+	hsb->sa[5] = rawHsb->sa30_0;
+	hsb->sa[4] = rawHsb->sa30_0>>8;
+	hsb->sa[3] = rawHsb->sa30_0>>16;
+	hsb->sa[2] = (rawHsb->sa30_0>>24) | (rawHsb->sa47_31<<7);
+	hsb->sa[1] = rawHsb->sa47_31>>1;
+	hsb->sa[0] = rawHsb->sa47_31>>9;
+#else
+	hsb->da[0] = rawHsb->da14_0;
+	hsb->da[1] = (rawHsb->da14_0>>8) | (rawHsb->da46_15<<7);
+	hsb->da[2] = rawHsb->da46_15>>1;
+	hsb->da[3] = rawHsb->da46_15>>9;
+	hsb->da[4] = rawHsb->da46_15>>17;
+	hsb->da[5] = (rawHsb->da46_15>>25) | (rawHsb->da47_47<<7);
+	hsb->sa[0] = rawHsb->sa30_0;
+	hsb->sa[1] = rawHsb->sa30_0>>8;
+	hsb->sa[2] = rawHsb->sa30_0>>16;
+	hsb->sa[3] = (rawHsb->sa30_0>>24) | (rawHsb->sa47_31<<7);
+	hsb->sa[4] = rawHsb->sa47_31>>1;
+	hsb->sa[5] = rawHsb->sa47_31>>9;
+#endif
+	hsb->hiprior = rawHsb->hiprior;
+	hsb->snap = rawHsb->snap;
+	hsb->udpnocs = rawHsb->udpnocs;
+	hsb->ttlst = rawHsb->ttlst;
+	hsb->dirtx = rawHsb->dirtx;
+	hsb->l3csok = rawHsb->l3csok;
+	hsb->l4csok = rawHsb->l4csok;
+	hsb->ipfo0_n = rawHsb->ipfo0_n;
+	hsb->llcothr = rawHsb->llcothr;
+	hsb->urlmch = rawHsb->urlmch;
+	hsb->extspa = rawHsb->extspa;
+	hsb->extl2 = rawHsb->extl2;
+	hsb->linkid = rawHsb->linkid;
+	hsb->pppoeid = rawHsb->pppoeid;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	hsb->cputag_if = rawHsb->cputag_if;
+	hsb->ipv6_ext  = rawHsb->ipv6_ext;
+	hsb->ipv6fo    = rawHsb->ipv6fo;
+	hsb->ipv6flag  = rawHsb->ipv6flag;
+	hsb->qpri      = (rawHsb->qpri2_1<<1)| rawHsb->qpri0;
+	hsb->ptp_pkt   = rawHsb->ptp_pkt;
+	hsb->ptp_ver   = rawHsb->ptp_ver;
+	hsb->ptp_typ   = rawHsb->ptp_typ;
+	hsb->ipver_1st = rawHsb->ipver_1st;
+
+	hsb->sipv6_31_0 =   ((rawHsb->sipv6_50_19&0x1FFF)<<19)  | rawHsb->sipv6_18_0;
+	hsb->sipv6_63_32 =  ((rawHsb->sipv6_82_51&0x1FFF)<<19)  | (rawHsb->sipv6_50_19>>13);
+	hsb->sipv6_95_64 =  ((rawHsb->sipv6_114_83&0x1FFF)<<19)  | (rawHsb->sipv6_82_51>>13);
+	hsb->sipv6_127_96 = ((rawHsb->sipv6_127_115&0x1FFF)<<19)  | (rawHsb->sipv6_114_83>>13);
+
+	hsb->dipv6_31_0 =   ((rawHsb->dipv6_50_19&0x1FFF)<<19)  | rawHsb->dipv6_18_0;
+	hsb->dipv6_63_32 =  ((rawHsb->dipv6_82_51&0x1FFF)<<19)  | (rawHsb->dipv6_50_19>>13);
+	hsb->dipv6_95_64 =  ((rawHsb->dipv6_114_83&0x1FFF)<<19)  | (rawHsb->dipv6_82_51>>13);
+	hsb->dipv6_127_96 = ((rawHsb->dipv6_127_115&0x1FFF)<<19)  | (rawHsb->dipv6_114_83>>13);
+
+	hsb->hop_limit    = rawHsb->hop_limit;
+	hsb->tra_cla      = rawHsb->tra_cla;
+	hsb->flow_lab     = (rawHsb->flow_lab_19_3<<3) | rawHsb->flow_lab_2_0;
+	hsb->nxt_hdr      = rawHsb->nxt_hdr;
+	hsb->ipv4         = rawHsb->ipv4;
+	hsb->ipv6         = rawHsb->ipv6;
+	hsb->ip_len       = (rawHsb->ip_len_15_5<<5)| rawHsb->ip_len_4_0;
+
+	#if defined(CONFIG_RTL_8197F)
+	hsb->l3_cso = rawHsb->l3_cso;				/* W20[11]		1 */
+	hsb->l4_cso = rawHsb->l4_cso;				/* W20[12]		1 */
+	#endif
+
+	hsb->tun_len      = rawHsb->tun_len;
+
+	#if defined(CONFIG_RTL_8197F)
+	hsb->l3_csum = rawHsb->l3_csum_4_0;			/* W20[31:27]	5 */
+	/* W21 */
+	hsb->l3_csum |=								/* W21[10:0]	11 */
+		(rawHsb->l3_csum_15_5 << 5);
+	hsb->l4_csum = rawHsb->l4_csum;				/* W21[26:11]	16 */
+	hsb->inn_hlen = rawHsb->inn_hlen_4_0;		/* W21[31:27]	5 */
+	/* W22 */
+	hsb->inn_hlen |= rawHsb->inn_hlen_13_5;		/* W22[8:0]		9 */
+	hsb->swred_pkt_flag =						/* W22[9]		1 */
+		rawHsb->swred_pkt_flag;
+	hsb->swred_pkt_type =						/* W22[11:10]	2 */
+		rawHsb->swred_pkt_type;
+	#endif
+#endif
+
+	return SUCCESS;
+}
+
+
+int32 virtualMacGetHsb( hsb_param_t* hsb )
+{
+	hsb_t rawHsb;
+	int32 ret = SUCCESS;
+
+	{ /* Word-Access */
+		uint32 *pSrc, *pDst;
+		uint32 i;
+
+		/* We must assert structure size is the times of 4-bytes. */
+		if ( (sizeof(rawHsb)%4) != 0 ) RTL_BUG( "sizeof(rawHsb) is not the times of 4-bytes." );
+
+		pSrc = (uint32*)HSB_BASE;
+		pDst = (uint32*)&rawHsb;
+		for( i = 0; i < sizeof(rawHsb); i+=4 )
+		{
+			#if defined(CONFIG_RTD_1295_HWNAT)
+			*pDst = READ_MEM32((uintptr_t)pSrc);
+			#else //defined(CONFIG_RTD_1295_HWNAT)
+			*pDst = READ_MEM32((uint32)pSrc);
+			#endif //defined(CONFIG_RTD_1295_HWNAT)
+			pSrc++;
+			pDst++;
+		}
+	}
+
+	convertHsbToSoftware( &rawHsb, hsb );
+	return ret;
+}
+
+int32 convertHsaToSoftware( hsa_t* rawHsa, hsa_param_t* hsa )
+{
+	/* bit-to-bit mapping */
+#if 1 /* Since the endian is reversed, we must translate it. */
+	hsa->nhmac[5] = rawHsa->nhmac0;
+	hsa->nhmac[4] = rawHsa->nhmac1;
+	hsa->nhmac[3] = rawHsa->nhmac2;
+	hsa->nhmac[2] = rawHsa->nhmac3;
+	hsa->nhmac[1] = rawHsa->nhmac4;
+	hsa->nhmac[0] = rawHsa->nhmac5;
+#else
+	hsa->nhmac[0] = rawHsa->nhmac0;
+	hsa->nhmac[1] = rawHsa->nhmac1;
+	hsa->nhmac[2] = rawHsa->nhmac2;
+	hsa->nhmac[3] = rawHsa->nhmac3;
+	hsa->nhmac[4] = rawHsa->nhmac4;
+	hsa->nhmac[5] = rawHsa->nhmac5;
+#endif
+
+	hsa->trip = rawHsa->trip15_0 | (rawHsa->trip31_16<<16);
+	hsa->port = rawHsa->port;
+	hsa->l3csdt = rawHsa->l3csdt;
+	hsa->l4csdt = rawHsa->l4csdt;
+	hsa->egif = rawHsa->egif;
+	hsa->l2tr = rawHsa->l2tr;
+	hsa->l34tr = rawHsa->l34tr;
+	hsa->dirtxo = rawHsa->dirtxo;
+	hsa->typeo = rawHsa->typeo;
+
+#if defined(CONFIG_RTL_8197F)
+	hsa->llcexist = rawHsa->llcexist;			/* W4[7]		1 */
+#else
+	hsa->snapo = rawHsa->snapo;
+#endif
+	hsa->rxtag = rawHsa->rxtag;
+	hsa->dvid = rawHsa->dvid;
+	hsa->pppoeifo = rawHsa->pppoeifo;
+	hsa->pppidx = rawHsa->pppidx;
+#if defined(CONFIG_RTL_8197F)
+	hsa->leno = rawHsa->leno5_0|(rawHsa->leno13_6<<6);
+#else
+	hsa->leno = rawHsa->leno5_0|(rawHsa->leno14_6<<6);
+#endif
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	hsa->mirrort = rawHsa->mirrort;
+#endif
+	hsa->l3csoko = rawHsa->l3csoko;
+	hsa->l4csoko = rawHsa->l4csoko;
+	hsa->frag = rawHsa->frag;
+	hsa->lastfrag = rawHsa->lastfrag;
+	hsa->ipmcastr = rawHsa->ipmcastr;
+	hsa->svid = rawHsa->svid;
+
+#if defined(CONFIG_RTL_8197F)
+	hsa->_6rd_df = rawHsa->_6rd_df;				/* W5[26]		1 */
+#else
+	hsa->fragpkt = rawHsa->fragpkt;
+#endif
+	hsa->ttl_1if = rawHsa->ttl_1if4_0|(rawHsa->ttl_1if5_5<<5)|(rawHsa->ttl_1if8_6<<6);
+	hsa->dpc = rawHsa->dpc;
+	hsa->spao = rawHsa->spao;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	hsa->ipv4_1st = rawHsa->ipv4_1st;
+#endif
+	hsa->hwfwrd = rawHsa->hwfwrd;
+	hsa->dpext = rawHsa->dpext;
+	hsa->spaext = rawHsa->spaext;
+	hsa->why2cpu = rawHsa->why2cpu13_0|(rawHsa->why2cpu15_14<<14);
+	hsa->spcp = rawHsa->spcp;
+	hsa->dvtag = rawHsa->dvtag;
+	hsa->difid = rawHsa->difid;
+	hsa->linkid = rawHsa->linkid;
+	hsa->siptos = rawHsa->siptos;
+	hsa->dp = rawHsa->dp6_0;
+	hsa->priority = rawHsa->priority;
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8881A)
+	hsa->cputag   = rawHsa->cputag;
+	hsa->ptp_pkt  = rawHsa->ptp_pkt;
+	hsa->ptp_v2   = rawHsa->ptp_v2;
+	hsa->ptp_type = rawHsa->ptp_type;
+	hsa->rmdp     = rawHsa->rmdp;
+	hsa->dpri     = rawHsa->dpri;
+#elif defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	hsa->cputag   = rawHsa->cputag;
+	hsa->ptp_pkt  = rawHsa->ptp_pkt;
+	hsa->ptp_v2   = rawHsa->ptp_v2;
+	hsa->ptp_type = rawHsa->ptp_type;
+	hsa->rmdp     = rawHsa->rmdp;
+	hsa->dpri     = rawHsa->dpri;
+	hsa->mdf      = rawHsa->mdf;
+
+	hsa->sipv6_31_0   = ((rawHsa->sipv6_43_12  &0xFFFFF)<<12) | rawHsa->sipv6_11_0;
+	hsa->sipv6_63_32  = ((rawHsa->sipv6_75_44  &0xFFFFF)<<12) |(rawHsa->sipv6_43_12>>20);
+	hsa->sipv6_95_64  = ((rawHsa->sipv6_107_76 &0xFFFFF)<<12) |(rawHsa->sipv6_75_44>>20);
+	hsa->sipv6_127_96 = ((rawHsa->sipv6_127_108&0xFFFFF)<<12) |(rawHsa->sipv6_107_76>>20);
+
+	hsa->dipv6_31_0   = ((rawHsa->dipv6_43_12  &0xFFFFF)<<12) | rawHsa->dipv6_11_0;
+	hsa->dipv6_63_32  = ((rawHsa->dipv6_75_44  &0xFFFFF)<<12) |(rawHsa->dipv6_43_12>>20);
+	hsa->dipv6_95_64  = ((rawHsa->dipv6_107_76 &0xFFFFF)<<12) |(rawHsa->dipv6_75_44>>20);
+	hsa->dipv6_127_96 = ((rawHsa->dipv6_127_108&0xFFFFF)<<12) |(rawHsa->dipv6_107_76>>20);
+
+	hsa->ip_len    = (rawHsa->ip_len_15_12<<12)| rawHsa->ip_len_11_0;
+	hsa->ipv4_id   = rawHsa->ipv4_id;
+	#if defined(CONFIG_RTL_8197F)
+	hsa->has_ipv4 = rawHsa->has_ipv4;			/* W19[20]		1 */
+	hsa->has_ipv6 = rawHsa->has_ipv6;			/* W19[21]		1 */
+	hsa->tun_len = rawHsa->tun_len_9_0;			/* W19[31:22]	10 */
+
+	hsa->tun_len |=	(rawHsa->tun_len_13_10<<10); /* W20[3:0]		4 */
+	#else
+	hsa->tun_len   = (rawHsa->tun_len_15_12<<12) | rawHsa->tun_len_11_0 ;
+	#endif
+	hsa->mltcst_v6 = rawHsa->mltcst_v6;
+	hsa->addip_pri = rawHsa->addip_pri;
+#endif
+
+#if defined(CONFIG_RTL_8197F)
+	hsa->l3_cso = rawHsa->l3_cso;				/* W20[8]		1 */
+	hsa->l4_cso = rawHsa->l4_cso;				/* W20[9]		1 */
+	hsa->inn_hlen = rawHsa->inn_hlen;			/* W20[23:10]	14 */
+	hsa->swred_pkt_flag =						/* W20[24]		1 */
+		rawHsa->swred_pkt_flag;
+	hsa->swred_pkt_type =						/* W20[26:25]	2 */
+		rawHsa->swred_pkt_type;
+#endif
+
+	return SUCCESS;
+}
+
+int32 virtualMacGetHsa( hsa_param_t* hsa )
+{
+	hsa_t rawHsa;
+	int32 ret = SUCCESS;
+
+	{ /* Word-Access */
+		uint32 *pSrc, *pDst;
+		uint32 i;
+
+		/* We must assert structure size is the times of 4-bytes. */
+		if ( (sizeof(rawHsa)%4) != 0 ) RTL_BUG( "sizeof(rawHsa) is not the times of 4-bytes." );
+
+		pSrc = (uint32*)HSA_BASE;
+		pDst = (uint32*)&rawHsa;
+		for( i = 0; i < sizeof(rawHsa); i+=4 )
+		{
+			#if defined(CONFIG_RTD_1295_HWNAT)
+			*pDst = READ_MEM32((uintptr_t)pSrc);
+			#else //defined(CONFIG_RTD_1295_HWNAT)
+			*pDst = READ_MEM32((uint32)pSrc);
+			#endif //defined(CONFIG_RTD_1295_HWNAT)
+			pSrc++;
+			pDst++;
+		}
+	}
+
+	convertHsaToSoftware( &rawHsa, hsa );
+	return ret;
+}
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865xC_hs.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865xC_hs.h
new file mode 100644
index 00000000..dc179ed
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865xC_hs.h
@@ -0,0 +1,777 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL865XC_HS
+#define RTL865XC_HS
+
+struct hsb_param_s
+{
+	uint32 spa:3;		/* [2:0] source	port number	0~5: rx	port0-5,  7: cpu & extension ports (includes extension ports, see also extspa )	*/
+	uint32 trigpkt:1;	/* [3:3] This is a Triggered packet	for	Smartbit-like function.	*/
+#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32 ipv4_opt:1;	 /*	1=indicates	IPv4 header	with optional fields; 0=non-ipv4 frame or ipv4 frame without optional field.*/
+	uint32 len:14;		/* [14:0] BYTECOUNT	FOR	THE	PACKET,	included L2	CRC	*/
+#else
+	uint32 len:15;		/* [15:0] BYTECOUNT	FOR	THE	PACKET,	included L2	CRC	*/
+#endif
+
+#if	defined(CONFIG_RTL_8197F)
+	uint32 ppp_ctrl: 1;	/* means packet	with PPPoEIF==1	and	PPP	protocol field is 0xC021 */	/* 150116 MarkLin added	*/
+#endif
+
+	uint32 vid:12;		/* [11:0] VLANID for normal	packets	and	CPU-DirecTX	packets	*/
+	uint32 tagif:1;		/*		  To indicate if the incoming packet is	VLAN tagged	*/
+	uint32 pppoeif:1;	/*		  To indicate if the incoming packet is	a PPPoE	packet */
+	uint32 sip:32;		/* [31:0] Source IP	*/
+	uint32 sprt:16;		/* [15:0] Source Port (TCP/UDP)	/ ICMPID (ICMP)	/ L3 Checksum (DirectTx) / Call	ID (PPTP) */
+	uint32 dip:32;		/* [31:0] Destination IP */
+	uint32 dprt:16;		/* [15:0] Destination Port / L4	Checksum (DirectTx)	*/
+	uint32 ipptl:8;		/* [7:0] 8 bit protocol	in IP header (IP packet)ICMP Type (ICMP)IGMP Type (IGMP) */
+	uint32 ipfg:3;		/* [2:0] Flag field	in IP header=[IP_NONFG,IP_DF, IP_MF] */
+	uint32 iptos:8;		/* [7:0] TOS 8 bits	in IP header (IP packet) Reason	to CPU (DirectTx)*/
+	uint32 tcpfg:8;		/* [7:0]=TCP flag or ICMP code */
+	uint32 type:3;		/* [2:0] The type categories after Input packet	parsing	flow. 000: Ethernet, 001: PPTP,	010: IPv4, 011:	ICMP, 100: IGMP, 101: TCP, 110:	UDP, 111:IPv6 */
+	uint32 patmatch:1;	/*		 To	indicate if	the	per-port pattern match is matched and corresponding	action.	Bit0: Match	or not?	*/
+	uint32 ethtype:16;	/* [15:0] EtherType{ DoVLANTAG[5:0], PortMask [5:0], DoPPPoETAG, PPPoEID[2:0]} for DirectTx. When LLC=1, EtherType should be the 16	bit	value after	AA-AA-03 00-00-00. */
+	uint8 da[6];		/* [47:0] Destination MAC */
+	uint8 sa[6];		/* [47:0] Source MAC */
+	uint32 hiprior:3;	/* [2:0] Queue ID */
+	uint32 snap:1;		/*		 With LLC-SNAP hader */
+	uint32 udpnocs:1;	/*		 UDP and checksum=0x0000 */
+	uint32 ttlst:2;		/* [1:0] 00: TTL=0,	01:	TTL=1, 10: TTL>1 */
+	uint32 dirtx: 1;	/*		 Packet	parsing	failure	indication or CPU-Direct-TX	to normal ports	0~5	(Note :	CPU-Dir-TX : ALE won't do any lookup and S/W could command ASIC	to do L3/4 checksum	offload, and the insertion /removement of PPPoE	and	VLAN headers) */
+	uint32 l3csok: 1;	/*		 L3	checksum OK	(This field	is valid with IPv4 header) */
+	uint32 l4csok: 1;	/*		 L4	checksum OK	(This field	is valid when hsb.type=011:ICMP,100:IGMP,101:TCP,110:UDP) */
+	uint32 ipfo0_n:	1;	/*		 IP	fragmentation offset status. 0:	IP fragmentation offset=0, 1: not 0	(This field	is valid when hsb.type=001:GRE,010:IPv4,011:ICMP,100:IGMP,101:TCP,110:UDP, 111:IPv6) */
+	uint32 llcothr:1;	/*		 LLC header	with {DSAP,	SSAP} != AAAA */
+	uint32 urlmch:1;	/*		 To	indicate if	the	packet is URL trapped */
+	uint32 extspa:2;	/* [1:0] Extension Source Port Address ( valid only	if SPA = 7 ). 2-0: extension port 2~0. 3: cpu*/
+	uint32 extl2:1;		/*		 S/W Directs ALE to	do L2 lookup only for those	packets	from extension ports; it's valid if	the	incoming packets are from extension	ports */
+	uint32 linkid:7;	/*		 WLAN link ID; if is valid only	if the packets are from	extension ports	*/
+	uint32 pppoeid:16;	/*		 PPPoE ID */
+
+#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32 cputag_if:1;
+	uint32 ipv6_ext:1;
+	uint32 ipv6fo:1;
+	uint32 ipv6flag:3;
+	uint32 qpri:3;
+	uint32 ptp_pkt:1;
+	uint32 ptp_ver:2;
+	uint32 ptp_typ:4;
+	uint32 ipver_1st:4;
+	uint32 sipv6_31_0:32;
+	uint32 sipv6_63_32:32;
+	uint32 sipv6_95_64:32;
+	uint32 sipv6_127_96:32;
+	uint32 dipv6_31_0:32;
+	uint32 dipv6_63_32:32;
+	uint32 dipv6_95_64:32;
+	uint32 dipv6_127_96:32;
+	uint32 hop_limit:8;
+	uint32 tra_cla:8;
+	uint32 flow_lab:20;
+	uint32 nxt_hdr:8;
+	uint32 ipv4:1;
+	uint32 ipv6:1;
+	uint32 ip_len:16;
+	#if	defined(CONFIG_RTL_8197F)
+	uint32 l3_cso: 1;
+	uint32 l4_cso: 1;
+	uint32 tun_len:	14;
+	#else
+	uint32 tun_len:	16;
+	#endif
+	#if	defined(CONFIG_RTL_8197F)
+	uint32 l3_csum:	16;
+	uint32 l4_csum:	16;
+	uint32 inn_hlen: 14;		/* inner IP	header length (if IPv6 is base header+extension	header)	*/ /* 150116 MarkLin added */
+	uint32 swred_pkt_flag: 1;	/* SWRED packet	indication */ /* 150116	MarkLin	added */
+	uint32 swred_pkt_type: 2;	/* swred pkt type */ /*	150116 MarkLin added */
+	#endif
+
+#endif
+
+};
+typedef	struct hsb_param_s hsb_param_t;
+
+
+/* HSA (Header Stamp After):
+ * Software-friendly structure definition */
+struct hsa_param_s
+{
+	uint8 nhmac[6];		/* [47:0] ARP MAC (next	hop	MAC	address) */
+	uint32 trip:32;		/* [31:0] Translated IP	*/
+	uint32 port:16;		/* [15:0] Translated PORT/ICMP ID (type= ICMP) /Call ID	(type=PPTP)	*/
+	uint32 l3csdt:16;	/* [15:0] The substrate	distance to	fix	the	L3 Checksum. It	requires to	consider the TTL-1 simultaneously. */
+	uint32 l4csdt:16;	/* [15:0] The substrate	distance to	fix	the	L4 Checksum. It	requires to	consider the TTL-1 simultaneously*/
+	uint32 egif:1;		/*		  IF the packet	is from	internal VLAN. */
+	uint32 l2tr:1;		/*		  To indicate if L2	(MAC Address) translation is needed. */
+	uint32 l34tr:1;		/*		  To indicate if L3	(IP) translation and L4	(PORT) translation is needed. (boundled	because	the	L3 translation will	influence the L4 checksum insertion). */
+	uint32 dirtxo:1;			/*		  Packet Protocol parsing failure indication or	CPU-Direct-TX to normal	ports 0~5 (for CRC auto-insertion to distinguish L2	switch or from CPU packets)	*/
+	uint32 typeo:3;		/* [2:0] The type categories that outputs. 000:	Ethernet, 001: PPTP, 010: IPv4,	011: ICMP, 100:	IGMP, 101: TCP,	110: UDP, 111:IPv6 */
+	#if	defined(CONFIG_RTL_8197F)
+	uint32 llcexist:1;			/*		 1:	LLC	exists */
+	#endif
+	uint32 snapo:1;		/*		 1:	SNAP exists	(copy from hsb.snap) */
+	uint32 rxtag:1;		/*		 Indicate the rx-packet	carries	tag	header */
+	uint32 dvid:12;		/*		 The destination VLAN, for VLAN	Tagging. */
+	uint32 pppoeifo:2;	/* [1:0] To	indicate if	PPPoE session stage	header is needed to	be tagged. 00: intact, 01: tagging,	10:	remove,	11:	modify */
+	uint32 pppidx:3;	/* [2:0] The PPPoE Session ID Index	(to	a 8-entry register table) for tagging in the translated	packet header if needed. */
+#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32 leno:14;		/* [13:0] Packet length	*/
+	uint32 mirrort:1 ;	/* Mirror tx pkt */
+#else
+	uint32 leno:15;		/* [14:0] Packet length	*/
+#endif
+	uint32 l3csoko:1;	/*		  L3 CRC OK? */
+	uint32 l4csoko:1;	/*		  L4 CRC OK? */
+	uint32 frag:1;		/*		  If this packet is	fragment packet? */
+	uint32 lastfrag:1;	/*		  If this packet is	the	last fragment packet? */
+	uint32 ipmcastr:1;	/*		  Routed IP	Multicast packet */
+	uint32 svid:12;		/* [11:0] Source vid */
+
+#if	defined(CONFIG_RTL_8197F)
+	uint32 _6rd_df:1;			/*		  Vakid	@ IP_MDF=100, as DF	field of IPv4 */
+#else
+	uint32 fragpkt:1;	/*		  Enable output	port to	fragmentize	this packet	*/
+#endif
+
+	uint32 ttl_1if:9;	/* [8:0] Per MAC port TTL operation	indication */
+	uint32 dpc:3;		/* [2:0] Destination ports count */
+#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32 spao:3;		/* [2:0] Packet	source Port	( refer	HSB.SPA	definitation ) */
+	uint32 ipv4_1st:1;	/* First layer IP is IPv4 */
+#else
+	uint32 spao:4;		/* [3:0] Packet	source Port	( refer	HSB.SPA	definitation ) */
+#endif
+	uint32 hwfwrd:1;	/* [0:0] Hardware forward flag.	( S/W use )	*/
+
+#if	defined(CONFIG_RTL_8197F)
+	uint32 ttl_1if2:3;			/*		 Per extension port	TTL	operation indication (exists since 8652) */
+#endif
+	uint32 dpext:4;		/* [3:0] Packet	destination	indication : 0-2: ext port0-2 3: cpu */
+	uint32 spaext:2;	/* [1:0] ( refer HSB.EXTSPA	definitation ) */
+	uint32 why2cpu:16;	/* [15:0] CPU reason */
+	uint32 spcp:3;		/* [2:0] Source	priority code point	*/
+	uint32 dvtag:9;				/* [8:0] Destination VLAN tag set: 0-5:	port 0-5, 6-8: extension port 0-2, 9: cpu */
+	uint32 difid:3;		/* [2:0] Destination Interface ID (	MAC	uses this to get gateway MAC if	L2Trans	= 1) */
+	uint32 linkid:7;	/* [6:0] WLAN link ID; if is valid only	if the packets are from	extension ports. 0:	this field is invalid. */
+	uint32 siptos:8;	/* [7:0] Source	IPToS for those	packets	which were delivered to	extension ports. */
+	uint32 dp:7;				/* [6:0] Destination port list of port 0,1,2,3,4,5,6(CPU i/f) Dplist[6:0] map to port #[6:0] (**Note: Not implement	in HSA table, but do report	in the HSA register) */
+	uint32 priority:3;			/* [2:0] priority ID (valid: 0~7) Output packet	priority information :=	Traffic	class (**Note: Not implement in	HSA	table, but do report in	the	HSA	register) */
+
+#if	defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8881A)
+	uint32 cputag:1;
+	uint32 ptp_pkt:1;
+	uint32 ptp_v2:2;
+	uint32 ptp_type:4;
+	uint32 rmdp:6;
+	uint32 dpri:3;
+#elif defined(CONFIG_RTL_8198C)	|| defined(CONFIG_RTL_8197F)
+	uint32 cputag:1;
+	uint32 ptp_pkt:1;
+	uint32 ptp_v2:2;
+	uint32 ptp_type:4;
+	uint32 rmdp:6;
+	uint32 dpri:3;
+	uint32 mdf:3;
+	uint32 sipv6_31_0:32;
+	uint32 sipv6_63_32:32;
+	uint32 sipv6_95_64:32;
+	uint32 sipv6_127_96:32;
+	uint32 dipv6_31_0:32;
+	uint32 dipv6_63_32:32;
+	uint32 dipv6_95_64:32;
+	uint32 dipv6_127_96:32;
+	uint32 ip_len:16;
+	uint32 ipv4_id:16;
+
+	#if	defined(CONFIG_RTL_8197F)
+	uint32 has_ipv4:1;			/* packet with IPv4	header */
+	uint32 has_ipv6:1;			/* packet with IPv6	header */
+	uint32 tun_len:14;			/* tunnel ip header	length */
+	#else
+	uint32 tun_len:16;
+	#endif
+
+	uint32 mltcst_v6:1;
+	uint32 addip_pri:3;
+
+	#if	defined(CONFIG_RTL_8197F)
+	uint32 l3_cso:1;			/* do ipv4 checksum	offload	*/
+	uint32 l4_cso:1;			/* do L4 checksum offload */
+	uint32 inn_hlen:14;			/* inner IP	header length */
+	uint32 swred_pkt_flag:1;	/* SWRED packet	indication */
+	uint32 swred_pkt_type:2;	/* swred pkt type */
+	#endif
+#endif
+};
+typedef	struct hsa_param_s hsa_param_t;
+
+/* RAW HSB:	Raw	structure to access	ASIC.
+ * The structure is	directly mapped	to ASIC, however, it is	not	friendly for software. */
+struct hsb_s
+{
+#ifdef _LITTLE_ENDIAN
+	uint32 spa:3;		/* W0[2:0] */
+	uint32 trigpkt:1;	/* W0[3:3] */
+	#if	defined(CONFIG_RTL_8198C)
+	uint32 ipv4_opt:1;		/* W0[4:4] */
+	uint32 len:14;		/* W0[18:5]	*/
+	uint32 resv:1;				/* W0[19] */
+	#elif defined(CONFIG_RTL_8197F)
+	uint32 ipv4_opt:1;		/* W0[4:4] */
+	uint32 len:14;		/* W0[18:5]	*/
+	uint32 ppp_ctrl:1;			/* W0[19] */
+	#else
+	uint32 resv:1;		/* W0[4:4] */
+	uint32 len:15;		/* W0[19:5]	*/
+	#endif
+	uint32 vid:12;		/* W0[31:20] */
+#else
+	uint32 vid:12;		/* W0[31:20] */
+	#if	defined(CONFIG_RTL_8198C)
+	uint32 resv:1;		/* W0[4:4] */
+	uint32 len:14;		/* W0[19:5]	*/
+	uint32 ipv4_opt:1;		/* W0[4:4] */
+	#else
+	uint32 len:15;		/* W0[19:5]	*/
+	uint32 resv:1;		/* W0[4:4] */
+	#endif
+	uint32 trigpkt:1;	/* W0[3:3] */
+	uint32 spa:3;		/* W0[2:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 tagif:1;		/* W1[0:0] */
+	uint32 pppoeif:1;	/* W1[1:1] */
+	uint32 sip29_0:30;	/* W1[31:2]	*/
+#else
+	uint32 sip29_0:30;	/* W1[31:2]	*/
+	uint32 pppoeif:1;	/* W1[1:1] */
+	uint32 tagif:1;		/* W1[0:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 sip31_30:2;	/* W2[1:0] */
+	uint32 sprt:16;		/* W2[17:2]	*/
+	uint32 dip13_0:14;	/* W2[31:18] */
+#else
+	uint32 dip13_0:14;	/* W2[31:18] */
+	uint32 sprt:16;		/* W2[17:2]	*/
+	uint32 sip31_30:2;	/* W2[1:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 dip31_14:18;	/* W3[17:0]	*/
+	uint32 dprt13_0:14;	/* W3[31:18] */
+#else
+	uint32 dprt13_0:14;	/* W3[31:18] */
+	uint32 dip31_14:18;	/* W3[17:0]	*/
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 dprt15_14:2;	/* W4[1:0] */
+	uint32 ipptl:8;		/* W4[9:2] */
+	uint32 ipfg:3;		/* W4[12:10]=[IP_NONFG,IP_DF, IP_MF] */
+	uint32 iptos:8;		/* W4[20:13] */
+	uint32 tcpfg:8;		/* W4[28:21]=TCP flag or ICMP code */
+	uint32 type:3;		/* W4[31:29] */
+#else
+	uint32 type:3;		/* W4[31:29] */
+	uint32 tcpfg:8;		/* W4[28:21]=TCP flag or ICMP code */
+	uint32 iptos:8;		/* W4[20:13] */
+	uint32 ipfg:3;		/* W4[12:10]=[IP_NONFG,IP_DF, IP_MF] */
+	uint32 ipptl:8;		/* W4[9:2] */
+	uint32 dprt15_14:2;	/* W4[1:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 patmatch:1;	/* W5[0:0] */
+	uint32 ethtype:16;	/* W5[16:1]	*/
+	uint32 da14_0:15;	/* W5[31:17] */
+#else
+	uint32 da14_0:15;	/* W5[31:17] */
+	uint32 ethtype:16;	/* W5[16:1]	*/
+	uint32 patmatch:1;	/* W5[0:0] */
+#endif
+
+	uint32 da46_15:32;	/* W6[31:0]	*/
+
+#ifdef _LITTLE_ENDIAN
+	uint32 da47_47:1;	/* W7[0:0] */
+	uint32 sa30_0:31;	/* W7[31:1]	*/
+#else
+	uint32 sa30_0:31;	/* W7[31:1]	*/
+	uint32 da47_47:1;	/* W7[0:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 sa47_31:17;	/* W8[16:0]	*/
+	uint32 hiprior:3;	/* W8[19:17] */
+	uint32 snap:1;		/* W8[20:20] */
+	uint32 udpnocs:1;	/* W8[21:21] */
+	uint32 ttlst:2;		/* W8[23:22] */
+	uint32 dirtx:1;		/* W8[24:24] */
+	uint32 l3csok:1;	/* W8[25:25] */
+	uint32 l4csok:1;	/* W8[26:26] */
+	uint32 ipfo0_n:1;	/* W8[27:27] */
+	uint32 llcothr:1;	/* W8[28:28] */
+	uint32 urlmch:1;	/* W8[29:29] */
+	uint32 extspa:2;	/* W8[31:30] */
+#else
+	uint32 extspa:2;	/* W8[31:30] */
+	uint32 urlmch:1;	/* W8[29:29] */
+	uint32 llcothr:1;	/* W8[28:28] */
+	uint32 ipfo0_n:1;	/* W8[27:27] */
+	uint32 l4csok:1;	/* W8[26:26] */
+	uint32 l3csok:1;	/* W8[25:25] */
+	uint32 dirtx:1;		/* W8[24:24] */
+	uint32 ttlst:2;		/* W8[23:22] */
+	uint32 udpnocs:1;	/* W8[21:21] */
+	uint32 snap:1;		/* W8[20:20] */
+	uint32 hiprior:3;	/* W8[19:17] */
+	uint32 sa47_31:17;	/* W8[16:0]	*/
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 extl2:1;		/* W9[0:0] */
+	uint32 linkid:7;	/* W9[7:1] */
+	uint32 pppoeid:16;	/* W9[23:8]	*/
+	#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32 cputag_if:1;	/* W9[24] */
+	uint32 ipv6_ext:1;	/* W9[25] */
+	uint32 ipv6fo:1;	/* W9[26] */
+	uint32 ipv6flag:3;	/* W9[29:27] */
+	uint32 resv2:1;		/* W9[30] */
+	uint32 qpri0:1;		/* W9[31] */
+	#else
+	uint32 res1:8;		/* W9[31:24] */
+	#endif
+#else
+	#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32 qpri0:1;		/* W9[31] */
+	uint32 resv2:1;		/* W9[30] */
+	uint32 ipv6flag:3;	/* W9[29:27] */
+	uint32 ipv6fo:1;	/* W9[26] */
+	uint32 ipv6_ext:1;	/* W9[25] */
+	uint32 cputag_if:1;	/* W9[24] */
+	#else
+	uint32 res1:8;		/* W9[31:24] */
+	#endif
+	uint32 pppoeid:16;	/* W9[23:8]	*/
+	uint32 linkid:7;	/* W9[7:1] */
+	uint32 extl2:1;		/* W9[0:0] */
+#endif
+
+
+#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#ifdef _LITTLE_ENDIAN
+	uint32 qpri2_1:2;	  /* W10[1:0] */
+	uint32 ptp_pkt:1;	  /* W10[2]	*/
+	uint32 ptp_ver:2;	  /* W10[4:3] */
+	uint32 ptp_typ:4;	  /* W10[8:5] */
+	uint32 ipver_1st:4;	  /* W10[12:9] */
+	uint32 sipv6_18_0:19; /* W10[31:13]	*/
+#else
+	uint32 sipv6_18_0:19; /* W10[31:13]	*/
+	uint32 ipver_1st:4;	  /* W10[12:9] */
+	uint32 ptp_typ:4;	  /* W10[8:5] */
+	uint32 ptp_ver:2;	  /* W10[4:3] */
+	uint32 ptp_pkt:1;	  /* W10[2]	*/
+	uint32 qpri2_1:2;	  /* W10[1:0] */
+#endif
+
+	uint32 sipv6_50_19;	   /* W11[31:0]	*/
+	uint32 sipv6_82_51;	   /* W12[31:0]	*/
+	uint32 sipv6_114_83;   /* W13[31:0]	*/
+
+#ifdef _LITTLE_ENDIAN
+	uint32 sipv6_127_115:13;   /* W14[12:0]	*/
+	uint32 dipv6_18_0:19;	   /* W14[31:13] */
+#else
+	uint32 dipv6_18_0:19;	   /* W14[31:13] */
+	uint32 sipv6_127_115:13;   /* W14[12:0]	*/
+#endif
+
+	uint32 dipv6_50_19;	   /* W15[31:0]	*/
+	uint32 dipv6_82_51;	   /* W16[31:0]	*/
+	uint32 dipv6_114_83;   /* W17[31:0]	*/
+
+#ifdef _LITTLE_ENDIAN
+	uint32 dipv6_127_115:13;   /* W18[12:0]	*/
+	uint32 hop_limit:8;		   /* W18[20:13] */
+	uint32 tra_cla:8;		   /* W18[28:21] */
+	uint32 flow_lab_2_0:3;	   /* W18[31:29] */
+#else
+	uint32 flow_lab_2_0:3;	   /* W18[31:29] */
+	uint32 tra_cla:8;		   /* W18[28:21] */
+	uint32 hop_limit:8;		   /* W18[20:13] */
+	uint32 dipv6_127_115:13;   /* W18[12:0]	*/
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 flow_lab_19_3:17;	 /*	W19[16:0] */
+	uint32 nxt_hdr:8;			 /*	W19[24:17] */
+	uint32 ipv4:1;				 /*	W19[25]	*/
+	uint32 ipv6:1;				 /*	W19[26]	*/
+	uint32 ip_len_4_0:5;		 /*	W19[31:27] */
+#else
+	uint32 ip_len_4_0:5;		 /*	W19[31:27] */
+	uint32 ipv6:1;				 /*	W19[26]	*/
+	uint32 ipv4:1;				 /*	W19[25]	*/
+	uint32 nxt_hdr:8;			 /*	W19[24:17] */
+	uint32 flow_lab_19_3:17;	 /*	W19[16:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 ip_len_15_5:11;		  /* W20[10:0] */
+
+	#if	defined(CONFIG_RTL_8197F)
+	uint32 l3_cso:1;			/* W20[11] */
+	uint32 l4_cso:1;			/* W20[12] */
+	uint32 tun_len:14;			/* W20[26:13] */
+	uint32 l3_csum_4_0:5;		/* W20[31:27] */
+	#else	/* CONFIG_RTL_8198C	*/
+	uint32 resv3:2;				  /* W20[12:11]	*/
+	uint32 tun_len:16;			  /* W20[28:13]	*/
+	uint32 resv4:3;				  /* W20[31:29]	*/
+	#endif
+
+#else
+	uint32 resv4:3;				  /* W20[31:29]	*/
+	uint32 tun_len:16;			  /* W20[28:13]	*/
+	uint32 resv3:2;				  /* W20[12:11]	*/
+	uint32 ip_len_15_5:11;		  /* W20[10:0] */
+#endif
+
+#if	defined(CONFIG_RTL_8197F)
+	/* W21 */
+	#ifdef _LITTLE_ENDIAN
+	uint32 l3_csum_15_5:11;		/* W21[10:0] */
+	uint32 l4_csum:16;			/* W21[26:11] */
+	uint32 inn_hlen_4_0:5;		/* W21[31:27] */
+	#else
+	uint32 inn_hlen_4_0:5;		/* W21[31:27] */
+	uint32 l4_csum:16;			/* W21[26:11] */
+	uint32 l3_csum_15_5:11;		/* W21[10:0] */
+	#endif
+
+	/* W22 */
+	#ifdef _LITTLE_ENDIAN
+	uint32 inn_hlen_13_5:9;		/* W22[8:0]	*/
+	uint32 swred_pkt_flag:1;	/* W22[9] */
+	uint32 swred_pkt_type:2;	/* W22[11:10] */
+	uint32 resv5:20;			/* W22[31:12] */
+	#else
+	uint32 resv5:20;			/* W22[31:12] */
+	uint32 swred_pkt_type:2;	/* W22[11:10] */
+	uint32 swred_pkt_flag:1;	/* W22[9] */
+	uint32 inn_hlen_13_5:9;		/* W22[8:0]	*/
+	#endif
+#endif
+
+#endif //end of	#if	defined(CONFIG_RTL_8198C)
+
+
+};
+typedef	struct hsb_s hsb_t;
+
+
+/* RAW HSA:	Raw	structure to access	ASIC.
+ * The structure is	directly mapped	to ASIC, however, it is	not	friendly for software. */
+struct hsa_s
+{
+#ifdef _LITTLE_ENDIAN
+	uint32 nhmac0:8;	/* W0[7:0] */
+	uint32 nhmac1:8;	/* W0[15:8]	*/
+	uint32 nhmac2:8;	/* W0[23:16] */
+	uint32 nhmac3:8;	/* W0[31:24] */
+#else
+	uint32 nhmac3:8;	/* W0[31:24] */
+	uint32 nhmac2:8;	/* W0[23:16] */
+	uint32 nhmac1:8;	/* W0[15:8]	*/
+	uint32 nhmac0:8;	/* W0[7:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 nhmac4:8;	/* W1[7:0] */
+	uint32 nhmac5:8;	/* W1[15:8]	*/
+	uint32 trip15_0:16;	/* W1[31:16] */
+#else
+	uint32 trip15_0:16;	/* W1[31:16] */
+	uint32 nhmac5:8;	/* W1[15:8]	*/
+	uint32 nhmac4:8;	/* W1[7:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 trip31_16:16;/* W2[15:0]	*/
+	uint32 port:16;		/* W2[31:16] */
+#else
+	uint32 port:16;		/* W2[31:16] */
+	uint32 trip31_16:16;/* W2[15:0]	*/
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 l3csdt:16;	/* W3[15:0]	*/
+	uint32 l4csdt:16;	/* W3[31:16] */
+#else
+	uint32 l4csdt:16;	/* W3[31:16] */
+	uint32 l3csdt:16;	/* W3[15:0]	*/
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 egif:1;		/* W4[0:0] */
+	uint32 l2tr:1;		/* W4[1:1] */
+	uint32 l34tr:1;		/* W4[2:2] */
+	uint32 dirtxo:1;	/* W4[3:3] */
+	uint32 typeo:3;		/* W4[6:4] */
+	#if	defined(CONFIG_RTL_8197F)
+	uint32 llcexist:1;			/* W4[7] */
+	#else
+	uint32 snapo:1;		/* W4[7:7] */
+	#endif
+	uint32 rxtag:1;		/* W4[8:8] */
+	uint32 dvid:12;		/* W4[20:9]	*/
+	uint32 pppoeifo:2;	/* W4[22:21] */
+	uint32 pppidx:3;	/* W4[25:23] */
+	uint32 leno5_0:6;	/* W4[31:26] */
+#else
+	uint32 leno5_0:6;	/* W4[31:26] */
+	uint32 pppidx:3;	/* W4[25:23] */
+	uint32 pppoeifo:2;	/* W4[22:21] */
+	uint32 dvid:12;		/* W4[20:9]	*/
+	uint32 rxtag:1;		/* W4[8:8] */
+	uint32 snapo:1;		/* W4[7:7] */
+	uint32 typeo:3;		/* W4[6:4] */
+	uint32 dirtxo:1;	/* W4[3:3] */
+	uint32 l34tr:1;		/* W4[2:2] */
+	uint32 l2tr:1;		/* W4[1:1] */
+	uint32 egif:1;		/* W4[0:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	#if	defined(CONFIG_RTL_8198C)
+	uint32 leno14_6:8;	/* W5[7:0] */
+	uint32 mirrort:1;  /* W5[8]	*/
+	#elif defined(CONFIG_RTL_8197F)
+	uint32 leno13_6:8;			/* W5[7:0] */
+	uint32 mirrort:1;			/* W5[8] */
+	#else
+	uint32 leno14_6:9;	/* W5[8:0] */
+	#endif //end of	#if	defined(CONFIG_RTL_8198C)
+	uint32 l3csoko:1;	/* W5[9:9] */
+	uint32 l4csoko:1;	/* W5[10:10] */
+	uint32 frag:1;		/* W5[11:11] */
+	uint32 lastfrag:1;	/* W5[12:12] */
+	uint32 ipmcastr:1;	/* W5[13:13] */
+	uint32 svid:12;		/* W5[25:14] */
+	#if	defined(CONFIG_RTL_8197F)
+	uint32 _6rd_df:1;			/* W5[26] */
+	#else
+	uint32 fragpkt:1;	/* W5[26:26] */
+	#endif
+	uint32 ttl_1if4_0:5;/* W5[31:27] */
+#else
+	uint32 ttl_1if4_0:5;/* W5[31:27] */
+	uint32 fragpkt:1;	/* W5[26:26] */
+	uint32 svid:12;		/* W5[25:14] */
+	uint32 ipmcastr:1;	/* W5[13:13] */
+	uint32 lastfrag:1;	/* W5[12:12] */
+	uint32 frag:1;		/* W5[11:11] */
+	uint32 l4csoko:1;	/* W5[10:10] */
+	uint32 l3csoko:1;	/* W5[9:9] */
+
+	#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32 mirrort:1;  /* W5[8]	*/
+	uint32 leno14_6:8;	/* W5[7:0] */
+	#else
+	uint32 leno14_6:9;	/* W5[8:0] */
+	#endif
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 ttl_1if5_5:1;/* W6[0:0] */
+	uint32 dpc:3;		/* W6[3:1] */
+	#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32 spao:3;		/* W6[6:4] */
+	uint32 ipv4_1st:1;	/* W6[7] */
+	#else
+	uint32 spao:4;		/* W6[7:4] */
+	#endif
+	uint32 hwfwrd:1;	/* W6[8:8] */
+	uint32 ttl_1if8_6:3;/* W6[11:9]	*/
+	uint32 dpext:4;		/* W6[15:12] */
+	uint32 spaext:2;	/* W6[17:16] 0~3 */
+	uint32 why2cpu13_0:14;/* W6[31:18] */
+#else
+	uint32 why2cpu13_0:14;/* W6[31:18] */
+	uint32 spaext:2;	/* W6[17:16] 0~3 */
+	uint32 dpext:4;		/* W6[15:12] */
+	uint32 ttl_1if8_6:3;/* W6[11:9]	*/
+	uint32 hwfwrd:1;	/* W6[8:8] */
+	#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32 ipv4_1st:1;	/* W6[7] */
+	uint32 spao:3;		/* W6[6:4] */
+	#else
+	uint32 spao:4;		/* W6[7:4] */
+	#endif
+	uint32 dpc:3;		/* W6[3:1] */
+	uint32 ttl_1if5_5:1;/* W6[0:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 why2cpu15_14:2;/* W7[1:0] */
+	uint32 spcp:3;		/* W7[4:2] */
+	uint32 dvtag:9;		/* W7[13:5]	*/
+	uint32 difid:3;		/* W7[16:14] */
+	uint32 linkid:7;	/* W7[23:17]*/
+	uint32 siptos:8;	/* W7[31:24] */
+#else
+	uint32 siptos:8;	/* W7[31:24] */
+	uint32 linkid:7;	/* W7[23:17]*/
+	uint32 difid:3;		/* W7[16:14] */
+	uint32 dvtag:9;		/* W7[13:5]	*/
+	uint32 spcp:3;		/* W7[4:2] */
+	uint32 why2cpu15_14:2;/* W7[1:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+	uint32 dp6_0:7;		/* W8[6_0]=destinatio port mask*/
+	uint32 resv2:25;	/* W8[31:7]	*/
+#else
+	uint32 resv2:25;	/* W8[31:7]	*/
+	uint32 dp6_0:7;		/* W8[6:0]=destinatio port mask*/
+#endif
+
+#ifdef _LITTLE_ENDIAN
+		uint32 priority:3;/* W9[6:0] */
+		uint32 resv3:29;
+#else
+		uint32 resv3:29;
+		uint32 priority:3;/* W9[6:0] */
+#endif
+
+#if	defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8881A)
+#ifdef _LITTLE_ENDIAN
+		uint32 cputag:1;	  /* W10[0]	*/
+		uint32 ptp_pkt:1;	  /* W10[1]	*/
+		uint32 ptp_v2:2;	  /* W10[3:2] */
+		uint32 ptp_type:4;	  /* W10[7:4] */
+		uint32 rmdp:6;		  /* W10[13:8] */
+		uint32 dpri:3;		  /* W10[16:14]	*/
+		uint32 resv4:15;	  /* W10[31:17]	*/
+#else
+		uint32 resv4:15;	  /* W10[31:17]	*/
+		uint32 dpri:3;		  /* W10[16:14]	*/
+		uint32 rmdp:6;		  /* W10[13:8] */
+		uint32 ptp_type:4;	  /* W10[7:4] */
+		uint32 ptp_v2:2;	  /* W10[3:2] */
+		uint32 ptp_pkt:1;	  /* W10[1]	*/
+		uint32 cputag:1;	  /* W10[0]	*/
+#endif
+
+#elif defined(CONFIG_RTL_8198C)	|| defined(CONFIG_RTL_8197F)
+#ifdef _LITTLE_ENDIAN
+		uint32 cputag:1;	  /* W10[0]	*/
+		uint32 ptp_pkt:1;	  /* W10[1]	*/
+		uint32 ptp_v2:2;	  /* W10[3:2] */
+		uint32 ptp_type:4;	  /* W10[7:4] */
+		uint32 rmdp:6;		  /* W10[13:8] */
+		uint32 dpri:3;		  /* W10[16:14]	*/
+		uint32 mdf:3;		  /* W10[19:17]	*/
+		uint32 sipv6_11_0:12; /* W10[31:20]	*/
+#else
+		uint32 sipv6_11_0:12; /* W10[31:20]	*/
+		uint32 mdf:3;		  /* W10[19:17]	*/
+		uint32 dpri:3;		  /* W10[16:14]	*/
+		uint32 rmdp:6;		  /* W10[13:8] */
+		uint32 ptp_type:4;	  /* W10[7:4] */
+		uint32 ptp_v2:2;	  /* W10[3:2] */
+		uint32 ptp_pkt:1;	  /* W10[1]	*/
+		uint32 cputag:1;	  /* W10[0]	*/
+#endif
+
+		uint32 sipv6_43_12;	  /* W11[31:0] */
+		uint32 sipv6_75_44;	  /* W12[31:0] */
+		uint32 sipv6_107_76;  /* W13[31:0] */
+
+#ifdef _LITTLE_ENDIAN
+		uint32 sipv6_127_108:20; /*	W14[19:0] */
+		uint32 dipv6_11_0:12;	 /*	W14[31:20] */
+#else
+		uint32 dipv6_11_0:12;	 /*	W14[31:20] */
+		uint32 sipv6_127_108:20; /*	W14[19:0] */
+#endif
+
+		uint32 dipv6_43_12;	  /* W15[31:0] */
+		uint32 dipv6_75_44;	  /* W16[31:0] */
+		uint32 dipv6_107_76;  /* W17[31:0] */
+
+#ifdef _LITTLE_ENDIAN
+		uint32 dipv6_127_108:20; /*	W18[19:0] */
+		uint32 ip_len_11_0:12;	 /*	W18[31:20] */
+#else
+		uint32 ip_len_11_0:12;	 /*	W18[31:20] */
+		uint32 dipv6_127_108:20; /*	W18[19:0] */
+#endif
+
+#ifdef _LITTLE_ENDIAN
+		uint32 ip_len_15_12:4;	 /*	W19[3:0] */
+		uint32 ipv4_id:16;		 /*	W19[19:4] */
+		#if	defined(CONFIG_RTL_8197F)
+		uint32 has_ipv4:1;		/* W19[20] */
+		uint32 has_ipv6:1;		/* W19[21] */
+		uint32 tun_len_9_0:10;	/* W19[31:22] */
+		#else
+		uint32 tun_len_11_0:12;	 /*	W19[31:20] */
+		#endif
+#else
+		uint32 tun_len_11_0:12;	 /*	W19[31:20] */
+		uint32 ipv4_id:16;		 /*	W19[19:4] */
+		uint32 ip_len_15_12:4;	 /*	W19[3:0] */
+#endif
+
+
+#ifdef _LITTLE_ENDIAN
+		#if	defined(CONFIG_RTL_8197F)
+		uint32 tun_len_13_10:4;	 /*	W20[3:0] */
+		uint32 mltcst_v6:1;		 /*	W20[4] */
+		uint32 addip_pri:3;		 /*	W20[7:5] */
+		uint32 l3_cso:1;		/* W20[8] */
+		uint32 l4_cso:1;		/* W20[9] */
+		uint32 inn_hlen:14;		/* W20[23:10] */
+		uint32 swred_pkt_flag:1;/* W20[24] */
+		uint32 swred_pkt_type:2;/* W20[26:25] */
+		uint32 resv4:5;			/* W20[31:27] */
+		#else
+		uint32 tun_len_15_12:4;	 /*	W20[3:0] */
+		uint32 mltcst_v6:1;		 /*	W20[4] */
+		uint32 addip_pri:3;		 /*	W20[7:5] */
+		uint32 resv4:24;		 /*	W20[31:8] */
+		#endif
+#else
+		uint32 resv4:24;		 /*	W20[31:8] */
+		uint32 addip_pri:3;		 /*	W20[7:5] */
+		uint32 mltcst_v6:1;		 /*	W20[4] */
+		uint32 tun_len_15_12:4;	 /*	W20[3:0] */
+#endif
+
+#endif //end of #if defined(CONFIG_RTL_8198C)
+
+};
+typedef struct hsa_s hsa_t;
+
+
+
+int32 virtualMacGetHsa( hsa_param_t* hsa );
+int32 virtualMacGetHsb( hsb_param_t* hsb );
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicBasic.c b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicBasic.c
new file mode 100644
index 00000000..02a2f14
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicBasic.c
@@ -0,0 +1,607 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2009
+* All rights reserved.
+*
+* Program : Switch table basic operation driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*/
+
+#include <net/rtl/rtl_types.h>
+//#include "types.h"
+#include "asicRegs.h"
+#include "asicTabs.h"
+//#include "rtl_glue.h"
+#include "rtl865x_hwPatch.h"
+#include "rtl865x_asicBasic.h"
+
+/*
+ *  According to ghhuang's suggest,
+ *    we DO NOT need to access 8 ASIC entries at once.
+ *  We just need to access several entries as we need.
+ */
+
+#define RTL865X_FAST_ASIC_ACCESS
+
+/*
+ *  For RTL865xC Access protection mechanism
+ *
+ *	We define 2 different MACROs for ASIC table
+ *	read/write protection correspondingly
+ *
+ */
+//#define		RTL865XC_ASIC_READ_PROTECTION				/* Enable/Disable ASIC read protection */
+#define		RTL865XC_ASIC_WRITE_PROTECTION				/* Enable/Disable ASIC write protection */
+
+//#undef		RTL865X_READ_MULTIPLECHECK
+#define 		RTL865X_READ_MULTIPLECHECK
+#define		RTL865X_READ_MULTIPLECHECK_CNT		2
+#define		RTL865X_READ_MULTIPLECHECK_MAX_RETRY	10
+#define 	SIG_REG	(BSP_REVR+0x0C)
+#define		ID_REG	(BSP_REVR+0x00)
+
+
+//int8 RtkHomeGatewayChipName[16];
+//int32 RtkHomeGatewayChipRevisionID;
+//int32 RtkHomeGatewayChipNameID;
+
+#ifdef RTL865X_FAST_ASIC_ACCESS
+static uint32 _rtl8651_asicTableSize[] =
+{
+        2 /*TYPE_L2_SWITCH_TABLE*/,
+        1 /*TYPE_ARP_TABLE*/,
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	 3 /*TYPE_L3_ROUTING_TABLE*/,
+#else
+	 2 /*TYPE_L3_ROUTING_TABLE*/,
+#endif
+        3 /*TYPE_MULTICAST_TABLE*/,
+        5 /*TYPE_NETIF_TABLE*/,
+        3 /*TYPE_EXT_INT_IP_TABLE*/,
+        3 /*TYPE_VLAN_TABLE*/,
+        3 /*TYPE_VLAN1_TABLE*/,
+    4 /*TYPE_SERVER_PORT_TABLE*/,
+    3 /*TYPE_L4_TCP_UDP_TABLE*/,
+    3 /*TYPE_L4_ICMP_TABLE*/,
+    1 /*TYPE_PPPOE_TABLE*/,
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+    11 /*TYPE_ACL_RULE_TABLE*/,
+#else
+    8 /*TYPE_ACL_RULE_TABLE*/,
+#endif
+    1 /*TYPE_NEXT_HOP_TABLE*/,
+    3 /*TYPE_RATE_LIMIT_TABLE*/,
+    1 /*TYPE_ALG_TABLE*/,
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+   9 /*TYPE_DS_LITE_TABLE*/,
+   6 /*TYPE_6RD_TABLE*/,
+   6 /*TYPE_L3_V6_ROUTING_TABLE*/,
+   1 /*TYPE_NEXT_HOP_V6_TABLE*/,
+   3 /*TYPE_ARP_V6_TABLE*/,
+   9 /*TYPE_MULTICAST_V6_TABLE*/,
+#endif
+};
+#endif
+
+static void _rtl8651_asicTableAccessForward(uint32 tableType, uint32 eidx, void *entryContent_P)
+{
+	ASSERT_CSP(entryContent_P);
+
+	while ( (READ_MEM32(SWTACR) & ACTION_MASK) != ACTION_DONE );//Wait for command done
+
+#ifdef RTL865X_FAST_ASIC_ACCESS
+
+	{
+		register uint32 index;
+
+		for( index = 0; index < _rtl8651_asicTableSize[tableType]; index++ )
+		{
+			WRITE_MEM32(TCR0+(index<<2), *((uint32 *)entryContent_P + index));
+		}
+
+	}
+#else
+	WRITE_MEM32(TCR0, *((uint32 *)entryContent_P + 0));
+	WRITE_MEM32(TCR1, *((uint32 *)entryContent_P + 1));
+	WRITE_MEM32(TCR2, *((uint32 *)entryContent_P + 2));
+	WRITE_MEM32(TCR3, *((uint32 *)entryContent_P + 3));
+	WRITE_MEM32(TCR4, *((uint32 *)entryContent_P + 4));
+	WRITE_MEM32(TCR5, *((uint32 *)entryContent_P + 5));
+	WRITE_MEM32(TCR6, *((uint32 *)entryContent_P + 6));
+	WRITE_MEM32(TCR7, *((uint32 *)entryContent_P + 7));
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if( _rtl8651_asicTableSize[tableType]>8)
+	{
+		WRITE_MEM32(TCR8, *((uint32 *)entryContent_P + 8));
+		WRITE_MEM32(TCR9, *((uint32 *)entryContent_P + 9));
+		WRITE_MEM32(TCR10, *((uint32 *)entryContent_P + 10));
+	}
+#endif
+
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+	WRITE_MEM32(SWTAA, ((uint32) rtl8651_asicTableWriteAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH));//Fill address
+#else //defined(CONFIG_RTD_1295_HWNAT)
+	WRITE_MEM32(SWTAA, ((uint32) rtl8651_asicTableAccessAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH));//Fill address
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+}
+
+int32 _rtl8651_addAsicEntry(uint32 tableType, uint32 eidx, void *entryContent_P)
+{
+	_rtl8651_asicTableAccessForward(tableType, eidx, entryContent_P);
+
+	#ifdef RTL865XC_ASIC_WRITE_PROTECTION
+	if (RTL819X_TLU_CHECK)	/* No need to stop HW table lookup process */
+	{
+      		WRITE_MEM32(SWTCR0,EN_STOP_TLU|READ_MEM32(SWTCR0));
+		while ( (READ_MEM32(SWTCR0) & STOP_TLU_READY)==0);
+	}
+	#endif
+
+	WRITE_MEM32(SWTACR, ACTION_START | CMD_ADD );//Activate add command
+
+	while ( (READ_MEM32(SWTACR) & ACTION_MASK) != ACTION_DONE );//Wait for command done
+
+	if ( (READ_MEM32(SWTASR) & TABSTS_MASK) != TABSTS_SUCCESS )//Check status
+	{
+		#ifdef RTL865XC_ASIC_WRITE_PROTECTION
+		if(RTL819X_TLU_CHECK)	/* No need to stop HW table lookup process */
+		{
+			WRITE_MEM32(SWTCR0,~EN_STOP_TLU&READ_MEM32(SWTCR0));
+		}
+		#endif
+
+		return FAILED;
+	}
+
+	#ifdef RTL865XC_ASIC_WRITE_PROTECTION
+	if (RTL819X_TLU_CHECK)	/* No need to stop HW table lookup process */
+	{
+		WRITE_MEM32(SWTCR0,~EN_STOP_TLU&READ_MEM32(SWTCR0));
+	}
+	#endif
+
+	return SUCCESS;
+}
+static unsigned int mcastForceAddOpCnt=0;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static unsigned int mcastForceAddOpCnt6=0;
+#endif
+unsigned int _rtl865x_getForceAddMcastOpCnt(void)
+{
+	return mcastForceAddOpCnt;
+}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+unsigned int _rtl8198C_getForceAddMcastv6OpCnt(void)
+{
+	return mcastForceAddOpCnt6;
+}
+#endif
+int32 _rtl8651_forceAddAsicEntry(uint32 tableType, uint32 eidx, void *entryContent_P)
+{
+	if(tableType==TYPE_MULTICAST_TABLE)
+	{
+		mcastForceAddOpCnt++;
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if(tableType==TYPE_MULTICAST_V6_TABLE)
+	{
+		mcastForceAddOpCnt6++;
+	}
+#endif
+	#ifdef RTL865XC_ASIC_WRITE_PROTECTION
+	if (RTL819X_TLU_CHECK)	/* No need to stop HW table lookup process */
+	{
+		WRITE_MEM32(SWTCR0,EN_STOP_TLU|READ_MEM32(SWTCR0));
+		while ( (READ_MEM32(SWTCR0) & STOP_TLU_READY)==0);
+	}
+	#endif
+
+	_rtl8651_asicTableAccessForward(tableType, eidx, entryContent_P);
+
+ 	WRITE_MEM32(SWTACR, ACTION_START | CMD_FORCE);//Activate add command
+	while ( (READ_MEM32(SWTACR) & ACTION_MASK) != ACTION_DONE );//Wait for command done
+
+	#ifdef RTL865XC_ASIC_WRITE_PROTECTION
+	if (RTL819X_TLU_CHECK)	/* No need to stop HW table lookup process */
+	{
+		WRITE_MEM32(SWTCR0,~EN_STOP_TLU&READ_MEM32(SWTCR0));
+	}
+	#endif
+
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define MAX_ENTRY_CONTENT_SIZE	11
+#else
+#define MAX_ENTRY_CONTENT_SIZE	8
+#endif
+
+int32 _rtl8651_readAsicEntry(uint32 tableType, uint32 eidx, void *entryContent_P)
+{
+	uint32 *entryAddr;
+	uint32 tmp;/* dummy variable, don't remove it */
+
+	#ifdef RTL865X_READ_MULTIPLECHECK
+	uint32 entryContent[RTL865X_READ_MULTIPLECHECK_CNT][MAX_ENTRY_CONTENT_SIZE];	// CONFIG_RTL_8198C
+	uint32 entryContentIdx;
+	uint32 entryContent_new = RTL865X_READ_MULTIPLECHECK_CNT;/* to indicate which content is newer */
+	uint32 entryCompare_max_count = RTL865X_READ_MULTIPLECHECK_MAX_RETRY;
+	uint32 needRetry;
+	#endif
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	int i;
+#endif
+
+	#ifdef RTL865XC_ASIC_READ_PROTECTION
+	if (RTL819X_TLU_CHECK)	/* No need to stop HW table lookup process */
+	{
+		WRITE_MEM32(SWTCR0,EN_STOP_TLU|READ_MEM32(SWTCR0));
+		while ( (READ_MEM32(SWTCR0) & STOP_TLU_READY)==0);
+	}
+	#endif
+
+	ASSERT_CSP(entryContent_P);
+#if defined(CONFIG_RTD_1295_HWNAT)
+	entryAddr = (uint32 *) (
+		(uintptr_t) rtl8651_asicTableReadAddrBase(tableType) + (eidx<<5 /*RTL8651_ASICTABLE_ENTRY_LENGTH*/) ) ;
+		/*(uint32) rtl8651_asicTableReadAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH);*/
+#else //defined(CONFIG_RTD_1295_HWNAT)
+	entryAddr = (uint32 *) (
+		(uint32) rtl8651_asicTableAccessAddrBase(tableType) + (eidx<<5 /*RTL8651_ASICTABLE_ENTRY_LENGTH*/) ) ;
+		/*(uint32) rtl8651_asicTableAccessAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH);*/
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	while ( (READ_MEM32(SWTACR) & ACTION_MASK) != ACTION_DONE );//Wait for command ready
+
+#ifdef RTL865X_READ_MULTIPLECHECK
+		do
+		{
+			for (	entryContentIdx = 0 ;
+				entryContentIdx < RTL865X_READ_MULTIPLECHECK_CNT ;
+			   	entryContentIdx ++ )
+			{
+				entryContent[entryContentIdx][0] = *(entryAddr + 0);
+				entryContent[entryContentIdx][1] = *(entryAddr + 1);
+				entryContent[entryContentIdx][2] = *(entryAddr + 2);
+				entryContent[entryContentIdx][3] = *(entryAddr + 3);
+				entryContent[entryContentIdx][4] = *(entryAddr + 4);
+				entryContent[entryContentIdx][5] = *(entryAddr + 5);
+				entryContent[entryContentIdx][6] = *(entryAddr + 6);
+				entryContent[entryContentIdx][7] = *(entryAddr + 7);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+				if(_rtl8651_asicTableSize[tableType]>8)
+				{
+				/*
+				   The LSB 256bits is defined as before, but bit 335 to bit256 is moved to add addr[15].
+				   for example:
+					ACL rule 0 Virtual Address : bit [255:0]  : 0xbb0c_0000 ~ 0xbb0c_001c
+						                                  bit [335:256] : 0xbb0c_8000 ~ 0xbb0c_8008
+
+					entryContent[entryContentIdx][8] = *(entryAddr + 0 + (BIT(15) / 4));
+					entryContent[entryContentIdx][9] = *(entryAddr + 1 + (BIT(15) / 4));
+					entryContent[entryContentIdx][10] = *(entryAddr + 2 + (BIT(15) / 4));
+				 */
+				entryContent[entryContentIdx][8] = *(entryAddr + 8192);
+				entryContent[entryContentIdx][9] = *(entryAddr + 8193);
+				entryContent[entryContentIdx][10] = *(entryAddr + 8194);
+				}
+#endif
+
+			}
+			entryContent_new = RTL865X_READ_MULTIPLECHECK_CNT-1;
+
+			needRetry = FALSE;
+
+			for (	entryContentIdx = 1 ;
+				entryContentIdx < RTL865X_READ_MULTIPLECHECK_CNT ;
+			   	entryContentIdx ++ )
+			{
+				int32 idx;
+
+				for ( idx = 0 ; idx < MAX_ENTRY_CONTENT_SIZE ; idx ++ )	// CONFIG_RTL_8198C
+				{
+					if (	entryContent[entryContentIdx][idx] !=
+						entryContent[0][idx]	)
+					{
+						needRetry = TRUE;
+						goto retry;
+					}
+				}
+			}
+retry:
+		entryCompare_max_count --;
+		} while (	( needRetry == TRUE ) &&
+		      		( entryCompare_max_count > 0 ) );
+
+	/* Update entryAddr for newer one */
+	entryAddr = &( entryContent[ entryContent_new ][0] );
+#endif
+
+#if defined(RTL865X_READ_MULTIPLECHECK) && (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F))
+	#ifdef RTL865X_FAST_ASIC_ACCESS
+	for( i = 0; i < _rtl8651_asicTableSize[tableType]; i++ )
+	{
+		*((uint32 *)entryContent_P + i) = entryContent[ entryContent_new ][i];
+	}
+	#else
+	for( i = 0; i < MAX_ENTRY_CONTENT_SIZE; i++ )
+	{
+		*((uint32 *)entryContent_P + i) = entryContent[ entryContent_new ][i];
+	}
+	#endif
+
+#else
+#ifdef RTL865X_FAST_ASIC_ACCESS
+	{
+		register uint32 index;
+
+		for( index = 0; index < _rtl8651_asicTableSize[tableType]; index++ )
+		{
+			#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			if(index<8)
+				*((uint32 *)entryContent_P + index) = READ_MEM32((uint32)(entryAddr + index));
+			else
+				*((uint32 *)entryContent_P + index) = READ_MEM32((uint32)(entryAddr + index-8+8192));
+			#else
+			*((uint32 *)entryContent_P + index) = READ_MEM32((uint32)(entryAddr + index));
+			#endif
+		}
+	}
+#else
+	*((uint32 *)entryContent_P + 0) = *(entryAddr + 0);
+	*((uint32 *)entryContent_P + 1) = *(entryAddr + 1);
+	*((uint32 *)entryContent_P + 2) = *(entryAddr + 2);
+	*((uint32 *)entryContent_P + 3) = *(entryAddr + 3);
+	*((uint32 *)entryContent_P + 4) = *(entryAddr + 4);
+	*((uint32 *)entryContent_P + 5) = *(entryAddr + 5);
+	*((uint32 *)entryContent_P + 6) = *(entryAddr + 6);
+	*((uint32 *)entryContent_P + 7) = *(entryAddr + 7);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if(_rtl8651_asicTableSize[tableType]>8)
+	{
+		*((uint32 *)entryContent_P + 8) = *(entryAddr + 8192);
+		*((uint32 *)entryContent_P + 9) = *(entryAddr + 8193);
+		*((uint32 *)entryContent_P + 10) = *(entryAddr+ 8194);
+	}
+#endif
+#endif
+#endif
+
+	/* Dummy read. Must read an un-used table entry to refresh asic latch */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	tmp = *(uint32 *)((uint32) rtl8651_asicTableReadAddrBase(TYPE_ACL_RULE_TABLE) + 1024 * RTL8651_ASICTABLE_ENTRY_LENGTH);
+#else //defined(CONFIG_RTD_1295_HWNAT)
+	tmp = *(uint32 *)((uint32) rtl8651_asicTableAccessAddrBase(TYPE_ACL_RULE_TABLE) + 1024 * RTL8651_ASICTABLE_ENTRY_LENGTH);
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+	#ifdef RTL865XC_ASIC_READ_PROTECTION
+	if (RTL819X_TLU_CHECK)	/* No need to stop HW table lookup process */
+	{
+		WRITE_MEM32(SWTCR0,~EN_STOP_TLU&READ_MEM32(SWTCR0));
+	}
+	#endif
+
+	return 0;
+}
+
+int32 _rtl8651_readAsicEntryStopTLU(uint32 tableType, uint32 eidx, void *entryContent_P)
+{
+	uint32 *entryAddr;
+	uint32 tmp;/* dummy variable, don't remove it */
+
+	ASSERT_CSP(entryContent_P);
+#if defined(CONFIG_RTD_1295_HWNAT)
+	entryAddr = (uint32 *) (
+		(uintptr_t) rtl8651_asicTableReadAddrBase(tableType) + (eidx<<5 /*RTL8651_ASICTABLE_ENTRY_LENGTH*/) ) ;
+		/*(uint32) rtl8651_asicTableReadAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH);*/
+#else //defined(CONFIG_RTD_1295_HWNAT)
+	entryAddr = (uint32 *) (
+		(uint32) rtl8651_asicTableAccessAddrBase(tableType) + (eidx<<5 /*RTL8651_ASICTABLE_ENTRY_LENGTH*/) ) ;
+		/*(uint32) rtl8651_asicTableAccessAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH);*/
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+#if 0
+	while ( (READ_MEM32(SWTACR) & ACTION_MASK) != ACTION_DONE );//Wait for command ready
+#endif
+
+	if (RTL819X_TLU_CHECK)	/* No need to stop HW table lookup process */
+	{
+		WRITE_MEM32(SWTCR0,EN_STOP_TLU|READ_MEM32(SWTCR0));
+		#if 0
+		//while ( (READ_MEM32(SWTCR0) & STOP_TLU_READY)==0);
+		#endif
+	}
+
+#ifdef RTL865X_FAST_ASIC_ACCESS
+	{
+		register uint32 index;
+
+		for( index = 0; index < _rtl8651_asicTableSize[tableType]; index++ )
+		{
+			#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			#if defined(CONFIG_RTD_1295_HWNAT)
+			if(index<8)
+				*((uint32 *)entryContent_P + index) = READ_MEM32((uintptr_t)(entryAddr + index));
+			else
+				*((uint32 *)entryContent_P + index) = READ_MEM32((uintptr_t)(entryAddr + index-8+8192));
+			#else //defined(CONFIG_RTD_1295_HWNAT)
+			if(index<8)
+				*((uint32 *)entryContent_P + index) = READ_MEM32((uint32)(entryAddr + index));
+			else
+				*((uint32 *)entryContent_P + index) = READ_MEM32((uint32)(entryAddr + index-8+8192));
+			#endif //defined(CONFIG_RTD_1295_HWNAT)
+			#else
+			*((uint32 *)entryContent_P + index) = READ_MEM32((uint32)(entryAddr + index));
+			#endif
+		}
+	}
+#else
+	*((uint32 *)entryContent_P + 0) = *(entryAddr + 0);
+	*((uint32 *)entryContent_P + 1) = *(entryAddr + 1);
+	*((uint32 *)entryContent_P + 2) = *(entryAddr + 2);
+	*((uint32 *)entryContent_P + 3) = *(entryAddr + 3);
+	*((uint32 *)entryContent_P + 4) = *(entryAddr + 4);
+	*((uint32 *)entryContent_P + 5) = *(entryAddr + 5);
+	*((uint32 *)entryContent_P + 6) = *(entryAddr + 6);
+	*((uint32 *)entryContent_P + 7) = *(entryAddr + 7);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+    if(_rtl8651_asicTableSize[tableType]>8)
+    {
+        *((uint32 *)entryContent_P + 8) = *(entryAddr + 8192);
+        *((uint32 *)entryContent_P + 9) = *(entryAddr + 8193);
+        *((uint32 *)entryContent_P + 10) = *(entryAddr + 8194);
+    }
+#endif
+
+#endif
+
+
+	if (RTL819X_TLU_CHECK)	/* No need to stop HW table lookup process */
+	{
+		WRITE_MEM32(SWTCR0,~EN_STOP_TLU&READ_MEM32(SWTCR0));
+	}
+
+	/* Dummy read. Must read an un-used table entry to refresh asic latch */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	tmp = *(uint32 *)((uint32) rtl8651_asicTableReadAddrBase(TYPE_ACL_RULE_TABLE) + 1024 * RTL8651_ASICTABLE_ENTRY_LENGTH);
+#else //defined(CONFIG_RTD_1295_HWNAT)
+	tmp = *(uint32 *)((uint32) rtl8651_asicTableAccessAddrBase(TYPE_ACL_RULE_TABLE) + 1024 * RTL8651_ASICTABLE_ENTRY_LENGTH);
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	return 0;
+}
+
+int32 _rtl8651_delAsicEntry(uint32 tableType, uint32 startEidx, uint32 endEidx)
+{
+	uint32 eidx = startEidx;
+
+	while ( (READ_MEM32(SWTACR) & ACTION_MASK) != ACTION_DONE );//Wait for command done
+
+#ifdef RTL865X_FAST_ASIC_ACCESS
+	{
+		register uint32 index;
+
+		for( index = 0; index < _rtl8651_asicTableSize[tableType]; index++ )
+		{
+			WRITE_MEM32(TCR0+(index<<2), 0);
+		}
+	}
+#else
+	WRITE_MEM32(TCR0, 0);
+	WRITE_MEM32(TCR1, 0);
+	WRITE_MEM32(TCR2, 0);
+	WRITE_MEM32(TCR3, 0);
+	WRITE_MEM32(TCR4, 0);
+	WRITE_MEM32(TCR5, 0);
+	WRITE_MEM32(TCR6, 0);
+	WRITE_MEM32(TCR7, 0);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+    if(_rtl8651_asicTableSize[tableType]>8)
+    {
+    	WRITE_MEM32(TCR8, 0);
+    	WRITE_MEM32(TCR9, 0);
+    	WRITE_MEM32(TCR10, 0);
+    }
+#endif
+
+#endif
+
+	while (eidx <= endEidx) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+		WRITE_MEM32(SWTAA, (uint32) rtl8651_asicTableWriteAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH);//Fill address
+#else //defined(CONFIG_RTD_1295_HWNAT)
+		WRITE_MEM32(SWTAA, (uint32) rtl8651_asicTableAccessAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH);//Fill address
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+		WRITE_MEM32(SWTACR, ACTION_START | CMD_FORCE);//Activate add command
+
+		while ( (READ_MEM32(SWTACR) & ACTION_MASK) != ACTION_DONE );//Wait for command done
+
+		if ( (READ_MEM32(SWTASR) & TABSTS_MASK) != TABSTS_SUCCESS )//Check status
+			return FAILED;
+
+		++eidx;
+	}
+	return SUCCESS;
+}
+
+extern void machine_restart(char *command);
+static unsigned int rtl819x_lastTxDesc=0;
+static unsigned int rtl819x_lastRxDesc=0;
+static unsigned int rtl819x_swHangCnt=0;
+static unsigned int rtl819x_checkSwCoreTimer=0;
+void rtl819x_poll_sw(void)
+{
+	unsigned int port6Queue0Cgst= (READ_MEM32(0xbb80610c) & (1<<16));
+	unsigned int curRing0RxDesc=READ_MEM32(0xb8010004)&0xFFFFFFFC;
+	unsigned int curRing0TxDesc=READ_MEM32(0xb8010020)&0xFFFFFFFC;
+
+	if (((rtl819x_checkSwCoreTimer++) % 20)==0)
+	{
+
+		//unsigned int sysDescRunOut= (READ_MEM32(0xbb806100) & (1<<27));
+		if(port6Queue0Cgst==0)
+		{
+			rtl819x_swHangCnt=0;
+		}
+		else
+		{
+
+			if((rtl819x_lastTxDesc==0) || (rtl819x_lastRxDesc==0))
+			{
+				rtl819x_lastRxDesc=curRing0RxDesc;
+				rtl819x_lastTxDesc=curRing0TxDesc;
+				rtl819x_swHangCnt=0;
+			}
+			else
+			{
+				if((rtl819x_lastRxDesc==curRing0RxDesc) && (rtl819x_lastTxDesc==curRing0TxDesc))
+				{
+					rtl819x_swHangCnt++;
+				}
+				else
+				{
+					rtl819x_swHangCnt=0;
+				}
+			}
+
+
+		}
+
+
+		rtl819x_lastRxDesc=curRing0RxDesc;
+		rtl819x_lastTxDesc=curRing0TxDesc;
+
+		if(rtl819x_swHangCnt>2)
+		{
+			rtl819x_swHangCnt=0;
+			rtlglue_printf(".........................................\n");
+			machine_restart(NULL);
+		}
+
+	}
+
+	return;
+}
+
+#ifdef CONFIG_RTL_8881A
+#include <linux/reboot.h>
+
+int Lx1_check(void)
+{
+	if (REG32(GISR2) & LX1_BTRDY_IP)  {
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0)) // added by lynn_pu, 2014-10-15
+		extern unsigned int get_uptime_by_sec(void);
+		panic_printk("\nLexra bus 1 master timeout, GISR2= 0x%08x, uptime= %d seconds.\n\n", REG32(GISR2), get_uptime_by_sec());
+#endif
+		machine_restart(NULL);
+	}
+	return 0;
+}
+#endif
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicBasic.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicBasic.h
new file mode 100644
index 00000000..51faabba
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicBasic.h
@@ -0,0 +1,89 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2009
+* All rights reserved.
+*
+* Program : Switch table basic operation driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865X_ASICBASIC_H
+#define RTL865X_ASICBASIC_H
+
+#define RTL8651_ASICTABLE_ENTRY_LENGTH (8 * sizeof(uint32))
+#if defined(RTL865X_TEST) || defined(RTL865X_MODEL_USER) || defined(RTL865X_MODEL_KERNEL)
+#define RTL8651_ASICTABLE_BASE_OF_ALL_TABLES pVirtualSWTable
+#else
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define RTL_ASIC_BASE_OF_ALL_TABLES HW_SWTBL_BASE
+#define RTL_VIRT_BASE_OF_ALL_TABLES SW_SWTBL_BASE
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#define RTL8651_ASICTABLE_BASE_OF_ALL_TABLES REAL_SWTBL_BASE
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+#endif /* RTL865X_TEST */
+
+#define DUMP_SWITCH	0x0001
+#define HW_MCST			0x0002
+#define HW_NAT			0x0004
+#define HW_QOS			0x0008
+#define HW_ACL			0x0010
+#define ALL_NAT			0x0020
+
+enum {
+	TYPE_L2_SWITCH_TABLE = 0,
+	TYPE_ARP_TABLE,
+	TYPE_L3_ROUTING_TABLE,
+	TYPE_MULTICAST_TABLE,
+	TYPE_NETINTERFACE_TABLE,
+	TYPE_EXT_INT_IP_TABLE,
+	TYPE_VLAN_TABLE,
+	TYPE_VLAN1_TABLE,
+	TYPE_SERVER_PORT_TABLE,
+	TYPE_L4_TCP_UDP_TABLE,
+	TYPE_L4_ICMP_TABLE,      //10
+	TYPE_PPPOE_TABLE,
+	TYPE_ACL_RULE_TABLE,
+	TYPE_NEXT_HOP_TABLE,
+	TYPE_RATE_LIMIT_TABLE,
+	TYPE_ALG_TABLE,
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	TYPE_DS_LITE_TABLE,	     //16
+	TYPE_6RD_TABLE,          //17
+	TYPE_L3_V6_ROUTING_TABLE,//18
+	TYPE_NEXT_HOP_V6_TABLE,  //19
+	TYPE_ARP_V6_TABLE,       //20
+	TYPE_MULTICAST_V6_TABLE, //21
+#endif
+};
+
+/*#define rtl8651_asicTableAccessAddrBase(type) (RTL8651_ASICTABLE_BASE_OF_ALL_TABLES + 0x10000 * (type)) */
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define rtl8651_asicTableReadAddrBase(type) (RTL_VIRT_BASE_OF_ALL_TABLES + ((type)<<16) )
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#define rtl8651_asicTableAccessAddrBase(type) (RTL8651_ASICTABLE_BASE_OF_ALL_TABLES + ((type)<<16) )
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#if defined(CONFIG_FPGA_V6_HWNAT)
+#define rtl8651_asicTableWriteAddrBase(type) ((RTL_ASIC_BASE_OF_ALL_TABLES | 0x80000000) + ((type)<<16) )
+#elif defined(CONFIG_RTD_1295_HWNAT)
+#define rtl8651_asicTableWriteAddrBase(type) (RTL_ASIC_BASE_OF_ALL_TABLES + ((type)<<16) )
+#endif //defined(CONFIG_FPGA_V6_HWNAT)
+
+
+//extern int8 RtkHomeGatewayChipName[16];
+//extern int32 RtkHomeGatewayChipNameID;
+//extern int32 RtkHomeGatewayChipRevisionID;
+
+
+int32 _rtl8651_addAsicEntry(uint32 tableType, uint32 eidx, void *entryContent_P);
+int32 _rtl8651_forceAddAsicEntry(uint32 tableType, uint32 eidx, void *entryContent_P);
+int32 _rtl8651_readAsicEntry(uint32 tableType, uint32 eidx, void *entryContent_P);
+int32 _rtl8651_readAsicEntryStopTLU(uint32 tableType, uint32 eidx, void *entryContent_P);
+int32 _rtl8651_delAsicEntry(uint32 tableType, uint32 startEidx, uint32 endEidx);
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicCom.c b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicCom.c
new file mode 100644
index 00000000..584b3f7
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicCom.c
@@ -0,0 +1,2249 @@
+/*
+* Program : Switch table basic operation driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+*  Copyright (c) 2011 Realtek Semiconductor Corp.
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License version 2 as
+*  published by the Free Software Foundation.
+*/
+
+#include <linux/delay.h>
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+//#include "common/rtl_utils.h"
+#include "rtl865x_hwPatch.h"
+#include "asicRegs.h"
+//#include "assert.h"
+#include "rtl865x_asicBasic.h"
+#include "rtl865x_asicCom.h"
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+//#define RTL_DEBUG	1
+#ifdef RTL_DEBUG
+#define DBG(fmt, ...) printk(KERN_ERR "%s:%d: " fmt "\n", \
+						__func__, __LINE__, ## __VA_ARGS__)
+#else
+#define DBG(fmt, ...)
+#endif
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+
+#define tick_Delay10ms(x) { int i=x; while(i--) __delay(5000); }
+
+static int32 _rtl865xC_lockTLUCounter	=	0;
+#if 1
+static int32 _rtl865xC_lockTLUPHYREG[RTL8651_PORT_NUMBER+1]	=	{0};
+static int32 _rtl_inputBandWidth[RTL8651_PORT_NUMBER+1]	=	{0};
+#if defined(CONFIG_RTL_8197F)
+static int32 _rtl_inputBandWidth3 = 0;
+#endif
+#if !defined(CONFIG_RTD_1295_HWNAT)
+static int32 _rtl_FCRegister = 0;
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+#else
+static int32 _rtl865xC_lockTLUPHYREG[RTL8651_PORT_NUMBER+1]	=	{0};
+#endif
+int32		rtl8651_totalExtPortNum=0; //this replaces all RTL8651_EXTPORT_NUMBER defines
+int32		rtl8651_allExtPortMask=0; //this replaces all RTL8651_EXTPORTMASK defines
+rtl8651_tblAsic_InitPara_t rtl8651_tblAsicDrvPara;
+
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E))  && !defined(CONFIG_RTL_8198C)
+int rtl8651_findAsicVlanIndexByVid(uint16 *vid)
+{
+	int i;
+	rtl865x_tblAsicDrv_vlanParam_t vlan;
+
+	for ( i = 0; i < RTL865XC_VLANTBL_SIZE; i++ )
+	{
+		if (rtl8651_getAsicVlan(i, &vlan) == SUCCESS){
+			if(*vid == vlan.vid){
+				*vid = i;
+				return SUCCESS;
+			}
+		}
+	}
+
+	return FAILED;
+}
+
+static int rtl8651_getAsicVlanIndex(rtl865xc_tblAsic_vlanTable_t *entry, uint16 *vid)
+{
+	int i;
+	int ret = FAILED;
+	rtl865x_tblAsicDrv_vlanParam_t vlan;
+
+	for ( i = 0; i < RTL865XC_VLANTBL_SIZE; i++ )
+	{
+		if ((rtl8651_getAsicVlan(i, &vlan) == SUCCESS) && (entry->vid == vlan.vid)){
+			if((entry->memberPort != vlan.memberPortMask) || (entry->egressUntag != vlan.untagPortMask) ||(entry->fid != vlan.fid)){
+				*vid = i;
+				return SUCCESS;
+			}else{
+				return FAILED;
+			}
+		}
+	}
+
+	for ( i = 0; i < RTL865XC_VLANTBL_SIZE; i++ )
+	{
+		if ( rtl8651_getAsicVlan( i, &vlan ) == FAILED )
+			break;
+	}
+
+	if(i == RTL865XC_VLANTBL_SIZE){
+		ret = FAILED;	//vlan table is full
+	}else{
+		*vid = i;
+		ret = SUCCESS;
+	}
+
+	return ret;
+}
+#endif
+
+/*=========================================
+  * ASIC DRIVER API: VLAN TABLE
+  *=========================================*/
+int32 rtl8651_setAsicVlan(uint16 vid, rtl865x_tblAsicDrv_vlanParam_t *vlanp)
+{
+	rtl865xc_tblAsic_vlanTable_t entry;
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E))  && !defined(CONFIG_RTL_8198C)
+	int flag = FAILED;
+#endif
+
+	memset(&entry,0,sizeof(entry));
+	if(vlanp == NULL)
+		return FAILED;
+	if (vid>=4096)
+		return FAILED;
+	if(vlanp->memberPortMask > RTL8651_PHYSICALPORTMASK )
+		entry.extMemberPort = vlanp->memberPortMask >> RTL8651_PORT_NUMBER;
+	if(vlanp->untagPortMask > RTL8651_PHYSICALPORTMASK )
+		entry.extEgressUntag = vlanp->untagPortMask >> RTL8651_PORT_NUMBER;
+	entry.memberPort = vlanp->memberPortMask & RTL8651_PHYSICALPORTMASK;
+	entry.egressUntag = vlanp->untagPortMask & RTL8651_PHYSICALPORTMASK;
+	entry.fid=vlanp->fid;
+
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E))  && !defined(CONFIG_RTL_8198C)
+	entry.vid=vid;
+	flag = rtl8651_getAsicVlanIndex(&entry, &vid);
+	if(flag == FAILED)
+		return FAILED;
+#endif
+
+#if defined(CONFIG_RTL_8197F)
+	entry.hp=vlanp->hp;
+#endif
+
+	_rtl8651_forceAddAsicEntry(TYPE_VLAN_TABLE, vid, &entry);
+
+	return SUCCESS;
+}
+
+
+int32 rtl8651_delAsicVlan(uint16 vid) {
+	rtl865xc_tblAsic_vlanTable_t entry;
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E))  && !defined(CONFIG_RTL_8198C)
+	int flag = FAILED;
+	flag = rtl8651_findAsicVlanIndexByVid(&vid);
+	if(flag == FAILED)
+		return FAILED;
+#endif
+	memset(&entry,0,sizeof(entry));
+	return _rtl8651_forceAddAsicEntry(TYPE_VLAN_TABLE, vid, &entry);
+}
+
+
+int32 rtl8651_getAsicVlan(uint16 vid, rtl865x_tblAsicDrv_vlanParam_t *vlanp) {
+	rtl865xc_tblAsic_vlanTable_t entry;
+	if(vlanp == NULL||vid>=4096)
+		return FAILED;
+
+	_rtl8651_readAsicEntry(TYPE_VLAN_TABLE, vid, &entry);
+	if((entry.extMemberPort | entry.memberPort) == 0)
+	{
+		return FAILED;
+	}
+	vlanp->memberPortMask = (entry.extMemberPort<<RTL8651_PORT_NUMBER) | entry.memberPort;
+	vlanp->untagPortMask = (entry.extEgressUntag<<RTL8651_PORT_NUMBER) |entry.egressUntag;
+	vlanp->fid=entry.fid;
+
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E))  && !defined(CONFIG_RTL_8198C)
+	vlanp->vid=entry.vid;
+#endif
+
+#if defined(CONFIG_RTL_8197F)
+	vlanp->hp=entry.hp;
+#endif
+
+	return SUCCESS;
+}
+
+
+int32 rtl8651_setAsicPvid(uint32 port, uint32 pvid)
+{
+	uint32 regValue,offset;
+
+	if(port>=RTL8651_AGGREGATOR_NUMBER || pvid>=RTL865XC_VLAN_NUMBER)
+		return FAILED;;
+	offset=(port*2)&(~0x3);
+	regValue=READ_MEM32(PVCR0+offset);
+	if((port&0x1))
+	{
+		regValue=  ((pvid &0xfff) <<16) | (regValue&~0xFFF0000);
+	}
+	else
+	{
+		regValue =  (pvid &0xfff) | (regValue &~0xFFF);
+	}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rtl819x_setSwEthPvid(port, pvid);
+#endif
+
+	WRITE_MEM32(PVCR0+offset,regValue);
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicPVlanId(uint32 port, uint32 *pvid)
+{
+	uint16 offset;
+	offset=(port*2)&(~0x3);
+	if(port>=RTL8651_AGGREGATOR_NUMBER || pvid == NULL)
+		return FAILED;
+	if((port&0x1))
+	{
+		*pvid=(((READ_MEM32(PVCR0+offset)>>16)&0xFFF));
+	}
+	else
+	{
+		*pvid=((READ_MEM32(PVCR0+offset)&0xFFF));
+	}
+	return SUCCESS;
+}
+
+int32 rtl8651_setPortToNetif(uint32 port, uint32 netifidx)
+{
+	uint16 offset;
+
+	if(port>= RTL8651_AGGREGATOR_NUMBER || netifidx > 8)
+		return FAILED;
+	offset = (port * 3);
+	WRITE_MEM32(PLITIMR,((READ_MEM32(PLITIMR) & (~(0x7 << offset))) | ((netifidx & 0x7)<< offset)));
+	return SUCCESS;
+}
+
+
+/*=========================================
+ * ASIC DRIVER API: Protocol-based VLAN
+ *=========================================*/
+
+/*
+@func int32 | rtl8651_defineProtocolBasedVLAN | configure user-definable protocol-based VLAN
+@parm uint32 | ruleNo        | Valid values: RTL8651_PBV_RULE_USR1 and RTL8651_PBV_RULE_USR2
+@parm uint8  | ProtocolType  | 00:ethernetII, 01:RFC-1042, 10: LLC-Other, 11:reserved
+@parm uint16 | ProtocolValue | ethernetII:ether type, RFC-1042:ether type, LLC-Other:PDSAP(8),SSAP(8)}
+@rvalue SUCCESS |
+@comm
+ */
+int32 rtl8651_defineProtocolBasedVLAN( uint32 ruleNo, uint8 ProtocolType, uint16 ProtocolValue )
+{
+	assert( ruleNo == RTL8651_PBV_RULE_USR1 ||
+	        ruleNo == RTL8651_PBV_RULE_USR2 );
+
+	if ( ruleNo == RTL8651_PBV_RULE_USR1 )
+	{
+		WRITE_MEM32( PBVCR0, ( ProtocolType << PBVCR_PROTO_TYPE_OFFSET ) |
+		                    ( ProtocolValue << PBVCR_PROTO_VALUE_OFFSET ) );
+	}
+	else if ( ruleNo == RTL8651_PBV_RULE_USR2 )
+	{
+		WRITE_MEM32( PBVCR1, ( ProtocolType << PBVCR_PROTO_TYPE_OFFSET ) |
+		                     ( ProtocolValue << PBVCR_PROTO_VALUE_OFFSET ) );
+	}
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_setProtocolBasedVLAN | set corresponding table index of protocol-based VLAN
+@parm uint32 | ruleNo  | rule Number (1~6)
+@parm uint8  | port    | 0~4:PHY  5:MII  6~8:ExtPort
+@parm uint8  | vlanIdx | VLAN Table index (0~7)
+@rvalue SUCCESS |
+@comm
+ */
+int32 rtl8651_setProtocolBasedVLAN( uint32 ruleNo, uint32 port, uint8 valid, uint16 vlanId )
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t addr;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 addr;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 value;
+
+	assert( ruleNo > 0 && ruleNo < RTL8651_PBV_RULE_MAX );
+//	assert( vlanId < RTL865XC_VLAN_NUMBER );
+//	assert( port < RTL8651_AGGREGATOR_NUMBER );
+	ruleNo = ruleNo-1;
+	valid = valid ? TRUE : FALSE;
+	if ( valid == FALSE )
+	{
+		vlanId = 0; // clear it for looking pretty.
+	}
+
+	if ( port < RTL8651_MAC_NUMBER )
+	{
+		// Port0 ~ Port9
+		addr=PBVR0_0 +(ruleNo*5*4) + ((port/2)*4) ;
+		value = ( vlanId<<1 | valid );
+		if (port&0x1)
+			value =(value <<16) | (0x0000FFFF& READ_MEM32(addr));
+		else
+			value =value|( 0xFFFF0000& READ_MEM32(addr));
+		WRITE_MEM32(addr,value);
+	}
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_getProtocolBasedVLAN | get corresponding table index of protocol-based VLAN
+@parm uint32 | ruleNo  | rule Number (1~6)
+@parm uint8* | port    | (output) 0~4:PHY  5:MII  6~8:ExtPort
+@parm uint8* | vlanIdx | (output) VLAN Table index (0~7)
+@rvalue SUCCESS |
+@comm
+ */
+int32 rtl8651_getProtocolBasedVLAN( uint32 ruleNo, uint32 port, uint8* valid, uint32* vlanId )
+{
+	uint32 value;
+
+	assert( ruleNo > 0 && ruleNo < RTL8651_PBV_RULE_MAX );
+	assert( port < RTL8651_AGGREGATOR_NUMBER );
+	ruleNo=ruleNo-1;
+	if ( port < RTL865XC_PORT_NUMBER )
+	{
+		// Port0 ~ Port9
+		value =  READ_MEM32(PBVR0_0+(ruleNo*5*4) +(port/2)*4 );
+		if (port&0x1)
+			value =(value & 0xffff0000)>>16;
+		else
+			value &= 0x0000ffff ;
+		if ( valid ) *valid = value & 1;
+		if ( vlanId ) *vlanId = value >> 1;
+	}
+
+	assert( *vlanId < RTL865XC_VLAN_NUMBER );
+
+	return SUCCESS;
+}
+
+
+/*=========================================
+  * ASIC DRIVER API: INTERFACE TABLE
+  *=========================================*/
+
+/*
+@func int32		| rtl865xC_setNetDecisionPolicy	| Set Interface Multilayer-Decision-Base Control
+@parm uint32 | policy | Possible values: NETIF_VLAN_BASED / NETIF_PORT_BASED / NETIF_MAC_BASED
+@rvalue SUCCESS	| 	Success
+@comm
+RTL865xC supports Multilayer-Decision-Base for interface lookup.
+ */
+int32 rtl865xC_setNetDecisionPolicy( enum ENUM_NETDEC_POLICY policy )
+{
+	if ( policy == NETIF_PORT_BASED )
+		WRITE_MEM32( SWTCR0, ( READ_MEM32( SWTCR0 ) & ~LIMDBC_MASK ) | LIMDBC_PORT );
+	else if ( policy == NETIF_MAC_BASED )
+		WRITE_MEM32( SWTCR0, ( READ_MEM32( SWTCR0 ) & ~LIMDBC_MASK ) | LIMDBC_MAC );
+	else
+		WRITE_MEM32( SWTCR0, ( READ_MEM32( SWTCR0 ) & ~LIMDBC_MASK ) | LIMDBC_VLAN );
+
+	return SUCCESS;
+}
+
+/*
+@func int32		| rtl865x_setDefACLForNetDecisionMiss	| ACL action when netif decision miss match
+@parm uint8 | start_ingressAclIdx |acl index
+@parm uint8 | end_ingressAclIdx |acl index
+@parm uint8 | start_egressAclIdx |acl index
+@parm uint8 | end_egressAclIdx |acl index
+@rvalue SUCCESS	| 	Success
+@comm
+RTL865xC supports Multilayer-Decision-Base for interface lookup.
+ */
+int32 rtl865x_setDefACLForNetDecisionMiss(uint8 start_ingressAclIdx, uint8 end_ingressAclIdx,uint8 start_egressAclIdx,uint8 end_egressAclIdx)
+{
+	if(start_ingressAclIdx >= RTL8651_ACLHWTBL_SIZE || end_ingressAclIdx >= RTL8651_ACLHWTBL_SIZE ||
+		start_egressAclIdx >= RTL8651_ACLHWTBL_SIZE ||end_egressAclIdx >= RTL8651_ACLHWTBL_SIZE )
+		return FAILED;
+	#if 0
+	WRITE_MEM32(DACLRCR,start_ingressAclIdx|end_ingressAclIdx<<7|start_egressAclIdx<<14|end_egressAclIdx<<21);
+	#else
+	WRITE_MEM32(DACLRCR,start_ingressAclIdx|end_ingressAclIdx<<ACLI_EDA_OFFSET|start_egressAclIdx<<ACLO_STA_OFFSET|end_egressAclIdx<<ACLO_EDA_OFFSET);
+	#endif
+	return SUCCESS;
+}
+
+#if 1 //defined (CONFIG_RTL_LOCAL_PUBLIC)
+int32 rtl865xC_getNetDecisionPolicy( enum ENUM_NETDEC_POLICY *policy )
+{
+	unsigned int tmp=0;
+	tmp=READ_MEM32(SWTCR0);
+	*policy=NETIF_VLAN_BASED;
+	if(tmp & LIMDBC_VLAN)
+	{
+		*policy=NETIF_VLAN_BASED;
+	}
+	else if (tmp & LIMDBC_PORT)
+	{
+		*policy=NETIF_PORT_BASED;
+	}
+	else if (tmp &  LIMDBC_MAC)
+	{
+		*policy=NETIF_MAC_BASED;
+	}
+
+	return SUCCESS;
+}
+
+int32 rtl865x_getDefACLForNetDecisionMiss(uint8 *start_ingressAclIdx, uint8 *end_ingressAclIdx,uint8 *start_egressAclIdx,uint8 *end_egressAclIdx)
+{
+	int defAclRule=0;
+
+	defAclRule=READ_MEM32(DACLRCR);
+	#if 0
+	*start_ingressAclIdx = defAclRule & 0x7f;
+	*end_ingressAclIdx = (defAclRule>>7) & 0x7f;
+	*start_egressAclIdx = (defAclRule>>14) & 0x7f;
+	*end_egressAclIdx =	 (defAclRule>>21) & 0x7f;
+	#else
+	*start_ingressAclIdx = (defAclRule & ACLI_STA_MASK);
+	*end_ingressAclIdx = ((defAclRule & ACLI_EDA_MASK) >> ACLI_EDA_OFFSET);
+	*start_egressAclIdx = ((defAclRule & ACLO_STA_MASK) >> ACLO_STA_OFFSET);
+	*end_egressAclIdx =	 ((defAclRule & ACLO_EDA_MASK) >> ACLO_EDA_OFFSET);
+	#endif
+
+	return SUCCESS;
+}
+#endif
+
+/*
+@func int32		| rtl865x_delNetInterfaceByVid	| Delete ASIC Interface Table according to Vlan ID
+@parm uint16 | vid | vlan id .
+@rvalue SUCCESS	| 	Success
+@rvalue FAILED	| 	Failed
+@comm
+ */
+int32 rtl865x_delNetInterfaceByVid(uint16 vid)
+{
+	rtl865xc_tblAsic_netifTable_t entry;
+	uint32 i,netIfIdx;
+	int32 retVal = FAILED;
+
+	netIfIdx = RTL865XC_NETIFTBL_SIZE;
+
+	if(vid < 1 || vid > 4095)
+		return FAILED;
+
+	/*search...*/
+	for (i=0;i<RTL865XC_NETIFTBL_SIZE;i++)
+	{
+		_rtl8651_readAsicEntry(TYPE_NETINTERFACE_TABLE, i, &entry);
+	 	if ( entry.valid && entry.vid==vid )
+	 	{
+	 		netIfIdx = i;
+			break;
+		}
+	}
+
+	if(netIfIdx < RTL865XC_NETIFTBL_SIZE)
+	{
+		memset(&entry,0,sizeof(entry));
+		retVal = _rtl8651_forceAddAsicEntry(TYPE_NETINTERFACE_TABLE, netIfIdx, &entry);
+	}
+
+	return retVal;
+
+}
+
+/*
+@func int32		| rtl8651_setAsicNetInterface	| Set ASIC Interface Table
+@parm uint32 | idx | Table index. Specific RTL865XC_NETIFTBL_SIZE to auto-search.
+@parm rtl865x_tblAsicDrv_intfParam_t* | intfp | pointer to interface structure to add
+@rvalue SUCCESS	| 	Success
+@rvalue FAILED	| 	Failed
+@comm
+To read an interface entry, we provide two ways:
+1. given the index which we want to force set
+2. leave the index with RTL865XC_NETIFTBL_SIZE, we will search the whole table to find out existed entry or empty entry.
+ */
+
+int32 rtl8651_setAsicNetInterface( uint32 idx, rtl865x_tblAsicDrv_intfParam_t *intfp )
+{
+	rtl865xc_tblAsic_netifTable_t entry;
+	uint32 i;
+
+	if(intfp == NULL)
+		return FAILED;
+
+	if ( idx==RTL865XC_NETIFTBL_SIZE )
+	{
+		/* User does not specific idx, we shall find out idx first. */
+#ifdef FULL_CAP
+		/* search Interface table to see if exists */
+		for (i=0;i<RTL865XC_NETIFTBL_SIZE;i++)
+		{
+			_rtl8651_readAsicEntry(TYPE_NETINTERFACE_TABLE, i, &entry);
+	 		if ( entry.valid && entry.vid==intfp->vid )
+	 		{
+	 			idx = i;
+				goto exist;
+			}
+		}
+		/* Not existed, find an empty entry */
+		for (i=0;i<RTL865XC_NETIFTBL_SIZE;i++)
+		{
+			_rtl8651_readAsicEntry(TYPE_NETINTERFACE_TABLE, i, &entry);
+			if ( !entry.valid )
+				break;
+		}
+		if ( i>=RTL865XC_NETIFTBL_SIZE )
+			return FAILED; /* no empty entry */
+		idx = i;
+#else
+		/* search Interface table to see if exists */
+		for (i=0;i<RTL865XC_NETIFTBL_SIZE;i++)
+		{
+			/* Since FPGA only has entry 0,1,6,7, we ignore null entry. */
+			if (i>1&&(i<(RTL865XC_NETIFTBL_SIZE-2))) continue;
+
+			_rtl8651_readAsicEntry(TYPE_NETINTERFACE_TABLE, i, &entry);
+			if (entry.valid)
+				if (entry.vid==intfp->vid)
+		 		{
+		 			idx = i;
+					goto exist;
+				}
+		}
+		/* Not existed, find an empty entry */
+		for (i=0;i<RTL865XC_NETIFTBL_SIZE;i++)
+		{
+			/* Since FPGA only has entry 0,1,6,7, we ignore null entry. */
+			if (i>1&&(i<(RTL865XC_NETIFTBL_SIZE-2))) continue;
+
+			_rtl8651_readAsicEntry(TYPE_NETINTERFACE_TABLE, i, &entry);
+			if (!entry.valid)
+			{
+				break;
+			}
+		}
+		if ( i>=RTL865XC_NETIFTBL_SIZE )
+			return FAILED; /* no empty entry */
+		idx = i;
+#endif
+	}
+
+exist:
+	assert( idx < RTL865XC_NETIFTBL_SIZE );
+
+#ifdef CONFIG_HARDWARE_NAT_DEBUG
+/*2007-12-19*/
+	rtlglue_printf("%s:%d,idx is %d ,intfp->vid is %d\n",__FUNCTION__,__LINE__,idx, intfp->vid);
+#endif
+
+	memset(&entry,0,sizeof(entry));
+	entry.valid = intfp->valid;
+	entry.vid = intfp->vid;
+	entry.mac47_19 = (intfp->macAddr.octet[0]<<21) | (intfp->macAddr.octet[1]<<13) | (intfp->macAddr.octet[2]<<5) |
+					 (intfp->macAddr.octet[3]>>3);
+	entry.mac18_0 = (intfp->macAddr.octet[3]<<16) | (intfp->macAddr.octet[4]<<8) | (intfp->macAddr.octet[5]);
+
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	entry.inACLStartH = (intfp->inAclStart >>1)&0x7f;
+	entry.inACLStartL = intfp->inAclStart&0x1;
+	entry.inACLEnd    = intfp->inAclEnd;
+	entry.outACLStart = intfp->outAclStart;
+	entry.outACLEnd   = intfp->outAclEnd;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	entry.enHWRouteV6 = intfp->enableRouteV6;
+	entry.enHWRoute   = intfp->enableRoute;
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#ifdef CONFIG_RTL_8198C_FPGA_TEST
+	entry.enHWRouteV6 = intfp->enableRouteV6;
+#else
+	entry.enHWRouteV6 = (rtl8651_getAsicOperationLayer()>2)?	(intfp->enableRouteV6==TRUE? 1: 0):0;
+#endif
+
+	entry.enHWRoute   = (rtl8651_getAsicOperationLayer()>2)?	(intfp->enableRoute==TRUE? 1: 0):0;
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	switch(intfp->macAddrNumber) {
+		case 0:
+		case 1:
+		    entry.macMaskL = 1;
+		    entry.macMaskH = 3;
+		break;
+		case 2:
+		    entry.macMaskL = 0;
+		    entry.macMaskH = 3;
+		break;
+		case 4:
+		    entry.macMaskL = 0;
+		    entry.macMaskH = 2;
+		break;
+		case 8:
+		    entry.macMaskL = 0;
+		    entry.macMaskH = 0;
+			break;
+		default:
+		    return FAILED;//Not permitted macNumber value
+	}
+	entry.mtu   = intfp->mtu;
+	entry.mtuV6 = intfp->mtuV6;
+#else
+
+	entry.inACLStartH = (intfp->inAclStart >>2)&0x1f;
+	entry.inACLStartL = intfp->inAclStart&0x3;
+	entry.inACLEnd = intfp->inAclEnd;
+	entry.outACLStart= intfp->outAclStart;
+	entry.outACLEnd = intfp->outAclEnd;
+
+	entry.enHWRoute = (rtl8651_getAsicOperationLayer()>2)?	(intfp->enableRoute==TRUE? 1: 0):0;
+
+
+	switch(intfp->macAddrNumber) {
+		case 0:
+		case 1:
+		    entry.macMask = 7;
+		break;
+		case 2:
+		    entry.macMask = 6;
+		break;
+		case 4:
+		    entry.macMask = 4;
+		break;
+		case 8:
+		    entry.macMask = 0;
+			break;
+		default:
+		    return FAILED;//Not permitted macNumber value
+	}
+	entry.mtuH = intfp->mtu >>3;
+	entry.mtuL = intfp->mtu & 0x7;
+#endif
+	return _rtl8651_forceAddAsicEntry(TYPE_NETINTERFACE_TABLE, idx, &entry);
+}
+
+
+/*
+@func int32		| rtl8651_getAsicNetInterface	| Get ASIC Interface Table
+@parm uint32 | idx | Table index.
+@parm rtl865x_tblAsicDrv_intfParam_t* | intfp | pointer to store interface structure
+@rvalue SUCCESS	| 	Success
+@rvalue FAILED	| 	Failed. Possible reason: idx error, or invalid entry.
+@comm
+To read an interface entry, we provide two ways:
+1. given the index which we want to read
+2. leave the index with RTL865XC_NETIFTBL_SIZE, we will search the whole table according the given intfp->vid
+ */
+int32 rtl8651_getAsicNetInterface( uint32 idx, rtl865x_tblAsicDrv_intfParam_t *intfp )
+{
+	rtl865xc_tblAsic_netifTable_t entry;
+	uint32 i;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	 uint32   macMask;
+#endif
+	if(intfp == NULL)
+		return FAILED;
+
+	intfp->valid=0;
+
+	if ( idx == RTL865XC_NETIFTBL_SIZE )
+	{
+		/* idx is not specified, we search whole interface table. */
+		for( i = 0; i < RTL865XC_NETIFTBL_SIZE; i++ )
+		{
+#ifdef FULL_CAP
+#else
+			/* Since FPGA only has entry 0,1,6,7, we ignore null entry. */
+			if (i>1&&(i<(RTL865XC_NETIFTBL_SIZE-2))) continue;
+#endif
+
+			_rtl8651_readAsicEntry(TYPE_NETINTERFACE_TABLE, i, &entry);
+			if ( entry.valid && entry.vid==intfp->vid ){
+				goto found;
+			}
+		}
+
+		/* intfp.vid is not found. */
+		return FAILED;
+	}
+	else
+	{
+		/* idx is specified, read from ASIC directly. */
+		_rtl8651_readAsicEntry(TYPE_NETINTERFACE_TABLE, idx, &entry);
+	}
+
+found:
+	intfp->valid=entry.valid;
+	intfp->vid=entry.vid;
+	intfp->macAddr.octet[0] = entry.mac47_19>>21;
+	intfp->macAddr.octet[1] = (entry.mac47_19 >>13)&0xff;
+	intfp->macAddr.octet[2] = (entry.mac47_19 >>5)&0xff;
+	intfp->macAddr.octet[3] = ((entry.mac47_19 &0x3f) <<3) | (entry.mac18_0 >>16);
+	intfp->macAddr.octet[4] = (entry.mac18_0 >> 8)&0xff;
+	intfp->macAddr.octet[5] = entry.mac18_0 & 0xff;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	intfp->inAclEnd     = entry.inACLEnd;
+	intfp->inAclStart   = (entry.inACLStartH<<1)|entry.inACLStartL;
+	intfp->outAclStart  = entry.outACLStart;
+	intfp->outAclEnd    = entry.outACLEnd;
+	intfp->enableRoute  = entry.enHWRoute==1? TRUE: FALSE;
+	intfp->enableRouteV6= entry.enHWRouteV6==1? TRUE: FALSE;
+
+	macMask = (entry.macMaskH<<1)|entry.macMaskL;
+	switch(macMask)
+	{
+		case 0:
+			intfp->macAddrNumber =8;
+			break;
+		case 6:
+			intfp->macAddrNumber =2;
+			break;
+		case 4:
+			intfp->macAddrNumber =4;
+			break;
+		case 7:
+			intfp->macAddrNumber =1;
+			break;
+	}
+	intfp->mtu = entry.mtu;
+	intfp->mtuV6 = entry.mtuV6;
+#else
+	intfp->inAclEnd = entry.inACLEnd;
+	intfp->inAclStart= (entry.inACLStartH<<2)|entry.inACLStartL;
+	intfp->outAclStart = entry.outACLStart;
+	intfp->outAclEnd = entry.outACLEnd;
+	intfp->enableRoute = entry.enHWRoute==1? TRUE: FALSE;
+
+	switch(entry.macMask)
+	{
+		case 0:
+			intfp->macAddrNumber =8;
+			break;
+		case 6:
+			intfp->macAddrNumber =2;
+			break;
+		case 4:
+			intfp->macAddrNumber =4;
+			break;
+		case 7:
+			intfp->macAddrNumber =1;
+			break;
+
+
+	}
+	intfp->mtu = (entry.mtuH <<3)|entry.mtuL;
+#endif
+	return SUCCESS;
+}
+
+
+/*=========================================
+  * ASIC DRIVER API: ACL Table
+  *=========================================*/
+
+/*
+@func int32	| rtl865xC_setDefaultACLReg	| This function sets default ACL Rule Control Register.
+@parm uint32	| isIngress	| TRUE if you want to set default ingress ACL register. FLASE if egress ACL register.
+@parm uint32	| start	| The starting address in the ACL table.
+@parm uint32	| end	| The ending address in the ACL table.
+@rvalue SUCCESS	| Done
+@comm
+This function sets the ACL range (starting & ending address) of default ACL Rule Control Register.
+*/
+int32 rtl865xC_setDefaultACLReg(uint32 isIngress, uint32 start, uint32 end)
+{
+	/* set default ingress ACL reg's start & end index of ASIC ACL table */
+	if ( isIngress == TRUE )
+	{
+		WRITE_MEM32( DACLRCR, ( READ_MEM32( DACLRCR ) & ( ~ACLI_STA_MASK ) ) | start );
+		WRITE_MEM32( DACLRCR, ( READ_MEM32( DACLRCR ) & ( ~ACLI_EDA_MASK ) ) | ( end << ACLI_EDA_OFFSET) );
+	}
+	else		/* egress */
+	{
+		WRITE_MEM32( DACLRCR, ( READ_MEM32( DACLRCR ) & ( ~ACLO_STA_MASK ) ) | ( start << ACLO_STA_OFFSET ) );
+		WRITE_MEM32( DACLRCR, ( READ_MEM32( DACLRCR ) & ( ~ACLO_EDA_MASK ) ) | ( end << ACLO_EDA_OFFSET ) );
+	}
+	return SUCCESS;
+}
+
+/*
+@func int32	| rtl865xC_getDefaultACLReg	| This function gets default ACL Rule Control Register.
+@parm uint32	| isIngress	| TRUE if you want to set default ingress ACL register. FLASE if egress ACL register.
+@parm uint32 *	| start	| Memory to store the starting address in the ACL table.
+@parm uint32 *	| end	| Memory to store the ending address in the ACL table.
+@rvalue SUCCESS	| Done
+@comm
+This function gets the ACL range (starting & ending address) of default ACL Rule Control Register.
+*/
+int32 rtl865xC_getDefaultACLReg(uint32 isIngress, uint32 *start, uint32 *end)
+{
+	/* set default ingress ACL reg's start & end index of ASIC ACL table */
+	if ( isIngress == TRUE )
+	{
+		*start = READ_MEM32( DACLRCR ) & ACLI_STA_MASK;
+		*end = ( READ_MEM32( DACLRCR ) & ACLI_EDA_MASK ) >> ACLI_EDA_OFFSET;
+	}
+	else		/* egress */
+	{
+		*start = ( READ_MEM32( DACLRCR ) & ACLO_STA_MASK ) >> ACLO_STA_OFFSET;
+		*end = ( READ_MEM32( DACLRCR ) & ACLO_EDA_MASK ) >> ACLO_EDA_OFFSET;
+	}
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicAclRule(uint32 index, rtl865xc_tblAsic_aclTable_t *rule)
+{
+	if(index >= RTL8651_ACLTBL_SIZE+RTL8651_ACLTBL_RESERV_SIZE || rule == NULL)
+		return FAILED;
+
+	return _rtl8651_readAsicEntry(TYPE_ACL_RULE_TABLE, index, rule);
+}
+
+/*
+@func int32 | rtl865xC_lockSWCore | stop TLU operation
+@rvalue SUCCESS |
+@comm
+	When TLU operation stopped, all the received pkt will be queue in rx buffer.
+ */
+int32 rtl865xC_lockSWCore(void)
+{
+	if (_rtl865xC_lockTLUCounter == 0)
+	{
+	#if 1
+		/*	record the original value	*/
+		_rtl865xC_lockTLUPHYREG[0] = READ_MEM32(PCRP0);
+		_rtl865xC_lockTLUPHYREG[1] = READ_MEM32(PCRP1);
+		_rtl865xC_lockTLUPHYREG[2] = READ_MEM32(PCRP2);
+		_rtl865xC_lockTLUPHYREG[3] = READ_MEM32(PCRP3);
+		_rtl865xC_lockTLUPHYREG[4] = READ_MEM32(PCRP4);
+		if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+			_rtl865xC_lockTLUPHYREG[5] = READ_MEM32(PCRP5);
+
+		/*	disable phy */
+		WRITE_MEM32(PCRP0, ((READ_MEM32(PCRP0))&(~PauseFlowControlNway)) ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP0,EnForceMode);
+		WRITE_MEM32(PCRP1, ((READ_MEM32(PCRP1))&(~PauseFlowControlNway)) ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP1,EnForceMode);
+		WRITE_MEM32(PCRP2, ((READ_MEM32(PCRP2))&(~PauseFlowControlNway)) ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP2,EnForceMode);
+		WRITE_MEM32(PCRP3, ((READ_MEM32(PCRP3))&(~PauseFlowControlNway)) ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP3,EnForceMode);
+		WRITE_MEM32(PCRP4, ((READ_MEM32(PCRP4))&(~PauseFlowControlNway)) ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP4,EnForceMode);
+
+		if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+		{
+			WRITE_MEM32(PCRP5, ((READ_MEM32(PCRP5))&(~PauseFlowControlNway)) ); /* Jumbo Frame */
+		}
+
+		//_rtl_inputThrehold = REG32(IQFCTCR);
+		#if !defined(CONFIG_RTD_1295_HWNAT)
+		_rtl_FCRegister = REG32(FCREN);
+		#endif //!defined(CONFIG_RTD_1295_HWNAT)
+		_rtl_inputBandWidth[0] = REG32(IBCR0);
+		_rtl_inputBandWidth[1] = REG32(IBCR1);
+		_rtl_inputBandWidth[2] = REG32(IBCR2);
+		#if defined(CONFIG_RTL_8197F)
+		_rtl_inputBandWidth3 = REG32(IBCR3);
+		#endif
+		//REG32(IQFCTCR) = (_rtl_inputThrehold&0xffffff00);
+		#if !defined(CONFIG_RTD_1295_HWNAT)
+		REG32(FCREN) = (_rtl_FCRegister&0x3ff);
+		#endif //!defined(CONFIG_RTD_1295_HWNAT)
+		REG32(IBCR0) = 0x10001;
+		REG32(IBCR1) = 0x10001;
+		REG32(IBCR2) = 0x10001;
+		#if defined(CONFIG_RTL_8197F)
+		REG32(IBCR3) = 0;
+		#endif
+//		REG32(QNUMCR) = 0;
+	#else
+		/*	record the original value	*/
+		_rtl865xC_lockTLUPHYREG[0] = READ_MEM32(PCRP0);
+		_rtl865xC_lockTLUPHYREG[1] = READ_MEM32(PCRP1);
+		_rtl865xC_lockTLUPHYREG[2] = READ_MEM32(PCRP2);
+		_rtl865xC_lockTLUPHYREG[3] = READ_MEM32(PCRP3);
+		_rtl865xC_lockTLUPHYREG[4] = READ_MEM32(PCRP4);
+		if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+			_rtl865xC_lockTLUPHYREG[5] = READ_MEM32(PCRP5);
+
+		/*	disable phy */
+		WRITE_MEM32(PCRP0, ((READ_MEM32(PCRP0))&(~EnablePHYIf)) ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP0,EnForceMode);
+		WRITE_MEM32(PCRP1, ((READ_MEM32(PCRP1))&(~EnablePHYIf)) ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP1,EnForceMode);
+		WRITE_MEM32(PCRP2, ((READ_MEM32(PCRP2))&(~EnablePHYIf)) ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP2,EnForceMode);
+		WRITE_MEM32(PCRP3, ((READ_MEM32(PCRP3))&(~EnablePHYIf)) ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP3,EnForceMode);
+		WRITE_MEM32(PCRP4, ((READ_MEM32(PCRP4))&(~EnablePHYIf)) ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP4,EnForceMode);
+
+		if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+		{
+			WRITE_MEM32(PCRP5, ((READ_MEM32(PCRP5))&(~EnablePHYIf)) ); /* Jumbo Frame */
+		}
+	#endif
+	}
+
+	_rtl865xC_lockTLUCounter++;
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865xC_unLockSWCore | restart TLU operation
+@rvalue SUCCESS |
+@comm
+	restore the system operation.
+ */
+ int32 rtl865xC_unLockSWCore(void)
+ {
+	if (_rtl865xC_lockTLUCounter == 1)
+	{
+	#if 1
+		//REG32(IQFCTCR) = _rtl_inputThrehold;
+		#if !defined(CONFIG_RTD_1295_HWNAT)
+		REG32(FCREN) = _rtl_FCRegister;
+		#endif //!defined(CONFIG_RTD_1295_HWNAT)
+		//REG32(QNUMCR) = _rtl_QNumRegister;
+		REG32(IBCR0) = _rtl_inputBandWidth[0];
+		REG32(IBCR1) = _rtl_inputBandWidth[1];
+		REG32(IBCR2) = _rtl_inputBandWidth[2];
+		#if defined(CONFIG_RTL_8197F)
+		REG32(IBCR3) = _rtl_inputBandWidth3;
+		#endif
+
+		WRITE_MEM32(PCRP0, _rtl865xC_lockTLUPHYREG[0]); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP0,EnForceMode);
+		WRITE_MEM32(PCRP1, _rtl865xC_lockTLUPHYREG[1] ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP1,EnForceMode);
+		WRITE_MEM32(PCRP2, _rtl865xC_lockTLUPHYREG[2] ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP2,EnForceMode);
+		WRITE_MEM32(PCRP3, _rtl865xC_lockTLUPHYREG[3] ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP3,EnForceMode);
+		WRITE_MEM32(PCRP4, _rtl865xC_lockTLUPHYREG[4] ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP4,EnForceMode);
+
+		if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+		{
+			WRITE_MEM32(PCRP5, _rtl865xC_lockTLUPHYREG[5] ); /* Jumbo Frame */
+		}
+
+	#else
+		/*	restore phy */
+#if 0
+		WRITE_MEM32(PCRP0, ((READ_MEM32(PCRP0))|(EnablePHYIf)) ); /* Jumbo Frame */
+		WRITE_MEM32(PCRP1, ((READ_MEM32(PCRP1))|(EnablePHYIf)) ); /* Jumbo Frame */
+		WRITE_MEM32(PCRP2, ((READ_MEM32(PCRP2))|(EnablePHYIf)) ); /* Jumbo Frame */
+		WRITE_MEM32(PCRP3, ((READ_MEM32(PCRP3))|(EnablePHYIf)) ); /* Jumbo Frame */
+		WRITE_MEM32(PCRP4, ((READ_MEM32(PCRP4))|(EnablePHYIf)) ); /* Jumbo Frame */
+
+		if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+		{
+			WRITE_MEM32(PCRP5, ((READ_MEM32(PCRP5))|(EnablePHYIf)) ); /* Jumbo Frame */
+		}
+
+#else
+		WRITE_MEM32(PCRP0, _rtl865xC_lockTLUPHYREG[0]); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP0,EnForceMode);
+		WRITE_MEM32(PCRP1, _rtl865xC_lockTLUPHYREG[1] ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP1,EnForceMode);
+		WRITE_MEM32(PCRP2, _rtl865xC_lockTLUPHYREG[2] ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP2,EnForceMode);
+		WRITE_MEM32(PCRP3, _rtl865xC_lockTLUPHYREG[3] ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP3,EnForceMode);
+		WRITE_MEM32(PCRP4, _rtl865xC_lockTLUPHYREG[4] ); /* Jumbo Frame */
+		TOGGLE_BIT_IN_REG_TWICE(PCRP4,EnForceMode);
+
+		if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+		{
+			WRITE_MEM32(PCRP5, _rtl865xC_lockTLUPHYREG[5] ); /* Jumbo Frame */
+		}
+#endif
+	#endif
+	}
+
+	_rtl865xC_lockTLUCounter--;
+	return SUCCESS;
+ }
+
+
+/*define for version control --Mark*/
+#define RLRevID_OFFSET  12
+#define RLRevID_MASK    0x0f
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#define A_DIFF_B_ADDR   (PCI_CTRL_BASE+0x08) /*B800-3408*/
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+/* get CHIP version */
+int32 rtl8651_getChipVersion(int8 *name,uint32 size, int32 *rev)
+{
+	int32 revID;
+	#if !defined(CONFIG_RTD_1295_HWNAT)
+	uint32 val;
+	#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+	revID = ((READ_MEM32(CRMR)) >> RLRevID_OFFSET) & RLRevID_MASK ;
+#ifdef CONFIG_RTL_819X
+	strncpy(name,"8196C",size);
+#else
+	strncpy(name,"865xC",size);
+#endif
+	if(rev == NULL)
+		return SUCCESS;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	/* pseudo code */
+	if(revID >= RTL865X_CHIP_REV_B )
+		*rev = revID ;
+	else
+		*rev = RTL865X_CHIP_REV_A;
+#else //defined(CONFIG_RTD_1295_HWNAT)
+	/*modified by Mark*/
+	/*if RLRevID >= 1 V.B  *rev = RLRevID*/
+	/*RLRevID == 0 ,then need to check [B800-3408]*/
+
+	if(revID >= RTL865X_CHIP_REV_B )
+		*rev = revID ;
+	else /*A-CUT or B-CUT*/
+	{
+		val = READ_MEM32(A_DIFF_B_ADDR);
+		if(val == 0)
+			*rev = RTL865X_CHIP_REV_A; /* RTL865X_CHIP_REV_A*/
+		else
+			*rev = RTL865X_CHIP_REV_B; /* RTL865X_CHIP_REV_B*/
+	}
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+	return SUCCESS;
+}
+
+int32 rtl8651_getChipNameID(int32 *id)
+{
+	*id = RTL865X_CHIP_VER_RTL8196C;
+	return  SUCCESS;
+}
+
+
+/*=========================================
+  * ASIC DRIVER API: SYSTEM INIT
+  *=========================================*/
+#define RTL865X_ASIC_DRIVER_SYSTEM_INIT_API
+
+/*
+@func void | rtl8651_clearRegister | Clear ALL registers in ASIC
+@comm
+	Clear ALL registers in ASIC.
+	for RTL865xC only
+*/
+
+void rtl8651_clearRegister(void)
+{
+	int i = 0;
+
+	WRITE_MEM32(MACCR,LONG_TXE);
+	WRITE_MEM32(MGFCR_E0R0,0);
+	WRITE_MEM32(MGFCR_E0R1,0);
+	WRITE_MEM32(MGFCR_E0R2,0);
+	WRITE_MEM32(MGFCR_E1R0,0);
+	WRITE_MEM32(MGFCR_E1R1,0);
+	WRITE_MEM32(MGFCR_E1R2,0);
+	WRITE_MEM32(MGFCR_E2R0,0);
+	WRITE_MEM32(MGFCR_E2R1,0);
+	WRITE_MEM32(MGFCR_E2R2,0);
+	WRITE_MEM32(MGFCR_E3R0,0);
+	WRITE_MEM32(MGFCR_E3R1,0);
+	WRITE_MEM32(MGFCR_E3R2,0);
+	WRITE_MEM32(VCR0,0);
+	WRITE_MEM32(VCR1,0);
+	WRITE_MEM32(PVCR0,0);
+	WRITE_MEM32(PVCR1,0);
+	WRITE_MEM32(PVCR2,0);
+	WRITE_MEM32(PVCR3,0);
+	WRITE_MEM32(PVCR4,0);
+	WRITE_MEM32(TEACR,0);
+	WRITE_MEM32(FFCR,0);
+	WRITE_MEM32(DOT1XPORTCR,0);
+	WRITE_MEM32(DOT1XMACCR,0);
+	WRITE_MEM32(GVGCR,0);
+	WRITE_MEM32(SWTCR0,0);
+	WRITE_MEM32(SWTCR1,0);
+	WRITE_MEM32(PLITIMR,0);
+	/* Set all Protocol-Based Reg. to 0 */
+	WRITE_MEM32(PBVCR0,  0x00000000);
+	WRITE_MEM32(PBVCR1, 0x00000000);
+	WRITE_MEM32(PBVR0_0, 0x00000000);	/* IPX */
+	WRITE_MEM32(PBVR0_1, 0x00000000);	/* IPX */
+	WRITE_MEM32(PBVR0_2, 0x00000000);	/* IPX */
+	WRITE_MEM32(PBVR0_3, 0x00000000);	/* IPX */
+	WRITE_MEM32(PBVR0_4, 0x00000000);	/* IPX */
+	WRITE_MEM32(PBVR1_0,  0x00000000);	/* NetBIOS */
+	WRITE_MEM32(PBVR1_1,  0x00000000);	/* NetBIOS */
+	WRITE_MEM32(PBVR1_2,  0x00000000);	/* NetBIOS */
+	WRITE_MEM32(PBVR1_3,  0x00000000);	/* NetBIOS */
+	WRITE_MEM32(PBVR1_4,  0x00000000);	/* NetBIOS */
+	WRITE_MEM32(PBVR2_0,  0x00000000);	/* PPPoE Control */
+	WRITE_MEM32(PBVR2_1,  0x00000000);
+	WRITE_MEM32(PBVR2_2,  0x00000000);
+	WRITE_MEM32(PBVR2_3,  0x00000000);
+	WRITE_MEM32(PBVR2_4,  0x00000000);
+	WRITE_MEM32(PBVR3_0,  0x00000000);	/* PPPoE Session */
+	WRITE_MEM32(PBVR3_1,  0x00000000);	/* PPPoE Session */
+	WRITE_MEM32(PBVR3_2,  0x00000000);	/* PPPoE Session */
+	WRITE_MEM32(PBVR3_3,  0x00000000);	/* PPPoE Session */
+	WRITE_MEM32(PBVR3_4,  0x00000000);	/* PPPoE Session */
+	WRITE_MEM32(PBVR4_0,  0x00000000);	/* User-defined 1 */
+	WRITE_MEM32(PBVR4_1,  0x00000000);	/* User-defined 1 */
+	WRITE_MEM32(PBVR4_2,  0x00000000);	/* User-defined 1 */
+	WRITE_MEM32(PBVR4_3,  0x00000000);	/* User-defined 1 */
+	WRITE_MEM32(PBVR4_4,  0x00000000);	/* User-defined 1 */
+	WRITE_MEM32(PBVR5_0,  0x00000000);	/* User-defined 2 */
+	WRITE_MEM32(PBVR5_1,  0x00000000);	/* User-defined 2 */
+	WRITE_MEM32(PBVR5_2,  0x00000000);	/* User-defined 2 */
+	WRITE_MEM32(PBVR5_3,  0x00000000);	/* User-defined 2 */
+	WRITE_MEM32(PBVR5_4,  0x00000000);	/* User-defined 2 */
+	WRITE_MEM32(MSCR,0);
+
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	WRITE_MEM32(PCRP0, (1 | MacSwReset));
+	TOGGLE_BIT_IN_REG_TWICE(PCRP0,EnForceMode);
+	WRITE_MEM32(PCRP1, (1 | MacSwReset));
+	TOGGLE_BIT_IN_REG_TWICE(PCRP1,EnForceMode);
+	WRITE_MEM32(PCRP2, (1 | MacSwReset));
+	TOGGLE_BIT_IN_REG_TWICE(PCRP2,EnForceMode);
+	WRITE_MEM32(PCRP3, (1 | MacSwReset));
+	TOGGLE_BIT_IN_REG_TWICE(PCRP3,EnForceMode);
+	WRITE_MEM32(PCRP4, (1 | MacSwReset));
+	TOGGLE_BIT_IN_REG_TWICE(PCRP4,EnForceMode);
+#else
+	WRITE_MEM32(PCRP0,1);
+	WRITE_MEM32(PCRP1,1);
+	WRITE_MEM32(PCRP2,1);
+	WRITE_MEM32(PCRP3,1);
+	WRITE_MEM32(PCRP4,1);
+#endif
+	WRITE_MEM32(PCRP5,1);
+	WRITE_MEM32(PCRP6,1);
+	WRITE_MEM32(PCRP7,1);
+	WRITE_MEM32(PCRP8,1);
+	WRITE_MEM32(PPMAR,1);
+	WRITE_MEM32(SIRR, TRXRDY);
+	/* WRITE_MEM32(TMCR,0xFCFC0000); */
+	WRITE_MEM32(QIDDPCR,(0x1<<NAPT_PRI_OFFSET)|(0x1<<ACL_PRI_OFFSET)|(0x1<<DSCP_PRI_OFFSET)|(0x1<<BP8021Q_PRI_OFFSET)|(0x1<<PBP_PRI_OFFSET));
+	WRITE_MEM32(LPTM8021Q,0);
+	WRITE_MEM32(DSCPCR0,0);
+	WRITE_MEM32(DSCPCR1,0);
+	WRITE_MEM32(DSCPCR2,0);
+	WRITE_MEM32(DSCPCR3,0);
+	WRITE_MEM32(DSCPCR4,0);
+	WRITE_MEM32(DSCPCR5,0);
+	WRITE_MEM32(DSCPCR6,0);
+	WRITE_MEM32(RMACR,0);
+	WRITE_MEM32(ALECR,0);
+
+	/* System Based Flow Control Threshold Register */
+	WRITE_MEM32( SBFCR0, (0x1E0<<S_DSC_RUNOUT_OFFSET) );
+	WRITE_MEM32( SBFCR1, (0x0190<<S_DSC_FCOFF_OFFSET)|(0x01CC<<S_DSC_FCON_OFFSET) );
+	WRITE_MEM32( SBFCR2, (0x0050<<S_Max_SBuf_FCOFF_OFFSET)|(0x006C<<S_Max_SBuf_FCON_OFFSET) );
+	/* Port Based Flow Control Threshold Register */
+	WRITE_MEM32( PBFCR0, (0x003C<<P_MaxDSC_FCOFF_OFFSET)|(0x005A<<P_MaxDSC_FCON_OFFSET) );
+	WRITE_MEM32( PBFCR1, (0x003C<<P_MaxDSC_FCOFF_OFFSET)|(0x005A<<P_MaxDSC_FCON_OFFSET) );
+	WRITE_MEM32( PBFCR2, (0x003C<<P_MaxDSC_FCOFF_OFFSET)|(0x005A<<P_MaxDSC_FCON_OFFSET) );
+	WRITE_MEM32( PBFCR3, (0x003C<<P_MaxDSC_FCOFF_OFFSET)|(0x005A<<P_MaxDSC_FCON_OFFSET) );
+	WRITE_MEM32( PBFCR4, (0x003C<<P_MaxDSC_FCOFF_OFFSET)|(0x005A<<P_MaxDSC_FCON_OFFSET) );
+	WRITE_MEM32( PBFCR5, (0x003C<<P_MaxDSC_FCOFF_OFFSET)|(0x005A<<P_MaxDSC_FCON_OFFSET) );
+
+	/* Packet Schecduling Control Register */
+	WRITE_MEM32(ELBPCR, (51<<Token_OFFSET)|(38<<Tick_OFFSET) );
+	WRITE_MEM32(ELBTTCR, /*0x99*/0x400<<L2_OFFSET );
+	WRITE_MEM32(ILBPCR1, (0<<UpperBound_OFFSET)|(0<<LowerBound_OFFSET) );
+	WRITE_MEM32(ILBPCR2, (0x33<<ILB_feedToken_OFFSET)|(0x26<<ILB_Tick_OFFSET) );
+	for( i = 0; i<42; i++ )
+		WRITE_MEM32(P0Q0RGCR+i*4, (7<<PPR_OFFSET)|(0xff<<L1_OFFSET)|(0x3FFF<<APR_OFFSET) );
+	for( i = 0; i<7; i++ )
+	{
+		#if defined(CONFIG_RTL_8197F)
+		WRITE_MEM32(WFQRCRP0+i*4*3+ 0, 0xfffff<<APR_OFFSET ); /*WFQRCRP0*/
+		#else
+		WRITE_MEM32(WFQRCRP0+i*4*3+ 0, 0x3fff<<APR_OFFSET ); /*WFQRCRP0*/
+		#endif
+		WRITE_MEM32(WFQRCRP0+i*4*3+ 4, 0 ); 				 /* WFQWCR0P0 */
+		WRITE_MEM32(WFQRCRP0+i*4*3+ 8, 0 ); 				 /* WFQWCR1P0 */
+	}
+
+	for (i=0;i<48;i+=4)
+			WRITE_MEM32(PATP0+i,0xfe12);
+
+	rtl8651_totalExtPortNum=0;
+
+	/* Set chip's mode as NORMAL mode */
+	WRITE_MEM32(TMCR,~ENHSBTESTMODE&READ_MEM32(TMCR));
+
+	/* CPU NIC */
+	WRITE_MEM32(CPUICR,READ_MEM32(CPUICR)&~(LBMODE|LB10MHZ|MITIGATION|EXCLUDE_CRC));
+	WRITE_MEM32(CPUIISR,READ_MEM32(CPUIISR));  /* clear all interrupt */
+	WRITE_MEM16(CPUQDM0,0);
+	WRITE_MEM16(CPUQDM1,0);
+	WRITE_MEM16(CPUQDM2,0);
+	WRITE_MEM16(CPUQDM3,0);
+	WRITE_MEM16(CPUQDM4,0);
+	WRITE_MEM16(CPUQDM5,0);
+	WRITE_MEM32(RMCR1P,0);
+	WRITE_MEM32(DSCPRM0,0);
+	WRITE_MEM32(DSCPRM1,0);
+	WRITE_MEM32(RLRC,0);
+
+#if 0 /* Since swNic only init once when starting model code, we don't clear the following registers. */
+	WRITE_MEM32(CPURPDCR0,0);
+	WRITE_MEM32(CPURPDCR1,0);
+	WRITE_MEM32(CPURPDCR2,0);
+	WRITE_MEM32(CPURPDCR3,0);
+	WRITE_MEM32(CPURPDCR4,0);
+	WRITE_MEM32(CPURPDCR5,0);
+	WRITE_MEM32(CPURMDCR0,0);
+	WRITE_MEM32(CPUTPDCR0,0);
+	WRITE_MEM32(CPUTPDCR1,0);
+	WRITE_MEM32(CPUIIMR,0);
+#endif
+
+}
+
+void rtl8651_clearSpecifiedAsicTable(uint32 type, uint32 count)
+{
+	rtl865xc_tblAsic_aclTable_t entry;
+	uint32 idx;
+
+	memset(&entry,0,sizeof(entry));
+	for (idx=0; idx<count; idx++)// Write into hardware
+		_rtl8651_forceAddAsicEntry(type, idx, &entry);
+
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+// Joey_added, 03-09-2017
+int32 rtl8651_clearAsicNaptTable(void)
+{
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	REG32(MEMCR) &= ~(1<<1);
+	REG32(MEMCR) |= (1<<1); // L4
+
+	// wait for L4 table clear done.
+	while ( (REG32(MEMCR) & (1<<9)) != (1<<9) ) {} ;
+#else
+	#define RTL8651_TCPUDPTBL_SIZE			1024
+	rtl8651_clearSpecifiedAsicTable(TYPE_L4_TCP_UDP_TABLE, RTL8651_TCPUDPTBL_SIZE);
+#endif
+
+	return SUCCESS;
+}
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+int32 rtl8651_clearAsicCommTable(void)
+{
+	//rtl8651_clearSpecifiedAsicTable(TYPE_L2_SWITCH_TABLE, RTL8651_L2TBL_ROW*RTL8651_L2TBL_COLUMN);
+	//rtl8651_clearSpecifiedAsicTable(TYPE_RATE_LIMIT_TABLE, RTL8651_RATELIMITTBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_NETINTERFACE_TABLE, RTL865XC_NETINTERFACE_NUMBER);
+#if defined(CONFIG_RTD_1295_HWNAT)
+	rtl8651_clearSpecifiedAsicTable(TYPE_VLAN_TABLE, RTL865XC_VLANTBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_ACL_RULE_TABLE, RTL8651_ACLTBL_SIZE);
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	REG32(MEMCR) = 0;
+	REG32(MEMCR) = ((1<<2) | (1<<5)); // VLAN and ACL
+
+	// wait for ACL table clear done due to the code below will set ACL table.
+	//while ( (REG32(MEMCR) & (1<< (5+8))) == 0 ) {} ;
+	while ( (REG32(MEMCR) & ((1<<10) | (1<<13))) != ((1<<10) | (1<<13)) ) {} ;
+#else
+	rtl8651_clearSpecifiedAsicTable(TYPE_VLAN_TABLE, RTL865XC_VLANTBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_ACL_RULE_TABLE, RTL8651_ACLTBL_SIZE);
+#endif
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	/*
+	_rtl8651_clearSpecifiedAsicTable(TYPE_EXT_INT_IP_TABLE, RTL8651_IPTABLE_SIZE);
+	_rtl8651_clearSpecifiedAsicTable(TYPE_ARP_TABLE, RTL8651_ARPTBL_SIZE);
+	_rtl8651_clearSpecifiedAsicTable(TYPE_PPPOE_TABLE, RTL8651_PPPOE_NUMBER);
+	_rtl8651_clearSpecifiedAsicTable(TYPE_NEXT_HOP_TABLE, RTL8651_NEXTHOPTBL_SIZE);
+	_rtl8651_clearSpecifiedAsicTable(TYPE_L3_ROUTING_TABLE, RTL8651_ROUTINGTBL_SIZE);
+	_rtl8651_clearSpecifiedAsicTable(TYPE_MULTICAST_TABLE, RTL8651_IPMULTICASTTBL_SIZE);
+	_rtl8651_clearSpecifiedAsicTable(TYPE_ALG_TABLE, RTL865XC_ALGTBL_SIZE);
+	_rtl8651_clearSpecifiedAsicTable(TYPE_SERVER_PORT_TABLE, RTL8651_SERVERPORTTBL_SIZE);
+	_rtl8651_clearSpecifiedAsicTable(TYPE_L4_TCP_UDP_TABLE, RTL8651_TCPUDPTBL_SIZE);
+	_rtl8651_clearSpecifiedAsicTable(TYPE_L4_ICMP_TABLE, RTL8651_ICMPTBL_SIZE);
+
+	*/
+
+	{
+		rtl865xc_tblAsic_aclTable_t rule;
+		int32 aclIdx;
+
+		memset(&rule,0,sizeof(rtl865xc_tblAsic_aclTable_t));
+		rule.actionType = 0x0;
+		rule.ruleType = 0x0;
+		for(aclIdx=0; aclIdx<=RTL8651_ACLHWTBL_SIZE; aclIdx++)
+			_rtl8651_forceAddAsicEntry(TYPE_ACL_RULE_TABLE,aclIdx, &rule);
+
+	}
+
+	return SUCCESS;
+}
+#if defined(CONFIG_OPENWRT_SDK)
+unsigned int GetSysClockRateForAsicDrv(void)
+{
+	unsigned int SysClkRate;
+
+    REG32(MACMR) = REG32(MACMR) & ~SYS_CLK_MASK;
+    switch ( REG32(MACMR) & SYS_CLK_MASK )
+    {
+	case SYS_CLK_100M:
+	    SysClkRate = 100000000;
+	    break;
+	case SYS_CLK_90M:
+	    SysClkRate = 90000000;
+	    break;
+	case SYS_CLK_85M:
+	    SysClkRate = 85000000;
+	    break;
+	case SYS_CLK_96M:
+	    SysClkRate = 96000000;
+	    break;
+	case SYS_CLK_80M:
+	    SysClkRate = 80000000;
+	    break;
+	case SYS_CLK_75M:
+	    SysClkRate = 75000000;
+	    break;
+	case SYS_CLK_70M:
+	    SysClkRate = 70000000;
+	    break;
+	case SYS_CLK_50M:
+	    SysClkRate = 50000000;
+	    break;
+	default:
+	    while(1);
+    }
+
+    return SysClkRate;
+}
+#endif
+
+/*=========================================
+  * ASIC DRIVER API: SWITCH MODE
+  *=========================================*/
+static int32 rtl8651_operationlayer=0;
+int32 rtl8651_setAsicOperationLayer(uint32 layer)
+{
+	if(layer<1 || layer>4)
+		return FAILED;
+	/*   for bridge mode ip multicast patch
+		When  in bridge mode,
+		only one vlan(8) is available,
+		if rtl8651_operationlayer is set less than 3,
+		(pelase refer to rtl8651_setAsicVlan() )
+		the "enable routing bit" of VLAN table will be set to 0 according to rtl8651_operationlayer.
+		On the one hand, multicast data is flooded in vlan(8) by hardware,
+		on the other hand,it will be also trapped to cpu.
+		In romedriver process,
+		it will do _rtl8651_l2PhysicalPortRelay() in _rtl8651_l2switch(),
+		and results in same multicast packet being flooded twice:
+		one is by hareware, the other is by romedriver.
+		so the minimum  rtl8651_operationlayer will be set 3.
+	*/
+	#if 0//defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	/*if hardware multicast is enable the minimium asic operation layer must be above layer 3  */
+	if(layer<4)
+	{
+		layer=4;
+	}
+	#endif
+	if(layer == 1) {
+		WRITE_MEM32(MSCR,READ_MEM32(MSCR)&~(EN_L2|EN_L3|EN_L4));
+		WRITE_MEM32(MSCR,READ_MEM32(MSCR)&~(EN_IN_ACL));
+		WRITE_MEM32(MSCR,READ_MEM32(MSCR)&~(EN_OUT_ACL));
+	}else{
+		/*
+		 * Egress acl check should never enable, becuase of some hardware bug
+		 * reported by alpha    2007/12/05
+		 */
+		#ifndef CONFIG_RTL_NFJROM_MP
+		WRITE_MEM32(MSCR,READ_MEM32(MSCR)|(EN_IN_ACL));
+		#endif
+		/*WRITE_MEM32(MSCR,READ_MEM32(MSCR)|(EN_OUT_ACL));*/
+
+		if(layer == 2) {
+			WRITE_MEM32(MSCR,READ_MEM32(MSCR)|(EN_L2));
+			WRITE_MEM32(MSCR,READ_MEM32(MSCR)&~(EN_L3|EN_L4));
+		}
+		else
+		{	// options for L3/L4 enable
+			//WRITE_MEM32(MISCCR,READ_MEM32(MISCCR)|FRAG2CPU); //IP fragment packet need to send to CPU when multilayer is enabled
+			/*
+			  * Only for RTL8650B:
+			  * It is no need to trap fragment packets to CPU in pure rouitng mode while ACL is enabled, hence we should
+			  * turn this bit (FRAG2CPU) off.
+			  * NOTE: if we do this, we should also turn ENFRAG2ACLPT on.
+			  *														-chhuang, 7/30/2004
+			  */
+			   /*
+			  *    FRAG2CPU bit should be in ALECR register, not MSCR.
+			  */
+			//WRITE_MEM32(MSCR,READ_MEM32(MSCR) & ~FRAG2CPU);
+			#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+			WRITE_MEM32(ALECR,READ_MEM32(ALECR) | FRAG2CPU);
+			#else
+			WRITE_MEM32(ALECR,READ_MEM32(ALECR) & ~FRAG2CPU);
+			#endif
+
+			if(layer == 3) {
+				WRITE_MEM32(MSCR,READ_MEM32(MSCR)|(EN_L2|EN_L3));
+				WRITE_MEM32(MSCR,READ_MEM32(MSCR)&~(EN_L4));
+			}
+			else {	// layer 4
+				WRITE_MEM32(MSCR,READ_MEM32(MSCR)|(EN_L2|EN_L3|EN_L4));
+			}
+		}
+	}
+	if(layer == 1)
+		rtl8651_setAsicAgingFunction(FALSE, FALSE);
+	else if (layer == 2 || layer == 3)
+		rtl8651_setAsicAgingFunction(TRUE, FALSE);
+	else
+		rtl8651_setAsicAgingFunction(TRUE, TRUE);
+	rtl8651_operationlayer	=layer;
+	return SUCCESS;
+}
+
+
+
+int32 rtl8651_getAsicOperationLayer(void)
+{
+	return  rtl8651_operationlayer;
+}
+
+int32 rtl8651_setAsicAgingFunction(int8 l2Enable, int8 l4Enable)
+{
+	WRITE_MEM32( TEACR, (READ_MEM32(TEACR) & ~0x3) |(l2Enable == TRUE? 0x0: 0x1) | (l4Enable == TRUE? 0x0 : 0x2));
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicAgingFunction(int8 * l2Enable, int8 * l4Enable) {
+	if(l2Enable == NULL || l4Enable == NULL)
+		return FAILED;
+
+	*l2Enable = (READ_MEM32(TEACR) & 0x1)? FALSE: TRUE;
+	*l4Enable = (READ_MEM32(TEACR) & 0x2)? FALSE: TRUE;
+	return SUCCESS;
+}
+
+   #define BSP_SW_IE           (1 << 15)
+void rtl865x_start(void)
+{
+	/* set "Lexra Bus Burst Size" to 128
+		Prevents DMA occupying the Lexra bus for too long.
+		00: 32 Bytes,  01: 64 (alignment issue must be fixed) 10:128
+	*/
+	//REG32(CPUICR) = TXCMD | RXCMD | BUSBURST_32WORDS | MBUF_2048BYTES;
+	REG32(CPUICR) = TXCMD | RXCMD | BUSBURST_128WORDS | MBUF_2048BYTES;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	REG32(DMA_CR0) = (REG32(DMA_CR0) & ~(LowFifoMark_MASK|HiFifoMark_MASK)) | ((0x80<<LowFifoMark_OFFSET)|0xC0);
+#else /* CONFIG_RTD_1295_HWNAT */
+#if defined(CONFIG_RTL_8197F)
+	// the HiFifoMark value will be reset to default value (0x57) after updated the burst size field of CPUICR
+	REG32(DMA_CR0) = (REG32(DMA_CR0) & ~(LowFifoMark_MASK|HiFifoMark_MASK)) | ((0xA0<<LowFifoMark_OFFSET)|0xA0);
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	REG32(0xbb0c0000) = REG32(0xbb0c0000); // read entry 0 of ACL table to fix driver can't receive packet when lan un-plug
+#endif
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+	REG32(CPUIISR) = REG32(CPUIISR);
+#if 1
+	REG32(CPUIIMR) = RX_DONE_IE_ALL | TX_ALL_DONE_IE_ALL | LINK_CHANGE_IE | PKTHDR_DESC_RUNOUT_IE_ALL;
+#else
+	//REG32(CPUIIMR) = RX_DONE_IE_ALL | LINK_CHANGE_IE | PKTHDR_DESC_RUNOUT_IE_ALL | MBUF_DESC_RUNOUT_IE_ALL | TX_ALL_DONE_IE_ALL;
+	REG32(CPUIIMR) = RX_DONE_IE_ALL | LINK_CHANGE_IE | PKTHDR_DESC_RUNOUT_IE_ALL | MBUF_DESC_RUNOUT_IE_ALL;
+#endif
+	REG32(SIRR) = TRXRDY;
+	#if !defined(CONFIG_RTD_1295_HWNAT)
+	REG32(GIMR) |= (BSP_SW_IE);
+	#endif //!defined(CONFIG_RTD_1295_HWNAT)
+}
+
+void rtl865x_down(void)
+{
+	REG32(CPUIIMR) = 0;
+	REG32(CPUIISR) = REG32(CPUIISR);
+	#if !defined(CONFIG_RTD_1295_HWNAT)
+	REG32(GIMR) &= ~(BSP_SW_IE);
+	#endif //!defined(CONFIG_RTD_1295_HWNAT)
+	REG32(CPUICR) = 0;
+	REG32(SIRR) = 0;
+}
+
+unsigned int rtl865x_probeSdramSize(void)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	return 0;
+#else //defined(CONFIG_RTD_1295_HWNAT)
+	unsigned int memsize;
+	unsigned int MCRsdram;
+#if defined(CONFIG_RTL_819X)
+	unsigned int colcnt, rowcnt;
+	unsigned int colsize, rowsize;
+	MCRsdram = READ_MEM32(MCR);
+	{
+		/*	96c & 98	*/
+		colcnt = (READ_MEM32(DCR)&COLCNT_MASK)>>COLCNT_OFFSET;
+		rowcnt = (READ_MEM32(DCR)&ROWCNT_MASK)>>ROWCNT_OFFSET;
+		switch (colcnt)
+		{
+			case 0:	colsize = 256; break;
+			case 1:	colsize = 512; break;
+			case 2:	colsize = 1024; break;
+			case 3:	colsize = 2048; break;
+			case 4:	colsize = 4096; break;
+			default:
+			printk( "DDR SDRAM unknown(0x%08X):column cnt(0x%x)\n", MCRsdram, colcnt);
+			memsize = 0;
+			goto out;
+		}
+		switch(rowcnt)
+		{
+			case 0:	rowsize = 2048; break;
+			case 1:	rowsize = 4096; break;
+			case 2:	rowsize = 8192; break;
+			case 3:	rowsize = 16384; break;
+			default:
+			printk( "DDR SDRAM unknown(0x%08X):row cnt(0x%x)\n", MCRsdram, rowcnt);
+			memsize = 0;
+			goto out;
+		}
+		memsize = (colsize*rowsize)<<3;
+	}
+out:
+#else
+	switch ( MCRsdram = (READ_MEM32( MCR ) & 0x1C100010 ) )
+	{
+		/* SDRAM 16-bit mode */
+		case 0x00000000: memsize =  2<<20; break;
+		case 0x04000000: memsize =  4<<20; break;
+		case 0x08000000: memsize =  8<<20; break;
+		case 0x0C000000: memsize = 16<<20; break;
+		case 0x10000000: memsize = 32<<20; break;
+		case 0x14000000: memsize = 64<<20; break;
+
+		/* SDRAM 16-bit mode - 2 chip select */
+		case 0x00000010: memsize =  4<<20; break;
+		case 0x04000010: memsize =  8<<20; break;
+		case 0x08000010: memsize = 16<<20; break;
+		case 0x0C000010: memsize = 32<<20; break;
+		case 0x10000010: memsize = 64<<20; break;
+		case 0x14000010: memsize = 128<<20; break;
+
+		/* SDRAM 32-bit mode */
+		case 0x00100000: memsize =  4<<20; break;
+		case 0x04100000: memsize =  8<<20; break;
+		case 0x08100000: memsize = 16<<20; break;
+		case 0x0C100000: memsize = 32<<20; break;
+		case 0x10100000: memsize = 64<<20; break;
+		case 0x14100000: memsize =128<<20; break;
+
+		/* SDRAM 32-bit mode - 2 chip select */
+		case 0x00100010: memsize =  8<<20; break;
+		case 0x04100010: memsize = 16<<20; break;
+		case 0x08100010: memsize = 32<<20; break;
+		case 0x0C100010: memsize = 64<<20; break;
+		case 0x10100010: memsize =128<<20; break;
+		/*
+		case 0x14100010: memsize =256<<20; break;
+		*/
+
+		default:
+			printk( "SDRAM unknown(0x%08X)\n", MCRsdram );
+			memsize = 0;
+			break;
+	}
+#endif
+	return memsize;
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+}
+
+/*=========================================
+  * ASIC DRIVER API: ASIC Counter
+  *=========================================*/
+static void _rtl8651_initialRead(void) {//RTL8651 read counter for the first time will get value -1 and this is meaningless
+	uint32 i;
+	for(i=0; i<=0xac; i+=0x4)
+	{
+		rtl8651_returnAsicCounter(i);
+	}
+}
+
+uint32 rtl8651_returnAsicCounter(uint32 offset)
+{
+	if(offset & 0x3)
+		return 0;
+	return  READ_MEM32(MIB_COUNTER_BASE + offset);
+}
+
+uint64 rtl865xC_returnAsicCounter64(uint32 offset)
+{
+	if ( offset & 0x3 )
+		return 0;
+
+	return ( READ_MEM32( MIB_COUNTER_BASE + offset ) + ( ( uint64 ) READ_MEM32( MIB_COUNTER_BASE + offset + 4 ) << 22 ) );
+}
+
+int32 rtl8651_clearAsicCounter(void)
+{
+	WRITE_MEM32(MIB_CONTROL, ALL_COUNTER_RESTART_MASK);
+#if 0	/* We don't want to read once first. */
+	_rtl8651_initialRead();
+#endif
+	return SUCCESS;
+}
+
+int32 rtl8651_resetAsicMIBCounter(uint32 port, uint32 inCounterReset, uint32 outCounterReset )
+{
+	if(port==0xffffffff)
+	{
+		WRITE_MEM32(MIB_CONTROL, SYS_COUNTER_RESTART);
+		return SUCCESS;
+	}
+	else
+	{
+		switch(port)
+		{
+			case 0:
+				if(inCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, IN_COUNTER_RESTART_P0);
+				}
+
+				if(outCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, OUT_COUNTER_RESTART_P0);
+				}
+				break;
+
+			case 1:
+				if(inCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, IN_COUNTER_RESTART_P1);
+				}
+
+				if(outCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, OUT_COUNTER_RESTART_P1);
+				}
+				break;
+			case 2:
+				if(inCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, IN_COUNTER_RESTART_P2);
+				}
+
+				if(outCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, OUT_COUNTER_RESTART_P2);
+				}
+				break;
+			case 3:
+				if(inCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, IN_COUNTER_RESTART_P3);
+				}
+
+				if(outCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, OUT_COUNTER_RESTART_P3);
+				}
+				break;
+			case 4:
+				if(inCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, IN_COUNTER_RESTART_P4);
+				}
+
+				if(outCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, OUT_COUNTER_RESTART_P4);
+				}
+				break;
+			case 5:
+				if(inCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, IN_COUNTER_RESTART_P5);
+				}
+
+				if(outCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, OUT_COUNTER_RESTART_P5);
+				}
+				break;
+			case 6:
+				if(inCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, IN_COUNTER_RESTART_P6);
+				}
+
+				if(outCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, OUT_COUNTER_RESTART_P6);
+				}
+				break;
+			case 7:
+				if(inCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, IN_COUNTER_RESTART_P7);
+				}
+
+				if(outCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, OUT_COUNTER_RESTART_P7);
+				}
+				break;
+
+			case 8:
+				if(inCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, IN_COUNTER_RESTART_P8);
+				}
+
+				if(outCounterReset==TRUE)
+				{
+					WRITE_MEM32(MIB_CONTROL, OUT_COUNTER_RESTART_P8);
+				}
+				break;
+
+			default:
+				rtlglue_printf("wrong port number\n");
+				return FAILED;
+		}
+
+		return SUCCESS;
+
+	}
+
+}
+
+int32 rtl8651_resetAllAsicMIBCounter(void)
+{
+	WRITE_MEM32(MIB_CONTROL, ALL_COUNTER_RESTART_MASK);
+	return SUCCESS;
+}
+
+int32 rtl8651_getSimpleAsicMIBCounter(uint32 port, rtl865x_tblAsicDrv_simpleCounterParam_t * simpleCounter)
+{
+	uint32 addrOffset_fromP0 =0;
+
+	if((port>6)||(simpleCounter==NULL) )
+	{
+		return FAILED;
+	}
+
+	addrOffset_fromP0= port* MIB_ADDROFFSETBYPORT;
+
+//	simpleCounter->rxBytes = rtl865xC_returnAsicCounter64( OFFSET_IFINOCTETS_P0 + addrOffset_fromP0 );
+	simpleCounter->rxPkts = 	rtl8651_returnAsicCounter( OFFSET_IFINUCASTPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSMULTICASTPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSBROADCASTPKTS_P0 + addrOffset_fromP0 );
+//	simpleCounter->rxPausePkts=rtl8651_returnAsicCounter( OFFSET_DOT3INPAUSEFRAMES_P0 + addrOffset_fromP0 ) ;
+
+//	simpleCounter->drops = rtl8651_returnAsicCounter( OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSUNDERSIZEPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSFRAGMEMTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSOVERSIZEPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSJABBERS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSDROPEVENTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_DOT3STATSFCSERRORS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_DOT3STATSSYMBOLERRORS_P0 + addrOffset_fromP0 );
+//	simpleCounter->txBytes =rtl865xC_returnAsicCounter64( OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0 );
+	simpleCounter->txPkts =rtl8651_returnAsicCounter( OFFSET_IFOUTUCASTPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_IFOUTMULTICASTPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_IFOUTBROADCASTPKTS_P0 + addrOffset_fromP0 );
+//	simpleCounter->txPausePkts=rtl8651_returnAsicCounter( OFFSET_DOT3OUTPAUSEFRAMES_P0 + addrOffset_fromP0 );
+	return SUCCESS;
+}
+
+int32 rtl8651_getAdvancedMIBCounter(uint32 port, uint32 asicCounterType, rtl865x_tblAsicDrv_advancedCounterParam_t * advancedCounter)
+{
+	uint32 addrOffset_fromP0 =0;
+
+	if((port>6)||(advancedCounter==NULL) )
+	{
+		return FAILED;
+	}
+
+	addrOffset_fromP0= port* MIB_ADDROFFSETBYPORT;
+
+	memset(advancedCounter,0,sizeof(rtl865x_tblAsicDrv_advancedCounterParam_t));
+
+	if((asicCounterType & ASIC_IN_COUNTERS)!=0)
+	{
+		advancedCounter->ifInOctets=rtl865xC_returnAsicCounter64(OFFSET_IFINOCTETS_P0 + addrOffset_fromP0);
+		advancedCounter->ifInUcastPkts=rtl8651_returnAsicCounter(OFFSET_IFINUCASTPKTS_P0 + addrOffset_fromP0) ;
+		advancedCounter->etherStatsOctets=rtl865xC_returnAsicCounter64(OFFSET_ETHERSTATSOCTETS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsUndersizePkts=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSUNDERSIZEPKTS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsFraments=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSFRAGMEMTS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsPkts64Octets=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS64OCTETS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsPkts65to127Octets=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS65TO127OCTETS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsPkts128to255Octets=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS128TO255OCTETS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsPkts256to511Octets=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS256TO511OCTETS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsPkts512to1023Octets=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS512TO1023OCTETS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsPkts1024to1518Octets=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS1024TO1518OCTETS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsOversizePkts=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSOVERSIZEPKTS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsJabbers=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSJABBERS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsMulticastPkts=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSMULTICASTPKTS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsBroadcastPkts=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSBROADCASTPKTS_P0 + addrOffset_fromP0);
+		advancedCounter->dot1dTpPortInDiscards=rtl8651_returnAsicCounter( OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatusDropEvents=rtl8651_returnAsicCounter( OFFSET_ETHERSTATSDROPEVENTS_P0 + addrOffset_fromP0);
+		advancedCounter->dot3FCSErrors=rtl8651_returnAsicCounter( OFFSET_DOT3STATSFCSERRORS_P0 + addrOffset_fromP0);
+		advancedCounter->dot3StatsSymbolErrors=rtl8651_returnAsicCounter( OFFSET_DOT3STATSSYMBOLERRORS_P0 + addrOffset_fromP0);
+		advancedCounter->dot3ControlInUnknownOpcodes=rtl8651_returnAsicCounter( OFFSET_DOT3CONTROLINUNKNOWNOPCODES_P0 + addrOffset_fromP0);
+		advancedCounter->dot3InPauseFrames=rtl8651_returnAsicCounter( OFFSET_DOT3INPAUSEFRAMES_P0 + addrOffset_fromP0);
+	}
+
+	if((asicCounterType & ASIC_OUT_COUNTERS)!=0)
+	{
+		advancedCounter->ifOutOctets=rtl865xC_returnAsicCounter64(OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0);
+		advancedCounter->ifOutUcastPkts=rtl8651_returnAsicCounter(OFFSET_IFOUTUCASTPKTS_P0 + addrOffset_fromP0);
+		advancedCounter->ifOutMulticastPkts=rtl8651_returnAsicCounter(OFFSET_IFOUTMULTICASTPKTS_P0 + addrOffset_fromP0);
+		advancedCounter->ifOutBroadcastPkts=rtl8651_returnAsicCounter(OFFSET_IFOUTBROADCASTPKTS_P0 + addrOffset_fromP0);
+		advancedCounter->ifOutDiscards=rtl8651_returnAsicCounter(OFFSET_IFOUTDISCARDS + addrOffset_fromP0);
+		advancedCounter->dot3StatsSingleCollisionFrames=rtl8651_returnAsicCounter(OFFSET_DOT3STATSSINGLECOLLISIONFRAMES_P0+ addrOffset_fromP0);
+		advancedCounter->dot3StatsMultipleCollisionFrames=rtl8651_returnAsicCounter(OFFSET_DOT3STATSMULTIPLECOLLISIONFRAMES_P0 + addrOffset_fromP0);
+		advancedCounter->dot3StatsDefferedTransmissions=rtl8651_returnAsicCounter(OFFSET_DOT3STATSDEFERREDTRANSMISSIONS_P0 + addrOffset_fromP0);
+		advancedCounter->dot3StatsLateCollisions=rtl8651_returnAsicCounter(OFFSET_DOT3STATSLATECOLLISIONS_P0 + addrOffset_fromP0);
+		advancedCounter->dot3StatsExcessiveCollisions=rtl8651_returnAsicCounter(OFFSET_DOT3STATSEXCESSIVECOLLISIONS_P0 + addrOffset_fromP0);
+		advancedCounter->dot3OutPauseFrames=rtl8651_returnAsicCounter(OFFSET_DOT3OUTPAUSEFRAMES_P0 + addrOffset_fromP0);
+		advancedCounter->dot1dBasePortDelayExceededDiscards=rtl8651_returnAsicCounter(OFFSET_DOT1DBASEPORTDELAYEXCEEDEDDISCARDS_P0 + addrOffset_fromP0);
+		advancedCounter->etherStatsCollisions=rtl8651_returnAsicCounter(OFFSET_ETHERSTATSCOLLISIONS_P0 + addrOffset_fromP0);
+
+	}
+
+	if((asicCounterType & ASIC_WHOLE_SYSTEM_COUNTERS)!=0)
+	{
+		advancedCounter->dot1dTpLearnedEntryDiscards=rtl8651_returnAsicCounter(MIB_ADDROFFSETBYPORT);
+		advancedCounter->etherStatsCpuEventPkts=rtl8651_returnAsicCounter(MIB_ADDROFFSETBYPORT);
+	}
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865xC_dumpAsicCounter | Dump common counters of all ports (CPU port included).
+@rvalue SUCCESS | Finish showing the counters.
+@comm
+Dump common counters of all ports. Includes Rx/Tx Bytes, Rx/Tx pkts, Rx/Tx Pause frames, Rx Drops.
+*/
+int32 rtl865xC_dumpAsicCounter(void)
+{
+	uint32 i;
+
+	for ( i = 0; i <= RTL8651_PORT_NUMBER; i++ )
+	{
+		uint32 addrOffset_fromP0 = i * MIB_ADDROFFSETBYPORT;
+
+		if ( i == RTL8651_PORT_NUMBER )
+			rtlglue_printf("<CPU port>\n");
+		else
+			rtlglue_printf("<Port: %d>\n", i);
+		rtlglue_printf("Rx %llu Bytes, Rx %u Pkts, Drop %u pkts, Rx Pause %u pkts\n",
+			rtl865xC_returnAsicCounter64( OFFSET_IFINOCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_IFINUCASTPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSMULTICASTPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSBROADCASTPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSUNDERSIZEPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSFRAGMEMTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSOVERSIZEPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSJABBERS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_ETHERSTATSDROPEVENTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_DOT3STATSFCSERRORS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_DOT3STATSSYMBOLERRORS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3INPAUSEFRAMES_P0 + addrOffset_fromP0 ) );
+		rtlglue_printf("Tx %llu Bytes, Tx %u Pkts Tx Pause %u pkts\n",
+			rtl865xC_returnAsicCounter64( OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_IFOUTUCASTPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_IFOUTMULTICASTPKTS_P0 + addrOffset_fromP0 ) + rtl8651_returnAsicCounter( OFFSET_IFOUTBROADCASTPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3OUTPAUSEFRAMES_P0 + addrOffset_fromP0 ) );
+	}
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865xC_dumpAsicDiagCounter | Dump complex counters of all ports (CPU port included).
+@rvalue SUCCESS | Finish showing the counters.
+@comm
+Dump complex counters of all ports.
+*/
+#ifdef CONFIG_RTL_PROC_NEW
+int32 rtl865xC_dumpAsicDiagCounter(struct seq_file *s)
+{
+	uint32 i;
+
+	for ( i = 0; i <= RTL8651_PORT_NUMBER; i++ )
+	{
+		uint32 addrOffset_fromP0 = i * MIB_ADDROFFSETBYPORT;
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) || defined(CONFIG_RTL_8197F)
+		if (i == 5) continue;
+#endif
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+		if ( i == RTL8651_PORT_NUMBER )
+			seq_printf(s,"<CPU port (extension port included)>\n");
+		else
+			seq_printf(s,"<Port: %d>\n", i);
+
+		seq_printf(s,"Rx counters\n");
+		seq_printf(s,"   Rcv %llu bytes, TpPortInDiscard %u, DropEvent %u",
+			rtl865xC_returnAsicCounter64( OFFSET_IFINOCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter(OFFSET_ETHERSTATSDROPEVENTS_P0 + addrOffset_fromP0 ));
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) || \
+	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		seq_printf(s,", QmDiscard  %u",
+			rtl8651_returnAsicCounter( OFFSET_QMDISCARDCNT_P0 + addrOffset_fromP0 ));
+#endif
+		seq_printf(s,"\n   CRCAlignErr %u, SymbolErr %u, FragErr %u, JabberErr %u\n",
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSFCSERRORS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSSYMBOLERRORS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSFRAGMEMTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSJABBERS_P0 + addrOffset_fromP0 ));
+		seq_printf(s,"   Unicast %u pkts, Multicast %u pkts, Broadcast %u pkts\n",
+			rtl8651_returnAsicCounter( OFFSET_IFINUCASTPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSMULTICASTPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSBROADCASTPKTS_P0 + addrOffset_fromP0 ));
+		seq_printf(s,"   < 64: %u pkts, 64: %u pkts, 65 -127: %u pkts, 128 -255: %u pkts\n",
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSUNDERSIZEPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS64OCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS65TO127OCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS128TO255OCTETS_P0 + addrOffset_fromP0 ));
+		seq_printf(s,"   256 - 511: %u pkts, 512 - 1023: %u pkts, 1024 - 1518: %u pkts\n",
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS256TO511OCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS512TO1023OCTETS_P0 + addrOffset_fromP0),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS1024TO1518OCTETS_P0 + addrOffset_fromP0 ) );
+		seq_printf(s,"   oversize: %u pkts, Control unknown %u pkts, Pause %u pkts\n",
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSOVERSIZEPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3CONTROLINUNKNOWNOPCODES_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3INPAUSEFRAMES_P0 + addrOffset_fromP0 ));
+
+		seq_printf(s,"Output counters\n");
+		seq_printf(s,"   Snd %llu bytes, Unicast %u pkts, Multicast %u pkts\n",
+			rtl865xC_returnAsicCounter64( OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_IFOUTUCASTPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_IFOUTMULTICASTPKTS_P0 + addrOffset_fromP0 ));
+		seq_printf(s,"   Broadcast %u pkts, Late collision %u, Deferred transmission %u\n",
+			rtl8651_returnAsicCounter( OFFSET_IFOUTBROADCASTPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSLATECOLLISIONS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSDEFERREDTRANSMISSIONS_P0 + addrOffset_fromP0 ));
+		seq_printf(s,"   Collisions %u, Single collision %u, Multiple collision %u, pause %u\n",
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSCOLLISIONS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSSINGLECOLLISIONFRAMES_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSMULTIPLECOLLISIONFRAMES_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3OUTPAUSEFRAMES_P0 + addrOffset_fromP0 ));
+
+	}
+
+	seq_printf(s,"<Whole system counters>\n");
+	seq_printf(s,"   CpuEvent %u pkts\n", rtl8651_returnAsicCounter(OFFSET_ETHERSTATSCPUEVENTPKT));
+
+	return SUCCESS;
+}
+#else
+int32 rtl865xC_dumpAsicDiagCounter(char *page, int *ret_len)
+{
+	uint32 i;
+	int len = *ret_len;
+
+	for ( i = 0; i <= RTL8651_PORT_NUMBER; i++ )
+	{
+		uint32 addrOffset_fromP0 = i * MIB_ADDROFFSETBYPORT;
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) || defined(CONFIG_RTL_8197F)
+		if (i == 5) continue;
+#endif
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+		if ( i == RTL8651_PORT_NUMBER )
+			len += sprintf(page+len,"<CPU port (extension port included)>\n");
+		else
+			len += sprintf(page+len,"<Port: %d>\n", i);
+
+		len += sprintf(page+len,"Rx counters\n");
+		len += sprintf(page+len,"   Rcv %llu bytes, TpPortInDiscard %u, DropEvent %u",
+			rtl865xC_returnAsicCounter64( OFFSET_IFINOCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter(OFFSET_ETHERSTATSDROPEVENTS_P0 + addrOffset_fromP0 ));
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) || \
+	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		len += sprintf(page+len,", QmDiscard  %u",
+			rtl8651_returnAsicCounter( OFFSET_QMDISCARDCNT_P0 + addrOffset_fromP0 ));
+#endif
+		len += sprintf(page+len,"\n   CRCAlignErr %u, SymbolErr %u, FragErr %u, JabberErr %u\n",
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSFCSERRORS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSSYMBOLERRORS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSFRAGMEMTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSJABBERS_P0 + addrOffset_fromP0 ));
+		len += sprintf(page+len,"   Unicast %u pkts, Multicast %u pkts, Broadcast %u pkts\n",
+			rtl8651_returnAsicCounter( OFFSET_IFINUCASTPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSMULTICASTPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSBROADCASTPKTS_P0 + addrOffset_fromP0 ));
+		len += sprintf(page+len,"   < 64: %u pkts, 64: %u pkts, 65 -127: %u pkts, 128 -255: %u pkts\n",
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSUNDERSIZEPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS64OCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS65TO127OCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS128TO255OCTETS_P0 + addrOffset_fromP0 ));
+		len += sprintf(page+len,"   256 - 511: %u pkts, 512 - 1023: %u pkts, 1024 - 1518: %u pkts\n",
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS256TO511OCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS512TO1023OCTETS_P0 + addrOffset_fromP0),
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSPKTS1024TO1518OCTETS_P0 + addrOffset_fromP0 ) );
+		len += sprintf(page+len,"   oversize: %u pkts, Control unknown %u pkts, Pause %u pkts\n",
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSOVERSIZEPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3CONTROLINUNKNOWNOPCODES_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3INPAUSEFRAMES_P0 + addrOffset_fromP0 ));
+
+		len += sprintf(page+len,"Output counters\n");
+		len += sprintf(page+len,"   Snd %llu bytes, Unicast %u pkts, Multicast %u pkts\n",
+			rtl865xC_returnAsicCounter64( OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_IFOUTUCASTPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_IFOUTMULTICASTPKTS_P0 + addrOffset_fromP0 ));
+		len += sprintf(page+len,"   Broadcast %u pkts, Late collision %u, Deferred transmission %u\n",
+			rtl8651_returnAsicCounter( OFFSET_IFOUTBROADCASTPKTS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSLATECOLLISIONS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSDEFERREDTRANSMISSIONS_P0 + addrOffset_fromP0 ));
+		len += sprintf(page+len,"   Collisions %u, Single collision %u, Multiple collision %u, pause %u\n",
+			rtl8651_returnAsicCounter( OFFSET_ETHERSTATSCOLLISIONS_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSSINGLECOLLISIONFRAMES_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3STATSMULTIPLECOLLISIONFRAMES_P0 + addrOffset_fromP0 ),
+			rtl8651_returnAsicCounter( OFFSET_DOT3OUTPAUSEFRAMES_P0 + addrOffset_fromP0 ));
+
+	}
+
+	len += sprintf(page+len,"<Whole system counters>\n");
+	len += sprintf(page+len,"   CpuEvent %u pkts\n", rtl8651_returnAsicCounter(OFFSET_ETHERSTATSCPUEVENTPKT));
+	*ret_len = len;
+	return SUCCESS;
+}
+
+#endif
+
+/*
+@func int32 | rtl8651_clearAsicCounter | Clear specified ASIC counter to zero
+@parm	uint32	|	counterIdx |  Specify the counter to clear
+@rvalue SUCCESS | When counter index is valid, return SUCCESS
+@rvalue FAILED | When counter index is invalid, return FAILED
+@comm
+	When specify a vlid counter, the corresponding counter will be reset to zero and read the counter once
+	for guarantee following read can get correct value.
+*/
+int32 rtl8651_clearAsicSpecifiedCounter(uint32 counterIdx) {
+
+	uint32 reg;
+	rtlglue_printf("attention!this function is obsolete, please use new api:rtl8651_resetAsicMIBCounter()  or rtl8651_clearAsicCounter()\n");
+	return FAILED;
+	switch(counterIdx) {
+		case 0:
+		reg = READ_MEM32(MIB_CONTROL);
+		WRITE_MEM32(MIB_CONTROL, SYS_COUNTER_RESTART);
+		WRITE_MEM32(MIB_CONTROL, reg);
+		break;
+	default:
+		rtlglue_printf("Not Comptable Counter Index  %d\n",counterIdx);
+			return FAILED;//counter index out of range
+
+	}
+	_rtl8651_initialRead();
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_resetAsicCounterMemberPort | Clear the specified counter value and its member port
+@parm	uint32	|	counterIdx |  Specify the counter to clear
+@rvalue SUCCESS | When counter index is valid, return SUCCESS
+@rvalue FAILED | When counter index is invalid, return FAILED
+@comm
+	When specify a vlid counter, the member port of the specified counter will be cleared to null set.
+*/
+int32 rtl8651_resetAsicCounterMemberPort(uint32 counterIdx){
+
+	rtlglue_printf("attention!this function is obsolete, please use new api:rtl8651_resetAsicMIBCounter()  or rtl8651_clearAsicCounter()\n");
+	return FAILED;
+	switch(counterIdx) {
+		case 0:
+		WRITE_MEM32(MIB_CONTROL, 0x0);
+		break;
+		default:
+			rtlglue_printf("Not Comptable Counter Index  %d\n",counterIdx);
+			return FAILED;//counter index out of range
+
+	}
+	_rtl8651_initialRead();
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_addAsicCounterMemberPort | The specified counter value add the specified port port into counter monitor member
+@parm	uint32	|	counterIdx |  Specify the counter to add member port
+@parm	uint32	|	port |  The added member port
+@rvalue SUCCESS | When counter index is valid, return SUCCESS
+@rvalue FAILED | When counter index is invalid, return FAILED
+@comm
+	When specify a vlid counter and a valid port number, the specified port will be added to the counter coverage.
+*/
+int32 rtl8651_addAsicCounterMemberPort(uint32 counterIdx, uint32 port) {
+	uint32 reg, portMask;
+	rtlglue_printf("attention!this function is obsolete, it shouldn't be used any more\n");
+	return FAILED;
+
+
+	if(port <RTL8651_PORT_NUMBER)
+		portMask = 1<<(port + PORT_FOR_COUNTING_OFFSET);
+	else if (port < RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum)
+		portMask = 1<<(port - RTL8651_PORT_NUMBER + EXT_PORT_FOR_COUNTING_OFFSET);
+	else
+		return FAILED;//Port number out of range
+	switch(counterIdx) {
+		case 0:
+		reg = READ_MEM32(MIB_CONTROL) & 0x3FE00000;
+		WRITE_MEM32(MIB_CONTROL, reg|portMask);
+		break;
+		default:
+			rtlglue_printf("Not Comptable Counter Index  %d\n",counterIdx);
+			return FAILED;//counter index out of range
+	}
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_resetAsicCounterMemberPort | Clear the specified counter value and its member port
+@parm	uint32	|	counterIdx |  Specify the counter to clear
+@rvalue SUCCESS | When counter index is valid, return SUCCESS
+@rvalue FAILED | When counter index is invalid, return FAILED
+@comm
+	When specify a vlid counter, the corresponding counter will be reset to zero, its member port will be cleared to null set and read the counter once
+	for guarantee following read can get correct value.
+*/
+int32 rtl8651_delAsicCounterMemberPort(uint32 counterIdx, uint32 port) {
+	uint32 reg, portMask;
+	rtlglue_printf("attention!this function is obsolete, it shouldn't be used any more\n");
+	return FAILED;
+	if(port <RTL8651_PORT_NUMBER)
+		portMask = 1<<(port + PORT_FOR_COUNTING_OFFSET);
+	else if (port < RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum)
+		portMask = 1<<(port - RTL8651_PORT_NUMBER + EXT_PORT_FOR_COUNTING_OFFSET);
+	else
+		return FAILED;//Port number out of range
+	switch(counterIdx) {
+		case 0:
+		reg = READ_MEM32(MIB_CONTROL) & 0x3FE00000;
+		WRITE_MEM32(MIB_CONTROL, reg&~portMask);
+		break;
+		default:
+			rtlglue_printf("Not Comptable Counter Index  %d\n",counterIdx);
+			return FAILED;//counter index out of range
+	}
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_resetAsicCounterMemberPort | Clear the specified counter value and its member port
+@parm	uint32	|	counterIdx |  Specify the counter to clear
+@rvalue SUCCESS | When counter index is valid, return SUCCESS
+@rvalue FAILED | When counter index is invalid, return FAILED
+@comm
+	When specify a vlid counter, the corresponding counter will be reset to zero, its member port will be cleared to null set and read the counter once
+	for guarantee following read can get correct value.
+*/
+int32 rtl8651_getAsicCounter(uint32 counterIdx, rtl865x_tblAsicDrv_basicCounterParam_t * basicCounter) {
+
+	rtlglue_printf("attention!this function is obsolete, please use new api:rtl8651_getSimpleAsicMIBCounter()  or rtl8651_getAdvancedMIBCounter()\n");
+	return FAILED;
+	_rtl8651_initialRead();
+	switch(counterIdx) {
+		case 0:
+				basicCounter->rxBytes = READ_MEM32(MIB_COUNTER_BASE);
+				basicCounter->rxPackets = READ_MEM32(MIB_COUNTER_BASE+0x14) +	//Unicast
+						READ_MEM32(MIB_COUNTER_BASE+0x18) + 	//Multicast
+						READ_MEM32(MIB_COUNTER_BASE+0x1c);	//Broadcast
+				basicCounter->rxErrors = READ_MEM32(MIB_COUNTER_BASE+0x8) +	//CRC error and Alignment error
+						READ_MEM32(MIB_COUNTER_BASE+0xc) +	//Fragment error
+						READ_MEM32(MIB_COUNTER_BASE+010);	//Jabber error
+				basicCounter->drops = READ_MEM32(MIB_COUNTER_BASE+0x4);
+				basicCounter->cpus = READ_MEM32(MIB_COUNTER_BASE+0x74);
+				basicCounter->txBytes = READ_MEM32(MIB_COUNTER_BASE+0x48);
+				basicCounter->txPackets = READ_MEM32(MIB_COUNTER_BASE+0x4c) +	//Unicast
+						READ_MEM32(MIB_COUNTER_BASE+0x50) +	//Multicast
+						READ_MEM32(MIB_COUNTER_BASE+0x54);	//Broadcast
+				/*
+				basicCounter->mbr = (READ_MEM32(MIB_CONTROL)&PORT_FOR_COUNTING_MASK)>>PORT_FOR_COUNTING_OFFSET |
+								((READ_MEM32(MIB_CONTROL)&EXT_PORT_FOR_COUNTING_MASK)>>EXT_PORT_FOR_COUNTING_OFFSET)<<6;
+				*/
+		break;
+		default:
+			rtlglue_printf("Not Comptable Counter Index  %d\n",counterIdx);
+			return FAILED;//counter index out of range
+
+	}
+	return SUCCESS;
+}
+
+//sync from rtl865x kernel 2.4
+void FullAndSemiReset( void )
+{
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	/* for RTD1295, we move full reset to rtd129x_hwnat_clk_init() */
+	REG32(SIRR) |= FULL_RST;
+	mdelay(300);
+
+	REG32(SYS_CLK_MAG) &= ~CM_ACTIVE_SWCORE;
+	mdelay(300);
+
+	REG32(SYS_CLK_MAG) |= CM_ACTIVE_SWCORE;
+	mdelay(50);
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+#elif defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	REG32(SIRR) |= FULL_RST;
+	mdelay(300);
+
+	REG32(SYS_CLK_MAG) |= CM_PROTECT;
+	REG32(SYS_CLK_MAG) &= ~CM_ACTIVE_SWCORE;
+	mdelay(300);
+
+	REG32(SYS_CLK_MAG) |= CM_ACTIVE_SWCORE;
+	REG32(SYS_CLK_MAG) &= ~CM_PROTECT;
+	mdelay(50);
+
+#elif defined(CONFIG_RTL8198_REVISION_B)
+	if (REG32(BSP_REVR) >= BSP_RTL8198_REVISION_B)
+	{
+	  	REG32(SYS_CLK_MAG)&=(~(SYS_SW_RESET));
+		mdelay(300);
+		REG32(SYS_CLK_MAG)|=(SYS_SW_RESET);
+		mdelay(50);
+	}
+	else {
+		REG32(SIRR) |= FULL_RST;
+		tick_Delay10ms(50);
+	}
+#else
+	/* Perform full-reset for sw-core. */
+	REG32(SIRR) |= FULL_RST;
+	tick_Delay10ms(50);
+#endif
+
+	// 08-15-2012, set TRXRDY bit in rtl865x_start() in rtl865x_asicCom.c
+	/* Enable TRXRDY */
+	//REG32(SIRR) |= TRXRDY;
+}
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicCom.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicCom.h
new file mode 100644
index 00000000..ea57b3f
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicCom.h
@@ -0,0 +1,1093 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2009
+* All rights reserved.
+*
+* Program : Switch table basic operation driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865X_ASICCOM_H
+#define RTL865X_ASICCOM_H
+#include <linux/seq_file.h>
+
+// note: CONFIG_RTL_CPU_TAG should NOT be defined when CONFIG_RTL_8370_SUPPORT is chose.
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+#define CONFIG_RTL_CPU_TAG		1
+#endif
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+#define RTL865XC_VLANTBL_SIZE				16
+#else
+#define RTL865XC_VLANTBL_SIZE				4096
+#endif
+
+#define RTL865XC_NETIFTBL_SIZE			8
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define RTL8651_ACLTBL_SIZE			252
+#define RTL8651_ACLHWTBL_SIZE			256
+#define RTL8651_ACLTBL_RESERV_SIZE	4
+#else
+#define RTL8651_ACLTBL_SIZE			125
+#define RTL8651_ACLHWTBL_SIZE			128
+#define RTL8651_ACLTBL_RESERV_SIZE	3
+#endif
+
+#if defined(CONFIG_RTL_8198C)
+#define CONFIG_RTL_GIGA_LITE_REFINE		1
+#endif
+
+#define RTL8651_MAC_NUMBER				6
+#define RTL8651_PORT_NUMBER				RTL8651_MAC_NUMBER
+#define RTL8651_ALLPORTMASK				((1<<RTL8651_AGGREGATOR_NUMBER)-1)
+#define RTL8651_PHYSICALPORTMASK			((1<<RTL8651_MAC_NUMBER)-1)
+
+extern int32 rtl8651_totalExtPortNum; //this replaces all rtl8651_totalExtPortNum defines
+extern int32		rtl8651_allExtPortMask;
+#define RTL8651_AGGREGATOR_NUMBER		(RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum)
+//#define RTL8651_PSOFFLOAD_RESV_PORT		(RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum+1)	/* port reserved for protocol stack offloading */
+
+/*	external PHY Property :
+	Because there really has many different external PHY, so we just simply define for each MODEL. */
+#define RTL8651_TBLASIC_EXTPHYPROPERTY_PORT1234_RTL8212		(1 << 0)
+#define RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B			(1 << 1)
+
+/*===============================================
+ * ASIC DRIVER DEFINITION: Protocol-based VLAN
+ *==============================================*/
+#define RTL8651_PBV_RULE_IPX				1	/* Protocol-based VLAN rule 1: IPX */
+#define RTL8651_PBV_RULE_NETBIOS			2	/* Protocol-based VLAN rule 2: NetBIOS */
+#define RTL8651_PBV_RULE_PPPOE_CONTROL		3	/* Protocol-based VLAN rule 3: PPPoE Control */
+#define RTL8651_PBV_RULE_PPPOE_SESSION		4	/* Protocol-based VLAN rule 4: PPPoE Session */
+#define RTL8651_PBV_RULE_USR1				5	/* Protocol-based VLAN rule 5: user-defined 1 */
+#define RTL8651_PBV_RULE_USR2				6	/* Protocol-based VLAN rule 6: user-defined 2 */
+#define RTL8651_PBV_RULE_MAX				7
+
+
+#define ASICDRV_ASSERT(expr) do {\
+	if(!(expr)){\
+		rtlglue_printf("Error >>> initialize failed at function %s line %d!!!\n", __FUNCTION__, __LINE__);\
+			return FAILED;\
+	}\
+}while(0)
+
+#define ASICDRV_INIT_CHECK(expr) do {\
+	if((expr)!=SUCCESS){\
+		rtlglue_printf("Error >>> initialize failed at function %s line %d!!!\n", __FUNCTION__, __LINE__);\
+			return FAILED;\
+	}\
+}while(0)
+
+#if 1
+enum ENUM_NETDEC_POLICY
+{
+	NETIF_VLAN_BASED = 0x0,   /* Net interface Multilayer-Decision-Based Control by VLAN Based. */
+	NETIF_PORT_BASED = 0x1,   /* Net interface Multilayer-Decision-Based Control by PORT Based. */
+	NETIF_MAC_BASED = 0x2,    /* Net interface Multilayer-Decision-Based Control by MAC Based. */
+};
+enum ENUM_DEFACL_FOR_NETDECMISS
+{
+	PERMIT_FOR_NETDECMISS = 0x0, /*default permit when netif decision miss match*/
+	DROP_FOR_NETDECMISS = 0x1,
+	TOCPU_FOR_NETDECMISS = 0x2,
+};
+#endif
+
+/* ======================================================
+	ASIC Driver initiation parameters
+    ====================================================== */
+typedef struct rtl8651_tblAsic_InitPara_s {
+
+/*			Add Parameters for ASIC initiation                  */
+/* ===================================== */
+	uint32	externalPHYProperty;
+	uint32	externalPHYId[RTL8651_MAC_NUMBER];
+/* ===================================== */
+
+} rtl8651_tblAsic_InitPara_t;
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    uint32          mac18_0:19;
+    uint32          vid		 : 12;
+    uint32          valid       : 1;
+    /* word 1 */
+#if defined(CONFIG_RTL_8198C)
+    uint32          inACLStartL:1;
+    uint32          enHWRouteV6    : 1;
+#else
+    uint32         inACLStartL:2;
+#endif
+    uint32         enHWRoute : 1;
+    uint32         mac47_19:29;
+
+    /* word 2 */
+#if defined(CONFIG_RTL_8198C)
+    uint32         macMaskL    :1;
+    uint32         outACLEnd   :8;
+    uint32         outACLStart :8;
+    uint32         inACLEnd    :8;
+    uint32         inACLStartH :7;
+#else
+    uint32         mtuL       : 3;
+    uint32         macMask :3;
+    uint32         outACLEnd : 7;
+    uint32         outACLStart : 7;
+    uint32         inACLEnd : 7;
+    uint32         inACLStartH: 5;
+#endif
+
+    /* word 3 */
+#if defined(CONFIG_RTL_8198C)
+    uint32         mtuV6       :15;
+    uint32         mtu         :15;
+    uint32         macMaskH    :2;
+#else
+    uint32          reserv10   : 20;
+    uint32          mtuH       : 12;
+#endif
+
+#else /*_LITTLE_ENDIAN*/
+    /* word 0 */
+    uint32          valid       : 1;
+    uint32          vid		 : 12;
+    uint32          mac18_0:19;
+
+    /* word 1 */
+    uint32         mac47_19:29;
+    uint32          enHWRoute      : 1;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+    uint32          enHWRouteV6    : 1;
+    uint32          inACLStartL:1;
+#else
+    uint32          inACLStartL:2;
+#endif
+
+
+    /* word 2 */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+    uint32         inACLStartH :7;
+    uint32         inACLEnd    :8;
+    uint32         outACLStart :8;
+    uint32         outACLEnd   :8;
+    uint32         macMaskL    :1;
+#else
+    uint32         inACLStartH : 5;
+    uint32         inACLEnd : 7;
+    uint32         outACLStart : 7;
+    uint32         outACLEnd : 7;
+    uint32         macMask :3;
+    uint32         mtuL       : 3;
+#endif
+
+    /* word 3 */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+    uint32         macMaskH    :2;
+    uint32         mtu         :15;
+    uint32         mtuV6       :15;
+#else
+    uint32          mtuH       : 12;
+    uint32          reserv10   : 20;
+#endif
+
+#endif /*_LITTLE_ENDIAN*/
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl865xc_tblAsic_netifTable_t;
+
+
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+	 /* word 0 */
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)) && !defined(CONFIG_RTL_8198C)
+	uint32	vid:12;
+#else
+	uint32	reserved1:12;
+#endif
+	uint32	fid:2;
+	uint32     extEgressUntag  : 3;
+	uint32     egressUntag : 6;
+	uint32     extMemberPort   : 3;
+	uint32     memberPort  : 6;
+#else /*_LITTLE_ENDIAN*/
+	/* word 0 */
+
+	uint32     memberPort  : 6;
+	uint32     extMemberPort   : 3;
+	uint32     egressUntag : 6;
+	uint32     extEgressUntag  : 3;
+	uint32	fid:2;
+#if defined(CONFIG_RTL_8197F)
+	uint32	hp:3;
+	uint32	reserved2:9;
+#else
+	uint32	reserved1:12;
+#endif
+
+#endif /*_LITTLE_ENDIAN*/
+    /* word 1 */
+    uint32          reservw1;
+    /* word 2 */
+    uint32          reservw2;
+    /* word 3 */
+    uint32          reservw3;
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl865xc_tblAsic_vlanTable_t;
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    union {
+	struct {
+	    /* word 0 */
+	    uint16          dMacP31_16;
+	    uint16          dMacP15_0;
+	    /* word 1 */
+	    uint16          dMacM15_0;
+	    uint16          dMacP47_32;
+	    /* word 2 */
+	    uint16          dMacM47_32;
+	    uint16          dMacM31_16;
+	    /* word 3 */
+	    uint16          sMacP31_16;
+	    uint16          sMacP15_0;
+	    /* word 4 */
+	    uint16          sMacM15_0;
+	    uint16          sMacP47_32;
+	    /* word 5 */
+	    uint16          sMacM47_32;
+	    uint16          sMacM31_16;
+	    /* word 6 */
+	    uint16          ethTypeM;
+	    uint16          ethTypeP;
+	} ETHERNET;
+	struct {
+	    /* word 0 */
+	    uint32          reserv1     : 24;
+	    uint32          gidxSel     : 8;
+	    /* word 1~6 */
+	    uint32          reserv2[6];
+	} IFSEL;
+	struct {
+	    /* word 0 */
+	    ipaddr_t        sIPP;
+	    /* word 1 */
+	    ipaddr_t        sIPM;
+	    /* word 2 */
+	    ipaddr_t        dIPP;
+	    /* word 3 */
+	    ipaddr_t        dIPM;
+	    union {
+		struct {
+		    /* word 4 */
+		    uint8           IPProtoM;
+		    uint8           IPProtoP;
+		    uint8           IPTOSM;
+		    uint8           IPTOSP;
+		    /* word 5 */
+		    uint32          reserv0     : 20;
+		    uint32          identSDIPM  : 1;
+		    uint32          identSDIPP  : 1;
+		    uint32          HTTPM       : 1;
+		    uint32          HTTPP       : 1;
+		    uint32          FOM         : 1;
+		    uint32          FOP         : 1;
+		    uint32          IPFlagM     : 3;
+		    uint32          IPFlagP     : 3;
+		    /* word 6 */
+		    uint32          reserv1;
+		} IP;
+		struct {
+		    /* word 4 */
+		    uint8           ICMPTypeM;
+		    uint8           ICMPTypeP;
+		    uint8           IPTOSM;
+		    uint8           IPTOSP;
+		    /* word 5 */
+		    uint16          reserv0;
+		    uint8           ICMPCodeM;
+		    uint8           ICMPCodeP;
+		    /* word 6 */
+		    uint32          reserv1;
+		} ICMP;
+		struct {
+		    /* word 4 */
+		    uint8           IGMPTypeM;
+		    uint8           IGMPTypeP;
+		    uint8           IPTOSM;
+		    uint8           IPTOSP;
+		    /* word 5,6 */
+		    uint32          reserv0[2];
+		} IGMP;
+		struct {
+		    /* word 4 */
+		    uint8           TCPFlagM;
+		    uint8           TCPFlagP;
+		    uint8           IPTOSM;
+		    uint8           IPTOSP;
+		    /* word 5 */
+		    uint16          TCPSPLB;
+		    uint16          TCPSPUB;
+		    /* word 6 */
+		    uint16          TCPDPLB;
+		    uint16          TCPDPUB;
+		} TCP;
+		struct {
+		    /* word 4 */
+		    uint16          reserv0;
+		    uint8           IPTOSM;
+		    uint8           IPTOSP;
+		    /* word 5 */
+		    uint16          UDPSPLB;
+		    uint16          UDPSPUB;
+		    /* word 6 */
+		    uint16          UDPDPLB;
+		    uint16          UDPDPUB;
+		} UDP;
+	    } is;
+	} L3L4;
+
+#if defined(CONFIG_RTL_8198C)
+	struct{
+	    union{
+		struct{
+		    /* word 0 */
+		    uint32        sip_addr31_0;
+		    /* word 1 */
+		    uint32        sip_addr63_32;
+		    /* word 2 */
+		    uint32        sip_addr95_64;
+		    /* word 3 */
+		    uint32        sip_addr127_96;
+		    /* word 4 */
+		    uint32        sip_mask31_0;
+		    /* word 5 */
+		    uint32        sip_mask63_32;
+		    /* word 6 */
+		    uint32        sip_mask95_64;
+		}entry0;
+		struct{
+		    /* word 0 */
+		    uint32        dip_addr31_0;
+		    /* word 1 */
+		    uint32        dip_addr63_32;
+		    /* word 2 */
+		    uint32        dip_addr95_64;
+		    /* word 3 */
+		    uint32        dip_addr127_96;
+		    /* word 4 */
+		    uint32        dip_mask31_0;
+		    /* word 5 */
+		    uint32        dip_mask63_32;
+		    /* word 6 */
+		    uint32        dip_mask95_64;
+		}entry1;
+	    }is;
+	}L3V6;
+#endif
+	struct {
+	    /* word 0 */
+	    uint16          sMacP31_16;
+	    uint16          sMacP15_0;
+	    /* word 1 */
+	    uint16          reserv1:3;
+	    uint16          spaP:9;
+	    uint16          sMacM3_0:4;
+	    uint16          sMacP47_32;
+			/* word 2 */
+		    uint32	        reserv3:2;
+	    uint32          sVidM:12;
+		    uint32          sVidP:12;
+		    uint32		    reserv2:6;
+	    /* word 3 */
+	    uint32          reserv5     : 6;
+	    uint32          protoType   : 2;
+	    uint32          reserv4        : 24;
+			/* word 4 */
+	    ipaddr_t        sIPP;
+	    /* word 5 */
+	    ipaddr_t        sIPM;
+	    /* word 6 */
+	    uint16          SPORTLB;
+	    uint16          SPORTUB;
+	} SRC_FILTER;
+	struct {
+	    /* word 0 */
+	    uint16          dMacP31_16;
+	    uint16          dMacP15_0;
+	    /* word 1 */
+		    uint16 	        vidP:12;
+	    uint16          dMacM3_0:4;
+	    uint16          dMacP47_32;
+	    /* word 2 */
+		    uint32          reserv2:20;
+		    uint32          vidM:12;
+	    /* word 3 */
+	    uint32          reserv4     : 24;
+	    uint32          protoType   : 2;
+		     uint32         reserv3:6;
+	    /* word 4 */
+	    ipaddr_t        dIPP;
+	    /* word 5 */
+	    ipaddr_t        dIPM;
+	    /* word 6 */
+	    uint16          DPORTLB;
+	    uint16          DPORTUB;
+	} DST_FILTER;
+
+    } is;
+    /* word 7 */
+#if defined(CONFIG_RTL_8198C)
+    uint32          ip_tunnel   : 1;
+    uint32          comb      : 1;
+    uint32          ruleType1 : 1;
+    uint32          ipv6ETY0  : 1;
+    uint32          inv       : 1;
+#else
+    uint32          reserv0     : 5;
+#endif
+    uint32          pktOpApp    : 3;
+    uint32          PPPoEIndex  : 3;
+    uint32          vid         : 3;
+    uint32          nextHop     : 10; //index of l2, next hop, or rate limit tables
+    uint32          actionType  : 4;
+    uint32          ruleType    : 4;
+
+#if defined(CONFIG_RTL_8198C)
+    struct{
+	union{
+	    struct{
+		/*word 8*/
+		uint32 sip_mask119_96  :24;
+		uint32 reserv1         :8;
+		/*word 9*/
+		uint32 flowLabelM3_0   :4;
+		uint32 flowLabel       :20;
+		uint32 sip_mask127_120 :8;
+		/*word 10*/
+		uint32 reserv2         :16;
+		uint32 flowLabelM19_4  :16;
+	    }entry0;
+	    struct{
+		/*word 8*/
+		uint32 dip_mask119_96  :24;
+		uint32 reserv1         :8;
+		/*word 9*/
+		uint32 nextHeader      :8;
+		uint32 trafficClassM   :8;
+		uint32 trafficClass    :8;
+		uint32 dip_mask127_120 :8;
+		/*word 10*/
+		uint32 reserv2         :20;
+		uint32 identSDIPM     :1;
+		uint32 identSDIPP      :1;
+		uint32 HTTPM          :1;
+		uint32 HTTPP           :1;
+		uint32 nextHeaderM     :8;
+	    }entry1;
+	}is;
+    }ipv6;
+#endif
+#else /* littlen endian*/
+    union {
+	struct {
+	    /* word 0 */
+	    uint16          dMacP15_0;
+	    uint16          dMacP31_16;
+	    /* word 1 */
+	    uint16          dMacP47_32;
+	    uint16          dMacM15_0;
+	    /* word 2 */
+	    uint16          dMacM31_16;
+	    uint16          dMacM47_32;
+	    /* word 3 */
+	    uint16          sMacP15_0;
+	    uint16          sMacP31_16;
+	    /* word 4 */
+	    uint16          sMacP47_32;
+	    uint16          sMacM15_0;
+	    /* word 5 */
+	    uint16          sMacM31_16;
+	    uint16          sMacM47_32;
+	    /* word 6 */
+	    uint16          ethTypeP;
+	    uint16          ethTypeM;
+	} ETHERNET;
+	struct {
+	    /* word 0 */
+	    uint32          gidxSel     : 8;
+	    uint32          reserv1     : 24;
+	    /* word 1~6 */
+	    uint32          reserv2[6];
+	} IFSEL;
+	struct {
+	    /* word 0 */
+	    ipaddr_t        sIPP;
+	    /* word 1 */
+	    ipaddr_t        sIPM;
+	    /* word 2 */
+	    ipaddr_t        dIPP;
+	    /* word 3 */
+	    ipaddr_t        dIPM;
+	    union {
+		struct {
+		    /* word 4 */
+		    uint8           IPTOSP;
+		    uint8           IPTOSM;
+		    uint8           IPProtoP;
+		    uint8           IPProtoM;
+		    /* word 5 */
+		    uint32          IPFlagP     : 3;
+		    uint32          IPFlagM     : 3;
+		    uint32          FOP         : 1;
+		    uint32          FOM         : 1;
+		    uint32          HTTPP       : 1;
+		    uint32          HTTPM       : 1;
+		    uint32          identSDIPP  : 1;
+		    uint32          identSDIPM  : 1;
+		    uint32          reserv0     : 20;
+
+		    /* word 6 */
+		    uint32          reserv1;
+		} IP;
+		struct {
+		    /* word 4 */
+		    uint8           IPTOSP;
+		    uint8           IPTOSM;
+		    uint8           ICMPTypeP;
+		    uint8           ICMPTypeM;
+		    /* word 5 */
+		    uint8           ICMPCodeP;
+		    uint8           ICMPCodeM;
+		    uint16          reserv0;
+		    /* word 6 */
+		    uint32          reserv1;
+		} ICMP;
+		struct {
+		    /* word 4 */
+		    uint8           IPTOSP;
+		    uint8           IPTOSM;
+		    uint8           IGMPTypeP;
+		    uint8           IGMPTypeM;
+		    /* word 5,6 */
+		    uint32          reserv0[2];
+		} IGMP;
+		struct {
+		    /* word 4 */
+		    uint8           IPTOSP;
+		    uint8           IPTOSM;
+		    uint8           TCPFlagP;
+		    uint8           TCPFlagM;
+		    /* word 5 */
+		    uint16          TCPSPUB;
+		    uint16          TCPSPLB;
+		    /* word 6 */
+		    uint16          TCPDPUB;
+		    uint16          TCPDPLB;
+		} TCP;
+		struct {
+		    /* word 4 */
+		    uint8           IPTOSP;
+		    uint8           IPTOSM;
+		    uint16          reserv0;
+		    /* word 5 */
+		    uint16          UDPSPUB;
+		    uint16          UDPSPLB;
+		    /* word 6 */
+		    uint16          UDPDPUB;
+		    uint16          UDPDPLB;
+		} UDP;
+	    } is;
+	} L3L4;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	struct{
+	    union{
+		struct{
+		    /* word 0 */
+		    uint32        sip_addr31_0;
+		    /* word 1 */
+		    uint32        sip_addr63_32;
+		    /* word 2 */
+		    uint32        sip_addr95_64;
+		    /* word 3 */
+		    uint32        sip_addr127_96;
+		    /* word 4 */
+		    uint32        sip_mask31_0;
+		    /* word 5 */
+		    uint32        sip_mask63_32;
+		    /* word 6 */
+		    uint32        sip_mask95_64;
+		}entry0;
+		struct{
+		    /* word 0 */
+		    uint32        dip_addr31_0;
+		    /* word 1 */
+		    uint32        dip_addr63_32;
+		    /* word 2 */
+		    uint32        dip_addr95_64;
+		    /* word 3 */
+		    uint32        dip_addr127_96;
+		    /* word 4 */
+		    uint32        dip_mask31_0;
+		    /* word 5 */
+		    uint32        dip_mask63_32;
+		    /* word 6 */
+		    uint32        dip_mask95_64;
+		}entry1;
+	    }is;
+	}L3V6;
+#endif
+
+	struct {
+	    /* word 0 */
+	    uint16          sMacP15_0;
+	    uint16          sMacP31_16;
+	    /* word 1 */
+	    uint16          sMacP47_32;
+	    uint16          sMacM3_0:4;
+	     uint16		   spaP:9;
+	     uint16           reserv1:3;
+	    /* word 2 */
+	     uint32		   reserv2:6;
+	     uint32          sVidP:12;
+	    uint32          sVidM:12;
+	     uint32	          reserv3:2;
+
+	    /* word 3 */
+	    uint32          reserv4        : 24;
+	    uint32          protoType   : 2;
+	    uint32          reserv5     : 6;
+	    /* word 4 */
+	    ipaddr_t        sIPP;
+	    /* word 5 */
+	    ipaddr_t        sIPM;
+	    /* word 6 */
+	    uint16          SPORTUB;
+	    uint16          SPORTLB;
+	} SRC_FILTER;
+	struct {
+	    /* word 0 */
+	    uint16          dMacP15_0;
+	    uint16          dMacP31_16;
+
+	    /* word 1 */
+	    uint16          dMacP47_32;
+	    uint16          dMacM3_0:4;
+	     uint16 	   vidP:12;
+	    /* word 2 */
+	     uint32          vidM:12;
+	     uint32          reserv2:20;
+	    /* word 3 */
+	     uint32          reserv3:6;
+	    uint32          protoType   : 2;
+	    uint32          reserv4     : 24;
+	    /* word 4 */
+	    ipaddr_t        dIPP;
+	    /* word 5 */
+	    ipaddr_t        dIPM;
+	    /* word 6 */
+	    uint16          DPORTUB;
+	    uint16          DPORTLB;
+	} DST_FILTER;
+#if defined(CONFIG_RTL_8197F)
+		struct {
+			union{
+				struct{
+					/* word 0 */
+					uint32  spub:16; ////sport upper bound
+					uint32  splb:16; ////sport lower bound
+					/* word 1 */
+					uint32  dpub:16; ////dport upper bound
+					uint32  dplb:16; ////dport lower bound
+
+					/* word 2 */
+					uint32  protocol :2;
+					uint32  rsv      :6;
+					uint32  offset0  :7;
+					uint32  pattern0 :16;
+					uint32  pm0_0    :1;
+
+					/* word 3 */
+					uint32  pm0_15_1     :15;
+					uint32  or0      :1;
+					uint32  offset1  :7;
+					uint32  pattern1_8_0 :9;
+
+					/* word 4 */
+					uint32  pattern1_15_9 :7;
+					uint32  pm1           :16;
+					uint32  or1          :1;
+					uint32  offset2      :7;
+					uint32  pattern2_0    :1;
+
+					/* word 5 */
+					uint32  pattern2_15_1 :15;
+					uint32  pm2          :16;
+					uint32  or2          :1;
+
+					/* word 6 */
+					uint32  rsv1:32;
+				} entry0;
+				struct{
+					/* word 0 */
+					uint32  offset4   :7;
+					uint32  pattern4  :16;
+					uint32  pm4_8_0   :9;
+
+					/* word 1 */
+					uint32  pm4_15_9      :7;
+					uint32  or4           :1;
+					uint32  offset5  :7;
+					uint32  pattern5 :16;
+					uint32  pm5_0      :1;
+
+					/* word 2 */
+					uint32  pm5_15_1     :15;
+					uint32  or5          :1;
+					uint32  offset6      :7;
+					uint32  pattern6_8_0 :9;
+
+					/* word 3 */
+					uint32  pattern6_15_9 :7;
+					uint32  pm6           :16;
+					uint32  or6           :1;
+					uint32  offset7       :7;
+					uint32  pattern7_0    :1;
+
+					/* word 4 */
+					uint32  pattern7_15_1 :15;
+					uint32  pm7           :16;
+					uint32  or7           :1;
+
+					/* word 5 */
+					uint32  specialop     :1;
+					uint32  spa           :9;
+					uint32  spam          :9;
+					uint32  pppctl        :1;
+					uint32  pppctlm       :1;
+					uint32  pppctl_or     :1;
+					uint32  rsv2          :10;
+					/* word 6 */
+					uint32        rsv3;
+				}entry1;
+			}is;
+		}PM_U;//pattern match rule up
+#endif
+    } is;
+    /* word 7 */
+
+    uint32          ruleType    : 4;
+    uint32          actionType  : 4;
+    uint32          nextHop     : 10; //index of l2, next hop, or rate limit tables
+    uint32          vid         : 3;
+    uint32          PPPoEIndex  : 3;
+    uint32          pktOpApp    : 3;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+    uint32          inv       : 1;
+    uint32          ipv6ETY0  : 1;
+    uint32          ruleType1 : 1;
+    uint32          comb      : 1;
+    uint32          ip_tunnel : 1;
+#else
+    uint32          reserv0     : 5;
+#endif
+
+#if defined(CONFIG_RTL_8198C)
+    struct{
+	union{
+	    struct{
+		/*word 8*/
+		uint32 reserv1         :8;
+		uint32 sip_mask119_96  :24;
+		/*word 9*/
+		uint32 sip_mask127_120 :8;
+		uint32 flowLabel       :20;
+		uint32 flowLabelM3_0   :4;
+		/*word 10*/
+		uint32 flowLabelM19_4  :16;
+		uint32 reserv2         :16;
+	    }entry0;
+	    struct{
+		/*word 8*/
+		uint32 reserv1         :8;
+		uint32 dip_mask119_96  :24;
+		/*word 9*/
+		uint32 dip_mask127_120 :8;
+		uint32 trafficClass    :8;
+		uint32 trafficClassM   :8;
+		uint32 nextHeader      :8;
+		/*word 10*/
+		uint32 nextHeaderM     :8;
+		uint32 HTTPP           :1;
+		uint32 HTTPM          :1;
+		uint32 identSDIPP      :1;
+		uint32 identSDIPM     :1;
+		uint32 reserv2         :20;
+	    }entry1;
+	}is;
+    }ipv6;
+#endif
+
+#if defined(CONFIG_RTL_8197F)
+    union {
+    struct{
+	union{
+	    struct{
+		/*word 8*/
+		uint32 reserv1         :8;
+		uint32 sip_mask119_96  :24;
+		/*word 9*/
+		uint32 sip_mask127_120 :8;
+		uint32 flowLabel       :20;
+		uint32 flowLabelM3_0   :4;
+		/*word 10*/
+		uint32 flowLabelM19_4  :16;
+		uint32 reserv2         :16;
+	    }entry0;
+	    struct{
+		/*word 8*/
+		uint32 reserv1         :8;
+		uint32 dip_mask119_96  :24;
+		/*word 9*/
+		uint32 dip_mask127_120 :8;
+		uint32 trafficClass    :8;
+		uint32 trafficClassM   :8;
+		uint32 nextHeader      :8;
+		/*word 10*/
+		uint32 nextHeaderM     :8;
+		uint32 HTTPP           :1;
+		uint32 HTTPM          :1;
+		uint32 identSDIPP      :1;
+		uint32 identSDIPM     :1;
+		uint32 reserv2         :20;
+	    }entry1;
+	    }is;
+	}ipv6;
+    struct {
+	union{
+	    struct{
+		/* word 8 */
+		uint32 offset3  :7;
+		uint32 pattern3 :16;
+		uint32 pm3_8_0  :9;
+
+		/* word 9 */
+		uint32 pm3_15_9 :7;
+		uint32 or3      :1;
+		uint32 rsv      :24;
+
+		/* word 10 */
+		uint32 rsv1  ;
+	    }entry0;
+	    struct{
+		/*word 8*/
+		uint32 nexthopaddr2 :1;
+		uint32 ipfrag_apply :1; ////todo maybe better coding style here.
+		uint32 rsv          :30;
+		/*word 9*/
+		uint32 rsv1;
+
+		/*word 10*/
+		uint32 rsv2;
+	    }entry1;
+	}is;
+    }PM_D;//pattern match rule down part
+    } is_d;
+#endif
+
+#endif /*_LITTLE_ENDIAN*/
+} rtl865xc_tblAsic_aclTable_t;
+
+typedef struct rtl865x_tblAsicDrv_vlanParam_s {
+	uint32 	memberPortMask; /*extension ports [rtl8651_totalExtPortNum-1:0] are located at bits [RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum-1:RTL8651_PORT_NUMBER]*/
+	uint32 	untagPortMask; /*extension ports [rtl8651_totalExtPortNum-1:0] are located at bits [RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum-1:RTL8651_PORT_NUMBER]*/
+	uint32  fid:2;
+
+#if defined(CONFIG_RTL_8197F)
+	uint32  hp:3;
+#elif (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)) && !defined(CONFIG_RTL_8198C)
+	uint32  vid:12;
+#endif
+} rtl865x_tblAsicDrv_vlanParam_t;
+
+typedef struct rtl865x_tblAsicDrv_intfParam_s {
+	ether_addr_t macAddr;
+	uint16 	macAddrNumber;
+	uint16 	vid;
+	uint32 	inAclStart, inAclEnd, outAclStart, outAclEnd;
+	uint32 	mtu;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+    uint32  mtuV6;
+#endif
+	uint32 	enableRoute:1;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32  enableRouteV6:1;
+#endif
+	uint32  valid:1;
+
+} rtl865x_tblAsicDrv_intfParam_t;
+
+
+#define ASIC_IN_COUNTERS 					0x01
+#define ASIC_OUT_COUNTERS 					0x02
+#define ASIC_WHOLE_SYSTEM_COUNTERS 		0x04
+
+typedef struct rtl865x_tblAsicDrv_basicCounterParam_s {
+	uint32	mbr;
+	uint32	txPackets;
+	uint32	txBytes;
+	uint32	rxPackets;
+	uint32	rxBytes;
+	uint32	rxErrors;
+	uint32	drops;
+	uint32	cpus;
+} rtl865x_tblAsicDrv_basicCounterParam_t;
+
+typedef struct rtl865x_tblAsicDrv_simpleCounterParam_s
+{
+	uint64	rxBytes;
+	uint32	rxPkts;
+	uint32	rxPausePkts;
+
+	uint32	drops;
+
+	uint64	txBytes;
+	uint32	txPkts;
+	uint32	txPausePkts;
+
+} rtl865x_tblAsicDrv_simpleCounterParam_t;
+
+typedef struct rtl865x_tblAsicDrv_advancedCounterParam_s
+{
+	/*here is in counters  definition*/
+	uint64 ifInOctets;
+	uint32 ifInUcastPkts;
+	uint64 etherStatsOctets;
+	uint32 etherStatsUndersizePkts;
+	uint32 etherStatsFraments;
+	uint32 etherStatsPkts64Octets;
+	uint32 etherStatsPkts65to127Octets;
+	uint32 etherStatsPkts128to255Octets;
+	uint32 etherStatsPkts256to511Octets;
+	uint32 etherStatsPkts512to1023Octets;
+	uint32 etherStatsPkts1024to1518Octets;
+	uint32 etherStatsOversizePkts;
+	uint32 etherStatsJabbers;
+	uint32 etherStatsMulticastPkts;
+	uint32 etherStatsBroadcastPkts;
+	uint32 dot1dTpPortInDiscards;
+	uint32 etherStatusDropEvents;
+	uint32 dot3FCSErrors;
+	uint32 dot3StatsSymbolErrors;
+	uint32 dot3ControlInUnknownOpcodes;
+	uint32 dot3InPauseFrames;
+
+	/*here is out counters  definition*/
+	uint64 ifOutOctets;
+	uint32 ifOutUcastPkts;
+	uint32 ifOutMulticastPkts;
+	uint32 ifOutBroadcastPkts;
+	uint32 ifOutDiscards;
+	uint32 dot3StatsSingleCollisionFrames;
+	uint32 dot3StatsMultipleCollisionFrames;
+	uint32 dot3StatsDefferedTransmissions;
+	uint32 dot3StatsLateCollisions;
+	uint32 dot3StatsExcessiveCollisions;
+	uint32 dot3OutPauseFrames;
+	uint32 dot1dBasePortDelayExceededDiscards;
+	uint32 etherStatsCollisions;
+
+	/*here is whole system couters definition*/
+	uint32 dot1dTpLearnedEntryDiscards;
+	uint32 etherStatsCpuEventPkts;
+
+}rtl865x_tblAsicDrv_advancedCounterParam_t;
+
+extern rtl8651_tblAsic_InitPara_t rtl8651_tblAsicDrvPara;
+
+int32 rtl8651_clearAsicCommTable(void);
+/*vlan*/
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E))  && !defined(CONFIG_RTL_8198C)
+int rtl8651_findAsicVlanIndexByVid(uint16 *vid);
+#endif
+int32 rtl8651_setAsicVlan(uint16 vid, rtl865x_tblAsicDrv_vlanParam_t *vlanp);
+int32 rtl8651_getAsicVlan(uint16 vid, rtl865x_tblAsicDrv_vlanParam_t *vlanp);
+int32 rtl8651_delAsicVlan(uint16 vid);
+int32 rtl8651_setAsicPvid(uint32 port, uint32 pvid);
+int32 rtl8651_getAsicPVlanId(uint32 port, uint32 *pvid);
+int32 rtl8651_setPortToNetif(uint32 port, uint32 netifidx);
+
+int32 rtl8651_defineProtocolBasedVLAN( uint32 ruleNo, uint8 ProtocolType, uint16 ProtocolValue );
+int32 rtl8651_setProtocolBasedVLAN( uint32 ruleNo, uint32 port, uint8 valid, uint16 vlanId);
+int32 rtl8651_getProtocolBasedVLAN( uint32 ruleNo, uint32 port, uint8* valid, uint32* vlanIdx );
+
+/*netif*/
+int32 rtl8651_getAsicNetInterface(uint32 idx, rtl865x_tblAsicDrv_intfParam_t *intfp);
+int32 rtl8651_setAsicNetInterface(uint32 idx, rtl865x_tblAsicDrv_intfParam_t *intfp);
+int32 rtl865x_delNetInterfaceByVid(uint16 vid);
+int32 rtl865xC_setNetDecisionPolicy( enum ENUM_NETDEC_POLICY policy );
+int32 rtl865x_setDefACLForNetDecisionMiss(uint8 start_ingressAclIdx, uint8 end_ingressAclIdx,uint8 start_egressAclIdx,uint8 end_egressAclIdx);
+#if 1 //defined (CONFIG_RTL_LOCAL_PUBLIC)
+int32 rtl865xC_getNetDecisionPolicy( enum ENUM_NETDEC_POLICY *policy );
+int32 rtl865x_getDefACLForNetDecisionMiss(uint8 *start_ingressAclIdx, uint8 *end_ingressAclIdx,uint8 *start_egressAclIdx,uint8 *end_egressAclIdx);
+#endif
+/*operation layer*/
+int32 rtl8651_getAsicOperationLayer(void);
+int32 rtl8651_setAsicOperationLayer(uint32 layer);
+
+/*switch core*/
+int32 rtl865xC_lockSWCore(void);
+int32 rtl865xC_unLockSWCore(void);
+int32 rtl8651_getChipVersion(int8 *name,uint32 size, int32 *rev);
+int32 rtl8651_getChipNameID(int32 *id);
+
+void rtl8651_clearRegister(void);
+void rtl8651_clearSpecifiedAsicTable(uint32 type, uint32 count);
+
+
+int32 rtl8651_setAsicAgingFunction(int8 l2Enable, int8 l4Enable);
+int32 rtl8651_setAsicAgingFunction(int8 l2Enable, int8 l4Enable);
+
+unsigned int rtl865x_probeSdramSize(void);
+void rtl865x_start(void);
+void rtl865x_down(void);
+
+/*counter*/
+uint32 rtl8651_returnAsicCounter(uint32 offset);
+uint64 rtl865xC_returnAsicCounter64(uint32 offset);
+int32 rtl8651_clearAsicCounter(void);
+#ifdef CONFIG_RTL_PROC_NEW
+int32 rtl865xC_dumpAsicDiagCounter(struct seq_file *s);
+#else
+int32 rtl865xC_dumpAsicDiagCounter(char *page, int *len);
+#endif
+
+int32 rtl865xC_dumpAsicCounter(void);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+extern int rtl819x_setSwEthPvid(uint16 port, uint16 pvid);
+extern int rtl819x_getSwEthPvid(uint16 port, uint16* pvid);
+#endif
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL2.c b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL2.c
new file mode 100644
index 00000000..6e4f083
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL2.c
@@ -0,0 +1,11805 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2009
+* All rights reserved.
+*
+* Program : Switch table Layer2 switch driver,following features are included:
+*	PHY/MII/Port/STP/QOS
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+//#include "assert.h"
+#include "rtl865x_asicBasic.h"
+#include "rtl865x_asicCom.h"
+#include "rtl865x_asicL2.h"
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if (defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8211F_SUPPORT)) && defined(CONFIG_RTL819X_GPIO) && !defined(CONFIG_OPENWRT_SDK)
+#include <../bsp/bspchip.h>
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+#include "asicRegs.h"
+//#include "rtl_utils.h"
+#include "rtl865x_hwPatch.h"
+
+#include <linux/delay.h>
+
+#if defined(CONFIG_RTL819X_GPIO) && !defined(CONFIG_OPENWRT_SDK)
+#include <linux/platform_device.h>
+#include <linux/platform_data/rtl819x-gpio.h>
+#include <linux/gpio.h>
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+#include <soc/realtek/rtk_cpu.h>
+//#define RTL_DEBUG	1
+#ifdef RTL_DEBUG
+#define DBG(fmt, ...) printk(KERN_ERR "%s:%d: " fmt "\n", \
+						__func__, __LINE__, ## __VA_ARGS__)
+#else
+#define DBG(fmt, ...)
+#endif
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+static uint8 fidHashTable[]={0x00,0x0f,0xf0,0xff};
+
+__DRAM_FWD int32		rtl865x_wanPortMask;
+int32		rtl865x_lanPortMask = RTL865X_PORTMASK_UNASIGNED;
+
+int32		rtl865x_maxPreAllocRxSkb = RTL865X_PREALLOC_SKB_UNASIGNED;
+int32		rtl865x_rxSkbPktHdrDescNum = RTL865X_PREALLOC_SKB_UNASIGNED;
+int32		rtl865x_txSkbPktHdrDescNum = RTL865X_PREALLOC_SKB_UNASIGNED;
+int32 	miiPhyAddress;
+rtl8651_tblAsic_ethernet_t 	rtl8651AsicEthernetTable[9];//RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum
+
+#if defined(REINIT_SWITCH_CORE)
+extern int rtl865x_duringReInitSwtichCore;
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+uint8 hwnat_mac0_enable = 0; /* 0: interface used by SATA, 1: interface used by NAT */
+uint8 hwnat_mac0_mode = 1; /* 0:RGMII to PHY, 1:SGMII to PHY, 2: RGMII to MAC, 3: SGMII to MAC */
+uint8 hwnat_mac5_conn_to = 0; /* 0:PHY, 1:MAC */
+uint8 hwnat_rgmii_voltage = 1; /* 1:1.8V, 2:2.5V, 3:3.3V */
+uint8 hwnat_rgmii_enable = 1; /* 0:disable, 1:enable */
+uint8 hwnat_rgmii0_tx_delay = 0; /* 0 to 7: 0.5ns per step */
+uint8 hwnat_rgmii0_rx_delay = 4; /* 0 to 7: 0.5ns per step */
+uint8 hwnat_rgmii1_tx_delay = 0; /* 0 to 7: 0.5ns per step */
+uint8 hwnat_rgmii1_rx_delay = 4; /* 0 to 7: 0.5ns per step */
+uint8 hwnat_led_mode = 1;	/* 0~3: SCAN_0~3, 4~6: DIRECT 0~2 */
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+static uint32 _rtl865xC_QM_orgDescUsage = 0;	/* Original Descriptor Usage in HW */
+#endif
+
+/* For Bandwidth control - RTL865xB Backward compatible only */
+#define _RTL865XB_BANDWIDTHCTRL_X1			(1 << 0)
+#define _RTL865XB_BANDWIDTHCTRL_X4			(1 << 1)
+#define _RTL865XB_BANDWIDTHCTRL_X8			(1 << 2)
+#define _RTL865XB_BANDWIDTHCTRL_CFGTYPE		2		/* Ingress (0) and Egress (1) : 2 types of configuration */
+static int32 _rtl865xB_BandwidthCtrlMultiplier = _RTL865XB_BANDWIDTHCTRL_X1;
+static uint32 _rtl865xB_BandwidthCtrlPerPortConfiguration[RTL8651_PORT_NUMBER][_RTL865XB_BANDWIDTHCTRL_CFGTYPE /* Ingress (0), Egress (1) */ ];
+static uint32 _rtl865xC_BandwidthCtrlNum[] = {	0,	/* BW_FULL_RATE */
+														131072,	/* BW_128K */
+														262144,	/* BW_256K */
+														524288,	/* BW_512K */
+														1048576,	/* BW_1M */
+														2097152,	/* BW_2M */
+														4194304,	/* BW_4M */
+														8388608	/* BW_8M */
+														};
+
+#define	RTL865XC_INGRESS_16KUNIT	16384
+#define	RTL865XC_EGRESS_64KUNIT	65535
+
+#define RTL8198C_PORT0_PHY_ID		8
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#define RTL8198C_GPHY_CALIBRATION		1
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+#if defined(CONFIG_RTL_8198C)
+int giga_lite_enabled = 0;
+int phy_link_sts = 0;
+#endif
+
+#ifdef CONFIG_RTL8196C_ETH_IOT
+extern uint32 port_link_sts, port_linkpartner_eee;
+#endif
+
+#if defined(CONFIG_RTL_8196C)
+
+#define RTL8196C_EEE_REFINE		1
+
+int eee_enabled = 1;
+void eee_phy_enable(void);
+void eee_phy_disable(void);
+void eee_phy_enable_by_port(int port);
+#elif defined(RTL8198_EEE_MAC)
+int eee_enabled = 1;
+void eee_phy_enable_98(void);
+void eee_phy_disable_98(void);
+#else
+int eee_enabled = 0;
+#endif
+
+#if defined(CONFIG_RTL_8198_NFBI_BOARD)
+#define RTL8198_NFBI_PORT5_GMII 1 //mark_nfbi , default port5 set to GMII , you can undef here to set to MII mode!!!
+//#undef RTL8198_NFBI_PORT5_GMII  //mark_nfbi , default port5 set to GMII , you can undef here to set to MII mode!!!
+#endif
+
+
+#if defined(CONFIG_RTL_8198)
+
+#define PORT5_RGMII_GMII		1
+
+//static void qos_init(void);
+#endif
+
+#define	QNUM_IDX_123		0
+#define	QNUM_IDX_45		1
+#define	QNUM_IDX_6		2
+
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198)
+static int32 _rtl865x_setQosThresholdByQueueIdx(uint32 qidx);
+
+#if 0
+static rtl865xC_outputQueuePara_t	outputQueuePara[3] = {
+										{
+											1, 		/* default: Bandwidth Control Include/exclude Preamble & IFG */
+											20, 		/* default: Per Queue Physical Length Gap = 20 */
+											504, 		/* default: Descriptor Run Out Threshold = 504 */
+											180, 		/*default: System shared buffer flow control turn off threshold = 212 */
+											196,		/*default: System shared buffer flow control turn on threshold = 248 */
+											500, 		/*default: system flow control turn off threshold = 500*/
+											502,		/*default: system flow control turn on threshold = 502*/
+											330, 		/*default: port base flow control turn off threshold = 0xf8*/
+											400,		/*default: port base flow control turn on threshold = 0x108*/
+											31, 		/* Queue-Descriptor=Based Flow Control turn off Threshold =0x14 */
+											48, 		/* Queue-Descriptor=Based Flow Control turn on Threshold = 0x21 */
+											0x03, 	/* Queue-Packet=Based Flow Control turn off Threshold = 0x03 */
+											0x05	/* Queue-Packet=Based Flow Control turn on Threshold =0x05 */
+										},
+										{
+											1, 		/* default: Bandwidth Control Include/exclude Preamble & IFG */
+											20, 		/* default: Per Queue Physical Length Gap = 20 */
+											504, 		/* default: Descriptor Run Out Threshold = 504 */
+											120, 		/*default: System shared buffer flow control turn off threshold = 212 */
+											136,		/*default: System shared buffer flow control turn on threshold = 248 */
+											330, 		/*default: system flow control turn off threshold = 500*/
+											344,		/*default: system flow control turn on threshold = 502*/
+											248, 		/*default: port base flow control turn off threshold = 0xf8*/
+											264,		/*default: port base flow control turn on threshold = 0x108*/
+											20, 		/* Queue-Descriptor=Based Flow Control turn off Threshold =0x14 */
+											33, 		/* Queue-Descriptor=Based Flow Control turn on Threshold = 0x21 */
+											0x03, 	/* Queue-Packet=Based Flow Control turn off Threshold = 0x03 */
+											0x05	/* Queue-Packet=Based Flow Control turn on Threshold =0x05 */
+										},
+										{
+											1, 		/* default: Bandwidth Control Include/exclude Preamble & IFG */
+											20, 		/* default: Per Queue Physical Length Gap = 20 */
+											500, 		/* default: Descriptor Run Out Threshold = 504 */
+											324, 		/*default: System shared buffer flow control turn off threshold = 212 */
+											340,		/*default: System shared buffer flow control turn on threshold = 248 */
+											330, 		/*default: system flow control turn off threshold = 500*/
+											400,		/*default: system flow control turn on threshold = 502*/
+											240, 		/*default: port base flow control turn off threshold = 0xf8*/
+											282,		/*default: port base flow control turn on threshold = 0x108*/
+											20, 		/* Queue-Descriptor=Based Flow Control turn off Threshold =0x14 */
+											28, 		/* Queue-Descriptor=Based Flow Control turn on Threshold = 0x21 */
+											10, 	/* Queue-Packet=Based Flow Control turn off Threshold = 0x03 */
+											11	/* Queue-Packet=Based Flow Control turn on Threshold =0x05 */
+										}
+										};
+#else
+// sync from kernel 2.4 qos_init() -- 20110330
+static rtl865xC_outputQueuePara_t	outputQueuePara[3] = {
+										{
+											1, 		/* default: Bandwidth Control Include/exclude Preamble & IFG */
+											0x48, 		/* default: Per Queue Physical Length Gap = 20 */
+											500, 		/* default: Descriptor Run Out Threshold = 504 */
+											252, 		/*default: System shared buffer flow control turn off threshold = 212 */
+											310,		/*default: System shared buffer flow control turn on threshold = 248 */
+											280, 		/*default: system flow control turn off threshold = 500*/
+											400,		/*default: system flow control turn on threshold = 502*/
+											258, 		/*default: port base flow control turn off threshold = 0xf8*/
+											320,		/*default: port base flow control turn on threshold = 0x108*/
+											16, 		/* Queue-Descriptor=Based Flow Control turn off Threshold =0x14 */
+											21, 		/* Queue-Descriptor=Based Flow Control turn on Threshold = 0x21 */
+											5, 	/* Queue-Packet=Based Flow Control turn off Threshold = 0x03 */
+											6	/* Queue-Packet=Based Flow Control turn on Threshold =0x05 */
+										},
+										{
+											1, 		/* default: Bandwidth Control Include/exclude Preamble & IFG */
+											0x48, 		/* default: Per Queue Physical Length Gap = 20 */
+											500, 		/* default: Descriptor Run Out Threshold = 504 */
+											252, 		/*default: System shared buffer flow control turn off threshold = 212 */
+											310,		/*default: System shared buffer flow control turn on threshold = 248 */
+											280, 		/*default: system flow control turn off threshold = 500*/
+											400,		/*default: system flow control turn on threshold = 502*/
+											258, 		/*default: port base flow control turn off threshold = 0xf8*/
+											320,		/*default: port base flow control turn on threshold = 0x108*/
+											16, 		/* Queue-Descriptor=Based Flow Control turn off Threshold =0x14 */
+											21, 		/* Queue-Descriptor=Based Flow Control turn on Threshold = 0x21 */
+											5, 	/* Queue-Packet=Based Flow Control turn off Threshold = 0x03 */
+											6	/* Queue-Packet=Based Flow Control turn on Threshold =0x05 */
+										},
+										{
+											1, 		/* default: Bandwidth Control Include/exclude Preamble & IFG */
+											0x48, 		/* default: Per Queue Physical Length Gap = 20 */
+											500, 		/* default: Descriptor Run Out Threshold = 504 */
+											252, 		/*default: System shared buffer flow control turn off threshold = 212 */
+											310,		/*default: System shared buffer flow control turn on threshold = 248 */
+											280, 		/*default: system flow control turn off threshold = 500*/
+											400,		/*default: system flow control turn on threshold = 502*/
+											258, 		/*default: port base flow control turn off threshold = 0xf8*/
+											320,		/*default: port base flow control turn on threshold = 0x108*/
+											16, 		/* Queue-Descriptor=Based Flow Control turn off Threshold =0x14 */
+											21, 		/* Queue-Descriptor=Based Flow Control turn on Threshold = 0x21 */
+											5, 	/* Queue-Packet=Based Flow Control turn off Threshold = 0x03 */
+											6	/* Queue-Packet=Based Flow Control turn on Threshold =0x05 */
+										}
+										};
+#endif
+#elif defined(CONFIG_RTL_8198C)
+//port base flow control turn off threshold  for 98C
+static uint32 rtl_portFCOFF=0x34c ;
+static uint32 rtl_portFCON=0x358;
+#elif defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define Q_DESC_FC_ON		0x48
+#define Q_DESC_FC_OFF		0x3C
+#define Q_PKT_FC_ON		0xAC
+#define Q_PKT_FC_OFF		0xA4
+#define Q_GAP			0x48
+static int32 rtd129x_setQosThreshold(void);
+#else
+// todo: need to find out
+static uint32 rtl_portFCOFF=0x1A6;
+static uint32 rtl_portFCON=0x1AC;
+#endif /* CONFIG_RTD_1295_HWNAT */
+#endif
+
+static void _rtl8651_syncToAsicEthernetBandwidthControl(void);
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+static int32 _rtl865xC_QM_init( void );
+extern int32 swNic_freeRxRing(void);
+#if defined (CONFIG_RTL_HW_QOS_DEBUG)
+extern int net_ratelimit(void);
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8196C)
+// EEE PHY -- Page 4
+// register 16
+#define P4R16_eee_10_cap                           (1 << 13)	// enable EEE 10M
+#define P4R16_eee_nway_en                           (1 << 12)	// enable Next Page exchange in nway for EEE 100M
+#define P4R16_tx_quiet_en                            (1 << 9)	// enable ability to turn off pow100tx when TX Quiet state
+#define P4R16_rx_quiet_en                            (1 << 8)	// enable ability to turn off pow100rx when RX Quiet state
+
+// register 25
+#define P4R25_rg_dacquiet_en                            (1 << 10)	// enable ability to turn off DAC when TX Quiet state
+#define P4R25_rg_ldvquiet_en                            (1 << 9)		// enable ability to turn off line driver when TX Quiet state
+#define P4R25_rg_eeeprg_rst                            (1 << 6)		// reset for EEE programmable finite state machine
+#define P4R25_rg_ckrsel                            		(1 << 5)		// select ckr125 as RX 125MHz clock
+#define P4R25_rg_eeeprg_en                            (1 << 4)		// enable EEE programmable finite state machine
+
+static const unsigned short phy_data[]={
+	0x5000,  // write, address 0
+	0x6000,  // write, address 1
+	0x7000,  // write, address 2
+	0x4000,  // write, address 3
+	0xD36C,  // write, address 4
+	0xFFFF,  // write, address 5
+	0x5060,  // write, address 6
+	0x61C5,  // write, address 7
+	0x7000,  // write, address 8
+	0x4001,  // write, address 9
+	0x5061,  // write, address 10
+	0x87F5,  // write, address 11
+	0xCE60,  // write, address 12
+	0x0026,  // write, address 13
+	0x8E03,  // write, address 14
+	0xA021,  // write, address 15
+	0x300B,  // write, address 16
+	0x58A0,  // write, address 17
+	0x629C,  // write, address 18
+	0x7000,  // write, address 19
+	0x4002,  // write, address 20
+	0x58A1,  // write, address 21
+	0x87EA,  // write, address 22
+	0xAE25,  // write, address 23
+	0xA018,  // write, address 24
+	0x3016,  // write, address 25
+	0x6894,  // write, address 26
+	0x6094,  // write, address 27
+	0x5123,  // write, address 28
+	0x63C2,  // write, address 29
+	0x5127,  // write, address 30
+	0x4003,  // write, address 31
+	0x87E0,  // write, address 32
+	0x8EF3,  // write, address 33
+	0xA10E,  // write, address 34
+	0xCC40,  // write, address 35
+	0x0007,  // write, address 36
+	0xCA40,  // write, address 37
+	0xFFE0,  // write, address 38
+	0xA202,  // write, address 39
+	0x3020,  // write, address 40
+	0x7008,  // write, address 41
+	0x3020,  // write, address 42
+	0xCC44,  // write, address 43
+	0xFFF4,  // write, address 44
+	0xCC44,  // write, address 45
+	0xFFF2,  // write, address 46
+	0x3000,  // write, address 47
+	0x5220,  // write, address 48
+	0x4004,  // write, address 49
+	0x3000,  // write, address 50
+	0x64A0,  // write, address 51
+	0x5429,  // write, address 52
+	0x4005,  // write, address 53
+	0x87CA,  // write, address 54
+	0xCE18,  // write, address 55
+	0xFFC8,  // write, address 56
+	0xCE64,  // write, address 57
+	0xFFD0,  // write, address 58
+	0x3036,  // write, address 59
+	0x65C0,  // write, address 60
+	0x50A9,  // write, address 61
+	0x4006,  // write, address 62
+	0xA3DB,  // write, address 63
+	0x303F,  // write, address 64
+};
+
+static int ram_code_done=0;
+
+void set_ram_code(void)
+{
+	uint32 reg;
+	int i, len=sizeof(phy_data)/sizeof(unsigned short);
+
+	if (ram_code_done)
+		return;
+
+	rtl8651_getAsicEthernetPHYReg( 4, 0x19, &reg );
+
+	// turn on rg_eeeprg_rst
+	rtl8651_setAsicEthernetPHYReg(4, 0x19, ((reg & ~(P4R25_rg_eeeprg_en)) | P4R25_rg_eeeprg_rst));
+
+	// turn on mem_mdio_mode
+	rtl8651_setAsicEthernetPHYReg(4, 0x1c, 0x0180);
+
+	// begin to write all RAM
+	for(i=0;i<len;i++) {
+		rtl8651_setAsicEthernetPHYReg(4, 0x1d, phy_data[i]);
+	}
+
+	for(i=0;i<63;i++) {
+		rtl8651_setAsicEthernetPHYReg(4, 0x1d, 0);
+	}
+
+	// finish reading all RAM
+	// turn off mem_mdio_mode
+	rtl8651_setAsicEthernetPHYReg(4, 0x1c, 0x0080);
+
+	// turn off rg_eeeprg_rst, enable EEE programmable finite state machine
+	rtl8651_setAsicEthernetPHYReg(4, 0x19, ((reg & ~(P4R25_rg_eeeprg_rst)) | P4R25_rg_eeeprg_en));
+
+	ram_code_done = 1;
+}
+
+static const unsigned short phy_data_b[]={
+  0x5000,  // write, address 0
+  0x6000,  // write, address 1
+  0x7000,  // write, address 2
+  0x4000,  // write, address 3
+  0x8700,  // write, address 4
+  0xD344,  // write, address 5
+  0xFFFF,  // write, address 6
+  0xCA6C,  // write, address 7
+  0xFFFD,  // write, address 8
+  0x5460,  // write, address 9
+  0x61C5,  // write, address 10
+  0x7000,  // write, address 11
+  0x4001,  // write, address 12
+  0x5461,  // write, address 13
+  0x4001,  // write, address 14
+  0x87F1,  // write, address 15
+  0xCE60,  // write, address 16
+  0x0026,  // write, address 17
+  0x8E03,  // write, address 18
+  0xA021,  // write, address 19
+  0x300F,  // write, address 20
+  0x5CA0,  // write, address 21
+  0x629C,  // write, address 22
+  0x7000,  // write, address 23
+  0x4002,  // write, address 24
+  0x5CA1,  // write, address 25
+  0x87E6,  // write, address 26
+  0xAE25,  // write, address 27
+  0xA018,  // write, address 28
+  0x301A,  // write, address 29
+  0x6E94,  // write, address 30
+  0x6694,  // write, address 31
+  0x5523,  // write, address 32
+  0x63C2,  // write, address 33
+  0x5527,  // write, address 34
+  0x4003,  // write, address 35
+  0x87DC,  // write, address 36
+  0x8EF3,  // write, address 37
+  0xA10E,  // write, address 38
+  0xCC40,  // write, address 39
+  0x0007,  // write, address 40
+  0xCA40,  // write, address 41
+  0xFFDF,  // write, address 42
+  0xA202,  // write, address 43
+  0x3024,  // write, address 44
+  0x7008,  // write, address 45
+  0x3024,  // write, address 46
+  0xCC44,  // write, address 47
+  0xFFF4,  // write, address 48
+  0xCC44,  // write, address 49
+  0xFFF2,  // write, address 50
+  0x3000,  // write, address 51
+  0x5620,  // write, address 52
+  0x4004,  // write, address 53
+  0x3000,  // write, address 54
+  0x64A0,  // write, address 55
+  0x5429,  // write, address 56
+  0x4005,  // write, address 57
+  0x87C6,  // write, address 58
+  0xCE18,  // write, address 59
+  0xFFC4,  // write, address 60
+  0xCE64,  // write, address 61
+  0xFFCF,  // write, address 62
+  0x303A,  // write, address 63
+  0x65C0,  // write, address 64
+  0x54A9,  // write, address 65
+  0x4006,  // write, address 66
+  0xA3DB,  // write, address 67
+  0x3043,  // write, address 68
+};
+
+#ifdef RTL8196C_EEE_REFINE
+void cmp_eee_ram_code(int mode)
+{
+	uint32 reg;
+	int i, len=sizeof(phy_data_b)/sizeof(unsigned short);
+
+	printk(" => comparing eee ram code\n");
+
+	// change to page 4
+	rtl8651_setAsicEthernetPHYReg(4, 31, 4);
+
+	for(i=0;i<5;i++) {
+		rtl8651_getAsicEthernetPHYReg(i, 0x19, &reg );
+		rtl8651_setAsicEthernetPHYReg(i, 0x19, ((reg & ~(P4R25_rg_eeeprg_en)) | P4R25_rg_eeeprg_rst));
+	}
+
+	rtl8651_setAsicEthernetPHYReg(4, 29, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x0180);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x017F);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x0180);
+
+	for(i=0;i<len;i++) {
+		rtl8651_getAsicEthernetPHYReg(4, 0x1d, &reg);
+		if (mode == 0)
+			printk(" => [%d]  %x\n", i, reg);
+		else if (mode == 1) {
+			if (reg != phy_data_b[i])
+				printk(" => different: idx= %d, readback: %x, expect: %x\n",i, reg, phy_data_b[i]);
+		}
+	}
+
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x017E);
+	rtl8651_setAsicEthernetPHYReg(4, 29, 0x0001);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x017F);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x0180);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x0080);
+
+	for(i=0;i<5;i++) {
+		rtl8651_getAsicEthernetPHYReg(i, 0x19, &reg );
+		rtl8651_setAsicEthernetPHYReg(i, 0x19, ((reg & ~(P4R25_rg_eeeprg_rst)) | P4R25_rg_eeeprg_en));
+	}
+
+	// switch to page 0
+	rtl8651_setAsicEthernetPHYReg(4, 31, 0 );
+	printk(" => compare done\n");
+	return;
+}
+
+void set_ram_code_b(void)
+{
+	uint32 reg;
+	int i, len=sizeof(phy_data_b)/sizeof(unsigned short);
+
+	if (ram_code_done)
+		return;
+
+	/* 2. disable all of the fephy access
+	    wr  0   4  25  0x0760
+	    wr  1   4  25  0x0760
+	    wr  2   4  25  0x0760
+	    wr  3   4  25  0x0760
+	    wr  4   4  25  0x0760
+	    ( bit 6 = 1  /  bit4 = 0 )
+	 */
+	for(i=0;i<5;i++) {
+		rtl8651_getAsicEthernetPHYReg(i, 0x19, &reg );
+		rtl8651_setAsicEthernetPHYReg(i, 0x19, ((reg & ~(P4R25_rg_eeeprg_en)) | P4R25_rg_eeeprg_rst));
+	}
+	/* 3. enable memory access
+	    wr  4  4  29  0x0000  //
+		   wr  4  4  28  0x0180  //
+	    wr  4  4  28  0x017F  // mem_mdio_en = 1 / ram bist control = 0x00
+	    wr  4   4  28  0x0180 // mem_mdio_en = 1
+	 */
+	rtl8651_setAsicEthernetPHYReg(4, 29, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x0180);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x017F);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x0180);
+
+	// 4. start to write patch
+	for(i=0;i<len;i++) {
+		rtl8651_setAsicEthernetPHYReg(4, 0x1d, phy_data_b[i]);
+	}
+
+	/* 5. disable memory access
+	    wr  4  4  28   0x017E  //
+	    wr  4  4  29   0x0001  //  ram 0x7E  =  0x01
+	    wr  4  4  28   0x017F  //  ram bist control = 0x01
+	    wr  4  4  28   0x0180  //  addr = 0x00
+	    wr  4  4  28   0x0080  //  mem_mdio_en = 0
+	 */
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x017E);
+	rtl8651_setAsicEthernetPHYReg(4, 29, 0x0001);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x017F);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x0180);
+	rtl8651_setAsicEthernetPHYReg(4, 28, 0x0080);
+
+	/* 6. reenable all of the fephy access
+	    wr  0   4  25  0x0730
+	    wr  1   4  25  0x0730
+	    wr  2   4  25  0x0730
+	    wr  3   4  25  0x0730
+	    wr  4   4  25  0x0730
+	    ( bit 6 = 0  /  bit4 = 1 )
+	 */
+	for(i=0;i<5;i++) {
+		rtl8651_getAsicEthernetPHYReg(i, 0x19, &reg );
+		rtl8651_setAsicEthernetPHYReg(i, 0x19, ((reg & ~(P4R25_rg_eeeprg_rst)) | P4R25_rg_eeeprg_en));
+	}
+	ram_code_done = 1;
+}
+#else
+void set_ram_code_b(void)
+{
+	uint32 reg;
+	int i, len=sizeof(phy_data_b)/sizeof(unsigned short);
+
+	if (ram_code_done)
+		return;
+
+	rtl8651_getAsicEthernetPHYReg(4, 0x19, &reg );
+	rtl8651_setAsicEthernetPHYReg(4, 0x19, ((reg & ~(P4R25_rg_eeeprg_en)) | P4R25_rg_eeeprg_rst));
+	rtl8651_setAsicEthernetPHYReg(4, 0x1c, 0x0180);
+
+	for(i=0;i<len;i++) {
+		rtl8651_setAsicEthernetPHYReg(4, 0x1d, phy_data_b[i]);
+	}
+
+	rtl8651_setAsicEthernetPHYReg(4, 0x1c, 0x0080);
+	rtl8651_setAsicEthernetPHYReg(4, 0x19, ((reg & ~(P4R25_rg_eeeprg_rst)) | P4R25_rg_eeeprg_en));
+
+	ram_code_done = 1;
+}
+#endif
+
+void eee_phy_enable_by_port(int port)
+{
+	uint32 reg;
+
+	// change to page 4
+	rtl8651_setAsicEthernetPHYReg(port, 31, 4);
+
+	// enable EEE N-way & set turn off power at quiet state
+	rtl8651_getAsicEthernetPHYReg( port, 16, &reg );
+	reg |= (P4R16_eee_nway_en | P4R16_tx_quiet_en | P4R16_rx_quiet_en);
+
+#ifdef CONFIG_RTL8196C_ETH_IOT
+	reg |= P4R16_eee_10_cap;	// enable 10M_EEE also.
+#endif
+	rtl8651_setAsicEthernetPHYReg( port, 16, reg );
+
+	// enable EEE turn off DAC and line driver when TX Quiet state
+	rtl8651_getAsicEthernetPHYReg( port, 25, &reg );
+//	reg = reg & 0xF9FF | P4R25_rg_dacquiet_en | P4R25_rg_ldvquiet_en;
+	reg |= (P4R25_rg_dacquiet_en | P4R25_rg_ldvquiet_en | P4R25_rg_eeeprg_en);
+
+	rtl8651_setAsicEthernetPHYReg( port, 25, reg );
+
+	rtl8651_setAsicEthernetPHYReg( port, 17, 0xa2a2 );
+	rtl8651_setAsicEthernetPHYReg( port, 19, 0xc5c2 );
+	rtl8651_setAsicEthernetPHYReg( port, 24, 0xc0f3 );
+
+	if ((REG32(REVR)==RTL8196C_REVISION_A) && (port==4)){
+		set_ram_code();
+	}
+	else if ((REG32(REVR) == RTL8196C_REVISION_B) && (port == 4)) {
+		set_ram_code_b();
+	}
+
+	// switch to page 0
+	rtl8651_setAsicEthernetPHYReg(port, 31, 0 );
+}
+
+#ifdef RTL8196C_EEE_REFINE
+void eee_phy_enable(void)
+{
+	int i;
+
+	// EEE PHY enable
+	for (i=0; i<MAX_PORT_NUMBER; i++)
+	{
+		eee_phy_enable_by_port(i);
+		rtl8651_restartAsicEthernetPHYNway(i+1);
+	}
+}
+#else
+void eee_phy_enable(void)
+{
+	int i;
+	uint32 reg;
+
+	// EEE PHY enable
+	for (i=0; i<MAX_PORT_NUMBER; i++)
+	{
+		// change to page 4
+		rtl8651_setAsicEthernetPHYReg(i, 31, 4);
+
+		// enable EEE N-way & set turn off power at quiet state
+		rtl8651_getAsicEthernetPHYReg( i, 16, &reg );
+		reg |= (P4R16_eee_nway_en | P4R16_tx_quiet_en | P4R16_rx_quiet_en);
+		rtl8651_setAsicEthernetPHYReg( i, 16, reg );
+
+		// enable EEE turn off DAC and line driver when TX Quiet state
+		rtl8651_getAsicEthernetPHYReg( i, 25, &reg );
+//		reg = reg & 0xF9FF | P4R25_rg_dacquiet_en | P4R25_rg_ldvquiet_en;
+		reg |= (P4R25_rg_dacquiet_en | P4R25_rg_ldvquiet_en | P4R25_rg_eeeprg_en);
+		rtl8651_setAsicEthernetPHYReg( i, 25, reg );
+
+		rtl8651_setAsicEthernetPHYReg( i, 17, 0xa2a2 );
+		rtl8651_setAsicEthernetPHYReg( i, 19, 0xc5c2 );
+		rtl8651_setAsicEthernetPHYReg( i, 24, 0xc0f3 );
+
+		if ((REG32(REVR)==RTL8196C_REVISION_A) && (i==4)){
+			set_ram_code();
+		}
+		else if ((REG32(REVR) == RTL8196C_REVISION_B) && (i == 4)) {
+			set_ram_code_b();
+		}
+
+		// switch to page 0
+		rtl8651_setAsicEthernetPHYReg(i, 31, 0 );
+
+		rtl8651_restartAsicEthernetPHYNway(i+1);
+	}
+}
+#endif
+
+void eee_phy_disable(void)
+{
+	int i;
+	uint32 reg;
+
+	// EEE PHY disable
+	for (i=0; i<MAX_PORT_NUMBER; i++)
+	{
+		// change to page 4
+		rtl8651_setAsicEthernetPHYReg(i, 31, 4);
+
+		// disable (EEE N-way & turn off power at quiet state)
+		rtl8651_getAsicEthernetPHYReg( i, 16, &reg );
+		reg = reg & 0xECFF;
+		rtl8651_setAsicEthernetPHYReg( i, 16, reg );
+
+		// switch to page 0
+		rtl8651_setAsicEthernetPHYReg(i, 31, 0 );
+
+		rtl8651_restartAsicEthernetPHYNway(i+1);
+	}
+
+	// EEE MAC disable
+
+}
+#endif
+
+#if defined(RTL8198_EEE_MAC)
+// EEE PHY -- Page 4
+void Set_GPHYWB(unsigned int phyid, unsigned int page, unsigned int reg, unsigned int mask, unsigned int val);
+
+void eee_phy_enable_98(void)
+{
+	int i;
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	// EEE PHY enable
+	for (i=0; i<5; i++)
+	{
+		// change to page 4
+		Set_GPHYWB(i,32,27,0xffff - 0xffff,0x2fce);
+		Set_GPHYWB(i,32,21,0xffff - 0xffff,0x0100);
+		Set_GPHYWB(i,5,5,0xffff - 0xffff,0x8b84);
+		Set_GPHYWB(i,5,6,0xffff - 0xffff,0x0062);
+
+		/* enable "EEE auto off" for JMicron's bug */
+		Set_GPHYWB(i,5,5,0,0x857a);
+		Set_GPHYWB(i,5,6,0,0x0770);
+
+		rtl8651_restartAsicEthernetPHYNway(i+1);
+	}
+
+//	for(i=0; i<5; i++)
+//		REG32(PCRP0+i*4) &= ~(EnForceMode);
+}
+
+void eee_phy_disable_98(void)
+{
+	int i;
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	for (i=0; i<5; i++)
+	{
+		// change to page 4
+		Set_GPHYWB(i,32,27,0xffff - 0xffff,0x2f4e);
+		Set_GPHYWB(i,32,21,0xffff - 0xffff,0x0);
+		Set_GPHYWB(i,5,5,0xffff - 0xffff,0x8b84);
+		Set_GPHYWB(i,5,6,0xffff - 0xffff,0x0042);
+
+		rtl8651_restartAsicEthernetPHYNway(i+1);
+	}
+	// EEE PHY disable
+
+//	for(i=0; i<5; i++)
+//		REG32(PCRP0+i*4) &= ~(EnForceMode);
+}
+#endif
+
+#if defined(CONFIG_RTL_8198)
+int rtl8198_power_saving_config(uint32 mode)
+{
+	unsigned long flags=0;
+	int i, _8198_ALDPS, _8198_green_eth;
+
+	if(mode == 0)
+	{
+		// 8198 green ethernet / EEE / ALDPS off
+		eee_enabled = 0;
+		_8198_green_eth = 0;
+		_8198_ALDPS = 0;
+	}
+	else if(mode == 1)
+	{
+		// 8198 green ethernet / EEE / ALDPS on
+		eee_enabled = 1;
+		_8198_green_eth = 1;
+		_8198_ALDPS = 1;
+	}
+	else if(mode == 2)
+	{
+		// 8198 green ethernet on / EEE off
+		eee_enabled = 0;
+		_8198_green_eth = 1;
+		_8198_ALDPS = 1;
+	}
+	else if(mode == 3)
+	{
+		// 8198 green ethernet off / EEE on
+		eee_enabled = 1;
+		_8198_green_eth = 0;
+		_8198_ALDPS = 1;
+	}
+	else {
+		return (-1);
+	}
+
+	SMP_LOCK_ETH(flags);
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	/*
+		8198 ALDPS feature is on by default.
+		It is in PHY page 44, reg 21, bit 0: 1 enable, 0 disable
+	*/
+	if (_8198_ALDPS) {
+		Set_GPHYWB(999, 44, 21, 0xfffe, 1);
+	}
+	else {
+		Set_GPHYWB(999, 44, 21, 0xfffe, 0);
+	}
+
+	/*
+		write Page 5 Reg 5 = 0x85E4
+		read Page 5 Reg 6; #bit0 = 1, for enable green Rx
+		write Page 5 Reg 5 = 0x85E7
+		read Page 5 Reg 6; #bit0 = 1, for enable green Tx
+
+	*/
+	if (_8198_green_eth) {
+		Set_GPHYWB(999, 5, 5, 0, 0x85e4);
+		Set_GPHYWB(999, 5, 6, 0xfffe, 1);
+
+		Set_GPHYWB(999, 5, 5, 0, 0x85e7);
+		Set_GPHYWB(999, 5, 6, 0xfffe, 1);
+	}
+	else {
+		Set_GPHYWB(999, 5, 5, 0, 0x85e4);
+		Set_GPHYWB(999, 5, 6, 0xfffe, 0);
+
+		Set_GPHYWB(999, 5, 5, 0, 0x85e7);
+		Set_GPHYWB(999, 5, 6, 0xfffe, 0);
+	}
+
+	if (eee_enabled) {
+		eee_phy_enable_98();
+	}
+	else {
+		eee_phy_disable_98();
+	}
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+
+	SMP_UNLOCK_ETH(flags);
+
+	return 0;
+}
+#endif
+
+#ifdef CONFIG_RTL8196C_GREEN_ETHERNET
+void set_phy_pwr_save(int id, int val)
+{
+	uint32 reg_val;
+	int i, start, end;
+
+	if (id == 99)
+		{ start=0; end=4; }
+	else if (id <= 4)
+		{ start = end = id; }
+	else
+		return;
+	for(i=start; i<=end; i++)
+	{
+		rtl8651_getAsicEthernetPHYReg( i, 24, &reg_val);
+
+		if (val == 1)
+			rtl8651_setAsicEthernetPHYReg( i, 24, (reg_val | BIT(15)) );
+		else
+			rtl8651_setAsicEthernetPHYReg( i, 24, (reg_val & (~BIT(15))) );
+	}
+}
+#endif
+
+int32 mmd_read(uint32 phyId, uint32 devId, uint32 regId, uint32 *rData)
+{
+	rtl8651_setAsicEthernetPHYReg( phyId, 13, devId);
+	rtl8651_setAsicEthernetPHYReg( phyId, 14, regId);
+	rtl8651_setAsicEthernetPHYReg( phyId, 13, (devId | 0x4000));
+	return (rtl8651_getAsicEthernetPHYReg(phyId, 14, rData));
+}
+
+int32 mmd_write(uint32 phyId, uint32 devId, uint32 regId, uint32 wData)
+{
+	rtl8651_setAsicEthernetPHYReg( phyId, 13, devId);
+	rtl8651_setAsicEthernetPHYReg( phyId, 14, regId);
+	rtl8651_setAsicEthernetPHYReg( phyId, 13, (devId | 0x4000));
+	rtl8651_setAsicEthernetPHYReg( phyId, 14, wData);
+	return SUCCESS;
+}
+
+uint32 rtl8651_filterDbIndex(ether_addr_t * macAddr,uint16 fid)
+{
+	return ( macAddr->octet[0] ^ macAddr->octet[1] ^
+					macAddr->octet[2] ^ macAddr->octet[3] ^
+					macAddr->octet[4] ^ macAddr->octet[5] ^fidHashTable[fid]) & 0xFF;
+}
+
+int32 rtl8651_setAsicL2Table(uint32 row, uint32 column, rtl865x_tblAsicDrv_l2Param_t *l2p)
+{
+	rtl865xc_tblAsic_l2Table_t entry;
+
+	if((row >= RTL8651_L2TBL_ROW) || (column >= RTL8651_L2TBL_COLUMN) || (l2p == NULL))
+		return FAILED;
+	if(l2p->macAddr.octet[5] != ((row^(fidHashTable[l2p->fid])^ l2p->macAddr.octet[0] ^ l2p->macAddr.octet[1] ^ l2p->macAddr.octet[2] ^ l2p->macAddr.octet[3] ^ l2p->macAddr.octet[4] ) & 0xff))
+		return FAILED;
+
+	memset(&entry, 0,sizeof(entry));
+	entry.mac47_40 = l2p->macAddr.octet[0];
+	entry.mac39_24 = (l2p->macAddr.octet[1] << 8) | l2p->macAddr.octet[2];
+	entry.mac23_8 = (l2p->macAddr.octet[3] << 8) | l2p->macAddr.octet[4];
+
+
+	if( l2p->memberPortMask  > RTL8651_PHYSICALPORTMASK) //this MAC is on extension port
+		entry.extMemberPort = (l2p->memberPortMask >>RTL8651_PORT_NUMBER);
+
+	entry.memberPort = l2p->memberPortMask & RTL8651_PHYSICALPORTMASK;
+	entry.toCPU = l2p->cpu==TRUE? 1: 0;
+	entry.isStatic = l2p->isStatic==TRUE? 1: 0;
+	entry.nxtHostFlag = l2p->nhFlag==TRUE? 1: 0;
+
+	/* RTL865xC: modification of age from ( 2 -> 3 -> 1 -> 0 ) to ( 3 -> 2 -> 1 -> 0 ). modification of granularity 100 sec to 150 sec. */
+	entry.agingTime = ( l2p->ageSec > 300 )? 0x03: ( l2p->ageSec <= 300 && l2p->ageSec > 150 )? 0x02: (l2p->ageSec <= 150 && l2p->ageSec > 0 )? 0x01: 0x00;
+
+	entry.srcBlock = (l2p->srcBlk==TRUE)? 1: 0;
+	entry.fid=l2p->fid;
+	entry.auth=l2p->auth;
+	return _rtl8651_forceAddAsicEntry(TYPE_L2_SWITCH_TABLE, row<<2 | column, &entry);
+}
+
+int32 rtl8651_delAsicL2Table(uint32 row, uint32 column)
+{
+	rtl865xc_tblAsic_l2Table_t entry;
+
+	if(row >= RTL8651_L2TBL_ROW || column >= RTL8651_L2TBL_COLUMN)
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	return _rtl8651_forceAddAsicEntry(TYPE_L2_SWITCH_TABLE, row<<2 | column, &entry);
+}
+
+
+ether_addr_t cachedDA;
+static uint32 cachedMbr;
+unsigned int rtl8651_asicL2DAlookup(uint8 *dmac){
+	uint32 column;
+	rtl865xc_tblAsic_l2Table_t	entry;
+
+	uint32 row = rtl8651_filterDbIndex((ether_addr_t *)dmac, 0);
+	//rtlglue_printf("mac %02x %02x %02x %02x %02x %02x \n",	mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
+
+	//cache miss...
+	cachedMbr=0;
+	for(column=0;column<RTL8651_L2TBL_COLUMN; column++) {
+/* Should be fixed 		WRITE_MEM32(TEACR,READ_MEM32(TEACR)|0x1);ASIC patch: disable L2 Aging while reading L2 table */
+		_rtl8651_readAsicEntry(TYPE_L2_SWITCH_TABLE, row<<2 | column, &entry);
+/*		WRITE_MEM32(TEACR,READ_MEM32(TEACR)&~0x1); ASIC patch: enable L2 Aging aftrer reading L2 table */
+		if(entry.agingTime == 0 && entry.isStatic == 0)
+			continue;
+		if(	dmac[0]==entry.mac47_40 &&
+		    	dmac[1]==(entry.mac39_24>>8) &&
+		    	dmac[2]==(entry.mac39_24 & 0xff)&&
+		    	dmac[3]==(entry.mac23_8 >> 8)&&
+		    	dmac[4]==(entry.mac23_8 & 0xff)&&
+			dmac[5]== (row ^dmac[0]^dmac[1]^dmac[2]^dmac[3]^dmac[4])){
+
+			cachedDA=*((ether_addr_t *)dmac);
+			cachedMbr =(entry.extMemberPort<<RTL8651_PORT_NUMBER) | entry.memberPort;
+			return cachedMbr;
+		}
+	}
+	if(column==RTL8651_L2TBL_COLUMN)
+		return 0xffffffff;//can't find this MAC, broadcast it.
+	return cachedMbr;
+}
+
+
+
+int32 rtl8651_getAsicL2Table(uint32 row, uint32 column, rtl865x_tblAsicDrv_l2Param_t *l2p) {
+	rtl865xc_tblAsic_l2Table_t   entry;
+
+	if((row >= RTL8651_L2TBL_ROW) || (column >= RTL8651_L2TBL_COLUMN) || (l2p == NULL))
+		return FAILED;
+
+/*	RTL865XC should fix this problem.WRITE_MEM32(TEACR,READ_MEM32(TEACR)|0x1); ASIC patch: disable L2 Aging while reading L2 table */
+	_rtl8651_readAsicEntry(TYPE_L2_SWITCH_TABLE, row<<2 | column, &entry);
+	//WRITE_MEM32(TEACR,READ_MEM32(TEACR)&0x1); ASIC patch: enable L2 Aging aftrer reading L2 table */
+
+	if(entry.agingTime == 0 && entry.isStatic == 0 )
+		return FAILED;
+	l2p->macAddr.octet[0] = entry.mac47_40;
+	l2p->macAddr.octet[1] = entry.mac39_24 >> 8;
+	l2p->macAddr.octet[2] = entry.mac39_24 & 0xff;
+	l2p->macAddr.octet[3] = entry.mac23_8 >> 8;
+	l2p->macAddr.octet[4] = entry.mac23_8 & 0xff;
+	l2p->macAddr.octet[5] = row ^ l2p->macAddr.octet[0] ^ l2p->macAddr.octet[1] ^ l2p->macAddr.octet[2] ^ l2p->macAddr.octet[3] ^ l2p->macAddr.octet[4]  ^(fidHashTable[entry.fid]);
+	l2p->cpu = entry.toCPU==1? TRUE: FALSE;
+	l2p->srcBlk = entry.srcBlock==1? TRUE: FALSE;
+	l2p->nhFlag = entry.nxtHostFlag==1? TRUE: FALSE;
+	l2p->isStatic = entry.isStatic==1? TRUE: FALSE;
+	l2p->memberPortMask = (entry.extMemberPort<<RTL8651_PORT_NUMBER) | entry.memberPort;
+
+	/* RTL865xC: modification of age from ( 2 -> 3 -> 1 -> 0 ) to ( 3 -> 2 -> 1 -> 0 ). modification of granularity 100 sec to 150 sec. */
+	l2p->ageSec = entry.agingTime * 150;
+
+	l2p->fid=entry.fid;
+	l2p->auth=entry.auth;
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicPortMirror(uint32 mRxMask, uint32 mTxMask,uint32 mPortMask)
+{
+	uint32 pmcr = 0;
+	pmcr = ((mTxMask<<MirrorTxPrtMsk_OFFSET)&MirrorTxPrtMsk_MASK) |
+		((mRxMask << MirrorRxPrtMsk_OFFSET) & MirrorRxPrtMsk_MASK)|
+		((mPortMask<<MirrorPortMsk_OFFSET) & MirrorPortMsk_MASK);
+
+	WRITE_MEM32(PMCR,pmcr);
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicPortMirror(uint32 *mRxMask, uint32 *mTxMask, uint32 *mPortMask)
+{
+	uint32 pmcr = READ_MEM32( PMCR );
+
+	if ( mPortMask )
+	{
+		*mPortMask = ( pmcr & MirrorPortMsk_MASK ) >> MirrorPortMsk_OFFSET;
+	}
+
+	if ( mRxMask )
+	{
+		*mRxMask = ( pmcr & MirrorRxPrtMsk_MASK ) >> MirrorRxPrtMsk_OFFSET;
+	}
+
+	if ( mTxMask )
+	{
+		*mTxMask = ( pmcr & MirrorTxPrtMsk_MASK ) >> MirrorTxPrtMsk_OFFSET;
+	}
+
+	return SUCCESS;
+}
+
+int32 rtl8651_clearAsicL2Table(void)
+{
+	rtl8651_clearSpecifiedAsicTable(TYPE_L2_SWITCH_TABLE, RTL8651_L2TBL_ROW*RTL8651_L2TBL_COLUMN);
+	rtl8651_clearSpecifiedAsicTable(TYPE_RATE_LIMIT_TABLE, RTL8651_RATELIMITTBL_SIZE);
+	return SUCCESS;
+}
+
+inline int32 convert_setAsicL2Table(uint32 row, uint32 column, ether_addr_t * mac, int8 cpu,
+		int8 srcBlk, uint32 mbr, uint32 ageSec, int8 isStatic, int8 nhFlag,int8 fid, int8 auth)
+{
+	rtl865x_tblAsicDrv_l2Param_t l2;
+
+	memset(&l2,0,sizeof(rtl865x_tblAsicDrv_l2Param_t));
+
+	l2.ageSec				= ageSec;
+	l2.cpu				= cpu;
+	l2.isStatic				= isStatic;
+	l2.memberPortMask		= mbr;
+	l2.nhFlag				= nhFlag;
+	l2.srcBlk				= srcBlk;
+//#ifdef RTL865XC_LAN_PORT_NUM_RESTRIT
+//	if(enable4LanPortNumRestrict == TRUE)
+	l2.fid=fid;
+	l2.auth = auth;
+//#endif
+	memcpy(&l2.macAddr, mac, 6);
+	return rtl8651_setAsicL2Table(row, column, &l2);
+}
+
+/*
+ * RTL8651 L2 entry:
+ *		For each L2 entry added by driver table as a static entry, the aging time
+ *		will not be updated by ASIC.
+ * Action:
+ *		set the entry is a dynamic entry and turn on the 'nhFlag',
+ *		then the aging time of this entry will be updated and once aging time expired,
+ *		it won't be removed by ASIC automatically.
+ */
+int32 rtl8651_setAsicL2Table_Patch(uint32 row, uint32 column, ether_addr_t * mac, int8 cpu,
+		int8 srcBlk, uint32 mbr, uint32 ageSec, int8 isStatic, int8 nhFlag, int8 fid,int8 auth)
+{
+#if 0
+	ether_addr_t bcast_mac = { {0xff, 0xff, 0xff, 0xff, 0xff, 0xff} };
+	ether_addr_t cpu_mac = {{0x00,0x00,0x0a,0x00,0x00,0x0f}};
+
+	/*
+		In RTL865xC, we need to turn on the CPU bit of broadcast mac to let broadcast packets being trapped to CPU.
+	*/
+
+	if ( memcmp( &bcast_mac, mac, sizeof(ether_addr_t) ) == 0 || memcmp(&cpu_mac,mac,sizeof(ether_addr_t)) == 0)
+	{
+		return convert_setAsicL2Table(
+				row,
+				column,
+				mac,
+				TRUE,	/* Set CPU bit to TRUE */
+				FALSE,
+				mbr,
+				500,
+				isStatic,	/* No one will be broadcast/multicast source */
+				nhFlag,/* No one will be broadcast/multicast source */
+				TRUE
+		);
+	}
+#endif
+	if(mac->octet[0]&0x1)
+	{
+		return convert_setAsicL2Table(
+				row,
+				column,
+				mac,
+				cpu,
+				FALSE,
+				mbr,
+				ageSec,
+				isStatic,	/* No one will be broadcast/multicast source */
+				nhFlag,	/* No one will be broadcast/multicast source */
+				fid,
+				TRUE
+		);
+	}
+	else {
+		int8 dStatic=isStatic/*, dnhFlag=(isStatic==TRUE? TRUE: FALSE)*/;
+		int8 dnhFlag = nhFlag;
+#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
+		extern rtl8651_tblDrv_miiTunneling_t tunnel;
+		uint32 MBR = (1 << tunnel.loopbackPort);
+		if (tunnel.valid && mbr==MBR) {
+			dStatic = TRUE;
+			dnhFlag = FALSE;
+		}
+#endif
+		return convert_setAsicL2Table(
+				row,
+				column,
+				mac,
+				cpu,
+				srcBlk,
+				mbr,
+				ageSec,
+				dStatic,
+				dnhFlag,
+				fid,
+				auth
+//				FALSE,							/* patch here!! always dynamic entry */
+//				(isStatic==TRUE? TRUE: FALSE)	/* patch here!! nhFlag always turned on if static entry*/
+		);
+	}
+}
+
+#ifdef CONFIG_RTL_HW_TX_CSUM
+int getL2MbrByMac(unsigned char *mac)
+{
+	int idx;
+	rtl865x_tblAsicDrv_l2Param_t l2_t;
+
+	idx = (((fidHashTable[0])^ mac[0] ^ mac[1] ^ mac[2] ^ mac[3] ^ mac[4]  ^ mac[5]) & 0xff);
+
+	if (rtl8651_getAsicL2Table_Patch(idx, 0, &l2_t) == SUCCESS)
+		return (l2_t.memberPortMask);
+	else
+		return (-1);
+}
+#endif
+
+#if 0
+int32 rtl8651_getAsicL2Table_Patch(uint32 row, uint32 column, ether_addr_t * mac, int8 * cpu,
+	int8 * srcBlk, int8 * isStatic, uint32 * mbr, uint32 * ageSec, int8 *nhFlag)
+{
+	rtl865x_tblAsicDrv_l2Param_t l2;
+
+	int32 retval = rtl8651_getAsicL2Table(row, column, &l2);
+	if (mac) memcpy(mac, &l2.macAddr, 6);
+	if (cpu) *cpu = l2.cpu;
+	if (srcBlk) *srcBlk = l2.srcBlk;
+	if (isStatic) *isStatic = l2.isStatic;
+	if (mbr) *mbr = l2.memberPortMask;
+	if (ageSec) *ageSec = l2.ageSec;
+	if (nhFlag) *nhFlag = l2.nhFlag;
+	if (isStatic != NULL) *isStatic = TRUE; /* patch!!, always TRUE(static entry */
+	if (nhFlag != NULL) *nhFlag = FALSE;  /* always false */
+	return retval;
+}
+#else
+
+int32 rtl8651_getAsicL2Table_Patch(uint32 row, uint32 column, rtl865x_tblAsicDrv_l2Param_t *asic_l2_t)
+{
+	int32 retval = rtl8651_getAsicL2Table(row, column, asic_l2_t);
+#ifdef CONFIG_RTL865XB_EXP_INVALID
+	if (retval == SUCCESS) {
+		asic_l2_t->isStatic	= TRUE;
+		asic_l2_t->nhFlag	= FALSE;
+	}
+#endif
+	return retval;
+}
+#endif
+
+#if !defined(CONFIG_RTL_819X)
+#define	PAGE_SELECT_REGID		31
+#define	PAGE_SELECT_OFFSET		0
+#define	PAGE_SELECT_MASK		0xF
+#define		EXTRTL_8214_REGBASE_1		CONFIG_EXTRTL8212_PHYID_P1
+#define		EXTRTL_8214_REGBASE_3		CONFIG_EXTRTL8212_PHYID_P3
+static inline unsigned int rtl865x_probeP1toP4GigaPHYChip(void)
+{
+	unsigned int uid,tmp;
+	unsigned int i;
+
+	/* Read */
+	for(i=0; i<4; i++)  //probe p1-p4
+	{
+		rtl8651_getAsicEthernetPHYReg( CONFIG_EXTRTL8212_PHYID_P1+i, 2, &tmp );
+		uid=tmp<<16;
+		rtl8651_getAsicEthernetPHYReg( CONFIG_EXTRTL8212_PHYID_P1+i, 3, &tmp );
+		uid=uid | tmp;
+
+		if( uid==0x001CC912 )  //0x001cc912 is 8212 two giga port , 0x001cc940 is 8214 four giga port
+		{
+			return 1;
+		}
+		else if(uid==0x001CC940)
+		{
+			//printk("Find Port1-4 8214 PHY Chip! \r\n");
+			//FixPHYChip();
+			//RstGigaPhy();
+			return 1;
+		}
+	}
+	return 0;
+}
+
+static inline unsigned int rtl865x_probeP5GigaPHYChip(void)
+{
+	unsigned int uid,tmp;
+
+	/* Read */
+	rtl8651_getAsicEthernetPHYReg( CONFIG_EXTRTL8212_PHYID_P5, 0, &tmp );
+	rtl8651_setAsicEthernetPHYReg(CONFIG_EXTRTL8212_PHYID_P5,0x10,0x01FE);
+
+	/* Read */
+	rtl8651_getAsicEthernetPHYReg( CONFIG_EXTRTL8212_PHYID_P5, 2, &tmp );
+	uid=tmp<<16;
+	rtl8651_getAsicEthernetPHYReg( CONFIG_EXTRTL8212_PHYID_P5, 3, &tmp );
+	uid=uid | tmp;
+
+	if( uid==0x001CC912 )  //0x001cc912 is 8212 two giga port , 0x001cc940 is 8214 four giga port
+	{	//printk("Find Port5   have 8211 PHY Chip! \r\n");
+		return 1;
+	}
+
+	return 0;
+}
+
+static void	rtl865x_fix8214Bug(void)
+{
+	/*	52_phy_write 0x12 9 21 0xDD0A	*/
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, PAGE_SELECT_REGID, 0x0009);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, 21, 0xDD0A);
+	/*	52_phy_write 0x13 9 21 0xDD0A	*/
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, PAGE_SELECT_REGID, 0x0009);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, 21, 0xDD0A);
+	/*	52_phy_write 0x14 8 28 0x0003	*/
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, PAGE_SELECT_REGID, 0x0008);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, 28, 0x0003);
+
+	/*	mdcmdio_cmd w 0x12 31  0x0002
+	*	mdcmdio_cmd w 0x12 8  0x3672
+	*	mdcmdio_cmd w 0x12 9  0x8c00
+	*	mdcmdio_cmd w 0x12 12  0x5b15
+	*	mdcmdio_cmd w 0x12 18  0x0edd
+	*	mdcmdio_cmd w 0x12 27  0x5c5c
+	*/
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, PAGE_SELECT_REGID, 0x0002);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, 8, 0x3672);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, 9, 0x8c00);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, 12, 0x5b15);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, 18, 0x0edd);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, 27, 0x5c5c);
+
+	/*	mdcmdio_cmd w 0x13 31  0x0002
+	*	mdcmdio_cmd w 0x13 8  0x3672
+	*	mdcmdio_cmd w 0x13 9  0x8c00
+	*	mdcmdio_cmd w 0x13 12  0x5b15
+	*	mdcmdio_cmd w 0x13 18  0x0edd
+	*	mdcmdio_cmd w 0x13 27  0x5c5c
+	*/
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, PAGE_SELECT_REGID, 0x0002);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, 8, 0x3672);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, 9, 0x8c00);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, 12, 0x5b15);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, 18, 0x0edd);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, 27, 0x5c5c);
+
+	/*	mdcmdio_cmd w 0x14 31  0x0002
+	*	mdcmdio_cmd w 0x14 8  0x3672
+	*	mdcmdio_cmd w 0x14 9  0x8c00
+	*	mdcmdio_cmd w 0x14 12  0x5b15
+	*	mdcmdio_cmd w 0x14 18  0x0edd
+	*	mdcmdio_cmd w 0x14 27  0x5c5c
+	*/
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, PAGE_SELECT_REGID, 0x0002);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, 8, 0x3672);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, 9, 0x8c00);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, 12, 0x5b15);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, 18, 0x0edd);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, 27, 0x5c5c);
+	/*	mdcmdio_cmd w 0x15 31  0x0002
+	*	mdcmdio_cmd w 0x15 8  0x3672
+	*	mdcmdio_cmd w 0x15 9  0x8c00
+	*	mdcmdio_cmd w 0x15 12  0x5b15
+	*	mdcmdio_cmd w 0x15 18  0x0edd
+	*	mdcmdio_cmd w 0x15 27  0x5c5c
+	*/
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, PAGE_SELECT_REGID, 0x0002);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, 8, 0x3672);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, 9, 0x8c00);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, 12, 0x5b15);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, 18, 0x0edd);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, 27, 0x5c5c);
+
+	/*
+	*	#RTL8214 Enable AUTO - K
+	*	52_phy_write 0x12 0 20 0x8000
+	*	52_phy_write 0x13 0 20 0x8000
+	*	52_phy_write 0x14 0 20 0x8000
+	*	52_phy_write 0x15 0 20 0x8000
+	*/
+
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, PAGE_SELECT_REGID, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, 20, 0x8000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, PAGE_SELECT_REGID, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, 20, 0x8000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, PAGE_SELECT_REGID, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, 20, 0x8000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, PAGE_SELECT_REGID, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, 20, 0x8000);
+
+	/*
+	*	52_phy_write 0x12 0 20 0x8040
+	*	52_phy_write 0x13 0 20 0x8040
+	*	52_phy_write 0x14 0 20 0x8040
+	*	52_phy_write 0x15 0 20 0x8040
+	*/
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, PAGE_SELECT_REGID, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, 20, 0x8040);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, PAGE_SELECT_REGID, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, 20, 0x8040);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, PAGE_SELECT_REGID, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, 20, 0x8040);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, PAGE_SELECT_REGID, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, 20, 0x8040);
+	/*
+		#change to default page
+		52_phy_read 0x12 8 0
+	*/
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1, PAGE_SELECT_REGID, 0x0008);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, PAGE_SELECT_REGID, 0x0008);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3, PAGE_SELECT_REGID, 0x0008);
+	rtl8651_setAsicEthernetPHYReg(EXTRTL_8214_REGBASE_3+1, PAGE_SELECT_REGID, 0x0008);
+
+#if 0
+	/* Test */
+	rtl8651_getAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, PAGE_SELECT_REGID, &rData);
+	rtl8651_getAsicEthernetPHYReg(EXTRTL_8214_REGBASE_1+1, 15, &rData);
+	rtl865x_setAsicEthernetPHYPage(EXTRTL_8214_REGBASE_1+1, 8);
+	printk("*********************\nrData 0x%x\n*********************\n", rData);
+#endif
+}
+#endif
+
+static int32 _rtl8651_initAsicPara( rtl8651_tblAsic_InitPara_t *para )
+{
+	memset(&rtl8651_tblAsicDrvPara, 0, sizeof(rtl8651_tblAsic_InitPara_t));
+
+	if ( para )
+	{
+		/* Parameter != NULL, check its correctness */
+		if (para->externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT1234_RTL8212)
+		{
+			ASICDRV_ASSERT(para->externalPHYId[1] != 0);
+			ASICDRV_ASSERT(para->externalPHYId[2] != 0);
+			ASICDRV_ASSERT(para->externalPHYId[3] != 0);
+			ASICDRV_ASSERT(para->externalPHYId[4] != 0);
+			ASICDRV_ASSERT(para->externalPHYId[2] == (para->externalPHYId[1] + 1));
+			ASICDRV_ASSERT(para->externalPHYId[4] == (para->externalPHYId[3] + 1));
+		}
+		if (para->externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+		{
+			ASICDRV_ASSERT(para->externalPHYId[5] != 0);
+		}
+
+		/* ============= Check passed : set it =============  */
+		memcpy(&rtl8651_tblAsicDrvPara, para, sizeof(rtl8651_tblAsic_InitPara_t));
+	}
+
+	return SUCCESS;
+}
+
+void Set_GPHYWB(unsigned int phyid, unsigned int page, unsigned int reg, unsigned int mask, unsigned int val)
+{
+	unsigned int data=0;
+	unsigned int i, wphyid=0;	//start
+	unsigned int wphyid_end=1;   //end
+
+	if(phyid==999)
+	{	i=0;
+		wphyid_end=5;    //total phyid=0~4
+	}
+	else
+	{	i=phyid;
+		wphyid_end=phyid+1;
+	}
+
+	for(; i<wphyid_end; i++)
+	{
+		wphyid = i;
+		//change page
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		if (i == 0)
+			wphyid = RTL8198C_PORT0_PHY_ID;
+
+		if(page > 0)
+			rtl8651_setAsicEthernetPHYReg( wphyid, 31, page  );
+#else
+		if(page>=31)
+		{	rtl8651_setAsicEthernetPHYReg( wphyid, 31, 7  );
+			rtl8651_setAsicEthernetPHYReg( wphyid, 30, page  );
+		}
+		else
+		{
+			rtl8651_setAsicEthernetPHYReg( wphyid, 31, page  );
+		}
+#endif
+		if(mask != 0)
+		{
+			rtl8651_getAsicEthernetPHYReg( wphyid, reg, &data);
+			data = data&mask;
+		}
+		rtl8651_setAsicEthernetPHYReg( wphyid, reg, data|val  );
+
+
+		//switch to page 0
+		rtl8651_setAsicEthernetPHYReg( wphyid, 31, 0  );
+	}
+}
+
+#ifdef CONFIG_RTL8196C_REVISION_B
+
+#ifdef CONFIG_RTL8196C_ETH_IOT
+void set_gray_code_by_port(int port)
+{
+		uint32 val;
+
+		rtl8651_setAsicEthernetPHYReg( 4, 31, 1  );
+		rtl8651_getAsicEthernetPHYReg( 4, 20, &val  );
+		rtl8651_setAsicEthernetPHYReg( 4, 20, val + (0x1 << port)  );
+		rtl8651_setAsicEthernetPHYReg( 4, 31, 0  );
+
+		rtl8651_setAsicEthernetPHYReg( port, 31, 1  );
+		rtl8651_setAsicEthernetPHYReg( port, 19,  0x5400 );
+		if (port<4) rtl8651_setAsicEthernetPHYReg( port, 19,  0x5440 );
+		if (port<3) rtl8651_setAsicEthernetPHYReg( port, 19,  0x54c0 );
+		if (port<2) rtl8651_setAsicEthernetPHYReg( port, 19,  0x5480 );
+		if (port<1) rtl8651_setAsicEthernetPHYReg( port, 19,  0x5580 );
+		rtl8651_setAsicEthernetPHYReg( port, 31, 0  );
+
+		rtl8651_setAsicEthernetPHYReg( 4, 31, 1  );
+		rtl8651_setAsicEthernetPHYReg( 4, 20, 0xb20  );
+		rtl8651_setAsicEthernetPHYReg( 4, 31, 0  );
+}
+#endif
+
+void Setting_RTL8196C_PHY(void)
+{
+	int i, j;
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	/*
+	  #=========ADC Bias Current =========================
+	  #RG1X_P4~0 [12:10] = Reg_pi_fix [2:0], 5 ->7
+	  phywb all 1 17 12-10 0x7
+	*/
+	Set_GPHYWB(999, 1, 17, 0xffff-(7<<10), 0x7<<10);
+
+	/*
+	  #=========patch for eee============================
+	  #1. page4Breg24Glpi_rx_ti_timer_cnt change to f3
+	  phywb all 4 24 7-0 0xf3
+
+	  #2. page4Breg16Grg_txqt_ps_sel change to 1
+	  phywb all 4 16 3 1
+	*/
+	Set_GPHYWB(999, 4, 24, 0xff00, 0xf3);
+	Set_GPHYWB(999, 4, 16, 0xffff-(1<<3), 1<<3);
+	/*
+	  #=========patch for IOL Tx amp.=====================
+	  #<a>modify 100M DAC current default value:
+	  #Port#0~#4(per port control)
+	  #Page1,Reg19,bit[13:11]:
+	  #original value 200uA(3b'100),--> change to 205u(3b'000)   => change to 205u(3b010)
+
+	  phywb all 1 19 13-11 0x2
+
+	  #<b>modify bandgap voltage default value:
+	  #Port#0~#4 (Global all ports contorl setting),
+	  #Page1,Reg23,bit[8:6],
+
+	  #original value 1.312V(3b'110),-->change to 1.212V(3b'100).
+
+	  phywb all 1 23 8-6 0x4
+
+	  #<c>modify TX CS cap default value:
+	  #Port#0~#4 (Global all ports contorl setting),
+	  #Page1,Reg18,bit[5:3],
+
+	  #original value Reserved bits(3b'000),-->change to 600fF(3b'011). =>change to 750fF(3b'110)
+	  phywb all 1 18 5-3 0x6
+	*/
+
+	Set_GPHYWB(999, 1, 19, 0xffff-(7<<11), 0x2<<11);
+	Set_GPHYWB(999, 1, 23, 0xffff-(7<<6)  , 0x4<<6);
+	Set_GPHYWB(999, 1, 18, 0xffff-(7<<3), 0x6<<3);
+
+
+	/* 20100223 from Maxod: 100M half duplex enhancement */
+	REG32(MACCR)= (REG32(MACCR) & ~CF_RXIPG_MASK) | 0x05;
+
+	/* fix the link down / link up issue with SmartBit 3101B when DUT(8196c) set to Auto-negotiation
+	    and SmartBit force to 100M Full-duplex */
+	REG32(MACCR)= (REG32(MACCR) & ~SELIPG_MASK) | SELIPG_11;
+
+	/*20100222 from Anson:Switch Corner test pass setting*/
+	 /*
+		REG21 default=0x2c5
+		After snr_ub(page0 reg21.7-4) = 3 and snr_lb(page0 reg21.3-0)=2 ,REG21=0x232
+		REG22 default=0x5b85
+		After adtune_lb(page0 reg22.6-4)=4 (10uA) ,REG21=0x5b45
+
+		REG0 default=0x1100
+		restart AN
+		page0 reg0.9 =1 , ,REG0=0x1300
+	*/
+	//rtl8651_setAsicEthernetPHYReg( i, 0x15, 0x232 );
+	//Set_GPHYWB(999, 0, 21, 0xffff-(0xff<<0), 0x32<<0);
+	// test 96C to 96C restart AN 100 times, result is pass ==> page0 reg21.14(disable the equlizar)=1
+#ifdef CONFIG_RTL8196C_ETH_IOT
+	// enable "equalizer reset", i.e. page 0 , reg21, bit14= 0
+	Set_GPHYWB(999, 0, 21, (~0x40ff), 0x0032);
+#else
+	Set_GPHYWB(999, 0, 21, (~0x40ff), 0x4032);
+#endif
+
+	//rtl8651_setAsicEthernetPHYReg( i, 0x16, 0x5b45 );
+	//Set_GPHYWB(999, 0, 22, 0xffff-(7<<4), 0x4<<4);
+	Set_GPHYWB(999, 0, 22, 0xffff-(7<<4), 0x5<<4);
+	//rtl8651_setAsicEthernetPHYReg( i, 0x0, 0x1300 );
+	Set_GPHYWB(999, 0, 0, 0xffff-(1<<9), 0x1<<9);
+
+	/*20100225 from Anson:Switch Force cailibration
+	#change calibration update method for patch first pkt no update impedance
+	phywb all 1 29 1 0
+	#--------------Patch for impedance update fail cause rx crc error with long calbe--------
+	#Froce cailibration
+	phywb all 1 29 2 1
+	#Force impedance value = 0x8888
+	phywb all 1 28 15-0 0x8888
+	#-----------------------------------------------------------------------------------------
+	#Select clock (ckt125[4]) edge trigger mlt3[1:0] = negative for patch four corner fail issue(only tx timing)
+	phywb all 1 17 2-1 0x3
+	*/
+	//Set_GPHYWB(999, 1, 29, 0xffff-(1<<1), 0x0<<1);
+	//Set_GPHYWB(999, 1, 29, 0xffff-(1<<2), 0x1<<2);
+	//Set_GPHYWB(999, 1, 28, 0xffff-(0xffff), 0x8888);
+	Set_GPHYWB(999, 1, 17, 0xffff-(3<<1), 0x3<<1);
+
+	/*20100222 from Yozen:AOI TEST pass setting*/
+	Set_GPHYWB(999, 1, 18, 0xffff-(0xffff), 0x9004);
+
+	// for "DSP recovery fail when link partner = force 100F"
+	Set_GPHYWB(999, 4, 26, 0xffff-(0xfff<<4), 0xff8<<4);
+
+	// fix unlink IOT issue
+	Set_GPHYWB(999, 0, 26, 0xffff-(0x1<<14), 0x0<<14);
+	Set_GPHYWB(999, 0, 17, 0xffff-(0xf<<8), 0xe<<8);
+
+#ifdef CONFIG_RTL8196C_ETH_IOT
+		for(j=0; j<5; j++) {
+				set_gray_code_by_port(j);
+		}
+#endif
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+
+	printk("  Set 8196C PHY Patch OK\n");
+
+}
+#endif
+
+#ifdef CONFIG_RTL_8198
+static const unsigned int phy_para[]={
+	//###################### PHY parameter patch ################################
+	0x1f, 0x0005, //Page 5
+	0x13, 0x0003, //Page 5 ########## EMA =3#############
+	//0x01, 0x0700; #Page 5 Reg 1 = 0x0700, NEC ON	(20100112)
+	0x05,0x8B82,//Page 5 Reg 5 = 0x8B82, Fix 100M re-link fail issue (20100110)
+	0x06,0x05CB,//Page 5 Reg 6 = 0x05CB, Fix 100M re-link fail issue (20100110)
+	0x1f,0x0002,//Page 2
+	0x04,0x80C2,//Page 2 Reg 4 0x80C2, Fix 100M re-link fail issue (20100110)
+	0x05,0x0938,//Page 2 Reg 5 0x0938, Disable 10M standby mode (20100112)
+
+	0x1F,0x0003,//Page 3
+	0x12,0xC4D2,//Page 3 Reg 18 = 0xC4D2, GAIN upper bond=24
+	0x0D,0x0207,//Page 3 Reg 13 = 0x0207 (20100112)
+	0x01,0x3554, //#Page 3 Reg  1 = 0x3554 (20100423)
+	0x02,0x63E8, //#Page 3 Reg  2 = 0x63E8 (20100423)
+	0x03,0x99C2, //#Page 3 Reg  3 = 0x99C2 (20100423)
+	0x04,0x0113, //#Page 3 Reg  4 = 0x0113 (20100423)
+
+	0x1f,0x0001,//Page 1
+	0x07,0x267E,//Page 1 Reg  7 = 0x267E, Channel Gain offset (20100111)
+	0x1C,0xE5F7,//Page 1 Reg 28 = 0xE5F7, Cable length offset (20100111)
+	0x1B,0x0424,//Page 1 Reg 27 = 0x0424, SD threshold (20100111)
+
+	//#Add by Gary for Channel Estimation fine tune 20100430
+	//0x1f,0x0002, //# change to Page 1 (Global)
+	//0x08,0x0574, //# Page1 Reg8 (CG_INITIAL_MASTER)
+	//0x09,0x2724, //# Page1 Reg9 (CB0_INITIAL_GIGA)
+	//0x1f,0x0003, //# change to Page 3 (Global)
+	//0x1a,0x06f6, //# Page3 Reg26 (CG_INITIAL_SLAVE)
+
+	//#Add by Gary for Channel Estimation fine tune 20100430
+	//#Page1 Reg8 (CG_INITIAL_MASTER)
+	//0x1f, 0x0005,
+	//0x05, 0x83dd,
+	//0x06, 0x0574,
+	//#Page1 Reg9 (CB0_INITIAL_GIGA)
+	//0x1f, 0x0005,
+	//0x05, 0x83e0,
+	//0x06, 0x2724,
+	//#Page3 Reg26 (CG_INITIAL_SLAVE)
+	//0x1f, 0x0005,
+	//0x05, 0x843d,
+	//0x06, 0x06f6 ,
+
+	//#NC FIFO
+	0x1f,0x0007,//ExtPage
+	0x1e,0x0042,//ExtPage 66
+	0x18,0x0000,//Page 66 Reg 24 = 0x0000, NC FIFO (20100111)
+	0x1e,0x002D,//ExtPage 45
+	0x18,0xF010,//Page 45 Reg 24 = 0xF010, Enable Giga Down Shift to 100M (20100118)
+
+	0x1e,0x002c, //#ExtPage 44
+	0x18,0x008B, //#Page 44 Reg 24 = 0x008B, Enable deglitch circuit (20100426)
+
+	//############################ EEE giga patch ################################
+
+	//0x1f 0x0007;
+	0x1e,0x0028,
+	0x16,0xf640,//phywb $phyID 40 22 15-0 0xF640
+
+	0x1e,0x0021,
+	0x19,0x2929,//phywb $phyID 33 25 15-0 0x2929
+
+	0x1a,0x1005,//phywb $phyID 33 26 15-0 0x1005
+
+	0x1e,0x0020,
+	0x17,0x000a,//phywb $phyID 32 23 15-0 0x000a
+
+	0x1b,0x2f4a,//Disable EEE PHY mode
+	0x15,0x0100,//EEE ability, Disable EEEP
+
+	0x1e,0x0040,//
+	0x1a,0x5110,//	phywb $phyID 64 26 15-0 0x5110
+	0x18,0x0000,// programable mode
+
+	0x1e,0x0041,//
+	0x15,0x0e02,//phywb $phyID 65 21 15-0 0x0e02
+
+	0x16,0x2185,//phywb $phyID 65 22 15-0 0x2185
+	0x17,0x000c,//phywb $phyID 65 23 15-0 0x000c
+	0x1c,0x0008,//phywb $phyID 65 28 15-0 0x0008
+	0x1e,0x0042,//
+	0x15,0x0d00,//phywb $phyID 66 21 15-0 0x0d00
+
+	#if 1
+	//############################ EEE Run code patch #################################
+	//###proc 67R_ram_code_20100211_inrx_uc_98_1
+	//###proc ram_code_0223_uc {} {
+	//#replace 0xfff6, lock uc ram code version!
+	31, 0x5,
+	5,  0xfff6,
+	6,  0x0080,
+	5,  0x8b6e,
+	6,  0x0000,
+	15, 0x0100,
+
+	//### force MDI/MDIX
+	0x1f, 0x0007,
+	0x1e, 0x002d,
+	0x18, 0xf030,
+
+	//### pcs nctl patch code (0423)
+	0x1f, 0x0007,
+	0x1e, 0x0023,
+	0x16, 0x0005,
+
+	//### startpoint
+	 0x15, 0x005c,
+	0x19, 0x0068,
+	0x15, 0x0082,
+	0x19, 0x000a,
+	0x15, 0x00a1,
+	0x19, 0x0081,
+	0x15 ,0x00af,
+	0x19, 0x0080,
+	0x15, 0x00d4,
+	0x19, 0x0000,
+	0x15, 0x00e4,
+	0x19, 0x0081,
+	0x15, 0x00e7,
+	0x19, 0x0080,
+	0x15, 0x010d,
+	0x19, 0x0083,
+	0x15, 0x0118,
+	0x19, 0x0083,
+	0x15, 0x0120,
+	0x19, 0x0082,
+	0x15, 0x019c,
+	0x19, 0x0081,
+	0x15, 0x01a4,
+	0x19, 0x0080,
+	0x15, 0x01cd,
+	0x19, 0x0000,
+	0x15, 0x01dd,
+	0x19, 0x0081,
+	0x15, 0x01e0,
+	0x19, 0x0080,
+	//### endpoint
+
+	0x16, 0x0000,
+	//### end of pcs nctl patch code
+
+	//inrx
+	0x1f, 0x0007,
+	0x1e, 0x0040,
+	0x18, 0x0004,
+	0x1f,0x0000,
+	0x17,0x2160,
+	0x1f,0x0007,
+	0x1e,0x0040,
+
+	//### startpoint
+	0x18,0x0004,
+	0x19,0x4000,
+	0x18,0x0014,
+	0x19,0x7f00,
+	0x18,0x0024,
+	0x19,0x0000,
+	0x18,0x0034,
+	0x19,0x0100,
+	0x18,0x0044,
+	0x19,0xe000,
+	0x18,0x0054,
+	0x19,0x0000,
+	0x18,0x0064,
+	0x19,0x0000,
+	0x18,0x0074,
+	0x19,0x0000,
+	0x18,0x0084,
+	0x19,0x0400,
+	0x18,0x0094,
+	0x19,0x8000,
+	0x18,0x00a4,
+	0x19,0x7f00,
+	0x18,0x00b4,
+	0x19,0x4000,
+	0x18,0x00c4,
+	0x19,0x2000,
+	0x18,0x00d4,
+	0x19,0x0100,
+	0x18,0x00e4,
+	0x19,0x8400,
+	0x18,0x00f4,
+	0x19,0x7a00,
+	0x18,0x0104,
+	0x19,0x4000,
+	0x18,0x0114,
+	0x19,0x3f00,
+	0x18,0x0124,
+	0x19,0x0100,
+	0x18,0x0134,
+	0x19,0x7800,
+	0x18,0x0144,
+	0x19,0x0000,
+	0x18,0x0154,
+	0x19,0x0000,
+	0x18,0x0164,
+	0x19,0x0000,
+	0x18,0x0174,
+	0x19,0x0400,
+	0x18,0x0184,
+	0x19,0x8000,
+	0x18,0x0194,
+	0x19,0x7f00,
+	0x18,0x01a4,
+	0x19,0x8300,
+	0x18,0x01b4,
+	0x19,0x8300,
+	0x18,0x01c4,
+	0x19,0xe200,
+	0x18,0x01d4,
+	0x19,0x0a00,
+	0x18,0x01e4,
+	0x19,0x8800,
+	0x18,0x01f4,
+	0x19,0x0300,
+	0x18,0x0204,
+	0x19,0xe100,
+	0x18,0x0214,
+	0x19,0x4600,
+	0x18,0x0224,
+	0x19,0x4000,
+	0x18,0x0234,
+	0x19,0x7f00,
+	0x18,0x0244,
+	0x19,0x0000,
+	0x18,0x0254,
+	0x19,0x0100,
+	0x18,0x0264,
+	0x19,0x4000,
+	0x18,0x0274,
+	0x19,0x3e00,
+	0x18,0x0284,
+	0x19,0x0000,
+	0x18,0x0294,
+	0x19,0xe000,
+	0x18,0x02a4,
+	0x19,0x1200,
+	0x18,0x02b4,
+	0x19,0x8000,
+	0x18,0x02c4,
+	0x19,0x7f00,
+	0x18,0x02d4,
+	0x19,0x8900,
+	0x18,0x02e4,
+	0x19,0x8300,
+	0x18,0x02f4,
+	0x19,0xe000,
+	0x18,0x0304,
+	0x19,0x0000,
+	0x18,0x0314,
+	0x19,0x4000,
+	0x18,0x0324,
+	0x19,0x7f00,
+	0x18,0x0334,
+	0x19,0x0000,
+	0x18,0x0344,
+	0x19,0x2000,
+	0x18,0x0354,
+	0x19,0x4000,
+	0x18,0x0364,
+	0x19,0x3e00,
+	0x18,0x0374,
+	0x19,0xfd00,
+	0x18,0x0384,
+	0x19,0x0000,
+	0x18,0x0394,
+	0x19,0x1200,
+	0x18,0x03a4,
+	0x19,0xab00,
+	0x18,0x03b4,
+	0x19,0x0c00,
+	0x18,0x03c4,
+	0x19,0x0600,
+	0x18,0x03d4,
+	0x19,0xa000,
+	0x18,0x03e4,
+	0x19,0x3d00,
+	0x18,0x03f4,
+	0x19,0xfb00,
+	0x18,0x0404,
+	0x19,0xe000,
+	0x18,0x0414,
+	0x19,0x0000,
+	0x18,0x0424,
+	0x19,0x4000,
+	0x18,0x0434,
+	0x19,0x7f00,
+	0x18,0x0444,
+	0x19,0x0000,
+	0x18,0x0454,
+	0x19,0x0100,
+	0x18,0x0464,
+	0x19,0x4000,
+	0x18,0x0474,
+	0x19,0xc600,
+	0x18,0x0484,
+	0x19,0xff00,
+	0x18,0x0494,
+	0x19,0x0000,
+	0x18,0x04a4,
+	0x19,0x1000,
+	0x18,0x04b4,
+	0x19,0x0200,
+	0x18,0x04c4,
+	0x19,0x7f00,
+	0x18,0x04d4,
+	0x19,0x4000,
+	0x18,0x04e4,
+	0x19,0x7f00,
+	0x18,0x04f4,
+	0x19,0x0200,
+	0x18,0x0504,
+	0x19,0x0200,
+	0x18,0x0514,
+	0x19,0x5200,
+	0x18,0x0524,
+	0x19,0xc400,
+	0x18,0x0534,
+	0x19,0x7400,
+	0x18,0x0544,
+	0x19,0x0000,
+	0x18,0x0554,
+	0x19,0x1000,
+	0x18,0x0564,
+	0x19,0xbc00,
+	0x18,0x0574,
+	0x19,0x0600,
+	0x18,0x0584,
+	0x19,0xfe00,
+	0x18,0x0594,
+	0x19,0x4000,
+	0x18,0x05a4,
+	0x19,0x7f00,
+	0x18,0x05b4,
+	0x19,0x0000,
+	0x18,0x05c4,
+	0x19,0x0a00,
+	0x18,0x05d4,
+	0x19,0x5200,
+	0x18,0x05e4,
+	0x19,0xe400,
+	0x18,0x05f4,
+	0x19,0x3c00,
+	0x18,0x0604,
+	0x19,0x0000,
+	0x18,0x0614,
+	0x19,0x1000,
+	0x18,0x0624,
+	0x19,0x8a00,
+	0x18,0x0634,
+	0x19,0x7f00,
+	0x18,0x0644,
+	0x19,0x4000,
+	0x18,0x0654,
+	0x19,0x7f00,
+	0x18,0x0664,
+	0x19,0x0100,
+	0x18,0x0674,
+	0x19,0x2000,
+	0x18,0x0684,
+	0x19,0x0000,
+	0x18,0x0694,
+	//### 0x2219:0x4600 =>0xe600 #0309
+	0x19,0xe600,
+	0x18,0x06a4,
+	//### 0x2219:0xfc00 =>0xff00 #0309
+	0x19,0xff00,
+	0x18,0x06b4,
+	0x19,0x0000,
+	0x18,0x06c4,
+	0x19,0x5000,
+	0x18,0x06d4,
+	0x19,0x9d00,
+	0x18,0x06e4,
+	0x19,0xff00,
+	0x18,0x06f4,
+	0x19,0x4000,
+	0x18,0x0704,
+	0x19,0x7f00,
+	0x18,0x0714,
+	0x19,0x0000,
+	0x18,0x0724,
+	0x19,0x2000,
+	0x18,0x0734,
+	0x19,0x0000,
+	0x18,0x0744,
+	0x19,0xe600,
+	0x18,0x0754,
+	0x19,0xff00,
+	0x18,0x0764,
+	0x19,0x0000,
+	0x18,0x0774,
+	0x19,0x5000,
+	0x18,0x0784,
+	0x19,0x8500,
+	0x18,0x0794,
+	0x19,0x7f00,
+	0x18,0x07a4,
+	0x19,0xac00,
+	0x18,0x07b4,
+	0x19,0x0800,
+	0x18,0x07c4,
+	0x19,0xfc00,
+	0x18,0x07d4,
+	0x19,0x4000,
+	0x18,0x07e4,
+	0x19,0x7f00,
+	0x18,0x07f4,
+	0x19,0x0400,
+	0x18,0x0804,
+	0x19,0x0200,
+	0x18,0x0814,
+	0x19,0x0000,
+	0x18,0x0824,
+	0x19,0xff00,
+	0x18,0x0834,
+	0x19,0x7f00,
+	0x18,0x0844,
+	0x19,0x0000,
+	0x18,0x0854,
+	0x19,0x4200,
+	0x18,0x0864,
+	0x19,0x0500,
+	0x18,0x0874,
+	0x19,0x9000,
+	0x18,0x0884,
+	0x19,0x8000,
+	0x18,0x0894,
+	0x19,0x7d00,
+	0x18,0x08a4,
+	0x19,0x8c00,
+	0x18,0x08b4,
+	0x19,0x8300,
+	0x18,0x08c4,
+	0x19,0xe000,
+	0x18,0x08d4,
+	0x19,0x0000,
+	0x18,0x08e4,
+	0x19,0x4000,
+	0x18,0x08f4,
+	0x19,0x0400,
+	0x18,0x0904,
+	0x19,0xff00,
+	0x18,0x0914,
+	0x19,0x0500,
+	0x18,0x0924,
+	0x19,0x8500,
+	0x18,0x0934,
+	0x19,0x8c00,
+	0x18,0x0944,
+	0x19,0xfa00,
+	0x18,0x0954,
+	0x19,0xe000,
+	0x18,0x0964,
+	0x19,0x0000,
+	0x18,0x0974,
+	0x19,0x4000,
+	0x18,0x0984,
+	0x19,0x5f00,
+	0x18,0x0994,
+	0x19,0x0400,
+	0x18,0x09a4,
+	0x19,0x0000,
+	0x18,0x09b4,
+	0x19,0xfe00,
+	0x18,0x09c4,
+	0x19,0x7300,
+	0x18,0x09d4,
+	0x19,0x0d00,
+	0x18,0x09e4,
+	0x19,0x0300,
+	0x18,0x09f4,
+	0x19,0x4000,
+	0x18,0x0a04,
+	0x19,0x2000,
+	0x18,0x0a14,
+	0x19,0x0000,
+	0x18,0x0a24,
+	0x19,0x0400,
+	0x18,0x0a34,
+	0x19,0xda00,
+	0x18,0x0a44,
+	0x19,0x0600,
+	0x18,0x0a54,
+	0x19,0x7d00,
+	0x18,0x0a64,
+	0x19,0x4000,
+	0x18,0x0a74,
+	0x19,0x5f00,
+	0x18,0x0a84,
+	0x19,0x0400,
+	0x18,0x0a94,
+	0x19,0x0000,
+	0x18,0x0aa4,
+	0x19,0x0000,
+	0x18,0x0ab4,
+	0x19,0x7300,
+	0x18,0x0ac4,
+	0x19,0x0d00,
+	0x18,0x0ad4,
+	0x19,0x0300,
+	0x18,0x0ae4,
+	0x19,0x0400,
+	0x18,0x0af4,
+	0x19,0xce00,
+	0x18,0x0b04,
+	0x19,0x0900,
+	0x18,0x0b14,
+	0x19,0x9d00,
+	0x18,0x0b24,
+	0x19,0x0800,
+	0x18,0x0b34,
+	0x19,0x9000,
+	0x18,0x0b44,
+	0x19,0x0700,
+	0x18,0x0b54,
+	0x19,0x7900,
+	0x18,0x0b64,
+	0x19,0x4000,
+	0x18,0x0b74,
+	0x19,0x7f00,
+	0x18,0x0b84,
+	0x19,0x0400,
+	0x18,0x0b94,
+	0x19,0x0000,
+	0x18,0x0ba4,
+	0x19,0x0000,
+	0x18,0x0bb4,
+	0x19,0x0400,
+	0x18,0x0bc4,
+	0x19,0x7300,
+	0x18,0x0bd4,
+	0x19,0x0d00,
+	0x18,0x0be4,
+	0x19,0x0100,
+	0x18,0x0bf4,
+	0x19,0x0900,
+	0x18,0x0c04,
+	0x19,0x8e00,
+	0x18,0x0c14,
+	0x19,0x0800,
+	0x18,0x0c24,
+	0x19,0x7d00,
+	0x18,0x0c34,
+	0x19,0x4000,
+	0x18,0x0c44,
+	0x19,0x7f00,
+	0x18,0x0c54,
+	0x19,0x0000,
+	0x18,0x0c64,
+	0x19,0x0000,
+	0x18,0x0c74,
+	0x19,0x0200,
+	0x18,0x0c84,
+	0x19,0x0000,
+	0x18,0x0c94,
+	0x19,0x7000,
+	0x18,0x0ca4,
+	0x19,0x0c00,
+	0x18,0x0cb4,
+	0x19,0x0100,
+	0x18,0x0cc4,
+	0x19,0x0900,
+	0x18,0x0cd4,
+	0x19,0x7f00,
+	0x18,0x0ce4,
+	0x19,0x4000,
+	0x18,0x0cf4,
+	0x19,0x7f00,
+	0x18,0x0d04,
+	0x19,0x3400,
+	0x18,0x0d14,
+	0x19,0x8300,
+	0x18,0x0d24,
+	0x19,0x8200,
+	0x18,0x0d34,
+	0x19,0x0000,
+	0x18,0x0d44,
+	0x19,0x7000,
+	0x18,0x0d54,
+	0x19,0x0d00,
+	0x18,0x0d64,
+	0x19,0x0100,
+	0x18,0x0d74,
+	0x19,0x0f00,
+	0x18,0x0d84,
+	0x19,0x7f00,
+	0x18,0x0d94,
+	0x19,0x9a00,
+	0x18,0x0da4,
+	0x19,0x7d00,
+	0x18,0x0db4,
+	0x19,0x4000,
+	0x18,0x0dc4,
+	0x19,0x7f00,
+	0x18,0x0dd4,
+	0x19,0x1400,
+	0x18,0x0de4,
+	0x19,0x0000,
+	0x18,0x0df4,
+	0x19,0x8200,
+	0x18,0x0e04,
+	0x19,0x0000,
+	0x18,0x0e14,
+	0x19,0x7000,
+	0x18,0x0e24,
+	0x19,0x0f00,
+	0x18,0x0e34,
+	0x19,0x0100,
+	0x18,0x0e44,
+	0x19,0x9b00,
+	0x18,0x0e54,
+	0x19,0x7f00,
+	0x18,0x0e64,
+	0x19,0x4000,
+	0x18,0x0e74,
+	0x19,0x1f00,
+	0x18,0x0e84,
+	0x19,0x0200,
+	0x18,0x0e94,
+	0x19,0x0600,
+	0x18,0x0ea4,
+	0x19,0x7100,
+	0x18,0x0eb4,
+	0x19,0x1d00,
+	0x18,0x0ec4,
+	0x19,0x0100,
+	0x18,0x0ed4,
+	0x19,0x4000,
+	0x18,0x0ee4,
+	0x19,0x1f00,
+	0x18,0x0ef4,
+	0x19,0x0200,
+	0x18,0x0f04,
+	0x19,0x0600,
+	0x18,0x0f14,
+	0x19,0x7100,
+	0x18,0x0f24,
+	0x19,0x0d00,
+	0x18,0x0f34,
+	0x19,0x0100,
+	0x18,0x0f44,
+	0x19,0x4000,
+	0x18,0x0f54,
+	0x19,0x1f00,
+	0x18,0x0f64,
+	0x19,0x0200,
+	0x18,0x0f74,
+	0x19,0x0600,
+	0x18,0x0f84,
+	0x19,0x7100,
+	0x18,0x0f94,
+	0x19,0x0d00,
+	0x18,0x0fa4,
+	0x19,0x0100,
+	0x18,0x0fb4,
+	0x19,0x4000,
+	0x18,0x0fc4,
+	0x19,0x1f00,
+	0x18,0x0fd4,
+	0x19,0x0200,
+	0x18,0x0fe4,
+	0x19,0x0600,
+	0x18,0x0ff4,
+	0x19,0x7100,
+	0x18,0x1004,
+	0x19,0x0d00,
+	0x18,0x1014,
+	0x19,0x0100,
+	0x18,0x1024,
+	0x19,0x4000,
+	0x18,0x1034,
+	0x19,0x1f00,
+	0x18,0x1044,
+	0x19,0x0200,
+	0x18,0x1054,
+	0x19,0x0600,
+	0x18,0x1064,
+	0x19,0x7100,
+	0x18,0x1074,
+	0x19,0x0d00,
+	0x18,0x1084,
+	0x19,0x0100,
+	0x18,0x1094,
+	0x19,0x4000,
+	0x18,0x10a4,
+	0x19,0x1f00,
+	0x18,0x10b4,
+	0x19,0x0200,
+	0x18,0x10c4,
+	0x19,0x0600,
+	0x18,0x10d4,
+	0x19,0x7100,
+	0x18,0x10e4,
+	0x19,0x0d00,
+	0x18,0x10f4,
+	0x19,0x0100,
+	0x18,0x1104,
+	0x19,0x4000,
+	0x18,0x1114,
+	0x19,0x7f00,
+	0x18,0x1124,
+	0x19,0x0400,
+	0x18,0x1134,
+	0x19,0x9000,
+	0x18,0x1144,
+	0x19,0x0200,
+	0x18,0x1154,
+	0x19,0x0600,
+	0x18,0x1164,
+	0x19,0x7300,
+	0x18,0x1174,
+	0x19,0x0d00,
+	0x18,0x1184,
+	0x19,0x0100,
+	0x18,0x1194,
+	0x19,0x0b00,
+	0x18,0x11a4,
+	0x19,0x9500,
+	0x18,0x11b4,
+	0x19,0x9400,
+	0x18,0x11c4,
+	0x19,0x0400,
+	0x18,0x11d4,
+	0x19,0x4000,
+	0x18,0x11e4,
+	0x19,0x4000,
+	0x18,0x11f4,
+	0x19,0x0500,
+	0x18,0x1204,
+	0x19,0x8000,
+	0x18,0x1214,
+	0x19,0x7800,
+	0x18,0x1224,
+	0x19,0x4000,
+	0x18,0x1234,
+	0x19,0x7f00,
+	0x18,0x1244,
+	0x19,0x0400,
+	0x18,0x1254,
+	0x19,0x0000,
+	0x18,0x1264,
+	0x19,0x0200,
+	0x18,0x1274,
+	0x19,0x0000,
+	0x18,0x1284,
+	0x19,0x7000,
+	0x18,0x1294,
+	0x19,0x0f00,
+	0x18,0x12a4,
+	0x19,0x0100,
+	0x18,0x12b4,
+	0x19,0x9b00,
+	0x18,0x12c4,
+	0x19,0x7f00,
+	0x18,0x12d4,
+	0x19,0xe100,
+	0x18,0x12e4,
+	0x19,0x1000,
+	0x18,0x12f4,
+	0x19,0x4000,
+	0x18,0x1304,
+	0x19,0x7f00,
+	0x18,0x1314,
+	0x19,0x0500,
+	0x18,0x1324,
+	0x19,0x0000,
+	0x18,0x1334,
+	0x19,0x0000,
+	0x18,0x1344,
+	0x19,0x0600,
+	0x18,0x1354,
+	0x19,0x7300,
+	0x18,0x1364,
+	0x19,0x0d00,
+	0x18,0x1374,
+	0x19,0x0100,
+	0x18,0x1384,
+	0x19,0x0400,
+	0x18,0x1394,
+	0x19,0x0600,
+	0x18,0x13a4,
+	0x19,0x4000,
+	0x18,0x13b4,
+	0x19,0x4000,
+	0x18,0x13c4,
+	0x19,0x0400,
+	0x18,0x13d4,
+	0x19,0xe000,
+	0x18,0x13e4,
+	0x19,0x7d00,
+	0x18,0x13f4,
+	0x19,0x0500,
+	0x18,0x1404,
+	0x19,0x7800,
+	0x18,0x1414,
+	0x19,0x4000,
+	0x18,0x1424,
+	0x19,0x4000,
+	0x18,0x1434,
+	0x19,0x0400,
+	0x18,0x1444,
+	0x19,0xe000,
+	0x18,0x1454,
+	0x19,0x9700,
+	0x18,0x1464,
+	0x19,0x4000,
+	0x18,0x1474,
+	0x19,0x7f00,
+	0x18,0x1484,
+	0x19,0x0000,
+	0x18,0x1494,
+	0x19,0x0100,
+	0x18,0x14a4,
+	0x19,0x4400,
+	0x18,0x14b4,
+	0x19,0x0000,
+	0x18,0x14c4,
+	0x19,0x0000,
+	0x18,0x14d4,
+	0x19,0x0000,
+	0x18,0x14e4,
+	0x19,0x4000,
+	0x18,0x14f4,
+	0x19,0x8000,
+	0x18,0x1504,
+	0x19,0x7f00,
+	0x18,0x1514,
+	0x19,0x4000,
+	0x18,0x1524,
+	0x19,0x3f00,
+	0x18,0x1534,
+	0x19,0x0400,
+	0x18,0x1544,
+	0x19,0x5000,
+	0x18,0x1554,
+	0x19,0xf800,
+	0x18,0x1564,
+	0x19,0x0000,
+	0x18,0x1574,
+	0x19,0xe000,
+	0x18,0x1584,
+	0x19,0x4000,
+	0x18,0x1594,
+	0x19,0x8000,
+	0x18,0x15a4,
+	0x19,0x7f00,
+	0x18,0x15b4,
+	0x19,0x8900,
+	0x18,0x15c4,
+	0x19,0x8300,
+	0x18,0x15d4,
+	0x19,0xe000,
+	0x18,0x15e4,
+	0x19,0x0000,
+	0x18,0x15f4,
+	0x19,0x4000,
+	0x18,0x1604,
+	0x19,0x7f00,
+	0x18,0x1614,
+	0x19,0x0200,
+	0x18,0x1624,
+	0x19,0x1000,
+	0x18,0x1634,
+	0x19,0x0000,
+	0x18,0x1644,
+	0x19,0xfc00,
+	0x18,0x1654,
+	0x19,0xfd00,
+	0x18,0x1664,
+	0x19,0x0000,
+	0x18,0x1674,
+	0x19,0x4000,
+	0x18,0x1684,
+	0x19,0xbc00,
+	0x18,0x1694,
+	0x19,0x0e00,
+	0x18,0x16a4,
+	0x19,0xfe00,
+	0x18,0x16b4,
+	0x19,0x8a00,
+	0x18,0x16c4,
+	0x19,0x8300,
+	0x18,0x16d4,
+	0x19,0xe000,
+	0x18,0x16e4,
+	0x19,0x0000,
+	0x18,0x16f4,
+	0x19,0x4000,
+	0x18,0x1704,
+	0x19,0x7f00,
+	0x18,0x1714,
+	0x19,0x0100,
+	0x18,0x1724,
+	0x19,0xff00,
+	0x18,0x1734,
+	0x19,0x0000,
+	0x18,0x1744,
+	//### 0x2219 : 0xfc00 ##0309
+	0x19,0xfc00,
+	0x18,0x1754,
+	//### 0x2219 : 0xff00 ##0309
+	0x19,0xff00,
+	0x18,0x1764,
+	0x19,0x0000,
+	0x18,0x1774,
+	0x19,0x4000,
+	0x18,0x1784,
+	0x19,0x9d00,
+	0x18,0x1794,
+	0x19,0xff00,
+	0x18,0x17a4,
+	0x19,0x4000,
+	0x18,0x17b4,
+	0x19,0x7f00,
+	0x18,0x17c4,
+	0x19,0x0000,
+	0x18,0x17d4,
+	0x19,0xff00,
+	0x18,0x17e4,
+	0x19,0x0000,
+	0x18,0x17f4,
+	0x19,0xfc00,
+	0x18,0x1804,
+	0x19,0xff00,
+	0x18,0x1814,
+	0x19,0x0000,
+	0x18,0x1824,
+	0x19,0x4000,
+	0x18,0x1834,
+	0x19,0x8900,
+	0x18,0x1844,
+	0x19,0x8300,
+	0x18,0x1854,
+	0x19,0xe000,
+	0x18,0x1864,
+	0x19,0x0000,
+	0x18,0x1874,
+	0x19,0xac00,
+	0x18,0x1884,
+	0x19,0x0800,
+	0x18,0x1894,
+	0x19,0xfa00,
+	0x18,0x18a4,
+	0x19,0x4000,
+	0x18,0x18b4,
+	0x19,0x7f00,
+	0x18,0x18c4,
+	0x19,0x0400,
+	0x18,0x18d4,
+	0x19,0x0200,
+	0x18,0x18e4,
+	0x19,0x0000,
+	0x18,0x18f4,
+	0x19,0xfd00,
+	0x18,0x1904,
+	0x19,0x7f00,
+	0x18,0x1914,
+	0x19,0x0000,
+	0x18,0x1924,
+	0x19,0x4000,
+	0x18,0x1934,
+	0x19,0x0500,
+	0x18,0x1944,
+	0x19,0x9000,
+	0x18,0x1954,
+	0x19,0x8000,
+	0x18,0x1964,
+	0x19,0x7d00,
+	0x18,0x1974,
+	0x19,0x8c00,
+	0x18,0x1984,
+	0x19,0x8300,
+	0x18,0x1994,
+	0x19,0xe000,
+	0x18,0x19a4,
+	0x19,0x0000,
+	0x18,0x19b4,
+	0x19,0x4000,
+	0x18,0x19c4,
+	0x19,0x0400,
+	0x18,0x19d4,
+	0x19,0xff00,
+	0x18,0x19e4,
+	0x19,0x0500,
+	0x18,0x19f4,
+	0x19,0x8500,
+	0x18,0x1a04,
+	0x19,0x8c00,
+	0x18,0x1a14,
+	0x19,0xfa00,
+	0x18,0x1a24,
+	0x19,0xe000,
+	0x18,0x1a34,
+	0x19,0x0000,
+	0x18,0x1a44,
+	0x19,0x4000,
+	0x18,0x1a54,
+	0x19,0x5f00,
+	0x18,0x1a64,
+	0x19,0x0400,
+	0x18,0x1a74,
+	0x19,0x0000,
+	0x18,0x1a84,
+	0x19,0xfc00,
+	0x18,0x1a94,
+	0x19,0x7300,
+	0x18,0x1aa4,
+	0x19,0x0d00,
+	0x18,0x1ab4,
+	0x19,0x0100,
+	0x18,0x1ac4,
+	0x19,0x4000,
+	0x18,0x1ad4,
+	0x19,0x2000,
+	0x18,0x1ae4,
+	0x19,0x0000,
+	0x18,0x1af4,
+	0x19,0x0400,
+	0x18,0x1b04,
+	0x19,0xda00,
+	0x18,0x1b14,
+	0x19,0x0600,
+	0x18,0x1b24,
+	0x19,0x7d00,
+	0x18,0x1b34,
+	0x19,0x4000,
+	0x18,0x1b44,
+	0x19,0x5f00,
+	0x18,0x1b54,
+	0x19,0x0400,
+	0x18,0x1b64,
+	0x19,0x0000,
+	0x18,0x1b74,
+	0x19,0x0000,
+	0x18,0x1b84,
+	0x19,0x7300,
+	0x18,0x1b94,
+	0x19,0x0d00,
+	0x18,0x1ba4,
+	0x19,0x0100,
+	0x18,0x1bb4,
+	0x19,0x0400,
+	0x18,0x1bc4,
+	0x19,0xce00,
+	0x18,0x1bd4,
+	0x19,0x0800,
+	0x18,0x1be4,
+	0x19,0x9200,
+	0x18,0x1bf4,
+	0x19,0x0900,
+	0x18,0x1c04,
+	0x19,0x9b00,
+	0x18,0x1c14,
+	0x19,0x0700,
+	0x18,0x1c24,
+	0x19,0x7900,
+	0x18,0x1c34,
+	0x19,0x4000,
+	0x18,0x1c44,
+	0x19,0x7f00,
+	0x18,0x1c54,
+	0x19,0x0400,
+	0x18,0x1c64,
+	0x19,0x0000,
+	0x18,0x1c74,
+	0x19,0x0000,
+	0x18,0x1c84,
+	0x19,0x0400,
+	0x18,0x1c94,
+	0x19,0x7300,
+	0x18,0x1ca4,
+	0x19,0x0d00,
+	0x18,0x1cb4,
+	0x19,0x0100,
+	0x18,0x1cc4,
+	0x19,0x0900,
+	0x18,0x1cd4,
+	0x19,0x8e00,
+	0x18,0x1ce4,
+	0x19,0x0800,
+	0x18,0x1cf4,
+	0x19,0x7d00,
+	0x18,0x1d04,
+	0x19,0x4000,
+	0x18,0x1d14,
+	0x19,0x7f00,
+	0x18,0x1d24,
+	0x19,0x0000,
+	0x18,0x1d34,
+	0x19,0x0000,
+	0x18,0x1d44,
+	0x19,0x0000,
+	0x18,0x1d54,
+	0x19,0x0000,
+	0x18,0x1d64,
+	0x19,0x7000,
+	0x18,0x1d74,
+	0x19,0x0c00,
+	0x18,0x1d84,
+	0x19,0x0100,
+	0x18,0x1d94,
+	0x19,0x0900,
+	0x18,0x1da4,
+	0x19,0x7f00,
+	0x18,0x1db4,
+	0x19,0x4000,
+	0x18,0x1dc4,
+	0x19,0x7f00,
+	0x18,0x1dd4,
+	0x19,0x0400,
+	0x18,0x1de4,
+	0x19,0x0000,
+	0x18,0x1df4,
+	0x19,0x0000,
+	0x18,0x1e04,
+	0x19,0x0000,
+	0x18,0x1e14,
+	0x19,0x7000,
+	0x18,0x1e24,
+	0x19,0x0d00,
+	0x18,0x1e34,
+	0x19,0x0100,
+	0x18,0x1e44,
+	0x19,0x0b00,
+	0x18,0x1e54,
+	0x19,0x7f00,
+	0x18,0x1e64,
+	0x19,0x9a00,
+	0x18,0x1e74,
+	0x19,0x7f00,
+	0x18,0x1e84,
+	0x19,0x4000,
+	0x18,0x1e94,
+	0x19,0x7f00,
+	0x18,0x1ea4,
+	0x19,0x0400,
+	0x18,0x1eb4,
+	0x19,0x0000,
+	0x18,0x1ec4,
+	0x19,0x0000,
+	0x18,0x1ed4,
+	0x19,0x0000,
+	0x18,0x1ee4,
+	0x19,0x7100,
+	0x18,0x1ef4,
+	0x19,0x0d00,
+	0x18,0x1f04,
+	0x19,0x0100,
+	0x18,0x1f14,
+	0x19,0x9400,
+	0x18,0x1f24,
+	0x19,0x7f00,
+	0x18,0x1f34,
+	0x19,0x4000,
+	0x18,0x1f44,
+	0x19,0x7f00,
+	0x18,0x1f54,
+	0x19,0x0500,
+	0x18,0x1f64,
+	0x19,0x0000,
+	0x18,0x1f74,
+	0x19,0x0000,
+	0x18,0x1f84,
+	0x19,0x0000,
+	0x18,0x1f94,
+	0x19,0x7300,
+	0x18,0x1fa4,
+	0x19,0x0d00,
+	0x18,0x1fb4,
+	0x19,0x0100,
+	0x18,0x1fc4,
+	0x19,0x0500,
+	0x18,0x1fd4,
+	0x19,0x8800,
+	0x18,0x1fe4,
+	0x19,0x0400,
+	0x18,0x1ff4,
+	0x19,0x7d00,
+	0x18,0x2004,
+	0x19,0x4000,
+	0x18,0x2014,
+	0x19,0x4000,
+	0x18,0x2024,
+	0x19,0x0400,
+	0x18,0x2034,
+	0x19,0xe100,
+	0x18,0x2044,
+	0x19,0x8a00,
+	0x18,0x2054,
+	0x19,0x4000,
+	0x18,0x2064,
+	0x19,0x4000,
+	0x18,0x2074,
+	0x19,0x0400,
+	0x18,0x2084,
+	0x19,0xe100,
+	0x18,0x2094,
+	0x19,0xa400,
+	0x18,0x20a4,
+	0x19,0x4000,
+	0x18,0x20b4,
+	0x19,0x7f00,
+	0x18,0x20c4,
+	0x19,0x0000,
+	0x18,0x20d4,
+	0x19,0x0100,
+	0x18,0x20e4,
+	0x19,0x4000,
+	0x18,0x20f4,
+	0x19,0x3e00,
+	0x18,0x2104,
+	0x19,0x0000,
+	0x18,0x2114,
+	0x19,0xe000,
+	0x18,0x2124,
+	0x19,0x1200,
+	0x18,0x2134,
+	0x19,0x8000,
+	0x18,0x2144,
+	0x19,0x7f00,
+	0x18,0x2154,
+	0x19,0x8900,
+	0x18,0x2164,
+	0x19,0x8300,
+	0x18,0x2174,
+	0x19,0xe000,
+	0x18,0x2184,
+	0x19,0x0000,
+	0x18,0x2194,
+	0x19,0x4000,
+	0x18,0x21a4,
+	0x19,0x7f00,
+	0x18,0x21b4,
+	0x19,0x0000,
+	0x18,0x21c4,
+	0x19,0x2000,
+	0x18,0x21d4,
+	0x19,0x4000,
+	0x18,0x21e4,
+	0x19,0x3e00,
+	0x18,0x21f4,
+	0x19,0xff00,
+	0x18,0x2204,
+	0x19,0x0000,
+	0x18,0x2214,
+	0x19,0x1200,
+	0x18,0x2224,
+	0x19,0x8000,
+	0x18,0x2234,
+	0x19,0x7f00,
+	0x18,0x2244,
+	0x19,0x8600,
+	0x18,0x2254,
+	0x19,0x8500,
+	0x18,0x2264,
+	0x19,0x8900,
+	0x18,0x2274,
+	0x19,0xfd00,
+	0x18,0x2284,
+	0x19,0xe000,
+	0x18,0x2294,
+	0x19,0x0000,
+	0x18,0x22a4,
+	0x19,0x9500,
+	0x18,0x22b4,
+	0x19,0x0400,
+	0x18,0x22c4,
+	0x19,0x4000,
+	0x18,0x22d4,
+	0x19,0x4000,
+	0x18,0x22e4,
+	0x19,0x1000,
+	0x18,0x22f4,
+	0x19,0x4000,
+	0x18,0x2304,
+	0x19,0x3f00,
+	0x18,0x2314,
+	0x19,0x0200,
+	0x18,0x2324,
+	0x19,0x4000,
+	0x18,0x2334,
+	0x19,0x3700,
+	0x18,0x2344,
+	0x19,0x7f00,
+	0x18,0x2354,
+	0x19,0x0000,
+	0x18,0x2364,
+	0x19,0x0200,
+	0x18,0x2374,
+	0x19,0x0200,
+	0x18,0x2384,
+	0x19,0x9000,
+	0x18,0x2394,
+	0x19,0x8000,
+	0x18,0x23a4,
+	0x19,0x7d00,
+	0x18,0x23b4,
+	0x19,0x8900,
+	0x18,0x23c4,
+	0x19,0x8300,
+	0x18,0x23d4,
+	0x19,0xe000,
+	0x18,0x23e4,
+	0x19,0x0000,
+	0x18,0x23f4,
+	0x19,0x4000,
+	0x18,0x2404,
+	0x19,0x0400,
+	0x18,0x2414,
+	0x19,0xff00,
+	0x18,0x2424,
+	0x19,0x0200,
+	0x18,0x2434,
+	0x19,0x8500,
+	0x18,0x2444,
+	0x19,0x8900,
+	0x18,0x2454,
+	0x19,0xfa00,
+	0x18,0x2464,
+	0x19,0xe000,
+	0x18,0x2474,
+	0x19,0x0000,
+	0x18,0x2484,
+	0x19,0x4000,
+	0x18,0x2494,
+	0x19,0x7f00,
+	0x18,0x24a4,
+	0x19,0x0000,
+	0x18,0x24b4,
+	0x19,0x0000,
+	0x18,0x24c4,
+	0x19,0x4000,
+	0x18,0x24d4,
+	0x19,0x3700,
+	0x18,0x24e4,
+	0x19,0x7300,
+	0x18,0x24f4,
+	0x19,0x0500,
+	0x18,0x2504,
+	0x19,0x0200,
+	0x18,0x2514,
+	0x19,0x0100,
+	0x18,0x2524,
+	0x19,0xd800,
+	0x18,0x2534,
+	0x19,0x0400,
+	0x18,0x2544,
+	0x19,0x7d00,
+	0x18,0x2554,
+	0x19,0x4000,
+	0x18,0x2564,
+	0x19,0x7f00,
+	0x18,0x2574,
+	0x19,0x0000,
+	0x18,0x2584,
+	0x19,0x0000,
+	0x18,0x2594,
+	0x19,0x4000,
+	0x18,0x25a4,
+	0x19,0x0000,
+	0x18,0x25b4,
+	0x19,0x7200,
+	0x18,0x25c4,
+	0x19,0x0400,
+	0x18,0x25d4,
+	0x19,0x0000,
+	0x18,0x25e4,
+	0x19,0x0800,
+	0x18,0x25f4,
+	0x19,0x7f00,
+	0x18,0x2604,
+	0x19,0x4000,
+	0x18,0x2614,
+	0x19,0x7f00,
+	0x18,0x2624,
+	0x19,0x0000,
+	0x18,0x2634,
+	0x19,0x0000,
+	0x18,0x2644,
+	0x19,0xc000,
+	0x18,0x2654,
+	0x19,0x0000,
+	0x18,0x2664,
+	0x19,0x7200,
+	0x18,0x2674,
+	0x19,0x0500,
+	0x18,0x2684,
+	0x19,0x0000,
+	0x18,0x2694,
+	0x19,0x0400,
+	0x18,0x26a4,
+	0x19,0xeb00,
+	0x18,0x26b4,
+	0x19,0x8400,
+	0x18,0x26c4,
+	0x19,0x7d00,
+	0x18,0x26d4,
+	0x19,0x4000,
+	0x18,0x26e4,
+	0x19,0x7f00,
+	0x18,0x26f4,
+	0x19,0x0000,
+	0x18,0x2704,
+	0x19,0x0000,
+	0x18,0x2714,
+	0x19,0x4000,
+	0x18,0x2724,
+	0x19,0x0000,
+	0x18,0x2734,
+	0x19,0x7200,
+	0x18,0x2744,
+	0x19,0x0700,
+	0x18,0x2754,
+	0x19,0x0000,
+	0x18,0x2764,
+	0x19,0x0400,
+	0x18,0x2774,
+	0x19,0xde00,
+	0x18,0x2784,
+	0x19,0x9b00,
+	0x18,0x2794,
+	0x19,0x7d00,
+	0x18,0x27a4,
+	0x19,0x4000,
+	0x18,0x27b4,
+	0x19,0x7f00,
+	0x18,0x27c4,
+	0x19,0x0000,
+	0x18,0x27d4,
+	0x19,0x9000,
+	0x18,0x27e4,
+	0x19,0x4000,
+	0x18,0x27f4,
+	0x19,0x0400,
+	0x18,0x2804,
+	0x19,0x7300,
+	0x18,0x2814,
+	0x19,0x1500,
+	0x18,0x2824,
+	0x19,0x0000,
+	0x18,0x2834,
+	0x19,0x0400,
+	0x18,0x2844,
+	0x19,0xd100,
+	0x18,0x2854,
+	0x19,0x9400,
+	0x18,0x2864,
+	0x19,0x9200,
+	0x18,0x2874,
+	0x19,0x8000,
+	0x18,0x2884,
+	0x19,0x7b00,
+	0x18,0x2894,
+	0x19,0x4000,
+	0x18,0x28a4,
+	0x19,0x7f00,
+	0x18,0x28b4,
+	0x19,0x0000,
+	0x18,0x28c4,
+	0x19,0x0000,
+	0x18,0x28d4,
+	0x19,0x4000,
+	0x18,0x28e4,
+	0x19,0x0000,
+	0x18,0x28f4,
+	0x19,0x7200,
+	0x18,0x2904,
+	0x19,0x0700,
+	0x18,0x2914,
+	0x19,0x0000,
+	0x18,0x2924,
+	0x19,0x0400,
+	0x18,0x2934,
+	0x19,0xc200,
+	0x18,0x2944,
+	0x19,0x9b00,
+	0x18,0x2954,
+	0x19,0x7d00,
+	0x18,0x2964,
+	0x19,0xe200,
+	0x18,0x2974,
+	0x19,0x7a00,
+	0x18,0x2984,
+	0x19,0x4000,
+	0x18,0x2994,
+	0x19,0x7f00,
+	0x18,0x29a4,
+	0x19,0x0000,
+	0x18,0x29b4,
+	0x19,0x0000,
+	0x18,0x29c4,
+	0x19,0x4000,
+	0x18,0x29d4,
+	0x19,0x3700,
+	0x18,0x29e4,
+	0x19,0x7300,
+	0x18,0x29f4,
+	0x19,0x0500,
+	0x18,0x2a04,
+	0x19,0x0000,
+	0x18,0x2a14,
+	0x19,0x0100,
+	0x18,0x2a24,
+	0x19,0x0300,
+	0x18,0x2a34,
+	0x19,0xe200,
+	0x18,0x2a44,
+	0x19,0x2a00,
+	0x18,0x2a54,
+	0x19,0x0200,
+	0x18,0x2a64,
+	0x19,0x7b00,
+	0x18,0x2a74,
+	0x19,0xe200,
+	0x18,0x2a84,
+	0x19,0x4800,
+	//### endpoint
+
+	0x1f,0x0000,
+	0x17,0x2100,
+	0x1f,0x0007,
+	0x1e,0x0040,
+	0x18,0x0000,
+	//### end of inrx dspctl patch code
+
+	//### inrx eyesch patch code
+	0x1f,0x0007,
+	0x1e,0x0042,
+	0x15,0x0f00,
+	0x1f,0x0000,
+	0x17,0x2160,
+	0x1f,0x0001,
+	0x10,0xf25e,
+	0x1f,0x0007,
+	0x1e,0x0042,
+
+	//### startpoint
+	0x15,0x0f00,
+	0x16,0x7408,
+	0x15,0x0e00,
+	0x15,0x0f00,
+	0x15,0x0f01,
+	0x16,0x4000,
+	0x15,0x0e01,
+	0x15,0x0f01,
+	0x15,0x0f02,
+	0x16,0x9400,
+	0x15,0x0e02,
+	0x15,0x0f02,
+	0x15,0x0f03,
+	0x16,0x7408,
+	0x15,0x0e03,
+	0x15,0x0f03,
+	0x15,0x0f04,
+	0x16,0x4008,
+	0x15,0x0e04,
+	0x15,0x0f04,
+	0x15,0x0f05,
+	0x16,0x9400,
+	0x15,0x0e05,
+	0x15,0x0f05,
+	0x15,0x0f06,
+	0x16,0x0803,
+	0x15,0x0e06,
+	0x15,0x0f06,
+	//### endpoint
+
+	0x1f, 0x0001,
+	0x10, 0xf05e,
+	0x1f, 0x0007,
+	0x1e, 0x0042,
+	0x15,0x0d00,
+	0x15,0x0100,
+	0x1f,0x0000,
+	0x17,0x2100,
+	//### end of inrx eyesch patch code
+
+	//### release MDI/MDIX force mode
+	0x1f, 0x0007,
+	0x1e, 0x002d,
+	0x18, 0xf010,
+
+	//### uc patch code (20110103 add foce giga mode)
+	0x1f,0x0005,
+	//### startpoint
+
+	5, 0x8000,
+	6, 0xeeff,
+	6, 0xfc8b,
+	6, 0xeeff,
+	6, 0xfda0,
+	6, 0x0280,
+	6, 0x33f7,
+	6, 0x00e0,
+	6, 0xfff7,
+	6, 0xa080,
+	6, 0x02ae,
+	6, 0xf602,
+	6, 0x842b,
+	6, 0x0201,
+	6, 0x4802,
+	6, 0x015b,
+	6, 0x0280,
+	6, 0xabe0,
+	6, 0x8b8c,
+	6, 0xe18b,
+	6, 0x8d1e,
+	6, 0x01e1,
+	6, 0x8b8e,
+	6, 0x1e01,
+	6, 0xa000,
+	6, 0xe4ae,
+	6, 0xd8bf,
+	6, 0x846c,
+	6, 0xd785,
+	6, 0x80d0,
+	6, 0x6c02,
+	6, 0x28b4,
+	6, 0xeee1,
+	6, 0x4477,
+	6, 0xeee1,
+	6, 0x4565,
+	6, 0xee8b,
+	6, 0x85c2,
+	6, 0xee8a,
+	6, 0xe86e,
+	6, 0xee85,
+	6, 0x7100,
+	6, 0xee85,
+	6, 0x7200,
+	6, 0xee85,
+	6, 0x7302,
+	6, 0xee85,
+	6, 0x7a03,
+	6, 0xee85,
+	6, 0x7bb8,
+	6, 0xee85,
+	6, 0x7400,
+	6, 0xee85,
+	6, 0x7500,
+	6, 0xee85,
+	6, 0x7000,
+	6, 0xd407,
+	6, 0xf7e4,
+	6, 0x8b96,
+	6, 0xe58b,
+	6, 0x97d4,
+	6, 0x0802,
+	6, 0xe48b,
+	6, 0x94e5,
+	6, 0x8b95,
+	6, 0xd100,
+	6, 0xbf84,
+	6, 0x5d02,
+	6, 0x2959,
+	6, 0xbf8b,
+	6, 0x88ec,
+	6, 0x0019,
+	6, 0xa98b,
+	6, 0x90f9,
+	6, 0xeeff,
+	6, 0xf600,
+	6, 0xeeff,
+	6, 0xf7fc,
+	6, 0xe0e1,
+	6, 0x40e1,
+	6, 0xe141,
+	6, 0xf72f,
+	6, 0xf628,
+	6, 0xe4e1,
+	6, 0x40e5,
+	6, 0xe141,
+	6, 0x04f8,
+	6, 0xe08b,
+	6, 0x8ead,
+	6, 0x2017,
+	6, 0xf620,
+	6, 0xe48b,
+	6, 0x8e02,
+	6, 0x25da,
+	6, 0x0226,
+	6, 0xb402,
+	6, 0x8169,
+	6, 0x0202,
+	6, 0x3402,
+	6, 0x82b1,
+	6, 0x0283,
+	6, 0x4ae0,
+	6, 0x8b8e,
+	6, 0xad23,
+	6, 0x05f6,
+	6, 0x23e4,
+	6, 0x8b8e,
+	6, 0xe08b,
+	6, 0x8ead,
+	6, 0x2408,
+	6, 0xf624,
+	6, 0xe48b,
+	6, 0x8e02,
+	6, 0x277d,
+	6, 0xe08b,
+	6, 0x8ead,
+	6, 0x260b,
+	6, 0xf626,
+	6, 0xe48b,
+	6, 0x8e02,
+	6, 0x056e,
+	6, 0x021c,
+	6, 0x9a02,
+	6, 0x80fb,
+	6, 0x0281,
+	6, 0x55fc,
+	6, 0x04f8,
+	6, 0xe08b,
+	6, 0x83ad,
+	6, 0x2321,
+	6, 0xe0e0,
+	6, 0x22e1,
+	6, 0xe023,
+	6, 0xad29,
+	6, 0x20e0,
+	6, 0x8b83,
+	6, 0xad21,
+	6, 0x06e1,
+	6, 0x8b84,
+	6, 0xad28,
+	6, 0x3ce0,
+	6, 0x8b85,
+	6, 0xad21,
+	6, 0x06e1,
+	6, 0x8b84,
+	6, 0xad29,
+	6, 0x30bf,
+	6, 0x3144,
+	6, 0x0228,
+	6, 0xe8ae,
+	6, 0x28ee,
+	6, 0x8ae2,
+	6, 0x00ee,
+	6, 0x8ae3,
+	6, 0x00ee,
+	6, 0x8ae4,
+	6, 0x00ee,
+	6, 0x8ae5,
+	6, 0x00ee,
+	6, 0x8b72,
+	6, 0x00e0,
+	6, 0x8b83,
+	6, 0xad21,
+	6, 0x08e0,
+	6, 0x8b84,
+	6, 0xf620,
+	6, 0xe48b,
+	6, 0x84bf,
+	6, 0x3147,
+	6, 0x0228,
+	6, 0xe8fc,
+	6, 0x04f8,
+	6, 0xe0e0,
+	6, 0x38e1,
+	6, 0xe039,
+	6, 0xac2e,
+	6, 0x08ee,
+	6, 0xe08e,
+	6, 0x36ee,
+	6, 0xe08f,
+	6, 0x20fc,
+	6, 0x04f8,
+	6, 0xfaef,
+	6, 0x69e0,
+	6, 0x8b85,
+	6, 0xad21,
+	6, 0x39e0,
+	6, 0xe022,
+	6, 0xe1e0,
+	6, 0x2358,
+	6, 0xc059,
+	6, 0x021e,
+	6, 0x01e1,
+	6, 0x8b72,
+	6, 0x1f10,
+	6, 0x9e26,
+	6, 0xe48b,
+	6, 0x72ad,
+	6, 0x211d,
+	6, 0xe18b,
+	6, 0x84f7,
+	6, 0x29e5,
+	6, 0x8b84,
+	6, 0xac27,
+	6, 0x0dac,
+	6, 0x2605,
+	6, 0x0204,
+	6, 0xa2ae,
+	6, 0x0d02,
+	6, 0x820c,
+	6, 0xae08,
+	6, 0x0282,
+	6, 0x38ae,
+	6, 0x0302,
+	6, 0x81b1,
+	6, 0xef96,
+	6, 0xfefc,
+	6, 0x04d1,
+	6, 0x00bf,
+	6, 0x845d,
+	6, 0x0229,
+	6, 0x59d1,
+	6, 0x03bf,
+	6, 0x316b,
+	6, 0x0229,
+	6, 0x59d1,
+	6, 0x00bf,
+	6, 0x316e,
+	6, 0x0229,
+	6, 0x59d1,
+	6, 0x00bf,
+	6, 0x8463,
+	6, 0x0229,
+	6, 0x59d1,
+	6, 0x0fbf,
+	6, 0x3162,
+	6, 0x0229,
+	6, 0x59d1,
+	6, 0x01bf,
+	6, 0x3165,
+	6, 0x0229,
+	6, 0x59d1,
+	6, 0x01bf,
+	6, 0x3168,
+	6, 0x0229,
+	6, 0x59e0,
+	6, 0x8b85,
+	6, 0xad24,
+	6, 0x0ed1,
+	6, 0x00bf,
+	6, 0x3177,
+	6, 0xad23,
+	6, 0x03bf,
+	6, 0x317a,
+	6, 0x0229,
+	6, 0x59e0,
+	6, 0x8b83,
+	6, 0xad22,
+	6, 0x08d1,
+	6, 0x00bf,
+	6, 0x315c,
+	6, 0x0229,
+	6, 0x5904,
+	6, 0xd102,
+	6, 0xbf31,
+	6, 0x6b02,
+	6, 0x2959,
+	6, 0xd106,
+	6, 0xbf31,
+	6, 0x6202,
+	6, 0x2959,
+	6, 0xd107,
+	6, 0xbf31,
+	6, 0x6502,
+	6, 0x2959,
+	6, 0xd107,
+	6, 0xbf31,
+	6, 0x6802,
+	6, 0x2959,
+	6, 0xd101,
+	6, 0xbf84,
+	6, 0x5d02,
+	6, 0x2959,
+	6, 0x0282,
+	6, 0x7104,
+	6, 0xd102,
+	6, 0xbf31,
+	6, 0x6b02,
+	6, 0x2959,
+	6, 0xd101,
+	6, 0xbf84,
+	6, 0x5d02,
+	6, 0x2959,
+	6, 0xd011,
+	6, 0x0228,
+	6, 0x0459,
+	6, 0x03ef,
+	6, 0x01d1,
+	6, 0x00a0,
+	6, 0x0002,
+	6, 0xd101,
+	6, 0xbf31,
+	6, 0x6e02,
+	6, 0x2959,
+	6, 0xd111,
+	6, 0xad20,
+	6, 0x020c,
+	6, 0x11ad,
+	6, 0x2102,
+	6, 0x0c12,
+	6, 0xbf84,
+	6, 0x6302,
+	6, 0x2959,
+	6, 0x04f8,
+	6, 0xe08b,
+	6, 0x85ad,
+	6, 0x2437,
+	6, 0xe0ea,
+	6, 0xcae1,
+	6, 0xeacb,
+	6, 0xad29,
+	6, 0x2ee0,
+	6, 0xeacc,
+	6, 0xe1ea,
+	6, 0xcdad,
+	6, 0x2925,
+	6, 0xe0e0,
+	6, 0x08e1,
+	6, 0xe009,
+	6, 0xad20,
+	6, 0x1ce0,
+	6, 0xe00a,
+	6, 0xe1e0,
+	6, 0x0bad,
+	6, 0x2013,
+	6, 0xd103,
+	6, 0xbf31,
+	6, 0x77e0,
+	6, 0x8b85,
+	6, 0xad23,
+	6, 0x05d1,
+	6, 0x01bf,
+	6, 0x317a,
+	6, 0x0229,
+	6, 0x59fc,
+	6, 0x04f8,
+	6, 0xf9fb,
+	6, 0xe08b,
+	6, 0x85ad,
+	6, 0x2522,
+	6, 0xe0e0,
+	6, 0x22e1,
+	6, 0xe023,
+	6, 0xe2e0,
+	6, 0x36e3,
+	6, 0xe037,
+	6, 0x5ac4,
+	6, 0x0d01,
+	6, 0x5802,
+	6, 0x1e20,
+	6, 0xe385,
+	6, 0x71ac,
+	6, 0x3160,
+	6, 0xac3a,
+	6, 0x08ac,
+	6, 0x3e26,
+	6, 0xae67,
+	6, 0xaf83,
+	6, 0x46ad,
+	6, 0x3761,
+	6, 0xe085,
+	6, 0x7210,
+	6, 0xe485,
+	6, 0x72e1,
+	6, 0x8573,
+	6, 0x1b10,
+	6, 0x9e02,
+	6, 0xae51,
+	6, 0xd100,
+	6, 0xbf84,
+	6, 0x6002,
+	6, 0x2959,
+	6, 0xee85,
+	6, 0x7200,
+	6, 0xae43,
+	6, 0xad36,
+	6, 0x27e0,
+	6, 0x857a,
+	6, 0xe185,
+	6, 0x7bef,
+	6, 0x74e0,
+	6, 0x8574,
+	6, 0xe185,
+	6, 0x751b,
+	6, 0x749e,
+	6, 0x2e14,
+	6, 0xe485,
+	6, 0x74e5,
+	6, 0x8575,
+	6, 0xef74,
+	6, 0xe085,
+	6, 0x7ae1,
+	6, 0x857b,
+	6, 0x1b47,
+	6, 0x9e0f,
+	6, 0xae19,
+	6, 0xee85,
+	6, 0x7400,
+	6, 0xee85,
+	6, 0x7500,
+	6, 0xae0f,
+	6, 0xac39,
+	6, 0x0cd1,
+	6, 0x01bf,
+	6, 0x8460,
+	6, 0x0229,
+	6, 0x59ee,
+	6, 0x8572,
+	6, 0x00e6,
+	6, 0x8571,
+	6, 0xfffd,
+	6, 0xfc04,
+	6, 0xf8e0,
+	6, 0x8b85,
+	6, 0xad27,
+	6, 0x30e0,
+	6, 0xe036,
+	6, 0xe1e0,
+	6, 0x37e1,
+	6, 0x8570,
+	6, 0x1f10,
+	6, 0x9e23,
+	6, 0xe485,
+	6, 0x70ac,
+	6, 0x200b,
+	6, 0xac21,
+	6, 0x0dac,
+	6, 0x250f,
+	6, 0xac27,
+	6, 0x11ae,
+	6, 0x1202,
+	6, 0x8383,
+	6, 0xae0d,
+	6, 0x0283,
+	6, 0x88ae,
+	6, 0x0802,
+	6, 0x838f,
+	6, 0xae03,
+	6, 0x0283,
+	6, 0xa2fc,
+	6, 0x04ee,
+	6, 0x8576,
+	6, 0x0004,
+	6, 0x0283,
+	6, 0xaf02,
+	6, 0x83f2,
+	6, 0x04f8,
+	6, 0xf9e0,
+	6, 0x8b87,
+	6, 0xad26,
+	6, 0x08d1,
+	6, 0x01bf,
+	6, 0x8469,
+	6, 0x0229,
+	6, 0x59fd,
+	6, 0xfc04,
+	6, 0x0284,
+	6, 0x1304,
+	6, 0xee85,
+	6, 0x7600,
+	6, 0xee85,
+	6, 0x7702,
+	6, 0x04f8,
+	6, 0xf9e0,
+	6, 0x8b85,
+	6, 0xad26,
+	6, 0x38d0,
+	6, 0x0b02,
+	6, 0x2804,
+	6, 0x5882,
+	6, 0x7882,
+	6, 0x9f2d,
+	6, 0xe085,
+	6, 0x76e1,
+	6, 0x8577,
+	6, 0x1f10,
+	6, 0x9eb5,
+	6, 0x10e4,
+	6, 0x8576,
+	6, 0xe0e0,
+	6, 0x00e1,
+	6, 0xe001,
+	6, 0xf727,
+	6, 0xe4e0,
+	6, 0x00e5,
+	6, 0xe001,
+	6, 0xe2e0,
+	6, 0x20e3,
+	6, 0xe021,
+	6, 0xad30,
+	6, 0xf7f6,
+	6, 0x27e4,
+	6, 0xe000,
+	6, 0xe5e0,
+	6, 0x01fd,
+	6, 0xfc04,
+	6, 0xf8fa,
+	6, 0xef69,
+	6, 0xe08b,
+	6, 0x86ad,
+	6, 0x2212,
+	6, 0xe0e0,
+	6, 0x14e1,
+	6, 0xe015,
+	6, 0xad26,
+	6, 0x89e1,
+	6, 0x8578,
+	6, 0xbf84,
+	6, 0x6602,
+	6, 0x2959,
+	6, 0xef96,
+	6, 0xfefc,
+	6, 0x04f8,
+	6, 0xfaef,
+	6, 0x69e0,
+	6, 0x8b86,
+	6, 0xad22,
+	6, 0x09e1,
+	6, 0x8579,
+	6, 0xbf84,
+	6, 0x6602,
+	6, 0x2959,
+	6, 0xef96,
+	6, 0xfefc,
+	6, 0x04f8,
+	6, 0xfaef,
+	6, 0x69e0,
+	6, 0x8b86,
+	6, 0xac20,
+	6, 0x1abf,
+	6, 0x8580,
+	6, 0xd06c,
+	6, 0x0228,
+	6, 0xbbe0,
+	6, 0xe0e4,
+	6, 0xe1e0,
+	6, 0xe558,
+	6, 0x0668,
+	6, 0xc0d1,
+	6, 0xd2e4,
+	6, 0xe0e4,
+	6, 0xe5e0,
+	6, 0xe5ef,
+	6, 0x96fe,
+	6, 0xfc04,
+	6, 0xa0e0,
+	6, 0xeaf0,
+	6, 0xe07c,
+	6, 0x55e2,
+	6, 0x3211,
+	6, 0xe232,
+	6, 0x88e2,
+	6, 0x0070,
+	6, 0xe426,
+	6, 0x70e0,
+	6, 0x7699,
+	6, 0xe000,
+	6, 0x2508,
+	6, 0x0726,
+	6, 0x4072,
+	6, 0x2726,
+	6, 0x7e28,
+	6, 0x04b7,
+	6, 0x2925,
+	6, 0x762a,
+	6, 0x68e5,
+	6, 0x2bad,
+	6, 0x002c,
+	6, 0xdbf0,
+	6, 0x2d67,
+	6, 0xbb2e,
+	6, 0x7b0f,
+	6, 0x2f73,
+	6, 0x6531,
+	6, 0xaccc,
+	6, 0x3223,
+	6, 0x0033,
+	6, 0x2d17,
+	6, 0x347f,
+	6, 0x5235,
+	6, 0x1000,
+	6, 0x3606,
+	6, 0x0037,
+	6, 0x0cc0,
+	6, 0x387f,
+	6, 0xce3c,
+	6, 0xe5f7,
+	6, 0x3d3d,
+	6, 0xa465,
+	6, 0x303e,
+	6, 0x6700,
+	6, 0x5369,
+	6, 0xd20f,
+	6, 0x6a01,
+	6, 0x2c6c,
+	6, 0x2b13,
+	6, 0x6ee1,
+	6, 0x006f,
+	6, 0x12f7,
+	6, 0x7100,
+	6, 0x6b73,
+	6, 0x06eb,
+	6, 0x7494,
+	6, 0xc776,
+	6, 0x980a,
+	6, 0x7750,
+	6, 0x0078,
+	6, 0x8a15,
+	6, 0x797f,
+	6, 0x6f7a,
+	6, 0x06a6,
+	//### endpoint
+
+	//#unlock uc ramcode version
+	5,  0xe142,
+	6,  0x0701,
+	5,  0xe140,
+	6,  0x0405,
+	15, 0x0000,
+
+	//### end of uc patch code
+	//#Enable negear EEE Nway ability autooff
+	0x1f,0x0005,
+	0x05,0x8b84,
+	0x06,0x0026,
+	0x1f,0x0000,
+
+	//#lpi patch code-maxod-20110103
+	31, 0x0007,
+	30, 0x0023,
+	22, 0x0006,
+	//#quiet time to 22ms
+	21, 0x147,
+	25, 0x96,
+	//#lpi_tx_wake_timer to 1.3us
+	21, 0x16d,
+	25, 0x26,
+	22, 0x0002,
+	31, 0x0000,
+
+	//#Add by Gary for Channel Estimation fine tune 20100430
+	//#Page1 Reg8 (CG_INITIAL_MASTER)
+	0x1f, 0x0005,
+	0x05, 0x83dd,
+	0x06, 0x0574,
+	//#Page1 Reg9 (CB0_INITIAL_GIGA)
+	0x1f, 0x0005,
+	0x05, 0x83e0,
+	0x06, 0x2724,
+	//#Page3 Reg26 (CG_INITIAL_SLAVE)
+	0x1f, 0x0005,
+	0x05, 0x843d,
+	0x06, 0x06f6 ,
+
+	0x1f, 0x0000,
+	#endif
+};
+
+static const unsigned int default_val[]={
+	999,0x1f,0x0002,
+
+	2,0x11,0x7e00,
+
+	3,0x1f,0x0002,
+	3,0x17,0xff00,
+	3,0x18,0x0005,
+	3,0x19,0x0005,
+	3,0x1a,0x0005,
+	3,0x1b,0x0005,
+	3,0x1c,0x0005,
+
+	4,0x1f,0x0002,
+	4,0x13,0x00aa,
+	4,0x14,0x00aa,
+	4,0x15,0x00aa,
+	4,0x16,0x00aa,
+	4,0x17,0x00aa,
+	4,0x18,0x0f0a,
+	4,0x19,0x50ab,
+	4,0x1a,0x0000,
+	4,0x1b,0x0f0f,
+
+	999,0x1f,0x0000,
+};
+
+void Setting_RTL8198_GPHY(void)
+{
+	int i=0, port =0, len=0;
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	if (REG32(BSP_REVR) == BSP_RTL8198_REVISION_A)
+	{
+		/*
+		 #Access command format: phywb {all: phyID=0,1,2,3,4} {page} {RegAddr} {Bit location} {Bit value}
+		 #when writing gpage 72, must do mdcmdio_cmd write $phyID 31 0x7, then mdcmdio_cmd write $phyID 30 $PageNum
+		 phywb all 72 21 15-0 0x7092
+		 phywb all 72 22 15-0 0x7092
+		 phywb all 72 23 15-0 0x7092
+		 phywb all 72 24 15-0 0x7092
+		 phywb all 72 25 15-0 0x7092
+		 phywb all 72 26 15-0 0x7092
+		*/
+
+		//	Set_GPHYWB(3, 2, 20, 0, 0x2000);
+
+		Set_GPHYWB(999, 72, 21, 0, 0x7092);
+		Set_GPHYWB(999, 72, 22, 0, 0x7092);
+		Set_GPHYWB(999, 72, 23, 0, 0x7092);
+		Set_GPHYWB(999, 72, 24, 0, 0x7092);
+		Set_GPHYWB(999, 72, 25, 0, 0x7092);
+		Set_GPHYWB(999, 72, 26, 0, 0x7092);
+
+		/*
+		 set PageNum 2; #All of GPHY register in the Page#2
+		 #Array format = {{PhyID List1}  {RegAddr1 RegData1 RegAddr2 RegData2}, ...}
+
+		set AFE_Reg     {{0 1 2 3 4} { 0 0x0000 1  0x065a 2 0x8c01  3  0x0428 4 0x80c8  5   0x0978  6  0x0678 7  0x3620 8 0x0000 9 0x0007 10 0x0000}
+	       	               {2}         {11 0x0063 12 0xeb65 13 0x51d1 14 0x5dcb 15 0x3044 16 0x1000 17  0x7e00 18 0x0000}
+	              	        {3}         {19 0x3d22 20 0x2000 21 0x6040 22 0x0000 23 0xff00 24 0x0005 25 0x0005 26 0x0005 27 0x0005 28 0x0005}
+	                     	 {4}         {19 0x00aa 20 0x00aa 21 0x00aa 22 0x00aa 23 0x00aa 24 0x0f0a 25 0x5050 26 0x0000 27 0x0f0f }}
+		*/
+
+	       //phyid=all
+		Set_GPHYWB(999, 2,  0, 0, 0x0000);
+		Set_GPHYWB(999, 2,  1, 0, 0x065a);
+		Set_GPHYWB(999, 2,  2, 0, 0x8c01);
+		Set_GPHYWB(999, 2,  3, 0, 0x0428);
+		Set_GPHYWB(999, 2,  4, 0, 0x80c8);
+		Set_GPHYWB(999, 2,  5, 0, 0x0978);
+		Set_GPHYWB(999, 2,  6, 0, 0x0678);
+		Set_GPHYWB(999, 2,  7, 0, 0x3620);
+		Set_GPHYWB(999, 2,  8, 0, 0x0000);
+		Set_GPHYWB(999, 2,  9, 0, 0x0007);
+		Set_GPHYWB(999, 2,  10, 0, 0x0000);
+
+	       //phyid=2
+		Set_GPHYWB( 2,   2, 11, 0, 0x0063);
+		Set_GPHYWB( 2,   2, 12, 0, 0xeb65);
+		Set_GPHYWB( 2,   2, 13, 0, 0x51d1);
+		Set_GPHYWB( 2,   2, 14, 0, 0x5dcb);
+		Set_GPHYWB( 2,   2, 15, 0, 0x3044);
+		Set_GPHYWB( 2,   2, 16, 0, 0x1000);
+		Set_GPHYWB( 2,   2, 17, 0, 0x7e00);
+		Set_GPHYWB( 2,   2, 18, 0, 0x0000);
+
+	       //phyid=3
+		Set_GPHYWB( 3,   2, 19, 0, 0x3d22);
+		Set_GPHYWB( 3,   2, 20, 0, 0x2000);
+	   	Set_GPHYWB( 3,   2, 21, 0, 0x6040);
+		Set_GPHYWB( 3,   2, 22, 0, 0x0000);
+		Set_GPHYWB( 3,   2, 23, 0, 0xff00);
+		Set_GPHYWB( 3,   2, 24, 0, 0x0005);
+		Set_GPHYWB( 3,   2, 25, 0, 0x0005);
+		Set_GPHYWB( 3,   2, 26, 0, 0x0005);
+		Set_GPHYWB( 3,   2, 27, 0, 0x0005);
+		Set_GPHYWB( 3,   2, 28, 0, 0x0005);
+
+	       //phyid=4
+		Set_GPHYWB( 4,   2, 19, 0, 0x00aa);
+		Set_GPHYWB( 4,   2, 20, 0, 0x00aa);
+		Set_GPHYWB( 4,   2, 21, 0, 0x00aa);
+		Set_GPHYWB( 4,   2, 22, 0, 0x00aa);
+		Set_GPHYWB( 4,   2, 23, 0, 0x00aa);
+		Set_GPHYWB( 4,   2, 24, 0, 0x0f0a);
+		Set_GPHYWB( 4,   2, 25, 0, 0x5050);
+		Set_GPHYWB( 4,   2, 26, 0, 0x0000);
+		Set_GPHYWB( 4,   2, 27, 0, 0x0f0f);
+
+		/*
+		 #=========== INRX Para. =================================
+
+		 phywb all 0 21 0x1006
+	           #dfse_mode[15:14]=3(full), Fine tune aagc_lvl_fnet[10:0]
+	           phywb all 1 12 15-0 0xdbf0
+
+	           #cb0_i_giga[12:0]
+	           phywb all 1 9  15-0 0x2576
+	           phywb all 1 7  15-0 0x287E
+	           phywb all 1 10 15-0 0x68E5
+	           phywb all 1 29 15-0 0x3DA4
+	           phywb all 1 28 15-0 0xE7F7
+	           phywb all 1 20 15-0 0x7F52
+	           phywb all 1 24 15-0 0x7FCE
+	           phywb all 1 8  15-0 0x04B7
+	           phywb all 1 6  15-0 0x4072
+	           phywb all 1 16 15-0 0xF05E
+	           phywb all 1 27 15-0 0xB414
+		*/
+
+		Set_GPHYWB( 999,   1, 12, 0, 0xdbf0);
+
+		Set_GPHYWB( 999,   1, 9, 0, 0x2576);
+		Set_GPHYWB( 999,   1, 7, 0, 0x287E);
+		Set_GPHYWB( 999,   1, 10, 0, 0x68E5);
+		Set_GPHYWB( 999,   1, 29, 0, 0x3DA4);
+		Set_GPHYWB( 999,   1, 28, 0, 0xE7F7);
+		Set_GPHYWB( 999,   1, 20, 0, 0x7F52);
+		Set_GPHYWB( 999,   1, 24, 0, 0x7FCE);
+		Set_GPHYWB( 999,   1, 8, 0, 0x04B7);
+		Set_GPHYWB( 999,   1, 6, 0, 0x4072);
+		Set_GPHYWB( 999,   1, 16, 0, 0xF05E);
+		Set_GPHYWB( 999,   1, 27, 0, 0xB414);
+
+		/*
+		 #=========== Cable Test =================================
+
+		  phywb all 3 26 15-0 0x06A6
+		  phywb all 3 16 15-0 0xF05E
+		  phywb all 3 19 15-0 0x06EB
+		  phywb all 3 18 15-0 0xF4D2
+		  phywb all 3 14 15-0 0xE120
+		  phywb all 3 0  15-0 0x7C00
+
+		  phywb all 3 2  15-0 0x5FD0
+		  phywb all 3 13 15-0 0x0207
+
+		  #disable jabber detect
+		   phywb all 0 16 15-0 0x05EF
+
+		  #Patch for EEE GMII issue
+		  phywb all 32 26 15-0 0x0103
+		  phywb all 32 22 15-0 0x0004
+		*/
+		Set_GPHYWB( 999,   3, 26, 0, 0x06A6);
+		Set_GPHYWB( 999,   3, 16, 0, 0xF05E);
+		Set_GPHYWB( 999,   3, 19, 0, 0x06EB);
+		Set_GPHYWB( 999,   3, 18, 0, 0xF4D2);
+		Set_GPHYWB( 999,   3, 14, 0, 0xE120);
+		Set_GPHYWB( 999,   3, 00, 0, 0x7C00);
+
+		Set_GPHYWB( 999,   3, 02, 0, 0x5FD0);
+		Set_GPHYWB( 999,   3, 13, 0, 0x0207);
+
+		Set_GPHYWB( 999,   0, 16, 0, 0x05EF);
+
+		Set_GPHYWB( 999,   3, 26, 0, 0x0103);
+		Set_GPHYWB( 999,   3, 22, 0, 0x0004);
+
+		/*
+		 disable aldps_en, for power measurement
+		 hywb all 44 21 15-0 0x0350
+		*/
+		Set_GPHYWB( 999,   44, 21, 0, 0x0350);
+	}
+	else
+	{
+		Set_GPHYWB(999, 0, 0, 0xffff-POWER_DOWN, POWER_DOWN); // set power down
+
+		len=sizeof(default_val)/sizeof(unsigned int);
+		for(i=0;i<len;i=i+3)
+		{
+
+			if(default_val[i]==999)
+			{
+				for(port=0; port<5; port++)
+					rtl8651_setAsicEthernetPHYReg(port, default_val[i+1], default_val[i+2]);
+			}
+			else
+			{
+				port=default_val[i];
+				rtl8651_setAsicEthernetPHYReg(port, default_val[i+1], default_val[i+2]);
+			}
+		}
+		len=sizeof(phy_para)/sizeof(unsigned int);
+		for(port=0; port<5; port++)
+		{
+			for(i=0;i<len;i=i+2)
+			{
+				rtl8651_setAsicEthernetPHYReg(port, phy_para[i], phy_para[i+1]);
+			}
+		}
+		Set_GPHYWB( 999,   5, 5, 0, 0x8b84);
+		Set_GPHYWB( 999,   5, 6, 0, 0x0006);
+		Set_GPHYWB( 999,   2, 8, 0, 0x0020);
+
+		// for the IOT issue with IC+ when EEE N-way.
+		Set_GPHYWB( 999,   172, 24, 0, 0x0006);
+
+#ifdef CONFIG_RTL_8198_ESD
+		Set_GPHYWB(999, 44, 27, 0xffff-(0xf<<12), 0x4<<12);
+#endif
+	}
+
+//	for(i=0; i<5; i++)
+//		REG32(PCRP0+i*4) &= ~(EnForceMode);
+
+	printk("==Set GPHY Parameter OK\n");
+}
+
+int rtl8198_force_giga(int port)
+{
+	if (port < 0 || port > 4)
+		return 0;
+
+	REG32(PCRP0+ port*4) |= (EnForceMode);
+
+	rtl8651_setAsicEthernetPHYReg(port, 31, 0x5);
+	rtl8651_setAsicEthernetPHYReg(port, 5, 0x8b86);
+	rtl8651_setAsicEthernetPHYReg(port, 6, 0x0040);
+	rtl8651_setAsicEthernetPHYReg(port, 31, 0x0);
+
+	REG32(PCRP0+ port*4) = REG32(PCRP0+ port*4) & ~(EnForceMode | NwayAbility100MF | NwayAbility100MH | NwayAbility10MF | NwayAbility10MH); // disable Nway 10/100 ability
+
+	rtl8651_restartAsicEthernetPHYNway(port);
+	return 0;
+}
+
+int rtl8198_disable_force(int port)
+{
+	if (port < 0 || port > 4)
+		return 0;
+
+	REG32(PCRP0+ port*4) |= (EnForceMode);
+
+	rtl8651_setAsicEthernetPHYReg(port, 31, 0x5);
+	rtl8651_setAsicEthernetPHYReg(port, 5, 0x8b86);
+	rtl8651_setAsicEthernetPHYReg(port, 6, 0x0000);
+	rtl8651_setAsicEthernetPHYReg(port, 31, 0x0);
+
+	REG32(PCRP0+ port*4) = (REG32(PCRP0+ port*4) & ~(EnForceMode)) | NwayAbility100MF | NwayAbility100MH | NwayAbility10MF | NwayAbility10MH; // enable Nway 10/100 ability
+
+	rtl8651_restartAsicEthernetPHYNway(port);
+	return 0;
+}
+
+#if defined(PORT5_RGMII_GMII)
+unsigned int ExtP5GigaPhyMode=0;
+void ProbeP5GigaPHYChip(void)
+{
+	unsigned int uid,tmp;
+	unsigned int i;
+
+	//printk("In Setting port5 \r\n");
+
+	//REG32(0xB8000010)=0x01FFFCB9;
+
+	for(i=0; i<=5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+
+	/* Read */
+	rtl8651_setAsicEthernetPHYReg(GIGA_P5_PHYID,0x10,0x01FE);
+	rtl8651_getAsicEthernetPHYReg(GIGA_P5_PHYID, 0, &tmp );
+
+	//printk("Read port5 phyReg0= 0x%x \r\n",tmp);
+
+	rtl8651_getAsicEthernetPHYReg( GIGA_P5_PHYID, 2, &tmp );
+	//printk("Read port5 UPChipID= 0x%x \r\n",tmp);
+	uid=tmp<<16;
+	rtl8651_getAsicEthernetPHYReg( GIGA_P5_PHYID, 3, &tmp );
+	//printk("Read port5 downChipID= 0x%x \r\n",tmp);
+	uid=uid | tmp;
+
+	if( uid==0x001CC912 )  //0x001cc912 is 8212 two giga port , 0x001cc940 is 8214 four giga port
+	{
+		//printk("Find Port5   have 8211 PHY Chip! \r\n");
+		ExtP5GigaPhyMode=1;
+		//return 1;
+	}
+	else
+	{
+		//printk("NO Find Port5 8211 PHY Chip! \r\n");
+		//ExtP5GigaPhyMode=0;
+		//return 1;
+	}
+	for(i=0; i<=5; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+
+}
+#endif
+
+void disable_phy_power_down(void)
+{
+	int i;
+	uint32 statCtrlReg0;
+
+	for (i=0; i<5; i++)
+	{
+		rtl8651_getAsicEthernetPHYReg( i, 0, &statCtrlReg0 );
+
+		statCtrlReg0 &= (~POWER_DOWN);
+
+		/* write PHY reg 0 */
+		rtl8651_setAsicEthernetPHYReg( i, 0, statCtrlReg0 );
+
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+	}
+	mdelay(3000);
+}
+#endif
+
+int32 rtl865x_platform_check(void)
+{
+	uint32 bondOptReg=0;
+	bondOptReg=REG32(0xB800000C);
+	if(((bondOptReg&0x0F)!=0x7) && ((bondOptReg&0x0F)!=0x9))
+	{
+		printk("current chip doesn't supported,system halt...\n");
+		while(1);
+	}
+
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+unsigned int Get_P0_PhyMode(void)
+{
+	/*
+		00: External  phy
+		01: embedded phy
+		10: olt
+		11: deb_sel
+	*/
+	#define GET_BITVAL(v,bitpos,pat) ((v& ((unsigned int)pat<<bitpos))>>bitpos)
+	#define RANG1 1
+	#define RANG2 3
+	#define RANG3  7
+	#define RANG4 0xf
+
+	unsigned int v=REG32(HW_STRAP);
+	unsigned int mode=GET_BITVAL(v, 6, RANG1) *2 + GET_BITVAL(v, 7, RANG1);
+
+	return (mode&3);
+}
+
+unsigned int Get_P0_MiiMode(void)
+{
+	/*
+		0: MII-PHY
+		1: MII-MAC
+		2: GMII-MAC
+		3: RGMII
+	*/
+	#define GET_BITVAL(v,bitpos,pat) ((v& ((unsigned int)pat<<bitpos))>>bitpos)
+	#define RANG1 1
+	#define RANG2 3
+	#define RANG3  7
+	#define RANG4 0xf
+
+	unsigned int v=REG32(HW_STRAP);
+	unsigned int mode=GET_BITVAL(v, 27, RANG2);
+
+	return mode;
+}
+
+unsigned int Get_P0_RxDelay(void)
+{
+	#define GET_BITVAL(v,bitpos,pat) ((v& ((unsigned int)pat<<bitpos))>>bitpos)
+	#define RANG1 1
+	#define RANG2 3
+	#define RANG3  7
+	#define RANG4 0xf
+
+	unsigned int v=REG32(HW_STRAP);
+	unsigned int val=GET_BITVAL(v, 29, RANG3);
+	return val;
+}
+
+unsigned int Get_P0_TxDelay(void)
+{
+	#define GET_BITVAL(v,bitpos,pat) ((v& ((unsigned int)pat<<bitpos))>>bitpos)
+	#define RANG1 1
+	#define RANG2 3
+	#define RANG3  7
+	#define RANG4 0xf
+
+	unsigned int v=REG32(HW_STRAP);
+	unsigned int val=GET_BITVAL(v, 17, RANG1);
+	return val;
+}
+
+int Setting_RTL8197D_PHY(void)
+{
+	int i;
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	/*
+	  page 	addr rtl8197d-default 	rtl8197d-new value Purpose
+	  0 		21 	0x02c5 			0x0232 			Green: up/low bond to 3/2
+	  0 		22 	0x5b85 			0x5bd5 			Green: ad current from 2 to 3
+	  1 		18 	0x901c 			0x9004 			finetune AOI waveform
+	  1 		19 	0x4400 			0x5400 			finetune 100M DAC current
+	  1 		25 	0x00da 			0x00d0 			enable pwdn10rx at pwr saving enable snr threshold = 18dB
+
+	  4 		16 	0x4007 			0x737f 			enable EEE, fine tune EEE parameter
+	  4 		24 	0xc0a0 			0xc0f3 			change EEE wake idle to 10us
+	  4 		25 	0x0130 			0x0730 			turn off tx/rx pwr at LPI state
+	*/
+
+	// only do the PHY setting in this revision IC, no need for the new one.
+	if (REG32(REVR) == 0x8197C000) {
+
+		Set_GPHYWB(999, 0, 21, 0, 0x0232);
+
+		/* purpose: to avoid 100M N-way link fail issue Set_p="1" */
+		Set_GPHYWB(999, 0, 22, 0, 0x5bd5);
+
+	 	/* purpose: to adjust AOI waveform */
+		Set_GPHYWB(999, 1, 18, 0, 0x9004);
+
+		/* purpose: to enhance ethernet 100Mhz output voltage about 1.0(v) */
+		Set_GPHYWB(999, 1, 19, 0, 0x5400);
+
+		Set_GPHYWB(999, 1, 25, 0, 0x00d0);  //enable pwdn10rx at pwr saving enable snr threshold = 18dB
+
+		Set_GPHYWB(999, 4, 16, 0, 0x737f);// enable EEE, fine tune EEE parameter
+		Set_GPHYWB(999, 4, 24, 0, 0xc0f3);	//change EEE wake idle to 10us
+		Set_GPHYWB(999, 4, 25, 0, 0x0730);	 // turn off tx/rx pwr at LPI state
+	}
+
+	// fix unlink IOT issue
+	Set_GPHYWB(999, 0, 26, 0xffff-(0x1<<14), 0x0<<14);
+	Set_GPHYWB(999, 0, 17, 0xffff-(0xf<<8), 0xe<<8);
+
+	/* fine tune port on/off threshold to 160/148 */
+	REG32(PBFCR0) = 0x009400A0;
+	REG32(PBFCR1) = 0x009400A0;
+	REG32(PBFCR2) = 0x009400A0;
+	REG32(PBFCR3) = 0x009400A0;
+	REG32(PBFCR4) = 0x009400A0;
+	REG32(PBFCR6) = 0x009400A0;
+
+	/* modify egress leaky bucket parameter, default inaccuracy is 5~10%, the new one is 1~2% after modification */
+	REG32(ELBPCR) = 0x0000400B;
+	REG32(ELBTTCR) = 0x000000C0;
+
+	/* 100M half duplex enhancement */
+	/* fix SmartBits half duplex backpressure IOT issue */
+	REG32(MACCR)= (REG32(MACCR) & ~(CF_RXIPG_MASK | SELIPG_MASK)) | (0x05 | SELIPG_11);
+
+	/* enlarge "Flow control DSC tolerance" from 24 pages to 48 pages
+	    to prevent the hardware may drop incoming packets
+	    after flow control triggered and Pause frame sent */
+	REG32(MACCR)= (REG32(MACCR) & ~CF_FCDSC_MASK) | (0x30 << CF_FCDSC_OFFSET);
+
+	/* default enable MAC EEE */
+	REG32(EEECR) = 0x28739ce7;
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+
+	return 0;
+}
+#endif
+
+#ifdef CONFIG_RTL_8196E
+int Setting_RTL8196E_PHY(void)
+{
+	int i;
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	// write page1, reg16, bit[15:13] Iq Current 110:175uA (default 100: 125uA)
+	Set_GPHYWB(999, 1, 16, 0xffff-(0x7<<13), 0x6<<13);
+
+	// disable power saving mode in A-cut only
+	if (REG32(REVR) == 0x8196e000)
+		Set_GPHYWB(999, 0, 0x18, 0xffff-(1<<15), 0<<15);
+
+	/* B-cut and later,
+	    just increase a little power in long RJ45 cable case for Green Ethernet feature.
+	 */
+	else
+	{
+		// adtune_lb setting
+		Set_GPHYWB(999, 0, 22, 0xffff-(0x7<<4), 0x4<<4);
+		//Setting SNR lb and hb
+		Set_GPHYWB(999, 0, 21, 0xffff-(0xff<<0), 0xc2<<0);
+		//auto bais current
+		Set_GPHYWB(999, 1, 19, 0xffff-(0x1<<0), 0x0<<0);
+		Set_GPHYWB(999, 0, 22, 0xffff-(0x1<<3), 0x0<<3);
+	}
+
+	// fix Ethernet IOT issue
+	if ( ((REG32(BOND_OPTION) & BOND_ID_MASK) != BOND_8196ES)  &&
+		((REG32(BOND_OPTION) & BOND_ID_MASK) != BOND_8196ES1)  &&
+		((REG32(BOND_OPTION) & BOND_ID_MASK) != BOND_8196ES2)  &&
+		((REG32(BOND_OPTION) & BOND_ID_MASK) != BOND_8196ES3)  )
+	{
+		Set_GPHYWB(999, 0, 26, 0xffff-(0x1<<14), 0x0<<14);
+		Set_GPHYWB(999, 0, 17, 0xffff-(0xf<<8), 0xe<<8);
+	}
+
+#if defined(CONFIG_RTL_DISABLE_ETH_MIPS16)
+	/*jwj: Refine off 140, on 152 for smartflow test.*/
+	REG32(PBFCR6) = 0x008C0098;
+#endif
+	/* 100M half duplex enhancement */
+	/* fix SmartBits half duplex backpressure IOT issue */
+	REG32(MACCR)= (REG32(MACCR) & ~(CF_RXIPG_MASK | SELIPG_MASK)) | (0x05 | SELIPG_11);
+
+	/* enlarge "Flow control DSC tolerance" from 24 pages to 48 pages
+	    to prevent the hardware may drop incoming packets
+	    after flow control triggered and Pause frame sent */
+	REG32(MACCR)= (REG32(MACCR) & ~CF_FCDSC_MASK) | (0x30 << CF_FCDSC_OFFSET);
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+
+	return 0;
+}
+#endif
+
+#if defined(CONFIG_RTL_8198C)
+// if oper = 0 (read), sramdata is ignored
+void Sram98C(uint32 phyid, uint32 oper, uint32 RegAddr, uint32 sramdata)
+{
+	uint32 srdata=0;
+	uint32 i, wphyid=0;	//start
+	uint32 wphyid_end=1;   //end
+
+	if(phyid==999)
+	{	i=0;
+		wphyid_end=5;    //total phyid=0~4
+	}
+	else
+	{	i=phyid;
+		wphyid_end=phyid+1;
+	}
+
+	for(; i<wphyid_end; i++)
+	{
+		wphyid = i;
+		//change page
+		if (i == 0)
+			wphyid = RTL8198C_PORT0_PHY_ID;
+
+		if (oper == 0) { // read
+
+			rtl8651_setAsicEthernetPHYReg( wphyid, 31, 0x0a43  );
+			rtl8651_setAsicEthernetPHYReg( wphyid, 27, RegAddr  );
+			rtl8651_getAsicEthernetPHYReg( wphyid, 28, &srdata  );
+			rtl8651_setAsicEthernetPHYReg( wphyid, 31, 0  );
+			panic_printk("phy= %d, RegAddr 0x%x = 0x%x\n",wphyid, RegAddr, ((srdata & 0xff00)>>8));
+		}
+		else if (oper == 1) { // write
+
+			rtl8651_setAsicEthernetPHYReg( wphyid, 31, 0x0a43  );
+			rtl8651_setAsicEthernetPHYReg( wphyid, 27, RegAddr  );
+			rtl8651_getAsicEthernetPHYReg( wphyid, 28, &srdata  );
+
+			rtl8651_setAsicEthernetPHYReg( wphyid, 27, RegAddr  );
+			rtl8651_setAsicEthernetPHYReg( wphyid, 28, ((sramdata << 8) | (srdata & 0x00ff)) );
+			rtl8651_setAsicEthernetPHYReg( wphyid, 31, 0  );
+		}
+	}
+}
+
+#if 0
+// mode=0: disable; 1:enable
+void giga_lite_eee(int mode)
+{
+	int i;
+
+	if (mode == 1) {
+		// enable 500M eee capability, page a4a, reg17, bit9=1
+		Set_GPHYWB(999, 0xa4a, 17, 0xffff-(0x0200), 0x0200);
+
+		// Enable MAC EEE ability for 500M port, 0xbb805108~1c bit12=1
+		for(i=0; i<=5; i++) {
+			REG32(EXTPCR0+i*4) |= (FRC_Pn_EEE_GELITE);
+		}
+	}
+	else if (mode == 0) {
+		Set_GPHYWB(999, 0xa4a, 17, 0xffff-(0x0200), 0);
+
+		for(i=0; i<=5; i++) {
+			REG32(EXTPCR0+i*4) &= ~(FRC_Pn_EEE_GELITE);
+		}
+	}
+}
+#endif
+
+// mode=0: disable; 1:enable
+void set_giga_lite(int mode)
+{
+	int i;
+
+	giga_lite_enabled = mode;
+
+	if (mode == 1) {
+		phy_link_sts = 0;
+		// enable 500M, page a42, reg20, bit7,9=11
+		Set_GPHYWB(999, 0xa42, 20, 0xffff-(0x0280), 0x0280);
+
+		// MAC set 500M ability, enable 500M bit0,1=0b11
+		for(i=0; i<=5; i++) {
+			//REG32(EXTPCR0+i*4) |= (CF_HW_500M_AN | CF_500M_EN);
+			//REG32(EXTPCR0+i*4) |= (CF_500M_EN);
+			REG32(EXTPCR0+i*4) &= ~(CF_HW_500M_AN | CF_500M_EN);
+		}
+	}
+	else if (mode == 0) {
+		Set_GPHYWB(999, 0xa42, 20, 0xffff-(0x0280), 0);
+
+		for(i=0; i<=5; i++) {
+			REG32(EXTPCR0+i*4) &= ~(CF_HW_500M_AN | CF_500M_EN);
+		}
+	}
+}
+
+#ifdef CONFIG_RTL_GIGA_LITE_REFINE
+#if !defined(CONFIG_RTD_1295_HWNAT)
+static int _8198c_link_speed = 0;
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+void set_giga_lite2(void)
+{
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	int i, phyid;
+	uint32 phyData, data2;
+	uint32 cur_link_sts=0;
+
+	for(i=0; i<5; i++) {
+		if (i==0)
+			phyid = RTL8198C_PORT0_PHY_ID;
+		else
+			phyid = i;
+		rtl8651_getAsicEthernetPHYReg(phyid, 1, &phyData);
+
+		/*check link status*/
+		if (phyData & (1<<2))
+			cur_link_sts |= (1<<i);
+
+		if ((phy_link_sts & (1<<i)) != (cur_link_sts & (1<<i))) {
+
+			if (phyData & (1<<2)) {		// link up
+
+				//Link Speed check bit4,5
+				//00:10M, 01:100M, 10:1000M, 11:500M
+				//page a43, reg26
+				rtl8651_setAsicEthernetPHYReg(phyid, 31, 0xa43);
+				rtl8651_getAsicEthernetPHYReg(phyid, 26, &data2);
+				rtl8651_setAsicEthernetPHYReg(phyid, 31, 0);
+
+				if ((data2 & 0x30) == 0x30) { // link at 500Mbps
+					_8198c_link_speed |= (1<<i);
+					//REG32(EXTPCR0+i*4) |= (CF_HW_500M_AN);
+					REG32(EXTPCR0+i*4) |= (CF_HW_500M_AN | CF_500M_EN);
+				}
+			}
+			else {		// link down
+
+				if (_8198c_link_speed & (1<<i)) {
+					//REG32(EXTPCR0+i*4) &= ~(CF_HW_500M_AN);
+					REG32(EXTPCR0+i*4) &= ~(CF_HW_500M_AN | CF_500M_EN);
+					rtl8651_restartAsicEthernetPHYNway(i);
+					mdelay(100);
+					_8198c_link_speed &= ~(1<<i);
+				}
+			}
+		}
+	}
+	phy_link_sts = cur_link_sts;
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+}
+#endif
+
+static const unsigned int phy_98c_para[]={
+
+	27, 0xB820,
+	28, 0x0290,
+	27, 0xA012,
+	28, 0x0000,
+	27, 0xA014,
+	28, 0x2c04,
+	28, 0x2c12,
+	28, 0x2c14,
+	28, 0x2c14,
+	28, 0x8620,
+	28, 0xa480,
+	28, 0x609f,
+	28, 0x3084,
+	28, 0x58ae,
+	28, 0x2c06,
+	28, 0xd710,
+	28, 0x6096,
+	28, 0xd71e,
+	28, 0x7fa4,
+	28, 0x28ae,
+	28, 0x8480,
+	28, 0xa101,
+	28, 0x2a65,
+	28, 0x8104,
+	28, 0x0800,
+	27, 0xA01A,
+	28, 0x0000,
+	27, 0xA006,
+	28, 0x0fff,
+	27, 0xA004,
+	28, 0x0fff,
+	27, 0xA002,
+	28, 0x05e9,
+	27, 0xA000,
+	28, 0x3a5a,
+	27, 0xB820,
+	28, 0x0210,
+};
+
+int phy_refine(void)
+{
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	int i,j,pid,ready=0,len;
+	uint32 data;
+
+	for(i=0;i<5;i++)
+	{
+		if (i==0)
+			pid = RTL8198C_PORT0_PHY_ID;
+		else
+			pid = i;
+
+		// refine request & wait ready
+		Set_GPHYWB(pid, 0xb82, 16, (0xffff & ~(1<<4)), (1<<4));
+
+		rtl8651_setAsicEthernetPHYReg( pid, 31, 0xb80 );
+		while (!ready)
+		{
+			rtl8651_getAsicEthernetPHYReg( pid, 16, &data );
+			ready = (data >> 6) & 0x1;
+		}
+		rtl8651_setAsicEthernetPHYReg( pid, 31, 0);
+
+		// set key & lock
+		rtl8651_setAsicEthernetPHYReg( pid, 27, 0x8146);
+		rtl8651_setAsicEthernetPHYReg( pid, 28, 0x4800);
+		rtl8651_setAsicEthernetPHYReg( pid, 27, 0xb82e);
+		rtl8651_setAsicEthernetPHYReg( pid, 28, 0x0001);
+
+		// NCTL refine
+		len = sizeof(phy_98c_para)/sizeof(unsigned int);
+		for(j=0;j<len;j=j+2)
+		{
+			rtl8651_setAsicEthernetPHYReg(pid, phy_98c_para[j], phy_98c_para[j+1]);
+		}
+
+		// clear key & lock
+		rtl8651_setAsicEthernetPHYReg( pid, 27, 0x0000);
+		rtl8651_setAsicEthernetPHYReg( pid, 28, 0x0000);
+		Set_GPHYWB(pid, 0xb82, 23, 0, 0x0000);
+		rtl8651_setAsicEthernetPHYReg( pid, 27, 0x8146);
+		rtl8651_setAsicEthernetPHYReg( pid, 28, 0x0000);
+
+		// refine release & wait ready
+		Set_GPHYWB(pid, 0xb82, 16, (0xffff & ~(1<<4)), (0<<4));
+
+		rtl8651_setAsicEthernetPHYReg( pid, 31, 0xb80 );
+		while (ready)
+		{
+			rtl8651_getAsicEthernetPHYReg( pid, 16, &data );
+			ready = (data >> 6) & 0x1;
+		}
+		rtl8651_setAsicEthernetPHYReg( pid, 31, 0);
+	}
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+	return 0;
+}
+
+#ifdef RTL8198C_GPHY_CALIBRATION
+static const unsigned int phy_98c_ado[]={
+	27, 0x83de,
+	28, 0xaf83,
+	28, 0xeaaf,
+	28, 0x83ed,
+	28, 0xaf83,
+	28, 0xf0af,
+	28, 0x83f3,
+	28, 0xaf0c,
+	28, 0x0caf,
+	28, 0x83ed,
+	28, 0xaf83,
+	28, 0xf0af,
+	28, 0x83f3,
+	27, 0xb818,
+	28, 0x0bf1,
+	27, 0xb81a,
+	28, 0xfffd,
+	27, 0xb81c,
+	28, 0xfffd,
+	27, 0xb81e,
+	28, 0xfffd,
+	27, 0xb832,
+	28, 0x0001,
+};
+
+int Ado_RamCode_Efuse(int phyport)
+{
+	unsigned int readReg;
+	int j , len;
+	//#Patch request
+	//#POLL	a46	21	10	8	3
+	//#wr 0xB82 rg16[4] = 1     // set patch_req
+	//#polling 0xB80 rg16[6] = 1   // patch rdy
+
+	while(1)
+	{
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0xa46 );
+		rtl8651_getAsicEthernetPHYReg( phyport, 21, &readReg );
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0);
+
+		if(((readReg >> 8) & 7) == 3)
+			break;
+	}
+
+	Set_GPHYWB(phyport, 0xb82, 16, (0xffff & ~(1<<4)), (1<<4));
+
+	while(1)
+	{
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0xb80 );
+		rtl8651_getAsicEthernetPHYReg( phyport, 16, &readReg );
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0);
+
+		if(((readReg >> 6) & 1) == 1)
+			break;
+	}
+
+	len = sizeof(phy_98c_ado)/sizeof(unsigned int);
+	for(j=0;j<len;j=j+2)
+	{
+		Set_GPHYWB(phyport, 0, phy_98c_ado[j], 0, phy_98c_ado[j+1]);
+	}
+
+	//#Patch request clear
+	//#wr 0xB82 rg16[4] = 0
+	Set_GPHYWB(phyport, 0xb82, 16, (0xffff & ~(1<<4)), (0<<4));
+	return 0;
+}
+#endif
+
+void ado_default(void)
+{
+	int phyport, i;
+
+	for(i=0;i<5;i++)
+	{
+		if (i==0)
+			phyport = 8;
+		else
+			phyport = i;
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+		Ado_RamCode_Efuse(phyport);
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+		//#adc_ioffset adjustment
+		Set_GPHYWB(phyport, 0xbcf, 22, 0, 0x7777);
+		Set_GPHYWB(phyport, 0, 0, ~(1<<9), (1<<9));
+	}
+}
+
+static const unsigned int phy_ado_patch[]={
+	27, 0x83de,
+	28, 0xaf83,
+	28, 0xeaaf,
+	28, 0x83f1,
+	28, 0xaf83,
+	28, 0xf4af,
+	28, 0x8438,
+	28, 0x0d42,
+	28, 0x583f,
+	28, 0xaf32,
+	28, 0x53af,
+	28, 0x0c0c,
+	28, 0xe482,
+	28, 0x4502,
+	28, 0x83fd,
+	28, 0xaf30,
+	28, 0xc9f8,
+	28, 0xf9fa,
+	28, 0xef69,
+	28, 0xfafb,
+	28, 0xbf87,
+	28, 0xf7d1,
+	28, 0x08ec,
+	28, 0x0019,
+	28, 0xb1fb,
+	28, 0xd204,
+	28, 0x82d6,
+	28, 0x0000,
+	28, 0xd380,
+	28, 0x0233,
+	28, 0x311a,
+	28, 0x67b3,
+	28, 0xf90d,
+	28, 0x67ef,
+	28, 0x120c,
+	28, 0x11bf,
+	28, 0x87f7,
+	28, 0x1a91,
+	28, 0xef46,
+	28, 0xdc19,
+	28, 0xdda2,
+	28, 0x00e0,
+	28, 0xfffe,
+	28, 0xef96,
+	28, 0xfefd,
+	28, 0xfc04,
+	28, 0xaf84,
+	28, 0x3800,
+	27, 0xb818,
+	28, 0x3251,
+	27, 0xb81a,
+	28, 0x0bf1,
+	27, 0xb81c,
+	28, 0x30c6,
+	27, 0xb81e,
+	28, 0xfffd,
+	27, 0xb832,
+	28, 0x0007,
+	31, 0x0000,
+};
+
+void Ado_RamCode(int phyport)
+{
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	unsigned int readReg;
+	int j , len;
+	//#Patch request
+	//#POLL	a46	21	10	8	3
+	//#wr 0xB82 rg16[4] = 1     // set patch_req
+	//#polling 0xB80 rg16[6] = 1   // patch rdy
+
+	while(1)
+	{
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0xa46 );
+		rtl8651_getAsicEthernetPHYReg( phyport, 21, &readReg );
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0);
+
+		if(((readReg >> 8) & 7) == 3)
+			break;
+	}
+
+	Set_GPHYWB(phyport, 0xb82, 16, (0xffff & ~(1<<4)), (1<<4));
+
+	while(1)
+	{
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0xb80 );
+		rtl8651_getAsicEthernetPHYReg( phyport, 16, &readReg );
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0);
+
+		if(((readReg >> 6) & 1) == 1)
+			break;
+	}
+
+	//#Load patch code
+	len = sizeof(phy_ado_patch)/sizeof(unsigned int);
+	for(j=0;j<len;j=j+2)
+	{
+		Set_GPHYWB(phyport, 0, phy_ado_patch[j], 0, phy_ado_patch[j+1]);
+	}
+
+	//#Patch request clear
+	//#wr 0xB82 rg16[4] = 0
+	Set_GPHYWB(phyport, 0xb82, 16, (0xffff & ~(1<<4)), (0<<4));
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+}
+
+#define _ADC_CAL(ASF, A) \
+	if((A >> 8) == 1) \
+		ASF =  7 - ((256 - (A & 0xFF))  / 9); \
+	else \
+		ASF =  8 + ((A & 0xFF)  / 9);
+
+void Adc_Bias_Cal(int phyport)
+{
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	unsigned int adc_biasA,adc_biasB,adc_biasC,adc_biasD;
+	unsigned int adc_biasAsf;
+	unsigned int adc_mdf=0, readReg;
+
+	//#adc-bias calculate enable
+	//#	wr 0xA47 rg17[9] = 1
+	Set_GPHYWB(phyport, 0xA47, 17, (0xffff & ~(1<<9)), (1<<9));
+	//#Polling adc-bias calculate done
+	//#    polling 0xA47 rg17[9] = 0
+	while(1)
+	{
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0xA47 );
+		rtl8651_getAsicEthernetPHYReg( phyport, 17, &readReg );
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0);
+
+		if(((readReg >> 9) & 1) == 0)
+			break;
+	}
+
+	//#adc-bias calculate dump
+	//#   wr 0xA43 rg27 = 0x87f7
+	//#   rd 0xA43 rg28[8:0]      // read out_int
+	//#// adc_bias_p0 = (out_int - floor(out_int/2^8)*2^9)/2^8; % s9.8f, uc cal ado_dat of portA's avg of 128 point, get portA adc_bias
+	rtl8651_setAsicEthernetPHYReg( phyport, 27, 0x87f7 );
+	rtl8651_getAsicEthernetPHYReg( phyport, 28, &readReg );
+	adc_biasA = readReg & 0x1ff;
+
+	//#   wr 0xA43 rg27 = 0x87f9
+	//#   rd 0xA43 rg28[8:0]      // read out_int
+	//#// adc_bias_p0 = (out_int - floor(out_int/2^8)*2^9)/2^8; % s9.8f, uc cal ado_dat of portA's avg of 128 point, get portB adc_bias
+	rtl8651_setAsicEthernetPHYReg( phyport, 27, 0x87f9 );
+	rtl8651_getAsicEthernetPHYReg( phyport, 28, &readReg );
+	adc_biasB = readReg & 0x1ff;
+
+	//#   wr 0xA43 rg27 = 0x87fb
+	//#   rd 0xA43 rg28[8:0]      // read out_int
+	//#// adc_bias_p0 = (out_int - floor(out_int/2^8)*2^9)/2^8; % s9.8f, uc cal ado_dat of portA's avg of 128 point, get portC adc_bias
+	rtl8651_setAsicEthernetPHYReg( phyport, 27, 0x87fb );
+	rtl8651_getAsicEthernetPHYReg( phyport, 28, &readReg );
+	adc_biasC = readReg & 0x1ff;
+
+	//#   wr 0xA43 rg27 = 0x87fd
+	//#   rd 0xA43 rg28[8:0]      // read out_int
+	//#// adc_bias_p0 = (out_int - floor(out_int/2^8)*2^9)/2^8; % s9.8f, uc cal ado_dat of portA's avg of 128 point, get portD adc_bias
+	rtl8651_setAsicEthernetPHYReg( phyport, 27, 0x87fd );
+	rtl8651_getAsicEthernetPHYReg( phyport, 28, &readReg );
+	adc_biasD = readReg & 0x1ff;
+
+	_ADC_CAL(adc_biasAsf, adc_biasA);
+	adc_mdf |= adc_biasAsf;
+
+	_ADC_CAL(adc_biasAsf, adc_biasB);
+	adc_mdf |= (adc_biasAsf << 4) ;
+
+	_ADC_CAL(adc_biasAsf, adc_biasC);
+	adc_mdf |= (adc_biasAsf << 8);
+
+	_ADC_CAL(adc_biasAsf, adc_biasD);
+	adc_mdf |= (adc_biasAsf << 12);
+
+	//#adc_ioffset adjustment
+	//#1. Ioffset, 4 port's ioffset_pX will set to page 0xBCF reg 22
+	Set_GPHYWB(phyport, 0xbcf, 22, 0, adc_mdf);
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+}
+
+void force_giga_slave(unsigned int pid)
+{
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	/*
+	% dec2hex(mcu_wr('8010','f77b')) % disable force 1G
+	%%% disable force 1G, turn off internal n-way %%%
+	dec2hex(reg_pw('a43', 27, 15,0,'8010'));
+	dec2hex(reg_pw('a43', 28, 11,11,'0'));
+	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+	dec2hex(reg_pw('a46', 21, 1,1,'1'));% lock main
+
+	pcs_state = '0';
+	while (~strcmp(pcs_state , '1'))
+	 pcs_state = dec2hex(reg_pr('0a60',16,7,0));
+	 disp(sprintf('pcs_state = %s', pcs_state ));
+	end
+
+	dec2hex(reg_pw('a40', 0, 15,0,'0140'));% force 1G
+	dec2hex(reg_pw('a4a', 19, 7,6,'2')); %force slave
+	dec2hex(reg_pw('a44', 20, 2,2,'1'));%frc tp1
+	dec2hex(reg_pw('a46', 21, 1,1,'0'));%release lock main
+	*/
+	unsigned int readReg;
+
+	Set_GPHYWB(pid, 0xa43, 27, 0, 0x8010);
+	Set_GPHYWB(pid, 0xa43, 28, (0xffff & ~(1<<11)), (0<<11));
+	Set_GPHYWB(pid, 0xa46, 21, (0xffff & ~(1<<1)), (1<<1));
+
+	while(1)
+	{
+		rtl8651_setAsicEthernetPHYReg( pid, 31, 0xa60 );
+		rtl8651_getAsicEthernetPHYReg( pid, 16, &readReg );
+		rtl8651_setAsicEthernetPHYReg( pid, 31, 0);
+		if((readReg & 0xff) == 1)
+			break;
+	}
+
+	Set_GPHYWB(pid, 0xa40, 0, 0, 0x0140);
+	Set_GPHYWB(pid, 0xa4a, 19, (0xffff & ~(3<<6)), (2<<6));
+	Set_GPHYWB(pid, 0xa44, 20, (0xffff & ~(1<<2)), (1<<2));
+	Set_GPHYWB(pid, 0xa46, 21, (0xffff & ~(1<<1)), (0<<1));
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+}
+
+void Release_Force_slave(unsigned int pid)
+{
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	/*
+	wr 0xA43 rg27 = 0x8010
+	wr 0xA43 rg28 = 0xFF77   // set bit11=1
+	wr 0xA46 rg21[1] = 1     // lock main
+	wr 0xA40 rg16 = 0x1040   // disable force 1G, external n-way on
+	wr 0xA4A rg19[7:6] = 2'b 00 // disable force slave
+	wr 0xA44 rg20[2] = 1'b0   // disable frc tp1
+	wr 0xA46 rg21[1] = 1'b0   // release main
+	*/
+	Set_GPHYWB(pid, 0xa43, 27, 0, 0x8010);
+	Set_GPHYWB(pid, 0xa43, 28, (0xffff & ~(1<<11)), (1<<11));
+	Set_GPHYWB(pid, 0xa46, 21, (0xffff & ~(1<<1)), (1<<1));
+
+	Set_GPHYWB(pid, 0xa40, 0, 0, 0x1040);
+	Set_GPHYWB(pid, 0xa4a, 19, (0xffff & ~(3<<6)), (0<<6));
+	Set_GPHYWB(pid, 0xa44, 20, (0xffff & ~(1<<2)), (0<<2));
+	Set_GPHYWB(pid, 0xa46, 21, (0xffff & ~(1<<1)), (0<<1));
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+}
+
+void ado_modified(void)
+{
+	int phyport, i;
+
+	for(i=0;i<5;i++)
+	{
+		if (i==0)
+			phyport = 8;
+		else
+			phyport = i;
+
+		//#Initial
+		//#1. Green disable
+		//#	wr 0xA43 rg27 = 0x8011
+		//# wr 0xA43 rg28[15] = 0    (default f777)
+		Set_GPHYWB(phyport, 0xa43, 27, 0, 0x8011);
+		Set_GPHYWB(phyport, 0xa43, 28, (0xffff & ~(1<<15)), (0<<15));
+		//#3. set slave_sd_thd to MAX
+		//#      wr 0xA43 rg27 = 0x8120
+		//#      wr 0xA43 rg28 = 0xff00
+		Set_GPHYWB(phyport, 0xa43, 27, 0, 0x8120);
+		Set_GPHYWB(phyport, 0xa43, 28, 0, 0xff00);
+		//#4. Force PGA
+		//#      wr 0xA81 rg16[4:0] = 5'b0     //external PGA level selection
+		//#      wr 0xa81 rg16[9:6] = 4'b1111   //force aagc_code to aagc_reg.
+		Set_GPHYWB(phyport, 0xa81, 16, (0xffff & ~(0x1f<<0)), (0<<0));
+		Set_GPHYWB(phyport, 0xa81, 16, (0xffff & ~(0xf<<6)), (0xf<<6));
+
+		//#Load patch code
+		Ado_RamCode(phyport);
+
+		//#Force_slave_TP1
+		force_giga_slave(phyport);
+
+		//#adc-bias calculate enable
+		//#adc_ioffset adjustment
+		Adc_Bias_Cal(phyport);
+
+		//#Release_Force_slave_TP1
+		Release_Force_slave(phyport);
+
+		//# backfill
+		//#1. set slave_sd_thd to default
+		//#      wr 0xA43 rg27 = 0x8120
+		//#      wr 0xA43 rg28 = 0x0e00
+		rtl8651_setAsicEthernetPHYReg( phyport, 27, 0x8120 );
+		rtl8651_setAsicEthernetPHYReg( phyport, 28, 0x0e00);
+		//#2. Release Force PGA
+		//#      wr 0xA81 rg16 = 0x0000  //  set bit[4:0]=5b'0 & set bit[9:6]=4b'0
+		Set_GPHYWB(phyport, 0xA81, 16, 0, 0);
+		//#3. Green enable
+		//#	wr 0xA43 rg27 = 0x8011
+		//#	wr 0xa43 rg28 = 0xf777    // set bit15=1
+		rtl8651_setAsicEthernetPHYReg( phyport, 27, 0x8011 );
+		rtl8651_setAsicEthernetPHYReg( phyport, 28, 0xf777);
+		//#
+		//#5. Reset phy
+		//#wr 0xA40 rg16 = 0x9200    //Phy reset
+		Set_GPHYWB(phyport, 0xA40, 16, 0, 0x9200);
+	}
+}
+
+void ado_setting(int mode)
+{
+	if (mode == 0)
+		ado_default();
+	else if (mode == 1)
+		ado_modified();
+}
+
+static const unsigned int phy_ado_data[]={
+	27, 0x83de,
+	28, 0xaf83,
+	28, 0xeaaf,
+	28, 0x83ed,
+	28, 0xaf85,
+	28, 0x85af,
+	28, 0x8588,
+	28, 0xaf0c,
+	28, 0x0cf6,
+	28, 0x0102,
+	28, 0x83f5,
+	28, 0xaf00,
+	28, 0x8ff8,
+	28, 0xf9cd,
+	28, 0xf9fa,
+	28, 0xef69,
+	28, 0xfafb,
+	28, 0xe080,
+	28, 0x13ac,
+	28, 0x2303,
+	28, 0xaf85,
+	28, 0x21d1,
+	28, 0x00bf,
+	28, 0x8597,
+	28, 0x0241,
+	28, 0x05d1,
+	28, 0x0fbf,
+	28, 0x859a,
+	28, 0x0241,
+	28, 0x05bf,
+	28, 0x859d,
+	28, 0x0245,
+	28, 0xbbbf,
+	28, 0x85a0,
+	28, 0x0245,
+	28, 0xb3bf,
+	28, 0x85a3,
+	28, 0x0245,
+	28, 0xb3bf,
+	28, 0x85a6,
+	28, 0x0245,
+	28, 0xb3ee,
+	28, 0x87f4,
+	28, 0x001f,
+	28, 0x44e0,
+	28, 0x87f4,
+	28, 0xbfa8,
+	28, 0xc4ef,
+	28, 0x591a,
+	28, 0x54e6,
+	28, 0x87f5,
+	28, 0xe787,
+	28, 0xf6e1,
+	28, 0x87f4,
+	28, 0xd000,
+	28, 0xbf85,
+	28, 0x8b4c,
+	28, 0x0003,
+	28, 0x1a49,
+	28, 0xe487,
+	28, 0xf7e5,
+	28, 0x87f8,
+	28, 0xee87,
+	28, 0xf907,
+	28, 0xee87,
+	28, 0xfaff,
+	28, 0xee87,
+	28, 0xfb00,
+	28, 0xee87,
+	28, 0xfc10,
+	28, 0xee87,
+	28, 0xfd00,
+	28, 0x0285,
+	28, 0x2bef,
+	28, 0x67ad,
+	28, 0x5f03,
+	28, 0x7fff,
+	28, 0xffe2,
+	28, 0x87f9,
+	28, 0xe387,
+	28, 0xfa09,
+	28, 0xef56,
+	28, 0xef67,
+	28, 0x0bc6,
+	28, 0x0244,
+	28, 0xf4ad,
+	28, 0x5015,
+	28, 0xcce4,
+	28, 0x87f9,
+	28, 0xe587,
+	28, 0xfae0,
+	28, 0x87f7,
+	28, 0xe187,
+	28, 0xf8ef,
+	28, 0x9402,
+	28, 0x4143,
+	28, 0xe587,
+	28, 0xfee1,
+	28, 0x87fd,
+	28, 0x3904,
+	28, 0x9e38,
+	28, 0xe187,
+	28, 0xfd11,
+	28, 0xe587,
+	28, 0xfde0,
+	28, 0x87f7,
+	28, 0xe187,
+	28, 0xf8ef,
+	28, 0x9402,
+	28, 0x4143,
+	28, 0xad37,
+	28, 0x08e5,
+	28, 0x87fc,
+	28, 0xe087,
+	28, 0xfbae,
+	28, 0x06e5,
+	28, 0x87fb,
+	28, 0xe087,
+	28, 0xfc1a,
+	28, 0x100d,
+	28, 0x11d0,
+	28, 0x0008,
+	28, 0xe087,
+	28, 0xf7e1,
+	28, 0x87f8,
+	28, 0xef94,
+	28, 0x0802,
+	28, 0x4105,
+	28, 0xae8e,
+	28, 0xe187,
+	28, 0xfed0,
+	28, 0x0008,
+	28, 0xe087,
+	28, 0xf7e1,
+	28, 0x87f8,
+	28, 0xef94,
+	28, 0x0802,
+	28, 0x4105,
+	28, 0xe187,
+	28, 0xf439,
+	28, 0x039e,
+	28, 0x0ae1,
+	28, 0x87f4,
+	28, 0x11e5,
+	28, 0x87f4,
+	28, 0xaf84,
+	28, 0x33d1,
+	28, 0x00bf,
+	28, 0x859a,
+	28, 0x0241,
+	28, 0x05bf,
+	28, 0x85a6,
+	28, 0x0245,
+	28, 0xbbbf,
+	28, 0x859d,
+	28, 0x0245,
+	28, 0xb3bf,
+	28, 0x85a0,
+	28, 0x0245,
+	28, 0xbbbf,
+	28, 0x85a3,
+	28, 0x0245,
+	28, 0xbbff,
+	28, 0xfeef,
+	28, 0x96fe,
+	28, 0xfdc5,
+	28, 0xfdfc,
+	28, 0x04f8,
+	28, 0xf9fa,
+	28, 0xef69,
+	28, 0xfa1f,
+	28, 0x441f,
+	28, 0x77e2,
+	28, 0x87f5,
+	28, 0xe387,
+	28, 0xf6ef,
+	28, 0x95e2,
+	28, 0x87f3,
+	28, 0x1f66,
+	28, 0x160c,
+	28, 0x61b2,
+	28, 0xfcda,
+	28, 0x19db,
+	28, 0x890c,
+	28, 0x570d,
+	28, 0x581a,
+	28, 0x45ef,
+	28, 0x54ef,
+	28, 0x323a,
+	28, 0x7f9e,
+	28, 0x063b,
+	28, 0x809e,
+	28, 0x08ae,
+	28, 0x0a17,
+	28, 0x5c00,
+	28, 0xffae,
+	28, 0x0487,
+	28, 0x6cff,
+	28, 0x00b6,
+	28, 0xdc4f,
+	28, 0x007f,
+	28, 0x0d48,
+	28, 0x1a74,
+	28, 0xe087,
+	28, 0xf338,
+	28, 0x089e,
+	28, 0x050d,
+	28, 0x7180,
+	28, 0xaef9,
+	28, 0xfeef,
+	28, 0x96fe,
+	28, 0xfdfc,
+	28, 0x04af,
+	28, 0x8585,
+	28, 0xaf85,
+	28, 0x8830,
+	28, 0xbcfc,
+	28, 0x74bc,
+	28, 0xfcb8,
+	28, 0xbcfc,
+	28, 0xfcbc,
+	28, 0xfc40,
+	28, 0xa810,
+	28, 0x96a8,
+	28, 0x10aa,
+	28, 0xbcd2,
+	28, 0xccbc,
+	28, 0xd2ee,
+	28, 0xbcd2,
+	28, 0xffbc,
+	28, 0xd200,
+	27, 0xb818,
+	28, 0x0bf1,
+	27, 0xb81a,
+	28, 0x008d,
+	27, 0xb81c,
+	28, 0xfffd,
+	27, 0xb81e,
+	28, 0xfffd,
+	27, 0xb832,
+	28, 0x0003,
+	31, 0x0000,
+	27, 0x87f2,
+	28, 0x000f,
+};
+
+int phy_ready(int phyport)
+{
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	uint32 readReg, count=0;
+
+	while(1)
+	{
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0xa46 );
+		rtl8651_getAsicEthernetPHYReg( phyport, 21, &readReg );
+		rtl8651_setAsicEthernetPHYReg( phyport, 31, 0);
+
+		if(((readReg >> 8) & 7) == 2)
+			return 1;
+		else if((count++) >= 10)
+			return 0;
+	}
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+	return 0;
+}
+
+/*
+ must do this adc refinement in phy_state 2 (page 0xa46, reg 21, bit 9-8),
+ so put ado_refine() in bsp_swcore_init() of setup.c.
+ if we do ado_refine() in re865x_probe(), the phy_state will be 3.
+ */
+#if !defined(CONFIG_RTD_1295_HWNAT)
+void ado_refine(void)
+{
+	int i,phyport;
+	int j, len;
+	uint32 readReg;
+	unsigned int efuse_value[5] ;
+
+	REG32(SYS_CLK_MAG) |= CM_ACTIVE_SWCORE;
+
+	for(i=0;i<5;i++) {
+		REG32(PCRP0+i*4) |= (EnForceMode);
+		efuse_value[i] = 0;
+	}
+
+	if ((REG32(REVR) & 0xfff) > 0) {
+		REG32(EFUSE_TIMING_CONTROL)=0x030c174f;
+		REG32(EFUSE_CONFIG)=0x00040112;
+
+		for(i=0; i<5; i++) {
+			REG32(EFUSE_CONFIG) |= EFUSE_CFG_INT_STS;		/* clear efuse interrupt status bit */
+			REG32(EFUSE_CMD) = i;
+			while( ( REG32(EFUSE_CONFIG) & EFUSE_CFG_INT_STS ) == 0 );		/* Wait efuse_interrupt */
+			efuse_value[i] = REG32(EFUSE_RW_DATA);
+		}
+	}
+
+	rtl8651_getAsicEthernetPHYReg( RTL8198C_PORT0_PHY_ID, 0, &readReg );
+
+	for(i=0;i<5;i++)
+	{
+		if (i==0)
+			phyport = RTL8198C_PORT0_PHY_ID;
+		else
+			phyport = i;
+
+		rtl8651_getAsicEthernetPHYReg( phyport, 0, &readReg );
+
+		if((readReg & POWER_DOWN) == 0) // power_down=1, do it
+			continue;
+
+		if ((phy_ready(phyport)) == 0) // phy state=2, do it
+			continue;
+
+		if ((efuse_value[i] & 0x80))   // bit7=0, do it
+			continue;
+
+		len = sizeof(phy_ado_data)/sizeof(unsigned int);
+		for(j=0;j<len;j=j+2)
+		{
+			Set_GPHYWB(phyport, 0, phy_ado_data[j], 0, phy_ado_data[j+1]);
+		}
+	}
+}
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+int Setting_RTL8198C_GPHY(void)
+{
+	int i, phyid;
+	unsigned int data;
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+#if 0
+	// phy power down
+	Set_GPHYWB(999, 0, 0, 0, 0x1900);
+	// reset phy register
+	Set_GPHYWB(999, 0xc41, 20, 0, 1);
+	mdelay(50);
+	Set_GPHYWB(999, 0, 0, 0, 0x8000);
+	mdelay(300);
+#endif
+
+	phy_refine();
+
+	// to disable the PCS INT (GPHY PCS interrupt (MAC_INTRUPT  signal )).
+	Set_GPHYWB(999, 0xa42, 18, 0, 0);
+
+	// read to clear INT status.
+	for(i=0; i<5; i++) {
+		phyid = rtl8651AsicEthernetTable[i].phyId;
+
+		rtl8651_setAsicEthernetPHYReg( phyid, 31, 0xa42);
+		rtl8651_getAsicEthernetPHYReg( phyid, 29, &data);
+		rtl8651_setAsicEthernetPHYReg( phyid, 31, 0);
+	}
+
+	// fix MDI 10pf codedsp shift
+	Set_GPHYWB(999, 0xBCD, 21, 0, 0x2222);	// codedsp register = 2
+	Set_GPHYWB(999, 0, 27, 0, 0x8277);
+	Set_GPHYWB(999, 0, 28, 0xffff - 0xff00, 0x02 << 8);	// uc codedsp = 2
+
+	// giga master sd_thd
+	Set_GPHYWB(999, 0, 27, 0, 0x8101);
+	Set_GPHYWB(999, 0, 28, 0, 0x4000);
+
+	/* enlarge "Flow control DSC tolerance" from 36 pages to 48 pages
+	    to prevent the hardware may drop incoming packets
+	    after flow control triggered and Pause frame sent */
+	REG32(MACCR)= (REG32(MACCR) & ~CF_FCDSC_MASK) | (0x30 << CF_FCDSC_OFFSET);
+
+	/* set "System clock selection" to 100MHz
+		2'b00: 50MHz, 2'b01: 100MHz, 2'b10, 2'b11 reserved
+	*/
+	REG32(MACCR)= (REG32(MACCR) & ~(CF_SYSCLK_SEL_MASK)) | (0x01 << CF_SYSCLK_SEL_OFFSET);
+
+	/* set "Cport MAC clock selection with NIC interface" to lx_clk */
+	REG32(MACCTRL1) |= CF_CMAC_CLK_SEL;
+
+#ifdef RTL8198C_GPHY_CALIBRATION
+	{
+	unsigned int efuse_value[5] ;
+	unsigned int cali_rc[5] ; // bit 31 ~ 28
+	unsigned int cali_r[5] ; // bit 27 ~ 24
+
+	REG32(EFUSE_TIMING_CONTROL)=0x030c174f;
+	REG32(EFUSE_CONFIG)=0x00040112;
+
+	//read efuse
+	for(i=0; i<5; i++) {
+
+		REG32(EFUSE_CONFIG) |= EFUSE_CFG_INT_STS;		/* clear efuse interrupt status bit */
+		REG32(EFUSE_CMD) = i;
+		while( ( REG32(EFUSE_CONFIG) & EFUSE_CFG_INT_STS ) == 0 );		/* Wait efuse_interrupt */
+		efuse_value[i] = REG32(EFUSE_RW_DATA);
+		cali_rc[i] = (efuse_value[i] >> 28) & 0xF;
+		cali_r[i] = (efuse_value[i] >> 24) & 0xF;
+	}
+
+	// to backfill RC & R value
+	for(i=0; i<5; i++) {
+		phyid = rtl8651AsicEthernetTable[i].phyId;
+
+		rtl8651_setAsicEthernetPHYReg( phyid, 31, 0xbcd);
+
+		if ((cali_rc[i] != 0) && (cali_rc[i] != 0xF)) {
+			rtl8651_setAsicEthernetPHYReg( phyid, 0x16, (cali_rc[i] | (cali_rc[i] << 4) | (cali_rc[i] << 8) | (cali_rc[i] << 12)));
+			rtl8651_setAsicEthernetPHYReg( phyid, 0x17, (cali_rc[i] | (cali_rc[i] << 4) | (cali_rc[i] << 8) | (cali_rc[i] << 12)));
+		}
+
+		rtl8651_setAsicEthernetPHYReg( phyid, 31, 0xbce);
+
+		if ((cali_r[i] != 0) && (cali_r[i] != 0xF)) {
+			rtl8651_setAsicEthernetPHYReg( phyid, 0x10, (cali_r[i] | (cali_r[i] << 4) | (cali_r[i] << 8) | (cali_r[i] << 12)));
+			rtl8651_setAsicEthernetPHYReg( phyid, 0x11, (cali_r[i] | (cali_r[i] << 4) | (cali_r[i] << 8) | (cali_r[i] << 12)));
+		}
+
+		rtl8651_setAsicEthernetPHYReg( phyid, 31, 0);
+	}
+
+	for(i=0;i<5;i++)
+	{
+		if ((efuse_value[i] & 0x80)) { // bit7 = 1, efuse has been calibrated
+		 	// to backfill ADC-bias offset value
+			phyid = rtl8651AsicEthernetTable[i].phyId;
+			Ado_RamCode_Efuse(phyid);
+			Set_GPHYWB(i, 0xbcf, 22, 0, (efuse_value[i]>>8)&0xffff);
+		}
+	}
+	}
+#endif
+
+#if 1
+	//giga Green setting
+	Sram98C(999, 1, 0x809a, 0x89);
+	Sram98C(999, 1, 0x809b, 0x11);
+	Sram98C(999, 1, 0x80a3, 0x92);
+	Sram98C(999, 1, 0x80a4, 0x33);
+	Sram98C(999, 1, 0x80a0, 0x0);
+
+	//100M Green setting
+	Sram98C(999, 1, 0x8088, 0x89);
+	Sram98C(999, 1, 0x8089, 0x11);
+	Sram98C(999, 1, 0x808e, 0x0);
+#endif
+
+#ifdef CONFIG_RTL_GIGA_LITE_ENABLED
+	set_giga_lite(1);
+#endif
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+
+	return 0;
+}
+#endif
+
+#if defined(CONFIG_RTL_8881A)
+int Setting_RTL8881A_PHY(void)
+{
+	int i;
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+#if 0
+		// Page1, Reg23, Vref[7:6] 10
+		Set_GPHYWB(999, 1, 23, 0xffff-(3<<6), 2<<6);
+
+		// Page1, Reg16, cf1[6:4] 110->001
+		Set_GPHYWB(999, 1, 16, 0xffff-((7<<4)), ((1<<4)));
+
+		Set_GPHYWB(999,1, 29, 0xFFFE, 0x0);
+		mdelay(1);
+		Set_GPHYWB(999,0, 0, 0xffff, 0x200);
+		mdelay(1);
+		Set_GPHYWB(999,1, 29, 0xffff, 0x1);
+		mdelay(1);
+		Set_GPHYWB(999,0, 21, 0xff00, (1<<1|1<<4|1<<5));
+		mdelay(1);
+#else
+if(((REG32(0xb8000000)&0xff)>0))
+{
+	#define PLL2 0xb8000058
+	REG32(PLL2 )|=(5<<6);//20120906:Set RBG_L[8:6]=101 from RDC suggestion
+
+	Set_GPHYWB(999, 1, 23, 0xffff-(3<<6), 2<<6);//SwitchPatch #2 Page1,Reg.23[7:6] = 10
+	mdelay(1);
+	Set_GPHYWB(999, 1, 16, 0xffff-(7<<4), 1<<4);//SwitchPatch #3 Page1,Reg.16[6:4] = 001
+	mdelay(1);
+	//Set_GPHYWB(999, 1, 29, 0xffff-(1<<0), 0<<0);//SwitchPatch #4 Page1,Reg.29[0] = 0 //A cut don't need it
+	//Set_GPHYWB(999, 0, 0, 0xffff-(1<<9), 1<<9);//SwitchPatch #4 Page0,Reg.0[9] = 1 //A cut don't need it
+	//Set_GPHYWB(999, 1, 29, 0xffff-(1<<0), 1<<0);//SwitchPatch #4 Page1.Reg.29[0] =1 //A cut don't need it
+
+	//write page 31 = reg4 to check the PHY parameter
+
+	Set_GPHYWB(999, 4, 16, 0, 0x4077);//SwitchPatch #5 Page4,Reg.16 = 0x4077
+	mdelay(1);
+	Set_GPHYWB(999, 4, 24, 0, 0xc0f3);//SwitchPatch #6 Page4,Reg.24 = 0xc0f3
+	mdelay(1);
+	Set_GPHYWB(999, 4, 25, 0, 0x7630);//SwitchPatch #7 Page4,Reg.25 = 0x7630
+	mdelay(1);
+	//REG32( 0xBB804160)=0x0E739CE7 ;//SwitchPatch #8 BB804160 = 0x0E739CE7 ,Set EEE MAC register
+	REG32( 0xBB804160)=0x0 ;//SwitchPatch #8 BB804160 = 0x0E739CE7 ,Set EEE MAC register
+	mdelay(1);
+	Set_GPHYWB(999, 0, 21, 0xffff-(15<<4), 2<<4);//Patch #9 Page0,Reg.21[7:4]=0010  ,Set Green ethernet
+	mdelay(1);
+	Set_GPHYWB(999, 0, 21, 0xffff-(15<<0), 1<<0);//Patch #10 Page0,Reg.21[3:0]=0001  ,Set Green ethernet
+	mdelay(1);
+	Set_GPHYWB(999, 1, 19, 0xffff-(3<<3), 1<<3);//Patch #11 Page1,Reg.19[4:3]=01  ,....corner internetl SWR Pass 1.12V
+	mdelay(1);
+	Set_GPHYWB(999, 1, 17, 0xffff-(1<<14), 1<<14);//Patch #12 Page1,Reg.17[14]=1  ,Fix Low SNR issue.
+	mdelay(1);
+	Set_GPHYWB(999, 1, 16, 0xffff-(3<<12), 0<<0);//Patch #13 Page1,Reg.16[13:12]=00  ,IOL For 10M MAU
+	mdelay(1);
+}
+else
+{
+	Set_GPHYWB(999, 1, 23, 0xffff-(3<<6), 2<<6);//SwitchPatch #2 Page1,Reg.23[7:6] = 10
+	mdelay(1);
+	Set_GPHYWB(999, 1, 16, 0xffff-(7<<4), 1<<4);//SwitchPatch #3 Page1,Reg.16[6:4] = 001
+	mdelay(1);
+	Set_GPHYWB(999, 1, 29, 0xffff-(1<<0), 0<<0);//SwitchPatch #4 Page1,Reg.29[0] = 0 //A cut don't need it
+	mdelay(1);
+	Set_GPHYWB(999, 0, 0, 0xffff-(1<<9), 1<<9);//SwitchPatch #4 Page0,Reg.0[9] = 1 //A cut don't need it
+	mdelay(1);
+	Set_GPHYWB(999, 1, 29, 0xffff-(1<<0), 1<<0);//SwitchPatch #4 Page1.Reg.29[0] =1 //A cut don't need it
+	mdelay(1);
+
+	//write page 31 = reg4 to check the PHY parameter
+
+	Set_GPHYWB(999, 4, 16, 0, 0x7377);//SwitchPatch #5 Page4,Reg.16 = 0x7377
+	mdelay(1);
+	Set_GPHYWB(999, 4, 24, 0, 0xc0f3);//SwitchPatch #6 Page4,Reg.24 = 0xc0f3
+	mdelay(1);
+	Set_GPHYWB(999, 4, 25, 0, 0x7630);//SwitchPatch #7 Page4,Reg.25 = 0x7630
+	mdelay(1);
+	REG32( 0xBB804160)=0x0E739CE7 ;//SwitchPatch #8 BB804160 = 0x0E739CE7 ,Set EEE MAC register
+	mdelay(1);
+	Set_GPHYWB(999, 0, 21, 0xffff-(15<<4), 3<<4);//Patch #9 Page0,Reg.21[7:4]=0011  ,Set Green ethernet
+	mdelay(1);
+	Set_GPHYWB(999, 0, 21, 0xffff-(15<<0), 2<<0);//Patch #10 Page0,Reg.21[3:0]=0010  ,Set Green ethernet
+	mdelay(1);
+}
+#endif
+
+	// refine for B-cut and later
+	{
+	unsigned int val= REG32(0xb80000dc);
+	if ((val & 0x3) != 0x3)
+		REG32(0xb80000dc) |= 0x3; // wlanmac_control, set active_wlanmac_sys and active_wlanmac_lx for RF revision ID
+
+	if ((REG32(0xb86400f0) & 0x0000f000) >= 0x00001000)
+		Set_GPHYWB(999, 1, 16, 0xffff-(7<<4), 4<<4); // fix 100M IOL overshoot issue
+
+	REG32(0xb80000dc) = val; // restore value.
+	}
+
+	/* enlarge "Flow control DSC tolerance" from 24 pages to 48 pages
+	    to prevent the hardware may drop incoming packets
+	    after flow control triggered and Pause frame sent */
+	REG32(MACCR)= (REG32(MACCR) & ~CF_FCDSC_MASK) | (0x30 << CF_FCDSC_OFFSET);
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+
+	return 0;
+}
+#endif
+
+#if defined(CONFIG_RTL_8197F)
+#define RCAL_OFFSET		(-2)
+
+int Setting_RTL8197F_PHY(void)
+{
+	int i, phyid;
+	unsigned int data, force_r;
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	REG32(MACCR)= (REG32(MACCR) & ~CF_FCDSC_MASK) | (0x48 << CF_FCDSC_OFFSET);
+
+	// if enable 16K-byte jumbo frame support, set cf_fcdsc[6:0]= 0x7F
+	//REG32(MACCR)= (REG32(MACCR) & ~CF_FCDSC_MASK) | (0x7F << CF_FCDSC_OFFSET);
+
+	/* amendment #1
+		purpose: to refine the Auot-k R result.
+	 */
+	for(i=0; i<5; i++) {
+		phyid = rtl8651AsicEthernetTable[i].phyId;
+
+		Set_GPHYWB(phyid, 1, 29, 0xffff-(3<<1), 1<<1); // enable auto-k once only after power on; force to Auto-K mode
+
+		rtl8651_setAsicEthernetPHYReg( phyid, 31, 1);
+		rtl8651_getAsicEthernetPHYReg( phyid, 28, &data); // read back the auto-K R value
+		force_r = (data >> 12) & 0xf;
+		if (force_r >= 2)
+			force_r += RCAL_OFFSET;
+
+		data = (data & ~0xF000) | (force_r << 12);
+		rtl8651_setAsicEthernetPHYReg( phyid, 28, data);
+		rtl8651_setAsicEthernetPHYReg( phyid, 31, 0);
+
+		Set_GPHYWB(phyid, 1, 29, 0xffff-(1<<2), 1<<2); // enable forceR mode
+		Set_GPHYWB(phyid, 0, 0, 0xffff-(1<<15), 1<<15); // reset PHY
+	}
+	/* amendment #2
+		purpose: to solve 100M IOL Vout too large issue.
+				 to finetune bandgap current and finetune 100M Vout voltage.
+	 */
+	Set_GPHYWB(4, 1, 23, 0xffff-0xf880, 0x7000);
+	Set_GPHYWB(999, 1, 18, 0xffff-(0xf<<4), 5<<4);
+
+	/* amendment #3
+		purpose: to solve the IOL rise/falling time and symmetry violate spec issue.
+	 */
+	Set_GPHYWB(999, 1, 16, 0xffff-(7<<13), 7<<13);
+	Set_GPHYWB(999, 1, 17, 0xffff-(7<<11), 6<<11);
+
+	/* amendment #4
+		purpose: to improve/solve IOL 10M TPIDL mask fit fail issue.
+	 */
+	Set_GPHYWB(999, 1, 16, 0xffff-(3<<8), 0<<8);
+
+	/* amendment #5
+		purpose: to solve PHY not accept the 16kB jumbo frame issue.
+	 */
+	Set_GPHYWB(999, 0, 23, 0xffff-(1<<8), 1<<8);
+
+	for(i=0; i<5; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+	return 0;
+}
+#endif
+
+void enable_EEE(void)
+{
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+	int i;
+	extern int rtk_eee_portEnable_set(uint32 port, uint32 enable);
+	for (i=0;i<EXT_SWITCH_MAX_PHY_PORT;i++) {
+		rtk_eee_portEnable_set(i, 1);
+	}
+#elif defined(CONFIG_RTL_8198)
+	eee_phy_enable_98();
+
+#elif defined(CONFIG_RTL_8198C)
+	// enable 10M EEE
+	Set_GPHYWB(999, 0xa43, 25, 0xffff-(1<<4), 1<<4);
+
+	Set_GPHYWB(999, 0xa5d, 16, 0xffff-(0x3<<1), 0x3<<1);
+	REG32(EEECR) = 0x1F1F1F1F;
+	REG32(EEEABICR1) = 0x1F1F;
+
+#elif defined(CONFIG_RTL_8197F)
+	int i;
+
+	for(i=0; i<RTL8651_PHY_NUMBER; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	REG32(EEECR) = 0x0F0F0F0F;
+	REG32(EEEABICR1) = 0x00000F0F;
+
+	Set_GPHYWB(999, 4, 16, 0xffff-((0x3<<12)|(0x3<<8)), ((0x3<<12)|(0x3<<8)));
+
+	for(i=0; i<RTL8651_PHY_NUMBER; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+#else
+
+	int i;
+
+	for(i=0; i<RTL8651_PHY_NUMBER; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+#if defined(CONFIG_RTL_8881A)
+	Set_GPHYWB(999,4, 16, 0, 0x7377);
+	mdelay(1);
+	Set_GPHYWB(999,4, 24, 0, 0xc0f3);
+	mdelay(1);
+	Set_GPHYWB(999,4, 25, 0, 0x7630);
+	//enable MAC EEE
+	REG32(EEECR) = 0x0E739CE7;
+
+#elif defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+	//enable 100M EEE and 10M EEE
+	Set_GPHYWB(999, 4, 16, 0xffff-(0x3<<12), 0x3<<12);
+
+	//enable MAC EEE
+	REG32(EEECR) = 0x0E739CE7;
+
+#elif defined(CONFIG_RTL_8196C)
+
+	#ifdef RTL8196C_EEE_REFINE
+	{
+	/* 1. to link down all of the PHY */
+	uint32 reg;
+
+	for(i=0; i<RTL8651_PHY_NUMBER; i++) {
+		rtl8651_getAsicEthernetPHYReg( i, 0, &reg );
+		reg |= (POWER_DOWN);
+		rtl8651_setAsicEthernetPHYReg( i, 0, reg );
+	}
+
+	for(i=0; i<RTL8651_PHY_NUMBER; i++) {
+		eee_phy_enable_by_port(i);
+	}
+
+	/* 7. set PHY POWER_DOWN=0 */
+	for(i=0; i<RTL8651_PHY_NUMBER; i++) {
+		rtl8651_getAsicEthernetPHYReg( i, 0, &reg );
+		reg &= (~POWER_DOWN);
+		rtl8651_setAsicEthernetPHYReg( i, 0, reg );
+	}
+	}
+	#else
+	for(i=0; i<RTL8651_PHY_NUMBER; i++) {
+		eee_phy_enable_by_port(i);
+	}
+	#endif
+
+	// set FRC_P0_EEE_100, EN_P0_TX_EEE and EN_P0_RX_EEE
+	//REG32(EEECR) = 0x0E739CE7;		// consult with Jim and Anson, we do not use this setting.
+	// set EN_P0_TX_EEE and EN_P0_RX_EEE
+	REG32(EEECR) = 0x06318C63;
+
+#ifdef CONFIG_POCKET_ROUTER_SUPPORT
+	#define ETH_PORT_START		4
+	#define ETH_PORT_END		4
+#else
+	#define ETH_PORT_START		0
+	#define ETH_PORT_END		4
+#endif
+	for ( i = ETH_PORT_START ; i <= ETH_PORT_END; i++ ) {
+		/* enable phy 100 eee ability */
+		mmd_write(i, 7, 60, 0x2);
+	}
+#endif
+
+	for(i=0; i<RTL8651_PHY_NUMBER; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+#endif
+}
+
+void disable_EEE(void)
+{
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+	int i;
+	extern int rtk_eee_portEnable_set(uint32 port, uint32 enable);
+	for (i=0;i<EXT_SWITCH_MAX_PHY_PORT;i++) {
+		rtk_eee_portEnable_set(i, 0);
+	}
+#elif defined(CONFIG_RTL_8198)
+	eee_phy_disable_98();
+
+#elif defined(CONFIG_RTL_8198C)
+	//disable 10M EEE
+	Set_GPHYWB(999, 0xa43, 25, 0xffff-(1<<4), 0<<4);
+
+	Set_GPHYWB(999, 0xa5d, 16, 0xffff-(0x3<<1), 0);
+	REG32(EEECR) = 0;
+	REG32(EEEABICR1) = 0;
+
+#elif defined(CONFIG_RTL_8197F)
+	int i;
+
+	for(i=0; i<RTL8651_PHY_NUMBER; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	//disable EEE MAC
+	REG32(EEECR) = 0;
+	REG32(EEEABICR1) = 0;
+
+	//disable 100M EEE and 10M EEE
+	Set_GPHYWB(999, 4, 16, 0xffff-((0x3<<12)|(0x3<<8)), 0);
+
+	for(i=0; i<RTL8651_PHY_NUMBER; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+#else
+	// for CONFIG_RTL_8196C, CONFIG_RTL_819XD and CONFIG_RTL_8196E
+	int i;
+
+	for(i=0; i<RTL8651_PHY_NUMBER; i++)
+		REG32(PCRP0+i*4) |= (EnForceMode);
+
+	//disable EEE MAC
+	REG32(EEECR) = 0;
+
+	//disable 100M EEE and 10M EEE
+	Set_GPHYWB(999, 4, 16, 0xffff-(0x3<<12), 0x0<<12);
+
+	for(i=0; i<RTL8651_PHY_NUMBER; i++)
+		REG32(PCRP0+i*4) &= ~(EnForceMode);
+#endif
+}
+
+#if defined(CONFIG_RTL_8198C)
+void set_8198C_EEE(int mode, uint32 port_mask)
+{
+	int i;
+
+	for(i=0; i<4; i++) {
+		if (((1<<i) & port_mask) != 0) { // need to set port i
+			if (mode == 0) { // disable
+				Set_GPHYWB(i, 0xa43, 25, 0xffff-(1<<4), 0<<4);
+				Set_GPHYWB(i, 0xa5d, 16, 0xffff-(0x3<<1), 0);
+				REG32(EEECR) &= ~(0xFF << (i*8));
+			}
+			else {
+				Set_GPHYWB(i, 0xa43, 25, 0xffff-(1<<4), 1<<4);
+				Set_GPHYWB(i, 0xa5d, 16, 0xffff-(0x3<<1), 0x3<<1);
+				REG32(EEECR) = (REG32(EEECR) & ~(0xFF << (i*8))) | (0x1F << (i*8));
+			}
+			rtl8651_restartAsicEthernetPHYNway(i);
+			mdelay(10);
+		}
+	}
+	if (((1<<4) & port_mask) != 0) { // need to set port 4
+		if (mode == 0) { // disable
+			Set_GPHYWB(4, 0xa43, 25, 0xffff-(1<<4), 0<<4);
+			Set_GPHYWB(4, 0xa5d, 16, 0xffff-(0x3<<1), 0);
+			REG32(EEEABICR1) = 0;
+		}
+		else {
+			Set_GPHYWB(4, 0xa43, 25, 0xffff-(1<<4), 1<<4);
+			Set_GPHYWB(4, 0xa5d, 16, 0xffff-(0x3<<1), 0x3<<1);
+			REG32(EEEABICR1) = 0x1F;
+		}
+		rtl8651_restartAsicEthernetPHYNway(4);
+		mdelay(10);
+	}
+}
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT) || defined(CONFIG_RTL_8325D_SUPPORT)
+#define REG_IOCFG_GPIO		0x00000018
+
+/* define GPIO port */
+enum GPIO_PORT
+{
+	GPIO_PORT_A = 0,
+	GPIO_PORT_B,
+	GPIO_PORT_C,
+	GPIO_PORT_D,
+	GPIO_PORT_E,
+	GPIO_PORT_F,
+	GPIO_PORT_G,
+	GPIO_PORT_H,
+	GPIO_PORT_I,
+	GPIO_PORT_MAX,
+};
+
+extern int32 smi_init(uint32 port, uint32 pinSCK, uint32 pinSDA);
+extern int rtk_vlan_init(void);
+#endif
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+extern int RTL8367R_init(void);
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_DNS_TRAP) || defined(CONFIG_RTL_VLAN_8021Q)
+extern int rtk_filter_igrAcl_init(void);
+#endif
+
+// for linking issue of \linux-2.6.30\net\rtl\fastpath\9xD\filter.S
+#if !defined(CONFIG_RTL_IGMP_SNOOPING)
+int igmp_delete_init_netlink(void) { return 0; }
+EXPORT_SYMBOL(igmp_delete_init_netlink);
+#endif
+
+#if defined(CONFIG_RTL_8367MB_SUPPORT)
+#define GPIO_PINMUX_MASK	(3<<10)
+#define GPIO_RESET	19	//GPIO_G3
+#define RESET_CNR		PEFGH_CNR
+#define RESET_DIR		PEFGH_DIR
+#define RESET_DAT		PEFGH_DAT
+
+#define I2C_PINMUX_MASK	(3<<22)
+#define I2C_PORT		GPIO_PORT_G
+#define I2C_CLOCK		7
+#define I2C_DATA		6
+
+#else // 8367RB
+#define GPIO_PINMUX_MASK	(3<<12)
+#define GPIO_RESET	1	//GPIO_A1
+#define RESET_CNR		PABCD_CNR
+#define RESET_DIR		PABCD_DIR
+#define RESET_DAT		PABCD_DAT
+
+#define I2C_PINMUX_MASK	(3<<13)
+#define I2C_PORT		GPIO_PORT_F
+#define I2C_CLOCK		5
+#define I2C_DATA		6
+#endif
+
+void init_8367r(void)
+{
+#ifdef CONFIG_RTL_8881A
+	int i=0;
+	int ret=0;
+	REG32(0xb8000044) |=  (3<<12); // reg_iocfg_fcs1, set to GPIO mode
+	REG32(PABCD_CNR) &= (~(0x00004000)); //set GPIO pin, A1
+	REG32(PABCD_DIR) |= (0x00004000); //output pin
+
+	for (i=0; i<3; i++)
+	{
+		// for 8367r h/w reset pin
+		REG32(PABCD_DAT) &= (~(0x00004000));
+		mdelay(1000);
+		REG32(PABCD_DAT) |= (0x00004000);
+		mdelay(1000);
+
+		// set to GPIO mode
+		#ifndef CONFIG_MTD_NAND
+		REG32(PIN_MUX_SEL)=0xc;// ((REG32(PIN_MUX_SEL)&(~(7<<2))|0x3<<2));
+
+		// MDC: F5, MDIO: F6
+		WRITE_MEM32(PEFGH_CNR, READ_MEM32(PEFGH_CNR) & (~(0x00006000)));	//set GPIO pin, F5 and F6
+		WRITE_MEM32(PEFGH_DIR, READ_MEM32(PEFGH_DIR) | ((0x00006000))); //output pin
+
+		//smi_init(GPIO_PORT_A, 3, 2);
+		smi_init(GPIO_PORT_F, 5, 6);
+		#else
+		REG32(PIN_MUX_SEL2) = (REG32(PIN_MUX_SEL2)&(~(0xe38))) | (0x618);
+		WRITE_MEM32(PABCD_CNR, READ_MEM32(PABCD_CNR) & (~(0x00002800)));
+		WRITE_MEM32(PABCD_DIR, READ_MEM32(PABCD_DIR) | ((0x00002800)));
+		smi_init(GPIO_PORT_B, 5, 3);
+
+		#endif
+		mdelay(1000);
+		ret = RTL8367R_init();
+		if (ret == 0)
+			break;
+	}
+#elif defined(CONFIG_RTL_8197F)
+	#undef GPIO_RESET
+	#define GPIO_RESET	26		// GPIO_H2
+	int ret, i;
+
+	#if defined(REINIT_SWITCH_CORE)
+	if (rtl865x_duringReInitSwtichCore == 1)
+		return;
+	#endif
+
+	#if defined(CONFIG_OPENWRT_SDK)
+	// Reset 8367RB: REG_PINMUX_14, BIT_REG_IOCFG_LED_P0
+	REG32(PIN_MUX_SEL14) = (REG32(PIN_MUX_SEL14) & ~(0xF<<28)) | (2<<28);
+	REG32(PEFGH_CNR) &= ~(1<<GPIO_RESET);
+	REG32(PEFGH_DIR) |= (1<<GPIO_RESET);
+	#endif
+#ifndef CONFIG_MTD_NAND
+	REG32(PIN_MUX_SEL) = 0; // TODO: need to find out
+	REG32(PIN_MUX_SEL1) = 0; // TODO: need to find out
+#endif
+
+	for (i=0; i<3; i++)
+	{
+		// for 8367r h/w reset pin
+		REG32(PEFGH_DAT) &= ~(1<<GPIO_RESET);
+		mdelay(1000);
+		REG32(PEFGH_DAT) |= (1<<GPIO_RESET);
+		mdelay(1000);
+
+		#if defined(CONFIG_OPENWRT_SDK)
+		// set to GPIO mode
+		// [11:8]	BIT_REG_IOCFG_P0MDC, 0110:GPIO
+		// [7:4]	BIT_REG_IOCFG_P0MDIO, 0110:GPIO
+#ifndef CONFIG_MTD_NAND
+		REG32(PIN_MUX_SEL2) = 0x660; // TODO: need to find out
+#endif
+		REG32(PABCD_CNR) &= ~(0x000C0000);	//set GPIO pin, C2 and C3
+		REG32(PABCD_DIR) |= (0x000C0000);	//output pin
+		#endif
+
+		// MDC: C2, MDIO: C3
+		smi_init(GPIO_PORT_C, 2, 3);
+		mdelay(1000);
+		ret = RTL8367R_init();
+		if (ret == 0)
+			break;
+	}
+#else
+	int ret, i;
+
+	#if defined(CONFIG_RTL_8367MB_SUPPORT)
+	REG32(PIN_MUX_SEL) |= GPIO_PINMUX_MASK; // reg_iocfg_fcs1, set to GPIO mode
+	REG32(RESET_CNR) &= ~(1<<GPIO_RESET); //set GPIO pin, A1
+	REG32(RESET_DIR) |= (1<<GPIO_RESET); //output pin
+	#endif
+
+	for (i=0; i<3; i++) {
+		// for 8367r h/w reset pin
+		REG32(RESET_DAT) &= ~(1<<GPIO_RESET);
+		mdelay(1000);
+
+		REG32(RESET_DAT) |= (1<<GPIO_RESET);
+		mdelay(1000);
+
+		// set to GPIO mode
+		REG32(PIN_MUX_SEL) |= (REG_IOCFG_GPIO);
+
+		// MDC: F5, MDIO: F6
+		WRITE_MEM32(PEFGH_CNR, READ_MEM32(PEFGH_CNR) & (~I2C_PINMUX_MASK));	//set GPIO pin
+		WRITE_MEM32(PEFGH_DIR, READ_MEM32(PEFGH_DIR) | (I2C_PINMUX_MASK)); //output pin
+
+		smi_init(I2C_PORT, I2C_CLOCK, I2C_DATA);
+
+		ret = RTL8367R_init();
+		if (ret == 0)
+			break;
+	}
+#endif
+	// 8367_VLAN
+	rtk_vlan_init();
+
+	// clear mib counter
+	rtk_stat_global_reset();
+
+#ifdef CONFIG_RTL_CPU_TAG
+	RTL8367R_vlan_set();
+	RTL8367R_cpu_tag(1);
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)|| defined(CONFIG_RTL_DNS_TRAP) || defined(CONFIG_RTL_VLAN_8021Q)
+	rtk_filter_igrAcl_init();
+#endif
+}
+#endif
+
+#ifdef CONFIG_RTL_8198C_8367RB
+extern int32 smi_init(uint32 port, uint32 pinSCK, uint32 pinSDA);
+extern int RTL8367R_init_switch_mode(void);
+void init_8367rb_for_8198c(void)
+{
+	int i, ret = -1;
+
+	REG32(PIN_MUX_SEL3) = (REG32(PIN_MUX_SEL3) & ~(3<<30)) | (0x3<<30);
+	REG32(PEFGH_CNR) &= (~(0x00000040));
+	REG32(PEFGH_DIR) |= (0x00000040);
+
+	for (i=0; i<3; i++)
+	{
+		// for 8367r h/w reset pin
+		REG32(PEFGH_DAT) &= (~(0x00000040));
+		mdelay(1000);
+		REG32(PEFGH_DAT) |= (0x00000040);
+		mdelay(1000);
+
+		// set to GPIO mode
+		REG32(PIN_MUX_SEL4) = (REG32(PIN_MUX_SEL4) & ~(7<<0)) | (0x3<<0);
+
+		// MDC: F5, MDIO: F6
+		WRITE_MEM32(PEFGH_CNR, READ_MEM32(PEFGH_CNR) & (~(0x00006000)));	//set GPIO pin, F5 and F6
+		WRITE_MEM32(PEFGH_DIR, READ_MEM32(PEFGH_DIR) | ((0x00006000))); //output pin
+
+		smi_init(GPIO_PORT_F, 5, 6);
+		mdelay(1000);
+
+		ret = RTL8367R_init_switch_mode();
+		if (ret == 0)
+			break;
+	}
+}
+#endif
+
+#ifdef CONFIG_RTL_8370_SUPPORT
+extern int RTL8370_init(void);
+
+void init_8370(void)
+{
+	int ret, i;
+
+	REG32(PIN_MUX_SEL) |=  (3<<12); // reg_iocfg_fcs1, set to GPIO mode
+	REG32(PABCD_CNR) &= (~(0x00000002)); //set GPIO pin, A1
+	REG32(PABCD_DIR) |= (0x00000002); //output pin
+
+	for (i=0; i<3; i++) {
+		// for 8370 h/w reset pin
+		REG32(PABCD_DAT) &= ~(0x00000002);
+		mdelay(1000);
+
+		REG32(PABCD_DAT) |= (0x00000002);
+		mdelay(1000);
+
+		// set to GPIO mode
+		REG32(PIN_MUX_SEL) |= (0x3c000000); // bit 27~26 = 0b11, bit 29~28 = 0b11
+
+		//MA22(GPIOC5) => clock
+		//MA21(GPIOC4) => IO
+		// MDC: C5, MDIO: C4
+		WRITE_MEM32(PABCD_CNR, READ_MEM32(PABCD_CNR) & (~(0x00300000)));	//set GPIO pin, C5 and C4
+		WRITE_MEM32(PABCD_DIR, READ_MEM32(PABCD_DIR) | ((0x00300000))); //output pin
+
+		smi_init(GPIO_PORT_C, 5, 4);
+
+		ret = RTL8370_init();
+		if (ret == 0)
+			break;
+	}
+
+	// 8370_VLAN
+	rtk_vlan_init();
+
+	// clear mib counter
+	rtk_stat_global_reset();
+}
+#endif
+
+#ifdef CONFIG_RTL_8325D_SUPPORT
+//extern void rtl8316d_sys_reboot(void);
+extern int RTL8325D_init(void);
+
+void init_8325d(void)
+{
+	int ret;
+
+	// set to GPIO mode
+	REG32(PIN_MUX_SEL) |= (0xC00); // bit 11~10 = 0b11
+
+	REG32(PEFGH_CNR) &= (~(0x00020000)); //set GPIO pin, G1
+	REG32(PEFGH_DIR) |= (0x00020000); //output pin
+
+	// for 8325d h/w reset pin
+	REG32(PEFGH_DAT) &= ~(0x00020000);
+	mdelay(1000);
+
+	REG32(PEFGH_DAT) |= (0x00020000);
+	mdelay(1000);
+
+	//I2C dataGGPIOG6, P0_RXD5
+	//I2C clockGGPIOG7, P0_RXD4
+	WRITE_MEM32(PEFGH_CNR, READ_MEM32(PEFGH_CNR) & (~(0x00C00000)));	//set GPIO pin, G6 and G7
+	WRITE_MEM32(PEFGH_DIR, READ_MEM32(PEFGH_DIR) | ((0x00C00000))); //output pin
+
+	smi_init(GPIO_PORT_G, 7, 6);
+
+	//rtl8316d_sys_reboot();
+	//mdelay(1000);
+
+	ret = RTL8325D_init();
+}
+#endif
+
+#if defined(CONFIG_RTL_8211F_SUPPORT)
+
+#if defined(CONFIG_RTL_8881A)
+#define GPIO_RESET		17		// GPIO_G1
+#define PORT0_RGMII_PHYID	5
+#elif defined(CONFIG_RTL_819XD)
+#define GPIO_RESET		18		// GPIO_G2
+#define PORT0_RGMII_PHYID	5
+#elif defined(CONFIG_RTL_8197F)
+#define GPIO_RESET				BSP_GPIO_PIN_H2		// GPIO_H2
+#define GPIO_RESET_97FN			BSP_GPIO_PIN_F1		// GPIO_F1
+#define PORT0_RGMII_PHYID		6
+int gpio_simulate_mdc_mdio = 0;
+#endif
+
+
+#if defined(CONFIG_RTL_8197F)
+int init_p0(void)
+{
+	unsigned int data;
+
+	REG32(PCRP0) = (REG32(PCRP0) & ~(0x1F << ExtPHYID_OFFSET)) \
+		| ((PORT0_RGMII_PHYID << ExtPHYID_OFFSET) | MIIcfg_RXER |  EnablePHYIf | MacSwReset);
+	REG32(MACCR) |= (1<<12);
+	REG32(P0GMIICR) = (REG32(P0GMIICR) & ~((1<<4)|(7<<0))) | ((1<<4) | (5<<0));
+#ifndef CONFIG_MTD_NAND
+	REG32(PIN_MUX_SEL) = 0; // TODO: need to find out
+	REG32(PIN_MUX_SEL1) = 0; // TODO: need to find out
+	REG32(PIN_MUX_SEL2) = 0; // TODO: need to find out
+#endif
+
+	// Reset 8211E/8211F: REG_PINMUX_14, BIT_REG_IOCFG_LED_P0
+	if(gpio_simulate_mdc_mdio){
+		extern int nfbi_init(void);
+
+		gpio_request_one(GPIO_RESET_97FN, (GPIOF_DIR_OUT | GPIOF_EXPORT_DIR_FIXED), "reset pin");
+		gpio_set_value(GPIO_RESET_97FN, 0);
+		mdelay(500);
+		gpio_set_value(GPIO_RESET_97FN, 1);
+		mdelay(300);
+
+		REG32(PCRP0) = (REG32(PCRP0) & ~AutoNegoSts_MASK) \
+			| (EnForceMode| ForceLink|ForceSpeed1000M |ForceDuplex); //forcemode
+
+		nfbi_init();
+	} else {
+		gpio_request_one(GPIO_RESET, (GPIOF_DIR_OUT | GPIOF_EXPORT_DIR_FIXED), "reset pin");
+		gpio_set_value(GPIO_RESET, 0);
+		mdelay(500);
+		gpio_set_value(GPIO_RESET, 1);
+		mdelay(300);
+	}
+
+	REG32(PITCR) |= (1<<0);
+	REG32(P0GMIICR) |=(Conf_done);
+
+	//pad control
+//TODO:	REG32(0xb8000048) |= BIT(28);
+
+	rtl8651_getAsicEthernetPHYReg(PORT0_RGMII_PHYID, 4, &data );
+	// Advertise support of asymmetric pause
+	// Advertise support of pause frames
+	rtl8651_setAsicEthernetPHYReg(PORT0_RGMII_PHYID, 4, (data | 0xC00));
+
+	return 0;
+}
+#else // CONFIG_RTL_8881A or CONFIG_RTL_819XD
+int init_p0(void)
+{
+	unsigned int data;
+
+	REG32(PCRP0) |=  (PORT0_RGMII_PHYID << ExtPHYID_OFFSET) | MIIcfg_RXER |  EnablePHYIf | MacSwReset;
+	REG32(MACCR) |= (1<<12);
+	REG32(P0GMIICR) = (REG32(P0GMIICR) & ~((1<<4)|(7<<0))) | ((1<<4) | (3<<0));
+
+	#if defined(CONFIG_RTL_8881A)
+	// 0xb8000040 bit [4:2] Configure P0 mdc/mdio PAD as P0-MDIO (3'b100)
+	// 0xb8000040 bit [9:7] Configure P0 PAD as P0-MII (3'b000)
+	REG32(PIN_MUX_SEL) = (REG32(PIN_MUX_SEL) & ~((7<<7) | (7<<2))) | (4<<2);
+	#endif
+
+	// Reset 8211F
+	REG32(PIN_MUX_SEL) |= (3<<10);
+	REG32(PEFGH_CNR) &= ~(1<<GPIO_RESET);
+	REG32(PEFGH_DIR) |= (1<<GPIO_RESET);
+	REG32(PEFGH_DAT) &= ~(1<<GPIO_RESET);
+	mdelay(500);
+	REG32(PEFGH_DAT) |= (1<<GPIO_RESET);
+	mdelay(300);
+
+	REG32(PITCR) |= (1<<0);
+	REG32(P0GMIICR) |=(Conf_done);
+
+	//pad control
+	REG32(0xb8000048) |= BIT(28);
+
+	rtl8651_getAsicEthernetPHYReg(PORT0_RGMII_PHYID, 4, &data );
+	// Advertise support of asymmetric pause
+	// Advertise support of pause frames
+	rtl8651_setAsicEthernetPHYReg(PORT0_RGMII_PHYID, 4, (data | 0xC00));
+
+	//panic_printk(" --> config port 0 done.\n");
+	return 0;
+}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8198C_8211F)
+int init_p5(void)
+{
+	unsigned int data;
+
+	REG32(PIN_MUX_SEL4) = REG32(PIN_MUX_SEL4) & ~(0x01E00000);
+	REG32(PIN_MUX_SEL5) = REG32(PIN_MUX_SEL5) & ~(0x0000C000);
+
+	// 8211F Reset pin
+	#define GPIO_RESET		10		// GPIO_F2
+
+	// PIN_MUX_SEL3 b[20:18] reg_iocfg_p0rxd0 = 0b011[GPIO]
+	REG32(PIN_MUX_SEL3) = (REG32(PIN_MUX_SEL3) & ~(7<<18)) | (3<<18);
+	REG32(PEFGH_CNR) &= ~(1<<GPIO_RESET);
+	REG32(PEFGH_DIR) |= (1<<GPIO_RESET);
+	REG32(PEFGH_DAT) &= ~(1<<GPIO_RESET);
+	mdelay(500);
+	REG32(PEFGH_DAT) |= (1<<GPIO_RESET);
+	mdelay(300);
+
+#define _98C_P5_RGMII_TX_DELAY	0
+#define _98C_P5_RGMII_RX_DELAY	3
+#define _98C_P5_PHY_ID			5
+
+	REG32(P5GMIICR) = (REG32(P5GMIICR) & ~((1<<4)|(7<<0))) | ((_98C_P5_RGMII_TX_DELAY<<4) | (_98C_P5_RGMII_RX_DELAY<<0));
+	REG32(PCRP5) = (REG32(PCRP5) & ~(0x1f << ExtPHYID_OFFSET))
+			| ((_98C_P5_PHY_ID << ExtPHYID_OFFSET) | MIIcfg_RXER |  EnablePHYIf | MacSwReset | AutoNegoSts_MASK);
+	REG32(P5GMIICR) |= (Conf_done);
+
+	rtl8651_getAsicEthernetPHYReg(_98C_P5_PHY_ID, 4, &data );
+	// Advertise support of asymmetric pause
+	// Advertise support of pause frames
+	rtl8651_setAsicEthernetPHYReg(_98C_P5_PHY_ID, 4, (data | 0xC00));
+
+	return 0;
+}
+#endif
+
+#ifdef CONFIG_8198_PORT5_RGMII
+void init_8198_p5(void)
+{
+	/* define GPIO port */
+	enum GPIO_PORT
+	{
+	GPIO_PORT_A = 0,
+	GPIO_PORT_B,
+	GPIO_PORT_C,
+	GPIO_PORT_D,
+	GPIO_PORT_E,
+	GPIO_PORT_F,
+	GPIO_PORT_G,
+	GPIO_PORT_H,
+	GPIO_PORT_I,
+	GPIO_PORT_MAX,
+	};
+
+	#define REG_IOCFG_GPIO		0x00000018
+
+	extern int32 smi_init(uint32 port, uint32 pinSCK, uint32 pinSDA);
+	extern int RTL8370_init(void);
+
+	// set to GPIO mode
+	REG32(PIN_MUX_SEL) |= (REG_IOCFG_GPIO);
+
+
+	WRITE_MEM32(PABCD_CNR, READ_MEM32(PABCD_CNR) & (~(0x0000000C)));	//set GPIO pin
+	WRITE_MEM32(PABCD_DIR, READ_MEM32(PABCD_DIR) | ((0x0000000C))); //output pin
+
+	smi_init(GPIO_PORT_A, 3, 2);
+
+	RTL8370_init();
+}
+#endif
+
+#if defined(CONFIG_RTL819X_GPIO) && defined(CONFIG_RTL_8367R_SUPPORT) && !defined(CONFIG_OPENWRT_SDK)
+static int rtl819x_8367r_reset_pin_probe(struct platform_device *dev) {
+	struct rtl819x_gpio_platdata *pdata = dev->dev.platform_data;
+	int ret = 0;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+	ret = devm_gpio_request_one(&dev->dev, pdata->gpio, GPIOF_OUT_INIT_HIGH | GPIOF_EXPORT_DIR_FIXED, pdata->name);
+#else
+	if(!(ret = gpio_request_one(pdata->gpio, GPIOF_OUT_INIT_HIGH, pdata->name)))
+		ret = gpio_export(pdata->gpio, false);
+#endif
+
+	if(ret < 0)
+		return ret;
+
+	if(pdata->flags & RTL819X_GPIO_ACTLOW)
+		gpio_sysfs_set_active_low(pdata->gpio, 1);
+
+	return ret;
+}
+
+static struct platform_driver rtl819x_8367r_reset_pin_driver = {
+	.probe		= rtl819x_8367r_reset_pin_probe,
+//	.remove		= rtl819x_8367r_reset_pin_remove,
+	.driver		= {
+		.name	= "rtl819x_8367r_reset_pin",
+		.owner	= THIS_MODULE,
+	},
+};
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,2,0)
+module_platform_driver(rtl819x_8367r_reset_pin_driver);
+#else
+static int __init rtl819x_8367r_reset_pin_driver_init(void)
+{
+	return platform_driver_register(&rtl819x_8367r_reset_pin_driver);
+}
+module_init(rtl819x_8367r_reset_pin_driver_init);
+#endif
+
+static int rtl819x_8367r_i2c_pin_probe(struct platform_device *dev) {
+	struct rtl819x_gpio_platdata *pdata = dev->dev.platform_data;
+	int ret = 0;
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+	ret = devm_gpio_request_one(&dev->dev, pdata->gpio, GPIOF_OUT_INIT_HIGH | GPIOF_EXPORT_DIR_FIXED, pdata->name);
+#else
+	if(!(ret = gpio_request_one(pdata->gpio, GPIOF_OUT_INIT_HIGH, pdata->name)))
+		ret = gpio_export(pdata->gpio, false);
+#endif
+
+	if(ret < 0)
+		return ret;
+
+	if(pdata->flags & RTL819X_GPIO_ACTLOW)
+		gpio_sysfs_set_active_low(pdata->gpio, 1);
+
+	return ret;
+}
+
+static struct platform_driver rtl819x_8367r_i2c_pin_driver = {
+	.probe		= rtl819x_8367r_i2c_pin_probe,
+//	.remove		= rtl819x_8367r_i2c_pin_remove,
+	.driver		= {
+		.name	= "rtl819x_8367r_i2c_pin",
+		.owner	= THIS_MODULE,
+	},
+};
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,2,0)
+module_platform_driver(rtl819x_8367r_i2c_pin_driver);
+#else
+static int __init rtl819x_8367r_i2c_pin_driver_init(void)
+{
+	return platform_driver_register(&rtl819x_8367r_i2c_pin_driver);
+}
+module_init(rtl819x_8367r_i2c_pin_driver_init);
+#endif
+
+#endif
+
+#if defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8367R_SUPPORT)
+void init_8197f_p0(void)
+{
+	REG32(PCRP0) = (REG32(PCRP0) & ~(ExtPHYID_MASK)) | (5 << ExtPHYID_OFFSET)
+					| MIIcfg_RXER |  EnablePHYIf | MacSwReset;
+	REG32(PCRP0) = (REG32(PCRP0) & ~(AutoNegoSts_MASK)) | (EnForceMode| ForceLink|ForceSpeed1000M |ForceDuplex);
+
+	REG32(P0GMIICR) = (REG32(P0GMIICR) & ~(3<<23)) | (LINK_RGMII<<23);
+	REG32(P0GMIICR) = (REG32(P0GMIICR) & ~((1<<4)|(7<<0))) | ((0<<4) | (5<<0) | (3<<CF_SEL_RGTXC_OFFSET));
+
+	#ifdef CONFIG_RTL_CPU_TAG
+	REG32(P0GMIICR) |= (CFG_CPUC_TAG|CFG_TX_CPUC_TAG);
+	// enable port 0 router mode
+	REG32(MACCR1) |= PORT0_ROUTER_MODE;
+	#endif
+
+	REG32(PITCR) |= (1<<0);   //00: embedded , 01L GMII/MII/RGMII
+	REG32(MACCR) |= (1<<12);   //giga link
+	REG32(P0GMIICR) |=(Conf_done);
+
+	REG32(PAD_CTRL_1) = (REG32(PAD_CTRL_1) & ~(PAD_P0_RGMII_DN_MASK|PAD_P0_RGMII_DP_MASK|PAD_P0_RGMII_MODE_MASK|PAD_P0_TX_E2_MASK))
+					| (0x6 << PAD_P0_RGMII_DN_OFFSET) | (0x6 << PAD_P0_RGMII_DP_OFFSET);
+
+	return;
+}
+#endif
+
+#if (defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) \
+	|| defined(CONFIG_RTL_8197F)) && !defined(CONFIG_RTL_8367R_SUPPORT)
+autoDownSpeed_t fe_ads[RTL8651_PHY_NUMBER];
+#endif
+
+#if defined(CONFIG_RTL_FE_AUTO_DOWN_SPEED)
+
+#define restart_nway(port)	rtl8651_restartAsicEthernetPHYNway(port)
+/*
+ * NWAY time:
+ *	TXDIS: 1.5sec
+ *	FLGC: 1sec
+ *	ABD+CACK+ACKD=(3+3+8)*24ms=0.4sec
+ *	AutoX: 11 * 64ms = 0.7sec
+ *	1.5+1+0.4+0.7=3.6sec, add some margin and take 6sec.
+ */
+#define ADS_NWAY_TIME		6
+#define ADS_FAILED_COUNT_TO_DOWN_SPEED		3
+
+//autoDownSpeed_t fe_ads[RTL8651_PHY_NUMBER];
+uint32 ads_time;
+
+inline int get_anerr(int port)
+{
+	uint32 data, phyid;
+
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+	rtl8651_getAsicEthernetPHYReg( phyid, 30, &data );
+	return ((data >> 15) & 1);
+}
+
+void ads_init(void)
+{
+	int i;
+
+	/* Depiction 1 */
+	ads_time = 0;
+	for (i=ADS_PORT_START; i<RTL8651_PHY_NUMBER; i++) {
+		fe_ads[i].time_flag = 0;
+		fe_ads[i].down_speed = 0;
+		fe_ads[i].fail_counter = 0;
+		fe_ads[i].state = ADS_LINKDOWN;
+		fe_ads[i].down_speed_renway = 0;
+		fe_ads[i].cb_snr_down_speed = 0;
+		fe_ads[i].cb_snr_cache_lpi_down_speed = 0;
+	}
+}
+
+inline void set_nway_ability(int port)
+{
+	if (fe_ads[port].down_speed == 0)
+		REG32(PCRP0+(port*4)) = (REG32(PCRP0+(port*4)) & ~AutoNegoSts_MASK) |
+			(NwayAbility100MF|NwayAbility100MH|NwayAbility10MF|NwayAbility10MH);
+	else
+		REG32(PCRP0+(port*4)) = (REG32(PCRP0+(port*4)) & ~AutoNegoSts_MASK) |
+			(NwayAbility10MF|NwayAbility10MH);
+}
+
+void ads_debug(void)
+{
+	int i;
+
+	rtlglue_printf(" --> ads_time= %u\n", ads_time);
+	for (i=ADS_PORT_START; i<5; i++) {
+		rtlglue_printf(" => [%d] time_flag= %u\n", i, fe_ads[i].time_flag);
+		rtlglue_printf("       fail_counter= %u, anerr_down_speed= %d\n", fe_ads[i].fail_counter, fe_ads[i].down_speed);
+		rtlglue_printf("       state= %u, anerr= %d, cb_snr_down_speed= %d\n",
+			fe_ads[i].state, fe_ads[i].anerr, fe_ads[i].cb_snr_down_speed);
+		rtlglue_printf("       cb_snr_cache_lpi_down_speed= %d\n",
+			fe_ads[i].cb_snr_cache_lpi_down_speed);
+	}
+}
+
+/*
+ * this function is for the port unlinked issue with long cable.
+ * we can check phy reg 30 bit 15 for AN error.
+ * if the "AN error" count > 3  in a 6-second duration, we down speed to 10M.
+ */
+inline void ads_check(void)
+{
+	int i;
+
+	ads_time++;
+
+	for (i=ADS_PORT_START; i<RTL8651_PHY_NUMBER; i++) {
+
+		/* Conditional expression 1 */
+		if (REG32(PCRP0+(i*4))&EnForceMode) {
+			/* Depiction 2 */
+			fe_ads[i].down_speed = 0;
+			fe_ads[i].fail_counter = 0;
+			fe_ads[i].state = ADS_LINKDOWN;
+			fe_ads[i].anerr = get_anerr(i);
+			continue;
+		}
+
+		/* Conditional expression 2 */
+		if (fe_ads[i].state == ADS_LINKUP) {
+
+			/* Conditional expression 3 */
+			if ((REG32(PSRP0+(i*4))&PortStatusLinkUp)==0) {
+				/* Depiction 3 */
+				fe_ads[i].down_speed = 0;
+				set_nway_ability(i);
+				fe_ads[i].fail_counter = 0;
+				restart_nway(i);
+				fe_ads[i].anerr = get_anerr(i);
+				fe_ads[i].state = ADS_LINKDOWN;
+				//rtlglue_printf(" => ADS_D3: port %d: LINKDOWN (down_speed=%d)\n", i,fe_ads[i].down_speed);
+			}
+			continue;
+		}
+
+		/* Conditional expression 4 */
+		if ((REG32(PSRP0+(i*4))&PortStatusLinkUp)!=0) {
+			/* Depiction 4 */
+			//rtlglue_printf(" => ADS_D4: port %d: LINKUP (down_speed=%d)\n", i,fe_ads[i].down_speed);
+			fe_ads[i].state = ADS_LINKUP;
+			continue;
+		}
+
+		/* Conditional expression 5 */
+		if (!((fe_ads[i].fail_counter) || (fe_ads[i].down_speed))) {
+
+			fe_ads[i].anerr = get_anerr(i);
+
+			/* Conditional expression 6 */
+			if (fe_ads[i].anerr) {
+
+				//rtlglue_printf(" => ADS_C6_Yes: port %d.\n", i);
+				/* Depiction 5 */
+				fe_ads[i].fail_counter++;
+				fe_ads[i].time_flag = ads_time;
+			}
+			continue;
+		}
+
+		/* Conditional expression 7 */
+		if ((ads_time - fe_ads[i].time_flag) > ADS_NWAY_TIME) {
+			/* unplug cable */
+			/* Depiction 6 */
+			fe_ads[i].down_speed = 0;
+			set_nway_ability(i);
+			fe_ads[i].fail_counter = 0;
+			restart_nway(i);
+			continue;
+		}
+
+		fe_ads[i].anerr = get_anerr(i);
+
+		/* Conditional expression 8 */
+		if (fe_ads[i].anerr) {
+			//rtlglue_printf(" => ADS_C8: port %d: anerr= 1\n", i);
+
+			/* abnormal happened again */
+			/* Conditional expression 9 */
+			if (fe_ads[i].fail_counter > ADS_FAILED_COUNT_TO_DOWN_SPEED) {
+				//rtlglue_printf(" => ADS_C9: port %d: fail_counter= %d (>3)\n", i,fe_ads[i].fail_counter);
+				/* accumulated count reach the treshold */
+				/* Depiction 7 */
+				fe_ads[i].down_speed ^= 1;
+				set_nway_ability(i);
+				fe_ads[i].fail_counter = 0;
+				restart_nway(i);
+			}
+			else {
+				/* keep accumulating */
+				/* Depiction 8 */
+				fe_ads[i].fail_counter++;
+			}
+			fe_ads[i].time_flag = ads_time;
+		}
+	}
+}
+#endif
+
+#define REG32_ANDOR(x,y,z)   (REG32(x)=(REG32(x)& (y))|(z))
+
+// rtl865x_initAsicL2() is too long, move something out
+void initAsic_PHY(void)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_FPGA_V6_HWNAT)
+	uint32 phyId, phyData;
+#endif //defined(CONFIG_FPGA_V6_HWNAT)
+	uint32 p0_type_cfg;
+	uint32 p0_phyId;
+
+	rtl8651AsicEthernetTable[1].phyId = 8;
+	rtl8651AsicEthernetTable[2].phyId = 9;
+	rtl8651AsicEthernetTable[3].phyId = 10;
+	/*** PHY ID is assigned by device tree ****
+	rtl8651AsicEthernetTable[0].phyId = 1;
+	rtl8651AsicEthernetTable[4].phyId = 3;
+	rtl8651AsicEthernetTable[5].phyId = 6;
+	 ******************************************/
+	rtl8651AsicEthernetTable[0].isGPHY = TRUE;
+	rtl8651AsicEthernetTable[1].isGPHY = FALSE;
+	rtl8651AsicEthernetTable[2].isGPHY = FALSE;
+	rtl8651AsicEthernetTable[3].isGPHY = FALSE;
+	rtl8651AsicEthernetTable[4].isGPHY = TRUE;
+	rtl8651AsicEthernetTable[5].isGPHY = TRUE;
+
+	//choose interface of MAC0 to be embedded PHY1(0)
+	//0:RGMII to PHY, 1:SGMII to PHY, 2: RGMII to MAC, 3: SGMII to MAC
+	p0_type_cfg = ((hwnat_mac0_mode & 1) == 1 /*SGMII*/) ? Port0_TypeCfg_UTP : Port0_TypeCfg_GMII_MII_RGMII;
+	WRITE_MEM32(PITCR, 	Port5_TypeCfg_GMII_MII_RGMII |
+				Port4_TypeCfg_UTP |
+				Port3_TypeCfg_UTP |
+				Port2_TypeCfg_UTP |
+				Port1_TypeCfg_UTP |
+				p0_type_cfg);
+
+	//DBG("PITCR = 0x%x", READ_MEM32(PITCR));
+
+	//arrange PHY ID for MAC0=PHY1, MAC4=PHY3, MAC1=PHY8, MAC2=PHY9, MAC3=PHYa
+	//DBG("old EPIDR = 0x%x", READ_MEM32(EPIDR));
+	if ((get_rtd129x_cpu_revision() != RTD129x_CHIP_REVISION_A00) &&
+			(hwnat_mac0_mode == 1 /*SGMII*/))
+		p0_phyId = rtl8651AsicEthernetTable[0].phyId;
+	else
+		p0_phyId = 11 /* unused PHYID */;
+	WRITE_MEM32(EPIDR, 	(Port_embPhyID(rtl8651AsicEthernetTable[4].phyId, 4) |
+				Port_embPhyID(rtl8651AsicEthernetTable[3].phyId, 3) |
+				Port_embPhyID(rtl8651AsicEthernetTable[2].phyId, 2) |
+				Port_embPhyID(rtl8651AsicEthernetTable[1].phyId, 1) |
+				Port_embPhyID(p0_phyId, 0)));
+	//DBG("EPIDR = 0x%x", READ_MEM32(EPIDR));
+
+#if defined(CONFIG_FPGA_V6_HWNAT)
+	//enable auto negotiation,
+	//turn on all advertise abilities except 1000M,
+	//enable PHY interface of MAC0
+	WRITE_MEM32(PCRP0, 	(READ_MEM32(PCRP0) & ~(EnForceMode | PollLinkStatus | NwayAbility1000MF)) |
+				NwayAbility100MF |
+				NwayAbility100MH |
+				NwayAbility10MF |
+				NwayAbility10MH |
+				EnablePHYIf);
+
+	//enable auto negotiation,
+	//turn on all advertise abilities except 1000M,
+	//enable PHY interface of MAC4
+	WRITE_MEM32(PCRP4, 	(READ_MEM32(PCRP4) & ~(EnForceMode | PollLinkStatus | NwayAbility1000MF)) |
+				NwayAbility100MF |
+				NwayAbility100MH |
+				NwayAbility10MF |
+				NwayAbility10MH |
+				EnablePHYIf);
+
+	//arrange PHY ID for MAC5=PHY6,
+	//enable auto negotiation,
+	//turn on all advertise abilities except 1000M,
+	//enable PHY interface of MAC5
+	WRITE_MEM32(PCRP5, 	(READ_MEM32(PCRP5) & ~(ExtPHYID_MASK | EnForceMode | PollLinkStatus | NwayAbility1000MF)) |
+				(rtl8651AsicEthernetTable[5].phyId << ExtPHYID_OFFSET) |
+				NwayAbility100MF |
+				NwayAbility100MH |
+				NwayAbility10MF |
+				NwayAbility10MH |
+				EnablePHYIf);
+
+	//assign MAC5 to be GMII MAC auto mode
+	//WRITE_MEM32(P5GMIICR, (READ_MEM32(P5GMIICR) & ~(3 << 23)) | (0x1 << 23));
+	rtl865xC_setAsicEthernetMIIMode(5, LINK_MII_MAC);
+	REG32(P5GMIICR) |= Conf_done;
+
+	//enable auto negotiation,
+	//turn off all advertise abilities,
+	//disable PHY interface of MAC1
+	WRITE_MEM32(PCRP1, 	(READ_MEM32(PCRP1) & ~(EnForceMode | PollLinkStatus | NwayAbility1000MF |
+				NwayAbility100MF | NwayAbility100MH | NwayAbility10MF | NwayAbility10MH |
+				EnablePHYIf)));
+
+	//enable auto negotiation,
+	//turn off all advertise abilities,
+	//disable PHY interface of MAC2
+	WRITE_MEM32(PCRP2, 	(READ_MEM32(PCRP2) & ~(EnForceMode | PollLinkStatus | NwayAbility1000MF |
+				NwayAbility100MF | NwayAbility100MH | NwayAbility10MF | NwayAbility10MH |
+				EnablePHYIf)));
+
+	//enable auto negotiation,
+	//turn off all advertise abilities,
+	//disable PHY interface of MAC3
+	WRITE_MEM32(PCRP3, 	(READ_MEM32(PCRP3) & ~(EnForceMode | PollLinkStatus | NwayAbility1000MF |
+				NwayAbility100MF | NwayAbility100MH | NwayAbility10MF | NwayAbility10MH |
+				EnablePHYIf)));
+
+	//set PHY regs
+	DBG("Disable 1000M for FPGA v6");
+	phyId = rtl8651AsicEthernetTable[0].phyId;
+	rtl8651_getAsicEthernetPHYReg( phyId, 9, &phyData);
+	phyData &= ~(CAPABLE_1000BASE_TX_FD | CAPABLE_1000BASE_TX_HD);
+	rtl8651_setAsicEthernetPHYReg(phyId, 9, phyData);
+
+	phyId = rtl8651AsicEthernetTable[4].phyId;
+	rtl8651_getAsicEthernetPHYReg( phyId, 9, &phyData);
+	phyData &= ~(CAPABLE_1000BASE_TX_FD | CAPABLE_1000BASE_TX_HD);
+	rtl8651_setAsicEthernetPHYReg(phyId, 9, phyData);
+
+	phyId = rtl8651AsicEthernetTable[5].phyId;
+	rtl8651_getAsicEthernetPHYReg( phyId, 9, &phyData);
+	phyData &= ~(CAPABLE_1000BASE_TX_FD | CAPABLE_1000BASE_TX_HD);
+	rtl8651_setAsicEthernetPHYReg(phyId, 9, phyData);
+
+	//enhance GMII TX pad driving
+	DBG("enhance GMII TX pad driving for FPGA v6");
+	rtl8651_setAsicEthernetPHYTxPadDriving(0);
+	rtl8651_setAsicEthernetPHYTxPadDriving(4);
+	rtl8651_setAsicEthernetPHYTxPadDriving(5);
+
+	//restart all PHYs
+	DBG("restart all PHYs");
+	rtl8651_restartAsicEthernetPHYNway(0);
+	rtl8651_restartAsicEthernetPHYNway(4);
+	rtl8651_restartAsicEthernetPHYNway(5);
+	DBG("finish to restart all PHYs");
+#else //!defined(CONFIG_FPGA_V6_HWNAT)
+	#if defined(CONFIG_RTL_CPU_TAG)
+	#if 0 /* use CPU tag on both MAC0 and MAC5 */
+	/* Set MAC1~4 port isolation, only can forward to CPU and MAC0/MAC5 (WAN) */
+	/* MAC0/MAC5 can forward to all ports */
+	WRITE_MEM32(PISOCR0, 0x1E1785FF);
+	WRITE_MEM32(PISOCR1, 0x1FF785E1);
+	#endif
+	#if 1 /* use CPU tag on only MAC0 */
+	/* Set MAC0~4 port isolation, only can forward to CPU and MAC5 (WAN) */
+	/* MAC5 can forward to all ports */
+	WRITE_MEM32(PISOCR0, 0x1E0781E0);
+	WRITE_MEM32(PISOCR1, 0x1FF781E0);
+	#endif
+	#if 0 /* use CPU tag on only MAC5 */
+	/* Set MAC0~4 port isolation, only can forward to CPU and MAC5 (WAN) */
+	/* MAC5 can forward to all ports */
+	WRITE_MEM32(PISOCR0, 0x1E0781E0);
+	WRITE_MEM32(PISOCR1, 0x1FF781E0);
+	#endif
+	#endif /* CONFIG_RTL_CPU_TAG */
+
+	//enable auto negotiation,
+	//turn on all advertise abilities,
+	//enable PHY interface of MAC0
+	if (hwnat_mac0_enable == 1 && hwnat_mac0_mode == 0 /*RGMII*/) {
+		WRITE_MEM32(PCRP0, (READ_MEM32(PCRP0) &
+				~(ExtPHYID_MASK | EnForceMode | PollLinkStatus |
+				PauseFlowControl_MASK | AcptMaxLen_16K)) |
+				(rtl8651AsicEthernetTable[0].phyId << ExtPHYID_OFFSET) |
+				NwayAbility1000MF |
+				NwayAbility100MF |
+				NwayAbility100MH |
+				NwayAbility10MF |
+				NwayAbility10MH |
+				PauseFlowControlEtxDrx |
+				MacSwReset |
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+				AcptMaxLen_9K |
+#endif /* CONFIG_RTL_JUMBO_FRAME */
+				EnablePHYIf);
+		REG32(P0GMIICR) |= Conf_done;
+	}
+#ifdef CONFIG_RTD_1295_MAC0_SGMII_LINK_MON
+	else if (hwnat_mac0_enable == 1 && hwnat_mac0_mode == 1 /*SGMII*/ &&
+				(get_rtd129x_cpu_revision() == RTD129x_CHIP_REVISION_A00)) {
+		WRITE_MEM32(PCRP0, (READ_MEM32(PCRP0) &
+				~(PauseFlowControl_MASK | AutoNegoSts_MASK |
+				PollLinkStatus | ForceLink | AcptMaxLen_16K)) |
+				EnForceMode |
+				ForceSpeed10M |
+				PauseFlowControlEtxErx |
+				MacSwReset |
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+				AcptMaxLen_9K |
+#endif /* CONFIG_RTL_JUMBO_FRAME */
+				EnablePHYIf);
+	}
+#endif /* CONFIG_RTD_1295_MAC0_SGMII_LINK_MON */
+	else if (hwnat_mac0_enable == 1 && hwnat_mac0_mode == 1 /*SGMII*/) { /* get_rtd129x_cpu_revision() == RTD129x_CHIP_REVISION_A01 */
+		WRITE_MEM32(PCRP0, (READ_MEM32(PCRP0) &
+				~(EnForceMode | PollLinkStatus |
+				PauseFlowControl_MASK | AcptMaxLen_16K)) |
+				NwayAbility1000MF |
+				NwayAbility100MF |
+				NwayAbility100MH |
+				NwayAbility10MF |
+				NwayAbility10MH |
+				PauseFlowControlEtxDrx |
+				MacSwReset |
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+				AcptMaxLen_9K |
+#endif /* CONFIG_RTL_JUMBO_FRAME */
+				EnablePHYIf);
+	} else if (hwnat_mac0_enable == 1 && (hwnat_mac0_mode & 2) > 0 /* to MAC */) {
+		//arrange PHY ID for MAC0,
+		//enable force link up,
+		//turn on 1000MF,
+		//disable TX/RX pause flow control,
+		//disable PHY interface of MAC0
+		WRITE_MEM32(PCRP0, (READ_MEM32(PCRP0) &
+				~(ExtPHYID_MASK | ForceSpeedMask | PollLinkStatus |
+				PauseFlowControl_MASK | AcptMaxLen_16K)) |
+				(rtl8651AsicEthernetTable[0].phyId << ExtPHYID_OFFSET) |
+				EnForceMode |
+				ForceLink |
+				ForceSpeed1000M |
+				ForceDuplex |
+				MIIcfg_RXER |
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+				AcptMaxLen_9K |
+#endif /* CONFIG_RTL_JUMBO_FRAME */
+				MacSwReset);
+
+		if ((hwnat_mac0_mode & 1) == 0 /* RGMII */) {
+			#if defined(CONFIG_RTL_CPU_TAG)
+			REG32(P0GMIICR) |= (CFG_CPUC_TAG | CFG_TX_CPUC_TAG);
+			#endif /* CONFIG_RTL_CPU_TAG */
+
+			/* set tx and rx delay */
+			WRITE_MEM32(P0GMIICR, (READ_MEM32(P0GMIICR) & ~((3 << 18) | (1 << 4) | (7 << 0))) |
+				((hwnat_rgmii1_tx_delay & 3) << 18) |
+				(((hwnat_rgmii1_tx_delay & 4) >> 2) << 4) |
+				((hwnat_rgmii1_rx_delay & 7) << 0));
+			REG32(P0GMIICR) |= Conf_done;
+		}
+	} else { /* hwnat_mac0_enable == 0 */
+		/* write default value */
+		WRITE_MEM32(PCRP0,
+				(0x10 << ExtPHYID_OFFSET) |
+				AutoNegoSts_MASK |
+				PauseFlowControl_MASK |
+				STP_PortST_MASK |
+				MacSwReset);
+	}
+	//DBG("PCRP0 = 0x%x", READ_MEM32(PCRP0));
+
+	//enable auto negotiation,
+	//turn on all advertise abilities,
+	//enable PHY interface of MAC4
+	WRITE_MEM32(PCRP4, 	(READ_MEM32(PCRP4) &
+				~(EnForceMode | PollLinkStatus |
+				PauseFlowControl_MASK | AcptMaxLen_16K)) |
+				NwayAbility1000MF |
+				NwayAbility100MF |
+				NwayAbility100MH |
+				NwayAbility10MF |
+				NwayAbility10MH |
+				PauseFlowControlEtxDrx |
+				MacSwReset |
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+				AcptMaxLen_9K |
+#endif /* CONFIG_RTL_JUMBO_FRAME */
+				EnablePHYIf);
+	//DBG("PCRP4 = 0x%x", READ_MEM32(PCRP4));
+
+	if (hwnat_mac5_conn_to == 0 /* PHY */) {
+		//arrange PHY ID for MAC5,
+		//enable auto negotiation,
+		//turn on all advertise abilities,
+		//enable PHY interface of MAC5
+		WRITE_MEM32(PCRP5, (READ_MEM32(PCRP5) &
+				~(ExtPHYID_MASK | EnForceMode | PollLinkStatus |
+				PauseFlowControl_MASK | AcptMaxLen_16K)) |
+				(rtl8651AsicEthernetTable[5].phyId << ExtPHYID_OFFSET) |
+				NwayAbility1000MF |
+				NwayAbility100MF |
+				NwayAbility100MH |
+				NwayAbility10MF |
+				NwayAbility10MH |
+				PauseFlowControlEtxDrx |
+				MacSwReset |
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+				AcptMaxLen_9K |
+#endif /* CONFIG_RTL_JUMBO_FRAME */
+				EnablePHYIf);
+		//DBG("PCRP5 = 0x%x", READ_MEM32(PCRP5));
+	} else {
+		//arrange PHY ID for MAC5,
+		//enable force link up,
+		//turn on 1000MF,
+		//disable TX/RX pause flow control,
+		//disable PHY interface of MAC5
+		WRITE_MEM32(PCRP5, (READ_MEM32(PCRP5) &
+				~(ExtPHYID_MASK | ForceSpeedMask | PollLinkStatus |
+				PauseFlowControl_MASK | AcptMaxLen_16K)) |
+				(rtl8651AsicEthernetTable[5].phyId << ExtPHYID_OFFSET) |
+				EnForceMode |
+				ForceLink |
+				ForceSpeed1000M |
+				ForceDuplex |
+				MIIcfg_RXER |
+#if defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)
+				PauseFlowControlEtxErx |
+#endif /* CONFIG_RTL_2_RGMII_PORTS_ONLY */
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+				AcptMaxLen_9K |
+#endif /* CONFIG_RTL_JUMBO_FRAME */
+				MacSwReset);
+		//DBG("PCRP5 = 0x%x", READ_MEM32(PCRP5));
+
+		/* set tx and rx delay */
+		WRITE_MEM32(P5GMIICR, (READ_MEM32(P5GMIICR) & ~((3 << 18) | (1 << 4) | (7 << 0))) |
+				((hwnat_rgmii0_tx_delay & 3) << 18) |
+				(((hwnat_rgmii0_tx_delay & 4) >> 2) << 4) |
+				((hwnat_rgmii0_rx_delay & 7) << 0));
+	}
+
+	//assign MAC5 to be GMII MAC auto mode
+	//WRITE_MEM32(P5GMIICR, (READ_MEM32(P5GMIICR) & ~(3 << 23)) | (0x1 << 23));
+	rtl865xC_setAsicEthernetMIIMode(5, LINK_RGMII);
+	#if defined(CONFIG_RTL_CPU_TAG)
+	//REG32(P5GMIICR) |= (CFG_CPUC_TAG | CFG_TX_CPUC_TAG);
+	/* enable router mode and let port5 connect to switch */
+	//REG32(MACCR1) |= (EN_ROUTER_MODE | ROUTER_MODE_TYPE_1); /* MAC0 and MAC5 connect to switch */
+	//REG32(MACCR1) |= (EN_ROUTER_MODE | ROUTER_MODE_TYPE_3); /* only MAC5 connects to switch */
+	REG32(MACCR1) |= (EN_ROUTER_MODE | ROUTER_MODE_TYPE_2); /* MAC0 connect to switch, MAC5 is WAN */
+	REG32(MACCR2) = (4 << SPA0_MAP_OFFSET) |
+			(1 << SPA1_MAP_OFFSET) |
+			(2 << SPA2_MAP_OFFSET) |
+			(3 << SPA3_MAP_OFFSET) |
+			(5 << SPA4_MAP_OFFSET) |
+			(0 << SPA5_MAP_OFFSET) ;
+	#endif /* CONFIG_RTL_CPU_TAG */
+	REG32(P5GMIICR) |= Conf_done;
+
+	#if !defined(CONFIG_RTL_CPU_TAG)
+	//enable force mode
+	//turn off all advertise abilities,
+	//disable PHY interface of MAC1
+	WRITE_MEM32(PCRP1, 	(READ_MEM32(PCRP1) & ~(PollLinkStatus | NwayAbility1000MF |
+				NwayAbility100MF | NwayAbility100MH | NwayAbility10MF | NwayAbility10MH |
+				EnablePHYIf)) | EnForceMode);
+
+	//enable force mode
+	//enable auto negotiation,
+	//turn off all advertise abilities,
+	//disable PHY interface of MAC2
+	WRITE_MEM32(PCRP2, 	(READ_MEM32(PCRP2) & ~(PollLinkStatus | NwayAbility1000MF |
+				NwayAbility100MF | NwayAbility100MH | NwayAbility10MF | NwayAbility10MH |
+				EnablePHYIf)) | EnForceMode);
+
+	//enable force mode
+	//enable auto negotiation,
+	//turn off all advertise abilities,
+	//disable PHY interface of MAC3
+	WRITE_MEM32(PCRP3, 	(READ_MEM32(PCRP3) & ~(PollLinkStatus | NwayAbility1000MF |
+				NwayAbility100MF | NwayAbility100MH | NwayAbility10MF | NwayAbility10MH |
+				EnablePHYIf)) | EnForceMode);
+	#endif /* !CONFIG_RTL_CPU_TAG */
+
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+	WRITE_MEM32(PCRP6, 	(READ_MEM32(PCRP6) & ~(AcptMaxLen_16K)) |
+				AcptMaxLen_9K);
+#endif /* CONFIG_RTL_JUMBO_FRAME */
+
+	/* set "System clock selection" to 100MHz
+		2'b00: 50MHz, 2'b01: 100MHz, 2'b10, 2'b11 reserved
+	*/
+	REG32(MACCR)= (REG32(MACCR) & ~(CF_SYSCLK_SEL_MASK)) | (0x01 << CF_SYSCLK_SEL_OFFSET);
+
+	/* set "Cport MAC clock selection with NIC interface" to lx_clk */
+	REG32(MACCTRL1) |= CF_CMAC_CLK_SEL;
+
+#endif //defined(CONFIG_FPGA_V6_HWNAT)
+
+#else //defined(CONFIG_RTD_1295_HWNAT)
+
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT1234_RTL8212)
+	{
+
+		printk("\nEnable Port1~Port4 GigaPort.\n\n");
+		/* Patch for 'RGMII port does not get descritpors'. Set to MII PHY mode first and later we'll change to RGMII mode again. */
+		rtl865xC_setAsicEthernetMIIMode(0, LINK_MII_PHY);
+
+		/*
+			# According to Hardware SD: David & Maxod,
+
+			Set Port5_GMII Configuration Register.
+			- RGMII Output Timing compensation control : 0 ns
+			- RGMII Input Timing compensation control : 0 ns
+		*/
+		rtl865xC_setAsicEthernetRGMIITiming(0, RGMII_TCOMP_0NS, RGMII_RCOMP_0NS);
+
+		/* Set P1 - P4 to SerDes Interface. */
+		WRITE_MEM32(PITCR, Port4_TypeCfg_SerDes | Port3_TypeCfg_SerDes | Port2_TypeCfg_SerDes | Port1_TypeCfg_SerDes );
+	}
+	else if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		/* Patch for 'RGMII port does not get descritpors'. Set to MII PHY mode first and later we'll change to RGMII mode again. */
+		rtl865xC_setAsicEthernetMIIMode(RTL8651_MII_PORTNUMBER, LINK_MII_PHY);
+
+		/*
+			# According to Hardware SD: David & Maxod,
+
+			Set Port5_GMII Configuration Register.
+			- RGMII Output Timing compensation control : 0 ns
+			- RGMII Input Timing compensation control : 0 ns
+		*/
+		rtl865xC_setAsicEthernetRGMIITiming(RTL8651_MII_PORTNUMBER, RGMII_TCOMP_0NS, RGMII_RCOMP_0NS);
+	}
+
+#if defined(CONFIG_RTL_8198C)
+	rtl8651AsicEthernetTable[0].phyId = RTL8198C_PORT0_PHY_ID;	/* Default value of port 0's embedded phy id -- 8 */
+	rtl8651AsicEthernetTable[1].phyId = 1;	/* Default value of port 1's embedded phy id -- 1 */
+	rtl8651AsicEthernetTable[2].phyId = 2;	/* Default value of port 2's embedded phy id -- 2 */
+	rtl8651AsicEthernetTable[3].phyId = 3;	/* Default value of port 3's embedded phy id -- 3 */
+	rtl8651AsicEthernetTable[4].phyId = 4;	/* Default value of port 4's embedded phy id -- 4 */
+	rtl8651AsicEthernetTable[0].isGPHY = TRUE;
+	rtl8651AsicEthernetTable[1].isGPHY = TRUE;
+	rtl8651AsicEthernetTable[2].isGPHY = TRUE;
+	rtl8651AsicEthernetTable[3].isGPHY = TRUE;
+	rtl8651AsicEthernetTable[4].isGPHY = TRUE;
+
+#elif defined(CONFIG_RTL_8197F)
+	rtl8651AsicEthernetTable[0].phyId = RTL8198C_PORT0_PHY_ID;	/* Default value of port 0's embedded phy id -- 8 */
+	rtl8651AsicEthernetTable[1].phyId = 1;	/* Default value of port 1's embedded phy id -- 1 */
+	rtl8651AsicEthernetTable[2].phyId = 2;	/* Default value of port 2's embedded phy id -- 2 */
+	rtl8651AsicEthernetTable[3].phyId = 3;	/* Default value of port 3's embedded phy id -- 3 */
+	rtl8651AsicEthernetTable[4].phyId = 4;	/* Default value of port 4's embedded phy id -- 4 */
+	rtl8651AsicEthernetTable[0].isGPHY = FALSE;
+	rtl8651AsicEthernetTable[1].isGPHY = FALSE;
+	rtl8651AsicEthernetTable[2].isGPHY = FALSE;
+	rtl8651AsicEthernetTable[3].isGPHY = FALSE;
+	rtl8651AsicEthernetTable[4].isGPHY = FALSE;
+
+#else
+	memset( &rtl8651AsicEthernetTable[0], 0, ( RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum ) * sizeof(rtl8651_tblAsic_ethernet_t) );
+	/* Record the PHYIDs of physical ports. Default values are 0. */
+	rtl8651AsicEthernetTable[0].phyId = 0;	/* Default value of port 0's embedded phy id -- 0 */
+	rtl8651AsicEthernetTable[0].isGPHY = FALSE;
+
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT1234_RTL8212)
+	{
+		rtl8651AsicEthernetTable[1].phyId = rtl8651_tblAsicDrvPara.externalPHYId[1];
+		rtl8651AsicEthernetTable[2].phyId = rtl8651_tblAsicDrvPara.externalPHYId[2];
+		rtl8651AsicEthernetTable[3].phyId = rtl8651_tblAsicDrvPara.externalPHYId[3];
+		rtl8651AsicEthernetTable[4].phyId = rtl8651_tblAsicDrvPara.externalPHYId[4];
+		rtl8651AsicEthernetTable[1].isGPHY = TRUE;
+		rtl8651AsicEthernetTable[2].isGPHY = TRUE;
+		rtl8651AsicEthernetTable[3].isGPHY = TRUE;
+		rtl8651AsicEthernetTable[4].isGPHY = TRUE;
+	} else
+	{	/* USE internal 10/100 PHY */
+		rtl8651AsicEthernetTable[1].phyId = 1;	/* Default value of port 1's embedded phy id -- 1 */
+		rtl8651AsicEthernetTable[2].phyId = 2;	/* Default value of port 2's embedded phy id -- 2 */
+		rtl8651AsicEthernetTable[3].phyId = 3;	/* Default value of port 3's embedded phy id -- 3 */
+		rtl8651AsicEthernetTable[4].phyId = 4;	/* Default value of port 4's embedded phy id -- 4 */
+		rtl8651AsicEthernetTable[1].isGPHY = FALSE;
+		rtl8651AsicEthernetTable[2].isGPHY = FALSE;
+		rtl8651AsicEthernetTable[3].isGPHY = FALSE;
+		rtl8651AsicEthernetTable[4].isGPHY = FALSE;
+	}
+
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		rtl8651AsicEthernetTable[RTL8651_MII_PORTNUMBER].phyId = rtl8651_tblAsicDrvPara.externalPHYId[5];
+		rtl8651AsicEthernetTable[RTL8651_MII_PORTNUMBER].isGPHY = TRUE;
+		rtl8651_setAsicEthernetMII(	rtl8651AsicEthernetTable[RTL8651_MII_PORTNUMBER].phyId,
+									P5_LINK_RGMII,
+									TRUE );
+	}
+#endif
+
+#ifdef CONFIG_RTL8196C_REVISION_B
+	if (REG32(REVR) == RTL8196C_REVISION_B)
+		Setting_RTL8196C_PHY();
+
+#elif defined(CONFIG_RTL_8198C)
+	Setting_RTL8198C_GPHY();
+
+#elif defined(CONFIG_RTL_8196E)
+	Setting_RTL8196E_PHY();
+
+#elif defined(CONFIG_RTL_8881A)
+	Setting_RTL8881A_PHY();
+
+#elif defined(CONFIG_RTL_819XD)
+	Setting_RTL8197D_PHY();
+
+#elif defined(CONFIG_RTL_8198)
+	Setting_RTL8198_GPHY();
+
+#elif defined(CONFIG_RTL_8197F)
+	Setting_RTL8197F_PHY();
+
+#endif
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+}
+
+/*=========================================
+  * init Layer2 Asic
+  * rtl865x_initAsicL2 mainly configure basic&L2 Asic.
+  * =========================================*/
+int32 rtl865x_initAsicL2(rtl8651_tblAsic_InitPara_t *para)
+{
+	int32 index;
+
+#if defined (CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	uint32 token= 0, tick = 0, hiThreshold = 0;
+	uint32 maccrData =0, dataTemp = 0;
+#endif
+
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)) && !(defined(CONFIG_RTL_8211F_SUPPORT))
+	unsigned int P0phymode, P0miimode, P0txdly, P0rxdly;
+#endif
+
+#ifdef CONFIG_RTL8196C_ETH_IOT
+	port_link_sts = 0;
+	port_linkpartner_eee = 0;
+#endif
+
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A)
+	rtl865x_probeSdramSize();
+#endif
+
+	ASICDRV_INIT_CHECK(_rtl8651_initAsicPara(para));
+
+	initAsic_PHY();
+
+#ifdef CONFIG_8198_PORT5_RGMII
+	init_8198_p5();
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	init_8367r();
+
+#ifdef CONFIG_RTL_8198C_8367RB
+	init_8367rb_for_8198c();
+#endif
+
+#elif defined(CONFIG_RTL_8370_SUPPORT)
+	init_8370();
+
+#elif defined(CONFIG_RTL_8325D_SUPPORT)
+	init_8325d();
+#endif
+
+	/* 	2006.12.12
+		We turn on bit.10 (ENATT2LOG).
+
+		* Current implementation of unnumbered pppoe in multiple session
+		When wan type is multiple-session, and one session is unnumbered pppoe, WAN to unnumbered LAN is RP --> NPI.
+		And user adds ACL rule to trap dip = unnumbered LAN to CPU.
+
+		However, when pktOpApp of this ACL rule is set, it seems that this toCPU ACL does not work.
+		Therefore, we turn on this bit (ENATT2LOG) to trap pkts (WAN --> unnumbered LAN) to CPU.
+
+	*/
+	WRITE_MEM32( SWTCR1, READ_MEM32( SWTCR1 ) | EnNATT2LOG );
+
+	/*
+	  * Turn on ENFRAG2ACLPT for Rate Limit. For those packets which need to be trapped to CPU, we turn on
+	  * this bit to tell ASIC ACL and Protocol Trap to process these packets. If this bit is not turnned on, packets
+	  * which need to be trapped to CPU will not be processed by ASIC ACL and Protocol Trap.
+	  * NOTE: 	If this bit is turned on, the backward compatible will disable.
+	  *																- chhuang
+	  */
+	WRITE_MEM32( SWTCR1, READ_MEM32( SWTCR1 ) | ENFRAGTOACLPT );
+
+#ifdef CONFIG_RTL865X_LIGHT_ROMEDRV
+	WRITE_MEM32( SWTCR1, READ_MEM32( SWTCR1 ) | L4EnHash1 );    /*Turn on Napt Enhanced hash1*/
+#endif
+
+	/*
+	  * Cannot turn on EnNAP8651B due to:
+	  * If turn on, NAT/LP/ServerPort will reference nexthop. This will result in referecing wrong L2 entry when
+	  * the destination host is in the same subnet as WAN.
+	  */
+
+	rtl8651_totalExtPortNum=3; //this replaces all RTL8651_EXTPORT_NUMBER defines
+	rtl8651_allExtPortMask = 0x7<<RTL8651_MAC_NUMBER; //this replaces all RTL8651_EXTPORTMASK defines
+
+	//Disable layer2, layer3 and layer4 function
+	//Layer 2 enabled automatically when a VLAN is added
+	//Layer 3 enabled automatically when a network interface is added.
+	//Layer 4 enabled automatically when an IP address is setup.
+	rtl8651_setAsicOperationLayer(1);
+	rtl8651_clearAsicCommTable();
+	rtl8651_clearAsicL2Table();
+	//rtl8651_clearAsicAllTable();//MAY BE OMITTED. FULL_RST clears all tables already.
+	rtl8651_setAsicSpanningEnable(FALSE);
+
+#ifdef RTL865XB_URL_FILTER
+	WRITE_MEM32( SWTCR1, READ_MEM32( SWTCR1 ) | EN_51B_CPU_REASON );	/* Use 8650B's new reason bit definition. */
+#endif
+
+	/* Init PHY LED style */
+#ifdef CONFIG_RTL_819X
+#if defined (CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198)
+
+#elif defined(CONFIG_RTL_8881A)
+
+	#if defined(CONFIG_RTL_8367R_SUPPORT)
+	REG32(PIN_MUX_SEL) &= ~( (3<<8) | (3<<10) | (1<<15) );
+	REG32(PIN_MUX_SEL2) &= ~ ((3<<0) | (3<<3) | (3<<6) | (3<<9) | (7<<15) );  //S0-S3, P0-P1
+
+	#else
+	#if defined(CONFIG_I2C_GPIO_MFI_COPROCESSOR_DRIVER)
+	REG32(PIN_MUX_SEL) &= ~( (1<<15) );
+	REG32(PIN_MUX_SEL2) &= ~ ((3<<0) | (3<<3) | (3<<6) | (3<<9) | (3<<12) | (7<<15) );  //S0-S3, P0-P1
+	#else
+	REG32(PIN_MUX_SEL) &= ~( (3<<8) | (3<<10) | (3<<3) | (1<<15) );  //let P0 to mii mode
+	REG32(PIN_MUX_SEL2) &= ~ ((3<<0) | (3<<3) | (3<<6) | (3<<9) | (3<<12) | (7<<15) );  //S0-S3, P0-P1
+	#endif
+	#endif
+	REG32(LEDCREG)  = (2<<20) | (0<<18) | (0<<16) | (0<<14) | (0<<12) | (0<<10) | (0<<8);  //P0-P5
+
+#elif defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	/*
+		#LED = direct mode
+		set mode 0x0
+		swwb 0xbb804300 21-20 0x2 19-18 $mode 17-16 $mode 15-14 $mode 13-12 $mode 11-10 $mode 9-8 $mode
+	*/
+	#ifdef 	CONFIG_RTK_VOIP_BOARD
+	//for GMII/RGMII
+	//REG32(PIN_MUX_SEL) &= ~( (3<<8) | (3<<10) | (3<<3) | (1<<15) );  //let P0 to mii mode
+	REG32(PIN_MUX_SEL2) &= ~ ((3<<0) | (3<<3) | (3<<6) | (3<<9) | (3<<12) );  //LED0~LED4
+
+	#elif defined(CONFIG_RTL_8367MB_SUPPORT)
+	REG32(PIN_MUX_SEL) &= ~( (3<<8) | (1<<15) );
+	REG32(PIN_MUX_SEL2) &= ~ ((3<<0) | (3<<3) | (3<<6) | (3<<9) | (3<<12) | (7<<15) );  //S0-S3, P0-P1
+
+	#elif defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+	REG32(PIN_MUX_SEL) &= ~( (3<<8) | (3<<10) | (1<<15) );
+	REG32(PIN_MUX_SEL2) &= ~ ((3<<0) | (3<<3) | (3<<6) | (3<<9) | (3<<12) | (7<<15) );  //S0-S3, P0-P1
+
+	#elif defined(CONFIG_RTL_8325D_SUPPORT)
+	REG32(PIN_MUX_SEL) &= ~( (3<<8) | (3<<3) | (1<<15) );
+	REG32(PIN_MUX_SEL2) &= ~ ((3<<0) | (3<<3) | (3<<6) | (3<<9) | (3<<12) | (7<<15) );  //S0-S3, P0-P1
+
+	#else
+	#ifndef CONFIG_MTD_NAND
+	REG32(PIN_MUX_SEL) &= ~( (3<<8) | (3<<10) | (3<<3) | (1<<15) );  //let P0 to mii mode
+	#endif
+#if defined(CONFIG_RTL_8196E) && defined(CONFIG_APPLE_MFI_SUPPORT)
+
+	if (((REG32(BOND_OPTION) & BOND_ID_MASK) == BOND_8196E3))
+	{
+		REG32(PIN_MUX_SEL2) &= ~ ((3<<12) | (7<<15) );  //P4
+	}
+	else if (((REG32(BOND_OPTION) & BOND_ID_MASK) == BOND_8196EU3))
+	{
+		REG32(PIN_MUX_SEL2) &= ~ ((7<<15));
+	}
+	else
+		REG32(PIN_MUX_SEL2) &= ~ ((3<<0) | (3<<3) | (3<<6) | (3<<9) | (3<<12) | (7<<15) );  //S0-S3, P0-P1
+
+#elif defined(CONFIG_RTL_96E_GPIOB5_RESET)
+	REG32(PIN_MUX_SEL2) &= ~ ((3<<12));
+#else
+	REG32(PIN_MUX_SEL2) &= ~ ((3<<0) | (3<<3) | (3<<6) | (3<<9) | (3<<12) | (7<<15) );  //S0-S3, P0-P1
+#endif
+	#endif
+	REG32(LEDCREG)  = (2<<20) | (0<<18) | (0<<16) | (0<<14) | (0<<12) | (0<<10) | (0<<8);  //P0-P5
+
+#elif defined (CONFIG_RTL_8198C)
+#ifndef CONFIG_USING_JTAG
+	REG32(PIN_MUX_SEL3) = (REG32(PIN_MUX_SEL3) & ~ (0x7FFF)) | ((1<<0) | (1<<3) | (1<<6) | (1<<9) | (1<<12));  //LED0~LED4
+#else
+	REG32(PIN_MUX_SEL3) = (REG32(PIN_MUX_SEL3) & ~ (0x7FFF));
+#endif
+	REG32(LEDCR0) = (REG32(LEDCR0) & ~ LEDTOPOLOGY_MASK) |LEDMODE_DIRECT;
+	REG32(DIRECTLCR) = (REG32(DIRECTLCR) & ~ LEDONSCALEP0_MASK) |(7<<LEDONSCALEP0_OFFSET);
+
+#elif defined(CONFIG_RTL_8197F)
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	REG32(LEDCR0) = (REG32(LEDCR0) & ~(LEDTOPOLOGY_MASK | (3 << 10))) |
+			((hwnat_led_mode & 3) << 10) |
+			((hwnat_led_mode & 4) ? LEDMODE_DIRECT : LEDMODE_SCAN);
+	#else /* CONFIG_RTD_1295_HWNAT */
+	#if !defined(CONFIG_RTL_8367R_SUPPORT)
+	{
+		extern uint32 rtl819x_bond_option(void);
+		if (rtl819x_bond_option() != 3)
+			REG32(PIN_MUX_SEL13) = 0;
+
+		#if !defined(CONFIG_RTL_8211F_SUPPORT)
+		REG32(PIN_MUX_SEL14) = 0;
+		#endif
+	}
+	#endif
+#if defined(CONFIG_APPLE_MFI_SUPPORT)
+	REG32(PIN_MUX_SEL15) = ((REG32(PIN_MUX_SEL15)&(0xFFFFFF00)) | (0x77));
+#endif
+	REG32(LEDCR0) = (REG32(LEDCR0) & ~LEDTOPOLOGY_MASK) | LEDMODE_DIRECT;
+	#endif /* CONFIG_RTD_1295_HWNAT */
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198)
+	//MAC Control (0xBC803000)
+/*	WRITE_MEM32(MACCR,READ_MEM32(MACCR)&~DIS_IPG);//Set IFG range as 96+-4bit time*/
+	WRITE_MEM32(MACCR,READ_MEM32(MACCR)&~NORMAL_BACKOFF);//Normal backoff
+	WRITE_MEM32(MACCR,READ_MEM32(MACCR)&~BACKOFF_EXPONENTIAL_3);//Exponential parameter is 9
+	WRITE_MEM32(MACCR,READ_MEM32(MACCR)|INFINITE_PAUSE_FRAMES);//send pause frames infinitely.
+	WRITE_MEM32(MACCR,READ_MEM32(MACCR)|DIS_MASK_CGST);
+#endif
+
+	miiPhyAddress = -1;		/* not ready to use mii port 5 */
+
+/*	WRITE_MEM32(MACCR,READ_MEM32(MACCR)&~(EN_FX_P4 | EN_FX_P3 | EN_FX_P2 | EN_FX_P1 | EN_FX_P0));//Disable FX mode (UTP mode)*/
+	/* Initialize MIB counters */
+	rtl8651_clearAsicCounter();
+
+	rtl865xC_setNetDecisionPolicy( NETIF_VLAN_BASED );	/* Net interface Multilayer-Decision-Based Control -- Set to VLAN-Based mode. */
+	//rtl865xC_setNetDecisionPolicy( NETIF_PORT_BASED );	/* Net interface Multilayer-Decision-Based Control -- Set to port-Based mode. */
+	//WRITE_MEM32(PLITIMR,0);
+
+	/*FIXME:Hyking init in Layer4 2*/
+	//WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0)&~NAPTR_NOT_FOUND_DROP);//When reverse NAPT entry not found, CPU process it.
+	//rtl8651_setAsicNaptAutoAddDelete(FALSE, TRUE);
+	WRITE_MEM32( VCR0, READ_MEM32( VCR0 ) & (~EN_ALL_PORT_VLAN_INGRESS_FILTER) );		/* Disable VLAN ingress filter of all ports */ /* Please reference to the maintis bug 2656# */
+#ifdef CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT
+	WRITE_MEM32( VCR0, READ_MEM32( VCR0 ) | EN_1QTAGVIDIGNORE );		/* enable ignore 802.1q vlan */
+#endif
+	/*WRITE_MEM32( VCR0, READ_MEM32( VCR0 ) & (~EN_ALL_PORT_VLAN_INGRESS_FILTER) );*/		/* Enable VLAN ingress filter of all ports */
+	WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0)&~WAN_ROUTE_MASK);//Set WAN route toEnable (Allow traffic from WAN port to WAN port)
+	WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0)|NAPTF2CPU);//When packet destination to switch. Just send to CPU
+	WRITE_MEM32(SWTCR0,(READ_MEM32(SWTCR0)&(~LIMDBC_MASK))|LIMDBC_VLAN);//When packet destination to switch. Just send to CPU
+
+	/*FIXME:Hyking init in Layer3 1*/
+	//rtl8651_setAsicMulticastEnable(TRUE); /* Enable multicast table */
+
+	/* Enable unknown unicast / multicast packet to be trapped to CPU. */
+//	WRITE_MEM32( FFCR, READ_MEM32( FFCR ) | EN_UNUNICAST_TOCPU );
+	WRITE_MEM32( FFCR, READ_MEM32( FFCR ) & ~EN_UNUNICAST_TOCPU );
+	WRITE_MEM32( FFCR, READ_MEM32( FFCR ) | EN_UNMCAST_TOCPU );
+/*	WRITE_MEM32(SWTMCR,READ_MEM32(SWTMCR)&~MCAST_TO_CPU);*/
+/*	WRITE_MEM32(SWTMCR,READ_MEM32(SWTMCR)|EN_BCAST);//Enable special broadcast handling*/
+/*	WRITE_MEM32(SWTMCR,READ_MEM32(SWTMCR)&~BCAST_TO_CPU);//When EN_BCAST enables, this bit is invalid*/
+/*	WRITE_MEM32(SWTMCR,READ_MEM32(SWTMCR)&~BRIDGE_PKT_TO_CPU);//Current no bridge protocol is supported*/
+
+	/*FIXME:Hyking init in Layer3 1*/
+	//WRITE_MEM32(ALECR, READ_MEM32(ALECR)|(uint32)EN_PPPOE);//enable PPPoE auto encapsulation
+	WRITE_MEM32(CSCR,READ_MEM32(CSCR)&~ALLOW_L2_CHKSUM_ERR);//Don't allow chcksum error pkt be forwarded.
+
+	WRITE_MEM32(CSCR,READ_MEM32(CSCR)&~ALLOW_L3_CHKSUM_ERR);
+	WRITE_MEM32(CSCR,READ_MEM32(CSCR)&~ALLOW_L4_CHKSUM_ERR);
+	WRITE_MEM32(CSCR,READ_MEM32(CSCR)|EN_ETHER_L3_CHKSUM_REC); //Enable L3 checksum Re-calculation
+	WRITE_MEM32(CSCR,READ_MEM32(CSCR)|EN_ETHER_L4_CHKSUM_REC); //Enable L4 checksum Re-calculation
+
+/*	WRITE_MEM32(MISCCR,READ_MEM32(MISCCR)&~FRAG2CPU);//IP fragment packet does not need to send to CPU when initial ASIC
+	WRITE_MEM32(MISCCR,READ_MEM32(MISCCR)&~MULTICAST_L2_MTU_MASK);
+	WRITE_MEM32(MISCCR,READ_MEM32(MISCCR)|(1522&MULTICAST_L2_MTU_MASK));//Multicast packet layer2 size 1522 at most*/
+	/* follow RTL865xB's convention, we use 1522 as default multicast MTU */
+
+	/*FIXME:Hyking init in Layer3 1*/
+	//rtl8651_setAsicMulticastMTU(1522);
+
+	//Set all Protocol-Based Reg. to 0
+
+	for (index=0;index<32;index++)
+		WRITE_MEM32(PBVCR0+index*4,  0x00000000);
+	//Enable TTL-1
+	/*FIXME:Hyking init in Layer3 1*/
+	//WRITE_MEM32(TTLCR,READ_MEM32(TTLCR)|(uint32)EN_TTL1);//Don't hide this router. enable TTL-1 when routing on this gateway.
+
+
+	for (index=0; index<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; index++) {
+
+		rtl865xC_setAsicSpanningTreePortState(index, RTL8651_PORTSTA_FORWARDING);
+
+		rtl8651_setAsicEthernetBandwidthControl(index, TRUE, RTL8651_BC_FULL);
+		rtl8651_setAsicEthernetBandwidthControl(index, FALSE, RTL8651_BC_FULL);
+	}
+
+	// 08-15-2012, set TRXRDY bit in rtl865x_start() in rtl865x_asicCom.c
+	/* Enable TX/RX After ALL ASIC configurations are done */
+	//WRITE_MEM32( SIRR, READ_MEM32(SIRR)| TRXRDY );
+
+	/* Initiate Bandwidth control backward compatible mode : Set all of them to FULL-Rate */
+	{
+		int32 portIdx, typeIdx;
+		_rtl865xB_BandwidthCtrlMultiplier = _RTL865XB_BANDWIDTHCTRL_X1;
+		for ( portIdx = 0 ; portIdx < RTL8651_PORT_NUMBER ; portIdx ++ )
+		{
+			for ( typeIdx = 0 ; typeIdx < _RTL865XB_BANDWIDTHCTRL_CFGTYPE ; typeIdx ++ )
+			{
+				_rtl865xB_BandwidthCtrlPerPortConfiguration[portIdx][typeIdx] = BW_FULL_RATE;
+			}
+		}
+		/* Sync the configuration to ASIC */
+		_rtl8651_syncToAsicEthernetBandwidthControl();
+	}
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	/* ===============================
+	    =============================== */
+	{
+		uint32 port;
+		uint32 maxPort;
+
+		maxPort =	(rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)?
+					RTL8651_MAC_NUMBER:
+					RTL8651_PHY_NUMBER;
+
+		for ( port = 0 ; port < maxPort ; port ++ )
+		{
+			rtl8651_setAsicFlowControlRegister(port, TRUE);
+			rtl865xC_setAsicPortPauseFlowControl(port, TRUE, TRUE);
+		}
+	}
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+	/* ===============================
+	 	EEE setup
+	    =============================== */
+#if defined(CONFIG_RTL_EEE_DISABLED) || defined(CONFIG_MP_PSD_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+	eee_enabled = 0;
+#else
+	eee_enabled = 1;
+#endif
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	if (eee_enabled) {
+		enable_EEE();
+	}
+	else {
+		disable_EEE();
+	}
+
+	/* ===============================
+	 	(1) Handling port 0.
+	    =============================== */
+	rtl8651_restartAsicEthernetPHYNway(0);	/* Restart N-way of port 0 to let embedded phy patch take effect. */
+
+	/* ===============================
+	 	(2) Handling port 1 - port 4.
+	    =============================== */
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT1234_RTL8212)
+	{
+
+	} else
+	{
+		/* Restart N-way of port 1 - port 4 to let embedded phy patch take effect. */
+		{
+			uint32 port;
+
+			/* Restart N-way of port 1 - port 4 */
+			for ( port = 1; port < RTL8651_PHY_NUMBER; port++ )
+			{
+				rtl8651_restartAsicEthernetPHYNway(port);
+			}
+		}
+	}
+
+	/* ===============================
+		(3) Handling port 5.
+	    =============================== */
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+
+	/* =====================
+		QoS-related patch
+	    ===================== */
+	{
+		#define DEFAULT_ILB_UBOUND 0x3FBE  /*added by Mark for suggested Leacky Bucket value*/
+		#define DEFAULT_ILB_LBOUND 0x3FBC
+
+		uint32 i;
+		#if 0
+		/*desigener suggest: hiThreshold=3*token,
+		in Setting_RTL8197D_PHY or some function similar, it is set as designeer suggested*/
+		uint32 token, tick, hiThreshold,i;
+		rtl8651_getAsicLBParameter( &token, &tick, &hiThreshold );
+		hiThreshold = 0x400;	/* New default vlue. */
+		rtl8651_setAsicLBParameter( token, tick, hiThreshold );
+		#endif
+		/*Mantis(2307): Ingress leaky bucket need to be initized with suggested value . added by mark*/
+		WRITE_MEM32( ILBPCR1, DEFAULT_ILB_UBOUND << UpperBound_OFFSET | DEFAULT_ILB_LBOUND << LowerBound_OFFSET );
+		for(i=0;i<=(RTL8651_PHY_NUMBER/2);i++) /*Current Token Register is 2 bytes per port*/
+			WRITE_MEM32( ILB_CURRENT_TOKEN + 4*i , DEFAULT_ILB_UBOUND << UpperBound_OFFSET | DEFAULT_ILB_UBOUND );
+
+	}
+
+	#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	/* Initiate Queue Management system */
+	_rtl865xC_QM_init();
+	#endif
+
+	/*
+		Init QUEUE Number configuration for RTL865xC : For Port 0~5 and CPU Port - All ports have 1 queue for each.
+	*/
+	{
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		for ( index = PHY0 ; index <= CPU ; index ++ )
+		{
+			/*
+				Init QUEUE Number configuration for RTL865xC : For Port 0~5 and CPU Port - All ports have 1 queue for each.
+			*/
+			rtl8651_setAsicOutputQueueNumber(index, QNUM1	/* According to DataSheet of QNUMCR : All ports use 1 queue by default */);
+		}
+
+		for ( index = 0 ; index <= 8 ; index ++ )
+		{
+			REG32(V4VLDSCPCR0 + (index * 4)) = (REG32(V4VLDSCPCR0 + (index * 4)) & ~(CF_IPM4DSCP_ACT_MASK | CF_IPM4PRI_ACT_MASK))
+				| ((CF_IPM4DSCP_ACT_REMARK << CF_IPM4DSCP_ACT_OFFSET) | (CF_IPM4PRI_ACT_ORIG << CF_IPM4PRI_ACT_OFFSET));
+		}
+#elif !defined(CONFIG_RTL_819XD) && !defined(CONFIG_RTL_8196E)
+	/*	The default value was just as same as what we want	*/
+		rtl865xC_lockSWCore();
+
+		/* Enable Flow Control for each QUEUE / Port */
+		{
+			int32 port, queue;
+
+			for ( port = PHY0 ; port <= CPU ; port ++ )
+			{
+				/*	Set the Ingress & Egress bandwidth control NO LIMIT */
+				/* Has been done by _rtl8651_syncToAsicEthernetBandwidthControl() */
+				/*
+				rtl8651_setAsicPortIngressBandwidth(port, (IBWC_ODDPORT_MASK>>IBWC_ODDPORT_OFFSET));
+				rtl8651_setAsicPortEgressBandwidth(port, (APR_MASK>>APR_OFFSET));
+				*/
+
+				/*
+					Init QUEUE Number configuration for RTL865xC : For Port 0~5 and CPU Port - All ports have 1 queue for each.
+				*/
+				rtl8651_setAsicOutputQueueNumber(port, QNUM1	/* According to DataSheet of QNUMCR : All ports use 1 queue by default */);
+
+				for ( queue = QUEUE0 ; queue <= QUEUE5 ; queue ++ )
+				{
+					rtl8651_setAsicQueueFlowControlConfigureRegister( port, queue, TRUE);
+					#if 0
+					/*	Please keep the queue setting as above.
+					*	Default set queue FC disable will corrupt wlan<->lan performance
+					*	2011/01/10 ZhaoBo
+					*/
+					rtl8651_setAsicQueueFlowControlConfigureRegister( port, queue, FALSE);
+					#endif
+				}
+			}
+		}
+
+		rtl865xC_waitForOutputQueueEmpty();
+		rtl8651_resetAsicOutputQueue();
+		rtl865xC_unLockSWCore();
+#endif
+	}
+
+	/* set default include IFG */
+	WRITE_MEM32( QOSFCR, BC_withPIFG_MASK);
+
+		{
+		#if defined(CONFIG_RTL_8197F)
+		rtl8651_setAsicPriorityDecision(2, 1, 1, 1, 1, 1);
+		#else
+		rtl8651_setAsicPriorityDecision(2, 1, 1, 1, 1);
+		#endif
+
+		WRITE_MEM32(PBPCR, 0);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTD_1295_HWNAT)
+		/* Set the threshold value for qos sytem */
+		rtd129x_setQosThreshold();
+#else
+		for(index=0;index<=CPU;index++)
+			rtl8651_setAsicPortBasedFlowControlRegister(PHY0+index,rtl_portFCON , rtl_portFCOFF);
+#endif /* CONFIG_RTD_1295_HWNAT */
+#elif defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198)
+		/* Set the threshold value for qos sytem */
+		_rtl865x_setQosThresholdByQueueIdx(QNUM_IDX_123);
+#endif
+
+	/*	clear dscp priority assignment, otherwise, pkt with dscp value 0 will be assign priority 1		*/
+		WRITE_MEM32(DSCPCR0,0);
+		WRITE_MEM32(DSCPCR1,0);
+		WRITE_MEM32(DSCPCR2,0);
+		WRITE_MEM32(DSCPCR3,0);
+		WRITE_MEM32(DSCPCR4,0);
+		WRITE_MEM32(DSCPCR5,0);
+		WRITE_MEM32(DSCPCR6,0);
+	}
+
+#if 1
+#if defined(CONFIG_RTL_8198_NFBI_BOARD)
+	//WRITE_MEM32(PIN_MUX_SEL_2, 0); //for led control
+
+	REG32(PCRP0) &= (0xFFFFFFFF-(0x00000000|MacSwReset));
+	REG32(PCRP1) &= (0xFFFFFFFF-(0x00000000|MacSwReset));
+	REG32(PCRP2) &= (0xFFFFFFFF-(0x00000000|MacSwReset));
+	REG32(PCRP3) &= (0xFFFFFFFF-(0x00000000|MacSwReset));
+	REG32(PCRP4) &= (0xFFFFFFFF-(0x00000000|MacSwReset));
+	REG32(PCRP5) &= (0xFFFFFFFF-(0x00000000|MacSwReset));
+
+	REG32(PCRP0) = REG32(PCRP0) | (0 << ExtPHYID_OFFSET) | EnablePHYIf | MacSwReset;
+	REG32(PCRP1) = REG32(PCRP1) | (1 << ExtPHYID_OFFSET) | EnablePHYIf | MacSwReset;
+	REG32(PCRP2) = REG32(PCRP2) | (2 << ExtPHYID_OFFSET) | EnablePHYIf | MacSwReset;
+	REG32(PCRP3) = REG32(PCRP3) | (3 << ExtPHYID_OFFSET) | EnablePHYIf | MacSwReset;
+	REG32(PCRP4) = REG32(PCRP4) | (4 << ExtPHYID_OFFSET) | EnablePHYIf | MacSwReset;
+
+	//port5 STP forwarding?
+	REG32(PITCR) = REG32(PITCR) & 0xFFFFF3FF; //configure port 5 to be a MII interface
+
+	// for EMI issue, use "GMII/MII MAC auto mode" instead
+	//rtl865xC_setAsicEthernetMIIMode(5, LINK_MII_PHY); //port 5 MII PHY mode
+	rtl865xC_setAsicEthernetMIIMode(5, LINK_MII_MAC); //port 5 MII MAC mode
+	REG32(P5GMIICR) = REG32(P5GMIICR) | 0x40; //Conf_done=1
+
+#if defined(RTL8198_NFBI_PORT5_GMII) //GMII mode
+	#define GMII_PIN_MUX 0xc0
+	REG32(PIN_MUX_SEL)= REG32(PIN_MUX_SEL)&(~(GMII_PIN_MUX));
+	REG32(PCRP5) = 0 | (0x10<<ExtPHYID_OFFSET) |
+			EnForceMode| ForceLink|ForceSpeed1000M|ForceDuplex |
+			MIIcfg_RXER | EnablePHYIf | MacSwReset;
+#else //MII mode
+	REG32(PCRP5) = 0 | (0x10<<ExtPHYID_OFFSET) |
+			EnForceMode| ForceLink|ForceSpeed100M |ForceDuplex |
+			MIIcfg_RXER | EnablePHYIf | MacSwReset;
+#endif
+
+#elif defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	#define GMII_PIN_MUX 0xf00
+	#if defined(CONFIG_8198_PORT5_GMII) || defined(CONFIG_8198_PORT5_RGMII)
+	REG32(PIN_MUX_SEL)= REG32(PIN_MUX_SEL)&(~(GMII_PIN_MUX));
+	#endif
+	//WRITE_MEM32(PIN_MUX_SEL_2, 0);
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+#ifdef CONFIG_GIGABYTE_PHY_LINK_MODE_10_100 // use 10/100 only
+	WRITE_MEM32(PCRP0, READ_MEM32(PCRP0) & ~(1<<22));
+	WRITE_MEM32(PCRP1, READ_MEM32(PCRP1) & ~(1<<22));
+	WRITE_MEM32(PCRP2, READ_MEM32(PCRP2) & ~(1<<22));
+	WRITE_MEM32(PCRP3, READ_MEM32(PCRP3) & ~(1<<22));
+	WRITE_MEM32(PCRP4, READ_MEM32(PCRP4) & ~(1<<22));
+#endif
+
+	WRITE_MEM32(PCRP0, READ_MEM32(PCRP0) & ~MacSwReset);
+	WRITE_MEM32(PCRP1, READ_MEM32(PCRP1) & ~MacSwReset);
+	WRITE_MEM32(PCRP2, READ_MEM32(PCRP2) & ~MacSwReset);
+	WRITE_MEM32(PCRP3, READ_MEM32(PCRP3) & ~MacSwReset);
+	WRITE_MEM32(PCRP4, READ_MEM32(PCRP4) & ~MacSwReset);
+
+	WRITE_MEM32(PCRP0, READ_MEM32(PCRP0) | ((0<<ExtPHYID_OFFSET)|EnablePHYIf|MacSwReset) ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP1, READ_MEM32(PCRP1) | ((1<<ExtPHYID_OFFSET)|EnablePHYIf|MacSwReset) ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP2, READ_MEM32(PCRP2) | ((2<<ExtPHYID_OFFSET)|EnablePHYIf|MacSwReset) ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP3, READ_MEM32(PCRP3) | ((3<<ExtPHYID_OFFSET)|EnablePHYIf|MacSwReset) ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP4, READ_MEM32(PCRP4) | ((4<<ExtPHYID_OFFSET)|EnablePHYIf|MacSwReset) ); /* Jumbo Frame */
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(PORT5_RGMII_GMII)
+	if(ExtP5GigaPhyMode)
+	{
+		REG32(PCRP5) &= (0x83FFFFFF-(0x00000000|MacSwReset));
+		REG32(PCRP5) = REG32(PCRP5) | (GIGA_P5_PHYID << ExtPHYID_OFFSET) | EnablePHYIf | MacSwReset | 1<<20;
+		REG32(P5GMIICR) = REG32(P5GMIICR) | Conf_done ;//| P5txdely;
+	}
+#endif
+#if defined(CONFIG_8198_PORT5_GMII)
+	REG32(PITCR) = REG32(PITCR) & 0xFFFFF3FF; //configure port 5 to be a MII interface
+	rtl865xC_setAsicEthernetMIIMode(5, LINK_MII_MAC); //port 5  GMII/MII MAC auto mode
+	REG32(P5GMIICR) = REG32(P5GMIICR) | 0x40; //Conf_done=1
+	REG32(PCRP5) = 0 | (0x5<<ExtPHYID_OFFSET) |      //JSW@20100309:For external 8211BN GMII ,PHYID must be 5
+		EnForceMode| ForceLink|ForceSpeed1000M |ForceDuplex |
+		MIIcfg_RXER | EnablePHYIf | MacSwReset;
+#elif defined(CONFIG_8198_PORT5_RGMII)
+	REG32(PITCR) = REG32(PITCR) & 0xFFFFF3FF; //configure port 5 to be a MII interface
+	rtl865xC_setAsicEthernetMIIMode(5, LINK_RGMII); //port 5  GMII/MII MAC auto mode
+
+	REG32(P5GMIICR) = REG32(P5GMIICR) | Conf_done;
+	REG32(PCRP5) = 0 | (0x5<<ExtPHYID_OFFSET) |      //JSW@20100309:For external 8211BN GMII ,PHYID must be 5
+		EnForceMode| ForceLink|ForceSpeed1000M |ForceDuplex |
+		MIIcfg_RXER | EnablePHYIf | MacSwReset;
+#elif defined(CONFIG_8198C_8211FS)
+	#define GPIO_RESET   24   // GPIO_ H0
+	// Reset 8211FS
+	REG32(PIN_MUX_SEL4) = (REG32(PIN_MUX_SEL4) & ~( 0xf <<3)) | (0x3<<3);
+	REG32(PEFGH_CNR) &= ~(1<<GPIO_RESET);
+	REG32(PEFGH_DIR) |= (1<<GPIO_RESET);
+	REG32(PEFGH_DAT) &= ~(1<<GPIO_RESET);
+	mdelay(500);
+	REG32(PEFGH_DAT) |= (1<<GPIO_RESET);
+	mdelay(300);
+
+	REG32(PIN_MUX_SEL4) &= ~((1 << 21) | (1 << 22) | (1 << 23) | (1 << 24) | (1 << 25)) ;
+	REG32(PAD_CONTROL_2) |= ( 1 << 22 );
+	REG32(PIN_MUX_SEL5) &= ~((1 << 14) | (1 << 15));
+
+	// P5txdly = 1; P5rxdly = 5
+	REG32_ANDOR(P5GMIICR, ~((1<<4)|(7<<0)) , (1<<4) | (5<<0) );
+	// force mode
+	REG32(PCRP5) = (REG32(PCRP5) & ~AutoNegoSts_MASK) | (EnForceMode| ForceLink|ForceSpeed1000M |ForceDuplex);
+	REG32(PCRP5) = (REG32(PCRP5) & ~(0x1f << ExtPHYID_OFFSET))
+			| ((0x5 << ExtPHYID_OFFSET) | MIIcfg_RXER |  EnablePHYIf | MacSwReset);
+
+	REG32(P5GMIICR) |= (Conf_done);
+#elif defined(CONFIG_RTL_8198C_8211F)
+	init_p5();
+#endif
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+	WRITE_MEM32(PCRP0,(REG32(PCRP0) & (0xFFFFFFFF-(MacSwReset))));
+	WRITE_MEM32(PCRP0,(REG32(PCRP0) | (0 << ExtPHYID_OFFSET) | EnablePHYIf |MacSwReset));
+
+#ifdef CONFIG_RTL_8197B
+	/* disable MAC Gbe ability/Gbe 1000F ability of PHY. */
+	WRITE_MEM32(PCRP0, READ_MEM32(PCRP0) & ~NwayAbility1000MF);
+	WRITE_MEM32(PCRP1, READ_MEM32(PCRP1) & ~NwayAbility1000MF);
+	WRITE_MEM32(PCRP2, READ_MEM32(PCRP2) & ~NwayAbility1000MF);
+	WRITE_MEM32(PCRP3, READ_MEM32(PCRP3) & ~NwayAbility1000MF);
+	WRITE_MEM32(PCRP4, READ_MEM32(PCRP4) & ~NwayAbility1000MF);
+	Set_GPHYWB(999, 0, 9, 0, 0);
+#endif
+
+#ifdef CONFIG_RTL_8198C_8367RB
+	// 8198C port 5 setting for 8367RB
+	// P5txdly = 1; P5rxdly = 5
+	REG32(P5GMIICR) = (REG32(P5GMIICR) & ~((1<<4)|(7<<0))) | ((1<<4) | (5<<0));
+	REG32(PCRP5) = (REG32(PCRP5) & ~AutoNegoSts_MASK) | (EnForceMode| ForceLink|ForceSpeed1000M |ForceDuplex);
+	REG32(PCRP5) = (REG32(PCRP5) & ~(0x1f << ExtPHYID_OFFSET))
+			| ((0x15 << ExtPHYID_OFFSET) | MIIcfg_RXER |  EnablePHYIf | MacSwReset);
+	REG32(P5GMIICR) |= (Conf_done);
+#endif
+#if defined(CONFIG_RTL_8211F_SUPPORT)
+	{
+#ifdef CONFIG_RTL_8197F
+	int ret;
+	extern unsigned int rtl819x_bond_option(void);
+	ret = rtl819x_bond_option();
+	if (ret == 2) //97FN:2
+		gpio_simulate_mdc_mdio = 1;
+#endif
+	init_p0();
+	}
+#elif defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8367R_SUPPORT)
+	init_8197f_p0();
+
+#elif defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	{
+#if defined(CONFIG_RTL_8211DS_SUPPORT)&&defined(CONFIG_RTL_8197D)
+	int i;
+	uint32 reg_tmp=0;
+#endif
+
+	P0phymode=1;
+
+#if (defined(CONFIG_RTL_8211DS_SUPPORT)&&defined(CONFIG_RTL_8197D)) || defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT) || defined(CONFIG_RTL_8325D_SUPPORT)
+	P0phymode = 3;
+
+#elif defined(CONFIG_RTL_8196E)
+	if ( ((REG32(BOND_OPTION) & BOND_ID_MASK) == BOND_8196ES)  ||
+		((REG32(BOND_OPTION) & BOND_ID_MASK) == BOND_8196ES1)  ||
+		((REG32(BOND_OPTION) & BOND_ID_MASK) == BOND_8196ES2)  ||
+		((REG32(BOND_OPTION) & BOND_ID_MASK) == BOND_8196ES3)  )
+	{
+		P0phymode=Get_P0_PhyMode();
+	}
+#endif
+
+	if(P0phymode==1)  //embedded phy
+	{
+		REG32(PCRP0) |=  (0 << ExtPHYID_OFFSET) | EnablePHYIf | MacSwReset;	//emabedded
+	}
+	else //external phy
+	{
+		P0miimode=Get_P0_MiiMode();
+
+	#if (defined(CONFIG_RTL_8211DS_SUPPORT)&&defined(CONFIG_RTL_8197D)) || defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT) || defined(CONFIG_RTL_8325D_SUPPORT)
+		P0miimode = 3;
+	#endif
+
+		REG32(PCRP0) = (REG32(PCRP0) & ~(ExtPHYID_MASK)) | (P0_EXT_PHY_ID << ExtPHYID_OFFSET)
+						| MIIcfg_RXER |  EnablePHYIf | MacSwReset;	//external
+
+		if(P0miimode==0)
+			REG32_ANDOR(P0GMIICR, ~(3<<23)  , LINK_MII_PHY<<23);
+		else if(P0miimode==1)
+			REG32_ANDOR(P0GMIICR, ~(3<<23)  , LINK_MII_MAC<<23);
+		else if(P0miimode==2)
+			REG32_ANDOR(P0GMIICR, ~(3<<23)  , LINK_MII_MAC<<23);  //GMII
+		else if(P0miimode==3)
+			REG32_ANDOR(P0GMIICR, ~(3<<23)  , LINK_RGMII<<23);
+
+		if(P0miimode==3)
+		{
+			P0txdly=Get_P0_TxDelay();
+			P0rxdly=Get_P0_RxDelay();
+
+			#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT) || defined(CONFIG_RTL_8325D_SUPPORT)
+			P0txdly = 1;
+			P0rxdly = 5;
+			#endif
+
+			REG32_ANDOR(P0GMIICR, ~((1<<4)|(3<<0)) , (P0txdly<<4) | (P0rxdly<<0) );
+
+			#if defined(CONFIG_RTL_8211DS_SUPPORT)&&defined(CONFIG_RTL_8197D)
+				//Set GPIOC0 to PHY reset.
+				REG32_ANDOR(0xb8000044, 0xFFFFFFFF, (1<<20));
+				REG32_ANDOR(0xb8003500, ~(1<<16), 0);
+				REG32_ANDOR(0xb8003508, 0xFFFFFFFF, (1<<16));
+				REG32_ANDOR(0xb800350c, ~(1<<16), 0); //Set Reset to low
+
+				REG32(0xbb804104) &=0x3FFFFFF;
+				REG32(0xbb804104) |=0x18FF0000;	//set PCR0 phyid
+				REG32(0xbb80414c) =0x37d55;			//set port MII
+				REG32(0xbb804100) =0x1;
+
+				for(i=0; i<5; i++)
+					REG32(PCRP0+i*4) |= (EnForceMode);
+
+				REG32_ANDOR(0xb800350c, 0xFFFFFFFF, (1<<16));//Set Reset to high
+				mdelay(30);
+				//__delay(50000);
+
+				rtl8651_getAsicEthernetPHYReg(P0_EXT_PHY_ID, 0, &reg_tmp);//Learning PHY ID
+
+				for(i=0; i<5; i++)
+					REG32(PCRP0+i*4) &= ~(EnForceMode);
+			#endif
+		}
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+#ifdef CONFIG_RTL_CPU_TAG
+		REG32(P0GMIICR) |= (CFG_CPUC_TAG|CFG_TX_CPUC_TAG);
+
+		// enable port 0 router mode
+		REG32(MACCR1) |= PORT0_ROUTER_MODE;
+#endif
+#endif
+
+		if(P0miimode==0)
+			REG32_ANDOR(PCRP0, ~AutoNegoSts_MASK, EnForceMode| ForceLink|ForceSpeed100M |ForceDuplex) ;
+		else if(P0miimode==1)
+			REG32_ANDOR(PCRP0, ~AutoNegoSts_MASK, EnForceMode| ForceLink|ForceSpeed100M |ForceDuplex) ;
+		else if(P0miimode==2)
+			REG32_ANDOR(PCRP0, ~AutoNegoSts_MASK, EnForceMode| ForceLink|ForceSpeed1000M |ForceDuplex );
+		#if !defined(CONFIG_RTL_8211DS_SUPPORT)
+		else if(P0miimode==3)
+			REG32_ANDOR(PCRP0, ~AutoNegoSts_MASK, EnForceMode| ForceLink|ForceSpeed1000M |ForceDuplex );
+		#endif
+
+		#if defined(CONFIG_RTL_8325D_SUPPORT)
+		REG32_ANDOR(PCRP0, ~AutoNegoSts_MASK, EnForceMode| ForceLink|ForceSpeed100M |ForceDuplex) ;
+		#endif
+
+		REG32(PITCR) |= (1<<0);   //00: embedded , 01L GMII/MII/RGMII
+
+		if((P0miimode==2)  ||(P0miimode==3)) {
+			REG32(MACCR) |= (1<<12);   //giga link
+		}
+		REG32(P0GMIICR) |=(Conf_done);
+	}
+	}
+#endif
+
+#if defined(CONFIG_RTL_8881A)
+	// MACCR b.13-b.12 System clock selection, 2'b00: 50MHz, 2'b01: 100MHz
+	REG32(MACCR) |= (1<<12);
+	// MAC Configuration Register 1, b.0, Cport MAC clock selection with NIC interface, 1: lx_clk, 0: lx_clk/2
+	REG32(0xbb805100) |= 1;
+#endif
+
+//set Leaky bucket parameter
+/* 	system clock = 50MHz --> token=0x40, tick=0x0b, l2=3*token=0xC0
+    system clock = 100MHz --> token=0x36, tick=0x13, l2=3*token=0xA2*/
+#if defined (CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	maccrData = READ_MEM32(MACCR);
+	dataTemp= (maccrData & CF_SYSCLK_SEL_MASK)>>CF_SYSCLK_SEL_OFFSET;
+	if(dataTemp==0x00)
+	{
+		token = 0x40;
+		tick = 0x0b;
+		hiThreshold = 0xC0;
+		rtl8651_setAsicLBParameter( token, tick, hiThreshold );
+	}
+	else if(dataTemp==0x01)
+	{
+		token = 0x36;
+		tick = 0x13;
+		hiThreshold = 0xA2;
+		rtl8651_setAsicLBParameter( token, tick, hiThreshold );
+	}
+
+#endif
+
+#elif defined(CONFIG_RTL_8196C)
+	WRITE_MEM32(PCRP0, (READ_MEM32(PCRP0)&(0xFFFFFFFF-(0x00400000|MacSwReset))) );
+	TOGGLE_BIT_IN_REG_TWICE(PCRP0,EnForceMode);
+
+	WRITE_MEM32(PCRP1, (READ_MEM32(PCRP1)&(0xFFFFFFFF-(0x00400000|MacSwReset))) );
+	TOGGLE_BIT_IN_REG_TWICE(PCRP1,EnForceMode);
+	WRITE_MEM32(PCRP2, (READ_MEM32(PCRP2)&(0xFFFFFFFF-(0x00400000|MacSwReset))) );
+	TOGGLE_BIT_IN_REG_TWICE(PCRP2,EnForceMode);
+	WRITE_MEM32(PCRP3, (READ_MEM32(PCRP3)&(0xFFFFFFFF-(0x00400000|MacSwReset))) );
+	TOGGLE_BIT_IN_REG_TWICE(PCRP3,EnForceMode);
+	WRITE_MEM32(PCRP4, (READ_MEM32(PCRP4)&(0xFFFFFFFF-(0x00400000|MacSwReset))) );
+	TOGGLE_BIT_IN_REG_TWICE(PCRP4,EnForceMode);
+
+	WRITE_MEM32(PCRP0, (READ_MEM32(PCRP0)|(rtl8651AsicEthernetTable[0].phyId<<ExtPHYID_OFFSET)|EnablePHYIf|MacSwReset ) ); /* Jumbo Frame */
+	TOGGLE_BIT_IN_REG_TWICE(PCRP0,EnForceMode);
+	WRITE_MEM32(PCRP1, (READ_MEM32(PCRP1)|(rtl8651AsicEthernetTable[1].phyId<<ExtPHYID_OFFSET)|EnablePHYIf|MacSwReset ) ); /* Jumbo Frame */
+	TOGGLE_BIT_IN_REG_TWICE(PCRP1,EnForceMode);
+	WRITE_MEM32(PCRP2, (READ_MEM32(PCRP2)|(rtl8651AsicEthernetTable[2].phyId<<ExtPHYID_OFFSET)|EnablePHYIf|MacSwReset ) ); /* Jumbo Frame */
+	TOGGLE_BIT_IN_REG_TWICE(PCRP2,EnForceMode);
+	WRITE_MEM32(PCRP3, (READ_MEM32(PCRP3)|(rtl8651AsicEthernetTable[3].phyId<<ExtPHYID_OFFSET)|EnablePHYIf|MacSwReset ) ); /* Jumbo Frame */
+	TOGGLE_BIT_IN_REG_TWICE(PCRP3,EnForceMode);
+	WRITE_MEM32(PCRP4, (READ_MEM32(PCRP4)|(rtl8651AsicEthernetTable[4].phyId<<ExtPHYID_OFFSET)|EnablePHYIf|MacSwReset ) ); /* Jumbo Frame */
+	TOGGLE_BIT_IN_REG_TWICE(PCRP4,EnForceMode);
+#else
+	WRITE_MEM32(PCRP0, (READ_MEM32(PCRP0)|(rtl8651AsicEthernetTable[0].phyId<<ExtPHYID_OFFSET)|EnablePHYIf ) ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP1, (READ_MEM32(PCRP1)|(rtl8651AsicEthernetTable[1].phyId<<ExtPHYID_OFFSET)|EnablePHYIf ) ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP2, (READ_MEM32(PCRP2)|(rtl8651AsicEthernetTable[2].phyId<<ExtPHYID_OFFSET)|EnablePHYIf ) ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP3, (READ_MEM32(PCRP3)|(rtl8651AsicEthernetTable[3].phyId<<ExtPHYID_OFFSET)|EnablePHYIf ) ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP4, (READ_MEM32(PCRP4)|(rtl8651AsicEthernetTable[4].phyId<<ExtPHYID_OFFSET)|EnablePHYIf ) ); /* Jumbo Frame */
+#endif
+
+
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		WRITE_MEM32(PCRP5, ( (READ_MEM32(PCRP5))|(rtl8651AsicEthernetTable[5].phyId<<ExtPHYID_OFFSET)|EnablePHYIf ) ); /* Jumbo Frame */
+	}
+#endif
+
+	/*disable pattern match*/
+	{
+		int pnum;
+		 for(pnum=0;pnum<RTL8651_PORT_NUMBER;pnum++)
+	        {
+	                rtl8651_setAsicPortPatternMatch(pnum, 0, 0, 0x2);
+	        }
+	}
+
+#if defined(CONFIG_RTL_8196C)
+	//enable RTL8196C 10M power saving mode
+	{
+		int tmp,idx;
+
+		for(idx=0;idx<MAX_PORT_NUMBER;idx++) {
+			rtl8651_getAsicEthernetPHYReg( idx, 0x18, &tmp );
+#ifdef CONFIG_RTL8196C_GREEN_ETHERNET
+			tmp |= BIT(15); //enable power saving mode
+#else
+			tmp &= ~BIT(15); //disable power saving mode
+#endif
+			rtl8651_setAsicEthernetPHYReg( idx, 0x18, tmp );
+		}
+	}
+	REG32(MPMR) |= PM_MODE_ENABLE_AUTOMATIC_POWER_DOWN;
+
+	// Configure LED-SIG0/LED-SIG1/LED-SIG2/LED-SIG3/LED-PHASE0/LED-PHASE1/LED-PHASE2/LED-PHASE3 PAD as LED-SW
+
+#ifndef CONFIG_POCKET_ROUTER_SUPPORT
+	#ifndef CONFIG_MTD_NAND
+	REG32(PIN_MUX_SEL) &= ~(0xFFFF);
+	#endif
+#endif
+
+#if defined(PATCH_GPIO_FOR_LED)
+	REG32(PIN_MUX_SEL) |= (0xFFFF);
+#endif
+
+#endif  // end of defined(CONFIG_RTL_8196C)
+
+#if defined(CONFIG_RTL_8198) && !defined(CONFIG_RTL_819XD)
+		REG32(MPMR) |= PM_MODE_ENABLE_AUTOMATIC_POWER_DOWN;
+#endif
+
+
+#if defined(CONFIG_RTL_8196E) && defined(CONFIG_RTL_ULINKER) /* disable unused port for saving power */
+	{
+	uint32 statCtrlReg0;
+
+	for (index=0; index<4; index++) {
+		/* read current PHY reg 0 value */
+		rtl8651_getAsicEthernetPHYReg( index, 0, &statCtrlReg0 );
+
+		REG32(PCRP0+(index*4)) |= EnForceMode;
+		statCtrlReg0 |= POWER_DOWN;
+
+		/* write PHY reg 0 */
+		rtl8651_setAsicEthernetPHYReg( index, 0, statCtrlReg0 );
+	}
+	}
+#endif
+#if  defined(CONFIG_RTL_8196E) //mark_es
+	if ( ((REG32(BOND_OPTION) & BOND_ID_MASK) == BOND_8196ES)  ||
+		((REG32(BOND_OPTION) & BOND_ID_MASK) == BOND_8196ES1)  ||
+		((REG32(BOND_OPTION) & BOND_ID_MASK) == BOND_8196ES2)  ||
+		((REG32(BOND_OPTION) & BOND_ID_MASK) == BOND_8196ES3)  )
+	{
+		uint32 statCtrlReg0;
+
+		for (index=1; index<5; index++) {
+		/* read current PHY reg 0 value */
+		rtl8651_getAsicEthernetPHYReg( index, 0, &statCtrlReg0 );
+
+		REG32(PCRP0+(index*4)) |= EnForceMode;
+		statCtrlReg0 |= POWER_DOWN;
+
+		/* write PHY reg 0 */
+		rtl8651_setAsicEthernetPHYReg( index, 0, statCtrlReg0 );
+		}
+	}
+#endif
+
+#if defined(CONFIG_RTL_8198C)
+	// for the board which has 512Mbytes RAM
+	REG32(DMA_CR0) |= (1 << HsbAddrMark_OFFSET);
+
+	#if defined(PATCH_GPIO_FOR_LED)
+	REG32(PIN_MUX_SEL3) = (REG32(PIN_MUX_SEL3) & ~0x7FFF) | (0x36DB);
+	#endif
+
+	/*fix jwj: let ipv6 with exten header to cpu*/
+	REG32(IPV6CR1) = (REG32(IPV6CR1) & ~0x3) | (0x3);
+
+#elif defined(CONFIG_RTL_8881A)
+	#if !defined(CONFIG_RTL_8367R_SUPPORT) && !defined(CONFIG_RTL_8211F_SUPPORT)
+	REG32(PIN_MUX_SEL) |= 0x180;
+	#endif
+
+	#if defined(PATCH_GPIO_FOR_LED)
+	REG32(PIN_MUX_SEL2) = (REG32(PIN_MUX_SEL2) & ~(0x3FFF)) | (0x36DB);
+	#endif
+
+#elif defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	#if defined(PATCH_GPIO_FOR_LED)
+	REG32(PIN_MUX_SEL2) |= (0x3FFF);
+	#endif
+
+#elif defined(CONFIG_RTL_8197F)
+	/*fix jwj: let ipv6 with exten header to cpu*/
+	REG32(IPV6CR1) = (REG32(IPV6CR1) & ~0x3) | (0x3);
+
+	#if !defined(CONFIG_RTD_1295_HWNAT)
+	REG32(SYS_CLK_MAG) |= (CM_ACTIVE_LX2_CLK | CM_ACTIVE_LX2_ARB);
+	#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+	#if defined(CONFIG_FPGA_V6_HWNAT)
+	REG32(CPUICR1) |= (1 << CF_NIC_LITTLE_ENDIAN_OFFSET);
+	#else //defined(CONFIG_FPGA_V6_HWNAT)
+	REG32(CPUICR1) |= ((1 << CF_NIC_LITTLE_ENDIAN_OFFSET) | (1 << CF_TXRX_DIV_LX_OFFSET) | (1 << CF_TSO_ID_SEL));
+	#endif //defined(CONFIG_FPGA_V6_HWNAT)
+
+	REG32(MACCTRL1) |= CF_CMAC_CLK_SEL;
+
+	#if !defined(CONFIG_RTD_1295_HWNAT)
+	#if defined(PATCH_GPIO_FOR_LED) && !defined(CONFIG_RTL_8367R_SUPPORT)
+	REG32(PIN_MUX_SEL13) = 0x33320000;
+	REG32(PIN_MUX_SEL14) = 0x20000000;
+	#endif
+
+	#if !defined(CONFIG_RTL_8367R_SUPPORT) && !defined(CONFIG_RTL_8211F_SUPPORT)
+	{
+	extern uint32 rtl819x_bond_option(void);
+	if (rtl819x_bond_option() == 3)
+		REG32(EPHY_CONTROL) &= ~EN_ROUTER_MODE;
+	}
+	#endif
+	#endif //!defined(CONFIG_RTD_1295_HWNAT)
+#endif
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	// WARNING: TX_RING2_EN bit must be 1 if TxRing2 is used, TX_RING3_EN bit must be 1 if TxRing3 is used.
+	#if defined(RTL_MULTIPLE_RX_TX_RING)
+	REG32(TXRINGCR) &= ~(TX_RING3_EN|TX_RING2_EN);
+	#else
+	//REG32(TXRINGCR) &= ~(TX_RING3_EN|TX_RING2_EN|TX_RING1_EN);
+	REG32(TXRINGCR) &= ~(TX_RING3_EN|TX_RING2_EN); // enable ring1 and ring0 to let the hardware state machine healthy (by Alan Ho)
+	#endif
+#endif
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_8197F)
+	//default enable acl pattern match, and latch begin from 1st byte in pkt (from dmac).
+	REG32(MACCTRL1) |=  (CF_CMAC_LATPKT_EN);
+	REG32(MACCTRL1) &=  ~(CF_CMAC_LATPKT_TYPE);
+	//REG32(MACCTRL1) |=  (CF_CMAC_LATPKT_TYPE);
+#endif
+
+#if defined(CONFIG_RTL_FE_AUTO_DOWN_SPEED)
+	ads_init();
+#endif
+
+	return SUCCESS;
+}
+
+#ifdef CONFIG_RTL_JUMBO_FRAME
+int32 rtl865x_set_jumbo_frame_size(uint32 size, int op_mode)
+{
+
+	/*clear jumbo frame size*/
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	WRITE_MEM32(PCRP0, (READ_MEM32(PCRP0)&(~AcptMaxLen_16K)) | MacSwReset ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP4, (READ_MEM32(PCRP4)&(~AcptMaxLen_16K)) | MacSwReset ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP5, (READ_MEM32(PCRP5)&(~AcptMaxLen_16K)) | MacSwReset ); /* Jumbo Frame */
+	#else /* CONFIG_RTD_1295_HWNAT */
+	WRITE_MEM32(PCRP0, (READ_MEM32(PCRP0)&(~AcptMaxLen_16K)) | MacSwReset ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP1, (READ_MEM32(PCRP1)&(~AcptMaxLen_16K)) | MacSwReset ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP2, (READ_MEM32(PCRP2)&(~AcptMaxLen_16K)) | MacSwReset ); /* Jumbo Frame */
+	WRITE_MEM32(PCRP3, (READ_MEM32(PCRP3)&(~AcptMaxLen_16K)) | MacSwReset ); /* Jumbo Frame */
+	if (op_mode != 0) //not GATEWAY_MODE
+		WRITE_MEM32(PCRP4, (READ_MEM32(PCRP4)&(~AcptMaxLen_16K)) | MacSwReset ); /* Jumbo Frame */
+	#endif /* CONFIG_RTD_1295_HWNAT */
+	WRITE_MEM32(PCRP6, (READ_MEM32(PCRP6)&(~AcptMaxLen_16K)) | MacSwReset ); /* Jumbo Frame */
+	switch(size){
+		case 1552:
+			#if defined(CONFIG_RTD_1295_HWNAT)
+			WRITE_MEM32(PCRP0, READ_MEM32(PCRP0) | (AcptMaxLen_1552|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP4, READ_MEM32(PCRP4) | (AcptMaxLen_1552|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP5, READ_MEM32(PCRP5) | (AcptMaxLen_1552|MacSwReset) ); /* Jumbo Frame */
+			#else /* CONFIG_RTD_1295_HWNAT */
+			WRITE_MEM32(PCRP0, READ_MEM32(PCRP0) | (AcptMaxLen_1552|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP1, READ_MEM32(PCRP1) | (AcptMaxLen_1552|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP2, READ_MEM32(PCRP2) | (AcptMaxLen_1552|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP3, READ_MEM32(PCRP3) | (AcptMaxLen_1552|MacSwReset) ); /* Jumbo Frame */
+			if (op_mode != 0) //not GATEWAY_MODE
+				WRITE_MEM32(PCRP4, READ_MEM32(PCRP4) | (AcptMaxLen_1552|MacSwReset) ); /* Jumbo Frame */
+			#endif /* CONFIG_RTD_1295_HWNAT */
+			WRITE_MEM32(PCRP6, READ_MEM32(PCRP6) | (AcptMaxLen_1552|MacSwReset) ); /* Jumbo Frame */
+			break;
+		case 9000:
+			#if defined(CONFIG_RTD_1295_HWNAT)
+			WRITE_MEM32(PCRP0, READ_MEM32(PCRP0) | (AcptMaxLen_9K|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP4, READ_MEM32(PCRP4) | (AcptMaxLen_9K|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP5, READ_MEM32(PCRP5) | (AcptMaxLen_9K|MacSwReset) ); /* Jumbo Frame */
+			#else /* CONFIG_RTD_1295_HWNAT */
+			WRITE_MEM32(PCRP0, READ_MEM32(PCRP0) | (AcptMaxLen_9K|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP1, READ_MEM32(PCRP1) | (AcptMaxLen_9K|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP2, READ_MEM32(PCRP2) | (AcptMaxLen_9K|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP3, READ_MEM32(PCRP3) | (AcptMaxLen_9K|MacSwReset) ); /* Jumbo Frame */
+			if (op_mode != 0) //not GATEWAY_MODE
+				WRITE_MEM32(PCRP4, READ_MEM32(PCRP4) | (AcptMaxLen_9K|MacSwReset) ); /* Jumbo Frame */
+			#endif /* CONFIG_RTD_1295_HWNAT */
+			WRITE_MEM32(PCRP6, READ_MEM32(PCRP6) | (AcptMaxLen_9K|MacSwReset) ); /* Jumbo Frame */
+			break;
+		case 16000:
+			#if defined(CONFIG_RTD_1295_HWNAT)
+			WRITE_MEM32(PCRP0, READ_MEM32(PCRP0) | (AcptMaxLen_16K|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP4, READ_MEM32(PCRP4) | (AcptMaxLen_16K|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP5, READ_MEM32(PCRP5) | (AcptMaxLen_16K|MacSwReset) ); /* Jumbo Frame */
+			#else /* CONFIG_RTD_1295_HWNAT */
+			WRITE_MEM32(PCRP0, READ_MEM32(PCRP0) | (AcptMaxLen_16K|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP1, READ_MEM32(PCRP1) | (AcptMaxLen_16K|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP2, READ_MEM32(PCRP2) | (AcptMaxLen_16K|MacSwReset) ); /* Jumbo Frame */
+			WRITE_MEM32(PCRP3, READ_MEM32(PCRP3) | (AcptMaxLen_16K|MacSwReset) ); /* Jumbo Frame */
+			if (op_mode != 0) //not GATEWAY_MODE
+				WRITE_MEM32(PCRP4, READ_MEM32(PCRP4) | (AcptMaxLen_16K|MacSwReset) ); /* Jumbo Frame */
+			#endif /* CONFIG_RTD_1295_HWNAT */
+			WRITE_MEM32(PCRP6, READ_MEM32(PCRP6) | (AcptMaxLen_16K|MacSwReset) ); /* Jumbo Frame */
+			break;
+		default:
+			return 1;
+			break;
+	}
+	return 0;
+
+}
+#endif
+
+
+int32 rtl8651_setAsicPortPatternMatch(uint32 port, uint32 pattern, uint32 patternMask, int32 operation) {
+	//not for ext port
+	if(port>=RTL8651_PORT_NUMBER)
+		return FAILED;
+
+	if(pattern==0&&patternMask==0){
+		//bit 0~13 is reseved...
+		//if((READ_MEM32(PPMAR)&0x2000)==0) //system pattern match not enabled.
+			//return SUCCESS;
+		WRITE_MEM32(PPMAR,READ_MEM32(PPMAR)&~(1<<(port+26)));
+		if((READ_MEM32(PPMAR)&0xfc000000)==0)
+			WRITE_MEM32(PPMAR,READ_MEM32(PPMAR)&~(1<<13)); //turn off system pattern match switch.
+
+		return SUCCESS;
+	}
+	if(operation>3)
+		return FAILED; //valid operations: 0(drop), 1(mirror to cpu),2(fwd to cpu), 3(to mirror port)
+	WRITE_MEM32(PPMAR,READ_MEM32(PPMAR)|((1<<(port+26))|(1<<13))); //turn on system pattern match and turn on pattern match on indicated port.
+	WRITE_MEM32(PPMAR,(READ_MEM32(PPMAR) & (~(0x3<<(14+2*port))))|(operation<<(14+2*port)));   //specify operation
+	WRITE_MEM32(PATP0+4*port,pattern);
+	WRITE_MEM32(MASKP0+4*port,patternMask);
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicPortPatternMatch(uint32 port, uint32 *pattern, uint32 *patternMask, int32 *operation)
+{
+	//not for ext port
+	if(port>=RTL8651_PORT_NUMBER)
+		return FAILED;
+	if(((READ_MEM32(PPMAR)& (1<<13))==0)||((READ_MEM32(PPMAR)& (1<<(26+port)))==0))
+		return FAILED;
+	if(pattern)
+		*pattern=READ_MEM32(PATP0+4*port);
+	if(patternMask)
+		*patternMask=READ_MEM32(MASKP0+4*port);
+	if(operation)
+		*operation=(READ_MEM32(PPMAR)>>(14+2*port))&0x3;
+	return SUCCESS;
+}
+
+/*
+@func int32		| rtl8651_setAsicSpanningEnable 	| Enable/disable ASIC spanning tree support
+@parm int8		| spanningTreeEnabled | TRUE to indicate spanning tree is enabled; FALSE to indicate spanning tree is disabled.
+@rvalue SUCCESS	| 	Success
+@comm
+Global switch to enable or disable ASIC spanning tree support.
+If ASIC spanning tree support is enabled, further configuration would be refered by ASIC to prcoess packet forwarding / MAC learning.
+If ASIC spanning tree support is disabled, all MAC learning and packet forwarding would be done regardless of port state.
+Note that the configuration does not take effect for spanning tree BPDU CPU trapping. It is set in <p rtl8651_setAsicResvMcastAddrToCPU()>.
+@xref <p rtl865xC_setAsicSpanningTreePortState()>, <p rtl8651_getAsicMulticastSpanningTreePortState()>, <p rtl865xC_getAsicSpanningTreePortState()>
+ */
+int32 rtl8651_setAsicSpanningEnable(int8 spanningTreeEnabled)
+{
+	if(spanningTreeEnabled == TRUE)
+	{
+		WRITE_MEM32(MSCR,READ_MEM32(MSCR)|(EN_STP));
+		WRITE_MEM32(RMACR ,READ_MEM32(RMACR)|MADDR00);
+
+	}else
+	{
+		WRITE_MEM32(MSCR,READ_MEM32(MSCR)&~(EN_STP));
+		WRITE_MEM32(RMACR, READ_MEM32(RMACR)&~MADDR00);
+
+	}
+	return SUCCESS;
+}
+
+/*
+@func int32		| rtl8651_getAsicSpanningEnable 	| Getting the ASIC spanning tree support status
+@parm int8*		| spanningTreeEnabled | The pointer to get the status of ASIC spanning tree configuration status.
+@rvalue FAILED	| 	Failed
+@rvalue SUCCESS	| 	Success
+@comm
+Get the ASIC global switch to enable or disable ASIC spanning tree support.
+The switch can be set by calling <p rtl8651_setAsicSpanningEnable()>
+@xref <p rtl8651_setAsicSpanningEnable()>, <p rtl865xC_setAsicSpanningTreePortState()>, <p rtl8651_getAsicMulticastSpanningTreePortState()>, <p rtl865xC_getAsicSpanningTreePortState()>
+ */
+int32 rtl8651_getAsicSpanningEnable(int8 *spanningTreeEnabled)
+{
+	if(spanningTreeEnabled == NULL)
+		return FAILED;
+	*spanningTreeEnabled = (READ_MEM32(MSCR)&(EN_STP)) == (EN_STP)? TRUE: FALSE;
+	return SUCCESS;
+}
+
+/*
+@func int32		| rtl865xC_setAsicSpanningTreePortState 	| Configure Spanning Tree Protocol Port State
+@parm uint32 | port | port number under consideration
+@parm uint32 | portState | Spanning tree port state: RTL8651_PORTSTA_DISABLED, RTL8651_PORTSTA_BLOCKING, RTL8651_PORTSTA_LISTENING, RTL8651_PORTSTA_LEARNING, RTL8651_PORTSTA_FORWARDING
+@rvalue SUCCESS	| 	Success
+@rvalue FAILED | Failed
+@comm
+Config IEEE 802.1D spanning tree port sate into ASIC.
+ */
+int32 rtl865xC_setAsicSpanningTreePortState(uint32 port, uint32 portState)
+{
+	uint32 offset = port * 4;
+
+	if ( port >= RTL865XC_PORT_NUMBER )
+		return FAILED;
+
+	switch(portState)
+	{
+		case RTL8651_PORTSTA_DISABLED:
+			WRITE_MEM32( PCRP0 + offset, ( READ_MEM32( PCRP0 + offset ) & (~STP_PortST_MASK) ) | STP_PortST_DISABLE );
+			break;
+		case RTL8651_PORTSTA_BLOCKING:
+		case RTL8651_PORTSTA_LISTENING:
+			WRITE_MEM32( PCRP0 + offset, ( READ_MEM32( PCRP0 + offset ) & (~STP_PortST_MASK) ) | STP_PortST_BLOCKING );
+			break;
+		case RTL8651_PORTSTA_LEARNING:
+			WRITE_MEM32( PCRP0 + offset, ( READ_MEM32( PCRP0 + offset ) & (~STP_PortST_MASK) ) | STP_PortST_LEARNING );
+			break;
+		case RTL8651_PORTSTA_FORWARDING:
+			WRITE_MEM32( PCRP0 + offset, ( READ_MEM32( PCRP0 + offset ) & (~STP_PortST_MASK) ) | STP_PortST_FORWARDING );
+			break;
+		default:
+			return FAILED;
+	}
+
+	TOGGLE_BIT_IN_REG_TWICE(PCRP0 + offset, EnForceMode);
+	return SUCCESS;
+}
+
+/*
+@func int32		| rtl865xC_getAsicSpanningTreePortState 	| Retrieve Spanning Tree Protocol Port State
+@parm uint32 | port | port number under consideration
+@parm uint32 | portState | pointer to memory to store the port state
+@rvalue SUCCESS	| 	Success
+@rvalue FAILED | Failed
+@comm
+Possible spanning tree port state: RTL8651_PORTSTA_DISABLED, RTL8651_PORTSTA_BLOCKING, RTL8651_PORTSTA_LISTENING, RTL8651_PORTSTA_LEARNING, RTL8651_PORTSTA_FORWARDING
+ */
+int32 rtl865xC_getAsicSpanningTreePortState(uint32 port, uint32 *portState)
+{
+	uint32 reg;
+	uint32 offset = port * 4;
+
+	if ( port >= RTL865XC_PORT_NUMBER || portState == NULL )
+		return FAILED;
+
+	reg = ( READ_MEM32( PCRP0 + offset ) & STP_PortST_MASK );
+
+	switch(reg)
+	{
+		case STP_PortST_DISABLE:
+			*portState = RTL8651_PORTSTA_DISABLED;
+			break;
+		case STP_PortST_BLOCKING:
+			*portState = RTL8651_PORTSTA_BLOCKING;
+			break;
+		case STP_PortST_LEARNING:
+			*portState = RTL8651_PORTSTA_LEARNING;
+			break;
+		case STP_PortST_FORWARDING:
+			*portState = RTL8651_PORTSTA_FORWARDING;
+			break;
+		default:
+			return FAILED;
+	}
+	return SUCCESS;
+
+}
+
+/*
+@func int32		| rtl8651_getAsicMulticastSpanningTreePortState 	| Retrieve Spanning Tree Protocol Port State
+@parm uint32 | port | port number under consideration
+@parm uint32 | portState | pointer to memory to store the port state
+@rvalue SUCCESS	| 	Success
+@rvalue FAILED | Failed
+@comm
+In RTL865xC platform, Multicast spanning tree configuration is gotten by this API.
+@xref  <p rtl865xC_getAsicSpanningTreePortState()>
+ */
+int32 rtl8651_getAsicMulticastSpanningTreePortState(uint32 port, uint32 *portState)
+{
+	uint32 reg;
+	uint32 offset = port * 4;
+
+	if ( port >= RTL865XC_PORT_NUMBER || portState == NULL )
+		return FAILED;
+
+	reg = ( READ_MEM32( PCRP0 + offset ) & IPMSTP_PortST_MASK );
+
+	switch(reg)
+	{
+		case IPMSTP_PortST_DISABLE:
+			*portState = RTL8651_PORTSTA_DISABLED;
+			break;
+		case IPMSTP_PortST_BLOCKING:
+			*portState = RTL8651_PORTSTA_BLOCKING;
+			break;
+		case IPMSTP_PortST_LEARNING:
+			*portState = RTL8651_PORTSTA_LEARNING;
+			break;
+		case IPMSTP_PortST_FORWARDING:
+			*portState = RTL8651_PORTSTA_FORWARDING;
+			break;
+		default:
+			return FAILED;
+	}
+	return SUCCESS;
+}
+
+/*=========================================
+  * ASIC DRIVER API: MDC/MDIO Control
+  *=========================================*/
+
+int32 rtl8651_getAsicEthernetPHYReg(uint32 phyId, uint32 regId, uint32 *rData)
+{
+	uint32 status;
+
+	WRITE_MEM32( MDCIOCR, COMMAND_READ | ( phyId << PHYADD_OFFSET ) | ( regId << REGADD_OFFSET ) );
+
+#if defined(CONFIG_RTL_8198)
+	if (REG32(REVR) == BSP_RTL8198_REVISION_A)
+		mdelay(10);
+#elif defined(CONFIG_RTL8196C_REVISION_B)
+	if (REG32(REVR) == RTL8196C_REVISION_A)
+		mdelay(10);	//wei add, for 8196C revision A. mdio data read will delay 1 mdc clock.
+#endif
+
+	do { status = READ_MEM32( MDCIOSR ); } while ( ( status & MDC_STATUS ) != 0 );
+
+	status &= 0xffff;
+	*rData = status;
+
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicEthernetPHYReg(uint32 phyId, uint32 regId, uint32 wData)
+{
+	WRITE_MEM32( MDCIOCR, COMMAND_WRITE | ( phyId << PHYADD_OFFSET ) | ( regId << REGADD_OFFSET ) | wData );
+
+	while( ( READ_MEM32( MDCIOSR ) & MDC_STATUS ) != 0 );		/* wait until command complete */
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicEthernetPHYStatus(uint32 port, uint32 *rData)
+{
+	uint32 statCtrlReg1, phyid;
+
+	/* port number validation */
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+
+	/* PHY id determination */
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+
+	/* read current PHY reg 1*/
+	rtl8651_getAsicEthernetPHYReg( phyid, 1, &statCtrlReg1 );
+
+	/*assign value*/
+	*rData=statCtrlReg1;
+	return SUCCESS;
+}
+
+int32 rtl8651_restartAsicEthernetPHYNway(uint32 port)
+{
+	uint32 statCtrlReg0, phyid;
+
+	/* port number validation */
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+
+	/* PHY id determination */
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+
+	/* read current PHY reg 0 */
+	rtl8651_getAsicEthernetPHYReg( phyid, 0, &statCtrlReg0 );
+
+	/* enable 'restart Nway' bit */
+	statCtrlReg0 |= RESTART_AUTONEGO;
+
+	/* write PHY reg 0 */
+	rtl8651_setAsicEthernetPHYReg( phyid, 0, statCtrlReg0 );
+
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicEthernetPHYPowerDown( uint32 port, uint32 pwrDown )
+{
+	uint32 statCtrlReg0, phyid;
+
+	/* port number validation */
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+
+	/* PHY id determination */
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+
+	/* read current PHY reg 0 value */
+	rtl8651_getAsicEthernetPHYReg( phyid, 0, &statCtrlReg0 );
+
+	if ( pwrDown ){
+		REG32(PCRP0+port*4) |= EnForceMode;
+		REG32(PCRP0+port*4) |= PollLinkStatus;
+		REG32(PCRP0+port*4) &= ~ForceLink;
+		statCtrlReg0 |= POWER_DOWN;
+	}
+	else{
+		//REG32(PCRP0+port*4) &= ~EnForceMode;
+		statCtrlReg0 &= ~POWER_DOWN;
+	}
+	/* write PHY reg 0 */
+	rtl8651_setAsicEthernetPHYReg( phyid, 0, statCtrlReg0 );
+
+	if ( !pwrDown ){
+		REG32(PCRP0+port*4) &= ~EnForceMode;
+		REG32(PCRP0+port*4) &= ~ PollLinkStatus;
+	}
+	return SUCCESS;
+
+}
+
+int32 rtl8651_setAsicEthernetPHYAdvCapality(uint32 port, uint32 capality)
+{
+	uint32 statCtrlReg4, phyid;
+
+	/* port number validation */
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+
+	/* PHY id determination */
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+
+	/* read current PHY reg 4 value */
+	rtl8651_getAsicEthernetPHYReg( phyid, 4, &statCtrlReg4);
+
+	/*Clear Duplex and Speed bits*/
+	statCtrlReg4 &= ~(0xF<<5);
+
+	if (capality & (1<<DUPLEX_100M))
+	{
+		statCtrlReg4 |= (1<<8);
+	}
+	if (capality & (1<<HALF_DUPLEX_100M))
+	{
+		statCtrlReg4 |= (1<<7);
+	}
+	if (capality & (1<<DUPLEX_10M))
+	{
+		statCtrlReg4 |= (1<<6);
+	}
+	if (capality & (1<<HALF_DUPLEX_10M))
+	{
+		statCtrlReg4 |= (1<<5);
+	}
+	if(capality & (1<<PORT_AUTO))
+	{
+		/*Set All Duplex and Speed All Supported*/
+		statCtrlReg4 |=(0xF <<5);
+	}
+
+	/* write PHY reg 4 */
+	rtl8651_setAsicEthernetPHYReg( phyid, 4, statCtrlReg4 );
+
+	return SUCCESS;
+}
+int32 rtl8651_setAsicEthernetPHYSpeed( uint32 port, uint32 speed )
+{
+	uint32 statCtrlReg0, phyid;
+
+	/* port number validation */
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+
+	/* PHY id determination */
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+
+	/* read current PHY reg 0 value */
+	rtl8651_getAsicEthernetPHYReg( phyid, 0, &statCtrlReg0 );
+
+	if (0 == speed )
+	{
+		/*10M*/
+		statCtrlReg0 &= ~SPEED_SELECT_100M;
+	}
+	else if (1 == speed)
+	{
+		/*100M*/
+		statCtrlReg0 |= SPEED_SELECT_100M;
+	}
+	else if(2 == speed)
+	{
+		/*1000M*/
+	}
+
+	/* write PHY reg 0 */
+	rtl8651_setAsicEthernetPHYReg( phyid, 0, statCtrlReg0 );
+
+	return SUCCESS;
+
+}
+
+int32 rtl8651_setAsicEthernetPHYDuplex( uint32 port, uint32 duplex )
+{
+	uint32 statCtrlReg0, phyid;
+
+	/* port number validation */
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+
+	/* PHY id determination */
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+
+	/* read current PHY reg 0 value */
+	rtl8651_getAsicEthernetPHYReg( phyid, 0, &statCtrlReg0 );
+
+	if ( duplex )
+		statCtrlReg0 |= SELECT_FULL_DUPLEX;
+	else
+		statCtrlReg0 &= ~SELECT_FULL_DUPLEX;
+
+	/* write PHY reg 0 */
+	rtl8651_setAsicEthernetPHYReg( phyid, 0, statCtrlReg0 );
+
+	return SUCCESS;
+
+}
+
+int32 rtl8651_setAsicEthernetPHYAutoNeg( uint32 port, uint32 autoneg)
+{
+	uint32 statCtrlReg0, phyid;
+
+	/* port number validation */
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+
+	/* PHY id determination */
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+
+	/* read current PHY reg 0 value */
+	rtl8651_getAsicEthernetPHYReg( phyid, 0, &statCtrlReg0 );
+
+	if (autoneg)
+		statCtrlReg0 |= ENABLE_AUTONEGO;
+	else
+		statCtrlReg0 &= ~ENABLE_AUTONEGO;
+
+	/* write PHY reg 0 */
+	rtl8651_setAsicEthernetPHYReg( phyid, 0, statCtrlReg0 );
+
+	return SUCCESS;
+
+}
+
+int32 rtl865xC_setAsicPortPauseFlowControl(uint32 port, uint8 rxEn, uint8 txEn)
+{
+	uint32 offset = port<<2;
+	uint32 pauseFC = 0;
+
+	if(rxEn!=0)
+		pauseFC |= PauseFlowControlDtxErx;
+	if(txEn!=0)
+		pauseFC |= PauseFlowControlEtxDrx;
+
+	WRITE_MEM32(PCRP0+offset, (~(PauseFlowControl_MASK)&(READ_MEM32(PCRP0+offset)))|pauseFC);
+
+	TOGGLE_BIT_IN_REG_TWICE(PCRP0 + offset,EnForceMode);
+	return SUCCESS;
+}
+
+int32 rtl865xC_getAsicPortPauseFlowControl(uint32 port, uint8 *rxEn, uint8 *txEn)
+{
+	uint32 offset = port<<2;
+	uint32 pauseFC = 0;
+
+	pauseFC = ((PauseFlowControl_MASK)&(READ_MEM32(PCRP0+offset)));
+
+	if (pauseFC&PauseFlowControlDtxErx)
+		*rxEn = TRUE;
+
+	if (pauseFC&PauseFlowControlEtxDrx)
+		*txEn = TRUE;
+
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+int32 rtl8651_setAsicEthernetPHYTxPadDriving(uint32 port)
+{
+	uint32 data, phyid;
+
+	/* port number validation */
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+
+	/* PHY id determination */
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+
+	/* change to page 0x0d41 */
+	rtl8651_setAsicEthernetPHYReg(phyid, 31, 0x0d41);
+
+	/* read current PHY reg 16 */
+	rtl8651_getAsicEthernetPHYReg(phyid, 16, &data);
+
+	/* set reg16 bit[13] */
+	data |= (1 << 13);
+
+	/* write PHY reg 16 */
+	rtl8651_setAsicEthernetPHYReg(phyid, 16, data);
+
+	/* change to page 0 */
+	rtl8651_setAsicEthernetPHYReg(phyid, 31, 0);
+
+	return SUCCESS;
+}
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+/*=========================================
+  * ASIC DRIVER API: ETHERNET MII
+  *=========================================*/
+int32 rtl865xC_setAsicEthernetMIIMode(uint32 port, uint32 mode)
+{
+	if ( port != 0 && port != RTL8651_MII_PORTNUMBER )
+		return FAILED;
+	if ( mode != LINK_RGMII && mode != LINK_MII_MAC && mode != LINK_MII_PHY )
+		return FAILED;
+
+	if ( port == 0 )
+	{
+		/* MII port MAC interface mode configuration */
+		WRITE_MEM32( P0GMIICR, ( READ_MEM32( P0GMIICR ) & ~CFG_GMAC_MASK ) | ( mode << LINKMODE_OFFSET ) );
+	}
+	else
+	{
+		/* MII port MAC interface mode configuration */
+		WRITE_MEM32( P5GMIICR, ( READ_MEM32( P5GMIICR ) & ~CFG_GMAC_MASK ) | ( mode << LINKMODE_OFFSET ) );
+	}
+	return SUCCESS;
+
+}
+
+int32 rtl865xC_setAsicEthernetRGMIITiming(uint32 port, uint32 Tcomp, uint32 Rcomp)
+{
+	if ( port != 0 && port != RTL8651_MII_PORTNUMBER )
+		return FAILED;
+	if ( Tcomp < RGMII_TCOMP_0NS || Tcomp > RGMII_TCOMP_7NS || Rcomp < RGMII_RCOMP_0NS || Rcomp > RGMII_RCOMP_2DOT5NS )
+		return FAILED;
+
+	if ( port == 0 )
+	{
+		WRITE_MEM32(P0GMIICR, ( ( ( READ_MEM32(P0GMIICR) & ~RGMII_TCOMP_MASK ) | Tcomp ) & ~RGMII_RCOMP_MASK ) | Rcomp );
+	}
+	else
+	{
+		WRITE_MEM32(P5GMIICR, ( ( ( READ_MEM32(P5GMIICR) & ~RGMII_TCOMP_MASK ) | Tcomp ) & ~RGMII_RCOMP_MASK ) | Rcomp );
+	}
+
+	return SUCCESS;
+}
+
+/* For backward-compatible issue, this API is used to set MII port 5. */
+int32 rtl8651_setAsicEthernetMII(uint32 phyAddress, int32 mode, int32 enabled)
+{
+	/* Input validation */
+	if ( phyAddress < 0 || phyAddress > 31 )
+		return FAILED;
+	if ( mode != P5_LINK_RGMII && mode != P5_LINK_MII_MAC && mode != P5_LINK_MII_PHY )
+		return FAILED;
+
+	/* Configure driver level information about mii port 5 */
+	if ( enabled )
+	{
+		if ( miiPhyAddress >= 0 && miiPhyAddress != phyAddress )
+			return FAILED;
+
+		miiPhyAddress = phyAddress;
+	}
+	else
+	{
+		miiPhyAddress = -1;
+	}
+
+	/* MII port MAC interface mode configuration */
+	WRITE_MEM32( P5GMIICR, ( READ_MEM32( P5GMIICR ) & ~CFG_GMAC_MASK ) | ( mode << P5_LINK_OFFSET ) );
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicEthernetMII(uint32 *phyAddress)
+{
+	*phyAddress=miiPhyAddress;
+	return SUCCESS;
+}
+
+
+/*vlan remark*/
+int32 rtl8651_setAsicVlanRemark(enum PORTID port, enum PRIORITYVALUE priority, int remark)
+{
+	int regValue;
+	if ((port < PHY0) || (port > CPU) || (priority < PRI0) || (priority > PRI7) ||(remark < PRI0) || (remark > PRI7))
+		return FAILED;
+
+	WRITE_MEM32(RLRC, (READ_MEM32(RLRC) &~(0x7)) |0x7);
+
+	regValue = READ_MEM32(RMCR1P) & ~((0x7<<(3*priority)) |(0x1 << (24 + port)));
+	regValue |= ((remark << (3*priority)) |(0x1 << (24 + port)));
+	WRITE_MEM32( RMCR1P, regValue);
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicVlanRemark(enum PORTID port, enum PRIORITYVALUE priority, int* remark)
+{
+	int regValue;
+	if ((port < PHY0) || (port > CPU) || (priority < PRI0) || (priority > PRI7) ||(remark == NULL))
+		return FAILED;
+
+	regValue = READ_MEM32(RMCR1P);
+	if(regValue & (0x1<<(24+port))){
+		*remark = (regValue>>(3*priority)) & 0x7;
+	}else{
+			return FAILED;
+	}
+
+	return SUCCESS;
+}
+
+
+/*vlan remark*/
+#if defined(CONFIG_RTD_1295_HWNAT)
+void rtl8651_resetAsicVlanRemark(void)
+{
+	WRITE_MEM32(RLRC, (READ_MEM32(RLRC) &~(0x7)));
+	WRITE_MEM32(RMCR1P, 0xFAC688);
+
+	/* clear vlan priority assignment */
+	#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+	WRITE_MEM32(LPTM8021Q, 0);
+	#else
+	WRITE_MEM32(LPTM8021Q, 0xFAC642);
+	#endif
+}
+
+void rtl8651_resetAsicDscpRemark(void)
+{
+	WRITE_MEM32(RLRC, (READ_MEM32(RLRC) &~(0x7<<3)));
+	WRITE_MEM32(DSCPRM0, 0x2E000000);
+	WRITE_MEM32(DSCPRM1, 0x2EBAE);
+
+	/* clear dscp priority assignment */
+	WRITE_MEM32(DSCPCR0,0);
+	WRITE_MEM32(DSCPCR1,0);
+	WRITE_MEM32(DSCPCR2,0);
+	WRITE_MEM32(DSCPCR3,0);
+	WRITE_MEM32(DSCPCR4,0);
+	WRITE_MEM32(DSCPCR5,0);
+	WRITE_MEM32(DSCPCR6,0);
+}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+int32 rtl8651_setAsicDscpRemark(enum PORTID port, enum PRIORITYVALUE priority, int remark)
+{
+	int regValue0;
+	if ((port < PHY0) || (port > CPU) || (priority < PRI0) || (priority > PRI7) ||(remark < 0) ||(remark > 63))
+		return FAILED;
+
+	WRITE_MEM32(RLRC, (READ_MEM32(RLRC) &~(0x7<<3)) |(0x7<<3));
+
+	if(priority < 5){
+		regValue0 = READ_MEM32(DSCPRM0) &~(0x3f<<(6*priority));
+		regValue0 |= remark << (6*priority);
+		WRITE_MEM32( DSCPRM0, regValue0);
+
+		regValue0 = READ_MEM32(DSCPRM1) &~(0x1 << (23 + port));
+		regValue0 |= 0x1 << (23 + port);
+		WRITE_MEM32( DSCPRM1, regValue0);
+	}else{
+		regValue0 = READ_MEM32(DSCPRM1) & ~((0x3f<<(6*(priority -5))) |(0x1 << (23 + port)));
+		regValue0 |= ((remark<<(6*(priority -5))) |(0x1 << (23 + port)));
+		WRITE_MEM32( DSCPRM1, regValue0);
+	}
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicDscpRemark(enum PORTID port, enum PRIORITYVALUE priority, int* remark)
+{
+	int regValue0, regValue1;
+	if ((port < PHY0) || (port > CPU) || (priority < PRI0) || (priority > PRI7) || (remark == NULL))
+		return FAILED;
+
+	regValue1 = READ_MEM32(DSCPRM1);
+	if(regValue1 & (0x1 << (23 + port))){
+		if(priority < 5){
+			regValue0 = READ_MEM32(DSCPRM0);
+			*remark = (regValue0>>(6*priority)) & 0x3f;
+		}else{
+			*remark = (regValue1>>(6*(priority-5))) & 0x3f;
+		}
+	}else{
+			return FAILED;
+	}
+
+	return SUCCESS;
+}
+
+
+
+/*=========================================
+  * ASIC DRIVER API: Packet Scheduling Control Register
+  *=========================================*/
+/*
+@func int32 | rtl8651_setAsicPriorityDecision | set priority selection
+@parm uint32 | portpri | output queue decision priority assign for Port Based Priority.
+@parm uint32 | dot1qpri | output queue decision priority assign for 1Q Based Priority.
+@parm uint32 | dscppri | output queue decision priority assign for DSCP Based Priority
+@parm uint32 | aclpri | output queue decision priority assign for ACL Based Priority.
+@parm uint32 | natpri | output queue decision priority assign for NAT Based Priority.
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+#if defined(CONFIG_RTL_8197F)
+int32 rtl8651_setAsicPriorityDecision( uint32 portpri, uint32 dot1qpri, uint32 dscppri, uint32 aclpri, uint32 natpri, uint32 vidpri )
+#else
+int32 rtl8651_setAsicPriorityDecision( uint32 portpri, uint32 dot1qpri, uint32 dscppri, uint32 aclpri, uint32 natpri)
+#endif
+{
+	/* Invalid input parameter */
+	if ((portpri < 0) || (portpri > 0xF) || (dot1qpri < 0) || (dot1qpri > 0xF) ||
+		(dscppri < 0) || (dscppri > 0xF) || (aclpri < 0) || (aclpri > 0xF) ||
+		(natpri < 0) || (natpri > 0xF))
+		return FAILED;
+
+	#if defined(CONFIG_RTL_8197F)
+	if((vidpri < 0) || (vidpri > 0xF))
+		return FAILED;
+	#endif
+
+	#if defined(CONFIG_RTL_8197F)
+	WRITE_MEM32(QIDDPCR, (portpri << PBP_PRI_OFFSET) | (dot1qpri << BP8021Q_PRI_OFFSET) |
+		                 (dscppri << DSCP_PRI_OFFSET) | (aclpri << ACL_PRI_OFFSET) |
+		                 (natpri << NAPT_PRI_OFFSET) | (vidpri << VID_PRI_OFFSET));
+	#else
+	WRITE_MEM32(QIDDPCR, (portpri << PBP_PRI_OFFSET) | (dot1qpri << BP8021Q_PRI_OFFSET) |
+		                 (dscppri << DSCP_PRI_OFFSET) | (aclpri << ACL_PRI_OFFSET) |
+		                 (natpri << NAPT_PRI_OFFSET));
+	#endif
+
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_8197F)
+int32 rtl8651_getAsicPriorityDecision( uint32* portpri, uint32* dot1qpri, uint32* dscppri, uint32* aclpri, uint32* natpri, uint32* vidpri )
+#else
+int32 rtl8651_getAsicPriorityDecision( uint32* portpri, uint32* dot1qpri, uint32* dscppri, uint32* aclpri, uint32* natpri)
+#endif
+{
+	uint32 temp;
+	if((portpri == NULL) ||(dot1qpri == NULL) ||(dscppri == NULL) ||(aclpri == NULL) ||(natpri == NULL))
+		return FAILED;
+
+	temp = READ_MEM32(QIDDPCR);
+	*portpri = (temp >> PBP_PRI_OFFSET) & 0xf;
+	*dot1qpri = (temp >> BP8021Q_PRI_OFFSET) & 0xf;
+	*dscppri = (temp >> DSCP_PRI_OFFSET) & 0xf;
+	*aclpri = (temp >> ACL_PRI_OFFSET) & 0xf;
+	*natpri  = (temp >> NAPT_PRI_OFFSET) & 0xf;
+	#if defined(CONFIG_RTL_8197F)
+	*vidpri = (temp >> VID_PRI_OFFSET) & 0xf;
+	#endif
+
+	return SUCCESS;
+}
+
+
+int32 rtl8651_setAsicQueueFlowControlConfigureRegister(enum PORTID port, enum QUEUEID queue, uint32 enable)
+{
+	switch (port)
+	{
+		case PHY0:
+			WRITE_MEM32(FCCR0, (READ_MEM32(FCCR0) & ~(0x1<<(queue+Q_P0_EN_FC_OFFSET))) | (enable << (queue+Q_P0_EN_FC_OFFSET)));  break;
+		case PHY1:
+			WRITE_MEM32(FCCR0, (READ_MEM32(FCCR0) & ~(0x1<<(queue+Q_P1_EN_FC_OFFSET))) | (enable << (queue+Q_P1_EN_FC_OFFSET)));  break;
+		case PHY2:
+			WRITE_MEM32(FCCR0, (READ_MEM32(FCCR0) & ~(0x1<<(queue+Q_P2_EN_FC_OFFSET))) | (enable << (queue+Q_P2_EN_FC_OFFSET)));  break;
+		case PHY3:
+			WRITE_MEM32(FCCR0, (READ_MEM32(FCCR0) & ~(0x1<<(queue+Q_P3_EN_FC_OFFSET))) | (enable << (queue+Q_P3_EN_FC_OFFSET)));  break;
+		case PHY4:
+			WRITE_MEM32(FCCR1, (READ_MEM32(FCCR1) & ~(0x1<<(queue+Q_P4_EN_FC_OFFSET))) | (enable << (queue+Q_P4_EN_FC_OFFSET)));  break;
+		case PHY5:
+			WRITE_MEM32(FCCR1, (READ_MEM32(FCCR1) & ~(0x1<<(queue+Q_P5_EN_FC_OFFSET))) | (enable << (queue+Q_P5_EN_FC_OFFSET)));  break;
+		case CPU:
+			WRITE_MEM32(FCCR1, (READ_MEM32(FCCR1) & ~(0x1<<(queue+Q_P6_EN_FC_OFFSET))) | (enable << (queue+Q_P6_EN_FC_OFFSET)));  break;
+		default:
+			return FAILED;
+	}
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicQueueFlowControlConfigureRegister(enum PORTID port, enum QUEUEID queue, uint32 *enable)
+{
+	if (enable != NULL)
+	{
+		switch (port)
+		{
+			case PHY0:
+				*enable = (READ_MEM32(FCCR0) & (0x1<<(queue+Q_P0_EN_FC_OFFSET))) >> (queue+Q_P0_EN_FC_OFFSET);  break;
+			case PHY1:
+				*enable = (READ_MEM32(FCCR0) & (0x1<<(queue+Q_P1_EN_FC_OFFSET))) >> (queue+Q_P1_EN_FC_OFFSET);  break;
+			case PHY2:
+				*enable = (READ_MEM32(FCCR0) & (0x1<<(queue+Q_P2_EN_FC_OFFSET))) >> (queue+Q_P2_EN_FC_OFFSET);  break;
+			case PHY3:
+				*enable = (READ_MEM32(FCCR0) & (0x1<<(queue+Q_P3_EN_FC_OFFSET))) >> (queue+Q_P3_EN_FC_OFFSET);  break;
+			case PHY4:
+				*enable = (READ_MEM32(FCCR1) & (0x1<<(queue+Q_P4_EN_FC_OFFSET))) >> (queue+Q_P4_EN_FC_OFFSET);  break;
+			case PHY5:
+				*enable = (READ_MEM32(FCCR1) & (0x1<<(queue+Q_P5_EN_FC_OFFSET))) >> (queue+Q_P5_EN_FC_OFFSET);  break;
+			case CPU:
+				*enable = (READ_MEM32(FCCR1) & (0x1<<(queue+Q_P6_EN_FC_OFFSET))) >> (queue+Q_P6_EN_FC_OFFSET);  break;
+			default:
+				return FAILED;
+		}
+	}
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_setAsicLBParameter | set Leaky Bucket Paramters
+@parm uint32 | token | Token is used for adding budget in each time slot.
+@parm uint32 | tick | Tick is used for time slot size slot.
+@parm uint32 | hiThreshold | leaky bucket token high-threshold register
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicLBParameter( uint32 token, uint32 tick, uint32 hiThreshold )
+{
+	WRITE_MEM32( ELBPCR, (READ_MEM32(ELBPCR) & ~(Token_MASK | Tick_MASK)) | (token << Token_OFFSET) | (tick << Tick_OFFSET));
+	WRITE_MEM32( ELBTTCR, (READ_MEM32(ELBTTCR) & ~0xFFFF/*L2_MASK*/) | (hiThreshold << L2_OFFSET));
+	WRITE_MEM32( ILBPCR2, (READ_MEM32(ILBPCR2) & ~(ILB_feedToken_MASK|ILB_Tick_MASK)) | (token << ILB_feedToken_OFFSET) | (tick << ILB_Tick_OFFSET) );
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_getAsicLBParameter | get Leaky Bucket Paramters
+@parm uint32* | pToken | pointer to return token
+@parm uint32* | pTick | pointer to return tick
+@parm uint32* | pHiThreshold | pointer to return hiThreshold
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_getAsicLBParameter( uint32* pToken, uint32* pTick, uint32* pHiThreshold )
+{
+	uint32 regValue;
+
+	regValue = READ_MEM32(ELBPCR);
+
+	if (pToken != NULL)
+		*pToken = (regValue & Token_MASK) >> Token_OFFSET;
+	if (pTick != NULL)
+		*pTick = (regValue & Tick_MASK) >> Tick_OFFSET;
+	if (pHiThreshold != NULL)
+		*pHiThreshold = (READ_MEM32(ELBTTCR) & 0xFF) >> L2_OFFSET;
+
+	return SUCCESS;
+}
+
+/*port based priority*/
+int32 rtl8651_setAsicPortBasedPriority( enum PORTID port, enum PRIORITYVALUE priority )
+{
+	/* Invalid input parameter */
+	if ((priority < PRI0) || (priority > PRI7) ||(port < PHY0) || (port> EXT3) )
+		return FAILED;
+
+	WRITE_MEM32(PBPCR, (READ_MEM32(PBPCR) & ~(0x7 << (port*3))) | (priority << (port*3)));
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicPortBasedPriority( enum PORTID port, enum PRIORITYVALUE* priority )
+{
+	/* Invalid input parameter */
+	if ((port < PHY0) || (port> EXT3) ||(priority == NULL))
+		return FAILED;
+
+	*priority = (READ_MEM32(PBPCR) >> (3*port)) & 0x7;
+
+	return SUCCESS;
+}
+
+
+
+/*
+@func int32 | rtl8651_setAsicQueueRate | set per queue rate
+@parm enum PORTID | port | the port number
+@parm enum QUEUEID | queueid | the queue ID wanted to set
+@parm uint32 | pprTime | Peak Packet Rate (in times of APR). 0~6: PPR = (2^pprTime)*apr. 7: disable PPR
+@parm uint32 | aprBurstSize | Bucket Burst Size of Average Packet Rate (unit: 1KByte). 0xFF: disable
+@parm uint32 | apr | Average Packet Rate (unit: 64Kbps). 0x3FFF: unlimited rate
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicQueueRate( enum PORTID port, enum QUEUEID queueid, uint32 pprTime, uint32 aprBurstSize, uint32 apr )
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg1;
+	uint32 regValue;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 reg1, regValue;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	if ((port < PHY0) || (port > CPU) || (queueid < QUEUE0) || (queueid > MAX_QUEUE))
+			return FAILED;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if(queueid < QUEUE6)
+		reg1 = P0Q0RGCR + (port * 0x18) + (queueid * 0x4);  /* offset to get corresponding register */
+	else
+		reg1 = P0Q6RGCR + (port * 0x8) + ((queueid-QUEUE6) * 0x4);	/* offset to get corresponding register */
+
+#else
+	reg1 = P0Q0RGCR + (port * 0x18) + (queueid * 0x4);  /* offset to get corresponding register */
+#endif
+
+	regValue = READ_MEM32(reg1) & ~(PPR_MASK | L1_MASK | APR_MASK);
+	regValue |= ((pprTime << PPR_OFFSET) | (aprBurstSize << L1_OFFSET) | (apr << APR_OFFSET));
+	WRITE_MEM32( reg1, regValue);
+
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_getAsicQueueRate | get per queue rate configuration
+@parm enum PORTID | port | the port number
+@parm enum QUEUEID | queueid | the queue ID wanted to set
+@parm uint32* | pPprTime | pointer to Peak Packet Rate (in times of APR). 0~6: PPR = (2^pprTime)*apr. 7: disable PPR
+@parm uint32* | pAprBurstSize | pointer to APR Burst Size (unit: 1KBytes). 0xff: disable
+@parm uint32* | pApr | pointer to Average Packet Rate (unit: 64Kbps). 0x3FFF: unlimited rate
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_getAsicQueueRate( enum PORTID port, enum QUEUEID queueid, uint32* pPprTime, uint32* pAprBurstSize, uint32* pApr )
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg1;
+	uint32 regValue;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 reg1, regValue;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	if ((port < PHY0) || (port > CPU) || (queueid < QUEUE0) || (queueid > MAX_QUEUE))
+		return FAILED;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if(queueid < QUEUE6)
+		reg1 = P0Q0RGCR + (port * 0x18) + (queueid * 0x4);	/* offset to get corresponding register */
+	else
+		reg1 = P0Q6RGCR + (port * 0x8) + ((queueid-QUEUE6) * 0x4);	/* offset to get corresponding register */
+#else
+	reg1 = P0Q0RGCR + (port * 0x18) + (queueid * 0x4);  /* offset to get corresponding register */
+#endif
+	regValue = READ_MEM32(reg1);
+
+	if (pPprTime != NULL)
+		*pPprTime = (regValue & PPR_MASK) >> PPR_OFFSET;
+	if (pAprBurstSize != NULL)
+		*pAprBurstSize = (regValue & L1_MASK) >> L1_OFFSET;
+	if (pApr != NULL)
+		*pApr = (regValue & APR_MASK) >> APR_OFFSET;
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_setAsicPortIngressBandwidth | set per-port total ingress bandwidth
+@parm enum PORTID | port | the port number
+@parm uint32 | bandwidth | the total ingress bandwidth (unit: 16Kbps), 0:disable
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicPortIngressBandwidth( enum PORTID port, uint32 bandwidth)
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg1;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 reg1;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+	#if defined(CONFIG_RTL_8197F)
+	uint32 bandwidth_high = 0;
+	#endif
+
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	/* ingress bandwidth control of CPU port */
+	if (port == CPU) {
+		WRITE_MEM32(IBCR4, ((READ_MEM32(IBCR4) & (~(IBWC_P6_MASK))) | (bandwidth & IBWC_P6_MASK)));
+		return SUCCESS;
+	}
+	#endif /* CONFIG_RTD_1295_HWNAT */
+
+	/* For ingress bandwidth control, its only for PHY0 to PHY5 */
+	if ((port < PHY0) || (port > PHY5))
+		return FAILED;
+
+	reg1 = IBCR0 + ((port / 2) * 0x04);		/* offset to get corresponding register */
+
+	if ( port % 2)
+	{	/* ODD-port */
+		WRITE_MEM32( reg1, ((READ_MEM32(reg1) & ~(IBWC_ODDPORT_MASK)) | ((bandwidth << IBWC_ODDPORT_OFFSET) & IBWC_ODDPORT_MASK)));
+	} else
+	{	/* EVEN-port */
+		WRITE_MEM32( reg1, ((READ_MEM32(reg1) & ~(IBWC_EVENPORT_MASK)) | ((bandwidth << IBWC_EVENPORT_OFFSET) & IBWC_EVENPORT_MASK)));
+	}
+
+	#if defined(CONFIG_RTL_8197F)
+	bandwidth_high = bandwidth>>IBCR3_HIGH_OFFSET;
+	WRITE_MEM32( IBCR3, ((READ_MEM32(IBCR3) & (~(IBCR3_PORT_MASK<<IBCR3_PORT_OFFSET(port)))) |((bandwidth_high&IBCR3_PORT_MASK)<<IBCR3_PORT_OFFSET(port))));
+	#endif
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_getAsicPortIngressBandwidth | get per-port total ingress bandwidth
+@parm enum PORTID | port | the port number
+@parm uint32* | pBandwidth | pointer to the returned total ingress bandwidth (unit: 16Kbps), 0:disable
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_getAsicPortIngressBandwidth( enum PORTID port, uint32* pBandwidth )
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg1;
+	uint32 regValue;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 reg1, regValue;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+	#if defined(CONFIG_RTL_8197F)
+	uint32 pBandwidth_high = 0;
+	#endif
+
+	/* For ingress bandwidth control, its only for PHY0 to PHY5 */
+	if ((port < PHY0) || (port > PHY5))
+		return FAILED;
+
+	reg1 = IBCR0 + ((port / 2) * 0x04);		/* offset to get corresponding register */
+
+	regValue = READ_MEM32(reg1);
+
+	if (pBandwidth != NULL)
+	{
+		*pBandwidth = (port % 2)?
+						/* Odd port */((regValue & IBWC_ODDPORT_MASK) >> IBWC_ODDPORT_OFFSET):
+						/* Even port */((regValue & IBWC_EVENPORT_MASK) >> IBWC_EVENPORT_OFFSET);
+	}
+
+	#if defined(CONFIG_RTL_8197F)
+	regValue = READ_MEM32(IBCR3);
+	pBandwidth_high = (regValue&(IBCR3_PORT_MASK<<IBCR3_PORT_OFFSET(port)))>>IBCR3_PORT_OFFSET(port);
+	*pBandwidth = (pBandwidth_high<<IBCR3_HIGH_OFFSET) |*pBandwidth;
+	#endif
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_setAsicPortEgressBandwidth | set per-port total egress bandwidth
+@parm enum PORTID | port | the port number
+@parm uint32 | bandwidth | the total egress bandwidth (unit: 64kbps). 0x3FFF: disable
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicPortEgressBandwidth( enum PORTID port, uint32 bandwidth )
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg1;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 reg1;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#ifdef CONFIG_RTK_VOIP_QOS
+	extern int wan_port_check(int port);
+#endif
+	if ((port < PHY0) || (port > CPU))
+		return FAILED;
+
+	reg1 = WFQRCRP0 + (port * 0xC);  /* offset to get corresponding register */
+	WRITE_MEM32( reg1, (READ_MEM32(reg1) & ~(APR_MASK)) | (bandwidth << APR_OFFSET));
+
+#ifdef CONFIG_RTK_VOIP_QOS
+	if(wan_port_check(port))
+	{
+		if(bandwidth < 161 )
+			rtl8651_cpu_tx_fc(0);//disable flow control
+		else
+			rtl8651_cpu_tx_fc(1);//enable flow control
+	}
+#endif
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_getAsicPortEgressBandwidth | get per-port total egress bandwidth
+@parm enum PORTID | port | the port number
+@parm uint32* | pBandwidth | pointer to the returned total egress bandwidth (unit: 64kbps). 0x3FFF: disable
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_getAsicPortEgressBandwidth( enum PORTID port, uint32* pBandwidth )
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg1;
+	uint32 regValue;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 reg1, regValue;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	if ((port < PHY0) || (port > CPU))
+		return FAILED;
+
+	reg1 = WFQRCRP0 + (port * 0xC);  /* offset to get corresponding register */
+	regValue = READ_MEM32(reg1);
+
+	if (pBandwidth != NULL)
+		*pBandwidth = (regValue & APR_MASK) >> APR_OFFSET;
+
+	return SUCCESS;
+}
+
+/*set queue type as STRICT*/
+int32 rtl8651_setAsicQueueStrict( enum PORTID port, enum QUEUEID queueid, enum QUEUETYPE queueType)
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg1;
+	uint32 regOFFSET, regValue;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 reg1, regOFFSET, regValue;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	if ((port < PHY0) || (port > CPU) || (queueid < QUEUE0) || (queueid > MAX_QUEUE))
+		return FAILED;
+	if ((queueType < STR_PRIO) || (queueType > WFQ_PRIO))
+		return FAILED;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if(queueid < QUEUE6)
+	{
+		reg1 = WFQWCR0P0 + (port * 0xC) + ((queueid >> 2) * 0x4);	/* offset to get corresponding register */
+		regOFFSET = (queueid % 4) * 0x8;	/* used to offset register value */
+
+		regValue = READ_MEM32(reg1) & ~((WEIGHT0_MASK | SCHE0_MASK) << regOFFSET);
+		regValue |= (queueType << (SCHE0_OFFSET + regOFFSET));
+		WRITE_MEM32( reg1, regValue);
+	}
+	else
+	{
+		reg1 = WFQWCR1P0_98C + (port * 0x4) + (((queueid-QUEUE6) >> 2) * 0x4);	/* offset to get corresponding register */
+		regOFFSET = ((queueid- QUEUE6) % 4) * 0x8;	/* used to offset register value */
+
+		regValue = READ_MEM32(reg1) & ~((WEIGHT0_MASK | SCHE0_MASK) << regOFFSET);
+		regValue |= (queueType << (SCHE0_OFFSET + regOFFSET));
+		WRITE_MEM32( reg1, regValue);
+	}
+#else
+
+	reg1 = WFQWCR0P0 + (port * 0xC) + ((queueid >> 2) * 0x4);	/* offset to get corresponding register */
+	regOFFSET = (queueid % 4) * 0x8;	/* used to offset register value */
+
+	regValue = READ_MEM32(reg1) & ~((WEIGHT0_MASK | SCHE0_MASK) << regOFFSET);
+	regValue |= (queueType << (SCHE0_OFFSET + regOFFSET));
+	WRITE_MEM32( reg1, regValue);
+#endif
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicQueueStrict( enum PORTID port, enum QUEUEID queueid, enum QUEUETYPE *pQueueType)
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg1;
+	uint32 regOFFSET, regValue;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 reg1, regOFFSET, regValue;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	if ((port < PHY0) || (port > CPU) || (queueid < QUEUE0) || (queueid > MAX_QUEUE) ||(pQueueType == NULL))
+		return FAILED;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if(queueid < QUEUE6)
+	{
+		reg1 = WFQWCR0P0 + (port * 0xC) + ((queueid >> 2) * 0x4);  /* offset to get corresponding register */
+		regOFFSET = (queueid % 4) * 0x8;	/* used to offset register value */
+		regValue = READ_MEM32(reg1);
+
+		if (pQueueType != NULL)
+			*pQueueType = ((regValue & (SCHE0_MASK << regOFFSET)) >> SCHE0_OFFSET) >> regOFFSET;
+	}
+	else
+	{
+		reg1 = WFQWCR1P0_98C + (port * 0x4) + (((queueid -QUEUE6)>>2) * 0x4);  /* offset to get corresponding register */
+		regOFFSET = ((queueid- QUEUE6)% 4) * 0x8;	/* used to offset register value */
+		regValue = READ_MEM32(reg1);
+
+		if (pQueueType != NULL)
+			*pQueueType = ((regValue & (SCHE0_MASK << regOFFSET)) >> SCHE0_OFFSET) >> regOFFSET;
+	}
+#else
+	reg1 = WFQWCR0P0 + (port * 0xC) + ((queueid >> 2) * 0x4);  /* offset to get corresponding register */
+	regOFFSET = (queueid % 4) * 0x8;	/* used to offset register value */
+	regValue = READ_MEM32(reg1);
+
+	if (pQueueType != NULL)
+		*pQueueType = ((regValue & (SCHE0_MASK << regOFFSET)) >> SCHE0_OFFSET) >> regOFFSET;
+#endif
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_setAsicQueueWeight | set WFQ weighting
+@parm enum PORTID | port | the port number
+@parm enum QUEUEID | queueid | the queue ID wanted to set
+@parm enum QUEUETYPE | queueType | the specified queue type
+@parm uint32 | weight | the weight value wanted to set (valid:0~127)
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicQueueWeight( enum PORTID port, enum QUEUEID queueid, enum QUEUETYPE queueType, uint32 weight )
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg1;
+	uint32 regOFFSET, regValue;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 reg1, regOFFSET, regValue;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	if ((port < PHY0) || (port > CPU) || (queueid < QUEUE0) || (queueid > MAX_QUEUE))
+		return FAILED;
+
+	if ((queueType < STR_PRIO) || (queueType > WFQ_PRIO))
+		return FAILED;
+	if((weight < 0) && (weight > 127))
+		return FAILED;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if(queueid < QUEUE6){
+		reg1 = WFQWCR0P0 + (port * 0xC) + ((queueid >> 2) * 0x4);	/* offset to get corresponding register */
+		regOFFSET = (queueid % 4) * 0x8;	/* used to offset register value */
+	}
+	else{
+		reg1 = WFQWCR1P0_98C + (port * 0x4) + (((queueid -QUEUE6) >> 2) * 0x4);	/* offset to get corresponding register */
+		regOFFSET = ((queueid- QUEUE6)% 4) * 0x8;	/* used to offset register value */
+	}
+
+#else
+	reg1 = WFQWCR0P0 + (port * 0xC) + ((queueid >> 2) * 0x4);	/* offset to get corresponding register */
+	regOFFSET = (queueid % 4) * 0x8;	/* used to offset register value */
+#endif
+
+	regValue = READ_MEM32(reg1) & ~((WEIGHT0_MASK | SCHE0_MASK) << regOFFSET);
+	regValue |= ((queueType << (SCHE0_OFFSET + regOFFSET)) | (weight << (WEIGHT0_OFFSET + regOFFSET)));
+	WRITE_MEM32( reg1, regValue);
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_getAsicQueueWeight | get WFQ weighting
+@parm enum PORTID | port | the port number
+@parm enum QUEUEID | queueid | the queue ID wanted to set
+@parm enum QUEUETYPE* | pQueueType | pointer to the returned queue type
+@parm uint32* | pWeight | pointer to the returned weight value
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_getAsicQueueWeight( enum PORTID port, enum QUEUEID queueid, enum QUEUETYPE *pQueueType, uint32 *pWeight )
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg1;
+	uint32 regOFFSET, regValue;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 reg1, regOFFSET, regValue;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	if ((port < PHY0) || (port > CPU) || (queueid < QUEUE0) || (queueid > MAX_QUEUE))
+		return FAILED;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if(queueid < QUEUE6)
+		reg1 = WFQWCR0P0 + (port * 0xC) + ((queueid >> 2) * 0x4);	/* offset to get corresponding register */
+	else
+		reg1 = WFQWCR1P0_98C + (port * 0x4) + (((queueid -QUEUE6) >> 2) * 0x4); /* offset to get corresponding register */
+
+	if(queueid < QUEUE6)
+		regOFFSET = (queueid% 4) * 0x8;
+	else
+		regOFFSET = ((queueid - QUEUE6)% 4) * 0x8;
+
+	//regOFFSET = ((queueid- QUEUE6)% 4) * 0x8;	/* used to offset register value */
+#else
+	reg1 = WFQWCR0P0 + (port * 0xC) + ((queueid >> 2) * 0x4);  /* offset to get corresponding register */
+	regOFFSET = (queueid % 4) * 0x8;	/* used to offset register value */
+#endif
+	regValue = READ_MEM32(reg1);
+
+	if (pQueueType != NULL)
+		*pQueueType = ((regValue & (SCHE0_MASK << regOFFSET)) >> SCHE0_OFFSET) >> regOFFSET;
+	if (pWeight != NULL)
+		*pWeight = ((regValue & (WEIGHT0_MASK << regOFFSET)) >> WEIGHT0_OFFSET) >> regOFFSET;
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_setAsicOutputQueueNumber | set output queue number for a specified port
+@parm enum PORTID | port | the port number (valid: physical ports(0~5) and CPU port(6) )
+@parm enum QUEUENUM | qnum | the output queue number
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicOutputQueueNumber( enum PORTID port, enum QUEUENUM qnum )
+{
+	/* Invalid input parameter */
+
+	enum QUEUENUM orgQnum;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if ((port < PHY0) || (port > CPU) || (qnum < QNUM1) || (qnum > QNUM8))
+		return FAILED;
+	if(qnum==QNUM8)
+		WRITE_MEM32(PQGCR8, (READ_MEM32(PQGCR8) |EN_8PRI_Q_MASK));
+	else
+		WRITE_MEM32(PQGCR8, (READ_MEM32(PQGCR8) &(~EN_8PRI_Q_MASK)));
+
+
+	orgQnum = (READ_MEM32(QNUMCR) >> (3*port)) & 0x7;
+
+	WRITE_MEM32(QNUMCR, (READ_MEM32(QNUMCR) & ~(0x7 << (3*port))) | ((qnum-1) << (3*port)));
+#else
+
+	if ((port < PHY0) || (port > CPU) || (qnum < QNUM1) || (qnum > QNUM6))
+		return FAILED;
+
+	orgQnum = (READ_MEM32(QNUMCR) >> (3*port)) & 0x7;
+	WRITE_MEM32(QNUMCR, (READ_MEM32(QNUMCR) & ~(0x7 << (3*port))) | (qnum << (3*port)));
+#endif
+
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198)
+	if (qnum==6)
+	{
+		if (orgQnum!=6)
+			_rtl865x_setQosThresholdByQueueIdx(QNUM_IDX_6);
+	}
+	else if (qnum>3)
+	{
+		if((orgQnum==6)||orgQnum<4)
+			_rtl865x_setQosThresholdByQueueIdx(QNUM_IDX_45);
+	}
+	else
+	{
+		if(orgQnum>3)
+			_rtl865x_setQosThresholdByQueueIdx(QNUM_IDX_123);
+	}
+#endif
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_getAsicOutputQueueNumber | get output queue number for a specified port
+@parm enum PORTID | port | the port number (valid: physical ports(0~5) and CPU port(6) )
+@parm enum QUEUENUM | qnum | the output queue number
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_getAsicOutputQueueNumber( enum PORTID port, enum QUEUENUM *qnum )
+{
+	/* Invalid input parameter */
+	if ((port < PHY0) || (port > CPU))
+		return FAILED;
+
+	if (qnum != NULL)
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		*qnum = ((READ_MEM32(QNUMCR) >> (3*port)) & 0x7)+1;
+#else
+		*qnum = (READ_MEM32(QNUMCR) >> (3*port)) & 0x7;
+#endif
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_setAsicPriorityToQIDMappingTable | set user priority to QID mapping table parameter
+@parm enum QUEUENUM | qnum | the output queue number
+@parm enum PRIORITYVALUE | priority | priority
+@parm enum QUEUEID | qid | queue ID
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicPriorityToQIDMappingTable( enum QUEUENUM qnum, enum PRIORITYVALUE priority, enum QUEUEID qid )
+{
+	/* Invalid input parameter */
+	if ((priority < PRI0) || (priority > PRI7))
+		return FAILED;
+
+	if ((qid < QUEUE0) || (qid > MAX_QUEUE))
+		return FAILED;
+
+	switch (qnum)
+	{
+		case QNUM1:
+			WRITE_MEM32(UPTCMCR0, (READ_MEM32(UPTCMCR0) & ~(0x7 << (priority*3))) | (qid << (priority*3))); break;
+		case QNUM2:
+			WRITE_MEM32(UPTCMCR1, (READ_MEM32(UPTCMCR1) & ~(0x7 << (priority*3))) | (qid << (priority*3))); break;
+		case QNUM3:
+			WRITE_MEM32(UPTCMCR2, (READ_MEM32(UPTCMCR2) & ~(0x7 << (priority*3))) | (qid << (priority*3))); break;
+		case QNUM4:
+			WRITE_MEM32(UPTCMCR3, (READ_MEM32(UPTCMCR3) & ~(0x7 << (priority*3))) | (qid << (priority*3))); break;
+		case QNUM5:
+			WRITE_MEM32(UPTCMCR4, (READ_MEM32(UPTCMCR4) & ~(0x7 << (priority*3))) | (qid << (priority*3))); break;
+		case QNUM6:
+			WRITE_MEM32(UPTCMCR5, (READ_MEM32(UPTCMCR5) & ~(0x7 << (priority*3))) | (qid << (priority*3))); break;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		case QNUM7:
+			WRITE_MEM32(UPTCMCR6, (READ_MEM32(UPTCMCR6) & ~(0x7 << (priority*3))) | (qid << (priority*3))); break;
+		case QNUM8:
+			WRITE_MEM32(UPTCMCR7, (READ_MEM32(UPTCMCR7) & ~(0x7 << (priority*3))) | (qid << (priority*3))); break;
+#endif
+		default:
+			return FAILED;
+	}
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicPriorityToQIDMappingTable( enum QUEUENUM qnum, enum PRIORITYVALUE priority, enum QUEUEID* qid )
+{
+	/* Invalid input parameter */
+	if ((priority < PRI0) || (priority > PRI7) ||(qid == NULL))
+		return FAILED;
+
+	switch (qnum)
+	{
+		case QNUM1:
+			*qid = (READ_MEM32(UPTCMCR0) >> (priority*3)) & 0x7;
+			break;
+		case QNUM2:
+			*qid = (READ_MEM32(UPTCMCR1) >> (priority*3)) & 0x7;
+			break;
+		case QNUM3:
+			*qid = (READ_MEM32(UPTCMCR2) >> (priority*3)) & 0x7;
+			break;
+		case QNUM4:
+			*qid = (READ_MEM32(UPTCMCR3) >> (priority*3)) & 0x7;
+			break;
+		case QNUM5:
+			*qid = (READ_MEM32(UPTCMCR4) >> (priority*3)) & 0x7;
+			break;
+		case QNUM6:
+			*qid = (READ_MEM32(UPTCMCR5) >> (priority*3)) & 0x7;
+			break;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		case QNUM7:
+			*qid = (READ_MEM32(UPTCMCR6) >> (priority*3)) & 0x7;
+			break;
+		case QNUM8:
+			*qid = (READ_MEM32(UPTCMCR7) >> (priority*3)) & 0x7;
+			break;
+#endif
+		default:
+			return FAILED;
+	}
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_setAsicCPUPriorityToQIDMappingTable | set user priority to QID mapping table parameter based on destination port & priority information
+@parm enum PORTID | port | the destination port
+@parm enum PRIORITYVALUE | priority | priority
+@parm enum QUEUEID | qid | queue ID
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicCPUPriorityToQIDMappingTable( enum PORTID port, enum PRIORITYVALUE priority, enum QUEUEID qid )
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t reg;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32	reg;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+	/* Invalid input parameter */
+	if ((priority < PRI0) || (priority > PRI7))
+		return FAILED;
+
+	if ((qid < QUEUE0) || (qid > MAX_QUEUE))
+		return FAILED;
+
+	if (port<CPU || port>MULTEXT)
+		return FAILED;
+
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	reg = (uintptr_t)(((uint32*)CPUQIDMCR0) + (port-CPU));
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	reg = (uint32)(((uint32*)CPUQIDMCR0) + (port-CPU));
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+	WRITE_MEM32(reg, (READ_MEM32(reg) & ~(0x7 << (priority<<2))) | (qid << (priority<<2)));
+
+	return SUCCESS;
+}
+
+
+int32 rtl8651_setAsicSystemBasedFlowControlRegister(uint32 sharedON, uint32 sharedOFF, uint32 fcON, uint32 fcOFF, uint32 drop)
+{
+	/* Invalid input parameter */
+	if ((sharedON > (SDC_FCON_MASK >> SDC_FCON_OFFSET)) ||
+		(sharedOFF > (S_DSC_FCOFF_MASK >> S_DSC_FCOFF_OFFSET)) ||
+		(fcON > ((S_Max_SBuf_FCON_MASK >> S_Max_SBuf_FCON_OFFSET))) ||
+		(fcOFF > (S_Max_SBuf_FCOFF_MASK >> S_Max_SBuf_FCOFF_OFFSET)) ||
+		(drop > (S_DSC_RUNOUT_MASK >> S_DSC_RUNOUT_OFFSET)))
+		return FAILED;
+
+	WRITE_MEM32(SBFCR0, (READ_MEM32(SBFCR0) & ~(S_DSC_RUNOUT_MASK)) | (drop << S_DSC_RUNOUT_OFFSET));
+	WRITE_MEM32(SBFCR1, (READ_MEM32(SBFCR1) & ~(S_DSC_FCON_MASK | S_DSC_FCOFF_MASK)) | ( fcON<< S_DSC_FCON_OFFSET) | (fcOFF << S_DSC_FCOFF_OFFSET));
+	WRITE_MEM32(SBFCR2, (READ_MEM32(SBFCR2) & ~(S_Max_SBuf_FCON_MASK | S_Max_SBuf_FCOFF_MASK)) | (sharedON << S_Max_SBuf_FCON_OFFSET) | (sharedOFF << S_Max_SBuf_FCOFF_OFFSET));
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicQueueDescriptorBasedFlowControlRegister(enum PORTID port, enum QUEUEID queue, uint32 fcON, uint32 fcOFF)
+{
+	/* Invalid input parameter */
+	if ((port < PHY0) || (port > CPU))
+		return FAILED;
+
+	if ((fcON > (QG_DSC_FCON_MASK >> QG_DSC_FCON_OFFSET)) ||
+		(fcOFF > (QG_DSC_FCOFF_MASK >> QG_DSC_FCOFF_OFFSET)))
+		return FAILED;
+
+
+	switch (queue)
+	{
+		case QUEUE0:
+			WRITE_MEM32((QDBFCRP0G0+(port*0xC)), (READ_MEM32(QDBFCRP0G0+(port*0xC)) & ~(QG_DSC_FCON_MASK | QG_DSC_FCOFF_MASK)) | (fcON << QG_DSC_FCON_OFFSET) | (fcOFF << QG_DSC_FCOFF_OFFSET));
+			break;
+		case QUEUE1:
+		case QUEUE2:
+		case QUEUE3:
+		case QUEUE4:
+			WRITE_MEM32((QDBFCRP0G1+(port*0xC)), (READ_MEM32(QDBFCRP0G1+(port*0xC)) & ~(QG_DSC_FCON_MASK | QG_DSC_FCOFF_MASK)) | (fcON << QG_DSC_FCON_OFFSET) | (fcOFF << QG_DSC_FCOFF_OFFSET));
+			break;
+		case QUEUE5:
+			WRITE_MEM32((QDBFCRP0G2+(port*0xC)), (READ_MEM32(QDBFCRP0G2+(port*0xC)) & ~(QG_DSC_FCON_MASK | QG_DSC_FCOFF_MASK)) | (fcON << QG_DSC_FCON_OFFSET) | (fcOFF << QG_DSC_FCOFF_OFFSET));
+			break;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		case QUEUE6:
+			WRITE_MEM32((QDBFCRP0G3+(port*0x8)), (READ_MEM32(QDBFCRP0G3+(port*0x8)) & ~(QG_DSC_FCON_MASK | QG_DSC_FCOFF_MASK)) | (fcON << QG_DSC_FCON_OFFSET) | (fcOFF << QG_DSC_FCOFF_OFFSET));
+			break;
+		case QUEUE7:
+			WRITE_MEM32((QDBFCRP0G4+(port*0x8)), (READ_MEM32(QDBFCRP0G3+(port*0x8)) & ~(QG_DSC_FCON_MASK | QG_DSC_FCOFF_MASK)) | (fcON << QG_DSC_FCON_OFFSET) | (fcOFF << QG_DSC_FCOFF_OFFSET));
+			break;
+#endif
+		default:
+			return FAILED;
+	}
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicQueuePacketBasedFlowControlRegister(enum PORTID port, enum QUEUEID queue, uint32 fcON, uint32 fcOFF)
+{
+	/* Invalid input parameter */
+	if ((port < PHY0) || (port > CPU))
+		return FAILED;
+
+	if ((fcON > (QG_QLEN_FCON_MASK>> QG_QLEN_FCON_OFFSET)) ||
+		(fcOFF > (QG_QLEN_FCOFF_MASK >> QG_QLEN_FCOFF_OFFSET)))
+		return FAILED;
+
+	switch (queue)
+	{
+		case QUEUE0:
+			WRITE_MEM32((QPKTFCRP0G0+(port*0xC)), (READ_MEM32(QPKTFCRP0G0+(port*0xC)) & ~(QG_QLEN_FCON_MASK | QG_QLEN_FCOFF_MASK)) | (fcON << QG_QLEN_FCON_OFFSET) | (fcOFF << QG_QLEN_FCOFF_OFFSET));
+			break;
+		case QUEUE1:
+		case QUEUE2:
+		case QUEUE3:
+		case QUEUE4:
+			WRITE_MEM32((QPKTFCRP0G1+(port*0xC)), (READ_MEM32(QPKTFCRP0G1+(port*0xC)) & ~(QG_QLEN_FCON_MASK | QG_QLEN_FCOFF_MASK)) | (fcON << QG_QLEN_FCON_OFFSET) | (fcOFF << QG_QLEN_FCOFF_OFFSET));
+			break;
+		case QUEUE5:
+			WRITE_MEM32((QPKTFCRP0G2+(port*0xC)), (READ_MEM32(QPKTFCRP0G2+(port*0xC)) & ~(QG_QLEN_FCON_MASK | QG_QLEN_FCOFF_MASK)) | (fcON << QG_QLEN_FCON_OFFSET) | (fcOFF << QG_QLEN_FCOFF_OFFSET));
+			break;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		case QUEUE6:
+			WRITE_MEM32((QPKTFCRP0G3+(port*0x8)), (READ_MEM32(QPKTFCRP0G3+(port*0x8)) & ~(QG_QLEN_FCON_MASK | QG_QLEN_FCOFF_MASK)) | (fcON << QG_QLEN_FCON_OFFSET) | (fcOFF << QG_QLEN_FCOFF_OFFSET));
+			break;
+		case QUEUE7:
+			WRITE_MEM32((QPKTFCRP0G4+(port*0x8)), (READ_MEM32(QPKTFCRP0G4+(port*0x8)) & ~(QG_QLEN_FCON_MASK | QG_QLEN_FCOFF_MASK)) | (fcON << QG_QLEN_FCON_OFFSET) | (fcOFF << QG_QLEN_FCOFF_OFFSET));
+			break;
+#endif
+		default:
+			return FAILED;
+	}
+
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicPortBasedFlowControlRegister(enum PORTID port, uint32 fcON, uint32 fcOFF)
+{
+	/* Invalid input parameter */
+	if ((fcON > (P_MaxDSC_FCON_MASK >> P_MaxDSC_FCON_OFFSET)) ||
+		(fcOFF > (P_MaxDSC_FCOFF_MASK >> P_MaxDSC_FCOFF_OFFSET)))
+		return FAILED;
+
+	switch (port)
+	{
+		case PHY0:
+			WRITE_MEM32(PBFCR0, (READ_MEM32(PBFCR0) & ~(P_MaxDSC_FCON_MASK | P_MaxDSC_FCOFF_MASK)) | (fcON << P_MaxDSC_FCON_OFFSET) | (fcOFF << P_MaxDSC_FCOFF_OFFSET)); break;
+		case PHY1:
+			WRITE_MEM32(PBFCR1, (READ_MEM32(PBFCR1) & ~(P_MaxDSC_FCON_MASK | P_MaxDSC_FCOFF_MASK)) | (fcON << P_MaxDSC_FCON_OFFSET) | (fcOFF << P_MaxDSC_FCOFF_OFFSET)); break;
+		case PHY2:
+			WRITE_MEM32(PBFCR2, (READ_MEM32(PBFCR2) & ~(P_MaxDSC_FCON_MASK | P_MaxDSC_FCOFF_MASK)) | (fcON << P_MaxDSC_FCON_OFFSET) | (fcOFF << P_MaxDSC_FCOFF_OFFSET)); break;
+		case PHY3:
+			WRITE_MEM32(PBFCR3, (READ_MEM32(PBFCR3) & ~(P_MaxDSC_FCON_MASK | P_MaxDSC_FCOFF_MASK)) | (fcON << P_MaxDSC_FCON_OFFSET) | (fcOFF << P_MaxDSC_FCOFF_OFFSET)); break;
+		case PHY4:
+			WRITE_MEM32(PBFCR4, (READ_MEM32(PBFCR4) & ~(P_MaxDSC_FCON_MASK | P_MaxDSC_FCOFF_MASK)) | (fcON << P_MaxDSC_FCON_OFFSET) | (fcOFF << P_MaxDSC_FCOFF_OFFSET)); break;
+		case PHY5:
+			WRITE_MEM32(PBFCR5, (READ_MEM32(PBFCR5) & ~(P_MaxDSC_FCON_MASK | P_MaxDSC_FCOFF_MASK)) | (fcON << P_MaxDSC_FCON_OFFSET) | (fcOFF << P_MaxDSC_FCOFF_OFFSET)); break;
+		case CPU:
+			WRITE_MEM32(PBFCR6, (READ_MEM32(PBFCR6) & ~(P_MaxDSC_FCON_MASK | P_MaxDSC_FCOFF_MASK)) | (fcON << P_MaxDSC_FCON_OFFSET) | (fcOFF << P_MaxDSC_FCOFF_OFFSET)); break;
+		default:
+			return FAILED;
+	}
+
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicPerQueuePhysicalLengthGapRegister(uint32 gap)
+{
+	/* Invalid input parameter */
+	if (gap > (QLEN_GAP_MASK >> QLEN_GAP_OFFSET))
+		return FAILED;
+
+	WRITE_MEM32(PQPLGR, (READ_MEM32(PQPLGR) & ~(QLEN_GAP_MASK)) | (gap << QLEN_GAP_OFFSET));
+	return SUCCESS;
+}
+
+/* 	note: the dynamic mechanism: adjust the flow control threshold value according to the number of Ethernet link up ports.
+	buffer threshold setting:
+	sys on = 208, share on = 192 for link port <=3
+	0xbb804504 = 0x00c000d0
+	0xbb804508 = 0x00b000c0
+
+	sys on = 172, share on = 98 , for link port > 3
+	0xbb804504 = 0x00A000AC
+	0xbb804508 = 0x004A0062
+
+	1. default threshold setting is link port <=3
+	2. got link change interrupt and link port > 3, then change threhosld for link port > 3
+	3. got link change interrupt and link port <= 3, then change threhosld for link port <= 3
+ */
+
+#ifdef CONFIG_RTL_8197D_DYN_THR
+int32 rtl819x_setQosThreshold(uint32 old_sts, uint32 new_sts)
+{
+	int32 i, link_up_ports=0;
+	uint32 j = new_sts;
+
+	if (old_sts == new_sts)
+		return SUCCESS;
+
+	for (i=0; i<5; i++) {
+		if ((j & 0x1) == 1)
+			link_up_ports++;
+		j = j >> 1;
+	}
+
+	if (link_up_ports <= DYN_THR_LINK_UP_PORTS) {
+		WRITE_MEM32(SBFCR1, (READ_MEM32(SBFCR1) & ~(S_DSC_FCON_MASK | S_DSC_FCOFF_MASK)) | ( DYN_THR_AGG_fcON<< S_DSC_FCON_OFFSET) | (DYN_THR_AGG_fcOFF << S_DSC_FCOFF_OFFSET));
+		WRITE_MEM32(SBFCR2, (READ_MEM32(SBFCR2) & ~(S_Max_SBuf_FCON_MASK | S_Max_SBuf_FCOFF_MASK)) | (DYN_THR_AGG_sharedON << S_Max_SBuf_FCON_OFFSET) | (DYN_THR_AGG_sharedOFF << S_Max_SBuf_FCOFF_OFFSET));
+	}
+	else {
+		WRITE_MEM32(SBFCR1, (READ_MEM32(SBFCR1) & ~(S_DSC_FCON_MASK | S_DSC_FCOFF_MASK)) | ( DYN_THR_DEF_fcON<< S_DSC_FCON_OFFSET) | (DYN_THR_DEF_fcOFF << S_DSC_FCOFF_OFFSET));
+		WRITE_MEM32(SBFCR2, (READ_MEM32(SBFCR2) & ~(S_Max_SBuf_FCON_MASK | S_Max_SBuf_FCOFF_MASK)) | (DYN_THR_DEF_sharedON << S_Max_SBuf_FCON_OFFSET) | (DYN_THR_DEF_sharedOFF << S_Max_SBuf_FCOFF_OFFSET));
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198)
+static int32 _rtl865x_setQosThresholdByQueueIdx(uint32 qidx)
+{
+	/* Set the threshold value for qos sytem */
+	int32 retval;
+	int32	i,j;
+
+	printk("Set threshould idx %d\n", qidx);
+	retval = rtl8651_setAsicSystemBasedFlowControlRegister(outputQueuePara[qidx].systemSBFCON, outputQueuePara[qidx].systemSBFCOFF, outputQueuePara[qidx].systemFCON, outputQueuePara[qidx].systemFCOFF, outputQueuePara[qidx].drop);
+	if (retval!= SUCCESS)
+	{
+		rtlglue_printf("Set System Base Flow Control Para Error.\n");
+		return retval;
+	}
+
+	for(i =0; i < RTL8651_OUTPUTQUEUE_SIZE; i++)
+	{
+		retval = rtl8651_setAsicQueueDescriptorBasedFlowControlRegister(0, i, outputQueuePara[qidx].queueDescFCON, outputQueuePara[qidx].queueDescFCOFF);
+		if (retval!= SUCCESS)
+		{
+			rtlglue_printf("Set Queue Descriptor Base Flow Control Para Error.\n");
+			return retval;
+		}
+		for(j=1;j<=CPU;j++)
+			rtl8651_setAsicQueueDescriptorBasedFlowControlRegister(PHY0+j, i, outputQueuePara[qidx].queueDescFCON, outputQueuePara[qidx].queueDescFCOFF);
+
+
+		retval = rtl8651_setAsicQueuePacketBasedFlowControlRegister(0, i, outputQueuePara[qidx].queuePktFCON, outputQueuePara[qidx].queuePktFCOFF);
+		if (retval!= SUCCESS)
+		{
+			rtlglue_printf("Set Queue Packet Base Flow Control Para Error.\n");
+			return retval;
+		}
+		for(j=1;j<=CPU;j++)
+			rtl8651_setAsicQueuePacketBasedFlowControlRegister(PHY0+j, i, outputQueuePara[qidx].queuePktFCON, outputQueuePara[qidx].queuePktFCOFF);
+
+	}
+
+	retval = rtl8651_setAsicPortBasedFlowControlRegister(0, outputQueuePara[qidx].portFCON, outputQueuePara[qidx].portFCOFF);
+	if (retval!= SUCCESS)
+	{
+		rtlglue_printf("Set Port Base Flow Control Para Error.\n");
+		return retval;
+	}
+	for(j=1;j<=CPU;j++)
+		rtl8651_setAsicPortBasedFlowControlRegister(PHY0+j, outputQueuePara[qidx].portFCON, outputQueuePara[qidx].portFCOFF);
+
+	retval = rtl8651_setAsicPerQueuePhysicalLengthGapRegister(outputQueuePara[qidx].gap);
+	if (retval!= SUCCESS)
+	{
+		rtlglue_printf("Set Queue Physical Lenght Gap Reg Error.\n");
+		return retval;
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+static int32 rtd129x_setQosThreshold(void)
+{
+	/* Set the threshold value for qos sytem */
+	int32 retval;
+	int32 i, j;
+
+	for (i = 0; i < RTL8651_OUTPUTQUEUE_SIZE; i++) {
+		retval = rtl8651_setAsicQueueDescriptorBasedFlowControlRegister(0, i, Q_DESC_FC_ON, Q_DESC_FC_OFF);
+		if (retval != SUCCESS) {
+			pr_err("Set Queue Descriptor Base Flow Control Para Error.\n");
+			return retval;
+		}
+		for (j = 1; j <= CPU; j++)
+			rtl8651_setAsicQueueDescriptorBasedFlowControlRegister(PHY0+j, i, Q_DESC_FC_ON, Q_DESC_FC_OFF);
+
+
+		retval = rtl8651_setAsicQueuePacketBasedFlowControlRegister(0, i, Q_PKT_FC_ON, Q_PKT_FC_OFF);
+		if (retval!= SUCCESS) {
+			pr_err("Set Queue Packet Base Flow Control Para Error.\n");
+			return retval;
+		}
+		for ( j = 1; j <= CPU; j++)
+			rtl8651_setAsicQueuePacketBasedFlowControlRegister(PHY0+j, i, Q_PKT_FC_ON, Q_PKT_FC_OFF);
+
+	}
+
+	retval = rtl8651_setAsicPerQueuePhysicalLengthGapRegister(Q_GAP);
+	if (retval!= SUCCESS) {
+		pr_err("Set Queue Physical Lenght Gap Reg Error.\n");
+		return retval;
+	}
+
+	return SUCCESS;
+}
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+static int32 _rtl865xC_QM_init( void )
+{
+	uint32 originalDescGetReady;
+	int32 cnt;
+	rtlglue_printf("Start to initiate QM\n");
+
+
+	/*
+	   1. Get the original decriptor usage for QM.
+	 */
+	WRITE_MEM32( SIRR, READ_MEM32(SIRR)| TRXRDY );
+	rtl865xC_lockSWCore();
+	cnt = 0;
+
+	do
+	{
+		int32 idx;
+
+		originalDescGetReady = TRUE;	/* by default, set it to TRUE */
+		_rtl865xC_QM_orgDescUsage = 0;	/* by default, set it to 0 */
+
+		for ( idx = 0 ; idx < RTL865XC_QM_DESC_READROBUSTPARAMETER ; idx ++ )
+		{
+			uint32 currentDescUsage;
+
+			currentDescUsage = (READ_MEM32( GDSR0 ) & USEDDSC_MASK) >> USEDDSC_OFFSET;
+			if (	( currentDescUsage == 0 /* It's impossible */ ) ||
+				(( _rtl865xC_QM_orgDescUsage != 0 ) &&
+				 ( currentDescUsage != _rtl865xC_QM_orgDescUsage) ) )
+			{
+				rtlglue_printf("INIT swCore descriptor count Failed : (%d [%d])\n", currentDescUsage, _rtl865xC_QM_orgDescUsage);
+				originalDescGetReady = FALSE;
+			} else
+			{
+				_rtl865xC_QM_orgDescUsage = currentDescUsage;
+			}
+		}
+		cnt++;
+	} while ( originalDescGetReady != TRUE && cnt< 200000);
+
+	if (_rtl865xC_QM_orgDescUsage<12)
+		_rtl865xC_QM_orgDescUsage = 12;
+
+	rtl865xC_unLockSWCore();
+
+	return SUCCESS;
+}
+#endif
+
+/*
+@func int32 | rtl865xC_waitForOutputQueueEmpty | wait until output queue empty
+@rvalue SUCCESS |
+@comm
+	The function will not return until all the output queue is empty.
+ */
+int32 rtl865xC_waitForOutputQueueEmpty(void)
+{
+#if defined(CONFIG_OPENWRT_SDK)
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	int32	currentDescUsage;
+	int32	cnt, i;
+	unsigned long latetime=jiffies;
+	unsigned long currtime =jiffies;
+#if defined (CONFIG_RTL_HW_QOS_DEBUG)
+	printk("1.[%s]:[%d].\n",__FUNCTION__,__LINE__);
+#endif
+	#if defined(CONFIG_RTL_8196C)
+	while((READ_MEM32(LAGCR1)&OUTPUTQUEUE_STAT_MASK_CR1)!=OUTPUTQUEUE_STAT_MASK_CR1);
+	#elif defined(CONFIG_RTL_8198C)	|| defined(CONFIG_RTL_8197F)
+	while( ((READ_MEM32(LAGCR1)&OUTPUTQUEUE_STAT_MASK_CR1)^OUTPUTQUEUE_STAT_MASK_CR1) ||
+	((READ_MEM32(LAGCR2)&OUTPUTQUEUE_STAT_MASK_CR2)^OUTPUTQUEUE_STAT_MASK_CR2) )
+	{
+		/*free rx ring when cpu port queue not empty */
+		currtime =jiffies;
+		if((time_before_eq(latetime+5*HZ,  currtime))
+		&&((READ_MEM32(LAGCR2)&OUTPUTQUEUE_STAT_MASK_CPU)^OUTPUTQUEUE_STAT_MASK_CPU))
+		{
+			swNic_freeRxRing( );
+		}
+#if defined (CONFIG_RTL_HW_QOS_DEBUG)
+
+		if (net_ratelimit() )
+			printk("LAGCR1:%x,LAGCR2:%x.\n",READ_MEM32(LAGCR1),READ_MEM32(LAGCR2));
+#else
+				;	/* do nothing */
+#endif
+
+	}
+	#else
+	while ( ((READ_MEM32(LAGCR0)&OUTPUTQUEUE_STAT_MASK_CR0)^OUTPUTQUEUE_STAT_MASK_CR0) ||
+	((READ_MEM32(LAGCR1)&OUTPUTQUEUE_STAT_MASK_CR1)^OUTPUTQUEUE_STAT_MASK_CR1) )
+	{
+#if defined (CONFIG_RTL_HW_QOS_DEBUG)
+
+		if (net_ratelimit() )
+			printk("LAGCR0:%x,LAGCR1:%x.\n",READ_MEM32(LAGCR0),READ_MEM32(LAGCR1));
+#else
+				;	/* do nothing */
+#endif
+
+	}
+	#endif
+
+	/*	There are something wrong when check the input queue is empty or not	*/
+	currentDescUsage = (READ_MEM32( GDSR0 ) & USEDDSC_MASK) >> USEDDSC_OFFSET;
+	cnt = (currentDescUsage-_rtl865xC_QM_orgDescUsage)<<10;
+	i = 0;
+	while ( ((currentDescUsage = ((READ_MEM32( GDSR0 ) & USEDDSC_MASK) >> USEDDSC_OFFSET)) > _rtl865xC_QM_orgDescUsage) && (i<cnt) )
+	{
+#if defined (CONFIG_RTL_HW_QOS_DEBUG)
+		if (net_ratelimit() )
+		printk("Waiting for input queue empty.  ==> currently used %d-%d=%d.\n",currentDescUsage, _rtl865xC_QM_orgDescUsage,(currentDescUsage-_rtl865xC_QM_orgDescUsage));
+#else
+		;	/* do nothing */
+#endif
+		i++;
+	}
+#if defined (CONFIG_RTL_HW_QOS_DEBUG)
+	printk("2.[%s]:[%d].\n",__FUNCTION__,__LINE__);
+#endif
+#endif
+#else
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	int32	currentDescUsage;
+	int32	cnt, i;
+
+	#if defined(CONFIG_RTL_8196C)
+	while((READ_MEM32(LAGCR1)&OUTPUTQUEUE_STAT_MASK_CR1)!=OUTPUTQUEUE_STAT_MASK_CR1);
+	#elif defined(CONFIG_RTL_8198C)	|| defined(CONFIG_RTL_8197F)
+	while( ((READ_MEM32(LAGCR1)&OUTPUTQUEUE_STAT_MASK_CR1)^OUTPUTQUEUE_STAT_MASK_CR1) ||
+		((READ_MEM32(LAGCR2)&OUTPUTQUEUE_STAT_MASK_CR2)^OUTPUTQUEUE_STAT_MASK_CR2) );
+	#else
+	while ( ((READ_MEM32(LAGCR0)&OUTPUTQUEUE_STAT_MASK_CR0)^OUTPUTQUEUE_STAT_MASK_CR0) ||
+		((READ_MEM32(LAGCR1)&OUTPUTQUEUE_STAT_MASK_CR1)^OUTPUTQUEUE_STAT_MASK_CR1) );
+	#endif
+
+	/*	There are something wrong when check the input queue is empty or not	*/
+	currentDescUsage = (READ_MEM32( GDSR0 ) & USEDDSC_MASK) >> USEDDSC_OFFSET;
+	cnt = (currentDescUsage-_rtl865xC_QM_orgDescUsage)<<10;
+	//printk("currentDescUsage:%d,_rtl865xC_QM_orgDescUsage:%d,[%s]:[%d].\n",currentDescUsage,_rtl865xC_QM_orgDescUsage,__FUNCTION__,__LINE__);
+	i = 0;
+	while ( ((currentDescUsage = ((READ_MEM32( GDSR0 ) & USEDDSC_MASK) >> USEDDSC_OFFSET)) > _rtl865xC_QM_orgDescUsage) && (i<cnt) )
+	{
+#if 0
+		extern int net_ratelimit(void);
+		if (net_ratelimit() && i<120)
+		rtlglue_printf("Waiting for input queue empty.  ==> currently used %d.\n", (currentDescUsage-_rtl865xC_QM_orgDescUsage));
+#else
+		;	/* do nothing */
+#endif
+		i++;
+	}
+#endif
+#endif
+	   return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_resetAsicOutputQueue | reset output queue
+@rvalue SUCCESS |
+@comm
+	When reset is done, all queue pointer will be reset to the initial base address.
+ */
+
+ int32 rtl8651_resetAsicOutputQueue(void)
+ {
+	#if !defined(CONFIG_RTD_1295_HWNAT)
+	uint32	i;
+	uint32	scr, pauseTicks;
+
+	WRITE_MEM32(QRR, 0x0);
+	#if defined(CONFIG_RTL_819XD) ||defined(CONFIG_RTL_8196E) ||defined(CONFIG_RTL_8198C) ||defined(CONFIG_RTL_8197F)
+	scr = (REG32(MACCR) & 0x00003000) >> 12;
+	switch( scr )
+	{
+		case 0: pauseTicks = 6250000; break;		//lexra clock 50Mhz
+		case 1: pauseTicks = 12500000; break;		//lexra clock 100Mhz
+		default:pauseTicks = 6250000; break;		//lexra clock 50Mhz
+	}
+	#else
+	scr = (REG32(SCCR) & 0x00000070) >> 4;
+	switch( scr )
+	{
+		case 0: pauseTicks = 12500000; break;
+		case 1: pauseTicks = 25000000; break;
+		case 2: pauseTicks = 31250000; break;
+		case 3: pauseTicks = 32500000; break;
+		case 4: pauseTicks = 33750000; break;
+		case 5: pauseTicks = 35000000; break;
+		case 6: pauseTicks = 36250000; break;
+		case 7: pauseTicks = 37500000; break;
+		default:pauseTicks = 25000000; break;
+
+	}
+	#endif
+	/* waiting 500ms */
+
+	pauseTicks = pauseTicks<<2;
+
+	for(i=pauseTicks;i>0;i--)
+	{
+		i = i;
+	}
+
+	WRITE_MEM32(QRR, 0x1);
+
+	for(i=pauseTicks;i>0;i--)
+	{
+		i = i;
+	}
+
+	WRITE_MEM32(QRR, 0x0);
+
+	#endif //!defined(CONFIG_RTD_1295_HWNAT)
+	return SUCCESS;
+ }
+
+
+/*
+ *	_rtl8651_syncToAsicEthernetBandwidthControl()
+ *
+ *	Sync SW bandwidth control () configuration to ASIC:
+ *
+ *
+ *		_rtl865xB_BandwidthCtrlPerPortConfiguration -----> Translate from RTL865xB Index to ACTUAL
+ *														 	 token count in RTL865xC
+ *																		|
+ *																---------
+ *																|
+ *		_rtl865xB_BandwidthCtrlMultiplier	---- Translate using         ---->*
+ *										 RTL865xB's mechanism		|
+ *																|
+ *											---------------------
+ *											|
+ *											-- > Actual Token count which need to set to ASIC.
+ *												 => Set it to ASIC if value in SW is different from ASIC.
+ *
+*/
+static void _rtl8651_syncToAsicEthernetBandwidthControl(void)
+{
+	uint32 port;
+	uint32 cfgTypeIdx;
+	int32 retval;
+
+	for ( port = 0 ; port < RTL8651_PORT_NUMBER ; port ++ )
+	{
+		for ( cfgTypeIdx = 0 ; cfgTypeIdx < _RTL865XB_BANDWIDTHCTRL_CFGTYPE ; cfgTypeIdx ++ )
+		{
+			uint32 currentSwBandwidthCtrlBasicSetting;
+			uint32 currentSwBandwidthCtrlMultiplier;
+			uint32 currentSwBandwidthCtrlSetting;
+			uint32 currentAsicBandwidthCtrlSetting;
+
+			/*
+				We would check for rate and _rtl865xB_BandwidthCtrlMultiplier for the rate-multiply.
+
+				In RTL865xB, the bits definition is as below.
+
+				SWTECR
+
+				bit 14(x8)		bit 15 (x4)		Result
+				=============================================
+				0				0				x1
+				0				1				x4
+				1				0				x8
+				1				1				x8
+			*/
+			if (_rtl865xB_BandwidthCtrlMultiplier & _RTL865XB_BANDWIDTHCTRL_X8)
+			{	/* case {b'10, b'11} */
+				currentSwBandwidthCtrlMultiplier = 8;
+			} else if ( _rtl865xB_BandwidthCtrlMultiplier & _RTL865XB_BANDWIDTHCTRL_X4)
+			{	/* case {b'01} */
+				currentSwBandwidthCtrlMultiplier = 4;
+			} else
+			{	/* case {b'00} */
+				currentSwBandwidthCtrlMultiplier = 1;
+			}
+
+			/* Calculate Current SW configuration : 0 : Full Rate */
+			/* Mix BASIC setting and Multiplier -> to get the ACTUAL bandwidth setting */
+
+			currentSwBandwidthCtrlBasicSetting = ((_rtl865xC_BandwidthCtrlNum[_rtl865xB_BandwidthCtrlPerPortConfiguration[port][cfgTypeIdx]])*(currentSwBandwidthCtrlMultiplier));
+			currentSwBandwidthCtrlSetting = (cfgTypeIdx == 0)?
+					/* Ingress */
+					(((currentSwBandwidthCtrlBasicSetting%RTL865XC_INGRESS_16KUNIT)<(RTL865XC_INGRESS_16KUNIT>>1))?(currentSwBandwidthCtrlBasicSetting/RTL865XC_INGRESS_16KUNIT):((currentSwBandwidthCtrlBasicSetting/RTL865XC_INGRESS_16KUNIT)+1)):
+					/* Egress */
+					(((currentSwBandwidthCtrlBasicSetting%RTL865XC_EGRESS_64KUNIT)<(RTL865XC_EGRESS_64KUNIT>>1))?(currentSwBandwidthCtrlBasicSetting/RTL865XC_EGRESS_64KUNIT):((currentSwBandwidthCtrlBasicSetting/RTL865XC_EGRESS_64KUNIT)+1));
+
+			/* Get Current ASIC configuration */
+			retval = (cfgTypeIdx == 0)?
+					/* Ingress */
+					(rtl8651_getAsicPortIngressBandwidth(	port,
+															&currentAsicBandwidthCtrlSetting)):
+					/* Egress */
+					(rtl8651_getAsicPortEgressBandwidth(		port,
+															&currentAsicBandwidthCtrlSetting));
+
+			if ( retval != SUCCESS )
+			{
+				assert(0);
+				goto out;
+			}
+			#if defined(CONFIG_RTL_8197F)
+				if((!( (currentSwBandwidthCtrlSetting) == 0 && (currentAsicBandwidthCtrlSetting == 0xfffff) ) /* for FULL Rate case */) ||
+				( currentSwBandwidthCtrlSetting != currentAsicBandwidthCtrlSetting ))
+				{
+					retval = (cfgTypeIdx == 0)?
+					/* Ingress */
+					(rtl8651_setAsicPortIngressBandwidth(	port,
+															(currentSwBandwidthCtrlSetting == 0)?
+																(0	/* For Ingress Bandwidth control, 0 means "disabled" */):
+																(currentSwBandwidthCtrlSetting))		):
+					/* Egress */
+					(rtl8651_setAsicPortEgressBandwidth(		port,
+															(currentSwBandwidthCtrlSetting == 0)?
+																(0xfffff	/* For Egress Bandwidth control, 0xfffff means "disabled" */):
+																(currentSwBandwidthCtrlSetting))		);
+					if ( retval != SUCCESS )
+					{
+						assert(0);
+						goto out;
+					}
+				}
+			#else
+			/* SYNC configuration to HW if the configuration is different */
+			if (	(!( (currentSwBandwidthCtrlSetting) == 0 && (currentAsicBandwidthCtrlSetting == 0x3fff) ) /* for FULL Rate case */) ||
+				( currentSwBandwidthCtrlSetting != currentAsicBandwidthCtrlSetting ))
+			{
+#if 0
+				if (cfgTypeIdx==0)
+				{
+					rtlglue_printf("set ingress bandwidth port %d, %d.\n", port, (currentSwBandwidthCtrlSetting == 0)?
+																(0	/* For Ingress Bandwidth control, 0 means "disabled" */):
+																(currentSwBandwidthCtrlSetting));
+				}
+				else
+				{
+					rtlglue_printf("set ingress bandwidth port %d, %d.\n", port, (currentSwBandwidthCtrlSetting == 0)?
+																(0x3fff	/* For Egress Bandwidth control, 0x3fff means "disabled" */):
+																(currentSwBandwidthCtrlSetting));
+				}
+#endif
+				retval = (cfgTypeIdx == 0)?
+					/* Ingress */
+					(rtl8651_setAsicPortIngressBandwidth(	port,
+															(currentSwBandwidthCtrlSetting == 0)?
+																(0	/* For Ingress Bandwidth control, 0 means "disabled" */):
+																(currentSwBandwidthCtrlSetting))		):
+					/* Egress */
+					(rtl8651_setAsicPortEgressBandwidth(		port,
+															(currentSwBandwidthCtrlSetting == 0)?
+																(0x3fff	/* For Egress Bandwidth control, 0x3fff means "disabled" */):
+																(currentSwBandwidthCtrlSetting))		);
+
+				if ( retval != SUCCESS )
+				{
+					assert(0);
+					goto out;
+				}
+			}
+			#endif
+		}
+	}
+out:
+	return;
+}
+
+
+/*
+@func int32 | rtl8651_setAsicEthernetBandwidthControl | set ASIC per-port total ingress bandwidth
+@parm uint32 | port | the port number
+@parm int8 | input | Ingress or egress control to <p port>
+@parm uint32 | rate | rate to set.
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+The <p rate> can be set to several different values:
+BW_FULL_RATE
+BW_128K
+BW_256K
+BW_512K
+BW_1M
+BW_2M
+BW_4M
+BW_8M
+
+Note: This function is backward compatible to RTL865xB.
+ */
+int32 rtl8651_setAsicEthernetBandwidthControl(uint32 port, int8 input, uint32 rate)
+{
+	uint32 *currentConfig_p;
+
+	if ( port >= RTL8651_PORT_NUMBER )
+	{
+		goto err;
+	}
+
+	switch ( rate )
+	{
+		case BW_FULL_RATE:
+		case BW_128K:
+		case BW_256K:
+		case BW_512K:
+		case BW_1M:
+		case BW_2M:
+		case BW_4M:
+		case BW_8M:
+			break;
+		default:
+			goto err;
+	}
+
+	currentConfig_p = &(_rtl865xB_BandwidthCtrlPerPortConfiguration[port][(input)?0 /* Ingress */:1 /* Egress */]);
+
+	/* We just need to re-config HW when it's updated */
+	if ( *currentConfig_p != rate )
+	{
+		/* Update configuration table */
+		*currentConfig_p = rate;
+
+		/* sync the configuration to ASIC */
+		_rtl8651_syncToAsicEthernetBandwidthControl();
+	}
+
+	return SUCCESS;
+err:
+	return FAILED;
+}
+
+
+int32 rtl8651_setAsicFlowControlRegister(uint32 port, uint32 enable)
+{
+	#if !defined(CONFIG_RTD_1295_HWNAT)
+	uint32 phyid, statCtrlReg4;
+
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+	/* phy id determination */
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+
+	/* Read */
+	rtl8651_getAsicEthernetPHYReg( phyid, 4, &statCtrlReg4 );
+
+	if ( enable && ( statCtrlReg4 & CAPABLE_PAUSE ) == 0 )
+	{
+		statCtrlReg4 |= CAPABLE_PAUSE;
+	}
+	else if ( enable == 0 && ( statCtrlReg4 & CAPABLE_PAUSE ) )
+	{
+		statCtrlReg4 &= ~CAPABLE_PAUSE;
+	}
+	else
+		return SUCCESS;	/* The configuration does not change. Do nothing. */
+
+	rtl8651_setAsicEthernetPHYReg( phyid, 4, statCtrlReg4 );
+
+	/* restart N-way. */
+	rtl8651_restartAsicEthernetPHYNway(port);
+	#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicFlowControlRegister(uint32 port, uint32 *enable)
+{
+	#if !defined(CONFIG_RTD_1295_HWNAT)
+	uint32 phyid, statCtrlReg4;
+
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+	/* phy id determination */
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+
+	/* Read */
+	rtl8651_getAsicEthernetPHYReg( phyid, 4, &statCtrlReg4 );
+
+	*enable = ( statCtrlReg4 & CAPABLE_PAUSE )? TRUE: FALSE;
+	#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_setAsicSystemInputFlowControlRegister | Set System input queue flow control register
+@parm uint32 | fcON		| Threshold for Flow control OFF
+@parm uint32 | fcOFF		| Threshold for Flow control ON
+@rvalue SUCCESS |
+@comm
+Set input-queue flow control threshold on RTL865xC platform.
+ */
+int32 rtl8651_setAsicSystemInputFlowControlRegister(uint32 fcON, uint32 fcOFF)
+{
+	/* Check the correctness */
+	if (	(fcON > ( IQ_DSC_FCON_MASK >> IQ_DSC_FCON_OFFSET )) ||
+	   	(fcOFF > ( IQ_DSC_FCOFF_MASK >> IQ_DSC_FCOFF_OFFSET ))	)
+	{
+		return FAILED;
+	}
+
+	/* Write the flow control threshold value into ASIC */
+	WRITE_MEM32(	IQFCTCR,
+			(	(READ_MEM32(IQFCTCR) & ~(IQ_DSC_FCON_MASK | IQ_DSC_FCOFF_MASK)) |
+				(fcON << IQ_DSC_FCON_OFFSET) |
+				(fcOFF << IQ_DSC_FCOFF_OFFSET))	);
+	return SUCCESS;
+}
+/*
+@func int32 | rtl8651_getAsicSystemInputFlowControlRegister | Get System input queue flow control register
+@parm uint32* | fcON		| pointer to get Threshold for Flow control OFF
+@parm uint32* | fcOFF		| pointer to get Threshold for Flow control ON
+@rvalue SUCCESS |
+@comm
+Set input-queue flow control threshold on RTL865xC platform.
+ */
+int32 rtl8651_getAsicSystemInputFlowControlRegister(uint32 *fcON, uint32 *fcOFF)
+{
+	uint32 iqfctcr;
+
+	iqfctcr = READ_MEM32( IQFCTCR );
+
+	if ( fcON )
+	{
+		*fcON = ( iqfctcr & IQ_DSC_FCON_MASK ) >> IQ_DSC_FCON_OFFSET;
+	}
+
+	if ( fcOFF )
+	{
+		*fcOFF = ( iqfctcr & IQ_DSC_FCOFF_MASK ) >> IQ_DSC_FCOFF_OFFSET;
+	}
+
+	return SUCCESS;
+}
+
+
+int32 rtl865xC_setAsicEthernetForceModeRegs(uint32 port, uint32 enForceMode, uint32 forceLink, uint32 forceSpeed, uint32 forceDuplex)
+{
+	uint32 offset = port * 4;
+	uint32 PCR = READ_MEM32( PCRP0 + offset );
+
+	if (rtl8651_tblAsicDrvPara.externalPHYProperty & RTL8651_TBLASIC_EXTPHYPROPERTY_PORT5_RTL8211B)
+	{
+		if ( port > RTL8651_MAC_NUMBER )
+		{
+			return FAILED;
+		}
+	} else
+	{
+		if ( port > RTL8651_PHY_NUMBER )
+		{
+			return FAILED;
+		}
+	}
+
+	PCR &= ~EnForceMode;
+	PCR &= ~ForceLink;
+	PCR &= ~ForceSpeedMask;
+	PCR &= ~ForceDuplex;
+
+	if ( enForceMode )
+	{
+		PCR |= EnForceMode;
+
+				//ForceMode with polling link status, disable Auto-Negotiation but polling phy's link status
+				PCR |= PollLinkStatus;
+
+		if ( forceLink )
+			PCR |= ForceLink;
+
+		if ( forceSpeed == 2 )
+			PCR |= ForceSpeed1000M;
+		else if ( forceSpeed == 1 )
+			PCR |= ForceSpeed100M;
+		else
+			PCR |= ForceSpeed10M;
+
+		if ( forceDuplex )
+			PCR |= ForceDuplex;
+	}
+	else {
+		PCR = (PCR & ~(PollLinkStatus)) | (ForceLink | AutoNegoSts_MASK);
+
+#ifdef CONFIG_RTL_8198C
+		/* user set force_1000M mode, we set auto-negotiation mode but disable 10/100M ability */
+		if (forceSpeed == 2 /*SPEED1000M*/) {
+			PCR = (PCR & ~(AutoNegoSts_MASK)) | (NwayAbility1000MF);
+		}
+#endif
+	}
+
+	WRITE_MEM32( PCRP0 + offset, PCR );
+	mdelay(10);
+	return SUCCESS;
+
+}
+
+
+#define	MULTICAST_STORM_CONTROL	1
+#define	BROADCAST_STORM_CONTROL	2
+#define RTL865XC_MAXALLOWED_BYTECOUNT	30360	/* Used for BSCR in RTL865xC. Means max allowable byte count for 10Mbps port */
+#if defined(CONFIG_RTL_8197F)
+#define UNKNOWN_UNICAST_STORM_CONTROL 1
+#define UNKNOWN_MULTICAST_SOTRM_CONTROL 2
+#define ARP_STORM_CONTROL 4
+#define DHCP_STORM_CONTROL 8
+#define IGMP_MLD_STORM_CONTROL 16
+#define UNKOWN_UNICAST_COUNTER 0
+#define UNKOWN_MULTICAST_COUNTER 1
+#define ARP_COUNTER 2
+#define DHCP_COUNTER 3
+#define IGMP_MLD_COUNTER 3
+#endif
+static int32 rtl865xC_setBrdcstStormCtrlRate(uint32 percentage)
+{
+	uint32 rate = RTL865XC_MAXALLOWED_BYTECOUNT * percentage / 100;
+
+	WRITE_MEM32( BSCR, rate );
+	return SUCCESS;
+}
+
+
+static int32 rtl8651_perPortStormControl(uint32 type, uint32 portNum, uint32 enable)
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t regAddress;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 regAddress;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 oldRegValue;
+	uint32 newRegValue;
+	uint32 totalExtPortNum=3;
+
+	if(portNum>=RTL8651_PORT_NUMBER + totalExtPortNum)
+	{
+		rtlglue_printf("wrong port number\n");
+		return FAILED;
+	}
+
+	regAddress=PCRP0 + portNum * 4;
+
+	oldRegValue=READ_MEM32(regAddress);
+
+	newRegValue=oldRegValue;
+
+	if((type & BROADCAST_STORM_CONTROL) !=0)
+	{
+		if(enable == TRUE)
+		{
+			newRegValue = newRegValue |ENBCSC |BCSC_ENBROADCAST;
+		}
+
+		if(enable==FALSE)
+		{
+			newRegValue = newRegValue & (~BCSC_ENBROADCAST);
+		}
+
+	}
+
+	if((type & MULTICAST_STORM_CONTROL) !=0)
+	{
+		if(enable == TRUE)
+		{
+			newRegValue = newRegValue | ENBCSC |BCSC_ENMULTICAST;
+		}
+
+		if(enable==FALSE)
+		{
+			newRegValue = newRegValue & (~BCSC_ENMULTICAST);
+		}
+
+	}
+
+	if((newRegValue & (BCSC_ENMULTICAST |BCSC_ENBROADCAST ))==0)
+	{
+		/*no needn't storm control*/
+		newRegValue = newRegValue & (~ENBCSC);
+	}
+
+	if(newRegValue!=oldRegValue)
+	{
+		WRITE_MEM32(regAddress, newRegValue);
+	}
+
+	TOGGLE_BIT_IN_REG_TWICE(regAddress,EnForceMode);
+
+	return SUCCESS;
+
+
+}
+
+int32 rtl865x_setStormControl(uint32 type,uint32 enable,uint32 percentage)
+{
+	uint32 port;
+	uint32 totalExtPortNum=3;
+	for ( port = 0; port < RTL8651_PORT_NUMBER + totalExtPortNum; port++ )
+	{
+		if(enable==TRUE)
+		{
+			/*speed unit Mbps*/
+			if(percentage>100)
+			{
+				rtl865xC_setBrdcstStormCtrlRate(100);
+			}
+			else
+			{
+				rtl865xC_setBrdcstStormCtrlRate(percentage);
+			}
+
+			rtl8651_perPortStormControl(type, port, TRUE);
+		}
+		else
+		{
+			rtl865xC_setBrdcstStormCtrlRate(100);
+			rtl8651_perPortStormControl(type, port, FALSE);
+
+		}
+
+	}
+
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_8197F)
+static int32 rtl865x_setExtendStormCtrlRate(uint32 type, uint32 percentage)
+{
+	uint32 counter;
+	uint32 port;
+	uint32 regData, data0;
+	uint32 minSpeed = PortStatusLinkSpeedReserved;
+	uint32 rate = RTL865XC_MAXALLOWED_BYTECOUNT * percentage / 100 / 4;		/* counter unit 4 bytes*/
+
+	for(port=0; port<RTL8651_PORT_NUMBER; port++){
+		regData = READ_MEM32(PSRP0+((port)<<2));
+		data0 = regData & PortStatusLinkUp;
+		if (data0){
+			data0 = (regData&PortStatusLinkSpeed_MASK)>>PortStatusLinkSpeed_OFFSET;
+			if(data0 < minSpeed)
+				minSpeed = data0;
+		}
+		else
+			continue;
+	}
+
+	/* counter timing unit & rate */
+	regData = READ_MEM32(EXTSTMCR3);
+	switch(type){
+		case UNKNOWN_UNICAST_STORM_CONTROL:
+			counter = 0;
+			regData |= (minSpeed<<TUSSCM0_OFFSET);
+			WRITE_MEM32(EXTSTMCR4, rate);
+			break;
+		case UNKNOWN_MULTICAST_SOTRM_CONTROL:
+			counter = 1;
+			regData |= (minSpeed<<TUSSCM1_OFFSET);
+			WRITE_MEM32(EXTSTMCR4, rate<<16);
+			break;
+		case ARP_STORM_CONTROL:
+			counter = 2;
+			regData |= (minSpeed<<TUSSCM2_OFFSET);
+			WRITE_MEM32(EXTSTMCR5, rate);
+			break;
+		case DHCP_STORM_CONTROL:
+			counter = 3;
+			regData |= (minSpeed<<TUSSCM3_OFFSET);
+			WRITE_MEM32(EXTSTMCR5, rate<<16);
+			break;
+		case IGMP_MLD_STORM_CONTROL:
+			counter = 3;
+			regData |= (minSpeed<<TUSSCM3_OFFSET);
+			WRITE_MEM32(EXTSTMCR5, rate<<16);
+			break;
+		default:
+			counter = 0;
+			break;
+	}
+
+	WRITE_MEM32(EXTSTMCR3, regData);
+	return SUCCESS;
+}
+static int32 rtl865x_setPerPortExtendStormControl(uint32 type, uint32 port,uint32 enable)
+{
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t regAddress;
+	#else //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 regAddress;
+	#endif //defined(CONFIG_RTD_1295_HWNAT)
+	uint32 oldRegValue;
+	uint32 newRegValue;
+	uint32 enCounterDrop = 0;
+	uint32 counter = 0;
+
+	if(port >= RTL8651_PORT_NUMBER)
+	{
+		rtlglue_printf("wrong port number\n");
+		return FAILED;
+	}
+
+	regAddress=EXTSTMCR0 + (port>>1)*4;
+	oldRegValue=READ_MEM32(regAddress);
+	newRegValue=oldRegValue;
+
+	enCounterDrop = READ_MEM32(EXTSTMCR3);
+
+	type = (port & 0x1)? (type << OPSCS_OFFSET): type;
+
+	if(enable==TRUE){
+		switch(type){
+			case UNKNOWN_UNICAST_STORM_CONTROL:
+				enCounterDrop |= ENDROPSC0;
+				counter = 0;
+				break;
+			case UNKNOWN_MULTICAST_SOTRM_CONTROL:
+				enCounterDrop |= ENDROPSC1;
+				counter = 1;
+				break;
+			case ARP_STORM_CONTROL:
+				enCounterDrop |= ENDROPSC2;
+				counter = 2;
+				break;
+			case DHCP_STORM_CONTROL:
+				enCounterDrop |= ENDROPSC3;
+				counter = 3;
+				break;
+			case IGMP_MLD_STORM_CONTROL:
+				enCounterDrop |= ENDROPSC3;
+				counter = 3;
+				break;
+			default:
+				break;
+		}
+
+		counter = (port & 0x1)? (counter << OPUUSC_OFFSET): (counter << EPUUSC_OFFSET);
+		newRegValue = newRegValue | type | counter;
+
+	}
+	else{
+		switch(type){
+			case UNKNOWN_UNICAST_STORM_CONTROL:
+				enCounterDrop &= ~ENDROPSC0;
+				counter = 0;
+				break;
+			case UNKNOWN_MULTICAST_SOTRM_CONTROL:
+				enCounterDrop &= ~ENDROPSC1;
+				counter = 1;
+				break;
+			case ARP_STORM_CONTROL:
+				enCounterDrop &= ~ENDROPSC2;
+				counter = 2;
+				break;
+			case DHCP_STORM_CONTROL:
+				enCounterDrop &= ~ENDROPSC3;
+				counter = 3;
+				break;
+			case IGMP_MLD_STORM_CONTROL:
+				enCounterDrop &= ~ENDROPSC3;
+				counter = 3;
+				break;
+			default:
+				break;
+		}
+
+		counter = (port & 0x1)? (counter << OPUUSC_OFFSET): (counter << EPUUSC_OFFSET);
+		newRegValue = newRegValue & ~type & ~counter;
+	}
+
+	WRITE_MEM32(EXTSTMCR3, enCounterDrop);
+
+	if(newRegValue!=oldRegValue)
+	{
+		WRITE_MEM32(regAddress, newRegValue);
+	}
+
+	return SUCCESS;
+}
+int32 rtl865x_setExtendStormControl(uint32 type,uint32 enable,uint32 percentage)
+{
+	uint32 port;
+
+	if(enable==TRUE)
+	{
+		/*speed unit Mbps*/
+		if(percentage>100)
+		{
+			rtl865x_setExtendStormCtrlRate(type, 100);
+		}
+		else
+		{
+			rtl865x_setExtendStormCtrlRate(type, percentage);
+		}
+
+		for(port=0; port<RTL8651_PORT_NUMBER; port++)
+			rtl865x_setPerPortExtendStormControl(type, port, TRUE);
+	}
+	else
+	{
+		rtl865x_setExtendStormCtrlRate(type, 100);
+
+		for(port=0; port<RTL8651_PORT_NUMBER; port++)
+			rtl865x_setPerPortExtendStormControl(type, port, FALSE);
+
+	}
+
+	return SUCCESS;
+}
+
+#endif
+
+
+/*
+@func int32 | rtl8651_setAsic802D1xMacBaseAbility | set 802.1x mac based ability
+@parm enum PORTID | port | the port number (physical port: 0~5, extension port: 6~8)
+@parm uint32* | isEnable | 1: enabled, 0: disabled.
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsic802D1xMacBaseAbility( enum PORTID port, uint32 isEnable )
+{
+	/* Invalid input parameter */
+	if ((port < PHY0) || (port > EXT2))
+		return FAILED;
+
+	/* Invalid input parameter */
+	if ((isEnable != TRUE) && (isEnable != FALSE))
+		return FAILED;
+
+	switch (port)
+	{
+		case PHY0:
+		WRITE_MEM32(DOT1XMACCR, isEnable == TRUE ? (READ_MEM32(DOT1XMACCR) | ( Dot1xMAC_P0En)):
+											(READ_MEM32(DOT1XMACCR) & ~( Dot1xMAC_P0En)));
+			break;
+
+		case PHY1:
+		WRITE_MEM32(DOT1XMACCR, isEnable == TRUE ? (READ_MEM32(DOT1XMACCR) | ( Dot1xMAC_P1En)):
+											(READ_MEM32(DOT1XMACCR) & ~( Dot1xMAC_P1En)));
+			break;
+
+		case PHY2:
+		WRITE_MEM32(DOT1XMACCR, isEnable == TRUE ? (READ_MEM32(DOT1XMACCR) | ( Dot1xMAC_P2En)):
+											(READ_MEM32(DOT1XMACCR) & ~( Dot1xMAC_P2En)));
+			break;
+
+		case PHY3:
+		WRITE_MEM32(DOT1XMACCR, isEnable == TRUE ? (READ_MEM32(DOT1XMACCR) | ( Dot1xMAC_P3En)):
+											(READ_MEM32(DOT1XMACCR) & ~( Dot1xMAC_P3En)));
+			break;
+
+		case PHY4:
+		WRITE_MEM32(DOT1XMACCR, isEnable == TRUE ? (READ_MEM32(DOT1XMACCR) | ( Dot1xMAC_P4En)):
+											(READ_MEM32(DOT1XMACCR) & ~( Dot1xMAC_P4En)));
+			break;
+
+		case PHY5:
+		WRITE_MEM32(DOT1XMACCR, isEnable == TRUE ? (READ_MEM32(DOT1XMACCR) | ( Dot1xMAC_P5En)):
+											(READ_MEM32(DOT1XMACCR) & ~( Dot1xMAC_P5En)));
+			break;
+
+		case CPU:
+		WRITE_MEM32(DOT1XMACCR, isEnable == TRUE ? (READ_MEM32(DOT1XMACCR) | ( Dot1xMAC_P6En)):
+											(READ_MEM32(DOT1XMACCR) & ~( Dot1xMAC_P6En)));
+			break;
+
+		case EXT1:
+		WRITE_MEM32(DOT1XMACCR, isEnable == TRUE ? (READ_MEM32(DOT1XMACCR) | ( Dot1xMAC_P7En)):
+											(READ_MEM32(DOT1XMACCR) & ~( Dot1xMAC_P7En)));
+			break;
+
+		case EXT2:
+		WRITE_MEM32(DOT1XMACCR, isEnable == TRUE ? (READ_MEM32(DOT1XMACCR) | ( Dot1xMAC_P8En)):
+											(READ_MEM32(DOT1XMACCR) & ~( Dot1xMAC_P8En)));
+			break;
+
+		case EXT3:
+			return FAILED;
+
+		case MULTEXT:
+			return FAILED;
+
+	}
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_setAsic802D1xMacBaseDirection | set 802.1x mac based direction
+@parm enum uint32 | dir | OperCOnntrolledDirections for MAC-Based ACCESS Control. 0:BOTH, 1:IN
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsic802D1xMacBaseDirection(int32 dir)
+{
+
+
+	/* Invalid input parameter */
+	if ((dir != Dot1xMAC_OPDIR_IN) && (dir != Dot1xMAC_OPDIR_BOTH))
+	{
+		return FAILED;
+	}
+
+	if(dir == Dot1xMAC_OPDIR_IN)
+	{
+		WRITE_MEM32(DOT1XMACCR,(READ_MEM32(DOT1XMACCR)) |Dot1xMAC_OPDIR);
+	}
+	else
+	{
+		WRITE_MEM32(DOT1XMACCR,(READ_MEM32(DOT1XMACCR)) &(~Dot1xMAC_OPDIR));
+	}
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_setAsicGuestVlanProcessControl | set guest vlan process control
+@parm enum  uint32 | process |default process for unauthenticated client  (00~11)<<12
+@rvalue SUCCESS
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicGuestVlanProcessControl( uint32 process)
+{
+	/* Invalid input parameter */
+	if((process < Dot1xUNAUTHBH_DROP) || (process > Dot1xUNAUTHBH_RESERVED))
+		return FAILED;
+
+	WRITE_MEM32(GVGCR, ((READ_MEM32(GVGCR)) & 0x0fff) | process);
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_setAsicDot1qAbsolutelyPriority | set 802.1Q absolutely priority
+@parm enum PRIORITYVALUE | srcpriority | priority value
+@parm enum PRIORITYVALUE | priority | absolute priority value
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicDot1qAbsolutelyPriority( enum PRIORITYVALUE srcpriority, enum PRIORITYVALUE priority )
+{
+	/* Invalid input parameter */
+	if ((srcpriority < PRI0) || (srcpriority > PRI7) || (priority < PRI0) || (priority > PRI7))
+		return FAILED;
+
+	switch (srcpriority)
+	{
+		case PRI0:
+			WRITE_MEM32(LPTM8021Q, (READ_MEM32(LPTM8021Q) & ~(EN_8021Q2LTMPRI0_MASK)) | (priority << EN_8021Q2LTMPRI0)); break;
+		case PRI1:
+			WRITE_MEM32(LPTM8021Q, (READ_MEM32(LPTM8021Q) & ~(EN_8021Q2LTMPRI1_MASK)) | (priority << EN_8021Q2LTMPRI1)); break;
+		case PRI2:
+			WRITE_MEM32(LPTM8021Q, (READ_MEM32(LPTM8021Q) & ~(EN_8021Q2LTMPRI2_MASK)) | (priority << EN_8021Q2LTMPRI2)); break;
+		case PRI3:
+			WRITE_MEM32(LPTM8021Q, (READ_MEM32(LPTM8021Q) & ~(EN_8021Q2LTMPRI3_MASK)) | (priority << EN_8021Q2LTMPRI3)); break;
+		case PRI4:
+			WRITE_MEM32(LPTM8021Q, (READ_MEM32(LPTM8021Q) & ~(EN_8021Q2LTMPRI4_MASK)) | (priority << EN_8021Q2LTMPRI4)); break;
+		case PRI5:
+			WRITE_MEM32(LPTM8021Q, (READ_MEM32(LPTM8021Q) & ~(EN_8021Q2LTMPRI5_MASK)) | (priority << EN_8021Q2LTMPRI5)); break;
+		case PRI6:
+			WRITE_MEM32(LPTM8021Q, (READ_MEM32(LPTM8021Q) & ~(EN_8021Q2LTMPRI6_MASK)) | (priority << EN_8021Q2LTMPRI6)); break;
+		case PRI7:
+			WRITE_MEM32(LPTM8021Q, (READ_MEM32(LPTM8021Q) & ~(EN_8021Q2LTMPRI7_MASK)) | (priority << EN_8021Q2LTMPRI7)); break;
+	}
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | rtl8651_getAsicDot1qAbsolutelyPriority | get 802.1Q absolutely priority
+@parm enum PRIORITYVALUE | srcpriority | priority value
+@parm enum PRIORITYVALUE* | pPriority | pPriority will return the absolute priority value
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_getAsicDot1qAbsolutelyPriority( enum PRIORITYVALUE srcpriority, enum PRIORITYVALUE *pPriority )
+{
+
+	/* Invalid input parameter */
+	if ((srcpriority < PRI0) || (srcpriority > PRI7))
+		return FAILED;
+
+	if (pPriority != NULL)
+	{
+		switch (srcpriority)
+		{
+			case PRI0:
+				*pPriority = (READ_MEM32(LPTM8021Q) & EN_8021Q2LTMPRI0_MASK) >> EN_8021Q2LTMPRI0;  break;
+			case PRI1:
+				*pPriority = (READ_MEM32(LPTM8021Q) & EN_8021Q2LTMPRI1_MASK) >> EN_8021Q2LTMPRI1;  break;
+			case PRI2:
+				*pPriority = (READ_MEM32(LPTM8021Q) & EN_8021Q2LTMPRI2_MASK) >> EN_8021Q2LTMPRI2;  break;
+			case PRI3:
+				*pPriority = (READ_MEM32(LPTM8021Q) & EN_8021Q2LTMPRI3_MASK) >> EN_8021Q2LTMPRI3;  break;
+			case PRI4:
+				*pPriority = (READ_MEM32(LPTM8021Q) & EN_8021Q2LTMPRI4_MASK) >> EN_8021Q2LTMPRI4;  break;
+			case PRI5:
+				*pPriority = (READ_MEM32(LPTM8021Q) & EN_8021Q2LTMPRI5_MASK) >> EN_8021Q2LTMPRI5;  break;
+			case PRI6:
+				*pPriority = (READ_MEM32(LPTM8021Q) & EN_8021Q2LTMPRI6_MASK) >> EN_8021Q2LTMPRI6;  break;
+			case PRI7:
+				*pPriority = (READ_MEM32(LPTM8021Q) & EN_8021Q2LTMPRI7_MASK) >> EN_8021Q2LTMPRI7;  break;
+		}
+	}
+
+	return SUCCESS;
+}
+
+
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+
+/*
+@func int32 | rtl8651_flushAsicDot1qAbsolutelyPriority | set 802.1Q absolutely priority the default value 0
+@parm void
+@rvalue SUCCESS |
+@comm
+ */
+int32 rtl8651_flushAsicDot1qAbsolutelyPriority(void)
+{
+	WRITE_MEM32(LPTM8021Q, 0);
+	return SUCCESS;
+}
+#else
+int32 rtl851_setDefaultAsicDot1qAbsolutelyPriority(void)
+{
+	//default 802.1p -> queue prio: 0->0, 1->1, 2->2...
+	WRITE_MEM32(LPTM8021Q, 0xFAC688);
+	return SUCCESS;
+}
+#endif
+
+#ifdef CONFIG_RTL_LINKCHG_PROCESS
+/*
+@func int32 | rtl8651_updateAsicLinkAggregatorLMPR | Arrange the table which maps hashed index to port.
+@parm	uint32	|	portMask |  Specify the port mask for the aggregator.
+@rvalue SUCCESS | Update the mapping table successfully.
+@rvalue FAILED | When the port mask is invalid, return FAILED
+@comm
+RTL865x provides an aggregator port. This API updates the table which maps hashed index to port.
+If portmask = 0: clear all aggregation port mappings.
+Rearrange policy is round-robin. ie. if port a,b,c is in portmask, then hash block 0~7's port number is a,b,c,a,b,c,a,b
+*/
+int32  rtl8651_updateAsicLinkAggregatorLMPR(int32 portmask)
+{
+	uint32 hIdx, portIdx, reg;
+
+	/* Clear all mappings */
+	WRITE_MEM32( LAGHPMR0, 0 );
+
+	if ( portmask == 0 )
+	{
+		return SUCCESS;
+	}
+
+	reg = 0;
+	portIdx = 0;
+	for ( hIdx = 0; hIdx < RTL865XC_LAGHASHIDX_NUMBER; hIdx++ )
+	{
+		while ( ( ( 1 << portIdx ) & portmask ) == 0 )	/* Don't worry about infinite loop because portmask won't be 0. */
+		{
+			portIdx = ( portIdx + 1 ) % ( RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum );
+		}
+
+		reg |= ( portIdx << ( hIdx * LAG_HASHIDX_BITNUM ) );
+		portIdx = ( portIdx + 1 ) % ( RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum );
+	}
+
+	WRITE_MEM32( LAGHPMR0, reg );
+	return SUCCESS;
+}
+
+
+
+#if 0
+static uint32 _rtl8651_findAsicLinkupPortmask(uint32 portMask)
+{
+	uint32 port, lnkUp_portMask = portMask;
+	for ( port = 0; port < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; port++ )
+	{
+		if ( ( portMask & ( 1 << port ) ) && (rtl8651AsicEthernetTable[port].linkUp == FALSE) )
+		{
+			lnkUp_portMask &= ~( 1 << port );
+		}
+	}
+	return lnkUp_portMask;
+}
+#endif
+
+int32 rtl8651_setAsicEthernetLinkStatus(uint32 port, int8 linkUp)
+{
+	int8 notify;
+//	uint32 portmask;
+
+	if (port >= (RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum))
+	{
+		return FAILED;
+	}
+
+	notify = (rtl8651AsicEthernetTable[port].linkUp != ((linkUp==TRUE)? TRUE: FALSE))?TRUE:FALSE;
+
+
+	rtl8651AsicEthernetTable[port].linkUp = (linkUp == TRUE)? TRUE: FALSE;
+
+#if 0
+	/*
+		If the specified port is a member of the aggregator,
+		update the table which maps hashed index to the port
+		because the member port of the aggregator link changes.
+	*/
+	portmask = READ_MEM32( LAGCR0 ) & TRUNKMASK_MASK;
+	if ( portmask & ( 1 << port ) )
+	{
+		/* Find the link-up portmask */
+		uint32 lnkUp_portMask = _rtl8651_findAsicLinkupPortmask(portmask);
+		rtl8651_updateAsicLinkAggregatorLMPR( lnkUp_portMask );
+	}
+#endif
+
+	return SUCCESS;
+}
+#endif
+
+#if defined (CONFIG_RTL_ENABLE_RATELIMIT_TABLE)
+int32 rtl8651_setAsicRateLimitTable(uint32 index, rtl865x_tblAsicDrv_rateLimitParam_t *rateLimit_t)
+{
+	rtl8651_tblAsic_rateLimitTable_t entry;
+
+	if (rateLimit_t == NULL || index >= RTL8651_RATELIMITTBL_SIZE)
+		return FAILED;
+	memset(&entry,0,sizeof(rtl8651_tblAsic_rateLimitTable_t));
+	entry.maxToken				= rateLimit_t->maxToken&0xFFFFFF;
+	entry.refill				= rateLimit_t->refill_number&0xFFFFFF;
+	entry.refillTime			= rateLimit_t->t_intervalUnit&0x3F;
+	entry.refillRemainTime		= rateLimit_t->t_remainUnit&0x3F;
+	entry.token					= rateLimit_t->token&0xFFFFFF;
+	return _rtl8651_forceAddAsicEntry(TYPE_RATE_LIMIT_TABLE, index, &entry);
+}
+
+
+int32 rtl8651_delAsicRateLimitTable(uint32 index)
+{
+	rtl8651_tblAsic_rateLimitTable_t entry;
+
+	if (index >= RTL8651_RATELIMITTBL_SIZE)
+		return FAILED;
+	memset(&entry,0,sizeof(rtl8651_tblAsic_rateLimitTable_t));
+	return _rtl8651_forceAddAsicEntry(TYPE_RATE_LIMIT_TABLE, index, &entry);
+}
+
+
+int32 rtl8651_getAsicRateLimitTable(uint32 index, rtl865x_tblAsicDrv_rateLimitParam_t *rateLimit_t)
+{
+	rtl8651_tblAsic_rateLimitTable_t entry;
+
+	if (rateLimit_t == NULL || index >= RTL8651_RATELIMITTBL_SIZE)
+		return FAILED;
+	_rtl8651_readAsicEntry(TYPE_RATE_LIMIT_TABLE, index, &entry);
+	if (entry.refillTime == 0)
+		return FAILED;
+	rateLimit_t->token			= entry.token & 0xFFFFFF;
+	rateLimit_t->maxToken		= entry.maxToken & 0xFFFFFF;
+	rateLimit_t->t_remainUnit = entry.refillRemainTime&0x3F;
+	rateLimit_t->t_intervalUnit = entry.refillTime&0x3F;
+	rateLimit_t->refill_number	= entry.refill&0xFFFFFF;
+	return SUCCESS;
+}
+#endif
+
+
+int32 rtl8651_setPortFlowControlConfigureRegister(enum PORTID port,uint32 enable)
+{
+	int enable_port = 0;
+	if(enable)
+		enable_port = 0x3f;
+
+	switch (port)
+	{
+		case PHY0:
+			WRITE_MEM32(FCCR0, (READ_MEM32(FCCR0) & ~(0x3F<<Q_P0_EN_FC_OFFSET)) | (enable_port << Q_P0_EN_FC_OFFSET));  break;
+		case PHY1:
+			WRITE_MEM32(FCCR0, (READ_MEM32(FCCR0) & ~(0x3F<<Q_P1_EN_FC_OFFSET)) | (enable_port << Q_P1_EN_FC_OFFSET));  break;
+		case PHY2:
+			WRITE_MEM32(FCCR0, (READ_MEM32(FCCR0) & ~(0x3F<<Q_P2_EN_FC_OFFSET)) | (enable_port << Q_P2_EN_FC_OFFSET));  break;
+		case PHY3:
+			WRITE_MEM32(FCCR0, (READ_MEM32(FCCR0) & ~(0x3F<<Q_P3_EN_FC_OFFSET)) | (enable_port << Q_P3_EN_FC_OFFSET));  break;
+		case PHY4:
+			WRITE_MEM32(FCCR1, (READ_MEM32(FCCR1) & ~(0x3F<<Q_P4_EN_FC_OFFSET)) | (enable_port << Q_P4_EN_FC_OFFSET));  break;
+		case PHY5:
+			WRITE_MEM32(FCCR1, (READ_MEM32(FCCR1) & ~(0x3F<<Q_P5_EN_FC_OFFSET)) | (enable_port << Q_P5_EN_FC_OFFSET));  break;
+		case CPU:
+			WRITE_MEM32(FCCR1, (READ_MEM32(FCCR1) & ~(0x1<<Q_P6_EN_FC_OFFSET)) | (enable_port << Q_P6_EN_FC_OFFSET));  break;
+		default:
+			return FAILED;
+	}
+
+	return SUCCESS;
+}
+/*
+@func int32 | rtl8651_setAsicPortPriority | set port based priority
+@parm enum PORTID | port | the port number (valid: physical ports(0~5) and extension ports(7~9) )
+@parm enum PRIORITYVALUE | priority | priority value.
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_setAsicPortPriority( enum PORTID port, enum PRIORITYVALUE priority )
+{
+	/* Invalid input parameter */
+	if ((priority < PRI0) || (priority > PRI7))
+		return FAILED;
+
+	switch (port)
+	{
+		case PHY0:
+			WRITE_MEM32(PBPCR, (READ_MEM32(PBPCR) & ~(PBPRI_P0_MASK)) | (priority << PBPRI_P0_OFFSET)); break;
+		case PHY1:
+			WRITE_MEM32(PBPCR, (READ_MEM32(PBPCR) & ~(PBPRI_P1_MASK)) | (priority << PBPRI_P1_OFFSET)); break;
+		case PHY2:
+			WRITE_MEM32(PBPCR, (READ_MEM32(PBPCR) & ~(PBPRI_P2_MASK)) | (priority << PBPRI_P2_OFFSET)); break;
+		case PHY3:
+			WRITE_MEM32(PBPCR, (READ_MEM32(PBPCR) & ~(PBPRI_P3_MASK)) | (priority << PBPRI_P3_OFFSET)); break;
+		case PHY4:
+			WRITE_MEM32(PBPCR, (READ_MEM32(PBPCR) & ~(PBPRI_P4_MASK)) | (priority << PBPRI_P4_OFFSET)); break;
+		case PHY5:
+			WRITE_MEM32(PBPCR, (READ_MEM32(PBPCR) & ~(PBPRI_P5_MASK)) | (priority << PBPRI_P5_OFFSET)); break;
+		case EXT1:
+			WRITE_MEM32(PBPCR, (READ_MEM32(PBPCR) & ~(PBPRI_P6_MASK)) | (priority << PBPRI_P6_OFFSET)); break;
+		case EXT2:
+			WRITE_MEM32(PBPCR, (READ_MEM32(PBPCR) & ~(PBPRI_P7_MASK)) | (priority << PBPRI_P7_OFFSET)); break;
+		case EXT3:
+			WRITE_MEM32(PBPCR, (READ_MEM32(PBPCR) & ~(PBPRI_P8_MASK)) | (priority << PBPRI_P8_OFFSET)); break;
+		case CPU: /* fall thru */
+		default:
+			return FAILED;
+	}
+
+	return SUCCESS;
+}
+/*
+@func int32 | rtl8651_getAsicPortPriority | get port based priority
+@parm enum PORTID | port | the port number (valid: physical ports(0~5) and extension ports(7~9) )
+@parm enum PRIORITYVALUE* | pPriority | pPriority will return the priority of the specified port.
+@rvalue SUCCESS |
+@rvalue FAILED | invalid parameter
+@comm
+ */
+int32 rtl8651_getAsicPortPriority( enum PORTID port, enum PRIORITYVALUE *pPriority )
+{
+		if (pPriority != NULL)
+		{
+				switch (port)
+				{
+						case PHY0:
+								*pPriority = (READ_MEM32(PBPCR) & PBPRI_P0_MASK) >> PBPRI_P0_OFFSET;  break;
+						case PHY1:
+								*pPriority = (READ_MEM32(PBPCR) & PBPRI_P1_MASK) >> PBPRI_P1_OFFSET;  break;
+						case PHY2:
+								*pPriority = (READ_MEM32(PBPCR) & PBPRI_P2_MASK) >> PBPRI_P2_OFFSET;  break;
+						case PHY3:
+								*pPriority = (READ_MEM32(PBPCR) & PBPRI_P3_MASK) >> PBPRI_P3_OFFSET;  break;
+						case PHY4:
+								*pPriority = (READ_MEM32(PBPCR) & PBPRI_P4_MASK) >> PBPRI_P4_OFFSET;  break;
+						case PHY5:
+								*pPriority = (READ_MEM32(PBPCR) & PBPRI_P5_MASK) >> PBPRI_P5_OFFSET;  break;
+						case EXT1:
+								*pPriority = (READ_MEM32(PBPCR) & PBPRI_P6_MASK) >> PBPRI_P6_OFFSET;  break;
+						case EXT2:
+								*pPriority = (READ_MEM32(PBPCR) & PBPRI_P7_MASK) >> PBPRI_P7_OFFSET;  break;
+						case EXT3:
+								*pPriority = (READ_MEM32(PBPCR) & PBPRI_P8_MASK) >> PBPRI_P8_OFFSET;  break;
+						case CPU: /* fall thru */
+						default:
+								return FAILED;
+				}
+		}
+
+		return SUCCESS;
+}
+
+/*
+ * @func int32 | rtl8651_setAsicDscpPriority | set DSCP-based priority
+ * @parm uint32 | dscp | DSCP value
+ * @parm enum PRIORITYVALUE | priority | priority value
+ * @rvalue SUCCESS |
+ * @rvalue FAILED | invalid parameter
+ * @comm
+ *  */
+int32 rtl8651_setAsicDscpPriority( uint32 dscp, enum PRIORITYVALUE priority )
+{
+	/* Invalid input parameter */
+	if ((dscp < 0) || (dscp > 63))
+		return FAILED;
+	if ((priority < PRI0) || (priority > PRI7))
+		return FAILED;
+
+	if ((0 <= dscp) && (dscp <= 9))
+		WRITE_MEM32(DSCPCR0, (READ_MEM32(DSCPCR0) & ~(0x7 << (dscp*3))) | (priority << (dscp*3)));
+	else if ((10 <= dscp) && (dscp <= 19))
+		WRITE_MEM32(DSCPCR1, (READ_MEM32(DSCPCR1) & ~(0x7 << ((dscp%10)*3))) | (priority << ((dscp%10)*3)));
+	else if ((20 <= dscp) && (dscp <= 29))
+		WRITE_MEM32(DSCPCR2, (READ_MEM32(DSCPCR2) & ~(0x7 << ((dscp%10)*3))) | (priority << ((dscp%10)*3)));
+	else if ((30 <= dscp) && (dscp <= 39))
+		WRITE_MEM32(DSCPCR3, (READ_MEM32(DSCPCR3) & ~(0x7 << ((dscp%10)*3))) | (priority << ((dscp%10)*3)));
+	else if ((40 <= dscp) && (dscp <= 49))
+		WRITE_MEM32(DSCPCR4, (READ_MEM32(DSCPCR4) & ~(0x7 << ((dscp%10)*3))) | (priority << ((dscp%10)*3)));
+	else if ((50 <= dscp) && (dscp <= 59))
+		WRITE_MEM32(DSCPCR5, (READ_MEM32(DSCPCR5) & ~(0x7 << ((dscp%10)*3))) | (priority << ((dscp%10)*3)));
+	else if ((60 <= dscp) && (dscp <= 63))
+		WRITE_MEM32(DSCPCR6, (READ_MEM32(DSCPCR6) & ~(0x7 << ((dscp%10)*3))) | (priority << ((dscp%10)*3)));
+
+	return SUCCESS;
+}
+
+
+/*
+ * @func int32 | rtl8651_setAsicDscpPriority | set DSCP-based priority
+ * @parm uint32 | dscp | DSCP value
+ * @parm enum PRIORITYVALUE* | pPriority | pPriority will return the priority of the specified DSCP
+ * @rvalue SUCCESS |
+ * @rvalue FAILED | invalid parameter
+ * @comm
+ *  */
+int32 rtl8651_getAsicDscpPriority( uint32 dscp, enum PRIORITYVALUE *pPriority )
+{
+	/* Invalid input parameter */
+	if ((dscp < 0) || (dscp > 63))
+		return FAILED;
+
+	if (pPriority != NULL)
+	{
+		if ((0 <= dscp) && (dscp <= 9))
+			*pPriority = (READ_MEM32(DSCPCR0) & (0x7 << (dscp*3))) >> (dscp*3);
+		else if ((10 <= dscp) && (dscp <= 19))
+			*pPriority = (READ_MEM32(DSCPCR1) & (0x7 << ((dscp%10)*3))) >> ((dscp%10)*3);
+		else if ((20 <= dscp) && (dscp <= 29))
+			*pPriority = (READ_MEM32(DSCPCR2) & (0x7 << ((dscp%10)*3))) >> ((dscp%10)*3);
+		else if ((30 <= dscp) && (dscp <= 39))
+			*pPriority = (READ_MEM32(DSCPCR3) & (0x7 << ((dscp%10)*3))) >> ((dscp%10)*3);
+		else if ((40 <= dscp) && (dscp <= 49))
+			*pPriority = (READ_MEM32(DSCPCR4) & (0x7 << ((dscp%10)*3))) >> ((dscp%10)*3);
+		else if ((50 <= dscp) && (dscp <= 59))
+			*pPriority = (READ_MEM32(DSCPCR5) & (0x7 << ((dscp%10)*3))) >> ((dscp%10)*3);
+		else if ((60 <= dscp) && (dscp <= 63))
+			*pPriority = (READ_MEM32(DSCPCR6) & (0x7 << ((dscp%10)*3))) >> ((dscp%10)*3);
+	}
+
+	return SUCCESS;
+}
+
+#ifdef CONFIG_RTK_VOIP_QOS
+
+int32 rtl8651_reset_dscp_priority(void)
+{
+	//clear dscp priority assignment, otherwise pkt with dscp value 0 will be assign priority 1
+	WRITE_MEM32(DSCPCR0,0);
+	WRITE_MEM32(DSCPCR1,0);
+	WRITE_MEM32(DSCPCR2,0);
+	WRITE_MEM32(DSCPCR3,0);
+	WRITE_MEM32(DSCPCR4,0);
+	WRITE_MEM32(DSCPCR5,0);
+	WRITE_MEM32(DSCPCR6,0);
+	return 0;
+}
+int32 rtl8651_cpu_tx_fc(int enable)
+{
+		if(enable)
+				REG32(PSRP6_RW) |= 0x40;
+		else
+				REG32(PSRP6_RW) &= 0xffffffbf;
+		return 0;
+}
+int32 rtl8651_setQueueNumber(int port, int qnum)
+{
+		rtl865xC_lockSWCore();
+		rtl8651_setAsicOutputQueueNumber(port, qnum);
+		rtl865xC_waitForOutputQueueEmpty();
+		rtl8651_resetAsicOutputQueue();
+		rtl865xC_unLockSWCore();
+		return SUCCESS;
+}
+#endif
+#ifdef CONFIG_RTK_VOIP_PORT_LINK
+int rtl8651_getAsicEthernetLinkStatus(uint32 port, int8 *linkUp)
+{
+
+		int status = READ_MEM32( PSRP0 + port * 4 );
+
+		if(status & PortStatusLinkUp)
+				*linkUp = TRUE;
+		else
+				*linkUp = FALSE;
+
+
+	return SUCCESS;
+}
+#endif
+
+#if 1//defined(CONFIG_RTL_LINK_AGGREGATION)
+int32 rtl8651_setLAHashIndexToPortMapping( uint32 hash_index, uint32 port_num)
+{
+	uint32 reg = 0;
+
+	if ((hash_index >= RTL865XC_LAGHASHIDX_NUMBER) || (port_num >=RTL8651_AGGREGATOR_NUMBER)){
+		return FAILED;
+	}
+
+	reg = READ_MEM32(LAGHPMR0);
+	reg &= ~(0xf << (hash_index * LAG_HASHIDX_BITNUM));
+	reg |= (port_num << (hash_index * LAG_HASHIDX_BITNUM));
+	//panic_printk("%s %d reg=0x%x port_num=%u hash_index=%u \n", __FUNCTION__, __LINE__, reg, port_num, hash_index);
+	WRITE_MEM32(LAGHPMR0, reg);
+
+	return SUCCESS;
+}
+int32 rtl8651_getLAHashIndexToPortMapping( uint32 hash_index, uint32 *port_num)
+{
+	uint32 reg = 0;
+
+	if ((hash_index >= RTL865XC_LAGHASHIDX_NUMBER) || (!port_num)){
+		return FAILED;
+	}
+
+	reg = READ_MEM32(LAGHPMR0);
+	*port_num = (reg >> (hash_index * LAG_HASHIDX_BITNUM)) & 0xf;
+	//panic_printk("%s %d reg=0x%x *port_num=%u hash_index=%u \n", __FUNCTION__, __LINE__, reg, *port_num, hash_index);
+
+	return SUCCESS;
+}
+
+
+int32 rtl8651_setLATrunkMask(uint32 trunk_mask)
+{
+	uint32 reg = 0;
+
+	reg = READ_MEM32(LAGCR0);
+	//set trunk mask
+	reg &= ~(TRUNKMASK_MASK);
+	reg |= (trunk_mask & TRUNKMASK_MASK);
+
+	//panic_printk("%s %d reg=0x%x trunk_mask=0x%x  \n", __FUNCTION__, __LINE__, reg, trunk_mask);
+	WRITE_MEM32(LAGCR0, reg);
+
+	return SUCCESS;
+}
+
+int32 rtl8651_setLAHashSel(uint32 hash_sel)
+{
+	uint32 reg = 0;
+
+	reg = READ_MEM32(LAGCR0);
+	//set hash select
+	reg &= ~(LAG_THASH_SELECT_MASK);
+	reg |= ((hash_sel & 0x3) << LAG_THASH_SELECT_OFFSET);
+
+	//panic_printk("%s %d reg=0x%x hash_sel=%u \n", __FUNCTION__, __LINE__, reg, hash_sel);
+	WRITE_MEM32(LAGCR0, reg);
+
+	return SUCCESS;
+}
+int32 rtl8651_setLAFtkCongest(uint32 ftk_congest)
+{
+	uint32 reg = 0;
+
+	reg = READ_MEM32(LAGCR0);
+
+	//set Force Trunk Congest
+	reg &= ~(LAG_FTK_CONGEST_MASK);
+	reg |= ((ftk_congest & 0x1) << LAG_FTK_CONGEST_OFFSET);
+
+	//panic_printk("%s %d reg=%u ftk_congest=%u \n", __FUNCTION__, __LINE__, reg, ftk_congest);
+	WRITE_MEM32(LAGCR0, reg);
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getLATrunkMask(uint32 *trunk_mask)
+{
+	uint32 reg = 0;
+
+	if (!trunk_mask)
+		return FAILED;
+
+	reg = READ_MEM32(LAGCR0);
+	*trunk_mask = (reg & TRUNKMASK_MASK);
+	//panic_printk("%s %d reg=0x%x *trunk_mask=0x%x  \n", __FUNCTION__, __LINE__, reg, *trunk_mask);
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getLAHashSel(uint32 *hash_sel)
+{
+	uint32 reg = 0;
+
+	if (!hash_sel)
+		return FAILED;
+
+	reg = READ_MEM32(LAGCR0);
+	*hash_sel = (reg >> LAG_THASH_SELECT_OFFSET) & 0x3;
+	//panic_printk("%s %d reg=0x%x *hash_sel=%u \n", __FUNCTION__, __LINE__, reg, *hash_sel);
+
+	return SUCCESS;
+}
+int32 rtl8651_getLAFtkCongest(uint32 *ftk_congest)
+{
+	uint32 reg = 0;
+
+	if (!ftk_congest)
+		return FAILED;
+
+	reg = READ_MEM32(LAGCR0);
+	*ftk_congest = (reg >> LAG_FTK_CONGEST_OFFSET) & 0x1;
+	//panic_printk("%s %d reg=%u *ftk_congest=%u \n", __FUNCTION__, __LINE__, reg, *ftk_congest);
+
+	return SUCCESS;
+}
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL2.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL2.h
new file mode 100644
index 00000000..f19ed84
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL2.h
@@ -0,0 +1,617 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2009
+* All rights reserved.
+*
+* Program : Switch table Layer2 switch driver,following features are included:
+*	PHY/MII/Port/STP/QOS
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865X_ASICL2_H
+#define RTL865X_ASICL2_H
+
+// Use sw gpio to control led of Port0~Port4
+//#define PATCH_GPIO_FOR_LED		1
+
+#define RTL865XC_QM_DESC_READROBUSTPARAMETER	10
+
+ #define RTL8651_MII_PORTNUMBER                 	5
+#define RTL8651_MII_PORTMASK                    	0x20
+#define RTL8651_PHY_NUMBER				5
+
+#define RTL8651_ETHER_AUTO_100FULL	0x00
+#define RTL8651_ETHER_AUTO_100HALF	0x01
+#define RTL8651_ETHER_AUTO_10FULL	0x02
+#define RTL8651_ETHER_AUTO_10HALF	0x03
+#define RTL8651_ETHER_AUTO_1000FULL	0x08
+#define RTL8651_ETHER_AUTO_1000HALF	0x09
+/* chhuang: patch for priority issue */
+#define RTL8651_ETHER_FORCE_100FULL	0x04
+#define RTL8651_ETHER_FORCE_100HALF	0x05
+#define RTL8651_ETHER_FORCE_10FULL	0x06
+#define RTL8651_ETHER_FORCE_10HALF	0x07
+
+#define RTL865XC_MNQUEUE_OUTPUTQUEUE  1
+#define RTL865XC_QOS_OUTPUTQUEUE 1
+
+#if (defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) \
+	|| defined(CONFIG_RTL_8197F)) && !defined(CONFIG_RTL_8367R_SUPPORT)
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+/*
+ * fast ethernet auto down speed mechanism
+ * reference document: 96D+96E+8881A fephy ip speedown_20151224_webber.vsd
+ *
+ */
+#define CONFIG_RTL_FE_AUTO_DOWN_SPEED		1
+#define CONFIG_RTL_LONG_ETH_CABLE_REFINE 	1	// from Wen-jain 07-17-2015
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+#if defined(CONFIG_RTL_8211F_SUPPORT)
+#define ADS_PORT_START		1
+#else
+#define ADS_PORT_START		0
+#endif
+
+typedef struct autoDownSpeed_s {
+	uint32	time_flag;
+	uint8	fail_counter;
+	uint8	down_speed: 1;
+	uint8	state: 1;
+	uint8	anerr: 1;
+	uint8	down_speed_renway: 1; // CONFIG_RTL_LONG_ETH_CABLE_REFINE
+	uint8	cb_snr_down_speed: 1; // for debug only
+	uint8	cb_snr_cache_lpi_down_speed: 1; // for debug only
+}	autoDownSpeed_t;
+
+enum ADS_STATE
+{
+	ADS_LINKDOWN = 0,
+	ADS_LINKUP,
+};
+extern autoDownSpeed_t fe_ads[];
+#endif
+
+#if defined(RTL865XC_MNQUEUE_OUTPUTQUEUE) || defined(RTL865XC_QOS_OUTPUTQUEUE)
+typedef struct rtl865xC_outputQueuePara_s {
+
+	uint32	ifg;							/* default: Bandwidth Control Include/exclude Preamble & IFG */
+	uint32	gap;							/* default: Per Queue Physical Length Gap = 20 */
+	uint32	drop;						/* default: Descriptor Run Out Threshold = 500 */
+
+	uint32	systemSBFCOFF;				/*System shared buffer flow control turn off threshold*/
+	uint32	systemSBFCON;				/*System shared buffer flow control turn on threshold*/
+
+	uint32	systemFCOFF;				/* system flow control turn off threshold */
+	uint32	systemFCON;					/* system flow control turn on threshold */
+
+	uint32	portFCOFF;					/* port base flow control turn off threshold */
+	uint32	portFCON;					/* port base flow control turn on threshold */
+
+	uint32	queueDescFCOFF;				/* Queue-Descriptor=Based Flow Control turn off Threshold  */
+	uint32	queueDescFCON;				/* Queue-Descriptor=Based Flow Control turn on Threshold  */
+
+	uint32	queuePktFCOFF;				/* Queue-Packet=Based Flow Control turn off Threshold  */
+	uint32	queuePktFCON;				/* Queue-Packet=Based Flow Control turn on Threshold  */
+}	rtl865xC_outputQueuePara_t;
+#endif
+
+
+/*enum for duplex and speed*/
+enum
+{
+	PORT_DOWN=0,
+	HALF_DUPLEX_10M,
+	HALF_DUPLEX_100M,
+	HALF_DUPLEX_1000M,
+	DUPLEX_10M,
+	DUPLEX_100M,
+	DUPLEX_1000M,
+	PORT_AUTO,
+	PORT_UP
+};
+
+/* enum for port ID */
+enum PORTID
+{
+	PHY0 = 0,
+	PHY1 = 1,
+	PHY2 = 2,
+	PHY3 = 3,
+	PHY4 = 4,
+	PHY5 = 5,
+	CPU = 6,
+	EXT1 = 7,
+	EXT2 = 8,
+	EXT3 = 9,
+	MULTEXT = 10,
+};
+enum GROUP
+{
+	GR0 = 0,
+	GR1 = 1,
+	GR2 = 2,
+};
+
+/* enum for queue ID */
+enum QUEUEID
+{
+	QUEUE0 = 0,
+	QUEUE1,
+	QUEUE2,
+	QUEUE3,
+	QUEUE4,
+	QUEUE5,
+	#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	QUEUE6,
+	QUEUE7,
+	#endif
+	QUEUE_END,
+};
+
+#define MAX_QUEUE		(QUEUE_END-1)
+
+/* enum for queue type */
+enum QUEUETYPE
+{
+	STR_PRIO = 0,
+	WFQ_PRIO,
+};
+
+/* enum for output queue number */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+enum QUEUENUM
+{
+	QNUM1 = 1,
+	QNUM2,
+	QNUM3,
+	QNUM4,
+	QNUM5,
+	QNUM6,
+	QNUM7,
+	QNUM8
+};
+#else
+
+enum QUEUENUM
+{
+	QNUM1 = 1,
+	QNUM2,
+	QNUM3,
+	QNUM4,
+	QNUM5,
+	QNUM6,
+};
+#endif
+
+
+/* enum for priority value type */
+enum PRIORITYVALUE
+{
+	PRI0 = 0,
+	PRI1,
+	PRI2,
+	PRI3,
+	PRI4,
+	PRI5,
+	PRI6,
+	PRI7,
+};
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+	/* word 0 */
+	uint16          mac39_24;
+	uint16          mac23_8;
+
+	/* word 1 */
+	uint32          reserv0: 6;
+	uint32          auth: 1;
+	uint32          fid:2;
+	uint32          nxtHostFlag : 1;
+	uint32          srcBlock    : 1;
+	uint32          agingTime   : 2;
+	uint32          isStatic    : 1;
+	uint32          toCPU       : 1;
+	uint32          extMemberPort   : 3;
+	uint32          memberPort : 6;
+	uint32          mac47_40    : 8;
+
+#else /*LITTLE_ENDIAN*/
+	/* word 0 */
+	uint16          mac23_8;
+	uint16          mac39_24;
+
+	/* word 1 */
+	uint32          mac47_40    : 8;
+	uint32          memberPort : 6;
+	uint32          extMemberPort   : 3;
+	uint32          toCPU       : 1;
+	uint32          isStatic    : 1;
+	uint32          agingTime   : 2;
+	uint32          srcBlock    : 1;
+	uint32          nxtHostFlag : 1;
+	uint32          fid:2;
+	uint32          auth:1;
+	uint32          reserv0:6;
+
+#endif /*LITTLE_ENDIAN*/
+	/* word 2 */
+	uint32          reservw2;
+	/* word 3 */
+	uint32          reservw3;
+	/* word 4 */
+	uint32          reservw4;
+	/* word 5 */
+	uint32          reservw5;
+	/* word 6 */
+	uint32          reservw6;
+	/* word 7 */
+	uint32          reservw7;
+} rtl865xc_tblAsic_l2Table_t;
+
+
+
+typedef struct rtl865x_tblAsicDrv_l2Param_s {
+	ether_addr_t	macAddr;
+	uint32 		memberPortMask; /*extension ports [rtl8651_totalExtPortNum-1:0] are located at bits [RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum-1:RTL8651_PORT_NUMBER]*/
+	uint32 		ageSec;
+	uint32	 	cpu:1,
+				srcBlk:1,
+				isStatic:1,
+				nhFlag:1,
+				fid:2,
+				auth:1;
+
+} rtl865x_tblAsicDrv_l2Param_t;
+
+typedef struct rtl8651_tblAsic_ethernet_s {
+	uint8	linkUp: 1,
+			phyId: 5,
+			isGPHY: 1;
+} rtl8651_tblAsic_ethernet_t;
+
+extern rtl8651_tblAsic_ethernet_t 	rtl8651AsicEthernetTable[];
+
+#if defined (CONFIG_RTL_ENABLE_RATELIMIT_TABLE)
+typedef struct rtl865x_tblAsicDrv_rateLimitParam_s {
+	uint32 	token;
+	uint32	maxToken;
+	uint32	t_remainUnit;
+	uint32 	t_intervalUnit;
+	uint32	refill_number;
+} rtl865x_tblAsicDrv_rateLimitParam_t;
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+	/* word 0 */
+	uint32          reserv0     : 2;
+	uint32          refillRemainTime    : 6;
+	uint32          token       : 24;
+	/* word 1 */
+	uint32          reserv1     : 2;
+	uint32          refillTime  : 6;
+	uint32          maxToken    : 24;
+	/* word 2 */
+	uint32          reserv2     : 8;
+	uint32          refill      : 24;
+#else
+	/* word 0 */
+	uint32          token       : 24;
+	uint32          refillRemainTime    : 6;
+	uint32          reserv0     : 2;
+	/* word 1 */
+	uint32          maxToken    : 24;
+	uint32          refillTime  : 6;
+	uint32          reserv1     : 2;
+	/* word 2 */
+	uint32          refill      : 24;
+	uint32          reserv2     : 8;
+#endif /*_LITTLE_ENDIAN*/
+	/* word 3 */
+	uint32          reservw3;
+	/* word 4 */
+	uint32          reservw4;
+	/* word 5 */
+	uint32          reservw5;
+	/* word 6 */
+	uint32          reservw6;
+	/* word 7 */
+	uint32          reservw7;
+} rtl8651_tblAsic_rateLimitTable_t;
+#endif
+
+extern int32 rtl865x_maxPreAllocRxSkb;
+extern int32 rtl865x_rxSkbPktHdrDescNum;
+extern int32 rtl865x_txSkbPktHdrDescNum;
+
+extern int32	rtl865x_wanPortMask;
+extern int32	rtl865x_lanPortMask;
+
+int32 rtl865x_initAsicL2(rtl8651_tblAsic_InitPara_t *para);
+int32 rtl8651_setAsicL2Table(uint32 row, uint32 column, rtl865x_tblAsicDrv_l2Param_t *l2p);
+int32 rtl8651_delAsicL2Table(uint32 row, uint32 column);
+unsigned int rtl8651_asicL2DAlookup(uint8 *dmac);
+int32 rtl8651_getAsicL2Table(uint32 row, uint32 column, rtl865x_tblAsicDrv_l2Param_t *l2p);
+int32 rtl8651_getAsicPortMirror(uint32 *mRxMask, uint32 *mTxMask, uint32 *mPortMask);
+int32 rtl8651_setAsicPortMirror(uint32 mRxMask, uint32 mTxMask,uint32 mPortMask);
+uint32 rtl8651_filterDbIndex(ether_addr_t * macAddr,uint16 fid);
+
+int32 rtl8651_setAsicL2Table_Patch(uint32 row, uint32 column, ether_addr_t * mac, int8 cpu,
+		int8 srcBlk, uint32 mbr, uint32 ageSec, int8 isStatic, int8 nhFlag, int8 fid, int8 auth);
+int32 rtl8651_getAsicL2Table_Patch(uint32 row, uint32 column, rtl865x_tblAsicDrv_l2Param_t *asic_l2_t);
+
+int32 rtl8651_setAsicPortPatternMatch(uint32 port, uint32 pattern, uint32 patternMask, int32 operation);
+int32 rtl8651_getAsicPortPatternMatch(uint32 port, uint32 *pattern, uint32 *patternMask, int32 *operation);
+
+int32 rtl8651_setAsicSpanningEnable(int8 spanningTreeEnabled);
+int32 rtl8651_getAsicSpanningEnable(int8 *spanningTreeEnabled);
+
+int32 rtl865xC_setAsicSpanningTreePortState(uint32 port, uint32 portState);
+int32 rtl865xC_getAsicSpanningTreePortState(uint32 port, uint32 *portState);
+int32 rtl8651_getAsicMulticastSpanningTreePortState(uint32 port, uint32 *portState);
+
+int32 rtl865xC_setAsicPortPauseFlowControl(uint32 port, uint8 rxEn, uint8 txEn);
+int32 rtl865xC_getAsicPortPauseFlowControl(uint32 port, uint8 *rxEn, uint8 *txEn);
+
+int32 rtl8651_restartAsicEthernetPHYNway(uint32 port);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+int32 rtl8651_setAsicEthernetPHYTxPadDriving(uint32 port);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+/*MDC/MDIO*/
+int32 rtl8651_getAsicEthernetPHYReg(uint32 phyId, uint32 regId, uint32 *rData);
+int32 rtl8651_setAsicEthernetPHYReg(uint32 phyId, uint32 regId, uint32 wData);
+
+int32 rtl865xC_setAsicEthernetMIIMode(uint32 port, uint32 mode);
+int32 rtl865xC_setAsicEthernetRGMIITiming(uint32 port, uint32 Tcomp, uint32 Rcomp);
+int32 rtl8651_setAsicEthernetMII(uint32 phyAddress, int32 mode, int32 enabled);
+int32 rtl8651_getAsicEthernetMII(uint32 *phyAddress);
+
+int32 rtl865x_setStormControl(uint32 type,uint32 enable,uint32 percentage);
+
+/*flow control*/
+#if defined(CONFIG_RTL_8197F)
+int32 rtl8651_setAsicPriorityDecision( uint32 portpri, uint32 dot1qpri, uint32 dscppri, uint32 aclpri, uint32 natpri, uint32 vidpri );
+#else
+int32 rtl8651_setAsicPriorityDecision( uint32 portpri, uint32 dot1qpri, uint32 dscppri, uint32 aclpri, uint32 natpri);
+#endif
+int32 rtl8651_setAsicQueueFlowControlConfigureRegister(enum PORTID port, enum QUEUEID queue, uint32 enable);
+int32 rtl8651_setAsicLBParameter( uint32 token, uint32 tick, uint32 hiThreshold );
+int32 rtl8651_getAsicLBParameter( uint32* pToken, uint32* pTick, uint32* pHiThreshold );
+int32 rtl8651_setAsicQueueRate( enum PORTID port, enum QUEUEID queueid, uint32 pprTime, uint32 aprBurstSize, uint32 apr );
+int32 rtl8651_getAsicQueueRate( enum PORTID port, enum QUEUEID queueid, uint32* pPprTime, uint32* pAprBurstSize, uint32* pApr );
+int32 rtl8651_setAsicPortIngressBandwidth( enum PORTID port, uint32 bandwidth);
+int32 rtl8651_getAsicPortIngressBandwidth( enum PORTID port, uint32* pBandwidth );
+int32 rtl8651_setAsicPortEgressBandwidth( enum PORTID port, uint32 bandwidth );
+int32 rtl8651_getAsicPortEgressBandwidth( enum PORTID port, uint32* pBandwidth );
+int32 rtl8651_setAsicQueueWeight( enum PORTID port, enum QUEUEID queueid, enum QUEUETYPE queueType, uint32 weight );
+int32 rtl8651_getAsicQueueWeight( enum PORTID port, enum QUEUEID queueid, enum QUEUETYPE *pQueueType, uint32 *pWeight );
+int32 rtl8651_setAsicOutputQueueNumber( enum PORTID port, enum QUEUENUM qnum );
+int32 rtl8651_getAsicOutputQueueNumber( enum PORTID port, enum QUEUENUM *qnum );
+int32 rtl8651_setAsicPriorityToQIDMappingTable( enum QUEUENUM qnum, enum PRIORITYVALUE priority, enum QUEUEID qid );
+int32 rtl8651_setAsicCPUPriorityToQIDMappingTable( enum PORTID port, enum PRIORITYVALUE priority, enum QUEUEID qid );
+int32 rtl8651_setAsicSystemBasedFlowControlRegister(uint32 sharedON, uint32 sharedOFF, uint32 fcON, uint32 fcOFF, uint32 drop);
+int32 rtl8651_setAsicQueueDescriptorBasedFlowControlRegister(enum PORTID port, enum QUEUEID queue, uint32 fcON, uint32 fcOFF);
+int32 rtl8651_setAsicQueuePacketBasedFlowControlRegister(enum PORTID port, enum QUEUEID queue, uint32 fcON, uint32 fcOFF);
+int32 rtl8651_setAsicPortBasedFlowControlRegister(enum PORTID port, uint32 fcON, uint32 fcOFF);
+int32 rtl8651_setAsicPerQueuePhysicalLengthGapRegister(uint32 gap);
+int32 rtl8651_getAsicQueueFlowControlConfigureRegister(enum PORTID port, enum QUEUEID queue, uint32 *enable);
+#ifdef CONFIG_RTL_LINKCHG_PROCESS
+int32 rtl8651_setAsicEthernetLinkStatus(uint32 port, int8 linkUp);
+int32  rtl8651_updateAsicLinkAggregatorLMPR(int32 portmask);
+#endif
+#ifdef CONFIG_RTK_VOIP_PORT_LINK
+int rtl8651_getAsicEthernetLinkStatus(uint32 port, int8 *linkUp);
+#endif
+int32 rtl865xC_waitForOutputQueueEmpty(void);
+ int32 rtl8651_resetAsicOutputQueue(void);
+
+ int32 rtl8651_setAsicEthernetBandwidthControl(uint32 port, int8 input, uint32 rate);
+ int32 rtl8651_setAsicFlowControlRegister(uint32 port, uint32 enable);
+ int32 rtl8651_getAsicFlowControlRegister(uint32 port, uint32 *enable);
+ int32 rtl8651_setAsicSystemInputFlowControlRegister(uint32 fcON, uint32 fcOFF);
+ int32 rtl8651_getAsicSystemInputFlowControlRegister(uint32 *fcON, uint32 *fcOFF);
+int32 rtl8651_setAsic802D1xMacBaseAbility( enum PORTID port, uint32 isEnable );
+int32 rtl8651_setAsic802D1xMacBaseDirection(int32 dir);
+int32 rtl8651_setAsicGuestVlanProcessControl( uint32 process);
+int32 rtl8651_setAsicPortBasedPriority( enum PORTID port, enum PRIORITYVALUE priority );
+int32 rtl8651_setAsicQueueStrict( enum PORTID port, enum QUEUEID queueid, enum QUEUETYPE queueType);
+int32 rtl8651_setAsicVlanRemark(enum PORTID port, enum PRIORITYVALUE priority, int remark);
+int32 rtl8651_setAsicDscpRemark(enum PORTID port, enum PRIORITYVALUE priority, int remark);
+#if defined(CONFIG_RTD_1295_HWNAT)
+void rtl8651_resetAsicVlanRemark(void);
+void rtl8651_resetAsicDscpRemark(void);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+int32 rtl8651_getAsicPortBasedPriority( enum PORTID port, enum PRIORITYVALUE* priority );
+int32 rtl8651_getAsicQueueStrict( enum PORTID port, enum QUEUEID queueid, enum QUEUETYPE *pQueueType);
+int32 rtl8651_getAsicPriorityToQIDMappingTable( enum QUEUENUM qnum, enum PRIORITYVALUE priority, enum QUEUEID* qid );
+#if defined(CONFIG_RTL_8197F)
+int32 rtl8651_getAsicPriorityDecision( uint32* portpri, uint32* dot1qpri, uint32* dscppri, uint32* aclpri, uint32* natpri, uint32* vidpri );
+#else
+int32 rtl8651_getAsicPriorityDecision( uint32* portpri, uint32* dot1qpri, uint32* dscppri, uint32* aclpri, uint32* natpri);
+#endif
+int32 rtl8651_getAsicVlanRemark(enum PORTID port, enum PRIORITYVALUE priority, int* remark);
+int32 rtl8651_getAsicDscpRemark(enum PORTID port, enum PRIORITYVALUE priority, int* remark);
+
+
+/* for vlan base qos */
+int32 rtl8651_setAsicDot1qAbsolutelyPriority( enum PRIORITYVALUE srcpriority, enum PRIORITYVALUE priority );
+int32 rtl8651_getAsicDot1qAbsolutelyPriority( enum PRIORITYVALUE srcpriority, enum PRIORITYVALUE *pPriority );
+
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+/* for vlan base qos */
+//int32 rtl8651_setAsicDot1qAbsolutelyPriority( enum PRIORITYVALUE srcpriority, enum PRIORITYVALUE priority );
+//int32 rtl8651_getAsicDot1qAbsolutelyPriority( enum PRIORITYVALUE srcpriority, enum PRIORITYVALUE *pPriority );
+int32 rtl8651_flushAsicDot1qAbsolutelyPriority(void);
+#endif
+
+#if defined (CONFIG_RTL_ENABLE_RATELIMIT_TABLE)
+int32 rtl8651_setAsicRateLimitTable(uint32 index, rtl865x_tblAsicDrv_rateLimitParam_t *rateLimit_t);
+int32 rtl8651_delAsicRateLimitTable(uint32 index);
+int32 rtl8651_getAsicRateLimitTable(uint32 index, rtl865x_tblAsicDrv_rateLimitParam_t *rateLimit_t);
+#endif
+
+int32 rtl8651_setPortFlowControlConfigureRegister(enum PORTID port,uint32 enable);
+int32 rtl8651_setAsicPortPriority( enum PORTID port, enum PRIORITYVALUE priority);
+int32 rtl8651_getAsicPortPriority( enum PORTID port, enum PRIORITYVALUE *pPriority );
+
+int32 rtl8651_setAsicDscpPriority( uint32 dscp, enum PRIORITYVALUE priority );
+int32 rtl8651_getAsicDscpPriority( uint32 dscp, enum PRIORITYVALUE *pPriority );
+
+#ifdef CONFIG_RTK_VOIP_QOS
+int32 rtl8651_reset_dscp_priority(void);
+int32 rtl8651_cpu_tx_fc(int enable);
+int32 rtl8651_setQueueNumber(int port, int qnum);
+#endif
+
+#ifdef CONFIG_RTL_8197D_DYN_THR
+int32 rtl819x_setQosThreshold(uint32 old_sts, uint32 new_sts);
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8198C_8367RB)
+/* port statistic counter structure */
+typedef struct rtk_stat_port_cntr_s
+{
+	uint64 ifInOctets;
+	uint32 dot3StatsFCSErrors;
+	uint32 dot3StatsSymbolErrors;
+	uint32 dot3InPauseFrames;
+	uint32 dot3ControlInUnknownOpcodes;
+	uint32 etherStatsFragments;
+	uint32 etherStatsJabbers;
+	uint32 ifInUcastPkts;
+	uint32 etherStatsDropEvents;
+	uint64 etherStatsOctets;
+	uint32 etherStatsUndersizePkts;
+	uint32 etherStatsOversizePkts;
+	uint32 etherStatsPkts64Octets;
+	uint32 etherStatsPkts65to127Octets;
+	uint32 etherStatsPkts128to255Octets;
+	uint32 etherStatsPkts256to511Octets;
+	uint32 etherStatsPkts512to1023Octets;
+	uint32 etherStatsPkts1024toMaxOctets;
+	uint32 etherStatsMcastPkts;
+	uint32 etherStatsBcastPkts;
+	uint64 ifOutOctets;
+	uint32 dot3StatsSingleCollisionFrames;
+	uint32 dot3StatsMultipleCollisionFrames;
+	uint32 dot3StatsDeferredTransmissions;
+	uint32 dot3StatsLateCollisions;
+	uint32 etherStatsCollisions;
+	uint32 dot3StatsExcessiveCollisions;
+	uint32 dot3OutPauseFrames;
+	uint32 dot1dBasePortDelayExceededDiscards;
+	uint32 dot1dTpPortInDiscards;
+	uint32 ifOutUcastPkts;
+	uint32 ifOutMulticastPkts;
+	uint32 ifOutBrocastPkts;
+	uint32 outOampduPkts;
+	uint32 inOampduPkts;
+	uint32 pktgenPkts;
+	uint32 inMldChecksumError;
+	uint32 inIgmpChecksumError;
+	uint32 inMldSpecificQuery;
+	uint32 inMldGeneralQuery;
+	uint32 inIgmpSpecificQuery;
+	uint32 inIgmpGeneralQuery;
+	uint32 inMldLeaves;
+	uint32 inIgmpLeaves;
+	uint32 inIgmpJoinsSuccess;
+	uint32 inIgmpJoinsFail;
+	uint32 inMldJoinsSuccess;
+	uint32 inMldJoinsFail;
+	uint32 inReportSuppressionDrop;
+	uint32 inLeaveSuppressionDrop;
+	uint32 outIgmpReports;
+	uint32 outIgmpLeaves;
+	uint32 outIgmpGeneralQuery;
+	uint32 outIgmpSpecificQuery;
+	uint32 outMldReports;
+	uint32 outMldLeaves;
+	uint32 outMldGeneralQuery;
+	uint32 outMldSpecificQuery;
+	uint32 inKnownMulticastPkts;
+	uint32 ifInMulticastPkts;
+	uint32 ifInBroadcastPkts;
+}rtk_stat_port_cntr_t;
+
+extern int rtk_stat_global_reset(void);
+extern int rtk_stat_port_getAll(uint32 port, rtk_stat_port_cntr_t *pPort_cntrs);
+extern int RTL8367R_vlan_set(void);
+extern void RTL8367R_cpu_tag(int enable);
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+typedef struct  rtk_port_mac_ability_s
+{
+	uint32 forcemode;
+	uint32 speed;
+	uint32 duplex;
+	uint32 link;
+	uint32 nway;
+	uint32 txpause;
+	uint32 rxpause;
+	uint32 lpi100;
+	uint32 lpi1000;
+}rtk_port_mac_ability_t;
+#endif
+
+#ifdef CONFIG_RTL_8370_SUPPORT
+/* port statistic counter structure */
+typedef struct rtk_stat_port_cntr_s
+{
+	uint64 ifInOctets;
+	uint32 dot3StatsFCSErrors;
+	uint32 dot3StatsSymbolErrors;
+	uint32 dot3InPauseFrames;
+	uint32 dot3ControlInUnknownOpcodes;
+	uint32 etherStatsFragments;
+	uint32 etherStatsJabbers;
+	uint32 ifInUcastPkts;
+	uint32 etherStatsDropEvents;
+	uint64 etherStatsOctets;
+	uint32 etherStatsUndersizePkts;
+	uint32 etherStatsOversizePkts;
+	uint32 etherStatsPkts64Octets;
+	uint32 etherStatsPkts65to127Octets;
+	uint32 etherStatsPkts128to255Octets;
+	uint32 etherStatsPkts256to511Octets;
+	uint32 etherStatsPkts512to1023Octets;
+	uint32 etherStatsPkts1024toMaxOctets;
+	uint32 etherStatsMcastPkts;
+	uint32 etherStatsBcastPkts;
+	uint64 ifOutOctets;
+	uint32 dot3StatsSingleCollisionFrames;
+	uint32 dot3StatsMultipleCollisionFrames;
+	uint32 dot3StatsDeferredTransmissions;
+	uint32 dot3StatsLateCollisions;
+	uint32 etherStatsCollisions;
+	uint32 dot3StatsExcessiveCollisions;
+	uint32 dot3OutPauseFrames;
+	uint32 dot1dBasePortDelayExceededDiscards;
+	uint32 dot1dTpPortInDiscards;
+	uint32 ifOutUcastPkts;
+	uint32 ifOutMulticastPkts;
+	uint32 ifOutBrocastPkts;
+	uint32 outOampduPkts;
+	uint32 inOampduPkts;
+	uint32 pktgenPkts;
+}rtk_stat_port_cntr_t;
+
+extern int rtk_stat_global_reset(void);
+extern int rtk_stat_port_getAll(uint32 port, rtk_stat_port_cntr_t *pPort_cntrs);
+#endif
+
+extern unsigned int _debug_flag;
+
+#define _DEBUG_ETH_PHY			0x00000001
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL3.c b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL3.c
new file mode 100644
index 00000000..b741672
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL3.c
@@ -0,0 +1,1934 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2009
+* All rights reserved.
+*
+* Program : Switch table Layer3 route driver,following features are included:
+*	Route/Multicast
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#include <net/rtl/rtl_types.h>
+#include "asicRegs.h"
+#include "rtl865x_asicCom.h"
+#include "rtl865x_asicBasic.h"
+#include "rtl865x_asicL3.h"
+//#include "rtl_utils.h"
+#include "rtl865x_hwPatch.h"
+
+
+
+int32 rtl8651_setAsicExtIntIpTable(uint32 index, rtl865x_tblAsicDrv_extIntIpParam_t *extIntIpp)
+{
+	rtl8651_tblAsic_extIpTable_t   entry;
+
+	if((index >= RTL8651_IPTABLE_SIZE) || (extIntIpp == NULL) ||
+	((extIntIpp->localPublic == TRUE) && (extIntIpp->nat == TRUE))) //Local public IP and NAT property cannot co-exist
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	entry.externalIP = extIntIpp->extIpAddr;
+	entry.internalIP = extIntIpp->intIpAddr;
+	entry.isLocalPublic = extIntIpp->localPublic==TRUE? 1: 0;
+	entry.isOne2One = extIntIpp->nat==TRUE? 1: 0;
+		entry.nextHop = extIntIpp->nhIndex;
+	entry.valid = 1;
+	return _rtl8651_forceAddAsicEntry(TYPE_EXT_INT_IP_TABLE, index, &entry);
+
+}
+
+int32 rtl8651_delAsicExtIntIpTable(uint32 index)
+{
+		rtl8651_tblAsic_extIpTable_t   entry;
+
+	if(index >= RTL8651_IPTABLE_SIZE)
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	entry.valid = 0;
+	return _rtl8651_forceAddAsicEntry(TYPE_EXT_INT_IP_TABLE, index, &entry);
+}
+
+int32 rtl8651_getAsicExtIntIpTable(uint32 index, rtl865x_tblAsicDrv_extIntIpParam_t *extIntIpp)
+{
+		rtl8651_tblAsic_extIpTable_t   entry;
+
+	if((index>=RTL8651_IPTABLE_SIZE) || (extIntIpp == NULL))
+		return FAILED;
+	_rtl8651_readAsicEntry(TYPE_EXT_INT_IP_TABLE, index, &entry);
+	if(entry.valid == 0)
+		return FAILED;//Entry not found
+	extIntIpp->extIpAddr = ntohl(entry.externalIP);
+	extIntIpp->intIpAddr = ntohl(entry.internalIP);
+	extIntIpp->localPublic = entry.isLocalPublic==1? TRUE: FALSE;
+	extIntIpp->nat = entry.isOne2One==1? TRUE: FALSE;
+		extIntIpp->nhIndex = entry.nextHop;
+		return SUCCESS;
+}
+
+int32 rtl8651_setAsicPppoe(uint32 index, rtl865x_tblAsicDrv_pppoeParam_t *pppoep)
+{
+	rtl8651_tblAsic_pppoeTable_t entry;
+
+	if((index >= RTL8651_PPPOETBL_SIZE) || (pppoep == NULL) || (pppoep->sessionId == 0xffff))
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	entry.sessionID = pppoep->sessionId;
+	entry.ageTime = pppoep->age;
+
+	return _rtl8651_forceAddAsicEntry(TYPE_PPPOE_TABLE, index, &entry);
+}
+
+int32 rtl8651_getAsicPppoe(uint32 index, rtl865x_tblAsicDrv_pppoeParam_t *pppoep) {
+	rtl8651_tblAsic_pppoeTable_t entry;
+
+	if((index >= RTL8651_PPPOETBL_SIZE) || (pppoep == NULL))
+		return FAILED;
+
+	_rtl8651_readAsicEntry(TYPE_PPPOE_TABLE, index, &entry);
+	pppoep->sessionId = entry.sessionID;
+	pppoep->age = entry.ageTime;
+
+	return SUCCESS;
+}
+
+
+
+int32 rtl8651_setAsicNextHopTable(uint32 index, rtl865x_tblAsicDrv_nextHopParam_t *nextHopp)
+{
+	rtl8651_tblAsic_nextHopTable_t  entry;
+	if((index >= RTL8651_NEXTHOPTBL_SIZE ) || (nextHopp == NULL))
+		return FAILED;
+
+	/* for debug
+	rtlglue_printf("[%s:%d] rtl8651_setAsicNextHopTable(idx=%d,Row=%d,Col=%d,PPPIdx=%d,dvid=%d,IPIdx=%d,type=%d)\n",
+		__FILE__,__LINE__,index, nextHopp->nextHopRow,nextHopp->nextHopColumn,nextHopp->pppoeIdx,
+		nextHopp->dvid,nextHopp->extIntIpIdx,nextHopp->isPppoe);
+	*/
+	memset(&entry,0,sizeof(entry));
+	entry.nextHop = (nextHopp->nextHopRow <<2) | nextHopp->nextHopColumn;
+	entry.PPPoEIndex = nextHopp->pppoeIdx;
+	entry.dstVid = nextHopp->dvid;
+	entry.IPIndex = nextHopp->extIntIpIdx;
+	entry.type = nextHopp->isPppoe==TRUE? 1: 0;
+	return _rtl8651_forceAddAsicEntry(TYPE_NEXT_HOP_TABLE, index, &entry);
+}
+
+int32 rtl8651_getAsicNextHopTable(uint32 index, rtl865x_tblAsicDrv_nextHopParam_t *nextHopp)
+{
+	rtl8651_tblAsic_nextHopTable_t  entry;
+	if((index>=RTL8651_NEXTHOPTBL_SIZE) || (nextHopp == NULL))
+		return FAILED;
+
+	_rtl8651_readAsicEntry(TYPE_NEXT_HOP_TABLE, index, &entry);
+	nextHopp->nextHopRow = entry.nextHop>>2;
+	nextHopp->nextHopColumn = entry.nextHop&0x3;
+	nextHopp->pppoeIdx = entry.PPPoEIndex;
+	nextHopp->dvid = entry.dstVid;
+	nextHopp->extIntIpIdx = entry.IPIndex;
+	nextHopp->isPppoe = entry.type==1? TRUE: FALSE;
+	return SUCCESS;
+}
+
+
+int32 rtl8651_setAsicRouting(uint32 index, rtl865x_tblAsicDrv_routingParam_t *routingp)
+{
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+		extern int sixrd_hw_fw ;
+#endif
+#endif
+	uint32 i, asicMask;
+	rtl865xc_tblAsic_l3RouteTable_t entry;
+#ifdef FPGA
+	if (index==2) index=6;
+	if (index==3) index=7;
+	if (index>=4 && index <=5)
+		rtlglue_printf("Out of range\n");
+#endif
+	if((index >= RTL8651_ROUTINGTBL_SIZE) || (routingp == NULL))
+		return FAILED;
+
+	if (routingp->ipMask) {
+		routingp->ipMask = routingp->ipMask;
+		for(i=0; i<32; i++)
+			if(routingp->ipMask & (1<<i)) break;
+		asicMask = 31 - i;
+	} else asicMask = 0;
+
+	memset(&entry,0,sizeof(entry));
+	entry.IPAddr = routingp->ipAddr;
+	switch(routingp->process) {
+	case 0://PPPoE
+		entry.linkTo.PPPoEEntry.PPPoEIndex = routingp->pppoeIdx;
+		entry.linkTo.PPPoEEntry.nextHop = (routingp->nextHopRow <<2) | routingp->nextHopColumn;
+		entry.linkTo.PPPoEEntry.IPMask = asicMask;
+		entry.linkTo.PPPoEEntry.netif = routingp->vidx;
+		entry.linkTo.PPPoEEntry.internal=routingp->internal;
+		entry.linkTo.PPPoEEntry.isDMZ=routingp->DMZFlag;
+		entry.linkTo.PPPoEEntry.process = routingp->process;
+		entry.linkTo.PPPoEEntry.valid = 1;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		entry.linkTo.PPPoEEntry.DSLEG      = routingp->DSLEG;
+		entry.linkTo.PPPoEEntry.DSL_IDX1_0 = routingp->DSL_IDX&0x3;
+#endif
+		break;
+	case 1://Direct
+		entry.linkTo.L2Entry.nextHop = (routingp->nextHopRow <<2) | routingp->nextHopColumn;
+		entry.linkTo.L2Entry.IPMask = asicMask;
+		entry.linkTo.L2Entry.netif = routingp->vidx;
+		entry.linkTo.L2Entry.internal=routingp->internal;
+		entry.linkTo.L2Entry.isDMZ=routingp->DMZFlag;
+		entry.linkTo.L2Entry.process = routingp->process;
+		entry.linkTo.L2Entry.valid = 1;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		entry.linkTo.L2Entry.DSLEG      = routingp->DSLEG;
+		entry.linkTo.L2Entry.DSL_IDX1_0 = routingp->DSL_IDX&0x3;
+#endif
+		break;
+	case 2://arp
+		entry.linkTo.ARPEntry.ARPEnd = routingp->arpEnd >> 3;
+		entry.linkTo.ARPEntry.ARPStart = routingp->arpStart >> 3;
+		entry.linkTo.ARPEntry.IPMask = asicMask;
+		entry.linkTo.ARPEntry.netif = routingp->vidx;
+		entry.linkTo.ARPEntry.internal=routingp->internal;
+		entry.linkTo.ARPEntry.isDMZ = routingp->DMZFlag;
+		entry.linkTo.ARPEntry.process = routingp->process;
+		entry.linkTo.ARPEntry.valid = 1;
+
+		entry.linkTo.ARPEntry.ARPIpIdx = routingp->arpIpIdx; /* for RTL8650B C Version Only */
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		entry.linkTo.ARPEntry.DSLEG      = routingp->DSLEG;
+		entry.linkTo.ARPEntry.DSL_IDX1_0 = routingp->DSL_IDX&0x3;
+#endif
+		break;
+	case 4://CPU
+	case 6://DROP
+		/*
+		  *   Note:  although the process of this routing entry is CPU/DROP,
+		  *             we still have to assign "vid" field for packet decision process use.
+		  *                                                                                          - 2005.3.23 -
+		  */
+		entry.linkTo.ARPEntry.netif = routingp->vidx;
+		entry.linkTo.ARPEntry.IPMask = asicMask;
+		entry.linkTo.ARPEntry.process = routingp->process;
+		entry.linkTo.ARPEntry.valid = 1;
+		entry.linkTo.ARPEntry.internal=routingp->internal;
+		break;
+	case 5://NAPT NextHop
+		entry.linkTo.NxtHopEntry.nhStart = routingp->nhStart >> 1;
+		switch (routingp->nhNum)
+		{
+		    case 2: entry.linkTo.NxtHopEntry.nhNum = 0; break;
+		    case 4: entry.linkTo.NxtHopEntry.nhNum = 1; break;
+		    case 8: entry.linkTo.NxtHopEntry.nhNum = 2; break;
+		    case 16: entry.linkTo.NxtHopEntry.nhNum = 3; break;
+		    case 32: entry.linkTo.NxtHopEntry.nhNum = 4; break;
+		    default: return FAILED;
+		}
+		entry.linkTo.NxtHopEntry.nhNxt = routingp->nhNxt;
+		entry.linkTo.NxtHopEntry.nhAlgo = routingp->nhAlgo;
+		entry.linkTo.NxtHopEntry.IPMask = asicMask;
+		entry.linkTo.NxtHopEntry.process = routingp->process;
+		entry.linkTo.NxtHopEntry.valid = 1;
+		entry.linkTo.NxtHopEntry.IPDomain = routingp->ipDomain;
+		entry.linkTo.NxtHopEntry.internal = routingp->internal;
+		entry.linkTo.NxtHopEntry.isDMZ = routingp->DMZFlag;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		entry.linkTo.NxtHopEntry.DSLEG      = routingp->DSLEG;
+		entry.linkTo.NxtHopEntry.DSL_IDX1_0 = routingp->DSL_IDX&0x3;
+#endif
+		break;
+
+	default:
+		return FAILED;
+	}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		entry.DSL_IDX2   = routingp->DSL_IDX>>2;
+#endif
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+	if(sixrd_hw_fw)
+	{
+		if(entry.linkTo.ARPEntry.process  ==2){
+
+			return FAILED;
+		}
+	}
+#endif
+#endif
+
+		return _rtl8651_forceAddAsicEntry(TYPE_L3_ROUTING_TABLE, index, &entry);
+}
+int32 rtl8651_delAsicRouting(uint32 index)
+{
+	rtl865xc_tblAsic_l3RouteTable_t entry;
+
+	if(index >= RTL8651_ROUTINGTBL_SIZE)
+		return FAILED;
+	memset(&entry,0,sizeof(entry));
+	entry.linkTo.ARPEntry.valid = 0;
+	return _rtl8651_forceAddAsicEntry(TYPE_L3_ROUTING_TABLE, index, &entry);
+}
+
+int32 rtl8651_getAsicRouting(uint32 index, rtl865x_tblAsicDrv_routingParam_t *routingp)
+{
+	uint32 i;
+	rtl865xc_tblAsic_l3RouteTable_t entry;
+
+	if((index >= RTL8651_ROUTINGTBL_SIZE) || (routingp == NULL))
+		return FAILED;
+
+	_rtl8651_readAsicEntry(TYPE_L3_ROUTING_TABLE, index, &entry);
+	if(entry.linkTo.ARPEntry.valid == 0)
+		return FAILED;
+
+	routingp->ipAddr = ntohl(entry.IPAddr);
+	routingp->process = entry.linkTo.ARPEntry.process;
+	for(i=0, routingp->ipMask = 0; i<=entry.linkTo.ARPEntry.IPMask; i++)
+		routingp->ipMask |= 1<<(31-i);
+
+	routingp->ipMask = ntohl(routingp->ipMask);
+
+	routingp->vidx = entry.linkTo.ARPEntry.netif;
+	routingp->internal= entry.linkTo.PPPoEEntry.internal;
+	switch(routingp->process) {
+	case 0://PPPoE
+		routingp->arpStart = 0;
+		routingp->arpEnd = 0;
+		routingp->pppoeIdx = entry.linkTo.PPPoEEntry.PPPoEIndex;
+		routingp->nextHopRow = entry.linkTo.PPPoEEntry.nextHop>>2;
+		routingp->nextHopColumn = entry.linkTo.PPPoEEntry.nextHop & 0x3;
+		routingp->DMZFlag= entry.linkTo.NxtHopEntry.isDMZ;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		routingp->DSLEG      = entry.linkTo.PPPoEEntry.DSLEG;
+		routingp->DSL_IDX   = entry.linkTo.PPPoEEntry.DSL_IDX1_0;
+#endif
+		break;
+	case 1://Direct
+		routingp->arpStart = 0;
+		routingp->arpEnd = 0;
+		routingp->pppoeIdx = 0;
+		routingp->nextHopRow = entry.linkTo.L2Entry.nextHop>>2;
+		routingp->nextHopColumn = entry.linkTo.L2Entry.nextHop&0x3;
+		routingp->DMZFlag= entry.linkTo.NxtHopEntry.isDMZ;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		routingp->DSLEG      = entry.linkTo.L2Entry.DSLEG;
+		routingp->DSL_IDX   = entry.linkTo.L2Entry.DSL_IDX1_0;
+#endif
+		break;
+	case 2://Indirect
+		routingp->arpEnd = entry.linkTo.ARPEntry.ARPEnd;
+		routingp->arpStart = entry.linkTo.ARPEntry.ARPStart;
+		routingp->pppoeIdx = 0;
+		routingp->nextHopRow = 0;
+		routingp->nextHopColumn = 0;
+		routingp->arpIpIdx = entry.linkTo.ARPEntry.ARPIpIdx;
+		routingp->DMZFlag= entry.linkTo.NxtHopEntry.isDMZ;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		routingp->DSLEG      = entry.linkTo.ARPEntry.DSLEG;
+		routingp->DSL_IDX   = entry.linkTo.ARPEntry.DSL_IDX1_0;
+#endif
+		break;
+	case 4: /* CPU */
+	case 6: /* Drop */
+		routingp->arpStart = 0;
+		routingp->arpEnd = 0;
+		routingp->pppoeIdx = 0;
+		routingp->nextHopRow = 0;
+		routingp->nextHopColumn = 0;
+		routingp->DMZFlag= entry.linkTo.NxtHopEntry.isDMZ;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		routingp->DSLEG      = 0;
+		routingp->DSL_IDX   = 0;
+#endif
+		break;
+
+	case 5:
+		routingp->nhStart = (entry.linkTo.NxtHopEntry.nhStart) << 1;
+		switch (entry.linkTo.NxtHopEntry.nhNum)
+		{
+		case 0: routingp->nhNum = 2; break;
+		case 1: routingp->nhNum = 4; break;
+		case 2: routingp->nhNum = 8; break;
+		case 3: routingp->nhNum = 16; break;
+		case 4: routingp->nhNum = 32; break;
+		default: return FAILED;
+		}
+		routingp->nhNxt = entry.linkTo.NxtHopEntry.nhNxt;
+		routingp->nhAlgo = entry.linkTo.NxtHopEntry.nhAlgo;
+		routingp->ipDomain = entry.linkTo.NxtHopEntry.IPDomain;
+		routingp->internal= entry.linkTo.NxtHopEntry.internal;
+		routingp->DMZFlag= entry.linkTo.NxtHopEntry.isDMZ;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		routingp->DSLEG      = entry.linkTo.NxtHopEntry.DSLEG;
+		routingp->DSL_IDX   = entry.linkTo.NxtHopEntry.DSL_IDX1_0;
+#endif
+		break;
+
+	default: return FAILED;
+	}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		routingp->DSL_IDX    = routingp->DSL_IDX |(entry.DSL_IDX2<<0x2);
+#endif
+
+	return SUCCESS;
+}
+
+
+int32 rtl8651_setAsicArp(uint32 index, rtl865x_tblAsicDrv_arpParam_t *arpp)
+{
+	rtl865xc_tblAsic_arpTable_t   entry;
+	if((index >= RTL8651_ARPTBL_SIZE) || (arpp == NULL))
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	entry.nextHop = (arpp->nextHopRow<<2) | (arpp->nextHopColumn&0x3);
+	entry.valid = 1;
+	entry.aging=arpp->aging;
+	return _rtl8651_forceAddAsicEntry(TYPE_ARP_TABLE, index, &entry);
+}
+
+int32 rtl8651_delAsicArp(uint32 index)
+{
+	rtl865xc_tblAsic_arpTable_t   entry;
+	if(index >= RTL8651_ARPTBL_SIZE)
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	entry.valid = 0;
+	return _rtl8651_forceAddAsicEntry(TYPE_ARP_TABLE, index, &entry);
+}
+
+int32 rtl8651_getAsicArp(uint32 index, rtl865x_tblAsicDrv_arpParam_t *arpp)
+{
+	rtl865xc_tblAsic_arpTable_t   entry;
+	if((index >= RTL8651_ARPTBL_SIZE) || (arpp == NULL))
+		return FAILED;
+	//_rtl8651_readAsicEntry(TYPE_ARP_TABLE, index, &entry);
+	/*for 8196B patch,read arp table and ip multicast table should stop TLU*/
+	_rtl8651_readAsicEntryStopTLU(TYPE_ARP_TABLE, index, &entry);
+	if(entry.valid == 0)
+		return FAILED;
+	arpp->nextHopRow = entry.nextHop>>2;
+	arpp->nextHopColumn = entry.nextHop&0x3;
+	arpp->aging=entry.aging&0x1f;
+	return SUCCESS;
+}
+
+inline unsigned int bitReverse(unsigned int x)
+{
+  unsigned int y = 0x55555555;
+  x = (((x >> 1) & y) | ((x & y) << 1));
+  y = 0x33333333;
+  x = (((x >> 2) & y) | ((x & y) << 2));
+  y = 0x0f0f0f0f;
+  x = (((x >> 4) & y) | ((x & y) << 4));
+  y = 0x00ff00ff;
+  x = (((x >> 8) & y) | ((x & y) << 8));
+  return((x >> 16) | (x << 16));
+}
+
+/*=========================================
+  * ASIC DRIVER API: Multicast Table
+  *=========================================*/
+static uint32 currHashMethod = 0; /* init hash method as 0 */
+
+uint32 rtl8651_ipMulticastTableIndex(ipaddr_t srcAddr, ipaddr_t dstAddr)
+{
+	uint32 idx;
+
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) || defined(CONFIG_RTL_8198C)	|| defined(CONFIG_RTL_8197F)
+	currHashMethod = ( REG32(FFCR) & 0x00000060) >> 5;
+
+	if (currHashMethod == HASH_METHOD_SIP)
+	{
+		idx = srcAddr & 0xff;
+	}
+	else if (currHashMethod == HASH_METHOD_DIP)
+	{
+		idx = dstAddr & 0xff;
+	}
+	else
+	{
+		#if 0
+		uint32 sip[32],dip[32];
+		uint32 hash[8];
+		uint32 i;
+
+		for(i=0; i<8; i++) {
+			hash[i]=0;
+		}
+
+		for(i=0; i<32; i++)	{
+			if((srcAddr & (1<<i))!=0) {
+				sip[i]=1;
+			}
+			else 	{
+				sip[i]=0;
+			}
+
+			if((dstAddr & (1<<i))!=0) {
+				dip[i]=1;
+			}
+			else {
+				dip[i]=0;
+			}
+		}
+
+		hash[7] = sip[0] ^ sip[8]   ^ sip[16] ^ sip[24] ^ dip[7] ^ dip[15] ^ dip[23] ^ dip[31];
+		hash[6] = sip[1] ^ sip[9]   ^ sip[17] ^ sip[25] ^ dip[6] ^ dip[14] ^ dip[22] ^ dip[30];
+		hash[5] = sip[2] ^ sip[10] ^ sip[18] ^ sip[26] ^ dip[5] ^ dip[13] ^ dip[21] ^ dip[29];
+		hash[4] = sip[3] ^ sip[11] ^ sip[19] ^ sip[27] ^ dip[4] ^ dip[12] ^ dip[20] ^ dip[28];
+		hash[3] = sip[4] ^ sip[12] ^ sip[20] ^ sip[28] ^ dip[3] ^ dip[11] ^ dip[19] ^ dip[27];
+		hash[2] = sip[5] ^ sip[13] ^ sip[21] ^ sip[29] ^ dip[2] ^ dip[10] ^ dip[18] ^ dip[26];
+		hash[1] = sip[6] ^ sip[14] ^ sip[22] ^ sip[30] ^ dip[1] ^ dip[9]  ^ dip[17] ^ dip[25];
+		hash[0] = sip[7] ^ sip[15] ^ sip[23] ^ sip[31] ^ dip[0] ^ dip[8]  ^ dip[16] ^ dip[24];
+
+		for(i=0; i<8; i++) {
+			hash[i]=hash[i] & (0x01);
+		}
+
+		idx=0;
+		for(i=0; i<8; i++) {
+			idx=idx+(hash[i]<<i);
+		}
+		#else
+		uint32 temp;
+		uint8 *tempPtr;
+		uint32 newSrcAddr = bitReverse(srcAddr);
+
+		temp = newSrcAddr^dstAddr;
+		tempPtr = (uint8 *)(&temp);
+		idx = (uint32)(tempPtr[0]^tempPtr[1]^tempPtr[2]^tempPtr[3]);
+		#endif
+
+	}
+
+#elif defined (CONFIG_RTL8196C_REVISION_B) || defined (CONFIG_RTL8198_REVISION_B) || defined(CONFIG_RTL_819XD)
+	currHashMethod = ( REG32(FFCR) & 0x00000060) >> 5; /* Frame Forwarding Configuration Register bit:5~6 */
+
+	if (currHashMethod == HASH_METHOD_SIP) /* hash method:  SIP[6:0] */
+	{
+		idx = srcAddr & 0x7f;
+	}
+	else if (currHashMethod == HASH_METHOD_DIP) /* hash method:  DIP[6:0] */
+	{
+		idx = dstAddr & 0x7f;
+	}
+	else
+	{
+		#if 0
+		uint32 sip[32],dip[32];
+		uint32 hash[7];
+		uint32 i;
+
+		for(i=0; i<7; i++) {
+			hash[i]=0;
+		}
+
+		for(i=0; i<32; i++)	{
+			if((srcAddr & (1<<i))!=0) {
+				sip[i]=1;
+			}
+			else 	{
+				sip[i]=0;
+			}
+
+			if((dstAddr & (1<<i))!=0) {
+				dip[i]=1;
+			}
+			else {
+				dip[i]=0;
+			}
+		}
+
+		hash[0] = sip[0] ^ sip[7]   ^ sip[14] ^ sip[21] ^ sip[28] ^ dip[1] ^ dip[8]   ^ dip[15] ^ dip[22] ^ dip[29];
+		hash[1] = sip[1] ^ sip[8]   ^ sip[15] ^ sip[22] ^ sip[29] ^ dip[2] ^ dip[9]   ^ dip[16] ^ dip[23] ^ dip[30];
+		hash[2] = sip[2] ^ sip[9]   ^ sip[16] ^ sip[23] ^ sip[30] ^ dip[3] ^ dip[10] ^ dip[17] ^ dip[24] ^ dip[31];
+		hash[3] = sip[3] ^ sip[10] ^ sip[17] ^ sip[24] ^ sip[31] ^ dip[4] ^ dip[11] ^ dip[18] ^ dip[25];
+		hash[4] = sip[4] ^ sip[11] ^ sip[18] ^ sip[25]               ^ dip[5] ^ dip[12] ^ dip[19] ^ dip[26];
+		hash[5] = sip[5] ^ sip[12] ^ sip[19] ^ sip[26]               ^ dip[6] ^ dip[13] ^ dip[20] ^ dip[27];
+		hash[6] = sip[6] ^ sip[13] ^ sip[20] ^ sip[27]   ^ dip[0] ^ dip[7] ^ dip[14] ^ dip[21] ^ dip[28];
+
+		for(i=0; i<7; i++) {
+			hash[i]=hash[i] & (0x01);
+		}
+
+		idx=0;
+		for(i=0; i<7; i++) {
+			idx=idx+(hash[i]<<i);
+		}
+		#else
+		uint32 hashSrcAddr = 0;
+		uint32 hashDstAddr = 0;
+
+		hashSrcAddr = srcAddr ^ (srcAddr>>7) ^ (srcAddr>>14) ^ (srcAddr>>21) ^ ((srcAddr>>28)&0xF);
+		hashDstAddr = ((dstAddr>>1) ^ (dstAddr>>8) ^ (dstAddr>>15) ^ (dstAddr>>22)) ^ ((dstAddr>>29)&0x7)^((dstAddr&0x1)<<6);
+		idx= (hashSrcAddr ^ hashDstAddr) & 0x7F;
+		#endif
+	}
+
+	return idx;
+#else
+	#error "wrong compile flag, not supported IC reversion"
+#endif
+
+	return idx;
+}
+
+#ifdef CONFIG_RTL_SWITCH_FPGA
+void set_mc_entry_for_test(void)
+{
+	rtl865x_tblAsicDrv_multiCastParam_t mCast;
+
+	mCast.sip = htonl(0xAC010163);	// VLC server is in WAN (port 0), IP: 172.1.1.99, MC IP: 224.1.2.3
+	mCast.dip = htonl(0xE0010203);	// VLC client is in LAN (port 1), join 224.1.2.3
+	mCast.svid = 0;
+	mCast.port = 0;	// WAN (port 0)
+	mCast.mbr = 0x2; // LAN (port 1)
+	mCast.extIdx = 0;
+	rtl8651_setAsicIpMulticastTable(&mCast);
+}
+#endif
+
+int32 rtl8651_setAsicIpMulticastTable(rtl865x_tblAsicDrv_multiCastParam_t *mCast_t) {
+	uint32 idx;
+	rtl865xc_tblAsic_ipMulticastTable_t entry;
+	//int16 age;
+
+	if(mCast_t->dip >>28 != 0xe || mCast_t->port >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum)
+		return FAILED;//Non-IP multicast destination address
+	memset(&entry,0,sizeof(entry));
+	entry.srcIPAddr 		= mCast_t->sip;
+	entry.destIPAddrLsbs 	= mCast_t->dip & 0xfffffff;
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+	idx = mCast_t->idx;
+#else
+	idx = rtl8651_ipMulticastTableIndex(mCast_t->sip, mCast_t->dip);
+#endif
+
+	entry.srcPort 			= mCast_t->port;
+	entry.portList 			= mCast_t->mbr;
+#ifdef CONFIG_RTL_HW_MCAST_WIFI
+	entry.toCPU      = (entry.portList & ( 0x01<<RTL8651_MAC_NUMBER)) ? 1 : 0;
+	entry.portList     = entry.portList &(~( 0x01<<RTL8651_MAC_NUMBER));
+#else
+	entry.toCPU 			= 0;
+#endif
+	entry.valid 			= 1;
+	entry.extIPIndex 		= mCast_t->extIdx;
+#if 1
+	entry.ageTime			= 7;
+#else
+	entry.ageTime			= 0;
+	age = (int16)mCast_t->age;
+	while ( age > 0 ) {
+		if ( (++entry.ageTime) == 7)
+			break;
+		age -= 5;
+	}
+#endif
+#if defined (CONFIG_RTL_8197F)
+	entry.destInterface = 0;
+#endif
+
+	return _rtl8651_forceAddAsicEntry(TYPE_MULTICAST_TABLE, idx, &entry);
+}
+
+int32 rtl8651_delAsicIpMulticastTable(uint32 index) {
+	rtl865xc_tblAsic_ipMulticastTable_t entry;
+	memset(&entry,0,sizeof(entry));
+	return _rtl8651_forceAddAsicEntry(TYPE_MULTICAST_TABLE, index, &entry);
+}
+
+int32 rtl8651_getAsicIpMulticastTable(uint32 index, rtl865x_tblAsicDrv_multiCastParam_t *mCast_t)
+{
+	rtl865xc_tblAsic_ipMulticastTable_t entry;
+
+	if (mCast_t == NULL)
+		return FAILED;
+	//_rtl8651_readAsicEntry(TYPE_MULTICAST_TABLE, index, &entry);
+	_rtl8651_readAsicEntryStopTLU(TYPE_MULTICAST_TABLE, index, &entry);
+
+	mCast_t->sip = entry.srcIPAddr;
+	if(entry.valid)
+	{
+		mCast_t->dip	= entry.destIPAddrLsbs | 0xe0000000;
+	}
+	else
+	{
+		if(entry.destIPAddrLsbs==0)
+		{
+			mCast_t->dip	= entry.destIPAddrLsbs;
+		}
+		else
+		{
+			mCast_t->dip	= entry.destIPAddrLsbs | 0xe0000000;
+		}
+	}
+	mCast_t->dip = mCast_t->dip;
+	mCast_t->svid = 0;
+	mCast_t->port = entry.srcPort;
+	mCast_t->mbr = entry.portList;
+	mCast_t->extIdx = entry.extIPIndex ;
+	mCast_t->age	= entry.ageTime * 5;
+	mCast_t->cpu = entry.toCPU;
+
+	if(entry.valid == 0)
+	{
+		return FAILED;
+	}
+	return SUCCESS;
+}
+
+
+/*
+@func int32		|	rtl8651_setAsicMulticastEnable 	| Enable / disable ASIC IP multicast support.
+@parm uint32		|	enable	| TRUE to indicate ASIC IP multicast process is enabled; FALSE to indicate ASIC IP multicast process is disabled.
+@rvalue FAILED	|	Failed
+@rvalue SUCCESS	|	Success
+@comm
+We would use this API to enable/disable ASIC IP multicast process.
+If it's disabled here, Hardware IP multicast table would be ignored.
+If it's enabled here, IP multicast table is used to forwarding IP multicast packets.
+ */
+int32 rtl8651_setAsicMulticastEnable(uint32 enable)
+{
+	if (enable == TRUE)
+	{
+		WRITE_MEM32(FFCR, READ_MEM32(FFCR)|EN_MCAST);
+	} else
+	{
+		WRITE_MEM32(FFCR, READ_MEM32(FFCR) & ~EN_MCAST);
+	}
+
+	return SUCCESS;
+}
+/*
+@func int32		|	rtl8651_getAsicMulticastEnable 	| Get the state about ASIC IP multicast support.
+@parm uint32*		|	enable	| Pointer to store the state about ASIC IP multicast support.
+@rvalue FAILED	|	Failed
+@rvalue SUCCESS	|	Success
+@comm
+We would use this API to get the status of ASIC IP multicast process.
+TRUE to indicate ASIC IP multicast process is enabled; FALSE to indicate ASIC IP multicast process is disabled.
+*/
+int32 rtl8651_getAsicMulticastEnable(uint32 *enable)
+{
+	if (enable == NULL)
+	{
+		return FAILED;
+	}
+
+	*enable = (READ_MEM32(FFCR) & EN_MCAST) ? TRUE : FALSE;
+
+	return SUCCESS;
+}
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+
+int32 rtl865x_set_mcastMacClone(uint32 enabled, unsigned char * macAddr)
+{
+	uint32 value0_31=0,value32_47=0;
+
+	if(enabled)
+	{
+		WRITE_MEM32(FFCR,((READ_MEM32(FFCR)&(~CF_IPMMAC_CLONE_EN))|CF_IPMMAC_CLONE_EN));
+		if(macAddr)
+		{
+			value32_47 = (macAddr[0]<<8)|(macAddr[1]);
+			value0_31 = (macAddr[2]<<24)|(macAddr[3]<<16)|(macAddr[4]<<8)|(macAddr[5]);
+			WRITE_MEM32(IPMCMCR0,value0_31);
+			WRITE_MEM32(IPMCMCR1,value32_47);
+		}
+	}
+	else
+	{
+		WRITE_MEM32(FFCR,((READ_MEM32(FFCR)&(~CF_IPMMAC_CLONE_EN))));
+	}
+	return SUCCESS;
+}
+
+#endif
+/*
+@func int32		|	rtl8651_setAsicMulticastPortInternal 	| Configure internal/external state for each port
+@parm uint32		|	port		| Port to set its state.
+@parm int8		|	isInternal	| set TRUE to indicate <p port> is internal port; set FALSE to indicate <p port> is external port
+@rvalue FAILED	|	Failed
+@rvalue SUCCESS	|	Success
+@comm
+In RTL865x platform,
+user would need to config the Internal/External state for each port to support HW multicast NAPT.
+If packet is sent from internal port to external port, and source VLAN member port checking indicates that L34 is needed.
+Source IP modification would be applied.
+ */
+int32 rtl8651_setAsicMulticastPortInternal(uint32 port, int8 isInternal)
+{
+	if (port >= RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum)
+	{	/* Invalid port */
+		return FAILED;
+	}
+
+	/*
+		RTL865XC : All multicast mode are stored in [SWTCR0 / Switch Table Control Register 0]
+	*/
+	if (isInternal == TRUE)
+	{
+		WRITE_MEM32(SWTCR0, READ_MEM32(SWTCR0) | (((1 << port) & MCAST_PORT_EXT_MODE_MASK) << MCAST_PORT_EXT_MODE_OFFSET));
+	} else
+	{
+		WRITE_MEM32(SWTCR0, READ_MEM32(SWTCR0) & ~(((1 << port) & MCAST_PORT_EXT_MODE_MASK) << MCAST_PORT_EXT_MODE_OFFSET));
+	}
+
+	return SUCCESS;
+}
+
+/*
+@func int32		|	rtl8651_getAsicMulticastPortInternal 	| Get internal/external state for each port
+@parm uint32		|	port		| Port to set its state.
+@parm int8*		|	isInternal	| Pointer to get port state of <p port>.
+@rvalue FAILED	|	Failed
+@rvalue SUCCESS	|	Success
+@comm
+To get the port internal / external state for <p port>:
+TRUE to indicate <p port> is internal port; FALSE to indicate <p port> is external port
+ */
+int32 rtl8651_getAsicMulticastPortInternal(uint32 port, int8 *isInternal)
+{
+	if (isInternal == NULL)
+	{
+		return FAILED;
+	}
+
+	if (port >= RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum)
+	{	/* Invalid port */
+		return FAILED;
+	}
+
+	if (READ_MEM32(SWTCR0) & (((1 << port) & MCAST_PORT_EXT_MODE_MASK) << MCAST_PORT_EXT_MODE_OFFSET))
+	{
+		*isInternal = TRUE;
+	} else
+	{
+		*isInternal = FALSE;
+	}
+
+	return SUCCESS;
+}
+
+/*
+@func int32		|	rtl8651_setAsicMulticastMTU 	| Set MTU for ASIC IP multicast forwarding
+@parm uint32		|	mcastMTU	| MTU used by HW IP multicast forwarding.
+@rvalue FAILED	|	Failed
+@rvalue SUCCESS	|	Success
+@comm
+To set the MTU for ASIC IP multicast forwarding.
+Its independent from other packet forwarding because IP multicast would include L2/L3/L4 at one time.
+*/
+int32 rtl8651_setAsicMulticastMTU(uint32 mcastMTU)
+{
+	if (mcastMTU & ~(MultiCastMTU_MASK) )
+	{	/* multicast MTU overflow */
+		return FAILED;
+	}
+
+	UPDATE_MEM32(ALECR, mcastMTU, MultiCastMTU_MASK, MultiCastMTU_OFFSET);
+
+	return SUCCESS;
+}
+
+/*
+@func int32		|	rtl8651_setAsicMulticastMTU 	| Get MTU for ASIC IP multicast forwarding
+@parm uint32*	|	mcastMTU	| Pointer to get MTU used by HW IP multicast forwarding.
+@rvalue FAILED	|	Failed
+@rvalue SUCCESS	|	Success
+@comm
+To get the MTU value for ASIC IP multicast forwarding.
+Its independent from other packet forwarding because IP multicast would include L2/L3/L4 at one time.
+*/
+int32 rtl8651_getAsicMulticastMTU(uint32 *mcastMTU)
+{
+	if (mcastMTU == NULL)
+	{
+		return FAILED;
+	}
+
+	*mcastMTU = GET_MEM32_VAL(ALECR, MultiCastMTU_MASK, MultiCastMTU_OFFSET);
+
+	return SUCCESS;
+}
+
+int32 rtl865x_setAsicMulticastAging(uint32 enable)
+{
+	if (enable == TRUE)
+	{
+		WRITE_MEM32(TEACR, READ_MEM32(TEACR) & ~IPMcastAgingDisable);
+
+	} else
+	{
+		WRITE_MEM32(TEACR, READ_MEM32(TEACR)|IPMcastAgingDisable);
+	}
+
+	return SUCCESS;
+}
+int32 rtl865x_getAsicMCastHashMethod(unsigned int *hashMethod)
+{
+	if(hashMethod==NULL)
+	{
+		return FAILED;
+	}
+	*hashMethod = (READ_MEM32(FFCR) & 0x60)>>5;
+
+	return SUCCESS;
+}
+
+int32 rtl865x_setAsicMCastHashMethod(unsigned int hashMethod)
+{
+	uint32 	  oldHashMethod = 0;
+	uint32 	  currHashMethod = 0;
+	oldHashMethod = (READ_MEM32(FFCR) & 0x60)>>5;
+	currHashMethod = hashMethod;
+	if(currHashMethod >3)
+	{
+		return FAILED;
+	}
+	currHashMethod=currHashMethod&0x3;
+	if (oldHashMethod != currHashMethod) /* set FFCR Register bit 5~6 */
+	{
+		WRITE_MEM32(FFCR,(READ_MEM32(FFCR) & 0xFFFFFF9F)|(currHashMethod << 5));
+	}
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F) //add for 8198C ipv6 (+)
+
+int32 rtl8198C_setAsicMulticastv6Enable(uint32 enable)
+{
+	if (enable == TRUE)
+	{
+		WRITE_MEM32(IPV6CR0, READ_MEM32(IPV6CR0)|EN_MCASTv6);
+	}
+	else
+	{
+		WRITE_MEM32(IPV6CR0, READ_MEM32(IPV6CR0) & ~EN_MCASTv6);
+	}
+	return SUCCESS;
+}
+int32 rtl8198C_getAsicMulticastv6Enable(uint32 *enable)
+{
+	if (enable == NULL)
+	{
+		return FAILED;
+	}
+
+	*enable = (READ_MEM32(IPV6CR0) & EN_MCASTv6) ? TRUE : FALSE;
+
+	return SUCCESS;
+}
+int32 rtl8198C_setAsicMulticastv6MTU(uint32 mcastMTU)
+{
+	if (mcastMTU & ~(MultiCastv6MTU_MASK) )
+	{	/* multicast MTU overflow */
+		return FAILED;
+	}
+
+	UPDATE_MEM32(IPV6CR0, mcastMTU, MultiCastv6MTU_MASK, MultiCastv6MTU_OFFSET);
+
+	return SUCCESS;
+}
+int32 rtl8198C_getAsicMulticastv6MTU(uint32 *mcastMTU)
+{
+	if (mcastMTU == NULL)
+	{
+		return FAILED;
+	}
+
+	*mcastMTU = GET_MEM32_VAL(IPV6CR0, MultiCastv6MTU_MASK, MultiCastv6MTU_OFFSET);
+
+	return SUCCESS;
+}
+int32 rtl8198C_getAsicMCastv6HashMethod(unsigned int *hashMethod)
+{
+	if(hashMethod==NULL)
+	{
+		return FAILED;
+	}
+	*hashMethod = (READ_MEM32(IPV6CR0) & 0x60000)>>17;
+	return SUCCESS;
+}
+int32 rtl8198C_setAsicMCastv6HashMethod(unsigned int hashMethod)//to be checked
+{
+	uint32	  oldHashMethod = 0;
+	oldHashMethod = (READ_MEM32(IPV6CR0) & 0x60000)>>17;
+	currHashMethod = hashMethod;
+	if(hashMethod >3)
+	{
+		return FAILED;
+	}
+
+	hashMethod=hashMethod&0x3;
+
+	if (oldHashMethod != hashMethod) /* set IPV6CR Register bit 17~18 and flush multicastv6 table */
+	{
+		WRITE_MEM32(IPV6CR0,(READ_MEM32(IPV6CR0) & 0xFFF9FFFF)|(currHashMethod << 17));
+	}
+	return SUCCESS;
+}
+int32 rtl8198C_setAsicMulticastv6Aging(uint32 enable)
+{
+	if (enable == TRUE)
+	{
+		WRITE_MEM32(TEACR, READ_MEM32(TEACR) & ~IPv6McastAgingDisable);
+
+	} else
+	{
+		WRITE_MEM32(TEACR, READ_MEM32(TEACR)|IPv6McastAgingDisable);
+	}
+
+	return SUCCESS;
+}
+
+
+///////////////
+//6rd
+///////////////
+int32 rtl8198C_setAsic6rdTable(uint32 index, rtl8198C_tblAsicDrv_6rdParam_t *six_rd_entry)
+{
+	uint32 asicMask=0;
+	rtl8198C_tblAsic_6rdTable_t  entry;
+
+	if((index >= RTL8198C_6RDTBL_SIZE ) || (six_rd_entry == NULL))
+		return FAILED;
+
+	if((six_rd_entry->six_rd_prefix_len==0)||(six_rd_entry->br_ip_mask_len==0))
+	{
+		return FAILED;
+	}
+
+	/* for debug
+	rtlglue_printf("[%s:%d] rtl8198C_setAsic6rdTable(idx=%d,Row=%d,Col=%d,PPPIdx=%d,dvid=%d,IPIdx=%d,type=%d)\n",
+		__FILE__,__LINE__,index, nextHopp->nextHopRow,nextHopp->nextHopColumn,nextHopp->pppoeIdx,
+		nextHopp->dvid,nextHopp->extIntIpIdx,nextHopp->isPppoe);
+	*/
+	memset(&entry,0,sizeof(entry));
+	entry.ce_ip_addr = six_rd_entry->ce_ip_addr;
+
+#if 0
+	for(i=0; i<32; i++)
+		if(six_rd_entry->ce_ip_mask & (1<<i)) break;
+	asicMask = i;
+	printk("six_rd_entry->ce_ip_mask:0x%x i:%d asicMask:%d\n",six_rd_entry->ce_ip_mask,i,asicMask);//leroy
+
+
+
+	if (1/*six_rd_entry->ce_ip_mask*/) {
+		for(i=0; i<32; i++)
+			if(six_rd_entry->ce_ip_mask & (1<<i)) break;
+		///leroy////asicMask = 31 - i;
+		if(i!=0)
+		    asicMask = i-1;
+		else
+			asicMask = 0;//31
+		printk("six_rd_entry->ce_ip_mask:0x%x i:%d asicMask:%d\n",six_rd_entry->ce_ip_mask,i,asicMask);//leroy
+	} else asicMask = 0;
+#endif
+	entry.ce_ip_mask      = 32-six_rd_entry->ce_ip_mask_len;
+	entry.six_rd_pfx25_0  = six_rd_entry->six_rd_prefix.v6_addr32[1]
+						    &0x3FFFFFF;
+	entry.six_rd_pfx57_26 =(  (six_rd_entry->six_rd_prefix.v6_addr32[0]<<6)|
+		                      (six_rd_entry->six_rd_prefix.v6_addr32[1]>>26) );
+	entry.six_rd_pfx63_58 = (six_rd_entry->six_rd_prefix.v6_addr32[0]>>26);
+
+	if (six_rd_entry->six_rd_prefix_len){
+		asicMask=six_rd_entry->six_rd_prefix_len-1;
+	}else{
+		asicMask=0;
+	}
+	entry.pfx_mask        = asicMask ;
+	entry.br_ip_addr19_0  = six_rd_entry->br_ip_addr&0xFFFFF;
+	entry.br_ip_addr31_20 = six_rd_entry->br_ip_addr>>20;
+
+#if 0
+	if (1/*six_rd_entry->br_ip_mask*/) {
+		for(i=0; i<32; i++)
+			if(six_rd_entry->br_ip_mask & (1<<i)) break;
+		///leroy////asicMask = 31 - i;
+		if(i!=0)
+		    asicMask = i-1;
+		else
+			asicMask = 0;//31
+		printk("six_rd_entry->br_ip_mask:0x%x i:%d asicMask:%d\n",six_rd_entry->br_ip_mask,i,asicMask);//leroy
+	} else asicMask = 0;
+	entry.br_ip_mask = asicMask ;
+#endif
+
+	if (six_rd_entry->br_ip_mask_len){
+		asicMask=six_rd_entry->br_ip_mask_len-1;
+	}else{
+		asicMask=0;
+	}
+
+	entry.br_ip_mask = asicMask ;
+	entry.six_rd_mtu = six_rd_entry->mtu;
+	entry.valid      = six_rd_entry->valid;
+	return _rtl8651_forceAddAsicEntry(TYPE_6RD_TABLE, index, &entry);
+}
+
+int32 rtl8198C_delAsic6rdTable(uint32 index)
+{
+	rtl8198C_tblAsic_6rdTable_t   entry;
+	if(index >= RTL8198C_6RDTBL_SIZE)
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	return _rtl8651_forceAddAsicEntry(TYPE_6RD_TABLE, index, &entry);
+}
+
+int32 rtl8198C_getAsic6rdTable(uint32 index, rtl8198C_tblAsicDrv_6rdParam_t *six_rd_entry)
+{
+	rtl8198C_tblAsic_6rdTable_t  entry;
+	if((index>=RTL8198C_6RDTBL_SIZE) || (six_rd_entry == NULL))
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));   //leroy todo remove this
+	_rtl8651_readAsicEntry(TYPE_6RD_TABLE, index, &entry);
+
+	if(entry.valid == 0)
+		return FAILED;
+
+
+	six_rd_entry->ce_ip_addr = entry.ce_ip_addr;
+
+	////six_rd_entry->ce_ip_mask_len = entry.ce_ip_mask+1;
+	six_rd_entry->ce_ip_mask_len = 32-entry.ce_ip_mask;
+	////for(i=0, six_rd_entry->ce_ip_mask = 0; i<entry.ce_ip_mask; i++)
+	////	six_rd_entry->ce_ip_mask |= 1<<(i);
+
+	six_rd_entry->six_rd_prefix.v6_addr32[1]= entry.six_rd_pfx25_0
+		                                    |((entry.six_rd_pfx57_26 &0x3F)<<26) ;
+	six_rd_entry->six_rd_prefix.v6_addr32[0]= ((entry.six_rd_pfx57_26 &(~0x3F))>>6)
+											|((entry.six_rd_pfx63_58 &0x3F)<<26) ;
+	six_rd_entry->six_rd_prefix_len=entry.pfx_mask+1;
+	six_rd_entry->br_ip_addr = entry.br_ip_addr19_0 | (entry.br_ip_addr31_20<<20);
+	six_rd_entry->mtu        = entry.six_rd_mtu;
+	six_rd_entry->valid      = entry.valid;
+
+	//for(i=0, six_rd_entry->br_ip_mask = 0; i<=entry.br_ip_mask; i++)
+	//	six_rd_entry->br_ip_mask |= 1<<(i);
+	six_rd_entry->br_ip_mask_len = entry.br_ip_mask+1;
+
+	return SUCCESS;
+}
+
+///////////////
+//dslite
+///////////////
+int32 rtl8198C_setAsicDsliteTable(uint32 index, rtl8198C_tblAsicDrv_dsliteParam_t *dslite_entry)
+{
+	uint32 asicMask;
+	rtl8198C_tblAsic_dsliteTable_t  entry;
+
+	if((index >= RTL8198C_DSLITETBL_SIZE ) || (dslite_entry == NULL))
+	{
+		return FAILED;
+	}
+	/* for debug
+	rtlglue_printf("[%s:%d] rtl8651_setAsic6rdTable(idx=%d,Row=%d,Col=%d,PPPIdx=%d,dvid=%d,IPIdx=%d,type=%d)\n",
+		__FILE__,__LINE__,index, nextHopp->nextHopRow,nextHopp->nextHopColumn,nextHopp->pppoeIdx,
+		nextHopp->dvid,nextHopp->extIntIpIdx,nextHopp->isPppoe);
+	*/
+	memset(&entry,0,sizeof(entry));
+	entry.host_ipv6_addr31_0   = dslite_entry->host_ipv6_addr.v6_addr32[3];
+	entry.host_ipv6_addr63_32  = dslite_entry->host_ipv6_addr.v6_addr32[2];
+	entry.host_ipv6_addr95_64  = dslite_entry->host_ipv6_addr.v6_addr32[1];
+	entry.host_ipv6_addr127_96 = dslite_entry->host_ipv6_addr.v6_addr32[0];
+
+	if (dslite_entry->host_ipv6_mask) {
+		asicMask = dslite_entry->host_ipv6_mask-1;
+	} else{
+		asicMask = 0;
+	}
+	entry.host_ipv6_mask = asicMask;
+
+	entry.aftr_ipv6_addr24_0    =     dslite_entry->aftr_ipv6_addr.v6_addr32[3]&0x1FFFFFF;
+	entry.aftr_ipv6_addr56_25   = (  (dslite_entry->aftr_ipv6_addr.v6_addr32[2]<<7)|
+		                             (dslite_entry->aftr_ipv6_addr.v6_addr32[3]>>25) );
+	entry.aftr_ipv6_addr88_57   = (  (dslite_entry->aftr_ipv6_addr.v6_addr32[1]<<7)|
+		                             (dslite_entry->aftr_ipv6_addr.v6_addr32[2]>>25) );
+	entry.aftr_ipv6_addr120_89  = (  (dslite_entry->aftr_ipv6_addr.v6_addr32[0]<<7)|
+		                             (dslite_entry->aftr_ipv6_addr.v6_addr32[1]>>25) );
+	entry.aftr_ipv6_addr127_121 = (   dslite_entry->aftr_ipv6_addr.v6_addr32[0]>>25);
+
+	if (dslite_entry->aftr_ipv6_mask){
+		asicMask = dslite_entry->aftr_ipv6_mask-1;
+	}else{
+		asicMask = 0;
+	}
+	entry.aftr_ipv6_mask = asicMask ;
+	entry.dslite_mtu     = dslite_entry->mtu;
+	entry.valid          = dslite_entry->valid;
+	return _rtl8651_forceAddAsicEntry(TYPE_DS_LITE_TABLE, index, &entry);
+}
+
+int32 rtl8198C_delAsicDsliteTable(uint32 index)
+{
+	rtl8198C_tblAsic_dsliteTable_t   entry;
+	if(index >= RTL8198C_DSLITETBL_SIZE)
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	return _rtl8651_forceAddAsicEntry(TYPE_DS_LITE_TABLE, index, &entry);
+}
+
+int32 rtl8198C_getAsicDsliteTable(uint32 index, rtl8198C_tblAsicDrv_dsliteParam_t *dslite_entry)
+{
+	rtl8198C_tblAsic_dsliteTable_t  entry;
+	if((index>=RTL8198C_DSLITETBL_SIZE) || (dslite_entry == NULL))
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+
+	_rtl8651_readAsicEntry(TYPE_DS_LITE_TABLE, index, &entry);
+	if(entry.valid == 0)
+		return FAILED;
+
+	dslite_entry->host_ipv6_addr.v6_addr32[3]= entry.host_ipv6_addr31_0;
+	dslite_entry->host_ipv6_addr.v6_addr32[2]= entry.host_ipv6_addr63_32;
+	dslite_entry->host_ipv6_addr.v6_addr32[1]= entry.host_ipv6_addr95_64;
+	dslite_entry->host_ipv6_addr.v6_addr32[0]= entry.host_ipv6_addr127_96;
+
+	dslite_entry->host_ipv6_mask=entry.host_ipv6_mask+1;
+	dslite_entry->aftr_ipv6_addr.v6_addr32[3]= entry.aftr_ipv6_addr24_0 |
+	 											(entry.aftr_ipv6_addr56_25<<25)	;
+
+	dslite_entry->aftr_ipv6_addr.v6_addr32[2]= (entry.aftr_ipv6_addr88_57<<25)|
+												(entry.aftr_ipv6_addr56_25>>7)	;
+
+	dslite_entry->aftr_ipv6_addr.v6_addr32[1]= (entry.aftr_ipv6_addr120_89<<25)|
+												(entry.aftr_ipv6_addr88_57>>7)	;
+
+	dslite_entry->aftr_ipv6_addr.v6_addr32[0]= (entry.aftr_ipv6_addr127_121<<25)|
+												(entry.aftr_ipv6_addr120_89>>7)	;
+
+	dslite_entry->aftr_ipv6_mask=entry.aftr_ipv6_mask+1;
+	dslite_entry->mtu   = entry.dslite_mtu;
+	dslite_entry->valid = entry.valid;
+	return SUCCESS;
+}
+
+int32 rtl8198C_setAsicRoutingv6(uint32 index, rtl8198C_tblAsicDrv_routingv6Param_t *routingp)
+{
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	extern int dslite_hw_fw ;
+#endif
+
+	uint32 asicMask;
+	rtl8198C_tblAsic_l3v6RouteTable_t entry;
+
+/*
+#ifdef FPGA
+	if (index==2) index=6;
+	if (index==3) index=7;
+	if (index>=4 && index <=5)
+		rtlglue_printf("Out of range\n");
+#endif
+*/
+	if((index >= RTL8198C_ROUTINGV6TBL_SIZE) || (routingp == NULL))
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	entry.ipv6_addr31_0   = routingp->ipAddr.v6_addr32[3];
+	entry.ipv6_addr63_32  = routingp->ipAddr.v6_addr32[2];
+	entry.ipv6_addr95_64  = routingp->ipAddr.v6_addr32[1];
+	entry.ipv6_addr127_96 = routingp->ipAddr.v6_addr32[0];
+
+	if (routingp->ipMask) {
+		asicMask=routingp->ipMask-1;
+	} else{
+		asicMask = 0;
+	}
+	switch(routingp->process) {
+		case 0://PPPoE
+			entry.linkTo.PPPoEEntry.PPPoEIndex = routingp->pppoeIdx;
+			entry.linkTo.PPPoEEntry.nextHop    = (routingp->nextHopRow <<2) | routingp->nextHopColumn;
+			entry.linkTo.PPPoEEntry.IPMask     = asicMask;
+			entry.linkTo.PPPoEEntry.netif      = routingp->vidx;
+			entry.linkTo.PPPoEEntry.process    = routingp->process;
+			entry.linkTo.PPPoEEntry.valid      = 1;
+			break;
+		case 1://Direct
+			entry.linkTo.L2Entry.nextHop = (routingp->nextHopRow <<2) | routingp->nextHopColumn;
+			entry.linkTo.L2Entry.IPMask  = asicMask;
+			entry.linkTo.L2Entry.netif   = routingp->vidx;
+			entry.linkTo.L2Entry.process = routingp->process;
+			entry.linkTo.L2Entry.valid   = 1;
+			break;
+
+		case 2://arp
+			entry.linkTo.ARPEntry.IPMask   = asicMask;
+			entry.linkTo.ARPEntry.netif    = routingp->vidx;
+			entry.linkTo.ARPEntry.process  = routingp->process;
+			entry.linkTo.ARPEntry.subnet_idx = routingp->subnet_idx;
+			entry.linkTo.ARPEntry.valid    = 1;
+#if 0
+			printk("rtl8651_setAsicRoutingv6 arp\n");
+			printk("ARPEntry.ARPEnd   :0x%x\n",entry.linkTo.ARPEntry.ARPEnd);
+			printk("ARPEntry.ARPStart :0x%x\n",entry.linkTo.ARPEntry.ARPStart);
+			printk("ARPEntry.IPMask   :0x%x\n",entry.linkTo.ARPEntry.IPMask);
+			printk("ARPEntry.netif    :0x%x\n",entry.linkTo.ARPEntry.netif);
+			printk("ARPEntry.process  :0x%x\n",entry.linkTo.ARPEntry.process);
+#endif
+			break;
+		case 4://CPU
+		case 6://DROP
+			/*
+			  *   Note:  although the process of this routing entry is CPU/DROP,
+			  *             we still have to assign "vid" field for packet decision process use.
+			  *                                                                                          - 2005.3.23 -
+			  */
+			entry.linkTo.ARPEntry.netif   = routingp->vidx;
+			entry.linkTo.ARPEntry.IPMask  = asicMask;
+			entry.linkTo.ARPEntry.process = routingp->process;
+			entry.linkTo.ARPEntry.valid   = 1;
+			break;
+		case 5://NAPT NextHop
+			entry.linkTo.NxtHopEntry.nhStart = routingp->nhStart >> 1;
+
+			switch (routingp->nhNum)
+			{
+			    case 2: entry.linkTo.NxtHopEntry.nhNum  = 0; break;
+			    case 4: entry.linkTo.NxtHopEntry.nhNum  = 1; break;
+			    case 8: entry.linkTo.NxtHopEntry.nhNum  = 2; break;
+			    case 16: entry.linkTo.NxtHopEntry.nhNum = 3; break;
+			    case 32: entry.linkTo.NxtHopEntry.nhNum = 4; break;
+			    default: return FAILED;
+			}
+			entry.linkTo.NxtHopEntry.nhNxt   = routingp->nhNxt;
+			entry.linkTo.NxtHopEntry.nhAlgo  = routingp->nhAlgo;
+
+			entry.linkTo.NxtHopEntry.IPMask  = asicMask;
+			entry.linkTo.NxtHopEntry.process = routingp->process;
+			entry.linkTo.NxtHopEntry.valid   = 1;
+
+			break;
+
+		default:
+			return FAILED;
+	}
+
+	entry.six_rd_eg  = routingp->six_rd_eg;
+	entry.six_rd_idx = routingp->six_rd_idx;
+
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	if(dslite_hw_fw)
+	{
+		if(entry.linkTo.ARPEntry.process  ==2){
+			return FAILED;
+		}
+	}
+#endif
+	return _rtl8651_forceAddAsicEntry(TYPE_L3_V6_ROUTING_TABLE, index, &entry);
+
+}
+
+int32 rtl8198C_delAsicRoutingv6(uint32 index)
+{
+	rtl8198C_tblAsic_l3v6RouteTable_t entry;
+
+	if(index >= RTL8198C_ROUTINGV6TBL_SIZE)
+		return FAILED;
+	memset(&entry,0,sizeof(entry));
+	entry.linkTo.ARPEntry.valid = 0;
+	return _rtl8651_forceAddAsicEntry(TYPE_L3_V6_ROUTING_TABLE, index, &entry);
+}
+
+int32 rtl8198C_getAsicRoutingv6(uint32 index, rtl8198C_tblAsicDrv_routingv6Param_t *routingp)
+{
+	rtl8198C_tblAsic_l3v6RouteTable_t entry;
+
+	if((index >= RTL8198C_ROUTINGV6TBL_SIZE) || (routingp == NULL))
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	_rtl8651_readAsicEntry(TYPE_L3_V6_ROUTING_TABLE, index, &entry);
+
+	if(entry.linkTo.ARPEntry.valid == 0)
+		return FAILED;
+
+	routingp->ipAddr.v6_addr32[3]= entry.ipv6_addr31_0;
+	routingp->ipAddr.v6_addr32[2]= entry.ipv6_addr63_32;
+	routingp->ipAddr.v6_addr32[1]= entry.ipv6_addr95_64;
+	routingp->ipAddr.v6_addr32[0]= entry.ipv6_addr127_96;
+
+	routingp->process = entry.linkTo.ARPEntry.process;
+
+	routingp->vidx = entry.linkTo.ARPEntry.netif;
+
+	switch(routingp->process) {
+		case 0://PPPoE
+			routingp->arpStart = 0;
+			routingp->arpEnd = 0;
+			routingp->pppoeIdx = entry.linkTo.PPPoEEntry.PPPoEIndex;
+			routingp->nextHopRow = entry.linkTo.PPPoEEntry.nextHop>>2;
+			routingp->nextHopColumn = entry.linkTo.PPPoEEntry.nextHop & 0x3;
+			routingp->ipMask=entry.linkTo.PPPoEEntry.IPMask+1;
+			break;
+		case 1://Direct
+			routingp->arpStart = 0;
+			routingp->arpEnd = 0;
+			routingp->pppoeIdx = 0;
+			routingp->nextHopRow = entry.linkTo.L2Entry.nextHop>>2;
+			routingp->nextHopColumn = entry.linkTo.L2Entry.nextHop&0x3;
+			routingp->ipMask=entry.linkTo.L2Entry.IPMask+1;
+			break;
+		case 2://arp
+			routingp->arpStart = 0;
+			routingp->arpEnd = 0;
+			routingp->pppoeIdx   = 0;
+			routingp->nextHopRow = 0;
+			routingp->nextHopColumn = 0;
+			routingp->subnet_idx= entry.linkTo.ARPEntry.subnet_idx;
+			routingp->ipMask=entry.linkTo.ARPEntry.IPMask+1;
+			break;
+		case 4: /* CPU */
+		case 6: /* Drop */
+			routingp->arpStart      = 0;
+			routingp->arpEnd        = 0;
+			routingp->pppoeIdx      = 0;
+			routingp->nextHopRow    = 0;
+			routingp->nextHopColumn = 0;
+			routingp->ipMask        = 0;
+			break;
+
+		case 5:
+			routingp->nhStart = (entry.linkTo.NxtHopEntry.nhStart) << 1;
+			switch (entry.linkTo.NxtHopEntry.nhNum)
+			{
+				case 0: routingp->nhNum = 2; break;
+				case 1: routingp->nhNum = 4; break;
+				case 2: routingp->nhNum = 8; break;
+				case 3: routingp->nhNum = 16; break;
+				case 4: routingp->nhNum = 32; break;
+				default: return FAILED;
+			}
+			routingp->nhNxt = entry.linkTo.NxtHopEntry.nhNxt;
+			routingp->nhAlgo = entry.linkTo.NxtHopEntry.nhAlgo;
+			routingp->ipMask=entry.linkTo.NxtHopEntry.IPMask+1;
+			break;
+
+		default:
+		    return FAILED;
+	}
+
+
+	routingp->six_rd_eg  = entry.six_rd_eg;
+	routingp->six_rd_idx = entry.six_rd_idx;
+
+#if 0
+	printk("ipAddr:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n"
+		,routingp->ipAddr.v6_addr16[0],routingp->ipAddr.v6_addr16[1]
+		,routingp->ipAddr.v6_addr16[2],routingp->ipAddr.v6_addr16[3]
+		,routingp->ipAddr.v6_addr16[4],routingp->ipAddr.v6_addr16[5]
+		,routingp->ipAddr.v6_addr16[6],routingp->ipAddr.v6_addr16[7]);
+	printk("ipMask     :0x%x\n",routingp->ipMask);
+	printk("process    :0x%x\n",routingp->process);
+	printk("vidx       :0x%x\n",routingp->vidx);
+	printk("arpStart   :0x%x\n",routingp->arpStart);
+	printk("arpEnd     :0x%x\n",routingp->arpEnd);
+	printk("nextHopRow   :0x%x\n",routingp->nextHopRow);
+	printk("nextHopColumn:0x%x\n",routingp->nextHopColumn);
+	printk("pppoeIdx     :0x%x\n",routingp->pppoeIdx);
+	printk("nhStart   :0x%x\n",routingp->nhStart);
+	printk("nhNum     :0x%x\n",routingp->nhNum);
+	printk("nhNxt     :0x%x\n",routingp->nhNxt);
+	printk("nhAlgo    :0x%x\n",routingp->nhAlgo);
+	printk("six_rd_eg :0x%x\n",routingp->six_rd_eg);
+	printk("six_rd_idx:0x%x\n",routingp->six_rd_idx);
+#endif
+	return SUCCESS;
+}
+
+
+/*=========================================
+  * ASIC DRIVER API: IPv6 ARP Table
+  *=========================================*/
+int32 rtl8198C_Arpv6TableIndex(rtl8198C_tblAsicDrv_arpV6Param_t *arpp)
+{
+	uint32 hash_idx_arpv6;
+	uint32 id[66];
+	uint32 arpv6_hash_idx[6],arpv6_hash[6];
+	uint32 i,offset,src;
+
+	for(i=0; i<6; i++) {
+		arpv6_hash_idx[i]=0;
+	}
+
+	offset = 0;
+	src = arpp->hostid.v6_addr32[3];
+	for(i=0; i<32; i++)	{
+		if((src& (1<<i))!=0) {
+			id[i+offset]=1;
+		}
+		else 	{
+			id[i+offset]=0;
+		}
+	}
+
+	offset = 32;
+	src = arpp->hostid.v6_addr32[2];
+	for(i=0; i<32; i++)	{
+		if((src& (1<<i))!=0) {
+			id[i+offset]=1;
+		}
+		else 	{
+			id[i+offset]=0;
+		}
+	}
+
+	offset = 64;
+	src = arpp->subnet_id;
+	 for(i=0; i<3; i++)	{
+		if((src& (1<<i))!=0) {
+			id[i+offset]=1;
+		}
+		else 	{
+			id[i+offset]=0;
+		}
+	}
+
+	arpv6_hash_idx[0] = id[0] ^ id[6]  ^ id[12] ^ id[18] ^ id[24] ^ id[30] ^ id[36] ^ id[42] ^ id[48] ^ id[54] ^ id[60] ^ id[66];
+	arpv6_hash_idx[1] = id[1] ^ id[7]  ^ id[13] ^ id[19] ^ id[25] ^ id[31] ^ id[37] ^ id[43] ^ id[49] ^ id[55] ^ id[61] ;
+	arpv6_hash_idx[2] = id[2] ^ id[8]  ^ id[14] ^ id[20] ^ id[26] ^ id[32] ^ id[38] ^ id[44] ^ id[50] ^ id[56] ^ id[62] ;
+	arpv6_hash_idx[3] = id[3] ^ id[9]  ^ id[15] ^ id[21] ^ id[27] ^ id[33] ^ id[39] ^ id[45] ^ id[51] ^ id[57] ^ id[63] ;
+	arpv6_hash_idx[4] = id[4] ^ id[10] ^ id[16] ^ id[22] ^ id[28] ^ id[34] ^ id[40] ^ id[46] ^ id[52] ^ id[58] ^ id[64] ;
+	arpv6_hash_idx[5] = id[5] ^ id[11] ^ id[17] ^ id[23] ^ id[29] ^ id[35] ^ id[41] ^ id[47] ^ id[53] ^ id[59] ^ id[65] ;
+
+	for(i=0; i<6; i++) {
+		arpv6_hash[i]=arpv6_hash_idx[i] & (0x01);
+	}
+
+	hash_idx_arpv6=0;
+	for(i=0; i<6; i++) {
+		hash_idx_arpv6=hash_idx_arpv6+(arpv6_hash[i]<<i);
+	}
+
+	////printk("hash_idx_arpv6:0x%x @ rtl8651_Arpv6TableIndexn\n",hash_idx_arpv6);
+	return hash_idx_arpv6;
+}
+
+int32 rtl8198C_addAsicArpV6(uint32 index, rtl8198C_tblAsicDrv_arpV6Param_t *arpp)
+{
+	uint32 found=0;
+	uint32 rowIdx=0,colIdx=0;
+	rtl8198C_tblAsicDrv_arpV6Param_t   tbl_entry;
+
+	rowIdx = rtl8198C_Arpv6TableIndex(arpp);
+	memset(&tbl_entry,0,sizeof(tbl_entry));
+
+	for(colIdx=0;colIdx<4;colIdx++)
+	{
+		tbl_entry.nextHopRow=1;////for rtl8198C_getAsicArpV6 response real get failed or valid==0
+		if ((rtl8198C_getAsicArpV6(rowIdx<<2|colIdx,&tbl_entry))!=SUCCESS)
+		{
+			if(tbl_entry.nextHopRow==1) /*real get failed*/
+			{
+				goto rtl8198C_addAsicArpV6_err;
+			}
+			else/*tbl_entry.nextHopRow==0 ==> an empty entry */
+			{
+				found = TRUE;
+			}
+		}
+		else        /*get one non empty entry==> compare.*/
+		{
+			if((tbl_entry.subnet_id == arpp->subnet_id) &&
+				(memcmp(&tbl_entry.hostid,&arpp->hostid,sizeof(inv6_addr_t))==0)    )
+			{
+				found = TRUE;
+			}
+		}
+
+		if (found == TRUE)
+			break;
+	}
+
+	if(found == TRUE )
+	{
+		if(rtl8198C_setAsicArpV6(rowIdx<<2|colIdx,arpp)==SUCCESS);
+			return SUCCESS;
+	}
+
+	/*all 4-way full*/
+rtl8198C_addAsicArpV6_err:
+	return FAILED;
+}
+
+int32 rtl8198C_setAsicArpV6(uint32 index, rtl8198C_tblAsicDrv_arpV6Param_t *arpp)
+{
+	rtl8198C_tblAsic_arpV6Table_t   entry;
+
+	if((index >= RTL8198C_ARPV6TBL_SIZE) || (arpp == NULL))
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	entry.nextHop    = (arpp->nextHopRow<<2) | (arpp->nextHopColumn&0x3);
+	entry.valid      = 1;
+	entry.aging      = arpp->aging;
+	entry.subnet_idx = arpp->subnet_id;
+
+	entry.host_id_17_0  = arpp->hostid.v6_addr32[3]&0x3FFFF;
+	entry.host_id_49_18 = (arpp->hostid.v6_addr32[2]<<14)|(arpp->hostid.v6_addr32[3]>>18);
+	entry.host_id_63_50 = arpp->hostid.v6_addr32[2]>>18;
+
+	return _rtl8651_forceAddAsicEntry(TYPE_ARP_V6_TABLE, index, &entry);
+}
+
+int32 rtl8198C_delAsicArpV6(uint32 index)
+{
+	rtl8198C_tblAsic_arpV6Table_t   entry;
+	if(index >= RTL8198C_ARPV6TBL_SIZE)
+		return FAILED;
+
+	memset(&entry,0,sizeof(entry));
+	entry.valid = 0;
+	return _rtl8651_forceAddAsicEntry(TYPE_ARP_V6_TABLE, index, &entry);
+}
+
+int32 rtl8198C_getAsicArpV6(uint32 index, rtl8198C_tblAsicDrv_arpV6Param_t *arpp)
+{
+	rtl8198C_tblAsic_arpV6Table_t   entry;
+
+	if( (index >= RTL8198C_ARPV6TBL_SIZE) || (arpp == NULL))
+		return FAILED;
+	//_rtl8651_readAsicEntry(TYPE_ARP_TABLE, index, &entry);
+	/*for 8196B patch,read arp table and ip multicast table should stop TLU*/
+
+	memset(&entry,0,sizeof(entry));
+	_rtl8651_readAsicEntryStopTLU(TYPE_ARP_V6_TABLE, index, &entry);
+
+	if(entry.valid == 0)
+	{
+		arpp->nextHopRow=0;//for upper layer more information.
+		return FAILED;
+	}
+	arpp->nextHopRow    = entry.nextHop>>2;
+	arpp->nextHopColumn = entry.nextHop&0x3;
+	arpp->aging         = entry.aging&0x1f;
+	arpp->subnet_id     = entry.subnet_idx;
+	arpp->valid         = entry.valid;
+
+	arpp->hostid.v6_addr32[3] =  (entry.host_id_17_0) |
+								 ((entry.host_id_49_18&0x3FFF)<<18);
+	arpp->hostid.v6_addr32[2] =  (entry.host_id_49_18>>14) |
+								 (entry.host_id_63_50<<18);
+	return SUCCESS;
+}
+
+int32 rtl8198C_setAsicNextHopTableV6(uint32 index, rtl8198C_tblAsicDrv_nextHopV6Param_t *nextHopp)
+{
+	rtl8198C_tblAsic_nextHopV6Table_t  entry;
+
+	if((index >= RTL8198C_NEXTHOPV6TBL_SIZE ) || (nextHopp == NULL))
+		return FAILED;
+
+	/* for debug
+	rtlglue_printf("[%s:%d] rtl8651_setAsicNextHopTable(idx=%d,Row=%d,Col=%d,PPPIdx=%d,dvid=%d,IPIdx=%d,type=%d)\n",
+		__FILE__,__LINE__,index, nextHopp->nextHopRow,nextHopp->nextHopColumn,nextHopp->pppoeIdx,
+		nextHopp->dvid,nextHopp->extIntIpIdx,nextHopp->isPppoe);
+	*/
+	memset(&entry,0,sizeof(entry));
+	entry.nextHop    = (nextHopp->nextHopRow <<2) | nextHopp->nextHopColumn;
+	entry.PPPoEIndex = nextHopp->pppoeIdx;
+	entry.dstVid     = nextHopp->dvid;
+	entry.type       = nextHopp->isPppoe==TRUE? 1: 0;
+	return _rtl8651_forceAddAsicEntry(TYPE_NEXT_HOP_V6_TABLE, index, &entry);
+}
+
+int32 rtl8198C_delAsicNextHopTableV6(uint32 index)
+{
+	rtl8198C_tblAsic_nextHopV6Table_t   entry;
+	if(index>=RTL8198C_NEXTHOPV6TBL_SIZE)
+		return FAILED;
+	memset(&entry,0,sizeof(entry));
+	return _rtl8651_forceAddAsicEntry(TYPE_NEXT_HOP_V6_TABLE, index, &entry);
+}
+
+int32 rtl8198C_getAsicNextHopTableV6(uint32 index, rtl8198C_tblAsicDrv_nextHopV6Param_t *nextHopp)
+{
+	rtl8198C_tblAsic_nextHopV6Table_t  entry;
+	if((index>=RTL8198C_NEXTHOPV6TBL_SIZE) || (nextHopp == NULL))
+		return FAILED;
+
+	_rtl8651_readAsicEntry(TYPE_NEXT_HOP_V6_TABLE, index, &entry);
+	nextHopp->nextHopRow    = entry.nextHop>>2;
+	nextHopp->nextHopColumn = entry.nextHop&0x3;
+	nextHopp->pppoeIdx      = entry.PPPoEIndex;
+	nextHopp->dvid          = entry.dstVid;
+	nextHopp->isPppoe       = entry.type==1? TRUE: FALSE;
+	return SUCCESS;
+}
+
+
+/*=========================================
+  * ASIC DRIVER API: IPv6 Multicast Table
+  *=========================================*/
+uint32 rtl8198C_ipMulticastv6TableIndex(uint32 hash_type,inv6_addr_t srcAddr, inv6_addr_t dstAddr)
+{
+	uint32 idx=0,hash_idx_sip,hash_idx_dip;
+	static uint32 sip[128],dip[128];
+	uint32 sip_hash[8],dip_hash[8];
+	uint32 i,j,offset,src,dst;
+
+	if(hash_type==2)
+	{
+		idx = srcAddr.v6_addr32[3]&0xFF;
+		return idx;
+	}
+	else if(hash_type==3)
+	{
+		idx = dstAddr.v6_addr32[3]&0xFF;
+		return idx;
+	}
+
+	for(i=0; i<8; i++) {
+		sip_hash[i]=0;
+		dip_hash[i]=0;
+	}
+
+	for(j=0;j<4;j++)
+	{
+		offset = j*32;
+		src = srcAddr.v6_addr32[j];
+		dst = dstAddr.v6_addr32[j];
+		for(i=0; i<32; i++)	{
+			if((src& (1<<i))!=0) {
+				sip[i+offset]=1;
+			}
+			else 	{
+				sip[i+offset]=0;
+			}
+
+			if((dst & (1<<i))!=0) {
+				dip[i+offset]=1;
+			}
+			else {
+				dip[i+offset]=0;
+			}
+		}
+	}
+
+	sip_hash[0] = sip[7] ^ sip[15] ^ sip[23] ^ sip[31] ^ sip[39] ^ sip[47] ^ sip[55] ^ sip[63] ^ sip[71] ^ sip[79] ^ sip[87] ^ sip[95] ^ sip[103]^ sip[111] ^ sip[119] ^ sip[127];
+	sip_hash[1] = sip[6] ^ sip[14] ^ sip[22] ^ sip[30] ^ sip[38] ^ sip[46] ^ sip[54] ^ sip[62] ^ sip[70] ^ sip[78] ^ sip[86] ^ sip[94] ^ sip[102]^ sip[110] ^ sip[118] ^ sip[126];
+	sip_hash[2] = sip[5] ^ sip[13] ^ sip[21] ^ sip[29] ^ sip[37] ^ sip[45] ^ sip[53] ^ sip[61] ^ sip[69] ^ sip[77] ^ sip[85] ^ sip[93] ^ sip[101]^ sip[109] ^ sip[117] ^ sip[125];
+	sip_hash[3] = sip[4] ^ sip[12] ^ sip[20] ^ sip[28] ^ sip[36] ^ sip[44] ^ sip[52] ^ sip[60] ^ sip[68] ^ sip[76] ^ sip[84] ^ sip[92] ^ sip[100]^ sip[108] ^ sip[116] ^ sip[124];
+	sip_hash[4] = sip[3] ^ sip[11] ^ sip[19] ^ sip[27] ^ sip[35] ^ sip[43] ^ sip[51] ^ sip[59] ^ sip[67] ^ sip[75] ^ sip[83] ^ sip[91] ^ sip[99] ^ sip[107] ^ sip[115] ^ sip[123];
+	sip_hash[5] = sip[2] ^ sip[10] ^ sip[18] ^ sip[26] ^ sip[34] ^ sip[42] ^ sip[50] ^ sip[58] ^ sip[66] ^ sip[74] ^ sip[82] ^ sip[90] ^ sip[98] ^ sip[106] ^ sip[114] ^ sip[122];
+	sip_hash[6] = sip[1] ^ sip[9]  ^ sip[17] ^ sip[25] ^ sip[33] ^ sip[41] ^ sip[49] ^ sip[57] ^ sip[65] ^ sip[73] ^ sip[81] ^ sip[89] ^ sip[97] ^ sip[105] ^ sip[113] ^ sip[121];
+	sip_hash[7] = sip[0] ^ sip[8]  ^ sip[16] ^ sip[24] ^ sip[32] ^ sip[40] ^ sip[48] ^ sip[56] ^ sip[64] ^ sip[72] ^ sip[80] ^ sip[88] ^ sip[96] ^ sip[104] ^ sip[112] ^ sip[120];
+
+	dip_hash[7] = dip[7] ^ dip[15] ^ dip[23] ^ dip[31] ^ dip[39] ^ dip[47] ^ dip[55] ^ dip[63] ^ dip[71] ^ dip[79] ^ dip[87] ^ dip[95] ^ dip[103]^ dip[111] ^ dip[119] ^ dip[127];
+	dip_hash[6] = dip[6] ^ dip[14] ^ dip[22] ^ dip[30] ^ dip[38] ^ dip[46] ^ dip[54] ^ dip[62] ^ dip[70] ^ dip[78] ^ dip[86] ^ dip[94] ^ dip[102]^ dip[110] ^ dip[118] ^ dip[126];
+	dip_hash[5] = dip[5] ^ dip[13] ^ dip[21] ^ dip[29] ^ dip[37] ^ dip[45] ^ dip[53] ^ dip[61] ^ dip[69] ^ dip[77] ^ dip[85] ^ dip[93] ^ dip[101]^ dip[109] ^ dip[117] ^ dip[125];
+	dip_hash[4] = dip[4] ^ dip[12] ^ dip[20] ^ dip[28] ^ dip[36] ^ dip[44] ^ dip[52] ^ dip[60] ^ dip[68] ^ dip[76] ^ dip[84] ^ dip[92] ^ dip[100]^ dip[108] ^ dip[116] ^ dip[124];
+	dip_hash[3] = dip[3] ^ dip[11] ^ dip[19] ^ dip[27] ^ dip[35] ^ dip[43] ^ dip[51] ^ dip[59] ^ dip[67] ^ dip[75] ^ dip[83] ^ dip[91] ^ dip[99] ^ dip[107] ^ dip[115] ^ dip[123];
+	dip_hash[2] = dip[2] ^ dip[10] ^ dip[18] ^ dip[26] ^ dip[34] ^ dip[42] ^ dip[50] ^ dip[58] ^ dip[66] ^ dip[74] ^ dip[82] ^ dip[90] ^ dip[98] ^ dip[106] ^ dip[114] ^ dip[122];
+	dip_hash[1] = dip[1] ^ dip[9]  ^ dip[17] ^ dip[25] ^ dip[33] ^ dip[41] ^ dip[49] ^ dip[57] ^ dip[65] ^ dip[73] ^ dip[81] ^ dip[89] ^ dip[97] ^ dip[105] ^ dip[113] ^ dip[121];
+	dip_hash[0] = dip[0] ^ dip[8]  ^ dip[16] ^ dip[24] ^ dip[32] ^ dip[40] ^ dip[48] ^ dip[56] ^ dip[64] ^ dip[72] ^ dip[80] ^ dip[88] ^ dip[96] ^ dip[104] ^ dip[112] ^ dip[120];
+
+	for(i=0; i<8; i++) {
+		sip_hash[i]=sip_hash[i] & (0x01);
+		dip_hash[i]=dip_hash[i] & (0x01);
+	}
+
+	hash_idx_sip=0;
+	for(i=0; i<8; i++) {
+		hash_idx_sip=hash_idx_sip+(sip_hash[i]<<i);
+	}
+	hash_idx_dip=0;
+	for(i=0; i<8; i++) {
+		hash_idx_dip=hash_idx_dip+(dip_hash[i]<<i);
+	}
+
+	idx=0;
+	idx = hash_idx_dip ^ hash_idx_sip;
+
+	return idx;
+}
+
+int32 rtl8198C_setAsicIpMulticastv6Table(uint32 hash_type,rtl8198C_tblAsicDrv_multiCastv6Param_t *mCast_t)
+{
+	uint32 idx;
+	rtl8198C_tblAsic_ipMulticastv6Table_t entry;
+
+	if(mCast_t == NULL)
+		return FAILED;
+
+	if(mCast_t->dip.v6_addr32[0] >>24 != 0xFF || mCast_t->port >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum)
+	{
+		return FAILED;//Non-IP multicast destination address
+	}
+
+	memset(&entry,0,sizeof(entry));
+	entry.sip_addr31_0 		= mCast_t->sip.v6_addr32[3];
+	entry.sip_addr63_32 	= mCast_t->sip.v6_addr32[2];
+	entry.sip_addr95_64 	= mCast_t->sip.v6_addr32[1];
+	entry.sip_addr127_96 	= mCast_t->sip.v6_addr32[0];
+
+	entry.dip_addr31_0 		= mCast_t->dip.v6_addr32[3];
+	entry.dip_addr63_32 	= mCast_t->dip.v6_addr32[2];
+	entry.dip_addr95_64 	= mCast_t->dip.v6_addr32[1];
+	entry.dip_addr123_96 	= mCast_t->dip.v6_addr32[0]&0xFFFFFFF;
+
+	idx=rtl8198C_ipMulticastv6TableIndex(hash_type,mCast_t->sip, mCast_t->dip);
+
+	entry.srcPort 	    = mCast_t->port;
+	entry.extmbr 		= mCast_t->mbr >> RTL8651_PORT_NUMBER;
+	entry.mbr 			= mCast_t->mbr & (RTL8651_PHYSICALPORTMASK);
+	entry.toCPU 		= mCast_t->cpu;
+	entry.valid 		= 1;
+	entry.six_rd_eg     = mCast_t->six_rd_eg;
+	entry.six_rd_idx    = mCast_t->six_rd_idx;
+	entry.ageTime		= mCast_t->age;
+	////age = (int16)mCast_t->age;
+#if 0
+	while ( age > 0 ) {
+		if ( (++entry.ageTime) == 7)
+			break;
+		age -= 5;
+	}
+#endif
+	////entry.ageTime = 7;
+	/* todo add compare already has data in this entry?*/
+#if defined (CONFIG_RTL_8197F)
+	entry.destInterface = 0;
+#endif
+	return _rtl8651_forceAddAsicEntry(TYPE_MULTICAST_V6_TABLE, idx, &entry);
+}
+
+int32 rtl8198C_delAsicIpMulticastv6Table(uint32 index)
+{
+	rtl8198C_tblAsic_ipMulticastv6Table_t entry;
+	memset(&entry,0,sizeof(entry));
+	return _rtl8651_forceAddAsicEntry(TYPE_MULTICAST_V6_TABLE, index, &entry);
+}
+
+int32 rtl8198C_getAsicIpMulticastv6Table(uint32 index, rtl8198C_tblAsicDrv_multiCastv6Param_t *mCast_t)
+{
+	rtl8198C_tblAsic_ipMulticastv6Table_t entry;
+
+	if (mCast_t == NULL)
+	{
+		return FAILED;
+	}
+
+	memset(&entry,0,sizeof(entry));
+	_rtl8651_readAsicEntryStopTLU(TYPE_MULTICAST_V6_TABLE, index, &entry);
+
+	mCast_t->sip.v6_addr32[3] = entry.sip_addr31_0;
+	mCast_t->sip.v6_addr32[2] = entry.sip_addr63_32;
+	mCast_t->sip.v6_addr32[1] = entry.sip_addr95_64;
+	mCast_t->sip.v6_addr32[0] = entry.sip_addr127_96;
+
+	mCast_t->dip.v6_addr32[3] = entry.dip_addr31_0;
+	mCast_t->dip.v6_addr32[2] = entry.dip_addr63_32;
+	mCast_t->dip.v6_addr32[1] = entry.dip_addr95_64;
+	mCast_t->dip.v6_addr32[0] = entry.dip_addr123_96;
+
+	mCast_t->port = entry.srcPort;
+	mCast_t->mbr  = (entry.extmbr<<RTL8651_PORT_NUMBER) |entry.mbr;
+	mCast_t->age  = entry.ageTime;////*5
+	mCast_t->cpu  = entry.toCPU;
+	mCast_t->six_rd_eg  = entry.six_rd_eg;
+	mCast_t->six_rd_idx = entry.six_rd_idx;
+
+	if(entry.valid == 0)
+	{
+		return FAILED;
+	}
+	return SUCCESS;
+}
+
+//add for 8198c ipv6 multicast(-)
+#endif
+
+int32 rtl865x_initAsicL3(void)
+{
+	int32 index;
+	rtl865x_tblAsicDrv_routingParam_t rth;
+
+	/*clear asic table*/
+#if defined(CONFIG_RTD_1295_HWNAT)
+	rtl8651_clearSpecifiedAsicTable(TYPE_ARP_TABLE, RTL8651_ARPTBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_MULTICAST_TABLE, RTL8651_IPMULTICASTTBL_SIZE);
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	REG32(MEMCR) = 0;
+	REG32(MEMCR) = (1<<3); // ARP and Multicast
+
+	// wait clear done
+	while ( (REG32(MEMCR) & (1<<11)) != (1<<11) ) {} ;
+#else
+	rtl8651_clearSpecifiedAsicTable(TYPE_ARP_TABLE, RTL8651_ARPTBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_MULTICAST_TABLE, RTL8651_IPMULTICASTTBL_SIZE);
+#endif
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+	rtl8651_clearSpecifiedAsicTable(TYPE_EXT_INT_IP_TABLE, RTL8651_IPTABLE_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_PPPOE_TABLE, RTL8651_PPPOETBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_NEXT_HOP_TABLE, RTL8651_NEXTHOPTBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_L3_ROUTING_TABLE, RTL8651_ROUTINGTBL_SIZE);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rtl8651_clearSpecifiedAsicTable(TYPE_DS_LITE_TABLE, RTL8198C_6RDTBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_6RD_TABLE, RTL8198C_DSLITETBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_L3_V6_ROUTING_TABLE, RTL8198C_ROUTINGV6TBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_NEXT_HOP_V6_TABLE, RTL8198C_MULTICASTV6TBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_ARP_V6_TABLE, RTL8198C_ARPV6TBL_SIZE);
+	rtl8651_clearSpecifiedAsicTable(TYPE_MULTICAST_V6_TABLE, RTL8198C_NEXTHOPV6TBL_SIZE);
+#endif
+	rtl8651_setAsicMulticastEnable(TRUE); /* Enable multicast table */
+	WRITE_MEM32(ALECR, READ_MEM32(ALECR)|(uint32)EN_PPPOE);//enable PPPoE auto encapsulation
+	rtl8651_setAsicMulticastMTU(1522);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#ifdef CONFIG_RTL_HW_DSLITE_SUPPORT
+	REG32(V6DSLITECTR0) = 0;
+	WRITE_MEM32(V6DSLITECTR0,(CF_DSLITE_EN_MASK|CF_UKN_DSLDIP_CPU_MASK));
+	REG32(V6DSLITECTR1) = 0;
+	WRITE_MEM32(V6DSLITECTR1,(CF_HOP_LIMIT<<CF_DSL_HOPLIMIT_OFFSET & CF_DSL_HOPLIMIT_MASK));
+#endif
+#ifdef CONFIG_RTL_HW_6RD_SUPPORT
+	REG32(V6RDCTR0) = 0;
+	WRITE_MEM32(V6RDCTR0,(CF_6RD_EN_MASK|CF_6RDTOS_MASK|CF_UKN_6RDDIP_CPU_MASK));
+	REG32(V6RDCTR1) = 0;
+	WRITE_MEM32(V6RDCTR1,(CF_DSLITE_EN_MASK|CF_DSLTC_EN_MASK|CF_UKN_DSLDIP_CPU_MASK|CF_DSLITE_NAT_MASK));
+#endif
+#endif
+	//Enable TTL-1
+	WRITE_MEM32(TTLCR,READ_MEM32(TTLCR)|(uint32)EN_TTL1);//Don't hide this router. enable TTL-1 when routing on this gateway.
+
+	for (index=0; index<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; index++)
+	{
+		if( rtl8651_setAsicMulticastPortInternal(index, TRUE) )
+			return FAILED;
+	}
+	{
+		memset(&rth, 0, sizeof(rtl865x_tblAsicDrv_routingParam_t));
+		rth.process = 0x4; /* CPU */
+		rth.ipAddr = 0;
+		rth.ipMask = 0;
+		rth.vidx = 0;
+		rth.internal = 0;
+		rtl8651_setAsicRouting(7, &rth);
+	}
+
+	return SUCCESS;
+}
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL3.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL3.h
new file mode 100644
index 00000000..e82ca9a
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL3.h
@@ -0,0 +1,1053 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2009
+* All rights reserved.
+*
+* Program : Switch table Layer3 route driver,following features are included:
+*	Route/Multicast
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865X_ASICL3_H
+#define RTL865X_ASICL3_H
+
+#define RTL8651_IPTABLE_SIZE			16
+#define RTL8651_PPPOETBL_SIZE			8
+#define RTL8651_NEXTHOPTBL_SIZE		32
+#define RTL8651_ROUTINGTBL_SIZE		8
+#define RTL8651_ARPTBL_SIZE			512
+
+
+#if defined(CONFIG_RTL_8196E)  || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+//#define CONFIG_RTL_HARDWARE_MULTICAST_CAM
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+#define RTL8651_IPMCAST_CAM_SIZE			32
+#else
+#define RTL8651_IPMCAST_CAM_SIZE			0
+#endif
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+
+//#define RTL8651_MULTICASTTBL_SIZE			256
+#define RTL8651_IPMULTICASTTBL_SIZE		256
+//#define RTL8651_IPMCAST_CAM_SIZE			32
+#define RTL8651_MULTICASTTBL_SIZE			(RTL8651_IPMULTICASTTBL_SIZE+RTL8651_IPMCAST_CAM_SIZE)
+
+#elif defined (CONFIG_RTL8196C_REVISION_B) || defined (CONFIG_RTL8198_REVISION_B) || defined(CONFIG_RTL_819XD)
+#define RTL8651_IPMULTICASTTBL_SIZE		128
+#define RTL8651_MULTICASTTBL_SIZE		(RTL8651_IPMULTICASTTBL_SIZE+RTL8651_IPMCAST_CAM_SIZE)
+//#define RTL8651_IPMCAST_CAM_SIZE			32
+
+#else
+#define RTL8651_IPMULTICASTTBL_SIZE		64
+#define RTL8651_MULTICASTTBL_SIZE		(RTL8651_IPMULTICASTTBL_SIZE+RTL8651_IPMCAST_CAM_SIZE)
+#endif
+
+#define HASH_METHOD_SIP_DIP0        0
+#define HASH_METHOD_SIP_DIP1        1
+#define HASH_METHOD_SIP             2
+#define HASH_METHOD_DIP             3
+
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    ipaddr_t        internalIP;
+    /* word 1 */
+    ipaddr_t        externalIP;
+    /* word 2 */
+    uint32          reserv0     : 24;
+    uint32          nextHop     : 5;
+    uint32          isLocalPublic   : 1;
+    uint32          isOne2One       : 1;
+    uint32          valid       : 1;
+#else /*_LITTLE_ENDIAN*/
+    /* word 0 */
+    ipaddr_t        internalIP;
+    /* word 1 */
+    ipaddr_t        externalIP;
+    /* word 2 */
+    uint32          valid       : 1;
+    uint32          isOne2One       : 1;
+    uint32          isLocalPublic   : 1;
+    uint32          nextHop     : 5;
+    uint32          reserv0     : 24;
+#endif /*_LITTLE_ENDIAN*/
+    /* word 3 */
+    uint32          reservw3;
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl8651_tblAsic_extIpTable_t;
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    uint16          reserv0     : 13;
+    uint16          ageTime     : 3;
+    uint16          sessionID;
+#else /*_LITTLE_ENDIAN*/
+    /* word 0 */
+    uint16          sessionID;
+    uint16          ageTime     : 3;
+    uint16          reserv0     : 13;
+#endif /*_LITTLE_ENDIAN*/
+    /* word 1 */
+    uint32          reservw1;
+    /* word 2 */
+    uint32          reservw2;
+    /* word 3 */
+    uint32          reservw3;
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl8651_tblAsic_pppoeTable_t;
+
+
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    uint32          reserv0     : 11;
+    uint32          nextHop     : 10;
+    uint32          PPPoEIndex  : 3;
+    uint32          dstVid      : 3;
+    uint32          IPIndex     : 4;
+    uint32          type        : 1;
+#else
+    /* word 0 */
+    uint32          type        : 1;
+    uint32          IPIndex     : 4;
+    uint32          dstVid      : 3;
+    uint32          PPPoEIndex  : 3;
+    uint32          nextHop     : 10;
+    uint32          reserv0     : 11;
+#endif /*_LITTLE_ENDIAN*/
+    /* word 1 */
+    uint32          reservw1;
+    /* word 2 */
+    uint32          reservw2;
+    /* word 3 */
+    uint32          reservw3;
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl8651_tblAsic_nextHopTable_t;
+
+
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    ipaddr_t        IPAddr;
+
+    /* word 1 */
+    union {
+	struct {
+#if defined(CONFIG_RTL_8198C)
+			uint32          DSL_IDX1_0 : 2;
+			uint32          DSLEG      : 1;
+#else
+	    uint32          reserv0     : 3;
+#endif
+	    uint32		  ARPIpIdx	: 3;
+	    uint32          ARPEnd      : 6;
+	    uint32          ARPStart    : 6;
+	    uint32          netif         : 3;
+	    uint32          isDMZ      : 1;
+	    uint32          internal   : 1;
+	    uint32          process     : 3;
+	    uint32          valid       : 1;
+	    uint32          IPMask      : 5;
+	} ARPEntry;
+	struct {
+#if defined(CONFIG_RTL_8198C)
+			uint32          DSL_IDX1_0 : 2;
+			uint32          DSLEG      : 1;
+			uint32          reserv0     : 5;
+#else
+	    uint32          reserv0     : 8;
+#endif
+	    uint32          nextHop     : 10;
+	    uint32          netif         : 3;
+	    uint32          isDMZ      : 1;
+	    uint32          internal   : 1;
+	    uint32          process     : 3;
+	    uint32          valid       : 1;
+	    uint32          IPMask      : 5;
+	} L2Entry;
+	struct {
+#if defined(CONFIG_RTL_8198C)
+			uint32          DSL_IDX1_0 : 2;
+			uint32          DSLEG      : 1;
+			uint32          reserv0     : 2;
+#else
+	    uint32          reserv0     : 5;
+#endif
+	    uint32          PPPoEIndex  : 3;
+	    uint32          nextHop     : 10;
+	     uint32          netif         : 3;
+	    uint32          isDMZ      : 1;
+	    uint32          internal   : 1;
+	    uint32          process     : 3;
+	    uint32          valid       : 1;
+	    uint32          IPMask      : 5;
+	} PPPoEEntry;
+	struct {
+#if defined(CONFIG_RTL_8198C)
+			uint32          DSL_IDX1_0 : 2;
+			uint32          DSLEG      : 1;
+			uint32          reserv0     : 1;
+#else
+	    uint32          reserv0     : 4;
+#endif
+	    uint32          IPDomain    : 3;
+	    uint32          nhAlgo      : 2;
+	    uint32          nhNxt       : 5;
+	    uint32          nhStart     : 4;
+	    uint32          nhNum       : 3;
+	     uint32          isDMZ      : 1;
+	     uint32          internal   : 1;
+	     uint32          process     : 3;
+	     uint32          valid       : 1;
+	    uint32          IPMask      : 5;
+	} NxtHopEntry;
+
+    } linkTo;
+
+#if defined(CONFIG_RTL_8198C)
+    /* word 2 */
+    uint32          reservw2:31;
+    uint32          DSL_IDX2:1;
+#else
+    uint32          reservw2;
+#endif
+
+
+#else /*_LITTLE_ENDIAN*/
+
+    /* word 0 */
+    ipaddr_t        IPAddr;
+    /* word 1 */
+    union {
+	struct {
+	    uint32          IPMask      : 5;
+	    uint32          valid       : 1;
+	    uint32          process     : 3;
+	    uint32          internal   : 1;
+	    uint32          isDMZ      : 1;
+
+	    uint32          netif         : 3;
+	    uint32          ARPStart    : 6;
+	    uint32          ARPEnd      : 6;
+	    uint32		  ARPIpIdx	: 3;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			uint32          DSLEG      : 1;
+			uint32          DSL_IDX1_0 : 2;
+#else
+	    uint32          reserv0     : 3;
+#endif
+	} ARPEntry;
+	struct {
+	    uint32          IPMask      : 5;
+	    uint32          valid       : 1;
+	    uint32          process     : 3;
+	    uint32          internal   : 1;
+	    uint32          isDMZ      : 1;
+
+	    uint32          netif         : 3;
+	    uint32          nextHop     : 10;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			uint32          reserv0     : 5;
+			uint32          DSLEG      : 1;
+			uint32          DSL_IDX1_0 : 2;
+#else
+	    uint32          reserv0     : 8;
+#endif
+	} L2Entry;
+	struct {
+	    uint32          IPMask      : 5;
+	    uint32          valid       : 1;
+	    uint32          process     : 3;
+	    uint32          internal   : 1;
+	    uint32          isDMZ      : 1;
+
+	     uint32          netif         : 3;
+	    uint32          nextHop     : 10;
+	    uint32          PPPoEIndex  : 3;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			uint32          reserv0     : 2;
+			uint32          DSLEG       : 1;
+			uint32          DSL_IDX1_0  : 2;
+#else
+	    uint32          reserv0     : 5;
+#endif
+	} PPPoEEntry;
+	struct {
+	    uint32          IPMask      : 5;
+	    uint32          valid       : 1;
+	    uint32          process     : 3;
+	    uint32          internal   : 1;
+	    uint32          isDMZ      : 1;
+
+
+	    uint32          nhNum       : 3;
+	    uint32          nhStart     : 4;
+	    uint32          nhNxt       : 5;
+	    uint32          nhAlgo      : 2;
+	    uint32          IPDomain    : 3;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			uint32          reserv0     : 1;
+			uint32          DSLEG       : 1;
+			uint32          DSL_IDX1_0  : 2;
+#else
+	    uint32          reserv0     : 4;
+#endif
+	} NxtHopEntry;
+    } linkTo;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+    /* word 2 */
+    uint32          DSL_IDX2:1;
+    uint32          reservw2:31;
+#else
+    uint32          reservw2;
+#endif
+
+#endif /*_LITTLE_ENDIAN*/
+
+    /* word 3 */
+    uint32          reservw3;
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl865xc_tblAsic_l3RouteTable_t;
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    uint32          reserv0     : 16;
+    uint32          aging:5;
+    uint32          nextHop     : 10;
+    uint32          valid       : 1;
+#else /*_LITTLE_ENDIAN*/
+    /* word 0 */
+    uint32          valid       : 1;
+    uint32          nextHop     : 10;
+    uint32		  aging:5;
+    uint32          reserv0     : 21;
+#endif /*_LITTLE_ENDIAN*/
+    /* word 1 */
+    uint32          reservw1;
+    /* word 2 */
+    uint32          reservw2;
+    /* word 3 */
+    uint32          reservw3;
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl865xc_tblAsic_arpTable_t;
+
+typedef struct {
+
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    ipaddr_t        srcIPAddr;
+    /* word 1 */
+    uint32          srcPort      : 4;
+    uint32          destIPAddrLsbs : 28;
+
+    /* word 2*/
+	#if defined (CONFIG_RTL_8197F)
+	uint32          reserv0     : 11;
+	uint32          destInterface : 3;
+	#else
+    uint32          reserv0     : 14;
+	#endif
+    uint32          ageTime     : 3;
+    uint32          toCPU       : 1;
+    uint32          valid       : 1;
+    uint32          extIPIndex  : 4;
+    uint32          portList    : 9;
+#else
+    /* word 0 */
+    ipaddr_t        srcIPAddr;
+    /* word 1 */
+    uint32          destIPAddrLsbs : 28;
+    uint32          srcPort      :4 ;
+
+    /* word 2*/
+    uint32          portList    : 9;
+    uint32          extIPIndex  : 4;
+    uint32          valid       : 1;
+    uint32          toCPU       : 1;
+    uint32          ageTime     : 3;
+#if defined (CONFIG_RTL_8197F)
+	uint32   		destInterface : 3;
+    uint32          reserv0     : 11;
+#else
+    uint32          reserv0     : 14;
+#endif
+
+#endif /*_LITTLE_ENDIAN*/
+    /* word 3 */
+    uint32          reservw3;
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+
+} rtl865xc_tblAsic_ipMulticastTable_t;
+
+typedef struct rtl865x_tblAsicDrv_extIntIpParam_s {
+	    ipaddr_t 	extIpAddr;
+	    ipaddr_t 	intIpAddr;
+	    uint32 		nhIndex; //index of next hop table
+	    uint32 		localPublic:1,
+	           		nat:1;
+} rtl865x_tblAsicDrv_extIntIpParam_t;
+
+typedef struct rtl865x_tblAsicDrv_pppoeParam_s {
+	uint16 sessionId;
+	uint16 age;
+} rtl865x_tblAsicDrv_pppoeParam_t;
+
+
+typedef struct rtl865x_tblAsicDrv_nextHopParam_s {
+	uint32 nextHopRow;
+	uint32 nextHopColumn;
+	uint32 pppoeIdx;
+	uint32 dvid;	//note: dvid means DVID index here! hyking
+	uint32 extIntIpIdx;
+	uint32 isPppoe:1;
+} rtl865x_tblAsicDrv_nextHopParam_t;
+
+typedef struct rtl865x_tblAsicDrv_routingParam_s {
+	    ipaddr_t ipAddr;
+	    ipaddr_t ipMask;
+	    uint32 process; //0: pppoe, 1:direct, 2:indirect, 4:Strong CPU, 5:napt nexthop
+	    uint32 vidx;
+	    uint32 arpStart;
+	    uint32 arpEnd;
+	    uint32 arpIpIdx; /* for RTL8650B C Version Only */
+	    uint32 nextHopRow;
+	    uint32 nextHopColumn;
+	    uint32 pppoeIdx;
+	    uint32 nhStart; //exact index
+	    uint32 nhNum; //exact number
+	    uint32 nhNxt;
+	    uint32 nhAlgo;
+	    uint32 ipDomain;
+	    uint16 	internal:1,
+		DMZFlag:1;
+
+	    uint32 netif;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32          DSLEG;
+	uint32          DSL_IDX;
+#endif
+
+} rtl865x_tblAsicDrv_routingParam_t;
+
+typedef struct rtl865x_tblAsicDrv_arpParam_s {
+	uint32 nextHopRow;
+	uint32 nextHopColumn;
+	uint32 aging;
+} rtl865x_tblAsicDrv_arpParam_t;
+
+typedef struct rtl865x_tblAsicDrv_multiCastParam_s {
+	ipaddr_t	sip;
+	ipaddr_t	dip;
+	uint16	svid;
+	uint16	port;
+	uint32	mbr;
+	uint16	age;
+	uint16	cpu;
+	uint16	extIdx;
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+	uint16  idx;
+#endif
+} rtl865x_tblAsicDrv_multiCastParam_t;
+
+
+/*arp*/
+int32 rtl8651_setAsicArp(uint32 index, rtl865x_tblAsicDrv_arpParam_t *arpp);
+int32 rtl8651_delAsicArp(uint32 index);
+int32 rtl8651_getAsicArp(uint32 index, rtl865x_tblAsicDrv_arpParam_t *arpp);
+
+/*ip*/
+int32 rtl8651_setAsicExtIntIpTable(uint32 index, rtl865x_tblAsicDrv_extIntIpParam_t *extIntIpp);
+int32 rtl8651_delAsicExtIntIpTable(uint32 index);
+int32 rtl8651_getAsicExtIntIpTable(uint32 index, rtl865x_tblAsicDrv_extIntIpParam_t *extIntIpp);
+
+/*pppoe*/
+int32 rtl8651_setAsicPppoe(uint32 index, rtl865x_tblAsicDrv_pppoeParam_t *pppoep);
+int32 rtl8651_getAsicPppoe(uint32 index, rtl865x_tblAsicDrv_pppoeParam_t *pppoep);
+
+/*nexthop*/
+int32 rtl8651_setAsicNextHopTable(uint32 index, rtl865x_tblAsicDrv_nextHopParam_t *nextHopp);
+int32 rtl8651_getAsicNextHopTable(uint32 index, rtl865x_tblAsicDrv_nextHopParam_t *nextHopp);
+
+/*L3 routing*/
+int32 rtl8651_setAsicRouting(uint32 index, rtl865x_tblAsicDrv_routingParam_t *routingp);
+int32 rtl8651_delAsicRouting(uint32 index);
+int32 rtl8651_getAsicRouting(uint32 index, rtl865x_tblAsicDrv_routingParam_t *routingp);
+
+/*multicast*/
+uint32 rtl8651_ipMulticastTableIndex(ipaddr_t srcAddr, ipaddr_t dstAddr);
+int32 rtl8651_setAsicIpMulticastTable(rtl865x_tblAsicDrv_multiCastParam_t *mCast_t);
+int32 rtl8651_delAsicIpMulticastTable(uint32 index);
+int32 rtl8651_getAsicIpMulticastTable(uint32 index, rtl865x_tblAsicDrv_multiCastParam_t *mCast_t);
+int32 rtl8651_setAsicMulticastPortInternal(uint32 port, int8 isInternal);
+int32 rtl8651_getAsicMulticastPortInternal(uint32 port, int8 *isInternal);
+int32 rtl8651_setAsicMulticastMTU(uint32 mcastMTU);
+int32 rtl8651_getAsicMulticastMTU(uint32 *mcastMTU);
+int32 rtl8651_setAsicMulticastEnable(uint32 enable);
+int32 rtl8651_getAsicMulticastEnable(uint32 *enable);
+int32 rtl865x_setAsicMulticastAging(uint32 enable);
+int32 rtl865x_getAsicMCastHashMethod(unsigned int *hashMethod);
+int32 rtl865x_setAsicMCastHashMethod(unsigned int hashMethod);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+int32 rtl8198C_setAsicMulticastv6Enable(uint32 enable);
+int32 rtl8198C_getAsicMulticastv6Enable(uint32 *enable);
+int32 rtl8198C_setAsicMulticastv6MTU(uint32 mcastMTU);
+int32 rtl8198C_getAsicMulticastv6MTU(uint32 *mcastMTU);
+int32 rtl8198C_getAsicMCastv6HashMethod(unsigned int *hashMethod);
+int32 rtl8198C_setAsicMCastv6HashMethod(unsigned int hashMethod);
+int32 rtl8198C_setAsicMulticastv6Aging(uint32 enable);
+#endif
+
+
+
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define RTL8198C_6RDTBL_SIZE		 8
+#define RTL8198C_DSLITETBL_SIZE		 8
+#define RTL8198C_ROUTINGV6TBL_SIZE	 8
+#define RTL8198C_MULTICASTV6TBL_SIZE 256
+#define RTL8198C_ARPV6TBL_SIZE		 256 //4-way
+#define RTL8198C_NEXTHOPV6TBL_SIZE	 32
+
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    ipaddr_t      ce_ip_addr;
+
+    /* word 1 */
+    uint32        six_rd_pfx25_0 :26;
+    uint32        ce_ip_mask     :6;
+    /* word 2 */
+	uint32        six_rd_pfx57_26;
+    /* word 3 */
+    uint32        br_ip_addr19_0 :20;
+    uint32        pfx_mask       :6;
+    uint32        six_rd_pfx63_58:6;
+
+    /* word 4 */
+    uint32        six_rd_mtu     :15;
+    uint32        br_ip_mask     :5;
+    uint32        br_ip_addr31_20:12;
+    /* word 5 */
+    uint32        reservw5       :31;
+    uint32        valid          :1;
+
+#else /*_LITTLE_ENDIAN*/
+    /* word 0 */
+    ipaddr_t      ce_ip_addr;
+    /* word 1 */
+    uint32        ce_ip_mask     :6;
+    uint32        six_rd_pfx25_0 :26;
+    /* word 2 */
+	uint32        six_rd_pfx57_26;
+
+    /* word 3 */
+    uint32        six_rd_pfx63_58:6;
+    uint32        pfx_mask       :6;
+    uint32        br_ip_addr19_0 :20;
+
+    /* word 4 */
+    uint32        br_ip_addr31_20:12;
+    uint32        br_ip_mask     :5;
+    uint32        six_rd_mtu     :15;
+
+    /* word 5 */
+    uint32        valid          :1;
+    uint32        reservw5       :31;
+#endif /*_LITTLE_ENDIAN*/
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl8198C_tblAsic_6rdTable_t;
+
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+
+    /* word 0 */
+    uint32          host_id_17_0: 18;
+    uint32          subnet_idx  : 3;
+    uint32          nextHop     : 10;
+    uint32          valid       : 1;
+    /* word 1 */
+    uint32          host_id_49_18;
+    /* word 2 */
+    uint32          reserv0     : 13;
+    uint32		    aging       : 5;
+    uint32          host_id_63_50:14;
+
+#else /*_LITTLE_ENDIAN*/
+    /* word 0 */
+    uint32          valid       : 1;
+    uint32          nextHop     : 10;
+    uint32          subnet_idx  : 3;
+    uint32          host_id_17_0: 18;
+    /* word 1 */
+    uint32          host_id_49_18;
+    /* word 2 */
+    uint32          host_id_63_50:14;
+    uint32		    aging       : 5;
+    uint32          reserv0     : 13;
+#endif /*_LITTLE_ENDIAN*/
+    /* word 3 */
+    uint32          reservw3;
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl8198C_tblAsic_arpV6Table_t;
+
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    uint32          reserv0     : 15;
+    uint32          nextHop     : 10;
+    uint32          PPPoEIndex  : 3;
+    uint32          dstVid      : 3;
+    uint32          type        : 1;
+#else
+    /* word 0 */
+    uint32          type        : 1;
+    uint32          dstVid      : 3;
+    uint32          PPPoEIndex  : 3;
+    uint32          nextHop     : 10;
+    uint32          reserv0     : 15;
+#endif /*_LITTLE_ENDIAN*/
+    /* word 1 */
+    uint32          reservw1;
+    /* word 2 */
+    uint32          reservw2;
+    /* word 3 */
+    uint32          reservw3;
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl8198C_tblAsic_nextHopV6Table_t;
+
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    uint32        host_ipv6_addr31_0;
+    /* word 1 */
+    uint32        host_ipv6_addr63_32;
+    /* word 2 */
+    uint32        host_ipv6_addr95_64;
+    /* word 3 */
+    uint32        host_ipv6_addr127_96;
+    /* word 4 */
+    uint32        aftr_ipv6_addr24_0:25;
+	uint32        host_ipv6_mask    :7;
+	/* word 5 */
+    uint32        aftr_ipv6_addr56_25;
+    /* word 6 */
+    uint32        aftr_ipv6_addr88_57;
+    /* word 7 */
+    uint32        aftr_ipv6_addr120_89;
+    /* word 8 */
+	uint32        reservw8             :2;
+    uint32        valid                :1;
+    uint32        dslite_mtu           :15;
+    uint32        aftr_ipv6_mask       :7;
+    uint32        aftr_ipv6_addr127_121:7;
+#else /*_LITTLE_ENDIAN*/
+    /* word 0 */
+    uint32        host_ipv6_addr31_0;
+    /* word 1 */
+    uint32        host_ipv6_addr63_32;
+    /* word 2 */
+    uint32        host_ipv6_addr95_64;
+    /* word 3 */
+    uint32        host_ipv6_addr127_96;
+    /* word 4 */
+    uint32        host_ipv6_mask    :7;
+    uint32        aftr_ipv6_addr24_0:25;
+    /* word 5 */
+    uint32        aftr_ipv6_addr56_25;
+    /* word 6 */
+    uint32        aftr_ipv6_addr88_57;
+    /* word 7 */
+    uint32        aftr_ipv6_addr120_89;
+    /* word 8 */
+    uint32        aftr_ipv6_addr127_121 :7;
+    uint32        aftr_ipv6_mask        :7;
+    uint32        dslite_mtu            :15;
+    uint32        valid                 :1;
+	uint32        reservw8              :2;
+#endif /*_LITTLE_ENDIAN*/
+
+} rtl8198C_tblAsic_dsliteTable_t;
+
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    uint32        ipv6_addr31_0;
+
+    /* word 1 */
+    uint32        ipv6_addr63_32;
+
+    /* word 2 */
+    uint32        ipv6_addr95_64;
+
+    /* word 3 */
+    uint32        ipv6_addr127_96;
+
+    /* word 4 */
+    union {
+	struct {
+			uint32          reserv0     : 15;
+	    uint32          subnet_idx  : 3;
+	    uint32          netif       : 3;
+	    uint32          process     : 3;
+	    uint32          valid       : 1;
+	    uint32          IPMask      : 7;
+	} ARPEntry;
+	struct {
+			uint32          reserv0     : 8;
+	    uint32          nextHop     : 10;
+	    uint32          netif       : 3;
+	    uint32          process     : 3;
+	    uint32          valid       : 1;
+	    uint32          IPMask      : 7;
+	} L2Entry;
+	struct {
+			uint32          reserv0     : 5;
+	    uint32          PPPoEIndex  : 3;
+	    uint32          nextHop     : 10;
+	        uint32          netif       : 3;
+	    uint32          process     : 3;
+	    uint32          valid       : 1;
+	    uint32          IPMask      : 7;
+	} PPPoEEntry;
+	struct {
+			uint32          reserv0     : 7;
+	    uint32          nhAlgo      : 2;
+	    uint32          nhNxt       : 5;
+	    uint32          nhStart     : 4;
+	    uint32          nhNum       : 3;
+	        uint32          process     : 3;
+	        uint32          valid       : 1;
+	    uint32          IPMask      : 7;
+	} NxtHopEntry;
+
+    } linkTo;
+
+    /* word 5 */
+    uint32          reservw5   :28;
+    uint32          six_rd_idx :3;
+    uint32          six_rd_eg  :1;
+#else /*_LITTLE_ENDIAN*/
+    /* word 0 */
+    uint32        ipv6_addr31_0;
+    /* word 1 */
+    uint32        ipv6_addr63_32;
+    /* word 2 */
+    uint32        ipv6_addr95_64;
+    /* word 3 */
+    uint32        ipv6_addr127_96;
+    /* word 4 */
+    union {
+	struct {
+	    uint32          IPMask      : 7;
+	    uint32          valid       : 1;
+	    uint32          process     : 3;
+	    uint32          netif       : 3;
+	    uint32          subnet_idx   : 3;
+			uint32          reserv0     : 15;
+	} ARPEntry;
+	struct {
+	    uint32          IPMask      : 7;
+	    uint32          valid       : 1;
+	    uint32          process     : 3;
+	    uint32          netif       : 3;
+	    uint32          nextHop     : 10;
+			uint32          reserv0     : 8;
+	} L2Entry;
+	struct {
+	    uint32          IPMask      : 7;
+	    uint32          valid       : 1;
+	    uint32          process     : 3;
+	        uint32          netif       : 3;
+	    uint32          nextHop     : 10;
+	    uint32          PPPoEIndex  : 3;
+			uint32          reserv0     : 5;
+	} PPPoEEntry;
+	struct {
+	    uint32          IPMask      : 7;
+	    uint32          valid       : 1;
+	    uint32          process     : 3;
+	    uint32          nhNum       : 3;
+	    uint32          nhStart     : 4;
+	    uint32          nhNxt       : 5;
+	    uint32          nhAlgo      : 2;
+			uint32          reserv0     : 7;
+
+	} NxtHopEntry;
+    } linkTo;
+
+    /* word 5 */
+    uint32          six_rd_eg  :1;
+    uint32          six_rd_idx :3;
+    uint32          reservw5   :28;
+#endif /*_LITTLE_ENDIAN*/
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+
+} rtl8198C_tblAsic_l3v6RouteTable_t;
+
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    uint32        sip_addr31_0;
+    /* word 1 */
+    uint32        sip_addr63_32;
+    /* word 2 */
+    uint32        sip_addr95_64;
+    /* word 3 */
+    uint32        sip_addr127_96;
+    /* word 4 */
+    uint32        dip_addr31_0;
+    /* word 5 */
+    uint32        dip_addr63_32;
+    /* word 6 */
+    uint32        dip_addr95_64;
+    /* word 7 */
+    uint32        srcPort        : 4;
+    uint32        dip_addr123_96 :28;
+    /* word 8*/
+#if defined (CONFIG_RTL_8197F)
+    uint32        reserv0     : 11;
+	uint32		  destInterface : 3;
+#else
+    uint32        reserv0     : 14;
+#endif
+    uint32        ageTime     : 3;
+    uint32        toCPU       : 1;
+    uint32        valid       : 1;
+    uint32        six_rd_idx  : 3;
+    uint32        six_rd_eg   : 1;
+    uint32        extmbr      : 3;
+    uint32        mbr         : 6;
+#else
+    /* word 0 */
+    uint32        sip_addr31_0;
+    /* word 1 */
+    uint32        sip_addr63_32;
+    /* word 2 */
+    uint32        sip_addr95_64;
+    /* word 3 */
+    uint32        sip_addr127_96;
+    /* word 4 */
+    uint32        dip_addr31_0;
+    /* word 5 */
+    uint32        dip_addr63_32;
+    /* word 6 */
+    uint32        dip_addr95_64;
+    /* word 7 */
+    uint32        dip_addr123_96 :28;
+    uint32        srcPort        : 4;
+    /* word 8*/
+    uint32        mbr         : 6;
+    uint32        extmbr      : 3;
+    uint32        six_rd_eg   : 1;
+    uint32        six_rd_idx  : 3;
+    uint32        valid       : 1;
+    uint32        toCPU       : 1;
+    uint32        ageTime     : 3;
+#if defined (CONFIG_RTL_8197F)
+	uint32        destInterface : 3;
+    uint32        reserv0     : 11;
+#else
+    uint32        reserv0     : 14;
+#endif
+#endif
+} rtl8198C_tblAsic_ipMulticastv6Table_t;
+
+typedef struct rtl865x_tblAsicDrv_arpV6Param_s {
+	uint32 nextHopRow;
+	uint32 nextHopColumn;
+	uint32 aging;
+	uint32 subnet_id;
+    inv6_addr_t hostid;
+	uint32 valid;
+} rtl8198C_tblAsicDrv_arpV6Param_t;
+
+
+typedef struct rtl865x_tblAsicDrv_nextHopV6Param_s {
+	uint32 nextHopRow;
+	uint32 nextHopColumn;
+	uint32 pppoeIdx;
+	uint32 dvid;
+	uint32 isPppoe;
+} rtl8198C_tblAsicDrv_nextHopV6Param_t;
+
+
+typedef struct rtl8198C_tblAsicDrv_6rdParam_s {
+	ipaddr_t    ce_ip_addr;
+	uint8       ce_ip_mask_len;/*LSB*/
+	inv6_addr_t six_rd_prefix;
+    uint8       six_rd_prefix_len;
+	ipaddr_t    br_ip_addr;
+	uint8       br_ip_mask_len;/*MSB*/
+	uint16      mtu;
+	uint8       valid;
+} rtl8198C_tblAsicDrv_6rdParam_t;
+
+
+typedef struct rtl8198C_tblAsicDrv_dsliteParam_s {
+	inv6_addr_t host_ipv6_addr;
+	uint32      host_ipv6_mask;
+	inv6_addr_t aftr_ipv6_addr;
+    uint32      aftr_ipv6_mask;
+	uint32      mtu;
+	uint32      valid;
+} rtl8198C_tblAsicDrv_dsliteParam_t;
+
+typedef struct rtl865x_tblAsicDrv_routingv6Param_s {
+	    inv6_addr_t ipAddr;
+	    uint32 ipMask;
+	    uint32 process; //0: pppoe, 1:direct, 2:indirect, 4:Strong CPU, 5:napt nexthop
+	    uint32 vidx;
+
+	    uint32 arpStart;
+	    uint32 arpEnd;
+	    uint32 subnet_idx;
+
+	    uint32 nextHopRow;
+	    uint32 nextHopColumn;
+	    uint32 pppoeIdx;
+
+	    uint32 nhStart; //exact index
+	    uint32 nhNum;   //exact number
+	    uint32 nhNxt;
+	    uint32 nhAlgo;
+
+	    uint32 netif;
+
+	    uint32 six_rd_eg;
+	    uint32 six_rd_idx;
+} rtl8198C_tblAsicDrv_routingv6Param_t;
+
+typedef struct rtl8198C_tblAsicDrv_multiCastv6Param_s {
+	inv6_addr_t	sip;
+	inv6_addr_t	dip;
+	uint16	port;
+	uint32	mbr;
+	uint16	age;
+	uint16	cpu;
+	uint16	six_rd_eg;
+	uint16	six_rd_idx;
+} rtl8198C_tblAsicDrv_multiCastv6Param_t;
+
+
+/*6rd*/
+int32 rtl8198C_setAsic6rdTable(uint32 index, rtl8198C_tblAsicDrv_6rdParam_t *six_rd_entry);
+int32 rtl8198C_delAsic6rdTable(uint32 index);
+int32 rtl8198C_getAsic6rdTable(uint32 index, rtl8198C_tblAsicDrv_6rdParam_t *six_rd_entry);
+
+/*dslite*/
+int32 rtl8198C_setAsicDsliteTable(uint32 index, rtl8198C_tblAsicDrv_dsliteParam_t *dslite_entry);
+int32 rtl8198C_delAsicDsliteTable(uint32 index);
+int32 rtl8198C_getAsicDsliteTable(uint32 index, rtl8198C_tblAsicDrv_dsliteParam_t *dslite_entry);
+
+/*L3v6 routing*/
+int32 rtl8198C_setAsicRoutingv6(uint32 index, rtl8198C_tblAsicDrv_routingv6Param_t *routingp);
+int32 rtl8198C_delAsicRoutingv6(uint32 index);
+int32 rtl8198C_getAsicRoutingv6(uint32 index, rtl8198C_tblAsicDrv_routingv6Param_t *routingp);
+
+/*arpv6 */
+int32 rtl8198C_Arpv6TableIndex(rtl8198C_tblAsicDrv_arpV6Param_t *arpp);
+int32 rtl8198C_addAsicArpV6(uint32 index, rtl8198C_tblAsicDrv_arpV6Param_t *arpp);
+int32 rtl8198C_setAsicArpV6(uint32 index, rtl8198C_tblAsicDrv_arpV6Param_t *arpp);
+int32 rtl8198C_delAsicArpV6(uint32 index);
+int32 rtl8198C_getAsicArpV6(uint32 index, rtl8198C_tblAsicDrv_arpV6Param_t *arpp);
+
+/*nexthopv6 */
+int32 rtl8198C_setAsicNextHopTableV6(uint32 index, rtl8198C_tblAsicDrv_nextHopV6Param_t *nextHopp);
+int32 rtl8198C_delAsicNextHopTableV6(uint32 index) ;
+int32 rtl8198C_getAsicNextHopTableV6(uint32 index, rtl8198C_tblAsicDrv_nextHopV6Param_t *nextHopp);
+
+/*multicastv6*/
+uint32 rtl8198C_ipMulticastv6TableIndex(uint32 hash_type,inv6_addr_t srcAddr, inv6_addr_t dstAddr);
+int32 rtl8198C_setAsicIpMulticastv6Table(uint32 hash_type,rtl8198C_tblAsicDrv_multiCastv6Param_t *mCast_t);
+int32 rtl8198C_delAsicIpMulticastv6Table(uint32 index);
+int32 rtl8198C_getAsicIpMulticastv6Table(uint32 index, rtl8198C_tblAsicDrv_multiCastv6Param_t *mCast_t);
+
+#endif
+
+
+
+
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL4.c b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL4.c
new file mode 100644
index 00000000..de9f7d1
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL4.c
@@ -0,0 +1,466 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2009
+* All rights reserved.
+*
+* Program : Switch table Layer4 napt driver,following features are included:
+*	napt
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "asicRegs.h"
+#include "rtl865x_asicBasic.h"
+#include "rtl865x_asicCom.h"
+#include "rtl865x_asicL4.h"
+//#include "assert.h"
+//#include "rtl_utils.h"
+
+
+uint32 _rtl8651_NaptAgingToSec(uint32 value) {
+	/*
+	 * Convert differentiated timer value to actual second value
+	 * Actual Timeout second = Theory timeout sec * 5/3 - (unit==1? 0: granularity)
+	 */
+	uint32 unit = 0, G = value>>3, S = 1;
+
+	value &= 0x07;
+	while (G > 0) {
+		unit += (S << 3);
+		S = S << 2;
+		G--;
+	}
+	unit += (S * (value + 1));
+	unit = (unit-1)*5/3 - (S>1? S: 0);
+	return unit;
+}
+
+ uint32 _rtl8651_NaptAgingToUnit(uint32 sec) {
+	/*
+	 * Convert actual second value to differentiated timer value
+	 * Unit = naptAgingToUnit(sec*0.6) + 1
+	 */
+	uint32 value = 0, S = 1;
+
+	sec++;
+	sec = sec * 3 / 5;
+	while(sec >= (S<<3)) {
+		sec -= (S << 3);
+		S = S << 2;
+		value++;
+	}
+	return (sec%S > (S>>1))? ((value << 3) + (sec / S) + 1) : ((value << 3) + (sec / S) - 1 + 1);
+}
+
+/*
+@func int8	| Is4WayEnabled	| This function returns if the 4-way hash function is enabled?
+@rvalue TRUE	| Yes, 4-way hash is enabled.
+@comm
+	(under construction)
+@devnote
+	(under construction)
+ */
+uint32 _Is4WayHashEnabled(void)
+{
+	/*
+	rtlglue_printf("%s (%s %d) No More Support \n",__FUNCTION__,__FILE__,__LINE__);
+	return 0;
+	*/
+	uint32 regValue = READ_MEM32( SWTCR1 );
+	return ( regValue & EN_TCPUDP_4WAY_HASH );
+}
+
+/*
+@func int8	| Is4WayEnabled	| This function sets SWTECR register to enable or diable 4-way hash.
+@parm int	| enable	| TRUE if you want to enable 4-way hash.
+@rvalue SUCCESS	| Done
+@comm
+This function sets SWTECR register to enable or diable 4-way hash.
+@devnote
+	(under construction)
+ */
+int32 _set4WayHash( int32 enable )
+{
+	/*
+	rtlglue_printf("%s (%s %d) No More Support \n",__FUNCTION__,__FILE__,__LINE__);
+	*/
+	uint32 regValue = READ_MEM32( SWTCR1 );
+	if ( enable )
+	{
+		regValue |= EN_TCPUDP_4WAY_HASH;
+	}
+	else
+	{
+		//rtlglue_printf("%s (%s %d) Warning!! Disable 4 wayHash would bring on something unexpected! \n",__FUNCTION__,__FILE__,__LINE__);
+		regValue &= ~EN_TCPUDP_4WAY_HASH;
+	}
+	#if 0
+	// write back
+	WRITE_MEM32( SWTECR, regValue );
+	#else
+	WRITE_MEM32( SWTCR1, regValue );
+	#endif
+
+	return SUCCESS;
+}
+
+int32 _rtl8651_enableEnhancedHash1()
+{
+	uint32 regValue = READ_MEM32( SWTCR1 );
+
+	regValue |= L4EnHash1;
+	WRITE_MEM32( SWTCR1, regValue );
+	return SUCCESS;
+}
+
+int32 _rtl8651_disableEnhancedHash1()
+{
+	uint32 regValue = READ_MEM32( SWTCR1 );
+
+	regValue &= (~L4EnHash1);
+	WRITE_MEM32( SWTCR1, regValue );
+	return SUCCESS;
+}
+
+
+/*
+ * Get table index using the default hash algorithm of RTL865xC
+ *
+ *   {VERI,isTCP}  srcAddr  srcPort  destAddr  destPort
+ *      0     *       	*        	*       	!=0       !=0       	HASH1 index (for tranditional and enhanced Hash1)
+ *      0     *      	*        	*        	0         	0        	HASH2 index
+ *      1     *       	*        	*        	*         	*        	Verification of Enhanced HASH1
+ */
+uint32 rtl8651_naptTcpUdpTableIndex(int8 isTCP, ipaddr_t srcAddr, uint16 srcPort, ipaddr_t destAddr, uint16 destPort) {
+	uint32 eidx;
+
+	if(destAddr==0 && destPort==0 && ((isTCP&HASH_FOR_VERI)==0))
+	{
+		/* From alpha's mail (2006/05/02)
+		hash 2
+		hash2id = sip[9:0] ^ sip[19:10] ^ sip[29:20] ^
+		          sport[9:0] ^
+		          { 1'd0, tcp_pkt, sip[31:30], sport[15:10] } ;
+		*/
+		eidx = (srcAddr&0x3ff) ^ ((srcAddr>>10)&0x3ff) ^ ((srcAddr>>20)&0x3ff) ^
+		       (srcPort&0x3ff) ^
+		       (((isTCP&1)<<8) | ((srcAddr&0xc0000000)>>24) | ((srcPort>>10)&0x3f) );
+		assert(eidx < RTL8651_TCPUDPTBL_SIZE);
+		return eidx;
+	}
+
+	/* From alpha's mail (2006/05/02)
+	  hash 1
+	  idx[96:0] = { dip, dport, tcp_pkt, sip, sport } ;
+	  hash1id   = idx[9:0] ^ idx[19:10] ^ idx[29:20] ^
+	              idx[39:30] ^ idx[49:40] ^ idx[59:50] ^
+	              idx[69:60] ^ idx[79:70] ^ idx[89:80] ^
+	              { 3'd0,  idx[96:90] } ;
+	*/
+	eidx = (srcPort&0x3ff) ^ (((srcPort&0xfc00)>>10)|((srcAddr&0xf)<<6)) ^ ((srcAddr>>4)&0x3ff) ^
+	       ((srcAddr>>14)&0x3ff) ^ (((srcAddr&0xff000000)>>24)|((isTCP&1)<<8)|((destPort&1)<<9)) ^
+	       ((destPort>>1)&0x3ff) ^ (((destPort>>11)&0x1f)|((destAddr&0x1f)<<5)) ^ ((destAddr>>5)&0x3ff) ^
+	       ((destAddr>>15)&0x3ff) ^ ((destAddr>>25)&0x7f);
+	assert(eidx < RTL8651_TCPUDPTBL_SIZE);
+	return eidx;
+}
+
+int32 rtl8651_setAsicLiberalNaptTcpUdpTable( int8 forced, uint16 index,
+	ipaddr_t insideLocalIpAddr, uint16 insideLocalPort, int8 selExtIPIdx, uint16 insideGlobalPort,
+	uint32 ageSec, int8 entryType, int8 isTcp, int8 isCollision, int8 isCollision2, int8 isValid )
+{
+	rtl865xc_tblAsic_naptTcpUdpTable_t  entry;
+	int8 tcpQuiet, directional, outbound;
+
+	//use liberal hash algorithm
+	assert(entryType&RTL8651_STATIC_NAPT_ENTRY);
+	assert(entryType & RTL8651_LIBERAL_NAPT_ENTRY);
+	assert(index<RTL8651_TCPUDPTBL_SIZE);
+
+	memset(&entry,0, sizeof(entry));
+	entry.collision = isCollision==TRUE? 1: 0;
+	entry.collision2 = isCollision2==TRUE? 1: 0;
+	entry.offset = insideGlobalPort>>RTL8651_TCPUDPTBL_BITS;
+
+	// Edward said: col1 and col2 are always set.
+	// To recover those code, cvs checkout version 1.3 (2004/01/14).
+	entry.collision = entry.collision2 = 1;
+
+	if(isValid){
+		entry.valid = 1;
+		entry.isStatic = entry.dedicate = 1;
+		entry.intIPAddr = insideLocalIpAddr;
+		entry.intPort = insideLocalPort;
+
+		entry.agingTime = _rtl8651_NaptAgingToUnit(ageSec);
+
+		/* TCPFlag is reused in RTL8651B when dedicate bit is set.
+		 * TCPFlag[2]= 1: Quiet	, 0: Trap SYN/FIN/RST to CPU
+		 * TCPFlag[1]= 1: unidirectional,   0: bidirectional
+		 * TCPFlag[0]= 1: outbound flow,   0: inbound flow
+		 */
+		tcpQuiet = (ISSET(entryType, RTL8651_NAPT_SYNFIN_QUIET))? 1:0;
+		directional = (ISSET(entryType, RTL8651_NAPT_UNIDIRECTIONAL_FLOW))? 1:0;
+		outbound = (directional&&ISSET(entryType, RTL8651_NAPT_OUTBOUND_FLOW))? 1:0;
+
+		/* In fact, these two fields should be filled if entry is for outbound */
+		entry.selEIdx = insideGlobalPort & (RTL8651_TCPUDPTBL_SIZE-1);
+		entry.selIPIdx = selExtIPIdx;
+
+		/* TCP flag field for HASH2 is {Quiet,Dir,Out}. */
+		entry.TCPFlag = (tcpQuiet<<2)|(directional<<1) | (outbound);
+		entry.isTCP= isTcp==TRUE? 1: 0;
+	}
+	else
+	{
+		entry.isStatic = entry.dedicate= entry.intIPAddr=entry.intPort =0;
+		entry.agingTime =entry.selEIdx=entry.selIPIdx= entry.TCPFlag = 0;
+	}
+
+	if(forced == TRUE)
+		return _rtl8651_forceAddAsicEntry(TYPE_L4_TCP_UDP_TABLE, index, &entry);
+	else if(_rtl8651_addAsicEntry(TYPE_L4_TCP_UDP_TABLE, index, &entry))
+			return FAILED;
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicNaptTcpUdpTable(int8 forced, uint32 index, rtl865x_tblAsicDrv_naptTcpUdpParam_t *naptTcpUdpp)
+{
+	rtl865xc_tblAsic_naptTcpUdpTable_t  entry;
+
+	if((index >= RTL8651_TCPUDPTBL_SIZE) || (naptTcpUdpp == NULL))
+		return FAILED;
+
+	assert( naptTcpUdpp->tcpFlag < TCP_CLOSED_FLOW );
+
+	memset(&entry, 0, sizeof(entry));
+	entry.collision = 1; // always TRUE. naptTcpUdpp->isCollision==TRUE? 1: 0;
+	entry.collision2 = 1; // always TRUE. naptTcpUdpp->isCollision2==TRUE? 1: 0;
+	entry.valid = naptTcpUdpp->isValid==TRUE? 1: 0;
+	entry.intIPAddr = naptTcpUdpp->insideLocalIpAddr;
+
+	entry.intPort=naptTcpUdpp->insideLocalPort;
+	entry.offset = naptTcpUdpp->offset;
+	entry.agingTime = _rtl8651_NaptAgingToUnit(naptTcpUdpp->ageSec);
+	entry.isStatic = naptTcpUdpp->isStatic==TRUE? 1: 0;
+	entry.isTCP = naptTcpUdpp->isTcp==TRUE? 1: 0;
+	entry.TCPFlag = naptTcpUdpp->tcpFlag;
+	entry.dedicate = naptTcpUdpp->isDedicated==TRUE? 1: 0;
+	entry.selIPIdx = naptTcpUdpp->selExtIPIdx;
+	entry.selEIdx = naptTcpUdpp->selEIdx;
+
+	// Edward said: col1 and col2 are always set.
+	// To recover those code, cvs checkout version 1.3 (2004/01/14).
+	entry.collision = entry.collision2 = 1;
+	entry.priValid =  naptTcpUdpp->priValid;
+	entry.priority = naptTcpUdpp->priority;
+
+#if defined(CONFIG_RTL_8197F)
+	entry.NHIDX      = naptTcpUdpp->NHIDX;
+	entry.NHIDXValid = naptTcpUdpp->NHIDXValid;
+#endif
+
+	if(forced == TRUE){
+		_rtl8651_forceAddAsicEntry(TYPE_L4_TCP_UDP_TABLE, index, &entry);
+	}else if(_rtl8651_addAsicEntry(TYPE_L4_TCP_UDP_TABLE, index, &entry))
+		return FAILED;
+	return SUCCESS;
+}
+
+
+int32 rtl8651_getAsicRawNaptTable(uint32 index, void   *entry)
+{
+	/*entry is actually an rtl8651_tblAsic_naptTcpUdpTable_t pointer*/
+	uint32  *pEntry=(uint32 *)entry;
+	int32 retval;
+
+	// WRITE_MEM32(TEATCR, READ_MEM32(TEATCR) | 0x2); /*ASIC patch: disable L4 Aging aftrer reading L4 table */
+	retval=_rtl8651_readAsicEntry(TYPE_L4_TCP_UDP_TABLE, index, entry);
+	//WRITE_MEM32(TEATCR, READ_MEM32(TEATCR) & ~0x2); /*ASIC patch: enable L4 Aging aftrer reading NAPT table */
+
+	//ASIC patch. static entry's valid bit would be cleared if aged out.
+	if(((pEntry[1]&0x1)==0)&&((pEntry[1]&0x10000)==0x10000))
+		pEntry[1] |=0x1;
+
+	return retval;
+}
+
+int32 rtl8651_setAsicRawNaptTable( uint32 index, void *vEntry, int8 forced )
+{
+	rtl865xc_tblAsic_naptTcpUdpTable_t *entry = (rtl865xc_tblAsic_naptTcpUdpTable_t *)vEntry;
+
+	// Edward said: col1 and col2 are always set.
+	// To recover those code, cvs checkout version 1.3 (2004/01/14).
+	entry->collision = entry->collision2 = 1;
+	if( forced == TRUE )
+		return _rtl8651_forceAddAsicEntry( TYPE_L4_TCP_UDP_TABLE, index, vEntry );
+	else if( _rtl8651_addAsicEntry( TYPE_L4_TCP_UDP_TABLE, index, vEntry ) )
+		return FAILED;
+	return SUCCESS;
+}
+
+
+int32 rtl8651_getAsicNaptTcpUdpTable(uint32 index, rtl865x_tblAsicDrv_naptTcpUdpParam_t *naptTcpUdpp)
+{
+	rtl865xc_tblAsic_naptTcpUdpTable_t  entry;
+	if((index >= RTL8651_TCPUDPTBL_SIZE) || (naptTcpUdpp == NULL))
+		return FAILED;
+
+	rtl8651_getAsicRawNaptTable( index, &entry);
+
+	naptTcpUdpp->insideLocalIpAddr = entry.intIPAddr;
+	naptTcpUdpp->insideLocalPort = entry.intPort;
+	naptTcpUdpp->offset = entry.offset;
+	naptTcpUdpp->ageSec = _rtl8651_NaptAgingToSec(entry.agingTime);
+	naptTcpUdpp->isStatic = entry.isStatic;
+	naptTcpUdpp->isTcp = entry.isTCP;
+	naptTcpUdpp->isCollision = entry.collision;
+	naptTcpUdpp->isCollision2 = entry.collision2;
+	naptTcpUdpp->isValid = entry.valid;
+	naptTcpUdpp->isDedicated = entry.dedicate;
+	naptTcpUdpp->selExtIPIdx = entry.selIPIdx;
+	naptTcpUdpp->selEIdx = entry.selEIdx;
+	naptTcpUdpp->tcpFlag = entry.TCPFlag;
+	naptTcpUdpp->priValid= entry.priValid;
+	naptTcpUdpp->priority= entry.priority;
+
+#if defined(CONFIG_RTL_8197F)
+	naptTcpUdpp->NHIDXValid = entry.NHIDXValid;
+	naptTcpUdpp->NHIDX      = entry.NHIDX;
+#endif
+	 return SUCCESS;
+}
+
+int32 rtl8651_delAsicNaptTcpUdpTable(uint32 start, uint32 end) {
+	if((start >= RTL8651_TCPUDPTBL_SIZE) || (end >= RTL8651_TCPUDPTBL_SIZE))
+		return FAILED;
+
+	_rtl8651_delAsicEntry(TYPE_L4_TCP_UDP_TABLE, start, end);
+	return SUCCESS;
+}
+
+/*=========================================
+  * ASIC DRIVER API: NAPT TIMER
+  * hyking
+  * 2007_7_12
+  * for 865xC: 0~29bits are valid, 30~31 bits are reserved.
+  *=========================================*/
+
+int32 rtl8651_setAsicNaptIcmpTimeout(uint32 timeout) {
+	uint32 timeUnit = _rtl8651_NaptAgingToUnit(timeout), timeMask;
+
+	if(timeUnit >= 0x400)
+		return FAILED;
+	timeMask = (uint32)0x3f<< 24;
+	WRITE_MEM32(TEATCR,(READ_MEM32(TEATCR) & ~timeMask) | (timeUnit<<24));
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicNaptIcmpTimeout(uint32 *timeout) {
+	if(timeout == NULL)
+		return FAILED;
+	*timeout = _rtl8651_NaptAgingToSec((READ_MEM32(TEATCR)>>24) & 0x3f);
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicNaptUdpTimeout(uint32 timeout) {
+	uint32 timeUnit = _rtl8651_NaptAgingToUnit(timeout), timeMask;
+
+	if(timeUnit >= 0x400)
+		return FAILED;
+	timeMask = 0x3f << 18;
+	WRITE_MEM32(TEATCR,(READ_MEM32(TEATCR) & ~timeMask) | (timeUnit<<18));
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicNaptUdpTimeout(uint32 *timeout) {
+	if(timeout == NULL)
+		return FAILED;
+	*timeout = _rtl8651_NaptAgingToSec((READ_MEM32(TEATCR)>>18) & 0x3f);
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicNaptTcpLongTimeout(uint32 timeout) {
+	uint32 timeUnit = _rtl8651_NaptAgingToUnit(timeout), timeMask;
+
+	if(timeUnit >= 0x400)
+		return FAILED;
+	timeMask = 0x3f << 12;
+	WRITE_MEM32(TEATCR,(READ_MEM32(TEATCR) & ~timeMask) | (timeUnit<<12));
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicNaptTcpLongTimeout(uint32 *timeout) {
+	if(timeout == NULL)
+		return FAILED;
+	*timeout = _rtl8651_NaptAgingToSec((READ_MEM32(TEATCR)>>12) & 0x3f);
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicNaptTcpMediumTimeout(uint32 timeout) {
+	uint32 timeUnit = _rtl8651_NaptAgingToUnit(timeout), timeMask;
+
+	if(timeUnit >= 0x400)
+		return FAILED;
+	timeMask = 0x3f << 6;
+	WRITE_MEM32(TEATCR,(READ_MEM32(TEATCR) & ~timeMask) | (timeUnit<<6));
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicNaptTcpMediumTimeout(uint32 *timeout) {
+	if(timeout == NULL)
+		return FAILED;
+	*timeout = _rtl8651_NaptAgingToSec((READ_MEM32(TEATCR)>>6) & 0x3f);
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicNaptTcpFastTimeout(uint32 timeout) {
+	uint32 timeUnit = _rtl8651_NaptAgingToUnit(timeout), timeMask;
+
+	if(timeUnit >= 0x400)
+		return FAILED;
+	timeMask = 0x3f;
+	WRITE_MEM32(TEATCR,(READ_MEM32(TEATCR) & ~timeMask) | (timeUnit));
+
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicNaptTcpFastTimeout(uint32 *timeout) {
+	if(timeout == NULL)
+		return FAILED;
+	*timeout = _rtl8651_NaptAgingToSec((READ_MEM32(TEATCR)) & 0x3f);
+	return SUCCESS;
+}
+
+int32 rtl8651_setAsicNaptAutoAddDelete(int8 autoAdd, int8 autoDelete) {
+	if(autoAdd == TRUE)
+		WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0)|EN_NAPT_AUTO_LEARN);
+	else
+		WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0)&~EN_NAPT_AUTO_LEARN);
+	if(autoDelete == TRUE)
+		WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0)|EN_NAPT_AUTO_DELETE);
+	else
+		WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0)&~EN_NAPT_AUTO_DELETE);
+	return SUCCESS;
+}
+
+int32 rtl865x_initAsicL4(void)
+{
+	/*clear asic table*/
+	rtl8651_clearSpecifiedAsicTable(TYPE_L4_TCP_UDP_TABLE, RTL8651_TCPUDPTBL_SIZE);
+
+	WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0)&~NAPTR_NOT_FOUND_DROP);//When reverse NAPT entry not found, CPU process it.
+	rtl8651_setAsicNaptAutoAddDelete(FALSE, TRUE);
+
+	return SUCCESS;
+
+}
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL4.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL4.h
new file mode 100644
index 00000000..908ad97
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_asicL4.h
@@ -0,0 +1,162 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2009
+* All rights reserved.
+*
+* Program : Switch table Layer4 napt driver,following features are included:
+*	napt
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865X_ASICL4_H
+#define RTL865X_ASICL4_H
+
+#define RTL8651_DYNAMIC_NAPT_ENTRY		(0x0<<0)
+#define RTL8651_STATIC_NAPT_ENTRY			(0x1<<0)
+#define 	RTL8651_LIBERAL_NAPT_ENTRY			(0x2<<0)
+
+#define RTL8651_TCPUDPTBL_SIZE			1024
+#define RTL8651_SERVERPORTTBL_SIZE	16
+#define RTL8651_ALGTBL_SIZE			48
+#define RTL8651_ICMPTBL_SIZE			32
+#define RTL8651_TCPUDPTBL_BITS			10
+
+#define RTL8651_NAPT_OUTBOUND_FLOW				(1<<2) 	//exact value in ASIC
+#define RTL8651_NAPT_INBOUND_FLOW				(0<<2)	//exact value in ASIC
+#define RTL8651_NAPT_UNIDIRECTIONAL_FLOW		(2<<2)	//exact value in ASIC
+#define RTL8651_NAPT_SYNFIN_QUIET				(4<<2)	//exact value in ASIC
+#define RTL8651_NAPT_CHKAUTOLEARN				(1<<5)
+//In RTL8651, TCPFlag field records current state of entry
+#define RTL8651_TCPNAPT_WAIT4FIN			(0x4 <<2) //exact value in ASIC
+#define RTL8651_TCPNAPT_WAITINBOUND			(0x2 <<2) //exact value in ASIC
+#define RTL8651_TCPNAPT_WAITOUTBOUND		(0x1 <<2) //exact value in ASIC
+
+#define HASH_UDP      0 /* flag for hash UDP */
+#define HASH_TCP      1 /* flag for hash TCP */
+#define HASH_FOR_TRAN 0 /* flag for hash hash1 and hash2 index */
+#define HASH_FOR_VERI 2 /* flag for hash verification value of enhanced hash1 */
+
+typedef struct {
+#ifndef _LITTLE_ENDIAN
+    /* word 0 */
+    ipaddr_t        intIPAddr;
+    /* word 1 */
+    uint32          reserv0     : 1;
+    uint32          selEIdx     : 10;
+    uint32          selIPIdx    : 4;
+    uint32          isStatic    : 1;
+    uint32          dedicate    : 1;
+    uint32          collision2  : 1;
+    uint32          offset      : 6;
+    uint32          agingTime   : 6;
+    uint32          collision   : 1;
+    uint32          valid       : 1;
+
+    /* word 2 */
+#if defined(CONFIG_RTL_8197F)
+    uint32          reserv2     : 2;
+    uint32          NHIDX       : 5;
+    uint32          NHIDXValid  : 1;
+#else
+    uint32          reserv2     : 8;
+#endif
+    uint32		  priority     :3;
+    uint32          priValid	   :1;
+    uint32          isTCP       : 1;
+    uint32          TCPFlag     : 3;
+    uint32          intPort     : 16;
+#else /*_LITTLE_ENDIAN*/
+    /* word 0 */
+    ipaddr_t        intIPAddr;
+    /* word 1 */
+    uint32          valid       : 1;
+    uint32          collision   : 1;
+    uint32          agingTime   : 6;
+    uint32          offset      : 6;
+    uint32          collision2  : 1;
+    uint32          dedicate    : 1;
+    uint32          isStatic    : 1;
+    uint32          selIPIdx    : 4;
+    uint32          selEIdx     : 10;
+    uint32          reserv0     : 1;
+
+    /* word 2 */
+    uint32          intPort     : 16;
+    uint32          TCPFlag     : 3;
+    uint32          isTCP       : 1;
+    uint32          priValid	   :1;
+    uint32		  priority	   :3;
+#if defined(CONFIG_RTL_8197F)
+    uint32          NHIDXValid  : 1;
+    uint32          NHIDX       : 5;
+    uint32          reserv2     : 2;
+#else
+    uint32          reserv2     : 8;
+#endif
+#endif /*_LITTLE_ENDIAN*/
+    /* word 3 */
+    uint32          reservw3;
+    /* word 4 */
+    uint32          reservw4;
+    /* word 5 */
+    uint32          reservw5;
+    /* word 6 */
+    uint32          reservw6;
+    /* word 7 */
+    uint32          reservw7;
+} rtl865xc_tblAsic_naptTcpUdpTable_t;
+
+typedef struct rtl865x_tblAsicDrv_naptTcpUdpParam_s {
+	ipaddr_t 	insideLocalIpAddr;
+	uint16 	insideLocalPort;
+	uint32 	ageSec;
+	uint8 	tcpFlag;
+	uint8 	offset;
+	uint8 	selExtIPIdx;
+	uint16 	selEIdx;
+	uint32 	isTcp:1,
+			isCollision:1,
+			isStatic:1,
+			isCollision2:1,
+			isDedicated:1,
+			isValid:1,
+			priValid:1,
+#if defined(CONFIG_RTL_8197F)
+			priority:3,
+			NHIDXValid:1,
+			NHIDX:5;
+#else
+			priority:3;
+#endif
+
+} rtl865x_tblAsicDrv_naptTcpUdpParam_t;
+
+
+//uint32 _Is4WayHashEnabled( void );
+int32 _set4WayHash( int32 enable );
+int32 _rtl8651_enableEnhancedHash1(void);
+int32 _rtl8651_disableEnhancedHash1(void);
+
+uint32 rtl8651_naptTcpUdpTableIndex(int8 isTCP, ipaddr_t srcAddr, uint16 srcPort, ipaddr_t destAddr, uint16 destPort);
+
+int32 rtl8651_setAsicNaptTcpUdpTable(int8 forced, uint32 index, rtl865x_tblAsicDrv_naptTcpUdpParam_t *naptTcpUdpp);
+int32 rtl8651_getAsicNaptTcpUdpTable(uint32 index, rtl865x_tblAsicDrv_naptTcpUdpParam_t *naptTcpUdpp);
+int32 rtl8651_delAsicNaptTcpUdpTable(uint32 start, uint32 end);
+
+int32 rtl8651_setAsicNaptIcmpTimeout(uint32 timeout);
+int32 rtl8651_getAsicNaptIcmpTimeout(uint32 *timeout);
+int32 rtl8651_setAsicNaptUdpTimeout(uint32 timeout);
+int32 rtl8651_getAsicNaptUdpTimeout(uint32 *timeout);
+int32 rtl8651_setAsicNaptTcpLongTimeout(uint32 timeout);
+int32 rtl8651_getAsicNaptTcpLongTimeout(uint32 *timeout);
+int32 rtl8651_setAsicNaptTcpMediumTimeout(uint32 timeout);
+int32 rtl8651_getAsicNaptTcpMediumTimeout(uint32 *timeout);
+int32 rtl8651_setAsicNaptTcpFastTimeout(uint32 timeout);
+int32 rtl8651_getAsicNaptTcpFastTimeout(uint32 *timeout);
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_hwPatch.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_hwPatch.h
new file mode 100644
index 00000000..e08355f
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865x_hwPatch.h
@@ -0,0 +1,48 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+/*
+ *
+ *	The header file collects the information about the IC's different Version/Sub-version.
+ *		=> It's used by DRIVER to determine how to implement features for different ICs.
+ *
+ */
+
+#ifndef RTL865x_hwPatch_H
+#define RTL865x_hwPatch_H
+
+/* Chip Version */
+#define RTL865X_CHIP_VER_RTL865XB	0x01
+#define RTL865X_CHIP_VER_RTL865XC	0x02
+#define RTL865X_CHIP_VER_RTL8196B	0x03
+#define RTL865X_CHIP_VER_RTL8196C	0x04
+
+/* Revision ID of each chip */
+#define RTL865X_CHIP_REV_A		0x00
+#define RTL865X_CHIP_REV_B		0x01
+#define RTL865X_CHIP_REV_C		0x02
+#define RTL865X_CHIP_REV_D		0x03
+#define RTL865X_CHIP_REV_E		0x04
+
+#if 1
+#define RTL819X_TLU_CHECK		1
+#else
+
+/* RTL865xC */
+/* ================================== */
+/* Rev-A: It would cause HW process when dynamically stop HW table lookup. */
+#define  RTL819X_TLU_CHECK		(	(( RtkHomeGatewayChipNameID == RTL865X_CHIP_VER_RTL865XC	/* CHIP */ ) && \
+										( RtkHomeGatewayChipRevisionID >= RTL865X_CHIP_REV_B		/* REV */ ))	|| \
+										( RtkHomeGatewayChipNameID == RTL865X_CHIP_VER_RTL8196B		/* CHIP */ ) ||\
+										( RtkHomeGatewayChipNameID == RTL865X_CHIP_VER_RTL8196C		/* CHIP */ ))
+
+#endif
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865xc_asicregs.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865xc_asicregs.h
new file mode 100644
index 00000000..2dfdf04
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/rtl865xc_asicregs.h
@@ -0,0 +1,4099 @@
+/*
+* ----------------------------------------------------------------
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* $Header: /home1/sub1/tmp/cvs2svn/skylark/skylark/skylark/linux-2.6.x/drivers/net/re865x/AsicDriver/rtl865xc_asicregs.h,v 1.3 2008-02-28 11:06:35 alva_zhang Exp $
+*
+* Abstract: ASIC specific definitions.
+*
+* $Author: alva_zhang $
+*
+* ---------------------------------------------------------------
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#ifndef _ASICREGS_H
+#define _ASICREGS_H
+#if defined(CONFIG_RTD_1295_HWNAT)
+#include <asm/io.h>
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+/*
+ *	Just for check menuconfig ....
+ */
+#if defined(CONFIG_RTL_819X)
+#else
+	#error You must choice either 865xB or 865xC in 'make menuconfig'.
+#endif
+
+#undef SWTABLE_NO_HW
+
+/* Basic features
+*/
+#ifdef CONFIG_RTL8196B
+#define MAX_PORT_NUMBER				5
+#else
+#define MAX_PORT_NUMBER				6
+#endif
+#define PORT_NUM_MASK				7
+#define ALL_PORT_MASK				0x3F
+
+#define TABLE_ENTRY_DISTANCE 			(8 * sizeof(uint32))
+#define SWTABLE_BASE_OF_ALL_TABLES 		0xbb000000
+#define table_access_addr_base(type) 		(SWTABLE_BASE_OF_ALL_TABLES + 0x10000 * (type))
+
+/* Filtering Database features */
+#define RTL865XC_FID_BITMASK			0x3
+
+/* Register access macro (REG*()).
+*/
+#ifndef REG32
+#define REG32(reg)				(*((volatile uint32 *)(reg)))
+#endif
+#ifndef REG16
+#define REG16(reg)				(*((volatile uint16 *)(reg)))
+#endif
+#ifndef REG8
+#define REG8(reg)				(*((volatile uint8 *)(reg)))
+#endif
+
+/* Register access macro (READ_MEM32() and WRITE_MEM32()). */
+#if defined(RTL865X_MODEL_USER)||defined(RTL865X_TEST)
+/*
+ * big_endian() is a macro to make endian consistence between 865x board and x86 PC.
+ * All the ASIC registers stored in memory will be stored at big-endian order.
+ * Therefore, we will see the same result when memory dump ASIC registers.
+ *
+ * big_endian32() and big_endian16() are like ntohs() and ntohl().
+ * In order to reduce the complexity of include hirerachy, we don't use ntohs-related functions.
+ */
+#define big_endian32(x) ((((x) & 0xff000000) >> 24) | (((x) & 0x00ff0000) >> 8) | (((x) & 0x0000ff00) << 8) | (((x) & 0x000000ff) << 24))
+#define big_endian16(x) (((x) >> 8) | (((x) & 0x000000ff) << 8))
+#define big_endian(x) big_endian32(x)	/* backward-compatible */
+#else
+#define big_endian32(x) (x)
+#define big_endian16(x) (x)
+#define big_endian(x) big_endian32(x)	/* backward-compatible */
+#endif
+
+#if defined(RTL865X_MODEL_USER)||defined(RTL865X_MODEL_KERNEL)
+void WRITE_MEM32(uint32 reg, uint32 val);
+void WRITE_MEM16(uint32 reg, uint32 val);
+void WRITE_MEM8(uint32 reg, uint32 val);
+uint32 READ_MEM32(uint32 reg);
+uint32 READ_MEM16(uint32 reg);
+uint32 READ_MEM8(uint32 reg);
+void WRITE_VIR32(uint32 reg, uint32 val);
+void WRITE_VIR16(uint32 reg, uint32 val);
+void WRITE_VIR8(uint32 reg, uint32 val);
+uint32 READ_VIR32(uint32 reg);
+uint32 READ_VIR16(uint32 reg);
+uint32 READ_VIR8(uint32 reg);
+#else
+#if defined(CONFIG_RTD_1295_HWNAT)
+#ifndef WRITE_MEM32
+#define WRITE_MEM32(reg, val) iowrite32(val, (void __iomem *)reg)
+#endif
+
+#ifndef WRITE_MEM16
+#define WRITE_MEM16(reg, val) iowrite16(val, (void __iomem *)reg)
+#endif
+
+#ifndef WRITE_MEM8
+#define WRITE_MEM8(reg,val) iowrite8(val, (void __iomem *)reg)
+#endif
+
+#ifndef READ_MEM32
+#define READ_MEM32(reg) ioread32((void __iomem *)reg)
+#endif
+
+#ifndef READ_MEM16
+#define READ_MEM16(reg) ioread16((void __iomem *)reg)
+#endif
+
+#ifndef READ_MEM8
+#define READ_MEM8(reg) ioread8((void __iomem *)reg)
+#endif
+#else // !defined(CONFIG_RTD_1295_HWNAT)
+/* Target Platform, RTL865X_TEST */
+#ifndef WRITE_MEM32
+#define WRITE_MEM32(reg,val) REG32(reg)=big_endian(val)
+#endif
+
+#ifndef WRITE_MEM16
+#define WRITE_MEM16(reg,val) REG16(reg)=big_endian16(val)
+#endif
+
+#ifndef WRITE_MEM8
+#define WRITE_MEM8(reg,val) REG8(reg)=(val)
+#endif
+
+#ifndef READ_MEM32
+#define READ_MEM32(reg) big_endian(REG32(reg))
+#endif
+
+#ifndef READ_MEM16
+#define READ_MEM16(reg) big_endian16(REG16(reg))
+#endif
+
+#ifndef READ_MEM8
+#define READ_MEM8(reg) (REG8(reg))
+#endif
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+#endif
+
+#ifdef CONFIG_RTL8196C_REVISION_B
+#define TOGGLE_BIT_IN_REG(reg, bit_shift)	(WRITE_MEM32(reg, READ_MEM32(reg) ^ bit_shift))
+#define TOGGLE_BIT_IN_REG_TWICE(reg, bit_shift) \
+		do { \
+				TOGGLE_BIT_IN_REG(reg, bit_shift);		\
+				TOGGLE_BIT_IN_REG(reg, bit_shift);		\
+		} while (0)
+#else
+#define TOGGLE_BIT_IN_REG_TWICE(reg, bit_shift)
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define RTL_R32(addr)				ioread32((void __iomem *)addr)
+#define RTL_W32(addr, l)			iowrite32(l, (void __iomem *)addr)
+#define RTL_R8(addr)				ioread8((void __iomem *)addr)
+#define RTL_W8(addr, l)				iowrite8(l, (void __iomem *)addr)
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#define RTL_R32(addr)				(*(volatile unsigned long *)(addr))
+#define RTL_W32(addr, l)			((*(volatile unsigned long*)(addr)) = (l))
+#define RTL_R8(addr)				(*(volatile unsigned char*)(addr))
+#define RTL_W8(addr, l)				((*(volatile unsigned char*)(addr)) = (l))
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+/* MACRO to update HW configuration */
+#define UPDATE_MEM32(reg, val, mask, offset)	\
+	do { \
+		WRITE_MEM32(	(reg),	\
+			((READ_MEM32(reg) & ~((mask) << (offset))) | (((val) & (mask)) << (offset))));\
+	} while (0)
+
+/* MACRO to get value of HW configuration */
+#define GET_MEM32_VAL(reg, mask, offset)	((READ_MEM32(reg) >> (offset)) & (mask))
+
+#define	DIVISOR	1000		/* cfliu: change DIVISOR from 0xe to 4096 for watchdog */
+				/* yjlou: change DIVISOR from 4096 to 100 for better resolution. */
+				/* yjlou: change DIVISOR from 100 to 1000 for longer watchdog trigger. */
+				/* cfliu: change DIVISOR back to 4000 to let printk happy. */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+enum rtl_hwnat_mmio_idx {
+	HWNAT_SWTBL_BASE_IDX = 0,
+	HWNAT_MIB_BASE_IDX,
+	HWNAT_GBL_CTRL_BASE_IDX,
+	HWNAT_EXT_MAC_CTRL_BASE_IDX,
+	HWNAT_GD_STA_BASE_IDX,
+	HWNAT_GMII_TM_BASE_IDX,		/* 5 */
+	HWNAT_CPU_IFACE_BASE_IDX,
+	HWNAT_SERDES_BASE_IDX,
+	HWNAT_NAT_WRP_BASE_IDX,
+	HWNAT_SERDES_ANA_BASE_IDX,
+	HWNAT_MAX_IDX			/* 10 */
+};
+
+/* physical address from 0x98060000 to 0x981CFFFF */
+enum rtl_hwnat_mmio_offset {
+	HWNAT_SWTBL_OFFSET	= 0,		/* all tables in SWCORE */
+	HWNAT_CPUIR_OFFSET	= 0x160000,	/* CPU Interface Register */
+	HWNAT_MIB_OFFSET	= 0x161000,	/* MIM Counters */
+	HWNAT_GPCR_OFFSET	= 0x164000,	/* Global Port Control Register */
+	HWNAT_EXT_MACCR_OFFSET	= 0x165000,	/* Extend MAC Control Register */
+	HWNAT_DDR1_OFFSET	= 0x166100,	/* Descriptor Diagnostic Register (group 1) */
+	HWNAT_DDR2_OFFSET	= 0x166200,	/* Descriptor Diagnostic Register (group 2) */
+	HWNAT_GMII_TM_OFFSET	= 0x166400,	/* MAC GMII i/f Test Mode TX Register */
+	HWNAT_SERDES_OFFSET	= 0x168000,	/* SERDES register , address 16bits */
+	HWNAT_NAT_WRP_OFFSET	= 0x169000,	/* NAT wrapper registers */
+	HWNAT_SERDES_WRP_OFFSET	= 0x169800,	/* SERDES wrapper registers */
+	HWNAT_SERDES_ANA_OFFSET	= 0x16A000,	/* SERDES ANA page register , address 16bits */
+};
+
+extern void __iomem *rtl_hwnat_mmio;
+extern unsigned int rtl_hwnat_base;
+
+#define CPU_IFACE_BASE				((uintptr_t) rtl_hwnat_mmio + HWNAT_CPUIR_OFFSET)
+#define REAL_SWCORE_BASE			CPU_IFACE_BASE
+//#define REAL_SYSTEM_BASE			0x981B0000
+#define REAL_HSA_BASE				((uintptr_t) rtl_hwnat_mmio + HWNAT_DDR2_OFFSET)
+#define REAL_HSB_BASE				(REAL_HSA_BASE + 0x80)
+//#define REAL_SWTBL_BASE			((uintptr_t) rtl_hwnat_mmio + HWNAT_SWTBL_OFFSET)
+#define SW_SWTBL_BASE				((uintptr_t) rtl_hwnat_mmio + HWNAT_SWTBL_OFFSET)
+#define HW_SWTBL_BASE				(rtl_hwnat_base + HWNAT_SWTBL_OFFSET)
+//#define HW_SWTBL_BASE				0x1B000000
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#define REAL_SWCORE_BASE			0xBB800000
+#define REAL_SYSTEM_BASE			0xB8000000
+#define REAL_HSB_BASE				0xBB806280
+#define REAL_HSA_BASE				0xBB806200
+#define REAL_SWTBL_BASE				0xBB000000
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#if defined(RTL865X_TEST) || defined(RTL865X_MODEL_USER) || defined(RTL865X_MODEL_KERNEL)
+#define VIRTUAL_SWCORE_REG_SIZE	(1*64*1024) /* said, BB80_xxxx */
+#define VIRTUAL_SYSTEM_REG_SIZE	(2*64*1024) /* said, B800_xxxx */
+#define VIRTUAL_SWCORE_TBL_SIZE	(1*1024*1024+256*1024) /* said, BB00_xxxx */
+extern int8					*pVirtualSWReg;
+extern int8					*pVirtualSysReg;
+extern int8					*pVirtualHsb;
+extern int8					*pVirtualHsa;
+extern int8					*pVirtualSWTable;
+#define SWCORE_BASE				((uint32)pVirtualSWReg)
+#define SWCORE_SIZE				VIRTUAL_SWCORE_REG_SIZE
+#define SYSTEM_BASE				((uint32)pVirtualSysReg)
+#define SYSTEM_SIZE				(VIRTUAL_SYSTEM_REG_SIZE)
+#define HSB_BASE				((uint32)pVirtualHsb)
+#define HSB_SIZE				0x40
+#define HSA_BASE				((uint32)pVirtualHsa)
+#define HSA_SIZE				0x40
+#else
+#define SWCORE_BASE				REAL_SWCORE_BASE
+#define SYSTEM_BASE				REAL_SYSTEM_BASE
+#define HSB_BASE				REAL_HSB_BASE
+#define HSA_BASE				REAL_HSA_BASE
+#endif
+
+#define RTL8197D_RGMII_PORT			0
+#if defined(CONFIG_RTL_EXCHANGE_PORTMASK)
+#define RTL83XX_WAN				0	// WAN port is set to 8367R port 0
+#else
+#define RTL83XX_WAN				4	// WAN port is set to 8367R port 4
+#endif
+
+#ifdef CONFIG_RTL_8370_SUPPORT
+#define P0_EXT_PHY_ID				5
+#define EXT_SWITCH_MAX_PHY_PORT			8
+#undef RTL83XX_WAN
+#define RTL83XX_WAN				8	// WAN port is set to 8370 port 8
+
+#else
+#define P0_EXT_PHY_ID				6
+#define EXT_SWITCH_MAX_PHY_PORT			5
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_CPU_TAG)
+#if defined(CONFIG_RTL_836X_SUPPORT)
+#undef RTL83XX_WAN
+#define RTL83XX_WAN				0	// WAN port is set to 8367R port 0
+#endif /* CONFIG_RTL_836X_SUPPORT */
+#endif /* CONFIG_RTL_CPU_TAG */
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+#define RTL865X_PORTMASK_UNASIGNED		0x5A5A5A5A
+#define RTL865X_PREALLOC_SKB_UNASIGNED		0xA5A5A5A5
+
+#define RTL865XC_PORT_NUMBER			9
+
+/* Spanning Tree Port State Definition */
+#define RTL8651_PORTSTA_DISABLED		0x00
+#define RTL8651_PORTSTA_BLOCKING		0x01
+#define RTL8651_PORTSTA_LISTENING		0x02
+#define RTL8651_PORTSTA_LEARNING		0x03
+#define RTL8651_PORTSTA_FORWARDING		0x04
+
+#define RTL8651_L2TBL_ROW			256
+#define RTL8651_L2TBL_COLUMN			4
+
+#define RTL865XC_LAGHASHIDX_NUMBER		8	/* There are 8 hash values in RTL865xC Link Aggregation. */
+
+#define RTL865XC_VLAN_NUMBER			4096
+
+//Ethernet port bandwidth control
+#define RTL8651_BC_FULL				0x00
+#define RTL8651_BC_128K				0x01
+#define RTL8651_BC_256K				0x02
+#define RTL8651_BC_512K				0x03
+#define RTL8651_BC_1M				0x04
+#define RTL8651_BC_2M				0x05
+#define RTL8651_BC_4M				0x06
+#define RTL8651_BC_8M				0x07
+#define RTL8651_BC_16M				0x08
+#define RTL8651_BC_32M				0x09
+#define RTL8651_BC_64M				0x0A
+
+/* For round robin ration */
+#define RTL8651_RR_H_FIRST			0x03
+#define RTL8651_RR_H16_L1			0x02
+#define RTL8651_RR_H8_L1			0x01
+#define RTL8651_RR_H4_L1			0x00
+
+#define RTL865XC_NETINTERFACE_NUMBER		8
+
+#define RTL8651_L2_NUMBER			1024
+
+enum FDB_FLAGS {
+	FDB_FWD = 0,
+	FDB_SRCBLK = 1,
+	FDB_TRAPCPU = 2,
+};
+
+/*
+ * ----------------------------------------------------------------------------
+ *
+ * SYSTEM_BASE, 0xB8010000 ~
+ *
+ * ----------------------------------------------------------------------------
+ */
+
+/* redefine CPU_IFACE_BASE as ((unsigned int) rtl_hwnat_mmio + HWNAT_CPUIR_OFFSET) */
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#define CPU_IFACE_BASE				(SYSTEM_BASE+0x10000)	/* 0xB8010000 */
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+#define CPUICR					(0x000 + CPU_IFACE_BASE)	/* Interface control */
+
+#define CPURPDCR0				(0x004 + CPU_IFACE_BASE)	/* Rx pkthdr descriptor control 0 */
+#define CPURPDCR1				(0x008 + CPU_IFACE_BASE)	/* Rx pkthdr descriptor control 1 */
+#define CPURPDCR2				(0x00c + CPU_IFACE_BASE)	/* Rx pkthdr descriptor control 2 */
+#define CPURPDCR3				(0x010 + CPU_IFACE_BASE)	/* Rx pkthdr descriptor control 3 */
+#define CPURPDCR4				(0x014 + CPU_IFACE_BASE)	/* Rx pkthdr descriptor control 4 */
+#define CPURPDCR5				(0x018 + CPU_IFACE_BASE)	/* Rx pkthdr descriptor control 5 */
+#define CPURPDCR(idx)				(CPURPDCR0 + (idx << 2))	/* Rx pkthdr descriptor control with index */
+
+#define CPURMDCR0				(0x01c + CPU_IFACE_BASE)	/* Rx mbuf descriptor control */
+#define CPUTPDCR0				(0x020 + CPU_IFACE_BASE)	/* Tx pkthdr descriptor control Low */
+#define CPUTPDCR1				(0x024 + CPU_IFACE_BASE)	/* Tx pkthdr descriptor control High */
+#define CPUTPDCR(idx)				(CPUTPDCR0 + (idx << 2))	/* Tx pkthdr descriptor control with index */
+
+#define CPUIIMR					(0x028 + CPU_IFACE_BASE)	/* Interrupt mask control */
+#define CPUIISR					(0x02c + CPU_IFACE_BASE)	/* Interrupt status control */
+#define CPUQDM0					(0x030 + CPU_IFACE_BASE)	/* Queue ID 0 and Descriptor Ring Mapping Register */
+#define CPUQDM1					(0x032 + CPU_IFACE_BASE)	/* Queue ID 1 and Descriptor Ring Mapping Register */
+#define CPUQDM2					(0x034 + CPU_IFACE_BASE)	/* Queue ID 2 and Descriptor Ring Mapping Register */
+#define CPUQDM3					(0x036 + CPU_IFACE_BASE)	/* Queue ID 3 and Descriptor Ring Mapping Register */
+#define CPUQDM4					(0x038 + CPU_IFACE_BASE)	/* Queue ID 4 and Descriptor Ring Mapping Register */
+#define CPUQDM5					(0x03a + CPU_IFACE_BASE)	/* Queue ID 5 and Descriptor Ring Mapping Register */
+
+#define DMA_CR0					(0x03c + CPU_IFACE_BASE)	/* DMA Control Register 0 */
+#define DMA_CR1					(0x040 + CPU_IFACE_BASE)	/* DMA Control Register 1 */
+#define DMA_CR2					(0x044 + CPU_IFACE_BASE)	/* DMA Control Register 2 */
+
+#define CPUTPDCR2				(0x060 + CPU_IFACE_BASE)	/* Tx Pkthdr Descriptor 2 Control Register */
+#define CPUTPDCR3				(0x064 + CPU_IFACE_BASE)	/* Tx Pkthdr Descriptor 3 Control Register */
+#define DMA_CR3					(0x068 + CPU_IFACE_BASE)	/* DMA Control Register 3 */
+#define TXRINGCR				(0x078 + CPU_IFACE_BASE)	/* CPU Tx Packet Header Ring Control Register */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define CPUIMCR					(0x080 + CPU_IFACE_BASE)	/* CPU Interrupt Migration Control Register */
+#define CPUIMTTR0				(0x084 + CPU_IFACE_BASE)	/* CPU Interrupt Migration Timeout Threshold Register 0 */
+#define CPUIMTTR1				(0x088 + CPU_IFACE_BASE)	/* CPU Interrupt Migration Timeout Threshold Register 1 */
+#define CPUIMTTR2				(0x08c + CPU_IFACE_BASE)	/* CPU Interrupt Migration Timeout Threshold Register 2 */
+#define CPUIMTTR3				(0x090 + CPU_IFACE_BASE)	/* CPU Interrupt Migration Timeout Threshold Register 3 */
+#define CPUIMPNTR0				(0x094 + CPU_IFACE_BASE)	/* CPU Interrupt Migration Packet Numbers Threshold Register 0 */
+#define CPUIMPNTR1				(0x098 + CPU_IFACE_BASE)	/* CPU Interrupt Migration Packet Numbers Threshold Register 1 */
+#define CPUIMPNTR2				(0x09c + CPU_IFACE_BASE)	/* CPU Interrupt Migration Packet Numbers Threshold Register 2 */
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#define DMA_CR4					(0x0a0 + CPU_IFACE_BASE)	/* DMA Control Register 4 */
+#define CPUICR1					(0x0a4 + CPU_IFACE_BASE)	/* CPU Interface Control Register 1 */
+
+/* CPUICR - CPU interface control register field definitions
+*/
+#define TXCMD					(1 << 31)	/* Enable Tx */
+#define RXCMD					(1 << 30)	/* Enable Rx */
+#define BUSBURST_32WORDS			0
+#define BUSBURST_64WORDS			(1 << 28)
+#define BUSBURST_128WORDS			(2 << 28)
+#define BUSBURST_256WORDS			(3 << 28)
+#define MBUF_128BYTES				0
+#define MBUF_256BYTES				(1 << 24)
+#define MBUF_512BYTES				(2 << 24)
+#define MBUF_1024BYTES				(3 << 24)
+#define MBUF_2048BYTES				(4 << 24)
+#define TXFD					(1 << 23)	/* Notify Tx descriptor fetch */
+#define SOFTRST					(1 << 22)	/* Re-initialize all descriptors */
+#define STOPTX					(1 << 21)	/* Stop Tx */
+#define SWINTSET				(1 << 20)	/* Set software interrupt */
+#define LBMODE					(1 << 19)	/* Loopback mode */
+#define LB10MHZ					(1 << 18)	/* LB 10MHz */
+#define LB100MHZ				(1 << 18)	/* LB 100MHz */
+#define MITIGATION				(1 << 17)	/* Mitigation with timer1 */
+#define EXCLUDE_CRC				(1 << 16)	/* Exclude CRC from length */
+#define RX_SHIFT_OFFSET				0
+
+/*
+	CPU interface descriptor field defintions
+*/
+#define DESC_OWNED_BIT				(1 << 0)
+#define DESC_RISC_OWNED				(0 << 0)
+#define DESC_SWCORE_OWNED			(1 << 0)
+
+#define DESC_WRAP				(1 << 1)
+
+#define DESC_ENG_OWNED				1
+#if defined(CONFIG_RTD_1295_HWNAT)
+/* OWN bit of word5 */
+#define DESC_OWNED2_BIT				(1 << 15)
+#define DESC_RISC_OWNED2			(0 << 15)
+#define DESC_SWCORE_OWNED2			(1 << 15)
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+/* CPUIIMR - CPU interface interrupt mask register field definitions */
+#define LINK_CHANGE_IE				(1 << 31)	/* Link change interrupt enable */
+
+#define RX_ERR_IE0				(1 << 25)	/* Rx error interrupt enable for descriptor 0 */
+#define RX_ERR_IE1				(1 << 26)	/* Rx error interrupt enable for descriptor 1 */
+#define RX_ERR_IE2				(1 << 27)	/* Rx error interrupt enable for descriptor 2 */
+#define RX_ERR_IE3				(1 << 28)	/* Rx error interrupt enable for descriptor 3 */
+#define RX_ERR_IE4				(1 << 29)	/* Rx error interrupt enable for descriptor 4 */
+#define RX_ERR_IE5				(1 << 30)	/* Rx error interrupt enable for descriptor 5 */
+#define RX_ERR_IE_ALL				(0x3f<<25)	/* Rx error interrupt enable for any descriptor */
+
+#define TX_ERR_IE0				(1 << 23)	/* Tx error interrupt pending for descriptor 0 */
+#define TX_ERR_IE1				(1 << 24)	/* Tx error interrupt pending for descriptor 1 */
+#define TX_ERR_IE_ALL				(0x3<<23)	/* Tx error interrupt pending for any descriptor */
+#define TX_ERR_IE				(1 << 29)	/* Tx error interrupt enable */
+
+#define PKTHDR_DESC_RUNOUT_IE0			(1 << 17)	/* Run out pkthdr descriptor 0 interrupt enable */
+#define PKTHDR_DESC_RUNOUT_IE1			(1 << 18)	/* Run out pkthdr descriptor 1 interrupt enable */
+#define PKTHDR_DESC_RUNOUT_IE2			(1 << 19)	/* Run out pkthdr descriptor 2 interrupt enable */
+#define PKTHDR_DESC_RUNOUT_IE3			(1 << 20)	/* Run out pkthdr descriptor 3 interrupt enable */
+#define PKTHDR_DESC_RUNOUT_IE4			(1 << 21)	/* Run out pkthdr descriptor 4 interrupt enable */
+#define PKTHDR_DESC_RUNOUT_IE5			(1 << 22)	/* Run out pkthdr descriptor 5 interrupt enable */
+#define PKTHDR_DESC_RUNOUT_IE_ALL		(0x3f << 17)	/* Run out anyone pkthdr descriptor interrupt pending */
+
+#define TX_DONE_IE3				(1 << 15)	/* Tx Descript Ring 3 one packet done interrupt enable */
+#define TX_DONE_IE2				(1 << 14)	/* Tx Descript Ring 2 one packet done interrupt enable */
+#define TX_ALL_DONE_IE3				(1 << 13)	/* Tx Descript Ring 3 all packets done interrupt enable */
+#define TX_ALL_DONE_IE2				(1 << 12)	/* Tx Descript Ring 2 all packets done interrupt enable */
+
+#define MBUF_DESC_RUNOUT_IE_ALL			(1 << 11)	/* Run out anyone mbuf interrupt pending */
+#define MBUF_DESC_RUNOUT_IE0			(1 << 11)	/* Run out mbuf descriptor 0 interrupt enable */
+
+#define TX_DONE_IE0				(1 << 9)	/* Tx Descript Ring 0 one packet done interrupt enable */
+#define TX_DONE_IE1				(1 << 10)	/* Tx Descript Ring 1 one packet done interrupt enable */
+#define TX_DONE_IE_ALL				(0x3 << 9)	/* Any Tx Descript Ring one packet done interrupt enable */
+
+#define RX_DONE_IE0				(1 << 3)	/* Rx Descript Ring 0 one packet done interrupt enable */
+#define RX_DONE_IE1				(1 << 4)	/* Rx Descript Ring 1 one packet done interrupt enable */
+#define RX_DONE_IE2				(1 << 5)	/* Rx Descript Ring 2 one packet done interrupt enable */
+#define RX_DONE_IE3				(1 << 6)	/* Rx Descript Ring 3 one packet done interrupt enable */
+#define RX_DONE_IE4				(1 << 7)	/* Rx Descript Ring 4 one packet done interrupt enable */
+#define RX_DONE_IE5				(1 << 8)	/* Rx Descript Ring 5 one packet done interrupt enable */
+#define RX_DONE_IE_ALL				(0x3f << 3)	/* Rx Descript Ring any one packet done interrupt enable */
+
+#define TX_ALL_DONE_IE0				(1 << 1)	/* Tx Descript Ring 0 all packets done interrupt enable */
+#define TX_ALL_DONE_IE1				(1 << 2)	/* Tx Descript Ring 1 all packets done interrupt enable */
+
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define TX_ALL_DONE_IE_ALL			(TX_ALL_DONE_IE0|TX_ALL_DONE_IE1|TX_ALL_DONE_IE2|TX_ALL_DONE_IE3)
+#else
+#define TX_ALL_DONE_IE_ALL			(0x3 << 1)	/* Any Tx Descript Ring all packets done interrupt enable */
+#endif
+
+/* CPU interface interrupt status register field definitions */
+#define LINK_CHANGE_IP				(1 << 31)	/* Link change interrupt pending */
+
+#define RX_ERR_IP0				(1 << 25)	/* Rx error descriptor 0 interrupt pending */
+#define RX_ERR_IP1				(1 << 26)	/* Rx error descriptor 1 interrupt pending */
+#define RX_ERR_IP2				(1 << 27)	/* Rx error descriptor 2 interrupt pending */
+#define RX_ERR_IP3				(1 << 28)	/* Rx error descriptor 3 interrupt pending */
+#define RX_ERR_IP4				(1 << 29)	/* Rx error descriptor 4 interrupt pending */
+#define RX_ERR_IP5				(1 << 30)	/* Rx error descriptor 5 interrupt pending */
+#define RX_ERR_IP_ALL				(0x3f<<25)	/* Rx error any descriptor interrupt pending */
+#define RX_ERR_IP(idx)				(1 << (25+(idx)))	/* Rx error descriptor [IDX] interrupt pending */
+
+#define TX_ERR_IP0				(1 << 23)	/* Tx error descriptor 0 interrupt pending */
+#define TX_ERR_IP1				(1 << 24)	/* Tx error descriptor 1 interrupt pending */
+#define TX_ERR_IP_ALL				(0x3<<23)	/* Tx error any descriptor interrupt pending */
+#define TX_ERR_IP(idx)				(1 << (23+(idx)))	/* Tx error descriptor [IDX] interrupt pending */
+
+#define PKTHDR_DESC_RUNOUT_IP0			(1 << 17)	/* Run out pkthdr descriptor 0 interrupt pending */
+#define PKTHDR_DESC_RUNOUT_IP1			(1 << 18)	/* Run out pkthdr descriptor 1 interrupt pending */
+#define PKTHDR_DESC_RUNOUT_IP2			(1 << 19)	/* Run out pkthdr descriptor 2 interrupt pending */
+#define PKTHDR_DESC_RUNOUT_IP3			(1 << 20)	/* Run out pkthdr descriptor 3 interrupt pending */
+#define PKTHDR_DESC_RUNOUT_IP4			(1 << 21)	/* Run out pkthdr descriptor 4 interrupt pending */
+#define PKTHDR_DESC_RUNOUT_IP5			(1 << 22)	/* Run out pkthdr descriptor 5 interrupt pending */
+#define PKTHDR_DESC_RUNOUT_IP_ALL		(0x3f << 17)	/* Run out anyone pkthdr descriptor interrupt pending */
+#define PKTHDR_DESC_RUNOUT_IP(idx)		(1 << (17+(idx)))	/* Run out pkthdr descriptor [IDX] interrupt pending */
+
+#define MBUF_DESC_RUNOUT_IP_ALL			(1 << 16)	/* Run out anyone mbuf interrupt pending */
+#define MBUF_DESC_RUNOUT_IP0			(1 << 16)	/* Run out mbuf descriptor 0 interrupt pending */
+
+#define TX_DONE_IP3				(1 << 15)	/* Tx one packet done interrupt for descriptor 3 pending */
+#define TX_DONE_IP2				(1 << 14)	/* Tx one packet done interrupt for descriptor 2 pending */
+#define TX_ALL_DONE_IP3				(1 << 13)	/* Tx all packets done interrupt 3 pending */
+#define TX_ALL_DONE_IP2				(1 << 12)	/* Tx all packets done interrupt 2 pending */
+
+#define TX_DONE_IP0				(1 << 9)	/* Tx one packet done interrupt for descriptor 0 pending */
+#define TX_DONE_IP1				(1 << 10)	/* Tx one packet done interrupt for descriptor 1 pending */
+#define TX_DONE_IP_ALL				(0x3 << 9)	/* Tx one packet done interrupt for any descriptor pending */
+#define TX_DONE_IP(idx)				(1 << (9+(idx)))	/* Tx one packet done interrupt for descriptor [IDX] pending */
+
+#define RX_DONE_IP0				(1 << 3)	/* Rx one packet done 0 interrupt pending */
+#define RX_DONE_IP1				(1 << 4)	/* Rx one packet done 1 interrupt pending */
+#define RX_DONE_IP2				(1 << 5)	/* Rx one packet done 2 interrupt pending */
+#define RX_DONE_IP3				(1 << 6)	/* Rx one packet done 3 interrupt pending */
+#define RX_DONE_IP4				(1 << 7)	/* Rx one packet done 4 interrupt pending */
+#define RX_DONE_IP5				(1 << 8)	/* Rx one packet done 5 interrupt pending */
+#define RX_DONE_IP_ALL				(0x3f << 3)	/* Rx one packet done anyone interrupt pending */
+#define RX_DONE_IP(idx)				(1 << (3+(idx)))	/* Rx one packet done [IDX] interrupt pending */
+
+#define TX_ALL_DONE_IP0				(1 << 1)	/* Tx all packets done interrupt 0 pending */
+#define TX_ALL_DONE_IP1				(1 << 2)	/* Tx all packets done interrupt 1 pending */
+
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define TX_ALL_DONE_IP_ALL			(TX_ALL_DONE_IP0|TX_ALL_DONE_IP1|TX_ALL_DONE_IP2|TX_ALL_DONE_IP3)
+#else
+#define TX_ALL_DONE_IP_ALL			(0x03 << 1)	/* Tx all packets done any interrupt pending */
+#endif
+#define TX_ALL_DONE_IP(idx)			(1 << (1+(idx)))	/* Tx all packets done interrupt [IDX] pending */
+
+#define INTPENDING_NIC_MASK			(RX_ERR_IP_ALL|TX_ERR_IP_ALL|RX_DONE_IP_ALL|PKTHDR_DESC_RUNOUT_IP_ALL)
+#define INTPENDING_RUN_OUT			(PKTHDR_DESC_RUNOUT_IP_ALL)
+
+/* CPUQDM0,CPUQDM1,CPUQDM2,CPUQDM3,CPUQDM4,CPUQDM5 - Queue ID 0~5 and Descriptor Ring Mapping Register */
+#define CPURxDesc_OFFSET			12
+#define CPURxDesc_MASK				(7<<12)
+#define Ext1RxDesc_OFFSET			8
+#define Ext1RxDesc_MASK				(7<<8)
+#define Ext2RxDesc_OFFSET			4
+#define Ext2RxDesc_MASK				(7<<4)
+#define Ext3RxDesc_OFFSET			0
+#define Ext3RxDesc_MASK				(7<<0)
+#define CPU_RX_DESC_SHIFT			12
+#define EXT1_RX_DESC_SHIFT			8
+#define EXT2_RX_DESC_SHIFT			4
+#define EXT3_RX_DESC_SHIFT			0
+
+/* DMA_CR0 - DMA Control Register 0 */
+/* HSB of Lexra bus address marking for mapping the SW virtual address to physical address.
+	addr[31:28] is replace by 'HsbAddrMark & addr[31:28]' */
+#define HsbAddrMark_OFFSET			16
+#define HsbAddrMark_MASK			(0xf<<16)
+#define LowFifoMark_OFFSET			8
+#define LowFifoMark_MASK			(0xff<<8)
+#define HiFifoMark_MASK				(0xff<<0)
+
+/* DMA_CR4 - DMA Control Register 4 */
+#define TX_RING3_TAIL_AWARE			(1<<3)
+#define TX_RING2_TAIL_AWARE			(1<<2)
+#define TX_RING1_TAIL_AWARE			(1<<1)
+#define TX_RING0_TAIL_AWARE			(1<<0)
+
+/* CPUICR1 - CPU Interface Control Register 1 */
+#define CF_V6LSO_ID_UP_OFFSET			10	/* Configure to update LSO IPFv6 and UFOv6 fragment ID  W1C */
+#define CF_PKT_HDR_TYPE_OFFSET			8	/* Tx packet header type */
+#define CF_PKT_HDR_TYPE_MASK			(3<<8)
+#define TX_PKTHDR_8198C_DEF			(0<<8)	/* default type as RTL8198C */
+#define TX_PKTHDR_SHORTCUT_LSO			(1<<8)	/* packet header support shortcut and LSO */
+
+#define CF_TXGAYHER_INT_OFFSET			7	/* Configure to integrate NIC TX done interrupt in gather mode */
+#define CF_TX_GATHER_OFFSET			6	/* Configure NIC Tx to support to gather multiple descriptor into 1 packet */
+#define CF_RX_GATHER_OFFSET			5	/* Configure NIC Rx to support to gather multiple descriptor into 1 packet */
+#define CF_TSO_ID_SEL_OFFSET			4	/* Increment ID configuration of IP header:
+							 * 0: each ID of IP header is same as original ID
+							 * 1: increment 1 from original ID.     R/W     0B
+							 */
+#define CF_NIC_LITTLE_ENDIAN_OFFSET		1	/* Configure NIC master lexra bus in little endian mode */
+#define CF_TXRX_DIV_LX_OFFSET			0	/* Configure for NIC Tx/Rx using different lexra bus */
+#define CF_TSO_ID_SEL				4	/* Increment ID configuration of IP header */
+
+/* TXRINGCR - CPU Tx Packet Header Ring Control Register */
+#define TX_RING3_EN				(1<<3)	/* enable tx packet ring#3 */
+#define TX_RING2_EN				(1<<2)	/* enable tx packet ring#2 */
+#define TX_RING1_EN				(1<<1)	/* enable tx packet ring#1 */
+#define TX_RING0_EN				(1<<0)	/* enable tx packet ring#0, must be 1 */
+
+/*
+ * ----------------------------------------------------------------------------
+ *
+ * SWCORE_BASE, 0xBB800000 ~
+ *
+ * ----------------------------------------------------------------------------
+ */
+
+/* MIB counter registers
+*/
+#define MIB_COUNTER_BASE			(SWCORE_BASE + 0x00001000)
+#define MIB_CONTROL				(0x00 + MIB_COUNTER_BASE)	/*MIB control Register */
+
+/* MIB counter registers
+*/
+#define MIB_ADDROFFSETBYPORT			0x80	/* Address offset of the same counters of each port. Ex: P0's ifInOctets counter and P1's ifInOctets counter. */
+#define OFFSET_ETHERSTATSCPUEVENTPKT		0x84
+#define OFFSET_IFINOCTETS_P0			0x100
+#define OFFSET_IFINUCASTPKTS_P0			0x108
+#define OFFSET_ETHERSTATSOCTETS_P0		0x10C
+#define OFFSET_ETHERSTATSUNDERSIZEPKTS_P0	0x114
+#define OFFSET_ETHERSTATSFRAGMEMTS_P0		0x118
+#define OFFSET_ETHERSTATSPKTS64OCTETS_P0	0x11C
+#define OFFSET_ETHERSTATSPKTS65TO127OCTETS_P0	0x120
+#define OFFSET_ETHERSTATSPKTS128TO255OCTETS_P0	0x124
+#define OFFSET_ETHERSTATSPKTS256TO511OCTETS_P0	0x128
+#define OFFSET_ETHERSTATSPKTS512TO1023OCTETS_P0	0x12C
+#define OFFSET_ETHERSTATSPKTS1024TO1518OCTETS_P0	0x130
+#define OFFSET_ETHERSTATSOVERSIZEPKTS_P0	0x134
+#define OFFSET_ETHERSTATSJABBERS_P0		0x138
+#define OFFSET_ETHERSTATSMULTICASTPKTS_P0	0x13C
+#define OFFSET_ETHERSTATSBROADCASTPKTS_P0	0x140
+#define OFFSET_DOT1DTPPORTINDISCARDS_P0		0x144
+#define OFFSET_ETHERSTATSDROPEVENTS_P0		0x148
+#define OFFSET_DOT3STATSFCSERRORS_P0		0x14C
+#define OFFSET_DOT3STATSSYMBOLERRORS_P0		0x150
+#define OFFSET_DOT3CONTROLINUNKNOWNOPCODES_P0	0x154
+#define OFFSET_DOT3INPAUSEFRAMES_P0		0x158
+#define OFFSET_INRXDVCNT_P0			0x15C
+#define OFFSET_QMDISCARDCNT_P0			0x160
+
+#define OFFSET_IFOUTOCTETS_P0			0x800
+#define OFFSET_IFOUTUCASTPKTS_P0		0x808
+#define OFFSET_IFOUTMULTICASTPKTS_P0		0x80C
+#define OFFSET_IFOUTBROADCASTPKTS_P0		0x810
+#define OFFSET_IFOUTDISCARDS			0x814
+#define OFFSET_DOT3STATSSINGLECOLLISIONFRAMES_P0	0x818
+#define OFFSET_DOT3STATSMULTIPLECOLLISIONFRAMES_P0	0x81C
+#define OFFSET_DOT3STATSDEFERREDTRANSMISSIONS_P0	0x820
+#define OFFSET_DOT3STATSLATECOLLISIONS_P0	0x824
+#define OFFSET_DOT3STATSEXCESSIVECOLLISIONS_P0	0x828
+#define OFFSET_DOT3OUTPAUSEFRAMES_P0		0x82C
+#define OFFSET_DOT1DBASEPORTDELAYEXCEEDEDDISCARDS_P0	0x830
+#define OFFSET_ETHERSTATSCOLLISIONS_P0		0x834
+/* MIB control register field definitions
+*/
+#define ALL_COUNTER_RESTART_MASK		0x0007ffff	/* SYS_COUNTER_RESTART | IN_COUNTER_RESTART_P8 | ... | OUT_COUNTER_RESTART_P0 */
+#define SYS_COUNTER_RESTART			(1 << 18)
+#define IN_COUNTER_RESTART_P8			(1 << 17)
+#define OUT_COUNTER_RESTART_P8			(1 << 16)
+#define IN_COUNTER_RESTART_P7			(1 << 15)
+#define OUT_COUNTER_RESTART_P7			(1 << 14)
+#define IN_COUNTER_RESTART_P6			(1 << 13)
+#define OUT_COUNTER_RESTART_P6			(1 << 12)
+#define IN_COUNTER_RESTART_P5			(1 << 11)
+#define OUT_COUNTER_RESTART_P5			(1 << 10)
+#define IN_COUNTER_RESTART_P4			(1 << 9)
+#define OUT_COUNTER_RESTART_P4			(1 << 8)
+#define IN_COUNTER_RESTART_P3			(1 << 7)
+#define OUT_COUNTER_RESTART_P3			(1 << 6)
+#define IN_COUNTER_RESTART_P2			(1 << 5)
+#define OUT_COUNTER_RESTART_P2			(1 << 4)
+#define IN_COUNTER_RESTART_P1			(1 << 3)
+#define OUT_COUNTER_RESTART_P1			(1 << 2)
+#define IN_COUNTER_RESTART_P0			(1 << 1)
+#define OUT_COUNTER_RESTART_P0			(1 << 0)
+
+#define PORT_FOR_COUNTING_OFFSET		24	/*8650 offset while 8650B offset is 21 */
+
+#define CPU_EVENTS				(0x074 + MIB_COUNTER_BASE)
+#define EXT_PORT_FOR_COUNTING_MASK		0x00E00000
+#define EXT_PORT_FOR_COUNTING_OFFSET		21
+#define RX_BYTES_1				(0x080 + MIB_COUNTER_BASE)
+#define RX_PKTS_1				(0x084 + MIB_COUNTER_BASE)
+#define DROP_EVENTS_1				(0x088 + MIB_COUNTER_BASE)
+#define CPU_EVENTS_1				(0x08C + MIB_COUNTER_BASE)
+#define RX_BYTES_2				(0x090 + MIB_COUNTER_BASE)
+#define RX_PKTS_2				(0x094 + MIB_COUNTER_BASE)
+#define DROP_EVENTS_2				(0x098 + MIB_COUNTER_BASE)
+#define CPU_EVENTS_2				(0x09C + MIB_COUNTER_BASE)
+#define TX_BYTES_1				(0x0A0 + MIB_COUNTER_BASE)
+#define TX_PKTS_1				(0x0A4 + MIB_COUNTER_BASE)
+#define TX_BYTES_2				(0x0A8 + MIB_COUNTER_BASE)
+#define TX_PKTS_2				(0x0AC + MIB_COUNTER_BASE)
+
+/* Pre-fetch control register
+*/
+#define PFBRst					(1<<16)	/* Pre-fetch buffer reset */
+#define DFC_OV					(1<<15)	/* DFC counter overflow flag */
+#define FPFHC_OV				(1<<14)	/* DPFHC counter overflow flag */
+#define CDFC					(1<<13)	/* Clear Data Fetch Counter */
+#define CDPFHC					(1<<12)	/* Clear Data Pre-Fetch Hit Counter */
+#define EnDFC					(1<<11)	/* Enable Data Fetch Counter */
+#define EnDPFHC					(1<<10)	/* Enable Data Pre-Fetch Hit Counter */
+#define EnSDPreFetch_D_MASK			(0x00000300)	/* Enable SDRAM pre-fetch function for Data : Mask */
+#define EnSDPreFetch_D_Disable			(0x00000100)	/* Enable SDRAM pre-fetch function for Data : disable */
+#define EnSDPreFetch_D_4W			(0x00000200)	/* Enable SDRAM pre-fetch function for Data : 4W */
+#define EnSDPreFetch_D_4W4W			(0x00000300)	/* Enable SDRAM pre-fetch function for Data : 4W+4W */
+#define EnSDPreFetch_D_OFFSET			(8)	/* Enable SDRAM pre-fetch function for Data : Offset */
+#define IFC_OV					(1<<7)	/* IFC counter overflow flag */
+#define IPFHC_OV				(1<<6)	/* IPFHC counter overflow flag */
+#define CIFC					(1<<5)	/* Clear Instruction Fetch Counter */
+#define CIPFHC					(1<<4)	/* Clear Instruction Pre-Fetch Hit Counter */
+#define EnIFC					(1<<3)	/* Enable Instruction Fetch Counter */
+#define EnIPFHC					(1<<2)	/* Enable Instruction Pre-Fetch Hit Counter */
+#define EnSDPreFetch_I_MASK			(0x00000003)	/* Enable SDRAM pre-fetch function for Instruction : Mask */
+#define EnSDPreFetch_I_OFFSET			(0)	/* Enable SDRAM pre-fetch function for Instruction : Offset */
+#define EnSDPreFetch_I_Disable			(0x00000001)	/* Enable SDRAM pre-fetch function for Instruction : disable */
+#define EnSDPreFetch_I_4W			(0x00000002)	/* Enable SDRAM pre-fetch function for Instruction : 4W */
+#define EnSDPreFetch_I_4W4W			(0x00000003)	/* Enable SDRAM pre-fetch function for Instruction : 4W+4W */
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+/* PHY control registers
+*/
+#define PHY_BASE				(SWCORE_BASE + 0x00002000)
+#define PORT0_PHY_CONTROL			(0x000 + PHY_BASE)
+#define PORT0_PHY_STATUS			(0x004 + PHY_BASE)
+#define PORT0_PHY_IDENTIFIER_1			(0x008 + PHY_BASE)
+#define PORT0_PHY_IDENTIFIER_2			(0x00C + PHY_BASE)
+#define PORT0_PHY_AUTONEGO_ADVERTISEMENT	(0x010 + PHY_BASE)
+#define PORT0_PHY_AUTONEGO_LINK_PARTNER_ABILITY	(0x014 + PHY_BASE)
+#define PORT1_PHY_CONTROL			(0x020 + PHY_BASE)
+#define PORT1_PHY_STATUS			(0x024 + PHY_BASE)
+#define PORT1_PHY_IDENTIFIER_1			(0x028 + PHY_BASE)
+#define PORT1_PHY_IDENTIFIER_2			(0x02C + PHY_BASE)
+#define PORT1_PHY_AUTONEGO_ADVERTISEMENT	(0x030 + PHY_BASE)
+#define PORT1_PHY_AUTONEGO_LINK_PARTNER_ABILITY	(0x034 + PHY_BASE)
+#define PORT2_PHY_CONTROL			(0x040 + PHY_BASE)
+#define PORT2_PHY_STATUS			(0x044 + PHY_BASE)
+#define PORT2_PHY_IDENTIFIER_1			(0x048 + PHY_BASE)
+#define PORT2_PHY_IDENTIFIER_2			(0x04C + PHY_BASE)
+#define PORT2_PHY_AUTONEGO_ADVERTISEMENT	(0x050 + PHY_BASE)
+#define PORT2_PHY_AUTONEGO_LINK_PARTNER_ABILITY	(0x054 + PHY_BASE)
+#define PORT3_PHY_CONTROL			(0x060 + PHY_BASE)
+#define PORT3_PHY_STATUS			(0x064 + PHY_BASE)
+#define PORT3_PHY_IDENTIFIER_1			(0x068 + PHY_BASE)
+#define PORT3_PHY_IDENTIFIER_2			(0x06C + PHY_BASE)
+#define PORT3_PHY_AUTONEGO_ADVERTISEMENT	(0x070 + PHY_BASE)
+#define PORT3_PHY_AUTONEGO_LINK_PARTNER_ABILITY	(0x074 + PHY_BASE)
+#define PORT4_PHY_CONTROL			(0x080 + PHY_BASE)
+#define PORT4_PHY_STATUS			(0x084 + PHY_BASE)
+#define PORT4_PHY_IDENTIFIER_1			(0x088 + PHY_BASE)
+#define PORT4_PHY_IDENTIFIER_2			(0x08C + PHY_BASE)
+#define PORT4_PHY_AUTONEGO_ADVERTISEMENT	(0x090 + PHY_BASE)
+#define PORT4_PHY_AUTONEGO_LINK_PARTNER_ABILITY	(0x094 + PHY_BASE)
+#define PORT5_PHY_CONTROL			(0x0A0 + PHY_BASE)
+#define PORT5_PHY_STATUS			(0x0A4 + PHY_BASE)
+#define PORT5_PHY_IDENTIFIER_1			(0x0A8 + PHY_BASE)
+#define PORT5_PHY_IDENTIFIER_2			(0x0AC + PHY_BASE)
+#define PORT5_PHY_AUTONEGO_ADVERTISEMENT	(0x0B0 + PHY_BASE)
+#define PORT5_PHY_AUTONEGO_LINK_PARTNER_ABILITY	(0x0B4 + PHY_BASE)
+#define PORT6_PHY_CONTROL			(0x0C0 + PHY_BASE)
+#define PORT6_PHY_STATUS			(0x0C4 + PHY_BASE)
+#define PORT6_PHY_IDENTIFIER_1			(0x0C8 + PHY_BASE)
+#define PORT6_PHY_IDENTIFIER_2			(0x0CC + PHY_BASE)
+#define PORT6_PHY_AUTONEGO_ADVERTISEMENT	(0x0D0 + PHY_BASE)
+#define PORT6_PHY_AUTONEGO_LINK_PARTNER_ABILITY	(0x0D4 + PHY_BASE)
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+/* PHY control register field definitions
+*/
+#define PHY_RESET				(1 << 15)
+#define ENABLE_LOOPBACK				(1 << 14)
+#define SPEED_SELECT_100M			(1 << 13)
+#define SPEED_SELECT_10M			0
+#define ENABLE_AUTONEGO				(1 << 12)
+#define POWER_DOWN				(1 << 11)
+#define ISOLATE_PHY				(1 << 10)
+#define RESTART_AUTONEGO			(1 << 9)
+#define SELECT_FULL_DUPLEX			(1 << 8)
+#define SELECT_HALF_DUPLEX			0
+#define SPEED_SELECT_1000M			(1 << 6)
+/* PHY status register field definitions
+*/
+#define STS_CAPABLE_100BASE_T4			(1 << 15)
+#define STS_CAPABLE_100BASE_TX_FD		(1 << 14)
+#define STS_CAPABLE_100BASE_TX_HD		(1 << 13)
+#define STS_CAPABLE_10BASE_TX_FD		(1 << 12)
+#define STS_CAPABLE_10BASE_TX_HD		(1 << 11)
+#define STS_MF_PREAMBLE_SUPPRESSION		(1 << 6)
+#define STS_AUTONEGO_COMPLETE			(1 << 5)
+#define STS_REMOTE_FAULT			(1 << 4)
+#define STS_CAPABLE_NWAY_AUTONEGO		(1 << 3)
+#define STS_LINK_ESTABLISHED			(1 << 2)
+#define STS_JABBER_DETECTED			(1 << 1)
+#define STS_CAPABLE_EXTENDED			(1 << 0)
+/* PHY identifier 1
+*/
+#define OUT_3_18_MASK				(0xFFFF << 16)
+#define OUT_3_18_OFFSET				16
+#define OUT_19_24_MASK				(0x3F << 10)
+#define OUT_19_24_OFFSET			10
+#define MODEL_NUMBER_MASK			(0x3F << 4)
+#define MODEL_NUMBER_OFFSET			4
+#define REVISION_NUMBER_MASK			0x0F
+#define REVISION_NUMBER_OFFSET			0
+/* PHY auto-negotiation advertisement and
+link partner ability registers field definitions
+*/
+#define NEXT_PAGE_ENABLED			(1 << 15)
+#define ACKNOWLEDGE				(1 << 14)
+#define REMOTE_FAULT				(1 << 13)
+#define CAPABLE_PAUSE				(1 << 10)
+#define CAPABLE_100BASE_T4			(1 << 9)
+#define CAPABLE_100BASE_TX_FD			(1 << 8)
+#define CAPABLE_100BASE_TX_HD			(1 << 7)
+#define CAPABLE_10BASE_TX_FD			(1 << 6)
+#define CAPABLE_10BASE_TX_HD			(1 << 5)
+#define SELECTOR_MASK				0x1F
+#define SELECTOR_OFFSET				0
+#define CAP_100BASE_OFFSET			5
+#define CAP_100BASE_MASK			(0x1F << CAP_100BASE_OFFSET)	/* 10/100 capability mask */
+/* PHY 1000BASE-T control and 1000BASE-T Status
+*/
+#define CAPABLE_1000BASE_TX_FD			(1 << 9)
+#define CAPABLE_1000BASE_TX_HD			(1 << 8)
+#define ADVCAP_1000BASE_OFFSET			8
+#define LPCAP_1000BASE_OFFSET			10
+#define ADVCAP_1000BASE_MASK			(0x3 << ADVCAP_1000BASE_OFFSET)	/* advertisement capability mask */
+#define LPCAP_1000BASE_MASK			(0x3 << LPCAP_1000BASE_OFFSET)	/* link partner status mask */
+
+/* Switch Core Control Registers
+*/
+#define SWCORECNR				(SWCORE_BASE + 0x00006000)
+
+#define MACMR					(0x004 + SWCORECNR)	/* MAC monitor */
+#define VLANTCR					(0x008 + SWCORECNR)	/* Vlan tag control */
+#define DSCR0					(0x00C + SWCORECNR)	/* Qos by DS control */
+#define DSCR1					(0x010 + SWCORECNR)	/* Qos by DS control */
+#define QOSCR					(0x014 + SWCORECNR)	/* Qos control */
+
+/* Descriptor Diagnostic Register */
+#define DESCDIAG_BASE				(SWCORE_BASE + 0x6100)
+#define GDSR0					(DESCDIAG_BASE + 0x000)	/* Global Descriptor Status Register 0 */
+#define GDSR1					(DESCDIAG_BASE + 0x004)	/* Global Descriptor Status Register 1 */
+#define PCSR0					(DESCDIAG_BASE + 0x008)	/* Port Congestion Status Register 0 */
+#define PCSR1					(DESCDIAG_BASE + 0x00c)	/* Port Congestion Status Register 1 */
+#define P0_DCR0					(DESCDIAG_BASE + 0x010)	/* Port 0 Descriptor Counter Register 0 */
+#define P0_DCR1					(DESCDIAG_BASE + 0x014)	/* Port 0 Descriptor Counter Register 1 */
+#define P0_DCR2					(DESCDIAG_BASE + 0x018)	/* Port 0 Descriptor Counter Register 2 */
+#define P0_DCR3					(DESCDIAG_BASE + 0x01c)	/* Port 0 Descriptor Counter Register 3 */
+#define P1_DCR0					(DESCDIAG_BASE + 0x020)	/* Port 1 Descriptor Counter Register 0 */
+#define P1_DCR1					(DESCDIAG_BASE + 0x024)	/* Port 1 Descriptor Counter Register 1 */
+#define P1_DCR2					(DESCDIAG_BASE + 0x028)	/* Port 1 Descriptor Counter Register 2 */
+#define P1_DCR3					(DESCDIAG_BASE + 0x02c)	/* Port 1 Descriptor Counter Register 3 */
+#define P2_DCR0					(DESCDIAG_BASE + 0x030)	/* Port 2 Descriptor Counter Register 0 */
+#define P2_DCR1					(DESCDIAG_BASE + 0x034)	/* Port 2 Descriptor Counter Register 1 */
+#define P2_DCR2					(DESCDIAG_BASE + 0x038)	/* Port 2 Descriptor Counter Register 2 */
+#define P2_DCR3					(DESCDIAG_BASE + 0x03c)	/* Port 2 Descriptor Counter Register 3 */
+#define P3_DCR0					(DESCDIAG_BASE + 0x040)	/* Port 3 Descriptor Counter Register 0 */
+#define P3_DCR1					(DESCDIAG_BASE + 0x044)	/* Port 3 Descriptor Counter Register 1 */
+#define P3_DCR2					(DESCDIAG_BASE + 0x048)	/* Port 3 Descriptor Counter Register 2 */
+#define P3_DCR3					(DESCDIAG_BASE + 0x04c)	/* Port 3 Descriptor Counter Register 3 */
+#define P4_DCR0					(DESCDIAG_BASE + 0x050)	/* Port 4 Descriptor Counter Register 0 */
+#define P4_DCR1					(DESCDIAG_BASE + 0x054)	/* Port 4 Descriptor Counter Register 1 */
+#define P4_DCR2					(DESCDIAG_BASE + 0x058)	/* Port 4 Descriptor Counter Register 2 */
+#define P4_DCR3					(DESCDIAG_BASE + 0x05c)	/* Port 4 Descriptor Counter Register 3 */
+#define P5_DCR0					(DESCDIAG_BASE + 0x060)	/* Port 5 Descriptor Counter Register 0 */
+#define P5_DCR1					(DESCDIAG_BASE + 0x064)	/* Port 5 Descriptor Counter Register 1 */
+#define P5_DCR2					(DESCDIAG_BASE + 0x068)	/* Port 5 Descriptor Counter Register 2 */
+#define P5_DCR3					(DESCDIAG_BASE + 0x06c)	/* Port 5 Descriptor Counter Register 3 */
+#define P6_DCR0					(DESCDIAG_BASE + 0x070)	/* Port CPU Descriptor Counter Register 0 */
+#define P6_DCR1					(DESCDIAG_BASE + 0x074)	/* Port CPU Descriptor Counter Register 1 */
+#define P6_DCR2					(DESCDIAG_BASE + 0x078)	/* Port CPU Descriptor Counter Register 2 */
+#define P6_DCR3					(DESCDIAG_BASE + 0x07c)	/* Port CPU Descriptor Counter Register 3 */
+
+#define Pn_DSCR0(idx)				(DESCDIAG_BASE + ((idx) * 0x10) + 0x010)
+#define Pn_DSCR1(idx)				(DESCDIAG_BASE + ((idx) * 0x10) + 0x014)
+#define Pn_DSCR2(idx)				(DESCDIAG_BASE + ((idx) * 0x10) + 0x018)
+#define Pn_DSCR3(idx)				(DESCDIAG_BASE + ((idx) * 0x10) + 0x01c)
+
+#define Pn_IQDesCnt_OFFSET			(0)
+#define Pn_IQDesCnt_MASK			(0x3ff << Pn_IQDesCnt_OFFSET)
+
+#define Pn_OQDSCR_MASK				(0x3ff)<<Pn_ODD_OQDSCR_OFFSET
+#define Pn_ODD_OQDSCR_OFFSET			(16)
+#define Pn_EQDSCR_MASK				(0x3ff)<<Pn_EVEN_OQDSCR_OFFSET
+#define Pn_EVEN_OQDSCR_OFFSET			(0)
+
+#define Pn_OQDSCR(port, queue)	\
+	( \
+	((queue) == 0) || ((queue) == 1) ? \
+		((queue & 0x01) ? ((READ_MEM32(Pn_DSCR0(port)) >> Pn_ODD_OQDSCR_OFFSET) & Pn_OQDSCR_MASK) : \
+						((READ_MEM32(Pn_DSCR0(port)) >> Pn_EVEN_OQDSCR_OFFSET) & Pn_OQDSCR_MASK)): \
+	((queue) == 2) || ((queue) == 3) ? \
+		((queue & 0x01) ? ((READ_MEM32(Pn_DSCR1(port)) >> Pn_ODD_OQDSCR_OFFSET) & Pn_OQDSCR_MASK) : \
+						((READ_MEM32(Pn_DSCR1(port)) >> Pn_EVEN_OQDSCR_OFFSET) & Pn_OQDSCR_MASK)): \
+	((queue) == 4) || ((queue) == 5) ? \
+		((queue & 0x01) ? ((READ_MEM32(Pn_DSCR2(port)) >> Pn_ODD_OQDSCR_OFFSET) & Pn_OQDSCR_MASK) : \
+						((READ_MEM32(Pn_DSCR2(port)) >> Pn_EVEN_OQDSCR_OFFSET) & Pn_OQDSCR_MASK)): \
+	0)
+
+#define Pn_IQDSCR(port)	((READ_MEM32(Pn_DSCR3(port)) & Pn_IQDesCnt_MASK) >> Pn_IQDesCnt_OFFSET)
+
+/* GDSR0 - Global Descriptor Status Register 0 */
+#define DSCRUNOUT				(1<<27)	/* Descriptor Run Out */
+#define TotalDscFctrl_Flag			(1<<26)	/* TotalDescriptor Flow Control event flag */
+#define USEDDSC_OFFSET				16	/* Total Used Descriptor */
+#define USEDDSC_MASK				(0x3ff<<16)	/* Total Used Descriptor */
+#define SharedBufFCON_Flag			(1<<14)	/* SharedBufFCON threshold triggerred flag */
+#define MaxUsedDsc_OFFSET			0	/* Max Used Descriptor Count History */
+#define MaxUsedDsc_MASK				(0x3fff<<0)	/* Max Used Descriptor Count History */
+
+/* PCSR0 - Port Congestion Status Register 0 */
+#define P3OQCgst_OFFSET				(24)
+#define P3OQCgst_MASK				(0x7f << P3OQCgst_OFFSET)
+#define P2OQCgst_OFFSET				(16)
+#define P2OQCgst_MASK				(0x7f << P2OQCgst_OFFSET)
+#define P1OQCgst_OFFSET				(8)
+#define P1OQCgst_MASK				(0x7f << P1OQCgst_OFFSET)
+#define P0OQCgst_OFFSET				(0)
+#define P0OQCgst_MASK				(0x7f << P0OQCgst_OFFSET)
+
+#define P3QQCgst(queue)				(((READ_MEM32(PCSR0) & P3OQCgst_MASK) >> P3OQCgst_OFFSET) & (1 << (queue)))
+#define P2QQCgst(queue)				(((READ_MEM32(PCSR0) & P2OQCgst_MASK) >> P2OQCgst_OFFSET) & (1 << (queue)))
+#define P1QQCgst(queue)				(((READ_MEM32(PCSR0) & P1OQCgst_MASK) >> P1OQCgst_OFFSET) & (1 << (queue)))
+#define P0QQCgst(queue)				(((READ_MEM32(PCSR0) & P0OQCgst_MASK) >> P0OQCgst_OFFSET) & (1 << (queue)))
+
+/* PCSR1 - Port Congestion Status Register 1 */
+#define IQCgst_OFFSET				(24)
+#define IQCgst_MASK				(0x7f << P3OQCgst_OFFSET)
+#define P6OQCgst_OFFSET				(16)
+#define P6OQCgst_MASK				(0x7f << P6OQCgst_OFFSET)
+#define P5OQCgst_OFFSET				(8)
+#define P5OQCgst_MASK				(0x7f << P5OQCgst_OFFSET)
+#define P4OQCgst_OFFSET				(0)
+#define P4OQCgst_MASK				(0x7f << P4OQCgst_OFFSET)
+
+#define IQCgst(port)				(((READ_MEM32(PCSR1) & IQCgst_MASK) >> IQCgst_OFFSET) & (1 << (port)))
+#define P6QQCgst(queue)				(((READ_MEM32(PCSR1) & P6OQCgst_MASK) >> P6OQCgst_OFFSET) & (1 << (queue)))
+#define P5QQCgst(queue)				(((READ_MEM32(PCSR1) & P5OQCgst_MASK) >> P5OQCgst_OFFSET) & (1 << (queue)))
+#define P4QQCgst(queue)				(((READ_MEM32(PCSR1) & P4OQCgst_MASK) >> P4OQCgst_OFFSET) & (1 << (queue)))
+
+#define TMCR					(0x300 + SWCORECNR)	/* Test mode control */
+#define MIITM_TXR0				(0x400 + SWCORECNR)	/* MAC Test Mode MII TX Interface Register */
+#define MIITM_TXR1				(0x404 + SWCORECNR)	/* MAC Test Mode MII TX Interface Register */
+#define MIITM_RXR0				(0x408 + SWCORECNR)	/* MAC Test Mode MII RX Interface Register */
+#define MIITM_RXR1				(0x40C + SWCORECNR)	/* MAC Test Mode MII RX Interface Register */
+#define GMIITM_TXR0				(0x400 + SWCORECNR)	/* MAC Test Mode MII TX Interface Register */
+#define GMIITM_TXR1				(0x404 + SWCORECNR)	/* MAC Test Mode MII TX Interface Register */
+#define GMIITM_RXR0				(0x408 + SWCORECNR)	/* MAC Test Mode MII RX Interface Register */
+#define GMIITM_RXR1				(0x40C + SWCORECNR)	/* MAC Test Mode MII RX Interface Register */
+
+#define EN_PHY_P4				(1 << 9)
+#define EN_PHY_P3				(1 << 8)
+#define EN_PHY_P2				(1 << 7)
+#define EN_PHY_P1				(1 << 6)
+#define EN_PHY_P0				(1 << 5)
+#define EN_FX_P4				(1 << 4)
+#define EN_FX_P3				(1 << 3)
+#define EN_FX_P2				(1 << 2)
+#define EN_FX_P1				(1 << 1)
+#define EN_FX_P0				(1 << 0)
+
+#define GUEST_VLAN_BITMASK			0xFFF
+#define MULTICAST_BROADCAST_BIT			0x1
+#define PCRP_SIZE				4
+#define STP_PortST				5
+#define STP_PortST_BITMASK			3
+
+/* MAC monitor register field definitions
+*/
+#define SYS_CLK_MASK				(0x7 << 16)
+#define SYS_CLK_100M				(0 << 16)
+#define SYS_CLK_90M				(1 << 16)
+#define SYS_CLK_85M				(2 << 16)
+#define SYS_CLK_96M				(3 << 16)
+#define SYS_CLK_80M				(4 << 16)
+#define SYS_CLK_75M				(5 << 16)
+#define SYS_CLK_70M				(6 << 16)
+#define SYS_CLK_50M				(7 << 16)
+/* VLAN tag control register field definitions
+*/
+#define VLAN_TAG_ONLY				(1 << 19)	/* Only accept tagged packets */
+#define MII_ENFORCE_MODE			(1 << 4)	/* Enable MII port property set by force mode */
+/* Qos by DS control register
+*/
+/* Qos control register
+*/
+#define QWEIGHT_MASK				(3 << 30)
+#define QWEIGHT_ALWAYS_H			(3 << 30)	/* Weighted round robin of priority always high first */
+#define QWEIGHT_16TO1				(2 << 30)	/* Weighted round robin of priority queue 16:1 */
+#define QWEIGHT_8O1				(1 << 30)	/* Weighted round robin of priority queue 8:1 */
+#define QWEIGHT_4TO1				0		/* Weighted round robin of priority queue 4:1 */
+#define EN_FCA_AUTOOFF				(1 << 29)	/* Enable flow control auto off */
+#define DIS_DS_PRI				(1 << 28)	/* Disable DS priority */
+#define DIS_VLAN_PRI				(1 << 27)	/* Disable 802.1p priority */
+#define PORT5_H_PRI				(1 << 26)	/* Port 5 high priority */
+#define PORT4_H_PRI				(1 << 25)	/* Port 4 high priority */
+#define PORT3_H_PRI				(1 << 24)	/* Port 3 high priority */
+#define PORT2_H_PRI				(1 << 23)	/* Port 2 high priority */
+#define PORT1_H_PRI				(1 << 22)	/* Port 1 high priority */
+#define PORT0_H_PRI				(1 << 21)	/* Port 0 high priority */
+#define EN_QOS					(1 << 20)	/* Enable QoS */
+/* Switch core misc control register field definitions
+*/
+#define DIS_P5_LOOPBACK				(1 << 30)	/* Disable port 5 loopback */
+
+#define LINK_RGMII				0		/* RGMII mode */
+#define LINK_MII_MAC				1		/* GMII/MII MAC auto mode */
+#define LINK_MII_PHY				2		/* GMII/MII PHY auto mode */
+#define LINKMODE_OFFSET				23		/* Link type offset */
+#define P5_LINK_RGMII				LINK_RGMII	/* Port 5 RGMII mode */
+#define P5_LINK_MII_MAC				LINK_MII_MAC	/* Port 5 GMII/MII MAC auto mode */
+#define P5_LINK_MII_PHY				LINK_MII_PHY	/* Port 5 GMII/MII PHY auto mode */
+#define P5_LINK_OFFSET				LINKMODE_OFFSET	/* Port 5 link type offset */
+/*#define P4_USB_SEL				  (1 << 25)	   Select port USB interface */
+#define EN_P5_LINK_PHY				(1 << 26)	/* Enable port 5 PHY provides link status to MAC */
+#define EN_P4_LINK_PHY				(1 << 25)	/* Enable port 4 PHY provides link status to MAC */
+#define EN_P3_LINK_PHY				(1 << 24)	/* Enable port 3 PHY provides link status to MAC */
+#define EN_P2_LINK_PHY				(1 << 23)	/* Enable port 2 PHY provides link status to MAC */
+#define EN_P1_LINK_PHY				(1 << 22)	/* Enable port 1 PHY provides link status to MAC */
+#define EN_P0_LINK_PHY				(1 << 21)	/* Enable port 0 PHY provides link status to MAC */
+
+/*When enabled, the authorized node are allowed in one direction ("IN" direction)
+to forward packet to the unauthorized node. Otherwise, it is not allowed.
+0= BOTH direction. (control for the packets that "SA=" or "DA=" this MAC address.)
+1= IN direction. (control for the packets that "SA=" this MAC address.)	*/
+#define EN_8021X_TOGVLAN			( DOT1X_PROCESS_GVLAN<<GVLAN_PROCESS_BITS)
+#define EN_8021X_TOCPU				( DOT1X_PROCESS_TOCPU<<GVLAN_PROCESS_BITS)
+#define EN_8021X_DROP				( DOT1X_PROCESS_DROP<<GVLAN_PROCESS_BITS)
+
+/* Test mode Tx MII-like register field definitions
+*/
+#define P0TxEN					(1<<24)	/* Enable port 0 Mii Tx signal (1 - data valid) */
+#define P1TxEN					(1<<25)	/* Enable port 1 Mii Tx signal (1 - data valid) */
+#define P2TxEN					(1<<26)	/* Enable port 2 Mii Tx signal (1 - data valid) */
+#define P0TxEN_OFFSET				(24)	/* Enable port 0 Mii Tx */
+#define P1TxEN_OFFSET				(25)	/* Enable port 1 Mii Tx */
+#define P2TxEN_OFFSET				(26)	/* Enable port 2 Mii Tx */
+#define P0TXD_OFFSET				(0)	/* Port 0 TxD [7:0] */
+#define P1TXD_OFFSET				(8)	/* Port 1 TxD [7:0] */
+#define P2TXD_OFFSET				(16)	/* Port 2 TxD [7:0] */
+
+#define P3TxEN					(1<<24)	/* Enable port 3 Mii Tx signal (1 - data valid) */
+#define P4TxEN					(1<<25)	/* Enable port 4 Mii Tx signal (1 - data valid) */
+#define P5TxEN					(1<<26)	/* Enable port 5 Mii Tx signal (1 - data valid) */
+#define P3TxEN_OFFSET				(24)	/* Enable port 3 Mii Tx */
+#define P4TxEN_OFFSET				(25)	/* Enable port 4 Mii Tx */
+#define P5TxEN_OFFSET				(26)	/* Enable port 5 Mii Tx */
+#define P3TXD_OFFSET				(0)	/* Port 3 TxD [7:0] */
+#define P4TXD_OFFSET				(8)	/* Port 4 TxD [7:0] */
+#define P5TXD_OFFSET				(16)	/* Port 5 TxD [7:0] */
+/* Test mode Rx MII-like register field definitions
+*/
+#define P0RxEN					(1<<24)	/* Enable port 0 Mii Rx signal (1 - data valid) */
+#define P1RxEN					(1<<25)	/* Enable port 1 Mii Rx signal (1 - data valid) */
+#define P2RxEN					(1<<26)	/* Enable port 2 Mii Rx signal (1 - data valid) */
+#define P0RxEN_OFFSET				(24)	/* Enable port 0 Mii Rx */
+#define P1RxEN_OFFSET				(25)	/* Enable port 1 Mii Rx */
+#define P2RxEN_OFFSET				(26)	/* Enable port 2 Mii Rx */
+#define P0RXD_OFFSET				(0)	/* Port 0 RxD [7:0] */
+#define P1RXD_OFFSET				(8)	/* Port 1 RxD [7:0] */
+#define P2RXD_OFFSET				(16)	/* Port 2 RxD [7:0] */
+
+#define P3RxEN					(1<<24)	/* Enable port 3 Mii Rx signal (1 - data valid) */
+#define P4RxEN					(1<<25)	/* Enable port 4 Mii Rx signal (1 - data valid) */
+#define P5RxEN					(1<<26)	/* Enable port 5 Mii Rx signal (1 - data valid) */
+#define P3RxEN_OFFSET				(24)	/* Enable port 3 Mii Rx */
+#define P4RxEN_OFFSET				(25)	/* Enable port 4 Mii Rx */
+#define P5RxEN_OFFSET				(26)	/* Enable port 5 Mii Rx */
+#define P3RXD_OFFSET				(0)	/* Port 3 RxD [7:0] */
+#define P4RXD_OFFSET				(8)	/* Port 4 RxD [7:0] */
+#define P5RXD_OFFSET				(16)	/* Port 5 RxD [7:0] */
+
+/* Test mode enable register
+*/
+#define TX_TEST_PORT_OFFSET			26	/* Tx test mode enable port offset */
+#define RX_TEST_PORT_OFFSET			18	/* Rx test mode enable port offset */
+#define MiiTxPktRDY_OFFSET			10	/* Status flag of MII TX packet ready to send on port */
+#define HSABUSY					(1 << 2)	/* HSA process ready flag */
+#define ENHSBTESTMODE				(1 << 1)	/* Enable HSB Test Mode */
+#define HSB_RDY					(1 << 0)	/* HSB ready */
+/* Gateway MAC low register
+*/
+#define GMACL_OFFSET				20	/* Gateway MAC[15:4] offset */
+#define GMACL_MASK				(0xFFFFFFFF << 20)	/* Gateway MAC[15:4] mask */
+
+#define SWMACCR_BASE				(SWCORE_BASE+0x4000)
+/* MAC control register field definitions */
+#define MACCR					(0x000+SWMACCR_BASE)	/* MAC Configuration Register */
+#define MDCIOCR					(0x004+SWMACCR_BASE)	/* MDC/MDIO Command */
+#define MDCIOSR					(0x008+SWMACCR_BASE)	/* MDC/MDIO Status */
+#define PMCR					(0x00C+SWMACCR_BASE)	/* Port Mirror Control Register */
+#define PPMAR					(0x010+SWMACCR_BASE)	/* Per port matching action */
+#define PATP0					(0x014+SWMACCR_BASE)	/* Pattern for port 0 */
+#define PATP1					(0x018+SWMACCR_BASE)	/* Pattern for port 1 */
+#define PATP2					(0x01C+SWMACCR_BASE)	/* Pattern for port 2 */
+#define PATP3					(0x020+SWMACCR_BASE)	/* Pattern for port 3 */
+#define PATP4					(0x024+SWMACCR_BASE)	/* Pattern for port 4 */
+#define PATP5					(0x028+SWMACCR_BASE)	/* Pattern for port 5 */
+#define MASKP0					(0x02C+SWMACCR_BASE)	/* Mask for port 0 */
+#define MASKP1					(0x030+SWMACCR_BASE)	/* Mask for port 1 */
+#define MASKP2					(0x034+SWMACCR_BASE)	/* Mask for port 2 */
+#define MASKP3					(0x038+SWMACCR_BASE)	/* Mask for port 3 */
+#define MASKP4					(0x03C+SWMACCR_BASE)	/* Mask for port 4 */
+#define MASKP5					(0x040+SWMACCR_BASE)	/* Mask for port 5 */
+#define BSCR					(0x044+SWMACCR_BASE)	/* Broadcast Storm Control Rate Configuration */
+#define CSCR					(0x048+SWMACCR_BASE)	/* Checksum Control Register */
+#define CCR					CSCR
+#define EPOCR					(0x04C+SWMACCR_BASE)	/* Embedded PHY Operation Control Register */
+#define EPIDR					(0x050+SWMACCR_BASE)	/* Embedded PHY ID Register */
+#define MACCR1					(0x058+SWMACCR_BASE)	/* MAC Configuration Register 1 */
+#define PISOCR0					(0x05C+SWMACCR_BASE)	/* Port Isolation 0 Register */
+#define PISOCR1					(0x060+SWMACCR_BASE)	/* Port Isolation 1 Register */
+#define PISOCR2					(0x064+SWMACCR_BASE)	/* Port Isolation 2 Register */
+#define MACCR2					(0x068+SWMACCR_BASE)	/* MAC Configuration Register 2 */
+
+/* MACCR2 - MAC control register 2 field definitions */
+#define RTMD_DP0_MAP_OFFSET			(20)		/* Configure dp 0 to p0 or p5 */
+#define RTMD_DP0_MAP_MASK			(3 << 20)
+#define SPA5_MAP_OFFSET				(15)		/* SPA 5 maps to real SPA */
+#define SPA5_MAP_MASK				(7 << 15)
+#define SPA4_MAP_OFFSET				(12)		/* SPA 4 maps to real SPA */
+#define SPA4_MAP_MASK				(7 << 12)
+#define SPA3_MAP_OFFSET				(9)		/* SPA 3 maps to real SPA */
+#define SPA3_MAP_MASK				(7 << 9)
+#define SPA2_MAP_OFFSET				(6)		/* SPA 2 maps to real SPA */
+#define SPA2_MAP_MASK				(7 << 6)
+#define SPA1_MAP_OFFSET				(3)		/* SPA 1 maps to real SPA */
+#define SPA1_MAP_MASK				(7 << 3)
+#define SPA0_MAP_OFFSET				(0)		/* SPA 0 maps to real SPA */
+#define SPA0_MAP_MASK				(7 << 0)
+
+/* MACCR1 - MAC control register 1 field definitions */
+#define ROUTER_MODE_TYPE_MASK			(3 << 24)
+#define ROUTER_MODE_TYPE_3			(3 << 24)	/* port5 connect to switch, and only port0,4,5 work */
+#define ROUTER_MODE_TYPE_2			(2 << 24)	/* port0 connect to switch, and only port0,4,5 work */
+#define ROUTER_MODE_TYPE_1			(1 << 24)	/* both port0 and port5 connect to switch, only port0, 4, 5 work */
+#define ROUTER_MODE_TYPE_0			(0 << 24)	/* port 0 connect to switch, and only port0 work */
+#define ROUTER_MODE_TYPE_OFFSET			(24)
+#define EN_ROUTER_MODE				(1 << 0)	/* 1: enable router mode,  0: normal mode */
+
+/* MACCR - MAC control register field definitions */
+#define NORMAL_BACKOFF				(1 << 28)	/* Normal back off slot timer */
+#define BACKOFF_EXPONENTIAL_3			(1 << 27)	/* Set back off exponential parameter 9 */
+#define DIS_BACKOFF_BIST			(1 << 26)	/* Disable back off BIST */
+#define IPG_SEL					(1 << 25)	/* Fixed IPG */
+#define INFINITE_PAUSE_FRAMES			(1 << 24)	/* Infinite pause frames */
+#define LONG_TXE				(1 << 22)	/* Back pressure, carrier based */
+#define DIS_MASK_CGST				(1 << 21)
+#define EN_48_DROP				(1 << 20)
+#define SELIPG_OFFSET				(18)	/* Define min. IPG between backpressure data */
+#define SELIPG_MASK				(0x3 << 18)	/* Define min. IPG between backpressure data */
+#define SELIPG_7				(0<<18)	/* 7, unit: byte-time */
+#define SELIPG_8				(1<<18)	/* 8, unit: byte-time */
+#define SELIPG_11				(2<<18)	/* 11, unit: byte-time */
+#define SELIPG_12				(3<<18)	/* 12, unit: byte-time */
+#define SPDUP_100				(1 << 16)	/* 10000 times speed up aging timer */
+#define CF_SYSCLK_SEL_MASK			(0x3 << 12)
+#define CF_SYSCLK_SEL_OFFSET			(12)
+#define CF_FCDSC_OFFSET				(4)	/* Flow control DSC tolerance, default: 24 pages ( also minimum value ) */
+#define CF_FCDSC_MASK				(0x7f << 4)	/* Flow control DSC tolerance, default: 24 pages ( also minimum value ) */
+#define CF_RXIPG_MASK				(0xf << 0)	/* Min. IPG limitation for RX receiving packetMinimum value is 6. Maximum value is 12. */
+
+/* MDCIOCR - MDC/MDIO Command */
+#define COMMAND_OFFSET				31	/* MDCMDIO Command */
+#define COMMAND_MASK				(1<<31)	/* 0:Read Access, 1:Write Access */
+#define COMMAND_READ				(0<<31)	/* 0:Read Access, 1:Write Access */
+#define COMMAND_WRITE				(1<<31)	/* 0:Read Access, 1:Write Access */
+#define PHYADD_OFFSET				(24)	/* PHY Address, said, PHY ID */
+#define PHYADD_MASK				(0x1f<<24)	/* PHY Address, said, PHY ID */
+#define REGADD_OFFSET				(16)	/* PHY Register */
+#define REGADD_MASK				(0x1f<<16)	/* PHY Register */
+#define WRDATA_OFFSET				(0)	/* Data to PHY register */
+#define WRDATA_MASK				(0xffff<<0)	/* Data to PHY register */
+
+/* MDCIOSR - MDC/MDIO Status */
+#define MDC_STATUS				(1<<31)	/* 0: Process Done, 1: In progress */
+#define MDCIO_STATUS				(1<<31)
+#define RDATA_OFFSET				(0)	/* Read Data Result of PHY register */
+#define RDATA_MASK				(0xffff<<0)	/* Read Data Result of PHY register */
+
+/* PMCR - Port mirror control register field definitions */
+#define MirrorPortMsk_OFFSET			18	/* Port receiving the mirrored traffic (single bit set to 1 is allowed) */
+#define MirrorPortMsk_MASK			(0x1ff<<18)	/* Port receiving the mirrored traffic (single bit set to 1 is allowed) */
+#define MirrorRxPrtMsk_OFFSET			9	/* Rx port to be mirrored (Source Mirroring, multiple ports allowed) */
+#define MirrorRxPrtMsk_MASK			(0x1ff<<9)	/* Rx port to be mirrored (Source Mirroring, multiple ports allowed) */
+#define MirrorTxPrtMsk_OFFSET			0	/* Tx port to be mirrored (Destination Mirroring, multiple ports allowed) */
+#define MirrorTxPrtMsk_MASK			(0x1ff<<0)	/* Tx port to be mirrored (Destination Mirroring, multiple ports allowed) */
+
+/* PPMAR - Per port matching action register field definitions */
+#define EnPatternMatch_OFFSET			26	/* Enable pattern match port list */
+#define EnPatternMatch_MASK			(0x3f<<26)	/* Enable pattern match port list */
+#define EnPatternMatch_P0			(1<<26)	/* Enable pattern match for port 0 */
+#define EnPatternMatch_P1			(1<<27)	/* Enable pattern match for port 1 */
+#define EnPatternMatch_P2			(1<<28)	/* Enable pattern match for port 2 */
+#define EnPatternMatch_P3			(1<<29)	/* Enable pattern match for port 3 */
+#define EnPatternMatch_P4			(1<<30)	/* Enable pattern match for port 4 */
+#define EnPatternMatch_P5			(1<<31)	/* Enable pattern match for port 5 */
+#define MatchOpRx5_OFFSET			24	/* operation if matched on port 5 */
+#define MatchOpRx5_MASK				(3<<24)	/* operation if matched on port 5 */
+#define MatchOpRx5_DROP				(0<<24)	/* Drop if matched on port 5 */
+#define MatchOpRx5_MTCPU			(1<<24)	/* Mirror to CPU if matched on port 5 */
+#define MatchOpRx5_FTCPU			(2<<24)	/* Forward to CPU if matched on port 5 */
+#define MatchOpRx5_MTMP				(3<<24)	/* Mirror to Mirror Port if matched on port 5 */
+#define MatchOpRx4_OFFSET			22	/* operation if matched on port 4 */
+#define MatchOpRx4_MASK				(3<<22)	/* operation if matched on port 4 */
+#define MatchOpRx4_DROP				(0<<22)	/* Drop if matched on port 4 */
+#define MatchOpRx4_MTCPU			(1<<22)	/* Mirror to CPU if matched on port 4 */
+#define MatchOpRx4_FTCPU			(2<<22)	/* Forward to CPU if matched on port 4 */
+#define MatchOpRx4_MTMP				(3<<22)	/* Mirror to Mirror Port if matched on port 4 */
+#define MatchOpRx3_OFFSET			20	/* operation if matched on port 3 */
+#define MatchOpRx3_MASK				(3<<20)	/* operation if matched on port 3 */
+#define MatchOpRx3_DROP				(0<<20)	/* Drop if matched on port 3 */
+#define MatchOpRx3_MTCPU			(1<<20)	/* Mirror to CPU if matched on port 3 */
+#define MatchOpRx3_FTCPU			(2<<20)	/* Forward to CPU if matched on port 3 */
+#define MatchOpRx3_MTMP				(3<<20)	/* Mirror to Mirror Port if matched on port 3 */
+#define MatchOpRx2_OFFSET			18	/* operation if matched on port 2 */
+#define MatchOpRx2_MASK				(3<<18)	/* operation if matched on port 2 */
+#define MatchOpRx2_DROP				(0<<18)	/* Drop if matched on port 2 */
+#define MatchOpRx2_MTCPU			(1<<18)	/* Mirror to CPU if matched on port 25 */
+#define MatchOpRx2_FTCPU			(2<<18)	/* Forward to CPU if matched on port 2 */
+#define MatchOpRx2_MTMP				(3<<18)	/* Mirror to Mirror Port if matched on port 2 */
+#define MatchOpRx1_OFFSET			16	/* operation if matched on port 1 */
+#define MatchOpRx1_MASK				(3<<16)	/* operation if matched on port 1 */
+#define MatchOpRx1_DROP				(0<<16)	/* Drop if matched on port 1 */
+#define MatchOpRx1_MTCPU			(1<<16)	/* Mirror to CPU if matched on port 1 */
+#define MatchOpRx1_FTCPU			(2<<16)	/* Forward to CPU if matched on port 1 */
+#define MatchOpRx1_MTMP				(3<<16)	/* Mirror to Mirror Port if matched on port 1 */
+#define MatchOpRx0_OFFSET			14	/* operation if matched on port 0 */
+#define MatchOpRx0_MASK				(3<<14)	/* operation if matched on port 0 */
+#define MatchOpRx0_DROP				(0<<14)	/* Drop if matched on port 0 */
+#define MatchOpRx0_MTCPU			(1<<14)	/* Mirror to CPU if matched on port 0 */
+#define MatchOpRx0_FTCPU			(2<<14)	/* Forward to CPU if matched on port 0 */
+#define MatchOpRx0_MTMP				(3<<14)	/* Mirror to Mirror Port if matched on port 0 */
+
+/* CSCR, CCR - Checksum Control Register */
+#define EnL4ChkCal				(1<<5)	/* Enable L4 Checksum Re-calculation */
+#define EnL3ChkCal				(1<<4)	/* Enable L3 Checksum Re-calculation */
+#define AcceptL2Err				(1<<3)	/* CPU port L2 CRC Error Allow; 0: Not Allowed, 1: Allowed (default) */
+#define L4ChkSErrAllow				(1<<2)	/* L4 Checksum Error Allow */
+#define L3ChkSErrAllow				(1<<1)	/* L3 Checksum Error Allow */
+#define L2CRCErrAllow				(1<<0)	/* L2 CRC Error Allow */
+#define EN_ETHER_L4_CHKSUM_REC			EnL4ChkCal
+#define EN_ETHER_L3_CHKSUM_REC			EnL3ChkCal
+#define ALLOW_L4_CHKSUM_ERR			L4ChkSErrAllow
+#define ALLOW_L3_CHKSUM_ERR			L3ChkSErrAllow
+#define ALLOW_L2_CHKSUM_ERR			L2CRCErrAllow
+
+/* EPOCR, EPIDR - Embedded PHY Operation Control Register */
+#define Port_embPhyID_MASK(port)		( 0x1f << ( port * 5 ) )	/* Embedded PHY ID MASK of port 'idx' */
+#define Port_embPhyID(id, port)			( id << ( port * 5 ) )	/* Embedded PHY ID setting of port 'idx' */
+
+#define PCRAM_BASE				(SWCORE_BASE+0x4100)
+#define PITCR					(0x000 + PCRAM_BASE)	/* Port Interface Type Control Register */
+#define PCRP0					(0x004 + PCRAM_BASE)	/* Port Configuration Register of Port 0 */
+#define PCRP1					(0x008 + PCRAM_BASE)	/* Port Configuration Register of Port 1 */
+#define PCRP2					(0x00C + PCRAM_BASE)	/* Port Configuration Register of Port 2 */
+#define PCRP3					(0x010 + PCRAM_BASE)	/* Port Configuration Register of Port 3 */
+#define PCRP4					(0x014 + PCRAM_BASE)	/* Port Configuration Register of Port 4 */
+#define PCRP5					(0x018 + PCRAM_BASE)	/* Port Configuration Register of Port 5 */
+#define PCRP6					(0x01C + PCRAM_BASE)	/* Port Configuration Register of Ext Port 0 */
+#define PCRP7					(0x020 + PCRAM_BASE)	/* Port Configuration Register of Ext Port 1 */
+#define PCRP8					(0x024 + PCRAM_BASE)	/* Port Configuration Register of Ext Port 2 */
+#define PSRP0					(0x028 + PCRAM_BASE)	/* Port Status Register Port 0 */
+#define PSRP1					(0x02C + PCRAM_BASE)	/* Port Status Register Port 1 */
+#define PSRP2					(0x030 + PCRAM_BASE)	/* Port Status Register Port 2 */
+#define PSRP3					(0x034 + PCRAM_BASE)	/* Port Status Register Port 3 */
+#define PSRP4					(0x038 + PCRAM_BASE)	/* Port Status Register Port 4 */
+#define PSRP5					(0x03C + PCRAM_BASE)	/* Port Status Register Port 5 */
+#define PSRP6					(0x040 + PCRAM_BASE)	/* Port Status Register Port 6 */
+#define PSRP7					(0x044 + PCRAM_BASE)	/* Port Status Register Port 7 */
+#define PSRP8					(0x048 + PCRAM_BASE)	/* Port Status Register Port 8 */
+#define P0GMIICR				(0x04C + PCRAM_BASE)	/* Port-0 GMII Configuration Register */
+#define P5GMIICR				(0x050 + PCRAM_BASE)	/* Port-5 GMII Configuration Register */
+
+/* PITCR - Port Interface Type Control Register	 */
+#define Port5_TypeCfg_GMII_MII_RGMII		(0<<10)
+#define Port4_TypeCfg_UTP			(0<< 8)
+#define Port4_TypeCfg_SerDes			(1<< 8)
+#define Port3_TypeCfg_UTP			(0<< 6)
+#define Port3_TypeCfg_SerDes			(1<< 6)
+#define Port2_TypeCfg_UTP			(0<< 4)
+#define Port2_TypeCfg_SerDes			(1<< 4)
+#define Port1_TypeCfg_UTP			(0<< 2)
+#define Port1_TypeCfg_SerDes			(1<< 2)
+#define Port0_TypeCfg_UTP			(0<< 0)
+#define Port0_TypeCfg_GMII_MII_RGMII		(1<< 0)
+
+#define GIGA_P5_PHYID				0x16
+/* 0xBB804104 ~ 0xBB804124 */
+/* PCRP0,PCRP1,PCRP2,PCRP3,PCRP4,PCRP5,PCRP6,PCRP7,PCRP8 - Port Configuration Register */
+#define BYPASS_TCRC				(1 << 31)	/* Not recalculate CRC error */
+#define ExtPHYID_OFFSET				(26)	/* External PHY ID */
+#define ExtPHYID_MASK				(0x1f<<26)	/* External PHY ID */
+#define EnForceMode				(1<<25)	/* Enable Force Mode to set link/speed/duplix/flow status */
+
+	/*      EnForceMode=0,  PollLinkStatus: do not care
+	 * EnForceMode=1, PollLinkStatus=0 : ForceMode , disable Auto-Negotiation.       It's noted that The mode should be setting for MAC-to-MAC connection.
+	 * PollLinkStatus=1:  ForceMode with polling link status, disable Auto-Negotiation but polling phy's link status.
+	 */
+#define PollLinkStatus				(1<<24)
+#define ForceLink				(1<<23)	/* 0-link down, 1-link up */
+
+	/*      FrcAbi_AnAbi_sel[4:0]: bit 22 ~ 18
+	 * If EnForceMode = 1, FrcAbi_AnAbi_sel is used to indicate the force mode operation. (For either MAC mode or PHY mode operation.)
+	 * FrcAbi_AnAbi_sel[0] = ForceDuplex1: force FULL duplex ,       0: force HALF duplex
+	 * FrcAbi_AnAbi_sel[2:1] = ForceSpeed00: force 10Mbps    01: force 100Mbps      ( default setting for port#5 NFBI-PHY-mode spec. )
+	 * 10: force 1000Mbps 11: reserved.
+	 * FrcAbi_AnAbi_sel[4:3] = Reserved, useless.
+	 * If EnForceMode = 0, FrcAbi_AnAbi_sel is used to indicate Auto-Negotiation advertise ability.
+	 * FrcAbi_AnAbi_sel[0]: 10Mbps Half-duplexFrcAbi_AnAbi_sel[1]: 10Mbps Full-duplexFrcAbi_AnAbi_sel[2]: 100Mbps Half-duplex
+	 * FrcAbi_AnAbi_sel[3]: 100Mbps Full-duplexFrcAbi_AnAbi_sel[4]: 1000Mbps Full-duplex
+	 */
+
+//Note: 96C/98 have remove these bits !!!
+#define IPMSTP_PortST_MASK			(3<<21)	/* Mask of IP Multicast Spanning Tree Protocol Port State Control */
+#define IPMSTP_PortST_OFFSET			(21)	/* Offset of IP Multicast Spanning Tree Protocol Port State Control */
+#define IPMSTP_PortST_DISABLE			(0<<21)	/* Disable State of IP Multicast Spanning Tree Protocol Port State Control */
+#define IPMSTP_PortST_BLOCKING			(1<<21)	/* Blocking State of IP Multicast Spanning Tree Protocol Port State Control */
+#define IPMSTP_PortST_LISTENING			(1<<21)	/* Listening State of IP Multicast Spanning Tree Protocol Port State Control */
+#define IPMSTP_PortST_LEARNING			(2<<21)	/* Learning State of IP Multicast Spanning Tree Protocol Port State Control */
+#define IPMSTP_PortST_FORWARDING		(3<<21)	/* Forwarding State of IP Multicast Spanning Tree Protocol Port State Control */
+
+#define ForceSpeedMask				(3<<19)	/* Force speed Mask */
+#define ForceSpeed10M				(0<<19)	/* Force speed 10M */
+#define ForceSpeed100M				(1<<19)	/* Force speed 100M */
+#define ForceSpeed1000M				(2<<19)	/* Force speed 1G */
+#define ForceDuplex				(1<<18)	/* Force Duplex */
+#define AutoNegoSts_OFFSET			(18)
+#define AutoNegoSts_MASK			(0x1f<<18)
+
+#define NwayAbility1000MF			(1<<22)	/* Auto-Negotiation advertise ability: 1000Mbps Full-duplex */
+#define NwayAbility100MF			(1<<21)	/* Auto-Negotiation advertise ability: 100Mbps Full-duplex */
+#define NwayAbility100MH			(1<<20)	/* Auto-Negotiation advertise ability: 100Mbps Half-duplex */
+#define NwayAbility10MF				(1<<19)	/* Auto-Negotiation advertise ability: 10Mbps Full-duplex */
+#define NwayAbility10MH				(1<<18)	/* Auto-Negotiation advertise ability: 10Mbps Half-duplex */
+
+/* bit 16, 17
+  if EnForceMode = 1, PAUSE flow control ability Control .
+	[0]= enable TX pause ability
+	[1]= enable RX pause ability
+  if EnForceMode =0, PHY advertise pause operation ability :
+	[0]= PAUSE operation for full duplex links
+	[1]= Asymmetric PAUSE operation for full duplex links
+ */
+#define PauseFlowControl_MASK			(3<<16)	/* Mask for per-port 802.3 PAUSE flow control ability control */
+#define PauseFlowControlNway			(0<<16)	/* Follow the PHY N-way result */
+#define PauseFlowControlEtxDrx			(1<<16)	/* force: enable TX, disable RX */
+#define PauseFlowControlDtxErx			(2<<16)	/* force: disable TX, enable RX */
+#define PauseFlowControlEtxErx			(3<<16)	/* force: enable TX, enable RX */
+
+#define MIIcfg_CRS				(1<<15)	/* MII interface Parameter setup */
+#define MIIcfg_COL				(1<<14)	/* MII interface Parameter setup */
+#define MIIcfg_RXER				(1<<13)	/* MII interface Parameter setup */
+#define GMIIcfg_CRS				(1<<12)	/* GMII interface Parameter setup */
+#define BCSC_Types_MASK				(7<<9)	/* Broadcast Storm Control packet type selection */
+//#define BCSC_ENUNKNOWNUNICAST			(1<<11)	/* Enable control for unknown unicast packet */
+#define BCSC_ENMULTICAST			(1<<10)	/* Enable control for multicast packet */
+#define BCSC_ENBROADCAST			(1<<9)	/* Enable control for broadcast packet */
+#define ENBCSC					(1<<8)	/* Enable broadcast storm control */
+#define EnLoopBack				(1<<7)	/* Enable MAC-PHY interface Mii Loopback */
+#define DisBKP					(1<<6)	/* Per-port Disable Backpressure function for Half duplex */
+#define STP_PortST_MASK				(3<<4)	/* Mask Spanning Tree Protocol Port State Control */
+#define STP_PortST_OFFSET			(4)	/* Offset */
+#define STP_PortST_DISABLE			(0<<4)	/* Disable State */
+#define STP_PortST_BLOCKING			(1<<4)	/* Blocking State */
+#define STP_PortST_LISTENING			(1<<4)	/* Listening State */
+#define STP_PortST_LEARNING			(2<<4)	/* Learning State */
+#define STP_PortST_FORWARDING			(3<<4)	/* Forwarding State */
+#define MacSwReset				(1<<3)	/* 0: reset state, 1: normal state */
+#define AcptMaxLen_OFFSET			(1)	/* Enable the max acceptable packet length supported */
+#define AcptMaxLen_MASK				(3<<1)	/* Enable the max acceptable packet length supported */
+#define AcptMaxLen_1536				(0<<1)	/* 1536 Bytes (RTL865xB) */
+#define AcptMaxLen_1552				(1<<1)	/* 1552 Bytes (RTL865xB) */
+#define AcptMaxLen_9K				(2<<1)	/* 9K(9216) Bytes */
+#define AcptMaxLen_16K				(3<<1)	/* 16370 bytes = 16K-2(cutoff)-4(vlan)-8(pppoe) */
+#define EnablePHYIf				(1<<0)	/* Enable PHY interface. */
+
+/* 0xBB804150 P5GMIICR */
+#define Conf_done				(1<<6)	/*Port5 configuration is done to enable the frame reception and transmission.   */
+#define P5txdely				(1<<4)	/*Port5 TX clock delay. */
+
+/* 0xBB804008 */
+/* MDCIOSR - MDC/MDIO Status */
+#define MDCIOSR_ReadError			(1<<30)	/* read only: MII management frame reading error */
+
+/* 0xBB804008 */
+/* GDSR0 - Global Descriptor Status Register 0 */
+#define HSA_OverRun				(1<<28)	/* HSA fifo is overflow */
+
+/* PSRP0,PSRP1,PSRP2,PSRP3,PSRP4,PSRP5,PSRP6,PSRP7,PSRP8 - Port Status Register Port 0~8 */
+#define PortEEEStatus_MASK			(3<<12)
+#define PortEEEStatus_OFFSET			12
+#define LinkDownEventFlag			(1<<8)	/* Port Link Down Event detecting monitor flag */
+#define PortStatusNWayEnable			(1<<7)	/* N-Way Enable */
+#define PortStatusRXPAUSE			(1<<6)	/* Rx PAUSE */
+#define PortStatusTXPAUSE			(1<<5)	/* Tx PAUSE */
+#define PortStatusLinkUp			(1<<4)	/* Link Up */
+#define PortStatusDuplex			(1<<3)	/* Duplex */
+#define PortStatusLinkSpeed_MASK		(3<<0)	/* Link Speed */
+#define PortStatusLinkSpeed_OFFSET		0
+#define PortStatusLinkSpeed10M			(0<<0)	/* 10M */
+#define PortStatusLinkSpeed100M			(1<<0)	/* 100M */
+#define PortStatusLinkSpeed1000M		(2<<0)	/* 1000M */
+#define PortStatusLinkSpeedReserved		(3<<0)	/* Reserved Speed */
+
+/* P0GMIICR Port-0 / Port-5 GMII Configuration Register */
+#define CFG_TX_CPUC_TAG				(1<<26)	/* Enable Tx CPU tag */
+#define CFG_CPUC_TAG				(1<<25)	/* Enable CPU tag */
+#define CFG_GMAC_MASK				(3<<23)	/* The register default reflect the HW power on strapping value of H/W pin. */
+#define CFG_GMAC_RGMII				(0<<23)	/* RGMII mode */
+#define CFG_GMAC_GMII_MII_MAC			(1<<23)	/* GMII/MII MAC mode */
+#define CFG_GMAC_GMII_MII_PHY			(2<<23)	/* GMII/MII PHY mode */
+#define CFG_GMAC_Reserved			(3<<23)	/* Reserved */
+#define CF_SEL_RGTXC_OFFSET			18
+#define CF_SEL_RGTXC_MASK			(3<<CF_SEL_RGTXC_OFFSET)
+
+#define RGMII_RCOMP_MASK			(3<<0)	/* RGMII Input Timing compensation control */
+#define RGMII_RCOMP_0NS				(0<<0)	/* Rcomp 0.0 ns */
+#define RGMII_RCOMP_1DOT5NS			(1<<0)	/* Rcomp 1.5 ns */
+#define RGMII_RCOMP_2NS				(2<<0)	/* Rcomp 2.0 ns */
+#define RGMII_RCOMP_2DOT5NS			(3<<0)	/* Rcomp 3.0 ns */
+#define RGMII_TCOMP_MASK			(7<<2)	/* RGMII Output Timing compensation control */
+#define RGMII_TCOMP_0NS				(0<<2)	/* Tcomp 0.0 ns */
+#define RGMII_TCOMP_1DOT5NS			(1<<2)	/* Tcomp 1.5 ns */
+#define RGMII_TCOMP_2NS				(2<<2)	/* Tcomp 2.0 ns */
+#define RGMII_TCOMP_2DOT5NS			(3<<2)	/* Tcomp 2.5 ns */
+#define RGMII_TCOMP_3NS				(4<<2)	/* Tcomp 3.0 ns */
+#define RGMII_TCOMP_4NS				(5<<2)	/* Tcomp 4.0 ns */
+#define RGMII_TCOMP_6NS				(6<<2)	/* Tcomp 6.0 ns */
+#define RGMII_TCOMP_7NS				(7<<2)	/* Tcomp 7.0 ns */
+
+#define EEECR					(0x60+PCRAM_BASE)	/* EEE ability Control Register ( 0xBB80_4160 ) */
+#define EEEABICR1				(0x64+PCRAM_BASE)	/* EEE ability Control Register 1 */
+
+/* EEE ability Control Register ( 0xBB80_4160 ) */
+#define EN_P5_FRC_EEE				(1 << 29)	/* Enable Port 5 EEE force mode */
+#define FRC_P5_EEE_Giga				(1 << 28)	/* Force Port 5 EEE ability for 1000BASE-T. */
+#define FRC_P5_EEE_100				(1 << 27)	/* Force Port 5 EEE ability for 100BASE-TX. */
+#define EN_P5_TX_EEE				(1 << 26)	/* Enable Port 5 MAC TX EEE ability */
+#define EN_P5_RX_EEE				(1 << 25)	/* Enable Port 5 MAC RX EEE ability      */
+#define EN_P4_FRC_EEE				(1 << 24)	/* Enable Port 4 EEE force mode */
+#define FRC_P4_EEE_Giga				(1 << 23)	/* Force Port 4 EEE ability for 1000BASE-T. */
+#define FRC_P4_EEE_100				(1 << 22)	/* Force Port 4 EEE ability for 100BASE-TX. */
+#define EN_P4_TX_EEE				(1 << 21)	/* Enable Port 4 MAC TX EEE ability */
+#define EN_P4_RX_EEE				(1 << 20)	/* Enable Port 4 MAC RX EEE ability      */
+#define EN_P3_FRC_EEE				(1 << 19)	/* Enable Port 3 EEE force mode */
+#define FRC_P3_EEE_Giga				(1 << 18)	/* Force Port 3 EEE ability for 1000BASE-T. */
+#define FRC_P3_EEE_100				(1 << 17)	/* Force Port 3 EEE ability for 100BASE-TX. */
+#define EN_P3_TX_EEE				(1 << 16)	/* Enable Port 3 MAC TX EEE ability */
+#define EN_P3_RX_EEE				(1 << 15)	/* Enable Port 3 MAC RX EEE ability      */
+#define EN_P2_FRC_EEE				(1 << 14)	/* Enable Port 2 EEE force mode */
+#define FRC_P2_EEE_Giga				(1 << 13)	/* Force Port 2 EEE ability for 1000BASE-T */
+#define FRC_P2_EEE_100				(1 << 12)	/* Force Port 2 EEE ability for 100BASE-TX. */
+#define EN_P2_TX_EEE				(1 << 11)	/* Enable Port 2 MAC TX EEE ability */
+#define EN_P2_RX_EEE				(1 << 10)	/* Enable Port 2 MAC RX EEE ability      */
+#define EN_P1_FRC_EEE				(1 << 9)	/* Enable Port 1 EEE force mode */
+#define FRC_P1_EEE_Giga				(1 << 8)	/* Force Port 1 EEE ability for 1000BASE-T. */
+#define FRC_P1_EEE_100				(1 << 7)	/* Force Port 1 EEE ability for 100BASE-TX. */
+#define EN_P1_TX_EEE				(1 << 6)	/* Enable Port 1 MAC TX EEE ability */
+#define EN_P1_RX_EEE				(1 << 5)	/* Enable Port 1 MAC RX EEE ability      */
+#define EN_P0_FRC_EEE				(1 << 4)	/* Enable Port 0 EEE force mode */
+#define FRC_P0_EEE_Giga				(1 << 3)	/* Force Port 0 EEE ability for 1000BASE-T. */
+#define FRC_P0_EEE_100				(1 << 2)	/* Force Port 0 EEE ability for 100BASE-TX. */
+#define EN_P0_TX_EEE				(1 << 1)	/* Enable Port 0 MAC TX EEE ability */
+#define EN_P0_RX_EEE				(1 << 0)	/* Enable Port 0 MAC RX EEE ability */
+
+#define SWMISC_BASE				(0x4200+SWCORE_BASE)
+/* Chip Version ID Register */
+#define CVIDR					(0x00+SWMISC_BASE)	/* Chip Version ID Register */
+#define SSIR					(0x04+SWMISC_BASE)	/* System Initial and Reset Registe */
+#define SIRR					(SSIR)	/* Alias Name */
+#define CRMR					(0x08+SWMISC_BASE)	/* Chip Revision Management Register */
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#define BISTCR					(0x0C+SWMISC_BASE)	/* BIST control */
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+#define MEMCR					(0x34+SWMISC_BASE)	/* MEM CTRL Register */
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define BISTTSDR0				(0x18+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 0 */
+#define BISTTSDR1				(0x1C+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 1 */
+#define BISTTSDR2				(0x20+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 2 */
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#define BISTTSDR0				(0x40+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 0 */
+#define BISTTSDR1				(0x44+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 1 */
+#define BISTTSDR2				(0x48+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 2 */
+#define BISTTSDR3				(0x4C+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 3 */
+#define BISTTSDR4				(0x50+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 4 */
+#define BISTTSDR5				(0x54+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 5 */
+#define BISTTSDR6				(0x58+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 6 */
+#define BISTTSDR7				(0x5C+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 7 */
+#define BISTTSDR8				(0x60+SWMISC_BASE)	/* BIST Test Status Diagnostic Register 8 */
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+/*	SIRR, SSIR - System Initial and Reset Register*/
+#define SwitchFullRst				(1 << 2)	/* Reset all tables & queues */
+#define SwitchSemiRst				(1 << 1)	/* Reset queues */
+#define TRXRDY					(1 << 0)	/* Start normal TX and RX */
+#define FULL_RST				SwitchFullRst	/* Alias Name */
+#define SEMI_RST				SwitchSemiRst	/* Alias Name */
+
+/* BISTCR - BIST control register field definitions */
+#define DisBIST					(1<<31)	/* (RO)1 if Disable all SRAM BIST. By default, all SRAM BIST are invoked after power-on reset completes. */
+#define dis_skip_fp				(1<<30)	/* Disable skipping fail pages. Only column repairs of the packet buffer take effect. */
+#define diag_mode				(1<<29)	/* Enter the diagnosis mode for the SRAM of packet buffer */
+#define diag_done				(1<<28)	/* The diagnosis mode for the packet buffer allows the user to perform diagnosis of the memory defects. */
+#define lat_fail_info				(1<<27)	/* Latch failure information for a specific testing condition. */
+#define bisting_MASK				(0x000007ff)	/* bisting[10]=NICTXRAM BIST ongoingbisting
+										 * [9]=NICRXRAM BIST ongoingbisting
+										 * [8]=V4KRAM BIST ongoingbisting
+										 * [7]=PBRAM BIST ongoingbisting
+										 * [6]=OQRAM BIST ongoingbisting
+										 * [5]=MIBRAM BIST ongoingbisting
+										 * [4]=L2/L4RAM BIST ongoingbisting
+										 * [3]=IQRAM BIST ongoingbisting
+										 * [2]=HTRAM BIST ongoingbisting
+										 * [1]=HSARAM BIST ongoingbisting
+										 * [0]=ACL/AMI/RLMRAM BIST ongoing */
+#define bisting_OFFSET				0
+#define BIST_READY_MASK				bisting_MASK	/* Alias Name */
+#define BIST_READY_PATTERN			0x00000000
+
+/* BISTTSDR0 - IST Test Status Diagnostic Register 0 */
+#define BISTTSDR0_READY_MASK			0x03ffffff
+#define BISTTSDR0_READY_PATTERN			0x00000000
+
+/* Chip version ID register field definitions */
+#define RTL8650_CVID				0x86500000
+
+/* Miscellaneous control registers */
+#define LEDCREG					(SWCORE_BASE + 0x4300)	/* LED control */
+#define LEDCR0					(LEDCREG+0x00)
+#define LEDCR					LEDCR0
+#define LEDCR1					(LEDCREG+0x04)
+#define LEDBCR					(LEDCREG+0x0C)
+#define DIRECTLCR				(LEDCREG+0x14)
+
+/* LED control register field definitions
+*/
+#define LED_P0_SPEED				(1 << 0)	/* LED port 0 collision */
+#define LED_P0_ACT				(1 << 1)	/* LED port 0 active */
+#define LED_P0_COL				(1 << 2)	/* LED port 0 speed 100M */
+#define LED_P1_SPEED				(1 << 3)	/* LED port 1 collision */
+#define LED_P1_ACT				(1 << 4)	/* LED port 1 active */
+#define LED_P1_COL				(1 << 5)	/* LED port 1 speed 100M */
+#define LED_P2_SPEED				(1 << 6)	/* LED port 2 collision */
+#define LED_P2_ACT				(1 << 7)	/* LED port 2 active */
+#define LED_P2_COL				(1 << 8)	/* LED port 2 speed 100M */
+#define LED_P3_SPEED				(1 << 9)	/* LED port 3 collision */
+#define LED_P3_ACT				(1 << 10)	/* LED port 3 active */
+#define LED_P3_COL				(1 << 11)	/* LED port 3 speed 100M */
+#define LED_P4_SPEED				(1 << 12)	/* LED port 4 collision */
+#define LED_P4_ACT				(1 << 13)	/* LED port 4 active */
+#define LED_P4_COL				(1 << 14)	/* LED port 4 speed 100M */
+#define LED_P5_SPEED				(1 << 15)	/* LED port 5 collision */
+#define LED_P5_ACT				(1 << 16)	/* LED port 5 active */
+#define LED_P5_COL				(1 << 17)	/* LED port 5 speed 100M */
+#define EN_LED_CPU_CTRL				(1 << 18)	/* Enable CPU control LED */
+
+/* LEDCR0 - LED Control Register 0 */
+#define LEDTOPOLOGY_OFFSET			20
+#define LEDTOPOLOGY_MASK			(3<<20)	/* LED topology selection: To select the Scan mode or Matrix mode of LED topology. */
+							/* 00: Scan mode Topology, 01: Matrix mode Topology, 10 : Direct mode Topology, 11 : Combine mode Topology */
+#define LEDMODE_SCAN				(0<<20)
+#define LEDMODE_MATRIX				(1<<20)
+#define LEDMODE_DIRECT				(2<<20)
+#define LEDMODE_COMBINE				(3<<20)
+
+/* DIRECTLCR - DIRECT mode LED Configuration Register */
+#define LEDONSCALEP0_OFFSET			16
+#define LEDONSCALEP0_MASK			(7<<16)	/* Select the LED turn on scale for port0. */
+
+/**********************************************************************/
+#define ALE_BASE				(0x4400+SWCORE_BASE)
+#define TEACR					(0x00+ALE_BASE)	/* Table Entry Aging Control Register */
+#define TEATCR					(0x04+ALE_BASE)	/* Table entry aging time control */
+#define RMACR					(0x08+ALE_BASE)	/* Reserved Multicast Address Address Mapping */
+#define ALECR					(0x0C+ALE_BASE)	/* ALE Control Register */
+#define MSCR					(0x10+ALE_BASE)	/* Module Switch Control Register */
+#define TTLCR					(0x0C+ALE_BASE)	/* TTL control */
+#define L4TOCR					(0x14+ALE_BASE)	/* L4 Table Offset control */
+#define SWTCR0					(0x18+ALE_BASE)	/* swtich table control register 0 */
+#define SWTCR1					(0x1C+ALE_BASE)	/* swtich table control register 1 */
+#define PLITIMR					(0x20+ALE_BASE)	/* Port to LAN Interface Table Index Mapping Register */
+#define DACLRCR					(0x24+ALE_BASE)	/* default ACL rule control register */
+#define FFCR					(0x28+ALE_BASE)	/*Frame Forwarding Configuratoin Register */
+#define MGFCR_E0R0				(0x2C+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_0 R0 */
+#define MGFCR_E0R1				(0x30+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_1 R1 */
+#define MGFCR_E0R2				(0x34+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_2 R2 */
+#define MGFCR_E1R0				(0x38+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_0 R0 */
+#define MGFCR_E1R1				(0x3C+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_1 R1 */
+#define MGFCR_E1R2				(0x40+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_2 R2 */
+#define MGFCR_E2R0				(0x44+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_0 R0 */
+#define MGFCR_E2R1				(0x48+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_1 R1 */
+#define MGFCR_E2R2				(0x4C+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_2 R2 */
+#define MGFCR_E3R0				(0x50+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_0 R0 */
+#define MGFCR_E3R1				(0x54+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_1 R1 */
+#define MGFCR_E3R2				(0x58+ALE_BASE)	/*L2 MAC Group Forwarding Control Register Entry_2 R2 */
+#define OCR						L4TOCR	/* Alias Name */
+#define IPMCMCR0				(0x5C+ALE_BASE)	/*IPM Clone Mac Configuration register 0 */
+#define IPMCMCR1				(0x60+ALE_BASE)	/*IPM Clone Mac Configuration register 1 */
+#define V4VLDSCPCR0				(0x64+ALE_BASE)	/* V4 VLAN and DSCP remarking control register for Port 0 */
+#define V4VLDSCPCR1				(0x68+ALE_BASE)	/* V4 VLAN and DSCP remarking control register for Port 1 */
+#define V4VLDSCPCR2				(0x6C+ALE_BASE)	/* V4 VLAN and DSCP remarking control register for Port 2 */
+#define V4VLDSCPCR3				(0x70+ALE_BASE)	/* V4 VLAN and DSCP remarking control register for Port 3 */
+#define V4VLDSCPCR4				(0x74+ALE_BASE)	/* V4 VLAN and DSCP remarking control register for Port 4 */
+#define V4VLDSCPCR5				(0x78+ALE_BASE)	/* V4 VLAN and DSCP remarking control register for Port 5 */
+#define V4VLDSCPCR6				(0x7C+ALE_BASE)	/* V4 VLAN and DSCP remarking control register for Port 6 */
+#define V4VLDSCPCR7				(0x80+ALE_BASE)	/* V4 VLAN and DSCP remarking control register for Port 7 */
+#define V4VLDSCPCR8				(0x84+ALE_BASE)	/* V4 VLAN and DSCP remarking control register for Port 8 */
+
+/* TEACR - Table Entry Aging Control Register */
+#define IPv6McastAgingDisable			(1<<9)	/* 0=Enable IPv6 Multicast table aging. 1=disable */
+#define EnRateLimitTbAging			(1<<6)	/* Enable Rate Limit table hardware aging function. */
+#define EnL2FastAging				(1<<5)	/* Enable L2 Fast Aging Out */
+#define EnL2HashColOW				(1<<4)	/* Enable L2 Tablsh Hash Collision Over Write */
+#define IPMcastAgingDisable			(1<<3)	/* 0=Enable IP Multicast table aging. 1=disable */
+#define PPPoEAgingDisable			(1<<2)	/* 0=Enable PPPoE Table Aging. 1=disable */
+#define L4AgingDisable				(1<<1)	/* 0=Enable L4 Aging. 1=disable */
+#define L2AgingDisable				(1<<0)	/* 0=Enable L2 Aging. 1=disable */
+
+/* TEATCR - Table entry aging time control */
+#define ICMPT_OFFSET				24		/* ICMP Timeout */
+#define ICMPT_MASK				(0x3f<<24)	/* ICMP TImeout */
+#define UDPT_OFFSET				18		/* UDP Timeout */
+#define UDPT_MASK				(0x3f<<18)	/* UDP Timeout */
+#define TCPLT_OFFSET				12		/* TCP Long Timeout */
+#define TCPLT_MASK				(0x3f<<12)	/* TCP Long Timeout */
+#define TCPMT_OFFSET				6		/* TCP Medium Timeout */
+#define TCPMT_MASK				(0x3f<<6)	/* TCP Medium Timeout */
+#define TCPST_OFFSET				0		/* TCP Short Timeout */
+#define TCPST_MASK				(0x3f<<0)	/* TCP Short Timeout */
+
+/* RMACR - Reserved Multicast Address Address Mapping (01-80-c2-00-00-xx) */
+#define MADDR20_2F				(1<< 8)	/* GARP Reserved Address */
+#define MADDR00_10				(1<< 7)	/* 802.1d Reservedd Address */
+#define MADDR21					(1<< 6)	/* GVRP Address */
+#define MADDR20					(1<< 5)	/* GMRP Address */
+#define MADDR10					(1<< 4)	/* All LANs Bridge Management Group Address */
+#define MADDR0E					(1<< 3)	/* IEEE Std. 802.1AB Link Layer Discovery protocol multicast address */
+#define MADDR03					(1<< 2)	/* IEEE Std 802.1X PAE address */
+#define MADDR02					(1<< 1)	/* IEEE Std 802.3ad Slow Protocols-Multicast address */
+#define MADDR00					(1<< 0)	/* BPDU (Bridge Group Address) */
+
+/* ALECR */
+#define EN_PPPOE				(1<<18)	/* Enable PPPoE auto-encapsulation and auto-decapsulation */
+#define TTL_1Enable				(1<<16)	/* Enable TTL-1 operation for L3 routing */
+#define Fragment2CPU				(1<<15)	/*      When ACL is enabled, enable all fragmented IP packet to be trapped to CPU (because L4 is needed)
+							 * When ACL is disabled, if this bit is set, L2 forwarding as before, L3 above operation will trapped to CPU.
+							 * When ACL is disabled, if this bit is not set, IP fragment packet will be forwarded as normal via L3 routing or NAT. */
+#define FRAG2CPU				Fragment2CPU
+#define MultiCastMTU_OFFSET			(0)
+#define MultiCastMTU_MASK			(0x3fff)
+#define MULTICAST_L2_MTU_MASK			MultiCastMTU_MASK	/* Alias Name */
+#define EN_TTL1					TTL_1Enable		/* Alias Name */
+
+/* MSCR - Module Switch Control Register */
+#define DisChk_CFI				(1<< 9)	/* Disable Check CFI bit for L2 random packet testing purpose. */
+#define EnRRCP2CPU				(1<< 7)	/* Enable trap RRCP packet to CPU port for L2 testing purpose. RRCP: Realtek Remote Control Protocol (Proprietary) */
+#define NATTM					(1<< 6)	/* 0: Normal mode processing, 1: NAT Test Mode */
+#define Enable_ST				(1<< 5)	/* Enable Spanning Tree Protocol. 0: disable, 1: enable */
+#define Ingress_ACL				(1<< 4)	/* Enable Ingress ACL. 0: disable, 1: enable */
+#define Egress_ACL				(1<< 3)	/* Enable Egress ACL. 0: disable, 1: enable */
+#define Mode_OFFSET				0	/* Switch operation layer function mode */
+#define Mode_MASK				(7<< 0)	/* Switch operation layer function mode */
+#define Mode_enL2				(1<< 0)	/* Enable L2 */
+#define Mode_enL3				(1<< 1)	/* Enable L3 */
+#define Mode_enL4				(1<< 2)	/* Enable L4 */
+#define EN_STP					Enable_ST	/* Alias Name */
+#define EN_IN_ACL				Ingress_ACL	/* Alias Name */
+#define EN_OUT_ACL				Egress_ACL	/* Alias Name */
+#define EN_L4					Mode_enL4	/* Alias Name */
+#define EN_L3					Mode_enL3	/* Alias Name */
+#define EN_L2					Mode_enL2	/* Alias Name */
+
+/* SWTCR0 - swtich table control register */
+#define STOP_TLU_STA				(1<<19)	/* (RO) Table Lookup Stop Status. 1-STOP_TLU command execute is ready */
+#define STOP_TLU				(1<<18)	/* Stop Table Lookup Process 1-to stop */
+#define LIMDBC_OFFSET				(16)	/* LAN Interface Multilayer-Decision-Base Control */
+#define LIMDBC_MASK				(3<<16)
+#define LIMDBC_VLAN				(0<<16)	/* By VLAN base */
+#define LIMDBC_PORT				(1<<16)	/* By Port base */
+#define LIMDBC_MAC				(2<<16)	/* By MAC base */
+#define EnUkVIDtoCPU				(1 << 15)	/* Enable trap unknown tagged VID (VLAN table lookup miss) packet to CPU */
+#define NAPTF2CPU				(1 << 14)	/*    Trap packets not in TCP/UDP/ICMP format and
+											 * destined to the interface required to do NAPT */
+#define MultiPortModeP_OFFSET			(5)	/* Multicast Port Mode : Internal (0) or External (1) */
+#define MultiPortModeP_MASK			(0x1ff)	/* {Ext3~Ext1,Port0~Port5} 0:Internal, 1:External */
+#define MCAST_PORT_EXT_MODE_OFFSET		MultiPortModeP_OFFSET	/* Alias Name */
+#define MCAST_PORT_EXT_MODE_MASK		MultiPortModeP_MASK	/* Alias Name */
+#define WANRouteMode_OFFSET			(3)
+#define WANRouteMode_MASK			(3<<3)
+#define WANRouteMode_Forward			(0<<3)
+#define WANRouteMode_ToCpu			(1<<3)
+#define WANRouteMode_Drop			(2<<3)
+#define WAN_ROUTE_MASK				WANRouteMode_MASK
+#define WAN_ROUTE_FORWARD			WANRouteMode_Forward	/* Route WAN packets */
+#define WAN_ROUTE_TO_CPU			WANRouteMode_ToCpu	/* Forward WAN packets to CPU */
+#define WAN_ROUTE_DROP				WANRouteMode_Drop	/* Drop WAN packets */
+#define EnNAPTAutoDelete			(1<<2)
+#define EnNAPTAutoLearn				(1<<1)
+#define EnNAPTRNotFoundDrop			(1<<0)	/* 0: Reverse NAPT entry not found to forward to CPU, 1: Reverse NAPT entry not found to drop */
+#define EN_NAPT_AUTO_DELETE			EnNAPTAutoDelete	/* Enable NAPT auto delete */
+#define EN_NAPT_AUTO_LEARN			EnNAPTAutoLearn	/* Enable NAPT auto learn */
+#define NAPTR_NOT_FOUND_DROP			EnNAPTRNotFoundDrop	/* Reverse NAPT not found to S_DROP */
+
+/* SWTCR1 - swtich table control register */
+#define L4EnHash1				(1 << 13)	/* Enhanced Hash1 */
+#define EnNAP8651B				(1 << 12)	/* Enable 51B mode */
+#define EN_RTL8650B				EnNAP8651B	/* Alias Name */
+#define ENFRAGTOACLPT				(1 << 11)	/* Enable fragment packet checked by ACL and protocol trapper */
+#define EN_FRAG_TO_ACLPT			ENFRAGTOACLPT	/* Alias Name */
+#define EnNATT2LOG				(1 << 10)	/* Enable trapping attack packets for logging */
+#define EN_ATTACK_TO_LOG			EnNATT2LOG	/* Alias Name */
+#define EnL4WayH				(1 << 9)	/* Enable 4-way hash on L4 TCP/UDP table */
+#define EN_TCPUDP_4WAY_HASH			EnL4WayH	/* Alias Name */
+#define SelCpuReason				(1 << 8)	/* Enable 51B CPU reason coding */
+#define EN_51B_CPU_REASON			SelCpuReason	/* Alias Name */
+#define EN_SPI6_WAN_SRVPRT			(1 << 7)	/* Enable SPI-6 between WAN and server port */
+#define EN_SPI5_WAN_NI				(1 << 6)	/* Enable SPI-5 between WAN and NI */
+#define EN_SPI4_WAN_DMZ				(1 << 5)	/* Enable SPI-4 between WAN and DMZ */
+#define EN_SPI3_DMZ_RLAN			(1 << 4)	/* Enable SPI-3 between DMZ and RLAN */
+#define EN_SPI2_DMZ_LAN				(1 << 3)	/* Enable SPI-2 between DMZ and LAN */
+#define EN_SPI1_WAN_RLAN			(1 << 2)	/* Enable SPI-1 between WAN and RLAN */
+#define EnSPIRDrp				(1 << 1)	/* Enable dropping packets not found by reverse SPI */
+#define EN_DROP_SPIR_NOT_FOUND			EnSPIRDrp	/* Alias Name */
+#define TrapSPIUnknown				(1 << 0)	/* Enable SPI trapping non-TCP/UDP/ICMP packets */
+#define EN_SPI_TRAP_UNKNOWN			TrapSPIUnknown	/* Alias Name */
+
+/* PLITIMR - Port to LAN Interface Table Index Mapping Register */
+#define INTP0_OFFSET				0	/* Index for P0, pointing to Interface table */
+#define INTP0_MASK				(7<<0)	/* Index for P0, pointing to Interface table */
+#define INTP1_OFFSET				3	/* Index for P1, pointing to Interface table */
+#define INTP1_MASK				(7<<3)	/* Index for P1, pointing to Interface table */
+#define INTP2_OFFSET				6	/* Index for P2, pointing to Interface table */
+#define INTP2_MASK				(7<<6)	/* Index for P2, pointing to Interface table */
+#define INTP3_OFFSET				9	/* Index for P3, pointing to Interface table */
+#define INTP3_MASK				(7<<9)	/* Index for P3, pointing to Interface table */
+#define INTP4_OFFSET				12	/* Index for P4, pointing to Interface table */
+#define INTP4_MASK				(7<<12)	/* Index for P4, pointing to Interface table */
+#define INTP5_OFFSET				15	/* Index for P5, pointing to Interface table */
+#define INTP5_MASK				(7<<15)	/* Index for P5, pointing to Interface table */
+#define INTExtP0_OFFSET				18	/* Index for Ext0, pointing to Interface table */
+#define INTExtP0_MASK				(7<<18)	/* Index for Ext0, pointing to Interface table */
+#define INTExtP1_OFFSET				21	/* Index for Ext1, pointing to Interface table */
+#define INTExtP1_MASK				(7<<21)	/* Index for Ext1, pointing to Interface table */
+#define INTExtP2_OFFSET				24	/* Index for Ext2, pointing to Interface table */
+#define INTExtP2_MASK				(7<<24)	/* Index for Ext2, pointing to Interface table */
+
+/* DACLRCR - Default ACL Rule Control Register */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define ACLI_STA_MASK				(0xff)
+#define ACLI_EDA_OFFSET				8
+#define ACLI_EDA_MASK				(0xff<<ACLI_EDA_OFFSET)
+#define ACLO_STA_OFFSET				16
+#define ACLO_STA_MASK				(0xff<<ACLO_STA_OFFSET)
+#define ACLO_EDA_OFFSET				24
+#define ACLO_EDA_MASK				(0xff<<ACLO_EDA_OFFSET)
+#else
+#define ACLI_STA_MASK				(0x7f)
+#define ACLI_EDA_OFFSET				7
+#define ACLI_EDA_MASK				(0x7f<<ACLI_EDA_OFFSET)
+#define ACLO_STA_OFFSET				14
+#define ACLO_STA_MASK				(0x7f<<ACLO_STA_OFFSET)
+#define ACLO_EDA_OFFSET				21
+#define ACLO_EDA_MASK				(0x7f<<ACLO_EDA_OFFSET)
+#endif
+
+/* FFCR - Frame Forwarding Configuration Register */
+#define CF_IPM_SPA_UNMCH_OFFSET			(10)	/* SIP & DIP match but SPA unmatch */
+#define CF_IPM_SPA_UNMCH_MASK			(3<<10)	/* SIP & DIP match but SPA unmatch */
+#define CF_IPM_SPA_UNMCH_FLOODING		(2)
+#define CF_IPM_SPA_UNMCH_DROP			(1)
+#define CF_IPM_SPA_UNMCH_CPU			(0)
+
+#define CF_IPM_IP_UNMCH_OFFSET			(8)	/* IPM table unmatch flow */
+#define CF_IPM_IP_UNMCH_MASK			(3<<8)	/* IPM table unmatch flow */
+#define CF_IPM_IP_UNMCH_FLOODING		(2)
+#define CF_IPM_IP_UNMCH_DROP			(1)
+#define CF_IPM_IP_UNMCH_TO_CPU			(0)
+
+#define CF_IPMMAC_CLONE_EN			(1<<7)	/* Configure to clone the IP multicast mac from register */
+#define CF_IPMMAC_CLONE_EN_OFFSET		(7)	/* Configure to clone the IP multicast mac from register */
+
+#define IPMltHash_OFFSET			(5)	/* The hash algorithm selection for IP Multicast routing */
+#define IPMltHash_MASK				(3<<5)	/* The hash algorithm selection for IP Multicast routing */
+#define IPMltCstCtrl_OFFSET			(3)	/* IP Multicast Forwarding Control */
+#define IPMltCstCtrl_MASK			(3<<3)	/* IP Multicast Forwarding Control */
+#define IPMltCstCtrl_Disable			(0<<3)	/* Disable IP Multicast table lookup (just follow L2 Multicast packet procedure) */
+#define IPMltCstCtrl_Enable			(1<<3)	/* Enable IP Multicast table lookup */
+#define IPMltCstCtrl_TrapToCpu			(2<<3)	/* Tral all IP Multicast packet to CPU port */
+
+#define IPMltCstv6Ctrl_Disable			(0<<20)	/* Disable IPV6 Multicast table lookup (just follow L2 Multicast packet procedure) */
+#define IPMltCstv6Ctrl_Enable			(1<<20)	/* Enable IPV6 Multicast table lookup */
+#define IPMltCstv6Ctrl_TrapToCpu		(2<<20)	/* Tral all IPV6 Multicast packet to CPU port */
+
+#define EN_MCAST				IPMltCstCtrl_Enable	/* Alias Name for Enable Multicast Table */
+#define EN_MCASTv6				IPMltCstv6Ctrl_Enable	/* Alias Name for Enable Multicast Table */
+
+#define EnFlood2NonCgtPrt			(1<<2)	/* Enable Flooding to non-Congested Port Only */
+#define EnUnkUC2CPU				(1<<1)	/* Enable Unknown Unicast Packet Trap to CPU port */
+#define EnUnkMC2CPU				(1<<0)	/* Enable Unknown Multicast Packet Trap to CPU port */
+#define EN_UNUNICAST_TOCPU			EnUnkUC2CPU	/* Alias Name */
+#define EN_UNMCAST_TOCPU			EnUnkMC2CPU	/* Alias Name */
+
+/* V4VLDSCPCR0 ~ V4VLDSCPCR8 - V4 VLAN and DSCP remarking control register */
+#define CF_IPM4DSCP_ACT_OFFSET			(28)	/* CF_IPM4DSCP_ACT */
+#define CF_IPM4DSCP_ACT_MASK			(3<<28)
+#define CF_IPM4DSCP_ACT_REMARK			(2)	/* Remark DSCP value by DSCP Remarking table seeting */
+#define CF_IPM4DSCP_ACT_DIRECT			(1)	/* Direct Remark DSCP value by cf_ipm4dscp in IPMv4 packet */
+#define CF_IPM4DSCP_ACT_BYPASS			(0)	/* Bypass DSCP value */
+
+#define CF_IPM4PRI_ACT_OFFSET			(17)	/* CF_IPM4PRI_ACT */
+#define CF_IPM4PRI_ACT_MASK			(3<<17)
+#define CF_IPM4PRI_ACT_ORIG			(2)	/* follow original priority flow, like unicast packet */
+#define CF_IPM4PRI_ACT_REMARK			(1)	/* Remark VLAN priority value by cf_ipm4pri */
+#define CF_IPM4PRI_ACT_BYPASS			(0)	/* Bypass VLAN priority value */
+
+#define SBFCTR					(0x4500+SWCORE_BASE)	/* System Based Flow Control Threshold Register */
+#define SBFCR0					(0x000+SBFCTR)	/* System Based Flow Control Register 0 */
+#define SBFCR1					(0x004+SBFCTR)	/* System Based Flow Control Register 1 */
+#define SBFCR2					(0x008+SBFCTR)	/* System Based Flow Control Register 2 */
+#define PBFCR0					(0x00C+SBFCTR)	/* Port Based Flow Control Threshold Register */
+#define PBFCR1					(0x010+SBFCTR)	/* Port Based Flow Control Threshold Register */
+#define PBFCR2					(0x014+SBFCTR)	/* Port Based Flow Control Threshold Register */
+#define PBFCR3					(0x018+SBFCTR)	/* Port Based Flow Control Threshold Register */
+#define PBFCR4					(0x01C+SBFCTR)	/* Port Based Flow Control Threshold Register */
+#define PBFCR5					(0x020+SBFCTR)	/* Port Based Flow Control Threshold Register */
+#define PBFCR6					(0x024+SBFCTR)	/* Port Based Flow Control Threshold Register */
+#define QDBFCRP0G0				(0x028+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 0 Group 0 */
+#define QDBFCRP0G1				(0x02C+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 0 Group 1 */
+#define QDBFCRP0G2				(0x030+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 0 Group 2 */
+#define QDBFCRP1G0				(0x034+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 1 Group 0 */
+#define QDBFCRP1G1				(0x038+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 1 Group 1 */
+#define QDBFCRP1G2				(0x03C+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 1 Group 2 */
+#define QDBFCRP2G0				(0x040+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 2 Group 0 */
+#define QDBFCRP2G1				(0x044+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 2 Group 1 */
+#define QDBFCRP2G2				(0x048+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 2 Group 2 */
+#define QDBFCRP3G0				(0x04C+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 3 Group 0 */
+#define QDBFCRP3G1				(0x050+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 3 Group 1 */
+#define QDBFCRP3G2				(0x054+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 3 Group 2 */
+#define QDBFCRP4G0				(0x058+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 4 Group 0 */
+#define QDBFCRP4G1				(0x05C+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 4 Group 1 */
+#define QDBFCRP4G2				(0x060+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 4 Group 2 */
+#define QDBFCRP5G0				(0x064+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 5 Group 0 */
+#define QDBFCRP5G1				(0x068+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 5 Group 1 */
+#define QDBFCRP5G2				(0x06C+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 5 Group 2 */
+#define QDBFCRP6G0				(0x070+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 6 Group 0 */
+#define QDBFCRP6G1				(0x074+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 6 Group 1 */
+#define QDBFCRP6G2				(0x078+SBFCTR)	/* Queue-Descriptor=Based Flow Control Threshold for Port 6 Group 2 */
+#define QPKTFCRP0G0				(0x07C+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 0 Group 0 */
+#define QPKTFCRP0G1				(0x080+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 0 Group 1 */
+#define QPKTFCRP0G2				(0x084+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 0 Group 2 */
+#define QPKTFCRP1G0				(0x088+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 1 Group 0 */
+#define QPKTFCRP1G1				(0x08C+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 1 Group 1 */
+#define QPKTFCRP1G2				(0x090+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 1 Group 2 */
+#define QPKTFCRP2G0				(0x094+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 2 Group 0 */
+#define QPKTFCRP2G1				(0x098+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 2 Group 1 */
+#define QPKTFCRP2G2				(0x09C+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 2 Group 2 */
+#define QPKTFCRP3G0				(0x0A0+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 3 Group 0 */
+#define QPKTFCRP3G1				(0x0A4+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 3 Group 1 */
+#define QPKTFCRP3G2				(0x0A8+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 3 Group 2 */
+#define QPKTFCRP4G0				(0x0AC+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 4 Group 0 */
+#define QPKTFCRP4G1				(0x0B0+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 4 Group 1 */
+#define QPKTFCRP4G2				(0x0B4+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 4 Group 2 */
+#define QPKTFCRP5G0				(0x0B8+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 5 Group 0 */
+#define QPKTFCRP5G1				(0x0BC+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 5 Group 1 */
+#define QPKTFCRP5G2				(0x0C0+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 5 Group 2 */
+#define QPKTFCRP6G0				(0x0C4+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 6 Group 0 */
+#define QPKTFCRP6G1				(0x0C8+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 6 Group 1 */
+#define QPKTFCRP6G2				(0x0CC+SBFCTR)	/* Queue-Packet-Based Flow Control Register for Port 6 Group 2 */
+#define FCCR0					(0x0d0+SBFCTR)	/* Flow Control Configuration Register 0 */
+#define FCCR1					(0x0d4+SBFCTR)	/* Flow Control Configuration Register 1 */
+#define PQPLGR					(0x0d8+SBFCTR)	/* Per Queue Physical Length Gap Register */
+#define QRR					(0x0dc+SBFCTR)	/* Queue Reset Register */
+#define IQFCTCR					(0x0E0+SBFCTR)	/* Input Queue Flow Control Threshold Configuration Register */
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define SBFCTR2					(0x5000+SWCORE_BASE)	/* System Based Flow Control Threshold Register */
+
+#define QDBFCRP0G3				(0x01C+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 0 Group 3 */
+#define QDBFCRP0G4				(0x020+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 0 Group 4 */
+#define QDBFCRP1G3				(0x024+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 1 Group 3 */
+#define QDBFCRP1G4				(0x028+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 1 Group 4 */
+#define QDBFCRP2G3				(0x02C+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 2 Group 3 */
+#define QDBFCRP2G4				(0x030+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 2 Group 4 */
+#define QDBFCRP3G3				(0x034+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 3 Group 3 */
+#define QDBFCRP3G4				(0x038+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 3 Group 4 */
+#define QDBFCRP4G3				(0x03C+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 4 Group 3 */
+#define QDBFCRP4G4				(0x040+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 4 Group 4 */
+#define QDBFCRP5G3				(0x044+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 5 Group 3 */
+#define QDBFCRP5G4				(0x048+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 5 Group 4 */
+#define QDBFCRP6G3				(0x04C+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 6 Group 3 */
+#define QDBFCRP6G4				(0x050+SBFCTR2)	/* Queue-Descriptor=Based Flow Control Threshold for Port 6 Group 4 */
+
+#define QPKTFCRP0G3				(0x054+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 0 Group 3 */
+#define QPKTFCRP0G4				(0x058+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 0 Group 4 */
+#define QPKTFCRP1G3				(0x05C+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 1 Group 3 */
+#define QPKTFCRP1G4				(0x060+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 1 Group 4 */
+#define QPKTFCRP2G3				(0x064+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 2 Group 3 */
+#define QPKTFCRP2G4				(0x068+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 2 Group 4 */
+#define QPKTFCRP3G3				(0x06C+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 3 Group 3 */
+#define QPKTFCRP3G4				(0x070+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 3 Group 4 */
+#define QPKTFCRP4G3				(0x074+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 4 Group 3 */
+#define QPKTFCRP4G4				(0x078+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 4 Group 4 */
+#define QPKTFCRP5G3				(0x07C+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 5 Group 3 */
+#define QPKTFCRP5G4				(0x080+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 5 Group 4 */
+#define QPKTFCRP6G3				(0x084+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 6 Group 3 */
+#define QPKTFCRP6G4				(0x088+SBFCTR2)	/* Queue-Packet-Based Flow Control Register for Port 6 Group 4 */
+#endif
+
+/* SBFCR0 */
+#define S_DSC_RUNOUT_OFFSET			(0)	/* Offset for Descriptor Run Out Threshold */
+#define S_DSC_RUNOUT_MASK			(0x3FF<<0)	/* Mask for Descriptor Run Out Threshold */
+
+/* SBFCR1 */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define SDC_FCOFF_OFFSET			(16)	/* Offset for system flow control turn off threshold */
+#define SDC_FCOFF_MASK				(0x3ff<<16)	/* Mask for system flow control turn off threshold */
+#define SDC_FCON_OFFSET				(0)	/* Offset for system flow control turn on threshold */
+#define SDC_FCON_MASK				(0x3ff<<0)	/* Mask for system flow control turn on threshold */
+
+#define S_DSC_FCOFF_OFFSET			(16)	/* Offset for system flow control turn off threshold */
+#define S_DSC_FCOFF_MASK			(0x3ff<<16)	/* Mask for system flow control turn off threshold */
+#define S_DSC_FCON_OFFSET			(0)	/* Offset for system flow control turn on threshold */
+#define S_DSC_FCON_MASK				(0x3ff<<0)	/* Mask for system flow control turn on threshold */
+#else
+#define SDC_FCOFF_OFFSET			(16)	/* Offset for system flow control turn off threshold */
+#define SDC_FCOFF_MASK				(0x1ff<<16)	/* Mask for system flow control turn off threshold */
+#define SDC_FCON_OFFSET				(0)	/* Offset for system flow control turn on threshold */
+#define SDC_FCON_MASK				(0x1ff<<0)	/* Mask for system flow control turn on threshold */
+
+#define S_DSC_FCOFF_OFFSET			(16)	/* Offset for system flow control turn off threshold */
+#define S_DSC_FCOFF_MASK			(0x1ff<<16)	/* Mask for system flow control turn off threshold */
+#define S_DSC_FCON_OFFSET			(0)	/* Offset for system flow control turn on threshold */
+#define S_DSC_FCON_MASK				(0x1ff<<0)	/* Mask for system flow control turn on threshold */
+#endif
+
+/* SBFCR2 */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define S_Max_SBuf_FCOFF_OFFSET			(16)	/* System max shared buffer flow control turn off threshold */
+#define S_Max_SBuf_FCOFF_MASK			(0x3FF<<16)	/* System max shared buffer flow control turn off threshold */
+#define S_Max_SBuf_FCON_OFFSET			(0)	/* System max shared buffer flow control turn on threshold */
+#define S_Max_SBuf_FCON_MASK			(0x3FF<<0)	/* System max shared buffer flow control turn on threshold */
+#else
+#define S_Max_SBuf_FCOFF_OFFSET			(16)	/* System max shared buffer flow control turn off threshold */
+#define S_Max_SBuf_FCOFF_MASK			(0x1FF<<16)	/* System max shared buffer flow control turn off threshold */
+#define S_Max_SBuf_FCON_OFFSET			(0)	/* System max shared buffer flow control turn on threshold */
+#define S_Max_SBuf_FCON_MASK			(0x1FF<<0)	/* System max shared buffer flow control turn on threshold */
+#endif
+
+/* PBFCR0~PBFCR6 - Port Based Flow Control Threshold Register */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define P_MaxDSC_FCOFF_OFFSET			(16)	/* Per-Port Max Used Descriptor Flow Control Turn Off Threshold */
+#define P_MaxDSC_FCOFF_MASK			(0x3ff<<16)	/* Per-Port Max Used Descriptor Flow Control Turn Off Threshold */
+#define P_MaxDSC_FCON_OFFSET			(0)	/* Per-Port Max Used Descriptor Flow Control Turn On Threshold */
+#define P_MaxDSC_FCON_MASK			(0x3ff<<0)	/* Per-Port Max Used Descriptor Flow Control Turn On Threshold */
+#else
+#define P_MaxDSC_FCOFF_OFFSET			(16)	/* Per-Port Max Used Descriptor Flow Control Turn Off Threshold */
+#define P_MaxDSC_FCOFF_MASK			(0x1ff<<16)	/* Per-Port Max Used Descriptor Flow Control Turn Off Threshold */
+#define P_MaxDSC_FCON_OFFSET			(0)	/* Per-Port Max Used Descriptor Flow Control Turn On Threshold */
+#define P_MaxDSC_FCON_MASK			(0x1ff<<0)	/* Per-Port Max Used Descriptor Flow Control Turn On Threshold */
+#endif
+/* QDBFCRP0G0,QDBFCRP0G1,QDBFCRP0G2
+ * QDBFCRP1G0,QDBFCRP1G1,QDBFCRP1G2
+ * QDBFCRP2G0,QDBFCRP2G1,QDBFCRP2G2
+ * QDBFCRP3G0,QDBFCRP3G1,QDBFCRP3G2
+ * QDBFCRP4G0,QDBFCRP4G1,QDBFCRP4G2
+ * QDBFCRP5G0,QDBFCRP5G1,QDBFCRP5G2
+ * - Queue-Descriptor=Based Flow Control Threshold for Port 0 Group 0 */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define QG_DSC_FCOFF_OFFSET			(16)	/* Queue Descriptor Based Flow Control Turn Off Threshold */
+#define QG_DSC_FCOFF_MASK			(0xff<<16)	/* Queue Descriptor Based Flow Control Turn Off Threshold */
+#define QG_DSC_FCON_OFFSET			(0)	/* Queue Descriptor Based Flow Control Turn Off Threshold */
+#define QG_DSC_FCON_MASK			(0xff<<0)	/* Queue Descriptor Based Flow Control Turn Off Threshold */
+#else
+#define QG_DSC_FCOFF_OFFSET			(16)	/* Queue Descriptor Based Flow Control Turn Off Threshold */
+#define QG_DSC_FCOFF_MASK			(0x1f<<16)	/* Queue Descriptor Based Flow Control Turn Off Threshold */
+#define QG_DSC_FCON_OFFSET			(0)	/* Queue Descriptor Based Flow Control Turn Off Threshold */
+#define QG_DSC_FCON_MASK			(0x7f<<0)	/* Queue Descriptor Based Flow Control Turn Off Threshold */
+#endif
+/* QPKTFCRP0G0,QPKTFCRP0G1,QPKTFCRP0G2
+ * QPKTFCRP1G0,QPKTFCRP1G1,QPKTFCRP1G2
+ * QPKTFCRP2G0,QPKTFCRP2G1,QPKTFCRP2G2
+ * QPKTFCRP3G0,QPKTFCRP3G1,QPKTFCRP3G2
+ * QPKTFCRP4G0,QPKTFCRP4G1,QPKTFCRP4G2
+ * QPKTFCRP5G0,QPKTFCRP5G1,QPKTFCRP5G2
+   - Queue-Packet-Based Flow Control Register for Port 0 Group 0 */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define QG_QLEN_FCOFF_OFFSET			(16)	/* Queue Packet Based Flow Control Turn Off Threshold */
+#define QG_QLEN_FCOFF_MASK			(0x1ff<<16)	/* Queue Packet Based Flow Control Turn Off Threshold */
+#define QG_QLEN_FCON_OFFSET			(0)	/* Queue Packet Based Flow Control Turn Off Threshold */
+#define QG_QLEN_FCON_MASK			(0x1ff<<0)	/* Queue Packet Based Flow Control Turn Off Threshold */
+
+#else
+#define QG_QLEN_FCOFF_OFFSET			(16)	/* Queue Packet Based Flow Control Turn Off Threshold */
+#define QG_QLEN_FCOFF_MASK			(0x1f<<16)	/* Queue Packet Based Flow Control Turn Off Threshold */
+#define QG_QLEN_FCON_OFFSET			(0)	/* Queue Packet Based Flow Control Turn Off Threshold */
+#define QG_QLEN_FCON_MASK			(0x7f<<0)	/* Queue Packet Based Flow Control Turn Off Threshold */
+#endif
+
+/* FCCR0 - Flow Control enable/disable for port3~port0 */
+/* FCCR1 - Flow Control enable/disable for port6~port4 */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define Q_P0_EN_FC_OFFSET			(0)
+#define Q_P0_EN_FC_MASK				(0xff<<0)
+#define Q_P1_EN_FC_OFFSET			(8)
+#define Q_P1_EN_FC_MASK				(0xff<<8)
+#define Q_P2_EN_FC_OFFSET			(16)
+#define Q_P2_EN_FC_MASK				(0xff<<16)
+#define Q_P3_EN_FC_OFFSET			(24)
+#define Q_P3_EN_FC_MASK				(0xff<<24)
+#define Q_P4_EN_FC_OFFSET			(0)
+#define Q_P4_EN_FC_MASK				(0xff<<0)
+#define Q_P5_EN_FC_OFFSET			(8)
+#define Q_P5_EN_FC_MASK				(0xff<<8)
+#define Q_P6_EN_FC_OFFSET			(16)
+#define Q_P6_EN_FC_MASK				(0xff<<16)
+#else
+#define Q_P0_EN_FC_OFFSET			(0)
+#define Q_P0_EN_FC_MASK				(0x3f<<0)
+#define Q_P1_EN_FC_OFFSET			(8)
+#define Q_P1_EN_FC_MASK				(0x3f<<8)
+#define Q_P2_EN_FC_OFFSET			(16)
+#define Q_P2_EN_FC_MASK				(0x3f<<16)
+#define Q_P3_EN_FC_OFFSET			(24)
+#define Q_P3_EN_FC_MASK				(0x3f<<24)
+#define Q_P4_EN_FC_OFFSET			(0)
+#define Q_P4_EN_FC_MASK				(0x3f<<0)
+#define Q_P5_EN_FC_OFFSET			(8)
+#define Q_P5_EN_FC_MASK				(0x3f<<8)
+#define Q_P6_EN_FC_OFFSET			(16)
+#define Q_P6_EN_FC_MASK				(0x3f<<16)
+#endif
+
+/* PQPLGR - Per-Queue Physical length Gap Register */
+#define QLEN_GAP_OFFSET				(0)	/* Per Queue physical length gap */
+#define QLEN_GAP_MASK				(0xff<<0)	/* Per Queue physical length gap */
+
+/* QRR - Queue Reset Register */
+#define QRST					(1<<0)	/* Queue Reset */
+
+/* IQFCTCR - Input Queue Flow Control Threshold Configuration Register */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define IQ_DSC_FCON_OFFSET			(16)	/* Offset for input Queue Flow control turn OFF descriptor threshold */
+#define IQ_DSC_FCON_MASK			(0xff<<16)	/* Mask for input Queue Flow control turn OFF descriptor threshold */
+#define IQ_DSC_FCOFF_OFFSET			(0)	/* Offset for input Queue Flow control turn ON descriptor threshold */
+#define IQ_DSC_FCOFF_MASK			(0xff<<0)	/* Mask for input Queue Flow control turn ON descriptor threshold */
+#else
+#define IQ_DSC_FCON_OFFSET			(8)	/* Offset for input Queue Flow control turn OFF descriptor threshold */
+#define IQ_DSC_FCON_MASK			(0xff<<8)	/* Mask for input Queue Flow control turn OFF descriptor threshold */
+#define IQ_DSC_FCOFF_OFFSET			(0)	/* Offset for input Queue Flow control turn ON descriptor threshold */
+#define IQ_DSC_FCOFF_MASK			(0xff<<0)	/* Mask for input Queue Flow control turn ON descriptor threshold */
+#endif
+
+#ifdef	CONFIG_RTK_VOIP_QOS
+#define PSRP6_RW				(SWCORE_BASE+0x4600)	/*CPU Port Status : R/W */
+#endif
+
+/* QoS Function Control Register */
+#define OQNCR_BASE				(SWCORE_BASE+0x4700)	/* Output Queue Number Control Registers */
+#define QOSFCR					(0x00 + OQNCR_BASE)	/* QoS Function Control Register */
+#define IBCR0					(0x04 + OQNCR_BASE)	/* Ingress Bandwidth Control Register 0 */
+#define IBCR1					(0x08 + OQNCR_BASE)	/* Ingress Bandwidth Control Register 1 */
+#define IBCR2					(0x0C + OQNCR_BASE)	/* Ingress Bandwidth Control Register 2 */
+#if defined(CONFIG_RTL_8197F)
+#define IBCR3					(0x10 + OQNCR_BASE)	/* Ingress Bandwidth Control Register 3 */
+#endif
+#define PBPCR					(0x14 + OQNCR_BASE)	/* Port Based Priority Control Register Address Mapping */
+#define UPTCMCR0				(0x18 + OQNCR_BASE)	/* User Priority to Traffic Class Mapping for 1 output queue */
+#define UPTCMCR1				(0x1c + OQNCR_BASE)	/* User Priority to Traffic Class Mapping for 2 output queue */
+#define UPTCMCR2				(0x20 + OQNCR_BASE)	/* User Priority to Traffic Class Mapping for 3 output queue */
+#define UPTCMCR3				(0x24 + OQNCR_BASE)	/* User Priority to Traffic Class Mapping for 4 output queue */
+#define UPTCMCR4				(0x28 + OQNCR_BASE)	/* User Priority to Traffic Class Mapping for 5 output queue */
+#define UPTCMCR5				(0x2c + OQNCR_BASE)	/* User Priority to Traffic Class Mapping for 6 output queue */
+#define LPTM8021Q				(0x30 + OQNCR_BASE)	/*802.1Q priority to linear priority Transfer mapping. */
+#define DSCPCR0					(0x34 + OQNCR_BASE)	/*DSCP Priority Control Register Address Mapping. */
+#define DSCPCR1					(0x38 + OQNCR_BASE)	/*DSCP Priority Control Register Address Mapping. */
+#define DSCPCR2					(0x3C + OQNCR_BASE)	/*DSCP Priority Control Register Address Mapping. */
+#define DSCPCR3					(0x40 + OQNCR_BASE)	/*DSCP Priority Control Register Address Mapping. */
+#define DSCPCR4					(0x44 + OQNCR_BASE)	/*DSCP Priority Control Register Address Mapping. */
+#define DSCPCR5					(0x48 + OQNCR_BASE)	/*DSCP Priority Control Register Address Mapping. */
+#define DSCPCR6					(0x4C + OQNCR_BASE)	/*DSCP Priority Control Register Address Mapping. */
+#define QIDDPCR					(0x50 + OQNCR_BASE)	/*Queue ID Decision Priority Register Address Mapping */
+#define QNUMCR					(0x54 + OQNCR_BASE)	/*Queue Number Control Register */
+#define CPUQIDMCR0				(0x58 + OQNCR_BASE)	/*CPU port QID Mapping Control Register (DP=include CPU) */
+#define CPUQIDMCR1				(0x5C + OQNCR_BASE)	/*CPU port QID Mapping Control Register (DP=EXT0) */
+#define CPUQIDMCR2				(0x60 + OQNCR_BASE)	/*CPU port QID Mapping Control Register (DP=EXT1) */
+#define CPUQIDMCR3				(0x64 + OQNCR_BASE)	/*CPU port QID Mapping Control Register (DP=EXT2) */
+#define CPUQIDMCR4				(0x68 + OQNCR_BASE)	/*CPU port QID Mapping Control Register (DP=multi-port of Ext port) */
+#define RMCR1P					(0x6C + OQNCR_BASE)	/*802.1P      Remarking Control Register 0 */
+#define DSCPRM0					(0x70 + OQNCR_BASE)	/*DSCP Remarking Control Register 0 */
+#define DSCPRM1					(0x74 + OQNCR_BASE)	/*DSCP Remarking Control Register 1 */
+#define RLRC					(0x78 + OQNCR_BASE)	/*Remarking Layer Rule Control */
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define IBCR4					(0x7C + OQNCR_BASE)	/* Ingress Bandwidth Control Register 4 */
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define OQNCR_BASE2				(SWCORE_BASE+0x5000)	/* Output Queue Number Control Registers for 98C */
+#define PQGCR8					(0x00 + OQNCR_BASE2)	/*8 Priority Queue Global Control Register */
+#define UPTCMCR6				(0x10 + OQNCR_BASE2)	/* User Priority to Traffic Class Mapping for 7 output queue */
+#define UPTCMCR7				(0x14 + OQNCR_BASE2)	/* User Priority to Traffic Class Mapping for 8 output queue */
+#define EN_8PRI_Q_MASK				(1<<0)	/*Enable 8 Priority Q */
+#endif
+
+/* QOSFCR - QoS Function Control Register */
+#define BC_withPIFG_OFFSET			(0)	/* Bandwidth Conrol Include/Exclude Preamble&IFG. 0:exclude; 1:include */
+#define BC_withPIFG_MASK			(1<<0)	/* Bandwidth Conrol Include/Exclude Preamble&IFG. 0:exclude; 1:include */
+
+/* IBCR0/IBCR1/IBCR2 general */
+#define IBWC_ODDPORT_OFFSET			(16)	/* ODD-port Ingress Bandwidth Control Offset */
+#define IBWC_ODDPORT_MASK			(0xFFFF<<16)	/* ODD-port Ingress Bandwidth Control MASK */
+#define IBWC_EVENPORT_OFFSET			(0)	/* EVEN-port Ingress Bandwidth Control Offset */
+#define IBWC_EVENPORT_MASK			(0xFFFF<<0)	/* EVEN-port Ingress Bandwidth Control MASK */
+
+#if defined(CONFIG_RTL_8197F)
+/*IBCR3 general*/
+#define IBCR3_HIGH_OFFSET			(16)
+#define IBCR3_PORT_MASK				(0xf)
+#define IBCR3_PORT_OFFSET(port)			((port)<<2)
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+/* IBCR4 - Ingress Bandwidth Control Register 4 */
+#define IBWC_P6_MASK				(0x1fffff)	/* Port6 Ingress Bandwidth Control */
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+/* IBCR0 - Ingress Bandwidth Control Register 0 */
+#define IBWC_P1_OFFSET				(16)	/* Port1 Ingress Bandwidth Control */
+#define IBWC_P1_MASK				(0xffff<<16)	/* Port1 Ingress Bandwidth Control */
+#define IBWC_P0_OFFSET				( 0)	/* Port0 Ingress Bandwidth Control */
+#define IBWC_P0_MASK				(0xffff<< 0)	/* Port0 Ingress Bandwidth Control */
+
+/* IBCR1 - Ingress Bandwidth Control Register 1 */
+#define IBWC_P3_OFFSET				(16)	/* Port3 Ingress Bandwidth Control */
+#define IBWC_P3_MASK				(0xffff<<16)	/* Port3 Ingress Bandwidth Control */
+#define IBWC_P2_OFFSET				( 0)	/* Port2 Ingress Bandwidth Control */
+#define IBWC_P2_MASK				(0xffff<< 0)	/* Port2 Ingress Bandwidth Control */
+
+/* IBCR2 - Ingress Bandwidth Control Register 2 */
+#define IBWC_P5_OFFSET				(16)	/* Port5 Ingress Bandwidth Control */
+#define IBWC_P5_MASK				(0xffff<<16)	/* Port5 Ingress Bandwidth Control */
+#define IBWC_P4_OFFSET				( 0)	/* Port4 Ingress Bandwidth Control */
+#define IBWC_P4_MASK				(0xffff<< 0)	/* Port4 Ingress Bandwidth Control */
+
+/* PBPCR - Port Based Priority Control Register */
+#define PBPRI_P8_OFFSET				(24)	/* Port Based Priority assign for port 8 */
+#define PBPRI_P8_MASK				(0x7<<24)	/* Port Based Priority assign for port 8 */
+#define PBPRI_P7_OFFSET				(21)	/* Port Based Priority assign for port 7 */
+#define PBPRI_P7_MASK				(0x7<<21)	/* Port Based Priority assign for port 7 */
+#define PBPRI_P6_OFFSET				(18)	/* Port Based Priority assign for port 6 */
+#define PBPRI_P6_MASK				(0x7<<18)	/* Port Based Priority assign for port 6 */
+#define PBPRI_P5_OFFSET				(15)	/* Port Based Priority assign for port 5 */
+#define PBPRI_P5_MASK				(0x7<<15)	/* Port Based Priority assign for port 5 */
+#define PBPRI_P4_OFFSET				(12)	/* Port Based Priority assign for port 4 */
+#define PBPRI_P4_MASK				(0x7<<12)	/* Port Based Priority assign for port 4 */
+#define PBPRI_P3_OFFSET				(9)	/* Port Based Priority assign for port 3 */
+#define PBPRI_P3_MASK				(0x7<<9)	/* Port Based Priority assign for port 3 */
+#define PBPRI_P2_OFFSET				(6)	/* Port Based Priority assign for port 2 */
+#define PBPRI_P2_MASK				(0x7<<6)	/* Port Based Priority assign for port 2 */
+#define PBPRI_P1_OFFSET				(3)	/* Port Based Priority assign for port 1 */
+#define PBPRI_P1_MASK				(0x7<<3)	/* Port Based Priority assign for port 1 */
+#define PBPRI_P0_OFFSET				(0)	/* Port Based Priority assign for port 0 */
+#define PBPRI_P0_MASK				(0x7<<0)	/* Port Based Priority assign for port 0 */
+
+/* QIDDPCR - Queue ID Decision Priority Register Address Mapping*/
+#define PBP_PRI_OFFSET				0	/*Output queue decision priority assign for Port Based Priority */
+#define PBP_PRI_MASK				(0xf<< 0)	/*Output queue decision priority assign for Port Based Priority */
+#define BP8021Q_PRI_OFFSET			4	/*Output queue decision priority assign for 1Q Based Priority */
+#define BP8021Q_PRI_MASK			(0xf<< 4)	/*Output queue decision priority assign for 1Q Based Priority */
+#define DSCP_PRI_OFFSET				8	/*Output queue decision priority assign for DSCP Based Priority */
+#define DSCP_PRI_MASK				(0xf<< 8)	/*Output queue decision priority assign for DSCP Based Priority */
+#define ACL_PRI_OFFSET				12	/*Output queue decision priority assign for ACL Based Priority */
+#define ACL_PRI_MASK				(0xf<<12)	/*Output queue decision priority assign for ACL Based Priority */
+#define NAPT_PRI_OFFSET				16	/*Output queue decision priority assign for NAPT Based Priority */
+#define NAPT_PRI_MASK				(0xf<<16)	/*Output queue decision priority assign for NAPT Based Priority */
+#if defined(CONFIG_RTL_8197F)
+#define VID_PRI_OFFSET				20	/*Output queue decision priority assign for VID Based Priority */
+#define VID_PRI_MARK				(0xf<<20)	/*Output queue decision priority assign for VID Based Priority */
+#endif
+
+/* LPTM8021Q - 802.1Q priority to linear priority Transfer mapping. */
+#define EN_8021Q2LTMPRI7			21	/* 8 level linear priority mapping for 802.1Q priority level 7 */
+#define EN_8021Q2LTMPRI7_MASK			(0x7<<21)	/* 8 level linear priority mapping for 802.1Q priority level 7 */
+#define EN_8021Q2LTMPRI6			18	/* 8 level linear priority mapping for 802.1Q priority level 6 */
+#define EN_8021Q2LTMPRI6_MASK			(0x7<<18)	/* 8 level linear priority mapping for 802.1Q priority level 6 */
+#define EN_8021Q2LTMPRI5			15	/* 8 level linear priority mapping for 802.1Q priority level 5 */
+#define EN_8021Q2LTMPRI5_MASK			(0x7<<15)	/* 8 level linear priority mapping for 802.1Q priority level 5 */
+#define EN_8021Q2LTMPRI4			12	/* 8 level linear priority mapping for 802.1Q priority level 4 */
+#define EN_8021Q2LTMPRI4_MASK			(0x7<<12)	/* 8 level linear priority mapping for 802.1Q priority level 4 */
+#define EN_8021Q2LTMPRI3			9	/* 8 level linear priority mapping for 802.1Q priority level 3 */
+#define EN_8021Q2LTMPRI3_MASK			(0x7<<9)	/* 8 level linear priority mapping for 802.1Q priority level 3 */
+#define EN_8021Q2LTMPRI2			6	/* 8 level linear priority mapping for 802.1Q priority level 2 */
+#define EN_8021Q2LTMPRI2_MASK			(0x7<<6)	/* 8 level linear priority mapping for 802.1Q priority level 2 */
+#define EN_8021Q2LTMPRI1			3	/* 8 level linear priority mapping for 802.1Q priority level 1 */
+#define EN_8021Q2LTMPRI1_MASK			(0x7<<3)	/* 8 level linear priority mapping for 802.1Q priority level 1 */
+#define EN_8021Q2LTMPRI0			0	/* 8 level linear priority mapping for 802.1Q priority level 0 */
+#define EN_8021Q2LTMPRI0_MASK			(0x7<<0)	/* 8 level linear priority mapping for 802.1Q priority level 0 */
+
+/* DSCPCR0 - DSCP Priority Control Register Address Mapping. */
+#define DSCP0_PRI				0
+#define DSCP1_PRI				3
+#define DSCP2_PRI				6
+#define DSCP3_PRI				9
+#define DSCP4_PRI				12
+#define DSCP5_PRI				15
+#define DSCP6_PRI				18
+#define DSCP7_PRI				21
+#define DSCP8_PRI				24
+#define DSCP9_PRI				27
+#define DSCP32_PRI				6
+
+/* QNUMCR - Queue Number Control Register*/
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define P0QNum_OFFSET				(0)
+#define P0QNum_MASK				(7<<0)	/* Valid for 1~6 output queues */
+#define P0QNum_1				(0<<0)	/* 1 Output Queue */
+#define P0QNum_2				(1<<0)	/* 2 Output Queues */
+#define P0QNum_3				(2<<0)	/* 3 Output Queues */
+#define P0QNum_4				(3<<0)	/* 4 Output Queues */
+#define P0QNum_5				(4<<0)	/* 5 Output Queues */
+#define P0QNum_6				(5<<0)	/* 6 Output Queues */
+#define P0QNum_7				(6<<0)	/* 7 Output Queues */
+#define P0QNum_8				(7<<0)	/* 8 Output Queues */
+#define P1QNum_OFFSET				(3)
+#define P1QNum_MASK				(7<<3)	/* Valid for 1~6 output queues */
+#define P1QNum_1				(0<<3)	/* 1 Output Queue */
+#define P1QNum_2				(1<<3)	/* 2 Output Queues */
+#define P1QNum_3				(2<<3)	/* 3 Output Queues */
+#define P1QNum_4				(3<<3)	/* 4 Output Queues */
+#define P1QNum_5				(4<<3)	/* 5 Output Queues */
+#define P1QNum_6				(5<<3)	/* 6 Output Queues */
+#define P1QNum_7				(6<<3)	/* 7 Output Queues */
+#define P1QNum_8				(7<<3)	/* 8 Output Queues */
+#define P2QNum_OFFSET				(6)
+#define P2QNum_MASK				(7<<6)	/* Valid for 1~6 output queues */
+#define P2QNum_1				(0<<6)	/* 1 Output Queue */
+#define P2QNum_2				(1<<6)	/* 2 Output Queues */
+#define P2QNum_3				(2<<6)	/* 3 Output Queues */
+#define P2QNum_4				(3<<6)	/* 4 Output Queues */
+#define P2QNum_5				(4<<6)	/* 5 Output Queues */
+#define P2QNum_6				(5<<6)	/* 6 Output Queues */
+#define P2QNum_7				(6<<6)	/* 7 Output Queues */
+#define P2QNum_8				(7<<6)	/* 8 Output Queues */
+#define P3QNum_OFFSET				(9)
+#define P3QNum_MASK				(7<<9)	/* Valid for 1~6 output queues */
+#define P3QNum_1				(0<<9)	/* 1 Output Queue */
+#define P3QNum_2				(1<<9)	/* 2 Output Queues */
+#define P3QNum_3				(2<<9)	/* 3 Output Queues */
+#define P3QNum_4				(3<<9)	/* 4 Output Queues */
+#define P3QNum_5				(4<<9)	/* 5 Output Queues */
+#define P3QNum_6				(5<<9)	/* 6 Output Queues */
+#define P3QNum_7				(6<<9)	/* 7 Output Queues */
+#define P3QNum_8				(7<<9)	/* 8 Output Queues */
+#define P4QNum_OFFSET				(12)
+#define P4QNum_MASK				(7<<12)	/* Valid for 1~6 output queues */
+#define P4QNum_1				(0<<12)	/* 1 Output Queue */
+#define P4QNum_2				(1<<12)	/* 2 Output Queues */
+#define P4QNum_3				(2<<12)	/* 3 Output Queues */
+#define P4QNum_4				(3<<12)	/* 4 Output Queues */
+#define P4QNum_5				(4<<12)	/* 5 Output Queues */
+#define P4QNum_6				(5<<12)	/* 6 Output Queues */
+#define P4QNum_7				(6<<12)	/* 7 Output Queues */
+#define P4QNum_8				(7<<12)	/* 8 Output Queues */
+#define P5QNum_OFFSET				(15)
+#define P5QNum_MASK				(7<<15)	/* Valid for 1~6 output queues */
+#define P5QNum_1				(0<<15)	/* 1 Output Queue */
+#define P5QNum_2				(1<<15)	/* 2 Output Queues */
+#define P5QNum_3				(2<<15)	/* 3 Output Queues */
+#define P5QNum_4				(3<<15)	/* 4 Output Queues */
+#define P5QNum_5				(4<<15)	/* 5 Output Queues */
+#define P5QNum_6				(5<<15)	/* 6 Output Queues */
+#define P5QNum_7				(6<<15)	/* 7 Output Queues */
+#define P5QNum_8				(7<<15)	/* 8 Output Queues */
+#define P6QNum_OFFSET				(18)	/* CPU port */
+#define P6QNum_MASK				(7<<18)	/* Valid for 1~6 output queues */
+#define P6QNum_1				(0<<18)	/* 1 Output Queue */
+#define P6QNum_2				(1<<18)	/* 2 Output Queues */
+#define P6QNum_3				(2<<18)	/* 3 Output Queues */
+#define P6QNum_4				(3<<18)	/* 4 Output Queues */
+#define P6QNum_5				(4<<18)	/* 5 Output Queues */
+#define P6QNum_6				(5<<18)	/* 6 Output Queues */
+#define P6QNum_7				(6<<18)	/* 7 Output Queues */
+#define P6QNum_8				(7<<18)	/* 8 Output Queues */
+#else
+#define P0QNum_OFFSET				(0)
+#define P0QNum_MASK				(7<<0)	/* Valid for 1~6 output queues */
+#define P0QNum_1				(1<<0)	/* 1 Output Queue */
+#define P0QNum_2				(2<<0)	/* 2 Output Queues */
+#define P0QNum_3				(3<<0)	/* 3 Output Queues */
+#define P0QNum_4				(4<<0)	/* 4 Output Queues */
+#define P0QNum_5				(5<<0)	/* 5 Output Queues */
+#define P0QNum_6				(6<<0)	/* 6 Output Queues */
+#define P1QNum_OFFSET				(3)
+#define P1QNum_MASK				(7<<3)	/* Valid for 1~6 output queues */
+#define P1QNum_1				(1<<3)	/* 1 Output Queue */
+#define P1QNum_2				(2<<3)	/* 2 Output Queues */
+#define P1QNum_3				(3<<3)	/* 3 Output Queues */
+#define P1QNum_4				(4<<3)	/* 4 Output Queues */
+#define P1QNum_5				(5<<3)	/* 5 Output Queues */
+#define P1QNum_6				(6<<3)	/* 6 Output Queues */
+#define P2QNum_OFFSET				(6)
+#define P2QNum_MASK				(7<<6)	/* Valid for 1~6 output queues */
+#define P2QNum_1				(1<<6)	/* 1 Output Queue */
+#define P2QNum_2				(2<<6)	/* 2 Output Queues */
+#define P2QNum_3				(3<<6)	/* 3 Output Queues */
+#define P2QNum_4				(4<<6)	/* 4 Output Queues */
+#define P2QNum_5				(5<<6)	/* 5 Output Queues */
+#define P2QNum_6				(6<<6)	/* 6 Output Queues */
+#define P3QNum_OFFSET				(9)
+#define P3QNum_MASK				(7<<9)	/* Valid for 1~6 output queues */
+#define P3QNum_1				(1<<9)	/* 1 Output Queue */
+#define P3QNum_2				(2<<9)	/* 2 Output Queues */
+#define P3QNum_3				(3<<9)	/* 3 Output Queues */
+#define P3QNum_4				(4<<9)	/* 4 Output Queues */
+#define P3QNum_5				(5<<9)	/* 5 Output Queues */
+#define P3QNum_6				(6<<9)	/* 6 Output Queues */
+#define P4QNum_OFFSET				(12)
+#define P4QNum_MASK				(7<<12)	/* Valid for 1~6 output queues */
+#define P4QNum_1				(1<<12)	/* 1 Output Queue */
+#define P4QNum_2				(2<<12)	/* 2 Output Queues */
+#define P4QNum_3				(3<<12)	/* 3 Output Queues */
+#define P4QNum_4				(4<<12)	/* 4 Output Queues */
+#define P4QNum_5				(5<<12)	/* 5 Output Queues */
+#define P4QNum_6				(6<<12)	/* 6 Output Queues */
+#define P5QNum_OFFSET				(15)
+#define P5QNum_MASK				(7<<15)	/* Valid for 1~6 output queues */
+#define P5QNum_1				(1<<15)	/* 1 Output Queue */
+#define P5QNum_2				(2<<15)	/* 2 Output Queues */
+#define P5QNum_3				(3<<15)	/* 3 Output Queues */
+#define P5QNum_4				(4<<15)	/* 4 Output Queues */
+#define P5QNum_5				(5<<15)	/* 5 Output Queues */
+#define P5QNum_6				(6<<15)	/* 6 Output Queues */
+#define P6QNum_OFFSET				(18)	/* CPU port */
+#define P6QNum_MASK				(7<<18)	/* Valid for 1~6 output queues */
+#define P6QNum_1				(1<<18)	/* 1 Output Queue */
+#define P6QNum_2				(2<<18)	/* 2 Output Queues */
+#define P6QNum_3				(3<<18)	/* 3 Output Queues */
+#define P6QNum_4				(4<<18)	/* 4 Output Queues */
+#define P6QNum_5				(5<<18)	/* 5 Output Queues */
+#define P6QNum_6				(6<<18)	/* 6 Output Queues */
+#endif
+
+/* output queue status mask */
+#define OUTPUTQUEUE_STAT_MASK_CR0		0xfc000000
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define OUTPUTQUEUE_STAT_MASK_CR1		0xffffffff
+#define OUTPUTQUEUE_STAT_MASK_CR2		0xffffff
+#define OUTPUTQUEUE_STAT_MASK_CPU		0xff0000
+
+#else
+#define OUTPUTQUEUE_STAT_MASK_CR1		0x3fffffff
+#endif
+
+/* CPUQIDMCR0 - CPU port QID Mapping Control Register (DP=include CPU) */
+#define CPUPri7QIDM_OFFSET			28	/* DP=include CPU, priority=7 */
+#define CPUPri7QIDM_MASK			(7<<28)	/* DP=include CPU, priority=7 */
+#define CPUPri6QIDM_OFFSET			24	/* DP=include CPU, priority=6 */
+#define CPUPri6QIDM_MASK			(7<<24)	/* DP=include CPU, priority=6 */
+#define CPUPri5QIDM_OFFSET			20	/* DP=include CPU, priority=5 */
+#define CPUPri5QIDM_MASK			(7<<20)	/* DP=include CPU, priority=5 */
+#define CPUPri4QIDM_OFFSET			16	/* DP=include CPU, priority=4 */
+#define CPUPri4QIDM_MASK			(7<<16)	/* DP=include CPU, priority=4 */
+#define CPUPri3QIDM_OFFSET			12	/* DP=include CPU, priority=3 */
+#define CPUPri3QIDM_MASK			(7<<12)	/* DP=include CPU, priority=3 */
+#define CPUPri2QIDM_OFFSET			8	/* DP=include CPU, priority=2 */
+#define CPUPri2QIDM_MASK			(7<<8)	/* DP=include CPU, priority=2 */
+#define CPUPri1QIDM_OFFSET			4	/* DP=include CPU, priority=1 */
+#define CPUPri1QIDM_MASK			(7<<4)	/* DP=include CPU, priority=1 */
+#define CPUPri0QIDM_OFFSET			0	/* DP=include CPU, priority=0 */
+#define CPUPri0QIDM_MASK			(7<<0)	/* DP=include CPU, priority=0 */
+
+/* CPUQIDMCR1 - CPU port QID Mapping Control Register (DP=EXT0) */
+#define EXT0Pri7QIDM_OFFSET			28	/* DP=EXT0, priority=7 */
+#define EXT0Pri7QIDM_MASK			(7<<28)	/* DP=EXT0, priority=7 */
+#define EXT0Pri6QIDM_OFFSET			24	/* DP=EXT0, priority=6 */
+#define EXT0Pri6QIDM_MASK			(7<<24)	/* DP=EXT0, priority=6 */
+#define EXT0Pri5QIDM_OFFSET			20	/* DP=EXT0, priority=5 */
+#define EXT0Pri5QIDM_MASK			(7<<20)	/* DP=EXT0, priority=5 */
+#define EXT0Pri4QIDM_OFFSET			16	/* DP=EXT0, priority=4 */
+#define EXT0Pri4QIDM_MASK			(7<<16)	/* DP=EXT0, priority=4 */
+#define EXT0Pri3QIDM_OFFSET			12	/* DP=EXT0, priority=3 */
+#define EXT0Pri3QIDM_MASK			(7<<12)	/* DP=EXT0, priority=3 */
+#define EXT0Pri2QIDM_OFFSET			8	/* DP=EXT0, priority=2 */
+#define EXT0Pri2QIDM_MASK			(7<<8)	/* DP=EXT0, priority=2 */
+#define EXT0Pri1QIDM_OFFSET			4	/* DP=EXT0, priority=1 */
+#define EXT0Pri1QIDM_MASK			(7<<4)	/* DP=EXT0, priority=1 */
+#define EXT0Pri0QIDM_OFFSET			0	/* DP=EXT0, priority=0 */
+#define EXT0Pri0QIDM_MASK			(7<<0)	/* DP=EXT0, priority=0 */
+
+/* CPUQIDMCR1 - CPU port QID Mapping Control Register (DP=EXT1) */
+#define EXT1Pri7QIDM_OFFSET			28	/* DP=EXT1, priority=7 */
+#define EXT1Pri7QIDM_MASK			(7<<28)	/* DP=EXT1, priority=7 */
+#define EXT1Pri6QIDM_OFFSET			24	/* DP=EXT1, priority=6 */
+#define EXT1Pri6QIDM_MASK			(7<<24)	/* DP=EXT1, priority=6 */
+#define EXT1Pri5QIDM_OFFSET			20	/* DP=EXT1, priority=5 */
+#define EXT1Pri5QIDM_MASK			(7<<20)	/* DP=EXT1, priority=5 */
+#define EXT1Pri4QIDM_OFFSET			16	/* DP=EXT1, priority=4 */
+#define EXT1Pri4QIDM_MASK			(7<<16)	/* DP=EXT1, priority=4 */
+#define EXT1Pri3QIDM_OFFSET			12	/* DP=EXT1, priority=3 */
+#define EXT1Pri3QIDM_MASK			(7<<12)	/* DP=EXT1, priority=3 */
+#define EXT1Pri2QIDM_OFFSET			8	/* DP=EXT1, priority=2 */
+#define EXT1Pri2QIDM_MASK			(7<<8)	/* DP=EXT1, priority=2 */
+#define EXT1Pri1QIDM_OFFSET			4	/* DP=EXT1, priority=1 */
+#define EXT1Pri1QIDM_MASK			(7<<4)	/* DP=EXT1, priority=1 */
+#define EXT1Pri0QIDM_OFFSET			0	/* DP=EXT1, priority=0 */
+#define EXT1Pri0QIDM_MASK			(7<<0)	/* DP=EXT1, priority=0 */
+
+/* CPUQIDMCR1 - CPU port QID Mapping Control Register (DP=EXT2) */
+#define EXT2Pri7QIDM_OFFSET			28	/* DP=EXT2, priority=7 */
+#define EXT2Pri7QIDM_MASK			(7<<28)	/* DP=EXT2, priority=7 */
+#define EXT2Pri6QIDM_OFFSET			24	/* DP=EXT2, priority=6 */
+#define EXT2Pri6QIDM_MASK			(7<<24)	/* DP=EXT2, priority=6 */
+#define EXT2Pri5QIDM_OFFSET			20	/* DP=EXT2, priority=5 */
+#define EXT2Pri5QIDM_MASK			(7<<20)	/* DP=EXT2, priority=5 */
+#define EXT2Pri4QIDM_OFFSET			16	/* DP=EXT2, priority=4 */
+#define EXT2Pri4QIDM_MASK			(7<<16)	/* DP=EXT2, priority=4 */
+#define EXT2Pri3QIDM_OFFSET			12	/* DP=EXT2, priority=3 */
+#define EXT2Pri3QIDM_MASK			(7<<12)	/* DP=EXT2, priority=3 */
+#define EXT2Pri2QIDM_OFFSET			8	/* DP=EXT2, priority=2 */
+#define EXT2Pri2QIDM_MASK			(7<<8)	/* DP=EXT2, priority=2 */
+#define EXT2Pri1QIDM_OFFSET			4	/* DP=EXT2, priority=1 */
+#define EXT2Pri1QIDM_MASK			(7<<4)	/* DP=EXT2, priority=1 */
+#define EXT2Pri0QIDM_OFFSET			0	/* DP=EXT2, priority=0 */
+#define EXT2Pri0QIDM_MASK			(7<<0)	/* DP=EXT2, priority=0 */
+
+/* CPUQIDMCR1 - CPU port QID Mapping Control Register (DP=MultiEXT) */
+#define MultiEXTPri7QIDM_OFFSET			28	/* DP=multi-port of Ext port, priority=7 */
+#define MultiEXTPri7QIDM_MASK			(7<<28)	/* DP=multi-port of Ext port, priority=7 */
+#define MultiEXTPri6QIDM_OFFSET			24	/* DP=multi-port of Ext port, priority=6 */
+#define MultiEXTPri6QIDM_MASK			(7<<24)	/* DP=multi-port of Ext port, priority=6 */
+#define MultiEXTPri5QIDM_OFFSET			20	/* DP=multi-port of Ext port, priority=5 */
+#define MultiEXTPri5QIDM_MASK			(7<<20)	/* DP=multi-port of Ext port, priority=5 */
+#define MultiEXTPri4QIDM_OFFSET			16	/* DP=multi-port of Ext port, priority=4 */
+#define MultiEXTPri4QIDM_MASK			(7<<16)	/* DP=multi-port of Ext port, priority=4 */
+#define MultiEXTPri3QIDM_OFFSET			12	/* DP=multi-port of Ext port, priority=3 */
+#define MultiEXTPri3QIDM_MASK			(7<<12)	/* DP=multi-port of Ext port, priority=3 */
+#define MultiEXTPri2QIDM_OFFSET			8	/* DP=multi-port of Ext port, priority=2 */
+#define MultiEXTPri2QIDM_MASK			(7<<8)	/* DP=multi-port of Ext port, priority=2 */
+#define MultiEXTPri1QIDM_OFFSET			4	/* DP=multi-port of Ext port, priority=1 */
+#define MultiEXTPri1QIDM_MASK			(7<<4)	/* DP=multi-port of Ext port, priority=1 */
+#define MultiEXTPri0QIDM_OFFSET			0	/* DP=multi-port of Ext port, priority=0 */
+#define MultiEXTPri0QIDM_MASK			(7<<0)	/* DP=multi-port of Ext port, priority=0 */
+
+/* RMCR1P - 802.1P	Remarking Control Register 0 */
+#define RM1P_EN_OFFSET				(24)	/* Enable 802.1p remarking for destination port[7:0] */
+#define RM1P_EN_MASK				(0xff<<24)	/* Enable 802.1p remarking for destination port */
+#define RM7_1P_OFFSET				(21)	/* New 3-bit priority for system parsed priority 7 */
+#define RM7_1P_MASK				(0x7<<21)	/* New 3-bit priority for system parsed priority 7 */
+#define RM6_1P_OFFSET				(18)	/* New 3-bit priority for system parsed priority 6 */
+#define RM6_1P_MASK				(0x7<<18)	/* New 3-bit priority for system parsed priority 6 */
+#define RM5_1P_OFFSET				(15)	/* New 3-bit priority for system parsed priority 5 */
+#define RM5_1P_MASK				(0x7<<15)	/* New 3-bit priority for system parsed priority 5 */
+#define RM4_1P_OFFSET				(12)	/* New 3-bit priority for system parsed priority 4 */
+#define RM4_1P_MASK				(0x7<<12)	/* New 3-bit priority for system parsed priority 4 */
+#define RM3_1P_OFFSET				( 9)	/* New 3-bit priority for system parsed priority 3 */
+#define RM3_1P_MASK				(0x7<< 9)	/* New 3-bit priority for system parsed priority 3 */
+#define RM2_1P_OFFSET				( 6)	/* New 3-bit priority for system parsed priority 2 */
+#define RM2_1P_MASK				(0x7<< 6)	/* New 3-bit priority for system parsed priority 2 */
+#define RM1_1P_OFFSET				( 3)	/* New 3-bit priority for system parsed priority 1 */
+#define RM1_1P_MASK				(0x7<< 3)	/* New 3-bit priority for system parsed priority 1 */
+#define RM0_1P_OFFSET				( 0)	/* New 3-bit priority for system parsed priority 0 */
+#define RM0_1P_MASK				(0x7<< 0)	/* New 3-bit priority for system parsed priority 0 */
+
+/* DSCPRM0 - DSCP Remarking Control Register 0 */
+#define RM1P_EN_8_OFFSET			(31)	/* Enable 802.1p remarking for destination port[8] */
+#define RM1P_EN_8				(1<<31)	/* Enable 802.1p remarking for destination port[8] */
+#define DSCPRM4_OFFSET				(24)	/* New 6-bit DSCP value for system parsed 3-bit priority 4 */
+#define DSCPRM4_MASK				(0x3f<<24)	/* New 6-bit DSCP value for system parsed 3-bit priority 4 */
+#define DSCPRM3_OFFSET				(18)	/* New 6-bit DSCP value for system parsed 3-bit priority 3 */
+#define DSCPRM3_MASK				(0x3f<<18)	/* New 6-bit DSCP value for system parsed 3-bit priority 3 */
+#define DSCPRM2_OFFSET				(12)	/* New 6-bit DSCP value for system parsed 3-bit priority 2 */
+#define DSCPRM2_MASK				(0x3f<<12)	/* New 6-bit DSCP value for system parsed 3-bit priority 2 */
+#define DSCPRM1_OFFSET				( 6)	/* New 6-bit DSCP value for system parsed 3-bit priority 1 */
+#define DSCPRM1_MASK				(0x3f<< 6)	/* New 6-bit DSCP value for system parsed 3-bit priority 1 */
+#define DSCPRM0_OFFSET				( 0)	/* New 6-bit DSCP value for system parsed 3-bit priority 0 */
+#define DSCPRM0_MASK				(0x3f<< 0)	/* New 6-bit DSCP value for system parsed 3-bit priority 0 */
+
+/* DSCPRM1 - DSCP Remarking Control Register 1 */
+#define DSCPRM_EN_OFFSET			(23)	/* Enable DSCP Remark for destination output port[8:0] */
+#define DSCPRM_EN_MASK				(0x1ff<<23)	/* Enable DSCP Remark for destination output port */
+#define DSCPRM7_OFFSET				(12)	/* New 6-bit DSCP value for system parsed 3-bit priority 7 */
+#define DSCPRM7_MASK				(0x3f<<12)	/* New 6-bit DSCP value for system parsed 3-bit priority 7 */
+#define DSCPRM6_OFFSET				( 6)	/* New 6-bit DSCP value for system parsed 3-bit priority 6 */
+#define DSCPRM6_MASK				(0x3f<< 6)	/* New 6-bit DSCP value for system parsed 3-bit priority 6 */
+#define DSCPRM5_OFFSET				( 0)	/* New 6-bit DSCP value for system parsed 3-bit priority 5 */
+#define DSCPRM5_MASK				(0x3f<< 0)	/* New 6-bit DSCP value for system parsed 3-bit priority 5 */
+
+/* RLRC - Remarking Layer Rule Control */
+#define RMLC_DSCP_L4				(1<<5)	/* Applied on L4 Operation */
+#define RMLC_DSCP_L3				(1<<4)	/* Applied on L3 Operation */
+#define RMLC_DSCP_L2				(1<<3)	/* Applied on L2 Operation */
+#define RMLC_8021P_L4				(1<<2)	/* Applied on L4 Operation */
+#define RMLC_8021P_L3				(1<<1)	/* Applied on L3 Operation */
+#define RMLC_8021P_L2				(1<<0)	/* Applied on L2 Operation */
+
+/*
+ * Packet Scheduling Control Register */
+#define PSCR					(SWCORE_BASE + 0x4800)
+#define P0Q0RGCR				(0x000 + PSCR)	/* Rate Guarantee Control Register of Port 0 Queue 0 */
+#define P0Q1RGCR				(0x004 + PSCR)	/* Rate Guarantee Control Register of Port 0 Queue 1 */
+#define P0Q2RGCR				(0x008 + PSCR)	/* Rate Guarantee Control Register of Port 0 Queue 2 */
+#define P0Q3RGCR				(0x00C + PSCR)	/* Rate Guarantee Control Register of Port 0 Queue 3 */
+#define P0Q4RGCR				(0x010 + PSCR)	/* Rate Guarantee Control Register of Port 0 Queue 4 */
+#define P0Q5RGCR				(0x014 + PSCR)	/* Rate Guarantee Control Register of Port 0 Queue 5 */
+#define P1Q0RGCR				(0x018 + PSCR)	/* Rate Guarantee Control Register of Port 1 Queue 0 */
+#define P1Q1RGCR				(0x01C + PSCR)	/* Rate Guarantee Control Register of Port 1 Queue 1 */
+#define P1Q2RGCR				(0x020 + PSCR)	/* Rate Guarantee Control Register of Port 1 Queue 2 */
+#define P1Q3RGCR				(0x024 + PSCR)	/* Rate Guarantee Control Register of Port 1 Queue 3 */
+#define P1Q4RGCR				(0x028 + PSCR)	/* Rate Guarantee Control Register of Port 1 Queue 4 */
+#define P1Q5RGCR				(0x02C + PSCR)	/* Rate Guarantee Control Register of Port 1 Queue 5 */
+#define P2Q0RGCR				(0x030 + PSCR)	/* Rate Guarantee Control Register of Port 2 Queue 0 */
+#define P2Q1RGCR				(0x034 + PSCR)	/* Rate Guarantee Control Register of Port 2 Queue 1 */
+#define P2Q2RGCR				(0x038 + PSCR)	/* Rate Guarantee Control Register of Port 2 Queue 2 */
+#define P2Q3RGCR				(0x03C + PSCR)	/* Rate Guarantee Control Register of Port 2 Queue 3 */
+#define P2Q4RGCR				(0x040 + PSCR)	/* Rate Guarantee Control Register of Port 2 Queue 4 */
+#define P2Q5RGCR				(0x044 + PSCR)	/* Rate Guarantee Control Register of Port 2 Queue 5 */
+#define P3Q0RGCR				(0x048 + PSCR)	/* Rate Guarantee Control Register of Port 3 Queue 0 */
+#define P3Q1RGCR				(0x04C + PSCR)	/* Rate Guarantee Control Register of Port 3 Queue 1 */
+#define P3Q2RGCR				(0x050 + PSCR)	/* Rate Guarantee Control Register of Port 3 Queue 2 */
+#define P3Q3RGCR				(0x054 + PSCR)	/* Rate Guarantee Control Register of Port 3 Queue 3 */
+#define P3Q4RGCR				(0x058 + PSCR)	/* Rate Guarantee Control Register of Port 3 Queue 4 */
+#define P3Q5RGCR				(0x05C + PSCR)	/* Rate Guarantee Control Register of Port 3 Queue 5 */
+#define P4Q0RGCR				(0x060 + PSCR)	/* Rate Guarantee Control Register of Port 4 Queue 0 */
+#define P4Q1RGCR				(0x064 + PSCR)	/* Rate Guarantee Control Register of Port 4 Queue 1 */
+#define P4Q2RGCR				(0x068 + PSCR)	/* Rate Guarantee Control Register of Port 4 Queue 2 */
+#define P4Q3RGCR				(0x06C + PSCR)	/* Rate Guarantee Control Register of Port 4 Queue 3 */
+#define P4Q4RGCR				(0x070 + PSCR)	/* Rate Guarantee Control Register of Port 4 Queue 4 */
+#define P4Q5RGCR				(0x074 + PSCR)	/* Rate Guarantee Control Register of Port 4 Queue 5 */
+#define P5Q0RGCR				(0x078 + PSCR)	/* Rate Guarantee Control Register of Port 5 Queue 0 */
+#define P5Q1RGCR				(0x07C + PSCR)	/* Rate Guarantee Control Register of Port 5 Queue 1 */
+#define P5Q2RGCR				(0x080 + PSCR)	/* Rate Guarantee Control Register of Port 5 Queue 2 */
+#define P5Q3RGCR				(0x084 + PSCR)	/* Rate Guarantee Control Register of Port 5 Queue 3 */
+#define P5Q4RGCR				(0x088 + PSCR)	/* Rate Guarantee Control Register of Port 5 Queue 4 */
+#define P5Q5RGCR				(0x08C + PSCR)	/* Rate Guarantee Control Register of Port 5 Queue 5 */
+#define P6Q0RGCR				(0x090 + PSCR)	/* Rate Guarantee Control Register of Port 6 Queue 0 */
+#define P6Q1RGCR				(0x094 + PSCR)	/* Rate Guarantee Control Register of Port 6 Queue 1 */
+#define P6Q2RGCR				(0x098 + PSCR)	/* Rate Guarantee Control Register of Port 6 Queue 2 */
+#define P6Q3RGCR				(0x09C + PSCR)	/* Rate Guarantee Control Register of Port 6 Queue 3 */
+#define P6Q4RGCR				(0x0A0 + PSCR)	/* Rate Guarantee Control Register of Port 6 Queue 4 */
+#define P6Q5RGCR				(0x0A4 + PSCR)	/* Rate Guarantee Control Register of Port 6 Queue 5 */
+#define WFQRCRP0				(0x0B0 + PSCR)	/* Weighted Fair Queue Rate Control Register of Port 0 */
+#define WFQWCR0P0				(0x0B4 + PSCR)	/* Weighted Fair Queue Weighting Control Register 0 of Port 0 */
+#define WFQWCR1P0				(0x0B8 + PSCR)	/* Weighted Fair Queue Weighting Control Register 1 of Port 0 */
+#define WFQRCRP1				(0x0BC + PSCR)	/* Weighted Fair Queue Rate Control Register of Port 1 */
+#define WFQWCR0P1				(0x0C0 + PSCR)	/* Weighted Fair Queue Weighting Control Register 0 of Port 1 */
+#define WFQWCR1P1				(0x0C4 + PSCR)	/* Weighted Fair Queue Weighting Control Register 1 of Port 1 */
+#define WFQRCRP2				(0x0C8 + PSCR)	/* Weighted Fair Queue Rate Control Register of Port 2 */
+#define WFQWCR0P2				(0x0CC + PSCR)	/* Weighted Fair Queue Weighting Control Register 0 of Port 2 */
+#define WFQWCR1P2				(0x0D0 + PSCR)	/* Weighted Fair Queue Weighting Control Register 1 of Port 2 */
+#define WFQRCRP3				(0x0D4 + PSCR)	/* Weighted Fair Queue Rate Control Register of Port 3 */
+#define WFQWCR0P3				(0x0D8 + PSCR)	/* Weighted Fair Queue Weighting Control Register 0 of Port 3 */
+#define WFQWCR1P3				(0x0DC + PSCR)	/* Weighted Fair Queue Weighting Control Register 1 of Port 3 */
+#define WFQRCRP4				(0x0E0 + PSCR)	/* Weighted Fair Queue Rate Control Register of Port 4 */
+#define WFQWCR0P4				(0x0E4 + PSCR)	/* Weighted Fair Queue Weighting Control Register 0 of Port 4 */
+#define WFQWCR1P4				(0x0E8 + PSCR)	/* Weighted Fair Queue Weighting Control Register 1 of Port 4 */
+#define WFQRCRP5				(0x0EC + PSCR)	/* Weighted Fair Queue Rate Control Register of Port 5 */
+#define WFQWCR0P5				(0x0F0 + PSCR)	/* Weighted Fair Queue Weighting Control Register 0 of Port 5 */
+#define WFQWCR1P5				(0x0F4 + PSCR)	/* Weighted Fair Queue Weighting Control Register 1 of Port 5 */
+#define WFQRCRP6				(0x0F8 + PSCR)	/* Weighted Fair Queue Rate Control Register of Port 6 */
+#define WFQWCR0P6				(0x0FC + PSCR)	/* Weighted Fair Queue Weighting Control Register 0 of Port 6 */
+#define WFQWCR1P6				(0x100 + PSCR)	/* Weighted Fair Queue Weighting Control Register 1 of Port 6 */
+#define ELBPCR					(0x104 + PSCR)	/* Leaky Bucket Parameter Control Register */
+#define ELBTTCR					(0x108 + PSCR)	/* Leaky Bucket Token Threshold Control Register */
+#define ILBPCR1					(0x10C + PSCR)	/* Ingress Leaky Bucket Parameter Control Register1 */
+#define ILBPCR2					(0x110 + PSCR)	/* Ingress Leaky Bucket Parameter Control Register2 */
+#define ILB_CURRENT_TOKEN			(0x114 + PSCR)	/* The current token of the Leaky bucket 2Bytes per port(Port 0~Port5) */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define PSCR98C					(SWCORE_BASE + 0x5000)
+#define P0Q6RGCR				(0x0A8 + PSCR98C)	/* Rate Guarantee Control Register of Port 0 Queue 6 */
+#define P0Q7RGCR				(0x0AC + PSCR98C)	/* Rate Guarantee Control Register of Port 0 Queue 7 */
+#define P1Q6RGCR				(0x0B0 + PSCR98C)	/* Rate Guarantee Control Register of Port 1 Queue 6 */
+#define P1Q7RGCR				(0x0B4 + PSCR98C)	/* Rate Guarantee Control Register of Port 1 Queue 7 */
+#define P2Q6RGCR				(0x0B8 + PSCR98C)	/* Rate Guarantee Control Register of Port 2 Queue 6 */
+#define P2Q7RGCR				(0x0BC + PSCR98C)	/* Rate Guarantee Control Register of Port 2 Queue 7 */
+#define P3Q6RGCR				(0x0C0 + PSCR98C)	/* Rate Guarantee Control Register of Port 3 Queue 6 */
+#define P3Q7RGCR				(0x0C4 + PSCR98C)	/* Rate Guarantee Control Register of Port 3 Queue 7 */
+#define P4Q6RGCR				(0x0C8 + PSCR98C)	/* Rate Guarantee Control Register of Port 4 Queue 6 */
+#define P4Q7RGCR				(0x0CC + PSCR98C)	/* Rate Guarantee Control Register of Port 4 Queue 7 */
+#define P5Q6RGCR				(0x0D0 + PSCR98C)	/* Rate Guarantee Control Register of Port 5 Queue 6 */
+#define P5Q7RGCR				(0x0D4 + PSCR98C)	/* Rate Guarantee Control Register of Port 5 Queue 7 */
+#define P6Q6RGCR				(0x0D8 + PSCR98C)	/* Rate Guarantee Control Register of Port 6 Queue 6 */
+#define P6Q7RGCR				(0x0DC + PSCR98C)	/* Rate Guarantee Control Register of Port 6 Queue 7 */
+
+#define WFQWCR1P0_98C				(0x08C + PSCR98C)	/* Weighted Fair Queue Weighting Control Register 1 of Port 0 Queue6/7 */
+#define WFQWCR1P1_98C				(0x090 + PSCR98C)	/* Weighted Fair Queue Weighting Control Register 1 of Port 1 Queue6/7 */
+#define WFQWCR1P2_98C				(0x094 + PSCR98C)	/* Weighted Fair Queue Weighting Control Register 1 of Port 2 Queue6/7 */
+#define WFQWCR1P3_98C				(0x098 + PSCR98C)	/* Weighted Fair Queue Weighting Control Register 1 of Port 3 Queue6/7 */
+#define WFQWCR1P4_98C				(0x09C + PSCR98C)	/* Weighted Fair Queue Weighting Control Register 1 of Port 4 Queue6/7 */
+#define WFQWCR1P5_98C				(0x0A0 + PSCR98C)	/* Weighted Fair Queue Weighting Control Register 1 of Port 5 Queue6/7 */
+#define WFQWCR1P6_98C				(0x0A4 + PSCR98C)	/* Weighted Fair Queue Weighting Control Register 1 of Port 6 Queue6/7 */
+
+#endif
+
+/* P0Q0RGCG - Per-Queue Rate Guarantee Control Register */
+#if defined(CONFIG_RTL_8197F)
+#define PPR_OFFSET				(28)	/* Peak Packet Rate, in times of APR            CNT2 */
+#define PPR_MASK				(7<<28)	/* Peak Packet Rate, in times of APR            CNT2 */
+#define L1_OFFSET				(20)	/* Bucket burst size of APR. unit: 1KB          MAX      */
+#define L1_MASK					(0xff<<20)	/* Bucket burst size of APR. unit: 1KB          MAX      */
+#define APR_OFFSET				(0)	/* Average Packet Rate, in times of 1Kbps       CNT1 */
+#define APR_MASK				(0xFFFFF<<0)
+#else
+#define PPR_OFFSET				(24)	/* Peak Packet Rate, in times of APR            CNT2 */
+#define PPR_MASK				(7<<24)	/* Peak Packet Rate, in times of APR            CNT2 */
+#define L1_OFFSET				(16)	/* Bucket burst size of APR. unit: 1KB          MAX      */
+#define L1_MASK					(0xff<<16)	/* Bucket burst size of APR. unit: 1KB          MAX      */
+#define APR_OFFSET				(0)	/* Average Packet Rate, in times of 64Kbps      CNT1 */
+#define APR_MASK				(0x3FFF<<0)	/* Average Packet Rate, in times of 64Kbps      CNT1 */
+#endif
+
+/* WFQECR0P0 - Weighted Fair Queue Weighting Control Register 0 */
+#define SCHE3_WFQ				(1<<31)	/* Schedule Type for Queue 3: 1-WFQ ,0-Strict Priority */
+#define SCHE3_OFFSET				(31)	/* Schedule Type for Queue 3: 1-WFQ ,0-Strict Priority */
+#define SCHE3_MASK				(1<<31)	/* Schedule Type for Queue 3: 1-WFQ ,0-Strict Priority */
+#define WEIGHT3_OFFSET				(24)	/* Weight value assign of queue 3 for WFQ */
+#define WEIGHT3_MASK				(0x7f<<24)	/* Weight value assign of queue 3 for WFQ */
+#define SCHE2_WFQ				(1<<23)	/* Schedule Type for Queue 2: 1-WFQ ,0-Strict Priority */
+#define SCHE2_OFFSET				(23)	/* Schedule Type for Queue 2: 1-WFQ ,0-Strict Priority */
+#define SCHE2_MASK				(1<<23)	/* Schedule Type for Queue 2: 1-WFQ ,0-Strict Priority */
+#define WEIGHT2_OFFSET				(16)	/* Weight value assign of queue 2 for WFQ */
+#define WEIGHT2_MASK				(0x7f<<16)	/* Weight value assign of queue 2 for WFQ */
+#define SCHE1_WFQ				(1<<15)	/* Schedule Type for Queue 1: 1-WFQ ,0-Strict Priority */
+#define SCHE1_OFFSET				(15)	/* Schedule Type for Queue 1: 1-WFQ ,0-Strict Priority */
+#define SCHE1_MASK				(1<<15)	/* Schedule Type for Queue 1: 1-WFQ ,0-Strict Priority */
+#define WEIGHT1_OFFSET				( 8)	/* Weight value assign of queue 1 for WFQ */
+#define WEIGHT1_MASK				(0x7f<< 8)	/* Weight value assign of queue 1 for WFQ */
+#define SCHE0_WFQ				(1<<7)	/* Schedule Type for Queue 0: 1-WFQ ,0-Strict Priority */
+#define SCHE0_OFFSET				( 7)	/* Schedule Type for Queue 0: 1-WFQ ,0-Strict Priority */
+#define SCHE0_MASK				(1<<7)	/* Schedule Type for Queue 0: 1-WFQ ,0-Strict Priority */
+#define WEIGHT0_OFFSET				( 0)	/* Weight value assign of queue 0 for WFQ */
+#define WEIGHT0_MASK				(0x7f<< 0)	/* Weight value assign of queue 0 for WFQ */
+/* WFQECR0P0 - Weighted Fair Queue Weighting Control Register 1 */
+#define SCHE5_WFQ				(1<<15)	/* Schedule Type for Queue 5: 1-WFQ ,0-Strict Priority */
+#define SCHE5_OFFSET				(15)	/* Schedule Type for Queue 5: 1-WFQ ,0-Strict Priority */
+#define SCHE5_MASK				(1<<15)	/* Schedule Type for Queue 5: 1-WFQ ,0-Strict Priority */
+#define WEIGHT5_OFFSET				( 8)	/* Weight value assign of queue 5 for WFQ */
+#define WEIGHT5_MASK				(0x7f<< 8)	/* Weight value assign of queue 5 for WFQ */
+#define SCHE4_WFQ				(1<< 7)	/* Schedule Type for Queue 4: 1-WFQ ,0-Strict Priority */
+#define SCHE4_OFFSET				( 7)	/* Schedule Type for Queue 4: 1-WFQ ,0-Strict Priority */
+#define SCHE4_MASK				(1<< 7)	/* Schedule Type for Queue 4: 1-WFQ ,0-Strict Priority */
+#define WEIGHT4_OFFSET				( 0)	/* Weight value assign of queue 4 for WFQ */
+#define WEIGHT4_MASK				(0x7f<< 0)	/* Weight value assign of queue 4 for WFQ */
+
+/* ELBPCR - Egress Leaky Bucket Parameter Control Register */
+#define Token_OFFSET				(8)	/* Token used for adding budget in each time slot. */
+#define Token_MASK				(0xff<<8)	/* Token used for adding budget in each time slot. */
+#define Tick_OFFSET				(0)	/* Tick used for time slot size unit */
+#define Tick_MASK				(0xff<<0)	/* Tick used for time slot size unit */
+
+/* ELBTTCR - Egress Leaky Bucket Token Threshold Control Register */
+#define L2_OFFSET				(0)	/* leaky Bucket Token Hi-threshold register */
+#if 0				/* conflict with flagDef.h */
+#define L2_MASK					(0xffff<<0)	/* leaky Bucket Token Hi-threshold register */
+#endif
+
+/* ILBPCR1 - Ingress Leaky Bucket Parameter Control Register 1 */
+#define UpperBound_OFFSET			(16)	/* Ingress BWC Parameter Upper bound Threshold (unit: 400bytes) */
+#define UpperBound_MASK				(0xffff<<16)	/* Ingress BWC Parameter Upper bound Threshold (unit: 400bytes) */
+#define LowerBound_OFFSET			(0)	/* Ingress BWC Parameter Lower Bound Threshold (unit: 400 bytes) */
+#define LowerBound_MASK				(0xffff<<0)	/* Ingress BWC Parameter Lower Bound Threshold (unit: 400 bytes) */
+
+/* ILBPCR2 - Ingress Leaky Bucket Parameter Control Register 2 */
+#define ILB_feedToken_OFFSET			(8)	/* Token is used for adding budget in each time slot */
+#define ILB_feedToken_MASK			(0xff<<8)	/* Token is used for adding budget in each time slot */
+#define ILB_Tick_OFFSET				(0)	/* Tick is used for time slot size unit. */
+#define ILB_Tick_MASK				(0xff<<0)	/* Tick is used for time slot size unit. */
+
+#define VCR0					(0x00 +0x4A00+SWCORE_BASE)	/* Vlan Control register */
+#define VCR1					(0x04 +0x4A00+SWCORE_BASE)	/* Vlan Control register */
+#define PVCR0					(0x08 +0x4A00+SWCORE_BASE)	/* port base control register */
+#define PVCR1					(0x0C +0x4A00+SWCORE_BASE)	/* port base control register */
+#define PVCR2					(0x10 +0x4A00+SWCORE_BASE)	/* port base control register */
+#define PVCR3					(0x14 +0x4A00+SWCORE_BASE)	/* port base control register */
+#define PVCR4					(0x18 +0x4A00+SWCORE_BASE)	/* port base control register */
+#define PBVCR0					(0x1C +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Control Register 0      */
+#define PBVCR1					(0x20 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Control Register 1          */
+#define PBVR0_0					(0x24 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 0 -- IPX                   */
+#define PBVR0_1					(0x28 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 0 -- IPX                   */
+#define PBVR0_2					(0x2C +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 0 -- IPX                   */
+#define PBVR0_3					(0x30 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 0 -- IPX                   */
+#define PBVR0_4					(0x34 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 0 -- IPX                   */
+#define PBVR1_0					(0x38 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 1 NetBIOS           */
+#define PBVR1_1					(0x3C +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 1 NetBIOS           */
+#define PBVR1_2					(0x40 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 1 NetBIOS           */
+#define PBVR1_3					(0x44 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 1 NetBIOS           */
+#define PBVR1_4					(0x48 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 1 NetBIOS           */
+#define PBVR2_0					(0x4C +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 2 PPPoE Control               */
+#define PBVR2_1					(0x50 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 2 PPPoE Control              */
+#define PBVR2_2					(0x54 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 2 PPPoE Control               */
+#define PBVR2_3					(0x58 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 2 PPPoE Control               */
+#define PBVR2_4					(0x5C +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 2 PPPoE Control               */
+#define PBVR3_0					(0x60 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 3 PPPoE session               */
+#define PBVR3_1					(0x64 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 3 PPPoE session              */
+#define PBVR3_2					(0x68 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 3 PPPoE session               */
+#define PBVR3_3					(0x6C +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 3 PPPoE session               */
+#define PBVR3_4					(0x70 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 3 PPPoE session        */
+#define PBVR4_0					(0x74 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 4 User-defined 1       */
+#define PBVR4_1					(0x78 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 4 User-defined 1      */
+#define PBVR4_2					(0x7C +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 4 User-defined 1       */
+#define PBVR4_3					(0x80 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 4 User-defined 1       */
+#define PBVR4_4					(0x84 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 4 User-defined 1       */
+#define PBVR5_0					(0x88 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 4 User-defined 2       */
+#define PBVR5_1					(0x8C +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 4 User-defined 2     */
+#define PBVR5_2					(0x90 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 4 User-defined 2       */
+#define PBVR5_3					(0x94 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 4 User-defined 2       */
+#define PBVR5_4					(0x98 +0x4A00+SWCORE_BASE)	/* Protocol-Based VLAN Rule 4 User-defined 2       */
+
+/* VCR0 - Vlan Control register */
+#define En1QtagVIDignore			(1<<31)	/* Enable 1Q vlan unware */
+#define EN_1QTAGVIDIGNORE			En1QtagVIDignore	/* Alias Name */
+#define P8_AcptFType_OFFSET			25	/* Accept Frame Type for VLAN ingress control (Ext2) */
+#define P8_AcptFType_MASK			(3<<25)	/* Accept Frame Type for VLAN ingress control (Ext2) */
+#define P8_AcptFType_AdmitAllFrame		(0<<25)	/* Accept tagged and untagged frame (Ext2) */
+#define P8_AcptFType_AdmitTaggedOnly		(1<<25)	/* Accept tagged frame only (Ext2) */
+#define P8_AcptFType_AdmitUntagged		(2<<25)	/* Accept untagged frame and priority tag frame (Ext2) */
+#define P7_AcptFType_OFFSET			23	/* Accept Frame Type for VLAN ingress control (Ext1) */
+#define P7_AcptFType_MASK			(3<<23)	/* Accept Frame Type for VLAN ingress control (Ext1) */
+#define P7_AcptFType_AdmitAllFrame		(0<<23)	/* Accept tagged and untagged frame (Ext1) */
+#define P7_AcptFType_AdmitTaggedOnly		(1<<23)	/* Accept tagged frame only (Ext1) */
+#define P7_AcptFType_AdmitUntagged		(2<<23)	/* Accept untagged frame and priority tag frame (Ext1) */
+#define P6_AcptFType_OFFSET			21	/* Accept Frame Type for VLAN ingress control (Ext0) */
+#define P6_AcptFType_MASK			(3<<21)	/* Accept Frame Type for VLAN ingress control (Ext0) */
+#define P6_AcptFType_AdmitAllFrame		(0<<21)	/* Accept tagged and untagged frame (Ext0) */
+#define P6_AcptFType_AdmitTaggedOnly		(1<<21)	/* Accept tagged frame only (Ext0) */
+#define P6_AcptFType_AdmitUntagged		(2<<21)	/* Accept untagged frame and priority tag frame (Ext0) */
+#define P5_AcptFType_OFFSET			19	/* Accept Frame Type for VLAN ingress control */
+#define P5_AcptFType_MASK			(3<<19)	/* Accept Frame Type for VLAN ingress control */
+#define P5_AcptFType_AdmitAllFrame		(0<<19)	/* Accept tagged and untagged frame */
+#define P5_AcptFType_AdmitTaggedOnly		(1<<19)	/* Accept tagged frame only */
+#define P5_AcptFType_AdmitUntagged		(2<<19)	/* Accept untagged frame and priority tag frame */
+#define P4_AcptFType_OFFSET			17	/* Accept Frame Type for VLAN ingress control */
+#define P4_AcptFType_MASK			(3<<17)	/* Accept Frame Type for VLAN ingress control */
+#define P4_AcptFType_AdmitAllFrame		(0<<17)	/* Accept tagged and untagged frame */
+#define P4_AcptFType_AdmitTaggedOnly		(1<<17)	/* Accept tagged frame only */
+#define P4_AcptFType_AdmitUntagged		(2<<17)	/* Accept untagged frame and priority tag frame */
+#define P3_AcptFType_OFFSET			15	/* Accept Frame Type for VLAN ingress control */
+#define P3_AcptFType_MASK			(3<<15)	/* Accept Frame Type for VLAN ingress control */
+#define P3_AcptFType_AdmitAllFrame		(0<<15)	/* Accept tagged and untagged frame */
+#define P3_AcptFType_AdmitTaggedOnly		(1<<15)	/* Accept tagged frame only */
+#define P3_AcptFType_AdmitUntagged		(2<<15)	/* Accept untagged frame and priority tag frame */
+#define P2_AcptFType_OFFSET			13	/* Accept Frame Type for VLAN ingress control */
+#define P2_AcptFType_MASK			(3<<13)	/* Accept Frame Type for VLAN ingress control */
+#define P2_AcptFType_AdmitAllFrame		(0<<13)	/* Accept tagged and untagged frame */
+#define P2_AcptFType_AdmitTaggedOnly		(1<<13)	/* Accept tagged frame only */
+#define P2_AcptFType_AdmitUntagged		(2<<13)	/* Accept untagged frame and priority tag frame */
+#define P1_AcptFType_OFFSET			11	/* Accept Frame Type for VLAN ingress control */
+#define P1_AcptFType_MASK			(3<<11)	/* Accept Frame Type for VLAN ingress control */
+#define P1_AcptFType_AdmitAllFrame		(0<<11)	/* Accept tagged and untagged frame */
+#define P1_AcptFType_AdmitTaggedOnly		(1<<11)	/* Accept tagged frame only */
+#define P1_AcptFType_AdmitUntagged		(2<<11)	/* Accept untagged frame and priority tag frame */
+#define P0_AcptFType_OFFSET			9	/* Accept Frame Type for VLAN ingress control */
+#define P0_AcptFType_MASK			(3<<9)	/* Accept Frame Type for VLAN ingress control */
+#define P0_AcptFType_AdmitAllFrame		(0<<9)	/* Accept tagged and untagged frame */
+#define P0_AcptFType_AdmitTaggedOnly		(1<<9)	/* Accept tagged frame only */
+#define P0_AcptFType_AdmitUntagged		(2<<9)	/* Accept untagged frame and priority tag frame */
+#define EnVlanInF_OFFSET			0	/* Enable Vlan Ingress Filtering */
+#define EnVlanInF_MASK				(0x1ff<<0)	/* Enable Vlan Ingress Filtering */
+#define EN_VLAN_INGRESS_FILTER			(1)	/* Backward compatible for EnVlanInF */
+#define EN_ALL_PORT_VLAN_INGRESS_FILTER		EnVlanInF_MASK	/* Alias Name */
+
+/* PVCR0, PVCR1, PVCR2, PVCR3, PVCR4 - Port-Based VLAN Control Register */
+#define PVIDP0_OFFSET				0	/* Default PVID for Port 0 */
+#define PVIDP0_MASK				(0xfff<< 0)	/* Default PVID for Port 0 */
+#define DPRIOP0_OFFSET				12	/* Default Port Priority for Port 0 */
+#define DPRIOP0_MASK				(7<<12)	/* Default Port Priority for Port 0 */
+#define PVIDP1_OFFSET				16	/* Default PVID for Port 1 */
+#define PVIDP1_MASK				(0xfff<<16)	/* Default PVID for Port 1 */
+#define DPRIOP1_OFFSET				28	/* Default Port Priority for Port 1 */
+#define DPRIOP1_MASK				(7<<28)	/* Default Port Priority for Port 1 */
+#define PVIDP2_OFFSET				0	/* Default PVID for Port 2 */
+#define PVIDP2_MASK				(0xfff<< 0)	/* Default PVID for Port 2 */
+#define DPRIOP2_OFFSET				12	/* Default Port Priority for Port 2 */
+#define DPRIOP2_MASK				(7<<12)	/* Default Port Priority for Port 2 */
+#define PVIDP3_OFFSET				16	/* Default PVID for Port 3 */
+#define PVIDP3_MASK				(0xfff<<16)	/* Default PVID for Port 3 */
+#define DPRIOP3_OFFSET				28	/* Default Port Priority for Port 3 */
+#define DPRIOP3_MASK				(7<<28)	/* Default Port Priority for Port 3 */
+#define PVIDP4_OFFSET				0	/* Default PVID for Port 4 */
+#define PVIDP4_MASK				(0xfff<< 0)	/* Default PVID for Port 4 */
+#define DPRIOP4_OFFSET				12	/* Default Port Priority for Port 4 */
+#define DPRIOP4_MASK				(7<<12)	/* Default Port Priority for Port 4 */
+#define PVIDP5_OFFSET				16	/* Default PVID for Port 5 */
+#define PVIDP5_MASK				(0xfff<<16)	/* Default PVID for Port 5 */
+#define DPRIOP5_OFFSET				28	/* Default Port Priority for Port 5 */
+#define DPRIOP5_MASK				(7<<28)	/* Default Port Priority for Port 5 */
+#define PVIDP6_OFFSET				0	/* Default PVID for Port 6 */
+#define PVIDP6_MASK				(0xfff<< 0)	/* Default PVID for Port 6 */
+#define DPRIOP6_OFFSET				12	/* Default Port Priority for Port 6 */
+#define DPRIOP6_MASK				(7<<12)	/* Default Port Priority for Port 6 */
+#define PVIDP7_OFFSET				16	/* Default PVID for Port 7 */
+#define PVIDP7_MASK				(0xfff<<16)	/* Default PVID for Port 7 */
+#define DPRIOP7_OFFSET				28	/* Default Port Priority for Port 7 */
+#define DPRIOP7_MASK				(7<<28)	/* Default Port Priority for Port 7 */
+#define PVIDP8_OFFSET				0	/* Default PVID for Port 8 */
+#define PVIDP8_MASK				(0xfff<< 0)	/* Default PVID for Port 8 */
+#define DPRIOP8_OFFSET				12	/* Default Port Priority for Port 8 */
+#define DPRIOP8_MASK				(7<<12)	/* Default Port Priority for Port 8 */
+
+/*
+ * 802.1X Control Register */
+#define DOT1X_BASE				(SWCORE_BASE + 0x4B00)
+#define DOT1XPORTCR				(0x00 +DOT1X_BASE)	/* 802.1X port base control register */
+#define DOT1XMACCR				(0x04 +DOT1X_BASE)	/* 802.1X mac base control register */
+#define GVGCR					(0x08 +DOT1X_BASE)	/* Guest VLAN registerr */
+
+#define DOT1X_DIR_BOTH				0	/* Bi-directional */
+#define DOT1X_DIR_IN				1	/* only filter IN */
+#define DOT1X_UNAUTH				0	/* Un-auth */
+#define DOT1X_AUTH				1	/* Auth */
+#define DOT1X_DISABLE				0	/* Disable */
+#define DOT1X_ENABLE				1	/* Enable */
+
+/* DOT1XPORTCR - 802.1X port base control register */
+#define Dot1XPB_P8OPDIR				(1<<26)	/* Uni/Bi-directional Control Type for Port 8. 0:BOTH, 1:IN */
+#define Dot1XPB_P8Auth				(1<<25)	/* Authentication Status for Port 8. 0:Unauthorized, 1:Authorized */
+#define Dot1XPB_P8En				(1<<24)	/* Enabled/Disable Port Based Access Control for Port 8. 0:Disable, 1:Enable */
+#define Dot1XPB_P7OPDIR				(1<<23)	/* Uni/Bi-directional Control Type for Port 7. 0:BOTH, 1:IN */
+#define Dot1XPB_P7Auth				(1<<22)	/* Authentication Status for Port 7. 0:Unauthorized, 1:Authorized */
+#define Dot1XPB_P7En				(1<<21)	/* Enabled/Disable Port Based Access Control for Port 7. 0:Disable, 1:Enable */
+#define Dot1XPB_P6OPDIR				(1<<20)	/* Uni/Bi-directional Control Type for Port 6. 0:BOTH, 1:IN */
+#define Dot1XPB_P6Auth				(1<<19)	/* Authentication Status for Port 6. 0:Unauthorized, 1:Authorized */
+#define Dot1XPB_P6En				(1<<18)	/* Enabled/Disable Port Based Access Control for Port 6. 0:Disable, 1:Enable */
+#define Dot1XPB_P5OPDIR				(1<<17)	/* Uni/Bi-directional Control Type for Port 5. 0:BOTH, 1:IN */
+#define Dot1XPB_P5Auth				(1<<16)	/* Authentication Status for Port 5. 0:Unauthorized, 1:Authorized */
+#define Dot1XPB_P5En				(1<<15)	/* Enabled/Disable Port Based Access Control for Port 5. 0:Disable, 1:Enable */
+#define Dot1XPB_P4OPDIR				(1<<14)	/* Uni/Bi-directional Control Type for Port 4. 0:BOTH, 1:IN */
+#define Dot1XPB_P4Auth				(1<<13)	/* Authentication Status for Port 4. 0:Unauthorized, 1:Authorized */
+#define Dot1XPB_P4En				(1<<13)	/* Enabled/Disable Port Based Access Control for Port 4. 0:Disable, 1:Enable */
+#define Dot1XPB_P3OPDIR				(1<<11)	/* Uni/Bi-directional Control Type for Port 3. 0:BOTH, 1:IN */
+#define Dot1XPB_P3Auth				(1<<10)	/* Authentication Status for Port 3. 0:Unauthorized, 1:Authorized */
+#define Dot1XPB_P3En				(1<< 9)	/* Enabled/Disable Port Based Access Control for Port 3. 0:Disable, 1:Enable */
+#define Dot1XPB_P2OPDIR				(1<< 8)	/* Uni/Bi-directional Control Type for Port 2. 0:BOTH, 1:IN */
+#define Dot1XPB_P2Auth				(1<< 7)	/* Authentication Status for Port 2. 0:Unauthorized, 1:Authorized */
+#define Dot1XPB_P2En				(1<< 6)	/* Enabled/Disable Port Based Access Control for Port 2. 0:Disable, 1:Enable */
+#define Dot1XPB_P1OPDIR				(1<< 5)	/* Uni/Bi-directional Control Type for Port 1. 0:BOTH, 1:IN */
+#define Dot1XPB_P1Auth				(1<< 4)	/* Authentication Status for Port 1. 0:Unauthorized, 1:Authorized */
+#define Dot1XPB_P1En				(1<< 3)	/* Enabled/Disable Port Based Access Control for Port 1. 0:Disable, 1:Enable */
+#define Dot1XPB_P0OPDIR				(1<< 2)	/* Uni/Bi-directional Control Type for Port 0. 0:BOTH, 1:IN */
+#define Dot1XPB_P0Auth				(1<< 1)	/* Authentication Status for Port 0. 0:Unauthorized, 1:Authorized */
+#define Dot1XPB_P0En				(1<< 0)	/* Enabled/Disable Port Based Access Control for Port 0. 0:Disable, 1:Enable */
+
+#define Dot1XPB_POPDIR_offset(idx)		(((idx)*3) + 2)
+#define Dot1XPB_PAuth_offset(idx)		(((idx)*3) + 1)
+#define Dot1XPB_PEn_offset(idx)			((idx)*3)
+#define Dot1XPB_POPDIR(idx, dir)		((dir) << Dot1XPB_POPDIR_offset(idx))
+#define Dot1XPB_PAuth(idx, auth)		((auth) << Dot1XPB_PAuth_offset(idx))
+#define Dot1XPB_PEn(idx, en)			((en) << Dot1XPB_PEn_offset(idx))
+
+#define EN_8021X_PORT_CONTROL			Dot1XPB_P0En	/* Enable 1X Port Base Control */
+#define EN_8021X_PORT_AUTH			Dot1XPB_P0Auth	/* port authorized */
+#define EN_8021X_PORT_DIR_IN			Dot1XPB_P0OPDIR	/* Only filter In direction */
+#define EN_DOT1XPB_P0				Dot1XPB_P0En	/* Alias Name */
+#define EN_DOT1XPB_P0_AUTH			Dot1XPB_P0Auth	/* Alias Name */
+#define EN_DOT1XPB_P0_OPINDIR			Dot1XPB_P0OPDIR	/* Alias Name */
+#define EN_DOT1XPB_P1				Dot1XPB_P1En	/* Alias Name */
+#define EN_DOT1XPB_P1_AUTH			Dot1XPB_P1Auth	/* Alias Name */
+#define EN_DOT1XPB_P1_OPINDIR			Dot1XPB_P1OPDIR	/* Alias Name */
+#define EN_DOT1XPB_P2				Dot1XPB_P2En	/* Alias Name */
+#define EN_DOT1XPB_P2_AUTH			Dot1XPB_P2Auth	/* Alias Name */
+#define EN_DOT1XPB_P2_OPINDIR			Dot1XPB_P2OPDIR	/* Alias Name */
+#define EN_DOT1XPB_P3				Dot1XPB_P3En	/* Alias Name */
+#define EN_DOT1XPB_P3_AUTH			Dot1XPB_P3Auth	/* Alias Name */
+#define EN_DOT1XPB_P3_OPINDIR			Dot1XPB_P3OPDIR	/* Alias Name */
+#define EN_DOT1XPB_P4				Dot1XPB_P4En	/* Alias Name */
+#define EN_DOT1XPB_P4_AUTH			Dot1XPB_P4Auth	/* Alias Name */
+#define EN_DOT1XPB_P4_OPINDIR			Dot1XPB_P4OPDIR	/* Alias Name */
+#define EN_DOT1XPB_P5				Dot1XPB_P5En	/* Alias Name */
+#define EN_DOT1XPB_P5_AUTH			Dot1XPB_P5Auth	/* Alias Name */
+#define EN_DOT1XPB_P5_OPINDIR			Dot1XPB_P5OPDIR	/* Alias Name */
+#define EN_DOT1XPB_P6				Dot1XPB_P6En	/* Alias Name */
+#define EN_DOT1XPB_P6_AUTH			Dot1XPB_P6Auth	/* Alias Name */
+#define EN_DOT1XPB_P6_OPINDIR			Dot1XPB_P6OPDIR	/* Alias Name */
+#define EN_DOT1XPB_P7				Dot1XPB_P7En	/* Alias Name */
+#define EN_DOT1XPB_P7_AUTH			Dot1XPB_P7Auth	/* Alias Name */
+#define EN_DOT1XPB_P7_OPINDIR			Dot1XPB_P7OPDIR	/* Alias Name */
+#define EN_DOT1XPB_P8				Dot1XPB_P8En	/* Alias Name */
+#define EN_DOT1XPB_P8_AUTH			Dot1XPB_P8Auth	/* Alias Name */
+#define EN_DOT1XPB_P8_OPINDIR			Dot1XPB_P8OPDIR	/* Alias Name */
+
+/* DOT1XMACCR - 802.1X mac base control register*/
+#define Dot1xMAC_OPDIR				(1<<10)	/* OperCOnntrolledDirections for MAC-Based ACCESS Control. 0:BOTH, 1:IN */
+#define Dot1xMAC_OPDIR_IN			Dot1xMAC_OPDIR
+#define Dot1xMAC_OPDIR_BOTH			0
+#define Dot1xMAC_P8En				(1<< 8)	/* Enable/Disable MAC Address Based Control on Port 8. 0:disable, 1:enable */
+#define Dot1xMAC_P7En				(1<< 7)	/* Enable/Disable MAC Address Based Control on Port 7. 0:disable, 1:enable */
+#define Dot1xMAC_P6En				(1<< 6)	/* Enable/Disable MAC Address Based Control on Port 6. 0:disable, 1:enable */
+#define Dot1xMAC_P5En				(1<< 5)	/* Enable/Disable MAC Address Based Control on Port 5. 0:disable, 1:enable */
+#define Dot1xMAC_P4En				(1<< 4)	/* Enable/Disable MAC Address Based Control on Port 4. 0:disable, 1:enable */
+#define Dot1xMAC_P3En				(1<< 3)	/* Enable/Disable MAC Address Based Control on Port 3. 0:disable, 1:enable */
+#define Dot1xMAC_P2En				(1<< 2)	/* Enable/Disable MAC Address Based Control on Port 2. 0:disable, 1:enable */
+#define Dot1xMAC_P1En				(1<< 1)	/* Enable/Disable MAC Address Based Control on Port 1. 0:disable, 1:enable */
+#define Dot1xMAC_P0En				(1<< 0)	/* Enable/Disable MAC Address Based Control on Port 0. 0:disable, 1:enable */
+#define EN_DOT1XMAC_OPDIR_IN			Dot1xMAC_OPDIR	/* Alias Name */
+#define EN_8021X_ALLPORT_MAC_CONTROL		0x01FF
+#define EN_8021X_MAC_CONTROL			(1)	/* Flag to check if port n is enabled */
+#define EN_8021X_PORT0_MAC_CONTROL		Dot1xMAC_P0En	/* Alias Name */
+#define EN_8021X_PORT1_MAC_CONTROL		Dot1xMAC_P1En	/* Alias Name */
+#define EN_8021X_PORT2_MAC_CONTROL		Dot1xMAC_P2En	/* Alias Name */
+#define EN_8021X_PORT3_MAC_CONTROL		Dot1xMAC_P3En	/* Alias Name */
+#define EN_8021X_PORT4_MAC_CONTROL		Dot1xMAC_P4En	/* Alias Name */
+#define EN_8021X_PORT5_MAC_CONTROL		Dot1xMAC_P5En	/* Alias Name */
+#define EN_8021X_PORT6_MAC_CONTROL		Dot1xMAC_P6En	/* Alias Name */
+#define EN_8021X_PORT7_MAC_CONTROL		Dot1xMAC_P7En	/* Alias Name */
+#define EN_8021X_PORT8_MAC_CONTROL		Dot1xMAC_P8En	/* Alias Name */
+
+/* GVGCR - Guest VLAN registerr*/
+#define GVR2CPU					(1<<15)	/* Enable Guest VLAN routing packet to be trap to CPU */
+#define GVOPDIR					(1<<14)	/* Guest Vlan operation direction control */
+#define Dot1xUNAUTHBH_OFFSET			12	/* Defaulkt Process of unauthenticated client(/packet) for both port-based and MAC-based Access Control */
+#define Dot1XUNAUTHBH_MASK			(3<<12)	/* Defaulkt Process of unauthenticated client(/packet) for both port-based and MAC-based Access Control */
+#define Dot1xUNAUTHBH_DROP			(0<<12)	/* Drop unauthorized frame */
+#define Dot1xUNAUTHBH_TOCPU			(1<<12)	/* Trap unauthorized frame to CPU */
+#define Dot1xUNAUTHBH_GVLAN			(2<<12)	/* Enable limited access in Guest VLAN */
+#define Dot1xUNAUTHBH_RESERVED			(3<<12)	/* Reserved */
+#define GVID_OFFSET				0	/* Guest VLAN VID */
+#define GVID_MASK				(0xfff<<0)	/* Guest VLAN VID */
+#define EN_DOT1X_GVR2CPU			GVR2CPU	/* Alias Name */
+#define EN_GVOPDIR				GVOPDIR	/* Alias Name */
+#define GVLAN_PROCESS_BITS			Dot1xUNAUTHBH_OFFSET	/* Alias Name */
+#define GVLAN_PROCESS_MASK			(Dot1XUNAUTHBH_MASK>>Dot1xUNAUTHBH_OFFSET)	/* Alias Name */
+#define DOT1X_PROCESS_DROP			(Dot1xUNAUTHBH_DROP>>Dot1xUNAUTHBH_OFFSET)	/* Alias Name */
+#define DOT1X_PROCESS_TOCPU			(Dot1xUNAUTHBH_TOCPU>>Dot1xUNAUTHBH_OFFSET)	/* Alias Name */
+#define DOT1X_PROCESS_GVLAN			(Dot1xUNAUTHBH_GVLAN>>Dot1xUNAUTHBH_OFFSET)	/* Alias Name */
+#define DOT1X_PROCESS_RESERVED			(Dot1xUNAUTHBH_RESERVED>>Dot1xUNAUTHBH_OFFSET)	/* Alias Name */
+
+/* Link Aggregation Control Register (IEEE 802.3ad) */
+#define LAGCR_BASE				(SWCORE_BASE + 0x4C00)
+#define LAGHPMR0				(0x00 + LAGCR_BASE)	/* Link Aggregation Hashed Index to Port Mapping Register 0 */
+#define LAGCR0					(0x08 + LAGCR_BASE)	/* Link Aggregation Control Register 0 */
+#define LAGCR1					(0x0C + LAGCR_BASE)	/* Link Aggregation Control Register 1 */
+#define LAGCR2					(0x10+ LAGCR_BASE)	/* Link Aggregation Control Register 2 */
+
+/* LAGHPMR0 - Link Aggregation Hashed Index to Port Mapping Register 0 */
+#define LAG_HASHIDX_BITNUM			4
+
+/* LAGCR0 - Link Aggregation Control Register 0 */
+#define TRUNKMASK_MASK				(0x1ff)
+#if 1				//defined(CONFIG_RTL_LINK_AGGREGATION)
+#define LAG_THASH_SELECT_MASK			(3 << 9)
+#define LAG_THASH_SELECT_OFFSET			(9)
+#define LAG_FTK_CONGEST_MASK			(1 << 11)
+#define LAG_FTK_CONGEST_OFFSET			(11)
+#endif
+
+/* Table access and CPU interface control registers */
+#define TACI_BASE				(SWCORE_BASE + 0x00004D00)
+#define SWTACR					(0x000 + TACI_BASE)	/* Table Access Control */
+#define SWTASR					(0x004 + TACI_BASE)	/* Table Access Status */
+#define SWTAA					(0x008 + TACI_BASE)	/* Table Access Address */
+#define TCR0					(0x020 + TACI_BASE)	/* Table Access Control 0 */
+#define TCR1					(0x024 + TACI_BASE)	/* Table Access Control 1 */
+#define TCR2					(0x028 + TACI_BASE)	/* Table Access Control 2 */
+#define TCR3					(0x02C + TACI_BASE)	/* Table Access Control 3 */
+#define TCR4					(0x030 + TACI_BASE)	/* Table Access Control 4 */
+#define TCR5					(0x034 + TACI_BASE)	/* Table Access Control 5 */
+#define TCR6					(0x038 + TACI_BASE)	/* Table Access Control 6 */
+#define TCR7					(0x03C + TACI_BASE)	/* Table Access Control 7 */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define TCR8					(0x040 + TACI_BASE)	/* Table Access Control 5 */
+#define TCR9					(0x044 + TACI_BASE)	/* Table Access Control 6 */
+#define TCR10					(0x048 + TACI_BASE)	/* Table Access Control 7 */
+#endif
+/* Table access control register field definitions
+*/
+#define ACTION_MASK				1
+#define ACTION_DONE				0
+#define ACTION_START				1
+#define CMD_MASK				(7 << 1)
+#define CMD_ADD					(1 << 1)
+#define CMD_MODIFY				(1 << 2)
+#define CMD_FORCE				(1 << 3)
+#define STOP_TLU_READY				(1<<19)
+#define EN_STOP_TLU				(1<<18)
+/* Table access status register field definitions
+*/
+#define TABSTS_MASK				1
+#define TABSTS_SUCCESS				0
+#define TABSTS_FAIL				1
+/* Vlan table access definitions
+*/
+#define STP_DISABLE				0
+#define STP_BLOCK				1
+#define STP_LEARN				2
+#define STP_FORWARD				3
+/* Protocol trapping table access definitions
+*/
+#define TYPE_TRAP_ETHERNET			0x00
+#define TYPE_TRAP_IP				0x02
+#define TYPE_TRAP_TCP				0x05
+#define TYPE_TRAP_UDP				0x06
+/* L3 Routing table access definitions
+*/
+#define PROCESS_PPPOE				0x00
+#define PROCESS_DIRECT				0x01
+#define PROCESS_INDIRECT			0x02
+#define PROCESS_S_CPU				0x04
+#define PROCESS_NXT_HOP				0x05
+#define PROCESS_S_DROP				0x06
+#define PROCESS_N_DROP				0x07
+/* ACL table access definitions
+*/
+#define RULE_ETHERNET				0
+#define RULE_IP					2
+#define RULE_IFSEL				3
+#define RULE_ICMP				4
+#define RULE_IGMP				5
+#define RULE_TCP				6
+#define RULE_UDP				7
+#define RULE_SRC_FILTER				8
+#define RULE_DST_FILTER				9
+#define ACTION_PERMIT				0
+#define ACTION_REDIRECT				1
+#define ACTION_S_DROP				2
+#define ACTION_S_CPU				3
+#define ACTION_N_DROP				4
+#define ACTION_N_CPU				5
+#define ACTION_CPU_FOR_LOGGING			5
+#define ACTION_MIRROR				6
+#define ACTION_PPPOE_REDIRECT			7
+#define ACTION_DEFAULT_REDIRECT			8
+#define ACTION_DEFAULT_MIRROR			9
+#define ACTION_DROP_RATE_PPS			10
+#define ACTION_LOG2CPU_RATE_PPS			11
+#define ACTION_DROP_RATE_BPS			12
+#define ACTION_LOG2CPU_RATE_BPS			13
+
+/* Extend MAC Control Register */
+#define EXTMAC_BASE				(SWCORE_BASE + 0x5100)
+#define MACCTRL1				(0x00+EXTMAC_BASE)	/* MAC Configuration Register 1 */
+#define EXTPCR0					(0x08+EXTMAC_BASE)	/* Extend Port Configuration Register for Port 0 */
+
+#if defined(CONFIG_RTL_8197F)
+#define EXTSTMCR0				(0x2C+EXTMAC_BASE)	/* Extend Storm Configuration Register 1 */
+#define EXTSTMCR1				(0x30+EXTMAC_BASE)	/* Extend Storm Configuration Register 2 */
+#define EXTSTMCR2				(0x34+EXTMAC_BASE)	/* Extend Storm Configuration Register 3 */
+#define EXTSTMCR3				(0x38+EXTMAC_BASE)	/* Extend Storm Configuration Register 4 */
+#define EXTSTMCR4				(0x3C+EXTMAC_BASE)	/* Extend Storm Configuration Register 5 */
+#define EXTSTMCR5				(0x40+EXTMAC_BASE)	/* Extend Storm Configuration Register 6 */
+
+#define EUUSCS					(1)	/* even Unknown Unicast Storm Control Selection */
+#define EUMSCS					(1<<1)	/* even Unknown Multicast Storm Control Selection */
+#define EASCS					(1<<2)	/* even ARP Storm Control Selection */
+#define EDSCS					(1<<3)	/* even DHCP Storm Control Selection */
+#define EIMSCS					(1<<4)	/* even IGMP/MLD Storm Control Selection */
+
+#define OUUSCS					(1<<16)	/* odd Unknown Unicast Storm Control Selection */
+#define OUMSCS					(1<<17)	/* odd Unknown Multicast Storm Control Selection */
+#define OASCS					(1<<18)	/* odd ARP Storm Control Selection */
+#define ODSCS					(1<<19)	/* odd DHCP Storm Control Selection */
+#define OIMSCS					(1<<20)	/* odd IGMP/MLD Storm Control Selection */
+
+#define TUSSCM0					(3<<16)	/* Timing unit selection for storm control meter threshold 0 */
+#define TUSSCM1					(3<<18)	/* Timing unit selection for storm control meter threshold 1 */
+#define TUSSCM2					(3<<20)	/* Timing unit selection for storm control meter threshold 2 */
+#define TUSSCM3					(3<<22)	/* Timing unit selection for storm control meter threshold 3 */
+#define TUSSCM0_OFFSET				(16)
+#define TUSSCM1_OFFSET				(18)
+#define TUSSCM2_OFFSET				(20)
+#define TUSSCM3_OFFSET				(22)
+#define ESCTI0					(0)	/* extend storm control time interval 25ms */
+#define ESCTI1					(1)	/* extend storm control time interval 2.5ms */
+#define ESCTI2					(2)	/* extend storm control time interval 0.25ms */
+#define ESCTI3					(3)	/* extend storm control time interval 0.5ms */
+
+#define EPSCS					(31)	/* even port storm control selection */
+#define OPSCS					(31<<16)	/* odd port storm control selection */
+#define OPSCS_OFFSET				(16)
+#define EPUUSC					(3<<6)	/* even port unknown unicast storm meter counter selection */
+#define EPUMSC					(3<<8)	/* even port unknown multicast storm meter counter selection */
+#define EPASC					(3<<10)	/* even port arp storm meter counter selection */
+#define EPDSC					(3<<12)	/* even port dhcp storm meter counter selection */
+#define EPIMSC					(3<<14)	/* even port igmp/mld storm meter counter selection */
+#define OPUUSC					(3<<22)	/* odd port unknown unicast storm meter counter selection */
+#define OPUMSC					(3<<24)	/* odd port unknown multicast storm meter counter selection */
+#define OPASC					(3<<26)	/* odd port arp storm meter counter selection */
+#define OPDSC					(3<<28)	/* odd port dhcp storm meter counter selection */
+#define OPIMSC					(3<<30)	/* odd port igmp/mld storm meter counter selection */
+
+#define EPUUSC_OFFSET				(6)
+#define EPUMSC_OFFSET				(8)
+#define EPASC_OFFSET				(10)
+#define EPDSC_OFFSET				(12)
+#define EPIMSC_OFFSET				(14)
+#define OPUUSC_OFFSET				(22)
+#define OPUMSC_OFFSET				(24)
+#define OPASC_OFFSET				(26)
+#define OPDSC_OFFSET				(28)
+#define OPIMSC_OFFSET				(30)
+
+#define ENDROPSC0				(1<<24)	/* Configure to whether the storm bin counter will drop packet  */
+#define ENDROPSC1				(1<<25)
+#define ENDROPSC2				(1<<26)
+#define ENDROPSC3				(1<<27)
+#endif
+
+/* MACCTRL1 - MAC Configuration Register 1 */
+#define CF_CMAC_CLK_SEL				(1<<0)	/* Cport MAC clock selection with NIC interface,      1: lx_clk, 0: lx_clk/2 ( default ) */
+							/* Note: Before cf_cmac_clk_sel = 1'b1, 0xbb80_4000 n13-n12 must be set to 2'b01 first. (sys_clk_sel = 2'b01) */
+#define CF_CMAC_LATPKT_EN			(1<<5)	/* Enable to latch pkt content, default value is 1'b0 */
+#define CF_CMAC_LATPKT_TYPE			(1<<6)	/*  0 : latch begin from 1st byte in pkt (from dmac); 1 : latch pkt content after pkt header recognized by port_rx */
+
+/* EXTPCR0 - Extend Port Configuration Register for Port 0 */
+#define FRC_Pn_EEE_GELITE			(1<<12)	/* MAC EEE ability for 500M port, or Advertise 500M EEE capable */
+#define CF_HW_500M_AN				(1<<1)	/* Configure each Ethernet port whether HW auto check Giga lite status */
+#define CF_500M_EN				(1<<0)	/* Configure whether port has the ability to support Giga Lite */
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+/* IPv6 Control Register */
+#define IPV6_BASE				(SWCORE_BASE + 0x5200)
+#define IPV6CR0					(0x000+IPV6_BASE)	/* ALE IPv6 Control Register 0 */
+#define IPV6CR1					(0x004+IPV6_BASE)	/* ALE IPv6 Control Register 1 */
+#define V6RDCTR0				(0x008+IPV6_BASE)
+#define V6RDCTR1				(0x00C+IPV6_BASE)
+#define DSLITECTR0				(0x010+IPV6_BASE)
+#define DSLITECTR1				(0x038+IPV6_BASE)
+#define V6DSLITECTR0				DSLITECTR0
+#define V6DSLITECTR1				DSLITECTR1
+
+#define MultiCastv6MTU_OFFSET			(0)
+#define MultiCastv6MTU_MASK			(0x7fff)
+
+/*V6DSLITECTR0*/
+#define CF_DSLITE_NAT_OFFSET			(31)
+#define CF_DSLITE_NAT_MASK			(1<<31)
+#define CF_DSLITE_DPRI_OFFSET			(28)
+#define CF_DSLITE_DPRI_MASK			(3<<28)
+#define CF_DSL_MTU_OFFSET			(13)
+#define CF_DSL_MTU_MASK				(0X8FFF<<13)
+#define CF_STA_DSLMTU_OFFSET			(12)
+#define CF_STA_DSLMTU_MASK			(1<<12)
+#define CF_DSLTC_OFFSET				(4)
+#define CF_DSLTC_MASK				(0xFF<<4)
+#define CF_UKN_DSLDIP_CPU_OFFSET		(2)
+#define CF_UKN_DSLDIP_CPU_MASK			(1<<2)
+#define CF_DSLTC_EN_OFFSET			(1)
+#define CF_DSLTC_EN_MASK			(1<<1)
+#define CF_DSLITE_EN_OFFSET			(0)
+#define CF_DSLITE_EN_MASK			(1)
+#define CF_HOP_LIMIT				(64)
+
+/*V6DSLITECTR1*/
+#define CF_DSL_HOPLIMIT_OFFSET			(19)
+#define CF_DSL_HOPLIMIT_MASK			(0xFF<<19)
+#define CF_DSL_FWLABEL_OFFSET			(0)
+#define CF_DSL_FWLABEL_MASK			(0xFFFFF)
+
+/*V6RDCTR0*/
+#define CF_DELPREFIX_CHK_OFFSET			(27)
+#define CF_DELPREFIX_CHK_MASK			(1<<27)
+#define CF_6RD_DPRI_OFFSET			(24)
+#define CF_6RD_DPRI_MASK			(3<<24)
+#define CF_6RD_IPV4_TTL_OFFSET			(16)
+#define CF_6RD_IPV4_TTL_MASK			(0xFF<<16)
+#define CF_6RDTOS_OFFSET			(8)
+#define CF_6RDTOS_MASK				(0xff<<8)
+#define CF_UKN_6RDDIP_CPU_OFFSET		(6)
+#define CF_UKN_6RDDIP_CPU_MASK			(1<<6)
+#define CF_6RDTOS_EN_OFFSET			(5)
+#define CF_6RDTOS_EN_MASK			(1<<5)
+#define CF_STA_6RDMTU_OFFSET			(4)
+#define CF_STA_6RDMTU_MASK			(1<<4)
+#define CF_6RDIN_SIPCHK_OFFSET			(3)
+#define CF_6RDIN_SIPCHK_MASK			(1<<3)
+#define CF_SIP46_MCH_OFFSET			(2)
+#define CF_SIP46_MCH_MASK			(1<<2)
+#define CF_ACPT_BR_ONLY_OFFSET			(1)
+#define CF_ACPT_BR_ONLY_MASK			(1<<1)
+#define CF_6RD_EN_OFFSET			(0)
+#define CF_6RD_EN_MASK				(1)
+
+/*V6RDCTR1*/
+#define CF_6RDID_END_OFFSET			(16)
+#define CF_6RDID_END_MASK			(0xFFFF<<16)
+#define CF_6RDID_ST_OFFSET			(0)
+#define CF_6RDID_ST_MASK			(0xFFFF)
+#endif
+
+/* SmartBit Like Function Control Register */
+#define PG_BASE					(SWCORE_BASE + 0x6900)
+#define PGGCR0					(0x00+PG_BASE)	/* PktGen Global Control Register 0 */
+#define PGGCR1					(0x04+PG_BASE)	/* PktGen Global Control Register 1 */
+#define PGFPCR					(0x94+PG_BASE)	/* PktGen Frame Parameter Control Register */
+#define PGDPR					(0xA8+PG_BASE)	/* PktGen Data Pattern Register */
+
+/* PktGen Global Control Register 1 */
+#define EnSMBMode_OFFSET			(24)
+#define StopTXcommandPulse			(2)
+#define StartTXcommandPulse			(1)
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#define MISC_BASE				(SWCORE_BASE + 0x00007000)
+#define BCR0					(0x008 + MISC_BASE)	/* Input bandwidth control */
+#define BCR1					(0x00C + MISC_BASE)	/* Ouput bandwidth control */
+#define FCREN					(0x014 + MISC_BASE)	/* Flow control enable control */
+#define FCRTH					(0x018 + MISC_BASE)	/* Flow control threshold */
+#define FCPTR					(0x028 + MISC_BASE)	/* Flow control prime threshold register */
+#define PTCR					(0x01C + MISC_BASE)	/* Port trunk control */
+#define SWTECR					(0x020 + MISC_BASE)	/* Switch table extended control */
+#define PTRAPCR					(0x024 + MISC_BASE)	/* Protocol trapping control */
+
+#define GIDXMCR					(0x07C + MISC_BASE)	/* GIDX mapping control */
+#define PBVR2					(0x0A0 + MISC_BASE)	/* Protocol-Based VLAN Rule 2 -- NetBIOS           */
+#define PBVR2E					(0x0A4 + MISC_BASE)	/* Protocol-Based VLAN Rule 2 Extended             */
+#define PBVR3					(0x0A8 + MISC_BASE)	/* Protocol-Based VLAN Rule 3 -- PPPoE Control */
+#define PBVR3E					(0x0AC + MISC_BASE)	/* Protocol-Based VLAN Rule 3 Extended             */
+#define PBVR4					(0x0B0 + MISC_BASE)	/* Protocol-Based VLAN Rule 4 -- PPPoE Session */
+#define PBVR4E					(0x0B4 + MISC_BASE)	/* Protocol-Based VLAN Rule 4 Extended             */
+#define PBVR5					(0x0B8 + MISC_BASE)	/* Protocol-Based VLAN Rule 5 -- User-defined 1 */
+#define PBVR5E					(0x0BC + MISC_BASE)	/* Protocol-Based VLAN Rule 5 Extended             */
+#define PBVR6					(0x0C0 + MISC_BASE)	/* Protocol-Based VLAN Rule 6 -- User-defined 2 */
+#define PBVR6E					(0x0C4 + MISC_BASE)	/* Protocol-Based VLAN Rule 6 Extended             */
+
+#define PSIR0					(0x0C8 + MISC_BASE)	/* Port State Information Register 0 */
+#define PSIR1					(0x0CC + MISC_BASE)	/* Port State Information Register 1 */
+#define CHIPID					(0x100 + MISC_BASE)	/* Chip version ID */
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+/* Bandwidth control register field definitions
+*/
+#define OUT_BC_P0_OFFSET			0	/* Output bandwidth control port 0 offset */
+#define IN_BC_P0_OFFSET				4	/* Input bandwidth control port 0 offset */
+#define OUT_BC_P1_OFFSET			8	/* Output bandwidth control port 1 offset */
+#define IN_BC_P1_OFFSET				12	/* Input bandwidth control port 1 offset */
+#define OUT_BC_P2_OFFSET			16	/* Output bandwidth control port 2 offset */
+#define IN_BC_P2_OFFSET				20	/* Input bandwidth control port 2 offset */
+#define OUT_BC_P3_OFFSET			24	/* Output bandwidth control port 3 offset */
+#define IN_BC_P3_OFFSET				48	/* Input bandwidth control port 3 offset */
+#define OUT_BC_P4_OFFSET			0	/* Output bandwidth control port 4 offset */
+#define IN_BC_P4_OFFSET				4	/* Input bandwidth control port 4 offset */
+#define OUT_BC_P5_OFFSET			8	/* Output bandwidth control port 5 offset */
+#define IN_BC_P5_OFFSET				12	/* Input bandwidth control port 5 offset */
+#define BW_FULL_RATE				0
+#define BW_128K					1
+#define BW_256K					2
+#define BW_512K					3
+#define BW_1M					4
+#define BW_2M					5
+#define BW_4M					6
+#define BW_8M					7
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+/* Flow control enable register field defintions
+*/
+#define EN_INQ_FC_CPU				(1 << 31)	/* Enable Flow Control on CPU Port */
+#define EN_INQ_FC_5				(1 << 30)	/* Enable Flow Control on Port 5 */
+#define EN_INQ_FC_4				(1 << 29)	/* Enable Flow Control on Port 4 */
+#define EN_INQ_FC_3				(1 << 28)	/* Enable Flow Control on Port 3 */
+#define EN_INQ_FC_2				(1 << 27)	/* Enable Flow Control on Port 2 */
+#define EN_INQ_FC_1				(1 << 26)	/* Enable Flow Control on Port 1 */
+#define EN_INQ_FC_0				(1 << 25)	/* Enable Flow Control on Port 0 */
+#define EN_OUTQ_FC_CPU				(1 << 24)	/* Enable Flow Control on CPU Port */
+#define EN_OUTQ_FC_5				(1 << 23)	/* Enable Flow Control on Port 5 */
+#define EN_OUTQ_FC_4				(1 << 22)	/* Enable Flow Control on Port 4 */
+#define EN_OUTQ_FC_3				(1 << 21)	/* Enable Flow Control on Port 3 */
+#define EN_OUTQ_FC_2				(1 << 20)	/* Enable Flow Control on Port 2 */
+#define EN_OUTQ_FC_1				(1 << 19)	/* Enable Flow Control on Port 1 */
+#define EN_OUTQ_FC_0				(1 << 18)	/* Enable Flow Control on Port 0 */
+#define CPU_LAUNCH_FC_P5			(1 << 17)	/* CPU launch flow control of Port 5 */
+#define CPU_LAUNCH_FC_P4			(1 << 16)	/* CPU launch flow control of Port 4 */
+#define CPU_LAUNCH_FC_P3			(1 << 15)	/* CPU launch flow control of Port 3 */
+#define CPU_LAUNCH_FC_P2			(1 << 14)	/* CPU launch flow control of Port 2 */
+#define CPU_LAUNCH_FC_P1			(1 << 13)	/* CPU launch flow control of Port 1 */
+#define CPU_LAUNCH_FC_P0			(1 << 12)	/* CPU launch flow control of Port 0 */
+#define EN_MDC_MDIO_FC				(1 << 10)	/* Enable MDC/MDIO Flow Control */
+#define DSC_TH_OFFSET				0	/* Descriptor Initial threshold */
+/* Flow control threshold register field defintions
+*/
+#define IN_Q_PER_PORT_BUF_FC_THH_OFFSET		24	/* InQ per port buffer page flow control high threshold offset */
+#define IN_Q_PER_PORT_BUF_FC_THL_OFFSET		16	/* InQ per port buffer page flow control low threshold offset */
+#define OUT_Q_PER_PORT_BUF_FC_THH_OFFSET	8	/* OutQ per port buffer page flow control high threshold offset */
+#define OUT_Q_PER_PORT_BUF_FC_THL_OFFSET	0	/* OutQ per port buffer page flow control low threshold offset */
+/* Flow control prime threshold register field defintions
+*/
+#define IN_Q_PTH_OFFSET				16	/* InQ Prime flow control threshold */
+#define OUT_Q_PTH_OFFSET			0	/* OutQ Prime flow control threshold */
+/* Port trunking control register field definitions
+*/
+#define LMPR7_OFFSET				27	/* Physical port index for logical port 7 */
+#define LMPR6_OFFSET				24	/* Physical port index for logical port 6 */
+#define LMPR5_OFFSET				21	/* Physical port index for logical port 5 */
+#define LMPR4_OFFSET				18	/* Physical port index for logical port 4 */
+#define LMPR3_OFFSET				15	/* Physical port index for logical port 3 */
+#define LMPR2_OFFSET				12	/* Physical port index for logical port 2 */
+#define LMPR1_OFFSET				9	/* Physical port index for logical port 1 */
+#define LMPR0_OFFSET				6	/* Physical port index for logical port 0 */
+#define TRUNK1_PORT_MASK_OFFSET			0	/* Physical port mask of trunk 1 */
+/* Port trunking control register field definitions
+*/
+#define EN_PPP_OP				(1 << 31)	/* Enable PPPoE auto insert and remove */
+/* Protocol trapping control register field definitions
+*/
+#define EN_ARP_TRAP				(1 << 24)	/* Enable trapping ARP packets */
+#define EN_RARP_TRAP				(1 << 25)	/* Enable trapping RARP packets */
+#define EN_PPPOE_TRAP				(1 << 26)	/* Enable trapping PPPoE packets */
+#define EN_IGMP_TRAP				(1 << 27)	/* Enable trapping IGMP packets */
+#define EN_DHCP_TRAP1				(1 << 28)	/* Enable trapping DHCP 67 packets */
+#define EN_DHCP_TRAP2				(1 << 29)	/* Enable trapping DHCP 68 packets */
+#define EN_OSPF_TRAP				(1 << 30)	/* Enable trapping OSPF packets */
+#define EN_RIP_TRAP				(1 << 31)	/* Enable trapping RIP packets */
+/* Spanning tree control register field definitions
+*/
+#define EN_ESTP_S_DROP				(1 << 5)	/* Enable egress spanning tree forward S_Drop */
+/* Broadcast storm control register field definitions
+*/
+#define EN_BCAST_STORM				(1 << 0)	/* Enable broadcast storm control */
+#define BCAST_TH_MASK				(0xFF << 1)	/* Threshold within broadcast interval mask */
+#define BCAST_TH_OFFSET				1	/* Threshold within broadcast interval offset */
+#define TI_100M_MASK				(0x3F << 9)	/* Time interval for 100M mask */
+#define TI_100M_OFFSET				9	/* Time interval for 100M offset */
+#define TI_10M_MASK				(0x3F << 15)	/* Time interval for 10M mask */
+#define TI_10M_OFFSET				15	/* Time interval for 10M offset */
+#define	EN_L2LRUHASH				(1<<4)	/*Enable L2 Table hash collision over write the last used entry mode */
+#define	EN_L2FASTAGING				(1<<5)	/*Enable L2 Fast Aging Out */
+
+/* Table entry aging time control register field definitions
+*/
+#define ICMP_TH_OFFSET				26	/* ICMP timeout threshold offset */
+#define ICMP_TH_MASK				(0x3f << ICMP_TH_OFFSET)
+#define UDP_TH_OFFSET				20	/* UDP timeout threshold offset */
+#define UDP_TH_MASK				(0x3f << UDP_TH_OFFSET)
+#define TCP_LONG_TH_OFFSET			14	/* TCP long timeout threshold offset */
+#define TCP_LONG_TH_MASK			(0x3f << TCP_LONG_TH_OFFSET)
+#define TCP_MED_TH_OFFSET			8	/* TCP medium timeout threshold offset */
+#define TCP_MED_TH_MASK				(0x3f << TCP_MED_TH_OFFSET)
+#define TCP_FAST_TH_OFFSET			2	/* TCP fast timeout threshold offset */
+#define TCP_FAST_TH_MASK			(0x3f << TCP_FAST_TH_OFFSET)
+/* Port mirror control register field definitions
+*/
+#define MIRROR_TO_PORT_OFFSET			26	/* Port receiving the mirrored traffic offset */
+#define MIRROR_FROM_PORT_RX_OFFSET		20	/* Rx port to be mirrored offset */
+#define MIRROR_FROM_PORT_TX_OFFSET		14	/* Tx port to be mirrored offset */
+/* Per port matching action register field definitions
+*/
+#define EN_PMATCH_PORT_LIST_OFFSET		26	/* Enable pattern match port list offset */
+#define MATCH_OP_P5_OFFSET			24	/* Offset of operation if matched on port 5 */
+#define MATCH_OP_P4_OFFSET			22	/* Offset of operation if matched on port 4 */
+#define MATCH_OP_P3_OFFSET			20	/* Offset of operation if matched on port 3 */
+#define MATCH_OP_P2_OFFSET			18	/* Offset of operation if matched on port 2 */
+#define MATCH_OP_P1_OFFSET			16	/* Offset of operation if matched on port 1 */
+#define MATCH_OP_P0_OFFSET			14	/* Offset of operation if matched on port 0 */
+#define MATCH_DROP				0	/* Drop if matched */
+#define MATCH_MIRROR_TO_CPU			1	/* Mirror to CPU if matched */
+#define MATCH_FORWARD_TO_CPU			2	/* Forward to CPU if matched */
+#define MATCH_TO_MIRROR_PORT			3	/* To mirror port if matched */
+/* Port based vlan config register field definitions
+*/
+#define PVID_MASK				7	/* MASK for PVID */
+#define VIDP0_OFFSET				0	/* Vlan table index for port 0 */
+#define VIDP1_OFFSET				3	/* Vlan table index for port 1 */
+#define VIDP2_OFFSET				6	/* Vlan table index for port 2 */
+#define VIDP3_OFFSET				9	/* Vlan table index for port 3 */
+#define VIDP4_OFFSET				12	/* Vlan table index for port 4 */
+#define VIDP5_OFFSET				15	/* Vlan table index for port 5 */
+/* GIDX mapping control register field definitions
+*/
+#define GIDX_MASK				7	/* MASK for GIDX */
+#define GIDX0_OFFSET				0	/* Index to IP table */
+#define GIDX1_OFFSET				3	/* Index to IP table */
+#define GIDX2_OFFSET				6	/* Index to IP table */
+#define GIDX3_OFFSET				9	/* Index to IP table */
+#define GIDX4_OFFSET				12	/* Index to IP table */
+#define GIDX5_OFFSET				15	/* Index to IP table */
+#define GIDX6_OFFSET				18	/* Index to IP table */
+#define GIDX7_OFFSET				21	/* Index to IP table */
+/* Offset control register field definitions
+*/
+#define OCR_START_MASK				(0x1f << 26)	/* Starting value of offset mask */
+#define OCR_START_OFFSET			26	/* Starting value of offset offset */
+#define OCR_END_MASK				(0x1f << 20)	/* End value of offset mask */
+#define OCR_END_OFFSET				20	/* End value of offset offset */
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+/* Protocol-based VLAN Control Register field definitions
+*/
+#define PBVCR_PROTO_TYPE_OFFSET			0	/* Protocol-Based VLAN Control Register Protocol Type */
+#define PBVCR_PROTO_TYPE_MASK			(0x3 << PBVCR_PROTO_TYPE_OFFSET)
+#define PBVCR_PROTO_VALUE_OFFSET		2	/* Protocol-Based VLAN Control Register Protocol Value */
+#define PBVCR_PROTO_VALUE_MASK			(0xffff << PBVCR_PROTO_VALUE_OFFSET)
+#define PBVCR_VIDXP5_OFFSET			21	/* VLAN index for Port 5 */
+#define PBVCR_VIDXP5_MASK			(0x7 << PBVCR_VIDXP5_OFFSET)
+#define PBVCR_VP5_OFFSET			20	/* Valid bit for Port 5 */
+#define PBVCR_VP5_MASK				(0x1 << PBVCR_VP5_OFFSET)
+#define PBVCR_VIDXP4_OFFSET			17	/* VLAN index for Port 4 */
+#define PBVCR_VIDXP4_MASK			(0x7 << PBVCR_VIDXP4_OFFSET)
+#define PBVCR_VP4_OFFSET			16	/* Valid bit for Port 4 */
+#define PBVCR_VP4_MASK				(0x1 << PBVCR_VP4_OFFSET)
+#define PBVCR_VIDXP3_OFFSET			13	/* VLAN index for Port 3 */
+#define PBVCR_VIDXP3_MASK			(0x7 << PBVCR_VIDXP3_OFFSET)
+#define PBVCR_VP3_OFFSET			12	/* Valid bit for Port 3 */
+#define PBVCR_VP3_MASK				(0x1 << PBVCR_VP3_OFFSET)
+#define PBVCR_VIDXP2_OFFSET			9	/* VLAN index for Port 2 */
+#define PBVCR_VIDXP2_MASK			(0x7 << PBVCR_VIDXP2_OFFSET)
+#define PBVCR_VP2_OFFSET			8	/* Valid bit for Port 2 */
+#define PBVCR_VP2_MASK				(0x1 << PBVCR_VP2_OFFSET)
+#define PBVCR_VIDXP1_OFFSET			5	/* VLAN index for Port 1 */
+#define PBVCR_VIDXP1_MASK			(0x7 << PBVCR_VIDXP1_OFFSET)
+#define PBVCR_VP1_OFFSET			4	/* Valid bit for Port 1 */
+#define PBVCR_VP1_MASK				(0x1 << PBVCR_VP1_OFFSET)
+#define PBVCR_VIDXP0_OFFSET			3	/* VLAN index for Port 0 */
+#define PBVCR_VIDXP0_MASK			(0x7 << PBVCR_VIDXP0_OFFSET)
+#define PBVCR_VP0_OFFSET			0	/* Valid bit for Port 0 */
+#define PBVCR_VP0_MASK				(0x1 << PBVCR_VP0_OFFSET)
+#define PBVCR_VIDXEP2_OFFSET			9	/* VLAN index for Extented Port 2 */
+#define PBVCR_VIDXEP2_MASK			(0x7 << PBVCR_VIDXEP2_OFFSET)
+#define PBVCR_VEP2_OFFSET			8	/* Valid bit for Extented Port 2 */
+#define PBVCR_VEP2_MASK				(0x1 << PBVCR_VEP2_OFFSET)
+#define PBVCR_VIDXEP1_OFFSET			5	/* VLAN index for Extented Port 1 */
+#define PBVCR_VIDXEP1_MASK			(0x7 << PBVCR_VIDXEP1_OFFSET)
+#define PBVCR_VEP1_OFFSET			4	/* Valid bit for Extented Port 1 */
+#define PBVCR_VEP1_MASK				(0x1 << PBVCR_VEP1_OFFSET)
+#define PBVCR_VIDXEP0_OFFSET			1	/* VLAN index for Extented Port 0 */
+#define PBVCR_VIDXEP0_MASK			(0x7 << PBVCR_VIDXEP0_OFFSET)
+#define PBVCR_VEP0_OFFSET			0	/* Valid bit for Extented Port 0 */
+#define PBVCR_VEP0_MASK				(0x1 << PBVCR_VEP0_OFFSET)
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+/*
+ * ----------------------------------------------------------------------------
+ *
+ * SYSTEM_BASE, 0xB8000000 ~
+ *
+ * ----------------------------------------------------------------------------
+ */
+
+#define EPHY_CONTROL			 	(SYSTEM_BASE+0x01E0)	/* ephy control register */
+
+/* ephy control register */
+#define	EN_ROUTER_MODE			  	(0x1<<12)	/* 5-port router mode(default) or 1-port AP mode, 1'b1 */
+
+/* Efuse_ctrl Registers */
+#define EFUSE_CMD				(SYSTEM_BASE+0x0700)	/* cmd register */
+#define EFUSE_CONFIG			 	(SYSTEM_BASE+0x0704)	/* Config register */
+#define EFUSE_RW_DATA			 	(SYSTEM_BASE+0x0708)	/* Read or write data port register */
+#define EFUSE_TIMING_CONTROL	  		(SYSTEM_BASE+0x070C)	/* Timing control register */
+
+/* Config register */
+#define EFUSE_CFG_INT_STS		  	(1 << 8)	/* Interrupt_status */
+
+/* Memory Control Register registers
+*/
+#define MCR_BASE				(SYSTEM_BASE+0x1000)	/* 0xB8001000 */
+#define MCR					(0x000 + MCR_BASE)	/* Memory configuration register */
+#define MTCR0					(0x004 + MCR_BASE)	/* Memory timing configuration register */
+#define MTCR1					(0x008 + MCR_BASE)	/* Memory timing configuration register */
+#define PFCR					(0x010 + MCR_BASE)	/* Pre-Fetch Control Register */
+#define MPMR					(0x040 + MCR_BASE)
+
+#if defined(CONFIG_RTL_819X)
+#define	SDRDRAM_MASK				(0x1<<31)
+#define	DCR					(0x004 + MCR_BASE)	/*      DRAM control register */
+#define	COLCNT_MASK				(0x1c00000)
+#define	COLCNT_OFFSET				22
+#define	ROWCNT_MASK				(0x6000000)
+#define	ROWCNT_OFFSET				25
+#endif
+
+// MPMR 0xB8001040 Memory Power Management Register
+#define PM_MODE_OFFSET				30
+#define PM_MODE_NORMAL				(0 << PM_MODE_OFFSET)
+#define PM_MODE_ENABLE_AUTOMATIC_POWER_DOWN	(1 << PM_MODE_OFFSET)
+#define PM_MODE_ENABLE_SELF_REFRESH		(2 << PM_MODE_OFFSET)
+
+/* UART registers
+*/
+#define UART0_BASE				(SYSTEM_BASE+0x2000)	/* 0xB8002000 */
+#define UART1_BASE				(SYSTEM_BASE+0x2100)
+
+/* System Control Registers */
+
+/* Global interrupt control registers */
+#define GICR_BASE				(SYSTEM_BASE+0x3000)	/* 0xB8003000 */
+#define GIMR					(0x000 + GICR_BASE)	/* Global interrupt mask */
+#define GISR					(0x004 + GICR_BASE)	/* Global interrupt status */
+#define IRR					(0x008 + GICR_BASE)	/* Interrupt routing */
+#define IRR0					(0x008 + GICR_BASE)	/* Interrupt routing */
+#define IRR1					(0x00C + GICR_BASE)	/* Interrupt routing */
+#define IRR2					(0x010 + GICR_BASE)	/* Interrupt routing */
+#define IRR3					(0x014 + GICR_BASE)	/* Interrupt routing */
+#define GIMR2					(0x020 + GICR_BASE)	/* Global interrupt mask 2 */
+#define GISR2					(0x024 + GICR_BASE)	/* Global interrupt status 2 */
+#define PLTC					(0x064 + GICR_BASE)	/* Peripheral Lexra timeout control */
+
+/* Global interrupt status 2 */
+#define LX1_BTRDY_IP				(1 << 27)	/* LBC 1 bus time ready time-out interrupt pending flag */
+
+/* Global interrupt mask register field definitions
+*/
+#define TCIE					(1 << 29)	/* Timer/Counter interrupt enable */
+#define USBIE					(1 << 30)	/* USB interrupt enable */
+#define PCMCIAIE				(1 << 29)	/* PCMCIA interrupt enable */
+#define UART1IE					(1 << 28)	/* UART 1 interrupt enable */
+#define UART0IE					(1 << 27)	/* UART 0 interrupt enable */
+#define PCIIE					(1 << 26)	/* Parallel port interrupt enable */
+#define SWIE					(1 << 25)	/* Switch core interrupt enable */
+#define PABCIE					(1 << 24)	/* GPIO port ABC interrupt enable */
+#define IREQ0IE					(1 << 23)	/* External interrupt 0 enable */
+#define LBCTMOIE				(1 << 21)	/* LBC time-out interrupt enable */
+/* Global interrupt status register field definitions
+*/
+#define TCIP					(1 << 31)	/* Timer/Counter interrupt pending */
+#define USBIP					(1 << 30)	/* USB host interrupt pending */
+#define PCMCIAIP				(1 << 29)	/* PCMCIA interrupt pending */
+#define UART1IP					(1 << 28)	/* UART 1 interrupt pending */
+#define UART0IP					(1 << 27)	/* UART 0 interrupt pending */
+#define PCIIP					(1 << 26)	/* PCI host interrupt pending */
+#define SWIP					(1 << 25)	/* Switch core interrupt pending */
+#define PABCIP					(1 << 24)	/* GPIO port ABC interrupt pending */
+#define IREQIP					(1 << 23)	/* External interrupt 0 pending */
+#define LBCTMOIP				(1 << 21)	/* LBC time-out interrupt pending */
+#define LX0_BFRAME_IP				(1 << 1)	/* LBC 0 bus frame time-out interrupt pending flag */
+/* Interrupt routing register field definitions
+*/
+#define TCIRS_OFFSET				30	/* Timer/Counter interrupt routing select offset */
+#define USBIRS_OFFSET				28	/* USB interrupt routing select offset */
+#define PCMCIAIRS_OFFSET			26	/* PCI interrupt routing select offset */
+#define UART1IRS_OFFSET				24	/* UART 1 interrupt routing select offset */
+#define UART0IRS_OFFSET				22	/* UART 0 interrupt routing select offset */
+#define PCIIRS_OFFSET				20	/* USB 1 interrupt routing select offset */
+#define SWIRS_OFFSET				18	/* Switch core interrupt routing select offset */
+#define PABCIRS_OFFSET				16	/* GPIO port B interrupt routing select offset */
+#define IREQ0RS_OFFSET				14	/* External interrupt 0 routing select offset */
+#define LBCTMOIRS_OFFSET			10	/* LBC time-out interrupt routing select offset */
+
+/* PLTC: Peripheral Lexra timeout control register field definitions
+*/
+#define TOEN					(1 << 31)
+#define TOLIMIT_2_7				(0 << 28)
+#define TOLIMIT_2_8				(1 << 28)
+#define TOLIMIT_2_9				(2 << 28)
+#define TOLIMIT_2_10				(3 << 28)
+#define TOLIMIT_2_11				(4 << 28)
+#define TOLIMIT_2_12				(5 << 28)
+#define TOLIMIT_2_13				(6 << 28)
+#define TOLIMIT_2_14				(7 << 28)
+
+/* Timer control registers
+*/
+#define TIMER_BASE				(SYSTEM_BASE+0x3100)	/* 0xB8003100 */
+#define TC0DATA					(0x000 + TIMER_BASE)	/* Timer/Counter 0 data */
+#define TC1DATA					(0x004 + TIMER_BASE)	/* Timer/Counter 1 data */
+#define TC0CNT					(0x008 + TIMER_BASE)	/* Timer/Counter 0 count */
+#define TC1CNT					(0x00C + TIMER_BASE)	/* Timer/Counter 1 count */
+#define TCCNR					(0x010 + TIMER_BASE)	/* Timer/Counter control */
+#define TCIR					(0x014 + TIMER_BASE)	/* Timer/Counter intertupt */
+#define CDBR					(0x018 + TIMER_BASE)	/* Clock division base */
+#define WDTCNR					(0x01C + TIMER_BASE)	/* Watchdog timer control */
+/* Timer/Counter data register field definitions
+*/
+#define TCD_OFFSET				8
+/* Timer/Counter control register field defintions
+*/
+#define TC0EN					(1 << 31)	/* Timer/Counter 0 enable */
+#define TC0MODE_COUNTER				0	/* Timer/Counter 0 counter mode */
+#define TC0MODE_TIMER				(1 << 30)	/* Timer/Counter 0 timer mode */
+#define TC1EN					(1 << 29)	/* Timer/Counter 1 enable */
+#define TC1MODE_COUNTER				0	/* Timer/Counter 1 counter mode */
+#define TC1MODE_TIMER				(1 << 28)	/* Timer/Counter 1 timer mode */
+/* Timer/Counter interrupt register field definitions
+*/
+#define TC0IE					((uint32)1 << 31)	/* Timer/Counter 0 interrupt enable */
+#define TC1IE					(1 << 30)	/* Timer/Counter 1 interrupt enable */
+#define TC0IP					(1 << 29)	/* Timer/Counter 0 interrupt pending */
+#define TC1IP					(1 << 28)	/* Timer/Counter 1 interrupt pending */
+/* Clock division base register field definitions
+*/
+#define DIVF_OFFSET				16
+/* Watchdog control register field definitions
+*/
+#define WDTE_OFFSET				24	/* Watchdog enable */
+#define WDSTOP_PATTERN				0xA5	/* Watchdog stop pattern */
+#define WDTCLR					(1 << 23)	/* Watchdog timer clear */
+#define OVSEL_15				0	/* Overflow select count 2^15 */
+#define OVSEL_16				(1 << 21)	/* Overflow select count 2^16 */
+#define OVSEL_17				(2 << 21)	/* Overflow select count 2^17 */
+#define OVSEL_18				(3 << 21)	/* Overflow select count 2^18 */
+#define WDTIND					(1 << 20)	/* Indicate whether watchdog ever occurs */
+/* RTC control register field definitions */
+#define WRITE_CDLW_OK				(1 << 31)	/* Write CDLW OK */
+#define RTCSEL					(1 << 30)	/* Fase mode */
+#define RTCEN					(1 << 29)	/* Enable */
+
+/* System clock generation */
+#define SCCR					(SYSTEM_BASE+0x3200)	/* 0xB8003200  System Clock Control Register */
+#define DPLCR0					(SCCR+0x04)	/* DPLL Clock Control Register 0 */
+#define DPLCR1					(SCCR+0x08)	/* DPLL Clock Control Register 1 */
+#define PCCR					(SCCR+0x0C)	/* Peripheral Clock Control Register */
+
+#define SCCR_CPU_OFFSET				4	/* SCCR CPU(Lexra Bus 0) status offset */
+#define SCCR_STATUS_MASK			0x07	/* SCCR LexaBus0/LexaBus1/Memory mask */
+
+#define EN_S0DPLL				(1 << 31)	/* Enable S0DPLL Tuning */
+#define EN_S1DPLL				(1 << 30)	/* Enable S1DPLL Tuning */
+#define EN_MDPLL				(1 << 31)	/* Enable MDPLL Tuning */
+#define S0UPDPLL_MASK				0x3F	/* S0_UP_DPLL mask */
+#define MUPDPLL_MASK				0x3F	/* M_UP_DPLL mask */
+#define S0DOWNDPLL_MASK				0x1F	/* S0_DOWN_DPLL mask */
+#define MDOWNDPLL_MASK				0x1F	/* M_DOWN_DPLL mask */
+#define S0UPDPLL_OFFSET				16	/* S0_UP_DPLL status offset */
+#define MUPDPLL_OFFSET				5	/* M_UP_DPLL status offset */
+#define S0DOWNDPLL_OFFSET			11	/* S0_DOWN_DPLL status offset */
+#define MDOWNDPLL_OFFSET			0	/* M_DOWN_DPLL status offset */
+
+#define S0DOWNDPLL_VALUE			(9 << S0DOWNDPLL_OFFSET)	/* S0_DOWN_DPLL default test value */
+#define S0UPDPLL_VALUE_225MHZ			(17 << S0UPDPLL_OFFSET)	/* S0_UP_DPLL test value 0 */
+#define S0UPDPLL_VALUE_250MHZ			(19 << S0UPDPLL_OFFSET)	/* S0_UP_DPLL test value 1 */
+#define S0UPDPLL_VALUE_275MHZ			(21 << S0UPDPLL_OFFSET)	/* S0_UP_DPLL test value 2 */
+#define S0UPDPLL_VALUE_300MHZ			(23 << S0UPDPLL_OFFSET)	/* S0_UP_DPLL test value 3 */
+#define S0UPDPLL_VALUE_325MHZ			(25 << S0UPDPLL_OFFSET)	/* S0_UP_DPLL test value 4 */
+#define S0UPDPLL_VALUE_350MHZ			(27 << S0UPDPLL_OFFSET)	/* S0_UP_DPLL test value 5 */
+#define S0UPDPLL_VALUE_375MHZ			(29 << S0UPDPLL_OFFSET)	/* S0_UP_DPLL test value 6 */
+#define S0UPDPLL_VALUE_400MHZ			(31 << S0UPDPLL_OFFSET)	/* S0_UP_DPLL test value 7 */
+#define S0UPDPLL_VALUE_NUM			8	/* S0_UP_DPLL total test values */
+#define S0UPDPLL_VALUE_DEFAULT 			S0UPDPLL_VALUE_275MHZ	/* S0_UP_DPLL default test value */
+
+#define MDOWNDPLL_VALUE				(9 << MDOWNDPLL_OFFSET)	/* M_DOWN_DPLL default test value */
+#define MUPDPLL_VALUE_137MHZ			(10 << MUPDPLL_OFFSET)	/* M_UP_DPLL test value 0 */
+#define MUPDPLL_VALUE_150MHZ			(11 << MUPDPLL_OFFSET)	/* M_UP_DPLL test value 1 */
+#define MUPDPLL_VALUE_162MHZ			(12 << MUPDPLL_OFFSET)	/* M_UP_DPLL test value 2 */
+#define MUPDPLL_VALUE_175MHZ			(13 << MUPDPLL_OFFSET)	/* M_UP_DPLL test value 3 */
+#define MUPDPLL_VALUE_187MHZ			(14 << MUPDPLL_OFFSET)	/* M_UP_DPLL test value 4 */
+#define MUPDPLL_VALUE_NUM			5	/* M_UP_DPLL total test values */
+#define MUPDPLL_VALUE_DEFAULT 			MUPDPLL_VALUE_137MHZ	/* M_UP_DPLL default test value */
+
+/*added by Mark*/
+/*PCI control regs*/
+#define PCI_CTRL_BASE				(SYSTEM_BASE+0x3400)	/* 0xB8003400 */
+
+/* GPIO Register Set */
+#define GPIO_BASE				(SYSTEM_BASE+0x3500)	/* 0xB8003500 */
+
+#define PABCD_CNR				(GPIO_BASE + 0x00)
+#define PABCD_PTYPE				(GPIO_BASE + 0x04)
+#define PABCD_DIR				(GPIO_BASE + 0x08)
+#define PABCD_DAT				(GPIO_BASE + 0x0C)
+#define PABCD_ISR				(GPIO_BASE + 0x10)
+#define PAB_IMR					(GPIO_BASE + 0x14)
+#define PCD_IMR					(GPIO_BASE + 0x18)
+#define PEFGH_CNR				(GPIO_BASE + 0x1C)
+#define PEFGH_PTYPE				(GPIO_BASE + 0x20)
+#define PEFGH_DIR				(GPIO_BASE + 0x24)
+#define PEFGH_DAT				(GPIO_BASE + 0x28)
+#define PEFGH_ISR				(GPIO_BASE + 0x2C)
+#define PEF_IMR					(GPIO_BASE + 0x30)
+#define PGH_IMR					(GPIO_BASE + 0x34)
+
+#define PABCDCNR_REG				PABCD_CNR	/* Port ABCD control */
+#define PABCDPTYPE_REG				PABCD_PTYPE	/* Port ABCD type */
+#define PABCDDIR_REG				PABCD_DIR	/* Port ABCD direction */
+#define PABCDDAT_REG				PABCD_DAT	/* Port ABCD data */
+#define PABCDISR_REG				PABCD_ISR	/* Port ABCD interrupt status */
+#define PABIMR_REG				PAB_IMR	/* Port AB interrupt mask */
+#define PCDIMR_REG				PCD_IMR	/* Port CD interrupt mask */
+#define PEFGHCNR_REG				PEFGH_CNR	/* Port ABCD control */
+#define PEFGHPTYPE_REG				PEFGH_PTYPE	/* Port ABCD type */
+#define PEFGHDIR_REG				PEFGH_DIR	/* Port ABCD direction */
+#define PEFGHDAT_REG				PEFGH_DAT	/* Port ABCD data */
+#define PEFGHISR_REG				PEFGH_ISR	/* Port ABCD interrupt status */
+#define PEFIMR_REG				PEF_IMR	/* Port AB interrupt mask */
+#define PGHIMR_REG				PGH_IMR	/* Port CD interrupt mask */
+
+/* Port ABC data register field definitions
+*/
+#define PDA_OFFSET				24	/* Port A data offset */
+#define PDB_OFFSET				16	/* Port B data offset */
+#define PDC_OFFSET				8	/* Port C data offset */
+/* Port ABC interrupt status register field definitions
+*/
+#define PAIP_OFFSET				24	/* Port A pending status offset */
+#define PBIP_OFFSET				16	/* Port B pending status offset */
+#define PCIP_OFFSET				8	/* Port C pending status offset */
+
+#define CRYPTO_BASE			 	(SYSTEM_BASE+0xC000)	/* 0xB801C000 */
+#define IPSSDAR					(CRYPTO_BASE+0x00)	/* IPSec Source Descriptor Starting Address Register */
+#define IPSDDAR					(CRYPTO_BASE+0x04)	/* IPSec Destination Descriptor Starting Address Register */
+#define IPSCSR					(CRYPTO_BASE+0x08)	/* IPSec Command/Status Register */
+#define IPSCTR					(CRYPTO_BASE+0x0C)	/* IPSec Control Register */
+
+/* IPSec Command/Status Register */
+#define IPS_SDUEIP				(1<<15)	/* Source Descriptor Unavailable Error Interrupt Pending */
+#define IPS_SDLEIP				(1<<14)	/* Source Descriptor Length Error Interrupt Pending */
+#define IPS_DDUEIP				(1<<13)	/* Destination Descriptor Unavailable Error Interrupt Pending */
+#define IPS_DDOKIP				(1<<12)	/* Destination Descriptor OK Interrupt Pending */
+#define IPS_DABFIP				(1<<11)	/* Data Address Buffer Interrupt Pending */
+#define IPS_POLL				(1<<1)	/* Descriptor Polling. Set 1 to kick crypto engine to fetch source descriptor. */
+#define IPS_SRST				(1<<0)	/* Software reset, write 1 to reset */
+
+/* IPSec Control Register */
+#define IPS_SDUEIE				(1<<15)	/* Source Descriptor Unavailable Error Interrupt Enable */
+#define IPS_SDLEIE				(1<<14)	/* Source Descriptor Length Error Interrupt Enable */
+#define IPS_DDUEIE				(1<<13)	/* Destination Descriptor Unavailable Error Interrupt Enable */
+#define IPS_DDOKIE				(1<<12)	/* Destination Descriptor OK Interrupt Enable */
+#define IPS_DABFIE				(1<<11)	/* Data Address Buffer Interrupt Enable */
+#define IPS_LBKM				(1<<8)	/* Loopback mode enable */
+#define IPS_SAWB				(1<<7)	/* Source Address Write Back */
+#define IPS_CKE					(1<<6)	/* Clock enable */
+#define IPS_DMBS_MASK				(0x7<<3)	/* Mask for Destination DMA Maximum Burst Size */
+#define IPS_DMBS_16				(0x0<<3)	/* 16 Bytes */
+#define IPS_DMBS_32				(0x1<<3)	/* 32 Bytes */
+#define IPS_DMBS_64				(0x2<<3)	/* 64 Bytes */
+#define IPS_DMBS_128				(0x3<<3)	/* 128 Bytes */
+#define IPS_SMBS_MASK				(0x7<<0)	/* Mask for SourceDMA Maximum Burst Size */
+#define IPS_SMBS_16				(0x0<<0)	/* 16 Bytes */
+#define IPS_SMBS_32				(0x1<<0)	/* 32 Bytes */
+#define IPS_SMBS_64				(0x2<<0)	/* 64 Bytes */
+#define IPS_SMBS_128				(0x3<<0)	/* 128 Bytes */
+
+/* PCM */
+#define PCM_BASE				(SYSTEM_BASE+0x8000)	/* 0xB8008000 */
+#define PCM_GCR					(PCM_BASE+0x00)	/* PCM Generic Control Register */
+#define PCM_SCR					(PCM_BASE+0x04)	/* PCM Specific Control Register */
+#define PCM_TSAR				(PCM_BASE+0x08)	/* PCM Time Slot Assignment Register */
+#define PCM_BSIZE				(PCM_BASE+0x0C)	/* PCM Buffer Size Register */
+#define PCM_CH0TXBSA				(PCM_BASE+0x10)	/* PCM Channel 0 Tx Buffer Starting Address */
+#define PCM_CH1TXBSA				(PCM_BASE+0x14)	/* PCM Channel 1 Tx Buffer Starting Address */
+#define PCM_CH2TXBSA				(PCM_BASE+0x18)	/* PCM Channel 2 Tx Buffer Starting Address */
+#define PCM_CH3TXBSA				(PCM_BASE+0x1C)	/* PCM Channel 3 Tx Buffer Starting Address */
+#define PCM_CH0RXBSA				(PCM_BASE+0x20)	/* PCM Channel 0 Rx Buffer Starting Address */
+#define PCM_CH1RXBSA				(PCM_BASE+0x24)	/* PCM Channel 1 Rx Buffer Starting Address */
+#define PCM_CH2RXBSA				(PCM_BASE+0x28)	/* PCM Channel 2 Rx Buffer Starting Address */
+#define PCM_CH3RXBSA				(PCM_BASE+0x2C)	/* PCM Channel 3 Rx Buffer Starting Address */
+#define PCM_IMR					(PCM_BASE+0x30)	/* PCM Interrupt Mask Register */
+#define PCM_ISR					(PCM_BASE+0x34)	/* PCM Interrupt Status Register */
+
+#define PAGE1_PCM_OWN 				( 1 << 1 )
+#define PAGE0_PCM_OWN 				( 1 << 0 )
+#define PCM_PAGE0 				0
+#define PCM_PAGE1 				1
+#define PCM_CHANNEL0 				0
+#define PCM_CHANNEL1 				1
+#define PCM_CHANNEL2 				2
+#define PCM_CHANNEL3 				3
+#define PCM_LINEAR	 			0
+#define PCM_ALAW	 			1
+#define PCM_ULAW	 			2
+
+/* PCM Generic Control Register
+*/
+#define PCM_AE					(1<<12)	/* Interrupt Enable */
+#define PCM_CLKDIR				(1<<11)	/* 0:external source from codec, 1:internal PLL */
+#define PCM_EXDSE				(1<<10)	/* PCM interface A Extra Data Strobe Enable */
+#define PCM_FSINV				(1<< 9)	/* PCM interface frame synchronization polarity invert */
+#define PCM_ICC_OFFSET				(0)	/* PCM interface Channel Inter Change control */
+#define PCM_ICC_MASK				(0xf<<PCM_ICC_OFFSET)	/* PCM interface Channel Inter Change control */
+
+/* PCM Specific Control Register
+*/
+#define PCM_allCHILBE				(1<<28)	/* all channel internal loop back enable */
+
+#define PCM_CH0CMPE				(1<<27)	/* Channel 0 compander enable */
+#define PCM_CH0uA				(1<<26)	/* Channel 0 u-law/A-law selection; 0:u-law, 1:A-law */
+#define PCM_CH0TE				(1<<25)	/* Channel 0 transmitter enable */
+#define PCM_CH0RE				(1<<24)	/* Channel 0 receiver enable */
+
+#define PCM_CH1CMPE				(1<<19)	/* Channel 1 compander enable */
+#define PCM_CH1uA				(1<<18)	/* Channel 1 u-law/A-law selection; 0:u-law, 1:A-law */
+#define PCM_CH1TE				(1<<17)	/* Channel 1 transmitter enable */
+#define PCM_CH1RE				(1<<16)	/* Channel 1 receiver enable */
+
+#define PCM_CH2CMPE				(1<< 11)	/* Channel 2 compander enable */
+#define PCM_CH2uA				(1<< 10)	/* Channel 2 u-law/A-law selection; 0:u-law, 1:A-law */
+#define PCM_CH2TE				(1<< 9)	/* Channel 2 transmitter enable */
+#define PCM_CH2RE				(1<< 8)	/* Channel 2 receiver enable */
+
+#define PCM_CH3CMPE				(1<< 3)	/* Channel 3 compander enable */
+#define PCM_CH3uA				(1<< 2)	/* Channel 3 u-law/A-law selection; 0:u-law, 1:A-law */
+#define PCM_CH3TE				(1<< 1)	/* Channel 3 transmitter enable */
+#define PCM_CH3RE				(1<< 0)	/* Channel 3 receiver enable */
+
+/* PCM Time Slot Assignment Register
+*/
+#define PCM_CH0TSA_OFFSET			(24)	/* Channel 0 Time Slot Assignment */
+#define PCM_CH0TSA_MASK				(0x1f<<PCM_CH0TSA_OFFSET)	/* Channel 0 Time Slot Assignment */
+#define PCM_CH1TSA_OFFSET			(16)	/* Channel 1 Time Slot Assignment */
+#define PCM_CH1TSA_MASK				(0x1f<<PCM_CH1TSA_OFFSET)	/* Channel 1 Time Slot Assignment */
+#define PCM_CH2TSA_OFFSET			( 8)	/* Channel 2 Time Slot Assignment */
+#define PCM_CH2TSA_MASK				(0x1f<<PCM_CH2TSA_OFFSET)	/* Channel 2 Time Slot Assignment */
+#define PCM_CH3TSA_OFFSET			( 0)	/* Channel 3 Time Slot Assignment */
+#define PCM_CH3TSA_MASK				(0x1f<<PCM_CH3TSA_OFFSET)	/* Channel 3 Time Slot Assignment */
+
+/* PCM Buffer Size Register
+*/
+#define PCM_CH0BSIZE_OFFSET			(24)	/* Channel 0 Buffer Size 4(n+1) bytes */
+#define PCM_CH0BSIZE_MASK			(0xff<<PCM_CH0BSIZE_OFFSET)	/* Channel 0 Buffer Size 4(n+1) bytes */
+#define PCM_CH1BSIZE_OFFSET			(16)	/* Channel 1 Buffer Size 4(n+1) bytes */
+#define PCM_CH1BSIZE_MASK			(0xff<<PCM_CH1BSIZE_OFFSET)	/* Channel 1 Buffer Size 4(n+1) bytes */
+#define PCM_CH2BSIZE_OFFSET			( 8)	/* Channel 2 Buffer Size 4(n+1) bytes */
+#define PCM_CH2BSIZE_MASK			(0xff<<PCM_CH2BSIZE_OFFSET)	/* Channel 2 Buffer Size 4(n+1) bytes */
+#define PCM_CH3BSIZE_OFFSET			( 0)	/* Channel 3 Buffer Size 4(n+1) bytes */
+#define PCM_CH3BSIZE_MASK			(0xff<<PCM_CH3BSIZE_OFFSET)	/* Channel 3 Buffer Size 4(n+1) bytes */
+
+/* PCM Channel 0 Tx Buffer Starting Address */
+/* PCM Channel 1 Tx Buffer Starting Address */
+/* PCM Channel 2 Tx Buffer Starting Address */
+/* PCM Channel 3 Tx Buffer Starting Address */
+/* PCM Channel 0 Rx Buffer Starting Address */
+/* PCM Channel 1 Rx Buffer Starting Address */
+/* PCM Channel 2 Rx Buffer Starting Address */
+/* PCM Channel 3 Rx Buffer Starting Address */
+#define PCM_TXBUFPTR_MASK			(0xfffffffc)	/* Physical Tx buffer starting address */
+#define PCM_P1OWN				(0x00000002)	/* Page 1 own bit; 1:PCM own, 0:CPU own */
+#define PCM_P0OWN				(0x00000001)	/* Page 0 own bit; 1:PCM own, 0:CPU own */
+
+/* PCM Interrupt Mask Register
+*/
+#define PCM_CH0P0OKIE				(1<<15)	/* Channel 0 page 0 OK Interrupt Enable */
+#define PCM_CH0P1OKIE				(1<<14)	/* Channel 0 page 1 OK Interrupt Enable */
+#define PCM_CH0TBUAIE				(1<<13)	/* Channel 0 Transmit Buffer Unavailable Interrupt Enable */
+#define PCM_CH0RBUAIE				(1<<12)	/* Channel 0 Receive Buffer Unavailable Interrupt Enable */
+#define PCM_CH1P0OKIE				(1<<11)	/* Channel 1 page 0 OK Interrupt Enable */
+#define PCM_CH1P1OKIE				(1<<10)	/* Channel 1 page 1 OK Interrupt Enable */
+#define PCM_CH1TBUAIE				(1<< 9)	/* Channel 1 Transmit Buffer Unavailable Interrupt Enable */
+#define PCM_CH1RBUAIE				(1<< 8)	/* Channel 1 Receive Buffer Unavailable Interrupt Enable */
+#define PCM_CH2P0OKIE				(1<< 7)	/* Channel 2 page 0 OK Interrupt Enable */
+#define PCM_CH2P1OKIE				(1<< 6)	/* Channel 2 page 1 OK Interrupt Enable */
+#define PCM_CH2TBUAIE				(1<< 5)	/* Channel 2 Transmit Buffer Unavailable Interrupt Enable */
+#define PCM_CH2RBUAIE				(1<< 4)	/* Channel 2 Receive Buffer Unavailable Interrupt Enable */
+#define PCM_CH3P0OKIE				(1<< 3)	/* Channel 3 page 0 OK Interrupt Enable */
+#define PCM_CH3P1OKIE				(1<< 2)	/* Channel 3 page 1 OK Interrupt Enable */
+#define PCM_CH3TBUAIE				(1<< 1)	/* Channel 3 Transmit Buffer Unavailable Interrupt Enable */
+#define PCM_CH3RBUAIE				(1<< 0)	/* Channel 3 Receive Buffer Unavailable Interrupt Enable */
+
+/* PCM Interrupt Status Register
+*/
+#define PCM_CH0TXP0IP				(1<<31)	/* Channel 0 Tx Page 0 Interrupt Pending */
+#define PCM_CH0TXP1IP				(1<<30)	/* Channel 0 Tx Page 1 Interrupt Pending */
+#define PCM_CH0RXP0IP				(1<<29)	/* Channel 0 Rx Page 0 Interrupt Pending */
+#define PCM_CH0RXP1IP				(1<<28)	/* Channel 0 Rx Page 1 Interrupt Pending */
+#define PCM_CH0TXP0UA				(1<<27)	/* Channel 0 Tx Page 0 Unavailable Interrupt Pending */
+#define PCM_CH0TXP1UA				(1<<26)	/* Channel 0 Tx Page 1 Unavailable Interrupt Pending */
+#define PCM_CH0RXP0UA				(1<<25)	/* Channel 0 Rx Page 0 Unavailable Interrupt Pending */
+#define PCM_CH0RXP1UA				(1<<24)	/* Channel 0 Rx Page 1 Unavailable Interrupt Pending */
+#define PCM_CH1TXP0IP				(1<<23)	/* Channel 1 Tx Page 0 Interrupt Pending */
+#define PCM_CH1TXP1IP				(1<<22)	/* Channel 1 Tx Page 1 Interrupt Pending */
+#define PCM_CH1RXP0IP				(1<<21)	/* Channel 1 Rx Page 0 Interrupt Pending */
+#define PCM_CH1RXP1IP				(1<<20)	/* Channel 1 Rx Page 1 Interrupt Pending */
+#define PCM_CH1TXP0UA				(1<<19)	/* Channel 1 Tx Page 0 Unavailable Interrupt Pending */
+#define PCM_CH1TXP1UA				(1<<18)	/* Channel 1 Tx Page 1 Unavailable Interrupt Pending */
+#define PCM_CH1RXP0UA				(1<<17)	/* Channel 1 Rx Page 0 Unavailable Interrupt Pending */
+#define PCM_CH1RXP1UA				(1<<16)	/* Channel 1 Rx Page 1 Unavailable Interrupt Pending */
+#define PCM_CH2TXP0IP				(1<<15)	/* Channel 2 Tx Page 0 Interrupt Pending */
+#define PCM_CH2TXP1IP				(1<<14)	/* Channel 2 Tx Page 1 Interrupt Pending */
+#define PCM_CH2RXP0IP				(1<<13)	/* Channel 2 Rx Page 0 Interrupt Pending */
+#define PCM_CH2RXP1IP				(1<<12)	/* Channel 2 Rx Page 1 Interrupt Pending */
+#define PCM_CH2TXP0UA				(1<<11)	/* Channel 2 Tx Page 0 Unavailable Interrupt Pending */
+#define PCM_CH2TXP1UA				(1<<10)	/* Channel 2 Tx Page 1 Unavailable Interrupt Pending */
+#define PCM_CH2RXP0UA				(1<< 9)	/* Channel 2 Rx Page 0 Unavailable Interrupt Pending */
+#define PCM_CH2RXP1UA				(1<< 8)	/* Channel 2 Rx Page 1 Unavailable Interrupt Pending */
+#define PCM_CH3TXP0IP				(1<< 7)	/* Channel 3 Tx Page 0 Interrupt Pending */
+#define PCM_CH3TXP1IP				(1<< 6)	/* Channel 3 Tx Page 1 Interrupt Pending */
+#define PCM_CH3RXP0IP				(1<< 5)	/* Channel 3 Rx Page 0 Interrupt Pending */
+#define PCM_CH3RXP1IP				(1<< 4)	/* Channel 3 Rx Page 1 Interrupt Pending */
+#define PCM_CH3TXP0UA				(1<< 3)	/* Channel 3 Tx Page 0 Unavailable Interrupt Pending */
+#define PCM_CH3TXP1UA				(1<< 2)	/* Channel 3 Tx Page 1 Unavailable Interrupt Pending */
+#define PCM_CH3RXP0UA				(1<< 1)	/* Channel 3 Rx Page 0 Unavailable Interrupt Pending */
+#define PCM_CH3RXP1UA				(1<< 0)	/* Channel 3 Rx Page 1 Unavailable Interrupt Pending */
+
+/* Generic DMA */
+#define GDMA_BASE				(SYSTEM_BASE+0xA000)	/* 0xB800A000 */
+#define GDMACNR					(GDMA_BASE+0x00)	/* Generic DMA Control Register */
+#define GDMAIMR					(GDMA_BASE+0x04)	/* Generic DMA Interrupt Mask Register */
+#define GDMAISR					(GDMA_BASE+0x08)	/* Generic DMA Interrupt Status Register */
+#define GDMAICVL				(GDMA_BASE+0x0C)	/* Generic DMA Initial Checksum Value (Left Part) Register */
+#define GDMAICVR				(GDMA_BASE+0x10)	/* Generic DMA Initial Checksum Value (Right Part) Register */
+#define GDMASBP0				(GDMA_BASE+0x20)	/* Generic DMA Source Block Pointer 0 Register */
+#define GDMASBL0				(GDMA_BASE+0x24)	/* Generic DMA Source Block Length 0 Register */
+#define GDMASBP1				(GDMA_BASE+0x28)	/* Generic DMA Source Block Pointer 1 Register */
+#define GDMASBL1				(GDMA_BASE+0x2C)	/* Generic DMA Source Block Length 1 Register */
+#define GDMASBP2				(GDMA_BASE+0x30)	/* Generic DMA Source Block Pointer 2 Register */
+#define GDMASBL2				(GDMA_BASE+0x34)	/* Generic DMA Source Block Length 2 Register */
+#define GDMASBP3				(GDMA_BASE+0x38)	/* Generic DMA Source Block Pointer 3 Register */
+#define GDMASBL3				(GDMA_BASE+0x3C)	/* Generic DMA Source Block Length 3 Register */
+#define GDMASBP4				(GDMA_BASE+0x40)	/* Generic DMA Source Block Pointer 4 Register */
+#define GDMASBL4				(GDMA_BASE+0x44)	/* Generic DMA Source Block Length 4 Register */
+#define GDMASBP5				(GDMA_BASE+0x48)	/* Generic DMA Source Block Pointer 5 Register */
+#define GDMASBL5				(GDMA_BASE+0x4C)	/* Generic DMA Source Block Length 5 Register */
+#define GDMASBP6				(GDMA_BASE+0x50)	/* Generic DMA Source Block Pointer 6 Register */
+#define GDMASBL6				(GDMA_BASE+0x54)	/* Generic DMA Source Block Length 6 Register */
+#define GDMASBP7				(GDMA_BASE+0x58)	/* Generic DMA Source Block Pointer 7 Register */
+#define GDMASBL7				(GDMA_BASE+0x5C)	/* Generic DMA Source Block Length 7 Register */
+#define GDMADBP0				(GDMA_BASE+0x60)	/* Generic DMA Destination Block Pointer 0 Register */
+#define GDMADBL0				(GDMA_BASE+0x64)	/* Generic DMA Destination Block Length 0 Register */
+#define GDMADBP1				(GDMA_BASE+0x68)	/* Generic DMA Destination Block Pointer 1 Register */
+#define GDMADBL1				(GDMA_BASE+0x6C)	/* Generic DMA Destination Block Length 1 Register */
+#define GDMADBP2				(GDMA_BASE+0x70)	/* Generic DMA Destination Block Pointer 2 Register */
+#define GDMADBL2				(GDMA_BASE+0x74)	/* Generic DMA Destination Block Length 2 Register */
+#define GDMADBP3				(GDMA_BASE+0x78)	/* Generic DMA Destination Block Pointer 3 Register */
+#define GDMADBL3				(GDMA_BASE+0x7C)	/* Generic DMA Destination Block Length 3 Register */
+#define GDMADBP4				(GDMA_BASE+0x80)	/* Generic DMA Destination Block Pointer 4 Register */
+#define GDMADBL4				(GDMA_BASE+0x84)	/* Generic DMA Destination Block Length 4 Register */
+#define GDMADBP5				(GDMA_BASE+0x88)	/* Generic DMA Destination Block Pointer 5 Register */
+#define GDMADBL5				(GDMA_BASE+0x8C)	/* Generic DMA Destination Block Length 5 Register */
+#define GDMADBP6				(GDMA_BASE+0x90)	/* Generic DMA Destination Block Pointer 6 Register */
+#define GDMADBL6				(GDMA_BASE+0x94)	/* Generic DMA Destination Block Length 6 Register */
+#define GDMADBP7				(GDMA_BASE+0x98)	/* Generic DMA Destination Block Pointer 7 Register */
+#define GDMADBL7				(GDMA_BASE+0x9C)	/* Generic DMA Destination Block Length 7 Register */
+
+/* Generic DMA Control Register */
+#define GDMA_ENABLE				(1<<31)	/* Enable GDMA */
+#define GDMA_POLL				(1<<30)	/* Kick off GDMA */
+#define GDMA_FUNCMASK				(0xf<<24)	/* GDMA Function Mask */
+#define GDMA_MEMCPY				(0x0<<24)	/* Memory Copy */
+#define GDMA_CHKOFF				(0x1<<24)	/* Checksum Offload */
+#define GDMA_STCAM				(0x2<<24)	/* Sequential T-CAM */
+#define GDMA_MEMSET				(0x3<<24)	/* Memory Set */
+#define GDMA_B64ENC				(0x4<<24)	/* Base 64 Encode */
+#define GDMA_B64DEC				(0x5<<24)	/* Base 64 Decode */
+#define GDMA_QPENC				(0x6<<24)	/* Quoted Printable Encode */
+#define GDMA_QPDEC				(0x7<<24)	/* Quoted Printable Decode */
+#define GDMA_MIC				(0x8<<24)	/* Wireless MIC */
+#define GDMA_MEMXOR				(0x9<<24)	/* Memory XOR */
+#define GDMA_MEMCMP				(0xa<<24)	/* Memory Compare */
+#define GDMA_BYTESWAP				(0xb<<24)	/* Byte Swap */
+#define GDMA_PATTERN				(0xc<<24)	/* Pattern Match */
+#define GDMA_SWAPTYPE0				(0<<22)	/* Original:{0,1,2,3} => {1,0,3,2} */
+#define GDMA_SWAPTYPE1				(1<<22)	/* Original:{0,1,2,3} => {3,2,1,0} */
+#define GDMA_ENTSIZMASK				(3<<20)	/* T-CAM Entry Size Mask */
+#define GDMA_ENTSIZ32				(0<<20)	/* T-CAM Entry Size 32 bits */
+#define GDMA_ENTSIZ64				(1<<20)	/* T-CAM Entry Size 64 bits */
+#define GDMA_ENTSIZ128				(2<<20)	/* T-CAM Entry Size 128 bits */
+#define GDMA_ENTSIZ256				(3<<20)	/* T-CAM Entry Size 256 bits */
+
+/* Generic DMA Interrupt Mask Register */
+#define GDMA_COMPIE				(1<<31)	/* Completed Interrupt Enable */
+#define GDMA_NEEDCPUIE				(1<<28)	/* Need-CPU Interrupt Enable */
+
+/* Generic DMA Interrupt Status Register */
+#define GDMA_COMPIP				(1<<31)	/* Completed Interrupt Status (write 1 to clear) */
+#define GDMA_NEEDCPUIP				(1<<28)	/* Need-CPU Interrupt Status (write 1 to clear) */
+
+/* Generic DMA Source Block Length n. Register */
+#define GDMA_LDB				(1<<31)	/* Last Data Block */
+#define GDMA_BLKLENMASK				(0x1fff)	/* Block Length (valid value: from 1 to 8K-1 bytes) */
+
+//hyking:define for 8196C FIB test chip
+#if defined(CONFIG_RTL_8196C)
+#define RTL8196C_EEE_MAC
+#endif
+
+#ifndef REVR
+#define REVR					(SYSTEM_BASE+0x0000)
+#endif
+
+#ifndef BSP_REVR
+#define BSP_REVR				(SYSTEM_BASE+0x0000)
+#endif
+
+#ifndef RTL8196C_REVISION_A
+#define RTL8196C_REVISION_A			0x80000001
+#endif
+#ifndef RTL8196C_REVISION_B
+#define RTL8196C_REVISION_B			0x80000002
+#endif
+#define GIGA_P5_PHYID	0x16
+#define BSP_RTL8198_REVISION_A			0xC0000000
+#define BSP_RTL8198_REVISION_B			0xC0000001
+
+#define HW_STRAP				(SYSTEM_BASE+0x0008)
+#define BOND_OPTION				(SYSTEM_BASE+0x000C)
+
+#define BOND_ID_MASK				(0xF)
+
+#define BOND_8196EU1				(0x0)
+#define BOND_8196ES1				(0x1)
+#define BOND_8196E1				(0x3)
+#define BOND_8196EU3				(0x4)
+#define BOND_8196ES3				(0x5)
+#define BOND_8196E3				(0x7)
+#define BOND_8196EU2				(0x8)
+#define BOND_8196ES2				(0x9)
+#define BOND_8196E2				(0xB)
+#define BOND_8196EU				(0xC)
+#define BOND_8196ES				(0xD)
+#define BOND_8196ET				(0xE)
+#define BOND_8196E				(0xF)
+
+#define BOND_8197FB0				(0x0)
+#define BOND_8197FB1				(0x1)
+#define BOND_8197FB2				(0x2)
+#define BOND_8197FB3				(0x3)
+#define BOND_8197FN64				(0x4)
+#define BOND_8197FN128				(0x5)
+#define BOND_8197FN32				(0x6)
+#define BOND_8197FS64				(0xA)
+#define BOND_8197FS128				(0xB)
+#define BOND_8197FS32				(0xC)
+
+#define SYS_CLK_MAG				(SYSTEM_BASE+0x0010)
+#define SYS_SW_CLK_ENABLE			0x200
+#define SYS_SW_RESET				0x800
+#define CM_PROTECT				(1<<27)
+#define CM_ACTIVE_LX2_ARB			(1<<20)
+#define CM_ACTIVE_LX2_CLK			(1<<19)
+#define CM_ACTIVE_SWCORE			(1<<11)
+
+/*Shared Pin Register Set */
+#ifdef CONFIG_RTL_8196B
+#define PIN_MUX_SEL				(SYSTEM_BASE+0x0030)
+
+#elif defined(CONFIG_RTL_8198C)
+#define PIN_MUX_SEL				(SYSTEM_BASE+0x0100)
+#define PIN_MUX_SEL2				(SYSTEM_BASE+0x0104)
+#define PIN_MUX_SEL3				(SYSTEM_BASE+0x0108)
+#define PIN_MUX_SEL4				(SYSTEM_BASE+0x010C)
+#define PIN_MUX_SEL5				(SYSTEM_BASE+0x0110)
+#define PAD_CONTROL_2				(SYSTEM_BASE+0x0134)
+
+#elif defined(CONFIG_RTL_8197F)
+#define PIN_MUX_BASE				(0x800 + SYSTEM_BASE)
+#define PIN_MUX_SEL				(PIN_MUX_BASE+0x00)
+#define PIN_MUX_SEL1				(PIN_MUX_BASE+0x04)
+#define PIN_MUX_SEL2				(PIN_MUX_BASE+0x08)
+#define PIN_MUX_SEL6				(PIN_MUX_BASE+0x18)
+#define PIN_MUX_SEL7				(PIN_MUX_BASE+0x1C)
+#define PIN_MUX_SEL8				(PIN_MUX_BASE+0x20)
+#define PIN_MUX_SEL9				(PIN_MUX_BASE+0x24)
+#define PIN_MUX_SEL12				(PIN_MUX_BASE+0x30)
+#define PIN_MUX_SEL13				(PIN_MUX_BASE+0x34)
+#define PIN_MUX_SEL14				(PIN_MUX_BASE+0x38)
+#define PIN_MUX_SEL15				(PIN_MUX_BASE+0x3C)
+#define PIN_MUX_SEL16				(PIN_MUX_BASE+0x40)
+#define PIN_MUX_SEL17				(PIN_MUX_BASE+0x44)
+#define PIN_MUX_SEL18				(PIN_MUX_BASE+0x48)
+
+#else
+#define PIN_MUX_SEL				(SYSTEM_BASE+0x0040)
+#define PIN_MUX_SEL2				(SYSTEM_BASE+0x0044)
+#define PIN_MUX_SEL_2				(PIN_MUX_SEL2)
+#endif
+
+/* Shared Pin Register field definitions */
+#define REG_IOCFG_POMII				(3 << 0)	/* P0-MII Shared Pin Control Bits */
+#define REG_IOCFG_PCIE				(3 << 2)	/* PCIE Shared Pin Control Bits */
+#define REG_IOCFG_UART				(3 << 5)	/* UART Shared Pin Control Bits */
+#define REG_IOCFG_JTAG				(7 << 7)	/* JTAG  Shared Pin Control Bits */
+#define REG_IOCFG_LED_S0			(3 << 10)	/* LEDSIG0 Shared Pin Control Bits */
+#define REG_IOCFG_LED_S1			(3 << 12)	/* LEDSIG1 Shared Pin Control Bits */
+#define REG_IOCFG_LED_S2			(3 << 14)	/* LEDSIG2 Shared Pin Control Bits */
+#define REG_IOCFG_LED_S3			(3 << 16)	/* LEDSIG3 Shared Pin Control Bits */
+#define REG_IOCFG_LED_P0			(3 << 18)	/* LEDPHASE0 Shared Pin Control Bits */
+#define REG_IOCFG_LED_P1			(3 << 20)	/* LEDPHASE1 Shared Pin Control Bits */
+#define REG_IOCFG_LED_P2			(3 << 22)	/* LEDPHASE2 Shared Pin Control Bits */
+#define REG_IOCFG_LED_P3			(3 << 24)	/* LEDPHASE3 Shared Pin Control Bits */
+#define REG_IOCFG_LED_P4			(3 << 26)	/* LEDPHASE4 Shared Pin Control Bits */
+
+#define PAD_CTRL_1                      	(SYSTEM_BASE+0x0850)
+
+#define PAD_P0_RGMII_DN_OFFSET          	(29)
+#define PAD_P0_RGMII_DN_MASK            	(0x7<<PAD_P0_RGMII_DN_OFFSET)
+#define PAD_P0_RGMII_DP_OFFSET          	(26)
+#define PAD_P0_RGMII_DP_MASK            	(0x7<<PAD_P0_RGMII_DP_OFFSET)
+#define PAD_P0_RGMII_MODE_OFFSET        	(25)
+#define PAD_P0_RGMII_MODE_MASK          	(0x1<<PAD_P0_RGMII_MODE_OFFSET)
+#define PAD_P0_TX_E2_OFFSET             	(22)
+#define PAD_P0_TX_E2_MASK               	(0x1<<PAD_P0_TX_E2_OFFSET)
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+/* 0x981C_8000 */
+#define HWNAT_SERDES_BASE			((uintptr_t) rtl_hwnat_mmio + HWNAT_SERDES_OFFSET)
+#define HWNAT_SERDES_SDS_REG00			(0x000 + HWNAT_SERDES_BASE)
+#define HWNAT_SERDES_SDS_REG01			(0x004 + HWNAT_SERDES_BASE)
+#define HWNAT_SERDES_SDS_REG02			(0x008 + HWNAT_SERDES_BASE)
+#define HWNAT_SERDES_SDS_REG03			(0x00C + HWNAT_SERDES_BASE)
+#define HWNAT_SERDES_SDS_REG04			(0x010 + HWNAT_SERDES_BASE)
+
+/* 0x981C_9000 */
+#define NAT_WRP_BASE				((uintptr_t) rtl_hwnat_mmio + HWNAT_NAT_WRP_OFFSET)
+#define NAT_WRP_DMY_A				(0x100 + NAT_WRP_BASE)	/* dummy reg A */
+#define NAT_WRP_DMY_B				(0x104 + NAT_WRP_BASE)	/* dummy reg B */
+#define NAT_WRP_DEBUG				(0x108 + NAT_WRP_BASE)	/* debug */
+#define NAT_WRP_SERDES				(0x10C + NAT_WRP_BASE)	/* SerDes */
+
+#define NAT_WRP_SERDES_sata_phy_mdio_en_shift	(12)
+#define NAT_WRP_SERDES_serdes_clk_en_shift	(9)
+#define NAT_WRP_SERDES_sdsif_clk_en_shift	(8)
+#define NAT_WRP_SERDES_sds_idx_shift		(0)
+
+/* 0x981C_9800 */
+#define SERDES_WRP_BASE				((uintptr_t) rtl_hwnat_mmio + HWNAT_SERDES_WRP_OFFSET)
+#define SERDES_WRP_SDS_MODE			(0x000 + SERDES_WRP_BASE)
+#define SERDES_WRP_SDS_MISC			(0x004 + SERDES_WRP_BASE)
+#define SERDES_WRP_SDS_LPI			(0x008 + SERDES_WRP_BASE)
+#define SERDES_WRP_SDS_LINK			(0x00C + SERDES_WRP_BASE)
+
+#define SERDES_WRP_SDS_MISC_sds_link_ok_sum_shift	(13)
+#define SERDES_WRP_SDS_MISC_sds_link_ok_shift		(12)
+
+#define SERDES_WRP_SDS_LINK_partner_ablity_shift	(12)
+#define SERDES_WRP_SDS_LINK_partner_fib_linkok		(1 << 4)
+
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#endif /* _ASICREGS_H */
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/sata_reg.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/sata_reg.h
new file mode 100644
index 00000000..6743b89
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/sata_reg.h
@@ -0,0 +1,1220 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+/**************************************************************
+// Spec Version                  : 0.6
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/7/15 20:39:21
+***************************************************************/
+
+
+#ifndef _SATA_REG_H_INCLUDED_
+#define _SATA_REG_H_INCLUDED_
+#ifdef  _SATA_USE_STRUCT
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     Mbist_sata_st:1;
+unsigned int     cp_pod1:1;
+unsigned int     cp_pod0:1;
+unsigned int     pme_req:1;
+unsigned int     sata_mac_int:1;
+}SATA_SATA_MAC_IN;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     sata_phy_rst_force:1;
+unsigned int     sata_phy_rstn:2;
+}SATA_SATA_FORCE_RST;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     sata_ls_en:1;
+unsigned int     sata_clk_gate_en:1;
+}SATA_SATA_SAVE;
+
+typedef struct
+{
+unsigned int     reserved_0:14;
+unsigned int     rx_error_CDR_sel:2;
+unsigned int     rx_error_sel:2;
+unsigned int     clk_mode_sel_1:2;
+unsigned int     clk_mode_sel_0:2;
+unsigned int     ckbuf_en1:1;
+unsigned int     ckbuf_en0:1;
+unsigned int     mp_switch1:1;
+unsigned int     mp_switch0:1;
+unsigned int     cp_det1:1;
+unsigned int     cp_det0:1;
+unsigned int     phy_rx_err_1:1;
+unsigned int     phy_rx_err_0:1;
+unsigned int     phy_iprx_en_1:1;
+unsigned int     phy_iprx_en_0:1;
+}SATA_SATA_CTR;
+
+typedef struct
+{
+unsigned int     reserved_0:28;
+unsigned int     phy_rdy_1:1;
+unsigned int     phy_rdy_0:1;
+unsigned int     phy_calibrated_1:1;
+unsigned int     phy_calibrated_0:1;
+}SATA_SATA_PHY_MON;
+
+typedef struct
+{
+unsigned int     reserved_0:14;
+unsigned int     rdata_in_order:1;
+unsigned int     wcmd_bufable_sel:1;
+unsigned int     reserved_1:4;
+unsigned int     outstd_wcmd:4;
+unsigned int     reserved_2:3;
+unsigned int     outstd_rcmd:5;
+}SATA_SATA_WRAPPER_DMA_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     dbus2_remote_cmd_num:4;
+unsigned int     reserved_1:4;
+unsigned int     dbus_remote_cmd_num:4;
+unsigned int     reserved_2:2;
+unsigned int     dbus2_remote_wdata_num:6;
+unsigned int     reserved_3:2;
+unsigned int     dbus_remote_wdata_num:6;
+}SATA_SATA_WRAPPER_DC_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:19;
+unsigned int     dbg_sel1:6;
+unsigned int     dbg_sel0:6;
+unsigned int     dbg_en:1;
+}SATA_SATA_DBG;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     sram_debug_sel:1;
+unsigned int     sram_debug_mode:1;
+}SATA_WRAP_CTR;
+
+typedef struct
+{
+unsigned int     data:16;
+unsigned int     phy_addr:2;
+unsigned int     phy_reg_addr:6;
+unsigned int     mdio_busy:1;
+unsigned int     mdio_st:2;
+unsigned int     mdio_rdy:1;
+unsigned int     mclk_rate:2;
+unsigned int     mdio_srst:1;
+unsigned int     mdio_rdwr:1;
+}SATA_MDIO_CTR;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     phy_sel:1;
+}SATA_MDIO_CTR1;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     p1_spd_mode_st:2;
+unsigned int     p0_spd_mode_st:2;
+unsigned int     p1_spd_mode:2;
+unsigned int     p0_spd_mode:2;
+}SATA_SPD;
+
+typedef struct
+{
+unsigned int     reserved_0:15;
+unsigned int     done_st:1;
+unsigned int     reserved_1:15;
+unsigned int     go_ct:1;
+}SATA_RAM_CTR;
+
+typedef struct
+{
+unsigned int     sram_addr:32;
+}SATA_RAM_ADDR;
+
+typedef struct
+{
+unsigned int     ram_wdata:32;
+}SATA_RAM_WDATA;
+
+typedef struct
+{
+unsigned int     ram_rdata:32;
+}SATA_RAM_RDATA;
+
+typedef struct
+{
+unsigned int     p0_csr_diagnr:32;
+}SATA_SATA_MAC_P0_DBG0;
+
+typedef struct
+{
+unsigned int     p0_csr_diagnr1:32;
+}SATA_SATA_MAC_P0_DBG1;
+
+typedef struct
+{
+unsigned int     p0_csr_is:32;
+}SATA_SATA_MAC_P0_DBG2;
+
+typedef struct
+{
+unsigned int     p0_csr_cmd:32;
+}SATA_SATA_MAC_P0_DBG3;
+
+typedef struct
+{
+unsigned int     p1_csr_diagnr:32;
+}SATA_SATA_MAC_P1_DBG0;
+
+typedef struct
+{
+unsigned int     p1_csr_diagnr1:32;
+}SATA_SATA_MAC_P1_DBG1;
+
+typedef struct
+{
+unsigned int     p1_csr_is:32;
+}SATA_SATA_MAC_P1_DBG2;
+
+typedef struct
+{
+unsigned int     p1_csr_cmd:32;
+}SATA_SATA_MAC_P1_DBG3;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     p0_rx_error:1;
+unsigned int     p0_link_state:5;
+}SATA_SATA_MAC_P0_DBG4;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     p1_rx_error:1;
+unsigned int     p1_link_state:5;
+}SATA_SATA_MAC_P1_DBG4;
+
+typedef struct
+{
+unsigned int     reserved_0:15;
+unsigned int     sata_bist1_ls10:2;
+unsigned int     sata_bist1_rm_1:4;
+unsigned int     sata_bist1_rme_1:1;
+unsigned int     sata_bist1_rm_0:4;
+unsigned int     sata_bist1_rme_0:1;
+unsigned int     sata_drf_1_test_resume:1;
+unsigned int     sata_drf_bist1_en:1;
+unsigned int     sata_bist1_en:1;
+unsigned int     sata_bist1_rstn:1;
+unsigned int     sata_bist1_test_mode:1;
+}SATA_SATA_BIST1_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:21;
+unsigned int     sata_bist2_ls50:6;
+unsigned int     sata_drf_2_test_resume:1;
+unsigned int     sata_drf_bist2_en:1;
+unsigned int     sata_bist2_en:1;
+unsigned int     sata_bist2_rstn:1;
+unsigned int     sata_bist2_test_mode:1;
+}SATA_SATA_BIST2_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:2;
+unsigned int     sata_bist2_rm_5:4;
+unsigned int     sata_bist2_rme_5:1;
+unsigned int     sata_bist2_rm_4:4;
+unsigned int     sata_bist2_rme_4:1;
+unsigned int     sata_bist2_rm_3:4;
+unsigned int     sata_bist2_rme_3:1;
+unsigned int     sata_bist2_rm_2:4;
+unsigned int     sata_bist2_rme_2:1;
+unsigned int     sata_bist2_rm_1:4;
+unsigned int     sata_bist2_rme_1:1;
+unsigned int     sata_bist2_rm_0:4;
+unsigned int     sata_bist2_rme_0:1;
+}SATA_SATA_BIST2_CTRL1;
+
+typedef struct
+{
+unsigned int     reserved_0:25;
+unsigned int     sata_drf_bist1_fail_1:1;
+unsigned int     sata_bist1_fail_1:1;
+unsigned int     sata_drf_bist1_fail_0:1;
+unsigned int     sata_bist1_fail_0:1;
+unsigned int     sata_drf_1_start_pause:1;
+unsigned int     sata_drf_bist1_done:1;
+unsigned int     sata_bist1_done:1;
+}SATA_SATA_BIST1_STS;
+
+typedef struct
+{
+unsigned int     reserved_0:17;
+unsigned int     sata_drf_bist2_fail_5:1;
+unsigned int     sata_bist2_fail_5:1;
+unsigned int     sata_drf_bist2_fail_4:1;
+unsigned int     sata_bist2_fail_4:1;
+unsigned int     sata_drf_bist2_fail_3:1;
+unsigned int     sata_bist2_fail_3:1;
+unsigned int     sata_drf_bist2_fail_2:1;
+unsigned int     sata_bist2_fail_2:1;
+unsigned int     sata_drf_bist2_fail_1:1;
+unsigned int     sata_bist2_fail_1:1;
+unsigned int     sata_drf_bist2_fail_0:1;
+unsigned int     sata_bist2_fail_0:1;
+unsigned int     sata_drf_2_start_pause:1;
+unsigned int     sata_drf_bist2_done:1;
+unsigned int     sata_bist2_done:1;
+}SATA_SATA_BIST2_STS;
+
+typedef struct
+{
+unsigned int     dummy_0:32;
+}SATA_SATA_DUMMY_0_REG;
+
+typedef struct
+{
+unsigned int     dummy_1:32;
+}SATA_SATA_DUMMY_1_REG;
+
+#endif
+
+#define SATA_SATA_MAC_IN                                                             0x9803FF00
+#define SATA_SATA_MAC_IN_reg_addr                                                    "0xD803FF00"
+#define SATA_SATA_MAC_IN_reg                                                         0xD803FF00
+#define set_SATA_SATA_MAC_IN_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_IN_reg)=data)
+#define get_SATA_SATA_MAC_IN_reg   (*((volatile unsigned int*) SATA_SATA_MAC_IN_reg))
+#define SATA_SATA_MAC_IN_inst_adr                                                    "0x00C0"
+#define SATA_SATA_MAC_IN_inst                                                        0x00C0
+#define SATA_SATA_MAC_IN_Mbist_sata_st_shift                                         (4)
+#define SATA_SATA_MAC_IN_Mbist_sata_st_mask                                          (0x00000010)
+#define SATA_SATA_MAC_IN_Mbist_sata_st(data)                                         (0x00000010&((data)<<4))
+#define SATA_SATA_MAC_IN_Mbist_sata_st_src(data)                                     ((0x00000010&(data))>>4)
+#define SATA_SATA_MAC_IN_get_Mbist_sata_st(data)                                     ((0x00000010&(data))>>4)
+#define SATA_SATA_MAC_IN_cp_pod1_shift                                               (3)
+#define SATA_SATA_MAC_IN_cp_pod1_mask                                                (0x00000008)
+#define SATA_SATA_MAC_IN_cp_pod1(data)                                               (0x00000008&((data)<<3))
+#define SATA_SATA_MAC_IN_cp_pod1_src(data)                                           ((0x00000008&(data))>>3)
+#define SATA_SATA_MAC_IN_get_cp_pod1(data)                                           ((0x00000008&(data))>>3)
+#define SATA_SATA_MAC_IN_cp_pod0_shift                                               (2)
+#define SATA_SATA_MAC_IN_cp_pod0_mask                                                (0x00000004)
+#define SATA_SATA_MAC_IN_cp_pod0(data)                                               (0x00000004&((data)<<2))
+#define SATA_SATA_MAC_IN_cp_pod0_src(data)                                           ((0x00000004&(data))>>2)
+#define SATA_SATA_MAC_IN_get_cp_pod0(data)                                           ((0x00000004&(data))>>2)
+#define SATA_SATA_MAC_IN_pme_req_shift                                               (1)
+#define SATA_SATA_MAC_IN_pme_req_mask                                                (0x00000002)
+#define SATA_SATA_MAC_IN_pme_req(data)                                               (0x00000002&((data)<<1))
+#define SATA_SATA_MAC_IN_pme_req_src(data)                                           ((0x00000002&(data))>>1)
+#define SATA_SATA_MAC_IN_get_pme_req(data)                                           ((0x00000002&(data))>>1)
+#define SATA_SATA_MAC_IN_sata_mac_int_shift                                          (0)
+#define SATA_SATA_MAC_IN_sata_mac_int_mask                                           (0x00000001)
+#define SATA_SATA_MAC_IN_sata_mac_int(data)                                          (0x00000001&((data)<<0))
+#define SATA_SATA_MAC_IN_sata_mac_int_src(data)                                      ((0x00000001&(data))>>0)
+#define SATA_SATA_MAC_IN_get_sata_mac_int(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SATA_SATA_FORCE_RST                                                          0x9803FF10
+#define SATA_SATA_FORCE_RST_reg_addr                                                 "0xD803FF10"
+#define SATA_SATA_FORCE_RST_reg                                                      0xD803FF10
+#define set_SATA_SATA_FORCE_RST_reg(data)   (*((volatile unsigned int*) SATA_SATA_FORCE_RST_reg)=data)
+#define get_SATA_SATA_FORCE_RST_reg   (*((volatile unsigned int*) SATA_SATA_FORCE_RST_reg))
+#define SATA_SATA_FORCE_RST_inst_adr                                                 "0x00C4"
+#define SATA_SATA_FORCE_RST_inst                                                     0x00C4
+#define SATA_SATA_FORCE_RST_sata_phy_rst_force_shift                                 (2)
+#define SATA_SATA_FORCE_RST_sata_phy_rst_force_mask                                  (0x00000004)
+#define SATA_SATA_FORCE_RST_sata_phy_rst_force(data)                                 (0x00000004&((data)<<2))
+#define SATA_SATA_FORCE_RST_sata_phy_rst_force_src(data)                             ((0x00000004&(data))>>2)
+#define SATA_SATA_FORCE_RST_get_sata_phy_rst_force(data)                             ((0x00000004&(data))>>2)
+#define SATA_SATA_FORCE_RST_sata_phy_rstn_shift                                      (0)
+#define SATA_SATA_FORCE_RST_sata_phy_rstn_mask                                       (0x00000003)
+#define SATA_SATA_FORCE_RST_sata_phy_rstn(data)                                      (0x00000003&((data)<<0))
+#define SATA_SATA_FORCE_RST_sata_phy_rstn_src(data)                                  ((0x00000003&(data))>>0)
+#define SATA_SATA_FORCE_RST_get_sata_phy_rstn(data)                                  ((0x00000003&(data))>>0)
+
+
+#define SATA_SATA_SAVE                                                               0x9803FF14
+#define SATA_SATA_SAVE_reg_addr                                                      "0xD803FF14"
+#define SATA_SATA_SAVE_reg                                                           0xD803FF14
+#define set_SATA_SATA_SAVE_reg(data)   (*((volatile unsigned int*) SATA_SATA_SAVE_reg)=data)
+#define get_SATA_SATA_SAVE_reg   (*((volatile unsigned int*) SATA_SATA_SAVE_reg))
+#define SATA_SATA_SAVE_inst_adr                                                      "0x00C5"
+#define SATA_SATA_SAVE_inst                                                          0x00C5
+#define SATA_SATA_SAVE_sata_ls_en_shift                                              (1)
+#define SATA_SATA_SAVE_sata_ls_en_mask                                               (0x00000002)
+#define SATA_SATA_SAVE_sata_ls_en(data)                                              (0x00000002&((data)<<1))
+#define SATA_SATA_SAVE_sata_ls_en_src(data)                                          ((0x00000002&(data))>>1)
+#define SATA_SATA_SAVE_get_sata_ls_en(data)                                          ((0x00000002&(data))>>1)
+#define SATA_SATA_SAVE_sata_clk_gate_en_shift                                        (0)
+#define SATA_SATA_SAVE_sata_clk_gate_en_mask                                         (0x00000001)
+#define SATA_SATA_SAVE_sata_clk_gate_en(data)                                        (0x00000001&((data)<<0))
+#define SATA_SATA_SAVE_sata_clk_gate_en_src(data)                                    ((0x00000001&(data))>>0)
+#define SATA_SATA_SAVE_get_sata_clk_gate_en(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SATA_SATA_CTR                                                                0x9803FF20
+#define SATA_SATA_CTR_reg_addr                                                       "0xD803FF20"
+#define SATA_SATA_CTR_reg                                                            0xD803FF20
+#define set_SATA_SATA_CTR_reg(data)   (*((volatile unsigned int*) SATA_SATA_CTR_reg)=data)
+#define get_SATA_SATA_CTR_reg   (*((volatile unsigned int*) SATA_SATA_CTR_reg))
+#define SATA_SATA_CTR_inst_adr                                                       "0x00C8"
+#define SATA_SATA_CTR_inst                                                           0x00C8
+#define SATA_SATA_CTR_rx_error_CDR_sel_shift                                         (16)
+#define SATA_SATA_CTR_rx_error_CDR_sel_mask                                          (0x00030000)
+#define SATA_SATA_CTR_rx_error_CDR_sel(data)                                         (0x00030000&((data)<<16))
+#define SATA_SATA_CTR_rx_error_CDR_sel_src(data)                                     ((0x00030000&(data))>>16)
+#define SATA_SATA_CTR_get_rx_error_CDR_sel(data)                                     ((0x00030000&(data))>>16)
+#define SATA_SATA_CTR_rx_error_sel_shift                                             (14)
+#define SATA_SATA_CTR_rx_error_sel_mask                                              (0x0000C000)
+#define SATA_SATA_CTR_rx_error_sel(data)                                             (0x0000C000&((data)<<14))
+#define SATA_SATA_CTR_rx_error_sel_src(data)                                         ((0x0000C000&(data))>>14)
+#define SATA_SATA_CTR_get_rx_error_sel(data)                                         ((0x0000C000&(data))>>14)
+#define SATA_SATA_CTR_clk_mode_sel_1_shift                                           (12)
+#define SATA_SATA_CTR_clk_mode_sel_1_mask                                            (0x00003000)
+#define SATA_SATA_CTR_clk_mode_sel_1(data)                                           (0x00003000&((data)<<12))
+#define SATA_SATA_CTR_clk_mode_sel_1_src(data)                                       ((0x00003000&(data))>>12)
+#define SATA_SATA_CTR_get_clk_mode_sel_1(data)                                       ((0x00003000&(data))>>12)
+#define SATA_SATA_CTR_clk_mode_sel_0_shift                                           (10)
+#define SATA_SATA_CTR_clk_mode_sel_0_mask                                            (0x00000C00)
+#define SATA_SATA_CTR_clk_mode_sel_0(data)                                           (0x00000C00&((data)<<10))
+#define SATA_SATA_CTR_clk_mode_sel_0_src(data)                                       ((0x00000C00&(data))>>10)
+#define SATA_SATA_CTR_get_clk_mode_sel_0(data)                                       ((0x00000C00&(data))>>10)
+#define SATA_SATA_CTR_ckbuf_en1_shift                                                (9)
+#define SATA_SATA_CTR_ckbuf_en1_mask                                                 (0x00000200)
+#define SATA_SATA_CTR_ckbuf_en1(data)                                                (0x00000200&((data)<<9))
+#define SATA_SATA_CTR_ckbuf_en1_src(data)                                            ((0x00000200&(data))>>9)
+#define SATA_SATA_CTR_get_ckbuf_en1(data)                                            ((0x00000200&(data))>>9)
+#define SATA_SATA_CTR_ckbuf_en0_shift                                                (8)
+#define SATA_SATA_CTR_ckbuf_en0_mask                                                 (0x00000100)
+#define SATA_SATA_CTR_ckbuf_en0(data)                                                (0x00000100&((data)<<8))
+#define SATA_SATA_CTR_ckbuf_en0_src(data)                                            ((0x00000100&(data))>>8)
+#define SATA_SATA_CTR_get_ckbuf_en0(data)                                            ((0x00000100&(data))>>8)
+#define SATA_SATA_CTR_mp_switch1_shift                                               (7)
+#define SATA_SATA_CTR_mp_switch1_mask                                                (0x00000080)
+#define SATA_SATA_CTR_mp_switch1(data)                                               (0x00000080&((data)<<7))
+#define SATA_SATA_CTR_mp_switch1_src(data)                                           ((0x00000080&(data))>>7)
+#define SATA_SATA_CTR_get_mp_switch1(data)                                           ((0x00000080&(data))>>7)
+#define SATA_SATA_CTR_mp_switch0_shift                                               (6)
+#define SATA_SATA_CTR_mp_switch0_mask                                                (0x00000040)
+#define SATA_SATA_CTR_mp_switch0(data)                                               (0x00000040&((data)<<6))
+#define SATA_SATA_CTR_mp_switch0_src(data)                                           ((0x00000040&(data))>>6)
+#define SATA_SATA_CTR_get_mp_switch0(data)                                           ((0x00000040&(data))>>6)
+#define SATA_SATA_CTR_cp_det1_shift                                                  (5)
+#define SATA_SATA_CTR_cp_det1_mask                                                   (0x00000020)
+#define SATA_SATA_CTR_cp_det1(data)                                                  (0x00000020&((data)<<5))
+#define SATA_SATA_CTR_cp_det1_src(data)                                              ((0x00000020&(data))>>5)
+#define SATA_SATA_CTR_get_cp_det1(data)                                              ((0x00000020&(data))>>5)
+#define SATA_SATA_CTR_cp_det0_shift                                                  (4)
+#define SATA_SATA_CTR_cp_det0_mask                                                   (0x00000010)
+#define SATA_SATA_CTR_cp_det0(data)                                                  (0x00000010&((data)<<4))
+#define SATA_SATA_CTR_cp_det0_src(data)                                              ((0x00000010&(data))>>4)
+#define SATA_SATA_CTR_get_cp_det0(data)                                              ((0x00000010&(data))>>4)
+#define SATA_SATA_CTR_phy_rx_err_1_shift                                             (3)
+#define SATA_SATA_CTR_phy_rx_err_1_mask                                              (0x00000008)
+#define SATA_SATA_CTR_phy_rx_err_1(data)                                             (0x00000008&((data)<<3))
+#define SATA_SATA_CTR_phy_rx_err_1_src(data)                                         ((0x00000008&(data))>>3)
+#define SATA_SATA_CTR_get_phy_rx_err_1(data)                                         ((0x00000008&(data))>>3)
+#define SATA_SATA_CTR_phy_rx_err_0_shift                                             (2)
+#define SATA_SATA_CTR_phy_rx_err_0_mask                                              (0x00000004)
+#define SATA_SATA_CTR_phy_rx_err_0(data)                                             (0x00000004&((data)<<2))
+#define SATA_SATA_CTR_phy_rx_err_0_src(data)                                         ((0x00000004&(data))>>2)
+#define SATA_SATA_CTR_get_phy_rx_err_0(data)                                         ((0x00000004&(data))>>2)
+#define SATA_SATA_CTR_phy_iprx_en_1_shift                                            (1)
+#define SATA_SATA_CTR_phy_iprx_en_1_mask                                             (0x00000002)
+#define SATA_SATA_CTR_phy_iprx_en_1(data)                                            (0x00000002&((data)<<1))
+#define SATA_SATA_CTR_phy_iprx_en_1_src(data)                                        ((0x00000002&(data))>>1)
+#define SATA_SATA_CTR_get_phy_iprx_en_1(data)                                        ((0x00000002&(data))>>1)
+#define SATA_SATA_CTR_phy_iprx_en_0_shift                                            (0)
+#define SATA_SATA_CTR_phy_iprx_en_0_mask                                             (0x00000001)
+#define SATA_SATA_CTR_phy_iprx_en_0(data)                                            (0x00000001&((data)<<0))
+#define SATA_SATA_CTR_phy_iprx_en_0_src(data)                                        ((0x00000001&(data))>>0)
+#define SATA_SATA_CTR_get_phy_iprx_en_0(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SATA_SATA_PHY_MON                                                            0x9803FF24
+#define SATA_SATA_PHY_MON_reg_addr                                                   "0xD803FF24"
+#define SATA_SATA_PHY_MON_reg                                                        0xD803FF24
+#define set_SATA_SATA_PHY_MON_reg(data)   (*((volatile unsigned int*) SATA_SATA_PHY_MON_reg)=data)
+#define get_SATA_SATA_PHY_MON_reg   (*((volatile unsigned int*) SATA_SATA_PHY_MON_reg))
+#define SATA_SATA_PHY_MON_inst_adr                                                   "0x00C9"
+#define SATA_SATA_PHY_MON_inst                                                       0x00C9
+#define SATA_SATA_PHY_MON_phy_rdy_1_shift                                            (3)
+#define SATA_SATA_PHY_MON_phy_rdy_1_mask                                             (0x00000008)
+#define SATA_SATA_PHY_MON_phy_rdy_1(data)                                            (0x00000008&((data)<<3))
+#define SATA_SATA_PHY_MON_phy_rdy_1_src(data)                                        ((0x00000008&(data))>>3)
+#define SATA_SATA_PHY_MON_get_phy_rdy_1(data)                                        ((0x00000008&(data))>>3)
+#define SATA_SATA_PHY_MON_phy_rdy_0_shift                                            (2)
+#define SATA_SATA_PHY_MON_phy_rdy_0_mask                                             (0x00000004)
+#define SATA_SATA_PHY_MON_phy_rdy_0(data)                                            (0x00000004&((data)<<2))
+#define SATA_SATA_PHY_MON_phy_rdy_0_src(data)                                        ((0x00000004&(data))>>2)
+#define SATA_SATA_PHY_MON_get_phy_rdy_0(data)                                        ((0x00000004&(data))>>2)
+#define SATA_SATA_PHY_MON_phy_calibrated_1_shift                                     (1)
+#define SATA_SATA_PHY_MON_phy_calibrated_1_mask                                      (0x00000002)
+#define SATA_SATA_PHY_MON_phy_calibrated_1(data)                                     (0x00000002&((data)<<1))
+#define SATA_SATA_PHY_MON_phy_calibrated_1_src(data)                                 ((0x00000002&(data))>>1)
+#define SATA_SATA_PHY_MON_get_phy_calibrated_1(data)                                 ((0x00000002&(data))>>1)
+#define SATA_SATA_PHY_MON_phy_calibrated_0_shift                                     (0)
+#define SATA_SATA_PHY_MON_phy_calibrated_0_mask                                      (0x00000001)
+#define SATA_SATA_PHY_MON_phy_calibrated_0(data)                                     (0x00000001&((data)<<0))
+#define SATA_SATA_PHY_MON_phy_calibrated_0_src(data)                                 ((0x00000001&(data))>>0)
+#define SATA_SATA_PHY_MON_get_phy_calibrated_0(data)                                 ((0x00000001&(data))>>0)
+
+
+#define SATA_SATA_WRAPPER_DMA_CTRL                                                   0x9803FF30
+#define SATA_SATA_WRAPPER_DMA_CTRL_reg_addr                                          "0xD803FF30"
+#define SATA_SATA_WRAPPER_DMA_CTRL_reg                                               0xD803FF30
+#define set_SATA_SATA_WRAPPER_DMA_CTRL_reg(data)   (*((volatile unsigned int*) SATA_SATA_WRAPPER_DMA_CTRL_reg)=data)
+#define get_SATA_SATA_WRAPPER_DMA_CTRL_reg   (*((volatile unsigned int*) SATA_SATA_WRAPPER_DMA_CTRL_reg))
+#define SATA_SATA_WRAPPER_DMA_CTRL_inst_adr                                          "0x00CC"
+#define SATA_SATA_WRAPPER_DMA_CTRL_inst                                              0x00CC
+#define SATA_SATA_WRAPPER_DMA_CTRL_rdata_in_order_shift                              (17)
+#define SATA_SATA_WRAPPER_DMA_CTRL_rdata_in_order_mask                               (0x00020000)
+#define SATA_SATA_WRAPPER_DMA_CTRL_rdata_in_order(data)                              (0x00020000&((data)<<17))
+#define SATA_SATA_WRAPPER_DMA_CTRL_rdata_in_order_src(data)                          ((0x00020000&(data))>>17)
+#define SATA_SATA_WRAPPER_DMA_CTRL_get_rdata_in_order(data)                          ((0x00020000&(data))>>17)
+#define SATA_SATA_WRAPPER_DMA_CTRL_wcmd_bufable_sel_shift                            (16)
+#define SATA_SATA_WRAPPER_DMA_CTRL_wcmd_bufable_sel_mask                             (0x00010000)
+#define SATA_SATA_WRAPPER_DMA_CTRL_wcmd_bufable_sel(data)                            (0x00010000&((data)<<16))
+#define SATA_SATA_WRAPPER_DMA_CTRL_wcmd_bufable_sel_src(data)                        ((0x00010000&(data))>>16)
+#define SATA_SATA_WRAPPER_DMA_CTRL_get_wcmd_bufable_sel(data)                        ((0x00010000&(data))>>16)
+#define SATA_SATA_WRAPPER_DMA_CTRL_outstd_wcmd_shift                                 (8)
+#define SATA_SATA_WRAPPER_DMA_CTRL_outstd_wcmd_mask                                  (0x00000F00)
+#define SATA_SATA_WRAPPER_DMA_CTRL_outstd_wcmd(data)                                 (0x00000F00&((data)<<8))
+#define SATA_SATA_WRAPPER_DMA_CTRL_outstd_wcmd_src(data)                             ((0x00000F00&(data))>>8)
+#define SATA_SATA_WRAPPER_DMA_CTRL_get_outstd_wcmd(data)                             ((0x00000F00&(data))>>8)
+#define SATA_SATA_WRAPPER_DMA_CTRL_outstd_rcmd_shift                                 (0)
+#define SATA_SATA_WRAPPER_DMA_CTRL_outstd_rcmd_mask                                  (0x0000001F)
+#define SATA_SATA_WRAPPER_DMA_CTRL_outstd_rcmd(data)                                 (0x0000001F&((data)<<0))
+#define SATA_SATA_WRAPPER_DMA_CTRL_outstd_rcmd_src(data)                             ((0x0000001F&(data))>>0)
+#define SATA_SATA_WRAPPER_DMA_CTRL_get_outstd_rcmd(data)                             ((0x0000001F&(data))>>0)
+
+
+#define SATA_SATA_WRAPPER_DC_CTRL                                                    0x9803FF34
+#define SATA_SATA_WRAPPER_DC_CTRL_reg_addr                                           "0xD803FF34"
+#define SATA_SATA_WRAPPER_DC_CTRL_reg                                                0xD803FF34
+#define set_SATA_SATA_WRAPPER_DC_CTRL_reg(data)   (*((volatile unsigned int*) SATA_SATA_WRAPPER_DC_CTRL_reg)=data)
+#define get_SATA_SATA_WRAPPER_DC_CTRL_reg   (*((volatile unsigned int*) SATA_SATA_WRAPPER_DC_CTRL_reg))
+#define SATA_SATA_WRAPPER_DC_CTRL_inst_adr                                           "0x00CD"
+#define SATA_SATA_WRAPPER_DC_CTRL_inst                                               0x00CD
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus2_remote_cmd_num_shift                         (24)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus2_remote_cmd_num_mask                          (0x0F000000)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus2_remote_cmd_num(data)                         (0x0F000000&((data)<<24))
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus2_remote_cmd_num_src(data)                     ((0x0F000000&(data))>>24)
+#define SATA_SATA_WRAPPER_DC_CTRL_get_dbus2_remote_cmd_num(data)                     ((0x0F000000&(data))>>24)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus_remote_cmd_num_shift                          (16)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus_remote_cmd_num_mask                           (0x000F0000)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus_remote_cmd_num(data)                          (0x000F0000&((data)<<16))
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus_remote_cmd_num_src(data)                      ((0x000F0000&(data))>>16)
+#define SATA_SATA_WRAPPER_DC_CTRL_get_dbus_remote_cmd_num(data)                      ((0x000F0000&(data))>>16)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus2_remote_wdata_num_shift                       (8)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus2_remote_wdata_num_mask                        (0x00003F00)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus2_remote_wdata_num(data)                       (0x00003F00&((data)<<8))
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus2_remote_wdata_num_src(data)                   ((0x00003F00&(data))>>8)
+#define SATA_SATA_WRAPPER_DC_CTRL_get_dbus2_remote_wdata_num(data)                   ((0x00003F00&(data))>>8)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus_remote_wdata_num_shift                        (0)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus_remote_wdata_num_mask                         (0x0000003F)
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus_remote_wdata_num(data)                        (0x0000003F&((data)<<0))
+#define SATA_SATA_WRAPPER_DC_CTRL_dbus_remote_wdata_num_src(data)                    ((0x0000003F&(data))>>0)
+#define SATA_SATA_WRAPPER_DC_CTRL_get_dbus_remote_wdata_num(data)                    ((0x0000003F&(data))>>0)
+
+
+#define SATA_SATA_DBG                                                                0x9803FF40
+#define SATA_SATA_DBG_reg_addr                                                       "0xD803FF40"
+#define SATA_SATA_DBG_reg                                                            0xD803FF40
+#define set_SATA_SATA_DBG_reg(data)   (*((volatile unsigned int*) SATA_SATA_DBG_reg)=data)
+#define get_SATA_SATA_DBG_reg   (*((volatile unsigned int*) SATA_SATA_DBG_reg))
+#define SATA_SATA_DBG_inst_adr                                                       "0x00D0"
+#define SATA_SATA_DBG_inst                                                           0x00D0
+#define SATA_SATA_DBG_dbg_sel1_shift                                                 (7)
+#define SATA_SATA_DBG_dbg_sel1_mask                                                  (0x00001F80)
+#define SATA_SATA_DBG_dbg_sel1(data)                                                 (0x00001F80&((data)<<7))
+#define SATA_SATA_DBG_dbg_sel1_src(data)                                             ((0x00001F80&(data))>>7)
+#define SATA_SATA_DBG_get_dbg_sel1(data)                                             ((0x00001F80&(data))>>7)
+#define SATA_SATA_DBG_dbg_sel0_shift                                                 (1)
+#define SATA_SATA_DBG_dbg_sel0_mask                                                  (0x0000007E)
+#define SATA_SATA_DBG_dbg_sel0(data)                                                 (0x0000007E&((data)<<1))
+#define SATA_SATA_DBG_dbg_sel0_src(data)                                             ((0x0000007E&(data))>>1)
+#define SATA_SATA_DBG_get_dbg_sel0(data)                                             ((0x0000007E&(data))>>1)
+#define SATA_SATA_DBG_dbg_en_shift                                                   (0)
+#define SATA_SATA_DBG_dbg_en_mask                                                    (0x00000001)
+#define SATA_SATA_DBG_dbg_en(data)                                                   (0x00000001&((data)<<0))
+#define SATA_SATA_DBG_dbg_en_src(data)                                               ((0x00000001&(data))>>0)
+#define SATA_SATA_DBG_get_dbg_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SATA_WRAP_CTR                                                                0x9803FF50
+#define SATA_WRAP_CTR_reg_addr                                                       "0xD803FF50"
+#define SATA_WRAP_CTR_reg                                                            0xD803FF50
+#define set_SATA_WRAP_CTR_reg(data)   (*((volatile unsigned int*) SATA_WRAP_CTR_reg)=data)
+#define get_SATA_WRAP_CTR_reg   (*((volatile unsigned int*) SATA_WRAP_CTR_reg))
+#define SATA_WRAP_CTR_inst_adr                                                       "0x00D4"
+#define SATA_WRAP_CTR_inst                                                           0x00D4
+#define SATA_WRAP_CTR_sram_debug_sel_shift                                           (1)
+#define SATA_WRAP_CTR_sram_debug_sel_mask                                            (0x00000002)
+#define SATA_WRAP_CTR_sram_debug_sel(data)                                           (0x00000002&((data)<<1))
+#define SATA_WRAP_CTR_sram_debug_sel_src(data)                                       ((0x00000002&(data))>>1)
+#define SATA_WRAP_CTR_get_sram_debug_sel(data)                                       ((0x00000002&(data))>>1)
+#define SATA_WRAP_CTR_sram_debug_mode_shift                                          (0)
+#define SATA_WRAP_CTR_sram_debug_mode_mask                                           (0x00000001)
+#define SATA_WRAP_CTR_sram_debug_mode(data)                                          (0x00000001&((data)<<0))
+#define SATA_WRAP_CTR_sram_debug_mode_src(data)                                      ((0x00000001&(data))>>0)
+#define SATA_WRAP_CTR_get_sram_debug_mode(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SATA_MDIO_CTR                                                                0x9803FF60
+#define SATA_MDIO_CTR_reg_addr                                                       "0xD803FF60"
+#define SATA_MDIO_CTR_reg                                                            0xD803FF60
+#define set_SATA_MDIO_CTR_reg(data)   (*((volatile unsigned int*) SATA_MDIO_CTR_reg)=data)
+#define get_SATA_MDIO_CTR_reg   (*((volatile unsigned int*) SATA_MDIO_CTR_reg))
+#define SATA_MDIO_CTR_inst_adr                                                       "0x00D8"
+#define SATA_MDIO_CTR_inst                                                           0x00D8
+#define SATA_MDIO_CTR_data_shift                                                     (16)
+#define SATA_MDIO_CTR_data_mask                                                      (0xFFFF0000)
+#define SATA_MDIO_CTR_data(data)                                                     (0xFFFF0000&((data)<<16))
+#define SATA_MDIO_CTR_data_src(data)                                                 ((0xFFFF0000&(data))>>16)
+#define SATA_MDIO_CTR_get_data(data)                                                 ((0xFFFF0000&(data))>>16)
+#define SATA_MDIO_CTR_phy_addr_shift                                                 (14)
+#define SATA_MDIO_CTR_phy_addr_mask                                                  (0x0000C000)
+#define SATA_MDIO_CTR_phy_addr(data)                                                 (0x0000C000&((data)<<14))
+#define SATA_MDIO_CTR_phy_addr_src(data)                                             ((0x0000C000&(data))>>14)
+#define SATA_MDIO_CTR_get_phy_addr(data)                                             ((0x0000C000&(data))>>14)
+#define SATA_MDIO_CTR_phy_reg_addr_shift                                             (8)
+#define SATA_MDIO_CTR_phy_reg_addr_mask                                              (0x00003F00)
+#define SATA_MDIO_CTR_phy_reg_addr(data)                                             (0x00003F00&((data)<<8))
+#define SATA_MDIO_CTR_phy_reg_addr_src(data)                                         ((0x00003F00&(data))>>8)
+#define SATA_MDIO_CTR_get_phy_reg_addr(data)                                         ((0x00003F00&(data))>>8)
+#define SATA_MDIO_CTR_mdio_busy_shift                                                (7)
+#define SATA_MDIO_CTR_mdio_busy_mask                                                 (0x00000080)
+#define SATA_MDIO_CTR_mdio_busy(data)                                                (0x00000080&((data)<<7))
+#define SATA_MDIO_CTR_mdio_busy_src(data)                                            ((0x00000080&(data))>>7)
+#define SATA_MDIO_CTR_get_mdio_busy(data)                                            ((0x00000080&(data))>>7)
+#define SATA_MDIO_CTR_mdio_st_shift                                                  (5)
+#define SATA_MDIO_CTR_mdio_st_mask                                                   (0x00000060)
+#define SATA_MDIO_CTR_mdio_st(data)                                                  (0x00000060&((data)<<5))
+#define SATA_MDIO_CTR_mdio_st_src(data)                                              ((0x00000060&(data))>>5)
+#define SATA_MDIO_CTR_get_mdio_st(data)                                              ((0x00000060&(data))>>5)
+#define SATA_MDIO_CTR_mdio_rdy_shift                                                 (4)
+#define SATA_MDIO_CTR_mdio_rdy_mask                                                  (0x00000010)
+#define SATA_MDIO_CTR_mdio_rdy(data)                                                 (0x00000010&((data)<<4))
+#define SATA_MDIO_CTR_mdio_rdy_src(data)                                             ((0x00000010&(data))>>4)
+#define SATA_MDIO_CTR_get_mdio_rdy(data)                                             ((0x00000010&(data))>>4)
+#define SATA_MDIO_CTR_mclk_rate_shift                                                (2)
+#define SATA_MDIO_CTR_mclk_rate_mask                                                 (0x0000000C)
+#define SATA_MDIO_CTR_mclk_rate(data)                                                (0x0000000C&((data)<<2))
+#define SATA_MDIO_CTR_mclk_rate_src(data)                                            ((0x0000000C&(data))>>2)
+#define SATA_MDIO_CTR_get_mclk_rate(data)                                            ((0x0000000C&(data))>>2)
+#define SATA_MDIO_CTR_mdio_srst_shift                                                (1)
+#define SATA_MDIO_CTR_mdio_srst_mask                                                 (0x00000002)
+#define SATA_MDIO_CTR_mdio_srst(data)                                                (0x00000002&((data)<<1))
+#define SATA_MDIO_CTR_mdio_srst_src(data)                                            ((0x00000002&(data))>>1)
+#define SATA_MDIO_CTR_get_mdio_srst(data)                                            ((0x00000002&(data))>>1)
+#define SATA_MDIO_CTR_mdio_rdwr_shift                                                (0)
+#define SATA_MDIO_CTR_mdio_rdwr_mask                                                 (0x00000001)
+#define SATA_MDIO_CTR_mdio_rdwr(data)                                                (0x00000001&((data)<<0))
+#define SATA_MDIO_CTR_mdio_rdwr_src(data)                                            ((0x00000001&(data))>>0)
+#define SATA_MDIO_CTR_get_mdio_rdwr(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SATA_MDIO_CTR1                                                               0x9803FF64
+#define SATA_MDIO_CTR1_reg_addr                                                      "0xD803FF64"
+#define SATA_MDIO_CTR1_reg                                                           0xD803FF64
+#define set_SATA_MDIO_CTR1_reg(data)   (*((volatile unsigned int*) SATA_MDIO_CTR1_reg)=data)
+#define get_SATA_MDIO_CTR1_reg   (*((volatile unsigned int*) SATA_MDIO_CTR1_reg))
+#define SATA_MDIO_CTR1_inst_adr                                                      "0x00D9"
+#define SATA_MDIO_CTR1_inst                                                          0x00D9
+#define SATA_MDIO_CTR1_phy_sel_shift                                                 (0)
+#define SATA_MDIO_CTR1_phy_sel_mask                                                  (0x00000001)
+#define SATA_MDIO_CTR1_phy_sel(data)                                                 (0x00000001&((data)<<0))
+#define SATA_MDIO_CTR1_phy_sel_src(data)                                             ((0x00000001&(data))>>0)
+#define SATA_MDIO_CTR1_get_phy_sel(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SATA_SPD                                                                     0x9803FF68
+#define SATA_SPD_reg_addr                                                            "0xD803FF68"
+#define SATA_SPD_reg                                                                 0xD803FF68
+#define set_SATA_SPD_reg(data)   (*((volatile unsigned int*) SATA_SPD_reg)=data)
+#define get_SATA_SPD_reg   (*((volatile unsigned int*) SATA_SPD_reg))
+#define SATA_SPD_inst_adr                                                            "0x00DA"
+#define SATA_SPD_inst                                                                0x00DA
+#define SATA_SPD_p1_spd_mode_st_shift                                                (6)
+#define SATA_SPD_p1_spd_mode_st_mask                                                 (0x000000C0)
+#define SATA_SPD_p1_spd_mode_st(data)                                                (0x000000C0&((data)<<6))
+#define SATA_SPD_p1_spd_mode_st_src(data)                                            ((0x000000C0&(data))>>6)
+#define SATA_SPD_get_p1_spd_mode_st(data)                                            ((0x000000C0&(data))>>6)
+#define SATA_SPD_p0_spd_mode_st_shift                                                (4)
+#define SATA_SPD_p0_spd_mode_st_mask                                                 (0x00000030)
+#define SATA_SPD_p0_spd_mode_st(data)                                                (0x00000030&((data)<<4))
+#define SATA_SPD_p0_spd_mode_st_src(data)                                            ((0x00000030&(data))>>4)
+#define SATA_SPD_get_p0_spd_mode_st(data)                                            ((0x00000030&(data))>>4)
+#define SATA_SPD_p1_spd_mode_shift                                                   (2)
+#define SATA_SPD_p1_spd_mode_mask                                                    (0x0000000C)
+#define SATA_SPD_p1_spd_mode(data)                                                   (0x0000000C&((data)<<2))
+#define SATA_SPD_p1_spd_mode_src(data)                                               ((0x0000000C&(data))>>2)
+#define SATA_SPD_get_p1_spd_mode(data)                                               ((0x0000000C&(data))>>2)
+#define SATA_SPD_p0_spd_mode_shift                                                   (0)
+#define SATA_SPD_p0_spd_mode_mask                                                    (0x00000003)
+#define SATA_SPD_p0_spd_mode(data)                                                   (0x00000003&((data)<<0))
+#define SATA_SPD_p0_spd_mode_src(data)                                               ((0x00000003&(data))>>0)
+#define SATA_SPD_get_p0_spd_mode(data)                                               ((0x00000003&(data))>>0)
+
+
+#define SATA_RAM_CTR                                                                 0x9803FF70
+#define SATA_RAM_CTR_reg_addr                                                        "0xD803FF70"
+#define SATA_RAM_CTR_reg                                                             0xD803FF70
+#define set_SATA_RAM_CTR_reg(data)   (*((volatile unsigned int*) SATA_RAM_CTR_reg)=data)
+#define get_SATA_RAM_CTR_reg   (*((volatile unsigned int*) SATA_RAM_CTR_reg))
+#define SATA_RAM_CTR_inst_adr                                                        "0x00DC"
+#define SATA_RAM_CTR_inst                                                            0x00DC
+#define SATA_RAM_CTR_done_st_shift                                                   (16)
+#define SATA_RAM_CTR_done_st_mask                                                    (0x00010000)
+#define SATA_RAM_CTR_done_st(data)                                                   (0x00010000&((data)<<16))
+#define SATA_RAM_CTR_done_st_src(data)                                               ((0x00010000&(data))>>16)
+#define SATA_RAM_CTR_get_done_st(data)                                               ((0x00010000&(data))>>16)
+#define SATA_RAM_CTR_go_ct_shift                                                     (0)
+#define SATA_RAM_CTR_go_ct_mask                                                      (0x00000001)
+#define SATA_RAM_CTR_go_ct(data)                                                     (0x00000001&((data)<<0))
+#define SATA_RAM_CTR_go_ct_src(data)                                                 ((0x00000001&(data))>>0)
+#define SATA_RAM_CTR_get_go_ct(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define SATA_RAM_ADDR                                                                0x9803FF74
+#define SATA_RAM_ADDR_reg_addr                                                       "0xD803FF74"
+#define SATA_RAM_ADDR_reg                                                            0xD803FF74
+#define set_SATA_RAM_ADDR_reg(data)   (*((volatile unsigned int*) SATA_RAM_ADDR_reg)=data)
+#define get_SATA_RAM_ADDR_reg   (*((volatile unsigned int*) SATA_RAM_ADDR_reg))
+#define SATA_RAM_ADDR_inst_adr                                                       "0x00DD"
+#define SATA_RAM_ADDR_inst                                                           0x00DD
+#define SATA_RAM_ADDR_sram_addr_shift                                                (0)
+#define SATA_RAM_ADDR_sram_addr_mask                                                 (0xFFFFFFFF)
+#define SATA_RAM_ADDR_sram_addr(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SATA_RAM_ADDR_sram_addr_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SATA_RAM_ADDR_get_sram_addr(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_RAM_WDATA                                                               0x9803FF78
+#define SATA_RAM_WDATA_reg_addr                                                      "0xD803FF78"
+#define SATA_RAM_WDATA_reg                                                           0xD803FF78
+#define set_SATA_RAM_WDATA_reg(data)   (*((volatile unsigned int*) SATA_RAM_WDATA_reg)=data)
+#define get_SATA_RAM_WDATA_reg   (*((volatile unsigned int*) SATA_RAM_WDATA_reg))
+#define SATA_RAM_WDATA_inst_adr                                                      "0x00DE"
+#define SATA_RAM_WDATA_inst                                                          0x00DE
+#define SATA_RAM_WDATA_ram_wdata_shift                                               (0)
+#define SATA_RAM_WDATA_ram_wdata_mask                                                (0xFFFFFFFF)
+#define SATA_RAM_WDATA_ram_wdata(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SATA_RAM_WDATA_ram_wdata_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SATA_RAM_WDATA_get_ram_wdata(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_RAM_RDATA                                                               0x9803FF7C
+#define SATA_RAM_RDATA_reg_addr                                                      "0xD803FF7C"
+#define SATA_RAM_RDATA_reg                                                           0xD803FF7C
+#define set_SATA_RAM_RDATA_reg(data)   (*((volatile unsigned int*) SATA_RAM_RDATA_reg)=data)
+#define get_SATA_RAM_RDATA_reg   (*((volatile unsigned int*) SATA_RAM_RDATA_reg))
+#define SATA_RAM_RDATA_inst_adr                                                      "0x00DF"
+#define SATA_RAM_RDATA_inst                                                          0x00DF
+#define SATA_RAM_RDATA_ram_rdata_shift                                               (0)
+#define SATA_RAM_RDATA_ram_rdata_mask                                                (0xFFFFFFFF)
+#define SATA_RAM_RDATA_ram_rdata(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SATA_RAM_RDATA_ram_rdata_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SATA_RAM_RDATA_get_ram_rdata(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_SATA_MAC_P0_DBG0                                                        0x9803FF80
+#define SATA_SATA_MAC_P0_DBG0_reg_addr                                               "0xD803FF80"
+#define SATA_SATA_MAC_P0_DBG0_reg                                                    0xD803FF80
+#define set_SATA_SATA_MAC_P0_DBG0_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_P0_DBG0_reg)=data)
+#define get_SATA_SATA_MAC_P0_DBG0_reg   (*((volatile unsigned int*) SATA_SATA_MAC_P0_DBG0_reg))
+#define SATA_SATA_MAC_P0_DBG0_inst_adr                                               "0x00E0"
+#define SATA_SATA_MAC_P0_DBG0_inst                                                   0x00E0
+#define SATA_SATA_MAC_P0_DBG0_p0_csr_diagnr_shift                                    (0)
+#define SATA_SATA_MAC_P0_DBG0_p0_csr_diagnr_mask                                     (0xFFFFFFFF)
+#define SATA_SATA_MAC_P0_DBG0_p0_csr_diagnr(data)                                    (0xFFFFFFFF&((data)<<0))
+#define SATA_SATA_MAC_P0_DBG0_p0_csr_diagnr_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define SATA_SATA_MAC_P0_DBG0_get_p0_csr_diagnr(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_SATA_MAC_P0_DBG1                                                        0x9803FF84
+#define SATA_SATA_MAC_P0_DBG1_reg_addr                                               "0xD803FF84"
+#define SATA_SATA_MAC_P0_DBG1_reg                                                    0xD803FF84
+#define set_SATA_SATA_MAC_P0_DBG1_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_P0_DBG1_reg)=data)
+#define get_SATA_SATA_MAC_P0_DBG1_reg   (*((volatile unsigned int*) SATA_SATA_MAC_P0_DBG1_reg))
+#define SATA_SATA_MAC_P0_DBG1_inst_adr                                               "0x00E1"
+#define SATA_SATA_MAC_P0_DBG1_inst                                                   0x00E1
+#define SATA_SATA_MAC_P0_DBG1_p0_csr_diagnr1_shift                                   (0)
+#define SATA_SATA_MAC_P0_DBG1_p0_csr_diagnr1_mask                                    (0xFFFFFFFF)
+#define SATA_SATA_MAC_P0_DBG1_p0_csr_diagnr1(data)                                   (0xFFFFFFFF&((data)<<0))
+#define SATA_SATA_MAC_P0_DBG1_p0_csr_diagnr1_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define SATA_SATA_MAC_P0_DBG1_get_p0_csr_diagnr1(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_SATA_MAC_P0_DBG2                                                        0x9803FF88
+#define SATA_SATA_MAC_P0_DBG2_reg_addr                                               "0xD803FF88"
+#define SATA_SATA_MAC_P0_DBG2_reg                                                    0xD803FF88
+#define set_SATA_SATA_MAC_P0_DBG2_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_P0_DBG2_reg)=data)
+#define get_SATA_SATA_MAC_P0_DBG2_reg   (*((volatile unsigned int*) SATA_SATA_MAC_P0_DBG2_reg))
+#define SATA_SATA_MAC_P0_DBG2_inst_adr                                               "0x00E2"
+#define SATA_SATA_MAC_P0_DBG2_inst                                                   0x00E2
+#define SATA_SATA_MAC_P0_DBG2_p0_csr_is_shift                                        (0)
+#define SATA_SATA_MAC_P0_DBG2_p0_csr_is_mask                                         (0xFFFFFFFF)
+#define SATA_SATA_MAC_P0_DBG2_p0_csr_is(data)                                        (0xFFFFFFFF&((data)<<0))
+#define SATA_SATA_MAC_P0_DBG2_p0_csr_is_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define SATA_SATA_MAC_P0_DBG2_get_p0_csr_is(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_SATA_MAC_P0_DBG3                                                        0x9803FF8C
+#define SATA_SATA_MAC_P0_DBG3_reg_addr                                               "0xD803FF8C"
+#define SATA_SATA_MAC_P0_DBG3_reg                                                    0xD803FF8C
+#define set_SATA_SATA_MAC_P0_DBG3_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_P0_DBG3_reg)=data)
+#define get_SATA_SATA_MAC_P0_DBG3_reg   (*((volatile unsigned int*) SATA_SATA_MAC_P0_DBG3_reg))
+#define SATA_SATA_MAC_P0_DBG3_inst_adr                                               "0x00E3"
+#define SATA_SATA_MAC_P0_DBG3_inst                                                   0x00E3
+#define SATA_SATA_MAC_P0_DBG3_p0_csr_cmd_shift                                       (0)
+#define SATA_SATA_MAC_P0_DBG3_p0_csr_cmd_mask                                        (0xFFFFFFFF)
+#define SATA_SATA_MAC_P0_DBG3_p0_csr_cmd(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SATA_SATA_MAC_P0_DBG3_p0_csr_cmd_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SATA_SATA_MAC_P0_DBG3_get_p0_csr_cmd(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_SATA_MAC_P1_DBG0                                                        0x9803FF90
+#define SATA_SATA_MAC_P1_DBG0_reg_addr                                               "0xD803FF90"
+#define SATA_SATA_MAC_P1_DBG0_reg                                                    0xD803FF90
+#define set_SATA_SATA_MAC_P1_DBG0_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_P1_DBG0_reg)=data)
+#define get_SATA_SATA_MAC_P1_DBG0_reg   (*((volatile unsigned int*) SATA_SATA_MAC_P1_DBG0_reg))
+#define SATA_SATA_MAC_P1_DBG0_inst_adr                                               "0x00E4"
+#define SATA_SATA_MAC_P1_DBG0_inst                                                   0x00E4
+#define SATA_SATA_MAC_P1_DBG0_p1_csr_diagnr_shift                                    (0)
+#define SATA_SATA_MAC_P1_DBG0_p1_csr_diagnr_mask                                     (0xFFFFFFFF)
+#define SATA_SATA_MAC_P1_DBG0_p1_csr_diagnr(data)                                    (0xFFFFFFFF&((data)<<0))
+#define SATA_SATA_MAC_P1_DBG0_p1_csr_diagnr_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define SATA_SATA_MAC_P1_DBG0_get_p1_csr_diagnr(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_SATA_MAC_P1_DBG1                                                        0x9803FF94
+#define SATA_SATA_MAC_P1_DBG1_reg_addr                                               "0xD803FF94"
+#define SATA_SATA_MAC_P1_DBG1_reg                                                    0xD803FF94
+#define set_SATA_SATA_MAC_P1_DBG1_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_P1_DBG1_reg)=data)
+#define get_SATA_SATA_MAC_P1_DBG1_reg   (*((volatile unsigned int*) SATA_SATA_MAC_P1_DBG1_reg))
+#define SATA_SATA_MAC_P1_DBG1_inst_adr                                               "0x00E5"
+#define SATA_SATA_MAC_P1_DBG1_inst                                                   0x00E5
+#define SATA_SATA_MAC_P1_DBG1_p1_csr_diagnr1_shift                                   (0)
+#define SATA_SATA_MAC_P1_DBG1_p1_csr_diagnr1_mask                                    (0xFFFFFFFF)
+#define SATA_SATA_MAC_P1_DBG1_p1_csr_diagnr1(data)                                   (0xFFFFFFFF&((data)<<0))
+#define SATA_SATA_MAC_P1_DBG1_p1_csr_diagnr1_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define SATA_SATA_MAC_P1_DBG1_get_p1_csr_diagnr1(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_SATA_MAC_P1_DBG2                                                        0x9803FF98
+#define SATA_SATA_MAC_P1_DBG2_reg_addr                                               "0xD803FF98"
+#define SATA_SATA_MAC_P1_DBG2_reg                                                    0xD803FF98
+#define set_SATA_SATA_MAC_P1_DBG2_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_P1_DBG2_reg)=data)
+#define get_SATA_SATA_MAC_P1_DBG2_reg   (*((volatile unsigned int*) SATA_SATA_MAC_P1_DBG2_reg))
+#define SATA_SATA_MAC_P1_DBG2_inst_adr                                               "0x00E6"
+#define SATA_SATA_MAC_P1_DBG2_inst                                                   0x00E6
+#define SATA_SATA_MAC_P1_DBG2_p1_csr_is_shift                                        (0)
+#define SATA_SATA_MAC_P1_DBG2_p1_csr_is_mask                                         (0xFFFFFFFF)
+#define SATA_SATA_MAC_P1_DBG2_p1_csr_is(data)                                        (0xFFFFFFFF&((data)<<0))
+#define SATA_SATA_MAC_P1_DBG2_p1_csr_is_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define SATA_SATA_MAC_P1_DBG2_get_p1_csr_is(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_SATA_MAC_P1_DBG3                                                        0x9803FF9c
+#define SATA_SATA_MAC_P1_DBG3_reg_addr                                               "0xD803FF9C"
+#define SATA_SATA_MAC_P1_DBG3_reg                                                    0xD803FF9C
+#define set_SATA_SATA_MAC_P1_DBG3_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_P1_DBG3_reg)=data)
+#define get_SATA_SATA_MAC_P1_DBG3_reg   (*((volatile unsigned int*) SATA_SATA_MAC_P1_DBG3_reg))
+#define SATA_SATA_MAC_P1_DBG3_inst_adr                                               "0x00E7"
+#define SATA_SATA_MAC_P1_DBG3_inst                                                   0x00E7
+#define SATA_SATA_MAC_P1_DBG3_p1_csr_cmd_shift                                       (0)
+#define SATA_SATA_MAC_P1_DBG3_p1_csr_cmd_mask                                        (0xFFFFFFFF)
+#define SATA_SATA_MAC_P1_DBG3_p1_csr_cmd(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SATA_SATA_MAC_P1_DBG3_p1_csr_cmd_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SATA_SATA_MAC_P1_DBG3_get_p1_csr_cmd(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_SATA_MAC_P0_DBG4                                                        0x9803FFA0
+#define SATA_SATA_MAC_P0_DBG4_reg_addr                                               "0xD803FFA0"
+#define SATA_SATA_MAC_P0_DBG4_reg                                                    0xD803FFA0
+#define set_SATA_SATA_MAC_P0_DBG4_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_P0_DBG4_reg)=data)
+#define get_SATA_SATA_MAC_P0_DBG4_reg   (*((volatile unsigned int*) SATA_SATA_MAC_P0_DBG4_reg))
+#define SATA_SATA_MAC_P0_DBG4_inst_adr                                               "0x00E8"
+#define SATA_SATA_MAC_P0_DBG4_inst                                                   0x00E8
+#define SATA_SATA_MAC_P0_DBG4_p0_rx_error_shift                                      (5)
+#define SATA_SATA_MAC_P0_DBG4_p0_rx_error_mask                                       (0x00000020)
+#define SATA_SATA_MAC_P0_DBG4_p0_rx_error(data)                                      (0x00000020&((data)<<5))
+#define SATA_SATA_MAC_P0_DBG4_p0_rx_error_src(data)                                  ((0x00000020&(data))>>5)
+#define SATA_SATA_MAC_P0_DBG4_get_p0_rx_error(data)                                  ((0x00000020&(data))>>5)
+#define SATA_SATA_MAC_P0_DBG4_p0_link_state_shift                                    (0)
+#define SATA_SATA_MAC_P0_DBG4_p0_link_state_mask                                     (0x0000001F)
+#define SATA_SATA_MAC_P0_DBG4_p0_link_state(data)                                    (0x0000001F&((data)<<0))
+#define SATA_SATA_MAC_P0_DBG4_p0_link_state_src(data)                                ((0x0000001F&(data))>>0)
+#define SATA_SATA_MAC_P0_DBG4_get_p0_link_state(data)                                ((0x0000001F&(data))>>0)
+
+
+#define SATA_SATA_MAC_P1_DBG4                                                        0x9803FFA4
+#define SATA_SATA_MAC_P1_DBG4_reg_addr                                               "0xD803FFA4"
+#define SATA_SATA_MAC_P1_DBG4_reg                                                    0xD803FFA4
+#define set_SATA_SATA_MAC_P1_DBG4_reg(data)   (*((volatile unsigned int*) SATA_SATA_MAC_P1_DBG4_reg)=data)
+#define get_SATA_SATA_MAC_P1_DBG4_reg   (*((volatile unsigned int*) SATA_SATA_MAC_P1_DBG4_reg))
+#define SATA_SATA_MAC_P1_DBG4_inst_adr                                               "0x00E9"
+#define SATA_SATA_MAC_P1_DBG4_inst                                                   0x00E9
+#define SATA_SATA_MAC_P1_DBG4_p1_rx_error_shift                                      (5)
+#define SATA_SATA_MAC_P1_DBG4_p1_rx_error_mask                                       (0x00000020)
+#define SATA_SATA_MAC_P1_DBG4_p1_rx_error(data)                                      (0x00000020&((data)<<5))
+#define SATA_SATA_MAC_P1_DBG4_p1_rx_error_src(data)                                  ((0x00000020&(data))>>5)
+#define SATA_SATA_MAC_P1_DBG4_get_p1_rx_error(data)                                  ((0x00000020&(data))>>5)
+#define SATA_SATA_MAC_P1_DBG4_p1_link_state_shift                                    (0)
+#define SATA_SATA_MAC_P1_DBG4_p1_link_state_mask                                     (0x0000001F)
+#define SATA_SATA_MAC_P1_DBG4_p1_link_state(data)                                    (0x0000001F&((data)<<0))
+#define SATA_SATA_MAC_P1_DBG4_p1_link_state_src(data)                                ((0x0000001F&(data))>>0)
+#define SATA_SATA_MAC_P1_DBG4_get_p1_link_state(data)                                ((0x0000001F&(data))>>0)
+
+
+#define SATA_SATA_BIST1_CTRL                                                         0x9803FFB0
+#define SATA_SATA_BIST1_CTRL_reg_addr                                                "0xD803FFB0"
+#define SATA_SATA_BIST1_CTRL_reg                                                     0xD803FFB0
+#define set_SATA_SATA_BIST1_CTRL_reg(data)   (*((volatile unsigned int*) SATA_SATA_BIST1_CTRL_reg)=data)
+#define get_SATA_SATA_BIST1_CTRL_reg   (*((volatile unsigned int*) SATA_SATA_BIST1_CTRL_reg))
+#define SATA_SATA_BIST1_CTRL_inst_adr                                                "0x00EC"
+#define SATA_SATA_BIST1_CTRL_inst                                                    0x00EC
+#define SATA_SATA_BIST1_CTRL_sata_bist1_ls10_shift                                   (15)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_ls10_mask                                    (0x00018000)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_ls10(data)                                   (0x00018000&((data)<<15))
+#define SATA_SATA_BIST1_CTRL_sata_bist1_ls10_src(data)                               ((0x00018000&(data))>>15)
+#define SATA_SATA_BIST1_CTRL_get_sata_bist1_ls10(data)                               ((0x00018000&(data))>>15)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rm_1_shift                                   (11)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rm_1_mask                                    (0x00007800)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rm_1(data)                                   (0x00007800&((data)<<11))
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rm_1_src(data)                               ((0x00007800&(data))>>11)
+#define SATA_SATA_BIST1_CTRL_get_sata_bist1_rm_1(data)                               ((0x00007800&(data))>>11)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rme_1_shift                                  (10)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rme_1_mask                                   (0x00000400)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rme_1(data)                                  (0x00000400&((data)<<10))
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rme_1_src(data)                              ((0x00000400&(data))>>10)
+#define SATA_SATA_BIST1_CTRL_get_sata_bist1_rme_1(data)                              ((0x00000400&(data))>>10)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rm_0_shift                                   (6)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rm_0_mask                                    (0x000003C0)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rm_0(data)                                   (0x000003C0&((data)<<6))
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rm_0_src(data)                               ((0x000003C0&(data))>>6)
+#define SATA_SATA_BIST1_CTRL_get_sata_bist1_rm_0(data)                               ((0x000003C0&(data))>>6)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rme_0_shift                                  (5)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rme_0_mask                                   (0x00000020)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rme_0(data)                                  (0x00000020&((data)<<5))
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rme_0_src(data)                              ((0x00000020&(data))>>5)
+#define SATA_SATA_BIST1_CTRL_get_sata_bist1_rme_0(data)                              ((0x00000020&(data))>>5)
+#define SATA_SATA_BIST1_CTRL_sata_drf_1_test_resume_shift                            (4)
+#define SATA_SATA_BIST1_CTRL_sata_drf_1_test_resume_mask                             (0x00000010)
+#define SATA_SATA_BIST1_CTRL_sata_drf_1_test_resume(data)                            (0x00000010&((data)<<4))
+#define SATA_SATA_BIST1_CTRL_sata_drf_1_test_resume_src(data)                        ((0x00000010&(data))>>4)
+#define SATA_SATA_BIST1_CTRL_get_sata_drf_1_test_resume(data)                        ((0x00000010&(data))>>4)
+#define SATA_SATA_BIST1_CTRL_sata_drf_bist1_en_shift                                 (3)
+#define SATA_SATA_BIST1_CTRL_sata_drf_bist1_en_mask                                  (0x00000008)
+#define SATA_SATA_BIST1_CTRL_sata_drf_bist1_en(data)                                 (0x00000008&((data)<<3))
+#define SATA_SATA_BIST1_CTRL_sata_drf_bist1_en_src(data)                             ((0x00000008&(data))>>3)
+#define SATA_SATA_BIST1_CTRL_get_sata_drf_bist1_en(data)                             ((0x00000008&(data))>>3)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_en_shift                                     (2)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_en_mask                                      (0x00000004)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_en(data)                                     (0x00000004&((data)<<2))
+#define SATA_SATA_BIST1_CTRL_sata_bist1_en_src(data)                                 ((0x00000004&(data))>>2)
+#define SATA_SATA_BIST1_CTRL_get_sata_bist1_en(data)                                 ((0x00000004&(data))>>2)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rstn_shift                                   (1)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rstn_mask                                    (0x00000002)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rstn(data)                                   (0x00000002&((data)<<1))
+#define SATA_SATA_BIST1_CTRL_sata_bist1_rstn_src(data)                               ((0x00000002&(data))>>1)
+#define SATA_SATA_BIST1_CTRL_get_sata_bist1_rstn(data)                               ((0x00000002&(data))>>1)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_test_mode_shift                              (0)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_test_mode_mask                               (0x00000001)
+#define SATA_SATA_BIST1_CTRL_sata_bist1_test_mode(data)                              (0x00000001&((data)<<0))
+#define SATA_SATA_BIST1_CTRL_sata_bist1_test_mode_src(data)                          ((0x00000001&(data))>>0)
+#define SATA_SATA_BIST1_CTRL_get_sata_bist1_test_mode(data)                          ((0x00000001&(data))>>0)
+
+
+#define SATA_SATA_BIST2_CTRL                                                         0x9803FFB4
+#define SATA_SATA_BIST2_CTRL_reg_addr                                                "0xD803FFB4"
+#define SATA_SATA_BIST2_CTRL_reg                                                     0xD803FFB4
+#define set_SATA_SATA_BIST2_CTRL_reg(data)   (*((volatile unsigned int*) SATA_SATA_BIST2_CTRL_reg)=data)
+#define get_SATA_SATA_BIST2_CTRL_reg   (*((volatile unsigned int*) SATA_SATA_BIST2_CTRL_reg))
+#define SATA_SATA_BIST2_CTRL_inst_adr                                                "0x00ED"
+#define SATA_SATA_BIST2_CTRL_inst                                                    0x00ED
+#define SATA_SATA_BIST2_CTRL_sata_bist2_ls50_shift                                   (5)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_ls50_mask                                    (0x000007E0)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_ls50(data)                                   (0x000007E0&((data)<<5))
+#define SATA_SATA_BIST2_CTRL_sata_bist2_ls50_src(data)                               ((0x000007E0&(data))>>5)
+#define SATA_SATA_BIST2_CTRL_get_sata_bist2_ls50(data)                               ((0x000007E0&(data))>>5)
+#define SATA_SATA_BIST2_CTRL_sata_drf_2_test_resume_shift                            (4)
+#define SATA_SATA_BIST2_CTRL_sata_drf_2_test_resume_mask                             (0x00000010)
+#define SATA_SATA_BIST2_CTRL_sata_drf_2_test_resume(data)                            (0x00000010&((data)<<4))
+#define SATA_SATA_BIST2_CTRL_sata_drf_2_test_resume_src(data)                        ((0x00000010&(data))>>4)
+#define SATA_SATA_BIST2_CTRL_get_sata_drf_2_test_resume(data)                        ((0x00000010&(data))>>4)
+#define SATA_SATA_BIST2_CTRL_sata_drf_bist2_en_shift                                 (3)
+#define SATA_SATA_BIST2_CTRL_sata_drf_bist2_en_mask                                  (0x00000008)
+#define SATA_SATA_BIST2_CTRL_sata_drf_bist2_en(data)                                 (0x00000008&((data)<<3))
+#define SATA_SATA_BIST2_CTRL_sata_drf_bist2_en_src(data)                             ((0x00000008&(data))>>3)
+#define SATA_SATA_BIST2_CTRL_get_sata_drf_bist2_en(data)                             ((0x00000008&(data))>>3)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_en_shift                                     (2)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_en_mask                                      (0x00000004)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_en(data)                                     (0x00000004&((data)<<2))
+#define SATA_SATA_BIST2_CTRL_sata_bist2_en_src(data)                                 ((0x00000004&(data))>>2)
+#define SATA_SATA_BIST2_CTRL_get_sata_bist2_en(data)                                 ((0x00000004&(data))>>2)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_rstn_shift                                   (1)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_rstn_mask                                    (0x00000002)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_rstn(data)                                   (0x00000002&((data)<<1))
+#define SATA_SATA_BIST2_CTRL_sata_bist2_rstn_src(data)                               ((0x00000002&(data))>>1)
+#define SATA_SATA_BIST2_CTRL_get_sata_bist2_rstn(data)                               ((0x00000002&(data))>>1)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_test_mode_shift                              (0)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_test_mode_mask                               (0x00000001)
+#define SATA_SATA_BIST2_CTRL_sata_bist2_test_mode(data)                              (0x00000001&((data)<<0))
+#define SATA_SATA_BIST2_CTRL_sata_bist2_test_mode_src(data)                          ((0x00000001&(data))>>0)
+#define SATA_SATA_BIST2_CTRL_get_sata_bist2_test_mode(data)                          ((0x00000001&(data))>>0)
+
+
+#define SATA_SATA_BIST2_CTRL1                                                        0x9803FFB8
+#define SATA_SATA_BIST2_CTRL1_reg_addr                                               "0xD803FFB8"
+#define SATA_SATA_BIST2_CTRL1_reg                                                    0xD803FFB8
+#define set_SATA_SATA_BIST2_CTRL1_reg(data)   (*((volatile unsigned int*) SATA_SATA_BIST2_CTRL1_reg)=data)
+#define get_SATA_SATA_BIST2_CTRL1_reg   (*((volatile unsigned int*) SATA_SATA_BIST2_CTRL1_reg))
+#define SATA_SATA_BIST2_CTRL1_inst_adr                                               "0x00EE"
+#define SATA_SATA_BIST2_CTRL1_inst                                                   0x00EE
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_5_shift                                  (26)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_5_mask                                   (0x3C000000)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_5(data)                                  (0x3C000000&((data)<<26))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_5_src(data)                              ((0x3C000000&(data))>>26)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rm_5(data)                              ((0x3C000000&(data))>>26)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_5_shift                                 (25)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_5_mask                                  (0x02000000)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_5(data)                                 (0x02000000&((data)<<25))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_5_src(data)                             ((0x02000000&(data))>>25)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rme_5(data)                             ((0x02000000&(data))>>25)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_4_shift                                  (21)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_4_mask                                   (0x01E00000)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_4(data)                                  (0x01E00000&((data)<<21))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_4_src(data)                              ((0x01E00000&(data))>>21)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rm_4(data)                              ((0x01E00000&(data))>>21)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_4_shift                                 (20)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_4_mask                                  (0x00100000)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_4(data)                                 (0x00100000&((data)<<20))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_4_src(data)                             ((0x00100000&(data))>>20)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rme_4(data)                             ((0x00100000&(data))>>20)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_3_shift                                  (16)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_3_mask                                   (0x000F0000)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_3(data)                                  (0x000F0000&((data)<<16))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_3_src(data)                              ((0x000F0000&(data))>>16)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rm_3(data)                              ((0x000F0000&(data))>>16)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_3_shift                                 (15)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_3_mask                                  (0x00008000)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_3(data)                                 (0x00008000&((data)<<15))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_3_src(data)                             ((0x00008000&(data))>>15)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rme_3(data)                             ((0x00008000&(data))>>15)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_2_shift                                  (11)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_2_mask                                   (0x00007800)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_2(data)                                  (0x00007800&((data)<<11))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_2_src(data)                              ((0x00007800&(data))>>11)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rm_2(data)                              ((0x00007800&(data))>>11)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_2_shift                                 (10)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_2_mask                                  (0x00000400)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_2(data)                                 (0x00000400&((data)<<10))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_2_src(data)                             ((0x00000400&(data))>>10)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rme_2(data)                             ((0x00000400&(data))>>10)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_1_shift                                  (6)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_1_mask                                   (0x000003C0)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_1(data)                                  (0x000003C0&((data)<<6))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_1_src(data)                              ((0x000003C0&(data))>>6)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rm_1(data)                              ((0x000003C0&(data))>>6)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_1_shift                                 (5)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_1_mask                                  (0x00000020)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_1(data)                                 (0x00000020&((data)<<5))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_1_src(data)                             ((0x00000020&(data))>>5)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rme_1(data)                             ((0x00000020&(data))>>5)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_0_shift                                  (1)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_0_mask                                   (0x0000001E)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_0(data)                                  (0x0000001E&((data)<<1))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rm_0_src(data)                              ((0x0000001E&(data))>>1)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rm_0(data)                              ((0x0000001E&(data))>>1)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_0_shift                                 (0)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_0_mask                                  (0x00000001)
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_0(data)                                 (0x00000001&((data)<<0))
+#define SATA_SATA_BIST2_CTRL1_sata_bist2_rme_0_src(data)                             ((0x00000001&(data))>>0)
+#define SATA_SATA_BIST2_CTRL1_get_sata_bist2_rme_0(data)                             ((0x00000001&(data))>>0)
+
+
+#define SATA_SATA_BIST1_STS                                                          0x9803FFC0
+#define SATA_SATA_BIST1_STS_reg_addr                                                 "0xD803FFC0"
+#define SATA_SATA_BIST1_STS_reg                                                      0xD803FFC0
+#define set_SATA_SATA_BIST1_STS_reg(data)   (*((volatile unsigned int*) SATA_SATA_BIST1_STS_reg)=data)
+#define get_SATA_SATA_BIST1_STS_reg   (*((volatile unsigned int*) SATA_SATA_BIST1_STS_reg))
+#define SATA_SATA_BIST1_STS_inst_adr                                                 "0x00F0"
+#define SATA_SATA_BIST1_STS_inst                                                     0x00F0
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_fail_1_shift                              (6)
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_fail_1_mask                               (0x00000040)
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_fail_1(data)                              (0x00000040&((data)<<6))
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_fail_1_src(data)                          ((0x00000040&(data))>>6)
+#define SATA_SATA_BIST1_STS_get_sata_drf_bist1_fail_1(data)                          ((0x00000040&(data))>>6)
+#define SATA_SATA_BIST1_STS_sata_bist1_fail_1_shift                                  (5)
+#define SATA_SATA_BIST1_STS_sata_bist1_fail_1_mask                                   (0x00000020)
+#define SATA_SATA_BIST1_STS_sata_bist1_fail_1(data)                                  (0x00000020&((data)<<5))
+#define SATA_SATA_BIST1_STS_sata_bist1_fail_1_src(data)                              ((0x00000020&(data))>>5)
+#define SATA_SATA_BIST1_STS_get_sata_bist1_fail_1(data)                              ((0x00000020&(data))>>5)
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_fail_0_shift                              (4)
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_fail_0_mask                               (0x00000010)
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_fail_0(data)                              (0x00000010&((data)<<4))
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_fail_0_src(data)                          ((0x00000010&(data))>>4)
+#define SATA_SATA_BIST1_STS_get_sata_drf_bist1_fail_0(data)                          ((0x00000010&(data))>>4)
+#define SATA_SATA_BIST1_STS_sata_bist1_fail_0_shift                                  (3)
+#define SATA_SATA_BIST1_STS_sata_bist1_fail_0_mask                                   (0x00000008)
+#define SATA_SATA_BIST1_STS_sata_bist1_fail_0(data)                                  (0x00000008&((data)<<3))
+#define SATA_SATA_BIST1_STS_sata_bist1_fail_0_src(data)                              ((0x00000008&(data))>>3)
+#define SATA_SATA_BIST1_STS_get_sata_bist1_fail_0(data)                              ((0x00000008&(data))>>3)
+#define SATA_SATA_BIST1_STS_sata_drf_1_start_pause_shift                             (2)
+#define SATA_SATA_BIST1_STS_sata_drf_1_start_pause_mask                              (0x00000004)
+#define SATA_SATA_BIST1_STS_sata_drf_1_start_pause(data)                             (0x00000004&((data)<<2))
+#define SATA_SATA_BIST1_STS_sata_drf_1_start_pause_src(data)                         ((0x00000004&(data))>>2)
+#define SATA_SATA_BIST1_STS_get_sata_drf_1_start_pause(data)                         ((0x00000004&(data))>>2)
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_done_shift                                (1)
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_done_mask                                 (0x00000002)
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_done(data)                                (0x00000002&((data)<<1))
+#define SATA_SATA_BIST1_STS_sata_drf_bist1_done_src(data)                            ((0x00000002&(data))>>1)
+#define SATA_SATA_BIST1_STS_get_sata_drf_bist1_done(data)                            ((0x00000002&(data))>>1)
+#define SATA_SATA_BIST1_STS_sata_bist1_done_shift                                    (0)
+#define SATA_SATA_BIST1_STS_sata_bist1_done_mask                                     (0x00000001)
+#define SATA_SATA_BIST1_STS_sata_bist1_done(data)                                    (0x00000001&((data)<<0))
+#define SATA_SATA_BIST1_STS_sata_bist1_done_src(data)                                ((0x00000001&(data))>>0)
+#define SATA_SATA_BIST1_STS_get_sata_bist1_done(data)                                ((0x00000001&(data))>>0)
+
+
+#define SATA_SATA_BIST2_STS                                                          0x9803FFC4
+#define SATA_SATA_BIST2_STS_reg_addr                                                 "0xD803FFC4"
+#define SATA_SATA_BIST2_STS_reg                                                      0xD803FFC4
+#define set_SATA_SATA_BIST2_STS_reg(data)   (*((volatile unsigned int*) SATA_SATA_BIST2_STS_reg)=data)
+#define get_SATA_SATA_BIST2_STS_reg   (*((volatile unsigned int*) SATA_SATA_BIST2_STS_reg))
+#define SATA_SATA_BIST2_STS_inst_adr                                                 "0x00F1"
+#define SATA_SATA_BIST2_STS_inst                                                     0x00F1
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_5_shift                              (14)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_5_mask                               (0x00004000)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_5(data)                              (0x00004000&((data)<<14))
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_5_src(data)                          ((0x00004000&(data))>>14)
+#define SATA_SATA_BIST2_STS_get_sata_drf_bist2_fail_5(data)                          ((0x00004000&(data))>>14)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_5_shift                                  (13)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_5_mask                                   (0x00002000)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_5(data)                                  (0x00002000&((data)<<13))
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_5_src(data)                              ((0x00002000&(data))>>13)
+#define SATA_SATA_BIST2_STS_get_sata_bist2_fail_5(data)                              ((0x00002000&(data))>>13)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_4_shift                              (12)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_4_mask                               (0x00001000)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_4(data)                              (0x00001000&((data)<<12))
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_4_src(data)                          ((0x00001000&(data))>>12)
+#define SATA_SATA_BIST2_STS_get_sata_drf_bist2_fail_4(data)                          ((0x00001000&(data))>>12)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_4_shift                                  (11)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_4_mask                                   (0x00000800)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_4(data)                                  (0x00000800&((data)<<11))
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_4_src(data)                              ((0x00000800&(data))>>11)
+#define SATA_SATA_BIST2_STS_get_sata_bist2_fail_4(data)                              ((0x00000800&(data))>>11)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_3_shift                              (10)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_3_mask                               (0x00000400)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_3(data)                              (0x00000400&((data)<<10))
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_3_src(data)                          ((0x00000400&(data))>>10)
+#define SATA_SATA_BIST2_STS_get_sata_drf_bist2_fail_3(data)                          ((0x00000400&(data))>>10)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_3_shift                                  (9)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_3_mask                                   (0x00000200)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_3(data)                                  (0x00000200&((data)<<9))
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_3_src(data)                              ((0x00000200&(data))>>9)
+#define SATA_SATA_BIST2_STS_get_sata_bist2_fail_3(data)                              ((0x00000200&(data))>>9)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_2_shift                              (8)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_2_mask                               (0x00000100)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_2(data)                              (0x00000100&((data)<<8))
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_2_src(data)                          ((0x00000100&(data))>>8)
+#define SATA_SATA_BIST2_STS_get_sata_drf_bist2_fail_2(data)                          ((0x00000100&(data))>>8)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_2_shift                                  (7)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_2_mask                                   (0x00000080)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_2(data)                                  (0x00000080&((data)<<7))
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_2_src(data)                              ((0x00000080&(data))>>7)
+#define SATA_SATA_BIST2_STS_get_sata_bist2_fail_2(data)                              ((0x00000080&(data))>>7)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_1_shift                              (6)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_1_mask                               (0x00000040)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_1(data)                              (0x00000040&((data)<<6))
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_1_src(data)                          ((0x00000040&(data))>>6)
+#define SATA_SATA_BIST2_STS_get_sata_drf_bist2_fail_1(data)                          ((0x00000040&(data))>>6)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_1_shift                                  (5)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_1_mask                                   (0x00000020)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_1(data)                                  (0x00000020&((data)<<5))
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_1_src(data)                              ((0x00000020&(data))>>5)
+#define SATA_SATA_BIST2_STS_get_sata_bist2_fail_1(data)                              ((0x00000020&(data))>>5)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_0_shift                              (4)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_0_mask                               (0x00000010)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_0(data)                              (0x00000010&((data)<<4))
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_fail_0_src(data)                          ((0x00000010&(data))>>4)
+#define SATA_SATA_BIST2_STS_get_sata_drf_bist2_fail_0(data)                          ((0x00000010&(data))>>4)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_0_shift                                  (3)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_0_mask                                   (0x00000008)
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_0(data)                                  (0x00000008&((data)<<3))
+#define SATA_SATA_BIST2_STS_sata_bist2_fail_0_src(data)                              ((0x00000008&(data))>>3)
+#define SATA_SATA_BIST2_STS_get_sata_bist2_fail_0(data)                              ((0x00000008&(data))>>3)
+#define SATA_SATA_BIST2_STS_sata_drf_2_start_pause_shift                             (2)
+#define SATA_SATA_BIST2_STS_sata_drf_2_start_pause_mask                              (0x00000004)
+#define SATA_SATA_BIST2_STS_sata_drf_2_start_pause(data)                             (0x00000004&((data)<<2))
+#define SATA_SATA_BIST2_STS_sata_drf_2_start_pause_src(data)                         ((0x00000004&(data))>>2)
+#define SATA_SATA_BIST2_STS_get_sata_drf_2_start_pause(data)                         ((0x00000004&(data))>>2)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_done_shift                                (1)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_done_mask                                 (0x00000002)
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_done(data)                                (0x00000002&((data)<<1))
+#define SATA_SATA_BIST2_STS_sata_drf_bist2_done_src(data)                            ((0x00000002&(data))>>1)
+#define SATA_SATA_BIST2_STS_get_sata_drf_bist2_done(data)                            ((0x00000002&(data))>>1)
+#define SATA_SATA_BIST2_STS_sata_bist2_done_shift                                    (0)
+#define SATA_SATA_BIST2_STS_sata_bist2_done_mask                                     (0x00000001)
+#define SATA_SATA_BIST2_STS_sata_bist2_done(data)                                    (0x00000001&((data)<<0))
+#define SATA_SATA_BIST2_STS_sata_bist2_done_src(data)                                ((0x00000001&(data))>>0)
+#define SATA_SATA_BIST2_STS_get_sata_bist2_done(data)                                ((0x00000001&(data))>>0)
+
+
+#define SATA_SATA_DUMMY_0_REG                                                        0x9803FFC8
+#define SATA_SATA_DUMMY_0_REG_reg_addr                                               "0xD803FFC8"
+#define SATA_SATA_DUMMY_0_REG_reg                                                    0xD803FFC8
+#define set_SATA_SATA_DUMMY_0_REG_reg(data)   (*((volatile unsigned int*) SATA_SATA_DUMMY_0_REG_reg)=data)
+#define get_SATA_SATA_DUMMY_0_REG_reg   (*((volatile unsigned int*) SATA_SATA_DUMMY_0_REG_reg))
+#define SATA_SATA_DUMMY_0_REG_inst_adr                                               "0x00F2"
+#define SATA_SATA_DUMMY_0_REG_inst                                                   0x00F2
+#define SATA_SATA_DUMMY_0_REG_dummy_0_shift                                          (0)
+#define SATA_SATA_DUMMY_0_REG_dummy_0_mask                                           (0xFFFFFFFF)
+#define SATA_SATA_DUMMY_0_REG_dummy_0(data)                                          (0xFFFFFFFF&((data)<<0))
+#define SATA_SATA_DUMMY_0_REG_dummy_0_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define SATA_SATA_DUMMY_0_REG_get_dummy_0(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define SATA_SATA_DUMMY_1_REG                                                        0x9803FFCC
+#define SATA_SATA_DUMMY_1_REG_reg_addr                                               "0xD803FFCC"
+#define SATA_SATA_DUMMY_1_REG_reg                                                    0xD803FFCC
+#define set_SATA_SATA_DUMMY_1_REG_reg(data)   (*((volatile unsigned int*) SATA_SATA_DUMMY_1_REG_reg)=data)
+#define get_SATA_SATA_DUMMY_1_REG_reg   (*((volatile unsigned int*) SATA_SATA_DUMMY_1_REG_reg))
+#define SATA_SATA_DUMMY_1_REG_inst_adr                                               "0x00F3"
+#define SATA_SATA_DUMMY_1_REG_inst                                                   0x00F3
+#define SATA_SATA_DUMMY_1_REG_dummy_1_shift                                          (0)
+#define SATA_SATA_DUMMY_1_REG_dummy_1_mask                                           (0xFFFFFFFF)
+#define SATA_SATA_DUMMY_1_REG_dummy_1(data)                                          (0xFFFFFFFF&((data)<<0))
+#define SATA_SATA_DUMMY_1_REG_dummy_1_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define SATA_SATA_DUMMY_1_REG_get_dummy_1(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/sb2_reg.h b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/sb2_reg.h
new file mode 100644
index 00000000..05e86c2
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/AsicDriver/sb2_reg.h
@@ -0,0 +1,5563 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+/**************************************************************
+// Spec Version                  : 0.1.6
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/7/29 16:34:45
+***************************************************************/
+
+
+#ifndef _SB2_REG_H_INCLUDED_
+#define _SB2_REG_H_INCLUDED_
+#ifdef  _SB2_USE_STRUCT
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     Semaphore:1;
+}SB2_HD_SEM;
+
+typedef struct
+{
+unsigned int     reserved_0:25;
+unsigned int     swcivairq_en:1;
+unsigned int     To_en1:1;
+unsigned int     To_en:1;
+unsigned int     acivairq_en:1;
+unsigned int     reserved_1:1;
+unsigned int     scivairq_en:1;
+unsigned int     write_data:1;
+}SB2_INV_INTEN;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     swciva_int:1;
+unsigned int     Aciva_int:1;
+unsigned int     reserved_1:1;
+unsigned int     Sciva_int:1;
+unsigned int     write_data:1;
+}SB2_INV_INTSTAT;
+
+typedef struct
+{
+unsigned int     Inv_adr:32;
+}SB2_INV_ADDR;
+
+typedef struct
+{
+unsigned int     reserved_0:25;
+unsigned int     To_thr1:4;
+unsigned int     To_thr:3;
+}SB2_DEBUG_REG;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     Wr_hold_cyc:4;
+unsigned int     reserved_1:3;
+unsigned int     Wwr_cyc:5;
+unsigned int     Wr_cyc:5;
+unsigned int     Rd_cyc:5;
+}SB2_FLASH_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:17;
+unsigned int     write_en13:1;
+unsigned int     mult_wr_en:1;
+unsigned int     write_en11:1;
+unsigned int     ac_in_order:1;
+unsigned int     write_en9:1;
+unsigned int     ac_bypass:1;
+unsigned int     write_en7:1;
+unsigned int     ac_merge:1;
+unsigned int     reserved_1:3;
+unsigned int     write_en2:1;
+unsigned int     sc_in_order:1;
+unsigned int     reserved_2:2;
+}SB2_WRAPPER_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}SB2_SCPU_INT_CHECK;
+
+typedef struct
+{
+unsigned int     Sync:32;
+}SB2_SYNC;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     Dbg_mode:5;
+}SB2_DBG;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     write_enable3:1;
+unsigned int     sel1:6;
+unsigned int     write_enable2:1;
+unsigned int     sel0:6;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}SB2_SB2_DEBUG;
+
+typedef struct
+{
+unsigned int     reserved_0:12;
+unsigned int     pcie1_tostat:1;
+unsigned int     sata_tostat:1;
+unsigned int     pcie0_tostat:1;
+unsigned int     etn_tostat:1;
+unsigned int     reserved_1:12;
+unsigned int     pcie1_tostat_auto:1;
+unsigned int     sata_tostat_auto:1;
+unsigned int     pcie0_tostat_auto:1;
+unsigned int     etn_tostat_auto:1;
+}SB2_RBUS1_TOSTAT;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     clk_gate_dis:1;
+unsigned int     speed_up:1;
+}SB2_LEXRA_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     int_aswc:1;
+unsigned int     int_swca:1;
+unsigned int     reserved_1:6;
+unsigned int     int_as:1;
+unsigned int     reserved_2:1;
+unsigned int     int_sa:1;
+unsigned int     write_data:1;
+}SB2_CPU_INT;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     int_aswc_en:1;
+unsigned int     int_swca_en:1;
+unsigned int     reserved_1:6;
+unsigned int     int_as_en:1;
+unsigned int     reserved_2:1;
+unsigned int     int_sa_en:1;
+unsigned int     write_data:1;
+}SB2_CPU_INT_EN;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     pending:1;
+unsigned int     reserved_1:2;
+unsigned int     mask_id:3;
+}SB2_DREQ_MASK;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     Chip_id:16;
+}SB2_CHIP_ID;
+
+typedef struct
+{
+unsigned int     Revise_id:16;
+unsigned int     reserved_0:16;
+}SB2_CHIP_INFO;
+
+typedef struct
+{
+unsigned int     rom_remap:20;
+unsigned int     reserved_0:12;
+}SB2_ACPU_ROM_REMAP;
+
+typedef struct
+{
+unsigned int     gnt_wr_delay:4;
+unsigned int     acc_write_delay:4;
+unsigned int     reserved_0:4;
+unsigned int     did_com:4;
+unsigned int     reserved_1:4;
+unsigned int     read_comm:4;
+unsigned int     reserved_2:4;
+unsigned int     addcmd:4;
+}SB2_ACPU_DELAY;
+
+typedef struct
+{
+unsigned int     cbustx_en:1;
+unsigned int     cbusiso_en:1;
+unsigned int     isomis_en:1;
+unsigned int     ae_en:1;
+unsigned int     gpu_en:1;
+unsigned int     mis_en:1;
+unsigned int     rsa_en:1;
+unsigned int     dcsb_en:1;
+unsigned int     scw_en:1;
+unsigned int     sbx_en:1;
+unsigned int     sb2_en:1;
+unsigned int     md_en:1;
+unsigned int     jpeg_en:1;
+unsigned int     nat_en:1;
+unsigned int     usb3host_2_en:1;
+unsigned int     usb3drd_en:1;
+unsigned int     usb3host_en:1;
+unsigned int     usb2_en:1;
+unsigned int     usb_en:1;
+unsigned int     dbp4_en:1;
+unsigned int     dbp_en:1;
+unsigned int     efs_en:1;
+unsigned int     etn_en:1;
+unsigned int     pcie_en:1;
+unsigned int     cr_en:1;
+unsigned int     sdio_en:1;
+unsigned int     emmc_en:1;
+unsigned int     nfs_en:1;
+unsigned int     nf_en:1;
+unsigned int     sata_en:1;
+unsigned int     tp_en:1;
+unsigned int     cp_en:1;
+}SB2_RBUS_ICG1;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     ve3_en:1;
+unsigned int     ve2_en:1;
+unsigned int     ve1_en:1;
+unsigned int     lvds_en:1;
+unsigned int     edp_en:1;
+unsigned int     cbusrx_en:1;
+unsigned int     hdmir_en:1;
+unsigned int     hdmit_en:1;
+unsigned int     se_en:1;
+unsigned int     mipi_en:1;
+unsigned int     dptmx_en:1;
+unsigned int     tve_en:1;
+unsigned int     voregsram_en:1;
+unsigned int     ao_en:1;
+unsigned int     vo_en:1;
+unsigned int     sys_en:1;
+}SB2_RBUS_ICG2;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     tmp11:1;
+unsigned int     tmp10:1;
+unsigned int     tmp9:1;
+unsigned int     tmp8:1;
+unsigned int     tmp7:1;
+unsigned int     tmp6:1;
+unsigned int     tmp5:1;
+unsigned int     tmp4:1;
+unsigned int     tmp3:1;
+unsigned int     tmp2:1;
+unsigned int     tmp1:1;
+unsigned int     tmp0:1;
+unsigned int     mon_en:1;
+unsigned int     dbus_en:1;
+unsigned int     rbus_en:1;
+unsigned int     spi_en:1;
+}SB2_RBUS_ICG3;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     hif_rdata_swap:1;
+unsigned int     hif_wdata_swap:1;
+}SB2_HIF_CTRL1;
+
+typedef struct
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en6:1;
+unsigned int     acpu_rbus_go:1;
+unsigned int     reserved_1:2;
+unsigned int     write_en4:1;
+unsigned int     scpu_rbus_go:1;
+unsigned int     write_en3:1;
+unsigned int     acpu_dbus_go:1;
+unsigned int     reserved_2:4;
+}SB2_PC_CTRL;
+
+typedef struct
+{
+unsigned int     acpu_dbus_acc:32;
+}SB2_ACPU_DACC;
+
+typedef struct
+{
+unsigned int     reserved_0:8;
+unsigned int     acpu_dreq_num:24;
+}SB2_ACPU_DREQ_NUM;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     acpu_dreq_max:16;
+}SB2_ACPU_DREQ_MAX;
+
+typedef struct
+{
+unsigned int     reserved_0:6;
+unsigned int     acpu_dreq_ack:26;
+}SB2_ACPU_DREQ_ACK;
+
+typedef struct
+{
+unsigned int     scpu_rbus_acc:32;
+}SB2_SCPU_RACC;
+
+typedef struct
+{
+unsigned int     scpu_rreq_max:8;
+unsigned int     scpu_rreq_num:24;
+}SB2_SCPU_RREQ_RLT;
+
+typedef struct
+{
+unsigned int     acpu_rbus_acc:32;
+}SB2_ACPU_RACC;
+
+typedef struct
+{
+unsigned int     acpu_rreq_max:8;
+unsigned int     acpu_rreq_num:24;
+}SB2_ACPU_RREQ_RLT;
+
+typedef struct
+{
+unsigned int     Dbg_start_addr:32;
+}SB2_DBG_START;
+
+typedef struct
+{
+unsigned int     Dbg_end_addr:32;
+}SB2_DBG_END;
+
+typedef struct
+{
+unsigned int     reserved_0:18;
+unsigned int     write_en6:1;
+unsigned int     Dbg_acpu_chk_en:1;
+unsigned int     reserved_1:2;
+unsigned int     write_en4:1;
+unsigned int     Dbg_scpu_chk_en:1;
+unsigned int     write_en3:1;
+unsigned int     Dbg_wr_chk:2;
+unsigned int     write_en2:1;
+unsigned int     Dbg_id_chk:2;
+unsigned int     write_en1:1;
+unsigned int     Dbg_en:1;
+}SB2_DBG_CTRL;
+
+typedef struct
+{
+unsigned int     dbg_addr:32;
+}SB2_DBG_ADDR;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     acpu_dbg_write:1;
+unsigned int     acpu_dbg_dacc:1;
+unsigned int     scpu_dbg_write:1;
+unsigned int     scpu_dbg_dacc:1;
+unsigned int     reserved_1:2;
+}SB2_DBG_ADDR1;
+
+typedef struct
+{
+unsigned int     reserved_0:19;
+unsigned int     acpu_int:1;
+unsigned int     reserved_1:1;
+unsigned int     scpu_int:1;
+unsigned int     acpu_int_en:1;
+unsigned int     reserved_2:1;
+unsigned int     scpu_int_en:1;
+unsigned int     acpu_neg_int:1;
+unsigned int     reserved_3:1;
+unsigned int     scpu_neg_int:1;
+unsigned int     acpu_neg_int_en:1;
+unsigned int     reserved_4:1;
+unsigned int     scpu_neg_int_en:1;
+unsigned int     write_data:1;
+}SB2_DBG_INT;
+
+typedef struct
+{
+unsigned int     dbg_wdata:32;
+}SB2_DBG_WDATA;
+
+typedef struct
+{
+unsigned int     data:32;
+}SB2_DUMMY;
+
+typedef struct
+{
+unsigned int     data:32;
+}SB2_SHADOW;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     Semaphore:1;
+}SB2_HD_SEM_NEW;
+
+typedef struct
+{
+unsigned int     reserved_0:29;
+unsigned int     inva_wr_sec2_en:1;
+unsigned int     reserved_1:1;
+unsigned int     inva_wr_sec1_en:1;
+}SB2_RBUS_INVA_ACC_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     sec1_start:20;
+unsigned int     reserved_1:2;
+}SB2_RBUS_INVA_ACC_SEC1_START;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     sec1_end:20;
+unsigned int     reserved_1:2;
+}SB2_RBUS_INVA_ACC_SEC1_END;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     sec2_start:20;
+unsigned int     reserved_1:2;
+}SB2_RBUS_INVA_ACC_SEC2_START;
+
+typedef struct
+{
+unsigned int     reserved_0:10;
+unsigned int     sec2_end:20;
+unsigned int     reserved_1:2;
+}SB2_RBUS_INVA_ACC_SEC2_END;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     crc_cmp_latch_en:1;
+}SB2_RBUS_CMP_CTRL;
+
+typedef struct
+{
+unsigned int     crc_cmp_expect0:32;
+}SB2_RBUS_CMP_DATA0;
+
+typedef struct
+{
+unsigned int     crc_cmp_expect1:32;
+}SB2_RBUS_CMP_DATA1;
+
+typedef struct
+{
+unsigned int     reserved_0:30;
+unsigned int     crc_cmp_result0:1;
+unsigned int     crc_cmp_result1:1;
+}SB2_RBUS_CMP_RESULT;
+
+typedef struct
+{
+unsigned int     reserved_0:24;
+unsigned int     sb2_bist_rstn:1;
+unsigned int     sb2_bist_en:1;
+unsigned int     sb2_rom_ls:1;
+unsigned int     sb2_rom_rme:1;
+unsigned int     sb2_rom_rm:4;
+}SB2_BIST_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:15;
+unsigned int     sb2_rom_bist_done:1;
+unsigned int     reserved_1:16;
+}SB2_BIST_STATUS;
+
+typedef struct
+{
+unsigned int     sb2_misr_dataout_0:32;
+}SB2_BIST_MISR_DATAOUT0;
+
+typedef struct
+{
+unsigned int     sb2_misr_dataout_1:32;
+}SB2_BIST_MISR_DATAOUT1;
+
+typedef struct
+{
+unsigned int     reserved_0:21;
+unsigned int     dual_mode:2;
+unsigned int     fat_mode:1;
+unsigned int     opc:8;
+}SB2_SFC_OPCODE;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     reserved_1:11;
+unsigned int     dataen:1;
+unsigned int     adren:1;
+unsigned int     dmycnt:3;
+}SB2_SFC_CTL;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     reserved_1:7;
+unsigned int     mode:1;
+unsigned int     fdiv:8;
+}SB2_SFC_SCK;
+
+typedef struct
+{
+unsigned int     tdt:16;
+unsigned int     Phcnt:8;
+unsigned int     Plcnt:8;
+}SB2_SFC_CE;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en5:1;
+unsigned int     rdy:1;
+unsigned int     reserved_1:24;
+unsigned int     write_en1:1;
+unsigned int     wp_n:1;
+}SB2_SFC_WP;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     pos_latch:1;
+}SB2_SFC_POS_LATCH;
+
+typedef struct
+{
+unsigned int     reserved_0:23;
+unsigned int     wt_prog_done:1;
+unsigned int     rdsr_op:8;
+}SB2_SFC_WAIT_WR;
+
+typedef struct
+{
+unsigned int     reserved_0:23;
+unsigned int     wt_prog_en:1;
+unsigned int     wr_en_op:8;
+}SB2_SFC_EN_WR;
+
+typedef struct
+{
+unsigned int     reserved_0:27;
+unsigned int     sf_dclk_sel:1;
+unsigned int     fifo_write_tap:3;
+unsigned int     fast_read_en:1;
+}SB2_SFC_FAST_RD;
+
+typedef struct
+{
+unsigned int     delay_clk_tap:32;
+}SB2_SFC_SCK_TAP;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     SFC_OPCODE_adr4byte_en:1;
+}SB2_SFC_ADR_FOUR_BYTE_EN;
+
+typedef struct
+{
+unsigned int     reserved_0:8;
+unsigned int     tp1_clk:2;
+unsigned int     tp1_valid:2;
+unsigned int     tp1_sync:2;
+unsigned int     tp1_data:2;
+unsigned int     reserved_1:4;
+unsigned int     tp0_clk:3;
+unsigned int     tp0_valid:3;
+unsigned int     tp0_sync:3;
+unsigned int     tp0_data:3;
+}SB2_MUXPAD2;
+
+typedef struct
+{
+unsigned int     sensor_cko_0:2;
+unsigned int     sensor_cko_1:2;
+unsigned int     sensor_rst:2;
+unsigned int     sensor_stb_0:2;
+unsigned int     sensor_stb_1:2;
+unsigned int     ejtag_scpu_loc:2;
+unsigned int     hi_loc:2;
+unsigned int     usb_id:2;
+unsigned int     reserved_0:4;
+unsigned int     i2c_scl_5:2;
+unsigned int     i2c_sda_5:2;
+unsigned int     i2c_scl_4:2;
+unsigned int     i2c_sda_4:2;
+unsigned int     reserved_1:4;
+}SB2_MUXPAD3;
+
+typedef struct
+{
+unsigned int     reserved_0:8;
+unsigned int     gpio_9:2;
+unsigned int     gpio_8:2;
+unsigned int     gpio_7:2;
+unsigned int     gpio_6:2;
+unsigned int     gpio_5:2;
+unsigned int     gpio_4:2;
+unsigned int     gpio_3:3;
+unsigned int     gpio_2:3;
+unsigned int     gpio_1:3;
+unsigned int     gpio_0:3;
+}SB2_MUXPAD4;
+
+typedef struct
+{
+unsigned int     reserved_0:23;
+unsigned int     tp1_loc:1;
+unsigned int     tp0_loc:1;
+unsigned int     debug_p2s_enable:1;
+unsigned int     ur1_loc:2;
+unsigned int     ao_loc:2;
+unsigned int     arm_trace_dbg_en:1;
+unsigned int     sf_en:1;
+}SB2_MUXPAD5;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     tp0_data_smt:1;
+unsigned int     tp0_data_e2:1;
+unsigned int     tp0_data_pud_en:1;
+unsigned int     tp0_data_pud_sel:1;
+unsigned int     tp0_valid_smt:1;
+unsigned int     tp0_valid_e2:1;
+unsigned int     tp0_valid_pud_en:1;
+unsigned int     tp0_valid_pud_sel:1;
+unsigned int     tp0_sync_smt:1;
+unsigned int     tp0_sync_e2:1;
+unsigned int     tp0_sync_pud_en:1;
+unsigned int     tp0_sync_pud_sel:1;
+unsigned int     tp0_clk_smt:1;
+unsigned int     tp0_clk_e2:1;
+unsigned int     tp0_clk_pud_en:1;
+unsigned int     tp0_clk_pud_sel:1;
+}SB2_PFUNC_TP0;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     tp1_data_smt:1;
+unsigned int     tp1_data_e2:1;
+unsigned int     tp1_data_pud_en:1;
+unsigned int     tp1_data_pud_sel:1;
+unsigned int     tp1_valid_smt:1;
+unsigned int     tp1_valid_e2:1;
+unsigned int     tp1_valid_pud_en:1;
+unsigned int     tp1_valid_pud_sel:1;
+unsigned int     tp1_sync_smt:1;
+unsigned int     tp1_sync_e2:1;
+unsigned int     tp1_sync_pud_en:1;
+unsigned int     tp1_sync_pud_sel:1;
+unsigned int     tp1_clk_smt:1;
+unsigned int     tp1_clk_e2:1;
+unsigned int     tp1_clk_pud_en:1;
+unsigned int     tp1_clk_pud_sel:1;
+}SB2_PFUNC_TP1;
+
+typedef struct
+{
+unsigned int     reserved_0:8;
+unsigned int     i2c_scl_5_smt:1;
+unsigned int     i2c_scl_5_e2:1;
+unsigned int     i2c_scl_5_pud_en:1;
+unsigned int     i2c_scl_5_pud_sel:1;
+unsigned int     i2c_sda_5_smt:1;
+unsigned int     i2c_sda_5_e2:1;
+unsigned int     i2c_sda_5_pud_en:1;
+unsigned int     i2c_sda_5_pud_sel:1;
+unsigned int     i2c_scl_4_smt:1;
+unsigned int     i2c_scl_4_e2:1;
+unsigned int     i2c_scl_4_pud_en:1;
+unsigned int     i2c_scl_4_pud_sel:1;
+unsigned int     i2c_sda_4_smt:1;
+unsigned int     i2c_sda_4_e2:1;
+unsigned int     i2c_sda_4_pud_en:1;
+unsigned int     i2c_sda_4_pud_sel:1;
+unsigned int     reserved_1:8;
+}SB2_PFUNC_MISC0;
+
+typedef struct
+{
+unsigned int     gpio_7_smt:1;
+unsigned int     gpio_7_e2:1;
+unsigned int     gpio_7_pud_en:1;
+unsigned int     gpio_7_pud_sel:1;
+unsigned int     gpio_6_smt:1;
+unsigned int     gpio_6_e2:1;
+unsigned int     gpio_6_pud_en:1;
+unsigned int     gpio_6_pud_sel:1;
+unsigned int     gpio_5_smt:1;
+unsigned int     gpio_5_e2:1;
+unsigned int     gpio_5_pud_en:1;
+unsigned int     gpio_5_pud_sel:1;
+unsigned int     gpio_4_smt:1;
+unsigned int     gpio_4_e2:1;
+unsigned int     gpio_4_pud_en:1;
+unsigned int     gpio_4_pud_sel:1;
+unsigned int     gpio_3_smt:1;
+unsigned int     gpio_3_e2:1;
+unsigned int     gpio_3_pud_en:1;
+unsigned int     gpio_3_pud_sel:1;
+unsigned int     gpio_2_smt:1;
+unsigned int     gpio_2_e2:1;
+unsigned int     gpio_2_pud_en:1;
+unsigned int     gpio_2_pud_sel:1;
+unsigned int     gpio_1_smt:1;
+unsigned int     gpio_1_e2:1;
+unsigned int     gpio_1_pud_en:1;
+unsigned int     gpio_1_pud_sel:1;
+unsigned int     gpio_0_smt:1;
+unsigned int     gpio_0_e2:1;
+unsigned int     gpio_0_pud_en:1;
+unsigned int     gpio_0_pud_sel:1;
+}SB2_PFUNC_MISC1;
+
+typedef struct
+{
+unsigned int     sensor_cko1_smt:1;
+unsigned int     sensor_cko1_e2:1;
+unsigned int     sensor_cko1_pud_en:1;
+unsigned int     sensor_cko1_pud_sel:1;
+unsigned int     sensor_cko0_smt:1;
+unsigned int     sensor_cko0_e2:1;
+unsigned int     sensor_cko0_pud_en:1;
+unsigned int     sensor_cko0_pud_sel:1;
+unsigned int     sensor_rst_smt:1;
+unsigned int     sensor_rst_e2:1;
+unsigned int     sensor_rst_pud_en:1;
+unsigned int     sensor_rst_pud_sel:1;
+unsigned int     sensor_stb1_smt:1;
+unsigned int     sensor_stb1_e2:1;
+unsigned int     sensor_stb1_pud_en:1;
+unsigned int     sensor_stb1_pud_sel:1;
+unsigned int     sensor_stb0_smt:1;
+unsigned int     sensor_stb0_e2:1;
+unsigned int     sensor_stb0_pud_en:1;
+unsigned int     sensor_stb0_pud_sel:1;
+unsigned int     usb_id_smt:1;
+unsigned int     usb_id_e2:1;
+unsigned int     usb_id_pud_en:1;
+unsigned int     usb_id_pud_sel:1;
+unsigned int     gpio_9_smt:1;
+unsigned int     gpio_9_e2:1;
+unsigned int     gpio_9_pud_en:1;
+unsigned int     gpio_9_pud_sel:1;
+unsigned int     gpio_8_smt:1;
+unsigned int     gpio_8_e2:1;
+unsigned int     gpio_8_pud_en:1;
+unsigned int     gpio_8_pud_sel:1;
+}SB2_PFUNC_MISC2;
+
+typedef struct
+{
+unsigned int     reserved_0:5;
+unsigned int     boption4_smt:1;
+unsigned int     boption4_pud_en:1;
+unsigned int     boption4_pud_sel:1;
+unsigned int     boption3_smt:1;
+unsigned int     boption3_pud_en:1;
+unsigned int     boption3_pud_sel:1;
+unsigned int     boption1_smt:1;
+unsigned int     boption1_pud_en:1;
+unsigned int     boption1_pud_sel:1;
+unsigned int     boption0_smt:1;
+unsigned int     boption0_pud_en:1;
+unsigned int     boption0_pud_sel:1;
+unsigned int     boption9_smt:1;
+unsigned int     boption9_pud_en:1;
+unsigned int     boption9_pud_sel:1;
+unsigned int     boption8_smt:1;
+unsigned int     boption8_pud_en:1;
+unsigned int     boption8_pud_sel:1;
+unsigned int     boption7_smt:1;
+unsigned int     boption7_pud_en:1;
+unsigned int     boption7_pud_sel:1;
+unsigned int     boption6_smt:1;
+unsigned int     boption6_pud_en:1;
+unsigned int     boption6_pud_sel:1;
+unsigned int     boption5_smt:1;
+unsigned int     boption5_pud_en:1;
+unsigned int     boption5_pud_sel:1;
+}SB2_PFUNC_MISC3;
+
+typedef struct
+{
+unsigned int     main1_dbg_en:1;
+unsigned int     reserved_0:3;
+unsigned int     main1_dbg_sel:4;
+unsigned int     reserved_1:9;
+unsigned int     dbg_en:1;
+unsigned int     dbg_loc:2;
+unsigned int     dbg_sel0:6;
+unsigned int     dbg_sel1:6;
+}SB2_DEBUG;
+
+typedef struct
+{
+unsigned int     reserved_0:3;
+unsigned int     mbist_gpu_chip_top_st:1;
+unsigned int     mbist_jpeg_st:1;
+unsigned int     mbist_ve1_st:1;
+unsigned int     mbist_ve2_st:1;
+unsigned int     mbist_ve3_st:1;
+unsigned int     mbist_rsa_st:1;
+unsigned int     mbist_sata_st:1;
+unsigned int     mbist_pcie0_st:1;
+unsigned int     mbist_pcie1_st:1;
+unsigned int     mbist_nat_st:1;
+unsigned int     mbist_mipi_st:1;
+unsigned int     mbist_usb_st:1;
+unsigned int     mbist_se_st:1;
+unsigned int     mbist_md_st:1;
+unsigned int     mbist_nf_st:1;
+unsigned int     mbist_cr_st:1;
+unsigned int     mbist_etn_st:1;
+unsigned int     mbist_dp_st:1;
+unsigned int     mbist_ae_st:1;
+unsigned int     mbist_acpu_st:1;
+unsigned int     mbist_gpu_st:1;
+unsigned int     mbist_tp_st:1;
+unsigned int     mbist_aio_st:1;
+unsigned int     mbist_pif_st:1;
+unsigned int     mbist_hdmi_st:1;
+unsigned int     mbist_vo_st:1;
+unsigned int     mbist_dc_phy_st:1;
+unsigned int     mbist_dc_sys_st:1;
+unsigned int     mbist_cp_st:1;
+}SB2_MBIST;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     rgmii0_txd_3_sr:1;
+unsigned int     rgmii0_txd_2_sr:1;
+unsigned int     rgmii0_txd_1_sr:1;
+unsigned int     rgmii0_txd_0_sr:1;
+unsigned int     rgmii0_tx_ctl_sr:1;
+unsigned int     rgmii0_txc_sr:1;
+}SB2_PFUNC_RG0;
+
+typedef struct
+{
+unsigned int     rgmii0_rx_ctl_smt:1;
+unsigned int     rgmii0_rx_ctl_e2:1;
+unsigned int     rgmii0_rx_ctl_pud_en:1;
+unsigned int     rgmii0_rx_ctl_pud_sel:1;
+unsigned int     rgmii0_rxc_smt:1;
+unsigned int     rgmii0_rxc_e2:1;
+unsigned int     rgmii0_rxc_pud_en:1;
+unsigned int     rgmii0_rxc_pud_sel:1;
+unsigned int     rgmii0_txd_3_smt:1;
+unsigned int     rgmii0_txd_3_e2:1;
+unsigned int     rgmii0_txd_3_pud_en:1;
+unsigned int     rgmii0_txd_3_pud_sel:1;
+unsigned int     rgmii0_txd_2_smt:1;
+unsigned int     rgmii0_txd_2_e2:1;
+unsigned int     rgmii0_txd_2_pud_en:1;
+unsigned int     rgmii0_txd_2_pud_sel:1;
+unsigned int     rgmii0_txd_1_smt:1;
+unsigned int     rgmii0_txd_1_e2:1;
+unsigned int     rgmii0_txd_1_pud_en:1;
+unsigned int     rgmii0_txd_1_pud_sel:1;
+unsigned int     rgmii0_txd_0_smt:1;
+unsigned int     rgmii0_txd_0_e2:1;
+unsigned int     rgmii0_txd_0_pud_en:1;
+unsigned int     rgmii0_txd_0_pud_sel:1;
+unsigned int     rgmii0_tx_ctl_smt:1;
+unsigned int     rgmii0_tx_ctl_e2:1;
+unsigned int     rgmii0_tx_ctl_pud_en:1;
+unsigned int     rgmii0_tx_ctl_pud_sel:1;
+unsigned int     rgmii0_txc_smt:1;
+unsigned int     rgmii0_txc_e2:1;
+unsigned int     rgmii0_txc_pud_en:1;
+unsigned int     rgmii0_txc_pud_sel:1;
+}SB2_PFUNC_RG1;
+
+typedef struct
+{
+unsigned int     rgmii0_bias_mode2:1;
+unsigned int     rgmii0_bias_mode:1;
+unsigned int     rgmii0_bias_dn:3;
+unsigned int     rgmii0_bias_dp:3;
+unsigned int     rgmii0_mdc_smt:1;
+unsigned int     rgmii0_mdc_e2:1;
+unsigned int     rgmii0_mdc_pud_en:1;
+unsigned int     rgmii0_mdc_pud_sel:1;
+unsigned int     rgmii0_mdio_smt:1;
+unsigned int     rgmii0_mdio_e2:1;
+unsigned int     rgmii0_mdio_pud_en:1;
+unsigned int     rgmii0_mdio_pud_sel:1;
+unsigned int     rgmii0_rxd_3_smt:1;
+unsigned int     rgmii0_rxd_3_e2:1;
+unsigned int     rgmii0_rxd_3_pud_en:1;
+unsigned int     rgmii0_rxd_3_pud_sel:1;
+unsigned int     rgmii0_rxd_2_smt:1;
+unsigned int     rgmii0_rxd_2_e2:1;
+unsigned int     rgmii0_rxd_2_pud_en:1;
+unsigned int     rgmii0_rxd_2_pud_sel:1;
+unsigned int     rgmii0_rxd_1_smt:1;
+unsigned int     rgmii0_rxd_1_e2:1;
+unsigned int     rgmii0_rxd_1_pud_en:1;
+unsigned int     rgmii0_rxd_1_pud_sel:1;
+unsigned int     rgmii0_rxd_0_smt:1;
+unsigned int     rgmii0_rxd_0_e2:1;
+unsigned int     rgmii0_rxd_0_pud_en:1;
+unsigned int     rgmii0_rxd_0_pud_sel:1;
+}SB2_PFUNC_RG2;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     rgmii0_mdc:2;
+unsigned int     rgmii0_mdio:2;
+unsigned int     rgmii0_rxd_3:2;
+unsigned int     rgmii0_rxd_2:2;
+unsigned int     rgmii0_rxd_1:2;
+unsigned int     rgmii0_rxd_0:2;
+unsigned int     rgmii0_rx_ctl:2;
+unsigned int     rgmii0_rxc:2;
+unsigned int     rgmii0_txd_3:2;
+unsigned int     rgmii0_txd_2:2;
+unsigned int     rgmii0_txd_1:2;
+unsigned int     rgmii0_txd_0:2;
+unsigned int     rgmii0_tx_ctl:2;
+unsigned int     rgmii0_txc:2;
+}SB2_MUXPAD_RG0;
+
+typedef struct
+{
+unsigned int     reserved_0:26;
+unsigned int     rgmii1_txd_3_sr:1;
+unsigned int     rgmii1_txd_2_sr:1;
+unsigned int     rgmii1_txd_1_sr:1;
+unsigned int     rgmii1_txd_0_sr:1;
+unsigned int     rgmii1_tx_ctl_sr:1;
+unsigned int     rgmii1_txc_sr:1;
+}SB2_PFUNC_RG3;
+
+typedef struct
+{
+unsigned int     rgmii1_rx_ctl_smt:1;
+unsigned int     rgmii1_rx_ctl_e2:1;
+unsigned int     rgmii1_rx_ctl_pud_en:1;
+unsigned int     rgmii1_rx_ctl_pud_sel:1;
+unsigned int     rgmii1_rxc_smt:1;
+unsigned int     rgmii1_rxc_e2:1;
+unsigned int     rgmii1_rxc_pud_en:1;
+unsigned int     rgmii1_rxc_pud_sel:1;
+unsigned int     rgmii1_txd_3_smt:1;
+unsigned int     rgmii1_txd_3_e2:1;
+unsigned int     rgmii1_txd_3_pud_en:1;
+unsigned int     rgmii1_txd_3_pud_sel:1;
+unsigned int     rgmii1_txd_2_smt:1;
+unsigned int     rgmii1_txd_2_e2:1;
+unsigned int     rgmii1_txd_2_pud_en:1;
+unsigned int     rgmii1_txd_2_pud_sel:1;
+unsigned int     rgmii1_txd_1_smt:1;
+unsigned int     rgmii1_txd_1_e2:1;
+unsigned int     rgmii1_txd_1_pud_en:1;
+unsigned int     rgmii1_txd_1_pud_sel:1;
+unsigned int     rgmii1_txd_0_smt:1;
+unsigned int     rgmii1_txd_0_e2:1;
+unsigned int     rgmii1_txd_0_pud_en:1;
+unsigned int     rgmii1_txd_0_pud_sel:1;
+unsigned int     rgmii1_tx_ctl_smt:1;
+unsigned int     rgmii1_tx_ctl_e2:1;
+unsigned int     rgmii1_tx_ctl_pud_en:1;
+unsigned int     rgmii1_tx_ctl_pud_sel:1;
+unsigned int     rgmii1_txc_smt:1;
+unsigned int     rgmii1_txc_e2:1;
+unsigned int     rgmii1_txc_pud_en:1;
+unsigned int     rgmii1_txc_pud_sel:1;
+}SB2_PFUNC_RG4;
+
+typedef struct
+{
+unsigned int     rgmii1_bias_mode2:1;
+unsigned int     rgmii1_bias_mode:1;
+unsigned int     rgmii1_bias_dn:3;
+unsigned int     rgmii1_bias_dp:3;
+unsigned int     reserved_0:8;
+unsigned int     rgmii1_rxd_3_smt:1;
+unsigned int     rgmii1_rxd_3_e2:1;
+unsigned int     rgmii1_rxd_3_pud_en:1;
+unsigned int     rgmii1_rxd_3_pud_sel:1;
+unsigned int     rgmii1_rxd_2_smt:1;
+unsigned int     rgmii1_rxd_2_e2:1;
+unsigned int     rgmii1_rxd_2_pud_en:1;
+unsigned int     rgmii1_rxd_2_pud_sel:1;
+unsigned int     rgmii1_rxd_1_smt:1;
+unsigned int     rgmii1_rxd_1_e2:1;
+unsigned int     rgmii1_rxd_1_pud_en:1;
+unsigned int     rgmii1_rxd_1_pud_sel:1;
+unsigned int     rgmii1_rxd_0_smt:1;
+unsigned int     rgmii1_rxd_0_e2:1;
+unsigned int     rgmii1_rxd_0_pud_en:1;
+unsigned int     rgmii1_rxd_0_pud_sel:1;
+}SB2_PFUNC_RG5;
+
+typedef struct
+{
+unsigned int     reserved_0:4;
+unsigned int     rgmii1_mdc:2;
+unsigned int     rgmii1_mdio:2;
+unsigned int     rgmii1_rxd_3:2;
+unsigned int     rgmii1_rxd_2:2;
+unsigned int     rgmii1_rxd_1:2;
+unsigned int     rgmii1_rxd_0:2;
+unsigned int     rgmii1_rx_ctl:2;
+unsigned int     rgmii1_rxc:2;
+unsigned int     rgmii1_txd_3:2;
+unsigned int     rgmii1_txd_2:2;
+unsigned int     rgmii1_txd_1:2;
+unsigned int     rgmii1_txd_0:2;
+unsigned int     rgmii1_tx_ctl:2;
+unsigned int     rgmii1_txc:2;
+}SB2_MUXPAD_RG1;
+
+typedef struct
+{
+unsigned int     reserved_0:23;
+unsigned int     sata_sgmii_sel:1;
+unsigned int     isolate_sata_sgmii_1:1;
+unsigned int     isolate_sata_sgmii_0:1;
+unsigned int     sata_rx50_link_1:1;
+unsigned int     sata_rx50_link_0:1;
+unsigned int     sata_mbias_en_1:1;
+unsigned int     sata_mbias_en_0:1;
+unsigned int     sata_bg_en_1:1;
+unsigned int     sata_bg_en_0:1;
+}SB2_SATA_PHY_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:14;
+unsigned int     lfsr_mode:1;
+unsigned int     lfsr_bypass_1:1;
+unsigned int     dbg1_sel:4;
+unsigned int     dbg0_sel:4;
+unsigned int     reserved_1:2;
+unsigned int     corrector_imode:1;
+unsigned int     reserved_2:1;
+unsigned int     rng_cali_srst:1;
+unsigned int     corrector_bypass:1;
+unsigned int     clk_hf_sel:1;
+unsigned int     rng_srst:1;
+}SB2_RNG_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:16;
+unsigned int     rosc_d:4;
+unsigned int     rosc_res:2;
+unsigned int     rosc_div:2;
+unsigned int     rosc_gain:2;
+unsigned int     rosc_fs:2;
+unsigned int     reserved_1:2;
+unsigned int     rosc_test:1;
+unsigned int     rosc_pow:1;
+}SB2_RNG_ANALOG;
+
+typedef struct
+{
+unsigned int     prd_ub:16;
+unsigned int     prd_lb:16;
+}SB2_RNG_CALI_CHK;
+
+typedef struct
+{
+unsigned int     shot_num:12;
+unsigned int     cyc_num:3;
+unsigned int     wait_num:5;
+unsigned int     reserved_0:3;
+unsigned int     trig_num:5;
+unsigned int     lock:1;
+unsigned int     shot_mode:1;
+unsigned int     pol:1;
+unsigned int     hw_en:1;
+}SB2_RNG_CALI_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:8;
+unsigned int     hw_d:4;
+unsigned int     reserved_1:2;
+unsigned int     rosc_lock:1;
+unsigned int     cnt_ovflw:1;
+unsigned int     cnt:16;
+}SB2_RNG_RETURN;
+
+typedef struct
+{
+unsigned int     prd_ub:16;
+unsigned int     prd_lb:16;
+}SB2_RNG_LOCK_CHK;
+
+typedef struct
+{
+unsigned int     reserved_0:12;
+unsigned int     exit_num:4;
+unsigned int     reserved_1:12;
+unsigned int     enter_num:4;
+}SB2_RNG_LOCK_CTRL;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     out_ready:1;
+}SB2_RNG_RETURN3;
+
+typedef struct
+{
+unsigned int     valid_bit_num:32;
+}SB2_RNG_RETURN4;
+
+typedef struct
+{
+unsigned int     drop_num:32;
+}SB2_RNG_RETURN5;
+
+typedef struct
+{
+unsigned int     random_out:32;
+}SB2_RNG_RESULTR;
+
+typedef struct
+{
+unsigned int     lfsr_poly_lsb:32;
+}SB2_RNG_LFSR_POLY_LSB;
+
+typedef struct
+{
+unsigned int     lfsr_poly_msb:32;
+}SB2_RNG_LFSR_POLY_MSB;
+
+typedef struct
+{
+unsigned int     dummy_msb:16;
+unsigned int     dummy_lsb:16;
+}SB2_RNG_DUMMY;
+
+typedef struct
+{
+unsigned int     reserved_0:31;
+unsigned int     gating_en:1;
+}SB2_RNG_POWER;
+
+#endif
+
+#define SB2_HD_SEM                                                                   0x9801A000
+#define SB2_HD_SEM_reg_addr                                                          "0xD801A000"
+#define SB2_HD_SEM_reg                                                               0xD801A000
+#define set_SB2_HD_SEM_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_reg)=data)
+#define get_SB2_HD_SEM_reg   (*((volatile unsigned int*) SB2_HD_SEM_reg))
+#define SB2_HD_SEM_inst_adr                                                          "0x0000"
+#define SB2_HD_SEM_inst                                                              0x0000
+#define SB2_HD_SEM_Semaphore_shift                                                   (0)
+#define SB2_HD_SEM_Semaphore_mask                                                    (0x00000001)
+#define SB2_HD_SEM_Semaphore(data)                                                   (0x00000001&((data)<<0))
+#define SB2_HD_SEM_Semaphore_src(data)                                               ((0x00000001&(data))>>0)
+#define SB2_HD_SEM_get_Semaphore(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SB2_INV_INTEN                                                                0x9801A004
+#define SB2_INV_INTEN_reg_addr                                                       "0xD801A004"
+#define SB2_INV_INTEN_reg                                                            0xD801A004
+#define set_SB2_INV_INTEN_reg(data)   (*((volatile unsigned int*) SB2_INV_INTEN_reg)=data)
+#define get_SB2_INV_INTEN_reg   (*((volatile unsigned int*) SB2_INV_INTEN_reg))
+#define SB2_INV_INTEN_inst_adr                                                       "0x0001"
+#define SB2_INV_INTEN_inst                                                           0x0001
+#define SB2_INV_INTEN_swcivairq_en_shift                                             (6)
+#define SB2_INV_INTEN_swcivairq_en_mask                                              (0x00000040)
+#define SB2_INV_INTEN_swcivairq_en(data)                                             (0x00000040&((data)<<6))
+#define SB2_INV_INTEN_swcivairq_en_src(data)                                         ((0x00000040&(data))>>6)
+#define SB2_INV_INTEN_get_swcivairq_en(data)                                         ((0x00000040&(data))>>6)
+#define SB2_INV_INTEN_To_en1_shift                                                   (5)
+#define SB2_INV_INTEN_To_en1_mask                                                    (0x00000020)
+#define SB2_INV_INTEN_To_en1(data)                                                   (0x00000020&((data)<<5))
+#define SB2_INV_INTEN_To_en1_src(data)                                               ((0x00000020&(data))>>5)
+#define SB2_INV_INTEN_get_To_en1(data)                                               ((0x00000020&(data))>>5)
+#define SB2_INV_INTEN_To_en_shift                                                    (4)
+#define SB2_INV_INTEN_To_en_mask                                                     (0x00000010)
+#define SB2_INV_INTEN_To_en(data)                                                    (0x00000010&((data)<<4))
+#define SB2_INV_INTEN_To_en_src(data)                                                ((0x00000010&(data))>>4)
+#define SB2_INV_INTEN_get_To_en(data)                                                ((0x00000010&(data))>>4)
+#define SB2_INV_INTEN_acivairq_en_shift                                              (3)
+#define SB2_INV_INTEN_acivairq_en_mask                                               (0x00000008)
+#define SB2_INV_INTEN_acivairq_en(data)                                              (0x00000008&((data)<<3))
+#define SB2_INV_INTEN_acivairq_en_src(data)                                          ((0x00000008&(data))>>3)
+#define SB2_INV_INTEN_get_acivairq_en(data)                                          ((0x00000008&(data))>>3)
+#define SB2_INV_INTEN_scivairq_en_shift                                              (1)
+#define SB2_INV_INTEN_scivairq_en_mask                                               (0x00000002)
+#define SB2_INV_INTEN_scivairq_en(data)                                              (0x00000002&((data)<<1))
+#define SB2_INV_INTEN_scivairq_en_src(data)                                          ((0x00000002&(data))>>1)
+#define SB2_INV_INTEN_get_scivairq_en(data)                                          ((0x00000002&(data))>>1)
+#define SB2_INV_INTEN_write_data_shift                                               (0)
+#define SB2_INV_INTEN_write_data_mask                                                (0x00000001)
+#define SB2_INV_INTEN_write_data(data)                                               (0x00000001&((data)<<0))
+#define SB2_INV_INTEN_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define SB2_INV_INTEN_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SB2_INV_INTSTAT                                                              0x9801A008
+#define SB2_INV_INTSTAT_reg_addr                                                     "0xD801A008"
+#define SB2_INV_INTSTAT_reg                                                          0xD801A008
+#define set_SB2_INV_INTSTAT_reg(data)   (*((volatile unsigned int*) SB2_INV_INTSTAT_reg)=data)
+#define get_SB2_INV_INTSTAT_reg   (*((volatile unsigned int*) SB2_INV_INTSTAT_reg))
+#define SB2_INV_INTSTAT_inst_adr                                                     "0x0002"
+#define SB2_INV_INTSTAT_inst                                                         0x0002
+#define SB2_INV_INTSTAT_swciva_int_shift                                             (4)
+#define SB2_INV_INTSTAT_swciva_int_mask                                              (0x00000010)
+#define SB2_INV_INTSTAT_swciva_int(data)                                             (0x00000010&((data)<<4))
+#define SB2_INV_INTSTAT_swciva_int_src(data)                                         ((0x00000010&(data))>>4)
+#define SB2_INV_INTSTAT_get_swciva_int(data)                                         ((0x00000010&(data))>>4)
+#define SB2_INV_INTSTAT_Aciva_int_shift                                              (3)
+#define SB2_INV_INTSTAT_Aciva_int_mask                                               (0x00000008)
+#define SB2_INV_INTSTAT_Aciva_int(data)                                              (0x00000008&((data)<<3))
+#define SB2_INV_INTSTAT_Aciva_int_src(data)                                          ((0x00000008&(data))>>3)
+#define SB2_INV_INTSTAT_get_Aciva_int(data)                                          ((0x00000008&(data))>>3)
+#define SB2_INV_INTSTAT_Sciva_int_shift                                              (1)
+#define SB2_INV_INTSTAT_Sciva_int_mask                                               (0x00000002)
+#define SB2_INV_INTSTAT_Sciva_int(data)                                              (0x00000002&((data)<<1))
+#define SB2_INV_INTSTAT_Sciva_int_src(data)                                          ((0x00000002&(data))>>1)
+#define SB2_INV_INTSTAT_get_Sciva_int(data)                                          ((0x00000002&(data))>>1)
+#define SB2_INV_INTSTAT_write_data_shift                                             (0)
+#define SB2_INV_INTSTAT_write_data_mask                                              (0x00000001)
+#define SB2_INV_INTSTAT_write_data(data)                                             (0x00000001&((data)<<0))
+#define SB2_INV_INTSTAT_write_data_src(data)                                         ((0x00000001&(data))>>0)
+#define SB2_INV_INTSTAT_get_write_data(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SB2_INV_ADDR                                                                 0x9801A00C
+#define SB2_INV_ADDR_reg_addr                                                        "0xD801A00C"
+#define SB2_INV_ADDR_reg                                                             0xD801A00C
+#define set_SB2_INV_ADDR_reg(data)   (*((volatile unsigned int*) SB2_INV_ADDR_reg)=data)
+#define get_SB2_INV_ADDR_reg   (*((volatile unsigned int*) SB2_INV_ADDR_reg))
+#define SB2_INV_ADDR_inst_adr                                                        "0x0003"
+#define SB2_INV_ADDR_inst                                                            0x0003
+#define SB2_INV_ADDR_Inv_adr_shift                                                   (0)
+#define SB2_INV_ADDR_Inv_adr_mask                                                    (0xFFFFFFFF)
+#define SB2_INV_ADDR_Inv_adr(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define SB2_INV_ADDR_Inv_adr_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define SB2_INV_ADDR_get_Inv_adr(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DEBUG_REG                                                                0x9801A010
+#define SB2_DEBUG_REG_reg_addr                                                       "0xD801A010"
+#define SB2_DEBUG_REG_reg                                                            0xD801A010
+#define set_SB2_DEBUG_REG_reg(data)   (*((volatile unsigned int*) SB2_DEBUG_REG_reg)=data)
+#define get_SB2_DEBUG_REG_reg   (*((volatile unsigned int*) SB2_DEBUG_REG_reg))
+#define SB2_DEBUG_REG_inst_adr                                                       "0x0004"
+#define SB2_DEBUG_REG_inst                                                           0x0004
+#define SB2_DEBUG_REG_To_thr1_shift                                                  (3)
+#define SB2_DEBUG_REG_To_thr1_mask                                                   (0x00000078)
+#define SB2_DEBUG_REG_To_thr1(data)                                                  (0x00000078&((data)<<3))
+#define SB2_DEBUG_REG_To_thr1_src(data)                                              ((0x00000078&(data))>>3)
+#define SB2_DEBUG_REG_get_To_thr1(data)                                              ((0x00000078&(data))>>3)
+#define SB2_DEBUG_REG_To_thr_shift                                                   (0)
+#define SB2_DEBUG_REG_To_thr_mask                                                    (0x00000007)
+#define SB2_DEBUG_REG_To_thr(data)                                                   (0x00000007&((data)<<0))
+#define SB2_DEBUG_REG_To_thr_src(data)                                               ((0x00000007&(data))>>0)
+#define SB2_DEBUG_REG_get_To_thr(data)                                               ((0x00000007&(data))>>0)
+
+
+#define SB2_FLASH_CTRL                                                               0x9801A014
+#define SB2_FLASH_CTRL_reg_addr                                                      "0xD801A014"
+#define SB2_FLASH_CTRL_reg                                                           0xD801A014
+#define set_SB2_FLASH_CTRL_reg(data)   (*((volatile unsigned int*) SB2_FLASH_CTRL_reg)=data)
+#define get_SB2_FLASH_CTRL_reg   (*((volatile unsigned int*) SB2_FLASH_CTRL_reg))
+#define SB2_FLASH_CTRL_inst_adr                                                      "0x0005"
+#define SB2_FLASH_CTRL_inst                                                          0x0005
+#define SB2_FLASH_CTRL_Wr_hold_cyc_shift                                             (18)
+#define SB2_FLASH_CTRL_Wr_hold_cyc_mask                                              (0x003C0000)
+#define SB2_FLASH_CTRL_Wr_hold_cyc(data)                                             (0x003C0000&((data)<<18))
+#define SB2_FLASH_CTRL_Wr_hold_cyc_src(data)                                         ((0x003C0000&(data))>>18)
+#define SB2_FLASH_CTRL_get_Wr_hold_cyc(data)                                         ((0x003C0000&(data))>>18)
+#define SB2_FLASH_CTRL_Wwr_cyc_shift                                                 (10)
+#define SB2_FLASH_CTRL_Wwr_cyc_mask                                                  (0x00007C00)
+#define SB2_FLASH_CTRL_Wwr_cyc(data)                                                 (0x00007C00&((data)<<10))
+#define SB2_FLASH_CTRL_Wwr_cyc_src(data)                                             ((0x00007C00&(data))>>10)
+#define SB2_FLASH_CTRL_get_Wwr_cyc(data)                                             ((0x00007C00&(data))>>10)
+#define SB2_FLASH_CTRL_Wr_cyc_shift                                                  (5)
+#define SB2_FLASH_CTRL_Wr_cyc_mask                                                   (0x000003E0)
+#define SB2_FLASH_CTRL_Wr_cyc(data)                                                  (0x000003E0&((data)<<5))
+#define SB2_FLASH_CTRL_Wr_cyc_src(data)                                              ((0x000003E0&(data))>>5)
+#define SB2_FLASH_CTRL_get_Wr_cyc(data)                                              ((0x000003E0&(data))>>5)
+#define SB2_FLASH_CTRL_Rd_cyc_shift                                                  (0)
+#define SB2_FLASH_CTRL_Rd_cyc_mask                                                   (0x0000001F)
+#define SB2_FLASH_CTRL_Rd_cyc(data)                                                  (0x0000001F&((data)<<0))
+#define SB2_FLASH_CTRL_Rd_cyc_src(data)                                              ((0x0000001F&(data))>>0)
+#define SB2_FLASH_CTRL_get_Rd_cyc(data)                                              ((0x0000001F&(data))>>0)
+
+
+#define SB2_WRAPPER_CTRL                                                             0x9801A018
+#define SB2_WRAPPER_CTRL_reg_addr                                                    "0xD801A018"
+#define SB2_WRAPPER_CTRL_reg                                                         0xD801A018
+#define set_SB2_WRAPPER_CTRL_reg(data)   (*((volatile unsigned int*) SB2_WRAPPER_CTRL_reg)=data)
+#define get_SB2_WRAPPER_CTRL_reg   (*((volatile unsigned int*) SB2_WRAPPER_CTRL_reg))
+#define SB2_WRAPPER_CTRL_inst_adr                                                    "0x0006"
+#define SB2_WRAPPER_CTRL_inst                                                        0x0006
+#define SB2_WRAPPER_CTRL_write_en13_shift                                            (14)
+#define SB2_WRAPPER_CTRL_write_en13_mask                                             (0x00004000)
+#define SB2_WRAPPER_CTRL_write_en13(data)                                            (0x00004000&((data)<<14))
+#define SB2_WRAPPER_CTRL_write_en13_src(data)                                        ((0x00004000&(data))>>14)
+#define SB2_WRAPPER_CTRL_get_write_en13(data)                                        ((0x00004000&(data))>>14)
+#define SB2_WRAPPER_CTRL_mult_wr_en_shift                                            (13)
+#define SB2_WRAPPER_CTRL_mult_wr_en_mask                                             (0x00002000)
+#define SB2_WRAPPER_CTRL_mult_wr_en(data)                                            (0x00002000&((data)<<13))
+#define SB2_WRAPPER_CTRL_mult_wr_en_src(data)                                        ((0x00002000&(data))>>13)
+#define SB2_WRAPPER_CTRL_get_mult_wr_en(data)                                        ((0x00002000&(data))>>13)
+#define SB2_WRAPPER_CTRL_write_en11_shift                                            (12)
+#define SB2_WRAPPER_CTRL_write_en11_mask                                             (0x00001000)
+#define SB2_WRAPPER_CTRL_write_en11(data)                                            (0x00001000&((data)<<12))
+#define SB2_WRAPPER_CTRL_write_en11_src(data)                                        ((0x00001000&(data))>>12)
+#define SB2_WRAPPER_CTRL_get_write_en11(data)                                        ((0x00001000&(data))>>12)
+#define SB2_WRAPPER_CTRL_ac_in_order_shift                                           (11)
+#define SB2_WRAPPER_CTRL_ac_in_order_mask                                            (0x00000800)
+#define SB2_WRAPPER_CTRL_ac_in_order(data)                                           (0x00000800&((data)<<11))
+#define SB2_WRAPPER_CTRL_ac_in_order_src(data)                                       ((0x00000800&(data))>>11)
+#define SB2_WRAPPER_CTRL_get_ac_in_order(data)                                       ((0x00000800&(data))>>11)
+#define SB2_WRAPPER_CTRL_write_en9_shift                                             (10)
+#define SB2_WRAPPER_CTRL_write_en9_mask                                              (0x00000400)
+#define SB2_WRAPPER_CTRL_write_en9(data)                                             (0x00000400&((data)<<10))
+#define SB2_WRAPPER_CTRL_write_en9_src(data)                                         ((0x00000400&(data))>>10)
+#define SB2_WRAPPER_CTRL_get_write_en9(data)                                         ((0x00000400&(data))>>10)
+#define SB2_WRAPPER_CTRL_ac_bypass_shift                                             (9)
+#define SB2_WRAPPER_CTRL_ac_bypass_mask                                              (0x00000200)
+#define SB2_WRAPPER_CTRL_ac_bypass(data)                                             (0x00000200&((data)<<9))
+#define SB2_WRAPPER_CTRL_ac_bypass_src(data)                                         ((0x00000200&(data))>>9)
+#define SB2_WRAPPER_CTRL_get_ac_bypass(data)                                         ((0x00000200&(data))>>9)
+#define SB2_WRAPPER_CTRL_write_en7_shift                                             (8)
+#define SB2_WRAPPER_CTRL_write_en7_mask                                              (0x00000100)
+#define SB2_WRAPPER_CTRL_write_en7(data)                                             (0x00000100&((data)<<8))
+#define SB2_WRAPPER_CTRL_write_en7_src(data)                                         ((0x00000100&(data))>>8)
+#define SB2_WRAPPER_CTRL_get_write_en7(data)                                         ((0x00000100&(data))>>8)
+#define SB2_WRAPPER_CTRL_ac_merge_shift                                              (7)
+#define SB2_WRAPPER_CTRL_ac_merge_mask                                               (0x00000080)
+#define SB2_WRAPPER_CTRL_ac_merge(data)                                              (0x00000080&((data)<<7))
+#define SB2_WRAPPER_CTRL_ac_merge_src(data)                                          ((0x00000080&(data))>>7)
+#define SB2_WRAPPER_CTRL_get_ac_merge(data)                                          ((0x00000080&(data))>>7)
+#define SB2_WRAPPER_CTRL_write_en2_shift                                             (3)
+#define SB2_WRAPPER_CTRL_write_en2_mask                                              (0x00000008)
+#define SB2_WRAPPER_CTRL_write_en2(data)                                             (0x00000008&((data)<<3))
+#define SB2_WRAPPER_CTRL_write_en2_src(data)                                         ((0x00000008&(data))>>3)
+#define SB2_WRAPPER_CTRL_get_write_en2(data)                                         ((0x00000008&(data))>>3)
+#define SB2_WRAPPER_CTRL_sc_in_order_shift                                           (2)
+#define SB2_WRAPPER_CTRL_sc_in_order_mask                                            (0x00000004)
+#define SB2_WRAPPER_CTRL_sc_in_order(data)                                           (0x00000004&((data)<<2))
+#define SB2_WRAPPER_CTRL_sc_in_order_src(data)                                       ((0x00000004&(data))>>2)
+#define SB2_WRAPPER_CTRL_get_sc_in_order(data)                                       ((0x00000004&(data))>>2)
+
+
+#define SB2_SCPU_INT_CHECK                                                           0x9801A01C
+#define SB2_SCPU_INT_CHECK_reg_addr                                                  "0xD801A01C"
+#define SB2_SCPU_INT_CHECK_reg                                                       0xD801A01C
+#define set_SB2_SCPU_INT_CHECK_reg(data)   (*((volatile unsigned int*) SB2_SCPU_INT_CHECK_reg)=data)
+#define get_SB2_SCPU_INT_CHECK_reg   (*((volatile unsigned int*) SB2_SCPU_INT_CHECK_reg))
+#define SB2_SCPU_INT_CHECK_inst_adr                                                  "0x0007"
+#define SB2_SCPU_INT_CHECK_inst                                                      0x0007
+#define SB2_SCPU_INT_CHECK_enable_shift                                              (0)
+#define SB2_SCPU_INT_CHECK_enable_mask                                               (0x00000001)
+#define SB2_SCPU_INT_CHECK_enable(data)                                              (0x00000001&((data)<<0))
+#define SB2_SCPU_INT_CHECK_enable_src(data)                                          ((0x00000001&(data))>>0)
+#define SB2_SCPU_INT_CHECK_get_enable(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SB2_SYNC                                                                     0x9801A020
+#define SB2_SYNC_reg_addr                                                            "0xD801A020"
+#define SB2_SYNC_reg                                                                 0xD801A020
+#define set_SB2_SYNC_reg(data)   (*((volatile unsigned int*) SB2_SYNC_reg)=data)
+#define get_SB2_SYNC_reg   (*((volatile unsigned int*) SB2_SYNC_reg))
+#define SB2_SYNC_inst_adr                                                            "0x0008"
+#define SB2_SYNC_inst                                                                0x0008
+#define SB2_SYNC_Sync_shift                                                          (0)
+#define SB2_SYNC_Sync_mask                                                           (0xFFFFFFFF)
+#define SB2_SYNC_Sync(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define SB2_SYNC_Sync_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define SB2_SYNC_get_Sync(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DBG                                                                      0x9801A024
+#define SB2_DBG_reg_addr                                                             "0xD801A024"
+#define SB2_DBG_reg                                                                  0xD801A024
+#define set_SB2_DBG_reg(data)   (*((volatile unsigned int*) SB2_DBG_reg)=data)
+#define get_SB2_DBG_reg   (*((volatile unsigned int*) SB2_DBG_reg))
+#define SB2_DBG_inst_adr                                                             "0x0009"
+#define SB2_DBG_inst                                                                 0x0009
+#define SB2_DBG_Dbg_mode_shift                                                       (0)
+#define SB2_DBG_Dbg_mode_mask                                                        (0x0000001F)
+#define SB2_DBG_Dbg_mode(data)                                                       (0x0000001F&((data)<<0))
+#define SB2_DBG_Dbg_mode_src(data)                                                   ((0x0000001F&(data))>>0)
+#define SB2_DBG_get_Dbg_mode(data)                                                   ((0x0000001F&(data))>>0)
+
+
+#define SB2_SB2_DEBUG                                                                0x9801A028
+#define SB2_SB2_DEBUG_reg_addr                                                       "0xD801A028"
+#define SB2_SB2_DEBUG_reg                                                            0xD801A028
+#define set_SB2_SB2_DEBUG_reg(data)   (*((volatile unsigned int*) SB2_SB2_DEBUG_reg)=data)
+#define get_SB2_SB2_DEBUG_reg   (*((volatile unsigned int*) SB2_SB2_DEBUG_reg))
+#define SB2_SB2_DEBUG_inst_adr                                                       "0x000A"
+#define SB2_SB2_DEBUG_inst                                                           0x000A
+#define SB2_SB2_DEBUG_write_enable3_shift                                            (15)
+#define SB2_SB2_DEBUG_write_enable3_mask                                             (0x00008000)
+#define SB2_SB2_DEBUG_write_enable3(data)                                            (0x00008000&((data)<<15))
+#define SB2_SB2_DEBUG_write_enable3_src(data)                                        ((0x00008000&(data))>>15)
+#define SB2_SB2_DEBUG_get_write_enable3(data)                                        ((0x00008000&(data))>>15)
+#define SB2_SB2_DEBUG_sel1_shift                                                     (9)
+#define SB2_SB2_DEBUG_sel1_mask                                                      (0x00007E00)
+#define SB2_SB2_DEBUG_sel1(data)                                                     (0x00007E00&((data)<<9))
+#define SB2_SB2_DEBUG_sel1_src(data)                                                 ((0x00007E00&(data))>>9)
+#define SB2_SB2_DEBUG_get_sel1(data)                                                 ((0x00007E00&(data))>>9)
+#define SB2_SB2_DEBUG_write_enable2_shift                                            (8)
+#define SB2_SB2_DEBUG_write_enable2_mask                                             (0x00000100)
+#define SB2_SB2_DEBUG_write_enable2(data)                                            (0x00000100&((data)<<8))
+#define SB2_SB2_DEBUG_write_enable2_src(data)                                        ((0x00000100&(data))>>8)
+#define SB2_SB2_DEBUG_get_write_enable2(data)                                        ((0x00000100&(data))>>8)
+#define SB2_SB2_DEBUG_sel0_shift                                                     (2)
+#define SB2_SB2_DEBUG_sel0_mask                                                      (0x000000FC)
+#define SB2_SB2_DEBUG_sel0(data)                                                     (0x000000FC&((data)<<2))
+#define SB2_SB2_DEBUG_sel0_src(data)                                                 ((0x000000FC&(data))>>2)
+#define SB2_SB2_DEBUG_get_sel0(data)                                                 ((0x000000FC&(data))>>2)
+#define SB2_SB2_DEBUG_write_enable1_shift                                            (1)
+#define SB2_SB2_DEBUG_write_enable1_mask                                             (0x00000002)
+#define SB2_SB2_DEBUG_write_enable1(data)                                            (0x00000002&((data)<<1))
+#define SB2_SB2_DEBUG_write_enable1_src(data)                                        ((0x00000002&(data))>>1)
+#define SB2_SB2_DEBUG_get_write_enable1(data)                                        ((0x00000002&(data))>>1)
+#define SB2_SB2_DEBUG_enable_shift                                                   (0)
+#define SB2_SB2_DEBUG_enable_mask                                                    (0x00000001)
+#define SB2_SB2_DEBUG_enable(data)                                                   (0x00000001&((data)<<0))
+#define SB2_SB2_DEBUG_enable_src(data)                                               ((0x00000001&(data))>>0)
+#define SB2_SB2_DEBUG_get_enable(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SB2_RBUS1_TOSTAT                                                             0x9801A02C
+#define SB2_RBUS1_TOSTAT_reg_addr                                                    "0xD801A02C"
+#define SB2_RBUS1_TOSTAT_reg                                                         0xD801A02C
+#define set_SB2_RBUS1_TOSTAT_reg(data)   (*((volatile unsigned int*) SB2_RBUS1_TOSTAT_reg)=data)
+#define get_SB2_RBUS1_TOSTAT_reg   (*((volatile unsigned int*) SB2_RBUS1_TOSTAT_reg))
+#define SB2_RBUS1_TOSTAT_inst_adr                                                    "0x000B"
+#define SB2_RBUS1_TOSTAT_inst                                                        0x000B
+#define SB2_RBUS1_TOSTAT_pcie1_tostat_shift                                          (19)
+#define SB2_RBUS1_TOSTAT_pcie1_tostat_mask                                           (0x00080000)
+#define SB2_RBUS1_TOSTAT_pcie1_tostat(data)                                          (0x00080000&((data)<<19))
+#define SB2_RBUS1_TOSTAT_pcie1_tostat_src(data)                                      ((0x00080000&(data))>>19)
+#define SB2_RBUS1_TOSTAT_get_pcie1_tostat(data)                                      ((0x00080000&(data))>>19)
+#define SB2_RBUS1_TOSTAT_sata_tostat_shift                                           (18)
+#define SB2_RBUS1_TOSTAT_sata_tostat_mask                                            (0x00040000)
+#define SB2_RBUS1_TOSTAT_sata_tostat(data)                                           (0x00040000&((data)<<18))
+#define SB2_RBUS1_TOSTAT_sata_tostat_src(data)                                       ((0x00040000&(data))>>18)
+#define SB2_RBUS1_TOSTAT_get_sata_tostat(data)                                       ((0x00040000&(data))>>18)
+#define SB2_RBUS1_TOSTAT_pcie0_tostat_shift                                          (17)
+#define SB2_RBUS1_TOSTAT_pcie0_tostat_mask                                           (0x00020000)
+#define SB2_RBUS1_TOSTAT_pcie0_tostat(data)                                          (0x00020000&((data)<<17))
+#define SB2_RBUS1_TOSTAT_pcie0_tostat_src(data)                                      ((0x00020000&(data))>>17)
+#define SB2_RBUS1_TOSTAT_get_pcie0_tostat(data)                                      ((0x00020000&(data))>>17)
+#define SB2_RBUS1_TOSTAT_etn_tostat_shift                                            (16)
+#define SB2_RBUS1_TOSTAT_etn_tostat_mask                                             (0x00010000)
+#define SB2_RBUS1_TOSTAT_etn_tostat(data)                                            (0x00010000&((data)<<16))
+#define SB2_RBUS1_TOSTAT_etn_tostat_src(data)                                        ((0x00010000&(data))>>16)
+#define SB2_RBUS1_TOSTAT_get_etn_tostat(data)                                        ((0x00010000&(data))>>16)
+#define SB2_RBUS1_TOSTAT_pcie1_tostat_auto_shift                                     (3)
+#define SB2_RBUS1_TOSTAT_pcie1_tostat_auto_mask                                      (0x00000008)
+#define SB2_RBUS1_TOSTAT_pcie1_tostat_auto(data)                                     (0x00000008&((data)<<3))
+#define SB2_RBUS1_TOSTAT_pcie1_tostat_auto_src(data)                                 ((0x00000008&(data))>>3)
+#define SB2_RBUS1_TOSTAT_get_pcie1_tostat_auto(data)                                 ((0x00000008&(data))>>3)
+#define SB2_RBUS1_TOSTAT_sata_tostat_auto_shift                                      (2)
+#define SB2_RBUS1_TOSTAT_sata_tostat_auto_mask                                       (0x00000004)
+#define SB2_RBUS1_TOSTAT_sata_tostat_auto(data)                                      (0x00000004&((data)<<2))
+#define SB2_RBUS1_TOSTAT_sata_tostat_auto_src(data)                                  ((0x00000004&(data))>>2)
+#define SB2_RBUS1_TOSTAT_get_sata_tostat_auto(data)                                  ((0x00000004&(data))>>2)
+#define SB2_RBUS1_TOSTAT_pcie0_tostat_auto_shift                                     (1)
+#define SB2_RBUS1_TOSTAT_pcie0_tostat_auto_mask                                      (0x00000002)
+#define SB2_RBUS1_TOSTAT_pcie0_tostat_auto(data)                                     (0x00000002&((data)<<1))
+#define SB2_RBUS1_TOSTAT_pcie0_tostat_auto_src(data)                                 ((0x00000002&(data))>>1)
+#define SB2_RBUS1_TOSTAT_get_pcie0_tostat_auto(data)                                 ((0x00000002&(data))>>1)
+#define SB2_RBUS1_TOSTAT_etn_tostat_auto_shift                                       (0)
+#define SB2_RBUS1_TOSTAT_etn_tostat_auto_mask                                        (0x00000001)
+#define SB2_RBUS1_TOSTAT_etn_tostat_auto(data)                                       (0x00000001&((data)<<0))
+#define SB2_RBUS1_TOSTAT_etn_tostat_auto_src(data)                                   ((0x00000001&(data))>>0)
+#define SB2_RBUS1_TOSTAT_get_etn_tostat_auto(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SB2_LEXRA_CTRL                                                               0x9801A070
+#define SB2_LEXRA_CTRL_reg_addr                                                      "0xD801A070"
+#define SB2_LEXRA_CTRL_reg                                                           0xD801A070
+#define set_SB2_LEXRA_CTRL_reg(data)   (*((volatile unsigned int*) SB2_LEXRA_CTRL_reg)=data)
+#define get_SB2_LEXRA_CTRL_reg   (*((volatile unsigned int*) SB2_LEXRA_CTRL_reg))
+#define SB2_LEXRA_CTRL_inst_adr                                                      "0x001C"
+#define SB2_LEXRA_CTRL_inst                                                          0x001C
+#define SB2_LEXRA_CTRL_clk_gate_dis_shift                                            (1)
+#define SB2_LEXRA_CTRL_clk_gate_dis_mask                                             (0x00000002)
+#define SB2_LEXRA_CTRL_clk_gate_dis(data)                                            (0x00000002&((data)<<1))
+#define SB2_LEXRA_CTRL_clk_gate_dis_src(data)                                        ((0x00000002&(data))>>1)
+#define SB2_LEXRA_CTRL_get_clk_gate_dis(data)                                        ((0x00000002&(data))>>1)
+#define SB2_LEXRA_CTRL_speed_up_shift                                                (0)
+#define SB2_LEXRA_CTRL_speed_up_mask                                                 (0x00000001)
+#define SB2_LEXRA_CTRL_speed_up(data)                                                (0x00000001&((data)<<0))
+#define SB2_LEXRA_CTRL_speed_up_src(data)                                            ((0x00000001&(data))>>0)
+#define SB2_LEXRA_CTRL_get_speed_up(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SB2_CPU_INT                                                                  0x9801A104
+#define SB2_CPU_INT_reg_addr                                                         "0xD801A104"
+#define SB2_CPU_INT_reg                                                              0xD801A104
+#define set_SB2_CPU_INT_reg(data)   (*((volatile unsigned int*) SB2_CPU_INT_reg)=data)
+#define get_SB2_CPU_INT_reg   (*((volatile unsigned int*) SB2_CPU_INT_reg))
+#define SB2_CPU_INT_inst_adr                                                         "0x0041"
+#define SB2_CPU_INT_inst                                                             0x0041
+#define SB2_CPU_INT_int_aswc_shift                                                   (11)
+#define SB2_CPU_INT_int_aswc_mask                                                    (0x00000800)
+#define SB2_CPU_INT_int_aswc(data)                                                   (0x00000800&((data)<<11))
+#define SB2_CPU_INT_int_aswc_src(data)                                               ((0x00000800&(data))>>11)
+#define SB2_CPU_INT_get_int_aswc(data)                                               ((0x00000800&(data))>>11)
+#define SB2_CPU_INT_int_swca_shift                                                   (10)
+#define SB2_CPU_INT_int_swca_mask                                                    (0x00000400)
+#define SB2_CPU_INT_int_swca(data)                                                   (0x00000400&((data)<<10))
+#define SB2_CPU_INT_int_swca_src(data)                                               ((0x00000400&(data))>>10)
+#define SB2_CPU_INT_get_int_swca(data)                                               ((0x00000400&(data))>>10)
+#define SB2_CPU_INT_int_as_shift                                                     (3)
+#define SB2_CPU_INT_int_as_mask                                                      (0x00000008)
+#define SB2_CPU_INT_int_as(data)                                                     (0x00000008&((data)<<3))
+#define SB2_CPU_INT_int_as_src(data)                                                 ((0x00000008&(data))>>3)
+#define SB2_CPU_INT_get_int_as(data)                                                 ((0x00000008&(data))>>3)
+#define SB2_CPU_INT_int_sa_shift                                                     (1)
+#define SB2_CPU_INT_int_sa_mask                                                      (0x00000002)
+#define SB2_CPU_INT_int_sa(data)                                                     (0x00000002&((data)<<1))
+#define SB2_CPU_INT_int_sa_src(data)                                                 ((0x00000002&(data))>>1)
+#define SB2_CPU_INT_get_int_sa(data)                                                 ((0x00000002&(data))>>1)
+#define SB2_CPU_INT_write_data_shift                                                 (0)
+#define SB2_CPU_INT_write_data_mask                                                  (0x00000001)
+#define SB2_CPU_INT_write_data(data)                                                 (0x00000001&((data)<<0))
+#define SB2_CPU_INT_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define SB2_CPU_INT_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SB2_CPU_INT_EN                                                               0x9801A108
+#define SB2_CPU_INT_EN_reg_addr                                                      "0xD801A108"
+#define SB2_CPU_INT_EN_reg                                                           0xD801A108
+#define set_SB2_CPU_INT_EN_reg(data)   (*((volatile unsigned int*) SB2_CPU_INT_EN_reg)=data)
+#define get_SB2_CPU_INT_EN_reg   (*((volatile unsigned int*) SB2_CPU_INT_EN_reg))
+#define SB2_CPU_INT_EN_inst_adr                                                      "0x0042"
+#define SB2_CPU_INT_EN_inst                                                          0x0042
+#define SB2_CPU_INT_EN_int_aswc_en_shift                                             (11)
+#define SB2_CPU_INT_EN_int_aswc_en_mask                                              (0x00000800)
+#define SB2_CPU_INT_EN_int_aswc_en(data)                                             (0x00000800&((data)<<11))
+#define SB2_CPU_INT_EN_int_aswc_en_src(data)                                         ((0x00000800&(data))>>11)
+#define SB2_CPU_INT_EN_get_int_aswc_en(data)                                         ((0x00000800&(data))>>11)
+#define SB2_CPU_INT_EN_int_swca_en_shift                                             (10)
+#define SB2_CPU_INT_EN_int_swca_en_mask                                              (0x00000400)
+#define SB2_CPU_INT_EN_int_swca_en(data)                                             (0x00000400&((data)<<10))
+#define SB2_CPU_INT_EN_int_swca_en_src(data)                                         ((0x00000400&(data))>>10)
+#define SB2_CPU_INT_EN_get_int_swca_en(data)                                         ((0x00000400&(data))>>10)
+#define SB2_CPU_INT_EN_int_as_en_shift                                               (3)
+#define SB2_CPU_INT_EN_int_as_en_mask                                                (0x00000008)
+#define SB2_CPU_INT_EN_int_as_en(data)                                               (0x00000008&((data)<<3))
+#define SB2_CPU_INT_EN_int_as_en_src(data)                                           ((0x00000008&(data))>>3)
+#define SB2_CPU_INT_EN_get_int_as_en(data)                                           ((0x00000008&(data))>>3)
+#define SB2_CPU_INT_EN_int_sa_en_shift                                               (1)
+#define SB2_CPU_INT_EN_int_sa_en_mask                                                (0x00000002)
+#define SB2_CPU_INT_EN_int_sa_en(data)                                               (0x00000002&((data)<<1))
+#define SB2_CPU_INT_EN_int_sa_en_src(data)                                           ((0x00000002&(data))>>1)
+#define SB2_CPU_INT_EN_get_int_sa_en(data)                                           ((0x00000002&(data))>>1)
+#define SB2_CPU_INT_EN_write_data_shift                                              (0)
+#define SB2_CPU_INT_EN_write_data_mask                                               (0x00000001)
+#define SB2_CPU_INT_EN_write_data(data)                                              (0x00000001&((data)<<0))
+#define SB2_CPU_INT_EN_write_data_src(data)                                          ((0x00000001&(data))>>0)
+#define SB2_CPU_INT_EN_get_write_data(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SB2_DREQ_MASK                                                                0x9801A138
+#define SB2_DREQ_MASK_reg_addr                                                       "0xD801A138"
+#define SB2_DREQ_MASK_reg                                                            0xD801A138
+#define set_SB2_DREQ_MASK_reg(data)   (*((volatile unsigned int*) SB2_DREQ_MASK_reg)=data)
+#define get_SB2_DREQ_MASK_reg   (*((volatile unsigned int*) SB2_DREQ_MASK_reg))
+#define SB2_DREQ_MASK_inst_adr                                                       "0x004E"
+#define SB2_DREQ_MASK_inst                                                           0x004E
+#define SB2_DREQ_MASK_pending_shift                                                  (5)
+#define SB2_DREQ_MASK_pending_mask                                                   (0x00000020)
+#define SB2_DREQ_MASK_pending(data)                                                  (0x00000020&((data)<<5))
+#define SB2_DREQ_MASK_pending_src(data)                                              ((0x00000020&(data))>>5)
+#define SB2_DREQ_MASK_get_pending(data)                                              ((0x00000020&(data))>>5)
+#define SB2_DREQ_MASK_mask_id_shift                                                  (0)
+#define SB2_DREQ_MASK_mask_id_mask                                                   (0x00000007)
+#define SB2_DREQ_MASK_mask_id(data)                                                  (0x00000007&((data)<<0))
+#define SB2_DREQ_MASK_mask_id_src(data)                                              ((0x00000007&(data))>>0)
+#define SB2_DREQ_MASK_get_mask_id(data)                                              ((0x00000007&(data))>>0)
+
+
+#define SB2_CHIP_ID                                                                  0x9801A200
+#define SB2_CHIP_ID_reg_addr                                                         "0xD801A200"
+#define SB2_CHIP_ID_reg                                                              0xD801A200
+#define set_SB2_CHIP_ID_reg(data)   (*((volatile unsigned int*) SB2_CHIP_ID_reg)=data)
+#define get_SB2_CHIP_ID_reg   (*((volatile unsigned int*) SB2_CHIP_ID_reg))
+#define SB2_CHIP_ID_inst_adr                                                         "0x0080"
+#define SB2_CHIP_ID_inst                                                             0x0080
+#define SB2_CHIP_ID_Chip_id_shift                                                    (0)
+#define SB2_CHIP_ID_Chip_id_mask                                                     (0x0000FFFF)
+#define SB2_CHIP_ID_Chip_id(data)                                                    (0x0000FFFF&((data)<<0))
+#define SB2_CHIP_ID_Chip_id_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define SB2_CHIP_ID_get_Chip_id(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define SB2_CHIP_INFO                                                                0x9801A204
+#define SB2_CHIP_INFO_reg_addr                                                       "0xD801A204"
+#define SB2_CHIP_INFO_reg                                                            0xD801A204
+#define set_SB2_CHIP_INFO_reg(data)   (*((volatile unsigned int*) SB2_CHIP_INFO_reg)=data)
+#define get_SB2_CHIP_INFO_reg   (*((volatile unsigned int*) SB2_CHIP_INFO_reg))
+#define SB2_CHIP_INFO_inst_adr                                                       "0x0081"
+#define SB2_CHIP_INFO_inst                                                           0x0081
+#define SB2_CHIP_INFO_Revise_id_shift                                                (16)
+#define SB2_CHIP_INFO_Revise_id_mask                                                 (0xFFFF0000)
+#define SB2_CHIP_INFO_Revise_id(data)                                                (0xFFFF0000&((data)<<16))
+#define SB2_CHIP_INFO_Revise_id_src(data)                                            ((0xFFFF0000&(data))>>16)
+#define SB2_CHIP_INFO_get_Revise_id(data)                                            ((0xFFFF0000&(data))>>16)
+
+
+#define SB2_ACPU_ROM_REMAP                                                           0x9801A300
+#define SB2_ACPU_ROM_REMAP_reg_addr                                                  "0xD801A300"
+#define SB2_ACPU_ROM_REMAP_reg                                                       0xD801A300
+#define set_SB2_ACPU_ROM_REMAP_reg(data)   (*((volatile unsigned int*) SB2_ACPU_ROM_REMAP_reg)=data)
+#define get_SB2_ACPU_ROM_REMAP_reg   (*((volatile unsigned int*) SB2_ACPU_ROM_REMAP_reg))
+#define SB2_ACPU_ROM_REMAP_inst_adr                                                  "0x00C0"
+#define SB2_ACPU_ROM_REMAP_inst                                                      0x00C0
+#define SB2_ACPU_ROM_REMAP_rom_remap_shift                                           (12)
+#define SB2_ACPU_ROM_REMAP_rom_remap_mask                                            (0xFFFFF000)
+#define SB2_ACPU_ROM_REMAP_rom_remap(data)                                           (0xFFFFF000&((data)<<12))
+#define SB2_ACPU_ROM_REMAP_rom_remap_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define SB2_ACPU_ROM_REMAP_get_rom_remap(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define SB2_ACPU_DELAY                                                               0x9801A304
+#define SB2_ACPU_DELAY_reg_addr                                                      "0xD801A304"
+#define SB2_ACPU_DELAY_reg                                                           0xD801A304
+#define set_SB2_ACPU_DELAY_reg(data)   (*((volatile unsigned int*) SB2_ACPU_DELAY_reg)=data)
+#define get_SB2_ACPU_DELAY_reg   (*((volatile unsigned int*) SB2_ACPU_DELAY_reg))
+#define SB2_ACPU_DELAY_inst_adr                                                      "0x00C1"
+#define SB2_ACPU_DELAY_inst                                                          0x00C1
+#define SB2_ACPU_DELAY_gnt_wr_delay_shift                                            (28)
+#define SB2_ACPU_DELAY_gnt_wr_delay_mask                                             (0xF0000000)
+#define SB2_ACPU_DELAY_gnt_wr_delay(data)                                            (0xF0000000&((data)<<28))
+#define SB2_ACPU_DELAY_gnt_wr_delay_src(data)                                        ((0xF0000000&(data))>>28)
+#define SB2_ACPU_DELAY_get_gnt_wr_delay(data)                                        ((0xF0000000&(data))>>28)
+#define SB2_ACPU_DELAY_acc_write_delay_shift                                         (24)
+#define SB2_ACPU_DELAY_acc_write_delay_mask                                          (0x0F000000)
+#define SB2_ACPU_DELAY_acc_write_delay(data)                                         (0x0F000000&((data)<<24))
+#define SB2_ACPU_DELAY_acc_write_delay_src(data)                                     ((0x0F000000&(data))>>24)
+#define SB2_ACPU_DELAY_get_acc_write_delay(data)                                     ((0x0F000000&(data))>>24)
+#define SB2_ACPU_DELAY_did_com_shift                                                 (16)
+#define SB2_ACPU_DELAY_did_com_mask                                                  (0x000F0000)
+#define SB2_ACPU_DELAY_did_com(data)                                                 (0x000F0000&((data)<<16))
+#define SB2_ACPU_DELAY_did_com_src(data)                                             ((0x000F0000&(data))>>16)
+#define SB2_ACPU_DELAY_get_did_com(data)                                             ((0x000F0000&(data))>>16)
+#define SB2_ACPU_DELAY_read_comm_shift                                               (8)
+#define SB2_ACPU_DELAY_read_comm_mask                                                (0x00000F00)
+#define SB2_ACPU_DELAY_read_comm(data)                                               (0x00000F00&((data)<<8))
+#define SB2_ACPU_DELAY_read_comm_src(data)                                           ((0x00000F00&(data))>>8)
+#define SB2_ACPU_DELAY_get_read_comm(data)                                           ((0x00000F00&(data))>>8)
+#define SB2_ACPU_DELAY_addcmd_shift                                                  (0)
+#define SB2_ACPU_DELAY_addcmd_mask                                                   (0x0000000F)
+#define SB2_ACPU_DELAY_addcmd(data)                                                  (0x0000000F&((data)<<0))
+#define SB2_ACPU_DELAY_addcmd_src(data)                                              ((0x0000000F&(data))>>0)
+#define SB2_ACPU_DELAY_get_addcmd(data)                                              ((0x0000000F&(data))>>0)
+
+
+#define SB2_RBUS_ICG1                                                                0x9801A308
+#define SB2_RBUS_ICG1_reg_addr                                                       "0xD801A308"
+#define SB2_RBUS_ICG1_reg                                                            0xD801A308
+#define set_SB2_RBUS_ICG1_reg(data)   (*((volatile unsigned int*) SB2_RBUS_ICG1_reg)=data)
+#define get_SB2_RBUS_ICG1_reg   (*((volatile unsigned int*) SB2_RBUS_ICG1_reg))
+#define SB2_RBUS_ICG1_inst_adr                                                       "0x00C2"
+#define SB2_RBUS_ICG1_inst                                                           0x00C2
+#define SB2_RBUS_ICG1_cbustx_en_shift                                                (31)
+#define SB2_RBUS_ICG1_cbustx_en_mask                                                 (0x80000000)
+#define SB2_RBUS_ICG1_cbustx_en(data)                                                (0x80000000&((data)<<31))
+#define SB2_RBUS_ICG1_cbustx_en_src(data)                                            ((0x80000000&(data))>>31)
+#define SB2_RBUS_ICG1_get_cbustx_en(data)                                            ((0x80000000&(data))>>31)
+#define SB2_RBUS_ICG1_cbusiso_en_shift                                               (30)
+#define SB2_RBUS_ICG1_cbusiso_en_mask                                                (0x40000000)
+#define SB2_RBUS_ICG1_cbusiso_en(data)                                               (0x40000000&((data)<<30))
+#define SB2_RBUS_ICG1_cbusiso_en_src(data)                                           ((0x40000000&(data))>>30)
+#define SB2_RBUS_ICG1_get_cbusiso_en(data)                                           ((0x40000000&(data))>>30)
+#define SB2_RBUS_ICG1_isomis_en_shift                                                (29)
+#define SB2_RBUS_ICG1_isomis_en_mask                                                 (0x20000000)
+#define SB2_RBUS_ICG1_isomis_en(data)                                                (0x20000000&((data)<<29))
+#define SB2_RBUS_ICG1_isomis_en_src(data)                                            ((0x20000000&(data))>>29)
+#define SB2_RBUS_ICG1_get_isomis_en(data)                                            ((0x20000000&(data))>>29)
+#define SB2_RBUS_ICG1_ae_en_shift                                                    (28)
+#define SB2_RBUS_ICG1_ae_en_mask                                                     (0x10000000)
+#define SB2_RBUS_ICG1_ae_en(data)                                                    (0x10000000&((data)<<28))
+#define SB2_RBUS_ICG1_ae_en_src(data)                                                ((0x10000000&(data))>>28)
+#define SB2_RBUS_ICG1_get_ae_en(data)                                                ((0x10000000&(data))>>28)
+#define SB2_RBUS_ICG1_gpu_en_shift                                                   (27)
+#define SB2_RBUS_ICG1_gpu_en_mask                                                    (0x08000000)
+#define SB2_RBUS_ICG1_gpu_en(data)                                                   (0x08000000&((data)<<27))
+#define SB2_RBUS_ICG1_gpu_en_src(data)                                               ((0x08000000&(data))>>27)
+#define SB2_RBUS_ICG1_get_gpu_en(data)                                               ((0x08000000&(data))>>27)
+#define SB2_RBUS_ICG1_mis_en_shift                                                   (26)
+#define SB2_RBUS_ICG1_mis_en_mask                                                    (0x04000000)
+#define SB2_RBUS_ICG1_mis_en(data)                                                   (0x04000000&((data)<<26))
+#define SB2_RBUS_ICG1_mis_en_src(data)                                               ((0x04000000&(data))>>26)
+#define SB2_RBUS_ICG1_get_mis_en(data)                                               ((0x04000000&(data))>>26)
+#define SB2_RBUS_ICG1_rsa_en_shift                                                   (25)
+#define SB2_RBUS_ICG1_rsa_en_mask                                                    (0x02000000)
+#define SB2_RBUS_ICG1_rsa_en(data)                                                   (0x02000000&((data)<<25))
+#define SB2_RBUS_ICG1_rsa_en_src(data)                                               ((0x02000000&(data))>>25)
+#define SB2_RBUS_ICG1_get_rsa_en(data)                                               ((0x02000000&(data))>>25)
+#define SB2_RBUS_ICG1_dcsb_en_shift                                                  (24)
+#define SB2_RBUS_ICG1_dcsb_en_mask                                                   (0x01000000)
+#define SB2_RBUS_ICG1_dcsb_en(data)                                                  (0x01000000&((data)<<24))
+#define SB2_RBUS_ICG1_dcsb_en_src(data)                                              ((0x01000000&(data))>>24)
+#define SB2_RBUS_ICG1_get_dcsb_en(data)                                              ((0x01000000&(data))>>24)
+#define SB2_RBUS_ICG1_scw_en_shift                                                   (23)
+#define SB2_RBUS_ICG1_scw_en_mask                                                    (0x00800000)
+#define SB2_RBUS_ICG1_scw_en(data)                                                   (0x00800000&((data)<<23))
+#define SB2_RBUS_ICG1_scw_en_src(data)                                               ((0x00800000&(data))>>23)
+#define SB2_RBUS_ICG1_get_scw_en(data)                                               ((0x00800000&(data))>>23)
+#define SB2_RBUS_ICG1_sbx_en_shift                                                   (22)
+#define SB2_RBUS_ICG1_sbx_en_mask                                                    (0x00400000)
+#define SB2_RBUS_ICG1_sbx_en(data)                                                   (0x00400000&((data)<<22))
+#define SB2_RBUS_ICG1_sbx_en_src(data)                                               ((0x00400000&(data))>>22)
+#define SB2_RBUS_ICG1_get_sbx_en(data)                                               ((0x00400000&(data))>>22)
+#define SB2_RBUS_ICG1_sb2_en_shift                                                   (21)
+#define SB2_RBUS_ICG1_sb2_en_mask                                                    (0x00200000)
+#define SB2_RBUS_ICG1_sb2_en(data)                                                   (0x00200000&((data)<<21))
+#define SB2_RBUS_ICG1_sb2_en_src(data)                                               ((0x00200000&(data))>>21)
+#define SB2_RBUS_ICG1_get_sb2_en(data)                                               ((0x00200000&(data))>>21)
+#define SB2_RBUS_ICG1_md_en_shift                                                    (20)
+#define SB2_RBUS_ICG1_md_en_mask                                                     (0x00100000)
+#define SB2_RBUS_ICG1_md_en(data)                                                    (0x00100000&((data)<<20))
+#define SB2_RBUS_ICG1_md_en_src(data)                                                ((0x00100000&(data))>>20)
+#define SB2_RBUS_ICG1_get_md_en(data)                                                ((0x00100000&(data))>>20)
+#define SB2_RBUS_ICG1_jpeg_en_shift                                                  (19)
+#define SB2_RBUS_ICG1_jpeg_en_mask                                                   (0x00080000)
+#define SB2_RBUS_ICG1_jpeg_en(data)                                                  (0x00080000&((data)<<19))
+#define SB2_RBUS_ICG1_jpeg_en_src(data)                                              ((0x00080000&(data))>>19)
+#define SB2_RBUS_ICG1_get_jpeg_en(data)                                              ((0x00080000&(data))>>19)
+#define SB2_RBUS_ICG1_nat_en_shift                                                   (18)
+#define SB2_RBUS_ICG1_nat_en_mask                                                    (0x00040000)
+#define SB2_RBUS_ICG1_nat_en(data)                                                   (0x00040000&((data)<<18))
+#define SB2_RBUS_ICG1_nat_en_src(data)                                               ((0x00040000&(data))>>18)
+#define SB2_RBUS_ICG1_get_nat_en(data)                                               ((0x00040000&(data))>>18)
+#define SB2_RBUS_ICG1_usb3host_2_en_shift                                            (17)
+#define SB2_RBUS_ICG1_usb3host_2_en_mask                                             (0x00020000)
+#define SB2_RBUS_ICG1_usb3host_2_en(data)                                            (0x00020000&((data)<<17))
+#define SB2_RBUS_ICG1_usb3host_2_en_src(data)                                        ((0x00020000&(data))>>17)
+#define SB2_RBUS_ICG1_get_usb3host_2_en(data)                                        ((0x00020000&(data))>>17)
+#define SB2_RBUS_ICG1_usb3drd_en_shift                                               (16)
+#define SB2_RBUS_ICG1_usb3drd_en_mask                                                (0x00010000)
+#define SB2_RBUS_ICG1_usb3drd_en(data)                                               (0x00010000&((data)<<16))
+#define SB2_RBUS_ICG1_usb3drd_en_src(data)                                           ((0x00010000&(data))>>16)
+#define SB2_RBUS_ICG1_get_usb3drd_en(data)                                           ((0x00010000&(data))>>16)
+#define SB2_RBUS_ICG1_usb3host_en_shift                                              (15)
+#define SB2_RBUS_ICG1_usb3host_en_mask                                               (0x00008000)
+#define SB2_RBUS_ICG1_usb3host_en(data)                                              (0x00008000&((data)<<15))
+#define SB2_RBUS_ICG1_usb3host_en_src(data)                                          ((0x00008000&(data))>>15)
+#define SB2_RBUS_ICG1_get_usb3host_en(data)                                          ((0x00008000&(data))>>15)
+#define SB2_RBUS_ICG1_usb2_en_shift                                                  (14)
+#define SB2_RBUS_ICG1_usb2_en_mask                                                   (0x00004000)
+#define SB2_RBUS_ICG1_usb2_en(data)                                                  (0x00004000&((data)<<14))
+#define SB2_RBUS_ICG1_usb2_en_src(data)                                              ((0x00004000&(data))>>14)
+#define SB2_RBUS_ICG1_get_usb2_en(data)                                              ((0x00004000&(data))>>14)
+#define SB2_RBUS_ICG1_usb_en_shift                                                   (13)
+#define SB2_RBUS_ICG1_usb_en_mask                                                    (0x00002000)
+#define SB2_RBUS_ICG1_usb_en(data)                                                   (0x00002000&((data)<<13))
+#define SB2_RBUS_ICG1_usb_en_src(data)                                               ((0x00002000&(data))>>13)
+#define SB2_RBUS_ICG1_get_usb_en(data)                                               ((0x00002000&(data))>>13)
+#define SB2_RBUS_ICG1_dbp4_en_shift                                                  (12)
+#define SB2_RBUS_ICG1_dbp4_en_mask                                                   (0x00001000)
+#define SB2_RBUS_ICG1_dbp4_en(data)                                                  (0x00001000&((data)<<12))
+#define SB2_RBUS_ICG1_dbp4_en_src(data)                                              ((0x00001000&(data))>>12)
+#define SB2_RBUS_ICG1_get_dbp4_en(data)                                              ((0x00001000&(data))>>12)
+#define SB2_RBUS_ICG1_dbp_en_shift                                                   (11)
+#define SB2_RBUS_ICG1_dbp_en_mask                                                    (0x00000800)
+#define SB2_RBUS_ICG1_dbp_en(data)                                                   (0x00000800&((data)<<11))
+#define SB2_RBUS_ICG1_dbp_en_src(data)                                               ((0x00000800&(data))>>11)
+#define SB2_RBUS_ICG1_get_dbp_en(data)                                               ((0x00000800&(data))>>11)
+#define SB2_RBUS_ICG1_efs_en_shift                                                   (10)
+#define SB2_RBUS_ICG1_efs_en_mask                                                    (0x00000400)
+#define SB2_RBUS_ICG1_efs_en(data)                                                   (0x00000400&((data)<<10))
+#define SB2_RBUS_ICG1_efs_en_src(data)                                               ((0x00000400&(data))>>10)
+#define SB2_RBUS_ICG1_get_efs_en(data)                                               ((0x00000400&(data))>>10)
+#define SB2_RBUS_ICG1_etn_en_shift                                                   (9)
+#define SB2_RBUS_ICG1_etn_en_mask                                                    (0x00000200)
+#define SB2_RBUS_ICG1_etn_en(data)                                                   (0x00000200&((data)<<9))
+#define SB2_RBUS_ICG1_etn_en_src(data)                                               ((0x00000200&(data))>>9)
+#define SB2_RBUS_ICG1_get_etn_en(data)                                               ((0x00000200&(data))>>9)
+#define SB2_RBUS_ICG1_pcie_en_shift                                                  (8)
+#define SB2_RBUS_ICG1_pcie_en_mask                                                   (0x00000100)
+#define SB2_RBUS_ICG1_pcie_en(data)                                                  (0x00000100&((data)<<8))
+#define SB2_RBUS_ICG1_pcie_en_src(data)                                              ((0x00000100&(data))>>8)
+#define SB2_RBUS_ICG1_get_pcie_en(data)                                              ((0x00000100&(data))>>8)
+#define SB2_RBUS_ICG1_cr_en_shift                                                    (7)
+#define SB2_RBUS_ICG1_cr_en_mask                                                     (0x00000080)
+#define SB2_RBUS_ICG1_cr_en(data)                                                    (0x00000080&((data)<<7))
+#define SB2_RBUS_ICG1_cr_en_src(data)                                                ((0x00000080&(data))>>7)
+#define SB2_RBUS_ICG1_get_cr_en(data)                                                ((0x00000080&(data))>>7)
+#define SB2_RBUS_ICG1_sdio_en_shift                                                  (6)
+#define SB2_RBUS_ICG1_sdio_en_mask                                                   (0x00000040)
+#define SB2_RBUS_ICG1_sdio_en(data)                                                  (0x00000040&((data)<<6))
+#define SB2_RBUS_ICG1_sdio_en_src(data)                                              ((0x00000040&(data))>>6)
+#define SB2_RBUS_ICG1_get_sdio_en(data)                                              ((0x00000040&(data))>>6)
+#define SB2_RBUS_ICG1_emmc_en_shift                                                  (5)
+#define SB2_RBUS_ICG1_emmc_en_mask                                                   (0x00000020)
+#define SB2_RBUS_ICG1_emmc_en(data)                                                  (0x00000020&((data)<<5))
+#define SB2_RBUS_ICG1_emmc_en_src(data)                                              ((0x00000020&(data))>>5)
+#define SB2_RBUS_ICG1_get_emmc_en(data)                                              ((0x00000020&(data))>>5)
+#define SB2_RBUS_ICG1_nfs_en_shift                                                   (4)
+#define SB2_RBUS_ICG1_nfs_en_mask                                                    (0x00000010)
+#define SB2_RBUS_ICG1_nfs_en(data)                                                   (0x00000010&((data)<<4))
+#define SB2_RBUS_ICG1_nfs_en_src(data)                                               ((0x00000010&(data))>>4)
+#define SB2_RBUS_ICG1_get_nfs_en(data)                                               ((0x00000010&(data))>>4)
+#define SB2_RBUS_ICG1_nf_en_shift                                                    (3)
+#define SB2_RBUS_ICG1_nf_en_mask                                                     (0x00000008)
+#define SB2_RBUS_ICG1_nf_en(data)                                                    (0x00000008&((data)<<3))
+#define SB2_RBUS_ICG1_nf_en_src(data)                                                ((0x00000008&(data))>>3)
+#define SB2_RBUS_ICG1_get_nf_en(data)                                                ((0x00000008&(data))>>3)
+#define SB2_RBUS_ICG1_sata_en_shift                                                  (2)
+#define SB2_RBUS_ICG1_sata_en_mask                                                   (0x00000004)
+#define SB2_RBUS_ICG1_sata_en(data)                                                  (0x00000004&((data)<<2))
+#define SB2_RBUS_ICG1_sata_en_src(data)                                              ((0x00000004&(data))>>2)
+#define SB2_RBUS_ICG1_get_sata_en(data)                                              ((0x00000004&(data))>>2)
+#define SB2_RBUS_ICG1_tp_en_shift                                                    (1)
+#define SB2_RBUS_ICG1_tp_en_mask                                                     (0x00000002)
+#define SB2_RBUS_ICG1_tp_en(data)                                                    (0x00000002&((data)<<1))
+#define SB2_RBUS_ICG1_tp_en_src(data)                                                ((0x00000002&(data))>>1)
+#define SB2_RBUS_ICG1_get_tp_en(data)                                                ((0x00000002&(data))>>1)
+#define SB2_RBUS_ICG1_cp_en_shift                                                    (0)
+#define SB2_RBUS_ICG1_cp_en_mask                                                     (0x00000001)
+#define SB2_RBUS_ICG1_cp_en(data)                                                    (0x00000001&((data)<<0))
+#define SB2_RBUS_ICG1_cp_en_src(data)                                                ((0x00000001&(data))>>0)
+#define SB2_RBUS_ICG1_get_cp_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SB2_RBUS_ICG2                                                                0x9801A30C
+#define SB2_RBUS_ICG2_reg_addr                                                       "0xD801A30C"
+#define SB2_RBUS_ICG2_reg                                                            0xD801A30C
+#define set_SB2_RBUS_ICG2_reg(data)   (*((volatile unsigned int*) SB2_RBUS_ICG2_reg)=data)
+#define get_SB2_RBUS_ICG2_reg   (*((volatile unsigned int*) SB2_RBUS_ICG2_reg))
+#define SB2_RBUS_ICG2_inst_adr                                                       "0x00C3"
+#define SB2_RBUS_ICG2_inst                                                           0x00C3
+#define SB2_RBUS_ICG2_ve3_en_shift                                                   (15)
+#define SB2_RBUS_ICG2_ve3_en_mask                                                    (0x00008000)
+#define SB2_RBUS_ICG2_ve3_en(data)                                                   (0x00008000&((data)<<15))
+#define SB2_RBUS_ICG2_ve3_en_src(data)                                               ((0x00008000&(data))>>15)
+#define SB2_RBUS_ICG2_get_ve3_en(data)                                               ((0x00008000&(data))>>15)
+#define SB2_RBUS_ICG2_ve2_en_shift                                                   (14)
+#define SB2_RBUS_ICG2_ve2_en_mask                                                    (0x00004000)
+#define SB2_RBUS_ICG2_ve2_en(data)                                                   (0x00004000&((data)<<14))
+#define SB2_RBUS_ICG2_ve2_en_src(data)                                               ((0x00004000&(data))>>14)
+#define SB2_RBUS_ICG2_get_ve2_en(data)                                               ((0x00004000&(data))>>14)
+#define SB2_RBUS_ICG2_ve1_en_shift                                                   (13)
+#define SB2_RBUS_ICG2_ve1_en_mask                                                    (0x00002000)
+#define SB2_RBUS_ICG2_ve1_en(data)                                                   (0x00002000&((data)<<13))
+#define SB2_RBUS_ICG2_ve1_en_src(data)                                               ((0x00002000&(data))>>13)
+#define SB2_RBUS_ICG2_get_ve1_en(data)                                               ((0x00002000&(data))>>13)
+#define SB2_RBUS_ICG2_lvds_en_shift                                                  (12)
+#define SB2_RBUS_ICG2_lvds_en_mask                                                   (0x00001000)
+#define SB2_RBUS_ICG2_lvds_en(data)                                                  (0x00001000&((data)<<12))
+#define SB2_RBUS_ICG2_lvds_en_src(data)                                              ((0x00001000&(data))>>12)
+#define SB2_RBUS_ICG2_get_lvds_en(data)                                              ((0x00001000&(data))>>12)
+#define SB2_RBUS_ICG2_edp_en_shift                                                   (11)
+#define SB2_RBUS_ICG2_edp_en_mask                                                    (0x00000800)
+#define SB2_RBUS_ICG2_edp_en(data)                                                   (0x00000800&((data)<<11))
+#define SB2_RBUS_ICG2_edp_en_src(data)                                               ((0x00000800&(data))>>11)
+#define SB2_RBUS_ICG2_get_edp_en(data)                                               ((0x00000800&(data))>>11)
+#define SB2_RBUS_ICG2_cbusrx_en_shift                                                (10)
+#define SB2_RBUS_ICG2_cbusrx_en_mask                                                 (0x00000400)
+#define SB2_RBUS_ICG2_cbusrx_en(data)                                                (0x00000400&((data)<<10))
+#define SB2_RBUS_ICG2_cbusrx_en_src(data)                                            ((0x00000400&(data))>>10)
+#define SB2_RBUS_ICG2_get_cbusrx_en(data)                                            ((0x00000400&(data))>>10)
+#define SB2_RBUS_ICG2_hdmir_en_shift                                                 (9)
+#define SB2_RBUS_ICG2_hdmir_en_mask                                                  (0x00000200)
+#define SB2_RBUS_ICG2_hdmir_en(data)                                                 (0x00000200&((data)<<9))
+#define SB2_RBUS_ICG2_hdmir_en_src(data)                                             ((0x00000200&(data))>>9)
+#define SB2_RBUS_ICG2_get_hdmir_en(data)                                             ((0x00000200&(data))>>9)
+#define SB2_RBUS_ICG2_hdmit_en_shift                                                 (8)
+#define SB2_RBUS_ICG2_hdmit_en_mask                                                  (0x00000100)
+#define SB2_RBUS_ICG2_hdmit_en(data)                                                 (0x00000100&((data)<<8))
+#define SB2_RBUS_ICG2_hdmit_en_src(data)                                             ((0x00000100&(data))>>8)
+#define SB2_RBUS_ICG2_get_hdmit_en(data)                                             ((0x00000100&(data))>>8)
+#define SB2_RBUS_ICG2_se_en_shift                                                    (7)
+#define SB2_RBUS_ICG2_se_en_mask                                                     (0x00000080)
+#define SB2_RBUS_ICG2_se_en(data)                                                    (0x00000080&((data)<<7))
+#define SB2_RBUS_ICG2_se_en_src(data)                                                ((0x00000080&(data))>>7)
+#define SB2_RBUS_ICG2_get_se_en(data)                                                ((0x00000080&(data))>>7)
+#define SB2_RBUS_ICG2_mipi_en_shift                                                  (6)
+#define SB2_RBUS_ICG2_mipi_en_mask                                                   (0x00000040)
+#define SB2_RBUS_ICG2_mipi_en(data)                                                  (0x00000040&((data)<<6))
+#define SB2_RBUS_ICG2_mipi_en_src(data)                                              ((0x00000040&(data))>>6)
+#define SB2_RBUS_ICG2_get_mipi_en(data)                                              ((0x00000040&(data))>>6)
+#define SB2_RBUS_ICG2_dptmx_en_shift                                                 (5)
+#define SB2_RBUS_ICG2_dptmx_en_mask                                                  (0x00000020)
+#define SB2_RBUS_ICG2_dptmx_en(data)                                                 (0x00000020&((data)<<5))
+#define SB2_RBUS_ICG2_dptmx_en_src(data)                                             ((0x00000020&(data))>>5)
+#define SB2_RBUS_ICG2_get_dptmx_en(data)                                             ((0x00000020&(data))>>5)
+#define SB2_RBUS_ICG2_tve_en_shift                                                   (4)
+#define SB2_RBUS_ICG2_tve_en_mask                                                    (0x00000010)
+#define SB2_RBUS_ICG2_tve_en(data)                                                   (0x00000010&((data)<<4))
+#define SB2_RBUS_ICG2_tve_en_src(data)                                               ((0x00000010&(data))>>4)
+#define SB2_RBUS_ICG2_get_tve_en(data)                                               ((0x00000010&(data))>>4)
+#define SB2_RBUS_ICG2_voregsram_en_shift                                             (3)
+#define SB2_RBUS_ICG2_voregsram_en_mask                                              (0x00000008)
+#define SB2_RBUS_ICG2_voregsram_en(data)                                             (0x00000008&((data)<<3))
+#define SB2_RBUS_ICG2_voregsram_en_src(data)                                         ((0x00000008&(data))>>3)
+#define SB2_RBUS_ICG2_get_voregsram_en(data)                                         ((0x00000008&(data))>>3)
+#define SB2_RBUS_ICG2_ao_en_shift                                                    (2)
+#define SB2_RBUS_ICG2_ao_en_mask                                                     (0x00000004)
+#define SB2_RBUS_ICG2_ao_en(data)                                                    (0x00000004&((data)<<2))
+#define SB2_RBUS_ICG2_ao_en_src(data)                                                ((0x00000004&(data))>>2)
+#define SB2_RBUS_ICG2_get_ao_en(data)                                                ((0x00000004&(data))>>2)
+#define SB2_RBUS_ICG2_vo_en_shift                                                    (1)
+#define SB2_RBUS_ICG2_vo_en_mask                                                     (0x00000002)
+#define SB2_RBUS_ICG2_vo_en(data)                                                    (0x00000002&((data)<<1))
+#define SB2_RBUS_ICG2_vo_en_src(data)                                                ((0x00000002&(data))>>1)
+#define SB2_RBUS_ICG2_get_vo_en(data)                                                ((0x00000002&(data))>>1)
+#define SB2_RBUS_ICG2_sys_en_shift                                                   (0)
+#define SB2_RBUS_ICG2_sys_en_mask                                                    (0x00000001)
+#define SB2_RBUS_ICG2_sys_en(data)                                                   (0x00000001&((data)<<0))
+#define SB2_RBUS_ICG2_sys_en_src(data)                                               ((0x00000001&(data))>>0)
+#define SB2_RBUS_ICG2_get_sys_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SB2_RBUS_ICG3                                                                0x9801A310
+#define SB2_RBUS_ICG3_reg_addr                                                       "0xD801A310"
+#define SB2_RBUS_ICG3_reg                                                            0xD801A310
+#define set_SB2_RBUS_ICG3_reg(data)   (*((volatile unsigned int*) SB2_RBUS_ICG3_reg)=data)
+#define get_SB2_RBUS_ICG3_reg   (*((volatile unsigned int*) SB2_RBUS_ICG3_reg))
+#define SB2_RBUS_ICG3_inst_adr                                                       "0x00C4"
+#define SB2_RBUS_ICG3_inst                                                           0x00C4
+#define SB2_RBUS_ICG3_tmp11_shift                                                    (15)
+#define SB2_RBUS_ICG3_tmp11_mask                                                     (0x00008000)
+#define SB2_RBUS_ICG3_tmp11(data)                                                    (0x00008000&((data)<<15))
+#define SB2_RBUS_ICG3_tmp11_src(data)                                                ((0x00008000&(data))>>15)
+#define SB2_RBUS_ICG3_get_tmp11(data)                                                ((0x00008000&(data))>>15)
+#define SB2_RBUS_ICG3_tmp10_shift                                                    (14)
+#define SB2_RBUS_ICG3_tmp10_mask                                                     (0x00004000)
+#define SB2_RBUS_ICG3_tmp10(data)                                                    (0x00004000&((data)<<14))
+#define SB2_RBUS_ICG3_tmp10_src(data)                                                ((0x00004000&(data))>>14)
+#define SB2_RBUS_ICG3_get_tmp10(data)                                                ((0x00004000&(data))>>14)
+#define SB2_RBUS_ICG3_tmp9_shift                                                     (13)
+#define SB2_RBUS_ICG3_tmp9_mask                                                      (0x00002000)
+#define SB2_RBUS_ICG3_tmp9(data)                                                     (0x00002000&((data)<<13))
+#define SB2_RBUS_ICG3_tmp9_src(data)                                                 ((0x00002000&(data))>>13)
+#define SB2_RBUS_ICG3_get_tmp9(data)                                                 ((0x00002000&(data))>>13)
+#define SB2_RBUS_ICG3_tmp8_shift                                                     (12)
+#define SB2_RBUS_ICG3_tmp8_mask                                                      (0x00001000)
+#define SB2_RBUS_ICG3_tmp8(data)                                                     (0x00001000&((data)<<12))
+#define SB2_RBUS_ICG3_tmp8_src(data)                                                 ((0x00001000&(data))>>12)
+#define SB2_RBUS_ICG3_get_tmp8(data)                                                 ((0x00001000&(data))>>12)
+#define SB2_RBUS_ICG3_tmp7_shift                                                     (11)
+#define SB2_RBUS_ICG3_tmp7_mask                                                      (0x00000800)
+#define SB2_RBUS_ICG3_tmp7(data)                                                     (0x00000800&((data)<<11))
+#define SB2_RBUS_ICG3_tmp7_src(data)                                                 ((0x00000800&(data))>>11)
+#define SB2_RBUS_ICG3_get_tmp7(data)                                                 ((0x00000800&(data))>>11)
+#define SB2_RBUS_ICG3_tmp6_shift                                                     (10)
+#define SB2_RBUS_ICG3_tmp6_mask                                                      (0x00000400)
+#define SB2_RBUS_ICG3_tmp6(data)                                                     (0x00000400&((data)<<10))
+#define SB2_RBUS_ICG3_tmp6_src(data)                                                 ((0x00000400&(data))>>10)
+#define SB2_RBUS_ICG3_get_tmp6(data)                                                 ((0x00000400&(data))>>10)
+#define SB2_RBUS_ICG3_tmp5_shift                                                     (9)
+#define SB2_RBUS_ICG3_tmp5_mask                                                      (0x00000200)
+#define SB2_RBUS_ICG3_tmp5(data)                                                     (0x00000200&((data)<<9))
+#define SB2_RBUS_ICG3_tmp5_src(data)                                                 ((0x00000200&(data))>>9)
+#define SB2_RBUS_ICG3_get_tmp5(data)                                                 ((0x00000200&(data))>>9)
+#define SB2_RBUS_ICG3_tmp4_shift                                                     (8)
+#define SB2_RBUS_ICG3_tmp4_mask                                                      (0x00000100)
+#define SB2_RBUS_ICG3_tmp4(data)                                                     (0x00000100&((data)<<8))
+#define SB2_RBUS_ICG3_tmp4_src(data)                                                 ((0x00000100&(data))>>8)
+#define SB2_RBUS_ICG3_get_tmp4(data)                                                 ((0x00000100&(data))>>8)
+#define SB2_RBUS_ICG3_tmp3_shift                                                     (7)
+#define SB2_RBUS_ICG3_tmp3_mask                                                      (0x00000080)
+#define SB2_RBUS_ICG3_tmp3(data)                                                     (0x00000080&((data)<<7))
+#define SB2_RBUS_ICG3_tmp3_src(data)                                                 ((0x00000080&(data))>>7)
+#define SB2_RBUS_ICG3_get_tmp3(data)                                                 ((0x00000080&(data))>>7)
+#define SB2_RBUS_ICG3_tmp2_shift                                                     (6)
+#define SB2_RBUS_ICG3_tmp2_mask                                                      (0x00000040)
+#define SB2_RBUS_ICG3_tmp2(data)                                                     (0x00000040&((data)<<6))
+#define SB2_RBUS_ICG3_tmp2_src(data)                                                 ((0x00000040&(data))>>6)
+#define SB2_RBUS_ICG3_get_tmp2(data)                                                 ((0x00000040&(data))>>6)
+#define SB2_RBUS_ICG3_tmp1_shift                                                     (5)
+#define SB2_RBUS_ICG3_tmp1_mask                                                      (0x00000020)
+#define SB2_RBUS_ICG3_tmp1(data)                                                     (0x00000020&((data)<<5))
+#define SB2_RBUS_ICG3_tmp1_src(data)                                                 ((0x00000020&(data))>>5)
+#define SB2_RBUS_ICG3_get_tmp1(data)                                                 ((0x00000020&(data))>>5)
+#define SB2_RBUS_ICG3_tmp0_shift                                                     (4)
+#define SB2_RBUS_ICG3_tmp0_mask                                                      (0x00000010)
+#define SB2_RBUS_ICG3_tmp0(data)                                                     (0x00000010&((data)<<4))
+#define SB2_RBUS_ICG3_tmp0_src(data)                                                 ((0x00000010&(data))>>4)
+#define SB2_RBUS_ICG3_get_tmp0(data)                                                 ((0x00000010&(data))>>4)
+#define SB2_RBUS_ICG3_mon_en_shift                                                   (3)
+#define SB2_RBUS_ICG3_mon_en_mask                                                    (0x00000008)
+#define SB2_RBUS_ICG3_mon_en(data)                                                   (0x00000008&((data)<<3))
+#define SB2_RBUS_ICG3_mon_en_src(data)                                               ((0x00000008&(data))>>3)
+#define SB2_RBUS_ICG3_get_mon_en(data)                                               ((0x00000008&(data))>>3)
+#define SB2_RBUS_ICG3_dbus_en_shift                                                  (2)
+#define SB2_RBUS_ICG3_dbus_en_mask                                                   (0x00000004)
+#define SB2_RBUS_ICG3_dbus_en(data)                                                  (0x00000004&((data)<<2))
+#define SB2_RBUS_ICG3_dbus_en_src(data)                                              ((0x00000004&(data))>>2)
+#define SB2_RBUS_ICG3_get_dbus_en(data)                                              ((0x00000004&(data))>>2)
+#define SB2_RBUS_ICG3_rbus_en_shift                                                  (1)
+#define SB2_RBUS_ICG3_rbus_en_mask                                                   (0x00000002)
+#define SB2_RBUS_ICG3_rbus_en(data)                                                  (0x00000002&((data)<<1))
+#define SB2_RBUS_ICG3_rbus_en_src(data)                                              ((0x00000002&(data))>>1)
+#define SB2_RBUS_ICG3_get_rbus_en(data)                                              ((0x00000002&(data))>>1)
+#define SB2_RBUS_ICG3_spi_en_shift                                                   (0)
+#define SB2_RBUS_ICG3_spi_en_mask                                                    (0x00000001)
+#define SB2_RBUS_ICG3_spi_en(data)                                                   (0x00000001&((data)<<0))
+#define SB2_RBUS_ICG3_spi_en_src(data)                                               ((0x00000001&(data))>>0)
+#define SB2_RBUS_ICG3_get_spi_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SB2_HIF_CTRL1                                                                0x9801A314
+#define SB2_HIF_CTRL1_reg_addr                                                       "0xD801A314"
+#define SB2_HIF_CTRL1_reg                                                            0xD801A314
+#define set_SB2_HIF_CTRL1_reg(data)   (*((volatile unsigned int*) SB2_HIF_CTRL1_reg)=data)
+#define get_SB2_HIF_CTRL1_reg   (*((volatile unsigned int*) SB2_HIF_CTRL1_reg))
+#define SB2_HIF_CTRL1_inst_adr                                                       "0x00C5"
+#define SB2_HIF_CTRL1_inst                                                           0x00C5
+#define SB2_HIF_CTRL1_hif_rdata_swap_shift                                           (1)
+#define SB2_HIF_CTRL1_hif_rdata_swap_mask                                            (0x00000002)
+#define SB2_HIF_CTRL1_hif_rdata_swap(data)                                           (0x00000002&((data)<<1))
+#define SB2_HIF_CTRL1_hif_rdata_swap_src(data)                                       ((0x00000002&(data))>>1)
+#define SB2_HIF_CTRL1_get_hif_rdata_swap(data)                                       ((0x00000002&(data))>>1)
+#define SB2_HIF_CTRL1_hif_wdata_swap_shift                                           (0)
+#define SB2_HIF_CTRL1_hif_wdata_swap_mask                                            (0x00000001)
+#define SB2_HIF_CTRL1_hif_wdata_swap(data)                                           (0x00000001&((data)<<0))
+#define SB2_HIF_CTRL1_hif_wdata_swap_src(data)                                       ((0x00000001&(data))>>0)
+#define SB2_HIF_CTRL1_get_hif_wdata_swap(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SB2_PC_CTRL                                                                  0x9801A400
+#define SB2_PC_CTRL_reg_addr                                                         "0xD801A400"
+#define SB2_PC_CTRL_reg                                                              0xD801A400
+#define set_SB2_PC_CTRL_reg(data)   (*((volatile unsigned int*) SB2_PC_CTRL_reg)=data)
+#define get_SB2_PC_CTRL_reg   (*((volatile unsigned int*) SB2_PC_CTRL_reg))
+#define SB2_PC_CTRL_inst_adr                                                         "0x0000"
+#define SB2_PC_CTRL_inst                                                             0x0000
+#define SB2_PC_CTRL_write_en6_shift                                                  (11)
+#define SB2_PC_CTRL_write_en6_mask                                                   (0x00000800)
+#define SB2_PC_CTRL_write_en6(data)                                                  (0x00000800&((data)<<11))
+#define SB2_PC_CTRL_write_en6_src(data)                                              ((0x00000800&(data))>>11)
+#define SB2_PC_CTRL_get_write_en6(data)                                              ((0x00000800&(data))>>11)
+#define SB2_PC_CTRL_acpu_rbus_go_shift                                               (10)
+#define SB2_PC_CTRL_acpu_rbus_go_mask                                                (0x00000400)
+#define SB2_PC_CTRL_acpu_rbus_go(data)                                               (0x00000400&((data)<<10))
+#define SB2_PC_CTRL_acpu_rbus_go_src(data)                                           ((0x00000400&(data))>>10)
+#define SB2_PC_CTRL_get_acpu_rbus_go(data)                                           ((0x00000400&(data))>>10)
+#define SB2_PC_CTRL_write_en4_shift                                                  (7)
+#define SB2_PC_CTRL_write_en4_mask                                                   (0x00000080)
+#define SB2_PC_CTRL_write_en4(data)                                                  (0x00000080&((data)<<7))
+#define SB2_PC_CTRL_write_en4_src(data)                                              ((0x00000080&(data))>>7)
+#define SB2_PC_CTRL_get_write_en4(data)                                              ((0x00000080&(data))>>7)
+#define SB2_PC_CTRL_scpu_rbus_go_shift                                               (6)
+#define SB2_PC_CTRL_scpu_rbus_go_mask                                                (0x00000040)
+#define SB2_PC_CTRL_scpu_rbus_go(data)                                               (0x00000040&((data)<<6))
+#define SB2_PC_CTRL_scpu_rbus_go_src(data)                                           ((0x00000040&(data))>>6)
+#define SB2_PC_CTRL_get_scpu_rbus_go(data)                                           ((0x00000040&(data))>>6)
+#define SB2_PC_CTRL_write_en3_shift                                                  (5)
+#define SB2_PC_CTRL_write_en3_mask                                                   (0x00000020)
+#define SB2_PC_CTRL_write_en3(data)                                                  (0x00000020&((data)<<5))
+#define SB2_PC_CTRL_write_en3_src(data)                                              ((0x00000020&(data))>>5)
+#define SB2_PC_CTRL_get_write_en3(data)                                              ((0x00000020&(data))>>5)
+#define SB2_PC_CTRL_acpu_dbus_go_shift                                               (4)
+#define SB2_PC_CTRL_acpu_dbus_go_mask                                                (0x00000010)
+#define SB2_PC_CTRL_acpu_dbus_go(data)                                               (0x00000010&((data)<<4))
+#define SB2_PC_CTRL_acpu_dbus_go_src(data)                                           ((0x00000010&(data))>>4)
+#define SB2_PC_CTRL_get_acpu_dbus_go(data)                                           ((0x00000010&(data))>>4)
+
+
+#define SB2_ACPU_DACC                                                                0x9801A42C
+#define SB2_ACPU_DACC_reg_addr                                                       "0xD801A42C"
+#define SB2_ACPU_DACC_reg                                                            0xD801A42C
+#define set_SB2_ACPU_DACC_reg(data)   (*((volatile unsigned int*) SB2_ACPU_DACC_reg)=data)
+#define get_SB2_ACPU_DACC_reg   (*((volatile unsigned int*) SB2_ACPU_DACC_reg))
+#define SB2_ACPU_DACC_inst_adr                                                       "0x000B"
+#define SB2_ACPU_DACC_inst                                                           0x000B
+#define SB2_ACPU_DACC_acpu_dbus_acc_shift                                            (0)
+#define SB2_ACPU_DACC_acpu_dbus_acc_mask                                             (0xFFFFFFFF)
+#define SB2_ACPU_DACC_acpu_dbus_acc(data)                                            (0xFFFFFFFF&((data)<<0))
+#define SB2_ACPU_DACC_acpu_dbus_acc_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define SB2_ACPU_DACC_get_acpu_dbus_acc(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_ACPU_DREQ_NUM                                                            0x9801A430
+#define SB2_ACPU_DREQ_NUM_reg_addr                                                   "0xD801A430"
+#define SB2_ACPU_DREQ_NUM_reg                                                        0xD801A430
+#define set_SB2_ACPU_DREQ_NUM_reg(data)   (*((volatile unsigned int*) SB2_ACPU_DREQ_NUM_reg)=data)
+#define get_SB2_ACPU_DREQ_NUM_reg   (*((volatile unsigned int*) SB2_ACPU_DREQ_NUM_reg))
+#define SB2_ACPU_DREQ_NUM_inst_adr                                                   "0x000C"
+#define SB2_ACPU_DREQ_NUM_inst                                                       0x000C
+#define SB2_ACPU_DREQ_NUM_acpu_dreq_num_shift                                        (0)
+#define SB2_ACPU_DREQ_NUM_acpu_dreq_num_mask                                         (0x00FFFFFF)
+#define SB2_ACPU_DREQ_NUM_acpu_dreq_num(data)                                        (0x00FFFFFF&((data)<<0))
+#define SB2_ACPU_DREQ_NUM_acpu_dreq_num_src(data)                                    ((0x00FFFFFF&(data))>>0)
+#define SB2_ACPU_DREQ_NUM_get_acpu_dreq_num(data)                                    ((0x00FFFFFF&(data))>>0)
+
+
+#define SB2_ACPU_DREQ_MAX                                                            0x9801A434
+#define SB2_ACPU_DREQ_MAX_reg_addr                                                   "0xD801A434"
+#define SB2_ACPU_DREQ_MAX_reg                                                        0xD801A434
+#define set_SB2_ACPU_DREQ_MAX_reg(data)   (*((volatile unsigned int*) SB2_ACPU_DREQ_MAX_reg)=data)
+#define get_SB2_ACPU_DREQ_MAX_reg   (*((volatile unsigned int*) SB2_ACPU_DREQ_MAX_reg))
+#define SB2_ACPU_DREQ_MAX_inst_adr                                                   "0x000D"
+#define SB2_ACPU_DREQ_MAX_inst                                                       0x000D
+#define SB2_ACPU_DREQ_MAX_acpu_dreq_max_shift                                        (0)
+#define SB2_ACPU_DREQ_MAX_acpu_dreq_max_mask                                         (0x0000FFFF)
+#define SB2_ACPU_DREQ_MAX_acpu_dreq_max(data)                                        (0x0000FFFF&((data)<<0))
+#define SB2_ACPU_DREQ_MAX_acpu_dreq_max_src(data)                                    ((0x0000FFFF&(data))>>0)
+#define SB2_ACPU_DREQ_MAX_get_acpu_dreq_max(data)                                    ((0x0000FFFF&(data))>>0)
+
+
+#define SB2_ACPU_DREQ_ACK                                                            0x9801A438
+#define SB2_ACPU_DREQ_ACK_reg_addr                                                   "0xD801A438"
+#define SB2_ACPU_DREQ_ACK_reg                                                        0xD801A438
+#define set_SB2_ACPU_DREQ_ACK_reg(data)   (*((volatile unsigned int*) SB2_ACPU_DREQ_ACK_reg)=data)
+#define get_SB2_ACPU_DREQ_ACK_reg   (*((volatile unsigned int*) SB2_ACPU_DREQ_ACK_reg))
+#define SB2_ACPU_DREQ_ACK_inst_adr                                                   "0x000E"
+#define SB2_ACPU_DREQ_ACK_inst                                                       0x000E
+#define SB2_ACPU_DREQ_ACK_acpu_dreq_ack_shift                                        (0)
+#define SB2_ACPU_DREQ_ACK_acpu_dreq_ack_mask                                         (0x03FFFFFF)
+#define SB2_ACPU_DREQ_ACK_acpu_dreq_ack(data)                                        (0x03FFFFFF&((data)<<0))
+#define SB2_ACPU_DREQ_ACK_acpu_dreq_ack_src(data)                                    ((0x03FFFFFF&(data))>>0)
+#define SB2_ACPU_DREQ_ACK_get_acpu_dreq_ack(data)                                    ((0x03FFFFFF&(data))>>0)
+
+
+#define SB2_SCPU_RACC                                                                0x9801A440
+#define SB2_SCPU_RACC_reg_addr                                                       "0xD801A440"
+#define SB2_SCPU_RACC_reg                                                            0xD801A440
+#define set_SB2_SCPU_RACC_reg(data)   (*((volatile unsigned int*) SB2_SCPU_RACC_reg)=data)
+#define get_SB2_SCPU_RACC_reg   (*((volatile unsigned int*) SB2_SCPU_RACC_reg))
+#define SB2_SCPU_RACC_inst_adr                                                       "0x0010"
+#define SB2_SCPU_RACC_inst                                                           0x0010
+#define SB2_SCPU_RACC_scpu_rbus_acc_shift                                            (0)
+#define SB2_SCPU_RACC_scpu_rbus_acc_mask                                             (0xFFFFFFFF)
+#define SB2_SCPU_RACC_scpu_rbus_acc(data)                                            (0xFFFFFFFF&((data)<<0))
+#define SB2_SCPU_RACC_scpu_rbus_acc_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define SB2_SCPU_RACC_get_scpu_rbus_acc(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_SCPU_RREQ_RLT                                                            0x9801A444
+#define SB2_SCPU_RREQ_RLT_reg_addr                                                   "0xD801A444"
+#define SB2_SCPU_RREQ_RLT_reg                                                        0xD801A444
+#define set_SB2_SCPU_RREQ_RLT_reg(data)   (*((volatile unsigned int*) SB2_SCPU_RREQ_RLT_reg)=data)
+#define get_SB2_SCPU_RREQ_RLT_reg   (*((volatile unsigned int*) SB2_SCPU_RREQ_RLT_reg))
+#define SB2_SCPU_RREQ_RLT_inst_adr                                                   "0x0011"
+#define SB2_SCPU_RREQ_RLT_inst                                                       0x0011
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_max_shift                                        (24)
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_max_mask                                         (0xFF000000)
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_max(data)                                        (0xFF000000&((data)<<24))
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_max_src(data)                                    ((0xFF000000&(data))>>24)
+#define SB2_SCPU_RREQ_RLT_get_scpu_rreq_max(data)                                    ((0xFF000000&(data))>>24)
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_num_shift                                        (0)
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_num_mask                                         (0x00FFFFFF)
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_num(data)                                        (0x00FFFFFF&((data)<<0))
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_num_src(data)                                    ((0x00FFFFFF&(data))>>0)
+#define SB2_SCPU_RREQ_RLT_get_scpu_rreq_num(data)                                    ((0x00FFFFFF&(data))>>0)
+
+
+#define SB2_ACPU_RACC                                                                0x9801A450
+#define SB2_ACPU_RACC_reg_addr                                                       "0xD801A450"
+#define SB2_ACPU_RACC_reg                                                            0xD801A450
+#define set_SB2_ACPU_RACC_reg(data)   (*((volatile unsigned int*) SB2_ACPU_RACC_reg)=data)
+#define get_SB2_ACPU_RACC_reg   (*((volatile unsigned int*) SB2_ACPU_RACC_reg))
+#define SB2_ACPU_RACC_inst_adr                                                       "0x0014"
+#define SB2_ACPU_RACC_inst                                                           0x0014
+#define SB2_ACPU_RACC_acpu_rbus_acc_shift                                            (0)
+#define SB2_ACPU_RACC_acpu_rbus_acc_mask                                             (0xFFFFFFFF)
+#define SB2_ACPU_RACC_acpu_rbus_acc(data)                                            (0xFFFFFFFF&((data)<<0))
+#define SB2_ACPU_RACC_acpu_rbus_acc_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define SB2_ACPU_RACC_get_acpu_rbus_acc(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_ACPU_RREQ_RLT                                                            0x9801A454
+#define SB2_ACPU_RREQ_RLT_reg_addr                                                   "0xD801A454"
+#define SB2_ACPU_RREQ_RLT_reg                                                        0xD801A454
+#define set_SB2_ACPU_RREQ_RLT_reg(data)   (*((volatile unsigned int*) SB2_ACPU_RREQ_RLT_reg)=data)
+#define get_SB2_ACPU_RREQ_RLT_reg   (*((volatile unsigned int*) SB2_ACPU_RREQ_RLT_reg))
+#define SB2_ACPU_RREQ_RLT_inst_adr                                                   "0x0015"
+#define SB2_ACPU_RREQ_RLT_inst                                                       0x0015
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_max_shift                                        (24)
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_max_mask                                         (0xFF000000)
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_max(data)                                        (0xFF000000&((data)<<24))
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_max_src(data)                                    ((0xFF000000&(data))>>24)
+#define SB2_ACPU_RREQ_RLT_get_acpu_rreq_max(data)                                    ((0xFF000000&(data))>>24)
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_num_shift                                        (0)
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_num_mask                                         (0x00FFFFFF)
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_num(data)                                        (0x00FFFFFF&((data)<<0))
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_num_src(data)                                    ((0x00FFFFFF&(data))>>0)
+#define SB2_ACPU_RREQ_RLT_get_acpu_rreq_num(data)                                    ((0x00FFFFFF&(data))>>0)
+
+
+#define SB2_DBG_START_0                                                              0x9801A458
+#define SB2_DBG_START_1                                                              0x9801A45C
+#define SB2_DBG_START_2                                                              0x9801A460
+#define SB2_DBG_START_3                                                              0x9801A464
+#define SB2_DBG_START_4                                                              0x9801A468
+#define SB2_DBG_START_5                                                              0x9801A46C
+#define SB2_DBG_START_6                                                              0x9801A470
+#define SB2_DBG_START_7                                                              0x9801A474
+#define SB2_DBG_START_0_reg_addr                                                     "0xD801A458"
+#define SB2_DBG_START_1_reg_addr                                                     "0xD801A45C"
+#define SB2_DBG_START_2_reg_addr                                                     "0xD801A460"
+#define SB2_DBG_START_3_reg_addr                                                     "0xD801A464"
+#define SB2_DBG_START_4_reg_addr                                                     "0xD801A468"
+#define SB2_DBG_START_5_reg_addr                                                     "0xD801A46C"
+#define SB2_DBG_START_6_reg_addr                                                     "0xD801A470"
+#define SB2_DBG_START_7_reg_addr                                                     "0xD801A474"
+#define SB2_DBG_START_0_reg                                                          0xD801A458
+#define SB2_DBG_START_1_reg                                                          0xD801A45C
+#define SB2_DBG_START_2_reg                                                          0xD801A460
+#define SB2_DBG_START_3_reg                                                          0xD801A464
+#define SB2_DBG_START_4_reg                                                          0xD801A468
+#define SB2_DBG_START_5_reg                                                          0xD801A46C
+#define SB2_DBG_START_6_reg                                                          0xD801A470
+#define SB2_DBG_START_7_reg                                                          0xD801A474
+#define set_SB2_DBG_START_0_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_0_reg)=data)
+#define set_SB2_DBG_START_1_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_1_reg)=data)
+#define set_SB2_DBG_START_2_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_2_reg)=data)
+#define set_SB2_DBG_START_3_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_3_reg)=data)
+#define set_SB2_DBG_START_4_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_4_reg)=data)
+#define set_SB2_DBG_START_5_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_5_reg)=data)
+#define set_SB2_DBG_START_6_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_6_reg)=data)
+#define set_SB2_DBG_START_7_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_7_reg)=data)
+#define get_SB2_DBG_START_0_reg   (*((volatile unsigned int*) SB2_DBG_START_0_reg))
+#define get_SB2_DBG_START_1_reg   (*((volatile unsigned int*) SB2_DBG_START_1_reg))
+#define get_SB2_DBG_START_2_reg   (*((volatile unsigned int*) SB2_DBG_START_2_reg))
+#define get_SB2_DBG_START_3_reg   (*((volatile unsigned int*) SB2_DBG_START_3_reg))
+#define get_SB2_DBG_START_4_reg   (*((volatile unsigned int*) SB2_DBG_START_4_reg))
+#define get_SB2_DBG_START_5_reg   (*((volatile unsigned int*) SB2_DBG_START_5_reg))
+#define get_SB2_DBG_START_6_reg   (*((volatile unsigned int*) SB2_DBG_START_6_reg))
+#define get_SB2_DBG_START_7_reg   (*((volatile unsigned int*) SB2_DBG_START_7_reg))
+#define SB2_DBG_START_0_inst_adr                                                     "0x0016"
+#define SB2_DBG_START_1_inst_adr                                                     "0x0017"
+#define SB2_DBG_START_2_inst_adr                                                     "0x0018"
+#define SB2_DBG_START_3_inst_adr                                                     "0x0019"
+#define SB2_DBG_START_4_inst_adr                                                     "0x001A"
+#define SB2_DBG_START_5_inst_adr                                                     "0x001B"
+#define SB2_DBG_START_6_inst_adr                                                     "0x001C"
+#define SB2_DBG_START_7_inst_adr                                                     "0x001D"
+#define SB2_DBG_START_0_inst                                                         0x0016
+#define SB2_DBG_START_1_inst                                                         0x0017
+#define SB2_DBG_START_2_inst                                                         0x0018
+#define SB2_DBG_START_3_inst                                                         0x0019
+#define SB2_DBG_START_4_inst                                                         0x001A
+#define SB2_DBG_START_5_inst                                                         0x001B
+#define SB2_DBG_START_6_inst                                                         0x001C
+#define SB2_DBG_START_7_inst                                                         0x001D
+#define SB2_DBG_START_Dbg_start_addr_shift                                           (0)
+#define SB2_DBG_START_Dbg_start_addr_mask                                            (0xFFFFFFFF)
+#define SB2_DBG_START_Dbg_start_addr(data)                                           (0xFFFFFFFF&((data)<<0))
+#define SB2_DBG_START_Dbg_start_addr_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define SB2_DBG_START_get_Dbg_start_addr(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DBG_END_0                                                                0x9801A478
+#define SB2_DBG_END_1                                                                0x9801A47C
+#define SB2_DBG_END_2                                                                0x9801A480
+#define SB2_DBG_END_3                                                                0x9801A484
+#define SB2_DBG_END_4                                                                0x9801A488
+#define SB2_DBG_END_5                                                                0x9801A48C
+#define SB2_DBG_END_6                                                                0x9801A490
+#define SB2_DBG_END_7                                                                0x9801A494
+#define SB2_DBG_END_0_reg_addr                                                       "0xD801A478"
+#define SB2_DBG_END_1_reg_addr                                                       "0xD801A47C"
+#define SB2_DBG_END_2_reg_addr                                                       "0xD801A480"
+#define SB2_DBG_END_3_reg_addr                                                       "0xD801A484"
+#define SB2_DBG_END_4_reg_addr                                                       "0xD801A488"
+#define SB2_DBG_END_5_reg_addr                                                       "0xD801A48C"
+#define SB2_DBG_END_6_reg_addr                                                       "0xD801A490"
+#define SB2_DBG_END_7_reg_addr                                                       "0xD801A494"
+#define SB2_DBG_END_0_reg                                                            0xD801A478
+#define SB2_DBG_END_1_reg                                                            0xD801A47C
+#define SB2_DBG_END_2_reg                                                            0xD801A480
+#define SB2_DBG_END_3_reg                                                            0xD801A484
+#define SB2_DBG_END_4_reg                                                            0xD801A488
+#define SB2_DBG_END_5_reg                                                            0xD801A48C
+#define SB2_DBG_END_6_reg                                                            0xD801A490
+#define SB2_DBG_END_7_reg                                                            0xD801A494
+#define set_SB2_DBG_END_0_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_0_reg)=data)
+#define set_SB2_DBG_END_1_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_1_reg)=data)
+#define set_SB2_DBG_END_2_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_2_reg)=data)
+#define set_SB2_DBG_END_3_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_3_reg)=data)
+#define set_SB2_DBG_END_4_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_4_reg)=data)
+#define set_SB2_DBG_END_5_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_5_reg)=data)
+#define set_SB2_DBG_END_6_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_6_reg)=data)
+#define set_SB2_DBG_END_7_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_7_reg)=data)
+#define get_SB2_DBG_END_0_reg   (*((volatile unsigned int*) SB2_DBG_END_0_reg))
+#define get_SB2_DBG_END_1_reg   (*((volatile unsigned int*) SB2_DBG_END_1_reg))
+#define get_SB2_DBG_END_2_reg   (*((volatile unsigned int*) SB2_DBG_END_2_reg))
+#define get_SB2_DBG_END_3_reg   (*((volatile unsigned int*) SB2_DBG_END_3_reg))
+#define get_SB2_DBG_END_4_reg   (*((volatile unsigned int*) SB2_DBG_END_4_reg))
+#define get_SB2_DBG_END_5_reg   (*((volatile unsigned int*) SB2_DBG_END_5_reg))
+#define get_SB2_DBG_END_6_reg   (*((volatile unsigned int*) SB2_DBG_END_6_reg))
+#define get_SB2_DBG_END_7_reg   (*((volatile unsigned int*) SB2_DBG_END_7_reg))
+#define SB2_DBG_END_0_inst_adr                                                       "0x001E"
+#define SB2_DBG_END_1_inst_adr                                                       "0x001F"
+#define SB2_DBG_END_2_inst_adr                                                       "0x0020"
+#define SB2_DBG_END_3_inst_adr                                                       "0x0021"
+#define SB2_DBG_END_4_inst_adr                                                       "0x0022"
+#define SB2_DBG_END_5_inst_adr                                                       "0x0023"
+#define SB2_DBG_END_6_inst_adr                                                       "0x0024"
+#define SB2_DBG_END_7_inst_adr                                                       "0x0025"
+#define SB2_DBG_END_0_inst                                                           0x001E
+#define SB2_DBG_END_1_inst                                                           0x001F
+#define SB2_DBG_END_2_inst                                                           0x0020
+#define SB2_DBG_END_3_inst                                                           0x0021
+#define SB2_DBG_END_4_inst                                                           0x0022
+#define SB2_DBG_END_5_inst                                                           0x0023
+#define SB2_DBG_END_6_inst                                                           0x0024
+#define SB2_DBG_END_7_inst                                                           0x0025
+#define SB2_DBG_END_Dbg_end_addr_shift                                               (0)
+#define SB2_DBG_END_Dbg_end_addr_mask                                                (0xFFFFFFFF)
+#define SB2_DBG_END_Dbg_end_addr(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SB2_DBG_END_Dbg_end_addr_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SB2_DBG_END_get_Dbg_end_addr(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DBG_CTRL_0                                                               0x9801A498
+#define SB2_DBG_CTRL_1                                                               0x9801A49C
+#define SB2_DBG_CTRL_2                                                               0x9801A4A0
+#define SB2_DBG_CTRL_3                                                               0x9801A4A4
+#define SB2_DBG_CTRL_4                                                               0x9801A4A8
+#define SB2_DBG_CTRL_5                                                               0x9801A4AC
+#define SB2_DBG_CTRL_6                                                               0x9801A4B0
+#define SB2_DBG_CTRL_7                                                               0x9801A4B4
+#define SB2_DBG_CTRL_0_reg_addr                                                      "0xD801A498"
+#define SB2_DBG_CTRL_1_reg_addr                                                      "0xD801A49C"
+#define SB2_DBG_CTRL_2_reg_addr                                                      "0xD801A4A0"
+#define SB2_DBG_CTRL_3_reg_addr                                                      "0xD801A4A4"
+#define SB2_DBG_CTRL_4_reg_addr                                                      "0xD801A4A8"
+#define SB2_DBG_CTRL_5_reg_addr                                                      "0xD801A4AC"
+#define SB2_DBG_CTRL_6_reg_addr                                                      "0xD801A4B0"
+#define SB2_DBG_CTRL_7_reg_addr                                                      "0xD801A4B4"
+#define SB2_DBG_CTRL_0_reg                                                           0xD801A498
+#define SB2_DBG_CTRL_1_reg                                                           0xD801A49C
+#define SB2_DBG_CTRL_2_reg                                                           0xD801A4A0
+#define SB2_DBG_CTRL_3_reg                                                           0xD801A4A4
+#define SB2_DBG_CTRL_4_reg                                                           0xD801A4A8
+#define SB2_DBG_CTRL_5_reg                                                           0xD801A4AC
+#define SB2_DBG_CTRL_6_reg                                                           0xD801A4B0
+#define SB2_DBG_CTRL_7_reg                                                           0xD801A4B4
+#define set_SB2_DBG_CTRL_0_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_0_reg)=data)
+#define set_SB2_DBG_CTRL_1_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_1_reg)=data)
+#define set_SB2_DBG_CTRL_2_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_2_reg)=data)
+#define set_SB2_DBG_CTRL_3_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_3_reg)=data)
+#define set_SB2_DBG_CTRL_4_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_4_reg)=data)
+#define set_SB2_DBG_CTRL_5_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_5_reg)=data)
+#define set_SB2_DBG_CTRL_6_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_6_reg)=data)
+#define set_SB2_DBG_CTRL_7_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_7_reg)=data)
+#define get_SB2_DBG_CTRL_0_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_0_reg))
+#define get_SB2_DBG_CTRL_1_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_1_reg))
+#define get_SB2_DBG_CTRL_2_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_2_reg))
+#define get_SB2_DBG_CTRL_3_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_3_reg))
+#define get_SB2_DBG_CTRL_4_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_4_reg))
+#define get_SB2_DBG_CTRL_5_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_5_reg))
+#define get_SB2_DBG_CTRL_6_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_6_reg))
+#define get_SB2_DBG_CTRL_7_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_7_reg))
+#define SB2_DBG_CTRL_0_inst_adr                                                      "0x0026"
+#define SB2_DBG_CTRL_1_inst_adr                                                      "0x0027"
+#define SB2_DBG_CTRL_2_inst_adr                                                      "0x0028"
+#define SB2_DBG_CTRL_3_inst_adr                                                      "0x0029"
+#define SB2_DBG_CTRL_4_inst_adr                                                      "0x002A"
+#define SB2_DBG_CTRL_5_inst_adr                                                      "0x002B"
+#define SB2_DBG_CTRL_6_inst_adr                                                      "0x002C"
+#define SB2_DBG_CTRL_7_inst_adr                                                      "0x002D"
+#define SB2_DBG_CTRL_0_inst                                                          0x0026
+#define SB2_DBG_CTRL_1_inst                                                          0x0027
+#define SB2_DBG_CTRL_2_inst                                                          0x0028
+#define SB2_DBG_CTRL_3_inst                                                          0x0029
+#define SB2_DBG_CTRL_4_inst                                                          0x002A
+#define SB2_DBG_CTRL_5_inst                                                          0x002B
+#define SB2_DBG_CTRL_6_inst                                                          0x002C
+#define SB2_DBG_CTRL_7_inst                                                          0x002D
+#define SB2_DBG_CTRL_write_en6_shift                                                 (13)
+#define SB2_DBG_CTRL_write_en6_mask                                                  (0x00002000)
+#define SB2_DBG_CTRL_write_en6(data)                                                 (0x00002000&((data)<<13))
+#define SB2_DBG_CTRL_write_en6_src(data)                                             ((0x00002000&(data))>>13)
+#define SB2_DBG_CTRL_get_write_en6(data)                                             ((0x00002000&(data))>>13)
+#define SB2_DBG_CTRL_Dbg_acpu_chk_en_shift                                           (12)
+#define SB2_DBG_CTRL_Dbg_acpu_chk_en_mask                                            (0x00001000)
+#define SB2_DBG_CTRL_Dbg_acpu_chk_en(data)                                           (0x00001000&((data)<<12))
+#define SB2_DBG_CTRL_Dbg_acpu_chk_en_src(data)                                       ((0x00001000&(data))>>12)
+#define SB2_DBG_CTRL_get_Dbg_acpu_chk_en(data)                                       ((0x00001000&(data))>>12)
+#define SB2_DBG_CTRL_write_en4_shift                                                 (9)
+#define SB2_DBG_CTRL_write_en4_mask                                                  (0x00000200)
+#define SB2_DBG_CTRL_write_en4(data)                                                 (0x00000200&((data)<<9))
+#define SB2_DBG_CTRL_write_en4_src(data)                                             ((0x00000200&(data))>>9)
+#define SB2_DBG_CTRL_get_write_en4(data)                                             ((0x00000200&(data))>>9)
+#define SB2_DBG_CTRL_Dbg_scpu_chk_en_shift                                           (8)
+#define SB2_DBG_CTRL_Dbg_scpu_chk_en_mask                                            (0x00000100)
+#define SB2_DBG_CTRL_Dbg_scpu_chk_en(data)                                           (0x00000100&((data)<<8))
+#define SB2_DBG_CTRL_Dbg_scpu_chk_en_src(data)                                       ((0x00000100&(data))>>8)
+#define SB2_DBG_CTRL_get_Dbg_scpu_chk_en(data)                                       ((0x00000100&(data))>>8)
+#define SB2_DBG_CTRL_write_en3_shift                                                 (7)
+#define SB2_DBG_CTRL_write_en3_mask                                                  (0x00000080)
+#define SB2_DBG_CTRL_write_en3(data)                                                 (0x00000080&((data)<<7))
+#define SB2_DBG_CTRL_write_en3_src(data)                                             ((0x00000080&(data))>>7)
+#define SB2_DBG_CTRL_get_write_en3(data)                                             ((0x00000080&(data))>>7)
+#define SB2_DBG_CTRL_Dbg_wr_chk_shift                                                (5)
+#define SB2_DBG_CTRL_Dbg_wr_chk_mask                                                 (0x00000060)
+#define SB2_DBG_CTRL_Dbg_wr_chk(data)                                                (0x00000060&((data)<<5))
+#define SB2_DBG_CTRL_Dbg_wr_chk_src(data)                                            ((0x00000060&(data))>>5)
+#define SB2_DBG_CTRL_get_Dbg_wr_chk(data)                                            ((0x00000060&(data))>>5)
+#define SB2_DBG_CTRL_write_en2_shift                                                 (4)
+#define SB2_DBG_CTRL_write_en2_mask                                                  (0x00000010)
+#define SB2_DBG_CTRL_write_en2(data)                                                 (0x00000010&((data)<<4))
+#define SB2_DBG_CTRL_write_en2_src(data)                                             ((0x00000010&(data))>>4)
+#define SB2_DBG_CTRL_get_write_en2(data)                                             ((0x00000010&(data))>>4)
+#define SB2_DBG_CTRL_Dbg_id_chk_shift                                                (2)
+#define SB2_DBG_CTRL_Dbg_id_chk_mask                                                 (0x0000000C)
+#define SB2_DBG_CTRL_Dbg_id_chk(data)                                                (0x0000000C&((data)<<2))
+#define SB2_DBG_CTRL_Dbg_id_chk_src(data)                                            ((0x0000000C&(data))>>2)
+#define SB2_DBG_CTRL_get_Dbg_id_chk(data)                                            ((0x0000000C&(data))>>2)
+#define SB2_DBG_CTRL_write_en1_shift                                                 (1)
+#define SB2_DBG_CTRL_write_en1_mask                                                  (0x00000002)
+#define SB2_DBG_CTRL_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define SB2_DBG_CTRL_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define SB2_DBG_CTRL_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define SB2_DBG_CTRL_Dbg_en_shift                                                    (0)
+#define SB2_DBG_CTRL_Dbg_en_mask                                                     (0x00000001)
+#define SB2_DBG_CTRL_Dbg_en(data)                                                    (0x00000001&((data)<<0))
+#define SB2_DBG_CTRL_Dbg_en_src(data)                                                ((0x00000001&(data))>>0)
+#define SB2_DBG_CTRL_get_Dbg_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SB2_DBG_ADDR_0                                                               0x9801A4B8
+#define SB2_DBG_ADDR_1                                                               0x9801A4BC
+#define SB2_DBG_ADDR_2                                                               0x9801A4C0
+#define SB2_DBG_ADDR_0_reg_addr                                                      "0xD801A4B8"
+#define SB2_DBG_ADDR_1_reg_addr                                                      "0xD801A4BC"
+#define SB2_DBG_ADDR_2_reg_addr                                                      "0xD801A4C0"
+#define SB2_DBG_ADDR_0_reg                                                           0xD801A4B8
+#define SB2_DBG_ADDR_1_reg                                                           0xD801A4BC
+#define SB2_DBG_ADDR_2_reg                                                           0xD801A4C0
+#define set_SB2_DBG_ADDR_0_reg(data)   (*((volatile unsigned int*) SB2_DBG_ADDR_0_reg)=data)
+#define set_SB2_DBG_ADDR_1_reg(data)   (*((volatile unsigned int*) SB2_DBG_ADDR_1_reg)=data)
+#define set_SB2_DBG_ADDR_2_reg(data)   (*((volatile unsigned int*) SB2_DBG_ADDR_2_reg)=data)
+#define get_SB2_DBG_ADDR_0_reg   (*((volatile unsigned int*) SB2_DBG_ADDR_0_reg))
+#define get_SB2_DBG_ADDR_1_reg   (*((volatile unsigned int*) SB2_DBG_ADDR_1_reg))
+#define get_SB2_DBG_ADDR_2_reg   (*((volatile unsigned int*) SB2_DBG_ADDR_2_reg))
+#define SB2_DBG_ADDR_0_inst_adr                                                      "0x002E"
+#define SB2_DBG_ADDR_1_inst_adr                                                      "0x002F"
+#define SB2_DBG_ADDR_2_inst_adr                                                      "0x0030"
+#define SB2_DBG_ADDR_0_inst                                                          0x002E
+#define SB2_DBG_ADDR_1_inst                                                          0x002F
+#define SB2_DBG_ADDR_2_inst                                                          0x0030
+#define SB2_DBG_ADDR_dbg_addr_shift                                                  (0)
+#define SB2_DBG_ADDR_dbg_addr_mask                                                   (0xFFFFFFFF)
+#define SB2_DBG_ADDR_dbg_addr(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define SB2_DBG_ADDR_dbg_addr_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define SB2_DBG_ADDR_get_dbg_addr(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DBG_ADDR1                                                                0x9801A4C8
+#define SB2_DBG_ADDR1_reg_addr                                                       "0xD801A4C8"
+#define SB2_DBG_ADDR1_reg                                                            0xD801A4C8
+#define set_SB2_DBG_ADDR1_reg(data)   (*((volatile unsigned int*) SB2_DBG_ADDR1_reg)=data)
+#define get_SB2_DBG_ADDR1_reg   (*((volatile unsigned int*) SB2_DBG_ADDR1_reg))
+#define SB2_DBG_ADDR1_inst_adr                                                       "0x0032"
+#define SB2_DBG_ADDR1_inst                                                           0x0032
+#define SB2_DBG_ADDR1_acpu_dbg_write_shift                                           (5)
+#define SB2_DBG_ADDR1_acpu_dbg_write_mask                                            (0x00000020)
+#define SB2_DBG_ADDR1_acpu_dbg_write(data)                                           (0x00000020&((data)<<5))
+#define SB2_DBG_ADDR1_acpu_dbg_write_src(data)                                       ((0x00000020&(data))>>5)
+#define SB2_DBG_ADDR1_get_acpu_dbg_write(data)                                       ((0x00000020&(data))>>5)
+#define SB2_DBG_ADDR1_acpu_dbg_dacc_shift                                            (4)
+#define SB2_DBG_ADDR1_acpu_dbg_dacc_mask                                             (0x00000010)
+#define SB2_DBG_ADDR1_acpu_dbg_dacc(data)                                            (0x00000010&((data)<<4))
+#define SB2_DBG_ADDR1_acpu_dbg_dacc_src(data)                                        ((0x00000010&(data))>>4)
+#define SB2_DBG_ADDR1_get_acpu_dbg_dacc(data)                                        ((0x00000010&(data))>>4)
+#define SB2_DBG_ADDR1_scpu_dbg_write_shift                                           (3)
+#define SB2_DBG_ADDR1_scpu_dbg_write_mask                                            (0x00000008)
+#define SB2_DBG_ADDR1_scpu_dbg_write(data)                                           (0x00000008&((data)<<3))
+#define SB2_DBG_ADDR1_scpu_dbg_write_src(data)                                       ((0x00000008&(data))>>3)
+#define SB2_DBG_ADDR1_get_scpu_dbg_write(data)                                       ((0x00000008&(data))>>3)
+#define SB2_DBG_ADDR1_scpu_dbg_dacc_shift                                            (2)
+#define SB2_DBG_ADDR1_scpu_dbg_dacc_mask                                             (0x00000004)
+#define SB2_DBG_ADDR1_scpu_dbg_dacc(data)                                            (0x00000004&((data)<<2))
+#define SB2_DBG_ADDR1_scpu_dbg_dacc_src(data)                                        ((0x00000004&(data))>>2)
+#define SB2_DBG_ADDR1_get_scpu_dbg_dacc(data)                                        ((0x00000004&(data))>>2)
+
+
+#define SB2_DBG_INT                                                                  0x9801A4E0
+#define SB2_DBG_INT_reg_addr                                                         "0xD801A4E0"
+#define SB2_DBG_INT_reg                                                              0xD801A4E0
+#define set_SB2_DBG_INT_reg(data)   (*((volatile unsigned int*) SB2_DBG_INT_reg)=data)
+#define get_SB2_DBG_INT_reg   (*((volatile unsigned int*) SB2_DBG_INT_reg))
+#define SB2_DBG_INT_inst_adr                                                         "0x0038"
+#define SB2_DBG_INT_inst                                                             0x0038
+#define SB2_DBG_INT_acpu_int_shift                                                   (12)
+#define SB2_DBG_INT_acpu_int_mask                                                    (0x00001000)
+#define SB2_DBG_INT_acpu_int(data)                                                   (0x00001000&((data)<<12))
+#define SB2_DBG_INT_acpu_int_src(data)                                               ((0x00001000&(data))>>12)
+#define SB2_DBG_INT_get_acpu_int(data)                                               ((0x00001000&(data))>>12)
+#define SB2_DBG_INT_scpu_int_shift                                                   (10)
+#define SB2_DBG_INT_scpu_int_mask                                                    (0x00000400)
+#define SB2_DBG_INT_scpu_int(data)                                                   (0x00000400&((data)<<10))
+#define SB2_DBG_INT_scpu_int_src(data)                                               ((0x00000400&(data))>>10)
+#define SB2_DBG_INT_get_scpu_int(data)                                               ((0x00000400&(data))>>10)
+#define SB2_DBG_INT_acpu_int_en_shift                                                (9)
+#define SB2_DBG_INT_acpu_int_en_mask                                                 (0x00000200)
+#define SB2_DBG_INT_acpu_int_en(data)                                                (0x00000200&((data)<<9))
+#define SB2_DBG_INT_acpu_int_en_src(data)                                            ((0x00000200&(data))>>9)
+#define SB2_DBG_INT_get_acpu_int_en(data)                                            ((0x00000200&(data))>>9)
+#define SB2_DBG_INT_scpu_int_en_shift                                                (7)
+#define SB2_DBG_INT_scpu_int_en_mask                                                 (0x00000080)
+#define SB2_DBG_INT_scpu_int_en(data)                                                (0x00000080&((data)<<7))
+#define SB2_DBG_INT_scpu_int_en_src(data)                                            ((0x00000080&(data))>>7)
+#define SB2_DBG_INT_get_scpu_int_en(data)                                            ((0x00000080&(data))>>7)
+#define SB2_DBG_INT_acpu_neg_int_shift                                               (6)
+#define SB2_DBG_INT_acpu_neg_int_mask                                                (0x00000040)
+#define SB2_DBG_INT_acpu_neg_int(data)                                               (0x00000040&((data)<<6))
+#define SB2_DBG_INT_acpu_neg_int_src(data)                                           ((0x00000040&(data))>>6)
+#define SB2_DBG_INT_get_acpu_neg_int(data)                                           ((0x00000040&(data))>>6)
+#define SB2_DBG_INT_scpu_neg_int_shift                                               (4)
+#define SB2_DBG_INT_scpu_neg_int_mask                                                (0x00000010)
+#define SB2_DBG_INT_scpu_neg_int(data)                                               (0x00000010&((data)<<4))
+#define SB2_DBG_INT_scpu_neg_int_src(data)                                           ((0x00000010&(data))>>4)
+#define SB2_DBG_INT_get_scpu_neg_int(data)                                           ((0x00000010&(data))>>4)
+#define SB2_DBG_INT_acpu_neg_int_en_shift                                            (3)
+#define SB2_DBG_INT_acpu_neg_int_en_mask                                             (0x00000008)
+#define SB2_DBG_INT_acpu_neg_int_en(data)                                            (0x00000008&((data)<<3))
+#define SB2_DBG_INT_acpu_neg_int_en_src(data)                                        ((0x00000008&(data))>>3)
+#define SB2_DBG_INT_get_acpu_neg_int_en(data)                                        ((0x00000008&(data))>>3)
+#define SB2_DBG_INT_scpu_neg_int_en_shift                                            (1)
+#define SB2_DBG_INT_scpu_neg_int_en_mask                                             (0x00000002)
+#define SB2_DBG_INT_scpu_neg_int_en(data)                                            (0x00000002&((data)<<1))
+#define SB2_DBG_INT_scpu_neg_int_en_src(data)                                        ((0x00000002&(data))>>1)
+#define SB2_DBG_INT_get_scpu_neg_int_en(data)                                        ((0x00000002&(data))>>1)
+#define SB2_DBG_INT_write_data_shift                                                 (0)
+#define SB2_DBG_INT_write_data_mask                                                  (0x00000001)
+#define SB2_DBG_INT_write_data(data)                                                 (0x00000001&((data)<<0))
+#define SB2_DBG_INT_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define SB2_DBG_INT_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SB2_DBG_WDATA_0                                                              0x9801A4E4
+#define SB2_DBG_WDATA_1                                                              0x9801A4E8
+#define SB2_DBG_WDATA_0_reg_addr                                                     "0xD801A4E4"
+#define SB2_DBG_WDATA_1_reg_addr                                                     "0xD801A4E8"
+#define SB2_DBG_WDATA_0_reg                                                          0xD801A4E4
+#define SB2_DBG_WDATA_1_reg                                                          0xD801A4E8
+#define set_SB2_DBG_WDATA_0_reg(data)   (*((volatile unsigned int*) SB2_DBG_WDATA_0_reg)=data)
+#define set_SB2_DBG_WDATA_1_reg(data)   (*((volatile unsigned int*) SB2_DBG_WDATA_1_reg)=data)
+#define get_SB2_DBG_WDATA_0_reg   (*((volatile unsigned int*) SB2_DBG_WDATA_0_reg))
+#define get_SB2_DBG_WDATA_1_reg   (*((volatile unsigned int*) SB2_DBG_WDATA_1_reg))
+#define SB2_DBG_WDATA_0_inst_adr                                                     "0x0039"
+#define SB2_DBG_WDATA_1_inst_adr                                                     "0x003A"
+#define SB2_DBG_WDATA_0_inst                                                         0x0039
+#define SB2_DBG_WDATA_1_inst                                                         0x003A
+#define SB2_DBG_WDATA_dbg_wdata_shift                                                (0)
+#define SB2_DBG_WDATA_dbg_wdata_mask                                                 (0xFFFFFFFF)
+#define SB2_DBG_WDATA_dbg_wdata(data)                                                (0xFFFFFFFF&((data)<<0))
+#define SB2_DBG_WDATA_dbg_wdata_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define SB2_DBG_WDATA_get_dbg_wdata(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DUMMY_0                                                                  0x9801A600
+#define SB2_DUMMY_1                                                                  0x9801A604
+#define SB2_DUMMY_2                                                                  0x9801A608
+#define SB2_DUMMY_3                                                                  0x9801A60C
+#define SB2_DUMMY_0_reg_addr                                                         "0xD801A600"
+#define SB2_DUMMY_1_reg_addr                                                         "0xD801A604"
+#define SB2_DUMMY_2_reg_addr                                                         "0xD801A608"
+#define SB2_DUMMY_3_reg_addr                                                         "0xD801A60C"
+#define SB2_DUMMY_0_reg                                                              0xD801A600
+#define SB2_DUMMY_1_reg                                                              0xD801A604
+#define SB2_DUMMY_2_reg                                                              0xD801A608
+#define SB2_DUMMY_3_reg                                                              0xD801A60C
+#define set_SB2_DUMMY_0_reg(data)   (*((volatile unsigned int*) SB2_DUMMY_0_reg)=data)
+#define set_SB2_DUMMY_1_reg(data)   (*((volatile unsigned int*) SB2_DUMMY_1_reg)=data)
+#define set_SB2_DUMMY_2_reg(data)   (*((volatile unsigned int*) SB2_DUMMY_2_reg)=data)
+#define set_SB2_DUMMY_3_reg(data)   (*((volatile unsigned int*) SB2_DUMMY_3_reg)=data)
+#define get_SB2_DUMMY_0_reg   (*((volatile unsigned int*) SB2_DUMMY_0_reg))
+#define get_SB2_DUMMY_1_reg   (*((volatile unsigned int*) SB2_DUMMY_1_reg))
+#define get_SB2_DUMMY_2_reg   (*((volatile unsigned int*) SB2_DUMMY_2_reg))
+#define get_SB2_DUMMY_3_reg   (*((volatile unsigned int*) SB2_DUMMY_3_reg))
+#define SB2_DUMMY_0_inst_adr                                                         "0x0080"
+#define SB2_DUMMY_1_inst_adr                                                         "0x0081"
+#define SB2_DUMMY_2_inst_adr                                                         "0x0082"
+#define SB2_DUMMY_3_inst_adr                                                         "0x0083"
+#define SB2_DUMMY_0_inst                                                             0x0080
+#define SB2_DUMMY_1_inst                                                             0x0081
+#define SB2_DUMMY_2_inst                                                             0x0082
+#define SB2_DUMMY_3_inst                                                             0x0083
+#define SB2_DUMMY_data_shift                                                         (0)
+#define SB2_DUMMY_data_mask                                                          (0xFFFFFFFF)
+#define SB2_DUMMY_data(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define SB2_DUMMY_data_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define SB2_DUMMY_get_data(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_SHADOW_0                                                                 0x9801A610
+#define SB2_SHADOW_1                                                                 0x9801A614
+#define SB2_SHADOW_2                                                                 0x9801A618
+#define SB2_SHADOW_3                                                                 0x9801A61C
+#define SB2_SHADOW_0_reg_addr                                                        "0xD801A610"
+#define SB2_SHADOW_1_reg_addr                                                        "0xD801A614"
+#define SB2_SHADOW_2_reg_addr                                                        "0xD801A618"
+#define SB2_SHADOW_3_reg_addr                                                        "0xD801A61C"
+#define SB2_SHADOW_0_reg                                                             0xD801A610
+#define SB2_SHADOW_1_reg                                                             0xD801A614
+#define SB2_SHADOW_2_reg                                                             0xD801A618
+#define SB2_SHADOW_3_reg                                                             0xD801A61C
+#define set_SB2_SHADOW_0_reg(data)   (*((volatile unsigned int*) SB2_SHADOW_0_reg)=data)
+#define set_SB2_SHADOW_1_reg(data)   (*((volatile unsigned int*) SB2_SHADOW_1_reg)=data)
+#define set_SB2_SHADOW_2_reg(data)   (*((volatile unsigned int*) SB2_SHADOW_2_reg)=data)
+#define set_SB2_SHADOW_3_reg(data)   (*((volatile unsigned int*) SB2_SHADOW_3_reg)=data)
+#define get_SB2_SHADOW_0_reg   (*((volatile unsigned int*) SB2_SHADOW_0_reg))
+#define get_SB2_SHADOW_1_reg   (*((volatile unsigned int*) SB2_SHADOW_1_reg))
+#define get_SB2_SHADOW_2_reg   (*((volatile unsigned int*) SB2_SHADOW_2_reg))
+#define get_SB2_SHADOW_3_reg   (*((volatile unsigned int*) SB2_SHADOW_3_reg))
+#define SB2_SHADOW_0_inst_adr                                                        "0x0084"
+#define SB2_SHADOW_1_inst_adr                                                        "0x0085"
+#define SB2_SHADOW_2_inst_adr                                                        "0x0086"
+#define SB2_SHADOW_3_inst_adr                                                        "0x0087"
+#define SB2_SHADOW_0_inst                                                            0x0084
+#define SB2_SHADOW_1_inst                                                            0x0085
+#define SB2_SHADOW_2_inst                                                            0x0086
+#define SB2_SHADOW_3_inst                                                            0x0087
+#define SB2_SHADOW_data_shift                                                        (0)
+#define SB2_SHADOW_data_mask                                                         (0xFFFFFFFF)
+#define SB2_SHADOW_data(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define SB2_SHADOW_data_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define SB2_SHADOW_get_data(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_HD_SEM_NEW_0                                                             0x9801A620
+#define SB2_HD_SEM_NEW_1                                                             0x9801A624
+#define SB2_HD_SEM_NEW_2                                                             0x9801A628
+#define SB2_HD_SEM_NEW_3                                                             0x9801A62C
+#define SB2_HD_SEM_NEW_4                                                             0x9801A630
+#define SB2_HD_SEM_NEW_5                                                             0x9801A634
+#define SB2_HD_SEM_NEW_6                                                             0x9801A638
+#define SB2_HD_SEM_NEW_7                                                             0x9801A63C
+#define SB2_HD_SEM_NEW_0_reg_addr                                                    "0xD801A620"
+#define SB2_HD_SEM_NEW_1_reg_addr                                                    "0xD801A624"
+#define SB2_HD_SEM_NEW_2_reg_addr                                                    "0xD801A628"
+#define SB2_HD_SEM_NEW_3_reg_addr                                                    "0xD801A62C"
+#define SB2_HD_SEM_NEW_4_reg_addr                                                    "0xD801A630"
+#define SB2_HD_SEM_NEW_5_reg_addr                                                    "0xD801A634"
+#define SB2_HD_SEM_NEW_6_reg_addr                                                    "0xD801A638"
+#define SB2_HD_SEM_NEW_7_reg_addr                                                    "0xD801A63C"
+#define SB2_HD_SEM_NEW_0_reg                                                         0xD801A620
+#define SB2_HD_SEM_NEW_1_reg                                                         0xD801A624
+#define SB2_HD_SEM_NEW_2_reg                                                         0xD801A628
+#define SB2_HD_SEM_NEW_3_reg                                                         0xD801A62C
+#define SB2_HD_SEM_NEW_4_reg                                                         0xD801A630
+#define SB2_HD_SEM_NEW_5_reg                                                         0xD801A634
+#define SB2_HD_SEM_NEW_6_reg                                                         0xD801A638
+#define SB2_HD_SEM_NEW_7_reg                                                         0xD801A63C
+#define set_SB2_HD_SEM_NEW_0_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_0_reg)=data)
+#define set_SB2_HD_SEM_NEW_1_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_1_reg)=data)
+#define set_SB2_HD_SEM_NEW_2_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_2_reg)=data)
+#define set_SB2_HD_SEM_NEW_3_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_3_reg)=data)
+#define set_SB2_HD_SEM_NEW_4_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_4_reg)=data)
+#define set_SB2_HD_SEM_NEW_5_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_5_reg)=data)
+#define set_SB2_HD_SEM_NEW_6_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_6_reg)=data)
+#define set_SB2_HD_SEM_NEW_7_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_7_reg)=data)
+#define get_SB2_HD_SEM_NEW_0_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_0_reg))
+#define get_SB2_HD_SEM_NEW_1_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_1_reg))
+#define get_SB2_HD_SEM_NEW_2_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_2_reg))
+#define get_SB2_HD_SEM_NEW_3_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_3_reg))
+#define get_SB2_HD_SEM_NEW_4_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_4_reg))
+#define get_SB2_HD_SEM_NEW_5_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_5_reg))
+#define get_SB2_HD_SEM_NEW_6_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_6_reg))
+#define get_SB2_HD_SEM_NEW_7_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_7_reg))
+#define SB2_HD_SEM_NEW_0_inst_adr                                                    "0x0088"
+#define SB2_HD_SEM_NEW_1_inst_adr                                                    "0x0089"
+#define SB2_HD_SEM_NEW_2_inst_adr                                                    "0x008A"
+#define SB2_HD_SEM_NEW_3_inst_adr                                                    "0x008B"
+#define SB2_HD_SEM_NEW_4_inst_adr                                                    "0x008C"
+#define SB2_HD_SEM_NEW_5_inst_adr                                                    "0x008D"
+#define SB2_HD_SEM_NEW_6_inst_adr                                                    "0x008E"
+#define SB2_HD_SEM_NEW_7_inst_adr                                                    "0x008F"
+#define SB2_HD_SEM_NEW_0_inst                                                        0x0088
+#define SB2_HD_SEM_NEW_1_inst                                                        0x0089
+#define SB2_HD_SEM_NEW_2_inst                                                        0x008A
+#define SB2_HD_SEM_NEW_3_inst                                                        0x008B
+#define SB2_HD_SEM_NEW_4_inst                                                        0x008C
+#define SB2_HD_SEM_NEW_5_inst                                                        0x008D
+#define SB2_HD_SEM_NEW_6_inst                                                        0x008E
+#define SB2_HD_SEM_NEW_7_inst                                                        0x008F
+#define SB2_HD_SEM_NEW_Semaphore_shift                                               (0)
+#define SB2_HD_SEM_NEW_Semaphore_mask                                                (0x00000001)
+#define SB2_HD_SEM_NEW_Semaphore(data)                                               (0x00000001&((data)<<0))
+#define SB2_HD_SEM_NEW_Semaphore_src(data)                                           ((0x00000001&(data))>>0)
+#define SB2_HD_SEM_NEW_get_Semaphore(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SB2_RBUS_INVA_ACC_CTRL                                                       0x9801A650
+#define SB2_RBUS_INVA_ACC_CTRL_reg_addr                                              "0xD801A650"
+#define SB2_RBUS_INVA_ACC_CTRL_reg                                                   0xD801A650
+#define set_SB2_RBUS_INVA_ACC_CTRL_reg(data)   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_CTRL_reg)=data)
+#define get_SB2_RBUS_INVA_ACC_CTRL_reg   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_CTRL_reg))
+#define SB2_RBUS_INVA_ACC_CTRL_inst_adr                                              "0x0094"
+#define SB2_RBUS_INVA_ACC_CTRL_inst                                                  0x0094
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec2_en_shift                                 (2)
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec2_en_mask                                  (0x00000004)
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec2_en(data)                                 (0x00000004&((data)<<2))
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec2_en_src(data)                             ((0x00000004&(data))>>2)
+#define SB2_RBUS_INVA_ACC_CTRL_get_inva_wr_sec2_en(data)                             ((0x00000004&(data))>>2)
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec1_en_shift                                 (0)
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec1_en_mask                                  (0x00000001)
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec1_en(data)                                 (0x00000001&((data)<<0))
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec1_en_src(data)                             ((0x00000001&(data))>>0)
+#define SB2_RBUS_INVA_ACC_CTRL_get_inva_wr_sec1_en(data)                             ((0x00000001&(data))>>0)
+
+
+#define SB2_RBUS_INVA_ACC_SEC1_START                                                 0x9801A654
+#define SB2_RBUS_INVA_ACC_SEC1_START_reg_addr                                        "0xD801A654"
+#define SB2_RBUS_INVA_ACC_SEC1_START_reg                                             0xD801A654
+#define set_SB2_RBUS_INVA_ACC_SEC1_START_reg(data)   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC1_START_reg)=data)
+#define get_SB2_RBUS_INVA_ACC_SEC1_START_reg   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC1_START_reg))
+#define SB2_RBUS_INVA_ACC_SEC1_START_inst_adr                                        "0x0095"
+#define SB2_RBUS_INVA_ACC_SEC1_START_inst                                            0x0095
+#define SB2_RBUS_INVA_ACC_SEC1_START_sec1_start_shift                                (2)
+#define SB2_RBUS_INVA_ACC_SEC1_START_sec1_start_mask                                 (0x003FFFFC)
+#define SB2_RBUS_INVA_ACC_SEC1_START_sec1_start(data)                                (0x003FFFFC&((data)<<2))
+#define SB2_RBUS_INVA_ACC_SEC1_START_sec1_start_src(data)                            ((0x003FFFFC&(data))>>2)
+#define SB2_RBUS_INVA_ACC_SEC1_START_get_sec1_start(data)                            ((0x003FFFFC&(data))>>2)
+
+
+#define SB2_RBUS_INVA_ACC_SEC1_END                                                   0x9801A658
+#define SB2_RBUS_INVA_ACC_SEC1_END_reg_addr                                          "0xD801A658"
+#define SB2_RBUS_INVA_ACC_SEC1_END_reg                                               0xD801A658
+#define set_SB2_RBUS_INVA_ACC_SEC1_END_reg(data)   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC1_END_reg)=data)
+#define get_SB2_RBUS_INVA_ACC_SEC1_END_reg   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC1_END_reg))
+#define SB2_RBUS_INVA_ACC_SEC1_END_inst_adr                                          "0x0096"
+#define SB2_RBUS_INVA_ACC_SEC1_END_inst                                              0x0096
+#define SB2_RBUS_INVA_ACC_SEC1_END_sec1_end_shift                                    (2)
+#define SB2_RBUS_INVA_ACC_SEC1_END_sec1_end_mask                                     (0x003FFFFC)
+#define SB2_RBUS_INVA_ACC_SEC1_END_sec1_end(data)                                    (0x003FFFFC&((data)<<2))
+#define SB2_RBUS_INVA_ACC_SEC1_END_sec1_end_src(data)                                ((0x003FFFFC&(data))>>2)
+#define SB2_RBUS_INVA_ACC_SEC1_END_get_sec1_end(data)                                ((0x003FFFFC&(data))>>2)
+
+
+#define SB2_RBUS_INVA_ACC_SEC2_START                                                 0x9801A65C
+#define SB2_RBUS_INVA_ACC_SEC2_START_reg_addr                                        "0xD801A65C"
+#define SB2_RBUS_INVA_ACC_SEC2_START_reg                                             0xD801A65C
+#define set_SB2_RBUS_INVA_ACC_SEC2_START_reg(data)   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC2_START_reg)=data)
+#define get_SB2_RBUS_INVA_ACC_SEC2_START_reg   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC2_START_reg))
+#define SB2_RBUS_INVA_ACC_SEC2_START_inst_adr                                        "0x0097"
+#define SB2_RBUS_INVA_ACC_SEC2_START_inst                                            0x0097
+#define SB2_RBUS_INVA_ACC_SEC2_START_sec2_start_shift                                (2)
+#define SB2_RBUS_INVA_ACC_SEC2_START_sec2_start_mask                                 (0x003FFFFC)
+#define SB2_RBUS_INVA_ACC_SEC2_START_sec2_start(data)                                (0x003FFFFC&((data)<<2))
+#define SB2_RBUS_INVA_ACC_SEC2_START_sec2_start_src(data)                            ((0x003FFFFC&(data))>>2)
+#define SB2_RBUS_INVA_ACC_SEC2_START_get_sec2_start(data)                            ((0x003FFFFC&(data))>>2)
+
+
+#define SB2_RBUS_INVA_ACC_SEC2_END                                                   0x9801A660
+#define SB2_RBUS_INVA_ACC_SEC2_END_reg_addr                                          "0xD801A660"
+#define SB2_RBUS_INVA_ACC_SEC2_END_reg                                               0xD801A660
+#define set_SB2_RBUS_INVA_ACC_SEC2_END_reg(data)   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC2_END_reg)=data)
+#define get_SB2_RBUS_INVA_ACC_SEC2_END_reg   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC2_END_reg))
+#define SB2_RBUS_INVA_ACC_SEC2_END_inst_adr                                          "0x0098"
+#define SB2_RBUS_INVA_ACC_SEC2_END_inst                                              0x0098
+#define SB2_RBUS_INVA_ACC_SEC2_END_sec2_end_shift                                    (2)
+#define SB2_RBUS_INVA_ACC_SEC2_END_sec2_end_mask                                     (0x003FFFFC)
+#define SB2_RBUS_INVA_ACC_SEC2_END_sec2_end(data)                                    (0x003FFFFC&((data)<<2))
+#define SB2_RBUS_INVA_ACC_SEC2_END_sec2_end_src(data)                                ((0x003FFFFC&(data))>>2)
+#define SB2_RBUS_INVA_ACC_SEC2_END_get_sec2_end(data)                                ((0x003FFFFC&(data))>>2)
+
+
+#define SB2_RBUS_CMP_CTRL                                                            0x9801A664
+#define SB2_RBUS_CMP_CTRL_reg_addr                                                   "0xD801A664"
+#define SB2_RBUS_CMP_CTRL_reg                                                        0xD801A664
+#define set_SB2_RBUS_CMP_CTRL_reg(data)   (*((volatile unsigned int*) SB2_RBUS_CMP_CTRL_reg)=data)
+#define get_SB2_RBUS_CMP_CTRL_reg   (*((volatile unsigned int*) SB2_RBUS_CMP_CTRL_reg))
+#define SB2_RBUS_CMP_CTRL_inst_adr                                                   "0x0099"
+#define SB2_RBUS_CMP_CTRL_inst                                                       0x0099
+#define SB2_RBUS_CMP_CTRL_crc_cmp_latch_en_shift                                     (0)
+#define SB2_RBUS_CMP_CTRL_crc_cmp_latch_en_mask                                      (0x00000001)
+#define SB2_RBUS_CMP_CTRL_crc_cmp_latch_en(data)                                     (0x00000001&((data)<<0))
+#define SB2_RBUS_CMP_CTRL_crc_cmp_latch_en_src(data)                                 ((0x00000001&(data))>>0)
+#define SB2_RBUS_CMP_CTRL_get_crc_cmp_latch_en(data)                                 ((0x00000001&(data))>>0)
+
+
+#define SB2_RBUS_CMP_DATA0                                                           0x9801A668
+#define SB2_RBUS_CMP_DATA0_reg_addr                                                  "0xD801A668"
+#define SB2_RBUS_CMP_DATA0_reg                                                       0xD801A668
+#define set_SB2_RBUS_CMP_DATA0_reg(data)   (*((volatile unsigned int*) SB2_RBUS_CMP_DATA0_reg)=data)
+#define get_SB2_RBUS_CMP_DATA0_reg   (*((volatile unsigned int*) SB2_RBUS_CMP_DATA0_reg))
+#define SB2_RBUS_CMP_DATA0_inst_adr                                                  "0x009A"
+#define SB2_RBUS_CMP_DATA0_inst                                                      0x009A
+#define SB2_RBUS_CMP_DATA0_crc_cmp_expect0_shift                                     (0)
+#define SB2_RBUS_CMP_DATA0_crc_cmp_expect0_mask                                      (0xFFFFFFFF)
+#define SB2_RBUS_CMP_DATA0_crc_cmp_expect0(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SB2_RBUS_CMP_DATA0_crc_cmp_expect0_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SB2_RBUS_CMP_DATA0_get_crc_cmp_expect0(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_RBUS_CMP_DATA1                                                           0x9801A66C
+#define SB2_RBUS_CMP_DATA1_reg_addr                                                  "0xD801A66C"
+#define SB2_RBUS_CMP_DATA1_reg                                                       0xD801A66C
+#define set_SB2_RBUS_CMP_DATA1_reg(data)   (*((volatile unsigned int*) SB2_RBUS_CMP_DATA1_reg)=data)
+#define get_SB2_RBUS_CMP_DATA1_reg   (*((volatile unsigned int*) SB2_RBUS_CMP_DATA1_reg))
+#define SB2_RBUS_CMP_DATA1_inst_adr                                                  "0x009B"
+#define SB2_RBUS_CMP_DATA1_inst                                                      0x009B
+#define SB2_RBUS_CMP_DATA1_crc_cmp_expect1_shift                                     (0)
+#define SB2_RBUS_CMP_DATA1_crc_cmp_expect1_mask                                      (0xFFFFFFFF)
+#define SB2_RBUS_CMP_DATA1_crc_cmp_expect1(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SB2_RBUS_CMP_DATA1_crc_cmp_expect1_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SB2_RBUS_CMP_DATA1_get_crc_cmp_expect1(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_RBUS_CMP_RESULT                                                          0x9801A670
+#define SB2_RBUS_CMP_RESULT_reg_addr                                                 "0xD801A670"
+#define SB2_RBUS_CMP_RESULT_reg                                                      0xD801A670
+#define set_SB2_RBUS_CMP_RESULT_reg(data)   (*((volatile unsigned int*) SB2_RBUS_CMP_RESULT_reg)=data)
+#define get_SB2_RBUS_CMP_RESULT_reg   (*((volatile unsigned int*) SB2_RBUS_CMP_RESULT_reg))
+#define SB2_RBUS_CMP_RESULT_inst_adr                                                 "0x009C"
+#define SB2_RBUS_CMP_RESULT_inst                                                     0x009C
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result0_shift                                    (1)
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result0_mask                                     (0x00000002)
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result0(data)                                    (0x00000002&((data)<<1))
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result0_src(data)                                ((0x00000002&(data))>>1)
+#define SB2_RBUS_CMP_RESULT_get_crc_cmp_result0(data)                                ((0x00000002&(data))>>1)
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result1_shift                                    (0)
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result1_mask                                     (0x00000001)
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result1(data)                                    (0x00000001&((data)<<0))
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result1_src(data)                                ((0x00000001&(data))>>0)
+#define SB2_RBUS_CMP_RESULT_get_crc_cmp_result1(data)                                ((0x00000001&(data))>>0)
+
+
+#define SB2_BIST_CTRL                                                                0x9801A674
+#define SB2_BIST_CTRL_reg_addr                                                       "0xD801A674"
+#define SB2_BIST_CTRL_reg                                                            0xD801A674
+#define set_SB2_BIST_CTRL_reg(data)   (*((volatile unsigned int*) SB2_BIST_CTRL_reg)=data)
+#define get_SB2_BIST_CTRL_reg   (*((volatile unsigned int*) SB2_BIST_CTRL_reg))
+#define SB2_BIST_CTRL_inst_adr                                                       "0x009D"
+#define SB2_BIST_CTRL_inst                                                           0x009D
+#define SB2_BIST_CTRL_sb2_bist_rstn_shift                                            (7)
+#define SB2_BIST_CTRL_sb2_bist_rstn_mask                                             (0x00000080)
+#define SB2_BIST_CTRL_sb2_bist_rstn(data)                                            (0x00000080&((data)<<7))
+#define SB2_BIST_CTRL_sb2_bist_rstn_src(data)                                        ((0x00000080&(data))>>7)
+#define SB2_BIST_CTRL_get_sb2_bist_rstn(data)                                        ((0x00000080&(data))>>7)
+#define SB2_BIST_CTRL_sb2_bist_en_shift                                              (6)
+#define SB2_BIST_CTRL_sb2_bist_en_mask                                               (0x00000040)
+#define SB2_BIST_CTRL_sb2_bist_en(data)                                              (0x00000040&((data)<<6))
+#define SB2_BIST_CTRL_sb2_bist_en_src(data)                                          ((0x00000040&(data))>>6)
+#define SB2_BIST_CTRL_get_sb2_bist_en(data)                                          ((0x00000040&(data))>>6)
+#define SB2_BIST_CTRL_sb2_rom_ls_shift                                               (5)
+#define SB2_BIST_CTRL_sb2_rom_ls_mask                                                (0x00000020)
+#define SB2_BIST_CTRL_sb2_rom_ls(data)                                               (0x00000020&((data)<<5))
+#define SB2_BIST_CTRL_sb2_rom_ls_src(data)                                           ((0x00000020&(data))>>5)
+#define SB2_BIST_CTRL_get_sb2_rom_ls(data)                                           ((0x00000020&(data))>>5)
+#define SB2_BIST_CTRL_sb2_rom_rme_shift                                              (4)
+#define SB2_BIST_CTRL_sb2_rom_rme_mask                                               (0x00000010)
+#define SB2_BIST_CTRL_sb2_rom_rme(data)                                              (0x00000010&((data)<<4))
+#define SB2_BIST_CTRL_sb2_rom_rme_src(data)                                          ((0x00000010&(data))>>4)
+#define SB2_BIST_CTRL_get_sb2_rom_rme(data)                                          ((0x00000010&(data))>>4)
+#define SB2_BIST_CTRL_sb2_rom_rm_shift                                               (0)
+#define SB2_BIST_CTRL_sb2_rom_rm_mask                                                (0x0000000F)
+#define SB2_BIST_CTRL_sb2_rom_rm(data)                                               (0x0000000F&((data)<<0))
+#define SB2_BIST_CTRL_sb2_rom_rm_src(data)                                           ((0x0000000F&(data))>>0)
+#define SB2_BIST_CTRL_get_sb2_rom_rm(data)                                           ((0x0000000F&(data))>>0)
+
+
+#define SB2_BIST_STATUS                                                              0x9801A678
+#define SB2_BIST_STATUS_reg_addr                                                     "0xD801A678"
+#define SB2_BIST_STATUS_reg                                                          0xD801A678
+#define set_SB2_BIST_STATUS_reg(data)   (*((volatile unsigned int*) SB2_BIST_STATUS_reg)=data)
+#define get_SB2_BIST_STATUS_reg   (*((volatile unsigned int*) SB2_BIST_STATUS_reg))
+#define SB2_BIST_STATUS_inst_adr                                                     "0x009E"
+#define SB2_BIST_STATUS_inst                                                         0x009E
+#define SB2_BIST_STATUS_sb2_rom_bist_done_shift                                      (16)
+#define SB2_BIST_STATUS_sb2_rom_bist_done_mask                                       (0x00010000)
+#define SB2_BIST_STATUS_sb2_rom_bist_done(data)                                      (0x00010000&((data)<<16))
+#define SB2_BIST_STATUS_sb2_rom_bist_done_src(data)                                  ((0x00010000&(data))>>16)
+#define SB2_BIST_STATUS_get_sb2_rom_bist_done(data)                                  ((0x00010000&(data))>>16)
+
+
+#define SB2_BIST_MISR_DATAOUT0                                                       0x9801A67C
+#define SB2_BIST_MISR_DATAOUT0_reg_addr                                              "0xD801A67C"
+#define SB2_BIST_MISR_DATAOUT0_reg                                                   0xD801A67C
+#define set_SB2_BIST_MISR_DATAOUT0_reg(data)   (*((volatile unsigned int*) SB2_BIST_MISR_DATAOUT0_reg)=data)
+#define get_SB2_BIST_MISR_DATAOUT0_reg   (*((volatile unsigned int*) SB2_BIST_MISR_DATAOUT0_reg))
+#define SB2_BIST_MISR_DATAOUT0_inst_adr                                              "0x009F"
+#define SB2_BIST_MISR_DATAOUT0_inst                                                  0x009F
+#define SB2_BIST_MISR_DATAOUT0_sb2_misr_dataout_0_shift                              (0)
+#define SB2_BIST_MISR_DATAOUT0_sb2_misr_dataout_0_mask                               (0xFFFFFFFF)
+#define SB2_BIST_MISR_DATAOUT0_sb2_misr_dataout_0(data)                              (0xFFFFFFFF&((data)<<0))
+#define SB2_BIST_MISR_DATAOUT0_sb2_misr_dataout_0_src(data)                          ((0xFFFFFFFF&(data))>>0)
+#define SB2_BIST_MISR_DATAOUT0_get_sb2_misr_dataout_0(data)                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_BIST_MISR_DATAOUT1                                                       0x9801A680
+#define SB2_BIST_MISR_DATAOUT1_reg_addr                                              "0xD801A680"
+#define SB2_BIST_MISR_DATAOUT1_reg                                                   0xD801A680
+#define set_SB2_BIST_MISR_DATAOUT1_reg(data)   (*((volatile unsigned int*) SB2_BIST_MISR_DATAOUT1_reg)=data)
+#define get_SB2_BIST_MISR_DATAOUT1_reg   (*((volatile unsigned int*) SB2_BIST_MISR_DATAOUT1_reg))
+#define SB2_BIST_MISR_DATAOUT1_inst_adr                                              "0x00A0"
+#define SB2_BIST_MISR_DATAOUT1_inst                                                  0x00A0
+#define SB2_BIST_MISR_DATAOUT1_sb2_misr_dataout_1_shift                              (0)
+#define SB2_BIST_MISR_DATAOUT1_sb2_misr_dataout_1_mask                               (0xFFFFFFFF)
+#define SB2_BIST_MISR_DATAOUT1_sb2_misr_dataout_1(data)                              (0xFFFFFFFF&((data)<<0))
+#define SB2_BIST_MISR_DATAOUT1_sb2_misr_dataout_1_src(data)                          ((0xFFFFFFFF&(data))>>0)
+#define SB2_BIST_MISR_DATAOUT1_get_sb2_misr_dataout_1(data)                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_SFC_OPCODE                                                               0x9801A800
+#define SB2_SFC_OPCODE_reg_addr                                                      "0xD801A800"
+#define SB2_SFC_OPCODE_reg                                                           0xD801A800
+#define set_SB2_SFC_OPCODE_reg(data)   (*((volatile unsigned int*) SB2_SFC_OPCODE_reg)=data)
+#define get_SB2_SFC_OPCODE_reg   (*((volatile unsigned int*) SB2_SFC_OPCODE_reg))
+#define SB2_SFC_OPCODE_inst_adr                                                      "0x0000"
+#define SB2_SFC_OPCODE_inst                                                          0x0000
+#define SB2_SFC_OPCODE_dual_mode_shift                                               (9)
+#define SB2_SFC_OPCODE_dual_mode_mask                                                (0x00000600)
+#define SB2_SFC_OPCODE_dual_mode(data)                                               (0x00000600&((data)<<9))
+#define SB2_SFC_OPCODE_dual_mode_src(data)                                           ((0x00000600&(data))>>9)
+#define SB2_SFC_OPCODE_get_dual_mode(data)                                           ((0x00000600&(data))>>9)
+#define SB2_SFC_OPCODE_fat_mode_shift                                                (8)
+#define SB2_SFC_OPCODE_fat_mode_mask                                                 (0x00000100)
+#define SB2_SFC_OPCODE_fat_mode(data)                                                (0x00000100&((data)<<8))
+#define SB2_SFC_OPCODE_fat_mode_src(data)                                            ((0x00000100&(data))>>8)
+#define SB2_SFC_OPCODE_get_fat_mode(data)                                            ((0x00000100&(data))>>8)
+#define SB2_SFC_OPCODE_opc_shift                                                     (0)
+#define SB2_SFC_OPCODE_opc_mask                                                      (0x000000FF)
+#define SB2_SFC_OPCODE_opc(data)                                                     (0x000000FF&((data)<<0))
+#define SB2_SFC_OPCODE_opc_src(data)                                                 ((0x000000FF&(data))>>0)
+#define SB2_SFC_OPCODE_get_opc(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define SB2_SFC_CTL                                                                  0x9801A804
+#define SB2_SFC_CTL_reg_addr                                                         "0xD801A804"
+#define SB2_SFC_CTL_reg                                                              0xD801A804
+#define set_SB2_SFC_CTL_reg(data)   (*((volatile unsigned int*) SB2_SFC_CTL_reg)=data)
+#define get_SB2_SFC_CTL_reg   (*((volatile unsigned int*) SB2_SFC_CTL_reg))
+#define SB2_SFC_CTL_inst_adr                                                         "0x0001"
+#define SB2_SFC_CTL_inst                                                             0x0001
+#define SB2_SFC_CTL_dataen_shift                                                     (4)
+#define SB2_SFC_CTL_dataen_mask                                                      (0x00000010)
+#define SB2_SFC_CTL_dataen(data)                                                     (0x00000010&((data)<<4))
+#define SB2_SFC_CTL_dataen_src(data)                                                 ((0x00000010&(data))>>4)
+#define SB2_SFC_CTL_get_dataen(data)                                                 ((0x00000010&(data))>>4)
+#define SB2_SFC_CTL_adren_shift                                                      (3)
+#define SB2_SFC_CTL_adren_mask                                                       (0x00000008)
+#define SB2_SFC_CTL_adren(data)                                                      (0x00000008&((data)<<3))
+#define SB2_SFC_CTL_adren_src(data)                                                  ((0x00000008&(data))>>3)
+#define SB2_SFC_CTL_get_adren(data)                                                  ((0x00000008&(data))>>3)
+#define SB2_SFC_CTL_dmycnt_shift                                                     (0)
+#define SB2_SFC_CTL_dmycnt_mask                                                      (0x00000007)
+#define SB2_SFC_CTL_dmycnt(data)                                                     (0x00000007&((data)<<0))
+#define SB2_SFC_CTL_dmycnt_src(data)                                                 ((0x00000007&(data))>>0)
+#define SB2_SFC_CTL_get_dmycnt(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define SB2_SFC_SCK                                                                  0x9801A808
+#define SB2_SFC_SCK_reg_addr                                                         "0xD801A808"
+#define SB2_SFC_SCK_reg                                                              0xD801A808
+#define set_SB2_SFC_SCK_reg(data)   (*((volatile unsigned int*) SB2_SFC_SCK_reg)=data)
+#define get_SB2_SFC_SCK_reg   (*((volatile unsigned int*) SB2_SFC_SCK_reg))
+#define SB2_SFC_SCK_inst_adr                                                         "0x0002"
+#define SB2_SFC_SCK_inst                                                             0x0002
+#define SB2_SFC_SCK_mode_shift                                                       (8)
+#define SB2_SFC_SCK_mode_mask                                                        (0x00000100)
+#define SB2_SFC_SCK_mode(data)                                                       (0x00000100&((data)<<8))
+#define SB2_SFC_SCK_mode_src(data)                                                   ((0x00000100&(data))>>8)
+#define SB2_SFC_SCK_get_mode(data)                                                   ((0x00000100&(data))>>8)
+#define SB2_SFC_SCK_fdiv_shift                                                       (0)
+#define SB2_SFC_SCK_fdiv_mask                                                        (0x000000FF)
+#define SB2_SFC_SCK_fdiv(data)                                                       (0x000000FF&((data)<<0))
+#define SB2_SFC_SCK_fdiv_src(data)                                                   ((0x000000FF&(data))>>0)
+#define SB2_SFC_SCK_get_fdiv(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define SB2_SFC_CE                                                                   0x9801A80C
+#define SB2_SFC_CE_reg_addr                                                          "0xD801A80C"
+#define SB2_SFC_CE_reg                                                               0xD801A80C
+#define set_SB2_SFC_CE_reg(data)   (*((volatile unsigned int*) SB2_SFC_CE_reg)=data)
+#define get_SB2_SFC_CE_reg   (*((volatile unsigned int*) SB2_SFC_CE_reg))
+#define SB2_SFC_CE_inst_adr                                                          "0x0003"
+#define SB2_SFC_CE_inst                                                              0x0003
+#define SB2_SFC_CE_tdt_shift                                                         (16)
+#define SB2_SFC_CE_tdt_mask                                                          (0xFFFF0000)
+#define SB2_SFC_CE_tdt(data)                                                         (0xFFFF0000&((data)<<16))
+#define SB2_SFC_CE_tdt_src(data)                                                     ((0xFFFF0000&(data))>>16)
+#define SB2_SFC_CE_get_tdt(data)                                                     ((0xFFFF0000&(data))>>16)
+#define SB2_SFC_CE_Phcnt_shift                                                       (8)
+#define SB2_SFC_CE_Phcnt_mask                                                        (0x0000FF00)
+#define SB2_SFC_CE_Phcnt(data)                                                       (0x0000FF00&((data)<<8))
+#define SB2_SFC_CE_Phcnt_src(data)                                                   ((0x0000FF00&(data))>>8)
+#define SB2_SFC_CE_get_Phcnt(data)                                                   ((0x0000FF00&(data))>>8)
+#define SB2_SFC_CE_Plcnt_shift                                                       (0)
+#define SB2_SFC_CE_Plcnt_mask                                                        (0x000000FF)
+#define SB2_SFC_CE_Plcnt(data)                                                       (0x000000FF&((data)<<0))
+#define SB2_SFC_CE_Plcnt_src(data)                                                   ((0x000000FF&(data))>>0)
+#define SB2_SFC_CE_get_Plcnt(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define SB2_SFC_WP                                                                   0x9801A810
+#define SB2_SFC_WP_reg_addr                                                          "0xD801A810"
+#define SB2_SFC_WP_reg                                                               0xD801A810
+#define set_SB2_SFC_WP_reg(data)   (*((volatile unsigned int*) SB2_SFC_WP_reg)=data)
+#define get_SB2_SFC_WP_reg   (*((volatile unsigned int*) SB2_SFC_WP_reg))
+#define SB2_SFC_WP_inst_adr                                                          "0x0004"
+#define SB2_SFC_WP_inst                                                              0x0004
+#define SB2_SFC_WP_write_en5_shift                                                   (27)
+#define SB2_SFC_WP_write_en5_mask                                                    (0x08000000)
+#define SB2_SFC_WP_write_en5(data)                                                   (0x08000000&((data)<<27))
+#define SB2_SFC_WP_write_en5_src(data)                                               ((0x08000000&(data))>>27)
+#define SB2_SFC_WP_get_write_en5(data)                                               ((0x08000000&(data))>>27)
+#define SB2_SFC_WP_rdy_shift                                                         (26)
+#define SB2_SFC_WP_rdy_mask                                                          (0x04000000)
+#define SB2_SFC_WP_rdy(data)                                                         (0x04000000&((data)<<26))
+#define SB2_SFC_WP_rdy_src(data)                                                     ((0x04000000&(data))>>26)
+#define SB2_SFC_WP_get_rdy(data)                                                     ((0x04000000&(data))>>26)
+#define SB2_SFC_WP_write_en1_shift                                                   (1)
+#define SB2_SFC_WP_write_en1_mask                                                    (0x00000002)
+#define SB2_SFC_WP_write_en1(data)                                                   (0x00000002&((data)<<1))
+#define SB2_SFC_WP_write_en1_src(data)                                               ((0x00000002&(data))>>1)
+#define SB2_SFC_WP_get_write_en1(data)                                               ((0x00000002&(data))>>1)
+#define SB2_SFC_WP_wp_n_shift                                                        (0)
+#define SB2_SFC_WP_wp_n_mask                                                         (0x00000001)
+#define SB2_SFC_WP_wp_n(data)                                                        (0x00000001&((data)<<0))
+#define SB2_SFC_WP_wp_n_src(data)                                                    ((0x00000001&(data))>>0)
+#define SB2_SFC_WP_get_wp_n(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define SB2_SFC_POS_LATCH                                                            0x9801A814
+#define SB2_SFC_POS_LATCH_reg_addr                                                   "0xD801A814"
+#define SB2_SFC_POS_LATCH_reg                                                        0xD801A814
+#define set_SB2_SFC_POS_LATCH_reg(data)   (*((volatile unsigned int*) SB2_SFC_POS_LATCH_reg)=data)
+#define get_SB2_SFC_POS_LATCH_reg   (*((volatile unsigned int*) SB2_SFC_POS_LATCH_reg))
+#define SB2_SFC_POS_LATCH_inst_adr                                                   "0x0005"
+#define SB2_SFC_POS_LATCH_inst                                                       0x0005
+#define SB2_SFC_POS_LATCH_pos_latch_shift                                            (0)
+#define SB2_SFC_POS_LATCH_pos_latch_mask                                             (0x00000001)
+#define SB2_SFC_POS_LATCH_pos_latch(data)                                            (0x00000001&((data)<<0))
+#define SB2_SFC_POS_LATCH_pos_latch_src(data)                                        ((0x00000001&(data))>>0)
+#define SB2_SFC_POS_LATCH_get_pos_latch(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SB2_SFC_WAIT_WR                                                              0x9801A818
+#define SB2_SFC_WAIT_WR_reg_addr                                                     "0xD801A818"
+#define SB2_SFC_WAIT_WR_reg                                                          0xD801A818
+#define set_SB2_SFC_WAIT_WR_reg(data)   (*((volatile unsigned int*) SB2_SFC_WAIT_WR_reg)=data)
+#define get_SB2_SFC_WAIT_WR_reg   (*((volatile unsigned int*) SB2_SFC_WAIT_WR_reg))
+#define SB2_SFC_WAIT_WR_inst_adr                                                     "0x0006"
+#define SB2_SFC_WAIT_WR_inst                                                         0x0006
+#define SB2_SFC_WAIT_WR_wt_prog_done_shift                                           (8)
+#define SB2_SFC_WAIT_WR_wt_prog_done_mask                                            (0x00000100)
+#define SB2_SFC_WAIT_WR_wt_prog_done(data)                                           (0x00000100&((data)<<8))
+#define SB2_SFC_WAIT_WR_wt_prog_done_src(data)                                       ((0x00000100&(data))>>8)
+#define SB2_SFC_WAIT_WR_get_wt_prog_done(data)                                       ((0x00000100&(data))>>8)
+#define SB2_SFC_WAIT_WR_rdsr_op_shift                                                (0)
+#define SB2_SFC_WAIT_WR_rdsr_op_mask                                                 (0x000000FF)
+#define SB2_SFC_WAIT_WR_rdsr_op(data)                                                (0x000000FF&((data)<<0))
+#define SB2_SFC_WAIT_WR_rdsr_op_src(data)                                            ((0x000000FF&(data))>>0)
+#define SB2_SFC_WAIT_WR_get_rdsr_op(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define SB2_SFC_EN_WR                                                                0x9801A81C
+#define SB2_SFC_EN_WR_reg_addr                                                       "0xD801A81C"
+#define SB2_SFC_EN_WR_reg                                                            0xD801A81C
+#define set_SB2_SFC_EN_WR_reg(data)   (*((volatile unsigned int*) SB2_SFC_EN_WR_reg)=data)
+#define get_SB2_SFC_EN_WR_reg   (*((volatile unsigned int*) SB2_SFC_EN_WR_reg))
+#define SB2_SFC_EN_WR_inst_adr                                                       "0x0007"
+#define SB2_SFC_EN_WR_inst                                                           0x0007
+#define SB2_SFC_EN_WR_wt_prog_en_shift                                               (8)
+#define SB2_SFC_EN_WR_wt_prog_en_mask                                                (0x00000100)
+#define SB2_SFC_EN_WR_wt_prog_en(data)                                               (0x00000100&((data)<<8))
+#define SB2_SFC_EN_WR_wt_prog_en_src(data)                                           ((0x00000100&(data))>>8)
+#define SB2_SFC_EN_WR_get_wt_prog_en(data)                                           ((0x00000100&(data))>>8)
+#define SB2_SFC_EN_WR_wr_en_op_shift                                                 (0)
+#define SB2_SFC_EN_WR_wr_en_op_mask                                                  (0x000000FF)
+#define SB2_SFC_EN_WR_wr_en_op(data)                                                 (0x000000FF&((data)<<0))
+#define SB2_SFC_EN_WR_wr_en_op_src(data)                                             ((0x000000FF&(data))>>0)
+#define SB2_SFC_EN_WR_get_wr_en_op(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define SB2_SFC_FAST_RD                                                              0x9801A820
+#define SB2_SFC_FAST_RD_reg_addr                                                     "0xD801A820"
+#define SB2_SFC_FAST_RD_reg                                                          0xD801A820
+#define set_SB2_SFC_FAST_RD_reg(data)   (*((volatile unsigned int*) SB2_SFC_FAST_RD_reg)=data)
+#define get_SB2_SFC_FAST_RD_reg   (*((volatile unsigned int*) SB2_SFC_FAST_RD_reg))
+#define SB2_SFC_FAST_RD_inst_adr                                                     "0x0008"
+#define SB2_SFC_FAST_RD_inst                                                         0x0008
+#define SB2_SFC_FAST_RD_sf_dclk_sel_shift                                            (4)
+#define SB2_SFC_FAST_RD_sf_dclk_sel_mask                                             (0x00000010)
+#define SB2_SFC_FAST_RD_sf_dclk_sel(data)                                            (0x00000010&((data)<<4))
+#define SB2_SFC_FAST_RD_sf_dclk_sel_src(data)                                        ((0x00000010&(data))>>4)
+#define SB2_SFC_FAST_RD_get_sf_dclk_sel(data)                                        ((0x00000010&(data))>>4)
+#define SB2_SFC_FAST_RD_fifo_write_tap_shift                                         (1)
+#define SB2_SFC_FAST_RD_fifo_write_tap_mask                                          (0x0000000E)
+#define SB2_SFC_FAST_RD_fifo_write_tap(data)                                         (0x0000000E&((data)<<1))
+#define SB2_SFC_FAST_RD_fifo_write_tap_src(data)                                     ((0x0000000E&(data))>>1)
+#define SB2_SFC_FAST_RD_get_fifo_write_tap(data)                                     ((0x0000000E&(data))>>1)
+#define SB2_SFC_FAST_RD_fast_read_en_shift                                           (0)
+#define SB2_SFC_FAST_RD_fast_read_en_mask                                            (0x00000001)
+#define SB2_SFC_FAST_RD_fast_read_en(data)                                           (0x00000001&((data)<<0))
+#define SB2_SFC_FAST_RD_fast_read_en_src(data)                                       ((0x00000001&(data))>>0)
+#define SB2_SFC_FAST_RD_get_fast_read_en(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SB2_SFC_SCK_TAP                                                              0x9801A824
+#define SB2_SFC_SCK_TAP_reg_addr                                                     "0xD801A824"
+#define SB2_SFC_SCK_TAP_reg                                                          0xD801A824
+#define set_SB2_SFC_SCK_TAP_reg(data)   (*((volatile unsigned int*) SB2_SFC_SCK_TAP_reg)=data)
+#define get_SB2_SFC_SCK_TAP_reg   (*((volatile unsigned int*) SB2_SFC_SCK_TAP_reg))
+#define SB2_SFC_SCK_TAP_inst_adr                                                     "0x0009"
+#define SB2_SFC_SCK_TAP_inst                                                         0x0009
+#define SB2_SFC_SCK_TAP_delay_clk_tap_shift                                          (0)
+#define SB2_SFC_SCK_TAP_delay_clk_tap_mask                                           (0xFFFFFFFF)
+#define SB2_SFC_SCK_TAP_delay_clk_tap(data)                                          (0xFFFFFFFF&((data)<<0))
+#define SB2_SFC_SCK_TAP_delay_clk_tap_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define SB2_SFC_SCK_TAP_get_delay_clk_tap(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_SFC_ADR_FOUR_BYTE_EN                                                     0x9801A828
+#define SB2_SFC_ADR_FOUR_BYTE_EN_reg_addr                                            "0xD801A828"
+#define SB2_SFC_ADR_FOUR_BYTE_EN_reg                                                 0xD801A828
+#define set_SB2_SFC_ADR_FOUR_BYTE_EN_reg(data)   (*((volatile unsigned int*) SB2_SFC_ADR_FOUR_BYTE_EN_reg)=data)
+#define get_SB2_SFC_ADR_FOUR_BYTE_EN_reg   (*((volatile unsigned int*) SB2_SFC_ADR_FOUR_BYTE_EN_reg))
+#define SB2_SFC_ADR_FOUR_BYTE_EN_inst_adr                                            "0x000A"
+#define SB2_SFC_ADR_FOUR_BYTE_EN_inst                                                0x000A
+#define SB2_SFC_ADR_FOUR_BYTE_EN_SFC_OPCODE_adr4byte_en_shift                        (0)
+#define SB2_SFC_ADR_FOUR_BYTE_EN_SFC_OPCODE_adr4byte_en_mask                         (0x00000001)
+#define SB2_SFC_ADR_FOUR_BYTE_EN_SFC_OPCODE_adr4byte_en(data)                        (0x00000001&((data)<<0))
+#define SB2_SFC_ADR_FOUR_BYTE_EN_SFC_OPCODE_adr4byte_en_src(data)                    ((0x00000001&(data))>>0)
+#define SB2_SFC_ADR_FOUR_BYTE_EN_get_SFC_OPCODE_adr4byte_en(data)                    ((0x00000001&(data))>>0)
+
+
+#define SB2_MUXPAD2                                                                  0x9801A908
+#define SB2_MUXPAD2_reg_addr                                                         "0xD801A908"
+#define SB2_MUXPAD2_reg                                                              0xD801A908
+#define set_SB2_MUXPAD2_reg(data)   (*((volatile unsigned int*) SB2_MUXPAD2_reg)=data)
+#define get_SB2_MUXPAD2_reg   (*((volatile unsigned int*) SB2_MUXPAD2_reg))
+#define SB2_MUXPAD2_inst_adr                                                         "0x0042"
+#define SB2_MUXPAD2_inst                                                             0x0042
+#define SB2_MUXPAD2_tp1_clk_shift                                                    (22)
+#define SB2_MUXPAD2_tp1_clk_mask                                                     (0x00C00000)
+#define SB2_MUXPAD2_tp1_clk(data)                                                    (0x00C00000&((data)<<22))
+#define SB2_MUXPAD2_tp1_clk_src(data)                                                ((0x00C00000&(data))>>22)
+#define SB2_MUXPAD2_get_tp1_clk(data)                                                ((0x00C00000&(data))>>22)
+#define SB2_MUXPAD2_tp1_valid_shift                                                  (20)
+#define SB2_MUXPAD2_tp1_valid_mask                                                   (0x00300000)
+#define SB2_MUXPAD2_tp1_valid(data)                                                  (0x00300000&((data)<<20))
+#define SB2_MUXPAD2_tp1_valid_src(data)                                              ((0x00300000&(data))>>20)
+#define SB2_MUXPAD2_get_tp1_valid(data)                                              ((0x00300000&(data))>>20)
+#define SB2_MUXPAD2_tp1_sync_shift                                                   (18)
+#define SB2_MUXPAD2_tp1_sync_mask                                                    (0x000C0000)
+#define SB2_MUXPAD2_tp1_sync(data)                                                   (0x000C0000&((data)<<18))
+#define SB2_MUXPAD2_tp1_sync_src(data)                                               ((0x000C0000&(data))>>18)
+#define SB2_MUXPAD2_get_tp1_sync(data)                                               ((0x000C0000&(data))>>18)
+#define SB2_MUXPAD2_tp1_data_shift                                                   (16)
+#define SB2_MUXPAD2_tp1_data_mask                                                    (0x00030000)
+#define SB2_MUXPAD2_tp1_data(data)                                                   (0x00030000&((data)<<16))
+#define SB2_MUXPAD2_tp1_data_src(data)                                               ((0x00030000&(data))>>16)
+#define SB2_MUXPAD2_get_tp1_data(data)                                               ((0x00030000&(data))>>16)
+#define SB2_MUXPAD2_tp0_clk_shift                                                    (9)
+#define SB2_MUXPAD2_tp0_clk_mask                                                     (0x00000E00)
+#define SB2_MUXPAD2_tp0_clk(data)                                                    (0x00000E00&((data)<<9))
+#define SB2_MUXPAD2_tp0_clk_src(data)                                                ((0x00000E00&(data))>>9)
+#define SB2_MUXPAD2_get_tp0_clk(data)                                                ((0x00000E00&(data))>>9)
+#define SB2_MUXPAD2_tp0_valid_shift                                                  (6)
+#define SB2_MUXPAD2_tp0_valid_mask                                                   (0x000001C0)
+#define SB2_MUXPAD2_tp0_valid(data)                                                  (0x000001C0&((data)<<6))
+#define SB2_MUXPAD2_tp0_valid_src(data)                                              ((0x000001C0&(data))>>6)
+#define SB2_MUXPAD2_get_tp0_valid(data)                                              ((0x000001C0&(data))>>6)
+#define SB2_MUXPAD2_tp0_sync_shift                                                   (3)
+#define SB2_MUXPAD2_tp0_sync_mask                                                    (0x00000038)
+#define SB2_MUXPAD2_tp0_sync(data)                                                   (0x00000038&((data)<<3))
+#define SB2_MUXPAD2_tp0_sync_src(data)                                               ((0x00000038&(data))>>3)
+#define SB2_MUXPAD2_get_tp0_sync(data)                                               ((0x00000038&(data))>>3)
+#define SB2_MUXPAD2_tp0_data_shift                                                   (0)
+#define SB2_MUXPAD2_tp0_data_mask                                                    (0x00000007)
+#define SB2_MUXPAD2_tp0_data(data)                                                   (0x00000007&((data)<<0))
+#define SB2_MUXPAD2_tp0_data_src(data)                                               ((0x00000007&(data))>>0)
+#define SB2_MUXPAD2_get_tp0_data(data)                                               ((0x00000007&(data))>>0)
+
+
+#define SB2_MUXPAD3                                                                  0x9801A90C
+#define SB2_MUXPAD3_reg_addr                                                         "0xD801A90C"
+#define SB2_MUXPAD3_reg                                                              0xD801A90C
+#define set_SB2_MUXPAD3_reg(data)   (*((volatile unsigned int*) SB2_MUXPAD3_reg)=data)
+#define get_SB2_MUXPAD3_reg   (*((volatile unsigned int*) SB2_MUXPAD3_reg))
+#define SB2_MUXPAD3_inst_adr                                                         "0x0043"
+#define SB2_MUXPAD3_inst                                                             0x0043
+#define SB2_MUXPAD3_sensor_cko_0_shift                                               (30)
+#define SB2_MUXPAD3_sensor_cko_0_mask                                                (0xC0000000)
+#define SB2_MUXPAD3_sensor_cko_0(data)                                               (0xC0000000&((data)<<30))
+#define SB2_MUXPAD3_sensor_cko_0_src(data)                                           ((0xC0000000&(data))>>30)
+#define SB2_MUXPAD3_get_sensor_cko_0(data)                                           ((0xC0000000&(data))>>30)
+#define SB2_MUXPAD3_sensor_cko_1_shift                                               (28)
+#define SB2_MUXPAD3_sensor_cko_1_mask                                                (0x30000000)
+#define SB2_MUXPAD3_sensor_cko_1(data)                                               (0x30000000&((data)<<28))
+#define SB2_MUXPAD3_sensor_cko_1_src(data)                                           ((0x30000000&(data))>>28)
+#define SB2_MUXPAD3_get_sensor_cko_1(data)                                           ((0x30000000&(data))>>28)
+#define SB2_MUXPAD3_sensor_rst_shift                                                 (26)
+#define SB2_MUXPAD3_sensor_rst_mask                                                  (0x0C000000)
+#define SB2_MUXPAD3_sensor_rst(data)                                                 (0x0C000000&((data)<<26))
+#define SB2_MUXPAD3_sensor_rst_src(data)                                             ((0x0C000000&(data))>>26)
+#define SB2_MUXPAD3_get_sensor_rst(data)                                             ((0x0C000000&(data))>>26)
+#define SB2_MUXPAD3_sensor_stb_0_shift                                               (24)
+#define SB2_MUXPAD3_sensor_stb_0_mask                                                (0x03000000)
+#define SB2_MUXPAD3_sensor_stb_0(data)                                               (0x03000000&((data)<<24))
+#define SB2_MUXPAD3_sensor_stb_0_src(data)                                           ((0x03000000&(data))>>24)
+#define SB2_MUXPAD3_get_sensor_stb_0(data)                                           ((0x03000000&(data))>>24)
+#define SB2_MUXPAD3_sensor_stb_1_shift                                               (22)
+#define SB2_MUXPAD3_sensor_stb_1_mask                                                (0x00C00000)
+#define SB2_MUXPAD3_sensor_stb_1(data)                                               (0x00C00000&((data)<<22))
+#define SB2_MUXPAD3_sensor_stb_1_src(data)                                           ((0x00C00000&(data))>>22)
+#define SB2_MUXPAD3_get_sensor_stb_1(data)                                           ((0x00C00000&(data))>>22)
+#define SB2_MUXPAD3_ejtag_scpu_loc_shift                                             (20)
+#define SB2_MUXPAD3_ejtag_scpu_loc_mask                                              (0x00300000)
+#define SB2_MUXPAD3_ejtag_scpu_loc(data)                                             (0x00300000&((data)<<20))
+#define SB2_MUXPAD3_ejtag_scpu_loc_src(data)                                         ((0x00300000&(data))>>20)
+#define SB2_MUXPAD3_get_ejtag_scpu_loc(data)                                         ((0x00300000&(data))>>20)
+#define SB2_MUXPAD3_hi_loc_shift                                                     (18)
+#define SB2_MUXPAD3_hi_loc_mask                                                      (0x000C0000)
+#define SB2_MUXPAD3_hi_loc(data)                                                     (0x000C0000&((data)<<18))
+#define SB2_MUXPAD3_hi_loc_src(data)                                                 ((0x000C0000&(data))>>18)
+#define SB2_MUXPAD3_get_hi_loc(data)                                                 ((0x000C0000&(data))>>18)
+#define SB2_MUXPAD3_usb_id_shift                                                     (16)
+#define SB2_MUXPAD3_usb_id_mask                                                      (0x00030000)
+#define SB2_MUXPAD3_usb_id(data)                                                     (0x00030000&((data)<<16))
+#define SB2_MUXPAD3_usb_id_src(data)                                                 ((0x00030000&(data))>>16)
+#define SB2_MUXPAD3_get_usb_id(data)                                                 ((0x00030000&(data))>>16)
+#define SB2_MUXPAD3_i2c_scl_5_shift                                                  (10)
+#define SB2_MUXPAD3_i2c_scl_5_mask                                                   (0x00000C00)
+#define SB2_MUXPAD3_i2c_scl_5(data)                                                  (0x00000C00&((data)<<10))
+#define SB2_MUXPAD3_i2c_scl_5_src(data)                                              ((0x00000C00&(data))>>10)
+#define SB2_MUXPAD3_get_i2c_scl_5(data)                                              ((0x00000C00&(data))>>10)
+#define SB2_MUXPAD3_i2c_sda_5_shift                                                  (8)
+#define SB2_MUXPAD3_i2c_sda_5_mask                                                   (0x00000300)
+#define SB2_MUXPAD3_i2c_sda_5(data)                                                  (0x00000300&((data)<<8))
+#define SB2_MUXPAD3_i2c_sda_5_src(data)                                              ((0x00000300&(data))>>8)
+#define SB2_MUXPAD3_get_i2c_sda_5(data)                                              ((0x00000300&(data))>>8)
+#define SB2_MUXPAD3_i2c_scl_4_shift                                                  (6)
+#define SB2_MUXPAD3_i2c_scl_4_mask                                                   (0x000000C0)
+#define SB2_MUXPAD3_i2c_scl_4(data)                                                  (0x000000C0&((data)<<6))
+#define SB2_MUXPAD3_i2c_scl_4_src(data)                                              ((0x000000C0&(data))>>6)
+#define SB2_MUXPAD3_get_i2c_scl_4(data)                                              ((0x000000C0&(data))>>6)
+#define SB2_MUXPAD3_i2c_sda_4_shift                                                  (4)
+#define SB2_MUXPAD3_i2c_sda_4_mask                                                   (0x00000030)
+#define SB2_MUXPAD3_i2c_sda_4(data)                                                  (0x00000030&((data)<<4))
+#define SB2_MUXPAD3_i2c_sda_4_src(data)                                              ((0x00000030&(data))>>4)
+#define SB2_MUXPAD3_get_i2c_sda_4(data)                                              ((0x00000030&(data))>>4)
+
+
+#define SB2_MUXPAD4                                                                  0x9801A910
+#define SB2_MUXPAD4_reg_addr                                                         "0xD801A910"
+#define SB2_MUXPAD4_reg                                                              0xD801A910
+#define set_SB2_MUXPAD4_reg(data)   (*((volatile unsigned int*) SB2_MUXPAD4_reg)=data)
+#define get_SB2_MUXPAD4_reg   (*((volatile unsigned int*) SB2_MUXPAD4_reg))
+#define SB2_MUXPAD4_inst_adr                                                         "0x0044"
+#define SB2_MUXPAD4_inst                                                             0x0044
+#define SB2_MUXPAD4_gpio_9_shift                                                     (22)
+#define SB2_MUXPAD4_gpio_9_mask                                                      (0x00C00000)
+#define SB2_MUXPAD4_gpio_9(data)                                                     (0x00C00000&((data)<<22))
+#define SB2_MUXPAD4_gpio_9_src(data)                                                 ((0x00C00000&(data))>>22)
+#define SB2_MUXPAD4_get_gpio_9(data)                                                 ((0x00C00000&(data))>>22)
+#define SB2_MUXPAD4_gpio_8_shift                                                     (20)
+#define SB2_MUXPAD4_gpio_8_mask                                                      (0x00300000)
+#define SB2_MUXPAD4_gpio_8(data)                                                     (0x00300000&((data)<<20))
+#define SB2_MUXPAD4_gpio_8_src(data)                                                 ((0x00300000&(data))>>20)
+#define SB2_MUXPAD4_get_gpio_8(data)                                                 ((0x00300000&(data))>>20)
+#define SB2_MUXPAD4_gpio_7_shift                                                     (18)
+#define SB2_MUXPAD4_gpio_7_mask                                                      (0x000C0000)
+#define SB2_MUXPAD4_gpio_7(data)                                                     (0x000C0000&((data)<<18))
+#define SB2_MUXPAD4_gpio_7_src(data)                                                 ((0x000C0000&(data))>>18)
+#define SB2_MUXPAD4_get_gpio_7(data)                                                 ((0x000C0000&(data))>>18)
+#define SB2_MUXPAD4_gpio_6_shift                                                     (16)
+#define SB2_MUXPAD4_gpio_6_mask                                                      (0x00030000)
+#define SB2_MUXPAD4_gpio_6(data)                                                     (0x00030000&((data)<<16))
+#define SB2_MUXPAD4_gpio_6_src(data)                                                 ((0x00030000&(data))>>16)
+#define SB2_MUXPAD4_get_gpio_6(data)                                                 ((0x00030000&(data))>>16)
+#define SB2_MUXPAD4_gpio_5_shift                                                     (14)
+#define SB2_MUXPAD4_gpio_5_mask                                                      (0x0000C000)
+#define SB2_MUXPAD4_gpio_5(data)                                                     (0x0000C000&((data)<<14))
+#define SB2_MUXPAD4_gpio_5_src(data)                                                 ((0x0000C000&(data))>>14)
+#define SB2_MUXPAD4_get_gpio_5(data)                                                 ((0x0000C000&(data))>>14)
+#define SB2_MUXPAD4_gpio_4_shift                                                     (12)
+#define SB2_MUXPAD4_gpio_4_mask                                                      (0x00003000)
+#define SB2_MUXPAD4_gpio_4(data)                                                     (0x00003000&((data)<<12))
+#define SB2_MUXPAD4_gpio_4_src(data)                                                 ((0x00003000&(data))>>12)
+#define SB2_MUXPAD4_get_gpio_4(data)                                                 ((0x00003000&(data))>>12)
+#define SB2_MUXPAD4_gpio_3_shift                                                     (9)
+#define SB2_MUXPAD4_gpio_3_mask                                                      (0x00000E00)
+#define SB2_MUXPAD4_gpio_3(data)                                                     (0x00000E00&((data)<<9))
+#define SB2_MUXPAD4_gpio_3_src(data)                                                 ((0x00000E00&(data))>>9)
+#define SB2_MUXPAD4_get_gpio_3(data)                                                 ((0x00000E00&(data))>>9)
+#define SB2_MUXPAD4_gpio_2_shift                                                     (6)
+#define SB2_MUXPAD4_gpio_2_mask                                                      (0x000001C0)
+#define SB2_MUXPAD4_gpio_2(data)                                                     (0x000001C0&((data)<<6))
+#define SB2_MUXPAD4_gpio_2_src(data)                                                 ((0x000001C0&(data))>>6)
+#define SB2_MUXPAD4_get_gpio_2(data)                                                 ((0x000001C0&(data))>>6)
+#define SB2_MUXPAD4_gpio_1_shift                                                     (3)
+#define SB2_MUXPAD4_gpio_1_mask                                                      (0x00000038)
+#define SB2_MUXPAD4_gpio_1(data)                                                     (0x00000038&((data)<<3))
+#define SB2_MUXPAD4_gpio_1_src(data)                                                 ((0x00000038&(data))>>3)
+#define SB2_MUXPAD4_get_gpio_1(data)                                                 ((0x00000038&(data))>>3)
+#define SB2_MUXPAD4_gpio_0_shift                                                     (0)
+#define SB2_MUXPAD4_gpio_0_mask                                                      (0x00000007)
+#define SB2_MUXPAD4_gpio_0(data)                                                     (0x00000007&((data)<<0))
+#define SB2_MUXPAD4_gpio_0_src(data)                                                 ((0x00000007&(data))>>0)
+#define SB2_MUXPAD4_get_gpio_0(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define SB2_MUXPAD5                                                                  0x9801A914
+#define SB2_MUXPAD5_reg_addr                                                         "0xD801A914"
+#define SB2_MUXPAD5_reg                                                              0xD801A914
+#define set_SB2_MUXPAD5_reg(data)   (*((volatile unsigned int*) SB2_MUXPAD5_reg)=data)
+#define get_SB2_MUXPAD5_reg   (*((volatile unsigned int*) SB2_MUXPAD5_reg))
+#define SB2_MUXPAD5_inst_adr                                                         "0x0045"
+#define SB2_MUXPAD5_inst                                                             0x0045
+#define SB2_MUXPAD5_tp1_loc_shift                                                    (8)
+#define SB2_MUXPAD5_tp1_loc_mask                                                     (0x00000100)
+#define SB2_MUXPAD5_tp1_loc(data)                                                    (0x00000100&((data)<<8))
+#define SB2_MUXPAD5_tp1_loc_src(data)                                                ((0x00000100&(data))>>8)
+#define SB2_MUXPAD5_get_tp1_loc(data)                                                ((0x00000100&(data))>>8)
+#define SB2_MUXPAD5_tp0_loc_shift                                                    (7)
+#define SB2_MUXPAD5_tp0_loc_mask                                                     (0x00000080)
+#define SB2_MUXPAD5_tp0_loc(data)                                                    (0x00000080&((data)<<7))
+#define SB2_MUXPAD5_tp0_loc_src(data)                                                ((0x00000080&(data))>>7)
+#define SB2_MUXPAD5_get_tp0_loc(data)                                                ((0x00000080&(data))>>7)
+#define SB2_MUXPAD5_debug_p2s_enable_shift                                           (6)
+#define SB2_MUXPAD5_debug_p2s_enable_mask                                            (0x00000040)
+#define SB2_MUXPAD5_debug_p2s_enable(data)                                           (0x00000040&((data)<<6))
+#define SB2_MUXPAD5_debug_p2s_enable_src(data)                                       ((0x00000040&(data))>>6)
+#define SB2_MUXPAD5_get_debug_p2s_enable(data)                                       ((0x00000040&(data))>>6)
+#define SB2_MUXPAD5_ur1_loc_shift                                                    (4)
+#define SB2_MUXPAD5_ur1_loc_mask                                                     (0x00000030)
+#define SB2_MUXPAD5_ur1_loc(data)                                                    (0x00000030&((data)<<4))
+#define SB2_MUXPAD5_ur1_loc_src(data)                                                ((0x00000030&(data))>>4)
+#define SB2_MUXPAD5_get_ur1_loc(data)                                                ((0x00000030&(data))>>4)
+#define SB2_MUXPAD5_ao_loc_shift                                                     (2)
+#define SB2_MUXPAD5_ao_loc_mask                                                      (0x0000000C)
+#define SB2_MUXPAD5_ao_loc(data)                                                     (0x0000000C&((data)<<2))
+#define SB2_MUXPAD5_ao_loc_src(data)                                                 ((0x0000000C&(data))>>2)
+#define SB2_MUXPAD5_get_ao_loc(data)                                                 ((0x0000000C&(data))>>2)
+#define SB2_MUXPAD5_arm_trace_dbg_en_shift                                           (1)
+#define SB2_MUXPAD5_arm_trace_dbg_en_mask                                            (0x00000002)
+#define SB2_MUXPAD5_arm_trace_dbg_en(data)                                           (0x00000002&((data)<<1))
+#define SB2_MUXPAD5_arm_trace_dbg_en_src(data)                                       ((0x00000002&(data))>>1)
+#define SB2_MUXPAD5_get_arm_trace_dbg_en(data)                                       ((0x00000002&(data))>>1)
+#define SB2_MUXPAD5_sf_en_shift                                                      (0)
+#define SB2_MUXPAD5_sf_en_mask                                                       (0x00000001)
+#define SB2_MUXPAD5_sf_en(data)                                                      (0x00000001&((data)<<0))
+#define SB2_MUXPAD5_sf_en_src(data)                                                  ((0x00000001&(data))>>0)
+#define SB2_MUXPAD5_get_sf_en(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define SB2_PFUNC_TP0                                                                0x9801A928
+#define SB2_PFUNC_TP0_reg_addr                                                       "0xD801A928"
+#define SB2_PFUNC_TP0_reg                                                            0xD801A928
+#define set_SB2_PFUNC_TP0_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_TP0_reg)=data)
+#define get_SB2_PFUNC_TP0_reg   (*((volatile unsigned int*) SB2_PFUNC_TP0_reg))
+#define SB2_PFUNC_TP0_inst_adr                                                       "0x004A"
+#define SB2_PFUNC_TP0_inst                                                           0x004A
+#define SB2_PFUNC_TP0_tp0_data_smt_shift                                             (15)
+#define SB2_PFUNC_TP0_tp0_data_smt_mask                                              (0x00008000)
+#define SB2_PFUNC_TP0_tp0_data_smt(data)                                             (0x00008000&((data)<<15))
+#define SB2_PFUNC_TP0_tp0_data_smt_src(data)                                         ((0x00008000&(data))>>15)
+#define SB2_PFUNC_TP0_get_tp0_data_smt(data)                                         ((0x00008000&(data))>>15)
+#define SB2_PFUNC_TP0_tp0_data_e2_shift                                              (14)
+#define SB2_PFUNC_TP0_tp0_data_e2_mask                                               (0x00004000)
+#define SB2_PFUNC_TP0_tp0_data_e2(data)                                              (0x00004000&((data)<<14))
+#define SB2_PFUNC_TP0_tp0_data_e2_src(data)                                          ((0x00004000&(data))>>14)
+#define SB2_PFUNC_TP0_get_tp0_data_e2(data)                                          ((0x00004000&(data))>>14)
+#define SB2_PFUNC_TP0_tp0_data_pud_en_shift                                          (13)
+#define SB2_PFUNC_TP0_tp0_data_pud_en_mask                                           (0x00002000)
+#define SB2_PFUNC_TP0_tp0_data_pud_en(data)                                          (0x00002000&((data)<<13))
+#define SB2_PFUNC_TP0_tp0_data_pud_en_src(data)                                      ((0x00002000&(data))>>13)
+#define SB2_PFUNC_TP0_get_tp0_data_pud_en(data)                                      ((0x00002000&(data))>>13)
+#define SB2_PFUNC_TP0_tp0_data_pud_sel_shift                                         (12)
+#define SB2_PFUNC_TP0_tp0_data_pud_sel_mask                                          (0x00001000)
+#define SB2_PFUNC_TP0_tp0_data_pud_sel(data)                                         (0x00001000&((data)<<12))
+#define SB2_PFUNC_TP0_tp0_data_pud_sel_src(data)                                     ((0x00001000&(data))>>12)
+#define SB2_PFUNC_TP0_get_tp0_data_pud_sel(data)                                     ((0x00001000&(data))>>12)
+#define SB2_PFUNC_TP0_tp0_valid_smt_shift                                            (11)
+#define SB2_PFUNC_TP0_tp0_valid_smt_mask                                             (0x00000800)
+#define SB2_PFUNC_TP0_tp0_valid_smt(data)                                            (0x00000800&((data)<<11))
+#define SB2_PFUNC_TP0_tp0_valid_smt_src(data)                                        ((0x00000800&(data))>>11)
+#define SB2_PFUNC_TP0_get_tp0_valid_smt(data)                                        ((0x00000800&(data))>>11)
+#define SB2_PFUNC_TP0_tp0_valid_e2_shift                                             (10)
+#define SB2_PFUNC_TP0_tp0_valid_e2_mask                                              (0x00000400)
+#define SB2_PFUNC_TP0_tp0_valid_e2(data)                                             (0x00000400&((data)<<10))
+#define SB2_PFUNC_TP0_tp0_valid_e2_src(data)                                         ((0x00000400&(data))>>10)
+#define SB2_PFUNC_TP0_get_tp0_valid_e2(data)                                         ((0x00000400&(data))>>10)
+#define SB2_PFUNC_TP0_tp0_valid_pud_en_shift                                         (9)
+#define SB2_PFUNC_TP0_tp0_valid_pud_en_mask                                          (0x00000200)
+#define SB2_PFUNC_TP0_tp0_valid_pud_en(data)                                         (0x00000200&((data)<<9))
+#define SB2_PFUNC_TP0_tp0_valid_pud_en_src(data)                                     ((0x00000200&(data))>>9)
+#define SB2_PFUNC_TP0_get_tp0_valid_pud_en(data)                                     ((0x00000200&(data))>>9)
+#define SB2_PFUNC_TP0_tp0_valid_pud_sel_shift                                        (8)
+#define SB2_PFUNC_TP0_tp0_valid_pud_sel_mask                                         (0x00000100)
+#define SB2_PFUNC_TP0_tp0_valid_pud_sel(data)                                        (0x00000100&((data)<<8))
+#define SB2_PFUNC_TP0_tp0_valid_pud_sel_src(data)                                    ((0x00000100&(data))>>8)
+#define SB2_PFUNC_TP0_get_tp0_valid_pud_sel(data)                                    ((0x00000100&(data))>>8)
+#define SB2_PFUNC_TP0_tp0_sync_smt_shift                                             (7)
+#define SB2_PFUNC_TP0_tp0_sync_smt_mask                                              (0x00000080)
+#define SB2_PFUNC_TP0_tp0_sync_smt(data)                                             (0x00000080&((data)<<7))
+#define SB2_PFUNC_TP0_tp0_sync_smt_src(data)                                         ((0x00000080&(data))>>7)
+#define SB2_PFUNC_TP0_get_tp0_sync_smt(data)                                         ((0x00000080&(data))>>7)
+#define SB2_PFUNC_TP0_tp0_sync_e2_shift                                              (6)
+#define SB2_PFUNC_TP0_tp0_sync_e2_mask                                               (0x00000040)
+#define SB2_PFUNC_TP0_tp0_sync_e2(data)                                              (0x00000040&((data)<<6))
+#define SB2_PFUNC_TP0_tp0_sync_e2_src(data)                                          ((0x00000040&(data))>>6)
+#define SB2_PFUNC_TP0_get_tp0_sync_e2(data)                                          ((0x00000040&(data))>>6)
+#define SB2_PFUNC_TP0_tp0_sync_pud_en_shift                                          (5)
+#define SB2_PFUNC_TP0_tp0_sync_pud_en_mask                                           (0x00000020)
+#define SB2_PFUNC_TP0_tp0_sync_pud_en(data)                                          (0x00000020&((data)<<5))
+#define SB2_PFUNC_TP0_tp0_sync_pud_en_src(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_TP0_get_tp0_sync_pud_en(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_TP0_tp0_sync_pud_sel_shift                                         (4)
+#define SB2_PFUNC_TP0_tp0_sync_pud_sel_mask                                          (0x00000010)
+#define SB2_PFUNC_TP0_tp0_sync_pud_sel(data)                                         (0x00000010&((data)<<4))
+#define SB2_PFUNC_TP0_tp0_sync_pud_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define SB2_PFUNC_TP0_get_tp0_sync_pud_sel(data)                                     ((0x00000010&(data))>>4)
+#define SB2_PFUNC_TP0_tp0_clk_smt_shift                                              (3)
+#define SB2_PFUNC_TP0_tp0_clk_smt_mask                                               (0x00000008)
+#define SB2_PFUNC_TP0_tp0_clk_smt(data)                                              (0x00000008&((data)<<3))
+#define SB2_PFUNC_TP0_tp0_clk_smt_src(data)                                          ((0x00000008&(data))>>3)
+#define SB2_PFUNC_TP0_get_tp0_clk_smt(data)                                          ((0x00000008&(data))>>3)
+#define SB2_PFUNC_TP0_tp0_clk_e2_shift                                               (2)
+#define SB2_PFUNC_TP0_tp0_clk_e2_mask                                                (0x00000004)
+#define SB2_PFUNC_TP0_tp0_clk_e2(data)                                               (0x00000004&((data)<<2))
+#define SB2_PFUNC_TP0_tp0_clk_e2_src(data)                                           ((0x00000004&(data))>>2)
+#define SB2_PFUNC_TP0_get_tp0_clk_e2(data)                                           ((0x00000004&(data))>>2)
+#define SB2_PFUNC_TP0_tp0_clk_pud_en_shift                                           (1)
+#define SB2_PFUNC_TP0_tp0_clk_pud_en_mask                                            (0x00000002)
+#define SB2_PFUNC_TP0_tp0_clk_pud_en(data)                                           (0x00000002&((data)<<1))
+#define SB2_PFUNC_TP0_tp0_clk_pud_en_src(data)                                       ((0x00000002&(data))>>1)
+#define SB2_PFUNC_TP0_get_tp0_clk_pud_en(data)                                       ((0x00000002&(data))>>1)
+#define SB2_PFUNC_TP0_tp0_clk_pud_sel_shift                                          (0)
+#define SB2_PFUNC_TP0_tp0_clk_pud_sel_mask                                           (0x00000001)
+#define SB2_PFUNC_TP0_tp0_clk_pud_sel(data)                                          (0x00000001&((data)<<0))
+#define SB2_PFUNC_TP0_tp0_clk_pud_sel_src(data)                                      ((0x00000001&(data))>>0)
+#define SB2_PFUNC_TP0_get_tp0_clk_pud_sel(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SB2_PFUNC_TP1                                                                0x9801A92C
+#define SB2_PFUNC_TP1_reg_addr                                                       "0xD801A92C"
+#define SB2_PFUNC_TP1_reg                                                            0xD801A92C
+#define set_SB2_PFUNC_TP1_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_TP1_reg)=data)
+#define get_SB2_PFUNC_TP1_reg   (*((volatile unsigned int*) SB2_PFUNC_TP1_reg))
+#define SB2_PFUNC_TP1_inst_adr                                                       "0x004B"
+#define SB2_PFUNC_TP1_inst                                                           0x004B
+#define SB2_PFUNC_TP1_tp1_data_smt_shift                                             (15)
+#define SB2_PFUNC_TP1_tp1_data_smt_mask                                              (0x00008000)
+#define SB2_PFUNC_TP1_tp1_data_smt(data)                                             (0x00008000&((data)<<15))
+#define SB2_PFUNC_TP1_tp1_data_smt_src(data)                                         ((0x00008000&(data))>>15)
+#define SB2_PFUNC_TP1_get_tp1_data_smt(data)                                         ((0x00008000&(data))>>15)
+#define SB2_PFUNC_TP1_tp1_data_e2_shift                                              (14)
+#define SB2_PFUNC_TP1_tp1_data_e2_mask                                               (0x00004000)
+#define SB2_PFUNC_TP1_tp1_data_e2(data)                                              (0x00004000&((data)<<14))
+#define SB2_PFUNC_TP1_tp1_data_e2_src(data)                                          ((0x00004000&(data))>>14)
+#define SB2_PFUNC_TP1_get_tp1_data_e2(data)                                          ((0x00004000&(data))>>14)
+#define SB2_PFUNC_TP1_tp1_data_pud_en_shift                                          (13)
+#define SB2_PFUNC_TP1_tp1_data_pud_en_mask                                           (0x00002000)
+#define SB2_PFUNC_TP1_tp1_data_pud_en(data)                                          (0x00002000&((data)<<13))
+#define SB2_PFUNC_TP1_tp1_data_pud_en_src(data)                                      ((0x00002000&(data))>>13)
+#define SB2_PFUNC_TP1_get_tp1_data_pud_en(data)                                      ((0x00002000&(data))>>13)
+#define SB2_PFUNC_TP1_tp1_data_pud_sel_shift                                         (12)
+#define SB2_PFUNC_TP1_tp1_data_pud_sel_mask                                          (0x00001000)
+#define SB2_PFUNC_TP1_tp1_data_pud_sel(data)                                         (0x00001000&((data)<<12))
+#define SB2_PFUNC_TP1_tp1_data_pud_sel_src(data)                                     ((0x00001000&(data))>>12)
+#define SB2_PFUNC_TP1_get_tp1_data_pud_sel(data)                                     ((0x00001000&(data))>>12)
+#define SB2_PFUNC_TP1_tp1_valid_smt_shift                                            (11)
+#define SB2_PFUNC_TP1_tp1_valid_smt_mask                                             (0x00000800)
+#define SB2_PFUNC_TP1_tp1_valid_smt(data)                                            (0x00000800&((data)<<11))
+#define SB2_PFUNC_TP1_tp1_valid_smt_src(data)                                        ((0x00000800&(data))>>11)
+#define SB2_PFUNC_TP1_get_tp1_valid_smt(data)                                        ((0x00000800&(data))>>11)
+#define SB2_PFUNC_TP1_tp1_valid_e2_shift                                             (10)
+#define SB2_PFUNC_TP1_tp1_valid_e2_mask                                              (0x00000400)
+#define SB2_PFUNC_TP1_tp1_valid_e2(data)                                             (0x00000400&((data)<<10))
+#define SB2_PFUNC_TP1_tp1_valid_e2_src(data)                                         ((0x00000400&(data))>>10)
+#define SB2_PFUNC_TP1_get_tp1_valid_e2(data)                                         ((0x00000400&(data))>>10)
+#define SB2_PFUNC_TP1_tp1_valid_pud_en_shift                                         (9)
+#define SB2_PFUNC_TP1_tp1_valid_pud_en_mask                                          (0x00000200)
+#define SB2_PFUNC_TP1_tp1_valid_pud_en(data)                                         (0x00000200&((data)<<9))
+#define SB2_PFUNC_TP1_tp1_valid_pud_en_src(data)                                     ((0x00000200&(data))>>9)
+#define SB2_PFUNC_TP1_get_tp1_valid_pud_en(data)                                     ((0x00000200&(data))>>9)
+#define SB2_PFUNC_TP1_tp1_valid_pud_sel_shift                                        (8)
+#define SB2_PFUNC_TP1_tp1_valid_pud_sel_mask                                         (0x00000100)
+#define SB2_PFUNC_TP1_tp1_valid_pud_sel(data)                                        (0x00000100&((data)<<8))
+#define SB2_PFUNC_TP1_tp1_valid_pud_sel_src(data)                                    ((0x00000100&(data))>>8)
+#define SB2_PFUNC_TP1_get_tp1_valid_pud_sel(data)                                    ((0x00000100&(data))>>8)
+#define SB2_PFUNC_TP1_tp1_sync_smt_shift                                             (7)
+#define SB2_PFUNC_TP1_tp1_sync_smt_mask                                              (0x00000080)
+#define SB2_PFUNC_TP1_tp1_sync_smt(data)                                             (0x00000080&((data)<<7))
+#define SB2_PFUNC_TP1_tp1_sync_smt_src(data)                                         ((0x00000080&(data))>>7)
+#define SB2_PFUNC_TP1_get_tp1_sync_smt(data)                                         ((0x00000080&(data))>>7)
+#define SB2_PFUNC_TP1_tp1_sync_e2_shift                                              (6)
+#define SB2_PFUNC_TP1_tp1_sync_e2_mask                                               (0x00000040)
+#define SB2_PFUNC_TP1_tp1_sync_e2(data)                                              (0x00000040&((data)<<6))
+#define SB2_PFUNC_TP1_tp1_sync_e2_src(data)                                          ((0x00000040&(data))>>6)
+#define SB2_PFUNC_TP1_get_tp1_sync_e2(data)                                          ((0x00000040&(data))>>6)
+#define SB2_PFUNC_TP1_tp1_sync_pud_en_shift                                          (5)
+#define SB2_PFUNC_TP1_tp1_sync_pud_en_mask                                           (0x00000020)
+#define SB2_PFUNC_TP1_tp1_sync_pud_en(data)                                          (0x00000020&((data)<<5))
+#define SB2_PFUNC_TP1_tp1_sync_pud_en_src(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_TP1_get_tp1_sync_pud_en(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_TP1_tp1_sync_pud_sel_shift                                         (4)
+#define SB2_PFUNC_TP1_tp1_sync_pud_sel_mask                                          (0x00000010)
+#define SB2_PFUNC_TP1_tp1_sync_pud_sel(data)                                         (0x00000010&((data)<<4))
+#define SB2_PFUNC_TP1_tp1_sync_pud_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define SB2_PFUNC_TP1_get_tp1_sync_pud_sel(data)                                     ((0x00000010&(data))>>4)
+#define SB2_PFUNC_TP1_tp1_clk_smt_shift                                              (3)
+#define SB2_PFUNC_TP1_tp1_clk_smt_mask                                               (0x00000008)
+#define SB2_PFUNC_TP1_tp1_clk_smt(data)                                              (0x00000008&((data)<<3))
+#define SB2_PFUNC_TP1_tp1_clk_smt_src(data)                                          ((0x00000008&(data))>>3)
+#define SB2_PFUNC_TP1_get_tp1_clk_smt(data)                                          ((0x00000008&(data))>>3)
+#define SB2_PFUNC_TP1_tp1_clk_e2_shift                                               (2)
+#define SB2_PFUNC_TP1_tp1_clk_e2_mask                                                (0x00000004)
+#define SB2_PFUNC_TP1_tp1_clk_e2(data)                                               (0x00000004&((data)<<2))
+#define SB2_PFUNC_TP1_tp1_clk_e2_src(data)                                           ((0x00000004&(data))>>2)
+#define SB2_PFUNC_TP1_get_tp1_clk_e2(data)                                           ((0x00000004&(data))>>2)
+#define SB2_PFUNC_TP1_tp1_clk_pud_en_shift                                           (1)
+#define SB2_PFUNC_TP1_tp1_clk_pud_en_mask                                            (0x00000002)
+#define SB2_PFUNC_TP1_tp1_clk_pud_en(data)                                           (0x00000002&((data)<<1))
+#define SB2_PFUNC_TP1_tp1_clk_pud_en_src(data)                                       ((0x00000002&(data))>>1)
+#define SB2_PFUNC_TP1_get_tp1_clk_pud_en(data)                                       ((0x00000002&(data))>>1)
+#define SB2_PFUNC_TP1_tp1_clk_pud_sel_shift                                          (0)
+#define SB2_PFUNC_TP1_tp1_clk_pud_sel_mask                                           (0x00000001)
+#define SB2_PFUNC_TP1_tp1_clk_pud_sel(data)                                          (0x00000001&((data)<<0))
+#define SB2_PFUNC_TP1_tp1_clk_pud_sel_src(data)                                      ((0x00000001&(data))>>0)
+#define SB2_PFUNC_TP1_get_tp1_clk_pud_sel(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SB2_PFUNC_MISC0                                                              0x9801A930
+#define SB2_PFUNC_MISC0_reg_addr                                                     "0xD801A930"
+#define SB2_PFUNC_MISC0_reg                                                          0xD801A930
+#define set_SB2_PFUNC_MISC0_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_MISC0_reg)=data)
+#define get_SB2_PFUNC_MISC0_reg   (*((volatile unsigned int*) SB2_PFUNC_MISC0_reg))
+#define SB2_PFUNC_MISC0_inst_adr                                                     "0x004C"
+#define SB2_PFUNC_MISC0_inst                                                         0x004C
+#define SB2_PFUNC_MISC0_i2c_scl_5_smt_shift                                          (23)
+#define SB2_PFUNC_MISC0_i2c_scl_5_smt_mask                                           (0x00800000)
+#define SB2_PFUNC_MISC0_i2c_scl_5_smt(data)                                          (0x00800000&((data)<<23))
+#define SB2_PFUNC_MISC0_i2c_scl_5_smt_src(data)                                      ((0x00800000&(data))>>23)
+#define SB2_PFUNC_MISC0_get_i2c_scl_5_smt(data)                                      ((0x00800000&(data))>>23)
+#define SB2_PFUNC_MISC0_i2c_scl_5_e2_shift                                           (22)
+#define SB2_PFUNC_MISC0_i2c_scl_5_e2_mask                                            (0x00400000)
+#define SB2_PFUNC_MISC0_i2c_scl_5_e2(data)                                           (0x00400000&((data)<<22))
+#define SB2_PFUNC_MISC0_i2c_scl_5_e2_src(data)                                       ((0x00400000&(data))>>22)
+#define SB2_PFUNC_MISC0_get_i2c_scl_5_e2(data)                                       ((0x00400000&(data))>>22)
+#define SB2_PFUNC_MISC0_i2c_scl_5_pud_en_shift                                       (21)
+#define SB2_PFUNC_MISC0_i2c_scl_5_pud_en_mask                                        (0x00200000)
+#define SB2_PFUNC_MISC0_i2c_scl_5_pud_en(data)                                       (0x00200000&((data)<<21))
+#define SB2_PFUNC_MISC0_i2c_scl_5_pud_en_src(data)                                   ((0x00200000&(data))>>21)
+#define SB2_PFUNC_MISC0_get_i2c_scl_5_pud_en(data)                                   ((0x00200000&(data))>>21)
+#define SB2_PFUNC_MISC0_i2c_scl_5_pud_sel_shift                                      (20)
+#define SB2_PFUNC_MISC0_i2c_scl_5_pud_sel_mask                                       (0x00100000)
+#define SB2_PFUNC_MISC0_i2c_scl_5_pud_sel(data)                                      (0x00100000&((data)<<20))
+#define SB2_PFUNC_MISC0_i2c_scl_5_pud_sel_src(data)                                  ((0x00100000&(data))>>20)
+#define SB2_PFUNC_MISC0_get_i2c_scl_5_pud_sel(data)                                  ((0x00100000&(data))>>20)
+#define SB2_PFUNC_MISC0_i2c_sda_5_smt_shift                                          (19)
+#define SB2_PFUNC_MISC0_i2c_sda_5_smt_mask                                           (0x00080000)
+#define SB2_PFUNC_MISC0_i2c_sda_5_smt(data)                                          (0x00080000&((data)<<19))
+#define SB2_PFUNC_MISC0_i2c_sda_5_smt_src(data)                                      ((0x00080000&(data))>>19)
+#define SB2_PFUNC_MISC0_get_i2c_sda_5_smt(data)                                      ((0x00080000&(data))>>19)
+#define SB2_PFUNC_MISC0_i2c_sda_5_e2_shift                                           (18)
+#define SB2_PFUNC_MISC0_i2c_sda_5_e2_mask                                            (0x00040000)
+#define SB2_PFUNC_MISC0_i2c_sda_5_e2(data)                                           (0x00040000&((data)<<18))
+#define SB2_PFUNC_MISC0_i2c_sda_5_e2_src(data)                                       ((0x00040000&(data))>>18)
+#define SB2_PFUNC_MISC0_get_i2c_sda_5_e2(data)                                       ((0x00040000&(data))>>18)
+#define SB2_PFUNC_MISC0_i2c_sda_5_pud_en_shift                                       (17)
+#define SB2_PFUNC_MISC0_i2c_sda_5_pud_en_mask                                        (0x00020000)
+#define SB2_PFUNC_MISC0_i2c_sda_5_pud_en(data)                                       (0x00020000&((data)<<17))
+#define SB2_PFUNC_MISC0_i2c_sda_5_pud_en_src(data)                                   ((0x00020000&(data))>>17)
+#define SB2_PFUNC_MISC0_get_i2c_sda_5_pud_en(data)                                   ((0x00020000&(data))>>17)
+#define SB2_PFUNC_MISC0_i2c_sda_5_pud_sel_shift                                      (16)
+#define SB2_PFUNC_MISC0_i2c_sda_5_pud_sel_mask                                       (0x00010000)
+#define SB2_PFUNC_MISC0_i2c_sda_5_pud_sel(data)                                      (0x00010000&((data)<<16))
+#define SB2_PFUNC_MISC0_i2c_sda_5_pud_sel_src(data)                                  ((0x00010000&(data))>>16)
+#define SB2_PFUNC_MISC0_get_i2c_sda_5_pud_sel(data)                                  ((0x00010000&(data))>>16)
+#define SB2_PFUNC_MISC0_i2c_scl_4_smt_shift                                          (15)
+#define SB2_PFUNC_MISC0_i2c_scl_4_smt_mask                                           (0x00008000)
+#define SB2_PFUNC_MISC0_i2c_scl_4_smt(data)                                          (0x00008000&((data)<<15))
+#define SB2_PFUNC_MISC0_i2c_scl_4_smt_src(data)                                      ((0x00008000&(data))>>15)
+#define SB2_PFUNC_MISC0_get_i2c_scl_4_smt(data)                                      ((0x00008000&(data))>>15)
+#define SB2_PFUNC_MISC0_i2c_scl_4_e2_shift                                           (14)
+#define SB2_PFUNC_MISC0_i2c_scl_4_e2_mask                                            (0x00004000)
+#define SB2_PFUNC_MISC0_i2c_scl_4_e2(data)                                           (0x00004000&((data)<<14))
+#define SB2_PFUNC_MISC0_i2c_scl_4_e2_src(data)                                       ((0x00004000&(data))>>14)
+#define SB2_PFUNC_MISC0_get_i2c_scl_4_e2(data)                                       ((0x00004000&(data))>>14)
+#define SB2_PFUNC_MISC0_i2c_scl_4_pud_en_shift                                       (13)
+#define SB2_PFUNC_MISC0_i2c_scl_4_pud_en_mask                                        (0x00002000)
+#define SB2_PFUNC_MISC0_i2c_scl_4_pud_en(data)                                       (0x00002000&((data)<<13))
+#define SB2_PFUNC_MISC0_i2c_scl_4_pud_en_src(data)                                   ((0x00002000&(data))>>13)
+#define SB2_PFUNC_MISC0_get_i2c_scl_4_pud_en(data)                                   ((0x00002000&(data))>>13)
+#define SB2_PFUNC_MISC0_i2c_scl_4_pud_sel_shift                                      (12)
+#define SB2_PFUNC_MISC0_i2c_scl_4_pud_sel_mask                                       (0x00001000)
+#define SB2_PFUNC_MISC0_i2c_scl_4_pud_sel(data)                                      (0x00001000&((data)<<12))
+#define SB2_PFUNC_MISC0_i2c_scl_4_pud_sel_src(data)                                  ((0x00001000&(data))>>12)
+#define SB2_PFUNC_MISC0_get_i2c_scl_4_pud_sel(data)                                  ((0x00001000&(data))>>12)
+#define SB2_PFUNC_MISC0_i2c_sda_4_smt_shift                                          (11)
+#define SB2_PFUNC_MISC0_i2c_sda_4_smt_mask                                           (0x00000800)
+#define SB2_PFUNC_MISC0_i2c_sda_4_smt(data)                                          (0x00000800&((data)<<11))
+#define SB2_PFUNC_MISC0_i2c_sda_4_smt_src(data)                                      ((0x00000800&(data))>>11)
+#define SB2_PFUNC_MISC0_get_i2c_sda_4_smt(data)                                      ((0x00000800&(data))>>11)
+#define SB2_PFUNC_MISC0_i2c_sda_4_e2_shift                                           (10)
+#define SB2_PFUNC_MISC0_i2c_sda_4_e2_mask                                            (0x00000400)
+#define SB2_PFUNC_MISC0_i2c_sda_4_e2(data)                                           (0x00000400&((data)<<10))
+#define SB2_PFUNC_MISC0_i2c_sda_4_e2_src(data)                                       ((0x00000400&(data))>>10)
+#define SB2_PFUNC_MISC0_get_i2c_sda_4_e2(data)                                       ((0x00000400&(data))>>10)
+#define SB2_PFUNC_MISC0_i2c_sda_4_pud_en_shift                                       (9)
+#define SB2_PFUNC_MISC0_i2c_sda_4_pud_en_mask                                        (0x00000200)
+#define SB2_PFUNC_MISC0_i2c_sda_4_pud_en(data)                                       (0x00000200&((data)<<9))
+#define SB2_PFUNC_MISC0_i2c_sda_4_pud_en_src(data)                                   ((0x00000200&(data))>>9)
+#define SB2_PFUNC_MISC0_get_i2c_sda_4_pud_en(data)                                   ((0x00000200&(data))>>9)
+#define SB2_PFUNC_MISC0_i2c_sda_4_pud_sel_shift                                      (8)
+#define SB2_PFUNC_MISC0_i2c_sda_4_pud_sel_mask                                       (0x00000100)
+#define SB2_PFUNC_MISC0_i2c_sda_4_pud_sel(data)                                      (0x00000100&((data)<<8))
+#define SB2_PFUNC_MISC0_i2c_sda_4_pud_sel_src(data)                                  ((0x00000100&(data))>>8)
+#define SB2_PFUNC_MISC0_get_i2c_sda_4_pud_sel(data)                                  ((0x00000100&(data))>>8)
+
+
+#define SB2_PFUNC_MISC1                                                              0x9801A934
+#define SB2_PFUNC_MISC1_reg_addr                                                     "0xD801A934"
+#define SB2_PFUNC_MISC1_reg                                                          0xD801A934
+#define set_SB2_PFUNC_MISC1_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_MISC1_reg)=data)
+#define get_SB2_PFUNC_MISC1_reg   (*((volatile unsigned int*) SB2_PFUNC_MISC1_reg))
+#define SB2_PFUNC_MISC1_inst_adr                                                     "0x004D"
+#define SB2_PFUNC_MISC1_inst                                                         0x004D
+#define SB2_PFUNC_MISC1_gpio_7_smt_shift                                             (31)
+#define SB2_PFUNC_MISC1_gpio_7_smt_mask                                              (0x80000000)
+#define SB2_PFUNC_MISC1_gpio_7_smt(data)                                             (0x80000000&((data)<<31))
+#define SB2_PFUNC_MISC1_gpio_7_smt_src(data)                                         ((0x80000000&(data))>>31)
+#define SB2_PFUNC_MISC1_get_gpio_7_smt(data)                                         ((0x80000000&(data))>>31)
+#define SB2_PFUNC_MISC1_gpio_7_e2_shift                                              (30)
+#define SB2_PFUNC_MISC1_gpio_7_e2_mask                                               (0x40000000)
+#define SB2_PFUNC_MISC1_gpio_7_e2(data)                                              (0x40000000&((data)<<30))
+#define SB2_PFUNC_MISC1_gpio_7_e2_src(data)                                          ((0x40000000&(data))>>30)
+#define SB2_PFUNC_MISC1_get_gpio_7_e2(data)                                          ((0x40000000&(data))>>30)
+#define SB2_PFUNC_MISC1_gpio_7_pud_en_shift                                          (29)
+#define SB2_PFUNC_MISC1_gpio_7_pud_en_mask                                           (0x20000000)
+#define SB2_PFUNC_MISC1_gpio_7_pud_en(data)                                          (0x20000000&((data)<<29))
+#define SB2_PFUNC_MISC1_gpio_7_pud_en_src(data)                                      ((0x20000000&(data))>>29)
+#define SB2_PFUNC_MISC1_get_gpio_7_pud_en(data)                                      ((0x20000000&(data))>>29)
+#define SB2_PFUNC_MISC1_gpio_7_pud_sel_shift                                         (28)
+#define SB2_PFUNC_MISC1_gpio_7_pud_sel_mask                                          (0x10000000)
+#define SB2_PFUNC_MISC1_gpio_7_pud_sel(data)                                         (0x10000000&((data)<<28))
+#define SB2_PFUNC_MISC1_gpio_7_pud_sel_src(data)                                     ((0x10000000&(data))>>28)
+#define SB2_PFUNC_MISC1_get_gpio_7_pud_sel(data)                                     ((0x10000000&(data))>>28)
+#define SB2_PFUNC_MISC1_gpio_6_smt_shift                                             (27)
+#define SB2_PFUNC_MISC1_gpio_6_smt_mask                                              (0x08000000)
+#define SB2_PFUNC_MISC1_gpio_6_smt(data)                                             (0x08000000&((data)<<27))
+#define SB2_PFUNC_MISC1_gpio_6_smt_src(data)                                         ((0x08000000&(data))>>27)
+#define SB2_PFUNC_MISC1_get_gpio_6_smt(data)                                         ((0x08000000&(data))>>27)
+#define SB2_PFUNC_MISC1_gpio_6_e2_shift                                              (26)
+#define SB2_PFUNC_MISC1_gpio_6_e2_mask                                               (0x04000000)
+#define SB2_PFUNC_MISC1_gpio_6_e2(data)                                              (0x04000000&((data)<<26))
+#define SB2_PFUNC_MISC1_gpio_6_e2_src(data)                                          ((0x04000000&(data))>>26)
+#define SB2_PFUNC_MISC1_get_gpio_6_e2(data)                                          ((0x04000000&(data))>>26)
+#define SB2_PFUNC_MISC1_gpio_6_pud_en_shift                                          (25)
+#define SB2_PFUNC_MISC1_gpio_6_pud_en_mask                                           (0x02000000)
+#define SB2_PFUNC_MISC1_gpio_6_pud_en(data)                                          (0x02000000&((data)<<25))
+#define SB2_PFUNC_MISC1_gpio_6_pud_en_src(data)                                      ((0x02000000&(data))>>25)
+#define SB2_PFUNC_MISC1_get_gpio_6_pud_en(data)                                      ((0x02000000&(data))>>25)
+#define SB2_PFUNC_MISC1_gpio_6_pud_sel_shift                                         (24)
+#define SB2_PFUNC_MISC1_gpio_6_pud_sel_mask                                          (0x01000000)
+#define SB2_PFUNC_MISC1_gpio_6_pud_sel(data)                                         (0x01000000&((data)<<24))
+#define SB2_PFUNC_MISC1_gpio_6_pud_sel_src(data)                                     ((0x01000000&(data))>>24)
+#define SB2_PFUNC_MISC1_get_gpio_6_pud_sel(data)                                     ((0x01000000&(data))>>24)
+#define SB2_PFUNC_MISC1_gpio_5_smt_shift                                             (23)
+#define SB2_PFUNC_MISC1_gpio_5_smt_mask                                              (0x00800000)
+#define SB2_PFUNC_MISC1_gpio_5_smt(data)                                             (0x00800000&((data)<<23))
+#define SB2_PFUNC_MISC1_gpio_5_smt_src(data)                                         ((0x00800000&(data))>>23)
+#define SB2_PFUNC_MISC1_get_gpio_5_smt(data)                                         ((0x00800000&(data))>>23)
+#define SB2_PFUNC_MISC1_gpio_5_e2_shift                                              (22)
+#define SB2_PFUNC_MISC1_gpio_5_e2_mask                                               (0x00400000)
+#define SB2_PFUNC_MISC1_gpio_5_e2(data)                                              (0x00400000&((data)<<22))
+#define SB2_PFUNC_MISC1_gpio_5_e2_src(data)                                          ((0x00400000&(data))>>22)
+#define SB2_PFUNC_MISC1_get_gpio_5_e2(data)                                          ((0x00400000&(data))>>22)
+#define SB2_PFUNC_MISC1_gpio_5_pud_en_shift                                          (21)
+#define SB2_PFUNC_MISC1_gpio_5_pud_en_mask                                           (0x00200000)
+#define SB2_PFUNC_MISC1_gpio_5_pud_en(data)                                          (0x00200000&((data)<<21))
+#define SB2_PFUNC_MISC1_gpio_5_pud_en_src(data)                                      ((0x00200000&(data))>>21)
+#define SB2_PFUNC_MISC1_get_gpio_5_pud_en(data)                                      ((0x00200000&(data))>>21)
+#define SB2_PFUNC_MISC1_gpio_5_pud_sel_shift                                         (20)
+#define SB2_PFUNC_MISC1_gpio_5_pud_sel_mask                                          (0x00100000)
+#define SB2_PFUNC_MISC1_gpio_5_pud_sel(data)                                         (0x00100000&((data)<<20))
+#define SB2_PFUNC_MISC1_gpio_5_pud_sel_src(data)                                     ((0x00100000&(data))>>20)
+#define SB2_PFUNC_MISC1_get_gpio_5_pud_sel(data)                                     ((0x00100000&(data))>>20)
+#define SB2_PFUNC_MISC1_gpio_4_smt_shift                                             (19)
+#define SB2_PFUNC_MISC1_gpio_4_smt_mask                                              (0x00080000)
+#define SB2_PFUNC_MISC1_gpio_4_smt(data)                                             (0x00080000&((data)<<19))
+#define SB2_PFUNC_MISC1_gpio_4_smt_src(data)                                         ((0x00080000&(data))>>19)
+#define SB2_PFUNC_MISC1_get_gpio_4_smt(data)                                         ((0x00080000&(data))>>19)
+#define SB2_PFUNC_MISC1_gpio_4_e2_shift                                              (18)
+#define SB2_PFUNC_MISC1_gpio_4_e2_mask                                               (0x00040000)
+#define SB2_PFUNC_MISC1_gpio_4_e2(data)                                              (0x00040000&((data)<<18))
+#define SB2_PFUNC_MISC1_gpio_4_e2_src(data)                                          ((0x00040000&(data))>>18)
+#define SB2_PFUNC_MISC1_get_gpio_4_e2(data)                                          ((0x00040000&(data))>>18)
+#define SB2_PFUNC_MISC1_gpio_4_pud_en_shift                                          (17)
+#define SB2_PFUNC_MISC1_gpio_4_pud_en_mask                                           (0x00020000)
+#define SB2_PFUNC_MISC1_gpio_4_pud_en(data)                                          (0x00020000&((data)<<17))
+#define SB2_PFUNC_MISC1_gpio_4_pud_en_src(data)                                      ((0x00020000&(data))>>17)
+#define SB2_PFUNC_MISC1_get_gpio_4_pud_en(data)                                      ((0x00020000&(data))>>17)
+#define SB2_PFUNC_MISC1_gpio_4_pud_sel_shift                                         (16)
+#define SB2_PFUNC_MISC1_gpio_4_pud_sel_mask                                          (0x00010000)
+#define SB2_PFUNC_MISC1_gpio_4_pud_sel(data)                                         (0x00010000&((data)<<16))
+#define SB2_PFUNC_MISC1_gpio_4_pud_sel_src(data)                                     ((0x00010000&(data))>>16)
+#define SB2_PFUNC_MISC1_get_gpio_4_pud_sel(data)                                     ((0x00010000&(data))>>16)
+#define SB2_PFUNC_MISC1_gpio_3_smt_shift                                             (15)
+#define SB2_PFUNC_MISC1_gpio_3_smt_mask                                              (0x00008000)
+#define SB2_PFUNC_MISC1_gpio_3_smt(data)                                             (0x00008000&((data)<<15))
+#define SB2_PFUNC_MISC1_gpio_3_smt_src(data)                                         ((0x00008000&(data))>>15)
+#define SB2_PFUNC_MISC1_get_gpio_3_smt(data)                                         ((0x00008000&(data))>>15)
+#define SB2_PFUNC_MISC1_gpio_3_e2_shift                                              (14)
+#define SB2_PFUNC_MISC1_gpio_3_e2_mask                                               (0x00004000)
+#define SB2_PFUNC_MISC1_gpio_3_e2(data)                                              (0x00004000&((data)<<14))
+#define SB2_PFUNC_MISC1_gpio_3_e2_src(data)                                          ((0x00004000&(data))>>14)
+#define SB2_PFUNC_MISC1_get_gpio_3_e2(data)                                          ((0x00004000&(data))>>14)
+#define SB2_PFUNC_MISC1_gpio_3_pud_en_shift                                          (13)
+#define SB2_PFUNC_MISC1_gpio_3_pud_en_mask                                           (0x00002000)
+#define SB2_PFUNC_MISC1_gpio_3_pud_en(data)                                          (0x00002000&((data)<<13))
+#define SB2_PFUNC_MISC1_gpio_3_pud_en_src(data)                                      ((0x00002000&(data))>>13)
+#define SB2_PFUNC_MISC1_get_gpio_3_pud_en(data)                                      ((0x00002000&(data))>>13)
+#define SB2_PFUNC_MISC1_gpio_3_pud_sel_shift                                         (12)
+#define SB2_PFUNC_MISC1_gpio_3_pud_sel_mask                                          (0x00001000)
+#define SB2_PFUNC_MISC1_gpio_3_pud_sel(data)                                         (0x00001000&((data)<<12))
+#define SB2_PFUNC_MISC1_gpio_3_pud_sel_src(data)                                     ((0x00001000&(data))>>12)
+#define SB2_PFUNC_MISC1_get_gpio_3_pud_sel(data)                                     ((0x00001000&(data))>>12)
+#define SB2_PFUNC_MISC1_gpio_2_smt_shift                                             (11)
+#define SB2_PFUNC_MISC1_gpio_2_smt_mask                                              (0x00000800)
+#define SB2_PFUNC_MISC1_gpio_2_smt(data)                                             (0x00000800&((data)<<11))
+#define SB2_PFUNC_MISC1_gpio_2_smt_src(data)                                         ((0x00000800&(data))>>11)
+#define SB2_PFUNC_MISC1_get_gpio_2_smt(data)                                         ((0x00000800&(data))>>11)
+#define SB2_PFUNC_MISC1_gpio_2_e2_shift                                              (10)
+#define SB2_PFUNC_MISC1_gpio_2_e2_mask                                               (0x00000400)
+#define SB2_PFUNC_MISC1_gpio_2_e2(data)                                              (0x00000400&((data)<<10))
+#define SB2_PFUNC_MISC1_gpio_2_e2_src(data)                                          ((0x00000400&(data))>>10)
+#define SB2_PFUNC_MISC1_get_gpio_2_e2(data)                                          ((0x00000400&(data))>>10)
+#define SB2_PFUNC_MISC1_gpio_2_pud_en_shift                                          (9)
+#define SB2_PFUNC_MISC1_gpio_2_pud_en_mask                                           (0x00000200)
+#define SB2_PFUNC_MISC1_gpio_2_pud_en(data)                                          (0x00000200&((data)<<9))
+#define SB2_PFUNC_MISC1_gpio_2_pud_en_src(data)                                      ((0x00000200&(data))>>9)
+#define SB2_PFUNC_MISC1_get_gpio_2_pud_en(data)                                      ((0x00000200&(data))>>9)
+#define SB2_PFUNC_MISC1_gpio_2_pud_sel_shift                                         (8)
+#define SB2_PFUNC_MISC1_gpio_2_pud_sel_mask                                          (0x00000100)
+#define SB2_PFUNC_MISC1_gpio_2_pud_sel(data)                                         (0x00000100&((data)<<8))
+#define SB2_PFUNC_MISC1_gpio_2_pud_sel_src(data)                                     ((0x00000100&(data))>>8)
+#define SB2_PFUNC_MISC1_get_gpio_2_pud_sel(data)                                     ((0x00000100&(data))>>8)
+#define SB2_PFUNC_MISC1_gpio_1_smt_shift                                             (7)
+#define SB2_PFUNC_MISC1_gpio_1_smt_mask                                              (0x00000080)
+#define SB2_PFUNC_MISC1_gpio_1_smt(data)                                             (0x00000080&((data)<<7))
+#define SB2_PFUNC_MISC1_gpio_1_smt_src(data)                                         ((0x00000080&(data))>>7)
+#define SB2_PFUNC_MISC1_get_gpio_1_smt(data)                                         ((0x00000080&(data))>>7)
+#define SB2_PFUNC_MISC1_gpio_1_e2_shift                                              (6)
+#define SB2_PFUNC_MISC1_gpio_1_e2_mask                                               (0x00000040)
+#define SB2_PFUNC_MISC1_gpio_1_e2(data)                                              (0x00000040&((data)<<6))
+#define SB2_PFUNC_MISC1_gpio_1_e2_src(data)                                          ((0x00000040&(data))>>6)
+#define SB2_PFUNC_MISC1_get_gpio_1_e2(data)                                          ((0x00000040&(data))>>6)
+#define SB2_PFUNC_MISC1_gpio_1_pud_en_shift                                          (5)
+#define SB2_PFUNC_MISC1_gpio_1_pud_en_mask                                           (0x00000020)
+#define SB2_PFUNC_MISC1_gpio_1_pud_en(data)                                          (0x00000020&((data)<<5))
+#define SB2_PFUNC_MISC1_gpio_1_pud_en_src(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_MISC1_get_gpio_1_pud_en(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_MISC1_gpio_1_pud_sel_shift                                         (4)
+#define SB2_PFUNC_MISC1_gpio_1_pud_sel_mask                                          (0x00000010)
+#define SB2_PFUNC_MISC1_gpio_1_pud_sel(data)                                         (0x00000010&((data)<<4))
+#define SB2_PFUNC_MISC1_gpio_1_pud_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define SB2_PFUNC_MISC1_get_gpio_1_pud_sel(data)                                     ((0x00000010&(data))>>4)
+#define SB2_PFUNC_MISC1_gpio_0_smt_shift                                             (3)
+#define SB2_PFUNC_MISC1_gpio_0_smt_mask                                              (0x00000008)
+#define SB2_PFUNC_MISC1_gpio_0_smt(data)                                             (0x00000008&((data)<<3))
+#define SB2_PFUNC_MISC1_gpio_0_smt_src(data)                                         ((0x00000008&(data))>>3)
+#define SB2_PFUNC_MISC1_get_gpio_0_smt(data)                                         ((0x00000008&(data))>>3)
+#define SB2_PFUNC_MISC1_gpio_0_e2_shift                                              (2)
+#define SB2_PFUNC_MISC1_gpio_0_e2_mask                                               (0x00000004)
+#define SB2_PFUNC_MISC1_gpio_0_e2(data)                                              (0x00000004&((data)<<2))
+#define SB2_PFUNC_MISC1_gpio_0_e2_src(data)                                          ((0x00000004&(data))>>2)
+#define SB2_PFUNC_MISC1_get_gpio_0_e2(data)                                          ((0x00000004&(data))>>2)
+#define SB2_PFUNC_MISC1_gpio_0_pud_en_shift                                          (1)
+#define SB2_PFUNC_MISC1_gpio_0_pud_en_mask                                           (0x00000002)
+#define SB2_PFUNC_MISC1_gpio_0_pud_en(data)                                          (0x00000002&((data)<<1))
+#define SB2_PFUNC_MISC1_gpio_0_pud_en_src(data)                                      ((0x00000002&(data))>>1)
+#define SB2_PFUNC_MISC1_get_gpio_0_pud_en(data)                                      ((0x00000002&(data))>>1)
+#define SB2_PFUNC_MISC1_gpio_0_pud_sel_shift                                         (0)
+#define SB2_PFUNC_MISC1_gpio_0_pud_sel_mask                                          (0x00000001)
+#define SB2_PFUNC_MISC1_gpio_0_pud_sel(data)                                         (0x00000001&((data)<<0))
+#define SB2_PFUNC_MISC1_gpio_0_pud_sel_src(data)                                     ((0x00000001&(data))>>0)
+#define SB2_PFUNC_MISC1_get_gpio_0_pud_sel(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SB2_PFUNC_MISC2                                                              0x9801A938
+#define SB2_PFUNC_MISC2_reg_addr                                                     "0xD801A938"
+#define SB2_PFUNC_MISC2_reg                                                          0xD801A938
+#define set_SB2_PFUNC_MISC2_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_MISC2_reg)=data)
+#define get_SB2_PFUNC_MISC2_reg   (*((volatile unsigned int*) SB2_PFUNC_MISC2_reg))
+#define SB2_PFUNC_MISC2_inst_adr                                                     "0x004E"
+#define SB2_PFUNC_MISC2_inst                                                         0x004E
+#define SB2_PFUNC_MISC2_sensor_cko1_smt_shift                                        (31)
+#define SB2_PFUNC_MISC2_sensor_cko1_smt_mask                                         (0x80000000)
+#define SB2_PFUNC_MISC2_sensor_cko1_smt(data)                                        (0x80000000&((data)<<31))
+#define SB2_PFUNC_MISC2_sensor_cko1_smt_src(data)                                    ((0x80000000&(data))>>31)
+#define SB2_PFUNC_MISC2_get_sensor_cko1_smt(data)                                    ((0x80000000&(data))>>31)
+#define SB2_PFUNC_MISC2_sensor_cko1_e2_shift                                         (30)
+#define SB2_PFUNC_MISC2_sensor_cko1_e2_mask                                          (0x40000000)
+#define SB2_PFUNC_MISC2_sensor_cko1_e2(data)                                         (0x40000000&((data)<<30))
+#define SB2_PFUNC_MISC2_sensor_cko1_e2_src(data)                                     ((0x40000000&(data))>>30)
+#define SB2_PFUNC_MISC2_get_sensor_cko1_e2(data)                                     ((0x40000000&(data))>>30)
+#define SB2_PFUNC_MISC2_sensor_cko1_pud_en_shift                                     (29)
+#define SB2_PFUNC_MISC2_sensor_cko1_pud_en_mask                                      (0x20000000)
+#define SB2_PFUNC_MISC2_sensor_cko1_pud_en(data)                                     (0x20000000&((data)<<29))
+#define SB2_PFUNC_MISC2_sensor_cko1_pud_en_src(data)                                 ((0x20000000&(data))>>29)
+#define SB2_PFUNC_MISC2_get_sensor_cko1_pud_en(data)                                 ((0x20000000&(data))>>29)
+#define SB2_PFUNC_MISC2_sensor_cko1_pud_sel_shift                                    (28)
+#define SB2_PFUNC_MISC2_sensor_cko1_pud_sel_mask                                     (0x10000000)
+#define SB2_PFUNC_MISC2_sensor_cko1_pud_sel(data)                                    (0x10000000&((data)<<28))
+#define SB2_PFUNC_MISC2_sensor_cko1_pud_sel_src(data)                                ((0x10000000&(data))>>28)
+#define SB2_PFUNC_MISC2_get_sensor_cko1_pud_sel(data)                                ((0x10000000&(data))>>28)
+#define SB2_PFUNC_MISC2_sensor_cko0_smt_shift                                        (27)
+#define SB2_PFUNC_MISC2_sensor_cko0_smt_mask                                         (0x08000000)
+#define SB2_PFUNC_MISC2_sensor_cko0_smt(data)                                        (0x08000000&((data)<<27))
+#define SB2_PFUNC_MISC2_sensor_cko0_smt_src(data)                                    ((0x08000000&(data))>>27)
+#define SB2_PFUNC_MISC2_get_sensor_cko0_smt(data)                                    ((0x08000000&(data))>>27)
+#define SB2_PFUNC_MISC2_sensor_cko0_e2_shift                                         (26)
+#define SB2_PFUNC_MISC2_sensor_cko0_e2_mask                                          (0x04000000)
+#define SB2_PFUNC_MISC2_sensor_cko0_e2(data)                                         (0x04000000&((data)<<26))
+#define SB2_PFUNC_MISC2_sensor_cko0_e2_src(data)                                     ((0x04000000&(data))>>26)
+#define SB2_PFUNC_MISC2_get_sensor_cko0_e2(data)                                     ((0x04000000&(data))>>26)
+#define SB2_PFUNC_MISC2_sensor_cko0_pud_en_shift                                     (25)
+#define SB2_PFUNC_MISC2_sensor_cko0_pud_en_mask                                      (0x02000000)
+#define SB2_PFUNC_MISC2_sensor_cko0_pud_en(data)                                     (0x02000000&((data)<<25))
+#define SB2_PFUNC_MISC2_sensor_cko0_pud_en_src(data)                                 ((0x02000000&(data))>>25)
+#define SB2_PFUNC_MISC2_get_sensor_cko0_pud_en(data)                                 ((0x02000000&(data))>>25)
+#define SB2_PFUNC_MISC2_sensor_cko0_pud_sel_shift                                    (24)
+#define SB2_PFUNC_MISC2_sensor_cko0_pud_sel_mask                                     (0x01000000)
+#define SB2_PFUNC_MISC2_sensor_cko0_pud_sel(data)                                    (0x01000000&((data)<<24))
+#define SB2_PFUNC_MISC2_sensor_cko0_pud_sel_src(data)                                ((0x01000000&(data))>>24)
+#define SB2_PFUNC_MISC2_get_sensor_cko0_pud_sel(data)                                ((0x01000000&(data))>>24)
+#define SB2_PFUNC_MISC2_sensor_rst_smt_shift                                         (23)
+#define SB2_PFUNC_MISC2_sensor_rst_smt_mask                                          (0x00800000)
+#define SB2_PFUNC_MISC2_sensor_rst_smt(data)                                         (0x00800000&((data)<<23))
+#define SB2_PFUNC_MISC2_sensor_rst_smt_src(data)                                     ((0x00800000&(data))>>23)
+#define SB2_PFUNC_MISC2_get_sensor_rst_smt(data)                                     ((0x00800000&(data))>>23)
+#define SB2_PFUNC_MISC2_sensor_rst_e2_shift                                          (22)
+#define SB2_PFUNC_MISC2_sensor_rst_e2_mask                                           (0x00400000)
+#define SB2_PFUNC_MISC2_sensor_rst_e2(data)                                          (0x00400000&((data)<<22))
+#define SB2_PFUNC_MISC2_sensor_rst_e2_src(data)                                      ((0x00400000&(data))>>22)
+#define SB2_PFUNC_MISC2_get_sensor_rst_e2(data)                                      ((0x00400000&(data))>>22)
+#define SB2_PFUNC_MISC2_sensor_rst_pud_en_shift                                      (21)
+#define SB2_PFUNC_MISC2_sensor_rst_pud_en_mask                                       (0x00200000)
+#define SB2_PFUNC_MISC2_sensor_rst_pud_en(data)                                      (0x00200000&((data)<<21))
+#define SB2_PFUNC_MISC2_sensor_rst_pud_en_src(data)                                  ((0x00200000&(data))>>21)
+#define SB2_PFUNC_MISC2_get_sensor_rst_pud_en(data)                                  ((0x00200000&(data))>>21)
+#define SB2_PFUNC_MISC2_sensor_rst_pud_sel_shift                                     (20)
+#define SB2_PFUNC_MISC2_sensor_rst_pud_sel_mask                                      (0x00100000)
+#define SB2_PFUNC_MISC2_sensor_rst_pud_sel(data)                                     (0x00100000&((data)<<20))
+#define SB2_PFUNC_MISC2_sensor_rst_pud_sel_src(data)                                 ((0x00100000&(data))>>20)
+#define SB2_PFUNC_MISC2_get_sensor_rst_pud_sel(data)                                 ((0x00100000&(data))>>20)
+#define SB2_PFUNC_MISC2_sensor_stb1_smt_shift                                        (19)
+#define SB2_PFUNC_MISC2_sensor_stb1_smt_mask                                         (0x00080000)
+#define SB2_PFUNC_MISC2_sensor_stb1_smt(data)                                        (0x00080000&((data)<<19))
+#define SB2_PFUNC_MISC2_sensor_stb1_smt_src(data)                                    ((0x00080000&(data))>>19)
+#define SB2_PFUNC_MISC2_get_sensor_stb1_smt(data)                                    ((0x00080000&(data))>>19)
+#define SB2_PFUNC_MISC2_sensor_stb1_e2_shift                                         (18)
+#define SB2_PFUNC_MISC2_sensor_stb1_e2_mask                                          (0x00040000)
+#define SB2_PFUNC_MISC2_sensor_stb1_e2(data)                                         (0x00040000&((data)<<18))
+#define SB2_PFUNC_MISC2_sensor_stb1_e2_src(data)                                     ((0x00040000&(data))>>18)
+#define SB2_PFUNC_MISC2_get_sensor_stb1_e2(data)                                     ((0x00040000&(data))>>18)
+#define SB2_PFUNC_MISC2_sensor_stb1_pud_en_shift                                     (17)
+#define SB2_PFUNC_MISC2_sensor_stb1_pud_en_mask                                      (0x00020000)
+#define SB2_PFUNC_MISC2_sensor_stb1_pud_en(data)                                     (0x00020000&((data)<<17))
+#define SB2_PFUNC_MISC2_sensor_stb1_pud_en_src(data)                                 ((0x00020000&(data))>>17)
+#define SB2_PFUNC_MISC2_get_sensor_stb1_pud_en(data)                                 ((0x00020000&(data))>>17)
+#define SB2_PFUNC_MISC2_sensor_stb1_pud_sel_shift                                    (16)
+#define SB2_PFUNC_MISC2_sensor_stb1_pud_sel_mask                                     (0x00010000)
+#define SB2_PFUNC_MISC2_sensor_stb1_pud_sel(data)                                    (0x00010000&((data)<<16))
+#define SB2_PFUNC_MISC2_sensor_stb1_pud_sel_src(data)                                ((0x00010000&(data))>>16)
+#define SB2_PFUNC_MISC2_get_sensor_stb1_pud_sel(data)                                ((0x00010000&(data))>>16)
+#define SB2_PFUNC_MISC2_sensor_stb0_smt_shift                                        (15)
+#define SB2_PFUNC_MISC2_sensor_stb0_smt_mask                                         (0x00008000)
+#define SB2_PFUNC_MISC2_sensor_stb0_smt(data)                                        (0x00008000&((data)<<15))
+#define SB2_PFUNC_MISC2_sensor_stb0_smt_src(data)                                    ((0x00008000&(data))>>15)
+#define SB2_PFUNC_MISC2_get_sensor_stb0_smt(data)                                    ((0x00008000&(data))>>15)
+#define SB2_PFUNC_MISC2_sensor_stb0_e2_shift                                         (14)
+#define SB2_PFUNC_MISC2_sensor_stb0_e2_mask                                          (0x00004000)
+#define SB2_PFUNC_MISC2_sensor_stb0_e2(data)                                         (0x00004000&((data)<<14))
+#define SB2_PFUNC_MISC2_sensor_stb0_e2_src(data)                                     ((0x00004000&(data))>>14)
+#define SB2_PFUNC_MISC2_get_sensor_stb0_e2(data)                                     ((0x00004000&(data))>>14)
+#define SB2_PFUNC_MISC2_sensor_stb0_pud_en_shift                                     (13)
+#define SB2_PFUNC_MISC2_sensor_stb0_pud_en_mask                                      (0x00002000)
+#define SB2_PFUNC_MISC2_sensor_stb0_pud_en(data)                                     (0x00002000&((data)<<13))
+#define SB2_PFUNC_MISC2_sensor_stb0_pud_en_src(data)                                 ((0x00002000&(data))>>13)
+#define SB2_PFUNC_MISC2_get_sensor_stb0_pud_en(data)                                 ((0x00002000&(data))>>13)
+#define SB2_PFUNC_MISC2_sensor_stb0_pud_sel_shift                                    (12)
+#define SB2_PFUNC_MISC2_sensor_stb0_pud_sel_mask                                     (0x00001000)
+#define SB2_PFUNC_MISC2_sensor_stb0_pud_sel(data)                                    (0x00001000&((data)<<12))
+#define SB2_PFUNC_MISC2_sensor_stb0_pud_sel_src(data)                                ((0x00001000&(data))>>12)
+#define SB2_PFUNC_MISC2_get_sensor_stb0_pud_sel(data)                                ((0x00001000&(data))>>12)
+#define SB2_PFUNC_MISC2_usb_id_smt_shift                                             (11)
+#define SB2_PFUNC_MISC2_usb_id_smt_mask                                              (0x00000800)
+#define SB2_PFUNC_MISC2_usb_id_smt(data)                                             (0x00000800&((data)<<11))
+#define SB2_PFUNC_MISC2_usb_id_smt_src(data)                                         ((0x00000800&(data))>>11)
+#define SB2_PFUNC_MISC2_get_usb_id_smt(data)                                         ((0x00000800&(data))>>11)
+#define SB2_PFUNC_MISC2_usb_id_e2_shift                                              (10)
+#define SB2_PFUNC_MISC2_usb_id_e2_mask                                               (0x00000400)
+#define SB2_PFUNC_MISC2_usb_id_e2(data)                                              (0x00000400&((data)<<10))
+#define SB2_PFUNC_MISC2_usb_id_e2_src(data)                                          ((0x00000400&(data))>>10)
+#define SB2_PFUNC_MISC2_get_usb_id_e2(data)                                          ((0x00000400&(data))>>10)
+#define SB2_PFUNC_MISC2_usb_id_pud_en_shift                                          (9)
+#define SB2_PFUNC_MISC2_usb_id_pud_en_mask                                           (0x00000200)
+#define SB2_PFUNC_MISC2_usb_id_pud_en(data)                                          (0x00000200&((data)<<9))
+#define SB2_PFUNC_MISC2_usb_id_pud_en_src(data)                                      ((0x00000200&(data))>>9)
+#define SB2_PFUNC_MISC2_get_usb_id_pud_en(data)                                      ((0x00000200&(data))>>9)
+#define SB2_PFUNC_MISC2_usb_id_pud_sel_shift                                         (8)
+#define SB2_PFUNC_MISC2_usb_id_pud_sel_mask                                          (0x00000100)
+#define SB2_PFUNC_MISC2_usb_id_pud_sel(data)                                         (0x00000100&((data)<<8))
+#define SB2_PFUNC_MISC2_usb_id_pud_sel_src(data)                                     ((0x00000100&(data))>>8)
+#define SB2_PFUNC_MISC2_get_usb_id_pud_sel(data)                                     ((0x00000100&(data))>>8)
+#define SB2_PFUNC_MISC2_gpio_9_smt_shift                                             (7)
+#define SB2_PFUNC_MISC2_gpio_9_smt_mask                                              (0x00000080)
+#define SB2_PFUNC_MISC2_gpio_9_smt(data)                                             (0x00000080&((data)<<7))
+#define SB2_PFUNC_MISC2_gpio_9_smt_src(data)                                         ((0x00000080&(data))>>7)
+#define SB2_PFUNC_MISC2_get_gpio_9_smt(data)                                         ((0x00000080&(data))>>7)
+#define SB2_PFUNC_MISC2_gpio_9_e2_shift                                              (6)
+#define SB2_PFUNC_MISC2_gpio_9_e2_mask                                               (0x00000040)
+#define SB2_PFUNC_MISC2_gpio_9_e2(data)                                              (0x00000040&((data)<<6))
+#define SB2_PFUNC_MISC2_gpio_9_e2_src(data)                                          ((0x00000040&(data))>>6)
+#define SB2_PFUNC_MISC2_get_gpio_9_e2(data)                                          ((0x00000040&(data))>>6)
+#define SB2_PFUNC_MISC2_gpio_9_pud_en_shift                                          (5)
+#define SB2_PFUNC_MISC2_gpio_9_pud_en_mask                                           (0x00000020)
+#define SB2_PFUNC_MISC2_gpio_9_pud_en(data)                                          (0x00000020&((data)<<5))
+#define SB2_PFUNC_MISC2_gpio_9_pud_en_src(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_MISC2_get_gpio_9_pud_en(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_MISC2_gpio_9_pud_sel_shift                                         (4)
+#define SB2_PFUNC_MISC2_gpio_9_pud_sel_mask                                          (0x00000010)
+#define SB2_PFUNC_MISC2_gpio_9_pud_sel(data)                                         (0x00000010&((data)<<4))
+#define SB2_PFUNC_MISC2_gpio_9_pud_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define SB2_PFUNC_MISC2_get_gpio_9_pud_sel(data)                                     ((0x00000010&(data))>>4)
+#define SB2_PFUNC_MISC2_gpio_8_smt_shift                                             (3)
+#define SB2_PFUNC_MISC2_gpio_8_smt_mask                                              (0x00000008)
+#define SB2_PFUNC_MISC2_gpio_8_smt(data)                                             (0x00000008&((data)<<3))
+#define SB2_PFUNC_MISC2_gpio_8_smt_src(data)                                         ((0x00000008&(data))>>3)
+#define SB2_PFUNC_MISC2_get_gpio_8_smt(data)                                         ((0x00000008&(data))>>3)
+#define SB2_PFUNC_MISC2_gpio_8_e2_shift                                              (2)
+#define SB2_PFUNC_MISC2_gpio_8_e2_mask                                               (0x00000004)
+#define SB2_PFUNC_MISC2_gpio_8_e2(data)                                              (0x00000004&((data)<<2))
+#define SB2_PFUNC_MISC2_gpio_8_e2_src(data)                                          ((0x00000004&(data))>>2)
+#define SB2_PFUNC_MISC2_get_gpio_8_e2(data)                                          ((0x00000004&(data))>>2)
+#define SB2_PFUNC_MISC2_gpio_8_pud_en_shift                                          (1)
+#define SB2_PFUNC_MISC2_gpio_8_pud_en_mask                                           (0x00000002)
+#define SB2_PFUNC_MISC2_gpio_8_pud_en(data)                                          (0x00000002&((data)<<1))
+#define SB2_PFUNC_MISC2_gpio_8_pud_en_src(data)                                      ((0x00000002&(data))>>1)
+#define SB2_PFUNC_MISC2_get_gpio_8_pud_en(data)                                      ((0x00000002&(data))>>1)
+#define SB2_PFUNC_MISC2_gpio_8_pud_sel_shift                                         (0)
+#define SB2_PFUNC_MISC2_gpio_8_pud_sel_mask                                          (0x00000001)
+#define SB2_PFUNC_MISC2_gpio_8_pud_sel(data)                                         (0x00000001&((data)<<0))
+#define SB2_PFUNC_MISC2_gpio_8_pud_sel_src(data)                                     ((0x00000001&(data))>>0)
+#define SB2_PFUNC_MISC2_get_gpio_8_pud_sel(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SB2_PFUNC_MISC3                                                              0x9801A93C
+#define SB2_PFUNC_MISC3_reg_addr                                                     "0xD801A93C"
+#define SB2_PFUNC_MISC3_reg                                                          0xD801A93C
+#define set_SB2_PFUNC_MISC3_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_MISC3_reg)=data)
+#define get_SB2_PFUNC_MISC3_reg   (*((volatile unsigned int*) SB2_PFUNC_MISC3_reg))
+#define SB2_PFUNC_MISC3_inst_adr                                                     "0x004F"
+#define SB2_PFUNC_MISC3_inst                                                         0x004F
+#define SB2_PFUNC_MISC3_boption4_smt_shift                                           (26)
+#define SB2_PFUNC_MISC3_boption4_smt_mask                                            (0x04000000)
+#define SB2_PFUNC_MISC3_boption4_smt(data)                                           (0x04000000&((data)<<26))
+#define SB2_PFUNC_MISC3_boption4_smt_src(data)                                       ((0x04000000&(data))>>26)
+#define SB2_PFUNC_MISC3_get_boption4_smt(data)                                       ((0x04000000&(data))>>26)
+#define SB2_PFUNC_MISC3_boption4_pud_en_shift                                        (25)
+#define SB2_PFUNC_MISC3_boption4_pud_en_mask                                         (0x02000000)
+#define SB2_PFUNC_MISC3_boption4_pud_en(data)                                        (0x02000000&((data)<<25))
+#define SB2_PFUNC_MISC3_boption4_pud_en_src(data)                                    ((0x02000000&(data))>>25)
+#define SB2_PFUNC_MISC3_get_boption4_pud_en(data)                                    ((0x02000000&(data))>>25)
+#define SB2_PFUNC_MISC3_boption4_pud_sel_shift                                       (24)
+#define SB2_PFUNC_MISC3_boption4_pud_sel_mask                                        (0x01000000)
+#define SB2_PFUNC_MISC3_boption4_pud_sel(data)                                       (0x01000000&((data)<<24))
+#define SB2_PFUNC_MISC3_boption4_pud_sel_src(data)                                   ((0x01000000&(data))>>24)
+#define SB2_PFUNC_MISC3_get_boption4_pud_sel(data)                                   ((0x01000000&(data))>>24)
+#define SB2_PFUNC_MISC3_boption3_smt_shift                                           (23)
+#define SB2_PFUNC_MISC3_boption3_smt_mask                                            (0x00800000)
+#define SB2_PFUNC_MISC3_boption3_smt(data)                                           (0x00800000&((data)<<23))
+#define SB2_PFUNC_MISC3_boption3_smt_src(data)                                       ((0x00800000&(data))>>23)
+#define SB2_PFUNC_MISC3_get_boption3_smt(data)                                       ((0x00800000&(data))>>23)
+#define SB2_PFUNC_MISC3_boption3_pud_en_shift                                        (22)
+#define SB2_PFUNC_MISC3_boption3_pud_en_mask                                         (0x00400000)
+#define SB2_PFUNC_MISC3_boption3_pud_en(data)                                        (0x00400000&((data)<<22))
+#define SB2_PFUNC_MISC3_boption3_pud_en_src(data)                                    ((0x00400000&(data))>>22)
+#define SB2_PFUNC_MISC3_get_boption3_pud_en(data)                                    ((0x00400000&(data))>>22)
+#define SB2_PFUNC_MISC3_boption3_pud_sel_shift                                       (21)
+#define SB2_PFUNC_MISC3_boption3_pud_sel_mask                                        (0x00200000)
+#define SB2_PFUNC_MISC3_boption3_pud_sel(data)                                       (0x00200000&((data)<<21))
+#define SB2_PFUNC_MISC3_boption3_pud_sel_src(data)                                   ((0x00200000&(data))>>21)
+#define SB2_PFUNC_MISC3_get_boption3_pud_sel(data)                                   ((0x00200000&(data))>>21)
+#define SB2_PFUNC_MISC3_boption1_smt_shift                                           (20)
+#define SB2_PFUNC_MISC3_boption1_smt_mask                                            (0x00100000)
+#define SB2_PFUNC_MISC3_boption1_smt(data)                                           (0x00100000&((data)<<20))
+#define SB2_PFUNC_MISC3_boption1_smt_src(data)                                       ((0x00100000&(data))>>20)
+#define SB2_PFUNC_MISC3_get_boption1_smt(data)                                       ((0x00100000&(data))>>20)
+#define SB2_PFUNC_MISC3_boption1_pud_en_shift                                        (19)
+#define SB2_PFUNC_MISC3_boption1_pud_en_mask                                         (0x00080000)
+#define SB2_PFUNC_MISC3_boption1_pud_en(data)                                        (0x00080000&((data)<<19))
+#define SB2_PFUNC_MISC3_boption1_pud_en_src(data)                                    ((0x00080000&(data))>>19)
+#define SB2_PFUNC_MISC3_get_boption1_pud_en(data)                                    ((0x00080000&(data))>>19)
+#define SB2_PFUNC_MISC3_boption1_pud_sel_shift                                       (18)
+#define SB2_PFUNC_MISC3_boption1_pud_sel_mask                                        (0x00040000)
+#define SB2_PFUNC_MISC3_boption1_pud_sel(data)                                       (0x00040000&((data)<<18))
+#define SB2_PFUNC_MISC3_boption1_pud_sel_src(data)                                   ((0x00040000&(data))>>18)
+#define SB2_PFUNC_MISC3_get_boption1_pud_sel(data)                                   ((0x00040000&(data))>>18)
+#define SB2_PFUNC_MISC3_boption0_smt_shift                                           (17)
+#define SB2_PFUNC_MISC3_boption0_smt_mask                                            (0x00020000)
+#define SB2_PFUNC_MISC3_boption0_smt(data)                                           (0x00020000&((data)<<17))
+#define SB2_PFUNC_MISC3_boption0_smt_src(data)                                       ((0x00020000&(data))>>17)
+#define SB2_PFUNC_MISC3_get_boption0_smt(data)                                       ((0x00020000&(data))>>17)
+#define SB2_PFUNC_MISC3_boption0_pud_en_shift                                        (16)
+#define SB2_PFUNC_MISC3_boption0_pud_en_mask                                         (0x00010000)
+#define SB2_PFUNC_MISC3_boption0_pud_en(data)                                        (0x00010000&((data)<<16))
+#define SB2_PFUNC_MISC3_boption0_pud_en_src(data)                                    ((0x00010000&(data))>>16)
+#define SB2_PFUNC_MISC3_get_boption0_pud_en(data)                                    ((0x00010000&(data))>>16)
+#define SB2_PFUNC_MISC3_boption0_pud_sel_shift                                       (15)
+#define SB2_PFUNC_MISC3_boption0_pud_sel_mask                                        (0x00008000)
+#define SB2_PFUNC_MISC3_boption0_pud_sel(data)                                       (0x00008000&((data)<<15))
+#define SB2_PFUNC_MISC3_boption0_pud_sel_src(data)                                   ((0x00008000&(data))>>15)
+#define SB2_PFUNC_MISC3_get_boption0_pud_sel(data)                                   ((0x00008000&(data))>>15)
+#define SB2_PFUNC_MISC3_boption9_smt_shift                                           (14)
+#define SB2_PFUNC_MISC3_boption9_smt_mask                                            (0x00004000)
+#define SB2_PFUNC_MISC3_boption9_smt(data)                                           (0x00004000&((data)<<14))
+#define SB2_PFUNC_MISC3_boption9_smt_src(data)                                       ((0x00004000&(data))>>14)
+#define SB2_PFUNC_MISC3_get_boption9_smt(data)                                       ((0x00004000&(data))>>14)
+#define SB2_PFUNC_MISC3_boption9_pud_en_shift                                        (13)
+#define SB2_PFUNC_MISC3_boption9_pud_en_mask                                         (0x00002000)
+#define SB2_PFUNC_MISC3_boption9_pud_en(data)                                        (0x00002000&((data)<<13))
+#define SB2_PFUNC_MISC3_boption9_pud_en_src(data)                                    ((0x00002000&(data))>>13)
+#define SB2_PFUNC_MISC3_get_boption9_pud_en(data)                                    ((0x00002000&(data))>>13)
+#define SB2_PFUNC_MISC3_boption9_pud_sel_shift                                       (12)
+#define SB2_PFUNC_MISC3_boption9_pud_sel_mask                                        (0x00001000)
+#define SB2_PFUNC_MISC3_boption9_pud_sel(data)                                       (0x00001000&((data)<<12))
+#define SB2_PFUNC_MISC3_boption9_pud_sel_src(data)                                   ((0x00001000&(data))>>12)
+#define SB2_PFUNC_MISC3_get_boption9_pud_sel(data)                                   ((0x00001000&(data))>>12)
+#define SB2_PFUNC_MISC3_boption8_smt_shift                                           (11)
+#define SB2_PFUNC_MISC3_boption8_smt_mask                                            (0x00000800)
+#define SB2_PFUNC_MISC3_boption8_smt(data)                                           (0x00000800&((data)<<11))
+#define SB2_PFUNC_MISC3_boption8_smt_src(data)                                       ((0x00000800&(data))>>11)
+#define SB2_PFUNC_MISC3_get_boption8_smt(data)                                       ((0x00000800&(data))>>11)
+#define SB2_PFUNC_MISC3_boption8_pud_en_shift                                        (10)
+#define SB2_PFUNC_MISC3_boption8_pud_en_mask                                         (0x00000400)
+#define SB2_PFUNC_MISC3_boption8_pud_en(data)                                        (0x00000400&((data)<<10))
+#define SB2_PFUNC_MISC3_boption8_pud_en_src(data)                                    ((0x00000400&(data))>>10)
+#define SB2_PFUNC_MISC3_get_boption8_pud_en(data)                                    ((0x00000400&(data))>>10)
+#define SB2_PFUNC_MISC3_boption8_pud_sel_shift                                       (9)
+#define SB2_PFUNC_MISC3_boption8_pud_sel_mask                                        (0x00000200)
+#define SB2_PFUNC_MISC3_boption8_pud_sel(data)                                       (0x00000200&((data)<<9))
+#define SB2_PFUNC_MISC3_boption8_pud_sel_src(data)                                   ((0x00000200&(data))>>9)
+#define SB2_PFUNC_MISC3_get_boption8_pud_sel(data)                                   ((0x00000200&(data))>>9)
+#define SB2_PFUNC_MISC3_boption7_smt_shift                                           (8)
+#define SB2_PFUNC_MISC3_boption7_smt_mask                                            (0x00000100)
+#define SB2_PFUNC_MISC3_boption7_smt(data)                                           (0x00000100&((data)<<8))
+#define SB2_PFUNC_MISC3_boption7_smt_src(data)                                       ((0x00000100&(data))>>8)
+#define SB2_PFUNC_MISC3_get_boption7_smt(data)                                       ((0x00000100&(data))>>8)
+#define SB2_PFUNC_MISC3_boption7_pud_en_shift                                        (7)
+#define SB2_PFUNC_MISC3_boption7_pud_en_mask                                         (0x00000080)
+#define SB2_PFUNC_MISC3_boption7_pud_en(data)                                        (0x00000080&((data)<<7))
+#define SB2_PFUNC_MISC3_boption7_pud_en_src(data)                                    ((0x00000080&(data))>>7)
+#define SB2_PFUNC_MISC3_get_boption7_pud_en(data)                                    ((0x00000080&(data))>>7)
+#define SB2_PFUNC_MISC3_boption7_pud_sel_shift                                       (6)
+#define SB2_PFUNC_MISC3_boption7_pud_sel_mask                                        (0x00000040)
+#define SB2_PFUNC_MISC3_boption7_pud_sel(data)                                       (0x00000040&((data)<<6))
+#define SB2_PFUNC_MISC3_boption7_pud_sel_src(data)                                   ((0x00000040&(data))>>6)
+#define SB2_PFUNC_MISC3_get_boption7_pud_sel(data)                                   ((0x00000040&(data))>>6)
+#define SB2_PFUNC_MISC3_boption6_smt_shift                                           (5)
+#define SB2_PFUNC_MISC3_boption6_smt_mask                                            (0x00000020)
+#define SB2_PFUNC_MISC3_boption6_smt(data)                                           (0x00000020&((data)<<5))
+#define SB2_PFUNC_MISC3_boption6_smt_src(data)                                       ((0x00000020&(data))>>5)
+#define SB2_PFUNC_MISC3_get_boption6_smt(data)                                       ((0x00000020&(data))>>5)
+#define SB2_PFUNC_MISC3_boption6_pud_en_shift                                        (4)
+#define SB2_PFUNC_MISC3_boption6_pud_en_mask                                         (0x00000010)
+#define SB2_PFUNC_MISC3_boption6_pud_en(data)                                        (0x00000010&((data)<<4))
+#define SB2_PFUNC_MISC3_boption6_pud_en_src(data)                                    ((0x00000010&(data))>>4)
+#define SB2_PFUNC_MISC3_get_boption6_pud_en(data)                                    ((0x00000010&(data))>>4)
+#define SB2_PFUNC_MISC3_boption6_pud_sel_shift                                       (3)
+#define SB2_PFUNC_MISC3_boption6_pud_sel_mask                                        (0x00000008)
+#define SB2_PFUNC_MISC3_boption6_pud_sel(data)                                       (0x00000008&((data)<<3))
+#define SB2_PFUNC_MISC3_boption6_pud_sel_src(data)                                   ((0x00000008&(data))>>3)
+#define SB2_PFUNC_MISC3_get_boption6_pud_sel(data)                                   ((0x00000008&(data))>>3)
+#define SB2_PFUNC_MISC3_boption5_smt_shift                                           (2)
+#define SB2_PFUNC_MISC3_boption5_smt_mask                                            (0x00000004)
+#define SB2_PFUNC_MISC3_boption5_smt(data)                                           (0x00000004&((data)<<2))
+#define SB2_PFUNC_MISC3_boption5_smt_src(data)                                       ((0x00000004&(data))>>2)
+#define SB2_PFUNC_MISC3_get_boption5_smt(data)                                       ((0x00000004&(data))>>2)
+#define SB2_PFUNC_MISC3_boption5_pud_en_shift                                        (1)
+#define SB2_PFUNC_MISC3_boption5_pud_en_mask                                         (0x00000002)
+#define SB2_PFUNC_MISC3_boption5_pud_en(data)                                        (0x00000002&((data)<<1))
+#define SB2_PFUNC_MISC3_boption5_pud_en_src(data)                                    ((0x00000002&(data))>>1)
+#define SB2_PFUNC_MISC3_get_boption5_pud_en(data)                                    ((0x00000002&(data))>>1)
+#define SB2_PFUNC_MISC3_boption5_pud_sel_shift                                       (0)
+#define SB2_PFUNC_MISC3_boption5_pud_sel_mask                                        (0x00000001)
+#define SB2_PFUNC_MISC3_boption5_pud_sel(data)                                       (0x00000001&((data)<<0))
+#define SB2_PFUNC_MISC3_boption5_pud_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define SB2_PFUNC_MISC3_get_boption5_pud_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SB2_DEBUG                                                                    0x9801A954
+#define SB2_DEBUG_reg_addr                                                           "0xD801A954"
+#define SB2_DEBUG_reg                                                                0xD801A954
+#define set_SB2_DEBUG_reg(data)   (*((volatile unsigned int*) SB2_DEBUG_reg)=data)
+#define get_SB2_DEBUG_reg   (*((volatile unsigned int*) SB2_DEBUG_reg))
+#define SB2_DEBUG_inst_adr                                                           "0x0055"
+#define SB2_DEBUG_inst                                                               0x0055
+#define SB2_DEBUG_main1_dbg_en_shift                                                 (31)
+#define SB2_DEBUG_main1_dbg_en_mask                                                  (0x80000000)
+#define SB2_DEBUG_main1_dbg_en(data)                                                 (0x80000000&((data)<<31))
+#define SB2_DEBUG_main1_dbg_en_src(data)                                             ((0x80000000&(data))>>31)
+#define SB2_DEBUG_get_main1_dbg_en(data)                                             ((0x80000000&(data))>>31)
+#define SB2_DEBUG_main1_dbg_sel_shift                                                (24)
+#define SB2_DEBUG_main1_dbg_sel_mask                                                 (0x0F000000)
+#define SB2_DEBUG_main1_dbg_sel(data)                                                (0x0F000000&((data)<<24))
+#define SB2_DEBUG_main1_dbg_sel_src(data)                                            ((0x0F000000&(data))>>24)
+#define SB2_DEBUG_get_main1_dbg_sel(data)                                            ((0x0F000000&(data))>>24)
+#define SB2_DEBUG_dbg_en_shift                                                       (14)
+#define SB2_DEBUG_dbg_en_mask                                                        (0x00004000)
+#define SB2_DEBUG_dbg_en(data)                                                       (0x00004000&((data)<<14))
+#define SB2_DEBUG_dbg_en_src(data)                                                   ((0x00004000&(data))>>14)
+#define SB2_DEBUG_get_dbg_en(data)                                                   ((0x00004000&(data))>>14)
+#define SB2_DEBUG_dbg_loc_shift                                                      (12)
+#define SB2_DEBUG_dbg_loc_mask                                                       (0x00003000)
+#define SB2_DEBUG_dbg_loc(data)                                                      (0x00003000&((data)<<12))
+#define SB2_DEBUG_dbg_loc_src(data)                                                  ((0x00003000&(data))>>12)
+#define SB2_DEBUG_get_dbg_loc(data)                                                  ((0x00003000&(data))>>12)
+#define SB2_DEBUG_dbg_sel0_shift                                                     (6)
+#define SB2_DEBUG_dbg_sel0_mask                                                      (0x00000FC0)
+#define SB2_DEBUG_dbg_sel0(data)                                                     (0x00000FC0&((data)<<6))
+#define SB2_DEBUG_dbg_sel0_src(data)                                                 ((0x00000FC0&(data))>>6)
+#define SB2_DEBUG_get_dbg_sel0(data)                                                 ((0x00000FC0&(data))>>6)
+#define SB2_DEBUG_dbg_sel1_shift                                                     (0)
+#define SB2_DEBUG_dbg_sel1_mask                                                      (0x0000003F)
+#define SB2_DEBUG_dbg_sel1(data)                                                     (0x0000003F&((data)<<0))
+#define SB2_DEBUG_dbg_sel1_src(data)                                                 ((0x0000003F&(data))>>0)
+#define SB2_DEBUG_get_dbg_sel1(data)                                                 ((0x0000003F&(data))>>0)
+
+
+#define SB2_MBIST                                                                    0x9801A958
+#define SB2_MBIST_reg_addr                                                           "0xD801A958"
+#define SB2_MBIST_reg                                                                0xD801A958
+#define set_SB2_MBIST_reg(data)   (*((volatile unsigned int*) SB2_MBIST_reg)=data)
+#define get_SB2_MBIST_reg   (*((volatile unsigned int*) SB2_MBIST_reg))
+#define SB2_MBIST_inst_adr                                                           "0x0056"
+#define SB2_MBIST_inst                                                               0x0056
+#define SB2_MBIST_mbist_gpu_chip_top_st_shift                                        (28)
+#define SB2_MBIST_mbist_gpu_chip_top_st_mask                                         (0x10000000)
+#define SB2_MBIST_mbist_gpu_chip_top_st(data)                                        (0x10000000&((data)<<28))
+#define SB2_MBIST_mbist_gpu_chip_top_st_src(data)                                    ((0x10000000&(data))>>28)
+#define SB2_MBIST_get_mbist_gpu_chip_top_st(data)                                    ((0x10000000&(data))>>28)
+#define SB2_MBIST_mbist_jpeg_st_shift                                                (27)
+#define SB2_MBIST_mbist_jpeg_st_mask                                                 (0x08000000)
+#define SB2_MBIST_mbist_jpeg_st(data)                                                (0x08000000&((data)<<27))
+#define SB2_MBIST_mbist_jpeg_st_src(data)                                            ((0x08000000&(data))>>27)
+#define SB2_MBIST_get_mbist_jpeg_st(data)                                            ((0x08000000&(data))>>27)
+#define SB2_MBIST_mbist_ve1_st_shift                                                 (26)
+#define SB2_MBIST_mbist_ve1_st_mask                                                  (0x04000000)
+#define SB2_MBIST_mbist_ve1_st(data)                                                 (0x04000000&((data)<<26))
+#define SB2_MBIST_mbist_ve1_st_src(data)                                             ((0x04000000&(data))>>26)
+#define SB2_MBIST_get_mbist_ve1_st(data)                                             ((0x04000000&(data))>>26)
+#define SB2_MBIST_mbist_ve2_st_shift                                                 (25)
+#define SB2_MBIST_mbist_ve2_st_mask                                                  (0x02000000)
+#define SB2_MBIST_mbist_ve2_st(data)                                                 (0x02000000&((data)<<25))
+#define SB2_MBIST_mbist_ve2_st_src(data)                                             ((0x02000000&(data))>>25)
+#define SB2_MBIST_get_mbist_ve2_st(data)                                             ((0x02000000&(data))>>25)
+#define SB2_MBIST_mbist_ve3_st_shift                                                 (24)
+#define SB2_MBIST_mbist_ve3_st_mask                                                  (0x01000000)
+#define SB2_MBIST_mbist_ve3_st(data)                                                 (0x01000000&((data)<<24))
+#define SB2_MBIST_mbist_ve3_st_src(data)                                             ((0x01000000&(data))>>24)
+#define SB2_MBIST_get_mbist_ve3_st(data)                                             ((0x01000000&(data))>>24)
+#define SB2_MBIST_mbist_rsa_st_shift                                                 (23)
+#define SB2_MBIST_mbist_rsa_st_mask                                                  (0x00800000)
+#define SB2_MBIST_mbist_rsa_st(data)                                                 (0x00800000&((data)<<23))
+#define SB2_MBIST_mbist_rsa_st_src(data)                                             ((0x00800000&(data))>>23)
+#define SB2_MBIST_get_mbist_rsa_st(data)                                             ((0x00800000&(data))>>23)
+#define SB2_MBIST_mbist_sata_st_shift                                                (22)
+#define SB2_MBIST_mbist_sata_st_mask                                                 (0x00400000)
+#define SB2_MBIST_mbist_sata_st(data)                                                (0x00400000&((data)<<22))
+#define SB2_MBIST_mbist_sata_st_src(data)                                            ((0x00400000&(data))>>22)
+#define SB2_MBIST_get_mbist_sata_st(data)                                            ((0x00400000&(data))>>22)
+#define SB2_MBIST_mbist_pcie0_st_shift                                               (21)
+#define SB2_MBIST_mbist_pcie0_st_mask                                                (0x00200000)
+#define SB2_MBIST_mbist_pcie0_st(data)                                               (0x00200000&((data)<<21))
+#define SB2_MBIST_mbist_pcie0_st_src(data)                                           ((0x00200000&(data))>>21)
+#define SB2_MBIST_get_mbist_pcie0_st(data)                                           ((0x00200000&(data))>>21)
+#define SB2_MBIST_mbist_pcie1_st_shift                                               (20)
+#define SB2_MBIST_mbist_pcie1_st_mask                                                (0x00100000)
+#define SB2_MBIST_mbist_pcie1_st(data)                                               (0x00100000&((data)<<20))
+#define SB2_MBIST_mbist_pcie1_st_src(data)                                           ((0x00100000&(data))>>20)
+#define SB2_MBIST_get_mbist_pcie1_st(data)                                           ((0x00100000&(data))>>20)
+#define SB2_MBIST_mbist_nat_st_shift                                                 (19)
+#define SB2_MBIST_mbist_nat_st_mask                                                  (0x00080000)
+#define SB2_MBIST_mbist_nat_st(data)                                                 (0x00080000&((data)<<19))
+#define SB2_MBIST_mbist_nat_st_src(data)                                             ((0x00080000&(data))>>19)
+#define SB2_MBIST_get_mbist_nat_st(data)                                             ((0x00080000&(data))>>19)
+#define SB2_MBIST_mbist_mipi_st_shift                                                (18)
+#define SB2_MBIST_mbist_mipi_st_mask                                                 (0x00040000)
+#define SB2_MBIST_mbist_mipi_st(data)                                                (0x00040000&((data)<<18))
+#define SB2_MBIST_mbist_mipi_st_src(data)                                            ((0x00040000&(data))>>18)
+#define SB2_MBIST_get_mbist_mipi_st(data)                                            ((0x00040000&(data))>>18)
+#define SB2_MBIST_mbist_usb_st_shift                                                 (17)
+#define SB2_MBIST_mbist_usb_st_mask                                                  (0x00020000)
+#define SB2_MBIST_mbist_usb_st(data)                                                 (0x00020000&((data)<<17))
+#define SB2_MBIST_mbist_usb_st_src(data)                                             ((0x00020000&(data))>>17)
+#define SB2_MBIST_get_mbist_usb_st(data)                                             ((0x00020000&(data))>>17)
+#define SB2_MBIST_mbist_se_st_shift                                                  (16)
+#define SB2_MBIST_mbist_se_st_mask                                                   (0x00010000)
+#define SB2_MBIST_mbist_se_st(data)                                                  (0x00010000&((data)<<16))
+#define SB2_MBIST_mbist_se_st_src(data)                                              ((0x00010000&(data))>>16)
+#define SB2_MBIST_get_mbist_se_st(data)                                              ((0x00010000&(data))>>16)
+#define SB2_MBIST_mbist_md_st_shift                                                  (15)
+#define SB2_MBIST_mbist_md_st_mask                                                   (0x00008000)
+#define SB2_MBIST_mbist_md_st(data)                                                  (0x00008000&((data)<<15))
+#define SB2_MBIST_mbist_md_st_src(data)                                              ((0x00008000&(data))>>15)
+#define SB2_MBIST_get_mbist_md_st(data)                                              ((0x00008000&(data))>>15)
+#define SB2_MBIST_mbist_nf_st_shift                                                  (14)
+#define SB2_MBIST_mbist_nf_st_mask                                                   (0x00004000)
+#define SB2_MBIST_mbist_nf_st(data)                                                  (0x00004000&((data)<<14))
+#define SB2_MBIST_mbist_nf_st_src(data)                                              ((0x00004000&(data))>>14)
+#define SB2_MBIST_get_mbist_nf_st(data)                                              ((0x00004000&(data))>>14)
+#define SB2_MBIST_mbist_cr_st_shift                                                  (13)
+#define SB2_MBIST_mbist_cr_st_mask                                                   (0x00002000)
+#define SB2_MBIST_mbist_cr_st(data)                                                  (0x00002000&((data)<<13))
+#define SB2_MBIST_mbist_cr_st_src(data)                                              ((0x00002000&(data))>>13)
+#define SB2_MBIST_get_mbist_cr_st(data)                                              ((0x00002000&(data))>>13)
+#define SB2_MBIST_mbist_etn_st_shift                                                 (12)
+#define SB2_MBIST_mbist_etn_st_mask                                                  (0x00001000)
+#define SB2_MBIST_mbist_etn_st(data)                                                 (0x00001000&((data)<<12))
+#define SB2_MBIST_mbist_etn_st_src(data)                                             ((0x00001000&(data))>>12)
+#define SB2_MBIST_get_mbist_etn_st(data)                                             ((0x00001000&(data))>>12)
+#define SB2_MBIST_mbist_dp_st_shift                                                  (11)
+#define SB2_MBIST_mbist_dp_st_mask                                                   (0x00000800)
+#define SB2_MBIST_mbist_dp_st(data)                                                  (0x00000800&((data)<<11))
+#define SB2_MBIST_mbist_dp_st_src(data)                                              ((0x00000800&(data))>>11)
+#define SB2_MBIST_get_mbist_dp_st(data)                                              ((0x00000800&(data))>>11)
+#define SB2_MBIST_mbist_ae_st_shift                                                  (10)
+#define SB2_MBIST_mbist_ae_st_mask                                                   (0x00000400)
+#define SB2_MBIST_mbist_ae_st(data)                                                  (0x00000400&((data)<<10))
+#define SB2_MBIST_mbist_ae_st_src(data)                                              ((0x00000400&(data))>>10)
+#define SB2_MBIST_get_mbist_ae_st(data)                                              ((0x00000400&(data))>>10)
+#define SB2_MBIST_mbist_acpu_st_shift                                                (9)
+#define SB2_MBIST_mbist_acpu_st_mask                                                 (0x00000200)
+#define SB2_MBIST_mbist_acpu_st(data)                                                (0x00000200&((data)<<9))
+#define SB2_MBIST_mbist_acpu_st_src(data)                                            ((0x00000200&(data))>>9)
+#define SB2_MBIST_get_mbist_acpu_st(data)                                            ((0x00000200&(data))>>9)
+#define SB2_MBIST_mbist_gpu_st_shift                                                 (8)
+#define SB2_MBIST_mbist_gpu_st_mask                                                  (0x00000100)
+#define SB2_MBIST_mbist_gpu_st(data)                                                 (0x00000100&((data)<<8))
+#define SB2_MBIST_mbist_gpu_st_src(data)                                             ((0x00000100&(data))>>8)
+#define SB2_MBIST_get_mbist_gpu_st(data)                                             ((0x00000100&(data))>>8)
+#define SB2_MBIST_mbist_tp_st_shift                                                  (7)
+#define SB2_MBIST_mbist_tp_st_mask                                                   (0x00000080)
+#define SB2_MBIST_mbist_tp_st(data)                                                  (0x00000080&((data)<<7))
+#define SB2_MBIST_mbist_tp_st_src(data)                                              ((0x00000080&(data))>>7)
+#define SB2_MBIST_get_mbist_tp_st(data)                                              ((0x00000080&(data))>>7)
+#define SB2_MBIST_mbist_aio_st_shift                                                 (6)
+#define SB2_MBIST_mbist_aio_st_mask                                                  (0x00000040)
+#define SB2_MBIST_mbist_aio_st(data)                                                 (0x00000040&((data)<<6))
+#define SB2_MBIST_mbist_aio_st_src(data)                                             ((0x00000040&(data))>>6)
+#define SB2_MBIST_get_mbist_aio_st(data)                                             ((0x00000040&(data))>>6)
+#define SB2_MBIST_mbist_pif_st_shift                                                 (5)
+#define SB2_MBIST_mbist_pif_st_mask                                                  (0x00000020)
+#define SB2_MBIST_mbist_pif_st(data)                                                 (0x00000020&((data)<<5))
+#define SB2_MBIST_mbist_pif_st_src(data)                                             ((0x00000020&(data))>>5)
+#define SB2_MBIST_get_mbist_pif_st(data)                                             ((0x00000020&(data))>>5)
+#define SB2_MBIST_mbist_hdmi_st_shift                                                (4)
+#define SB2_MBIST_mbist_hdmi_st_mask                                                 (0x00000010)
+#define SB2_MBIST_mbist_hdmi_st(data)                                                (0x00000010&((data)<<4))
+#define SB2_MBIST_mbist_hdmi_st_src(data)                                            ((0x00000010&(data))>>4)
+#define SB2_MBIST_get_mbist_hdmi_st(data)                                            ((0x00000010&(data))>>4)
+#define SB2_MBIST_mbist_vo_st_shift                                                  (3)
+#define SB2_MBIST_mbist_vo_st_mask                                                   (0x00000008)
+#define SB2_MBIST_mbist_vo_st(data)                                                  (0x00000008&((data)<<3))
+#define SB2_MBIST_mbist_vo_st_src(data)                                              ((0x00000008&(data))>>3)
+#define SB2_MBIST_get_mbist_vo_st(data)                                              ((0x00000008&(data))>>3)
+#define SB2_MBIST_mbist_dc_phy_st_shift                                              (2)
+#define SB2_MBIST_mbist_dc_phy_st_mask                                               (0x00000004)
+#define SB2_MBIST_mbist_dc_phy_st(data)                                              (0x00000004&((data)<<2))
+#define SB2_MBIST_mbist_dc_phy_st_src(data)                                          ((0x00000004&(data))>>2)
+#define SB2_MBIST_get_mbist_dc_phy_st(data)                                          ((0x00000004&(data))>>2)
+#define SB2_MBIST_mbist_dc_sys_st_shift                                              (1)
+#define SB2_MBIST_mbist_dc_sys_st_mask                                               (0x00000002)
+#define SB2_MBIST_mbist_dc_sys_st(data)                                              (0x00000002&((data)<<1))
+#define SB2_MBIST_mbist_dc_sys_st_src(data)                                          ((0x00000002&(data))>>1)
+#define SB2_MBIST_get_mbist_dc_sys_st(data)                                          ((0x00000002&(data))>>1)
+#define SB2_MBIST_mbist_cp_st_shift                                                  (0)
+#define SB2_MBIST_mbist_cp_st_mask                                                   (0x00000001)
+#define SB2_MBIST_mbist_cp_st(data)                                                  (0x00000001&((data)<<0))
+#define SB2_MBIST_mbist_cp_st_src(data)                                              ((0x00000001&(data))>>0)
+#define SB2_MBIST_get_mbist_cp_st(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SB2_PFUNC_RG0                                                                0x9801A960
+#define SB2_PFUNC_RG0_reg_addr                                                       "0xD801A960"
+#define SB2_PFUNC_RG0_reg                                                            0xD801A960
+#define set_SB2_PFUNC_RG0_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_RG0_reg)=data)
+#define get_SB2_PFUNC_RG0_reg   (*((volatile unsigned int*) SB2_PFUNC_RG0_reg))
+#define SB2_PFUNC_RG0_inst_adr                                                       "0x0058"
+#define SB2_PFUNC_RG0_inst                                                           0x0058
+#define SB2_PFUNC_RG0_rgmii0_txd_3_sr_shift                                          (5)
+#define SB2_PFUNC_RG0_rgmii0_txd_3_sr_mask                                           (0x00000020)
+#define SB2_PFUNC_RG0_rgmii0_txd_3_sr(data)                                          (0x00000020&((data)<<5))
+#define SB2_PFUNC_RG0_rgmii0_txd_3_sr_src(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG0_get_rgmii0_txd_3_sr(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG0_rgmii0_txd_2_sr_shift                                          (4)
+#define SB2_PFUNC_RG0_rgmii0_txd_2_sr_mask                                           (0x00000010)
+#define SB2_PFUNC_RG0_rgmii0_txd_2_sr(data)                                          (0x00000010&((data)<<4))
+#define SB2_PFUNC_RG0_rgmii0_txd_2_sr_src(data)                                      ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG0_get_rgmii0_txd_2_sr(data)                                      ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG0_rgmii0_txd_1_sr_shift                                          (3)
+#define SB2_PFUNC_RG0_rgmii0_txd_1_sr_mask                                           (0x00000008)
+#define SB2_PFUNC_RG0_rgmii0_txd_1_sr(data)                                          (0x00000008&((data)<<3))
+#define SB2_PFUNC_RG0_rgmii0_txd_1_sr_src(data)                                      ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG0_get_rgmii0_txd_1_sr(data)                                      ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG0_rgmii0_txd_0_sr_shift                                          (2)
+#define SB2_PFUNC_RG0_rgmii0_txd_0_sr_mask                                           (0x00000004)
+#define SB2_PFUNC_RG0_rgmii0_txd_0_sr(data)                                          (0x00000004&((data)<<2))
+#define SB2_PFUNC_RG0_rgmii0_txd_0_sr_src(data)                                      ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG0_get_rgmii0_txd_0_sr(data)                                      ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG0_rgmii0_tx_ctl_sr_shift                                         (1)
+#define SB2_PFUNC_RG0_rgmii0_tx_ctl_sr_mask                                          (0x00000002)
+#define SB2_PFUNC_RG0_rgmii0_tx_ctl_sr(data)                                         (0x00000002&((data)<<1))
+#define SB2_PFUNC_RG0_rgmii0_tx_ctl_sr_src(data)                                     ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG0_get_rgmii0_tx_ctl_sr(data)                                     ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG0_rgmii0_txc_sr_shift                                            (0)
+#define SB2_PFUNC_RG0_rgmii0_txc_sr_mask                                             (0x00000001)
+#define SB2_PFUNC_RG0_rgmii0_txc_sr(data)                                            (0x00000001&((data)<<0))
+#define SB2_PFUNC_RG0_rgmii0_txc_sr_src(data)                                        ((0x00000001&(data))>>0)
+#define SB2_PFUNC_RG0_get_rgmii0_txc_sr(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SB2_PFUNC_RG1                                                                0x9801A964
+#define SB2_PFUNC_RG1_reg_addr                                                       "0xD801A964"
+#define SB2_PFUNC_RG1_reg                                                            0xD801A964
+#define set_SB2_PFUNC_RG1_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_RG1_reg)=data)
+#define get_SB2_PFUNC_RG1_reg   (*((volatile unsigned int*) SB2_PFUNC_RG1_reg))
+#define SB2_PFUNC_RG1_inst_adr                                                       "0x0059"
+#define SB2_PFUNC_RG1_inst                                                           0x0059
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_smt_shift                                        (31)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_smt_mask                                         (0x80000000)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_smt(data)                                        (0x80000000&((data)<<31))
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_smt_src(data)                                    ((0x80000000&(data))>>31)
+#define SB2_PFUNC_RG1_get_rgmii0_rx_ctl_smt(data)                                    ((0x80000000&(data))>>31)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_e2_shift                                         (30)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_e2_mask                                          (0x40000000)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_e2(data)                                         (0x40000000&((data)<<30))
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_e2_src(data)                                     ((0x40000000&(data))>>30)
+#define SB2_PFUNC_RG1_get_rgmii0_rx_ctl_e2(data)                                     ((0x40000000&(data))>>30)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_pud_en_shift                                     (29)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_pud_en_mask                                      (0x20000000)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_pud_en(data)                                     (0x20000000&((data)<<29))
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_pud_en_src(data)                                 ((0x20000000&(data))>>29)
+#define SB2_PFUNC_RG1_get_rgmii0_rx_ctl_pud_en(data)                                 ((0x20000000&(data))>>29)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_pud_sel_shift                                    (28)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_pud_sel_mask                                     (0x10000000)
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_pud_sel(data)                                    (0x10000000&((data)<<28))
+#define SB2_PFUNC_RG1_rgmii0_rx_ctl_pud_sel_src(data)                                ((0x10000000&(data))>>28)
+#define SB2_PFUNC_RG1_get_rgmii0_rx_ctl_pud_sel(data)                                ((0x10000000&(data))>>28)
+#define SB2_PFUNC_RG1_rgmii0_rxc_smt_shift                                           (27)
+#define SB2_PFUNC_RG1_rgmii0_rxc_smt_mask                                            (0x08000000)
+#define SB2_PFUNC_RG1_rgmii0_rxc_smt(data)                                           (0x08000000&((data)<<27))
+#define SB2_PFUNC_RG1_rgmii0_rxc_smt_src(data)                                       ((0x08000000&(data))>>27)
+#define SB2_PFUNC_RG1_get_rgmii0_rxc_smt(data)                                       ((0x08000000&(data))>>27)
+#define SB2_PFUNC_RG1_rgmii0_rxc_e2_shift                                            (26)
+#define SB2_PFUNC_RG1_rgmii0_rxc_e2_mask                                             (0x04000000)
+#define SB2_PFUNC_RG1_rgmii0_rxc_e2(data)                                            (0x04000000&((data)<<26))
+#define SB2_PFUNC_RG1_rgmii0_rxc_e2_src(data)                                        ((0x04000000&(data))>>26)
+#define SB2_PFUNC_RG1_get_rgmii0_rxc_e2(data)                                        ((0x04000000&(data))>>26)
+#define SB2_PFUNC_RG1_rgmii0_rxc_pud_en_shift                                        (25)
+#define SB2_PFUNC_RG1_rgmii0_rxc_pud_en_mask                                         (0x02000000)
+#define SB2_PFUNC_RG1_rgmii0_rxc_pud_en(data)                                        (0x02000000&((data)<<25))
+#define SB2_PFUNC_RG1_rgmii0_rxc_pud_en_src(data)                                    ((0x02000000&(data))>>25)
+#define SB2_PFUNC_RG1_get_rgmii0_rxc_pud_en(data)                                    ((0x02000000&(data))>>25)
+#define SB2_PFUNC_RG1_rgmii0_rxc_pud_sel_shift                                       (24)
+#define SB2_PFUNC_RG1_rgmii0_rxc_pud_sel_mask                                        (0x01000000)
+#define SB2_PFUNC_RG1_rgmii0_rxc_pud_sel(data)                                       (0x01000000&((data)<<24))
+#define SB2_PFUNC_RG1_rgmii0_rxc_pud_sel_src(data)                                   ((0x01000000&(data))>>24)
+#define SB2_PFUNC_RG1_get_rgmii0_rxc_pud_sel(data)                                   ((0x01000000&(data))>>24)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_smt_shift                                         (23)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_smt_mask                                          (0x00800000)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_smt(data)                                         (0x00800000&((data)<<23))
+#define SB2_PFUNC_RG1_rgmii0_txd_3_smt_src(data)                                     ((0x00800000&(data))>>23)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_3_smt(data)                                     ((0x00800000&(data))>>23)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_e2_shift                                          (22)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_e2_mask                                           (0x00400000)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_e2(data)                                          (0x00400000&((data)<<22))
+#define SB2_PFUNC_RG1_rgmii0_txd_3_e2_src(data)                                      ((0x00400000&(data))>>22)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_3_e2(data)                                      ((0x00400000&(data))>>22)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_pud_en_shift                                      (21)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_pud_en_mask                                       (0x00200000)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_pud_en(data)                                      (0x00200000&((data)<<21))
+#define SB2_PFUNC_RG1_rgmii0_txd_3_pud_en_src(data)                                  ((0x00200000&(data))>>21)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_3_pud_en(data)                                  ((0x00200000&(data))>>21)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_pud_sel_shift                                     (20)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_pud_sel_mask                                      (0x00100000)
+#define SB2_PFUNC_RG1_rgmii0_txd_3_pud_sel(data)                                     (0x00100000&((data)<<20))
+#define SB2_PFUNC_RG1_rgmii0_txd_3_pud_sel_src(data)                                 ((0x00100000&(data))>>20)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_3_pud_sel(data)                                 ((0x00100000&(data))>>20)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_smt_shift                                         (19)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_smt_mask                                          (0x00080000)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_smt(data)                                         (0x00080000&((data)<<19))
+#define SB2_PFUNC_RG1_rgmii0_txd_2_smt_src(data)                                     ((0x00080000&(data))>>19)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_2_smt(data)                                     ((0x00080000&(data))>>19)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_e2_shift                                          (18)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_e2_mask                                           (0x00040000)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_e2(data)                                          (0x00040000&((data)<<18))
+#define SB2_PFUNC_RG1_rgmii0_txd_2_e2_src(data)                                      ((0x00040000&(data))>>18)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_2_e2(data)                                      ((0x00040000&(data))>>18)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_pud_en_shift                                      (17)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_pud_en_mask                                       (0x00020000)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_pud_en(data)                                      (0x00020000&((data)<<17))
+#define SB2_PFUNC_RG1_rgmii0_txd_2_pud_en_src(data)                                  ((0x00020000&(data))>>17)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_2_pud_en(data)                                  ((0x00020000&(data))>>17)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_pud_sel_shift                                     (16)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_pud_sel_mask                                      (0x00010000)
+#define SB2_PFUNC_RG1_rgmii0_txd_2_pud_sel(data)                                     (0x00010000&((data)<<16))
+#define SB2_PFUNC_RG1_rgmii0_txd_2_pud_sel_src(data)                                 ((0x00010000&(data))>>16)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_2_pud_sel(data)                                 ((0x00010000&(data))>>16)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_smt_shift                                         (15)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_smt_mask                                          (0x00008000)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_smt(data)                                         (0x00008000&((data)<<15))
+#define SB2_PFUNC_RG1_rgmii0_txd_1_smt_src(data)                                     ((0x00008000&(data))>>15)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_1_smt(data)                                     ((0x00008000&(data))>>15)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_e2_shift                                          (14)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_e2_mask                                           (0x00004000)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_e2(data)                                          (0x00004000&((data)<<14))
+#define SB2_PFUNC_RG1_rgmii0_txd_1_e2_src(data)                                      ((0x00004000&(data))>>14)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_1_e2(data)                                      ((0x00004000&(data))>>14)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_pud_en_shift                                      (13)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_pud_en_mask                                       (0x00002000)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_pud_en(data)                                      (0x00002000&((data)<<13))
+#define SB2_PFUNC_RG1_rgmii0_txd_1_pud_en_src(data)                                  ((0x00002000&(data))>>13)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_1_pud_en(data)                                  ((0x00002000&(data))>>13)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_pud_sel_shift                                     (12)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_pud_sel_mask                                      (0x00001000)
+#define SB2_PFUNC_RG1_rgmii0_txd_1_pud_sel(data)                                     (0x00001000&((data)<<12))
+#define SB2_PFUNC_RG1_rgmii0_txd_1_pud_sel_src(data)                                 ((0x00001000&(data))>>12)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_1_pud_sel(data)                                 ((0x00001000&(data))>>12)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_smt_shift                                         (11)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_smt_mask                                          (0x00000800)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_smt(data)                                         (0x00000800&((data)<<11))
+#define SB2_PFUNC_RG1_rgmii0_txd_0_smt_src(data)                                     ((0x00000800&(data))>>11)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_0_smt(data)                                     ((0x00000800&(data))>>11)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_e2_shift                                          (10)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_e2_mask                                           (0x00000400)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_e2(data)                                          (0x00000400&((data)<<10))
+#define SB2_PFUNC_RG1_rgmii0_txd_0_e2_src(data)                                      ((0x00000400&(data))>>10)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_0_e2(data)                                      ((0x00000400&(data))>>10)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_pud_en_shift                                      (9)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_pud_en_mask                                       (0x00000200)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_pud_en(data)                                      (0x00000200&((data)<<9))
+#define SB2_PFUNC_RG1_rgmii0_txd_0_pud_en_src(data)                                  ((0x00000200&(data))>>9)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_0_pud_en(data)                                  ((0x00000200&(data))>>9)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_pud_sel_shift                                     (8)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_pud_sel_mask                                      (0x00000100)
+#define SB2_PFUNC_RG1_rgmii0_txd_0_pud_sel(data)                                     (0x00000100&((data)<<8))
+#define SB2_PFUNC_RG1_rgmii0_txd_0_pud_sel_src(data)                                 ((0x00000100&(data))>>8)
+#define SB2_PFUNC_RG1_get_rgmii0_txd_0_pud_sel(data)                                 ((0x00000100&(data))>>8)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_smt_shift                                        (7)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_smt_mask                                         (0x00000080)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_smt(data)                                        (0x00000080&((data)<<7))
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_smt_src(data)                                    ((0x00000080&(data))>>7)
+#define SB2_PFUNC_RG1_get_rgmii0_tx_ctl_smt(data)                                    ((0x00000080&(data))>>7)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_e2_shift                                         (6)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_e2_mask                                          (0x00000040)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_e2(data)                                         (0x00000040&((data)<<6))
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_e2_src(data)                                     ((0x00000040&(data))>>6)
+#define SB2_PFUNC_RG1_get_rgmii0_tx_ctl_e2(data)                                     ((0x00000040&(data))>>6)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_pud_en_shift                                     (5)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_pud_en_mask                                      (0x00000020)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_pud_en(data)                                     (0x00000020&((data)<<5))
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_pud_en_src(data)                                 ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG1_get_rgmii0_tx_ctl_pud_en(data)                                 ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_pud_sel_shift                                    (4)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_pud_sel_mask                                     (0x00000010)
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_pud_sel(data)                                    (0x00000010&((data)<<4))
+#define SB2_PFUNC_RG1_rgmii0_tx_ctl_pud_sel_src(data)                                ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG1_get_rgmii0_tx_ctl_pud_sel(data)                                ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG1_rgmii0_txc_smt_shift                                           (3)
+#define SB2_PFUNC_RG1_rgmii0_txc_smt_mask                                            (0x00000008)
+#define SB2_PFUNC_RG1_rgmii0_txc_smt(data)                                           (0x00000008&((data)<<3))
+#define SB2_PFUNC_RG1_rgmii0_txc_smt_src(data)                                       ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG1_get_rgmii0_txc_smt(data)                                       ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG1_rgmii0_txc_e2_shift                                            (2)
+#define SB2_PFUNC_RG1_rgmii0_txc_e2_mask                                             (0x00000004)
+#define SB2_PFUNC_RG1_rgmii0_txc_e2(data)                                            (0x00000004&((data)<<2))
+#define SB2_PFUNC_RG1_rgmii0_txc_e2_src(data)                                        ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG1_get_rgmii0_txc_e2(data)                                        ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG1_rgmii0_txc_pud_en_shift                                        (1)
+#define SB2_PFUNC_RG1_rgmii0_txc_pud_en_mask                                         (0x00000002)
+#define SB2_PFUNC_RG1_rgmii0_txc_pud_en(data)                                        (0x00000002&((data)<<1))
+#define SB2_PFUNC_RG1_rgmii0_txc_pud_en_src(data)                                    ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG1_get_rgmii0_txc_pud_en(data)                                    ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG1_rgmii0_txc_pud_sel_shift                                       (0)
+#define SB2_PFUNC_RG1_rgmii0_txc_pud_sel_mask                                        (0x00000001)
+#define SB2_PFUNC_RG1_rgmii0_txc_pud_sel(data)                                       (0x00000001&((data)<<0))
+#define SB2_PFUNC_RG1_rgmii0_txc_pud_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define SB2_PFUNC_RG1_get_rgmii0_txc_pud_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SB2_PFUNC_RG2                                                                0x9801A968
+#define SB2_PFUNC_RG2_reg_addr                                                       "0xD801A968"
+#define SB2_PFUNC_RG2_reg                                                            0xD801A968
+#define set_SB2_PFUNC_RG2_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_RG2_reg)=data)
+#define get_SB2_PFUNC_RG2_reg   (*((volatile unsigned int*) SB2_PFUNC_RG2_reg))
+#define SB2_PFUNC_RG2_inst_adr                                                       "0x005A"
+#define SB2_PFUNC_RG2_inst                                                           0x005A
+#define SB2_PFUNC_RG2_rgmii0_bias_mode2_shift                                        (31)
+#define SB2_PFUNC_RG2_rgmii0_bias_mode2_mask                                         (0x80000000)
+#define SB2_PFUNC_RG2_rgmii0_bias_mode2(data)                                        (0x80000000&((data)<<31))
+#define SB2_PFUNC_RG2_rgmii0_bias_mode2_src(data)                                    ((0x80000000&(data))>>31)
+#define SB2_PFUNC_RG2_get_rgmii0_bias_mode2(data)                                    ((0x80000000&(data))>>31)
+#define SB2_PFUNC_RG2_rgmii0_bias_mode_shift                                         (30)
+#define SB2_PFUNC_RG2_rgmii0_bias_mode_mask                                          (0x40000000)
+#define SB2_PFUNC_RG2_rgmii0_bias_mode(data)                                         (0x40000000&((data)<<30))
+#define SB2_PFUNC_RG2_rgmii0_bias_mode_src(data)                                     ((0x40000000&(data))>>30)
+#define SB2_PFUNC_RG2_get_rgmii0_bias_mode(data)                                     ((0x40000000&(data))>>30)
+#define SB2_PFUNC_RG2_rgmii0_bias_dn_shift                                           (27)
+#define SB2_PFUNC_RG2_rgmii0_bias_dn_mask                                            (0x38000000)
+#define SB2_PFUNC_RG2_rgmii0_bias_dn(data)                                           (0x38000000&((data)<<27))
+#define SB2_PFUNC_RG2_rgmii0_bias_dn_src(data)                                       ((0x38000000&(data))>>27)
+#define SB2_PFUNC_RG2_get_rgmii0_bias_dn(data)                                       ((0x38000000&(data))>>27)
+#define SB2_PFUNC_RG2_rgmii0_bias_dp_shift                                           (24)
+#define SB2_PFUNC_RG2_rgmii0_bias_dp_mask                                            (0x07000000)
+#define SB2_PFUNC_RG2_rgmii0_bias_dp(data)                                           (0x07000000&((data)<<24))
+#define SB2_PFUNC_RG2_rgmii0_bias_dp_src(data)                                       ((0x07000000&(data))>>24)
+#define SB2_PFUNC_RG2_get_rgmii0_bias_dp(data)                                       ((0x07000000&(data))>>24)
+#define SB2_PFUNC_RG2_rgmii0_mdc_smt_shift                                           (23)
+#define SB2_PFUNC_RG2_rgmii0_mdc_smt_mask                                            (0x00800000)
+#define SB2_PFUNC_RG2_rgmii0_mdc_smt(data)                                           (0x00800000&((data)<<23))
+#define SB2_PFUNC_RG2_rgmii0_mdc_smt_src(data)                                       ((0x00800000&(data))>>23)
+#define SB2_PFUNC_RG2_get_rgmii0_mdc_smt(data)                                       ((0x00800000&(data))>>23)
+#define SB2_PFUNC_RG2_rgmii0_mdc_e2_shift                                            (22)
+#define SB2_PFUNC_RG2_rgmii0_mdc_e2_mask                                             (0x00400000)
+#define SB2_PFUNC_RG2_rgmii0_mdc_e2(data)                                            (0x00400000&((data)<<22))
+#define SB2_PFUNC_RG2_rgmii0_mdc_e2_src(data)                                        ((0x00400000&(data))>>22)
+#define SB2_PFUNC_RG2_get_rgmii0_mdc_e2(data)                                        ((0x00400000&(data))>>22)
+#define SB2_PFUNC_RG2_rgmii0_mdc_pud_en_shift                                        (21)
+#define SB2_PFUNC_RG2_rgmii0_mdc_pud_en_mask                                         (0x00200000)
+#define SB2_PFUNC_RG2_rgmii0_mdc_pud_en(data)                                        (0x00200000&((data)<<21))
+#define SB2_PFUNC_RG2_rgmii0_mdc_pud_en_src(data)                                    ((0x00200000&(data))>>21)
+#define SB2_PFUNC_RG2_get_rgmii0_mdc_pud_en(data)                                    ((0x00200000&(data))>>21)
+#define SB2_PFUNC_RG2_rgmii0_mdc_pud_sel_shift                                       (20)
+#define SB2_PFUNC_RG2_rgmii0_mdc_pud_sel_mask                                        (0x00100000)
+#define SB2_PFUNC_RG2_rgmii0_mdc_pud_sel(data)                                       (0x00100000&((data)<<20))
+#define SB2_PFUNC_RG2_rgmii0_mdc_pud_sel_src(data)                                   ((0x00100000&(data))>>20)
+#define SB2_PFUNC_RG2_get_rgmii0_mdc_pud_sel(data)                                   ((0x00100000&(data))>>20)
+#define SB2_PFUNC_RG2_rgmii0_mdio_smt_shift                                          (19)
+#define SB2_PFUNC_RG2_rgmii0_mdio_smt_mask                                           (0x00080000)
+#define SB2_PFUNC_RG2_rgmii0_mdio_smt(data)                                          (0x00080000&((data)<<19))
+#define SB2_PFUNC_RG2_rgmii0_mdio_smt_src(data)                                      ((0x00080000&(data))>>19)
+#define SB2_PFUNC_RG2_get_rgmii0_mdio_smt(data)                                      ((0x00080000&(data))>>19)
+#define SB2_PFUNC_RG2_rgmii0_mdio_e2_shift                                           (18)
+#define SB2_PFUNC_RG2_rgmii0_mdio_e2_mask                                            (0x00040000)
+#define SB2_PFUNC_RG2_rgmii0_mdio_e2(data)                                           (0x00040000&((data)<<18))
+#define SB2_PFUNC_RG2_rgmii0_mdio_e2_src(data)                                       ((0x00040000&(data))>>18)
+#define SB2_PFUNC_RG2_get_rgmii0_mdio_e2(data)                                       ((0x00040000&(data))>>18)
+#define SB2_PFUNC_RG2_rgmii0_mdio_pud_en_shift                                       (17)
+#define SB2_PFUNC_RG2_rgmii0_mdio_pud_en_mask                                        (0x00020000)
+#define SB2_PFUNC_RG2_rgmii0_mdio_pud_en(data)                                       (0x00020000&((data)<<17))
+#define SB2_PFUNC_RG2_rgmii0_mdio_pud_en_src(data)                                   ((0x00020000&(data))>>17)
+#define SB2_PFUNC_RG2_get_rgmii0_mdio_pud_en(data)                                   ((0x00020000&(data))>>17)
+#define SB2_PFUNC_RG2_rgmii0_mdio_pud_sel_shift                                      (16)
+#define SB2_PFUNC_RG2_rgmii0_mdio_pud_sel_mask                                       (0x00010000)
+#define SB2_PFUNC_RG2_rgmii0_mdio_pud_sel(data)                                      (0x00010000&((data)<<16))
+#define SB2_PFUNC_RG2_rgmii0_mdio_pud_sel_src(data)                                  ((0x00010000&(data))>>16)
+#define SB2_PFUNC_RG2_get_rgmii0_mdio_pud_sel(data)                                  ((0x00010000&(data))>>16)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_smt_shift                                         (15)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_smt_mask                                          (0x00008000)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_smt(data)                                         (0x00008000&((data)<<15))
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_smt_src(data)                                     ((0x00008000&(data))>>15)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_3_smt(data)                                     ((0x00008000&(data))>>15)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_e2_shift                                          (14)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_e2_mask                                           (0x00004000)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_e2(data)                                          (0x00004000&((data)<<14))
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_e2_src(data)                                      ((0x00004000&(data))>>14)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_3_e2(data)                                      ((0x00004000&(data))>>14)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_pud_en_shift                                      (13)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_pud_en_mask                                       (0x00002000)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_pud_en(data)                                      (0x00002000&((data)<<13))
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_pud_en_src(data)                                  ((0x00002000&(data))>>13)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_3_pud_en(data)                                  ((0x00002000&(data))>>13)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_pud_sel_shift                                     (12)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_pud_sel_mask                                      (0x00001000)
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_pud_sel(data)                                     (0x00001000&((data)<<12))
+#define SB2_PFUNC_RG2_rgmii0_rxd_3_pud_sel_src(data)                                 ((0x00001000&(data))>>12)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_3_pud_sel(data)                                 ((0x00001000&(data))>>12)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_smt_shift                                         (11)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_smt_mask                                          (0x00000800)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_smt(data)                                         (0x00000800&((data)<<11))
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_smt_src(data)                                     ((0x00000800&(data))>>11)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_2_smt(data)                                     ((0x00000800&(data))>>11)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_e2_shift                                          (10)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_e2_mask                                           (0x00000400)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_e2(data)                                          (0x00000400&((data)<<10))
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_e2_src(data)                                      ((0x00000400&(data))>>10)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_2_e2(data)                                      ((0x00000400&(data))>>10)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_pud_en_shift                                      (9)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_pud_en_mask                                       (0x00000200)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_pud_en(data)                                      (0x00000200&((data)<<9))
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_pud_en_src(data)                                  ((0x00000200&(data))>>9)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_2_pud_en(data)                                  ((0x00000200&(data))>>9)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_pud_sel_shift                                     (8)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_pud_sel_mask                                      (0x00000100)
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_pud_sel(data)                                     (0x00000100&((data)<<8))
+#define SB2_PFUNC_RG2_rgmii0_rxd_2_pud_sel_src(data)                                 ((0x00000100&(data))>>8)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_2_pud_sel(data)                                 ((0x00000100&(data))>>8)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_smt_shift                                         (7)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_smt_mask                                          (0x00000080)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_smt(data)                                         (0x00000080&((data)<<7))
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_smt_src(data)                                     ((0x00000080&(data))>>7)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_1_smt(data)                                     ((0x00000080&(data))>>7)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_e2_shift                                          (6)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_e2_mask                                           (0x00000040)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_e2(data)                                          (0x00000040&((data)<<6))
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_e2_src(data)                                      ((0x00000040&(data))>>6)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_1_e2(data)                                      ((0x00000040&(data))>>6)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_pud_en_shift                                      (5)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_pud_en_mask                                       (0x00000020)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_pud_en(data)                                      (0x00000020&((data)<<5))
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_pud_en_src(data)                                  ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_1_pud_en(data)                                  ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_pud_sel_shift                                     (4)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_pud_sel_mask                                      (0x00000010)
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_pud_sel(data)                                     (0x00000010&((data)<<4))
+#define SB2_PFUNC_RG2_rgmii0_rxd_1_pud_sel_src(data)                                 ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_1_pud_sel(data)                                 ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_smt_shift                                         (3)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_smt_mask                                          (0x00000008)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_smt(data)                                         (0x00000008&((data)<<3))
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_smt_src(data)                                     ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_0_smt(data)                                     ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_e2_shift                                          (2)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_e2_mask                                           (0x00000004)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_e2(data)                                          (0x00000004&((data)<<2))
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_e2_src(data)                                      ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_0_e2(data)                                      ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_pud_en_shift                                      (1)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_pud_en_mask                                       (0x00000002)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_pud_en(data)                                      (0x00000002&((data)<<1))
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_pud_en_src(data)                                  ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_0_pud_en(data)                                  ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_pud_sel_shift                                     (0)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_pud_sel_mask                                      (0x00000001)
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_pud_sel(data)                                     (0x00000001&((data)<<0))
+#define SB2_PFUNC_RG2_rgmii0_rxd_0_pud_sel_src(data)                                 ((0x00000001&(data))>>0)
+#define SB2_PFUNC_RG2_get_rgmii0_rxd_0_pud_sel(data)                                 ((0x00000001&(data))>>0)
+
+
+#define SB2_MUXPAD_RG0                                                               0x9801A96C
+#define SB2_MUXPAD_RG0_reg_addr                                                      "0xD801A96C"
+#define SB2_MUXPAD_RG0_reg                                                           0xD801A96C
+#define set_SB2_MUXPAD_RG0_reg(data)   (*((volatile unsigned int*) SB2_MUXPAD_RG0_reg)=data)
+#define get_SB2_MUXPAD_RG0_reg   (*((volatile unsigned int*) SB2_MUXPAD_RG0_reg))
+#define SB2_MUXPAD_RG0_inst_adr                                                      "0x005B"
+#define SB2_MUXPAD_RG0_inst                                                          0x005B
+#define SB2_MUXPAD_RG0_rgmii0_mdc_shift                                              (26)
+#define SB2_MUXPAD_RG0_rgmii0_mdc_mask                                               (0x0C000000)
+#define SB2_MUXPAD_RG0_rgmii0_mdc(data)                                              (0x0C000000&((data)<<26))
+#define SB2_MUXPAD_RG0_rgmii0_mdc_src(data)                                          ((0x0C000000&(data))>>26)
+#define SB2_MUXPAD_RG0_get_rgmii0_mdc(data)                                          ((0x0C000000&(data))>>26)
+#define SB2_MUXPAD_RG0_rgmii0_mdio_shift                                             (24)
+#define SB2_MUXPAD_RG0_rgmii0_mdio_mask                                              (0x03000000)
+#define SB2_MUXPAD_RG0_rgmii0_mdio(data)                                             (0x03000000&((data)<<24))
+#define SB2_MUXPAD_RG0_rgmii0_mdio_src(data)                                         ((0x03000000&(data))>>24)
+#define SB2_MUXPAD_RG0_get_rgmii0_mdio(data)                                         ((0x03000000&(data))>>24)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_3_shift                                            (22)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_3_mask                                             (0x00C00000)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_3(data)                                            (0x00C00000&((data)<<22))
+#define SB2_MUXPAD_RG0_rgmii0_rxd_3_src(data)                                        ((0x00C00000&(data))>>22)
+#define SB2_MUXPAD_RG0_get_rgmii0_rxd_3(data)                                        ((0x00C00000&(data))>>22)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_2_shift                                            (20)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_2_mask                                             (0x00300000)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_2(data)                                            (0x00300000&((data)<<20))
+#define SB2_MUXPAD_RG0_rgmii0_rxd_2_src(data)                                        ((0x00300000&(data))>>20)
+#define SB2_MUXPAD_RG0_get_rgmii0_rxd_2(data)                                        ((0x00300000&(data))>>20)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_1_shift                                            (18)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_1_mask                                             (0x000C0000)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_1(data)                                            (0x000C0000&((data)<<18))
+#define SB2_MUXPAD_RG0_rgmii0_rxd_1_src(data)                                        ((0x000C0000&(data))>>18)
+#define SB2_MUXPAD_RG0_get_rgmii0_rxd_1(data)                                        ((0x000C0000&(data))>>18)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_0_shift                                            (16)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_0_mask                                             (0x00030000)
+#define SB2_MUXPAD_RG0_rgmii0_rxd_0(data)                                            (0x00030000&((data)<<16))
+#define SB2_MUXPAD_RG0_rgmii0_rxd_0_src(data)                                        ((0x00030000&(data))>>16)
+#define SB2_MUXPAD_RG0_get_rgmii0_rxd_0(data)                                        ((0x00030000&(data))>>16)
+#define SB2_MUXPAD_RG0_rgmii0_rx_ctl_shift                                           (14)
+#define SB2_MUXPAD_RG0_rgmii0_rx_ctl_mask                                            (0x0000C000)
+#define SB2_MUXPAD_RG0_rgmii0_rx_ctl(data)                                           (0x0000C000&((data)<<14))
+#define SB2_MUXPAD_RG0_rgmii0_rx_ctl_src(data)                                       ((0x0000C000&(data))>>14)
+#define SB2_MUXPAD_RG0_get_rgmii0_rx_ctl(data)                                       ((0x0000C000&(data))>>14)
+#define SB2_MUXPAD_RG0_rgmii0_rxc_shift                                              (12)
+#define SB2_MUXPAD_RG0_rgmii0_rxc_mask                                               (0x00003000)
+#define SB2_MUXPAD_RG0_rgmii0_rxc(data)                                              (0x00003000&((data)<<12))
+#define SB2_MUXPAD_RG0_rgmii0_rxc_src(data)                                          ((0x00003000&(data))>>12)
+#define SB2_MUXPAD_RG0_get_rgmii0_rxc(data)                                          ((0x00003000&(data))>>12)
+#define SB2_MUXPAD_RG0_rgmii0_txd_3_shift                                            (10)
+#define SB2_MUXPAD_RG0_rgmii0_txd_3_mask                                             (0x00000C00)
+#define SB2_MUXPAD_RG0_rgmii0_txd_3(data)                                            (0x00000C00&((data)<<10))
+#define SB2_MUXPAD_RG0_rgmii0_txd_3_src(data)                                        ((0x00000C00&(data))>>10)
+#define SB2_MUXPAD_RG0_get_rgmii0_txd_3(data)                                        ((0x00000C00&(data))>>10)
+#define SB2_MUXPAD_RG0_rgmii0_txd_2_shift                                            (8)
+#define SB2_MUXPAD_RG0_rgmii0_txd_2_mask                                             (0x00000300)
+#define SB2_MUXPAD_RG0_rgmii0_txd_2(data)                                            (0x00000300&((data)<<8))
+#define SB2_MUXPAD_RG0_rgmii0_txd_2_src(data)                                        ((0x00000300&(data))>>8)
+#define SB2_MUXPAD_RG0_get_rgmii0_txd_2(data)                                        ((0x00000300&(data))>>8)
+#define SB2_MUXPAD_RG0_rgmii0_txd_1_shift                                            (6)
+#define SB2_MUXPAD_RG0_rgmii0_txd_1_mask                                             (0x000000C0)
+#define SB2_MUXPAD_RG0_rgmii0_txd_1(data)                                            (0x000000C0&((data)<<6))
+#define SB2_MUXPAD_RG0_rgmii0_txd_1_src(data)                                        ((0x000000C0&(data))>>6)
+#define SB2_MUXPAD_RG0_get_rgmii0_txd_1(data)                                        ((0x000000C0&(data))>>6)
+#define SB2_MUXPAD_RG0_rgmii0_txd_0_shift                                            (4)
+#define SB2_MUXPAD_RG0_rgmii0_txd_0_mask                                             (0x00000030)
+#define SB2_MUXPAD_RG0_rgmii0_txd_0(data)                                            (0x00000030&((data)<<4))
+#define SB2_MUXPAD_RG0_rgmii0_txd_0_src(data)                                        ((0x00000030&(data))>>4)
+#define SB2_MUXPAD_RG0_get_rgmii0_txd_0(data)                                        ((0x00000030&(data))>>4)
+#define SB2_MUXPAD_RG0_rgmii0_tx_ctl_shift                                           (2)
+#define SB2_MUXPAD_RG0_rgmii0_tx_ctl_mask                                            (0x0000000C)
+#define SB2_MUXPAD_RG0_rgmii0_tx_ctl(data)                                           (0x0000000C&((data)<<2))
+#define SB2_MUXPAD_RG0_rgmii0_tx_ctl_src(data)                                       ((0x0000000C&(data))>>2)
+#define SB2_MUXPAD_RG0_get_rgmii0_tx_ctl(data)                                       ((0x0000000C&(data))>>2)
+#define SB2_MUXPAD_RG0_rgmii0_txc_shift                                              (0)
+#define SB2_MUXPAD_RG0_rgmii0_txc_mask                                               (0x00000003)
+#define SB2_MUXPAD_RG0_rgmii0_txc(data)                                              (0x00000003&((data)<<0))
+#define SB2_MUXPAD_RG0_rgmii0_txc_src(data)                                          ((0x00000003&(data))>>0)
+#define SB2_MUXPAD_RG0_get_rgmii0_txc(data)                                          ((0x00000003&(data))>>0)
+
+
+#define SB2_PFUNC_RG3                                                                0x9801A970
+#define SB2_PFUNC_RG3_reg_addr                                                       "0xD801A970"
+#define SB2_PFUNC_RG3_reg                                                            0xD801A970
+#define set_SB2_PFUNC_RG3_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_RG3_reg)=data)
+#define get_SB2_PFUNC_RG3_reg   (*((volatile unsigned int*) SB2_PFUNC_RG3_reg))
+#define SB2_PFUNC_RG3_inst_adr                                                       "0x005C"
+#define SB2_PFUNC_RG3_inst                                                           0x005C
+#define SB2_PFUNC_RG3_rgmii1_txd_3_sr_shift                                          (5)
+#define SB2_PFUNC_RG3_rgmii1_txd_3_sr_mask                                           (0x00000020)
+#define SB2_PFUNC_RG3_rgmii1_txd_3_sr(data)                                          (0x00000020&((data)<<5))
+#define SB2_PFUNC_RG3_rgmii1_txd_3_sr_src(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG3_get_rgmii1_txd_3_sr(data)                                      ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG3_rgmii1_txd_2_sr_shift                                          (4)
+#define SB2_PFUNC_RG3_rgmii1_txd_2_sr_mask                                           (0x00000010)
+#define SB2_PFUNC_RG3_rgmii1_txd_2_sr(data)                                          (0x00000010&((data)<<4))
+#define SB2_PFUNC_RG3_rgmii1_txd_2_sr_src(data)                                      ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG3_get_rgmii1_txd_2_sr(data)                                      ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG3_rgmii1_txd_1_sr_shift                                          (3)
+#define SB2_PFUNC_RG3_rgmii1_txd_1_sr_mask                                           (0x00000008)
+#define SB2_PFUNC_RG3_rgmii1_txd_1_sr(data)                                          (0x00000008&((data)<<3))
+#define SB2_PFUNC_RG3_rgmii1_txd_1_sr_src(data)                                      ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG3_get_rgmii1_txd_1_sr(data)                                      ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG3_rgmii1_txd_0_sr_shift                                          (2)
+#define SB2_PFUNC_RG3_rgmii1_txd_0_sr_mask                                           (0x00000004)
+#define SB2_PFUNC_RG3_rgmii1_txd_0_sr(data)                                          (0x00000004&((data)<<2))
+#define SB2_PFUNC_RG3_rgmii1_txd_0_sr_src(data)                                      ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG3_get_rgmii1_txd_0_sr(data)                                      ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG3_rgmii1_tx_ctl_sr_shift                                         (1)
+#define SB2_PFUNC_RG3_rgmii1_tx_ctl_sr_mask                                          (0x00000002)
+#define SB2_PFUNC_RG3_rgmii1_tx_ctl_sr(data)                                         (0x00000002&((data)<<1))
+#define SB2_PFUNC_RG3_rgmii1_tx_ctl_sr_src(data)                                     ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG3_get_rgmii1_tx_ctl_sr(data)                                     ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG3_rgmii1_txc_sr_shift                                            (0)
+#define SB2_PFUNC_RG3_rgmii1_txc_sr_mask                                             (0x00000001)
+#define SB2_PFUNC_RG3_rgmii1_txc_sr(data)                                            (0x00000001&((data)<<0))
+#define SB2_PFUNC_RG3_rgmii1_txc_sr_src(data)                                        ((0x00000001&(data))>>0)
+#define SB2_PFUNC_RG3_get_rgmii1_txc_sr(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SB2_PFUNC_RG4                                                                0x9801A974
+#define SB2_PFUNC_RG4_reg_addr                                                       "0xD801A974"
+#define SB2_PFUNC_RG4_reg                                                            0xD801A974
+#define set_SB2_PFUNC_RG4_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_RG4_reg)=data)
+#define get_SB2_PFUNC_RG4_reg   (*((volatile unsigned int*) SB2_PFUNC_RG4_reg))
+#define SB2_PFUNC_RG4_inst_adr                                                       "0x005D"
+#define SB2_PFUNC_RG4_inst                                                           0x005D
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_smt_shift                                        (31)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_smt_mask                                         (0x80000000)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_smt(data)                                        (0x80000000&((data)<<31))
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_smt_src(data)                                    ((0x80000000&(data))>>31)
+#define SB2_PFUNC_RG4_get_rgmii1_rx_ctl_smt(data)                                    ((0x80000000&(data))>>31)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_e2_shift                                         (30)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_e2_mask                                          (0x40000000)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_e2(data)                                         (0x40000000&((data)<<30))
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_e2_src(data)                                     ((0x40000000&(data))>>30)
+#define SB2_PFUNC_RG4_get_rgmii1_rx_ctl_e2(data)                                     ((0x40000000&(data))>>30)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_pud_en_shift                                     (29)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_pud_en_mask                                      (0x20000000)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_pud_en(data)                                     (0x20000000&((data)<<29))
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_pud_en_src(data)                                 ((0x20000000&(data))>>29)
+#define SB2_PFUNC_RG4_get_rgmii1_rx_ctl_pud_en(data)                                 ((0x20000000&(data))>>29)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_pud_sel_shift                                    (28)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_pud_sel_mask                                     (0x10000000)
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_pud_sel(data)                                    (0x10000000&((data)<<28))
+#define SB2_PFUNC_RG4_rgmii1_rx_ctl_pud_sel_src(data)                                ((0x10000000&(data))>>28)
+#define SB2_PFUNC_RG4_get_rgmii1_rx_ctl_pud_sel(data)                                ((0x10000000&(data))>>28)
+#define SB2_PFUNC_RG4_rgmii1_rxc_smt_shift                                           (27)
+#define SB2_PFUNC_RG4_rgmii1_rxc_smt_mask                                            (0x08000000)
+#define SB2_PFUNC_RG4_rgmii1_rxc_smt(data)                                           (0x08000000&((data)<<27))
+#define SB2_PFUNC_RG4_rgmii1_rxc_smt_src(data)                                       ((0x08000000&(data))>>27)
+#define SB2_PFUNC_RG4_get_rgmii1_rxc_smt(data)                                       ((0x08000000&(data))>>27)
+#define SB2_PFUNC_RG4_rgmii1_rxc_e2_shift                                            (26)
+#define SB2_PFUNC_RG4_rgmii1_rxc_e2_mask                                             (0x04000000)
+#define SB2_PFUNC_RG4_rgmii1_rxc_e2(data)                                            (0x04000000&((data)<<26))
+#define SB2_PFUNC_RG4_rgmii1_rxc_e2_src(data)                                        ((0x04000000&(data))>>26)
+#define SB2_PFUNC_RG4_get_rgmii1_rxc_e2(data)                                        ((0x04000000&(data))>>26)
+#define SB2_PFUNC_RG4_rgmii1_rxc_pud_en_shift                                        (25)
+#define SB2_PFUNC_RG4_rgmii1_rxc_pud_en_mask                                         (0x02000000)
+#define SB2_PFUNC_RG4_rgmii1_rxc_pud_en(data)                                        (0x02000000&((data)<<25))
+#define SB2_PFUNC_RG4_rgmii1_rxc_pud_en_src(data)                                    ((0x02000000&(data))>>25)
+#define SB2_PFUNC_RG4_get_rgmii1_rxc_pud_en(data)                                    ((0x02000000&(data))>>25)
+#define SB2_PFUNC_RG4_rgmii1_rxc_pud_sel_shift                                       (24)
+#define SB2_PFUNC_RG4_rgmii1_rxc_pud_sel_mask                                        (0x01000000)
+#define SB2_PFUNC_RG4_rgmii1_rxc_pud_sel(data)                                       (0x01000000&((data)<<24))
+#define SB2_PFUNC_RG4_rgmii1_rxc_pud_sel_src(data)                                   ((0x01000000&(data))>>24)
+#define SB2_PFUNC_RG4_get_rgmii1_rxc_pud_sel(data)                                   ((0x01000000&(data))>>24)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_smt_shift                                         (23)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_smt_mask                                          (0x00800000)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_smt(data)                                         (0x00800000&((data)<<23))
+#define SB2_PFUNC_RG4_rgmii1_txd_3_smt_src(data)                                     ((0x00800000&(data))>>23)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_3_smt(data)                                     ((0x00800000&(data))>>23)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_e2_shift                                          (22)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_e2_mask                                           (0x00400000)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_e2(data)                                          (0x00400000&((data)<<22))
+#define SB2_PFUNC_RG4_rgmii1_txd_3_e2_src(data)                                      ((0x00400000&(data))>>22)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_3_e2(data)                                      ((0x00400000&(data))>>22)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_pud_en_shift                                      (21)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_pud_en_mask                                       (0x00200000)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_pud_en(data)                                      (0x00200000&((data)<<21))
+#define SB2_PFUNC_RG4_rgmii1_txd_3_pud_en_src(data)                                  ((0x00200000&(data))>>21)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_3_pud_en(data)                                  ((0x00200000&(data))>>21)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_pud_sel_shift                                     (20)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_pud_sel_mask                                      (0x00100000)
+#define SB2_PFUNC_RG4_rgmii1_txd_3_pud_sel(data)                                     (0x00100000&((data)<<20))
+#define SB2_PFUNC_RG4_rgmii1_txd_3_pud_sel_src(data)                                 ((0x00100000&(data))>>20)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_3_pud_sel(data)                                 ((0x00100000&(data))>>20)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_smt_shift                                         (19)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_smt_mask                                          (0x00080000)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_smt(data)                                         (0x00080000&((data)<<19))
+#define SB2_PFUNC_RG4_rgmii1_txd_2_smt_src(data)                                     ((0x00080000&(data))>>19)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_2_smt(data)                                     ((0x00080000&(data))>>19)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_e2_shift                                          (18)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_e2_mask                                           (0x00040000)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_e2(data)                                          (0x00040000&((data)<<18))
+#define SB2_PFUNC_RG4_rgmii1_txd_2_e2_src(data)                                      ((0x00040000&(data))>>18)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_2_e2(data)                                      ((0x00040000&(data))>>18)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_pud_en_shift                                      (17)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_pud_en_mask                                       (0x00020000)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_pud_en(data)                                      (0x00020000&((data)<<17))
+#define SB2_PFUNC_RG4_rgmii1_txd_2_pud_en_src(data)                                  ((0x00020000&(data))>>17)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_2_pud_en(data)                                  ((0x00020000&(data))>>17)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_pud_sel_shift                                     (16)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_pud_sel_mask                                      (0x00010000)
+#define SB2_PFUNC_RG4_rgmii1_txd_2_pud_sel(data)                                     (0x00010000&((data)<<16))
+#define SB2_PFUNC_RG4_rgmii1_txd_2_pud_sel_src(data)                                 ((0x00010000&(data))>>16)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_2_pud_sel(data)                                 ((0x00010000&(data))>>16)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_smt_shift                                         (15)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_smt_mask                                          (0x00008000)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_smt(data)                                         (0x00008000&((data)<<15))
+#define SB2_PFUNC_RG4_rgmii1_txd_1_smt_src(data)                                     ((0x00008000&(data))>>15)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_1_smt(data)                                     ((0x00008000&(data))>>15)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_e2_shift                                          (14)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_e2_mask                                           (0x00004000)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_e2(data)                                          (0x00004000&((data)<<14))
+#define SB2_PFUNC_RG4_rgmii1_txd_1_e2_src(data)                                      ((0x00004000&(data))>>14)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_1_e2(data)                                      ((0x00004000&(data))>>14)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_pud_en_shift                                      (13)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_pud_en_mask                                       (0x00002000)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_pud_en(data)                                      (0x00002000&((data)<<13))
+#define SB2_PFUNC_RG4_rgmii1_txd_1_pud_en_src(data)                                  ((0x00002000&(data))>>13)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_1_pud_en(data)                                  ((0x00002000&(data))>>13)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_pud_sel_shift                                     (12)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_pud_sel_mask                                      (0x00001000)
+#define SB2_PFUNC_RG4_rgmii1_txd_1_pud_sel(data)                                     (0x00001000&((data)<<12))
+#define SB2_PFUNC_RG4_rgmii1_txd_1_pud_sel_src(data)                                 ((0x00001000&(data))>>12)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_1_pud_sel(data)                                 ((0x00001000&(data))>>12)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_smt_shift                                         (11)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_smt_mask                                          (0x00000800)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_smt(data)                                         (0x00000800&((data)<<11))
+#define SB2_PFUNC_RG4_rgmii1_txd_0_smt_src(data)                                     ((0x00000800&(data))>>11)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_0_smt(data)                                     ((0x00000800&(data))>>11)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_e2_shift                                          (10)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_e2_mask                                           (0x00000400)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_e2(data)                                          (0x00000400&((data)<<10))
+#define SB2_PFUNC_RG4_rgmii1_txd_0_e2_src(data)                                      ((0x00000400&(data))>>10)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_0_e2(data)                                      ((0x00000400&(data))>>10)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_pud_en_shift                                      (9)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_pud_en_mask                                       (0x00000200)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_pud_en(data)                                      (0x00000200&((data)<<9))
+#define SB2_PFUNC_RG4_rgmii1_txd_0_pud_en_src(data)                                  ((0x00000200&(data))>>9)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_0_pud_en(data)                                  ((0x00000200&(data))>>9)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_pud_sel_shift                                     (8)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_pud_sel_mask                                      (0x00000100)
+#define SB2_PFUNC_RG4_rgmii1_txd_0_pud_sel(data)                                     (0x00000100&((data)<<8))
+#define SB2_PFUNC_RG4_rgmii1_txd_0_pud_sel_src(data)                                 ((0x00000100&(data))>>8)
+#define SB2_PFUNC_RG4_get_rgmii1_txd_0_pud_sel(data)                                 ((0x00000100&(data))>>8)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_smt_shift                                        (7)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_smt_mask                                         (0x00000080)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_smt(data)                                        (0x00000080&((data)<<7))
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_smt_src(data)                                    ((0x00000080&(data))>>7)
+#define SB2_PFUNC_RG4_get_rgmii1_tx_ctl_smt(data)                                    ((0x00000080&(data))>>7)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_e2_shift                                         (6)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_e2_mask                                          (0x00000040)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_e2(data)                                         (0x00000040&((data)<<6))
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_e2_src(data)                                     ((0x00000040&(data))>>6)
+#define SB2_PFUNC_RG4_get_rgmii1_tx_ctl_e2(data)                                     ((0x00000040&(data))>>6)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_pud_en_shift                                     (5)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_pud_en_mask                                      (0x00000020)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_pud_en(data)                                     (0x00000020&((data)<<5))
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_pud_en_src(data)                                 ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG4_get_rgmii1_tx_ctl_pud_en(data)                                 ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_pud_sel_shift                                    (4)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_pud_sel_mask                                     (0x00000010)
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_pud_sel(data)                                    (0x00000010&((data)<<4))
+#define SB2_PFUNC_RG4_rgmii1_tx_ctl_pud_sel_src(data)                                ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG4_get_rgmii1_tx_ctl_pud_sel(data)                                ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG4_rgmii1_txc_smt_shift                                           (3)
+#define SB2_PFUNC_RG4_rgmii1_txc_smt_mask                                            (0x00000008)
+#define SB2_PFUNC_RG4_rgmii1_txc_smt(data)                                           (0x00000008&((data)<<3))
+#define SB2_PFUNC_RG4_rgmii1_txc_smt_src(data)                                       ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG4_get_rgmii1_txc_smt(data)                                       ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG4_rgmii1_txc_e2_shift                                            (2)
+#define SB2_PFUNC_RG4_rgmii1_txc_e2_mask                                             (0x00000004)
+#define SB2_PFUNC_RG4_rgmii1_txc_e2(data)                                            (0x00000004&((data)<<2))
+#define SB2_PFUNC_RG4_rgmii1_txc_e2_src(data)                                        ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG4_get_rgmii1_txc_e2(data)                                        ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG4_rgmii1_txc_pud_en_shift                                        (1)
+#define SB2_PFUNC_RG4_rgmii1_txc_pud_en_mask                                         (0x00000002)
+#define SB2_PFUNC_RG4_rgmii1_txc_pud_en(data)                                        (0x00000002&((data)<<1))
+#define SB2_PFUNC_RG4_rgmii1_txc_pud_en_src(data)                                    ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG4_get_rgmii1_txc_pud_en(data)                                    ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG4_rgmii1_txc_pud_sel_shift                                       (0)
+#define SB2_PFUNC_RG4_rgmii1_txc_pud_sel_mask                                        (0x00000001)
+#define SB2_PFUNC_RG4_rgmii1_txc_pud_sel(data)                                       (0x00000001&((data)<<0))
+#define SB2_PFUNC_RG4_rgmii1_txc_pud_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define SB2_PFUNC_RG4_get_rgmii1_txc_pud_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SB2_PFUNC_RG5                                                                0x9801A978
+#define SB2_PFUNC_RG5_reg_addr                                                       "0xD801A978"
+#define SB2_PFUNC_RG5_reg                                                            0xD801A978
+#define set_SB2_PFUNC_RG5_reg(data)   (*((volatile unsigned int*) SB2_PFUNC_RG5_reg)=data)
+#define get_SB2_PFUNC_RG5_reg   (*((volatile unsigned int*) SB2_PFUNC_RG5_reg))
+#define SB2_PFUNC_RG5_inst_adr                                                       "0x005E"
+#define SB2_PFUNC_RG5_inst                                                           0x005E
+#define SB2_PFUNC_RG5_rgmii1_bias_mode2_shift                                        (31)
+#define SB2_PFUNC_RG5_rgmii1_bias_mode2_mask                                         (0x80000000)
+#define SB2_PFUNC_RG5_rgmii1_bias_mode2(data)                                        (0x80000000&((data)<<31))
+#define SB2_PFUNC_RG5_rgmii1_bias_mode2_src(data)                                    ((0x80000000&(data))>>31)
+#define SB2_PFUNC_RG5_get_rgmii1_bias_mode2(data)                                    ((0x80000000&(data))>>31)
+#define SB2_PFUNC_RG5_rgmii1_bias_mode_shift                                         (30)
+#define SB2_PFUNC_RG5_rgmii1_bias_mode_mask                                          (0x40000000)
+#define SB2_PFUNC_RG5_rgmii1_bias_mode(data)                                         (0x40000000&((data)<<30))
+#define SB2_PFUNC_RG5_rgmii1_bias_mode_src(data)                                     ((0x40000000&(data))>>30)
+#define SB2_PFUNC_RG5_get_rgmii1_bias_mode(data)                                     ((0x40000000&(data))>>30)
+#define SB2_PFUNC_RG5_rgmii1_bias_dn_shift                                           (27)
+#define SB2_PFUNC_RG5_rgmii1_bias_dn_mask                                            (0x38000000)
+#define SB2_PFUNC_RG5_rgmii1_bias_dn(data)                                           (0x38000000&((data)<<27))
+#define SB2_PFUNC_RG5_rgmii1_bias_dn_src(data)                                       ((0x38000000&(data))>>27)
+#define SB2_PFUNC_RG5_get_rgmii1_bias_dn(data)                                       ((0x38000000&(data))>>27)
+#define SB2_PFUNC_RG5_rgmii1_bias_dp_shift                                           (24)
+#define SB2_PFUNC_RG5_rgmii1_bias_dp_mask                                            (0x07000000)
+#define SB2_PFUNC_RG5_rgmii1_bias_dp(data)                                           (0x07000000&((data)<<24))
+#define SB2_PFUNC_RG5_rgmii1_bias_dp_src(data)                                       ((0x07000000&(data))>>24)
+#define SB2_PFUNC_RG5_get_rgmii1_bias_dp(data)                                       ((0x07000000&(data))>>24)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_smt_shift                                         (15)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_smt_mask                                          (0x00008000)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_smt(data)                                         (0x00008000&((data)<<15))
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_smt_src(data)                                     ((0x00008000&(data))>>15)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_3_smt(data)                                     ((0x00008000&(data))>>15)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_e2_shift                                          (14)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_e2_mask                                           (0x00004000)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_e2(data)                                          (0x00004000&((data)<<14))
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_e2_src(data)                                      ((0x00004000&(data))>>14)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_3_e2(data)                                      ((0x00004000&(data))>>14)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_pud_en_shift                                      (13)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_pud_en_mask                                       (0x00002000)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_pud_en(data)                                      (0x00002000&((data)<<13))
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_pud_en_src(data)                                  ((0x00002000&(data))>>13)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_3_pud_en(data)                                  ((0x00002000&(data))>>13)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_pud_sel_shift                                     (12)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_pud_sel_mask                                      (0x00001000)
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_pud_sel(data)                                     (0x00001000&((data)<<12))
+#define SB2_PFUNC_RG5_rgmii1_rxd_3_pud_sel_src(data)                                 ((0x00001000&(data))>>12)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_3_pud_sel(data)                                 ((0x00001000&(data))>>12)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_smt_shift                                         (11)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_smt_mask                                          (0x00000800)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_smt(data)                                         (0x00000800&((data)<<11))
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_smt_src(data)                                     ((0x00000800&(data))>>11)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_2_smt(data)                                     ((0x00000800&(data))>>11)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_e2_shift                                          (10)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_e2_mask                                           (0x00000400)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_e2(data)                                          (0x00000400&((data)<<10))
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_e2_src(data)                                      ((0x00000400&(data))>>10)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_2_e2(data)                                      ((0x00000400&(data))>>10)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_pud_en_shift                                      (9)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_pud_en_mask                                       (0x00000200)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_pud_en(data)                                      (0x00000200&((data)<<9))
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_pud_en_src(data)                                  ((0x00000200&(data))>>9)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_2_pud_en(data)                                  ((0x00000200&(data))>>9)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_pud_sel_shift                                     (8)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_pud_sel_mask                                      (0x00000100)
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_pud_sel(data)                                     (0x00000100&((data)<<8))
+#define SB2_PFUNC_RG5_rgmii1_rxd_2_pud_sel_src(data)                                 ((0x00000100&(data))>>8)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_2_pud_sel(data)                                 ((0x00000100&(data))>>8)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_smt_shift                                         (7)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_smt_mask                                          (0x00000080)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_smt(data)                                         (0x00000080&((data)<<7))
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_smt_src(data)                                     ((0x00000080&(data))>>7)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_1_smt(data)                                     ((0x00000080&(data))>>7)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_e2_shift                                          (6)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_e2_mask                                           (0x00000040)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_e2(data)                                          (0x00000040&((data)<<6))
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_e2_src(data)                                      ((0x00000040&(data))>>6)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_1_e2(data)                                      ((0x00000040&(data))>>6)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_pud_en_shift                                      (5)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_pud_en_mask                                       (0x00000020)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_pud_en(data)                                      (0x00000020&((data)<<5))
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_pud_en_src(data)                                  ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_1_pud_en(data)                                  ((0x00000020&(data))>>5)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_pud_sel_shift                                     (4)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_pud_sel_mask                                      (0x00000010)
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_pud_sel(data)                                     (0x00000010&((data)<<4))
+#define SB2_PFUNC_RG5_rgmii1_rxd_1_pud_sel_src(data)                                 ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_1_pud_sel(data)                                 ((0x00000010&(data))>>4)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_smt_shift                                         (3)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_smt_mask                                          (0x00000008)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_smt(data)                                         (0x00000008&((data)<<3))
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_smt_src(data)                                     ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_0_smt(data)                                     ((0x00000008&(data))>>3)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_e2_shift                                          (2)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_e2_mask                                           (0x00000004)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_e2(data)                                          (0x00000004&((data)<<2))
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_e2_src(data)                                      ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_0_e2(data)                                      ((0x00000004&(data))>>2)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_pud_en_shift                                      (1)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_pud_en_mask                                       (0x00000002)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_pud_en(data)                                      (0x00000002&((data)<<1))
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_pud_en_src(data)                                  ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_0_pud_en(data)                                  ((0x00000002&(data))>>1)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_pud_sel_shift                                     (0)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_pud_sel_mask                                      (0x00000001)
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_pud_sel(data)                                     (0x00000001&((data)<<0))
+#define SB2_PFUNC_RG5_rgmii1_rxd_0_pud_sel_src(data)                                 ((0x00000001&(data))>>0)
+#define SB2_PFUNC_RG5_get_rgmii1_rxd_0_pud_sel(data)                                 ((0x00000001&(data))>>0)
+
+
+#define SB2_MUXPAD_RG1                                                               0x9801A97C
+#define SB2_MUXPAD_RG1_reg_addr                                                      "0xD801A97C"
+#define SB2_MUXPAD_RG1_reg                                                           0xD801A97C
+#define set_SB2_MUXPAD_RG1_reg(data)   (*((volatile unsigned int*) SB2_MUXPAD_RG1_reg)=data)
+#define get_SB2_MUXPAD_RG1_reg   (*((volatile unsigned int*) SB2_MUXPAD_RG1_reg))
+#define SB2_MUXPAD_RG1_inst_adr                                                      "0x005F"
+#define SB2_MUXPAD_RG1_inst                                                          0x005F
+#define SB2_MUXPAD_RG1_rgmii1_mdc_shift                                              (26)
+#define SB2_MUXPAD_RG1_rgmii1_mdc_mask                                               (0x0C000000)
+#define SB2_MUXPAD_RG1_rgmii1_mdc(data)                                              (0x0C000000&((data)<<26))
+#define SB2_MUXPAD_RG1_rgmii1_mdc_src(data)                                          ((0x0C000000&(data))>>26)
+#define SB2_MUXPAD_RG1_get_rgmii1_mdc(data)                                          ((0x0C000000&(data))>>26)
+#define SB2_MUXPAD_RG1_rgmii1_mdio_shift                                             (24)
+#define SB2_MUXPAD_RG1_rgmii1_mdio_mask                                              (0x03000000)
+#define SB2_MUXPAD_RG1_rgmii1_mdio(data)                                             (0x03000000&((data)<<24))
+#define SB2_MUXPAD_RG1_rgmii1_mdio_src(data)                                         ((0x03000000&(data))>>24)
+#define SB2_MUXPAD_RG1_get_rgmii1_mdio(data)                                         ((0x03000000&(data))>>24)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_3_shift                                            (22)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_3_mask                                             (0x00C00000)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_3(data)                                            (0x00C00000&((data)<<22))
+#define SB2_MUXPAD_RG1_rgmii1_rxd_3_src(data)                                        ((0x00C00000&(data))>>22)
+#define SB2_MUXPAD_RG1_get_rgmii1_rxd_3(data)                                        ((0x00C00000&(data))>>22)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_2_shift                                            (20)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_2_mask                                             (0x00300000)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_2(data)                                            (0x00300000&((data)<<20))
+#define SB2_MUXPAD_RG1_rgmii1_rxd_2_src(data)                                        ((0x00300000&(data))>>20)
+#define SB2_MUXPAD_RG1_get_rgmii1_rxd_2(data)                                        ((0x00300000&(data))>>20)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_1_shift                                            (18)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_1_mask                                             (0x000C0000)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_1(data)                                            (0x000C0000&((data)<<18))
+#define SB2_MUXPAD_RG1_rgmii1_rxd_1_src(data)                                        ((0x000C0000&(data))>>18)
+#define SB2_MUXPAD_RG1_get_rgmii1_rxd_1(data)                                        ((0x000C0000&(data))>>18)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_0_shift                                            (16)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_0_mask                                             (0x00030000)
+#define SB2_MUXPAD_RG1_rgmii1_rxd_0(data)                                            (0x00030000&((data)<<16))
+#define SB2_MUXPAD_RG1_rgmii1_rxd_0_src(data)                                        ((0x00030000&(data))>>16)
+#define SB2_MUXPAD_RG1_get_rgmii1_rxd_0(data)                                        ((0x00030000&(data))>>16)
+#define SB2_MUXPAD_RG1_rgmii1_rx_ctl_shift                                           (14)
+#define SB2_MUXPAD_RG1_rgmii1_rx_ctl_mask                                            (0x0000C000)
+#define SB2_MUXPAD_RG1_rgmii1_rx_ctl(data)                                           (0x0000C000&((data)<<14))
+#define SB2_MUXPAD_RG1_rgmii1_rx_ctl_src(data)                                       ((0x0000C000&(data))>>14)
+#define SB2_MUXPAD_RG1_get_rgmii1_rx_ctl(data)                                       ((0x0000C000&(data))>>14)
+#define SB2_MUXPAD_RG1_rgmii1_rxc_shift                                              (12)
+#define SB2_MUXPAD_RG1_rgmii1_rxc_mask                                               (0x00003000)
+#define SB2_MUXPAD_RG1_rgmii1_rxc(data)                                              (0x00003000&((data)<<12))
+#define SB2_MUXPAD_RG1_rgmii1_rxc_src(data)                                          ((0x00003000&(data))>>12)
+#define SB2_MUXPAD_RG1_get_rgmii1_rxc(data)                                          ((0x00003000&(data))>>12)
+#define SB2_MUXPAD_RG1_rgmii1_txd_3_shift                                            (10)
+#define SB2_MUXPAD_RG1_rgmii1_txd_3_mask                                             (0x00000C00)
+#define SB2_MUXPAD_RG1_rgmii1_txd_3(data)                                            (0x00000C00&((data)<<10))
+#define SB2_MUXPAD_RG1_rgmii1_txd_3_src(data)                                        ((0x00000C00&(data))>>10)
+#define SB2_MUXPAD_RG1_get_rgmii1_txd_3(data)                                        ((0x00000C00&(data))>>10)
+#define SB2_MUXPAD_RG1_rgmii1_txd_2_shift                                            (8)
+#define SB2_MUXPAD_RG1_rgmii1_txd_2_mask                                             (0x00000300)
+#define SB2_MUXPAD_RG1_rgmii1_txd_2(data)                                            (0x00000300&((data)<<8))
+#define SB2_MUXPAD_RG1_rgmii1_txd_2_src(data)                                        ((0x00000300&(data))>>8)
+#define SB2_MUXPAD_RG1_get_rgmii1_txd_2(data)                                        ((0x00000300&(data))>>8)
+#define SB2_MUXPAD_RG1_rgmii1_txd_1_shift                                            (6)
+#define SB2_MUXPAD_RG1_rgmii1_txd_1_mask                                             (0x000000C0)
+#define SB2_MUXPAD_RG1_rgmii1_txd_1(data)                                            (0x000000C0&((data)<<6))
+#define SB2_MUXPAD_RG1_rgmii1_txd_1_src(data)                                        ((0x000000C0&(data))>>6)
+#define SB2_MUXPAD_RG1_get_rgmii1_txd_1(data)                                        ((0x000000C0&(data))>>6)
+#define SB2_MUXPAD_RG1_rgmii1_txd_0_shift                                            (4)
+#define SB2_MUXPAD_RG1_rgmii1_txd_0_mask                                             (0x00000030)
+#define SB2_MUXPAD_RG1_rgmii1_txd_0(data)                                            (0x00000030&((data)<<4))
+#define SB2_MUXPAD_RG1_rgmii1_txd_0_src(data)                                        ((0x00000030&(data))>>4)
+#define SB2_MUXPAD_RG1_get_rgmii1_txd_0(data)                                        ((0x00000030&(data))>>4)
+#define SB2_MUXPAD_RG1_rgmii1_tx_ctl_shift                                           (2)
+#define SB2_MUXPAD_RG1_rgmii1_tx_ctl_mask                                            (0x0000000C)
+#define SB2_MUXPAD_RG1_rgmii1_tx_ctl(data)                                           (0x0000000C&((data)<<2))
+#define SB2_MUXPAD_RG1_rgmii1_tx_ctl_src(data)                                       ((0x0000000C&(data))>>2)
+#define SB2_MUXPAD_RG1_get_rgmii1_tx_ctl(data)                                       ((0x0000000C&(data))>>2)
+#define SB2_MUXPAD_RG1_rgmii1_txc_shift                                              (0)
+#define SB2_MUXPAD_RG1_rgmii1_txc_mask                                               (0x00000003)
+#define SB2_MUXPAD_RG1_rgmii1_txc(data)                                              (0x00000003&((data)<<0))
+#define SB2_MUXPAD_RG1_rgmii1_txc_src(data)                                          ((0x00000003&(data))>>0)
+#define SB2_MUXPAD_RG1_get_rgmii1_txc(data)                                          ((0x00000003&(data))>>0)
+
+
+#define SB2_SATA_PHY_CTRL                                                            0x9801A980
+#define SB2_SATA_PHY_CTRL_reg_addr                                                   "0xD801A980"
+#define SB2_SATA_PHY_CTRL_reg                                                        0xD801A980
+#define set_SB2_SATA_PHY_CTRL_reg(data)   (*((volatile unsigned int*) SB2_SATA_PHY_CTRL_reg)=data)
+#define get_SB2_SATA_PHY_CTRL_reg   (*((volatile unsigned int*) SB2_SATA_PHY_CTRL_reg))
+#define SB2_SATA_PHY_CTRL_inst_adr                                                   "0x0060"
+#define SB2_SATA_PHY_CTRL_inst                                                       0x0060
+#define SB2_SATA_PHY_CTRL_sata_sgmii_sel_shift                                       (8)
+#define SB2_SATA_PHY_CTRL_sata_sgmii_sel_mask                                        (0x00000100)
+#define SB2_SATA_PHY_CTRL_sata_sgmii_sel(data)                                       (0x00000100&((data)<<8))
+#define SB2_SATA_PHY_CTRL_sata_sgmii_sel_src(data)                                   ((0x00000100&(data))>>8)
+#define SB2_SATA_PHY_CTRL_get_sata_sgmii_sel(data)                                   ((0x00000100&(data))>>8)
+#define SB2_SATA_PHY_CTRL_isolate_sata_sgmii_1_shift                                 (7)
+#define SB2_SATA_PHY_CTRL_isolate_sata_sgmii_1_mask                                  (0x00000080)
+#define SB2_SATA_PHY_CTRL_isolate_sata_sgmii_1(data)                                 (0x00000080&((data)<<7))
+#define SB2_SATA_PHY_CTRL_isolate_sata_sgmii_1_src(data)                             ((0x00000080&(data))>>7)
+#define SB2_SATA_PHY_CTRL_get_isolate_sata_sgmii_1(data)                             ((0x00000080&(data))>>7)
+#define SB2_SATA_PHY_CTRL_isolate_sata_sgmii_0_shift                                 (6)
+#define SB2_SATA_PHY_CTRL_isolate_sata_sgmii_0_mask                                  (0x00000040)
+#define SB2_SATA_PHY_CTRL_isolate_sata_sgmii_0(data)                                 (0x00000040&((data)<<6))
+#define SB2_SATA_PHY_CTRL_isolate_sata_sgmii_0_src(data)                             ((0x00000040&(data))>>6)
+#define SB2_SATA_PHY_CTRL_get_isolate_sata_sgmii_0(data)                             ((0x00000040&(data))>>6)
+#define SB2_SATA_PHY_CTRL_sata_rx50_link_1_shift                                     (5)
+#define SB2_SATA_PHY_CTRL_sata_rx50_link_1_mask                                      (0x00000020)
+#define SB2_SATA_PHY_CTRL_sata_rx50_link_1(data)                                     (0x00000020&((data)<<5))
+#define SB2_SATA_PHY_CTRL_sata_rx50_link_1_src(data)                                 ((0x00000020&(data))>>5)
+#define SB2_SATA_PHY_CTRL_get_sata_rx50_link_1(data)                                 ((0x00000020&(data))>>5)
+#define SB2_SATA_PHY_CTRL_sata_rx50_link_0_shift                                     (4)
+#define SB2_SATA_PHY_CTRL_sata_rx50_link_0_mask                                      (0x00000010)
+#define SB2_SATA_PHY_CTRL_sata_rx50_link_0(data)                                     (0x00000010&((data)<<4))
+#define SB2_SATA_PHY_CTRL_sata_rx50_link_0_src(data)                                 ((0x00000010&(data))>>4)
+#define SB2_SATA_PHY_CTRL_get_sata_rx50_link_0(data)                                 ((0x00000010&(data))>>4)
+#define SB2_SATA_PHY_CTRL_sata_mbias_en_1_shift                                      (3)
+#define SB2_SATA_PHY_CTRL_sata_mbias_en_1_mask                                       (0x00000008)
+#define SB2_SATA_PHY_CTRL_sata_mbias_en_1(data)                                      (0x00000008&((data)<<3))
+#define SB2_SATA_PHY_CTRL_sata_mbias_en_1_src(data)                                  ((0x00000008&(data))>>3)
+#define SB2_SATA_PHY_CTRL_get_sata_mbias_en_1(data)                                  ((0x00000008&(data))>>3)
+#define SB2_SATA_PHY_CTRL_sata_mbias_en_0_shift                                      (2)
+#define SB2_SATA_PHY_CTRL_sata_mbias_en_0_mask                                       (0x00000004)
+#define SB2_SATA_PHY_CTRL_sata_mbias_en_0(data)                                      (0x00000004&((data)<<2))
+#define SB2_SATA_PHY_CTRL_sata_mbias_en_0_src(data)                                  ((0x00000004&(data))>>2)
+#define SB2_SATA_PHY_CTRL_get_sata_mbias_en_0(data)                                  ((0x00000004&(data))>>2)
+#define SB2_SATA_PHY_CTRL_sata_bg_en_1_shift                                         (1)
+#define SB2_SATA_PHY_CTRL_sata_bg_en_1_mask                                          (0x00000002)
+#define SB2_SATA_PHY_CTRL_sata_bg_en_1(data)                                         (0x00000002&((data)<<1))
+#define SB2_SATA_PHY_CTRL_sata_bg_en_1_src(data)                                     ((0x00000002&(data))>>1)
+#define SB2_SATA_PHY_CTRL_get_sata_bg_en_1(data)                                     ((0x00000002&(data))>>1)
+#define SB2_SATA_PHY_CTRL_sata_bg_en_0_shift                                         (0)
+#define SB2_SATA_PHY_CTRL_sata_bg_en_0_mask                                          (0x00000001)
+#define SB2_SATA_PHY_CTRL_sata_bg_en_0(data)                                         (0x00000001&((data)<<0))
+#define SB2_SATA_PHY_CTRL_sata_bg_en_0_src(data)                                     ((0x00000001&(data))>>0)
+#define SB2_SATA_PHY_CTRL_get_sata_bg_en_0(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SB2_RNG_CTRL                                                                 0x9801AA00
+#define SB2_RNG_CTRL_reg_addr                                                        "0xD801AA00"
+#define SB2_RNG_CTRL_reg                                                             0xD801AA00
+#define set_SB2_RNG_CTRL_reg(data)   (*((volatile unsigned int*) SB2_RNG_CTRL_reg)=data)
+#define get_SB2_RNG_CTRL_reg   (*((volatile unsigned int*) SB2_RNG_CTRL_reg))
+#define SB2_RNG_CTRL_inst_adr                                                        "0x0080"
+#define SB2_RNG_CTRL_inst                                                            0x0080
+#define SB2_RNG_CTRL_lfsr_mode_shift                                                 (17)
+#define SB2_RNG_CTRL_lfsr_mode_mask                                                  (0x00020000)
+#define SB2_RNG_CTRL_lfsr_mode(data)                                                 (0x00020000&((data)<<17))
+#define SB2_RNG_CTRL_lfsr_mode_src(data)                                             ((0x00020000&(data))>>17)
+#define SB2_RNG_CTRL_get_lfsr_mode(data)                                             ((0x00020000&(data))>>17)
+#define SB2_RNG_CTRL_lfsr_bypass_1_shift                                             (16)
+#define SB2_RNG_CTRL_lfsr_bypass_1_mask                                              (0x00010000)
+#define SB2_RNG_CTRL_lfsr_bypass_1(data)                                             (0x00010000&((data)<<16))
+#define SB2_RNG_CTRL_lfsr_bypass_1_src(data)                                         ((0x00010000&(data))>>16)
+#define SB2_RNG_CTRL_get_lfsr_bypass_1(data)                                         ((0x00010000&(data))>>16)
+#define SB2_RNG_CTRL_dbg1_sel_shift                                                  (12)
+#define SB2_RNG_CTRL_dbg1_sel_mask                                                   (0x0000F000)
+#define SB2_RNG_CTRL_dbg1_sel(data)                                                  (0x0000F000&((data)<<12))
+#define SB2_RNG_CTRL_dbg1_sel_src(data)                                              ((0x0000F000&(data))>>12)
+#define SB2_RNG_CTRL_get_dbg1_sel(data)                                              ((0x0000F000&(data))>>12)
+#define SB2_RNG_CTRL_dbg0_sel_shift                                                  (8)
+#define SB2_RNG_CTRL_dbg0_sel_mask                                                   (0x00000F00)
+#define SB2_RNG_CTRL_dbg0_sel(data)                                                  (0x00000F00&((data)<<8))
+#define SB2_RNG_CTRL_dbg0_sel_src(data)                                              ((0x00000F00&(data))>>8)
+#define SB2_RNG_CTRL_get_dbg0_sel(data)                                              ((0x00000F00&(data))>>8)
+#define SB2_RNG_CTRL_corrector_imode_shift                                           (5)
+#define SB2_RNG_CTRL_corrector_imode_mask                                            (0x00000020)
+#define SB2_RNG_CTRL_corrector_imode(data)                                           (0x00000020&((data)<<5))
+#define SB2_RNG_CTRL_corrector_imode_src(data)                                       ((0x00000020&(data))>>5)
+#define SB2_RNG_CTRL_get_corrector_imode(data)                                       ((0x00000020&(data))>>5)
+#define SB2_RNG_CTRL_rng_cali_srst_shift                                             (3)
+#define SB2_RNG_CTRL_rng_cali_srst_mask                                              (0x00000008)
+#define SB2_RNG_CTRL_rng_cali_srst(data)                                             (0x00000008&((data)<<3))
+#define SB2_RNG_CTRL_rng_cali_srst_src(data)                                         ((0x00000008&(data))>>3)
+#define SB2_RNG_CTRL_get_rng_cali_srst(data)                                         ((0x00000008&(data))>>3)
+#define SB2_RNG_CTRL_corrector_bypass_shift                                          (2)
+#define SB2_RNG_CTRL_corrector_bypass_mask                                           (0x00000004)
+#define SB2_RNG_CTRL_corrector_bypass(data)                                          (0x00000004&((data)<<2))
+#define SB2_RNG_CTRL_corrector_bypass_src(data)                                      ((0x00000004&(data))>>2)
+#define SB2_RNG_CTRL_get_corrector_bypass(data)                                      ((0x00000004&(data))>>2)
+#define SB2_RNG_CTRL_clk_hf_sel_shift                                                (1)
+#define SB2_RNG_CTRL_clk_hf_sel_mask                                                 (0x00000002)
+#define SB2_RNG_CTRL_clk_hf_sel(data)                                                (0x00000002&((data)<<1))
+#define SB2_RNG_CTRL_clk_hf_sel_src(data)                                            ((0x00000002&(data))>>1)
+#define SB2_RNG_CTRL_get_clk_hf_sel(data)                                            ((0x00000002&(data))>>1)
+#define SB2_RNG_CTRL_rng_srst_shift                                                  (0)
+#define SB2_RNG_CTRL_rng_srst_mask                                                   (0x00000001)
+#define SB2_RNG_CTRL_rng_srst(data)                                                  (0x00000001&((data)<<0))
+#define SB2_RNG_CTRL_rng_srst_src(data)                                              ((0x00000001&(data))>>0)
+#define SB2_RNG_CTRL_get_rng_srst(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SB2_RNG_ANALOG                                                               0x9801AA14
+#define SB2_RNG_ANALOG_reg_addr                                                      "0xD801AA14"
+#define SB2_RNG_ANALOG_reg                                                           0xD801AA14
+#define set_SB2_RNG_ANALOG_reg(data)   (*((volatile unsigned int*) SB2_RNG_ANALOG_reg)=data)
+#define get_SB2_RNG_ANALOG_reg   (*((volatile unsigned int*) SB2_RNG_ANALOG_reg))
+#define SB2_RNG_ANALOG_inst_adr                                                      "0x0085"
+#define SB2_RNG_ANALOG_inst                                                          0x0085
+#define SB2_RNG_ANALOG_rosc_d_shift                                                  (12)
+#define SB2_RNG_ANALOG_rosc_d_mask                                                   (0x0000F000)
+#define SB2_RNG_ANALOG_rosc_d(data)                                                  (0x0000F000&((data)<<12))
+#define SB2_RNG_ANALOG_rosc_d_src(data)                                              ((0x0000F000&(data))>>12)
+#define SB2_RNG_ANALOG_get_rosc_d(data)                                              ((0x0000F000&(data))>>12)
+#define SB2_RNG_ANALOG_rosc_res_shift                                                (10)
+#define SB2_RNG_ANALOG_rosc_res_mask                                                 (0x00000C00)
+#define SB2_RNG_ANALOG_rosc_res(data)                                                (0x00000C00&((data)<<10))
+#define SB2_RNG_ANALOG_rosc_res_src(data)                                            ((0x00000C00&(data))>>10)
+#define SB2_RNG_ANALOG_get_rosc_res(data)                                            ((0x00000C00&(data))>>10)
+#define SB2_RNG_ANALOG_rosc_div_shift                                                (8)
+#define SB2_RNG_ANALOG_rosc_div_mask                                                 (0x00000300)
+#define SB2_RNG_ANALOG_rosc_div(data)                                                (0x00000300&((data)<<8))
+#define SB2_RNG_ANALOG_rosc_div_src(data)                                            ((0x00000300&(data))>>8)
+#define SB2_RNG_ANALOG_get_rosc_div(data)                                            ((0x00000300&(data))>>8)
+#define SB2_RNG_ANALOG_rosc_gain_shift                                               (6)
+#define SB2_RNG_ANALOG_rosc_gain_mask                                                (0x000000C0)
+#define SB2_RNG_ANALOG_rosc_gain(data)                                               (0x000000C0&((data)<<6))
+#define SB2_RNG_ANALOG_rosc_gain_src(data)                                           ((0x000000C0&(data))>>6)
+#define SB2_RNG_ANALOG_get_rosc_gain(data)                                           ((0x000000C0&(data))>>6)
+#define SB2_RNG_ANALOG_rosc_fs_shift                                                 (4)
+#define SB2_RNG_ANALOG_rosc_fs_mask                                                  (0x00000030)
+#define SB2_RNG_ANALOG_rosc_fs(data)                                                 (0x00000030&((data)<<4))
+#define SB2_RNG_ANALOG_rosc_fs_src(data)                                             ((0x00000030&(data))>>4)
+#define SB2_RNG_ANALOG_get_rosc_fs(data)                                             ((0x00000030&(data))>>4)
+#define SB2_RNG_ANALOG_rosc_test_shift                                               (1)
+#define SB2_RNG_ANALOG_rosc_test_mask                                                (0x00000002)
+#define SB2_RNG_ANALOG_rosc_test(data)                                               (0x00000002&((data)<<1))
+#define SB2_RNG_ANALOG_rosc_test_src(data)                                           ((0x00000002&(data))>>1)
+#define SB2_RNG_ANALOG_get_rosc_test(data)                                           ((0x00000002&(data))>>1)
+#define SB2_RNG_ANALOG_rosc_pow_shift                                                (0)
+#define SB2_RNG_ANALOG_rosc_pow_mask                                                 (0x00000001)
+#define SB2_RNG_ANALOG_rosc_pow(data)                                                (0x00000001&((data)<<0))
+#define SB2_RNG_ANALOG_rosc_pow_src(data)                                            ((0x00000001&(data))>>0)
+#define SB2_RNG_ANALOG_get_rosc_pow(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SB2_RNG_CALI_CHK                                                             0x9801AA18
+#define SB2_RNG_CALI_CHK_reg_addr                                                    "0xD801AA18"
+#define SB2_RNG_CALI_CHK_reg                                                         0xD801AA18
+#define set_SB2_RNG_CALI_CHK_reg(data)   (*((volatile unsigned int*) SB2_RNG_CALI_CHK_reg)=data)
+#define get_SB2_RNG_CALI_CHK_reg   (*((volatile unsigned int*) SB2_RNG_CALI_CHK_reg))
+#define SB2_RNG_CALI_CHK_inst_adr                                                    "0x0086"
+#define SB2_RNG_CALI_CHK_inst                                                        0x0086
+#define SB2_RNG_CALI_CHK_prd_ub_shift                                                (16)
+#define SB2_RNG_CALI_CHK_prd_ub_mask                                                 (0xFFFF0000)
+#define SB2_RNG_CALI_CHK_prd_ub(data)                                                (0xFFFF0000&((data)<<16))
+#define SB2_RNG_CALI_CHK_prd_ub_src(data)                                            ((0xFFFF0000&(data))>>16)
+#define SB2_RNG_CALI_CHK_get_prd_ub(data)                                            ((0xFFFF0000&(data))>>16)
+#define SB2_RNG_CALI_CHK_prd_lb_shift                                                (0)
+#define SB2_RNG_CALI_CHK_prd_lb_mask                                                 (0x0000FFFF)
+#define SB2_RNG_CALI_CHK_prd_lb(data)                                                (0x0000FFFF&((data)<<0))
+#define SB2_RNG_CALI_CHK_prd_lb_src(data)                                            ((0x0000FFFF&(data))>>0)
+#define SB2_RNG_CALI_CHK_get_prd_lb(data)                                            ((0x0000FFFF&(data))>>0)
+
+
+#define SB2_RNG_CALI_CTRL                                                            0x9801AA1C
+#define SB2_RNG_CALI_CTRL_reg_addr                                                   "0xD801AA1C"
+#define SB2_RNG_CALI_CTRL_reg                                                        0xD801AA1C
+#define set_SB2_RNG_CALI_CTRL_reg(data)   (*((volatile unsigned int*) SB2_RNG_CALI_CTRL_reg)=data)
+#define get_SB2_RNG_CALI_CTRL_reg   (*((volatile unsigned int*) SB2_RNG_CALI_CTRL_reg))
+#define SB2_RNG_CALI_CTRL_inst_adr                                                   "0x0087"
+#define SB2_RNG_CALI_CTRL_inst                                                       0x0087
+#define SB2_RNG_CALI_CTRL_shot_num_shift                                             (20)
+#define SB2_RNG_CALI_CTRL_shot_num_mask                                              (0xFFF00000)
+#define SB2_RNG_CALI_CTRL_shot_num(data)                                             (0xFFF00000&((data)<<20))
+#define SB2_RNG_CALI_CTRL_shot_num_src(data)                                         ((0xFFF00000&(data))>>20)
+#define SB2_RNG_CALI_CTRL_get_shot_num(data)                                         ((0xFFF00000&(data))>>20)
+#define SB2_RNG_CALI_CTRL_cyc_num_shift                                              (17)
+#define SB2_RNG_CALI_CTRL_cyc_num_mask                                               (0x000E0000)
+#define SB2_RNG_CALI_CTRL_cyc_num(data)                                              (0x000E0000&((data)<<17))
+#define SB2_RNG_CALI_CTRL_cyc_num_src(data)                                          ((0x000E0000&(data))>>17)
+#define SB2_RNG_CALI_CTRL_get_cyc_num(data)                                          ((0x000E0000&(data))>>17)
+#define SB2_RNG_CALI_CTRL_wait_num_shift                                             (12)
+#define SB2_RNG_CALI_CTRL_wait_num_mask                                              (0x0001F000)
+#define SB2_RNG_CALI_CTRL_wait_num(data)                                             (0x0001F000&((data)<<12))
+#define SB2_RNG_CALI_CTRL_wait_num_src(data)                                         ((0x0001F000&(data))>>12)
+#define SB2_RNG_CALI_CTRL_get_wait_num(data)                                         ((0x0001F000&(data))>>12)
+#define SB2_RNG_CALI_CTRL_trig_num_shift                                             (4)
+#define SB2_RNG_CALI_CTRL_trig_num_mask                                              (0x000001F0)
+#define SB2_RNG_CALI_CTRL_trig_num(data)                                             (0x000001F0&((data)<<4))
+#define SB2_RNG_CALI_CTRL_trig_num_src(data)                                         ((0x000001F0&(data))>>4)
+#define SB2_RNG_CALI_CTRL_get_trig_num(data)                                         ((0x000001F0&(data))>>4)
+#define SB2_RNG_CALI_CTRL_lock_shift                                                 (3)
+#define SB2_RNG_CALI_CTRL_lock_mask                                                  (0x00000008)
+#define SB2_RNG_CALI_CTRL_lock(data)                                                 (0x00000008&((data)<<3))
+#define SB2_RNG_CALI_CTRL_lock_src(data)                                             ((0x00000008&(data))>>3)
+#define SB2_RNG_CALI_CTRL_get_lock(data)                                             ((0x00000008&(data))>>3)
+#define SB2_RNG_CALI_CTRL_shot_mode_shift                                            (2)
+#define SB2_RNG_CALI_CTRL_shot_mode_mask                                             (0x00000004)
+#define SB2_RNG_CALI_CTRL_shot_mode(data)                                            (0x00000004&((data)<<2))
+#define SB2_RNG_CALI_CTRL_shot_mode_src(data)                                        ((0x00000004&(data))>>2)
+#define SB2_RNG_CALI_CTRL_get_shot_mode(data)                                        ((0x00000004&(data))>>2)
+#define SB2_RNG_CALI_CTRL_pol_shift                                                  (1)
+#define SB2_RNG_CALI_CTRL_pol_mask                                                   (0x00000002)
+#define SB2_RNG_CALI_CTRL_pol(data)                                                  (0x00000002&((data)<<1))
+#define SB2_RNG_CALI_CTRL_pol_src(data)                                              ((0x00000002&(data))>>1)
+#define SB2_RNG_CALI_CTRL_get_pol(data)                                              ((0x00000002&(data))>>1)
+#define SB2_RNG_CALI_CTRL_hw_en_shift                                                (0)
+#define SB2_RNG_CALI_CTRL_hw_en_mask                                                 (0x00000001)
+#define SB2_RNG_CALI_CTRL_hw_en(data)                                                (0x00000001&((data)<<0))
+#define SB2_RNG_CALI_CTRL_hw_en_src(data)                                            ((0x00000001&(data))>>0)
+#define SB2_RNG_CALI_CTRL_get_hw_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SB2_RNG_RETURN                                                               0x9801AA20
+#define SB2_RNG_RETURN_reg_addr                                                      "0xD801AA20"
+#define SB2_RNG_RETURN_reg                                                           0xD801AA20
+#define set_SB2_RNG_RETURN_reg(data)   (*((volatile unsigned int*) SB2_RNG_RETURN_reg)=data)
+#define get_SB2_RNG_RETURN_reg   (*((volatile unsigned int*) SB2_RNG_RETURN_reg))
+#define SB2_RNG_RETURN_inst_adr                                                      "0x0088"
+#define SB2_RNG_RETURN_inst                                                          0x0088
+#define SB2_RNG_RETURN_hw_d_shift                                                    (20)
+#define SB2_RNG_RETURN_hw_d_mask                                                     (0x00F00000)
+#define SB2_RNG_RETURN_hw_d(data)                                                    (0x00F00000&((data)<<20))
+#define SB2_RNG_RETURN_hw_d_src(data)                                                ((0x00F00000&(data))>>20)
+#define SB2_RNG_RETURN_get_hw_d(data)                                                ((0x00F00000&(data))>>20)
+#define SB2_RNG_RETURN_rosc_lock_shift                                               (17)
+#define SB2_RNG_RETURN_rosc_lock_mask                                                (0x00020000)
+#define SB2_RNG_RETURN_rosc_lock(data)                                               (0x00020000&((data)<<17))
+#define SB2_RNG_RETURN_rosc_lock_src(data)                                           ((0x00020000&(data))>>17)
+#define SB2_RNG_RETURN_get_rosc_lock(data)                                           ((0x00020000&(data))>>17)
+#define SB2_RNG_RETURN_cnt_ovflw_shift                                               (16)
+#define SB2_RNG_RETURN_cnt_ovflw_mask                                                (0x00010000)
+#define SB2_RNG_RETURN_cnt_ovflw(data)                                               (0x00010000&((data)<<16))
+#define SB2_RNG_RETURN_cnt_ovflw_src(data)                                           ((0x00010000&(data))>>16)
+#define SB2_RNG_RETURN_get_cnt_ovflw(data)                                           ((0x00010000&(data))>>16)
+#define SB2_RNG_RETURN_cnt_shift                                                     (0)
+#define SB2_RNG_RETURN_cnt_mask                                                      (0x0000FFFF)
+#define SB2_RNG_RETURN_cnt(data)                                                     (0x0000FFFF&((data)<<0))
+#define SB2_RNG_RETURN_cnt_src(data)                                                 ((0x0000FFFF&(data))>>0)
+#define SB2_RNG_RETURN_get_cnt(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define SB2_RNG_LOCK_CHK                                                             0x9801AA24
+#define SB2_RNG_LOCK_CHK_reg_addr                                                    "0xD801AA24"
+#define SB2_RNG_LOCK_CHK_reg                                                         0xD801AA24
+#define set_SB2_RNG_LOCK_CHK_reg(data)   (*((volatile unsigned int*) SB2_RNG_LOCK_CHK_reg)=data)
+#define get_SB2_RNG_LOCK_CHK_reg   (*((volatile unsigned int*) SB2_RNG_LOCK_CHK_reg))
+#define SB2_RNG_LOCK_CHK_inst_adr                                                    "0x0089"
+#define SB2_RNG_LOCK_CHK_inst                                                        0x0089
+#define SB2_RNG_LOCK_CHK_prd_ub_shift                                                (16)
+#define SB2_RNG_LOCK_CHK_prd_ub_mask                                                 (0xFFFF0000)
+#define SB2_RNG_LOCK_CHK_prd_ub(data)                                                (0xFFFF0000&((data)<<16))
+#define SB2_RNG_LOCK_CHK_prd_ub_src(data)                                            ((0xFFFF0000&(data))>>16)
+#define SB2_RNG_LOCK_CHK_get_prd_ub(data)                                            ((0xFFFF0000&(data))>>16)
+#define SB2_RNG_LOCK_CHK_prd_lb_shift                                                (0)
+#define SB2_RNG_LOCK_CHK_prd_lb_mask                                                 (0x0000FFFF)
+#define SB2_RNG_LOCK_CHK_prd_lb(data)                                                (0x0000FFFF&((data)<<0))
+#define SB2_RNG_LOCK_CHK_prd_lb_src(data)                                            ((0x0000FFFF&(data))>>0)
+#define SB2_RNG_LOCK_CHK_get_prd_lb(data)                                            ((0x0000FFFF&(data))>>0)
+
+
+#define SB2_RNG_LOCK_CTRL                                                            0x9801AA28
+#define SB2_RNG_LOCK_CTRL_reg_addr                                                   "0xD801AA28"
+#define SB2_RNG_LOCK_CTRL_reg                                                        0xD801AA28
+#define set_SB2_RNG_LOCK_CTRL_reg(data)   (*((volatile unsigned int*) SB2_RNG_LOCK_CTRL_reg)=data)
+#define get_SB2_RNG_LOCK_CTRL_reg   (*((volatile unsigned int*) SB2_RNG_LOCK_CTRL_reg))
+#define SB2_RNG_LOCK_CTRL_inst_adr                                                   "0x008A"
+#define SB2_RNG_LOCK_CTRL_inst                                                       0x008A
+#define SB2_RNG_LOCK_CTRL_exit_num_shift                                             (16)
+#define SB2_RNG_LOCK_CTRL_exit_num_mask                                              (0x000F0000)
+#define SB2_RNG_LOCK_CTRL_exit_num(data)                                             (0x000F0000&((data)<<16))
+#define SB2_RNG_LOCK_CTRL_exit_num_src(data)                                         ((0x000F0000&(data))>>16)
+#define SB2_RNG_LOCK_CTRL_get_exit_num(data)                                         ((0x000F0000&(data))>>16)
+#define SB2_RNG_LOCK_CTRL_enter_num_shift                                            (0)
+#define SB2_RNG_LOCK_CTRL_enter_num_mask                                             (0x0000000F)
+#define SB2_RNG_LOCK_CTRL_enter_num(data)                                            (0x0000000F&((data)<<0))
+#define SB2_RNG_LOCK_CTRL_enter_num_src(data)                                        ((0x0000000F&(data))>>0)
+#define SB2_RNG_LOCK_CTRL_get_enter_num(data)                                        ((0x0000000F&(data))>>0)
+
+
+#define SB2_RNG_RETURN3                                                              0x9801AA2C
+#define SB2_RNG_RETURN3_reg_addr                                                     "0xD801AA2C"
+#define SB2_RNG_RETURN3_reg                                                          0xD801AA2C
+#define set_SB2_RNG_RETURN3_reg(data)   (*((volatile unsigned int*) SB2_RNG_RETURN3_reg)=data)
+#define get_SB2_RNG_RETURN3_reg   (*((volatile unsigned int*) SB2_RNG_RETURN3_reg))
+#define SB2_RNG_RETURN3_inst_adr                                                     "0x008B"
+#define SB2_RNG_RETURN3_inst                                                         0x008B
+#define SB2_RNG_RETURN3_out_ready_shift                                              (0)
+#define SB2_RNG_RETURN3_out_ready_mask                                               (0x00000001)
+#define SB2_RNG_RETURN3_out_ready(data)                                              (0x00000001&((data)<<0))
+#define SB2_RNG_RETURN3_out_ready_src(data)                                          ((0x00000001&(data))>>0)
+#define SB2_RNG_RETURN3_get_out_ready(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SB2_RNG_RETURN4                                                              0x9801AA30
+#define SB2_RNG_RETURN4_reg_addr                                                     "0xD801AA30"
+#define SB2_RNG_RETURN4_reg                                                          0xD801AA30
+#define set_SB2_RNG_RETURN4_reg(data)   (*((volatile unsigned int*) SB2_RNG_RETURN4_reg)=data)
+#define get_SB2_RNG_RETURN4_reg   (*((volatile unsigned int*) SB2_RNG_RETURN4_reg))
+#define SB2_RNG_RETURN4_inst_adr                                                     "0x008C"
+#define SB2_RNG_RETURN4_inst                                                         0x008C
+#define SB2_RNG_RETURN4_valid_bit_num_shift                                          (0)
+#define SB2_RNG_RETURN4_valid_bit_num_mask                                           (0xFFFFFFFF)
+#define SB2_RNG_RETURN4_valid_bit_num(data)                                          (0xFFFFFFFF&((data)<<0))
+#define SB2_RNG_RETURN4_valid_bit_num_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define SB2_RNG_RETURN4_get_valid_bit_num(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_RNG_RETURN5                                                              0x9801AA34
+#define SB2_RNG_RETURN5_reg_addr                                                     "0xD801AA34"
+#define SB2_RNG_RETURN5_reg                                                          0xD801AA34
+#define set_SB2_RNG_RETURN5_reg(data)   (*((volatile unsigned int*) SB2_RNG_RETURN5_reg)=data)
+#define get_SB2_RNG_RETURN5_reg   (*((volatile unsigned int*) SB2_RNG_RETURN5_reg))
+#define SB2_RNG_RETURN5_inst_adr                                                     "0x008D"
+#define SB2_RNG_RETURN5_inst                                                         0x008D
+#define SB2_RNG_RETURN5_drop_num_shift                                               (0)
+#define SB2_RNG_RETURN5_drop_num_mask                                                (0xFFFFFFFF)
+#define SB2_RNG_RETURN5_drop_num(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SB2_RNG_RETURN5_drop_num_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SB2_RNG_RETURN5_get_drop_num(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_RNG_RESULTR                                                              0x9801AA38
+#define SB2_RNG_RESULTR_reg_addr                                                     "0xD801AA38"
+#define SB2_RNG_RESULTR_reg                                                          0xD801AA38
+#define set_SB2_RNG_RESULTR_reg(data)   (*((volatile unsigned int*) SB2_RNG_RESULTR_reg)=data)
+#define get_SB2_RNG_RESULTR_reg   (*((volatile unsigned int*) SB2_RNG_RESULTR_reg))
+#define SB2_RNG_RESULTR_inst_adr                                                     "0x008E"
+#define SB2_RNG_RESULTR_inst                                                         0x008E
+#define SB2_RNG_RESULTR_random_out_shift                                             (0)
+#define SB2_RNG_RESULTR_random_out_mask                                              (0xFFFFFFFF)
+#define SB2_RNG_RESULTR_random_out(data)                                             (0xFFFFFFFF&((data)<<0))
+#define SB2_RNG_RESULTR_random_out_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define SB2_RNG_RESULTR_get_random_out(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_RNG_LFSR_POLY_LSB                                                        0x9801AA3C
+#define SB2_RNG_LFSR_POLY_LSB_reg_addr                                               "0xD801AA3C"
+#define SB2_RNG_LFSR_POLY_LSB_reg                                                    0xD801AA3C
+#define set_SB2_RNG_LFSR_POLY_LSB_reg(data)   (*((volatile unsigned int*) SB2_RNG_LFSR_POLY_LSB_reg)=data)
+#define get_SB2_RNG_LFSR_POLY_LSB_reg   (*((volatile unsigned int*) SB2_RNG_LFSR_POLY_LSB_reg))
+#define SB2_RNG_LFSR_POLY_LSB_inst_adr                                               "0x008F"
+#define SB2_RNG_LFSR_POLY_LSB_inst                                                   0x008F
+#define SB2_RNG_LFSR_POLY_LSB_lfsr_poly_lsb_shift                                    (0)
+#define SB2_RNG_LFSR_POLY_LSB_lfsr_poly_lsb_mask                                     (0xFFFFFFFF)
+#define SB2_RNG_LFSR_POLY_LSB_lfsr_poly_lsb(data)                                    (0xFFFFFFFF&((data)<<0))
+#define SB2_RNG_LFSR_POLY_LSB_lfsr_poly_lsb_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define SB2_RNG_LFSR_POLY_LSB_get_lfsr_poly_lsb(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_RNG_LFSR_POLY_MSB                                                        0x9801AA40
+#define SB2_RNG_LFSR_POLY_MSB_reg_addr                                               "0xD801AA40"
+#define SB2_RNG_LFSR_POLY_MSB_reg                                                    0xD801AA40
+#define set_SB2_RNG_LFSR_POLY_MSB_reg(data)   (*((volatile unsigned int*) SB2_RNG_LFSR_POLY_MSB_reg)=data)
+#define get_SB2_RNG_LFSR_POLY_MSB_reg   (*((volatile unsigned int*) SB2_RNG_LFSR_POLY_MSB_reg))
+#define SB2_RNG_LFSR_POLY_MSB_inst_adr                                               "0x0090"
+#define SB2_RNG_LFSR_POLY_MSB_inst                                                   0x0090
+#define SB2_RNG_LFSR_POLY_MSB_lfsr_poly_msb_shift                                    (0)
+#define SB2_RNG_LFSR_POLY_MSB_lfsr_poly_msb_mask                                     (0xFFFFFFFF)
+#define SB2_RNG_LFSR_POLY_MSB_lfsr_poly_msb(data)                                    (0xFFFFFFFF&((data)<<0))
+#define SB2_RNG_LFSR_POLY_MSB_lfsr_poly_msb_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define SB2_RNG_LFSR_POLY_MSB_get_lfsr_poly_msb(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_RNG_DUMMY                                                                0x9801AA44
+#define SB2_RNG_DUMMY_reg_addr                                                       "0xD801AA44"
+#define SB2_RNG_DUMMY_reg                                                            0xD801AA44
+#define set_SB2_RNG_DUMMY_reg(data)   (*((volatile unsigned int*) SB2_RNG_DUMMY_reg)=data)
+#define get_SB2_RNG_DUMMY_reg   (*((volatile unsigned int*) SB2_RNG_DUMMY_reg))
+#define SB2_RNG_DUMMY_inst_adr                                                       "0x0091"
+#define SB2_RNG_DUMMY_inst                                                           0x0091
+#define SB2_RNG_DUMMY_dummy_msb_shift                                                (16)
+#define SB2_RNG_DUMMY_dummy_msb_mask                                                 (0xFFFF0000)
+#define SB2_RNG_DUMMY_dummy_msb(data)                                                (0xFFFF0000&((data)<<16))
+#define SB2_RNG_DUMMY_dummy_msb_src(data)                                            ((0xFFFF0000&(data))>>16)
+#define SB2_RNG_DUMMY_get_dummy_msb(data)                                            ((0xFFFF0000&(data))>>16)
+#define SB2_RNG_DUMMY_dummy_lsb_shift                                                (0)
+#define SB2_RNG_DUMMY_dummy_lsb_mask                                                 (0x0000FFFF)
+#define SB2_RNG_DUMMY_dummy_lsb(data)                                                (0x0000FFFF&((data)<<0))
+#define SB2_RNG_DUMMY_dummy_lsb_src(data)                                            ((0x0000FFFF&(data))>>0)
+#define SB2_RNG_DUMMY_get_dummy_lsb(data)                                            ((0x0000FFFF&(data))>>0)
+
+
+#define SB2_RNG_POWER                                                                0x9801AA48
+#define SB2_RNG_POWER_reg_addr                                                       "0xD801AA48"
+#define SB2_RNG_POWER_reg                                                            0xD801AA48
+#define set_SB2_RNG_POWER_reg(data)   (*((volatile unsigned int*) SB2_RNG_POWER_reg)=data)
+#define get_SB2_RNG_POWER_reg   (*((volatile unsigned int*) SB2_RNG_POWER_reg))
+#define SB2_RNG_POWER_inst_adr                                                       "0x0092"
+#define SB2_RNG_POWER_inst                                                           0x0092
+#define SB2_RNG_POWER_gating_en_shift                                                (0)
+#define SB2_RNG_POWER_gating_en_mask                                                 (0x00000001)
+#define SB2_RNG_POWER_gating_en(data)                                                (0x00000001&((data)<<0))
+#define SB2_RNG_POWER_gating_en_src(data)                                            ((0x00000001&(data))>>0)
+#define SB2_RNG_POWER_get_gating_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/Kconfig b/drivers/soc/realtek/rtd129x/hw_nat/Kconfig
new file mode 100644
index 00000000..76537fc
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/Kconfig
@@ -0,0 +1,607 @@
+menuconfig RTD_1295_HWNAT
+	bool "Realtek HW NAT Driver"
+	depends on NET
+	select RTL_819X
+	select RTL_8197F
+	select 8198_PORT5_GMII
+	select CPU_LITTLE_ENDIAN
+	select RTL_819X_SWCORE
+	select RTL_PROC_NEW
+	select IP_VS
+	default n
+	---help---
+	  You can say N here if you don't intend to use Realtek HW NAT at all.
+
+	  You'll have to say Y if only HW NAT is used for your router.
+
+	  If unsure, say N.
+
+if RTD_1295_HWNAT
+
+config RTL_819X
+	bool
+	default n
+
+config RTL_8197F
+	bool
+	default y
+
+config 8198_PORT5_GMII
+	bool
+	default n
+
+config CPU_LITTLE_ENDIAN
+	bool
+	default n
+
+config RTL_PROC_NEW
+	bool
+	default y
+
+config RTL_8367R_SUPPORT
+	bool
+	default n
+
+config RTL_8198C_8367RB
+	bool
+	default n
+
+config RTL_8325D_SUPPORT
+	bool
+	default n
+
+config RTL_SWITCH_NEW_DESCRIPTOR
+	bool
+	default n
+
+config RTL_ETH_PRIV_SKB
+	bool
+	default n
+
+config RTL_HW_TX_CSUM
+	bool
+	default n
+
+config RTL_HTTP_REDIRECT
+	bool
+	default n
+
+config RTL_HTTP_REDIRECT_LOCAL
+	bool
+	default n
+
+config RTL_DNS_TRAP
+	bool
+	default n
+
+config HARDWARE_NAT_DEBUG
+	bool
+	default n
+
+config RTL_819X_SWCORE
+	bool
+	default y
+
+config FPGA_V6_HWNAT
+	bool
+	default n
+
+config DEFAULTS_KERNEL_2_6
+	bool
+	default y
+
+config AUTO_DHCP_CHECK
+	#bool "Auto DHCP Check"
+	bool
+	default n
+
+config NEW_PCI
+	bool
+	default y
+	depends on PCI
+
+config RTL_IGMP_PROXY
+	bool
+	default n
+
+config RTL_IGMP_SNOOPING
+	bool
+	default n
+	depends on BRIDGE
+	depends on !BRIDGE_IGMP_SNOOPING
+
+config RTL_MLD_SNOOPING
+	bool
+	default n
+	depends on RTL_IGMP_SNOOPING
+
+config RTL_QUERIER_SELECTION
+	bool
+	default y
+	depends on RTL_IGMP_SNOOPING
+
+config RTL_MLD_PROXY
+	bool
+	default n
+
+config RTL_LINKCHG_PROCESS
+	bool
+	default y
+
+config RTL_DEBUG_TOOL
+	bool
+	default y
+
+menu "Config for Layered Driver Features"
+	config RTL_LAYERED_DRIVER
+		bool
+	        default y
+		depends on RTL_819X
+
+	config RTL_LAYERED_ASIC_DRIVER
+		bool
+		default n
+		depends on RTL_LAYERED_DRIVER
+
+	config RTL_LAYERED_ASIC_DRIVER_L3
+		bool
+		default n
+		depends on RTL_LAYERED_ASIC_DRIVER
+
+	config RTL_LAYERED_ASIC_DRIVER_L4
+		bool
+		default n
+		depends on RTL_LAYERED_ASIC_DRIVER
+		depends on RTL_8198 || RTL_8196CT || RTL_8198T || RTL_8198C || RTL_8197F
+
+	config RTL_LAYERED_DRIVER_ACL
+		bool
+		default n
+		depends on RTL_LAYERED_DRIVER
+
+	config RTL_LAYERED_DRIVER_L2
+		bool
+		default n
+		depends on RTL_LAYERED_DRIVER
+
+	config RTL_HW_QOS_SUPPORT
+		bool
+		default n
+		depends on RTL_LAYERED_DRIVER
+		depends on RTL_8196CT || RTL_8198T || RTL_8198 || RTL_819XDT || RTL_8198C || RTL_8197F
+
+	config RTL_LAYERED_DRIVER_L3
+		bool
+		default n
+		depends on RTL_LAYERED_DRIVER
+
+
+	config RTL_LAYERED_DRIVER_L4
+		bool
+		default n
+		depends on RTL_LAYERED_DRIVER
+		depends on RTL_8198 || RTL_8196CT || RTL_8198T || RTL_8198C || RTL_8197F
+
+	comment 'Choose basic features.'
+
+	config RTL_LINKCHG_PROCESS
+		bool
+		default n
+		depends on RTL_LAYERED_DRIVER
+
+	config RTL_EXTPORT_VLANID
+		int
+		default "9"
+		depends on RTL_LAYERED_DRIVER
+
+	comment 'Choose hardware features.'
+
+	choice
+		prompt "Hardware Features Selection"
+		default RTL_HW_L2_ONLY
+		depends on RTL_LAYERED_DRIVER
+
+	config RTL_HW_NAPT
+		bool "Enable RTL Hardware NAPT"
+		depends on RTL_8198 || RTL_8196CT || RTL_8198T || RTL_819XDT || RTL_8367R_SUPPORT || RTL_89xxD || RTL_8196C || RTL_8196E || RTL_819XD || RTL_8198C || RTL_8197F
+		select RTL_LAYERED_ASIC_DRIVER
+		select RTL_LAYERED_ASIC_DRIVER_L3
+		select RTL_LAYERED_ASIC_DRIVER_L4
+		select RTL_LAYERED_DRIVER_ACL
+		#select RTL_HW_QOS_SUPPORT
+		select RTL_LAYERED_DRIVER_L2
+		select RTL_LAYERED_DRIVER_L3
+		select RTL_LAYERED_DRIVER_L4
+		select RTL_HARDWARE_MULTICAST if RTL_IGMP_SNOOPING
+		select RTL_HARDWARE_NAT
+
+	config RTL_HW_MULTICAST_ONLY
+		bool "Enable RTL Hardware Multicast Only"
+		depends on !RTL_8370_SUPPORT
+		select RTL_LAYERED_ASIC_DRIVER
+		select RTL_LAYERED_ASIC_DRIVER_L3
+		select RTL_LAYERED_DRIVER_ACL
+		select RTL_LAYERED_DRIVER_L2
+		select RTL_LAYERED_DRIVER_L3
+		select RTL_HARDWARE_MULTICAST
+
+	config RTL_HW_L2_ONLY
+		bool "Enable RTL Hardware switch Only"
+		select RTL_LAYERED_ASIC_DRIVER
+		select RTL_LAYERED_DRIVER_ACL		#because mld snooping need add acl to trap ipv6 multicast packet to cpu
+		select RTL_LAYERED_DRIVER_L2
+
+	endchoice
+
+	comment 'Choose advance features.'
+#	config RTL_L2_HW_MULTICAST_SUPPORT
+#		bool "RTL l2 hw multicast support"
+#		default n
+#		depends on RTL_HARDWARE_MULTICAST
+
+	config RTL_HW_MCAST_PATCH_FOR_MAC
+		#bool "RTL Hardware Multicast patch for Mac address"
+		default y
+		depends on RTL_HARDWARE_MULTICAST && !OPENWRT_SDK
+		depends on RTL_8196E || RTL_8881A || RTL_8198C || RTL_8197F
+
+	config RTL_HW_MCAST_WIFI
+		bool "Support hw multiast for eth+wlan client"
+		default y
+		depends on RTL_HARDWARE_MULTICAST
+
+
+	config RTL_EXT_PORT_SUPPORT
+		bool "Enable extension port support"
+		default n
+		depends on RTL_HW_NAPT && !OPENWRT_SDK
+
+	config RTL_CPU_TAG
+		bool "Enable CPU tag"
+		default n
+		---help---
+		Enable CPU tag between MAC0/MAC5 and external switch.
+		Extra 4 bytes are inserted after SA MAC address in each packet.
+
+	config RTL_WAN_MAC5
+		bool "Set MAC5 as WAN port"
+		default n
+		---help---
+		Disable original WAN (MAC4) port, and use MAC5 as WAN port.
+
+	config RTL_2_RGMII_PORTS_ONLY
+		bool "Set MAC5 as WAN port and MAC0 as LAN port"
+		default n
+		---help---
+		Disable original WAN (MAC4) port.
+		Use MAC5 as WAN port, and MAC0 as LAN port.
+
+	config RTL_NETIF_MAPPING
+		bool
+		default y
+		depends on RTL_LAYERED_DRIVER
+
+	config RTL_MULTIPLE_WAN
+		bool "Enable multiple wan in hw nat mode"
+		default n
+		depends on RTL_HARDWARE_NAT && !OPENWRT_SDK
+		depends on RTL_8198T || RTL_8196CT || RTL_819XDT || RTL_8198C || RTL_8197F
+
+	config RTL_IVL_SUPPORT
+		bool "Support multi-vlan in bridge/wisp mode"
+		default y
+		depends on RTL_LAYERED_DRIVER && !RTL_8370_SUPPORT
+
+	#config RTL_LOCAL_PUBLIC
+	#	bool "Enable RTL local public"
+	#	default n
+	#	depends on RTL_HW_NAPT
+
+	config RTL_HW_DSLITE_SUPPORT
+		bool "Enable HW DS-LITE SUPPORT"
+			default n
+			depends on RTL_LAYERED_DRIVER && !OPENWRT_SDK
+			depends on RTL_8198C || RTL_8197F
+			depends on IPV6
+			select IPV6_TUNNEL
+
+	config RTL_HW_6RD_SUPPORT
+		bool "Enable HW 6RD SUPPORT"
+			default n
+			depends on RTL_LAYERED_DRIVER && !OPENWRT_SDK
+			depends on RTL_8198C || RTL_8197F
+			depends on IPV6
+			select IPV6_SIT
+			select IPV6_SIT_6RD
+
+	config RTL_TSO
+		bool "Enable hardware TSO support(GSO is needed)"
+		default y
+		depends on RTL_8197F
+		select RTL_GSO
+
+	config RTL_GSO
+		bool "Enable software GSO support"
+		default y if RTL_8198C || RTL_819XD || RTL_8881A
+		depends on RTL_8197F || RTL_8198C || RTL_819XD || RTL_8881A
+
+endmenu
+
+menu "Config Multicast Options"
+	depends on RTL_IGMP_SNOOPING
+
+	config RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD
+		bool "IGMP/MLD Support for PPPoE Connection"
+		#WE DON'T TURN ON THIS FEATURE WITHOUT TESTING.
+		default n
+endmenu
+
+config RTL_IPTABLES_RULE_2_ACL
+	bool "Enable iptables rule to RTL ACL rule"
+	default n
+	depends on RTL_LAYERED_DRIVER_ACL
+
+config RTL865X_MBUF_HEADROOM
+	int
+	range 0 256
+	default "128"
+	depends on RTL_819X
+
+config RTL_ETH_PRIV_SKB
+	bool "Enable Ethernet Private Skb"
+	default n
+	depends on RTL_819X
+
+config EXTRTL8212_PHYID_P1
+	int
+	default "18"
+	depends on RTL_819X
+
+config EXTRTL8212_PHYID_P3
+	int
+	default "20"
+	depends on RTL_819X
+
+config EXTRTL8212_PHYID_P5
+	int
+	default "22"
+	depends on RTL_819X
+
+config RTL_HW_NAPT_REFINE_KERNEL_HOOKS
+	bool "Hw Nat Refine Kernel Hooks"
+	default n
+	depends on RTL_LAYERED_DRIVER
+	depends on RTL_HARDWARE_NAT
+	depends on OPENWRT_SDK
+	depends on RTL_8196CT || RTL_8198T || RTL_8198 || RTL_819XDT || RTL_8196C || RTL_8196E || RTL_8198C ||RTL_8881A || RTL_8197F
+
+config RTL_QOS_SYNC_SUPPORT
+	bool "rtl qos sync hook support"
+	depends on OPENWRT_SDK
+	depends on RTL_IPTABLES_FAST_PATH ||RTL_HW_QOS_SUPPORT
+	default y
+
+config RTL_HW_QOS_DEBUG
+	bool "rtl hw qos debug support"
+	depends on OPENWRT_SDK
+	depends on RTL_HW_QOS_SUPPORT
+	default n
+
+config RTL_HW_QOS_SUPPORT
+	bool "Support HW Qos"
+	default n
+	depends on RTL_LAYERED_DRIVER
+	depends on RTL_HARDWARE_NAT
+	depends on RTL_8196CT || RTL_8198T || RTL_8198 || RTL_819XDT || RTL_8196C || RTL_8196E || RTL_8198C || RTL_8197F
+
+config RTL_QOS_PATCH
+	bool "HW QoS patch"
+	default n
+	depends on RTL_HW_QOS_SUPPORT
+
+config RTL_HW_QOS_SUPPORT_WLAN
+	bool "HW QoS Support Wlan Session"
+	default n
+	depends on RTL_HW_QOS_SUPPORT && !OPENWRT_SDK
+
+config RTL_SW_QUEUE_DECISION_PRIORITY
+	bool "HW QoS sw queue decision priority patch"
+	default n
+	depends on RTL_HW_QOS_SUPPORT && !OPENWRT_SDK
+
+config RTL_HW_QOS_BRIDGE_FWD_SUPPORT
+	bool "HW QoS bridge forward config support"
+	default n
+	depends on RTL_HW_QOS_SUPPORT
+
+config RTL_8367_QOS_SUPPORT
+	bool "Hw QoS support for 8367"
+	default y
+	depends on RTL_HW_QOS_SUPPORT && RTL_8367R_SUPPORT
+
+config RTL_HARDWARE_MULTICAST
+	bool
+	default n
+	depends on RTL_LAYERED_DRIVER
+	depends on RTL_IGMP_SNOOPING
+
+config RTL_HARDWARE_MULTICAST_CAM
+    bool "HW multicast cam support"
+	default n
+	depends on RTL_LAYERED_DRIVER
+	depends on RTL_HARDWARE_MULTICAST
+#	depends on RTL_8196E || RTL_819XD
+
+config RTL_HARDWARE_NAT
+	bool
+	default n
+	depends on RTL_819X
+	depends on RTL_8196CT || RTL_8198 || RTL8198T || RTL_8198C || RTL_8197F
+
+config RTL_PPPOE_HWACC
+	bool
+	default y
+	depends on RTL_HARDWARE_NAT
+
+config RTL865X_HW_PPTPL2TP
+	bool
+	default n
+	depends on RTL_HARDWARE_NAT
+
+config RTL_IPV6READYLOGO
+	bool "IPv6: ready logo patch"
+	depends on IPV6
+	default n
+
+config RTL_HARDWARE_IPV6_SUPPORT
+	bool "Enable hardware ipv6 support"
+	default n
+	depends on RTL_8198C || RTL_8197F
+	depends on IPV6 && !OPENWRT_SDK
+
+config RTL_PROC_DEBUG
+	bool "Enable proc filesystem for debug"
+	default y
+	depends on RTL_819X
+
+config RTL_JUMBO_FRAME
+	bool "Enable JUMBO frame support"
+	default n
+	depends on RTL_819X && !OPENWRT_SDK
+
+config RTL_UNKOWN_UNICAST_CONTROL
+	bool
+	default n
+	depends on RTL_819X
+
+config RTL_ENABLE_RATELIMIT_TABLE
+	bool
+	default y
+	depends on RTL_UNKOWN_UNICAST_CONTROL
+
+config RTL_MULTI_LAN_DEV
+	bool "Multiple lan dev support"
+	default y
+	depends on (RTL_8198C || RTL_8197F) && !RTL_8021Q_VLAN_SUPPORT_SRC_TAG
+
+config RTL_EEE_DISABLED
+	bool "Disable 802.3az EEE feature"
+	default n
+	depends on RTL_819X && !RTL_8370_SUPPORT
+#	depends on RTL_8196C || RTL_8198 || RTL_819XD || RTL_8196E || RTL_8881A
+
+config RTL_ETH_802DOT1X_SUPPORT
+	bool "Rtl ethernet 802.1x support"
+	default n
+	depends on RTL_819X
+	depends on RTL_LAYERED_DRIVER
+
+config RTL_ETH_802DOT1X_CLIENT_MODE_SUPPORT
+	bool "Rtl ethernet 802.1x client mode support"
+	default n
+	depends on RTL_819X
+	depends on RTL_LAYERED_DRIVER
+	depends on RTL_ETH_802DOT1X_SUPPORT
+
+# Realtek samba speed up
+config RTL_USB_IP_HOST_SPEEDUP
+	bool "rtl samba speedup"
+	   default n
+	depends on OPENWRT_SDK
+
+config RTL_SENDFILE_PATCH
+	bool "Enable reverse sendfile fastpath"
+	default n
+	depends on OPENWRT_SDK
+	help
+	  Improve performance on socket-to-file by using zero copy techonology.
+
+config RTL_96E_GPIOB5_RESET
+	bool "Enable GPIOB5 as Reset Button"
+	default n
+	depends on RTL_8196E
+
+config RTL_GIGA_LITE_ENABLED
+	bool "Enable Giga Lite support"
+	default n
+	depends on RTL_8198C
+config RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN
+	bool "Enable redirect acl support for ISP multi wan"
+	default n
+	depends on RTL_ISP_MULTI_WAN_SUPPORT
+	depends on RTL_HW_NAPT
+
+#config RTL_IGMP_PROXY_MULTIWAN
+#	bool "Enable igmpproxy for multi wan"
+#	default n
+#	depends on RTL_ISP_MULTI_WAN_SUPPORT
+#	depends on RTL_IGMP_PROXY
+
+#config RTL_ISP_MULTIPLE_BR_SUPPORT
+#        bool "Enable multiple bridge support for igmp snooping"
+#        default n
+#        depends on RTL_ISP_MULTI_WAN_SUPPORT
+#        depends on RTL_IGMP_SNOOPING
+
+config RT_MULTIPLE_BR_SUPPORT
+	bool
+	default y
+	depends on RTL_IGMP_SNOOPING && VLAN_8021Q
+	depends on !OPENWRT_SDK
+
+config RTL_BR_SHORTCUT
+	bool "Enable bridge shortcut between LAN and WiFi"
+	default n
+
+config RTL_MULTICAST_PORT_MAPPING
+	bool
+	default y
+	depends on RT_MULTIPLE_BR_SUPPORT
+
+config RTD_1295_MAC0_SGMII_LINK_MON
+	bool "Polling MAC0 link status"
+	default n
+	depends on RTD_1295_HWNAT
+	---help---
+	  You can say N here if you could get interrupt event when MAC0 link change.
+
+	  You'll have to say Y if MDC/MDIO for MAC0 SGMII mode is broken.
+
+	  If unsure, say Y.
+
+config RTL_8211F_SUPPORT
+	bool "Enable RTL8211F support"
+	default n
+	depends on RTL_8197F
+
+config RTL_8367R_SUPPORT
+	bool "Enable RTL8367RB support"
+	default n
+	depends on RTL_8197F || RTL_819XD || RTL_819XDT || RTL_8881A
+
+config RTL_836X_SUPPORT
+	bool "Enable RTL836X series support"
+	default n
+	depends on RTD_1295_HWNAT
+
+config RTL_VLAN_8021Q
+	bool "Make linux vlan support RTK router"
+	default y
+	depends on VLAN_8021Q
+	help
+	  Select this to make linux vlan support RTK router.
+	  If unsure, say N.
+
+config RTL_8021Q_VLAN_SUPPORT_SRC_TAG
+	bool "Enable source tag support in linux vlan"
+	default n
+	depends on RTL_VLAN_8021Q
+	help
+	  Select this to make wan use source-lan tag in linux vlan.
+	  If unsure, say N.
+
+endif
+#endmenu
+#============================= End of Kconfig ===============================#
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/Makefile b/drivers/soc/realtek/rtd129x/hw_nat/Makefile
new file mode 100644
index 00000000..367270b
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/Makefile
@@ -0,0 +1,109 @@
+#
+# Makefile for the 865x High Performance
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definitions are now in the main makefile...
+# Note 3! Pay attention to the important comments line(21-25 and 42-46)!!!!!
+
+#obj-y := mmap.o
+
+ifeq ($(CONFIG_OPENWRT_SDK),y)
+export DIR_LINUX := $(srctree)
+endif
+
+DIR_RTLASIC = $(srctree)/drivers/soc/realtek/rtd129x/hw_nat/
+EXTRA_CFLAGS += -DCONFIG_RTL865X_MODULE_INTERNAL
+
+#obj-y := rtl_glue.o
+#Add mips16 Support
+ifdef CONFIG_RTL865X_KERNEL_MIPS16_LAYERDRIVER
+	#CFLAGS_rtl865xc_swNic.o		= -mips16
+	#CFLAGS_rtl_nic.o		= -mips16
+	#CFLAGS_romeper.o		= -mips16
+endif
+
+#
+#	The following configuration is used for 865xC model code only.
+#	In fact, we will port more and more driver files from 865xB to 865xC.
+#
+
+obj-y += rtl865xc_swNic.o
+obj-y += rtl_nic.o
+obj-$(CONFIG_RTL_ROMEPERF_24K) += m24kctrl.o
+
+
+obj-$(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT) += rtl_multi_wan.o
+
+obj-$(CONFIG_RTL_DEBUG_TOOL) += rtl865x_proc_debug.o
+obj-$(CONFIG_RTL_PROC_DEBUG) += rtl865x_proc_debug.o
+obj-$(CONFIG_RTD_1295_MAC0_SGMII_LINK_MON) += rtd129x_link_mon.o
+
+ifeq ($(CONFIG_RTL_8197F),y)
+obj-y += rtl819x_swNic.o
+endif
+
+obj-$(CONFIG_RTL865X_ROMEPERF) += romeperf.o
+obj-$(CONFIG_RTL_ETH_802DOT1X_SUPPORT) += rtl_dot1x.o
+ifeq ($(CONFIG_OPENWRT_SDK),y)
+obj-$(CONFIG_SWCONFIG) += rtl819x_switch.o
+endif
+### for 8196B/8196C/8196E, use rlx5181_perCounter.S
+## obj-$(CONFIG_RTL865X_ROMEPERF) += rlx5181_perCounter.o
+### for 8198/8196D/8197D/8881A, use rlx5281_perCounter.S
+obj-$(CONFIG_RTL865X_ROMEPERF) += rlx5281_perCounter.o
+
+#===>Attention: the following line define subdir with type ":=",not "+=", so to be
+#	    sure that the other addition to subdir should not be placed before this line,or
+#	    the addition would be layed over!!
+#
+
+obj-y  += rtl865x/built-in.o
+subdir-y += rtl865x
+
+ifeq ($(CONFIG_RTL_836X_SUPPORT), y)
+obj-y  += rtl836x/built-in.o
+subdir-y += rtl836x
+endif
+
+EXTRA_CFLAGS += -DRTL865X_OVER_KERNEL -DRTL865X_OVER_LINUX -D__KERNEL__ -Wno-implicit
+ifeq ($(CONFIG_RTL_8367R_SUPPORT), y)
+else
+ifeq ($(CONFIG_RTL_AP_PACKAGE), y)
+else
+EXTRA_CFLAGS += -Werror
+endif
+endif
+
+#EXTRA_CFLAGS += -DCONFIG_RTL865X_IGMP_SNOOPING
+
+ifeq ($(CONFIG_MESH_ENABLE),y)
+        EXTRA_CFLAGS += -DCONFIG_RTK_MESH #-DMESH_USE_METRICOP
+        ifeq ($(CONFIG_11S_TEST_MODE),y)
+        EXTRA_CFLAGS += -D_11s_TEST_MODE_
+        endif
+endif
+
+#######################################################################################################_CFLAGS
+#
+#	FAST EXTERNAL DEVICES related files
+#
+#	Fast path for external device process
+#
+########################################################################################################
+
+EXTRA_CFLAGS += -I$(srctree)/include
+EXTRA_CFLAGS += -I$(DIR_ROOT)/target/bsp
+EXTRA_CFLAGS += -I$(DIR_RTLASIC)
+EXTRA_CFLAGS += -I$(DIR_BOARD)
+EXTRA_CFLAGS += -D__KERNEL__
+EXTRA_CFLAGS += -DEXPORT_SYMTAB
+ifeq ($(CONFIG_RTL865X_MODULE_ROMEDRV),y)
+EXTRA_CFLAGS += -G 0
+EXTRA_CFLAGS += -DMODULE
+EXTRA_CFLAGS += -mlong-calls
+endif		#$(CONFIG_RTL865X_MODULE_ROMEDRV)!=y
+
+EXTRA_AFLAGS += $(EXTRA_CFLAGS)
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/Makefile.Release b/drivers/soc/realtek/rtd129x/hw_nat/Makefile.Release
new file mode 100644
index 00000000..7983346
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/Makefile.Release
@@ -0,0 +1,32 @@
+obj-y := rtl_glue.o
+obj-y += rtl_nic.o
+obj-y += re865x.o
+
+EXTRA_CFLAGS += -DCONFIG_RTL865X_MODULE_INTERNAL
+EXTRA_CFLAGS += -DRTL865X_OVER_KERNEL -DRTL865X_OVER_LINUX -D__KERNEL__ -Wno-implicit
+
+EXTRA_CFLAGS += -DCONFIG_RTL865X_IGMP_SNOOPING
+#######################################################################################################_CFLAGS
+#
+#       FAST EXTERNAL DEVICES related files
+#
+#       Fast path for external device process
+#
+########################################################################################################
+
+EXTRA_CFLAGS += -I$(ROOTDIR)/include
+EXTRA_CFLAGS += -I$(ROOTDIR)/$(LINUXDIR)/drivers/net/re865x/AsicDriver
+EXTRA_CFLAGS += -I$(ROOTDIR)/$(LINUXDIR)/drivers/net/re865x/common
+EXTRA_CFLAGS += -I$(ROOTDIR)/$(LINUXDIR)/drivers/net/re865x/l2Driver
+EXTRA_CFLAGS += -I$(ROOTDIR)/$(LINUXDIR)/drivers/net/re865x/l3Driver
+EXTRA_CFLAGS += -I$(ROOTDIR)/$(LINUXDIR)/drivers/net/re865x/l4Driver
+EXTRA_CFLAGS += -I$(ROOTDIR)/$(LINUXDIR)/drivers/net/re865x/igmpsnooping
+EXTRA_CFLAGS += -I$(ROOTDIR)/$(LINUXDIR)/drivers/net/re865x/cle
+EXTRA_CFLAGS += -I$(ROOTDIR)/$(LINUXDIR)/drivers/net/re865x
+EXTRA_CFLAGS += -D__KERNEL__
+EXTRA_CFLAGS += -DEXPORT_SYMTAB
+ifeq ($(CONFIG_RTL865X_MODULE_ROMEDRV),y)
+EXTRA_CFLAGS += -G 0
+EXTRA_CFLAGS += -DMODULE
+EXTRA_CFLAGS += -mlong-calls
+endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/board.h b/drivers/soc/realtek/rtd129x/hw_nat/board.h
new file mode 100644
index 00000000..4321994
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/board.h
@@ -0,0 +1,2229 @@
+/*
+* ----------------------------------------------------------------
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* $Header: /home1/sub1/tmp/cvs2svn/skylark/skylark/skylark/linux-2.6.x/drivers/net/re865x/board.h,v 1.1 2007-12-21 10:28:22 davidhsu Exp $
+*
+* Abstract: Board specific definitions.
+*
+* $Author: davidhsu $
+*
+* $Log: not supported by cvs2svn $
+* Revision 1.70  2007/11/01 09:26:25  alva_zhang
+* +: add a new item to support MII QoS
+*
+* Revision 1.69  2007/10/11 13:00:03  cary_lee
+* +:notify info
+*
+* Revision 1.68  2007/08/24 03:56:21  cary_lee
+* +:CWMP_CONREQ_ACCOUNT
+*
+* Revision 1.67  2007/07/26 02:40:36  cary_lee
+* *:For Tr069 l3fw take-effect
+*
+* Revision 1.66  2007/07/19 01:53:04  cary_lee
+* +:for port mapping supports the take-effect mechanism
+*
+* Revision 1.65  2007/07/10 02:24:40  cary_lee
+* *:For 069 param cwmpDHCPServerConfCfgParamDefault and UpGradesManaged
+*
+* Revision 1.64  2007/07/04 03:38:00  cary_lee
+* +:l3 table array for Tr069
+*
+* Revision 1.63  2007/07/03 02:15:50  cary_lee
+* +:server port for Tr069
+*
+* Revision 1.62  2007/06/26 02:44:49  hf_shi
+* +:Web UI for updatedd daemon
+*
+* Revision 1.61  2007/06/22 05:26:00  chihhsing
+* +: Add WDS security setting support
+*
+* Revision 1.60  2007/06/12 05:48:14  hf_shi
+* Web UI for snmpv2trap
+*
+* Revision 1.59  2007/06/08 07:00:16  cary_lee
+* add param for TR069
+*
+* Revision 1.58  2007/06/06 05:48:47  cary_lee
+* *** empty log message ***
+*
+* Revision 1.57  2007/06/04 09:12:40  cary_lee
+* For 069
+*
+* Revision 1.56  2007/06/03 11:31:42  chihhsing
+* *: change some enum vlaue for 8190 11n mode
+*
+* Revision 1.55  2007/06/01 03:28:19  cary_lee
+* *** empty log message ***
+*
+* Revision 1.54  2007/05/31 06:18:45  cary_lee
+* *** empty log message ***
+*
+* Revision 1.53  2007/05/29 07:41:58  cary_lee
+* *** empty log message ***
+*
+* Revision 1.52  2007/05/18 09:45:30  cary_lee
+* *** empty log message ***
+*
+* Revision 1.51  2007/04/13 07:08:07  hf_shi
+* dhcpv6 and radvd defination modify.
+* put mgmt_udp_500 into the mgm structure to avoid compile error
+*
+* Revision 1.50  2007/04/06 03:31:44  ghhuang
+* *: Change RTL865XC flash base from 0xBD000000 to 0xBE000000
+*
+* Revision 1.49  2007/03/29 08:32:14  chihhsing
+* *: modify wlan code for NEW SDK framework
+*
+* Revision 1.48  2007/03/06 05:54:01  chihhsing
+* +: add WMM and LNA support
+*
+* Revision 1.47  2007/03/05 06:18:43  qjj_qin
+* *:865xc igmp snooping support
+*
+* Revision 1.46  2007/02/14 05:33:09  qjj_qin
+* +:igmp proxy to snooping
+*
+* Revision 1.45  2007/01/12 03:33:02  chihhsing
+* +: add Multiple BSSID current associated clients list and access policy feature
+*
+* Revision 1.44  2007/01/05 09:11:08  hf_shi
+* add enable bit for radvd dnsv6 dhcpv6
+*
+* Revision 1.43  2007/01/03 06:52:06  alva_zhang
+* +:  Add GW Setting Save/Restore Feature
+*
+* Revision 1.42  2006/12/27 04:31:14  cary_lee
+* 6to4
+*
+* Revision 1.41  2006/12/19 01:49:42  hf_shi
+* add web support for radvd dhcpv6 dnsv6
+*
+* Revision 1.40  2006/12/15 10:23:01  chihhsing
+* +: Add Multiple BSSID(for 8185B) support
+*
+* Revision 1.39  2006/11/17 01:33:48  qy_wang
+* *:replace the magic number with macro
+*
+* Revision 1.38  2006/11/07 03:26:25  cary_lee
+* IPv6 soppurt
+*
+* Revision 1.37  2006/10/20 03:31:53  chihhsing
+* +: add repeaterssid for wireless configuration
+*
+* Revision 1.36  2006/09/27 07:56:39  bo_zhao
+* *:replace numeric value by a macro
+*
+* Revision 1.35  2006/09/26 06:49:49  bo_zhao
+* *:add ip-mask for pptpserver
+*
+* Revision 1.34  2006/09/11 09:07:08  bo_zhao
+* *:support pptpserver
+*
+* Revision 1.33  2006/08/23 03:21:02  chihhsing
+* *: add "RateRange" to struct qosCfgParam_s for QoS configuration
+*
+* Revision 1.32  2006/08/16 07:55:10  jiucai_wang
+* *:support AH ,IPCOMP and manual key mode
+*
+* Revision 1.31  2006/08/11 02:51:10  alva_zhang
+* *: fix dhcpl2tp/l2tp idle timeout issue
+*
+* Revision 1.30  2006/08/09 05:23:37  alva_zhang
+* *: fix l2tp/dhcpl2tp dial state issue
+*
+* Revision 1.29  2006/04/10 09:37:08  jiucai_wang
+* *:modify struct at line 1366-1369 to avoid compile warning.
+*
+* Revision 1.28  2006/03/24 05:44:31  alva_zhang
+* *: rename full-cone-nat as nat-mapping
+*
+* Revision 1.27  2006/03/23 08:08:28  alva_zhang
+* +: add struct fullConeNatCfgParam_s for full-cone nat
+*
+* Revision 1.26  2006/03/16 03:12:37  yjlou
+* +: Support various NAT Cone Type:
+*    Naive, Symmetric, Restricted, Port-Restricted, and Full Cone.
+*
+* Revision 1.25  2006/03/08 13:09:53  alva_zhang
+* +: add definition of layer2Permit in struct aclGlobalCfgParam for permit layer2 ACL rule
+*
+* Revision 1.24  2006/03/01 05:05:01  yjlou
+* *: correct compile flag: from CONFIG_KLIPS to CONFIG_KU_KLIPS
+*
+* Revision 1.23  2005/12/12 03:24:12  tony
+* +: new feature: support trusted user in url-filter.
+*
+* Revision 1.22  2005/12/09 06:21:28  rupert
+* +: Add IPSEC NAT Traversal Configuration
+*
+* Revision 1.21  2005/12/02 11:00:35  yjlou
+* *: fixed the bug of re-entry flashdrv:
+*    Since we used mutex lock thru ioctl(), it does not work.
+*    Because when ioctl() returns to user-space, the 'IEc' flag will be recovered to 1 due to 'rfe' instruction.
+*    Therefore, we must turn off GIRM to ensure no interrupt will be fired.
+*    And also, we will kick watchdog when erasing and programming flash.
+*
+* Revision 1.20  2005/10/05 13:39:43  rupert
+* +: Add MAX_IPSEC_SESSION Definition
+*
+* Revision 1.19  2005/10/05 09:54:53  chenyl
+* +: BOTH setting for WLAN 8185 WPA/WPA2 configurations
+* 	- support TKIP/AES clients simultaneously
+*
+* *: if the second WLAN interface is not installed, the 'Apply' 'Reset' button
+* 	in advance setting web-page still must be visitable.
+*
+* Revision 1.18  2005/09/26 08:14:22  tony
+* +: add SNMP Daemon application.
+*
+* Revision 1.17  2005/09/23 03:19:50  yjlou
+* *: Port for 865xC FPGA (NEW_SPEC is undef, said, jblin version).
+*    To enable final version, please define NEW_SPEC in the following files:
+* 	linux-2.4.x/arch/mips/realtek/rtl865x/irq.c
+* 	linux-2.4.x/arch/mips/realtek/rtl865x/setup.c
+* 	linux-2.4.x/include/asm-mips/rtl865x/interrupt.h
+*
+* Revision 1.16  2005/09/20 09:20:30  shliu
+* *: define Remote Management Configuration-related constant
+*
+* Revision 1.15  2005/09/05 08:00:00  chenyl
+* +: WPA2 setting
+*
+* Revision 1.14  2005/08/03 08:42:07  chenyl
+* *: modify some WLAN WEP/WPA code to fix bugs
+*
+* Revision 1.13  2005/07/29 09:44:00  chenyl
+* +: dns module in ROMEDRV
+* +: domain blocking (SDK + RomeDrv)
+*
+* Revision 1.12  2005/07/28 13:01:30  tony
+* *: bug fixed: Time Zone - in New York , add PPTP Server UI
+*
+* Revision 1.11  2005/07/28 02:18:40  chhuang
+* *: modify qos page
+*
+* Revision 1.10  2005/07/19 08:48:13  tony
+* *** empty log message ***
+*
+* Revision 1.9  2005/07/11 07:20:23  shliu
+* *: add feature of remote pptp/l2tp setting.
+*
+* Revision 1.8  2005/07/06 12:02:36  tony
+* +: New Features: Gaming
+*
+* Revision 1.7  2005/07/06 11:44:45  chenyl
+* *: bug fix: modify some 8185 setting code
+*
+* Revision 1.6  2005/06/28 06:38:59  tony
+* *: support remote log
+*
+* Revision 1.5  2005/06/24 02:30:10  tony
+* +: new features: mail alert
+*
+* Revision 1.4  2005/06/02 08:38:50  tony
+* +: support new wan type - Static USB-ETHERNET
+*
+* Revision 1.3  2005/05/06 05:07:41  tony
+* *: bug fixed: support PAP,CHAP auth mode by UI.
+*
+* Revision 1.2  2005/05/04 02:32:05  shliu
+* *: add mode selection data structure.
+*
+* Revision 1.1  2005/04/19 04:58:15  tony
+* +: BOA web server initial version.
+*
+* Revision 1.128  2005/03/29 08:29:41  shliu
+* *: Let RIPD run on the WAN interface.
+*
+* Revision 1.127  2005/03/09 08:43:57  chenyl
+* +: for the new default ACL action: RTL8651_ACL_L34_DROP
+*
+* Revision 1.126  2005/02/25 05:34:52  cfliu
+* +Add wds support
+*
+* Revision 1.125  2005/02/17 09:59:40  cfliu
+* +:Modify board.c, board.h, rome_Asp.c to support 8185 AP client mode
+*
+* Revision 1.124  2005/02/02 11:00:17  tony
+* +: add crontab ACL scheduling.
+*
+* Revision 1.123  2005/01/20 10:52:00  ghhuang
+* *: Modify web interface of Diffserv DSCP remarking
+*
+* Revision 1.122  2005/01/20 08:11:33  shliu
+* *: Multiple DMZ-host added
+*
+* Revision 1.121  2005/01/19 09:38:17  ghhuang
+* *: DMZ web interface modification & ratioQosCfgParam_t initial values modification
+*
+* Revision 1.120  2005/01/19 09:07:00  shliu
+* *** empty log message ***
+*
+* Revision 1.119  2005/01/19 06:53:33  shliu
+* *** empty log message ***
+*
+* Revision 1.118  2005/01/18 08:50:22  ghhuang
+* +: Diffserv (DSCP) remarking support
+*
+* Revision 1.117  2005/01/09 08:56:35  cfliu
+* +:Update UI config for dual band/card.
+*
+* Revision 1.116  2005/01/03 01:32:12  rupert
+* +: IPSEC WEB access
+*
+* Revision 1.115  2004/12/28 09:50:48  rupert
+* +: Add IPSEC Support
+*
+* Revision 1.114  2004/12/22 05:19:35  tony
+* +: support new features: make ALG(FTP,SIP,NetMeeting) support MNQueue.
+*
+* Revision 1.113  2004/12/14 09:48:10  chenyl
+* +: NAPT-Connection Control system
+* *: add "NAPT-AddFail" error messages into ignore case.
+*
+* Revision 1.112  2004/12/06 10:51:09  ghhuang
+* Multiple ACL entries can refer to one rate limit entry
+*
+* Revision 1.111  2004/12/02 03:08:38  yjlou
+* +: support IPX/Netbios Passthru function
+*
+* Revision 1.110  2004/11/30 04:55:52  cfliu
+* +: Update wireless ccfg structure info
+*
+* Revision 1.109  2004/11/29 07:42:16  chenyl
+* +: add Semaphore protection into tunekey when ip Up/Down events occur.
+*
+* Revision 1.108  2004/11/18 08:05:22  shliu
+* *** empty log message ***
+*
+* Revision 1.107  2004/11/16 02:30:30  shliu
+* *** empty log message ***
+*
+* Revision 1.106  2004/11/10 05:32:19  cfliu
+* *** empty log message ***
+*
+* Revision 1.105  2004/10/29 09:43:32  cfliu
+* +add regulation domain field
+*
+* Revision 1.104  2004/10/21 11:47:57  chenyl
+* +: web-based icmp/l4proto DMZ forward setting
+*
+* Revision 1.103  2004/10/13 13:35:44  chenyl
+* +: domain setting of DHCP Server
+* +: real-DNS-server setting of DHCP Server
+*
+* Revision 1.102  2004/10/11 10:23:08  yjlou
+* *: restrict only 865xB revB code apply patch code.
+*
+* Revision 1.101  2004/10/11 04:50:48  yjlou
+* +: add rtl8651_enableDropUnknownPppoePADT()
+*
+* Revision 1.100  2004/10/06 14:08:03  chenyl
+* +: dhcp-server wins setting and broadcast to client
+*
+* Revision 1.99  2004/10/05 09:20:42  chenyl
+* +: web page to turn ON/OFF ip-multicast system
+*
+* Revision 1.98  2004/10/04 09:26:59  cfliu
+* change wireless configuration structure
+*
+* Revision 1.97  2004/10/01 07:52:55  yjlou
+* +: add enable/disable PPPoE Passthru and IPv6 Passthru
+*
+* Revision 1.96  2004/09/03 03:00:09  chhuang
+* +: add new feature: pseudo VLAN
+*
+* Revision 1.95  2004/09/02 08:54:14  yjlou
+* *: fixed the bug of flashdrv_isOver5xBBootInstructions(): direct access CRMR in MMU user space is NOT allowed.
+*
+* Revision 1.94  2004/08/20 12:14:43  cfliu
+* +: Add Loose UDP ctrl item
+*
+* Revision 1.93  2004/08/18 05:39:59  chenyl
+* +: napt special option web-based setting
+*
+* Revision 1.92  2004/08/13 06:00:50  cfliu
+* +: Update port number from 8650's 5 to 8650B's 9
+*
+* Revision 1.91  2004/08/10 12:13:20  yjlou
+* *: modify to support kernel mode
+*
+* Revision 1.90  2004/08/04 14:58:27  yjlou
+* *: By default, we DO NOT define _SUPPORT_LARGE_FLASH_ !!
+*
+* Revision 1.89  2004/08/04 14:50:18  yjlou
+* *: change type of __flash_base from 'int*' to 'uint32'
+*
+* Revision 1.88  2004/07/27 07:23:52  chenyl
+* +: DoS ignore type setting
+*
+* Revision 1.87  2004/07/14 13:55:59  chenyl
+* +: web page for MN queue
+*
+* Revision 1.86  2004/07/12 07:35:32  chhuang
+* *: modify rate limit web page
+*
+* Revision 1.85  2004/07/12 07:03:47  tony
+* +: add wan type dhcpl2tp.
+*
+* Revision 1.84  2004/07/12 04:25:36  chenyl
+* *: extend existing port scan mechanism
+*
+* Revision 1.83  2004/07/08 10:51:41  tony
+* *: change ipUp routine to new arch.
+*
+* Revision 1.82  2004/07/07 05:12:36  chhuang
+* +: add a new WAN type (DHCP+L2TP). But not complete yet!!
+*
+* Revision 1.81  2004/07/06 06:19:25  chhuang
+* +: add rate limit
+*
+* Revision 1.80  2004/06/29 09:40:01  cfliu
+* *: Change WLAN rate defines
+*
+* Revision 1.79  2004/06/14 13:48:17  rupert
+* +: Add work properly with MMU kernel
+*
+* Revision 1.78  2004/06/14 09:47:25  tony
+* *: fix PPTP can't compiler well  when not define PPTP/L2TP.
+*
+* Revision 1.77  2004/06/11 09:20:18  tony
+* +: using share memory instead of direct access for pRomeCfgParam.
+*
+* Revision 1.76  2004/06/11 00:44:56  cfliu
+* +: Add port ON/Off webpage
+*
+* Revision 1.75  2004/06/10 14:35:27  cfliu
+* +: Add port config webpage
+*
+* Revision 1.74  2004/06/10 10:34:52  tony
+* +: add PPTP dial status: disconnecting, make redial function correct.
+*
+* Revision 1.73  2004/06/09 12:32:16  tony
+* +: add PPTP/L2TP UI page.(Dial and Hang_Up).
+*
+* Revision 1.72  2004/06/08 10:54:22  cfliu
+* +: Add WLAN dual mode webpages. Not yet completed...
+*
+* Revision 1.71  2004/05/28 09:49:16  yjlou
+* +: support Protocol-Based NAT
+*
+* Revision 1.70  2004/05/27 05:12:36  tony
+* fix multiple pppoe dial problem.
+*
+* Revision 1.69  2004/05/26 06:51:49  yjlou
+* *: use IS_865XB() instead of IS_REV_B()
+* *: use IS_865XA() instead of IS_REV_A()
+*
+* Revision 1.68  2004/05/21 12:08:50  chenyl
+* *: TCP/UDP/ICMP spoof -> check for (sip) == (dip)
+* *: modify DOS prevention webpage
+*
+* Revision 1.67  2004/05/20 08:43:55  chhuang
+* add Web Page for QoS
+*
+* Revision 1.66  2004/05/17 12:17:00  cfliu
+* Add AC Name field
+*
+* Revision 1.65  2004/05/13 13:27:01  yjlou
+* +: loader version is migrated to "00.00.07".
+* +: new architecture for INTEL flash (code is NOT verified).
+* *: FLASH_BASE is decided by IS_REV_A()
+* -: remove flash_map.h (content moved to flashdrv.h)
+* -: remove un-necessary calling setIlev()
+*
+* Revision 1.64  2004/05/12 08:09:56  chhuang
+* +: dhcp static binding
+*
+* Revision 1.63  2004/05/12 07:20:15  chenyl
+* +: source ip blocking
+* *: modify dos mechanism
+*
+* Revision 1.62  2004/05/12 05:15:05  tony
+* support PPTP/L2TP in RTL865XB.
+*
+* Revision 1.61  2004/05/10 05:49:20  chhuang
+* add src ip blocking for url-filtering
+*
+* Revision 1.60  2004/05/05 08:27:07  tony
+* new features: add remote management spec
+*
+* Revision 1.59  2004/05/03 15:02:51  cfliu
+* Add 8650B extension port support.
+* Revise all WLAN/extport related code.
+*
+* Revision 1.58  2004/04/08 13:18:12  tony
+* add PPTP/L2TP routine for MII lookback port.
+*
+* Revision 1.57  2004/04/08 12:40:56  cfliu
+* Update WLAN webpages and related ASP code.
+*
+* Revision 1.56  2004/03/31 01:59:36  tony
+* add L2TP wan type UI pages.
+*
+* Revision 1.55  2004/03/19 09:51:18  tony
+* make the 'lan permit' acl is able to select by user.
+*
+* Revision 1.54  2004/03/03 03:43:31  tony
+* add static routing table in turnkey.
+*
+* Revision 1.53  2004/02/05 07:11:16  tony
+* add acl filter field: IP.
+*
+* Revision 1.52  2004/02/04 03:46:10  tony
+* change lantype from uint8 to uint32
+*
+* Revision 1.51  2004/02/03 08:14:34  tony
+* add UDP Blocking web UI configuration.
+*
+* Revision 1.50  2004/01/30 12:03:05  tony
+* make Special Application is able to support multiple session.
+*
+* Revision 1.49  2004/01/16 12:16:46  tony
+* modify ALG cfg params and web UI,
+* rearrange rtl8651a_setAlgStatus() must called after rtl8651_addIpIntf()
+*
+* Revision 1.48  2004/01/14 02:46:24  hiwu
+* add PPTP configuration
+*
+* Revision 1.47  2004/01/08 13:28:29  orlando
+* dos/url/log related changes
+*
+* Revision 1.46  2004/01/08 12:13:44  tony
+* add Port Range into Server Port.
+* support Server Port for multiple session UI.
+*
+* Revision 1.45  2004/01/08 07:23:21  tony
+* support multiple session UI for ACL, URL Filter, DoS log.
+*
+* Revision 1.44  2004/01/07 10:59:56  tony
+* Support multiple session UI plugin for ACL.
+*
+* Revision 1.43  2004/01/07 09:10:04  tony
+* add PPTP Client UI in Config Wizard.
+*
+* Revision 1.42  2004/01/07 07:36:36  tony
+* Support multiple session UI plugin for ALG.
+*
+* Revision 1.41  2004/01/06 13:50:25  tony
+* Support multiple session UI plugin for the following functions:
+* DMZ, URL Filter, Dos Prevention
+*
+* Revision 1.40  2003/12/19 04:33:01  tony
+* add Wireless Lan config pages: Basic Setting, Advance Setting, Security, Access Control, WDS
+*
+* Revision 1.39  2003/12/12 01:34:54  tony
+* add NAPT toggle in Unnumbered PPPoE.
+*
+* Revision 1.38  2003/12/09 13:44:34  tony
+* add ACL,DoS,URL Filter logging function in kernel space.
+*
+* Revision 1.37  2003/12/02 10:24:47  tony
+* Add Routine: support DoS is able to set threshold by user(Webs GUI).
+*
+* Revision 1.36  2003/12/01 12:35:52  tony
+* make ALG is able to be configured by users(Web GUI).
+*
+* Revision 1.35  2003/11/18 09:04:47  tony
+* add routine: support mtu configure by user in pppoe.
+*
+* Revision 1.34  2003/11/13 13:33:58  tony
+* pppoe: automaic Hang up all the connections after save.
+*
+* Revision 1.33  2003/11/13 12:52:06  tony
+* add MTU and MRU field in pppoe.
+*
+* Revision 1.32  2003/11/07 06:31:22  tony
+* add type PPPOECFGPARAM_DESTNETTYPE_NONE in MultiPPPoE dest network.
+*
+* Revision 1.31  2003/11/06 02:25:08  tony
+* add field in multi-pppoe cfg.
+*
+* Revision 1.30  2003/11/04 09:30:56  tony
+* modfiy special-application list in board.c
+*
+* Revision 1.29  2003/10/29 10:20:41  tony
+* modify acl policy list.
+*
+* Revision 1.28  2003/10/29 01:48:24  tony
+* fix trigger port bug: when ouside host send a SYN to internal computer,
+* gateway return a RST packet problem.
+*
+* Revision 1.27  2003/10/24 10:25:58  tony
+* add DoS attack interactive webpage,
+* FwdEngine is able to get WAN status by rtl8651_wanStatus(0:disconnect,1:connect)
+*
+* Revision 1.26  2003/10/15 12:12:08  orlando
+* add pppoeCfgParam[].pppx to keep track of hw ppp obj id (0,1,2,3,...)
+* in association with linux ppp dial up interface (ppp0,ppp1,ppp2,ppp3,...)
+*
+* Revision 1.25  2003/10/14 08:15:01  tony
+* add user account management routine
+*
+* Revision 1.24  2003/10/03 12:27:35  tony
+* add NTP time sync routine in management web page.
+*
+* Revision 1.23  2003/10/03 01:26:42  tony
+* add ServiceName field in pppoeCfgParam_t.
+* add dynamic check in PPPoE/Unnumbered PPPoE/Multiple PPPoE web page.
+*
+* Revision 1.22  2003/10/02 10:50:17  orlando
+* add manualHangup and whichPppObjId fields in pppoeCfgParam_t for auto
+* reconnect implementation
+*
+* Revision 1.21  2003/10/01 05:57:31  tony
+* add URL Filter routine
+*
+* Revision 1.20  2003/09/30 08:56:29  tony
+* remove newServerpCfgParam[] from flash, rename ram PPPoeCfg to ramPppoeCfgParam
+*
+* Revision 1.19  2003/09/29 13:21:03  rupert
+* add primary and secondary dns fields of ifCfgParam_s
+*
+* Revision 1.18  2003/09/29 08:57:32  tony
+* add routine: when pppoe config changed, the dial function will be disabled.
+* add routine: dhcps is able to start/stop server on runtime.
+*
+* Revision 1.17  2003/09/29 05:05:42  orlando
+* add pppoeCfgParam[].svrMac/sessionId
+*
+* Revision 1.16  2003/09/26 01:55:31  orlando
+* clean the structure
+*
+* Revision 1.15  2003/09/25 10:44:50  tony
+* small change
+*
+* Revision 1.14  2003/09/25 10:14:50  tony
+* modify pppoe webpage, support unnumbered IP, PPPoE, Multiple PPPoE.
+*
+* Revision 1.13  2003/09/25 06:43:32  rupert
+* add contant of routing function
+*
+* Revision 1.12  2003/09/25 06:06:45  orlando
+* adjust inclue files
+*
+* Revision 1.11  2003/09/25 03:48:35  orlando
+* add romecfg.txt file to pass romeCfgParam structure pointer for other user space application
+*
+* Revision 1.10  2003/09/25 03:37:36  orlando
+* integration...
+*
+* Revision 1.9  2003/09/25 02:15:32  orlando
+* Big Change
+*
+* Revision 1.8  2003/09/24 07:10:30  rupert
+* rearrange init sequence
+*
+* Revision 1.7  2003/09/23 03:47:29  tony
+* add ddnsCfgParam,ddnsDefaultFactory,ddns_init
+*
+* Revision 1.6  2003/09/22 08:01:45  tony
+* add UPnP Web Configuration Function Routine
+*
+* Revision 1.5  2003/09/22 06:33:37  tony
+* add syslogd process start/stop by CGI.
+* add eventlog download/clear routine.
+*
+* Revision 1.4  2003/09/19 06:06:51  tony
+* *** empty log message ***
+*
+* Revision 1.3  2003/09/19 01:43:50  tony
+* add dmz routine
+*
+* Revision 1.2  2003/09/18 02:05:45  tony
+* modify pppoeCfgParam to array
+*
+* Revision 1.1.1.1  2003/08/27 06:20:15  rupert
+* uclinux initial
+*
+* Revision 1.1.1.1  2003/08/27 03:08:53  rupert
+*  initial version
+*
+* Revision 1.24  2003/07/03 12:15:59  tony
+* fix some warning messages.
+*
+* Revision 1.23  2003/07/03 06:01:11  tony
+* change dhcpcCfgParam_s field order, for 4 bytes alignment.
+*
+* Revision 1.22  2003/07/01 10:25:22  orlando
+* call table driver server port and acl API in board.c
+*
+* Revision 1.21  2003/07/01 03:09:06  tony
+* add aclGlobalCfgParam structure.
+* modify aclCfgParam and serverpCfgParam structure.
+*
+* Revision 1.20  2003/06/30 13:27:55  tony
+* add a field in server_port table
+*
+* Revision 1.19  2003/06/30 07:46:12  tony
+* add ACL and Server_Port structure
+*
+* Revision 1.18  2003/06/27 13:53:25  orlando
+* remove dhcpcCfgParam.valid field, use ifCfgParam[0].connType field
+* modify rtConfigHook() for cloneMac:
+* use dhcpcCfgParam.cloneMac if ifCfgParam[0].connType is
+* DHCPC and dhcpcCfgParam.cmacValid is 1 during boottime.
+*
+* Revision 1.17  2003/06/27 05:33:06  orlando
+* adjust some structure.
+*
+* Revision 1.16  2003/06/26 03:22:29  tony
+* remove some element in dhcpc data structure.
+*
+* Revision 1.15  2003/06/26 03:19:53  orlando
+* add ifCfgParam_connType enumeration.
+*
+* Revision 1.14  2003/06/23 10:57:23  elvis
+* change include path of  rtl_types.h
+*
+* Revision 1.13  2003/06/20 12:59:50  tony
+* add dhcp client
+*
+* Revision 1.12  2003/06/16 08:08:30  tony
+* add dhcps & dns function
+*
+* Revision 1.11  2003/06/11 11:39:29  tony
+* add WAN IP connection Type (static, PPPoE, DHCP)
+*
+* Revision 1.10  2003/06/06 11:57:06  orlando
+* add pppoe cfg.
+*
+* Revision 1.9  2003/06/06 06:31:45  idayang
+* add mgmt table in cfgmgr.
+*
+* Revision 1.8  2003/06/03 10:56:57  orlando
+* add nat table in cfgmgr.
+*
+* Revision 1.7  2003/05/20 08:45:03  elvis
+* change the include path of "rtl_types.h"
+*
+* Revision 1.6  2003/05/09 12:22:20  kckao
+* remove RTL8650_LOAD_COUNT
+*
+* Revision 1.5  2003/05/02 08:51:45  orlando
+* merge cfgmgr with old board.c/board.h.
+*
+* Revision 1.4  2003/04/29 14:20:19  orlando
+* modified for cfgmgr.
+*
+* Revision 1.3  2003/04/08 15:29:47  elvis
+* add interface ,route and static arp configurations
+*
+* Revision 1.2  2003/04/04 02:28:48  elvis
+* add constant definition for PHY0, ..., PHY4
+*
+* Revision 1.1  2003/04/03 01:52:37  danwu
+* init
+*
+* ---------------------------------------------------------------
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#ifndef _BOARD_H_
+#define _BOARD_H_
+
+#if defined(__KERNEL__) && defined(__linux__)
+	/* kernel mode */
+	#include "rtl865x/rtl_types.h"
+	#include "rtl865x/asicRegs.h"
+	#ifdef CONFIG_RTL865XC
+		#define IS_865XC() (1)
+		#define IS_865XB() (0)
+		#define IS_865XA() (0)
+	#else
+		#define IS_865XC() (0)
+		#define IS_865XB() ( ( REG32( CRMR ) & 0xffff ) == 0x5788 )
+		#define IS_865XA() ( !IS_865XB() )
+	#endif
+	#define FLASH_BASE          (IS_865XA()?0xBFC00000:(IS_865XB()?0xBE000000:0xBE000000))
+	#define CRMR_ADDR          CRMR
+	#define WDTCNR_ADDR        WDTCNR
+#else
+	/* goahead */
+	#include <rtl_types.h>
+	#include <linux/config.h>
+	#include <asicRegs.h>
+	#ifdef __uClinux__
+	/* non MMU */
+	#ifdef CONFIG_RTL865XC
+		#define IS_865XC() (1)
+		#define IS_865XB() (0)
+		#define IS_865XA() (0)
+	#else
+		#define IS_865XC() (0)
+		#define IS_865XB() ( ( REG32( CRMR ) & 0xffff ) == 0x5788 )
+		#define IS_865XA() ( !IS_865XB() )
+	#endif
+	#define FLASH_BASE          (IS_865XA()?0xBFC00000:(IS_865XB()?0xBE000000:0xBE000000))
+	#define CRMR_ADDR          CRMR
+	#define WDTCNR_ADDR        WDTCNR
+	#else
+	/* MMU */
+	#ifdef CONFIG_RTL865XC
+		#define IS_865XC() (1)
+		#define IS_865XB() (0)
+		#define IS_865XA() (0)
+	#else
+		#define IS_865XC() (0)
+		#define IS_865XB() (1)
+		#define IS_865XA() (0)
+	#endif
+	extern uint32 __flash_base;
+	#define FLASH_BASE          __flash_base
+	#define FLASH_BASE_REAL     (IS_865XA()?0xBFC00000:(IS_865XB()?0xBE000000:0xBE000000))
+	extern uint32 __crmr_addr;
+	extern uint32 __wdtcnr_addr;
+	#define CRMR_ADDR          __crmr_addr
+	#define WDTCNR_ADDR        __wdtcnr_addr
+	int rtl865x_mmap(int base,int length);
+	#endif
+#endif
+
+#undef _SUPPORT_LARGE_FLASH_ /* to support single 8MB/16MB flash */
+
+
+/* Define flash device
+*/
+
+#define VLAN_LOAD_COUNT		8
+#define MAX_PORT_NUM		9
+#define MAX_IP_INTERFACE	VLAN_LOAD_COUNT
+#define MAX_ROUTE			MAX_IP_INTERFACE
+#define MAX_STATIC_ARP		10
+#define MAX_MGMT_USER		1
+#define MAX_ACL				8
+#define MAX_SERVER_PORT	    8
+#define MAX_SPECIAL_AP		8
+#define MAX_GAMING		8
+#define MAX_PPPOE_SESSION	2
+#define MAX_WLAN_CARDS		2
+#define MAX_URL_FILTER		8
+#define MAX_WLAN_AC		    8
+#define MAX_WLAN_WDS		8
+#define MAX_WLAN_VAP		4
+#define MAX_WLAN_CRYPT_MIX_TYPE	2		/* WPA2 mix : allow WPA/WPA2 -- 2 types */
+#define	MAX_IP_STRING_LEN	48
+#define MAX_ROUTING	5
+#define MAX_QOS			13
+#define MAX_RATIO_QOS		10
+#define MAX_PBNAT			4
+#define MAX_NAT_MAPPING   6 // define for NAT Mapping
+#define MAX_USER_SEMAPHORE	2
+#define ROMECFGFILE         "/var/romecfg.txt"
+#define ALG_QOS_TYPES		3
+#define MAX_DOMAIN_BLOCKING	8
+#define MAX_ALLOW_DOMAINNAME_LEN	(32+1)
+#define MAX_IPSEC_SESSION 	3
+#define PHY0	            0x00000001
+#define PHY1	            0x00000002
+#define PHY2	            0x00000004
+#define PHY3	            0x00000008
+#define PHY4	            0x00000010
+#define PHYMII		0x00000020
+#define MAX_PHYS	        5
+#define EXTPT0	   0x00000040
+#define EXTPT1	   0x00000080
+#define EXTPT2	   0x00000100
+#define _RTL8651_EXTDEV_DEVCOUNT 16
+#define MAX_CWMP_PORTMAPPING16
+
+/* define semaphore types */
+#define SEMAPHORE_IPUPDOWN	0	/* for IP Up/Down only */
+#define SEMAPHORE_IPEVENT		1	/* for IP events in board.c */
+
+/* add routing functions  constant*/
+#define error_msg(fmt,args...)
+#define ENOSUPP(fmt,args...)
+#define RTACTION_ADD   1
+#define RTACTION_DEL   2
+#define RTACTION_HELP  3
+#define RTACTION_FLUSH 4
+#define RTACTION_SHOW  5
+#define E_LOOKUP	-1
+#define E_OPTERR	-2
+#define E_SOCK	-3
+#define mask_in_addr(x) (((struct sockaddr_in *)&((x).rt_genmask))->sin_addr.s_addr)
+#define full_mask(x) (x)
+
+#define ACL_SINGLE_HANDLE_ADD 1
+#define ACL_SINGLE_HANDLE_DEL 2
+
+#define SHM_PROMECFGPARAM 0x1000
+
+/* define NAPT-mode/Router-mode/Bridge-mode constant. */
+#define RTL865XB_L4GATEWAYMODE	4
+#define RTL865XB_L3ROUTERMODE		3
+#define RTL865XB_L2BRIDGEMODE		2
+
+/* define Remote Management Configuration-related constant */
+#define RTL865XB_MULTIPLE_PPPOE_PRIVATE_LAN		0
+#define RTL865XB_MULTIPLE_PPPOE_UNNUMBER_LAN 	1
+
+/*define max prefix supported*/
+#define MAX_PREFIX_NUM 2
+#define IFNAMESIZE 32
+#define NAMSIZE 32
+#define MAX_DNAME_SIZE 256
+#define RR_MAX_NUM 4
+
+
+#ifdef CONFIG_RTL8185
+
+#define SIOCGIWNAME	0x8B01		/* get name == wireless protocol */
+
+#define SIOCGIWRTLSTAINFO       0x8B30
+#define SIOCGIWRTLSTANUM        0x8B31
+#define SIOCGIWRTLDRVVERSION    0x8B32
+#define SIOCGIWRTLSCANREQ       0x8B33
+#define SIOCGIWRTLGETBSSDB      0x8B34
+#define SIOCGIWRTLJOINREQ       0x8B35
+#define SIOCGIWRTLJOINREQSTATUS 0x8B36
+#define SIOCGIWRTLGETBSSINFO    0x8B37
+#define SIOCGIWRTLGETWDSINFO    0x8B38
+#define STA_INFO_FLAG_80211A    0x10
+#define STA_INFO_FLAG_80211B    0x20   //if this bit is not set, it is a 11G station
+
+#define  MAX_BSS_DESC 64
+#define  SSID_LEN     32
+
+
+#define CWMP_L3ENTRY_LEN		 8
+#define CWMP_MAX_NOTIFY_CONFIG_INFO 15
+
+typedef struct _sta_info_2_web {
+    unsigned short    aid;
+    unsigned char     addr[6];
+    unsigned long     tx_packets;
+    unsigned long     rx_packets;
+    unsigned long     expired_time;    // 10 msec unit
+    unsigned short    flags;
+    unsigned char     TxOperaRate;
+    unsigned char     rssi;
+    unsigned long     link_time;        // 1 sec unit
+    unsigned long     tx_fail;
+    unsigned char     resv[16];
+} sta_info_2_web;
+
+typedef enum _BssType {
+    infrastructure = 1,
+    independent = 2,
+} BssType;
+
+typedef struct _OCTET_STRING {
+    unsigned char *Octet;
+    unsigned short Length;
+} OCTET_STRING;
+
+typedef    struct _IbssParms {
+    unsigned short    atimWin;
+} IbssParms;
+
+
+typedef struct _BssDscr {
+    unsigned char bdBssId[6];
+    unsigned char bdSsIdBuf[SSID_LEN];
+    OCTET_STRING  bdSsId;
+    BssType bdType;
+    unsigned short bdBcnPer;            // beacon period in Time Units
+    unsigned char bdDtimPer;            // DTIM period in beacon periods
+    unsigned long bdTstamp[2];            // 8 Octets from ProbeRsp/Beacon
+    IbssParms bdIbssParms;            // empty if infrastructure BSS
+    unsigned short bdCap;                // capability information
+    unsigned char ChannelNumber;            // channel number
+    unsigned long bdBrates;
+    unsigned long bdSupportRates;
+    unsigned char bdsa[6];            // SA address
+    unsigned char rssi, sq;            // RSSI and signal strength
+    unsigned char network;            // 1: 11B, 2: 11G, 4:11G
+} BssDscr, *pBssDscr;
+
+typedef struct _bss_info {
+    unsigned char state;
+    unsigned char channel;
+    unsigned char txRate;
+    unsigned char bssid[6];
+    unsigned char rssi, sq;    // RSSI  and signal strength
+    unsigned char ssid[SSID_LEN+1];
+} bss_info;
+
+typedef enum { INFRASTRUCTURE=0, ADHOC=1 } NETWORK_TYPE_T;
+typedef enum { BAND_11B=1, BAND_11G=2, BAND_11BG=3, BAND_11A=4 } BAND_TYPE_T;
+typedef enum { AP_MODE=0, CLIENT_MODE=1, WDS_MODE=2, AP_WDS_MODE=3    } WLAN_MODE_T;
+typedef enum _wlan_mac_state {
+    STATE_DISABLED=0, STATE_IDLE, STATE_SCANNING, STATE_STARTED, STATE_CONNECTED
+} wlan_mac_state;
+
+typedef enum _Capability {
+    cESS         = 0x01,
+    cIBSS        = 0x02,
+    cPollable        = 0x04,
+    cPollReq        = 0x01,
+    cPrivacy        = 0x10,
+    cShortPreamble    = 0x20,
+} Capability;
+
+typedef struct _sitesurvey_status {
+    unsigned char number;
+    unsigned char pad[3];
+    BssDscr bssdb[MAX_BSS_DESC];
+} SS_STATUS_T, *SS_STATUS_Tp;
+
+
+typedef enum _Synchronization_Sta_State{
+    STATE_Min                   = 0,
+    STATE_No_Bss                = 1,
+    STATE_Bss                   = 2,
+    STATE_Ibss_Active           = 3,
+    STATE_Ibss_Idle             = 4,
+    STATE_Act_Receive           = 5,
+    STATE_Pas_Listen            = 6,
+    STATE_Act_Listen            = 7,
+    STATE_Join_Wait_Beacon      = 8,
+    STATE_Max                   = 9
+} Synchronization_Sta_State;
+
+#endif
+
+
+typedef struct vlanCfgParam_s
+{
+	uint32          vid;        /* VLAN index */
+	uint32          memberPort; /* member port list */
+	uint32	   enablePorts; /*Enabled Port Numbers*/
+	uint32          mtu;        /* layer 3 mtu */
+	uint32          valid;      /* valid */
+	ether_addr_t	gmac;	    /* clone gateway mac address */
+	uint8           rsv[2];     /* for 4 byte alignment */
+} vlanCfgParam_t;
+
+
+enum ifCfgParam_connType_e {
+	IFCFGPARAM_CONNTYPE_STATIC = 0,
+	IFCFGPARAM_CONNTYPE_PPPOE,
+	IFCFGPARAM_CONNTYPE_DHCPC,
+	IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED,
+	IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE,
+	IFCFGPARAM_CONNTYPE_PPTP,
+	IFCFGPARAM_CONNTYPE_L2TP,
+	IFCFGPARAM_CONNTYPE_DHCPL2TP,
+	IFCFGPARAM_CONNTYPE_3G,
+	IFCFGPARAM_CONNTYPE_USB_ETHERNET,
+};
+
+typedef struct ifCfgParam_s	/* Interface Configuration */
+{
+	uint32		if_unit;	/* interface unit; 0, 1(vl0, vl1)... */
+	uint8		ipAddr[4];	/* ip address */
+	uint8		ipAddr1[4];	/* ip address 1: this is for multiple DMZ host spec. */
+	uint8		ipAddr2[4];	/* ip address 2: this is for multiple DMZ host spec. */
+	uint8		ipMask[4];	/* network mask */
+	uint8		ipMask1[4];	/* network mask 1: this is for multiple DMZ host spec.  */
+	uint8		ipMask2[4];	/* network mask 2: this is for multiple DMZ host spec.  */
+	uint8		gwAddr[4];  /* default gateway address */
+	uint8		dnsPrimaryAddr[4]; /* dns address */
+	uint8		dnsSecondaryAddr[4]; /* dns address */
+	uint8		fwdWins;		/* propagate Wins server setting to LAN */
+	ipaddr_t		winsPrimaryAddr;	/* wins primary server address */
+	ipaddr_t		winsSecondaryAddr;	/* wins secondary server address */
+	uint32		flags;	    /* flags for interface attributes */
+	uint32		valid;	    /* valid */
+	uint32		connType;	/* connection type: 0->static ip, 1->pppoe, 2->dhcp */
+} ifCfgParam_t;
+
+
+
+enum pptpCfgParam_dialState_e {
+	PPTPCFGPARAM_DIALSTATE_OFF=0,
+	PPTPCFGPARAM_DIALSTATE_DIALED_WAITING,
+	PPTPCFGPARAM_DIALSTATE_DIALED_TRYING,
+	PPTPCFGPARAM_DIALSTATE_DIALED_SUCCESS,
+	PPTPCFGPARAM_DIALSTATE_DISCONNECTING
+};
+
+enum l2tpCfgParam_dialState_e {
+	L2TPCFGPARAM_DIALSTATE_OFF=0,
+	L2TPCFGPARAM_DIALSTATE_DIALED_WAITING,
+	L2TPCFGPARAM_DIALSTATE_DIALED_TRYING,
+	L2TPCFGPARAM_DIALSTATE_DIALED_SUCCESS,
+	L2TPCFGPARAM_DIALSTATE_DISCONNECTING,
+	L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER,
+	L2TPCFGPARAM_DIALSTATE_DIALED_MANUAL_HANGUP,
+	L2TPCFGPARAM_DIALSTATE_DIALED_IDLE_HANGUP
+};
+
+enum pppParam_authType {
+	PPPPARAM_AUTHTYPE_PAP=0,
+	PPPPARAM_AUTHTYPE_CHAP
+};
+
+typedef struct pptpCfgParam_s	/* PPTP Configuration */
+{
+	uint8	ipAddr[4];	/* ip address */
+	uint8	ipMask[4];	/* network mask */
+	uint8	svAddr[4];  /* pptp server ip address */
+	uint8	gwAddr[4];  /* pptp default gw ip address */
+	int8		username[32];  /* pptp server username */
+	int8		password[32];  /* pptp server password */
+	uint32	mtu;
+
+	uint8			manualHangup;        /* only meaningful for ram version, to record a manual hangup event from web ui */
+	uint8			autoReconnect; /* 1/0 */
+	uint8			demand;		   /* 1/0 */
+	uint8			dialState;	   /*  only meaningful for ram version, dial state */
+
+	uint32			silentTimeout; /* in seconds */
+	uint32			authType;
+
+} pptpCfgParam_t;
+
+typedef struct pptpServerCfgParam_s	/* PPTP Configuration */
+{
+	int8		username[32];  /* pptp server username */
+	int8		password[32];  /* pptp server password */
+	uint8	range1;	/* start ip address */
+	uint8	range2;	/* end ip address */
+	uint8	mapIp;	/* ipaddress mapped to lan */
+	uint8 ipmask;	/* IP mask */
+	uint8	status; /* 0:Stop , 1:Start */
+	uint8	reserved;
+} pptpServerCfgParam_t;
+
+typedef struct l2tpCfgParam_s	/* L2TP Configuration */
+{
+	uint8	ipAddr[4];	/* ip address */
+	uint8	ipMask[4];	/* network mask */
+	uint8	svAddr[4];  /* l2tp server ip address */
+	uint8	gwAddr[4];  /* l2tp default gw ip address */
+	int8		username[32];  /* pppoe server username */
+	int8		password[32];  /* pppoe server password */
+	uint32	mtu;
+
+	uint8			manualHangup;        /* only meaningful for ram version, to record a manual hangup event from web ui */
+	uint8			autoReconnect; /* 1/0 */
+	uint8			demand;		   /* 1/0 */
+	uint8			dialState;	   /*  only meaningful for ram version, dial state */
+
+	uint32			silentTimeout; /* in seconds */
+	uint32			authType;
+
+} l2tpCfgParam_t;
+
+
+typedef struct routeCfgParam_s	/* Route Configuration */
+{
+	uint32          if_unit;	  /* interface unit; 0, 1(vl0, vl1)... */
+	uint8           ipAddr[4];	  /* ip network address */
+	uint8           ipMask[4];	  /* ip network mask */
+	uint8           ipGateway[4]; /* gateway address */
+	uint32          valid; 		  /* valid */
+} routeCfgParam_t;
+
+typedef struct arpCfgParam_s /* Static ARP Configuration */
+{
+	uint32          if_unit;	  /* interface unit; 0, 1(vl0, vl1)... */
+	uint8           ipAddr[4];	  /* ip host address */
+	uint32          port;
+	uint32          valid;
+	ether_addr_t	mac;
+	uint8           rsv[2];       /* for 4 byte alignment */
+} arpCfgParam_t;
+
+typedef struct natCfgParam_s /* nat Configuration */
+{
+	uint8			enable;			/* 0: disable, 1: enable */
+	uint8			hwaccel;			/* 1:hardware acceleration,0:no hw accel */
+	uint8			ipsecPassthru;	/* 1: passthru, 0: no passthru */
+	uint8			pptpPassthru;	/* 1: passthru, 0: no passthru */
+	uint8			l2tpPassthru;	/* 1: passthru, 0: no passthru */
+	uint8			natType;
+	uint8			rsv[2];			/* for 4 byte alignment */
+} natCfgParam_t;
+
+typedef struct natMappingCfgParam_s
+{
+    ipaddr_t IntIp;
+    ipaddr_t ExtIp;
+    uint8 Enabled;
+    uint8 Empty;
+    int16 Status;
+}natMappingCfgParam_t;
+
+enum ppppoeCfgParam_dialState_e {
+	PPPOECFGPARAM_DIALSTATE_OFF=0,
+	PPPOECFGPARAM_DIALSTATE_DIALED_WAITING,
+	PPPOECFGPARAM_DIALSTATE_DIALED_TRYING,
+	PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS
+};
+
+enum ppppoeCfgParam_destnetType_e {
+	PPPOECFGPARAM_DESTNETTYPE_NONE=0,
+	PPPOECFGPARAM_DESTNETTYPE_IP,
+	PPPOECFGPARAM_DESTNETTYPE_DOMAIN,
+	PPPOECFGPARAM_DESTNETTYPE_TCPPORT,
+	PPPOECFGPARAM_DESTNETTYPE_UDPPORT,
+};
+
+enum ppppoeCfgParam_lanType_e {
+	PPPOECFGPARAM_LANTYPE_NAPT=0,
+	PPPOECFGPARAM_LANTYPE_UNNUMBERED,
+};
+
+typedef struct pppoeCfgParam_s
+{
+	uint8			enable;        /* 1:used/enabled, 0:no pppoe */
+	uint8			defaultSession;   	/* default pppoe session  */
+	uint8			unnumbered;		/* unnumbered pppoe */
+	uint8			autoReconnect; /* 1/0 */
+
+	uint8			demand;		   /* 1/0 */
+	uint8			dialState;	   /*  only meaningful for ram version, dial state */
+	uint16			sessionId;	   /* pppoe session id */
+
+	uint32			silentTimeout; /* in seconds */
+
+	uint8           ipAddr[4];	   /* ip address, for multiple pppoe only */
+	uint8           ipMask[4];	   /* network mask, for multiple pppoe only */
+	uint8           gwAddr[4];     /* default gateway address, for multiple pppoe only */
+	uint8           dnsAddr[4];    /* dns address, for multiple pppoe only */
+
+	uint8           localHostIp[4]; /* nat's local host ip, for pppoe/nat case only */
+
+	int8			username[32];  /* pppoe server username */
+
+	int8			password[32];  /* pppoe server password */
+
+	int8 			acName[32];
+
+	int8			serviceName[32];  /* pppoe service name */
+
+	int8			destnet[4][32];  /* pppoe destination network route 1~4 */
+
+	int8			destnetType[4];  /* pppoe destination network type 1~4 */
+
+	uint8			unnumberedIpAddr[4];  /* global IP assign by ISP */
+
+	uint8			unnumberedIpMask[4];  /* global Network mask assign by ISP */
+
+	uint8           svrMac[6];     /* pppoe server mac address */
+    uint8           pppx; /* i am pppx (0,1,2,3,...: ppp0,ppp1,ppp2,...) */
+    uint8           unnumberedNapt;
+
+	uint8           whichPppObjId; /* only meaningful for ram version, and for pppoeCfgParam[0] only, to keep track of who is the up/down pppObjId */
+	uint8           manualHangup; /* only meaningful for ram version, to record a manual hangup event from web ui */
+	uint16	mtu;
+
+	uint32	lanType;
+	uint32	authType;
+
+} pppoeCfgParam_t;
+
+typedef struct dhcpsCfgParam_s
+{
+	uint8           enable;     /* 1:used/enabled, 0:disable */
+	uint8           startIp;    /* DHCP Server IP Pool Start IP */
+	uint8           endIp;      /* DHCP Server IP Pool End IP */
+	uint8	   rsv;     	/* for 4 byte alignment */
+	uint8	   realDNSenable;	/* dhcp server provide real-DNS server ip address to dhcp client */
+	uint8	   dhcpDomainFwd;	/* forward domain name got from WAN DHCP server */
+	char		   domain[64];	/* domain name provided by dhcp server */
+	uint32	   manualIp[2];
+	uint8	   hardwareAddr[2][6];
+} dhcpsCfgParam_t;
+
+typedef struct dhcpcCfgParam_s
+{
+	uint32      cmacValid; 	    /* cmac valid */
+	uint8		cloneMac[6];	/* clone mac address */
+	uint8       rsv[2]; 		    /* for alignment */
+} dhcpcCfgParam_t;
+
+/*IPv6 Addr*/
+typedef struct addrIPv6_s
+{
+	int	   enable; 	/* 0:off 1:on */
+	int	   prefix_len[2];
+	uint16	   addrIPv6[2][8];
+} addrIPv6_t;
+
+/*IPv6 in IPv4 tunnel*/
+typedef struct tunnel6in4_s
+{
+	char strTunnelName[12];
+	uint8 	addrRemote[4];
+	uint8	addrLocal[4];
+	uint16	tunnelAddrIPv6[8];
+	uint8	maskRemote[4];
+	uint8 	maskLocal[4];
+} tunnel6in4_t;
+
+typedef struct tunnel6in4array_s
+{
+	int  iTunnelNum;
+	tunnel6in4_t tunnel6in4[10];
+}tunnel6in4array_t;
+
+typedef struct tunnel6to4_s
+{
+	int  flag_6to4;
+}tunnel6to4_t;
+
+/*IPv6 Route*/
+typedef struct routeIPv6_s
+{
+	char	 	dev[8];
+	int	   prefix_len;
+	uint16	   addrIPv6[8];
+
+} routeIPv6_t;
+
+typedef struct routeTableIPv6_s
+{
+	int	   iRouteNum;
+	routeIPv6_t	   routeIPv6[10];
+} routeTableIPv6_t;
+
+/*radvd*/
+
+struct AdvPrefix {
+        uint16    		Prefix[8];
+        uint8                  PrefixLen;
+        int                     AdvOnLinkFlag;
+        int                     AdvAutonomousFlag;
+        uint32                AdvValidLifetime;
+        uint32                AdvPreferredLifetime;
+
+        /* Mobile IPv6 extensions */
+        int                     AdvRouterAddr;
+
+        /* 6to4 extensions */
+        char                    if6to4[IFNAMESIZE];
+        int                     enabled;
+};
+
+
+struct Interface {
+	  char                    Name[IFNAMESIZE]; /* interface name */
+        uint32                  MaxRtrAdvInterval;
+        uint32                  MinRtrAdvInterval;
+        uint32                  MinDelayBetweenRAs;
+        uint8                    AdvManagedFlag;
+        uint8                    AdvOtherConfigFlag;
+        uint32                   AdvLinkMTU;
+        uint32			   AdvReachableTime;
+        uint32                  AdvRetransTimer;
+        uint8                   AdvCurHopLimit;
+        uint16                  AdvDefaultLifetime;
+        char                    AdvDefaultPreference[IFNAMESIZE];
+        int                       AdvSourceLLAddress;
+        int                       UnicastOnly;
+	 struct AdvPrefix prefix[MAX_PREFIX_NUM];
+};
+
+typedef struct radvdCfgParam_s
+{
+	uint8 enabled;
+       /*support eth1 only*/
+	struct Interface interface;
+}radvdCfgParam_t;
+
+/*dnsv6*/
+struct rrResource
+{
+	char domainName[MAX_DNAME_SIZE];
+	uint16 address[8];
+};
+
+typedef struct dnsv6CfgParam_s
+{
+       uint8 enabled;
+	/*default name myrouter*/
+	char routerName[NAMSIZE];
+	struct rrResource rr[RR_MAX_NUM];
+}dnsv6CfgParam_t;
+
+/*dhcpv6*/
+struct dnsOptions
+{
+	char dns_domain[NAMSIZE];
+	uint16 dns_server[8] ;
+};
+
+struct prefixDelegation
+{
+	/*the interface to send IA_PD request*/
+	char up_intfName[IFNAMESIZE];
+	/*prefix+sla_id = new prefix*/
+	int sla_id;
+	/*local interface using the new prefix*/
+	char local_intfName[IFNAMESIZE];
+};
+
+typedef struct dhcpv6sCfgParam_s
+{
+       uint8 enabled;
+	char  intfname[IFNAMESIZE]; /* interface name */
+	/*now only support DNS options*/
+	struct dnsOptions dns;
+}dhcpv6sCfgParam_t;
+
+typedef struct dhcpv6cCfgParam_s
+{
+       uint8 enabled;
+	/*now only support prefix delagation on eth0 interface*/
+	uint8 information_only;
+      uint8 send_rapid_commit;
+      uint8 request_prefix_delegation;
+      uint8 request_temp_address;
+	uint8 request_domain_name_servers;
+	struct prefixDelegation delegation;
+}dhcpv6cCfgParam_t;
+
+typedef struct tr069CfgParam_s
+{
+	char	ACS_URL[50];
+}tr069CfgParam_t;
+
+typedef struct cwmpFlag_s
+{
+	unsigned char	cFlag;
+}cwmpFlag_t;
+
+typedef struct cwmpACSAccountCfgParam_s
+{
+	char name[10];
+	char key[10];
+}cwmpACSAccountCfgParam_t;
+
+typedef struct cwmpConreqAccountCfgParam_s
+{
+        char name[10];
+        char key[10];
+}cwmpConreqAccountCfgParam_t;
+
+typedef struct cwmpInform_s
+{
+	int cwmpInformInterval;
+	char cwmpInformEnable[2];
+}cwmpInform_t;
+
+typedef struct cwmpDeviceInfo_s{
+	char		Manufacturer[65];
+	char		ManufacturerOUI[7];
+	char		ModelName[65];
+	char		Description[257];
+	char		SerialNumber[65];
+	char		HardwareVersion[65];
+	char		SoftwareVersion[65];
+	char		SpecVersion[17];
+	char		ProvisioningCode[65];
+	unsigned int	UpTime;
+	char 	UpGradesManaged;
+	char		DeviceLog[8]; //size should be 32K bytes
+}cwmpDeviceInfo_t;
+
+typedef struct cwmpInformTime_s
+{
+	int  itime;
+	int  test;
+}cwmpInformTime_t;
+
+typedef struct cwmpParam_s
+{
+	char			enable;
+	int  			EventCode;
+	int			DLStartTime;
+	int			DLCompleteTime;
+	unsigned int	DLFaultCode;
+	char	 		DLCommandKey[10];
+	char			RB_CommandKey[20];
+	char			SI_CommandKey[20];
+}cwmpParam_t;
+
+typedef struct cwmpDHCPServ_s
+{
+        char configurable;
+}cwmpDHCPServ_t;
+
+typedef struct cwmpNotifyConfig_s
+{
+      	char name[128] ;
+  	unsigned int mode;
+}cwmpNotifyConfig_t;
+
+typedef struct cwmpServerpCfgParam_s
+{
+	uint32		InstanceNum;	//instance Num
+	uint8		ip[4];		// Server IP address
+	uint16		wanPortStart;	// WAN Port
+	uint16		wanPortFinish;	// WAN Port
+	uint16		portStart;		// Server Port
+	uint8       	protocol;	// SERVERPCFGPARAM_PROTOCOL_TCP or SERVERPCFGPARAM_PROTOCOL_UDP
+	uint8		enable;		// enable
+	uint32		flag;
+} cwmpServerpCfgParam_t;
+
+#define CWMP_NETINTF_NAME_LEN 16
+typedef struct cwmp_extRouteTable_s
+{
+	uint16	InstanceNum;	//instance Num
+	uint16	enable;
+	ipaddr_t 	ipAddr; /* Destination IP Address */
+	ipaddr_t 	ipMask; /* Network mask */
+	ipaddr_t 	nextHop; /* next hop IP address */
+	char	 	ifName[CWMP_NETINTF_NAME_LEN];
+	uint16	flag;
+} cwmp_extRouteTable_t;
+
+
+typedef struct dnsCfgParam_s
+{
+	uint32          enable;  /* 1:used/enabled, 0:disable */
+	uint8		    primary[4];  /* primary dns server ip */
+	uint8		    secondary[4]; /* secondary dns server ip */
+} dnsCfgParam_t;
+
+typedef struct mgmtCfgParam_s
+{
+	uint8	name[16];
+	uint8	password[16];
+	uint8	mailfrom[32];
+	uint8	rcptto[32];
+	uint8	smtpserver[32];
+	uint8	logserver[32];
+	uint32	valid; 		/* valid */
+	uint32	remoteMgmtIp;
+	uint32	remoteMgmtMask; /* reserved */
+	uint16	remoteMgmtPort; /* remote management port */
+	uint8	remoteIcmpEnable; /* remote icmp enable */
+	uint8	mgmt_udp_500;
+} mgmtCfgParam_t;
+
+enum aclGlobalCfgParam_e {
+	ACLGLOBALCFGPARAM_ALLOWALLBUTACL = 0,
+	ACLGLOBALCFGPARAM_DENYALLBUTACL,
+	ACLGLOBALCFGPARAM_L34_DENYALLBUTACL,
+	ACLGLOBALCFGPARAM_ALLOWALLBUTACL_LOG,
+};
+
+typedef struct aclGlobalCfgParam_s
+{
+	uint8		policy;				// 0: allow all except ACL , 1: deny all except ACL
+	uint8		lanPermit;			// for sercomm spec
+	uint8		layer2Permit;            // for Permit Layer2 ACL rule
+	uint8		rsv;				        // for 4 bytes alignment
+} aclGlobalCfgParam_t;
+
+enum aclCfgParam_type_e {
+	ACLCFGPARAM_PROTOCOL_TCP = 0,
+	ACLCFGPARAM_PROTOCOL_UDP,
+	ACLCFGPARAM_PROTOCOL_IP
+};
+
+enum aclCfgParam_direction_e {
+	ACLCFGPARAM_DIRECTION_EGRESS_DEST = 0,
+	ACLCFGPARAM_DIRECTION_INGRESS_DEST,
+	ACLCFGPARAM_DIRECTION_EGRESS_SRC,
+	ACLCFGPARAM_DIRECTION_INGRESS_SRC
+};
+
+typedef struct aclCfgParam_s
+{
+	uint8		ip[4];		// IP address
+
+	uint16		port;		// IP port
+	uint8		enable;		// 0: disable,  1:enable
+	uint8		direction;	// 0: egress dest, 1: ingress dest, 2: egress src, 3: ingress src
+
+	uint8		type;		// 0: TCP, 1: UDP
+	uint8		day;		// bit0:Sunday, bit1:Monday .... bit6:Saturday
+	uint8		start_hour;
+	uint8		start_minute;
+
+	uint8		end_hour;
+	uint8		end_minute;
+	uint8		rsv[2];
+
+} aclCfgParam_t;
+
+
+
+enum serverpCfgParam_e {
+	SERVERPCFGPARAM_PROTOCOL_TCP = 0,
+	SERVERPCFGPARAM_PROTOCOL_UDP,
+};
+
+typedef struct serverpCfgParam_s
+{
+	uint8		ip[4];		// Server IP address
+	uint16		wanPortStart;	// WAN Port
+	uint16		wanPortFinish;	// WAN Port
+	uint16		portStart;		// Server Port
+	uint8       protocol;	// SERVERPCFGPARAM_PROTOCOL_TCP or SERVERPCFGPARAM_PROTOCOL_UDP
+	uint8		enable;		// enable
+
+} serverpCfgParam_t;
+
+enum specialapCfgParam_e {
+	SPECIALACPCFGPARAM_PROTOCOL_TCP = 0,
+	SPECIALACPCFGPARAM_PROTOCOL_UDP,
+	SPECIALACPCFGPARAM_PROTOCOL_BOTH
+};
+
+#define SPECIAL_AP_MAX_IN_RANGE 80
+typedef struct specialapCfgParam_s
+{
+	uint8		name[16];		// name
+	uint32		inType;			// incoming type
+	uint8		inRange[SPECIAL_AP_MAX_IN_RANGE];	// incoming port range
+	uint32		outType;		// outgoing type
+	uint16		outStart;		// outgoing start port
+	uint16		outFinish;		// outgoing finish port
+	uint8		enable;			// enable
+	uint8		rsv[3];			// for 4 bytes alignment
+} specialapCfgParam_t;
+
+
+#define GAMING_MAX_RANGE 80
+typedef struct gamingCfgParam_s
+{
+	uint8		name[32];		// name
+	uint32		ip;
+	uint8		tcpRange[GAMING_MAX_RANGE];
+	uint8		udpRange[GAMING_MAX_RANGE];
+	uint8		enable;			// enable
+	uint8		rsv[3];			// for 4 bytes alignment
+} gamingCfgParam_t;
+
+typedef struct tbldrvCfgParam_s
+{
+	uint8		naptAutoAdd;		// napt auto add
+	uint8       naptAutoDelete;     // napt auto delete
+	uint16		naptIcmpTimeout;	// napt icmp timeout
+	uint16      naptUdpTimeout;
+	uint16		naptTcpLongTimeout;
+	uint16      naptTcpMediumTimeout;
+	uint16		naptTcpFastTimeout;
+} tbldrvCfgParam_t;
+
+typedef struct dmzCfgParam_s	/* DMZ Configuration */
+{
+	uint32		enable; 	/* 0:off 1:on */
+	uint32		enable2;
+	uint32		enable3;
+	uint32		dmzIp;
+	uint32		dmzIp2;
+	uint32		dmzIp3;
+	uint8		l4fwd;	/* forward various L4 protocol to DMZ */
+	uint8		icmpfwd;	/* forward icmp packet to DMZ */
+} dmzCfgParam_t;
+
+typedef struct logCfgParam_s	/* Event Log Configuration */
+{
+	uint32		module;  /* each bit mapping to each module */
+} logCfgParam_t;
+
+typedef struct upnpCfgParam_s	/* UPnP Configuration */
+{
+	uint32		enable; 	/* 0:off 1:on */
+
+} upnpCfgParam_t;
+
+typedef struct snmpCfgParam_s	/* SNMP Daemon Configuration */
+{
+	uint32		enable; 	/* 0:off 1:on */
+
+} snmpCfgParam_t;
+
+typedef struct snmpv2trapCfgParam_S	/*SNMPV2Trap Daemon Configuration*/
+{
+	uint32 enable;
+	char systemDescription[32];
+	char systemId[32];
+	char systemName[32];
+	char systemContact[32];
+	char	systemLocation[32];
+	uint32 systemServInt;
+	char	readCommunity[32];
+	char	writeCommunity[32];
+	uint32	trap_to_ip;
+
+}snmpv2trapCfgParam_t;
+
+typedef struct ddnsCfgParam_s	/* DDNS Configuration */
+{
+	uint32		enable; 	/* 0:off 1:on */
+	uint8		username[32];
+	uint8		password[32];
+	uint8		service[16];
+	uint8		username2[32];
+	uint8		password2[32];
+	uint8		hostname[32];
+	/*updatedd*/
+	uint8 		service3[16];
+	uint8 		username3[32];
+	uint8		password3[32];
+	uint32		wan_ip;
+	uint8 		domain_name[32];
+} ddnsCfgParam_t;
+
+typedef struct urlfilterCfgParam_s	/* URL FILTER Configuration */
+{
+	uint32		enable; 	/* 0:off 1:on */
+	uint8		string[32];
+	uint32		ip_start;
+	uint32		ip_end;
+} urlfilterCfgParam_t;
+
+
+typedef struct urlfilterTrustedUserCfgParam_s	/* URL FILTER Configuration */
+{
+	uint32		trustedIP;
+	uint32		enable;
+} urlfilterTrustedUserCfgParam_t;
+#define URL_FILTER_MAX_TRUSTED_USERS 5
+
+
+typedef struct timeCfgParam_s	/* Time Configuration */
+{
+	uint32		timeZoneIndex;
+	uint8		timeZone[16];
+	uint8		ntpServer1[32];
+	uint8		ntpServer2[32];
+	uint8		ntpServer3[32];
+} timeCfgParam_t;
+
+typedef struct dosCfgParam_s	/* DoS Configuration */
+{
+	uint32		enable;
+	uint32		enableItem;
+	uint8		ignoreLanSideCheck;
+	/* connection count system */
+	/* <---Whole System counter---> */
+	uint16		tcpc;
+	uint16		udpc;
+	uint16		tcpudpc;
+	/* <---Per source IP tracking---> */
+	uint16		perSrc_tcpc;
+	uint16		perSrc_udpc;
+	uint16		perSrc_tcpudpc;
+	/* flood check system */
+	/* <---Whole System counter---> */
+	uint16		syn;
+	uint16		fin;
+	uint16		udp;
+	uint16		icmp;
+	/* <---Per source IP tracking---> */
+	uint16		perSrc_syn;
+	uint16		perSrc_fin;
+	uint16		perSrc_udp;
+	uint16		perSrc_icmp;
+	/* <----Source IP blocking----> */
+	uint16		sipblock_enable;
+	uint16		sipblock_PrisonTime;
+	/* <----Port Scan Level ----> */
+	uint16		portScan_level;
+} dosCfgParam_t;
+
+typedef struct naptCfgParam_s	/* NAPT Option Configuration */
+{
+	uint8		weakNaptEnable;						/* Weak TCP mode */
+	uint8 		looseUdpEnable;	/*Loose UDP mode*/
+	uint8		tcpStaticPortMappingEnable;				/* TCP static port mapping mode */
+	uint8		udpStaticPortMappingEnable;				/* UDP static port mapping mode */
+} naptCfgParam_t;
+
+typedef struct algCfgParam_s	/* ALG Configuration */
+{
+	uint32		algList;
+	ipaddr_t		localIp[32];
+} algCfgParam_t;
+
+
+ typedef enum{
+	CRYPT_NONE = 0,
+	CRYPT_WEP,
+	CRYPT_WPA,
+	CRYPT_WPA2,
+	CRYPT_WPAMIX,
+	CRYPT_MAX
+}WlanCryptType;
+
+typedef enum {
+	CRYPT_SUB_NONE = 0,
+	CRYPT_SUB_WEP_64,
+	CRYPT_SUB_WEP_128,
+	CRYPT_SUB_WPA_TKIP,
+	CRYPT_SUB_WPA_AES,
+	CRYPT_SUB_WPA_TKIPAES,
+	CRYPT_SUB_MAX
+} WlanCryptSubType;
+
+ typedef enum{
+ 	AUTH_NONE=0,
+	AUTH_KEY,
+	AUTH_AUTO,
+	AUTH_8021x,
+	AUTH_MAX
+}WlanAuthType;
+
+enum wlanDataRateModeCfgParam_e {
+	WLAN_DATA_RATE_B=1,
+	WLAN_DATA_RATE_G=2,
+	WLAN_DATA_RATE_BG=3,
+	WLAN_DATA_RATE_A=4,
+	WLAN_DATA_RATE_GN=10,
+	WLAN_DATA_RATE_BGN=11
+};
+
+#ifdef CONFIG_RTL8190
+enum wlanDataRateCfgParam_e {
+	WLAN_DATA_RATE_AUTO = 0,
+	WLAN_DATA_RATE_MCS15,
+	WLAN_DATA_RATE_MCS14,
+	WLAN_DATA_RATE_MCS13,
+	WLAN_DATA_RATE_MCS12,
+	WLAN_DATA_RATE_MCS11,
+	WLAN_DATA_RATE_MCS10,
+	WLAN_DATA_RATE_MCS9,
+	WLAN_DATA_RATE_MCS8,
+	WLAN_DATA_RATE_MCS7,
+	WLAN_DATA_RATE_MCS6,
+	WLAN_DATA_RATE_MCS5,
+	WLAN_DATA_RATE_MCS4,
+	WLAN_DATA_RATE_MCS3,
+	WLAN_DATA_RATE_MCS2,
+	WLAN_DATA_RATE_MCS1,
+	WLAN_DATA_RATE_MCS0,
+	WLAN_DATA_RATE_54M,
+	WLAN_DATA_RATE_48M,
+	WLAN_DATA_RATE_36M,
+	WLAN_DATA_RATE_24M,
+	WLAN_DATA_RATE_18M,
+	WLAN_DATA_RATE_12M,
+	WLAN_DATA_RATE_9M,
+	WLAN_DATA_RATE_6M,
+	WLAN_DATA_RATE_11M,
+	WLAN_DATA_RATE_5_5M,
+	WLAN_DATA_RATE_2M,
+	WLAN_DATA_RATE_1M
+};
+#else
+enum wlanDataRateCfgParam_e {
+	WLAN_DATA_RATE_AUTO = 0,
+	WLAN_DATA_RATE_54M,
+	WLAN_DATA_RATE_48M,
+	WLAN_DATA_RATE_36M,
+	WLAN_DATA_RATE_24M,
+	WLAN_DATA_RATE_18M,
+	WLAN_DATA_RATE_12M,
+	WLAN_DATA_RATE_9M,
+	WLAN_DATA_RATE_6M,
+	WLAN_DATA_RATE_11M,
+	WLAN_DATA_RATE_5_5M,
+	WLAN_DATA_RATE_2M,
+	WLAN_DATA_RATE_1M
+};
+#endif
+
+enum wlanPreambleTypeCfgParam_e {
+	WLAN_PREAMBLE_TYPE_LONG = 0,
+	WLAN_PREAMBLE_TYPE_SHORT = 1,
+};
+
+
+typedef struct wlanCfgParam_s	/* Wireless LAN Configuration */
+{
+	uint8	aliasName[32];
+	uint8	ssid[16];
+
+	uint8	enable;
+	uint8	channel; //0:auto
+	uint8	dataRateMode; //enum  //
+	uint8	highPowerChk;
+
+	uint8 	protection;
+	uint8 	rxChargePump;
+	uint8 	txChargePump;
+	uint8 	regDomain;
+
+	uint16	dataRate; //enum	//
+	uint16	frag;
+	uint16	rts;
+	uint16	beacon;
+
+	uint8	preambleType; //enum
+	uint8	broadcastSSID;
+	uint8	range;
+	uint8 	chipVer;
+
+	uint8	authRadiusPasswd[16];
+
+	uint8	cryptType; //enum
+	uint8	cryptSubType[MAX_WLAN_CRYPT_MIX_TYPE];		/* array: for WPA mix-mode */
+	uint8	authType;
+
+	uint8	wdscryptType; //enum
+	uint8	wdscryptSubType[MAX_WLAN_CRYPT_MIX_TYPE];		/* array: for WPA mix-mode */
+	uint8	wdsauthType;
+
+	uint8	acEnable;
+	uint8	wdsEnable;
+	uint8	wdsCount;
+	uint8	wmmEnable;
+
+	uint8	channelBond;
+	int8	selectedAPIdx; //for 4 bytes alignment
+	uint8	sideBand;
+	uint8	AMPDU;
+
+	uint8	shortGI;
+	uint8	RepeaterEnable;
+	uint8	xxxReserved1; //for 4 bytes alignment
+	uint8	xxxReserved2; //for 4 bytes alignment
+
+	uint16	authRadiusPort;
+	uint8	mode;
+	uint8 	adhoc;
+
+	uint32	authRadiusIp;
+
+	uint8	acMacList[MAX_WLAN_AC][6];
+	uint8	acComment[MAX_WLAN_AC][8];
+
+	uint8	wdsMacList[MAX_WLAN_WDS][6];
+
+	uint8	key[68]; //10 hex for wep64,26 hex for wep128, 64 hex for WPA-PSK
+	uint8	wdskey[68]; //10 hex for wep64,26 hex for wep128, 64 hex for WPA-PSK
+
+	uint8	repeaterssid[16];
+
+#ifdef CONFIG_RTL8185B
+	uint8	vap_ssid[MAX_WLAN_VAP][16];	/* for Multiple BSSID */
+	uint8	vap_cryptType[MAX_WLAN_VAP]; //enum
+	uint8	vap_cryptSubType[MAX_WLAN_VAP][MAX_WLAN_CRYPT_MIX_TYPE];
+	uint8	vap_authType[MAX_WLAN_VAP];	/* for Multiple BSSID */
+
+	uint8	vap_authRadiusPasswd[MAX_WLAN_VAP][16];
+	uint32	vap_authRadiusIp[MAX_WLAN_VAP];
+
+	uint8	vap_key[MAX_WLAN_VAP][68];
+	uint8	enable_vap[MAX_WLAN_VAP];
+
+	uint16	vap_authRadiusPort[MAX_WLAN_VAP];
+
+	uint8	vap_acEnable[MAX_WLAN_VAP];
+	uint8	vap_acMacList[MAX_WLAN_VAP][MAX_WLAN_AC][6];
+	uint8	vap_acComment[MAX_WLAN_VAP][MAX_WLAN_AC][8];
+ #endif
+ 	//uint8 	reserved[29];
+} wlanCfgParam_t;
+
+typedef struct wlaninterCfgParam_s	/* Wireless LAN Configuration */
+{
+	uint8		 totalWlanCards;
+	SS_STATUS_Tp pStatus1;
+} wlaninterCfgParam_t;
+
+typedef struct udpblockCfgParam_s	/* UDP Blocking Configuration */
+{
+	uint32		enable;
+	uint32		size;
+} udpblockCfgParam_t;
+
+enum routingInterfaceCfgParam_e {
+	ROUTING_INTERFACE_NONE = 0,
+	ROUTING_INTERFACE_LAN,
+	ROUTING_INTERFACE_WAN
+};
+
+typedef struct routingCfgParam_s	/* Routing Table Configuration */
+{
+	uint32		route;
+	uint32		mask;
+	uint32		gateway;
+	uint8		interface;
+} routingCfgParam_t;
+
+typedef struct qosCfgParam_s /* QoS Configuration */
+{
+	uint32		qosType;
+	uint8		RateRange;
+	union {
+		struct {
+			uint16	port;
+			uint8	isHigh;
+			uint8	enableFlowCtrl;
+			uint32	inRL;
+			uint32	outRL;
+		} port_based;
+		struct {
+			uint16	portNumber;
+			uint16	isHigh;
+		} policy_based;
+	} un;
+} qosCfgParam_t;
+
+
+typedef struct ratioAlgQosEntry_s	/* Ratio based ALG QoS entry */
+{
+	uint32	queueID;	/* 1 ~ max no. of queue */
+	uint8	isHigh;		/* 0: Low 1: High */
+	uint8	ratio;		/* percentage */
+	uint8	enable;		/* 0: disable, 1: enable */
+	uint8 	rsv;			/* reserve for 32bits-alignment */
+} ratioAlgQosEntry_t;
+
+typedef struct ratioQosUpstreamCfgParam_s /* Ratio based QoS: Upstream total bandwidth Configuration */
+{
+	uint32	maxRate;
+	uint8	maxRateUnit;		/* 0: Mbps, 1: Kbps */
+	uint8	remainingRatio_h;	/* remaining ratio in high queue */
+	uint8	remainingRatio_l;	/* remaining ratio in low queue */
+	uint8	rsv;				/* reserve for 32bits-alignment */
+	ratioAlgQosEntry_t algQosEntry[3];
+
+} ratioQosUpstreamCfgParam_t;
+
+typedef struct ratioQosEntry_s	/* Ratio based QoS entry */
+{
+	uint32	queueID;	/* 1 ~ max no. of queue */
+	uint32	ip;
+	uint32	ipMask;
+	uint16	s_port;
+	uint16	e_port;
+	uint8	enable;		/* 0: disable, 1: enable */
+	uint8	isSrc;		/* 0: dst, 1: src */
+	uint8	protoType;	/* 0: TCP, 1: UDP, 2: IP */
+	uint8	isHigh;		/* 0: Low 1: High */
+	uint8	ratio;		/* percentage */
+	uint8	mark;		/* 0: DSCP marking disabled,  1: enabled */
+	uint16	dscp;		/* DSCP value */
+} ratioQosEntry_t;
+
+typedef struct ratioQosCfgParam_s	/* Ratio based QoS Configuration */
+{
+	uint8 enable;							/* 0: disable, 1: enable */
+	ratioQosUpstreamCfgParam_t upInfo;
+	ratioQosEntry_t entry[MAX_RATIO_QOS];
+} ratioQosCfgParam_t;
+
+typedef struct pbnatCfgParam_s /* Protocol-Based NAT Configuration */
+{
+	uint8 protocol;
+	uint8 enabled;
+	ipaddr_t IntIp;
+} pbnatCfgParam_t;
+
+#define NULL_QOS						0x00
+#define PORT_BASED_QOS				0x01
+#define POLICY_BASED_QOS				0x02
+#define ENABLE_QOS					0x04
+
+
+typedef struct rateLimitEntry_s
+{
+	uint8		enable;		/* 0: disable, 1: enable */
+	uint32		ip;
+	uint32		ipMask;
+	uint16		s_port, e_port;
+	uint8		protoType;	/* 0: TCP, 1: UDP, 2: IP */
+	uint8		isByteCount;	/* 0: Packet Count, 1: Byte Count */
+	uint32		rate;
+	uint8		rateUnit;		/* 0: Kbps, 1: Mbps */
+	uint32		maxRate;		/* Tolerance */
+	uint8		maxRateUnit;	/* 0: Kbps, 1: Mbps */
+	uint8		isDropLog;	/* 1: Drop & Log, 0: Drop */
+	uint8		isSrcIp;
+} rateLimitEntry_t;
+
+
+typedef struct rateLimitCfgParam_s
+{
+	uint32		enable;		/* 0: disable, 1: enable */
+	rateLimitEntry_t entry[16];
+} rateLimitCfgParam_t;
+
+typedef struct modeCfgParam_s
+{
+	uint32		Mode;
+} modeCfgParam_t;
+
+
+typedef struct ripCfgParam_s
+{
+
+	uint8		send_eth0;
+	uint8		rcv_eth0;
+	uint8		auth_eth0;
+	char			pass_eth0[16];
+
+	char			pass_eth1[16];
+	uint8		send_eth1;
+	uint8		rcv_eth1;
+	uint8		auth_eth1;
+	uint8		update_tr;
+	uint8		timeout_tr;
+	uint8		garbage_tr;
+	uint16		resv;
+} ripCfgParam_t;
+
+
+typedef struct pseudoVlanCfgParam_s
+{
+	uint8				enable;
+	uint16				portVid[9];
+	uint8 				rsv[1];
+} pseudoVlanCfgParam_t;
+
+typedef struct passthruCfgParam_s	/* Passthru Configuration */
+{
+	uint8	enabledPppoe;
+	uint8	enabledDropUnknownPppoePADT;
+	uint8	enabledIpv6;
+	uint8	enabledIpx;
+	uint8	enabledNetbios;
+} passthruCfgParam_t;
+
+typedef struct ipMulticastCfgParam_s	/* IP Multicast Configuration */
+{
+	uint8	enabledIpMulticast;
+#if 1
+	 /*865xc igmp snooping,2007-03-05*/
+	 /*for igmp proxy to snooping, by qjj, 2006-11-28*/
+	uint8	ipMulticastMode;/*0: igmp proxy; 1: igmp snooping*/
+#endif
+} ipMulticastCfgParam_t;
+
+typedef struct ipsecGlobalCfgParam_s	/* IP Multicast Configuration */
+{
+	uint8	enableNatTraversal;
+} ipsecGlobalCfgParam_t;
+
+
+
+typedef struct ipsecConfigCfgParam_s	/* Ratio based QoS Configuration */
+{
+	uint8 enable;							/* 0: disable, 1: enable */
+	uint8 protocol;							/* 0: ESP, 1: AH*/
+	uint8 encryption;
+	uint8 authentication;
+	uint8 keymanagement;					/* 0:automatic,  1:manual */
+	uint8 ipcompress;						/* 0: no,  1: yes */
+	uint8 pfs;
+	uint8 dpd;								/* 0: no,  1: yes */
+
+	uint32 localnet;
+	uint32 remotegw;
+	uint32 remotenet;
+	uint32 ipsec_keylife;
+	uint32 isakmp_keylife;
+	uint8  secrets[30];
+	uint8 ipsec_enckey[80];
+	uint8 ipsec_authkey[60];
+
+} ipsecConfigCfgParam_t;
+
+typedef struct domainBlockCfgParam_s
+{
+	char domain[MAX_ALLOW_DOMAINNAME_LEN];
+	ipaddr_t sip;
+	ipaddr_t smask;
+	uint8 enable;
+} domainBlockCfgParam_t;
+
+typedef struct settingMgmtCfgParam_s
+{
+   int16   upload;
+   uint8 curversion[29];
+   uint8 newversion[29];
+}settingMgmtCfgParam_t;
+
+typedef struct romeCfgParam_s
+{
+	vlanCfgParam_t      vlanCfgParam[VLAN_LOAD_COUNT];
+	ifCfgParam_t        ifCfgParam[MAX_IP_INTERFACE];
+	routeCfgParam_t     routeCfgParam[MAX_ROUTE];
+	arpCfgParam_t       arpCfgParam[MAX_STATIC_ARP];
+	natCfgParam_t       natCfgParam;
+	pppoeCfgParam_t     pppoeCfgParam[MAX_PPPOE_SESSION];
+	dhcpsCfgParam_t     dhcpsCfgParam;
+	dhcpcCfgParam_t     dhcpcCfgParam;
+	dnsCfgParam_t       dnsCfgParam;
+	mgmtCfgParam_t      mgmtCfgParam[MAX_MGMT_USER];
+	aclGlobalCfgParam_t	aclGlobalCfgParam;
+	aclCfgParam_t       aclCfgParam[MAX_PPPOE_SESSION][MAX_ACL];
+	serverpCfgParam_t   serverpCfgParam[MAX_PPPOE_SESSION][MAX_SERVER_PORT];
+	specialapCfgParam_t specialapCfgParam[MAX_PPPOE_SESSION][MAX_SPECIAL_AP];
+	gamingCfgParam_t gamingCfgParam[MAX_PPPOE_SESSION][MAX_GAMING];
+    dmzCfgParam_t       dmzCfgParam[MAX_PPPOE_SESSION];
+	logCfgParam_t       logCfgParam[MAX_PPPOE_SESSION];
+    upnpCfgParam_t      upnpCfgParam;
+    snmpCfgParam_t      snmpCfgParam;
+	snmpv2trapCfgParam_t snmpv2trapCfgParam;
+    ddnsCfgParam_t      ddnsCfgParam;
+	tbldrvCfgParam_t    tbldrvCfgParam;
+	urlfilterCfgParam_t	urlfilterCfgParam[MAX_PPPOE_SESSION][MAX_URL_FILTER];
+	dosCfgParam_t		dosCfgParam[MAX_PPPOE_SESSION];
+	naptCfgParam_t		naptCfgParam;
+	timeCfgParam_t		timeCfgParam;
+	algCfgParam_t		algCfgParam[MAX_PPPOE_SESSION];
+	wlanCfgParam_t		wlanCfgParam[MAX_WLAN_CARDS];
+	wlaninterCfgParam_t wlaninterCfgParam;
+	udpblockCfgParam_t	udpblockCfgParam[MAX_PPPOE_SESSION];
+	routingCfgParam_t	routingCfgParam[MAX_ROUTING];
+	pptpCfgParam_t		pptpCfgParam;
+	l2tpCfgParam_t		l2tpCfgParam;
+	qosCfgParam_t		qosCfgParam[MAX_QOS];
+	rateLimitCfgParam_t	rateLimitCfgParam;
+	ratioQosCfgParam_t	ratioQosCfgParam;
+	pbnatCfgParam_t		pbnatCfgParam[MAX_PPPOE_SESSION][MAX_PBNAT];
+	pseudoVlanCfgParam_t pseudoVlanCfgParam;
+	passthruCfgParam_t	passthruCfgParam;
+	ipMulticastCfgParam_t	ipMulticastCfgParam;
+	modeCfgParam_t		modeCfgParam;
+	ripCfgParam_t			ripCfgParam;
+	uint8				semaphore[MAX_USER_SEMAPHORE];	/* used by user level */
+//#ifdef CONFIG_KU_KLIPS
+	ipsecConfigCfgParam_t   ipsecConfigCfgParam[3];
+	ipsecGlobalCfgParam_t   ipsecGlobalCfgParam;
+//#endif
+	domainBlockCfgParam_t	domainBlockCfgParam[MAX_DOMAIN_BLOCKING];
+	pptpServerCfgParam_t   pptpServerCfgParam;
+	urlfilterTrustedUserCfgParam_t urlfilterTrustedUserCfgParam[URL_FILTER_MAX_TRUSTED_USERS];
+	natMappingCfgParam_t       natMappingCfgParam[MAX_NAT_MAPPING];
+
+	addrIPv6_t		  addrIPv6Param;
+	tunnel6in4_t		  tunnel6in4Param;
+	tunnel6in4array_t		tunnel6in4arrayParam;
+	tunnel6to4_t			tunnel6to4Param;
+	routeIPv6_t		routeIPv6Param;
+	routeTableIPv6_t 	routeTableIPv6Param;
+	radvdCfgParam_t   radvdCfgParam;
+	dnsv6CfgParam_t   dnsv6CfgParam;
+	dhcpv6sCfgParam_t  dhcpv6sCfgParam;
+	dhcpv6cCfgParam_t  dhcpv6cCfgParam;
+	settingMgmtCfgParam_t  settingMgmtCfgParam;
+
+	tr069CfgParam_t tr069CfgParam;
+	cwmpFlag_t cwmpFlagCfgParam;
+	cwmpInform_t cwmpInformCfgParam;
+	cwmpACSAccountCfgParam_t cwmpACSAccountCfgParam;
+	cwmpConreqAccountCfgParam_t cwmpConreqAccountCfgParam;
+	cwmpDeviceInfo_t cwmpDevinfoCfgParam;
+	cwmpInformTime_t cwmpInformTimeCfgParam;
+	cwmpParam_t cwmpParamCfgParam;
+	cwmpDHCPServ_t cwmpDHCPServerConfCfgParam;
+	cwmpNotifyConfig_t cwmpNotifyConfigCfgParam[CWMP_MAX_NOTIFY_CONFIG_INFO];
+	cwmpServerpCfgParam_t cwmpserverpCfgParam[MAX_CWMP_PORTMAPPING];
+	cwmp_extRouteTable_t cwmpextRouteTableCfgParam[CWMP_L3ENTRY_LEN];
+} romeCfgParam_t;
+
+
+
+#endif /* _BOARD_H_ */
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/Makefile b/drivers/soc/realtek/rtd129x/hw_nat/common/Makefile
new file mode 100644
index 00000000..9f0738f
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/Makefile
@@ -0,0 +1,60 @@
+#
+# Makefile for the Tulip ethernet driver
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definitions are now in the main makefile...
+
+#Add mips16 Support
+
+DIR_RTLASIC = $(srctree)/drivers/soc/realtek/rtd129x/hw_nat/
+
+ifeq ($(CONFIG_RTK_IPTABLES_FAST_PATH),m)
+EXTRA_CFLAGS += -DCONFIG_FAST_PATH_MODULE
+endif
+ifdef CONFIG_RTL865X_KERNEL_MIPS16_LAYERDRIVER
+	CFLAGS_rtl_utils.o		= -mips16
+	CFLAGS_rtl865xC_tblDrvPatch.o	= -mips16
+	CFLAGS_rtl865x_vlan.o		= -mips16
+	CFLAGS_rtl865x_netif.o		= -mips16
+	CFLAGS_rtl865x_eventMgr.o	= -mips16
+endif
+	ifeq ($(CONFIG_RTL_LAYERED_ASIC_DRIVER),y)
+		obj-y := rtl865x_vlan.o rtl865x_netif.o rtl865x_eventMgr.o
+	else
+		obj-y := rtl865xC_tblDrvPatch.o rtl865x_vlan.o rtl865x_netif.o rtl865x_eventMgr.o
+	endif
+
+ifeq ($(CONFIG_RTL_PROC_DEBUG), y)
+	obj-y += rtl_utils.o
+endif
+
+ifeq ($(CONFIG_RTL_819XD), y)
+	obj-y += smi.o gpio.o
+endif
+
+ifeq ($(CONFIG_RTL_8197F), y)
+	ifeq ($(CONFIG_RTL_8367R_SUPPORT), y)
+		obj-y += smi.o gpio.o
+	endif
+endif
+
+ifeq ($(CONFIG_RTL_8198C_8367RB), y)
+	obj-y += smi.o gpio.o
+endif
+
+EXTRA_CFLAGS += -O1 -DRTL_TBLDRV -D__linux__ -DRTL865X_OVER_KERNEL -DRTL865X_OVER_LINUX -Werror
+EXTRA_CFLAGS += -I$(DIR_RTLASIC)
+
+ifeq ($(CONFIG_RTL865X_MODULE_ROMEDRV),y)
+	EXTRA_CFLAGS += -D__KERNEL__
+	EXTRA_CFLAGS += -G 0
+	EXTRA_CFLAGS += -DMODULE
+	EXTRA_CFLAGS += -mlong-calls
+	EXTRA_CFLAGS += -DEXPORT_SYMTAB
+	EXTRA_CFLAGS += -DCONFIG_RTL865X_MODULE_INTERNAL
+endif
+
+EXTRA_AFLAGS += $(EXTRA_CFLAGS)
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/gpio.c b/drivers/soc/realtek/rtd129x/hw_nat/common/gpio.c
new file mode 100644
index 00000000..965ab3d
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/gpio.c
@@ -0,0 +1,451 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "../AsicDriver/asicRegs.h"
+#include "gpio.h"
+
+#define RTL_GPIO_PABDIR         PABCD_DIR
+#define RTL_GPIO_PABDATA        PABCD_DAT
+#define RTL_GPIO_PABCNR         PABCD_CNR
+
+/*
+ * 0 -- less debug information
+ * 5 -- more debug information
+ */
+#define _GPIO_DEBUG_ 0
+
+enum GPIO_FUNC
+{
+	GPIO_FUNC_DEDICATE,
+	GPIO_FUNC_DEDICATE_PERIPHERAL_TYPE,
+	GPIO_FUNC_DIRECTION,
+	GPIO_FUNC_DATA,
+	GPIO_FUNC_INTERRUPT_STATUS,
+	GPIO_FUNC_INTERRUPT_ENABLE,
+	GPIO_FUNC_MAX,
+};
+#define PABCCNR PABCD_CNR
+#define PDEPTCR PEFGH_CNR
+#define PFGHICNR PEFGH_CNR
+
+static uint32 regGpioControl[] =
+{
+	PABCD_CNR, /* Port A */
+	PABCD_CNR, /* Port B */
+	PABCD_CNR, /* Port C */
+	PABCD_CNR, /* Port D */
+	PEFGH_CNR, /* Port E */
+	PEFGH_CNR,/* Port F */
+	PEFGH_CNR,/* Port G */
+	PEFGH_CNR,/* Port H */
+};
+
+static uint32 bitStartGpioControl[] =
+{
+	0, /* Port A */
+	8, /* Port B */
+	16,  /* Port C */
+	24, /* Port D */
+	0, /* Port E */
+	8, /* Port F */
+	16, /* Port G */
+	24,  /* Port H */
+	0,  /* Port I */
+};
+
+static uint32 regGpioDedicatePeripheralType[] =
+{
+	PABCD_PTYPE, /* Port A */
+	PABCD_PTYPE, /* Port B */
+	PABCD_PTYPE, /* Port C */
+	PABCD_PTYPE,  /* Port D */
+	PEFGH_PTYPE,  /* Port E */
+	PEFGH_PTYPE,        /* Port F */
+	PEFGH_PTYPE,        /* Port G */
+	PEFGH_PTYPE,        /* Port H */
+	0,        /* Port I */
+};
+
+static uint32 bitStartGpioDedicatePeripheralType[] =
+{
+	0, /* Port A */
+	8, /* Port B */
+	16,  /* Port C */
+	24, /* Port D */
+	0, /* Port E */
+	8,  /* Port F */
+	16,  /* Port G */
+	24,  /* Port H */
+	0,  /* Port I */
+};
+
+static uint32 regGpioDirection[] =
+{
+	PABCD_DIR, /* Port A */
+	PABCD_DIR, /* Port B */
+	PABCD_DIR, /* Port C */
+	PABCD_DIR,  /* Port D */
+	PEFGH_DIR,  /* Port E */
+	PEFGH_DIR,/* Port F */
+	PEFGH_DIR,/* Port G */
+	PEFGH_DIR,/* Port H */
+	0,/* Port I */
+};
+
+static uint32 bitStartGpioDirection[] =
+{
+	0, /* Port A */
+	8, /* Port B */
+	16,  /* Port C */
+	24, /* Port D */
+	0, /* Port E */
+	8, /* Port F */
+	16, /* Port G */
+	24,  /* Port H */
+	0,  /* Port I */
+};
+
+static uint32 regGpioData[] =
+{
+	PABCD_DAT, /* Port A */
+	PABCD_DAT, /* Port B */
+	PABCD_DAT, /* Port C */
+	PABCD_DAT,  /* Port D */
+	PEFGH_DAT,  /* Port E */
+	PEFGH_DAT,/* Port F */
+	PEFGH_DAT,/* Port G */
+	PEFGH_DAT,/* Port H */
+	0,/* Port I */
+};
+
+static uint32 bitStartGpioData[] =
+{
+	0, /* Port A */
+	8, /* Port B */
+	16,  /* Port C */
+	24, /* Port D */
+	0, /* Port E */
+	8, /* Port F */
+	16, /* Port G */
+	24,  /* Port H */
+	0,  /* Port I */
+};
+
+static uint32 regGpioInterruptStatus[] =
+{
+	PABCD_ISR, /* Port A */
+	PABCD_ISR, /* Port B */
+	PABCD_ISR, /* Port C */
+	PABCD_ISR,  /* Port D */
+	PEFGH_ISR,  /* Port E */
+	PEFGH_ISR,/* Port F */
+	PEFGH_ISR,/* Port G */
+	PEFGH_ISR,/* Port H */
+	0,/* Port I */
+};
+
+static uint32 bitStartGpioInterruptStatus[] =
+{
+	0, /* Port A */
+	8, /* Port B */
+	16,  /* Port C */
+	24, /* Port D */
+	0, /* Port E */
+	8, /* Port F */
+	16, /* Port G */
+	24,  /* Port H */
+	0,  /* Port I */
+};
+
+static uint32 regGpioInterruptEnable[] =
+{
+	PAB_IMR,/* Port A */
+	PAB_IMR,/* Port B */
+	PCD_IMR, /* Port C */
+	PCD_IMR,/* Port D */
+	PEF_IMR,/* Port E */
+	PEF_IMR,/* Port F */
+	PGH_IMR,/* Port G */
+	PGH_IMR,/* Port H */
+	0,/* Port I */
+};
+
+static uint32 bitStartGpioInterruptEnable[] =
+{
+	16, /* Port A */
+	0,  /* Port B */
+	16, /* Port C */
+	16, /* Port D */
+	0,  /* Port E */
+	16, /* Port F */
+	0,  /* Port G */
+	16, /* Port H */
+	0,  /* Port I */
+};
+
+#undef rtlglue_printf
+#ifdef CONFIG_PRINTK
+	#define rtlglue_printf	printk
+#else
+	#define rtlglue_printf	panic_printk
+#endif
+
+/*
+@func int32 | _getGpio | abstract GPIO registers
+@parm enum GPIO_FUNC | func | control/data/interrupt register
+@parm enum GPIO_PORT | port | GPIO port
+@parm uint32 | pin | pin number
+@rvalue uint32 | value
+@comm
+This function is for internal use only. You don't need to care what register address of GPIO is.
+This function abstracts these information.
+*/
+static uint32 _getGpio( enum GPIO_FUNC func, enum GPIO_PORT port, uint32 pin )
+{
+
+	switch( func )
+	{
+		case GPIO_FUNC_DEDICATE:
+			if ( REG32(regGpioControl[port]) & ( (uint32)1 << (pin+bitStartGpioControl[port]) ) )
+				return 1;
+			else
+				return 0;
+			break;
+
+		case GPIO_FUNC_DEDICATE_PERIPHERAL_TYPE:
+
+			if ( REG32(regGpioDedicatePeripheralType[port]) & ( (uint32)1 << (pin+bitStartGpioDedicatePeripheralType[port]) ) )
+				return 1;
+			else
+				return 0;
+			break;
+
+		case GPIO_FUNC_DIRECTION:
+			if ( REG32(regGpioDirection[port]) & ( (uint32)1 << (pin+bitStartGpioDirection[port]) ) )
+				return 1;
+			else
+				return 0;
+			break;
+
+		case GPIO_FUNC_DATA:
+			if ( REG32(regGpioData[port]) & ( (uint32)1 << (pin+bitStartGpioData[port]) ) )
+				return 1;
+			else
+				return 0;
+			break;
+
+		case GPIO_FUNC_INTERRUPT_ENABLE:
+			return ( REG32(regGpioInterruptEnable[port]) >> (pin*2+bitStartGpioInterruptEnable[port]) ) & (uint32)0x3;
+			break;
+
+		case GPIO_FUNC_INTERRUPT_STATUS:
+			if ( REG32(regGpioInterruptStatus[port]) & ( (uint32)1 << (pin+bitStartGpioInterruptStatus[port]) ) )
+				return 1;
+			else
+				return 0;
+			break;
+
+		case GPIO_FUNC_MAX:
+			break;
+	}
+	return 0xffffffff;
+}
+
+
+/*
+@func int32 | _setGpio | abstract GPIO registers
+@parm enum GPIO_FUNC | func | control/data/interrupt register
+@parm enum GPIO_PORT | port | GPIO port
+@parm uint32 | pin | pin number
+@parm uint32 | data | value
+@rvalue NONE
+@comm
+This function is for internal use only. You don't need to care what register address of GPIO is.
+This function abstracts these information.
+*/
+static void _setGpio( enum GPIO_FUNC func, enum GPIO_PORT port, uint32 pin, uint32 data )
+{
+
+#if _GPIO_DEBUG_ >= 4
+	rtlglue_printf("[%s():%d] func=%d port=%d pin=%d data=%d\n", __FUNCTION__, __LINE__, func, port, pin, data );
+#endif
+
+	switch( func )
+	{
+		case GPIO_FUNC_DEDICATE:
+#if _GPIO_DEBUG_ >= 5
+			rtlglue_printf("[%s():%d] regGpioControl[port]=0x%08x  bitStartGpioControl[port]=%d\n", __FUNCTION__, __LINE__, regGpioControl[port], bitStartGpioControl[port] );
+#endif
+			if ( data )
+				REG32(regGpioControl[port]) |= (uint32)1 << (pin+bitStartGpioControl[port]);
+			else
+				REG32(regGpioControl[port]) &= ~((uint32)1 << (pin+bitStartGpioControl[port]));
+			break;
+
+		case GPIO_FUNC_DEDICATE_PERIPHERAL_TYPE:
+#if _GPIO_DEBUG_ >= 5
+			rtlglue_printf("[%s():%d] regGpioDedicatePeripheralType[port]=0x%08x  bitStartGpioDedicatePeripheralType[port]=%d\n", __FUNCTION__, __LINE__, regGpioDedicatePeripheralType[port], bitStartGpioDedicatePeripheralType[port] );
+#endif
+			if ( data )
+				REG32(regGpioDedicatePeripheralType[port]) |= (uint32)1 << (pin+bitStartGpioDedicatePeripheralType[port]);
+			else
+				REG32(regGpioDedicatePeripheralType[port]) &= ~((uint32)1 << (pin+bitStartGpioDedicatePeripheralType[port]));
+			break;
+
+		case GPIO_FUNC_DIRECTION:
+#if _GPIO_DEBUG_ >= 5
+			rtlglue_printf("[%s():%d] regGpioDirection[port]=0x%08x  bitStartGpioDirection[port]=%d\n", __FUNCTION__, __LINE__, regGpioDirection[port], bitStartGpioDirection[port] );
+#endif
+			if ( data )
+				REG32(regGpioDirection[port]) |= (uint32)1 << (pin+bitStartGpioDirection[port]);
+			else
+				REG32(regGpioDirection[port]) &= ~((uint32)1 << (pin+bitStartGpioDirection[port]));
+			break;
+
+		case GPIO_FUNC_DATA:
+#if _GPIO_DEBUG_ >= 5
+			rtlglue_printf("[%s():%d] regGpioData[port]=0x%08x  bitStartGpioData[port]=%d\n", __FUNCTION__, __LINE__, regGpioData[port], bitStartGpioData[port] );
+#endif
+			if ( data )
+				REG32(regGpioData[port]) |= (uint32)1 << (pin+bitStartGpioData[port]);
+			else
+				REG32(regGpioData[port]) &= ~((uint32)1 << (pin+bitStartGpioData[port]));
+			break;
+
+		case GPIO_FUNC_INTERRUPT_ENABLE:
+#if _GPIO_DEBUG_ >= 5
+			rtlglue_printf("[%s():%d] regGpioInterruptEnable[port]=0x%08x  bitStartGpioInterruptEnable[port]=%d\n", __FUNCTION__, __LINE__, regGpioInterruptEnable[port], bitStartGpioInterruptEnable[port] );
+#endif
+			REG32(regGpioInterruptEnable[port]) &= ~((uint32)0x3 << (pin*2+bitStartGpioInterruptEnable[port]));
+			REG32(regGpioInterruptEnable[port]) |= (uint32)data << (pin*2+bitStartGpioInterruptEnable[port]);
+			break;
+
+		case GPIO_FUNC_INTERRUPT_STATUS:
+#if _GPIO_DEBUG_ >= 5
+			rtlglue_printf("[%s():%d] regGpioInterruptStatus[port]=0x%08x  bitStartGpioInterruptStatus[port]=%d\n", __FUNCTION__, __LINE__, regGpioInterruptStatus[port], bitStartGpioInterruptStatus[port] );
+#endif
+			if ( data )
+				REG32(regGpioInterruptStatus[port]) |= (uint32)1 << (pin+bitStartGpioInterruptStatus[port]);
+			else
+				REG32(regGpioInterruptStatus[port]) &= ~((uint32)1 << (pin+bitStartGpioInterruptStatus[port]));
+			break;
+
+		case GPIO_FUNC_MAX:
+			break;
+	}
+}
+
+
+/*
+@func int32 | _rtl865x_initGpioPin | Initiate a specifed GPIO port.
+@parm uint32 | gpioId | The GPIO port that will be configured
+@parm enum GPIO_PERIPHERAL | dedicate | Dedicated peripheral type
+@parm enum GPIO_DIRECTION | direction | Data direction, in or out
+@parm enum GPIO_INTERRUPT_TYPE | interruptEnable | Interrupt mode
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed. Parameter error.
+@comm
+This function is used to initialize GPIO port.
+*/
+int32 _rtl865x_initGpioPin( gpioID gpioId,
+	enum GPIO_PERIPHERAL dedicate,
+	enum GPIO_DIRECTION direction,
+	enum GPIO_INTERRUPT_TYPE interruptEnable )
+{
+	uint32 port = GPIO_PORT( gpioId );
+	uint32 pin = GPIO_PIN( gpioId );
+
+	if ( port >= GPIO_PORT_MAX ) return FAILED;
+	if ( pin >= 8 ) return FAILED;
+
+	switch( dedicate )
+	{
+		case GPIO_PERI_GPIO:
+			_setGpio( GPIO_FUNC_DEDICATE, port, pin, 0 );
+
+			//if ( port == GPIO_PORT_D || port == GPIO_PORT_E ) /*change Mii interface IO as GPIO pins*/
+			//	REG32( MISCCR ) |= P5_LINK_PCMCIA << P5_LINK_OFFSET;
+
+			break;
+		case GPIO_PERI_TYPE0:
+			if( port > GPIO_PORT_E ) return FAILED;
+			_setGpio( GPIO_FUNC_DEDICATE, port, pin, 1 );
+			_setGpio( GPIO_FUNC_DEDICATE_PERIPHERAL_TYPE, port, pin, 0 );
+			break;
+		case GPIO_PERI_TYPE1:
+			if( port > GPIO_PORT_E ) return FAILED;
+			_setGpio( GPIO_FUNC_DEDICATE, port, pin, 1 );
+			_setGpio( GPIO_FUNC_DEDICATE_PERIPHERAL_TYPE, port, pin, 1 );
+			break;
+	}
+
+	_setGpio( GPIO_FUNC_DIRECTION, port, pin, direction );
+
+	_setGpio( GPIO_FUNC_INTERRUPT_ENABLE, port, pin, interruptEnable );
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | _rtl865x_getGpioDataBit | Get the bit value of a specified GPIO ID.
+@parm uint32 | gpioId | GPIO ID
+@parm uint32* | data | Pointer to store return value
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed. Parameter error.
+@comm
+*/
+int32 _rtl865x_getGpioDataBit( uint32 gpioId, uint32* pData )
+{
+	uint32 port = GPIO_PORT( gpioId );
+	uint32 pin = GPIO_PIN( gpioId );
+
+	if ( port >= GPIO_PORT_MAX ) return FAILED;
+	if ( pin >= 8 ) return FAILED;
+	if ( pData == NULL ) return FAILED;
+
+	*pData = _getGpio( GPIO_FUNC_DATA, port, pin );
+#if _GPIO_DEBUG_ >= 3
+	rtlglue_printf("[%s():%d] (port=%d,pin=%d)=%d\n", __FUNCTION__, __LINE__, port, pin, *pData );
+#endif
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32 | _rtl865x_setGpioDataBit | Set the bit value of a specified GPIO ID.
+@parm uint32 | gpioId | GPIO ID
+@parm uint32 | data | Data to write
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed. Parameter error.
+@comm
+*/
+int32 _rtl865x_setGpioDataBit( uint32 gpioId, uint32 data )
+{
+	uint32 port = GPIO_PORT( gpioId );
+	uint32 pin = GPIO_PIN( gpioId );
+
+	if ( port >= GPIO_PORT_MAX ) return FAILED;
+	if ( pin >= 8 ) return FAILED;
+#if 0
+	if ( _getGpio( GPIO_FUNC_DIRECTION, port, pin ) == GPIO_DIR_IN ) return FAILED; /* read only */
+#endif
+
+#if _GPIO_DEBUG_ >= 3
+	rtlglue_printf("[%s():%d] (port=%d,pin=%d)=%d\n", __FUNCTION__, __LINE__, port, pin, data );
+#endif
+	_setGpio( GPIO_FUNC_DATA, port, pin, data );
+
+	return SUCCESS;
+}
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/gpio.h b/drivers/soc/realtek/rtd129x/hw_nat/common/gpio.h
new file mode 100644
index 00000000..d22ca51
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/gpio.h
@@ -0,0 +1,109 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* Program : GPIO Header File
+* Abstract :
+* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)
+* $Id: gpio.h,v 1.1 2009/03/23 11:54:49 jasonwang Exp $
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef __GPIO_H__
+#define __GPIO_H__
+
+#define PECNR	 (PDEPTCR+1)
+#define PEDIR (PDEDIR+1)
+#define PEDATA (PDEDAT+1)
+
+/*
+			9001 	8651  dir
+----------------------------------
+	RESET			D5		O    (slic2)
+	RESET	A0		E7		O    (slic1)
+	DI		B2		E6		I
+	DO		B1		E5		O
+	CLK		B3		E4		O
+	CS		B0		E3		O
+	INT		A4		E2		I    (slic2)
+	INT				E1		I    (slic1)
+	RELAY			E0		O
+
+//CS is active low
+#define si3120_RS	0x80
+#define si3210_INT	0x04
+#define si3210_DI	0x40
+#define si3210_DO	0x20
+#define si3210_CLK	0x10
+#define si3210_CS	0x08
+*/
+
+/* define GPIO port */
+enum GPIO_PORT
+{
+	GPIO_PORT_A = 0,
+	GPIO_PORT_B,
+	GPIO_PORT_C,
+	GPIO_PORT_D,
+	GPIO_PORT_E,
+	GPIO_PORT_F,
+	GPIO_PORT_G,
+	GPIO_PORT_H,
+	GPIO_PORT_I,
+	GPIO_PORT_MAX,
+};
+
+/* define GPIO dedicate peripheral pin */
+enum GPIO_PERIPHERAL
+{
+	GPIO_PERI_GPIO = 0,
+	GPIO_PERI_TYPE0 = 0x2,
+	GPIO_PERI_TYPE1 = 0x3,
+};
+
+
+/* define GPIO direction */
+enum GPIO_DIRECTION
+{
+	GPIO_DIR_IN = 0,
+	GPIO_DIR_OUT,
+};
+
+/* define GPIO Interrupt Type */
+enum GPIO_INTERRUPT_TYPE
+{
+	GPIO_INT_DISABLE = 0,
+	GPIO_INT_FALLING_EDGE,
+	GPIO_INT_RISING_EDGE,
+	GPIO_INT_BOTH_EDGE,
+};
+
+typedef uint32 gpioID;
+
+
+/*
+ * Every pin of GPIO port can be mapped to a unique ID.
+ * All the access to a GPIO pin must use the ID.
+ * This macro is used to map the port and pin into the ID.
+ */
+#define GPIO_ID(port,pin) ((uint32)port<<8|(uint32)pin)
+
+/* This is reversed macro. */
+#define GPIO_PORT(id) (id>>8)
+#define GPIO_PIN(id) (id&0xff)
+
+
+
+int32 _rtl865x_initGpioPin(gpioID gpioId,
+				enum GPIO_PERIPHERAL dedicate,
+				enum GPIO_DIRECTION direction,
+				enum GPIO_INTERRUPT_TYPE interruptEnable );
+int32 _rtl865x_getGpioDataBit( uint32 gpioId, uint32* data );
+int32 _rtl865x_setGpioDataBit( uint32 gpioId, uint32 data );
+
+#endif/*__GPIO__*/
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/mbuf.h b/drivers/soc/realtek/rtd129x/hw_nat/common/mbuf.h
new file mode 100644
index 00000000..04f3c51
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/mbuf.h
@@ -0,0 +1,1391 @@
+
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* Program : The mbuf module header file
+* Abstract :
+* Author : David Chun-Feng Liu (cfliu@realtek.com.tw)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+*/
+#ifndef _MBUF_H_
+#define	_MBUF_H_
+
+/*********************************************************************************
+	SECTION 1:		mbuf module default settings
+**********************************************************************************/
+#define	PKT_MBUF_CLUSTER_LEN		1650
+
+#define PKT_BUF_SZ		PKT_MBUF_CLUSTER_LEN /* Size of each temporary Rx buffer.*/
+
+/*********************************************************************************
+	SECTION 2:		mbuf module data structure definitions
+**********************************************************************************/
+#define 	BUF_FREE			0x00   /* Buffer is Free  */
+#define 	BUF_USED			0x80   /* Buffer is occupied */
+#define 	BUF_ASICHOLD		0x80   /* Buffer is hold by ASIC */
+#define 	BUF_DRIVERHOLD 	0xc0   /* Buffer is hold by driver */
+
+#define 	MBUFTYPE_DATA		0x01	//not in use now. Keep for backward compatablity.
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#define _PKTHDR_CACHEABLE		1
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+
+/*@struct m_buf | The mbuf header associated with each cluster */
+
+struct rtl_mBuf
+{
+	struct rtl_mBuf *m_next;
+	struct rtl_pktHdr *m_pkthdr;            /* Points to the pkthdr structure */
+
+#ifdef _LITTLE_ENDIAN
+	int8      m_reserved2;              /* padding */
+	int8      m_flags;                  /* mbuf flags; see below */
+	uint16    m_len;                    /* data bytes used in this cluster */
+#else
+	uint16    m_len;                    /* data bytes used in this cluster */
+	int8      m_flags;                  /* mbuf flags; see below */
+	int8      m_reserved2;              /* padding */
+#endif
+
+#define MBUF_FREE            BUF_FREE   /* Free. Not occupied. should be on free list   */
+#define MBUF_USED            BUF_USED   /* Buffer is occupied */
+#define MBUF_EXT             0x10       /* has associated with an external cluster, this is always set. */
+#define MBUF_PKTHDR          0x08       /* is the 1st mbuf of this packet */
+#define MBUF_EOR             0x04       /* is the last mbuf of this packet. Set only by ASIC*/
+	uint8     *m_data;                  /*  location of data in the cluster */
+	uint8     *m_extbuf;                /* start of buffer*/
+
+#ifdef _LITTLE_ENDIAN
+	int8      m_reserved[2];            /* padding */
+	uint16    m_extsize;                /* sizeof the cluster */
+#else
+	uint16    m_extsize;                /* sizeof the cluster */
+	int8      m_reserved[2];            /* padding */
+#endif
+
+	void			*skb;
+#if defined(_PKTHDR_CACHEABLE)
+	uint32	 pending0;	// for cache line alignment
+#endif
+};
+
+/*@struct rtl_pktHdr |  pkthdr records packet specific information. Each pkthdr is exactly 32 bytes.
+ first 20 bytes are for ASIC, the rest 12 bytes are for driver and software usage.
+ */
+struct rtl_pktHdr
+{
+	union
+	{
+		struct rtl_pktHdr *pkthdr_next;     /*  next pkthdr in free list */
+		struct rtl_mBuf *mbuf_first;        /*  1st mbuf of this pkt */
+	}PKTHDRNXT;
+#define ph_nextfree         PKTHDRNXT.pkthdr_next
+#define ph_mbuf             PKTHDRNXT.mbuf_first
+
+#ifdef _LITTLE_ENDIAN
+
+	uint16    ph_srcExtPortNum: 2;      /* Both in RX & TX. Source extension port number. */
+	uint16    ph_l2Trans: 1;            /* l2Trans - copy from HSA bit 129 */
+	uint16    ph_isOriginal: 1;         /* isOriginal - DP included cpu port or more than one ext port */
+	uint16    ph_hwFwd: 1;              /* hwFwd - copy from HSA bit 200 */
+	uint16    ph_reserved2: 3;          /* reserved */
+	uint16    ph_extPortList: 4;        /* dest extension port list. must be 0 for TX */
+	uint16    ph_queueId: 3;            /* bit 2~0: Queue ID */
+	uint16    ph_reserved1: 1;           /* reserved */
+	uint16    ph_len;                   /*   total packet length */
+
+#else
+	uint16    ph_len;                   /*   total packet length */
+	uint16    ph_reserved1: 1;           /* reserved */
+	uint16    ph_queueId: 3;            /* bit 2~0: Queue ID */
+	uint16    ph_extPortList: 4;        /* dest extension port list. must be 0 for TX */
+	uint16    ph_reserved2: 3;          /* reserved */
+	uint16    ph_hwFwd: 1;              /* hwFwd - copy from HSA bit 200 */
+	uint16    ph_isOriginal: 1;         /* isOriginal - DP included cpu port or more than one ext port */
+	uint16    ph_l2Trans: 1;            /* l2Trans - copy from HSA bit 129 */
+	uint16    ph_srcExtPortNum: 2;      /* Both in RX & TX. Source extension port number. */
+#endif
+
+		/* for ph_extPortList */
+		#define	PKTHDR_EXTPORT_MAGIC		0xA530
+		#define	PKTHDR_EXTPORT_MAGIC2		0xA531
+		#define	PKTHDR_EXTPORT_MAGIC3		0xA532
+		#define	PKTHDR_EXTPORT_MAGIC4		0xA533
+		#define	PKTHDR_EXTPORT_P1               6
+		#define	PKTHDR_EXTPORT_P2               7
+		#define	PKTHDR_EXTPORT_P3               8
+
+		#define PKTHDR_EXTPORT_LIST_P0		0
+		#define PKTHDR_EXTPORT_LIST_P1		1
+		#define PKTHDR_EXTPORT_LIST_P2		2
+		#define PKTHDR_EXTPORT_LIST_CPU		3
+		#define PKTHDR_EXTPORTMASK_P0		(0x1 << (PKTHDR_EXTPORT_LIST_P0))
+		#define PKTHDR_EXTPORTMASK_P1		(0x1 << (PKTHDR_EXTPORT_LIST_P1))
+		#define PKTHDR_EXTPORTMASK_P2		(0x1 << (PKTHDR_EXTPORT_LIST_P2))
+		#define PKTHDR_EXTPORTMASK_CPU		(0x1 << (PKTHDR_EXTPORT_LIST_CPU))
+		#define PKTHDR_EXTPORTMASK_ALL		(	PKTHDR_EXTPORTMASK_P0 |\
+												PKTHDR_EXTPORTMASK_P1 |\
+												PKTHDR_EXTPORTMASK_P2 |\
+												PKTHDR_EXTPORTMASK_CPU \
+											)
+
+#ifdef _LITTLE_ENDIAN
+	uint16    ph_reason;                /* indicates wht the packet is received by CPU */
+
+	uint16    ph_linkID: 7;             /* for WLAN WDS multiple tunnel */
+	uint16    ph_pppoeIdx: 3;
+	uint16    ph_pppeTagged: 1;         /* the tag status after ALE */
+	uint16    ph_LLCTagged: 1;          /* the tag status after ALE */
+	uint16    ph_vlanTagged: 1;         /* the tag status after ALE */
+	uint16    ph_type: 3;
+#else
+	uint16    ph_type: 3;
+	uint16    ph_vlanTagged: 1;         /* the tag status after ALE */
+	uint16    ph_LLCTagged: 1;          /* the tag status after ALE */
+	uint16    ph_pppeTagged: 1;         /* the tag status after ALE */
+	uint16    ph_pppoeIdx: 3;
+	uint16    ph_linkID: 7;             /* for WLAN WDS multiple tunnel */
+	uint16    ph_reason;                /* indicates wht the packet is received by CPU */
+#endif
+
+#define	ph_proto				ph_type
+#define PKTHDR_ETHERNET      0
+#define PKTHDR_PPTP          1
+#define PKTHDR_IP            2
+#define PKTHDR_ICMP          3
+#define PKTHDR_IGMP          4
+#define PKTHDR_TCP           5
+#define PKTHDR_UDP           6
+#define PKTHDR_IPV6          7
+
+#ifdef _LITTLE_ENDIAN
+	uint8     ph_portlist;              /* RX: source port number, TX: destination portmask */
+	uint8     ph_orgtos;                /* RX: original TOS of IP header's value before remarking, TX: undefined */
+	uint16    ph_flags;                 /*  NEW:Packet header status bits */
+#else
+	uint16    ph_flags;                 /*  NEW:Packet header status bits */
+	uint8     ph_orgtos;                /* RX: original TOS of IP header's value before remarking, TX: undefined */
+	uint8     ph_portlist;              /* RX: source port number, TX: destination portmask */
+#endif
+
+#define PKTHDR_FREE          (BUF_FREE << 8)        /* Free. Not occupied. should be on free list   */
+#define PKTHDR_USED          (BUF_USED << 8)
+#define PKTHDR_ASICHOLD      (BUF_ASICHOLD<<8)      /* Hold by ASIC */
+#define PKTHDR_DRIVERHOLD    (BUF_DRIVERHOLD<<8)    /* Hold by driver */
+#define PKTHDR_CPU_OWNED     0x4000
+#define PKT_INCOMING         0x1000     /* Incoming: packet is incoming */
+#define PKT_OUTGOING         0x0800     /*  Outgoing: packet is outgoing */
+#define PKT_BCAST            0x0100     /*send/received as link-level broadcast  */
+#define PKT_MCAST            0x0080     /*send/received as link-level multicast   */
+#define PKTHDR_BRIDGING      0x0040     /* when PKTHDR_HWLOOKUP is on. 1: Hardware assist to do L2 bridging only, 0:hardware assist to do NAPT*/
+#define PKTHDR_HWLOOKUP      0x0020	/* valid when ph_extPortList!=0. 1:Hardware table lookup assistance*/
+#define PKTHDR_PPPOE_AUTOADD    0x0004  /* PPPoE header auto-add */
+#define CSUM_TCPUDP_OK       0x0001     /*Incoming:TCP or UDP cksum checked */
+#define CSUM_IP_OK           0x0002     /* Incoming: IP header cksum has checked */
+#define CSUM_TCPUDP          0x0001     /*Outgoing:TCP or UDP cksum offload to ASIC*/
+#define CSUM_IP              0x0002     /* Outgoing: IP header cksum offload to ASIC*/
+
+
+#ifdef _LITTLE_ENDIAN
+	union
+	{
+		uint16	_flags2;			/* RX: bit 15: Reserved, bit14~12: Original Priority, bit 11~0: Original VLAN ID */
+								/* TX: bit 15~6: Reserved, bit 5~0: Per Port Tag mask setting for TX(bit 5:MII, bit 4~0: Physical Port) */
+		struct
+		{
+			/* RX: bit 15: Reserved, bit14~12: Original Priority, bit 11~0: Original VLAN ID */
+			uint16 _svlanId:12;			/* Source (Original) VLAN ID */
+			uint16 _rxPktPriority:3;		/* Rx packet's original priority */
+			uint16 _reserved:1;
+		} _rx;
+
+		struct
+		{
+			/* TX: bit 15~6: Reserved, bit 5~0: Per Port Tag mask setting for TX(bit 5:MII, bit 4~0: Physical Port) */
+
+			uint16 _txCVlanTagAutoAdd:6;	/* BitMask to indicate the port which would need to add VLAN tag */
+			#if defined(CONFIG_RTL_8197F)
+			uint16 _reserved:2;
+			uint16 _q_priority_tx:3;
+			uint16 _reserved_2:5;
+
+			#define ph_q_priority_tx	_flags2._tx._q_priority_tx
+			#else
+			uint16 _reserved:10;
+			#endif
+		} _tx;
+	} _flags2;
+
+	uint16     ph_vlanId: 12;
+	uint16     ph_txPriority: 3;
+	uint16     ph_vlanId_resv: 1;
+#else
+	uint16     ph_vlanId_resv: 1;
+	uint16     ph_txPriority: 3;
+	uint16     ph_vlanId: 12;
+	union
+	{
+		uint16	_flags2;			/* RX: bit 15: Reserved, bit14~12: Original Priority, bit 11~0: Original VLAN ID */
+								/* TX: bit 15~6: Reserved, bit 5~0: Per Port Tag mask setting for TX(bit 5:MII, bit 4~0: Physical Port) */
+		struct
+		{
+			/* RX: bit 15: Reserved, bit14~12: Original Priority, bit 11~0: Original VLAN ID */
+			uint16 _reserved:1;
+			uint16 _rxPktPriority:3;		/* Rx packet's original priority */
+			uint16 _svlanId:12;			/* Source (Original) VLAN ID */
+		} _rx;
+
+		struct
+		{
+			/* TX: bit 15~6: Reserved, bit 5~0: Per Port Tag mask setting for TX(bit 5:MII, bit 4~0: Physical Port) */
+			uint16 _reserved:10;
+			uint16 _txCVlanTagAutoAdd:6;	/* BitMask to indicate the port which would need to add VLAN tag */
+		} _tx;
+	} _flags2;
+#endif
+
+	#define ph_dvlanId		ph_vlanId
+	#define ph_rxPriority		ph_txPriority
+
+	#define PKTHDR_TXPRIORITY_MIN			0
+	#define PKTHDR_TXPRIORITY_MAX			7
+
+	#define ph_flags2				_flags2._flags2
+	#define ph_svlanId				_flags2._rx._svlanId
+	#define ph_rxPktPriority			_flags2._rx._rxPktPriority
+	#define ph_txCVlanTagAutoAdd	_flags2._tx._txCVlanTagAutoAdd
+
+	#define PKTHDR_TXCVID(vid)					(vid & 0xfff)
+	#define PKTHDR_VLAN_P0_AUTOADD			(0x0001<<0)
+	#define PKTHDR_VLAN_P1_AUTOADD			(0x0001<<1)
+	#define PKTHDR_VLAN_P2_AUTOADD			(0x0001<<2)
+	#define PKTHDR_VLAN_P3_AUTOADD			(0x0001<<3)
+	#define PKTHDR_VLAN_P4_AUTOADD			(0x0001<<4)
+	#define PKTHDR_VLAN_P5_AUTOADD			(0x0001<<5)
+	#define PKTHDR_VLAN_AUTOADD				(	(PKTHDR_VLAN_P0_AUTOADD)|	\
+												(PKTHDR_VLAN_P1_AUTOADD)|	\
+												(PKTHDR_VLAN_P2_AUTOADD)|	\
+												(PKTHDR_VLAN_P3_AUTOADD)|	\
+												(PKTHDR_VLAN_P4_AUTOADD)|	\
+												(PKTHDR_VLAN_P5_AUTOADD)	)
+
+#ifdef _LITTLE_ENDIAN
+	#if defined(CONFIG_RTL_8197F)
+	uint16	ph_ipIpv6HdrLen;	/* IPv6 header length */
+	uint8	ph_ipIpv4_1st:1;	/* IPv4 first header */
+	uint8	ph_ipIpv4:1;		/* IPv4 Header flag */
+	uint8	ph_ipIpv6:1;		/* IPv6 Header flag */
+	uint8	ph_ipResv:5;
+
+	uint8	ph_ptpPkt:1;		/* 1: PTP */
+	uint8	ph_ptpVer:2;		/* PTP version, 0: 1588v1; 1: 1588v2 or 802.1as; others: reserved */
+	uint8	ph_ptpMsgType:4;	/* message type */
+	uint8	ph_ptpResv:1;
+	#else
+	uint8	ph_reserved[4];
+	#endif
+#else
+	#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C)
+	uint8	ph_ptpResv:1;
+	uint8	ph_ptpMsgType:4;	/* message type */
+	uint8	ph_ptpVer:2;		/* PTP version, 0: 1588v1; 1: 1588v2 or 802.1as; others: reserved */
+	uint8	ph_ptpPkt:1;			/* 1: PTP */
+	#else
+	uint8	ph_ptpreserved;
+	#endif
+
+	#if defined(CONFIG_RTL_8198C)
+	uint8	ph_ipResv:5;
+	uint8	ph_ipIpv6:1;		/* IPv6 Header flag */
+	uint8	ph_ipIpv4:1;		/* IPv4 Header flag */
+	uint8	ph_ipIpv4_1st:1;	/* IPv4 first header */
+	uint16	ph_ipIpv6HdrLen;	/* IPv6 header length */
+	#else
+	uint8	ph_reserved[3];		/* padding */
+	#endif
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	dma_addr_t dma_addr;
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#if defined(_PKTHDR_CACHEABLE)
+	uint32 	pending0;	//for cache line alianment
+	uint32	pending1;
+#endif
+};
+
+	//property for ph_unnumber		: cw_du
+	#define PHUNNUMBER_SRCGLOBEIP			0x01
+	#define PHUNNUMBER_DIRECTION			0x02		// 1 : WAN->LAN; 	0: LAN->WAN
+	#define PHUNNUMBER_UNNUMBEREDSRCIP	0x04
+	#define PHUNNUMBER_ADVRTMATCHED		0x08
+	#define PHUNNUMBER_ALLBITS				0xff
+
+
+	#define PKTHDR_PHUNNUMBER_SET(pkthdrPtr, property) \
+		do{\
+			assert(pkthdrPtr);\
+			pkthdrPtr->ph_unnumber |=property;\
+		}while(0)
+
+	#define PKTHDR_PHUNNUMBER_CLR(pkthdrPtr, property) \
+		do{\
+			assert(pkthdrPtr);\
+			pkthdrPtr->ph_unnumber &= ~property;\
+		}while(0)
+
+	#define PKTHDR_PHUNNUMBER_TEST(pkthdrPtr, property) 	((pkthdrPtr->ph_unnumber & property) ? 1: 0)
+
+struct rtl_mBufStatus
+{
+	uint32 	m_totalmbufs;	/* Total mbufs allocated during initialization */
+	uint32 	m_totalclusters;/* Total clusters allocated during initialization */
+	uint32 	m_totalpkthdrs;	/* Total pkthdrs allocated during initialization */
+	uint32 	m_freembufs;	/* free mbufs in pool now*/
+	uint32 	m_freeclusters;	/* free clusters in  pool now*/
+	uint32 	m_freepkthdrs;	/* free pkthdrs in pool now*/
+	uint32 	m_msize;		/* length of an mbuf */
+	uint32 	m_mclbytes;		/* length of an mbuf cluster */
+	uint32 	m_pkthdrsize;	/* length of an pkthdr */
+	uint32 	m_wait;			/* times waited for space, includes mbuf, pkthdr and cluster */
+};
+
+
+/*********************************************************************************
+	SECTION 3:		mbuf module exported variables, symbols and macros
+**********************************************************************************/
+#define	MBUF_COPYALL		1000000000	   /* length for m_copy to copy all */
+#define	MBUF_WAITOK		0x01
+#define	MBUF_DONTWAIT	0x02	   /* Don't wait if there is no buffer available */
+#define	MBUF_ONLY	0x04	   /* Don't allocate a cluster in mBuf_get */
+#define	MBUF_ALLOCPKTHDR	0x08	   /* Allocate a packet header with mbuf chain in mBuf_getm, mBuf_cloneMbufChain, mBuf_dupMbufChain*/
+#define	MBUF_GETNEWMBUF 0x10		   /* In mBuf_prepend, alloate new mbufs directly */
+#define MBUF_CHECKPKTHDR(m)	((m)&&(ISSET((m)->m_flags, MBUF_USED) && ((m)->m_pkthdr))?1:0)
+#define MBUF_GETPKTHDRFIELD16(field)  (*((uint16 *)(field)))
+#define MBUF_SETPKTHDRFIELD16(field, value)	*((uint16 *)(field)) = (value)
+
+//The size of each cluster.
+extern int32 m_clusterSize;
+
+/*********************************************************************************
+	SECTION 4:		mbuf module exported API prototype
+**********************************************************************************/
+
+/* mbuf module exported APIs */
+
+/*	@doc MBUF_API
+
+	@module mbuf.h - Mbuf module API documentation	|
+	This document illustrates the API interface of the mbuf module.
+	@normal Chun-Feng Liu (cfliu@realtek.com.tw) <date>
+
+	Copyright <cp>2001 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+	@head3 List of Symbols |
+	Here is a list of all functions and variables in this module.
+
+	@index | MBUF_API
+*/
+extern int32 mBuf_init(uint32, uint32, uint32, uint32, uint32);			   //was tunable_mbinit()
+#if defined(RTL865X_TEST)||defined(RTL865X_MODEL_USER)
+extern int32 mBuf_Reinit(void);
+#endif /* RTL865X_TEST */
+/*
+@func void	| mBuf_init	| mbuf module initialization
+@parm uint32 	| mbufs		| Number of mbufs
+@parm uint32 	| clusters	| Number of clusters
+@parm uint32 	| pkthdrs		| Number of packet headers
+@parm uint32		| clusterSize	| Size of each cluster. must be power of 2
+@parm uint32		| msgLogId	| Debuging message log list id
+@rdesc None
+@rvalue SUCCESS		| 	The mbuf module and its memory pool is initiated as requested
+@rvalue FAILED	| 	Failed to initialize the mbuf module.
+@comm mbuf module initialization. Allocate mbuf and related structure pools. Value for <p clusterSize> must be power of 2.
+If <p clusters> is 0, clusters would be allocated externally through registered OS buffer allocation glue function. If clusters
+are allocated this way, MBUF_WAITOK flag can't be used for mBuf_get, mBuf_getm, mBuf_dupMbufChain, mBuf_dupPacket since
+mbuf module knows nothing about external cluter pool managed by OS hence doesn't know when to wakeup waiting threads.
+ */
+
+
+extern int32 mBuf_getBufStat(struct rtl_mBufStatus *mbs);
+/*
+@func  int32	| mBuf_getBufStat	| Returns current status of the mbuf module
+@parm struct rtl_mBufStatus *	| mbs	| A pointer to the mbstat structure for mBuf_getBufStat() to fill in
+@rdesc Returns current status of the mbuf module
+@rvalue <p FAILED>	| 	Failed to get mbuf module status. Maybe mbs is NULL or mbuf module not yet initiated.
+@rvalue <p SUCCESS>	| 	Mbuf module status is returned with the mbstat structure given.
+ */
+
+
+
+extern int32 mBuf_leadingSpace(struct rtl_mBuf *m);
+
+/*
+@func int32	| mBuf_leadingSpace	| Calculate the number of leading free data bytes.
+@parm struct rtl_mBuf * 	| m		| Pointer to the mbuf chain.
+@rdesc Returns the number of free leading space
+@rvalue n		| 	The number of free leading data bytes in cluster.
+@comm
+Calculate the number of leading free data bytes.
+@xref  <c mBuf_trailingSpace>
+
+ */
+
+
+extern int32 mBuf_trailingSpace(struct rtl_mBuf *m);
+
+/*
+@func int32	| mBuf_trailingSpace	| Calculate the number of trailing free data bytes.
+@parm struct rtl_mBuf * 	| m		| Pointer to the mbuf chain.
+@rdesc Returns the number of free trailing space
+@rvalue n		| 	The number of free trailing data bytes in cluster.
+@comm
+Calculate the number of trailing free data bytes.
+@xref <c mBuf_leadingSpace>
+
+ */
+
+
+extern int32 mBuf_clusterIsWritable(struct rtl_mBuf *m);
+
+/*
+@func int32	| mBuf_clusterIsWritable	| Determine whether <p m>'s cluster is writable or not.
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf.
+@rdesc Returns TRUE or FALSE
+@rvalue TRUE		| 	The cluster is writable.
+@rvalue FALSE	| 	The cluster is not writable.
+@comm
+Determine whether <p m>'s cluster is writable or not. New mbufs allocated due to mBuf_clonePacket, mBuf_split, mBuf_cloneMbufChain
+should not modify its cluster becoz it is not the owner of these clusters. This function always return TRUE if the 'clusters' parameter
+during mBuf_init() was initialized to 0.
+
+ */
+
+extern   uint32 mBuf_getPktlen(struct rtl_mBuf *m);
+/*
+@func uint32	| mBuf_getPktlen	| Get total number of data bytes in the packet which <p m> belongs to
+@parm struct rtl_mBuf *	|m		| Indicate the packet
+@rdesc Returns data length of the packet
+@rvalue -1		| 	Failed.
+@rvalue <p length>| 	The actual length of  packet
+@comm
+Get total number of data bytes in the packet which <p m> belongs to
+@xref <c MBUF_GETLEN>
+*/
+
+extern struct rtl_mBuf *mBuf_data2Mbuf(int8 * x);  //was dtom
+
+/*
+@func struct rtl_mBuf *	| mBuf_data2Mbuf	| Given data address <p x>, return mbuf address <p m>
+@parm int8  * 	|x		| Data address
+@rdesc Returns mbuf address <p m> which owns the cluster block where <p x> resides.
+@rvalue <p NULL>		| 	Can't find the address. The data address <p x> given might be within a zombie cluster whose owning mbuf has already been freed.
+@rvalue <p m>		| 	The address of owning mbuf
+@comm
+Finds the mbuf address of given data address <p x>
+This function can't be called if the 'clusters' parameter during mBuf_init() was initialized to 0.
+@devnote  Original BSD code define this as a dtom macro. In our implmentation, we make it a function.
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *n;
+
+	n = mBuf_data2Mbuf(x);
+	if (n != NULL) {
+		printf("There are %d bytes in the cluster", n->m_len);
+	}
+  @xref  <c MBUF2DATAPTR>
+*/
+
+
+
+extern struct rtl_mBuf *mBuf_get(int32 how, int32 unused, uint32 Nbuf);
+
+/*
+@func struct rtl_mBuf *	| mBuf_get	| mbuf space allocation routines.
+@parm int32			| how	| <p MBUF_WAITOK>, <p MBUF_DONTWAIT>, and/or <p MBUF_ONLY>
+@parm int32			| unused	| unused now. Keep for backward compatibility.
+@parm uint32 			| Nbuf	| The number of mbufs requesting.
+
+@rdesc Returns the address of allocated mbuf head
+@rvalue <p NULL>		| 	Can't allocate all  <p Nbuf>s at once.
+@rvalue <p n>		| 	The address of first mbuf allocated. All <p Nbuf>s have been linked together.
+@comm
+Get <p Nbuf> mbufs and clusters. All mbufs are chained via the <p m_next> pointer inside each mbuf. Note that memory content in all allocated clusters are NOT initialized.
+
+If <p how> has MBUF_DONTWAIT bit set, and we can't get all <p Nbuf>s immediately, return NULL.
+
+If <p how> has MBUF_WAITOK bit set, and we can't get all <p Nbuf>s right away, block waiting until our request is satisfied
+
+If <p how> has MBUF_ONLY bit set, then no clusters would be allocated. Only mbufs are allocated. Can be used with MBUF_DONTWAIT or MBUF_WAITOK
+
+@devnote
+1.Side effect: <p mBuf_get> wakes up any sleeping threads if they are block waiting for free mbufs or clusters.
+2. If the 'clusters' parameter during mBuf_init() was initialized to 0, mBuf_get doesn't accept MBUF_ONLY flag
+
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *m;
+	m= mBuf_get( MBUF_DONTWAIT, 0, 5);  //allocate 5 mbufs and clusters without blocking.
+	if (!m)
+		return NULL;
+
+  @xref
+  <c mBuf_getCleared> ,  <c mBuf_getm>, <c mBuf_driverGet>
+ */
+
+
+extern struct rtl_mBuf *mBuf_getCleared(int32 how, int32 unused, uint32 Nbuf);
+
+/*
+@func struct rtl_mBuf *	| mBuf_getCleared| Same as mBuf_get, but initialize all clusters to zero.
+@parm int32			|how	| <p MBUF_WAIT>, <p MBUF_DONTWAIT> and/or <p MBUF_ONLY>
+@parm int32			|unused	| unused now. Keep for backward compatibility.
+@parm uint32 			| Nbuf	| The number of mbufs requesting.
+
+@rdesc Returns the address of allocated mbuf head
+@rvalue <p NULL>		| 	Can't allocate all  <p Nbuf>s at once.
+@rvalue <p n>		| 	The address of first mbuf allocated. All <p Nbuf>s have been linked together and cleared to 0.
+@comm
+Same as <p mget>(). However, content in all mbufs and clusters have been cleared to 0.
+@ex The following example demonstrates how to use this function |
+	register struct rtl_mBuf *m;
+	m= mBuf_getCleared(MBUF_DONTWAIT | MBUF_ONLY, 0, 5);  //allocate 5  mbufs without blocking.
+	if (!m)
+		return NULL;
+
+  @xref
+  <c mBuf_get>,  <c mBuf_getm>, <c mBuf_driverGet>
+ */
+
+
+extern uint32 mBuf_driverGet(uint32 Nmbuf,struct rtl_mBuf **ppFirstMbuf, struct rtl_mBuf **ppLastMbuf);
+/*
+@func uint32	| mBuf_driverGet| Driver specific. Get multiple mbufs without blocking
+@parm uint32	|Nmbuf	| Number of mbufs requesting
+@parm struct rtl_mBuf **	|ppFirstMbuf	| Returns a pointer which points to  the first mbuf allocated.
+@parm struct rtl_mBuf **	| ppLastMbuf	| Returns a pointer which points to  the last mbuf allocated.
+@rdesc Returns number of mbufs successfully allocated.
+@comm
+An optimized mBuf_get() for driver. <p ppFirstMbuf> and <p ppLastMbuf> should not be NULL!!
+mbuf and cluster not initialized to zero. Only required fields in mBuf_driverGet have been properly filled.
+
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf * localTempMbufHead,  * localTempMbufTail;
+	int32 allocated;
+	requested = 5;
+	allocated= mBuf_driverGet(requested, &localTempMbufHead, &localTempMbufTail);
+	if (allocated!=requested)
+		printf("Can't allocate all 5 mbufs in driver\n")
+
+  @xref
+  <c mBuf_get>,  <c mBuf_getm>, <c mBuf_getCleared>
+ */
+
+extern struct rtl_mBuf *mBuf_getm(struct rtl_mBuf *m, uint32 len, int32 how, int32 unused);
+
+/*
+@func struct rtl_mBuf *	| mBuf_getm| allocate <p len>-worth of  mbuf clusters and return a pointer to the top
+of the allocated chain.
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain. Could be NULL.
+@parm uint32			|len		| Number of data bytes requesting.
+@parm int32			|how	| <p MBUF_WAIT> or <p MBUF_DONTWAIT> and/or <p M_ALLOCPKTHDR>.
+@parm int32			|unused	| unused now. Keep for backward compatibility.
+@rdesc Returns return a pointer to the head of the allocated chain.
+@rvalue <p NULL>		| 	Allocation failed.
+@rvalue <p n>		| 	The memory address of first mbuf allocated.
+@comm
+If <p m> is non-null, then it is an mbuf chain to which we want <p len> bytes worth of clusters and their associating mbufs be attached, and so
+if allocation is successful, a pointer to m is returned. i.e <p n> = <p m>)
+
+If <p m> is null,  <p len> bytes worth of clusters and their associating mbufs would be allocated.
+
+If <p how> has M_ALLOCPKTHDR bit set, <p mBuf_getm> also allocates a pkthdr with the mbuf chain.
+If <p how> has MBUF_DONTWAIT bit set, and we can't get a pkthdr immediately, return NULL.
+If <p how> has MBUF_WAITOK bit set, and we can't get a pkthdr right away, block waiting until our request is satisfied.
+
+M_BUFONLY can't be used with mBuf_getm, in this case, you should use mBuf_get() and calculate how many mbufs you need on your own.
+
+@ex The following example demonstrates how to use this function |
+	m = mBuf_getm(m, size, MBUF_WAITOK, 0);
+	if (m == NULL)
+		return ENOBUFS;
+
+  @xref
+  <c mBuf_get> , <c mBuf_driverGet>, <c mBuf_getCleared>
+ */
+
+
+extern struct rtl_mBuf *mBuf_getPkthdr(struct rtl_mBuf *m, int32 how);
+/*
+@func struct rtl_mBuf *	| mBuf_getPkthdr| Allocate a packet header for mbuf chain <p m>
+@parm struct rtl_mBuf * 	| m		| Pointer to the mbuf chain.
+@parm int32			|how	| <p MBUF_WAIT> or <p MBUF_DONTWAIT>
+
+@rdesc Returns the address of mbuf <p m> that holds a packet header.
+@rvalue <p NULL>		| 	Can't allocate a  pkthdr for mbuf <p m>.
+@rvalue <p m>		| 	A pkthdr is allocated to mbuf <p m>.
+@comm
+
+Given an mbuf <p m>, allocate a packet header (pkthdr) structure for <p m> and makes <p m> the owner of this pkthdr.
+If there is already a pkthdr owned by some mbuf after m on the same mbuf chain, m becomes the owner of that pkthdr without getting a new one. Corresponding pkthdr fields are modified accordingly.
+
+If <p how> has MBUF_DONTWAIT bit set, and we can't get a pkthdr immediately, return NULL.
+If <p how> has MBUF_WAITOK bit set, and we can't get a pkthdr right away, block waiting until our request is satisfied.
+
+
+ mBuf_getPkthdr may wake up other sleeping threads waiting for pkthdrs if any
+
+@ex The following example demonstrates how to use this function |
+	if (!mBuf_getPkthdr(pNewMbuf, MBUF_DONTWAIT))	//get a pkthdr
+		goto nospace;
+  @xref
+  <c mBuf_driverGetPkthdr>
+ */
+
+extern uint32 mBuf_driverGetPkthdr(uint32 Npkthdr,struct rtl_pktHdr **ppHeadPkthdr, struct rtl_pktHdr **ppTailPkthdr);
+/*
+@func uint32	| mBuf_driverGetPkthdr| Driver specific. Get multiple pkthdrs without blocking
+@parm uint32	|Npkthdr	| Number of pkthdrs requesting
+@parm struct rtl_pktHdr **	|ppHeadPkthdr	| Returns a pointer which points to  the first pkthdr allocated.
+@parm struct rtl_pktHdr **	| ppTailPkthdr	| Returns a pointer which points to  the last pkthdr allocated.
+@rdesc Returns number of pkthdrs successfully allocated.
+@comm
+This function is dedicated for driver.  <p ppHeadPkthdr> and <p ppTailPkthdr> should not be NULL!!
+
+@ex The following example demonstrates how to use this function |
+	struct rtl_pktHdr * localTempPkthdrHead,  * localTempPkthdrTail;
+	int32 allocated;
+	requested = 5;
+	allocated= mBuf_driverGetPkthdr(requested, &localTempPkthdrHead, &localTempPkthdrTail);
+	if (allocated!=requested)
+		printf("Can't allocate all 5 mbufs in driver\n")
+
+  @xref
+  <c mBuf_getPkthdr>
+ */
+
+
+extern void mBuf_freeMbuf(struct rtl_mBuf *m);
+/*
+@func struct rtl_mBuf *	| mBuf_freeMbuf	| Free a single mbuf <p m>..
+@parm struct rtl_mBuf * 	| m		|  Pointer to an mbuf chain.
+@rdesc None
+@comm
+ Free a single mbuf. Leave assocated pkthdr or cluster, if any, intact.
+
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *n;
+	mBuf_freeMbuf(m);
+@xref
+  <c mBuf_freeMbufChain> , <c mBuf_driverFreeMbufChain>, <c mBuf_freePkthdr>, <c mBuf_driverFreePkthdr>
+ */
+
+
+extern int32 mBuf_attachCluster(struct rtl_mBuf *m, void *buffer, uint32 id, uint32 size, uint16 datalen, uint16 align);
+/*
+@func struct rtl_mBuf *	| mBuf_attachCluster	| Attach a cluster to mbuf <p m>
+@parm struct rtl_mBuf * 	| m		|  Pointer to an mbuf chain.
+@parm void * 	| buffer	|  Address of cluster to be associated with mbuf <p m>.
+@parm uint32 	| id		| Identifier of cluster to be associated with mbuf <p m>.
+@parm uint32  	| size	|  Size of cluster to be associated with mbuf <p m>.
+@parm uint32  	| datalen	|  Byte count of data already in packet.
+@parm uint16  	| align	|  byte offset of first data byte in cluster <p buffer>,if any,from which <p m> attaches to. Default is 0.
+@rvalue <p SUCCESS>		| 	cluster has been successfully attached with mbuf <p m>.
+@rvalue <p FAILED>		| 	Failed to attach cluster with mbuf <p m>
+@comm
+Attach a cluster to mbuf <p m>. If there is already a cluster attached with mbuf <p m>, return FAILED.
+If <p align> is non-zero, mbuf <p m> sets it's data pointer from which <p m>'s data pointer attaches.
+@xref
+  <c mBuf_get> , <c mBuf_driverGetMbufChain>, <c mBuf_GetPkthdr>, <c mBuf_getm>
+ */
+
+
+extern int32 mBuf_freeOneMbufPkthdr(struct rtl_mBuf *m, void **buffer, uint32 *id, uint16 *size);
+/*
+@func struct int32	| mBuf_freeOneMbufPkthdr	| Free a single mbuf <p m> and associated pkthdr, if any. Returns information of cluster associated.
+@parm struct rtl_mBuf * 	| m		|  Pointer to an mbuf chain.
+@parm void * 	| buffer	|  placeholder for address of cluster associated on return.
+@parm void * 	| id		|  placeholder of identifier of cluster associated on return.
+@parm uint16 * 	| size	|  placeholder of size of cluster associated on return.
+@rdesc Returns number of mbufs being freed
+@rvalue <p n>		| 	number of mbufs being freed
+@comm
+ Free a single mbuf and associated pkthdr, if any. Place the successor, if any, in <p n>.
+ Note that this function DOES NOT free the associated cluster.
+
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *n;
+	void *buffer ;
+	uint32 size, id;
+	n = mBuf_freeOne(m,&buffer,&id, &size);
+
+@xref
+  <c mBuf_freeMbufChain> , <c mBuf_driverFreeMbufChain>, <c mBuf_freePkthdr>, <c mBuf_driverFreePkthdr>, <c mBuf_freeOne>
+ */
+
+
+extern struct rtl_mBuf *mBuf_freeOne(struct rtl_mBuf *m);
+
+/*
+@func struct rtl_mBuf *	| mBuf_freeOne	| Free a single mbuf <p m> and associated cluster storage.
+@parm struct rtl_mBuf * 	| m		|  Pointer to an mbuf chain.
+@rdesc Returns address of next mbuf if any
+@rvalue <p NULL>		| 	<p m> has been freed and there isn't any successing mbufs.
+@rvalue <p n>		| 	The address of next mbuf after <p m>.
+@comm
+ Free a single mbuf and associated external storage. Place the successor, if any, in <p n>.
+
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *n;
+	n = mBuf_freeOne(m);
+
+@xref
+  <c mBuf_freeMbufChain> , <c mBuf_driverFreeMbufChain>, <c mBuf_freePkthdr>, <c mBuf_driverFreePkthdr>
+ */
+
+extern uint32 mBuf_freeMbufChain(register struct rtl_mBuf *m);
+
+/*
+@func struct rtl_mBuf *	| mBuf_freeMbufChain| Free the whole mbuf chain started from <p m>
+@parm struct rtl_mBuf * 	| m		| Pointer to the mbuf chain.
+@rdesc Returns number of mbufs being freed in mbuf chain <p m>.
+@rvalue <p n>		| 	The number of mbufs being freed. If <p n> is 0, <p m> is not freed.
+@comm
+ Free the whole mbuf chain starting from <p m>.
+
+@devnote  Return type changed from void to int32 to provide more information.
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *m;
+	int32 n;
+	m = mBuf_get(MBUF_DONTWAIT, 0, 5);
+	n = mBuf_freeMbufChain(m);
+	if (n!=5){
+		//Do error handling...
+	}
+@xref
+  <c mBuf_freeOne> , <c mBuf_driverFreeMbufChain>, <c mBuf_freePkthdr>, <c mBuf_driverFreePkthdr>
+ */
+
+extern uint32 mBuf_driverFreeMbufChain(struct rtl_mBuf *pFirstMbuf);
+/*
+@func uint32	| mBuf_driverFreeMbufChain| Free the whole mbuf chain started from <p m>
+@parm struct rtl_mBuf * 	| m		| Pointer to the mbuf chain.
+@rdesc Returns number of mbufs being freed in mbuf chain <p m>.
+@rvalue <p n>		| 	The number of mbufs being freed. If <p n> is 0, <p m> is not freed.
+@comm
+ Free the whole mbuf chain starting from <p m>.  To be used only in driver.
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf * localTempMbufHead,  * localTempMbufTail;
+	int32 allocated;
+	requested = 5;
+	allocated= mBuf_driverGet(requested, &localTempMbufHead, &localTempMbufTail);
+	if (allocated==requested){
+		n = mBuf_driverFreeMbufChain(localTempMbufHead);
+		if(n==allocated)
+			printf("All mbufs successfully freed in driver\n");
+	}
+@xref
+  <c mBuf_freeOne> , <c mBuf_driverFreeMbufChain>, <c mBuf_freePkthdr>, <c mBuf_driverFreePkthdr>
+ */
+
+
+
+extern void mBuf_freePkthdr(struct rtl_pktHdr *ph);
+/*
+@func struct rtl_pktHdr *	| mBuf_freePkthdr| Free a pkthdr alone.
+@parm struct rtl_pktHdr *	|ph	| The pkthdr to be freed.
+@rdesc No return value
+@comm  Free a pkthdr alone. Callers should be aware that this is NOT the normal way to free a pkthdr with mbufs attached.
+You should use <p mBuf_freeOne> or <p mBuf_freeMbufChain> to free pkthdrs attached with mbuf chains. This function is usd once only in TCP module.
+@devnote
+Caller of this function should remove the links between mbufs and pkthdrs on their own before <p mBuf_freePkthdr> is called.
+@xref  <c mBuf_freeOne> , <c mBuf_freeMbufChain>, <c mBuf_driverFreeMbufChain>, <c mBuf_driverFreePkthdr>
+ */
+
+uint32 mBuf_driverFreePkthdr(struct rtl_pktHdr *ph, uint32 Npkthdr, struct rtl_pktHdr **ppHeadPkthdr);
+/*
+@func uint32	| mBuf_driverFreePkthdr| Driver specific. Free multiple pkthdrs without blocking
+@parm struct rtl_pktHdr *	|ph	| The first pkthdr to be freed
+@parm uint32	|Npkthdr	| Number of pkthdrs to be freed
+@parm struct rtl_pktHdr **	|ppHeadPkthdr	| Returns next un-freed pkthdr, if any.
+@rdesc Returns number of pkthdrs successfully freed.
+@comm
+This function is dedicated for driver.  <p ph> should not be NULL!!
+
+ @xref
+   <c mBuf_freeOne> , <c mBuf_freeMbufChain>, <c mBuf_driverFreeMbufChain>, <c mBuf_freePkthdr>
+ */
+
+extern struct rtl_mBuf *mBuf_adjHead(struct rtl_mBuf *, uint32 req_len);
+/*
+@func struct rtl_mBuf *	| mBuf_adjHead	| Remove <p req_len> bytes of data from head the mbuf chain pointed to by <p m>.
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain. <p m> doesn't need to be the first mbuf in chain.
+@parm int32			| req_len	| Number of data bytes to be removed
+@rdesc m_adj returns the address of first mbuf after trimming data.
+@rvalue <p NULL>	| 	Can't adjust length of mbuf. <p m> might 1)be NULL 2)have no clusters.
+@rvalue <p m>		| 	When success, the first mbuf <p m> where user can read/write data is returned.
+@comm
+Remove <p req_len> bytes of data from the head of mbuf chain  <p m>. If user removed all
+data bytes in the whole packet, <p m> is returned.
+
+@devnote  If any clusters, after m_adj, is totally unused (ie. m_len=0),
+the m_data pointer would be reset to m_extbuf and the mbuf would NOT be freed.
+
+@xref
+  <c mBuf_adjTail>,   <c mBuf_trimHead>,  <c mBuf_trimTail>
+ */
+
+extern struct rtl_mBuf *mBuf_adjTail(struct rtl_mBuf *, uint32 req_len);
+/*
+@func struct rtl_mBuf *	| mBuf_adjTail	| Remove <p req_len> bytes of data from tail of the mbuf chain pointed to by <p m>.
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain. <p m> doesn't need to be the first mbuf in chain.
+@parm int32			| req_len	| Number of data bytes to be removed
+@rdesc m_adj returns the address of mbuf which contains the last data byte.
+@rvalue <p NULL>	| 	Can't adjust length of mbuf. <p m> might 1)be NULL 2)have no clusters or <p req_len> is 0
+@rvalue <p m>		| 	When success, the address of the mbuf which hold the last data byte is returned.
+@comm
+Remove <p req_len> bytes of data from the tail of mbuf chain  <p m>. If user removed all
+data bytes in the whole packet, <p m> is returned.
+
+@devnote  If any clusters, after m_adj, is totally unused (ie. m_len=0),
+the m_data pointer would be reset to m_extbuf and the mbuf would NOT be freed.
+
+@xref
+  <c mBuf_adjHead>,   <c mBuf_trimHead>,  <c mBuf_trimTail>
+ */
+
+extern struct rtl_mBuf *mBuf_trimHead(struct rtl_mBuf *, uint32 req_len);
+/*
+@func struct rtl_mBuf *	| mBuf_trimHead	| Same as mBuf_adjHead, but also frees unused mbufs and clusters
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain. <p m> doesn't need to be the first mbuf in chain.
+@parm int32			| req_len	| Number of data bytes to be trimmed from head.
+@rdesc mBuf_trimHead returns the address of first mbuf after trimming.
+@rvalue <p NULL>	| 	Can't adjust length of mbuf or the whole mbuf chain is trimmed and freed.
+@rvalue <p m>		| 	When success, the first mbuf <p m> where user can read/write data is returned.
+@comm
+Same as mBuf_adjHead, but also frees unused mbufs and clusters
+
+@devnote  mBuf_trimHead is implemented with mBuf_split and mBuf_freeMbufChain. It first splits the mbuf
+to two mbuf chains from indicated position and frees the first one.
+There is a possible risk that mBuf_trimHead may fail when the mbuf chain <p m> consumes all mbufs and no free mbufs
+is available for mBuf_split to work correctly.
+
+@xref
+  <c mBuf_adjHead>,   <c mBuf_adjTail>,  <c mBuf_trimTail>
+ */
+
+extern struct rtl_mBuf *mBuf_trimTail(struct rtl_mBuf *, uint32 req_len);
+/*
+@func struct rtl_mBuf *	| mBuf_trimTail	| Same as mBuf_adjTail, but also frees unused mbufs and clusters
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain. <p m> doesn't need to be the first mbuf in chain.
+@parm int32			| req_len	| Number of data bytes to be trimmed from tail.
+@rdesc mBuf_trimTail returns the address <p m>.
+@rvalue <p NULL>	| 	Can't adjust length of mbuf or the whole mbuf chain is trimmed and freed.
+@rvalue <p m>		| 	When success, returns the first mbuf <p m> with data.
+@comm
+Same as mBuf_adjTail, but also frees unused mbufs and clusters
+
+@devnote  mBuf_trimTail is implemented with mBuf_split and mBuf_freeMbufChain. It first splits the mbuf
+to two mbuf chains from indicated position and frees the latter one.
+There is a possible risk that mBuf_trimTail may fail when the mbuf chain <p m> consumes all mbufs and no free mbufs
+is available for mBuf_split to work correctly.
+
+@xref
+  <c mBuf_adjHead>,   <c mBuf_adjTail>,  <c mBuf_trimTail>
+*/
+
+
+
+extern int32 mBuf_copyToMbuf(struct rtl_mBuf *, uint32 offset, uint32 len, int8 *cp);
+
+/*
+@func int32			| mBuf_copyToMbuf	| Copy <p len> bytes of data from user's buffer <p cp> to mbuf chain <p m>, started form offset <p offset>.
+@parm struct rtl_mBuf * 	| m		| Address of the mbuf chain.
+@parm uint32			|offset	| Starting byte to be copied in mbuf chain <p m>. Start from 0
+@parm uint32			|len		| Number of bytes to be copied from <p cp>
+@parm int8 * 		|cp		| Address of user's buffer.
+@rdesc Returns number of bytes successfully copied
+@rvalue <p -1>		| 	Failed.
+@rvalue <p n>		| 	<p n> bytes have been copied from <p cp> into indicated mbuf chain <p m>
+@comm
+Copy <p len> bytes from user's buffer <p cp>, to the indicated mbuf chain
+<p m> beginning from the <p offset>-th data byte in mbuf chain.
+If there aren't at least 'offset' bytes in mbuf chain, -1 is returned.
+mBuf_copyToMbuf() extends mbuf chain if neccessary.
+@comm
+Be careful, when clusters are allocated externally by OS, mbuf module doesn't know which mbuf
+is the first referee and owns the write priviledge to cluster. Therefore, write priviledge
+is granted to ALL cluster referees.
+
+@ex The following example demonstrates how to use this function |
+	#define SIZE	100
+	int32 i;
+	int8 my_buffer[SIZE];
+	for(i=0; i<SIZE; i++)
+		my_buffer[i] = i;
+	if (100!=mBuf_copyToMbuf(m, 10, 100, my_buffer))	//copy 100 bytes from my_buffer to mbuf m, started from the 10th bytes in mbuf
+		printf("Can't copy all data!");
+  @xref
+  <c mBuf_copyToUserBuffer>
+ */
+
+
+
+extern int32 mBuf_copyToUserBuffer(struct rtl_mBuf *m, uint32 off, uint32 len, int8 * cp);
+
+/*
+@func int32			| mBuf_copyToUserBuffer	| Copy some data from an mbuf chain <p m> to user's buffer <p cp>.
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain.
+@parm uint32			|offset	| The number of starting data byte in mbuf chain <p m>. Start from 0.
+@parm uint32			|len		| The number of data bytes to be copied. If <p len>=M_COPYALL, then copy all data till the end of mbuf chain.
+@parm int8 *			|cp		| User specified buffer address.
+@rdesc Returns number of bytes successfully received and copied to user's buffer
+@rvalue <p -1>		| 	Failed.
+@rvalue <p n>		| 	<p n> bytes have been copied from <p m> into indicated buffer <p cp> successfully.
+@comm
+Copy data from an mbuf chain starting from the <p offset>-th data byte,
+continuing for <p len> bytes, into the indicated buffer <p cp>. User should be sure that there is enough free space in
+the specified buffer <p cp>.
+
+@ex The following example demonstrates how to use this function |
+	int8 my_buffer[100];
+	mBuf_copyToUserBuffer(m, 10, 100, my_buffer); //copy 100 bytes from the 10-th byte in mbuf to user's cp buffer.
+
+  @xref
+  <c mBuf_copyToMbuf>
+ */
+
+extern struct rtl_mBuf *mBuf_cloneMbufChain(struct rtl_mBuf *pThisMbuf, int32 iOffset,
+							int32 iLength, int32 iWait);
+
+/*
+@func struct rtl_mBuf *	| mBuf_cloneMbufChain	| Clone a part of mbuf chain <p m>
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain.
+@parm int32			|offset	| The number of starting data byte in mbuf chain <p m>. Start from 0
+@parm int32			|len		| The number of data bytes to be cloned. If <p len>=M_COPYALL, then clone all data till the end of mbuf chain.
+@parm int32			|how	| <p MBUF_WAIT> or <p MBUF_DONTWAIT> and/or <p M_ALLOCPKTHDR>
+@rdesc Returns address of the new, cloned mbuf chain <p n>.
+@rvalue <p NULL>		| 	Can't clone mbuf chain <p m>.
+@rvalue <p n>		| 	The address of cloned mbuf chain <p n>. Data in <p n> is read only.
+@comm
+Make a clone of an mbuf chain starting from <p offset>-th byte from the beginning,
+continuing for <p len> bytes.  If <p len> is M_COPYALL, then clone to end of the whole mbuf chain. (You may choose to use the optimized mBuf_clonePacket() in this case)
+The <p how> parameter is a choice of MBUF_WAIT or MBUF_DONTWAIT and/or M_ALLOCPKTHDR by the caller.
+If M_ALLOCPKTHDR flag is given, a new pkthdr would be allocated for duplicated packet.
+
+Note that the clone is read-only, The new mbuf chain <p n> only shares cluster data with <p m>.
+<p n> can only read cluster data, but not write. <p m> still owns write priviledge.
+
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *n;
+
+	n = mBuf_cloneMbufChain(m, 20, M_COPYALL, MBUF_WAIT);
+	if (n != NULL) {
+		// do following processing
+	}
+  @xref
+  <c mBuf_clonePacket>, <c mBuf_dupPacket>, <c mBuf_cloneMbufChain>
+ */
+
+extern struct rtl_mBuf *mBuf_dupMbufChain(struct rtl_mBuf *pMbufChain, int32 iOffset, int32 iLength,  int32 flag);
+
+/*
+@func struct rtl_mBuf *	| mBuf_dupMbufChain	| Duplicate a part of mbuf chain <p m>
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain.
+@parm int32			|offset	| The number of starting data byte in mbuf chain <p m>. Start from 0
+@parm int32			|len		| The number of data bytes to be cloned. If <p len>=M_COPYALL, then duplicate all data till the end of mbuf chain.
+@parm int32			|how	| <p MBUF_WAIT> or <p MBUF_DONTWAIT> and/or <p M_ALLOCPKTHDR>
+@rdesc Returns address of the new, duplicated mbuf chain <p n>.
+@rvalue <p NULL>		| 	Can't duplicate mbuf chain <p m>.
+@rvalue <p n>		| 	The address of duplicated mbuf chain <p n>. Data in <p n> is writable.
+@comm
+Duplicate an mbuf chain starting from <p offset>-th byte from the beginning,
+continuing for <p len> bytes.  If <p len> is M_COPYALL, then duplicate to end of the whole mbuf chain. (You may choose to use the optimized mBuf_dupPacket() in this case)
+The <p how> parameter is a choice of MBUF_WAIT or MBUF_DONTWAIT and/or M_ALLOCPKTHDR by the caller.
+If M_ALLOCPKTHDR flag is given, a new pkthdr would be allocated for duplicated packet.
+
+Note that the duplicated mbuf is writable..
+
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *n;
+
+	n = mBuf_dupMbufChain(m, 20, M_COPYALL, MBUF_WAIT);
+	if (n != NULL) {
+		// do following processing
+	}
+  @xref
+  <c mBuf_clonePacket>, <c mBuf_dupPacket>, <c mBuf_cloneMbufChain>
+ */
+
+
+
+extern struct rtl_mBuf *mBuf_clonePacket(struct rtl_mBuf *pMbuf, int32 iHow);
+
+/*
+@func struct rtl_mBuf *	| mBuf_clonePacket	| Clone the entire packet <p m>
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain.
+@parm int32			|how	| <p MBUF_WAIT> or <p MBUF_DONTWAIT>
+@rdesc Returns address of the new mbuf chain <p n>.
+@rvalue <p NULL>		| 	Can't clone mbuf chain <p m>.
+@rvalue <p n>		| 	The address of copied mbuf chain <p n>. Data in <p n> is read only.
+@comm
+Clone an entire mbuf chain <p m>, including the packet header (which must be present).
+An optimization of the common case `mBuf_cloneMbufChain(m, 0, M_COPYALL, how)'.
+The new cloned packet always allocates a new pkthdr.
+Note that the copy is read-only, because clusters are not copied, only their reference counts are incremented.
+
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *n;
+	n = mBuf_clonePacket(m, MBUF_WAIT);
+	if (n != NULL) {
+		// do following processing
+	}
+  @xref
+  <c mBuf_dupPacket>, <c mBuf_cloneMbufChain>, <c mBuf_dupMbufChain>
+ */
+
+extern struct rtl_mBuf *mBuf_dupPacket(struct rtl_mBuf *pMbuf, int32 iHow);
+
+/*
+@func struct rtl_mBuf *	| mBuf_dupPacket	| Duplicate an mbuf chain <p m>, including its data,  into a completely new chain <p n>
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain.
+@parm int32			|how	| <p MBUF_WAIT> or <p MBUF_DONTWAIT>
+@rdesc Returns address of the new mbuf chain <p n>.
+@rvalue <p NULL>		| 	Can't duplicate mbuf chain <p m>.
+@rvalue <p n>		| 	The address of copied mbuf chain <p n>. Data in <p n> is writable.
+@comm
+Duplicate an mbuf chain <p m> into a completely new chain <p n>, including
+copying data in any <p m>'s mbuf clusters.
+The new duplicated packet always allocates a new pkthdr.
+Use this instead of mBuf_clonePacket() when you need a writable copy of an mbuf chain.
+
+@ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *n;
+	n = mBuf_dupPacket(m, MBUF_WAIT);
+	if (n != NULL) {
+		// do following processing
+	}
+  @xref
+  <c mBuf_clonePacket> , <c mBuf_copyToUserBuffer>, <c mBuf_cloneMbufChain>
+ */
+
+
+
+
+
+extern struct rtl_mBuf *mBuf_prepend(struct rtl_mBuf *m, uint32 plen, int32 how);
+
+/*
+@func struct rtl_mBuf *	| mBuf_prepend	| Arrange to prepend space of size <p plen> to mbuf <p m>.
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain.
+@parm uint32			|plen	| Number of bytes to be prepended before <p m>
+@parm int32			|how	| <p MBUF_WAIT>, <p MBUF_DONTWAIT>, <p M_GETNEWMBUF>
+@rdesc Returns address of the first mbuf.
+@rvalue <p NULL>		| 	Can't allocate memory or parameter problem.
+@rvalue <p n>		| 	The address of first mbuf after prepending.
+@comm
+Arrange to prepend space of size <p plen> to mbuf <p m>.
+ If new mbufs must be allocated, <p how> specifies whether to wait or not. When user calls mBuf_prepend, the
+ data length recorded in mbufs and pkthdr is incremented accordingly.
+
+By default, mBuf_prepend uses any leading free space before allocating any new clusters.
+But if <p M_GETNEWMBUF> is set, mBuf_prepend allocates new mbufs directly and leaves any leading free buffer space as is.
+
+If <p how> has MBUF_DONTWAIT bit set, and we can't get all buffers immediately, return NULL.
+If <p how> has MBUF_WAITOK bit set, and we can't get all buffers right away, block waiting until our request is satisfied.
+
+M_BUFONLY can't be used with mBuf_prepend.
+
+@ex The following example demonstrates how to use this function |
+	m0 = mBuf_prepend(m0, PPP_HDRLEN, MBUF_DONTWAIT | M_GETNEWMBUF);
+	if (m0 == 0) {
+	    error = ENOBUFS;
+	    goto bad;
+	}
+  @xref <c mBuf_cat>, <c mBuf_padding>
+
+ */
+
+extern struct rtl_mBuf *mBuf_padding(struct rtl_mBuf *m, uint32 plen, int32 how);
+/*
+@func struct rtl_mBuf *	| mBuf_padding	| Arrange to append space of size <p plen> to mbuf <p m>.
+@parm struct rtl_mBuf * 	| m		| Pointer to an mbuf chain.
+@parm uint32			|plen	| Number of bytes to append at <p m>
+@parm int32			|how	| <p MBUF_WAIT> or <p MBUF_DONTWAIT>
+@rdesc Returns address of the last mbuf padded.
+@rvalue <p NULL>		| 	Can't allocate memory or parameter problem.
+@rvalue <p n>		| 	The address of last mbuf after padding
+@comm
+Arrange to append space of size <p plen> to mbuf <p m>.
+ If new mbufs must be allocated, <p how> specifies whether to wait or not. When user calls mBuf_padding, the
+ data length recorded in mbufs and pkthdr are incremented accordingly.
+
+ M_BUFONLY can't be used with mBuf_padding.
+@devnote  API CHANGED:  If <p how> is MBUF_DONTWAIT and allocation fails, NULL is returned.
+Original mbuf <p m> is intact.
+
+@ex The following example demonstrates how to use this function |
+	m0 = mBuf_padding(m, (ETHER_MIN_LEN-ETHER_CRC_LEN-len), MBUF_DONTWAIT);
+	if (m0 == 0) {
+	    error = ENOBUFS;
+	    goto bad;
+	}
+@xref <c mBuf_split>, <c mBuf_cat>, <c mBuf_getm>, <c mBuf_prepend>, <c mBuf_split>
+
+
+ */
+
+
+extern struct rtl_mBuf *mBuf_cat(struct rtl_mBuf *m, struct rtl_mBuf *n);
+
+/*
+@func struct rtl_mBuf *	| mBuf_cat	| Concatenate mbuf chain <p n> to <p m>.
+@parm struct rtl_mBuf * 	| m		| mbuf chain to be appended.
+@parm struct rtl_mBuf * 	| n		| mbuf chain to be appended after <p m>
+@rdesc Returns the address of <p m> or NULL if failed.
+@rvalue <p NULL>		| 	Can't concatenate two mbuf chain
+@rvalue <p m>		| 	When success, the address of <p m> is returned..
+@comm
+Concatenate mbuf chain <p n> to <p m>.
+Total packet length of <p m> would be adjusted accordingly. However, <p n>'s control header, if any, would be freed
+@xref   <c mBuf_split>, <c mBuf_padding>, <p mBuf_getm>
+
+ */
+
+
+extern int32 mBuf_pullup(struct rtl_mBuf *, int32);
+
+/*
+@func int32		| mBuf_pullup| 	Rearange an mbuf chain so that <p len> bytes are contiguous
+								 in <p m>'s first cluster.
+@parm struct rtl_mBuf * 	| m	| Pointer to an mbuf chain.
+@parm 	int32			|len	| The number of databytes requested to put in <p m>'s first cluster. <p len> should not exceed the size of a cluster buffer (256 bytes).
+@rdesc	Returns total data bytes in the first mbuf cluster.
+@rvalue <p n>		| 	The number of data bytes in <p m>'s first cluster. If <p n> is less than <p len>,
+						that means <p mBuf_pullup> can't pull up all <p len> bytes requested because there isn't
+						so much data in mbuf chain.
+@comm  Original BSD4.4 note: Rearange an mbuf chain so that <p len> bytes are contiguous and in <p m>'s cluster.
+Successing mbufs are adjusted accordingly. If the return value <p n> is smaller than requested <p len>,
+maybe there isn't enough data bytes in the mbuf chain <p m>, or maybe the requested value <p len> exceeds
+the maximum capacity for a single cluster.
+
+Our implementation note:
+(cfliu 2002.02.19)This function is important in traditional BSD networking stack because
+original mbuf can't do dtom() if data is saved in cluster. This is not the
+case here since we offer a back pointer from cluster to mbuf via cltag_mbuf field.
+However, this function is still useful if we want to collect continous databytes from later clusters
+to the specified mbuf's cluster. The maximum number of  <p len> should be less than a cluster
+can hold (ie. len less than or equal to m_clusterSIze)
+
+(2002.08.11) If 1) requested length <p len> is smaller than m_clusterSize, and 2) there are enough data in this mbuf chain. However, the
+trailing space in <p m> is not large enough, <p mBuf_pullup> will move m's data upward first and then copy requested data from latter clusters
+
+@devnote  This function is different from traditional BSD mbuf code. When pull up fails, the mbuf chain will not be freed,
+and the return value has been changed to an integer instead of a pointer to mbuf structure.
+
+@ex The following example demonstrates how to use this function |
+	int32 n;
+
+	n = mBuf_pullup(m, 128);
+	if (n < 128) {
+		//There isn't so much data in mbuf chain.
+	}
+  @xref
+  <c m_pulldown>
+ */
+
+
+struct rtl_mBuf *mBuf_split(register struct rtl_mBuf *m0, uint32 len0, int32 wait);
+
+/*@func struct rtl_mBuf * | mBuf_split | Partition an mbuf chain in two pieces. Data is cloned
+  @parm struct rtl_mBuf * 	| m    	| Pointer to an mbuf chain
+  @parm 	int32			| len    	| The number of last data byte to remain in original mbuf chain <p m>
+  @parm  int32 			| wait   	| <p MBUF_DONTWAIT> or <p MBUF_WAIT>
+  @rdesc	Returns a pointer to the splited mbuf chain <p n>
+  @rvalue NULL		| Can't split the mbuf chain
+  @rvalue <p n>		| Success. <p n> is the address of second mbuf chain. It holds all data bytes after the <p len>-th byte in <p m>.
+  @comm  Partition an mbuf chain <p m> into two pieces, returning the tail mbuf chain <p n>. In case of failure, it returns NULL and
+ attempts to restore the chain to its original state. Data in clusters  are NOT copied, but cloned only.
+
+  @ex The following example demonstrates how to use this function |
+	struct rtl_mBuf *n;
+
+	n = mBuf_split(m, off, MBUF_DONTWAIT);
+	if (n == NULL) {
+		goto bad;
+	}
+  @xref
+  <c mBuf_cat>, <c mBuf_padding>, <c mBuf_getm>
+
+ */
+void mBuf_getBMjmpTable(uint8 *pat,  uint16 *jump_tbl,uint16 patLen, uint8 caseSensitive);
+int32 mBuf_BMpatternMatch(struct rtl_mBuf *m, uint32 len, uint8 *delimiter, uint32 delimitLen, uint16 *jmp_tbl, uint8 caseSensitive);
+
+#define MBUF_GETLEN(m)	 ((m)? ((m)->m_len : -1)
+/*
+@func MACRO	| MBUF_GETLEN	| Get total number of data bytes in the mbuf <p m>
+@parm struct rtl_mBuf *	|m		| Indicate the packet
+@rdesc Returns data length of the mbuf
+@rvalue -1		| 	Failed.
+@rvalue <p length>| 	The actual length of data in <p m>
+@comm
+ Get total number of data bytes in the mbuf <p m>
+@xref  <c mBuf_getPktlen>
+*/
+
+
+ struct rtl_mBuf *mBuf_attachHeader(void *buffer, uint32 id, uint32 bufsize,uint32 datalen, uint16 align);
+struct rtl_mBuf *mBuf_attachHeaderJumbo(void *buffer, uint32 id, uint32 bufsize,uint32 datalen);
+
+int32 mBuf_setNICRxRingSize(uint32 size);
+extern int32 mBuf_reserve(struct rtl_mBuf * m, uint16 headroom);
+
+
+#define MBUF_SET_PKTHDRFLAGS(m, Flags) do{\
+	assert((m));\
+	assert(ISSET((m)->m_flags, MBUF_USED));\
+	assert((m)->m_pkthdr);\
+	MBUF_SETPKTHDRFIELD16(((memaddr *)&(m)->m_pkthdr->ph_flags), (Flags));\
+ }while(0)
+
+
+/*
+@func MACRO	| MBUF_SET_PKTHDRFLAGS	| Set packet specific flags for ASIC processing
+@parm struct rtl_mBuf *	|m		| Indicate the packet
+@parm uint32	|Flags		| flag to be set
+@rdesc None
+@comm
+Set packet specific flags for ASIC processing. This overwrites original flag value. If you are adding flag bits rather than reseting it,
+remember to save its old value first
+
+@xref  <c MBUF_GET_PKTHDRFLAGS>
+*/
+
+
+#define MBUF_GET_PKTHDRFLAGS(m)	(MBUF_CHECKPKTHDR((m))? MBUF_GETPKTHDRFIELD16((memaddr *)(&m->m_pkthdr->ph_flags)):-1)
+/*
+@func MACRO	| MBUF_GET_PKTHDRFLAGS	| Get packet specific flags set by ASIC
+@parm struct rtl_mBuf *	|m		| Indicate the packet
+@rdesc Returns the result of execution
+@rvalue -1		| 	Failed. <p m> might have no pkthdrs.
+@rvalue FLAGS	| 	Returns the flags.
+@comm
+Get packet specific flags set by ASIC
+
+@xref  <c MBUF_SET_PKTHDRFLAGS>
+*/
+
+#define MBUF_SET_PORTLIST(m,Portlist)  do{\
+	assert((m));\
+	assert(ISSET((m)->m_flags, MBUF_USED));\
+	assert((m)->m_pkthdr);\
+	(m)->m_pkthdr->ph_portlist = (Portlist);\
+}while(0)
+
+/*
+@func MACRO	| MBUF_SET_PORTLIST	| Set outgoing port list
+@parm struct rtl_mBuf *	|m		| Indicate the packet
+@parm uint32	|Portlist		| port list
+@rdesc None
+@comm  Set outgoing port list
+@xref  <c MBUF_GET_PORTLIST>
+*/
+
+#define MBUF_GET_PORTLIST(m) (MBUF_CHECKPKTHDR((m))? ((m)->m_pkthdr->ph_portlist):-1)
+/*
+@func MACRO	| MBUF_GET_PORTLIST	| get incoming port list
+@parm struct rtl_mBuf *	|m		| Indicate the packet
+@rdesc Returns the result of execution
+@rvalue 0		| 	Failed. <p m> might have no pkthdrs.
+@rvalue Portlist	| 	Returns incoming portlist.
+@comm
+ get incoming port list
+
+@xref  <c MBUF_SET_PORTLIST>
+*/
+
+
+#define MBUF_SET_TRAPREASON(m, Reason)	do{\
+	assert((m));\
+	assert(ISSET((m)->m_flags, MBUF_USED));\
+	assert((m)->m_pkthdr);\
+	MBUF_SETPKTHDRFIELD16(((memaddr *)&(m)->m_pkthdr->ph_reason), (Reason));\
+}while(0)
+
+/*
+@func MACRO	| MBUF_SET_TRAPREASON	| Set packet trapping reason for ASIC processing
+@parm struct rtl_mBuf *	|m		| Indicate the packet
+@parm uint16	|Reason		| Trapping reason
+@rdesc None
+@comm
+Set packet trapping reason for ASIC processing
+
+@xref  <c MBUF_GET_TRAPREASON>
+*/
+
+#define MBUF_GET_TRAPREASON(m)	(MBUF_CHECKPKTHDR((m))? MBUF_GETPKTHDRFIELD16((memaddr *)(&m->m_pkthdr->ph_reason)):-1)
+/*
+@func MACRO	| MBUF_GET_TRAPREASON	| Get packet trapping reason set by ASIC
+@parm struct rtl_mBuf *	|m		| Indicate the packet
+@rdesc Returns the result of execution
+@rvalue -1		| 	Failed. <p m> might have no pkthdrs.
+@rvalue Reason	| 	Returns trap reason
+@comm
+Get packet trapping reason set by ASIC
+
+@xref  <c MBUF_SET_TRAPREASON>
+*/
+
+#define	MBUF2DATAPTR(m, t)	((t)((m)->m_data))
+/*
+@func MACRO	| MBUF2DATAPTR	| Given mbuf pointer 'm', returns address of m->m_data, and convert it to type 't'
+@parm struct rtl_mBuf *	|m		| Pointer to an mbuf
+@parm TYPE	|t		| A type to be casted
+@rdesc Address of m->m_data
+@comm
+Given mbuf pointer 'm', returns address of m->m_data, and convert it to type 't'
+@xref  <c mBuf_data2Mbuf>
+*/
+
+
+#define	MBUF_ALIGN(m, len) do {	\
+	assert((m)->m_len==0);\
+	assert(len>0);\
+	assert(((m)->m_extsize - (len))>0);\
+	(m)->m_data += ( (m)->m_extsize - (len)) & ~(sizeof(memaddr) - 1);	\
+} while (0)
+
+/*
+@func MACRO	| MBUF_ALIGN	| Align the m->m_data pointer from end of the cluster, for 'len' bytes.
+@parm struct rtl_mBuf *	|m		| Pointer to an mbuf
+@parm uint32	|len		| Size to be aligned.
+@rdesc None
+@comm
+Set the m_data pointer of a NEWLY-allocated cluster  to place
+an object of the specified size at the end of the mbuf, longword aligned.
+@xref  <c MBUF_RESERVE>
+*/
+
+
+#define	MBUF_RESERVE(m, len) do {	\
+	assert(len>0);\
+	(m)->m_data += ( ((len) > (m)->m_extsize)? (m)->m_extsize : len);	\
+} while (0)
+/*
+@func MACRO	| MBUF_RESERVE	| Reserve 'len' bytes from the beginning of the newly allocated cluster
+@parm struct rtl_mBuf *	|m		| Pointer to an mbuf
+@parm uint32	|len		| Size to be aligned.
+@rdesc None
+@comm
+Forward move the m_data pointer of a NEWLY-allocated cluster  for 'len' bytes.
+m_data won't move beyond m_extbuf + m_extsize, make sure 'len' you give is a reasonable value
+@xref  <c MBUF_ALIGN>
+*/
+#endif			   /* !_MBUF_H_ */
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/rtl8651_tblDrvProto.h b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl8651_tblDrvProto.h
new file mode 100644
index 00000000..5c95a09
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl8651_tblDrvProto.h
@@ -0,0 +1,587 @@
+/*
+* Program : Protocol Header rtl8651_proto.h
+* Abstract :
+* Author : Chih-Hua Huang (chhuang@realtek.com.tw)
+* $Id: rtl8651_tblDrvProto.h,v 1.1 2007-12-21 10:29:52 davidhsu Exp $
+*
+*  Copyright (c) 2011 Realtek Semiconductor Corp.
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License version 2 as
+*  published by the Free Software Foundation.
+
+*/
+
+#ifndef RTL8651_TBLDRV_PROTO_H
+#define RTL8651_TBLDRV_PROTO_H
+
+#include <linux/in.h>
+#include <net/rtl/rtl_types.h>
+
+/*==========================================================================================
+ * Ethernet Header for MAC ACL lookup
+ *==========================================================================================*/
+#define ETHER_ADDR_LEN				6
+struct	ether_header {
+	uint8	ether_dhost[ETHER_ADDR_LEN];
+	uint8	ether_shost[ETHER_ADDR_LEN];
+	uint16	ether_type;
+};
+
+/* The number of bytes in the type field. */
+#define	ETHER_TYPE_LEN		2
+
+/* The length of the combined header. */
+#define	ETHER_HDR_LEN		(ETHER_ADDR_LEN*2+ETHER_TYPE_LEN)
+#define	ETHER_VLAN_HDR_LEN	(ETHER_HDR_LEN+4)
+
+
+#ifndef UTILITY_H /* pktproc/utility.h also defined this structure. */
+struct  ether_addr {
+        uint8 octet[ETHER_ADDR_LEN];
+};
+#endif
+
+typedef struct pppoeHdr_s {
+  #ifdef _LITTLE_ENDIAN
+	uint8	type:4, ver:4;
+  #else
+	uint8	ver:4, type:4;
+  #endif
+	uint8	code;
+	uint16	sessionId,
+			length; //Length of the PPPoE payload, does not include Ethernet and PPPoE header
+	uint16	proto;	//PPP protocol field
+} pppoeHdr_t;
+
+typedef struct vlanHdr_s {
+#ifdef _LITTLE_ENDIAN
+	uint16	vidh:4;
+	uint16	cfi:1;
+	uint16	priority:3;
+	uint16	vidl:8;
+#else
+	uint16	priority:3;
+	uint16	cfi:1;
+	uint16	vidh:4;
+	uint16	vidl:8;
+#endif
+	uint16	ether_type;
+} vlanHdr_t;
+
+
+/*==========================================================================================
+ * IP Header for IP ACL lookup
+ *==========================================================================================*/
+//#ifndef UTILITY_H /* pktproc/utility.h also defined this structure. */
+#if !defined(_LINUX_IN_H)
+struct in_addr{
+	uint32    s_addr;
+};
+
+/* AF_INET Supported IP Protocols*/
+#define IPPROTO_ICMP 1
+#define IPPROTO_IGMP 2
+#define IPPROTO_TCP	6
+#define IPPROTO_UDP	17
+#endif
+
+struct ip {
+
+#if 0
+union{
+   uint8 _vhl;   /* version << 4 | header length >> 2 */
+#ifdef _LITTLE_ENDIAN
+	struct {
+	  uint8  _hl:4,  /* header length */
+	   _ver:4;	/* version */
+	}s;
+#else
+	struct {
+	  uint8 _ver:4,  /* version */
+	  _hl:4;/* header length */
+	}s;
+#endif
+ } vhl;
+
+#define ip_vhl vhl._vhl
+#define ip_hl  vhl.s._hl
+#define ip_ver vhl.s._ver
+#else
+	/* replace bit field */
+	uint8 ip_vhl;
+#endif
+
+	uint8	ip_tos;			/* type of service */
+	uint16	ip_len;			/* total length */
+	uint16	ip_id;			/* identification */
+	uint16	ip_off;			/* fragment offset field */
+	uint8	ip_ttl;			/* time to live */
+	uint8	ip_p;			/* protocol */
+	uint16	ip_sum;			/* checksum */
+	struct	in_addr ip_src,ip_dst;	/* source and dest address */
+};
+typedef struct ip ip_t;
+
+#define	IP_RF 0x8000			/* reserved fragment flag */
+#define	IP_DF 0x4000			/* dont fragment flag */
+#define	IP_MF 0x2000			/* more fragments flag */
+#define	IP_OFFMASK 0x1fff		/* mask for fragmenting bits */
+
+
+
+/*==========================================================================================
+ * IP Header for IP ACL lookup
+ *==========================================================================================*/
+struct icmp_ra_addr {
+	uint32 ira_addr;
+	uint32 ira_preference;
+};
+
+struct icmp {
+	uint8	icmp_type;		/* type of message, see below */
+	uint8	icmp_code;		/* type sub code */
+	uint16	icmp_cksum;		/* ones complement cksum of struct */
+	union {
+		uint8 ih_pptr;			/* ICMP_PARAMPROB */
+		struct in_addr ih_gwaddr;	/* ICMP_REDIRECT */
+		struct ih_idseq {
+			uint16	icd_id;
+			uint16	icd_seq;
+		} ih_idseq;
+		uint32 ih_void;
+
+		/* ICMP_UNREACH_NEEDFRAG -- Path MTU Discovery (RFC1191) */
+		struct ih_pmtu {
+			uint16 ipm_void;
+			uint16 ipm_nextmtu;
+		} ih_pmtu;
+
+		struct ih_rtradv {
+			uint8 irt_num_addrs;
+			uint8 irt_wpa;
+			uint16 irt_lifetime;
+		} ih_rtradv;
+	} icmp_hun;
+#define	icmp_pptr	icmp_hun.ih_pptr
+#define	icmp_gwaddr	icmp_hun.ih_gwaddr
+#define	icmp_id		icmp_hun.ih_idseq.icd_id
+#define	icmp_seq	icmp_hun.ih_idseq.icd_seq
+#define	icmp_void	icmp_hun.ih_void
+#define	icmp_pmvoid	icmp_hun.ih_pmtu.ipm_void
+#define	icmp_nextmtu	icmp_hun.ih_pmtu.ipm_nextmtu
+#define	icmp_num_addrs	icmp_hun.ih_rtradv.irt_num_addrs
+#define	icmp_wpa	icmp_hun.ih_rtradv.irt_wpa
+#define	icmp_lifetime	icmp_hun.ih_rtradv.irt_lifetime
+	union {
+		struct id_ts {
+			uint32 its_otime;
+			uint32 its_rtime;
+			uint32 its_ttime;
+		} id_ts;
+		struct id_ip  {
+			struct ip idi_ip;
+			/* options and then 64 bits of data */
+		} id_ip;
+		struct icmp_ra_addr id_radv;
+		uint32 id_mask;
+		int8	id_data[1];
+	} icmp_dun;
+#define	icmp_otime	icmp_dun.id_ts.its_otime
+#define	icmp_rtime	icmp_dun.id_ts.its_rtime
+#define	icmp_ttime	icmp_dun.id_ts.its_ttime
+#define	icmp_ip		icmp_dun.id_ip.idi_ip
+#define	icmp_radv	icmp_dun.id_radv
+#define	icmp_mask	icmp_dun.id_mask
+#define	icmp_data	icmp_dun.id_data
+};
+
+
+/*
+ * Definition of type and code field values.
+ */
+#define	ICMP_ECHOREPLY		0		/* echo reply */
+#define	ICMP_UNREACH		3		/* dest unreachable, codes: */
+#define		ICMP_UNREACH_NET	0		/* bad net */
+#define		ICMP_UNREACH_HOST	1		/* bad host */
+#define		ICMP_UNREACH_PROTOCOL	2		/* bad protocol */
+#define		ICMP_UNREACH_PORT	3		/* bad port */
+#define		ICMP_UNREACH_NEEDFRAG	4		/* IP_DF caused drop */
+#define		ICMP_UNREACH_SRCFAIL	5		/* src route failed */
+#define		ICMP_UNREACH_NET_UNKNOWN 6		/* unknown net */
+#define		ICMP_UNREACH_HOST_UNKNOWN 7		/* unknown host */
+#define		ICMP_UNREACH_ISOLATED	8		/* src host isolated */
+#define		ICMP_UNREACH_NET_PROHIB	9		/* prohibited access */
+#define		ICMP_UNREACH_HOST_PROHIB 10		/* ditto */
+#define		ICMP_UNREACH_TOSNET	11		/* bad tos for net */
+#define		ICMP_UNREACH_TOSHOST	12		/* bad tos for host */
+#define		ICMP_UNREACH_FILTER_PROHIB 13		/* admin prohib */
+#define		ICMP_UNREACH_HOST_PRECEDENCE 14		/* host prec vio. */
+#define		ICMP_UNREACH_PRECEDENCE_CUTOFF 15	/* prec cutoff */
+#define	ICMP_SOURCEQUENCH	4		/* packet lost, slow down */
+#define	ICMP_REDIRECT		5		/* shorter route, codes: */
+#define		ICMP_REDIRECT_NET	0		/* for network */
+#define		ICMP_REDIRECT_HOST	1		/* for host */
+#define		ICMP_REDIRECT_TOSNET	2		/* for tos and net */
+#define		ICMP_REDIRECT_TOSHOST	3		/* for tos and host */
+#define	ICMP_ECHO		8		/* echo service */
+#define	ICMP_ROUTERADVERT	9		/* router advertisement */
+#define	ICMP_ROUTERSOLICIT	10		/* router solicitation */
+#define	ICMP_TIMXCEED		11		/* time exceeded, code: */
+#define		ICMP_TIMXCEED_INTRANS	0		/* ttl==0 in transit */
+#define		ICMP_TIMXCEED_REASS	1		/* ttl==0 in reass */
+#define	ICMP_PARAMPROB		12		/* ip header bad */
+#define		ICMP_PARAMPROB_ERRATPTR 0		/* error at param ptr */
+#define		ICMP_PARAMPROB_OPTABSENT 1		/* req. opt. absent */
+#define		ICMP_PARAMPROB_LENGTH 2			/* bad length */
+#define	ICMP_TSTAMP		13		/* timestamp request */
+#define	ICMP_TSTAMPREPLY	14		/* timestamp reply */
+#define	ICMP_IREQ		15		/* information request */
+#define	ICMP_IREQREPLY		16		/* information reply */
+#define	ICMP_MASKREQ		17		/* address mask request */
+#define	ICMP_MASKREPLY		18		/* address mask reply */
+
+#define	ICMP_MAXTYPE		18
+
+/*==========================================================================================
+ * IP Header for IP ACL lookup
+ *==========================================================================================*/
+// igmp v3 group record
+struct igmp_gr {
+	uint8	igmp_gr_rt;				/* Record Type */
+	uint8	igmp_gr_auxlen;			/* aux data length */
+	uint16	igmp_gr_nofs;			/* number of sources */
+	ipaddr_t	igmp_gr_group;			/* group address being reported */
+	ipaddr_t	src_list;					/* first entry of src list */
+	//	auxiliary data is unused now
+ };
+struct igmp {
+	uint8		igmp_type;			/* version & type of IGMP message */
+	uint8		igmp_code;			/* subtype for routing msgs */
+	uint16		igmp_cksum;		/* IP-style checksum */
+
+	union {
+		struct in_addr	group;		/* group address being presented (v1/v2/v3 query) */
+		struct v3_report{
+			uint16			resv;	/* reserved */
+			uint16			nofg;	/* number of group records */
+		} v3_report;
+	} grp;
+
+	union {
+		struct query {
+			uint8	rsq;				/* 4bit: reserved, 1bit: suppress router-side processing, 3bit: querier's robustness variable*/
+//			uint8	resv:4;			/* reserved */
+//			uint8	s:1;				/* suppress router-side processing */
+//			uint8	qrv:3;			/* querier's robustness variable */
+			uint8	qqic;			/* querier's query interval code */
+			uint16	nofs;			/* number of sources */
+			ipaddr_t	src_list;			/* first entry of src list */
+		} query;
+		struct report {
+			struct igmp_gr	gr_list;	/* first entry of group record */
+		} report;
+	} un_v3;
+
+	#define	igmp_group		grp.group
+	#define	igmp_qrsq		un_v3.query.rsq
+//	#define	igmp_qresv		un_v3.query.resv
+//	#define	igmp_qsflag		un_v3.query.s
+//	#define	igmp_qrv		un_v3.query.qrv
+	#define	igmp_qqic		un_v3.query.qqic
+	#define	igmp_qnofs		un_v3.query.nofs
+	#define	igmp_qsrclist	un_v3.query.src_list
+	#define	igmp_rnofg		grp.v3_report.nofg
+	#define	igmp_rresv		grp.v3_report.resv
+	#define	igmp_grlist		un_v3.report.gr_list
+
+};
+
+/* IGMP Type */
+#define	IGMP_QUERY				0x11		/* igmp group membership query */
+#define	IGMP_V1_REPORT		0x12		/* igmp v1 membership report */
+#define	IGMP_DVMRP			0x13		/* DVMRP */
+#define	IGMP_PIMV1				0x14		/* PIM v1 */
+#define	IGMP_CISCOTRACE		0x15		/* CISCO trace messages */
+#define	IGMP_V2_REPORT		0x16		/* igmp v2 membership report */
+#define	IGMP_V2_LEAVE			0x17		/* igmp v2 leave group message */
+#define	IGMP_MTRACE_RESPONSE	0x1e		/* multicast traceroute response */
+#define	IGMP_MTRACE			0x1f		/* multicast traceroute */
+#define	IGMP_V3_REPORT		0x22		/* igmp v3 membership report */
+#define	IGMP_MROUTER_ADV		0x24		/* igmp multicast router advertisement */
+#define	IGMP_MROUTER_SOL		0x25		/* igmp multicast router solicitation */
+#define	IGMP_MROUTER_TERM	0x26		/* igmp multicast router termination */
+
+/* IGMP v3 Group Record Type */
+#define	IGMPV3_MODE_IS_INCLUDE			0x01
+#define	IGMPV3_MODE_IS_EXCLUDE			0x02
+#define	IGMPV3_CHANGE_TO_INCLUDE_MODE	0x03
+#define	IGMPV3_CHANGE_TO_EXCLUDE_MODE	0x04
+#define	IGMPV3_ALLOW_NEW_SOURCES		0x05
+#define	IGMPV3_BLOCK_OLD_SOURCES		0x06
+
+/*==========================================================================================
+ * IP Header for IP ACL lookup
+ *==========================================================================================*/
+typedef	uint32 tcp_seq;
+struct tcphdr {
+	uint16	th_sport;		/* source port */
+	uint16	th_dport;		/* destination port */
+	tcp_seq	th_seq;			/* sequence number */
+	tcp_seq	th_ack;			/* acknowledgement number */
+#if 0
+	#ifdef  _LITTLE_ENDIAN
+		uint8	th_x2:4,		/* (unused) */
+			th_off:4;			/* data offset */
+	#else
+		uint8	th_off:4,		/* data offset */
+			th_x2:4;			/* (unused) */
+	#endif
+#else
+	/* replace bit field */
+	uint8  th_off_x;
+
+#endif
+
+	uint8	th_flags;
+		#define	TH_FIN	0x01
+		#define	TH_SYN	0x02
+		#define	TH_RST	0x04
+		#define	TH_PUSH 0x08
+		#define	TH_ACK	0x10
+		#define	TH_URG	0x20
+		#define	TH_ECE	0x40
+		#define	TH_CWR	0x80
+		#define	TH_FLAGS	(TH_FIN|TH_SYN|TH_RST|TH_ACK|TH_URG|TH_ECE|TH_CWR)
+
+	uint16	th_win;			/* window */
+	uint16	th_sum;			/* checksum */
+	uint16	th_urp;			/* urgent pointer */
+
+	//Optional TCP options. Max: 40 bytes.
+	#define	TCPOPT_EOL			0
+	#define	TCPOPT_NOP			1
+	#define	TCPOPT_MAXSEG		2
+	#define TCPOLEN_MAXSEG	4
+	#define TCPOPT_WINDOW	3
+	#define TCPOLEN_WINDOW	3
+	#define TCPOPT_SACK_PERMITTED		4		/* Experimental */
+	#define TCPOLEN_SACK_PERMITTED	2
+	#define TCPOPT_SACK		5		/* Experimental */
+	#define TCPOPT_TIMESTAMP	8
+	#define TCPOLEN_TIMESTAMP		10
+	#define TCPOLEN_TSTAMP_APPA	(TCPOLEN_TIMESTAMP+2) /* appendix A */
+	#define TCPOPT_TSTAMP_HDR	\
+	    (TCPOPT_NOP<<24|TCPOPT_NOP<<16|TCPOPT_TIMESTAMP<<8|TCPOLEN_TIMESTAMP)
+
+	#define	TCPOPT_CC		11		/* CC options: RFC-1644 */
+	#define TCPOPT_CCNEW	12
+	#define TCPOPT_CCECHO	13
+	#define TCPOLEN_CC		6
+	#define	TCPOLEN_CC_APPA		(TCPOLEN_CC+2)
+	#define	TCPOPT_CC_HDR(ccopt)		\
+	    (TCPOPT_NOP<<24|TCPOPT_NOP<<16|(ccopt)<<8|TCPOLEN_CC)
+};
+
+
+/*==========================================================================================
+ * IP Header for IP ACL lookup
+ *==========================================================================================*/
+struct udphdr
+{
+	uint16    uh_sport;				   /* source port */
+	uint16    uh_dport;				   /* destination port */
+	uint16    uh_ulen;				   /* udp length */
+	uint16    uh_sum;				   /* udp checksum */
+};
+
+/*==========================================================================================
+ * TFTP header for RRQ/WRQ
+ *==========================================================================================*/
+
+struct tftpRequest {
+	uint16	opcode;
+	char 	*string;
+};
+
+#define TFTP_RRQ	0x01
+#define TFTP_WRQ	0x02
+#define TFTP_DATA	0x03
+#define TFTP_ACK	0x04
+#define TFTP_ERR	0x05
+
+/*==========================================================================================
+ * AH Header
+ *==========================================================================================*/
+#define AH_AUTHLEN  	12              	/* authenticator length of 96bits */
+#define AH_BASIC_LEN 8      			/* basic AH header is 8 bytes, nh,hl,rv,spi and the ah_hl, says how many bytes after that to cover. */
+typedef struct ahHdr_s			/* Generic AH header */
+{
+	uint8	ah_nh;					/* Next header (protocol) */
+	uint8	ah_hl;					/* AH length, in 32-bit words */
+	uint16	ah_rv;				/* reserved, must be 0 */
+	uint32	ah_spi;				/* Security Parameters Index */
+        uint32   ah_rpl;                 		/* Replay prevention */
+	uint8	ah_data[AH_AUTHLEN];		/* Authentication hash */
+} ahHdr_t;
+
+/*==========================================================================================
+ * ESP Header
+ *==========================================================================================*/
+typedef struct espHdr_s
+{
+	uint32 spi;
+	uint32 seq;
+} espHdr_t;
+
+typedef struct cbcHdr64_s
+{
+	uint32 iv[2];
+} cbcHdr64_t;
+
+typedef struct cbcHdr128_s
+{
+	uint32 iv[4];
+} cbcHdr128_t;
+
+
+#if 0
+#define ntohs(x)	(x)
+#define ntohl(x)	(x)
+#define htons(x)	(x)
+#define htonl(x)	(x)
+
+#define NTOHL(d)
+#define NTOHS(d)
+#define HTONL(d)
+#define HTONS(d)
+#endif
+
+#if !defined(_LINUX_IN_H)
+/*
+ * Protocols (RFC 1700)
+ */
+#define	IPPROTO_IP		0		/* dummy for IP */
+#define	IPPROTO_HOPOPTS		0		/* IP6 hop-by-hop options */
+#define	IPPROTO_ICMP		1		/* control message protocol */
+#define	IPPROTO_IGMP		2		/* group mgmt protocol */
+#define	IPPROTO_GGP		3		/* gateway^2 (deprecated) */
+#define IPPROTO_IPV4		4 		/* IPv4 encapsulation */
+#define IPPROTO_IPIP		IPPROTO_IPV4	/* for compatibility */
+#define	IPPROTO_TCP		6		/* tcp */
+#define	IPPROTO_ST		7		/* Stream protocol II */
+#define	IPPROTO_EGP		8		/* exterior gateway protocol */
+#define	IPPROTO_PIGP		9		/* private interior gateway */
+#define	IPPROTO_RCCMON		10		/* BBN RCC Monitoring */
+#define	IPPROTO_NVPII		11		/* network voice protocol*/
+#define	IPPROTO_PUP		12		/* pup */
+#define	IPPROTO_ARGUS		13		/* Argus */
+#define	IPPROTO_EMCON		14		/* EMCON */
+#define	IPPROTO_XNET		15		/* Cross Net Debugger */
+#define	IPPROTO_CHAOS		16		/* Chaos*/
+#define	IPPROTO_UDP		17		/* user datagram protocol */
+#define	IPPROTO_MUX		18		/* Multiplexing */
+#define	IPPROTO_MEAS		19		/* DCN Measurement Subsystems */
+#define	IPPROTO_HMP		20		/* Host Monitoring */
+#define	IPPROTO_PRM		21		/* Packet Radio Measurement */
+#define	IPPROTO_IDP		22		/* xns idp */
+#define	IPPROTO_TRUNK1		23		/* Trunk-1 */
+#define	IPPROTO_TRUNK2		24		/* Trunk-2 */
+#define	IPPROTO_LEAF1		25		/* Leaf-1 */
+#define	IPPROTO_LEAF2		26		/* Leaf-2 */
+#define	IPPROTO_RDP		27		/* Reliable Data */
+#define	IPPROTO_IRTP		28		/* Reliable Transaction */
+#define	IPPROTO_TP		29 		/* tp-4 w/ class negotiation */
+#define	IPPROTO_BLT		30		/* Bulk Data Transfer */
+#define	IPPROTO_NSP		31		/* Network Services */
+#define	IPPROTO_INP		32		/* Merit Internodal */
+#define	IPPROTO_SEP		33		/* Sequential Exchange */
+#define	IPPROTO_3PC		34		/* Third Party Connect */
+#define	IPPROTO_IDPR		35		/* InterDomain Policy Routing */
+#define	IPPROTO_XTP		36		/* XTP */
+#define	IPPROTO_DDP		37		/* Datagram Delivery */
+#define	IPPROTO_CMTP		38		/* Control Message Transport */
+#define	IPPROTO_TPXX		39		/* TP++ Transport */
+#define	IPPROTO_IL		40		/* IL transport protocol */
+#define	IPPROTO_IPV6		41		/* IP6 header */
+#define	IPPROTO_SDRP		42		/* Source Demand Routing */
+#define	IPPROTO_ROUTING		43		/* IP6 routing header */
+#define	IPPROTO_FRAGMENT	44		/* IP6 fragmentation header */
+#define	IPPROTO_IDRP		45		/* InterDomain Routing*/
+#define	IPPROTO_RSVP		46 		/* resource reservation */
+#define	IPPROTO_GRE		47		/* General Routing Encap. */
+#define	IPPROTO_MHRP		48		/* Mobile Host Routing */
+#define	IPPROTO_BHA		49		/* BHA */
+#define	IPPROTO_ESP		50		/* IP6 Encap Sec. Payload */
+#define	IPPROTO_AH		51		/* IP6 Auth Header */
+#define	IPPROTO_INLSP		52		/* Integ. Net Layer Security */
+#define	IPPROTO_SWIPE		53		/* IP with encryption */
+#define	IPPROTO_NHRP		54		/* Next Hop Resolution */
+/* 55-57: Unassigned */
+#define	IPPROTO_ICMPV6		58		/* ICMP6 */
+#define	IPPROTO_NONE		59		/* IP6 no next header */
+#define	IPPROTO_DSTOPTS		60		/* IP6 destination option */
+#define	IPPROTO_AHIP		61		/* any host internal protocol */
+#define	IPPROTO_CFTP		62		/* CFTP */
+#define	IPPROTO_HELLO		63		/* "hello" routing protocol */
+#define	IPPROTO_SATEXPAK	64		/* SATNET/Backroom EXPAK */
+#define	IPPROTO_KRYPTOLAN	65		/* Kryptolan */
+#define	IPPROTO_RVD		66		/* Remote Virtual Disk */
+#define	IPPROTO_IPPC		67		/* Pluribus Packet Core */
+#define	IPPROTO_ADFS		68		/* Any distributed FS */
+#define	IPPROTO_SATMON		69		/* Satnet Monitoring */
+#define	IPPROTO_VISA		70		/* VISA Protocol */
+#define	IPPROTO_IPCV		71		/* Packet Core Utility */
+#define	IPPROTO_CPNX		72		/* Comp. Prot. Net. Executive */
+#define	IPPROTO_CPHB		73		/* Comp. Prot. HeartBeat */
+#define	IPPROTO_WSN		74		/* Wang Span Network */
+#define	IPPROTO_PVP		75		/* Packet Video Protocol */
+#define	IPPROTO_BRSATMON	76		/* BackRoom SATNET Monitoring */
+#define	IPPROTO_ND		77		/* Sun net disk proto (temp.) */
+#define	IPPROTO_WBMON		78		/* WIDEBAND Monitoring */
+#define	IPPROTO_WBEXPAK		79		/* WIDEBAND EXPAK */
+#define	IPPROTO_EON		80		/* ISO cnlp */
+#define	IPPROTO_VMTP		81		/* VMTP */
+#define	IPPROTO_SVMTP		82		/* Secure VMTP */
+#define	IPPROTO_VINES		83		/* Banyon VINES */
+#define	IPPROTO_TTP		84		/* TTP */
+#define	IPPROTO_IGP		85		/* NSFNET-IGP */
+#define	IPPROTO_DGP		86		/* dissimilar gateway prot. */
+#define	IPPROTO_TCF		87		/* TCF */
+#define	IPPROTO_IGRP		88		/* Cisco/GXS IGRP */
+#define	IPPROTO_OSPFIGP		89		/* OSPFIGP */
+#define	IPPROTO_SRPC		90		/* Strite RPC protocol */
+#define	IPPROTO_LARP		91		/* Locus Address Resoloution */
+#define	IPPROTO_MTP		92		/* Multicast Transport */
+#define	IPPROTO_AX25		93		/* AX.25 Frames */
+#define	IPPROTO_IPEIP		94		/* IP encapsulated in IP */
+#define	IPPROTO_MICP		95		/* Mobile Int.ing control */
+#define	IPPROTO_SCCSP		96		/* Semaphore Comm. security */
+#define	IPPROTO_ETHERIP		97		/* Ethernet IP encapsulation */
+#define	IPPROTO_ENCAP		98		/* encapsulation header */
+#define	IPPROTO_APES		99		/* any private encr. scheme */
+#define	IPPROTO_GMTP		100		/* GMTP*/
+#define	IPPROTO_IPCOMP		108		/* payload compression (IPComp) */
+/* 101-254: Partly Unassigned */
+#define	IPPROTO_PIM		103		/* Protocol Independent Mcast */
+#define	IPPROTO_PGM		113		/* PGM */
+/* 255: Reserved */
+/* BSD Private, local use, namespace incursion */
+#define	IPPROTO_RAW		255		/* raw IP packet */
+#define	IPPROTO_MAX		256
+
+/* last return value of *_input(), meaning "all job for this pkt is done".  */
+#define	IPPROTO_DONE		257
+#endif
+
+/*
+ * Ports < IPPORT_RESERVED are reserved for
+ * privileged processes (e.g. root).         (IP_PORTRANGE_LOW)
+ * Ports > IPPORT_USERRESERVED are reserved
+ * for servers, not necessarily privileged.  (IP_PORTRANGE_DEFAULT)
+ */
+#define	IPPORT_RESERVED		1024
+#define	IPPORT_USERRESERVED	5000
+
+#endif /* RTL8651_TBLDRV_PROTO_H */
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_eventMgr.c b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_eventMgr.c
new file mode 100644
index 00000000..b772ee4
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_eventMgr.c
@@ -0,0 +1,594 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "rtl_errno.h"
+//#include "rtl_utils.h"
+#include "rtl865x_eventMgr.h"
+#include "rtl865x_vlan.h"
+#include <linux/seq_file.h>
+
+/*record the allocated memory pool pointer,
+it can be used when event management module destroyed*/
+static char eventMgrInitFlag=FALSE;
+static rtl865x_event_t *eventPool;
+static rtl865x_eventLayerList_t *eventLayerListPool;
+static struct rtl865x_eventTables_s eventsTables;
+static rtl865x_eventMgr_param_t eventMgrParam;
+
+int32 rtl865x_initEventMgr(rtl865x_eventMgr_param_t *param)
+{
+	int32 i;
+	memset(&eventMgrParam,0,sizeof(rtl865x_eventMgr_param_t));
+
+	if(param==NULL)
+	{
+		eventMgrParam.eventCnt=DEFAULT_EVENT_CNT;
+		eventMgrParam.eventListCnt=DEFAULT_EVENT_LIST_CNT;
+	}
+	else
+	{
+		if(param->eventCnt>MAX_EVENT_CNT)
+		{
+			eventMgrParam.eventCnt=MAX_EVENT_CNT;
+		}
+		else if(param->eventCnt==0)
+		{
+			eventMgrParam.eventCnt=DEFAULT_EVENT_CNT;
+		}
+		else
+		{
+			eventMgrParam.eventCnt=param->eventCnt;
+		}
+
+
+		if(param->eventListCnt>MAX_EVENT_LIST_CNT)
+		{
+			eventMgrParam.eventListCnt=MAX_EVENT_LIST_CNT;
+		}
+		else if(param->eventListCnt==0)
+		{
+			eventMgrParam.eventListCnt=DEFAULT_EVENT_LIST_CNT;
+		}
+		else
+		{
+			eventMgrParam.eventListCnt=param->eventListCnt;
+		}
+	}
+
+	CTAILQ_INIT(&eventsTables.freeList.eventHead);
+	CTAILQ_INIT(&eventsTables.freeList.eventLayerListHead);
+	CTAILQ_INIT(&eventsTables.inuseList.eventLayerListHead);
+
+	//#ifdef __KERNEL__
+
+	TBL_MEM_ALLOC(eventPool, rtl865x_event_t, eventMgrParam.eventCnt);
+	//#else
+	//eventPool= (rtl865x_event_t *)malloc(eventMgrParam.eventCnt * sizeof(rtl865x_event_t));
+	//#endif
+	if(eventPool!=NULL)
+	{
+		memset( eventPool, 0, eventMgrParam.eventCnt * sizeof(rtl865x_event_t));
+	}
+	else
+	{
+		return FAILED;
+	}
+
+
+	//#ifdef __KERNEL__
+	TBL_MEM_ALLOC(eventLayerListPool, rtl865x_eventLayerList_t, eventMgrParam.eventListCnt);
+	//#else
+	//eventLayerListPool=(rtl865x_eventLayerList_t *)malloc(eventMgrParam.eventListCnt * sizeof(rtl865x_eventLayerList_t));
+	//#endif
+	if(eventLayerListPool!=NULL)
+	{
+		memset( eventLayerListPool, 0, eventMgrParam.eventListCnt * sizeof(rtl865x_eventLayerList_t));
+	}
+	else
+	{
+		return FAILED;
+	}
+
+	for(i = 0; i<eventMgrParam.eventCnt;i++)
+	{
+		CTAILQ_INSERT_HEAD(&eventsTables.freeList.eventHead, &eventPool[i], next);
+	}
+
+	for(i = 0; i<eventMgrParam.eventListCnt;i++)
+	{
+		CTAILQ_INSERT_HEAD(&eventsTables.freeList.eventLayerListHead, &eventLayerListPool[i], next);
+	}
+
+	eventMgrInitFlag=TRUE;
+	return SUCCESS;
+}
+
+
+static int32 rtl865x_flushEventLayerList(rtl865x_eventLayerList_t  *eventLayerList)
+{
+	rtl865x_event_t *event;
+	rtl865x_event_t *nextEvent;
+
+	if(eventLayerList==NULL)
+	{
+		return SUCCESS;
+	}
+
+	event = CTAILQ_FIRST(&eventLayerList->eventHead);
+	while(event)
+	{
+		nextEvent = CTAILQ_NEXT( event, next );
+		event->eventId=0;
+		event->eventPriority=0;
+		event->event_action_fn=NULL;
+		CTAILQ_REMOVE(&eventLayerList->eventHead, event, next);
+		CTAILQ_INSERT_HEAD(&eventsTables.freeList.eventHead, event, next);
+		event = nextEvent;
+	}
+	return SUCCESS;
+}
+
+int32 rtl865x_reInitEventMgr(void)
+{
+	rtl865x_eventLayerList_t *eventLayerList;
+	rtl865x_eventLayerList_t *nextEventLayerList;
+
+	if(eventMgrInitFlag==FALSE)
+	{
+		return FAILED;
+	}
+
+	eventLayerList = TAILQ_FIRST(&eventsTables.inuseList.eventLayerListHead);
+
+	for (;eventLayerList!=NULL;eventLayerList=nextEventLayerList)
+	{
+		nextEventLayerList=TAILQ_NEXT(eventLayerList, next);
+		rtl865x_flushEventLayerList(eventLayerList);
+
+		CTAILQ_REMOVE(&eventsTables.inuseList.eventLayerListHead, eventLayerList, next);
+		eventLayerList->eventLayerId=0;
+		CTAILQ_INIT(&eventLayerList->eventHead);
+		CTAILQ_INSERT_HEAD(&eventsTables.freeList.eventLayerListHead, eventLayerList, next);
+	}
+	return SUCCESS;
+}
+
+int32 rtl865x_destroyEventMgr(void)
+{
+
+	if(eventMgrInitFlag==FALSE)
+	{
+		return FAILED;
+	}
+
+	rtl865x_reInitEventMgr();
+	#ifdef __KERNEL__
+	if(eventPool!=NULL)
+	{
+		kfree(eventPool);
+		eventPool=NULL;
+	}
+
+	if(eventLayerListPool!=NULL)
+	{
+		kfree(eventLayerListPool);
+		eventLayerListPool=NULL;
+	}
+	#else
+	if(eventPool!=NULL)
+	{
+		free(eventPool);
+		eventPool=NULL;
+	}
+
+	if(eventLayerListPool!=NULL)
+	{
+		free(eventLayerListPool);
+		eventLayerListPool=NULL;
+	}
+	#endif
+
+	eventMgrInitFlag=FALSE;
+
+	return SUCCESS;
+}
+
+static rtl865x_eventLayerList_t * rtl865x_searchEventLayerList(rtl865x_event_Param_t *eventParam)
+{
+	rtl865x_eventLayerList_t *eventLayerList;
+	CTAILQ_FOREACH(eventLayerList, &eventsTables.inuseList.eventLayerListHead, next)
+	{
+		if(eventLayerList->eventLayerId==eventParam->eventLayerId)
+		{
+			return eventLayerList;
+		}
+	}
+
+	return NULL;
+}
+
+static rtl865x_event_t * rtl865x_searchEvent(rtl865x_eventLayerList_t *eventList,rtl865x_event_Param_t *eventParam)
+{
+	rtl865x_event_t *event=NULL;
+
+	if(eventParam==NULL)
+	{
+		return NULL;
+	}
+
+	CTAILQ_FOREACH(event, &eventList->eventHead, next)
+	{
+		if(	(event->eventId==eventParam->eventId)
+			&&(event->eventPriority==eventParam->eventPriority)
+			&&(event->event_action_fn== eventParam->event_action_fn))
+		{
+			return event;
+		}
+	}
+
+	return NULL;
+}
+
+static void rtl865x_insertEventLayerList(rtl865x_eventLayerList_t *eventLayerList)
+{
+	rtl865x_eventLayerList_t *tmpEventLayerList=NULL;
+	if(eventLayerList==NULL)
+	{
+		return;
+	}
+
+	CTAILQ_FOREACH(tmpEventLayerList, &eventsTables.inuseList.eventLayerListHead, next)
+	{
+		if(tmpEventLayerList->eventLayerId>=eventLayerList->eventLayerId)
+		{
+			CTAILQ_INSERT_BEFORE(&eventsTables.inuseList.eventLayerListHead,tmpEventLayerList,eventLayerList,next);
+			break;
+		}
+	}
+
+	if(tmpEventLayerList==NULL)
+	{
+		CTAILQ_INSERT_TAIL(&eventsTables.inuseList.eventLayerListHead,eventLayerList,next);
+	}
+	return;
+
+}
+
+static void rtl8651_insertEvent(rtl865x_eventLayerList_t *eventLayerList,rtl865x_event_t *event)
+{
+	rtl865x_event_t *tmpEvent=NULL;
+	if( (eventLayerList==NULL) ||(event==NULL))
+	{
+		return ;
+	}
+
+	CTAILQ_FOREACH(tmpEvent, &eventLayerList->eventHead, next)
+	{
+
+		if((tmpEvent->eventId>event->eventId)||
+			((tmpEvent->eventId== event->eventId) && (tmpEvent->eventPriority>=event->eventPriority)))
+		{
+			CTAILQ_INSERT_BEFORE(&eventLayerList->eventHead,tmpEvent,event,next);
+			break;
+		}
+	}
+
+	if(tmpEvent==NULL)
+	{
+		CTAILQ_INSERT_TAIL(&eventLayerList->eventHead,event,next);
+	}
+	return ;
+
+}
+
+int32 rtl865x_registerEvent(rtl865x_event_Param_t *eventParam)
+{
+	rtl865x_eventLayerList_t *eventLayerList=NULL;
+	rtl865x_event_t *event=NULL;
+
+	if(eventMgrInitFlag==FALSE)
+	{
+		return FAILED;
+	}
+
+	if(eventParam==NULL)
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	if(eventParam->eventLayerId==0)
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	eventLayerList=rtl865x_searchEventLayerList(eventParam);
+	if(eventLayerList==NULL)
+	{
+		eventLayerList = CTAILQ_FIRST(&eventsTables.freeList.eventLayerListHead);
+		if(eventLayerList==NULL)
+		{
+			return RTL_ENOFREEBUFFER;
+		}
+		CTAILQ_REMOVE(&eventsTables.freeList.eventLayerListHead, eventLayerList, next);
+		CTAILQ_INIT(&eventLayerList->eventHead);
+		eventLayerList->eventLayerId=eventParam->eventLayerId;
+		rtl865x_insertEventLayerList(eventLayerList);
+	}
+
+	if(	(eventParam->eventId< 0) ||
+		(eventParam->eventId >MAX_SYSTEM_EVENT_ID) ||
+		(eventParam->event_action_fn == NULL))
+		return RTL_EINVALIDINPUT;
+
+
+	/*check duplicate entry*/
+	event=rtl865x_searchEvent(eventLayerList,eventParam);
+	if(event!=NULL)
+	{
+		return RTL_EENTRYALREADYEXIST;
+	}
+	else
+	{
+
+		event = CTAILQ_FIRST(&eventsTables.freeList.eventHead);
+		if(event==NULL)
+		{
+			return RTL_ENOFREEBUFFER;
+		}
+		CTAILQ_REMOVE( &eventsTables.freeList.eventHead, event, next);
+		event->eventId= eventParam->eventId;
+		event->eventPriority = eventParam->eventPriority;
+		event->event_action_fn = eventParam->event_action_fn;
+
+		rtl8651_insertEvent(eventLayerList,event);
+	}
+
+	return SUCCESS;
+
+}
+
+int32 rtl865x_unRegisterEvent(rtl865x_event_Param_t *eventParam)
+{
+	rtl865x_eventLayerList_t *eventLayerList=NULL;
+	rtl865x_event_t *event=NULL;
+
+	if(eventMgrInitFlag==FALSE)
+	{
+		return FAILED;
+	}
+
+	if(eventParam==NULL)
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	eventLayerList=rtl865x_searchEventLayerList(eventParam);
+	if(eventLayerList==NULL)
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	if(	(eventParam->eventId< 0) ||
+		(eventParam->eventId >MAX_SYSTEM_EVENT_ID) ||
+		(eventParam->event_action_fn == NULL))
+		return RTL_EINVALIDINPUT;
+
+
+	event=rtl865x_searchEvent(eventLayerList,eventParam);
+	if(event!=NULL)
+	{
+		event->eventId = 0;
+		event->eventPriority = 0;
+		event->event_action_fn = NULL;
+		CTAILQ_REMOVE(&eventLayerList->eventHead, event, next);
+		CTAILQ_INSERT_HEAD(&eventsTables.freeList.eventHead, event, next);
+
+		if(CTAILQ_EMPTY(&eventLayerList->eventHead))
+		{
+			CTAILQ_REMOVE(&eventsTables.inuseList.eventLayerListHead, eventLayerList, next);
+			eventLayerList->eventLayerId=0;
+			CTAILQ_INIT(&eventLayerList->eventHead);
+			CTAILQ_INSERT_HEAD(&eventsTables.freeList.eventLayerListHead, eventLayerList, next);
+		}
+
+		return SUCCESS;
+	}
+	else
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	return SUCCESS;
+
+}
+
+
+int32 rtl865x_raiseEvent(int32 eventId,void *actionParam)
+{
+	rtl865x_eventLayerList_t *eventLayerList;
+	rtl865x_event_t *event;
+	int retValue;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	if(eventMgrInitFlag==FALSE)
+	{
+		return FAILED;
+	}
+
+	CTAILQ_FOREACH(eventLayerList, &eventsTables.inuseList.eventLayerListHead, next)
+	{
+		CTAILQ_FOREACH(event, &eventLayerList->eventHead, next)
+		{
+			if((event->eventId==eventId))
+			{
+				if(event->event_action_fn!=NULL)
+				{
+					do
+					{
+#if defined(CONFIG_SMP)
+						if ((event->eventId == EVENT_UPDATE_MCAST) ||
+								(event->eventId == EVENT_UPDATE_MCAST6)) {
+#if defined(CONFIG_HW_MCAST_DEBUG)
+							trace_printk("HW_MCAST:%s:%d eventId:%x event->eventId:%x START\n",
+									__func__, __LINE__, eventId, event->eventId);
+#endif
+							SMP_LOCK_ETH_EVENT(flags);
+						}
+#endif
+						retValue=event->event_action_fn(actionParam);
+#if defined(CONFIG_SMP)
+						if ((event->eventId == EVENT_UPDATE_MCAST) ||
+								(event->eventId == EVENT_UPDATE_MCAST6)) {
+							SMP_UNLOCK_ETH_EVENT(flags);
+#if defined(CONFIG_HW_MCAST_DEBUG)
+							trace_printk("HW_MCAST:%s:%d eventId:%x event->eventId:%x END\n",
+									__func__, __LINE__, eventId, event->eventId);
+#endif
+						}
+#endif
+					}while(retValue==EVENT_RE_EXECUTE);
+
+					switch(retValue)
+					{
+
+						case EVENT_STOP_EXECUTE:
+							return SUCCESS;
+
+						case EVENT_CONTINUE_EXECUTE:
+							break;
+
+						default:
+							break;
+					}
+				}
+			}
+		}
+
+	}
+
+	return SUCCESS;
+}
+
+void rtl865x_dumpAllEventLayerListInfo(void)
+{
+
+	rtl865x_eventLayerList_t *eventLayerList;
+	rtl865x_event_t *event;
+	int eventListCnt=0;
+	int eventCnt=0;
+	CTAILQ_FOREACH(eventLayerList, &eventsTables.inuseList.eventLayerListHead, next)
+	{
+		eventListCnt++;
+		eventCnt=0;
+		rtl865x_debug_printf(" No.%d eventLayerList:eventLayerId:%d \n",eventListCnt,eventLayerList->eventLayerId);
+		CTAILQ_FOREACH(event, &eventLayerList->eventHead, next)
+		{
+			eventCnt++;
+			#if defined(CONFIG_RTD_1295_HWNAT)
+			rtl865x_debug_printf(" \tNo.%d event:eventId:%d,priority:%d,action_fn is 0x%lx\n",eventCnt,event->eventId, event->eventPriority,(uintptr_t)(event->event_action_fn));
+			#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			rtl865x_debug_printf(" \tNo.%d event:eventId:%d,priority:%d,action_fn is 0x%x\n",eventCnt,event->eventId, event->eventPriority,(unsigned int)(event->event_action_fn));
+			#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		}
+
+	}
+
+	return;
+}
+
+
+#ifdef CONFIG_RTL865X_EVENT_PROC_DEBUG
+#ifdef CONFIG_RTL_PROC_NEW
+int32 rtl865x_event_proc_read(struct seq_file *s, void *v)
+{
+	rtl865x_eventLayerList_t *eventLayerList;
+	rtl865x_event_t *event;
+	int eventListCnt=0;
+	int eventCnt=0;
+
+	seq_printf(s, "%s\n", "realtek event management Table:");
+
+	CTAILQ_FOREACH(eventLayerList, &eventsTables.inuseList.eventLayerListHead, next)
+	{
+		eventListCnt++;
+		eventCnt=0;
+		seq_printf(s, " No.%d eventLayerList:eventLayerId:0x%x \n",eventListCnt,eventLayerList->eventLayerId);
+		CTAILQ_FOREACH(event, &eventLayerList->eventHead, next)
+		{
+			eventCnt++;
+			#if defined(CONFIG_RTD_1295_HWNAT)
+			seq_printf(s, " \tNo.%d event:eventId:0x%x,priority:%d,action_fn is 0x%lx\n",eventCnt,event->eventId, event->eventPriority,(uintptr_t)(event->event_action_fn));
+			#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			seq_printf(s, " \tNo.%d event:eventId:0x%x,priority:%d,action_fn is 0x%x\n",eventCnt,event->eventId, event->eventPriority,(unsigned int)(event->event_action_fn));
+			#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		}
+
+	}
+
+	return 0;
+}
+#else
+int32 rtl865x_event_proc_read( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int len=0;
+	rtl865x_eventLayerList_t *eventLayerList;
+	rtl865x_event_t *event;
+	int eventListCnt=0;
+	int eventCnt=0;
+
+	len = sprintf(page, "%s\n", "realtek event management Table:");
+
+	CTAILQ_FOREACH(eventLayerList, &eventsTables.inuseList.eventLayerListHead, next)
+	{
+		eventListCnt++;
+		eventCnt=0;
+		len += sprintf(page+len, " No.%d eventLayerList:eventLayerId:0x%x \n",eventListCnt,eventLayerList->eventLayerId);
+		CTAILQ_FOREACH(event, &eventLayerList->eventHead, next)
+		{
+			eventCnt++;
+			len += sprintf(page+len, " \tNo.%d event:eventId:0x%x,priority:%d,action_fn is 0x%x\n",eventCnt,event->eventId, event->eventPriority,(unsigned int)(event->event_action_fn));
+		}
+
+	}
+
+	if (len <= off+count)
+	{
+		*eof = 1;
+	}
+
+	*start = page + off;
+	len -= off;
+
+	if (len>count)
+	{
+		len = count;
+	}
+
+	if (len<0)
+	{
+	  	len = 0;
+	}
+
+	return len;
+}
+#endif
+
+int32  rtl865x_event_proc_write( struct file *filp, const char *buff,unsigned long len, void *data )
+{
+	return len;
+}
+#endif
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_eventMgr.h b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_eventMgr.h
new file mode 100644
index 00000000..5d300c8
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_eventMgr.h
@@ -0,0 +1,249 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865X_EVENT_MANAGEMENT_H
+#define RTL865X_EVENT_MANAGEMENT_H
+
+#include <net/rtl/rtl_queue.h>
+#if 0
+#define COMMON_MAX_EVENT_CNT		16 /*number of event*/
+#define MAX_NODE_PER_EVENT		4 /*max event node per event*/
+#define MAX_TOTAL_EVENT_NODE		COMMON_MAX_EVENT_CNT * MAX_NODE_PER_EVENT /*total event node count*/
+
+#define EV_DEL_VLAN		0
+#define EV_CHG_VLANFID	1
+#define EV_DEL_NETIF	2
+
+
+typedef struct action_param_s
+{
+	void *org;	/*old information*/
+	void *now;	/*new information*/
+	void *flag;
+}action_param_t;
+
+typedef struct event_node_s
+{
+	uint32 valid;
+	int32 priority; /*priority: minimal value indicate high priority*/
+	void (*event_action)(void *param);
+	struct event_node_s *pre,*next;
+}event_node_t;
+
+typedef struct event_s
+{
+	uint32 count;
+	event_node_t *head;
+	/*need a lock?*/
+}event_t;
+
+
+int32 rtl865x_initEventMgr(void);
+int32 rtl865x_registEvent(int32 event, int32 priority, void (*event_action_fn)(void *param));
+int32 rtl865x_unRegistEvent(int32 event, int32 priority, void (*event_action_fn)(void *param));
+int32 do_eventAction(int32 event,void *param);
+#else
+
+#ifdef CONFIG_PROC_FS
+#define CONFIG_RTL865X_EVENT_PROC_DEBUG
+#endif
+#define DEFAULT_EVENT_LIST_CNT 	4
+#define DEFAULT_EVENT_CNT			100
+
+#define MAX_EVENT_LIST_CNT		20
+#define MAX_EVENT_CNT			200
+
+
+#define DEFAULT_COMMON_EVENT_LIST_ID		0x10000000
+#define DEFAULT_LAYER2_EVENT_LIST_ID		0x20000000
+#define DEFAULT_LAYER3_EVENT_LIST_ID		0x30000000
+#define DEFAULT_LAYER4_EVENT_LIST_ID		0x40000000
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)	//jwj
+#define DEFAULT_IPV6_LAYER3_EVENT_LIST_ID	0x50000000
+#endif
+
+#define RTL865X_EVENT_PROC_DIR "reasilEvent"
+
+/*common layer event definition, common event range 0x10000000~0x1FFFFFFF*/
+#define MIN_COMM_EVENT_ID 			0x10000000
+#define MAX_COMM_EVENT_ID 		0x1FFFFFFF
+
+#define EVENT_ADD_VLAN				0x10000001
+#define EVENT_DEL_VLAN				0x10000002
+#define EVENT_CHANGE_VLANFID		0x10000003
+#define EVENT_ADD_NETIF			0x10000004
+#define EVENT_DEL_NETIF			0x10000005
+#define EVENT_ADD_ACL				0x10000006
+#define EVENT_DEL_ACL				0x10000007
+
+/*layer2 event definition, layer 2 event range 0x20000000~0x2FFFFFFF*/
+#define MIN_LAYER2_EVENT_ID 		0x20000000
+#define MAX_LAYER2_EVENT_ID 		0x2FFFFFFF
+
+#define EVENT_ADD_FDB				0x20000001
+#define EVENT_DEL_FDB				0x20000002
+#define EVENT_ADD_AUTHED_FDB		0x20000004
+#define EVENT_DEL_AUTHED_FDB		0x20000008
+
+#define EVENT_CHANGE_QOSRULE		0x20001001
+#define EVENT_FLUSH_QOSRULE		0x20001002
+
+#if defined CONFIG_RTL_L2_HW_MULTICAST_SUPPORT
+#define EVENT_UPDATE_L2_MCAST   0x20002001
+#endif
+
+
+/*layer3 event definition, layer3 event range 0x30000000~0x3FFFFFFF*/
+#define MIN_LAYER3_EVENT_ID 		0x30000000
+#define MAX_LAYER3_EVENT_ID 		0x3FFFFFFF
+
+#define EVENT_ADD_ROUTE			0x30000001
+#define EVENT_DEL_ROUTE				0x30000001
+#define EVENT_ADD_NEXTHOP			0x30000003
+#define EVENT_DEL_NEXTHOP			0x30000004
+#define EVENT_ADD_IP				0x30000005
+#define EVENT_DEL_IP					0x30000006
+#define EVENT_ADD_ARP				0x30000007
+#define EVENT_DEL_ARP				0x30000008
+#define EVENT_ADD_PPP				0x30000009
+#define EVENT_DEL_PPP				0x30000010
+
+/*macro for ip multicast usage*/
+#define EVENT_UPDATE_MCAST		0x30000011
+#define EVENT_ADD_MCAST			0x30000012
+#define EVENT_DEL_MCAST			0x30000013
+#define EVENT_ADD_GROUP			0x30000014
+#define EVENT_DEL_GROUP			0x30000015
+#define EVENT_ADD_MEMBER			0x30000016
+#define EVENT_DEL_MEMBER			0x30000017
+#define EVENT_ADD_SOURCE			0x30000018
+#define EVENT_DEL_SOURCE			0x30000019
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define EVENT_UPDATE_MCAST6		0x30000020
+#endif
+/*layer4 event definition, layer4 event range 0x40000000~0x4FFFFFFF*/
+#define MIN_LAYER4_EVENT_ID 		0x40000000
+#define MAX_LAYER4_EVENT_ID 		0x4FFFFFFF
+
+#define EVENT_ADD_NAPT				0x40000001
+#define EVENT_DELETE_NAPT			0x40000002
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)	//jwj
+/*layer3 event definition, ipv6 layer3 event range 0x50000000~0x5FFFFFFF*/
+#define MIN_IPV6_LAYER3_EVENT_ID 		0x50000000
+#define MAX_IPV6_LAYER3_EVENT_ID 		0x5FFFFFFF
+
+#define EVENT_ADD_IPV6_ARP			0x50000001
+#define EVENT_DEL_IPV6_ARP			0x50000002
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)	//jwj
+#define MAX_SYSTEM_EVENT_ID		0x5FFFFFFF
+#else
+#define MAX_SYSTEM_EVENT_ID		0x4FFFFFFF
+#endif
+
+#define HIGHEST_EVENT_PRIORITY		1
+#define LOWEST_EVENT_PRIORITY		65535
+
+/*callback function return vlue definition*/
+#define	EVENT_CONTINUE_EXECUTE	SUCCESS
+#define	EVENT_STOP_EXECUTE		FAILED
+#define	EVENT_RE_EXECUTE			(FAILED-1)
+
+
+#ifdef __KERNEL__
+	#define rtl865x_debug_printf	printk
+#else
+	#define rtl865x_debug_printf	printf
+#endif
+
+/*data structure definition*/
+typedef struct rtl865x_eventMgr_param_s
+{
+	uint32 eventListCnt;
+	uint32 eventCnt;
+}rtl865x_eventMgr_param_t;
+
+typedef struct rtl865x_event_Param_s
+{
+	int32 eventLayerId;
+	int32 eventId;
+	int32 eventPriority;
+	int32 (*event_action_fn)(void *param);
+}rtl865x_event_Param_t;
+
+
+typedef struct action_param_s
+{
+	void *org;	/*old information*/
+	void *now;	/*new information*/
+	void *flag;
+}action_param_t;
+
+
+typedef struct rtl865x_event_s
+{
+	int32 eventId;
+	int32 eventPriority; /*priority: less value indicate higher priority*/
+	int32 (*event_action_fn)(void *param);
+	CTAILQ_ENTRY(rtl865x_event_s) next;
+}rtl865x_event_t;
+
+
+typedef CTAILQ_HEAD(_event_head_s, rtl865x_event_s) rtl865x_event_Head_t;
+
+typedef struct rtl865x_eventLayerList_s
+{
+	int32 eventLayerId;
+	rtl865x_event_Head_t eventHead;
+	CTAILQ_ENTRY(rtl865x_eventLayerList_s) next;
+}rtl865x_eventLayerList_t;
+
+typedef CTAILQ_HEAD(_eventLayerList_head_s, rtl865x_eventLayerList_s) rtl865x_eventLayerList_Head_t;
+
+struct rtl865x_eventTables_s {
+	struct freeEntryList_s {
+		rtl865x_event_Head_t eventHead;
+		rtl865x_eventLayerList_Head_t eventLayerListHead;
+	} freeList;
+
+	struct inuseEntryList_s {
+		rtl865x_eventLayerList_Head_t	eventLayerListHead;
+	} inuseList;
+
+};
+
+int32 rtl865x_initEventMgr(rtl865x_eventMgr_param_t *param);
+int32 rtl865x_reInitEventMgr(void);
+int32 rtl865x_registerEvent(rtl865x_event_Param_t *eventParam);
+int32 rtl865x_unRegisterEvent(rtl865x_event_Param_t *eventParam);
+int32  rtl865x_raiseEvent(int32 eventId,void *actionParam);
+void rtl865x_dumpAllEventLayerListInfo(void);
+int32 rtl865x_destroyEventMgr(void);
+
+#ifdef CONFIG_RTL865X_EVENT_PROC_DEBUG
+#ifdef CONFIG_RTL_PROC_NEW
+#include <linux/debugfs.h>
+
+int32 rtl865x_event_proc_read(struct seq_file *s, void *v);
+int32  rtl865x_event_proc_write( struct file *filp, const char *buff,unsigned long len, void *data );
+#else
+int32 rtl865x_event_proc_read( char *page, char **start, off_t off, int count, int *eof, void *data );
+int32  rtl865x_event_proc_write( struct file *filp, const char *buff,unsigned long len, void *data );
+#endif
+#endif
+
+#endif
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_netif.c b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_netif.c
new file mode 100644
index 00000000..996d984
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_netif.c
@@ -0,0 +1,6057 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : network interface driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+/*      @doc RTL_LAYEREDDRV_API
+
+		@module rtl865x_netif.c - RTL865x Home gateway controller Layered driver API documentation       |
+		This document explains the API interface of the table driver module. Functions with rtl865x prefix
+		are external functions.
+		@normal Hyking Liu (Hyking_liu@realsil.com.cn) <date>
+
+		Copyright <cp>2008 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+		@head3 List of Symbols |
+		Here is a list of all functions and variables in this module.
+
+		@index | RTL_LAYEREDDRV_API
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "rtl_errno.h"
+//#include "rtl_utils.h"
+//#include "rtl_glue.h"
+#include <net/rtl/rtl865x_netif.h>
+#include "rtl865x_netif_local.h"
+#include "rtl865x_vlan.h" /*reference vlan*/
+#include "rtl865x_eventMgr.h" /*call back function....*/
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicBasic.h"
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#endif
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+//#include "rtl865x_localPublic.h"
+#endif
+
+#ifdef CONFIG_RTL_HARDWARE_IPV6_SUPPORT
+extern int rtk_hwL3v6_enable;
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+extern bool rtl_hwnat_enable;
+#define CHECK_IF_HWNAT_READY if (!rtl_hwnat_enable) return SUCCESS
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+static rtl865x_netif_local_t *netifTbl;
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+static int Netif_Asic2Sw_Mapping[NETIF_NUMBER] = {-1};
+#endif
+
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
+static RTL_DECLARE_MUTEX(netif_sem);
+#endif
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+static rtl865x_netif_local_t virtualNetIf;
+#endif
+
+static int (*rtl_get_drv_netifName_by_psName)(const char *psName,char *netifName);
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+static rtl865x_aclBuf_t freeAclList;
+static rtl865x_acl_chain_t *freeChainHead;
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+static uint32 rtl865x_acl_enable = 1; //default enable
+#endif
+
+static int32 _rtl865x_regist_aclChain(char *netifName, int32 priority,uint32 flag);
+static int32 _rtl865x_unRegister_all_aclChain(char *netifName);
+#endif
+
+static int32 _rtl865x_delNetif(char *name);
+
+int32 rtl865x_dump_AclRule(	rtl865x_AclRule_t *rule)
+{
+
+	int8 *actionT[] = { "permit", "redirect to ether", "drop", "to cpu", "legacy drop",
+					"drop for log", "mirror", "redirect to pppoe", "default redirect", "mirror keep match",
+					"drop rate exceed pps", "log rate exceed pps", "drop rate exceed bps", "log rate exceed bps","priority "
+					};
+
+	switch(rule->ruleType_)
+	{
+		case RTL865X_ACL_MAC:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Ethernet", actionT[rule->actionType_]);
+			printk("\tether type: %x   ether type mask: %x\n", rule->typeLen_, rule->typeLenMask_);
+			printk("\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					rule->dstMac_.octet[0], rule->dstMac_.octet[1], rule->dstMac_.octet[2],
+					rule->dstMac_.octet[3], rule->dstMac_.octet[4], rule->dstMac_.octet[5],
+					rule->dstMacMask_.octet[0], rule->dstMacMask_.octet[1], rule->dstMacMask_.octet[2],
+					rule->dstMacMask_.octet[3], rule->dstMacMask_.octet[4], rule->dstMacMask_.octet[5]
+					);
+
+			printk( "\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					rule->srcMac_.octet[0], rule->srcMac_.octet[1], rule->srcMac_.octet[2],
+					rule->srcMac_.octet[3], rule->srcMac_.octet[4], rule->srcMac_.octet[5],
+					rule->srcMacMask_.octet[0], rule->srcMacMask_.octet[1], rule->srcMacMask_.octet[2],
+					rule->srcMacMask_.octet[3], rule->srcMacMask_.octet[4], rule->srcMacMask_.octet[5]
+				);
+			break;
+
+		case RTL865X_ACL_IP:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IP", actionT[rule->actionType_]);
+			printk( "\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+					((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+					(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+					((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+					);
+			printk("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+					((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+					(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+					((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+					);
+			printk("\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					rule->tos_, rule->tosMask_, rule->ipProto_, rule->ipProtoMask_, rule->ipFlag_, rule->ipFlagMask_
+				);
+
+			printk("\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					rule->ipFOP_, rule->ipFOM_, rule->ipHttpFilter_, rule->ipHttpFilterM_, rule->ipIdentSrcDstIp_,
+					rule->ipIdentSrcDstIpM_
+					);
+			printk( "\t<DF:%x> <MF:%x>\n", rule->ipDF_, rule->ipMF_);
+				break;
+
+		case RTL865X_ACL_IP_RANGE:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IP Range", actionT[rule->actionType_]);
+			printk("\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+					((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+					(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+					((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+					);
+			printk("\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+					((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+					(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+					((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+					);
+			printk("\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					rule->tos_, rule->tosMask_, rule->ipProto_, rule->ipProtoMask_, rule->ipFlag_, rule->ipFlagMask_
+					);
+			printk("\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					rule->ipFOP_, rule->ipFOM_, rule->ipHttpFilter_, rule->ipHttpFilterM_, rule->ipIdentSrcDstIp_,
+					rule->ipIdentSrcDstIpM_
+					);
+				printk("\t<DF:%x> <MF:%x>\n", rule->ipDF_, rule->ipMF_);
+				break;
+		case RTL865X_ACL_ICMP:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "ICMP", actionT[rule->actionType_]);
+			printk("\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+					((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+					(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+					((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+					);
+			printk("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+					((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+					(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+					((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+					);
+			printk("\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					rule->tos_, rule->tosMask_, rule->icmpType_, rule->icmpTypeMask_,
+					rule->icmpCode_, rule->icmpCodeMask_);
+			break;
+		case RTL865X_ACL_ICMP_IPRANGE:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "ICMP IP RANGE", actionT[rule->actionType_]);
+			printk("\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+					((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+					(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+					((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+					);
+			printk("\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+					((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+					(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+					((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+					);
+			printk("\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					rule->tos_, rule->tosMask_, rule->icmpType_, rule->icmpTypeMask_,
+					rule->icmpCode_, rule->icmpCodeMask_);
+			break;
+		case RTL865X_ACL_IGMP:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IGMP", actionT[rule->actionType_]);
+			printk("\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+					((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+					(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+					((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+					);
+			printk("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+					((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+					(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+					((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+					);
+			printk("\tTos: %x   TosM: %x   type: %x   typeM: %x\n", rule->tos_, rule->tosMask_,
+					rule->igmpType_, rule->igmpTypeMask_
+					);
+			break;
+
+
+		case RTL865X_ACL_IGMP_IPRANGE:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IGMP IP RANGE", actionT[rule->actionType_]);
+			printk("\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+					((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+					(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+					((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+					);
+			printk("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+					((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+					(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+					((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+					);
+			printk("\tTos: %x   TosM: %x   type: %x   typeM: %x\n", rule->tos_, rule->tosMask_,
+					rule->igmpType_, rule->igmpTypeMask_
+					);
+			break;
+
+		case RTL865X_ACL_TCP:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "TCP", actionT[rule->actionType_]);
+			printk("\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+					((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+					(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+					((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+					);
+			printk("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+					((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+					(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+					((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+					);
+			printk("\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					rule->tos_, rule->tosMask_, rule->tcpSrcPortLB_, rule->tcpSrcPortUB_,
+					rule->tcpDstPortLB_, rule->tcpDstPortUB_
+					);
+			printk("\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					rule->tcpFlag_, rule->tcpFlagMask_, rule->tcpURG_, rule->tcpACK_,
+					rule->tcpPSH_, rule->tcpRST_, rule->tcpSYN_, rule->tcpFIN_
+					);
+			break;
+		case RTL865X_ACL_TCP_IPRANGE:
+				printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "TCP IP RANGE", actionT[rule->actionType_]);
+				printk("\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+					((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+					(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+					((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+					);
+				printk("\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+					((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+					(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+					((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+					);
+				printk("\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					rule->tos_, rule->tosMask_, rule->tcpSrcPortLB_, rule->tcpSrcPortUB_,
+					rule->tcpDstPortLB_, rule->tcpDstPortUB_
+					);
+				printk("\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					rule->tcpFlag_, rule->tcpFlagMask_, rule->tcpURG_, rule->tcpACK_,
+					rule->tcpPSH_, rule->tcpRST_, rule->tcpSYN_, rule->tcpFIN_
+				);
+			break;
+
+		case RTL865X_ACL_UDP:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx,"UDP", actionT[rule->actionType_]);
+			printk("\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+					((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+					(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+					((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+					);
+			printk("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+					((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+					(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+					((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+					);
+			printk("\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					rule->tos_, rule->tosMask_, rule->udpSrcPortLB_, rule->udpSrcPortUB_,
+					rule->udpDstPortLB_, rule->udpDstPortUB_
+					);
+			break;
+		case RTL865X_ACL_UDP_IPRANGE:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "UDP IP RANGE", actionT[rule->actionType_]);
+			printk("\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+					((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+					(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+					((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+					);
+			printk("\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+					((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+					(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+					((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+					);
+			printk("\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					rule->tos_, rule->tosMask_, rule->udpSrcPortLB_, rule->udpSrcPortUB_,
+					rule->udpDstPortLB_, rule->udpDstPortUB_
+				);
+			break;
+
+
+		case RTL865X_ACL_SRCFILTER:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Source Filter", actionT[rule->actionType_]);
+			printk("\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					rule->srcFilterMac_.octet[0], rule->srcFilterMac_.octet[1], rule->srcFilterMac_.octet[2],
+					rule->srcFilterMac_.octet[3], rule->srcFilterMac_.octet[4], rule->srcFilterMac_.octet[5],
+					rule->srcFilterMacMask_.octet[0], rule->srcFilterMacMask_.octet[1], rule->srcFilterMacMask_.octet[2],
+					rule->srcFilterMacMask_.octet[3], rule->srcFilterMacMask_.octet[4], rule->srcFilterMacMask_.octet[5]
+					);
+			printk("\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					rule->srcFilterVlanIdx_, rule->srcFilterVlanIdxMask_, rule->srcFilterPort_, rule->srcFilterPortMask_,
+					(rule->srcFilterIgnoreL3L4_==TRUE? 2: (rule->srcFilterIgnoreL4_ == 1? 1: 0))
+					);
+			printk("\tsip: %d.%d.%d.%d   sipM: %d.%d.%d.%d\n", (rule->srcFilterIpAddr_>>24),
+					((rule->srcFilterIpAddr_&0x00ff0000)>>16), ((rule->srcFilterIpAddr_&0x0000ff00)>>8),
+					(rule->srcFilterIpAddr_&0xff), (rule->srcFilterIpAddrMask_>>24),
+					((rule->srcFilterIpAddrMask_&0x00ff0000)>>16), ((rule->srcFilterIpAddrMask_&0x0000ff00)>>8),
+					(rule->srcFilterIpAddrMask_&0xff)
+					);
+			printk("\tsportL: %d   sportU: %d\n", rule->srcFilterPortLowerBound_, rule->srcFilterPortUpperBound_);
+			break;
+
+		case RTL865X_ACL_SRCFILTER_IPRANGE:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Source Filter(IP RANGE)", actionT[rule->actionType_]);
+			printk("\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					rule->srcFilterMac_.octet[0], rule->srcFilterMac_.octet[1], rule->srcFilterMac_.octet[2],
+					rule->srcFilterMac_.octet[3], rule->srcFilterMac_.octet[4], rule->srcFilterMac_.octet[5],
+					rule->srcFilterMacMask_.octet[0], rule->srcFilterMacMask_.octet[1], rule->srcFilterMacMask_.octet[2],
+					rule->srcFilterMacMask_.octet[3], rule->srcFilterMacMask_.octet[4], rule->srcFilterMacMask_.octet[5]
+					);
+			printk("\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					rule->srcFilterVlanIdx_, rule->srcFilterVlanIdxMask_, rule->srcFilterPort_, rule->srcFilterPortMask_,
+					(rule->srcFilterIgnoreL3L4_==TRUE? 2: (rule->srcFilterIgnoreL4_ == 1? 1: 0))
+					);
+			printk("\tsipU: %d.%d.%d.%d   sipL: %d.%d.%d.%d\n", (rule->srcFilterIpAddr_>>24),
+					((rule->srcFilterIpAddr_&0x00ff0000)>>16), ((rule->srcFilterIpAddr_&0x0000ff00)>>8),
+					(rule->srcFilterIpAddr_&0xff), (rule->srcFilterIpAddrMask_>>24),
+					((rule->srcFilterIpAddrMask_&0x00ff0000)>>16), ((rule->srcFilterIpAddrMask_&0x0000ff00)>>8),
+					(rule->srcFilterIpAddrMask_&0xff)
+					);
+			printk("\tsportL: %d   sportU: %d\n", rule->srcFilterPortLowerBound_, rule->srcFilterPortUpperBound_);
+			break;
+
+		case RTL865X_ACL_DSTFILTER:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Deatination Filter", actionT[rule->actionType_]);
+			printk("\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					rule->dstFilterMac_.octet[0], rule->dstFilterMac_.octet[1], rule->dstFilterMac_.octet[2],
+					rule->dstFilterMac_.octet[3], rule->dstFilterMac_.octet[4], rule->dstFilterMac_.octet[5],
+					rule->dstFilterMacMask_.octet[0], rule->dstFilterMacMask_.octet[1], rule->dstFilterMacMask_.octet[2],
+					rule->dstFilterMacMask_.octet[3], rule->dstFilterMacMask_.octet[4], rule->dstFilterMacMask_.octet[5]
+					);
+			printk("\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					rule->dstFilterVlanIdx_, rule->dstFilterVlanIdxMask_,
+					(rule->dstFilterIgnoreL3L4_==TRUE? 2: (rule->dstFilterIgnoreL4_ == 1? 1: 0)),
+					rule->dstFilterPortLowerBound_, rule->dstFilterPortUpperBound_
+					);
+			printk("\tdip: %d.%d.%d.%d   dipM: %d.%d.%d.%d\n", (rule->dstFilterIpAddr_>>24),
+					((rule->dstFilterIpAddr_&0x00ff0000)>>16), ((rule->dstFilterIpAddr_&0x0000ff00)>>8),
+					(rule->dstFilterIpAddr_&0xff), (rule->dstFilterIpAddrMask_>>24),
+					((rule->dstFilterIpAddrMask_&0x00ff0000)>>16), ((rule->dstFilterIpAddrMask_&0x0000ff00)>>8),
+					(rule->dstFilterIpAddrMask_&0xff)
+					);
+			break;
+		case RTL865X_ACL_DSTFILTER_IPRANGE:
+			printk(" [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Deatination Filter(IP Range)", actionT[rule->actionType_]);
+			printk("\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					rule->dstFilterMac_.octet[0], rule->dstFilterMac_.octet[1], rule->dstFilterMac_.octet[2],
+					rule->dstFilterMac_.octet[3], rule->dstFilterMac_.octet[4], rule->dstFilterMac_.octet[5],
+					rule->dstFilterMacMask_.octet[0], rule->dstFilterMacMask_.octet[1], rule->dstFilterMacMask_.octet[2],
+					rule->dstFilterMacMask_.octet[3], rule->dstFilterMacMask_.octet[4], rule->dstFilterMacMask_.octet[5]
+					);
+			printk("\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					rule->dstFilterVlanIdx_, rule->dstFilterVlanIdxMask_,
+					(rule->dstFilterIgnoreL3L4_==TRUE? 2: (rule->dstFilterIgnoreL4_ == 1? 1: 0)),
+					rule->dstFilterPortLowerBound_, rule->dstFilterPortUpperBound_
+					);
+			printk("\tdipU: %d.%d.%d.%d   dipL: %d.%d.%d.%d\n", (rule->dstFilterIpAddr_>>24),
+					((rule->dstFilterIpAddr_&0x00ff0000)>>16), ((rule->dstFilterIpAddr_&0x0000ff00)>>8),
+					(rule->dstFilterIpAddr_&0xff), (rule->dstFilterIpAddrMask_>>24),
+					((rule->dstFilterIpAddrMask_&0x00ff0000)>>16), ((rule->dstFilterIpAddrMask_&0x0000ff00)>>8),
+					(rule->dstFilterIpAddrMask_&0xff)
+				);
+			break;
+
+			default:
+				printk("rule->ruleType_(0x%x)\n", rule->ruleType_);
+
+	}
+
+	switch (rule->actionType_)
+	{
+		case RTL865X_ACL_PERMIT:
+		case RTL865X_ACL_REDIRECT_ETHER:
+		case RTL865X_ACL_DROP:
+		case RTL865X_ACL_TOCPU:
+		case RTL865X_ACL_LEGACY_DROP:
+		case RTL865X_ACL_DROPCPU_LOG:
+		case RTL865X_ACL_MIRROR:
+		case RTL865X_ACL_REDIRECT_PPPOE:
+		case RTL865X_ACL_MIRROR_KEEP_MATCH:
+			printk("\tnetifIdx: %d   pppoeIdx: %d   l2Idx:%d  ", rule->netifIdx_, rule->pppoeIdx_, rule->L2Idx_);
+			break;
+
+		case RTL865X_ACL_PRIORITY:
+			printk("\tprioirty: %d   ",  rule->priority_) ;
+			break;
+
+		case RTL865X_ACL_DEFAULT_REDIRECT:
+			printk("\tnextHop:%d  ",  rule->nexthopIdx_);
+			break;
+
+		case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+		case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+		case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+		case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+			printk("\tratelimitIdx: %d  ",  rule->ratelimtIdx_);
+			break;
+		default:
+			;
+
+		}
+		printk("pktOpApp: %d\n",  rule->pktOpApp_);
+		printk("===========================\n");
+		return SUCCESS;
+
+}
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+int32 rtl865x_show_allAclChains(struct seq_file *s)
+{
+	rtl865x_netif_local_t *netif = NULL;
+	rtl865x_acl_chain_t *chain;
+	rtl865x_AclRule_t *rule;
+	int32 i,j;
+	int8 *actionT[] = { "permit", "redirect to ether", "drop", "to cpu", "legacy drop",
+					"drop for log", "mirror", "redirect to pppoe", "default redirect", "mirror keep match",
+					"drop rate exceed pps", "log rate exceed pps", "drop rate exceed bps", "log rate exceed bps","priority "
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+					, "change vid"
+#endif
+					};
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rtl865x_AclRule_t *rule2 = NULL;
+	int8 ipv6_flag = 0;
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		if(netifTbl[i].valid == 1)
+		{
+			netif = &netifTbl[i];
+			for(j = RTL865X_ACL_INGRESS; j<= RTL865X_ACL_EGRESS;j++)
+			{
+				seq_printf(s,"netif(%s),isEgress(%d):\n",netif->name,j);
+				chain = netif->chainListHead[j];
+				while(chain)
+				{
+					seq_printf(s,"\tchain:priority(%d),rulecnt(%d)\n",chain->priority,chain->ruleCnt);
+					seq_printf(s,"===========================\n");
+					rule = chain->head;
+					while(rule)
+					{
+						switch(rule->ruleType_)
+						{
+							case RTL865X_ACL_MAC:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Ethernet", actionT[rule->actionType_]);
+								seq_printf(s,"\tether type: %x   ether type mask: %x\n", rule->typeLen_, rule->typeLenMask_);
+								seq_printf(s,"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->dstMac_.octet[0], rule->dstMac_.octet[1], rule->dstMac_.octet[2],
+										rule->dstMac_.octet[3], rule->dstMac_.octet[4], rule->dstMac_.octet[5],
+										rule->dstMacMask_.octet[0], rule->dstMacMask_.octet[1], rule->dstMacMask_.octet[2],
+										rule->dstMacMask_.octet[3], rule->dstMacMask_.octet[4], rule->dstMacMask_.octet[5]
+										);
+
+								seq_printf(s, "\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->srcMac_.octet[0], rule->srcMac_.octet[1], rule->srcMac_.octet[2],
+										rule->srcMac_.octet[3], rule->srcMac_.octet[4], rule->srcMac_.octet[5],
+										rule->srcMacMask_.octet[0], rule->srcMacMask_.octet[1], rule->srcMacMask_.octet[2],
+										rule->srcMacMask_.octet[3], rule->srcMacMask_.octet[4], rule->srcMacMask_.octet[5]
+									);
+								break;
+
+							case RTL865X_ACL_IP:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IP", actionT[rule->actionType_]);
+								seq_printf(s, "\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+										rule->tos_, rule->tosMask_, rule->ipProto_, rule->ipProtoMask_, rule->ipFlag_, rule->ipFlagMask_
+									);
+
+								seq_printf(s,"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+										rule->ipFOP_, rule->ipFOM_, rule->ipHttpFilter_, rule->ipHttpFilterM_, rule->ipIdentSrcDstIp_,
+										rule->ipIdentSrcDstIpM_
+										);
+								seq_printf(s, "\t<DF:%x> <MF:%x>\n", rule->ipDF_, rule->ipMF_);
+									break;
+
+							case RTL865X_ACL_IP_RANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IP Range", actionT[rule->actionType_]);
+								seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+										rule->tos_, rule->tosMask_, rule->ipProto_, rule->ipProtoMask_, rule->ipFlag_, rule->ipFlagMask_
+										);
+								seq_printf(s,"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+										rule->ipFOP_, rule->ipFOM_, rule->ipHttpFilter_, rule->ipHttpFilterM_, rule->ipIdentSrcDstIp_,
+										rule->ipIdentSrcDstIpM_
+										);
+									seq_printf(s,"\t<DF:%x> <MF:%x>\n", rule->ipDF_, rule->ipMF_);
+									break;
+							case RTL865X_ACL_ICMP:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "ICMP", actionT[rule->actionType_]);
+								seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+										rule->tos_, rule->tosMask_, rule->icmpType_, rule->icmpTypeMask_,
+										rule->icmpCode_, rule->icmpCodeMask_);
+								break;
+							case RTL865X_ACL_ICMP_IPRANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "ICMP IP RANGE", actionT[rule->actionType_]);
+								seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+										rule->tos_, rule->tosMask_, rule->icmpType_, rule->icmpTypeMask_,
+										rule->icmpCode_, rule->icmpCodeMask_);
+								break;
+							case RTL865X_ACL_IGMP:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IGMP", actionT[rule->actionType_]);
+								seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x\n", rule->tos_, rule->tosMask_,
+										rule->igmpType_, rule->igmpTypeMask_
+										);
+								break;
+
+
+							case RTL865X_ACL_IGMP_IPRANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IGMP IP RANGE", actionT[rule->actionType_]);
+								seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x\n", rule->tos_, rule->tosMask_,
+										rule->igmpType_, rule->igmpTypeMask_
+										);
+								break;
+
+							case RTL865X_ACL_TCP:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "TCP", actionT[rule->actionType_]);
+								seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+										rule->tos_, rule->tosMask_, rule->tcpSrcPortLB_, rule->tcpSrcPortUB_,
+										rule->tcpDstPortLB_, rule->tcpDstPortUB_
+										);
+								seq_printf(s,"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+										rule->tcpFlag_, rule->tcpFlagMask_, rule->tcpURG_, rule->tcpACK_,
+										rule->tcpPSH_, rule->tcpRST_, rule->tcpSYN_, rule->tcpFIN_
+										);
+								break;
+							case RTL865X_ACL_TCP_IPRANGE:
+									seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "TCP IP RANGE", actionT[rule->actionType_]);
+									seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+									seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+									seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+										rule->tos_, rule->tosMask_, rule->tcpSrcPortLB_, rule->tcpSrcPortUB_,
+										rule->tcpDstPortLB_, rule->tcpDstPortUB_
+										);
+									seq_printf(s,"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+										rule->tcpFlag_, rule->tcpFlagMask_, rule->tcpURG_, rule->tcpACK_,
+										rule->tcpPSH_, rule->tcpRST_, rule->tcpSYN_, rule->tcpFIN_
+									);
+								break;
+
+							case RTL865X_ACL_UDP:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx,"UDP", actionT[rule->actionType_]);
+								seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+										rule->tos_, rule->tosMask_, rule->udpSrcPortLB_, rule->udpSrcPortUB_,
+										rule->udpDstPortLB_, rule->udpDstPortUB_
+										);
+								break;
+							case RTL865X_ACL_UDP_IPRANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "UDP IP RANGE", actionT[rule->actionType_]);
+								seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+										rule->tos_, rule->tosMask_, rule->udpSrcPortLB_, rule->udpSrcPortUB_,
+										rule->udpDstPortLB_, rule->udpDstPortUB_
+									);
+								break;
+
+
+							case RTL865X_ACL_SRCFILTER:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Source Filter", actionT[rule->actionType_]);
+								seq_printf(s,"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->srcFilterMac_.octet[0], rule->srcFilterMac_.octet[1], rule->srcFilterMac_.octet[2],
+										rule->srcFilterMac_.octet[3], rule->srcFilterMac_.octet[4], rule->srcFilterMac_.octet[5],
+										rule->srcFilterMacMask_.octet[0], rule->srcFilterMacMask_.octet[1], rule->srcFilterMacMask_.octet[2],
+										rule->srcFilterMacMask_.octet[3], rule->srcFilterMacMask_.octet[4], rule->srcFilterMacMask_.octet[5]
+										);
+								seq_printf(s,"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+										rule->srcFilterVlanIdx_, rule->srcFilterVlanIdxMask_, rule->srcFilterPort_, rule->srcFilterPortMask_,
+										(rule->srcFilterIgnoreL3L4_==TRUE? 2: (rule->srcFilterIgnoreL4_ == 1? 1: 0))
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d   sipM: %d.%d.%d.%d\n", (rule->srcFilterIpAddr_>>24),
+										((rule->srcFilterIpAddr_&0x00ff0000)>>16), ((rule->srcFilterIpAddr_&0x0000ff00)>>8),
+										(rule->srcFilterIpAddr_&0xff), (rule->srcFilterIpAddrMask_>>24),
+										((rule->srcFilterIpAddrMask_&0x00ff0000)>>16), ((rule->srcFilterIpAddrMask_&0x0000ff00)>>8),
+										(rule->srcFilterIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsportL: %d   sportU: %d\n", rule->srcFilterPortLowerBound_, rule->srcFilterPortUpperBound_);
+								break;
+
+							case RTL865X_ACL_SRCFILTER_IPRANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Source Filter(IP RANGE)", actionT[rule->actionType_]);
+								seq_printf(s,"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->srcFilterMac_.octet[0], rule->srcFilterMac_.octet[1], rule->srcFilterMac_.octet[2],
+										rule->srcFilterMac_.octet[3], rule->srcFilterMac_.octet[4], rule->srcFilterMac_.octet[5],
+										rule->srcFilterMacMask_.octet[0], rule->srcFilterMacMask_.octet[1], rule->srcFilterMacMask_.octet[2],
+										rule->srcFilterMacMask_.octet[3], rule->srcFilterMacMask_.octet[4], rule->srcFilterMacMask_.octet[5]
+										);
+								seq_printf(s,"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+										rule->srcFilterVlanIdx_, rule->srcFilterVlanIdxMask_, rule->srcFilterPort_, rule->srcFilterPortMask_,
+										(rule->srcFilterIgnoreL3L4_==TRUE? 2: (rule->srcFilterIgnoreL4_ == 1? 1: 0))
+										);
+								seq_printf(s,"\tsipU: %d.%d.%d.%d   sipL: %d.%d.%d.%d\n", (rule->srcFilterIpAddr_>>24),
+										((rule->srcFilterIpAddr_&0x00ff0000)>>16), ((rule->srcFilterIpAddr_&0x0000ff00)>>8),
+										(rule->srcFilterIpAddr_&0xff), (rule->srcFilterIpAddrMask_>>24),
+										((rule->srcFilterIpAddrMask_&0x00ff0000)>>16), ((rule->srcFilterIpAddrMask_&0x0000ff00)>>8),
+										(rule->srcFilterIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsportL: %d   sportU: %d\n", rule->srcFilterPortLowerBound_, rule->srcFilterPortUpperBound_);
+								break;
+
+							case RTL865X_ACL_DSTFILTER:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Deatination Filter", actionT[rule->actionType_]);
+								seq_printf(s,"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->dstFilterMac_.octet[0], rule->dstFilterMac_.octet[1], rule->dstFilterMac_.octet[2],
+										rule->dstFilterMac_.octet[3], rule->dstFilterMac_.octet[4], rule->dstFilterMac_.octet[5],
+										rule->dstFilterMacMask_.octet[0], rule->dstFilterMacMask_.octet[1], rule->dstFilterMacMask_.octet[2],
+										rule->dstFilterMacMask_.octet[3], rule->dstFilterMacMask_.octet[4], rule->dstFilterMacMask_.octet[5]
+										);
+								seq_printf(s,"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+										rule->dstFilterVlanIdx_, rule->dstFilterVlanIdxMask_,
+										(rule->dstFilterIgnoreL3L4_==TRUE? 2: (rule->dstFilterIgnoreL4_ == 1? 1: 0)),
+										rule->dstFilterPortLowerBound_, rule->dstFilterPortUpperBound_
+										);
+								seq_printf(s,"\tdip: %d.%d.%d.%d   dipM: %d.%d.%d.%d\n", (rule->dstFilterIpAddr_>>24),
+										((rule->dstFilterIpAddr_&0x00ff0000)>>16), ((rule->dstFilterIpAddr_&0x0000ff00)>>8),
+										(rule->dstFilterIpAddr_&0xff), (rule->dstFilterIpAddrMask_>>24),
+										((rule->dstFilterIpAddrMask_&0x00ff0000)>>16), ((rule->dstFilterIpAddrMask_&0x0000ff00)>>8),
+										(rule->dstFilterIpAddrMask_&0xff)
+										);
+								break;
+							case RTL865X_ACL_DSTFILTER_IPRANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Deatination Filter(IP Range)", actionT[rule->actionType_]);
+								seq_printf(s,"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->dstFilterMac_.octet[0], rule->dstFilterMac_.octet[1], rule->dstFilterMac_.octet[2],
+										rule->dstFilterMac_.octet[3], rule->dstFilterMac_.octet[4], rule->dstFilterMac_.octet[5],
+										rule->dstFilterMacMask_.octet[0], rule->dstFilterMacMask_.octet[1], rule->dstFilterMacMask_.octet[2],
+										rule->dstFilterMacMask_.octet[3], rule->dstFilterMacMask_.octet[4], rule->dstFilterMacMask_.octet[5]
+										);
+								seq_printf(s,"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+										rule->dstFilterVlanIdx_, rule->dstFilterVlanIdxMask_,
+										(rule->dstFilterIgnoreL3L4_==TRUE? 2: (rule->dstFilterIgnoreL4_ == 1? 1: 0)),
+										rule->dstFilterPortLowerBound_, rule->dstFilterPortUpperBound_
+										);
+								seq_printf(s,"\tdipU: %d.%d.%d.%d   dipL: %d.%d.%d.%d\n", (rule->dstFilterIpAddr_>>24),
+										((rule->dstFilterIpAddr_&0x00ff0000)>>16), ((rule->dstFilterIpAddr_&0x0000ff00)>>8),
+										(rule->dstFilterIpAddr_&0xff), (rule->dstFilterIpAddrMask_>>24),
+										((rule->dstFilterIpAddrMask_&0x00ff0000)>>16), ((rule->dstFilterIpAddrMask_&0x0000ff00)>>8),
+										(rule->dstFilterIpAddrMask_&0xff)
+									);
+								break;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+							case RTL865X_ACL_IPV6: /* IP Rule Type: 0x0010 */
+							case RTL865X_ACL_IPV6_RANGE:
+								/* a ipv6 rule occupied  two entry, rule point to the first entry
+													* and rule2 point to the second entry.
+													*/
+								rule2 = rule->next;
+								ipv6_flag = 0;
+
+								if (rule2 != NULL)//the second entry
+								{
+									if ((!rule2->ipv6EntryType_) && rule->ipv6EntryType_)
+									{
+										rule->dstIpV6Addr_.v6_addr32[3] = rule2->dstIpV6Addr_.v6_addr32[3];
+										rule->dstIpV6Addr_.v6_addr32[2] = rule2->dstIpV6Addr_.v6_addr32[2];
+										rule->dstIpV6Addr_.v6_addr32[1] = rule2->dstIpV6Addr_.v6_addr32[1];
+										rule->dstIpV6Addr_.v6_addr32[0] = rule2->dstIpV6Addr_.v6_addr32[0];
+
+										rule->dstIpV6AddrMask_.v6_addr32[3] = rule2->dstIpV6AddrMask_.v6_addr32[3];
+										rule->dstIpV6AddrMask_.v6_addr32[2] = rule2->dstIpV6AddrMask_.v6_addr32[2];
+										rule->dstIpV6AddrMask_.v6_addr32[1] = rule2->dstIpV6AddrMask_.v6_addr32[1];
+										rule->dstIpV6AddrMask_.v6_addr32[0] = rule2->dstIpV6AddrMask_.v6_addr32[0];
+
+										rule->ipv6TrafficClass_ = rule2->ipv6TrafficClass_;
+										rule->ipv6TrafficClassM_ = rule2->ipv6TrafficClassM_;
+										rule->ipv6NextHeader_    = rule2->ipv6NextHeader_;
+										rule->ipv6NextHeaderM_   = rule2->ipv6NextHeaderM_;
+										rule->ipv6HttpFilter_    = rule2->ipv6HttpFilter_;
+										rule->ipv6HttpFilterM_ = rule2->ipv6HttpFilterM_;
+										rule->ipv6IdentSrcDstIp_ = rule2->ipv6IdentSrcDstIp_;
+										rule->ipv6IdentSrcDstIpM_ = rule2->ipv6IdentSrcDstIpM_;
+										/* ActionType and ActionField useless in entry0 */
+										rule->actionType_ = rule2->actionType_;
+										switch(rule->actionType_) {
+
+										case RTL865X_ACL_PERMIT:
+										case RTL865X_ACL_REDIRECT_ETHER:
+										case RTL865X_ACL_DROP:
+										case RTL865X_ACL_TOCPU:
+										case RTL865X_ACL_LEGACY_DROP:
+										case RTL865X_ACL_DROPCPU_LOG:
+										case RTL865X_ACL_MIRROR:
+										case RTL865X_ACL_REDIRECT_PPPOE:
+										case RTL865X_ACL_MIRROR_KEEP_MATCH:
+											rule->L2Idx_ = rule2->L2Idx_ ;
+											rule->netifIdx_ =  rule2->netifIdx_;
+											rule->pppoeIdx_ = rule2->pppoeIdx_;
+											 break;
+
+										case RTL865X_ACL_DEFAULT_REDIRECT:
+											rule->nexthopIdx_ = rule2->nexthopIdx_;
+											break;
+
+										case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+										case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+										case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+										case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+											rule->ratelimtIdx_ = rule2->ratelimtIdx_;
+											break;
+										case RTL865X_ACL_PRIORITY:
+											rule->priority_ = rule2->priority_;
+											break;
+										case RTL865X_ACL_VID:
+											rule->aclvid_ = rule2->aclvid_;
+											break;
+										}
+										/* INV useless in entry 0 */
+										rule->ipv6Invert_    = rule2->ipv6Invert_;
+										//rule->ipv6Combine_  = rule2->ipv6Combine_;
+										//rule->ipv6IPtunnel_ = rule2->ipv6IPtunnel_;
+										seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IPv6", actionT[rule->actionType_]);
+										if (RTL865X_ACL_IPV6 == rule->ruleType_)
+										{
+											seq_printf(s,"\tsip: %x:%x:%x:%x:%x:%x:%x:%x  sipM: %x:%x:%x:%x:%x:%x:%x:%x\n",
+													rule->srcIpV6Addr_.v6_addr16[0], rule->srcIpV6Addr_.v6_addr16[1],
+													rule->srcIpV6Addr_.v6_addr16[2],rule->srcIpV6Addr_.v6_addr16[3],
+													rule->srcIpV6Addr_.v6_addr16[4],rule->srcIpV6Addr_.v6_addr16[5],
+													rule->srcIpV6Addr_.v6_addr16[6],rule->srcIpV6Addr_.v6_addr16[7],
+													rule->srcIpV6AddrMask_.v6_addr16[0], rule->srcIpV6AddrMask_.v6_addr16[1],
+													rule->srcIpV6AddrMask_.v6_addr16[2],rule->srcIpV6AddrMask_.v6_addr16[3],
+													rule->srcIpV6AddrMask_.v6_addr16[4],rule->srcIpV6AddrMask_.v6_addr16[5],
+													rule->srcIpV6AddrMask_.v6_addr16[6],rule->srcIpV6AddrMask_.v6_addr16[7]
+													);
+											seq_printf(s,"\tdip: %x:%x:%x:%x:%x:%x:%x:%x  dipM: %x:%x:%x:%x:%x:%x:%x:%x\n",
+													rule->dstIpV6Addr_.v6_addr16[0], rule->dstIpV6Addr_.v6_addr16[1],
+													rule->dstIpV6Addr_.v6_addr16[2],rule->dstIpV6Addr_.v6_addr16[3],
+													rule->dstIpV6Addr_.v6_addr16[4],rule->dstIpV6Addr_.v6_addr16[5],
+													rule->dstIpV6Addr_.v6_addr16[6],rule->dstIpV6Addr_.v6_addr16[7],
+													rule->dstIpV6AddrMask_.v6_addr16[0], rule->dstIpV6AddrMask_.v6_addr16[1],
+													rule->dstIpV6AddrMask_.v6_addr16[2],rule->dstIpV6AddrMask_.v6_addr16[3],
+													rule->dstIpV6AddrMask_.v6_addr16[4],rule->dstIpV6AddrMask_.v6_addr16[5],
+													rule->dstIpV6AddrMask_.v6_addr16[6],rule->dstIpV6AddrMask_.v6_addr16[7]
+													);
+
+
+										}
+										else if (RTL865X_ACL_IPV6_RANGE == rule->ruleType_)
+										{
+											seq_printf(s,"\tsipLB: %x:%x:%x:%x:%x:%x:%x:%x  sipUB: %x:%x:%x:%x:%x:%x:%x:%x\n",
+													rule->srcIpV6AddrLB_.v6_addr16[0], rule->srcIpV6AddrLB_.v6_addr16[1],
+													rule->srcIpV6AddrLB_.v6_addr16[2], rule->srcIpV6AddrLB_.v6_addr16[3],
+													rule->srcIpV6AddrLB_.v6_addr16[4], rule->srcIpV6AddrLB_.v6_addr16[5],
+													rule->srcIpV6AddrLB_.v6_addr16[6], rule->srcIpV6AddrLB_.v6_addr16[7],
+													rule->srcIpV6AddrUB_.v6_addr16[0], rule->srcIpV6AddrUB_.v6_addr16[1],
+													rule->srcIpV6AddrUB_.v6_addr16[2], rule->srcIpV6AddrUB_.v6_addr16[3],
+													rule->srcIpV6AddrUB_.v6_addr16[4], rule->srcIpV6AddrUB_.v6_addr16[5],
+													rule->srcIpV6AddrUB_.v6_addr16[6], rule->srcIpV6AddrUB_.v6_addr16[7]
+													);
+											seq_printf(s,"\tdipLB: %x:%x:%x:%x:%x:%x:%x:%x  dipUB: %x:%x:%x:%x:%x:%x:%x:%x\n",
+													rule->dstIpV6AddrLB_.v6_addr16[0], rule->dstIpV6AddrLB_.v6_addr16[1],
+													rule->dstIpV6AddrLB_.v6_addr16[2], rule->dstIpV6AddrLB_.v6_addr16[3],
+													rule->dstIpV6AddrLB_.v6_addr16[4], rule->dstIpV6AddrLB_.v6_addr16[5],
+													rule->dstIpV6AddrLB_.v6_addr16[6], rule->dstIpV6AddrLB_.v6_addr16[7],
+													rule->dstIpV6AddrUB_.v6_addr16[0], rule->dstIpV6AddrUB_.v6_addr16[1],
+													rule->dstIpV6AddrUB_.v6_addr16[2], rule->dstIpV6AddrUB_.v6_addr16[3],
+													rule->dstIpV6AddrUB_.v6_addr16[4], rule->dstIpV6AddrUB_.v6_addr16[5],
+													rule->dstIpV6AddrUB_.v6_addr16[6], rule->dstIpV6AddrUB_.v6_addr16[7]
+													);
+										}
+										seq_printf(s,"\tFlowLabel: 0x%x   FlowLabelM: 0x%x\n",
+												rule->ipv6FlowLabel_, rule->ipv6FlowLabelM_
+												);
+										seq_printf(s,"\tInvert: %d   Combine: %d   IPtunnel: %d\n",
+												rule->ipv6Invert_, rule->ipv6Combine_,rule->ipv6IPtunnel_
+												);
+										seq_printf(s,"\tTrafficClassP: %d   TrafficClassM: %d   NextHeaderP: %d   NextHeaderM: %d\n",
+												rule->ipv6TrafficClass_, rule->ipv6TrafficClassM_,rule->ipv6NextHeader_,rule->ipv6NextHeaderM_
+												);
+										seq_printf(s,"\tHTTPP: %d   HTTPM: %d   IdentSDIPP: %d   IdentSDIPM: %d\n",
+												rule->ipv6HttpFilter_, rule->ipv6HttpFilterM_,rule->ipv6IdentSrcDstIp_,rule->ipv6IdentSrcDstIpM_
+												);
+										/* update  */
+										ipv6_flag = 1;//handle the ipv6 second rule successful
+									}
+
+								}
+							break;
+#endif
+
+								default:
+									seq_printf(s,"rule->ruleType_(0x%x)\n", rule->ruleType_);
+
+						}
+
+						switch (rule->actionType_)
+						{
+							case RTL865X_ACL_PERMIT:
+							case RTL865X_ACL_REDIRECT_ETHER:
+							case RTL865X_ACL_DROP:
+							case RTL865X_ACL_TOCPU:
+							case RTL865X_ACL_LEGACY_DROP:
+							case RTL865X_ACL_DROPCPU_LOG:
+							case RTL865X_ACL_MIRROR:
+							case RTL865X_ACL_REDIRECT_PPPOE:
+							case RTL865X_ACL_MIRROR_KEEP_MATCH:
+								seq_printf(s,"\tnetifIdx: %d   pppoeIdx: %d   l2Idx:%d  ", rule->netifIdx_, rule->pppoeIdx_, rule->L2Idx_);
+								break;
+
+							case RTL865X_ACL_PRIORITY:
+								seq_printf(s,"\tprioirty: %d   ",  rule->priority_) ;
+								break;
+
+							case RTL865X_ACL_DEFAULT_REDIRECT:
+								seq_printf(s,"\tnextHop:%d  ",  rule->nexthopIdx_);
+								break;
+
+							case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+							case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+							case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+							case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+								seq_printf(s,"\tratelimitIdx: %d  ",  rule->ratelimtIdx_);
+								break;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+							case RTL865X_ACL_VID:
+								seq_printf(s,"\taclvid: %d  ", rule->aclvid_);
+								break;
+#endif
+							default:
+								;
+
+							}
+						seq_printf(s,"pktOpApp: %d\n",  rule->pktOpApp_);
+
+						rule = rule->next;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+						if (ipv6_flag == 1)
+						{
+							rule = rule->next;
+							ipv6_flag= 0;
+						}
+#endif
+					}
+					seq_printf(s,"===========================\n");
+					chain = chain->nextChain;
+				}
+				seq_printf(s,"--------------------------------\n\n");
+			}
+
+		}
+	}
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+	{
+		if(virtualNetIf.valid == 1)
+		{
+			netif = &virtualNetIf;
+			for(j = RTL865X_ACL_INGRESS; j<= RTL865X_ACL_EGRESS;j++)
+			{
+				seq_printf(s,"netif(%s),isEgress(%d):\n",netif->name,j);
+				chain = netif->chainListHead[j];
+				while(chain)
+				{
+					seq_printf(s,"\tchain:priority(%d),rulecnt(%d)\n",chain->priority,chain->ruleCnt);
+					seq_printf(s,"===========================\n");
+					rule = chain->head;
+					while(rule)
+					{
+						switch(rule->ruleType_)
+						{
+							case RTL865X_ACL_MAC:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Ethernet", actionT[rule->actionType_]);
+								seq_printf(s,"\tether type: %x   ether type mask: %x\n", rule->typeLen_, rule->typeLenMask_);
+								seq_printf(s,"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->dstMac_.octet[0], rule->dstMac_.octet[1], rule->dstMac_.octet[2],
+										rule->dstMac_.octet[3], rule->dstMac_.octet[4], rule->dstMac_.octet[5],
+										rule->dstMacMask_.octet[0], rule->dstMacMask_.octet[1], rule->dstMacMask_.octet[2],
+										rule->dstMacMask_.octet[3], rule->dstMacMask_.octet[4], rule->dstMacMask_.octet[5]
+										);
+
+								seq_printf(s, "\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->srcMac_.octet[0], rule->srcMac_.octet[1], rule->srcMac_.octet[2],
+										rule->srcMac_.octet[3], rule->srcMac_.octet[4], rule->srcMac_.octet[5],
+										rule->srcMacMask_.octet[0], rule->srcMacMask_.octet[1], rule->srcMacMask_.octet[2],
+										rule->srcMacMask_.octet[3], rule->srcMacMask_.octet[4], rule->srcMacMask_.octet[5]
+									);
+								break;
+
+							case RTL865X_ACL_IP:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IP", actionT[rule->actionType_]);
+								seq_printf(s, "\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+										rule->tos_, rule->tosMask_, rule->ipProto_, rule->ipProtoMask_, rule->ipFlag_, rule->ipFlagMask_
+									);
+
+								seq_printf(s,"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+										rule->ipFOP_, rule->ipFOM_, rule->ipHttpFilter_, rule->ipHttpFilterM_, rule->ipIdentSrcDstIp_,
+										rule->ipIdentSrcDstIpM_
+										);
+								seq_printf(s, "\t<DF:%x> <MF:%x>\n", rule->ipDF_, rule->ipMF_);
+									break;
+
+							case RTL865X_ACL_IP_RANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IP Range", actionT[rule->actionType_]);
+								seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+										rule->tos_, rule->tosMask_, rule->ipProto_, rule->ipProtoMask_, rule->ipFlag_, rule->ipFlagMask_
+										);
+								seq_printf(s,"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+										rule->ipFOP_, rule->ipFOM_, rule->ipHttpFilter_, rule->ipHttpFilterM_, rule->ipIdentSrcDstIp_,
+										rule->ipIdentSrcDstIpM_
+										);
+									seq_printf(s,"\t<DF:%x> <MF:%x>\n", rule->ipDF_, rule->ipMF_);
+									break;
+							case RTL865X_ACL_ICMP:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "ICMP", actionT[rule->actionType_]);
+								seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+										rule->tos_, rule->tosMask_, rule->icmpType_, rule->icmpTypeMask_,
+										rule->icmpCode_, rule->icmpCodeMask_);
+								break;
+							case RTL865X_ACL_ICMP_IPRANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "ICMP IP RANGE", actionT[rule->actionType_]);
+								seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+										rule->tos_, rule->tosMask_, rule->icmpType_, rule->icmpTypeMask_,
+										rule->icmpCode_, rule->icmpCodeMask_);
+								break;
+							case RTL865X_ACL_IGMP:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IGMP", actionT[rule->actionType_]);
+								seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x\n", rule->tos_, rule->tosMask_,
+										rule->igmpType_, rule->igmpTypeMask_
+										);
+								break;
+
+
+							case RTL865X_ACL_IGMP_IPRANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IGMP IP RANGE", actionT[rule->actionType_]);
+								seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x\n", rule->tos_, rule->tosMask_,
+										rule->igmpType_, rule->igmpTypeMask_
+										);
+								break;
+
+							case RTL865X_ACL_TCP:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "TCP", actionT[rule->actionType_]);
+								seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+										rule->tos_, rule->tosMask_, rule->tcpSrcPortLB_, rule->tcpSrcPortUB_,
+										rule->tcpDstPortLB_, rule->tcpDstPortUB_
+										);
+								seq_printf(s,"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+										rule->tcpFlag_, rule->tcpFlagMask_, rule->tcpURG_, rule->tcpACK_,
+										rule->tcpPSH_, rule->tcpRST_, rule->tcpSYN_, rule->tcpFIN_
+										);
+								break;
+							case RTL865X_ACL_TCP_IPRANGE:
+									seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "TCP IP RANGE", actionT[rule->actionType_]);
+									seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+									seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+									seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+										rule->tos_, rule->tosMask_, rule->tcpSrcPortLB_, rule->tcpSrcPortUB_,
+										rule->tcpDstPortLB_, rule->tcpDstPortUB_
+										);
+									seq_printf(s,"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+										rule->tcpFlag_, rule->tcpFlagMask_, rule->tcpURG_, rule->tcpACK_,
+										rule->tcpPSH_, rule->tcpRST_, rule->tcpSYN_, rule->tcpFIN_
+									);
+								break;
+
+							case RTL865X_ACL_UDP:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx,"UDP", actionT[rule->actionType_]);
+								seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+										rule->tos_, rule->tosMask_, rule->udpSrcPortLB_, rule->udpSrcPortUB_,
+										rule->udpDstPortLB_, rule->udpDstPortUB_
+										);
+								break;
+							case RTL865X_ACL_UDP_IPRANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "UDP IP RANGE", actionT[rule->actionType_]);
+								seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+										((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+										(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+										((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+										((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+										(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+										((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+										rule->tos_, rule->tosMask_, rule->udpSrcPortLB_, rule->udpSrcPortUB_,
+										rule->udpDstPortLB_, rule->udpDstPortUB_
+									);
+								break;
+
+
+							case RTL865X_ACL_SRCFILTER:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Source Filter", actionT[rule->actionType_]);
+								seq_printf(s,"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->srcFilterMac_.octet[0], rule->srcFilterMac_.octet[1], rule->srcFilterMac_.octet[2],
+										rule->srcFilterMac_.octet[3], rule->srcFilterMac_.octet[4], rule->srcFilterMac_.octet[5],
+										rule->srcFilterMacMask_.octet[0], rule->srcFilterMacMask_.octet[1], rule->srcFilterMacMask_.octet[2],
+										rule->srcFilterMacMask_.octet[3], rule->srcFilterMacMask_.octet[4], rule->srcFilterMacMask_.octet[5]
+										);
+								seq_printf(s,"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+										rule->srcFilterVlanIdx_, rule->srcFilterVlanIdxMask_, rule->srcFilterPort_, rule->srcFilterPortMask_,
+										(rule->srcFilterIgnoreL3L4_==TRUE? 2: (rule->srcFilterIgnoreL4_ == 1? 1: 0))
+										);
+								seq_printf(s,"\tsip: %d.%d.%d.%d   sipM: %d.%d.%d.%d\n", (rule->srcFilterIpAddr_>>24),
+										((rule->srcFilterIpAddr_&0x00ff0000)>>16), ((rule->srcFilterIpAddr_&0x0000ff00)>>8),
+										(rule->srcFilterIpAddr_&0xff), (rule->srcFilterIpAddrMask_>>24),
+										((rule->srcFilterIpAddrMask_&0x00ff0000)>>16), ((rule->srcFilterIpAddrMask_&0x0000ff00)>>8),
+										(rule->srcFilterIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsportL: %d   sportU: %d\n", rule->srcFilterPortLowerBound_, rule->srcFilterPortUpperBound_);
+								break;
+
+							case RTL865X_ACL_SRCFILTER_IPRANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Source Filter(IP RANGE)", actionT[rule->actionType_]);
+								seq_printf(s,"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->srcFilterMac_.octet[0], rule->srcFilterMac_.octet[1], rule->srcFilterMac_.octet[2],
+										rule->srcFilterMac_.octet[3], rule->srcFilterMac_.octet[4], rule->srcFilterMac_.octet[5],
+										rule->srcFilterMacMask_.octet[0], rule->srcFilterMacMask_.octet[1], rule->srcFilterMacMask_.octet[2],
+										rule->srcFilterMacMask_.octet[3], rule->srcFilterMacMask_.octet[4], rule->srcFilterMacMask_.octet[5]
+										);
+								seq_printf(s,"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+										rule->srcFilterVlanIdx_, rule->srcFilterVlanIdxMask_, rule->srcFilterPort_, rule->srcFilterPortMask_,
+										(rule->srcFilterIgnoreL3L4_==TRUE? 2: (rule->srcFilterIgnoreL4_ == 1? 1: 0))
+										);
+								seq_printf(s,"\tsipU: %d.%d.%d.%d   sipL: %d.%d.%d.%d\n", (rule->srcFilterIpAddr_>>24),
+										((rule->srcFilterIpAddr_&0x00ff0000)>>16), ((rule->srcFilterIpAddr_&0x0000ff00)>>8),
+										(rule->srcFilterIpAddr_&0xff), (rule->srcFilterIpAddrMask_>>24),
+										((rule->srcFilterIpAddrMask_&0x00ff0000)>>16), ((rule->srcFilterIpAddrMask_&0x0000ff00)>>8),
+										(rule->srcFilterIpAddrMask_&0xff)
+										);
+								seq_printf(s,"\tsportL: %d   sportU: %d\n", rule->srcFilterPortLowerBound_, rule->srcFilterPortUpperBound_);
+								break;
+
+							case RTL865X_ACL_DSTFILTER:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Deatination Filter", actionT[rule->actionType_]);
+								seq_printf(s,"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->dstFilterMac_.octet[0], rule->dstFilterMac_.octet[1], rule->dstFilterMac_.octet[2],
+										rule->dstFilterMac_.octet[3], rule->dstFilterMac_.octet[4], rule->dstFilterMac_.octet[5],
+										rule->dstFilterMacMask_.octet[0], rule->dstFilterMacMask_.octet[1], rule->dstFilterMacMask_.octet[2],
+										rule->dstFilterMacMask_.octet[3], rule->dstFilterMacMask_.octet[4], rule->dstFilterMacMask_.octet[5]
+										);
+								seq_printf(s,"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+										rule->dstFilterVlanIdx_, rule->dstFilterVlanIdxMask_,
+										(rule->dstFilterIgnoreL3L4_==TRUE? 2: (rule->dstFilterIgnoreL4_ == 1? 1: 0)),
+										rule->dstFilterPortLowerBound_, rule->dstFilterPortUpperBound_
+										);
+								seq_printf(s,"\tdip: %d.%d.%d.%d   dipM: %d.%d.%d.%d\n", (rule->dstFilterIpAddr_>>24),
+										((rule->dstFilterIpAddr_&0x00ff0000)>>16), ((rule->dstFilterIpAddr_&0x0000ff00)>>8),
+										(rule->dstFilterIpAddr_&0xff), (rule->dstFilterIpAddrMask_>>24),
+										((rule->dstFilterIpAddrMask_&0x00ff0000)>>16), ((rule->dstFilterIpAddrMask_&0x0000ff00)>>8),
+										(rule->dstFilterIpAddrMask_&0xff)
+										);
+								break;
+							case RTL865X_ACL_DSTFILTER_IPRANGE:
+								seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Deatination Filter(IP Range)", actionT[rule->actionType_]);
+								seq_printf(s,"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+										rule->dstFilterMac_.octet[0], rule->dstFilterMac_.octet[1], rule->dstFilterMac_.octet[2],
+										rule->dstFilterMac_.octet[3], rule->dstFilterMac_.octet[4], rule->dstFilterMac_.octet[5],
+										rule->dstFilterMacMask_.octet[0], rule->dstFilterMacMask_.octet[1], rule->dstFilterMacMask_.octet[2],
+										rule->dstFilterMacMask_.octet[3], rule->dstFilterMacMask_.octet[4], rule->dstFilterMacMask_.octet[5]
+										);
+								seq_printf(s,"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+										rule->dstFilterVlanIdx_, rule->dstFilterVlanIdxMask_,
+										(rule->dstFilterIgnoreL3L4_==TRUE? 2: (rule->dstFilterIgnoreL4_ == 1? 1: 0)),
+										rule->dstFilterPortLowerBound_, rule->dstFilterPortUpperBound_
+										);
+								seq_printf(s,"\tdipU: %d.%d.%d.%d   dipL: %d.%d.%d.%d\n", (rule->dstFilterIpAddr_>>24),
+										((rule->dstFilterIpAddr_&0x00ff0000)>>16), ((rule->dstFilterIpAddr_&0x0000ff00)>>8),
+										(rule->dstFilterIpAddr_&0xff), (rule->dstFilterIpAddrMask_>>24),
+										((rule->dstFilterIpAddrMask_&0x00ff0000)>>16), ((rule->dstFilterIpAddrMask_&0x0000ff00)>>8),
+										(rule->dstFilterIpAddrMask_&0xff)
+									);
+								break;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+							case RTL865X_ACL_IPV6: /* IP Rule Type: 0x0010 */
+							case RTL865X_ACL_IPV6_RANGE:
+								/* a ipv6 rule occupied  two entry, rule point to the first entry
+													* and rule2 point to the second entry.
+													*/
+								rule2 = rule->next;
+								ipv6_flag = 0;
+
+								if (rule2 != NULL)//the second entry
+								{
+									if ((!rule2->ipv6EntryType_) && rule->ipv6EntryType_)
+									{
+										rule->dstIpV6Addr_.v6_addr32[3] = rule2->dstIpV6Addr_.v6_addr32[3];
+										rule->dstIpV6Addr_.v6_addr32[2] = rule2->dstIpV6Addr_.v6_addr32[2];
+										rule->dstIpV6Addr_.v6_addr32[1] = rule2->dstIpV6Addr_.v6_addr32[1];
+										rule->dstIpV6Addr_.v6_addr32[0] = rule2->dstIpV6Addr_.v6_addr32[0];
+
+										rule->dstIpV6AddrMask_.v6_addr32[3] = rule2->dstIpV6AddrMask_.v6_addr32[3];
+										rule->dstIpV6AddrMask_.v6_addr32[2] = rule2->dstIpV6AddrMask_.v6_addr32[2];
+										rule->dstIpV6AddrMask_.v6_addr32[1] = rule2->dstIpV6AddrMask_.v6_addr32[1];
+										rule->dstIpV6AddrMask_.v6_addr32[0] = rule2->dstIpV6AddrMask_.v6_addr32[0];
+
+										rule->ipv6TrafficClass_ = rule2->ipv6TrafficClass_;
+										rule->ipv6TrafficClassM_ = rule2->ipv6TrafficClassM_;
+										rule->ipv6NextHeader_    = rule2->ipv6NextHeader_;
+										rule->ipv6NextHeaderM_   = rule2->ipv6NextHeaderM_;
+										rule->ipv6HttpFilter_    = rule2->ipv6HttpFilter_;
+										rule->ipv6HttpFilterM_ = rule2->ipv6HttpFilterM_;
+										rule->ipv6IdentSrcDstIp_ = rule2->ipv6IdentSrcDstIp_;
+										rule->ipv6IdentSrcDstIpM_ = rule2->ipv6IdentSrcDstIpM_;
+										/* ActionType and ActionField useless in entry0 */
+										rule->actionType_ = rule2->actionType_;
+										switch(rule->actionType_) {
+
+										case RTL865X_ACL_PERMIT:
+										case RTL865X_ACL_REDIRECT_ETHER:
+										case RTL865X_ACL_DROP:
+										case RTL865X_ACL_TOCPU:
+										case RTL865X_ACL_LEGACY_DROP:
+										case RTL865X_ACL_DROPCPU_LOG:
+										case RTL865X_ACL_MIRROR:
+										case RTL865X_ACL_REDIRECT_PPPOE:
+										case RTL865X_ACL_MIRROR_KEEP_MATCH:
+											rule->L2Idx_ = rule2->L2Idx_ ;
+											rule->netifIdx_ =  rule2->netifIdx_;
+											rule->pppoeIdx_ = rule2->pppoeIdx_;
+											 break;
+
+										case RTL865X_ACL_DEFAULT_REDIRECT:
+											rule->nexthopIdx_ = rule2->nexthopIdx_;
+											break;
+
+										case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+										case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+										case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+										case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+											rule->ratelimtIdx_ = rule2->ratelimtIdx_;
+											break;
+										case RTL865X_ACL_PRIORITY:
+											rule->priority_ = rule2->priority_;
+											break;
+										case RTL865X_ACL_VID:
+											rule->aclvid_ = rule2->aclvid_;
+											break;
+										}
+										/* INV useless in entry 0 */
+										rule->ipv6Invert_    = rule2->ipv6Invert_;
+										//rule->ipv6Combine_  = rule2->ipv6Combine_;
+										//rule->ipv6IPtunnel_ = rule2->ipv6IPtunnel_;
+										seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IPv6", actionT[rule->actionType_]);
+										if (RTL865X_ACL_IPV6 == rule->ruleType_)
+										{
+											seq_printf(s,"\tsip: %x:%x:%x:%x:%x:%x:%x:%x  sipM: %x:%x:%x:%x:%x:%x:%x:%x\n",
+													rule->srcIpV6Addr_.v6_addr16[0], rule->srcIpV6Addr_.v6_addr16[1],
+													rule->srcIpV6Addr_.v6_addr16[2],rule->srcIpV6Addr_.v6_addr16[3],
+													rule->srcIpV6Addr_.v6_addr16[4],rule->srcIpV6Addr_.v6_addr16[5],
+													rule->srcIpV6Addr_.v6_addr16[6],rule->srcIpV6Addr_.v6_addr16[7],
+													rule->srcIpV6AddrMask_.v6_addr16[0], rule->srcIpV6AddrMask_.v6_addr16[1],
+													rule->srcIpV6AddrMask_.v6_addr16[2],rule->srcIpV6AddrMask_.v6_addr16[3],
+													rule->srcIpV6AddrMask_.v6_addr16[4],rule->srcIpV6AddrMask_.v6_addr16[5],
+													rule->srcIpV6AddrMask_.v6_addr16[6],rule->srcIpV6AddrMask_.v6_addr16[7]
+													);
+											seq_printf(s,"\tdip: %x:%x:%x:%x:%x:%x:%x:%x  dipM: %x:%x:%x:%x:%x:%x:%x:%x\n",
+													rule->dstIpV6Addr_.v6_addr16[0], rule->dstIpV6Addr_.v6_addr16[1],
+													rule->dstIpV6Addr_.v6_addr16[2],rule->dstIpV6Addr_.v6_addr16[3],
+													rule->dstIpV6Addr_.v6_addr16[4],rule->dstIpV6Addr_.v6_addr16[5],
+													rule->dstIpV6Addr_.v6_addr16[6],rule->dstIpV6Addr_.v6_addr16[7],
+													rule->dstIpV6AddrMask_.v6_addr16[0], rule->dstIpV6AddrMask_.v6_addr16[1],
+													rule->dstIpV6AddrMask_.v6_addr16[2],rule->dstIpV6AddrMask_.v6_addr16[3],
+													rule->dstIpV6AddrMask_.v6_addr16[4],rule->dstIpV6AddrMask_.v6_addr16[5],
+													rule->dstIpV6AddrMask_.v6_addr16[6],rule->dstIpV6AddrMask_.v6_addr16[7]
+													);
+
+
+										}
+										else if (RTL865X_ACL_IPV6_RANGE == rule->ruleType_)
+										{
+											seq_printf(s,"\tsipLB: %x:%x:%x:%x:%x:%x:%x:%x  sipUB: %x:%x:%x:%x:%x:%x:%x:%x\n",
+													rule->srcIpV6AddrLB_.v6_addr16[0], rule->srcIpV6AddrLB_.v6_addr16[1],
+													rule->srcIpV6AddrLB_.v6_addr16[2],rule->srcIpV6AddrLB_.v6_addr16[3],
+													rule->rcIpV6AddrLB_.v6_addr16[4],rule->srcIpV6AddrLB_.v6_addr16[5],
+													rule->srcIpV6AddrLB_.v6_addr16[6],rule->srcIpV6AddrLB_.v6_addr16[7],
+													rule->srcIpV6AddrUB_.v6_addr16[0], rule->srcIpV6AddrUB_.v6_addr16[1],
+													rule->srcIpV6AddrUB_.v6_addr16[2],rule->srcIpV6AddrUB_.v6_addr16[3],
+													rule->srcIpV6AddrUB_.v6_addr16[4],rule->srcIpV6AddrUB_.v6_addr16[5],
+													rule->srcIpV6AddrUB_.v6_addr16[6],rule->srcIpV6AddrUB_.v6_addr16[7]
+													);
+											seq_printf(s,"\tdipLB: %x:%x:%x:%x:%x:%x:%x:%x  dipUB: %x:%x:%x:%x:%x:%x:%x:%x\n",
+													rule->dstIpV6AddrLB_.v6_addr16[0], rule->dstIpV6AddrLB_.v6_addr16[1],
+													rule->dstIpV6AddrLB_.v6_addr16[2],rule->dstIpV6AddrLB_.v6_addr16[3],
+													rule->dstIpV6AddrLB_.v6_addr16[4],rule->dstIpV6AddrLB_.v6_addr16[5],
+													rule->dstIpV6AddrLB_.v6_addr16[6],rule->dstIpV6AddrLB_.v6_addr16[7],
+													rule->dstIpV6AddrUB_.v6_addr16[0], rule->dstIpV6AddrUB_.v6_addr16[1],
+													rule->dstIpV6AddrUB_.v6_addr16[2],rule->dstIpV6AddrUB_.v6_addr16[3],
+													rule->dstIpV6AddrUB_.v6_addr16[4],rule->dstIpV6AddrUB_.v6_addr16[5],
+													rule->dstIpV6AddrUB_.v6_addr16[6],rule->dstIpV6AddrUB_.v6_addr16[7]
+													);
+										}
+										seq_printf(s,"\tFlowLabel: 0x%x   FlowLabelM: 0x%x\n",
+												rule->ipv6FlowLabel_, rule->ipv6FlowLabelM_
+												);
+										seq_printf(s,"\tInvert: %d   Combine: %d   IPtunnel: %d\n",
+												rule->ipv6Invert_, rule->ipv6Combine_,rule->ipv6IPtunnel_
+												);
+										seq_printf(s,"\tTrafficClassP: %d   TrafficClassM: %d   NextHeaderP: %d   NextHeaderM: %d\n",
+												rule->ipv6TrafficClass_, rule->ipv6TrafficClassM_,rule->ipv6NextHeader_,rule->ipv6NextHeaderM_
+												);
+										seq_printf(s,"\tHTTPP: %d   HTTPM: %d   IdentSDIPP: %d   IdentSDIPM: %d\n",
+												rule->ipv6HttpFilter_, rule->ipv6HttpFilterM_,rule->ipv6IdentSrcDstIp_,rule->ipv6IdentSrcDstIpM_
+												);
+										/* update  */
+										ipv6_flag = 1;//handle the ipv6 second rule successful
+									}
+
+								}
+							break;
+#endif
+
+								default:
+									seq_printf(s,"rule->ruleType_(0x%x)\n", rule->ruleType_);
+
+						}
+
+						switch (rule->actionType_)
+						{
+							case RTL865X_ACL_PERMIT:
+							case RTL865X_ACL_REDIRECT_ETHER:
+							case RTL865X_ACL_DROP:
+							case RTL865X_ACL_TOCPU:
+							case RTL865X_ACL_LEGACY_DROP:
+							case RTL865X_ACL_DROPCPU_LOG:
+							case RTL865X_ACL_MIRROR:
+							case RTL865X_ACL_REDIRECT_PPPOE:
+							case RTL865X_ACL_MIRROR_KEEP_MATCH:
+								seq_printf(s,"\tnetifIdx: %d   pppoeIdx: %d   l2Idx:%d  ", rule->netifIdx_, rule->pppoeIdx_, rule->L2Idx_);
+								break;
+
+							case RTL865X_ACL_PRIORITY:
+								seq_printf(s,"\tprioirty: %d   ",  rule->priority_) ;
+								break;
+
+							case RTL865X_ACL_DEFAULT_REDIRECT:
+								seq_printf(s,"\tnextHop:%d  ",  rule->nexthopIdx_);
+								break;
+
+							case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+							case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+							case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+							case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+								seq_printf(s,"\tratelimitIdx: %d  ",  rule->ratelimtIdx_);
+								break;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+							case RTL865X_ACL_VID:
+								seq_printf(s,"\taclvid: %d  ", rule->aclvid_);
+								break;
+#endif
+							default:
+								;
+
+							}
+						seq_printf(s,"pktOpApp: %d\n",  rule->pktOpApp_);
+
+						rule = rule->next;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+						if (ipv6_flag == 1)
+						{
+							rule = rule->next;
+							ipv6_flag= 0;
+						}
+#endif
+					}
+					seq_printf(s,"===========================\n");
+					chain = chain->nextChain;
+				}
+				seq_printf(s,"--------------------------------\n\n");
+			}
+
+		}
+	}
+#endif
+	return SUCCESS;
+
+}
+
+
+#if RTL_LAYERED_DRIVER_DEBUG
+
+static int32 _rtl865x_print_allChain_allAcl(rtl865x_netif_local_t *netif)
+{
+	rtl865x_acl_chain_t *chain;
+	rtl865x_AclRule_t *rule;
+	int32 i;
+
+	for(i = RTL865X_ACL_INGRESS; i<= RTL865X_ACL_EGRESS;i++)
+	{
+		printk("netif(%s),isEgress(%d):\n",netif->name,i);
+		chain = netif->chainListHead[i];
+		while(chain)
+		{
+			printk("\tchain:priority(%d),rulecnt(%d)\n",chain->priority,chain->ruleCnt);
+			printk("===========================\n");
+			rule = chain->head;
+			while(rule)
+			{
+				printk("\tIdx%d:  aclIdx(%d),ruleType(%d),action(%d),direction(%d),pktOpApp(%d)\n", rule->aclIdx,rule->aclIdx,rule->ruleType_,rule->actionType_,rule->direction_,rule->pktOpApp_);
+				rule = rule->next;
+			}
+			printk("===========================\n");
+			chain = chain->nextChain;
+		}
+		printk("--------------------------------\n\n");
+	}
+	return SUCCESS;
+
+}
+
+
+static int32 _rtl865x_print_freeChainNum(void)
+{
+	rtl865x_acl_chain_t *entry;
+	rtl865x_AclRule_t *acl;
+	int32 freeCnt = 0;
+
+	entry = freeChainHead;
+	while(entry)
+	{
+		freeCnt++;
+		entry = entry->nextChain;
+	}
+	printk("the free chain number is: %d\n",freeCnt);
+
+	acl = freeAclList.freeHead;
+	freeCnt = 0;
+	while(acl)
+	{
+		freeCnt++;
+		acl = acl->next;
+	}
+	printk("freeAclList total(%d),free(%d),in fact free(%d)\n",freeAclList.totalCnt,freeAclList.freeCnt,freeCnt);
+	return SUCCESS;
+}
+
+#endif
+
+#endif //CONFIG_RTL_LAYERED_DRIVER_ACL
+static int32 _rtl865x_setAsicNetif(rtl865x_netif_local_t *entry)
+{
+	int32 retval = FAILED;
+	rtl865x_tblAsicDrv_intfParam_t asicEntry;
+
+	if(entry->is_slave == 1)
+		return retval;
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+	if(entry==(&virtualNetIf))
+	{
+		return FAILED;
+	}
+#endif
+	memset(&asicEntry,0,sizeof(rtl865x_tblAsicDrv_intfParam_t));
+	asicEntry.enableRoute = entry->enableRoute;
+	asicEntry.inAclStart = entry->inAclStart;
+	asicEntry.inAclEnd = entry->inAclEnd;
+	asicEntry.outAclStart = entry->outAclStart;
+	asicEntry.outAclEnd = entry->outAclEnd;
+	//asicEntry.macAddr = entry->macAddr;
+	memcpy(asicEntry.macAddr.octet,entry->macAddr.octet,ETHER_ADDR_LEN);
+	asicEntry.macAddrNumber = entry->macAddrNumber;
+	asicEntry.mtu = entry->mtu;
+	asicEntry.vid = entry->vid;
+	asicEntry.valid = entry->valid;
+
+#if defined (CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	asicEntry.mtuV6         = entry->mtuV6;
+	asicEntry.enableRouteV6 = entry->enableRouteV6;
+#endif
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+	{
+	/*
+	  Prevent port blocked.
+	  When 8367RB got attacked packet which source mac address
+	  is equal to DUT LAN/WAN MAC address, the 8367RB will learn
+	  the SA to L2 table. Later, the incoming packet which DA =
+	  DUT LAN/WAN MAC will be dropped until this L2 entry timeout.
+	 */
+	extern void set_8367r_L2(uint8 *mac, int intf_wan, int is_static);
+	set_8367r_L2(&entry->macAddr.octet[0], entry->is_wan, 1);
+	}
+#endif
+
+	retval = rtl8651_setAsicNetInterface( entry->asicIdx, &asicEntry);
+	return retval;
+
+}
+
+rtl865x_netif_local_t *_rtl865x_getSWNetifByName(char *name)
+{
+	int32 i;
+	rtl865x_netif_local_t *netif = NULL;
+
+	if(name == NULL)
+		return NULL;
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		//printk("%s:%d,i(%d),valid(%d),ifname(%s),strlen of name(%d), netifTbl(0x%p),netifTblName(%s)\n",__FUNCTION__,__LINE__,i,netifTbl[i].valid,name,strlen(name),&netifTbl[i],netifTbl[i].name);
+		if(netifTbl[i].valid == 1 && strlen(name) == strlen(netifTbl[i].name) && memcmp(netifTbl[i].name,name,strlen(name)) == 0)
+		{
+			netif = &netifTbl[i];
+			break;
+		}
+	}
+
+	#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+	if(virtualNetIf.valid == 1 && strlen(name) == strlen(virtualNetIf.name) && memcmp(virtualNetIf.name,name,strlen(name)) == 0)
+	{
+		netif = &virtualNetIf;
+	}
+	#endif
+
+	return netif;
+}
+
+rtl865x_netif_local_t *_rtl865x_getNetifByName(char *name)
+{
+	int32 i;
+	rtl865x_netif_local_t *netif = NULL;
+
+	if(name == NULL)
+		return NULL;
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		//printk("i(%d),ifname(%s),netifTbl(0x%p),netifTblName(%s)\n",i,name,&netifTbl[i],netifTbl[i].name);
+		if(netifTbl[i].valid == 1 && strlen(name) == strlen(netifTbl[i].name) && memcmp(netifTbl[i].name,name,strlen(name)) == 0)
+		{
+			if(netifTbl[i].is_slave == 0)
+				netif = &netifTbl[i];
+			else
+			{
+				netif = netifTbl[i].master;
+			}
+			break;
+		}
+	}
+	#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+	if(virtualNetIf.valid == 1 && strlen(name) == strlen(virtualNetIf.name) && memcmp(virtualNetIf.name,name,strlen(name)) == 0)
+	{
+		netif = &virtualNetIf;
+
+	}
+	#endif
+	return netif;
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+rtl865x_netif_local_t *_rtl865x_getNetifByIdx(unsigned int i)
+{
+	rtl865x_netif_local_t *netif = NULL;
+
+	if(i >= NETIF_NUMBER)
+		return NULL;
+
+	if(netifTbl[i].valid == 1)
+		netif = &netifTbl[i];
+	return netif;
+}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT) || defined (CONFIG_RTL_HW_6RD_SUPPORT)
+rtl865x_netif_local_t *_rtl865x_getNetifByType(int iftype)
+{
+	int32 i;
+	rtl865x_netif_local_t *netif = NULL;
+
+	if(iftype <IF_6RD||iftype >IF_DSLT)
+		return NULL;
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		//printk("i(%d),ifname(%s),netifTbl(0x%p),netifTblName(%s)\n",i,name,&netifTbl[i],netifTbl[i].name);
+		if(netifTbl[i].valid == 1 && netifTbl[i].if_type== iftype )
+		{
+			netif = &netifTbl[i];
+			break;
+		}
+	}
+	return netif;
+}
+int32 rtl865x_updatev6SwNetif(char *netifName,int iftype)
+{
+	int32 retval = FAILED;
+	rtl865x_netif_local_t *netifold = NULL;
+	netifold=_rtl865x_getNetifByType(iftype);
+	if(netifold == NULL)
+	{
+		printk("retval:%d,%s,%d,[%s]:[%d].\n",retval,netifName,iftype,__FUNCTION__,__LINE__);
+		return retval;
+	}
+
+	strcpy(netifold->name, netifName);
+	netifold->if_type = iftype;
+	retval = SUCCESS;
+	_rtl865x_setDefaultWanNetif(netifName);
+	return retval;
+}
+#endif
+#endif
+
+
+rtl865x_netif_local_t *_rtl865x_getDefaultWanNetif(void)
+{
+	int32 i;
+	rtl865x_netif_local_t *firstWan, *defNetif;
+	firstWan = defNetif = NULL;
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		//printk("i(%d),netifTbl(0x%p)\n",i,&netifTbl[i]);
+		if(netifTbl[i].valid == 1 && netifTbl[i].is_wan == 1 && firstWan == NULL)
+			firstWan = &netifTbl[i];
+
+		if(netifTbl[i].valid == 1 && netifTbl[i].is_defaultWan == 1)
+		{
+			defNetif = &netifTbl[i];
+			break;
+		}
+	}
+
+	/*if not found default wan, return wan interface first found*/
+	if(defNetif == NULL)
+	{
+		defNetif = firstWan;
+	}
+	return defNetif;
+}
+
+int32 _rtl865x_setDefaultWanNetif(char *name)
+{
+	rtl865x_netif_local_t *entry;
+	entry = _rtl865x_getSWNetifByName(name);
+
+	//printk("set default wan interface....(%s)\n",name);
+	if(entry)
+		entry->is_defaultWan = 1;
+	return SUCCESS;
+}
+
+int32 _rtl865x_clearDefaultWanNetif(char *name)
+{
+	rtl865x_netif_local_t *entry;
+	entry = _rtl865x_getSWNetifByName(name);
+
+	//printk("set default wan interface....(%s)\n",name);
+	if(entry)
+		entry->is_defaultWan = 0;
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_attachMasterNetif(char *slave, char *master)
+{
+	rtl865x_netif_local_t *slave_netif, *master_netif;
+
+	slave_netif = _rtl865x_getSWNetifByName(slave);
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT) && defined(CONFIG_RTL_PPPOE_HWACC)
+	if (NULL == slave_netif) {
+		extern int32 rtl_add_ppp_netif(char *ifname);
+		if (SUCCESS != rtl_add_ppp_netif(slave)) {
+			//print("Leave %s @ %d\n",__FUNCTION__,__LINE__);
+			return RTL_EENTRYNOTFOUND;
+		}
+		//get netif again, we have created a new netif through rtl_add_ppp_netif()
+		slave_netif = _rtl865x_getSWNetifByName(slave);
+	}
+#endif
+	master_netif = _rtl865x_getNetifByName(master);
+
+	if(slave_netif == NULL || master_netif == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	//printk("===%s(%d),slave(%s),master(%s),slave_netif->master(0x%p)\n",__FUNCTION__,__LINE__,slave,master,slave_netif->master);
+	if(slave_netif->master != NULL)
+		return RTL_EENTRYALREADYEXIST;
+
+	slave_netif ->master = master_netif;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	slave_netif->vid = master_netif->vid;
+#endif
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_detachMasterNetif(char *slave)
+{
+	rtl865x_netif_local_t *slave_netif;
+
+	slave_netif = _rtl865x_getSWNetifByName(slave);
+
+	if(slave_netif == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	slave_netif ->master = NULL;
+
+	return SUCCESS;
+}
+
+int32 _rtl865x_addNetif(rtl865x_netif_t *netif)
+{
+	rtl865x_netif_local_t *entry;
+	int32 retval = FAILED;
+	int32 i;
+#if defined (CONFIG_RTL_LOCAL_PUBLIC) || defined(CONFIG_RTL_MULTIPLE_WAN)
+	int asicIdx;
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+	rtl865xc_tblAsic_netifTable_t asicEntry;
+#endif
+#endif
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	int32 sw_netif_idx = 0;
+#endif
+
+	if(netif == NULL)
+		return RTL_EINVALIDINPUT;
+
+	/*duplicate entry....*/
+	entry = _rtl865x_getSWNetifByName(netif->name);
+	if(entry)
+		return RTL_EENTRYALREADYEXIST;
+
+	/*get netif buffer*/
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		if(netifTbl[i].valid == 0) {
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+			sw_netif_idx = i;
+#endif
+			break;
+		}
+	}
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC) || defined(CONFIG_RTL_MULTIPLE_WAN)
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+	for (asicIdx=0;asicIdx<RTL865XC_NETIFTBL_SIZE;asicIdx++)
+	{
+		_rtl8651_readAsicEntry(TYPE_NETINTERFACE_TABLE, asicIdx, &asicEntry);
+		if (asicEntry.valid==0)
+		{
+			break;
+		}
+	}
+#endif
+
+	if(netif->forMacBasedMCast==TRUE)
+	{
+		asicIdx=RTL865XC_NETIFTBL_SIZE-1;
+	}
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	else
+	{
+		asicIdx = i;
+	}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	if(i == NETIF_SW_NUMBER)
+#else
+	if(i == NETIF_NUMBER)
+#endif
+		return RTL_ENOFREEBUFFER;
+
+	/*add new entry*/
+	entry = &netifTbl[i];
+
+	#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+	memset(entry, 0, sizeof(rtl865x_netif_local_t));
+	#endif
+
+	entry->valid = 1;
+	entry->mtu = netif->mtu;
+	entry->if_type = netif->if_type;
+	entry->macAddr = netif->macAddr;
+	entry->vid = netif->vid;
+	entry->is_wan = netif->is_wan;
+	entry->dmz = netif->dmz;
+	entry->is_slave = netif->is_slave;
+
+	#if defined (CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT) || defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+	entry->enableRouteV6 = rtk_hwL3v6_enable?1:0;
+	#endif
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	entry->enableRouteV6 = (rtl8651_getAsicOperationLayer()>2)?(netif->enableRouteV6):0;
+	#endif
+	#else
+	entry->enableRouteV6 = netif->enableRouteV6;
+	#endif
+	entry->mtuV6         = netif->mtuV6;
+	#endif
+
+	memcpy(entry->name,netif->name,MAX_IFNAMESIZE);
+//	printk("netif:%s,%d,[%s]:[%d].\n",netif->name,netif->is_slave,__FUNCTION__,__LINE__);
+	/*private number...*/
+#if defined (CONFIG_RTL_LOCAL_PUBLIC) ||defined(CONFIG_RTL_MULTIPLE_WAN)
+	entry->asicIdx=asicIdx;
+#else
+	entry->asicIdx = i;
+#endif
+#if (defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS) || defined(CONFIG_RTL_HARDWARE_MULTICAST)) && defined(CONFIG_OPENWRT_SDK)
+	entry->enableRoute = (rtl8651_getAsicOperationLayer()>2)?(netif->enableRoute):0;
+#else
+	entry->enableRoute = netif->enableRoute;
+#endif
+	entry->macAddrNumber = 1;
+	entry->inAclEnd = entry->inAclStart = entry->outAclEnd = entry->outAclStart = RTL865X_ACLTBL_PERMIT_ALL; /*default permit...*/
+	entry->refCnt = 1;
+	entry->master = NULL;
+
+#ifdef 	CONFIG_RTL_LAYERED_DRIVER_ACL
+	//ingress acl chains head
+	entry->chainListHead[RTL865X_ACL_INGRESS] = NULL;
+
+	//init egress acl
+	entry->chainListHead[RTL865X_ACL_EGRESS] = NULL;
+#endif
+
+	/*only write master interface into ASIC*/
+	if(entry->is_slave == 0)
+	{
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+		{
+			int hw_netif_idx=0;
+
+			/* find new available hw asic index */
+			for (hw_netif_idx=0; hw_netif_idx<NETIF_NUMBER; hw_netif_idx++)
+			{
+				if (Netif_Asic2Sw_Mapping[hw_netif_idx] == -1)
+					break;
+			}
+
+			if (hw_netif_idx == NETIF_NUMBER) {
+				printk("%s[%d] Warning , there is no more empty entry in Asic Netif Table\n ", __FUNCTION__, __LINE__);
+				return RTL_ENOFREEBUFFER;
+			}
+#if defined(CONFIG_RTL_MAC_BASED_NETIF)
+			if (netif->forMacBasedMCast == TRUE)
+				hw_netif_idx = RTL865XC_NETIFTBL_SIZE-1;
+#endif
+			Netif_Asic2Sw_Mapping[hw_netif_idx] = sw_netif_idx ;
+			entry->asicIdx = hw_netif_idx;
+		}
+#endif
+		retval = _rtl865x_setAsicNetif(entry);
+		if(retval == SUCCESS)
+			rtl865x_referVlan(entry->vid);
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+		/*register 2 ingress chains: system/user*/
+		retval = rtl865x_regist_aclChain(netif->name, RTL865X_ACL_SYSTEM_USED, RTL865X_ACL_INGRESS);
+#if RTL_LAYERED_DRIVER_DEBUG
+		printk("register system acl chain, return %d\n",retval);
+		_rtl865x_print_freeChainNum();
+#endif
+		retval = rtl865x_regist_aclChain(netif->name, RTL865X_ACL_USER_USED, RTL865X_ACL_INGRESS);
+		retval = rtl865x_regist_aclChain(netif->name, RTL865X_ACL_USER_USED, RTL865X_ACL_EGRESS);
+
+#if RTL_LAYERED_DRIVER_DEBUG
+		printk("register user acl chain, return %d\n",retval);
+		_rtl865x_print_freeChainNum();
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+		retval = rtl865x_regist_aclChain(netif->name, RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS);
+		retval = rtl865x_regist_aclChain(netif->name, RTL865X_ACL_QOS_USED1, RTL865X_ACL_INGRESS);
+#endif
+#endif //CONFIG_RTL_LAYERED_DRIVER_ACL
+	}
+
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_delNetif(char *name)
+{
+	rtl865x_netif_local_t *entry;
+	int32 retval = FAILED;
+
+	/*FIXME:hyking, get swNetif entry.....*/
+	entry = _rtl865x_getSWNetifByName(name);
+	if(entry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	if(entry->refCnt > 1)
+	{
+		printk("name(%s),refcnt(%d)\n",name,entry->refCnt);
+		return RTL_EREFERENCEDBYOTHER;
+	}
+
+	if(entry->is_slave == 0)
+	{
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+		retval = _rtl865x_unRegister_all_aclChain(name);
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+		Netif_Asic2Sw_Mapping[entry->asicIdx] = -1;
+#endif
+		retval = rtl865x_delNetInterfaceByVid(entry->vid);
+		if(retval == SUCCESS)
+		{
+			rtl865x_deReferVlan(entry->vid);
+
+			/*flush acl*/
+			#if 0
+			do_eventAction(EV_DEL_NETIF, (void*)entry);
+			#else
+			rtl865x_raiseEvent(EVENT_DEL_NETIF, (void*)entry);
+			#endif
+		}
+
+		/*now delete all slave interface whose master is the deleting master interface*/
+		{
+			int32 i ;
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+			{
+				if(netifTbl[i].valid == 1 && netifTbl[i].is_slave == 1 && netifTbl[i].master == entry)
+					netifTbl[i].master = NULL;
+			}
+		}
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+#if RTL_LAYERED_DRIVER_DEBUG
+		printk("unregist all acl chain, return %d\n",retval);
+		_rtl865x_print_freeChainNum();
+#endif
+#endif
+	}
+
+	//entry->valid = 0;
+	memset(entry,0,sizeof(rtl865x_netif_local_t));
+	retval = SUCCESS;
+
+	return retval;
+}
+
+static int32 _rtl865x_referNetif(char *ifName)
+{
+	rtl865x_netif_local_t *entry;
+	if(ifName == NULL)
+		return FAILED;
+
+	entry = _rtl865x_getSWNetifByName(ifName);
+	if(entry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	entry->refCnt++;
+	return SUCCESS;
+}
+
+static int32 _rtl865x_deReferNetif(char *ifName)
+{
+	rtl865x_netif_local_t *entry;
+	if(ifName == NULL)
+		return FAILED;
+
+	entry = _rtl865x_getSWNetifByName(ifName);
+	if(entry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	entry->refCnt--;
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_setNetifVid(char *name, uint16 vid)
+{
+	rtl865x_netif_local_t *entry;
+
+	if(name == NULL || vid < 1 ||vid > 4095)
+		return RTL_EINVALIDINPUT;
+
+	entry = _rtl865x_getSWNetifByName(name);
+
+	if(entry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	if(entry->vid > 0 && entry->vid <= 4095)
+		rtl865x_deReferVlan(entry->vid);
+
+	entry->vid = vid;
+
+	/*update asic table*/
+	if (entry->is_slave)
+		return SUCCESS;
+	else
+		return _rtl865x_setAsicNetif(entry);
+}
+
+
+static int32 _rtl865x_setNetifType(char *name, uint32 ifType)
+{
+	rtl865x_netif_local_t *entry;
+
+	if(name == NULL || ifType <= IF_NONE ||ifType > IF_L2TP)
+		return RTL_EINVALIDINPUT;
+
+	entry = _rtl865x_getSWNetifByName(name);
+
+	if(entry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	entry->if_type = ifType;
+
+	return SUCCESS;
+}
+
+int32 _rtl865x_setNetifMac(rtl865x_netif_t *netif)
+{
+	int32 retval = FAILED;
+	rtl865x_netif_local_t *entry;
+
+	if(netif == NULL)
+		return RTL_EINVALIDINPUT;
+	entry = _rtl865x_getNetifByName(netif->name);
+
+	if(entry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	entry->macAddr = netif->macAddr;
+
+	/*update asic table*/
+	retval = _rtl865x_setAsicNetif(entry);
+
+	return retval;
+
+}
+
+int32 _rtl865x_setNetifMtu(rtl865x_netif_t *netif)
+{
+	int32 retval = FAILED;
+	rtl865x_netif_local_t *entry;
+	entry = _rtl865x_getNetifByName(netif->name);
+
+	if(entry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	entry->mtu = netif->mtu;
+	#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	entry->mtuV6 = netif->mtuV6;
+	#endif
+	/*update asic table*/
+	retval = _rtl865x_setAsicNetif(entry);
+
+	return retval;
+
+}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+int32 _rtl865x_setNetifMtuV6(rtl865x_netif_t *netif)
+{
+	int32 retval = FAILED;
+	rtl865x_netif_local_t *entry;
+	entry = _rtl865x_getNetifByName(netif->name);
+
+	if(entry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	entry->mtuV6 = netif->mtuV6;
+
+	/*update asic table*/
+	retval = _rtl865x_setAsicNetif(entry);
+	return retval;
+}
+#endif
+
+int32 _rtl865x_getNetifIdxByVid(uint16 vid)
+{
+	int32 i;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		if(netifTbl[i].valid == 1 && netifTbl[i].vid == vid)
+			break;
+	}
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	if(i == NETIF_SW_NUMBER)
+#else
+	if(i == NETIF_NUMBER)
+#endif
+		return -1;
+
+	return i;
+}
+
+int32 _rtl865x_getNetifIdxByName(uint8 *name)
+{
+	int32 i;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		if(netifTbl[i].valid == 1 && memcmp(netifTbl[i].name,name,strlen(name)) == 0)
+			break;
+	}
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	if(i == NETIF_SW_NUMBER)
+#else
+	if(i == NETIF_NUMBER)
+#endif
+		return -1;
+
+	return i;
+}
+
+int32 _rtl865x_getNetifIdxByNameExt(uint8 *name)
+{
+	int32 i;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		if(netifTbl[i].valid == 1 && memcmp(netifTbl[i].name,name,strlen(name)) == 0)
+		{
+			if (netifTbl[i].is_slave==TRUE)
+			{
+				if(netifTbl[i].master)
+					return _rtl865x_getNetifIdxByNameExt(netifTbl[i].master->name);
+				else
+					return -1;
+			}
+			else
+				return i;
+		}
+	}
+
+	return -1;
+}
+
+int32 _rtl865x_getAclFromAsic(int32 index, rtl865x_AclRule_t *rule)
+{
+	rtl865xc_tblAsic_aclTable_t	   entry;
+
+	if(index >=	RTL865X_ACL_MAX_NUMBER + RTL865X_ACL_RESERVED_NUMBER ||	rule ==	NULL)
+		return FAILED;
+	_rtl8651_readAsicEntry(TYPE_ACL_RULE_TABLE,	index, &entry);
+	bzero(rule,	sizeof(rtl865x_AclRule_t));
+
+#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rule->ruleType_	 = entry.ruleType  ;
+	rule->ruleType_	|= entry.ruleType1<<4;
+	switch(rule->ruleType_)	{
+#else
+	switch(entry.ruleType) {
+#endif
+	case RTL865X_ACL_MAC: /* Ethernet rule type	*/
+		 rule->dstMac_.octet[0]		= entry.is.ETHERNET.dMacP47_32 >> 8;
+		 rule->dstMac_.octet[1]		= entry.is.ETHERNET.dMacP47_32 & 0xff;
+		 rule->dstMac_.octet[2]		= entry.is.ETHERNET.dMacP31_16 >> 8;
+		 rule->dstMac_.octet[3]		= entry.is.ETHERNET.dMacP31_16 & 0xff;
+		 rule->dstMac_.octet[4]		= entry.is.ETHERNET.dMacP15_0 >> 8;
+		 rule->dstMac_.octet[5]		= entry.is.ETHERNET.dMacP15_0 &	0xff;
+		 rule->dstMacMask_.octet[0]	= entry.is.ETHERNET.dMacM47_32 >> 8;
+		 rule->dstMacMask_.octet[1]	= entry.is.ETHERNET.dMacM47_32 & 0xff;
+		 rule->dstMacMask_.octet[2]	= entry.is.ETHERNET.dMacM31_16 >> 8;
+		 rule->dstMacMask_.octet[3]	= entry.is.ETHERNET.dMacM31_16 & 0xff;
+		 rule->dstMacMask_.octet[4]	= entry.is.ETHERNET.dMacM15_0 >> 8;
+		 rule->dstMacMask_.octet[5]	= entry.is.ETHERNET.dMacM15_0 &	0xff;
+		 rule->srcMac_.octet[0]		= entry.is.ETHERNET.sMacP47_32 >> 8;
+		 rule->srcMac_.octet[1]		= entry.is.ETHERNET.sMacP47_32 & 0xff;
+		 rule->srcMac_.octet[2]		= entry.is.ETHERNET.sMacP31_16 >> 8;
+		 rule->srcMac_.octet[3]		= entry.is.ETHERNET.sMacP31_16 & 0xff;
+		 rule->srcMac_.octet[4]		= entry.is.ETHERNET.sMacP15_0 >> 8;
+		 rule->srcMac_.octet[5]		= entry.is.ETHERNET.sMacP15_0 &	0xff;
+		 rule->srcMacMask_.octet[0]	= entry.is.ETHERNET.sMacM47_32 >> 8;
+		 rule->srcMacMask_.octet[1]	= entry.is.ETHERNET.sMacM47_32 & 0xff;
+		 rule->srcMacMask_.octet[2]	= entry.is.ETHERNET.sMacM31_16 >> 8;
+		 rule->srcMacMask_.octet[3]	= entry.is.ETHERNET.sMacM31_16 & 0xff;
+		 rule->srcMacMask_.octet[4]	= entry.is.ETHERNET.sMacM15_0 >> 8;
+		 rule->srcMacMask_.octet[5]	= entry.is.ETHERNET.sMacM15_0 &	0xff;
+		 rule->typeLen_				= entry.is.ETHERNET.ethTypeP;
+		 rule->typeLenMask_			= entry.is.ETHERNET.ethTypeM;
+		 rule->ruleType_			= entry.ruleType;
+		 break;
+
+	case RTL865X_ACL_IP: /*	IP mask	rule type */
+	case RTL865X_ACL_IP_RANGE: /* IP range rule	type*/
+		 rule->tos_			= entry.is.L3L4.is.IP.IPTOSP;
+		 rule->tosMask_		= entry.is.L3L4.is.IP.IPTOSM;
+		 rule->ipProto_		= entry.is.L3L4.is.IP.IPProtoP;
+		 rule->ipProtoMask_	= entry.is.L3L4.is.IP.IPProtoM;
+		 rule->ipFlag_		= entry.is.L3L4.is.IP.IPFlagP;
+		 rule->ipFlagMask_	= entry.is.L3L4.is.IP.IPFlagM;
+		 rule->ipFOP_ =	entry.is.L3L4.is.IP.FOP;
+		 rule->ipFOM_ =	entry.is.L3L4.is.IP.FOM;
+		 rule->ipHttpFilterM_ =	entry.is.L3L4.is.IP.HTTPM;
+		 rule->ipHttpFilter_  =	entry.is.L3L4.is.IP.HTTPP;
+		 rule->ipIdentSrcDstIp_	= entry.is.L3L4.is.IP.identSDIPM;
+		 rule->ruleType_= entry.ruleType;
+		 goto l3l4_shared;
+
+	case RTL865X_ACL_ICMP: /* ICMP	(ip	is mask) rule type */
+	case RTL865X_ACL_ICMP_IPRANGE: /* ICMP (ip is  range) rule type	*/
+		 rule->tos_	= entry.is.L3L4.is.ICMP.IPTOSP;
+		 rule->tosMask_	= entry.is.L3L4.is.ICMP.IPTOSM;
+		 rule->icmpType_ = entry.is.L3L4.is.ICMP.ICMPTypeP;
+		 rule->icmpTypeMask_ = entry.is.L3L4.is.ICMP.ICMPTypeM;
+		 rule->icmpCode_ = entry.is.L3L4.is.ICMP.ICMPCodeP;
+		 rule->icmpCodeMask_ = entry.is.L3L4.is.ICMP.ICMPCodeM;
+		 rule->ruleType_ = entry.ruleType;
+		 goto l3l4_shared;
+
+	case RTL865X_ACL_IGMP: /* IGMP (ip is mask)	rule type */
+	case RTL865X_ACL_IGMP_IPRANGE: /* IGMP (ip is range) rule type */
+		 rule->tos_	= entry.is.L3L4.is.IGMP.IPTOSP;
+		 rule->tosMask_	= entry.is.L3L4.is.IGMP.IPTOSM;
+		 rule->igmpType_ = entry.is.L3L4.is.IGMP.IGMPTypeP;
+		 rule->igmpTypeMask_ = entry.is.L3L4.is.IGMP.IGMPTypeM;
+		 rule->ruleType_ = entry.ruleType;
+		 goto l3l4_shared;
+
+	case RTL865X_ACL_TCP: /* TCP rule type */
+	case RTL865X_ACL_TCP_IPRANGE:
+		 rule->tos_	= entry.is.L3L4.is.TCP.IPTOSP;
+		 rule->tosMask_	= entry.is.L3L4.is.TCP.IPTOSM;
+		 rule->tcpFlag_	= entry.is.L3L4.is.TCP.TCPFlagP;
+		 rule->tcpFlagMask_	= entry.is.L3L4.is.TCP.TCPFlagM;
+		 rule->tcpSrcPortUB_ = entry.is.L3L4.is.TCP.TCPSPUB;
+		 rule->tcpSrcPortLB_ = entry.is.L3L4.is.TCP.TCPSPLB;
+		 rule->tcpDstPortUB_ = entry.is.L3L4.is.TCP.TCPDPUB;
+		 rule->tcpDstPortLB_ = entry.is.L3L4.is.TCP.TCPDPLB;
+		 rule->ruleType_ = entry.ruleType;
+		 goto l3l4_shared;
+
+	case RTL865X_ACL_UDP: /* UDP rule type */
+	case RTL865X_ACL_UDP_IPRANGE:
+		 rule->tos_	= entry.is.L3L4.is.UDP.IPTOSP;
+		 rule->tosMask_	= entry.is.L3L4.is.UDP.IPTOSM;
+		 rule->udpSrcPortUB_ = entry.is.L3L4.is.UDP.UDPSPUB;
+		 rule->udpSrcPortLB_ = entry.is.L3L4.is.UDP.UDPSPLB;
+		 rule->udpDstPortUB_ = entry.is.L3L4.is.UDP.UDPDPUB;
+		 rule->udpDstPortLB_ = entry.is.L3L4.is.UDP.UDPDPLB;
+		 rule->ruleType_ = entry.ruleType;
+l3l4_shared:
+		rule->srcIpAddr_ = entry.is.L3L4.sIPP;
+		rule->srcIpAddrMask_ = entry.is.L3L4.sIPM;
+		rule->dstIpAddr_ = entry.is.L3L4.dIPP;
+		rule->dstIpAddrMask_ = entry.is.L3L4.dIPM;
+		break;
+
+	case RTL865X_ACL_SRCFILTER:	/* Source Filter */
+	case RTL865X_ACL_SRCFILTER_IPRANGE:
+		 rule->srcFilterMac_.octet[0]	  =	entry.is.SRC_FILTER.sMacP47_32 >> 8;
+		 rule->srcFilterMac_.octet[1]	  =	entry.is.SRC_FILTER.sMacP47_32 & 0xff;
+		 rule->srcFilterMac_.octet[2]	  =	entry.is.SRC_FILTER.sMacP31_16 >> 8;
+		 rule->srcFilterMac_.octet[3]	  =	entry.is.SRC_FILTER.sMacP31_16 & 0xff;
+		 rule->srcFilterMac_.octet[4]	  =	entry.is.SRC_FILTER.sMacP15_0 >> 8;
+		 rule->srcFilterMac_.octet[5]	  =	entry.is.SRC_FILTER.sMacP15_0 &	0xff;
+		 if	( entry.is.SRC_FILTER.sMacM3_0&0x8)
+		{
+			 rule->srcFilterMacMask_.octet[0] =	0xff;
+			 rule->srcFilterMacMask_.octet[1] =	0xff;
+			 rule->srcFilterMacMask_.octet[2] =	0xff;
+			 rule->srcFilterMacMask_.octet[3] =	0xff;
+			 rule->srcFilterMacMask_.octet[4] =	0xff;
+			 rule->srcFilterMacMask_.octet[5] =	0xF0|entry.is.SRC_FILTER.sMacM3_0;
+		}
+		 else
+		{
+			 rule->srcFilterMacMask_.octet[0] =	0x0;
+			 rule->srcFilterMacMask_.octet[1] =	0x0;
+			 rule->srcFilterMacMask_.octet[2] =	0x0;
+			 rule->srcFilterMacMask_.octet[3] =	0x0;
+			 rule->srcFilterMacMask_.octet[4] =	0x0;
+			 rule->srcFilterMacMask_.octet[5] =	entry.is.SRC_FILTER.sMacM3_0;
+		}
+
+		 rule->srcFilterPort_ =	entry.is.SRC_FILTER.spaP;
+		 rule->srcFilterVlanIdx_ = entry.is.SRC_FILTER.sVidP;
+		 rule->srcFilterVlanIdxMask_ = entry.is.SRC_FILTER.sVidM;
+		 if(entry.is.SRC_FILTER.protoType == 2)	rule->srcFilterIgnoreL4_ = 1;
+		 else if(entry.is.SRC_FILTER.protoType == 1) rule->srcFilterIgnoreL3L4_	= 1;
+		 rule->srcFilterIpAddr_	= entry.is.SRC_FILTER.sIPP;
+		 rule->srcFilterIpAddrMask_	= entry.is.SRC_FILTER.sIPM;
+		 rule->srcFilterPortUpperBound_	= entry.is.SRC_FILTER.SPORTUB;
+		 rule->srcFilterPortLowerBound_	= entry.is.SRC_FILTER.SPORTLB;
+		 rule->ruleType_ = entry.ruleType;
+		 break;
+
+	case RTL865X_ACL_DSTFILTER:	/* Destination Filter */
+	case RTL865X_ACL_DSTFILTER_IPRANGE:	/* Destination Filter(IP range)	*/
+		 rule->dstFilterMac_.octet[0]	  =	entry.is.DST_FILTER.dMacP47_32 >> 8;
+		 rule->dstFilterMac_.octet[1]	  =	entry.is.DST_FILTER.dMacP47_32 & 0xff;
+		 rule->dstFilterMac_.octet[2]	  =	entry.is.DST_FILTER.dMacP31_16 >> 8;
+		 rule->dstFilterMac_.octet[3]	  =	entry.is.DST_FILTER.dMacP31_16 & 0xff;
+		 rule->dstFilterMac_.octet[4]	  =	entry.is.DST_FILTER.dMacP15_0 >> 8;
+		 rule->dstFilterMac_.octet[5]	  =	entry.is.DST_FILTER.dMacP15_0 &	0xff;
+		 if	( entry.is.DST_FILTER.dMacM3_0&0x8)
+		{
+			 rule->dstFilterMacMask_.octet[0] =	0xff;
+			 rule->dstFilterMacMask_.octet[1] =	0xff;
+			 rule->dstFilterMacMask_.octet[2] =	0xff;
+			 rule->dstFilterMacMask_.octet[3] =	0xff;
+			 rule->dstFilterMacMask_.octet[4] =	0xff;
+			 rule->dstFilterMacMask_.octet[5] =	0xF0|entry.is.DST_FILTER.dMacM3_0;
+		}
+		 else
+		{
+			 rule->dstFilterMacMask_.octet[0] =	0x0;
+			 rule->dstFilterMacMask_.octet[1] =	0x0;
+			 rule->dstFilterMacMask_.octet[2] =	0x0;
+			 rule->dstFilterMacMask_.octet[3] =	0x0;
+			 rule->dstFilterMacMask_.octet[4] =	0x0;
+			 rule->dstFilterMacMask_.octet[5] =	entry.is.DST_FILTER.dMacM3_0;
+		}
+
+
+		 rule->dstFilterVlanIdx_ = entry.is.DST_FILTER.vidP;
+		 rule->dstFilterVlanIdxMask_ = entry.is.DST_FILTER.vidM;
+		 if(entry.is.DST_FILTER.protoType == 1)	rule->dstFilterIgnoreL3L4_ = 1;
+		 else if(entry.is.DST_FILTER.protoType == 2) rule->dstFilterIgnoreL4_ =	1;
+		 rule->dstFilterIpAddr_	= entry.is.DST_FILTER.dIPP;
+		 rule->dstFilterIpAddrMask_	= entry.is.DST_FILTER.dIPM;
+		 rule->dstFilterPortUpperBound_	= entry.is.DST_FILTER.DPORTUB;
+		 rule->dstFilterPortLowerBound_	= entry.is.DST_FILTER.DPORTLB;
+		 rule->ruleType_ = entry.ruleType;
+		 break;
+
+#if	defined(CONFIG_RTL_8197F)
+	case RTL865X_ACL_IPV6: /* IP Rule Type:	0x0010 */
+	case RTL865X_ACL_IPV6_RANGE:
+
+		if(entry.ipv6ETY0)//first entry
+		{
+			rule->srcIpV6Addr_.v6_addr32[3]	= entry.is.L3V6.is.entry0.sip_addr31_0;
+			rule->srcIpV6Addr_.v6_addr32[2]	= entry.is.L3V6.is.entry0.sip_addr63_32;
+			rule->srcIpV6Addr_.v6_addr32[1]	= entry.is.L3V6.is.entry0.sip_addr95_64;
+			rule->srcIpV6Addr_.v6_addr32[0]	= entry.is.L3V6.is.entry0.sip_addr127_96;
+
+			rule->srcIpV6AddrMask_.v6_addr32[3]	= entry.is.L3V6.is.entry0.sip_mask31_0;
+			rule->srcIpV6AddrMask_.v6_addr32[2]	= entry.is.L3V6.is.entry0.sip_mask63_32;
+			rule->srcIpV6AddrMask_.v6_addr32[1]	= entry.is.L3V6.is.entry0.sip_mask95_64;
+
+			rule->srcIpV6AddrMask_.v6_addr32[0]	=  entry.is_d.ipv6.is.entry0.sip_mask119_96;
+			rule->srcIpV6AddrMask_.v6_addr32[0]	|= entry.is_d.ipv6.is.entry0.sip_mask127_120 <<24;
+			rule->ipv6FlowLabel_  =	 entry.is_d.ipv6.is.entry0.flowLabel;
+			rule->ipv6FlowLabelM_ =	 entry.is_d.ipv6.is.entry0.flowLabelM3_0;
+			rule->ipv6FlowLabelM_ |= entry.is_d.ipv6.is.entry0.flowLabelM19_4<<4;
+		}
+		else
+		{
+			rule->dstIpV6Addr_.v6_addr32[3]	= entry.is.L3V6.is.entry1.dip_addr31_0;
+			rule->dstIpV6Addr_.v6_addr32[2]	= entry.is.L3V6.is.entry1.dip_addr63_32;
+			rule->dstIpV6Addr_.v6_addr32[1]	= entry.is.L3V6.is.entry1.dip_addr95_64;
+			rule->dstIpV6Addr_.v6_addr32[0]	= entry.is.L3V6.is.entry1.dip_addr127_96;
+
+			rule->dstIpV6AddrMask_.v6_addr32[3]	= entry.is.L3V6.is.entry1.dip_mask31_0;
+			//entry.is.L3V6.is.entry1.dip_mask63_32	 = rule->dstIpV6AddrMask_.v6_addr32[2];
+			//entry.is.L3V6.is.entry1.dip_mask95_64	 = rule->dstIpV6AddrMask_.v6_addr32[1];
+			rule->dstIpV6AddrMask_.v6_addr32[2]	= entry.is.L3V6.is.entry1.dip_mask63_32;
+			rule->dstIpV6AddrMask_.v6_addr32[1]	= entry.is.L3V6.is.entry1.dip_mask95_64;
+
+			rule->dstIpV6AddrMask_.v6_addr32[0]	= entry.is_d.ipv6.is.entry1.dip_mask119_96;
+			rule->dstIpV6AddrMask_.v6_addr32[0]	|= entry.is_d.ipv6.is.entry1.dip_mask127_120<<24;
+			rule->ipv6TrafficClass_	 = entry.is_d.ipv6.is.entry1.trafficClass;
+			rule->ipv6TrafficClassM_ = entry.is_d.ipv6.is.entry1.trafficClassM;
+			rule->ipv6NextHeader_	 = entry.is_d.ipv6.is.entry1.nextHeader;
+			rule->ipv6NextHeaderM_	 = entry.is_d.ipv6.is.entry1.nextHeaderM;
+			rule->ipv6HttpFilter_	 = entry.is_d.ipv6.is.entry1.HTTPP;
+			rule->ipv6HttpFilterM_	  =	entry.is_d.ipv6.is.entry1.HTTPM;
+			rule->ipv6IdentSrcDstIp_ = entry.is_d.ipv6.is.entry1.identSDIPP;
+			rule->ipv6IdentSrcDstIpM_ =	entry.is_d.ipv6.is.entry1.identSDIPM;
+		}
+
+		rule->ipv6Invert_	 = entry.inv;
+		rule->ipv6EntryType_ = entry.ipv6ETY0;
+		rule->ipv6Combine_	= entry.comb ;
+		rule->ipv6IPtunnel_	= entry.ip_tunnel;
+		break;
+#elif defined(CONFIG_RTL_8198C)
+	case RTL865X_ACL_IPV6: /* IP Rule Type:	0x0010 */
+	case RTL865X_ACL_IPV6_RANGE:
+
+		if(entry.ipv6ETY0)//first entry
+		{
+			rule->srcIpV6Addr_.v6_addr32[3]	= entry.is.L3V6.is.entry0.sip_addr31_0;
+			rule->srcIpV6Addr_.v6_addr32[2]	= entry.is.L3V6.is.entry0.sip_addr63_32;
+			rule->srcIpV6Addr_.v6_addr32[1]	= entry.is.L3V6.is.entry0.sip_addr95_64;
+			rule->srcIpV6Addr_.v6_addr32[0]	= entry.is.L3V6.is.entry0.sip_addr127_96;
+
+			rule->srcIpV6AddrMask_.v6_addr32[3]	= entry.is.L3V6.is.entry0.sip_mask31_0;
+			rule->srcIpV6AddrMask_.v6_addr32[2]	= entry.is.L3V6.is.entry0.sip_mask63_32;
+			rule->srcIpV6AddrMask_.v6_addr32[1]	= entry.is.L3V6.is.entry0.sip_mask95_64;
+
+			rule->srcIpV6AddrMask_.v6_addr32[0]	=  entry.ipv6.is.entry0.sip_mask119_96;
+			rule->srcIpV6AddrMask_.v6_addr32[0]	|= entry.ipv6.is.entry0.sip_mask127_120	<<24;
+			rule->ipv6FlowLabel_  =	 entry.ipv6.is.entry0.flowLabel;
+			rule->ipv6FlowLabelM_ =	 entry.ipv6.is.entry0.flowLabelM3_0;
+			rule->ipv6FlowLabelM_ |= entry.ipv6.is.entry0.flowLabelM19_4<<4;
+		}
+		else
+		{
+			rule->dstIpV6Addr_.v6_addr32[3]	= entry.is.L3V6.is.entry1.dip_addr31_0;
+			rule->dstIpV6Addr_.v6_addr32[2]	= entry.is.L3V6.is.entry1.dip_addr63_32;
+			rule->dstIpV6Addr_.v6_addr32[1]	= entry.is.L3V6.is.entry1.dip_addr95_64;
+			rule->dstIpV6Addr_.v6_addr32[0]	= entry.is.L3V6.is.entry1.dip_addr127_96;
+
+			rule->dstIpV6AddrMask_.v6_addr32[3]	= entry.is.L3V6.is.entry1.dip_mask31_0;
+			//entry.is.L3V6.is.entry1.dip_mask63_32	 = rule->dstIpV6AddrMask_.v6_addr32[2];
+			//entry.is.L3V6.is.entry1.dip_mask95_64	 = rule->dstIpV6AddrMask_.v6_addr32[1];
+			rule->dstIpV6AddrMask_.v6_addr32[2]	= entry.is.L3V6.is.entry1.dip_mask63_32;
+			rule->dstIpV6AddrMask_.v6_addr32[1]	= entry.is.L3V6.is.entry1.dip_mask95_64;
+
+			rule->dstIpV6AddrMask_.v6_addr32[0]	= entry.ipv6.is.entry1.dip_mask119_96;
+			rule->dstIpV6AddrMask_.v6_addr32[0]	|= entry.ipv6.is.entry1.dip_mask127_120<<24;
+			rule->ipv6TrafficClass_	 = entry.ipv6.is.entry1.trafficClass;
+			rule->ipv6TrafficClassM_ = entry.ipv6.is.entry1.trafficClassM;
+			rule->ipv6NextHeader_	 = entry.ipv6.is.entry1.nextHeader;
+			rule->ipv6NextHeaderM_	 = entry.ipv6.is.entry1.nextHeaderM;
+			rule->ipv6HttpFilter_	 = entry.ipv6.is.entry1.HTTPP;
+			rule->ipv6HttpFilterM_	  =	entry.ipv6.is.entry1.HTTPM;
+			rule->ipv6IdentSrcDstIp_ = entry.ipv6.is.entry1.identSDIPP;
+			rule->ipv6IdentSrcDstIpM_ =	entry.ipv6.is.entry1.identSDIPM;
+		}
+
+		rule->ipv6Invert_	 = entry.inv;
+		rule->ipv6EntryType_ = entry.ipv6ETY0;
+		rule->ipv6Combine_	= entry.comb ;
+		rule->ipv6IPtunnel_	= entry.ip_tunnel;
+		break;
+#endif
+
+#if	defined(CONFIG_RTL_8197F)
+	case RTL865X_ACL_PM: /*	acl	pattern	match */
+		if(entry.ipv6ETY0)//first entry
+		{
+			rule->pmSPUB_ =	entry.is.PM_U.is.entry0.spub;
+			rule->pmSPLB_ =	entry.is.PM_U.is.entry0.splb;
+			rule->pmDPUB_ =	entry.is.PM_U.is.entry0.dpub;
+			rule->pmDPLB_ =	entry.is.PM_U.is.entry0.dplb;
+			rule->pmProtocol_ =	entry.is.PM_U.is.entry0.protocol;
+
+			rule->pmOffset0_  =	entry.is.PM_U.is.entry0.offset0;
+			rule->pmPattern0_ =	entry.is.PM_U.is.entry0.pattern0;
+			rule->pmPatternMask0_ =	((entry.is.PM_U.is.entry0.pm0_15_1<<1 )
+										| entry.is.PM_U.is.entry0.pm0_0);
+			rule->pmOR0_ =entry.is.PM_U.is.entry0.or0 ;
+
+			rule->pmOffset1_	  =	entry.is.PM_U.is.entry0.offset1;
+			rule->pmPattern1_ =	((entry.is.PM_U.is.entry0.pattern1_8_0)
+								|(entry.is.PM_U.is.entry0.pattern1_15_9<<9));
+			rule->pmPatternMask1_ =	entry.is.PM_U.is.entry0.pm1;
+			rule->pmOR1_		  =	entry.is.PM_U.is.entry0.or1;
+
+			rule->pmOffset2_	  =	entry.is.PM_U.is.entry0.offset2;
+			rule->pmPattern2_ =	(entry.is.PM_U.is.entry0.pattern2_0
+							  |( entry.is.PM_U.is.entry0.pattern2_15_1<<1));
+			rule->pmPatternMask2_ =	entry.is.PM_U.is.entry0.pm2;
+			rule->pmOR2_		  =	entry.is.PM_U.is.entry0.or2;
+
+			rule->pmOffset3_  =	entry.is_d.PM_D.is.entry0.offset3;
+			rule->pmPattern3_ =	entry.is_d.PM_D.is.entry0.pattern3;
+			rule->pmPatternMask3_ =	(entry.is_d.PM_D.is.entry0.pm3_8_0
+								   |(entry.is_d.PM_D.is.entry0.pm3_15_9<<9));
+			rule->pmOR3_ = entry.is_d.PM_D.is.entry0.or3;
+		}
+		else
+		{
+			rule->pmOffset4_	  =	entry.is.PM_U.is.entry1.offset4;
+			rule->pmPattern4_	  =	entry.is.PM_U.is.entry1.pattern4;
+			rule->pmPatternMask4_ =	(entry.is.PM_U.is.entry1.pm4_8_0
+								  |	(entry.is.PM_U.is.entry1.pm4_15_9<<9));
+
+			rule->pmOR4_		  =	entry.is.PM_U.is.entry1.or4;
+
+			rule->pmOffset5_ = entry.is.PM_U.is.entry1.offset5;
+			rule->pmPattern5_ =	entry.is.PM_U.is.entry1.pattern5;
+			rule->pmPatternMask5_ =	(entry.is.PM_U.is.entry1.pm5_0
+									|(entry.is.PM_U.is.entry1.pm5_15_1<<1));
+			rule->pmOR5_ = entry.is.PM_U.is.entry1.or5;
+
+			rule->pmOffset6_ = entry.is.PM_U.is.entry1.offset6;
+			rule->pmPattern6_ =	(entry.is.PM_U.is.entry1.pattern6_8_0
+							   |(entry.is.PM_U.is.entry1.pattern6_15_9<<9));
+			rule->pmPatternMask6_ =	entry.is.PM_U.is.entry1.pm6;
+			rule->pmOR6_ = entry.is.PM_U.is.entry1.or6;
+
+			rule->pmOffset7_  =	entry.is.PM_U.is.entry1.offset7;
+			rule->pmPattern7_ =	(entry.is.PM_U.is.entry1.pattern7_0
+							   |(entry.is.PM_U.is.entry1.pattern7_15_1<<1));
+			rule->pmPatternMask7_ =	entry.is.PM_U.is.entry1.pm7;
+			rule->pmOR7_ = entry.is.PM_U.is.entry1.or7;
+
+			rule->pmSpecialop_ = entry.is.PM_U.is.entry1.specialop;
+			rule->pmSPA_ = entry.is.PM_U.is.entry1.spa;
+			rule->pmSPAM_ =	entry.is.PM_U.is.entry1.spam;
+			rule->pmPPPCTL_	= entry.is.PM_U.is.entry1.pppctl;
+			rule->pmPPPCTLM_ = entry.is.PM_U.is.entry1.pppctlm;
+			rule->pmPPPCTLOR_ =	entry.is.PM_U.is.entry1.pppctl_or;
+		}
+		rule->ipv6IPtunnel_	= entry.ip_tunnel;
+		rule->ipfrag_apply_	= entry.is_d.PM_D.is.entry1.ipfrag_apply;
+		rule->ipv6EntryType_ = entry.ipv6ETY0;
+		break;
+#endif
+	default: return	FAILED;	/* Unknown rule	type */
+
+	}
+
+	#if	defined(CONFIG_RTL_8197F) || defined(CONFIG_RTL_8198C)
+	rule->ipv6Combine_	= entry.comb;
+	rule->ipv6Invert_	 = entry.inv;
+	rule->ipv6IPtunnel_	= entry.ip_tunnel;
+	#endif
+
+	#if	defined(CONFIG_RTL_8197F)
+	rule->ipfrag_apply_ = entry.is_d.PM_D.is.entry1.ipfrag_apply;
+	#endif
+
+	rule->aclIdx = index;
+
+	switch(entry.actionType) {
+
+	case RTL865X_ACL_PERMIT:
+	case RTL865X_ACL_REDIRECT_ETHER:
+	case RTL865X_ACL_DROP:
+	case RTL865X_ACL_TOCPU:
+	case RTL865X_ACL_LEGACY_DROP:
+	case RTL865X_ACL_DROPCPU_LOG:
+	case RTL865X_ACL_MIRROR:
+	case RTL865X_ACL_REDIRECT_PPPOE:
+	case RTL865X_ACL_MIRROR_KEEP_MATCH:
+		rule->L2Idx_ = entry.nextHop ;
+		rule->netifIdx_	=  entry.vid;
+		rule->pppoeIdx_	= entry.PPPoEIndex;
+		 break;
+
+	case RTL865X_ACL_DEFAULT_REDIRECT:
+		rule->nexthopIdx_ =	entry.nextHop;
+		break;
+
+	case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+		rule->ratelimtIdx_ = entry.nextHop;
+		break;
+	case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+		rule->ratelimtIdx_ = entry.nextHop;
+		break;
+	case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+		rule->ratelimtIdx_ = entry.nextHop;
+		break;
+	case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+		rule->ratelimtIdx_ = entry.nextHop;
+		break;
+	case RTL865X_ACL_PRIORITY:
+		rule->priority_	= entry.nextHop;
+		break;
+
+#if	defined(CONFIG_RTL_8197F)
+	case RTL865X_ACL_VID:
+		rule->aclvid_ =	(entry.nextHop | (entry.vid	<<10)) & 0xfff;
+		rule->aclfid_ =	((entry.PPPoEIndex << 1)| (entry.vid >>2)) & 0x3;
+		break;
+
+#elif defined(CONFIG_RTL_8198C)
+	case RTL865X_ACL_VID:
+		rule->aclvid_ =	(entry.nextHop | (entry.vid	<<10)) & 0xfff;
+		break;
+#endif
+
+	}
+
+	rule->actionType_ =	entry.actionType;
+	rule->pktOpApp_	= entry.pktOpApp;
+
+	return SUCCESS;
+
+}
+
+static int32 _rtl865x_setAclToAsic(int32 startIdx, rtl865x_AclRule_t *rule)
+{
+	rtl865xc_tblAsic_aclTable_t entry;
+
+	if(rule->aclIdx >= RTL865X_ACL_MAX_NUMBER + RTL865X_ACL_RESERVED_NUMBER || rule == NULL)
+		return FAILED;
+
+	memset(&entry, 0, sizeof(entry));
+	switch(rule->ruleType_)
+	{
+
+	case RTL865X_ACL_MAC:			/* Etnernet Rule Type : 0x0000 */
+		 entry.is.ETHERNET.dMacP47_32 = rule->dstMac_.octet[0]<<8 | rule->dstMac_.octet[1];
+		 entry.is.ETHERNET.dMacP31_16 = rule->dstMac_.octet[2]<<8 | rule->dstMac_.octet[3];
+		 entry.is.ETHERNET.dMacP15_0 = rule->dstMac_.octet[4]<<8 | rule->dstMac_.octet[5];
+	 	 entry.is.ETHERNET.dMacM47_32 = rule->dstMacMask_.octet[0]<<8 | rule->dstMacMask_.octet[1];
+		 entry.is.ETHERNET.dMacM31_16 = rule->dstMacMask_.octet[2]<<8 | rule->dstMacMask_.octet[3];
+		 entry.is.ETHERNET.dMacM15_0 = rule->dstMacMask_.octet[4]<<8 | rule->dstMacMask_.octet[5];
+		 entry.is.ETHERNET.sMacP47_32 = rule->srcMac_.octet[0]<<8 | rule->srcMac_.octet[1];
+		 entry.is.ETHERNET.sMacP31_16 = rule->srcMac_.octet[2]<<8 | rule->srcMac_.octet[3];
+		 entry.is.ETHERNET.sMacP15_0 = rule->srcMac_.octet[4]<<8 | rule->srcMac_.octet[5];
+		 entry.is.ETHERNET.sMacM47_32 = rule->srcMacMask_.octet[0]<<8 | rule->srcMacMask_.octet[1];
+		 entry.is.ETHERNET.sMacM31_16 = rule->srcMacMask_.octet[2]<<8 | rule->srcMacMask_.octet[3];
+		 entry.is.ETHERNET.sMacM15_0 = rule->srcMacMask_.octet[4]<<8 | rule->srcMacMask_.octet[5];
+		 entry.is.ETHERNET.ethTypeP = rule->typeLen_;
+		 entry.is.ETHERNET.ethTypeM = rule->typeLenMask_;
+
+		 entry.ruleType = rule->ruleType_;
+		 break;
+
+	case RTL865X_ACL_IP:			/* IP Rule Type: 0x0002 */
+	case RTL865X_ACL_IP_RANGE:						/* 0x0010 */
+		 entry.is.L3L4.is.IP.IPTOSP = rule->tos_;
+		 entry.is.L3L4.is.IP.IPTOSM = rule->tosMask_;
+		 entry.is.L3L4.is.IP.IPProtoP = rule->ipProto_;
+		 entry.is.L3L4.is.IP.IPProtoM = rule->ipProtoMask_;
+		 entry.is.L3L4.is.IP.IPFlagP = rule->ipFlag_;
+		 entry.is.L3L4.is.IP.IPFlagM = rule->ipFlagMask_;
+		 entry.is.L3L4.is.IP.FOP = rule->ipFOP_;
+		 entry.is.L3L4.is.IP.FOM = rule->ipFOM_;
+		 entry.is.L3L4.is.IP.HTTPP = entry.is.L3L4.is.IP.HTTPM = rule->ipHttpFilter_;
+		 entry.is.L3L4.is.IP.identSDIPP = entry.is.L3L4.is.IP.identSDIPM = rule->ipIdentSrcDstIp_;
+
+		 goto l3l4_shared;
+
+	case RTL865X_ACL_ICMP:			/* ICMP Rule Type: 0x0004 */
+	case RTL865X_ACL_ICMP_IPRANGE:					/* 0x000C */
+		 entry.is.L3L4.is.ICMP.IPTOSP = rule->tos_;
+		 entry.is.L3L4.is.ICMP.IPTOSM = rule->tosMask_;
+		 entry.is.L3L4.is.ICMP.ICMPTypeP = rule->icmpType_;
+		 entry.is.L3L4.is.ICMP.ICMPTypeM = rule->icmpTypeMask_;
+		 entry.is.L3L4.is.ICMP.ICMPCodeP = rule->icmpCode_;
+		 entry.is.L3L4.is.ICMP.ICMPCodeM = rule->icmpCodeMask_;
+		 goto l3l4_shared;
+
+	case RTL865X_ACL_IGMP:			/* IGMP Rule Type: 0x0005 */
+	case RTL865X_ACL_IGMP_IPRANGE:					/* 0x000D */
+		 entry.is.L3L4.is.IGMP.IPTOSP = rule->tos_;
+		 entry.is.L3L4.is.IGMP.IPTOSM = rule->tosMask_;
+		 entry.is.L3L4.is.IGMP.IGMPTypeP = rule->igmpType_;
+		 entry.is.L3L4.is.IGMP.IGMPTypeM = rule->igmpTypeMask_;
+
+		 goto l3l4_shared;
+
+	case RTL865X_ACL_TCP:			/* TCP Rule Type: 0x0006 */
+	case RTL865X_ACL_TCP_IPRANGE:					/* 0x000E */
+		 entry.is.L3L4.is.TCP.IPTOSP = rule->tos_;
+		 entry.is.L3L4.is.TCP.IPTOSM = rule->tosMask_;
+		 entry.is.L3L4.is.TCP.TCPFlagP = rule->tcpFlag_;
+		 entry.is.L3L4.is.TCP.TCPFlagM = rule->tcpFlagMask_;
+		 entry.is.L3L4.is.TCP.TCPSPUB = rule->tcpSrcPortUB_;
+		 entry.is.L3L4.is.TCP.TCPSPLB = rule->tcpSrcPortLB_;
+		 entry.is.L3L4.is.TCP.TCPDPUB = rule->tcpDstPortUB_;
+		 entry.is.L3L4.is.TCP.TCPDPLB = rule->tcpDstPortLB_;
+
+		 goto l3l4_shared;
+
+	case RTL865X_ACL_UDP:			/* TCP Rule Type: 0x0007 */
+	case RTL865X_ACL_UDP_IPRANGE:					/* 0x000F */
+		 entry.is.L3L4.is.UDP.IPTOSP = rule->tos_;
+		 entry.is.L3L4.is.UDP.IPTOSM = rule->tosMask_;
+		 entry.is.L3L4.is.UDP.UDPSPUB = rule->udpSrcPortUB_;
+		 entry.is.L3L4.is.UDP.UDPSPLB = rule->udpSrcPortLB_;
+		 entry.is.L3L4.is.UDP.UDPDPUB = rule->udpDstPortUB_;
+		 entry.is.L3L4.is.UDP.UDPDPLB = rule->udpDstPortLB_;
+
+l3l4_shared:
+		 entry.ruleType = rule->ruleType_;
+		 #if defined(CONFIG_RTD_1295_HWNAT)
+		 entry.is.L3L4.sIPP = htonl(rule->srcIpAddr_);
+		 entry.is.L3L4.sIPM = htonl(rule->srcIpAddrMask_);
+		 entry.is.L3L4.dIPP = htonl(rule->dstIpAddr_);
+		 entry.is.L3L4.dIPM = htonl(rule->dstIpAddrMask_);
+		 #else /* CONFIG_RTD_1295_HWNAT */
+		 entry.is.L3L4.sIPP = rule->srcIpAddr_;
+		 entry.is.L3L4.sIPM = rule->srcIpAddrMask_;
+		 entry.is.L3L4.dIPP = rule->dstIpAddr_;
+		 entry.is.L3L4.dIPM = rule->dstIpAddrMask_;
+		 #endif /* CONFIG_RTD_1295_HWNAT */
+		 break;
+
+	case RTL865X_ACL_SRCFILTER:		/* TCP Rule Type: 0x0008 */
+	case RTL865X_ACL_SRCFILTER_IPRANGE:				/* 0x000B */
+		 rule->srcFilterMac_.octet[0] = rule->srcFilterMac_.octet[0] & rule->srcFilterMacMask_.octet[0];
+		 rule->srcFilterMac_.octet[1] = rule->srcFilterMac_.octet[1] & rule->srcFilterMacMask_.octet[1];
+		 rule->srcFilterMac_.octet[2] = rule->srcFilterMac_.octet[2] & rule->srcFilterMacMask_.octet[2];
+		 rule->srcFilterMac_.octet[3] = rule->srcFilterMac_.octet[3] & rule->srcFilterMacMask_.octet[3];
+		 rule->srcFilterMac_.octet[4] = rule->srcFilterMac_.octet[4] & rule->srcFilterMacMask_.octet[4];
+		 rule->srcFilterMac_.octet[5] = rule->srcFilterMac_.octet[5] & rule->srcFilterMacMask_.octet[5];
+
+		 entry.is.SRC_FILTER.sMacP47_32 = rule->srcFilterMac_.octet[0]<<8 | rule->srcFilterMac_.octet[1];
+		 entry.is.SRC_FILTER.sMacP31_16 = rule->srcFilterMac_.octet[2]<<8 | rule->srcFilterMac_.octet[3];
+		 entry.is.SRC_FILTER.sMacP15_0 = rule->srcFilterMac_.octet[4]<<8 | rule->srcFilterMac_.octet[5];
+		 entry.is.SRC_FILTER.sMacM3_0 =rule->srcFilterMacMask_.octet[5] &0xf;
+
+		 rule->srcFilterVlanId_ = rule->srcFilterVlanId_ & rule->srcFilterVlanIdMask_;
+		 entry.is.SRC_FILTER.spaP = rule->srcFilterPort_;
+		 entry.is.SRC_FILTER.sVidP = rule->srcFilterVlanId_;
+		 entry.is.SRC_FILTER.sVidM = rule->srcFilterVlanIdMask_;
+		 if(rule->srcFilterIgnoreL3L4_)
+		 	entry.is.SRC_FILTER.protoType = 1;
+		 else if(rule->srcFilterIgnoreL4_)
+		 	entry.is.SRC_FILTER.protoType = 2;
+		 else
+		 	entry.is.SRC_FILTER.protoType = 0;
+
+		 entry.is.SRC_FILTER.sIPP = rule->srcFilterIpAddr_;
+		 entry.is.SRC_FILTER.sIPM = rule->srcFilterIpAddrMask_;
+		 entry.is.SRC_FILTER.SPORTUB = rule->srcFilterPortUpperBound_;
+		 entry.is.SRC_FILTER.SPORTLB = rule->srcFilterPortLowerBound_;
+
+		 entry.ruleType = rule->ruleType_;
+		 break;
+
+	case RTL865X_ACL_DSTFILTER:		/* TCP Rule Type: 0x0009 */
+	case RTL865X_ACL_DSTFILTER_IPRANGE:				/* 0x0001 */
+		 entry.is.DST_FILTER.dMacP47_32 = rule->dstFilterMac_.octet[0]<<8 | rule->dstFilterMac_.octet[1];
+		 entry.is.DST_FILTER.dMacP31_16 = rule->dstFilterMac_.octet[2]<<8 | rule->dstFilterMac_.octet[3];
+		 entry.is.DST_FILTER.dMacP15_0 = rule->dstFilterMac_.octet[4]<<8 | rule->dstFilterMac_.octet[5];
+	 	 entry.is.DST_FILTER.dMacM3_0 =  rule->dstFilterMacMask_.octet[5]&0xf;
+		 entry.is.DST_FILTER.vidP = rule->dstFilterVlanIdx_;
+		 entry.is.DST_FILTER.vidM = rule->dstFilterVlanIdxMask_;
+		 if(rule->dstFilterIgnoreL3L4_)
+		 	entry.is.DST_FILTER.protoType = 1;
+		 else if(rule->dstFilterIgnoreL4_)
+		 	entry.is.DST_FILTER.protoType = 2;
+		 else
+		 	entry.is.DST_FILTER.protoType = 0;
+		 entry.is.DST_FILTER.dIPP = rule->dstFilterIpAddr_;
+		 entry.is.DST_FILTER.dIPM = rule->dstFilterIpAddrMask_;
+		 entry.is.DST_FILTER.DPORTUB = rule->dstFilterPortUpperBound_;
+		 entry.is.DST_FILTER.DPORTLB = rule->dstFilterPortLowerBound_;
+
+			 entry.ruleType = rule->ruleType_;
+		 break;
+
+
+#if defined(CONFIG_RTL_8197F)
+	case RTL865X_ACL_IPV6:			/* IP Rule Type: 0x0012	*/
+	case RTL865X_ACL_IPV6_RANGE:					/* 0x001A */
+		entry.ruleType = rule->ruleType_;
+		entry.ruleType1	= rule->ruleType_>>4;
+		if(rule->ipv6EntryType_==1)	//first	entry
+		{
+			entry.is.L3V6.is.entry0.sip_addr31_0   = rule->srcIpV6Addr_.v6_addr32[3];
+			entry.is.L3V6.is.entry0.sip_addr63_32  = rule->srcIpV6Addr_.v6_addr32[2];
+			entry.is.L3V6.is.entry0.sip_addr95_64  = rule->srcIpV6Addr_.v6_addr32[1];
+			entry.is.L3V6.is.entry0.sip_addr127_96 = rule->srcIpV6Addr_.v6_addr32[0];
+
+			entry.is.L3V6.is.entry0.sip_mask31_0   = rule->srcIpV6AddrMask_.v6_addr32[3];
+			entry.is.L3V6.is.entry0.sip_mask63_32  = rule->srcIpV6AddrMask_.v6_addr32[2];
+			entry.is.L3V6.is.entry0.sip_mask95_64  = rule->srcIpV6AddrMask_.v6_addr32[1];
+
+			entry.is_d.ipv6.is.entry0.sip_mask119_96	= rule->srcIpV6AddrMask_.v6_addr32[0]&0xFFFFFF;
+			entry.is_d.ipv6.is.entry0.sip_mask127_120	= rule->srcIpV6AddrMask_.v6_addr32[0]>>24;
+			entry.is_d.ipv6.is.entry0.flowLabel			= rule->ipv6FlowLabel_;
+			entry.is_d.ipv6.is.entry0.flowLabelM3_0		= rule->ipv6FlowLabelM_&0xF;
+			entry.is_d.ipv6.is.entry0.flowLabelM19_4	= rule->ipv6FlowLabelM_>>4;
+		}
+		else
+		{
+			entry.is.L3V6.is.entry1.dip_addr31_0   = rule->dstIpV6Addr_.v6_addr32[3];
+			entry.is.L3V6.is.entry1.dip_addr63_32  = rule->dstIpV6Addr_.v6_addr32[2];
+			entry.is.L3V6.is.entry1.dip_addr95_64  = rule->dstIpV6Addr_.v6_addr32[1];
+			entry.is.L3V6.is.entry1.dip_addr127_96 = rule->dstIpV6Addr_.v6_addr32[0];
+
+			entry.is.L3V6.is.entry1.dip_mask31_0   = rule->dstIpV6AddrMask_.v6_addr32[3];
+			entry.is.L3V6.is.entry1.dip_mask63_32  = rule->dstIpV6AddrMask_.v6_addr32[2];
+			entry.is.L3V6.is.entry1.dip_mask95_64  = rule->dstIpV6AddrMask_.v6_addr32[1];
+
+			entry.is_d.ipv6.is.entry1.dip_mask119_96	= rule->dstIpV6AddrMask_.v6_addr32[0]&0xFFFFFF;
+			entry.is_d.ipv6.is.entry1.dip_mask127_120	= rule->dstIpV6AddrMask_.v6_addr32[0]>>24;
+			entry.is_d.ipv6.is.entry1.trafficClass		= rule->ipv6TrafficClass_;
+			entry.is_d.ipv6.is.entry1.trafficClassM		= rule->ipv6TrafficClassM_;
+			entry.is_d.ipv6.is.entry1.nextHeader		= rule->ipv6NextHeader_;
+
+			entry.is_d.ipv6.is.entry1.nextHeaderM		= rule->ipv6NextHeaderM_;
+			entry.is_d.ipv6.is.entry1.HTTPP		  =	entry.is_d.ipv6.is.entry1.HTTPM	= rule->ipv6HttpFilter_;
+			entry.is_d.ipv6.is.entry1.identSDIPP  =	entry.is_d.ipv6.is.entry1.identSDIPM  =	rule->ipv6IdentSrcDstIp_;
+		}
+
+		entry.inv		= rule->ipv6Invert_;
+		entry.ipv6ETY0	= rule->ipv6EntryType_;
+		entry.comb		= rule->ipv6Combine_;
+		entry.ip_tunnel	= rule->ipv6IPtunnel_;
+		break;
+#elif defined(CONFIG_RTL_8198C)
+	case RTL865X_ACL_IPV6:			/* IP Rule Type: 0x0012 */
+	case RTL865X_ACL_IPV6_RANGE:					/* 0x001A */
+		entry.ruleType = rule->ruleType_;
+		entry.ruleType1 = rule->ruleType_>>4;
+		if(rule->ipv6EntryType_==1)//first entry
+		{
+			entry.is.L3V6.is.entry0.sip_addr31_0   = rule->srcIpV6Addr_.v6_addr32[3];
+			entry.is.L3V6.is.entry0.sip_addr63_32  = rule->srcIpV6Addr_.v6_addr32[2];
+			entry.is.L3V6.is.entry0.sip_addr95_64  = rule->srcIpV6Addr_.v6_addr32[1];
+			entry.is.L3V6.is.entry0.sip_addr127_96 = rule->srcIpV6Addr_.v6_addr32[0];
+
+			entry.is.L3V6.is.entry0.sip_mask31_0   = rule->srcIpV6AddrMask_.v6_addr32[3];
+			entry.is.L3V6.is.entry0.sip_mask63_32  = rule->srcIpV6AddrMask_.v6_addr32[2];
+			entry.is.L3V6.is.entry0.sip_mask95_64  = rule->srcIpV6AddrMask_.v6_addr32[1];
+
+			entry.ipv6.is.entry0.sip_mask119_96    = rule->srcIpV6AddrMask_.v6_addr32[0]&0xFFFFFF;
+			entry.ipv6.is.entry0.sip_mask127_120   = rule->srcIpV6AddrMask_.v6_addr32[0]>>24;
+			entry.ipv6.is.entry0.flowLabel         = rule->ipv6FlowLabel_;
+			entry.ipv6.is.entry0.flowLabelM3_0     = rule->ipv6FlowLabelM_&0xF;
+			entry.ipv6.is.entry0.flowLabelM19_4    = rule->ipv6FlowLabelM_>>4;
+		}
+		else
+		{
+			entry.is.L3V6.is.entry1.dip_addr31_0   = rule->dstIpV6Addr_.v6_addr32[3];
+			entry.is.L3V6.is.entry1.dip_addr63_32  = rule->dstIpV6Addr_.v6_addr32[2];
+			entry.is.L3V6.is.entry1.dip_addr95_64  = rule->dstIpV6Addr_.v6_addr32[1];
+			entry.is.L3V6.is.entry1.dip_addr127_96 = rule->dstIpV6Addr_.v6_addr32[0];
+
+			entry.is.L3V6.is.entry1.dip_mask31_0   = rule->dstIpV6AddrMask_.v6_addr32[3];
+			entry.is.L3V6.is.entry1.dip_mask63_32  = rule->dstIpV6AddrMask_.v6_addr32[2];
+			entry.is.L3V6.is.entry1.dip_mask95_64  = rule->dstIpV6AddrMask_.v6_addr32[1];
+
+			entry.ipv6.is.entry1.dip_mask119_96    = rule->dstIpV6AddrMask_.v6_addr32[0]&0xFFFFFF;
+			entry.ipv6.is.entry1.dip_mask127_120   = rule->dstIpV6AddrMask_.v6_addr32[0]>>24;
+			entry.ipv6.is.entry1.trafficClass      = rule->ipv6TrafficClass_;
+			entry.ipv6.is.entry1.trafficClassM     = rule->ipv6TrafficClassM_;
+			entry.ipv6.is.entry1.nextHeader        = rule->ipv6NextHeader_;
+
+			entry.ipv6.is.entry1.nextHeaderM       = rule->ipv6NextHeaderM_;
+			entry.ipv6.is.entry1.HTTPP       = entry.ipv6.is.entry1.HTTPM = rule->ipv6HttpFilter_;
+			entry.ipv6.is.entry1.identSDIPP  = entry.ipv6.is.entry1.identSDIPM  = rule->ipv6IdentSrcDstIp_;
+		}
+
+		entry.inv       = rule->ipv6Invert_;
+		entry.ipv6ETY0  = rule->ipv6EntryType_;
+		entry.comb      = rule->ipv6Combine_;
+		entry.ip_tunnel = rule->ipv6IPtunnel_;
+		break;
+#endif
+#if defined(CONFIG_RTL_8197F)
+		case RTL865X_ACL_PM:			/* IP Rule Type: 0x0012 */
+			entry.ruleType = rule->ruleType_;
+			entry.ruleType1 = rule->ruleType_>>4;
+			if(rule->ipv6EntryType_==1) //first entry
+			{
+				entry.is.PM_U.is.entry0.spub = rule->un_ty.PM._spub;
+				entry.is.PM_U.is.entry0.splb = rule->un_ty.PM._splb;
+				entry.is.PM_U.is.entry0.dpub = rule->un_ty.PM._dpub;
+				entry.is.PM_U.is.entry0.dplb = rule->un_ty.PM._dplb;
+				entry.is.PM_U.is.entry0.protocol = rule->un_ty.PM._protocol;
+
+				entry.is.PM_U.is.entry0.offset0 = rule->un_ty.PM._offset0;
+				entry.is.PM_U.is.entry0.pattern0 = rule->un_ty.PM._pattern0;
+				entry.is.PM_U.is.entry0.pm0_15_1 = rule->un_ty.PM._pm0>>1;
+				entry.is.PM_U.is.entry0.pm0_0 = rule->un_ty.PM._pm0 & 0x1;
+				entry.is.PM_U.is.entry0.or0 = rule->un_ty.PM._or0;
+
+				entry.is.PM_U.is.entry0.offset1 = rule->un_ty.PM._offset1;
+				entry.is.PM_U.is.entry0.pattern1_8_0 = rule->un_ty.PM._pattern1&0x1ff;
+				entry.is.PM_U.is.entry0.pattern1_15_9 = rule->un_ty.PM._pattern1>>9;
+				entry.is.PM_U.is.entry0.pm1 = rule->un_ty.PM._pm1;
+				entry.is.PM_U.is.entry0.or1 = rule->un_ty.PM._or1;
+
+				entry.is.PM_U.is.entry0.offset2 = rule->un_ty.PM._offset2;
+				entry.is.PM_U.is.entry0.pattern2_0 = rule->un_ty.PM._pattern2&0x1;
+				entry.is.PM_U.is.entry0.pattern2_15_1 = rule->un_ty.PM._pattern2>>1;
+				entry.is.PM_U.is.entry0.pm2 = rule->un_ty.PM._pm2;
+				entry.is.PM_U.is.entry0.or2 = rule->un_ty.PM._or2;
+
+				entry.is_d.PM_D.is.entry0.offset3 = rule->un_ty.PM._offset3;
+				entry.is_d.PM_D.is.entry0.pattern3 = rule->un_ty.PM._pattern3;
+				entry.is_d.PM_D.is.entry0.pm3_8_0 = rule->un_ty.PM._pm3&0x1ff;
+				entry.is_d.PM_D.is.entry0.pm3_15_9 = rule->un_ty.PM._pm3>>9;
+				entry.is_d.PM_D.is.entry0.or3 = rule->un_ty.PM._or3;
+			}
+			else
+			{
+				entry.is.PM_U.is.entry1.offset4 = rule->un_ty.PM._offset4;
+				entry.is.PM_U.is.entry1.pattern4 = rule->un_ty.PM._pattern4;
+				entry.is.PM_U.is.entry1.pm4_8_0 = rule->un_ty.PM._pm4&0x1ff;
+				entry.is.PM_U.is.entry1.pm4_15_9 = rule->un_ty.PM._pm4>>9;
+				entry.is.PM_U.is.entry1.or4 = rule->un_ty.PM._or4;
+
+				entry.is.PM_U.is.entry1.offset5 = rule->un_ty.PM._offset5;
+				entry.is.PM_U.is.entry1.pattern5 = rule->un_ty.PM._pattern5;
+				entry.is.PM_U.is.entry1.pm5_0 = rule->un_ty.PM._pm5&0x1;
+				entry.is.PM_U.is.entry1.pm5_15_1 = rule->un_ty.PM._pm5>>1;
+				entry.is.PM_U.is.entry1.or5	= rule->un_ty.PM._or5;
+
+				entry.is.PM_U.is.entry1.offset6 = rule->un_ty.PM._offset6;
+				entry.is.PM_U.is.entry1.pattern6_8_0 = rule->un_ty.PM._pattern6&0x1ff;
+				entry.is.PM_U.is.entry1.pattern6_15_9 = rule->un_ty.PM._pattern6>>9;
+				entry.is.PM_U.is.entry1.pm6 = rule->un_ty.PM._pm6;
+				entry.is.PM_U.is.entry1.or6 = rule->un_ty.PM._or6;
+
+				entry.is.PM_U.is.entry1.offset7 = rule->un_ty.PM._offset7;
+				entry.is.PM_U.is.entry1.pattern7_0 = rule->un_ty.PM._pattern7&0x1;
+				entry.is.PM_U.is.entry1.pattern7_15_1 = rule->un_ty.PM._pattern7>>1;
+				entry.is.PM_U.is.entry1.pm7 = rule->un_ty.PM._pm7;
+				entry.is.PM_U.is.entry1.or7 = rule->un_ty.PM._or7;
+
+				entry.is.PM_U.is.entry1.specialop = rule->un_ty.PM._specialop;
+				entry.is.PM_U.is.entry1.spa = rule->un_ty.PM._spa;
+				entry.is.PM_U.is.entry1.spam = rule->un_ty.PM._spam;
+				entry.is.PM_U.is.entry1.pppctl = rule->un_ty.PM._pppctl;
+				entry.is.PM_U.is.entry1.pppctlm = rule->un_ty.PM._pppctlm;
+				entry.is.PM_U.is.entry1.pppctl_or = rule->un_ty.PM._pppctlor;
+			}
+
+			entry.inv = rule->ipv6Invert_;
+			entry.ipv6ETY0 = rule->ipv6EntryType_;
+			entry.comb = rule->ipv6Combine_;
+			entry.ip_tunnel = rule->ipv6IPtunnel_;
+			entry.is_d.PM_D.is.entry1.ipfrag_apply = rule->ipfrag_apply_;
+			break;
+#endif
+	default: return FAILED; /* Unknown rule type: -1 */
+
+	}
+
+	#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	/*   when comb = 1, will continue to check down next ACL rule,
+		the last one of the rule set must set comb = 0,
+		all ACL rule match will do the last one's action
+	*/
+	entry.comb		= rule->ipv6Combine_;
+	entry.inv		= rule->ipv6Invert_;
+	entry.ip_tunnel = rule->ipv6IPtunnel_;
+	#endif
+	#if defined(CONFIG_RTL_8197F)
+	entry.is_d.PM_D.is.entry1.ipfrag_apply = rule->ipfrag_apply_;
+	#endif
+
+	switch(rule->actionType_)
+	{
+	case RTL865X_ACL_PERMIT:
+	case RTL865X_ACL_REDIRECT_ETHER:
+	case RTL865X_ACL_DROP:
+	case RTL865X_ACL_TOCPU:
+	case RTL865X_ACL_LEGACY_DROP:
+	case RTL865X_ACL_DROPCPU_LOG:
+	case RTL865X_ACL_MIRROR:
+	case RTL865X_ACL_REDIRECT_PPPOE:
+	case RTL865X_ACL_MIRROR_KEEP_MATCH:
+		 entry.nextHop = rule->L2Idx_;
+		 entry.vid = rule->netifIdx_;
+		 entry.PPPoEIndex = rule->pppoeIdx_;
+		 break;
+
+	case RTL865X_ACL_DEFAULT_REDIRECT:
+		entry.nextHop = rule->nexthopIdx_;
+		break;
+
+	case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+		entry.nextHop = rule->ratelimtIdx_;
+		break;
+	case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+		entry.nextHop = rule->ratelimtIdx_;
+		break;
+	case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+		entry.nextHop = rule->ratelimtIdx_;
+		break;
+	case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+		entry.nextHop = rule->ratelimtIdx_;
+		break;
+	case RTL865X_ACL_PRIORITY:
+		entry.nextHop = rule->priority_;
+		break;
+#if defined(CONFIG_RTL_8197F)
+	case RTL865X_ACL_VID:
+		entry.nextHop = (rule->aclvid_ & 0x3ff);
+		entry.vid = (rule->aclvid_ & 0xc00)>>10;
+		entry.vid |= (rule->aclfid_&0x1)<<2;
+		entry.PPPoEIndex = (rule->aclfid_&0x2)>>1;
+		break;
+#elif defined(CONFIG_RTL_8198C)
+	case RTL865X_ACL_VID:
+		entry.nextHop = (rule->aclvid_ & 0x3ff);
+		entry.vid = (rule->aclvid_ & 0xc00)>>10;
+		break;
+#endif
+	}
+
+	entry.actionType = rule->actionType_;
+	entry.pktOpApp = rule->pktOpApp_;
+
+
+	return _rtl8651_forceAddAsicEntry(TYPE_ACL_RULE_TABLE, startIdx + rule->aclIdx -1, &entry);
+}
+
+/*config the reserved acl rules: default permit/drop/toCPU*/
+static int32 _rtl865x_confReservedAcl(void)
+{
+	rtl865x_AclRule_t defAcl;
+
+	/*ipv6 packet trap to cpu*/
+	memset(&defAcl,0,sizeof(rtl865x_AclRule_t));
+	defAcl.ruleType_ = RTL865X_ACL_MAC;
+	defAcl.actionType_		= RTL865X_ACL_TOCPU;
+	defAcl.aclIdx = 1;
+	defAcl.pktOpApp_		= RTL865X_ACL_ALL_LAYER;
+	defAcl.dstMac_.octet[0]=0x33;
+	defAcl.dstMac_.octet[1]=0x33;
+	defAcl.dstMac_.octet[2]=0x00;
+	defAcl.dstMac_.octet[3]=0x00;
+	defAcl.dstMac_.octet[4]=0x00;
+	defAcl.dstMac_.octet[5]=0x00;
+	defAcl.dstMacMask_.octet[0]=0xFF;
+	defAcl.dstMacMask_.octet[1]=0xFF;
+	_rtl865x_setAclToAsic(RTL865X_ACLTBL_IPV6_TO_CPU,&defAcl);
+
+	/*default permit*/
+	memset(&defAcl,0,sizeof(rtl865x_AclRule_t));
+	defAcl.actionType_ = RTL865X_ACL_PERMIT;
+	defAcl.aclIdx = 1;
+	defAcl.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+	_rtl865x_setAclToAsic(RTL865X_ACLTBL_PERMIT_ALL,&defAcl);
+
+	/*default drop*/
+	defAcl.actionType_ = RTL865X_ACL_DROP;
+	defAcl.aclIdx = 1;
+	defAcl.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+	_rtl865x_setAclToAsic(RTL865X_ACLTBL_DROP_ALL, &defAcl);
+
+	/*default to cpu*/
+	defAcl.actionType_ = RTL865X_ACL_TOCPU;
+	defAcl.aclIdx = 1;
+	defAcl.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+	_rtl865x_setAclToAsic(RTL865X_ACLTBL_ALL_TO_CPU, &defAcl);
+
+	/*hyking:set default permit when network interface decision miss match*/
+	#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+	rtl865x_setDefACLForNetDecisionMiss(RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL);
+	#endif
+
+	return SUCCESS;
+
+}
+
+/*
+@func int32 | rtl865x_reinit_acl |memory reinit.
+@rvalue SUCCESS | Success.
+@comm
+	this API must be called when system boot.
+*/
+int32 rtl865x_reinit_acl(void)
+{
+	_rtl865x_confReservedAcl();
+	return SUCCESS;
+}
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+/*=====================================
+*acl releated function
+*======================================*/
+static int32 _rtl865x_setDefACLForAllNetif(uint8 start_ingressAclIdx, uint8 end_ingressAclIdx,uint8 start_egressAclIdx,uint8 end_egressAclIdx)
+{
+	rtl865x_netif_local_t *netif = NULL;
+	int32 i;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		netif = &netifTbl[i];
+		if(netif->valid == 0 || netif->is_slave == 1)
+			continue;
+
+		netif->inAclStart = start_ingressAclIdx;
+		netif->inAclEnd = end_ingressAclIdx;
+		netif->outAclStart = start_egressAclIdx;
+		netif->outAclEnd = end_egressAclIdx;
+		_rtl865x_setAsicNetif(netif);
+	}
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+	rtl865x_setDefACLForNetDecisionMiss(start_ingressAclIdx,end_ingressAclIdx,start_egressAclIdx,end_egressAclIdx);
+#endif
+
+	return SUCCESS;
+}
+
+int32 rtl865x_setDefACLForAllNetif(uint8 start_ingressAclIdx, uint8 end_ingressAclIdx,uint8 start_egressAclIdx,uint8 end_egressAclIdx)
+{
+	_rtl865x_setDefACLForAllNetif(start_ingressAclIdx, end_ingressAclIdx,start_egressAclIdx,end_egressAclIdx);
+	return SUCCESS;
+}
+
+static int8 _rtl865x_sameAclRule(rtl865x_AclRule_t *rule1, rtl865x_AclRule_t *rule2)
+{
+
+	if (rule1->actionType_ != rule2->actionType_ || rule1->ruleType_ != rule2->ruleType_)
+		return FALSE;
+
+	switch(rule1->ruleType_) {
+	case RTL865X_ACL_MAC:
+		 if (rule1->typeLen_ != rule2->typeLen_ || rule1->typeLenMask_ != rule2->typeLenMask_)
+		 	return FALSE;
+		 if (memcmp(&rule1->dstMac_, &rule2->dstMac_, sizeof(ether_addr_t)) ||
+		 	 memcmp(&rule1->dstMacMask_, &rule2->dstMacMask_, sizeof(ether_addr_t)) ||
+			 memcmp(&rule1->srcMac_, &rule2->srcMac_, sizeof(ether_addr_t)) ||
+			 memcmp(&rule1->srcMacMask_, &rule2->srcMacMask_, sizeof(ether_addr_t)) )
+			 return FALSE;
+		 return TRUE;
+	case RTL865X_ACL_IP:
+	case RTL865X_ACL_IP_RANGE:
+		 if (rule1->ipProto_ != rule2->ipProto_ || rule1->ipProtoMask_ != rule2->ipProtoMask_ ||
+			rule1->ipFlag_ != rule2->ipFlag_ || rule1->ipFlagMask_ != rule2->ipFlagMask_)
+			return FALSE;
+		break;
+
+	case RTL865X_ACL_ICMP:
+	case RTL865X_ACL_ICMP_IPRANGE:
+		 if (rule1->icmpType_ != rule2->icmpType_ || rule1->icmpTypeMask_ != rule2->icmpTypeMask_ ||
+			rule1->icmpCode_ != rule2->icmpCode_ || rule1->icmpCodeMask_ != rule2->icmpCodeMask_)
+			return FALSE;
+		 break;
+
+	case RTL865X_ACL_IGMP:
+	case RTL865X_ACL_IGMP_IPRANGE:
+		 if(rule1->igmpType_ != rule2->igmpType_ || rule1->igmpTypeMask_ != rule2->igmpTypeMask_)
+		 	return FALSE;
+		 break;
+	case RTL865X_ACL_TCP:
+	case RTL865X_ACL_TCP_IPRANGE:
+		 if(rule1->tcpFlag_ != rule2->tcpFlag_ || rule1->tcpFlagMask_ != rule2->tcpFlagMask_ ||
+			rule1->tcpSrcPortUB_ != rule2->tcpSrcPortUB_ || rule1->tcpSrcPortLB_ != rule2->tcpSrcPortLB_ ||
+			rule1->tcpDstPortUB_ != rule2->tcpDstPortUB_ || rule1->tcpDstPortLB_ != rule2->tcpDstPortLB_)
+		 	return FALSE;
+		 break;
+	case RTL865X_ACL_UDP:
+	case RTL865X_ACL_UDP_IPRANGE:
+		 if(rule1->udpSrcPortUB_ != rule2->udpSrcPortUB_ || rule1->udpSrcPortLB_ != rule2->udpSrcPortLB_ ||
+			rule1->udpDstPortUB_ != rule2->udpDstPortUB_ || rule1->udpDstPortLB_ != rule2->udpDstPortLB_)
+			return FALSE;
+		 break;
+
+	case RTL865X_ACL_SRCFILTER:
+	case RTL865X_ACL_SRCFILTER_IPRANGE:
+		if((rule1->srcFilterPort_ != rule2->srcFilterPort_)||
+			memcmp(&rule1->srcFilterMac_, &rule2->srcFilterMac_, sizeof(ether_addr_t)) != 0||
+			memcmp(&rule1->srcFilterMacMask_, &rule2->srcFilterMacMask_,sizeof(ether_addr_t)) != 0||
+			(rule1->srcFilterVlanIdx_ != rule2->srcFilterVlanIdx_)||
+			(rule1->srcFilterVlanIdxMask_ != rule2->srcFilterVlanIdxMask_)||
+			(rule1->srcFilterIgnoreL3L4_ != rule2->srcFilterIgnoreL3L4_)||
+			(rule1->srcFilterIgnoreL4_ != rule2->srcFilterIgnoreL4_))
+		{
+			return FALSE;
+		}
+
+		if(rule1->srcFilterIgnoreL4_==0 && rule1->srcFilterIgnoreL3L4_==0)
+		{
+			if((rule1->srcFilterPortUpperBound_ != rule2->srcFilterPortUpperBound_)||
+			   (rule1->srcFilterPortLowerBound_ != rule2->srcFilterPortLowerBound_))
+				return FALSE;
+		}
+
+		if(rule1->srcFilterIgnoreL3L4_==0)
+		{
+			if((rule1->srcFilterIpAddr_ != rule2->srcFilterIpAddr_)||
+				(rule2->srcFilterIpAddrMask_ != rule2->srcFilterIpAddrMask_))
+				return FALSE;
+		}
+
+		break;
+
+	case RTL865X_ACL_DSTFILTER:
+	case RTL865X_ACL_DSTFILTER_IPRANGE:
+		if(	memcmp(&rule1->dstFilterMac_, &rule2->dstFilterMac_, sizeof(ether_addr_t)) != 0||
+			memcmp(&rule1->dstFilterMacMask_, &rule2->dstFilterMacMask_,sizeof(ether_addr_t)) != 0||
+			(rule1->dstFilterVlanIdx_ != rule2->dstFilterVlanIdx_)||
+			(rule1->dstFilterVlanIdxMask_ != rule2->dstFilterVlanIdxMask_)||
+			(rule1->dstFilterIgnoreL3L4_ != rule2->dstFilterIgnoreL3L4_)||
+			(rule1->dstFilterIgnoreL4_ != rule2->dstFilterIgnoreL4_))
+		{
+			return FALSE;
+		}
+
+		if(rule1->dstFilterIgnoreL4_==0 && rule1->dstFilterIgnoreL4_==0)
+		{
+			if((rule1->dstFilterPortUpperBound_ != rule2->dstFilterPortUpperBound_)||
+			   (rule1->dstFilterPortLowerBound_ != rule2->dstFilterPortLowerBound_))
+				return FALSE;
+		}
+
+		if(rule1->dstFilterIgnoreL3L4_==0)
+		{
+			if((rule1->dstFilterIpAddr_ != rule2->dstFilterIpAddr_)||
+				(rule2->dstFilterIpAddrMask_ != rule2->dstFilterIpAddrMask_))
+				return FALSE;
+		}
+
+		break;
+	default: return FALSE; /* Unknown rule type */
+
+	}
+	/* Compare common part */
+	if (rule1->srcIpAddr_ != rule2->srcIpAddr_ || rule1->srcIpAddrMask_ != rule2->srcIpAddrMask_ ||
+		rule1->dstIpAddr_ != rule2->dstIpAddr_ || rule1->dstIpAddrMask_ != rule2->dstIpAddrMask_ ||
+		rule1->tos_ != rule2->tos_ || rule1->tosMask_ != rule2->tosMask_ )
+		return FALSE;
+	return TRUE;
+}
+
+
+static int32 _rtl865x_addAclToChain(rtl865x_AclRule_t *rule, rtl865x_AclRule_t **head, rtl865x_AclRule_t **tail)
+{
+	rtl865x_AclRule_t *addAcl;
+	rtl865x_AclRule_t *tmpRule;
+
+	if(head == NULL || tail == NULL)
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+
+	if((*head) != NULL)
+	{
+		tmpRule = *head;
+		while(tmpRule)
+		{
+			if(_rtl865x_sameAclRule(tmpRule, rule)==TRUE)
+			{
+				return RTL_EENTRYALREADYEXIST;
+			}
+			tmpRule = tmpRule->next;
+		}
+	}
+
+	addAcl = freeAclList.freeHead;
+	if(addAcl == NULL)
+		return RTL_ENOFREEBUFFER;
+
+	/*remove acl buffer from freeAclList*/
+	freeAclList.freeHead = freeAclList.freeHead->next;
+	if(freeAclList.freeHead)
+		freeAclList.freeHead->pre = NULL;
+	freeAclList.freeCnt--;
+
+	memcpy(addAcl,rule,sizeof(rtl865x_AclRule_t));
+
+	addAcl->pre = addAcl->next = NULL;
+	if((*head) == NULL)
+	{
+		/*head = null, tail must null*/
+		addAcl->aclIdx = 1;
+		*head = addAcl;
+		*tail = addAcl;
+	}
+	else
+	{
+		if(addAcl->aclIdx == 0 || addAcl->aclIdx > (*tail)->aclIdx)
+		{
+			/*append this rule to tail*/
+			addAcl->aclIdx = (*tail)->aclIdx + 1;
+			(*tail)->next = addAcl;
+			addAcl->pre = *tail;
+			addAcl->next = NULL;
+			*tail = addAcl;
+		}
+		else
+		{
+			/*user specified the index, it's means: this rule should be inserted before the rule->aclIdx*/
+
+			tmpRule = *head;
+			while(tmpRule)
+			{
+				if(tmpRule->aclIdx == addAcl->aclIdx)
+				{
+					/*found the rule...*/
+					break;
+				}
+
+				tmpRule = tmpRule->next;
+			}
+
+			if(tmpRule == NULL)
+			{
+				/*not found the correct position, append this rule at the tail??*/
+
+
+				printk("%s(%d): BUG!!!\n",__FUNCTION__,__LINE__);
+
+				addAcl->pre = NULL;
+				addAcl->next = freeAclList.freeHead;
+				if(freeAclList.freeHead)
+					freeAclList.freeHead->pre = addAcl;
+				freeAclList.freeHead = addAcl;
+				freeAclList.freeCnt++;
+				return FAILED;
+			}
+
+			/*insert new rule before the found rule*/
+			if(tmpRule->pre == NULL)
+			{
+				/*tmpRule->pre = null, means: tmprule is the head of this chain*/
+				addAcl->next = tmpRule;
+				tmpRule ->pre = addAcl;
+				*head = addAcl;
+				addAcl->aclIdx = 1;
+			}
+			else
+			{
+				tmpRule->pre->next = addAcl;
+				addAcl->pre = tmpRule->pre;
+				addAcl->next = tmpRule;
+				tmpRule->pre = addAcl;
+			}
+
+			/*update aclIdx...*/
+			while(tmpRule)
+			{
+				tmpRule->aclIdx++;
+				tmpRule = tmpRule->next;
+			}
+
+		}
+	}
+	return SUCCESS;
+}
+
+static int32 _rtl865x_delAclFromChain(rtl865x_AclRule_t *rule, rtl865x_AclRule_t **head, rtl865x_AclRule_t **tail)
+{
+	rtl865x_AclRule_t *delRule,*nextRule;
+	int8 isSame = FALSE;
+
+	if(head == NULL || tail == NULL)
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	delRule = *head;
+	while(delRule)
+	{
+		if(rule->aclIdx != 0)
+		{
+			if(rule->aclIdx == delRule->aclIdx)
+			{
+				break;
+			}
+		}
+		else
+		{
+			isSame = _rtl865x_sameAclRule(delRule,rule);
+			if(isSame == TRUE)
+			{
+				break;
+			}
+		}
+
+		delRule = delRule->next;
+	}
+
+	if(delRule == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	/*remove the acl rule from chains to free list*/
+	nextRule = delRule->next;
+	if(delRule->pre)
+		delRule->pre->next = delRule->next;
+	if(delRule->next)
+		delRule->next->pre = delRule->pre;
+
+	if(delRule == *head)
+		*head = delRule->next;
+
+	if(delRule == *tail)
+		*tail = delRule->pre;
+
+	/*inser the rule to free list*/
+	delRule->pre = NULL;
+	delRule->next = freeAclList.freeHead;
+	if(freeAclList.freeHead)
+		freeAclList.freeHead->pre = delRule;
+	freeAclList.freeHead = delRule;
+	freeAclList.freeCnt++;
+
+	/*update acl index whose position is after the delRule*/
+	while(nextRule)
+	{
+		nextRule->aclIdx--;
+		nextRule = nextRule->next;
+	}
+	return SUCCESS;
+}
+
+static int _rtl865x_checkDefAclAvailable(rtl865x_AclRule_t *endRule)
+{
+	rtl865x_AclRule_t defRule;
+	bzero((void*)&defRule,sizeof(rtl865x_AclRule_t));
+
+
+	if(endRule==NULL)
+	{
+		return 0;
+	}
+
+
+	defRule.ruleType_ = RTL865X_ACL_MAC;
+	defRule.actionType_ 	= RTL865X_ACL_PERMIT;
+	defRule.pktOpApp_		= RTL865X_ACL_ALL_LAYER;
+
+	if(_rtl865x_sameAclRule(&defRule,endRule)==TRUE)
+	{
+		return 1;
+	}
+
+
+	defRule.actionType_ 	= RTL865X_ACL_TOCPU;
+	if(_rtl865x_sameAclRule(&defRule,endRule)==TRUE)
+	{
+		return 1;
+	}
+
+
+	defRule.actionType_ 	= RTL865X_ACL_DROP;
+	if(_rtl865x_sameAclRule(&defRule,endRule)==TRUE)
+	{
+		return 1;
+	}
+
+	return 0;
+}
+
+
+#if defined(CONFIG_RTL_IPTABLES2ACL_PATCH)
+int32 _rtl865x_synAclwithAsicTbl(void)
+#else
+static int32 _rtl865x_synAclwithAsicTbl(void)
+#endif
+{
+	rtl865x_netif_local_t *netif = NULL;
+	rtl865x_acl_chain_t *chain;
+	rtl865x_AclRule_t *rule;
+	int32 i,startIdx,addCnt,totalAddCnt;
+
+	rtl865x_AclRule_t *preRule=NULL;
+	rtl865x_AclRule_t *endRule=NULL;
+
+	/*prepare default permit acl*/
+	rtl865x_AclRule_t defRule;
+	bzero((void*)&defRule,sizeof(rtl865x_AclRule_t));
+	defRule.aclIdx=1;
+	defRule.ruleType_ = RTL865X_ACL_MAC;
+	defRule.actionType_		= RTL865X_ACL_PERMIT;
+	defRule.pktOpApp_ 		= RTL865X_ACL_ALL_LAYER;
+
+	//hyking:when rearrange asic acl, permit all first...
+	_rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL);
+	startIdx = 0;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		netif = &netifTbl[i];
+		if(netif->valid)
+		{
+			/*ingress acl*/
+			chain = netif->chainListHead[RTL865X_ACL_INGRESS];
+			totalAddCnt = 0;
+			netif->inAclStart = startIdx;
+			preRule=NULL;
+			while(chain)
+			{
+				addCnt = 0;
+
+				rule = chain->head;
+
+				while(rule)
+				{
+
+					if((preRule==NULL) || (_rtl865x_sameAclRule(preRule,rule)==FALSE))
+					{
+						_rtl865x_setAclToAsic(startIdx, rule);
+						addCnt++;
+					}
+
+					preRule=rule;
+					endRule=rule;
+					rule = rule->next;
+				}
+				/*next chain..*/
+				chain = chain->nextChain;
+				startIdx += addCnt;
+				totalAddCnt += addCnt;
+			}
+
+			/*addCnt = 0: default permit??*/
+			if(totalAddCnt > 0)
+			{
+				netif->inAclEnd = netif->inAclStart + totalAddCnt -1;
+//				startIdx += addCnt;
+
+				if(netif->inAclEnd<(RTL865X_ACL_MAX_NUMBER-1))
+				{
+					if(_rtl865x_checkDefAclAvailable(endRule)==0)
+					{
+						/*add default acl to permit all*/
+						_rtl865x_setAclToAsic(startIdx, &defRule);
+						startIdx++;
+						netif->inAclEnd++;
+
+					}
+
+				}
+
+			}
+			else
+				netif->inAclEnd = netif->inAclStart = RTL865X_ACLTBL_PERMIT_ALL; /*default permit...*/
+
+			/*egress acl*/
+			chain = netif->chainListHead[RTL865X_ACL_EGRESS];
+			totalAddCnt = 0;
+			netif->outAclStart = startIdx;
+			preRule=NULL;
+			while(chain)
+			{
+				addCnt = 0;
+				rule = chain->head;
+				while(rule)
+				{
+					if((preRule==NULL) || (_rtl865x_sameAclRule(preRule,rule)==FALSE))
+					{
+						_rtl865x_setAclToAsic(startIdx, rule);
+						addCnt++;
+					}
+
+					preRule=rule;
+					endRule=rule;
+					rule = rule->next;
+				}
+				chain = chain->nextChain;
+				startIdx += addCnt;
+				totalAddCnt += addCnt;
+			}
+
+			if(totalAddCnt > 0)
+			{
+				netif->outAclEnd = netif->outAclStart + totalAddCnt -1;
+//				startIdx += addCnt;
+				if(netif->outAclEnd<(RTL865X_ACL_MAX_NUMBER-1))
+				{
+					if(_rtl865x_checkDefAclAvailable(endRule)==0)
+					{
+
+						/*add default acl to permit all*/
+						_rtl865x_setAclToAsic(startIdx, &defRule);
+						startIdx++;
+						netif->outAclEnd++;
+					}
+
+				}
+
+
+
+			}
+			else
+				netif->outAclEnd = netif->outAclStart = RTL865X_ACLTBL_PERMIT_ALL; /*default permit...*/
+
+			#if defined(CONFIG_RTL_MULTIPLE_WAN)  ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+				netif->enableRoute = (rtl8651_getAsicOperationLayer()>2)? 1:0;
+			#endif
+
+			_rtl865x_setAsicNetif(netif);
+
+		}
+	}
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+	{
+
+		netif = &virtualNetIf;
+		if(netif->valid)
+		{
+			chain = netif->chainListHead[RTL865X_ACL_INGRESS];
+			totalAddCnt = 0;
+			netif->inAclStart = startIdx;
+			while(chain)
+			{
+				addCnt = 0;
+				/*ingress acl*/
+				rule = chain->head;
+				while(rule)
+				{
+					_rtl865x_setAclToAsic(startIdx, rule);
+					addCnt++;
+					rule = rule->next;
+				}
+				/*next chain..*/
+				chain = chain->nextChain;
+				startIdx += addCnt;
+				totalAddCnt += addCnt;
+			}
+
+			/*addCnt = 0: default permit??*/
+			if(totalAddCnt > 0)
+			{
+				netif->inAclEnd = netif->inAclStart + totalAddCnt -1;
+//				startIdx += addCnt;
+			}
+			else
+				netif->inAclEnd = netif->inAclStart = RTL865X_ACLTBL_PERMIT_ALL; /*default permit...*/
+
+
+			/*egress acl*/
+			chain = netif->chainListHead[RTL865X_ACL_EGRESS];
+			totalAddCnt = 0;
+			netif->outAclStart = startIdx;
+			while(chain)
+			{
+				addCnt = 0;
+				rule = chain->head;
+				while(rule)
+				{
+					_rtl865x_setAclToAsic(startIdx, rule);
+					addCnt++;
+					rule = rule->next;
+				}
+				chain = chain->nextChain;
+				startIdx += addCnt;
+				totalAddCnt += addCnt;
+			}
+
+			if(totalAddCnt > 0)
+			{
+				netif->outAclEnd = netif->outAclStart + totalAddCnt -1;
+//				startIdx += addCnt;
+			}
+			else
+				netif->outAclEnd = netif->outAclStart = RTL865X_ACLTBL_PERMIT_ALL; /*default permit...*/
+			 //printk("netif->inAclStart is %d,netif->inAclEnd is %d,netif->outAclStart is %d, netif->outAclEnd is %d\n",netif->inAclStart,netif->inAclEnd,netif->outAclStart, netif->outAclEnd);
+			 rtl865x_setDefACLForNetDecisionMiss(netif->inAclStart, netif->inAclEnd, netif->outAclStart, netif->outAclEnd);
+		}
+	}
+#endif
+	return SUCCESS;
+}
+
+
+/*flag, 0: ingress, 1: egress*/
+static int32 _rtl865x_regist_aclChain(char *netifName, int32 priority,uint32 flag)
+{
+	rtl865x_netif_local_t *netif;
+	rtl865x_acl_chain_t *addEntry,*chainEntry;
+	uint32 aclDir = RTL865X_ACL_INGRESS;/*default :RTL865X_ACL_INGRESS*/
+
+	netif = _rtl865x_getNetifByName(netifName);
+
+	if(netif == NULL)
+		return RTL_ENETIFINVALID;
+
+	if(flag == RTL865X_ACL_EGRESS)
+		aclDir = RTL865X_ACL_EGRESS;
+
+	chainEntry = netif->chainListHead[aclDir];
+
+
+	while(chainEntry)
+	{
+		if(chainEntry->priority < priority)
+			chainEntry = chainEntry->nextChain;
+		else
+			/*bingo!, find the position*/
+			break;
+	}
+
+	/*duplicate?*/
+	if(chainEntry && chainEntry->priority == priority)
+		return RTL_EENTRYALREADYEXIST;
+
+	addEntry = freeChainHead;
+	if(addEntry == NULL)
+		return RTL_ENOFREEBUFFER;
+
+	freeChainHead = addEntry->nextChain;
+	if(freeChainHead)
+		freeChainHead->preChain = NULL;
+
+	memset(addEntry,0,sizeof(rtl865x_acl_chain_t));
+	addEntry->ruleCnt = 0;
+	addEntry->priority = priority;
+	addEntry->head = NULL;
+	addEntry->tail = NULL;
+	addEntry->preChain = addEntry->nextChain = NULL;
+
+	if(chainEntry)
+	{
+		/*insert addentry before the chainEntry*/
+		addEntry->nextChain = chainEntry;
+		addEntry->preChain = chainEntry->preChain;
+
+		if(chainEntry->preChain)
+			chainEntry->preChain->nextChain = addEntry;
+		else
+		{
+			/*insert before head???*/
+			netif->chainListHead[aclDir] = addEntry;
+		}
+
+		chainEntry->preChain = addEntry;
+	}
+	else
+	{
+		if(netif->chainListHead[aclDir] == NULL)
+			netif->chainListHead[aclDir] = addEntry;
+		else
+		{
+			/*append addEntry to the tail of this list...*/
+			chainEntry = netif->chainListHead[aclDir];
+			while(chainEntry)
+			{
+				if(chainEntry->nextChain == NULL)
+					break;
+
+				chainEntry = chainEntry->nextChain;
+			}
+
+			if(chainEntry == NULL)
+				printk("%s(%d) BUG!!!!\n",__FUNCTION__,__LINE__);
+
+			chainEntry->nextChain = addEntry;
+			addEntry->preChain = chainEntry;
+		}
+	}
+
+	return SUCCESS;
+
+}
+
+
+static int32 _rtl865x_unRegist_aclChain(char *netifName,int32 priority, uint32 flag)
+{
+	rtl865x_netif_local_t *netif;
+	rtl865x_AclRule_t *aclRule;
+	rtl865x_acl_chain_t *chainEntry;
+	uint32 aclDir = RTL865X_ACL_INGRESS;/*default :RTL865X_ACL_INGRESS*/
+
+	netif = _rtl865x_getNetifByName(netifName);
+
+	if(netif == NULL)
+		return RTL_ENETIFINVALID;
+
+	if(flag == RTL865X_ACL_EGRESS)
+		aclDir = RTL865X_ACL_EGRESS;
+
+	chainEntry = netif->chainListHead[aclDir];
+
+
+	while(chainEntry)
+	{
+		if(chainEntry->priority == priority)
+			break;
+		chainEntry = chainEntry->nextChain;
+	}
+
+	if(chainEntry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	/*remove all aclrule*/
+	aclRule = chainEntry->head;
+	while(aclRule)
+	{
+		_rtl865x_delAclFromChain(aclRule, &chainEntry->head, &chainEntry->tail);
+		aclRule = chainEntry->head;
+		chainEntry->ruleCnt--;
+	}
+
+	chainEntry->ruleCnt = 0;
+
+	if(chainEntry->nextChain)
+		chainEntry->nextChain->preChain = chainEntry->preChain;
+
+	if(chainEntry->preChain)
+		chainEntry->preChain->nextChain = chainEntry->nextChain;
+	else
+		/*remove head???*/
+		netif->chainListHead[aclDir] = chainEntry->nextChain;
+
+
+	memset(chainEntry,0,sizeof(rtl865x_acl_chain_t));
+
+	chainEntry->nextChain = freeChainHead;
+	if (freeChainHead)
+		freeChainHead->preChain = chainEntry;
+	freeChainHead = chainEntry;
+
+	_rtl865x_synAclwithAsicTbl();
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_flush_allAcl_fromChain(char *netifName,int32 priority, uint32 flag)
+{
+	rtl865x_netif_local_t *netif;
+	rtl865x_AclRule_t *aclRule;
+	rtl865x_acl_chain_t *chainEntry;
+	uint32 aclDir = RTL865X_ACL_INGRESS;/*default :RTL865X_ACL_INGRESS*/
+
+	if(flag == RTL865X_ACL_EGRESS)
+		aclDir = RTL865X_ACL_EGRESS;
+
+	if(netifName && netifName[0] != '\0')
+	{
+		netif = _rtl865x_getNetifByName(netifName);
+
+		if(netif == NULL)
+			return RTL_ENETIFINVALID;
+
+		chainEntry = netif->chainListHead[aclDir];
+		while(chainEntry)
+		{
+			if(chainEntry->priority == priority)
+				break;
+			chainEntry = chainEntry->nextChain;
+		}
+
+		if(chainEntry == NULL)
+			return RTL_EENTRYNOTFOUND;
+
+		/*remove all aclrule*/
+		aclRule = chainEntry->head;
+		while(aclRule)
+		{
+			_rtl865x_delAclFromChain(aclRule, &chainEntry->head, &chainEntry->tail);
+			aclRule = chainEntry->head;
+			chainEntry->ruleCnt--;
+		}
+
+		chainEntry->ruleCnt = 0;
+
+	}
+	else
+	{
+		/*add this rule to every netif*/
+		int32 i;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+		{
+			netif = &netifTbl[i];
+			if(netif->valid)
+			{
+				chainEntry = netif->chainListHead[aclDir];
+				while(chainEntry)
+				{
+					if(chainEntry->priority == priority)
+						break;
+					chainEntry = chainEntry->nextChain;
+				}
+
+				if(chainEntry == NULL)
+					continue;
+
+				/*remove all aclrule*/
+				aclRule = chainEntry->head;
+				while(aclRule)
+				{
+					_rtl865x_delAclFromChain(aclRule, &chainEntry->head, &chainEntry->tail);
+					aclRule = chainEntry->head;
+					chainEntry->ruleCnt--;
+				}
+
+				chainEntry->ruleCnt = 0;
+			}
+		}
+	}
+
+	_rtl865x_synAclwithAsicTbl();
+
+	return SUCCESS;
+}
+
+static rtl865x_AclRule_t* _rtl865x_matched_layer4_aclChain(char *netifName,int32 priority, uint32 flag, rtl865x_AclRule_t *match)
+{
+	rtl865x_netif_local_t *netif;
+	rtl865x_AclRule_t *aclRule;
+	rtl865x_acl_chain_t *chainEntry;
+	uint32			isRange;
+	uint32 aclDir = RTL865X_ACL_INGRESS;/*default :RTL865X_ACL_INGRESS*/
+
+	if(flag == RTL865X_ACL_EGRESS)
+		aclDir = RTL865X_ACL_EGRESS;
+
+	if(netifName && netifName[0] != '\0')
+	{
+		netif = _rtl865x_getNetifByName(netifName);
+
+		if(netif == NULL)
+			return NULL;
+
+		chainEntry = netif->chainListHead[aclDir];
+		while(chainEntry)
+		{
+			if(chainEntry->priority == priority)
+				break;
+			chainEntry = chainEntry->nextChain;
+		}
+
+		if(chainEntry == NULL)
+			return NULL;
+
+		/*check all aclrule*/
+		for(aclRule = chainEntry->head;aclRule;aclRule = aclRule->next)
+		{
+			isRange = FALSE;
+			switch(aclRule->ruleType_)
+			{
+				case RTL865X_ACL_TCP_IPRANGE:
+					isRange = TRUE;
+				case RTL865X_ACL_TCP:
+					if ( (aclRule->tcpSrcPortLB_<=match->tcpSrcPortLB_)
+						&&(aclRule->tcpSrcPortUB_>=match->tcpSrcPortLB_)
+						&&(aclRule->tcpDstPortLB_<=match->tcpDstPortLB_)
+						&&(aclRule->tcpDstPortUB_>=match->tcpDstPortLB_)
+						&& (match->ruleType_==RTL865X_ACL_TCP))
+						{
+							break;
+						}
+					else
+						continue;
+				case RTL865X_ACL_UDP_IPRANGE:
+					isRange = TRUE;
+				case RTL865X_ACL_UDP:
+					if ( (aclRule->udpSrcPortLB_<=match->tcpSrcPortLB_)
+						&&(aclRule->udpSrcPortUB_>=match->tcpSrcPortLB_)
+						&&(aclRule->udpDstPortLB_<=match->tcpDstPortLB_)
+						&&(aclRule->udpDstPortUB_>=match->tcpDstPortLB_)
+						&&(match->ruleType_==RTL865X_ACL_UDP))
+						{
+							break;
+						}
+					else
+						continue;
+				case RTL865X_ACL_IP_RANGE:
+					isRange = TRUE;
+				case RTL865X_ACL_IP:
+					if ( ((aclRule->tos_&aclRule->tosMask_)==(match->tos_&aclRule->tosMask_))
+						&& ((aclRule->ipProto_&aclRule->ipProtoMask_)==(match->ipProto_&aclRule->ipProtoMask_))
+						&& ((aclRule->ipFlag_&aclRule->ipFlagMask_)==(match->ipFlag_&aclRule->ipFlagMask_)))
+					{
+						break;
+					}
+					else
+						continue;
+				default:
+					continue;
+			}
+
+			if (isRange)
+			{
+				if ( (aclRule->srcIpAddrStart_<=match->srcIpAddr_)
+					&&(aclRule->srcIpAddrEnd_>=match->srcIpAddr_)
+					&&(aclRule->dstIpAddrStart_<=match->dstIpAddr_)
+					&&(aclRule->dstIpAddrEnd_>=match->dstIpAddr_) )
+				{
+					break;
+				}
+				else
+					continue;
+			}
+			else
+			{
+				if ( ((aclRule->srcIpAddr_&aclRule->srcIpAddrMask_)
+					==(match->srcIpAddr_&aclRule->srcIpAddrMask_))
+					&&((aclRule->dstIpAddr_&aclRule->dstIpAddrMask_)
+					==(match->dstIpAddr_&aclRule->dstIpAddrMask_)) )
+				{
+					break;
+				}
+				else
+					continue;
+			}
+		}
+	}
+	else
+	{
+		return NULL;
+	}
+
+	return aclRule;
+}
+
+static inline int _rtl865x_cmpMacAddr(ether_addr_t *mac1, ether_addr_t *mac2, ether_addr_t *mask)
+{
+	int	i;
+
+	for(i=0;i<ETHER_ADDR_LEN;i++)
+	{
+		if ((mac1->octet[i]&mask->octet[i])!=(mac2->octet[i]&mask->octet[i]))
+			return (SUCCESS+i+1);
+	}
+	return SUCCESS;
+}
+
+static rtl865x_AclRule_t* _rtl865x_matched_layer2_aclChain(char *netifName,int32 priority, uint32 flag, rtl865x_AclRule_t *match)
+{
+	rtl865x_netif_local_t *netif;
+	rtl865x_AclRule_t *aclRule;
+	rtl865x_acl_chain_t *chainEntry;
+	uint32 aclDir = RTL865X_ACL_INGRESS;/*default :RTL865X_ACL_INGRESS*/
+
+	if(flag == RTL865X_ACL_EGRESS)
+		aclDir = RTL865X_ACL_EGRESS;
+
+	if(netifName && netifName[0] != '\0')
+	{
+		netif = _rtl865x_getNetifByName(netifName);
+
+		if(netif == NULL)
+			return NULL;
+
+		chainEntry = netif->chainListHead[aclDir];
+		while(chainEntry)
+		{
+			if(chainEntry->priority == priority)
+				break;
+			chainEntry = chainEntry->nextChain;
+		}
+
+		if(chainEntry == NULL)
+			return NULL;
+
+		/*check all aclrule*/
+		for(aclRule = chainEntry->head;aclRule;aclRule = aclRule->next)
+		{
+			switch(aclRule->ruleType_)
+			{
+				case RTL865X_ACL_MAC:
+					break;
+				default:
+					continue;
+			}
+
+			{
+				if ( _rtl865x_cmpMacAddr(&aclRule->srcMac_, &match->srcMac_, &aclRule->srcMacMask_)==SUCCESS
+					&&_rtl865x_cmpMacAddr(&aclRule->dstMac_, &match->dstMac_, &aclRule->dstMacMask_)==SUCCESS
+					&&((aclRule->typeLen_&aclRule->typeLenMask_)==(match->typeLen_&aclRule->typeLenMask_))
+					&& aclRule->ruleType_==match->ruleType_)
+				{
+					break;
+				}
+				else
+					continue;
+			}
+		}
+	}
+	else
+	{
+		return NULL;
+	}
+
+	return aclRule;
+}
+
+static int32 _rtl865x_unRegister_all_aclChain(char *netifName)
+{
+	rtl865x_netif_local_t *netif;
+	rtl865x_AclRule_t *aclRule;
+	rtl865x_acl_chain_t *chainEntry;
+	uint32 aclDir = RTL865X_ACL_INGRESS;
+
+	netif = _rtl865x_getNetifByName(netifName);
+	if(netif == NULL)
+		return RTL_ENETIFINVALID;
+
+	for(aclDir = RTL865X_ACL_INGRESS; aclDir <= RTL865X_ACL_EGRESS; aclDir++)
+	{
+		chainEntry = netif->chainListHead[aclDir];
+		while(chainEntry)
+		{
+			/*remove all aclrule*/
+			aclRule = chainEntry->head;
+			while(aclRule)
+			{
+				_rtl865x_delAclFromChain(aclRule, &chainEntry->head, &chainEntry->tail);
+				aclRule = chainEntry->head;
+			}
+
+			chainEntry->ruleCnt = 0;
+			netif->chainListHead[aclDir] = chainEntry->nextChain;
+
+			/*remove to freelist*/
+			chainEntry->nextChain = freeChainHead;
+			if(freeChainHead)
+				freeChainHead->preChain = chainEntry;
+			freeChainHead = chainEntry;
+
+			chainEntry = netif->chainListHead[aclDir];
+		}
+	}
+
+	netif->inAclEnd = netif->inAclStart = netif->outAclEnd = netif->outAclStart = RTL865X_ACLTBL_PERMIT_ALL; /*default permit...*/
+	_rtl865x_setAsicNetif(netif);
+
+	return SUCCESS;
+}
+
+static rtl865x_acl_chain_t* _rtl865x_find_aclChain_byPriority(rtl865x_acl_chain_t *head, int32 priority)
+{
+	rtl865x_acl_chain_t *entry;
+	entry = head;
+	while(entry)
+	{
+		if(entry->priority == priority)
+			break;
+		entry = entry->nextChain;
+	}
+
+	return entry;
+}
+
+static int32 _rtl865x_add_acl(rtl865x_AclRule_t *rule, char *netifName,int32 chainNo)
+{
+	rtl865x_netif_local_t *netif = NULL;
+	rtl865x_acl_chain_t *chain = NULL;
+	int32 isSynAsic = 0;
+	int32 retval = FAILED;
+
+	if(rule == NULL)
+		return RTL_EINVALIDINPUT;
+
+	if(netifName && netifName[0] != '\0' && (rule->inv_flag == 0))
+	{
+		netif = _rtl865x_getNetifByName(netifName);
+		if(netif == NULL)
+			return RTL_EINVALIDINPUT;
+
+		chain = _rtl865x_find_aclChain_byPriority(netif->chainListHead[rule->direction_],chainNo);
+		if(chain == NULL)
+			return RTL_EENTRYNOTFOUND;
+
+		retval = _rtl865x_addAclToChain(rule, &(chain->head), &(chain->tail));
+		if(retval == SUCCESS)
+		{
+			isSynAsic = 1;
+			chain->ruleCnt++;
+		}
+	}
+	else
+	{
+		/*add this rule to every netif*/
+		int32 i;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+		{
+			netif = &netifTbl[i];
+			if(netif->valid == 0)
+				continue;
+
+			/*inv_flag != 0, means alc should add to the other netifs else netifName*/
+			/*now: the inv_flag only should be RTL865X_INVERT_IN_NETIF or RTL865X_INVERT_OUT_NETIF*/
+			if(netifName && netifName[0] != '\0' && rule->inv_flag != 0)
+			{
+				if(memcmp(netif->name,netifName,strlen(netifName)) == 0)
+					continue;
+			}
+
+			/*add rule to netif*/
+			{
+				chain = _rtl865x_find_aclChain_byPriority(netif->chainListHead[rule->direction_],chainNo);
+				if(chain == NULL)
+					continue;
+
+				retval = _rtl865x_addAclToChain(rule, &(chain->head), &(chain->tail));
+				if(retval == SUCCESS)
+				{
+					isSynAsic = 1;
+					chain->ruleCnt++;
+				}
+			}
+		}
+	}
+
+	if(isSynAsic == 1)
+		_rtl865x_synAclwithAsicTbl();
+
+	return retval;
+}
+
+static int32 _rtl865x_del_acl(rtl865x_AclRule_t *rule, char *netifName,int32 chainNo)
+{
+	rtl865x_netif_local_t *netif = NULL;
+	rtl865x_acl_chain_t *chain = NULL;
+	int32 isSynAsic = 0;
+	int32 retval = FAILED;
+
+	if(rule == NULL)
+		return RTL_EINVALIDINPUT;
+
+	if(netifName)
+	{
+		netif = _rtl865x_getNetifByName(netifName);
+		if(netif == NULL)
+			return RTL_EINVALIDINPUT;
+	}
+
+
+	if(netif != NULL)
+	{
+		chain = _rtl865x_find_aclChain_byPriority(netif->chainListHead[rule->direction_],chainNo);
+		if(chain == NULL)
+			return RTL_EENTRYNOTFOUND;
+
+		retval = _rtl865x_delAclFromChain(rule, &(chain->head), &(chain->tail));
+		if(retval == SUCCESS)
+		{
+			isSynAsic = 1;
+			chain->ruleCnt--;
+		}
+	}
+	else
+	{
+		/*remvoe this rule from every netif*/
+		int32 i;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+		{
+			netif = &netifTbl[i];
+			if(netif->valid)
+			{
+				chain = _rtl865x_find_aclChain_byPriority(netif->chainListHead[rule->direction_],chainNo);
+				if(chain == NULL)
+					continue;
+				retval = _rtl865x_delAclFromChain(rule, &(chain->head), &(chain->tail));
+				if(retval == SUCCESS)
+				{
+					isSynAsic = 1;
+					chain->ruleCnt--;
+				}
+			}
+		}
+	}
+
+	if(isSynAsic == 1)
+		_rtl865x_synAclwithAsicTbl();
+
+	return retval;
+
+}
+
+/*
+@func int32 | rtl865x_regist_aclChain | register an acl chain for a network interface.
+@parm char* | netifName | network interface Name.
+@parm int32 | priority | priority of this acl chain.
+@parm uint32 | flag | flags. it's value should be RTL865X_ACL_EGRESS or RTL865X_ACL_INGRESS.
+@rvalue SUCCESS | Success.
+@rvalue RTL_ENETIFINVALID | network interface is invalid.
+@rvalue RTL_EENTRYALREADYEXIST | acl chain is already exist.
+@rvalue RTL_ENOFREEBUFFER | no aclchains buffer.
+@comm
+In realtek 865x, there are two types acl list in each network interface: Ingress and Egress ACL list.
+NOTE 1:the priority of acl chain is the primary key, which should be unique!
+	  2:priority RTL865X_ACL_USER_USED = 0 is used by system.
+	  3:acl chain with minimal priority value hold the highest priority.
+In order to easily configure the ACL list, acl chains architecture is designed. lots of acl chains are allowed in one network work interface and lots of ACL rules can be attached in an acl chain.
+according to the priority of acl chains, ACL engine sequentially scan ACL rules in each chain.
+for example:
+ingress acl head--->acl chain(priority0)--->acl chain(priority1)--->acl chain(priority2)
+					|					|					|
+					|->acl rule1			|->acl rule1			|->aclrule1
+					|->acl rule2			|->acl rule2			|->aclrule2
+					|->acl rule3			|->acl rule3			|->aclrule3
+					|->acl rule4								|->aclrule4
+					|->acl rule5								|->aclrule5
+
+
+*/
+int32 rtl865x_regist_aclChain(char *netifName, int32 priority, uint32 flag)
+{
+	return _rtl865x_regist_aclChain(netifName, priority, flag);
+}
+
+/*
+@func int32 | rtl865x_unRegist_aclChain | unregister an acl chain from a network interface.
+@parm char* | netifName | network interface Name.
+@parm int32 | priority | priority of this acl chain.
+@parm uint32 | flag | flags. it's value should be RTL865X_ACL_EGRESS or RTL865X_ACL_INGRESS.
+@rvalue SUCCESS | Success.
+@rvalue RTL_ENETIFINVALID | network interface is invalid.
+@rvalue RTL_EENTRYNOTFOUND | Not found the acl chain .
+@comm
+an acl chain is unregistered, all ACL rules which attach on the acl chain are deleted at the same time.
+*/
+int32 rtl865x_unRegist_aclChain(char *netifName, int32 priority, uint32 flag)
+{
+	//printk("============%s(%d),netif(%s),priority(%d),flag(%d)\n",__FUNCTION__,__LINE__,netifName,priority,flag);
+	return _rtl865x_unRegist_aclChain(netifName, priority, flag);
+}
+
+/*
+@func int32 | rtl865x_flush_allAcl_fromChain | delete all Acl Rules which attach on the acl chain.
+@parm char* | netifName | network interface Name.
+@parm int32 | priority | priority of this acl chain.
+@parm uint32 | flag | flags. it's value should be RTL865X_ACL_EGRESS or RTL865X_ACL_INGRESS.
+@rvalue SUCCESS | Success.
+@rvalue RTL_ENETIFINVALID | network interface is invalid.
+@rvalue RTL_EENTRYNOTFOUND | Not found the acl chain .
+@comm
+	just delete the ACL rules, the acl chain is alive.
+*/
+int32 rtl865x_flush_allAcl_fromChain(char *netifName, int32 priority, uint32 flag)
+{
+	return _rtl865x_flush_allAcl_fromChain(netifName, priority, flag);
+}
+
+#if defined(CONFIG_RTL_IPTABLES2ACL_PATCH)
+
+static int32 _rtl865x_flush_allAcl_sw_fromChain(char *netifName,int32 priority, uint32 flag)
+{
+	rtl865x_netif_local_t *netif;
+	rtl865x_AclRule_t *aclRule;
+	rtl865x_acl_chain_t *chainEntry;
+	uint32 aclDir = RTL865X_ACL_INGRESS;/*default :RTL865X_ACL_INGRESS*/
+
+	if(flag == RTL865X_ACL_EGRESS)
+		aclDir = RTL865X_ACL_EGRESS;
+
+	if(netifName && netifName[0] != '\0')
+	{
+		netif = _rtl865x_getNetifByName(netifName);
+
+		if(netif == NULL)
+			return RTL_ENETIFINVALID;
+
+		chainEntry = netif->chainListHead[aclDir];
+		while(chainEntry)
+		{
+			if(chainEntry->priority == priority)
+				break;
+			chainEntry = chainEntry->nextChain;
+		}
+
+		if(chainEntry == NULL)
+			return RTL_EENTRYNOTFOUND;
+
+		/*remove all aclrule*/
+		aclRule = chainEntry->head;
+		while(aclRule)
+		{
+			_rtl865x_delAclFromChain(aclRule, &chainEntry->head, &chainEntry->tail);
+			aclRule = chainEntry->head;
+			chainEntry->ruleCnt--;
+		}
+
+		chainEntry->ruleCnt = 0;
+
+	}
+	else
+	{
+		/*add this rule to every netif*/
+		int32 i;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+		{
+			netif = &netifTbl[i];
+			if(netif->valid)
+			{
+				chainEntry = netif->chainListHead[aclDir];
+				while(chainEntry)
+				{
+					if(chainEntry->priority == priority)
+						break;
+					chainEntry = chainEntry->nextChain;
+				}
+
+				if(chainEntry == NULL)
+					continue;
+
+				/*remove all aclrule*/
+				aclRule = chainEntry->head;
+				while(aclRule)
+				{
+					_rtl865x_delAclFromChain(aclRule, &chainEntry->head, &chainEntry->tail);
+					aclRule = chainEntry->head;
+					chainEntry->ruleCnt--;
+				}
+
+				chainEntry->ruleCnt = 0;
+			}
+		}
+	}
+
+	//_rtl865x_synAclwithAsicTbl();
+	return SUCCESS;
+}
+
+int32 rtl865x_flush_allAcl_sw_fromChain(char *netifName, int32 priority, uint32 flag)
+{
+	return _rtl865x_flush_allAcl_sw_fromChain(netifName, priority, flag);
+}
+
+static int32 _rtl865x_add_sw_acl(rtl865x_AclRule_t *rule, char *netifName,int32 chainNo)
+{
+	rtl865x_netif_local_t *netif = NULL;
+	rtl865x_acl_chain_t *chain = NULL;
+	int32 isSynAsic = 0;
+	int32 retval = FAILED;
+
+	if(rule == NULL)
+		return RTL_EINVALIDINPUT;
+
+	if(netifName && netifName[0] != '\0' && (rule->inv_flag == 0))
+	{
+		netif = _rtl865x_getNetifByName(netifName);
+		if(netif == NULL)
+			return RTL_EINVALIDINPUT;
+
+		chain = _rtl865x_find_aclChain_byPriority(netif->chainListHead[rule->direction_],chainNo);
+		if(chain == NULL)
+			return RTL_EENTRYNOTFOUND;
+
+		retval = _rtl865x_addAclToChain(rule, &(chain->head), &(chain->tail));
+		if(retval == SUCCESS)
+		{
+			isSynAsic = 1;
+			chain->ruleCnt++;
+		}
+	}
+	else
+	{
+		/*add this rule to every netif*/
+		int32 i;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+		{
+			netif = &netifTbl[i];
+			if(netif->valid == 0)
+				continue;
+
+			/*inv_flag != 0, means alc should add to the other netifs else netifName*/
+			/*now: the inv_flag only should be RTL865X_INVERT_IN_NETIF or RTL865X_INVERT_OUT_NETIF*/
+			if(netifName && netifName[0] != '\0' && rule->inv_flag != 0)
+			{
+				if(memcmp(netif->name,netifName,strlen(netifName)) == 0)
+					continue;
+			}
+
+			/*add rule to netif*/
+			{
+				chain = _rtl865x_find_aclChain_byPriority(netif->chainListHead[rule->direction_],chainNo);
+				if(chain == NULL)
+					continue;
+
+				retval = _rtl865x_addAclToChain(rule, &(chain->head), &(chain->tail));
+				if(retval == SUCCESS)
+				{
+					isSynAsic = 1;
+					chain->ruleCnt++;
+				}
+			}
+		}
+	}
+
+	//if(isSynAsic == 1)
+		//_rtl865x_synAclwithAsicTbl();
+
+	return retval;
+}
+
+
+int32 rtl865x_add_sw_acl(rtl865x_AclRule_t *rule, char *netifName,int32 priority)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//printk("********%s(%d)*********,netif(%s),priority(%d)\n",__FUNCTION__,__LINE__,netifName,priority);
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	if(rtl865x_acl_enable == 0)
+		return retval;
+#endif
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_add_sw_acl(rule,netifName,priority);
+	if(retval == RTL_ENOFREEBUFFER){	// acl entries is full.
+		_rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL);
+	}
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH(flags);
+	//printk("********%s(%d)*********retval(%d)\n",__FUNCTION__,__LINE__,retval);
+	return retval;
+}
+
+#endif
+
+rtl865x_AclRule_t* rtl865x_matched_layer4_aclChain(char *netifName,int32 priority, uint32 flag, rtl865x_AclRule_t *match)
+{
+	return _rtl865x_matched_layer4_aclChain(netifName, priority, flag, match);
+}
+
+rtl865x_AclRule_t* rtl865x_matched_layer2_aclChain(char *netifName,int32 priority, uint32 flag, rtl865x_AclRule_t *match)
+{
+	return _rtl865x_matched_layer2_aclChain(netifName, priority, flag, match);
+}
+rtl865x_acl_chain_t* rtl865x_find_aclChain_byPriority(rtl865x_acl_chain_t *head, int32 priority)
+{
+	rtl865x_acl_chain_t *entry;
+	entry = head;
+	while(entry)
+	{
+		if(entry->priority == priority)
+			break;
+		entry = entry->nextChain;
+	}
+
+	return entry;
+}
+
+/*
+@func int32 | rtl865x_init_acl_chain |memory init for acl chains.
+@rvalue SUCCESS | Success.
+@comm
+	this API must be called when system boot.
+*/
+int32 rtl865x_init_acl_chain(void)
+{
+	int32 i;
+	rtl865x_acl_chain_t *entry;
+
+	freeChainHead = NULL;
+
+	TBL_MEM_ALLOC(entry, rtl865x_acl_chain_t, RTL865X_ACL_CHAIN_NUMBER);
+
+	for(i = 0; i<RTL865X_ACL_CHAIN_NUMBER;i++)
+	{
+		memset(&entry[i],0,sizeof(rtl865x_acl_chain_t));
+		entry[i].preChain= NULL;
+		entry[i].nextChain= freeChainHead;
+
+		entry[i].head = NULL;
+		entry[i].tail = NULL;
+		if(freeChainHead)
+			freeChainHead->preChain = &entry[i];
+		freeChainHead = &entry[i];
+	}
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865x_init_acl |memory init for acl rules.
+@rvalue SUCCESS | Success.
+@comm
+	this API must be called when system boot.
+*/
+int32 rtl865x_init_acl(void)
+{
+	int32 i;
+	rtl865x_AclRule_t *aclEntry;
+
+	freeAclList.freeHead = NULL;
+
+	TBL_MEM_ALLOC(aclEntry, rtl865x_AclRule_t, RTL865X_ACL_MAX_NUMBER);
+
+	for(i = 0; i<RTL865X_ACL_MAX_NUMBER;i++)
+	{
+		memset(&aclEntry[i],0,sizeof(rtl865x_AclRule_t));
+		aclEntry[i].pre = NULL;
+		aclEntry[i].next = freeAclList.freeHead;
+		if(freeAclList.freeHead)
+			freeAclList.freeHead->pre = &aclEntry[i];
+		freeAclList.freeHead = &aclEntry[i];
+
+		freeAclList.totalCnt++;
+		freeAclList.freeCnt++;
+	}
+
+	_rtl865x_confReservedAcl();
+	/*init acl chains*/
+	rtl865x_init_acl_chain();
+	return SUCCESS;
+}
+
+
+
+/*
+@func int32 | rtl865x_add_acl |add an ACL Rule to acl chain.
+@parm rtl865x_AclRule_t* | rule | realtek ACL rule
+@parm char* | netifName | network interface Name.
+@parm int32 | priority | priority of this acl chain.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDINPUT | ACL rule is NULL or netifName is NULL
+@rvalue RTL_EENTRYNOTFOUND | acl chain with priority is not found
+@rvalue FAILED | Failed
+@comm
+	ACL rule structure: please refer in header file.
+*/
+int32 rtl865x_add_acl(rtl865x_AclRule_t *rule, char *netifName,int32 priority)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	CHECK_IF_HWNAT_READY;
+	#endif /* CONFIG_RTD_1295_HWNAT */
+
+	//printk("********%s(%d)*********,netif(%s),priority(%d)\n",__FUNCTION__,__LINE__,netifName,priority);
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	if(rtl865x_acl_enable == 0)
+		return retval;
+#endif
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_add_acl(rule,netifName,priority);
+	if(retval == RTL_ENOFREEBUFFER){	// acl entries is full.
+		_rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL);
+	}
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH(flags);
+	//printk("********%s(%d)*********retval(%d)\n",__FUNCTION__,__LINE__,retval);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_del_acl |del an ACL Rule from the acl chain.
+@parm rtl865x_AclRule_t* | rule | realtek ACL rule
+@parm char* | netifName | network interface Name.
+@parm int32 | priority | priority of this acl chain.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDINPUT | ACL rule is NULL or netifName is NULL
+@rvalue RTL_EENTRYNOTFOUND | acl chain with priority is not found
+@rvalue FAILED | Failed
+@comm
+	ACL rule structure: please refer in header file.
+*/
+int32 rtl865x_del_acl(rtl865x_AclRule_t *rule, char *netifName,int32 priority)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	CHECK_IF_HWNAT_READY;
+	#endif /* CONFIG_RTD_1295_HWNAT */
+
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_del_acl(rule,netifName,priority);
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+int32 rtl865x_enable_acl(uint32 enable)
+{
+	if(enable)
+	{
+		rtl865x_acl_enable = 1;
+		_rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL);
+	}
+	else
+	{
+		rtl865x_acl_enable = 0;
+		_rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_ALL_TO_CPU,RTL865X_ACLTBL_ALL_TO_CPU,RTL865X_ACLTBL_PERMIT_ALL,RTL865X_ACLTBL_PERMIT_ALL);
+	}
+	return SUCCESS;
+}
+#endif
+
+
+
+int  rtl865x_add_pattern_acl_for_contentFilter(rtl865x_AclRule_t *rule,char *netifName)
+{
+	uint32 i;
+	//### add by sen_liu 2011.5.4 to get wan prot
+	rtl865x_netif_local_t	*netif;
+	rtl865x_vlan_entry_t	*vlan;
+	union
+	{
+		char pat[4];
+		uint32 pattern;
+	}u;
+
+	if(rule == NULL)
+		return FAILED;
+
+		rtl865x_add_acl(rule, netifName, RTL865X_ACL_SYSTEM_USED);
+		netif = _rtl865x_getNetifByName(netifName);
+		if(netif == NULL)
+			return FAILED;
+		vlan = _rtl8651_getVlanTableEntry(netif->vid);
+		if(vlan == NULL)
+			return FAILED;
+
+		u.pat[0]='T';
+		u.pat[1]='T';
+		u.pat[2]='P';
+		u.pat[3]='/';
+		for(i=0;i<RTL8651_PORT_NUMBER;i++)
+		{
+			if (vlan->memberPortMask & 1<<i) {
+				if(rtl8651_setAsicPortPatternMatch(i, u.pattern, 0xffffffff, 0x2)!=SUCCESS)
+					return FAILED;
+			}
+
+		}
+
+		return SUCCESS;
+}
+
+int  rtl865x_del_pattern_acl_for_contentFilter(rtl865x_AclRule_t *rule,char *netifName)
+{
+	union
+	{
+		char pat[4];
+		uint32 pattern;
+	}u;
+	int32 i;
+
+	rtl865x_netif_local_t	*netif;
+	rtl865x_vlan_entry_t	*vlan;
+
+	if(rule == NULL)
+		return FAILED;
+
+	rtl865x_del_acl(rule, netifName, RTL865X_ACL_SYSTEM_USED);
+
+	netif = _rtl865x_getNetifByName(netifName);
+		if(netif == NULL)
+			return FAILED;
+		vlan = _rtl8651_getVlanTableEntry(netif->vid);
+		if(vlan == NULL)
+			return FAILED;
+
+	u.pat[0]='T';
+	u.pat[1]='T';
+	u.pat[2]='P';
+	u.pat[3]='/';
+	for(i=0;i<RTL8651_PORT_NUMBER;i++)
+	{
+		if (vlan->memberPortMask & 1<<i) {
+				rtl8651_setAsicPortPatternMatch(i, 0, 0, 0x2);
+			}
+	}
+
+	return SUCCESS;
+}
+
+
+
+#ifdef CONFIG_FAST_PATH_MODULE
+EXPORT_SYMBOL(rtl865x_del_acl);
+EXPORT_SYMBOL(rtl865x_add_acl);
+#endif
+#endif //CONFIG_RTL_LAYERED_DRIVER_ACL
+int32 rtl865x_attachMasterNetif(char *slave, char *master)
+{
+	return _rtl865x_attachMasterNetif(slave, master);
+}
+EXPORT_SYMBOL(rtl865x_attachMasterNetif);
+
+int32 rtl865x_detachMasterNetif(char *slave)
+{
+	return _rtl865x_detachMasterNetif(slave);
+}
+EXPORT_SYMBOL(rtl865x_detachMasterNetif);
+
+/*
+@func int32 | rtl865x_addNetif |add network interface.
+@parm rtl865x_netif_t* | netif | network interface
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDINPUT | netif is NULL
+@rvalue RTL_EENTRYALREADYEXIST | netif is already exist
+@rvalue RTL_ENOFREEBUFFER | no netif to used
+@rvalue FAILED | Failed
+@comm
+	rtl865x_netif_t: please refer in header file.
+*/
+
+int32 rtl865x_addNetif(rtl865x_netif_t *netif)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_addNetif(netif);
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+/*
+@func int32 | rtl865x_delNetif |delete network interface.
+@parm char* | ifName | network interface name
+@rvalue SUCCESS | Success.
+@rvalue RTL_EENTRYNOTFOUND | network interface is NOT found
+@rvalue RTL_EREFERENCEDBYOTHER | netif is referenced by onter table entry
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_delNetif(char *ifName)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_delNetif(ifName);
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+int32 rtl865x_addVirtualNetif(rtl865x_netif_t *netif)
+{
+
+	rtl865x_netif_local_t *entry;
+	int32 retval = FAILED;
+	if(netif == NULL)
+		return RTL_EINVALIDINPUT;
+
+	/*duplicate entry....*/
+	entry = _rtl865x_getSWNetifByName(netif->name);
+	if(entry)
+		return RTL_EENTRYALREADYEXIST;
+
+
+	/*add new entry*/
+	entry = &virtualNetIf;
+
+	memset(entry, 0, sizeof(rtl865x_netif_local_t));
+
+	entry->valid = 1;
+	memcpy(entry->name,netif->name,MAX_IFNAMESIZE);
+	entry->inAclEnd = entry->inAclStart = entry->outAclEnd = entry->outAclStart = RTL865X_ACLTBL_PERMIT_ALL; /*default permit...*/
+	entry->refCnt = 1;
+
+
+#ifdef 	CONFIG_RTL_LAYERED_DRIVER_ACL
+	entry->chainListHead[RTL865X_ACL_INGRESS] = NULL;
+	entry->chainListHead[RTL865X_ACL_EGRESS] = NULL;
+#endif
+
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+	/*register 2 ingress chains: system/user*/
+	retval = rtl865x_regist_aclChain(netif->name, RTL865X_ACL_SYSTEM_USED, RTL865X_ACL_INGRESS);
+	retval = rtl865x_regist_aclChain(netif->name, RTL865X_ACL_USER_USED, RTL865X_ACL_INGRESS);
+#endif //CONFIG_RTL_LAYERED_DRIVER_ACL
+
+	return SUCCESS;
+}
+
+int32 rtl865x_delVirtualNetif(char *ifName)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_delNetif(ifName);
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH(flags);
+	_rtl865x_confReservedAcl();
+	return retval;
+}
+#endif
+/*
+@func int32 | rtl865x_referNetif |reference network interface entry.
+@parm char* | ifName | network interface name
+@rvalue SUCCESS | Success.
+@rvalue RTL_EENTRYNOTFOUND | network interface is NOT found
+@rvalue FAILED | Failed
+@comm
+when other table entry refer network interface table entry, please call this API.
+*/
+int32 rtl865x_referNetif(char *ifName)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH2(flags);
+	retval = _rtl865x_referNetif(ifName);
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH2(flags);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_deReferNetif |dereference network interface.
+@parm char* | ifName | network interface name
+@rvalue SUCCESS | Success.
+@rvalue RTL_EENTRYNOTFOUND | network interface is NOT found
+@rvalue FAILED | Failed
+@comm
+this API should be called after rtl865x_referNetif.
+*/
+int32 rtl865x_deReferNetif(char *ifName)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH2(flags);
+	retval = _rtl865x_deReferNetif(ifName);
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH2(flags);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_setNetifVid |mapping network interface with vlan.
+@parm char* | name | network interface name
+@parm uint16 | vid | vlan id
+@rvalue SUCCESS | Success.
+@rvalue RTL_EENTRYNOTFOUND | network interface is NOT found
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_setNetifVid(char *name, uint16 vid)
+{
+	int32 ret;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH(flags);
+	ret = _rtl865x_setNetifVid(name,vid);
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH(flags);
+	return ret;
+}
+
+int32 rtl865x_setPortToNetif(char *name,uint32 port)
+{
+	int32 ret;
+	rtl865x_netif_local_t *entry;
+	entry = _rtl865x_getNetifByName(name);
+
+	if(entry == NULL)
+		return FAILED;
+
+	ret = rtl8651_setPortToNetif(port, entry->asicIdx);
+	return ret;
+}
+
+/*
+@func int32 | rtl865x_setNetifType |config network interface type.
+@parm char* | ifName | network interface name
+@parm uint32 | ifType | interface type. IF_ETHER/IF_PPPOE/IF_PPTP/IF_L2TP allowed.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EENTRYNOTFOUND | network interface is NOT found
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_setNetifType(char *name, uint32 ifType)
+{
+	int32 ret;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH_HW(flags);
+	ret = _rtl865x_setNetifType(name,ifType);
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH_HW(flags);
+	return ret;
+}
+
+EXPORT_SYMBOL(rtl865x_setNetifType);
+/*
+@func int32 | rtl865x_setNetifMac |config network interface Mac address.
+@parm rtl865x_netif_t* | netif | netif name&MAC address
+@rvalue SUCCESS | Success.
+@rvalue RTL_EENTRYNOTFOUND | network interface is NOT found
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_setNetifMac(rtl865x_netif_t *netif)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&netif_sem);
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl865x_setNetifMac(netif);
+	//rtl_up(&netif_sem);
+	SMP_UNLOCK_ETH_HW(flags);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_setNetifMtu |config network interface MTU.
+@parm rtl865x_netif_t* | netif | netif name & MTU
+@rvalue SUCCESS | Success.
+@rvalue RTL_EENTRYNOTFOUND | network interface is NOT found
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_setNetifMtu(rtl865x_netif_t *netif)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&netif_sem);
+	//SMP_LOCK_ETH(flags);
+	local_irq_save(flags);
+	retval = _rtl865x_setNetifMtu(netif);
+	//rtl_up(&netif_sem);
+	local_irq_restore(flags);
+	//SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+
+/*
+@func int32 | rtl865x_initNetifTable | initialize network interface table.
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed,system should be reboot.
+*/
+int32 rtl865x_initNetifTable(void)
+{
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	int i;
+
+	TBL_MEM_ALLOC(netifTbl, rtl865x_netif_local_t, NETIF_SW_NUMBER);
+	memset(netifTbl,0,sizeof(rtl865x_netif_local_t)*NETIF_SW_NUMBER);
+	for (i=0; i<NETIF_NUMBER; i++)
+		Netif_Asic2Sw_Mapping[i] = -1;
+#else
+	TBL_MEM_ALLOC(netifTbl, rtl865x_netif_local_t, NETIF_NUMBER);
+	memset(netifTbl,0,sizeof(rtl865x_netif_local_t)*NETIF_NUMBER);
+#endif
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+	/*init reserved acl in function init_acl...*/
+#else
+	_rtl865x_confReservedAcl();
+#endif
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+	memset(&virtualNetIf,0,sizeof(rtl865x_netif_local_t));
+#endif
+	rtl_get_drv_netifName_by_psName = NULL;
+
+	return SUCCESS;
+}
+
+int32 rtl865x_config_callback_for_get_drv_netifName(int (*fun)(const char *psName,char *netifName))
+{
+	rtl_get_drv_netifName_by_psName = fun;
+	return SUCCESS;
+}
+
+int32 rtl865x_get_drvNetifName_by_psName(const char *psName,char *netifName)
+{
+	if(strlen(psName) >= MAX_IFNAMESIZE)
+		return FAILED;
+
+	if(rtl_get_drv_netifName_by_psName)
+		rtl_get_drv_netifName_by_psName(psName,netifName);
+	else
+	{
+		memcpy(netifName,psName,MAX_IFNAMESIZE);
+	}
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865x_enableNetifRouting |config network interface operation layer.
+@parm rtl865x_netif_local_t* | netif | netif & enableRoute
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDINPUT | input is invalid
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_enableNetifRouting(rtl865x_netif_local_t *netif)
+{
+	int32 retval = FAILED;
+
+	if(netif == NULL)
+		return RTL_EINVALIDINPUT;
+	if(netif ->enableRoute == 1)
+		return SUCCESS;
+
+#if (defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS) || defined(CONFIG_RTL_HARDWARE_MULTICAST)) && defined(CONFIG_OPENWRT_SDK)
+	netif->enableRoute = (rtl8651_getAsicOperationLayer()>2)? 1 :0;
+#else
+	netif->enableRoute = 1;
+#endif
+	retval = _rtl865x_setAsicNetif(netif);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_disableNetifRouting |config network interface operation layer.
+@parm rtl865x_netif_local_t* | netif | netif & enableRoute
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDINPUT | input is invalid
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_disableNetifRouting(rtl865x_netif_local_t *netif)
+{
+	int32 retval = FAILED;
+
+	if(netif == NULL)
+		return RTL_EINVALIDINPUT;
+
+	if(netif ->enableRoute == 0)
+		return SUCCESS;
+
+	netif->enableRoute = 0;
+	retval = _rtl865x_setAsicNetif(netif);
+	return retval;
+}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+int32 rtl865x_enableNetifRoutingV6(rtl865x_netif_local_t *netif)
+{
+	int32 retval = FAILED;
+
+	if(netif == NULL)
+		return RTL_EINVALIDINPUT;
+	if(netif ->enableRouteV6 == 1)
+		return SUCCESS;
+	#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT) || defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+	netif->enableRouteV6 = rtk_hwL3v6_enable?1:0;
+	#endif
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	netif->enableRouteV6 = (rtl8651_getAsicOperationLayer()>2)? 1 :0;
+	#endif
+	#else
+
+	netif->enableRouteV6 = 1;
+	#endif
+	retval = _rtl865x_setAsicNetif(netif);
+	return retval;
+}
+
+int32 rtl865x_disableNetifRoutingV6(rtl865x_netif_local_t *netif)
+{
+	int32 retval = FAILED;
+
+	if(netif == NULL)
+		return RTL_EINVALIDINPUT;
+
+	#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+	netif->enableRouteV6 = rtk_hwL3v6_enable?1:0;
+	#else
+	if(netif ->enableRouteV6 == 0)
+		return SUCCESS;
+
+	netif->enableRouteV6 = 0;
+	#endif
+	retval = _rtl865x_setAsicNetif(netif);
+	return retval;
+}
+
+
+#endif
+/*
+@func int32 | rtl865x_disableNetifRouting |config network interface operation layer.
+@parm rtl865x_netif_local_t* | netif | netif & enableRoute
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDINPUT | input is invalid
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_reinitNetifTable(void)
+{
+	int32 i;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&netif_sem);
+	/*Fix jwj: If here use SMP_LOCK_ETH(flags), rtl865x_reChangeOpMode will cause dead-lock.*/
+	//SMP_LOCK_ETH(flags);
+	local_irq_save(flags);
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		if(netifTbl[i].valid)
+		{
+			_rtl865x_delNetif(netifTbl[i].name);
+		}
+	}
+	//memset(netifTbl,0,sizeof(rtl865x_netif_local_t)*NETIF_NUMBER);
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+	if(virtualNetIf.valid)
+	{
+		_rtl865x_delNetif(virtualNetIf.name);
+	}
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for (i=0; i<NETIF_NUMBER; i++)
+		Netif_Asic2Sw_Mapping[i] = -1;
+#endif
+
+	//rtl_up(&netif_sem);
+	//SMP_UNLOCK_ETH(flags);
+	local_irq_restore(flags);
+	return SUCCESS;
+}
+
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST) ||defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+uint32 rtl865x_getExternalPortMask(void)
+{
+	int32 i;
+	rtl865x_netif_local_t *netif = NULL;
+	uint32 externalPortMask=0;
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+		netif = &netifTbl[i];
+		if((netif->valid == 1) && (netif->is_wan==1))
+		{
+			externalPortMask|=rtl865x_getVlanPortMask(netif->vid);
+		}
+	}
+
+	return externalPortMask;
+}
+
+int32 rtl865x_getNetifVid(char *name, uint32 *vid)
+{
+	rtl865x_netif_local_t *entry;
+
+	if(name == NULL)
+	{
+		return FAILED;
+	}
+
+	entry = _rtl865x_getNetifByName(name);
+
+	if(entry == NULL)
+	{
+		return FAILED;
+	}
+
+	*vid=(uint32)(entry->vid);
+	return SUCCESS;
+
+}
+
+int32 rtl865x_getNetifType(char *name,uint32 *type)
+{
+	rtl865x_netif_local_t *entry;
+
+	if(name == NULL)
+	{
+		return FAILED;
+	}
+
+	if(type==NULL)
+	{
+		return FAILED;
+	}
+
+	entry = _rtl865x_getNetifByName(name);
+
+	if(entry == NULL)
+	{
+		return FAILED;
+	}
+
+	*type=(uint32)(entry->if_type);
+	return SUCCESS;
+
+}
+#endif
+
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+#if RTL_LAYERED_DRIVER_DEBUG
+int32 rtl865x_acl_test(int32 testNo)
+{
+	int32 retval = 0;
+	printk("testNo = %d\n",testNo);
+	switch(testNo)
+	{
+		/*add a chain to br0, and delete it...*/
+		case 0:
+		{
+			rtl865x_acl_chain_t *chain = NULL;
+			rtl865x_netif_local_t *netif = NULL;
+			int32 cnt = 0;
+			retval = _rtl865x_regist_aclChain(RTL_DRV_LAN_NETIF_NAME, -500, RTL865X_ACL_INGRESS);
+			netif = _rtl865x_getNetifByName(RTL_DRV_LAN_NETIF_NAME);
+			if(netif == NULL)
+			{
+				printk("netif is NULL!!!!\n");
+				return FAILED;
+			}
+			chain = netif->chainListHead[RTL865X_ACL_INGRESS];
+
+			printk("chains of netif(%s):\n",netif->name);
+			while(chain)
+			{
+				printk("chain %d:\n",cnt);
+				printk("chain:priority(%d),ruleCnt(%d)\n",chain->priority,chain->ruleCnt);
+				cnt++;
+				chain = chain->nextChain;
+			}
+			printk("====================================\n");
+
+			retval = _rtl865x_unRegist_aclChain(RTL_DRV_LAN_NETIF_NAME, -500, RTL865X_ACL_INGRESS);
+
+			chain = netif->chainListHead[RTL865X_ACL_INGRESS];
+			cnt = 0;
+			printk("=============after unregist the chain================\n");
+			printk("chains of netif(%s):\n",netif->name);
+			while(chain)
+			{
+				printk("chain %d:\n",cnt);
+				printk("chain:priority(%d),ruleCnt(%d)\n",chain->priority,chain->ruleCnt);
+				cnt++;
+				chain = chain->nextChain;
+			}
+		}
+		break;
+
+		/*add acls and delete acl....*/
+		case 1:
+		{
+			rtl865x_acl_chain_t *chain = NULL;
+			rtl865x_netif_local_t *netif = NULL;
+			rtl865x_AclRule_t rule,rule1,rule2;
+			retval = _rtl865x_regist_aclChain(RTL_DRV_LAN_NETIF_NAME, -500, RTL865X_ACL_INGRESS);
+
+			netif = _rtl865x_getNetifByName(RTL_DRV_LAN_NETIF_NAME);
+			chain = netif->chainListHead[RTL865X_ACL_INGRESS];
+
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+
+			memset(&rule,0,sizeof(rtl865x_AclRule_t));
+			rule.pktOpApp_ = RTL865X_ACL_L2_AND_L3;
+			rule.actionType_ = RTL865X_ACL_DROP;
+
+			printk("============add 1st acl===========\n");
+			rtl865x_add_acl(&rule, RTL_DRV_LAN_NETIF_NAME, -500);
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+			printk("del the 1st acl\n");
+			rtl865x_del_acl(&rule, RTL_DRV_LAN_NETIF_NAME, -500);
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+			printk("add 2 rule, delete the tail...\n");
+			rtl865x_add_acl(&rule,RTL_DRV_LAN_NETIF_NAME, -500);
+			memset(&rule1,0,sizeof(rtl865x_AclRule_t));
+
+			rule1.pktOpApp_ = RTL865X_ACL_L3_AND_L4;
+			rule1.ruleType_ = RTL865X_ACL_IP;
+			rule1.actionType_ = RTL865X_ACL_DROP;
+
+			rtl865x_add_acl(&rule1,RTL_DRV_LAN_NETIF_NAME,-500);
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+			printk("del the rule1...\n");
+			rtl865x_del_acl(&rule1, RTL_DRV_LAN_NETIF_NAME, -500);
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+			rtl865x_add_acl(&rule1,RTL_DRV_LAN_NETIF_NAME,-500);
+			memset(&rule2,0,sizeof(rtl865x_AclRule_t));
+
+			rule2.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule2.ruleType_ = RTL865X_ACL_ICMP;
+			rule2.actionType_ = RTL865X_ACL_TOCPU;
+			rtl865x_add_acl(&rule2,RTL_DRV_LAN_NETIF_NAME,-500);
+
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+			printk("del the rule1...\n");
+			rtl865x_del_acl(&rule1, RTL_DRV_LAN_NETIF_NAME, -500);
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+			printk("unregist the chain(-500)\n");
+			_rtl865x_unRegist_aclChain(RTL_DRV_LAN_NETIF_NAME,-500,RTL865X_ACL_INGRESS);
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+
+			printk("flush all chain of br0");
+			_rtl865x_unRegister_all_aclChain(RTL_DRV_LAN_NETIF_NAME);
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+		}
+		break;
+
+		/*add acls....*/
+		case 2:
+		{
+			rtl865x_acl_chain_t *chain = NULL;
+			rtl865x_netif_local_t *netif = NULL;
+			rtl865x_AclRule_t rule;
+			retval = _rtl865x_regist_aclChain(RTL_DRV_LAN_NETIF_NAME, -500, RTL865X_ACL_INGRESS);
+
+			netif = _rtl865x_getNetifByName(RTL_DRV_LAN_NETIF_NAME);
+			chain = netif->chainListHead[RTL865X_ACL_INGRESS];
+
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+
+			memset(&rule,0,sizeof(rtl865x_AclRule_t));
+			rule.pktOpApp_ = RTL865X_ACL_L2_AND_L3;
+			rule.actionType_ = RTL865X_ACL_DROP;
+
+			printk("============add 1st acl===========\n");
+			rtl865x_add_acl(&rule, RTL_DRV_LAN_NETIF_NAME, -500);
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+		}
+		break;
+
+		/*add acls....*/
+		case 3:
+		{
+			rtl865x_acl_chain_t *chain = NULL;
+			rtl865x_netif_local_t *netif = NULL;
+			rtl865x_AclRule_t rule1;
+
+			netif = _rtl865x_getNetifByName(RTL_DRV_LAN_NETIF_NAME);
+			chain = netif->chainListHead[RTL865X_ACL_INGRESS];
+
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+
+			memset(&rule1,0,sizeof(rtl865x_AclRule_t));
+			rule1.pktOpApp_ = RTL865X_ACL_L3_AND_L4;
+			rule1.actionType_ = RTL865X_ACL_DROP;
+			rule1.ruleType_ = RTL865X_ACL_IP;
+
+
+			rtl865x_add_acl(&rule1, RTL_DRV_LAN_NETIF_NAME, -500);
+			printk("now the information of netif(%s) is:\n\n",netif->name);
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+
+		}
+		break;
+
+		case 4:
+		{
+			rtl865x_netif_local_t *netif = NULL;
+			netif = _rtl865x_getNetifByName(RTL_DRV_LAN_NETIF_NAME);
+			printk("unregist the chain(-500)\n");
+			_rtl865x_unRegist_aclChain(RTL_DRV_LAN_NETIF_NAME,-500,RTL865X_ACL_INGRESS);
+			printk("now the information of netif(br0) is:\n\n");
+			_rtl865x_print_allChain_allAcl(netif);
+			_rtl865x_print_freeChainNum();
+		}
+		break;
+
+		case 5:
+		{
+			rtl865x_AclRule_t rule;
+			union
+			{
+				char pat[4];
+				uint32 pattern;
+			}u;
+			int32 i;
+
+
+			printk("for url filter test....");
+			memset(&rule,0,sizeof(rtl865x_AclRule_t));
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.ruleType_ = RTL865X_ACL_IP;
+			rule.ipHttpFilter_=rule.ipHttpFilterM_=1;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rtl865x_add_acl(&rule, RTL_DRV_LAN_NETIF_NAME, -10000);
+
+			memset(&rule,0,sizeof(rtl865x_AclRule_t));
+			rule.actionType_ = RTL865X_ACL_PERMIT;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rtl865x_add_acl(&rule, RTL_DRV_LAN_NETIF_NAME, -10000);
+
+			u.pat[0]='T';
+			u.pat[1]='T';
+			u.pat[2]='P';
+			u.pat[3]='/';
+			for(i=0;i<RTL8651_PORT_NUMBER;i++)
+			{
+				if(rtl8651_setAsicPortPatternMatch(i, u.pattern, 0xffffffff, 0x2 /* fwd to CPU */)!=SUCCESS)
+					return FAILED;
+			}
+
+		}
+		break;
+
+		case 6:
+		{
+			/*print software netif table information*/
+			int32 i;
+			for(i = 0; i < NETIF_NUMBER; i++)
+			{
+				printk("i(%d),netifTbl(0x%p),name(%s)\n",i,&netifTbl[i],netifTbl[i].name);
+			}
+		}
+		break;
+
+
+	}
+	return retval;
+}
+
+#endif
+#endif
+
+#if 0
+int rtl865x_show_all_netif(void)
+{
+	int32 i;
+	rtl865x_netif_local_t *netif = NULL;
+
+	for(i = 0; i < NETIF_NUMBER; i++)
+	{
+		if(netifTbl[i].valid == 1 )
+		{
+			netif = &netifTbl[i];
+			printk("idx(%d),valid(%d),name(%s),vid(%d),is_slave(%d),type(%d)\n",i,netif->valid,netif->name,netif->vid,netif->is_slave,netif->if_type);
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#if 0 //defined (CONFIG_RTL_LOCAL_PUBLIC)
+int32 rtl865x_getNetifFid(char *name,  uint16 *fid)
+{
+	rtl865x_netif_local_t *entry;
+	rtl865x_vlan_entry_t *vlan;
+
+	if(name == NULL)
+	{
+		return FAILED;
+	}
+
+	entry = _rtl865x_getNetifByName(name);
+
+	if(entry == NULL)
+	{
+		return FAILED;
+	}
+
+	vlan = _rtl8651_getVlanTableEntry(entry->vid);
+	*fid = vlan->fid;
+	return SUCCESS;
+
+}
+#endif
+extern int rtk_vlan_support_enable;
+int32 rtl865x_reConfigDefaultAcl(char *ifName)
+{
+	rtl865x_AclRule_t	rule;
+	int ret=FAILED;
+
+	unsigned long flags=0;
+	SMP_LOCK_ETH(flags);
+
+#if defined (CONFIG_RTK_VLAN_SUPPORT)
+		if(rtk_vlan_support_enable==0)
+		{
+			/*del old default permit acl*/
+			bzero((void*)&rule,sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.actionType_ = RTL865X_ACL_PERMIT;
+			ret=_rtl865x_del_acl(&rule, ifName, RTL865X_ACL_SYSTEM_USED);
+
+			/*add new default permit acl*/
+			bzero((void*)&rule,sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.actionType_ = RTL865X_ACL_PERMIT;
+			ret=_rtl865x_add_acl(&rule, ifName, RTL865X_ACL_SYSTEM_USED);
+		}
+		else
+		{
+			/*del old default to cpu acl*/
+			bzero((void*)&rule,sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			ret=_rtl865x_del_acl(&rule, ifName, RTL865X_ACL_SYSTEM_USED);
+
+			/*add new default to cpu acl*/
+			bzero((void*)&rule,sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			ret=_rtl865x_add_acl(&rule, ifName, RTL865X_ACL_SYSTEM_USED);
+		}
+#else
+		{
+			/*del old default permit acl*/
+			bzero((void*)&rule,sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.actionType_ = RTL865X_ACL_PERMIT;
+			ret=_rtl865x_del_acl(&rule, ifName, RTL865X_ACL_SYSTEM_USED);
+
+			/*add new default permit acl*/
+			bzero((void*)&rule,sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.actionType_ = RTL865X_ACL_PERMIT;
+			ret=_rtl865x_add_acl(&rule, ifName, RTL865X_ACL_SYSTEM_USED);
+		}
+#endif
+		SMP_UNLOCK_ETH(flags);
+
+		return SUCCESS;
+}
+
+//#if defined(CONFIG_RTL_HW_QOS_BRIDGE_FWD_SUPPORT)
+int rtl865x_isWanNetifByIdx(int netifIdx)
+{
+	if (netifIdx <0 || netifIdx >= NETIF_NUMBER)
+		return -1;
+
+	if (netifTbl[netifIdx].valid) {
+		if (strncmp(netifTbl[netifIdx].name, RTL_DRV_LAN_NETIF_NAME, strlen(RTL_DRV_LAN_NETIF_NAME))==0)
+			return 0;
+		else if (strncmp(netifTbl[netifIdx].name, RTL_DRV_WAN0_NETIF_NAME, strlen(RTL_DRV_WAN0_NETIF_NAME))==0)
+			return 1;
+	}
+
+	return -1;
+}
+//#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+int32 sw_netif_read(struct seq_file *s, void *v)
+{
+	uint8 *mac;
+	int32 i;
+
+	seq_printf(s, "%s\n", "SW Network Interface Table:");
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+#endif
+	{
+
+		rtl865x_netif_local_t *intf;
+
+		intf = & netifTbl[i];
+
+		if ( intf->valid )
+		{
+			mac = (uint8 *)&intf->macAddr.octet[0];
+			seq_printf(s,"[%d]netif:%s	VID[%d] %x:%x:%x:%x:%x:%x",
+				i, intf->name,intf->vid, mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
+			seq_printf(s,"	Routing %s	\n",
+				intf->enableRoute==TRUE? "enabled": "disabled" );
+			seq_printf(s,"is slave %d	",intf->is_slave);
+			if(intf->is_slave){
+				seq_printf(s,"master netif:%s",(intf->master->name));
+			}
+			seq_printf(s,"\n");
+			#if 0
+			seq_printf(s,"      ingress ");
+
+			if ( RTL8651_ACLTBL_DROP_ALL <= intf.inAclStart )
+			{
+				if ( intf.inAclStart == RTL8651_ACLTBL_PERMIT_ALL )
+					seq_printf(s,"permit all,");
+				if ( intf.inAclStart == RTL8651_ACLTBL_ALL_TO_CPU )
+					seq_printf(s,"all to cpu,");
+				if ( intf.inAclStart == RTL8651_ACLTBL_DROP_ALL )
+					seq_printf(s,"drop all,");
+			}
+			else
+				seq_printf(s,"ACL %d-%d, ", intf.inAclStart, intf.inAclEnd);
+
+			seq_printf(s,"  egress ");
+
+			if ( RTL8651_ACLTBL_DROP_ALL <= intf.outAclStart )
+			{
+				if ( intf.outAclStart == RTL8651_ACLTBL_PERMIT_ALL )
+					seq_printf(s,"permit all,");
+				if ( intf.outAclStart==RTL8651_ACLTBL_ALL_TO_CPU )
+					seq_printf(s,"all to cpu,");
+				if ( intf.outAclStart==RTL8651_ACLTBL_DROP_ALL )
+					seq_printf(s,"drop all,");
+			}
+			else
+				seq_printf(s,"ACL %d-%d, ", intf.outAclStart, intf.outAclEnd);
+			#endif
+			seq_printf(s, "\n   VID:%d,MTU %d Bytes\n",  intf->vid,intf->mtu);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			seq_printf(s, "      enableRouteV6:%d,    mtuv6:%d\n", intf->enableRouteV6, intf->mtuV6);
+#endif
+
+
+			seq_printf(s, ")\n\n");
+		}
+
+	}
+	return 0;
+}
+#else
+int32 sw_netif_read( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int len;
+	uint8 *mac;
+	int32 i;
+
+	len = sprintf(page, "%s\n", "sw Network Interface Table:");
+	for ( i = 0; i < RTL865XC_NETIFTBL_SIZE; i++ )
+	{
+		rtl865x_netif_local_t *intf;
+
+		intf = & netifTbl[i];
+
+		if (intf->valid)
+		{
+
+			mac = (uint8 *)&intf->macAddr.octet[0];
+			len += sprintf(page+len,"[%d]  %s	VID[%d] %x:%x:%x:%x:%x:%x",
+				i, intf->name,intf->vid, mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
+			len += sprintf(page+len,"  Routing %s \n",
+				intf->enableRoute==TRUE? "enabled": "disabled" );
+
+			len += sprintf(page+len,"is slave %d		",intf->is_slave);
+			if(intf->is_slave){
+				len += sprintf(page+len,"master netif:%s",intf->master->name);
+			}
+			len += sprintf(page+len," \n");
+			#if 0
+			len += sprintf(page+len,"      ingress ");
+
+			if ( RTL8651_ACLTBL_DROP_ALL <= intf.inAclStart )
+			{
+				if ( intf.inAclStart == RTL8651_ACLTBL_PERMIT_ALL )
+					len += sprintf(page+len,"permit all,");
+				if ( intf.inAclStart == RTL8651_ACLTBL_ALL_TO_CPU )
+					len += sprintf(page+len,"all to cpu,");
+				if ( intf.inAclStart == RTL8651_ACLTBL_DROP_ALL )
+					len += sprintf(page+len,"drop all,");
+			}
+			else
+				len += sprintf(page+len,"ACL %d-%d, ", intf.inAclStart, intf.inAclEnd);
+
+			len += sprintf(page+len,"  egress ");
+
+			if ( RTL8651_ACLTBL_DROP_ALL <= intf.outAclStart )
+			{
+				if ( intf.outAclStart == RTL8651_ACLTBL_PERMIT_ALL )
+					len += sprintf(page+len,"permit all,");
+				if ( intf.outAclStart==RTL8651_ACLTBL_ALL_TO_CPU )
+					len += sprintf(page+len,"all to cpu,");
+				if ( intf.outAclStart==RTL8651_ACLTBL_DROP_ALL )
+					len += sprintf(page+len,"drop all,");
+			}
+			else
+				len += sprintf(page+len,"ACL %d-%d, ", intf.outAclStart, intf.outAclEnd);
+			#endif
+			len += sprintf(page+len, "\n      %d MAC Addresses, MTU %d Bytes\n", intf->macAddrNumber, intf->mtu);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			len += sprintf(page+len, "      enableRouteV6:%d,    mtuv6:%d\n", intf->enableRouteV6, intf->mtuV6);
+#endif
+
+
+			len += sprintf(page+len, ")\n\n");
+		}
+
+	}
+
+	if (len <= off+count) *eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len>count)
+		len = count;
+	if (len<0)
+	  	len = 0;
+
+	return len;
+}
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+void rtl865x_get_master_netif_by_vid(int vid, char* netif_name)
+{
+	int i;
+
+	if(!netif_name)
+		return;
+
+	strcpy(netif_name,"");
+
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+	{
+		if ((netifTbl[i].valid==1) && (netifTbl[i].is_slave==0) && (netifTbl[i].vid==vid)) {
+			strcpy(netif_name, netifTbl[i].name);
+			return;
+		}
+	}
+	return;
+}
+
+int32 rtl865x_netif_exist(char *ifName)
+{
+	if (_rtl865x_getSWNetifByName(ifName) != NULL)
+		return 1;
+	else
+		return 0;
+}
+
+/* Be careful,.... NAPT and pure routing are WAN  (If according to netif->is_wan, pure routing netif is LAN) */
+int32 rtl865x_netif_is_wan(char *ifName)
+{
+	rtl865x_netif_local_t* netif;
+	netif = _rtl865x_getNetifByName(ifName);
+
+	//if( netif && netif->is_wan == 1)
+	if (netif && strcmp(netif->name, RTL_DRV_LAN_NETIF_NAME))
+		return 1;
+	else
+		return 0;
+}
+
+int32 rtl865x_netif_is_master(char *ifName)
+{
+	rtl865x_netif_local_t* netif;
+	netif = _rtl865x_getNetifByName(ifName);
+
+	if (netif && netif->is_slave == 0)
+		return 1;
+	else
+		return 0;
+}
+
+
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+void rtl_set_netif_v6_route(int enable)
+{
+	int i = 0;
+
+	#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	for(i = 0; i < NETIF_SW_NUMBER; i++)
+	#else
+	for(i = 0; i < NETIF_NUMBER; i++)
+	#endif
+	{
+		if ((netifTbl[i].valid==1) && (netifTbl[i].is_slave==0)) {
+			if (enable){
+				rtl865x_enableNetifRoutingV6((rtl865x_netif_local_t *)&netifTbl[i]);
+			}
+			else
+			{
+				rtl865x_disableNetifRoutingV6((rtl865x_netif_local_t *)&netifTbl[i]);
+			}
+		}
+	}
+
+	return;
+}
+#endif
+
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS) || defined(CONFIG_RTL_HARDWARE_MULTICAST)
+int rtl_enable_netif_routing(void)
+{
+	int i;
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH(flags);
+	for (i=0; i<NETIF_NUMBER; i++)
+	{
+		if (netifTbl[i].valid == 1) {
+			rtl865x_enableNetifRouting(&netifTbl[i]);
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST) && (defined(CONFIG_RTL_8198C)||defined(CONFIG_RTL_8197F))
+			rtl865x_enableNetifRoutingV6(&netifTbl[i]);
+#endif
+		}
+	}
+	SMP_UNLOCK_ETH(flags);
+
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+uint8* rtl_get_netif_gmac(char *name)
+{
+	rtl865x_netif_local_t *entry;
+
+	if (name == NULL)
+		return NULL;
+
+	entry = _rtl865x_getNetifByName(name);
+
+	if (entry == NULL)
+		return NULL;
+
+	return entry->macAddr.octet;
+}
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_netif_local.h b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_netif_local.h
new file mode 100644
index 00000000..cc05afd
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_netif_local.h
@@ -0,0 +1,101 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : network interface driver header file
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865X_NETIF_LOCAL_H
+#define RTL865X_NETIF_LOCAL_H
+
+#if 0//!defined(REDUCE_MEMORY_SIZE_FOR_16M)
+#define REDUCE_MEMORY_SIZE_FOR_16M
+#endif
+
+#if defined(REDUCE_MEMORY_SIZE_FOR_16M)
+#define RTL865X_ACL_CHAIN_NUMBER	32
+#else
+#define RTL865X_ACL_CHAIN_NUMBER	16
+#endif
+#define RTL865X_ACL_SYSTEM_USED	-10000
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+typedef struct _rtl865x_acl_chain_s
+{
+	int32 ruleCnt;
+	int32 priority; /*chain priosity: the minimum value is the highest proirity*/
+	rtl865x_AclRule_t *head,*tail;
+	struct _rtl865x_acl_chain_s *preChain,*nextChain;
+}rtl865x_acl_chain_t;
+#endif
+
+/*the following fields are invalid when the interface is slave interface:
+* inAclStart, inAclEnd, outAclStart, outAclEnd,asicIdx,chainListHead
+*/
+typedef struct rtl865x_netif_local_s
+{
+	uint16 	vid; /*netif->vid*/
+	uint16 	mtu; /*netif's MTU*/
+	uint16 	macAddrNumber; /*how many continuous mac is attached*/
+	uint16 	inAclStart, inAclEnd, outAclStart, outAclEnd; /*acl index*/
+	uint16 	enableRoute; /*enable route*/
+	uint32 	valid:1,	/*valid?*/
+		if_type:5, /*interface type, IF_ETHER, IF_PPPOE*/
+		refCnt:5, /*referenc count by other table entry*/
+		asicIdx:3, /*asic index, total 8 entrys in asic*/
+		is_wan:1, /*this interface is wan?*/
+		is_defaultWan:1, /*if there is multiple wan interface, which interface is default wan*/
+		dmz:1,	/*dmz interface?*/
+		is_slave:1; /*is slave interface*/
+
+	ether_addr_t macAddr;
+	uint8	name[MAX_IFNAMESIZE];
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+	rtl865x_acl_chain_t  *chainListHead[2]; /*0: ingress acl chain, 1: egress acl chain*/
+#endif //CONFIG_RTL_LAYERED_DRIVER_ACL
+	struct rtl865x_netif_local_s *master; /*point master interface when this interface is slave interface*/
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint16 	enableRouteV6; /*enable ipv6 route*/
+	uint16 	mtuV6;         /*netif's ipv6 MTU*/
+#endif
+}rtl865x_netif_local_t;
+
+#define	RTL_ACL_INGRESS	0
+#define	RTL_ACL_EGRESS	1
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+typedef struct rtl865x_aclBuf_s
+{
+	int16 totalCnt;
+	int16 freeCnt;
+	rtl865x_AclRule_t *freeHead;
+}rtl865x_aclBuf_t;
+#endif
+
+int32 rtl865x_enableNetifRouting(rtl865x_netif_local_t *netif);
+int32 rtl865x_disableNetifRouting(rtl865x_netif_local_t *netif);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+int32 rtl865x_enableNetifRoutingV6(rtl865x_netif_local_t *netif);
+int32 rtl865x_disableNetifRoutingV6(rtl865x_netif_local_t *netif);
+#endif
+
+rtl865x_netif_local_t *_rtl865x_getNetifByName(char *name);
+rtl865x_netif_local_t *_rtl865x_getSWNetifByName(char * name);
+rtl865x_netif_local_t *_rtl865x_getDefaultWanNetif(void);
+int32 _rtl865x_setDefaultWanNetif(char *name);
+int32 _rtl865x_clearDefaultWanNetif(char * name);
+int32 _rtl865x_getNetifIdxByVid(uint16 vid);
+int32 _rtl865x_getNetifIdxByName(uint8 *name);
+int32 _rtl865x_getNetifIdxByNameExt(uint8 *name);
+int32 rtl865x_get_drvNetifName_by_psName(const char *psName,char *netifName);
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_vlan.c b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_vlan.c
new file mode 100644
index 00000000..e9f8ad6
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_vlan.c
@@ -0,0 +1,787 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : Vlan driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "rtl_errno.h"
+//#include "rtl_utils.h"
+//#include "rtl_glue.h"
+#include "rtl865x_vlan.h"
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#endif
+#include "rtl865x_eventMgr.h"
+
+
+static rtl865x_vlan_entry_t *vlanTbl = NULL;
+
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
+static RTL_DECLARE_MUTEX(vlan_sem);
+#endif
+static int32 _rtl865x_delVlan(uint16 vid);
+
+static int32 _rtl865x_setAsicVlan(uint16 vid,rtl865x_vlan_entry_t *vlanEntry)
+{
+	int32 retval = FAILED;
+	rtl865x_tblAsicDrv_vlanParam_t asicEntry;
+	/*add this entry to asic table*/
+	asicEntry.fid = vlanEntry->fid;
+	asicEntry.memberPortMask = vlanEntry->memberPortMask;
+	asicEntry.untagPortMask = vlanEntry->untagPortMask;
+
+#if defined(CONFIG_RTL_8197F)
+	asicEntry.hp = vlanEntry->hp;
+#endif
+
+	retval = rtl8651_setAsicVlan(vid,&asicEntry);
+	return retval;
+}
+
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+static rtl865x_vlan_entry_t *rtl_getVlanEntryByVid(uint16 vid)
+{
+	int i;
+	rtl865x_vlan_entry_t *entry = NULL;
+
+	for(i=0; i<VLANTBL_SIZE; i++)
+	{
+		if(vlanTbl[i].vid == vid){
+			entry = &vlanTbl[i];
+			break;
+		}
+	}
+
+	return entry;
+}
+
+static rtl865x_vlan_entry_t *rtl_findEmptyVlanEntry(void)
+{
+	int i;
+	rtl865x_vlan_entry_t *entry = NULL;
+
+	for(i=0; i<VLANTBL_SIZE; i++)
+	{
+		if(vlanTbl[i].valid == 0){
+			entry = &vlanTbl[i];
+			break;
+		}
+	}
+
+	return entry;
+}
+#endif
+
+static int32 _rtl865x_referVlan(uint16 vid)
+{
+	rtl865x_vlan_entry_t *entry;
+	/* vid should be legal vlan ID */
+	if(vid < 1 || vid > VLAN_NUMBER-1)
+		return RTL_EINVALIDVLANID;
+
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+
+	entry = rtl_getVlanEntryByVid(vid);
+	if(entry == NULL)
+		return RTL_EINVALIDVLANID;
+#else
+
+	entry = &vlanTbl[vid];
+#endif
+
+	if(entry->valid != 1)
+		return RTL_EINVALIDVLANID;
+
+	entry->refCnt++;
+	return SUCCESS;
+}
+
+static int32 _rtl865x_deReferVlan(uint16 vid)
+{
+	rtl865x_vlan_entry_t *entry;
+	/* vid should be legal vlan ID */
+	if(vid < 1 || vid > VLAN_NUMBER-1)
+		return RTL_EINVALIDVLANID;
+
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+
+	entry = rtl_getVlanEntryByVid(vid);
+	if(entry == NULL)
+		return RTL_EINVALIDVLANID;
+#else
+
+	entry = &vlanTbl[vid];
+#endif
+
+	if(entry->valid != 1)
+		return RTL_EINVALIDVLANID;
+
+	entry->refCnt--;
+	return SUCCESS;
+}
+
+int32 _rtl865x_addVlan(uint16 vid)
+{
+	int32 retval = FAILED;
+	rtl865x_vlan_entry_t *entry;
+
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+	entry = rtl_findEmptyVlanEntry();
+	if(entry == NULL)
+		return RTL_EINVALIDVLANID;
+#else
+	entry=&vlanTbl[vid];
+	if(1 == entry->valid)
+		return RTL_EVLANALREADYEXISTS;
+#endif
+
+	/*add new vlan entry*/
+	memset(entry,0,sizeof(rtl865x_vlan_entry_t));
+	entry->vid = vid;
+	entry->valid = 1;
+	entry->refCnt = 1;
+
+	/*add this entry to asic table*/
+	retval = _rtl865x_setAsicVlan(vid,entry);
+
+	return retval;
+}
+
+
+static int32 _rtl865x_delVlan(uint16 vid)
+{
+	int32 retval = FAILED;
+	rtl865x_vlan_entry_t *vlanEntry,org;
+
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+	vlanEntry = rtl_getVlanEntryByVid(vid);
+	if(vlanEntry == NULL)
+		return RTL_EINVALIDVLANID;
+#else
+	vlanEntry = &vlanTbl[vid];
+#endif
+	if(0 == vlanEntry->valid)
+		return RTL_EINVALIDVLANID;
+	/*
+	if(vlanEntry->refCnt > 1)
+	{
+		printk("vid(%d),reference(%d)\n",vid,vlanEntry->refCnt);
+		return RTL_EREFERENCEDBYOTHER;
+	}
+	*/
+
+	memcpy(&org,vlanEntry,sizeof(rtl865x_vlan_entry_t));
+
+	/*delete vlan entry*/
+	vlanEntry->valid =  0;
+	/*ignor other member...*/
+
+	retval = rtl8651_delAsicVlan(vid);
+
+	if(SUCCESS == retval)
+	{
+		/*if vlan entry is deleted, this information should be noticed by uplayer module*/
+		#if 0
+		do_eventAction(EV_DEL_VLAN, (void *)&org);
+		#else
+		rtl865x_raiseEvent(EVENT_DEL_VLAN, (void *)&org);
+		#endif
+	}
+
+	return retval;
+}
+
+static int32 _rtl865x_addVlanPortMember(uint16 vid, uint32 portMask)
+{
+	int32 retval = FAILED;
+	rtl865x_vlan_entry_t *vlanEntry;
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+	vlanEntry = rtl_getVlanEntryByVid(vid);
+	if(vlanEntry == NULL)
+		return RTL_EINVALIDVLANID;
+#else
+	vlanEntry = &vlanTbl[vid];
+#endif
+	if(vlanEntry->valid == 0)
+		return RTL_EINVALIDVLANID;
+
+	/*add member port*/
+	vlanEntry->memberPortMask |= portMask;
+	vlanEntry->untagPortMask |= portMask;
+
+	/*update this entry to asic table*/
+	retval = _rtl865x_setAsicVlan(vid,vlanEntry);
+
+	return retval;
+
+
+}
+
+static int32 _rtl865x_addVlanPortMember2(uint16 vid, uint32 portMask, uint32 untagPortMask)
+{
+	int32 retval = FAILED;
+	rtl865x_vlan_entry_t *vlanEntry;
+
+	vlanEntry = &vlanTbl[vid];
+	if(vlanEntry->valid == 0)
+		return RTL_EINVALIDVLANID;
+
+	/*add member port*/
+	vlanEntry->memberPortMask = portMask;
+	vlanEntry->untagPortMask = untagPortMask;
+
+	/*update this entry to asic table*/
+	retval = _rtl865x_setAsicVlan(vid,vlanEntry);
+
+	return retval;
+}
+
+int32 rtl865x_addVlanPortMember2(uint16 vid, uint32 portMask, uint32 untagPortMask)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	/* vid should be legal vlan ID */
+	if(vid < 1 || vid > VLAN_NUMBER -1)
+		return RTL_EINVALIDVLANID;
+
+	//rtl_down_interruptible(&vlan_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_addVlanPortMember2(vid,portMask,untagPortMask);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+static int32 _rtl865x_delVlanPortMember(uint16 vid, uint32 portMask)
+{
+	int32 retval = FAILED;
+	rtl865x_vlan_entry_t *vlanEntry;
+	//rtl865x_tblAsicDrv_vlanParam_t asicEntry;
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+	vlanEntry = rtl_getVlanEntryByVid(vid);
+	if(vlanEntry == NULL)
+		return RTL_EINVALIDVLANID;
+#else
+	vlanEntry = &vlanTbl[vid];
+#endif
+
+	if(vlanEntry->valid == 0)
+		return RTL_EINVALIDVLANID;
+
+	/*add member port*/
+	vlanEntry->memberPortMask &= ~portMask;
+	vlanEntry->untagPortMask &=~portMask;
+
+	if(vlanEntry->memberPortMask == 0)
+		vlanEntry->valid = 0;
+
+	/*update this entry to asic table*/
+	retval = _rtl865x_setAsicVlan(vid,vlanEntry);
+
+	return retval;
+
+
+}
+
+
+static int32 _rtl865x_setVlanPortTag(uint16 vid, uint32 portMask, uint8 tag)
+{
+	int32 retval = FAILED;
+	rtl865x_vlan_entry_t *vlanEntry;
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+	vlanEntry = rtl_getVlanEntryByVid(vid);
+	if(vlanEntry == NULL)
+		return RTL_EINVALIDVLANID;
+#else
+	vlanEntry = &vlanTbl[vid];
+#endif
+
+	if(vlanEntry->valid == 0)
+		return RTL_EINVALIDVLANID;
+
+	if(tag == 0)
+		vlanEntry->untagPortMask |= vlanEntry->memberPortMask & portMask;
+	else
+		vlanEntry->untagPortMask &=~(vlanEntry->memberPortMask & portMask);
+
+	/*update this entry to asic table*/
+	retval = _rtl865x_setAsicVlan(vid,vlanEntry);
+
+	return retval;
+
+}
+
+static int32 _rtl865x_setVlanFID(uint16 vid, uint32 fid)
+{
+	int32 retval = FAILED;
+	rtl865x_vlan_entry_t *vlanEntry;
+
+	if(fid >= RTL865X_FDB_NUMBER)
+		return RTL_EINVALIDFID;
+
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+	vlanEntry = rtl_getVlanEntryByVid(vid);
+	if(vlanEntry == NULL)
+		return RTL_EINVALIDVLANID;
+#else
+	vlanEntry = &vlanTbl[vid];
+#endif
+
+	if(vlanEntry->valid == 0)
+		return RTL_EINVALIDVLANID;
+
+	vlanEntry->fid = fid;
+
+	/*update this entry to asic table*/
+	retval = _rtl865x_setAsicVlan(vid,vlanEntry);
+
+	return retval;
+}
+
+
+static int32 _rtl865x_getVlanFilterDatabaseId(uint16 vid, uint32 *fid)
+{
+	int32 retval = 0;
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+	rtl865x_vlan_entry_t *vlanEntry;
+#endif
+
+	if(vid < 1 || vid > VLAN_NUMBER -1)
+		return RTL_EINVALIDVLANID;
+
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+
+	vlanEntry = rtl_getVlanEntryByVid(vid);
+	if(vlanEntry == NULL)
+		return RTL_EINVALIDVLANID;
+
+	if(vlanEntry->valid == 1)
+#else
+
+	if(vlanTbl[vid].valid == 1)
+#endif
+	{
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+		*fid = vlanEntry->fid;
+#else
+		*fid = vlanTbl[vid].fid;
+#endif
+		retval = SUCCESS;
+	}
+	else
+	{
+		/*jwj: Because I may change eth1 netif vid to 1 when CONFIG_RTL_VLAN_BASED_NETIF
+		enabled in rtl_set_wanport_vlanconfig()*/
+		#if !defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+		#ifndef CONFIG_RTL_IVL_SUPPORT
+		extern int rtl865x_curOpMode;
+		if (rtl865x_curOpMode == 0) // GATEWAY_MODE
+			printk("%s(%d):the vlan[%d] is invalid!\n",__FUNCTION__,__LINE__, vid);
+		#endif
+		#endif
+		retval = FAILED;
+	}
+
+	return retval;
+
+}
+rtl865x_vlan_entry_t *_rtl8651_getVlanTableEntry(uint16 vid)
+{
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+	rtl865x_vlan_entry_t *vlanEntry;
+
+	if(vid < 1 || vid > VLAN_NUMBER -1)
+		return NULL;
+
+	vlanEntry = rtl_getVlanEntryByVid(vid);
+	return vlanEntry;
+#else
+	if(vlanTbl[vid].valid == 1)
+		return &vlanTbl[vid];
+	return NULL;
+#endif
+}
+
+/*
+@func int32 | rtl865x_referVlan | reference a VLAN entry.
+@parm uint16 | vid | VLAN ID.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDVLANID | Invalid VLAN ID.
+@comm
+if a vlan entry is referenced, please call this API.
+*/
+int32 rtl865x_referVlan(uint16 vid)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&vlan_sem);
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl865x_referVlan(vid);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH_HW(flags);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_deReferVlan | dereference a VLAN entry.
+@parm uint16 | vid | VLAN ID.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDVLANID | Invalid VLAN ID.
+@comm
+if a vlan entry is dereferenced, please call this API.
+NOTE: rtl865x_deReferVlan should be called after rtl865x_referVlan.
+*/
+int32 rtl865x_deReferVlan(uint16 vid)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&vlan_sem);
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl865x_deReferVlan(vid);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH_HW(flags);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_addVlan | Add a VLAN.
+@parm uint16 | vid | VLAN ID.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDVLANID | Invalid VLAN ID.
+@rvalue RTL_EVLANALREADYEXISTS | Vlan already exists.
+*/
+int32 rtl865x_addVlan(uint16 vid)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	/* vid should be legal vlan ID */
+	if(vid < 1 || vid > VLAN_NUMBER-1)
+		return RTL_EINVALIDVLANID;
+
+	//rtl_down_interruptible(&vlan_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_addVlan(vid);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+
+}
+
+/*
+@func int32 | rtl865x_delVlan | Delete a VLAN.
+@parm uint16 | vid | VLAN ID.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDVLANID | Invalid VLAN ID.
+@rvalue RTL_EREFERENCEDBYOTHER | the Vlan is referenced by other,please delete releated table entry first.
+*/
+int32 rtl865x_delVlan(uint16 vid)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	/* vid should be legal vlan ID */
+	if(vid < 1 || vid > VLAN_NUMBER -1)
+		return RTL_EINVALIDVLANID;
+
+	//rtl_down_interruptible(&vlan_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_delVlan(vid);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_addVlanPortMember | configure vlan member port
+@parm uint16 | vid | VLAN ID.
+@parm uint32 | portMask | Port mask.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDVLANID | Invalid VLAN ID.
+@comm
+the parm portMask is the MASK of port. bit0 mapping to physical port 0,bit1 mapping to physical port 1.
+*/
+int32 rtl865x_addVlanPortMember(uint16 vid, uint32 portMask)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	/* vid should be legal vlan ID */
+	if(vid < 1 || vid > VLAN_NUMBER -1)
+		return RTL_EINVALIDVLANID;
+
+	//rtl_down_interruptible(&vlan_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_addVlanPortMember(vid,portMask);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_delVlanPortMember | delete vlan's member port
+@parm uint16 | vid | VLAN ID.
+@parm uint32 | portMask | Port mask.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDVLANID | Invalid VLAN ID.
+@comm
+the parm portMask is the MASK of port. bit0 mapping to physical port 0,bit1 mapping to physical port 1.
+*/
+int32 rtl865x_delVlanPortMember(uint16 vid,uint32 portMask)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	/* vid should be legal vlan ID */
+	if(vid < 1 || vid > VLAN_NUMBER -1)
+		return RTL_EINVALIDVLANID;
+
+	//rtl_down_interruptible(&vlan_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_delVlanPortMember(vid,portMask);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH(flags);
+
+	return retval;
+
+}
+
+
+/*
+@func uint32 | rtl865x_getVlanPortMask | get the member portMask of a vlan
+@parm uint16 | vid | VLAN ID.
+@comm
+if the retrun value is zero, it means vlan entry is invalid or no member port in this vlan.
+*/
+uint32 rtl865x_getVlanPortMask(uint32 vid)
+{
+	rtl865x_vlan_entry_t *vlanEntry;
+
+	if(vid < 1 || vid > VLAN_NUMBER -1)
+		return 0;
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+
+	vlanEntry = rtl_getVlanEntryByVid(vid);
+	if(vlanEntry == NULL)
+		return 0;
+#else
+
+	vlanEntry = &vlanTbl[vid];
+#endif
+	if(vlanEntry->valid == 0)
+		return 0;
+
+	return vlanEntry->memberPortMask;
+}
+
+
+/*
+@func int32 | rtl865x_setVlanPortTag | configure member port vlan tag attribute
+@parm uint16 | vid | VLAN ID.
+@parm uint32 | portMask | Port mask.
+@parm uint8 | portMask | vlantag or untag.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDVLANID | Invalid VLAN ID.
+@comm
+the parm portMask is the MASK of port. bit0 mapping to physical port 0,bit1 mapping to physical port 1.
+parm tag is used to indicated physical port is vlantag or untag. value 1 means vlan tagged, and vlan 0 means vlan untagged.
+*/
+int32 rtl865x_setVlanPortTag(uint16 vid,uint32 portMask,uint8 tag)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	/* vid should be legal vlan ID */
+	if(vid < 1 || vid > VLAN_NUMBER -1)
+		return RTL_EINVALIDVLANID;
+
+	//rtl_down_interruptible(&vlan_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_setVlanPortTag(vid,portMask,tag);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_setVlanFilterDatabase | configure the filter database for a vlan.
+@parm uint16 | vid | VLAN ID.
+@parm uint32 | fid | filter data base ID.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDVLANID | Invalid VLAN ID.
+@rvalue RTL_EINVALIDFID | Invalid filter database ID.
+@comm
+in realtek 865x, 4 filter databases are support.
+if you want to configure SVL for all vlan, please set the fid of vlan is same.
+default configure is SVL.
+*/
+int32 rtl865x_setVlanFilterDatabase(uint16 vid, uint32 fid)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	/* vid should be legal vlan ID */
+	if(vid < 1 || vid > VLAN_NUMBER -1)
+		return RTL_EINVALIDVLANID;
+
+	//rtl_down_interruptible(&vlan_sem);//Lock resource
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_setVlanFID(vid,fid);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH(flags);
+
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_getVlanFilterDatabaseId | get the vlan's filter database ID.
+@parm uint16 | vid | VLAN ID.
+@parm uint32 | fid | filter data base ID.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDVLANID | Invalid VLAN ID.
+@comm
+*/
+int32 rtl865x_getVlanFilterDatabaseId(uint16 vid, uint32 *fid)
+{
+	int32 retval = FAILED;
+	retval = _rtl865x_getVlanFilterDatabaseId(vid, fid);
+
+	return retval;
+}
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+static int32 _rtl865x_modVlanPortMember(uint16 vid, uint32 portMask, uint32 untagset)
+{
+	int32 retval = FAILED;
+	rtl865x_vlan_entry_t *vlanEntry;
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+	vlanEntry = rtl_getVlanEntryByVid(vid);
+	if(vlanEntry == NULL)
+		return RTL_EINVALIDVLANID;
+#else
+	vlanEntry = &vlanTbl[vid];
+#endif
+	if(vlanEntry->valid == 0)
+		return RTL_EINVALIDVLANID;
+
+	/*add member port*/
+	vlanEntry->memberPortMask = portMask;
+	vlanEntry->untagPortMask = untagset;
+
+	/*update this entry to asic table*/
+	retval = _rtl865x_setAsicVlan(vid,vlanEntry);
+
+	return retval;
+}
+
+int32 rtl865x_modVlanPortMember(uint16 vid, uint32 portMask, uint32 untagset)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	/* vid should be legal vlan ID */
+	if(vid < 1 || vid > VLAN_NUMBER -1)
+		return RTL_EINVALIDVLANID;
+
+	//rtl_down_interruptible(&vlan_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_modVlanPortMember(vid, portMask, untagset);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+#endif /* CONFIG_RTL_ISP_MULTI_WAN_SUPPORT */
+
+/*
+@func int32 | rtl865x_initVlanTable | initialize vlan table.
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed,system should be reboot.
+*/
+int32 rtl865x_initVlanTable(void)
+{
+	TBL_MEM_ALLOC(vlanTbl, rtl865x_vlan_entry_t, VLANTBL_SIZE);
+	memset(vlanTbl,0,sizeof(rtl865x_vlan_entry_t)*VLANTBL_SIZE);
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865x_reinitVlantable | initialize vlan table.
+@rvalue SUCCESS | Success.
+*/
+int32 rtl865x_reinitVlantable(void)
+{
+	uint16 i;
+	for(i = 0; i < VLAN_NUMBER; i++)
+	{
+		if(vlanTbl[i].valid)
+		{
+			#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+			_rtl865x_delVlan(vlanTbl[i].vid);
+			#else
+			_rtl865x_delVlan(i);
+			#endif
+		}
+	}
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_8197F)
+static int32 _rtl865x_setVlanHp(uint16 vid, uint8 hp)
+{
+	int32 retval = FAILED;
+	rtl865x_vlan_entry_t *vlanEntry;
+
+	vlanEntry = &vlanTbl[vid];
+	if (vlanEntry->valid == 0)
+		return RTL_EINVALIDVLANID;
+
+	/*add vid priority*/
+	vlanEntry->hp = hp;
+
+	/*update this entry to asic table*/
+	retval = _rtl865x_setAsicVlan(vid,vlanEntry);
+
+	return retval;
+}
+
+int32 rtl865x_setVlanHp(uint16 vid, uint8 hp)
+{
+	int32 retval = FAILED;
+	unsigned long flags = 0;
+	/* vid should be legal vlan ID */
+	if ((vid < 1) ||(vid > VLAN_NUMBER -1) ||(hp < 0) ||(hp > 7))
+		return RTL_EINVALIDVLANID;
+
+	//rtl_down_interruptible(&vlan_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_setVlanHp(vid, hp);
+	//rtl_up(&vlan_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+int32 rtl865x_getVlanHp(uint16 vid, uint8 *hp)
+{
+	rtl865x_vlan_entry_t *vlanEntry;
+
+	/* vid should be legal vlan ID */
+	if ((vid < 1) ||(vid > VLAN_NUMBER -1) ||(hp == NULL))
+		return RTL_EINVALIDVLANID;
+
+	vlanEntry = &vlanTbl[vid];
+	if (vlanEntry->valid == 0)
+		return RTL_EINVALIDVLANID;
+
+	*hp = vlanEntry->hp;
+
+	return SUCCESS;
+}
+#endif /* CONFIG_RTL_8197F */
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_vlan.h b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_vlan.h
new file mode 100644
index 00000000..aba6315
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl865x_vlan.h
@@ -0,0 +1,79 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : Vlan driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#ifndef	RTL865X_VLAN_H
+#define	RTL865X_VLAN_H
+
+//#include "rtl_types.h"
+
+#if 0//!defined(REDUCE_MEMORY_SIZE_FOR_16M)
+#define REDUCE_MEMORY_SIZE_FOR_16M
+#endif
+
+
+#define VLAN_NUMBER			4096
+
+
+#if defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_819XD)
+#define VLANTBL_SIZE				16
+#else
+#define VLANTBL_SIZE				4096
+#endif
+
+#define RTL865X_FDB_NUMBER	4
+
+#define RTL865X_PPTP_HWACC_PORTMASK		0x80
+#define RTL865X_PPTP_HWACC_VLANID		10
+
+
+typedef struct rtl865x_vlan_entry_s {
+	uint32	memberPortMask; /*extension ports [rtl8651_totalExtPortNum-1:0] are located at bits [RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum-1:RTL8651_PORT_NUMBER]*/
+	uint32	untagPortMask; /*extension ports [rtl8651_totalExtPortNum-1:0] are located at bits [RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum-1:RTL8651_PORT_NUMBER]*/
+	uint32	valid:1,
+			fid:2,	/*there are 4 fdbs in 865x*/
+			vid:12,
+			refCnt:5; /*reference count: this vlan entry is referenced by networkInterface...*/
+#if defined(CONFIG_RTL_8197F)
+	uint32	hp:3;
+#endif
+
+}rtl865x_vlan_entry_t;
+
+int32 rtl865x_initVlanTable(void);
+int32 rtl865x_reinitVlantable(void);
+int32 rtl865x_addVlan(uint16 vid);
+int32 rtl865x_delVlan(uint16 vid);
+int32 rtl865x_addVlanPortMember(uint16 vid, uint32 portMask);
+int32 rtl865x_delVlanPortMember(uint16 vid,uint32 portMask);
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST) || defined (CONFIG_RTL_HW_QOS_SUPPORT)
+uint32 rtl865x_getVlanPortMask(uint32 vid);
+#endif
+
+int32 rtl865x_setVlanPortTag(uint16 vid,uint32 portMask,uint8 tag);
+int32 rtl865x_setVlanFilterDatabase(uint16 vid, uint32 fid);
+int32 rtl865x_getVlanFilterDatabaseId(uint16 vid, uint32 *fid);
+rtl865x_vlan_entry_t *_rtl8651_getVlanTableEntry(uint16 vid);
+int32 rtl865x_referVlan(uint16 vid);
+int32 rtl865x_deReferVlan(uint16 vid);
+#if defined(CONFIG_RTL_8197F)
+int32 rtl865x_setVlanHp(uint16 vid, uint8 hp);
+int32 rtl865x_getVlanHp(uint16 vid, uint8 *hp);
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+int32 rtl865x_modVlanPortMember(uint16 vid, uint32 portMask, uint32 untagset);
+#endif
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/rtl_errno.h b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl_errno.h
new file mode 100644
index 00000000..348d740
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl_errno.h
@@ -0,0 +1,320 @@
+
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* Program : The header file of all error numbers
+* Abstract :
+* Author : David Chun-Feng Liu (cfliu@realtek.com.tw)
+* $Id: rtl_errno.h,v 1.1 2007-12-21 10:29:52 davidhsu Exp $
+* $log$
+* -------------------------------------------------------
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef _RTL_ERRNO_H
+#define _RTL_ERRNO_H
+
+//Driver ERROR NUMBER Definition
+
+/* Error Number for common use */
+#define RTL_DUMMY						-1 // NEVER use me!!! '-1' is used by FAILED.
+#define RTL_EENTRYALREADYEXIST			-2 //The specifyied entry already exists.
+#define RTL_EENTRYNOTFOUND			-3 //The specified entry was not found.
+#define RTL_EINVALIDPORT				-4 //Unknown port number
+#define RTL_EINVALIDVLANID				-5 //Invalid VLAN ID.
+#define RTL_EINVALIDINPUT				-6 //Invalid input parameter.
+#define RTL_EINVNETIFNAME				-7 //Invalid Network Interface name
+#define RTL_ENEEDLOOPBACKSET			-8 //Need loopback port set
+#define RTL_ENOFREEBUFFER				-9 //No Free buffer for new request
+#define RTL_EINVALIDIPRANGE				-10//Invalid IP RANGE
+#define RTL_EINVALIDIPFILTER			-11//Invalid Ip filter which for filter pkt's sip or dip
+#define RTL_ETOOMANYCOLLISION			-12//too many adding collsion
+
+/* Error Number for Port Mirror */
+#define RTL_EPORTISAMIRRORPORT		-1000 //The specified port is already configured as a mirror port
+#define RTL_EPORTISARXTXMIRRORED			-1001 //The specified port is a Rx/Tx mirrored port
+#define RTL_EPORTCANTBEAGGREGATED	-1002 //The Mirror port cannot be aggregated.
+#define RTL_EMIRRORPORTNOTFOUND		-1003 //The specified Mirror port not found.
+
+/* DMZ Host error number */
+#define RTL_EDMZHOSTNOTFOUND			-1100 //DMZ host not found
+#define RTL_EDMZHOSTNEEDNAPTIP		-1101 //DMZ host needs NAPT Ip address present
+#define RTL_EDMZHOSTSHOULDBEINTIP		-1102 //DMZ host should be internal ip address
+#define RTL_EDMZHOSTCANNOTBEGWIP		-1103 //DMZ host cannot be gateway ip address
+#define RTL_EDMZHOSTFULL				-1104 //DMZ host array is full.
+#define RTL_EDMZHOSTDENYFILTEREDSIP	-1105 //filtered PKT to DMZ because of the PKT's Sip in filterring range
+
+/* Error Number for ALG APIs */
+#define RTL_EINVALALGATTR			-1200 //Invalid ALG attribute. Neither Server nor Client is
+											  //specified to an ALG entry.
+#define RTL_EINVALPORTRANGE			-1201 //Invalid port range was specified.
+#define RTL_EALGPORTRANGEOVERLAP		-1202 //ALG port range overlap
+
+/* Error Number for Protocol Trap APIs */
+#define RTL_EUNKNOWPROTOTYPE			-1300 //Unknown Protocol Trap's Protocol type
+
+
+/* Error Number for ACL rule APIs */
+#define RTL_EACLRULEISNULL			-1400 //The specified ACL rule is NULL
+#define RTL_EINVALACTIONTYPE			-1401 //ACL rule with invalid action type
+#define RTL_EACLMODEISNOTALLOWED		-1402 //ACL mode is not match.
+#define RTL_EACLRULE_MATCHTYPEINCORRECT 	-1403 /* Incorrect match type */
+#define RTL_EACLEGRESSRULE_NOTSUPPORTPKTOP	-1404	/* Egress ACL not support packet operation */
+#define RTL_EACLINVALIDRULETYPE				-1405	/* Invalid acl rule type */
+
+/* Error Number for NAPT APIs */
+#define RTL_ENAPTIPNOTEXTIP			-1500 //The Specified NAPT IP is not an external IP address
+#define RTL_ENAPTIPCANNOTBENAT		-1501 //The Specified NAPT IP can not a NAT IP address
+
+/* Error Number for Ethernet port */
+#define RTL_EPORTOPMODECANNOTAGGREGATE	-1600 //Can not set a port's operation mode if the port is aggreaged.
+#define RTL_EUNKNOWPORTSPEED				-1601 //Unknow port speed. The port speed should be either 10 or 100.
+#define RTL_EPORTSPEEDCANNOTAGGREGATE 	-1602 //The specified port's speed can not be changed if the port is aggreaged.
+#define RTL_EPORTAUTONEGOCANNOTAGGREGATE	-1603 //Can not change a port's auto-negotiation capability if the port is aggregated.
+#define RTL_EINVALIDDATARATE				-1604 //Invalid data rate.
+#define RTL_ENOTVLANPORTMEMBER			-1605 //Specified port is not a member port of specified vlan.
+
+/* Error Number for Spanning Tree */
+#define RTL_EINVALIDSID					-1700 //Invalid spanning tree ID.
+#define RTL_ESIDALREADYEXIST				-1701 //Spannding Tree ID already exists.
+#define RTL_EINVALIDPORTSTATE			-1702 //Invalid Port State.
+#define RTL_ESIDISREFERENCEEDBYFID		-1703 //Spanning Tree is being referenced by Filter Database.
+
+/* Error Number for Filter Database */
+#define RTL_EINVALIDFID					-1800 //Invalid Filter database ID
+#define RTL_EFIDALREADYEXISTS			-1801 //Filter Database already exists.
+#define RTL_EFIDISREFERENCEDBYVLAN		-1802 //Filter Database is being referenced by VLAN
+#define RTL_EFIDISNOTEMPTY				-1803 //Filter Database is not empty
+#define RTL_EINVALIDACTIONTYPE			-1804 //Invalid Port Action Type.
+#define RTL_ENULLMACADDR					-1805 //The specified MAC address is NULL.
+#define RTL_EL2ENTRYEXISTS				-1806 //The filter database entry already exists.
+#define RTL_EL2ENTRYNOTFOUND				-1807 //The specified filter database entry was not found.
+//#ifdef TEST_GETL2TBL
+#define RTL_EGETL2_EMPTYL2TBL				-1808	/* The L2 table is empty */
+#define RTL_EGETL2_INVALIDL2ENTRY			-1809	/* User specifies an invalid MAC address */
+#define RTL_EGETL2_NOMOREVALIDL2ENTRY	-1810	/* No more valid L2 entry */
+//#endif
+
+/* Error Number for Aggregator */
+#define RTL_EINVALIDAGGREGATORID			-1900 //Invalid aggregator ID.
+#define RTL_EALREADYTRUNKING				-1901 //Aggregator already aggregates more than one port.
+#define RTL_EAGGREGATORHASNOPORT			-1902 //Not allow aggregator without port member
+#define RTL_EAGGREGATOREXCEED			-1903 //The number of aggregator excees the system capability.
+#define RTL_EAGGREGATORIDGTPORTNO		-1904 //Aggreagator ID > Port Number. When aggregating ports,
+												  //any port No. > aggregator ID is disallowed.
+#define RTL_EAGGREGATORSETINDIVIDUAL		-1905 //Aggregator was set to individual, hence it can not
+												  //aggreate more then one port.
+#define RTL_EDIFFBROADCASTDOMAIN			-1906 //Aggregator and port are in different broadcast domain.
+
+/* Error Number for VLAN */
+#define RTL_EVLANALREADYEXISTS			-2000 //Vlan already exists.
+#define RTL_ECANNOTREMOVEDEFVLAN			-2001 //Cannot remove default VLAN.
+#define RTL_EVLANISREFERENCEDBYNETIF		-2002 //Vlan is referenced by network interface.
+#define RTL_EVLANISREFERENCEDBYPPPOE		-2003 //Vlan is referenced by PPPoE.
+#define RTL_EVLANHASMACALLOCATED			-2004 //Vlan still has MAC address allocated.
+#define RTL_EVLANHASHPORTMEMBER			-2005 //Vlan can not have member port while specifying its Filter database.
+#define RTL_EVLANTXMIRRORSET				-2006 //Vlan has Tx mirror set hence can not set to promiscuous mode.
+#define RTL_EPORTNOTVLANMEMBER			-2007 //The specified port is not a member of specified VLAN.
+#define RTL_EVLANPROMISSET				-2008 //If VLAN promiscuous is set, a network interface cannot attach to the VLAN.
+#define RTL_EFWDTXMIRRORSET				-2009 //Vlan Forwarding Tx Mirror set.
+#define RTL_EVLANMACREFERENCEDBYPPPOE	-2010 //Vlan MAC is referenced by pppoe
+#define RTL_EVLANMACREFERENCEDBYNETIF	-2011 //VLan MAC is referenced by network interface.
+#define RTL_EINVVLANMAC					-2012 //Specified VLAN MAC number should be (0, 1, 2, 4, 8)
+#define RTL_ENOUSABLEMAC					-2013 //No usable MAC address can be allocated
+#define RTL_EVLANNOMAC					-2014 //Vlan has no MAC Address
+#define RTL_ENOVLAN						-2015 //No more availiable VLAN entry
+
+
+
+/* Error Number for NAT */
+#define RTL_ENATIPNOTEXTERNALIP			-2100 //The specified NAT IP address is not an External IP address.
+#define RTL_ENATIPNOTINTERNALIP			-2101 //The specified NAT Internal IP is not an Internal IP address.
+#define RTL_EDUPLOCATENATIP				-2102 //The specified NAT IP address already maps to an Internal IP address.
+#define RTL_ENATIPCANNOTBENAPTIP			-2103 //The specified NAT IP address cannot be a NAPT IP address.
+
+
+/* Error Number for Routing */
+#define RTL_ERTALREADYEXIST				-2300 //The routing entry already exists.
+#define RTL_ERTINVALNEXTHOP				-2301 //Invalid nextHop
+#define RTL_ENOSESSIONALLOCATE			-2302 //Need PPPoE session allocate
+/*#ifdef TEST_GETRTTBL*/
+#define RTL_ERTCREATEBYIF				-2303 //The route is added by IP interface creation. It can be removed.
+#define RTL_EGETRT_EMPTYRTTBL			-2304	/* The routing table is empty */
+#define RTL_EGETRT_NOMOREVALIDENTRY	-2305	/* No more valid routing entry */
+#define RTL_EGETRT_INVALIDRTENTRY		-2306	/* User specifies an invalid route */
+/*#endif */
+
+
+
+/* Error Number for Arp */
+#define RTL_ENONBROADCASTNET				-2400 //Non Boradcast network is forbidden to add ARP entry.
+#define RTL_EARPALREADYEXIST				-2401 //Arp entry already exists.
+#define RTL_EARPCANNOTADDL2ENTRY			-2402 //The L2 Entry cannot be added.
+#define RTL_EARPCANNOTDELL2ENTRY			-2403 //The L2 Entry cannot be deleted.
+#define RTL_ENOARPFOUND					-2404 //No ARP entry was found
+
+
+/* Error Number for Network interface */
+#define RTL_ENETIFREFERENCEDBYIPIF			-2500 //The network interface is referenced by IP interface.
+#define RTL_ENETIFREFBYROUTE				-2501 //The network interface is referenced by a routing entry.
+#define RTL_ELINKTYPESHOULDBERESET			-2502 //The link layer type should be reset before removing.
+#define RTL_ENETIFREFERENCEDBYACL			-2503 //The network interface is referenced by ACL.
+#define RTL_EUNKNOWLINKLAYERTYPE			-2504 //Unknow link layer type.
+#define RTL_ECANNOTREMOVEIPUNNUMBER		-2505 //Can not remove IP unnumbered network itnerface. Use rtl8651_delIpUnnumbered() first.
+#define RTL_ENETHASNOLLTYPESPECIFY			-2506 //The specified network interface has no link-layer type specified.
+#define RTL_ENETISEXTERNAL					-2507 //The removed network interface is an external interface.
+#define RTL_ENAPTSTART						-2508 //When NAPT starts, no manipulation about IP interface
+												  //should be done
+#define RTL_ENETIFALREADYEXTERNAL			-2509 //The specified network interface already is an external network interface.
+#define RTL_ESHOULDBEEXTIF					-2510 //The network interface should be an external network interface
+#define RTL_ESHOULDNOTDMZEXT				-2511 //The network interface should not be a DMZ external.
+#define RTL_ELIPUNNUMBEREDNOTALLOW		-2512 //The specified network itnerface cannot be IP Unnumbered network.
+#define RTL_ENETIFREFBYNATNAPT				-2513 //Network Interface is referenced BY NAT
+#define RTL_ENETIFLLTYPEALREADYSET			-2514 //Link layer of the specified network itnerface type already set.
+#define RTL_ENOLLTYPESPECIFY				-2515 //The network interface has no link layer type specified.
+
+
+/* Error Number for IP Unnumbered */
+#define RTL_EONLYONEIPUNNUMBERISALLOWED	-2600 //The whole system only allows one IP unnumbered network.
+#define RTL_ENETIFINVALID				-2601 //One external and one internal network interfaces are needed.
+#define RTL_EWANIFCANNOTHAVEIPINTF		-2602 //The external network interface cannot have IP interface.
+#define RTL_NETIFTYPENOTMATCH			-2603 //The external network interface should be PPPoE type and internal interface should be VLAN type.
+#define RTL_ENETIFNEEDIPUNNUMBERED		-2604 //The specified network itnerface should be IP unnumbered.
+#define RTL_EIPUNNUMBEREDHASHIPINTF		-2605 //The IP Unnumebred still has external IP interface unnumebred attached.
+#define RTL_ENETIFNOTIPUNNUMBERED		-2606 //The specified network interface is not an IP Unnumbered Network interface.
+#define RTL_ENOTIPUNNUMBEREDNETIF	  	-2607 //The specified network interface is not IP Unnumbered Network interface.
+#define RTL_EIPUNINTIPINTFNEED			-2608 //The specified network interface should be IP Unnumbered internal network interface.
+#define RTL_EIPUNISREFERENCEDBYPPPOE		-2609 //The IP Unnumbered IP interface is referenced by PPPoE Session.
+#define RTL_EEXTINTFSHOULDBEPPPOE		-2610 //The specified external network interface should be PPPoE type.
+#define RTL_ESHOULDBEEXTNETIF			-2611 //The specified network interface should be external network interface.
+
+
+/* Error Number for IP interface */
+#define RTL_ENETMASKCANNOTBEZERO			-2701 //The netmask of IP interface cannot be zero.
+#define RTL_EIPUNEXTIFCANNOTHASHIPINTF	-2702 //Cannot attach IP interface to External Network itnerface in an IP Unnumbered network.
+#define RTL_EIPIFALREADYEXIST			-2703 //IP Interface already exists
+#define RTL_EINVNETMASK					-2704 //Invalid network mask. The specified netmask may be 0xffffffff in a VLAN type network.
+#define RTL_ECANNOTREMOVEIPUNEXTIPINTF	-2705 //Global IP interface of IP Unnumbered cannot be removed. Use rtl8651_setLanSideExternalIpInterface() first.
+#define RTL_EIPINTFISREFERENCEDBYARP		-2706 //IP interface is referenced by ARP entry. It cannot be removed.
+#define RTL_EIPINTFISREFERENCEDBYLS		-2707 //IP interface is referenced by Local Server. It cannot be removed.
+#define RTL_EIPINTFISREFERENCEDBYRT		-2708 //IP interface is referenced by routing entry. It cannot be removed.
+#define RTL_EIPINTFISREFERENCEDNYNATNAPT	-2709 //IP interface is referenced by NAT/NAPT. It cannot be removed.
+#define RTL_ENOIPINTFFOUND				-2710 //The specified IP interface was not found.
+#define RTL_ENOTEXTIP					-2711 //Specified external IP address doesn't belong to external interface
+#define RTL_ENOTINTIP					-2712 //Specified internal IP address doesn't belong to internal interface
+
+/* Error Number for PPPoE */
+#define RTL_EFORBIDPROMISCINPPPOE		-2800 //If promiscuous mode was set, PPPoE cannot be created.
+#define RTL_EVLANSHOULDBEPPPOE			-2801 //The specified VLAN should be PPPoE Type.
+#define RTL_EPPPOEALREADYEXISTS			-2802 //The specified PPPoE already exists.
+#define RTL_EOUTOFVLANMACADDR			-2803 //Out of VLAN MAC address.
+#define RTL_EINVALIDPPPOEID				-2804 //Invalid PPPoE ID.
+#define RTL_EPPPOEISINUSE				-2805 //The specified PPPoE is in use.
+#define RTL_EPPPOEISREFERENCEDBYRT		-2806 //PPPoE is referenced by routing entry.
+#define RTL_EINVALIDSESSIONID			-2807 //Invalid PPPoE Session ID.
+#define RTL_EPROPERTUALREADYSET			-2808 //The specified PPPoE property was already set to another PPPoE ID.
+#define RTL_EPPPOEHASPROPERTYSET			-2809 //The specified PPPoE ID already has property set.
+#define RTL_EPPPOECANNOTADDL2ENTRY		-2810 //Cannot add L2 entry for the specified PPPoE.
+
+/* Error Number for Local Server */
+#define RTL_EINVALIDLSIPADDR				-2900 //Invalid Local Server IP address.
+#define RTL_ELSCANNOTBEGWIP				-2901 //Local Server IP address cannot be gateway's IP address.
+#define RTL_ELSALREADYEXISTS				-2902 //Local Server already exists.
+
+/* Error Number for NAPT */
+#define RTL_EDSTIPISLS					-3000 //NAPT DST IP is Local Server
+#define RTL_EGETOFFSETFAIL				-3001 //NAPT get offset fail
+#define RTL_EINVALIDEXTPORT				-3002 //Maybe the external port is in use or reserved
+#define RTL_ENOTPERMIT					-3003 //The action is not allowed
+#define RTL_EEXTIDINUSE					-3004 //NAPT ICMP external ID is in use
+#define RTL_EDRVNAPTEXIST				-3005 //NAPT connection already exist in driver table
+#define RTL_EINVL4PORTNUM				-3006 //Invalid UDP/TCP port number
+#define RTL_EINVEXTIP					-3007 //Invliad external port number for NAPT
+#define RTL_EDEFAULTROUTENOTFOUND		-3008 // Default Route is not defined.
+#define RTL_EADDHASH2NEXTHOP				-3009 // Add Hash2 nexthop error
+#define RTL_EDEFAULTNAPTIPEXIST			-3010 //Default Napt IP already exists
+#define RTL_ENAPTCONNECTIONFULL		-3011	// napt system is full and can not add any other new flows
+#define RTL_ENAPTNOTFOUNDWITHINFO		-3012 // Entry is not found, but return with infomation (for GetInbound()/Outbound())
+
+/*Error Number for NAPTUSRMAPPING*/
+#define RTL_EIPFILTEROVERLAPPING		-3050	//ipfilter overlap: the ip range and port is overloapping
+#define RTL_ENAPTUSRMAPTYPEERROR		-3051	//napt user map entry's type is error
+#define RTL_ENAPTUSRMAPFLAGERROR		-3052	//napt user map entry's flag is error
+#define RTL_ENAPTUSRMAPFILTERNOTFOUND	-3053	// napt user map ipFilter not found
+#define RTL_ENAPTUSRMAPDIRECTIONERROR	-3054	// napt usr map info's direction is error
+#define RTL_ENAPTUSRMAPFILTERDROP		-3055	//pkt was drop by usr filter
+
+/* Error Numebr for ALG */
+#define RTL_ERANGEOVERLAP				-3100	//ALG port range overlap
+
+/* Error Number Session: PPPoE, L2TP, PPTP */
+#define RTL_ESESSIONNOTFOUND			-3200	//The specified Session ID is not found
+#define RTL_ESESSIONREFERENCEDBYRT		-3201	//The specified Session is referenced by routing entry
+#define RTL_ECANNOTMOVESESSION		-3202	//Can not move session to another network interface
+#define RTL_EALREADYHAVESESSION		-3203	//The specified network interface already has session attached
+#define RTL_ESESSIONISREFERENCED		-3204	//Session is referenced
+#define RTL_ECANNOTUSETHISVID			-3205	//No more than one PPTP/L2TP VLAN is allowed
+
+/* Error Number for Protocol-based NAT */
+#define RTL_EPBNAT_ENTRY_EXIST			-3301 //The given {protocol,extip,intip} exists
+#define RTL_EPBNAT_NO_FREE_ENTRY			-3302 //No free entry for Protocol-Based NAT
+#define RTL_EPBNAT_ENTRY_NOT_FOUND		-3303 //The specific entry is not found
+#define RTL_EPBNAT_PROTOCOL_NOT_SUPPORTED	-3304 //The specific protocol is not supported by protocol-based NAT
+
+
+/* Error Number for Rate Limit */
+#define RTL_EDUPGROUPID				-3401	//Duplicate Rate Limit Group ID
+#define RTL_ERLENTRYISREFERENCE		-3402	//The specified rate limit entry is being referenced.
+#define RTL_ENOGROUPIDFOUND			-3403	//The specified group ID was not found.
+#define RTL_EEXCEEDTOTALBW			-3404	//The specified ratio exceeds total allowed bandwidth
+
+/* Error Number for IPSec */
+#define RTL_EIPSEC_PARAM_ERROR		-4001	//IPSec parameter error
+#define RTL_EIPSEC_SPI_EXISTED		-4002	//IPSec SPI has existed
+#define RTL_EIPSEC_SPI_NOT_FOUNT		-4003	//IPSec SPI not found
+#define RTL_EIPSEC_NO_MORE_SPI		-4004	//no more availiable IPSec SPI
+#define RTL_EIPSEC_SPIGRP_EXISTED	-4007	//IPSec SPIGRP has existed
+#define RTL_EIPSEC_SPIGRP_NOT_FOUNT	-4008	//IPSec SPIGRP not found
+#define RTL_EIPSEC_NO_MORE_SPIGRP	-4009	//no more availiable IPSec SPIGRP
+#define RTL_EIPSEC_EROUTE_EXISTED	-4012	//IPSec SPIGRP has existed
+#define RTL_EIPSEC_EROUTE_NOT_FOUNT	-4013	//IPSec SPIGRP not found
+#define RTL_EIPSEC_NO_MORE_EROUTE	-4014	//no more availiable IPSec SPIGRP
+#define RTL_EIPSEC_INVALID_WINSIZE	-4015	//Invalid window size (See RFC2046 3.4.3)
+#define RTL_EIPSEC_NO_MORE_NBT_ENTRY -4016 //no more netBios entry
+
+/* Error Number for URL Filter */
+#define RTL_EURLFILTER_URLSTRINGLEN_EXCEEND	-4501	// url filter string lenght exceeds system buffer size.
+#define RTL_EURLFILTER_PATHSTRINGLEN_EXCEEND	-4502	// path string of url exceeds system buffer size
+#define RTL_EMEMALLOCATEFAILEDFORURLFILTER	-4503	/* memory allocation failed for url filter operation */
+/* RTL865XB_URLFILTER_UNKNOWNURLTYPE_SUPPORT */
+#define RTL_EURLFILTER_INVALIDRULETYPE			-4504	/* Invalid url rule type */
+/* RTL865XB_URLFILTER_ACTIONTYPE_SUPPORT */
+#define RTL_EURLFILTER_INVALIDACTIONTYPE		-4505	/* Invalid action type of url filter rule */
+/* RTL865XB_WEB_CONTENT_HDR_FILTER */
+#define RTL_EURLFILTER_CONTENTSTRINGLEN_EXCEEND 	-4506	/* content string pattern exceeds system buffer size */
+#define RTL_EURLFILTER_HTTPHDRSTRINGLEN_EXCEEND 	-4507	/* http header string pattern exceeds system buffer size */
+#define RTL_EURLFILTER_CONTENTHDRFILTERINUSED		-4508	/* the content/httpHdr filter is used by an napt flow, cannot be deleted */
+
+/* Error Number for PCM drivers */
+#define RTL_EPCM_QUEUE_UNAV    -5001		/* pcm queue not allocated */
+#define RTL_EPCM_PGAE_UNAV     -5002		/* pcm page not allocated */
+#define RTL_EPCM_QUEUE_FULL    -5003		/* pcm queue is full of data */
+#define RTL_EPCM_QUEUE_EMPTY   -5004		/* pcm queue is no   of data */
+#define RTL_EPCM_QUEUE_SUBSIZE -5005		/* pcm queue has not enough data */
+#define RTL_EPCM_BUF_UNAV      -5006		/* requested buffer not allocated */
+#define RTL_EPCM_CHANNEL_NULL  -5007     /* current channel is not allocated */
+
+/*Error number for naptUsrMapping*/
+#define RTL_EVLANRANGETOOSMALL       -5100   /* set multiple pppoe id range too small RTL8651_IDLETIMEOUT_FIXED */
+//#define RTL_NAPTUSRMAP_
+
+/*Error number for reference count*/
+#define RTL_EREFERENCEDBYOTHER	-5200
+
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/rtl_utils.c b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl_utils.c
new file mode 100644
index 00000000..93b9661
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl_utils.c
@@ -0,0 +1,729 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* Program : RTL utilities
+* Abstract :
+* Author :
+* $Id: rtl_utils.c,v 1.1 2007-12-21 10:29:52 davidhsu Exp $
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "rtl_utils.h"
+#if defined(CONFIG_RTL_819X)
+#include "AsicDriver/asicRegs.h"
+#endif
+
+#ifdef __linux__
+#include <linux/ctype.h>
+#include <linux/string.h>
+#else
+#include <ctype.h>
+#include <string.h>
+#endif
+
+#if defined(RTL865X_MODEL_USER) || defined (RTL8316S_MODEL_USER)
+#include <net/rtl/rtl_glue.h>
+#endif
+
+//#include "assert.h"
+
+//const int8 *ntop4(const uint8 *src,int8 *dst, uint32 size);
+
+#define __rtl_isupper(c)	(((c) >= 'A') && ((c) <= 'Z'))
+
+#if 0
+void *rtl_malloc(size_t NBYTES) {
+	if(NBYTES==0) return NULL;
+	return (void *)kmalloc(NBYTES,GFP_ATOMIC);
+}
+
+void rtl_free(void *APTR) {
+	kfree(APTR);
+}
+#endif
+
+/*
+	copy string from 'src' to 'dst' and set all alphabets to lower-case in 'dst'.
+*/
+void __strlowerncpy(char *dst, const char *src, int32 len)
+{
+	int32 cpLen = 0;
+	char p;
+
+	while ((cpLen < len) && (src[cpLen] != 0))
+	{
+		p = src[cpLen];
+		dst[cpLen] = __rtl_isupper(p)?(p-'A'+'a'):p;
+		cpLen ++;
+	}
+}
+
+int8 * _strncpy(int8 *dst0, const int8 *src0, int32 count) {
+	int8 *dscan;
+	const int8 *sscan;
+
+	dscan = dst0;
+	sscan = src0;
+	while (count > 0)
+	{
+		--count;
+		if ((*dscan++ = *sscan++) == '\0')
+			break;
+	}
+	while (count-- > 0)
+		*dscan++ = '\0';
+
+	return dst0;
+}
+
+int _strncasecmp(const char *s1, const char *s2, unsigned int n)
+{
+	if (n == 0)
+		 return 0;
+
+	while ((n-- != 0)
+			&& (tolower(*(unsigned char *) s1) ==
+				tolower(*(unsigned char *) s2))) {
+		if (n == 0 || *s1 == '\0' || *s2 == '\0')
+			return 0;
+		s1++;
+		s2++;
+	}
+
+	return tolower(*(unsigned char *) s1) - tolower(*(unsigned char *) s2);
+}
+int32 _strncmp(const int8 *s1, const int8 *s2, int32 n) {
+
+	if (n == 0)
+		return 0;
+
+	while (n-- != 0 && *s1 == *s2)
+	{
+		if (n == 0 || *s1 == '\0')
+			break;
+		s1++;
+		s2++;
+	}
+	return (*(uint8 *)s1) - (*(uint8 *)s2);
+}
+
+void rtl8651_memcpy(void *dst,void*src,int32 len)
+{
+	memcpy(dst, src, (size_t)len);
+#if 0
+	if(len>16){
+		memCopy( dst,src, len);
+	}else
+#endif
+#if 0
+	{
+		int i=0;
+		char *dstp=(char*)dst;
+		char *srcp=(char*)src;
+		for (i=0;i<len;i++)
+		{
+			*dstp++=*srcp++;
+
+		}
+	}
+#endif
+}
+#if 1
+//#ifndef RTK_X86_CLE//RTK-CNSD2-NickWu-20061222: for x86 compile
+/*cfliu: This function is only for debugging. Should not be used in production code...*/
+void memDump (void *start, uint32 size, int8 * strHeader)
+{
+	int32 row, column, index, index2, max;
+	uint32 buffer[5];
+	uint8 *buf, *line, ascii[17];
+	int8 empty = ' ';
+
+	if(!start ||(size==0))
+		return;
+	line = (uint8*)start;
+
+	/*
+	16 bytes per line
+	*/
+	if (strHeader)
+		rtlglue_printf ("%s", strHeader);
+	column = size % 16;
+	row = (size / 16) + 1;
+	for (index = 0; index < row; index++, line += 16)
+	{
+#ifdef RTL865X_TEST
+		buf = (uint8*)line;
+#else
+		/* for un-alignment access */
+		#if defined(CONFIG_RTD_1295_HWNAT)
+		buffer[0] = ntohl( READ_MEM32( (((uintptr_t)line)&~3)+ 0 ) );
+		buffer[1] = ntohl( READ_MEM32( (((uintptr_t)line)&~3)+ 4 ) );
+		buffer[2] = ntohl( READ_MEM32( (((uintptr_t)line)&~3)+ 8 ) );
+		buffer[3] = ntohl( READ_MEM32( (((uintptr_t)line)&~3)+12 ) );
+		buffer[4] = ntohl( READ_MEM32( (((uintptr_t)line)&~3)+16 ) );
+		buf = ((uint8*)buffer) + (((uintptr_t)line)&3);
+		#else //defined(CONFIG_RTD_1295_HWNAT)
+		buffer[0] = ntohl( READ_MEM32( (((uint32)line)&~3)+ 0 ) );
+		buffer[1] = ntohl( READ_MEM32( (((uint32)line)&~3)+ 4 ) );
+		buffer[2] = ntohl( READ_MEM32( (((uint32)line)&~3)+ 8 ) );
+		buffer[3] = ntohl( READ_MEM32( (((uint32)line)&~3)+12 ) );
+		buffer[4] = ntohl( READ_MEM32( (((uint32)line)&~3)+16 ) );
+		buf = ((uint8*)buffer) + (((uint32)line)&3);
+		#endif //defined(CONFIG_RTD_1295_HWNAT)
+#endif
+
+		memset (ascii, 0, 17);
+
+		max = (index == row - 1) ? column : 16;
+		if ( max==0 ) break; /* If we need not dump this line, break it. */
+
+		#if defined(CONFIG_RTD_1295_HWNAT)
+		rtlglue_printf ("\n%016lx: ", (memaddr) line);
+		#else //defined(CONFIG_RTD_1295_HWNAT)
+		rtlglue_printf ("\n%08x: ", (memaddr) line);
+		#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+		//Hex
+		for (index2 = 0; index2 < max; index2++)
+		{
+			if (index2 == 8)
+			rtlglue_printf ("  ");
+			rtlglue_printf ("%02X", (uint8) buf[index2]);
+			ascii[index2] = ((uint8) buf[index2] < 32) ? empty : buf[index2];
+			if((index2+1)%4==0)
+				rtlglue_printf ("  ");
+		}
+
+		if (max != 16)
+		{
+			if (max < 8)
+				rtlglue_printf ("  ");
+			for (index2 = 16 - max; index2 > 0; index2--)
+				rtlglue_printf ("   ");
+		}
+
+		//ASCII
+#ifndef CONFIG_RTL_8197F
+		rtlglue_printf ("  %s", ascii);
+#endif
+	}
+	rtlglue_printf ("\n");
+	return;
+}
+#endif
+
+
+/*
+ * Compare two memory and hilight the differences.
+ */
+int32 memComp( void* _p1, void *_p2, int32 len, uint8* strHeader )
+{
+	uint8* p1;
+	uint8* p2;
+	int i, j;
+	uint8 ascii[17];
+
+	if ( memcmp( _p1, _p2, (size_t)len )==0 )
+		return 0; /* identical */
+
+	if ( strHeader ) rtlglue_printf( "%s", strHeader );
+	p1 = (uint8*)_p1;
+	p2 = (uint8*)_p2;
+	/* Show p1 */
+	for( i = 0; i<len; i+=16 )
+	{
+		#if defined(CONFIG_RTD_1295_HWNAT)
+		rtlglue_printf( "\n%016lx ", (uintptr_t)(&p1[i]) );
+		#else //defined(CONFIG_RTD_1295_HWNAT)
+		rtlglue_printf( "\n%08x ", (uint32)(&p1[i]) );
+		#endif //defined(CONFIG_RTD_1295_HWNAT)
+		memset( ascii, 0, sizeof(ascii) );
+		for( j = 0; j < 16; j++ )
+		{
+			if ( (i+j)>=len )
+			{
+				ascii[j] = ' ';
+				rtlglue_printf( "   " );
+			}
+			else
+			{
+				if ( (p1[i+j]>=0x20) && (p1[i+j]<=0x7e) ) /* Show visible char only */
+					ascii[j] = p1[i+j];
+				else
+					ascii[j] = '.';
+
+				if ( p1[i+j]==p2[i+j] )
+				{
+					rtlglue_printf( "%02x ", (uint8) p1[i+j] );
+				}
+				else
+				{
+					rtlglue_printf( "\033[41;33m%02x\033[m ", (uint8) p1[i+j] );
+				}
+			}
+		}
+
+		rtlglue_printf( "  %s", ascii );
+	}
+	rtlglue_printf( "\n--------" );
+	/* Show p2 */
+	for( i = 0; i<len; i+=16 )
+	{
+		#if defined(CONFIG_RTD_1295_HWNAT)
+		rtlglue_printf( "\n%016lx ", (uintptr_t)(&p2[i]) );
+		#else //defined(CONFIG_RTD_1295_HWNAT)
+		rtlglue_printf( "\n%08x ", (uint32)(&p2[i]) );
+		#endif //defined(CONFIG_RTD_1295_HWNAT)
+		memset( ascii, 0, sizeof(ascii) );
+		for( j = 0; j < 16; j++ )
+		{
+			if ( (i+j)>=len )
+			{
+				ascii[j] = ' ';
+				rtlglue_printf( "   " );
+			}
+			else
+			{
+				if ( (p2[i+j]>=0x20) && (p2[i+j]<=0x7e) ) /* Show visible char only */
+					ascii[j] = p2[i+j];
+				else
+					ascii[j] = '.';
+
+				if ( p1[i+j]==p2[i+j] )
+				{
+					rtlglue_printf( "%02x ", (uint8) p2[i+j] );
+				}
+				else
+				{
+					rtlglue_printf( "\033[41;33m%02x\033[m ", (uint8) p2[i+j] );
+				}
+			}
+		}
+
+		rtlglue_printf( "  %s", ascii );
+	}
+
+	rtlglue_printf( "\n" );
+	return 1;
+}
+
+
+void IntToAscii(int32 n, int8 s[]){
+		int8 c[32];
+		int32 i, sign, j;
+		if((sign=n)<0)
+				n=-n;
+		i=0;
+		do{
+				s[i++]=n%10+'0';
+		}while((n/=10)>0);
+		if(sign<0)
+				s[i++]='-';
+		s[i]='\0';
+		//assert(i<31);
+		for(j=0,i--;i>=0;j++,i--)
+				c[j]=s[i];
+		c[j]='\0';
+		memcpy(s, c, (size_t)(j+1));
+}
+
+uint8 charToInt(char c)
+{
+	if ((c >= '0') && ( c <= '9'))
+	{
+		return (c - '0');
+	} else if ((c >= 'a') && ( c <= 'f'))
+	{
+		return (c - 'a');
+	} else if ((c >= 'A') && ( c <= 'F'))
+	{
+		return (c - 'A');
+	}
+	return 0;
+}
+
+static int8 *_ui8tod( uint8 n, int8 *p )
+{
+	if( n > 99 ) *p++ = (n/100) + '0';
+	if( n >  9 ) *p++ = ((n/10)%10) + '0';
+	*p++ = (n%10) + '0';
+	return p;
+}
+
+//inet_ntoa which doens't need reentrant module
+int8 *inet_ntoa_r(ipaddr_t ipaddr, 	int8 *p)
+{
+	uint8 *ucp = (unsigned char *)&ipaddr;
+	assert(p!=NULL);
+	p = _ui8tod( ucp[0] & 0xFF, p);
+	*p++ = '.';
+	p = _ui8tod( ucp[1] & 0xFF, p);
+	*p++ = '.';
+	p = _ui8tod( ucp[2] & 0xFF, p);
+	*p++ = '.';
+	p = _ui8tod( ucp[3] & 0xFF, p);
+	*p++ = '\0';
+	return (p);
+}
+
+#ifndef RTL865X_TEST
+int32 IpStrToAscii(const int8 *cp, uint32 *addr){
+	uint32 val;
+	int32 base, n;
+	int8 c;
+	uint32 parts[4];
+	uint32 *pp = parts;
+
+	c = *cp;
+	for (;;) {
+		/*
+		 * Collect number up to ``.''.
+		 * Values are specified as for C:
+		 * 0x=hex, 0=octal, isdigit=decimal.
+		 */
+		if (!isdigit(c))
+			return (0);
+		val = 0; base = 10;
+
+		//determine the base
+		if (c == '0') {
+			c = *++cp;
+			if (c == 'x' || c == 'X')
+				base = 16, c = *++cp;
+			else
+				base = 8;
+		}
+
+		for (;;) {
+			if (isascii(c) && isdigit(c)) {
+				val = (val * base) + (c - '0');
+				c = *++cp;
+			} else if (base == 16 && isascii(c) && isxdigit(c)) {
+				val = (val << 4) |
+					(c + 10 - (islower(c) ? 'a' : 'A'));
+				c = *++cp;
+			} else
+				break;
+		}
+
+		if (c == '.') {
+			/*
+			 * Internet format:
+			 *	a.b.c.d
+			 *	a.b.c	(with c treated as 16 bits)
+			 *	a.b	(with b treated as 24 bits)
+			 */
+			if (pp >= parts + 3)
+				return (0);
+			*pp++ = val;
+			c = *++cp;
+		} else
+			break;
+	}
+	/*
+	 * Check for trailing characters.
+	 */
+	if (c != '\0' && (!isascii(c) || !isspace(c)))
+		return (0);
+	/*
+	 * Concoct the address according to
+	 * the number of parts specified.
+	 */
+	n = pp - parts + 1;
+	switch (n) {
+
+	case 0:
+		return (0);		/* initial nondigit */
+
+	case 1:				/* a -- 32 bits */
+		break;
+
+	case 2:				/* a.b -- 8.24 bits */
+		if ((val > 0xffffff) || (parts[0] > 0xff))
+			return (0);
+		val |= parts[0] << 24;
+		break;
+
+	case 3:				/* a.b.c -- 8.8.16 bits */
+		if ((val > 0xffff) || (parts[0] > 0xff) || (parts[1] > 0xff))
+			return (0);
+		val |= (parts[0] << 24) | (parts[1] << 16);
+		break;
+
+	case 4:				/* a.b.c.d -- 8.8.8.8 bits */
+		if ((val > 0xff) || (parts[0] > 0xff) || (parts[1] > 0xff) || (parts[2] > 0xff))
+			return (0);
+		val |= (parts[0] << 24) | (parts[1] << 16) | (parts[2] << 8);
+		break;
+	}
+	if (addr)
+		*addr = htonl(val);
+	return (1);
+}
+#endif /* RTL865X_TEST */
+
+
+
+
+/*
+ * Convert an ASCII string to a
+ * binary representation of mac address
+*/
+static int32 strToMac(uint8 *pMac, int8 *pStr)
+{
+	int8 *ptr;
+	uint32 k;
+
+	assert (pMac != NULL);
+	assert (pStr != NULL);
+
+	bzero(pMac, sizeof(ether_addr_t));
+	ptr = pStr;
+
+	for ( k = 0 ; *ptr ; ptr ++ )
+	{
+		if (*ptr == ' ')
+		{
+		} else if ( (*ptr == ':') || (*ptr == '-') )
+		{
+			k ++;
+		} else if ( ('0' <= *ptr) && (*ptr <= '9') )
+		{
+			pMac[k] = (pMac[k]<<4) + (*ptr-'0');
+		} else if ( ('a' <= *ptr) && (*ptr <= 'f') )
+		{
+			pMac[k] = (pMac[k]<<4) + (*ptr-'a'+10);
+		} else if( ('A' <= *ptr) && (*ptr <= 'F') )
+		{
+			pMac[k] = (pMac[k]<<4) + (*ptr-'A'+10);
+		} else
+		{
+			break;
+		}
+	}
+
+	if (k != 5)
+	{
+		return -1;
+	}
+
+	return 0;
+}
+
+
+int32 ether_aton_r(int8 *a, ether_addr_t *eth){
+	if ( strToMac(eth->octet, a) )
+		return FAILED;
+	return SUCCESS;
+}
+
+int32 ether_ntoa_r(ether_addr_t *n, uint8 *a){
+	int32 i;
+	i = sprintf((int8*)a, "%02x:%02x:%02x:%02x:%02x:%02x", n->octet[0], n->octet[1], n->octet[2], n->octet[3], n->octet[4],  n->octet[5]);
+	if (i < 11)
+		return FAILED;
+	return SUCCESS;
+}
+
+#if 0
+#define SPRINTF(x) ((uint32)sprintf x)
+
+const int8 *ntop4(const uint8 *src,int8* dst, uint32 size)
+{
+	static const int8 fmt[] = "%u.%u.%u.%u";
+	int8      tmp[sizeof "255.255.255.255"];
+
+	if (SPRINTF((tmp, fmt, src[0], src[1], src[2], src[3])) > size)
+	{
+		return (NULL);
+	}
+	strcpy(dst,tmp);
+	return (dst);
+}
+
+#undef SPRINTF
+#endif
+
+#ifndef RTL865X_TEST
+ int AsciiToInt( char **s)
+{
+	int i = 0;
+	while (isdigit(**s))
+	  i = i*20 + *((*s)++) - '0';
+	return i;
+}
+#endif /* RTL865X_TEST */
+
+
+//Check whether 'number' is power of 2.
+//if 'exponent' is non-NULL, the exponent of number is also returned. Ex: if number = 16, exponent would be 4
+int32 isPowerOf2(uint32 number, uint32 *exponent){
+	uint32 size, bits;
+	if(exponent){
+		//user is not interested in the exponent
+		for(bits=0, size=1; bits < (sizeof(uint32)<<3);bits++){
+			if(number==size)
+				break;
+			else
+				size = size << 1;
+		}
+		if(bits == sizeof(uint32)*8 )
+			return FALSE;
+		*exponent = bits;
+		return TRUE;
+	}else if(((number-1)&number)==0)
+		return TRUE;
+	 return FALSE;
+}
+
+//cfliu: Reserve these functions...need to see if they help.
+//Ask me first if you want to delete them.
+#if 0
+/* Set memory address from "pFrom" to "pFrom+iWords*4" with "iFill", Address value of "pFrom" should be 4 bytes aligned */
+void     *memSet(void *pTo, uint8 cFill, uint32 iBytes)
+{
+	uint32    iIndex = 0, iRemain, iWords;
+	uint8    *pcTo;
+	uint32    iFill = (uint32) cFill;
+
+	assert(pTo);
+	assert(iBytes > 0);
+
+	pcTo = (uint8 *) pTo;
+	iRemain = sizeof(memaddr) - (((memaddr) pTo) & (sizeof(memaddr) - 1));	//modular 4
+
+
+	for (; (iRemain > 0) && (iBytes > 0); iBytes--, pcTo++, iRemain--)
+		*pcTo = (uint8) cFill;
+
+	if (iBytes == 0)
+		return (void *) (pcTo - 1);	   //return the address of last byte we have copied.
+	else if (iBytes < sizeof(memaddr))
+		goto memset_last;
+
+	iWords = (iBytes & ~(sizeof(memaddr) - 1)) / sizeof(memaddr);	//calculate number of int32 words to copy
+
+	for (iIndex = 0; iIndex < sizeof(memaddr) - 1; iIndex++)	//prepare THE int32 word for copying
+		iFill = (iFill << (sizeof(uint8) * 8)) + (uint32) cFill;
+
+	//Do actual memory filling.
+	//Assumption: An integer is 32 bits int32
+	for (iIndex = 0; iIndex < iWords;
+		 iIndex++, iBytes -= sizeof(memaddr), pcTo += sizeof(memaddr))
+		*((memaddr *) pcTo) = (memaddr) cFill;
+
+	//if there are rested bytes to copy..
+  memset_last:
+	assert(iBytes < sizeof(memaddr));
+	while (iBytes > 0)
+	{
+		*pcTo = cFill;
+		iBytes--;
+		pcTo++;
+	}
+	return (void *) (((memaddr *) pTo) + (iIndex - 1));
+}
+
+
+/* Optimized memcpy function.
+  * Copy memory address from "pFrom" to "pTo", for "iBytes",
+  */
+void     *memCopy( void *pTo,void * pFrom,uint32 iBytes)
+{
+	uint32    iIndex = 0, iRemain = 0, iLengthCheck = 0, iWords = 0;
+	int8     *pcFrom, *pcTo;
+
+	assert(pFrom);
+	assert(pTo);
+	assert(iBytes > 0);
+
+	/*
+	   Check if memory is overlapped
+	 */
+	if ((memaddr) pFrom > (memaddr) pTo)
+		iLengthCheck = (memaddr) (pFrom - pTo);
+	else
+		iLengthCheck = (memaddr) (pTo - pFrom);
+
+	if (iLengthCheck < iBytes)
+		return NULL;				   //memory overlapped. Copy is NOT performed.
+
+
+	pcFrom = (int8 *) pFrom;
+	pcTo = (int8 *) pTo;
+
+	//modular 4, if remainders are not the same, copy bye by byte.
+	if ((((memaddr) pcFrom) & (sizeof(memaddr) - 1)) !=
+		(((memaddr) pcTo) & (sizeof(memaddr) - 1)))
+	{
+
+		for (iIndex = iBytes; iIndex > 0; iIndex--, pcTo++, pcFrom++)
+			*pcTo = *pcFrom;
+		goto memcpy_done;
+	}
+
+	//faster memory copy
+	iRemain = sizeof(memaddr) - ((memaddr) pFrom & (sizeof(memaddr) - 1));	//modular 4
+	for (; (iRemain > 0) && (iBytes > 0);
+		 iBytes--, pcTo++, pcFrom++, iRemain--)
+		*pcTo = *pcFrom;
+
+	if (iBytes == 0)
+		goto memcpy_done;			   //return the address of last byte we have copied.
+	else if (iBytes < sizeof(memaddr))
+		goto memcpy_last;
+
+	//Addresses now are 4 bytes aligned, do fast mem copy. Assumption: Pointers are 32 bits
+	assert(((memaddr) pcFrom & 0xFFFFFFFC) == (memaddr) pcFrom);
+	assert(((memaddr) pcTo & 0xFFFFFFFC) == (memaddr) pcTo);
+
+	//Maybe we should use >>2 here, but just let compiler do it.
+	iWords = (iBytes & ~(sizeof(memaddr) - 1)) / sizeof(memaddr);	//calculate number of int32 words to copy
+
+
+	//Do actual memory copy.
+	//Assumption: An integer is 32 bits int32
+	for (iIndex = 0; iIndex < iWords;
+		 iIndex++, iBytes -= sizeof(memaddr), pcTo +=
+		 sizeof(memaddr), pcFrom += sizeof(memaddr))
+		*((memaddr *) pcTo) = *((memaddr *) pcFrom);
+
+	//if there are rested bytes to copy..
+  memcpy_last:
+	assert(iBytes < sizeof(memaddr));
+	while (iBytes > 0)
+	{
+		*pcTo = *pcFrom;
+		iBytes--;
+		pcTo++;
+		pcFrom++;
+	}
+  memcpy_done:
+	return (void *) (pcTo - 1);		   //return the address of last byte we copied
+}
+#endif
+
+ipaddr_t convPrefix(int prefixLen)
+{
+	int i;
+	ipaddr_t mask = 0;
+
+	for (i = 32 - prefixLen; i < 32; i++)
+		mask |= (1 << i);
+
+	return mask;
+}
+
+uint8* strtomac(ether_addr_t *mac, int8 *str)
+{
+	strToMac((uint8*)mac, str);
+	return (uint8*)mac;
+}
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/rtl_utils.h b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl_utils.h
new file mode 100644
index 00000000..5470bf0
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/rtl_utils.h
@@ -0,0 +1,110 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* Program : Header File for RTL utilities
+* Abstract :
+* Author :
+* $Id: rtl_utils.h,v 1.1 2007-12-21 10:29:52 davidhsu Exp $
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL8651_UTILITY_H
+#define RTL8651_UTILITY_H
+
+void __strlowerncpy(char *dst, const char *src, int32 len);
+int8 *_strncpy(int8 *dst0, const int8 *src0, int32 count);
+int _strncasecmp(const char *s1, const char *s2, unsigned int n);
+int32 _strncmp(const int8 *s1, const int8 *s2, int32 n);
+void rtl8651_memcpy(void *dst,void*src,int32 len);
+int32 isPowerOf2(uint32 number, uint32 *exponent);
+int32 IpStrToAscii(const int8 *cp, uint32 *addr);
+void IntToAscii(int32 n, int8 s[]);
+int AsciiToInt( char **s);
+uint8 charToInt(char c);
+int32 ether_aton_r(int8 *a, ether_addr_t *eth);
+int32 ether_ntoa_r(ether_addr_t *n, uint8 *a);
+int8 *inet_ntoa_r(ipaddr_t ipaddr, 	int8 *p);
+int32 memComp( void* _p1, void *_p2, int32 len, uint8* strHeader );
+uint8* strtomac(ether_addr_t *mac, int8 *str);
+void memDump (void *start, uint32 size, int8 * strHeader);
+
+#if 0
+void *rtl_malloc(uint32);
+void rtl_free(void *APTR);
+#endif
+
+#ifdef CONFIG_RTL865X_ROMEREAL
+	/*Turn on In-memory "ethereal" like pkt sniffing code.*/
+	#define START_SNIFFING rtl8651_romerealRecord
+#else
+	#define START_SNIFFING(x,y) do{}while(0)
+#endif
+
+#ifdef CONFIG_RTL865X_ROMEPERF
+	/*Turn on CPU profiling code.*/
+	#include "../romeperf.h"
+	#define PROFILING_START rtl8651_romeperfEnterPoint
+	#define PROFILING_END	rtl8651_romeperfExitPoint
+#else
+	#define PROFILING_START(x)  do{}while(0)
+	#define PROFILING_END(x) do{}while(0)
+#endif
+
+/*===================================================================
+ *  ONE's COMPLEMENT OPERATION
+ *  All the operands and return value are 'host-order'.
+ *  Please notice the endian problem.
+ *===================================================================*/
+/* One's Complement ADD */
+inline static uint16 OCADD( uint16 a, uint16 b )
+{
+	uint32 t; /* temp */
+	t = ((a)&0xffff)+((b)&0xffff);
+	t = (t&0xffff)+(t>>16);
+	return (uint16)t;
+}
+
+/* One's Complement NEGtive */
+inline static uint16 OCNEG( uint16 a )
+{
+	return (~a)&0xffff;
+}
+
+/* One's Complement SUBtract */
+inline static uint16 OCSUB( uint16 a, uint16 b )
+{
+	return OCADD( a, OCNEG(b) );
+}
+
+ipaddr_t convPrefix(int prefixLen);
+
+#if 0
+#define TBL_MEM_ALLOC(tbl, type, size)	 \
+	{ \
+	(tbl) = (type *)rtl_malloc((size) * sizeof(type)); \
+		if(!(tbl)){\
+			rtlglue_printf("MEM alloc failed at line %d\n", __LINE__);\
+			while(1);\
+			return FAILED;\
+		}\
+	}
+
+#if defined(RTL865X_MODEL_USER)
+	/* User mode, compiler use STDINC, said that, bezro is defined. */
+#else
+	/* Not user mode, we need define. */
+	#ifndef bzero
+		#define bzero( p, s ) memset( p, 0, s )
+	#endif
+#endif
+#endif
+
+#endif /* RTL8651_UTILITY_H */
+
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/smi.c b/drivers/soc/realtek/rtd129x/hw_nat/common/smi.c
new file mode 100644
index 00000000..247b82d
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/smi.c
@@ -0,0 +1,617 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2006
+* All rights reserved.
+*
+* Program : Control  smi connected RTL8366
+* Abstract :
+* Author : Yu-Mei Pan (ympan@realtek.com.cn)
+*  $Id: smi.c,v 1.2 2008-04-10 03:04:19 shiehyy Exp $
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+//#include <rtk_types.h>
+#include "smi.h"
+//#include "rtk_error.h"
+
+// used in gpio.h
+typedef unsigned int uint32;
+typedef int int32;
+
+#include <linux/version.h>
+
+#include "gpio.h"
+
+#define RT_ERR_FAILED		(-1)
+#define RT_ERR_OK			0
+
+#define MDC_MDIO_DUMMY_ID           0
+#define MDC_MDIO_CTRL0_REG          31
+#define MDC_MDIO_START_REG          29
+#define MDC_MDIO_CTRL1_REG          21
+#define MDC_MDIO_ADDRESS_REG        23
+#define MDC_MDIO_DATA_WRITE_REG     24
+#define MDC_MDIO_DATA_READ_REG      25
+#define MDC_MDIO_PREAMBLE_LEN       32
+
+#define MDC_MDIO_START_OP          0xFFFF
+#define MDC_MDIO_ADDR_OP           0x000E
+#define MDC_MDIO_READ_OP           0x0001
+#define MDC_MDIO_WRITE_OP          0x0003
+
+#define SPI_READ_OP                 0x3
+#define SPI_WRITE_OP                0x2
+#define SPI_READ_OP_LEN             0x8
+#define SPI_WRITE_OP_LEN            0x8
+#define SPI_REG_LEN                 16
+#define SPI_DATA_LEN                16
+
+#if defined(CONFIG_RTL_8325D_SUPPORT)
+#define CTRL_CODE 		0xA
+#else
+#define CTRL_CODE 		0xB
+#endif
+
+#if defined(CONFIG_RTL_8370_SUPPORT) || defined(CONFIG_RTL_8325D_SUPPORT)
+
+__inline__ void __delay__(unsigned long loops)
+{
+	__asm__ __volatile__ (
+		".set\tnoreorder\n"
+		"1:\tbnez\t%0,1b\n\t"
+		"subu\t%0,1\n\t"
+		".set\treorder"
+		:"=r" (loops)
+		:"0" (loops));
+}
+
+__inline__ void __udelay__(unsigned long usecs, unsigned long lps)
+{
+	unsigned long lo;
+
+	lo = ((usecs * 0x000010c6) >> 12) * (lps >> 20);
+	__delay__(lo);
+}
+
+// __loops_per_jiffy=0x00324000 is calculated for 8197D 660MHz
+#define __loops_per_jiffy 0x00324000
+
+__inline__ void __nano_delay__(unsigned long nsecs)
+{
+	unsigned long lo;
+
+	lo = (((nsecs * 0x000010c6) >> 12) * ((__loops_per_jiffy * 100) >> 20)) / 1000;
+	__delay__(lo);
+}
+
+//#define __mdelay__(x) { int i=x; while(i--) __udelay__(1000, __loops_per_jiffy * 100); }
+
+#define __udelay2__(x) { __udelay__(x, __loops_per_jiffy * 100); }
+
+//#define CLK_DURATION(clk)            { __udelay2__(1); }
+#define CLK_DURATION(clk)            { __nano_delay__(50); }
+
+#else
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,4,0)
+#define DELAY                        100/*dirty fix for r/w reg hang too long issue , FIXME !!!*/
+#else
+#define DELAY                        10000
+#endif
+#define CLK_DURATION(clk)            { int i; for(i=0; i<clk; i++); }
+#endif
+
+#define _SMI_ACK_RESPONSE(ok)        { /*if (!(ok)) return RT_ERR_FAILED; */}
+
+
+gpioID smi_SCK;        /* GPIO used for SMI Clock Generation */
+gpioID smi_SDA;        /* GPIO used for SMI Data signal */
+gpioID smi_RST;     /* GPIO used for reset swtich */
+
+
+#define ack_timer                    5
+#define max_register                0x018A
+
+#if defined(MDC_MDIO_OPERATION) || defined(SPI_OPERATION)
+    /* No local function in MDC/MDIO mode */
+#else
+
+#define rtlglue_drvMutexLock()
+#define rtlglue_drvMutexUnlock()
+
+void _smi_start(void)
+{
+
+    /* change GPIO pin to Output only */
+    _rtl865x_initGpioPin(smi_SDA, GPIO_PERI_GPIO, GPIO_DIR_OUT, GPIO_INT_DISABLE);
+    _rtl865x_initGpioPin(smi_SCK, GPIO_PERI_GPIO, GPIO_DIR_OUT, GPIO_INT_DISABLE);
+
+    /* Initial state: SCK: 0, SDA: 1 */
+    _rtl865x_setGpioDataBit(smi_SCK, 0);
+    _rtl865x_setGpioDataBit(smi_SDA, 1);
+    CLK_DURATION(DELAY);
+
+    /* CLK 1: 0 -> 1, 1 -> 0 */
+    _rtl865x_setGpioDataBit(smi_SCK, 1);
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SCK, 0);
+    CLK_DURATION(DELAY);
+
+    /* CLK 2: */
+    _rtl865x_setGpioDataBit(smi_SCK, 1);
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SDA, 0);
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SCK, 0);
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SDA, 1);
+
+}
+
+
+
+void _smi_writeBit(rtk_uint16 signal, rtk_uint32 bitLen)
+{
+    for( ; bitLen > 0; bitLen--)
+    {
+        CLK_DURATION(DELAY);
+
+        /* prepare data */
+        if ( signal & (1<<(bitLen-1)) )
+            _rtl865x_setGpioDataBit(smi_SDA, 1);
+        else
+            _rtl865x_setGpioDataBit(smi_SDA, 0);
+        CLK_DURATION(DELAY);
+
+        /* clocking */
+        _rtl865x_setGpioDataBit(smi_SCK, 1);
+        CLK_DURATION(DELAY);
+        _rtl865x_setGpioDataBit(smi_SCK, 0);
+    }
+}
+
+
+
+void _smi_readBit(rtk_uint32 bitLen, rtk_uint32 *rData)
+{
+    rtk_uint32 u;
+
+    /* change GPIO pin to Input only */
+    _rtl865x_initGpioPin(smi_SDA, GPIO_PERI_GPIO, GPIO_DIR_IN, GPIO_INT_DISABLE);
+
+    for (*rData = 0; bitLen > 0; bitLen--)
+    {
+        CLK_DURATION(DELAY);
+
+        /* clocking */
+        _rtl865x_setGpioDataBit(smi_SCK, 1);
+        CLK_DURATION(DELAY);
+        _rtl865x_getGpioDataBit(smi_SDA, &u);
+        _rtl865x_setGpioDataBit(smi_SCK, 0);
+
+        *rData |= (u << (bitLen - 1));
+    }
+
+    /* change GPIO pin to Output only */
+    _rtl865x_initGpioPin(smi_SDA, GPIO_PERI_GPIO, GPIO_DIR_OUT, GPIO_INT_DISABLE);
+}
+
+
+
+void _smi_stop(void)
+{
+
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SDA, 0);
+    _rtl865x_setGpioDataBit(smi_SCK, 1);
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SDA, 1);
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SCK, 1);
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SCK, 0);
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SCK, 1);
+
+    /* add a click */
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SCK, 0);
+    CLK_DURATION(DELAY);
+    _rtl865x_setGpioDataBit(smi_SCK, 1);
+
+
+    /* change GPIO pin to Input only */
+    _rtl865x_initGpioPin(smi_SDA, GPIO_PERI_GPIO, GPIO_DIR_IN, GPIO_INT_DISABLE);
+    _rtl865x_initGpioPin(smi_SCK, GPIO_PERI_GPIO, GPIO_DIR_IN, GPIO_INT_DISABLE);
+
+
+}
+
+#endif /* End of #if defined(MDC_MDIO_OPERATION) || defined(SPI_OPERATION) */
+
+rtk_int32 smi_reset(rtk_uint32 port, rtk_uint32 pinRST)
+{
+#if defined(MDC_MDIO_OPERATION) || defined(SPI_OPERATION)
+
+#else
+    gpioID gpioId;
+    rtk_int32 res;
+
+    /* Initialize GPIO port A, pin 7 as SMI RESET */
+    gpioId = GPIO_ID(port, pinRST);
+    res = _rtl865x_initGpioPin(gpioId, GPIO_PERI_GPIO, GPIO_DIR_OUT, GPIO_INT_DISABLE);
+    if (res != RT_ERR_OK)
+        return res;
+    smi_RST = gpioId;
+
+    _rtl865x_setGpioDataBit(smi_RST, 1);
+    CLK_DURATION(1000000);
+    _rtl865x_setGpioDataBit(smi_RST, 0);
+    CLK_DURATION(1000000);
+    _rtl865x_setGpioDataBit(smi_RST, 1);
+    CLK_DURATION(1000000);
+
+    /* change GPIO pin to Input only */
+    _rtl865x_initGpioPin(smi_RST, GPIO_PERI_GPIO, GPIO_DIR_IN, GPIO_INT_DISABLE);
+#endif
+    return RT_ERR_OK;
+}
+
+
+rtk_int32 smi_init(rtk_uint32 port, rtk_uint32 pinSCK, rtk_uint32 pinSDA)
+{
+#if defined(MDC_MDIO_OPERATION) || defined(SPI_OPERATION)
+
+#else
+    gpioID gpioId;
+    rtk_int32 res;
+
+    /* change GPIO pin to Input only */
+    /* Initialize GPIO port C, pin 0 as SMI SDA0 */
+    gpioId = GPIO_ID(port, pinSDA);
+    res = _rtl865x_initGpioPin(gpioId, GPIO_PERI_GPIO, GPIO_DIR_OUT, GPIO_INT_DISABLE);
+    if (res != RT_ERR_OK)
+        return res;
+    smi_SDA = gpioId;
+
+
+    /* Initialize GPIO port C, pin 1 as SMI SCK0 */
+    gpioId = GPIO_ID(port, pinSCK);
+    res = _rtl865x_initGpioPin(gpioId, GPIO_PERI_GPIO, GPIO_DIR_OUT, GPIO_INT_DISABLE);
+    if (res != RT_ERR_OK)
+        return res;
+    smi_SCK = gpioId;
+
+
+    _rtl865x_setGpioDataBit(smi_SDA, 1);
+    _rtl865x_setGpioDataBit(smi_SCK, 1);
+#endif
+    return RT_ERR_OK;
+}
+
+
+
+
+rtk_int32 smi_read(rtk_uint32 mAddrs, rtk_uint32 *rData)
+{
+#if defined(MDC_MDIO_OPERATION)
+
+    /* Write Start command to register 29 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_START_REG, MDC_MDIO_START_OP);
+
+    /* Write address control code to register 31 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_CTRL0_REG, MDC_MDIO_ADDR_OP);
+
+    /* Write Start command to register 29 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_START_REG, MDC_MDIO_START_OP);
+
+    /* Write address to register 23 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_ADDRESS_REG, mAddrs);
+
+    /* Write Start command to register 29 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_START_REG, MDC_MDIO_START_OP);
+
+    /* Write read control code to register 21 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_CTRL1_REG, MDC_MDIO_READ_OP);
+
+    /* Write Start command to register 29 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_START_REG, MDC_MDIO_START_OP);
+
+    /* Read data from register 25 */
+    MDC_MDIO_READ(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_DATA_READ_REG, rData);
+
+    return RT_ERR_OK;
+
+#elif defined(SPI_OPERATION)
+    /* Write 8 bits READ OP_CODE */
+    SPI_WRITE(SPI_READ_OP, SPI_READ_OP_LEN);
+
+    /* Write 16 bits register address */
+    SPI_WRITE(mAddrs, SPI_REG_LEN);
+
+    /* Read 16 bits data */
+    SPI_READ(rData, SPI_DATA_LEN);
+
+#else
+    rtk_uint32 rawData=0, ACK;
+    rtk_uint8  con;
+    rtk_uint32 ret = RT_ERR_OK;
+
+    /*Disable CPU interrupt to ensure that the SMI operation is atomic.
+      The API is based on RTL865X, rewrite the API if porting to other platform.*/
+    rtlglue_drvMutexLock();
+
+    _smi_start();                                /* Start SMI */
+
+    _smi_writeBit(CTRL_CODE, 4);                     /* CTRL code: 4'b1011 for RTL8370 */
+
+    _smi_writeBit(0x4, 3);                        /* CTRL code: 3'b100 */
+
+    _smi_writeBit(0x1, 1);                        /* 1: issue READ command */
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);                    /* ACK for issuing READ command*/
+    } while ((ACK != 0) && (con < ack_timer));
+
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+    _smi_writeBit((mAddrs&0xff), 8);             /* Set reg_addr[7:0] */
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);                    /* ACK for setting reg_addr[7:0] */
+    } while ((ACK != 0) && (con < ack_timer));
+
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+#if defined(CONFIG_RTL_8325D_SUPPORT)
+    /*Set address addr[15:8] and ACK*/
+    _smi_writeBit(((mAddrs & 0xff00) >> 8), 8);
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+
+    /*Set address addr[23:16] and ACK*/
+    _smi_writeBit(((mAddrs & 0xff0000) >> 16), 8);
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+
+    /*Read DATA [7:0], and ACK by CPU*/
+    *rData = 0;
+    _smi_readBit(8, &rawData);
+    _smi_writeBit(0x0, 1);
+    *rData = rawData & 0xff;
+
+
+     /*Read DATA [15: 8], and ACK by CPU*/
+    _smi_readBit(8, &rawData);
+    _smi_writeBit(0x0, 1);
+    *rData |= ((rawData & 0xff)<<8);
+
+    /*Read DATA [23: 16], and ACK by CPU*/
+    _smi_readBit(8, &rawData);
+    _smi_writeBit(0x0, 1);
+    *rData |= ((rawData & 0xff) << 16);
+
+
+    /*Read DATA [31: 24], and NO ACK by CPU*/
+    _smi_readBit(8, &rawData);
+    _smi_writeBit(0x01, 1);
+    *rData |= ((rawData & 0xff) << 24);
+#else
+    _smi_writeBit((mAddrs>>8), 8);                 /* Set reg_addr[15:8] */
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);                    /* ACK by RTL8369 */
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+    _smi_readBit(8, &rawData);                    /* Read DATA [7:0] */
+    *rData = rawData&0xff;
+
+    _smi_writeBit(0x00, 1);                        /* ACK by CPU */
+
+    _smi_readBit(8, &rawData);                    /* Read DATA [15: 8] */
+
+    _smi_writeBit(0x01, 1);                        /* ACK by CPU */
+    *rData |= (rawData<<8);
+#endif
+
+    _smi_stop();
+
+    rtlglue_drvMutexUnlock();/*enable CPU interrupt*/
+
+    return ret;
+#endif /* end of #if defined(MDC_MDIO_OPERATION) */
+}
+
+
+
+rtk_int32 smi_write(rtk_uint32 mAddrs, rtk_uint32 rData)
+{
+#if defined(MDC_MDIO_OPERATION)
+
+    /* Write Start command to register 29 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_START_REG, MDC_MDIO_START_OP);
+
+    /* Write address control code to register 31 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_CTRL0_REG, MDC_MDIO_ADDR_OP);
+
+    /* Write Start command to register 29 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_START_REG, MDC_MDIO_START_OP);
+
+    /* Write address to register 23 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_ADDRESS_REG, mAddrs);
+
+    /* Write Start command to register 29 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_START_REG, MDC_MDIO_START_OP);
+
+    /* Write data to register 24 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_DATA_WRITE_REG, rData);
+
+    /* Write Start command to register 29 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_START_REG, MDC_MDIO_START_OP);
+
+    /* Write data control code to register 21 */
+    MDC_MDIO_WRITE(MDC_MDIO_PREAMBLE_LEN, MDC_MDIO_DUMMY_ID, MDC_MDIO_CTRL1_REG, MDC_MDIO_WRITE_OP);
+
+    return RT_ERR_OK;
+
+#elif defined(SPI_OPERATION)
+    /* Write 8 bits WRITE OP_CODE */
+    SPI_WRITE(SPI_WRITE_OP, SPI_WRITE_OP_LEN);
+
+    /* Write 16 bits register address */
+    SPI_WRITE(mAddrs, SPI_REG_LEN);
+
+    /* Write 16 bits data */
+    SPI_WRITE(rData, SPI_DATA_LEN);
+#else
+
+/*
+    if ((mAddrs > 0x018A) || (rData > 0xFFFF))  return    RT_ERR_FAILED;
+*/
+    rtk_int8 con;
+    rtk_uint32 ACK;
+    rtk_uint32 ret = RT_ERR_OK;
+
+    /*Disable CPU interrupt to ensure that the SMI operation is atomic.
+      The API is based on RTL865X, rewrite the API if porting to other platform.*/
+       rtlglue_drvMutexLock();
+
+    _smi_start();                                /* Start SMI */
+
+    _smi_writeBit(CTRL_CODE, 4);                     /* CTRL code: 4'b1011 for RTL8370*/
+
+    _smi_writeBit(0x4, 3);                        /* CTRL code: 3'b100 */
+
+    _smi_writeBit(0x0, 1);                        /* 0: issue WRITE command */
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);                    /* ACK for issuing WRITE command*/
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+    _smi_writeBit((mAddrs&0xff), 8);             /* Set reg_addr[7:0] */
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);                    /* ACK for setting reg_addr[7:0] */
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+#if defined(CONFIG_RTL_8325D_SUPPORT)
+    /*Set address addr[15:8], and ACK */
+    _smi_writeBit(((mAddrs & 0xff00)>>8), 8);
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+
+    /* Set address addr[23:16] and ACK*/
+    _smi_writeBit(((mAddrs & 0xff0000)>>16), 8);
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+
+    /* Write Data [7:0] out and ACK */
+    _smi_writeBit(rData&0xff, 8);
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+
+     /* Write Data [15:8] out and ACK */
+    _smi_writeBit((rData & 0xff00)>>8, 8);
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+
+    /* Write Data [23:16] out and ACK*/
+    _smi_writeBit((rData & 0xff0000)>>16, 8);
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+    /* Write Data [31:24] out and ACK */
+    _smi_writeBit((rData & 0xff000000)>>24, 8);
+#else
+    _smi_writeBit((mAddrs>>8), 8);                 /* Set reg_addr[15:8] */
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);                    /* ACK for setting reg_addr[15:8] */
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+    _smi_writeBit(rData&0xff, 8);                /* Write Data [7:0] out */
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);                    /* ACK for writting data [7:0] */
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+    _smi_writeBit(rData>>8, 8);                    /* Write Data [15:8] out */
+#endif
+
+    con = 0;
+    do {
+        con++;
+        _smi_readBit(1, &ACK);                        /* ACK for writting data [15:8] */
+    } while ((ACK != 0) && (con < ack_timer));
+    if (ACK != 0) ret = RT_ERR_FAILED;
+
+    _smi_stop();
+
+    rtlglue_drvMutexUnlock();/*enable CPU interrupt*/
+
+    return ret;
+#endif /* end of #if defined(MDC_MDIO_OPERATION) */
+}
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/common/smi.h b/drivers/soc/realtek/rtd129x/hw_nat/common/smi.h
new file mode 100644
index 00000000..2709581
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/common/smi.h
@@ -0,0 +1,27 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+
+#ifndef __SMI_H__
+#define __SMI_H__
+
+typedef unsigned int rtk_uint32;
+typedef unsigned short rtk_uint16;
+typedef unsigned char rtk_uint8;
+typedef int rtk_int32;
+typedef char rtk_int8;
+
+rtk_int32 smi_reset(rtk_uint32 port, rtk_uint32 pinRST);
+rtk_int32 smi_init(rtk_uint32 port, rtk_uint32 pinSCK, rtk_uint32 pinSDA);
+rtk_int32 smi_read(rtk_uint32 mAddrs, rtk_uint32 *rData);
+rtk_int32 smi_write(rtk_uint32 mAddrs, rtk_uint32 rData);
+
+#endif /* __SMI_H__ */
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/Makefile b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/Makefile
new file mode 100644
index 00000000..01630fb
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/Makefile
@@ -0,0 +1,40 @@
+#
+# Makefile for igmp snooping
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definitions are now in the main makefile...
+#Add mips16 Support
+ifdef CONFIG_RTL865X_KERNEL_MIPS16_LAYERDRIVER
+	CFLAGS_rtl865x_igmpsnooping_glue.o	= -mips16
+	#CFLAGS_rtl865x_igmpsnooping.o		= -mips16
+endif
+DIR_RTLASIC = $(srctree)/drivers/soc/realtek/rtd129x/hw_nat/
+CONFIG_NEW_IGMP_IMPLEMENTATION=y
+ifeq ($(CONFIG_NEW_IGMP_IMPLEMENTATION),y)
+obj-y := rtl865x_igmpsnooping_glue.o rtl865x_igmpsnooping_new.o igmp_delete.o
+EXTRA_CFLAGS += -DCONFIG_NEW_IGMP_IMPLEMENTATION
+else
+obj-y := rtl865x_igmpsnooping_glue.o rtl865x_igmpsnooping.o
+endif
+
+EXTRA_CFLAGS += -O1 -DRTL_TBLDRV -D__linux__ -D __KERNEL__ -DEXPORT_SYMTAB -DRTL865X_OVER_KERNEL -DRTL865X_OVER_LINUX -Werror
+EXTRA_CFLAGS += -I$(srctree)/include
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/AsicDriver
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/common
+EXTRA_CFLAGS += -I$(DIR_RTLASIC)
+#EXTRA_CFLAGS += -I. -I..
+
+
+
+ifeq ($(CONFIG_RTL865X_MODULE_ROMEDRV),y)
+	EXTRA_CFLAGS += -G 0
+	EXTRA_CFLAGS += -DMODULE
+	EXTRA_CFLAGS += -mlong-calls
+endif
+
+ifeq ($(CONFIG_RTL_MESH_SUPPORT),y)
+        EXTRA_CFLAGS += -DCONFIG_RTK_MESH
+endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/igmp_delete.c b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/igmp_delete.c
new file mode 100644
index 00000000..7eb9572
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/igmp_delete.c
@@ -0,0 +1,139 @@
+/*
+ *
+ *  Copyright (c) 2011 Realtek Semiconductor Corp.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 2 as
+ *  published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/proc_fs.h>
+#include <linux/types.h>
+#include <linux/errno.h>
+#include <linux/sched.h>
+#include <linux/kernel.h>
+#include <linux/kernel_stat.h>
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <asm/uaccess.h>
+#include <linux/net.h>
+#include <linux/socket.h>
+
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/string.h>
+#include <net/ip.h>
+#include <net/protocol.h>
+#include <net/route.h>
+#include <net/sock.h>
+#include <net/arp.h>
+#include <net/raw.h>
+#include <net/checksum.h>
+#include <linux/netfilter.h>
+#include <linux/netfilter_ipv4.h>
+#include <linux/netlink.h>
+#include <linux/inetdevice.h>
+#include <linux/icmp.h>
+#include <net/udp.h>
+#include <net/tcp.h>
+
+#include <net/rtl/rtl_types.h>
+#ifdef CONFIG_NETFILTER
+#include <net/netfilter/nf_conntrack.h>
+#include <net/rtl/fastpath/fastpath_core.h>
+#endif
+#include <net/rtl/rtl865x_netif.h>
+#include <net/rtl/rtl_nic.h>
+
+
+struct sock *igmp_delete_sk = NULL;
+struct test_struct
+{
+	char data[30];
+};
+// to_be_checked !!!
+#if !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F) && !defined(CONFIG_OPENWRT_SDK)
+static int try_mac(const char *data, char array[],
+		      int array_size, char sep)
+{
+	uint32 i;
+
+	memset(array, 0, sizeof(array[0])*array_size);
+
+	/* Keep data pointing at next char. */
+	for (i = 0;  i < array_size; data++) {
+		if (*data >= '0' && *data <= '9') {
+			array[i] = array[i]*16 + *data - '0';
+		}
+		else if(*data >='a' && *data <='f') {
+			array[i] = array[i]*16 + *data - 'a'+10;
+		}
+		else if(*data >='A' && *data <='F') {
+			array[i] = array[i]*16 + *data - 'A'+10;
+		}
+		else if (*data == sep)
+			i++;
+		else {
+			/* Unexpected character; true if it's the
+			   terminator and we're finished. */
+			if (i == array_size - 1)
+				return 1;
+
+			printk("Char %u  '%c' unexpected\n",\
+				 i, *data);
+			return 0;
+		}
+	}
+	return 0;
+}
+#endif
+
+extern int32 rtl_delIgmpRecordByMacAddr(uint8 *macAddr);
+void igmp_delete (struct sk_buff *__skb)
+{
+// to_be_checked !!!
+#if !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F) && !defined(CONFIG_OPENWRT_SDK)
+	int pid;
+	struct test_struct send_data,recv_data;
+	uint8 mac[6];
+	char *ptr;
+	pid=rtk_nlrecvmsg(__skb,sizeof(struct test_struct),&recv_data);
+	//printk("igmp_delete data:%s\n", recv_data.data);
+	memset(mac, 0, 6);
+	ptr = recv_data.data;
+	if(try_mac(recv_data.data, mac, 6, ':'))
+	{
+		rtl_delIgmpRecordByMacAddr(mac);
+		//printk("filter mac: %02x:%02x:%02x:%02x:%02x:%02x\n", mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
+		sprintf(send_data.data,"clear igmp cache ok\n");
+	}
+	else
+	{
+		printk("clear igmp cache of bad format mac:%s\n", recv_data.data);
+		sprintf(send_data.data,"please input like 00:23:e8:79:99:32\n");
+	}
+	rtk_nlsendmsg(pid, igmp_delete_sk, sizeof(struct test_struct), &send_data);
+#endif
+	return;
+}
+
+int igmp_delete_init_netlink(void)
+{
+// to_be_checked !!!
+//#ifndef CONFIG_RTL_8198C // modified by lynn_pu, 2014-10-22
+#if !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F) && (!defined(CONFIG_RLX)&&(LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0)))
+	igmp_delete_sk = netlink_kernel_create(&init_net, NETLINK_MULTICAST_DELETE, 0, igmp_delete, NULL, THIS_MODULE);
+
+	if (!igmp_delete_sk) {
+		printk(KERN_ERR "Netlink[Kernel] Cannot create netlink socket for igmp delete.\n");
+		return -EIO;
+	}
+	printk("Netlink[Kernel] create socket for igmp ok.\n");
+#endif
+	return 0;
+}
+
+EXPORT_SYMBOL(igmp_delete_init_netlink);
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping.c b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping.c
new file mode 100644
index 00000000..9b79d90
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping.c
@@ -0,0 +1,5074 @@
+/*
+* Program :  igmp snooping function
+* Abstract :
+* Author :qinjunjie
+* Email:qinjunjie1980@hotmail.com
+*
+*  Copyright (c) 2011 Realtek Semiconductor Corp.
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License version 2 as
+*  published by the Free Software Foundation.
+*/
+
+#ifdef __linux__
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,4,0)
+#include <linux/kconfig.h>
+#else
+#include <linux/config.h>
+#endif
+#include <linux/jiffies.h>
+#include <linux/timer.h>
+#include <linux/proc_fs.h>
+#ifdef CONFIG_PROC_FS
+#include <linux/seq_file.h>
+#endif
+#endif
+
+#include "rtl865x_igmpsnooping_glue.h"
+#include "rtl865x_igmpsnooping.h"
+#include "rtl865x_igmpsnooping_local.h"
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+#include "../common/rtl865x_eventMgr.h"
+#endif
+
+static struct rtl_multicastModule rtl_mCastModuleArray[MAX_MCAST_MODULE_NUM];
+#if defined(__linux__) && defined(__KERNEL__)
+static struct timer_list igmpSysTimer;	/*igmp timer*/
+#endif
+/*global system resources declaration*/
+static uint32 rtl_totalMaxGroupCnt;    /*maximum total group entry count,  default is 100*/
+static uint32 rtl_totalMaxSourceCnt;   /*maximum total group entry count,  default is 3000*/
+
+void *rtl_groupMemory=NULL;
+void *rtl_sourceMemory=NULL;
+
+static struct rtl_groupEntry *rtl_groupEntryPool=NULL;
+static struct rtl_sourceEntry *rtl_sourceEntryPool=NULL;
+
+static struct rtl_mCastTimerParameters rtl_mCastTimerParas;  /*IGMP snooping parameters */
+
+static uint32 rtl_hashTableSize=0;
+static uint32 rtl_hashMask=0;
+
+/*the system up time*/
+static uint32 rtl_startTime;
+static uint32 rtl_sysUpSeconds;
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+static rtl_multicastEventContext_t reportEventContext;
+static rtl_multicastEventContext_t timerEventContext;
+static rtl_multicastEventContext_t linkEventContext;
+#endif
+
+/*******************************internal function declaration*****************************/
+
+
+
+/**************************
+	resource managment
+**************************/
+static  struct rtl_groupEntry* rtl_initGroupEntryPool(uint32 poolSize);
+static  struct rtl_groupEntry* rtl_allocateGroupEntry(void);
+static  void rtl_freeGroupEntry(struct rtl_groupEntry* groupEntryPtr) ;
+
+
+static  struct rtl_sourceEntry* rtl_initSourceEntryPool(uint32 poolSize);
+static  struct rtl_sourceEntry* rtl_allocateSourceEntry(void);
+static  void rtl_freeSourceEntry(struct rtl_sourceEntry* sourceEntryPtr) ;
+
+
+/**********************************Structure Maintenance*************************/
+
+static struct rtl_groupEntry* rtl_searchGroupEntry(uint32 moduleIndex, uint32 ipVersion,uint32 *multicastAddr);
+static void rtl_linkGroupEntry(struct rtl_groupEntry* entryNode ,  struct rtl_groupEntry ** hashTable, uint32 hashIndex);
+static void rtl_unlinkGroupEntry(struct rtl_groupEntry* entryNode,  struct rtl_groupEntry ** hashTable, uint32 hashIndex);
+static void rtl_clearGroupEntry(struct rtl_groupEntry* groupEntryPtr);
+
+static struct rtl_sourceEntry* rtl_searchSourceEntry(uint32 ipVersion, uint32 *sourceAddr, struct rtl_groupEntry *groupEntry);
+static void rtl_linkSourceEntry(struct rtl_groupEntry *groupEntry,  struct rtl_sourceEntry* entryNode);
+static void rtl_unlinkSourceEntry(struct rtl_groupEntry *groupEntry, struct rtl_sourceEntry* entryNode);
+static void rtl_clearSourceEntry(struct rtl_sourceEntry* sourceEntryPtr);
+static void rtl_deleteSourceEntry(struct rtl_groupEntry *groupEntry, struct rtl_sourceEntry* sourceEntry);
+#if 0
+static int32 rtl_checkPortMask(uint8 pktPortMask);
+static uint32 rtl_mapPortMaskToPortNum(uint8 pormask);
+#endif
+
+
+//static int32 rtl_mapMCastIPToMAC(uint32 ipVersion, uint32 *ipAddr, uint8 *macAddr );
+static int32 rtl_checkMCastAddrMapping(uint32 ipVersion, uint32 *ipAddr, uint8* macAddr);
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+static int32 rtl_compareIpv6Addr(uint32* ipv6Addr1, uint32* ipv6Addr2);
+static uint16 rtl_ipv6L3Checksum(uint8 *pktBuf, uint32 pktLen, union pseudoHeader *ipv6PseudoHdr);
+#endif
+static int32 rtl_compareMacAddr(uint8* macAddr1, uint8* macAddr2);
+static uint16 rtl_checksum(uint8 *packetBuf, uint32 packetLen);
+
+static uint32 rtl_getGroupFwdPortMask(struct rtl_groupEntry * groupEntry, uint32 enableSourceList, uint32 sysTime);
+static void rtl_checkSourceTimer(struct rtl_groupEntry * groupEntry , struct rtl_sourceEntry * sourceEntry);
+static uint32 rtl_getSourceFwdPortMask(struct rtl_groupEntry * groupEntry,uint32 *sourceAddr, uint32 sysTime);
+//static void rtl_checkGroupFilterTimer(struct rtl_groupEntry *groupEntry);
+static void rtl_checkGroupEntryTimer(struct rtl_groupEntry * groupEntry,uint32 enableSourceList, struct rtl_groupEntry ** hashTable);
+
+static uint32  rtl_getMulticastRouterPortMask(uint32 moduleIndex, uint32 ipVersion, uint32 sysTime);
+
+
+/*hash table operation*/
+static int32 rtl_initHashTable(uint32 moduleIndex, uint32 hashTableSize);
+
+
+/************************************Pkt Process**********************************/
+/*MAC frame analyze function*/
+static void  rtl_parseMacFrame(uint32 moduleIndex, uint8* MacFrame, uint32 verifyCheckSum, struct rtl_macFrameInfo* macInfo);
+
+/*Process Query Packet*/
+static void rtl_snoopQuerier(uint32 moduleIndex, uint32 ipVersion, uint32 portNum);
+static uint32 rtl_processQueries(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8* pktBuf, uint32 pktLen);
+/*Process Report Packet*/
+static  uint32 rtl_processJoin(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf); // process join report packet
+static  uint32 rtl_processLeave(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf); //process leave/done report packet
+static  int32 rtl_processIsInclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf); //process MODE_IS_INCLUDE report packet
+static  int32 rtl_processIsExclude(uint32 moduleIndex, uint32 ipVersion,uint32 portNum, uint8 *pktBuf); //process MODE_IS_EXCLUDE report packet
+static  int32 rtl_processToInclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf); //process CHANGE_TO_INCLUDE_MODE report packet
+static  int32 rtl_processToExclude(uint32 moduleIndex, uint32 ipVersion,uint32 portNum, uint8 *pktBuf); //process CHANGE_TO_EXCLUDE_MODE report packet
+static  int32 rtl_processAllow(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf); //process ALLOW_NEW_SOURCES report packet
+static  int32 rtl_processBlock(uint32 moduleIndex, uint32 ipVersion,uint32 portNum, uint8 *pktBuf); //process BLOCK_OLD_SOURCES report packet
+static  uint32 rtl_processIgmpv3Mldv2Reports(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf);
+
+/*******************different protocol process function**********************************/
+static uint32 rtl_processIgmpMld(uint32 moduleIndex, uint32 ipVersion, uint8* pktBuf, uint32 pktLen, uint32 portNum);
+static uint32 rtl_processDvmrp(uint32 moduleIndex, uint32 ipVersion, uint8* pktBuf, uint32 pktLen, uint32 portNum);
+static uint32 rtl_processMospf(uint32 moduleIndex, uint32 ipVersion, uint8* pktBuf, uint32 pktLen, uint32 portNum);
+static uint32 rtl_processPim(uint32 moduleIndex, uint32 ipVersion, uint8* pktBuf, uint32 pktLen, uint32 portNum);
+
+#if  defined(__linux__) && defined(__KERNEL__)
+static void rtl_multicastSysTimerExpired(uint32 expireDada);
+static void rtl_multicastSysTimerInit(void);
+static void rtl_multicastSysTimerDestroy(void);
+#endif
+
+
+/************************************************
+			Implementation
+  ************************************************/
+
+/**************************
+	Initialize
+**************************/
+/*
+@func int32		| rtl_initMulticastSnooping	|Initialize  igmp snooping system.
+@parm 		struct rtl_mCastSnoopingGlobalConfig  | mCastSnoopingGlobalConfig | Global parameters to config igmp snooping system.
+@rvalue SUCCESS	| 	Initialize successfully.
+@rvalue FAILED	| 	Initialize failed.
+*/
+int32 rtl_initMulticastSnooping(struct rtl_mCastSnoopingGlobalConfig mCastSnoopingGlobalConfig)
+{
+	int i,j;
+	uint32 maxHashTableSize=MAX_HASH_TABLE_SIZE;
+	for(i=0; i<MAX_MCAST_MODULE_NUM; i++)
+	{
+		memset(&(rtl_mCastModuleArray[i]), 0,sizeof(struct rtl_multicastModule));
+
+		for(j=0; j<6; j++)
+		{
+			rtl_mCastModuleArray[i].rtl_gatewayMac[j]=0;
+		}
+
+		rtl_mCastModuleArray[i].rtl_gatewayIpv4Addr=0;
+		rtl_mCastModuleArray[i].rtl_ipv4HashTable=NULL;
+
+		#ifdef CONFIG_RTL_MLD_SNOOPING
+		for(j=0; j<4; j++)
+		{
+			rtl_mCastModuleArray[i].rtl_gatewayIpv6Addr[j]=0;
+		}
+		rtl_mCastModuleArray[i].rtl_ipv6HashTable=NULL;
+		#endif
+
+		rtl_mCastModuleArray[i].enableSourceList=TRUE;
+		rtl_mCastModuleArray[i].enableSnooping=FALSE;
+		rtl_mCastModuleArray[i].enableFastLeave=TRUE;
+	}
+
+
+       /*set multicast snooping parameters, use default value*/
+      if(mCastSnoopingGlobalConfig.groupMemberAgingTime==0)
+      {
+	      rtl_mCastTimerParas.groupMemberAgingTime= DEFAULT_GROUP_MEMBER_INTERVAL;
+      }
+      else
+      {
+	      rtl_mCastTimerParas.groupMemberAgingTime= mCastSnoopingGlobalConfig.groupMemberAgingTime;
+      }
+
+      if(mCastSnoopingGlobalConfig.lastMemberAgingTime==0)
+      {
+             rtl_mCastTimerParas.lastMemberAgingTime= 0;
+      }
+      else
+      {
+	      rtl_mCastTimerParas.lastMemberAgingTime= mCastSnoopingGlobalConfig.lastMemberAgingTime;
+      }
+
+      if(mCastSnoopingGlobalConfig.querierPresentInterval==0)
+      {
+	      rtl_mCastTimerParas.querierPresentInterval= DEFAULT_QUERIER_PRESENT_TIMEOUT;
+      }
+	else
+      {
+	      rtl_mCastTimerParas.querierPresentInterval=mCastSnoopingGlobalConfig.querierPresentInterval;
+      }
+
+
+      if(mCastSnoopingGlobalConfig.dvmrpRouterAgingTime==0)
+      {
+	      rtl_mCastTimerParas.dvmrpRouterAgingTime=DEFAULT_DVMRP_AGING_TIME;
+      }
+      else
+      {
+	      rtl_mCastTimerParas.dvmrpRouterAgingTime=mCastSnoopingGlobalConfig.dvmrpRouterAgingTime;
+      }
+
+      if(mCastSnoopingGlobalConfig.mospfRouterAgingTime==0)
+      {
+	      rtl_mCastTimerParas.mospfRouterAgingTime=DEFAULT_MOSPF_AGING_TIME;
+      }
+  	else
+      {
+	      rtl_mCastTimerParas.mospfRouterAgingTime=mCastSnoopingGlobalConfig.mospfRouterAgingTime;
+      }
+
+      if(mCastSnoopingGlobalConfig.pimRouterAgingTime==0)
+      {
+	      rtl_mCastTimerParas.pimRouterAgingTime=DEFAULT_PIM_AGING_TIME;
+      }
+      else
+      {
+	      rtl_mCastTimerParas.pimRouterAgingTime=mCastSnoopingGlobalConfig.pimRouterAgingTime;
+      }
+
+	 /* set hash table size and hash mask*/
+       if(mCastSnoopingGlobalConfig.hashTableSize==0)
+        {
+	      rtl_hashTableSize=DEFAULT_HASH_TABLE_SIZE;   /*default hash table size*/
+        }
+        else
+        {
+		for(i=0;i<11;i++)
+	        {
+		      if(mCastSnoopingGlobalConfig.hashTableSize>=maxHashTableSize)
+		      {
+			      rtl_hashTableSize=maxHashTableSize;
+
+			      break;
+		      }
+	 	      maxHashTableSize=maxHashTableSize>>1;
+
+	        }
+        }
+
+      rtl_hashMask=rtl_hashTableSize-1;
+
+
+      if(mCastSnoopingGlobalConfig.maxGroupNum==0)
+      {
+	      rtl_totalMaxGroupCnt=DEFAULT_MAX_GROUP_COUNT;
+      }
+      else
+      {
+		rtl_totalMaxGroupCnt=mCastSnoopingGlobalConfig.maxGroupNum;
+      }
+
+	/*initialize group entry pool*/
+      rtl_groupMemory=NULL;
+      rtl_sourceMemory=NULL;
+
+      rtl_groupEntryPool=rtl_initGroupEntryPool(rtl_totalMaxGroupCnt);
+      if(rtl_groupEntryPool==NULL)
+      {
+	      return FAILED;
+      }
+
+
+	if(mCastSnoopingGlobalConfig.maxSourceNum==0)
+      {
+	      rtl_totalMaxSourceCnt=DEFAULT_MAX_SOURCE_COUNT;
+      }
+      else
+      {
+            	rtl_totalMaxSourceCnt=mCastSnoopingGlobalConfig.maxSourceNum;
+      }
+
+	rtl_sourceEntryPool=rtl_initSourceEntryPool(rtl_totalMaxSourceCnt);
+      if(rtl_sourceEntryPool==NULL)
+      {
+	      rtl_totalMaxSourceCnt=0;
+	      return FAILED;
+      }
+
+#if defined(__linux__) && defined(__KERNEL__)
+	rtl_multicastSysTimerInit();
+#endif
+
+	return SUCCESS;
+
+}
+
+/*
+@func int32	| rtl_exitMulticastSnooping	| Exit igmp snooping system.
+@rvalue SUCCESS	| 	Exit successfully.
+@rvalue FAILED	| 	Exit failed.
+*/
+int32 rtl_exitMulticastSnooping(void)
+{
+
+	uint32 moduleIndex;
+	for(moduleIndex=0; moduleIndex<MAX_MCAST_MODULE_NUM; moduleIndex++)
+	{
+		rtl_unregisterIgmpSnoopingModule(moduleIndex);
+	}
+
+	rtl_hashTableSize=0;
+	rtl_hashMask=0;
+	memset(&rtl_mCastTimerParas,0,sizeof(struct rtl_mCastTimerParameters));
+
+	if(rtl_groupMemory!=NULL)
+	{
+		rtl_glueFree(rtl_groupMemory);
+	}
+
+	rtl_totalMaxGroupCnt=0;
+	rtl_groupMemory=NULL;
+	rtl_groupEntryPool=NULL;
+
+
+	if(rtl_sourceMemory!=NULL)
+	{
+		rtl_glueFree(rtl_sourceMemory);
+	}
+
+	rtl_totalMaxSourceCnt=0;
+	rtl_sourceMemory=NULL;
+	rtl_sourceEntryPool=NULL;
+
+#if defined(__linux__) && defined(__KERNEL__)
+	rtl_multicastSysTimerDestroy();
+#endif
+
+	 return SUCCESS;
+
+}
+
+static  struct rtl_groupEntry* rtl_initGroupEntryPool(uint32 poolSize)
+{
+
+	uint32 idx=0;
+	struct rtl_groupEntry *poolHead=NULL;
+	struct rtl_groupEntry *entryPtr=NULL;
+	rtl_glueMutexLock();	/* Lock resource */
+	if (poolSize == 0)
+	{
+		goto out;
+	}
+
+	/* Allocate memory */
+	poolHead = (struct rtl_groupEntry *)rtl_glueMalloc(sizeof(struct rtl_groupEntry) * poolSize);
+	rtl_groupMemory=(void *)poolHead;
+
+	if (poolHead != NULL)
+	{
+		memset(poolHead, 0,  (poolSize  * sizeof(struct rtl_groupEntry)));
+		entryPtr = poolHead;
+
+		/* link the whole group entry pool */
+		for (idx = 0 ; idx < poolSize ; idx++, entryPtr++)
+		{
+			if(idx==0)
+			{
+				entryPtr->previous=NULL;
+				if(idx == (poolSize - 1))
+				{
+					entryPtr->next=NULL;
+				}
+				else
+				{
+					entryPtr->next = entryPtr + 1;
+				}
+			}
+			else
+			{
+				entryPtr->previous=entryPtr-1;
+				if (idx == (poolSize - 1))
+				{
+					entryPtr->next = NULL;
+				}
+				else
+				{
+					entryPtr->next = entryPtr + 1;
+				}
+			}
+		}
+	}
+
+out:
+
+	rtl_glueMutexUnlock();	/* UnLock resource */
+	return poolHead;
+
+}
+
+
+
+/**************************
+	Resource Managment
+**************************/
+
+// allocate a group entry pool from the group entry pool
+static  struct rtl_groupEntry* rtl_allocateGroupEntry(void)
+{
+	struct rtl_groupEntry *ret = NULL;
+
+	rtl_glueMutexLock();
+		if (rtl_groupEntryPool!=NULL)
+		{
+			ret = rtl_groupEntryPool;
+			if(rtl_groupEntryPool->next!=NULL)
+			{
+				rtl_groupEntryPool->next->previous=NULL;
+			}
+			rtl_groupEntryPool = rtl_groupEntryPool->next;
+			memset(ret, 0, sizeof(struct rtl_groupEntry));
+		}
+
+	rtl_glueMutexUnlock();
+
+	return ret;
+}
+
+// free a group entry and link it back to the group entry pool, default is link to the pool head
+static  void rtl_freeGroupEntry(struct rtl_groupEntry* groupEntryPtr)
+{
+	if (!groupEntryPtr)
+	{
+		return;
+	}
+
+	rtl_glueMutexLock();
+		groupEntryPtr->next = rtl_groupEntryPool;
+		if(rtl_groupEntryPool!=NULL)
+		{
+			rtl_groupEntryPool->previous=groupEntryPtr;
+		}
+		rtl_groupEntryPool=groupEntryPtr;
+	rtl_glueMutexUnlock();
+}
+
+
+
+static  struct rtl_sourceEntry* rtl_initSourceEntryPool(uint32 poolSize)
+{
+
+	uint32 idx=0;
+	struct rtl_sourceEntry *poolHead=NULL;
+	struct rtl_sourceEntry *entryPtr=NULL;
+	rtl_glueMutexLock();	/* Lock resource */
+	if (poolSize == 0)
+	{
+		goto out;
+	}
+
+	/* Allocate memory */
+	poolHead = (struct rtl_sourceEntry *)rtl_glueMalloc(sizeof(struct rtl_sourceEntry) * rtl_totalMaxSourceCnt);
+	rtl_sourceMemory=(void *)poolHead;
+	if (poolHead != NULL)
+	{
+		memset(poolHead, 0,  (poolSize  * sizeof(struct rtl_sourceEntry)));
+		entryPtr = poolHead;
+
+		/* link the whole source entry pool */
+		for (idx = 0 ; idx < poolSize ; idx++, entryPtr++)
+		{
+			if(idx==0)
+			{
+				entryPtr->previous=NULL;
+				if(idx == (poolSize - 1))
+				{
+					entryPtr->next=NULL;
+				}
+				else
+				{
+					entryPtr->next = entryPtr + 1;
+				}
+			}
+			else
+			{
+				entryPtr->previous=entryPtr-1;
+				if (idx == (poolSize - 1))
+				{
+					entryPtr->next = NULL;
+				}
+				else
+				{
+					entryPtr->next = entryPtr + 1;
+				}
+			}
+
+		}
+	}
+
+out:
+	rtl_glueMutexUnlock();	/* UnLock resource */
+	return poolHead;
+
+}
+
+
+
+/**************************
+	Resource Managment
+**************************/
+
+// allocate a group entry pool from the group entry pool
+static  struct rtl_sourceEntry* rtl_allocateSourceEntry(void)
+{
+	struct rtl_sourceEntry *ret = NULL;
+
+	rtl_glueMutexLock();
+		if (rtl_sourceEntryPool!=NULL)
+		{
+			ret = rtl_sourceEntryPool;
+			if(rtl_sourceEntryPool->next!=NULL)
+			{
+				rtl_sourceEntryPool->next->previous=NULL;
+			}
+			rtl_sourceEntryPool = rtl_sourceEntryPool->next;
+			memset(ret, 0, sizeof(struct rtl_sourceEntry));
+		}
+
+	rtl_glueMutexUnlock();
+
+	return ret;
+}
+
+// free a group entry and link it back to the group entry pool, default is link to the pool head
+static  void rtl_freeSourceEntry(struct rtl_sourceEntry* sourceEntryPtr)
+{
+	if (!sourceEntryPtr)
+	{
+		return;
+	}
+
+	rtl_glueMutexLock();
+		sourceEntryPtr->next = rtl_sourceEntryPool;
+		if(rtl_sourceEntryPool!=NULL)
+		{
+			rtl_sourceEntryPool->previous=sourceEntryPtr;
+		}
+
+		rtl_sourceEntryPool=sourceEntryPtr;
+
+	rtl_glueMutexUnlock();
+}
+
+
+
+/*********************************************
+			Group list operation
+ *********************************************/
+
+/*       find a group address in a group list    */
+
+struct rtl_groupEntry* rtl_searchGroupEntry(uint32 moduleIndex, uint32 ipVersion,uint32 *multicastAddr)
+{
+	struct rtl_groupEntry* groupPtr = NULL;
+	int32 hashIndex;
+	if(ipVersion==IP_VERSION4)
+	{
+		hashIndex=rtl_hashMask&multicastAddr[0];
+		groupPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[hashIndex];
+
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+		hashIndex=rtl_hashMask&multicastAddr[3];
+		groupPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[hashIndex];
+	}
+#endif
+
+	while (groupPtr!=NULL)
+	{
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		if(ipVersion==IP_VERSION4)
+		{
+			if((multicastAddr[0]==groupPtr->groupAddr[0]) && (groupPtr->ipVersion==IP_VERSION4))
+			{
+				return groupPtr;
+			}
+		}
+
+		if(ipVersion==IP_VERSION6)
+		{
+			if(	(multicastAddr[0]==groupPtr->groupAddr[0])&&
+				(multicastAddr[1]==groupPtr->groupAddr[1])&&
+				(multicastAddr[2]==groupPtr->groupAddr[2])&&
+				(multicastAddr[3]==groupPtr->groupAddr[3])
+			)
+			{
+				return groupPtr;
+
+			}
+		}
+#else
+	if(ipVersion==IP_VERSION4)
+	{
+		if(multicastAddr[0]==groupPtr->groupAddr[0])
+		{
+			return groupPtr;
+		}
+	}
+#endif
+		groupPtr = groupPtr->next;
+
+	}
+
+	return NULL;
+}
+
+
+/* link group Entry in the front of a group list */
+static void  rtl_linkGroupEntry(struct rtl_groupEntry* groupEntry ,  struct rtl_groupEntry ** hashTable, uint32 hashIndex)
+{
+	rtl_glueMutexLock();//Lock resource
+	if(NULL==groupEntry)
+	{
+		return;
+	}
+	else
+	{
+		if(hashTable[hashIndex]!=NULL)
+		{
+			hashTable[hashIndex]->previous=groupEntry;
+		}
+		groupEntry->next = hashTable[hashIndex];
+		hashTable[hashIndex]=groupEntry;
+		hashTable[hashIndex]->previous=NULL;
+
+	}
+	rtl_glueMutexUnlock();//UnLock resource
+
+}
+
+
+/* unlink a group entry from group list */
+static void rtl_unlinkGroupEntry(struct rtl_groupEntry* groupEntry,  struct rtl_groupEntry ** hashTable, uint32 hashIndex)
+{
+	if(NULL==groupEntry)
+	{
+		return;
+	}
+	else
+	{
+		rtl_glueMutexLock();  /* lock resource*/
+		/* unlink entry node*/
+		if(groupEntry==hashTable[hashIndex]) /*unlink group list head*/
+		{
+			hashTable[hashIndex]=groupEntry->next;
+			if(hashTable[hashIndex]!=NULL)
+			{
+				hashTable[hashIndex]->previous=NULL;
+			}
+
+			groupEntry->previous=NULL;
+			groupEntry->next=NULL;
+		}
+		else
+		{
+			if(groupEntry->previous!=NULL)
+			{
+				groupEntry->previous->next=groupEntry->next;
+			}
+
+			if(groupEntry->next!=NULL)
+			{
+				groupEntry->next->previous=groupEntry->previous;
+			}
+			groupEntry->previous=NULL;
+			groupEntry->next=NULL;
+		}
+
+		rtl_glueMutexUnlock();//UnLock resource
+	}
+}
+
+
+/* clear the content of group entry */
+static void rtl_clearGroupEntry(struct rtl_groupEntry* groupEntry)
+{
+	rtl_glueMutexLock();
+	if (NULL!=groupEntry)
+	{
+		memset(groupEntry, 0, sizeof(struct rtl_groupEntry));
+	}
+	rtl_glueMutexUnlock();
+}
+
+static void rtl_deleteSourceList(struct rtl_groupEntry* groupEntry)
+{
+	struct rtl_sourceEntry *sourceEntry=groupEntry->sourceList;
+	struct rtl_sourceEntry *nextSourceEntry=NULL;
+	while(sourceEntry!=NULL)
+	{
+		nextSourceEntry=sourceEntry->next;
+		rtl_deleteSourceEntry(groupEntry,sourceEntry);
+		sourceEntry=nextSourceEntry;
+	}
+}
+
+static void rtl_deleteGroupEntry( struct rtl_groupEntry* groupEntry,struct rtl_groupEntry ** hashTable)
+{
+	if(groupEntry!=NULL)
+	{
+
+		if(groupEntry->ipVersion==IP_VERSION4)
+		{
+			rtl_deleteSourceList(groupEntry);
+			rtl_unlinkGroupEntry(groupEntry, hashTable,(groupEntry->groupAddr[0]&rtl_hashMask));
+			rtl_clearGroupEntry(groupEntry);
+			rtl_freeGroupEntry(groupEntry);
+		}
+		else
+		{
+			rtl_deleteSourceList(groupEntry);
+			rtl_unlinkGroupEntry(groupEntry, hashTable,(groupEntry->groupAddr[3]&rtl_hashMask));
+			rtl_clearGroupEntry(groupEntry);
+			rtl_freeGroupEntry(groupEntry);
+		}
+	}
+
+}
+
+static struct rtl_sourceEntry* rtl_searchSourceEntry(uint32 ipVersion, uint32 *sourceAddr, struct rtl_groupEntry *groupEntry)
+{
+	struct rtl_sourceEntry *sourcePtr=groupEntry->sourceList;
+	while(sourcePtr!=NULL)
+	{
+		if(ipVersion==IP_VERSION4)
+		{
+			if(sourceAddr[0]==sourcePtr->sourceAddr[0])
+			{
+				return sourcePtr;
+			}
+		}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		if(ipVersion==IP_VERSION6)
+		{
+			if(	(sourceAddr[0]==sourcePtr->sourceAddr[0]) &&
+				(sourceAddr[1]==sourcePtr->sourceAddr[1])&&
+				(sourceAddr[2]==sourcePtr->sourceAddr[2])&&
+				(sourceAddr[3]==sourcePtr->sourceAddr[3])
+			)
+			{
+				return sourcePtr;
+
+			}
+		}
+#endif
+		sourcePtr=sourcePtr->next;
+	}
+
+	return NULL;
+}
+
+static int32 rtl_searchSourceAddr(uint32 ipVersion, uint32 *sourceAddr, uint32 *sourceArray, uint32 elementCount)
+{
+	uint32 i=0;
+	uint32 *srcPtr=sourceArray;
+
+	for(i=0; i<elementCount; i++)
+	{
+		if(ipVersion==IP_VERSION4)
+		{
+			if(sourceAddr[0]==srcPtr[0])
+			{
+				return TRUE;
+			}
+			srcPtr++;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		if(ipVersion==IP_VERSION6)
+		{
+			if(	(sourceAddr[0]==srcPtr[0])&&\
+				(sourceAddr[1]==srcPtr[1])&&\
+				(sourceAddr[2]==srcPtr[2])&&\
+				(sourceAddr[3]==srcPtr[3]))
+			{
+
+				return TRUE;
+			}
+
+			srcPtr=srcPtr+4;
+		}
+#endif
+	}
+
+	return FALSE;
+}
+
+static void rtl_linkSourceEntry(struct rtl_groupEntry *groupEntry,  struct rtl_sourceEntry* entryNode)
+{
+	if((NULL==entryNode) || (NULL==groupEntry))
+	{
+		return;
+	}
+	else
+	{
+		rtl_glueMutexLock();  /* lock resource*/
+
+		if(groupEntry->sourceList!=NULL)
+		{
+			groupEntry->sourceList->previous=entryNode;
+		}
+		entryNode->next=groupEntry->sourceList;
+		groupEntry->sourceList=entryNode;
+		groupEntry->sourceList->previous=NULL;
+
+		rtl_glueMutexUnlock();  /* lock resource*/
+	}
+}
+
+static void rtl_unlinkSourceEntry(struct rtl_groupEntry *groupEntry, struct rtl_sourceEntry* sourceEntry)
+{
+
+	if((NULL==sourceEntry) ||(NULL==groupEntry))
+	{
+		return;
+	}
+	else
+	{
+		rtl_glueMutexLock();  /* lock resource*/
+		/* unlink entry node*/
+		if(sourceEntry==groupEntry->sourceList) /*unlink group list head*/
+		{
+
+			groupEntry->sourceList=sourceEntry->next;
+			if(groupEntry->sourceList!=NULL)
+			{
+				groupEntry->sourceList ->previous=NULL;
+			}
+
+			sourceEntry->previous=NULL;
+			sourceEntry->next=NULL;
+		}
+		else
+		{
+			if(sourceEntry->previous!=NULL)
+			{
+				sourceEntry->previous->next=sourceEntry->next;
+			}
+
+			if(sourceEntry->next!=NULL)
+			{
+				sourceEntry->next->previous=sourceEntry->previous;
+			}
+			sourceEntry->previous=NULL;
+			sourceEntry->next=NULL;
+		}
+
+		rtl_glueMutexUnlock();//UnLock resource
+	}
+
+
+}
+
+static void rtl_clearSourceEntry(struct rtl_sourceEntry* sourceEntryPtr)
+{
+	rtl_glueMutexLock();
+	if (NULL!=sourceEntryPtr)
+	{
+		memset(sourceEntryPtr, 0, sizeof(struct rtl_sourceEntry));
+	}
+	rtl_glueMutexUnlock();
+}
+
+
+static void rtl_deleteSourceEntry(struct rtl_groupEntry *groupEntry, struct rtl_sourceEntry* sourceEntry)
+{
+	if(sourceEntry!=NULL)
+	{
+		rtl_unlinkSourceEntry(groupEntry,sourceEntry);
+		rtl_clearSourceEntry(sourceEntry);
+		rtl_freeSourceEntry(sourceEntry);
+	}
+}
+
+#if 0
+static int32 rtl_checkPortMask(uint8 pktPortMask)
+{
+	int32 i=0;
+	uint8 portMaskn=PORT0_MASK;
+	uint8 count=0;
+	for(i=0; i<MAX_SUPPORT_PORT_NUMBER; i++)
+	{
+		if(portMaskn&pktPortMask)
+		{
+			count++;
+		}
+		portMaskn=portMaskn<<1;
+	}
+
+	if(count==1)
+	{
+		return SUCCESS;
+	}
+	else
+	{
+		return FAILED;
+	}
+}
+
+static uint32 rtl_mapPortMaskToPortNum(uint8 portMask)
+{
+	int i;
+	for(i=0; i<MAX_SUPPORT_PORT_NUMBER; i++)
+	{
+		if((portMask&(1<<i))!=0)
+		{
+			return i;
+		}
+	}
+
+	return 0xFFFFFFFF;
+}
+
+
+static int32 rtl_mapMCastIPToMAC(uint32 ipVersion, uint32 *ipAddr, uint8 *macAddr )
+{
+	if(ipVersion==IP_VERSION6)
+	{
+		if(IS_IPV6_MULTICAST_ADDRESS(ipAddr))
+		{
+			macAddr[0]=0x33;
+			macAddr[1]=0x33;
+			macAddr[2]=(ipAddr[3]&0xff000000)>>24;
+			macAddr[3]=(ipAddr[3]&0x00ff0000)>>16;
+			macAddr[4]=(ipAddr[3]&0x0000ff00)>>8;
+			macAddr[5]= ipAddr[3]&0x000000ff;
+			return SUCCESS;
+		}
+		else
+		{
+			return FAILED;
+		}
+	}
+
+	if(ipVersion==IP_VERSION4)
+	{
+		if(IS_IPV4_MULTICAST_ADDRESS(ipAddr))
+		{
+			macAddr[0]=0x01;
+			macAddr[1]=0x00;
+			macAddr[2]=0x5e;
+			macAddr[3]=(ipAddr[0]&0x007f0000)>>16;
+			macAddr[4]=(ipAddr[0]&0x0000ff00)>>8;
+			macAddr[5]= ipAddr[0]&0x000000ff;
+			return SUCCESS;
+		}
+		else
+		{
+			return FAILED;
+		}
+	}
+
+	return FAILED;
+}
+#endif
+
+static int32 rtl_checkMCastAddrMapping(uint32 ipVersion, uint32 *ipAddr, uint8* macAddr)
+{
+	if(ipVersion==IP_VERSION4)
+	{
+		if(macAddr[0]!=0x01)
+		{
+			return FALSE;
+		}
+
+		if((macAddr[3]&0x7f)!=(uint8)((ipAddr[0]&0x007f0000)>>16))
+		{
+			return FALSE;
+		}
+
+		if(macAddr[4]!=(uint8)((ipAddr[0]&0x0000ff00)>>8))
+		{
+			return FALSE;
+		}
+
+		if(macAddr[5]!=(uint8)(ipAddr[0]&0x000000ff))
+		{
+			return FALSE;
+		}
+
+		return TRUE;
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+		if(macAddr[0]!=0x33)
+		{
+			return FALSE;
+		}
+
+		if(macAddr[1]!=0x33)
+		{
+			return FALSE;
+		}
+
+		if(macAddr[2]!=(uint8)((ipAddr[3]&0xff000000)>>24))
+		{
+			return FALSE;
+		}
+
+		if(macAddr[3]!=(uint8)((ipAddr[3]&0x00ff0000)>>16))
+		{
+			return FALSE;
+		}
+
+		if(macAddr[4]!=(uint8)((ipAddr[3]&0x0000ff00)>>8))
+		{
+			return FALSE;
+		}
+
+		if(macAddr[5]!=(uint8)(ipAddr[3]&0x000000ff))
+		{
+			return FALSE;
+		}
+
+		return TRUE;
+	}
+#endif
+	return FALSE;
+}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+static int32 rtl_compareIpv6Addr(uint32* ipv6Addr1, uint32* ipv6Addr2)
+{
+	int i;
+	for(i=0; i<4; i++)
+	{
+		if(ipv6Addr1[i]!=ipv6Addr2[i])
+		{
+			return FALSE;
+		}
+	}
+
+	return TRUE;
+}
+#endif
+
+static int32 rtl_compareMacAddr(uint8* macAddr1, uint8* macAddr2)
+{
+	int i;
+	for(i=0; i<6; i++)
+	{
+		if(macAddr1[i]!=macAddr2[i])
+		{
+			return FALSE;
+		}
+	}
+	return TRUE;
+}
+
+static uint16 rtl_checksum(uint8 *packetBuf, uint32 packetLen)
+{
+	/*note: the first bytes of  packetBuf should be two bytes aligned*/
+	uint32  checksum=0;
+	uint32 count=packetLen;
+	uint16   *ptr= (uint16 *) (packetBuf);
+
+	 while(count>1)
+	 {
+		  checksum+= ntohs(*ptr);
+		  ptr++;
+		  count -= 2;
+	 }
+
+	if(count>0)
+	{
+		checksum+= *(packetBuf+packetLen-1)<<8; /*the last odd byte is treated as bit 15~8 of unsigned short*/
+	}
+
+	/* Roll over carry bits */
+	checksum = (checksum >> 16) + (checksum & 0xffff);
+	checksum += (checksum >> 16);
+
+	/* Return checksum */
+	return ((uint16) ~ checksum);
+
+}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+static uint16 rtl_ipv6L3Checksum(uint8 *pktBuf, uint32 pktLen, union pseudoHeader *ipv6PseudoHdr)
+{
+	uint32  checksum=0;
+	uint32 count=pktLen;
+	uint16   *ptr;
+
+	/*compute ipv6 pseudo-header checksum*/
+	ptr= (uint16 *) (ipv6PseudoHdr);
+	for(count=0; count<20; count++) /*the pseudo header is 40 bytes long*/
+	{
+		  checksum+= ntohs(*ptr);
+		  ptr++;
+	}
+
+	/*compute the checksum of mld buffer*/
+	 count=pktLen;
+	 ptr=(uint16 *) (pktBuf);
+	 while(count>1)
+	 {
+		  checksum+= ntohs(*ptr);
+		  ptr++;
+		  count -= 2;
+	 }
+
+	if(count>0)
+	{
+		checksum+= *(pktBuf+pktLen-1)<<8; /*the last odd byte is treated as bit 15~8 of unsigned short*/
+	}
+
+	/* Roll over carry bits */
+	checksum = (checksum >> 16) + (checksum & 0xffff);
+	checksum += (checksum >> 16);
+
+	/* Return checksum */
+	return ((uint16) ~ checksum);
+
+}
+#endif
+
+static uint32 rtl_getGroupFwdPortMask(struct rtl_groupEntry * groupEntry, uint32 enableSourceList, uint32 sysTime)
+{
+	int i;
+	uint32 portMaskn=PORT0_MASK;
+	uint32 fwdPortMask=0;
+	struct rtl_sourceEntry * sourcePtr=NULL;;
+
+	for(i=0; i<MAX_SUPPORT_PORT_NUMBER; i++)
+	{
+		if(enableSourceList==TRUE)
+		{
+			if(groupEntry->groupFilterTimer[i]>sysTime) /*exclude mode never expired*/
+			{
+				fwdPortMask|=portMaskn;
+			}
+			else/*include mode*/
+			{
+				sourcePtr=groupEntry->sourceList;
+				while(sourcePtr!=NULL)
+				{
+					if(sourcePtr->portTimer[i]>sysTime)
+					{
+						fwdPortMask|=portMaskn;
+						break;
+					}
+				 	else
+					{
+						sourcePtr=sourcePtr->next;
+				 	}
+
+				}
+
+			}
+		}
+		else
+		{
+			if(groupEntry->groupFilterTimer[i]>sysTime) /*exclude mode never expired*/
+			{
+				fwdPortMask|=portMaskn;
+			}
+		}
+		portMaskn=portMaskn<<1;
+	}
+
+
+	return fwdPortMask;
+}
+
+
+
+static void rtl_checkSourceTimer(struct rtl_groupEntry * groupEntry , struct rtl_sourceEntry * sourceEntry)
+{
+	int i=0;
+
+	uint32 portMaskn=PORT0_MASK;
+	uint32 deletePortMask=0;
+	for(i=0; i<MAX_SUPPORT_PORT_NUMBER; i++)
+	{
+
+		if(sourceEntry->portTimer[i]==0)/*means not exist*/
+		{
+			deletePortMask|=portMaskn;
+		}
+		else
+		{
+			if(sourceEntry->portTimer[i]<=rtl_sysUpSeconds) /*means time out*/
+			{
+				if(groupEntry->groupFilterTimer[i]<=rtl_sysUpSeconds) /*means include mode*/
+				{
+					sourceEntry->portTimer[i]=0;
+					deletePortMask|=portMaskn;
+				}
+
+			}
+		}
+
+		portMaskn=portMaskn<<1;
+	}
+
+	if(deletePortMask==((1<<MAX_SUPPORT_PORT_NUMBER)-1)) /*means all port  are INCLUDE mode and expired*/
+	{
+		rtl_deleteSourceEntry(groupEntry,sourceEntry);
+	}
+
+
+}
+
+static uint32 rtl_getSourceFwdPortMask(struct rtl_groupEntry * groupEntry,uint32 *sourceAddr, uint32 sysTime)
+{
+	int i;
+	uint32 portMaskn=PORT0_MASK;
+	uint32 fwdPortMask=0;
+	struct rtl_sourceEntry * sourceEntry=NULL;
+	if(groupEntry==NULL)
+	{
+		return 0xFFFFFFFF; /*broadcast*/
+	}
+	else
+	{
+		sourceEntry=rtl_searchSourceEntry((uint32)(groupEntry->ipVersion),sourceAddr, groupEntry);
+		for(i=0; i<MAX_SUPPORT_PORT_NUMBER; i++)
+		{
+
+			if(groupEntry->groupFilterTimer[i]<=sysTime)	/*include mode*/
+			{
+				if(sourceEntry!=NULL)
+				{
+					if( sourceEntry->portTimer[i]>sysTime)
+					{
+						fwdPortMask|=portMaskn;
+					}
+				}
+			}
+			else/*exclude mode*/
+			{
+				if(sourceEntry==NULL)
+				{
+					fwdPortMask|=portMaskn;
+				}
+				else
+				{
+					if((sourceEntry->portTimer[i]>sysTime) || (sourceEntry->portTimer[i]==0))
+					{
+						fwdPortMask|=portMaskn;
+					}
+				}
+			}
+
+			portMaskn=portMaskn<<1;
+		}
+		return fwdPortMask;
+
+	}
+}
+
+
+
+
+static void rtl_checkGroupEntryTimer(struct rtl_groupEntry * groupEntry, uint32 enableSourceList, struct rtl_groupEntry ** hashTable)
+{
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	uint32 oldFwdPortMask=0;
+	uint32 tmpFwdPortMask=0;
+	#endif
+
+	uint32 newFwdPortMask=0;
+	struct rtl_sourceEntry *sourceEntry=groupEntry->sourceList;
+	struct rtl_sourceEntry *nextSourceEntry=NULL;
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	oldFwdPortMask=rtl_getGroupFwdPortMask(groupEntry, enableSourceList, rtl_sysUpSeconds?(rtl_sysUpSeconds-1):0);
+	#endif
+
+	while(sourceEntry!=NULL)
+	{
+		nextSourceEntry=sourceEntry->next;
+		#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		timerEventContext.sourceAddr[0]=sourceEntry->sourceAddr[0];
+		#endif
+		rtl_checkSourceTimer(groupEntry, sourceEntry);
+		sourceEntry=nextSourceEntry;
+	}
+
+	newFwdPortMask=rtl_getGroupFwdPortMask(groupEntry, enableSourceList, rtl_sysUpSeconds);
+
+
+	if(newFwdPortMask==0) /*none active port*/
+	{
+		rtl_deleteGroupEntry(groupEntry,hashTable);
+	}
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if((oldFwdPortMask!=newFwdPortMask) ||(newFwdPortMask==0))
+	{
+		timerEventContext.sourceAddr[0]=0;
+
+		tmpFwdPortMask=oldFwdPortMask&(~newFwdPortMask);
+		if(tmpFwdPortMask==0)
+		{
+			tmpFwdPortMask=newFwdPortMask & (~oldFwdPortMask);
+		}
+
+#ifdef CONFIG_PROC_FS
+		rtl_mCastModuleArray[timerEventContext.moduleIndex].expireEventCnt++;
+#endif
+		timerEventContext.portMask=(uint32)tmpFwdPortMask;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &timerEventContext);
+
+	}
+	#endif
+
+}
+
+
+
+static int32 rtl_initHashTable(uint32 moduleIndex, uint32 hashTableSize)
+{
+	uint32 i=0;
+
+	/* Allocate memory */
+	rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable=NULL;
+	rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable = (struct rtl_groupEntry **)rtl_glueMalloc(4 * hashTableSize);
+	if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable!= NULL)
+	{
+		for (i = 0 ; i < hashTableSize ; i++)
+		{
+			rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i]=NULL;
+		}
+
+#ifndef CONFIG_RTL_MLD_SNOOPING
+		return SUCCESS;
+#endif
+
+	}
+	else
+	{
+		if(rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable!=NULL)
+		{
+			rtl_glueFree(rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+
+#ifndef CONFIG_RTL_MLD_SNOOPING
+		return FAILED;
+#endif
+
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable=NULL;
+	rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable=  (struct rtl_groupEntry **)rtl_glueMalloc(4 * hashTableSize);
+	if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable!=NULL)
+	{
+		for (i = 0 ; i < hashTableSize ; i++)
+		{
+
+			rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i]=NULL;
+		}
+		return SUCCESS;
+	}
+	else
+	{
+		if(rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable!=NULL)
+		{
+			rtl_glueFree(rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+		}
+
+		if(rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable!=NULL)
+		{
+			rtl_glueFree(rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+
+		return FAILED;
+
+	}
+#endif
+
+
+}
+
+
+
+/**************************
+	Utility
+**************************/
+static void  rtl_parseMacFrame(uint32 moduleIndex, uint8* macFrame, uint32 verifyCheckSum, struct rtl_macFrameInfo* macInfo)
+{
+
+//MAC Frame :DA(6 bytes)+SA(6 bytes)+ CPU tag(4 bytes) + VlAN tag(Optional, 4 bytes)
+//                   +Type(IPv4:0x0800, IPV6:0x86DD, PPPOE:0x8864, 2 bytes )+Data(46~1500 bytes)+CRC(4 bytes)
+//CPU tag: Realtek Ethertype==0x8899(2 bytes)+protocol==0x9(4 MSB)+priority(2 bits)+reserved(4 bits)+portmask(6 LSB)
+	uint8 *ptr=macFrame;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	int i=0;
+	uint8 nextHeader=0;
+	uint16 extensionHdrLen=0;
+	uint8 routerhead=FALSE;
+	uint8 needchecksum=FALSE;
+
+	uint8 optionDataLen=0;
+	uint8 optionType=0;
+	uint32 ipv6RAO=0;
+#endif
+
+	uint32 ipAddr[4]={0,0,0,0};
+	union pseudoHeader pHeader;
+
+	memset(macInfo,0,sizeof(struct rtl_macFrameInfo));
+	memset(&pHeader, 0, sizeof(union pseudoHeader));
+
+	ptr=ptr+12;
+
+
+	/*check the presence of VLAN tag*/
+	if(*(int16 *)(ptr)==(int16)htons(VLAN_PROTOCOL_ID))
+	{
+		ptr=ptr+4;
+	}
+
+	/*ignore packet with PPPOE header*/
+	if(*(int16 *)(ptr)==(int16)htons(PPPOE_ETHER_TYPE))
+	{
+		return;
+	}
+
+
+	/*check the presence of ipv4 type*/
+	if(*(int16 *)(ptr)==(int16)htons(IPV4_ETHER_TYPE))
+	{
+		ptr=ptr+2;
+		macInfo->ipBuf=ptr;
+		macInfo->ipVersion=IP_VERSION4;
+	}
+	else
+	{
+		/*check the presence of ipv4 type*/
+		if(*(int16 *)(ptr)==(int16)htons(IPV6_ETHER_TYPE))
+		{
+			ptr=ptr+2;
+			macInfo->ipBuf=ptr;
+			macInfo->ipVersion=IP_VERSION6;
+		}
+	}
+
+	if((macInfo->ipVersion!=IP_VERSION4) && (macInfo->ipVersion!=IP_VERSION6))
+	{
+		return;
+	}
+	macInfo->checksumFlag=FAILED;
+
+	if(macInfo->ipVersion==IP_VERSION4)
+	{
+		macInfo->ipHdrLen=(uint16)((((struct ipv4Pkt *)(macInfo->ipBuf))->vhl&0x0f)<<2);
+		macInfo->l3PktLen=ntohs(((struct ipv4Pkt *)(macInfo->ipBuf))->length)-macInfo->ipHdrLen;
+		ptr=ptr+macInfo->ipHdrLen;
+		macInfo->l3PktBuf=ptr;
+		macInfo->macFrameLen=(uint16)((ptr-macFrame)+macInfo->l3PktLen);
+
+/*distinguish different IGMP packet:
+                                                    ip_header_length      destination_ip      igmp_packet_length   igmp_type   group_address
+IGMPv1_general_query:                            20                   224.0.0.1                       8                    0x11                 0
+IGMPv2_general_query:                            24                   224.0.0.1                       8                    0x11                 0
+IGMPv2_group_specific_query:			24                   224.0.0.1                       8                    0x11               !=0
+IGMPv3 _query:                                        24                   224.0.0.1                   >=12                  0x11        according_to_different_situation
+
+IGMPv1_join:                                            20          actual_multicast_address         8                    0x12           actual_multicast_address
+IGMPv2_join:                                            24          actual_multicast_address         8                    0x16           actual_multicast_address
+IGMPv2_leave:                                          24          actual_multicast_address         8                    0x17           actual_multicast_address
+IGMPv3_report:                                         24          actual_multicast_address       >=12                0x22           actual_multicast_address*/
+
+	/* parse IGMP type and version*/
+		if(((struct ipv4Pkt *)(macInfo->ipBuf))->protocol==IGMP_PROTOCOL)
+		{
+			/*check DVMRP*/
+			if((macInfo->l3PktBuf[0]==DVMRP_TYPE) && (((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp==htonl(DVMRP_ADDR)) )
+			{
+				macInfo->l3Protocol=DVMRP_PROTOCOL;
+			}
+			else
+			{
+				/*means unicast*/
+				if((macFrame[0]&0x01)==0)
+				{
+						if(rtl_compareMacAddr(macFrame, rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac)==TRUE)
+				       	{
+								if(((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp==htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv4Addr))
+								{
+									macInfo->l3Protocol=IGMP_PROTOCOL;
+               							goto otherpro;
+								}
+						}
+
+				}
+				else /*means multicast*/
+				{
+					ipAddr[0]=ntohl(((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp);
+					if(rtl_checkMCastAddrMapping(IP_VERSION4,ipAddr,macFrame)==TRUE)
+					{
+						macInfo->l3Protocol=IGMP_PROTOCOL;
+					}
+					else
+					{
+						return;
+					}
+				}
+			}
+
+		}
+
+otherpro:
+			if(((struct ipv4Pkt *)(macInfo->ipBuf))->protocol==MOSPF_PROTOCOL &&\
+			((((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp==htonl(IPV4_MOSPF_ADDR1)) ||\
+			(((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp==htonl(IPV4_MOSPF_ADDR2))))
+		{
+			macInfo->l3Protocol=MOSPF_PROTOCOL;
+		}
+
+		if(((struct ipv4Pkt *)(macInfo->ipBuf))->protocol==PIM_PROTOCOL && (((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp==htonl(IPV4_PIM_ADDR)))
+		{
+			macInfo->l3Protocol=PIM_PROTOCOL;
+		}
+
+		if(verifyCheckSum==TRUE)
+		{
+			if(rtl_checksum(macInfo->l3PktBuf, macInfo->l3PktLen)!=0)
+			{
+				macInfo->checksumFlag=FAILED;
+			}
+			else
+			{
+				macInfo->checksumFlag=SUCCESS;
+			}
+		}
+		else
+		{
+			macInfo->checksumFlag=SUCCESS;
+		}
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(macInfo->ipVersion==IP_VERSION6)
+	{
+		macInfo->macFrameLen=(uint16)(ptr-macFrame+IPV6_HEADER_LENGTH+ntohs(((struct ipv6Pkt *)(macInfo->ipBuf))->payloadLenth));
+		macInfo->ipHdrLen=IPV6_HEADER_LENGTH;
+
+		nextHeader=((struct ipv6Pkt *)(macInfo->ipBuf))->nextHeader;
+		ptr=ptr+IPV6_HEADER_LENGTH;
+		while((ptr-macInfo->ipBuf)<(ntohs(((struct ipv6Pkt *)(macInfo->ipBuf))->payloadLenth)+IPV6_HEADER_LENGTH))
+		{
+			switch(nextHeader)
+			{
+				case HOP_BY_HOP_OPTIONS_HEADER:
+					/*parse hop-by-hop option*/
+					nextHeader=ptr[0];
+					extensionHdrLen=((uint16)(ptr[1])+1)*8;
+					ptr=ptr+2;
+
+					while((ptr-macInfo->ipBuf-40)<extensionHdrLen)
+					{
+						optionType=ptr[0];
+						/*pad1 option*/
+						if(optionType==0)
+						{
+							ptr=ptr+1;
+							continue;
+						}
+
+						/*padN option*/
+						if(optionType==1)
+						{
+							optionDataLen=ptr[1];
+							ptr=ptr+optionDataLen+2;
+							continue;
+						}
+
+						/*router alter option*/
+						if(ntohl(*(uint32 *)(ptr))==IPV6_ROUTER_ALTER_OPTION)
+						{
+							ipv6RAO=IPV6_ROUTER_ALTER_OPTION;
+							ptr=ptr+4;
+							continue;
+						}
+
+						/*other TLV option*/
+						if((optionType!=0) && (optionType!=1))
+						{
+							optionDataLen=ptr[1];
+							ptr=ptr+optionDataLen+2;
+							continue;
+						}
+
+
+					}
+					/*
+					if((ptr-macInfo->ipBuf-40)!=extensionHdrLen)
+					{
+						rtl_gluePrintf("ipv6 packet parse error\n");
+					}*/
+
+				break;
+
+				case ROUTING_HEADER:
+					nextHeader=ptr[0];
+					extensionHdrLen=((uint16)(ptr[1])+1)*8;
+
+
+					 if (ptr[3]>0)
+				   	{
+                                          ptr=ptr+extensionHdrLen;
+						for(i=0; i<4; i++)
+						{
+						      pHeader.ipv6_pHdr.destinationAddr[i]=*((uint32 *)(ptr)-4+i);
+
+						}
+					     routerhead=TRUE;
+
+
+					}
+					else
+					{
+                                          ptr=ptr+extensionHdrLen;
+					}
+
+
+
+				break;
+
+				case FRAGMENT_HEADER:
+					nextHeader=ptr[0];
+					ptr=ptr+8;
+				break;
+
+				case DESTINATION_OPTION_HEADER:
+					nextHeader=ptr[0];
+					extensionHdrLen=((uint16)(ptr[1])+1)*8;
+					ptr=ptr+extensionHdrLen;
+				break;
+
+				case ICMP_PROTOCOL:
+					nextHeader=NO_NEXT_HEADER;
+					macInfo->l3PktLen=ntohs(((struct ipv6Pkt *)(macInfo->ipBuf))->payloadLenth)-(uint16)(ptr-macInfo->ipBuf-IPV6_HEADER_LENGTH);
+					macInfo->l3PktBuf=ptr;
+					if((ptr[0]==MLD_QUERY) ||(ptr[0]==MLDV1_REPORT) ||(ptr[0]==MLDV1_DONE) ||(ptr[0]==MLDV2_REPORT))
+					{
+						/*means multicast*/
+						if(	(macFrame[0]==0x33)&&\
+							(macFrame[1]==0x33))
+						{
+							ipAddr[0]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[0]);
+							ipAddr[1]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[1]);
+							ipAddr[2]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[2]);
+							ipAddr[3]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[3]);
+
+							if(rtl_checkMCastAddrMapping(IP_VERSION6, ipAddr, macFrame)==TRUE)
+							{
+								macInfo->l3Protocol=ICMP_PROTOCOL;
+							}
+
+						}
+						else /*means multicast*/
+						{
+
+								ipAddr[0]=htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[0]);
+								ipAddr[1]=htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[1]);
+								ipAddr[2]=htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[2]);
+								ipAddr[3]=htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[3]);
+								if(	(rtl_compareMacAddr(macFrame, rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac)==TRUE) &&\
+								(rtl_compareIpv6Addr(((struct ipv6Pkt *)macInfo->ipBuf)->destinationAddr, ipAddr) == TRUE))
+								{
+									macInfo->l3Protocol=ICMP_PROTOCOL;
+								}
+
+
+						}
+
+						needchecksum=TRUE;
+						/*
+						if(ipv6RAO!=IPV6_ROUTER_ALTER_OPTION)
+						{
+							rtl_gluePrintf("router alter option error\n");
+						}*/
+					}
+
+
+				break;
+
+				case PIM_PROTOCOL:
+					nextHeader=NO_NEXT_HEADER;
+					macInfo->l3PktLen=ntohs(((struct ipv6Pkt *)(macInfo->ipBuf))->payloadLenth)-(uint16)(ptr-macInfo->ipBuf-IPV6_HEADER_LENGTH);
+					macInfo->l3PktBuf=ptr;
+
+					ipAddr[0]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[0]);
+					ipAddr[1]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[1]);
+					ipAddr[2]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[2]);
+					ipAddr[3]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[3]);
+					if(IS_IPV6_PIM_ADDR(ipAddr))
+					{
+						macInfo->l3Protocol=PIM_PROTOCOL;
+					}
+					needchecksum=TRUE;
+
+				break;
+
+				case MOSPF_PROTOCOL:
+					nextHeader=NO_NEXT_HEADER;
+					macInfo->l3PktLen=ntohs(((struct ipv6Pkt *)(macInfo->ipBuf))->payloadLenth)-(uint16)(ptr-macInfo->ipBuf-IPV6_HEADER_LENGTH);
+					macInfo->l3PktBuf=ptr;
+
+					ipAddr[0]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[0]);
+					ipAddr[1]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[1]);
+					ipAddr[2]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[2]);
+					ipAddr[3]=ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[3]);
+
+					if(IS_IPV6_MOSPF_ADDR1(ipAddr) || IS_IPV6_MOSPF_ADDR2(ipAddr))
+					{
+						macInfo->l3Protocol=MOSPF_PROTOCOL;
+					}
+					needchecksum=TRUE;
+				break;
+
+				default:
+					goto out;
+				break;
+			}
+
+		}
+
+out:
+		/*compute pseudo header*/
+             if(needchecksum==TRUE)
+             	{
+		       for(i=0; i<4; i++)
+		      {
+			     pHeader.ipv6_pHdr.sourceAddr[i]=((struct ipv6Pkt *)(macInfo->ipBuf))->sourceAddr[i];
+
+		       }
+
+		      if(routerhead==FALSE)
+		      {
+		             for(i=0;i<4;i++)
+		      	      {
+			            pHeader.ipv6_pHdr.destinationAddr[i]=((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[i];
+		      	      }
+		       }
+
+
+		       pHeader.ipv6_pHdr.nextHeader=macInfo->l3Protocol;
+		       pHeader.ipv6_pHdr.upperLayerPacketLength=htonl((uint32)(macInfo->l3PktLen));
+		       pHeader.ipv6_pHdr.zeroData[0]=0;
+		       pHeader.ipv6_pHdr.zeroData[1]=0;
+		       pHeader.ipv6_pHdr.zeroData[2]=0;
+
+		       if(macInfo->l3PktBuf!=NULL)
+		       {
+		       	if(verifyCheckSum==TRUE)
+		       	{
+				      if(rtl_ipv6L3Checksum(macInfo->l3PktBuf, macInfo->l3PktLen,&pHeader)!=0)
+				      {
+					      macInfo->checksumFlag=FAILED;
+				       }
+				       else
+				       {
+					      macInfo->checksumFlag=SUCCESS;
+				       }
+		       	}
+				else
+				{
+					macInfo->checksumFlag=FAILED;
+				}
+		       }
+             	}
+	}
+#endif
+	return;
+}
+
+
+static uint32  rtl_getMulticastRouterPortMask(uint32 moduleIndex, uint32 ipVersion, uint32 sysTime)
+{
+	uint32 portIndex=0;
+	uint32 portMaskn=PORT0_MASK;
+	uint32 routerPortmask=0;
+
+	if(ipVersion==IP_VERSION4)
+	{
+		for(portIndex=0; portIndex<MAX_SUPPORT_PORT_NUMBER; portIndex++)
+		{
+			if(rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.querier.portTimer[portIndex]>sysTime)
+			{
+				routerPortmask=routerPortmask|portMaskn;
+			}
+
+			if(rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.dvmrpRouter.portTimer[portIndex]>sysTime)
+			{
+				routerPortmask=routerPortmask|portMaskn;
+			}
+
+
+			if(rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.mospfRouter.portTimer[portIndex]>sysTime)
+			{
+				routerPortmask=routerPortmask|portMaskn;
+			}
+
+
+			if(rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.pimRouter.portTimer[portIndex]>sysTime)
+			{
+				routerPortmask=routerPortmask|portMaskn;
+			}
+
+			portMaskn=portMaskn<<1;  /*shift to next port mask*/
+
+		}
+
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+		for(portIndex=0; portIndex<MAX_SUPPORT_PORT_NUMBER; portIndex++)
+		{
+			if(rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.querier.portTimer[portIndex]>sysTime)
+			{
+
+				routerPortmask=routerPortmask|portMaskn;
+			}
+
+			if(rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.mospfRouter.portTimer[portIndex]>sysTime)
+			{
+				routerPortmask=routerPortmask|portMaskn;
+			}
+
+			if(rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.pimRouter.portTimer[portIndex]>sysTime)
+			{
+				routerPortmask=routerPortmask|portMaskn;
+			}
+
+			portMaskn=portMaskn<<1;  /*shift to next port mask*/
+
+		}
+
+	}
+#endif
+
+	routerPortmask= routerPortmask |rtl_mCastModuleArray[moduleIndex].staticRouterPortMask;
+
+	return routerPortmask;
+}
+
+static uint32 rtl_processQueries(uint32 moduleIndex,uint32 ipVersion, uint32 portNum, uint8* pktBuf, uint32 pktLen)
+{
+	struct rtl_groupEntry *groupEntry=NULL;
+	struct rtl_sourceEntry*sourceEntry=NULL;
+	uint32 timerIndex=0;
+	uint32 hashIndex=0;
+	uint32 groupAddress[4]={0,0,0,0};
+	uint32 suppressFlag=0;
+	uint32 *sourceAddr=NULL;
+	uint32 numOfSrc=0;
+	uint32 i=0;
+
+	/*querier timer update and election process*/
+	rtl_snoopQuerier(moduleIndex, ipVersion, portNum);
+
+	if(ipVersion==IP_VERSION4)
+	{
+		if(pktLen>=12) /*means igmpv3 query*/
+		{
+			groupAddress[0]=ntohl(((struct igmpv3Query*)pktBuf)->groupAddr);
+			suppressFlag=((struct igmpv3Query*)pktBuf)->rsq & S_FLAG_MASK;
+			sourceAddr=&(((struct igmpv3Query*)pktBuf)->srcList);
+			numOfSrc=(uint32)ntohs(((struct igmpv3Query*)pktBuf)->numOfSrc);
+
+		}
+		else
+		{
+			groupAddress[0]=ntohl(((struct igmpv2Pkt *)pktBuf)->groupAddr);
+		}
+
+		if(groupAddress[0]==0) /*means general query*/
+		{
+			goto out;
+		}
+		else
+		{
+			hashIndex=groupAddress[0]&rtl_hashMask;
+		}
+
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+		if(pktLen>=28) /*means mldv2 query*/
+		{
+			groupAddress[0]=ntohl(((struct mldv2Query*)pktBuf)->mCastAddr[0]);
+			groupAddress[1]=ntohl(((struct mldv2Query*)pktBuf)->mCastAddr[1]);
+			groupAddress[2]=ntohl(((struct mldv2Query*)pktBuf)->mCastAddr[2]);
+			groupAddress[3]=ntohl(((struct mldv2Query*)pktBuf)->mCastAddr[3]);
+
+			suppressFlag=((struct mldv2Query*)pktBuf)->rsq & S_FLAG_MASK;
+			sourceAddr=&(((struct mldv2Query*)pktBuf)->srcList);
+			numOfSrc=(uint32)ntohs(((struct mldv2Query*)pktBuf)->numOfSrc);
+
+		}
+		else /*means mldv1 query*/
+		{
+			groupAddress[0]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[0]);
+			groupAddress[1]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[1]);
+			groupAddress[2]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[2]);
+			groupAddress[3]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[3]);
+
+		}
+
+		if(	(groupAddress[0]==0) &&
+			(groupAddress[1]==0) &&
+			(groupAddress[2]==0) &&
+			(groupAddress[3]==0) )/*means general query*/
+		{
+			goto out;
+		}
+		else
+		{
+			hashIndex=groupAddress[3]&rtl_hashMask;
+		}
+	}
+#endif
+	if(suppressFlag==0)
+	{
+
+		groupEntry=rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+		if((groupEntry!=NULL))
+		{
+			if(numOfSrc==0) /*means group specific query*/
+			{
+				for(timerIndex=0; timerIndex<MAX_SUPPORT_PORT_NUMBER; timerIndex++)
+				{
+					if(groupEntry->groupFilterTimer[timerIndex]>(rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime))
+					{
+						groupEntry->groupFilterTimer[timerIndex]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+					}
+
+				}
+			}
+			else /*means group and source specific query*/
+			{
+				if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+				{
+					for(i=0; i<numOfSrc; i++)
+					{
+
+						sourceEntry=rtl_searchSourceEntry(ipVersion, sourceAddr, groupEntry);
+
+						if(sourceEntry!=NULL)
+						{
+							for(timerIndex=0; timerIndex<MAX_SUPPORT_PORT_NUMBER; timerIndex++)
+							{
+								if(sourceEntry->portTimer[timerIndex]>(rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime))
+								{
+									sourceEntry->portTimer[timerIndex]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+								}
+							}
+						}
+
+						if(ipVersion==IP_VERSION4)
+						{
+							sourceAddr++;
+						}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+						if(ipVersion==IP_VERSION6)
+						{
+							sourceAddr=sourceAddr+4;
+						}
+#endif
+					}
+				}
+			}
+		}
+
+
+	}
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=groupAddress[0];
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+out:
+	return (~(1<<portNum) & ((1<<MAX_SUPPORT_PORT_NUMBER)-1));
+}
+
+
+static void rtl_snoopQuerier(uint32 moduleIndex, uint32 ipVersion, uint32 portNum)
+{
+
+	if(ipVersion==IP_VERSION4)
+	{
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.querier.portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.querierPresentInterval;/*update timer value*/
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.querier.portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.querierPresentInterval;/*update timer value*/
+	}
+#endif
+	return;
+}
+
+
+/*Process Report Packet*/
+static  uint32 rtl_processJoin(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf)
+{
+
+
+	uint32 groupAddress[4]={0, 0, 0, 0};
+	struct rtl_groupEntry* groupEntry=NULL;
+	struct rtl_groupEntry* newGroupEntry=NULL;
+	struct rtl_sourceEntry *sourceEntry=NULL;
+
+	uint32 hashIndex=0;
+
+	uint32 multicastRouterPortMask=rtl_getMulticastRouterPortMask(moduleIndex, ipVersion, rtl_sysUpSeconds);
+
+	if(ipVersion==IP_VERSION4)
+	{
+		if(pktBuf[0]==0x12)
+		{
+			groupAddress[0]=ntohl(((struct igmpv1Pkt *)pktBuf)->groupAddr);
+		}
+
+		if(pktBuf[0]==0x16)
+		{
+			groupAddress[0]=ntohl(((struct igmpv2Pkt *)pktBuf)->groupAddr);
+		}
+
+		hashIndex=groupAddress[0]&rtl_hashMask;
+
+	}
+
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+
+		groupAddress[0]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[0]);
+		groupAddress[1]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[1]);
+		groupAddress[2]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[2]);
+		groupAddress[3]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[3]);
+
+		hashIndex=groupAddress[3]&rtl_hashMask;
+	}
+#endif
+
+	groupEntry=rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+	if(groupEntry==NULL)   /*means new group address, create new group entry*/
+	{
+		newGroupEntry=rtl_allocateGroupEntry();
+		if(newGroupEntry==NULL)
+		{
+			rtl_gluePrintf("run out of group entry!\n");
+			goto out;
+		}
+		else
+		{
+			/*set new multicast entry*/
+			#ifdef CONFIG_RTL_MLD_SNOOPING
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+			newGroupEntry->groupAddr[1]=groupAddress[1];
+			newGroupEntry->groupAddr[2]=groupAddress[2];
+			newGroupEntry->groupAddr[3]=groupAddress[3];
+			#else
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+			#endif
+
+			newGroupEntry->sourceList=NULL;
+
+			newGroupEntry->ipVersion=ipVersion;
+
+			newGroupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+
+			/*must first link into hash table, then call the function of set rtl8306sdm, because of aggregator checking*/
+			if(ipVersion==IP_VERSION4)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable, hashIndex);
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			if(ipVersion==IP_VERSION6)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable, hashIndex);
+			}
+#endif
+
+		}
+
+	}
+	else
+	{
+
+		sourceEntry=groupEntry->sourceList;
+		/*delete all the source list*/
+		while(sourceEntry!=NULL)
+		{
+			sourceEntry->portTimer[portNum]=0;
+			sourceEntry=sourceEntry->next;
+		}
+
+		groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+
+	}
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=groupAddress[0];
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+#endif
+
+out:
+	return (multicastRouterPortMask&(~(1<<portNum))&((1<<MAX_SUPPORT_PORT_NUMBER)-1));
+}
+
+static  uint32 rtl_processLeave(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf)
+{
+	uint32 groupAddress[4]={0, 0, 0, 0};
+	struct rtl_groupEntry* groupEntry=NULL;
+	struct rtl_sourceEntry *sourceEntry=NULL;
+
+	uint32 hashIndex=0;
+	uint32 multicastRouterPortMask=rtl_getMulticastRouterPortMask(moduleIndex, ipVersion, rtl_sysUpSeconds);
+
+	if(ipVersion==IP_VERSION4)
+	{
+		groupAddress[0]=ntohl(((struct igmpv2Pkt *)pktBuf)->groupAddr);
+		hashIndex=groupAddress[0]&rtl_hashMask;
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+		groupAddress[0]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[0]);
+		groupAddress[1]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[1]);
+		groupAddress[2]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[2]);
+		groupAddress[3]=ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[3]);
+
+		hashIndex=groupAddress[3]&rtl_hashMask;
+	}
+#endif
+
+	      groupEntry=rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+	      /*lower the timer of the group*/
+	      if(groupEntry!=NULL)
+	      {
+
+		     if(groupEntry->groupFilterTimer[portNum]>rtl_sysUpSeconds)
+		     {
+
+				if(rtl_mCastModuleArray[moduleIndex].enableFastLeave==TRUE)
+				{
+					groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds;
+				}
+				else
+				{
+					if(groupEntry->groupFilterTimer[portNum]>(rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime))
+					{
+						groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+					}
+				}
+
+                   }
+
+		     sourceEntry=groupEntry->sourceList;
+		     while(sourceEntry)
+		     {
+				if(sourceEntry->portTimer[portNum]>rtl_sysUpSeconds)
+				{
+					if(rtl_mCastModuleArray[moduleIndex].enableFastLeave==TRUE)
+			        	{
+						sourceEntry->portTimer[portNum]=rtl_sysUpSeconds;
+				  	}
+					else
+					{
+						if(sourceEntry->portTimer[portNum]>(rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime))
+						{
+							sourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+						}
+					}
+
+				}
+
+				sourceEntry=sourceEntry->next;
+		      }
+
+
+	      }
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=groupAddress[0];
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+	return (multicastRouterPortMask&(~(1<<portNum))&0x3f);
+}
+
+static  int32 rtl_processIsInclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf)
+{
+
+	uint32 j=0;
+	uint32 groupAddress[4]={0, 0, 0, 0};
+	struct rtl_groupEntry* groupEntry=NULL;
+	struct rtl_groupEntry* newGroupEntry=NULL;
+	struct rtl_sourceEntry *sourceEntry=NULL;
+	struct rtl_sourceEntry *newSourceEntry=NULL;
+
+	uint32 hashIndex=0;
+
+	uint16 numOfSrc=0;
+	uint32 *sourceAddr=NULL;
+
+
+	if(ipVersion==IP_VERSION4)
+	{
+		groupAddress[0]=ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc=ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceAddr=&(((struct groupRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[0]&rtl_hashMask;
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+		groupAddress[0]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc=ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceAddr=&(((struct mCastAddrRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[3]&rtl_hashMask;
+
+	}
+#endif
+
+	groupEntry=rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+	if(groupEntry==NULL)   /*means new group address, create new group entry*/
+	{
+		newGroupEntry=rtl_allocateGroupEntry();
+		if(newGroupEntry==NULL)
+		{
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+		else
+		{
+			/*set new multicast entry*/
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+			newGroupEntry->groupAddr[1]=groupAddress[1];
+			newGroupEntry->groupAddr[2]=groupAddress[2];
+			newGroupEntry->groupAddr[3]=groupAddress[3];
+#else
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+#endif
+
+			newGroupEntry->ipVersion=ipVersion;
+
+			newGroupEntry->sourceList=NULL;
+
+			/*end of set group entry*/
+
+			/*must first link into hash table, then call the function of set rtl8306sdm, because of aggregator checking*/
+			if(ipVersion==IP_VERSION4)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable, hashIndex);
+			}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			if(ipVersion==IP_VERSION6)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable, hashIndex);
+			}
+#endif
+			if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+			{
+				newGroupEntry->groupFilterTimer[portNum]=0;
+				/*link the new source list*/
+				for(j=0; j<numOfSrc; j++)
+				{
+
+
+					newSourceEntry=rtl_allocateSourceEntry();
+					if(newSourceEntry==NULL)
+					{
+						rtl_gluePrintf("run out of source entry!\n");
+						return FAILED;
+					}
+					else
+					{
+
+						if(ipVersion==IP_VERSION4)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+						}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+						if(ipVersion==IP_VERSION6)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+							newSourceEntry->sourceAddr[1]=sourceAddr[1];
+							newSourceEntry->sourceAddr[2]=sourceAddr[2];
+							newSourceEntry->sourceAddr[3]=sourceAddr[3];
+						}
+#endif
+						newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+						rtl_linkSourceEntry(newGroupEntry,newSourceEntry);
+					}
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+				}
+
+			}
+			else
+			{
+				newGroupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+			}
+
+
+		}
+
+
+	}
+	else /*means it can be found in the forward hash table*/
+	{
+
+		if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+		{
+			/*here to handle the source list*/
+			for(j=0; j<numOfSrc; j++)
+			{
+
+				sourceEntry=rtl_searchSourceEntry(ipVersion, sourceAddr,groupEntry);
+				if(sourceEntry==NULL)
+				{
+					newSourceEntry=rtl_allocateSourceEntry();
+					if(newSourceEntry==NULL)
+					{
+						rtl_gluePrintf("run out of source entry!\n");
+						return FAILED;
+					}
+					else
+					{
+
+						if(ipVersion==IP_VERSION4)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+
+						}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+						if(ipVersion==IP_VERSION6)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+							newSourceEntry->sourceAddr[1]=sourceAddr[1];
+							newSourceEntry->sourceAddr[2]=sourceAddr[2];
+							newSourceEntry->sourceAddr[3]=sourceAddr[3];
+						}
+#endif
+						newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+						rtl_linkSourceEntry(groupEntry,newSourceEntry);
+					}
+
+				}
+				else
+				{
+					/*just update source timer*/
+					sourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+				}
+
+				if(ipVersion==IP_VERSION4)
+				{
+					sourceAddr++;
+				}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+				if(ipVersion==IP_VERSION6)
+				{
+					sourceAddr=sourceAddr+4;
+				}
+#endif
+			}
+
+		}
+		else
+		{
+			groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+		}
+
+	}
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=groupAddress[0];
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+	return SUCCESS;
+
+
+}
+
+static  int32 rtl_processIsExclude(uint32 moduleIndex, uint32 ipVersion,uint32 portNum, uint8 *pktBuf)
+{
+	uint32 j=0;
+	uint32 groupAddress[4]={0, 0, 0, 0};
+	struct rtl_groupEntry* groupEntry=NULL;
+	struct rtl_groupEntry* newGroupEntry=NULL;
+	struct rtl_sourceEntry *sourceEntry=NULL;
+	struct rtl_sourceEntry *newSourceEntry=NULL;
+
+	uint32 hashIndex=0;
+	uint16 numOfSrc=0;
+	uint32 *sourceArray=NULL;
+	uint32 *sourceAddr=NULL;
+
+	if(ipVersion==IP_VERSION4)
+	{
+		groupAddress[0]=ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc=ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceArray=&(((struct groupRecord *)pktBuf)->srcList);
+		sourceAddr=&(((struct groupRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[0]&rtl_hashMask;
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+
+		groupAddress[0]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc=ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceArray=&(((struct mCastAddrRecord *)pktBuf)->srcList);
+		sourceAddr=&(((struct mCastAddrRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[3]&rtl_hashMask;
+
+	}
+#endif
+	groupEntry=rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+	if(groupEntry==NULL)   /*means new group address, create new group entry*/
+	{
+		newGroupEntry=rtl_allocateGroupEntry();
+		if(newGroupEntry==NULL)
+		{
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+		else
+		{
+			/*set new multicast entry*/
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+			newGroupEntry->groupAddr[1]=groupAddress[1];
+			newGroupEntry->groupAddr[2]=groupAddress[2];
+			newGroupEntry->groupAddr[3]=groupAddress[3];
+#else
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+#endif
+
+
+			newGroupEntry->ipVersion=ipVersion;
+
+			newGroupEntry->sourceList=NULL;
+			/*means the filter mode is exclude*/
+			newGroupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+
+			/*end of set group entry*/
+
+			/*must first link into hash table, then call the function of set rtl8306sdm, because of aggregator checking*/
+			if(ipVersion==IP_VERSION4)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable, hashIndex);
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			if(ipVersion==IP_VERSION6)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable, hashIndex);
+			}
+#endif
+			if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+			{
+				/*link the new source list*/
+				for(j=0; j<numOfSrc; j++)
+				{
+					newSourceEntry=rtl_allocateSourceEntry();
+					if(newSourceEntry==NULL)
+					{
+						rtl_gluePrintf("run out of source entry!\n");
+						return FAILED;
+					}
+					else
+					{
+
+						if(ipVersion==IP_VERSION4)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+						}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+						if(ipVersion==IP_VERSION6)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+							newSourceEntry->sourceAddr[1]=sourceAddr[1];
+							newSourceEntry->sourceAddr[2]=sourceAddr[2];
+							newSourceEntry->sourceAddr[3]=sourceAddr[3];
+						}
+#endif
+						/*time out the sources included in the MODE_IS_EXCLUDE report*/
+						newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds;
+						rtl_linkSourceEntry(newGroupEntry,newSourceEntry);
+					}
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+				}
+
+			}
+
+		}
+
+	}
+	else /*means group address can be found in the forward hash table*/
+	{
+
+		if(groupEntry->groupFilterTimer[portNum]<=rtl_sysUpSeconds) /*means include mode*/
+		{
+			if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+			{
+				/*here to handle the source list*/
+
+				/*delete (A-B)*/
+				sourceEntry=groupEntry->sourceList;
+				while(sourceEntry)
+				{
+					if(rtl_searchSourceAddr(ipVersion,sourceEntry->sourceAddr,sourceArray, numOfSrc)== FALSE)
+					{
+						sourceEntry->portTimer[portNum]=0;
+					}
+					sourceEntry=sourceEntry->next;
+				}
+
+				/*(B-A) time out*/
+				for(j=0; j<numOfSrc; j++)
+				{
+
+					sourceEntry=rtl_searchSourceEntry(ipVersion, sourceAddr,groupEntry);
+
+					if(sourceEntry==NULL)
+					{
+						newSourceEntry=rtl_allocateSourceEntry();
+						if(newSourceEntry==NULL)
+						{
+							rtl_gluePrintf("run out of source entry!\n");
+							return FAILED;
+						}
+						else
+						{
+
+							if(ipVersion==IP_VERSION4)
+							{
+								newSourceEntry->sourceAddr[0]=sourceAddr[0];
+
+							}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+							if(ipVersion==IP_VERSION6)
+							{
+								newSourceEntry->sourceAddr[0]=sourceAddr[0];
+								newSourceEntry->sourceAddr[1]=sourceAddr[1];
+								newSourceEntry->sourceAddr[2]=sourceAddr[2];
+								newSourceEntry->sourceAddr[3]=sourceAddr[3];
+							}
+#endif
+							newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds;
+							rtl_linkSourceEntry(groupEntry,newSourceEntry);
+						}
+
+					}
+					else
+					{
+						if(sourceEntry->portTimer[portNum]==0)
+						{
+							sourceEntry->portTimer[portNum]=rtl_sysUpSeconds;
+						}
+					}
+
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+				}
+			}
+
+		}
+		else/*means exclude mode*/
+		{
+			if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+			{
+				/*here to handle the source list*/
+				/*delete (X-A) and delete (Y-A)*/
+				sourceEntry=groupEntry->sourceList;
+				while(sourceEntry)
+				{
+					if(rtl_searchSourceAddr(ipVersion,sourceEntry->sourceAddr,sourceArray, numOfSrc)== FALSE)
+					{
+						sourceEntry->portTimer[portNum]=0;
+					}
+					sourceEntry=sourceEntry->next;
+				}
+
+				/*A-X-Y=GMI*/
+				for(j=0; j<numOfSrc; j++)
+				{
+					sourceEntry=rtl_searchSourceEntry(ipVersion, sourceAddr,groupEntry);
+
+					if(sourceEntry==NULL)
+					{
+						newSourceEntry=rtl_allocateSourceEntry();
+						if(newSourceEntry==NULL)
+						{
+							rtl_gluePrintf("run out of source entry!\n");
+							return FAILED;
+						}
+						else
+						{
+
+							if(ipVersion==IP_VERSION4)
+							{
+								newSourceEntry->sourceAddr[0]=sourceAddr[0];
+
+							}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+							if(ipVersion==IP_VERSION6)
+							{
+								newSourceEntry->sourceAddr[0]=sourceAddr[0];
+								newSourceEntry->sourceAddr[1]=sourceAddr[1];
+								newSourceEntry->sourceAddr[2]=sourceAddr[2];
+								newSourceEntry->sourceAddr[3]=sourceAddr[3];
+							}
+#endif
+
+							newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+							rtl_linkSourceEntry(groupEntry,newSourceEntry);
+						}
+
+					}
+					else
+					{
+						if(sourceEntry->portTimer[portNum]==0)
+						{
+							sourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+						}
+					}
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+				}
+			}
+
+
+		}
+
+		groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+	}
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=groupAddress[0];
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+	return SUCCESS;
+
+}
+
+static int32 rtl_processToInclude(uint32 moduleIndex, uint32 ipVersion,  uint32 portNum, uint8 *pktBuf)
+{
+	uint32 j=0;
+	uint32 groupAddress[4]={0, 0, 0, 0};
+	struct rtl_groupEntry* groupEntry=NULL;
+	struct rtl_groupEntry* newGroupEntry=NULL;
+	struct rtl_sourceEntry *sourceEntry=NULL;
+	struct rtl_sourceEntry *newSourceEntry=NULL;
+
+	uint32 hashIndex=0;
+	uint16 numOfSrc=0;
+	uint32 *sourceAddr=NULL;
+
+	if(ipVersion==IP_VERSION4)
+	{
+		groupAddress[0]=ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc=ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceAddr=&(((struct groupRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[0]&rtl_hashMask;
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+
+		groupAddress[0]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc=ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceAddr=&(((struct mCastAddrRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[3]&rtl_hashMask;
+
+	}
+#endif
+
+	groupEntry=rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+	if(groupEntry==NULL)   /*means new group address, create new group entry*/
+	{
+		newGroupEntry=rtl_allocateGroupEntry();
+		if(newGroupEntry==NULL)
+		{
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+		else
+		{
+			/*set new multicast entry*/
+	#ifdef CONFIG_RTL_MLD_SNOOPING
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+			newGroupEntry->groupAddr[1]=groupAddress[1];
+			newGroupEntry->groupAddr[2]=groupAddress[2];
+			newGroupEntry->groupAddr[3]=groupAddress[3];
+	#else
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+	#endif
+
+
+			newGroupEntry->ipVersion=ipVersion;
+
+			newGroupEntry->sourceList=NULL;
+
+			/*end of set group entry*/
+
+			/*must first link into hash table, then call the function of set rtl8306sdm, because of aggregator checking*/
+			if(ipVersion==IP_VERSION4)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable, hashIndex);
+			}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			if(ipVersion==IP_VERSION6)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable, hashIndex);
+			}
+#endif
+
+			if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+			{
+				newGroupEntry->groupFilterTimer[portNum]=0;
+				/*link the new source list*/
+				for(j=0; j<numOfSrc; j++)
+				{
+
+
+					newSourceEntry=rtl_allocateSourceEntry();
+					if(newSourceEntry==NULL)
+					{
+						rtl_gluePrintf("run out of source entry!\n");
+						return FAILED;
+					}
+					else
+					{
+
+						if(ipVersion==IP_VERSION4)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+
+						}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+						if(ipVersion==IP_VERSION6)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+							newSourceEntry->sourceAddr[1]=sourceAddr[1];
+							newSourceEntry->sourceAddr[2]=sourceAddr[2];
+							newSourceEntry->sourceAddr[3]=sourceAddr[3];
+						}
+#endif
+						newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+						rtl_linkSourceEntry(newGroupEntry,newSourceEntry);
+					}
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+
+				}
+			}
+			else
+			{
+				newGroupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+			}
+
+
+		}
+
+	}
+	else /*means it can be found in the forward hash table*/
+	{
+
+		if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+		{
+			/*here to handle the source list*/
+
+			for(j=0; j<numOfSrc; j++)
+			{
+
+				sourceEntry=rtl_searchSourceEntry(ipVersion, sourceAddr,groupEntry);
+
+				if(sourceEntry==NULL)
+				{
+					newSourceEntry=rtl_allocateSourceEntry();
+					if(newSourceEntry==NULL)
+					{
+						rtl_gluePrintf("run out of source entry!\n");
+						return FAILED;
+					}
+					else
+					{
+
+						if(ipVersion==IP_VERSION4)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+
+						}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+						if(ipVersion==IP_VERSION6)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+							newSourceEntry->sourceAddr[1]=sourceAddr[1];
+							newSourceEntry->sourceAddr[2]=sourceAddr[2];
+							newSourceEntry->sourceAddr[3]=sourceAddr[3];
+						}
+#endif
+						newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+						rtl_linkSourceEntry(groupEntry,newSourceEntry);
+					}
+
+				}
+				else
+				{
+					/*just update source timer*/
+					sourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+				}
+
+				if(ipVersion==IP_VERSION4)
+				{
+					sourceAddr++;
+				}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+				if(ipVersion==IP_VERSION6)
+				{
+					sourceAddr=sourceAddr+4;
+				}
+#endif
+
+			}
+
+	//		if(rtl_mCastModuleArray[moduleIndex].enableFastLeave==TRUE)         /*lower the timer of (A-B) or (X-A)*/
+		//	{
+			    sourceEntry=groupEntry->sourceList;
+
+	                  if(ipVersion==IP_VERSION4)
+	                  {
+	                             sourceAddr=&(((struct groupRecord *)pktBuf)->srcList);
+	                  }
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	                  if(ipVersion==IP_VERSION6)
+	                  {
+		                      sourceAddr=&(((struct mCastAddrRecord *)pktBuf)->srcList);
+	                  }
+#endif
+				while(sourceEntry)
+				{
+				         if((rtl_searchSourceAddr(ipVersion, sourceEntry->sourceAddr, sourceAddr, numOfSrc)==FALSE)&&(sourceEntry->portTimer[portNum]>(rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime)))
+					 {
+						if(sourceEntry->portTimer[portNum]>(rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime))
+						{
+							sourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+						}
+
+					 }
+				         sourceEntry=sourceEntry->next;
+				}
+
+                            if(groupEntry->groupFilterTimer[portNum]>rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime)   /*lower the group timer if in exclude mode*/
+                            {
+					groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+
+				}
+
+				if((numOfSrc==0)&&(rtl_mCastModuleArray[moduleIndex].enableFastLeave==TRUE))
+				{
+		     			if(groupEntry->groupFilterTimer[portNum]>rtl_sysUpSeconds)
+		     			{
+						groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds;
+			 		}
+
+					sourceEntry=groupEntry->sourceList;
+
+					while(sourceEntry)
+					{
+						if(sourceEntry->portTimer[portNum]>rtl_sysUpSeconds)
+						{
+							sourceEntry->portTimer[portNum]=rtl_sysUpSeconds;
+						}
+		 				sourceEntry=sourceEntry->next;
+					}
+
+				}
+		}
+		else
+		{
+			if((numOfSrc==0)&&(groupEntry->groupFilterTimer[portNum]>rtl_sysUpSeconds))
+			{
+		     	 		if(rtl_mCastModuleArray[moduleIndex].enableFastLeave==TRUE)
+		     			{
+						groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds;
+					}
+					else
+					{
+						groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+					}
+			}
+			else
+			{
+				groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+			}
+
+		}
+
+
+	}
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=groupAddress[0];
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+return SUCCESS;
+
+}
+
+static  int32 rtl_processToExclude(uint32 moduleIndex, uint32 ipVersion,uint32 portNum , uint8 *pktBuf)
+{
+	uint32 j=0;
+	uint32 groupAddress[4]={0, 0, 0, 0};
+	struct rtl_groupEntry* groupEntry=NULL;
+	struct rtl_groupEntry* newGroupEntry=NULL;
+	struct rtl_sourceEntry *sourceEntry=NULL;
+	struct rtl_sourceEntry *newSourceEntry=NULL;
+
+	uint32 hashIndex=0;
+	uint16 numOfSrc=0;
+	uint32 *sourceArray=NULL;
+	uint32 *sourceAddr=NULL;
+
+	if(ipVersion==IP_VERSION4)
+	{
+		groupAddress[0]=ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc=ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceArray=&(((struct groupRecord *)pktBuf)->srcList);
+		sourceAddr=&(((struct groupRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[0]&rtl_hashMask;
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+
+		groupAddress[0]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc=ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceArray=&(((struct mCastAddrRecord *)pktBuf)->srcList);
+		sourceAddr=&(((struct mCastAddrRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[3]&rtl_hashMask;
+
+	}
+#endif
+
+	groupEntry=rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+	if(groupEntry==NULL)   /*means new group address, create new group entry*/
+	{
+		newGroupEntry=rtl_allocateGroupEntry();
+		if(newGroupEntry==NULL)
+		{
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+		else
+		{
+			/*set new multicast entry*/
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+			newGroupEntry->groupAddr[1]=groupAddress[1];
+			newGroupEntry->groupAddr[2]=groupAddress[2];
+			newGroupEntry->groupAddr[3]=groupAddress[3];
+#else
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+#endif
+
+			newGroupEntry->ipVersion=ipVersion;
+
+			newGroupEntry->sourceList=NULL;
+
+			/*means the filter mode is exclude*/
+			newGroupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+
+			/*end of set group entry*/
+
+			/*must first link into hash table, then call the function of set rtl8306sdm, because of aggregator checking*/
+			if(ipVersion==IP_VERSION4)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable, hashIndex);
+			}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			if(ipVersion==IP_VERSION6)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable, hashIndex);
+			}
+#endif
+			if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+			{
+				/*link the new source list*/
+				for(j=0; j<numOfSrc; j++)
+				{
+					newSourceEntry=rtl_allocateSourceEntry();
+					if(newSourceEntry==NULL)
+					{
+						rtl_gluePrintf("run out of source entry!\n");
+						return FAILED;
+					}
+					else
+					{
+
+						if(ipVersion==IP_VERSION4)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+						}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+						if(ipVersion==IP_VERSION6)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+							newSourceEntry->sourceAddr[1]=sourceAddr[1];
+							newSourceEntry->sourceAddr[2]=sourceAddr[2];
+							newSourceEntry->sourceAddr[3]=sourceAddr[3];
+						}
+#endif
+						/*time out the sources included  in the TO_EXCLUDE report */
+						newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds;
+						rtl_linkSourceEntry(newGroupEntry,newSourceEntry);
+					}
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+
+				}
+
+			}
+
+
+		}
+
+	}
+	else /*means group address can be found in the forward hash table*/
+	{
+
+		if(groupEntry->groupFilterTimer[portNum]<=rtl_sysUpSeconds) /*means include mode*/
+		{
+
+			if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+			{
+				/*here to handle the source list*/
+				/*delete (A-B)*/
+				sourceEntry=groupEntry->sourceList;
+				while(sourceEntry)
+				{
+					if(rtl_searchSourceAddr(ipVersion,sourceEntry->sourceAddr,sourceArray, numOfSrc)== FALSE)
+					{
+						sourceEntry->portTimer[portNum]=0;
+					}
+					sourceEntry=sourceEntry->next;
+				}
+
+				/*(B-A) time out*/
+				for(j=0; j<numOfSrc; j++)
+				{
+					sourceEntry=rtl_searchSourceEntry(ipVersion, sourceAddr,groupEntry);
+
+					if(sourceEntry==NULL)
+					{
+						newSourceEntry=rtl_allocateSourceEntry();
+						if(newSourceEntry==NULL)
+						{
+							rtl_gluePrintf("run out of source entry!\n");
+							return FAILED;
+						}
+						else
+						{
+
+							if(ipVersion==IP_VERSION4)
+							{
+								newSourceEntry->sourceAddr[0]=sourceAddr[0];
+
+							}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+							if(ipVersion==IP_VERSION6)
+							{
+								newSourceEntry->sourceAddr[0]=sourceAddr[0];
+								newSourceEntry->sourceAddr[1]=sourceAddr[1];
+								newSourceEntry->sourceAddr[2]=sourceAddr[2];
+								newSourceEntry->sourceAddr[3]=sourceAddr[3];
+							}
+#endif
+
+							/*B-A time out*/
+							newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds;
+							rtl_linkSourceEntry(groupEntry,newSourceEntry);
+						}
+
+					}
+					else/*maybe include redundant sources*/
+					{
+						/*B-A time out*/
+						if(sourceEntry->portTimer[portNum]==0)
+						{
+							sourceEntry->portTimer[portNum]=rtl_sysUpSeconds;
+						}
+
+						if(sourceEntry->portTimer[portNum]>rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime)            /*lower the A*B timer if the cpu is router*/
+						{
+							sourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+						}
+					}
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+				}
+
+			}
+
+		}
+		else/*means exclude mode*/
+		{
+
+			if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+			{
+				/*here to handle the source list*/
+				/*delete (X-A) and delete (Y-A)*/
+				sourceEntry=groupEntry->sourceList;
+				while(sourceEntry)
+				{
+					if(rtl_searchSourceAddr(ipVersion,sourceEntry->sourceAddr,sourceArray, numOfSrc)== FALSE)
+					{
+						sourceEntry->portTimer[portNum]=0;
+					}
+					sourceEntry=sourceEntry->next;
+				}
+
+				/*A-X-Y=filter timer*/
+				for(j=0; j<numOfSrc; j++)
+				{
+					sourceEntry=rtl_searchSourceEntry(ipVersion, sourceAddr,groupEntry);
+
+					if(sourceEntry==NULL)
+					{
+						newSourceEntry=rtl_allocateSourceEntry();
+						if(newSourceEntry==NULL)
+						{
+							rtl_gluePrintf("run out of source entry!\n");
+							return FAILED;
+						}
+						else
+						{
+
+							if(ipVersion==IP_VERSION4)
+							{
+								newSourceEntry->sourceAddr[0]=sourceAddr[0];
+							}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+							if(ipVersion==IP_VERSION6)
+							{
+								newSourceEntry->sourceAddr[0]=sourceAddr[0];
+								newSourceEntry->sourceAddr[1]=sourceAddr[1];
+								newSourceEntry->sourceAddr[2]=sourceAddr[2];
+								newSourceEntry->sourceAddr[3]=sourceAddr[3];
+							}
+#endif
+                                                 newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+                                                 rtl_linkSourceEntry(groupEntry,newSourceEntry);
+
+						}
+
+					}
+					else
+					{
+						if((sourceEntry->portTimer[portNum]==0)||(sourceEntry->portTimer[portNum]>(rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime)))
+						{
+							sourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+						}
+					}
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+
+				}
+			}
+
+
+		}
+
+		/*switch to exclude mode or update exclude mode filter timer*/
+		groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+
+
+
+	}
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=groupAddress[0];
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+	return SUCCESS;
+}
+
+static  int32 rtl_processAllow(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf)
+{
+	uint32 j=0;
+	uint32 groupAddress[4]={0, 0, 0, 0};
+	struct rtl_groupEntry* groupEntry=NULL;
+	struct rtl_groupEntry* newGroupEntry=NULL;
+	struct rtl_sourceEntry *sourceEntry=NULL;
+	struct rtl_sourceEntry *newSourceEntry=NULL;
+
+	uint32 hashIndex=0;
+	uint16 numOfSrc=0;
+	uint32 *sourceAddr=NULL;
+
+
+
+	if(ipVersion==IP_VERSION4)
+	{
+		groupAddress[0]=ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc=ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceAddr=&(((struct groupRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[0]&rtl_hashMask;
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+
+		groupAddress[0]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc=ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceAddr=&(((struct mCastAddrRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[3]&rtl_hashMask;
+
+	}
+#endif
+
+	groupEntry=rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+	if(groupEntry==NULL)   /*means new group address, create new group entry*/
+	{
+		newGroupEntry=rtl_allocateGroupEntry();
+		if(newGroupEntry==NULL)
+		{
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+		else
+		{
+			/*set new multicast entry*/
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+			newGroupEntry->groupAddr[1]=groupAddress[1];
+			newGroupEntry->groupAddr[2]=groupAddress[2];
+			newGroupEntry->groupAddr[3]=groupAddress[3];
+#else
+			newGroupEntry->groupAddr[0]=groupAddress[0];
+#endif
+
+
+			newGroupEntry->ipVersion=ipVersion;
+
+			newGroupEntry->sourceList=NULL;
+
+			/*end of set group entry*/
+
+			/*must first link into hash table, then call the function of set rtl8306sdm, because of aggregator checking*/
+			if(ipVersion==IP_VERSION4)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable, hashIndex);
+			}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			if(ipVersion==IP_VERSION6)
+			{
+				rtl_linkGroupEntry(newGroupEntry, rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable, hashIndex);
+			}
+#endif
+			if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+			{
+				newGroupEntry->groupFilterTimer[portNum]=0;
+				/*link the new source list*/
+				for(j=0; j<numOfSrc; j++)
+				{
+
+
+					newSourceEntry=rtl_allocateSourceEntry();
+					if(newSourceEntry==NULL)
+					{
+						rtl_gluePrintf("run out of source entry!\n");
+						return FAILED;
+					}
+					else
+					{
+
+						if(ipVersion==IP_VERSION4)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+						}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+						if(ipVersion==IP_VERSION6)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+							newSourceEntry->sourceAddr[1]=sourceAddr[1];
+							newSourceEntry->sourceAddr[2]=sourceAddr[2];
+							newSourceEntry->sourceAddr[3]=sourceAddr[3];
+						}
+#endif
+						newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+						rtl_linkSourceEntry(newGroupEntry,newSourceEntry);
+					}
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+				}
+			}
+			else
+			{
+				newGroupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;;
+			}
+
+		}
+
+
+
+	}
+	else /*means it can be found in the forward hash table*/
+	{
+		if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+		{
+			/*here to handle the source list*/
+			for(j=0; j<numOfSrc; j++)
+			{
+
+				sourceEntry=rtl_searchSourceEntry(ipVersion, sourceAddr,groupEntry);
+
+				if(sourceEntry==NULL)
+				{
+					newSourceEntry=rtl_allocateSourceEntry();
+					if(newSourceEntry==NULL)
+					{
+						rtl_gluePrintf("run out of source entry!\n");
+						return FAILED;
+					}
+					else
+					{
+
+						if(ipVersion==IP_VERSION4)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+						}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+						if(ipVersion==IP_VERSION6)
+						{
+							newSourceEntry->sourceAddr[0]=sourceAddr[0];
+							newSourceEntry->sourceAddr[1]=sourceAddr[1];
+							newSourceEntry->sourceAddr[2]=sourceAddr[2];
+							newSourceEntry->sourceAddr[3]=sourceAddr[3];
+						}
+#endif
+						newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+						rtl_linkSourceEntry(groupEntry,newSourceEntry);
+					}
+
+				}
+				else
+				{
+					/*just update source timer*/
+					sourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+				}
+
+				if(ipVersion==IP_VERSION4)
+				{
+					sourceAddr++;
+				}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+				if(ipVersion==IP_VERSION6)
+				{
+					sourceAddr=sourceAddr+4;
+				}
+#endif
+			}
+		}
+		else
+		{
+			groupEntry->groupFilterTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;;
+		}
+
+	}
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=groupAddress[0];
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+	return SUCCESS;
+}
+
+static int32 rtl_processBlock(uint32 moduleIndex, uint32 ipVersion,uint32 portNum, uint8 *pktBuf)
+{
+	uint32 j=0;
+	uint32 groupAddress[4]={0, 0, 0, 0};
+
+	struct rtl_groupEntry* groupEntry=NULL;
+	struct rtl_sourceEntry *sourceEntry=NULL;
+	struct rtl_sourceEntry *newSourceEntry=NULL;
+//	struct rtl_sourceEntry *nextSourceEntry=NULL;
+
+	uint32 hashIndex=0;
+	uint16 numOfSrc=0;
+	uint32 *sourceAddr=NULL;
+
+	if(ipVersion==IP_VERSION4)
+	{
+		groupAddress[0]=ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc=ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceAddr=&(((struct groupRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[0]&rtl_hashMask;
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+
+		groupAddress[0]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3]=ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc=ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceAddr=&(((struct mCastAddrRecord *)pktBuf)->srcList);
+		hashIndex=groupAddress[3]&rtl_hashMask;
+	}
+#endif
+
+	groupEntry=rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+	if(groupEntry!=NULL)
+	{
+
+		if(groupEntry->groupFilterTimer[portNum]>rtl_sysUpSeconds) /*means exclude mode*/
+		{
+			if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+			{
+				/*here to handle the source list*/
+				/*A-X-Y=filter timer*/
+				for(j=0; j<numOfSrc; j++)
+				{
+
+					sourceEntry=rtl_searchSourceEntry(ipVersion, sourceAddr,groupEntry);
+
+					if(sourceEntry==NULL)
+					{
+						newSourceEntry=rtl_allocateSourceEntry();
+						if(newSourceEntry==NULL)
+						{
+							rtl_gluePrintf("run out of source entry!\n");
+							return FAILED;
+						}
+						else
+						{
+
+							if(ipVersion==IP_VERSION4)
+							{
+								newSourceEntry->sourceAddr[0]=sourceAddr[0];
+
+							}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+							if(ipVersion==IP_VERSION6)
+							{
+								newSourceEntry->sourceAddr[0]=sourceAddr[0];
+								newSourceEntry->sourceAddr[1]=sourceAddr[1];
+								newSourceEntry->sourceAddr[2]=sourceAddr[2];
+								newSourceEntry->sourceAddr[3]=sourceAddr[3];
+							}
+#endif
+
+                                                 if(groupEntry->groupFilterTimer[portNum]>(rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime))
+                                                 {
+                                                 	newSourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+							}
+							else
+							{
+								newSourceEntry->portTimer[portNum]=groupEntry->groupFilterTimer[portNum];
+							}
+
+                                                 rtl_linkSourceEntry(groupEntry,newSourceEntry);
+
+						}
+
+					}
+					else
+					{
+
+                                       	if(rtl_mCastModuleArray[moduleIndex].enableFastLeave==TRUE)
+						{
+						   	sourceEntry->portTimer[portNum]=rtl_sysUpSeconds;
+						}
+						else
+						{
+							if((sourceEntry->portTimer[portNum]==0)||(sourceEntry->portTimer[portNum]>(rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime)))
+							{
+								sourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+							}
+						}
+
+					}
+
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+
+				}
+
+			}
+			#if 0
+			else
+			{
+					groupEntry->groupFilterTimer[portIndex]=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;;
+			}
+			#endif
+		}
+              else           /*means include mode*/
+              {
+                     if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)             /*process the special-group query if the cpu is router*/
+                     {
+                      	for(j=0; j<numOfSrc; j++)
+                          	{
+
+				        sourceEntry=rtl_searchSourceEntry(ipVersion, sourceAddr,groupEntry);
+					if(sourceEntry!=NULL)
+					{
+
+						if(rtl_mCastModuleArray[moduleIndex].enableFastLeave==TRUE)
+						{
+							sourceEntry->portTimer[portNum]=rtl_sysUpSeconds;
+						}
+						else
+						{
+							if((sourceEntry->portTimer[portNum]==0)||(sourceEntry->portTimer[portNum]>(rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime)))
+							{
+								sourceEntry->portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.lastMemberAgingTime;
+							}
+						}
+					}
+
+					if(ipVersion==IP_VERSION4)
+					{
+						sourceAddr++;
+					}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+					if(ipVersion==IP_VERSION6)
+					{
+						sourceAddr=sourceAddr+4;
+					}
+#endif
+			     	}
+
+			}
+
+	        }
+
+	}
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=groupAddress[0];
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+	return SUCCESS;
+
+}
+
+
+static uint32 rtl_processIgmpv3Mldv2Reports(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint8 *pktBuf)
+{
+	uint32 i=0;
+	uint16 numOfRecords=0;
+	uint8 *groupRecords=NULL;
+	uint8 recordType=0xff;
+	uint16 numOfSrc=0;
+	int32 returnVal=0;
+	uint32 multicastRouterPortMask=rtl_getMulticastRouterPortMask(moduleIndex, ipVersion, rtl_sysUpSeconds);
+
+	if(ipVersion==IP_VERSION4)
+	{
+		numOfRecords=ntohs(((struct igmpv3Report *)pktBuf)->numOfRecords);
+		if(numOfRecords!=0)
+		{
+			groupRecords=(uint8 *)(&(((struct igmpv3Report *)pktBuf)->recordList));
+		}
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+		numOfRecords=ntohs(((struct mldv2Report *)pktBuf)->numOfRecords);
+		if(numOfRecords!=0)
+		{
+			groupRecords=(uint8 *)(&(((struct mldv2Report *)pktBuf)->recordList));
+		}
+	}
+#endif
+
+	for(i=0; i<numOfRecords; i++)
+	{
+		if(ipVersion==IP_VERSION4)
+		{
+			recordType=((struct groupRecord *)groupRecords)->type;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		if(ipVersion==IP_VERSION6)
+		{
+			recordType=((struct mCastAddrRecord *)groupRecords)->type;
+		}
+#endif
+
+		switch(recordType)
+		{
+			case MODE_IS_INCLUDE:
+				returnVal=rtl_processIsInclude(moduleIndex, ipVersion, portNum, groupRecords);
+			break;
+
+			case MODE_IS_EXCLUDE:
+				returnVal=rtl_processIsExclude(moduleIndex, ipVersion, portNum, groupRecords);
+			break;
+
+			case CHANGE_TO_INCLUDE_MODE:
+				returnVal=rtl_processToInclude(moduleIndex, ipVersion, portNum, groupRecords);
+			break;
+
+			case CHANGE_TO_EXCLUDE_MODE:
+				returnVal=rtl_processToExclude(moduleIndex, ipVersion, portNum, groupRecords);
+			break;
+
+			case ALLOW_NEW_SOURCES:
+				returnVal=rtl_processAllow(moduleIndex, ipVersion, portNum, groupRecords);
+			break;
+
+			case BLOCK_OLD_SOURCES:
+				returnVal=rtl_processBlock(moduleIndex, ipVersion, portNum, groupRecords);
+			break;
+
+			default:break;
+
+		}
+
+		if(ipVersion==IP_VERSION4)
+		{
+			numOfSrc=ntohs(((struct groupRecord *)groupRecords)->numOfSrc);
+			/*shift pointer to another group record*/
+			groupRecords=groupRecords+8+numOfSrc*4+(((struct groupRecord *)(groupRecords))->auxLen)*4;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		if(ipVersion==IP_VERSION6)
+		{
+			numOfSrc=ntohs(((struct mCastAddrRecord *)groupRecords)->numOfSrc);
+			/*shift pointer to another group record*/
+			groupRecords=groupRecords+20+numOfSrc*16+(((struct mCastAddrRecord *)(groupRecords))->auxLen)*4;
+		}
+#endif
+	}
+
+	return (multicastRouterPortMask&(~(1<<portNum))&((1<<MAX_SUPPORT_PORT_NUMBER)-1));
+
+}
+
+static uint32 rtl_processIgmpMld(uint32 moduleIndex, uint32 ipVersion, uint8* pktBuf, uint32 pktLen, uint32 portNum)
+{
+	uint32 fwdPortMask=0;
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	reportEventContext.moduleIndex=moduleIndex;
+	#endif
+
+	switch(pktBuf[0])
+	{
+		case IGMP_QUERY:
+			fwdPortMask=rtl_processQueries(moduleIndex, ipVersion, portNum, pktBuf, pktLen);
+		break;
+
+		case IGMPV1_REPORT:
+			 fwdPortMask=rtl_processJoin(moduleIndex, ipVersion, portNum, pktBuf);
+		break;
+
+		case IGMPV2_REPORT:
+			 fwdPortMask=rtl_processJoin(moduleIndex, ipVersion, portNum, pktBuf);
+		break;
+
+		case IGMPV2_LEAVE:
+			 fwdPortMask=rtl_processLeave(moduleIndex, ipVersion, portNum, pktBuf);
+		break;
+
+		case IGMPV3_REPORT:
+			 fwdPortMask=rtl_processIgmpv3Mldv2Reports(moduleIndex, ipVersion, portNum, pktBuf);
+		break;
+
+		case MLD_QUERY:
+			fwdPortMask=rtl_processQueries(moduleIndex, ipVersion, portNum, pktBuf, pktLen);
+		break;
+
+		case MLDV1_REPORT:
+			 fwdPortMask=rtl_processJoin(moduleIndex, ipVersion, portNum, pktBuf);
+		break;
+
+		case MLDV1_DONE:
+			 fwdPortMask=rtl_processLeave(moduleIndex, ipVersion, portNum, pktBuf);
+		break;
+
+		case MLDV2_REPORT:
+			 fwdPortMask=rtl_processIgmpv3Mldv2Reports(moduleIndex, ipVersion, portNum, pktBuf);
+		break;
+
+		default:
+			fwdPortMask=((~(1<<portNum))&((1<<MAX_SUPPORT_PORT_NUMBER)-1));
+		break;
+	}
+
+	return fwdPortMask;
+
+}
+
+
+
+static uint32 rtl_processDvmrp(uint32 moduleIndex, uint32 ipVersion, uint8* pktBuf, uint32 pktLen, uint32 portNum)
+{
+
+	if(ipVersion==IP_VERSION4)
+	{
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.dvmrpRouter.portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.dvmrpRouterAgingTime; /*update timer*/
+	}
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=0;
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+	return ((~(1<<portNum))&((1<<MAX_SUPPORT_PORT_NUMBER)-1));
+
+}
+
+static uint32 rtl_processMospf(uint32 moduleIndex,uint32 ipVersion, uint8* pktBuf, uint32 pktLen, uint32 portNum)
+{
+	struct ipv4MospfHdr *ipv4MospfHeader=(struct ipv4MospfHdr*)pktBuf;
+	struct ipv4MospfHello *ipv4HelloPkt=(struct ipv4MospfHello*)pktBuf;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	struct ipv6MospfHdr *ipv6MospfHeader=(struct ipv6MospfHdr*)pktBuf;
+	struct ipv6MospfHello *ipv6HelloPkt=(struct ipv6MospfHello*)pktBuf;
+#endif
+
+
+	if(ipVersion==IP_VERSION4)
+	{
+		/*mospf is built based on ospfv2*/
+		if((ipv4MospfHeader->version==2) && (ipv4MospfHeader->type==MOSPF_HELLO_TYPE))
+		{
+			if((ipv4HelloPkt->options & 0x04)!=0)
+			{
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.mospfRouter.portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.mospfRouterAgingTime; /*update timer*/
+			}
+		}
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+		if((ipv6MospfHeader->version==3) && (ipv6MospfHeader->type==MOSPF_HELLO_TYPE))
+		{
+			if((ipv6HelloPkt->options[2] & 0x04)!=0)
+			{
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.mospfRouter.portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.mospfRouterAgingTime; /*update timer*/
+
+			}
+		}
+	}
+#endif
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=0;
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+	return ((~(1<<portNum))&((1<<MAX_SUPPORT_PORT_NUMBER)-1));
+
+}
+
+static uint32 rtl_processPim(uint32 moduleIndex, uint32 ipVersion, uint8* pktBuf, uint32 pktLen, uint32 portNum)
+{
+	if(ipVersion==IP_VERSION4)
+	{
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.pimRouter.portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.pimRouterAgingTime; /*update timer*/
+
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if(ipVersion==IP_VERSION6)
+	{
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.pimRouter.portTimer[portNum]=rtl_sysUpSeconds+rtl_mCastTimerParas.pimRouterAgingTime; /*update timer*/
+	}
+#endif
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if(ipVersion==IP_VERSION4)
+	{
+		strcpy(reportEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		reportEventContext.groupAddr[0]=0;
+		reportEventContext.sourceAddr[0]=0;
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+	}
+	#endif
+
+	return ((~(1<<portNum))&((1<<MAX_SUPPORT_PORT_NUMBER)-1));
+}
+
+
+
+/*********************************************
+				External Function
+  *********************************************/
+
+
+//External called function by high level program
+/*
+@func int32	| rtl_registerIgmpSnoopingModule	|   API to register an igmp snooping module.
+@parm  uint32 *	| moduleIndex	| Output parameter to return the igmp snooping module index.
+@rvalue SUCCESS	| Register igmp snooping module successfully.
+@rvalue FAILED	| Register igmp snooping module failed.
+*/
+int32 rtl_registerIgmpSnoopingModule(uint32 *moduleIndex)
+{
+	int32 i=0;
+	uint32 index=0xFFFFFFFF;
+
+	*moduleIndex=0xFFFFFFFF;
+
+	for(i=0; i<MAX_MCAST_MODULE_NUM; i++)
+	{
+		if(rtl_mCastModuleArray[i].enableSnooping==FALSE)
+		{
+			index=i;
+			break;
+		}
+	}
+
+	if(i>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+
+	if(rtl_mCastModuleArray[index].enableSnooping==FALSE)
+	{
+	      /*initialize multicast Routers information*/
+	      for(i=0; i<MAX_SUPPORT_PORT_NUMBER; i++)
+	      {
+			rtl_mCastModuleArray[index].rtl_ipv4MulticastRouters.querier.portTimer[i]=0;
+			rtl_mCastModuleArray[index].rtl_ipv4MulticastRouters.dvmrpRouter.portTimer[i]=0;
+			rtl_mCastModuleArray[index].rtl_ipv4MulticastRouters.pimRouter.portTimer[i]=0;
+			rtl_mCastModuleArray[index].rtl_ipv4MulticastRouters.mospfRouter.portTimer[i]=0;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			rtl_mCastModuleArray[index].rtl_ipv6MulticastRouters.querier.portTimer[i]=0;
+			rtl_mCastModuleArray[index].rtl_ipv6MulticastRouters.dvmrpRouter.portTimer[i]=0;
+			rtl_mCastModuleArray[index].rtl_ipv6MulticastRouters.pimRouter.portTimer[i]=0;
+			rtl_mCastModuleArray[index].rtl_ipv6MulticastRouters.mospfRouter.portTimer[i]=0;
+#endif
+	      }
+
+	      /*initialize hash table*/
+	      rtl_initHashTable(index, rtl_hashTableSize);
+
+	      if((rtl_mCastModuleArray[index].rtl_ipv4HashTable==NULL) )
+	      {
+		      return FAILED;
+	      }
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		if(rtl_mCastModuleArray[index].rtl_ipv6HashTable==NULL)
+		{
+			return FAILED;
+		}
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		memset(&rtl_mCastModuleArray[index].deviceInfo,0, sizeof(rtl_multicastDeviceInfo_t));
+#endif
+      		for(i=0; i<6; i++)
+      		{
+	      		rtl_mCastModuleArray[index].rtl_gatewayMac[i]=0;
+      		}
+
+		rtl_mCastModuleArray[index]. rtl_gatewayIpv4Addr=0;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		 for(i=0; i<4; i++)
+      		{
+	      		rtl_mCastModuleArray[index].rtl_gatewayIpv6Addr[i]=0;
+     		 }
+#endif
+		rtl_mCastModuleArray[index].enableSourceList=TRUE;
+	       rtl_mCastModuleArray[index].enableFastLeave=TRUE;
+	       rtl_mCastModuleArray[index].enableSnooping=TRUE;
+		rtl_mCastModuleArray[index].unknownMCastFloodMap=0;
+		rtl_mCastModuleArray[index].staticRouterPortMask=0;
+
+#ifdef CONFIG_PROC_FS
+		rtl_mCastModuleArray[index].expireEventCnt=0;
+#endif
+		*moduleIndex=index;
+		return SUCCESS;
+	}
+	else
+	{
+	       return FAILED;
+	}
+
+	*moduleIndex=index;
+	*moduleIndex=index;
+	return SUCCESS;
+}
+
+
+/*
+@func int32	| rtl_unregisterIgmpSnoopingModule	|  Unregister an igmp snooping module.
+@parm  uint32	| moduleIndex	| Igmp snooping module index.
+@rvalue SUCCESS	|Unregister igmp snooping module successfully.
+@rvalue FAILED	|Unregister igmp snooping module failed.
+@comm
+ This function should be called once a second to maintain multicast timer list.
+*/
+int32 rtl_unregisterIgmpSnoopingModule(uint32 moduleIndex)
+{
+	uint32 i=0;
+	struct rtl_groupEntry *groupEntryPtr=NULL;
+
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+       if(rtl_mCastModuleArray[moduleIndex].enableSnooping==TRUE)
+       {
+
+		 rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv4Addr=0;
+
+          	 for(i=0; i<6; i++)
+     		{
+	   		 rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[i]=0;
+      		}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		for(i=0;i<4;i++)
+		{
+			rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[i]=0;
+		}
+#endif
+
+	 	 /*delete ipv4 multicast entry*/
+        	for(i=0;i<rtl_hashTableSize;i++)
+	     	{
+			groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+
+			while(groupEntryPtr!=NULL)
+			{
+				rtl_deleteGroupEntry(groupEntryPtr, rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+				groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+			}
+	       }
+		rtl_glueFree(rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable=NULL;
+		memset(&(rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters), 0, sizeof(struct rtl_multicastRouters));
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		/*delete ipv6 multicast entry*/
+		for(i=0; i<rtl_hashTableSize; i++)
+		{
+
+			groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i];
+			while(groupEntryPtr!=NULL)
+			{
+				rtl_deleteGroupEntry(groupEntryPtr, rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+				groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i];
+			}
+		}
+		rtl_glueFree(rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable=NULL;
+		memset(&(rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters), 0, sizeof(struct rtl_multicastRouters));
+#endif
+
+		rtl_mCastModuleArray[moduleIndex].enableSnooping=FALSE;
+		rtl_mCastModuleArray[moduleIndex].enableSourceList=TRUE;
+		rtl_mCastModuleArray[moduleIndex].enableFastLeave=TRUE;
+
+		rtl_mCastModuleArray[moduleIndex].unknownMCastFloodMap=0;
+		rtl_mCastModuleArray[moduleIndex].staticRouterPortMask=0;
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		memset(&rtl_mCastModuleArray[moduleIndex].deviceInfo,0,sizeof(rtl_multicastDeviceInfo_t));
+#endif
+	       return SUCCESS;
+       }
+
+	 return SUCCESS;
+
+}
+
+static void _rtl865x_configIgmpSnoopingExpire(int32 disableExpire)
+{
+	uint32 maxTime=0xffffffff;
+
+	if((rtl_mCastTimerParas.disableExpire==FALSE) && (disableExpire==TRUE))
+	{
+		rtl_mCastTimerParas.disableExpire=TRUE;
+	}
+
+	if((rtl_mCastTimerParas.disableExpire==TRUE) && (disableExpire==FALSE) )
+	{
+#if defined(__linux__) && defined(__KERNEL__)
+		struct timeval currentTimeVector;
+		do_gettimeofday(&currentTimeVector);
+		/*reset start time*/
+		if(currentTimeVector.tv_sec>=rtl_sysUpSeconds)
+		{
+			rtl_startTime=(uint32)(currentTimeVector.tv_sec)-rtl_sysUpSeconds;
+		}
+		else
+		{
+			/*avoid timer wrap back*/
+			rtl_startTime=maxTime-rtl_sysUpSeconds+(uint32)(currentTimeVector.tv_sec)+1;
+		}
+#endif
+		rtl_mCastTimerParas.disableExpire=FALSE;
+	}
+
+
+	return;
+}
+
+//External called function by high level program
+/*
+@func  void	| rtl_setMulticastParameters	|   API to config igmp snooping time parameters.
+@parm  struct rtl_mCastTimerParameters	| mCastTimerParameters	|IGMP snooping time parameters to be set.
+*/
+void rtl_setMulticastParameters(struct rtl_mCastTimerParameters mCastTimerParameters)
+{
+	_rtl865x_configIgmpSnoopingExpire(mCastTimerParameters.disableExpire);
+
+	if(mCastTimerParameters.groupMemberAgingTime!=0)
+	{
+		rtl_mCastTimerParas.groupMemberAgingTime= mCastTimerParameters.groupMemberAgingTime;
+	}
+
+	if(mCastTimerParameters.lastMemberAgingTime!=0)
+	{
+		rtl_mCastTimerParas.lastMemberAgingTime= mCastTimerParameters.lastMemberAgingTime;
+	}
+
+	if(mCastTimerParameters.querierPresentInterval!=0)
+	{
+
+		rtl_mCastTimerParas.querierPresentInterval=mCastTimerParameters.querierPresentInterval;
+	}
+
+
+	if(mCastTimerParameters.dvmrpRouterAgingTime!=0)
+	{
+
+		rtl_mCastTimerParas.dvmrpRouterAgingTime=mCastTimerParameters.dvmrpRouterAgingTime;
+	}
+
+	if(mCastTimerParameters.mospfRouterAgingTime!=0)
+	{
+
+		rtl_mCastTimerParas.mospfRouterAgingTime=mCastTimerParameters.mospfRouterAgingTime;
+	}
+
+	if(mCastTimerParameters.pimRouterAgingTime!=0)
+	{
+
+		rtl_mCastTimerParas.pimRouterAgingTime=mCastTimerParameters.pimRouterAgingTime;
+	}
+
+	return;
+}
+
+/*
+@func int32	| rtl_configIgmpSnoopingModule	|   API to config local parameters of an igmp snooping module.
+@parm  uint32	| moduleIndex	| Input parameter to specify an igmp snooping module.
+@parm  struct rtl_mCastSnoopingLocalConfig *	| mCastSnoopingLocalConfig	| Local parameters to be set to an igmp snooping module
+@rvalue SUCCESS	| Configuration  success.
+@rvalue FAILED	| Configuration failed.
+*/
+int32 rtl_configIgmpSnoopingModule(uint32 moduleIndex, struct rtl_mCastSnoopingLocalConfig *mCastSnoopingLocalConfig)
+{
+
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+	if(mCastSnoopingLocalConfig==NULL)
+	{
+		return FAILED;
+	}
+
+	if(rtl_mCastModuleArray[moduleIndex].enableSnooping==FALSE)
+	{
+		return FAILED;
+	}
+
+	rtl_mCastModuleArray[moduleIndex].enableSourceList=mCastSnoopingLocalConfig->enableSourceList;
+	rtl_mCastModuleArray[moduleIndex].enableFastLeave=mCastSnoopingLocalConfig->enableFastLeave;
+	rtl_mCastModuleArray[moduleIndex].unknownMCastFloodMap=mCastSnoopingLocalConfig->unknownMcastFloodMap;
+	rtl_mCastModuleArray[moduleIndex].staticRouterPortMask=mCastSnoopingLocalConfig->staticRouterPortMask;
+
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[0]=mCastSnoopingLocalConfig->gatewayMac[0];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[1]=mCastSnoopingLocalConfig->gatewayMac[1];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[2]=mCastSnoopingLocalConfig->gatewayMac[2];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[3]=mCastSnoopingLocalConfig->gatewayMac[3];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[4]=mCastSnoopingLocalConfig->gatewayMac[4];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[5]=mCastSnoopingLocalConfig->gatewayMac[5];
+
+
+
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv4Addr=mCastSnoopingLocalConfig->gatewayIpv4Addr;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[0]=mCastSnoopingLocalConfig->gatewayIpv6Addr[0];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[1]=mCastSnoopingLocalConfig->gatewayIpv6Addr[1];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[2]=mCastSnoopingLocalConfig->gatewayIpv6Addr[2];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[3]=mCastSnoopingLocalConfig->gatewayIpv6Addr[3];
+#endif
+	return SUCCESS;
+}
+
+/*
+@func int32	| rtl_maintainMulticastSnoopingTimerList	|   Maintain igmp snooping internal timer list.
+@parm  uint32	| currentSystemTime	|The current system time (unit: seconds).
+@rvalue SUCCESS	|Always return SUCCESS.
+@comm
+ This function should be called every second
+*/
+int32 rtl_maintainMulticastSnoopingTimerList(uint32 currentSystemTime)
+{
+	/* maintain current time */
+	uint32 i=0;
+	uint32 maxTime=0xffffffff;
+
+	struct rtl_groupEntry* groupEntryPtr=NULL;
+	struct rtl_groupEntry* nextEntry=NULL;
+
+	uint32 moduleIndex;
+
+	if(rtl_mCastTimerParas.disableExpire==TRUE)
+	{
+		return SUCCESS;
+	}
+
+	/*handle timer conter overflow*/
+	if(currentSystemTime>rtl_startTime)
+	{
+		rtl_sysUpSeconds=currentSystemTime-rtl_startTime;
+	}
+	else
+	{
+		rtl_sysUpSeconds=(maxTime-rtl_startTime)+currentSystemTime+1;
+	}
+
+	for(moduleIndex=0; moduleIndex<MAX_MCAST_MODULE_NUM; moduleIndex++)
+	{
+		if(rtl_mCastModuleArray[moduleIndex].enableSnooping==TRUE)
+		{
+			#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+			strcpy(timerEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+			timerEventContext.moduleIndex=moduleIndex;
+			#endif
+
+			/*maintain ipv4 group entry  timer */
+			for(i=0; i<rtl_hashTableSize; i++)
+			{
+				  /*scan the hash table*/
+				 if(rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable!=NULL)
+				 {
+					groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+					while(groupEntryPtr)              /*traverse each group list*/
+					{
+						nextEntry=groupEntryPtr->next;
+						#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+						timerEventContext.groupAddr[0]=groupEntryPtr->groupAddr[0];
+						#endif
+						rtl_checkGroupEntryTimer(groupEntryPtr, rtl_mCastModuleArray[moduleIndex].enableSourceList, rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+						groupEntryPtr=nextEntry;/*because expired group entry  will be cleared*/
+					}
+				 }
+			}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			/*maintain ipv6 group entry  timer */
+			for(i=0; i<rtl_hashTableSize; i++)
+			{
+				  /*scan the hash table*/
+				if(rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable!=NULL)
+				{
+					groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i];
+					while(groupEntryPtr)              /*traverse each group list*/
+					{
+						nextEntry=groupEntryPtr->next;
+						rtl_checkGroupEntryTimer(groupEntryPtr, rtl_mCastModuleArray[moduleIndex].enableSourceList, rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+						groupEntryPtr=nextEntry;/*because expired group entry  will be cleared*/
+					}
+				}
+			}
+#endif
+
+		}
+	}
+	return SUCCESS;
+}
+
+
+/*
+@func int32	| rtl_igmpMldProcess	|  API to process an incoming igmp packet.
+@parm  uint32	| moduleIndex	| Igmp snooping module index.
+@parm  uint8 *	| macFrame	| Data pointer of igmp mac frame.
+@parm  uint32	| portNum	| Input parameter to specify at which port this igmp packet was recieved
+@parm  uint32 *	| fwdPortMask	| Output parameter to tell where to relay this igmp packet.
+@rvalue SUCCESS	|Doing igmp snooping successfully.
+@rvalue FAILED	|Doing igmp snooping failed.
+*/
+int32 rtl_igmpMldProcess(uint32 moduleIndex, uint8 * macFrame,  uint32 portNum, uint32 *fwdPortMask)
+{
+
+	struct rtl_macFrameInfo macFrameInfo;
+
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	reportEventContext.portMask=1<<portNum;
+	#endif
+
+	*fwdPortMask=(~(1<<portNum)) & 0xFFFFFFFF;
+
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+	//rtl_parseMacFrame(moduleIndex, macFrame, TRUE, &macFrameInfo);
+	rtl_parseMacFrame(moduleIndex, macFrame, FALSE, &macFrameInfo);
+	if(  rtl_mCastModuleArray[moduleIndex].enableSnooping==TRUE)
+	{
+		if(macFrameInfo.ipBuf==NULL)
+		{
+			return FAILED;
+		}
+
+		if((macFrameInfo.ipVersion!=IP_VERSION4) && (macFrameInfo.ipVersion!=IP_VERSION6))
+		{
+
+			return FAILED;
+		}
+
+#ifndef CONFIG_RTL_MLD_SNOOPING
+		if (macFrameInfo.ipVersion==IP_VERSION6)
+		{
+			return FAILED;
+		}
+#endif
+		/*port num starts from 0*/
+		if(portNum>=MAX_SUPPORT_PORT_NUMBER)
+		{
+			return FAILED;
+		}
+		#if 0
+		if(rtl_checkPortMask(pktPortMask)==FAILED)
+		{
+			return FAILED;
+		}
+		#endif
+		if(macFrameInfo.checksumFlag!=SUCCESS)
+		{
+			return FAILED;
+		}
+
+		switch(macFrameInfo.l3Protocol)
+		{
+
+			case IGMP_PROTOCOL:
+				*fwdPortMask=rtl_processIgmpMld(moduleIndex, (uint32)(macFrameInfo.ipVersion), macFrameInfo.l3PktBuf, macFrameInfo.l3PktLen, portNum);
+			break;
+
+			case ICMP_PROTOCOL:
+				*fwdPortMask=rtl_processIgmpMld(moduleIndex, (uint32)(macFrameInfo.ipVersion), macFrameInfo.l3PktBuf, macFrameInfo.l3PktLen, portNum);
+			break;
+
+
+			case DVMRP_PROTOCOL:
+				*fwdPortMask=rtl_processDvmrp(moduleIndex, (uint32)(macFrameInfo.ipVersion), macFrameInfo.l3PktBuf, macFrameInfo.l3PktLen, portNum);
+			break;
+
+			case MOSPF_PROTOCOL:
+				*fwdPortMask=rtl_processMospf(moduleIndex, (uint32)(macFrameInfo.ipVersion), macFrameInfo.l3PktBuf, macFrameInfo.l3PktLen,portNum);
+			break;
+
+			case PIM_PROTOCOL:
+				*fwdPortMask=rtl_processPim(moduleIndex, (uint32)(macFrameInfo.ipVersion), macFrameInfo.l3PktBuf, macFrameInfo.l3PktLen, portNum);
+			break;
+
+			default: break;
+		}
+
+	}
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32	| rtl_getMulticastDataFwdPortMask	| API to get multicast data forward port mask.
+@parm  uint32	| moduleIndex	| Igmp snooping module index.
+@parm  struct rtl_multicastDataInfo *	| multicastDataInfo	| Multicast data related information.
+@parm  uint32 *	| fwdPortMask	|Output parameter to tell where to forward this multicast data.
+@rvalue SUCCESS	| Get multicast data forward port mask successfully.
+@rvalue FAILED	| Get multicast data forward port mask failed.
+*/
+int32 rtl_getMulticastDataFwdPortMask(uint32 moduleIndex, struct rtl_multicastDataInfo *multicastDataInfo, uint32 *fwdPortMask)
+{
+	int32 retVal=FAILED;
+	struct rtl_multicastFwdInfo multicastFwdInfo;
+
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+	if(multicastDataInfo==NULL)
+	{
+		return FAILED;
+	}
+
+	if(fwdPortMask==NULL)
+	{
+		return FAILED;
+	}
+
+	retVal=rtl_getMulticastDataFwdInfo( moduleIndex, multicastDataInfo, &multicastFwdInfo);
+
+	*fwdPortMask=multicastFwdInfo.fwdPortMask;
+
+	return retVal;
+
+}
+
+
+
+int32 rtl_getMulticastDataFwdInfo(uint32 moduleIndex, struct rtl_multicastDataInfo *multicastDataInfo, struct rtl_multicastFwdInfo *multicastFwdInfo)
+{
+
+	struct rtl_groupEntry * groupEntry=NULL;
+	uint32 multicastRouterPortMask=0;
+
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+	if(multicastDataInfo==NULL)
+	{
+		return FAILED;
+	}
+
+	if(multicastFwdInfo==NULL)
+	{
+		return FAILED;
+	}
+
+	memset(multicastFwdInfo, 0, sizeof(struct rtl_multicastFwdInfo));
+
+	if(multicastDataInfo->groupAddr[0]==RESERVE_MULTICAST_ADDR1)
+	{
+		multicastFwdInfo->reservedMCast=TRUE;
+		multicastFwdInfo->fwdPortMask=0xFFFFFFFF;
+		multicastFwdInfo->cpuFlag=TRUE;
+
+		return FAILED;
+	}
+
+	if(IN_MULTICAST_RESV1(multicastDataInfo->groupAddr[0]) )
+	{
+		multicastFwdInfo->reservedMCast=TRUE;
+		multicastFwdInfo->fwdPortMask=0xFFFFFFFF;
+		multicastFwdInfo->cpuFlag=TRUE;
+
+		return FAILED;
+	}
+
+	groupEntry=rtl_searchGroupEntry(moduleIndex,multicastDataInfo->ipVersion, multicastDataInfo->groupAddr);
+
+	if(groupEntry==NULL)
+	{
+		multicastFwdInfo->unknownMCast=TRUE;
+		multicastFwdInfo->fwdPortMask= rtl_mCastModuleArray[moduleIndex].unknownMCastFloodMap;
+
+		#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		if((multicastFwdInfo->fwdPortMask & rtl_mCastModuleArray[moduleIndex].deviceInfo.swPortMask)!=0)
+		{
+			multicastFwdInfo->cpuFlag=TRUE;
+		}
+		#endif
+
+		return SUCCESS;
+	}
+	else
+	{
+		/*here to get multicast router port mask and forward port mask*/
+		//multicastRouterPortMask=rtl_getMulticastRouterPortMask(moduleIndex, multicastDataInfo->ipVersion, rtl_sysUpSeconds);
+		if(rtl_mCastModuleArray[moduleIndex].enableSourceList==TRUE)
+		{
+			multicastFwdInfo->fwdPortMask=rtl_getSourceFwdPortMask(groupEntry, multicastDataInfo->sourceIp, rtl_sysUpSeconds);
+		}
+		else
+		{
+			if(groupEntry!=NULL)
+			{
+				multicastFwdInfo->fwdPortMask=(uint32)rtl_getGroupFwdPortMask(groupEntry,0, rtl_sysUpSeconds);
+			}
+
+		}
+
+		multicastFwdInfo->fwdPortMask=(multicastFwdInfo->fwdPortMask|multicastRouterPortMask);
+
+		#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		if((multicastFwdInfo->fwdPortMask & rtl_mCastModuleArray[moduleIndex].deviceInfo.swPortMask)!=0)
+		{
+			multicastFwdInfo->cpuFlag=TRUE;
+		}
+		#endif
+
+		return SUCCESS;
+
+	}
+	return FAILED;
+
+}
+
+#if defined(__linux__) && defined(__KERNEL__)
+
+static void rtl_multicastSysTimerExpired(uint32 expireDada)
+{
+	struct timeval currentTimeVector;
+
+	do_gettimeofday(&currentTimeVector);
+	rtl_maintainMulticastSnoopingTimerList((uint32)(currentTimeVector.tv_sec));
+	mod_timer(&igmpSysTimer, jiffies+HZ);
+
+}
+
+static void rtl_multicastSysTimerInit(void)
+{
+	struct timeval startTimeVector;
+	do_gettimeofday(&startTimeVector);
+	rtl_startTime=(uint32)(startTimeVector.tv_sec);
+	rtl_sysUpSeconds=0;
+
+	init_timer(&igmpSysTimer);
+	igmpSysTimer.data=igmpSysTimer.expires;
+	igmpSysTimer.expires=jiffies+HZ;
+	igmpSysTimer.function=(void*)rtl_multicastSysTimerExpired;
+	add_timer(&igmpSysTimer);
+}
+
+static void rtl_multicastSysTimerDestroy(void)
+{
+	del_timer(&igmpSysTimer);
+}
+
+#endif
+
+int32 rtl_getDeviceIgmpSnoopingModuleIndex(rtl_multicastDeviceInfo_t *devInfo,uint32 *moduleIndex)
+{
+	int i;
+	*moduleIndex=0xFFFFFFFF;
+	if(devInfo==NULL)
+	{
+		return FAILED;
+	}
+
+	for(i=0; i<MAX_MCAST_MODULE_NUM; i++)
+	{
+		if(rtl_mCastModuleArray[i].enableSnooping==TRUE)
+		{
+			if(strcmp(rtl_mCastModuleArray[i].deviceInfo.devName, devInfo->devName)==0)
+			{
+				*moduleIndex=i;
+				return SUCCESS;
+			}
+		}
+	}
+
+	return FAILED;
+}
+
+int32 rtl865x_getDeviceIgmpSnoopingModuleIndex(rtl_multicastDeviceInfo_t *devInfo,uint32 *moduleIndex)
+{
+	return rtl_getDeviceIgmpSnoopingModuleIndex(devInfo,moduleIndex);
+}
+
+
+/*
+@func int32	| rtl_setIgmpSnoopingModuleDevInfo	|   API to set igmp snooping module related device information.
+@parm  uint32	| moduleIndex	| Input parameter to specify igmp snooping module.
+@parm  rtl_multicastDeviceInfo_t	*| devInfo	| Device information to be set.
+@rvalue SUCCESS	|Setting success.
+@rvalue FAILED	|Setting failed.
+*/
+int32 rtl_setIgmpSnoopingModuleDevInfo(uint32 moduleIndex,rtl_multicastDeviceInfo_t *devInfo)
+{
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+	if(devInfo==NULL)
+	{
+		return FAILED;
+	}
+
+	if(rtl_mCastModuleArray[moduleIndex].enableSnooping==FALSE)
+	{
+		return FAILED;
+	}
+
+	memcpy(&rtl_mCastModuleArray[moduleIndex].deviceInfo,devInfo, sizeof(rtl_multicastDeviceInfo_t));
+
+	return SUCCESS;
+}
+
+int32 rtl_setIgmpSnoopingModuleStaticRouterPortMask(uint32 moduleIndex,uint32 staticRouterPortMask)
+{
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+	if(rtl_mCastModuleArray[moduleIndex].enableSnooping==FALSE)
+	{
+		return FAILED;
+	}
+
+
+	rtl_mCastModuleArray[moduleIndex].staticRouterPortMask=staticRouterPortMask;
+
+	return SUCCESS;
+}
+
+int32 rtl_getgmpSnoopingModuleStaticRouterPortMask(uint32 moduleIndex,uint32 *staticRouterPortMask)
+{
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+	if(staticRouterPortMask==NULL)
+	{
+		return FAILED;
+	}
+
+	if(rtl_mCastModuleArray[moduleIndex].enableSnooping==FALSE)
+	{
+		return FAILED;
+	}
+
+	*staticRouterPortMask=rtl_mCastModuleArray[moduleIndex].staticRouterPortMask;
+
+	return SUCCESS;
+}
+
+
+int32 rtl_setIgmpSnoopingModuleUnknownMCastFloodMap(uint32 moduleIndex,uint32 unknownMCastFloodMap)
+{
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+	if(rtl_mCastModuleArray[moduleIndex].enableSnooping==FALSE)
+	{
+		return FAILED;
+	}
+
+	rtl_mCastModuleArray[moduleIndex].unknownMCastFloodMap=unknownMCastFloodMap;
+
+	return SUCCESS;
+}
+
+int32 rtl_getIgmpSnoopingModuleUnknownMCastFloodMap(uint32 moduleIndex,uint32 *unknownMCastFloodMap)
+{
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+	if(unknownMCastFloodMap==NULL)
+	{
+		return FAILED;
+	}
+
+	if(rtl_mCastModuleArray[moduleIndex].enableSnooping==FALSE)
+	{
+		return FAILED;
+	}
+
+	*unknownMCastFloodMap=rtl_mCastModuleArray[moduleIndex].unknownMCastFloodMap;
+
+	return SUCCESS;
+}
+
+/*
+@func int32	| rtl_setIgmpSnoopingModuleDevInfo	| API to get igmp snooping module related device information.
+@parm  uint32	| moduleIndex	| Input parameter to specify igmp snooping module
+@parm  rtl_multicastDeviceInfo_t	*| devInfo	| Output parameter to store the device information of specified igmp snooping module.
+@rvalue SUCCESS	|Geting success.
+@rvalue FAILED	|Getting failed.
+*/
+int32 rtl_getIgmpSnoopingModuleDevInfo(uint32 moduleIndex,rtl_multicastDeviceInfo_t *devInfo)
+{
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return FAILED;
+	}
+
+	if(devInfo==NULL)
+	{
+		return FAILED;
+	}
+	memset(devInfo,0,sizeof(rtl_multicastDeviceInfo_t));
+
+	if(rtl_mCastModuleArray[moduleIndex].enableSnooping==FALSE)
+	{
+		return FAILED;
+	}
+
+	memcpy(devInfo,&rtl_mCastModuleArray[moduleIndex].deviceInfo, sizeof(rtl_multicastDeviceInfo_t));
+	return SUCCESS;
+}
+
+
+
+#ifdef CONFIG_PROC_FS
+int igmp_show(struct seq_file *s, void *v)
+{
+	int32 moduleIndex;
+	int i=0,j=0;
+	struct rtl_groupEntry *groupEntryPtr;
+	struct rtl_sourceEntry *sourceEntryPtr;
+	int groupCnt=0;
+	for(moduleIndex=0; moduleIndex<MAX_MCAST_MODULE_NUM ;moduleIndex++)
+	{
+		if(rtl_mCastModuleArray[moduleIndex].enableSnooping==TRUE)
+		{
+			groupCnt=0;
+			seq_printf(s, "---------------------------------------------\n");
+			seq_printf(s, "module index:%d,",moduleIndex);
+			#ifdef CONFIG_RTL_HARDWARE_MULTICAST
+			seq_printf(s, "device name:%s\n",rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+			#endif
+			for(i=0;i<rtl_hashTableSize;i++)
+		     	{
+				groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+
+				while(groupEntryPtr!=NULL)
+				{
+					groupCnt++;
+					seq_printf(s, "[%d]group address:%d.%d.%d.%d\n",groupCnt,
+						groupEntryPtr->groupAddr[0]>>24, (groupEntryPtr->groupAddr[0]&0x00ff0000)>>16,
+						(groupEntryPtr->groupAddr[0]&0x0000ff00)>>8, (groupEntryPtr->groupAddr[0]&0xff));
+
+					for(j=0;j<MAX_SUPPORT_PORT_NUMBER;j++)
+					{
+						if(groupEntryPtr->groupFilterTimer[j]>=rtl_sysUpSeconds)
+						{
+							seq_printf(s, "\tgroup timer[port%d]:%d seconds\n",j,groupEntryPtr->groupFilterTimer[j]-rtl_sysUpSeconds);
+						}
+						else
+						{
+							//printk("\tgroup timer[port%d]:0 seconds\n",j);
+
+						}
+					}
+
+					sourceEntryPtr=groupEntryPtr->sourceList;
+					while(sourceEntryPtr!=NULL)
+					{
+						seq_printf(s, "\t\tsource address:%d.%d.%d.%d\n",
+						sourceEntryPtr->sourceAddr[0]>>24, (sourceEntryPtr->sourceAddr[0]&0x00ff0000)>>16,
+						(sourceEntryPtr->sourceAddr[0]&0x0000ff00)>>8, (sourceEntryPtr->sourceAddr[0]&0xff));
+						for(j=0;j<MAX_SUPPORT_PORT_NUMBER;j++)
+						{
+							if(sourceEntryPtr->portTimer[j]>=rtl_sysUpSeconds)
+							{
+								seq_printf(s, "\t\tsource  timer[port%d]:%d seconds\n",j,sourceEntryPtr->portTimer[j]-rtl_sysUpSeconds);
+							}
+							else
+							{
+								//printk("\t\tsource  timer[port%d]:0 seconds\n",j);
+							}
+						}
+						sourceEntryPtr=sourceEntryPtr->next;
+					}
+					seq_printf(s, "\n");
+					groupEntryPtr=groupEntryPtr->next;
+				}
+		       }
+			seq_printf(s, "expire event cnt is %d\n",rtl_mCastModuleArray[moduleIndex].expireEventCnt);
+			seq_printf(s, "\n\n");
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+
+
+void rtl865x_igmpLinkStatusChangeCallback(uint32 moduleIndex, rtl_igmpPortInfo_t * portInfo)
+{
+	int i=0,j=0;
+	int32 clearFlag=FALSE;
+	struct rtl_groupEntry *groupEntryPtr;
+	struct rtl_sourceEntry *sourceEntryPtr;
+
+
+	if(portInfo==NULL)
+	{
+		return ;
+	}
+
+	if(moduleIndex>=MAX_MCAST_MODULE_NUM)
+	{
+		return ;
+	}
+
+
+	if(rtl_mCastModuleArray[moduleIndex].enableSnooping==TRUE)
+	{
+
+		for(i=0;i<rtl_hashTableSize;i++)
+	     	{
+			groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+
+			while(groupEntryPtr!=NULL)
+			{
+				clearFlag=FALSE;
+
+				for(j=0;j<MAX_SUPPORT_PORT_NUMBER;j++)
+				{
+					if(( (1<<j) & (portInfo->linkPortMask)) ==0)
+					{
+						if(groupEntryPtr->groupFilterTimer[j]!=0)
+						{
+							groupEntryPtr->groupFilterTimer[j]=0;
+							clearFlag=TRUE;
+						}
+					}
+
+				}
+
+				sourceEntryPtr=groupEntryPtr->sourceList;
+				while(sourceEntryPtr!=NULL)
+				{
+
+
+					for(j=0;j<MAX_SUPPORT_PORT_NUMBER;j++)
+					{
+						if(( (1<<j) & (portInfo->linkPortMask)) ==0)
+						{
+							if(sourceEntryPtr->portTimer[j]!=0)
+							{
+								sourceEntryPtr->portTimer[j]=0;
+								clearFlag=TRUE;
+							}
+						}
+
+					}
+					sourceEntryPtr=sourceEntryPtr->next;
+				}
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+				if(clearFlag==TRUE)
+				{
+					strcpy(linkEventContext.devName,rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+					linkEventContext.moduleIndex=moduleIndex;
+
+					linkEventContext.groupAddr[0]=groupEntryPtr->groupAddr[0];
+					linkEventContext.groupAddr[1]=groupEntryPtr->groupAddr[1];
+					linkEventContext.groupAddr[2]=groupEntryPtr->groupAddr[2];
+					linkEventContext.groupAddr[3]=groupEntryPtr->groupAddr[3];
+
+					linkEventContext.sourceAddr[0]=0;
+					linkEventContext.sourceAddr[1]=0;
+					linkEventContext.sourceAddr[2]=0;
+					linkEventContext.sourceAddr[3]=0;
+
+					rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &linkEventContext);
+				}
+#endif
+
+				groupEntryPtr=groupEntryPtr->next;
+			}
+	       }
+
+	}
+
+	return ;
+}
+
+int32 rtl_getGroupInfo(uint32 groupAddr, struct rtl_groupInfo * groupInfo)
+{
+	int32 moduleIndex;
+	int32 hashIndex;
+	struct rtl_groupEntry *groupEntryPtr;
+
+	if(groupInfo==NULL)
+	{
+		return FAILED;
+	}
+
+	memset(groupInfo, 0 , sizeof(struct rtl_groupInfo));
+
+	for(moduleIndex=0; moduleIndex<MAX_MCAST_MODULE_NUM ;moduleIndex++)
+	{
+		if(rtl_mCastModuleArray[moduleIndex].enableSnooping==TRUE)
+		{
+			hashIndex=rtl_hashMask&groupAddr;
+			groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[hashIndex];
+
+			while(groupEntryPtr!=NULL)
+			{
+				if(groupEntryPtr->groupAddr[0]==groupAddr)
+				{
+					groupInfo->ownerMask |= (1<<moduleIndex);
+					break;
+				}
+				groupEntryPtr=groupEntryPtr->next;
+			}
+
+		}
+	}
+
+	return SUCCESS;
+}
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping_glue.c b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping_glue.c
new file mode 100644
index 00000000..a36851b
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping_glue.c
@@ -0,0 +1,97 @@
+/*
+* Copyright c                  Realsil Semiconductor Corporation, 2006
+* All rights reserved.
+*
+* Program :  IGMP glue file
+* Abstract :
+* Author :qinjunjie
+* Email:qinjunjie1980@hotmail.com
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+*/
+
+
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include <net/rtl/rtl865x_igmpsnooping_glue.h>
+#include "AsicDriver/rtl865xc_asicregs.h"
+
+#ifdef __linux__
+#include <linux/mm.h>
+#include	<linux/gfp.h>
+#endif
+
+/*
+@func int32	| rtl_glueMutexLock	|  glue function for system mutex lock
+@rvalue 0| always return 0;
+@comm
+ user should modify this function to glue different OS.
+*/
+
+void rtl_glueMutexLock(void)
+{
+	//rtlglue_drvMutexLock();
+	return;
+}
+
+
+
+/*
+@func int32	| rtl_glueMutexUnlock	|  Glue function for system mutex unlock
+@rvalue 0| always return 0;
+@comm
+ User should modify this function to glue different OS.
+*/
+void rtl_glueMutexUnlock(void)
+{
+	//rtlglue_drvMutexUnlock();
+	return;
+}
+
+
+/*
+@func void*	| rtl_glueMalloc	|   Glue function for memory allocation
+@parm uint32	| NBYTES		| Specifies the number of memory bytes to be allocated
+@rvalue void*| The memory pointer after allocation
+@comm
+ User should modify this function according to different OS.
+*/
+void *rtl_glueMalloc(uint32 NBYTES)
+{
+#ifndef RTL_MULTICAST_SNOOPING_TEST
+	if(NBYTES==0) return NULL;
+	return (void *)kmalloc(NBYTES,GFP_ATOMIC);
+
+#else
+	return malloc(NBYTES);
+
+#endif
+
+}
+
+/*
+@func void	| rtl_glueFree	|Glue function for memory free
+@parm void *	| APTR		| Specifies the memory buffer to be freed
+@comm
+  User should modify this function according to different OS.
+*/
+void rtl_glueFree(void *APTR)
+{
+
+#ifndef RTL_MULTICAST_SNOOPING_TEST
+	kfree(APTR);
+#else
+	free(APTR);
+#endif
+
+}
+
+
+
+
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping_local.h b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping_local.h
new file mode 100644
index 00000000..0eed369
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping_local.h
@@ -0,0 +1,589 @@
+/*
+* Copyright c                  Realsil Semiconductor Corporation, 2006
+* All rights reserved.
+*
+* Program :  IGMP snooping function
+* Abstract :
+* Author :qinjunjie
+* Email:qinjunjie1980@hotmail.com
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+*/
+
+#ifndef RTL_MULTICASTV2_LOCAL_H
+#define RTL_MULTICASTV2_LOCAL_H
+
+ /*                                               Macro declaration                                         */
+
+
+/***********************************Utilities************************************************/
+#define IS_CLASSD_ADDR(ipv4addr)				((((uint32)(ipv4addr)) & 0xf0000000) == 0xe0000000)
+#define RESERVE_MULTICAST_ADDR1 	0xEFFFFFFA
+/* ip 225.1.1.1 is not in the list of "http://www.iana.org/assignments/multicast-addresses/multicast-addresses.xml",
+	but it is used by customer's VoIP phone device.
+ */
+#define IS_RESERVE_MULTICAST_MDNS_ADDR_V4(ipv4addr) 	((((uint32)(ipv4addr)) & 0xFFFFFFFF) == 0xE00000FB)//224.0.0.251
+#define IS_RESERVE_MULTICAST_MDNS_ADDR_V6(ipv6addr) 	(((ipv6addr[0] & 0xFFFFFFFF)==0xff020000)&&((ipv6addr[1] & 0xFFFFFFFF)==0x00000000)&&((ipv6addr[2] & 0xFFFFFFFF)==0x00000000)&&((ipv6addr[3] & 0xFFFFFFFF)==0x000000FB))
+#define RESERVE_MULTICAST_ADDR2 	0xE1010101	//225.1.1.1
+#define IN_MULTICAST_RESV1(addr)	((((uint32)(addr)) & 0xFFFFFF00) == 0xe0000000)	// 224.0.0.x
+#define IN_MULTICAST_RESV2(addr)	((((uint32)(addr)) & 0xFF000000) == 0xEF000000)	// 239.0.0.0~239.255.255.255
+
+#define IS_IPV6_MULTICAST_ADDRESS(ipv6addr)	((ipv6addr[0] & 0xFF000000)==0xff000000)
+#define IS_IPV4_MULTICAST_ADDRESS(ipv4addr)	(IS_CLASSD_ADDR(ipv4addr[0]))
+
+#define CONFIG_STATIC_RESERVED_MULTICAST
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+#define STATIC_RESERVED_MULTICAST 	0x01
+#endif
+
+#define PORT0_MASK 0x01
+#define PORT1_MASK 0x02
+#define PORT2_MASK 0x04
+#define PORT3_MASK 0x08
+#define PORT4_MASK 0x10
+#define PORT5_MASK 0x20
+
+#ifdef CONFIG_NEW_IGMP_IMPLEMENTATION
+#define MAX_SUPPORT_PORT_NUMBER 16
+#else
+#define MAX_SUPPORT_PORT_NUMBER 10
+#endif
+#define DEFAULT_HASH_TABLE_SIZE 64
+#define MAX_HASH_TABLE_SIZE 1024
+#define MAX_MCAST_MODULE_NUM 8
+
+#define NON_PORT_MASK 0x00
+#define IPV4_MCAST_MAC_MASK 0x007fffff
+#define IPV6_MCAST_MAC_MASK 0x00ffffff
+
+
+
+/* IGMP snooping default  parameters */
+#define DEFAULT_MAX_GROUP_COUNT					     256	         /* default max group entry count **/
+#define DEFAULT_MAX_SOURCE_COUNT                                  300         /*default max source entry count*/
+#define DEFAULT_MAX_CLIENT_COUNT			256
+#define DEFAULT_MAX_FLOW_COUNT			256
+
+#define DEFAULT_LAST_MEMBER_AGINTGTIME 2
+#define DEFAULT_GROUP_MEMBER_INTERVAL 600             /* IGMP group member interval, default is 260 seconds */
+#define DEFAULT_LAST_MEMBER_INTERVAL  10             /* IGMP last member query time, default is 2 seconds */
+#define DEFAULT_QUERIER_PRESENT_TIMEOUT 260             /* IGMP  querier present timeout, default is 260 seconds */
+
+#define DEFAULT_MCAST_FLOW_EXPIRE_TIME 	15
+
+#define DEFAULT_DVMRP_AGING_TIME		120
+#define DEFAULT_PIM_AGING_TIME		120
+#define DEFAULT_MOSPF_AGING_TIME		120
+
+#define DEFAULT_IPV4_UNKNOWN_MCAST_FLOOD_MAP	0x0
+#define DEFAULT_IPV6_UNKNOWN_MCAST_FLOOD_MAP	0xFFFFFFFF
+
+#define IP_VERSION4 4
+#define IP_VERSION6 6
+#define BOTH_IPV4_IPV6 0x46
+
+#define CPUTAGPROTOCOL 0x09
+#define VLAN_PROTOCOL_ID 0x8100
+
+#define IPV4_ETHER_TYPE 0x0800
+#define IPV6_ETHER_TYPE 0x86DD
+
+#define PPPOE_ETHER_TYPE 0x8864
+#define PPP_IPV4_PROTOCOL 0x0021
+#define PPP_IPV6_PROTOCOL 0x0057
+#define ROUTER_ALERT_OPTION 0x94040000
+
+#define  HOP_BY_HOP_OPTIONS_HEADER 0
+#define ROUTING_HEADER 43
+#define  FRAGMENT_HEADER 44
+#define DESTINATION_OPTION_HEADER 60
+#define NO_NEXT_HEADER 59
+#define ICMP_PROTOCOL 58
+
+#define DVMRP_ADDR  0xE0000004
+#define DVMRP_TYPE 0x13
+#define DVMRP_PROTOCOL 3
+
+#define PIM_PROTOCOL 103
+#define IPV4_PIM_ADDR 0xE000000D
+#define IS_IPV6_PIM_ADDR(ipv6addr) ((ipv6addr[0] == 0xFF020000)&&(ipv6addr[1] == 0x00000000)&&(ipv6addr[2] == 0x00000000)&&(ipv6addr[3] ==0x0000000D))
+
+#define MOSPF_PROTOCOL 89
+#define MOSPF_HELLO_TYPE 1
+#define IPV4_MOSPF_ADDR1  0xE0000005
+#define IPV4_MOSPF_ADDR2  0xE0000006
+#define IS_IPV6_MOSPF_ADDR1(ipv6addr) ((ipv6addr[0] == 0xFF020000)&&(ipv6addr[1] == 0x00000000)&&(ipv6addr[2] == 0x00000000)&&(ipv6addr[3] ==0x00000005))
+#define IS_IPV6_MOSPF_ADDR2(ipv6addr) ((ipv6addr[0] == 0xFF020000)&&(ipv6addr[1] == 0x00000000)&&(ipv6addr[2] == 0x00000000)&&(ipv6addr[3] ==0x00000006))
+
+
+#define IGMP_PROTOCOL 2
+#define IGMP_ALL_HOSTS_ADDR	0xE0000001	/*general query address*/
+#define IGMP_ALL_ROUTERS_ADDR	0xE0000002  /*leave report address*/
+#define IGMPV3_REPORT_ADDR 0xE0000016
+
+
+#define IS_MLD_ALL_HOSTS_ADDRESS(ipv6addr) ((ipv6addr[0] == 0xFF020000)&&(ipv6addr[1] == 0x00000000)&&(ipv6addr[2] == 0x00000000)&&(ipv6addr[3] ==0x00000001))
+
+
+#define IS_MLD_ALL__ROUTER_ADDRESS(ipv6addr) ((ipv6addr[0] == 0xFF020000)&&(ipv6addr[1] ==0x00000000)&&(ipv6addr[2] ==0x00000000)&&(ipv6addr[3] == 0x00000002))
+
+
+#define IS_MLDv2_REPORT_ADDRESS(ipv6addr) ((ipv6addr[0] == 0xFF020000)&&(ipv6addr[1] == 0x00000000)&&(ipv6addr[2] == 0x00000000)&&(ipv6addr[3] ==0x00000016))
+
+
+/*            IGMP type              */
+#define IGMP_QUERY 0x11
+#define IGMPV1_REPORT 0x12
+#define IGMPV2_REPORT 0x16
+#define IGMPV2_LEAVE 0x17
+#define IGMPV3_REPORT 0x22
+
+/*             MLD type          */
+#define MLD_QUERY 130
+#define MLDV1_REPORT 131
+#define MLDV1_DONE 132
+#define MLDV2_REPORT 143
+#define S_FLAG_MASK 0x08
+
+#define MODE_IS_INCLUDE			                      1
+#define MODE_IS_EXCLUDE			                      2
+#define CHANGE_TO_INCLUDE_MODE	                      3
+#define CHANGE_TO_EXCLUDE_MODE		               4
+#define ALLOW_NEW_SOURCES                                  5
+#define BLOCK_OLD_SOURCES			                      6
+
+#define	FILTER_MODE_INCLUDE		0
+#define	FILTER_MODE_EXCLUDE		1
+
+		/*             IGMP version                       */
+#define IGMP_V1					       1
+#define IGMP_V2						2
+#define IGMP_V3						3
+
+#define MLD_V1 						1
+#define MLD_V2						2
+
+
+#define IPV4_ROUTER_ALTER_OPTION 0x94040000
+#define IPV6_ROUTER_ALTER_OPTION 0x05020000
+#define IPV6_HEADER_LENGTH 40
+
+/**********************IGMPv3 exponential field decoding ******************************/
+#define	RTL_IGMPV3_MASK(value, nb)		((nb)>=32 ? (value) : ((1<<(nb))-1) & (value))
+#define	RTL_IGMPV3_EXP(thresh, nbmant, nbexp, value) \
+			((value) < (thresh) ? (value) : \
+			((RTL_IGMPV3_MASK(value, nbmant) | (1<<(nbmant))) << \
+			(RTL_IGMPV3_MASK((value) >> (nbmant), nbexp) + (nbexp))))
+
+#define	RTL_IGMPV3_QQIC(value)			RTL_IGMPV3_EXP(0x80, 4, 3, value)
+#define	RTL_IGMPV3_MRC(value)			RTL_IGMPV3_EXP(0x80, 4, 3, value)
+/********************************************************************************/
+
+
+/**************************MLDv2 exponential field decoding ****************************/
+#define   RTL_MLDV2_MASK(value, nb) 	((nb)>=32 ? (value) : ((1<<(nb))-1) & (value))
+#define   RTL_MLDV2_EXP(thresh, nbmant, nbexp, value)\
+	              ((value) < (thresh) ? (value) : \
+			((RTL_MLDV2_MASK(value, nbmant) | (1<<(nbmant))) << \
+			(RTL_MLDV2_MASK((value) >> (nbmant), nbexp) + (nbexp))))
+
+#define   RTL_MLDV2_QQIC(value)			RTL_MLDV2_EXP(0x80, 4, 3, value)
+#define   RTL_MLDV2_MRC(value)			RTL_MLDV2_EXP(0x8000, 12, 3, value)
+/*------------------------------------------------------------------------------*/
+
+struct ipv4Pkt
+{
+	uint8       vhl;
+	uint8	typeOfService;
+	uint16	length;			/* total length */
+	uint16	identification;	/* identification */
+	uint16	offset;
+	uint8	ttl;				/* time to live */
+	uint8	protocol;
+	uint16	checksum;
+	uint32 sourceIp;
+	uint32 destinationIp;
+};
+
+struct igmpPkt{
+	uint8 type;				      /* type*/
+	uint8 maxRespTime;                /*maximum response time,unit:0.1 seconds*/
+	uint16 checksum;
+	uint32 groupAddr;
+
+};
+
+struct igmpv1Pkt
+{
+	uint8 VersionType;	              /*4bits: version, 4bits:type*/
+	uint8 unused;
+	uint16 checkSum;                     /*IGMP packet checksum*/
+	uint32 groupAddr;                    /*multicast group address*/
+};
+
+struct igmpv2Pkt
+{
+	uint8 type;				      /* type*/
+	uint8 maxRespTime;                /*maximum response time,unit:0.1 seconds*/
+	uint16 checkSum;
+	uint32 groupAddr;
+
+};
+
+struct igmpv3Query
+{
+	uint8 type;                                /*query type*/
+	uint8 maxRespCode;			/*maximum response code*/
+	uint16 checkSum;				/*IGMP checksum*/
+	uint32 groupAddr;                    /*multicast group address*/
+	uint8 rsq;					/* 4bit: reserved, 1bit: suppress router-side processing, 3bit: querier's robustness variable*/
+	uint8 qqic;					/* querier's query interval code */
+	uint16 numOfSrc;				/* number of sources */
+	uint32 srcList;				/* first entry of source list */
+};
+
+struct groupRecord
+{
+	uint8	type;					/* Record Type */
+	uint8	auxLen;			              /* auxiliary data length, in uints of 32 bit words*/
+	uint16	numOfSrc;			       /* number of sources */
+	uint32	groupAddr;			       /* group address being reported */
+	uint32	srcList;				       /* first entry of source list */
+
+};
+
+struct igmpv3Report
+{
+	uint8	type;					/* Report Type */
+	uint8  reserved1;
+	uint16 checkSum;					/*IGMP checksum*/
+	uint16 reserved2;
+	uint16	numOfRecords;			       /* number of Group records */
+	struct groupRecord recordList;       /*first entry of group record list*/
+};
+
+struct ipv6Pkt
+{
+	uint32     vtf;                 /*version(4bits),  traffic class(8bits), and flow label(20bits)*/
+	uint16	payloadLenth;			/* payload length */
+	uint8	nextHeader;			/* next header */
+	uint8	hopLimit;			/* hop limit*/
+	uint32     sourceAddr[4];	      /*source address*/
+	uint32    	destinationAddr[4];	      /* destination address */
+};
+
+
+struct mldv1Pkt
+{
+	uint8 type;
+	uint8 code;						/*initialize by sender, ignored by receiver*/
+	uint16 checkSum;
+	uint16 maxResDelay;                       /*maximum response delay,unit:0.001 second*/
+	uint16 reserved;
+	uint32 mCastAddr[4];                      /*ipv6 multicast address*/
+};
+
+
+struct mldv2Query
+{
+	uint8 type;
+	uint8 code;                                   /*initialize by sender, ignored by receiver*/
+	uint16 checkSum;
+	uint16 maxResCode;                      /*maximum response code,unit:0.001 second*/
+	uint16 reserved;
+	uint32 mCastAddr[4];
+	uint8 rsq;	                               /* 4bits: reserved, 1bit: suppress router-side processing, 3bits: querier's robustness variable*/
+	uint8 qqic;                                   /* querier's query interval code */
+	uint16 numOfSrc;				  /* number of sources */
+	uint32 srcList;
+};
+
+struct mCastAddrRecord
+{
+	uint8	type;					/* Record Type */
+	uint8	auxLen;			              /* auxiliary data length, in uints of 32 bit words*/
+	uint16	numOfSrc;			       /* number of sources */
+	uint32	mCastAddr[4];			/* group address being reported */
+	uint32	srcList;			             /* first entry of source list */
+};
+
+struct mldv2Report
+{
+	uint8 type;
+	uint8  reserved1;
+	uint16 checkSum;
+	uint16 reserved2;
+	uint16 numOfRecords;				  /* number of multicast address records */
+	struct mCastAddrRecord recordList;
+};
+
+
+struct ipv4MospfHdr
+{
+	uint8 version;
+	uint8 type;
+	uint16 pktLen;
+	uint32 routerId;
+	uint32 areaId;
+	uint16 CheckSum;
+	uint16 auType;
+	uint32 authentication[2];
+};
+
+struct ipv4MospfHello
+{
+	struct ipv4MospfHdr hdr;
+	uint32 netWorkMask;
+	uint16 helloInterVal;
+	uint8  options;          /*  X-X-DC-EA-N/P-MC-E-X */
+	uint8 routerPriority;
+	uint32 routerDeadInterval;
+	uint32 designatedRouter;
+	uint32 backupDesignatedRouter;
+	uint32 neighbor;
+};
+
+struct ipv6MospfHdr
+{
+	uint8 version; /*vesion is 3*/
+	uint8 type;
+	uint16 pktLen;
+	uint32 routerId;
+	uint32 areaId;
+	uint16 CheckSum;
+	uint8 instanceId;
+	uint8 zeroData;
+
+};
+
+struct ipv6MospfHello
+{
+	struct ipv6MospfHdr hdr;
+	uint32 interfaceId;
+	uint8 routerPriority;
+	uint8  options[3];          /*X-X-DC-R-N-MC-E-V6 */
+	uint16 helloInterval;
+	uint16 routerDeadInterval;
+	uint32 designatedRouter;
+	uint32 backupDesignatedRouter;
+	uint32 neighbor;
+};
+
+struct ipv6PseudoHeader
+{
+	uint32 sourceAddr[4];
+	uint32 destinationAddr[4];
+	uint32 upperLayerPacketLength;
+	uint8  zeroData[3];
+	uint8  nextHeader;
+};
+
+struct ipv4PseudoHeader
+{
+	uint32 sourceAddr;
+	uint32 destinationAddr;
+	uint8 zero;
+	uint8  protocol;
+	uint16  payloadLen;
+};
+
+
+union pseudoHeader
+{
+	struct ipv6PseudoHeader ipv6_pHdr;
+	struct ipv4PseudoHeader ipv4_pHdr;
+};
+
+#ifdef CONFIG_NEW_IGMP_IMPLEMENTATION
+struct rtl_groupEntry
+{
+	struct rtl_groupEntry *previous;
+	struct rtl_groupEntry  *next;             /*Pointer of next group entry*/
+	uint32 ipVersion;
+	#ifdef CONFIG_RTL_MLD_SNOOPING
+	uint32 groupAddr[4];
+	#else
+	uint32 groupAddr[1];
+	#endif
+
+	struct	rtl_clientEntry *clientList;
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	uint32	attribute;
+	uint32 	staticFwdPortMask;
+#endif
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	uint32 idx;
+#endif
+};
+
+struct rtl_clientEntry
+{
+	uint16 igmpVersion;
+	uint16 portNum;
+	struct rtl_clientEntry *previous;
+	struct rtl_clientEntry  *next;             /*Pointer of next group entry*/
+	#ifdef CONFIG_RTL_MLD_SNOOPING
+	uint32 clientAddr[4];	/*client ip address*/
+	#else
+	uint32 clientAddr[1];	/*client ip address*/
+	#endif
+	struct rtl_sourceEntry *sourceList;	/*this is the server source ip list*/
+	uint32 groupFilterTimer;
+	uint8 clientMacAddr[6];
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	uint32 idx;
+#endif
+};
+
+
+struct rtl_sourceEntry
+{
+	#ifdef CONFIG_RTL_MLD_SNOOPING
+	uint32 sourceAddr[4];                       /*D class IP multicast address*/
+	#else
+	uint32 sourceAddr[1];                       /*D class IP multicast address*/
+	#endif
+	uint32 fwdState;
+	struct rtl_sourceEntry *previous;
+	struct rtl_sourceEntry *next;             /*Pointer of next group entry*/
+	uint32 portTimer;
+};
+
+struct rtl_mcastFlowEntry
+{
+	struct rtl_mcastFlowEntry *previous;
+	struct rtl_mcastFlowEntry  *next;             /*Pointer of next group entry*/
+	uint32 ipVersion;
+	#ifdef CONFIG_RTL_MLD_SNOOPING
+	uint32 serverAddr[4];
+	uint32 groupAddr[4];
+	#else
+	uint32 serverAddr[1];
+	uint32 groupAddr[1];
+	#endif
+
+	struct rtl_multicastFwdInfo multicastFwdInfo;
+	uint32 refreshTime;
+};
+#else
+struct rtl_groupEntry
+{
+	struct rtl_groupEntry *previous;
+	struct rtl_groupEntry  *next;             /*Pointer of next group entry*/
+	struct rtl_sourceEntry *sourceList;
+	uint32 ipVersion;
+	#ifdef CONFIG_RTL_MLD_SNOOPING
+	uint32 groupAddr[4];
+	#else
+	uint32 groupAddr[1];
+	#endif
+	uint32 groupFilterTimer[MAX_SUPPORT_PORT_NUMBER];
+
+};
+
+struct rtl_sourceEntry
+{
+	#ifdef CONFIG_RTL_MLD_SNOOPING
+	uint32 sourceAddr[4];                       /*D class IP multicast address*/
+	#else
+	uint32 sourceAddr[1];                       /*D class IP multicast address*/
+	#endif
+	struct rtl_sourceEntry *previous;
+	struct rtl_sourceEntry *next;             /*Pointer of next group entry*/
+	uint32 portTimer[MAX_SUPPORT_PORT_NUMBER];
+};
+#endif
+
+struct rtl_mcastRouter
+{
+	uint32 portTimer[MAX_SUPPORT_PORT_NUMBER];
+};
+
+
+struct rtl_macFrameInfo
+{
+	uint8   ipVersion;
+
+	uint32 srcIpAddr[4];
+	uint32 dstIpAddr[4];
+
+	uint8 *ipBuf;
+	uint16   ipHdrLen;
+	uint8   l3Protocol;
+	uint8 checksumFlag;
+	uint8 *l3PktBuf;
+	uint16 l3PktLen;
+	uint16 macFrameLen;
+	uint16 vlanTagFlag;
+	uint16 vlanTagID;
+	uint8 srcMacAddr[6];
+
+};
+
+
+struct rtl_multicastRouters
+{
+	 struct rtl_mcastRouter querier;
+	 struct rtl_mcastRouter dvmrpRouter;
+	 struct rtl_mcastRouter mospfRouter;
+	 struct rtl_mcastRouter pimRouter;
+
+};
+#ifdef CONFIG_NEW_IGMP_IMPLEMENTATION
+//#define CONFIG_RECORD_MCAST_FLOW
+#endif
+
+struct rtl_multicastModule
+{
+	uint8 enableSnooping;
+#ifdef CONFIG_NEW_IGMP_IMPLEMENTATION
+#else
+	uint8 enableSourceList;
+#endif
+	uint8 enableFastLeave;
+
+	uint32 ipv4UnknownMCastFloodMap;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	uint32 ipv6UnknownMCastFloodMap;
+#endif
+	uint32 staticRouterPortMask;
+
+	rtl_multicastDeviceInfo_t deviceInfo;
+
+	struct rtl_multicastRouters rtl_ipv4MulticastRouters;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	struct rtl_multicastRouters rtl_ipv6MulticastRouters;
+#endif
+
+	/*gateway infomation*/
+	uint8 rtl_gatewayMac[6];
+	uint32 rtl_gatewayIpv4Addr;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	uint32 rtl_gatewayIpv6Addr[4];
+#endif
+
+
+	/*hash table definition*/
+	struct rtl_groupEntry ** rtl_ipv4HashTable;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	struct rtl_groupEntry ** rtl_ipv6HashTable;
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	struct rtl_mcastFlowEntry **flowHashTable;
+#endif
+#ifdef CONFIG_PROC_FS
+	 unsigned int expireEventCnt;
+#endif
+
+};
+
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping_new.c b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping_new.c
new file mode 100644
index 00000000..787f8ed
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/igmpsnooping/rtl865x_igmpsnooping_new.c
@@ -0,0 +1,8434 @@
+/*
+* Program :  igmp snooping function
+* Abstract :
+* Author :qinjunjie
+* Email:qinjunjie1980@hotmail.com
+*
+*  Copyright (c) 2011 Realtek Semiconductor Corp.
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License version 2 as
+*  published by the Free Software Foundation.
+*/
+
+#ifdef __linux__
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+#include <linux/kconfig.h>
+#else
+#include <linux/config.h>
+#endif
+#include <linux/jiffies.h>
+#include <linux/timer.h>
+#include <linux/proc_fs.h>
+#ifdef CONFIG_PROC_FS
+#include <linux/seq_file.h>
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+#include <linux/uaccess.h>
+#endif
+#endif
+
+#include <net/rtl/rtl865x_igmpsnooping_glue.h>
+#include <net/rtl/rtl_glue.h>
+#include <net/rtl/rtl865x_igmpsnooping.h>
+#include "rtl865x_igmpsnooping_local.h"
+//#include "../common/assert.h"
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+#include "../common/rtl865x_eventMgr.h"
+#endif
+
+static struct rtl_multicastModule rtl_mCastModuleArray[MAX_MCAST_MODULE_NUM];
+
+#if defined(__linux__) && defined(__KERNEL__)
+static struct timer_list igmpSysTimer;	/*igmp timer */
+#endif
+/*global system resources declaration*/
+static uint32 rtl_totalMaxGroupCnt;	/*maximum total group entry count,  default is 100 */
+static uint32 rtl_totalMaxClientCnt;	/*maximum total group entry count,  default is 100 */
+static uint32 rtl_totalMaxSourceCnt;	/*maximum total group entry count,  default is 3000 */
+static int32 rtl_currentGroupCnt = 0;
+static int32 rtl_currentClientCnt = 0;
+
+void *rtl_groupMemory = NULL;
+void *rtl_clientMemory = NULL;
+void *rtl_sourceMemory = NULL;
+void *rtl_mcastFlowMemory = NULL;
+
+static struct rtl_groupEntry *rtl_groupEntryPool = NULL;
+static struct rtl_clientEntry *rtl_clientEntryPool = NULL;
+static struct rtl_sourceEntry *rtl_sourceEntryPool = NULL;
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+static struct rtl_mcastFlowEntry *rtl_mcastFlowEntryPool = NULL;
+#endif
+static struct rtl_mCastTimerParameters rtl_mCastTimerParas;	/*IGMP snooping parameters */
+
+static uint32 rtl_hashTableSize = 0;
+static uint32 rtl_hashMask = 0;
+
+/*the system up time*/
+static uint32 rtl_startTime;
+static uint32 rtl_sysUpSeconds;
+
+static rtl_multicastEventContext_t reportEventContext;
+static rtl_multicastEventContext_t timerEventContext;
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+static rtl_multicastEventContext_t linkEventContext;
+#endif
+
+#if 0
+#ifndef CONFIG_RTL_IGMPSNOOPING_MAC_BASED
+#define CONFIG_RTL_IGMPSNOOPING_MAC_BASED 1
+#endif
+#endif
+
+#ifdef CONFIG_RTK_MESH
+extern unsigned int mesh_port_no;
+#endif
+
+extern unsigned int brIgmpModuleIndex;
+extern unsigned int brIgmpModuleIndex_2;
+extern uint32 nicIgmpModuleIndex;
+
+struct rtl865x_ReservedMCastRecord reservedMCastRecord[MAX_RESERVED_MULTICAST_NUM];
+
+#if defined(CONFIG_RTL_8370_SUPPORT)
+static uint32 wait_mac = 0;
+static uint32 saved_groupAddress;
+static uint32 saved_clientAddr;
+void rtl8370L2McastAddrUpdate(int mode, uint32 groupAddress, uint32 clientAddr,
+	uint8 *mac);
+#endif
+
+/*******************************internal function declaration*****************************/
+
+/**************************
+	resource managment
+**************************/
+static struct rtl_groupEntry *rtl_initGroupEntryPool(uint32 poolSize);
+static struct rtl_groupEntry *rtl_allocateGroupEntry(void);
+static void rtl_freeGroupEntry(struct rtl_groupEntry *groupEntryPtr);
+
+static struct rtl_clientEntry *rtl_initClientEntryPool(uint32 poolSize);
+static struct rtl_clientEntry *rtl_allocateClientEntry(void);
+static void rtl_freeClientEntry(struct rtl_clientEntry *clientEntryPtr);
+
+static struct rtl_sourceEntry *rtl_initSourceEntryPool(uint32 poolSize);
+static struct rtl_sourceEntry *rtl_allocateSourceEntry(void);
+static void rtl_freeSourceEntry(struct rtl_sourceEntry *sourceEntryPtr);
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+static struct rtl_mcastFlowEntry *rtl_initMcastFlowEntryPool(uint32 poolSize);
+static struct rtl_mcastFlowEntry *rtl_allocateMcastFlowEntry(void);
+static void rtl_freeMcastFlowEntry(struct rtl_mcastFlowEntry *mcastFlowEntry);
+#endif
+/**********************************Structure Maintenance*************************/
+
+static struct rtl_groupEntry *rtl_searchGroupEntry(uint32 moduleIndex,
+	uint32 ipVersion, uint32 *multicastAddr);
+static void rtl_linkGroupEntry(struct rtl_groupEntry *entryNode,
+	struct rtl_groupEntry **hashTable);
+static void rtl_unlinkGroupEntry(struct rtl_groupEntry *entryNode,
+	struct rtl_groupEntry **hashTable);
+static void rtl_clearGroupEntry(struct rtl_groupEntry *groupEntryPtr);
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+static struct rtl_clientEntry *rtl_searchClientEntry(uint32 ipVersion,
+	struct rtl_groupEntry *groupEntry, uint32 portNum, uint32 *clientAddr,
+	uint8 *clientmacAddr);
+#else
+static struct rtl_clientEntry *rtl_searchClientEntry(uint32 ipVersion,
+	struct rtl_groupEntry *groupEntry, uint32 portNum, uint32 *clientAddr);
+#endif
+static void rtl_linkClientEntry(struct rtl_groupEntry *groupEntry,
+	struct rtl_clientEntry *clientEntry);
+static void rtl_unlinkClientEntry(struct rtl_groupEntry *groupEntry,
+	struct rtl_clientEntry *clientEntry);
+static void rtl_clearClientEntry(struct rtl_clientEntry *clientEntryPtr);
+static void rtl_deleteClientEntry(struct rtl_groupEntry *groupEntry,
+	struct rtl_clientEntry *clientEntry);
+
+static struct rtl_sourceEntry *rtl_searchSourceEntry(uint32 ipVersion,
+	uint32 *sourceAddr, struct rtl_clientEntry *clientEntry);
+static void rtl_linkSourceEntry(struct rtl_clientEntry *clientEntry,
+	struct rtl_sourceEntry *entryNode);
+static void rtl_unlinkSourceEntry(struct rtl_clientEntry *clientEntry,
+	struct rtl_sourceEntry *entryNode);
+static void rtl_clearSourceEntry(struct rtl_sourceEntry *sourceEntryPtr);
+static void rtl_deleteSourceEntry(struct rtl_clientEntry *clientEntry,
+	struct rtl_sourceEntry *sourceEntry);
+#ifdef CONFIG_RECORD_MCAST_FLOW
+static struct rtl_mcastFlowEntry *rtl_searchMcastFlowEntry(uint32 moduleIndex,
+	uint32 ipVersion, uint32 *serverAddr, uint32 *groupAddr);
+static void rtl_linkMcastFlowEntry(struct rtl_mcastFlowEntry *mcastFlowEntry,
+	struct rtl_mcastFlowEntry **hashTable);
+static void rtl_unlinkMcastFlowEntry(struct rtl_mcastFlowEntry *mcastFlowEntry,
+	struct rtl_mcastFlowEntry **hashTable);
+static void rtl_clearMcastFlowEntry(struct rtl_mcastFlowEntry *mcastFlowEntry);
+static void rtl_deleteMcastFlowEntry(struct rtl_mcastFlowEntry *mcastFlowEntry,
+	struct rtl_mcastFlowEntry **hashTable);
+#endif
+static int32 rtl_checkMCastAddrMapping(uint32 ipVersion, uint32 *ipAddr,
+	uint8 *macAddr);
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+static int32 rtl_compareIpv6Addr(uint32 *ipv6Addr1, uint32 *ipv6Addr2);
+static uint16 rtl_ipv6L3Checksum(uint8 *pktBuf, uint32 pktLen,
+	union pseudoHeader *ipv6PseudoHdr);
+#endif
+static int32 rtl_compareMacAddr(uint8 *macAddr1, uint8 *macAddr2);
+static uint16 rtl_checksum(uint8 *packetBuf, uint32 packetLen);
+static uint32 rtl_getClientFwdPortMask(struct rtl_clientEntry *clientEntry,
+	uint32 sysTime);
+static void rtl_checkSourceTimer(struct rtl_clientEntry *clientEntry,
+	struct rtl_sourceEntry *sourceEntry);
+static uint32 rtl_getGroupSourceFwdPortMask(struct rtl_groupEntry *groupEntry,
+	uint32 *sourceAddr, uint32 sysTime);
+static uint32 rtl_getClientSourceFwdPortMask(uint32 ipVersion,
+	struct rtl_clientEntry *clientEntry, uint32 *sourceAddr,
+	uint32 sysTime);
+
+static void rtl_checkGroupEntryTimer(struct rtl_groupEntry *groupEntry,
+	struct rtl_groupEntry **hashTable);
+static void rtl_checkClientEntryTimer(struct rtl_groupEntry *groupEntry,
+	struct rtl_clientEntry *clientEntry);
+
+static uint32 rtl_getMulticastRouterPortMask(uint32 moduleIndex,
+	uint32 ipVersion, uint32 sysTime);
+
+/*hash table operation*/
+static int32 rtl_initHashTable(uint32 moduleIndex, uint32 hashTableSize);
+
+/************************************Pkt Process**********************************/
+/*MAC frame analyze function*/
+static void rtl_parseMacFrame(uint32 moduleIndex, uint8 *MacFrame,
+	uint32 verifyCheckSum, struct rtl_macFrameInfo *macInfo);
+
+/*Process Query Packet*/
+static void rtl_snoopQuerier(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum);
+static uint32 rtl_processQueries(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint8 *pktBuf, uint32 pktLen);
+/*Process Report Packet*/
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)	|| defined (M2U_DELETE_CHECK)
+static uint32 rtl_processJoin(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr,
+	uint8 *pktBuf);
+static uint32 rtl_processLeave(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf);	//process leave/done report packet
+static int32 rtl_processIsInclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf);	//process MODE_IS_INCLUDE report packet
+static int32 rtl_processIsExclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf);	//process MODE_IS_EXCLUDE report packet
+static int32 rtl_processToInclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf);	//process CHANGE_TO_INCLUDE_MODE report packet
+static int32 rtl_processToExclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf);	//process CHANGE_TO_EXCLUDE_MODE report packet
+static int32 rtl_processAllow(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf);	//process ALLOW_NEW_SOURCES report packet
+static int32 rtl_processBlock(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf);	//process BLOCK_OLD_SOURCES report packet
+static uint32 rtl_processIgmpv3Mldv2Reports(uint32 moduleIndex,
+	uint32 ipVersion, uint32 portNum, uint32 *clientAddr,
+	uint8 *clientmacAddr, uint8 *pktBuf);
+
+#else
+
+static uint32 rtl_processJoin(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *pktBuf);	// process join report packet
+static uint32 rtl_processLeave(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *pktBuf);	//process leave/done report packet
+static int32 rtl_processIsInclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *pktBuf);	//process MODE_IS_INCLUDE report packet
+static int32 rtl_processIsExclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *pktBuf);	//process MODE_IS_EXCLUDE report packet
+static int32 rtl_processToInclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *pktBuf);	//process CHANGE_TO_INCLUDE_MODE report packet
+static int32 rtl_processToExclude(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *pktBuf);	//process CHANGE_TO_EXCLUDE_MODE report packet
+static int32 rtl_processAllow(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *pktBuf);	//process ALLOW_NEW_SOURCES report packet
+static int32 rtl_processBlock(uint32 moduleIndex, uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *pktBuf);	//process BLOCK_OLD_SOURCES report packet
+static uint32 rtl_processIgmpv3Mldv2Reports(uint32 moduleIndex,
+	uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *pktBuf);
+#endif
+/*******************different protocol process function**********************************/
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+static uint32 rtl_processIgmpMld(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientMacAddr, uint8 *pktBuf,
+	uint32 pktLen);
+#else
+static uint32 rtl_processIgmpMld(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *pktBuf, uint32 pktLen);
+#endif
+static uint32 rtl_processDvmrp(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint8 *pktBuf, uint32 pktLen);
+static uint32 rtl_processMospf(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint8 *pktBuf, uint32 pktLen);
+static uint32 rtl_processPim(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint8 *pktBuf, uint32 pktLen);
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+static int32 rtl_recordMcastFlow(uint32 moduleIndex, uint32 ipVersion,
+	uint32 *sourceIpAddr, uint32 *groupAddr,
+	struct rtl_multicastFwdInfo *multicastFwdInfo);
+static void rtl_invalidateMCastFlow(uint32 moduleIndex, uint32 ipVersion,
+	uint32 *groupAddr);
+static void rtl_doMcastFlowRecycle(uint32 moduleIndex, uint32 ipVersion);
+#endif
+
+#if  defined(__linux__) && defined(__KERNEL__)
+static void rtl_multicastSysTimerExpired(unsigned long expireDada);
+static void rtl_multicastSysTimerInit(void);
+static void rtl_multicastSysTimerDestroy(void);
+#endif
+
+static void rtl_deleteGroupEntry(struct rtl_groupEntry *groupEntry,
+	struct rtl_groupEntry **hashTable);
+/************************************************
+			Implementation
+  ************************************************/
+
+/**************************
+	Initialize
+**************************/
+
+int32 rtl_initMulticastSnooping(struct rtl_mCastSnoopingGlobalConfig
+	mCastSnoopingGlobalConfig)
+{
+	int i, j;
+	uint32 maxHashTableSize = MAX_HASH_TABLE_SIZE;
+
+	for (i = 0; i < MAX_MCAST_MODULE_NUM; i++) {
+		memset(&(rtl_mCastModuleArray[i]), 0,
+			sizeof(struct rtl_multicastModule));
+
+		for (j = 0; j < 6; j++) {
+			rtl_mCastModuleArray[i].rtl_gatewayMac[j] = 0;
+		}
+
+		rtl_mCastModuleArray[i].rtl_gatewayIpv4Addr = 0;
+		rtl_mCastModuleArray[i].rtl_ipv4HashTable = NULL;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		for (j = 0; j < 4; j++) {
+			rtl_mCastModuleArray[i].rtl_gatewayIpv6Addr[j] = 0;
+		}
+		rtl_mCastModuleArray[i].rtl_ipv6HashTable = NULL;
+#endif
+#ifdef CONFIG_RECORD_MCAST_FLOW
+		rtl_mCastModuleArray[i].flowHashTable = NULL;
+#endif
+		rtl_mCastModuleArray[i].enableSnooping = FALSE;
+		rtl_mCastModuleArray[i].enableFastLeave = FALSE;
+
+	}
+
+	/*set multicast snooping parameters, use default value */
+	if (mCastSnoopingGlobalConfig.groupMemberAgingTime == 0) {
+		rtl_mCastTimerParas.groupMemberAgingTime = DEFAULT_GROUP_MEMBER_INTERVAL;
+	} else {
+		rtl_mCastTimerParas.groupMemberAgingTime = mCastSnoopingGlobalConfig.groupMemberAgingTime;
+	}
+
+	if (mCastSnoopingGlobalConfig.lastMemberAgingTime == 0) {
+		rtl_mCastTimerParas.lastMemberAgingTime = 0;
+	} else {
+		rtl_mCastTimerParas.lastMemberAgingTime = mCastSnoopingGlobalConfig.lastMemberAgingTime;
+	}
+
+	if (mCastSnoopingGlobalConfig.querierPresentInterval == 0) {
+		rtl_mCastTimerParas.querierPresentInterval = DEFAULT_QUERIER_PRESENT_TIMEOUT;
+	} else {
+		rtl_mCastTimerParas.querierPresentInterval = mCastSnoopingGlobalConfig.querierPresentInterval;
+	}
+
+	if (mCastSnoopingGlobalConfig.dvmrpRouterAgingTime == 0) {
+		rtl_mCastTimerParas.dvmrpRouterAgingTime = DEFAULT_DVMRP_AGING_TIME;
+	} else {
+		rtl_mCastTimerParas.dvmrpRouterAgingTime = mCastSnoopingGlobalConfig.dvmrpRouterAgingTime;
+	}
+
+	if (mCastSnoopingGlobalConfig.mospfRouterAgingTime == 0) {
+		rtl_mCastTimerParas.mospfRouterAgingTime = DEFAULT_MOSPF_AGING_TIME;
+	} else {
+		rtl_mCastTimerParas.mospfRouterAgingTime = mCastSnoopingGlobalConfig.mospfRouterAgingTime;
+	}
+
+	if (mCastSnoopingGlobalConfig.pimRouterAgingTime == 0) {
+		rtl_mCastTimerParas.pimRouterAgingTime = DEFAULT_PIM_AGING_TIME;
+	} else {
+		rtl_mCastTimerParas.pimRouterAgingTime = mCastSnoopingGlobalConfig.pimRouterAgingTime;
+	}
+
+	/* set hash table size and hash mask */
+	if (mCastSnoopingGlobalConfig.hashTableSize == 0) {
+		rtl_hashTableSize = DEFAULT_HASH_TABLE_SIZE;	/*default hash table size */
+	} else {
+		for (i = 0; i < 11; i++) {
+			if (mCastSnoopingGlobalConfig.hashTableSize >= maxHashTableSize) {
+				rtl_hashTableSize = maxHashTableSize;
+
+				break;
+			}
+			maxHashTableSize = maxHashTableSize >> 1;
+
+		}
+	}
+
+	rtl_hashMask = rtl_hashTableSize - 1;
+
+	rtl_groupMemory = NULL;
+	rtl_clientMemory = NULL;
+	rtl_sourceMemory = NULL;
+	rtl_mcastFlowMemory = NULL;
+
+	/* Initialize GroupCnt & ClientCnt */
+	rtl_currentGroupCnt = 0;
+	rtl_currentClientCnt = 0;
+
+	/*initialize group entry pool */
+	if (mCastSnoopingGlobalConfig.maxGroupNum == 0) {
+		rtl_totalMaxGroupCnt = DEFAULT_MAX_GROUP_COUNT;
+	} else {
+		rtl_totalMaxGroupCnt = mCastSnoopingGlobalConfig.maxGroupNum;
+	}
+
+	rtl_groupEntryPool = rtl_initGroupEntryPool(rtl_totalMaxGroupCnt);
+	if (rtl_groupEntryPool == NULL) {
+		printk(KERN_ERR
+				"HW_MCAST:%s:%d Failed to allocate group entry rtl_totalMaxGroupCnt:%d\n",
+				__func__, __LINE__, rtl_totalMaxGroupCnt);
+		return FAILED;
+	} else {
+		printk(KERN_DEBUG
+				"HW_MCAST:%s:%d Succeed to allocate group entry rtl_totalMaxGroupCnt:%d\n",
+				__func__, __LINE__, rtl_totalMaxGroupCnt);
+	}
+
+	/*initialize client entry pool */
+	if (mCastSnoopingGlobalConfig.maxClientNum == 0) {
+		rtl_totalMaxClientCnt = DEFAULT_MAX_CLIENT_COUNT;
+	} else {
+		rtl_totalMaxClientCnt = mCastSnoopingGlobalConfig.maxClientNum;
+	}
+
+	rtl_clientEntryPool = rtl_initClientEntryPool(rtl_totalMaxClientCnt);
+	if (rtl_clientEntryPool == NULL) {
+		printk(KERN_ERR
+				"HW_MCAST:%s:%d Failed to allocate client entry rtl_totalMaxClientCnt:%d\n",
+				__func__, __LINE__, rtl_totalMaxClientCnt);
+		return FAILED;
+	} else {
+		printk(KERN_DEBUG
+				"HW_MCAST:%s:%d Succeed to allocate client entry rtl_totalMaxClientCnt:%d\n",
+				__func__, __LINE__, rtl_totalMaxClientCnt);
+	}
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_mcastFlowEntryPool = rtl_initMcastFlowEntryPool(DEFAULT_MAX_FLOW_COUNT);
+	if (rtl_mcastFlowEntryPool == NULL) {
+		return FAILED;
+	}
+#endif
+	/*initialize source entry pool */
+	if (mCastSnoopingGlobalConfig.maxSourceNum == 0) {
+		rtl_totalMaxSourceCnt = DEFAULT_MAX_SOURCE_COUNT;
+	} else {
+		rtl_totalMaxSourceCnt = mCastSnoopingGlobalConfig.maxSourceNum;
+	}
+
+	rtl_sourceEntryPool = rtl_initSourceEntryPool(rtl_totalMaxSourceCnt);
+	if (rtl_sourceEntryPool == NULL) {
+		rtl_totalMaxSourceCnt = 0;
+		return FAILED;
+	}
+#if defined(__linux__) && defined(__KERNEL__)
+	rtl_multicastSysTimerInit();
+#endif
+
+	return SUCCESS;
+
+}
+
+int32 rtl_configMulticastSnoopingFastLeave(int enableFastLeave, int ageTime)
+{
+	int i;
+
+	for (i = 0; i < MAX_MCAST_MODULE_NUM; i++) {
+		if (rtl_mCastModuleArray[i].enableSnooping == TRUE)
+			rtl_mCastModuleArray[i].enableFastLeave = enableFastLeave;
+
+	}
+
+	if (ageTime)
+		rtl_mCastTimerParas.lastMemberAgingTime = ageTime;
+	else
+		rtl_mCastTimerParas.lastMemberAgingTime = DEFAULT_LAST_MEMBER_AGINTGTIME;
+
+	return SUCCESS;
+
+}
+
+int32 rtl_flushAllIgmpRecord(uint8 flush_flag)
+{
+	/* maintain current time */
+	uint32 i = 0;
+	struct rtl_groupEntry *groupEntryPtr = NULL;
+	struct rtl_groupEntry *nextGroupEntry = NULL;
+
+	uint32 moduleIndex;
+
+	for (moduleIndex = 0; moduleIndex < MAX_MCAST_MODULE_NUM; moduleIndex++) {
+		if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+			if (flush_flag & FLUSH_IGMP_RECORD) {
+				/*maintain ipv4 group entry  timer */
+				for (i = 0; i < rtl_hashTableSize; i++) {
+					/*scan the hash table */
+					if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+						groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+						while (groupEntryPtr) {	/*traverse each group list */
+							nextGroupEntry = groupEntryPtr->next;
+
+							reportEventContext.moduleIndex = moduleIndex;
+							reportEventContext.ipVersion = IP_VERSION4;
+							reportEventContext.groupAddr[0] = groupEntryPtr->groupAddr[0];
+							reportEventContext.groupAddr[1] = 0;
+							reportEventContext.groupAddr[2] = 0;
+							reportEventContext.groupAddr[3] = 0;
+
+							rtl_deleteGroupEntry(groupEntryPtr,
+								rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+							rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+								reportEventContext.ipVersion,
+								reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+							strcpy(reportEventContext.devName, rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+							rtl865x_raiseEvent(EVENT_UPDATE_MCAST,
+								&reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+							rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST,
+								&reportEventContext);
+#endif
+#endif
+
+							groupEntryPtr = nextGroupEntry;
+						}
+					}
+				}
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			if (flush_flag & FLUSH_MLD_RECORD) {
+				/*maintain ipv6 group entry  timer */
+				for (i = 0; i < rtl_hashTableSize; i++) {
+					/*scan the hash table */
+					if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+						groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i];
+						while (groupEntryPtr) {	/*traverse each group list */
+							nextGroupEntry = groupEntryPtr->next;
+
+							reportEventContext.moduleIndex = moduleIndex;
+							reportEventContext.ipVersion = IP_VERSION6;
+							reportEventContext.groupAddr[0] = groupEntryPtr->groupAddr[0];
+							reportEventContext.groupAddr[1] = groupEntryPtr->groupAddr[1];
+							reportEventContext.groupAddr[2] = groupEntryPtr->groupAddr[2];
+							reportEventContext.groupAddr[3] = groupEntryPtr->groupAddr[3];
+
+							rtl_deleteGroupEntry(groupEntryPtr,
+								rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+							rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+								reportEventContext.ipVersion,
+								reportEventContext.groupAddr);
+#endif
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+							strcpy(reportEventContext.devName, rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+							rtl865x_raiseEvent(EVENT_UPDATE_MCAST6,
+								&reportEventContext);
+#endif
+#endif
+
+							groupEntryPtr = nextGroupEntry;
+						}
+					}
+				}
+
+			}
+#endif
+
+		}
+	}
+	return SUCCESS;
+}
+
+static int32 rtl_setClientMacAddr(struct rtl_macFrameInfo *macFrameInfo)
+{
+	/* maintain current time */
+	uint32 i = 0;
+	struct rtl_groupEntry *groupEntryPtr = NULL;
+	struct rtl_groupEntry *nextGroupEntry = NULL;
+	struct rtl_clientEntry *clientEntryPtr = NULL;
+
+	uint32 moduleIndex;
+
+	for (moduleIndex = 0; moduleIndex < MAX_MCAST_MODULE_NUM; moduleIndex++) {
+		if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+
+			/*maintain ipv4 group entry  timer */
+			for (i = 0; i < rtl_hashTableSize; i++) {
+				/*scan the hash table */
+				if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+
+					groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+					while (groupEntryPtr) {	/*traverse each group list */
+						nextGroupEntry = groupEntryPtr->next;
+						clientEntryPtr = groupEntryPtr->clientList;
+						while (clientEntryPtr != NULL) {
+
+							if (memcmp(clientEntryPtr->clientAddr,
+									macFrameInfo->srcIpAddr,
+									4) == 0) {
+								memcpy(clientEntryPtr->clientMacAddr, macFrameInfo->srcMacAddr, 6);
+#if defined(CONFIG_RTL_8370_SUPPORT)
+								if ((wait_mac == 1) &&
+									(groupEntryPtr->groupAddr[0] == saved_groupAddress) &&
+									(clientEntryPtr->clientAddr[0] == saved_clientAddr)
+									) {
+									wait_mac = 0;
+									//  add/update 8370 L2 multicast entry here
+									rtl8370L2McastAddrUpdate(1,
+										saved_groupAddress,
+										saved_clientAddr,
+										clientEntryPtr->clientMacAddr);
+								}
+#endif
+							}
+							clientEntryPtr = clientEntryPtr->next;
+						}
+						groupEntryPtr = nextGroupEntry;
+					}
+				}
+			}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			/*maintain ipv6 group entry  timer */
+			for (i = 0; i < rtl_hashTableSize; i++) {
+				/*scan the hash table */
+				if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+					groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i];
+					while (groupEntryPtr) {	/*traverse each group list */
+						nextGroupEntry = groupEntryPtr->next;
+						clientEntryPtr = groupEntryPtr->clientList;
+						while (clientEntryPtr != NULL) {
+							if (memcmp(clientEntryPtr->clientAddr,
+									macFrameInfo->srcIpAddr,
+									16) == 0) {
+								memcpy(clientEntryPtr->clientMacAddr, macFrameInfo->srcMacAddr, 6);
+							}
+							clientEntryPtr = clientEntryPtr->next;
+						}
+						groupEntryPtr = nextGroupEntry;
+					}
+				}
+			}
+#endif
+
+		}
+	}
+	return SUCCESS;
+}
+
+int32 rtl_delIgmpRecordByMacAddr(uint8 *macAddr)
+{
+	/* maintain current time */
+	uint32 i = 0;
+	struct rtl_groupEntry *groupEntryPtr = NULL;
+	struct rtl_groupEntry *nextGroupEntry = NULL;
+	struct rtl_clientEntry *clientEntryPtr = NULL;
+	struct rtl_clientEntry *nextClientEntryPtr = NULL;
+
+	uint32 moduleIndex;
+	uint32 deleteFlag = FALSE;
+
+	for (moduleIndex = 0; moduleIndex < MAX_MCAST_MODULE_NUM; moduleIndex++) {
+		if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+
+			/*maintain ipv4 group entry  timer */
+			for (i = 0; i < rtl_hashTableSize; i++) {
+				/*scan the hash table */
+				if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+					groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+					while (groupEntryPtr) {	/*traverse each group list */
+						deleteFlag = FALSE;
+						reportEventContext.moduleIndex = moduleIndex;
+						reportEventContext.ipVersion = IP_VERSION4;
+						reportEventContext.groupAddr[0] = groupEntryPtr->groupAddr[0];
+						reportEventContext.groupAddr[1] = 0;
+						reportEventContext.groupAddr[2] = 0;
+						reportEventContext.groupAddr[3] = 0;
+
+						nextGroupEntry = groupEntryPtr->next;
+						clientEntryPtr = groupEntryPtr->clientList;
+						while (clientEntryPtr != NULL) {
+							nextClientEntryPtr = clientEntryPtr->next;
+							if (memcmp(clientEntryPtr->clientMacAddr,
+									macAddr,
+									6) == 0) {
+								rtl_deleteClientEntry(groupEntryPtr,
+									clientEntryPtr);
+								deleteFlag = TRUE;
+							}
+							clientEntryPtr = nextClientEntryPtr;
+						}
+
+						if (deleteFlag == TRUE) {
+#ifdef CONFIG_RECORD_MCAST_FLOW
+							rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+								reportEventContext.ipVersion,
+								reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+							strcpy(reportEventContext.devName, rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+							rtl865x_raiseEvent(EVENT_UPDATE_MCAST,
+								&reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+							rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST,
+								&reportEventContext);
+#endif
+#endif
+						}
+						groupEntryPtr = nextGroupEntry;
+					}
+				}
+			}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			/*maintain ipv6 group entry  timer */
+			for (i = 0; i < rtl_hashTableSize; i++) {
+				/*scan the hash table */
+				if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+					groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i];
+					while (groupEntryPtr) {	/*traverse each group list */
+						deleteFlag = FALSE;
+						reportEventContext.moduleIndex = moduleIndex;
+						reportEventContext.ipVersion = IP_VERSION6;
+						reportEventContext.groupAddr[0] = groupEntryPtr->groupAddr[0];
+						reportEventContext.groupAddr[1] = groupEntryPtr->groupAddr[1];
+						reportEventContext.groupAddr[2] = groupEntryPtr->groupAddr[2];
+						reportEventContext.groupAddr[3] = groupEntryPtr->groupAddr[3];
+
+						nextGroupEntry = groupEntryPtr->next;
+						clientEntryPtr = groupEntryPtr->clientList;
+						while (clientEntryPtr != NULL) {
+							nextClientEntryPtr = clientEntryPtr->next;
+							if (memcmp(clientEntryPtr->clientMacAddr,
+									macAddr,
+									6) == 0) {
+								rtl_deleteClientEntry(groupEntryPtr,
+									clientEntryPtr);
+								deleteFlag = TRUE;
+							}
+							clientEntryPtr = nextClientEntryPtr;
+						}
+
+						if (deleteFlag == TRUE) {
+#ifdef CONFIG_RECORD_MCAST_FLOW
+							rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+								reportEventContext.ipVersion,
+								reportEventContext.groupAddr);
+#endif
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+#if defined (CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+							strcpy(reportEventContext.devName, rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+							rtl865x_raiseEvent(EVENT_UPDATE_MCAST6,
+								&reportEventContext);
+#endif
+#endif
+						}
+
+						groupEntryPtr = nextGroupEntry;
+					}
+				}
+			}
+#endif
+
+		}
+	}
+	return SUCCESS;
+}
+
+static inline uint32 rtl_igmpHashAlgorithm(uint32 ipVersion, uint32 *groupAddr)
+{
+	uint32 hashIndex = 0;
+
+	if (ipVersion == IP_VERSION4) {
+		/*to do:change hash algorithm */
+		hashIndex = rtl_hashMask & groupAddr[0];
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		hashIndex = rtl_hashMask & groupAddr[3];
+	}
+#endif
+
+	return hashIndex;
+}
+
+int32 rtl_exitMulticastSnooping(void)
+{
+
+	uint32 moduleIndex;
+
+	for (moduleIndex = 0; moduleIndex < MAX_MCAST_MODULE_NUM; moduleIndex++) {
+		rtl_unregisterIgmpSnoopingModule(moduleIndex);
+	}
+
+	rtl_hashTableSize = 0;
+	rtl_hashMask = 0;
+	memset(&rtl_mCastTimerParas, 0,
+		sizeof(struct rtl_mCastTimerParameters));
+
+	if (rtl_groupMemory != NULL) {
+		rtl_glueFree(rtl_groupMemory);
+	}
+
+	rtl_totalMaxGroupCnt = 0;
+	rtl_groupMemory = NULL;
+	rtl_groupEntryPool = NULL;
+
+	if (rtl_clientMemory != NULL) {
+		rtl_glueFree(rtl_clientMemory);
+	}
+
+	rtl_totalMaxClientCnt = 0;
+	rtl_clientMemory = NULL;
+	rtl_clientEntryPool = NULL;
+
+	if (rtl_sourceMemory != NULL) {
+		rtl_glueFree(rtl_sourceMemory);
+	}
+
+	rtl_totalMaxSourceCnt = 0;
+	rtl_sourceMemory = NULL;
+	rtl_sourceEntryPool = NULL;
+
+#if defined(__linux__) && defined(__KERNEL__)
+	rtl_multicastSysTimerDestroy();
+#endif
+
+	return SUCCESS;
+
+}
+
+/*group entry memory management*/
+static struct rtl_groupEntry *rtl_initGroupEntryPool(uint32 poolSize)
+{
+
+	uint32 idx = 0;
+	struct rtl_groupEntry *poolHead = NULL;
+	struct rtl_groupEntry *entryPtr = NULL;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	rtl_glueMutexLock();	/* Lock resource */
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	if (poolSize == 0) {
+		goto out;
+	}
+
+	/* Allocate memory */
+	poolHead = (struct rtl_groupEntry *)rtl_glueMalloc(sizeof(struct rtl_groupEntry) * poolSize);
+	rtl_groupMemory = (void *)poolHead;
+
+	if (poolHead != NULL) {
+		memset(poolHead, 0, (poolSize * sizeof(struct rtl_groupEntry)));
+		entryPtr = poolHead;
+
+		/* link the whole group entry pool */
+		for (idx = 0; idx < poolSize; idx++, entryPtr++) {
+#if defined(CONFIG_HW_MCAST_DEBUG)
+			entryPtr->idx = idx;
+#endif
+			if (idx == 0) {
+				entryPtr->previous = NULL;
+				if (idx == (poolSize - 1)) {
+					entryPtr->next = NULL;
+				} else {
+					entryPtr->next = entryPtr + 1;
+				}
+			} else {
+				entryPtr->previous = entryPtr - 1;
+				if (idx == (poolSize - 1)) {
+					entryPtr->next = NULL;
+				} else {
+					entryPtr->next = entryPtr + 1;
+				}
+			}
+		}
+	}
+
+out:
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	rtl_glueMutexUnlock();	/* UnLock resource */
+	return poolHead;
+
+}
+
+// allocate a group entry from the group entry pool
+static struct rtl_groupEntry *rtl_allocateGroupEntry(void)
+{
+	struct rtl_groupEntry *ret = NULL;
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	int tmp_idx = 0;
+#endif
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	rtl_glueMutexLock();
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	if (rtl_groupEntryPool != NULL) {
+		ret = rtl_groupEntryPool;
+		if (rtl_groupEntryPool->next != NULL) {
+			rtl_groupEntryPool->next->previous = NULL;
+		}
+		rtl_groupEntryPool = rtl_groupEntryPool->next;
+#if defined(CONFIG_HW_MCAST_DEBUG)
+		tmp_idx = ret->idx;
+#endif
+		memset(ret, 0, sizeof(struct rtl_groupEntry));
+#if defined(CONFIG_HW_MCAST_DEBUG)
+		ret->idx = tmp_idx;
+#endif
+	}
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	rtl_glueMutexUnlock();
+
+	if (ret == NULL) {
+		printk(KERN_DEBUG
+				"HW_MCAST:%s:%d Failed to retrieve group entry rtl_currentGroupCnt:%d\n",
+				__func__, __LINE__, rtl_currentGroupCnt);
+	} else {
+		rtl_currentGroupCnt++;
+#if defined(CONFIG_HW_MCAST_DEBUG)
+		printk(KERN_DEBUG
+				"HW_MCAST:%s:%d Retrieve group entry successfully rtl_currentGroupCnt:%d idx:%d\n",
+				__func__, __LINE__, rtl_currentGroupCnt, ret->idx);
+#else
+		printk(KERN_DEBUG
+				"HW_MCAST:%s:%d Retrieve group entry successfully rtl_currentGroupCnt:%d\n",
+				__func__, __LINE__, rtl_currentGroupCnt);
+#endif
+	}
+
+	return ret;
+}
+
+// free a group entry and link it back to the group entry pool, default is link to the pool head
+static void rtl_freeGroupEntry(struct rtl_groupEntry *groupEntryPtr)
+{
+	if (!groupEntryPtr) {
+		return;
+	}
+
+	rtl_glueMutexLock();
+	groupEntryPtr->next = rtl_groupEntryPool;
+	if (rtl_groupEntryPool != NULL) {
+		rtl_groupEntryPool->previous = groupEntryPtr;
+	}
+	rtl_groupEntryPool = groupEntryPtr;
+	rtl_glueMutexUnlock();
+
+	rtl_currentGroupCnt--;
+	if (rtl_currentGroupCnt < 0) {
+		WARN_ON(1);
+		printk(KERN_ERR "rtl_currentGroupCnt < 0\n");
+	}
+
+	printk(KERN_DEBUG
+			"HW_MCAST:%s:%d Free group entry Cnt:%d\n",
+			__func__, __LINE__, rtl_currentGroupCnt);
+}
+
+/*client entry memory management*/
+static struct rtl_clientEntry *rtl_initClientEntryPool(uint32 poolSize)
+{
+
+	uint32 idx = 0;
+	struct rtl_clientEntry *poolHead = NULL;
+	struct rtl_clientEntry *entryPtr = NULL;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	rtl_glueMutexLock();	/* Lock resource */
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	if (poolSize == 0) {
+		goto out;
+	}
+
+	/* Allocate memory */
+	poolHead = (struct rtl_clientEntry *)rtl_glueMalloc(sizeof(struct rtl_clientEntry) * poolSize);
+	rtl_clientMemory = (void *)poolHead;
+
+	if (poolHead != NULL) {
+		memset(poolHead, 0,
+			(poolSize * sizeof(struct rtl_clientEntry)));
+		entryPtr = poolHead;
+
+		/* link the whole group entry pool */
+		for (idx = 0; idx < poolSize; idx++, entryPtr++) {
+#if defined(CONFIG_HW_MCAST_DEBUG)
+			entryPtr->idx = idx;
+#endif
+			if (idx == 0) {
+				entryPtr->previous = NULL;
+				if (idx == (poolSize - 1)) {
+					entryPtr->next = NULL;
+				} else {
+					entryPtr->next = entryPtr + 1;
+				}
+			} else {
+				entryPtr->previous = entryPtr - 1;
+				if (idx == (poolSize - 1)) {
+					entryPtr->next = NULL;
+				} else {
+					entryPtr->next = entryPtr + 1;
+				}
+			}
+		}
+	}
+
+out:
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	rtl_glueMutexUnlock();	/* UnLock resource */
+	return poolHead;
+
+}
+
+// allocate a client entry from the client entry pool
+static struct rtl_clientEntry *rtl_allocateClientEntry(void)
+{
+	struct rtl_clientEntry *ret = NULL;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	int tmp_idx = 0;
+#endif
+
+	rtl_glueMutexLock();
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	if (rtl_clientEntryPool != NULL) {
+		ret = rtl_clientEntryPool;
+		if (rtl_clientEntryPool->next != NULL) {
+			rtl_clientEntryPool->next->previous = NULL;
+		}
+		rtl_clientEntryPool = rtl_clientEntryPool->next;
+#if defined(CONFIG_HW_MCAST_DEBUG)
+		tmp_idx = ret->idx;
+#endif
+		memset(ret, 0, sizeof(struct rtl_clientEntry));
+#if defined(CONFIG_HW_MCAST_DEBUG)
+		ret->idx = tmp_idx;
+#endif
+	}
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	rtl_glueMutexUnlock();
+
+	if (ret == NULL) {
+		printk(KERN_DEBUG
+				"HW_MCAST:%s:%d Failed to retrieve client entry rtl_currentClientCnt:%d\n",
+				__func__, __LINE__, rtl_currentClientCnt);
+	} else {
+		rtl_currentClientCnt++;
+#if defined(CONFIG_HW_MCAST_DEBUG)
+		printk(KERN_DEBUG
+				"HW_MCAST:%s:%d Retrieve client entry successfully rtl_currentClientCnt:%d idx:%d\n",
+				__func__, __LINE__, rtl_currentClientCnt, ret->idx);
+#else
+		printk(KERN_DEBUG
+				"HW_MCAST:%s:%d Retrieve client entry successfully rtl_currentClientCnt:%d\n",
+				__func__, __LINE__, rtl_currentClientCnt);
+#endif
+	}
+
+	return ret;
+}
+
+// free a client entry and link it back to the client entry pool, default is link to the pool head
+static void rtl_freeClientEntry(struct rtl_clientEntry *clientEntryPtr)
+{
+	if (!clientEntryPtr) {
+		return;
+	}
+
+	rtl_glueMutexLock();
+
+	clientEntryPtr->next = rtl_clientEntryPool;
+	if (rtl_clientEntryPool != NULL) {
+		rtl_clientEntryPool->previous = clientEntryPtr;
+	}
+	rtl_clientEntryPool = clientEntryPtr;
+
+	rtl_glueMutexUnlock();
+
+	rtl_currentClientCnt--;
+	if (rtl_currentClientCnt < 0) {
+		WARN_ON(1);
+		printk(KERN_ERR "rtl_currentClientCnt < 0\n");
+	}
+
+	printk(KERN_DEBUG
+			"HW_MCAST:%s:%d Free client entry rtl_currentClientCnt:%d\n",
+			__func__, __LINE__, rtl_currentClientCnt);
+}
+
+/*source entry memory management*/
+static struct rtl_sourceEntry *rtl_initSourceEntryPool(uint32 poolSize)
+{
+
+	uint32 idx = 0;
+	struct rtl_sourceEntry *poolHead = NULL;
+	struct rtl_sourceEntry *entryPtr = NULL;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	rtl_glueMutexLock();	/* Lock resource */
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	if (poolSize == 0) {
+		goto out;
+	}
+
+	/* Allocate memory */
+	poolHead = (struct rtl_sourceEntry *)rtl_glueMalloc(sizeof(struct rtl_sourceEntry) * poolSize);
+	rtl_sourceMemory = (void *)poolHead;
+	if (poolHead != NULL) {
+		memset(poolHead, 0,
+			(poolSize * sizeof(struct rtl_sourceEntry)));
+		entryPtr = poolHead;
+
+		/* link the whole source entry pool */
+		for (idx = 0; idx < poolSize; idx++, entryPtr++) {
+			if (idx == 0) {
+				entryPtr->previous = NULL;
+				if (idx == (poolSize - 1)) {
+					entryPtr->next = NULL;
+				} else {
+					entryPtr->next = entryPtr + 1;
+				}
+			} else {
+				entryPtr->previous = entryPtr - 1;
+				if (idx == (poolSize - 1)) {
+					entryPtr->next = NULL;
+				} else {
+					entryPtr->next = entryPtr + 1;
+				}
+			}
+
+		}
+	}
+
+out:
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	rtl_glueMutexUnlock();	/* UnLock resource */
+	return poolHead;
+
+}
+
+// allocate a source entry from the source entry pool
+static struct rtl_sourceEntry *rtl_allocateSourceEntry(void)
+{
+	struct rtl_sourceEntry *ret = NULL;
+	rtl_glueMutexLock();
+	if (rtl_sourceEntryPool != NULL) {
+		ret = rtl_sourceEntryPool;
+		if (rtl_sourceEntryPool->next != NULL) {
+			rtl_sourceEntryPool->next->previous = NULL;
+		}
+		rtl_sourceEntryPool = rtl_sourceEntryPool->next;
+		memset(ret, 0, sizeof(struct rtl_sourceEntry));
+	}
+	rtl_glueMutexUnlock();
+
+	return ret;
+}
+
+// free a source entry and link it back to the source entry pool, default is link to the pool head
+static void rtl_freeSourceEntry(struct rtl_sourceEntry *sourceEntryPtr)
+{
+	if (!sourceEntryPtr) {
+		return;
+	}
+
+	rtl_glueMutexLock();
+	sourceEntryPtr->next = rtl_sourceEntryPool;
+	if (rtl_sourceEntryPool != NULL) {
+		rtl_sourceEntryPool->previous = sourceEntryPtr;
+	}
+
+	rtl_sourceEntryPool = sourceEntryPtr;
+	rtl_glueMutexUnlock();
+}
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+/*multicast flow entry memory management*/
+static struct rtl_mcastFlowEntry *rtl_initMcastFlowEntryPool(uint32 poolSize)
+{
+
+	uint32 idx = 0;
+	struct rtl_mcastFlowEntry *poolHead = NULL;
+	struct rtl_mcastFlowEntry *entryPtr = NULL;
+
+	rtl_glueMutexLock();	/* Lock resource */
+	if (poolSize == 0) {
+		goto out;
+	}
+
+	/* Allocate memory */
+	poolHead = (struct rtl_mcastFlowEntry *)rtl_glueMalloc(sizeof(struct rtl_mcastFlowEntry) * poolSize);
+	rtl_mcastFlowMemory = (void *)poolHead;
+
+	if (poolHead != NULL) {
+		memset(poolHead, 0,
+			(poolSize * sizeof(struct rtl_mcastFlowEntry)));
+		entryPtr = poolHead;
+
+		/* link the whole group entry pool */
+		for (idx = 0; idx < poolSize; idx++, entryPtr++) {
+			if (idx == 0) {
+				entryPtr->previous = NULL;
+				if (idx == (poolSize - 1)) {
+					entryPtr->next = NULL;
+				} else {
+					entryPtr->next = entryPtr + 1;
+				}
+			} else {
+				entryPtr->previous = entryPtr - 1;
+				if (idx == (poolSize - 1)) {
+					entryPtr->next = NULL;
+				} else {
+					entryPtr->next = entryPtr + 1;
+				}
+			}
+		}
+	}
+
+out:
+
+	rtl_glueMutexUnlock();	/* UnLock resource */
+	return poolHead;
+
+}
+
+// allocate a multicast flow entry  from the multicast flow pool
+static struct rtl_mcastFlowEntry *rtl_allocateMcastFlowEntry(void)
+{
+	struct rtl_mcastFlowEntry *ret = NULL;
+
+	rtl_glueMutexLock();
+	if (rtl_mcastFlowEntryPool != NULL) {
+		ret = rtl_mcastFlowEntryPool;
+		if (rtl_mcastFlowEntryPool->next != NULL) {
+			rtl_mcastFlowEntryPool->next->previous = NULL;
+		}
+		rtl_mcastFlowEntryPool = rtl_mcastFlowEntryPool->next;
+		memset(ret, 0, sizeof(struct rtl_mcastFlowEntry));
+	}
+
+	rtl_glueMutexUnlock();
+
+	return ret;
+}
+
+// free a multicast flow entry and link it back to the multicast flow entry pool, default is link to the pool head
+static void rtl_freeMcastFlowEntry(struct rtl_mcastFlowEntry *mcastFlowEntry)
+{
+	if (NULL == mcastFlowEntry) {
+		return;
+	}
+
+	rtl_glueMutexLock();
+	mcastFlowEntry->next = rtl_mcastFlowEntryPool;
+	if (rtl_mcastFlowEntryPool != NULL) {
+		rtl_mcastFlowEntryPool->previous = mcastFlowEntry;
+	}
+	rtl_mcastFlowEntryPool = mcastFlowEntry;
+	rtl_glueMutexUnlock();
+}
+
+#endif
+
+/*********************************************
+			Group list operation
+ *********************************************/
+
+/*       find a group address in a group list    */
+struct rtl_groupEntry *rtl_searchGroupEntry(uint32 moduleIndex,
+	uint32 ipVersion, uint32 *multicastAddr)
+{
+	struct rtl_groupEntry *groupPtr = NULL;
+	int32 hashIndex = 0;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, multicastAddr);
+
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+
+	if (ipVersion == IP_VERSION4) {
+		if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL)
+			groupPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[hashIndex];
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL)
+			groupPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[hashIndex];
+	}
+#endif
+
+	while (groupPtr != NULL) {
+		if (ipVersion == IP_VERSION4) {
+			if (multicastAddr[0] == groupPtr->groupAddr[0]) {
+#if defined(CONFIG_SMP)
+				SMP_UNLOCK_IGMP(flags);
+#endif
+				return groupPtr;
+			}
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			if ((multicastAddr[0] == groupPtr->groupAddr[0]) &&
+				(multicastAddr[1] == groupPtr->groupAddr[1]) &&
+				(multicastAddr[2] == groupPtr->groupAddr[2]) &&
+				(multicastAddr[3] == groupPtr->groupAddr[3])
+				) {
+#if defined(CONFIG_SMP)
+				SMP_UNLOCK_IGMP(flags);
+#endif
+				return groupPtr;
+
+			}
+		}
+#endif
+		groupPtr = groupPtr->next;
+
+	}
+
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+
+	return NULL;
+}
+
+int32 rtl_getGroupNum(uint32 ipVersion)
+{
+	int32 moduleIndex;
+	int32 hashIndex;
+	int32 groupCnt = 0;
+	struct rtl_groupEntry *groupEntryPtr;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+
+	for (moduleIndex = 0; moduleIndex < MAX_MCAST_MODULE_NUM; moduleIndex++) {
+
+		if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+			if (ipVersion == IP_VERSION4) {
+				groupCnt = 0;
+
+				if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+					for (hashIndex = 0;
+						hashIndex < rtl_hashTableSize;
+						hashIndex++) {
+						groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[hashIndex];
+						while (groupEntryPtr != NULL) {
+							if (groupEntryPtr->attribute != STATIC_RESERVED_MULTICAST)
+								groupCnt++;
+
+							groupEntryPtr = groupEntryPtr->next;
+						}
+
+					}
+				}
+
+			}
+#if defined (CONFIG_RTL_MLD_SNOOPING)
+			else if (ipVersion == IP_VERSION6) {
+				groupCnt = 0;
+
+				if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+					for (hashIndex = 0;
+						hashIndex < rtl_hashTableSize;
+						hashIndex++) {
+						groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[hashIndex];
+						while (groupEntryPtr != NULL) {
+							if (groupEntryPtr->attribute != STATIC_RESERVED_MULTICAST)
+								groupCnt++;
+
+							groupEntryPtr = groupEntryPtr->next;
+						}
+
+					}
+				}
+			}
+#endif
+		}
+	}
+
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	return groupCnt;
+}
+
+#if defined (CONFIG_RT_MULTIPLE_BR_SUPPORT)
+int32 rtl_getGroupNumbyBr(uint32 ipVersion, char *brName)
+{
+	int32 moduleIndex;
+	int32 hashIndex;
+	int32 groupCnt = 0;
+	struct rtl_groupEntry *groupEntryPtr;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	for (moduleIndex = 0; moduleIndex < MAX_MCAST_MODULE_NUM; moduleIndex++) {
+
+		if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE &&
+			strcmp(rtl_mCastModuleArray[moduleIndex].deviceInfo.devName, brName) == 0) {
+			if (ipVersion == IP_VERSION4) {
+				groupCnt = 0;
+
+				if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+					for (hashIndex = 0;
+						hashIndex < rtl_hashTableSize;
+						hashIndex++) {
+						groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[hashIndex];
+						while (groupEntryPtr != NULL) {
+							if (groupEntryPtr->attribute != STATIC_RESERVED_MULTICAST)
+								groupCnt++;
+
+							groupEntryPtr = groupEntryPtr->next;
+						}
+
+					}
+				}
+
+			}
+#if defined (CONFIG_RTL_MLD_SNOOPING)
+			else if (ipVersion == IP_VERSION6) {
+				groupCnt = 0;
+
+				if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+					for (hashIndex = 0;
+						hashIndex < rtl_hashTableSize;
+						hashIndex++) {
+						groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[hashIndex];
+						while (groupEntryPtr != NULL) {
+							if (groupEntryPtr->attribute != STATIC_RESERVED_MULTICAST)
+								groupCnt++;
+
+							groupEntryPtr = groupEntryPtr->next;
+						}
+
+					}
+				}
+			}
+#endif
+		}
+	}
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	return groupCnt;
+}
+#endif
+
+/* link group Entry in the front of a group list */
+static void rtl_linkGroupEntry(struct rtl_groupEntry *groupEntry,
+	struct rtl_groupEntry **hashTable)
+{
+	uint32 hashIndex = 0;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	rtl_glueMutexLock();	//Lock resource
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	hashIndex = rtl_igmpHashAlgorithm(groupEntry->ipVersion,
+		groupEntry->groupAddr);
+	if (NULL == groupEntry || hashTable == NULL) {
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_IGMP(flags);
+#endif
+		rtl_glueMutexUnlock();
+		return;
+	}
+
+	if (hashTable[hashIndex] != NULL) {
+		hashTable[hashIndex]->previous = groupEntry;
+	}
+	groupEntry->next = hashTable[hashIndex];
+	hashTable[hashIndex] = groupEntry;
+	hashTable[hashIndex]->previous = NULL;
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	printk("HW_MCAST:%s:%d Link group entry. idx:%d groupAddress:%d.%d.%d.%d\n",
+			__func__, __LINE__, groupEntry->idx,
+			groupEntry->groupAddr[0] >> 24,
+			(groupEntry->groupAddr[0] & 0x00ff0000) >> 16,
+			(groupEntry->groupAddr[0] & 0x0000ff00) >> 8,
+			(groupEntry->groupAddr[0] & 0xff));
+#endif
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	rtl_glueMutexUnlock();	//UnLock resource
+
+}
+
+/* unlink a group entry from group list */
+static void rtl_unlinkGroupEntry(struct rtl_groupEntry *groupEntry,
+	struct rtl_groupEntry **hashTable)
+{
+	uint32 hashIndex = 0;
+
+	if (NULL == groupEntry || hashTable == NULL) {
+		return;
+	}
+
+	rtl_glueMutexLock();	/* lock resource */
+
+	hashIndex = rtl_igmpHashAlgorithm(groupEntry->ipVersion,
+		groupEntry->groupAddr);
+	/* unlink entry node */
+	if (groupEntry == hashTable[hashIndex]) {	/*unlink group list head */
+		hashTable[hashIndex] = groupEntry->next;
+		if (hashTable[hashIndex] != NULL) {
+			hashTable[hashIndex]->previous = NULL;
+		}
+	} else {
+		if (groupEntry->previous != NULL) {
+			groupEntry->previous->next = groupEntry->next;
+		}
+
+		if (groupEntry->next != NULL) {
+			groupEntry->next->previous = groupEntry->previous;
+		}
+	}
+
+	groupEntry->previous = NULL;
+	groupEntry->next = NULL;
+
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	printk("HW_MCAST:%s:%d Link group entry. idx:%d groupAddress:%d.%d.%d.%d\n",
+			__func__, __LINE__, groupEntry->idx,
+			groupEntry->groupAddr[0] >> 24,
+			(groupEntry->groupAddr[0] & 0x00ff0000) >> 16,
+			(groupEntry->groupAddr[0] & 0x0000ff00) >> 8,
+			(groupEntry->groupAddr[0] & 0xff));
+#endif
+
+	rtl_glueMutexUnlock();	//UnLock resource
+
+}
+
+/* clear the content of group entry */
+static void rtl_clearGroupEntry(struct rtl_groupEntry *groupEntry)
+{
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	int tmp_idx = 0;
+#endif
+	rtl_glueMutexLock();
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	printk(KERN_DEBUG
+			"HW_MCAST:%s:%d Going to free groupEntry->idx:%d ipVersion:%d\n",
+			__func__, __LINE__, groupEntry->idx, groupEntry->ipVersion);
+#endif
+	if (NULL != groupEntry) {
+#if defined(CONFIG_HW_MCAST_DEBUG)
+		tmp_idx = groupEntry->idx;
+#endif
+		memset(groupEntry, 0, sizeof(struct rtl_groupEntry));
+#if defined(CONFIG_HW_MCAST_DEBUG)
+		groupEntry->idx = tmp_idx;
+#endif
+	}
+	rtl_glueMutexUnlock();
+}
+
+/*********************************************
+			Client list operation
+ *********************************************/
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+static struct rtl_clientEntry *rtl_searchClientEntry(uint32 ipVersion,
+	struct rtl_groupEntry *groupEntry, uint32 portNum, uint32 *clientAddr,
+	uint8 *clientmacAddr)
+#else
+static struct rtl_clientEntry *rtl_searchClientEntry(uint32 ipVersion,
+	struct rtl_groupEntry *groupEntry, uint32 portNum, uint32 *clientAddr)
+#endif
+{
+	struct rtl_clientEntry *clientPtr = groupEntry->clientList;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	if (clientAddr == NULL) {
+		return NULL;
+	}
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	while (clientPtr != NULL) {
+		if (ipVersion == IP_VERSION4) {
+			if ((clientPtr->clientAddr[0] == clientAddr[0])
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+				|| ((clientmacAddr[0] == clientPtr->clientMacAddr[0])
+					&& (clientmacAddr[1] == clientPtr->clientMacAddr[1])
+					&& (clientmacAddr[2] == clientPtr->clientMacAddr[2])
+					&& (clientmacAddr[3] == clientPtr->clientMacAddr[3])
+					&& (clientmacAddr[4] == clientPtr->clientMacAddr[4])
+					&& (clientmacAddr[5] == clientPtr->clientMacAddr[5])
+				)
+#endif
+				) {
+				if (portNum < MAX_SUPPORT_PORT_NUMBER) {
+					/*update port number,in case of client change port */
+					clientPtr->portNum = portNum;
+				}
+#if defined(CONFIG_SMP)
+				SMP_UNLOCK_IGMP(flags);
+#endif
+				return clientPtr;
+			}
+
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			if (((clientPtr->clientAddr[0] == clientAddr[0])
+					&& (clientPtr->clientAddr[1] == clientAddr[1])
+					&& (clientPtr->clientAddr[2] == clientAddr[2])
+					&& (clientPtr->clientAddr[3] == clientAddr[3]))
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+				|| ((clientmacAddr[0] == clientPtr->clientMacAddr[0])
+					&& (clientmacAddr[1] == clientPtr->clientMacAddr[1])
+					&& (clientmacAddr[2] == clientPtr->clientMacAddr[2])
+					&& (clientmacAddr[3] == clientPtr->clientMacAddr[3])
+					&& (clientmacAddr[4] == clientPtr->clientMacAddr[4])
+					&& (clientmacAddr[5] == clientPtr->clientMacAddr[5])
+				)
+#endif
+				) {
+
+				if (portNum < MAX_SUPPORT_PORT_NUMBER) {
+					/*update port number,in case of client change port */
+					clientPtr->portNum = portNum;
+				}
+#if defined(CONFIG_SMP)
+				SMP_UNLOCK_IGMP(flags);
+#endif
+				return clientPtr;
+			}
+		}
+#endif
+		clientPtr = clientPtr->next;
+
+	}
+
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+
+	return NULL;
+}
+
+uint32 rtl_getAllClientPortMask(struct rtl_groupEntry *groupEntry)
+{
+	uint32 clientPortMask = 0;
+
+	struct rtl_clientEntry *clientPtr = groupEntry->clientList;
+
+	while (clientPtr != NULL) {
+
+		clientPortMask |= 1 << (clientPtr->portNum);
+		clientPtr = clientPtr->next;
+	}
+
+	return clientPortMask;
+}
+
+/* link client Entry in the front of group client list */
+static void rtl_linkClientEntry(struct rtl_groupEntry *groupEntry,
+	struct rtl_clientEntry *clientEntry)
+{
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	rtl_glueMutexLock();	//Lock resource
+	if (NULL == clientEntry) {
+		return;
+	}
+
+	if (NULL == groupEntry) {
+		return;
+	}
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	if (groupEntry->clientList != NULL) {
+		groupEntry->clientList->previous = clientEntry;
+	}
+	clientEntry->next = groupEntry->clientList;
+
+	groupEntry->clientList = clientEntry;
+	groupEntry->clientList->previous = NULL;
+
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	printk("HW_MCAST:%s:%d Link client entry. group_idx:%d client_idx:%d "
+			"clientAddr:%d.%d.%d.%d\n",
+			__func__, __LINE__, groupEntry->idx,
+			clientEntry->idx, clientEntry->clientAddr[0] >> 24,
+			(clientEntry->clientAddr[0] & 0x00ff0000) >> 16,
+			(clientEntry->clientAddr[0] & 0x0000ff00) >> 8,
+			(clientEntry->clientAddr[0] & 0xff));
+#endif
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	rtl_glueMutexUnlock();	//UnLock resource
+
+}
+
+/* unlink a client entry from group client list */
+static void rtl_unlinkClientEntry(struct rtl_groupEntry *groupEntry,
+	struct rtl_clientEntry *clientEntry)
+{
+	if (NULL == clientEntry) {
+		return;
+	}
+
+	if (NULL == groupEntry) {
+		return;
+	}
+
+	rtl_glueMutexLock();	/* lock resource */
+
+	/* unlink entry node */
+	if (clientEntry == groupEntry->clientList) {	/*unlink group list head */
+		groupEntry->clientList = groupEntry->clientList->next;
+		if (groupEntry->clientList != NULL) {
+			groupEntry->clientList->previous = NULL;
+		}
+
+	} else {
+		if (clientEntry->previous != NULL) {
+			clientEntry->previous->next = clientEntry->next;
+		}
+
+		if (clientEntry->next != NULL) {
+			clientEntry->next->previous = clientEntry->previous;
+		}
+	}
+
+	clientEntry->previous = NULL;
+	clientEntry->next = NULL;
+
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	printk("HW_MCAST:%s:%d Unlink client entry. group_idx:%d client_idx:%d "
+			"clientAddr:%d.%d.%d.%d\n",
+			__func__, __LINE__, groupEntry->idx,
+			clientEntry->idx, clientEntry->clientAddr[0] >> 24,
+			(clientEntry->clientAddr[0] & 0x00ff0000) >> 16,
+			(clientEntry->clientAddr[0] & 0x0000ff00) >> 8,
+			(clientEntry->clientAddr[0] & 0xff));
+#endif
+	rtl_glueMutexUnlock();	//UnLock resource
+
+}
+
+/* clear the content of client entry */
+static void rtl_clearClientEntry(struct rtl_clientEntry *clientEntry)
+{
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	int tmp_idx = 0;
+#endif
+
+	rtl_glueMutexLock();
+	if (NULL != clientEntry) {
+#if defined(CONFIG_HW_MCAST_DEBUG)
+	printk(KERN_DEBUG
+			"HW_MCAST:%s:%d Going to free clientEntry->idx:%d clientAddr:%d.%d.%d.%d\n",
+			__func__, __LINE__, clientEntry->idx, clientEntry->clientAddr[0] >> 24,
+			(clientEntry->clientAddr[0] & 0x00ff0000) >> 16,
+			(clientEntry->clientAddr[0] & 0x0000ff00) >> 8,
+			(clientEntry->clientAddr[0] & 0xff));
+#endif
+#if defined(CONFIG_HW_MCAST_DEBUG)
+		tmp_idx = clientEntry->idx;
+#endif
+		memset(clientEntry, 0, sizeof(struct rtl_clientEntry));
+#if defined(CONFIG_HW_MCAST_DEBUG)
+		clientEntry->idx = tmp_idx;
+#endif
+	}
+	rtl_glueMutexUnlock();
+}
+
+static uint32 rtl_getClientNum(uint32 moduleIndex, uint32 ipVersion,
+	struct rtl_groupEntry *groupEntry, struct rtl_clientEntry *clientEntry)
+{
+	uint32 ClientNum = 0;
+
+	struct rtl_clientEntry *clientPtr = NULL;
+
+	if (groupEntry == NULL)
+		return 0;
+	/*printk("[%s]:[%d]moduleIndex:%d,group:%x,client:%x\n",__FUNCTION__,__LINE__,moduleIndex,
+	 * groupEntry->groupAddr[0],clientEntry->clientAddr[0]); */
+	clientPtr = groupEntry->clientList;
+
+	while (clientPtr != NULL) {
+		if (ipVersion == IP_VERSION4) {
+			if (clientEntry
+				&& (clientPtr->clientAddr[0] == clientEntry->clientAddr[0])) {
+				clientPtr = clientPtr->next;
+				continue;
+			}
+
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			if (clientEntry &&
+				((clientPtr->clientAddr[0] == clientEntry->clientAddr[0])
+					&& (clientPtr->clientAddr[1] == clientEntry->clientAddr[1])
+					&& (clientPtr->clientAddr[2] == clientEntry->clientAddr[2])
+					&& (clientPtr->clientAddr[3] == clientEntry->clientAddr[3]))) {
+				clientPtr = clientPtr->next;
+				continue;
+			}
+		}
+#endif
+		ClientNum++;
+		clientPtr = clientPtr->next;
+	}
+
+	return ClientNum;
+}
+
+/*********************************************
+			source list operation
+ *********************************************/
+static struct rtl_sourceEntry *rtl_searchSourceEntry(uint32 ipVersion,
+	uint32 *sourceAddr, struct rtl_clientEntry *clientEntry)
+{
+	struct rtl_sourceEntry *sourcePtr = clientEntry->sourceList;
+
+	while (sourcePtr != NULL) {
+		if (ipVersion == IP_VERSION4) {
+			if (sourceAddr[0] == sourcePtr->sourceAddr[0]) {
+				return sourcePtr;
+			}
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			if ((sourceAddr[0] == sourcePtr->sourceAddr[0]) &&
+				(sourceAddr[1] == sourcePtr->sourceAddr[1]) &&
+				(sourceAddr[2] == sourcePtr->sourceAddr[2]) &&
+				(sourceAddr[3] == sourcePtr->sourceAddr[3])
+				) {
+				return sourcePtr;
+			}
+		}
+#endif
+		sourcePtr = sourcePtr->next;
+	}
+
+	return NULL;
+}
+
+#if 0
+static int32 rtl_searchSourceAddr(uint32 ipVersion, uint32 *sourceAddr,
+	uint32 *sourceArray, uint32 elementCount)
+{
+	uint32 i = 0;
+	uint32 *srcPtr = sourceArray;
+
+	for (i = 0; i < elementCount; i++) {
+		if (ipVersion == IP_VERSION4) {
+			if (sourceAddr[0] == srcPtr[0]) {
+				return TRUE;
+			}
+			srcPtr++;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		if (ipVersion == IP_VERSION6) {
+			if ((sourceAddr[0] == srcPtr[0]) &&
+				(sourceAddr[1] == srcPtr[1]) &&
+				(sourceAddr[2] == srcPtr[2]) &&
+				(sourceAddr[3] == srcPtr[3])) {
+
+				return TRUE;
+			}
+
+			srcPtr = srcPtr + 4;
+		}
+#endif
+	}
+
+	return FALSE;
+}
+#endif
+
+static void rtl_linkSourceEntry(struct rtl_clientEntry *clientEntry,
+	struct rtl_sourceEntry *entryNode)
+{
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	if (NULL == entryNode) {
+		return;
+	}
+
+	if (NULL == clientEntry) {
+		return;
+	}
+
+	rtl_glueMutexLock();	/* lock resource */
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	if (clientEntry->sourceList != NULL) {
+		clientEntry->sourceList->previous = entryNode;
+	}
+	entryNode->next = clientEntry->sourceList;
+	clientEntry->sourceList = entryNode;
+	clientEntry->sourceList->previous = NULL;
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	rtl_glueMutexUnlock();	/* lock resource */
+}
+
+static void rtl_unlinkSourceEntry(struct rtl_clientEntry *clientEntry,
+	struct rtl_sourceEntry *sourceEntry)
+{
+	if (NULL == sourceEntry) {
+		return;
+	}
+
+	if (NULL == clientEntry) {
+		return;
+	}
+
+	rtl_glueMutexLock();	/* lock resource */
+	/* unlink entry node */
+	if (sourceEntry == clientEntry->sourceList) {	/*unlink group list head */
+
+		clientEntry->sourceList = sourceEntry->next;
+		if (clientEntry->sourceList != NULL) {
+			clientEntry->sourceList->previous = NULL;
+		}
+	} else {
+		if (sourceEntry->previous != NULL) {
+			sourceEntry->previous->next = sourceEntry->next;
+		}
+
+		if (sourceEntry->next != NULL) {
+			sourceEntry->next->previous = sourceEntry->previous;
+		}
+	}
+
+	sourceEntry->previous = NULL;
+	sourceEntry->next = NULL;
+
+	rtl_glueMutexUnlock();	//UnLock resource
+
+}
+
+static void rtl_clearSourceEntry(struct rtl_sourceEntry *sourceEntryPtr)
+{
+	rtl_glueMutexLock();
+	if (NULL != sourceEntryPtr) {
+		memset(sourceEntryPtr, 0, sizeof(struct rtl_sourceEntry));
+	}
+	rtl_glueMutexUnlock();
+}
+
+/*********************************************
+			multicast flow list operation
+ *********************************************/
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+static struct rtl_mcastFlowEntry *rtl_searchMcastFlowEntry(uint32 moduleIndex,
+	uint32 ipVersion, uint32 *serverAddr, uint32 *groupAddr)
+{
+	struct rtl_mcastFlowEntry *mcastFlowPtr = NULL;
+	uint32 hashIndex = 0;
+
+	if (NULL == serverAddr) {
+		return NULL;
+	}
+
+	if (NULL == groupAddr) {
+		return NULL;
+	}
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, groupAddr);
+
+	if (rtl_mCastModuleArray[moduleIndex].flowHashTable != NULL)
+		mcastFlowPtr = rtl_mCastModuleArray[moduleIndex].flowHashTable[hashIndex];
+
+	while (mcastFlowPtr != NULL) {
+
+		if (mcastFlowPtr->ipVersion != ipVersion) {
+			goto nextFlow;
+		}
+
+		if (ipVersion == IP_VERSION4) {
+			if ((serverAddr[0] == mcastFlowPtr->serverAddr[0])
+				&& (groupAddr[0] == mcastFlowPtr->groupAddr[0])) {
+				mcastFlowPtr->refreshTime = rtl_sysUpSeconds;
+				return mcastFlowPtr;
+			}
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+
+			if ((serverAddr[0] == mcastFlowPtr->serverAddr[0])
+				&& (serverAddr[0] == mcastFlowPtr->serverAddr[0])
+				&& (serverAddr[0] == mcastFlowPtr->serverAddr[0])
+				&& (serverAddr[0] == mcastFlowPtr->serverAddr[0])
+				&& (groupAddr[0] == mcastFlowPtr->groupAddr[0])
+				&& (groupAddr[1] == mcastFlowPtr->groupAddr[1])
+				&& (groupAddr[2] == mcastFlowPtr->groupAddr[2])
+				&& (groupAddr[3] == mcastFlowPtr->groupAddr[3])) {
+				mcastFlowPtr->refreshTime = rtl_sysUpSeconds;
+				return mcastFlowPtr;
+			}
+		}
+
+nextFlow:
+#endif
+		mcastFlowPtr = mcastFlowPtr->next;
+
+	}
+
+	return NULL;
+}
+
+/* link multicast flow entry in the front of a forwarding flow list */
+static void rtl_linkMcastFlowEntry(struct rtl_mcastFlowEntry *mcastFlowEntry,
+	struct rtl_mcastFlowEntry **hashTable)
+{
+	uint32 hashIndex = 0;
+
+	rtl_glueMutexLock();	//Lock resource
+	if (NULL == mcastFlowEntry) {
+		rtl_glueMutexUnlock();
+		return;
+	}
+
+	if (NULL == hashTable) {
+		rtl_glueMutexUnlock();
+		return;
+	}
+
+	hashIndex = rtl_igmpHashAlgorithm(mcastFlowEntry->ipVersion,
+		mcastFlowEntry->groupAddr);
+
+	if (hashTable[hashIndex] != NULL) {
+		hashTable[hashIndex]->previous = mcastFlowEntry;
+	}
+	mcastFlowEntry->next = hashTable[hashIndex];
+	hashTable[hashIndex] = mcastFlowEntry;
+	hashTable[hashIndex]->previous = NULL;
+
+	rtl_glueMutexUnlock();	//UnLock resource
+	return;
+
+}
+
+/* unlink a multicast flow entry*/
+static void rtl_unlinkMcastFlowEntry(struct rtl_mcastFlowEntry *mcastFlowEntry,
+	struct rtl_mcastFlowEntry **hashTable)
+{
+	uint32 hashIndex = 0;
+
+	if (NULL == mcastFlowEntry) {
+		return;
+	}
+
+	hashIndex = rtl_igmpHashAlgorithm(mcastFlowEntry->ipVersion,
+		mcastFlowEntry->groupAddr);
+
+	rtl_glueMutexLock();	/* lock resource */
+	/* unlink entry node */
+	if (mcastFlowEntry == hashTable[hashIndex]) {	/*unlink flow list head */
+		hashTable[hashIndex] = mcastFlowEntry->next;
+		if (hashTable[hashIndex] != NULL) {
+			hashTable[hashIndex]->previous = NULL;
+		}
+	} else {
+		if (mcastFlowEntry->previous != NULL) {
+			mcastFlowEntry->previous->next = mcastFlowEntry->next;
+		}
+
+		if (mcastFlowEntry->next != NULL) {
+			mcastFlowEntry->next->previous = mcastFlowEntry->previous;
+		}
+	}
+
+	mcastFlowEntry->previous = NULL;
+	mcastFlowEntry->next = NULL;
+
+	rtl_glueMutexUnlock();	//UnLock resource
+
+}
+
+/* clear the content of multicast flow entry */
+static void rtl_clearMcastFlowEntry(struct rtl_mcastFlowEntry *mcastFlowEntry)
+{
+	rtl_glueMutexLock();
+	if (NULL != mcastFlowEntry) {
+		memset(mcastFlowEntry, 0, sizeof(struct rtl_mcastFlowEntry));
+	}
+	rtl_glueMutexUnlock();
+}
+
+static void rtl_deleteMcastFlowEntry(struct rtl_mcastFlowEntry *mcastFlowEntry,
+	struct rtl_mcastFlowEntry **hashTable)
+{
+	if (mcastFlowEntry != NULL) {
+
+		rtl_unlinkMcastFlowEntry(mcastFlowEntry, hashTable);
+		rtl_clearMcastFlowEntry(mcastFlowEntry);
+		rtl_freeMcastFlowEntry(mcastFlowEntry);
+	}
+
+	return;
+}
+#endif
+
+/*****source entry/client entry/group entry/flow entry operation*****/
+
+static void rtl_deleteSourceEntry(struct rtl_clientEntry *clientEntry,
+	struct rtl_sourceEntry *sourceEntry)
+{
+	if (clientEntry == NULL) {
+		return;
+	}
+
+	if (sourceEntry != NULL) {
+		rtl_unlinkSourceEntry(clientEntry, sourceEntry);
+		rtl_clearSourceEntry(sourceEntry);
+		rtl_freeSourceEntry(sourceEntry);
+	}
+}
+
+static void rtl_deleteSourceList(struct rtl_clientEntry *clientEntry)
+{
+	struct rtl_sourceEntry *sourceEntry = NULL;
+	struct rtl_sourceEntry *nextSourceEntry = NULL;
+
+	sourceEntry = clientEntry->sourceList;
+	while (sourceEntry != NULL) {
+		nextSourceEntry = sourceEntry->next;
+		rtl_deleteSourceEntry(clientEntry, sourceEntry);
+		sourceEntry = nextSourceEntry;
+	}
+}
+
+static void rtl_deleteClientEntry(struct rtl_groupEntry *groupEntry,
+	struct rtl_clientEntry *clientEntry)
+{
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	if (NULL == clientEntry) {
+		return;
+	}
+
+	if (NULL == groupEntry) {
+		return;
+	}
+#if defined(CONFIG_RTL_8370_SUPPORT)
+	// delete/update 8370 L2 multicast entry here
+	if (clientEntry->portNum == 0) {
+		rtl8370L2McastAddrUpdate(2, groupEntry->groupAddr[0],
+			clientEntry->clientAddr[0], clientEntry->clientMacAddr);
+	}
+#endif
+
+	rtl_deleteSourceList(clientEntry);
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	rtl_unlinkClientEntry(groupEntry, clientEntry);
+	rtl_clearClientEntry(clientEntry);
+	rtl_freeClientEntry(clientEntry);
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	return;
+
+}
+
+static void rtl_deleteClientList(struct rtl_groupEntry *groupEntry)
+{
+
+	struct rtl_clientEntry *clientEntry = NULL;
+	struct rtl_clientEntry *nextClientEntry = NULL;
+
+	if (NULL == groupEntry) {
+		return;
+	}
+
+	clientEntry = groupEntry->clientList;
+	while (clientEntry != NULL) {
+		nextClientEntry = clientEntry->next;
+		rtl_deleteClientEntry(groupEntry, clientEntry);
+		clientEntry = nextClientEntry;
+	}
+}
+
+static void rtl_deleteGroupEntry(struct rtl_groupEntry *groupEntry,
+	struct rtl_groupEntry **hashTable)
+{
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	if (groupEntry != NULL) {
+
+		rtl_deleteClientList(groupEntry);
+#if defined(CONFIG_SMP)
+		SMP_LOCK_IGMP(flags);
+#endif
+		/*
+		 * This ipVersion condition protects the race condition on SMP platform.
+		 * Uncleared group entry won't have zero value in ipVersion.
+		 */
+		if (groupEntry->ipVersion) {
+			rtl_unlinkGroupEntry(groupEntry, hashTable);
+			rtl_clearGroupEntry(groupEntry);
+			rtl_freeGroupEntry(groupEntry);
+		}
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_IGMP(flags);
+#endif
+
+	}
+
+}
+
+static int32 rtl_checkMCastAddrMapping(uint32 ipVersion, uint32 *ipAddr,
+	uint8 *macAddr)
+{
+	if (ipVersion == IP_VERSION4) {
+		if (macAddr[0] != 0x01) {
+			return FALSE;
+		}
+
+		if ((macAddr[3] & 0x7f) != (uint8)((ipAddr[0] & 0x007f0000) >> 16)) {
+			return FALSE;
+		}
+
+		if (macAddr[4] != (uint8)((ipAddr[0] & 0x0000ff00) >> 8)) {
+			return FALSE;
+		}
+
+		if (macAddr[5] != (uint8)(ipAddr[0] & 0x000000ff)) {
+			return FALSE;
+		}
+
+		return TRUE;
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		if (macAddr[0] != 0x33) {
+			return FALSE;
+		}
+
+		if (macAddr[1] != 0x33) {
+			return FALSE;
+		}
+
+		if (macAddr[2] != (uint8)((ipAddr[3] & 0xff000000) >> 24)) {
+			return FALSE;
+		}
+
+		if (macAddr[3] != (uint8)((ipAddr[3] & 0x00ff0000) >> 16)) {
+			return FALSE;
+		}
+
+		if (macAddr[4] != (uint8)((ipAddr[3] & 0x0000ff00) >> 8)) {
+			return FALSE;
+		}
+
+		if (macAddr[5] != (uint8)(ipAddr[3] & 0x000000ff)) {
+			return FALSE;
+		}
+
+		return TRUE;
+	}
+#endif
+	return FALSE;
+}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+static int32 rtl_compareIpv6Addr(uint32 *ipv6Addr1, uint32 *ipv6Addr2)
+{
+	int i;
+
+	for (i = 0; i < 4; i++) {
+		if (ipv6Addr1[i] != ipv6Addr2[i]) {
+			return FALSE;
+		}
+	}
+
+	return TRUE;
+}
+#endif
+
+static int32 rtl_compareMacAddr(uint8 *macAddr1, uint8 *macAddr2)
+{
+	int i;
+
+	for (i = 0; i < 6; i++) {
+		if (macAddr1[i] != macAddr2[i]) {
+			return FALSE;
+		}
+	}
+	return TRUE;
+}
+
+static uint16 rtl_checksum(uint8 *packetBuf, uint32 packetLen)
+{
+	/*note: the first bytes of  packetBuf should be two bytes aligned */
+	uint32 checksum = 0;
+	uint32 count = packetLen;
+	uint16 *ptr = (uint16 *)(packetBuf);
+
+	while (count > 1) {
+		checksum += ntohs(*ptr);
+		ptr++;
+		count -= 2;
+	}
+
+	if (count > 0) {
+		checksum += *(packetBuf + packetLen - 1) << 8;	/*the last odd byte is treated as bit 15~8 of unsigned short */
+	}
+
+	/* Roll over carry bits */
+	checksum = (checksum >> 16) + (checksum & 0xffff);
+	checksum += (checksum >> 16);
+
+	/* Return checksum */
+	return ((uint16)~checksum);
+
+}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+static uint16 rtl_ipv6L3Checksum(uint8 *pktBuf, uint32 pktLen,
+	union pseudoHeader *ipv6PseudoHdr)
+{
+	uint32 checksum = 0;
+	uint32 count = pktLen;
+	uint16 *ptr;
+
+	/*compute ipv6 pseudo-header checksum */
+	ptr = (uint16 *)(ipv6PseudoHdr);
+	for (count = 0; count < 20; count++) {	/*the pseudo header is 40 bytes long */
+		checksum += ntohs(*ptr);
+		ptr++;
+	}
+
+	/*compute the checksum of mld buffer */
+	count = pktLen;
+	ptr = (uint16 *)(pktBuf);
+	while (count > 1) {
+		checksum += ntohs(*ptr);
+		ptr++;
+		count -= 2;
+	}
+
+	if (count > 0) {
+		checksum += *(pktBuf + pktLen - 1) << 8;	/*the last odd byte is treated as bit 15~8 of unsigned short */
+	}
+
+	/* Roll over carry bits */
+	checksum = (checksum >> 16) + (checksum & 0xffff);
+	checksum += (checksum >> 16);
+
+	/* Return checksum */
+	return ((uint16)~checksum);
+
+}
+#endif
+
+static uint32 rtl_getClientFwdPortMask(struct rtl_clientEntry *clientEntry,
+	uint32 sysTime)
+{
+
+	uint32 portMask = (1 << clientEntry->portNum);
+	uint32 fwdPortMask = 0;
+
+	struct rtl_sourceEntry *sourcePtr = NULL;;
+
+	if (clientEntry->groupFilterTimer > sysTime) {	/*exclude mode never expired */
+		fwdPortMask |= portMask;
+	} else {		/*include mode */
+
+		sourcePtr = clientEntry->sourceList;
+		while (sourcePtr != NULL) {
+			if (sourcePtr->portTimer > sysTime) {
+				fwdPortMask |= portMask;
+				break;
+			}
+			sourcePtr = sourcePtr->next;
+
+		}
+
+	}
+
+	return fwdPortMask;
+}
+
+static void rtl_checkSourceTimer(struct rtl_clientEntry *clientEntry,
+	struct rtl_sourceEntry *sourceEntry)
+{
+	uint8 deleteFlag = FALSE;
+	uint8 oldFwdState, newFwdState;
+
+	oldFwdState = sourceEntry->fwdState;
+
+	if (sourceEntry->portTimer <= rtl_sysUpSeconds) {	/*means time out */
+		if (clientEntry->groupFilterTimer <= rtl_sysUpSeconds) {	/* include mode */
+			deleteFlag = TRUE;
+		}
+
+		sourceEntry->fwdState = FALSE;
+	} else {
+		deleteFlag = FALSE;
+		sourceEntry->fwdState = TRUE;
+	}
+
+	newFwdState = sourceEntry->fwdState;
+
+	if (deleteFlag == TRUE) {	/*means INCLUDE mode and expired */
+		rtl_deleteSourceEntry(clientEntry, sourceEntry);
+	}
+
+	if ((deleteFlag == TRUE) || (newFwdState != oldFwdState)) {
+#ifdef CONFIG_RECORD_MCAST_FLOW
+		rtl_invalidateMCastFlow(timerEventContext.moduleIndex,
+			timerEventContext.ipVersion,
+			timerEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		if (timerEventContext.ipVersion == IP_VERSION4) {
+#ifdef CONFIG_PROC_FS
+			rtl_mCastModuleArray[timerEventContext.moduleIndex].expireEventCnt++;
+#endif
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST,
+				&timerEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+			rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST,
+				&timerEventContext);
+#endif
+
+		}
+#endif
+	}
+
+}
+
+static uint32 rtl_getClientSourceFwdPortMask(uint32 ipVersion,
+	struct rtl_clientEntry *clientEntry, uint32 *sourceAddr, uint32 sysTime)
+{
+	uint32 portMask = (1 << clientEntry->portNum);
+	uint32 fwdPortMask = 0;
+	struct rtl_sourceEntry *sourceEntry = NULL;
+
+	if (clientEntry == NULL) {
+		return 0xFFFFFFFF;	/*broadcast */
+	} else {
+		sourceEntry = rtl_searchSourceEntry(ipVersion, sourceAddr,
+			clientEntry);
+
+		if (clientEntry->groupFilterTimer <= sysTime) {	/*include mode */
+			if (sourceEntry != NULL) {
+				if (sourceEntry->portTimer > sysTime) {
+					fwdPortMask |= portMask;
+				}
+			}
+		} else {	/*exclude mode */
+
+			if (sourceEntry == NULL) {
+				fwdPortMask |= portMask;
+			} else {
+				if (sourceEntry->portTimer > sysTime) {
+					fwdPortMask |= portMask;
+				}
+			}
+		}
+
+		return fwdPortMask;
+
+	}
+}
+
+static uint32 rtl_getGroupSourceFwdPortMask(struct rtl_groupEntry *groupEntry,
+	uint32 *sourceAddr, uint32 sysTime)
+{
+	uint32 fwdPortMask = 0;
+	struct rtl_clientEntry *clientEntry = NULL;
+
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	if (groupEntry == NULL) {
+		return 0xFFFFFFFF;	/*broadcast */
+	}
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if (groupEntry->attribute == STATIC_RESERVED_MULTICAST) {
+		return groupEntry->staticFwdPortMask;
+	}
+#endif
+
+	SMP_LOCK_IGMP(flags);
+
+	clientEntry = groupEntry->clientList;
+	while (clientEntry != NULL) {
+		fwdPortMask |= rtl_getClientSourceFwdPortMask(groupEntry->ipVersion,
+			clientEntry, sourceAddr, sysTime);
+		clientEntry = clientEntry->next;
+	}
+
+	SMP_UNLOCK_IGMP(flags);
+
+	return fwdPortMask;
+}
+
+static void rtl_checkClientEntryTimer(struct rtl_groupEntry *groupEntry,
+	struct rtl_clientEntry *clientEntry)
+{
+	uint32 oldFwdPortMask = 0;
+	uint32 newFwdPortMask = 0;
+	struct rtl_sourceEntry *sourceEntry = clientEntry->sourceList;
+	struct rtl_sourceEntry *nextSourceEntry = NULL;
+
+	oldFwdPortMask = rtl_getClientFwdPortMask(clientEntry, rtl_sysUpSeconds);
+
+	while (sourceEntry != NULL) {
+		nextSourceEntry = sourceEntry->next;
+		rtl_checkSourceTimer(clientEntry, sourceEntry);
+		sourceEntry = nextSourceEntry;
+	}
+
+	newFwdPortMask = rtl_getClientFwdPortMask(clientEntry, rtl_sysUpSeconds);
+
+	if (newFwdPortMask == 0) {	/*none active port */
+		rtl_deleteClientEntry(groupEntry, clientEntry);
+	}
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if ((groupEntry != NULL)
+		&& (groupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		return;
+	}
+#endif
+
+	if ((oldFwdPortMask != newFwdPortMask) || (newFwdPortMask == 0)) {
+#ifdef CONFIG_RECORD_MCAST_FLOW
+		rtl_invalidateMCastFlow(timerEventContext.moduleIndex,
+			timerEventContext.ipVersion,
+			timerEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		if (timerEventContext.ipVersion == IP_VERSION4) {
+#ifdef CONFIG_PROC_FS
+			rtl_mCastModuleArray[timerEventContext.moduleIndex].expireEventCnt++;
+#endif
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST,
+				&timerEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+			rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST,
+				&timerEventContext);
+#endif
+
+		}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		if (timerEventContext.ipVersion == IP_VERSION6) {
+#ifdef CONFIG_PROC_FS
+			rtl_mCastModuleArray[timerEventContext.moduleIndex].expireEventCnt++;
+#endif
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST6,
+				&timerEventContext);
+		}
+#endif
+#endif
+
+	}
+
+}
+
+static void rtl_checkGroupEntryTimer(struct rtl_groupEntry *groupEntry,
+	struct rtl_groupEntry **hashTable)
+{
+	uint32 deleteFlag = FALSE;
+	struct rtl_clientEntry *clientEntry = groupEntry->clientList;
+	struct rtl_clientEntry *nextClientEntry = NULL;
+
+	while (clientEntry != NULL) {
+		nextClientEntry = clientEntry->next;
+		timerEventContext.portMask = 1 << (clientEntry->portNum);
+		rtl_checkClientEntryTimer(groupEntry, clientEntry);
+		clientEntry = nextClientEntry;
+	}
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if ((groupEntry != NULL)
+		&& (groupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		return;
+	}
+#endif
+
+	if (groupEntry->clientList == NULL) {	/*none active client */
+		deleteFlag = TRUE;
+		rtl_deleteGroupEntry(groupEntry, hashTable);
+	}
+
+	if (deleteFlag == TRUE) {
+#ifdef CONFIG_RECORD_MCAST_FLOW
+		rtl_invalidateMCastFlow(timerEventContext.moduleIndex,
+			timerEventContext.ipVersion,
+			timerEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		if (timerEventContext.ipVersion == IP_VERSION4) {
+#ifdef CONFIG_PROC_FS
+			rtl_mCastModuleArray[timerEventContext.moduleIndex].expireEventCnt++;
+#endif
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST,
+				&timerEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+			rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST,
+				&timerEventContext);
+#endif
+
+		}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		if (timerEventContext.ipVersion == IP_VERSION6) {
+#ifdef CONFIG_PROC_FS
+			rtl_mCastModuleArray[timerEventContext.moduleIndex].expireEventCnt++;
+#endif
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST6,
+				&timerEventContext);
+		}
+#endif
+#endif
+
+	}
+
+}
+
+static int32 rtl_initHashTable(uint32 moduleIndex, uint32 hashTableSize)
+{
+	uint32 i = 0;
+
+	/* Allocate memory */
+	rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable =
+			(struct rtl_groupEntry **)rtl_glueMalloc(sizeof(uintptr_t) * hashTableSize);
+	if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+		for (i = 0; i < hashTableSize; i++) {
+			rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i] = NULL;
+		}
+
+	} else {
+		return FAILED;
+	}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable =
+			(struct rtl_groupEntry **)rtl_glueMalloc(sizeof(uintptr_t) * hashTableSize);
+
+	if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+		for (i = 0; i < hashTableSize; i++) {
+
+			rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i] = NULL;
+		}
+	} else {
+		if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+			rtl_glueFree(rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+
+		return FAILED;
+
+	}
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_mCastModuleArray[moduleIndex].flowHashTable =
+			(struct rtl_mcastFlowEntry **)rtl_glueMalloc(sizeof(uintptr_t) * hashTableSize);
+
+	if (rtl_mCastModuleArray[moduleIndex].flowHashTable != NULL) {
+		for (i = 0; i < hashTableSize; i++) {
+
+			rtl_mCastModuleArray[moduleIndex].flowHashTable[i] = NULL;
+		}
+	} else {
+		if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+			rtl_glueFree(rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+			rtl_glueFree(rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+		}
+#endif
+		return FAILED;
+
+	}
+#endif
+	return SUCCESS;
+
+}
+
+/**************************
+	Utility
+**************************/
+static void rtl_parseMacFrame(uint32 moduleIndex, uint8 *macFrame,
+	uint32 verifyCheckSum, struct rtl_macFrameInfo *macInfo)
+{
+
+//MAC Frame :DA(6 bytes)+SA(6 bytes)+ CPU tag(4 bytes) + VlAN tag(Optional, 4 bytes)
+//                   +Type(IPv4:0x0800, IPV6:0x86DD, PPPOE:0x8864, 2 bytes )+Data(46~1500 bytes)+CRC(4 bytes)
+
+	uint8 *ptr = macFrame;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	int i = 0;
+	uint8 nextHeader = 0;
+	uint16 extensionHdrLen = 0;
+	uint8 routingHead = FALSE;
+
+	uint8 optionDataLen = 0;
+	uint8 optionType = 0;
+	uint32 ipv6RAO = 0;
+#endif
+
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	int is_pppoe = 0;
+#endif
+
+	uint32 ipAddr[4] = { 0, 0, 0, 0 };
+	union pseudoHeader pHeader;
+
+	memset(macInfo, 0, sizeof(struct rtl_macFrameInfo));
+	memset(&pHeader, 0, sizeof(union pseudoHeader));
+
+	memcpy(macInfo->srcMacAddr, ptr + 6, 6);
+
+	ptr = ptr + 12;
+
+	/*check the presence of VLAN tag */
+	if (*(int16 *)(ptr) == (int16)htons(VLAN_PROTOCOL_ID)) {
+		ptr = ptr + 4;
+	}
+
+	/*ignore packet with PPPOE header */
+	if (*(int16 *)(ptr) == (int16)htons(PPPOE_ETHER_TYPE)) {
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+		ptr = ptr + 2 + 6;
+		is_pppoe = 1;
+#else
+		return;
+#endif
+	}
+
+	/*check the presence of ipv4 type */
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	if ((*(int16 *)(ptr) == (int16)htons(IPV4_ETHER_TYPE)) ||
+		((is_pppoe == 1)
+			&& (*(int16 *)(ptr) == (int16)htons(PPP_IPV4_PROTOCOL))))
+#else
+	if (*(int16 *)(ptr) == (int16)htons(IPV4_ETHER_TYPE))
+#endif
+	{
+		ptr = ptr + 2;
+		macInfo->ipBuf = ptr;
+		macInfo->ipVersion = IP_VERSION4;
+	} else {
+		/*check the presence of ipv4 type */
+	#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+		if((*(int16 *)(ptr)==(int16)htons(IPV6_ETHER_TYPE))||
+		  ((is_pppoe == 1) && (*(int16 *)(ptr)==(int16)htons(PPP_IPV6_PROTOCOL))))
+
+	#else
+		if(*(int16 *)(ptr)==(int16)htons(IPV6_ETHER_TYPE))
+	#endif
+		{
+			ptr=ptr+2;
+			macInfo->ipBuf=ptr;
+			macInfo->ipVersion=IP_VERSION6;
+		}
+	}
+
+	if ((macInfo->ipVersion != IP_VERSION4)
+		&& (macInfo->ipVersion != IP_VERSION6)) {
+		return;
+	}
+	macInfo->checksumFlag = FAILED;
+
+	if (macInfo->ipVersion == IP_VERSION4) {
+		macInfo->ipHdrLen = (uint16)((((struct ipv4Pkt *)(macInfo->ipBuf))->vhl & 0x0f) << 2);
+		macInfo->l3PktLen = ntohs(((struct ipv4Pkt *)(macInfo->ipBuf))->length) -
+			macInfo->ipHdrLen;
+		ptr = ptr + macInfo->ipHdrLen;
+		macInfo->l3PktBuf = ptr;
+		macInfo->macFrameLen = (uint16)((ptr - macFrame) + macInfo->l3PktLen);
+		macInfo->srcIpAddr[0] = ntohl(((struct ipv4Pkt *)(macInfo->ipBuf))->sourceIp);
+		macInfo->dstIpAddr[0] = ntohl(((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp);
+/*distinguish different IGMP packet:
+                                                    ip_header_length      destination_ip      igmp_packet_length   igmp_type   group_address
+IGMPv1_general_query:                            20                   224.0.0.1                       8                    0x11                 0
+IGMPv2_general_query:                            24                   224.0.0.1                       8                    0x11                 0
+IGMPv2_group_specific_query:			24                   224.0.0.1                       8                    0x11               !=0
+IGMPv3 _query:                                        24                   224.0.0.1                   >=12                  0x11        according_to_different_situation
+
+IGMPv1_join:                                            20          actual_multicast_address         8                    0x12           actual_multicast_address
+IGMPv2_join:                                            24          actual_multicast_address         8                    0x16           actual_multicast_address
+IGMPv2_leave:                                          24          actual_multicast_address         8                    0x17           actual_multicast_address
+IGMPv3_report:                                         24          actual_multicast_address       >=12                0x22           actual_multicast_address*/
+
+		/* parse IGMP type and version */
+		if (((struct ipv4Pkt *)(macInfo->ipBuf))->protocol == IGMP_PROTOCOL) {
+			/*check DVMRP */
+			if ((macInfo->l3PktBuf[0] == DVMRP_TYPE)
+				&& (((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp == htonl(DVMRP_ADDR))) {
+				macInfo->l3Protocol = DVMRP_PROTOCOL;
+			} else {
+				/*means unicast */
+				if ((macFrame[0] & 0x01) == 0) {
+					if (rtl_compareMacAddr(macFrame,
+							rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac) == TRUE) {
+						if (((struct ipv4Pkt *)
+								(macInfo->ipBuf))->destinationIp == htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv4Addr))
+						{
+							macInfo->l3Protocol = IGMP_PROTOCOL;
+							goto otherpro;
+						}
+					}
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+					else if (is_pppoe == 1) {
+						macInfo->l3Protocol = IGMP_PROTOCOL;
+					}
+#endif
+
+				} else {	/*means multicast */
+
+					ipAddr[0] = ntohl(((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp);
+					if (rtl_checkMCastAddrMapping(IP_VERSION4, ipAddr,
+							macFrame) == TRUE) {
+						macInfo->l3Protocol = IGMP_PROTOCOL;
+					} else {
+						return;
+					}
+				}
+			}
+
+		}
+
+otherpro:
+		if (((struct ipv4Pkt *)(macInfo->ipBuf))->protocol == MOSPF_PROTOCOL
+			&& ((((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp == htonl(IPV4_MOSPF_ADDR1))
+				|| (((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp == htonl(IPV4_MOSPF_ADDR2)))) {
+			macInfo->l3Protocol = MOSPF_PROTOCOL;
+		}
+
+		if (((struct ipv4Pkt *)(macInfo->ipBuf))->protocol == PIM_PROTOCOL
+			&& (((struct ipv4Pkt *)(macInfo->ipBuf))->destinationIp == htonl(IPV4_PIM_ADDR))) {
+			macInfo->l3Protocol = PIM_PROTOCOL;
+		}
+
+		if (verifyCheckSum == TRUE) {
+			if (rtl_checksum(macInfo->l3PktBuf,
+					macInfo->l3PktLen) != 0) {
+				macInfo->checksumFlag = FAILED;
+			} else {
+				macInfo->checksumFlag = SUCCESS;
+			}
+		} else {
+			macInfo->checksumFlag = SUCCESS;
+		}
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	if (macInfo->ipVersion == IP_VERSION6) {
+		macInfo->srcIpAddr[0] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->sourceAddr[0]);
+		macInfo->srcIpAddr[1] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->sourceAddr[1]);
+		macInfo->srcIpAddr[2] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->sourceAddr[2]);
+		macInfo->srcIpAddr[3] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->sourceAddr[3]);
+
+		macInfo->dstIpAddr[0] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[0]);
+		macInfo->dstIpAddr[1] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[1]);
+		macInfo->dstIpAddr[2] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[2]);
+		macInfo->dstIpAddr[3] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[3]);
+
+		macInfo->macFrameLen = (uint16)(ptr - macFrame + IPV6_HEADER_LENGTH +
+			ntohs(((struct ipv6Pkt *)(macInfo->ipBuf))->payloadLenth));
+		macInfo->ipHdrLen = IPV6_HEADER_LENGTH;
+
+		nextHeader = ((struct ipv6Pkt *)(macInfo->ipBuf))->nextHeader;
+		ptr = ptr + IPV6_HEADER_LENGTH;
+		while ((ptr - macInfo->ipBuf) <
+			(ntohs(((struct ipv6Pkt *)(macInfo->ipBuf))->payloadLenth) + IPV6_HEADER_LENGTH)) {
+			switch (nextHeader) {
+			case HOP_BY_HOP_OPTIONS_HEADER:
+				/*parse hop-by-hop option */
+				nextHeader = ptr[0];
+				extensionHdrLen = ((uint16)(ptr[1]) + 1) * 8;
+				ptr = ptr + 2;
+
+				while ((ptr - macInfo->ipBuf - 40) < extensionHdrLen) {
+					optionType = ptr[0];
+					/*pad1 option */
+					if (optionType == 0) {
+						ptr = ptr + 1;
+						continue;
+					}
+
+					/*padN option */
+					if (optionType == 1) {
+						optionDataLen = ptr[1];
+						ptr = ptr + optionDataLen + 2;
+						continue;
+					}
+
+					/*router alter option */
+					if (ntohl(*(uint32 *)(ptr)) == IPV6_ROUTER_ALTER_OPTION) {
+						ipv6RAO = IPV6_ROUTER_ALTER_OPTION;
+						ptr = ptr + 4;
+						continue;
+					}
+
+					/*other TLV option */
+					if ((optionType != 0)
+						&& (optionType != 1)) {
+						optionDataLen = ptr[1];
+						ptr = ptr + optionDataLen + 2;
+						continue;
+					}
+
+				}
+				/*
+				 * if((ptr-macInfo->ipBuf-40)!=extensionHdrLen)
+				 * {
+				 * rtl_gluePrintf("ipv6 packet parse error\n");
+				 * } */
+
+				break;
+
+			case ROUTING_HEADER:
+				nextHeader = ptr[0];
+				extensionHdrLen = ((uint16)(ptr[1]) + 1) * 8;
+
+				if (ptr[3] > 0) {
+					ptr = ptr + extensionHdrLen;
+					for (i = 0; i < 4; i++) {
+						pHeader.ipv6_pHdr.destinationAddr[i] = *((uint32 *)(ptr) - 4 + i);
+
+					}
+					routingHead = TRUE;
+
+				} else {
+					ptr = ptr + extensionHdrLen;
+				}
+
+				break;
+
+			case FRAGMENT_HEADER:
+				nextHeader = ptr[0];
+				ptr = ptr + 8;
+				break;
+
+			case DESTINATION_OPTION_HEADER:
+				nextHeader = ptr[0];
+				extensionHdrLen = ((uint16)(ptr[1]) + 1) * 8;
+				ptr = ptr + extensionHdrLen;
+				break;
+
+			case ICMP_PROTOCOL:
+				nextHeader = NO_NEXT_HEADER;
+				macInfo->l3PktLen = ntohs(((struct ipv6Pkt *)(macInfo->ipBuf))->payloadLenth) -
+					(uint16)(ptr - macInfo->ipBuf - IPV6_HEADER_LENGTH);
+				macInfo->l3PktBuf = ptr;
+				if ((ptr[0] == MLD_QUERY)
+					|| (ptr[0] == MLDV1_REPORT)
+					|| (ptr[0] == MLDV1_DONE)
+					|| (ptr[0] == MLDV2_REPORT)) {
+					/*means multicast */
+					if ((macFrame[0] == 0x33) &&
+						(macFrame[1] == 0x33)) {
+						ipAddr[0] = ntohl(((struct ipv6Pkt *)
+								(macInfo->ipBuf))->destinationAddr[0]);
+						ipAddr[1] = ntohl(((struct ipv6Pkt *)
+								(macInfo->ipBuf))->destinationAddr[1]);
+						ipAddr[2] = ntohl(((struct ipv6Pkt *)
+								(macInfo->ipBuf))->destinationAddr[2]);
+						ipAddr[3] = ntohl(((struct ipv6Pkt *)
+								(macInfo->ipBuf))->destinationAddr[3]);
+
+						if (rtl_checkMCastAddrMapping(IP_VERSION6, ipAddr,
+								macFrame) == TRUE) {
+							macInfo->l3Protocol = ICMP_PROTOCOL;
+						}
+
+					} else {	/*means multicast */
+
+						ipAddr[0] = htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[0]);
+						ipAddr[1] = htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[1]);
+						ipAddr[2] = htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[2]);
+						ipAddr[3] = htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[3]);
+						if ((rtl_compareMacAddr(macFrame, rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac) == TRUE) &&
+							(rtl_compareIpv6Addr(((struct ipv6Pkt *)macInfo->ipBuf)->destinationAddr, ipAddr) == TRUE)) {
+							macInfo->l3Protocol = ICMP_PROTOCOL;
+						}
+						else /*means multicast*/
+						{
+
+								ipAddr[0]=htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[0]);
+								ipAddr[1]=htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[1]);
+								ipAddr[2]=htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[2]);
+								ipAddr[3]=htonl(rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[3]);
+								if(	(rtl_compareMacAddr(macFrame, rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac)==TRUE) &&\
+								(rtl_compareIpv6Addr(((struct ipv6Pkt *)macInfo->ipBuf)->destinationAddr, ipAddr) == TRUE))
+								{
+									macInfo->l3Protocol=ICMP_PROTOCOL;
+								}
+
+								#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+								else if(is_pppoe == 1)
+								{
+									macInfo->l3Protocol=ICMP_PROTOCOL;
+								}
+								#endif
+
+						}
+					}
+
+					/*
+					 * if(ipv6RAO!=IPV6_ROUTER_ALTER_OPTION)
+					 * {
+					 * rtl_gluePrintf("router alter option error\n");
+					 * } */
+				}
+
+				break;
+
+			case PIM_PROTOCOL:
+				nextHeader = NO_NEXT_HEADER;
+				macInfo->l3PktLen = ntohs(((struct ipv6Pkt *)(macInfo->ipBuf))->payloadLenth) -
+					(uint16)(ptr - macInfo->ipBuf - IPV6_HEADER_LENGTH);
+				macInfo->l3PktBuf = ptr;
+
+				ipAddr[0] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[0]);
+				ipAddr[1] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[1]);
+				ipAddr[2] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[2]);
+				ipAddr[3] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[3]);
+				if (IS_IPV6_PIM_ADDR(ipAddr)) {
+					macInfo->l3Protocol = PIM_PROTOCOL;
+				}
+
+				break;
+
+			case MOSPF_PROTOCOL:
+				nextHeader = NO_NEXT_HEADER;
+				macInfo->l3PktLen = ntohs(((struct ipv6Pkt *)(macInfo->ipBuf))->payloadLenth) -
+					(uint16)(ptr - macInfo->ipBuf - IPV6_HEADER_LENGTH);
+				macInfo->l3PktBuf = ptr;
+
+				ipAddr[0] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[0]);
+				ipAddr[1] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[1]);
+				ipAddr[2] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[2]);
+				ipAddr[3] = ntohl(((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[3]);
+
+				if (IS_IPV6_MOSPF_ADDR1(ipAddr)
+					|| IS_IPV6_MOSPF_ADDR2(ipAddr)) {
+					macInfo->l3Protocol = MOSPF_PROTOCOL;
+				}
+
+				break;
+
+			default:
+				goto out;
+				break;
+			}
+
+		}
+
+out:
+
+		if (verifyCheckSum == TRUE) {
+			if (macInfo->l3PktBuf == NULL) {
+				return;
+			}
+
+			/*generate pseudo header */
+			for (i = 0; i < 4; i++) {
+				pHeader.ipv6_pHdr.sourceAddr[i] = ((struct ipv6Pkt *)(macInfo->ipBuf))->sourceAddr[i];
+
+			}
+
+			if (routingHead == FALSE) {
+				for (i = 0; i < 4; i++) {
+					pHeader.ipv6_pHdr.destinationAddr[i] = ((struct ipv6Pkt *)(macInfo->ipBuf))->destinationAddr[i];
+				}
+			}
+
+			pHeader.ipv6_pHdr.nextHeader = macInfo->l3Protocol;
+			pHeader.ipv6_pHdr.upperLayerPacketLength = htonl((uint32)(macInfo->l3PktLen));
+			pHeader.ipv6_pHdr.zeroData[0] = 0;
+			pHeader.ipv6_pHdr.zeroData[1] = 0;
+			pHeader.ipv6_pHdr.zeroData[2] = 0;
+
+			/*verify checksum */
+			if (rtl_ipv6L3Checksum(macInfo->l3PktBuf,
+					macInfo->l3PktLen, &pHeader) != 0) {
+				macInfo->checksumFlag = FAILED;
+			} else {
+				macInfo->checksumFlag = SUCCESS;
+			}
+		} else {
+			macInfo->checksumFlag = SUCCESS;
+		}
+	}
+#endif
+	return;
+}
+
+static uint32 rtl_getMulticastRouterPortMask(uint32 moduleIndex,
+	uint32 ipVersion, uint32 sysTime)
+{
+	uint32 portIndex = 0;
+	uint8 portMaskn = PORT0_MASK;
+	uint32 routerPortmask = 0;
+
+	if (ipVersion == IP_VERSION4) {
+		for (portIndex = 0; portIndex < MAX_SUPPORT_PORT_NUMBER;
+			portIndex++) {
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.querier.portTimer[portIndex] > sysTime) {
+				routerPortmask = routerPortmask | portMaskn;
+			}
+
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.dvmrpRouter.portTimer[portIndex] > sysTime) {
+				routerPortmask = routerPortmask | portMaskn;
+			}
+
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.mospfRouter.portTimer[portIndex] > sysTime) {
+				routerPortmask = routerPortmask | portMaskn;
+			}
+
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.pimRouter.portTimer[portIndex] > sysTime) {
+				routerPortmask = routerPortmask | portMaskn;
+			}
+
+			portMaskn = portMaskn << 1;	/*shift to next port mask */
+
+		}
+
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		for (portIndex = 0; portIndex < MAX_SUPPORT_PORT_NUMBER;
+			portIndex++) {
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.querier.portTimer[portIndex] > sysTime) {
+
+				routerPortmask = routerPortmask | portMaskn;
+			}
+
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.mospfRouter.portTimer[portIndex] > sysTime) {
+				routerPortmask = routerPortmask | portMaskn;
+			}
+
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.pimRouter.portTimer[portIndex] > sysTime) {
+				routerPortmask = routerPortmask | portMaskn;
+			}
+
+			portMaskn = portMaskn << 1;	/*shift to next port mask */
+
+		}
+
+	}
+#endif
+
+	routerPortmask = routerPortmask | rtl_mCastModuleArray[moduleIndex].staticRouterPortMask;
+
+	return routerPortmask;
+}
+
+static uint32 rtl_processQueries(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint8 *pktBuf, uint32 pktLen)
+{
+#if 0
+	struct rtl_groupEntry *groupEntry = NULL;
+	struct rtl_clientEntry *clientEntry = NULL;
+	struct rtl_sourceEntry *sourceEntry = NULL;
+	uint32 i = 0;
+#endif
+	uint32 groupAddress[4] = { 0, 0, 0, 0 };
+	uint32 suppressFlag = 0;
+	uint32 *sourceAddr = NULL;
+	uint32 numOfSrc = 0;
+
+	/*querier timer update and election process */
+	rtl_snoopQuerier(moduleIndex, ipVersion, portNum);
+
+	if (ipVersion == IP_VERSION4) {
+		if (pktLen >= 12) {	/*means igmpv3 query */
+			groupAddress[0] = ntohl(((struct igmpv3Query *)pktBuf)->groupAddr);
+			suppressFlag = ((struct igmpv3Query *)pktBuf)->rsq & S_FLAG_MASK;
+			sourceAddr = &(((struct igmpv3Query *)pktBuf)->srcList);
+			numOfSrc = (uint32)ntohs(((struct igmpv3Query *)pktBuf)->numOfSrc);
+
+		} else {
+			groupAddress[0] = ntohl(((struct igmpv2Pkt *)pktBuf)->groupAddr);
+		}
+
+		if (groupAddress[0] == 0) {	/*means general query */
+			goto out;
+		} else {
+			//      hashIndex=rtl_igmpHashAlgorithm(ipVersion, groupAddress);
+		}
+
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		if (pktLen >= 28) {	/*means mldv2 query */
+			groupAddress[0] = ntohl(((struct mldv2Query *)pktBuf)->mCastAddr[0]);
+			groupAddress[1] = ntohl(((struct mldv2Query *)pktBuf)->mCastAddr[1]);
+			groupAddress[2] = ntohl(((struct mldv2Query *)pktBuf)->mCastAddr[2]);
+			groupAddress[3] = ntohl(((struct mldv2Query *)pktBuf)->mCastAddr[3]);
+
+			suppressFlag = ((struct mldv2Query *)pktBuf)->rsq & S_FLAG_MASK;
+			sourceAddr = &(((struct mldv2Query *)pktBuf)->srcList);
+			numOfSrc = (uint32)ntohs(((struct mldv2Query *)pktBuf)->numOfSrc);
+
+		} else {	/*means mldv1 query */
+
+			groupAddress[0] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[0]);
+			groupAddress[1] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[1]);
+			groupAddress[2] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[2]);
+			groupAddress[3] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[3]);
+
+		}
+
+		if ((groupAddress[0] == 0) &&
+			(groupAddress[1] == 0) &&
+			(groupAddress[2] == 0) &&
+			(groupAddress[3] == 0)) {	/*means general query */
+			goto out;
+		} else {
+			//hashIndex=rtl_igmpHashAlgorithm(ipVersion, groupAddress);
+		}
+	}
+#endif
+	if (suppressFlag == 0) {
+		/*ignore group specific query handling */
+#if 0
+		groupEntry = rtl_searchGroupEntry(moduleIndex, ipVersion,
+			groupAddress);
+		if ((groupEntry != NULL)) {
+
+			if (numOfSrc == 0) {	/*means group specific query */
+				clientEntry = groupEntry->clientList;
+				while (clientEntry != NULL) {
+					if (clientEntry->groupFilterTimer > (rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime)) {
+						clientEntry->groupFilterTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime;
+					}
+					clientEntry = clientEntry->next;
+				}
+
+			} else {	/*means group and source specific query */
+
+				clientEntry = groupEntry->clientList;
+				while (clientEntry != NULL) {
+					for (i = 0; i < numOfSrc; i++) {
+
+						sourceEntry = rtl_searchSourceEntry(ipVersion, sourceAddr,
+							clientEntry);
+
+						if (sourceEntry != NULL) {
+							if (sourceEntry->portTimer > (rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime))
+							{
+								sourceEntry->portTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime;
+							}
+
+						}
+
+						if (ipVersion == IP_VERSION4) {
+							sourceAddr++;
+						}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+						else {
+							sourceAddr = sourceAddr + 4;
+						}
+#endif
+					}
+
+					clientEntry = clientEntry->next;
+				}
+
+			}
+		}
+#endif
+
+	}
+
+	reportEventContext.ipVersion = ipVersion;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	reportEventContext.groupAddr[0] = groupAddress[0];
+	reportEventContext.groupAddr[1] = groupAddress[1];
+	reportEventContext.groupAddr[2] = groupAddress[2];
+	reportEventContext.groupAddr[3] = groupAddress[3];
+#else
+	reportEventContext.groupAddr[0] = groupAddress[0];
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (ipVersion == IP_VERSION6) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST6, &reportEventContext);
+	}
+#endif
+#endif
+
+out:
+	return (~(1 << portNum) & ((1 << MAX_SUPPORT_PORT_NUMBER) - 1));
+}
+
+static void rtl_snoopQuerier(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum)
+{
+
+	if (ipVersion == IP_VERSION4) {
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.querier.portTimer[portNum] = rtl_sysUpSeconds + rtl_mCastTimerParas.querierPresentInterval;	/*update timer value */
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.querier.portTimer[portNum] = rtl_sysUpSeconds + rtl_mCastTimerParas.querierPresentInterval;	/*update timer value */
+	}
+#endif
+	return;
+}
+
+int rtl_is_reserve_multicastAddr(uint32 *groupAddress, uint32 ipVersion)
+{
+	int ret = FAILED;
+
+	if (ipVersion == IP_VERSION4) {
+		/*upnp:239.255.255.250
+		 * mdns:224.0.0.251
+		 * iapp:224.0.1.178 */
+		if (((groupAddress[0] & 0xFFFFFFFF) == 0xEFFFFFFA)
+			|| ((groupAddress[0] & 0xFFFFFFFF) == 0xE00001B2)
+			|| ((groupAddress[0] & 0xFFFFFFFF) == 0xE00000FB)) {
+			ret = SUCCESS;
+		}
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else if (ipVersion == IP_VERSION6) {
+		/*ff02::1:FFxx:xxxx
+		 * MDNS:ff02::fb
+		 * UPNP: ff02::c */
+		if ((((groupAddress[0] & 0xFFFFFFFF) == 0xFF020000)
+				&& ((groupAddress[1] & 0xFFFFFFFF) == 0x0)
+				&& ((groupAddress[2] & 0xFFFFFFFF) == 0x1)
+				&& ((groupAddress[3] & 0xFF000000) == 0xFF000000))
+			|| (((groupAddress[0] & 0xFFFFFFFF) == 0xFF020000)
+				&& ((groupAddress[1] & 0xFFFFFFFF) == 0x00000000)
+				&& ((groupAddress[2] & 0xFFFFFFFF) == 0x00000000)
+				&& ((groupAddress[3] & 0xFFFFFFFF) == 0x000000FB))
+			|| (((groupAddress[0] & 0xFFFFFFFF) == 0xFF020000)
+				&& ((groupAddress[1] & 0xFFFFFFFF) == 0x00000000)
+				&& ((groupAddress[2] & 0xFFFFFFFF) == 0x00000000)
+				&& ((groupAddress[3] & 0xFFFFFFFF) == 0x0000000C))
+			) {
+			//diag_printf("reverve mulitcast:%x:%x:%x:%x\n",groupAddress[0],groupAddress[1],groupAddress[2],groupAddress[3]);
+			ret = SUCCESS;
+		}
+	}
+#endif
+	return ret;
+}
+
+/*Process Report Packet*/
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)	|| defined (M2U_DELETE_CHECK)
+static uint32 rtl_processJoin(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf)
+#else
+static uint32 rtl_processJoin(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *pktBuf)
+#endif
+{
+
+	uint32 groupAddress[4] = { 0, 0, 0, 0 };
+	struct rtl_groupEntry *groupEntry = NULL;
+	struct rtl_groupEntry *newGroupEntry = NULL;
+	struct rtl_clientEntry *clientEntry = NULL;
+	struct rtl_clientEntry *newClientEntry = NULL;
+
+	uint32 hashIndex = 0;
+	uint32 multicastRouterPortMask = rtl_getMulticastRouterPortMask(moduleIndex, ipVersion,
+		rtl_sysUpSeconds);
+	uint32 allClientPortMask = 0;
+
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	if (ipVersion == IP_VERSION4) {
+		if (pktBuf[0] == 0x12) {
+			groupAddress[0] = ntohl(((struct igmpv1Pkt *)pktBuf)->groupAddr);
+		}
+
+		if (pktBuf[0] == 0x16) {
+			groupAddress[0] = ntohl(((struct igmpv2Pkt *)pktBuf)->groupAddr);
+		}
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+
+		groupAddress[0] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[0]);
+		groupAddress[1] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[1]);
+		groupAddress[2] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[2]);
+		groupAddress[3] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[3]);
+	}
+#endif
+	if (rtl_is_reserve_multicastAddr(groupAddress, ipVersion) == SUCCESS)
+		goto out;
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, groupAddress);
+
+	groupEntry = rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+	if (groupEntry == NULL) {	/*means new group address, create new group entry */
+		newGroupEntry = rtl_allocateGroupEntry();
+
+		if (newGroupEntry == NULL) {
+			rtl_gluePrintf("run out of group entry!\n");
+			goto out;
+		}
+
+		assert(newGroupEntry->clientList == NULL);
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+		newGroupEntry->groupAddr[1] = groupAddress[1];
+		newGroupEntry->groupAddr[2] = groupAddress[2];
+		newGroupEntry->groupAddr[3] = groupAddress[3];
+#else
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+#endif
+
+		newGroupEntry->ipVersion = ipVersion;
+
+		if (ipVersion == IP_VERSION4) {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+		}
+#endif
+		groupEntry = newGroupEntry;
+
+	}
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr, clientmacAddr);
+#else
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr);
+#endif
+
+#ifdef CONFIG_RTL_8370_SUPPORT
+	// www.iana.org/assignments/multicast-addresses/multicast-addresses.xhtml
+#define RESERVED_MC_IP1		0xE00000FC	// Link-local Multicast Name Resolution [RFC4795]
+	if ((portNum == 0)) {
+		if (groupAddress[0] != RESERVED_MC_IP1) {
+			wait_mac = 1;
+			saved_groupAddress = groupAddress[0];
+			saved_clientAddr = *clientAddr;
+		}
+	}
+#endif
+
+	if (clientEntry == NULL) {
+		newClientEntry = rtl_allocateClientEntry();
+		if (newClientEntry == NULL) {
+			rtl_gluePrintf("run out of client entry!\n");
+			goto out;
+		}
+
+		assert(newClientEntry->sourceList == NULL);
+		newClientEntry->portNum = portNum;
+		newClientEntry->igmpVersion = IGMP_V2;
+
+		if (ipVersion == IP_VERSION4) {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+			newClientEntry->clientAddr[1] = clientAddr[1];
+			newClientEntry->clientAddr[2] = clientAddr[2];
+			newClientEntry->clientAddr[3] = clientAddr[3];
+
+		}
+#endif
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		newClientEntry->clientMacAddr[0] = clientmacAddr[0];
+		newClientEntry->clientMacAddr[1] = clientmacAddr[1];
+		newClientEntry->clientMacAddr[2] = clientmacAddr[2];
+		newClientEntry->clientMacAddr[3] = clientmacAddr[3];
+		newClientEntry->clientMacAddr[4] = clientmacAddr[4];
+		newClientEntry->clientMacAddr[5] = clientmacAddr[5];
+#endif
+		rtl_linkClientEntry(groupEntry, newClientEntry);
+		clientEntry = newClientEntry;
+	}
+
+	//rtl_deleteSourceList(clientEntry);
+	clientEntry->igmpVersion = IGMP_V2;
+	clientEntry->groupFilterTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.groupMemberAgingTime;
+
+	SMP_LOCK_IGMP(flags);
+	rtl_deleteSourceList(clientEntry);
+	SMP_UNLOCK_IGMP(flags);
+
+	allClientPortMask = rtl_getAllClientPortMask(groupEntry);
+#ifdef CONFIG_RTK_MESH
+	if (mesh_port_no != 0xFFFFFFFF)
+		allClientPortMask &= (~(1 << mesh_port_no));	/*always forward to wlan-msh */
+#endif
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if ((groupEntry != NULL)
+		&& (groupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		goto out;
+	}
+#endif
+
+	reportEventContext.ipVersion = ipVersion;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	reportEventContext.groupAddr[0] = groupAddress[0];
+	reportEventContext.groupAddr[1] = groupAddress[1];
+	reportEventContext.groupAddr[2] = groupAddress[2];
+	reportEventContext.groupAddr[3] = groupAddress[3];
+#else
+	reportEventContext.groupAddr[0] = groupAddress[0];
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (ipVersion == IP_VERSION6) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST6, &reportEventContext);
+	}
+#endif
+#endif
+
+out:
+
+	return (((~allClientPortMask) | multicastRouterPortMask) & (~(1 << portNum)) & ((1 << MAX_SUPPORT_PORT_NUMBER) -
+			1));
+	//return (multicastRouterPortMask&(~(1<<portNum))&((1<<MAX_SUPPORT_PORT_NUMBER)-1));
+}
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+static uint32 rtl_processLeave(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf)
+#else
+static uint32 rtl_processLeave(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *pktBuf)
+#endif
+{
+	uint32 groupAddress[4] = { 0, 0, 0, 0 };
+	struct rtl_groupEntry *groupEntry = NULL;
+	struct rtl_clientEntry *clientEntry = NULL;
+	struct rtl_sourceEntry *sourceEntry = NULL;
+	struct rtl_sourceEntry *nextSourceEntry = NULL;
+
+	uint32 hashIndex = 0;
+	uint32 ClientNum = 0;
+
+//      uint32 multicastRouterPortMask=rtl_getMulticastRouterPortMask(moduleIndex, ipVersion, rtl_sysUpSeconds);
+
+	if (ipVersion == IP_VERSION4) {
+		groupAddress[0] = ntohl(((struct igmpv2Pkt *)pktBuf)->groupAddr);
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		groupAddress[0] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[0]);
+		groupAddress[1] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[1]);
+		groupAddress[2] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[2]);
+		groupAddress[3] = ntohl(((struct mldv1Pkt *)pktBuf)->mCastAddr[3]);
+	}
+#endif
+	if (rtl_is_reserve_multicastAddr(groupAddress, ipVersion) == SUCCESS)
+		goto out;
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, groupAddress);
+
+	groupEntry = rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+
+	if (groupEntry != NULL) {
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+		clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+			clientAddr, clientmacAddr);
+#else
+		clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+			clientAddr);
+#endif
+		if (clientEntry != NULL) {
+
+			if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE) {
+				rtl_deleteClientEntry(groupEntry, clientEntry);
+			} else {
+				while (sourceEntry != NULL) {
+					nextSourceEntry = sourceEntry->next;
+					if (sourceEntry->portTimer > rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime) {
+						sourceEntry->portTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime;
+					}
+					sourceEntry = nextSourceEntry;
+				}
+
+				if (clientEntry->groupFilterTimer > rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime) {
+					clientEntry->groupFilterTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime;
+				}
+
+			}
+
+		}
+
+	}
+
+	ClientNum = rtl_getClientNum(moduleIndex, ipVersion, groupEntry,
+		clientEntry);
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if ((groupEntry != NULL)
+		&& (groupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		goto out;
+	}
+#endif
+
+	reportEventContext.ipVersion = ipVersion;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	reportEventContext.groupAddr[0] = groupAddress[0];
+	reportEventContext.groupAddr[1] = groupAddress[1];
+	reportEventContext.groupAddr[2] = groupAddress[2];
+	reportEventContext.groupAddr[3] = groupAddress[3];
+#else
+	reportEventContext.groupAddr[0] = groupAddress[0];
+#endif
+
+	if ((groupEntry != NULL) && (groupEntry->clientList == NULL)) {
+		if (ipVersion == IP_VERSION4)
+			rtl_deleteGroupEntry(groupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else if (ipVersion == IP_VERSION6)
+			rtl_deleteGroupEntry(groupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+#endif
+	}
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		/*we only support ipv4 hardware multicast */
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE) {
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST,
+				&reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+			rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST,
+				&reportEventContext);
+#endif
+		}
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (ipVersion == IP_VERSION6) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE) {
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST6,
+				&reportEventContext);
+		}
+
+	}
+#endif
+#endif
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+out:
+#endif
+#if 0
+	/*no client exist, send leave */
+	if (ClientNum == 0) {
+		//printk("no client exist.\n");
+		return ((~(1 << portNum)) & ((1 << MAX_SUPPORT_PORT_NUMBER) - 1));
+	} else {
+		//printk("exist clinetNum :%d\n",ClientNum);
+		return 0;
+	}
+	//return (multicastRouterPortMask&(~(1<<portNum))&((1<<MAX_SUPPORT_PORT_NUMBER)-1));
+#endif
+	return ((~(1 << portNum)) & ((1 << MAX_SUPPORT_PORT_NUMBER) - 1));
+}
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)	|| defined (M2U_DELETE_CHECK)
+static int32 rtl_processIsInclude(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf)
+#else
+static int32 rtl_processIsInclude(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *pktBuf)
+#endif
+{
+
+	uint32 j = 0;
+	uint32 groupAddress[4] = { 0, 0, 0, 0 };
+	uint32 srcAddress[4] = { 0, 0, 0, 0 };
+	struct rtl_groupEntry *groupEntry = NULL;
+	struct rtl_groupEntry *newGroupEntry = NULL;
+	struct rtl_clientEntry *clientEntry = NULL;
+	struct rtl_clientEntry *newClientEntry = NULL;
+	struct rtl_sourceEntry *sourceEntry = NULL;
+	struct rtl_sourceEntry *newSourceEntry = NULL;
+	struct rtl_sourceEntry *nextSourceEntry = NULL;
+
+	uint32 hashIndex = 0;
+
+	uint16 numOfSrc = 0;
+	uint32 *sourceAddr = NULL;
+	uint32 *sourceAddrHead = NULL;
+
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	if (ipVersion == IP_VERSION4) {
+		groupAddress[0] = ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc = ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceAddrHead = &(((struct groupRecord *)pktBuf)->srcList);
+
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		groupAddress[0] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc = ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceAddrHead = &(((struct mCastAddrRecord *)pktBuf)->srcList);
+	}
+#endif
+	if (rtl_is_reserve_multicastAddr(groupAddress, ipVersion) == SUCCESS)
+		return FAILED;
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, groupAddress);
+
+	groupEntry = rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+
+	if (groupEntry == NULL) {	/*means new group address, create new group entry */
+		newGroupEntry = rtl_allocateGroupEntry();
+		if (newGroupEntry == NULL) {
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+
+		assert(newGroupEntry->clientList == NULL);
+		/*set new multicast entry */
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+		newGroupEntry->groupAddr[1] = groupAddress[1];
+		newGroupEntry->groupAddr[2] = groupAddress[2];
+		newGroupEntry->groupAddr[3] = groupAddress[3];
+#else
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+#endif
+
+		newGroupEntry->ipVersion = ipVersion;
+
+		if (ipVersion == IP_VERSION4) {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+		}
+#endif
+		groupEntry = newGroupEntry;
+	}
+
+	/*from here groupEntry is the same as newGroupEntry */
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr, clientmacAddr);
+#else
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr);
+#endif
+	if (clientEntry == NULL) {
+		newClientEntry = rtl_allocateClientEntry();
+		if (newClientEntry == NULL) {
+			rtl_gluePrintf("run out of client entry!\n");
+			return FAILED;
+		}
+
+		assert(newClientEntry->sourceList == NULL);
+		newClientEntry->sourceList = NULL;
+		newClientEntry->igmpVersion = IGMP_V3;
+		newClientEntry->portNum = portNum;
+
+		if (ipVersion == IP_VERSION4) {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+			newClientEntry->clientAddr[1] = clientAddr[1];
+			newClientEntry->clientAddr[2] = clientAddr[2];
+			newClientEntry->clientAddr[3] = clientAddr[3];
+
+		}
+#endif
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		newClientEntry->clientMacAddr[0] = clientmacAddr[0];
+		newClientEntry->clientMacAddr[1] = clientmacAddr[1];
+		newClientEntry->clientMacAddr[2] = clientmacAddr[2];
+		newClientEntry->clientMacAddr[3] = clientmacAddr[3];
+		newClientEntry->clientMacAddr[4] = clientmacAddr[4];
+		newClientEntry->clientMacAddr[5] = clientmacAddr[5];
+#endif
+		rtl_linkClientEntry(groupEntry, newClientEntry);
+		clientEntry = newClientEntry;
+	}
+
+	/*from here client entry is the same as the newClientEntry */
+	//rtl_deleteSourceList(clientEntry);
+	clientEntry->igmpVersion = IGMP_V3;
+	clientEntry->groupFilterTimer = rtl_sysUpSeconds;	//include mode
+	//assert(clientEntry->sourceList==NULL);
+
+	SMP_LOCK_IGMP(flags);
+	/*here to handle the source list */
+	/*add src in igmp/mld to sourcelist */
+
+	sourceAddr = sourceAddrHead;
+	for (j = 0; j < numOfSrc; j++) {
+		if (ipVersion == IP_VERSION4) {
+			srcAddress[0] = ntohl(sourceAddr[0]);
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else if (ipVersion == IP_VERSION6) {
+			srcAddress[0] = ntohl(sourceAddr[0]);
+			srcAddress[1] = ntohl(sourceAddr[1]);
+			srcAddress[2] = ntohl(sourceAddr[2]);
+			srcAddress[3] = ntohl(sourceAddr[3]);
+		}
+#endif
+
+		sourceEntry = rtl_searchSourceEntry(ipVersion, srcAddress,
+			clientEntry);
+		if (sourceEntry == NULL) {
+			newSourceEntry = rtl_allocateSourceEntry();
+			if (newSourceEntry == NULL) {
+				rtl_gluePrintf("run out of source entry!\n");
+				SMP_UNLOCK_IGMP(flags);
+				return FAILED;
+			}
+
+			if (ipVersion == IP_VERSION4) {
+				newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+				//sourceAddr++;
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else {
+				newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+				newSourceEntry->sourceAddr[1] = ntohl(sourceAddr[1]);
+				newSourceEntry->sourceAddr[2] = ntohl(sourceAddr[2]);
+				newSourceEntry->sourceAddr[3] = ntohl(sourceAddr[3]);
+				//sourceAddr=sourceAddr+4;
+			}
+#endif
+			newSourceEntry->portTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.groupMemberAgingTime;
+			rtl_linkSourceEntry(clientEntry, newSourceEntry);
+
+		} else {
+
+			/*just update source timer */
+			sourceEntry->portTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.groupMemberAgingTime;
+		}
+
+		if (ipVersion == IP_VERSION4) {
+			sourceAddr++;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			sourceAddr = sourceAddr + 4;
+		}
+#endif
+	}
+
+	/*handle source not in igmp/mld */
+	sourceEntry = clientEntry->sourceList;
+	while (sourceEntry != NULL) {
+		sourceAddr = sourceAddrHead;
+		nextSourceEntry = sourceEntry->next;
+		for (j = 0; j < numOfSrc; j++) {
+			if (ipVersion == IP_VERSION4) {
+				if (ntohl(sourceAddr[0]) == sourceEntry->sourceAddr[0])
+					break;
+				sourceAddr++;
+			} else {
+				if (	(ntohl(sourceAddr[0]) == sourceEntry->sourceAddr[0]) &&
+					(ntohl(sourceAddr[1]) == sourceEntry->sourceAddr[1]) &&
+					(ntohl(sourceAddr[2]) == sourceEntry->sourceAddr[2]) &&
+					(ntohl(sourceAddr[3]) == sourceEntry->sourceAddr[3]))
+					break;
+				sourceAddr += 4;
+			}
+
+		}
+		if (j == numOfSrc) {
+			/*change portTimer of src not in igmp/mld to lastMemberAging Time */
+			if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE)
+				rtl_deleteSourceEntry(clientEntry, sourceEntry);
+			else
+				sourceEntry->portTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime;
+
+		}
+		sourceEntry = nextSourceEntry;
+	}
+	SMP_UNLOCK_IGMP(flags);
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if ((groupEntry != NULL)
+		&& (groupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		return SUCCESS;
+	}
+#endif
+
+	reportEventContext.ipVersion = ipVersion;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	reportEventContext.groupAddr[0] = groupAddress[0];
+	reportEventContext.groupAddr[1] = groupAddress[1];
+	reportEventContext.groupAddr[2] = groupAddress[2];
+	reportEventContext.groupAddr[3] = groupAddress[3];
+#else
+	reportEventContext.groupAddr[0] = groupAddress[0];
+#endif
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		/*we only support ipv4 hardware multicast */
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (ipVersion == IP_VERSION6) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST6, &reportEventContext);
+	}
+#endif
+#endif
+
+	return SUCCESS;
+}
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+static int32 rtl_processIsExclude(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf)
+#else
+static int32 rtl_processIsExclude(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *pktBuf)
+#endif
+{
+	uint32 j = 0;
+	uint32 groupAddress[4] = { 0, 0, 0, 0 };
+	struct rtl_groupEntry *groupEntry = NULL;
+	struct rtl_groupEntry *newGroupEntry = NULL;
+	struct rtl_clientEntry *clientEntry = NULL;
+	struct rtl_clientEntry *newClientEntry = NULL;
+	struct rtl_sourceEntry *newSourceEntry = NULL;
+
+	uint32 hashIndex = 0;
+	uint16 numOfSrc = 0;
+	uint32 *sourceArray = NULL;
+	uint32 *sourceAddr = NULL;
+
+#if defined (CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	if (ipVersion == IP_VERSION4) {
+		groupAddress[0] = ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc = ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceArray = &(((struct groupRecord *)pktBuf)->srcList);
+		sourceAddr = &(((struct groupRecord *)pktBuf)->srcList);
+
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+
+		groupAddress[0] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc = ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceArray = &(((struct mCastAddrRecord *)pktBuf)->srcList);
+		sourceAddr = &(((struct mCastAddrRecord *)pktBuf)->srcList);
+	}
+#endif
+	if (rtl_is_reserve_multicastAddr(groupAddress, ipVersion) == SUCCESS)
+		return FAILED;
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, groupAddress);
+
+	groupEntry = rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+
+	if (groupEntry == NULL) {	/*means new group address, create new group entry */
+		newGroupEntry = rtl_allocateGroupEntry();
+		if (newGroupEntry == NULL) {
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+
+		assert(newGroupEntry->clientList == NULL);
+		/*set new multicast entry */
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+		newGroupEntry->groupAddr[1] = groupAddress[1];
+		newGroupEntry->groupAddr[2] = groupAddress[2];
+		newGroupEntry->groupAddr[3] = groupAddress[3];
+#else
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+#endif
+
+		newGroupEntry->ipVersion = ipVersion;
+
+		if (ipVersion == IP_VERSION4) {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+		}
+#endif
+		groupEntry = newGroupEntry;
+	}
+
+	/*from here groupEntry is the same as  newGroupEntry */
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr, clientmacAddr);
+#else
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr);
+#endif
+	if (clientEntry == NULL) {
+		newClientEntry = rtl_allocateClientEntry();
+		if (newClientEntry == NULL) {
+			rtl_gluePrintf("run out of client entry!\n");
+			return FAILED;
+		}
+
+		assert(newClientEntry->sourceList == NULL);
+
+		newClientEntry->sourceList = NULL;
+		newClientEntry->igmpVersion = IGMP_V3;
+		newClientEntry->portNum = portNum;
+
+		if (ipVersion == IP_VERSION4) {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+			newClientEntry->clientAddr[1] = clientAddr[1];
+			newClientEntry->clientAddr[2] = clientAddr[2];
+			newClientEntry->clientAddr[3] = clientAddr[3];
+
+		}
+#endif
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		newClientEntry->clientMacAddr[0] = clientmacAddr[0];
+		newClientEntry->clientMacAddr[1] = clientmacAddr[1];
+		newClientEntry->clientMacAddr[2] = clientmacAddr[2];
+		newClientEntry->clientMacAddr[3] = clientmacAddr[3];
+		newClientEntry->clientMacAddr[4] = clientmacAddr[4];
+		newClientEntry->clientMacAddr[5] = clientmacAddr[5];
+#endif
+
+		rtl_linkClientEntry(groupEntry, newClientEntry);
+		clientEntry = newClientEntry;
+
+	}
+
+	/*from here clientEntry  is the same as newClientEntry */
+
+	/*set exclude mode first */
+	//rtl_deleteSourceList( clientEntry);
+	clientEntry->igmpVersion = IGMP_V3;
+	clientEntry->groupFilterTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.groupMemberAgingTime;
+	//assert(clientEntry->sourceList==NULL);
+
+	/*flush the old source list */
+	SMP_LOCK_IGMP(flags);
+	rtl_deleteSourceList(clientEntry);
+
+	/*link the new source list */
+	for (j = 0; j < numOfSrc; j++) {
+		newSourceEntry = rtl_allocateSourceEntry();
+		if (newSourceEntry == NULL) {
+			rtl_gluePrintf("run out of source entry!\n");
+			SMP_UNLOCK_IGMP(flags);
+			return FAILED;
+		}
+
+		if (ipVersion == IP_VERSION4) {
+			newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+
+			sourceAddr++;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+			newSourceEntry->sourceAddr[1] = ntohl(sourceAddr[1]);
+			newSourceEntry->sourceAddr[2] = ntohl(sourceAddr[2]);
+			newSourceEntry->sourceAddr[3] = ntohl(sourceAddr[3]);
+
+			sourceAddr = sourceAddr + 4;
+		}
+#endif
+		/*time out the sources included in the MODE_IS_EXCLUDE report */
+		newSourceEntry->portTimer = rtl_sysUpSeconds;
+		rtl_linkSourceEntry(clientEntry, newSourceEntry);
+
+	}
+	SMP_UNLOCK_IGMP(flags);
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if ((groupEntry != NULL)
+		&& (groupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		return SUCCESS;
+	}
+#endif
+
+	reportEventContext.ipVersion = ipVersion;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	reportEventContext.groupAddr[0] = groupAddress[0];
+	reportEventContext.groupAddr[1] = groupAddress[1];
+	reportEventContext.groupAddr[2] = groupAddress[2];
+	reportEventContext.groupAddr[3] = groupAddress[3];
+#else
+	reportEventContext.groupAddr[0] = groupAddress[0];
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		/*we only support ipv4 hardware multicast */
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (ipVersion == IP_VERSION6) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST6, &reportEventContext);
+
+	}
+#endif
+#endif
+
+	return SUCCESS;
+
+}
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+static int32 rtl_processToInclude(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf)
+#else
+static int32 rtl_processToInclude(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *pktBuf)
+#endif
+{
+	uint32 j = 0;
+	uint32 groupAddress[4] = { 0, 0, 0, 0 };
+	struct rtl_groupEntry *groupEntry = NULL;
+	struct rtl_groupEntry *newGroupEntry = NULL;
+	struct rtl_clientEntry *clientEntry = NULL;
+	struct rtl_clientEntry *newClientEntry = NULL;
+	struct rtl_sourceEntry *sourceEntry = NULL;
+	struct rtl_sourceEntry *nextSourceEntry = NULL;
+	struct rtl_sourceEntry *newSourceEntry = NULL;
+
+	uint32 hashIndex = 0;
+	uint16 numOfSrc = 0;
+	uint32 *sourceAddr = NULL;
+	uint32 *sourceAddrHead = NULL;
+	uint32 ClientNum = 0;
+
+	uint32 sourceAddr_host[4] = { 0, 0, 0, 0 };
+#if defined (CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	if (ipVersion == IP_VERSION4) {
+		groupAddress[0] = ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc = ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceAddrHead = &(((struct groupRecord *)pktBuf)->srcList);
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+
+		groupAddress[0] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc = ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceAddrHead = &(((struct mCastAddrRecord *)pktBuf)->srcList);
+
+	}
+#endif
+	if (rtl_is_reserve_multicastAddr(groupAddress, ipVersion) == SUCCESS)
+		goto OUT;
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, groupAddress);
+
+	groupEntry = rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+
+	if (groupEntry == NULL) {	/*means new group address, create new group entry */
+		newGroupEntry = rtl_allocateGroupEntry();
+		if (newGroupEntry == NULL) {
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+		newGroupEntry->groupAddr[1] = groupAddress[1];
+		newGroupEntry->groupAddr[2] = groupAddress[2];
+		newGroupEntry->groupAddr[3] = groupAddress[3];
+#else
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+#endif
+
+		newGroupEntry->ipVersion = ipVersion;
+
+		if (ipVersion == IP_VERSION4) {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+		}
+#endif
+		groupEntry = newGroupEntry;
+	}
+
+	/*from here groupEntry is the same as newGroupEntry */
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr, clientmacAddr);
+#else
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr);
+#endif
+	if (clientEntry == NULL) {
+
+		newClientEntry = rtl_allocateClientEntry();
+		if (newClientEntry == NULL) {
+			rtl_gluePrintf("run out of client entry!\n");
+			return FAILED;
+		}
+
+		assert(newClientEntry->sourceList == NULL);
+		newClientEntry->sourceList = NULL;
+		newClientEntry->igmpVersion = IGMP_V3;
+		newClientEntry->portNum = portNum;
+
+		if (ipVersion == IP_VERSION4) {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+			newClientEntry->clientAddr[1] = clientAddr[1];
+			newClientEntry->clientAddr[2] = clientAddr[2];
+			newClientEntry->clientAddr[3] = clientAddr[3];
+
+		}
+#endif
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		newClientEntry->clientMacAddr[0] = clientmacAddr[0];
+		newClientEntry->clientMacAddr[1] = clientmacAddr[1];
+		newClientEntry->clientMacAddr[2] = clientmacAddr[2];
+		newClientEntry->clientMacAddr[3] = clientmacAddr[3];
+		newClientEntry->clientMacAddr[4] = clientmacAddr[4];
+		newClientEntry->clientMacAddr[5] = clientmacAddr[5];
+#endif
+		rtl_linkClientEntry(groupEntry, newClientEntry);
+		clientEntry = newClientEntry;
+	}
+
+	/*here to handle the source list */
+
+	clientEntry->igmpVersion = IGMP_V3;
+
+	if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE) {
+		clientEntry->groupFilterTimer = rtl_sysUpSeconds;
+#if 0
+		rtl_deleteSourceList(clientEntry);
+		/*link the new source list */
+		for (j = 0; j < numOfSrc; j++) {
+
+			newSourceEntry = rtl_allocateSourceEntry();
+			if (newSourceEntry == NULL) {
+				rtl_gluePrintf("run out of source entry!\n");
+				return FAILED;
+			}
+
+			if (ipVersion == IP_VERSION4) {
+				newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+				sourceAddr++;
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else {
+				newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+				newSourceEntry->sourceAddr[1] = ntohl(sourceAddr[1]);
+				newSourceEntry->sourceAddr[2] = ntohl(sourceAddr[2]);
+				newSourceEntry->sourceAddr[3] = ntohl(sourceAddr[3]);
+
+				sourceAddr = sourceAddr + 4;
+			}
+#endif
+			newSourceEntry->portTimer = rtl_sysUpSeconds +
+				rtl_mCastTimerParas.groupMemberAgingTime;
+			rtl_linkSourceEntry(clientEntry, newSourceEntry);
+		}
+#else
+		/*add/modify source address in igmp/mld to source list */
+		SMP_LOCK_IGMP(flags);
+		sourceAddr = sourceAddrHead;
+		for (j = 0; j < numOfSrc; j++) {
+			if (ipVersion == IP_VERSION4) {
+				sourceAddr_host[0] = ntohl(sourceAddr[0]);
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else if (ipVersion == IP_VERSION6) {
+				sourceAddr_host[0] = ntohl(sourceAddr[0]);
+				sourceAddr_host[1] = ntohl(sourceAddr[1]);
+				sourceAddr_host[2] = ntohl(sourceAddr[2]);
+				sourceAddr_host[3] = ntohl(sourceAddr[3]);
+			}
+#endif
+			sourceEntry = rtl_searchSourceEntry(ipVersion,
+				sourceAddr_host, clientEntry);
+			if (sourceEntry != NULL) {
+				sourceEntry->portTimer = rtl_sysUpSeconds +
+					rtl_mCastTimerParas.groupMemberAgingTime;
+			} else {
+				newSourceEntry = rtl_allocateSourceEntry();
+				if (newSourceEntry == NULL) {
+					rtl_gluePrintf("run out of source entry!\n");
+					SMP_UNLOCK_IGMP(flags);
+					return FAILED;
+				}
+
+				if (ipVersion == IP_VERSION4) {
+					newSourceEntry->sourceAddr[0] = sourceAddr_host[0];
+
+				}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+				else {
+					newSourceEntry->sourceAddr[0] = sourceAddr_host[0];
+					newSourceEntry->sourceAddr[1] = sourceAddr_host[1];
+					newSourceEntry->sourceAddr[2] = sourceAddr_host[2];
+					newSourceEntry->sourceAddr[3] = sourceAddr_host[3];
+				}
+#endif
+				newSourceEntry->portTimer = rtl_sysUpSeconds +
+					rtl_mCastTimerParas.groupMemberAgingTime;
+				rtl_linkSourceEntry(clientEntry,
+					newSourceEntry);
+			}
+
+			if (ipVersion == IP_VERSION4) {
+
+				sourceAddr++;
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else {
+				sourceAddr = sourceAddr + 4;
+			}
+#endif
+		}
+		//delete source not in igmp/mld but in old source list
+		sourceEntry = clientEntry->sourceList;
+		while (sourceEntry != NULL) {
+			nextSourceEntry = sourceEntry->next;
+			sourceAddr = sourceAddrHead;
+			for (j = 0; j < numOfSrc; j++) {
+				if (ipVersion == IP_VERSION4) {
+					if (ntohl(sourceAddr[0]) == sourceEntry->sourceAddr[0])
+						break;
+					sourceAddr++;
+				} else {
+					if ((ntohl(sourceAddr[0]) == sourceEntry->sourceAddr[0])
+						&& (ntohl(sourceAddr[1]) == sourceEntry->sourceAddr[1])
+						&& (ntohl(sourceAddr[2]) == sourceEntry->sourceAddr[2])
+						&& (ntohl(sourceAddr[3]) == sourceEntry->sourceAddr[3]))
+						break;
+					sourceAddr += 4;
+				}
+
+			}
+			if (j == numOfSrc)	//not found
+				rtl_deleteSourceEntry(clientEntry, sourceEntry);
+
+			sourceEntry = nextSourceEntry;
+		}
+		SMP_UNLOCK_IGMP(flags);
+
+#endif
+
+	} else {
+		//add new source list first, then modify old source list time out
+#if 0
+		while (sourceEntry != NULL) {
+			nextSourceEntry = sourceEntry->next;
+			if (sourceEntry->portTimer >
+				rtl_sysUpSeconds +
+				rtl_mCastTimerParas.lastMemberAgingTime) {
+				sourceEntry->portTimer = rtl_sysUpSeconds +
+					rtl_mCastTimerParas.lastMemberAgingTime;
+			}
+			sourceEntry = nextSourceEntry;
+		}
+#endif
+
+		/*add  new source list */
+		sourceAddr = sourceAddrHead;
+		for (j = 0; j < numOfSrc; j++) {
+			if (ipVersion == IP_VERSION4) {
+				sourceAddr_host[0] = ntohl(sourceAddr[0]);
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else if (ipVersion == IP_VERSION6) {
+				sourceAddr_host[0] = ntohl(sourceAddr[0]);
+				sourceAddr_host[1] = ntohl(sourceAddr[1]);
+				sourceAddr_host[2] = ntohl(sourceAddr[2]);
+				sourceAddr_host[3] = ntohl(sourceAddr[3]);
+			}
+#endif
+			sourceEntry = rtl_searchSourceEntry(ipVersion,
+				sourceAddr_host, clientEntry);
+			if (sourceEntry != NULL) {
+				sourceEntry->portTimer = rtl_sysUpSeconds +
+					rtl_mCastTimerParas.groupMemberAgingTime;
+			} else {
+				newSourceEntry = rtl_allocateSourceEntry();
+				if (newSourceEntry == NULL) {
+					rtl_gluePrintf("run out of source entry!\n");
+					return FAILED;
+				}
+
+				if (ipVersion == IP_VERSION4) {
+					newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+
+				}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+				else {
+					newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+					newSourceEntry->sourceAddr[1] = ntohl(sourceAddr[1]);
+					newSourceEntry->sourceAddr[2] = ntohl(sourceAddr[2]);
+					newSourceEntry->sourceAddr[3] = ntohl(sourceAddr[3]);
+				}
+#endif
+				newSourceEntry->portTimer = rtl_sysUpSeconds +
+					rtl_mCastTimerParas.groupMemberAgingTime;
+				rtl_linkSourceEntry(clientEntry,
+					newSourceEntry);
+			}
+
+			if (ipVersion == IP_VERSION4) {
+
+				sourceAddr++;
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else {
+
+				sourceAddr = sourceAddr + 4;
+			}
+#endif
+		}
+
+		//modify old sourcelist time out
+		sourceEntry = clientEntry->sourceList;
+		while (sourceEntry != NULL) {
+			nextSourceEntry = sourceEntry->next;
+			sourceAddr = sourceAddrHead;
+			for (j = 0; j < numOfSrc; j++) {
+				if (ipVersion == IP_VERSION4) {
+					if (ntohl(sourceAddr[0]) == sourceEntry->sourceAddr[0])
+						break;
+					sourceAddr++;
+				} else {
+					if ((ntohl(sourceAddr[0]) == sourceEntry->sourceAddr[0])
+						&& (ntohl(sourceAddr[1]) == sourceEntry->sourceAddr[1])
+						&& (ntohl(sourceAddr[2]) == sourceEntry->sourceAddr[2])
+						&& (ntohl(sourceAddr[3]) == sourceEntry->sourceAddr[3]))
+						break;
+					sourceAddr += 4;
+				}
+
+			}
+			if (j == numOfSrc)	//not found
+				sourceEntry->portTimer = rtl_sysUpSeconds +
+					rtl_mCastTimerParas.lastMemberAgingTime;
+
+			sourceEntry = nextSourceEntry;
+		}
+		if (clientEntry->groupFilterTimer >
+			rtl_sysUpSeconds +
+			rtl_mCastTimerParas.lastMemberAgingTime) {
+			clientEntry->groupFilterTimer = rtl_sysUpSeconds +
+				rtl_mCastTimerParas.lastMemberAgingTime;
+		}
+
+	}
+	//to_in(empty) == leave
+	if (numOfSrc == 0)
+		ClientNum = rtl_getClientNum(moduleIndex, ipVersion, groupEntry,
+			clientEntry);
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if ((groupEntry != NULL)
+		&& (groupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		return SUCCESS;
+	}
+#endif
+
+	reportEventContext.ipVersion = ipVersion;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	reportEventContext.groupAddr[0] = groupAddress[0];
+	reportEventContext.groupAddr[1] = groupAddress[1];
+	reportEventContext.groupAddr[2] = groupAddress[2];
+	reportEventContext.groupAddr[3] = groupAddress[3];
+#else
+	reportEventContext.groupAddr[0] = groupAddress[0];
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		/*we only support ipv4 hardware multicast */
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE) {
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST,
+				&reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+			rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST,
+				&reportEventContext);
+#endif
+		}
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (ipVersion == IP_VERSION6) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE) {
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST6,
+				&reportEventContext);
+		}
+
+	}
+#endif
+#endif
+
+OUT:
+	/*no client exist, send leave */
+#if 0
+	if (ClientNum == 0) {
+		//printk("no client exist.\n");
+		return ((~(1 << portNum)) & ((1 << MAX_SUPPORT_PORT_NUMBER) -
+				1));
+	} else {
+		//printk("exist clinetNum :%d\n",ClientNum);
+		return 0;
+	}
+	//return SUCCESS;
+#endif
+	return ((~(1 << portNum)) & ((1 << MAX_SUPPORT_PORT_NUMBER) - 1));
+
+}
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+static int32 rtl_processToExclude(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf)
+#else
+static int32 rtl_processToExclude(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *pktBuf)
+#endif
+{
+	uint32 j = 0;
+	uint32 groupAddress[4] = { 0, 0, 0, 0 };
+	struct rtl_groupEntry *groupEntry = NULL;
+	struct rtl_groupEntry *newGroupEntry = NULL;
+	struct rtl_clientEntry *clientEntry = NULL;
+	struct rtl_clientEntry *newClientEntry = NULL;
+	struct rtl_sourceEntry *newSourceEntry = NULL;
+
+	uint32 hashIndex = 0;
+	uint16 numOfSrc = 0;
+	uint32 *sourceArray = NULL;
+	uint32 *sourceAddr = NULL;
+
+#if defined (CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	if (ipVersion == IP_VERSION4) {
+		groupAddress[0] = ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc = ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceArray = &(((struct groupRecord *)pktBuf)->srcList);
+		sourceAddr = &(((struct groupRecord *)pktBuf)->srcList);
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+
+		groupAddress[0] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc = ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceArray = &(((struct mCastAddrRecord *)pktBuf)->srcList);
+		sourceAddr = &(((struct mCastAddrRecord *)pktBuf)->srcList);
+	}
+#endif
+	if (rtl_is_reserve_multicastAddr(groupAddress, ipVersion) == SUCCESS)
+		return FAILED;
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, groupAddress);
+
+	groupEntry = rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+
+	if (groupEntry == NULL) {	/*means new group address, create new group entry */
+		newGroupEntry = rtl_allocateGroupEntry();
+		if (newGroupEntry == NULL) {
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+		newGroupEntry->groupAddr[1] = groupAddress[1];
+		newGroupEntry->groupAddr[2] = groupAddress[2];
+		newGroupEntry->groupAddr[3] = groupAddress[3];
+#else
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+#endif
+
+		newGroupEntry->ipVersion = ipVersion;
+		assert(newGroupEntry->clientList == NULL);
+
+		if (ipVersion == IP_VERSION4) {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+		}
+#endif
+		groupEntry = newGroupEntry;
+	}
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr, clientmacAddr);
+#else
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr);
+#endif
+
+	if (clientEntry == NULL) {
+		newClientEntry = rtl_allocateClientEntry();
+		if (newClientEntry == NULL) {
+			rtl_gluePrintf("run out of client entry!\n");
+			return FAILED;
+		}
+
+		assert(newClientEntry->sourceList == NULL);
+		newClientEntry->sourceList = NULL;
+		newClientEntry->igmpVersion = IGMP_V3;
+		newClientEntry->portNum = portNum;
+
+		if (ipVersion == IP_VERSION4) {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+			newClientEntry->clientAddr[1] = clientAddr[1];
+			newClientEntry->clientAddr[2] = clientAddr[2];
+			newClientEntry->clientAddr[3] = clientAddr[3];
+
+		}
+#endif
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		newClientEntry->clientMacAddr[0] = clientmacAddr[0];
+		newClientEntry->clientMacAddr[1] = clientmacAddr[1];
+		newClientEntry->clientMacAddr[2] = clientmacAddr[2];
+		newClientEntry->clientMacAddr[3] = clientmacAddr[3];
+		newClientEntry->clientMacAddr[4] = clientmacAddr[4];
+		newClientEntry->clientMacAddr[5] = clientmacAddr[5];
+#endif
+		rtl_linkClientEntry(groupEntry, newClientEntry);
+		clientEntry = newClientEntry;
+	}
+
+	/*flush the old source list */
+	//rtl_deleteSourceList( clientEntry);
+	clientEntry->igmpVersion = IGMP_V3;
+	clientEntry->groupFilterTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.groupMemberAgingTime;
+
+	SMP_LOCK_IGMP(flags);
+
+	rtl_deleteSourceList(clientEntry);
+
+	/*link the new source list */
+	for (j = 0; j < numOfSrc; j++) {
+		newSourceEntry = rtl_allocateSourceEntry();
+		if (newSourceEntry == NULL) {
+			rtl_gluePrintf("run out of source entry!\n");
+			SMP_UNLOCK_IGMP(flags);
+			return FAILED;
+		}
+
+		if (ipVersion == IP_VERSION4) {
+			newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+
+			sourceAddr++;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+			newSourceEntry->sourceAddr[1] = ntohl(sourceAddr[1]);
+			newSourceEntry->sourceAddr[2] = ntohl(sourceAddr[2]);
+			newSourceEntry->sourceAddr[3] = ntohl(sourceAddr[3]);
+			sourceAddr = sourceAddr + 4;
+		}
+#endif
+		/*time out the sources included in the MODE_IS_EXCLUDE report */
+		newSourceEntry->portTimer = rtl_sysUpSeconds;
+		rtl_linkSourceEntry(clientEntry, newSourceEntry);
+
+	}
+
+	SMP_UNLOCK_IGMP(flags);
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if ((groupEntry != NULL)
+		&& (groupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		return SUCCESS;
+	}
+#endif
+
+	reportEventContext.ipVersion = ipVersion;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	reportEventContext.groupAddr[0] = groupAddress[0];
+	reportEventContext.groupAddr[1] = groupAddress[1];
+	reportEventContext.groupAddr[2] = groupAddress[2];
+	reportEventContext.groupAddr[3] = groupAddress[3];
+#else
+	reportEventContext.groupAddr[0] = groupAddress[0];
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		/*we only support ipv4 hardware multicast */
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (ipVersion == IP_VERSION6) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST6, &reportEventContext);
+	}
+#endif
+#endif
+
+	return SUCCESS;
+}
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+static int32 rtl_processAllow(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf)
+#else
+
+static int32 rtl_processAllow(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *pktBuf)
+#endif
+{
+	uint32 j = 0;
+	uint32 groupAddress[4] = { 0, 0, 0, 0 };
+	struct rtl_groupEntry *groupEntry = NULL;
+	struct rtl_groupEntry *newGroupEntry = NULL;
+	struct rtl_clientEntry *clientEntry = NULL;
+	struct rtl_clientEntry *newClientEntry = NULL;
+	struct rtl_sourceEntry *sourceEntry = NULL;
+	struct rtl_sourceEntry *newSourceEntry = NULL;
+
+	uint32 hashIndex = 0;
+	uint16 numOfSrc = 0;
+	uint32 *sourceAddr = NULL;
+
+	uint32 sourceAddr_host[4] = { 0, 0, 0, 0 };
+
+	if (ipVersion == IP_VERSION4) {
+		groupAddress[0] = ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc = ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceAddr = &(((struct groupRecord *)pktBuf)->srcList);
+
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+
+		groupAddress[0] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc = ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceAddr = &(((struct mCastAddrRecord *)pktBuf)->srcList);
+	}
+#endif
+	if (rtl_is_reserve_multicastAddr(groupAddress, ipVersion) == SUCCESS)
+		return FAILED;
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, groupAddress);
+
+	groupEntry = rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+
+	if (groupEntry == NULL) {	/*means new group address, create new group entry */
+		newGroupEntry = rtl_allocateGroupEntry();
+		if (newGroupEntry == NULL) {
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+		newGroupEntry->groupAddr[1] = groupAddress[1];
+		newGroupEntry->groupAddr[2] = groupAddress[2];
+		newGroupEntry->groupAddr[3] = groupAddress[3];
+#else
+		newGroupEntry->groupAddr[0] = groupAddress[0];
+#endif
+
+		newGroupEntry->ipVersion = ipVersion;
+
+		if (ipVersion == IP_VERSION4) {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+		}
+#endif
+
+		groupEntry = newGroupEntry;
+	}
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr, clientmacAddr);
+#else
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr);
+#endif
+
+	if (clientEntry == NULL) {
+		newClientEntry = rtl_allocateClientEntry();
+		if (newClientEntry == NULL) {
+			rtl_gluePrintf("run out of client entry!\n");
+			return FAILED;
+		}
+
+		assert(newClientEntry->sourceList == NULL);
+		newClientEntry->sourceList = NULL;
+		newClientEntry->portNum = portNum;
+		newClientEntry->igmpVersion = IGMP_V3;
+		newClientEntry->groupFilterTimer = rtl_sysUpSeconds;
+		if (ipVersion == IP_VERSION4) {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			newClientEntry->clientAddr[0] = clientAddr[0];
+			newClientEntry->clientAddr[1] = clientAddr[1];
+			newClientEntry->clientAddr[2] = clientAddr[2];
+			newClientEntry->clientAddr[3] = clientAddr[3];
+
+		}
+#endif
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		newClientEntry->clientMacAddr[0] = clientmacAddr[0];
+		newClientEntry->clientMacAddr[1] = clientmacAddr[1];
+		newClientEntry->clientMacAddr[2] = clientmacAddr[2];
+		newClientEntry->clientMacAddr[3] = clientmacAddr[3];
+		newClientEntry->clientMacAddr[4] = clientmacAddr[4];
+		newClientEntry->clientMacAddr[5] = clientmacAddr[5];
+#endif
+		rtl_linkClientEntry(groupEntry, newClientEntry);
+		clientEntry = newClientEntry;
+	}
+
+	clientEntry->igmpVersion = IGMP_V3;
+
+	/*here to handle the source list */
+	for (j = 0; j < numOfSrc; j++) {
+		if (ipVersion == IP_VERSION4) {
+			sourceAddr_host[0] = ntohl(sourceAddr[0]);
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else if (ipVersion == IP_VERSION6) {
+			sourceAddr_host[0] = ntohl(sourceAddr[0]);
+			sourceAddr_host[1] = ntohl(sourceAddr[1]);
+			sourceAddr_host[2] = ntohl(sourceAddr[2]);
+			sourceAddr_host[3] = ntohl(sourceAddr[3]);
+		}
+#endif
+		sourceEntry = rtl_searchSourceEntry(ipVersion, sourceAddr_host,
+			clientEntry);
+
+		if (sourceEntry == NULL) {
+			newSourceEntry = rtl_allocateSourceEntry();
+			if (newSourceEntry == NULL) {
+				rtl_gluePrintf("run out of source entry!\n");
+				return FAILED;
+			}
+
+			if (ipVersion == IP_VERSION4) {
+				newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else {
+				newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+				newSourceEntry->sourceAddr[1] = ntohl(sourceAddr[1]);
+				newSourceEntry->sourceAddr[2] = ntohl(sourceAddr[2]);
+				newSourceEntry->sourceAddr[3] = ntohl(sourceAddr[3]);
+			}
+#endif
+			newSourceEntry->portTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.groupMemberAgingTime;
+			rtl_linkSourceEntry(clientEntry, newSourceEntry);
+
+		} else {
+			/*just update source timer */
+			sourceEntry->portTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.groupMemberAgingTime;
+		}
+
+		if (ipVersion == IP_VERSION4) {
+			sourceAddr++;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			sourceAddr = sourceAddr + 4;
+		}
+#endif
+	}
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if ((groupEntry != NULL)
+		&& (groupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		return SUCCESS;
+	}
+#endif
+
+	reportEventContext.ipVersion = ipVersion;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	reportEventContext.groupAddr[0] = groupAddress[0];
+	reportEventContext.groupAddr[1] = groupAddress[1];
+	reportEventContext.groupAddr[2] = groupAddress[2];
+	reportEventContext.groupAddr[3] = groupAddress[3];
+#else
+	reportEventContext.groupAddr[0] = groupAddress[0];
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		/*we only support ipv4 hardware multicast */
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (ipVersion == IP_VERSION6) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST6, &reportEventContext);
+	}
+#endif
+#endif
+
+	return SUCCESS;
+}
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+static int32 rtl_processBlock(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientmacAddr, uint8 *pktBuf)
+#else
+
+static int32 rtl_processBlock(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *pktBuf)
+#endif
+{
+	uint32 j = 0;
+	uint32 groupAddress[4] = { 0, 0, 0, 0 };
+
+	struct rtl_groupEntry *groupEntry = NULL;
+	struct rtl_clientEntry *clientEntry = NULL;
+
+	//struct rtl_clientEntry* newClientEntry=NULL;
+	struct rtl_sourceEntry *sourceEntry = NULL;
+	struct rtl_sourceEntry *newSourceEntry = NULL;
+
+	uint32 hashIndex = 0;
+	uint16 numOfSrc = 0;
+	uint32 *sourceAddr = NULL;
+
+	uint32 sourceAddr_host[4] = { 0, 0, 0, 0 };
+
+	if (ipVersion == IP_VERSION4) {
+		groupAddress[0] = ntohl(((struct groupRecord *)pktBuf)->groupAddr);
+		numOfSrc = ntohs(((struct groupRecord *)pktBuf)->numOfSrc);
+		sourceAddr = &(((struct groupRecord *)pktBuf)->srcList);
+
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+
+		groupAddress[0] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[0]);
+		groupAddress[1] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[1]);
+		groupAddress[2] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[2]);
+		groupAddress[3] = ntohl(((struct mCastAddrRecord *)pktBuf)->mCastAddr[3]);
+
+		numOfSrc = ntohs(((struct mCastAddrRecord *)pktBuf)->numOfSrc);
+		sourceAddr = &(((struct mCastAddrRecord *)pktBuf)->srcList);
+	}
+#endif
+	if (rtl_is_reserve_multicastAddr(groupAddress, ipVersion) == SUCCESS)
+		return FAILED;
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, groupAddress);
+
+	groupEntry = rtl_searchGroupEntry(moduleIndex, ipVersion, groupAddress);
+
+	if (groupEntry == NULL) {
+		goto out;
+	}
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED)
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr, clientmacAddr);
+#else
+	clientEntry = rtl_searchClientEntry(ipVersion, groupEntry, portNum,
+		clientAddr);
+#endif
+
+	if (clientEntry == NULL) {
+		goto out;
+	}
+
+	clientEntry->igmpVersion = IGMP_V3;
+
+	if (clientEntry->groupFilterTimer > rtl_sysUpSeconds) {	/*means exclude mode */
+
+		for (j = 0; j < numOfSrc; j++) {
+
+			if (ipVersion == IP_VERSION4) {
+				sourceAddr_host[0] = ntohl(sourceAddr[0]);
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else if (ipVersion == IP_VERSION6) {
+				sourceAddr_host[0] = ntohl(sourceAddr[0]);
+				sourceAddr_host[1] = ntohl(sourceAddr[1]);
+				sourceAddr_host[2] = ntohl(sourceAddr[2]);
+				sourceAddr_host[3] = ntohl(sourceAddr[3]);
+			}
+#endif
+			sourceEntry = rtl_searchSourceEntry(ipVersion,
+				sourceAddr_host, clientEntry);
+
+			if (sourceEntry == NULL) {
+				newSourceEntry = rtl_allocateSourceEntry();
+				if (newSourceEntry == NULL) {
+					rtl_gluePrintf("run out of source entry!\n");
+					return FAILED;
+				}
+
+				if (ipVersion == IP_VERSION4) {
+					newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+
+				}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+				else {
+					newSourceEntry->sourceAddr[0] = ntohl(sourceAddr[0]);
+					newSourceEntry->sourceAddr[1] = ntohl(sourceAddr[1]);
+					newSourceEntry->sourceAddr[2] = ntohl(sourceAddr[2]);
+					newSourceEntry->sourceAddr[3] = ntohl(sourceAddr[3]);
+				}
+#endif
+				newSourceEntry->portTimer = rtl_sysUpSeconds;
+				rtl_linkSourceEntry(clientEntry,
+					newSourceEntry);
+			} else {
+				if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE) {
+					sourceEntry->portTimer = rtl_sysUpSeconds;
+				} else {
+					if (sourceEntry->portTimer > rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime) {
+						sourceEntry->portTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime;
+					}
+				}
+			}
+
+			if (ipVersion == IP_VERSION4) {
+				sourceAddr++;
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else {
+				sourceAddr = sourceAddr + 4;
+			}
+#endif
+		}
+
+	} else {		/*means include mode */
+
+		for (j = 0; j < numOfSrc; j++) {
+			if (ipVersion == IP_VERSION4) {
+				sourceAddr_host[0] = ntohl(sourceAddr[0]);
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else if (ipVersion == IP_VERSION6) {
+				sourceAddr_host[0] = ntohl(sourceAddr[0]);
+				sourceAddr_host[1] = ntohl(sourceAddr[1]);
+				sourceAddr_host[2] = ntohl(sourceAddr[2]);
+				sourceAddr_host[3] = ntohl(sourceAddr[3]);
+			}
+#endif
+			sourceEntry = rtl_searchSourceEntry(ipVersion,
+				sourceAddr_host, clientEntry);
+			if (sourceEntry != NULL) {
+				if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE) {
+					sourceEntry->portTimer = rtl_sysUpSeconds;
+				} else {
+					if (sourceEntry->portTimer > rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime) {
+						sourceEntry->portTimer = rtl_sysUpSeconds + rtl_mCastTimerParas.lastMemberAgingTime;
+					}
+
+				}
+
+			}
+
+			if (ipVersion == IP_VERSION4) {
+				sourceAddr++;
+			}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			else {
+				sourceAddr = sourceAddr + 4;
+			}
+#endif
+		}
+
+	}
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	if ((groupEntry != NULL)
+		&& (groupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		return SUCCESS;
+	}
+#endif
+
+out:
+
+	reportEventContext.ipVersion = ipVersion;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	reportEventContext.groupAddr[0] = groupAddress[0];
+	reportEventContext.groupAddr[1] = groupAddress[1];
+	reportEventContext.groupAddr[2] = groupAddress[2];
+	reportEventContext.groupAddr[3] = groupAddress[3];
+#else
+	reportEventContext.groupAddr[0] = groupAddress[0];
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		/*we only support ipv4 hardware multicast */
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE) {
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST,
+				&reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+			rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST,
+				&reportEventContext);
+#endif
+		}
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (ipVersion == IP_VERSION6) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		if (rtl_mCastModuleArray[moduleIndex].enableFastLeave == TRUE) {
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST6,
+				&reportEventContext);
+		}
+	}
+#endif
+#endif
+
+	return SUCCESS;
+
+}
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+static uint32 rtl_processIgmpv3Mldv2Reports(uint32 moduleIndex,
+	uint32 ipVersion, uint32 portNum, uint32 *clientAddr,
+	uint8 *clientmacAddr, uint8 *pktBuf)
+#else
+
+static uint32 rtl_processIgmpv3Mldv2Reports(uint32 moduleIndex,
+	uint32 ipVersion, uint32 portNum, uint32 *clientAddr, uint8 *pktBuf)
+#endif
+{
+	uint32 i = 0;
+	uint16 numOfRecords = 0;
+	uint8 *groupRecords = NULL;
+	uint8 recordType = 0xff;
+	uint16 numOfSrc = 0;
+	int32 returnVal = 0;
+
+	//uint32 multicastRouterPortMask=rtl_getMulticastRouterPortMask(moduleIndex, ipVersion, rtl_sysUpSeconds);
+
+	if (ipVersion == IP_VERSION4) {
+		numOfRecords = ntohs(((struct igmpv3Report *)pktBuf)->numOfRecords);
+		if (numOfRecords != 0) {
+			groupRecords = (uint8 *)(&(((struct igmpv3Report *)pktBuf)->recordList));
+		}
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		numOfRecords = ntohs(((struct mldv2Report *)pktBuf)->numOfRecords);
+		if (numOfRecords != 0) {
+			groupRecords = (uint8 *)(&(((struct mldv2Report *)pktBuf)->recordList));
+		}
+	}
+#endif
+
+	for (i = 0; i < numOfRecords; i++) {
+		if (ipVersion == IP_VERSION4) {
+			recordType = ((struct groupRecord *)groupRecords)->type;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			recordType = ((struct mCastAddrRecord *)groupRecords)->type;
+		}
+#endif
+
+		switch (recordType) {
+		case MODE_IS_INCLUDE:
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+			returnVal = rtl_processIsInclude(moduleIndex, ipVersion,
+				portNum, clientAddr, clientmacAddr,
+				groupRecords);
+#else
+			returnVal = rtl_processIsInclude(moduleIndex, ipVersion,
+				portNum, clientAddr, groupRecords);
+#endif
+			break;
+
+		case MODE_IS_EXCLUDE:
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+			returnVal = rtl_processIsExclude(moduleIndex, ipVersion,
+				portNum, clientAddr, clientmacAddr,
+				groupRecords);
+#else
+			returnVal = rtl_processIsExclude(moduleIndex, ipVersion,
+				portNum, clientAddr, groupRecords);
+#endif
+			break;
+
+		case CHANGE_TO_INCLUDE_MODE:
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+			returnVal = rtl_processToInclude(moduleIndex, ipVersion,
+				portNum, clientAddr, clientmacAddr,
+				groupRecords);
+#else
+			returnVal = rtl_processToInclude(moduleIndex, ipVersion,
+				portNum, clientAddr, groupRecords);
+#endif
+			break;
+
+		case CHANGE_TO_EXCLUDE_MODE:
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+			returnVal = rtl_processToExclude(moduleIndex, ipVersion,
+				portNum, clientAddr, clientmacAddr,
+				groupRecords);
+#else
+			returnVal = rtl_processToExclude(moduleIndex, ipVersion,
+				portNum, clientAddr, groupRecords);
+#endif
+			break;
+
+		case ALLOW_NEW_SOURCES:
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+			returnVal = rtl_processAllow(moduleIndex, ipVersion,
+				portNum, clientAddr, clientmacAddr,
+				groupRecords);
+#else
+			returnVal = rtl_processAllow(moduleIndex, ipVersion,
+				portNum, clientAddr, groupRecords);
+#endif
+			break;
+
+		case BLOCK_OLD_SOURCES:
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+			returnVal = rtl_processBlock(moduleIndex, ipVersion,
+				portNum, clientAddr, clientmacAddr,
+				groupRecords);
+#else
+			returnVal = rtl_processBlock(moduleIndex, ipVersion,
+				portNum, clientAddr, groupRecords);
+#endif
+			break;
+
+		default:
+			break;
+
+		}
+
+		if (ipVersion == IP_VERSION4) {
+			numOfSrc = ntohs(((struct groupRecord *)groupRecords)->numOfSrc);
+			/*shift pointer to another group record */
+			groupRecords = groupRecords + 8 + numOfSrc * 4 + (((struct groupRecord *)(groupRecords))->auxLen) * 4;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			numOfSrc = ntohs(((struct mCastAddrRecord *)groupRecords)->numOfSrc);
+			/*shift pointer to another group record */
+			groupRecords = groupRecords + 20 + numOfSrc * 16 + (((struct mCastAddrRecord *)(groupRecords))->auxLen) * 4;
+		}
+#endif
+	}
+
+	if ((numOfRecords == 1) && (recordType == CHANGE_TO_INCLUDE_MODE)) {
+		return returnVal;
+	} else {
+		/*no report supress, due to multiple group record in igmpv3 report */
+		return ((~(1 << portNum)) & ((1 << MAX_SUPPORT_PORT_NUMBER) -
+				1));
+	}
+	//return (multicastRouterPortMask&(~(1<<portNum))&((1<<MAX_SUPPORT_PORT_NUMBER)-1));
+
+}
+
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+static uint32 rtl_processIgmpMld(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *clientMacAddr, uint8 *pktBuf,
+	uint32 pktLen)
+#else
+static uint32 rtl_processIgmpMld(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint32 *clientAddr, uint8 *pktBuf, uint32 pktLen)
+#endif
+{
+	uint32 fwdPortMask = 0;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	reportEventContext.moduleIndex = moduleIndex;
+
+	switch (pktBuf[0]) {
+	case IGMP_QUERY:
+		fwdPortMask = rtl_processQueries(moduleIndex, ipVersion, portNum,
+			pktBuf, pktLen);
+		break;
+
+	case IGMPV1_REPORT:
+#if defined(CONFIG_SMP)
+		SMP_LOCK_IGMP_CONCURRENT(flags);
+#endif
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		fwdPortMask = rtl_processJoin(moduleIndex, ipVersion, portNum,
+			clientAddr, clientMacAddr, pktBuf);
+#else
+		fwdPortMask = rtl_processJoin(moduleIndex, ipVersion, portNum,
+			clientAddr, pktBuf);
+#endif
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_IGMP_CONCURRENT(flags);
+#endif
+		break;
+
+	case IGMPV2_REPORT:
+#if defined(CONFIG_SMP)
+		SMP_LOCK_IGMP_CONCURRENT(flags);
+#endif
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		fwdPortMask = rtl_processJoin(moduleIndex, ipVersion, portNum,
+			clientAddr, clientMacAddr, pktBuf);
+#else
+		fwdPortMask = rtl_processJoin(moduleIndex, ipVersion, portNum,
+			clientAddr, pktBuf);
+#endif
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_IGMP_CONCURRENT(flags);
+#endif
+		break;
+
+	case IGMPV2_LEAVE:
+#if defined(CONFIG_SMP)
+		SMP_LOCK_IGMP_CONCURRENT(flags);
+#endif
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		fwdPortMask = rtl_processLeave(moduleIndex, ipVersion, portNum,
+			clientAddr, clientMacAddr, pktBuf);
+#else
+		fwdPortMask = rtl_processLeave(moduleIndex, ipVersion, portNum,
+			clientAddr, pktBuf);
+#endif
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_IGMP_CONCURRENT(flags);
+#endif
+		break;
+
+	case IGMPV3_REPORT:
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		fwdPortMask = rtl_processIgmpv3Mldv2Reports(moduleIndex, ipVersion,
+			portNum, clientAddr, clientMacAddr, pktBuf);
+#else
+		fwdPortMask = rtl_processIgmpv3Mldv2Reports(moduleIndex, ipVersion,
+			portNum, clientAddr, pktBuf);
+#endif
+		break;
+
+	case MLD_QUERY:
+		fwdPortMask = rtl_processQueries(moduleIndex, ipVersion, portNum,
+			pktBuf, pktLen);
+		break;
+
+	case MLDV1_REPORT:
+#if defined(CONFIG_SMP)
+		SMP_LOCK_IGMP_CONCURRENT(flags);
+#endif
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		fwdPortMask = rtl_processJoin(moduleIndex, ipVersion, portNum,
+			clientAddr, clientMacAddr, pktBuf);
+#else
+		fwdPortMask = rtl_processJoin(moduleIndex, ipVersion, portNum,
+			clientAddr, pktBuf);
+#endif
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_IGMP_CONCURRENT(flags);
+#endif
+		break;
+
+	case MLDV1_DONE:
+#if defined(CONFIG_SMP)
+		SMP_LOCK_IGMP_CONCURRENT(flags);
+#endif
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+
+		fwdPortMask = rtl_processLeave(moduleIndex, ipVersion, portNum,
+			clientAddr, clientMacAddr, pktBuf);
+#else
+		fwdPortMask = rtl_processLeave(moduleIndex, ipVersion, portNum,
+			clientAddr, pktBuf);
+#endif
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_IGMP_CONCURRENT(flags);
+#endif
+		break;
+
+	case MLDV2_REPORT:
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+		fwdPortMask = rtl_processIgmpv3Mldv2Reports(moduleIndex, ipVersion,
+			portNum, clientAddr, clientMacAddr, pktBuf);
+#else
+		fwdPortMask = rtl_processIgmpv3Mldv2Reports(moduleIndex, ipVersion,
+			portNum, clientAddr, pktBuf);
+#endif
+		break;
+
+	default:
+		fwdPortMask = ((~(1 << portNum)) & ((1 << MAX_SUPPORT_PORT_NUMBER) - 1));
+		break;
+	}
+
+	return fwdPortMask;
+
+}
+
+static uint32 rtl_processDvmrp(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint8 *pktBuf, uint32 pktLen)
+{
+
+	if (ipVersion == IP_VERSION4) {
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.dvmrpRouter.portTimer[portNum] = rtl_sysUpSeconds + rtl_mCastTimerParas.dvmrpRouterAgingTime;	/*update timer */
+	}
+
+	if (ipVersion == IP_VERSION4) {
+
+		reportEventContext.ipVersion = ipVersion;
+		reportEventContext.groupAddr[0] = 0;
+		reportEventContext.groupAddr[1] = 0;
+		reportEventContext.groupAddr[2] = 0;
+		reportEventContext.groupAddr[3] = 0;
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+		rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+			reportEventContext.ipVersion,
+			reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		/*we only support ipv4 hardware multicast */
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+#endif
+	}
+
+	return ((~(1 << portNum)) & ((1 << MAX_SUPPORT_PORT_NUMBER) - 1));
+
+}
+
+static uint32 rtl_processMospf(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint8 *pktBuf, uint32 pktLen)
+{
+	struct ipv4MospfHdr *ipv4MospfHeader = (struct ipv4MospfHdr *)pktBuf;
+	struct ipv4MospfHello *ipv4HelloPkt = (struct ipv4MospfHello *)pktBuf;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	struct ipv6MospfHdr *ipv6MospfHeader = (struct ipv6MospfHdr *)pktBuf;
+	struct ipv6MospfHello *ipv6HelloPkt = (struct ipv6MospfHello *)pktBuf;
+#endif
+
+	if (ipVersion == IP_VERSION4) {
+		/*mospf is built based on ospfv2 */
+		if ((ipv4MospfHeader->version == 2)
+			&& (ipv4MospfHeader->type == MOSPF_HELLO_TYPE)) {
+			if ((ipv4HelloPkt->options & 0x04) != 0) {
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.mospfRouter.portTimer[portNum] = rtl_sysUpSeconds + rtl_mCastTimerParas.mospfRouterAgingTime;	/*update timer */
+			}
+		}
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		if ((ipv6MospfHeader->version == 3)
+			&& (ipv6MospfHeader->type == MOSPF_HELLO_TYPE)) {
+			if ((ipv6HelloPkt->options[2] & 0x04) != 0) {
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.mospfRouter.portTimer[portNum] = rtl_sysUpSeconds + rtl_mCastTimerParas.mospfRouterAgingTime;	/*update timer */
+
+			}
+		}
+	}
+#endif
+
+	reportEventContext.ipVersion = ipVersion;
+	reportEventContext.groupAddr[0] = 0;
+	reportEventContext.groupAddr[1] = 0;
+	reportEventContext.groupAddr[2] = 0;
+	reportEventContext.groupAddr[3] = 0;
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+	}
+#endif
+
+	return ((~(1 << portNum)) & ((1 << MAX_SUPPORT_PORT_NUMBER) - 1));
+
+}
+
+static uint32 rtl_processPim(uint32 moduleIndex, uint32 ipVersion,
+	uint32 portNum, uint8 *pktBuf, uint32 pktLen)
+{
+	if (ipVersion == IP_VERSION4) {
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters.pimRouter.portTimer[portNum] = rtl_sysUpSeconds + rtl_mCastTimerParas.pimRouterAgingTime;	/*update timer */
+
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else {
+		rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters.pimRouter.portTimer[portNum] = rtl_sysUpSeconds + rtl_mCastTimerParas.pimRouterAgingTime;	/*update timer */
+	}
+#endif
+
+	reportEventContext.ipVersion = ipVersion;
+	reportEventContext.groupAddr[0] = 0;
+	reportEventContext.groupAddr[1] = 0;
+	reportEventContext.groupAddr[2] = 0;
+	reportEventContext.groupAddr[3] = 0;
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (ipVersion == IP_VERSION4) {
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+	}
+#endif
+
+	return ((~(1 << portNum)) & ((1 << MAX_SUPPORT_PORT_NUMBER) - 1));
+}
+
+/*********************************************
+				External Function
+  *********************************************/
+
+//External called function by high level program
+
+int32 rtl_registerIgmpSnoopingModule(uint32 *moduleIndex)
+{
+	int32 i = 0;
+	uint32 index = 0xFFFFFFFF;
+
+	*moduleIndex = 0xFFFFFFFF;
+
+	for (i = 0; i < MAX_MCAST_MODULE_NUM; i++) {
+		if (rtl_mCastModuleArray[i].enableSnooping == FALSE) {
+			index = i;
+			break;
+		}
+	}
+
+	if (i >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[index].enableSnooping == FALSE) {
+		/*initialize multicast Routers information */
+		for (i = 0; i < MAX_SUPPORT_PORT_NUMBER; i++) {
+			rtl_mCastModuleArray[index].rtl_ipv4MulticastRouters.querier.portTimer[i] = 0;
+			rtl_mCastModuleArray[index].rtl_ipv4MulticastRouters.dvmrpRouter.portTimer[i] = 0;
+			rtl_mCastModuleArray[index].rtl_ipv4MulticastRouters.pimRouter.portTimer[i] = 0;
+			rtl_mCastModuleArray[index].rtl_ipv4MulticastRouters.mospfRouter.portTimer[i] = 0;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			rtl_mCastModuleArray[index].rtl_ipv6MulticastRouters.querier.portTimer[i] = 0;
+			rtl_mCastModuleArray[index].rtl_ipv6MulticastRouters.dvmrpRouter.portTimer[i] = 0;
+			rtl_mCastModuleArray[index].rtl_ipv6MulticastRouters.pimRouter.portTimer[i] = 0;
+			rtl_mCastModuleArray[index].rtl_ipv6MulticastRouters.mospfRouter.portTimer[i] = 0;
+#endif
+		}
+
+		/*initialize hash table */
+		rtl_initHashTable(index, rtl_hashTableSize);
+
+		if ((rtl_mCastModuleArray[index].rtl_ipv4HashTable == NULL)) {
+			return FAILED;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		if (rtl_mCastModuleArray[index].rtl_ipv6HashTable == NULL) {
+			return FAILED;
+		}
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		memset(&rtl_mCastModuleArray[index].deviceInfo, 0,
+			sizeof(rtl_multicastDeviceInfo_t));
+#endif
+		for (i = 0; i < 6; i++) {
+			rtl_mCastModuleArray[index].rtl_gatewayMac[i] = 0;
+		}
+
+		rtl_mCastModuleArray[index].rtl_gatewayIpv4Addr = 0;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		for (i = 0; i < 4; i++) {
+			rtl_mCastModuleArray[index].rtl_gatewayIpv6Addr[i] = 0;
+		}
+#endif
+		rtl_mCastModuleArray[index].enableFastLeave = FALSE;
+		rtl_mCastModuleArray[index].enableSnooping = TRUE;
+		rtl_mCastModuleArray[index].ipv4UnknownMCastFloodMap = DEFAULT_IPV4_UNKNOWN_MCAST_FLOOD_MAP;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		rtl_mCastModuleArray[index].ipv6UnknownMCastFloodMap = DEFAULT_IPV6_UNKNOWN_MCAST_FLOOD_MAP;
+#endif
+		rtl_mCastModuleArray[index].staticRouterPortMask = 0;
+#ifdef CONFIG_PROC_FS
+		rtl_mCastModuleArray[index].expireEventCnt = 0;
+#endif
+		*moduleIndex = index;
+
+		return SUCCESS;
+	} else {
+		return FAILED;
+	}
+
+	*moduleIndex = index;
+	*moduleIndex = index;
+	return SUCCESS;
+}
+
+int32 rtl_unregisterIgmpSnoopingModule(uint32 moduleIndex)
+{
+	uint32 i = 0;
+	struct rtl_groupEntry *groupEntryPtr = NULL;
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	struct rtl_mcastFlowEntry *mcastFlowEntryPtr = NULL;
+#endif
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+
+		rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv4Addr = 0;
+
+		for (i = 0; i < 6; i++) {
+			rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[i] = 0;
+		}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		for (i = 0; i < 4; i++) {
+			rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[i] = 0;
+		}
+#endif
+
+		/*delete ipv4 multicast entry */
+		if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+			for (i = 0; i < rtl_hashTableSize; i++) {
+				groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+
+				while (groupEntryPtr != NULL) {
+					rtl_deleteGroupEntry(groupEntryPtr,
+						rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+					groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+				}
+			}
+			rtl_glueFree(rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+			rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable = NULL;
+			memset(&(rtl_mCastModuleArray[moduleIndex].rtl_ipv4MulticastRouters), 0,
+				sizeof(struct rtl_multicastRouters));
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		/*delete ipv6 multicast entry */
+		if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+			for (i = 0; i < rtl_hashTableSize; i++) {
+
+				groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i];
+				while (groupEntryPtr != NULL) {
+					rtl_deleteGroupEntry(groupEntryPtr,
+						rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+					groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i];
+				}
+			}
+			rtl_glueFree(rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+			rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable = NULL;
+			memset(&(rtl_mCastModuleArray[moduleIndex].rtl_ipv6MulticastRouters), 0,
+				sizeof(struct rtl_multicastRouters));
+		}
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+		/*delete multicast flow entry */
+		if (rtl_mCastModuleArray[moduleIndex].flowHashTable != NULL) {
+			for (i = 0; i < rtl_hashTableSize; i++) {
+				mcastFlowEntryPtr = rtl_mCastModuleArray[moduleIndex].flowHashTable[i];
+
+				while (mcastFlowEntryPtr != NULL) {
+					rtl_deleteMcastFlowEntry(mcastFlowEntryPtr,
+						rtl_mCastModuleArray[moduleIndex].flowHashTable);
+					mcastFlowEntryPtr = rtl_mCastModuleArray[moduleIndex].flowHashTable[i];
+				}
+			}
+			rtl_glueFree(rtl_mCastModuleArray[moduleIndex].flowHashTable);
+			rtl_mCastModuleArray[moduleIndex].flowHashTable = NULL;
+		}
+#endif
+		rtl_mCastModuleArray[moduleIndex].enableSnooping = FALSE;
+		rtl_mCastModuleArray[moduleIndex].enableFastLeave = FALSE;
+		rtl_mCastModuleArray[moduleIndex].ipv4UnknownMCastFloodMap = 0;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		rtl_mCastModuleArray[moduleIndex].ipv6UnknownMCastFloodMap = 0;
+#endif
+		rtl_mCastModuleArray[moduleIndex].staticRouterPortMask = 0;
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		memset(&rtl_mCastModuleArray[moduleIndex].deviceInfo, 0,
+			sizeof(rtl_multicastDeviceInfo_t));
+#endif
+		return SUCCESS;
+	}
+
+	return SUCCESS;
+
+}
+
+static void _rtl865x_configIgmpSnoopingExpire(int32 disableExpire)
+{
+	uint32 maxTime = 0xffffffff;
+
+	if ((rtl_mCastTimerParas.disableExpire == FALSE)
+		&& (disableExpire == TRUE)) {
+		rtl_mCastTimerParas.disableExpire = TRUE;
+	}
+
+	if ((rtl_mCastTimerParas.disableExpire == TRUE)
+		&& (disableExpire == FALSE)) {
+#if defined(__linux__) && defined(__KERNEL__)
+		struct timeval currentTimeVector;
+
+		do_gettimeofday(&currentTimeVector);
+		/*reset start time */
+		if (currentTimeVector.tv_sec >= rtl_sysUpSeconds) {
+			rtl_startTime = (uint32)(currentTimeVector.tv_sec) - rtl_sysUpSeconds;
+		} else {
+			/*avoid timer wrap back */
+			rtl_startTime = maxTime - rtl_sysUpSeconds +
+				(uint32)(currentTimeVector.tv_sec) + 1;
+		}
+#endif
+		rtl_mCastTimerParas.disableExpire = FALSE;
+	}
+
+	return;
+}
+
+//External called function by high level program
+void rtl_setMulticastParameters(struct rtl_mCastTimerParameters mCastTimerParameters)
+{
+	_rtl865x_configIgmpSnoopingExpire(mCastTimerParameters.disableExpire);
+
+	if (mCastTimerParameters.groupMemberAgingTime != 0) {
+		rtl_mCastTimerParas.groupMemberAgingTime = mCastTimerParameters.groupMemberAgingTime;
+	}
+
+	if (mCastTimerParameters.lastMemberAgingTime != 0) {
+		rtl_mCastTimerParas.lastMemberAgingTime = mCastTimerParameters.lastMemberAgingTime;
+	}
+
+	if (mCastTimerParameters.querierPresentInterval != 0) {
+
+		rtl_mCastTimerParas.querierPresentInterval = mCastTimerParameters.querierPresentInterval;
+	}
+
+	if (mCastTimerParameters.dvmrpRouterAgingTime != 0) {
+
+		rtl_mCastTimerParas.dvmrpRouterAgingTime = mCastTimerParameters.dvmrpRouterAgingTime;
+	}
+
+	if (mCastTimerParameters.mospfRouterAgingTime != 0) {
+
+		rtl_mCastTimerParas.mospfRouterAgingTime = mCastTimerParameters.mospfRouterAgingTime;
+	}
+
+	if (mCastTimerParameters.pimRouterAgingTime != 0) {
+
+		rtl_mCastTimerParas.pimRouterAgingTime = mCastTimerParameters.pimRouterAgingTime;
+	}
+
+	return;
+}
+int rtl_getMulticastParameters(struct rtl_mCastTimerParameters *mCastTimerParameters)
+{
+	if(mCastTimerParameters == NULL)
+		return FAILED;
+
+	mCastTimerParameters->disableExpire= rtl_mCastTimerParas.disableExpire;
+	mCastTimerParameters->groupMemberAgingTime= rtl_mCastTimerParas.groupMemberAgingTime;
+	mCastTimerParameters->lastMemberAgingTime= rtl_mCastTimerParas.lastMemberAgingTime;
+	mCastTimerParameters->querierPresentInterval=rtl_mCastTimerParas.querierPresentInterval;
+	mCastTimerParameters->dvmrpRouterAgingTime=rtl_mCastTimerParas.dvmrpRouterAgingTime;
+	mCastTimerParameters->mospfRouterAgingTime=rtl_mCastTimerParas.mospfRouterAgingTime;
+	mCastTimerParameters->pimRouterAgingTime=rtl_mCastTimerParas.pimRouterAgingTime;
+
+	return SUCCESS;
+}
+
+
+void rtl_modifyGroupTimer(int groupAgeTime)
+{
+	int32 moduleIndex;
+	int32 hashIndex;
+	struct rtl_groupEntry *groupEntryPtr=NULL;
+	struct rtl_clientEntry* clientEntry=NULL;
+	struct rtl_sourceEntry *sourceEntryPtr=NULL;
+
+	for(moduleIndex=0; moduleIndex<MAX_MCAST_MODULE_NUM ;moduleIndex++)
+	{
+			if(rtl_mCastModuleArray[moduleIndex].enableSnooping==TRUE)
+			{
+				if(rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL)
+				{
+					for(hashIndex=0;hashIndex<rtl_hashTableSize;hashIndex++)
+					{
+						groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[hashIndex];
+						while(groupEntryPtr!=NULL)
+						{
+							clientEntry=groupEntryPtr->clientList;
+
+							while (clientEntry!=NULL)
+							{
+
+								if(clientEntry->groupFilterTimer>rtl_sysUpSeconds)
+								{
+									if((clientEntry->groupFilterTimer-rtl_sysUpSeconds)>rtl_mCastTimerParas.groupMemberAgingTime)
+										clientEntry->groupFilterTimer = rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+								}
+
+								sourceEntryPtr=clientEntry->sourceList;
+
+								while(sourceEntryPtr!=NULL)
+								{
+									if(sourceEntryPtr->portTimer>rtl_sysUpSeconds)
+									{
+										if((sourceEntryPtr->portTimer-rtl_sysUpSeconds)>rtl_mCastTimerParas.groupMemberAgingTime)
+											sourceEntryPtr->portTimer=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+									}
+
+									sourceEntryPtr=sourceEntryPtr->next;
+								}
+								clientEntry = clientEntry->next;
+							}
+							groupEntryPtr=groupEntryPtr->next;
+						}
+
+					}
+				}
+				if(rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL)
+				{
+					for(hashIndex=0;hashIndex<rtl_hashTableSize;hashIndex++)
+					{
+						groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[hashIndex];
+						while(groupEntryPtr!=NULL)
+						{
+							clientEntry=groupEntryPtr->clientList;
+
+							while (clientEntry!=NULL)
+							{
+
+								if(clientEntry->groupFilterTimer>rtl_sysUpSeconds)
+								{
+									if((clientEntry->groupFilterTimer-rtl_sysUpSeconds)>rtl_mCastTimerParas.groupMemberAgingTime)
+										clientEntry->groupFilterTimer = rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+								}
+
+								sourceEntryPtr=clientEntry->sourceList;
+
+								while(sourceEntryPtr!=NULL)
+								{
+									if(sourceEntryPtr->portTimer>rtl_sysUpSeconds)
+									{
+										if((sourceEntryPtr->portTimer-rtl_sysUpSeconds)>rtl_mCastTimerParas.groupMemberAgingTime)
+											sourceEntryPtr->portTimer=rtl_sysUpSeconds+rtl_mCastTimerParas.groupMemberAgingTime;
+									}
+
+									sourceEntryPtr=sourceEntryPtr->next;
+								}
+								clientEntry = clientEntry->next;
+							}
+							groupEntryPtr=groupEntryPtr->next;
+						}
+
+					}
+				}
+			}
+		}
+
+}
+
+int32 rtl_configIgmpSnoopingModule(uint32 moduleIndex, struct rtl_mCastSnoopingLocalConfig *mCastSnoopingLocalConfig)
+{
+
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (mCastSnoopingLocalConfig == NULL) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	rtl_mCastModuleArray[moduleIndex].enableFastLeave = mCastSnoopingLocalConfig->enableFastLeave;
+	rtl_mCastModuleArray[moduleIndex].ipv4UnknownMCastFloodMap = mCastSnoopingLocalConfig->ipv4UnknownMcastFloodMap;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	rtl_mCastModuleArray[moduleIndex].ipv6UnknownMCastFloodMap = mCastSnoopingLocalConfig->ipv6UnknownMcastFloodMap;
+#endif
+	rtl_mCastModuleArray[moduleIndex].staticRouterPortMask = mCastSnoopingLocalConfig->staticRouterPortMask;
+
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[0] = mCastSnoopingLocalConfig->gatewayMac[0];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[1] = mCastSnoopingLocalConfig->gatewayMac[1];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[2] = mCastSnoopingLocalConfig->gatewayMac[2];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[3] = mCastSnoopingLocalConfig->gatewayMac[3];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[4] = mCastSnoopingLocalConfig->gatewayMac[4];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayMac[5] = mCastSnoopingLocalConfig->gatewayMac[5];
+
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv4Addr = mCastSnoopingLocalConfig->gatewayIpv4Addr;
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[0] = mCastSnoopingLocalConfig->gatewayIpv6Addr[0];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[1] = mCastSnoopingLocalConfig->gatewayIpv6Addr[1];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[2] = mCastSnoopingLocalConfig->gatewayIpv6Addr[2];
+	rtl_mCastModuleArray[moduleIndex].rtl_gatewayIpv6Addr[3] = mCastSnoopingLocalConfig->gatewayIpv6Addr[3];
+#endif
+	return SUCCESS;
+}
+
+/*
+@func int32	| rtl_maintainMulticastSnoopingTimerList	|   Multicast snooping timer list maintenance function.
+@parm  uint32	| currentSystemTime	|The current system time (unit: seconds).
+@rvalue SUCCESS	|Always return SUCCESS.
+@comm
+ This function should be called once a second to maintain multicast timer list.
+*/
+int32 rtl_maintainMulticastSnoopingTimerList(uint32 currentSystemTime)
+{
+	/* maintain current time */
+	uint32 i = 0;
+	uint32 maxTime = 0xffffffff;
+
+	struct rtl_groupEntry *groupEntryPtr = NULL;
+	struct rtl_groupEntry *nextEntry = NULL;
+
+	uint32 moduleIndex;
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	for (moduleIndex = 0; moduleIndex < MAX_MCAST_MODULE_NUM; moduleIndex++) {
+		if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+			if ((currentSystemTime % DEFAULT_MCAST_FLOW_EXPIRE_TIME) == 0) {
+				rtl_doMcastFlowRecycle(moduleIndex,
+					BOTH_IPV4_IPV6);
+			}
+
+		}
+	}
+#endif
+
+	if (rtl_mCastTimerParas.disableExpire == TRUE) {
+		return SUCCESS;
+	}
+
+	/*handle timer conter overflow */
+	if (currentSystemTime > rtl_startTime) {
+		rtl_sysUpSeconds = currentSystemTime - rtl_startTime;
+	} else {
+		rtl_sysUpSeconds = (maxTime - rtl_startTime) + currentSystemTime + 1;
+	}
+
+	for (moduleIndex = 0; moduleIndex < MAX_MCAST_MODULE_NUM; moduleIndex++) {
+		if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+			strcpy(timerEventContext.devName,
+				rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+			timerEventContext.moduleIndex = moduleIndex;
+#endif
+
+			/*maintain ipv4 group entry  timer */
+			for (i = 0; i < rtl_hashTableSize; i++) {
+				/*scan the hash table */
+				if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+					timerEventContext.ipVersion = IP_VERSION4;
+					groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[i];
+					while (groupEntryPtr) {	/*traverse each group list */
+						nextEntry = groupEntryPtr->next;
+						timerEventContext.groupAddr[0] = groupEntryPtr->groupAddr[0];
+						timerEventContext.groupAddr[1] = 0;
+						timerEventContext.groupAddr[2] = 0;
+						timerEventContext.groupAddr[3] = 0;
+						rtl_checkGroupEntryTimer(groupEntryPtr,
+							rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+						groupEntryPtr = nextEntry;	/*because expired group entry  will be cleared */
+					}
+				}
+			}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			/*maintain ipv6 group entry  timer */
+			for (i = 0; i < rtl_hashTableSize; i++) {
+				/*scan the hash table */
+				if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+					timerEventContext.ipVersion = IP_VERSION6;
+					groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[i];
+					while (groupEntryPtr) {	/*traverse each group list */
+						nextEntry = groupEntryPtr->next;
+						timerEventContext.groupAddr[0] = groupEntryPtr->groupAddr[0];
+						timerEventContext.groupAddr[1] = groupEntryPtr->groupAddr[1];
+						timerEventContext.groupAddr[2] = groupEntryPtr->groupAddr[2];
+						timerEventContext.groupAddr[3] = groupEntryPtr->groupAddr[3];
+						rtl_checkGroupEntryTimer(groupEntryPtr,
+							rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+						groupEntryPtr = nextEntry;	/*because expired group entry  will be cleared */
+					}
+				}
+			}
+#endif
+
+		}
+	}
+	return SUCCESS;
+}
+
+int32 rtl_igmpMldProcess(uint32 moduleIndex, uint8 *macFrame, uint32 portNum,
+	uint32 *fwdPortMask)
+{
+
+	struct rtl_macFrameInfo macFrameInfo;
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	reportEventContext.portMask = 1 << portNum;
+#endif
+
+	*fwdPortMask = (~(1 << portNum)) & 0xFFFFFFFF;
+
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+	//rtl_parseMacFrame(moduleIndex, macFrame, TRUE, &macFrameInfo);
+	rtl_parseMacFrame(moduleIndex, macFrame, FALSE, &macFrameInfo);
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+		if (macFrameInfo.ipBuf == NULL) {
+			return FAILED;
+		}
+
+		if ((macFrameInfo.ipVersion != IP_VERSION4)
+			&& (macFrameInfo.ipVersion != IP_VERSION6)) {
+
+			return FAILED;
+		}
+#ifndef CONFIG_RTL_MLD_SNOOPING
+		if (macFrameInfo.ipVersion == IP_VERSION6) {
+			return FAILED;
+		}
+#endif
+		/*port num starts from 0 */
+		if (portNum >= MAX_SUPPORT_PORT_NUMBER) {
+			return FAILED;
+		}
+
+		if (macFrameInfo.checksumFlag != SUCCESS) {
+			return FAILED;
+		}
+
+		switch (macFrameInfo.l3Protocol) {
+
+		case IGMP_PROTOCOL:
+			//      printk("%x-%x-%x-%x-%x-%x[%s]:[%d].\n",macFrameInfo.srcMacAddr[0],macFrameInfo.srcMacAddr[1],macFrameInfo.srcMacAddr[2],macFrameInfo.srcMacAddr[3],macFrameInfo.srcMacAddr[4],macFrameInfo.srcMacAddr[5],__FUNCTION__,__LINE__);
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+			*fwdPortMask = rtl_processIgmpMld(moduleIndex,
+				(uint32)(macFrameInfo.ipVersion), portNum,
+				macFrameInfo.srcIpAddr, macFrameInfo.srcMacAddr,
+				macFrameInfo.l3PktBuf, macFrameInfo.l3PktLen);
+#else
+			*fwdPortMask = rtl_processIgmpMld(moduleIndex,
+				(uint32)(macFrameInfo.ipVersion), portNum,
+				macFrameInfo.srcIpAddr, macFrameInfo.l3PktBuf,
+				macFrameInfo.l3PktLen);
+#endif
+			break;
+
+		case ICMP_PROTOCOL:
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+			*fwdPortMask = rtl_processIgmpMld(moduleIndex,
+				(uint32)(macFrameInfo.ipVersion), portNum,
+				macFrameInfo.srcIpAddr, macFrameInfo.srcMacAddr,
+				macFrameInfo.l3PktBuf, macFrameInfo.l3PktLen);
+#else
+			*fwdPortMask = rtl_processIgmpMld(moduleIndex,
+				(uint32)(macFrameInfo.ipVersion), portNum,
+				macFrameInfo.srcIpAddr, macFrameInfo.l3PktBuf,
+				macFrameInfo.l3PktLen);
+#endif
+			break;
+
+		case DVMRP_PROTOCOL:
+			*fwdPortMask = rtl_processDvmrp(moduleIndex,
+				(uint32)(macFrameInfo.ipVersion), portNum,
+				macFrameInfo.l3PktBuf, macFrameInfo.l3PktLen);
+			break;
+
+		case MOSPF_PROTOCOL:
+			*fwdPortMask = rtl_processMospf(moduleIndex,
+				(uint32)(macFrameInfo.ipVersion), portNum,
+				macFrameInfo.l3PktBuf, macFrameInfo.l3PktLen);
+			break;
+
+		case PIM_PROTOCOL:
+			*fwdPortMask = rtl_processPim(moduleIndex,
+				(uint32)(macFrameInfo.ipVersion), portNum,
+				macFrameInfo.l3PktBuf, macFrameInfo.l3PktLen);
+			break;
+
+		default:
+			break;
+		}
+
+		rtl_setClientMacAddr(&macFrameInfo);
+	}
+
+	return SUCCESS;
+}
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+static int32 rtl_recordMcastFlow(uint32 moduleIndex, uint32 ipVersion,
+	uint32 *sourceIpAddr, uint32 *groupAddr,
+	struct rtl_multicastFwdInfo *multicastFwdInfo)
+{
+	struct rtl_mcastFlowEntry *mcastFlowEntry = NULL;
+
+	if (multicastFwdInfo == NULL) {
+		return FAILED;
+	}
+
+	mcastFlowEntry = rtl_searchMcastFlowEntry(moduleIndex, ipVersion, sourceIpAddr,
+		groupAddr);
+
+	if (mcastFlowEntry == NULL) {
+
+		mcastFlowEntry = rtl_allocateMcastFlowEntry();
+		if (mcastFlowEntry == NULL) {
+			rtl_doMcastFlowRecycle(moduleIndex, ipVersion);
+
+			mcastFlowEntry = rtl_allocateMcastFlowEntry();
+			if (mcastFlowEntry == NULL) {
+				rtl_gluePrintf("run out of multicast flow entry!\n");
+				return FAILED;
+			}
+		}
+
+		if (ipVersion == IP_VERSION4) {
+			mcastFlowEntry->serverAddr[0] = sourceIpAddr[0];
+			mcastFlowEntry->groupAddr[0] = groupAddr[0];
+
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			mcastFlowEntry->serverAddr[0] = sourceIpAddr[0];
+			mcastFlowEntry->serverAddr[1] = sourceIpAddr[1];
+			mcastFlowEntry->serverAddr[2] = sourceIpAddr[2];
+			mcastFlowEntry->serverAddr[3] = sourceIpAddr[3];
+
+			mcastFlowEntry->groupAddr[0] = groupAddr[0];
+			mcastFlowEntry->groupAddr[1] = groupAddr[1];
+			mcastFlowEntry->groupAddr[2] = groupAddr[2];
+			mcastFlowEntry->groupAddr[3] = groupAddr[3];
+		}
+#endif
+
+		mcastFlowEntry->ipVersion = ipVersion;
+
+		memcpy(&mcastFlowEntry->multicastFwdInfo, multicastFwdInfo,
+			sizeof(struct rtl_multicastFwdInfo));
+
+		mcastFlowEntry->refreshTime = rtl_sysUpSeconds;
+
+		rtl_linkMcastFlowEntry(mcastFlowEntry,
+			rtl_mCastModuleArray[moduleIndex].flowHashTable);
+
+		return SUCCESS;
+
+	} else {
+		/*update forward port mask information */
+		memcpy(&mcastFlowEntry->multicastFwdInfo, multicastFwdInfo,
+			sizeof(struct rtl_multicastFwdInfo));
+		mcastFlowEntry->refreshTime = rtl_sysUpSeconds;
+		return SUCCESS;
+	}
+
+	return SUCCESS;
+}
+
+static void rtl_invalidateMCastFlow(uint32 moduleIndex, uint32 ipVersion,
+	uint32 *groupAddr)
+{
+	uint32 hashIndex;
+	struct rtl_mcastFlowEntry *mcastFlowEntry = NULL;
+	struct rtl_mcastFlowEntry *nextMcastFlowEntry = NULL;
+
+	if (NULL == groupAddr) {
+		return;
+	}
+
+	hashIndex = rtl_igmpHashAlgorithm(ipVersion, groupAddr);
+
+	if (rtl_mCastModuleArray[moduleIndex].flowHashTable != NULL)
+		mcastFlowEntry = rtl_mCastModuleArray[moduleIndex].flowHashTable[hashIndex];
+
+	while (mcastFlowEntry != NULL) {
+		nextMcastFlowEntry = mcastFlowEntry->next;
+
+		if (ipVersion == mcastFlowEntry->ipVersion) {
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			if ((groupAddr[0] == 0) && (groupAddr[1] == 0)
+				&& (groupAddr[2] == 0) && (groupAddr[3] == 0))
+#else
+			if (groupAddr[0] == 0)
+#endif
+			{
+				rtl_deleteMcastFlowEntry(mcastFlowEntry,
+					rtl_mCastModuleArray[moduleIndex].flowHashTable);
+			} else {
+#ifdef CONFIG_RTL_MLD_SNOOPING
+				if ((mcastFlowEntry->groupAddr[0] == groupAddr[0])
+					&& (mcastFlowEntry->groupAddr[1] == groupAddr[1])
+					&& (mcastFlowEntry->groupAddr[2] == groupAddr[2])
+					&& (mcastFlowEntry->groupAddr[3] == groupAddr[3]))
+#else
+				if (mcastFlowEntry->groupAddr[0] == groupAddr[0])
+#endif
+				{
+					rtl_deleteMcastFlowEntry(mcastFlowEntry,
+						rtl_mCastModuleArray[moduleIndex].flowHashTable);
+				}
+			}
+
+		}
+
+		mcastFlowEntry = nextMcastFlowEntry;
+	}
+
+	return;
+
+}
+
+static void rtl_doMcastFlowRecycle(uint32 moduleIndex, uint32 ipVersion)
+{
+	uint32 i;
+	uint32 freeCnt = 0;
+	struct rtl_mcastFlowEntry *mcastFlowEntry = NULL;
+	struct rtl_mcastFlowEntry *nextMcastFlowEntry = NULL;
+	struct rtl_mcastFlowEntry *oldestMcastFlowEntry = NULL;
+
+	if (rtl_mCastModuleArray[moduleIndex].flowHashTable == NULL)
+		return;
+
+	for (i = 0; i < rtl_hashTableSize; i++) {
+		mcastFlowEntry = rtl_mCastModuleArray[moduleIndex].flowHashTable[i];
+
+		if (oldestMcastFlowEntry == NULL) {
+			oldestMcastFlowEntry = mcastFlowEntry;
+		}
+
+		while (mcastFlowEntry != NULL) {
+			nextMcastFlowEntry = mcastFlowEntry->next;
+			/*keep the most recently used entry */
+			if ((mcastFlowEntry->refreshTime + DEFAULT_MCAST_FLOW_EXPIRE_TIME) < rtl_sysUpSeconds) {
+				rtl_deleteMcastFlowEntry(mcastFlowEntry,
+					rtl_mCastModuleArray[moduleIndex].flowHashTable);
+				freeCnt++;
+			}
+			mcastFlowEntry = nextMcastFlowEntry;
+
+		}
+	}
+
+	if (freeCnt > 0) {
+		return;
+	}
+
+	/*if too many concurrent flow,we have to do LRU */
+	for (i = 0; i < rtl_hashTableSize; i++) {
+		mcastFlowEntry = rtl_mCastModuleArray[moduleIndex].flowHashTable[i];
+
+		if (oldestMcastFlowEntry == NULL) {
+			oldestMcastFlowEntry = mcastFlowEntry;
+		}
+
+		while (mcastFlowEntry != NULL) {
+			nextMcastFlowEntry = mcastFlowEntry->next;
+			if (mcastFlowEntry->refreshTime <
+				oldestMcastFlowEntry->refreshTime) {
+				oldestMcastFlowEntry = mcastFlowEntry;
+			}
+
+			mcastFlowEntry = nextMcastFlowEntry;
+
+		}
+	}
+
+	if (oldestMcastFlowEntry != NULL) {
+		rtl_deleteMcastFlowEntry(oldestMcastFlowEntry,
+			rtl_mCastModuleArray[moduleIndex].flowHashTable);
+
+	}
+
+	return;
+
+}
+
+#endif
+#if 0
+int32 rtl_getMulticastDataFwdPortMask(uint32 moduleIndex,
+	struct rtl_multicastDataInfo *multicastDataInfo, uint32 *fwdPortMask)
+{
+	int32 retVal = FAILED;
+	struct rtl_multicastFwdInfo multicastFwdInfo;
+
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (multicastDataInfo == NULL) {
+		return FAILED;
+	}
+
+	if (fwdPortMask == NULL) {
+		return FAILED;
+	}
+
+	retVal = rtl_getMulticastDataFwdInfo(moduleIndex, multicastDataInfo,
+		&multicastFwdInfo);
+
+	*fwdPortMask = multicastFwdInfo.fwdPortMask;
+
+	if (retVal == SUCCESS) {
+		if (multicastFwdInfo.unknownMCast == TRUE) {
+			return FAILED;
+		} else {
+			return SUCCESS;
+		}
+	}
+
+	return FAILED;
+
+}
+#endif
+
+int32 rtl_getMulticastDataFwdInfo(uint32 moduleIndex,
+	struct rtl_multicastDataInfo *multicastDataInfo,
+	struct rtl_multicastFwdInfo *multicastFwdInfo)
+{
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	struct rtl_mcastFlowEntry *mcastFlowEntry = NULL;
+#endif
+	struct rtl_groupEntry *groupEntry = NULL;
+	uint32 multicastRouterPortMask = 0;
+
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (multicastDataInfo == NULL) {
+		return FAILED;
+	}
+
+	if (multicastFwdInfo == NULL) {
+		return FAILED;
+	}
+
+	memset(multicastFwdInfo, 0, sizeof(struct rtl_multicastFwdInfo));
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	mcastFlowEntry = rtl_searchMcastFlowEntry(moduleIndex,
+		multicastDataInfo->ipVersion, multicastDataInfo->sourceIp,
+		multicastDataInfo->groupAddr);
+	if (mcastFlowEntry != NULL) {
+		memcpy(multicastFwdInfo, &mcastFlowEntry->multicastFwdInfo,
+			sizeof(struct rtl_multicastFwdInfo));
+		return SUCCESS;
+	}
+#endif
+
+	//added for MDNS packets
+	if ((IS_RESERVE_MULTICAST_MDNS_ADDR_V4(multicastDataInfo->groupAddr[0])
+			&& multicastDataInfo->ipVersion == IP_VERSION4)
+		|| (IS_RESERVE_MULTICAST_MDNS_ADDR_V6(multicastDataInfo->groupAddr)
+			&& multicastDataInfo->ipVersion == IP_VERSION6)) {
+		multicastFwdInfo->reservedMCast = TRUE;
+		multicastFwdInfo->fwdPortMask = 0xFFFFFFFF;
+
+		return FAILED;
+	}
+
+	groupEntry = rtl_searchGroupEntry(moduleIndex, multicastDataInfo->ipVersion,
+		multicastDataInfo->groupAddr);
+
+	if (groupEntry == NULL) {
+		if ((multicastDataInfo->groupAddr[0] == RESERVE_MULTICAST_ADDR1)
+			|| (multicastDataInfo->groupAddr[0] == RESERVE_MULTICAST_ADDR2)) {
+			multicastFwdInfo->unknownMCast = FALSE;
+			multicastFwdInfo->reservedMCast = TRUE;
+			multicastFwdInfo->fwdPortMask = 0xFFFFFFFF;
+			multicastFwdInfo->cpuFlag = TRUE;
+
+			return FAILED;
+		}
+#if 0
+		else if (IN_MULTICAST_RESV1(multicastDataInfo->groupAddr[0])) {
+			multicastFwdInfo->unknownMCast = FALSE;
+			multicastFwdInfo->reservedMCast = TRUE;
+			multicastFwdInfo->fwdPortMask = 0xFFFFFFFF;
+			multicastFwdInfo->cpuFlag = TRUE;
+
+			return FAILED;
+		}
+#endif
+
+		multicastFwdInfo->unknownMCast = TRUE;
+		if (multicastDataInfo->ipVersion == IP_VERSION4) {
+			multicastFwdInfo->fwdPortMask = rtl_mCastModuleArray[moduleIndex].ipv4UnknownMCastFloodMap;
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else if (multicastDataInfo->ipVersion == IP_VERSION6) {
+			multicastFwdInfo->fwdPortMask = rtl_mCastModuleArray[moduleIndex].ipv6UnknownMCastFloodMap;
+		}
+#endif
+		else {
+			multicastFwdInfo->fwdPortMask = 0xFFFFFFFF;
+		}
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		if ((multicastFwdInfo->fwdPortMask & rtl_mCastModuleArray[moduleIndex].deviceInfo.swPortMask) != 0) {
+			multicastFwdInfo->cpuFlag = TRUE;
+		}
+#endif
+
+		return FAILED;
+	} else {
+		/*step1: handle user specified static reserved multicast entry */
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+		if (groupEntry->attribute == STATIC_RESERVED_MULTICAST) {
+			multicastFwdInfo->unknownMCast = FALSE;
+			multicastFwdInfo->reservedMCast = TRUE;
+			multicastFwdInfo->cpuFlag = TRUE;
+			multicastFwdInfo->fwdPortMask = groupEntry->staticFwdPortMask;
+			multicastFwdInfo->fwdPortMask = (multicastFwdInfo->fwdPortMask | multicastRouterPortMask);
+			return FAILED;
+		}
+#endif
+
+		/*step 2: handle hard-coded reserved multicast address */
+		if ((multicastDataInfo->groupAddr[0] == RESERVE_MULTICAST_ADDR1)
+			|| (multicastDataInfo->groupAddr[0] == RESERVE_MULTICAST_ADDR2)) {
+			multicastFwdInfo->unknownMCast = FALSE;
+			multicastFwdInfo->reservedMCast = TRUE;
+			multicastFwdInfo->fwdPortMask = 0xFFFFFFFF;
+			multicastFwdInfo->cpuFlag = TRUE;
+			return FAILED;
+		}
+#if 0
+		else if (IN_MULTICAST_RESV1(multicastDataInfo->groupAddr[0])) {
+			multicastFwdInfo->unknownMCast = FALSE;
+			multicastFwdInfo->reservedMCast = TRUE;
+			multicastFwdInfo->fwdPortMask = 0xFFFFFFFF;
+			multicastFwdInfo->cpuFlag = TRUE;
+
+			return FAILED;
+		}
+#endif
+
+		/*step3:handle normal multicast address */
+
+		/*here to get multicast router port mask and forward port mask */
+		//multicastRouterPortMask=rtl_getMulticastRouterPortMask(moduleIndex, multicastDataInfo->ipVersion, rtl_sysUpSeconds);
+		multicastFwdInfo->fwdPortMask = rtl_getGroupSourceFwdPortMask(groupEntry,
+			multicastDataInfo->sourceIp, rtl_sysUpSeconds);
+		multicastFwdInfo->fwdPortMask = (multicastFwdInfo->fwdPortMask | multicastRouterPortMask);
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		if ((multicastFwdInfo->fwdPortMask & rtl_mCastModuleArray[moduleIndex].deviceInfo.swPortMask) != 0) {
+			multicastFwdInfo->cpuFlag = TRUE;
+		}
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+		rtl_recordMcastFlow(moduleIndex, multicastDataInfo->ipVersion,
+			multicastDataInfo->sourceIp,
+			multicastDataInfo->groupAddr, multicastFwdInfo);
+#endif
+		return SUCCESS;
+
+	}
+	return FAILED;
+
+}
+
+#if defined(__linux__) && defined(__KERNEL__)
+
+static void rtl_multicastSysTimerExpired(unsigned long expireDada)
+{
+	struct timeval currentTimeVector;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	do_gettimeofday(&currentTimeVector);
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP_CONCURRENT(flags);
+#endif
+	rtl_maintainMulticastSnoopingTimerList((uint32)(currentTimeVector.tv_sec));
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP_CONCURRENT(flags);
+#endif
+	mod_timer(&igmpSysTimer, jiffies + HZ);
+
+}
+
+static void rtl_multicastSysTimerInit(void)
+{
+	struct timeval startTimeVector;
+
+	do_gettimeofday(&startTimeVector);
+	rtl_startTime = (uint32)(startTimeVector.tv_sec);
+	rtl_sysUpSeconds = 0;
+	igmpSysTimer.expires = jiffies + HZ;
+	setup_timer(&igmpSysTimer, rtl_multicastSysTimerExpired,
+			(unsigned long)igmpSysTimer.expires);
+	add_timer(&igmpSysTimer);
+}
+
+static void rtl_multicastSysTimerDestroy(void)
+{
+	del_timer(&igmpSysTimer);
+}
+
+#endif
+
+int32 rtl_getDeviceIgmpSnoopingModuleIndex(rtl_multicastDeviceInfo_t *devInfo,
+	uint32 *moduleIndex)
+{
+	int i;
+
+	*moduleIndex = 0xFFFFFFFF;
+	if (devInfo == NULL) {
+		return FAILED;
+	}
+
+	for (i = 0; i < MAX_MCAST_MODULE_NUM; i++) {
+		if (rtl_mCastModuleArray[i].enableSnooping == TRUE) {
+			if (strcmp(rtl_mCastModuleArray[i].deviceInfo.devName,
+					devInfo->devName) == 0) {
+				*moduleIndex = i;
+				return SUCCESS;
+			}
+		}
+	}
+
+	return FAILED;
+}
+
+int32 rtl865x_getDeviceIgmpSnoopingModuleIndex(rtl_multicastDeviceInfo_t
+	*devInfo, uint32 *moduleIndex)
+{
+	return rtl_getDeviceIgmpSnoopingModuleIndex(devInfo, moduleIndex);
+}
+
+int32 rtl_setIgmpSnoopingModuleDevInfo(uint32 moduleIndex,
+	rtl_multicastDeviceInfo_t *devInfo)
+{
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (devInfo == NULL) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	memcpy(&rtl_mCastModuleArray[moduleIndex].deviceInfo, devInfo,
+		sizeof(rtl_multicastDeviceInfo_t));
+
+	return SUCCESS;
+}
+
+int32 rtl_getIgmpSnoopingModuleDevInfo(uint32 moduleIndex,
+	rtl_multicastDeviceInfo_t *devInfo)
+{
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (devInfo == NULL) {
+		return FAILED;
+	}
+	memset(devInfo, 0, sizeof(rtl_multicastDeviceInfo_t));
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	memcpy(devInfo, &rtl_mCastModuleArray[moduleIndex].deviceInfo,
+		sizeof(rtl_multicastDeviceInfo_t));
+	return SUCCESS;
+}
+
+int32 rtl_setIgmpSnoopingModuleStaticRouterPortMask(uint32 moduleIndex,
+	uint32 staticRouterPortMask)
+{
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	rtl_mCastModuleArray[moduleIndex].staticRouterPortMask = staticRouterPortMask;
+
+	return SUCCESS;
+}
+
+int32 rtl_getgmpSnoopingModuleStaticRouterPortMask(uint32 moduleIndex,
+	uint32 *staticRouterPortMask)
+{
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (staticRouterPortMask == NULL) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	*staticRouterPortMask = rtl_mCastModuleArray[moduleIndex].staticRouterPortMask;
+
+	return SUCCESS;
+}
+
+static int32 rtl_syncAllIpv4UnknownMCastFlow(uint32 moduleIndex)
+{
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+		/*maintain ipv4 group entry  timer */
+		reportEventContext.moduleIndex = moduleIndex;
+		reportEventContext.ipVersion = IP_VERSION4;
+		reportEventContext.groupAddr[0] = 0;
+		reportEventContext.groupAddr[1] = 0;
+		reportEventContext.groupAddr[2] = 0;
+		reportEventContext.groupAddr[3] = 0;
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+		rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+			reportEventContext.ipVersion,
+			reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+#endif
+
+	}
+	return SUCCESS;
+}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+static int32 rtl_syncAllIpv6UnknownMCastFlow(uint32 moduleIndex)
+{
+	reportEventContext.moduleIndex = moduleIndex;
+	reportEventContext.ipVersion = IP_VERSION6;
+	reportEventContext.groupAddr[0] = 0;
+	reportEventContext.groupAddr[1] = 0;
+	reportEventContext.groupAddr[2] = 0;
+	reportEventContext.groupAddr[3] = 0;
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+		rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+			reportEventContext.ipVersion,
+			reportEventContext.groupAddr);
+#endif
+	}
+
+	return SUCCESS;
+}
+#endif
+
+int32 rtl_setIpv4UnknownMCastFloodMap(uint32 moduleIndex,
+	uint32 unknownMCastFloodMap)
+{
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	rtl_mCastModuleArray[moduleIndex].ipv4UnknownMCastFloodMap = unknownMCastFloodMap;
+
+	rtl_syncAllIpv4UnknownMCastFlow(moduleIndex);
+	return SUCCESS;
+}
+
+int32 rtl_getIpv4UnknownMCastFloodMap(uint32 moduleIndex,
+	uint32 *unknownMCastFloodMap)
+{
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (unknownMCastFloodMap == NULL) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	*unknownMCastFloodMap = rtl_mCastModuleArray[moduleIndex].ipv4UnknownMCastFloodMap;
+
+	return SUCCESS;
+}
+
+#ifdef CONFIG_RTL_MLD_SNOOPING
+int32 rtl_setIpv6UnknownMCastFloodMap(uint32 moduleIndex,
+	uint32 unknownMCastFloodMap)
+{
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	rtl_mCastModuleArray[moduleIndex].ipv6UnknownMCastFloodMap = unknownMCastFloodMap;
+
+	rtl_syncAllIpv6UnknownMCastFlow(moduleIndex);
+
+	return SUCCESS;
+}
+
+int32 rtl_getIpv6UnknownMCastFloodMap(uint32 moduleIndex,
+	uint32 *unknownMCastFloodMap)
+{
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (unknownMCastFloodMap == NULL) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	*unknownMCastFloodMap = rtl_mCastModuleArray[moduleIndex].ipv6UnknownMCastFloodMap;
+
+	return SUCCESS;
+}
+#endif
+
+int32 rtl_setIgmpSnoopingModuleUnknownMCastFloodMap(uint32 moduleIndex,
+	uint32 unknownMCastFloodMap)
+{
+	rtl_setIpv4UnknownMCastFloodMap(moduleIndex, unknownMCastFloodMap);
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	rtl_setIpv6UnknownMCastFloodMap(moduleIndex, unknownMCastFloodMap);
+#endif
+	return SUCCESS;
+}
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+static int32 rtl_addStaticGroupEntry(uint32 moduleIndex,
+	struct rtl_groupEntry *groupEntry)
+{
+	struct rtl_groupEntry *existGroupEntry = NULL;
+	struct rtl_groupEntry *newGroupEntry = NULL;
+
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	if (groupEntry == NULL) {
+		return FAILED;
+	}
+
+	if ((groupEntry->ipVersion != IP_VERSION4)
+		&& (groupEntry->ipVersion != IP_VERSION6)) {
+		return FAILED;
+	}
+
+	if (groupEntry->ipVersion == IP_VERSION4) {
+		if ((groupEntry->groupAddr[0] != 0)
+			&& (!IS_CLASSD_ADDR(groupEntry->groupAddr[0]))) {
+			return FAILED;
+		}
+	} else if (groupEntry->ipVersion == IP_VERSION6) {
+		/*need to complete ipv6 address range */
+	}
+
+	/*set unknown multicast default forwarding  configuration */
+	if (groupEntry->ipVersion == IP_VERSION4) {
+		if (groupEntry->groupAddr[0] == 0) {
+			rtl_setIpv4UnknownMCastFloodMap(moduleIndex,
+				groupEntry->staticFwdPortMask);
+			return SUCCESS;
+		}
+	} else if (groupEntry->ipVersion == IP_VERSION6) {
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		if ((groupEntry->groupAddr[0] == 0) &&
+			(groupEntry->groupAddr[0] == 0) &&
+			(groupEntry->groupAddr[0] == 0) &&
+			(groupEntry->groupAddr[0] == 0)) {
+			rtl_setIpv6UnknownMCastFloodMap(moduleIndex,
+				groupEntry->staticFwdPortMask);
+			return SUCCESS;
+		}
+#else
+		return FAILED;
+#endif
+	}
+
+	existGroupEntry = rtl_searchGroupEntry(moduleIndex, groupEntry->ipVersion,
+		groupEntry->groupAddr);
+	if (existGroupEntry != NULL) {
+		existGroupEntry->attribute = STATIC_RESERVED_MULTICAST;
+		existGroupEntry->staticFwdPortMask = groupEntry->staticFwdPortMask;
+	} else {
+
+		newGroupEntry = rtl_allocateGroupEntry();
+
+		if (newGroupEntry == NULL) {
+			rtl_gluePrintf("run out of group entry!\n");
+			return FAILED;
+		}
+
+		assert(newGroupEntry->clientList == NULL);
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		newGroupEntry->groupAddr[0] = groupEntry->groupAddr[0];
+		newGroupEntry->groupAddr[1] = groupEntry->groupAddr[1];
+		newGroupEntry->groupAddr[2] = groupEntry->groupAddr[2];
+		newGroupEntry->groupAddr[3] = groupEntry->groupAddr[3];
+#else
+		newGroupEntry->groupAddr[0] = groupEntry->groupAddr[0];
+#endif
+
+		newGroupEntry->ipVersion = groupEntry->ipVersion;
+		newGroupEntry->attribute = STATIC_RESERVED_MULTICAST;
+		newGroupEntry->staticFwdPortMask = groupEntry->staticFwdPortMask;
+
+		if (groupEntry->ipVersion == IP_VERSION4) {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable);
+		}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		else {
+			rtl_linkGroupEntry(newGroupEntry,
+				rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable);
+		}
+#endif
+	}
+
+	reportEventContext.moduleIndex = moduleIndex;
+	reportEventContext.ipVersion = groupEntry->ipVersion;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	reportEventContext.groupAddr[0] = groupEntry->groupAddr[0];
+	reportEventContext.groupAddr[1] = groupEntry->groupAddr[1];
+	reportEventContext.groupAddr[2] = groupEntry->groupAddr[2];
+	reportEventContext.groupAddr[3] = groupEntry->groupAddr[3];
+#else
+	reportEventContext.groupAddr[0] = groupEntry->groupAddr[0];
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+		reportEventContext.ipVersion, reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+	if (groupEntry->ipVersion == IP_VERSION4) {
+		/*we only support ipv4 hardware multicast */
+		strcpy(reportEventContext.devName,
+			rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+		rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &reportEventContext);
+#endif
+	}
+#endif
+
+	return SUCCESS;
+}
+
+static int32 rtl_delStaticGroupEntry(uint32 moduleIndex,
+	struct rtl_groupEntry *groupEntry)
+{
+	struct rtl_groupEntry *existGroupEntry = NULL;
+
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	if (groupEntry == NULL) {
+		return FAILED;
+	}
+
+	if ((groupEntry->ipVersion != IP_VERSION4)
+		&& (groupEntry->ipVersion != IP_VERSION6)) {
+		return FAILED;
+	}
+
+	if (groupEntry->ipVersion == IP_VERSION4) {
+		if ((groupEntry->groupAddr[0] != 0)
+			&& (!IS_CLASSD_ADDR(groupEntry->groupAddr[0]))) {
+			return FAILED;
+		}
+	} else if (groupEntry->ipVersion == IP_VERSION6) {
+		/*to-do:check ipv6 address range */
+	}
+
+	if (groupEntry->ipVersion == IP_VERSION4) {
+		if (groupEntry->groupAddr[0] == 0) {
+			rtl_mCastModuleArray[moduleIndex].ipv4UnknownMCastFloodMap = DEFAULT_IPV4_UNKNOWN_MCAST_FLOOD_MAP;
+			return SUCCESS;
+		}
+	} else if (groupEntry->ipVersion == IP_VERSION6) {
+		if ((groupEntry->groupAddr[0] == 0) &&
+			(groupEntry->groupAddr[0] == 0) &&
+			(groupEntry->groupAddr[0] == 0) &&
+			(groupEntry->groupAddr[0] == 0)) {
+#ifdef CONFIG_RTL_MLD_SNOOPING
+			rtl_mCastModuleArray[moduleIndex].ipv6UnknownMCastFloodMap = DEFAULT_IPV6_UNKNOWN_MCAST_FLOOD_MAP;
+#endif
+			return SUCCESS;
+		}
+	}
+
+	existGroupEntry = rtl_searchGroupEntry(moduleIndex, groupEntry->ipVersion,
+		groupEntry->groupAddr);
+	if ((existGroupEntry != NULL)
+		&& (existGroupEntry->attribute == STATIC_RESERVED_MULTICAST)) {
+		existGroupEntry->attribute = 0;
+		existGroupEntry->staticFwdPortMask = 0;
+
+		reportEventContext.moduleIndex = moduleIndex;
+		reportEventContext.ipVersion = groupEntry->ipVersion;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+		reportEventContext.groupAddr[0] = groupEntry->groupAddr[0];
+		reportEventContext.groupAddr[1] = groupEntry->groupAddr[1];
+		reportEventContext.groupAddr[2] = groupEntry->groupAddr[2];
+		reportEventContext.groupAddr[3] = groupEntry->groupAddr[3];
+#else
+		reportEventContext.groupAddr[0] = groupEntry->groupAddr[0];
+#endif
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+		rtl_invalidateMCastFlow(reportEventContext.moduleIndex,
+			reportEventContext.ipVersion,
+			reportEventContext.groupAddr);
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		if (groupEntry->ipVersion == IP_VERSION4) {
+			/*we only support ipv4 hardware multicast */
+			strcpy(reportEventContext.devName,
+				rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+			rtl865x_raiseEvent(EVENT_UPDATE_MCAST,
+				&reportEventContext);
+#if defined (CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+			rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST,
+				&reportEventContext);
+#endif
+		}
+#endif
+	}
+
+	return SUCCESS;
+}
+
+int32 rtl_addSpecialMCast(uint32 moduleIndex, uint32 ipVersion,
+	uint32 *groupAddr, uint32 fwdPortMask)
+{
+
+	struct rtl_groupEntry groupEntry;
+
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	if (groupAddr == NULL) {
+		return FAILED;
+	}
+
+	if ((ipVersion != IP_VERSION4) && (ipVersion != IP_VERSION6)) {
+		return FAILED;
+	}
+
+	memset(&groupEntry, 0, sizeof(struct rtl_groupEntry));
+	groupEntry.ipVersion = ipVersion;
+
+	if (ipVersion == IP_VERSION4) {
+		groupEntry.groupAddr[0] = groupAddr[0];
+	} else {
+		groupEntry.groupAddr[0] = groupAddr[0];
+		groupEntry.groupAddr[1] = groupAddr[1];
+		groupEntry.groupAddr[2] = groupAddr[2];
+		groupEntry.groupAddr[3] = groupAddr[3];
+	}
+
+	groupEntry.staticFwdPortMask = fwdPortMask;
+
+	return rtl_addStaticGroupEntry(moduleIndex, &groupEntry);
+}
+
+int32 rtl_delSpecialMCast(uint32 moduleIndex, uint32 ipVersion,
+	uint32 *groupAddr)
+{
+
+	struct rtl_groupEntry groupEntry;
+
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return FAILED;
+	}
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == FALSE) {
+		return FAILED;
+	}
+
+	if ((ipVersion != IP_VERSION4) && (ipVersion != IP_VERSION6)) {
+		return FAILED;
+	}
+
+	memset(&groupEntry, 0, sizeof(struct rtl_groupEntry));
+	groupEntry.ipVersion = ipVersion;
+
+	if (ipVersion == IP_VERSION4) {
+		groupEntry.groupAddr[0] = groupAddr[0];
+	} else {
+		groupEntry.groupAddr[0] = groupAddr[0];
+		groupEntry.groupAddr[1] = groupAddr[1];
+		groupEntry.groupAddr[2] = groupAddr[2];
+		groupEntry.groupAddr[3] = groupAddr[3];
+	}
+
+	return rtl_delStaticGroupEntry(moduleIndex, &groupEntry);
+}
+#endif
+
+int rtl_add_ReservedMCastAddr(uint32 groupAddr, int flag)
+{
+	int ret = FAILED;
+	int i = 0;
+
+	if ((groupAddr & 0xf0000000) != 0xe0000000)
+		goto OUT;
+	for (i = 0; i < MAX_RESERVED_MULTICAST_NUM; i++) {
+		if ((reservedMCastRecord[i].valid == 0)
+			&& (flag == ADD_RESERVED_MULTICAST_FLAG)) {
+			reservedMCastRecord[i].valid = 1;
+			reservedMCastRecord[i].groupAddr = groupAddr;
+			ret = SUCCESS;
+			goto OUT;
+		} else if ((reservedMCastRecord[i].valid == 1)
+			&& (flag == DEL_RESERVED_MULTICAST_FLAG)
+			&& (reservedMCastRecord[i].groupAddr == groupAddr)
+			) {
+			reservedMCastRecord[i].valid = 0;
+			ret = SUCCESS;
+			goto OUT;
+		}
+	}
+
+OUT:
+	return ret;
+}
+
+int rtl_check_ReservedMCastAddr(uint32 groupAddr)
+{
+	int ret = FAILED;
+	int i = 0;
+
+	if ((groupAddr & 0xf0000000) != 0xe0000000)
+		goto OUT;
+	for (i = 0; i < MAX_RESERVED_MULTICAST_NUM; i++) {
+		if ((reservedMCastRecord[i].valid == 1)
+			&& (reservedMCastRecord[i].groupAddr == groupAddr)
+			) {
+			ret = SUCCESS;
+			goto OUT;
+		}
+	}
+
+OUT:
+	return ret;
+}
+
+#ifdef CONFIG_PROC_FS
+int igmp_show(struct seq_file *s, void *v)
+{
+	int32 moduleIndex;
+	int32 hashIndex, groupCnt, clientCnt;
+	struct rtl_groupEntry *groupEntryPtr;
+	struct rtl_clientEntry *clientEntry = NULL;
+	struct rtl_sourceEntry *sourceEntryPtr;
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	int32 flowCnt;
+	struct rtl_mcastFlowEntry *mcastFlowEntry = NULL;
+#endif
+#if defined (CONFIG_RTL_MLD_SNOOPING)
+	int mldVersion;
+#endif
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	for (moduleIndex = 0; moduleIndex < MAX_MCAST_MODULE_NUM; moduleIndex++) {
+		if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+			seq_printf(s, "-------------------------------------------------------------------------\n");
+			seq_printf(s, "module index:%d, ", moduleIndex);
+#ifdef CONFIG_RTL_HARDWARE_MULTICAST
+			seq_printf(s, "device:%s, portMask:0x%x,swPortMask:0x%x ",
+				rtl_mCastModuleArray[moduleIndex].deviceInfo.devName,
+				rtl_mCastModuleArray[moduleIndex].deviceInfo.portMask,
+				rtl_mCastModuleArray[moduleIndex].deviceInfo.swPortMask);
+#endif
+			seq_printf(s, "fastleave:%d ipv4[0x%x]",
+				rtl_mCastModuleArray[moduleIndex].enableFastLeave,
+				rtl_mCastModuleArray[moduleIndex].ipv4UnknownMCastFloodMap);
+#if defined (CONFIG_RTL_MLD_SNOOPING)
+			seq_printf(s, "ipv6[0x%x]\n",
+				rtl_mCastModuleArray[moduleIndex].ipv6UnknownMCastFloodMap);
+#endif
+			seq_printf(s, "\n");
+			seq_printf(s, "igmp list:\n");
+			groupCnt = 0;
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+				for (hashIndex = 0;
+					hashIndex < rtl_hashTableSize;
+					hashIndex++) {
+					groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[hashIndex];
+					while (groupEntryPtr != NULL) {
+						groupCnt++;
+						seq_printf(s, "    [%d] Group address:%d.%d.%d.%d", groupCnt,	//hashIndex
+							groupEntryPtr->groupAddr[0] >> 24,
+							(groupEntryPtr->groupAddr[0] & 0x00ff0000) >> 16,
+							(groupEntryPtr->groupAddr[0] & 0x0000ff00) >> 8,
+							(groupEntryPtr->groupAddr[0] & 0xff));
+
+#if defined(CONFIG_HW_MCAST_DEBUG)
+							seq_printf(s, "\\idx:%d", groupEntryPtr->idx);
+#endif
+
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+						if (groupEntryPtr->attribute == STATIC_RESERVED_MULTICAST)
+						{
+							seq_printf(s, " <static> portMask:0x%x",
+								groupEntryPtr->staticFwdPortMask);
+						}
+#endif
+						seq_printf(s, "\n");
+
+						clientEntry = groupEntryPtr->clientList;
+
+						clientCnt = 0;
+						while (clientEntry != NULL) {
+
+							clientCnt++;
+							seq_printf(s, "        <%d>%d.%d.%d.%d",
+								clientCnt,
+								clientEntry->clientAddr[0] >> 24,
+								(clientEntry->clientAddr[0] & 0x00ff0000) >> 16,
+								(clientEntry->clientAddr[0] & 0x0000ff00) >> 8,
+								clientEntry->clientAddr[0] & 0xff);
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+							seq_printf(s, "(%02X-%02X-%02X-%02X-%02X-%02X)",
+								clientEntry->clientMacAddr[0],
+								clientEntry->clientMacAddr[1],
+								clientEntry->clientMacAddr[2],
+								clientEntry->clientMacAddr[3],
+								clientEntry->clientMacAddr[4],
+								clientEntry->clientMacAddr[5]);
+#endif
+							seq_printf(s, "\\port %d\\IGMPv%d\\",
+								clientEntry->portNum,
+								clientEntry->igmpVersion);
+
+							seq_printf(s, "%s",
+								(clientEntry->groupFilterTimer > rtl_sysUpSeconds) ? "EXCLUDE" : "INCLUDE");
+							if (clientEntry->groupFilterTimer
+								>
+								rtl_sysUpSeconds)
+							{
+								seq_printf(s, ":%ds",
+									clientEntry->groupFilterTimer - rtl_sysUpSeconds);
+							} else {
+								seq_printf(s, ":0s");
+							}
+#if defined(CONFIG_HW_MCAST_DEBUG)
+							seq_printf(s, "\\idx:%d", clientEntry->idx);
+#endif
+							sourceEntryPtr = clientEntry->sourceList;
+							if (sourceEntryPtr != NULL) {
+								seq_printf(s, "\\source list:");
+							}
+
+							while (sourceEntryPtr != NULL) {
+								seq_printf(s, "%d.%d.%d.%d:",
+									sourceEntryPtr->sourceAddr[0] >> 24,
+									(sourceEntryPtr->sourceAddr[0] & 0x00ff0000) >> 16,
+									(sourceEntryPtr->sourceAddr[0] & 0x0000ff00) >> 8,
+									(sourceEntryPtr->sourceAddr[0] & 0xff));
+
+								if (sourceEntryPtr->portTimer > rtl_sysUpSeconds) {
+									seq_printf(s, "%ds",
+										sourceEntryPtr->portTimer - rtl_sysUpSeconds);
+								} else {
+									seq_printf(s, "0s");
+								}
+
+								if (sourceEntryPtr->next != NULL) {
+									seq_printf(s, ", ");
+								}
+
+								sourceEntryPtr = sourceEntryPtr->next;
+							}
+
+							seq_printf(s, "\n");
+							clientEntry = clientEntry->next;
+						}
+
+						seq_printf(s, "\n");
+						groupEntryPtr = groupEntryPtr->next;
+					}
+
+				}
+			}
+			if (groupCnt == 0) {
+				seq_printf(s, "    <empty>\n");
+			}
+#if defined (CONFIG_RTL_MLD_SNOOPING)
+			seq_printf(s, "\n\n");
+			seq_printf(s, "mld list:\n");
+			groupCnt = 0;
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+				for (hashIndex = 0;
+					hashIndex < rtl_hashTableSize;
+					hashIndex++) {
+					groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[hashIndex];
+					while (groupEntryPtr != NULL) {
+						groupCnt++;
+						seq_printf(s, "    [%d] Group address:%x%x%x%x%x%x%x%x-%x%x%x%x%x%x%x%x-%x%x%x%x%x%x%x%x-%x%x%x%x%x%x%x%x",
+							groupCnt,
+							(groupEntryPtr->groupAddr[0]) >> 28,
+							(groupEntryPtr->groupAddr[0] << 4) >> 28,
+							(groupEntryPtr->groupAddr[0] << 8) >> 28,
+							(groupEntryPtr->groupAddr[0] << 12) >> 28,
+							(groupEntryPtr->groupAddr[0] << 16) >> 28,
+							(groupEntryPtr->groupAddr[0] << 20) >> 28,
+							(groupEntryPtr->groupAddr[0] << 24) >> 28,
+							(groupEntryPtr->groupAddr[0] << 28) >> 28,
+							(groupEntryPtr->groupAddr[1]) >> 28,
+							(groupEntryPtr->groupAddr[1] << 4) >> 28,
+							(groupEntryPtr->groupAddr[1] << 8) >> 28,
+							(groupEntryPtr->groupAddr[1] << 12) >> 28,
+							(groupEntryPtr->groupAddr[1] << 16) >> 28,
+							(groupEntryPtr->groupAddr[1] << 20) >> 28,
+							(groupEntryPtr->groupAddr[1] << 24) >> 28,
+							(groupEntryPtr->groupAddr[1] << 28) >> 28,
+							(groupEntryPtr->groupAddr[2]) >> 28,
+							(groupEntryPtr->groupAddr[2] << 4) >> 28,
+							(groupEntryPtr->groupAddr[2] << 8) >> 28,
+							(groupEntryPtr->groupAddr[2] << 12) >> 28,
+							(groupEntryPtr->groupAddr[2] << 16) >> 28,
+							(groupEntryPtr->groupAddr[2] << 20) >> 28,
+							(groupEntryPtr->groupAddr[2] << 24) >> 28,
+							(groupEntryPtr->groupAddr[2] << 28) >> 28,
+							(groupEntryPtr->groupAddr[3]) >> 28,
+							(groupEntryPtr->groupAddr[3] << 4) >> 28,
+							(groupEntryPtr->groupAddr[3] << 8) >> 28,
+							(groupEntryPtr->groupAddr[3] << 12) >> 28,
+							(groupEntryPtr->groupAddr[3] << 16) >> 28,
+							(groupEntryPtr->groupAddr[3] << 20) >> 28,
+							(groupEntryPtr->groupAddr[3] << 24) >> 28,
+							(groupEntryPtr->groupAddr[3] << 28) >> 28);
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+						if (groupEntryPtr->attribute == STATIC_RESERVED_MULTICAST)
+						{
+							seq_printf(s, " <static> portMask:0x%x",
+								groupEntryPtr->staticFwdPortMask);
+						}
+#endif
+						seq_printf(s, "\n");
+						clientEntry = groupEntryPtr->clientList;
+
+						clientCnt = 0;
+						while (clientEntry != NULL) {
+							if (clientEntry->igmpVersion == IGMP_V3) {
+								mldVersion = MLD_V2;
+							} else {
+								mldVersion = MLD_V1;
+							}
+							clientCnt++;
+							seq_printf(s, "        <%d>%x%x%x%x%x%x%x%x-%x%x%x%x%x%x%x%x-%x%x%x%x%x%x%x%x-%x%x%x%x%x%x%x%x",
+								clientCnt,
+								(clientEntry->clientAddr[0]) >> 28,
+								(clientEntry->clientAddr[0] << 4) >> 28,
+								(clientEntry->clientAddr[0] << 8) >> 28,
+								(clientEntry->clientAddr[0] << 12) >> 28,
+								(clientEntry->clientAddr[0] << 16) >> 28,
+								(clientEntry->clientAddr[0] << 20) >> 28,
+								(clientEntry->clientAddr[0] << 24) >> 28,
+								(clientEntry->clientAddr[0] << 28) >> 28,
+								(clientEntry->clientAddr[1]) >> 28,
+								(clientEntry->clientAddr[1] << 4) >> 28,
+								(clientEntry->clientAddr[1] << 8) >> 28,
+								(clientEntry->clientAddr[1] << 12) >> 28,
+								(clientEntry->clientAddr[1] << 16) >> 28,
+								(clientEntry->clientAddr[1] << 20) >> 28,
+								(clientEntry->clientAddr[1] << 24) >> 28,
+								(clientEntry->clientAddr[1] << 28) >> 28,
+								(clientEntry->clientAddr[2]) >> 28,
+								(clientEntry->clientAddr[2] << 4) >> 28,
+								(clientEntry->clientAddr[2] << 8) >> 28,
+								(clientEntry->clientAddr[2] << 12) >> 28,
+								(clientEntry->clientAddr[2] << 16) >> 28,
+								(clientEntry->clientAddr[2] << 20) >> 28,
+								(clientEntry->clientAddr[2] << 24) >> 28,
+								(clientEntry->clientAddr[2] << 28) >> 28,
+								(clientEntry->clientAddr[3]) >> 28,
+								(clientEntry->clientAddr[3] << 4) >> 28,
+								(clientEntry->clientAddr[3] << 8) >> 28,
+								(clientEntry->clientAddr[3] << 12) >> 28,
+								(clientEntry->clientAddr[3] << 16) >> 28,
+								(clientEntry->clientAddr[3] << 20) >> 28,
+								(clientEntry->clientAddr[3] << 24) >> 28,
+								(clientEntry->clientAddr[3] << 28) >> 28);
+#if defined (CONFIG_RTL_IGMPSNOOPING_MAC_BASED) || defined (M2U_DELETE_CHECK)
+							seq_printf(s, "(%02X-%02X-%02X-%02X-%02X-%02X)",
+								clientEntry->clientMacAddr[0],
+								clientEntry->clientMacAddr[1],
+								clientEntry->clientMacAddr[2],
+								clientEntry->clientMacAddr[3],
+								clientEntry->clientMacAddr[4],
+								clientEntry->clientMacAddr[5]);
+#endif
+							seq_printf(s, "\\port %d\\MLDv%d\\",
+								clientEntry->portNum,
+								mldVersion);
+							seq_printf(s, "%s",
+								(clientEntry->groupFilterTimer > rtl_sysUpSeconds) ? "EXCLUDE" : "INCLUDE");
+							if (clientEntry->groupFilterTimer > rtl_sysUpSeconds)
+							{
+								seq_printf(s, ":%ds",
+									clientEntry->groupFilterTimer - rtl_sysUpSeconds);
+							} else {
+								seq_printf(s, ":0s");
+							}
+
+							sourceEntryPtr = clientEntry->sourceList;
+							if (sourceEntryPtr != NULL) {
+								seq_printf(s, "\\source list:");
+							}
+
+							while (sourceEntryPtr != NULL) {
+								seq_printf(s, "%x%x%x%x%x%x%x%x-%x%x%x%x%x%x%x%x-%x%x%x%x%x%x%x%x-%x%x%x%x%x%x%x%x:",
+									(sourceEntryPtr->sourceAddr[0]) >> 28,
+									(sourceEntryPtr->sourceAddr[0] << 4) >> 28,
+									(sourceEntryPtr->sourceAddr[0] << 8) >> 28,
+									(sourceEntryPtr->sourceAddr[0] << 12) >> 28,
+									(sourceEntryPtr->sourceAddr[0] << 16) >> 28,
+									(sourceEntryPtr->sourceAddr[0] << 20) >> 28,
+									(sourceEntryPtr->sourceAddr[0] << 24) >> 28,
+									(sourceEntryPtr->sourceAddr[0] << 28) >> 28,
+									(sourceEntryPtr->sourceAddr[1]) >> 28,
+									(sourceEntryPtr->sourceAddr[1] << 4) >> 28,
+									(sourceEntryPtr->sourceAddr[1] << 8) >> 28,
+									(sourceEntryPtr->sourceAddr[1] << 12) >> 28,
+									(sourceEntryPtr->sourceAddr[1] << 16) >> 28,
+									(sourceEntryPtr->sourceAddr[1] << 20) >> 28,
+									(sourceEntryPtr->sourceAddr[1] << 24) >> 28,
+									(sourceEntryPtr->sourceAddr[1] << 28) >> 28,
+									(sourceEntryPtr->sourceAddr[2]) >> 28,
+									(sourceEntryPtr->sourceAddr[2] << 4) >> 28,
+									(sourceEntryPtr->sourceAddr[2] << 8) >> 28,
+									(sourceEntryPtr->sourceAddr[2] << 12) >> 28,
+									(sourceEntryPtr->sourceAddr[2] << 16) >> 28,
+									(sourceEntryPtr->sourceAddr[2] << 20) >> 28,
+									(sourceEntryPtr->sourceAddr[2] << 24) >> 28,
+									(sourceEntryPtr->sourceAddr[2] << 28) >> 28,
+									(sourceEntryPtr->sourceAddr[3]) >> 28,
+									(sourceEntryPtr->sourceAddr[3] << 4) >> 28,
+									(sourceEntryPtr->sourceAddr[3] << 8) >> 28,
+									(sourceEntryPtr->sourceAddr[3] << 12) >> 28,
+									(sourceEntryPtr->sourceAddr[3] << 16) >> 28,
+									(sourceEntryPtr->sourceAddr[3] << 20) >> 28,
+									(sourceEntryPtr->sourceAddr[3] << 24) >> 28,
+									(sourceEntryPtr->sourceAddr[3] << 28) >> 28);
+
+								if (sourceEntryPtr->portTimer > rtl_sysUpSeconds) {
+									seq_printf(s, "%ds",
+										sourceEntryPtr->portTimer - rtl_sysUpSeconds);
+								} else {
+									seq_printf(s, "0s");
+								}
+
+								if (sourceEntryPtr->next != NULL) {
+									seq_printf(s, ", ");
+								}
+
+								sourceEntryPtr = sourceEntryPtr->next;
+							}
+
+							seq_printf(s, "\n");
+							clientEntry = clientEntry->next;
+						}
+
+						seq_printf(s, "\n");
+						groupEntryPtr = groupEntryPtr->next;
+					}
+
+				}
+			}
+			if (groupCnt == 0) {
+				seq_printf(s, "    <empty>\n");
+			}
+#endif
+#ifdef CONFIG_RECORD_MCAST_FLOW
+
+			if (rtl_mCastModuleArray[moduleIndex].flowHashTable != NULL) {
+				seq_printf(s, "ipv4 flow list:\n");
+				flowCnt = 1;
+				for (hashIndex = 0;
+					hashIndex < rtl_hashTableSize;
+					hashIndex++) {
+
+					/*to dump multicast flow information */
+					mcastFlowEntry = rtl_mCastModuleArray[moduleIndex].flowHashTable[hashIndex];
+
+					while (mcastFlowEntry != NULL) {
+						if (mcastFlowEntry->ipVersion == IP_VERSION4) {
+							seq_printf(s, "    [%d] %d.%d.%d.%d-->",
+								flowCnt,
+								mcastFlowEntry->serverAddr[0] >> 24,
+								(mcastFlowEntry->serverAddr[0] & 0x00ff0000) >> 16,
+								(mcastFlowEntry->serverAddr[0] & 0x0000ff00) >> 8,
+								(mcastFlowEntry->serverAddr[0] & 0xff));
+
+							seq_printf(s,
+								"%d.%d.%d.%d-->",
+								mcastFlowEntry->groupAddr[0] >> 24,
+								(mcastFlowEntry->groupAddr[0] & 0x00ff0000) >> 16,
+								(mcastFlowEntry->groupAddr[0] & 0x0000ff00) >> 8,
+								(mcastFlowEntry->groupAddr[0] & 0xff));
+
+							seq_printf(s, "port mask:0x%x\n",
+								mcastFlowEntry->multicastFwdInfo.fwdPortMask);
+						}
+
+						flowCnt++;
+						mcastFlowEntry = mcastFlowEntry->next;
+					}
+
+				}
+				seq_printf(s, "ipv6 flow list:\n");
+				flowCnt = 1;
+				for (hashIndex = 0;
+					hashIndex < rtl_hashTableSize;
+					hashIndex++) {
+
+					/*to dump multicast flow information */
+					mcastFlowEntry = rtl_mCastModuleArray[moduleIndex].flowHashTable[hashIndex];
+
+					while (mcastFlowEntry != NULL) {
+						if (mcastFlowEntry->ipVersion == IP_VERSION6) {
+							seq_printf(s, "    [%d] %x-%x-%x-%x-->",
+								flowCnt,
+								mcastFlowEntry->serverAddr[0],
+								mcastFlowEntry->serverAddr[1],
+								mcastFlowEntry->serverAddr[2],
+								(mcastFlowEntry->serverAddr[3]);
+							seq_printf(s, "%x-%x-%x-%x-->",
+								mcastFlowEntry->groupAddr[1],
+								mcastFlowEntry->groupAddr[1],
+								mcastFlowEntry->groupAddr[2],
+								mcastFlowEntry->groupAddr[3];
+							seq_printf(s, "port mask:0x%x\n",
+								mcastFlowEntry->multicastFwdInfo.fwdPortMask);}
+
+							flowCnt++;
+							mcastFlowEntry
+								= mcastFlowEntry->next;
+						}
+
+					}
+				}
+#endif
+			}
+		}
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	seq_printf(s, "------------------------------------------------------------------\n");
+	return SUCCESS;
+}
+
+ssize_t igmp_write(struct file *file, const char __user *buffer,
+			size_t count, loff_t *data)
+{
+#if defined (CONFIG_STATIC_RESERVED_MULTICAST)
+	char tmp[256];
+	char *strptr, *cmd_addr;
+	char *tokptr;
+	uint32 allModuleFlag = FALSE;
+	uint32 moduleIndex = 0xFFFFFFFF;
+	uint32 ipAddr[4];
+	int cnt;
+	struct rtl_groupEntry groupEntry;
+
+	if (count < 5)
+		return -EFAULT;
+	if (buffer && !copy_from_user(tmp, buffer, count)) {
+
+		tmp[count] = '\0';
+		strptr = tmp;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+
+		if ((!memcmp(cmd_addr, "add", 3)) ||
+			(!memcmp(cmd_addr, "Add", 3)) ||
+			(!memcmp(cmd_addr, "ADD", 3))) {
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+
+			if ((!memcmp(tokptr, "all", 3)) ||
+				(!memcmp(tokptr, "All", 3)) ||
+				(!memcmp(tokptr, "ALL", 3))) {
+				allModuleFlag = TRUE;
+			} else {
+				allModuleFlag = FALSE;
+				for (moduleIndex = 0;
+					moduleIndex < MAX_MCAST_MODULE_NUM;
+					moduleIndex++) {
+					if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+						if (strcmp(rtl_mCastModuleArray[moduleIndex].deviceInfo.devName, tokptr) == 0) {
+							break;
+						}
+					}
+				}
+
+				if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+					goto errout;
+				}
+			}
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+
+			if ((!memcmp(tokptr, "ipv4", 4)) ||
+				(!memcmp(tokptr, "Ipv4", 4)) ||
+				(!memcmp(tokptr, "IPV4", 4))) {
+				groupEntry.ipVersion = IP_VERSION4;
+			}
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+			else if ((!memcmp(tokptr, "ipv6", 4)) ||
+				(!memcmp(tokptr, "Ipv6", 4)) ||
+				(!memcmp(tokptr, "IPV6", 4))) {
+				groupEntry.ipVersion = IP_VERSION6;
+			}
+#endif
+			else {
+				goto errout;
+			}
+
+			if (groupEntry.ipVersion == IP_VERSION4) {
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+
+				cnt = sscanf(tokptr, "%d.%d.%d.%d",
+						&ipAddr[0], &ipAddr[1],
+						&ipAddr[2], &ipAddr[3]);
+				groupEntry.groupAddr[0] = (ipAddr[0] << 24) | (ipAddr[1] << 16) | (ipAddr[2] << 8) | (ipAddr[3]);
+				groupEntry.groupAddr[1] = 0;
+				groupEntry.groupAddr[2] = 0;
+				groupEntry.groupAddr[3] = 0;
+			}
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+			else if (groupEntry.ipVersion == IP_VERSION6) {
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+
+				cnt = sscanf(tokptr, "0x%x-%x-%x-%x",
+						&ipAddr[0], &ipAddr[1],
+						&ipAddr[2], &ipAddr[3]);
+				groupEntry.groupAddr[0] = ipAddr[0];
+				groupEntry.groupAddr[1] = ipAddr[1];
+				groupEntry.groupAddr[2] = ipAddr[2];
+				groupEntry.groupAddr[3] = ipAddr[3];
+			}
+#endif
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+
+			groupEntry.staticFwdPortMask = simple_strtol(tokptr, NULL, 0);
+			if (allModuleFlag == TRUE) {
+				for (moduleIndex = 0;
+					moduleIndex < MAX_MCAST_MODULE_NUM;
+					moduleIndex++) {
+					if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+						rtl_addStaticGroupEntry(moduleIndex, &groupEntry);
+					}
+				}
+
+			}
+			else
+			{
+				rtl_addStaticGroupEntry(moduleIndex,
+					&groupEntry);
+			}
+
+		}
+		else if ((!memcmp(cmd_addr, "del", 3)) ||
+			(!memcmp(cmd_addr, "Del", 3)) ||
+			(!memcmp(cmd_addr, "DEL", 3))) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+
+			if ((!memcmp(tokptr, "all", 3)) ||
+				(!memcmp(tokptr, "All", 3)) ||
+				(!memcmp(tokptr, "ALL", 3))) {
+				allModuleFlag = TRUE;
+			} else {
+				allModuleFlag = FALSE;
+				for (moduleIndex = 0;
+					moduleIndex < MAX_MCAST_MODULE_NUM;
+					moduleIndex++) {
+					if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+						if (strcmp(rtl_mCastModuleArray[moduleIndex].deviceInfo.devName, tokptr) == 0) {
+							break;
+						}
+					}
+				}
+
+				if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+					goto errout;
+				}
+			}
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+
+			if ((!memcmp(tokptr, "ipv4", 4)) ||
+				(!memcmp(tokptr, "Ipv4", 4)) ||
+				(!memcmp(tokptr, "IPV4", 4))) {
+				groupEntry.ipVersion = IP_VERSION4;
+			}
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+			else if ((!memcmp(tokptr, "ipv6", 4)) ||
+				(!memcmp(tokptr, "Ipv6", 4)) ||
+				(!memcmp(tokptr, "IPV6", 4))) {
+				groupEntry.ipVersion = IP_VERSION6;
+			}
+#endif
+			else {
+				goto errout;
+			}
+
+			if (groupEntry.ipVersion == IP_VERSION4) {
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+				cnt = sscanf(tokptr, "%d.%d.%d.%d",
+						&ipAddr[0], &ipAddr[1],
+						&ipAddr[2], &ipAddr[3]);
+				groupEntry.groupAddr[0] = (ipAddr[0] << 24) | (ipAddr[1] << 16) | (ipAddr[2] << 8) | (ipAddr[3]);
+				groupEntry.groupAddr[1] = 0;
+				groupEntry.groupAddr[2] = 0;
+				groupEntry.groupAddr[3] = 0;
+			}
+
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+			else if (groupEntry.ipVersion == IP_VERSION6) {
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+				cnt = sscanf(tokptr, "0x%x-%x-%x-%x", &ipAddr[0],
+						&ipAddr[1], &ipAddr[2], &ipAddr[3]);
+				groupEntry.groupAddr[0] = ipAddr[0];
+				groupEntry.groupAddr[1] = ipAddr[1];
+				groupEntry.groupAddr[2] = ipAddr[2];
+				groupEntry.groupAddr[3] = ipAddr[3];}
+#endif
+
+			if (allModuleFlag == TRUE) {
+				for (moduleIndex = 0;
+					moduleIndex < MAX_MCAST_MODULE_NUM;
+					moduleIndex++) {
+					if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+					rtl_delStaticGroupEntry(moduleIndex, &groupEntry);}
+				}
+
+			} else {
+				rtl_delStaticGroupEntry(moduleIndex, &groupEntry);
+			}
+
+		} else if ((!memcmp(cmd_addr, "flush", 4)) ||
+			(!memcmp(cmd_addr, "Flush", 4)) ||
+			(!memcmp(cmd_addr, "FLUSH", 4))) {
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+			rtl_flushAllIgmpRecord(FLUSH_IGMP_RECORD | FLUSH_MLD_RECORD);
+#else
+			rtl_flushAllIgmpRecord(FLUSH_IGMP_RECORD);
+#endif
+		}
+		else
+		{
+errout:
+			printk("error input!\n");}
+
+		}
+#endif
+	return count;
+}
+#endif
+
+#if defined (CONFIG_RT_MULTIPLE_BR_SUPPORT)
+int rtl_get_brIgmpModuleIndexbyId(int idx, char *name);
+#endif
+void rtl865x_igmpLinkStatusChangeCallback(uint32 moduleIndex, rtl_igmpPortInfo_t * portInfo)
+{
+	int32 hashIndex;
+	int32 clearFlag=FALSE;
+	struct rtl_groupEntry *groupEntryPtr, *brGroupEntryPtr = NULL;
+	struct rtl_clientEntry* clientEntry=NULL, *brClientEntryPtr = NULL;
+	struct rtl_clientEntry* nextClientEntry=NULL;
+	#ifdef CONFIG_RECORD_MCAST_FLOW
+	struct rtl_mcastFlowEntry *mcastFlowEntry, *nextMcastFlowEntry;
+	#endif
+
+	uint32 groupAddress[4] = {0};
+	uint32 clientAddress[4] = {0};
+
+	#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	struct rtl_groupEntry *brGroupEntryPtr_2 = NULL;
+	struct rtl_clientEntry *brClientEntryPtr_2 = NULL;
+	#endif
+
+	#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+	int br_index = 0;
+	unsigned char br_name[16] = {0};
+	unsigned int igmpModuleIndex = 0xFFFFFFFF;
+	#endif
+
+	if (portInfo == NULL) {
+		return ;
+	}
+
+	if (moduleIndex >= MAX_MCAST_MODULE_NUM) {
+		return ;
+	}
+
+#ifdef CONFIG_RECORD_MCAST_FLOW
+	if (rtl_mCastModuleArray[moduleIndex].flowHashTable != NULL) {
+		for(hashIndex=0;hashIndex<rtl_hashTableSize;hashIndex++) {
+
+			mcastFlowEntry = rtl_mCastModuleArray[moduleIndex].flowHashTable[hashIndex];
+
+			while (mcastFlowEntry != NULL) {
+				nextMcastFlowEntry = mcastFlowEntry->next;
+
+				/*clear multicast forward flow cache*/
+				rtl_deleteMcastFlowEntry( mcastFlowEntry, rtl_mCastModuleArray[moduleIndex].flowHashTable);
+
+				mcastFlowEntry = nextMcastFlowEntry;
+			}
+
+		}
+	}
+#endif
+
+
+	if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+
+		if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL) {
+			for (hashIndex=0;hashIndex<rtl_hashTableSize;hashIndex++) {
+				groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[hashIndex];
+				while (groupEntryPtr != NULL) {
+					clientEntry = groupEntryPtr->clientList;
+					while (clientEntry!=NULL) {
+						/*save next client entry first*/
+						nextClientEntry = clientEntry->next;
+						if (((1<<clientEntry->portNum) & portInfo->linkPortMask) == 0) {
+							groupAddress[0] = groupEntryPtr->groupAddr[0];
+							clientAddress[0] = clientEntry->clientAddr[0];
+							//this client will be deleted, the portNum is meanlingless
+						#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+							for (br_index = 0; br_index < RTL_IMGP_MAX_BRMODULE; br_index++) {
+								igmpModuleIndex = rtl_get_brIgmpModuleIndexbyId(br_index,br_name);
+								if (igmpModuleIndex != 0xFFFFFFFF) {
+									brGroupEntryPtr = rtl_searchGroupEntry(igmpModuleIndex, 4, groupAddress);
+									if (brGroupEntryPtr != NULL) {
+										brClientEntryPtr = rtl_searchClientEntry(4,brGroupEntryPtr,MAX_SUPPORT_PORT_NUMBER,clientAddress);
+										if (brClientEntryPtr != NULL)
+											rtl_deleteClientEntry(brGroupEntryPtr,brClientEntryPtr);
+									}
+								}
+							}
+						#else
+							brGroupEntryPtr = rtl_searchGroupEntry(brIgmpModuleIndex, 4, groupAddress);
+
+							#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+							brGroupEntryPtr_2 = rtl_searchGroupEntry(brIgmpModuleIndex_2, 4, groupAddress);;
+							#endif
+							if (brGroupEntryPtr != NULL) {
+								brClientEntryPtr = rtl_searchClientEntry(4,brGroupEntryPtr,MAX_SUPPORT_PORT_NUMBER,clientAddress);
+								if(brClientEntryPtr != NULL)
+									rtl_deleteClientEntry(brGroupEntryPtr,brClientEntryPtr);
+							}
+							#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+							if (brGroupEntryPtr_2 != NULL) {
+								brClientEntryPtr_2 = rtl_searchClientEntry(4,brGroupEntryPtr_2,MAX_SUPPORT_PORT_NUMBER,clientAddress);
+								if(brClientEntryPtr_2 != NULL)
+									rtl_deleteClientEntry(brGroupEntryPtr,brClientEntryPtr);
+							}
+							#endif
+						#endif
+							rtl_deleteClientEntry(groupEntryPtr, clientEntry);
+							clearFlag = TRUE;
+						}
+
+
+						clientEntry = nextClientEntry;
+					}
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+					if (clearFlag == TRUE) {
+#if defined(CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+					linkEventContext.ipVersion = 4;
+#endif
+						strcpy(linkEventContext.devName, rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+						linkEventContext.moduleIndex=moduleIndex;
+
+						linkEventContext.groupAddr[0] = groupEntryPtr->groupAddr[0];
+						linkEventContext.groupAddr[1] = groupEntryPtr->groupAddr[1];
+						linkEventContext.groupAddr[2] = groupEntryPtr->groupAddr[2];
+						linkEventContext.groupAddr[3] = groupEntryPtr->groupAddr[3];
+
+						linkEventContext.sourceAddr[0] = 0;
+						linkEventContext.sourceAddr[1] = 0;
+						linkEventContext.sourceAddr[2] = 0;
+						linkEventContext.sourceAddr[3] = 0;
+
+						rtl865x_raiseEvent(EVENT_UPDATE_MCAST, &linkEventContext);
+#if defined(CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+					rtl865x_raiseEvent(EVENT_UPDATE_L2_MCAST, &linkEventContext);
+#endif
+					}
+#endif
+					groupEntryPtr = groupEntryPtr->next;
+				}
+
+			}
+		}
+#if defined (CONFIG_RTL_MLD_SNOOPING)
+		if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL) {
+			for (hashIndex=0;hashIndex<rtl_hashTableSize;hashIndex++) {
+				groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[hashIndex];
+				while (groupEntryPtr != NULL) {
+					clientEntry = groupEntryPtr->clientList;
+					while (clientEntry != NULL) {
+						/*save next client entry first*/
+						nextClientEntry=clientEntry->next;
+						if (((1<<clientEntry->portNum) & portInfo->linkPortMask) == 0) {
+							//this client will be deleted, the portNum is meanlingless
+								groupAddress[0] = groupEntryPtr->groupAddr[0];
+								groupAddress[1] = groupEntryPtr->groupAddr[1];
+								groupAddress[2] = groupEntryPtr->groupAddr[2];
+								groupAddress[3] = groupEntryPtr->groupAddr[3];
+								clientAddress[0] = clientEntry->clientAddr[0];
+								clientAddress[1] = clientEntry->clientAddr[1];
+								clientAddress[2] = clientEntry->clientAddr[2];
+								clientAddress[3] = clientEntry->clientAddr[3];
+								//this client will be deleted, the portNum is meanlingless
+						#if defined (CONFIG_RT_MULTIPLE_BR_SUPPORT)
+								for(br_index = 0; br_index < RTL_IMGP_MAX_BRMODULE; br_index++) {
+									igmpModuleIndex = rtl_get_brIgmpModuleIndexbyId(br_index,br_name);
+									if (igmpModuleIndex != 0xFFFFFFFF) {
+										brGroupEntryPtr = rtl_searchGroupEntry(igmpModuleIndex, 6, groupAddress);
+										if (brGroupEntryPtr != NULL) {
+											brClientEntryPtr = rtl_searchClientEntry(6,brGroupEntryPtr,MAX_SUPPORT_PORT_NUMBER,clientAddress);
+											if(brClientEntryPtr != NULL)
+												rtl_deleteClientEntry(brGroupEntryPtr,brClientEntryPtr);
+										}
+									}
+								}
+						#else
+								brGroupEntryPtr = rtl_searchGroupEntry(brIgmpModuleIndex, 6, groupAddress);
+
+								if (brGroupEntryPtr != NULL) {
+									brClientEntryPtr = rtl_searchClientEntry(6,brGroupEntryPtr,MAX_SUPPORT_PORT_NUMBER,clientAddress);
+									if(brClientEntryPtr != NULL)
+										rtl_deleteClientEntry(brGroupEntryPtr,brClientEntryPtr);
+								}
+						#endif
+
+
+							rtl_deleteClientEntry(groupEntryPtr, clientEntry);
+							#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+							clearFlag = TRUE;
+							#endif
+						}
+
+						clientEntry = nextClientEntry;
+					}
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+#if defined (CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+					if (clearFlag == TRUE) {
+						strcpy(linkEventContext.devName, rtl_mCastModuleArray[moduleIndex].deviceInfo.devName);
+						linkEventContext.moduleIndex = moduleIndex;
+
+						linkEventContext.groupAddr[0] = groupEntryPtr->groupAddr[0];
+						linkEventContext.groupAddr[1] = groupEntryPtr->groupAddr[1];
+						linkEventContext.groupAddr[2] = groupEntryPtr->groupAddr[2];
+						linkEventContext.groupAddr[3] = groupEntryPtr->groupAddr[3];
+
+						linkEventContext.sourceAddr[0] = 0;
+						linkEventContext.sourceAddr[1] = 0;
+						linkEventContext.sourceAddr[2] = 0;
+						linkEventContext.sourceAddr[3] = 0;
+
+						rtl865x_raiseEvent(EVENT_UPDATE_MCAST6, &linkEventContext);
+					}
+#endif
+#endif
+					groupEntryPtr = groupEntryPtr->next;
+				}
+			}
+		}
+#endif
+
+	}
+
+
+
+	return;
+}
+
+
+int32 rtl_getGroupInfo(uint32 groupAddr, struct rtl_groupInfo * groupInfo)
+{
+	int32 moduleIndex;
+	int32 hashIndex;
+	struct rtl_groupEntry *groupEntryPtr;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	if (groupInfo == NULL) {
+		return FAILED;
+	}
+
+	memset(groupInfo, 0 , sizeof(struct rtl_groupInfo));
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	for (moduleIndex  =0; moduleIndex < MAX_MCAST_MODULE_NUM; moduleIndex++) {
+		if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+			hashIndex = rtl_hashMask&groupAddr;
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable != NULL)
+				groupEntryPtr = rtl_mCastModuleArray[moduleIndex].rtl_ipv4HashTable[hashIndex];
+			else
+				groupEntryPtr = NULL;
+
+			while (groupEntryPtr != NULL) {
+				if (groupEntryPtr->groupAddr[0] == groupAddr) {
+					groupInfo->ownerMask |= (1<<moduleIndex);
+					break;
+				}
+				groupEntryPtr = groupEntryPtr->next;
+			}
+
+		}
+	}
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	return SUCCESS;
+}
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+int32 rtl_getGroupInfov6(uint32 * groupAddr,struct rtl_groupInfo * groupInfo)
+{
+	int32 moduleIndex;
+	int32 hashIndex;
+	struct rtl_groupEntry *groupEntryPtr;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	if (groupAddr==NULL || groupInfo==NULL) {
+		return FAILED;
+	}
+
+	memset(groupInfo, 0 , sizeof(struct rtl_groupInfo));
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+
+	for (moduleIndex = 0; moduleIndex < MAX_MCAST_MODULE_NUM ; moduleIndex++) {
+		if (rtl_mCastModuleArray[moduleIndex].enableSnooping == TRUE) {
+			hashIndex = rtl_hashMask&groupAddr[3];
+			if (rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable != NULL)
+				groupEntryPtr=rtl_mCastModuleArray[moduleIndex].rtl_ipv6HashTable[hashIndex];
+			else
+				groupEntryPtr = NULL;
+
+			while (groupEntryPtr != NULL) {
+				if (groupEntryPtr->groupAddr[0] == groupAddr[0] &&
+					groupEntryPtr->groupAddr[1] == groupAddr[1] &&
+					groupEntryPtr->groupAddr[2] == groupAddr[2] &&
+					groupEntryPtr->groupAddr[3] == groupAddr[3]) {
+					groupInfo->ownerMask |= (1<<moduleIndex);
+					break;
+				}
+				groupEntryPtr = groupEntryPtr->next;
+			}
+
+		}
+	}
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+
+	return SUCCESS;
+}
+
+#endif
+
+#ifdef M2U_DELETE_CHECK
+int FindClientforM2U(unsigned int moduleindex, unsigned char *dMac, unsigned char *sMac)
+{
+	int32 hashIndex;
+	struct rtl_groupEntry *groupEntryPtr = NULL;
+	struct rtl_clientEntry* clientEntryPtr = NULL;
+	unsigned int groupip[4] = {0, 0, 0, 0};
+	int ret = 0;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+	#if 0
+	printk("dst = %X:%X:%X:%X:%X:%X, src = %X:%X:%X:%X:%X:%X, [%s:%d]\n",
+		dMac[0], dMac[1], dMac[2], dMac[3], dMac[4], dMac[5],
+		sMac[0], sMac[1], sMac[2], sMac[3], sMac[4], sMac[5],
+		__FUNCTION__, __LINE__);
+	#endif
+#if defined(CONFIG_SMP)
+	SMP_LOCK_IGMP(flags);
+#endif
+	if (dMac[0] == 0x01 && dMac[1] == 0x00 && dMac[2] == 0x5e) {
+		if (rtl_mCastModuleArray[moduleindex].enableSnooping == TRUE) {
+			if (rtl_mCastModuleArray[moduleindex].rtl_ipv4HashTable != NULL) {
+				for (hashIndex = 0; hashIndex < rtl_hashTableSize; ++hashIndex) {
+					groupEntryPtr = rtl_mCastModuleArray[moduleindex].rtl_ipv4HashTable[hashIndex];
+					while (groupEntryPtr != NULL) {
+						memcpy(groupip, groupEntryPtr->groupAddr, 4);
+
+						#if 0
+						printk("groupip = %X:%X:%X:%X, [%s:%d]\n",
+							groupip[0], groupip[1], groupip[2], groupip[3], __FUNCTION__, __LINE__);
+
+						#endif
+						if((dMac[3] == (unsigned char)((groupip[0] >> 16) & 0xFF)) &&
+							(dMac[4] == (unsigned char)((groupip[0] >> 8) & 0xFF)) &&
+							(dMac[5] == (unsigned char)(groupip[0] & 0xFF))) {
+
+							clientEntryPtr = groupEntryPtr->clientList;
+							while (clientEntryPtr != NULL) {
+								if((sMac[0] == clientEntryPtr->clientMacAddr[0]) &&
+									(sMac[1] == clientEntryPtr->clientMacAddr[1]) &&
+									(sMac[2] == clientEntryPtr->clientMacAddr[2]) &&
+									(sMac[3] == clientEntryPtr->clientMacAddr[3]) &&
+									(sMac[4] == clientEntryPtr->clientMacAddr[4]) &&
+									(sMac[5] == clientEntryPtr->clientMacAddr[5])) {
+									ret = 1;
+									break;
+								}
+								clientEntryPtr = clientEntryPtr->next;
+							}
+
+							/*client found*/
+							if (clientEntryPtr) {
+								break;
+							}
+						}
+						groupEntryPtr = groupEntryPtr->next;
+					}
+					if (groupEntryPtr) {
+						break;
+					}
+				}
+			}
+		}
+	}
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	else if (dMac[0] == 0x33 && dMac[1] == 0x33 && dMac[2] != 0x0f) {
+		if (rtl_mCastModuleArray[moduleindex].enableSnooping == TRUE) {
+			if(rtl_mCastModuleArray[moduleindex].rtl_ipv6HashTable != NULL) {
+				for (hashIndex = 0; hashIndex < rtl_hashTableSize; ++hashIndex) {
+					groupEntryPtr = rtl_mCastModuleArray[moduleindex].rtl_ipv6HashTable[hashIndex];
+					while (groupEntryPtr != NULL) {
+						memcpy(groupip, groupEntryPtr->groupAddr, 16);
+						if ((dMac[2] == (unsigned char)((groupip[3]>>24)&0xFF)) &&
+							(dMac[3] == (unsigned char)((groupip[3]>>16)&0xFF)) &&
+							(dMac[4] == (unsigned char)((groupip[3]>>8)&0xFF)) &&
+							(dMac[5] == (unsigned char)(groupip[3]&0xFF))) {
+							clientEntryPtr = groupEntryPtr->clientList;
+							while (clientEntryPtr != NULL) {
+								if ((sMac[0] == clientEntryPtr->clientMacAddr[0]) &&
+									(sMac[1] == clientEntryPtr->clientMacAddr[1]) &&
+									(sMac[2] == clientEntryPtr->clientMacAddr[2]) &&
+									(sMac[3] == clientEntryPtr->clientMacAddr[3]) &&
+									(sMac[4] == clientEntryPtr->clientMacAddr[4]) &&
+									(sMac[5] == clientEntryPtr->clientMacAddr[5])) {
+									ret = 1;
+									break;
+								}
+								clientEntryPtr = clientEntryPtr->next;
+							}
+
+							/*client found*/
+							if (clientEntryPtr)
+								break;
+						}
+						groupEntryPtr = groupEntryPtr->next;
+					}
+					if (groupEntryPtr)
+						break;
+				}
+			}
+		}
+	}
+#endif
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_IGMP(flags);
+#endif
+	return ret;
+}
+
+int rtl_M2UDeletecheck(unsigned char *dMac, unsigned char *sMac)
+{
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+	int i = 0;
+	unsigned char br_name[16] = {0};
+	unsigned int igmpModuleIndex = 0xFFFFFFFF;
+
+	for (i = 0; i < RTL_IMGP_MAX_BRMODULE; i++) {
+		igmpModuleIndex = rtl_get_brIgmpModuleIndexbyId(i,br_name);
+		if (igmpModuleIndex != 0xFFFFFFFF && FindClientforM2U(igmpModuleIndex, dMac, sMac))
+			return 0;
+	}
+#else
+	if (brIgmpModuleIndex != 0xFFFFFFFF && FindClientforM2U(brIgmpModuleIndex, dMac, sMac))
+		return 0;
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if (brIgmpModuleIndex_2 != 0xFFFFFFFF && FindClientforM2U(brIgmpModuleIndex_2, dMac, sMac))
+		return 0;
+#endif
+#endif
+	return 1;
+}
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/Makefile b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/Makefile
new file mode 100644
index 00000000..011501a
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/Makefile
@@ -0,0 +1,55 @@
+#
+# Makefile for the Tulip ethernet driver
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definitions are now in the main makefile...
+#Add mips16 Support
+
+DIR_RTLASIC = $(srctree)/drivers/soc/realtek/rtd129x/hw_nat/
+
+ifdef CONFIG_RTL865X_KERNEL_MIPS16_LAYERDRIVER
+	CFLAGS_rtl865x_fdb.o		= -mips16
+	#CFLAGS_rtl865x_outputQueue.o 	= -mips16
+endif
+
+	ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+		obj-y := rtl865x_fdb.o
+		ifdef CONFIG_RTL_HW_QOS_SUPPORT
+			obj-y += rtl865x_outputQueue.o
+		endif
+	endif
+
+ifeq ($(CONFIG_OPENWRT_SDK),y)
+else
+	obj-y += rtl865x_hw_qos_config.o
+endif
+
+ifeq ($(CONFIG_RTL_STP),y)
+	obj-y += rtl865x_stp.o
+endif
+ifeq ($(CONFIG_RTL_HW_STP),y)
+	obj-y += rtl865x_stp.o
+endif
+
+EXTRA_CFLAGS += -O1 -DRTL_TBLDRV -D__linux__ -DRTL865X_OVER_KERNEL -DRTL865X_OVER_LINUX -Werror
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/AsicDriver
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/l2Driver
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/common
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/cle
+EXTRA_CFLAGS += -I$(DIR_RTLASIC)
+
+ifeq ($(CONFIG_RTL865X_MODULE_ROMEDRV),y)
+	EXTRA_CFLAGS += -D__KERNEL__
+	EXTRA_CFLAGS += -G 0
+	EXTRA_CFLAGS += -DMODULE
+	EXTRA_CFLAGS += -mlong-calls
+	EXTRA_CFLAGS += -DEXPORT_SYMTAB
+	EXTRA_CFLAGS += -DCONFIG_RTL865X_MODULE_INTERNAL
+#	EXTRA_CFLAGS += -DMODVERSIONS
+#	EXTRA_CFLAGS += -include $(srctree)/include/linux/modversions.h
+endif
+
+EXTRA_AFLAGS += $(EXTRA_CFLAGS)
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_fdb.c b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_fdb.c
new file mode 100644
index 00000000..6df1130
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_fdb.c
@@ -0,0 +1,2628 @@
+/*
+ *
+ *  Copyright (c) 2011 Realtek Semiconductor Corp.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 2 as
+ *  published by the Free Software Foundation.
+ */
+
+
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,2,0)
+#include <linux/kconfig.h>
+#else
+#include <linux/config.h>
+#endif
+#include <linux/module.h>
+#include <linux/kernel.h>
+
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include <net/rtl/rtl865x_fdb_api.h>
+#include "AsicDriver/asicRegs.h"
+//#include <common/rtl8651_aclLocal.h>
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+//#include <net/rtl/rtl_queue.h>
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#else
+#include <AsicDriver/rtl865xC_tblAsicDrv.h>
+#include <AsicDriver/rtl8651_tblAsicDrv.h>
+#include "rtl8651_tblDrvPatch.h"
+#endif
+
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl865x_eventMgr.h"
+#include "common/mbuf.h"
+#include "rtl865x_fdb.h"
+#include "common/rtl_errno.h"
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+extern unsigned int RTL_LANPORT_MASK;
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL865X_LANPORT_RESTRICTION)
+lan_restrict_info	lan_restrict_tbl[LAN_RESTRICT_PORT_NUMBER];
+int lan_restrict_tble_reset_port(int port)
+{
+	#if 0	//disable by jwj
+	lan_restrict_tbl[port].curr_num	= 	0;
+	#endif
+	return SUCCESS;
+}
+
+#endif
+
+struct rtl865x_L2Tables sw_FDB_Table;
+int32    arpAgingTime = 450;
+ether_addr_t cpu_mac = { {0x00, 0x00, 0x0a, 0x00, 0x00, 0x0f} };
+rtl865x_tblAsicDrv_l2Param_t tmpL2buff;
+
+#if defined(CONFIG_RTL_HARDWARE_NAT) //&&defined(REINIT_SWITCH_CORE)
+#define L2_BAKUP_ENTRY_MAX 128
+rtl865x_tblAsicDrv_l2Param_t l2_entry_bak[L2_BAKUP_ENTRY_MAX];
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
+static RTL_DECLARE_MUTEX(l2_sem);
+#endif
+int32 _rtl865x_fdb_alloc(void)
+{
+	int32 index = 0;
+	memset( &sw_FDB_Table, 0, sizeof( sw_FDB_Table ) );
+	#ifdef __KERNEL__
+	TBL_MEM_ALLOC(sw_FDB_Table.filterDB, rtl865x_filterDbTable_t, RTL865x_FDB_NUMBER);
+	#else
+	sw_FDB_Table.filterDB = (rtl865x_filterDbTable_t *)malloc(RTL865x_FDB_NUMBER * sizeof(rtl865x_filterDbTable_t));
+	#endif
+	{//Initial free filter database entry
+		rtl865x_filterDbTableEntry_t * tempFilterDb = NULL;
+		#ifdef __KERNEL__
+			TBL_MEM_ALLOC(tempFilterDb, rtl865x_filterDbTableEntry_t, RTL8651_L2TBL_ROW);
+		#else
+		#endif
+		SLIST_INIT(&sw_FDB_Table.freefdbList.filterDBentry);
+		for(index=0; index<RTL8651_L2TBL_ROW; index++)
+			SLIST_INSERT_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, &tempFilterDb[index], nextFDB);
+	}
+
+	return SUCCESS;
+
+}
+
+int32 rtl865x_getReserveMacAddr(ether_addr_t *macAddr)
+{
+	memcpy( macAddr, &cpu_mac, sizeof(ether_addr_t));
+	return SUCCESS;
+}
+
+int32 _rtl865x_layer2_patch(void)
+{
+
+	int32 retval = 0;
+	ether_addr_t mac = { {0xff, 0xff, 0xff, 0xff, 0xff, 0xff} };
+	uint32 portmask=RTL_WANPORT_MASK|RTL_LANPORT_MASK;
+
+	retval = _rtl865x_addFilterDatabaseEntry(RTL865x_L2_TYPEII, RTL_LAN_FID, &mac, FDB_TYPE_TRAPCPU, portmask, TRUE, FALSE);
+#if defined (CONFIG_RTL_IVL_SUPPORT)
+	retval = _rtl865x_addFilterDatabaseEntry(RTL865x_L2_TYPEII, RTL_WAN_FID, &mac, FDB_TYPE_TRAPCPU, portmask, TRUE, FALSE);
+#endif
+
+	retval = _rtl865x_addFilterDatabaseEntry(RTL865x_L2_TYPEII, RTL_LAN_FID, &cpu_mac, FDB_TYPE_TRAPCPU, 0, TRUE, FALSE);
+#if defined (CONFIG_RTL_IVL_SUPPORT)
+	retval = _rtl865x_addFilterDatabaseEntry(RTL865x_L2_TYPEII, RTL_WAN_FID, &cpu_mac, FDB_TYPE_TRAPCPU, 0, TRUE, FALSE);
+#endif
+	assert(retval == SUCCESS);
+
+	return SUCCESS;
+}
+
+int32 _rtl865x_fdb_collect(void)
+{
+	int32 index = 0;
+	int32 index1 = 0;
+
+	rtl865x_filterDbTable_t *filterDbPtr;
+	rtl865x_filterDbTableEntry_t * tempFilterDbPtr;
+	for(index=0,filterDbPtr=&sw_FDB_Table.filterDB[0]; index<RTL865x_FDB_NUMBER; index++,filterDbPtr++) {
+		for(index1=0; index1<RTL8651_L2TBL_ROW; index1++)
+			while(SLIST_FIRST(&(filterDbPtr->database[index1]))) {
+				tempFilterDbPtr = SLIST_FIRST(&(filterDbPtr->database[index1]));
+				SLIST_REMOVE_HEAD(&(filterDbPtr->database[index1]), nextFDB);
+				SLIST_INSERT_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, tempFilterDbPtr, nextFDB);
+			}
+	}
+
+	return SUCCESS;
+
+}
+
+int32 _rtl865x_fdb_init(void)
+{
+	int32 index, index1;
+	/*Initial Filter database*/
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[0];
+	for(index=0; index<RTL865x_FDB_NUMBER; index++, fdb_t++) {
+		for(index1=0; index1<RTL8651_L2TBL_ROW; index1++)
+			SLIST_INIT(&(fdb_t->database[index1]));
+		fdb_t->valid = 1;
+	}
+
+	return SUCCESS;
+}
+
+int32 _rtl865x_clearHWL2Table(void)
+{
+	int i, j;
+
+	for (i = 0; i < RTL8651_L2TBL_ROW; i++)
+		for (j = 0; j < RTL8651_L2TBL_COLUMN; j++)
+		{
+			rtl8651_delAsicL2Table(i, j);
+		}
+
+	return SUCCESS;
+}
+
+int32 rtl865x_layer2_init(void)
+{
+
+	_rtl865x_fdb_alloc();
+
+	_rtl865x_fdb_init();
+
+	_rtl865x_layer2_patch();
+
+	return SUCCESS;
+}
+
+int32 rtl865x_layer2_reinit(void)
+{
+	_rtl865x_clearHWL2Table();
+
+	_rtl865x_fdb_collect();
+
+	//_rtl865x_fdb_alloc();
+
+	_rtl865x_fdb_init();
+
+	_rtl865x_layer2_patch();
+
+	return SUCCESS;
+}
+
+ uint32 rtl865x_getHWL2Index(ether_addr_t * macAddr, uint16 fid)
+ {
+	return (rtl8651_filterDbIndex(macAddr, fid));
+ }
+
+int32 rtl865x_setHWL2Table(uint32 row, uint32 column, rtl865x_tblAsicDrv_l2Param_t *l2p)
+{
+	return (rtl8651_setAsicL2Table(row, column, l2p));
+}
+
+int32 rtl865x_getHWL2Table(uint32 row, uint32 column, rtl865x_tblAsicDrv_l2Param_t *l2p)
+{
+	return rtl8651_getAsicL2Table(row, column, l2p);
+}
+
+int32 rtl865x_refleshHWL2Table(ether_addr_t * macAddr, uint32 flags,uint16 fid)
+{
+
+	rtl865x_tblAsicDrv_l2Param_t L2temp, *L2buff;
+	uint32 rowIdx, col_num;
+	uint32 colIdx = 0;
+	uint32 found = FALSE;
+
+	L2buff = &L2temp;
+	memset(L2buff, 0, sizeof(rtl865x_tblAsicDrv_l2Param_t));
+	rowIdx = rtl8651_filterDbIndex(macAddr, fid);
+
+	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++) {
+		if ((rtl8651_getAsicL2Table(rowIdx, colIdx, L2buff))!=SUCCESS ||
+			memcmp(&(L2buff->macAddr), macAddr, 6)!= 0)
+			continue;
+
+		if (((flags&FDB_STATIC) && L2buff->isStatic) ||
+			((flags&FDB_DYNAMIC) && !L2buff->isStatic)) {
+				assert(colIdx);
+				col_num = colIdx;
+				found = TRUE;
+				break;
+		}
+	}
+
+	if (found == TRUE)
+	{
+		L2buff->ageSec = 450;
+		rtl8651_setAsicL2Table(rowIdx, colIdx, L2buff);
+		return SUCCESS;
+	}
+	else
+	{
+		return FAILED;
+	}
+}
+
+int32 rtl_get_hw_fdb_age(uint32 fid,ether_addr_t *mac, uint32 flags)
+{
+	uint32 rowIdx;
+	uint32 colIdx = 0;
+	int32 retval = 0;
+	rtl865x_tblAsicDrv_l2Param_t L2buff;
+
+	memset(&L2buff,0,sizeof(rtl865x_tblAsicDrv_l2Param_t));
+
+	rowIdx = rtl8651_filterDbIndex(mac, fid);
+
+	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++)
+	{
+		retval = rtl8651_getAsicL2Table(rowIdx, colIdx, &L2buff);
+
+		if (retval !=SUCCESS ||
+			memcmp(&(L2buff.macAddr), mac, 6)!= 0)
+			continue;
+		if (((flags&FDB_DYNAMIC) && !L2buff.isStatic)||((flags&FDB_STATIC) && L2buff.isStatic))
+		{
+			retval = L2buff.ageSec;
+			break;
+		}
+
+	}
+
+	return retval;
+}
+
+EXPORT_SYMBOL(rtl_get_hw_fdb_age);
+
+int32 rtl_get_hw_fdb_port(uint32 fid, ether_addr_t *mac, uint32 flags, uint8 *port)
+{
+	 int i;
+	uint32 rowIdx;
+	uint32 colIdx = 0;
+	int32 retval = FAILED;
+	rtl865x_tblAsicDrv_l2Param_t L2buff;
+
+	memset(&L2buff,0,sizeof(rtl865x_tblAsicDrv_l2Param_t));
+
+	rowIdx = rtl8651_filterDbIndex(mac, fid);
+
+	for (colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++)
+	{
+		retval = rtl8651_getAsicL2Table(rowIdx, colIdx, &L2buff);
+
+		if (retval !=SUCCESS ||
+			memcmp(&(L2buff.macAddr), mac, 6)!= 0)
+			continue;
+		if (((flags&FDB_DYNAMIC) && !L2buff.isStatic)||((flags&FDB_STATIC) && L2buff.isStatic))
+		{
+			  //retval = L2buff.memberPortMask;
+			  for (i=0; i<6; i++)
+			  {
+				if ((1<<i) & L2buff.memberPortMask) {
+					*port = i;
+					return SUCCESS;
+				}
+			  }
+		}
+	}
+
+	return retval;
+}
+
+int32 rtl865x_getPortNum(const unsigned char *addr){
+	ether_addr_t *macAddr;
+	int32 column;
+	rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+	int8 port_num = -1;
+	//fdb->ageing_timer = 300*HZ;
+	macAddr = (ether_addr_t *)(addr);
+
+	if (rtl865x_Lookup_fdb_entry(RTL_LAN_FID, macAddr, FDB_DYNAMIC, &column,&fdbEntry) == SUCCESS)
+	{
+		/*find the fdb entry*/
+		port_num = rtl865x_ConvertPortMasktoPortNum(fdbEntry.memberPortMask);
+	} else {
+		/*can't find */
+	}
+	return port_num;
+}
+
+int32 rtl865x_Lookup_fdb_entry(uint32 fid, ether_addr_t *mac, uint32 flags, uint32 *col_num, rtl865x_tblAsicDrv_l2Param_t *L2buff)
+{
+	uint32 rowIdx;
+	uint32 colIdx;
+	int32 retval;
+
+	rowIdx = rtl8651_filterDbIndex(mac, fid);
+	colIdx = 0;
+
+	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++)
+	{
+		retval = rtl8651_getAsicL2Table(rowIdx, colIdx, L2buff);
+
+		if (retval !=SUCCESS ||
+			memcmp(&(L2buff->macAddr), mac, 6)!= 0)
+			continue;
+		if (((flags&FDB_STATIC) && L2buff->isStatic) ||
+			((flags&FDB_DYNAMIC) && !L2buff->isStatic)) {
+			assert(colIdx);
+			*col_num = colIdx;
+			return SUCCESS;
+		}
+
+	}
+	return FAILED;
+}
+
+/*
+@func enum RTL_RESULT | rtl865x_addFdbEntry | Add an MAC address, said Filter Database Entry
+@parm uint32 | fid | The filter database index (valid: 0~3)
+@parm ether_addr_t * | mac | The MAC address to be added
+@parm uint32 | portmask | The portmask of this MAC address belongs to
+@parm uint32 | type | fdb entry type
+@rvalue SUCCESS | Add success
+@rvalue FAILED | General failure
+@comm
+	Add a Filter Database Entry to L2 Table(1024-Entry)
+@devnote
+	(under construction)
+*/
+int32 rtl865x_addFilterDatabaseEntry( uint32 fid, ether_addr_t * mac, uint32 portmask, uint32 type )
+{
+	int32 retval;
+	 unsigned long flags=0;
+	if (type != FDB_TYPE_FWD && type != FDB_TYPE_SRCBLK && type != FDB_TYPE_TRAPCPU)
+		return RTL_EINVALIDINPUT; /* Invalid parameter */
+
+	if (fid >= RTL865x_FDB_NUMBER)
+		return RTL_EINVALIDINPUT;
+	if (mac == (ether_addr_t *)NULL)
+		return RTL_EINVALIDINPUT;
+	if (sw_FDB_Table.filterDB[fid].valid == 0)
+		return RTL_EINVALIDFID;
+	/*l2 lock*/
+	//rtl_down_interruptible(&l2_sem);
+	SMP_LOCK_ETH(flags);
+#ifdef CONFIG_RTL865X_LANPORT_RESTRICTION
+	retval = _rtl865x_addFilterDatabaseEntry(RTL865x_L2_TYPEII, fid,  mac, type, portmask, TRUE, FALSE);
+#else
+	retval = _rtl865x_addFilterDatabaseEntry(RTL865x_L2_TYPEII, fid,  mac, type, portmask, FALSE, FALSE);
+#endif
+	/*l2 unlock*/
+	//rtl_up(&l2_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+int32 rtl865x_addFilterDatabaseEntryExtension( uint16 fid, rtl865x_filterDbTableEntry_t * L2entry)
+{
+	int32 retval;
+	 //unsigned long flags=0;
+	if (L2entry->process != FDB_TYPE_FWD && L2entry->process != FDB_TYPE_SRCBLK && L2entry->process != FDB_TYPE_TRAPCPU)
+		return RTL_EINVALIDINPUT; /* Invalid parameter */
+
+	if (fid >= RTL865x_FDB_NUMBER)
+		return RTL_EINVALIDINPUT;
+	if (&(L2entry->macAddr) == (ether_addr_t *)NULL)
+		return RTL_EINVALIDINPUT;
+	if (sw_FDB_Table.filterDB[fid].valid == 0)
+		return RTL_EINVALIDFID;
+	/*l2 lock*/
+	//rtl_down_interruptible(&l2_sem);
+	/*Fix jwj: disable SMP_LOCK_ETH*/
+	//SMP_LOCK_ETH(flags);
+	retval = _rtl865x_addFilterDatabaseEntry(	L2entry->l2type,
+											fid,
+											&(L2entry->macAddr),
+											L2entry->process,
+											L2entry->memberPortMask,
+											L2entry->auth,
+											L2entry->SrcBlk);
+
+	/*l2 unlock*/
+	//rtl_up(&l2_sem);
+	//SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+
+#if 0
+int32 rtl865x_addFilterDatabaseEntry( uint32 fid, ether_addr_t * mac, uint32 portmask, uint32 type , uint32 isStatic)
+{
+	int32 retval;
+
+	if (type != FDB_TYPE_FWD && type != FDB_TYPE_SRCBLK && type != FDB_TYPE_TRAPCPU)
+		return RTL_EINVALIDINPUT; /* Invalid parameter */
+
+	if (fid >= RTL865x_FDB_NUMBER)
+		return RTL_EINVALIDINPUT;
+	if (mac == (ether_addr_t *)NULL)
+		return RTL_EINVALIDINPUT;
+	if (sw_FDB_Table.filterDB[fid].valid == 0)
+		return RTL_EINVALIDFID;
+	/*l2 lock*/
+
+#ifdef RTL865XC_LAN_PORT_NUM_RESTRIT
+	retval = _rtl865x_addFilterDatabaseEntry(isStatic == TRUE? RTL865x_L2_TYPEII:RTL865x_L2_TYPEI, fid,  mac, type, portmask, TRUE, FALSE);
+#else
+	retval = _rtl865x_addFilterDatabaseEntry(isStatic == TRUE? RTL865x_L2_TYPEII:RTL865x_L2_TYPEI, fid,  mac, type, portmask, FALSE, FALSE);
+
+#endif
+	/*l2 unlock*/
+
+
+	return retval;
+}
+#endif
+
+
+int32 _rtl865x_removeFilterDatabaseEntry(uint16 fid, ether_addr_t * mac, uint32 rowIdx)
+{
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[fid];
+	rtl865x_filterDbTableEntry_t * l2entry_t ;
+	/*printk("rowIdx:%dfid:%d\n",rowIdx,fid);*/
+	/*printk("\n mac address is %x %x %x %x %x %x\n", mac->octet[0],
+													mac->octet[1],
+													mac->octet[2],
+													mac->octet[3],
+													mac->octet[4],
+													mac->octet[5]);
+													*/
+	if (SLIST_FIRST(&(fdb_t->database[rowIdx])))
+	{
+		SLIST_FOREACH(l2entry_t, &(fdb_t->database[rowIdx]), nextFDB)
+		{
+			 if (memcmp(&(l2entry_t->macAddr), mac, 6)== 0)
+			{
+				SLIST_REMOVE(
+					&(fdb_t->database[rowIdx]),
+					l2entry_t,
+					 rtl865x_filterDbTableEntry_s,
+					 nextFDB
+				);
+				SLIST_INSERT_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, l2entry_t, nextFDB);
+
+				rtl865x_raiseEvent(EVENT_DEL_FDB, (void *)(l2entry_t));
+
+				return SUCCESS;
+			}
+		}
+	}
+
+	return FAILED;
+}
+
+int32 rtl865x_lookup_FilterDatabaseEntry(uint16 fid, ether_addr_t * mac, rtl865x_filterDbTableEntry_t *l2_entry)
+{
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[fid];
+	rtl865x_filterDbTableEntry_t * l2entry_t ;
+	uint32 rowIdx;
+
+	rowIdx = rtl8651_filterDbIndex(mac, fid);
+
+	if (SLIST_FIRST(&(fdb_t->database[rowIdx])))
+	{
+		SLIST_FOREACH(l2entry_t, &(fdb_t->database[rowIdx]), nextFDB)
+		{
+			 if (memcmp(&(l2entry_t->macAddr), mac, 6)== 0)
+			{
+				l2_entry->asicPos	= l2entry_t->asicPos;
+				l2_entry->auth		= l2entry_t->auth;
+				l2_entry->l2type		= l2entry_t->l2type;
+				l2_entry->linkId		= l2entry_t->linkId;
+				l2_entry->memberPortMask = l2entry_t->memberPortMask;
+				l2_entry->nhFlag 	= l2entry_t->nhFlag;
+				l2_entry->process	= l2entry_t->process;
+				l2_entry->SrcBlk		= l2entry_t->SrcBlk;
+				l2_entry->vid		= l2entry_t->vid;
+				return SUCCESS;
+			}
+		}
+	}
+
+	memset(l2_entry, 0, sizeof(rtl865x_filterDbTableEntry_t));
+	return FAILED;
+}
+
+int32 _rtl865x_addFilterDatabaseEntry(uint16 l2Type, uint16 fid,  ether_addr_t * macAddr, uint32 type, uint32 portMask, uint8 auth, uint8 SrcBlk)
+{
+	uint32 rowIdx = 0;
+	uint32 colIdx = 0;
+	uint32 col_num = 0;
+	uint32 col_tmp = 0;
+	uint16 tmp_age = 0xffff;
+	int32   found = FALSE;
+	int32   flag = FALSE;
+	int32   nexthp_flag = FALSE;
+	int32  isStatic = FALSE;
+	int32  toCpu = FALSE;
+	rtl865x_filterDbTableEntry_t * l2entry_t = NULL;
+	rtl865x_filterDbTableEntry_t *tmpL2;
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[fid];
+	rtl865x_tblAsicDrv_l2Param_t l2entry_tmp,*L2buff;
+	int32 retval = 0;
+
+	L2buff = &l2entry_tmp;
+	memset(L2buff,0,sizeof(rtl865x_tblAsicDrv_l2Param_t));
+	rowIdx = rtl8651_filterDbIndex(macAddr, fid);
+	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++)
+	{
+		retval = rtl8651_getAsicL2Table(rowIdx, colIdx, L2buff);
+		if ((retval)==SUCCESS)
+		{
+			/*check whether mac address has been learned  to HW or not*/
+			if (memcmp(&(L2buff->macAddr), macAddr, 6)== 0)
+			{
+				/*the entry has been auto learned*/
+				if (L2buff->memberPortMask==portMask)
+				{
+					/*the entry has been auto learned        */
+					found = TRUE;
+					col_tmp = colIdx;
+				}
+				else
+				/*portmask is different , it should be overwrited*/
+				{
+					found = FALSE;
+					flag = TRUE;
+				}
+				break;
+			}
+			/*no matched entry, try get minimum aging time L2 Asic entry*/
+			if (tmp_age> L2buff->ageSec)
+			{
+				tmp_age = L2buff->ageSec;
+				col_num = colIdx;
+			}
+		}
+		else
+		{
+			/*there is still empty l2 asic entry*/
+			flag = TRUE;
+			break;
+		}
+	}
+
+	switch(l2Type) {
+	case RTL865x_L2_TYPEI:
+		nexthp_flag = FALSE;isStatic = FALSE;
+		break;
+	case RTL865x_L2_TYPEII:
+		nexthp_flag = TRUE; isStatic = TRUE;
+		break;
+	case RTL865x_L2_TYPEIII:
+		nexthp_flag = FALSE;isStatic = TRUE;
+		break;
+	default: assert(0);
+	}
+
+	switch(type) {
+	case FDB_TYPE_FWD:
+			toCpu =  FALSE;
+			break;
+	case FDB_TYPE_DSTBLK:
+			toCpu =  FALSE;
+			break;
+	case FDB_TYPE_SRCBLK:
+			toCpu =  FALSE;
+			break;
+	case FDB_TYPE_TRAPCPU:
+			toCpu =  TRUE;
+			break;
+	default: assert(0);
+	}
+
+	if (found == FALSE)
+	{
+#if 0
+		/*no empty entry, overwrite the biggest aging time asic l2 entry*/
+		if(flag == FALSE)
+		{
+			/*delete the biggest aging time software entry*/
+			rtl8651_getAsicL2Table(rowIdx, col_num, L2buff);
+			_rtl865x_removeFilterDatabaseEntry(fid, &(L2buff->macAddr), rowIdx);
+
+			/*overwrite asic entry*/
+			rtl8651_setAsicL2Table_Patch(
+					rowIdx,
+					col_num,
+					macAddr,
+					toCpu,
+					SrcBlk,
+					portMask,
+					arpAgingTime,
+					isStatic,
+					nexthp_flag,
+					fid,
+					auth);
+			col_tmp = col_num;
+		}
+		else
+#endif
+		/*portmask is different , so it should overwrite the original asic entry. Or there is empty entry, set it to asic*/
+		if(flag == TRUE)
+		{
+			rtl8651_setAsicL2Table_Patch(
+					rowIdx,
+					colIdx,
+					macAddr,
+					toCpu,
+					SrcBlk,
+					portMask,
+					arpAgingTime,
+					isStatic,
+					nexthp_flag,
+					fid,
+					auth);
+			col_tmp = colIdx;
+		}
+	}
+	/*find the same asic entry, should update the aging time*/
+	else
+	{
+		rtl8651_setAsicL2Table_Patch(
+				rowIdx,
+				col_tmp,
+				macAddr,
+				toCpu,
+				SrcBlk,
+				portMask,
+				arpAgingTime,
+				isStatic,
+				nexthp_flag,
+				fid,
+				auth);
+	}
+
+/*
+	colIdx=0;
+
+	tmpL2 = SLIST_FIRST(&(fdb_t->database[rowIdx]));
+	tmpL2->nextFDB.sle_next  = NULL;
+
+	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++)
+	{
+		if ((rtl8651_getAsicL2Table(rowIdx, colIdx, L2buff))==SUCCESS)
+		{
+			l2entry_t->asicPos =colIdx;
+			l2entry_t->auth = L2buff->auth;
+			l2entry_t->configToAsic = 0;
+			l2entry_t->memberPortMask = L2buff->memberPortMask;
+			l2entry_t->SrcBlk = L2buff->srcBlk;
+			memcpy(&l2entry_t->macAddr, &L2buff->macAddr, sizeof(ether_addr_t));
+
+			tmpL2->nextFDB.sle_next = l2entry_t;
+			l2entry_t->nextFDB.sle_next = NULL;
+			tmpL2 = l2entry_t;
+		}
+	}
+*/
+
+	if (SLIST_FIRST(&sw_FDB_Table.freefdbList.filterDBentry) == NULL)
+		return RTL_ENOFREEBUFFER;
+
+	/*config the SW l2 entry */
+	l2entry_t = SLIST_FIRST(&sw_FDB_Table.freefdbList.filterDBentry);
+	SLIST_REMOVE_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, nextFDB);
+
+	l2entry_t->asicPos =col_tmp;
+	l2entry_t->auth = auth;
+	l2entry_t->configToAsic = 0;
+	l2entry_t->memberPortMask = portMask;
+	l2entry_t->l2type = l2Type;
+	l2entry_t->nhFlag = nexthp_flag;
+
+	l2entry_t->SrcBlk = FALSE;
+	memcpy(&l2entry_t->macAddr, macAddr, sizeof(ether_addr_t));
+	switch(type) {
+	case FDB_TYPE_FWD:
+	 	 l2entry_t->process = FDB_TYPE_FWD;
+		 l2entry_t->memberPortMask = portMask;
+		 break;
+	case FDB_TYPE_DSTBLK:
+		 l2entry_t->process = FDB_TYPE_DSTBLK;
+		 l2entry_t->memberPortMask = 0;
+		 break;
+	case FDB_TYPE_SRCBLK:
+		 l2entry_t->process = FDB_TYPE_SRCBLK;
+		 l2entry_t->memberPortMask = 0;
+		 break;
+	case FDB_TYPE_TRAPCPU:
+		 l2entry_t->process = FDB_TYPE_TRAPCPU;
+		 l2entry_t->memberPortMask = portMask;
+	 	 break;
+	default: assert(0);
+	}
+
+	/*write the SW l2 entry */
+
+	if (SLIST_FIRST(&(fdb_t->database[rowIdx])))
+	{
+		SLIST_FOREACH(tmpL2, &(fdb_t->database[rowIdx]), nextFDB)
+		{
+			 if (memcmp(&(tmpL2->macAddr), macAddr, 6)== 0)
+			{
+				if(	(tmpL2->auth != auth) ||
+					(tmpL2->process != type) ||
+					(tmpL2->SrcBlk != SrcBlk) ||
+					(tmpL2->memberPortMask != portMask) ||
+					(tmpL2->l2type != l2Type)	)
+				{
+					tmpL2->auth				= auth;
+					tmpL2->process 			= type;
+					tmpL2->SrcBlk 			= SrcBlk;
+					tmpL2->memberPortMask	= portMask;
+					tmpL2->l2type 			= l2Type;
+
+					/*duplicate entry,avoid memory leak*/
+					SLIST_INSERT_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, l2entry_t, nextFDB);
+					break;
+/*					tmpL2 ->refCount = 1;*/
+				}
+				else
+				{
+/*					tmpL2->refCount +=1;*/
+
+					/*duplicate entry,avoid memory leak*/
+					SLIST_INSERT_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, l2entry_t, nextFDB);
+					return SUCCESS;
+				}
+			}
+			else if (tmpL2->nextFDB.sle_next == NULL)
+			{
+/*				l2entry_t ->refCount = 1;*/
+				tmpL2->nextFDB.sle_next = l2entry_t;
+				l2entry_t->nextFDB.sle_next = NULL;
+				break;
+			}
+		}
+	}
+	else
+	{
+/*		l2entry_t ->refCount = 1;*/
+		SLIST_INSERT_HEAD(&(fdb_t->database[rowIdx]), l2entry_t, nextFDB);
+	}
+
+	/* TypeII entry can not exceed RTL8651_L2TBL_COLUMN */
+/*	if (typeII == RTL8651_L2TBL_COLUMN && l2Type == RTL8651_L2_TYPEII)
+		return RTL_NOFREEBUFFER;
+*/
+	#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	if (portMask & (1<<PKTHDR_EXTPORT_P3))
+		rtl865x_raiseEvent(EVENT_ADD_FDB, (void *)(l2entry_t));
+	#endif
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8651_delFilterDatabaseEntry | Remove a filter database entry.
+@parm uint16 | fid | Filter database entry.
+@parm ether_addr_t * | macAddr | Pointer to a MAC Address.
+@rvalue RTL_EINVALIDFID | Filter database ID.
+@rvalue RTL_NULLMACADDR | The specified MAC address is NULL.
+@rvalue RTL_EINVALIDINPUT | Invalid input parameter.
+*/
+int32 rtl865x_delFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr) {
+	int32 retval;
+	unsigned long flags=0;
+	if (fid >= RTL865x_FDB_NUMBER)
+		return RTL_EINVALIDINPUT;
+	if (macAddr == (ether_addr_t *)NULL)
+		return RTL_EINVALIDINPUT;
+	if (sw_FDB_Table.filterDB[fid].valid == 0)
+		return RTL_EINVALIDFID;
+
+/*	L2 lock		*/
+	//rtl_down_interruptible(&l2_sem);
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEII, fid, macAddr);
+/*	L2 unlock		*/
+	//rtl_up(&l2_sem);
+	SMP_UNLOCK_ETH_HW(flags);
+	return retval;
+}
+
+int32 _rtl865x_delFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr)
+{
+	uint32 rowIdx = 0;
+	uint32 colIdx = 0;
+	rtl865x_tblAsicDrv_l2Param_t L2temp, *L2buff ;
+	rtl865x_filterDbTableEntry_t * l2entry_t = NULL;
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[fid];
+	int32 found = FALSE;
+	//printk("[%s][%d].\n", __FUNCTION__, __LINE__);
+	rowIdx = rtl8651_filterDbIndex(macAddr, fid);
+
+	L2buff = &L2temp;
+	memset(L2buff, 0 , sizeof (rtl865x_tblAsicDrv_l2Param_t));
+	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++)
+	{
+		if ((rtl8651_getAsicL2Table(rowIdx, colIdx, L2buff))==SUCCESS)
+		{
+			/*check whether mac address has been learned  to SW or not*/
+			if (memcmp(&(L2buff->macAddr), macAddr, 6)== 0)
+			{
+				/*the entry has been auto learned*/
+				found = TRUE;
+				break;
+			}
+		}
+	}
+
+	/*
+	when a sta from eth0 to wlan0, the layer driver fdb will be deleted, but linux bridge fdb still exist,
+	so delete the asic entry anyway to avoid layer connection issue.
+	eg:
+	first moment .sta is at eth0
+	second moment:connect sta to wlan0, the layer driver fdb will be deleted, but linux bridge fdb still there
+	third moment:move sta to eth0 again, layer driver fdb won't be created due to linux bridge fdb already exist.
+	*/
+	if (found == TRUE)
+	{
+		rtl8651_delAsicL2Table(rowIdx, colIdx);
+	}
+
+	SLIST_FOREACH(l2entry_t, &(fdb_t->database[rowIdx]), nextFDB)
+	{
+		if (!memcmp(&l2entry_t->macAddr, macAddr, sizeof(ether_addr_t)))
+		{
+	/*		l2entry_t->refCount -= 1;*/
+	/*		if (l2entry_t->refCount == 0)*/
+			{
+				SLIST_REMOVE(
+					&(fdb_t->database[rowIdx]),
+					l2entry_t,
+					 rtl865x_filterDbTableEntry_s,
+					 nextFDB
+				);
+				SLIST_INSERT_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, l2entry_t, nextFDB);
+
+				rtl865x_raiseEvent(EVENT_DEL_FDB, (void *)(l2entry_t));
+			}
+			break;
+		}
+	}
+	return SUCCESS;
+}
+
+#ifdef CONFIG_RTL865X_SYNC_L2
+int32 rtl865x_arrangeFdbEntry(const unsigned char *timeout_addr, int32 *port)
+{
+	int32 found = FAILED;
+	ether_addr_t *macAddr;
+	int32 column;
+	rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+	rtl865x_filterDbTableEntry_t		l2temp_entry;
+	int32 rowIdx;
+
+	macAddr = (ether_addr_t *)(timeout_addr);
+	rowIdx = rtl8651_filterDbIndex(macAddr, RTL_LAN_FID);
+	found = rtl865x_Lookup_fdb_entry(RTL_LAN_FID, macAddr, FDB_DYNAMIC, &column, &fdbEntry);
+	if (found != SUCCESS)
+	{
+		if (rtl865x_lookup_FilterDatabaseEntry(RTL_LAN_FID, macAddr, &l2temp_entry) == SUCCESS)
+		{
+/*			printk("\nlook up sw fdb success\n");
+			printk("\nport mask is %x\n", l2temp_entry.memberPortMask);
+*/
+			*port =  rtl865x_ConvertPortMasktoPortNum(l2temp_entry.memberPortMask);
+			return RTL865X_FDBENTRY_TIMEOUT;
+		}
+
+	}
+	else
+	{
+		if(fdbEntry.ageSec == 450)
+		{
+			return RTL865X_FDBENTRY_450SEC;
+		}
+		if(fdbEntry.ageSec == 300)
+		{
+			return RTL865X_FDBENTRY_300SEC;
+		}
+		if(fdbEntry.ageSec == 150)
+		{
+			return RTL865X_FDBENTRY_150SEC;
+		}
+	}
+	return FAILED;
+}
+
+void update_hw_l2table(const char *srcName,const unsigned char *addr)
+{
+
+	//int32 found = FAILED;
+	ether_addr_t *macAddr;
+	int32 ret = 0;
+#if defined (CONFIG_RTL_LAYERED_DRIVER)	&& defined (CONFIG_RTL_LAYERED_DRIVER_L2)
+	int32 column;
+	rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+#endif
+	macAddr = (ether_addr_t *)(addr);
+
+	if (memcmp(srcName, RTL_WLAN_NAME, 4) ==0)
+	{
+
+#if defined (CONFIG_RTL_LAYERED_DRIVER)
+#if defined (CONFIG_RTL_LAYERED_DRIVER_L2)
+		if (rtl865x_Lookup_fdb_entry(RTL_LAN_FID, macAddr, FDB_DYNAMIC, &column,&fdbEntry) == SUCCESS)
+#endif
+#else
+		if (rtl8651_lookupL2table(0, macAddr, FDB_DYNAMIC) == SUCCESS)
+#endif
+		{
+
+			if((fdbEntry.memberPortMask & RTL8651_PHYSICALPORTMASK)!=0)
+			{
+#if defined (CONFIG_RTL_LAYERED_DRIVER)
+#if defined (CONFIG_RTL_LAYERED_DRIVER_L2)
+				ret = rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEII, RTL_LAN_FID, macAddr);
+#endif
+#else
+				ret = rtl8651_delFilterDatabaseEntry(0, macAddr);
+#endif
+			}
+
+		}
+
+#if defined (CONFIG_RTL_IVL_SUPPORT)
+
+#if defined (CONFIG_RTL_LAYERED_DRIVER)
+#if defined (CONFIG_RTL_LAYERED_DRIVER_L2)
+		if (rtl865x_Lookup_fdb_entry(RTL_WAN_FID, macAddr, FDB_DYNAMIC, &column,&fdbEntry) == SUCCESS)
+#endif
+#endif
+		{
+
+			if((fdbEntry.memberPortMask & RTL8651_PHYSICALPORTMASK)!=0)
+			{
+#if defined (CONFIG_RTL_LAYERED_DRIVER)
+#if defined (CONFIG_RTL_LAYERED_DRIVER_L2)
+				ret = rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEII, RTL_WAN_FID, macAddr);
+#endif
+#endif
+			}
+
+		}
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+		{
+		extern void del_83XX_L2(const unsigned char *addr);
+		del_83XX_L2(addr);
+		}
+#endif
+	}
+
+
+}
+
+EXPORT_SYMBOL(update_hw_l2table);
+
+int32 rtl865x_addFDBEntry(const unsigned char *addr)
+{
+	int32 found = FAILED;
+	ether_addr_t *macAddr;
+	int32 ret=FAILED;
+	int8 port_num = -1;
+	int32 column;
+	rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+	rtl865x_filterDbTableEntry_t		l2temp_entry;
+
+	if (addr == NULL)
+		return RTL_EINVALIDINPUT;
+	//printk("[%s][%d].\n", __FUNCTION__, __LINE__);
+	macAddr = (ether_addr_t *)(addr);
+	found = rtl865x_Lookup_fdb_entry(RTL_LAN_FID, macAddr, FDB_DYNAMIC, &column, &fdbEntry);
+	if (found == SUCCESS )
+	{
+		port_num = rtl865x_ConvertPortMasktoPortNum(fdbEntry.memberPortMask);
+		//printk("[%s][%d].\n", __FUNCTION__, __LINE__);
+		//printk("\nbefore rtl865x_lookup_FilterDatabaseEntry, port is %d\n", port_num);
+		if (rtl865x_lookup_FilterDatabaseEntry(fdbEntry.fid, macAddr, &l2temp_entry) != SUCCESS)
+		{
+			l2temp_entry.l2type = (fdbEntry.nhFlag==0)?RTL865x_L2_TYPEI: RTL865x_L2_TYPEII;
+			l2temp_entry.process = FDB_TYPE_FWD;
+			l2temp_entry.memberPortMask = fdbEntry.memberPortMask;
+/*			l2temp_entry.auth = TRUE;*/
+/*			l2temp_entry.SrcBlk = FALSE;*/
+			memcpy(&(l2temp_entry.macAddr), macAddr, sizeof(ether_addr_t));
+			ret =_rtl865x_addFilterDatabaseEntry(	l2temp_entry.l2type,
+		        										fdbEntry.fid,
+		        										&(l2temp_entry.macAddr),
+		        										l2temp_entry.process,
+		        										l2temp_entry.memberPortMask,
+		        										FALSE,
+		        										FALSE);
+		}
+	}
+	else
+	{
+		//printk("[%s][%d].\n", __FUNCTION__, __LINE__);
+		/*add */
+	}
+	return ret;
+}
+
+#if defined (CONFIG_RTL_EXT_PORT_SUPPORT)
+int32 rtl865x_addExtFDBEntry(const unsigned char *addr,int extPort)
+{
+
+	int32 ret=FAILED;
+
+#if 1
+	int32 found = FAILED;
+	ether_addr_t *macAddr;
+	//int32 column;
+	//rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+	rtl865x_filterDbTableEntry_t l2_entry;
+	//printk("addr:%x:%x:%x:%x:%x:%x,extPort:%d,[%s][%d].\n",addr[0],addr[1],addr[2],addr[3], addr[4],addr[5],extPort,  __FUNCTION__, __LINE__);
+	/*only use PKTHDR_EXTPORT_P3 now, to-do*/
+	if(extPort!=PKTHDR_EXTPORT_P3)
+		return RTL_EINVALIDINPUT;
+
+	if (addr == NULL)
+		return RTL_EINVALIDINPUT;
+	macAddr = (ether_addr_t *)(addr);
+	//found = rtl865x_Lookup_fdb_entry(RTL_LAN_FID, macAddr, FDB_STATIC, &column, &fdbEntry);
+	found=rtl865x_lookup_FilterDatabaseEntry(RTL_LAN_FID, macAddr, &l2_entry) ;
+	if (found == SUCCESS )
+	{
+		#if 0
+		port_num = rtl865x_ConvertPortMasktoPortNum(fdbEntry.memberPortMask);
+		//printk("[%s][%d].\n", __FUNCTION__, __LINE__);
+		//printk("\nbefore rtl865x_lookup_FilterDatabaseEntry, port is %d\n", port_num);
+		if (rtl865x_lookup_FilterDatabaseEntry(fdbEntry.fid, macAddr, &l2temp_entry) != SUCCESS)
+		{
+			l2temp_entry.l2type = RTL865x_L2_TYPEIII;
+			l2temp_entry.process = FDB_TYPE_FWD;
+			l2temp_entry.memberPortMask = fdbEntry.memberPortMask;
+
+			memcpy(&(l2temp_entry.macAddr), macAddr, sizeof(ether_addr_t));
+			ret =_rtl865x_addFilterDatabaseEntry(	l2temp_entry.l2type,
+		        										fdbEntry.fid,
+		        										&(l2temp_entry.macAddr),
+		        										l2temp_entry.process,
+		        										l2temp_entry.memberPortMask,
+		        										TRUE,
+		        										FALSE);
+		}
+		#endif
+	}
+	else
+	{
+		//printk("addr:%x:%x:%x:%x:%x:%x,extPort:%d,[%s][%d].\n",addr[0],addr[1],addr[2],addr[3], addr[4],addr[5],extPort,	__FUNCTION__, __LINE__);
+		/*add */
+		if(extPort==PKTHDR_EXTPORT_P3)
+			ret = _rtl865x_addFilterDatabaseEntry(RTL865x_L2_TYPEIII, RTL_LAN_FID, macAddr, FDB_TYPE_FWD, (1<<PKTHDR_EXTPORT_P3), TRUE, FALSE);
+
+	}
+	#endif
+	return ret;
+}
+
+int32 _rtl865x_DelFDBEntryByType(int32 l2Type)
+{
+	int32 index = 0;
+	int32 index1 = 0;
+	rtl865x_filterDbTable_t *filterDbPtr;
+	rtl865x_filterDbTableEntry_t  *tempFilterDbPtr;
+
+	for(index=0,filterDbPtr=&sw_FDB_Table.filterDB[0]; index<RTL865x_FDB_NUMBER; index++,filterDbPtr++)
+	{
+		for(index1=0; index1<RTL8651_L2TBL_ROW; index1++){
+			if (SLIST_FIRST(&(filterDbPtr->database[index1])))
+			{
+				SLIST_FOREACH(tempFilterDbPtr, &(filterDbPtr->database[index1]), nextFDB)
+				{
+					if(tempFilterDbPtr->l2type==l2Type)
+					{
+						_rtl865x_delFilterDatabaseEntry(tempFilterDbPtr->l2type,RTL_LAN_FID,&tempFilterDbPtr->macAddr);
+					}
+				}
+			}
+		}
+	}
+	return 0;
+}
+
+int32 rtl865x_delExtFDBEntry(void)
+{
+	return _rtl865x_DelFDBEntryByType(RTL865x_L2_TYPEIII);
+}
+
+
+#endif
+int32 rtl865x_delLanFDBEntry(uint16 l2Type,  const unsigned char *addr)
+{
+	int32 ret=FAILED;
+	ether_addr_t *macAddr;
+
+	if (addr == NULL)
+	{
+		return RTL_EINVALIDINPUT;
+	}
+	macAddr = (ether_addr_t *)(addr);
+
+	ret =_rtl865x_delFilterDatabaseEntry(l2Type, RTL_LAN_FID, macAddr);
+
+	return ret;
+}
+
+int32 rtl865x_ConvertPortMasktoPortNum(int32 portmask)
+{
+	int32 i = 0;
+
+	for (i = PHY0; i < EXT3; i++)
+	{
+		if(((portmask >> i) & 0x01) == 1)
+		{
+			return i;
+		}
+	}
+	return FAILED;
+}
+
+#if defined(CONFIG_RTL865X_LANPORT_RESTRICTION)
+extern int rtl_delFdbByMac(const unsigned char *macAddr, const char* devName);
+char *rtl_getDevNameByPort(int32 port_num);
+int32 rtl_check_fdb_entry_check_exist(uint32 fid, ether_addr_t *mac, uint32 flags)
+{
+	uint32 rowIdx;
+	uint32 colIdx;
+	int32 retval;
+	rtl865x_tblAsicDrv_l2Param_t L2buff;
+
+	rowIdx = rtl8651_filterDbIndex(mac, fid);
+	colIdx = 0;
+
+	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++)
+	{
+		retval = rtl8651_getAsicL2Table(rowIdx, colIdx, &L2buff);
+
+		if (retval !=SUCCESS ||
+			memcmp(&(L2buff.macAddr), mac, 6)!= 0)
+			continue;
+		if (((flags&FDB_STATIC) && L2buff.isStatic) ||
+			((flags&FDB_DYNAMIC) && !L2buff.isStatic)) {
+			return SUCCESS;
+		}
+
+	}
+	return FAILED;
+}
+
+int32 rtl_check_fdb_entry_check_srcBlock(uint32 fid, ether_addr_t *mac, int32 *SrcBlk)
+{
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[fid];
+	rtl865x_filterDbTableEntry_t * l2entry_t ;
+	uint32 rowIdx;
+
+	rowIdx = rtl8651_filterDbIndex(mac, fid);
+
+	if (SLIST_FIRST(&(fdb_t->database[rowIdx])))
+	{
+		SLIST_FOREACH(l2entry_t, &(fdb_t->database[rowIdx]), nextFDB)
+		{
+			 if (memcmp(&(l2entry_t->macAddr), mac, 6)== 0)
+			{
+				*SrcBlk = l2entry_t->SrcBlk;
+				return SUCCESS;
+			}
+		}
+	}
+	return FAILED;
+}
+
+int32 lanrestrict_callbackFn_for_add_fdb(void *param)
+{
+	int32 port_num;
+	rtl865x_filterDbTableEntry_t  *fdbEntry;
+
+	if(param==NULL)
+	{
+		return EVENT_CONTINUE_EXECUTE;
+	}
+
+	fdbEntry=(rtl865x_filterDbTableEntry_t *)param;
+	port_num = rtl865x_ConvertPortMasktoPortNum(fdbEntry->memberPortMask);
+
+	if (lan_restrict_tbl[port_num].enable == TRUE)
+	{
+		lan_restrict_tbl[port_num].curr_num ++;
+	}
+
+	return SUCCESS;
+}
+
+int32 lanrestrict_callbackFn_for_del_fdb(void *param)
+{
+	int32 port_num;
+	rtl865x_filterDbTableEntry_t  *fdbEntry;
+
+	if(param==NULL)
+	{
+		return EVENT_CONTINUE_EXECUTE;
+	}
+
+	fdbEntry=(rtl865x_filterDbTableEntry_t *)param;
+	port_num = rtl865x_ConvertPortMasktoPortNum(fdbEntry->memberPortMask);
+	if (lan_restrict_tbl[port_num].enable == TRUE)
+	{
+		lan_restrict_tbl[port_num].curr_num --;
+		if (lan_restrict_tbl[port_num].curr_num < 0)
+		{
+			lan_restrict_tbl[port_num].curr_num = 0;
+		}
+		/*printk("\ndel authed port[%d], num:%d\n", port_num, lan_restrict_tbl[port_num].curr_num);*/
+	}
+	return SUCCESS;
+}
+
+static int32 lanrestrict_authadd_unRegister_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_ADD_AUTHED_FDB;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=lanrestrict_callbackFn_for_add_fdb;
+	rtl865x_unRegisterEvent(&eventParam);
+	return SUCCESS;
+}
+
+static int32 lanrestrict_authdel_unRegister_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_AUTHED_FDB;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=lanrestrict_callbackFn_for_del_fdb;
+	rtl865x_unRegisterEvent(&eventParam);
+	return SUCCESS;
+}
+
+int32 lanrestrict_unRegister_event(void)
+{
+	lanrestrict_authadd_unRegister_event();
+	lanrestrict_authdel_unRegister_event();
+	return SUCCESS;
+}
+
+static int32 lanrestrict_authadd_register_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_ADD_AUTHED_FDB;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=lanrestrict_callbackFn_for_add_fdb;
+	rtl865x_registerEvent(&eventParam);
+
+	#if 0
+	if (rtl865x_registerEvent(&eventParam)== SUCCESS)
+	{
+		printk("register Event SUCCESS:%x\n",EVENT_ADD_AUTHED_FDB);
+		return SUCCESS;
+	}
+	else if(rtl865x_registerEvent(&eventParam)== RTL_EENTRYALREADYEXIST)
+	{
+		printk("the Event already exist\n");
+		return SUCCESS;
+	}
+	else
+	{
+		printk("register Event FAILED:%d \n",rtl865x_registerEvent(&eventParam));
+		return FAILED;
+	}
+	#endif
+	return SUCCESS;
+}
+
+static int32 lanrestrict_authdel_register_event(void)
+{
+
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_AUTHED_FDB;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=lanrestrict_callbackFn_for_del_fdb;
+	rtl865x_registerEvent(&eventParam);
+
+	#if 0
+	if (rtl865x_registerEvent(&eventParam)== SUCCESS)
+	{
+		printk("register Event SUCCESS:%x\n",EVENT_DEL_AUTHED_FDB);
+		return SUCCESS;
+	}
+	else if(rtl865x_registerEvent(&eventParam)== RTL_EENTRYALREADYEXIST)
+	{
+		printk("the Event already exist\n");
+		return SUCCESS;
+	}
+	else
+	{
+		printk("register Event FAILED:%d \n",rtl865x_registerEvent(&eventParam));
+		return FAILED;
+	}
+	#endif
+	return SUCCESS;
+}
+
+int32 lanrestrict_register_event(void)
+{
+	lanrestrict_authadd_register_event();
+	lanrestrict_authdel_register_event();
+	return SUCCESS;
+}
+
+int32 _rtl865x_addAuthFilterDatabaseEntry(uint16 l2Type, uint16 fid,  ether_addr_t * macAddr, uint32 type, uint32 portMask, uint8 auth, uint8 SrcBlk)
+{
+	uint32 rowIdx = 0;
+	uint32 colIdx = 0;
+	uint32 col_num = 0;
+	uint32 col_tmp = 0;
+	uint16 tmp_age = 0xffff;
+	int32   found = FALSE;
+	int32   flag = FALSE;
+	int32   nexthp_flag = FALSE;
+	int32  isStatic = FALSE;
+	int32  toCpu = FALSE;
+	rtl865x_filterDbTableEntry_t * l2entry_t = NULL;
+	rtl865x_filterDbTableEntry_t *tmpL2;
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[fid];
+	rtl865x_tblAsicDrv_l2Param_t l2entry_tmp,*L2buff;
+	int32 retval = 0;
+	int32 overwite_blk_flag = FALSE;
+
+	//printk("auth:%d,srcblk:%d\n",auth,SrcBlk);
+	L2buff = &l2entry_tmp;
+	memset(L2buff,0,sizeof(rtl865x_tblAsicDrv_l2Param_t));
+	rowIdx = rtl8651_filterDbIndex(macAddr, fid);
+	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++)
+	{
+		retval = rtl8651_getAsicL2Table(rowIdx, colIdx, L2buff);
+		if ((retval)==SUCCESS)
+		{
+			/*check whether mac address has been learned  to HW or not*/
+			if (memcmp(&(L2buff->macAddr), macAddr, 6)== 0)
+			{
+				/*the entry has been auto learned*/
+				if (L2buff->memberPortMask==portMask)
+				{
+					/*the entry has been auto learned        */
+					if ((L2buff->srcBlk == TRUE) && (L2buff->auth == FALSE))
+					{
+						overwite_blk_flag = TRUE;
+					}
+					found = TRUE;
+
+					col_tmp = colIdx;
+				}
+				else
+				/*portmask is different , it should be overwrited*/
+				{
+					found = FALSE;
+					flag = TRUE;
+
+				}
+				break;
+			}
+			/*no matched entry, try get minimum aging time L2 Asic entry*/
+			if (tmp_age> L2buff->ageSec)
+			{
+				tmp_age = L2buff->ageSec;
+				col_num = colIdx;
+			}
+		}
+		else
+		{
+			/*there is still empty l2 asic entry*/
+
+			flag = TRUE;
+			break;
+		}
+	}
+	/*printk("found:%d,overwite_blk_flag:%d",found, overwite_blk_flag);*/
+	switch(l2Type) {
+	case RTL865x_L2_TYPEI:
+		nexthp_flag = FALSE;isStatic = FALSE;
+		break;
+	case RTL865x_L2_TYPEII:
+		nexthp_flag = TRUE; isStatic = TRUE;
+		break;
+	case RTL865x_L2_TYPEIII:
+		nexthp_flag = FALSE;isStatic = TRUE;
+		break;
+	default: assert(0);
+	}
+
+	switch(type) {
+	case FDB_TYPE_FWD:
+			toCpu =  FALSE;
+			break;
+	case FDB_TYPE_DSTBLK:
+			toCpu =  FALSE;
+			break;
+	case FDB_TYPE_SRCBLK:
+			toCpu =  FALSE;
+			break;
+	case FDB_TYPE_TRAPCPU:
+			toCpu =  TRUE;
+			break;
+	default: assert(0);
+	}
+
+	if (found == FALSE)
+	{
+		/*no empty entry, overwrite the biggest aging time asic l2 entry*/
+		if(flag == FALSE)
+		{
+			/*delete the biggest aging time software entry*/
+			rtl8651_getAsicL2Table(rowIdx, col_num, L2buff);
+
+			_rtl865x_removeFilterDatabaseEntry(fid, &(L2buff->macAddr), rowIdx);
+			/*overwrite asic entry*/
+			rtl8651_setAsicL2Table_Patch(
+					rowIdx,
+					col_num,
+					macAddr,
+					toCpu,
+					SrcBlk,
+					portMask,
+					arpAgingTime,
+					isStatic,
+					nexthp_flag,
+					fid,
+					auth);
+			col_tmp = col_num;
+		}
+		/*portmask is different , so it should overwrite the original asic entry. Or there is empty entry, set it to asic*/
+		else if(flag == TRUE)
+		{
+
+			rtl8651_setAsicL2Table_Patch(
+					rowIdx,
+					colIdx,
+					macAddr,
+					toCpu,
+					SrcBlk,
+					portMask,
+					arpAgingTime,
+					isStatic,
+					nexthp_flag,
+					fid,
+					auth);
+			col_tmp = colIdx;
+		}
+	}
+	/*find the same asic entry, should update the aging time*/
+	else
+	{
+
+		rtl8651_setAsicL2Table_Patch(
+				rowIdx,
+				col_tmp,
+				macAddr,
+				toCpu,
+				SrcBlk,
+				portMask,
+				arpAgingTime,
+				isStatic,
+				nexthp_flag,
+				fid,
+				auth);
+	}
+
+/*
+	colIdx=0;
+
+	tmpL2 = SLIST_FIRST(&(fdb_t->database[rowIdx]));
+	tmpL2->nextFDB.sle_next  = NULL;
+
+	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++)
+	{
+		if ((rtl8651_getAsicL2Table(rowIdx, colIdx, L2buff))==SUCCESS)
+		{
+			l2entry_t->asicPos =colIdx;
+			l2entry_t->auth = L2buff->auth;
+			l2entry_t->configToAsic = 0;
+			l2entry_t->memberPortMask = L2buff->memberPortMask;
+			l2entry_t->SrcBlk = L2buff->srcBlk;
+			memcpy(&l2entry_t->macAddr, &L2buff->macAddr, sizeof(ether_addr_t));
+
+			tmpL2->nextFDB.sle_next = l2entry_t;
+			l2entry_t->nextFDB.sle_next = NULL;
+			tmpL2 = l2entry_t;
+		}
+	}
+*/
+
+	if (SLIST_FIRST(&sw_FDB_Table.freefdbList.filterDBentry) == NULL)
+	{
+
+		return RTL_ENOFREEBUFFER;
+	}
+	/*config the SW l2 entry */
+	l2entry_t = SLIST_FIRST(&sw_FDB_Table.freefdbList.filterDBentry);
+	SLIST_REMOVE_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, nextFDB);
+
+	l2entry_t->asicPos =col_tmp;
+	l2entry_t->auth = auth;
+	l2entry_t->configToAsic = 0;
+	l2entry_t->memberPortMask = portMask;
+	l2entry_t->l2type = l2Type;
+	l2entry_t->nhFlag = nexthp_flag;
+
+	l2entry_t->SrcBlk = SrcBlk;
+	memcpy(&l2entry_t->macAddr, macAddr, sizeof(ether_addr_t));
+	switch(type) {
+	case FDB_TYPE_FWD:
+	 	 l2entry_t->process = FDB_TYPE_FWD;
+		 l2entry_t->memberPortMask = portMask;
+		 break;
+	case FDB_TYPE_DSTBLK:
+		 l2entry_t->process = FDB_TYPE_DSTBLK;
+		 l2entry_t->memberPortMask = 0;
+		 break;
+	case FDB_TYPE_SRCBLK:
+		 l2entry_t->process = FDB_TYPE_SRCBLK;
+		 l2entry_t->memberPortMask = 0;
+		 break;
+	case FDB_TYPE_TRAPCPU:
+		 l2entry_t->process = FDB_TYPE_TRAPCPU;
+		 l2entry_t->memberPortMask = portMask;
+	 	 break;
+	default: assert(0);
+	}
+
+	/*write the SW l2 entry */
+check_swfdb:
+	if (SLIST_FIRST(&(fdb_t->database[rowIdx])))
+	{
+		SLIST_FOREACH(tmpL2, &(fdb_t->database[rowIdx]), nextFDB)
+		{
+			 if (memcmp(&(tmpL2->macAddr), macAddr, 6)== 0)
+			{
+				if(	(tmpL2->auth != auth) ||
+					(tmpL2->process != type) ||
+					(tmpL2->SrcBlk != SrcBlk) ||
+					(tmpL2->memberPortMask != portMask) ||
+					(tmpL2->l2type != l2Type)	)
+				{
+					tmpL2->auth				= auth;
+					tmpL2->process 			= type;
+					tmpL2->SrcBlk 			= SrcBlk;
+					tmpL2->memberPortMask	= portMask;
+					tmpL2->l2type 			= l2Type;
+					/*tmpL2 ->refCount = 0;*/
+					break;
+				}
+				else
+				{
+					return SUCCESS;
+					//goto out; appear errorr:label used but not defined
+				}
+			}
+			/*try to check whether there is timeout sw fdb entry*/
+			else if(tmpL2->asicPos == col_tmp)
+			{
+			/*	if ((tmpL2->SrcBlk == TRUE) && (tmpL2->auth == FALSE))*/
+				{
+					_rtl865x_removeFilterDatabaseEntry(fid, &(tmpL2->macAddr), rowIdx);
+					goto check_swfdb;
+				}
+			}
+			else if (tmpL2->nextFDB.sle_next == NULL)
+			{
+/*				l2entry_t->refCount = 0;*/
+				tmpL2->nextFDB.sle_next = l2entry_t;
+				l2entry_t->nextFDB.sle_next = NULL;
+				break;
+			}
+		}
+	}
+	else
+	{
+/*		l2entry_t ->refCount = 0;*/
+
+		SLIST_INSERT_HEAD(&(fdb_t->database[rowIdx]), l2entry_t, nextFDB);
+	}
+
+	/* TypeII entry can not exceed RTL8651_L2TBL_COLUMN */
+/*	if (typeII == RTL8651_L2TBL_COLUMN && l2Type == RTL8651_L2_TYPEII)
+		return RTL_NOFREEBUFFER;
+*/
+
+	if (overwite_blk_flag != TRUE)
+	{
+		/*Add a new entry*/
+		rtl865x_raiseEvent(EVENT_ADD_AUTHED_FDB, (void *)(l2entry_t));
+	}
+	else
+	{
+
+		/*printk("\nover blk entry, no raise event\n");*/
+	}
+
+//out:
+	return SUCCESS;
+}
+
+
+int32 _rtl865x_addAuthSWl2Entry(uint16 l2Type, uint16 fid,  ether_addr_t * macAddr, uint32 type, int32 port, uint8 auth, uint8 SrcBlk)
+{
+	uint32 rowIdx = 0;
+	int32   nexthp_flag = FALSE;
+	rtl865x_filterDbTableEntry_t * l2entry_t = NULL;
+	rtl865x_filterDbTableEntry_t *tmpL2;
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[fid];
+	rtl865x_tblAsicDrv_l2Param_t l2entry_tmp,*L2buff;
+	int32 overwite_blk_flag = FALSE;
+
+	L2buff = &l2entry_tmp;
+	memset(L2buff,0,sizeof(rtl865x_tblAsicDrv_l2Param_t));
+	rowIdx = rtl8651_filterDbIndex(macAddr, fid);
+
+
+	if (SLIST_FIRST(&sw_FDB_Table.freefdbList.filterDBentry) == NULL)
+		return RTL_ENOFREEBUFFER;
+
+	/*config the SW l2 entry */
+	l2entry_t = SLIST_FIRST(&sw_FDB_Table.freefdbList.filterDBentry);
+	SLIST_REMOVE_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, nextFDB);
+
+	l2entry_t->auth = auth;
+	l2entry_t->configToAsic = 0;
+	l2entry_t->memberPortMask = 1<<port;
+	l2entry_t->l2type = l2Type;
+	l2entry_t->nhFlag = nexthp_flag;
+
+	l2entry_t->SrcBlk = SrcBlk;
+	memcpy(&l2entry_t->macAddr, macAddr, sizeof(ether_addr_t));
+	switch(type) {
+	case FDB_TYPE_FWD:
+	 	 l2entry_t->process = FDB_TYPE_FWD;
+		 l2entry_t->memberPortMask = 1<<port;
+		 break;
+	case FDB_TYPE_DSTBLK:
+		 l2entry_t->process = FDB_TYPE_DSTBLK;
+		 l2entry_t->memberPortMask = 0;
+		 break;
+	case FDB_TYPE_SRCBLK:
+		 l2entry_t->process = FDB_TYPE_SRCBLK;
+		 l2entry_t->memberPortMask = 0;
+		 break;
+	case FDB_TYPE_TRAPCPU:
+		 l2entry_t->process = FDB_TYPE_TRAPCPU;
+		 l2entry_t->memberPortMask = 1<<port;
+	 	 break;
+	default: assert(0);
+	}
+
+	/*write the SW l2 entry */
+	if (SLIST_FIRST(&(fdb_t->database[rowIdx])))
+	{
+		SLIST_FOREACH(tmpL2, &(fdb_t->database[rowIdx]), nextFDB)
+		{
+			 if (memcmp(&(tmpL2->macAddr), macAddr, 6)== 0)
+			{
+				if(	(tmpL2->auth != auth) ||
+					(tmpL2->process != type) ||
+					(tmpL2->SrcBlk != SrcBlk) ||
+					(tmpL2->memberPortMask != 1<<port) ||
+					(tmpL2->l2type != l2Type)	)
+				{
+
+					if ( ( tmpL2->auth == FALSE) && (tmpL2->SrcBlk == TRUE))
+					{
+						overwite_blk_flag = TRUE;
+					}
+					tmpL2->auth				= auth;
+					tmpL2->process 			= type;
+					tmpL2->SrcBlk 			= SrcBlk;
+					tmpL2->memberPortMask	= 1<<port;
+					tmpL2->l2type 			= l2Type;
+/*					tmpL2 ->refCount = 0;*/
+					break;
+				}
+				else
+				{
+					SLIST_INSERT_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, l2entry_t, nextFDB);
+					//goto out;
+					return SUCCESS;
+				}
+			}
+
+			else if (tmpL2->nextFDB.sle_next == NULL)
+			{
+/*				l2entry_t->refCount = 0;*/
+				tmpL2->nextFDB.sle_next = l2entry_t;
+				l2entry_t->nextFDB.sle_next = NULL;
+				break;
+			}
+		}
+	}
+	else
+	{
+/*		l2entry_t ->refCount = 0;*/
+		SLIST_INSERT_HEAD(&(fdb_t->database[rowIdx]), l2entry_t, nextFDB);
+	}
+
+	/* TypeII entry can not exceed RTL8651_L2TBL_COLUMN */
+/*	if (typeII == RTL8651_L2TBL_COLUMN && l2Type == RTL8651_L2_TYPEII)
+		return RTL_NOFREEBUFFER;
+*/
+
+	if (overwite_blk_flag != TRUE)
+	{
+		//printk("\nauth:,srcblk:\n",auth,SrcBlk);
+		rtl865x_raiseEvent(EVENT_ADD_AUTHED_FDB, (void *)(l2entry_t));
+	}
+	else
+	{
+		/*printk("\nNO need to add currnum,over blk entry, no raise event\n");*/
+	}
+
+//out:
+	return SUCCESS;
+}
+
+
+int32 rtl865x_addAuthFilterDatabaseEntryExtension( uint16 fid, rtl865x_filterDbTableEntry_t * L2entry)
+{
+	int32 retval;
+	unsigned long flags=0;
+	if (L2entry->process != FDB_TYPE_FWD && L2entry->process != FDB_TYPE_SRCBLK && L2entry->process != FDB_TYPE_TRAPCPU)
+		return RTL_EINVALIDINPUT; /* Invalid parameter */
+
+	if (fid >= RTL865x_FDB_NUMBER)
+		return RTL_EINVALIDINPUT;
+	if (&(L2entry->macAddr) == (ether_addr_t *)NULL)
+		return RTL_EINVALIDINPUT;
+	if (sw_FDB_Table.filterDB[fid].valid == 0)
+		return RTL_EINVALIDFID;
+
+	/*l2 lock*/
+	//rtl_down_interruptible(&l2_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_addAuthFilterDatabaseEntry(	L2entry->l2type,
+											fid,
+											&(L2entry->macAddr),
+											L2entry->process,
+											L2entry->memberPortMask,
+											L2entry->auth,
+											L2entry->SrcBlk);
+	/*l2 unlock*/
+	//rtl_up(&l2_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+
+/*
+@func int32 | rtl8651_delFilterDatabaseEntry | Remove a filter database entry.
+@parm uint16 | fid | Filter database entry.
+@parm ether_addr_t * | macAddr | Pointer to a MAC Address.
+@rvalue RTL_EINVALIDFID | Filter database ID.
+@rvalue RTL_NULLMACADDR | The specified MAC address is NULL.
+@rvalue RTL_EINVALIDINPUT | Invalid input parameter.
+*/
+int32 rtl865x_delAuthFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr) {
+	int32 retval;
+	unsigned long flags=0;
+	if (fid >= RTL865x_FDB_NUMBER)
+		return RTL_EINVALIDINPUT;
+	if (macAddr == (ether_addr_t *)NULL)
+		return RTL_EINVALIDINPUT;
+	if (sw_FDB_Table.filterDB[fid].valid == 0)
+		return RTL_EINVALIDFID;
+
+/*	L2 lock		*/
+	//rtl_down_interruptible(&l2_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_delAuthFilterDatabaseEntry(RTL865x_L2_TYPEII, fid, macAddr);
+/*	L2 unlock		*/
+	//rtl_up(&l2_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+
+
+int32 _rtl865x_delAuthFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr)
+{
+	uint32 rowIdx = 0;
+	uint32 colIdx = 0;
+	rtl865x_tblAsicDrv_l2Param_t L2temp, *L2buff ;
+	rtl865x_filterDbTableEntry_t * l2entry_t = NULL;
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[fid];
+	int32 found = FALSE;
+
+	rowIdx = rtl8651_filterDbIndex(macAddr, fid);
+	/*print message
+	printk("rowIdx%d:\n",rowIdx);
+	printk("fid%d:\n",fid);
+	printk("\n the mac address is %x %x %x %x %x %x\n", macAddr->octet[0],
+													macAddr->octet[1],
+													macAddr->octet[2],
+													macAddr->octet[3],
+													macAddr->octet[4],
+													macAddr->octet[5]);*/
+	L2buff = &L2temp;
+	memset(L2buff, 0 , sizeof (rtl865x_tblAsicDrv_l2Param_t));
+	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++)
+	{
+		if ((rtl8651_getAsicL2Table(rowIdx, colIdx, L2buff))==SUCCESS)
+		{
+			/*printk("\n mac address is %x %x %x %x %x %x\n", L2buff->macAddr.octet[0],
+															L2buff->macAddr.octet[1],
+															L2buff->macAddr.octet[2],
+															L2buff->macAddr.octet[3],
+															L2buff->macAddr.octet[4],
+															L2buff->macAddr.octet[5]);*/
+
+			/*check whether mac address has been learned  to SW or not*/
+			if (memcmp(&(L2buff->macAddr), macAddr, 6)== 0)
+			{
+				/*the entry has been auto learned*/
+				found = TRUE;
+				break;
+			}
+		}
+	}
+
+	SLIST_FOREACH(l2entry_t, &(fdb_t->database[rowIdx]), nextFDB)
+	{
+
+	if (!memcmp(&l2entry_t->macAddr, macAddr, sizeof(ether_addr_t)))
+	{
+	/*		l2entry_t->refCount -= 1;*/
+	/*		if (l2entry_t->refCount == 0)*/
+
+		SLIST_REMOVE(
+			&(fdb_t->database[rowIdx]),
+			l2entry_t,
+			 rtl865x_filterDbTableEntry_s,
+			 nextFDB
+		);
+		SLIST_INSERT_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, l2entry_t, nextFDB);
+		if (found == TRUE)
+		{
+			rtl8651_delAsicL2Table(rowIdx, colIdx);
+		}
+		/*printk("l2entry_t->srcblk:%d,l2entry_t->auth:%d\n", l2entry_t->SrcBlk,l2entry_t->auth);*/
+		if ((l2entry_t->SrcBlk == FALSE) && (l2entry_t->auth == TRUE))
+		{
+			uint32 memberPortMask_t;
+			memberPortMask_t=l2entry_t->memberPortMask;
+
+			/*after del an auth fdb, consider add an auth fdb*/
+
+			#if defined (CONFIG_RTL865X_LANPORT_RESTRICTION) && defined(CONFIG_RTL_LAYERED_DRIVER) && defined(CONFIG_RTL_LAYERED_DRIVER_L2)&& defined(CONFIG_RTL865X_SYNC_L2)
+			{
+				unsigned char swap_addr[ETHER_ADDR_LEN];
+				int32 port_num;
+				/*try to find blocked l2 entry, then set it to authed*/
+				port_num = rtl865x_ConvertPortMasktoPortNum(memberPortMask_t);
+				if (port_num != FAILED)
+				{
+					/*printk("\ntime out port num is %d\n", port_num);*/
+					if ((lan_restrict_getBlockAddr(port_num, swap_addr)) == SUCCESS)
+					{
+							//struct hlist_head *head = &br->hash[br_mac_hash(swap_addr)];
+							/*
+							printk("\n arrange block entry is %x %x %x %x %x %x\n", swap_addr[0],
+																	swap_addr[1],
+																	swap_addr[2],
+																	swap_addr[3],
+																	swap_addr[4],
+													 				swap_addr[5]);
+
+										*/
+						rtl865x_addAuthFDBEntry(swap_addr, TRUE, port_num, FALSE);
+					}
+
+				}
+				else
+				{/*port_num==FAILED*/}
+			}
+			#endif	/* #if defined (CONFIG_RTL865X_LANPORT_RESTRICTION) && defined(CONFIG_RTL_LAYERED_DRIVER) && defined(CONFIG_RTL_LAYERED_DRIVER_L2) && defined(CONFIG_RTL865X_SYNC_L2)	*/	//consider add an auth fdb entry
+
+		}
+
+		//SLIST_INSERT_HEAD(&sw_FDB_Table.freefdbList.filterDBentry, l2entry_t, nextFDB);
+		rtl865x_raiseEvent(EVENT_DEL_FDB, (void *)(l2entry_t));
+		//if(lanrestrict_authdel_register_event()==SUCCESS);
+		rtl865x_raiseEvent(EVENT_DEL_AUTHED_FDB, (void *)(l2entry_t));
+
+	break;
+	}
+	} /*SLIST_FOREACH*/
+	return SUCCESS;
+}
+
+int32 rtl865x_check_authfdbentry_Byport(int32 port_num, const unsigned char  *macAddr)
+{
+	uint32  rowIdx;
+	int32 retval = FAILED;
+	rtl865x_tblAsicDrv_l2Param_t *L2buff, l2temp;
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[0];
+	rtl865x_filterDbTableEntry_t * l2entry_t ;
+
+	L2buff = &l2temp;
+	memset(L2buff, 0, sizeof(rtl865x_tblAsicDrv_l2Param_t));
+	for(rowIdx=0; rowIdx<RTL8651_L2TBL_ROW; rowIdx++)
+	{
+		if (SLIST_FIRST(&(fdb_t->database[rowIdx])))
+		{
+
+			SLIST_FOREACH(l2entry_t, &(fdb_t->database[rowIdx]), nextFDB)
+			{
+				if ( (l2entry_t->memberPortMask&(1<<port_num)) && (l2entry_t ->auth == FALSE) && (l2entry_t->SrcBlk == TRUE))
+				{
+
+					memcpy((ether_addr_t *)macAddr, &(l2entry_t->macAddr), sizeof(ether_addr_t));
+#if 0
+					printk("\nfind block entry, rowIdx is %d, address2 is %x %x %x %x %x %x\n", rowIdx, ((ether_addr_t *)macAddr)->octet[0],
+																				((ether_addr_t *)macAddr)->octet[1],
+																				((ether_addr_t *)macAddr)->octet[2],
+																				((ether_addr_t *)macAddr)->octet[3],
+																				((ether_addr_t *)macAddr)->octet[4],
+																				((ether_addr_t *)macAddr)->octet[5]);
+#endif
+
+
+					retval =  SUCCESS;
+					break;
+				}
+			}
+		}
+
+	}
+	return retval;
+}
+
+int32 rtl865x_addAuthFDBEntry(const unsigned char *addr, int32 auth, int32  port, int32 srcblk)
+{
+	int32 found = FAILED;
+	ether_addr_t *macAddr;
+	int32 ret=FAILED;
+	int8 port_num = -1;
+	int32 column;
+	rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+	rtl865x_filterDbTableEntry_t		l2temp_entry;
+	//int32 srcblk;
+
+	if (addr == NULL)
+		return RTL_EINVALIDINPUT;
+	macAddr = (ether_addr_t *)(addr);
+	found = rtl865x_Lookup_fdb_entry(RTL_LAN_FID, macAddr, FDB_DYNAMIC, &column, &fdbEntry);
+	/*if (auth == TRUE)
+		srcblk = FALSE;
+	else
+		srcblk = TRUE; */
+
+	if (found == SUCCESS )
+	{
+		port_num = rtl865x_ConvertPortMasktoPortNum(fdbEntry.memberPortMask);
+
+		//printk("\nbefore rtl865x_lookup_FilterDatabaseEntry, port is %d, auth is %d\n", port_num, auth);
+		if (rtl865x_lookup_FilterDatabaseEntry(fdbEntry.fid, macAddr, &l2temp_entry) != SUCCESS)
+		{
+
+			l2temp_entry.l2type = (fdbEntry.nhFlag==0)?RTL865x_L2_TYPEI: RTL865x_L2_TYPEII;
+			l2temp_entry.process = FDB_TYPE_FWD;
+			l2temp_entry.memberPortMask = fdbEntry.memberPortMask;
+/*			l2temp_entry.auth = TRUE;*/
+/*			l2temp_entry.SrcBlk = FALSE;*/
+			memcpy(&(l2temp_entry.macAddr), macAddr, sizeof(ether_addr_t));
+			ret =_rtl865x_addAuthFilterDatabaseEntry(	l2temp_entry.l2type,
+			        										fdbEntry.fid,
+			        										&(l2temp_entry.macAddr),
+			        										l2temp_entry.process,
+			        										l2temp_entry.memberPortMask,
+			        										auth,
+			        										srcblk);
+
+		}
+#if 1
+		else
+		{
+			if ((l2temp_entry.auth == FALSE) && (l2temp_entry.SrcBlk == TRUE))
+			{
+
+				l2temp_entry.l2type = (fdbEntry.nhFlag==0)?RTL865x_L2_TYPEI: RTL865x_L2_TYPEII;
+				l2temp_entry.process = FDB_TYPE_FWD;
+				l2temp_entry.memberPortMask = fdbEntry.memberPortMask;
+				memcpy(&(l2temp_entry.macAddr), macAddr, sizeof(ether_addr_t));
+				ret =_rtl865x_addAuthFilterDatabaseEntry(	l2temp_entry.l2type,
+				        										fdbEntry.fid,
+				        										&(l2temp_entry.macAddr),
+				        										l2temp_entry.process,
+				        										l2temp_entry.memberPortMask,
+				        										auth,
+				        										srcblk);
+			}
+		}
+#endif
+	}
+	else
+	{
+		/*just add sw l2 table */
+
+		l2temp_entry.l2type = RTL865x_L2_TYPEII;
+		l2temp_entry.process = FDB_TYPE_FWD;
+		/*			l2temp_entry.auth = TRUE;*/
+		/*			l2temp_entry.SrcBlk = FALSE;*/
+		memcpy(&(l2temp_entry.macAddr), macAddr, sizeof(ether_addr_t));
+		ret =_rtl865x_addAuthSWl2Entry(	l2temp_entry.l2type,
+										0,
+										&(l2temp_entry.macAddr),
+										l2temp_entry.process,
+										1<<port,
+										auth,
+										srcblk);
+	}
+	return ret;
+}
+
+
+int32 rtl865x_addAuthFDBEntry_hooks(const unsigned char *addr)
+{
+	int32	port_num;
+	int32	ret;
+
+	if ((port_num=rtl865x_getPortNum(addr))!= -1)
+	{
+		ret = lan_restrict_CheckStatusByport(port_num);
+
+			if (ret == RTL_LAN_RESTRICT_STAT2)
+		{
+			//function opened, and should be authed
+			rtl865x_addAuthFDBEntry(addr, TRUE, port_num, FALSE);
+		} else if(ret == RTL_LAN_RESTRICT_STAT1)
+		{
+			//function opened, and set it to block
+			rtl865x_addAuthFDBEntry(addr, FALSE, port_num, TRUE);
+
+		}else  if(ret == RTL_LAN_RESTRICT_STAT0)
+		{
+			//function not open , no need to be authed
+			rtl865x_addFDBEntry(addr);
+		}
+	}
+	return SUCCESS;
+}
+
+
+int32 rtl865x_delAuthLanFDBEntry(uint16 l2Type,  const unsigned char *addr)
+{
+	int32 ret=FAILED;
+	ether_addr_t *macAddr;
+	if (addr == NULL)
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	macAddr = (ether_addr_t *)(addr);
+	ret =_rtl865x_delAuthFilterDatabaseEntry(	l2Type, RTL_LAN_FID, macAddr);
+	return ret;
+}
+
+int32 rtl865x_BlkCheck(const unsigned char *addr)
+{
+	ether_addr_t *macAddr;
+	rtl865x_filterDbTableEntry_t		l2temp_entry;
+
+	if (addr == NULL)
+		return RTL_EINVALIDINPUT;
+
+	macAddr = (ether_addr_t *)(addr);
+#if 0
+					printk("\nin rtl865x_BlkCheck, address2 is %x %x %x %x %x %x\n", ((ether_addr_t *)macAddr)->octet[0],
+																				((ether_addr_t *)macAddr)->octet[1],
+																				((ether_addr_t *)macAddr)->octet[2],
+																				((ether_addr_t *)macAddr)->octet[3],
+																				((ether_addr_t *)macAddr)->octet[4],
+																				((ether_addr_t *)macAddr)->octet[5]);
+#endif
+
+	if(rtl865x_lookup_FilterDatabaseEntry(RTL_LAN_FID, macAddr, &l2temp_entry) == SUCCESS)
+	{
+		if (l2temp_entry.SrcBlk == TRUE)
+		{
+			return TRUE;
+		}
+	}
+	return FALSE;
+}
+/*
+@func int32   | rtl865x_enableLanPortNumRestrict | enable max guest number restrict feature.
+@parm uint8 | isEnable | enable feature or not.
+@rvalue SUCCESS | enable feature.
+@comm This API may change wan & lan port 802.1x mac base ablity
+*/
+int32 rtl865x_enableLanPortNumRestrict(uint8 isEnable)
+{
+	if( isEnable == TRUE)
+	{
+		rtl8651_setAsic802D1xMacBaseDirection(Dot1xMAC_OPDIR_IN);
+		rtl8651_setAsicGuestVlanProcessControl(EN_8021X_TOCPU);
+	}
+	else
+	{
+		rtl8651_setAsic802D1xMacBaseDirection(Dot1xMAC_OPDIR_BOTH);
+		rtl8651_setAsicGuestVlanProcessControl( EN_8021X_DROP);
+	}
+
+	return SUCCESS;
+}
+
+
+/*
+@func int32   	| rtl865x_setRestrictPortNum | set per port max guest number for max  host restrict feature.
+@parm int32	| port 		| set port number .
+@parm int8	| isEnable 	| enable max  host restrict feature or not
+@parm int32 	| number 	| set max guest number
+@rvalue SUCCESS | set number for this port ok.
+*/
+int32 rtl865x_setRestrictPortNum(int32 port, uint8 isEnable, int32 number)
+{
+	int32 i = 0;
+
+	if(isEnable==TRUE)
+	{
+
+		for (i = PHY0; i < EXT3; i++)
+		{
+			if( i == port)
+			{
+				rtl8651_setAsic802D1xMacBaseAbility(i, TRUE);
+				break;
+			}
+		}
+	}
+
+	if(isEnable==FALSE)
+	{
+
+		for (i = PHY0; i < EXT3; i++)
+		{
+			if( i == port)
+			{
+				rtl8651_setAsic802D1xMacBaseAbility(i, FALSE);
+				break;
+			}
+		}
+
+	}
+	return SUCCESS;
+}
+#endif
+
+#endif
+
+#if defined(CONFIG_RTL_LINKCHG_PROCESS) || defined(CONFIG_RTL_IVL_SUPPORT)
+int32 _rtl865x_ClearFDBEntryByPort(int32 port_num)
+{
+	int i, j;
+	rtl865x_tblAsicDrv_l2Param_t l2entry_tmp,*L2buff;
+	#ifdef CONFIG_RTL865X_LANPORT_RESTRICTION
+	char *name;
+	#endif
+
+
+	L2buff = &l2entry_tmp;
+
+	for (i = 0; i < RTL8651_L2TBL_ROW; i++)
+		for (j = 0; j < RTL8651_L2TBL_COLUMN; j++)
+		{
+			if ((rtl8651_getAsicL2Table(i, j, L2buff))!=SUCCESS)
+				continue;
+
+			if ((rtl865x_ConvertPortMasktoPortNum(L2buff->memberPortMask)) != port_num)
+				continue;
+
+			if (L2buff->isStatic == TRUE)
+				continue;
+
+			rtl8651_delAsicL2Table(i, j);
+			#ifdef CONFIG_RTL865X_LANPORT_RESTRICTION
+			name = rtl_getDevNameByPort(port_num);
+			if(name){
+				rtl_delFdbByMac((unsigned char *)(&(L2buff->macAddr.octet)), name);
+			}
+			#endif
+			_rtl865x_removeFilterDatabaseEntry(RTL_LAN_FID, &(L2buff->macAddr), i);
+		}
+
+	#if defined(CONFIG_RTL865X_LANPORT_RESTRICTION)
+	/*when link is down, set curr_num of port to 0 */
+	lan_restrict_tble_reset_port(port_num);
+	#endif
+
+	return SUCCESS;
+
+}
+#endif
+
+#ifdef CONFIG_RTL_LINKCHG_PROCESS
+int32 rtl865x_LinkChange_Process(void)
+{
+	uint32 i, status;
+
+	/* Check each port. */
+	for ( i = 0; i < RTL8651_MAC_NUMBER; i++ )
+	{
+		/* Read Port Status Register to know the port is link-up or link-down. */
+		status = READ_MEM32( PSRP0 + i * 4 );
+		if ( ( status & PortStatusLinkUp ) == FALSE )
+		{
+			/* Link is down. */
+			rtl8651_setAsicEthernetLinkStatus( i, FALSE );
+#if defined(CONFIG_RTL865X_LANPORT_RESTRICTION)
+			_rtl865x_ClearFDBEntryByPort(i);
+#endif
+			#if defined(CONFIG_RTL_HW_TX_CSUM)
+			{
+				extern unsigned char hw_csum_cache_mac[6];
+				memset(hw_csum_cache_mac, 0, sizeof(hw_csum_cache_mac));
+			}
+			#endif
+		}
+		else
+		{
+			/* Link is up. */
+			rtl8651_setAsicEthernetLinkStatus( i, TRUE );
+		}
+	}
+
+	return SUCCESS;
+
+}
+#endif
+
+#ifdef CONFIG_RTL_PROC_DEBUG
+#ifdef CONFIG_RTL_PROC_NEW
+int32 rtl865x_sw_l2_proc_read(struct seq_file *s, void *v)
+{
+	int32 index = 0;
+	int32 index1 = 0;
+	//int len=0;
+	uint32 port, m=0;
+	rtl865x_filterDbTable_t *filterDbPtr;
+	rtl865x_filterDbTableEntry_t  *tempFilterDbPtr;
+
+	seq_printf(s, "%s\n", "sw l2 table:");
+
+	for(index=0,filterDbPtr=&sw_FDB_Table.filterDB[0]; index<RTL865x_FDB_NUMBER; index++,filterDbPtr++) {
+		for(index1=0; index1<RTL8651_L2TBL_ROW; index1++)
+			if (SLIST_FIRST(&(filterDbPtr->database[index1])))
+			{
+				SLIST_FOREACH(tempFilterDbPtr, &(filterDbPtr->database[index1]), nextFDB)
+				{
+					seq_printf(s, "%4d.[%3d,%d] %02x:%02x:%02x:%02x:%02x:%02x FID:%x mbr(",m, index1, tempFilterDbPtr->asicPos,
+								tempFilterDbPtr->macAddr.octet[0], tempFilterDbPtr->macAddr.octet[1], tempFilterDbPtr->macAddr.octet[2],
+								tempFilterDbPtr->macAddr.octet[3], tempFilterDbPtr->macAddr.octet[4], tempFilterDbPtr->macAddr.octet[5], index);
+
+					m++;
+
+					for (port = 0 ; port < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum ; port ++)
+					{
+						if (tempFilterDbPtr->memberPortMask & (1<<port))
+						{
+							seq_printf(s,"%d ", port);
+						}
+					}
+					seq_printf(s,")");
+
+					switch(tempFilterDbPtr->process)
+					{
+						case FDB_TYPE_FWD:
+								seq_printf(s,"%s ", "FWD");
+								break;
+						case FDB_TYPE_DSTBLK:
+								seq_printf(s,"%s ", "DSTBLK");
+								break;
+						case FDB_TYPE_SRCBLK:
+								seq_printf(s,"%s ", "SRCBLK");
+								break;
+						case FDB_TYPE_TRAPCPU:
+								seq_printf(s,"%s ", "CPU");
+								break;
+					}
+//					seq_printf(s,"%s %s %s",tempFilterDbPtr->process?"CPU":"FWD", tempFilterDbPtr->l2type?"STA":"DYN",  tempFilterDbPtr->SrcBlk?"BLK":"");
+					seq_printf(s,"%s ",  (tempFilterDbPtr->l2type != RTL865x_L2_TYPEI)?"STA":"DYN");
+					seq_printf(s,"%s ",  (tempFilterDbPtr->l2type == RTL865x_L2_TYPEII)?"NH":"");
+
+					seq_printf(s,"%s ", tempFilterDbPtr->SrcBlk?"BLK":"");
+
+					if (tempFilterDbPtr->auth)
+					{
+						seq_printf(s,"AUTH:%d  ",tempFilterDbPtr->auth);
+					}
+
+/*					seq_printf(s,"reference count:%d",tempFilterDbPtr->refCount);*/
+					seq_printf(s,"\n");
+				}
+			}
+		}
+
+	return 0;
+}
+#else
+int32 rtl865x_sw_l2_proc_read( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int32 index = 0;
+	int32 index1 = 0;
+	int len=0;
+	uint32 port, m=0;
+	rtl865x_filterDbTable_t *filterDbPtr;
+	rtl865x_filterDbTableEntry_t  *tempFilterDbPtr;
+
+	len = sprintf(page, "%s\n", "sw l2 table:");
+
+	for(index=0,filterDbPtr=&sw_FDB_Table.filterDB[0]; index<RTL865x_FDB_NUMBER; index++,filterDbPtr++) {
+		for(index1=0; index1<RTL8651_L2TBL_ROW; index1++)
+			if (SLIST_FIRST(&(filterDbPtr->database[index1])))
+			{
+				SLIST_FOREACH(tempFilterDbPtr, &(filterDbPtr->database[index1]), nextFDB)
+				{
+					len += sprintf(page + len, "%4d.[%3d,%d] %02x:%02x:%02x:%02x:%02x:%02x FID:%x mbr(",m, index1, tempFilterDbPtr->asicPos,
+								tempFilterDbPtr->macAddr.octet[0], tempFilterDbPtr->macAddr.octet[1], tempFilterDbPtr->macAddr.octet[2],
+								tempFilterDbPtr->macAddr.octet[3], tempFilterDbPtr->macAddr.octet[4], tempFilterDbPtr->macAddr.octet[5], index);
+
+					m++;
+
+					for (port = 0 ; port < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum ; port ++)
+					{
+						if (tempFilterDbPtr->memberPortMask & (1<<port))
+						{
+							len += sprintf(page + len,"%d ", port);
+						}
+					}
+					len += sprintf(page + len,")");
+
+					switch(tempFilterDbPtr->process)
+					{
+						case FDB_TYPE_FWD:
+								len += sprintf(page + len,"%s ", "FWD");
+								break;
+						case FDB_TYPE_DSTBLK:
+								len += sprintf(page + len,"%s ", "DSTBLK");
+								break;
+						case FDB_TYPE_SRCBLK:
+								len += sprintf(page + len,"%s ", "SRCBLK");
+								break;
+						case FDB_TYPE_TRAPCPU:
+								len += sprintf(page + len,"%s ", "CPU");
+								break;
+					}
+//					len += sprintf(page + len,"%s %s %s",tempFilterDbPtr->process?"CPU":"FWD", tempFilterDbPtr->l2type?"STA":"DYN",  tempFilterDbPtr->SrcBlk?"BLK":"");
+					len += sprintf(page + len,"%s ",  (tempFilterDbPtr->l2type != RTL865x_L2_TYPEI)?"STA":"DYN");
+					len += sprintf(page + len,"%s ",  (tempFilterDbPtr->l2type == RTL865x_L2_TYPEII)?"NH":"");
+
+					len += sprintf(page + len,"%s ", tempFilterDbPtr->SrcBlk?"BLK":"");
+
+					if (tempFilterDbPtr->auth)
+					{
+						len += sprintf(page + len,"AUTH:%d  ",tempFilterDbPtr->auth);
+					}
+
+/*					len += sprintf(page + len,"reference count:%d",tempFilterDbPtr->refCount);*/
+					len += sprintf(page + len,"\n");
+				}
+			}
+		}
+
+	return len;
+}
+#endif
+
+int32 rtl865x_sw_l2_proc_write( struct file *filp, const char *buff,unsigned long len, void *data )
+{
+	return len;
+}
+#endif
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+int32 rtl865x_updateAuthState(int32 auth, const unsigned char *addr)
+{
+    int32 found = FAILED;
+    ether_addr_t *macAddr;
+    int32 ret=FAILED;
+    //int8 port_num = -1;
+    int32 column;
+    uint32 rowIdx;
+    rtl865x_tblAsicDrv_l2Param_t    fdbEntry;
+    //rtl865x_filterDbTableEntry_t        l2temp_entry;
+	rtl865x_filterDbTable_t *fdb_t = &sw_FDB_Table.filterDB[RTL_LAN_FID];
+	rtl865x_filterDbTableEntry_t *tmpL2;
+
+    if (addr == NULL)
+	return RTL_EINVALIDINPUT;
+    //printk("[%s][%d].\n", __FUNCTION__, __LINE__);
+    macAddr = (ether_addr_t *)(addr);
+	rowIdx = rtl8651_filterDbIndex(macAddr, RTL_LAN_FID);
+    found = rtl865x_Lookup_fdb_entry(RTL_LAN_FID, macAddr, FDB_DYNAMIC, &column, &fdbEntry);
+    if (found == SUCCESS )
+    {
+	//port_num = rtl865x_ConvertPortMasktoPortNum(fdbEntry.memberPortMask);
+	//printk("[%s][%d].\n", __FUNCTION__, __LINE__);
+	//printk("\nbefore rtl865x_lookup_FilterDatabaseEntry, port is %d\n", port_num);
+
+	if (auth != fdbEntry.auth)
+	{
+	    //update hw l2
+		rtl8651_setAsicL2Table_Patch(
+				rowIdx,
+				column,
+				macAddr,
+				fdbEntry.cpu,
+				fdbEntry.srcBlk,
+				fdbEntry.memberPortMask,
+				fdbEntry.ageSec,
+				fdbEntry.isStatic,
+				fdbEntry.nhFlag,
+				fdbEntry.fid,
+				auth);
+	    //update sw l2
+	    if (SLIST_FIRST(&(fdb_t->database[rowIdx])))
+	    {
+		SLIST_FOREACH(tmpL2, &(fdb_t->database[rowIdx]), nextFDB)
+		{
+		     if (memcmp(&(tmpL2->macAddr), macAddr, 6)== 0)
+		    {
+			if((tmpL2->auth != auth))
+			{
+			    tmpL2->auth             = auth;
+			    break;
+			}
+		    }
+		}
+	    }
+
+	}
+
+    }
+    else
+    {
+	//printk("[%s][%d].\n", __FUNCTION__, __LINE__);
+	/*add */
+    }
+    return ret;
+}
+#endif
+
+int32 rtl865x_isEthPortMask(uint32 portMask)
+{
+	int i;
+	for(i=0; i <=RTL8651_PHY_NUMBER; i++)
+	{
+
+		if((1<<i) & portMask)
+		{
+			return TRUE;
+		}
+	}
+
+	return FALSE;
+}
+
+
+int32 rtl865x_isEthMac(void  *mac)
+{
+
+	int i;
+	//memset(mac, 0, sizeof(ether_addr_t));
+	uint32 fdb_type[]={ FDB_STATIC, FDB_DYNAMIC };
+	uint16 fid = 0;
+	uint32 column;
+	rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+
+	for(i=0; i<2; i++)
+	{
+
+		if(rtl865x_Lookup_fdb_entry(fid,(ether_addr_t*)mac, fdb_type[i], &column,&fdbEntry) != SUCCESS)
+		{
+			continue;
+		}
+
+		if(rtl865x_isEthPortMask(fdbEntry.memberPortMask )==TRUE)
+		{
+			return TRUE;
+		}
+
+	}
+
+	return FALSE;
+}
+
+#if defined(CONFIG_RTL_HARDWARE_NAT) //&&defined(REINIT_SWITCH_CORE)
+void rtl819x_init_l2_bakup_entry(void)
+{
+	memset((void *)&l2_entry_bak, 0x00, sizeof(l2_entry_bak));
+
+	return;
+}
+
+int32 rtl819x_save_inused_l2_entry(ipaddr_t ip, ether_addr_t *mac, uint32 fid)
+{
+	uint32 column;
+	int32 ret = FAILED, i = 0;
+	rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+	ether_addr_t empty_mac = { {0x00, 0x00, 0x00, 0x00, 0x00, 0x00} };
+
+	//parameter check
+	if((mac==NULL))
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	ret = rtl865x_Lookup_fdb_entry(fid, mac, FDB_DYNAMIC, &column,&fdbEntry);
+	if (ret == SUCCESS){
+		//found it , store it.
+		for (i = 0; i < L2_BAKUP_ENTRY_MAX; i++){
+			//find empty entry to store
+			if (!memcmp(l2_entry_bak[i].macAddr.octet, empty_mac.octet, ETHER_ADDR_LEN)){
+				memcpy((void *)&l2_entry_bak[i], (void *)&fdbEntry, sizeof(fdbEntry));
+				//panic_printk("%s %d ip=0x%x mac=0x%x:%x:%x:%x:%x:%x i=%d \n", __FUNCTION__, __LINE__, ip, mac->octet[0], mac->octet[1], mac->octet[2], mac->octet[3], mac->octet[4], mac->octet[5], i);
+				return SUCCESS;
+			}
+		}
+	}
+
+
+	return ret;
+}
+int rtl819x_restore_hw_l2_table(void)
+{
+	int32 i = 0, ret = FAILED;
+	uint32 type;
+	rtl865x_tblAsicDrv_l2Param_t *entry = NULL;
+	ether_addr_t empty_mac = { {0x00, 0x00, 0x00, 0x00, 0x00, 0x00} };
+
+	for (i = 0; i < L2_BAKUP_ENTRY_MAX; i++){
+		//restore non-empty entry
+		if (memcmp(l2_entry_bak[i].macAddr.octet, empty_mac.octet, ETHER_ADDR_LEN)){
+
+			entry = &l2_entry_bak[i];
+			if (entry->cpu)
+				type = FDB_TYPE_TRAPCPU;
+			else
+				type = FDB_TYPE_FWD;
+
+			ret = _rtl865x_addFilterDatabaseEntry((entry->nhFlag==0)?RTL865x_L2_TYPEI: RTL865x_L2_TYPEII, entry->fid, (ether_addr_t *)&entry->macAddr, type, entry->memberPortMask, entry->auth,entry->srcBlk);
+			//panic_printk("%s %d ret=%d type=0x%x \n", __FUNCTION__, __LINE__, ret, type);
+		}
+	}
+
+	return ret;
+}
+
+#endif
+
+#if defined CONFIG_RTL_L2_HW_MULTICAST_SUPPORT
+int rtl_delFilterDatabaseEntryforMCast(unsigned char *mac)
+{
+	ether_addr_t macAddr;
+	macAddr.octet[0] = mac[0];
+	macAddr.octet[1] = mac[1];
+	macAddr.octet[2] = mac[2];
+	macAddr.octet[3] = mac[3];
+	macAddr.octet[4] = mac[4];
+	macAddr.octet[5] = mac[5];
+	return rtl865x_delFilterDatabaseEntry(0, 0, &macAddr);
+}
+int rtl_addFilterDatabaseEntryforMCast(unsigned char *mac, unsigned int fwdPortMask)
+{
+	ether_addr_t macAddr;
+	macAddr.octet[0] = mac[0];
+	macAddr.octet[1] = mac[1];
+	macAddr.octet[2] = mac[2];
+	macAddr.octet[3] = mac[3];
+	macAddr.octet[4] = mac[4];
+	macAddr.octet[5] = mac[5];
+	return rtl865x_addFilterDatabaseEntry(0, &macAddr, fwdPortMask, FDB_TYPE_FWD);
+}
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_fdb.h b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_fdb.h
new file mode 100644
index 00000000..aa46f09
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_fdb.h
@@ -0,0 +1,137 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL8651_FDB_H
+#define RTL8651_FDB_H
+#define RTL8651_MAC_NUMBER						6
+#define RTL8651_PORT_NUMBER						RTL8651_MAC_NUMBER
+#define RTL8651_MII_PORTNUMBER                 			5
+#define RTL8651_MII_PORTMASK                    			0x20
+#define RTL8651_PHY_NUMBER						5
+//#define RTL8651_AGGREGATOR_NUMBER				(RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum)
+//#define RTL8651_PSOFFLOAD_RESV_PORT				(RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum+1)	/* port reserved for protocol stack offloading */
+#define RTL8651_ALLPORTMASK				((1<<RTL8651_AGGREGATOR_NUMBER)-1)
+#define RTL8651_PHYSICALPORTMASK			((1<<RTL8651_MAC_NUMBER)-1)
+#define RTL8651_L2TBL_ROW					256
+#define RTL8651_L2TBL_COLUMN				4
+#define RTL8651_MAX_AGGREGATION_NUM		1
+#define RTL8651_VLAN_NUMBER				8
+#define RTL865XC_NETINTERFACE_NUMBER		8
+#define RTL865XC_MAC_NETINTERFACE_NUMBER		4
+#define RTL865XC_PORT_NUMBER				9
+#define RTL865XC_VLAN_NUMBER				4096
+#define RTL865XC_LAGHASHIDX_NUMBER			8	/* There are 8 hash values in RTL865xC Link Aggregation. */
+#define RTL8651_CPU_PORTNUMBER			RTL8651_MAC_NUMBER
+
+#define RTL8651_L2_NUMBER				1024
+
+#define	FDB_TYPE_FWD					0x00
+#define	FDB_TYPE_SRCBLK				0x01
+#define	FDB_TYPE_DSTBLK				0x02
+#define	FDB_TYPE_TRAPCPU				0x03
+
+#define RTL865X_FDBENTRY_TIMEOUT		0x1001		/*fdb entry time out*/
+#define RTL865X_FDBENTRY_450SEC		0x1002		/*fdb entry 450s timing*/
+#define RTL865X_FDBENTRY_300SEC		0x1004		/*fdb entry 300s timing*/
+#define RTL865X_FDBENTRY_150SEC		0x1008		/*fdb entry 150s timing*/
+#define RTL865X_FDBENTRY_SWAP			0x1010		/*fdb entry swap */
+#define CONFIG_RTL865X_SYNC_L2		1
+
+//#define CONFIG_RTL865X_LANPORT_RESTRICTION
+/*
+Note:
+1. Entry property toCpu, srcBlocking destination blocking (memberPortMask) and normal forwarding (Neither toCpu nor srcBlocking) are
+	mutually exclusive. Therefore, only 2-bit to represent this situation.
+2. All entries are static configuration
+3. Unable to process conflict macAddress entry process, return fail when following operation are conflict with current one.
+*/
+typedef struct rtl865x_filterDbTableEntry_s {
+	ether_addr_t	macAddr;
+	uint16  l2type;			// see bleow definition
+	uint16	process:2,		//0: Normal forwarding, 1: destination blocking 2: source blocking 3: toCpu
+			//Management flag
+			refCount:8,		//Referenced by other table, such as
+			configToAsic:1,	//This entry is configured to ASIC
+			asicPos:2,		//The entry position of the ASIC. Since rtl8651 only provides 4-entry. Only 2-bit is required
+			SrcBlk:1,
+			auth:1,
+			nhFlag:1;
+	uint16 	vid;				//0: don't care. 1~4094: vid of this entry
+	uint32	linkId;			//For WLAN WDS.
+		//cfliu: What is link Id? link Id is a virtual port number which represents a WDS link for wireless application.
+		//since 8650 uses MII loopback port and 8650B has only 3 ext ports, it is always insufficient to map 8650B ext ports
+		//to typical 8 WDS links.
+
+	uint32	memberPortMask;
+	SLIST_ENTRY(rtl865x_filterDbTableEntry_s) nextFDB;
+} rtl865x_filterDbTableEntry_t;
+
+
+typedef struct rtl865x_filterDbTable_s {
+	uint16 sid;// Spanning tree ID, 0: CIST id, 1-4096 MST ID
+	uint32 valid:1;	//Whether this filter database is valid
+	SLIST_HEAD(, rtl865x_filterDbTableEntry_s) database[RTL8651_L2TBL_ROW];
+} rtl865x_filterDbTable_t;
+
+struct rtl865x_L2Tables{
+	rtl865x_filterDbTable_t *filterDB;
+	struct freefdbEntryList_s {
+		SLIST_HEAD( _FreeFDBEntry, rtl865x_filterDbTableEntry_s) filterDBentry;
+	} freefdbList;
+};
+
+// int32 rtl865x_arp_register_event(void);
+
+int32 rtl865x_layer2_init(void);
+int32 _rtl865x_addFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr, uint32 type, uint32 portMask, uint8 auth, uint8 SrcBlk);
+int32 _rtl865x_addAuthFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr, uint32 type, uint32 portMask, uint8 auth, uint8 SrcBlk);
+int32 _rtl865x_delAuthFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr);
+int32 rtl865x_addAuthFilterDatabaseEntryExtension( uint16 fid, rtl865x_filterDbTableEntry_t * L2entry);
+int32 rtl865x_delAuthFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr);
+int32 _rtl865x_delFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr);
+uint32 rtl865x_getHWL2Index(ether_addr_t * macAddr, uint16 fid);
+int32 rtl865x_setHWL2Table(uint32 row, uint32 column, rtl865x_tblAsicDrv_l2Param_t *l2p);
+int32 rtl865x_getHWL2Table(uint32 row, uint32 column, rtl865x_tblAsicDrv_l2Param_t *l2p);
+int32 rtl865x_refleshHWL2Table(ether_addr_t * macAddr, uint32 flags,uint16 fid);
+extern int32 rtl865x_Lookup_fdb_entry(uint32 fid, ether_addr_t *mac, uint32 flags, uint32 *col_num, rtl865x_tblAsicDrv_l2Param_t *L2buff);
+//int32 rtl865x_addFilterDatabaseEntry( uint32 fid, ether_addr_t * mac, uint32 portmask, uint32 type , uint32 isStatic);
+int32 rtl865x_addFilterDatabaseEntry( uint32 fid, ether_addr_t * mac, uint32 portmask, uint32 type );
+int32 rtl865x_addFilterDatabaseEntryExtension( uint16 fid, rtl865x_filterDbTableEntry_t * L2entry);
+int32 rtl865x_getReserveMacAddr(ether_addr_t *macAddr);
+int32 rtl865x_delFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr);
+int32 rtl865x_ConvertPortMasktoPortNum(int32 portmask);
+int32 rtl865x_delLanFDBEntry(uint16 l2Type,  const unsigned char *addr);
+int32 rtl865x_delAuthLanFDBEntry(uint16 l2Type,  const unsigned char *addr);
+int32 rtl865x_addFDBEntry(const unsigned char *addr);
+int32 rtl865x_arrangeFdbEntry(const unsigned char *timeout_addr, int32 *port);
+int32 rtl865x_lookup_FilterDatabaseEntry(uint16 fid, ether_addr_t * mac, rtl865x_filterDbTableEntry_t *l2_entry);
+
+#ifdef CONFIG_RTL_LINKCHG_PROCESS
+int32 rtl865x_LinkChange_Process(void);
+#endif
+int32 rtl865x_isEthPortMask(uint32 portMask);
+int32 rtl865x_isEthMac(void  *mac);
+
+
+#ifndef CONFIG_OPENWRT_SDK
+#define CONFIG_RTL_CUSTOM_PASSTHRU
+#endif
+//#define CONFIG_RTL_CUSTOM_PASSTHRU_PPPOE
+#ifdef CONFIG_RTL_CUSTOM_PASSTHRU
+#define PASSTHRU_VLAN_ID 100
+
+#define IP6_PASSTHRU_RULEID 5
+#define PPPOE_PASSTHRU_RULEID1 3
+#define PPPOE_PASSTHRU_RULEID2 4
+#define IP6_PASSTHRU_MASK 0x1
+#define PPPOE_PASSTHRU_MASK 0x1<<1
+#endif
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_hw_qos_config.c b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_hw_qos_config.c
new file mode 100644
index 00000000..5c7d867
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_hw_qos_config.c
@@ -0,0 +1,799 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/proc_fs.h>
+#include <linux/types.h>
+#include <linux/errno.h>
+#include <linux/sched.h>
+#include <linux/kernel.h>
+#include <linux/kernel_stat.h>
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <asm/uaccess.h>
+#include <linux/net.h>
+#include <linux/socket.h>
+
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/string.h>
+#include <net/ip.h>
+#include <net/protocol.h>
+#include <net/route.h>
+#include <net/sock.h>
+#include <net/arp.h>
+#include <net/raw.h>
+#include <net/checksum.h>
+#include <linux/netfilter.h>
+#include <linux/netfilter_ipv4.h>
+#include <linux/netlink.h>
+#include <linux/inetdevice.h>
+#include <linux/icmp.h>
+#include <net/udp.h>
+#include <net/tcp.h>
+
+#include <net/rtl/rtl_types.h>
+#ifdef CONFIG_NETFILTER
+#include <net/netfilter/nf_conntrack.h>
+#include <net/rtl/fastpath/fastpath_core.h>
+#endif
+#include <net/rtl/rtl865x_netif.h>
+#include <net/rtl/rtl_nic.h>
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include <AsicDriver/asicRegs.h>
+#include <AsicDriver/rtl865x_asicCom.h>
+#include <AsicDriver/rtl865x_asicL2.h>
+#else
+#include <AsicDriver/asicRegs.h>
+#include <AsicDriver/rtl8651_tblAsicDrv.h>
+#endif
+#ifdef __KERNEL__
+#include <linux/version.h>
+#endif
+
+#ifdef CONFIG_RTL_8197F
+#include <common/rtl865x_vlan.h>
+#include <common/rtl_errno.h>
+#endif
+
+#define CHLOE_FOR_TEST 1
+
+struct sock *hw_qos_sk = NULL;
+
+struct qos_cmd_info_s{
+	int action;
+	union{
+		struct{
+			char port[8];
+			unsigned int portmask;
+		} port_based_priority, queue_num;
+		struct{
+			char vlan[8];
+			unsigned int vlanmask;
+		}vlan_based_priority;
+		struct{
+			char dscp[64];
+			unsigned int dscpmask1;
+			unsigned int dscpmask2;
+		}dscp_based_priority;
+		#if defined(CONFIG_RTL_8197F)
+		struct{
+			unsigned char vid[5];
+			unsigned char pri[5];
+		}vid_based_priority;
+		#endif
+		struct{
+		#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			unsigned char queue[8][8];
+		#else
+			unsigned char queue[8][6];
+		#endif
+			unsigned int portmask;
+			unsigned int queuemask;
+		}queue_type;
+		struct{
+			char priority[8];
+			unsigned int prioritymask;
+		}sys_priority;
+		struct{
+			#if defined(CONFIG_RTL_8197F)
+			char decision[6];
+			#else
+			char decision[5];
+			#endif
+		}pri_decision;
+		struct{
+			char remark[8][8];
+			unsigned int portmask;
+			unsigned int prioritymask;
+		}vlan_remark, dscp_remark;
+		struct{
+			unsigned int apr[8][6];
+			unsigned char burst[8][6];
+			unsigned char ppr[8][6];
+			unsigned int portmask;
+			unsigned int queuemask;
+		}queue_rate;
+		struct{
+			unsigned int portmask;
+			unsigned short apr[8];
+		}port_rate;
+		struct{
+			unsigned int portmask;
+			unsigned short pri[8];
+		}port_pri;
+	} qos_data;
+};
+
+#define PORT_BASED_PRIORITY_ASSIGN 1
+#define VLAN_BASED_PRIORITY_ASSIGN 2
+#define DSCP_BASED_PRIORITY_ASSIGN 3
+#define QUEUE_NUMBER 4
+#define QUEUE_TYPE_STRICT 5
+#define QUEUE_TYPE_WEIGHTED 6
+#define PRIORITY_TO_QID 7
+#define PRIORITY_DECISION 8
+#define VLAN_REMARK 9
+#define DSCP_REMARK 10
+#define PORT_BASED_PRIORITY_SHOW 11
+#define VLAN_BASED_PRIORITY_SHOW 12
+#define DSCP_BASED_PRIORITY_SHOW 13
+#define QUEUE_NUMBER_SHOW 14
+#define QUEUE_TYPE_STRICT_SHOW 15
+#define QUEUE_TYPE_WEIGHTED_SHOW 16
+#define PRIORITY_TO_QID_SHOW 17
+#define PRIORITY_DECISION_SHOW 18
+#define VLAN_REMARK_SHOW 19
+#define DSCP_REMARK_SHOW 20
+#define QUEUE_RATE 21
+#define QUEUE_RATE_SHOW 22
+#define FLOW_CONTROL_ENABLE 23
+#define FLOW_CONTROL_DISABLE 24
+#define FLOW_CONTROL_CONFIGURATION_SHOW 25
+#define PORT_RATE 26
+#define PORT_RATE_SHOW 27
+#define PORT_DEFAULT_8021P 28
+#define PORT_DEFAULT_8021P_SHOW 29
+#if defined(CONFIG_RTL_8197F)
+#define VID_BASED_PRIORITY_ASSIGN 30
+#define VID_BASED_PRIORITY_SHOW 31
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define MAX_QUEUE_NUM		8
+#else
+#define MAX_QUEUE_NUM		6
+#endif
+int32 rtl8651_setAsicPortDefPri(uint32 port, uint32 pri);
+int32 rtl8651_getAsicPortDefPri(uint32 port, uint32 *pri) ;
+
+static inline void port_based_priority_show(void)
+{
+	int i, ret;
+	enum PRIORITYVALUE priority;
+
+	printk("PORT_BASED_PRIORITY: \n");
+	for(i=0; i<9; i++){
+		ret = rtl8651_getAsicPortBasedPriority(i, &priority);
+		if(ret == SUCCESS)
+			printk("    Priority of port[%d] is %d\n", i, priority);
+	}
+
+	return;
+}
+
+static inline void vlan_based_priority_show(void)
+{
+	int i, ret;
+	enum PRIORITYVALUE priority;
+
+	printk("VLAN_BASED_PRIORITY: \n");
+	for(i=0; i<9; i++){
+		ret = rtl8651_getAsicDot1qAbsolutelyPriority(i, &priority);
+		if(ret == SUCCESS)
+			printk("    Priority of vlan_pri[%d] is %d\n", i, priority);
+	}
+
+	return;
+}
+
+static inline void dscp_based_priority_show(void)
+{
+	int i, ret;
+	enum PRIORITYVALUE priority;
+
+	printk("DSCP_BASED_PRIORITY: \n");
+	for(i=0; i<64; i++){
+		ret = rtl8651_getAsicDscpPriority(i, &priority);
+		if(ret == SUCCESS)
+			printk("    Priority of dscp[%d] is %d\n", i, priority);
+	}
+
+	return;
+}
+
+#if defined(CONFIG_RTL_8197F)
+static inline void vid_based_priority_show(void)
+{
+	int i;
+	int ret;
+	uint8 priority;
+
+	printk("VID_BASED_PRIORITY: \n");
+
+	for(i=0; i<VLAN_NUMBER; i++){
+		ret = rtl865x_getVlanHp(i, &priority);
+		if((ret == SUCCESS))
+			printk("    Priority of vid[%d] is %d\n", i, priority);
+	}
+
+	return;
+}
+#endif
+
+static inline void queue_number_show(void)
+{
+	int i, ret;
+	enum QUEUENUM qnum;
+
+	printk("QUEUE_NUMBER: \n");
+	for(i=0; i<8; i++){
+		ret = rtl8651_getAsicOutputQueueNumber(i, &qnum);
+		if(ret == SUCCESS)
+			printk("    Queue number of port[%d] is %d\n", i, qnum);
+	}
+
+	return;
+}
+
+static inline void queue_type_strict_show(void)
+{
+	int i, ret, j;
+	enum QUEUETYPE queueType;
+
+	printk("QUEUE_TYPE_STRICT: \n");
+	for(i=0; i<8; i++){
+		for(j=0; j < MAX_QUEUE_NUM; j++){
+			ret = rtl8651_getAsicQueueStrict(i, j, &queueType);
+			if((ret == SUCCESS) && (queueType == 0))
+				printk("    Port[%d]'s  Queue[%d] type is STRICT\n", i, j);
+		}
+	}
+
+	return;
+}
+
+static inline void queue_type_weighted_show(void)
+{
+	int i, ret, j, weight;
+	enum QUEUETYPE queueType;
+
+	printk("QUEUE_TYPE_WEIGHTED: \n");
+	for(i=0; i<8; i++){
+		for(j=0; j < MAX_QUEUE_NUM; j++){
+			ret = rtl8651_getAsicQueueWeight(i, j, &queueType, &weight);
+			if((ret == SUCCESS) && (queueType == 1))
+				printk("    Port[%d]'s  Queue[%d] type is WEIGHTED, and weight is %u\n", i, j, weight);
+		}
+	}
+
+	return;
+}
+
+static inline void priority_to_qid_show(void)
+{
+	int i, j, ret;
+	enum QUEUEID qid;
+
+	printk("PRIORITY_TO_QID: \n");
+	for(i=1; i < (MAX_QUEUE_NUM+1); i++){
+		for(j=0; j<8; j++){
+			ret = rtl8651_getAsicPriorityToQIDMappingTable(i, j, &qid);
+			if(ret == SUCCESS)
+				printk("    For Queue number[%d], priority[%d] is mapping to qid[%d]\n", i, j, qid);
+		}
+	}
+
+	return;
+}
+
+
+static inline void priority_decision_show(void)
+{
+	unsigned int portpri, dot1qpri, dscppri, aclpri, natpri;
+	#if defined(CONFIG_RTL_8197F)
+	unsigned int vidpri;
+	#endif
+	int ret;
+
+	printk("PRIORITY_DECISION: \n");
+	#if defined(CONFIG_RTL_8197F)
+	ret = rtl8651_getAsicPriorityDecision(&portpri, &dot1qpri, &dscppri, &aclpri, &natpri, &vidpri);
+	#else
+	ret = rtl8651_getAsicPriorityDecision(&portpri, &dot1qpri, &dscppri, &aclpri, &natpri);
+	#endif
+	if(ret == SUCCESS){
+		printk("    Port   based decision priority is %d\n", portpri);
+		printk("    Vlan  based decision priority is %d\n", dot1qpri);
+		printk("    Dscp based decision priority is %d\n", dscppri);
+		printk("    Acl    based decision priority is %d\n", aclpri);
+		printk("    Nat    based decision priority is %d\n", natpri);
+		#if defined(CONFIG_RTL_8197F)
+		printk("    VID    based decision priority is %d\n", vidpri);
+		#endif
+	}
+
+	return;
+}
+
+static inline void vlan_remark_show(void)
+{
+	int i, j, ret, remark;
+
+	printk("VLAN_REMARK: \n");
+	for(i=0; i<8; i++){
+		for(j=0; j<8; j++){
+			ret = rtl8651_getAsicVlanRemark(i, j, &remark);
+			if(ret == SUCCESS)
+				printk("    Port[%d]'s sys_pri[%d] is remarked as vlan_pri[%d]\n", i, j, remark);
+		}
+
+	}
+
+	return;
+}
+
+static inline void dscp_remark_show(void)
+{
+	int i, j, ret, remark;
+
+	printk("DSCP_REMARK: \n");
+	for(i=0; i<8; i++){
+		for(j=0; j<8; j++){
+			ret = rtl8651_getAsicDscpRemark(i, j, &remark);
+			if(ret == SUCCESS)
+				printk("    Port[%d]'s sys_pri[%d] is remarked as dscp[%d]\n", i, j, remark);
+		}
+
+	}
+
+	return;
+}
+
+static inline void queue_rate_show(void)
+{
+	int i, j, ret;
+	unsigned int ppr, apr, burst;
+
+	printk("QUEUE_RATE: \n");
+	for(i=0; i<8; i++){
+		for(j=0; j < MAX_QUEUE_NUM; j++){
+			ret = rtl8651_getAsicQueueRate(i, j, &ppr, &burst, &apr);
+			if(ret == SUCCESS)
+				printk("    Port[%d] queue[%d]'s  ppr is %d, burst is %d, apr is %dkbps\n", i, j, ppr, burst, apr+1);
+		}
+
+	}
+
+	return;
+}
+
+static inline void port_default_8021p_show(void)
+{
+	int i, ret;
+	unsigned int pri;
+
+	printk("PORT_DEFAULT_8021P: \n");
+	for(i=0; i<8; i++){
+		ret = rtl8651_getAsicPortDefPri(i, &pri);
+		if(ret == SUCCESS)
+			printk("    Port[%d]'s default 8021p is %d\n", i, pri);
+	}
+
+	return;
+}
+
+static inline void port_rate_show(void)
+{
+	int i, ret;
+	unsigned int apr;
+
+	printk("PORT_RATE: \n");
+	for(i=0; i<8; i++){
+		ret = rtl8651_getAsicPortEgressBandwidth(i, &apr);
+		if(ret == SUCCESS)
+			//printk("    Port[%d]'s apr is %dMbps\n", i, (apr+1)*1024);
+			printk("    Port[%d]'s apr is %dKbps\n", i, apr+1);
+	}
+
+	return;
+}
+
+static inline void flow_control_config_show(void)
+{
+	unsigned int flow_control_enable = 0;
+	int ret;
+
+	ret = rtl8651_getAsicQueueFlowControlConfigureRegister(0, 0, &flow_control_enable);
+	if(ret == SUCCESS){
+		if(flow_control_enable == 1){
+			printk("    QOS Flow Control is enabled!\n");
+		}else{
+			printk("    QOS Flow Control is disabled!\n");
+		}
+	}
+}
+
+int32 rtl8651_setAsicPortDefPri(uint32 port, uint32 pri)
+{
+	uint32 regValue,offset;
+
+	if(port>=RTL8651_AGGREGATOR_NUMBER || pri>=8)
+		return FAILED;
+
+	offset=(port*2)&(~0x3);
+	regValue=READ_MEM32(PVCR0+offset);
+	if((port&0x1))
+	{
+		regValue=  ((pri &0x7) <<(16+12)) | (regValue&~0x70000000);
+	}
+	else
+	{
+		regValue =  ((pri &0x7)<<12) | (regValue &~0x7000);
+	}
+	WRITE_MEM32(PVCR0+offset,regValue);
+	return SUCCESS;
+}
+
+int32 rtl8651_getAsicPortDefPri(uint32 port, uint32 *pri)
+{
+	uint16 offset;
+	offset=(port*2)&(~0x3);
+	if(port>=RTL8651_AGGREGATOR_NUMBER || pri == NULL)
+		return FAILED;
+	if((port&0x1))
+	{
+		*pri=(((READ_MEM32(PVCR0+offset)>>(16+12))&0x7));
+	}
+	else
+	{
+		*pri=(((READ_MEM32(PVCR0+offset)>>12)&0x7));
+	}
+	return SUCCESS;
+}
+
+void hw_qos_netlink_receive (struct sk_buff *__skb)
+{
+// to_be_checked !!!
+#if 1//ndef CONFIG_RTL_8198C
+	unsigned int i, j;
+	enum QUEUENUM queue_num;
+	int ret;
+	int pid = 0;
+	struct qos_cmd_info_s send_data,recv_data;
+
+	pid=rtk_nlrecvmsg(__skb, sizeof(struct qos_cmd_info_s), &recv_data);
+
+	if(pid<0)
+		return;
+
+	switch(recv_data.action)
+	{
+		case PORT_BASED_PRIORITY_ASSIGN:
+			for(i=0; i<8; i++){
+				if((1<<i) & recv_data.qos_data.port_based_priority.portmask){
+					ret = rtl8651_setAsicPortBasedPriority(i, recv_data.qos_data.port_based_priority.port[i]);
+					if(ret == FAILED){
+						printk("Port based priority set to PBPCR register failed\n ");
+					}
+
+				}
+			}
+			send_data.action = PORT_BASED_PRIORITY_ASSIGN;
+			break;
+		case VLAN_BASED_PRIORITY_ASSIGN:
+			for(i=0; i<8; i++){
+				if((1<<i) & recv_data.qos_data.vlan_based_priority.vlanmask){
+					ret = rtl8651_setAsicDot1qAbsolutelyPriority(i, recv_data.qos_data.vlan_based_priority.vlan[i]);
+					if(ret == FAILED){
+						printk("Vlan based priority set to LPTM8021Q register failed\n ");
+					}
+				}
+			}
+			send_data.action = VLAN_BASED_PRIORITY_ASSIGN;
+			break;
+		case DSCP_BASED_PRIORITY_ASSIGN:
+			for(i=0; i<64; i++){
+				if(((i<32) && ((1<<i) & recv_data.qos_data.dscp_based_priority.dscpmask1)) ||
+				   ((i>=32) && ((1<<(i-32)) & recv_data.qos_data.dscp_based_priority.dscpmask2))){
+					ret = rtl8651_setAsicDscpPriority(i, recv_data.qos_data.dscp_based_priority.dscp[i]);
+					if(ret == FAILED){
+						printk("Dscp based priority set to DSCPCR register failed\n ");
+					}
+				}
+			}
+			send_data.action = DSCP_BASED_PRIORITY_ASSIGN;
+			break;
+
+		#if defined(CONFIG_RTL_8197F)
+		case VID_BASED_PRIORITY_ASSIGN:
+			for(i=0; i<5; i++){
+				if(recv_data.qos_data.vid_based_priority.vid[i]){
+					//panic_printk("vid%d is %d in kernel.\n", i, recv_data.qos_data.vid_based_priority.vid[i]);
+
+					if(!_rtl8651_getVlanTableEntry(recv_data.qos_data.vid_based_priority.vid[i]-'0')){
+						panic_printk("vlan table don't have the entry of vid%c.\n", recv_data.qos_data.vid_based_priority.vid[i]);
+						continue;
+					}
+					ret = rtl865x_setVlanHp(recv_data.qos_data.vid_based_priority.vid[i]-'0', recv_data.qos_data.vid_based_priority.pri[i]-'0');
+					if(ret == FAILED){
+						panic_printk("Vid based priority set to vlan table failed\n ");
+					}
+					if(ret == RTL_EINVALIDVLANID){
+						panic_printk("Invalid Vlan Id, vid%c\n", recv_data.qos_data.vid_based_priority.vid[i]);
+					}
+				}
+			}
+			break;
+		#endif
+
+		case QUEUE_NUMBER:
+			for(i=0; i<8; i++){
+				if((1<<i) & recv_data.qos_data.queue_num.portmask){
+					ret = rtl8651_setAsicOutputQueueNumber(i, recv_data.qos_data.queue_num.port[i]);
+					if(ret == FAILED){
+						printk("Queue number set to QNUMCR register failed\n ");
+					}
+				}
+			}
+			send_data.action = QUEUE_NUMBER;
+			break;
+		case QUEUE_TYPE_STRICT:
+			for(i=0; i<8; i++){
+				if((1<<i) & recv_data.qos_data.queue_type.portmask){
+					for(j=0; j < MAX_QUEUE_NUM; j++){
+						if((1<<j) & recv_data.qos_data.queue_type.queuemask){
+							if(recv_data.qos_data.queue_type.queue[i][j] == 255){
+									ret = rtl8651_setAsicQueueStrict(i, j, STR_PRIO);
+									if(ret == FAILED){
+										printk("Queue type STRICT set to WFQWCR0P0 register failed\n ");
+									}
+								}
+						}
+					}
+				}
+			}
+			send_data.action = QUEUE_TYPE_STRICT;
+			break;
+		case QUEUE_TYPE_WEIGHTED:
+			for(i=0; i<8; i++){
+				if((1<<i) & recv_data.qos_data.queue_type.portmask){
+					for(j=0; j < MAX_QUEUE_NUM; j++){
+						if((1<<j) & recv_data.qos_data.queue_type.queuemask){
+							if((recv_data.qos_data.queue_type.queue[i][j] > 0) &&
+					    		    (recv_data.qos_data.queue_type.queue[i][j] != 255)){
+								ret = rtl8651_setAsicQueueWeight(i, j, WFQ_PRIO, recv_data.qos_data.queue_type.queue[i][j]);
+								if(ret == FAILED){
+									printk("Queue type WEIGHTED set to WFQWCR0P0 register failed\n ");
+								}
+							}
+						}
+					}
+				}
+			}
+			send_data.action = QUEUE_TYPE_WEIGHTED;
+			break;
+		case PRIORITY_TO_QID:
+			for(i=0; i<8; i++){
+				ret = rtl8651_getAsicOutputQueueNumber(i, &queue_num);
+				if(ret == SUCCESS){
+					for(j=0; j<8; j++)
+					{
+						if((1<<j) & recv_data.qos_data.sys_priority.prioritymask){
+							ret = rtl8651_setAsicPriorityToQIDMappingTable(queue_num, j, recv_data.qos_data.sys_priority.priority[j]);
+							if(ret == FAILED){
+								printk("Priority to qid set to UPTCMCR register failed\n ");
+							}
+						}
+					}
+				}
+			}
+			send_data.action = PRIORITY_TO_QID;
+			break;
+		case PRIORITY_DECISION:
+			#if defined(CONFIG_RTL_8197F)
+			ret = rtl8651_setAsicPriorityDecision(recv_data.qos_data.pri_decision.decision[0], recv_data.qos_data.pri_decision.decision[1],
+										   recv_data.qos_data.pri_decision.decision[2], recv_data.qos_data.pri_decision.decision[3],
+										   recv_data.qos_data.pri_decision.decision[4], recv_data.qos_data.pri_decision.decision[5]);
+			#else
+			ret = rtl8651_setAsicPriorityDecision(recv_data.qos_data.pri_decision.decision[0], recv_data.qos_data.pri_decision.decision[1],
+										   recv_data.qos_data.pri_decision.decision[2], recv_data.qos_data.pri_decision.decision[3],
+										   recv_data.qos_data.pri_decision.decision[4]);
+			#endif
+			if(ret == FAILED){
+				printk("Priority decision set to QIDDPCR register failed\n ");
+			}
+			send_data.action = PRIORITY_DECISION;
+			break;
+		case VLAN_REMARK:
+			for(i=0; i<8; i++){
+				if((1<<i) & recv_data.qos_data.vlan_remark.portmask){
+					for(j=0; j<8; j++){
+						if((1<<j) & recv_data.qos_data.vlan_remark.prioritymask){
+							ret = rtl8651_setAsicVlanRemark(i, j, recv_data.qos_data.vlan_remark.remark[i][j]);
+							if(ret == FAILED){
+								printk("Vlan remark set to RMCR1P register failed\n ");
+							}
+						}
+					}
+				}
+			}
+			send_data.action = VLAN_REMARK;
+			break;
+		case DSCP_REMARK:
+			for(i=0; i<8; i++){
+				if((1<<i) & recv_data.qos_data.dscp_remark.portmask){
+					for(j=0; j<8; j++){
+						if((1<<j) & recv_data.qos_data.dscp_remark.prioritymask){
+							ret = rtl8651_setAsicDscpRemark(i, j, recv_data.qos_data.dscp_remark.remark[i][j]);
+							if(ret == FAILED){
+								printk("Dscp remark set to DSCPRM register failed\n ");
+							}
+						}
+					}
+				}
+			}
+			send_data.action = DSCP_REMARK;
+			break;
+		case QUEUE_RATE:
+			for(i=0; i<8; i++){
+				if((1<<i) & recv_data.qos_data.queue_rate.portmask){
+					for(j=0; j < MAX_QUEUE_NUM; j++){
+						if((1<<j) & recv_data.qos_data.queue_rate.queuemask){
+							ret = rtl8651_setAsicQueueRate(i, j, recv_data.qos_data.queue_rate.ppr[i][j],
+								                                      recv_data.qos_data.queue_rate.burst[i][j],
+								                                      recv_data.qos_data.queue_rate.apr[i][j]);
+							if(ret == FAILED){
+								printk("Queue rate set to P0Q0RGCR register failed\n ");
+							}
+						}
+					}
+				}
+			}
+			send_data.action = QUEUE_RATE;
+			break;
+		case PORT_RATE:
+			for(i=0; i<8; i++){
+				if((1<<i) & recv_data.qos_data.port_rate.portmask){
+					ret = rtl8651_setAsicPortEgressBandwidth(i, recv_data.qos_data.port_rate.apr[i]);
+					if(ret == FAILED){
+						printk("Port rate set to WFQRCRP0 register failed\n ");
+					}
+				}
+			}
+			send_data.action = PORT_RATE;
+			break;
+		case PORT_DEFAULT_8021P:
+			for(i=0; i<8; i++){
+				if((1<<i) & recv_data.qos_data.port_pri.portmask){
+					ret = rtl8651_setAsicPortDefPri(i, recv_data.qos_data.port_pri.pri[i]);
+					if(ret == FAILED){
+						printk("Port default 8021p set to PVCRx register failed\n ");
+					}
+				}
+			}
+			send_data.action = PORT_DEFAULT_8021P;
+			break;
+		case FLOW_CONTROL_ENABLE:
+			for(i=0; i<7; i++){
+				for(j=0; j < MAX_QUEUE_NUM; j++){
+					ret = rtl8651_setAsicQueueFlowControlConfigureRegister(i, j, 1);
+					if(ret == FAILED){
+						printk("Set Flow Control Enable failed\n ");
+					}
+				}
+			}
+			break;
+		case FLOW_CONTROL_DISABLE:
+			for(i=0; i<7; i++){
+				for(j=0; j < MAX_QUEUE_NUM; j++){
+					ret = rtl8651_setAsicQueueFlowControlConfigureRegister(i, j, 0);
+					if(ret == FAILED){
+						printk("Set Flow Control Disable failed\n ");
+					}
+				}
+			}
+			break;
+		case PORT_BASED_PRIORITY_SHOW:
+			port_based_priority_show();
+			break;
+		case VLAN_BASED_PRIORITY_SHOW:
+			vlan_based_priority_show();
+			break;
+		case DSCP_BASED_PRIORITY_SHOW:
+			dscp_based_priority_show();
+			break;
+		#if defined(CONFIG_RTL_8197F)
+		case VID_BASED_PRIORITY_SHOW:
+			vid_based_priority_show();
+			break;
+		#endif
+		case QUEUE_NUMBER_SHOW:
+			queue_number_show();
+			break;
+		case QUEUE_TYPE_STRICT_SHOW:
+			queue_type_strict_show();
+			break;
+		case QUEUE_TYPE_WEIGHTED_SHOW:
+			queue_type_weighted_show();
+			break;
+		case PRIORITY_TO_QID_SHOW:
+			priority_to_qid_show();
+			break;
+		case PRIORITY_DECISION_SHOW:
+			priority_decision_show();
+			break;
+		case VLAN_REMARK_SHOW:
+			vlan_remark_show();
+			break;
+		case DSCP_REMARK_SHOW:
+			dscp_remark_show();
+			break;
+		case QUEUE_RATE_SHOW:
+			queue_rate_show();
+			break;
+		case PORT_RATE_SHOW:
+			port_rate_show();
+			break;
+		case PORT_DEFAULT_8021P_SHOW:
+			port_default_8021p_show();
+			break;
+		case FLOW_CONTROL_CONFIGURATION_SHOW:
+			flow_control_config_show();
+			break;
+		default:
+			break;
+	}
+
+	rtk_nlsendmsg(pid, hw_qos_sk, sizeof(struct qos_cmd_info_s), &send_data);
+#endif
+	return;
+
+}
+
+
+int hw_qos_init_netlink(void)
+{
+// to_be_checked !!!
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,33)
+	hw_qos_sk = netlink_kernel_create(&init_net, NETLINK_RTK_HW_QOS, 0, hw_qos_netlink_receive, NULL, THIS_MODULE);
+#elif LINUX_VERSION_CODE >= KERNEL_VERSION(3,4,0)
+	struct netlink_kernel_cfg cfg;
+	memset(&cfg,0,sizeof(cfg));
+	cfg.cb_mutex =NULL;
+	cfg.groups =0;
+	cfg.input = hw_qos_netlink_receive;
+	hw_qos_sk = netlink_kernel_create(&init_net, NETLINK_RTK_HW_QOS,&cfg);
+#endif
+	if (!hw_qos_sk) {
+			printk(KERN_ERR "Netlink[Kernel] Cannot create netlink socket for hw qos config.\n");
+			return -EIO;
+	}
+	printk("Netlink[Kernel] create socket for hw qos config ok.\n");
+
+	return 0;
+}
+
+
+
+
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_outputQueue.c b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_outputQueue.c
new file mode 100644
index 00000000..6b56cd9
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_outputQueue.c
@@ -0,0 +1,3013 @@
+/*
+ *
+ *  Copyright (c) 2011 Realtek Semiconductor Corp.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 2 as
+ *  published by the Free Software Foundation.
+ */
+
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,4,0)
+#include <linux/kconfig.h>
+#else
+#include <linux/config.h>
+#endif
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include <common/rtl8651_tblDrvProto.h>
+#include <common/rtl865x_eventMgr.h>
+#include <common/rtl865x_vlan.h>
+#include <net/rtl/rtl865x_netif.h>
+#include <common/rtl865x_netif_local.h>
+#include <net/rtl/rtl865x_outputQueue.h>
+//#include "assert.h"
+//#include "rtl_utils.h"
+#include <common/rtl_errno.h>
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+#include <l3Driver/rtl865x_localPublic.h>
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include <AsicDriver/asicRegs.h>
+#include <AsicDriver/rtl865x_asicCom.h>
+#include <AsicDriver/rtl865x_asicL2.h>
+#else
+#include <AsicDriver/asicRegs.h>
+#include <AsicDriver/rtl8651_tblAsicDrv.h>
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+#include <net/pkt_cls.h>
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#include <net/rtl/rtl_nic.h>
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+#if defined CONFIG_RTL_8367_QOS_SUPPORT
+#define RTL8367_OUTPUTQUEUE_SIZE 8
+extern int rtl8367_qos_init(void);
+#endif
+uint8	netIfNameArray[NETIF_NUMBER][IFNAMSIZ] = {{0}};
+static int8	(*rtl865x_compFunc)(rtl865x_qos_t	*entry1, rtl865x_qos_t	*entry2);
+#if defined (CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+/*add 7 queue and 8 queue*/
+
+static uint8	priorityMatrix[RTL8651_OUTPUTQUEUE_SIZE][TOTAL_VLAN_PRIORITY_NUM] =
+								{{0,0,0,0,0,0,0,0},
+								{0,0,0,0,5,5,5,5},
+								{0,0,0,0,1,1,5,5},
+								{0,0,0,1,2,2,5,5},
+								{0,0,0,1,2,3,5,5},
+								{0,0,1,2,3,4,5,5},
+								{0,0,1,2,3,4,5,6},
+								{0,1,2,3,4,5,6,7}
+								};
+//priority used for not mapping to the same queue
+#else
+static uint8	priorityMatrix[RTL8651_OUTPUTQUEUE_SIZE][TOTAL_VLAN_PRIORITY_NUM] =
+								{{0,0,0,0,0,0,0,0},
+								{0,0,0,0,5,5,5,5},
+								{0,0,0,0,1,1,5,5},
+								{0,0,0,1,2,2,5,5},
+								{0,0,0,1,2,3,5,5},
+								{0,0,1,2,3,4,5,5}};
+
+#endif
+
+#if defined (CONFIG_RTL_8367_QOS_SUPPORT)
+static int32	queueMatrix[RTL8651_OUTPUTQUEUE_SIZE][RTL8367_OUTPUTQUEUE_SIZE] =
+								{{0, -1, -1, -1, -1, -1, -1, -1},
+								{0, -1, -1, -1, -1, -1, -1, 7},
+								{0, 5, -1, -1, -1, -1, -1, 7},
+								{0, 3, 5, -1, -1, -1, -1, 7},
+								{0, 3, 4, 5, -1, -1, -1, 7},
+								{0, 2, 3, 4, 5, -1, -1, 7},
+								{0, 2, 3, 4, 5 ,6, -1, 7},
+								{0, 1, 2, 3, 4, 5 ,6, 7}
+								};
+#else
+#if defined (CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static int32	queueMatrix[RTL8651_OUTPUTQUEUE_SIZE][RTL8651_OUTPUTQUEUE_SIZE] =
+								{{0, -1, -1, -1, -1, -1, -1, -1},
+								{0, -1, -1, -1, -1, 5, -1, -1},
+								{0, 4, -1, -1, -1, 6, -1, -1},
+								{0, 3, 4, -1, -1, 6, -1, -1},
+								{0, 3, 4, 5, -1, 6, -1, -1},
+								{0, 2, 3, 4, 5, 6, -1, -1},
+								{0, 2, 3, 4, 5 ,6, 7, -1},
+								{0, 1, 2, 3, 4, 5 ,6, 7}
+								};
+
+#else
+static int32	queueMatrix[RTL8651_OUTPUTQUEUE_SIZE][RTL8651_OUTPUTQUEUE_SIZE] =
+								{{0, -1, -1, -1, -1, -1},
+								{0, -1, -1, -1, -1, 5},
+								{0, 4, -1, -1, -1, 6},
+								{0, 3, 4, -1, -1, 6},
+								{0, 3, 4, 5, -1, 6},
+								{0, 2, 3, 4, 5 ,6}};
+
+#endif
+#endif
+
+static uint8    priorityDecisionArray[] = {	2,		/* port base */
+									8,		/*         802.1p base */
+#if defined (CONFIG_RTK_VOIP_QOS)
+									8,		/*         dscp base */
+#else
+									4,		/*         dscp base */
+#endif
+									8,		/*         acl base */
+									8		/* nat base */
+									#if defined(CONFIG_RTL_8197F)
+									,2		/* VID base*/
+									#endif
+								};
+
+#if defined(CONFIG_RTL_SW_QUEUE_DECISION_PRIORITY)
+static uint8    swPriorityDecisionArray[] = {	8,		/* port base */
+									8,		/*         802.1p base */
+									8,		/*         dscp base */
+									2,		/*         acl base */
+									8		/* nat base */
+									#if defined(CONFIG_RTL_8197F)
+									,8		/* VID base*/
+									#endif
+								};
+#endif
+
+static uint32	defPriority[NETIF_NUMBER] = {0};
+static uint32	queueNumber[NETIF_NUMBER] = {0};
+static uint32	priority2HandleMapping[NETIF_NUMBER][TOTAL_VLAN_PRIORITY_NUM] = {{0}};
+static rtl_qos_mark_info_t	mark2Priority[NETIF_NUMBER][MAX_MARK_NUM_PER_DEV] = {{{0}}};
+
+rtl865x_qos_rule_t		*rtl865x_qosRuleHead = NULL;
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl865x_qosRuleHead);
+#endif /* CONFIG_RTD_1295_HWNAT */
+extern int hw_qos_init_netlink(void);
+static int32 _rtl865x_qosArrangeRuleByNetif(uint8 *netIfName);
+
+
+extern struct proc_dir_entry proc_root;
+#define TOTAL_DSCP_NUM 64
+extern int rtl865x_isWanNetifByIdx(int netifIdx);
+struct proc_dir_entry *rtl_hw_qos_config_entry;
+extern struct proc_dir_entry proc_root;
+
+#if defined(CONFIG_RTL_HW_QOS_BRIDGE_FWD_SUPPORT)
+uint32 classId2Port[NETIF_NUMBER][RTL8651_PORT_NUMBER];
+uint32 classId2VlanPriority[NETIF_NUMBER][TOTAL_VLAN_PRIORITY_NUM];
+uint32 classId2Dscp[NETIF_NUMBER][TOTAL_DSCP_NUM];
+static uint8 vlanPri2SystemPri[TOTAL_VLAN_PRIORITY_NUM] = {2, 0, 1, 3, 4, 5, 6, 7};
+#endif
+
+int rtl_hw_qos_config_single_open(struct inode *inode, struct file *file);
+static ssize_t rtl_hw_qos_config_single_write(struct file * file, const char __user * userbuf,
+		     size_t count, loff_t * off);
+
+struct file_operations rtl_hw_qos_config_proc_fops= {
+	.open           = rtl_hw_qos_config_single_open,
+	.write          = rtl_hw_qos_config_single_write,
+	.read           = seq_read,
+	.llseek         = seq_lseek,
+	.release        = single_release,
+};
+
+extern uint32 rtl865x_getVlanPortMask(uint32 vid);
+extern struct net_device *dev_get_by_name(struct net *net, const char *name);
+extern struct net init_net;
+
+#if defined CONFIG_RTL_8367_QOS_SUPPORT
+int rtl8367_qosSetBandwidth(unsigned int memberPort, unsigned int Kbps);
+int32 rtl8367_qosFlushBandwidth(unsigned int memberPort);
+int32 rtl8367_qosSetIngressBandwidth(unsigned int memberPort, unsigned int Kbps);
+
+int rtl8367_qosProcessQueue(unsigned int memberPort, unsigned int queueNum, unsigned int *queueFlag, unsigned int *queueId, unsigned int *queueBw, unsigned int *queueWeight, unsigned int wanPortMask);
+int rtl8367_closeQos(unsigned int memberPort, unsigned int wanPortMask);
+#endif
+int32 rtl865x_qosSetBandwidth(uint8 *netIfName, uint32 bps)
+{
+	uint32	memberPort, wanMemberPort;
+	rtl865x_netif_local_t	*netIf, *wanNetIf;
+	rtl865x_vlan_entry_t	*vlan;
+#if !defined CONFIG_RTL_8367_QOS_SUPPORT
+	uint32	port;
+#endif
+	uint32	asicBandwidth;
+	uint32	wanPortAsicBandwidth;
+
+	netIf = _rtl865x_getNetifByName(netIfName);
+	if(netIf == NULL)
+		return FAILED;
+	vlan = _rtl8651_getVlanTableEntry(netIf->vid);
+	if(vlan == NULL)
+		return FAILED;
+
+	memberPort = vlan->memberPortMask;
+
+	///////////////////////////////////////////////
+	/*	Egress bandwidth granularity was 64Kbps for !97F, 1kbps for 97F, 8kbps for 8367*/
+	asicBandwidth = bps>>EGRESS_BANDWIDTH_GRANULARITY_BITLEN;
+	if (asicBandwidth>0 && (bps&(1<<(EGRESS_BANDWIDTH_GRANULARITY_BITLEN-1)))!=0)
+	{
+		asicBandwidth++;
+	}
+#if defined CONFIG_RTL_8367_QOS_SUPPORT
+	/*for 8367 qos api, Egress bandwidth parameter granularity was 1kbps*/
+	asicBandwidth = asicBandwidth<<3;
+	rtl8367_qosSetBandwidth(memberPort, asicBandwidth);
+
+	if(strcmp(netIfName,RTL_DRV_LAN_NETIF_NAME)==0)
+	{
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+		wanNetIf= _rtl865x_getNetifByName(RTL_GW_WAN_DEVICE_NAME);
+#else
+		wanNetIf= _rtl865x_getNetifByName(RTL_DRV_WAN0_NETIF_NAME);
+#endif
+		if(wanNetIf != NULL)
+		{
+			wanMemberPort=rtl865x_getVlanPortMask(wanNetIf->vid);
+			wanPortAsicBandwidth = asicBandwidth+8;
+			//rtl8367_qosSetIngressBandwidth(wanMemberPort, wanPortAsicBandwidth);
+		}
+
+	}
+#else
+
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+	if(strcmp(netIfName,RTL_GW_WAN_DEVICE_NAME) == 0)
+#else
+	if(strcmp(netIfName,RTL_DRV_WAN0_NETIF_NAME)==0)
+#endif
+	{
+		//Adjust for wan port egress asic bandwidth
+		asicBandwidth+=3;
+	}
+	if(strcmp(netIfName,RTL_DRV_LAN_NETIF_NAME)==0)
+	{
+		//Adjust for lan port egress asic bandwidth
+		asicBandwidth++;
+	}
+	////////////////////////////////////////////////////////////////
+
+	///////////////////////////////////////////////
+	/*	Ingress bandwidth granularity was 16Kbps	*/
+	wanPortAsicBandwidth=bps>>INGRESS_BANDWIDTH_GRANULARITY_BITLEN;
+	if (wanPortAsicBandwidth>0 && (bps&(1<<(INGRESS_BANDWIDTH_GRANULARITY_BITLEN-1)))!=0)
+	{
+		wanPortAsicBandwidth++;
+	}
+
+	//Adjust for wan port ingress asic bandwidth
+	wanPortAsicBandwidth+=5;
+
+	if(strcmp(netIfName,RTL_DRV_LAN_NETIF_NAME)==0)
+	{
+		//To set wan port ingress asic bandwidth
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+		wanNetIf= _rtl865x_getNetifByName(RTL_GW_WAN_DEVICE_NAME);
+#else
+		wanNetIf= _rtl865x_getNetifByName(RTL_DRV_WAN0_NETIF_NAME);
+#endif
+		if(wanNetIf != NULL)
+		{
+			wanMemberPort=rtl865x_getVlanPortMask(wanNetIf->vid);
+			for(port=0;port<=CPU;port++)
+			{
+				if(((1<<port)&wanMemberPort)==0)
+					continue;
+				//rtl8651_setAsicPortIngressBandwidth(port,wanPortAsicBandwidth);
+			}
+		}
+	}
+	////////////////////////////////////////////////////////////////
+
+	rtl865xC_lockSWCore();
+	for(port=0;port<=CPU;port++)
+	{
+		if(((1<<port)&memberPort)==0)
+			continue;
+		rtl8651_setAsicPortEgressBandwidth(port, asicBandwidth);
+	}
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+#endif
+	return SUCCESS;
+}
+
+int32 rtl865x_qosFlushBandwidth(uint8 *netIfName)
+{
+	uint32	memberPort;
+	rtl865x_netif_local_t	*netIf;
+	rtl865x_vlan_entry_t	*vlan;
+
+	uint32 wanMemberPort = 0xFFFFFFFF;
+	rtl865x_netif_local_t *wanNetIf = NULL;
+#if !defined CONFIG_RTL_8367_QOS_SUPPORT
+	uint32	port;
+#endif
+	netIf = _rtl865x_getNetifByName(netIfName);
+	if(netIf == NULL)
+		return FAILED;
+	vlan = _rtl8651_getVlanTableEntry(netIf->vid);
+	if(vlan == NULL)
+		return FAILED;
+
+	memberPort = vlan->memberPortMask;
+
+#if defined CONFIG_RTL_8367_QOS_SUPPORT
+	rtl8367_qosFlushBandwidth(memberPort);
+	if(strcmp(netIfName,RTL_DRV_LAN_NETIF_NAME)==0)
+	{
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+		wanNetIf= _rtl865x_getNetifByName(RTL_GW_WAN_DEVICE_NAME);
+#else
+		wanNetIf= _rtl865x_getNetifByName(RTL_DRV_WAN0_NETIF_NAME);
+#endif
+		if(wanNetIf != NULL)
+		{
+			wanMemberPort=rtl865x_getVlanPortMask(wanNetIf->vid);
+			//rtl8367_qosSetIngressBandwidth(wanMemberPort, 0);
+		}
+
+	}
+	//need to check
+	rtl865x_raiseEvent(EVENT_FLUSH_QOSRULE, NULL);
+#else
+	//If flush lan interface qos rules, wan port ingress bandwidth should be set to full speed.
+	if(strcmp(netIfName,RTL_DRV_LAN_NETIF_NAME)==0)
+	{
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+		wanNetIf= _rtl865x_getNetifByName(RTL_GW_WAN_DEVICE_NAME);
+#else
+		wanNetIf= _rtl865x_getNetifByName(RTL_DRV_WAN0_NETIF_NAME);
+#endif
+		if(wanNetIf != NULL)
+		{
+			wanMemberPort=rtl865x_getVlanPortMask(wanNetIf->vid);
+			for(port=0;port<=CPU;port++)
+			{
+				if(((1<<port)&wanMemberPort)==0)
+					continue;
+				rtl8651_setAsicPortIngressBandwidth(port,0);
+			}
+		}
+	}
+
+
+
+	rtl865xC_lockSWCore();
+	for(port=0;port<=CPU;port++)
+	{
+		if(((1<<port)&memberPort)==0)
+			continue;
+
+		rtl8651_setAsicPortEgressBandwidth(port, APR_MASK>>APR_OFFSET);
+	}
+
+	rtl865x_raiseEvent(EVENT_FLUSH_QOSRULE, NULL);
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+#endif
+	return SUCCESS;
+}
+#if 0
+int32 rtl865x_qosGetPriorityByHandle(uint8 *priority, uint32 handle)
+{
+	int	j;
+
+	for(j=0; j < TOTAL_VLAN_PRIORITY_NUM; j++)
+	{
+		if (priority2HandleMapping[j] == handle)
+		{
+			*priority = j;
+			break;
+		}
+	}
+	if (j<TOTAL_VLAN_PRIORITY_NUM)
+		return SUCCESS;
+	else
+		return FAILED;
+}
+#else
+static int32 _rtl865x_qosGetPriorityByHandle(int32 idx, uint32 handle)
+{
+	int	j;
+
+	for(j=0; j < TOTAL_VLAN_PRIORITY_NUM; j++)
+	{
+		if (priority2HandleMapping[idx][j] == handle)
+		{
+			return j;
+		}
+	}
+
+	return 0;
+}
+#endif
+
+int32 rtl_qosGetPriorityByMark(uint8 *netIfName, int32 mark)
+{
+	int	netifIdx, i;
+
+	//Especil for ppp0 which attach at eth1
+	netifIdx = _rtl865x_getNetifIdxByNameExt(netIfName);
+
+	if (queueNumber[netifIdx] <=1)
+		return defPriority[netifIdx];
+
+	for(i=0;i<MAX_MARK_NUM_PER_DEV;i++)
+	{
+		#if defined (CONFIG_OPENWRT_SDK)
+		if ((mark2Priority[netifIdx][i].mark&mark2Priority[netifIdx][i].mask)==(mark&mark2Priority[netifIdx][i].mask))
+		#else
+		if (mark2Priority[netifIdx][i].mark==mark)
+		#endif
+			return mark2Priority[netifIdx][i].priority;
+	}
+
+	return defPriority[netifIdx];
+}
+
+int32 rtl_qosGetPriorityByVid(int32 vid, int32 mark)
+{
+	int	netifIdx, i;
+
+	netifIdx = _rtl865x_getNetifIdxByVid(vid);
+	if (queueNumber[netifIdx] <=1)
+		return defPriority[netifIdx];
+	for(i=0;i<MAX_MARK_NUM_PER_DEV;i++)
+	{
+		#if defined (CONFIG_OPENWRT_SDK)
+		if ((mark2Priority[netifIdx][i].mark&mark2Priority[netifIdx][i].mask)==(mark&mark2Priority[netifIdx][i].mask))
+		#else
+		if (mark2Priority[netifIdx][i].mark==mark)
+		#endif
+			return mark2Priority[netifIdx][i].priority;
+	}
+
+	return defPriority[netifIdx];
+}
+#if defined (CONFIG_OPENWRT_SDK)
+int32 rtl_qosSetPriorityByMark(uint8 *netIfName, int32 mark, int32 handler, int32 mask,int32 enable)
+#else
+int32 rtl_qosSetPriorityByMark(uint8 *netIfName, int32 mark, int32 handler, int32 enable)
+#endif
+{
+	int	netifIdx, i;
+
+	//Especil for ppp0 which attach at eth1
+	netifIdx = _rtl865x_getNetifIdxByNameExt(netIfName);
+#if defined (CONFIG_OPENWRT_SDK)
+	if(enable ==RTL_MARK2PRIO_FLUSH_FLAG)
+	{
+
+		for(i=0;i<MAX_MARK_NUM_PER_DEV;i++)
+		{
+		#ifdef DEFAULT_PRIORITY_PATCH
+			mark2Priority[netifIdx][i].priority = -1;
+			mark2Priority[netifIdx][i].mark = -1;
+			mark2Priority[netifIdx][i].mask = -1;
+		#else
+			mark2Priority[netifIdx][i].priority=0;
+		#endif
+
+		}
+		return SUCCESS;
+	}
+#endif
+
+	for(i=0;i<MAX_MARK_NUM_PER_DEV;i++)
+	{
+
+
+		if ((mark2Priority[netifIdx][i].mark==mark)
+		#if defined (CONFIG_OPENWRT_SDK)
+			&&(mark2Priority[netifIdx][i].mask==mask)
+		#endif
+			)
+		{
+			if (enable==TRUE)
+			{
+				mark2Priority[netifIdx][i].priority = _rtl865x_qosGetPriorityByHandle(netifIdx, handler);
+			}
+			else
+			{
+			#ifdef DEFAULT_PRIORITY_PATCH
+				mark2Priority[netifIdx][i].mark = -1;
+				mark2Priority[netifIdx][i].priority = -1;
+				#if defined (CONFIG_OPENWRT_SDK)
+				mark2Priority[netifIdx][i].mask = -1;
+				#endif
+			#else
+				mark2Priority[netifIdx][i].mark = 0;
+				mark2Priority[netifIdx][i].priority = 0;
+				#if defined (CONFIG_OPENWRT_SDK)
+				mark2Priority[netifIdx][i].mask = 0;
+				#endif
+			#endif
+			}
+			break;
+		}
+	}
+
+	if (i==MAX_MARK_NUM_PER_DEV&&enable==TRUE)
+	{
+		for(i=0;i<MAX_MARK_NUM_PER_DEV;i++)
+		{
+#ifdef DEFAULT_PRIORITY_PATCH
+			if (mark2Priority[netifIdx][i].mark==-1)
+#else
+			if (mark2Priority[netifIdx][i].mark==0)
+#endif
+			{
+				mark2Priority[netifIdx][i].mark = mark;
+				#if defined (CONFIG_OPENWRT_SDK)
+				mark2Priority[netifIdx][i].mask = mask;
+				#endif
+				mark2Priority[netifIdx][i].priority = _rtl865x_qosGetPriorityByHandle(netifIdx, handler);
+				break;
+			}
+		}
+
+		if (i==MAX_MARK_NUM_PER_DEV)
+		{
+			return FAILED;
+		}
+	}
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_RTL_SW_QUEUE_DECISION_PRIORITY)
+/*Make sure priorityDecisionArray parameter seq is the same with enum decision_priority*/
+int rtl_getMaxDecisionBitMap(unsigned int* maxDecision)
+{
+	int i;
+	int max = 0;
+
+	#if defined(CONFIG_RTL_8197F)
+	for (i=0; i<6; i++)
+	#else
+	for (i=0; i<5; i++)
+	#endif
+	{
+		if (i==3)	//skip acl decision
+			continue;
+
+		if (swPriorityDecisionArray[i] > max) {
+			max = swPriorityDecisionArray[i];
+			*maxDecision = 0;
+			*maxDecision |= 1<<i;
+		} else if (swPriorityDecisionArray[i] == max) {
+			*maxDecision |= 1<<i;
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#if 1
+/*
+	_rtl865x_compare2Entry Return Value:
+		>0		means entry1 > entry2
+		<0		means entry1 < entry2
+		=0		means entry1 = entry2
+*/
+static int8 _rtl865x_compare2Entry(rtl865x_qos_t	*entry1, rtl865x_qos_t	*entry2)
+{
+#if 0
+	if (entry1->handle>entry2->handle)
+		return 1;
+	else if (entry1->handle<entry2->handle)
+		return -1;
+	else
+		return 0;
+#else
+	if (entry1->bandwidth<entry2->bandwidth)
+		return 1;
+	else if (entry1->bandwidth>entry2->bandwidth)
+		return -1;
+	else
+		return 0;
+#endif
+}
+#if defined (CONFIG_RTL_HW_QOS_SP_PRIO)
+
+static int8 rtl865x_compPri(rtl865x_qos_t	*entry1, rtl865x_qos_t	*entry2)
+{
+	if (entry1->prio<entry2->prio)
+		return 1;
+	else if (entry1->prio>entry2->prio)
+		return -1;
+	else
+		return 0;
+}
+#endif
+int32	rtl865x_registerQosCompFunc(int8 (*p_cmpFunc)(rtl865x_qos_t	*entry1, rtl865x_qos_t	*entry2))
+{
+	if (p_cmpFunc==NULL)
+		rtl865x_compFunc = _rtl865x_compare2Entry;
+	else
+		rtl865x_compFunc = p_cmpFunc;
+
+	return SUCCESS;
+}
+
+static int my_gcd(int numA, int numB)
+{
+	int	tmp;
+	int	divisor;
+
+	if (numA<numB)
+	{
+		tmp = numA;
+		numA = numB;
+		numB = tmp;
+	}
+
+	divisor = numA%numB;
+	while(divisor)
+	{
+		numA = numB;
+		numB = divisor;
+		divisor = numA%numB;
+	}
+
+	return numB;
+}
+
+static struct net_device *rtl865x_getDevByName(char *devName)
+{
+	struct net_device * dev=NULL;
+
+	if(devName != NULL)
+	{
+		dev=dev_get_by_name(&init_net, devName);
+	}
+
+	return dev;
+}
+
+static int32 _rtl865x_qosArrangeQueue(rtl865x_qos_t *qosInfo)
+{
+	uint32	queueOrder[RTL8651_OUTPUTQUEUE_SIZE] = {0};
+	uint32	entry;
+	int32	nStart, nEnd;
+	int32	mStart, mEnd;
+	int32	i=0, j=0, cnt=0;
+	int32	queueNum;
+#if !defined (CONFIG_OPENWRT_SDK)
+	int32	qosMarkNumIdx;
+	uint32	tmpHandle;
+	struct net_device * tmpDev;
+#endif
+	struct net_device *qosDev;
+	rtl865x_qos_t	*outputQueue;
+	rtl865x_qos_t	tmp_qosInfo[RTL8651_OUTPUTQUEUE_SIZE];
+	const int32	idx = _rtl865x_getNetifIdxByNameExt(qosInfo->ifname);
+#if defined (CONFIG_RTL_HW_QOS_SP_PRIO)
+	int ret;
+#endif
+
+	/*	Process the queue type & ratio	*/
+	{
+		int			divisor;
+#if defined (CONFIG_OPENWRT_SDK)
+		divisor = qosInfo[0].bandwidth;
+#else
+		if ((qosInfo[0].flags&QOS_DEF_QUEUE)!=0)
+			divisor = qosInfo[0].ceil;
+		else
+			divisor = qosInfo[0].bandwidth;
+#endif
+		for(queueNum=0; queueNum<RTL8651_OUTPUTQUEUE_SIZE; queueNum++)
+		{
+			if ((qosInfo[queueNum].flags&QOS_VALID_MASK)==0)
+				break;
+			/*	Currently, we set all queue as WFQ		*/
+			if ((qosInfo[queueNum].flags&QOS_TYPE_MASK)==QOS_TYPE_WFQ)
+			{
+			#if !defined (CONFIG_OPENWRT_SDK)
+				if ((qosInfo[queueNum].flags&QOS_DEF_QUEUE)!=0)
+				{
+					qosInfo[queueNum].bandwidth=qosInfo[queueNum].ceil;
+				}
+			#endif
+				divisor = my_gcd(qosInfo[queueNum].bandwidth, divisor);
+			}
+		}
+
+		/*	process WFQ type ratio	*/
+		{
+			if (divisor)
+			{
+				int	maxBandwidth;
+				int	queueNumBackup;
+				maxBandwidth = 0;
+				queueNumBackup = queueNum;
+
+				while(queueNum>0)
+				{
+					if ((qosInfo[queueNum-1].flags&QOS_TYPE_MASK)
+						==QOS_TYPE_WFQ)
+					{
+						qosInfo[queueNum-1].bandwidth = (qosInfo[queueNum-1].bandwidth/divisor);
+						if (maxBandwidth<qosInfo[queueNum-1].bandwidth)
+							maxBandwidth = qosInfo[queueNum-1].bandwidth;
+					}
+					queueNum--;
+				}
+
+				if (maxBandwidth>EGRESS_WFQ_MAX_RATIO)
+				{
+					queueNum = queueNumBackup;
+					divisor = (maxBandwidth/EGRESS_WFQ_MAX_RATIO)
+						+ ((maxBandwidth%EGRESS_WFQ_MAX_RATIO)>(EGRESS_WFQ_MAX_RATIO>>1)?1:0);
+					while(queueNum>0)
+					{
+						if ((qosInfo[queueNum-1].flags&QOS_TYPE_MASK)
+							==QOS_TYPE_WFQ)
+						{
+							qosInfo[queueNum-1].bandwidth =
+								(qosInfo[queueNum-1].bandwidth/divisor);
+
+							if (qosInfo[queueNum-1].bandwidth==0)
+								qosInfo[queueNum-1].bandwidth = 1;
+							else if (qosInfo[queueNum-1].bandwidth>EGRESS_WFQ_MAX_RATIO)
+								qosInfo[queueNum-1].bandwidth = EGRESS_WFQ_MAX_RATIO;
+						}
+						queueNum--;
+					}
+				}
+			}
+		}
+
+		divisor = 0;
+		for(queueNum=0; queueNum<RTL8651_OUTPUTQUEUE_SIZE; queueNum++)
+		{
+
+			#if !defined (CONFIG_OPENWRT_SDK)
+			if ((qosInfo[queueNum].flags&QOS_DEF_QUEUE)!=0)
+			{
+				qosInfo[queueNum].bandwidth = 1;
+			}
+			else
+			#endif
+			if ((qosInfo[queueNum].flags&QOS_VALID_MASK)!=0)
+			{
+				continue;
+			}
+			break;
+		}
+	}
+
+	nStart = nEnd = mStart = mEnd = 0;	/*	reserver 0 for default queue	*/
+	queueOrder[0] = 0;
+	outputQueue = qosInfo;
+
+	for(entry=0; entry<RTL8651_OUTPUTQUEUE_SIZE; entry++, outputQueue++)
+	{
+		if ((outputQueue->flags&QOS_VALID_MASK)==0)
+			break;
+
+		/*	rtlglue_printf("index %d, queueType %d.\n", entry, outputQueue->queueType); */
+		if ((outputQueue->flags&QOS_TYPE_MASK)==QOS_TYPE_WFQ)
+		{
+			/*	Do not exceed the max value: 1 ~ 128	*/
+			if (outputQueue->bandwidth>((WEIGHT0_MASK>>WEIGHT0_OFFSET)+1))
+				outputQueue->bandwidth = (WEIGHT0_MASK>>WEIGHT0_OFFSET)+1;
+
+			/*	this is a NQueue entry	*/
+			{
+				/*	process m Queue */
+				if (mEnd>mStart)
+				{
+					i = mEnd-1;
+					while(i>=mStart)
+					{
+						queueOrder[i+1] = queueOrder[i];
+						i--;
+					}
+				}
+				mEnd++;
+				mStart++;
+
+				/*	process n Queue */
+				i = nEnd;
+				{
+					while(i>nStart)
+					{
+						if(rtl865x_compFunc(outputQueue, &qosInfo[queueOrder[i-1]])>0)
+						{
+							queueOrder[i] = queueOrder[i-1];
+							i--;
+							continue;
+						}
+						break;
+					}
+				}
+				nEnd++;
+				queueOrder[i] = entry;
+			}
+		} else if ((outputQueue->flags&QOS_TYPE_MASK)==QOS_TYPE_STR)
+		{
+			i = mEnd;
+			{
+				while(i>mStart)
+				{
+
+					#if defined (CONFIG_RTL_HW_QOS_SP_PRIO)
+
+					ret =rtl865x_compPri(outputQueue, &qosInfo[queueOrder[i-1]]);
+					if (ret>0)
+					{
+						queueOrder[i] = queueOrder[i-1];
+						i--;
+						continue;
+					}
+					else if(ret==0)
+					#endif
+					{
+						if (rtl865x_compFunc(outputQueue, &qosInfo[queueOrder[i-1]])>0)
+						{
+							queueOrder[i] = queueOrder[i-1];
+							i--;
+							continue;
+						}
+					}
+					break;
+				}
+			}
+			mEnd++;
+			queueOrder[i] = entry;
+		}
+	}
+
+	queueNumber[idx] = mEnd;
+
+	queueNum = 1;
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (queueNum<queueNumber[i])
+			queueNum = queueNumber[i];
+	}
+
+	memset((void*)tmp_qosInfo, 0, RTL8651_OUTPUTQUEUE_SIZE*sizeof(rtl865x_qos_t));
+
+	/*	Record the priority <-> handle mapping relationship	*/
+	for(i=0;i<mEnd;i++)
+	{
+		cnt = -1;
+		for(j=0;j<RTL8651_OUTPUTQUEUE_SIZE;j++)
+		{
+			if (queueMatrix[queueNum-1][j]>=0)
+				cnt++;
+			else
+				continue;
+
+			if (cnt==i)
+			{
+				memcpy(&tmp_qosInfo[j], &qosInfo[queueOrder[i]], sizeof(rtl865x_qos_t));
+				priority2HandleMapping[idx][queueMatrix[queueNum-1][j]] = tmp_qosInfo[j].handle;
+				tmp_qosInfo[j].queueId = j;
+			}
+		}
+	}
+
+	memcpy(qosInfo, tmp_qosInfo, RTL8651_OUTPUTQUEUE_SIZE*sizeof(rtl865x_qos_t));
+
+	/*	Set default priority	*/
+	for(i=0;i<RTL8651_OUTPUTQUEUE_SIZE;i++)
+	{
+		if (!(qosInfo[i].flags&QOS_DEF_QUEUE))
+			continue;
+
+		for(j=0; j < TOTAL_VLAN_PRIORITY_NUM; j++)
+		{
+			if (priority2HandleMapping[idx][j] == qosInfo[i].handle)
+				break;
+		}
+
+		/*	If we do not find the default queue priority
+		  *	just keep the default priority 0
+		  */
+		if (j==TOTAL_VLAN_PRIORITY_NUM)
+			j = 0;
+
+		/*	Set default queue priority	*/
+		defPriority[idx] = j;
+	}
+
+	//To update mark2Priority
+	qosDev=rtl865x_getDevByName(qosInfo->ifname);
+
+	if(qosDev)
+	{
+		#if !defined (CONFIG_OPENWRT_SDK)
+		for(qosMarkNumIdx=0;qosMarkNumIdx<MAX_MARK_NUM_PER_DEV;qosMarkNumIdx++)
+		{
+		#ifdef DEFAULT_PRIORITY_PATCH
+			if(mark2Priority[idx][qosMarkNumIdx].mark != -1)
+			{
+				if(tc_getHandleByKey(mark2Priority[idx][qosMarkNumIdx].mark, &tmpHandle, qosDev, &tmpDev) == 0)
+				{
+					mark2Priority[idx][qosMarkNumIdx].priority=_rtl865x_qosGetPriorityByHandle(idx, tmpHandle);
+				}
+				else
+				{
+					mark2Priority[idx][qosMarkNumIdx].mark=-1;
+				}
+			}
+		#else
+			if(mark2Priority[idx][qosMarkNumIdx].mark != 0)
+			{
+				if(tc_getHandleByKey(mark2Priority[idx][qosMarkNumIdx].mark, &tmpHandle, qosDev, &tmpDev) == 0)
+				{
+					mark2Priority[idx][qosMarkNumIdx].priority=_rtl865x_qosGetPriorityByHandle(idx, tmpHandle);
+				}
+				else
+				{
+					mark2Priority[idx][qosMarkNumIdx].mark=0;
+				}
+			}
+		#endif
+		}
+		#endif
+		dev_put(qosDev);
+	}
+
+	return SUCCESS;
+}
+#endif
+
+int32 rtl865x_qosProcessQueue(uint8 *netIfName, rtl865x_qos_t *qosInfo)
+{
+	uint32	memberPort;
+	rtl865x_netif_local_t	*netIf;
+	rtl865x_vlan_entry_t	*vlan;
+	uint32	i, queue;
+	uint32	queueNum;
+	rtl865x_qos_t		*tmp_info;
+#if !defined CONFIG_RTL_8367_QOS_SUPPORT
+	uint32	port;
+	int32	asicBandwidth;
+	int32	weight=0;
+#else
+	uint32 queueFlag[RTL8651_OUTPUTQUEUE_SIZE];
+	uint32 queueId[RTL8651_OUTPUTQUEUE_SIZE];
+	uint32 queueBw[RTL8651_OUTPUTQUEUE_SIZE];
+	uint32 queueWeight[RTL8651_OUTPUTQUEUE_SIZE];
+#endif
+	if (qosInfo==NULL)
+		return FAILED;
+
+	netIf = _rtl865x_getNetifByName(netIfName);
+	if(netIf == NULL)
+		return FAILED;
+	vlan = _rtl8651_getVlanTableEntry(netIf->vid);
+	if(vlan == NULL)
+		return FAILED;
+
+	memberPort = vlan->memberPortMask;
+	tmp_info = qosInfo;
+	queueNum = 0;
+
+	rtl865x_closeQos(netIfName);
+
+
+	_rtl865x_qosArrangeQueue(qosInfo);
+	_rtl865x_qosArrangeRuleByNetif(netIfName);
+
+	/*	Since we use napt base priority,
+	*	the queue number of each network interface should be the same.
+	*	So we had to select the max queue number to set to each netif.
+	*/
+	queueNum = 1;
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (queueNum<queueNumber[i])
+			queueNum = queueNumber[i];
+	}
+#if defined CONFIG_RTL_8367_QOS_SUPPORT
+	for (queue=0;queue<RTL8651_OUTPUTQUEUE_SIZE;queue++)
+	{
+		queueFlag[queue] = qosInfo[queue].flags;
+		queueId[queue] = qosInfo[queue].queueId;
+		queueWeight[queue] = qosInfo[queue].bandwidth;
+		/*	Egress bandwidth granularity was 8Kbps, 	*/
+		if(qosInfo[queue].ceil != 0)
+		{
+			queueBw[queue] = ((qosInfo[queue].ceil)>>(EGRESS_BANDWIDTH_GRANULARITY_BITLEN)) - 1;
+			if ((qosInfo[queue].ceil)&(1<<(EGRESS_BANDWIDTH_GRANULARITY_BITLEN-1)))
+					queueBw[queue] += 1;
+			queueBw[queue] = queueBw[queue]<<3;
+		}
+		else
+		{
+			queueBw[queue] = 0;
+		}
+	}
+	rtl8367_qosProcessQueue(memberPort, queueNum, queueFlag, queueId, queueBw, queueWeight, RTL_WANPORT_MASK);
+#else
+	rtl865xC_lockSWCore();
+
+	for(port=0;port<=CPU;port++)
+	{
+		if(((1<<port)&memberPort)==0)
+			continue;
+
+		rtl8651_setAsicOutputQueueNumber(port, queueNum);
+
+		for (queue=0;queue<RTL8651_OUTPUTQUEUE_SIZE;queue++)
+		{
+			if ((qosInfo[queue].flags&QOS_VALID_MASK)==0 || qosInfo[queue].ceil==0)	/*	un-used queue	*/
+				continue;
+
+			/*	Egress bandwidth granularity was 64Kbps	*/
+			asicBandwidth = ((qosInfo[queue].ceil)>>(EGRESS_BANDWIDTH_GRANULARITY_BITLEN)) - 1;
+			if ((qosInfo[queue].ceil)&(1<<(EGRESS_BANDWIDTH_GRANULARITY_BITLEN-1)))
+				asicBandwidth += 1;
+#if 0
+			if (asicBandwidth<EGRESS_WFQ_MAX_RATIO && ((qosInfo[queue].ceil<<3)&(1<<(EGRESS_BANDWIDTH_GRANULARITY_BITLEN-1)))!=0)
+			{
+				asicBandwidth++;
+			}
+#endif
+
+#if 0
+			if(qosInfo[queue].bandwidth==1)
+			{
+				//Default queue
+				rtl8651_setAsicQueueRate(port, qosInfo[queue].queueId,
+					PPR_MASK>>PPR_OFFSET,
+					L1_MASK>>L1_OFFSET,
+					asicBandwidth);
+			}
+			else
+#endif
+			if ((qosInfo[queue].flags&QOS_TYPE_MASK)==QOS_TYPE_STR)
+			{
+				rtl8651_setAsicQueueRate(port, qosInfo[queue].queueId,
+					PPR_MASK>>PPR_OFFSET,
+					L1_MASK>>L1_OFFSET,
+					asicBandwidth);
+				rtl8651_setAsicQueueWeight(port, qosInfo[queue].queueId, STR_PRIO, 0);
+			}
+			else
+			{
+				rtl8651_setAsicQueueRate(port, qosInfo[queue].queueId,
+					1,
+					L1_MASK>>L1_OFFSET,
+					asicBandwidth);
+				weight =qosInfo[queue].bandwidth-1;
+				#if defined(CONFIG_OPENWRT_SDK)
+				if(weight<0)
+					rtl8651_setAsicQueueWeight(port, qosInfo[queue].queueId, WFQ_PRIO, 0);
+				else
+				#endif
+				rtl8651_setAsicQueueWeight(port, qosInfo[queue].queueId, WFQ_PRIO, qosInfo[queue].bandwidth-1);
+			}
+		}
+	}
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+#endif
+	return SUCCESS;
+}
+
+int32 rtl865x_qosArrangeRuleByNetif(void)
+{
+	int		i;
+
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (netIfNameArray[i][0]!=0)
+		{
+			rtl865x_flush_allAcl_fromChain(netIfNameArray[i], RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS);
+			rtl865x_flush_allAcl_fromChain(netIfNameArray[i], RTL865X_ACL_QOS_USED1, RTL865X_ACL_INGRESS);
+		}
+	}
+
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (netIfNameArray[i][0]!=0)
+		{
+			_rtl865x_qosArrangeRuleByNetif(netIfNameArray[i]);
+		}
+	}
+
+	return SUCCESS;
+}
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl865x_qosArrangeRuleByNetif);
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+static int32 _rtl865x_qosArrangeRuleByNetif(uint8 *netIfName)
+{
+	rtl865x_qos_rule_t	*qosRule;
+	int32			priority;
+	int32			i;
+	const int32	idx = _rtl865x_getNetifIdxByNameExt(netIfName);
+	int32			tmp_idx;
+
+	for(qosRule = rtl865x_qosRuleHead; qosRule; qosRule=qosRule->next)
+	{
+		if (qosRule->handle==0)
+			continue;
+		if ((priority=_rtl865x_qosGetPriorityByHandle(idx, qosRule->handle))==0)
+			continue;
+
+		if(qosRule->outIfname[0]!='\0')
+		{
+			/*	assigned egress netif	*/
+			tmp_idx = _rtl865x_getNetifIdxByNameExt(qosRule->outIfname);
+			if (tmp_idx!=idx)
+				continue;
+		}
+
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+		if (qosRule->rule->ruleType_==RTL865X_ACL_802D1P)
+		{
+			rtl8651_setAsicDot1qAbsolutelyPriority(qosRule->rule->vlanTagPri_, priority);
+			continue;
+		}
+#endif
+		{
+			qosRule->rule->priority_ = priority;
+			if (qosRule->inIfname[0]!='\0')
+			{
+				/*	assigned ingress netif	*/
+				rtl865x_del_acl(qosRule->rule, qosRule->inIfname, RTL865X_ACL_QOS_USED0);
+				rtl865x_add_acl(qosRule->rule, qosRule->inIfname, RTL865X_ACL_QOS_USED0);
+				#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+				#if defined(CONFIG_RTL_PUBLIC_SSID)
+				if (memcmp(RTL_GW_WAN_DEVICE_NAME, qosRule->inIfname, 4)==0
+					&&qosRule->rule->direction_==RTL_ACL_INGRESS)
+				#else
+				if (memcmp(RTL_DRV_WAN0_NETIF_NAME, qosRule->inIfname, 4)==0
+					&&qosRule->rule->direction_==RTL_ACL_INGRESS)
+				#endif
+				{
+					rtl_checkLocalPublicNetifIngressRule(qosRule->rule);
+				}
+				#endif
+			}
+			else
+			{
+				/*	do not assigned ingress netif	*/
+				for(i=0;i<NETIF_NUMBER;i++)
+				{
+					if (netIfNameArray[i][0]!=0)
+					{
+						tmp_idx = _rtl865x_getNetifIdxByNameExt(netIfNameArray[i]);
+						if (tmp_idx>=0&&tmp_idx<NETIF_NUMBER&&tmp_idx!=idx)
+						{
+							rtl865x_del_acl(qosRule->rule, netIfNameArray[i], RTL865X_ACL_QOS_USED0);
+							rtl865x_add_acl(qosRule->rule, netIfNameArray[i], RTL865X_ACL_QOS_USED0);
+						}
+					}
+				}
+				#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+				if (qosRule->rule->direction_==RTL_ACL_INGRESS)
+				{
+					rtl_checkLocalPublicNetifIngressRule(qosRule->rule);
+				}
+				#endif
+			}
+		}
+	}
+
+	/*	Add default priority	*/
+#ifndef DEFAULT_PRIORITY_PATCH
+	{
+		rtl865x_AclRule_t	aclRule;
+		int	i;
+
+		memset(&aclRule, 0, sizeof(rtl865x_AclRule_t));
+		aclRule.actionType_ = RTL865X_ACL_PRIORITY;
+		aclRule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+		aclRule.priority_ = defPriority[idx];
+		i = 0;
+		for(i=0;i<NETIF_NUMBER;i++)
+		{
+			if (netIfNameArray[i][0]!=0)
+			{
+				tmp_idx = _rtl865x_getNetifIdxByNameExt(netIfNameArray[i]);
+				if (tmp_idx>=0&&tmp_idx<NETIF_NUMBER&&tmp_idx!=idx)
+				{
+					rtl865x_add_acl(&aclRule, netIfNameArray[i], RTL865X_ACL_QOS_USED1);
+				}
+			}
+		}
+	}
+#endif
+
+	rtl865x_raiseEvent(EVENT_CHANGE_QOSRULE, NULL);
+
+	return SUCCESS;
+}
+
+int32 rtl865x_qosAddMarkRule(rtl865x_qos_rule_t *rule)
+{
+	rtl865x_AclRule_t *qosAclRule;
+	int				i;
+
+	qosAclRule = kmalloc(sizeof(rtl865x_AclRule_t), GFP_ATOMIC);
+	if (qosAclRule==NULL)
+	{
+		return RTL_ENOFREEBUFFER;
+	}
+	memcpy(qosAclRule, rule->rule, sizeof(rtl865x_AclRule_t));
+	qosAclRule->pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+	qosAclRule->actionType_ = RTL865X_ACL_PRIORITY;
+	qosAclRule->aclIdx = 0;
+
+	if (rtl865x_qosRuleHead==NULL)
+	{
+		rtl865x_qosRuleHead = rtl_malloc(sizeof(rtl865x_qos_rule_t));
+		if (rtl865x_qosRuleHead==NULL)
+		{
+			rtl_free(qosAclRule);
+			return RTL_ENOFREEBUFFER;
+		}
+		memcpy(rtl865x_qosRuleHead, rule, sizeof(rtl865x_qos_rule_t));
+		rtl865x_qosRuleHead->rule = qosAclRule;
+		rtl865x_qosRuleHead->next = NULL;
+	}
+	else
+	{
+		rtl865x_qos_rule_t	*qosRule, *lastQosRule;
+
+		qosRule = rtl_malloc(sizeof(rtl865x_qos_rule_t));
+		if (qosRule==NULL)
+		{
+			rtl_free(qosAclRule);
+			return RTL_ENOFREEBUFFER;
+		}
+		lastQosRule = rtl865x_qosRuleHead;
+		while(lastQosRule->next)
+			lastQosRule = lastQosRule->next;
+
+		lastQosRule->next = qosRule;
+		memcpy(qosRule, rule, sizeof(rtl865x_qos_rule_t));
+		qosRule->rule = qosAclRule;
+		qosRule->next = NULL;
+	}
+
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (netIfNameArray[i][0]!=0)
+		{
+			_rtl865x_qosArrangeRuleByNetif(netIfNameArray[i]);
+		}
+	}
+
+	return SUCCESS;
+}
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl865x_qosAddMarkRule);
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+int32 rtl865x_qosCheckNaptPriority(rtl865x_AclRule_t *qosRule)
+{
+	rtl865x_AclRule_t		*rule_p;
+
+	rule_p = rtl865x_matched_layer4_aclChain(netIfNameArray[qosRule->netifIdx_], RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS, qosRule);
+
+	if (!rule_p)
+		rule_p = rtl865x_matched_layer2_aclChain(netIfNameArray[qosRule->netifIdx_], RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS, qosRule);
+
+	if (rule_p)
+	{
+		qosRule->priority_ = rule_p->priority_;
+		qosRule->aclIdx = rule_p->aclIdx;
+		qosRule->upDown_=rule_p->upDown_;
+		return SUCCESS;
+	}
+	else
+	{
+		qosRule->priority_ = defPriority[qosRule->netifIdx_];
+		return FAILED;
+	}
+}
+
+int32 rtl865x_qosFlushMarkRule(void)
+{
+	rtl865x_qos_rule_t	*qosRule;
+	int	i;
+
+	while(rtl865x_qosRuleHead)
+	{
+		qosRule = rtl865x_qosRuleHead->next;
+		rtl_free(rtl865x_qosRuleHead->rule);
+		rtl_free(rtl865x_qosRuleHead);
+		rtl865x_qosRuleHead = qosRule;
+	}
+
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (netIfNameArray[i][0]!=0)
+		{
+			rtl865x_flush_allAcl_fromChain(netIfNameArray[i], RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS);
+			rtl865x_flush_allAcl_fromChain(netIfNameArray[i], RTL865X_ACL_QOS_USED1, RTL865X_ACL_INGRESS);
+			_rtl865x_qosArrangeRuleByNetif(netIfNameArray[i]);
+		}
+	}
+
+	rtl865x_raiseEvent(EVENT_FLUSH_QOSRULE, NULL);
+
+	return SUCCESS;
+}
+
+#if defined (CONFIG_RTL_HW_QOS_SUPPORT)	// sync from voip customer for multiple ppp
+int32 rtl865x_qosFlushMarkRuleByDev(uint8 *netIfName)
+{
+	int i;
+	rtl865x_qosFlushMarkRule();
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (netIfNameArray[i][0]!=0 && (strcmp(netIfName,netIfNameArray[i])!=0))
+		{
+			_rtl865x_qosArrangeRuleByNetif(netIfNameArray[i]);
+		}
+	}
+
+	return SUCCESS;
+}
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl865x_qosFlushMarkRuleByDev);
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+int32 rtl865x_qosRearrangeRule(void)
+{
+	int i;
+	rtl865x_qosFlushMarkRule();
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (netIfNameArray[i][0]!=0)
+		{
+			_rtl865x_qosArrangeRuleByNetif(netIfNameArray[i]);
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+int32 rtl865x_closeQos(uint8 *netIfName)
+{
+	uint32	memberPort;
+	rtl865x_netif_local_t	*netIf;
+	rtl865x_vlan_entry_t	*vlan;
+	uint32	i;
+	const int32	idx = _rtl865x_getNetifIdxByNameExt(netIfName);
+	int32		tmp_idx;
+#if !defined CONFIG_RTL_8367_QOS_SUPPORT
+	uint32 port;
+#endif
+
+	netIf = _rtl865x_getNetifByName(netIfName);
+	if(netIf == NULL)
+		return FAILED;
+	vlan = _rtl8651_getVlanTableEntry(netIf->vid);
+	if(vlan == NULL)
+		return FAILED;
+	/* clear all acl rules */
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+	rtl8651_flushAsicDot1qAbsolutelyPriority();
+#endif
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (netIfNameArray[i][0]!=0)
+		{
+			tmp_idx = _rtl865x_getNetifIdxByNameExt(netIfNameArray[i]);
+			if (tmp_idx>=0&&tmp_idx<NETIF_NUMBER&&tmp_idx!=idx)
+			{
+				rtl865x_flush_allAcl_fromChain(netIfNameArray[i], RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS);
+				rtl865x_flush_allAcl_fromChain(netIfNameArray[i], RTL865X_ACL_QOS_USED1, RTL865X_ACL_INGRESS);
+			}
+		}
+	}
+
+
+	defPriority[idx] = 0;
+	queueNumber[idx] = 0;
+	memset(priority2HandleMapping[idx], 0, TOTAL_VLAN_PRIORITY_NUM*sizeof(int));
+	for(i=0;i<MAX_MARK_NUM_PER_DEV;i++)
+#ifdef DEFAULT_PRIORITY_PATCH
+		mark2Priority[idx][i].priority = -1;	//Only clear priority here, mark need to be stored here.
+#else
+		mark2Priority[idx][i].priority=0;	//Only clear priority here, mark need to be stored here.
+#endif
+	/* keep the rule of RTL865X_ACL_QOS_USED2 untouched */
+
+	memberPort = vlan->memberPortMask;
+
+#if defined CONFIG_RTL_8367_QOS_SUPPORT
+
+	rtl8367_closeQos(memberPort, RTL_WANPORT_MASK);
+#else
+	rtl865xC_lockSWCore();
+	for(port=0;port<=CPU;port++)
+	{
+		if(((1<<port)&memberPort)==0)
+			continue;
+
+		for(i=0;i<RTL8651_OUTPUTQUEUE_SIZE;i++)
+		{
+			rtl8651_setAsicQueueWeight(port, i, STR_PRIO, 0);
+			rtl8651_setAsicQueueRate(port,i, PPR_MASK>>PPR_OFFSET, L1_MASK>>L1_OFFSET,APR_MASK>>APR_OFFSET);
+		}
+
+		rtl8651_setAsicOutputQueueNumber(port, 1);
+	}
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+#endif
+	return SUCCESS;
+}
+
+int __init rtl865x_initOutputQueue(uint8 **netIfName)
+{
+	int	i,j;
+
+#if defined(CONFIG_RTL_8367_QOS_SUPPORT)
+	int prio;
+#endif
+
+	rtl865xC_lockSWCore();
+	for(i=0;i<RTL8651_OUTPUTQUEUE_SIZE;i++)
+	{
+		for(j=0;j<TOTAL_VLAN_PRIORITY_NUM;j++)
+			rtl8651_setAsicPriorityToQIDMappingTable(i+1, j, priorityMatrix[i][j]);
+	}
+#if 0
+	for(i=CPU;i<=MULTEXT;i++)
+	{
+		/* mapping all priority to cpu port output queue 0	*/
+		for(j=0;j<TOTAL_VLAN_PRIORITY_NUM;j++)
+			if(j < 4)
+				rtl8651_setAsicCPUPriorityToQIDMappingTable(i, j, 0);
+			else
+				rtl8651_setAsicCPUPriorityToQIDMappingTable(i,j,5);
+	}
+#endif
+	/* default value is 0, so skip the code.
+	for(j=0;j<8;j++) {
+		//rtl8651_setAsicCPUPriorityToQIDMappingTable(CPU, j, j<4?0:5);
+		rtl8651_setAsicCPUPriorityToQIDMappingTable(CPU, j, 0);
+	}
+	*/
+	#if defined(CONFIG_RTL_8197F)
+	rtl8651_setAsicPriorityDecision(priorityDecisionArray[PORT_BASE],
+		priorityDecisionArray[D1P_BASE], priorityDecisionArray[DSCP_BASE],
+		priorityDecisionArray[ACL_BASE], priorityDecisionArray[NAT_BASE],
+		priorityDecisionArray[VID_BASE]);
+	#else
+	rtl8651_setAsicPriorityDecision(priorityDecisionArray[PORT_BASE],
+		priorityDecisionArray[D1P_BASE], priorityDecisionArray[DSCP_BASE],
+		priorityDecisionArray[ACL_BASE], priorityDecisionArray[NAT_BASE]);
+	#endif
+
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+	rtl8651_flushAsicDot1qAbsolutelyPriority();
+#endif
+#if !defined(CONFIG_OPENWRT_SDK)
+	hw_qos_init_netlink();
+#endif
+	for(i =0; i < RTL8651_OUTPUTQUEUE_SIZE; i++)
+	{
+		for(j=PHY0;j<=CPU;j++)
+		{
+			/* 1. If disable hw queue flow control, issues as follows:
+			  * 	1) 1Gbps ether port to 100Mbps ether port chariot traffic not stable.
+			  * 	2) hw qos not so precise
+			  * 2. If enable hw queue flow control, note as follows:
+			  *	1) for hw qos and using 2 chariot tcp downlink traffic,
+			  *      the no-matched traffic throughput will be pull-down because of the hw queue flow control.
+			  *
+			  * So we enable hw queue flow control as default setting at present.
+			  * 2011-04-02, zj
+			  */
+			if (rtl8651_setAsicQueueFlowControlConfigureRegister(j, i, TRUE)!=SUCCESS)
+			{
+				QOS_DEBUGP("Set Queue Flow Control Para Error.\n");
+			}
+		}
+	}
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+
+	memcpy(netIfNameArray, netIfName, NETIF_NUMBER*IFNAMSIZ);
+
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (netIfNameArray[i][0]!=0)
+		{
+			rtl865x_regist_aclChain(netIfNameArray[i], RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS);
+			rtl865x_regist_aclChain(netIfNameArray[i], RTL865X_ACL_QOS_USED1, RTL865X_ACL_INGRESS);
+		}
+	}
+
+	memset(defPriority, 0, NETIF_NUMBER*sizeof(uint32));
+	memset(queueNumber, 0, NETIF_NUMBER*sizeof(uint32));
+	memset(priority2HandleMapping, 0, NETIF_NUMBER*TOTAL_VLAN_PRIORITY_NUM*sizeof(int));
+#ifdef DEFAULT_PRIORITY_PATCH
+	for(i=0; i<NETIF_NUMBER; i++)
+	{
+		for(j=0; j<MAX_MARK_NUM_PER_DEV; j++)
+		{
+			mark2Priority[i][j].priority = -1;
+			mark2Priority[i][j].mark = -1;
+			mark2Priority[i][j].mask = -1;
+		}
+	}
+#else
+	memset(mark2Priority, 0, NETIF_NUMBER*MAX_MARK_NUM_PER_DEV*sizeof(rtl_qos_mark_info_t));
+#endif
+
+	rtl865x_qosRuleHead = NULL;
+	if (rtl865x_compFunc==NULL)
+		rtl865x_compFunc = _rtl865x_compare2Entry;
+
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		for(j=0;j<MAX_MARK_NUM_PER_DEV;j++){
+			mark2Priority[i][j].dscpRemark =0xff;
+			mark2Priority[i][j].vlanpriRemark=0xff;
+		}
+
+	}
+
+	#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("rtl_hw_qos_config",0,&proc_root,&rtl_hw_qos_config_proc_fops,NULL);
+	#else
+	rtl_hw_qos_config_entry = create_proc_entry("rtl_hw_qos_config", 0, NULL);
+	if(rtl_hw_qos_config_entry)
+	{
+		rtl_hw_qos_config_entry->read_proc = rtl_hw_qos_config_read;
+		rtl_hw_qos_config_entry->write_proc = rtl_hw_qos_config_write;
+	}
+	#endif
+
+#if defined(CONFIG_RTL_HW_QOS_BRIDGE_FWD_SUPPORT)
+	for (i=0; i<NETIF_NUMBER; i++)
+	{
+		for (j=0; j<RTL8651_PORT_NUMBER; j++)
+			classId2Port[i][j] = 0;
+		for (j=0; j<TOTAL_VLAN_PRIORITY_NUM; j++)
+			classId2VlanPriority[i][j] = 0;
+		for (j=0; j<TOTAL_DSCP_NUM; j++)
+			classId2Dscp[i][j] = 0;
+	}
+#endif
+
+#if defined(CONFIG_RTL_8367_QOS_SUPPORT)
+	rtl8367_qos_init();
+	for(prio = PRI0; prio <= PRI7; prio++)
+			rtl8651_setAsicVlanRemark(PHY0, prio, prio);
+#endif
+
+	return SUCCESS;
+}
+
+void __exit rtl865x_exitOutputQueue(void)
+{
+	int	i;
+
+	for(i=0;i<NETIF_NUMBER;i++)
+	{
+		if (netIfNameArray[i][0]!=0)
+		{
+			rtl865x_unRegist_aclChain(netIfNameArray[i], RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS);
+			rtl865x_unRegist_aclChain(netIfNameArray[i], RTL865X_ACL_QOS_USED1, RTL865X_ACL_INGRESS);
+			rtl865x_qosFlushBandwidth(netIfNameArray[i]);
+			rtl865x_closeQos(netIfNameArray[i]);
+		}
+	}
+
+//#if defined(CONFIG_RTL_HW_QOS_BRIDGE_FWD_SUPPORT)
+	if (rtl_hw_qos_config_entry) {
+		remove_proc_entry("rtl_hw_qos_config", NULL);
+		rtl_hw_qos_config_entry = NULL;
+	}
+//#endif
+}
+#if defined (CONFIG_OPENWRT_SDK)
+void rtl865x_HwQosProcess(struct net_device *dev, int flag)
+{
+	int32 port, queue;
+	int i, netif_index;
+	uint32	memberPort;
+	rtl865x_netif_local_t	*netIf = NULL;
+	rtl865x_vlan_entry_t	*vlan = NULL;
+
+	if(flag)
+	{
+		if (dev) {
+		    netif_index = _rtl865x_getNetifIdxByNameExt(dev->name);
+		    netIf = _rtl865x_getNetifByName(dev->name);
+		    if (netIf){
+			vlan = _rtl8651_getVlanTableEntry(netIf->vid);
+		    	if (vlan)
+			    memberPort = vlan->memberPortMask;
+		    }
+		}
+
+		if ((dev==NULL) || (netif_index<0) || (netIf==NULL) || (vlan==NULL)) {
+		    rtl865xC_lockSWCore();
+		    /* qos enabled */
+		    for(i=0;i<NETIF_NUMBER;i++)
+		    {
+			queueNumber[i]=1;
+		    }
+		    for ( port = PHY0 ; port <= CPU ; port ++ )
+		    {
+			rtl8651_setAsicOutputQueueNumber(port, 1);
+
+				for ( queue = QUEUE0 ; queue <= MAX_QUEUE ; queue ++ )
+			{
+				rtl8651_setAsicQueueWeight(port, queue, STR_PRIO, 0);
+				rtl8651_setAsicQueueRate(port,queue, PPR_MASK>>PPR_OFFSET, L1_MASK>>L1_OFFSET,APR_MASK>>APR_OFFSET);
+	  		}
+		    }
+		} else {
+		    rtl865xC_lockSWCore();
+		    /*enable dev qos*/
+		    queueNumber[netif_index] = 1;
+
+		    for ( port = PHY0 ; port <= CPU ; port ++ )
+		    {
+			if(((1<<port)& memberPort) == 0)
+				continue;
+			rtl8651_setAsicOutputQueueNumber(port, 1);
+
+				for ( queue = QUEUE0 ; queue <= MAX_QUEUE ; queue ++ )
+			{
+				rtl8651_setAsicQueueWeight(port, queue, STR_PRIO, 0);
+				rtl8651_setAsicQueueRate(port,queue, PPR_MASK>>PPR_OFFSET, L1_MASK>>L1_OFFSET,APR_MASK>>APR_OFFSET);
+			}
+		    }
+		}
+
+		rtl865xC_waitForOutputQueueEmpty();
+		rtl8651_resetAsicOutputQueue();
+		rtl865xC_unLockSWCore();
+#if defined (DEFAULT_PRIORITY_PATCH)
+		for(i=0;i<NETIF_NUMBER;i++)
+		{
+			if (netIfNameArray[i][0]!=0)
+			{
+				rtl865x_regist_aclChain(netIfNameArray[i], RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS);
+				rtl865x_regist_aclChain(netIfNameArray[i], RTL865X_ACL_QOS_USED1, RTL865X_ACL_INGRESS);
+			}
+		}
+#endif
+	}
+	else  if(flag ==0)
+	{
+		if (dev == NULL) {
+		    for(i=0;i<NETIF_NUMBER;i++)
+		    {
+			if (netIfNameArray[i][0]!=0){
+				rtl865x_unRegist_aclChain(netIfNameArray[i], RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS);
+				rtl865x_unRegist_aclChain(netIfNameArray[i], RTL865X_ACL_QOS_USED1, RTL865X_ACL_INGRESS);
+				rtl865x_qosFlushBandwidth(netIfNameArray[i]);
+				rtl865x_closeQos(netIfNameArray[i]);
+			}
+		   }
+		} else {
+		    for(i=0;i<NETIF_NUMBER;i++)
+		    {
+			if ((netIfNameArray[i][0]!=0) && (strncmp(netIfNameArray[i], dev->name, IFNAMSIZ)==0)) {
+				rtl865x_unRegist_aclChain(netIfNameArray[i], RTL865X_ACL_QOS_USED0, RTL865X_ACL_INGRESS);
+				rtl865x_unRegist_aclChain(netIfNameArray[i], RTL865X_ACL_QOS_USED1, RTL865X_ACL_INGRESS);
+				rtl865x_qosFlushBandwidth(netIfNameArray[i]);
+				rtl865x_closeQos(netIfNameArray[i]);
+			}
+		    }
+		}
+	}
+
+}
+#endif
+
+#if defined (CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_RTL_QOS_PATCH)
+void rtl865x_reinitOutputQueuePatchForQoS(uint32 qosEnabled)
+{
+	int32 port, queue;
+	int32 i;
+	int32 tmp_idx;
+	rtl865x_AclRule_t	aclRule;
+
+	rtl865xC_lockSWCore();
+
+	if(qosEnabled == TRUE)
+	{
+		/* qos enabled */
+		for(i=0;i<NETIF_NUMBER;i++)
+		{
+			queueNumber[i]=DEF_QUEUE_NUM;
+		}
+		for ( port = PHY0 ; port <= CPU ; port ++ )
+		{
+			rtl8651_setAsicOutputQueueNumber(port, DEF_QUEUE_NUM);
+
+			for ( queue = QUEUE0 ; queue <= MAX_QUEUE ; queue ++ )
+			{
+				rtl8651_setAsicQueueWeight(port, queue, STR_PRIO, 0);
+				rtl8651_setAsicQueueRate(port,queue, PPR_MASK>>PPR_OFFSET, L1_MASK>>L1_OFFSET,APR_MASK>>APR_OFFSET);
+	  		}
+		}
+
+	}
+	else
+	{
+		/* qos disabled */
+		for(i=0;i<NETIF_NUMBER;i++)
+		{
+			queueNumber[i]=MAX_QOS_PATCH_QUEUE_NUM;
+		}
+
+		for ( port = PHY0 ; port <= CPU ; port ++ )
+		{
+			rtl8651_setAsicOutputQueueNumber(port, MAX_QOS_PATCH_QUEUE_NUM);
+
+			for ( queue = QUEUE0 ; queue <= MAX_QUEUE ; queue ++ )
+			{
+				if((queue == QUEUE0) || (queue == QUEUE5))
+					rtl8651_setAsicQueueRate(port, queue,PPR_MASK>>PPR_OFFSET, L1_MASK>>L1_OFFSET, APR_MASK>>APR_OFFSET);	// full speed
+			}
+		}
+
+		// Add ACL rule for tcp dport(80) highest priority 7 to accelarate webpage access when heavy traffic load
+		memset(&aclRule, 0, sizeof(rtl865x_AclRule_t));
+		aclRule.ruleType_ = RTL865X_ACL_TCP;
+		aclRule.tcpSrcPortUB_=65535;
+		aclRule.tcpSrcPortLB_=0;
+		aclRule.tcpDstPortUB_=80;
+		aclRule.tcpDstPortLB_=80;
+		aclRule.actionType_ = RTL865X_ACL_PRIORITY;
+		aclRule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+		aclRule.priority_ = 7;
+		i = 0;
+		for(i=0;i<NETIF_NUMBER;i++)	//For all interfaces
+		{
+			if (netIfNameArray[i][0]!=0)
+			{
+				tmp_idx = _rtl865x_getNetifIdxByNameExt(netIfNameArray[i]);
+				if (tmp_idx>=0&&tmp_idx<NETIF_NUMBER)
+				{
+					rtl865x_add_acl(&aclRule, netIfNameArray[i], RTL865X_ACL_QOS_USED1);
+				}
+			}
+		}
+	}
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+}
+#endif
+
+#if defined(CONFIG_RTL_PROC_DEBUG)
+int32 rtl865x_show_allQosAcl(struct seq_file *s)
+{
+	rtl865x_qos_rule_t	*qosRule;
+	rtl865x_AclRule_t *rule;
+	int8 *actionT[] = { "permit", "redirect to ether", "drop", "to cpu", "legacy drop",
+					"drop for log", "mirror", "redirect to pppoe", "default redirect", "mirror keep match",
+					"drop rate exceed pps", "log rate exceed pps", "drop rate exceed bps", "log rate exceed bps","priority "
+					};
+
+	for(qosRule = rtl865x_qosRuleHead;qosRule;qosRule=qosRule->next)
+	{
+		rule = qosRule->rule;
+		switch(rule->ruleType_)
+		{
+			case RTL865X_ACL_MAC:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Ethernet", actionT[rule->actionType_]);
+				seq_printf(s,"\tether type: %x   ether type mask: %x\n", rule->typeLen_, rule->typeLenMask_);
+				seq_printf(s,"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+						rule->dstMac_.octet[0], rule->dstMac_.octet[1], rule->dstMac_.octet[2],
+						rule->dstMac_.octet[3], rule->dstMac_.octet[4], rule->dstMac_.octet[5],
+						rule->dstMacMask_.octet[0], rule->dstMacMask_.octet[1], rule->dstMacMask_.octet[2],
+						rule->dstMacMask_.octet[3], rule->dstMacMask_.octet[4], rule->dstMacMask_.octet[5]
+						);
+
+				seq_printf(s, "\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+						rule->srcMac_.octet[0], rule->srcMac_.octet[1], rule->srcMac_.octet[2],
+						rule->srcMac_.octet[3], rule->srcMac_.octet[4], rule->srcMac_.octet[5],
+						rule->srcMacMask_.octet[0], rule->srcMacMask_.octet[1], rule->srcMacMask_.octet[2],
+						rule->srcMacMask_.octet[3], rule->srcMacMask_.octet[4], rule->srcMacMask_.octet[5]
+					);
+				break;
+
+			case RTL865X_ACL_IP:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IP", actionT[rule->actionType_]);
+				seq_printf(s, "\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+						((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+						(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+						((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+						((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+						(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+						((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+						rule->tos_, rule->tosMask_, rule->ipProto_, rule->ipProtoMask_, rule->ipFlag_, rule->ipFlagMask_
+					);
+
+				seq_printf(s,"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+						rule->ipFOP_, rule->ipFOM_, rule->ipHttpFilter_, rule->ipHttpFilterM_, rule->ipIdentSrcDstIp_,
+						rule->ipIdentSrcDstIpM_
+						);
+				seq_printf(s, "\t<DF:%x> <MF:%x>\n", rule->ipDF_, rule->ipMF_);
+					break;
+
+			case RTL865X_ACL_IP_RANGE:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IP Range", actionT[rule->actionType_]);
+				seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+						((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+						(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+						((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+						((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+						(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+						((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+						rule->tos_, rule->tosMask_, rule->ipProto_, rule->ipProtoMask_, rule->ipFlag_, rule->ipFlagMask_
+						);
+				seq_printf(s,"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+						rule->ipFOP_, rule->ipFOM_, rule->ipHttpFilter_, rule->ipHttpFilterM_, rule->ipIdentSrcDstIp_,
+						rule->ipIdentSrcDstIpM_
+						);
+					seq_printf(s,"\t<DF:%x> <MF:%x>\n", rule->ipDF_, rule->ipMF_);
+					break;
+			case RTL865X_ACL_ICMP:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "ICMP", actionT[rule->actionType_]);
+				seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+						((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+						(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+						((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+						((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+						(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+						((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+						rule->tos_, rule->tosMask_, rule->icmpType_, rule->icmpTypeMask_,
+						rule->icmpCode_, rule->icmpCodeMask_);
+				break;
+			case RTL865X_ACL_ICMP_IPRANGE:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "ICMP IP RANGE", actionT[rule->actionType_]);
+				seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+						((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+						(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+						((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+						((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+						(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+						((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+						rule->tos_, rule->tosMask_, rule->icmpType_, rule->icmpTypeMask_,
+						rule->icmpCode_, rule->icmpCodeMask_);
+				break;
+			case RTL865X_ACL_IGMP:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IGMP", actionT[rule->actionType_]);
+				seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+						((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+						(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+						((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+						((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+						(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+						((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x\n", rule->tos_, rule->tosMask_,
+						rule->igmpType_, rule->igmpTypeMask_
+						);
+				break;
+
+
+			case RTL865X_ACL_IGMP_IPRANGE:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "IGMP IP RANGE", actionT[rule->actionType_]);
+				seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+						((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+						(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+						((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+						((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+						(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+						((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tTos: %x   TosM: %x   type: %x   typeM: %x\n", rule->tos_, rule->tosMask_,
+						rule->igmpType_, rule->igmpTypeMask_
+						);
+				break;
+
+			case RTL865X_ACL_TCP:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "TCP", actionT[rule->actionType_]);
+				seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+						((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+						(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+						((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+						((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+						(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+						((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+						rule->tos_, rule->tosMask_, rule->tcpSrcPortLB_, rule->tcpSrcPortUB_,
+						rule->tcpDstPortLB_, rule->tcpDstPortUB_
+						);
+				seq_printf(s,"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+						rule->tcpFlag_, rule->tcpFlagMask_, rule->tcpURG_, rule->tcpACK_,
+						rule->tcpPSH_, rule->tcpRST_, rule->tcpSYN_, rule->tcpFIN_
+						);
+				break;
+			case RTL865X_ACL_TCP_IPRANGE:
+					seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "TCP IP RANGE", actionT[rule->actionType_]);
+					seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+						((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+						(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+						((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+						);
+					seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+						((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+						(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+						((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+						);
+					seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+						rule->tos_, rule->tosMask_, rule->tcpSrcPortLB_, rule->tcpSrcPortUB_,
+						rule->tcpDstPortLB_, rule->tcpDstPortUB_
+						);
+					seq_printf(s,"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+						rule->tcpFlag_, rule->tcpFlagMask_, rule->tcpURG_, rule->tcpACK_,
+						rule->tcpPSH_, rule->tcpRST_, rule->tcpSYN_, rule->tcpFIN_
+					);
+				break;
+
+			case RTL865X_ACL_UDP:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx,"UDP", actionT[rule->actionType_]);
+				seq_printf(s,"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+						((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+						(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+						((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+						((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+						(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+						((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+						rule->tos_, rule->tosMask_, rule->udpSrcPortLB_, rule->udpSrcPortUB_,
+						rule->udpDstPortLB_, rule->udpDstPortUB_
+						);
+				break;
+			case RTL865X_ACL_UDP_IPRANGE:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "UDP IP RANGE", actionT[rule->actionType_]);
+				seq_printf(s,"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n", (rule->dstIpAddr_>>24),
+						((rule->dstIpAddr_&0x00ff0000)>>16), ((rule->dstIpAddr_&0x0000ff00)>>8),
+						(rule->dstIpAddr_&0xff), (rule->dstIpAddrMask_>>24), ((rule->dstIpAddrMask_&0x00ff0000)>>16),
+						((rule->dstIpAddrMask_&0x0000ff00)>>8), (rule->dstIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n", (rule->srcIpAddr_>>24),
+						((rule->srcIpAddr_&0x00ff0000)>>16), ((rule->srcIpAddr_&0x0000ff00)>>8),
+						(rule->srcIpAddr_&0xff), (rule->srcIpAddrMask_>>24), ((rule->srcIpAddrMask_&0x00ff0000)>>16),
+						((rule->srcIpAddrMask_&0x0000ff00)>>8), (rule->srcIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+						rule->tos_, rule->tosMask_, rule->udpSrcPortLB_, rule->udpSrcPortUB_,
+						rule->udpDstPortLB_, rule->udpDstPortUB_
+					);
+				break;
+
+
+			case RTL865X_ACL_SRCFILTER:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Source Filter", actionT[rule->actionType_]);
+				seq_printf(s,"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+						rule->srcFilterMac_.octet[0], rule->srcFilterMac_.octet[1], rule->srcFilterMac_.octet[2],
+						rule->srcFilterMac_.octet[3], rule->srcFilterMac_.octet[4], rule->srcFilterMac_.octet[5],
+						rule->srcFilterMacMask_.octet[0], rule->srcFilterMacMask_.octet[1], rule->srcFilterMacMask_.octet[2],
+						rule->srcFilterMacMask_.octet[3], rule->srcFilterMacMask_.octet[4], rule->srcFilterMacMask_.octet[5]
+						);
+				seq_printf(s,"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+						rule->srcFilterVlanIdx_, rule->srcFilterVlanIdxMask_, rule->srcFilterPort_, rule->srcFilterPortMask_,
+						(rule->srcFilterIgnoreL3L4_==TRUE? 2: (rule->srcFilterIgnoreL4_ == 1? 1: 0))
+						);
+				seq_printf(s,"\tsip: %d.%d.%d.%d   sipM: %d.%d.%d.%d\n", (rule->srcFilterIpAddr_>>24),
+						((rule->srcFilterIpAddr_&0x00ff0000)>>16), ((rule->srcFilterIpAddr_&0x0000ff00)>>8),
+						(rule->srcFilterIpAddr_&0xff), (rule->srcFilterIpAddrMask_>>24),
+						((rule->srcFilterIpAddrMask_&0x00ff0000)>>16), ((rule->srcFilterIpAddrMask_&0x0000ff00)>>8),
+						(rule->srcFilterIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsportL: %d   sportU: %d\n", rule->srcFilterPortLowerBound_, rule->srcFilterPortUpperBound_);
+				break;
+
+			case RTL865X_ACL_SRCFILTER_IPRANGE:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Source Filter(IP RANGE)", actionT[rule->actionType_]);
+				seq_printf(s,"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+						rule->srcFilterMac_.octet[0], rule->srcFilterMac_.octet[1], rule->srcFilterMac_.octet[2],
+						rule->srcFilterMac_.octet[3], rule->srcFilterMac_.octet[4], rule->srcFilterMac_.octet[5],
+						rule->srcFilterMacMask_.octet[0], rule->srcFilterMacMask_.octet[1], rule->srcFilterMacMask_.octet[2],
+						rule->srcFilterMacMask_.octet[3], rule->srcFilterMacMask_.octet[4], rule->srcFilterMacMask_.octet[5]
+						);
+				seq_printf(s,"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+						rule->srcFilterVlanIdx_, rule->srcFilterVlanIdxMask_, rule->srcFilterPort_, rule->srcFilterPortMask_,
+						(rule->srcFilterIgnoreL3L4_==TRUE? 2: (rule->srcFilterIgnoreL4_ == 1? 1: 0))
+						);
+				seq_printf(s,"\tsipU: %d.%d.%d.%d   sipL: %d.%d.%d.%d\n", (rule->srcFilterIpAddr_>>24),
+						((rule->srcFilterIpAddr_&0x00ff0000)>>16), ((rule->srcFilterIpAddr_&0x0000ff00)>>8),
+						(rule->srcFilterIpAddr_&0xff), (rule->srcFilterIpAddrMask_>>24),
+						((rule->srcFilterIpAddrMask_&0x00ff0000)>>16), ((rule->srcFilterIpAddrMask_&0x0000ff00)>>8),
+						(rule->srcFilterIpAddrMask_&0xff)
+						);
+				seq_printf(s,"\tsportL: %d   sportU: %d\n", rule->srcFilterPortLowerBound_, rule->srcFilterPortUpperBound_);
+				break;
+
+			case RTL865X_ACL_DSTFILTER:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Deatination Filter", actionT[rule->actionType_]);
+				seq_printf(s,"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+						rule->dstFilterMac_.octet[0], rule->dstFilterMac_.octet[1], rule->dstFilterMac_.octet[2],
+						rule->dstFilterMac_.octet[3], rule->dstFilterMac_.octet[4], rule->dstFilterMac_.octet[5],
+						rule->dstFilterMacMask_.octet[0], rule->dstFilterMacMask_.octet[1], rule->dstFilterMacMask_.octet[2],
+						rule->dstFilterMacMask_.octet[3], rule->dstFilterMacMask_.octet[4], rule->dstFilterMacMask_.octet[5]
+						);
+				seq_printf(s,"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+						rule->dstFilterVlanIdx_, rule->dstFilterVlanIdxMask_,
+						(rule->dstFilterIgnoreL3L4_==TRUE? 2: (rule->dstFilterIgnoreL4_ == 1? 1: 0)),
+						rule->dstFilterPortLowerBound_, rule->dstFilterPortUpperBound_
+						);
+				seq_printf(s,"\tdip: %d.%d.%d.%d   dipM: %d.%d.%d.%d\n", (rule->dstFilterIpAddr_>>24),
+						((rule->dstFilterIpAddr_&0x00ff0000)>>16), ((rule->dstFilterIpAddr_&0x0000ff00)>>8),
+						(rule->dstFilterIpAddr_&0xff), (rule->dstFilterIpAddrMask_>>24),
+						((rule->dstFilterIpAddrMask_&0x00ff0000)>>16), ((rule->dstFilterIpAddrMask_&0x0000ff00)>>8),
+						(rule->dstFilterIpAddrMask_&0xff)
+						);
+				break;
+			case RTL865X_ACL_DSTFILTER_IPRANGE:
+				seq_printf(s," [%d] rule type: %s   rule action: %s\n", rule->aclIdx, "Deatination Filter(IP Range)", actionT[rule->actionType_]);
+				seq_printf(s,"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+						rule->dstFilterMac_.octet[0], rule->dstFilterMac_.octet[1], rule->dstFilterMac_.octet[2],
+						rule->dstFilterMac_.octet[3], rule->dstFilterMac_.octet[4], rule->dstFilterMac_.octet[5],
+						rule->dstFilterMacMask_.octet[0], rule->dstFilterMacMask_.octet[1], rule->dstFilterMacMask_.octet[2],
+						rule->dstFilterMacMask_.octet[3], rule->dstFilterMacMask_.octet[4], rule->dstFilterMacMask_.octet[5]
+						);
+				seq_printf(s,"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+						rule->dstFilterVlanIdx_, rule->dstFilterVlanIdxMask_,
+						(rule->dstFilterIgnoreL3L4_==TRUE? 2: (rule->dstFilterIgnoreL4_ == 1? 1: 0)),
+						rule->dstFilterPortLowerBound_, rule->dstFilterPortUpperBound_
+						);
+				seq_printf(s,"\tdipU: %d.%d.%d.%d   dipL: %d.%d.%d.%d\n", (rule->dstFilterIpAddr_>>24),
+						((rule->dstFilterIpAddr_&0x00ff0000)>>16), ((rule->dstFilterIpAddr_&0x0000ff00)>>8),
+						(rule->dstFilterIpAddr_&0xff), (rule->dstFilterIpAddrMask_>>24),
+						((rule->dstFilterIpAddrMask_&0x00ff0000)>>16), ((rule->dstFilterIpAddrMask_&0x0000ff00)>>8),
+						(rule->dstFilterIpAddrMask_&0xff)
+					);
+				break;
+
+				default:
+					seq_printf(s,"rule->ruleType_(0x%x)\n", rule->ruleType_);
+
+		}
+
+		switch (rule->actionType_)
+		{
+			case RTL865X_ACL_PERMIT:
+			case RTL865X_ACL_REDIRECT_ETHER:
+			case RTL865X_ACL_DROP:
+			case RTL865X_ACL_TOCPU:
+			case RTL865X_ACL_LEGACY_DROP:
+			case RTL865X_ACL_DROPCPU_LOG:
+			case RTL865X_ACL_MIRROR:
+			case RTL865X_ACL_REDIRECT_PPPOE:
+			case RTL865X_ACL_MIRROR_KEEP_MATCH:
+				seq_printf(s,"\tnetifIdx: %d   pppoeIdx: %d   l2Idx:%d  ", rule->netifIdx_, rule->pppoeIdx_, rule->L2Idx_);
+				break;
+
+			case RTL865X_ACL_PRIORITY:
+				seq_printf(s,"\tprioirty: %d   ",  rule->priority_) ;
+				break;
+
+			case RTL865X_ACL_DEFAULT_REDIRECT:
+				seq_printf(s,"\tnextHop:%d  ",  rule->nexthopIdx_);
+				break;
+
+			case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+			case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+			case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+			case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+				seq_printf(s,"\tratelimitIdx: %d  ",  rule->ratelimtIdx_);
+				break;
+			default:
+				;
+
+		}
+		seq_printf(s,"pktOpApp: %d	handler:0x%x Mark: %d\n",  rule->pktOpApp_, qosRule->handle, qosRule->mark);
+		seq_printf(s,"InDev: %s	OutDev: %s\n", qosRule->inIfname[0]==0?"NULL":qosRule->inIfname, qosRule->outIfname[0]==0?"NULL":qosRule->outIfname);
+
+		rule = rule->next;
+	}
+
+	return SUCCESS;
+
+}
+#endif
+
+int rtl865x_syncRemarkInfoToAsic(uint8 *netIfName)
+{
+
+	uint32	memberPort, port;
+	rtl865x_netif_local_t	*netIf;
+	rtl865x_vlan_entry_t	*vlan;
+	int qosMarkNumIdx;
+	int netifIdx;
+
+	netIf = _rtl865x_getNetifByName(netIfName);
+	if(netIf == NULL)
+		return FAILED;
+	netifIdx=netIf->asicIdx ;
+	if(netifIdx>=NETIF_NUMBER)
+		return FAILED;
+	vlan = _rtl8651_getVlanTableEntry(netIf->vid);
+	if(vlan == NULL)
+		return FAILED;
+
+	memberPort = vlan->memberPortMask;
+
+	for(port=0;port<=CPU;port++)
+	{
+		if(((1<<port)&memberPort)==0)
+			continue;
+
+		for(qosMarkNumIdx=0;qosMarkNumIdx<MAX_MARK_NUM_PER_DEV;qosMarkNumIdx++)
+		{
+			if(mark2Priority[netifIdx][qosMarkNumIdx].mark )
+			{
+				if( mark2Priority[netifIdx][qosMarkNumIdx].dscpRemark!=0xff)
+					rtl8651_setAsicDscpRemark(port, mark2Priority[netifIdx][qosMarkNumIdx].priority,  mark2Priority[netifIdx][qosMarkNumIdx].dscpRemark);
+
+				if( mark2Priority[netifIdx][qosMarkNumIdx].vlanpriRemark!=0xff)
+					rtl8651_setAsicVlanRemark(port, mark2Priority[netifIdx][qosMarkNumIdx].priority,  mark2Priority[netifIdx][qosMarkNumIdx].vlanpriRemark);
+			}
+		}
+	}
+	return SUCCESS;
+}
+
+int rtl865x_setRemarkByMark(uint8 *netIfName,unsigned int markValue,int remarkDscp,int remark8021p)
+{
+	rtl865x_netif_local_t	*netIf;
+	int qosMarkNumIdx;
+	int netifIdx;
+
+	if((remarkDscp==-1)&&(remark8021p==-1))
+		return FAILED;
+
+	netIf = _rtl865x_getNetifByName(netIfName);
+	if(netIf == NULL)
+		return FAILED;
+	netifIdx=netIf->asicIdx ;
+	if(netifIdx>=NETIF_NUMBER)
+		return FAILED;
+
+	//panic_printk("netif:%s,%d memberPort:%x,mark:%d, pri:%d,remarkDscp:%d,remark8021p:%d,[%s]:[%d].\n",
+	//netIfName,netifIdx,memberPort,markValue,priority,remarkDscp,remark8021p,__FUNCTION__,__LINE__);
+	for(qosMarkNumIdx=0;qosMarkNumIdx<MAX_MARK_NUM_PER_DEV;qosMarkNumIdx++)
+	{
+		if(mark2Priority[netifIdx][qosMarkNumIdx].mark == markValue)
+		{
+			if(remarkDscp!=-1)
+				mark2Priority[netifIdx][qosMarkNumIdx].dscpRemark =remarkDscp;
+			if(remark8021p!=-1)
+				mark2Priority[netifIdx][qosMarkNumIdx].vlanpriRemark=remark8021p;
+		}
+	}
+
+	rtl865x_syncRemarkInfoToAsic(netIfName);
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_HW_QOS_BRIDGE_FWD_SUPPORT)
+static int rtl865x_setPortPriorityByClassId(int port, int netifIdx, unsigned int classId)
+{
+	int priority = 0;
+
+	priority = _rtl865x_qosGetPriorityByHandle(netifIdx, classId);
+
+	rtl865xC_lockSWCore();
+
+	rtl8651_setAsicPortPriority(port, priority);
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+
+	return SUCCESS;
+}
+
+static int rtl865x_setVlanPriorityByClassId(int vlanPri, int netifIdx, unsigned int classId)
+{
+	int priority = 0;
+
+	priority = _rtl865x_qosGetPriorityByHandle(netifIdx, classId);
+
+	rtl865xC_lockSWCore();
+
+	rtl8651_setAsicDot1qAbsolutelyPriority(vlanPri, priority);
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+
+	return SUCCESS;
+}
+
+static int rtl865x_setDscpPriorityByClassId(int dscp, int netifIdx, unsigned int classId)
+{
+	int priority = 0;
+
+	priority = _rtl865x_qosGetPriorityByHandle(netifIdx, classId);
+
+	rtl865xC_lockSWCore();
+
+	rtl8651_setAsicDscpPriority(dscp, priority);
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+
+	return SUCCESS;
+}
+
+static int rtl865x_resetPortPriority(int port)
+{
+	rtl865xC_lockSWCore();
+
+	rtl8651_setAsicPortPriority(port, 0);
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+
+	return SUCCESS;
+}
+
+static int rtl865x_resetVlanPriority(int vlanPri)
+{
+	int priority = 0;
+
+	priority = vlanPri2SystemPri[vlanPri];
+	rtl865xC_lockSWCore();
+
+	rtl8651_setAsicDot1qAbsolutelyPriority(vlanPri, priority);
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+
+	return SUCCESS;
+}
+
+static int rtl865x_resetDscpPriority(int dscp)
+{
+	rtl865xC_lockSWCore();
+
+	rtl8651_setAsicDscpPriority(dscp, 1);
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+
+	return SUCCESS;
+}
+
+static int rtl865x_flushPortPriority(void)
+{
+	int port;
+
+	rtl865xC_lockSWCore();
+
+	for (port=0; port<RTL8651_PORT_NUMBER; port++)
+	{
+		rtl8651_setAsicPortPriority(port, 0);
+	}
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+
+	return SUCCESS;
+}
+
+static int rtl865x_flushVlanPriority(void)
+{
+	int vlanPri, priority;
+
+	rtl865xC_lockSWCore();
+
+	for (vlanPri=0; vlanPri<TOTAL_VLAN_PRIORITY_NUM; vlanPri++)
+	{
+		priority = vlanPri2SystemPri[vlanPri];
+		rtl8651_setAsicDot1qAbsolutelyPriority(vlanPri, priority);
+	}
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+
+	return SUCCESS;
+}
+
+static int rtl865x_flushDscpPriority(void)
+{
+	int dscp;
+
+	rtl865xC_lockSWCore();
+
+	for (dscp=0; dscp<TOTAL_DSCP_NUM; dscp++)
+	{
+		rtl8651_setAsicDscpPriority(dscp, 1);
+	}
+
+	rtl865xC_waitForOutputQueueEmpty();
+	rtl8651_resetAsicOutputQueue();
+	rtl865xC_unLockSWCore();
+
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+int rtl_dump_AsicRemark_info(struct seq_file *s)
+{
+
+	int i=4, j;
+	int dscpRemark=0;
+	int vlanpriRemark=0;
+
+	seq_printf(s, "Dump Asic remark Info:\n");
+
+	for(j=0; j<=PRI7; j++)
+	{
+		rtl8651_getAsicDscpRemark(i, j, &dscpRemark);
+		rtl8651_getAsicVlanRemark(i, j, &vlanpriRemark);
+		seq_printf(s, "    Port[%d]'s sys_pri[%d] is remarked as v4Dscp[%d] 802.1p priority[%d]\n", i, j, dscpRemark, vlanpriRemark);
+	}
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+extern rtl865x_netif_local_t *_rtl865x_getNetifByIdx(unsigned int i);
+extern int rtl_getPortlistByDevName(char *name, uint32 *portlist);
+
+static int rtl865x_setIgressBandwidthByName(uint8 *netIfName,unsigned int kbps)
+{
+	rtl865x_netif_local_t	*netIf;
+	uint32	memberPort;
+	rtl865x_vlan_entry_t	*vlan;
+	uint32	port;
+
+	if (rtl_getPortlistByDevName(netIfName, &memberPort) == FAILED) {
+		netIf = _rtl865x_getNetifByName(netIfName);
+		if(netIf == NULL)
+			return FAILED;
+		vlan = _rtl8651_getVlanTableEntry(netIf->vid);
+		if(vlan == NULL)
+			return FAILED;
+
+		memberPort = vlan->memberPortMask;
+	}
+
+	for(port=0; port < CPU; port++)
+	{
+		if(((1 << port) & memberPort) == 0)
+			continue;
+		rtl8651_setAsicPortIngressBandwidth(port, kbps);
+	}
+
+	return SUCCESS;
+}
+
+static int rtl865x_setIgressBandwidthByPort(unsigned int port,unsigned int kbps)
+{
+	if(port > CPU)
+		return FAILED;
+
+	rtl8651_setAsicPortIngressBandwidth(port, kbps);
+
+	return SUCCESS;
+}
+
+static int rtl865x_resetRemark(void)
+{
+	int i, j;
+
+	memset(mark2Priority, 0, NETIF_NUMBER * MAX_MARK_NUM_PER_DEV * sizeof(rtl_qos_mark_info_t));
+
+	for(i=0; i < NETIF_NUMBER; i++)
+	{
+		for(j=0; j < MAX_MARK_NUM_PER_DEV; j++){
+			mark2Priority[i][j].dscpRemark    = 0xff;
+			mark2Priority[i][j].vlanpriRemark = 0xff;
+		}
+
+	}
+
+	rtl8651_resetAsicDscpRemark();
+	rtl8651_resetAsicVlanRemark();
+	return SUCCESS;
+}
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+int rtl_dump_configQosRemark_info(struct seq_file *s)
+{
+	int qosMarkNumIdx=0;
+	rtl865x_netif_local_t	*netIf;
+	int netifIdx=0;
+
+	seq_printf(s, "Dump config qosInfo:\n");
+	for(netifIdx=0;netifIdx<NETIF_NUMBER;netifIdx++)
+	{
+		netIf = _rtl865x_getNetifByIdx(netifIdx);
+		if(netIf == NULL)
+			continue;
+
+		seq_printf(s, "\n%s config qosInfo:\n",netIf->name);
+		for(qosMarkNumIdx=0;qosMarkNumIdx<MAX_MARK_NUM_PER_DEV;qosMarkNumIdx++)
+		{
+			if(mark2Priority[netifIdx][qosMarkNumIdx].mark)
+			{
+				seq_printf(s, "mark [%d] -> priority[%d]-> v4Dscp[%d]:vlanpriority[%d]\n",
+				mark2Priority[netifIdx][qosMarkNumIdx].mark,
+				mark2Priority[netifIdx][qosMarkNumIdx].priority,
+				mark2Priority[netifIdx][qosMarkNumIdx].dscpRemark,
+				mark2Priority[netifIdx][qosMarkNumIdx].vlanpriRemark);
+			}
+		}
+		seq_printf(s, "====================\n");
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtl_hw_qos_config_read(struct seq_file *s, void *v)
+{
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	rtl_dump_configQosRemark_info(s);
+	rtl_dump_AsicRemark_info(s);
+#endif
+	return 0;
+}
+#else
+static int32 rtl_hw_qos_config_read( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int i, j;
+	int len=0;
+
+	for (i=0; i<2; i++)
+	{
+		if (rtl865x_isWanNetifByIdx(i)==0)
+			len += sprintf(page+len, "%s\n", "br0 Hw Qos Cofig");
+		else if (rtl865x_isWanNetifByIdx(i)==1)
+			len += sprintf(page+len, "%s\n", "eth1 Hw Qos Cofig");
+		else
+			continue;
+
+		#if defined(CONFIG_RTL_HW_QOS_BRIDGE_FWD_SUPPORT)
+		len += sprintf(page+len, "\t%s\n", "Port Based Info:");
+		for (j=0; j<RTL8651_PORT_NUMBER; j++)
+		{
+			if (classId2Port[i][j]!=0) {
+				len += sprintf(page+len, "\t\tPort[%d] mapping to classId[0x%x]\n", j, classId2Port[i][j]);
+			}
+		}
+
+		len += sprintf(page+len, "\t%s\n", "Vlan Priority Based Info:");
+		for (j=0; j<TOTAL_VLAN_PRIORITY_NUM; j++)
+		{
+			if (classId2VlanPriority[i][j]!=0) {
+				len += sprintf(page+len, "\t\tVlan Priority[%d] mapping to classId[0x%x]\n", j, classId2VlanPriority[i][j]);
+			}
+		}
+
+		len += sprintf(page+len, "\t%s\n", "DSCP Based Info:");
+		for (j=0; j<TOTAL_DSCP_NUM; j++)
+		{
+			if (classId2Dscp[i][j]!=0) {
+				len += sprintf(page+len, "\t\tDscp[%d] mapping to classId[0x%x]\n", j, classId2Dscp[i][j]);
+			}
+		}
+		#endif
+	}
+
+	if (len <= off+count) *eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len>count)
+		len = count;
+	if (len<0)
+	  	len = 0;
+
+	return len;
+}
+#endif
+
+int rtl_hw_qos_config_single_open(struct inode *inode, struct file *file)
+{
+	return(single_open(file, rtl_hw_qos_config_read,NULL));
+}
+
+/*cmd example:
+echo "add port 1 classId 1000 eth1" > /proc/rtl_hw_qos_config
+echo "add vlan 2 classId 2000 br0" > /proc/rtl_hw_qos_config
+echo "add dscp 4 classId 3000 eth1" > /proc/rtl_hw_qos_config
+
+echo "del port 1 classId 1000 eth1" > /proc/rtl_hw_qos_config
+echo "del vlan 2 classId 2000 br0" > /proc/rtl_hw_qos_config
+echo "del dscp 4 classId 3000 eth1" > /proc/rtl_hw_qos_config
+
+echo "flush port" > /proc/rtl_hw_qos_config
+echo "flush vlan" > /proc/rtl_hw_qos_config
+echo "flush dscp" > /proc/rtl_hw_qos_config
+echo "flush all" > /proc/rtl_hw_qos_config
+
+echo "remark netif eth1 mark 13 1 2 > /proc/rtl_hw_qos_config"  // The stream marked 13 set dscp remark =1 and 802.1p priority remark =2
+*/
+static int32 rtl_hw_qos_config_write( struct file *filp, const char *buff,unsigned long len, void *data )
+{
+
+	char tmpbuf[512];
+	char *strptr;
+	char	*cmdptr;
+	int remarkDscp=-1,remark8021p=-1;
+	unsigned int markValue=0;
+	uint8	name[MAX_IFNAMESIZE];
+
+	#if defined(CONFIG_RTL_HW_QOS_BRIDGE_FWD_SUPPORT)
+	int i, j;
+	int tmp = 0;
+	int netifIdx = 0;
+	unsigned classId = 0;
+	#endif
+
+	if (len>512)
+		goto errout;
+
+	if (buff && !copy_from_user(tmpbuf, buff, len))
+	{
+		tmpbuf[len] = '\0';
+		strptr=tmpbuf;
+		if (strlen(strptr)==0)
+			goto errout;
+
+		cmdptr = strsep(&strptr," ");
+		if (cmdptr==NULL)
+			goto errout;
+
+		if(strncmp(cmdptr, "remark",6) == 0){
+			//rtlglue_printf("remark config [%s]:[%d].\n",__FUNCTION__,__LINE__);
+
+			cmdptr = strsep(&strptr," ");
+			if (cmdptr==NULL)
+				goto errout;
+			if (strncmp(cmdptr, "netif",5) == 0)
+			{
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				sscanf(cmdptr, "%s", name);
+
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+				if (strncmp(cmdptr, "mark",4) == 0)
+				{
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+					markValue=simple_strtol(cmdptr, NULL, 0);
+
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+					remarkDscp=simple_strtol(cmdptr, NULL, 0);
+
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+					remark8021p=simple_strtol(cmdptr, NULL, 0);
+
+					//sscanf(cmdptr, "%d %d", &remarkDscp, &remark8021p);
+					//panic_printk("netif:%s,mark:%d,remarkdscp:%d,remark8021p:%d,[%s]:[%d].\n",
+					//name,markValue,remarkDscp,remark8021p,__FUNCTION__,__LINE__);
+					if((remarkDscp!= -1)||(remark8021p!=-1))
+					{
+						rtl865x_setRemarkByMark(name,markValue,remarkDscp,remark8021p);
+					}
+
+				}
+				else
+					goto errout;
+			}
+			#if defined(CONFIG_RTD_1295_HWNAT)
+			else if (strncmp(cmdptr, "reset",5) == 0)
+			{
+				rtl865x_resetRemark();
+			}
+			#endif /* CONFIG_RTD_1295_HWNAT */
+			else
+			{
+				goto errout;
+			}
+		}
+		#if defined(CONFIG_RTD_1295_HWNAT)
+		/*echo "police netif eth0 50000000" > /proc/rtl_hw_qos_config*/
+		/*echo "police port 5 50000000" > /proc/rtl_hw_qos_config*/
+		/*echo "police reset" > /proc/rtl_hw_qos_config*/
+		else if (strncmp(cmdptr, "police",6) == 0) {
+			int port = 0;
+			int kbps = 0;
+
+			cmdptr = strsep(&strptr," ");
+			if (cmdptr == NULL)
+				goto errout;
+
+			if (strncmp(cmdptr, "netif",5) == 0)
+			{
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+				sscanf(cmdptr, "%s", name);
+
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr == NULL)
+					goto errout;
+				kbps = simple_strtol(cmdptr, NULL, 0);
+				rtl865x_setIgressBandwidthByName(name, kbps);
+			}
+			else if (strncmp(cmdptr, "port",4) == 0)
+			{
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+				port = simple_strtol(cmdptr, NULL, 0);
+
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr == NULL)
+					goto errout;
+				kbps = simple_strtol(cmdptr, NULL, 0);
+				rtl865x_setIgressBandwidthByPort(port, kbps);
+			}
+			else if (strncmp(cmdptr, "reset",5) == 0)
+			{
+				for (port = 0; port <= CPU; port++)
+					rtl865x_setIgressBandwidthByPort(port, 0);
+			}
+		}
+		#endif /* CONFIG_RTD_1295_HWNAT */
+		#if defined(CONFIG_RTL_HW_QOS_BRIDGE_FWD_SUPPORT)
+		/*echo "add port 1 classId 1000 eth1" > /proc/rtl_hw_qos_config*/
+		else if (strncmp(cmdptr, "add",3) == 0) {
+			cmdptr = strsep(&strptr," ");
+			if (cmdptr==NULL)
+				goto errout;
+
+			if (strncmp(cmdptr, "port",4) == 0) {
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				sscanf(cmdptr, "%d", &tmp);
+				if (tmp<0 ||tmp>=RTL8651_PORT_NUMBER)
+					goto errout;
+
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				if (strncmp(cmdptr, "classId",7) == 0) {
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					sscanf(cmdptr, "%u", &classId);
+
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					if (strncmp(cmdptr, RTL_DRV_LAN_NETIF_NAME,strlen(RTL_DRV_LAN_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_LAN_NETIF_NAME);
+					else if (strncmp(cmdptr, RTL_DRV_WAN0_NETIF_NAME, strlen(RTL_DRV_WAN0_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_WAN0_NETIF_NAME);
+					else
+						goto errout;
+
+					if (netifIdx < 0)
+						goto errout;
+					classId2Port[netifIdx][tmp] = classId;
+					rtl865x_setPortPriorityByClassId(tmp, netifIdx, classId);
+				}
+			} else if (strncmp(cmdptr, "vlan",4) == 0) {
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				sscanf(cmdptr, "%d", &tmp);
+				if (tmp<0 ||tmp>=TOTAL_VLAN_PRIORITY_NUM)
+					goto errout;
+
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				if (strncmp(cmdptr, "classId",7) == 0) {
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					sscanf(cmdptr, "%u", &classId);
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					if (strncmp(cmdptr, RTL_DRV_LAN_NETIF_NAME,strlen(RTL_DRV_LAN_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_LAN_NETIF_NAME);
+					else if (strncmp(cmdptr, RTL_DRV_WAN0_NETIF_NAME, strlen(RTL_DRV_WAN0_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_WAN0_NETIF_NAME);
+					else
+						goto errout;
+
+					if (netifIdx < 0)
+						goto errout;
+
+					classId2VlanPriority[netifIdx][tmp] = classId;
+					rtl865x_setVlanPriorityByClassId(tmp, netifIdx, classId);
+				}
+			} else if (strncmp(cmdptr, "dscp",4) == 0) {
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				sscanf(cmdptr, "%d", &tmp);
+				if (tmp<0 ||tmp>=TOTAL_DSCP_NUM)
+					goto errout;
+
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				if (strncmp(cmdptr, "classId",7) == 0) {
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					sscanf(cmdptr, "%u", &classId);
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					if (strncmp(cmdptr, RTL_DRV_LAN_NETIF_NAME,strlen(RTL_DRV_LAN_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_LAN_NETIF_NAME);
+					else if (strncmp(cmdptr, RTL_DRV_WAN0_NETIF_NAME, strlen(RTL_DRV_WAN0_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_WAN0_NETIF_NAME);
+					else
+						goto errout;
+
+					if (netifIdx < 0)
+						goto errout;
+
+					classId2Dscp[netifIdx][tmp] = classId;
+					rtl865x_setDscpPriorityByClassId(tmp, netifIdx, classId);
+				}
+			} else
+				goto errout;
+		} else if (strncmp(cmdptr, "del",3) == 0) {
+			cmdptr = strsep(&strptr," ");
+			if (cmdptr==NULL)
+				goto errout;
+
+			if (strncmp(cmdptr, "port",4) == 0) {
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				sscanf(cmdptr, "%d", &tmp);
+				if (tmp<0 ||tmp>=RTL8651_PORT_NUMBER)
+					goto errout;
+
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				if (strncmp(cmdptr, "classId",7) == 0) {
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					sscanf(cmdptr, "%u", &classId);
+
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					if (strncmp(cmdptr, RTL_DRV_LAN_NETIF_NAME,strlen(RTL_DRV_LAN_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_LAN_NETIF_NAME);
+					else if (strncmp(cmdptr, RTL_DRV_WAN0_NETIF_NAME, strlen(RTL_DRV_WAN0_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_WAN0_NETIF_NAME);
+					else
+						goto errout;
+
+					if (netifIdx < 0)
+						goto errout;
+
+					if (classId2Port[netifIdx][tmp]==classId) {
+						classId2Port[netifIdx][tmp] = 0;
+						rtl865x_resetPortPriority(tmp);
+					}
+				}
+			} else if (strncmp(cmdptr, "vlan",4) == 0) {
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				sscanf(cmdptr, "%d", &tmp);
+				if (tmp<0 ||tmp>=TOTAL_VLAN_PRIORITY_NUM)
+					goto errout;
+
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				if (strncmp(cmdptr, "classId",7) == 0) {
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					sscanf(cmdptr, "%u", &classId);
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					if (strncmp(cmdptr, RTL_DRV_LAN_NETIF_NAME,strlen(RTL_DRV_LAN_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_LAN_NETIF_NAME);
+					else if (strncmp(cmdptr, RTL_DRV_WAN0_NETIF_NAME, strlen(RTL_DRV_WAN0_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_WAN0_NETIF_NAME);
+					else
+						goto errout;
+
+					if (netifIdx < 0)
+						goto errout;
+
+					if (classId2VlanPriority[netifIdx][tmp] == classId) {
+						classId2VlanPriority[netifIdx][tmp] = 0;
+						rtl865x_resetVlanPriority(tmp);
+					}
+				}
+			} else if (strncmp(cmdptr, "dscp",4) == 0) {
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				sscanf(cmdptr, "%d", &tmp);
+				if (tmp<0 ||tmp>=TOTAL_DSCP_NUM)
+					goto errout;
+
+				cmdptr = strsep(&strptr," ");
+				if (cmdptr==NULL)
+					goto errout;
+
+				if (strncmp(cmdptr, "classId",7) == 0) {
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					sscanf(cmdptr, "%u", &classId);
+					cmdptr = strsep(&strptr," ");
+					if (cmdptr==NULL)
+						goto errout;
+
+					if (strncmp(cmdptr, RTL_DRV_LAN_NETIF_NAME,strlen(RTL_DRV_LAN_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_LAN_NETIF_NAME);
+					else if (strncmp(cmdptr, RTL_DRV_WAN0_NETIF_NAME, strlen(RTL_DRV_WAN0_NETIF_NAME))==0)
+						netifIdx = _rtl865x_getNetifIdxByNameExt(RTL_DRV_WAN0_NETIF_NAME);
+					else
+						goto errout;
+
+					if (netifIdx < 0)
+						goto errout;
+
+					if (classId2Dscp[netifIdx][tmp] == classId) {
+						classId2Dscp[netifIdx][tmp] = 0;
+						rtl865x_resetDscpPriority(tmp);
+					}
+				}
+			} else
+				goto errout;
+		}
+		else if (strncmp(cmdptr, "flush",5) == 0) {
+			cmdptr = strsep(&strptr," ");
+			if (cmdptr==NULL)
+				goto errout;
+
+			if (strncmp(cmdptr, "port",4) == 0) {
+				for (i=0; i<NETIF_NUMBER; i++) {
+					for (j=0; j<RTL8651_PORT_NUMBER; j++) {
+						classId2Port[i][j] = 0;
+					}
+				}
+
+				rtl865x_flushPortPriority();
+			} else if (strncmp(cmdptr, "vlan",4) == 0) {
+				for (i=0; i<NETIF_NUMBER; i++) {
+					for (j=0; j<TOTAL_VLAN_PRIORITY_NUM; j++) {
+						classId2VlanPriority[i][j] = 0;
+					}
+				}
+
+				rtl865x_flushVlanPriority();
+			} else if (strncmp(cmdptr, "dscp",4) == 0) {
+				for (i=0; i<NETIF_NUMBER; i++) {
+					for (j=0; j<TOTAL_DSCP_NUM; j++) {
+						classId2Dscp[i][j] = 0;
+					}
+				}
+
+				rtl865x_flushDscpPriority();
+			} else if (strncmp(cmdptr, "all",3) == 0) {
+				for (i=0; i<NETIF_NUMBER; i++) {
+					for (j=0; j<RTL8651_PORT_NUMBER; j++)
+						classId2Port[i][j] = 0;
+					for (j=0; j<TOTAL_VLAN_PRIORITY_NUM; j++)
+						classId2VlanPriority[i][j] = 0;
+					for (j=0; j<TOTAL_DSCP_NUM; j++)
+						classId2Dscp[i][j] = 0;
+				}
+				rtl865x_flushPortPriority();
+				rtl865x_flushVlanPriority();
+				rtl865x_flushDscpPriority();
+			} else
+				goto errout;
+		}
+		#endif
+		else {
+errout:
+			printk("error input\n");
+			return len;
+		}
+	}
+
+	return len;
+}
+
+static ssize_t rtl_hw_qos_config_single_write(struct file * file, const char __user * userbuf,
+		     size_t count, loff_t * off)
+{
+	    return rtl_hw_qos_config_write(file, userbuf,count, off);
+}
+
+#if defined CONFIG_RTL_8367_QOS_TEST
+void rtl865x_qos_set(void)
+{
+	int prio;
+	//	set port priority highest
+	rtl8651_setAsicPriorityDecision(0xF, 0, 0, 0, 0, 0);
+	/* set port priority*/
+	rtl8651_setAsicPortBasedPriority(0, 0);
+	rtl8651_setAsicPortBasedPriority(1, 0);
+	rtl8651_setAsicPortBasedPriority(2, 7);
+	rtl8651_setAsicPortBasedPriority(3, 7);
+	/*802.1p remark*/
+	for(prio = 0; prio <= 0; prio++)
+		rtl8651_setAsicVlanRemark(0, prio, prio);
+}
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_stp.c b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_stp.c
new file mode 100644
index 00000000..40af6b1
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l2Driver/rtl865x_stp.c
@@ -0,0 +1,39 @@
+/*
+ *
+ *  Copyright (c) 2011 Realtek Semiconductor Corp.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 2 as
+ *  published by the Free Software Foundation.
+ */
+
+
+//#include "rtl_utils.h"
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "AsicDriver/asicRegs.h"
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#else
+#include <common/rtl8651_aclLocal.h>
+#include <AsicDriver/rtl865xC_tblAsicDrv.h>
+#endif
+
+#include <net/rtl/rtk_stp.h>
+
+int32 rtl865x_setSpanningEnable(int8 spanningTreeEnabled)
+{
+	return rtl8651_setAsicSpanningEnable(spanningTreeEnabled);
+}
+
+int32 rtl865x_setSpanningTreePortState(uint32 port, uint32 portState)
+{
+	return rtl865xC_setAsicSpanningTreePortState(port,  portState);
+}
+
+int32 rtl865x_setMulticastSpanningTreePortState(uint32 port, uint32 portState)
+{
+	//Note: 96C/98 have remove these bits!!!
+	return SUCCESS;
+}
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/Makefile b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/Makefile
new file mode 100644
index 00000000..df2cd99
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/Makefile
@@ -0,0 +1,68 @@
+#
+# Makefile for the Tulip ethernet driver
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definitions are now in the main makefile...
+#Add mips16 Support
+
+DIR_RTLASIC = $(srctree)/drivers/soc/realtek/rtd129x/hw_nat/
+ifdef CONFIG_RTL865X_KERNEL_MIPS16_LAYERDRIVER
+	CFLAGS_rtl865x_arp.o 		= -mips16
+	CFLAGS_rtl865x_ip.o		= -mips16
+	CFLAGS_rtl865x_ppp.o 		= -mips16
+	CFLAGS_rtl865x_nexthop.o 	= -mips16
+	CFLAGS_rtl865x_route.o		= -mips16
+	CFLAGS_rtl865x_multicast.o	= -mips16
+endif
+
+	obj-$(CONFIG_RTL_HARDWARE_MULTICAST) := rtl865x_multicast.o
+
+ifdef CONFIG_RTL_HARDWARE_IPV6_SUPPORT
+		obj-y += rtl8198c_routeIpv6.o rtl8198c_arpIpv6.o rtl8198c_nexthopIpv6.o
+endif
+
+ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+		obj-y += rtl865x_arp.o rtl865x_ip.o rtl865x_ppp.o rtl865x_nexthop.o rtl865x_route.o
+endif
+ifdef CONFIG_RTL_MULTIPLE_WAN
+		obj-y += rtl865x_multipleWan.o
+else
+ifdef CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN
+		obj-y += rtl865x_multipleWan.o
+endif
+endif
+ifdef CONFIG_RTL_LOCAL_PUBLIC
+		obj-y += rtl865x_localPublic.o
+endif
+
+ifdef CONFIG_RTL_HW_DSLITE_SUPPORT
+		obj-y += rtl865x_dslite.o
+endif
+
+ifdef CONFIG_RTL_HW_6RD_SUPPORT
+	obj-y += rtl865x_6rd.o
+endif
+
+EXTRA_CFLAGS += -O1 -DRTL_TBLDRV -D__linux__ -DRTL865X_OVER_KERNEL -DRTL865X_OVER_LINUX -Werror
+#EXTRA_CFLAGS += -I$(srctree)
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/AsicDriver
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/common
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/l2Driver
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/igmpsnooping
+EXTRA_CFLAGS += -I$(DIR_RTLASIC)
+
+ifeq ($(CONFIG_RTL865X_MODULE_ROMEDRV),y)
+	EXTRA_CFLAGS += -D__KERNEL__
+	EXTRA_CFLAGS += -G 0
+	EXTRA_CFLAGS += -DMODULE
+	EXTRA_CFLAGS += -mlong-calls
+	EXTRA_CFLAGS += -DEXPORT_SYMTAB
+	EXTRA_CFLAGS += -DCONFIG_RTL865X_MODULE_INTERNAL
+#	EXTRA_CFLAGS += -DMODVERSIONS
+#	EXTRA_CFLAGS += -include $(srctree)/include/linux/modversions.h
+endif
+
+EXTRA_AFLAGS += $(EXTRA_CFLAGS)
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_arpIpv6.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_arpIpv6.c
new file mode 100644
index 00000000..98f3d89
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_arpIpv6.c
@@ -0,0 +1,674 @@
+/*      @doc RTL_LAYEREDDRV_API
+
+        @module rtl8198c_arpIpv6.c - RTL8198c Home gateway controller Layered driver API documentation       |
+        This document explains the API interface of the table driver module. Functions with rtl8198c prefix
+        are external functions.
+        @normal Jia Wenjian(wenjain_jai@realsil.com.cn) <date>
+
+        Copyright <cp>2013 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+        @head3 List of Symbols |
+        Here is a list of all functions and variables in this module.
+
+        @index | RTL_LAYEREDDRV_API
+
+        This program is free software; you can redistribute it and/or modify
+        it under the terms of the GNU General Public License as published by
+        the Free Software Foundation; either version 2 of the License, or
+        (at your option) any later version.
+*/
+
+#include <net/rtl/rtl_types.h>
+#include "common/rtl_errno.h"
+#include "common/mbuf.h"
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "rtl865xC_tblAsicDrv.h"
+#include "common/rtl8651_aclLocal.h"
+#endif
+
+#include "AsicDriver/rtl865x_hwPatch.h"		/* define for chip related spec */
+#include "common/rtl865x_eventMgr.h"
+#include "common/rtl865x_vlan.h"
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl865x_netif_local.h"
+#include "l2Driver/rtl865x_fdb.h"
+#include "rtl865x_ppp_local.h"
+#include "rtl8198c_routeIpv6.h"
+#include "rtl8198c_arpIpv6.h"
+#include <net/rtl/rtl865x_fdb_api.h>
+
+static uint32 rtl8198c_ipv6ArpHash(inv6_addr_t ip, uint32 subnetIdx);
+static int32 rtl8198c_ipv6_arp_callbackFn_for_del_fdb(void *param);
+static int32 rtl8198c_ipv6_arp_register_event(void);
+static struct rtl8198c_ipv6_arp_table ipv6ArpTables;
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+static struct rtl8198c_ipv6_arp_table ipv6ArpTablesBack;
+#endif
+static int32 rtl8198c_ipv6_arp_callbackFn_for_del_fdb(void *param)
+{
+	int i;
+	rtl865x_filterDbTableEntry_t  *fdbEntry;
+
+	if (param == NULL) {
+		return EVENT_CONTINUE_EXECUTE;
+	}
+
+	fdbEntry = (rtl865x_filterDbTableEntry_t *)param;
+	for(i=0; i<RTL8198C_IPV6_ARPTBL_SIZE; i++)
+	{
+		/*be careful of dead loop, the delete fdb event maybe caused by arp time out*/
+		if ((ipv6ArpTables.mappings[i].valid==1)&&memcmp(&(fdbEntry->macAddr), &(ipv6ArpTables.mappings[i].mac), 6)==0)
+			rtl8198c_delIpv6Arp(ipv6ArpTables.mappings[i].ip);
+	}
+
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 rtl8198c_ipv6_arp_unRegister_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId = DEFAULT_IPV6_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_DEL_FDB;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = rtl8198c_ipv6_arp_callbackFn_for_del_fdb;
+	rtl865x_unRegisterEvent(&eventParam);
+	return SUCCESS;
+}
+static int32 rtl8198c_ipv6_arp_register_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId = DEFAULT_IPV6_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_DEL_FDB;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = rtl8198c_ipv6_arp_callbackFn_for_del_fdb;
+	rtl865x_registerEvent(&eventParam);
+	return SUCCESS;
+}
+
+int32 rtl8198c_ipv6_arp_init(void)
+{
+	int i;
+
+	rtl8198c_ipv6_arp_unRegister_event();
+
+	memset(ipv6ArpTables.mappings, 0, RTL8198C_IPV6_ARPTBL_SIZE*sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+
+	for(i=0; i<RTL8198C_IPV6_ARPTBL_SIZE; i++)
+	{
+		rtl8198C_delAsicArpV6(i);
+	}
+
+	rtl8198c_ipv6_arp_register_event();
+
+	return SUCCESS;
+}
+
+int32 rtl8198c_ipv6_arp_reinit(void)
+{
+	return rtl8198c_ipv6_arp_init();
+}
+
+static uint32 rtl8198c_ipv6ArpHash(inv6_addr_t ip, uint32 subnetIdx)
+{
+	uint32 id[66];
+	uint32 arpv6_hash_idx[6], arpv6_hash[6];
+	uint32 i, src;
+	uint32 offset= 0;
+	uint32 hash_idx_arpv6 = 0;
+
+	memset(arpv6_hash_idx, 0, 6*4);
+	memset(arpv6_hash, 0, 6*4);
+
+    	src = ip.v6_addr32[3];
+	for (i=0; i<32; i++)
+	{
+		if ((src&(1<<i)) != 0) {
+		    id[i+offset]=1;
+		} else {
+		    id[i+offset]=0;
+		}
+	}
+
+    	offset = 32;
+    	src = ip.v6_addr32[2];
+	for (i=0; i<32; i++)
+	{
+		if ((src&(1<<i)) != 0) {
+		    id[i+offset]=1;
+		} else {
+		    id[i+offset]=0;
+		}
+	}
+
+    	offset = 64;
+	src = subnetIdx;
+	for (i=0; i<3; i++)
+	{
+		if ((src&(1<<i)) != 0) {
+		    id[i+offset]=1;
+		} else {
+		    id[i+offset]=0;
+		}
+	}
+
+	arpv6_hash_idx[0] = id[0] ^ id[6]  ^ id[12] ^ id[18] ^ id[24] ^ id[30] ^ id[36] ^ id[42] ^ id[48] ^ id[54] ^ id[60] ^ id[66];
+	arpv6_hash_idx[1] = id[1] ^ id[7]  ^ id[13] ^ id[19] ^ id[25] ^ id[31] ^ id[37] ^ id[43] ^ id[49] ^ id[55] ^ id[61] ;
+	arpv6_hash_idx[2] = id[2] ^ id[8]  ^ id[14] ^ id[20] ^ id[26] ^ id[32] ^ id[38] ^ id[44] ^ id[50] ^ id[56] ^ id[62] ;
+	arpv6_hash_idx[3] = id[3] ^ id[9]  ^ id[15] ^ id[21] ^ id[27] ^ id[33] ^ id[39] ^ id[45] ^ id[51] ^ id[57] ^ id[63] ;
+	arpv6_hash_idx[4] = id[4] ^ id[10] ^ id[16] ^ id[22] ^ id[28] ^ id[34] ^ id[40] ^ id[46] ^ id[52] ^ id[58] ^ id[64] ;
+	arpv6_hash_idx[5] = id[5] ^ id[11] ^ id[17] ^ id[23] ^ id[29] ^ id[35] ^ id[41] ^ id[47] ^ id[53] ^ id[59] ^ id[65] ;
+
+	for (i=0; i<6; i++)
+	{
+		arpv6_hash[i] = arpv6_hash_idx[i] & (0x01);
+	}
+
+	for (i=0; i<6; i++)
+	{
+		hash_idx_arpv6 = hash_idx_arpv6+(arpv6_hash[i]<<i);
+	}
+
+   //	printk("hash_idx_arpv6:0x%x @ rtl8651_Arpv6TableIndexn\n",hash_idx_arpv6);
+	return hash_idx_arpv6&0x3f;
+}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+
+int32 rtl8198c_dslite_Ipv6ArpMapping(inv6_addr_t ip, rtl8198c_ipv6_arpMapping_entry_t * arp_mapping)
+{
+	int i;
+	rtl8198c_ipv6_arpMapping_entry_t * arpEntry=NULL;
+
+	if (arp_mapping == NULL)
+	{
+		printk("%s,%d. arp_mapping NULL\n",__FUNCTION__,__LINE__);
+		return FAILED;
+	}
+	memset(arp_mapping, 0, sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+
+	for(i=0;i<RTL8651_ARPTBL_SIZE;i++)
+	{
+		arpEntry = &ipv6ArpTables.mappings[i];
+
+		if(arpEntry->valid==0)
+			continue;
+
+		if(memcmp(&ip,&(arpEntry->ip),sizeof(inv6_addr_t))==0)
+		{
+			memcpy(&(arp_mapping->mac),&(arpEntry->mac),6);
+			//printk("%s,%d. get mac success ******************\n",__FUNCTION__,__LINE__);
+			return SUCCESS;
+		}
+	}
+	return FAILED;
+}
+#endif
+#endif
+
+int32 rtl8198c_getIpv6ArpMapping(inv6_addr_t ip, rtl8198c_ipv6_arpMapping_entry_t * arp_mapping)
+{
+	uint32 hash_low, hash_high, hash;
+	rtl8198c_ipv6_route_t *route,rt_entry;
+	int32 retval = FAILED;
+
+	if (arp_mapping == NULL)
+		return FAILED;
+
+	memset(arp_mapping, 0, sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+
+	route = &rt_entry;
+	memset(route, 0, sizeof(rtl8198c_ipv6_route_t));
+	retval = rtl8198c_getIpv6RouteEntryByIp(ip, route);
+	if (retval != SUCCESS)
+		return retval;
+
+	if ((route->valid!=1) ||(route->process!=2) ||(route->dstNetif==NULL))
+		return FAILED;
+
+	hash_high = rtl8198c_ipv6ArpHash(ip, route->arp.subnetIdx);
+	/*ipv6 arp table use 4-way hash*/
+	for (hash_low=0; hash_low<4; hash_low++)
+	{
+		hash = hash_high<<2 |hash_low;
+		if ((memcmp(&ipv6ArpTables.mappings[hash].ip, &ip, sizeof(inv6_addr_t))==0)&&
+			(ipv6ArpTables.mappings[hash].subnetIdx==route->arp.subnetIdx)) {
+			memcpy(arp_mapping, &(ipv6ArpTables.mappings[hash]), sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+			return SUCCESS;
+		}
+	}
+	return FAILED;
+}
+
+static int32 rtl8198c_getIpv6ArpFid(inv6_addr_t ip, uint16 *fid)
+{
+	rtl8198c_ipv6_route_t *route,rt_entry;
+	rtl865x_vlan_entry_t *vlan;
+	int32 retval = FAILED;
+
+	if ((ip.v6_addr32[0]==0)&&(ip.v6_addr32[1]==0)&&(ip.v6_addr32[2]==0)&&(ip.v6_addr32[3]==0))
+		return FAILED;
+
+	route = &rt_entry;
+	memset(route, 0, sizeof(rtl8198c_ipv6_route_t));
+	retval = rtl8198c_getIpv6RouteEntryByIp(ip, route);
+	if(retval != SUCCESS)
+		return retval;
+
+	if((route->valid!=1) ||(route->process!=2) ||(route->dstNetif==NULL))
+		return FAILED;
+
+	vlan = _rtl8651_getVlanTableEntry(route->dstNetif->vid);
+	*fid = vlan->fid;
+
+	return SUCCESS;
+}
+
+int32 rtl8198c_isIpv6EthArp(inv6_addr_t ip)
+{
+	uint32 hash_low, hash_high, hash, retval;
+	rtl8198c_ipv6_route_t *route, rt_entry;
+
+	route = &rt_entry;
+	memset(route, 0, sizeof(rtl8198c_ipv6_route_t));
+	retval = rtl8198c_getIpv6RouteEntryByIp(ip, route);
+	if (retval != SUCCESS)
+		return FALSE;
+	if ((route->valid!=1) ||(route->process!=2) ||(route->dstNetif==NULL))
+		return FALSE;
+
+	hash_high = rtl8198c_ipv6ArpHash(ip, route->arp.subnetIdx);
+	for (hash_low=0; hash_low<4; hash_low++)
+	{
+		hash = hash_high<<2 |hash_low;
+		if ((ipv6ArpTables.mappings[hash].valid==1) && (ipv6ArpTables.mappings[hash].subnetIdx==route->arp.subnetIdx) &&
+		     (memcmp(&ipv6ArpTables.mappings[hash].ip, &ip, sizeof(inv6_addr_t))==0)) {
+			return TRUE;
+		}
+	}
+
+	return FALSE;
+}
+
+int32 rtl8198c_isEthPortMask(uint32 portMask)
+{
+	int i;
+
+	for (i=0; i <=RTL8651_PHY_NUMBER; i++)
+	{
+		if ((1<<i) & portMask)
+			return TRUE;
+	}
+
+	return FALSE;
+}
+
+int32 rtl8198c_addIpv6Arp(inv6_addr_t ip, ether_addr_t *mac)
+{
+	uint16 fid = 0;
+	int32   hash_found = -1;
+	uint32 i, hash_high, hash_low, hash, column, retval;
+
+	rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+
+	rtl8198c_ipv6_arpMapping_entry_t oldArpMapping;
+	rtl8198c_ipv6_arpMapping_entry_t newArpMapping;
+
+	rtl8198c_ipv6_route_t *route, rt_entry;
+	rtl8198C_tblAsicDrv_arpV6Param_t asicArpEntry;
+
+	uint32 fdb_type[]={ FDB_STATIC, FDB_DYNAMIC };
+
+
+	#if 0
+	pr_err("%s.%d.ipAddr(0x%4x%4x%4x%4x%4x%4x%4x%4x),mac(%02x:%02x:%02x:%02x:%02x:%02x)****\n",
+			__FUNCTION__,__LINE__,
+			ip.v6_addr16[0],ip.v6_addr16[1],ip.v6_addr16[2],ip.v6_addr16[3],
+			ip.v6_addr16[4],ip.v6_addr16[5],ip.v6_addr16[6],ip.v6_addr16[7],
+			mac->octet[0],mac->octet[1],
+			mac->octet[2],mac->octet[3],mac->octet[4],mac->octet[5]);
+	#endif
+
+	if (((ip.v6_addr32[0]==0)&&(ip.v6_addr32[1]==0)&&(ip.v6_addr32[2]==0)&&(ip.v6_addr32[3]==0)) ||(mac==NULL))
+		return RTL_EINVALIDINPUT;
+
+	route = &rt_entry;
+	memset(route, 0, sizeof(rtl8198c_ipv6_route_t));
+	retval = rtl8198c_getIpv6RouteEntryByIp(ip, route);
+	if (retval != SUCCESS)
+		return FAILED;
+	if ((route->valid!=1) ||(route->process!=2) ||(route->dstNetif==NULL))
+		return FAILED;
+
+	hash_high = rtl8198c_ipv6ArpHash(ip, route->arp.subnetIdx);
+	for (hash_low=0; hash_low<4; hash_low++)
+	{
+		hash = hash_high<<2 |hash_low;
+		if ((ipv6ArpTables.mappings[hash].valid==1) && (ipv6ArpTables.mappings[hash].subnetIdx==route->arp.subnetIdx) &&
+		     (memcmp(&ipv6ArpTables.mappings[hash].ip, &ip, sizeof(inv6_addr_t))==0)) {
+			if (memcmp(&ipv6ArpTables.mappings[hash].mac, mac, 6) != 0) {
+				/*should clear old arp mapping before delete fdb entry and raise arp event*/
+				memcpy(&oldArpMapping, &(ipv6ArpTables.mappings[hash]), sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+				rtl8198C_delAsicArpV6(hash);
+				memset(&(ipv6ArpTables.mappings[hash]), 0, sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+
+				if (rtl8198c_getIpv6ArpFid(oldArpMapping.ip, &fid) == SUCCESS)
+					rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEI|RTL865x_L2_TYPEII, fid, &oldArpMapping.mac);
+
+				rtl865x_raiseEvent(EVENT_DEL_IPV6_ARP, (void*)(&oldArpMapping));
+			} else {
+				hash_found = hash;
+			}
+		}
+	}
+
+	if (hash_found == -1) {
+		for (hash_low=0; hash_low<4; hash_low++)
+		{
+			hash = hash_high<<2 |hash_low;
+			if (ipv6ArpTables.mappings[hash].valid==0)
+				break;
+		}
+	} else {
+		/*use the exist entry*/
+		hash = hash_found;
+	}
+
+	/*here to handle the new arp mapping*/
+	memcpy(&newArpMapping.ip, &ip, sizeof(inv6_addr_t));
+	memcpy(&newArpMapping.mac,mac,sizeof(ether_addr_t));
+	newArpMapping.subnetIdx = route->arp.subnetIdx;
+	if (rtl8198c_getIpv6ArpFid(newArpMapping.ip, &fid) != SUCCESS)
+		return FAILED;
+
+	for (i=0; i<2; i++)
+	{
+
+		#if 0
+		pr_err("%s:%d,fid(%d),mac(%02x:%02x:%02x:%02x:%02x:%02x)\n",__FUNCTION__,__LINE__,fid,mac->octet[0],mac->octet[1],
+			mac->octet[2],mac->octet[3],mac->octet[4],mac->octet[5]);
+		#endif
+
+		if (rtl865x_Lookup_fdb_entry(fid, mac, fdb_type[i], &column, &fdbEntry) != SUCCESS)
+			continue;
+
+		#if 1//#if defined(CONFIG_RTL_AVOID_ADDING_WLAN_PKT_TO_HW_NAT)
+		if (rtl8198c_isEthPortMask(fdbEntry.memberPortMask) == FALSE)
+			continue;
+		#endif
+
+		/*update or reflesh arp mapping*/
+		asicArpEntry.valid = 1;
+		asicArpEntry.aging    =    300;
+		asicArpEntry.subnet_id = route->arp.subnetIdx;
+		asicArpEntry.nextHopColumn = column;
+	 	asicArpEntry.nextHopRow=rtl865x_getHWL2Index(mac, fid);
+		memcpy(&asicArpEntry.hostid, &ip, sizeof(inv6_addr_t));
+		rtl8198C_setAsicArpV6(hash, &asicArpEntry);
+
+		rtl865x_refleshHWL2Table(mac, FDB_DYNAMIC|FDB_STATIC, fid);
+		/*update mapping table*/
+		memcpy(&(ipv6ArpTables.mappings[hash]), &newArpMapping, sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+		ipv6ArpTables.mappings[hash].valid = 1;
+		rtl865x_raiseEvent(EVENT_ADD_IPV6_ARP,(void*)(&newArpMapping));
+
+		return SUCCESS;
+	}
+
+	return FAILED;
+}
+
+int32 rtl8198c_delIpv6Arp(inv6_addr_t ip)
+{
+	uint16 fid = 0;
+	uint32 hash_high, hash_low, hash, retval;
+	rtl8198c_ipv6_route_t *route, rt_entry;
+	rtl8198c_ipv6_arpMapping_entry_t arpMapping;
+
+	if ((ip.v6_addr32[0]==0)&&(ip.v6_addr32[1]==0)&&(ip.v6_addr32[2]==0)&&(ip.v6_addr32[3]==0))
+		return FAILED;
+
+	route = &rt_entry;
+	memset(route, 0, sizeof(rtl8198c_ipv6_route_t));
+	retval = rtl8198c_getIpv6RouteEntryByIp(ip, route);
+	if (retval != SUCCESS)
+		return FAILED;
+	if ((route->valid!=1) ||(route->process!=2) ||(route->dstNetif==NULL))
+		return FAILED;
+
+	hash_high = rtl8198c_ipv6ArpHash(ip, route->arp.subnetIdx);
+	for (hash_low=0; hash_low<4; hash_low++)
+	{
+		hash = hash_high<<2 |hash_low;
+		if ((ipv6ArpTables.mappings[hash].valid==1) && (ipv6ArpTables.mappings[hash].subnetIdx==route->arp.subnetIdx) &&
+		     (memcmp(&ipv6ArpTables.mappings[hash].ip, &ip, sizeof(inv6_addr_t))==0)) {
+				memcpy(&arpMapping, &ipv6ArpTables.mappings[hash], sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+				if (rtl8198c_getIpv6ArpFid(ip, &fid) != SUCCESS)
+					return FAILED;
+
+				/*should clear old arp mapping before delete fdb entry and raise arp event*/
+				rtl8198C_delAsicArpV6(hash);
+				memset(&ipv6ArpTables.mappings[hash], 0, sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+
+				rtl865x_raiseEvent(EVENT_DEL_IPV6_ARP, (void *)(&arpMapping));
+				return SUCCESS;
+		}
+	}
+
+	return FAILED;
+}
+
+int32 rtl8198c_delIpv6ArpBySubnetIdx(uint32 subnetIdx)
+{
+	int32 i;
+	uint16 fid = 0;
+
+	for (i=0; i<RTL8198C_IPV6_ARPTBL_SIZE; i++)
+	{
+		if ((ipv6ArpTables.mappings[i].valid==1) && (ipv6ArpTables.mappings[i].subnetIdx==subnetIdx)) {
+			if (rtl8198c_getIpv6ArpFid(ipv6ArpTables.mappings[i].ip, &fid) != SUCCESS)
+				continue;
+
+			rtl8198C_delAsicArpV6(i);
+			rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEII, fid, &(ipv6ArpTables.mappings[i].mac));
+			memset(&ipv6ArpTables.mappings[i], 0, sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+		}
+	}
+
+	return SUCCESS;
+}
+
+uint32 rtl8198c_ipv6ArpSync(inv6_addr_t ip, uint32 refresh )
+{
+	uint16 fid;
+	uint32 age=0;
+	int32   found = -1;
+	uint32 hash_high, hash_low, hash, retval;
+	rtl8198c_ipv6_route_t *route, rt_entry;
+	rtl8198c_ipv6_arpMapping_entry_t arpMapping;
+	rtl8198C_tblAsicDrv_arpV6Param_t asicArpEntry;
+	rtl865x_tblAsicDrv_l2Param_t l2entry;
+
+	if ((ip.v6_addr32[0]==0)&&(ip.v6_addr32[1]==0)&&(ip.v6_addr32[2]==0)&&(ip.v6_addr32[3]==0))
+		return 0;
+
+	route = &rt_entry;
+	memset(route, 0, sizeof(rtl8198c_ipv6_route_t));
+	retval = rtl8198c_getIpv6RouteEntryByIp(ip, route);
+	if (retval != SUCCESS)
+		return 0;
+	if ((route->valid!=1) ||(route->process!=2) ||(route->dstNetif==NULL))
+		return 0;
+
+	hash_high = rtl8198c_ipv6ArpHash(ip, route->arp.subnetIdx);
+	for (hash_low=0; hash_low<4; hash_low++)
+	{
+		hash = hash_high<<2 |hash_low;
+		if ((ipv6ArpTables.mappings[hash].valid==1) && (ipv6ArpTables.mappings[hash].subnetIdx==route->arp.subnetIdx) &&
+		     (memcmp(&ipv6ArpTables.mappings[hash].ip, &ip, sizeof(inv6_addr_t))==0)) {
+				memcpy(&arpMapping, &(ipv6ArpTables.mappings[hash]), sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+				found = 1;
+				break;
+		}
+	}
+
+	if (found == -1)
+		return 0;
+
+	/*asic arp entry is invalid*/
+	if (rtl8198C_getAsicArpV6(hash, &asicArpEntry)!=SUCCESS)
+		goto delete_and_out;
+
+	if (rtl865x_getHWL2Table(asicArpEntry.nextHopRow, asicArpEntry.nextHopColumn, &l2entry) != SUCCESS)
+		/*the old fdb entry has timed out*/
+		goto delete_and_out;
+
+	if (memcmp(&(l2entry.macAddr), &(arpMapping.mac), 6) != 0)
+		/*this layer 2 entry has different mac address,
+		also indicates the old fdb entry has timed out*/
+		goto delete_and_out;
+
+	age = l2entry.ageSec;
+	if (refresh) {
+		 rtl865x_refleshHWL2Table(&(l2entry.macAddr), FDB_DYNAMIC|FDB_STATIC, l2entry.fid);
+		 age=150;
+	} else {
+		if (age>=300) {
+			age=age-150;
+		}
+		else {
+			age=0;
+
+			/*to make sure linux arp entry time out before fdb entry*/
+			/*asic fdb entry's age is 150 seconds*/
+			/*since linux protocol stack arp entry has timed out and l2 entry's precision is also 150 second,
+			we should delete both arp and fdb  to sync between linux protocol stack and asic*/
+			//goto delete_and_out;
+		}
+	}
+
+	return age;
+
+delete_and_out:
+
+	if (rtl8198c_getIpv6ArpFid(ip, &fid) == SUCCESS) {
+		/*should clear old arp mapping before delete fdb entry and raise arp event*/
+		rtl8198C_delAsicArpV6(hash);
+		memset(&ipv6ArpTables.mappings[hash], 0, sizeof(rtl8198c_ipv6_arpMapping_entry_t));
+
+		rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEI|RTL865x_L2_TYPEII, fid, &arpMapping.mac);
+		rtl865x_raiseEvent(EVENT_DEL_IPV6_ARP, (void *)(&arpMapping));
+	}
+
+	return 0;
+
+}
+
+int32 rtl8198c_changeIpv6ArpSubnetIdx(uint32 old_subnetIdx, uint32 new_subnetIdx)
+{
+	int i;
+	rtl8198C_tblAsicDrv_arpV6Param_t asicArpEntry;
+
+	for (i=0; i<RTL8198C_IPV6_ARPTBL_SIZE; i++)
+	{
+		if ((ipv6ArpTables.mappings[i].valid==1) && (ipv6ArpTables.mappings[i].subnetIdx==old_subnetIdx)) {
+			if (rtl8198C_getAsicArpV6(i, &asicArpEntry) != SUCCESS) {
+				printk("%s[%d], Waring ipv6 arp sw tables is not the same with hw table!\n", __FUNCTION__, __LINE__);
+				continue;
+			}
+
+			ipv6ArpTables.mappings[i].subnetIdx = new_subnetIdx;
+			asicArpEntry.subnet_id = new_subnetIdx;
+			rtl8198C_setAsicArpV6(i, &asicArpEntry);
+		}
+	}
+
+	return SUCCESS;
+}
+
+
+#ifdef CONFIG_RTL_PROC_NEW
+int32 sw_arp6_read(struct seq_file *s, void *v)
+{
+
+
+	uint32 i;
+	rtl8198c_ipv6_arpMapping_entry_t * arpEntry=NULL;
+
+
+	seq_printf(s, "%s\n", "SW arp6 Table:\n");
+
+	for(i=0;i<RTL8651_ARPTBL_SIZE;i++)
+	{
+		arpEntry = &ipv6ArpTables.mappings[i];
+		if(arpEntry->valid==0)
+			continue;
+		seq_printf(s,"  [%d]  %d,ip:%x:%x:%x:%x,mac:%x-%x-%x-%x-%x-%x \n", i,arpEntry->subnetIdx,
+			arpEntry->ip.v6_addr32[0],arpEntry->ip.v6_addr32[1],arpEntry->ip.v6_addr32[2],arpEntry->ip.v6_addr32[3],
+			arpEntry->mac.octet[0],arpEntry->mac.octet[1],arpEntry->mac.octet[2],
+			arpEntry->mac.octet[3],arpEntry->mac.octet[4],arpEntry->mac.octet[5]);
+	}
+
+	return 0;
+}
+#else
+int32 sw_arp6_read( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int len;
+	rtl8198c_ipv6_arpMapping_entry_t * arpEntry=NULL;
+
+	uint32 i;
+
+	len = sprintf(page, "%s\n", "SW arp6 Table:\n");
+	for(i=0;i<RTL8651_ARPTBL_SIZE;i++)
+	{
+		arpEntry = &ipv6ArpTables.mappings[i];
+		if(arpEntry->valid==0)
+			continue;
+		len += sprintf(page + len,"  [%d]  %d,ip:%x:%x:%x:%x,mac:%x-%x-%x-%x-%x-%x \n", i,arpEntry->subnetIdx,
+			arpEntry->ip.v6_addr32[0],arpEntry->ip.v6_addr32[1],arpEntry->ip.v6_addr32[2],arpEntry->ip.v6_addr32[3],
+			arpEntry->mac.octet[0],arpEntry->mac.octet[1],arpEntry->mac.octet[2],
+			arpEntry->mac.octet[3],arpEntry->mac.octet[4],arpEntry->mac.octet[5]);
+	}
+
+	return len;
+}
+#endif
+
+int32 sw_arp6_write( struct file *filp, const char *buff,unsigned long len, void *data )
+{
+	return len;
+}
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+void rtl819x_save_hw_ipv6_arp_table(void)
+{
+	memcpy(&ipv6ArpTablesBack, &ipv6ArpTables, sizeof(struct rtl8198c_ipv6_arp_table));
+
+	return;
+}
+
+int rtl819x_restore_hw_ipv6_arp_table(void)
+{
+	int i;
+	int ret = FAILED;
+	ether_addr_t empty_mac = { {0x00, 0x00, 0x00, 0x00, 0x00, 0x00} };
+
+
+	for (i = 0; i < RTL8198C_IPV6_ARPTBL_SIZE; i++)
+	{
+		if ((ipv6ArpTablesBack.mappings[i].ip.v6_addr32[0]&& ipv6ArpTablesBack.mappings[i].ip.v6_addr32[1]
+			&&ipv6ArpTablesBack.mappings[i].ip.v6_addr32[2]&& ipv6ArpTablesBack.mappings[i].ip.v6_addr32[3])
+			|| memcmp(ipv6ArpTablesBack.mappings[i].mac.octet, empty_mac.octet, ETHER_ADDR_LEN)!=0){
+			ret = rtl8198c_addIpv6Arp(ipv6ArpTablesBack.mappings[i].ip, &ipv6ArpTablesBack.mappings[i].mac);
+		}
+	}
+
+	return SUCCESS;
+}
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_arpIpv6.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_arpIpv6.h
new file mode 100644
index 00000000..49a7c7d4
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_arpIpv6.h
@@ -0,0 +1,18 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL8198C_ARP_IPV6_H
+#define RTL8198C_ARP_IPV6_H
+
+#include <net/rtl/rtl8198c_arp_ipv6_api.h>
+/*for driver initialization*/
+int32 rtl8198c_ipv6_arp_init(void);
+int32 rtl8198c_ipv6_arp_reinit(void);
+
+#endif
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_nexthopIpv6.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_nexthopIpv6.c
new file mode 100644
index 00000000..2096414
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_nexthopIpv6.c
@@ -0,0 +1,699 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2013
+* All rights reserved.
+*
+* Program : ipv6 nexthop table driver
+* Abstract :
+* Author : Jia Wenjian (wenjain_jai@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+/*      @doc RTL_LAYEREDDRV_API
+
+        @module rtl8196c_nexthopIpv6.c - RTL865x Home gateway controller Layered driver API documentation       |
+        This document explains the API interface of the table driver module. Functions with rtl8198c prefix
+        are external functions.
+        @normal Jia Wenjian (wenjain_jai@realsil.com.cn) <date>
+
+        Copyright <cp>2013 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+        @head3 List of Symbols |
+        Here is a list of all functions and variables in this module.
+
+        @index | RTL_LAYEREDDRV_API
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl_errno.h"
+#include "common/rtl865x_netif_local.h"
+#include "rtl865x_ip.h"
+#include "rtl8198c_nexthopIpv6.h"
+//#include "rtl865x_ppp.h"
+#include "rtl865x_ppp_local.h"
+#include "rtl8198c_routeIpv6.h"
+#include "rtl8198c_arpIpv6.h"
+
+#include "common/rtl865x_vlan.h"
+#include "common/rtl865x_eventMgr.h" /*call back function....*/
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#endif
+#include "l2Driver/rtl865x_fdb.h"
+#include <net/rtl/rtl865x_fdb_api.h>
+
+#include <linux/version.h>
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#include "rtl865x_route.h"
+#include "rtl865x_arp.h"
+#include "rtl865x_nexthop.h"
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+#ifdef CONFIG_RTL_HW_6RD_SUPPORT
+#include <linux/netdevice.h>
+#include <net/ip_tunnels.h>
+#include "rtl865x_6rd.h"
+extern ipaddr_t br_ip_addr;
+#endif
+#endif
+
+
+static rtl8198c_ipv6_nextHopEntry_t *rtl865x_ipv6_nxtHopTable;
+
+#define IPV6_NEXTHOP_TABLE_INDEX(entry)	(entry - rtl865x_ipv6_nxtHopTable)
+static int32 _rtl8198c_ipv6_nextHop_register_event(void);
+static int32 _rtl8198c_ipv6_nextHop_unRegister_event(void);
+static int32 _rtl8198c_delIpv6NxtHop(uint32 attr, uint32 entryIdx);
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(3,4,0)
+extern int32 _rtl865x_referPpp(uint32 sessionId);
+extern int32 _rtl865x_deReferPpp(uint32 sessionId);
+#endif
+
+#if 0
+static void _print_softNxtHop(void)
+{
+	int32 i = 0;
+	rtl8198c_ipv6_nextHopEntry_t *entry = rtl865x_ipv6_nxtHopTable;
+	printk("software nextHop table:\n");
+	for(i = 0; i < IPV6_NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		printk("idx(%d): valid(%d),dst(%s),nexthop(0x%x%x%x%x),nexthopType(%d),refCnt(%d)\n",i,entry->valid,entry->dstNetif->name,
+			entry->un.nexthop.v6_addr32[0], entry->un.nexthop.v6_addr32[1],entry->un.nexthop.v6_addr32[2],
+			entry->un.nexthop.v6_addr32[3],entry->nextHopType,entry->refCnt);
+	}
+}
+#endif
+
+/*
+@func int32 | rtl8198c_initIpv6NxtHopTable |initialize the nexthop table
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed. system should reboot.
+@comm
+*/
+int32 rtl8198c_initIpv6NxtHopTable(void)
+{
+	TBL_MEM_ALLOC(rtl865x_ipv6_nxtHopTable, rtl8198c_ipv6_nextHopEntry_t, IPV6_NXTHOP_ENTRY_NUM);
+	memset(rtl865x_ipv6_nxtHopTable,0,sizeof(rtl8198c_ipv6_nextHopEntry_t)*IPV6_NXTHOP_ENTRY_NUM);
+	_rtl8198c_ipv6_nextHop_register_event();
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8198c_reinitIpv6NxtHopTable |reinitialize the nexthop table
+@rvalue SUCCESS | success.
+@comm
+*/
+int32 rtl8198c_reinitIpv6NxtHopTable(void)
+{
+	int32 i;
+	_rtl8198c_ipv6_nextHop_unRegister_event();
+
+	for(i = 0; i < IPV6_NXTHOP_ENTRY_NUM; i++)
+	{
+		if(rtl865x_ipv6_nxtHopTable[i].valid)
+			_rtl8198c_delIpv6NxtHop(IPV6_NEXTHOP_L3,i);
+	}
+
+	_rtl8198c_ipv6_nextHop_register_event();
+	return SUCCESS;
+}
+
+static int32 _rtl8198c_synIpv6NxtHopToAsic(rtl8198c_ipv6_nextHopEntry_t *entry_t)
+{
+	rtl8198C_tblAsicDrv_nextHopV6Param_t asic;
+	ether_addr_t reservedMac;
+	rtl865x_tblAsicDrv_l2Param_t asic_l2;
+	rtl865x_netif_local_t *dstNetif;
+	uint32 fid = 0;
+	uint32 columIdx = 0;
+	int32 retval = 0;
+
+	retval = rtl865x_getReserveMacAddr(&reservedMac);
+
+	bzero(&asic, sizeof(rtl8198C_tblAsicDrv_nextHopV6Param_t));
+
+	if (entry_t == NULL)
+		return RTL_EINVALIDINPUT;
+
+	if (entry_t->nextHopType == IF_ETHER) {
+		rtl8198c_ipv6_arpMapping_entry_t arp_t;
+		int32 ret_arpFound = FAILED;
+
+		/*if the arp info of nexthop is not found, reserved to cpu Mac is used for trap packet to CPU*/
+		if ((entry_t->un.nexthop.v6_addr32[0]!=0)||(entry_t->un.nexthop.v6_addr32[1]!=0)||
+		     (entry_t->un.nexthop.v6_addr32[2]!=0)||(entry_t->un.nexthop.v6_addr32[3]!=0))
+			ret_arpFound = rtl8198c_getIpv6ArpMapping(entry_t->un.nexthop, &arp_t);
+
+		rtl865x_getVlanFilterDatabaseId(entry_t->dstNetif->vid, &fid);
+		retval = rtl865x_Lookup_fdb_entry(fid, (ret_arpFound == SUCCESS)? &arp_t.mac : &reservedMac, FDB_DYNAMIC, &columIdx,&asic_l2);
+
+		asic.nextHopRow = rtl8651_filterDbIndex( (ret_arpFound == SUCCESS)? &arp_t.mac : &reservedMac, fid );
+		asic.nextHopColumn = (retval == SUCCESS)? columIdx: 0;
+
+		asic.isPppoe = FALSE;
+		asic.pppoeIdx = 0;
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#ifdef CONFIG_RTL_HW_6RD_SUPPORT
+	else if(entry_t->nextHopType == IF_6RD)
+	{
+		rtl865x_arpMapping_entry_t arp_t;
+		int32 ret_arpFound = FAILED;
+		/*if the arp info of nexthop is not found, reserved to cpu Mac is used for trap packet to CPU*/
+
+		ret_arpFound = rtl8198c_6rd_Ipv6ArpMapping(br_ip_addr, &arp_t);
+		rtl865x_getVlanFilterDatabaseId(entry_t->dstNetif->vid,&fid);
+		retval = rtl865x_Lookup_fdb_entry(fid, (ret_arpFound == SUCCESS)? &arp_t.mac : &reservedMac, FDB_DYNAMIC, &columIdx,&asic_l2);
+
+		asic.nextHopRow = rtl8651_filterDbIndex( (ret_arpFound == SUCCESS)? &arp_t.mac : &reservedMac, fid );
+		asic.nextHopColumn = (retval == SUCCESS)? columIdx: 0;
+		asic.isPppoe = FALSE;
+		asic.pppoeIdx = 0;
+
+		//printk("%d,%d,[%s]:[%d].\n",asic.nextHopRow,asic.nextHopColumn,__FUNCTION__,__LINE__);
+	}
+#endif
+#endif
+	else
+	{
+		/*session based interface type*/
+		rtl865x_ppp_t pppoe;
+		int32 pppidx = 0;
+
+		memset(&pppoe,0,sizeof(rtl865x_ppp_t));
+
+		if(entry_t->un.pppSessionId)
+			retval = rtl865x_getPppBySessionId(entry_t->un.pppSessionId, &pppoe);
+
+		rtl865x_getVlanFilterDatabaseId(entry_t->dstNetif->vid,&fid);
+
+		retval =rtl865x_Lookup_fdb_entry(fid, (pppoe.valid)? &pppoe.server_mac : &reservedMac, FDB_DYNAMIC, &columIdx,&asic_l2);
+
+		asic.nextHopRow = rtl8651_filterDbIndex( (pppoe.valid)? &pppoe.server_mac : &reservedMac, fid);
+		asic.nextHopColumn = (pppoe.valid)? columIdx: 0;
+		asic.isPppoe = (pppoe.type == IF_PPPOE)? TRUE: FALSE;
+
+		retval = rtl865x_getPppIdx(&pppoe, &pppidx);
+
+		//printk("%s(%d): pppoeIdx(%d), pppoeType(%d), pppoevalid(%d),pppoeSid(%d)\n",__FUNCTION__,__LINE__,pppidx,pppoe.type,pppoe.valid,pppoe.sessionId);
+		asic.pppoeIdx	= (pppoe.type == IF_PPPOE)? pppidx: 0;
+	}
+
+	if (entry_t->dstNetif->is_slave == 1) {
+		dstNetif = entry_t->dstNetif->master;
+
+		if(dstNetif == NULL)
+			dstNetif = _rtl865x_getDefaultWanNetif();
+	} else {
+		dstNetif = entry_t->dstNetif;
+	}
+
+	if(dstNetif == NULL)
+		printk("_%s(%d), BUG!!!!!!",__FUNCTION__,__LINE__);
+
+	asic.dvid 			= dstNetif->asicIdx;
+
+	//printk("%s(%d), entryIdx(%d),asic.isPPPoe(%d),asic.pppoeIdx(%d),asic.dvid(%d)\n", __FUNCTION__,__LINE__,entry_t->entryIndex,asic.isPppoe,asic.pppoeIdx,asic.dvid);
+	rtl8198C_setAsicNextHopTableV6(entry_t->entryIndex,  &asic);
+
+	return SUCCESS;
+}
+
+
+static int32 _rtl8198c_arrangeIpv6NxtHop(uint32 start, uint32 num)
+{
+	int32 idx;
+	rtl8198c_ipv6_nextHopEntry_t *entry = NULL;
+
+	if(start < 0 || start + num >= IPV6_NXTHOP_ENTRY_NUM)
+		return RTL_EINVALIDINPUT;
+
+	for(idx=start; idx<start+num; idx++)
+	{
+		entry = &rtl865x_ipv6_nxtHopTable[idx];
+
+		if(entry->valid)
+			_rtl8198c_synIpv6NxtHopToAsic(entry);
+	}
+
+	return SUCCESS;
+}
+
+static int32 _rtl8198c_addIpv6NxtHop(uint32 attr, void *ref_ptr, rtl865x_netif_local_t *netif, inv6_addr_t nexthop)
+{
+	int entryIdx;
+	rtl8198c_ipv6_nextHopEntry_t *entry = NULL, *entry1 = NULL;
+	rtl8198c_ipv6_route_t *rt_t = NULL;
+
+	/*
+	  * NOTE:
+	  * parameter description:
+	  * (1) attr: why need to add the nexthop entry? NEXTHOP_L3 or NEXTHOP_DEFREDIRECT_ACL?
+	  * (2) ref_ptr: when attr = NEXTHOP_L3, ref_ptr point to a route structure,
+	  *				   attr = NEXTHOP_DEFREDIRECT_ACL, ref_ptr = NULL,
+	  *				   attr = others, ref_ptr = NULL
+	  * (3) netif: destination network interface
+	  * (4) nexthop:
+	  *		a) netif->if_type == IF_ETHER, nexthop = nexthop ip address,
+	  *		b) netif->if_type == session based type, nexthop = session Id,
+	  *
+	  * following case should be NOTED now:
+	  * (1) ETHERNET type network interface:
+	  *	 a) If nexthop != NULL , it means the entry is added for:
+	  *		nexthop ip&mac information, nextHop = arp entry of nexthop ip address.
+	  *	  b) If nexthop == 0, use default route's nexthop or nexthop TOCPU
+	  *
+	  * (2) PPPoE/PPTP/L2TP type network interface:
+	  *	  The "nexthop" will explicitly specify the PPPoE session (PPTP/L2TP session).
+	  */
+
+	if(netif == NULL)
+		return RTL_EINVALIDINPUT;
+
+	/* Allocate an empty entry for new one */
+	/*Note: all nexthop entry referenced by L3 must be 2 entries aligned(reference l3 Datasheet)*/
+	for (entryIdx = 0; entryIdx < IPV6_NXTHOP_ENTRY_NUM; entryIdx++)
+	{
+		if (rtl865x_ipv6_nxtHopTable[entryIdx].valid == 0) {
+			switch(attr)
+			{
+				case IPV6_NEXTHOP_L3:
+					if ((entryIdx%2==0)&&((entryIdx + 1)<IPV6_NXTHOP_ENTRY_NUM)&&
+					     (rtl865x_ipv6_nxtHopTable[entryIdx+1].valid==0)) {
+						entry = &rtl865x_ipv6_nxtHopTable[entryIdx];
+						goto found;
+					}
+					break;
+
+				case IPV6_NEXTHOP_DEFREDIRECT_ACL:
+					entry = &rtl865x_ipv6_nxtHopTable[entryIdx];
+					goto found;
+					break;
+
+				default:
+					printk("ipv6: attr(%d) is not support.....\n",attr);
+					break;
+			}
+		}
+	}
+
+	/*if not found proper nextHop entry, return*/
+	entry = NULL;
+
+found:
+	if(entry == NULL)
+		return RTL_ENOFREEBUFFER;
+
+	entry->valid = 1;
+	entry->dstNetif = netif;
+	entry->entryIndex = entryIdx;
+	entry->nextHopType = netif->if_type;
+	entry->refCnt = 1;
+	entry->flag = attr;
+
+	switch(netif->if_type)
+	{
+		case IF_ETHER:
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+		case IF_6RD:
+#endif
+#endif
+			memcpy(&entry->un.nexthop, &nexthop, sizeof(inv6_addr_t));
+			break;
+		case IF_PPPOE:
+		case IF_PPTP:
+		case IF_L2TP:
+			/*nexthop is sessionId*/
+			entry->un.pppSessionId = nexthop.v6_addr32[0];
+			break;
+
+	}
+
+	if (attr == IPV6_NEXTHOP_L3) {
+		entry1 = &rtl865x_ipv6_nxtHopTable[entryIdx+1];
+		memcpy(entry1, entry, sizeof(rtl8198c_ipv6_nextHopEntry_t));
+		entry1->entryIndex = entryIdx + 1;
+
+		_rtl8198c_arrangeIpv6NxtHop(entryIdx, 2);
+
+		/*entry1 used netif,update reference netif*/
+		rtl865x_referNetif(netif->name);
+		/*entry1 used pppoe!, update reference pppoe*/
+		if((entry1->nextHopType==IF_PPPOE) || (entry1->nextHopType==IF_PPTP) || (entry1->nextHopType==IF_L2TP)) {
+			#if LINUX_VERSION_CODE > KERNEL_VERSION(3,4,0)
+			_rtl865x_referPpp(nexthop.v6_addr32[0]);
+			#else
+			rtl865x_referPpp(nexthop.v6_addr32[0]);
+			#endif
+		}
+
+		/*FIXME_hyking:lazy, update the route information right here....*/
+		rt_t = (rtl8198c_ipv6_route_t *)ref_ptr;
+		rt_t ->un.nxthop.nxtHopSta = entryIdx;
+		rt_t ->un.nxthop.nxtHopEnd = entryIdx + 1;
+	}
+	else {
+		_rtl8198c_arrangeIpv6NxtHop(entryIdx, 1);
+	}
+
+	/*update reference dstnetif&pppoe arp?*/
+	rtl865x_referNetif(netif->name);
+	if((entry1->nextHopType==IF_PPPOE) || (entry1->nextHopType==IF_PPTP) || (entry1->nextHopType==IF_L2TP)){
+		#if LINUX_VERSION_CODE > KERNEL_VERSION(3,4,0)
+		_rtl865x_referPpp(nexthop.v6_addr32[0]);
+		#else
+		rtl865x_referPpp(nexthop.v6_addr32[0]);
+		#endif
+	}
+
+	return SUCCESS;
+}
+
+static int32 _rtl8198c_delIpv6NxtHop(uint32 attr, uint32 entryIdx)
+{
+	rtl8198c_ipv6_nextHopEntry_t *entry;
+
+	if (entryIdx >= IPV6_NXTHOP_ENTRY_NUM)
+		return RTL_EINVALIDINPUT;
+
+	entry = &rtl865x_ipv6_nxtHopTable[entryIdx];
+
+	if(entry->valid == 0)
+		return RTL_EENTRYNOTFOUND;
+
+	if (entry->refCnt > 1) {
+		printk("%s(%d),refcnt(%d)\n", __FUNCTION__, __LINE__, entry->refCnt);
+		return SUCCESS;
+	}
+
+	if((entry->nextHopType==IF_PPPOE) || (entry->nextHopType==IF_PPTP) || (entry->nextHopType==IF_L2TP)){
+		#if LINUX_VERSION_CODE > KERNEL_VERSION(3,4,0)
+		_rtl865x_deReferPpp(entry->un.pppSessionId);
+		#else
+		rtl865x_deReferPpp(entry->un.pppSessionId);
+		#endif
+	}
+
+	rtl865x_deReferNetif(entry->dstNetif->name);
+	memset(entry, 0, sizeof(rtl8198c_ipv6_nextHopEntry_t));
+
+	/*jwj: Here not call _rtl8198c_arrangeIpv6NxtHop,because nexthop entry
+	is used for default router, and default router's nexthop will always exist.*/
+	/*update asic nextHop table*/
+	//_rtl8198c_arrangeIpv6NxtHop(entryIdx,1);
+
+	return SUCCESS;
+
+}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+int32 _rtl865x_eventHandle_6rd_addArp(rtl865x_arpMapping_entry_t * arp)
+{
+	rtl8198c_ipv6_nextHopEntry_t *entry;
+	int32 i;
+	int32 sixrdIndex=FAILED;
+	rtl865x_6rd_s * sixrdEntry=NULL;
+	if(arp == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	entry = rtl865x_ipv6_nxtHopTable;
+	for(i = 0; i < IPV6_NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		if(entry->valid && entry->nextHopType == IF_6RD)
+		{
+			/*update nexthop*/
+			if(entry->un.nexthop.v6_addr32[0] != 0 ||
+			   entry->un.nexthop.v6_addr32[1] != 0 ||
+			   entry->un.nexthop.v6_addr32[2] != 0 ||
+			   entry->un.nexthop.v6_addr32[3] != 0)
+			{
+				sixrdIndex=_rtl865x_getIpv66RDEntryByName(entry->dstNetif->name);
+				if(sixrdIndex!=FAILED)
+					sixrdEntry=_rtl865x_getIpv66RDEntryByIndex(sixrdIndex);
+
+				if(sixrdEntry)
+				{
+					if(arp->ip == br_ip_addr)
+				    {
+						_rtl8198c_synIpv6NxtHopToAsic(entry);
+					}
+				}
+			}
+		}
+	}
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+int32 _rtl865x_eventHandle_6rd_delArp(rtl865x_arpMapping_entry_t * arp)
+{
+	rtl8198c_ipv6_nextHopEntry_t *entry;
+	int32 i;
+	int32 sixrdIndex=FAILED;
+	rtl865x_6rd_s * sixrdEntry=NULL;
+
+	if(arp == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	entry = rtl865x_ipv6_nxtHopTable;
+	for(i = 0; i < IPV6_NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		if(entry->valid && entry->nextHopType == IF_6RD)
+		{
+			/*update nexthop*/
+			sixrdIndex=_rtl865x_getIpv66RDEntryByName(entry->dstNetif->name);
+			if(sixrdIndex!=FAILED)
+				sixrdEntry=_rtl865x_getIpv66RDEntryByIndex(sixrdIndex);
+
+			if(sixrdEntry)
+			{
+				if(arp->ip == br_ip_addr)
+				{
+					/*reset the gw ipv6 address to reset the default gw L3 nexthop info*/
+					br_ip_addr = 0;
+					_rtl8198c_synIpv6NxtHopToAsic(entry);
+				}
+			}
+		}
+	}
+	return EVENT_CONTINUE_EXECUTE;
+}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+extern int32 _rtl865x_eventHandle_addIpv6Arp(rtl8198c_ipv6_arpMapping_entry_t * arp);
+extern int32 _rtl865x_eventHandle_delIpv6Arp(rtl8198c_ipv6_arpMapping_entry_t * arp);
+#endif
+#endif
+
+static int32 _rtl8198c_eventHandle_addIpv6Arp(void *param)
+{
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	extern int dslite_hw_fw ;
+#endif
+#endif
+
+	int32 i;
+	rtl8198c_ipv6_arpMapping_entry_t *arp;
+	rtl8198c_ipv6_nextHopEntry_t *entry;
+
+	if(param == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	arp = (rtl8198c_ipv6_arpMapping_entry_t *)param;
+	entry = rtl865x_ipv6_nxtHopTable;
+	for (i = 0; i < IPV6_NXTHOP_ENTRY_NUM; i++, entry++)
+	{
+		/*skip ipv6 nexthop update to let ipv6 routing packet trap to cpu!!!!*/
+		#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+		if(!dslite_hw_fw)
+		#endif
+		#endif
+		if (entry->valid && (entry->nextHopType == IF_ETHER)) {
+			/*update nexthop*/
+			if (memcmp(&entry->un.nexthop, &arp->ip, sizeof(inv6_addr_t))==0)
+				_rtl8198c_synIpv6NxtHopToAsic(entry);
+		}
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	/*for dslite tunnel to update nexthop info*/
+	_rtl865x_eventHandle_addIpv6Arp(arp);
+#endif
+#endif
+
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 _rtl8198c_eventHandle_delIpv6Arp(void *param)
+{
+	int32 i;
+	rtl8198c_ipv6_arpMapping_entry_t *arp;
+	rtl8198c_ipv6_nextHopEntry_t *entry;
+
+	if(param == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	arp = (rtl8198c_ipv6_arpMapping_entry_t *)param;
+
+	entry = rtl865x_ipv6_nxtHopTable;
+	for (i = 0; i < IPV6_NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		if (entry->valid && (entry->nextHopType == IF_ETHER)) {
+			/*update nexthop*/
+			if (memcmp(&entry->un.nexthop, &arp->ip, sizeof(inv6_addr_t))==0)
+				_rtl8198c_synIpv6NxtHopToAsic(entry);
+		}
+	}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	/*for dslite tunnel to update nexthop info*/
+	_rtl865x_eventHandle_delIpv6Arp(arp);
+#endif
+#endif
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 _rtl8198c_eventHandle_delIpv6Ppp(void *param)
+{
+	int32 i;
+	rtl865x_ppp_t *pppoe;
+	rtl8198c_ipv6_nextHopEntry_t *entry;
+
+	if(param == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	pppoe = (rtl865x_ppp_t *)param;
+
+	entry = rtl865x_ipv6_nxtHopTable;
+	for (i = 0; i < IPV6_NXTHOP_ENTRY_NUM; i++, entry++)
+	{
+		if((entry->valid) && ((entry->nextHopType == IF_PPPOE) ||
+		    (entry->nextHopType == IF_PPTP)||(entry->nextHopType == IF_L2TP))) {
+				/*update nexthop*/
+				if (entry->un.pppSessionId == pppoe->sessionId) {
+					/*update the action(TOCPU)*/
+					entry->un.pppSessionId  = 0;
+					_rtl8198c_synIpv6NxtHopToAsic(entry);
+				}
+			}
+	}
+
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 _rtl8198c_ipv6_nextHop_register_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId = DEFAULT_IPV6_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_DEL_IPV6_ARP;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = _rtl8198c_eventHandle_delIpv6Arp;
+	rtl865x_registerEvent(&eventParam);
+
+	memset(&eventParam, 0, sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId = DEFAULT_IPV6_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_ADD_IPV6_ARP;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = _rtl8198c_eventHandle_addIpv6Arp;
+	rtl865x_registerEvent(&eventParam);
+
+	memset(&eventParam, 0, sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId = DEFAULT_IPV6_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_DEL_PPP;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = _rtl8198c_eventHandle_delIpv6Ppp;
+	rtl865x_registerEvent(&eventParam);
+
+	return SUCCESS;
+
+}
+
+static int32 _rtl8198c_ipv6_nextHop_unRegister_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId = DEFAULT_IPV6_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_DEL_IPV6_ARP;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = _rtl8198c_eventHandle_delIpv6Arp;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	memset(&eventParam, 0, sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId = DEFAULT_IPV6_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_ADD_IPV6_ARP;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = _rtl8198c_eventHandle_addIpv6Arp;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	memset(&eventParam, 0, sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId = DEFAULT_IPV6_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_DEL_PPP;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = _rtl8198c_eventHandle_delIpv6Ppp;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	return SUCCESS;
+
+}
+
+
+/*
+@func int32 | rtl8198c_addIpv6NxtHop |add a nexthop entry
+@parm uint32 | attr | attribute. IPV6_NEXTHOP_L3/IPV6_NEXTHOP_REDIRECT.
+@parm void* | ref_ptr | entry pointer who refer this nexthop entry.
+@parm rtl865x_netif_local_t* | netif | network interface.
+@parm inv6_addr_t | nexthop | nexthop. ipv6 ip address when linktype is ethernet, session id when linktype is ppp session based.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl8198c_addIpv6NxtHop(uint32 attr, void *ref_ptr, rtl865x_netif_local_t *netif, inv6_addr_t nexthop)
+{
+	int32 ret = FAILED;
+	unsigned long flags=0;
+
+	SMP_LOCK_ETH_HW(flags);
+	ret = _rtl8198c_addIpv6NxtHop(attr, ref_ptr, netif, nexthop);
+	SMP_UNLOCK_ETH_HW(flags);
+
+	return ret;
+}
+
+/*
+@func int32 | rtl8198c_delIpv6NxtHop |delete nexthop entry
+@parm uint32 | attr | attribute. IPV6_NEXTHOP_L3/IPV6_NEXTHOP_REDIRECT.
+@parm uint32 | entryIdx | entry index.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl8198c_delIpv6NxtHop(uint32 attr, uint32 entryIdx)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl8198c_delIpv6NxtHop(attr, entryIdx);
+	SMP_UNLOCK_ETH_HW(flags);
+
+	return retval;
+}
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_nexthopIpv6.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_nexthopIpv6.h
new file mode 100644
index 00000000..6c267a9
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_nexthopIpv6.h
@@ -0,0 +1,44 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2013
+* All rights reserved.
+*
+* Program : ipv6 nexthop table driver
+* Abstract :
+* Author : Jia Wenjian (wenjain_jai@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#ifndef	RTL8198C_NEXTHOP_IPV6_H
+#define	RTL8198C_NEXTHOP_IPV6_H
+
+typedef struct rtl8198c_ipv6_nextHopEntry_s
+{
+	rtl865x_netif_local_t *dstNetif;	/* dst network interface*/
+	union {
+		inv6_addr_t	nexthop;
+		uint32		pppSessionId;
+	} un; 	/* ethernet: nexthop ip address, pppoe: session Id */
+
+	uint16 valid:1,		/* 0: Invalid, 1: Invalid */
+		nextHopType:3,			/* IF_ETHER, IF_PPPOE */
+		flag:3;			/* bit0:referenced by l3, bit2:referenced by acl */
+
+	uint16	refCnt;			/* Reference Count */
+	uint32	entryIndex;			/* Entry Index */
+
+} rtl8198c_ipv6_nextHopEntry_t;
+
+#define IPV6_NEXTHOP_L3					0x01
+#define IPV6_NEXTHOP_DEFREDIRECT_ACL	0x02
+
+#define IPV6_NXTHOP_ENTRY_NUM	32
+
+int32 rtl8198c_initIpv6NxtHopTable(void);
+int32 rtl8198c_reinitIpv6NxtHopTable(void);
+int32 rtl8198c_addIpv6NxtHop(uint32 attr, void *ref_ptr, rtl865x_netif_local_t *netif, inv6_addr_t nexthop);
+int32 rtl8198c_delIpv6NxtHop(uint32 attr, uint32 entryIdx);
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_routeIpv6.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_routeIpv6.c
new file mode 100644
index 00000000..3c78c30
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_routeIpv6.c
@@ -0,0 +1,1228 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2013
+* All rights reserved.
+*
+* Program : ipv6 route table driver
+* Abstract :
+* Author : Jia Wenjian (wenjain_jai@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+/*      @doc RTL_LAYEREDDRV_API
+
+		@module rtl8198c_routeIpv6.c - RTL865x Home gateway controller Layered driver API documentation       |
+		This document explains the API interface of the table driver module. Functions with rtl8198c prefix
+		are external functions.
+		@normal Jia Wenjian (wenjain_jai@realsil.com.cn) <date>
+
+		Copyright <cp>2013 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+		@head3 List of Symbols |
+		Here is a list of all functions and variables in this module.
+
+		@index | RTL_LAYEREDDRV_API
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+//#include <net/rtl/rtl865x_ppp.h>
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl_errno.h"
+//#include "rtl_utils.h"
+#include "common/rtl865x_netif_local.h"
+#include "rtl865x_ppp_local.h"
+#include "rtl8198c_routeIpv6.h"
+//#include "rtl865x_ip.h"
+#include "rtl8198c_nexthopIpv6.h"
+#include "rtl8198c_arpIpv6.h"
+
+//#include "common/rtl_glue.h"
+#include "common/rtl865x_eventMgr.h" /*call back function....*/
+#include "common/rtl865x_vlan.h"
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#endif
+#include "l2Driver/rtl865x_fdb.h"
+#include "AsicDriver/rtl865xc_asicregs.h"
+#include <net/rtl/rtl865x_fdb_api.h>
+#include <net/ipv6.h>
+#include <linux/in6.h>
+#include <net/addrconf.h>
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+static rtl8198c_ipv6_route_t rtl8198c_ipv6_route_inused_back[IPV6_RT_DRV_ENTRY_NUM];
+#endif
+
+static rtl8198c_ipv6_route_t *rtl8198c_ipv6_route_freeHead;
+static rtl8198c_ipv6_route_t *rtl8198c_ipv6_route_inusedHead;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+extern ipaddr_t br_ip_addr;
+extern int32 _rtl865x_addIpv66RDEntryByBR(char *devname);
+extern int32 _rtl865x_getIpv66RDEntryByName(char * devName);
+extern int32 _rtl865x_delIpv66RDEntry(uint32 entryIdx);
+#endif
+#endif
+
+static rtl8198c_ipv6_route_t* _rtl8198c_getDefaultIpv6Route(void)
+{
+	rtl8198c_ipv6_route_t *rt = NULL;
+	rt = rtl8198c_ipv6_route_inusedHead;
+
+	while (rt)
+	{
+		if ((rt->valid == 1) && (rt->asicIdx == (IPV6_RT_ASIC_ENTRY_NUM - 1)))
+			return rt;
+
+		rt = rt->next;
+	}
+
+	return NULL;
+}
+
+void _rtl8198c_ipv6_addr_prefix(inv6_addr_t *pfx, inv6_addr_t *ipAddr, int fc_dst_len)
+{
+	struct in6_addr prefix;
+	inv6_addr_t addr;
+	addr = *ipAddr;
+	hton_inv6_addr(&addr);
+	ipv6_addr_prefix(&prefix, (struct in6_addr *)(&addr), fc_dst_len);
+	*(struct in6_addr *)pfx = prefix;
+	ntoh_inv6_addr(pfx);
+}
+bool _rtl8198c_ipv6_prefix_equal(inv6_addr_t *addr1, inv6_addr_t *addr2, int fc_dst_len)
+{
+	inv6_addr_t tmp1, tmp2;
+	tmp1 = *addr1;
+	tmp2 = *addr2;
+	hton_inv6_addr(&tmp1);
+	hton_inv6_addr(&tmp2);
+	return ipv6_prefix_equal((struct in6_addr *)&tmp1, (struct in6_addr *)&tmp2, fc_dst_len);
+}
+
+static rtl8198c_ipv6_route_t* _rtl8198c_getIpv6RouteEntry(inv6_addr_t ipAddr, int fc_len)
+{
+	rtl8198c_ipv6_route_t *rt = NULL;
+	rt = rtl8198c_ipv6_route_inusedHead;
+
+	while (rt)
+	{
+		if ((rt->valid == 1) && (rt->fc_dst_len == fc_len) &&
+			(_rtl8198c_ipv6_prefix_equal((&rt->ipAddr), (&ipAddr), rt->fc_dst_len)))
+			return rt;
+
+		rt = rt->next;
+	}
+
+	return NULL;
+}
+
+//get globle route count by interface name.
+//For pppoe, only one globle route should be added to hw route table, and add more will fail
+static int32 _rtl8198c_getIpv6GloRouteCountByIfname(char* ifname,int fc_len)
+{
+	rtl8198c_ipv6_route_t *rt = NULL;
+	int32 count=0;
+
+	if(!ifname) return 0;
+	rt = rtl8198c_ipv6_route_inusedHead;
+	//printk("%s:%d ifName=%s count=%d\n",__FUNCTION__,__LINE__,ifname,count);
+
+	while(rt)
+	{
+		if((rt->valid==1)
+			&& (fc_len==0 || rt->fc_dst_len==fc_len)
+			&&((rt->ipAddr.v6_addr32[0]>>16)!=0xfe80 && (rt->ipAddr.v6_addr32[0]>>16)!=0x0)
+			&&(rt->dstNetif->name && (strcmp(rt->dstNetif->name,ifname)==0))
+			)
+			count++;
+
+		rt = rt->next;
+	}
+
+	//printk("%s:%d ifName=%s count=%d\n",__FUNCTION__,__LINE__,ifname,count);
+	return count;
+}
+
+static int32 _rtl8198c_synIpv6RouteToAsic(rtl8198c_ipv6_route_t *rt_t)
+{
+	int32 ret = FAILED;
+	rtl8198C_tblAsicDrv_routingv6Param_t asic_t;
+	rtl865x_tblAsicDrv_l2Param_t asic_l2;
+	rtl865x_netif_local_t *dstNetif = NULL;
+	uint32 columIdx, fid;
+	int32 pppIdx = 0;
+
+	bzero(&asic_t, sizeof(rtl8198C_tblAsicDrv_routingv6Param_t));
+
+	if (rt_t == NULL) {
+		printk("%s(%d):NULL!!!!!!!!!!!!!!!!\n",__FUNCTION__,__LINE__);
+		return FAILED;
+	}
+	/*common information*/
+
+	memcpy(&asic_t.ipAddr, &rt_t->ipAddr, sizeof(inv6_addr_t));
+	asic_t.ipMask = rt_t->fc_dst_len;
+
+	/*if the dstNetif is attach on another interface, the netifIdx should the master interface's index*/
+	if (rt_t->dstNetif->is_slave == 1) {
+		//printk("========%s(%d), ip(0x%x),mask(0x%x),netif(%s)\n",__FUNCTION__,__LINE__,rt_t->ipAddr,rt_t->ipMask,rt_t->dstNetif->name);
+		dstNetif = _rtl865x_getNetifByName(rt_t->dstNetif->name);
+		if (dstNetif == NULL)
+			dstNetif = _rtl865x_getDefaultWanNetif();
+	} else {
+		dstNetif = rt_t->dstNetif;
+	}
+
+	if (dstNetif == NULL) {
+		printk("%s(%d) BUG!!!!!!\n",__FUNCTION__,__LINE__);
+		return FAILED;
+	}
+
+	asic_t.vidx = dstNetif->asicIdx;
+	asic_t.process = rt_t->process;
+
+	switch (rt_t->process)
+	{
+		case IPV6_RT_PPPOE:
+
+			ret = rtl865x_getPppIdx(rt_t->un.pppoe.pppInfo, &pppIdx);
+			asic_t.pppoeIdx = pppIdx;
+			/*
+			*if process==RT_PPPOE, the mac address of pppoe server is add in pppoe module,
+			*so, we read the FDB information directly....
+			*/
+			ret = rtl865x_getVlanFilterDatabaseId(rt_t->dstNetif->vid, &fid);
+			ret = rtl865x_Lookup_fdb_entry(fid, (ether_addr_t *)rt_t->un.pppoe.macInfo, FDB_DYNAMIC, &columIdx, &asic_l2);
+
+			if (ret != SUCCESS)
+				printk("Ipv6 can't get l2 entry by mac.....\n");
+
+			/*update mac/fdb table reference count*/
+			asic_t.nextHopRow = rtl8651_filterDbIndex(rt_t->un.pppoe.macInfo, fid);
+			asic_t.nextHopColumn = columIdx;
+
+			break;
+
+		case IPV6_RT_L2:
+			/*
+			* NOTE:this type not used now...
+			* if we want to use it, please add FDB entry to sure this L2 entry in both software FDB table and Asic L2 table.
+			*/
+			ret = rtl865x_getVlanFilterDatabaseId(rt_t->dstNetif->vid, &fid);
+			ret = rtl865x_Lookup_fdb_entry(fid, (ether_addr_t *)rt_t->un.direct.macInfo, FDB_STATIC, &columIdx,&asic_l2);
+			if(ret != SUCCESS)
+				printk("Ipv6 can't get l2 entry by mac.....\n");
+
+			/*update mac/fdb table reference count*/
+			asic_t.nextHopRow = rtl8651_filterDbIndex(rt_t->un.direct.macInfo, fid);
+			asic_t.nextHopColumn = columIdx;
+
+			break;
+
+		case IPV6_RT_ARP:
+			asic_t.subnet_idx = rt_t->arp.subnetIdx;
+			break;
+
+		case IPV6_RT_CPU:
+		case IPV6_RT_DROP:
+			/*do nothing*/
+			break;
+
+		case IPV6_RT_NEXTHOP:
+	 		asic_t.nhStart		 = rt_t->un.nxthop.nxtHopSta;
+			asic_t.nhNum	 	 = rt_t->un.nxthop.nxtHopEnd - rt_t->un.nxthop.nxtHopSta + 1;
+			asic_t.nhNxt	 	 = asic_t.nhStart;
+			asic_t.nhAlgo	 	 = rt_t->un.nxthop.nhalog;
+			break;
+
+		default:
+			printk("Ipv6 Process_Type(%d) is not support!\n",rt_t->process);
+	}
+
+	if (rt_t->asicIdx > IPV6_RT_ASIC_ENTRY_NUM-1) {
+		printk("BUG!! %s(%d)....", __FUNCTION__,__LINE__);
+		return FAILED;
+	}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+	asic_t.six_rd_eg = rt_t->sixRd_eg;
+	asic_t.six_rd_idx = rt_t->sixRd_idx;
+#endif
+#endif
+
+	ret = rtl8198C_setAsicRoutingv6(rt_t->asicIdx, &asic_t);
+
+	return ret;
+
+}
+
+static int32 _rtl8198c_updateDefaultIpv6Route(rtl8198c_ipv6_route_t *rt, int32 action)
+{
+	int32 i;
+	inv6_addr_t tmp_nexthop;
+	rtl8198c_ipv6_route_t *entry;
+	int32 retval = FAILED;
+
+	entry = rt;
+	if(entry == NULL)
+		return RTL_EINVALIDINPUT;
+
+	/*delete nexthop which is add by default route*/
+	if(rt->process == IPV6_RT_NEXTHOP) {
+		for ( i = entry->un.nxthop.nxtHopSta; i <= entry->un.nxthop.nxtHopEnd && entry->un.nxthop.nxtHopEnd != 0; i++)
+		{
+			retval = rtl8198c_delIpv6NxtHop(IPV6_NEXTHOP_L3, i);
+		}
+	}
+
+	entry->un.nxthop.nxtHopSta = 0;
+	entry->un.nxthop.nxtHopEnd = 0;
+	switch(action)
+	{
+		case IPV6_RT_DEFAULT_RT_NEXTHOP_CPU:
+			memset(&tmp_nexthop, 0, sizeof(inv6_addr_t));
+			retval = rtl8198c_addIpv6NxtHop(IPV6_NEXTHOP_L3, (void*)entry, entry->dstNetif, tmp_nexthop);
+			break;
+
+		case IPV6_RT_DEFAULT_RT_NEXTHOP_NORMAL:
+			{
+				rt->process = IPV6_RT_NEXTHOP;
+				switch(rt->dstNetif->if_type)
+				{
+					case IF_ETHER:
+						retval = rtl8198c_addIpv6NxtHop(IPV6_NEXTHOP_L3, (void*)rt, rt->dstNetif, rt->nextHop);
+						break;
+					case IF_PPPOE:
+						{
+							rtl865x_ppp_t *pppoe;
+							memset(&tmp_nexthop, 0, sizeof(inv6_addr_t));
+
+							pppoe = rtl865x_getPppByNetifName(rt->dstNetif->name);
+							if (pppoe != NULL) {
+								/*got pppoe session*/
+								tmp_nexthop.v6_addr32[0] = pppoe->sessionId;
+								retval = rtl8198c_addIpv6NxtHop(IPV6_NEXTHOP_L3, (void*)rt, rt->dstNetif, tmp_nexthop);
+							} else {
+								/*nexthop's action is to CPU*/
+								retval = rtl8198c_addIpv6NxtHop(IPV6_NEXTHOP_L3, (void*)rt, rt->dstNetif, tmp_nexthop);
+							}
+						}
+
+						break;
+				}
+			}
+			break;
+	}
+
+	retval = _rtl8198c_synIpv6RouteToAsic(entry);
+
+	return retval;
+}
+
+static int32 _rtl8198c_arrangeIpv6Route(rtl8198c_ipv6_route_t *start_rt, int32 start_idx)
+{
+	int32 count;
+	rtl8198c_ipv6_route_t *rt = NULL;
+
+	rt = start_rt;
+	count = 0;
+	while(rt)
+	{
+		if (rt->valid) {
+			/*if the rule is default route...*/
+			if(rt->fc_dst_len == 0) {
+				rt->asicIdx = IPV6_RT_ASIC_ENTRY_NUM-1;
+			} else {
+				/* entry number more than asic table's capacity*/
+				/* entry index=RT_ASIC_ENTRY_NUM-1 is reserved for default route*/
+				if((start_idx + count > IPV6_RT_ASIC_ENTRY_NUM-2))
+					break;
+
+				/*delete old asic entry firstly...*/
+				if(start_idx+count < rt->asicIdx && rt->asicIdx < IPV6_RT_ASIC_ENTRY_NUM-1)
+					rtl8198C_delAsicRoutingv6(rt->asicIdx);
+
+				rt->asicIdx = start_idx+count;
+				/*jwj: arp subnetIdx need to keep the same with rt->asicIdx.*/
+				if (rt->process == IPV6_RT_ARP) {
+					if (rt->arp.subnetIdx != rt->asicIdx) {
+						/*rt->asicIdx change, so its arp->subnetIdx need to change
+						also with the new rt->asicIdx.*/
+						if (rt->arp.subnetIdx != 0xf)	/*The new add router no need call rtl8198c_changeIpv6ArpSubnetIdx*/
+							rtl8198c_changeIpv6ArpSubnetIdx(rt->arp.subnetIdx, rt->asicIdx);
+						rt->arp.subnetIdx = rt->asicIdx;
+					}
+				}
+
+				_rtl8198c_synIpv6RouteToAsic(rt);
+			}
+		}
+
+		/*next entry*/
+		rt= rt->next;
+		count++;
+	}
+
+
+	/*more route entry need to add?*/
+	if (rt) {
+		/*not enough asic table entry! have to update default route's action TOCPU*/
+		rt = _rtl8198c_getDefaultIpv6Route();
+		_rtl8198c_updateDefaultIpv6Route(rt, IPV6_RT_DEFAULT_RT_NEXTHOP_CPU);
+	} else {
+		rt = _rtl8198c_getDefaultIpv6Route();
+		_rtl8198c_updateDefaultIpv6Route(rt, IPV6_RT_DEFAULT_RT_NEXTHOP_NORMAL);
+	}
+
+	return SUCCESS;
+}
+
+static int32 _rtl8198c_addIpv6RouteToInusedList(rtl8198c_ipv6_route_t *rt)
+{
+	int32 retval = FAILED;
+	int32 start_idx = 0;
+	rtl8198c_ipv6_route_t *entry,*fore_rt,*start_rt;
+
+	fore_rt = NULL;
+	entry = rtl8198c_ipv6_route_inusedHead;
+
+	/*always set 0x0f when init..., this value would be reset in arrange route*/
+	rt->asicIdx = 0x0f;
+	rt->next = NULL;
+
+	/*find the right position...*/
+	while(entry)
+	{
+		if (entry->valid == 1) {
+			if (entry->fc_dst_len < rt->fc_dst_len) {
+				break;
+			}
+		}
+		fore_rt = entry;
+		entry = entry->next;
+	}
+
+	/*insert this rule after insert_entry*/
+	if (fore_rt) {
+		rt->next = fore_rt->next;
+		fore_rt->next = rt;
+		start_idx = fore_rt->asicIdx+1;
+		start_rt = rt;
+	} else {
+		/*insert head...*/
+		rt->next = rtl8198c_ipv6_route_inusedHead;
+		rtl8198c_ipv6_route_inusedHead = rt;
+
+		start_idx = 0;
+		start_rt = rtl8198c_ipv6_route_inusedHead;
+	}
+
+	retval = _rtl8198c_arrangeIpv6Route(start_rt, start_idx);
+
+	return retval;
+}
+
+static int32 _rtl8198c_delIpv6RouteFromInusedList(rtl8198c_ipv6_route_t * rt)
+{
+	int32 retval, start_idx;
+	rtl8198c_ipv6_route_t *fore_rt = NULL, *entry = NULL, *start_rt = NULL;
+
+	entry = rtl8198c_ipv6_route_inusedHead;
+	while(entry)
+	{
+		if(entry == rt)
+			break;
+
+		fore_rt = entry;
+		entry = entry->next;
+	}
+
+	/*fore_rt == NULL means delete list head*/
+	if (fore_rt == NULL) {
+		rtl8198c_ipv6_route_inusedHead = rtl8198c_ipv6_route_inusedHead->next;
+		start_rt = rtl8198c_ipv6_route_inusedHead;
+		start_idx = 0;
+	} else {
+		fore_rt->next = rt->next;
+		start_rt = fore_rt->next;
+		start_idx = fore_rt->asicIdx + 1;
+	}
+
+	/*delete route from asic*/
+	if(rt->asicIdx < IPV6_RT_ASIC_ENTRY_NUM)
+		rtl8198C_delAsicRoutingv6(rt->asicIdx);
+
+	retval = _rtl8198c_arrangeIpv6Route(start_rt, start_idx);
+	rt->asicIdx = 0x0f;
+
+	return retval;
+
+}
+
+
+static int32 _rtl8198c_usedNetifInIpv6Route(int8 *ifname)
+{
+	rtl8198c_ipv6_route_t *rt = NULL;
+	rt = rtl8198c_ipv6_route_inusedHead;
+
+	while(rt)
+	{
+		if (memcmp(rt->dstNetif->name, ifname, strlen(ifname)) == 0)
+			return SUCCESS;
+
+		rt = rt->next;
+	}
+
+	return FAILED;
+}
+#if 1
+static int32 _rtl8198c_Ipv6ToCpu(rtl8198c_ipv6_route_t *rt, 	rtl865x_netif_local_t *netif)
+{
+		inv6_addr_t tmp_nexthop;
+		int32 retval = FAILED;
+		/*link local ipv6 route entry always to cpu*/
+		rt->process = IPV6_RT_NEXTHOP;
+		memset(&rt->nextHop, 0, sizeof(inv6_addr_t));
+		memset(&tmp_nexthop, 0, sizeof(inv6_addr_t));
+		retval = rtl8198c_addIpv6NxtHop(IPV6_NEXTHOP_L3, (void*)rt, netif, tmp_nexthop);
+		if (retval != SUCCESS) {
+			return retval;
+		}
+			/*update reference....*/
+		rtl865x_referNetif(netif->name);
+		rt->valid		= 1;
+		rt->ref_count	= 1;
+		retval = _rtl8198c_addIpv6RouteToInusedList(rt);
+
+		if (retval != SUCCESS) {
+			rtl865x_deReferNetif(netif->name);
+		}
+		return retval;
+
+}
+
+#endif
+
+#if 0
+static void print_ipv6_addr(void *addr,int prefix,const char* function,int line)
+{
+	inv6_addr_t ipAddr=*((inv6_addr_t *)addr);
+	printk("%s:%d ipAddr(0x%8x%8x%8x%8x),prefix len(%d)\n",function,line,
+		ipAddr.v6_addr32[0],ipAddr.v6_addr32[1],ipAddr.v6_addr32[2],ipAddr.v6_addr32[3],prefix);
+	return;
+}
+#endif
+static void htonl_array_hwv6(u32 *org_buf, u32 *dst_buf, unsigned int words)
+{
+	int i = 0;
+
+	if (!org_buf || !dst_buf)
+		return;
+	while (words--) {
+		dst_buf[i] = htonl(org_buf[i]);
+		i++;
+	}
+
+	return;
+}
+
+static rtl8198c_ipv6_route_t * _rtl8198c_getNewRouteEntry(inv6_addr_t ipAddr,int fc_dst_len,inv6_addr_t nextHop,rtl865x_netif_local_t *netif)
+{
+	rtl8198c_ipv6_route_t *rt=NULL;
+	/*allocate a new buffer for adding entry*/
+	rt = rtl8198c_ipv6_route_freeHead;
+
+	if (rt) {
+		rtl8198c_ipv6_route_freeHead = rt->next;
+	}else{
+		return NULL;
+	}
+
+	/*common information*/
+	_rtl8198c_ipv6_addr_prefix((&rt->ipAddr), (&ipAddr), fc_dst_len);
+	rt->fc_dst_len = fc_dst_len;
+	memcpy(&rt->nextHop, &nextHop, sizeof(inv6_addr_t));
+	rt->dstNetif 	= netif;
+
+	return rt;
+
+}
+static int32 _rtl8198c_addIpv6Route(inv6_addr_t ipAddr, int fc_dst_len, inv6_addr_t nextHop, int8 * ifName)
+{
+	inv6_addr_t tmp_nexthop;
+	rtl865x_netif_local_t *netif = NULL;
+	rtl8198c_ipv6_route_t *rt = NULL;
+	int32 retval = FAILED;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+	int32 sixrdIndex = FAILED;
+#endif
+#endif
+
+	/*para check*/
+	if (ifName == NULL)
+		netif = _rtl865x_getDefaultWanNetif();
+	else
+		netif = _rtl865x_getSWNetifByName(ifName);
+
+	if (netif == NULL)
+		return RTL_EINVALIDINPUT;
+
+	if (netif->if_type == IF_NONE)
+		return RTL_ENOLLTYPESPECIFY;
+#if 0
+	printk("%s.%d.ipAddr(0x%8x%8x%8x%8x),fc_dst_len(%d)nextHop(0x%8x%8x%8x%8x),ifName(%s)\n",
+		__FUNCTION__,__LINE__,
+		ipAddr.v6_addr32[0],ipAddr.v6_addr32[1],ipAddr.v6_addr32[2],ipAddr.v6_addr32[3],
+		fc_dst_len,
+		nextHop.v6_addr32[0],nextHop.v6_addr32[1],nextHop.v6_addr32[2],nextHop.v6_addr32[3],
+		ifName);
+#endif
+
+	/*All linklocal to DUT trap to cpu with prefix len = 10
+	  *reduce HW routing entry usage
+	  */
+	if ((ipAddr.v6_addr32[0] >> 16) == 0xFE80 )
+	{
+		if (fc_dst_len > 10)
+			fc_dst_len = 10;
+	}
+
+	/*
+	*duplicate entry check:
+	*	in Driver system, default route is always exist.
+	*	so if ipMask == 0, it's means that default route should be update...
+	*/
+	if (fc_dst_len != 0 && (rt = _rtl8198c_getIpv6RouteEntry(ipAddr, fc_dst_len)) != NULL) {
+		//rt->ref_count++;
+		return RTL_EENTRYALREADYEXIST;
+	}
+
+	/*add default route: just update the default route becase the default route always exist!*/
+#ifdef CONFIG_RTL_IPV6READYLOGO
+	if ((fc_dst_len==0) || !((nextHop.v6_addr32[0]==0)&&(nextHop.v6_addr32[1]==0)&&(nextHop.v6_addr32[2]==0)&&(nextHop.v6_addr32[3]==0)))
+#else
+	if (fc_dst_len==0)
+#endif
+	{
+		rt = _rtl8198c_getDefaultIpv6Route();
+		/*deference rt's orginal netif*/
+		if (rt && rt->dstNetif)
+			rtl865x_deReferNetif(rt->dstNetif->name);
+
+		/*init rt*/
+		if (rt && rt->dstNetif) {
+			_rtl8198c_ipv6_addr_prefix((&rt->ipAddr), (&ipAddr), fc_dst_len);
+			rt->fc_dst_len = fc_dst_len;
+			memcpy(&rt->nextHop, &nextHop, sizeof(inv6_addr_t));
+			rt->dstNetif = netif;
+		}
+	}
+
+	/*allocate a new buffer for adding entry*/
+	if (rt == NULL) {
+		rt=_rtl8198c_getNewRouteEntry(ipAddr,fc_dst_len,nextHop,netif);
+	}
+
+	if (rt == NULL) {
+		/*no buffer, default route should be TOCPU?*/
+		return RTL_ENOFREEBUFFER;
+	}
+
+
+
+#if 1
+	if((ipAddr.v6_addr32[0]>>16)==0xFE80 )
+	{
+	//	printk("%s:%d ifName=%s ipAddr.v6_addr16[0]=%x\n",__FUNCTION__,__LINE__,ifName,(ipAddr.v6_addr32[0]>>16));
+
+		retval=_rtl8198c_Ipv6ToCpu(rt,netif);
+		if (retval != SUCCESS) {
+			goto addFailed;
+		}
+		return retval;
+	}
+
+	//when pppoe add its ipv6 route to cpu
+
+	if(ifName && (strncmp(ifName,"ppp",3)==0)   //ppp0
+		&&((ipAddr.v6_addr32[0]>>16)!=0x0 && (ipAddr.v6_addr32[0]>>16)!=0xFE80)) //global ip
+		{
+			struct net_device *dev = NULL;
+			struct inet6_dev *idev;
+			struct inet6_ifaddr *ifa;
+			struct in6_addr ifaAddr;
+
+
+
+
+			dev = __dev_get_by_name(&init_net, ifName);
+			idev= __in6_dev_get(dev);
+			//printk("%s:%d ifName=%s\n",__FUNCTION__,__LINE__,ifName);
+
+			if (idev != NULL) {
+				list_for_each_entry(ifa, &idev->addr_list, if_list) {
+
+					htonl_array_hwv6((u32 *)&ifa->addr.s6_addr32[0], (u32 *)&ifaAddr.s6_addr32[0], 4);
+					//print_ipv6_addr(&ifaAddr,ifa->prefix_len,__FUNCTION__,__LINE__);
+					if(ipv6_prefix_equal(&ifaAddr,(struct in6_addr *)&rt->ipAddr,rt->fc_dst_len)){
+						rtl8198c_ipv6_route_t *rt_pppGlo=NULL;
+						rt_pppGlo = _rtl8198c_getNewRouteEntry(*((inv6_addr_t*)(&ifaAddr)),128,nextHop,netif);
+						if (rt_pppGlo == NULL) {
+							/*no buffer, default route should be TOCPU?*/
+							return RTL_ENOFREEBUFFER;
+						}
+						//print_ipv6_addr(&rt_pppGlo->ipAddr,rt_pppGlo->fc_dst_len,__FUNCTION__,__LINE__);
+
+						if(_rtl8198c_getIpv6GloRouteCountByIfname(ifName,128)!=0){
+							goto addFailed;
+						}
+						//printk("%s:%d ifName=%s\n",__FUNCTION__,__LINE__,ifName);
+
+						retval=_rtl8198c_Ipv6ToCpu(rt_pppGlo,netif);
+						if (retval != SUCCESS) {
+							goto addFailed;
+						}
+					}
+
+					//printk("%s:%d ifName=%s\n",__FUNCTION__,__LINE__,ifName);
+				}
+
+				//printk("%s:%d ifName=%s\n",__FUNCTION__,__LINE__,ifName);
+			}
+		}
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+		if(((ipAddr.v6_addr32[0]==0) && (ipAddr.v6_addr32[1]==0) &&
+			(ipAddr.v6_addr32[2]==0) && (ipAddr.v6_addr32[3]==0))
+			 &&
+			((nextHop.v6_addr32[0]!=0) || (nextHop.v6_addr32[1]!=0) ||
+			 (nextHop.v6_addr32[2]!=0) || (nextHop.v6_addr32[3]!=0))
+		)
+		{
+			extern inv6_addr_t gw_ipv6_addr;
+			memcpy(&gw_ipv6_addr,&nextHop,sizeof(inv6_addr_t));
+		}
+#endif
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+	if(netif->if_type == IF_6RD)
+	{
+		if(((ipAddr.v6_addr32[0]==0) && (ipAddr.v6_addr32[1]==0) &&
+			(ipAddr.v6_addr32[2]==0) && (ipAddr.v6_addr32[3]==0))
+			&&
+			((nextHop.v6_addr32[0]==0) && (nextHop.v6_addr32[1]==0) &&
+			(nextHop.v6_addr32[2]==0) && (nextHop.v6_addr32[3]!=0))
+			)
+		{
+			br_ip_addr = nextHop.v6_addr32[3];
+			_rtl865x_addIpv66RDEntryByBR(ifName);
+		}
+	}
+#endif
+#endif
+
+	/*don't specify the nexthop ip address, it's means that:
+	* all packet match this route entry should be forward by network interface with arp
+	*/
+
+	if (((nextHop.v6_addr32[0]==0)&&(nextHop.v6_addr32[1]==0)&&(nextHop.v6_addr32[2]==0)&&(nextHop.v6_addr32[3]==0)) && (fc_dst_len != 0)) {
+
+		switch(netif->if_type)
+		{
+			case IF_ETHER:
+				//printk("%s,%d.add arp info to asic ...........\n",__FUNCTION__,__LINE__);
+				rt->process = IPV6_RT_ARP;
+				/*rt->arp.subnetIdx will be updated as rt->asicIdx later in _rtl865x_arrangeRoute*/
+				break;
+
+			case IF_PPPOE:
+				{
+					rtl865x_ppp_t *ppp = NULL;
+
+					rt->process = IPV6_RT_PPPOE;
+					ppp = rtl865x_getPppByNetifName(netif->name);
+
+					if (ppp == NULL) {
+						printk("Ipv6 error!!can't get pppoe session information by interface name(%s)\n",netif->name);
+						goto addFailed;
+					}
+
+					rt->un.pppoe.macInfo = &ppp->server_mac;
+					rt->un.pppoe.pppInfo = ppp;
+
+					/*update reference...*/
+					rtl865x_referPpp(ppp->sessionId);
+				}
+				break;
+			case IF_PPTP:
+			case IF_L2TP:
+				{
+					rtl865x_ppp_t *ppp = NULL;
+
+					rt->process = IPV6_RT_L2;
+					ppp = rtl865x_getPppByNetifName(netif->name);
+
+					if (ppp == NULL) {
+						/*printk("Warning!!CAn't get pptp/l2tp session information by interface name(%s)\n",netif->name);*/
+						goto addFailed;
+					}
+
+					rt->un.direct.macInfo = &ppp->server_mac;
+				}
+				break;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+			case IF_6RD:
+				//do nothing
+				return SUCCESS;
+#endif
+#endif
+			default:
+				printk("Ipv6 lltype(%d) is not support now....\n", netif->if_type);
+				goto addFailed;
+		}
+
+	}
+	else {
+		/*if default is valid, delete nexthop firstly...*/
+		if ((rt->valid==1) && (rt->process==IPV6_RT_NEXTHOP))  {
+						int i;
+						for ( i = rt->un.nxthop.nxtHopSta; i <= rt->un.nxthop.nxtHopEnd; i++)
+						{
+								retval = rtl8198c_delIpv6NxtHop(IPV6_NEXTHOP_L3, i);
+						}
+			  }
+
+#ifdef CONFIG_RTL_IPV6READYLOGO
+		if (strncmp(netif->name, RTL_DRV_LAN_NETIF_NAME, sizeof(RTL_DRV_LAN_NETIF_NAME))==0)
+		{
+			rt->process = IPV6_RT_NEXTHOP;
+			memset(&rt->nextHop, 0, sizeof(inv6_addr_t));
+			 _rtl8198c_updateDefaultIpv6Route(rt, IPV6_RT_DEFAULT_RT_NEXTHOP_CPU);
+		}
+		else
+#endif
+		{
+
+		/*use nexthop type*/
+		rt->process = IPV6_RT_NEXTHOP;
+		//for restore nexthop table, when hw l3v6 cleared.
+		memcpy(&rt->nextHop, &nextHop, sizeof(inv6_addr_t));
+		switch(netif->if_type)
+		{
+			case IF_ETHER:
+				retval = rtl8198c_addIpv6NxtHop(IPV6_NEXTHOP_L3, (void*)rt, netif, nextHop);
+				break;
+			case IF_PPPOE:
+			case IF_PPTP:
+			case IF_L2TP:
+				{
+					rtl865x_ppp_t *pppoe;
+					memset(&tmp_nexthop, 0, sizeof(inv6_addr_t));
+
+					pppoe = rtl865x_getPppByNetifName(netif->name);
+
+					if (pppoe != NULL) {
+						/*got pppoe session*/
+						tmp_nexthop.v6_addr32[0] = pppoe->sessionId;
+						retval = rtl8198c_addIpv6NxtHop(IPV6_NEXTHOP_L3, (void*)rt, netif, tmp_nexthop);
+					}
+					else {
+						/*nexthop's action is to CPU*/
+						retval = rtl8198c_addIpv6NxtHop(IPV6_NEXTHOP_L3, (void*)rt, netif, tmp_nexthop);
+					}
+				}
+				break;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+			case IF_6RD:
+				retval = rtl8198c_addIpv6NxtHop(IPV6_NEXTHOP_L3, (void*)rt, netif, nextHop);
+				break;
+#endif
+#endif
+
+			default:
+				retval = FAILED;
+				break;
+		}
+
+		if (retval != SUCCESS) {
+			printk("error!!add ipv6 nexthop error! retval (%d)\n",retval);
+			goto addFailed;
+		}
+		rt->un.nxthop.nhalog = IPV6_RT_ALOG_SIP; /* use per-source IP */
+	}
+	}
+
+	rt->valid		= 1;
+	rt->ref_count	= 1;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+	if(netif->if_type == IF_6RD)
+	{
+		sixrdIndex=_rtl865x_getIpv66RDEntryByName(netif->name);
+
+		/*hook default gw for 6rd interface */
+		if(((ipAddr.v6_addr32[0]==0) && (ipAddr.v6_addr32[1]==0) &&
+			(ipAddr.v6_addr32[2]==0) && (ipAddr.v6_addr32[3]==0))
+			&& fc_dst_len == 0 &&
+			((nextHop.v6_addr32[0]==0) && (nextHop.v6_addr32[1]==0) &&
+			(nextHop.v6_addr32[2]==0) && (nextHop.v6_addr32[3]!=0)))
+		{
+			if(sixrdIndex == FAILED)
+			{
+				rt->sixRd_eg = 0;
+				rt->sixRd_idx = 0;
+			}
+			else
+			{
+				rt->sixRd_eg	= 1;
+				rt->sixRd_idx 	= sixrdIndex;
+			}
+		}
+	}
+#endif
+#endif
+
+	/*update reference....*/
+	rtl865x_referNetif(netif->name);
+	if (fc_dst_len == 0)
+		_rtl865x_setDefaultWanNetif(netif->name);
+
+	if (rt->asicIdx == IPV6_RT_ASIC_ENTRY_NUM-1) {
+		retval = _rtl8198c_synIpv6RouteToAsic(rt);
+	}
+	else {
+		/*insert the adding route to inused list*/
+		retval = _rtl8198c_addIpv6RouteToInusedList(rt);
+	}
+
+	/*if route is add, please enable Routing for the releated netif*/
+	retval = rtl865x_enableNetifRoutingV6(netif);
+	return retval;
+
+addFailed:
+	if (rt->asicIdx == IPV6_RT_ASIC_ENTRY_NUM -1) {
+#ifdef CONFIG_RTL_IPV6READYLOGO
+		rt->process = IPV6_RT_NEXTHOP;
+#endif
+		_rtl8198c_updateDefaultIpv6Route(rt, IPV6_RT_DEFAULT_RT_NEXTHOP_CPU);
+	}
+	else {
+		/*free this route entry and return error code...*/
+		memset(rt, 0, sizeof(rtl8198c_ipv6_route_t));
+		rt->arp.subnetIdx = 0xf;
+		rt->next = rtl8198c_ipv6_route_freeHead;
+		rtl8198c_ipv6_route_freeHead = rt;
+	}
+	return retval;
+}
+
+static int32 _rtl8198c_delIpv6Route(inv6_addr_t ipAddr, int fc_dst_len )
+{
+	rtl8198c_ipv6_route_t *entry;
+	int32 i;
+	int32 retval = 0;
+
+	entry = _rtl8198c_getIpv6RouteEntry(ipAddr, fc_dst_len);
+
+	if (entry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+	if (entry->asicIdx == (IPV6_RT_ASIC_ENTRY_NUM-1)) {
+		/*if default route
+		* 1. reset default route
+		* 2. reset entry->netif...
+		*/
+		rtl865x_netif_local_t *netif = NULL;
+		_rtl865x_clearDefaultWanNetif(entry->dstNetif->name);
+
+		netif = _rtl865x_getDefaultWanNetif();
+		if (netif == NULL) {
+			return RTL_EINVNETIFNAME;
+		}
+
+		if (netif != entry->dstNetif) {
+			rtl865x_deReferNetif(entry->dstNetif->name);
+			entry->dstNetif = netif;
+			rtl865x_referNetif(netif->name);
+		}
+
+		retval = _rtl8198c_updateDefaultIpv6Route(entry, IPV6_RT_DEFAULT_RT_NEXTHOP_CPU);
+	} else {
+		/*not default route*/
+		switch(entry->process)
+		{
+			case IPV6_RT_PPPOE:
+				{
+					rtl865x_ppp_t *ppp = entry->un.pppoe.pppInfo;
+					if (ppp)
+						rtl865x_deReferPpp(ppp->sessionId);
+				}
+				break;
+			case IPV6_RT_L2:
+				/*
+				* NOTE:this type not used now...
+				* if we want to use it, please DELETE FDB entry to sure this L2 entry is deleted both software FDB table and Asic L2 table.
+				*/
+				break;
+			case IPV6_RT_ARP:
+				/*free arp*/
+				retval = rtl8198c_delIpv6ArpBySubnetIdx(entry->arp.subnetIdx);
+				if ( retval != SUCCESS) {
+					printk("======Ipv6 error!!can't FREE arp entry for this route entry....retval(%d)\n",retval);
+				}
+				break;
+
+			case IPV6_RT_CPU:
+			case IPV6_RT_DROP:
+				/*do nothing*/
+
+				break;
+
+			case IPV6_RT_NEXTHOP:
+				/*delete nexthop which is add by l3*/
+				for ( i = entry->un.nxthop.nxtHopSta; i <= entry->un.nxthop.nxtHopEnd; i++)
+				{
+					retval = rtl8198c_delIpv6NxtHop(IPV6_NEXTHOP_L3, i);
+				}
+				break;
+		}
+
+		/*update netif reference count*/
+		rtl865x_deReferNetif(entry->dstNetif->name);
+
+		/*remove from inused list...*/
+		_rtl8198c_delIpv6RouteFromInusedList(entry);
+
+		if(_rtl8198c_usedNetifInIpv6Route(entry->dstNetif->name) == FAILED)
+			rtl865x_disableNetifRoutingV6(entry->dstNetif);
+
+		/*add to free list*/
+		memset(entry, 0, sizeof(rtl8198c_ipv6_route_t));
+		entry->arp.subnetIdx = 0xf;
+		entry->next = rtl8198c_ipv6_route_freeHead;
+		rtl8198c_ipv6_route_freeHead = entry;
+
+		retval = SUCCESS;
+	}
+
+	return retval;
+
+}
+
+rtl8198c_ipv6_route_t* _rtl8198c_getIpv6RouteEntryByIp(inv6_addr_t dst)
+{
+	rtl8198c_ipv6_route_t *tmpRtEntry = NULL;
+	rtl8198c_ipv6_route_t *rt=rtl8198c_ipv6_route_inusedHead;
+	int fc_len;
+
+	fc_len = 0;
+	while(rt)
+	{
+		if (rt->valid == 1 &&
+			(_rtl8198c_ipv6_prefix_equal((&rt->ipAddr), (&dst), rt->fc_dst_len)) &&
+			fc_len <= rt->fc_dst_len) {
+			fc_len = rt->fc_dst_len;
+			tmpRtEntry = rt;
+		}
+		rt = rt->next;
+	}
+	return tmpRtEntry;
+}
+
+/*
+@func int32 | rtl8198c_addIpv6Route |add a route entry.
+@parm inv6_addr_t | ipAddr | ip address.
+@parm int | fc_dst_len | ip prefix len.
+@parm inv6_addr_t | nextHop | the route's next hop.
+@parm int8* | ifName | destination network interface.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@rvalue RTL_EINVALIDINPUT | invalid input.
+@rvalue RTL_ENOLLTYPESPECIFY | network interface's link type is not specified.
+@rvalue RTL_EENTRYALREADYEXIST | route entry is already exist.
+@rvalue RTL_ENOFREEBUFFER | not enough memory in system.
+@comm
+	if ifName=NULL, it means the destionation network interface of route entry with ip/ipMask/nextHop is default wan.
+*/
+int32 rtl8198c_addIpv6Route(inv6_addr_t ipAddr, int fc_dst_len, inv6_addr_t nextHop, int8 * ifName)
+{
+	int32 retval = 0;
+	unsigned long flags=0;
+	//printk("========%s(%d), ip(0x%x%x%x%x),fc_dst_len(%d),ifname(%s),nxthop(0x%x)\n",__FUNCTION__,__LINE__,
+		//ipAddr.s6_addr32[0], ipAddr.s6_addr32[1],ipAddr.s6_addr32[2],ipAddr.s6_addr32[3],fc_dst_len,ifName,nextHop);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl8198c_addIpv6Route(ipAddr,fc_dst_len,nextHop,ifName);
+	SMP_UNLOCK_ETH(flags);
+	//printk("========%s(%d), ip(0x%x%x%x%x),fc_dst_len(%d),ifname(%s),nxthop(0x%x),retval(%d)\n",__FUNCTION__,__LINE__,
+		//ipAddr.s6_addr32[0], ipAddr.s6_addr32[1],ipAddr.s6_addr32[2],ipAddr.s6_addr32[3],,fc_dst_len,ifName,nextHop,retval);
+	return retval;
+}
+/*
+@func int32 | rtl8198c_delIpv6Route |delete a route entry.
+@parm inv6_addr_t | ipAddr | ipAddress.
+@parm int | fc_dst_len | ip prefix len.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@rvalue RTL_EENTRYNOTFOUND | not found the entry.
+@comm
+*/
+int32 rtl8198c_delIpv6Route(inv6_addr_t ipAddr, int fc_dst_len)
+{
+
+	int32 retval = 0;
+	unsigned long flags=0;
+	//printk("========%s(%d), ip(0x%x%x%x%x),fc_dst_len(%d)\n",__FUNCTION__,__LINE__,ipAddr.s6_addr32[0],
+		//ipAddr.s6_addr32[1],ipAddr.s6_addr32[2],ipAddr.s6_addr32[3],fc_dst_len);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl8198c_delIpv6Route(ipAddr,fc_dst_len);
+	SMP_UNLOCK_ETH(flags);
+	//printk("==================================retval(%d)\n",retval);
+	return retval;
+
+}
+
+/*
+@func int32 | rtl8198c_getIpv6RouteEntryByIp |according the destination ip address, get the matched route entry.
+@parm inv6_addr_t | dst | destionation ip address.
+@parm rtl8198c_ipv6_route_t* | rt | retrun value: route entry pointer
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl8198c_getIpv6RouteEntryByIp(inv6_addr_t dst, rtl8198c_ipv6_route_t *rt)
+{
+	int32 retval = FAILED;
+	rtl8198c_ipv6_route_t *ret_entry = NULL;
+
+	ret_entry = _rtl8198c_getIpv6RouteEntryByIp(dst);
+	if (ret_entry&&rt) {
+		memcpy(rt,ret_entry,sizeof(rtl8198c_ipv6_route_t));
+		retval = SUCCESS;
+	}
+
+	return retval;
+}
+
+/*
+@func int32 | rtl198c_initIpv6RouteTable |initialize route tabel.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl8198c_initIpv6RouteTable(void)
+{
+	int32 i;
+	rtl8198c_ipv6_route_t *rt;
+	rtl8198c_ipv6_route_freeHead = NULL;
+	rtl8198c_ipv6_route_inusedHead = NULL;
+
+	/*malloc buffer*/
+	TBL_MEM_ALLOC(rt, rtl8198c_ipv6_route_t, IPV6_RT_DRV_ENTRY_NUM);
+	memset(rt, 0, sizeof(rtl8198c_ipv6_route_t)*IPV6_RT_DRV_ENTRY_NUM);
+	for(i = 0; i < IPV6_RT_DRV_ENTRY_NUM; i++)
+	{
+		rt[i].arp.subnetIdx = 0xf;
+		rt[i].next = rtl8198c_ipv6_route_freeHead;
+		rtl8198c_ipv6_route_freeHead = &rt[i];
+	}
+
+	#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+	memset((void *)&rtl8198c_ipv6_route_inused_back, 0, sizeof(rtl8198c_ipv6_route_inused_back));
+	#endif
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl198c_reinitIpv6RouteTable |reinitialize route tabel.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl8198c_reinitIpv6RouteTable(void)
+{
+	rtl8198c_ipv6_route_t *rt;
+
+	rt = rtl8198c_ipv6_route_inusedHead;
+	while(rt && rt->asicIdx != IPV6_RT_ASIC_ENTRY_NUM -1)
+	{
+		_rtl8198c_delIpv6Route(rt->ipAddr,rt->fc_dst_len);
+		rt = rtl8198c_ipv6_route_inusedHead;
+	}
+
+	/*delete the last route*/
+	rt = rtl8198c_ipv6_route_inusedHead;
+	if(rt)
+	{
+		/*update netif reference count*/
+		rtl865x_deReferNetif(rt->dstNetif->name);
+
+		/*remove from inused list...*/
+		_rtl8198c_delIpv6RouteFromInusedList(rt);
+
+		/*add to free list*/
+		memset(rt, 0, sizeof(rtl8198c_ipv6_route_t));
+		rt->arp.subnetIdx = 0xf;
+		rt->next = rtl8198c_ipv6_route_freeHead;
+		rtl8198c_ipv6_route_freeHead = rt;
+	}
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+int rtl819x_save_inused_ipv6_route(void)
+{
+	int i = 0;
+	rtl8198c_ipv6_route_t *rt = rtl8198c_ipv6_route_inusedHead;
+
+	memset(rtl8198c_ipv6_route_inused_back, 0, sizeof(rtl8198c_ipv6_route_t)*IPV6_RT_DRV_ENTRY_NUM);
+	while(rt)
+	{
+		if (rt->valid == 1) {
+			memcpy(&rtl8198c_ipv6_route_inused_back[i], rt, sizeof(rtl8198c_ipv6_route_t));
+			i++;
+			if (i >= IPV6_RT_DRV_ENTRY_NUM)
+				break;
+		}
+		rt = rt->next;
+	}
+
+	return SUCCESS;
+}
+
+int rtl819x_restore_inused_ipv6_route(void)
+{
+	int i = 0;
+	int ret = 0;
+	rtl8198c_ipv6_route_t *rt = NULL;
+
+	for (i=0; i<IPV6_RT_DRV_ENTRY_NUM; i++)
+	{
+		if (rtl8198c_ipv6_route_inused_back[i].valid == 1) {
+			rt = &rtl8198c_ipv6_route_inused_back[i];
+			ret = rtl8198c_addIpv6Route(rt->ipAddr, rt->fc_dst_len, rt->nextHop, rt->dstNetif->name);
+			#if 0
+			panic_printk("%s %d ret=%d ip=0x%x:%x:%x:%x rt->fc_dst_len=%d nexthop=0x%x:%x:%x:%x rt->dstNetif->name=%s \n", __FUNCTION__, __LINE__, ret, rt->ipAddr.v6_addr32[0],
+				rt->ipAddr.v6_addr32[1], rt->ipAddr.v6_addr32[2], rt->ipAddr.v6_addr32[3], rt->fc_dst_len,
+				rt->nextHop.v6_addr32[0], rt->nextHop.v6_addr32[1], rt->nextHop.v6_addr32[2], rt->nextHop.v6_addr32[3], rt->dstNetif->name);
+			#endif
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_routeIpv6.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_routeIpv6.h
new file mode 100644
index 00000000..82bc57c
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl8198c_routeIpv6.h
@@ -0,0 +1,103 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2013
+* All rights reserved.
+*
+* Program : ipv6 route table driver
+* Abstract :
+* Author : Jia Wenjian (wenjain_jai@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#ifndef	RTL198C_ROUTE_IPV6_H
+#define	RTL198C_ROUTE_IPV6_H
+#include <net/rtl/rtl8198c_route_ipv6_api.h>
+
+typedef struct rtl198c_ipv6_route_s
+{
+	struct rtl198c_ipv6_route_s *next;
+	inv6_addr_t 	ipAddr;						/* Destination IP Address */
+	//ipaddr_t	ipMask;						/* Network mask */
+	int fc_dst_len;								/*prefix len*/
+	inv6_addr_t 	nextHop;					/* next hop IP address */
+	//ipaddr_t	srcIp;						/* source IP address,only for multiple wan now*/
+	uint32	valid:1,
+			process:4,					/* 000: PPPoE, 001: L2, 010: ARP, 100: CPU, 101: NextHop, 110: Drop*/
+			asicIdx:4;
+
+	uint32            ref_count;                       /*referrence count*/
+	rtl865x_netif_local_t *dstNetif;			/*destination network interface*/
+
+	struct
+	{
+		uint32 subnetIdx;
+	} arp;
+
+	/* nexthop informaiton */
+	union {
+		struct
+		{
+			void *macInfo;	/*direct nexthop's mac information*/
+		}direct;
+
+		struct
+		{
+			void *macInfo; /*pppoe server's mac information*/
+			rtl865x_ppp_t *pppInfo;
+		}pppoe;
+
+		struct
+		{
+
+			uint32 nxtHopSta;	/* pointer to Nexthop table: starting range */
+			uint32 nxtHopEnd;		/* pointer to Nexthop table: ending range */
+			uint8 nhalog;							/* algo. for load balance */
+			//uint8 ipDomain;						/* IP domain */
+		} nxthop;
+
+	} un;
+
+	uint32 sixRd_eg;
+ 	uint32 sixRd_idx;
+} rtl8198c_ipv6_route_t;
+#define IPV6_RT_DEFAULT_RT_NEXTHOP_CPU 		0x00
+#define IPV6_RT_DEFAULT_RT_NEXTHOP_NORMAL 	0x01
+
+/* process: */
+#define IPV6_RT_PPPOE				0x00
+#define IPV6_RT_L2					0x01
+#define IPV6_RT_ARP					0x02
+#define IPV6_RT_CPU					0x04
+#define IPV6_RT_NEXTHOP				0x05
+#define IPV6_RT_DROP					0x06
+
+/* nhalog: */
+#define IPV6_RT_ALOG_PACKET			0x00
+#define IPV6_RT_ALOG_SESSION		0x01
+#define IPV6_RT_ALOG_SIP				0x02
+
+int32 rtl8198c_initIpv6RouteTable(void);
+int32 rtl8198c_reinitIpv6RouteTable(void);
+int32 rtl8198c_getIpv6RouteEntryByIp(inv6_addr_t dst, rtl8198c_ipv6_route_t *rt);
+
+static inline void hton_inv6_addr(inv6_addr_t *ipAddr)
+{
+	ipAddr->v6_addr32[0] = htonl(ipAddr->v6_addr32[0]);
+	ipAddr->v6_addr32[1] = htonl(ipAddr->v6_addr32[1]);
+	ipAddr->v6_addr32[2] = htonl(ipAddr->v6_addr32[2]);
+	ipAddr->v6_addr32[3] = htonl(ipAddr->v6_addr32[3]);
+}
+
+static inline void ntoh_inv6_addr(inv6_addr_t *ipAddr)
+{
+	ipAddr->v6_addr32[0] = ntohl(ipAddr->v6_addr32[0]);
+	ipAddr->v6_addr32[1] = ntohl(ipAddr->v6_addr32[1]);
+	ipAddr->v6_addr32[2] = ntohl(ipAddr->v6_addr32[2]);
+	ipAddr->v6_addr32[3] = ntohl(ipAddr->v6_addr32[3]);
+}
+
+#endif
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_6rd.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_6rd.c
new file mode 100644
index 00000000..0ebd8ab
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_6rd.c
@@ -0,0 +1,396 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2014
+* All rights reserved.
+*
+* Program : 6rd table driver
+* Abstract :
+* Author : hualai_gu
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+/*      @doc RTL_LAYEREDDRV_API
+
+		Copyright <cp>2014 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+*/
+
+#include <linux/netdevice.h>
+
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include <net/rtl/rtl865x_netif.h>
+#include <net/ip_tunnels.h>
+#include "common/rtl_errno.h"
+#include "common/rtl865x_netif_local.h"
+#include "rtl865x_ip.h"
+#include "rtl865x_nexthop.h"
+#include "rtl865x_ppp_local.h"
+#include "rtl865x_route.h"
+#include "rtl865x_arp.h"
+
+#include "common/rtl865x_vlan.h"
+#include "common/rtl865x_eventMgr.h" /*call back function....*/
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#endif
+#include "l2Driver/rtl865x_fdb.h"
+#include <net/rtl/rtl865x_fdb_api.h>
+#include <linux/version.h>
+
+#if defined(CONFIG_RTL_8198C) ||defined(CONFIG_RTL_8197F)
+#include "rtl8198c_arpIpv6.h"
+#include "rtl8198c_nexthopIpv6.h"
+#endif
+
+#include "rtl865x_6rd.h"
+
+static int32 _rtl865x_updateIpv66RDEntry(rtl865x_6rd_s *tunnel_param, int entryIdx);
+static int32 _rtl865x_updateIpv66RDEntryByBR(int entryIdx);
+
+/*ipv6 6rd*/
+#define IPV6_6RD_TABLE_INDEX(entry)	(entry - rtl865x_ipv6_6RDTable)
+#define IPV6_6RD_ENTRY_NUM	8
+
+static rtl865x_6rd_s *rtl865x_ipv6_6RDTable = NULL;
+ipaddr_t br_ip_addr;
+
+int32 rtl8198c_initIpv66RDTable(void)
+{
+	TBL_MEM_ALLOC(rtl865x_ipv6_6RDTable, rtl865x_6rd_s, IPV6_6RD_ENTRY_NUM);
+	memset(rtl865x_ipv6_6RDTable,0,sizeof(rtl865x_6rd_s)*IPV6_6RD_ENTRY_NUM);
+	br_ip_addr = 0;
+	return SUCCESS;
+}
+
+int32 rtl8198c_reinitIpv66RDTable(void)
+{
+	int32 i;
+
+	for(i = 0; i < IPV6_6RD_ENTRY_NUM; i++)
+	{
+		if(rtl865x_ipv6_6RDTable[i].valid)
+			_rtl865x_delIpv66RDEntry(i);
+	}
+	br_ip_addr = 0;
+
+	return SUCCESS;
+}
+
+rtl865x_6rd_s * rtl865x_get6RDEntry(void)
+{
+	int32 entryIdx;
+	rtl865x_6rd_s *entry = NULL;
+
+	for (entryIdx = 0; entryIdx < IPV6_6RD_ENTRY_NUM; entryIdx++)
+	{
+		entry=&rtl865x_ipv6_6RDTable[entryIdx];
+		if(entry)
+		{
+			if (entry->valid == 1)
+			{
+				return entry;
+			}
+		}
+	}
+	return NULL;
+}
+
+rtl865x_6rd_s * _rtl865x_getIpv66RDEntryByIndex(int32 entryIdx)
+{
+	rtl865x_6rd_s *entry = NULL;
+
+	entry=&rtl865x_ipv6_6RDTable[entryIdx];
+	if(entry)
+	{
+		if (entry->valid == 1)
+		{
+			return entry;
+		}
+	}
+
+	return NULL;
+}
+
+int32 _rtl865x_getIpv66RDEntryByName(char * devName)
+{
+	int32 entryIdx;
+	rtl865x_6rd_s *entry = NULL;
+	int32 ret=FAILED;
+	int32 retVal=FAILED;
+	rtl8198C_tblAsicDrv_6rdParam_t sixrd_entry;
+	rtl8198C_tblAsicDrv_6rdParam_t *asic_entry =&sixrd_entry;
+
+	if(devName==NULL)
+		goto out;
+
+	for (entryIdx = 0; entryIdx < IPV6_6RD_ENTRY_NUM; entryIdx++)
+	{
+		entry=&rtl865x_ipv6_6RDTable[entryIdx];
+		if(entry)
+		{
+			if ((entry->valid == 1)
+				&& (strcmp(devName,entry->name)==0)
+				)
+			{
+				goto found;
+			}
+		}
+	}
+	entry =NULL;
+
+	if(entry ==NULL)
+		goto out;
+
+found:
+	ret=rtl8198C_getAsic6rdTable(entryIdx, asic_entry);
+	//printk("%s %d: found! entryIdx: %d, ret: %d, valid: %d\n", __FUNCTION__, __LINE__, entryIdx, ret, entry->valid);
+	if(ret == SUCCESS)
+		retVal = entryIdx;
+
+out:
+	return retVal;
+}
+
+int32 _rtl865x_getIpv66RDEntrybyIndex(uint32 entryIdx,rtl865x_6rd_s *entry)
+{
+	int32 ret=FAILED;
+	entry=&rtl865x_ipv6_6RDTable[entryIdx];
+
+	if (entry->valid == 1 )
+	{
+		ret =SUCCESS;
+	}
+
+	return ret;
+}
+
+static int32 _rtl865x_synIpv66RDToAsic(rtl865x_6rd_s *entry_t)
+{
+	rtl8198C_tblAsicDrv_6rdParam_t asic_entry;
+	uint32 index;
+	int ret = FAILED;
+	if(entry_t == NULL)
+		return FAILED;
+
+	asic_entry.ce_ip_addr					= entry_t->ce_ip_addr;
+	asic_entry.ce_ip_mask_len				= entry_t->ce_ip_mask_len;
+	asic_entry.six_rd_prefix.v6_addr32[0]	= entry_t->six_rd_prefix.v6_addr32[0];
+	asic_entry.six_rd_prefix.v6_addr32[1]	= entry_t->six_rd_prefix.v6_addr32[1];
+	asic_entry.six_rd_prefix.v6_addr32[2]	= entry_t->six_rd_prefix.v6_addr32[2];
+	asic_entry.six_rd_prefix.v6_addr32[3]	= entry_t->six_rd_prefix.v6_addr32[3];
+	asic_entry.six_rd_prefix_len			= entry_t->six_rd_prefix_len;
+	asic_entry.br_ip_addr					= entry_t->br_ip_addr;
+	asic_entry.br_ip_mask_len				= entry_t->br_ip_mask_len;
+	asic_entry.mtu							= entry_t->mtu;
+	asic_entry.valid						= entry_t->valid;
+	index									= entry_t->index;
+
+	ret = rtl8198C_setAsic6rdTable(index, &asic_entry);
+	return ret;
+}
+
+static void _rtl865x_tunnelTo6RDparam(struct ip_tunnel *t, rtl865x_6rd_s *tunnel_param)
+{
+	tunnel_param->ce_ip_addr					= htonl(t->parms.iph.saddr);
+	tunnel_param->ce_ip_mask_len				= 0;
+	tunnel_param->six_rd_prefix.v6_addr32[0]	= htonl(t->ip6rd.prefix.s6_addr32[0]);
+	tunnel_param->six_rd_prefix.v6_addr32[1]	= htonl(t->ip6rd.prefix.s6_addr32[1]);
+	tunnel_param->six_rd_prefix.v6_addr32[2]	= htonl(t->ip6rd.prefix.s6_addr32[2]);
+	tunnel_param->six_rd_prefix.v6_addr32[3]	= htonl(t->ip6rd.prefix.s6_addr32[3]);
+	tunnel_param->six_rd_prefix_len				= t->ip6rd.prefixlen;
+	tunnel_param->mtu							= t->dev->mtu;
+	tunnel_param->br_ip_mask_len				= 24;
+	memcpy(tunnel_param->name, t->dev->name, MAX_IFNAMESIZE);
+}
+
+int32 _rtl865x_addIpv66RDEntry(struct ip_tunnel *t)
+{
+	int retVal;
+	int entryIdx=FAILED;
+	rtl865x_6rd_s param;
+	rtl865x_6rd_s *entry = NULL, *tunnel_param = &param;
+
+	//entry = _rtl865x_getIpv6DsLiteEntry(host_ipv6_addr,host_ipv6_mask,aftr_ipv6_addr,aftr_ipv6_mask,devName);
+	memset(tunnel_param, 0, sizeof(rtl865x_6rd_s));
+	_rtl865x_tunnelTo6RDparam(t, tunnel_param);
+	entryIdx = _rtl865x_getIpv66RDEntryByName(tunnel_param->name);
+	if(entryIdx!=FAILED)
+	{
+		_rtl865x_updateIpv66RDEntry(tunnel_param, entryIdx);
+		entry = &rtl865x_ipv6_6RDTable[entryIdx];
+		goto sync;
+	}
+	else
+	{
+		/* Allocate an empty entry for new one */
+		/*
+				pppoe ----> index 0
+				direct ---> index 1
+				nexthop ---> index 2
+				arp ------> index 3
+		*/
+		//now test just for direct ,so use index 1 to use.
+		//for (entryIdx = 0; entryIdx < IPV6_6RD_ENTRY_NUM; entryIdx++)
+		//for (entryIdx = 1; entryIdx < IPV6_6RD_ENTRY_NUM; entryIdx++)
+		for (entryIdx = 2; entryIdx < IPV6_6RD_ENTRY_NUM; entryIdx++)
+		{
+			if (rtl865x_ipv6_6RDTable[entryIdx].valid == 0) {
+				entry = &rtl865x_ipv6_6RDTable[entryIdx];
+				goto found;
+				break;
+			}
+		}
+	}
+
+	/*if not found proper nextHop entry, return*/
+	entry = NULL;
+
+found:
+	if(entry == NULL)
+		return RTL_ENOFREEBUFFER;
+
+	/*common information*/
+	memcpy(entry, tunnel_param, sizeof(rtl865x_6rd_s));
+	entry->valid = 1;
+	entry->index = entryIdx;
+
+sync:
+	retVal = _rtl865x_synIpv66RDToAsic(entry);
+#if 0
+	printk("[%s]:[%d].retVal:%d, index:%d, ce: %x/%d, 6rd prefix: %x-%x-%x-%x/%d, br: %x/%d, if: %s, mtu: %d\n",
+		__FUNCTION__,__LINE__,retVal, entryIdx, entry->ce_ip_addr, entry->ce_ip_mask_len,
+		entry->six_rd_prefix.v6_addr32[0], entry->six_rd_prefix.v6_addr32[1],
+		entry->six_rd_prefix.v6_addr32[2], entry->six_rd_prefix.v6_addr32[3],
+		entry->six_rd_prefix_len, entry->br_ip_addr, entry->br_ip_mask_len,
+		entry->name, entry->mtu);
+#endif
+	return retVal;
+}
+
+int32 _rtl865x_addIpv66RDEntryByBR(char *devname)
+{
+	int retVal;
+	int entryIdx=FAILED;
+	rtl865x_6rd_s *entry = NULL;
+
+	entryIdx = _rtl865x_getIpv66RDEntryByName(devname);
+	if(entryIdx!=FAILED)
+	{
+		_rtl865x_updateIpv66RDEntryByBR(entryIdx);
+		entry = &rtl865x_ipv6_6RDTable[entryIdx];
+		goto sync;
+	}
+	else
+	{
+		/* Allocate an empty entry for new one */
+		/*
+				pppoe ----> index 0
+				direct ---> index 1
+				nexthop ---> index 2
+				arp ------> index 3
+		*/
+		//now test just for direct ,so use index 1 to use.
+		//for (entryIdx = 0; entryIdx < IPV6_6RD_ENTRY_NUM; entryIdx++)
+		//for (entryIdx = 1; entryIdx < IPV6_6RD_ENTRY_NUM; entryIdx++)
+		for (entryIdx = 2; entryIdx < IPV6_6RD_ENTRY_NUM; entryIdx++)
+		{
+			if (rtl865x_ipv6_6RDTable[entryIdx].valid == 0) {
+				entry = &rtl865x_ipv6_6RDTable[entryIdx];
+				goto found;
+				break;
+			}
+		}
+	}
+
+	/*if not found proper nextHop entry, return*/
+	entry = NULL;
+
+found:
+	if(entry == NULL)
+		return RTL_ENOFREEBUFFER;
+
+	/*common information*/
+	memcpy(entry->name, devname, MAX_IFNAMESIZE);
+	entry->br_ip_addr = br_ip_addr;
+	entry->br_ip_mask_len = 24;
+	entry->valid = 1;
+	entry->index = entryIdx;
+
+sync:
+	retVal = _rtl865x_synIpv66RDToAsic(entry);
+#if 0
+	printk("[%s]:[%d].retVal:%d, index: %d, ce: %x/%d, 6rd prefix: %x-%x-%x-%x/%d, br: %x/%d, if: %s, mtu: %d\n",
+		__FUNCTION__,__LINE__,retVal, entryIdx, entry->ce_ip_addr, entry->ce_ip_mask_len,
+		entry->six_rd_prefix.v6_addr32[0], entry->six_rd_prefix.v6_addr32[1],
+		entry->six_rd_prefix.v6_addr32[2], entry->six_rd_prefix.v6_addr32[3],
+		entry->six_rd_prefix_len, entry->br_ip_addr, entry->br_ip_mask_len,
+		entry->name, entry->mtu);
+#endif
+	return retVal;
+}
+
+static int32 _rtl865x_updateIpv66RDEntry(rtl865x_6rd_s *tunnel_param, int entryIdx)
+{
+	rtl865x_6rd_s *entry = NULL;
+
+	if(tunnel_param == NULL)
+		return FAILED;
+
+	if(entryIdx < 0 || entryIdx >= IPV6_6RD_ENTRY_NUM)
+		return FAILED;
+
+	entry = &rtl865x_ipv6_6RDTable[entryIdx];
+
+	if(tunnel_param->ce_ip_addr != 0)
+		entry->ce_ip_addr = tunnel_param->ce_ip_addr;
+	if(tunnel_param->ce_ip_mask_len != 0)
+		entry->ce_ip_mask_len = tunnel_param->ce_ip_mask_len;
+	if(tunnel_param->six_rd_prefix.v6_addr32[0] != 0 ||
+		tunnel_param->six_rd_prefix.v6_addr32[1] != 0 ||
+		tunnel_param->six_rd_prefix.v6_addr32[2] != 0 ||
+		tunnel_param->six_rd_prefix.v6_addr32[3] != 0)
+	{
+		entry->six_rd_prefix.v6_addr32[0] = tunnel_param->six_rd_prefix.v6_addr32[0];
+		entry->six_rd_prefix.v6_addr32[1] = tunnel_param->six_rd_prefix.v6_addr32[1];
+		entry->six_rd_prefix.v6_addr32[2] = tunnel_param->six_rd_prefix.v6_addr32[2];
+		entry->six_rd_prefix.v6_addr32[3] = tunnel_param->six_rd_prefix.v6_addr32[3];
+	}
+	if(tunnel_param->six_rd_prefix_len != 0)
+		entry->six_rd_prefix_len = tunnel_param->six_rd_prefix_len;
+	if(tunnel_param->br_ip_addr != 0)
+		entry->br_ip_addr = tunnel_param->br_ip_addr;
+	if(tunnel_param->br_ip_mask_len != 0)
+		entry->br_ip_mask_len = tunnel_param->br_ip_mask_len;
+	if(tunnel_param->mtu != 0)
+		entry->mtu = tunnel_param->mtu;
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_updateIpv66RDEntryByBR(int entryIdx)
+{
+	rtl865x_6rd_s *entry = NULL;
+
+	if(entryIdx < 0 || entryIdx >= IPV6_6RD_ENTRY_NUM)
+		return FAILED;
+
+	entry = &rtl865x_ipv6_6RDTable[entryIdx];
+
+	entry->br_ip_addr = br_ip_addr;
+	entry->br_ip_mask_len = 24;
+
+	return SUCCESS;
+}
+
+int32 _rtl865x_delIpv66RDEntry(uint32 entryIdx)
+{
+	return 0;
+}
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_6rd.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_6rd.h
new file mode 100644
index 00000000..b48058c
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_6rd.h
@@ -0,0 +1,36 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL865X_6RD_H
+#define RTL865X_6RD_H
+
+typedef struct rtl865x_6rd_s {
+	ipaddr_t    ce_ip_addr;
+	uint8       ce_ip_mask_len;/*LSB*/
+	inv6_addr_t six_rd_prefix;
+	uint8       six_rd_prefix_len;
+	ipaddr_t    br_ip_addr;
+	uint8       br_ip_mask_len;/*MSB*/
+	uint16      mtu;
+	uint8       valid;
+	char 	name[MAX_IFNAMESIZE];
+	uint8	index;
+} rtl865x_6rd_s;
+
+int32 rtl8198c_initIpv66RDTable(void);
+int32 rtl8198c_reinitIpv66RDTable(void);
+rtl865x_6rd_s * rtl865x_get6RDEntry(void);
+rtl865x_6rd_s * _rtl865x_getIpv66RDEntryByIndex(int32 entryIdx);
+int32 _rtl865x_getIpv66RDEntryByName(char * devName);
+int32 _rtl865x_getIpv66RDEntrybyIndex(uint32 entryIdx,rtl865x_6rd_s *entry);
+int32 _rtl865x_addIpv6DsLiteEntry(struct ip_tunnel *t);
+int32 _rtl865x_addIpv66RDEntryByBR(char *devname);
+int32 _rtl865x_delIpv66RDEntry(uint32 entryIdx);
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_arp.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_arp.c
new file mode 100644
index 00000000..afb71a1
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_arp.c
@@ -0,0 +1,991 @@
+
+/*      @doc RTL_LAYEREDDRV_API
+
+		@module rtl865x_arp.c - RTL865x Home gateway controller Layered driver API documentation       |
+		This document explains the API interface of the table driver module. Functions with rtl865x prefix
+		are external functions.
+		@normal Hyking Liu (Hyking_liu@realsil.com.cn) <date>
+
+		Copyright <cp>2008 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+		@head3 List of Symbols |
+		Here is a list of all functions and variables in this module.
+
+		@index | RTL_LAYEREDDRV_API
+
+		This program is free software; you can redistribute it and/or modify
+		it under the terms of the GNU General Public License as published by
+		the Free Software Foundation; either version 2 of the License, or
+		(at your option) any later version.
+*/
+
+#include <net/rtl/rtl_types.h>
+#include "common/rtl_errno.h"
+
+#include "common/mbuf.h"
+//#include "assert.h"
+
+//#include "rtl865xc_swNic.h"
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "rtl865xC_tblAsicDrv.h"
+#include "common/rtl8651_aclLocal.h"
+#endif
+
+#include "AsicDriver/rtl865x_hwPatch.h"		/* define for chip related spec */
+
+#include "common/rtl865x_eventMgr.h"
+
+#include "common/rtl865x_vlan.h"
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl865x_netif_local.h"
+
+#include "l2Driver/rtl865x_fdb.h"
+
+#include "rtl865x_ppp_local.h"
+#include "rtl865x_route.h"
+#include "rtl865x_arp.h"
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+#include <net/rtl/rtl865x_multipleWan_api.h>
+#include "rtl865x_multipleWan.h"
+#include "rtl865x_nexthop.h"
+#endif
+#include <net/rtl/rtl865x_fdb_api.h>
+
+static int32 rtl865x_arp_hash(ipaddr_t ip, uint32 *index);
+
+static int32 rtl865x_arp_callbackFn_for_del_fdb(void *param);
+static int32 rtl865x_arp_register_event(void);
+
+static struct rtl865x_arp_table arpTables;
+#if defined(CONFIG_RTL_HARDWARE_NAT) //&&defined(REINIT_SWITCH_CORE)
+static struct rtl865x_arp_table arpTables_bak;
+#endif
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+static int32 rtl865x_arp_callbackFn_for_add_fdb(void *param);
+static struct rtl865x_arp_table arpTables_all;
+extern int  extPortEnabled;
+#endif
+#if defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+static int (*rtl_callback_for_ps_arp)(ipaddr_t ip,rtl865x_arpMapping_entry_t *arp);
+#endif
+
+static int32 rtl865x_arp_callbackFn_for_del_fdb(void *param)
+{
+	int i;
+	rtl865x_filterDbTableEntry_t  *fdbEntry;
+
+	if(param==NULL)
+	{
+		return EVENT_CONTINUE_EXECUTE;
+	}
+
+	fdbEntry=(rtl865x_filterDbTableEntry_t *)param;
+
+	for(i=0;i<RTL8651_ARPTBL_SIZE;i++)
+	{
+		/*be careful of dead loop, the delete fdb event maybe caused by arp time out*/
+		if(memcmp(&(fdbEntry->macAddr),&(arpTables.mappings[i].mac), 6)==0)
+		{
+			rtl865x_delArp(arpTables.mappings[i].ip);
+		}
+
+	}
+
+	return EVENT_CONTINUE_EXECUTE;
+
+}
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+static int32 rtl865x_arp_callbackFn_for_add_fdb(void *param)
+{
+	int i;
+	rtl865x_filterDbTableEntry_t  *fdbEntry;
+
+	if (param == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+	if(extPortEnabled==0)
+		return EVENT_CONTINUE_EXECUTE;
+
+	fdbEntry=(rtl865x_filterDbTableEntry_t *)param;
+
+	for (i=0;i<RTL8651_ARPTBL_SIZE;i++)
+	{
+		/*be careful of dead loop, the delete fdb event maybe caused by arp time out*/
+		if (memcmp(&(fdbEntry->macAddr), &(arpTables.mappings[i].mac), 6) == 0) {
+			return EVENT_CONTINUE_EXECUTE;
+		}
+	}
+#if 1
+	for (i=0;i<RTL8651_ARPTBL_SIZE;i++)
+	{
+		/*be careful of dead loop, the delete fdb event maybe caused by arp time out*/
+		if (memcmp(&(fdbEntry->macAddr),&(arpTables_all.mappings[i].mac), 6) == 0){
+			#if 0
+			printk("%s[%d], ip is 0x%x, mac is 0x%2x%2x%2x%2x%2x%2x\n", __FUNCTION__, __LINE__,
+				arpTables_all.mappings[i].ip, arpTables_all.mappings[i].mac.octet[0],  arpTables_all.mappings[i].mac.octet[1],
+				 arpTables_all.mappings[i].mac.octet[2],  arpTables_all.mappings[i].mac.octet[3],  arpTables_all.mappings[i].mac.octet[4],
+				  arpTables_all.mappings[i].mac.octet[5]);
+			#endif
+			rtl865x_addArp(arpTables_all.mappings[i].ip, &(arpTables_all.mappings[i].mac));
+		}
+	}
+#endif
+	return EVENT_CONTINUE_EXECUTE;
+
+
+}
+
+#endif
+
+
+static int32 rtl865x_arp_unRegister_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_FDB;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_arp_callbackFn_for_del_fdb;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	memset(&eventParam, 0, sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_ADD_FDB;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_arp_callbackFn_for_add_fdb;
+	rtl865x_unRegisterEvent(&eventParam);
+	#endif
+
+	return SUCCESS;
+
+}
+static int32 rtl865x_arp_register_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_FDB;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_arp_callbackFn_for_del_fdb;
+	rtl865x_registerEvent(&eventParam);
+
+	#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	memset(&eventParam, 0, sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_ADD_FDB;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_arp_callbackFn_for_add_fdb;
+	rtl865x_registerEvent(&eventParam);
+	#endif
+
+	return SUCCESS;
+
+}
+
+
+int32 rtl865x_arp_init(void)
+{
+	int i;
+	rtl865x_arp_unRegister_event();
+	memset(arpTables.allocBitmap, 0, 64);
+	memset(arpTables.mappings, 0, RTL8651_ARPTBL_SIZE * sizeof(rtl865x_arpMapping_entry_t));
+	for(i=0; i<RTL8651_ARPTBL_SIZE; i++)
+	{
+		rtl8651_delAsicArp(i);
+	}
+	rtl865x_arp_register_event();
+	#if defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+	rtl_callback_for_ps_arp = NULL;
+	#endif
+	#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	memset(arpTables_all.allocBitmap, 0, 64);
+	memset(arpTables_all.mappings, 0, RTL8651_ARPTBL_SIZE * sizeof(rtl865x_arpMapping_entry_t));
+	#endif
+	return SUCCESS;
+}
+
+int32 rtl865x_arp_reinit(void)
+{
+	return rtl865x_arp_init();
+}
+
+int32 rtl865x_arp_tbl_alloc(rtl865x_route_t *route)
+{
+	uint32 netSize, entry, bestSize=0, bestStartPos=0xffffffff;
+	uint32 curSize, curStartPos;
+
+	if(route==NULL)
+	{
+		return FAILED;
+	}
+
+	/* process definition(000: PPPoE, 001: L2, 010: ARP, 100: CPU, 101: NextHop, 110: Drop)*/
+	if((route->process!=2))
+	{
+		return FAILED;
+	}
+
+	for(entry=0; entry<32; entry++)
+	{
+		if((route->ipMask) & (1<<entry))
+			break;
+	}
+
+	if ((netSize = (1<<entry)) > 1)
+	{
+		curStartPos = bestSize = curSize = 0;
+		for(entry = 0; entry <= 64; entry++)
+		{
+			if((entry == 64) || arpTables.allocBitmap[entry])
+			{
+				if(curSize > bestSize)
+				{
+					bestStartPos = curStartPos;
+					bestSize = curSize;
+				}
+				curStartPos = entry+1;
+				curSize = 0;
+			} else curSize++;
+		}
+	}
+
+	if (netSize>1 && ((bestSize<<3) >= netSize))
+	{
+		route->un.arp.arpsta= bestStartPos<<3;
+		route->un.arp.arpend = (bestStartPos + (netSize>>3) - ((netSize&0x7)==0? 1: 0))<<3;
+		for(entry=route->un.arp.arpsta>>3; entry<=route->un.arp.arpend>>3; entry++)
+		{
+			arpTables.allocBitmap[entry] = 1;
+		}
+		return SUCCESS;
+	}
+	return FAILED;
+
+}
+
+int32 rtl865x_arp_tbl_free(rtl865x_route_t *route)
+{
+	rtl865x_vlan_entry_t *vlan;
+	uint32 index;
+	int32 i, j;
+
+	if(route==NULL)
+	{
+		return FAILED;
+	}
+	if((route->valid!=1) || (route->process!=2) || (route->dstNetif==NULL) )
+	{
+		return FAILED;
+	}
+
+	for(i=route->un.arp.arpsta>>3; i<=route->un.arp.arpend>>3; i++)
+	{
+		arpTables.allocBitmap[i] = 0;
+		for(j=0; j<8; j++)
+		{
+			index = (i<<3)+j;
+			if(arpTables.mappings[index].ip!=0)
+			{
+				rtl8651_delAsicArp(index);
+				vlan = _rtl8651_getVlanTableEntry(route->dstNetif->vid);
+				rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEII, vlan->fid, &(arpTables.mappings[index].mac));
+				memset(&(arpTables.mappings[index]),0,sizeof(rtl865x_arpMapping_entry_t));
+			}
+			else
+			{
+				memset(&(arpTables.mappings[index]),0,sizeof(rtl865x_arpMapping_entry_t));
+			}
+		}
+	}
+
+	return SUCCESS;
+}
+
+static int32 rtl865x_arp_hash(ipaddr_t ip, uint32 *index)
+{
+	rtl865x_route_t rt_entry,*route;
+	uint32 arpIndex;
+	int32 retval = FAILED;
+
+	route = &rt_entry;
+	memset(route,0,sizeof(rtl865x_route_t));
+	retval =rtl865x_getRouteEntry(ip, route);
+
+	if (retval != SUCCESS)
+		return retval;
+	if((route->valid!=1) || (route->process!=2) ||(route->dstNetif==NULL))
+	{
+		return FAILED;
+	}
+
+	arpIndex=((route->un.arp.arpsta)+( (ip) & ~(route->ipMask)));
+	if(arpIndex>=RTL8651_ARPTBL_SIZE)
+	{
+		return FAILED;
+	}
+	*index=arpIndex;
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+int32 rtl8198c_6rd_Ipv6ArpMapping(ipaddr_t ip, rtl865x_arpMapping_entry_t * arp_mapping)
+{
+	int i;
+	rtl865x_arpMapping_entry_t * arpEntry=NULL;
+
+	if (arp_mapping == NULL)
+	{
+		printk("%s,%d. arp_mapping NULL\n",__FUNCTION__,__LINE__);
+		return FAILED;
+	}
+	memset(arp_mapping, 0, sizeof(rtl865x_arpMapping_entry_t));
+
+	for(i=0;i<512;i++)
+	{
+		arpEntry = &arpTables.mappings[i];
+
+		if(arpEntry->ip == ip)
+		{
+			memcpy(&(arp_mapping->mac),&(arpEntry->mac),6);
+			//printk("%s,%d. get mac success ******************\n",__FUNCTION__,__LINE__);
+			return SUCCESS;
+		}
+	}
+	return FAILED;
+}
+#endif
+#endif
+
+
+int32 rtl865x_getArpMapping(ipaddr_t ip, rtl865x_arpMapping_entry_t * arp_mapping)
+{
+
+	rtl865x_route_t *route,rt_entry;
+	uint32 hash;
+	int32 retval = FAILED;
+
+	if(arp_mapping==NULL)
+	{
+		return FAILED;
+	}
+	memset(arp_mapping, 0, sizeof(rtl865x_arpMapping_entry_t));
+	route= &rt_entry;
+	memset(route,0,sizeof(rtl865x_route_t));
+	retval=rtl865x_getRouteEntry(ip,route);
+
+	if(retval != SUCCESS)
+		return retval;
+
+
+	if((route->valid!=1) || (route->process!=2) ||(route->dstNetif==NULL))
+	{
+		return FAILED;
+	}
+
+	if(rtl865x_arp_hash(ip,&hash)==FAILED)
+	{
+		return FAILED;
+	}
+
+	if(arpTables.mappings[hash].ip==ip)
+	{
+		memcpy(arp_mapping,&(arpTables.mappings[hash]),sizeof(rtl865x_arpMapping_entry_t));
+	}
+	else
+		return FAILED;
+
+	return SUCCESS;
+}
+
+
+int32 rtl865x_getAsicArpEntry(ipaddr_t ip,rtl865x_tblAsicDrv_arpParam_t *asicArpEntry)
+{
+
+	rtl865x_route_t *route,rt_entry;
+	uint32 hash;
+	int32 retval;
+
+	if(asicArpEntry==NULL)
+	{
+		return FAILED;
+	}
+
+	route = &rt_entry;
+	memset(route,0,sizeof(rtl865x_route_t));
+	memset(asicArpEntry, 0, sizeof(rtl865x_tblAsicDrv_arpParam_t));
+
+	retval = rtl865x_getRouteEntry(ip,route);
+	if(retval != SUCCESS)
+		return retval;
+
+	if((route==NULL)||(route->valid!=1) || (route->process!=2) ||(route->dstNetif==NULL))
+	{
+		return FAILED;
+	}
+
+	if(rtl865x_arp_hash(ip,&hash)==FAILED)
+	{
+		return FAILED;
+	}
+
+	rtl8651_getAsicArp(hash, asicArpEntry);
+
+	return SUCCESS;
+
+}
+
+int32 rtl865x_mapIpToMac(ipaddr_t ip,ether_addr_t * mac)
+{
+	uint32 hash;
+
+	if(mac==NULL)
+	{
+		return FAILED;
+	}
+
+	memset(mac, 0, sizeof(ether_addr_t));
+
+	if(rtl865x_arp_hash(ip, &hash)!=SUCCESS)
+	{
+		return FAILED;
+	}
+
+	if(arpTables.mappings[hash].ip==ip)
+	{
+		memcpy(mac,&(arpTables.mappings[hash].mac),sizeof(ether_addr_t));
+		return SUCCESS;
+	}
+
+	return FAILED;
+}
+
+static int32 rtl865x_getArpFid(ipaddr_t ip, uint16 *fid)
+{
+	rtl865x_route_t *route,rt_entry;
+	rtl865x_vlan_entry_t *vlan;
+	int32 retval = FAILED;
+
+
+	if(ip==0)
+	{
+		return FAILED;
+	}
+
+	route = &rt_entry;
+	memset(route,0,sizeof(rtl865x_route_t));
+	retval = rtl865x_getRouteEntry(ip,route);
+	if(retval != SUCCESS)
+		return retval;
+
+	if((route->valid!=1) || (route->process!=2) ||(route->dstNetif==NULL))
+	{
+		return FAILED;
+	}
+
+
+	vlan = _rtl8651_getVlanTableEntry(route->dstNetif->vid);
+	*fid = vlan->fid;
+	return SUCCESS;
+}
+
+#if 1//#if defined(CONFIG_RTL_AVOID_ADDING_WLAN_PKT_TO_HW_NAT)
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+int32 rtl865x_isArpExisted(ipaddr_t ip)
+{
+	uint32 hash;
+
+	if(rtl865x_arp_hash(ip, &hash)!=SUCCESS)
+	{
+		return FALSE;
+	}
+
+	if(arpTables.mappings[hash].ip!=ip)
+	{
+		return FALSE;
+	}
+
+	return TRUE;
+}
+
+#endif
+
+
+#if 0//defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+
+int32 rtl865x_isEthArp(ipaddr_t ip)
+{
+	uint32 hash;
+	int i;
+	//memset(mac, 0, sizeof(ether_addr_t));
+	uint32 fdb_type[]={ FDB_STATIC, FDB_DYNAMIC };
+	uint16 fid = 0;
+	uint32 column;
+	rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+
+	if(rtl865x_arp_hash(ip, &hash)!=SUCCESS)
+	{
+		return FALSE;
+	}
+
+	if(arpTables.mappings[hash].ip!=ip)
+	{
+		return FALSE;
+	}
+
+	if(rtl865x_getArpFid(arpTables.mappings[hash].ip, &fid)!=SUCCESS)
+	{
+		return FALSE;
+	}
+
+
+	for(i=0; i<2; i++)
+	{
+
+		if(rtl865x_Lookup_fdb_entry(fid, &(arpTables.mappings[hash].mac), fdb_type[i], &column,&fdbEntry) != SUCCESS)
+		{
+			continue;
+		}
+
+		if(rtl865x_isEthPortMask(fdbEntry.memberPortMask )==TRUE)
+		{
+			return SUCCESS;
+		}
+
+	}
+
+	return FALSE;
+}
+#else
+int32 rtl865x_isEthArp(ipaddr_t ip)
+{
+	uint32 hash;
+
+	//memset(mac, 0, sizeof(ether_addr_t));
+
+	if(rtl865x_arp_hash(ip, &hash)!=SUCCESS)
+	{
+		return FALSE;
+	}
+
+	if(arpTables.mappings[hash].ip!=ip)
+	{
+		return FALSE;
+	}
+
+	return TRUE;
+}
+
+#endif
+
+#endif
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN) || defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+int32 rtl_set_callback_for_ps_arp(int (*call_back_fn)(u32 ip,rtl865x_arpMapping_entry_t *entry))
+{
+	if(NULL == call_back_fn)
+	{
+		return FAILED;
+	}
+
+	rtl_callback_for_ps_arp = call_back_fn;
+	return SUCCESS;
+}
+
+int32 rtl865x_get_ps_arpMapping(ipaddr_t ip,rtl865x_arpMapping_entry_t *entry)
+{
+	if(rtl_callback_for_ps_arp)
+		return rtl_callback_for_ps_arp(ip,entry);
+
+	return FAILED;
+}
+#endif
+int32 rtl865x_addArp(ipaddr_t ip, ether_addr_t * mac)
+{
+	uint32 i;
+	uint32 hash;
+	uint16 fid = 0;
+
+	rtl865x_arpMapping_entry_t oldArpMapping;
+	rtl865x_arpMapping_entry_t newArpMapping;
+
+	rtl865x_tblAsicDrv_arpParam_t asicArpEntry;
+
+	uint32 fdb_type[]={ FDB_STATIC, FDB_DYNAMIC };
+
+	uint32 column;
+	rtl865x_tblAsicDrv_l2Param_t	fdbEntry;
+	rtl865x_filterDbTableEntry_t		l2temp_entry;
+
+	if((ip==0) ||(mac==NULL))
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	#if defined(CONFIG_RTL_MULTIPLE_WAN) || defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+	if(rtl_get_advRt_entry_by_nexthop(ip))
+	{
+		newArpMapping.ip=ip;
+		memcpy(&newArpMapping.mac,mac,sizeof(ether_addr_t));
+		rtl865x_eventHandle_addArp_for_multiWan(&newArpMapping);
+	}
+	#endif
+
+	if(rtl865x_arp_hash(ip, &hash)==FAILED)
+	{
+		return FAILED;
+	}
+
+	if ((mac->octet[0]&mac->octet[1]&mac->octet[2]&mac->octet[3]&mac->octet[4]&mac->octet[5]) == 0xff)
+		return FAILED;
+
+	//printk("%s:%d+++++++++++++++++++++++++++++\n",__FUNCTION__,__LINE__);
+
+	/*check the old arp mapping first*/
+	memcpy(&oldArpMapping,&(arpTables.mappings[hash] ),sizeof(rtl865x_arpMapping_entry_t));
+	if((oldArpMapping.ip!=ip) ||(memcmp(&(oldArpMapping.mac),mac, 6)!=0))
+	{
+		/*delete old arp mapping*/
+		if(oldArpMapping.ip!=0)
+		{
+			/*should clear old arp mapping before delete fdb entry and raise arp event*/
+			rtl8651_delAsicArp(hash);
+			memset(&(arpTables.mappings[hash] ),0,sizeof(rtl865x_arpMapping_entry_t));
+
+			if(rtl865x_getArpFid(oldArpMapping.ip,&fid)==SUCCESS)
+			{
+				rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEI|RTL865x_L2_TYPEII, fid, &oldArpMapping.mac);
+			}
+			rtl865x_raiseEvent(EVENT_DEL_ARP,(void*)(&oldArpMapping));
+		}
+	}
+
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+	else
+	{
+		/*ip and mac of the new one is the same with the old one*/
+		arpTables.mappings[hash].exist_in_ps = 1;
+		return RTL_EENTRYALREADYEXIST;
+	}
+#endif
+
+	/*here to handle the new arp mapping*/
+	newArpMapping.ip=ip;
+	memcpy(&newArpMapping.mac,mac,sizeof(ether_addr_t));
+	if(rtl865x_getArpFid(newArpMapping.ip, &fid)!=SUCCESS)
+	{
+		return FAILED;
+	}
+
+	for(i=0; i<2; i++)
+	{
+		/*
+		printk("%s:%d\n,fid(%d),mac(%02x:%02x:%02x:%02x:%02x:%02x)\n",__FUNCTION__,__LINE__,fid,mac->octet[0],mac->octet[1],
+			mac->octet[2],mac->octet[3],mac->octet[4],mac->octet[5]);
+
+		printk("%s:%d\n",__FUNCTION__,__LINE__);
+		*/
+		#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+		if (i == 0)
+			memcpy(&(arpTables_all.mappings[hash]), &newArpMapping,sizeof(rtl865x_arpMapping_entry_t));
+		#endif
+		if(rtl865x_Lookup_fdb_entry(fid, mac, fdb_type[i], &column,&fdbEntry) != SUCCESS)
+		{
+			continue;
+		}
+
+		#ifdef CONFIG_RTL_EXT_PORT_SUPPORT
+		if(extPortEnabled==0)
+		#endif
+		{
+		if(rtl865x_isEthPortMask(fdbEntry.memberPortMask)==FALSE)
+		{
+			continue;
+		}
+		}
+
+		/*indicate new arp mapping*/
+		if((oldArpMapping.ip!=ip) ||(memcmp(&(oldArpMapping.mac),mac, 6)!=0))
+		{
+			/*in case of layer2 auto learn, add hardware entry to layer 2 software table*/
+			l2temp_entry.l2type = (fdbEntry.nhFlag==0)?RTL865x_L2_TYPEI: RTL865x_L2_TYPEII;
+			l2temp_entry.process = FDB_TYPE_FWD;
+			l2temp_entry.memberPortMask = fdbEntry.memberPortMask;
+			l2temp_entry.auth = fdbEntry.auth;
+			l2temp_entry.SrcBlk = fdbEntry.srcBlk;
+			memcpy(&(l2temp_entry.macAddr), mac, sizeof(ether_addr_t));
+#ifdef CONFIG_RTL865X_SYNC_L2
+#else
+//			rtl865x_addFilterDatabaseEntryExtension(fid, &l2temp_entry);
+#endif
+//			_rtl865x_addFilterDatabaseEntry((fdbEntry.nhFlag==0)?RTL865x_L2_TYPEI: RTL865x_L2_TYPEII, fid, mac, FDB_TYPE_FWD, fdbEntry.memberPortMask, fdbEntry.auth,fdbEntry.srcBlk);
+
+		}
+
+		/*update or reflesh arp mapping*/
+		asicArpEntry.nextHopColumn = column;
+		asicArpEntry.aging    =    300;
+	 	asicArpEntry.nextHopRow=rtl865x_getHWL2Index(mac, fid);
+		rtl8651_setAsicArp(hash, &asicArpEntry);
+		rtl865x_refleshHWL2Table(mac, FDB_DYNAMIC|FDB_STATIC,fid);
+		/*update mapping table*/
+		memcpy(&(arpTables.mappings[hash]),&newArpMapping,sizeof(rtl865x_arpMapping_entry_t));
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+		arpTables.mappings[hash].exist_in_ps 	= 1;
+		arpTables.mappings[hash].valid 			= 1;
+#endif
+		rtl865x_raiseEvent(EVENT_ADD_ARP,(void*)(&newArpMapping));
+		return SUCCESS;
+
+	}
+
+	return FAILED;
+}
+
+
+
+int32 rtl865x_delArp(ipaddr_t ip)
+{
+	uint32 hash;
+	uint16 fid = 0;
+
+	rtl865x_arpMapping_entry_t arpMapping;
+
+	if(ip==0)
+	{
+		return FAILED;
+	}
+
+	#if defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+	if(rtl_get_advRt_entry_by_nexthop(ip))
+	{
+		arpMapping.ip = ip;
+		memset(arpMapping.mac.octet,0,ETHER_ADDR_LEN);
+		rtl865x_eventHandle_delArp_for_multiWan(&arpMapping);
+	}
+	#endif
+
+	if(rtl865x_arp_hash(ip,&hash)==FAILED)
+	{
+		return FAILED;
+	}
+
+	//printk("%s:%d***************************************\n",__FUNCTION__,__LINE__);
+	memcpy(&arpMapping, &arpTables.mappings[hash], sizeof(rtl865x_arpMapping_entry_t));
+
+	if(arpMapping.ip!=ip)
+	{
+		return FAILED;
+	}
+
+	if(rtl865x_getArpFid(ip, &fid)!=SUCCESS)
+	{
+		return FAILED;
+	}
+
+	/*should clear old arp mapping before delete fdb entry and raise arp event*/
+	rtl8651_delAsicArp(hash);
+	memset(&arpTables.mappings[hash], 0, sizeof(rtl865x_arpMapping_entry_t));
+	#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	memset(&arpTables_all.mappings[hash], 0, sizeof(rtl865x_arpMapping_entry_t));
+	#endif
+
+#ifdef CONFIG_RTL865X_SYNC_L2
+#else
+//	rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEI|RTL865x_L2_TYPEII, fid, &arpMapping.mac);
+#endif
+	rtl865x_raiseEvent(EVENT_DEL_ARP,(void *)(&arpMapping));
+
+	return SUCCESS;
+}
+
+uint32 rtl865x_arpSync(ipaddr_t ip, uint32 refresh )
+{
+	uint32 hash;
+	rtl865x_arpMapping_entry_t arpMapping;
+	rtl865x_tblAsicDrv_arpParam_t asicArpEntry;
+
+	uint16 fid;
+	rtl865x_tblAsicDrv_l2Param_t l2entry;
+	uint32 age=0;
+
+	if(ip==0)
+	{
+		return 0;
+	}
+
+	if(rtl865x_arp_hash(ip,&hash)==FAILED)
+	{
+		return 0;
+	}
+
+	memcpy(&arpMapping, &(arpTables.mappings[hash]), sizeof(rtl865x_arpMapping_entry_t));
+
+	if(arpMapping.ip!=ip)
+	{
+		return 0;
+	}
+
+	/*asic arp entry is invalid*/
+	if (rtl8651_getAsicArp(hash, &asicArpEntry)!=SUCCESS)
+	{
+		goto delete_and_out;
+
+	}
+
+	if(rtl865x_getHWL2Table(asicArpEntry.nextHopRow, asicArpEntry.nextHopColumn, &l2entry)!=SUCCESS)
+	{
+		/*the old fdb entry has timed out*/
+		goto delete_and_out;
+	}
+
+	if(memcmp(&(l2entry.macAddr), &(arpMapping.mac), 6)!= 0)
+	{
+		/*this layer 2 entry has different mac address,
+		also indicates the old fdb entry has timed out*/
+		goto delete_and_out;
+	}
+
+	age = l2entry.ageSec;
+	if (refresh)
+	{
+		 rtl865x_refleshHWL2Table(&(l2entry.macAddr), FDB_DYNAMIC|FDB_STATIC,l2entry.fid);
+		 age=150;
+	}
+	else
+	{
+		if(age>=300)
+		{
+			age=age-150;
+		}
+		else
+		{
+			age=0;
+
+			/*to make sure linux arp entry time out before fdb entry*/
+			/*asic fdb entry's age is 150 seconds*/
+			/*since linux protocol stack arp entry has timed out and l2 entry's precision is also 150 second,
+			we should delete both arp and fdb  to sync between linux protocol stack and asic*/
+			//goto delete_and_out;
+		}
+	}
+	return age;
+
+
+delete_and_out:
+
+	if(rtl865x_getArpFid(ip, &fid)==SUCCESS)
+	{
+		/*should clear old arp mapping before delete fdb entry and raise arp event*/
+		rtl8651_delAsicArp(hash);
+		memset(&arpTables.mappings[hash], 0, sizeof(rtl865x_arpMapping_entry_t));
+
+		rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEI|RTL865x_L2_TYPEII, fid, &arpMapping.mac);
+		rtl865x_raiseEvent(EVENT_DEL_ARP,(void *)(&arpMapping));
+	}
+
+	return 0;
+
+}
+
+
+#if defined(CONFIG_RTL_HARDWARE_NAT) //&&defined(REINIT_SWITCH_CORE)
+void rtl819x_save_hw_arp_table(void)
+{
+	int i = 0;
+	uint16 fid = 0;
+	ether_addr_t empty_mac = { {0x00, 0x00, 0x00, 0x00, 0x00, 0x00} };
+
+	memcpy(&arpTables_bak, &arpTables, sizeof(struct rtl865x_arp_table));
+
+	//store arp related l2 entry
+	rtl819x_init_l2_bakup_entry();
+
+	for (i = 0; i < RTL8651_ARPTBL_SIZE; i++){
+		if ((arpTables_bak.mappings[i].ip != 0) ||
+			memcmp(arpTables_bak.mappings[i].mac.octet, empty_mac.octet, ETHER_ADDR_LEN)!=0){
+			//panic_printk("%s %d ip=0x%x \n", __FUNCTION__, __LINE__, arpTables_bak.mappings[i].ip);
+			if(rtl865x_getArpFid(arpTables_bak.mappings[i].ip, &fid)!=SUCCESS)
+			{
+				printk("%s %d ip=0x%x \n", __FUNCTION__, __LINE__, arpTables_bak.mappings[i].ip);
+			}
+			rtl819x_save_inused_l2_entry(arpTables_bak.mappings[i].ip, (ether_addr_t *)&arpTables_bak.mappings[i].mac, fid);
+		}
+	}
+	return;
+}
+
+int rtl819x_restore_hw_arp_table(void)
+{
+	int i;
+	int ret = FAILED;
+	ether_addr_t empty_mac = { {0x00, 0x00, 0x00, 0x00, 0x00, 0x00} };
+
+	//restore hw l2 table first.
+	//rtl819x_restore_hw_l2_table();
+
+	for (i = 0; i < RTL865X_ARPTBL_SIZE; i++)
+	{
+		if ((arpTables_bak.mappings[i].ip != 0) ||
+			memcmp(arpTables_bak.mappings[i].mac.octet, empty_mac.octet, ETHER_ADDR_LEN)!=0){
+			ret = rtl865x_addArp(arpTables_bak.mappings[i].ip, &arpTables_bak.mappings[i].mac);
+			//panic_printk("%s %d ip=0x%x ret = %d \n", __FUNCTION__, __LINE__, arpTables_bak.mappings[i].ip, ret);
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+static ipaddr_t arp_ip_entry[RTL8651_ARPTBL_SIZE];
+
+int rtl_clear_arp_exist_in_ps_flag(void)
+{
+	int i;
+	unsigned long flags=0;
+
+	SMP_LOCK_ETH(flags);
+	for (i=0; i<RTL8651_ARPTBL_SIZE; i++)
+	{
+		if (arpTables.mappings[i].valid)
+			arpTables.mappings[i].exist_in_ps = 0;
+	}
+	SMP_UNLOCK_ETH(flags);
+	return SUCCESS;
+}
+
+int rtl_del_arp_not_exist_in_ps(void)
+{
+	int i, count = 0;
+	unsigned long flags=0;
+	ipaddr_t *tmp = arp_ip_entry;
+
+	SMP_LOCK_ETH(flags);
+
+	memset(arp_ip_entry, 0, sizeof(ipaddr_t)*RTL8651_ARPTBL_SIZE);
+
+	for (i=0; i<RTL8651_ARPTBL_SIZE; i++)
+	{
+		if ((arpTables.mappings[i].valid==1) && (arpTables.mappings[i].exist_in_ps==0)) {
+			tmp[count] = arpTables.mappings[i].ip;
+			count++;
+		}
+	}
+
+	for (i=0; i<count; i++)
+	{
+		rtl865x_delArp(tmp[i]);
+	}
+
+	SMP_UNLOCK_ETH(flags);
+	return SUCCESS;
+}
+#endif
+
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_arp.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_arp.h
new file mode 100644
index 00000000..d60d842
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_arp.h
@@ -0,0 +1,35 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL865X_ARP_H
+#define RTL865X_ARP_H
+
+#include <net/rtl/rtl865x_arp_api.h>
+/*for driver initialization*/
+int32 rtl865x_arp_init(void);
+int32 rtl865x_arp_reinit(void);
+
+/*for routing module usage*/
+int32 rtl865x_arp_tbl_alloc(rtl865x_route_t *route);
+int32 rtl865x_arp_tbl_free(rtl865x_route_t *route);
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+int32 rtl865x_isArpExisted(ipaddr_t ip);
+#endif
+#if defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+int32 rtl865x_get_ps_arpMapping(ipaddr_t ip,rtl865x_arpMapping_entry_t *entry);
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#ifdef CONFIG_RTL_HW_6RD_SUPPORT
+int32 rtl8198c_6rd_Ipv6ArpMapping(ipaddr_t ip, rtl865x_arpMapping_entry_t * arp_mapping);
+#endif
+#endif
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_dslite.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_dslite.c
new file mode 100644
index 00000000..675a59e
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_dslite.c
@@ -0,0 +1,387 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2014
+* All rights reserved.
+*
+* Program : dslite table driver
+* Abstract :
+* Author : annti_hu/ethan_ding
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+/*      @doc RTL_LAYEREDDRV_API
+
+		@module rtl865x_dslite.c - RTL865x Home gateway controller Layered driver API documentation       |
+		This document explains the API interface of the table driver module. Functions with rtl865x prefix
+		are external functions.
+
+		Copyright <cp>2014 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+		@head3 List of Symbols |
+		Here is a list of all functions and variables in this module.
+
+		@index | RTL_LAYEREDDRV_API
+*/
+
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl_errno.h"
+#include "common/rtl865x_netif_local.h"
+#include "rtl865x_ip.h"
+#include "rtl865x_nexthop.h"
+#include "rtl865x_ppp_local.h"
+#include "rtl865x_route.h"
+#include "rtl865x_arp.h"
+
+#include "common/rtl865x_vlan.h"
+#include "common/rtl865x_eventMgr.h" /*call back function....*/
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#endif
+#include "l2Driver/rtl865x_fdb.h"
+#include <net/rtl/rtl865x_fdb_api.h>
+#include <linux/version.h>
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#include "rtl8198c_arpIpv6.h"
+#include "rtl8198c_nexthopIpv6.h"
+#endif
+
+#include "rtl865x_dslite.h"
+
+/*ipv6 ds-lite*/
+#define IPV6_DSLT_TABLE_INDEX(entry)	(entry - rtl865x_ipv6_DsLiteTable)
+#define IPV6_DSLT_ENTRY_NUM	8
+
+static rtl865x_dslite_s *rtl865x_ipv6_DsLiteTable;
+int32 _rtl865x_delIpv6DsLiteEntry(uint32 entryIdx);
+inv6_addr_t	gw_ipv6_addr;
+
+/*
+@func int32 | rtl8198c_initIpv6DsLiteTable |initialize the dslite table
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed. system should reboot.
+@comm
+*/
+int32 rtl8198c_initIpv6DsLiteTable(void)
+{
+	TBL_MEM_ALLOC(rtl865x_ipv6_DsLiteTable, rtl865x_dslite_s, IPV6_DSLT_ENTRY_NUM);
+	memset(rtl865x_ipv6_DsLiteTable,0,sizeof(rtl865x_dslite_s)*IPV6_DSLT_ENTRY_NUM);
+	memset(&gw_ipv6_addr,0,sizeof(gw_ipv6_addr));
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl8198c_reinitIpv6DsLiteTable |reinitialize the dslite table
+@rvalue SUCCESS | success.
+@comm
+*/
+int32 rtl8198c_reinitIpv6DsLiteTable(void)
+{
+	int32 i;
+
+	for(i = 0; i < IPV6_DSLT_ENTRY_NUM; i++)
+	{
+		if(rtl865x_ipv6_DsLiteTable[i].valid)
+			_rtl865x_delIpv6DsLiteEntry(i);
+	}
+
+	memset(&gw_ipv6_addr,0,sizeof(gw_ipv6_addr));
+	return SUCCESS;
+}
+
+/*
+	may cause issue, carefully uesed
+*/
+rtl865x_dslite_s *  rtl865x_getDsLiteEntry(void)
+{
+	int32 entryIdx;
+	rtl865x_dslite_s *entry = NULL;
+
+	for (entryIdx = 0; entryIdx < IPV6_DSLT_ENTRY_NUM; entryIdx++)
+	{
+		entry=&rtl865x_ipv6_DsLiteTable[entryIdx];
+		if(entry)
+		{
+			if (entry->valid == 1)
+			{
+				return entry;
+			}
+		}
+	}
+	return NULL;
+}
+
+int32  _rtl865x_getIpv6DsLiteEntryByName(char * devName)
+{
+	int32 entryIdx;
+	rtl865x_dslite_s *entry = NULL;
+	int32 ret=FAILED;
+	int32 retVal=FAILED;
+	rtl8198C_tblAsicDrv_dsliteParam_t dslt_entry;
+	rtl8198C_tblAsicDrv_dsliteParam_t * asic_entry =&dslt_entry;
+
+	if(devName==NULL)
+		goto out;
+
+	for (entryIdx = 0; entryIdx < IPV6_DSLT_ENTRY_NUM; entryIdx++)
+	{
+		entry=&rtl865x_ipv6_DsLiteTable[entryIdx];
+		if(entry)
+		{
+			if ((entry->valid == 1)
+				&& (strcmp(devName,entry->name)==0)
+				)
+			{
+				goto found;
+			}
+		}
+	}
+	entry =NULL;
+
+	if(entry ==NULL)
+		goto out;
+found:
+	ret=rtl8198C_getAsicDsliteTable(entryIdx, asic_entry) ;
+	if(ret == SUCCESS)
+		retVal = entryIdx;
+out:
+	return retVal;
+}
+
+rtl865x_dslite_s *  _rtl865x_getIpv6DsLiteEntryByIndex(int32 entryIdx)
+{
+
+	rtl865x_dslite_s *entry = NULL;
+
+	entry=&rtl865x_ipv6_DsLiteTable[entryIdx];
+	if(entry)
+	{
+		if (entry->valid == 1)
+		{
+			goto found;
+		}
+	}
+	entry =NULL;
+
+found:
+	return entry;
+
+}
+
+int32  _rtl865x_getIpv6DsLiteEntryByAfterAddr(inv6_addr_t aftr_ipv6_addr,uint32 aftr_ipv6_mask)
+{
+	int32 entryIdx;
+	rtl865x_dslite_s *entry = NULL;
+	int32 ret=FAILED;
+	int32 retVal=FAILED;
+	rtl8198C_tblAsicDrv_dsliteParam_t dslt_entry;
+	rtl8198C_tblAsicDrv_dsliteParam_t * asic_entry =&dslt_entry;
+	for (entryIdx = 0; entryIdx < IPV6_DSLT_ENTRY_NUM; entryIdx++)
+	{
+		entry=&rtl865x_ipv6_DsLiteTable[entryIdx];
+		if (entry->valid == 1
+			&&( (entry->aftr_ipv6_addr.v6_addr32[0]==aftr_ipv6_addr.v6_addr32[0])
+			&&(entry->aftr_ipv6_addr.v6_addr32[1]==aftr_ipv6_addr.v6_addr32[1])
+			&&(entry->aftr_ipv6_addr.v6_addr32[2]==aftr_ipv6_addr.v6_addr32[2])
+			&&(entry->aftr_ipv6_addr.v6_addr32[3]==aftr_ipv6_addr.v6_addr32[3])
+			)
+			)
+		{
+			goto found;
+		}
+	}
+	entry =NULL;
+
+	if(entry ==NULL)
+		goto out;
+found:
+	ret=rtl8198C_getAsicDsliteTable(entryIdx, asic_entry) ;
+	if(ret == SUCCESS)
+		retVal = entryIdx;
+out:
+	return retVal;
+
+}
+int32  _rtl865x_getIpv6DsLiteEntrybyIndex(uint32 entryIdx,rtl865x_dslite_s *entry)
+{
+	int32 ret=FAILED;
+	entry=&rtl865x_ipv6_DsLiteTable[entryIdx];
+	if (entry->valid == 1 )
+	{
+		ret =SUCCESS;
+	}
+	return ret;
+
+}
+extern int rtl865x_test_tunnel(void);
+
+static int32 _rtl865x_synIpv6DsLiteToAsic(rtl865x_dslite_s *entry_t)
+{
+	rtl8198C_tblAsicDrv_dsliteParam_t asic_entry;
+	uint32 index;
+	if(entry_t == NULL)
+		return FAILED;
+
+	asic_entry.host_ipv6_addr.v6_addr32[0] =entry_t->host_ipv6_addr.v6_addr32[0];
+	asic_entry.host_ipv6_addr.v6_addr32[1] =entry_t->host_ipv6_addr.v6_addr32[1];
+	asic_entry.host_ipv6_addr.v6_addr32[2] =entry_t->host_ipv6_addr.v6_addr32[2];
+	asic_entry.host_ipv6_addr.v6_addr32[3] =entry_t->host_ipv6_addr.v6_addr32[3];
+	asic_entry.host_ipv6_mask =entry_t->host_ipv6_mask;
+
+	asic_entry.aftr_ipv6_addr.v6_addr32[0] =entry_t->aftr_ipv6_addr.v6_addr32[0];
+	asic_entry.aftr_ipv6_addr.v6_addr32[1] =entry_t->aftr_ipv6_addr.v6_addr32[1];
+	asic_entry.aftr_ipv6_addr.v6_addr32[2] =entry_t->aftr_ipv6_addr.v6_addr32[2];
+	asic_entry.aftr_ipv6_addr.v6_addr32[3] =entry_t->aftr_ipv6_addr.v6_addr32[3];
+	asic_entry.aftr_ipv6_mask =entry_t->aftr_ipv6_mask;
+
+	asic_entry.mtu =entry_t->mtu;
+	asic_entry.valid =entry_t->valid;
+	index=entry_t->index;
+	rtl8198C_setAsicDsliteTable(index, &asic_entry);
+	return SUCCESS;
+}
+
+int32 _rtl865x_addIpv6DsLiteEntry(inv6_addr_t host_ipv6_addr,uint32 host_ipv6_mask,inv6_addr_t aftr_ipv6_addr,uint32 aftr_ipv6_mask,char * devName,unsigned int mtu)
+{
+	int retVal;
+	int entryIdx=FAILED;
+	rtl865x_dslite_s *entry = NULL;
+	//entry = _rtl865x_getIpv6DsLiteEntry(host_ipv6_addr,host_ipv6_mask,aftr_ipv6_addr,aftr_ipv6_mask,devName);
+	printk("[%s]:[%d].host:%x:%x:%x:%x,%d,after:%x:%x:%x:%x,%d,%s,%d\n",__FUNCTION__,__LINE__,
+	host_ipv6_addr.v6_addr32[0],host_ipv6_addr.v6_addr32[1],host_ipv6_addr.v6_addr32[2],host_ipv6_addr.v6_addr32[3],host_ipv6_mask,
+	aftr_ipv6_addr.v6_addr32[0],aftr_ipv6_addr.v6_addr32[1],aftr_ipv6_addr.v6_addr32[2],aftr_ipv6_addr.v6_addr32[3],aftr_ipv6_mask,
+	devName,mtu);
+	entryIdx = _rtl865x_getIpv6DsLiteEntryByName(devName);
+	if(entryIdx!=FAILED)
+		return RTL_EENTRYALREADYEXIST;
+	else
+	{
+		/* Allocate an empty entry for new one */
+		/*
+				pppoe ----> index 0
+				direct ---> index 1
+				nexthop ---> index 2
+				arp ------> index 3
+		*/
+		//now test just for direct ,so use index 1 to use.
+		//for (entryIdx = 0; entryIdx < IPV6_DSLT_ENTRY_NUM; entryIdx++)
+		//for (entryIdx = 1; entryIdx < IPV6_DSLT_ENTRY_NUM; entryIdx++)
+		for (entryIdx = 2; entryIdx < IPV6_DSLT_ENTRY_NUM; entryIdx++)
+		{
+			if (rtl865x_ipv6_DsLiteTable[entryIdx].valid == 0) {
+				entry = &rtl865x_ipv6_DsLiteTable[entryIdx];
+				goto found;
+				break;
+			}
+		}
+	}
+
+	/*if not found proper nextHop entry, return*/
+	entry = NULL;
+
+found:
+	if(entry == NULL)
+		return RTL_ENOFREEBUFFER;
+
+	/*common information*/
+	entry->host_ipv6_addr.v6_addr32[0] =  htonl(host_ipv6_addr.v6_addr32[0]);
+	entry->host_ipv6_addr.v6_addr32[1] =  htonl(host_ipv6_addr.v6_addr32[1]);
+	entry->host_ipv6_addr.v6_addr32[2] =  htonl(host_ipv6_addr.v6_addr32[2]);
+	entry->host_ipv6_addr.v6_addr32[3] =  htonl(host_ipv6_addr.v6_addr32[3]);
+	entry->host_ipv6_mask = host_ipv6_mask;
+
+	entry->aftr_ipv6_addr.v6_addr32[0] =  htonl(aftr_ipv6_addr.v6_addr32[0]);
+	entry->aftr_ipv6_addr.v6_addr32[1] =  htonl(aftr_ipv6_addr.v6_addr32[1]);
+	entry->aftr_ipv6_addr.v6_addr32[2] =  htonl(aftr_ipv6_addr.v6_addr32[2]);
+	entry->aftr_ipv6_addr.v6_addr32[3] =  htonl(aftr_ipv6_addr.v6_addr32[3]);
+	entry->aftr_ipv6_mask = aftr_ipv6_mask;
+
+	strlcpy(entry->name,devName, MAX_IFNAMESIZE);
+	entry->mtu = mtu;
+	entry->valid = 1;
+	entry->index = entryIdx;
+
+	retVal = _rtl865x_synIpv6DsLiteToAsic(entry);
+	printk("[%s]:[%d].retVal:%d,host:%x:%x:%x:%x,%d,after:%x:%x:%x:%x,%d,%s,%d\n",__FUNCTION__,__LINE__,retVal,
+	host_ipv6_addr.v6_addr32[0],host_ipv6_addr.v6_addr32[1],host_ipv6_addr.v6_addr32[2],host_ipv6_addr.v6_addr32[3],host_ipv6_mask,
+	aftr_ipv6_addr.v6_addr32[0],aftr_ipv6_addr.v6_addr32[1],aftr_ipv6_addr.v6_addr32[2],aftr_ipv6_addr.v6_addr32[3],aftr_ipv6_mask,
+	devName,mtu);
+	return retVal;
+}
+
+int32 _rtl865x_delIpv6DsLiteEntry(uint32 entryIdx)
+{
+	int32 retval=FAILED;
+	rtl865x_dslite_s *entry= NULL;
+
+	if (entryIdx >= IPV6_DSLT_ENTRY_NUM)
+		return RTL_EINVALIDINPUT;
+
+	entry = &rtl865x_ipv6_DsLiteTable[entryIdx];
+
+	if(entry->valid == 0)
+		return RTL_EENTRYNOTFOUND;
+
+
+	/*delete route from asic*/
+	if(entry->index< IPV6_DSLT_ENTRY_NUM)
+		retval=rtl8198C_delAsicDsliteTable(entry->index);
+
+	memset(entry, 0, sizeof(rtl865x_dslite_s));
+
+	return retval;
+
+}
+
+/*
+@func int32 | rtl8198c_addIpv6DsLiteEntry |add a dslite entry
+@parm uint32 | attr | attribute. IPV6_NEXTHOP_L3/IPV6_NEXTHOP_REDIRECT.
+@parm void* | ref_ptr | entry pointer who refer this nexthop entry.
+@parm rtl865x_netif_local_t* | netif | network interface.
+@parm inv6_addr_t | nexthop | nexthop. ipv6 ip address when linktype is ethernet, session id when linktype is ppp session based.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl8198c_addIpv6DsLiteEntry(inv6_addr_t host_ipv6_addr,uint32 host_ipv6_mask,inv6_addr_t aftr_ipv6_addr,uint32 aftr_ipv6_mask,char * devName,unsigned int mtu)
+{
+	int32 ret = FAILED;
+	unsigned long flags=0;
+
+	SMP_LOCK_ETH_HW(flags);
+	ret = _rtl865x_addIpv6DsLiteEntry(host_ipv6_addr,host_ipv6_mask,aftr_ipv6_addr,aftr_ipv6_mask,devName,mtu);
+
+	SMP_UNLOCK_ETH_HW(flags);
+
+	return ret;
+}
+
+/*
+@func int32 | rtl8198c_delIpv6DsLiteEntry |delete dslite entry
+@parm uint32 | attr | attribute. IPV6_NEXTHOP_L3/IPV6_NEXTHOP_REDIRECT.
+@parm uint32 | entryIdx | entry index.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl8198c_delIpv6DsLiteEntry(uint32 attr, uint32 entryIdx)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl865x_delIpv6DsLiteEntry(entryIdx);
+	SMP_UNLOCK_ETH_HW(flags);
+
+	return retval;
+}
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_dslite.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_dslite.h
new file mode 100644
index 00000000..a0d638b
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_dslite.h
@@ -0,0 +1,35 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL865X_DSLITE_H
+#define RTL865X_DSLITE_H
+
+
+typedef struct rtl865x_dslite_s {
+	inv6_addr_t host_ipv6_addr;
+	uint32      host_ipv6_mask;
+	inv6_addr_t aftr_ipv6_addr;
+    uint32      aftr_ipv6_mask;
+	char name[MAX_IFNAMESIZE];	/* name of tunnel device */
+	uint32      mtu;
+	uint32      valid;
+	uint8		index;
+	uint8		arpIdx;
+	inv6_addr_t	gw_ipv6_addr;
+} rtl865x_dslite_s;
+
+//int32 rtl865x_updatev6SwNetif(char *netifName,int iftype);
+int32 rtl8198c_initIpv6DsLiteTable(void);
+rtl865x_dslite_s *  rtl865x_getDsLiteEntry(void);
+int32  _rtl865x_getIpv6DsLiteEntryByName(char * devName);
+rtl865x_dslite_s *  _rtl865x_getIpv6DsLiteEntryByIndex(int32 entryIdx);
+int32  _rtl865x_getIpv6DsLiteEntryByAfterAddr(inv6_addr_t aftr_ipv6_addr,uint32 aftr_ipv6_mask);
+int32  _rtl865x_getIpv6DsLiteEntrybyIndex(uint32 entryIdx,rtl865x_dslite_s *entry);
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ip.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ip.c
new file mode 100644
index 00000000..a0fc3af
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ip.c
@@ -0,0 +1,379 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : ip table driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+/*      @doc RTL_LAYEREDDRV_API
+
+		@module rtl865x_ip.c - RTL865x Home gateway controller Layered driver API documentation       |
+		This document explains the API interface of the table driver module. Functions with rtl865x prefix
+		are external functions.
+		@normal Hyking Liu (Hyking_liu@realsil.com.cn) <date>
+
+		Copyright <cp>2008 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+		@head3 List of Symbols |
+		Here is a list of all functions and variables in this module.
+
+		@index | RTL_LAYEREDDRV_API
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "common/rtl_errno.h"
+//#include "rtl_utils.h"
+//#include <net/rtl/rtl865x_ip_api.h>
+#include "rtl865x_ip.h"
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+#include <net/rtl/rtl865x_localPublic.h>
+#endif
+#include "common/rtl865x_eventMgr.h" /*call back function....*/
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#endif
+
+static rtl865x_ip_entry_t *rtl865x_ipTable;
+
+#define IP_TABLE_INDEX(entry)	(entry - rtl865x_ipTable)
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
+static RTL_DECLARE_MUTEX(ip_sem);
+#endif
+static int32 _rtl865x_delIp(ipaddr_t extIp);
+
+/*
+@func int32 | rtl865x_initIpTable | initialize ip table.
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed,system should be reboot.
+*/
+int32 rtl865x_initIpTable(void)
+{
+	TBL_MEM_ALLOC(rtl865x_ipTable, rtl865x_ip_entry_t, IP_NUMBER);
+	memset(rtl865x_ipTable,0,sizeof(rtl865x_ip_entry_t)*IP_NUMBER);
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865x_initIpTable | reinitialize ip table.
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed.
+*/
+int32 rtl865x_reinitIpTable(void)
+{
+	int32 i ;
+	for(i = 0; i < IP_NUMBER; i++)
+	{
+		if(rtl865x_ipTable[i].valid)
+			_rtl865x_delIp(rtl865x_ipTable[i].extIp);
+	}
+	return SUCCESS;
+}
+
+
+static int32 _rtl865x_addIp(ipaddr_t intIp, ipaddr_t extIp, uint32 ip_type)
+{
+	int i;
+	rtl865x_ip_entry_t *entry = NULL;
+	rtl865x_tblAsicDrv_extIntIpParam_t asicIp;
+	int32 retval = FAILED;
+#if defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+	int empty_entry = -1;
+#endif
+
+	if(ip_type < IP_TYPE_NAPT || ip_type > IP_TYPE_LOCALSERVER)
+		return RTL_EINVALIDINPUT;
+
+	/*duplicate check*/
+	/*found a valid entry*/
+	for(i = 0; i < IP_NUMBER; i++)
+	{
+		if(rtl865x_ipTable[i].valid == 0)
+		{
+#if defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+			if (empty_entry == -1)
+				empty_entry = i;
+#else
+			entry = &rtl865x_ipTable[i];
+			break;
+#endif
+		}
+		else
+		{
+			if(rtl865x_ipTable[i].extIp == extIp)
+				return RTL_EENTRYALREADYEXIST;
+
+			if(ip_type == IP_TYPE_NAPT && rtl865x_ipTable[i].type == IP_TYPE_NAPT && rtl865x_ipTable[i].defNaptIp == 1)
+				return RTL_EENTRYALREADYEXIST;
+		}
+	}
+
+#if defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+	if (empty_entry != -1)
+		entry = &rtl865x_ipTable[empty_entry];
+#endif
+
+	if(entry == NULL)
+		return RTL_ENOFREEBUFFER;
+
+
+	/*update releated information*/
+	entry->valid = 1;
+	entry->intIp = intIp;
+	entry->extIp = extIp;
+	entry->type = ip_type;
+
+	/*from 865xC, this field is invalid...*/
+	entry->nexthop = NULL;
+
+
+	/*add this ip entry to asic*/
+	/* Set asic */
+	bzero(&asicIp, sizeof(rtl865x_tblAsicDrv_extIntIpParam_t));
+	asicIp.extIpAddr	= extIp;
+	asicIp.intIpAddr	= intIp;
+	asicIp.localPublic	= (ip_type == IP_TYPE_LOCALSERVER)? TRUE: FALSE;
+	asicIp.nat			= (ip_type == IP_TYPE_NAT)? TRUE: FALSE;
+	asicIp.nhIndex		= 0;
+
+	retval = rtl8651_setAsicExtIntIpTable(IP_TABLE_INDEX(entry), &asicIp);
+
+	if(ip_type == IP_TYPE_NAPT)
+		rtl8651_setAsicOperationLayer(4);
+
+	return SUCCESS;
+
+}
+
+static int32 _rtl865x_ipTableIsNull(void)
+{
+	int i;
+
+	/*found the entry*/
+	for(i = 0; i < IP_NUMBER; i++)
+	{
+		if(rtl865x_ipTable[i].valid == 1)
+		{
+			return FAILED;
+		}
+	}
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_delIp(ipaddr_t extIp)
+{
+	int i;
+	rtl865x_ip_entry_t *entry = NULL;
+
+	/*found the entry*/
+	for(i = 0; i < IP_NUMBER; i++)
+	{
+		if(rtl865x_ipTable[i].valid == 1 && rtl865x_ipTable[i].extIp == extIp)
+		{
+			entry = &rtl865x_ipTable[i];
+			break;
+		}
+	}
+
+	/*update asic ip table*/
+	if(entry!=NULL)
+	{
+		rtl8651_delAsicExtIntIpTable(IP_TABLE_INDEX(entry));
+		memset(entry,0,sizeof(rtl865x_ip_entry_t));
+	}
+	else
+		return RTL_EENTRYNOTFOUND;
+
+	//no entry in ip table, set operation to layer 2
+	if(_rtl865x_ipTableIsNull() == SUCCESS)
+	{
+		#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+			rtl8651_setAsicOperationLayer(3);
+		#else
+			rtl8651_setAsicOperationLayer(2);
+		#endif
+	}
+
+	return SUCCESS;
+
+}
+
+static rtl865x_ip_entry_t* _rtl865x_getIpEntryByExtIp(ipaddr_t extIp)
+{
+	int32 i;
+	rtl865x_ip_entry_t *entry = NULL;
+
+	for(i = 0; i < IP_NUMBER; i++)
+		if(rtl865x_ipTable[i].valid == 1 && rtl865x_ipTable[i].extIp == extIp)
+		{
+			entry = &rtl865x_ipTable[i];
+			break;
+		}
+	return entry;
+
+}
+
+/*
+@func rtl865x_ip_entry_t* | rtl865x_getIpEntryByIp | get ip entry .
+@parm ipaddr_t | extIp | ip address
+@rvalue ip_entry | Success.
+@rvalue NULL | Failed
+*/
+rtl865x_ip_entry_t* rtl865x_getIpEntryByIp(ipaddr_t extIp)
+{
+	return _rtl865x_getIpEntryByExtIp(extIp);
+}
+
+
+/*
+@func int32 | rtl865x_getIpIdxByExtIp | get asic idex .
+@parm ipaddr_t | extIp | ip address
+@parm int32* | idx | index
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed
+*/
+int32 rtl865x_getIpIdxByExtIp(ipaddr_t extIp, int32 *idx)
+{
+	int32 retval = FAILED;
+	rtl865x_ip_entry_t *entry = NULL;
+
+	entry = _rtl865x_getIpEntryByExtIp(extIp);
+	if(entry)
+	{
+		if(idx)
+			*idx = IP_TABLE_INDEX(entry);
+		retval = SUCCESS;
+	}
+
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_addIp | add ip table entry.
+@parm ipaddr_t | intIp | internal ip address
+@parm ipaddr_t | extIp | external ip address
+@parm uint32 | ip_type | entry type. support IP_TYPE_NAPT/IP_TYPE_NAT/IP_TYPE_LOCALSERVER
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDINPUT | Invalid input.
+@rvalue RTL_EENTRYALREADYEXIST | entry already exist.
+@rvalue RTL_ENOFREEBUFFER | not enough buffer in System.
+@rvalue FAILED | Failed.
+@comm
+the extIp is the primary key of the ip table.
+*/
+int32 rtl865x_addIp(ipaddr_t intIp, ipaddr_t extIp, uint32 ip_type)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&ip_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_addIp(intIp, extIp, ip_type);
+	//rtl_up(&ip_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+
+}
+
+/*
+@func int32 | rtl865x_delIp | delete ip table entry.
+@parm ipaddr_t | extIp | external ip address
+@rvalue SUCCESS | Success.
+@rvalue RTL_EINVALIDINPUT | Invalid input.
+@rvalue RTL_EENTRYNOTFOUND | not found.
+@rvalue FAILED | Failed.
+@comm
+the extIp is the primary key of the ip table.
+*/
+int32 rtl865x_delIp(ipaddr_t extIp)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&ip_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_delIp(extIp);
+	//rtl_up(&ip_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+
+}
+
+int32 rtl865x_getIPIdx(rtl865x_ip_entry_t *entry, int32 *idx)
+{
+	if(idx)
+	{
+		*idx =IP_TABLE_INDEX(entry);
+		return SUCCESS;
+	}
+	return FAILED;
+}
+
+#if defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+extern int rtl_check_extIp_exist_in_ps(uint32 extIp);
+int32 rtl_del_extIp_not_exist_in_ps(void)
+{
+	int i, found = 0;
+
+	for (i=0; i<IP_NUMBER; i++)
+	{
+		found = 0;
+		if (rtl865x_ipTable[i].valid == 1) {
+			if (rtl_check_extIp_exist_in_ps(rtl865x_ipTable[i].extIp) == SUCCESS)
+				found = 1;
+
+			/*Delete the ip not exist in protocol stack*/
+			if (found == 0) {
+				rtl865x_delIp(rtl865x_ipTable[i].extIp);
+			}
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+/*
+@func int32 | rtl865x_getIpIdxByIpRange | get asic idex .
+@parm ipaddr_t | ip | ip address
+@parm ipaddr_t | mask | ip address
+@parm int32* | idx | index
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed
+*/
+int32 rtl865x_getIpIdxByIpRange(ipaddr_t ip, ipaddr_t mask, int32 *idx)
+{
+	int32 retval = FAILED;
+	int32 i;
+	rtl865x_ip_entry_t *entry = NULL;
+
+	*idx = 0; //default point to index 0
+	for(i = 0; i < IP_NUMBER; i++)
+	{
+		if(rtl865x_ipTable[i].valid == 1 && ((rtl865x_ipTable[i].extIp & mask) == (ip&mask)))
+		{
+			entry = &rtl865x_ipTable[i];
+			break;
+		}
+	}
+
+	if(entry)
+	{
+		if(idx)
+			*idx = IP_TABLE_INDEX(entry);
+		retval = SUCCESS;
+	}
+
+	return retval;
+}
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ip.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ip.h
new file mode 100644
index 00000000..2121749
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ip.h
@@ -0,0 +1,67 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : ip table driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#ifndef	RTL865X_IP_H
+#define	RTL865X_IP_H
+
+#include <net/rtl/rtl865x_ip_api.h>
+
+#if 0//!defined(REDUCE_MEMORY_SIZE_FOR_16M)
+#define REDUCE_MEMORY_SIZE_FOR_16M
+#endif
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+#define IP_NUMBER	8
+#else
+#if defined(REDUCE_MEMORY_SIZE_FOR_16M)
+#define IP_NUMBER	2
+#else
+#define IP_NUMBER	8
+#endif
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+#undef IP_NUMBER
+#if defined(CONFIG_RTL_8198C) ||defined(CONFIG_RTL_8197F)
+#define IP_NUMBER	16
+#else
+#define IP_NUMBER	8
+#endif
+#endif
+
+typedef struct rtl865x_ip_entry_s
+{
+	ipaddr_t intIp; /*internal ip address*/
+	ipaddr_t extIp; /*external ip address*/
+	uint32 valid:1, /*valid*/
+		type:2,  /*napt/nat/ls/reserved*/
+		defNaptIp:1; /*this ip entry is default napt ip address?*/
+
+#if 1
+	/*now, this information is invalid...*/
+	void *nexthop; /*point to a nexthop entry,in preversion SoC,
+				     *used for multiple session hardware forwarding...
+				     */
+#endif
+}rtl865x_ip_entry_t;
+
+
+int32 rtl865x_initIpTable(void);
+int32 rtl865x_reinitIpTable(void);
+//int32 rtl865x_addIp(ipaddr_t intIp, ipaddr_t extIp, uint32 ip_type);
+//int32 rtl865x_delIp(ipaddr_t extIp);
+int32 rtl865x_getIPIdx(rtl865x_ip_entry_t *entry, int32 *idx);
+int32 rtl865x_getIpIdxByExtIp(ipaddr_t extIp, int32 *idx);
+int32 rtl865x_getIpIdxByIpRange(ipaddr_t ip, ipaddr_t mask, int32 *idx);
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_multicast.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_multicast.c
new file mode 100644
index 00000000..cb1ba09
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_multicast.c
@@ -0,0 +1,4518 @@
+/*
+ *
+ *  Copyright (c) 2011 Realtek Semiconductor Corp.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 2 as
+ *  published by the Free Software Foundation.
+ */
+
+#ifdef __linux__
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,2,0)
+#include <linux/kconfig.h>
+#else
+#include <linux/config.h>
+#endif
+#include <linux/jiffies.h>
+#include <linux/timer.h>
+#include <linux/proc_fs.h>
+#endif
+
+
+
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+//#include "common/rtl_utils.h"
+//#include "common/assert.h"
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#include "common/rtl865x_tblDrvPatch.h"
+#endif
+
+#include "AsicDriver/asicRegs.h"
+#include "AsicDriver/asicTabs.h"
+
+#include "common/rtl8651_tblDrvProto.h"
+
+#include "common/rtl865x_eventMgr.h"
+#include "common/rtl865x_vlan.h"
+#include <net/rtl/rtl865x_netif.h>
+
+#include "l3Driver/rtl865x_ip.h"
+
+#ifdef RTL865X_TEST
+#include <string.h>
+#endif
+
+#include <net/rtl/rtl865x_multicast.h>
+#include <net/rtl/rtl865x_igmpsnooping.h>
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+int32 rtl8198C_initMulticastv6(void);
+int32 rtl8198C_reinitMulticastv6(void);
+#endif
+
+/********************************************************/
+/*			Multicast Related Global Variable			*/
+/********************************************************/
+
+static rtl865x_mcast_fwd_descriptor_t *rtl865x_mcastFwdDescPool=NULL;
+static mcast_fwd_descriptor_head_t  free_mcast_fwd_descriptor_head;
+static struct rtl865x_multicastTable mCastTbl;
+static uint32 rtl865x_externalMulticastPortMask = 0;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static rtl8198c_mcast_fwd_descriptor6_t *rtl8198c_mcastFwdDescPool6=NULL;
+static mcast_fwd_descriptor_head6_t free_mcast_fwd_descriptor_head6;
+static struct rtl8198c_multicastv6Table mCastTbl6;
+static uint32 rtl8198c_externalMulticastPortMask6 = 0;
+#endif
+#if defined(__linux__) && defined(__KERNEL__)
+static struct timer_list rtl865x_mCastSysTimer;	/*igmp timer*/
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static struct timer_list rtl8198c_mCast6SysTimer;/*MLD timer*/
+#endif
+#endif
+
+#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+extern int hwwifiEnable;
+#endif
+
+
+#if defined (CONFIG_RT_MULTIPLE_BR_SUPPORT)
+extern int rtl_get_brIgmpModuleIndexbyName(char *name, int * index);
+extern struct net_bridge * rtl_get_brByIndex(int index, char *name);
+#endif
+
+static int32 _rtl865x_initMCastFwdDescPool(void)
+{
+	int32 i;
+
+
+	MC_LIST_INIT(&free_mcast_fwd_descriptor_head);
+
+	TBL_MEM_ALLOC(rtl865x_mcastFwdDescPool, rtl865x_mcast_fwd_descriptor_t,MAX_MCAST_FWD_DESCRIPTOR_CNT);
+
+	if(rtl865x_mcastFwdDescPool!=NULL)
+	{
+		memset( rtl865x_mcastFwdDescPool, 0, MAX_MCAST_FWD_DESCRIPTOR_CNT * sizeof(rtl865x_mcast_fwd_descriptor_t));
+	}
+	else
+	{
+		return FAILED;
+	}
+
+	for(i = 0; i<MAX_MCAST_FWD_DESCRIPTOR_CNT;i++)
+	{
+		MC_LIST_INSERT_HEAD(&free_mcast_fwd_descriptor_head, &rtl865x_mcastFwdDescPool[i], next);
+	}
+
+	return SUCCESS;
+}
+
+static rtl865x_mcast_fwd_descriptor_t *_rtl865x_allocMCastFwdDesc(void)
+{
+	rtl865x_mcast_fwd_descriptor_t *retDesc=NULL;
+	retDesc = MC_LIST_FIRST(&free_mcast_fwd_descriptor_head);
+	if(retDesc!=NULL)
+	{
+		MC_LIST_REMOVE(retDesc, next);
+		memset(retDesc,0,sizeof(rtl865x_mcast_fwd_descriptor_t));
+	}
+	return retDesc;
+}
+
+static int32 _rtl865x_freeMCastFwdDesc(rtl865x_mcast_fwd_descriptor_t *descPtr)
+{
+	if(descPtr==NULL)
+	{
+		return SUCCESS;
+	}
+	memset(descPtr,0,sizeof(rtl865x_mcast_fwd_descriptor_t));
+	MC_LIST_INSERT_HEAD(&free_mcast_fwd_descriptor_head, descPtr, next);
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_flushMCastFwdDescChain(mcast_fwd_descriptor_head_t * descChainHead)
+{
+	rtl865x_mcast_fwd_descriptor_t * curDesc,*nextDesc;
+
+	if(descChainHead==NULL)
+	{
+		return SUCCESS;
+	}
+
+	curDesc=MC_LIST_FIRST(descChainHead);
+	while(curDesc)
+	{
+		nextDesc=MC_LIST_NEXT(curDesc, next );
+		/*remove from the old descriptor chain*/
+		MC_LIST_REMOVE(curDesc, next);
+		/*return to the free descriptor chain*/
+		_rtl865x_freeMCastFwdDesc(curDesc);
+		curDesc = nextDesc;
+	}
+
+	return SUCCESS;
+}
+
+
+
+static int32 _rtl865x_mCastFwdDescEnqueue(mcast_fwd_descriptor_head_t * queueHead,
+												rtl865x_mcast_fwd_descriptor_t * enqueueDesc)
+{
+
+	rtl865x_mcast_fwd_descriptor_t *newDesc;
+	rtl865x_mcast_fwd_descriptor_t *curDesc,*nextDesc;
+	if(queueHead==NULL)
+	{
+		return FAILED;
+	}
+
+	if(enqueueDesc==NULL)
+	{
+		return SUCCESS;
+	}
+
+	/*multicast forward descriptor is internal maintained,always alloc new one*/
+	newDesc=_rtl865x_allocMCastFwdDesc();
+
+	if(newDesc!=NULL)
+	{
+		memcpy(newDesc, enqueueDesc,sizeof(rtl865x_mcast_fwd_descriptor_t ));
+		//memset(&(newDesc->next), 0, sizeof(MC_LIST_ENTRY(rtl865x_mcast_fwd_descriptor_s)));
+		newDesc->next.le_next=NULL;
+		newDesc->next.le_prev=NULL;
+	}
+	else
+	{
+		/*no enough memory*/
+		return FAILED;
+	}
+
+
+	for(curDesc=MC_LIST_FIRST(queueHead);curDesc!=NULL;curDesc=nextDesc)
+	{
+
+		nextDesc=MC_LIST_NEXT(curDesc, next);
+
+		/*merge two descriptor*/
+	//	if((strcmp(curDesc->netifName,newDesc->netifName)==0) && (curDesc->vid==newDesc->vid))
+		if(strcmp(curDesc->netifName,newDesc->netifName)==0)
+		{
+
+			if(newDesc->descPortMask==0)
+			{
+				newDesc->descPortMask=curDesc->descPortMask;
+			}
+			MC_LIST_REMOVE(curDesc, next);
+			_rtl865x_freeMCastFwdDesc(curDesc);
+
+		}
+	}
+
+	/*not matched descriptor is found*/
+	MC_LIST_INSERT_HEAD(queueHead, newDesc, next);
+
+	return SUCCESS;
+
+}
+
+
+static int32 _rtl865x_mergeMCastFwdDescChain(mcast_fwd_descriptor_head_t * targetChainHead ,
+													rtl865x_mcast_fwd_descriptor_t *srcChain)
+{
+	rtl865x_mcast_fwd_descriptor_t *curDesc;
+
+	if(targetChainHead==NULL)
+	{
+		return FAILED;
+	}
+
+	for(curDesc=srcChain; curDesc!=NULL; curDesc=MC_LIST_NEXT(curDesc,next))
+	{
+
+		_rtl865x_mCastFwdDescEnqueue(targetChainHead, curDesc);
+
+	}
+
+	return SUCCESS;
+}
+
+
+
+
+static int32 _rtl865x_initMCastEntryPool(void)
+{
+	int32 index;
+	rtl865x_tblDrv_mCast_t *multiCast_t;
+	struct MCast_hash_head *mCast_hash_head;
+	
+	TBL_MEM_ALLOC(multiCast_t, rtl865x_tblDrv_mCast_t ,MAX_MCAST_TABLE_ENTRY_CNT);
+	TAILQ_INIT(&mCastTbl.freeList.freeMultiCast);
+	for(index=0; index<MAX_MCAST_TABLE_ENTRY_CNT; index++)
+	{
+		memset( &multiCast_t[index], 0, sizeof(rtl865x_tblDrv_mCast_t));
+		TAILQ_INSERT_HEAD(&mCastTbl.freeList.freeMultiCast, &multiCast_t[index], nextMCast);
+	}
+
+	//TBL_MEM_ALLOC(multiCast_t, rtl865x_tblDrv_mCast_t, RTL8651_MULTICASTTBL_SIZE);
+	TBL_MEM_ALLOC(mCast_hash_head, struct MCast_hash_head, RTL8651_MULTICASTTBL_SIZE);
+	memset(mCast_hash_head, 0,RTL8651_MULTICASTTBL_SIZE* sizeof(struct MCast_hash_head));
+	mCastTbl.inuseList.mCastTbl = (void *)mCast_hash_head;
+
+	for(index=0; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+		TAILQ_INIT(&mCastTbl.inuseList.mCastTbl[index]);
+	}
+
+	return SUCCESS;
+}
+
+static rtl865x_tblDrv_mCast_t * _rtl865x_allocMCastEntry(uint32 hashIndex)
+{
+	rtl865x_tblDrv_mCast_t *newEntry;
+	newEntry=TAILQ_FIRST(&mCastTbl.freeList.freeMultiCast);
+	if (newEntry == NULL)
+	{
+		return NULL;
+	}
+
+	TAILQ_REMOVE(&mCastTbl.freeList.freeMultiCast, newEntry, nextMCast);
+
+
+	/*initialize it*/
+	if(MC_LIST_FIRST(&newEntry->fwdDescChain)!=NULL)
+	{
+		_rtl865x_flushMCastFwdDescChain(&newEntry->fwdDescChain);
+	}
+	MC_LIST_INIT(&newEntry->fwdDescChain);
+
+	memset(newEntry, 0, sizeof(rtl865x_tblDrv_mCast_t));
+
+	TAILQ_INSERT_TAIL(&mCastTbl.inuseList.mCastTbl[hashIndex], newEntry, nextMCast);
+
+	return newEntry;
+}
+
+static int32 _rtl865x_flushMCastEntry(rtl865x_tblDrv_mCast_t *mCastEntry)
+{
+	if(mCastEntry==NULL)
+	{
+		return SUCCESS;
+	}
+
+	_rtl865x_flushMCastFwdDescChain(&mCastEntry->fwdDescChain);
+
+	memset(mCastEntry, 0, sizeof(rtl865x_tblDrv_mCast_t));
+	return SUCCESS;
+}
+
+static int32 _rtl865x_freeMCastEntry(rtl865x_tblDrv_mCast_t * mCastEntry, uint32 hashIndex)
+{
+	if(mCastEntry==NULL)
+	{
+		return SUCCESS;
+	}
+
+	TAILQ_REMOVE(&mCastTbl.inuseList.mCastTbl[hashIndex], mCastEntry, nextMCast);
+	_rtl865x_flushMCastEntry(mCastEntry);
+	TAILQ_INSERT_HEAD(&mCastTbl.freeList.freeMultiCast, mCastEntry, nextMCast);
+	return SUCCESS;
+}
+
+
+static uint32 _rtl865x_doMCastEntrySrcVlanPortFilter(rtl865x_tblDrv_mCast_t *mCastEntry)
+{
+	rtl865x_mcast_fwd_descriptor_t * curDesc,*nextDesc;
+	if(mCastEntry==NULL)
+	{
+		return SUCCESS;
+	}
+
+	for(curDesc=MC_LIST_FIRST(&mCastEntry->fwdDescChain);curDesc!=NULL;curDesc=nextDesc)
+	{
+		nextDesc=MC_LIST_NEXT(curDesc, next);
+		{
+			curDesc->fwdPortMask=curDesc->fwdPortMask & (~(1<<mCastEntry->port));
+			if(curDesc->fwdPortMask==0)
+			{
+				/*remove from the old chain*/
+				MC_LIST_REMOVE(curDesc, next);
+				/*return to the free descriptor chain*/
+				_rtl865x_freeMCastFwdDesc(curDesc);
+
+			}
+		}
+
+	}
+
+	return SUCCESS;
+}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) && defined(CONFIG_RTL_HW_MCAST_WIFI)
+static uint32 rtl865x_genMCastEntryAsicFwdMaskIgnoreCpuFlag(rtl865x_tblDrv_mCast_t *mCastEntry)
+{
+	uint32 asicFwdPortMask=0;
+	rtl865x_mcast_fwd_descriptor_t * curDesc;
+	if(mCastEntry==NULL)
+	{
+		return 0;
+	}
+
+	MC_LIST_FOREACH(curDesc, &(mCastEntry->fwdDescChain), next)
+	{
+		asicFwdPortMask |= curDesc->fwdPortMask;
+	}
+	asicFwdPortMask = asicFwdPortMask & (~(1<<mCastEntry->port));
+	return asicFwdPortMask;
+}
+#endif
+
+
+static uint32 rtl865x_genMCastEntryAsicFwdMask(rtl865x_tblDrv_mCast_t *mCastEntry)
+{
+	uint32 asicFwdPortMask=0;
+	rtl865x_mcast_fwd_descriptor_t * curDesc;
+	if(mCastEntry==NULL)
+	{
+		return 0;
+	}
+
+	MC_LIST_FOREACH(curDesc, &(mCastEntry->fwdDescChain), next)
+	{
+		if(curDesc->toCpu==0)
+		{
+			asicFwdPortMask|=(curDesc->fwdPortMask & ((1<<RTL8651_MAC_NUMBER)-1));
+		}
+		else
+		{
+			asicFwdPortMask|=( 0x01<<RTL8651_MAC_NUMBER);
+		}
+	}
+	asicFwdPortMask = asicFwdPortMask & (~(1<<mCastEntry->port));
+	return asicFwdPortMask;
+}
+
+static uint16 rtl865x_genMCastEntryCpuFlag(rtl865x_tblDrv_mCast_t *mCastEntry)
+{
+	uint16 cpuFlag=FALSE;
+	rtl865x_mcast_fwd_descriptor_t * curDesc;
+	if(mCastEntry==NULL)
+	{
+		return 0;
+	}
+
+	if(mCastEntry->cpuHold==TRUE)
+	{
+		cpuFlag=TRUE;
+	}
+
+	MC_LIST_FOREACH(curDesc, &(mCastEntry->fwdDescChain), next)
+	{
+		if(	(curDesc->toCpu==TRUE)	||
+			(memcmp(curDesc->netifName, RTL_WLAN_NAME,4)==0)	)
+		{
+			cpuFlag=TRUE;
+		}
+	}
+
+	return cpuFlag;
+}
+
+#if defined (CONFIG_RTL_IGMP_SNOOPING)
+/*for linux bridge level igmp snooping usage*/
+#if !defined(CONFIG_RTL_MULTI_LAN_DEV)
+static uint32 rtl865x_getMCastEntryDescPortMask(rtl865x_tblDrv_mCast_t *mCastEntry)
+{
+	uint32 descPortMask=0;
+	rtl865x_mcast_fwd_descriptor_t * curDesc;
+	if(mCastEntry==NULL)
+	{
+		return 0;
+	}
+
+	MC_LIST_FOREACH(curDesc, &(mCastEntry->fwdDescChain), next)
+	{
+		descPortMask=descPortMask | curDesc->descPortMask;
+	}
+
+	return descPortMask;
+}
+#endif
+#endif
+/*=======================================
+  * Multicast Table APIs
+  *=======================================*/
+#define RTL865X_MULTICASE_TABLE_APIs
+
+static void  _rtl865x_setASICMulticastPortStatus(void) {
+	uint32 index;
+
+	for (index=0; index<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; index++) {
+		rtl8651_setAsicMulticastPortInternal(index, (rtl865x_externalMulticastPortMask&(1<<index))?FALSE:TRUE);
+	}
+}
+
+void rtl865x_arrangeMulticastPortStatus(void) {
+
+	rtl865x_externalMulticastPortMask=rtl865x_getExternalPortMask();
+	_rtl865x_setASICMulticastPortStatus();
+}
+
+/*
+@func int32	| rtl865x_addMulticastExternalPort	| API to add a hardware multicast external port.
+@parm  uint32 | extPort	| External port number to be added.
+@rvalue SUCCESS	|Add hardware multicast external port successfully.
+@rvalue FAILED	|Add hardware multicast external port failed.
+*/
+int32 rtl865x_addMulticastExternalPort(uint32 extPort)
+{
+	rtl865x_externalMulticastPortMask |= (1<<extPort);
+	_rtl865x_setASICMulticastPortStatus();
+	return SUCCESS;
+}
+
+/*
+@func int32	| rtl865x_delMulticastExternalPort	| API to delete a hardware multicast external port.
+@parm  uint32 | extPort	| External port number to be deleted.
+@rvalue SUCCESS	|Delete external port successfully.
+@rvalue FAILED	|Delete external port failed.
+*/
+int32 rtl865x_delMulticastExternalPort(uint32 extPort)
+{
+	rtl865x_externalMulticastPortMask &= ~(1<<extPort);
+	_rtl865x_setASICMulticastPortStatus();
+	return SUCCESS;
+}
+
+/*
+@func int32	| rtl865x_setMulticastExternalPortMask	| API to set hardware multicast external port mask.
+@parm  uint32 | extPortMask	| External port mask to be set.
+@rvalue SUCCESS	|Set external port mask successfully.
+@rvalue FAILED	|Set external port mask failed.
+*/
+int32 rtl865x_setMulticastExternalPortMask(uint32 extPortMask)
+{
+	rtl865x_externalMulticastPortMask =extPortMask;
+	_rtl865x_setASICMulticastPortStatus();
+	return SUCCESS;
+}
+
+/*
+@func int32	| rtl865x_addMulticastExternalPortMask	| API to add hardware multicast external port mask.
+@parm  uint32 | extPortMask	| External port mask to be added.
+@rvalue SUCCESS	|Add external port mask successfully.
+@rvalue FAILED	|Add external port mask failed.
+*/
+int32 rtl865x_addMulticastExternalPortMask(uint32 extPortMask)
+{
+	rtl865x_externalMulticastPortMask|= extPortMask;
+	_rtl865x_setASICMulticastPortStatus();
+	return SUCCESS;
+}
+
+/*
+@func int32	| rtl865x_delMulticastExternalPortMask	|  API to delete hardware multicast external port mask.
+@parm  uint32 | extPortMask	| External port mask to be deleted.
+@rvalue SUCCESS	|Delete external port mask successfully.
+@rvalue FAILED	|Delete external port mask failed.
+*/
+int32 rtl865x_delMulticastExternalPortMask(uint32 extPortMask)
+{
+	rtl865x_externalMulticastPortMask &= ~extPortMask;
+	_rtl865x_setASICMulticastPortStatus();
+	return SUCCESS;
+}
+
+int32 rtl865x_getMulticastExternalPortMask(void)
+{
+	return rtl865x_externalMulticastPortMask ;
+}
+
+static inline void _rtl865x_patchPppoeWeak(rtl865x_tblDrv_mCast_t *mCast_t)
+{
+	rtl865x_mcast_fwd_descriptor_t * curDesc;
+	uint32 netifType;
+	/* patch: keep cache in software if one vlan's interface is pppoe */
+	MC_LIST_FOREACH(curDesc, &(mCast_t->fwdDescChain), next)
+	{
+		if(rtl865x_getNetifType(curDesc->netifName, &netifType)==SUCCESS)
+		{
+			/*how about pptp,l2tp?*/
+			if(netifType==IF_PPPOE)
+			{
+				mCast_t->flag |= RTL865X_MULTICAST_PPPOEPATCH_CPUBIT;
+				return;
+			}
+		}
+
+	}
+
+	mCast_t->flag &= ~RTL865X_MULTICAST_PPPOEPATCH_CPUBIT;
+}
+#if 0
+static int _rtl865x_checkMulticastEntryEqual(rtl865x_tblDrv_mCast_t * mCastEntry1, rtl865x_tblDrv_mCast_t * mCastEntry2)
+{
+	if((mCastEntry1==NULL) && (mCastEntry2==NULL))
+	{
+		return TRUE;
+	}
+
+	if((mCastEntry1==NULL) && (mCastEntry2!=NULL))
+	{
+		return FALSE;
+	}
+
+	if((mCastEntry1!=NULL) && (mCastEntry2==NULL))
+	{
+		return FALSE;
+	}
+
+	if(mCastEntry1->sip!=mCastEntry2->sip)
+	{
+		return FALSE;
+	}
+
+	if(mCastEntry1->dip!=mCastEntry2->dip)
+	{
+		return FALSE;
+	}
+
+	if(mCastEntry1->svid!=mCastEntry2->svid)
+	{
+		return FALSE;
+	}
+
+	if(mCastEntry1->port!=mCastEntry2->port)
+	{
+		return FALSE;
+	}
+
+	if(mCastEntry1->mbr!=mCastEntry2->mbr)
+	{
+		return FALSE;
+	}
+
+	if(mCastEntry1->cpu!=mCastEntry2->cpu)
+	{
+		return FALSE;
+	}
+
+	if(mCastEntry1->extIp!=mCastEntry2->extIp)
+	{
+		return FALSE;
+	}
+
+	if(mCastEntry1->flag!=mCastEntry2->flag)
+	{
+		return FALSE;
+	}
+
+
+	if(mCastEntry1->inAsic!=mCastEntry2->inAsic)
+	{
+		return FALSE;
+	}
+
+	return TRUE;
+}
+#endif
+#ifdef CONFIG_PROC_FS
+static unsigned int mcastAddOpCnt=0;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static unsigned int mcastAddOpCnt6=0;
+#endif
+unsigned int _rtl865x_getAddMcastOpCnt(void)
+{
+	return mcastAddOpCnt;
+}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+unsigned int _rtl8198C_getAddMcastv6OpCnt(void)
+{
+	return mcastAddOpCnt6;
+}
+#endif
+
+static unsigned int mcastDelOpCnt=0;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static unsigned int mcastDelOpCnt6=0;
+#endif
+unsigned int _rtl865x_getDelMcastOpCnt(void)
+{
+	return mcastDelOpCnt;
+}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+unsigned int _rtl8198C_getDelMcastv6OpCnt(void)
+{
+	return mcastDelOpCnt6;
+}
+
+#endif
+#endif
+/* re-select Multicast entry to ASIC for the index ""entryIndex */
+static void _rtl865x_arrangeMulticast(uint32 entryIndex)
+{
+	rtl865x_tblAsicDrv_multiCastParam_t asic_mcast;
+	rtl865x_tblDrv_mCast_t *mCast_t=NULL;
+	rtl865x_tblDrv_mCast_t *select_t=NULL;
+	rtl865x_tblDrv_mCast_t *swapOutEntry=NULL;
+	int32 retval;
+
+	TAILQ_FOREACH(mCast_t, &mCastTbl.inuseList.mCastTbl[entryIndex], nextMCast)
+	{
+
+		#ifdef CONFIG_RTL_HW_MCAST_WIFI
+		if(((hwwifiEnable)||((hwwifiEnable==0)&&(mCast_t->cpu == 0)))
+			&& !(mCast_t->flag & RTL865X_MULTICAST_PPPOEPATCH_CPUBIT))
+		#else
+		if ((mCast_t->cpu == 0) && !(mCast_t->flag & RTL865X_MULTICAST_PPPOEPATCH_CPUBIT))
+		#endif
+		{ /* Ignore cpu=1 */
+
+			if(mCast_t->inAsic==TRUE)
+			{
+				if(swapOutEntry==NULL)
+				{
+					swapOutEntry=mCast_t;
+				}
+				else
+				{
+					/*impossible, two flow in one asic entry*/
+					swapOutEntry->inAsic=FALSE;
+					mCast_t->inAsic = FALSE;
+				}
+			}
+
+			if (select_t)
+			{
+
+
+				if ((mCast_t->unKnownMCast==FALSE) && (select_t->unKnownMCast==TRUE))
+				{
+					/*replace unknown multicast*/
+					select_t = mCast_t;
+				}
+				else
+				{
+					/*select the heavy load*/
+					if ((mCast_t->count) > (select_t->count))
+					{
+						select_t = mCast_t;
+					}
+				}
+
+			}
+			else
+			{
+				select_t = mCast_t;
+			}
+
+
+		}
+		else
+		{
+			mCast_t->inAsic = FALSE;	/* reset "inAsic" bit */
+		}
+
+
+	}
+
+	if(select_t && swapOutEntry)
+	{
+		if ((swapOutEntry->unKnownMCast==FALSE) && (select_t->unKnownMCast==TRUE))
+		{
+			/*replace unknown multicast*/
+			select_t = swapOutEntry;
+		}
+		else
+		{
+			if((select_t->count <= (swapOutEntry->count+RTL865X_HW_MCAST_SWAP_GAP)))
+				select_t = swapOutEntry;
+		}
+	}
+
+
+
+	/*
+	if(swapOutEntry)
+	{
+		printk("%s:%d,swapOutEntry->count:%d,swapOutEntry->dip is 0x%x,swapOutEntry->mbr is 0x%x\n",__FUNCTION__,__LINE__,swapOutEntry->count,swapOutEntry->dip,swapOutEntry->mbr);
+
+	}
+
+	if (select_t)
+	{
+		printk("%s:%d,select_t->count:%d,select_t->dip is 0x%x,select_t->mbr is 0x%x\n",__FUNCTION__,__LINE__,select_t->count,select_t->dip,select_t->mbr);
+	}
+	*/
+	if (select_t)
+	{
+		if((swapOutEntry==NULL) ||(select_t==swapOutEntry))
+		{
+			select_t->age = RTL865X_MULTICAST_TABLE_ASIC_AGE;
+			bzero(&asic_mcast, sizeof(rtl865x_tblAsicDrv_multiCastParam_t));
+			memcpy(&asic_mcast, select_t, (uintptr_t)&(((rtl865x_tblDrv_mCast_t *)0)->extIp));
+			if (select_t->extIp)
+			{
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+				int32 ipIdx;
+				if(rtl865x_getIpIdxByExtIp(select_t->extIp, &ipIdx)==SUCCESS)
+				{
+					asic_mcast.extIdx=(uint16)ipIdx;
+				}
+#else
+				asic_mcast.extIdx=0;
+#endif
+
+			}
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+			asic_mcast.idx=(uint16)entryIndex;
+	#endif
+			retval = rtl8651_setAsicIpMulticastTable(&asic_mcast);
+
+#ifdef CONFIG_PROC_FS
+			mcastAddOpCnt++;
+#endif
+			assert(retval == SUCCESS);
+			if(retval==SUCCESS)
+			{
+				select_t->inAsic = TRUE;
+			}
+			else
+			{
+				select_t->inAsic = FALSE;
+				rtl8651_delAsicIpMulticastTable(entryIndex);
+#ifdef CONFIG_PROC_FS
+				mcastDelOpCnt++;
+#endif
+			}
+
+			assert(retval == SUCCESS);
+			TAILQ_REMOVE(&mCastTbl.inuseList.mCastTbl[entryIndex], select_t, nextMCast);
+			TAILQ_INSERT_HEAD(&mCastTbl.inuseList.mCastTbl[entryIndex], select_t, nextMCast);
+		}
+		else/*(swapOutEntry!=NULL) && (select_t!=swapOutEntry)*/
+		{
+			/*disable swap and only explicit joined mulicast flow can replace unknown multicast flow*/
+			if(1)
+			{
+				/*don't forget to set swapOutEntry's inAsic flag*/
+				swapOutEntry->inAsic=FALSE;
+
+				select_t->age = RTL865X_MULTICAST_TABLE_ASIC_AGE;
+				bzero(&asic_mcast, sizeof(rtl865x_tblAsicDrv_multiCastParam_t));
+				memcpy(&asic_mcast, select_t, (uintptr_t)&(((rtl865x_tblDrv_mCast_t *)0)->extIp));
+
+				if (select_t->extIp)
+				{
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+					int32 ipIdx;
+					if(rtl865x_getIpIdxByExtIp(select_t->extIp, &ipIdx)==SUCCESS)
+					{
+						asic_mcast.extIdx=(uint16)ipIdx;
+					}
+#else
+					asic_mcast.extIdx=0;
+#endif
+				}
+
+				retval = rtl8651_setAsicIpMulticastTable(&asic_mcast);
+#ifdef CONFIG_PROC_FS
+				mcastAddOpCnt++;
+#endif
+				assert(retval == SUCCESS);
+				if(retval==SUCCESS)
+				{
+					select_t->inAsic = TRUE;
+				}
+				else
+				{
+					select_t->inAsic = FALSE;
+					rtl8651_delAsicIpMulticastTable(entryIndex);
+#ifdef CONFIG_PROC_FS
+					mcastDelOpCnt++;
+#endif
+				}
+
+				TAILQ_REMOVE(&mCastTbl.inuseList.mCastTbl[entryIndex], select_t, nextMCast);
+				TAILQ_INSERT_HEAD(&mCastTbl.inuseList.mCastTbl[entryIndex], select_t, nextMCast);
+
+			}
+			#if 0
+			else
+			{
+				if(swapOutEntry->inAsic == FALSE)
+				{
+					/*maybe something is wrong, we remove the asic entry*/
+					rtl8651_delAsicIpMulticastTable(entryIndex);
+#ifdef CONFIG_PROC_FS
+					mcastDelOpCnt++;
+#endif
+				}
+
+			}
+			#endif
+
+		}
+
+	}
+	else
+	{
+		if(swapOutEntry!=NULL)
+		{
+			swapOutEntry->inAsic=FALSE;
+		}
+		rtl8651_delAsicIpMulticastTable(entryIndex);
+#ifdef CONFIG_PROC_FS
+		mcastDelOpCnt++;
+#endif
+	}
+}
+
+
+static void _rtl865x_mCastEntryReclaim(void)
+{
+	uint32 index;
+	uint32 freeCnt=0;
+	uint32 asicFwdPortMask=0;
+	uint32 needReArrange=FALSE;
+	rtl865x_tblDrv_mCast_t *curMCastEntry, *nextMCastEntry;
+
+	/*free unused software forward entry*/
+	for(index=0; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+		curMCastEntry = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[index]);
+		while (curMCastEntry)
+		{
+			nextMCastEntry = TAILQ_NEXT(curMCastEntry, nextMCast);
+			if((curMCastEntry->inAsic==FALSE)  && (curMCastEntry->count==0))
+			{
+				_rtl865x_freeMCastEntry(curMCastEntry, index);
+				freeCnt++;
+			}
+			curMCastEntry = nextMCastEntry;
+		}
+
+	}
+
+	if(freeCnt>0)
+	{
+		return;
+	}
+
+	for(index=0; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+		curMCastEntry = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[index]);
+		needReArrange=FALSE;
+		while (curMCastEntry)
+		{
+			nextMCastEntry = TAILQ_NEXT(curMCastEntry, nextMCast);
+			if(curMCastEntry->inAsic)
+			{
+				asicFwdPortMask=rtl865x_genMCastEntryAsicFwdMask(curMCastEntry);
+				if(asicFwdPortMask==0)
+				{
+					_rtl865x_freeMCastEntry(curMCastEntry, index);
+					needReArrange=TRUE;
+				}
+			}
+			curMCastEntry = nextMCastEntry;
+		}
+
+		if(needReArrange==TRUE)
+		{
+			_rtl865x_arrangeMulticast(index);
+		}
+	}
+
+	return;
+}
+/*
+@func rtl865x_tblDrv_mCast_t *	| rtl865x_findMCastEntry	|  API to find a hardware multicast entry.
+@parm  ipaddr_t 	| mAddr	| Multicast stream destination group address.
+@parm  ipaddr_t	|  sip	| Multicast stream source ip address.
+@parm  uint16		| svid	| Multicast stream input vlan index.
+@parm  uint16 	| sport	| Multicast stream input port number.
+*/
+rtl865x_tblDrv_mCast_t *rtl865x_findMCastEntry(ipaddr_t mAddr, ipaddr_t sip, uint16 svid, uint16 sport)
+{
+	rtl865x_tblDrv_mCast_t *mCast_t;
+	uint32 entry = rtl8651_ipMulticastTableIndex(sip, mAddr);
+	TAILQ_FOREACH(mCast_t, &mCastTbl.inuseList.mCastTbl[entry], nextMCast) {
+		if (mCast_t->dip==mAddr && mCast_t->sip==sip && mCast_t->svid==svid && mCast_t->port==sport)
+		{
+			if (mCast_t->inAsic == FALSE)
+			{
+				mCast_t->age = RTL865X_MULTICAST_TABLE_AGE;
+				mCast_t->count ++;
+			}
+
+			return mCast_t;
+		}
+	}
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+	for(entry=RTL8651_IPMULTICASTTBL_SIZE; entry<RTL8651_MULTICASTTBL_SIZE; entry++)
+	{
+		TAILQ_FOREACH(mCast_t, &mCastTbl.inuseList.mCastTbl[entry], nextMCast) {
+			if (mCast_t->dip==mAddr && mCast_t->sip==sip && mCast_t->svid==svid && mCast_t->port==sport)
+			{
+				if (mCast_t->inAsic == FALSE)
+				{
+					mCast_t->age = RTL865X_MULTICAST_TABLE_AGE;
+					mCast_t->count ++;
+				}
+
+				return mCast_t;
+			}
+
+		}
+	}
+#endif
+	return (rtl865x_tblDrv_mCast_t *)NULL;
+}
+
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+
+int rtl865x_findEmptyCamEntry(void)
+{
+	int index=-1;
+
+	for(index=RTL8651_IPMULTICASTTBL_SIZE; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+
+		if(TAILQ_EMPTY(&mCastTbl.inuseList.mCastTbl[index]))
+		{
+			return index;
+		}
+	}
+
+	return -1;
+}
+#endif
+
+/*
+@func int32	| rtl865x_addMulticastEntry	|  API to add a hardwawre multicast forwarding entry.
+@parm  ipaddr_t 	| mAddr	| Multicast flow Destination group address.
+@parm  ipaddr_t 	| sip	| Multicast flow source ip address.
+@parm  uint16 	| svid	| Multicast flow input vlan index.
+@parm  uint16		| sport	| Multicast flow input port number.
+@parm  rtl865x_mcast_fwd_descriptor_t *	| newFwdDescChain	| Multicast flow forwarding descriptor chain to be added.
+@parm  int32 	| flushOldChain	| Flag to indicate to flush old mulicast forwarding descriptor chain or not. 1 is to flush old chain, and 0 is not to.
+@parm  ipaddr_t 	| extIp	| External source ip address used when forward multicast data from lan to wan.
+@parm  int8	| toCpu	| Cpu forwarding flag, 1 is to forward multicast data by cpu,and  0 is not.
+@parm  int8	| flag	| For future usage, set to 0 at present.
+@rvalue SUCCESS	|Add hardware multicast forwarding entry successfully.
+@rvalue FAILED	|Add hardware multicast forwarding entry failed.
+*/
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+int32 rtl865x_addMulticastEntry(ipaddr_t mAddr, ipaddr_t sip, uint16 svid, uint16 sport,
+									rtl865x_mcast_fwd_descriptor_t * newFwdDescChain,
+									int32 flushOldChain, ipaddr_t extIp, char cpuHold, uint8 flag, unsigned int mapPortMask)
+#else
+int32 rtl865x_addMulticastEntry(ipaddr_t mAddr, ipaddr_t sip, uint16 svid, uint16 sport,
+									rtl865x_mcast_fwd_descriptor_t * newFwdDescChain,
+									int32 flushOldChain, ipaddr_t extIp, char cpuHold, uint8 flag)
+#endif
+{
+
+	rtl865x_tblDrv_mCast_t *mCast_t;
+	uint32 hashIndex = rtl8651_ipMulticastTableIndex(sip, mAddr);
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+	uint32 emptyCamIndex=-1;
+	#endif
+	#if defined (CONFIG_RTL_IGMP_SNOOPING)
+	struct rtl_groupInfo groupInfo;
+	#endif
+	/*windows xp upnp:239.255.255.0*/
+	if(mAddr==0xEFFFFFFA)
+	{
+		return FAILED;
+	}
+#if 0
+	/*reserved multicast address 224.0.0.x*/
+	if((mAddr & 0xFFFFFF00) == 0xE0000000)
+	{
+		return FAILED;
+	}
+#endif
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+	mCast_t=rtl865x_findMCastEntry(mAddr, sip, svid, sport);
+	if(mCast_t==NULL)
+	{
+		/*table entry collided*/
+		if(!TAILQ_EMPTY(&mCastTbl.inuseList.mCastTbl[hashIndex]))
+		{
+			emptyCamIndex=rtl865x_findEmptyCamEntry();
+			if(emptyCamIndex!=-1)
+			{
+				hashIndex=emptyCamIndex;
+			}
+		}
+	}
+	else
+	{
+		hashIndex=mCast_t->hashIndex;
+	}
+#else
+	/*try to match hash line*/
+	TAILQ_FOREACH(mCast_t, &mCastTbl.inuseList.mCastTbl[hashIndex], nextMCast)
+	{
+		if (mCast_t->sip==sip && mCast_t->dip==mAddr && mCast_t->svid==svid && mCast_t->port==sport)
+			break;
+	}
+#endif
+
+	if (mCast_t == NULL)
+	{
+		mCast_t=_rtl865x_allocMCastEntry(hashIndex);
+		if (mCast_t == NULL)
+		{
+			_rtl865x_mCastEntryReclaim();
+			mCast_t=_rtl865x_allocMCastEntry(hashIndex);
+			if(mCast_t == NULL)
+			{
+				return FAILED;
+			}
+		}
+		mCast_t->sip			= sip;
+		mCast_t->dip			= mAddr;
+		mCast_t->svid		= svid;
+		mCast_t->port		= sport;
+		mCast_t->mbr		= 0;
+		mCast_t->count		= 0;
+		//mCast_t->maxPPS		= 0;
+
+		#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+		mCast_t->mapPortMbr = mapPortMask;
+		#endif
+
+		mCast_t->inAsic		= FALSE;
+	}
+
+	if(flushOldChain)
+	{
+		_rtl865x_flushMCastFwdDescChain(&mCast_t->fwdDescChain);
+
+	}
+
+	_rtl865x_mergeMCastFwdDescChain(&mCast_t->fwdDescChain,newFwdDescChain);
+	_rtl865x_doMCastEntrySrcVlanPortFilter(mCast_t);
+
+	mCast_t->mbr			= rtl865x_genMCastEntryAsicFwdMask(mCast_t);
+	mCast_t->extIp			= extIp;
+
+	mCast_t->age			= RTL865X_MULTICAST_TABLE_AGE;
+#if 0
+	mCast_t->cpu			= (toCpu==TRUE? 1: 0);
+#else
+	mCast_t->cpuHold			= cpuHold;
+	mCast_t->cpu 			= rtl865x_genMCastEntryCpuFlag(mCast_t);
+#endif
+	mCast_t->flag			= flag;
+
+	if (extIp)
+		mCast_t->flag |= RTL865X_MULTICAST_EXTIP_SET;
+	else
+		mCast_t->flag &= ~RTL865X_MULTICAST_EXTIP_SET;
+	#if defined (CONFIG_RTL_IGMP_SNOOPING)
+	rtl_getGroupInfo(mAddr, &groupInfo);
+	if(groupInfo.ownerMask==0)
+	{
+		mCast_t->unKnownMCast=TRUE;
+	}
+	else
+	{
+		mCast_t->unKnownMCast=FALSE;
+	}
+	#endif
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+	mCast_t->hashIndex=hashIndex;
+#endif
+	_rtl865x_patchPppoeWeak(mCast_t);
+	_rtl865x_arrangeMulticast(hashIndex);
+	return SUCCESS;
+}
+
+
+/*
+@func int32	| rtl865x_delMulticastEntry	|  API to delete multicast forwarding entry related with a certain group address.
+@parm  ipaddr_t 	| mcast_addr	| Group address to be mached in deleting hardware multicast forwarding entry.
+@rvalue SUCCESS	|Delete hardware multicast forwarding entry successfully.
+@rvalue FAILED	|Delete hardware multicast forwarding entry failed.
+*/
+int32 rtl865x_delMulticastEntry(ipaddr_t mcast_addr)
+{
+
+	rtl865x_tblDrv_mCast_t *mCastEntry, *nextMCastEntry;
+	uint32 entry;
+	uint32 deleteFlag=FALSE;
+
+	for(entry=0; entry<RTL8651_MULTICASTTBL_SIZE; entry++)
+	{
+		deleteFlag=FALSE;
+		mCastEntry = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[entry]);
+		while (mCastEntry)
+		{
+			nextMCastEntry = TAILQ_NEXT(mCastEntry, nextMCast);
+			if (!mcast_addr || mCastEntry->dip == mcast_addr)
+			{
+				deleteFlag=TRUE;
+				_rtl865x_freeMCastEntry(mCastEntry, entry);
+			}
+
+			mCastEntry = nextMCastEntry;
+		}
+
+		if(deleteFlag==TRUE)
+		{
+			_rtl865x_arrangeMulticast(entry);
+		}
+	}
+
+	return SUCCESS;
+}
+
+#if 0
+/*the following function maybe used in future*/
+
+int32 rtl865x_addMulticastFwdDesc(ipaddr_t mcast_addr, rtl865x_mcast_fwd_descriptor_t * newFwdDesc)
+{
+
+	rtl865x_tblDrv_mCast_t *mCast_t;
+	uint32 entry, matchedIdx = 0;
+	uint32 oldFwdPortMask,newFwdPortMask;
+	if(newFwdDesc==NULL)
+	{
+		return SUCCESS;
+	}
+
+	for (entry=0; entry< RTL8651_MULTICASTTBL_SIZE; entry++)
+	{
+		TAILQ_FOREACH(mCast_t, &mCastTbl.inuseList.mCastTbl[entry], nextMCast)
+		{
+			if (mCast_t->dip != mcast_addr)
+				continue;
+
+			oldFwdPortMask=mCast_t->mbr;
+
+			_rtl865x_mergeMCastFwdDescChain(&mCast_t->fwdDescChain,newFwdDesc);
+			_rtl865x_doMCastEntrySrcVlanPortFilter(mCast_t);
+
+			mCast_t->mbr 		= rtl865x_genMCastEntryFwdMask(mCast_t);
+			newFwdPortMask		= mCast_t->mbr ;
+#ifndef RTL8651_MCAST_ALWAYS2UPSTREAM
+			if (mCast_t->flag & RTL865X_MULTICAST_UPLOADONLY)
+			{	/* remove upload term*/
+				if(oldFwdPortMask!=newFwdPortMask)
+				{
+					mCast_t->flag &= ~RTL865X_MULTICAST_UPLOADONLY;
+					/* we assume multicast member will NEVER in External interface, so we remove
+					     external ip now */
+					mCast_t->flag &= ~RTL865X_MULTICAST_EXTIP_SET;
+					mCast_t->extIp= 0;
+				}
+			}
+#endif /* RTL8651_MCAST_ALWAYS2UPSTREAM */
+
+			_rtl865x_patchPppoeWeak(mCast_t);
+			_rtl865x_arrangeMulticast(entry);
+			matchedIdx = entry;
+		}
+	}
+
+	if (matchedIdx)
+	{
+		return SUCCESS;
+	}
+	return FAILED;
+}
+
+int32 rtl865x_delMulticastFwdDesc(ipaddr_t mcast_addr,  rtl865x_mcast_fwd_descriptor_t * deadFwdDesc)
+{
+
+	uint32 index;
+	rtl865x_tblDrv_mCast_t  *mCastEntry, *nextMCastEntry;
+	uint32 oldFwdPortMask,newFwdPortMask;
+
+	for(index=0; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+
+		for (mCastEntry = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[index]); mCastEntry; mCastEntry = nextMCastEntry)
+		{
+			nextMCastEntry=TAILQ_NEXT(mCastEntry, nextMCast);
+
+			if ((mcast_addr) && (mCastEntry->dip != mcast_addr))
+			{
+				continue;
+			}
+
+			oldFwdPortMask=mCastEntry->mbr;
+
+			_rtl865x_subMCastFwdDescChain(&mCastEntry->fwdDescChain, deadFwdDesc);
+
+			mCastEntry->mbr=rtl865x_genMCastEntryFwdMask(mCastEntry);
+			newFwdPortMask=mCastEntry->mbr;
+			if (mCastEntry->mbr == 0)
+			{
+				/*to-do:unknown multicast hardware blocking*/
+				_rtl865x_freeMCastEntry(mCastEntry, index);
+				mCastEntry=NULL;
+				_rtl865x_arrangeMulticast(index);
+			}
+			else
+			{
+
+				_rtl865x_patchPppoeWeak(mCastEntry);
+			}
+
+		}
+
+		_rtl865x_arrangeMulticast(index);
+	}
+
+	return SUCCESS;
+}
+
+int32 rtl865x_delMulticastUpStream(ipaddr_t mcast_addr, ipaddr_t sip, uint16 svid, uint16 sport)
+{
+	uint32 index;
+	rtl865x_tblDrv_mCast_t *mCast_t;
+
+	for(index=0; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+		TAILQ_FOREACH(mCast_t, &mCastTbl.inuseList.mCastTbl[index], nextMCast)
+		{
+			if ((!mcast_addr || mCast_t->dip == mcast_addr) &&
+				(!sip || mCast_t->sip==sip) &&
+				(!svid || mCast_t->svid==svid) &&
+				mCast_t->port==sport)
+			{
+				_rtl865x_freeMCastEntry(mCast_t, index);
+				_rtl865x_arrangeMulticast(index);
+				return SUCCESS;
+			}
+		}
+	}
+	return FAILED;
+}
+
+int32 rtl865x_delMulticastByVid(uint32 vid)
+{
+	uint16 sport;
+	uint32 sportMask;
+	rtl865x_mcast_fwd_descriptor_t vlanFwdDesc;
+	memset(&vlanFwdDesc,0,sizeof(rtl865x_mcast_fwd_descriptor_t));
+
+	/* delete all upstream related to vid */
+	sport = 0;
+	sportMask=rtl865x_getVlanPortMask(vid);
+	while (sportMask)
+	{
+		if (sportMask & 1)
+		{
+			rtl865x_delMulticastUpStream(0, 0, vid, sport);
+		}
+
+		sportMask = sportMask >> 1;
+		sport ++;
+	}
+
+	/* delete all downstream related to vid*/
+	vlanFwdDesc.vid=vid;
+	vlanFwdDesc.fwdPortMask=rtl865x_getVlanPortMask(vid);
+	rtl865x_delMulticastFwdDesc(0, &vlanFwdDesc);
+
+	return FAILED;
+}
+
+int32 rtl865x_delMulticastByPort(uint32 port)
+{
+
+	rtl865x_mcast_fwd_descriptor_t portFwdDesc;
+	memset(&portFwdDesc,0,sizeof(rtl865x_mcast_fwd_descriptor_t));
+
+	/* delete all upstream related to this port */
+	rtl865x_delMulticastUpStream(0, 0, 0, port);
+
+	/* delete all downstream related to this port*/
+	portFwdDesc.vid=0;
+	portFwdDesc.fwdPortMask=1<<port;
+	rtl865x_delMulticastFwdDesc(0, &portFwdDesc);
+
+	return SUCCESS;
+}
+
+int32 rtl865x_setMGroupAttribute(ipaddr_t groupIp, int8 toCpu)
+{
+	uint32 index;
+	rtl865x_tblDrv_mCast_t *mCast_t;
+
+	for(index=0; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+		TAILQ_FOREACH(mCast_t, &mCastTbl.inuseList.mCastTbl[index], nextMCast)
+		{
+			if (mCast_t->dip == groupIp)
+			{
+				mCast_t->cpu = (toCpu==TRUE? 1: 0);
+			}
+		}
+		_rtl865x_arrangeMulticast(index);
+	}
+	return SUCCESS;
+}
+
+
+static int32 _rtl865x_subMCastFwdDescChain(mcast_fwd_descriptor_head_t * targetChainHead,rtl865x_mcast_fwd_descriptor_t *srcChain)
+{
+	rtl865x_mcast_fwd_descriptor_t *curDesc;
+	if(targetChainHead==NULL)
+	{
+		return FAILED;
+	}
+
+	for(curDesc=srcChain; curDesc!=NULL; curDesc=MC_LIST_NEXT(curDesc,next))
+	{
+		_rtl865x_mCastFwdDescDequeue(targetChainHead, curDesc);
+	}
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_mCastFwdDescDequeue(mcast_fwd_descriptor_head_t * queueHead,rtl865x_mcast_fwd_descriptor_t * dequeueDesc)
+{
+	rtl865x_mcast_fwd_descriptor_t *curDesc,*nextDesc;
+
+	if(queueHead==NULL)
+	{
+		return FAILED;
+	}
+
+	if(dequeueDesc==NULL)
+	{
+		return FAILED;
+	}
+
+	for(curDesc=MC_LIST_FIRST(queueHead);curDesc!=NULL;curDesc=nextDesc)
+	{
+		nextDesc=MC_LIST_NEXT(curDesc, next );
+		if((strcmp(curDesc->netifName,dequeueDesc->netifName)==0) ||
+			((dequeueDesc->vid==0 ) ||(curDesc->vid==dequeueDesc->vid)))
+		{
+			curDesc->fwdPortMask &= (~dequeueDesc->fwdPortMask);
+			if(curDesc->fwdPortMask==0)
+			{
+				/*remove from the old descriptor chain*/
+				MC_LIST_REMOVE(curDesc, next);
+				/*return to the free descriptor chain*/
+				_rtl865x_freeMCastFwdDesc(curDesc);
+
+			}
+
+			return SUCCESS;
+		}
+	}
+
+	/*never reach here*/
+	return SUCCESS;
+}
+
+#endif
+
+#if defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+int32 rtl865x_multicastUpdate(rtl865x_mcast_fwd_descriptor_t* desc)
+{
+	uint32 index;
+	//uint32 oldDescPortMask,newDescPortMask;/*for device decriptor forwarding usage*/
+	uint32 oldAsicFwdPortMask,newAsicFwdPortMask;/*for physical port forwarding usage*/
+	uint32 oldCpuFlag,newCpuFlag;
+
+	rtl865x_mcast_fwd_descriptor_t newFwdDesc;
+	rtl865x_tblDrv_mCast_t	*mCastEntry,*nextMCastEntry;
+	//printk("[%s:%d]\n",__FUNCTION__,__LINE__);
+	if(desc==NULL)
+	{
+		//printk("[%s:%d]failed\n",__FUNCTION__,__LINE__);
+		return FAILED;
+	}
+	/*check device name's validity*/
+	if(strlen(desc->netifName)==0)
+	{
+		//printk("[%s:%d]failed\n",__FUNCTION__,__LINE__);
+		return FAILED;
+	}
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if(memcmp(desc->netifName,RTL_BR_NAME,3)==0 || memcmp(desc->devName,RTL_BR1_NAME,3)==0)
+#else
+	if(memcmp(desc->netifName,RTL_BR_NAME,3)==0)
+#endif
+	{
+		for (index=0; index< RTL8651_MULTICASTTBL_SIZE; index++)
+		{
+			for (mCastEntry = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[index]); mCastEntry; mCastEntry = nextMCastEntry)
+			{
+				nextMCastEntry=TAILQ_NEXT(mCastEntry, nextMCast);
+				//printk("[%s:%d]hw dip is:0x%x,cur dip is 0x%x\n",__FUNCTION__,__LINE__,mCastEntry->dip,desc->dip);
+				if (mCastEntry->dip != desc->dip)
+				{
+					continue;
+				}
+				memset(&newFwdDesc, 0 ,sizeof(rtl865x_mcast_fwd_descriptor_t));
+				strcpy(newFwdDesc.netifName,desc->netifName);
+
+				/*save old multicast entry forward port mask*/
+				oldAsicFwdPortMask=mCastEntry->mbr;
+				oldCpuFlag=mCastEntry->cpu;
+
+				/*sync with control plane*/
+				newFwdDesc.fwdPortMask=desc->fwdPortMask & (~(1<<mCastEntry->port));
+				newFwdDesc.toCpu=desc->toCpu;
+
+				/*update/replace old forward descriptor*/
+
+				_rtl865x_mergeMCastFwdDescChain(&mCastEntry->fwdDescChain,&newFwdDesc);
+				mCastEntry->mbr 	= rtl865x_genMCastEntryAsicFwdMask(mCastEntry);
+				mCastEntry->cpu 	= rtl865x_genMCastEntryCpuFlag(mCastEntry);
+
+				newAsicFwdPortMask	= mCastEntry->mbr ;
+				newCpuFlag			=mCastEntry->cpu;
+				/*printk("[%s:%d]old fwPortMask is %d,newfwPortMask is %d\n",
+					   __FUNCTION__,
+					   __LINE__,
+					   oldAsicFwdPortMask,
+					   newAsicFwdPortMask);*/
+#ifndef RTL8651_MCAST_ALWAYS2UPSTREAM
+				if (mCastEntry->flag & RTL865X_MULTICAST_UPLOADONLY)
+				{	/* remove upload term*/
+					if((newAsicFwdPortMask!=0) && (newAsicFwdPortMask!=oldAsicFwdPortMask))
+					{
+						mCastEntry->flag &= ~RTL865X_MULTICAST_UPLOADONLY;
+						/* we assume multicast member will NEVER in External interface, so we remove
+								 external ip now */
+						mCastEntry->flag &= ~RTL865X_MULTICAST_EXTIP_SET;
+						mCastEntry->extIp= 0;
+					}
+				}
+#endif /* RTL8651_MCAST_ALWAYS2UPSTREAM */
+
+				mCastEntry->unKnownMCast=FALSE;
+
+				if((oldCpuFlag != newCpuFlag)||(newAsicFwdPortMask!=oldAsicFwdPortMask))
+				{
+					_rtl865x_patchPppoeWeak(mCastEntry);
+
+					/*reset inAsic flag to re-select or re-write this hardware asic entry*/
+					if(newAsicFwdPortMask==0)
+					{
+						_rtl865x_freeMCastEntry(mCastEntry, index);
+					}
+
+					_rtl865x_arrangeMulticast(index);
+				}
+			}
+
+		}
+	}
+	return SUCCESS;
+}
+#endif
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+extern struct net_bridge* bridge0;
+extern unsigned int rtl865x_getPhyFwdPortMask(struct net_bridge *br,unsigned int brFwdPortMask);
+#endif
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+extern int rtl_get_brIgmpModuleIndexbyId(int idx,char *name);
+#endif
+
+static int32 rtl865x_multicastCallbackFn(void *param)
+{
+#if defined (CONFIG_RTL_IGMP_SNOOPING)
+	uint32 index;
+#if !defined(CONFIG_RTL_MULTI_LAN_DEV)
+	uint32 oldDescPortMask=0,newDescPortMask=0;/*for device decriptor forwarding usage*/
+#endif
+	uint32 oldAsicFwdPortMask=0,newAsicFwdPortMask=0;/*for physical port forwarding usage*/
+	uint32 oldCpuFlag=0,newCpuFlag=0;
+
+	rtl_multicastEventContext_t mcastEventContext;
+
+	rtl865x_mcast_fwd_descriptor_t newFwdDesc;
+	struct rtl_multicastDataInfo multicastDataInfo;
+	struct rtl_multicastFwdInfo multicastFwdInfo;
+	rtl865x_tblDrv_mCast_t  *mCastEntry,*nextMCastEntry;
+#if !defined(CONFIG_RTL_MULTI_LAN_DEV) && !defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+	struct rtl_multicastDeviceInfo_s bridgeMCastDev;
+#endif
+
+#if defined (CONFIG_RT_MULTIPLE_BR_SUPPORT)
+unsigned char br_name[16]={0};
+int br_index;
+
+#if defined (CONFIG_RTL_MULTI_LAN_DEV)
+	struct net_bridge* br_dev;
+#else
+	unsigned int br_moduleIndex = 0xFFFFFFFF;
+#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+	unsigned int currentCpuFlag = 0;
+#endif
+#endif
+#endif
+
+
+#if 0//defined(CONFIG_RTL_ISP_MULTIPLE_BR_SUPPORT) && defined(CONFIG_RTL_MULTI_LAN_DEV)
+//need to check, some are used only for CONFIG_RTL_MULTI_LAN_DEV
+	struct net_bridge* br_dev;
+	int  br_indextmp;
+	int br_moduleIndex = 0xFFFFFFFF;
+	unsigned char br_name[16]={0};
+	unsigned int fwdPortMask_tmp = 0xFFFFFFFF;
+	unsigned int cpuTrueNum = 0, bridgeNum = 0;
+	unsigned int joinBridgeNum = 0;
+#endif
+	struct rtl_groupInfo groupInfo;
+	int32 retVal=FAILED;
+
+	if(param==NULL)
+	{
+		return EVENT_CONTINUE_EXECUTE;
+	}
+	memcpy(&mcastEventContext,param,sizeof(rtl_multicastEventContext_t));
+	/*check device name's validity*/
+	if(strlen(mcastEventContext.devName)==0)
+	{
+		return EVENT_CONTINUE_EXECUTE;
+	}
+	#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+	printk("%s:%d,mcastEventContext.devName is %s,moduleindex:%x, mcastEventContext.groupAddr is 0x%x,mcastEventContext.sourceAdd is 0x%x,mcastEventContext.portMask is 0x%x\n",__FUNCTION__,__LINE__,mcastEventContext.devName, mcastEventContext.moduleIndex,mcastEventContext.groupAddr[0], mcastEventContext.sourceAddr[0], mcastEventContext.portMask);
+	#endif
+
+#if defined (CONFIG_RTL_MULTI_LAN_DEV)
+#if defined (CONFIG_RT_MULTIPLE_BR_SUPPORT)
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,2)==0)
+#else
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,3)==0)
+#endif
+	{
+		#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+		printk("%s:%d,multicast event from %s,mcastEventContext.groupAddr[0] is 0x%x\n",__FUNCTION__,__LINE__,mcastEventContext.devName,mcastEventContext.groupAddr[0]);
+		#endif
+
+		for (index=0; index< RTL8651_MULTICASTTBL_SIZE; index++)
+		{
+			for (mCastEntry = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[index]); mCastEntry; mCastEntry = nextMCastEntry)
+			{
+				nextMCastEntry=TAILQ_NEXT(mCastEntry, nextMCast);
+
+				if ((mcastEventContext.groupAddr!=0) && (mCastEntry->dip != mcastEventContext.groupAddr[0]))
+				{
+					continue;
+				}
+
+				memset(&newFwdDesc, 0 ,sizeof(rtl865x_mcast_fwd_descriptor_t));
+				strcpy(newFwdDesc.netifName,mcastEventContext.devName);
+
+				/*save old multicast entry forward port mask*/
+				oldAsicFwdPortMask=mCastEntry->mbr;
+				oldCpuFlag=mCastEntry->cpu;
+
+				/*sync with control plane*/
+				multicastDataInfo.ipVersion=4;
+				multicastDataInfo.sourceIp[0]=  mCastEntry->sip;
+				multicastDataInfo.groupAddr[0]= mCastEntry->dip;
+
+				#if 0
+				//#if defined (CONFIG_RTL_ISP_MULTIPLE_BR_SUPPORT)
+				for(br_index = 0; br_index<RTL_IMGP_MAX_BRMODULE; br_index++)
+				{
+					br_dev = rtl_get_brByIndex(br_index, br_name);
+					if(br_dev)
+					{
+						bridgeNum ++;
+						br_moduleIndex = rtl_get_brIgmpModuleIndexbyName(br_name,&br_indextmp);//br_indextmep should be equal to br_index
+						retVal= rtl_getMulticastDataFwdInfo(br_moduleIndex, &multicastDataInfo, &multicastFwdInfo);
+						if (multicastFwdInfo.unknownMCast == TRUE)
+							cpuTrueNum ++;
+						fwdPortMask_tmp = rtl865x_getPhyFwdPortMask(br_dev,multicastFwdInfo.fwdPortMask);
+						newFwdDesc.fwdPortMask |= fwdPortMask_tmp;
+						#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+						printk("dev:%s, multicastFwdInfo.fwdPortMask:%x, fwdPortMask_tmp:%x, in_port:%x, newFwdPortMask:%x, [%s:%d]\n",
+							br_name, multicastFwdInfo.fwdPortMask, fwdPortMask_tmp, mCastEntry->port, newFwdDesc.fwdPortMask, __FUNCTION__, __LINE__);
+						#endif
+					}
+					newFwdDesc.fwdPortMask &= (~(1<<mCastEntry->port));
+				}
+				if(bridgeNum == cpuTrueNum)
+					multicastFwdInfo.cpuFlag = TRUE;
+
+				#else
+				retVal= rtl_getMulticastDataFwdInfo(mcastEventContext.moduleIndex, &multicastDataInfo, &multicastFwdInfo);
+
+				/*fix jwj*/
+				if (multicastFwdInfo.unknownMCast == TRUE)
+					multicastFwdInfo.cpuFlag = TRUE;
+
+				if(retVal !=0)
+				{
+					multicastFwdInfo.fwdPortMask=0;
+					multicastFwdInfo.cpuFlag = TRUE;
+				}
+				#endif
+
+				#if defined CONFIG_RT_MULTIPLE_BR_SUPPORT
+				br_dev = NULL;
+				for(br_index = 0; br_index<RTL_IMGP_MAX_BRMODULE; br_index++)
+				{
+					br_dev = rtl_get_brByIndex(br_index, br_name);
+					if(strcmp(br_name, mcastEventContext.devName)==0)
+						break;
+				}
+				if(br_dev==NULL)
+					continue;
+
+				#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+				if(hwwifiEnable)
+				{
+					newFwdDesc.fwdPortMask=rtl865x_getPhyFwdPortMask(br_dev,multicastFwdInfo.fwdPortMask) & (~(1<<mCastEntry->port));
+					if(retVal == SUCCESS)
+					{
+						if(multicastFwdInfo.cpuFlag == TRUE)
+						{
+							//wifi entry exist
+							newFwdDesc.fwdPortMask |= (0x01<<6);
+						}
+					}
+				}
+				else
+				{
+					newFwdDesc.fwdPortMask=rtl865x_getPhyFwdPortMask(br_dev,multicastFwdInfo.fwdPortMask) & (~(1<<mCastEntry->port));
+				}
+				#else
+				newFwdDesc.fwdPortMask=rtl865x_getPhyFwdPortMask(br_dev,multicastFwdInfo.fwdPortMask) & (~(1<<mCastEntry->port));
+				#endif
+				#else
+
+				#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+				if(hwwifiEnable)
+				{
+
+					newFwdDesc.fwdPortMask=rtl865x_getPhyFwdPortMask(bridge0,multicastFwdInfo.fwdPortMask) & (~(1<<mCastEntry->port));
+					if(retVal == SUCCESS)
+					{
+						if(multicastFwdInfo.cpuFlag == TRUE)
+						{
+							//wifi entry exist
+							newFwdDesc.fwdPortMask |= (0x01<<6);
+						}
+					}
+
+				}
+				else
+				{
+					newFwdDesc.fwdPortMask=rtl865x_getPhyFwdPortMask(bridge0,multicastFwdInfo.fwdPortMask) & (~(1<<mCastEntry->port));
+				}
+				#else
+				newFwdDesc.fwdPortMask=rtl865x_getPhyFwdPortMask(bridge0,multicastFwdInfo.fwdPortMask) & (~(1<<mCastEntry->port));
+				#endif
+				#endif
+
+				newFwdDesc.toCpu=multicastFwdInfo.cpuFlag;
+		#if defined	CONFIG_RTL865X_MUTLICAST_DEBUG
+				panic_printk("newFwdDesc.tocpu %d, newFwdDesc.fwdPortMask:%x,[%s:%d]\n", multicastFwdInfo.cpuFlag, newFwdDesc.fwdPortMask, __FUNCTION__, __LINE__);
+		#endif
+				/*update/replace old forward descriptor*/
+				_rtl865x_mergeMCastFwdDescChain(&mCastEntry->fwdDescChain,&newFwdDesc);
+
+				/*tocpu flag=1, DescFwdMask will be ignored, to cpu flag*/
+			#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+				if(hwwifiEnable)
+				{
+					mCastEntry->mbr  	= rtl865x_genMCastEntryAsicFwdMaskIgnoreCpuFlag(mCastEntry);
+				}
+				else
+				{
+					mCastEntry->mbr 		= rtl865x_genMCastEntryAsicFwdMask(mCastEntry);
+				}
+			#else
+				mCastEntry->mbr 		= rtl865x_genMCastEntryAsicFwdMask(mCastEntry);
+			#endif
+				mCastEntry->cpu		= rtl865x_genMCastEntryCpuFlag(mCastEntry);
+				newAsicFwdPortMask	= mCastEntry->mbr ;
+				newCpuFlag			=mCastEntry->cpu;
+
+				#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+				printk("%s:%d,oldAsicFwdPortMask is %d,newAsicFwdPortMask is %d\n",__FUNCTION__,__LINE__,oldAsicFwdPortMask,newAsicFwdPortMask);
+				#endif
+
+#ifndef RTL8651_MCAST_ALWAYS2UPSTREAM
+				if (mCastEntry->flag & RTL865X_MULTICAST_UPLOADONLY)
+				{	/* remove upload term*/
+					if((newAsicFwdPortMask!=0) && (newAsicFwdPortMask!=oldAsicFwdPortMask))
+					{
+						mCastEntry->flag &= ~RTL865X_MULTICAST_UPLOADONLY;
+						/* we assume multicast member will NEVER in External interface, so we remove
+						     external ip now */
+						mCastEntry->flag &= ~RTL865X_MULTICAST_EXTIP_SET;
+						mCastEntry->extIp= 0;
+					}
+				}
+#endif /* RTL8651_MCAST_ALWAYS2UPSTREAM */
+
+				rtl_getGroupInfo(mCastEntry->dip, &groupInfo);
+				if(groupInfo.ownerMask==0)
+				{
+					mCastEntry->unKnownMCast=TRUE;
+				}
+				else
+				{
+					mCastEntry->unKnownMCast=FALSE;
+				}
+#if defined CONFIG_RTL865X_MUTLICAST_DEBUG
+				printk("old FwdPortMask:%x, newAsicFwdPortMask:%x, [%s:%d]\n", oldAsicFwdPortMask, newAsicFwdPortMask, __FUNCTION__, __LINE__);
+#endif
+
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+				newAsicFwdPortMask &= (mCastEntry->mapPortMbr |(0x01<<6));
+#endif
+
+#if defined(CONFIG_RTL_HW_MCAST_WIFI)
+				if(hwwifiEnable)
+				{
+					if(((newAsicFwdPortMask)&(~(1<<6)))==0)
+						newAsicFwdPortMask =0;
+				}
+#endif
+
+#if defined CONFIG_RTL865X_MUTLICAST_DEBUG
+				printk("old FwdPortMask:%x, newAsicFwdPortMask:%x, [%s:%d]\n", oldAsicFwdPortMask, newAsicFwdPortMask, __FUNCTION__, __LINE__);
+#endif
+				if((oldCpuFlag != newCpuFlag)||(newAsicFwdPortMask!=oldAsicFwdPortMask))
+				{
+					_rtl865x_patchPppoeWeak(mCastEntry);
+
+					/*reset inAsic flag to re-select or re-write this hardware asic entry*/
+					if(newAsicFwdPortMask==0)
+					{
+						_rtl865x_freeMCastEntry(mCastEntry, index);
+					}
+
+					_rtl865x_arrangeMulticast(index);
+				}
+			}
+
+
+
+		}
+	}
+
+#else  //CONFIG_RTL_MULTI_LAN_DEV
+	/*case 1:this is multicast event from bridge */
+	/*sync wlan and ethernet*/
+	//hyking:[Fix me] the RTL_BR_NAME...
+#if defined(CONFIG_OPENWRT_SDK)
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,6)==0 || memcmp(mcastEventContext.devName,RTL_BR1_NAME,3)==0)
+#else
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,6)==0)
+#endif
+#else
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,3)==0 || memcmp(mcastEventContext.devName,RTL_BR1_NAME,3)==0)
+#elif defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,2)==0)
+#else
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,3)==0)
+#endif
+#endif
+	{
+
+		for (index=0; index< RTL8651_MULTICASTTBL_SIZE; index++)
+		{
+			for (mCastEntry = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[index]); mCastEntry; mCastEntry = nextMCastEntry)
+			{
+				nextMCastEntry=TAILQ_NEXT(mCastEntry, nextMCast);
+
+				if ((mcastEventContext.groupAddr!=0) && (mCastEntry->dip != mcastEventContext.groupAddr[0]))
+				{
+					continue;
+				}
+
+				rtl_getGroupInfo(mCastEntry->dip, &groupInfo);
+				if(groupInfo.ownerMask==0)
+				{
+					mCastEntry->unKnownMCast=TRUE;
+				}
+				else
+				{
+					mCastEntry->unKnownMCast=FALSE;
+				}
+
+				oldDescPortMask=rtl865x_getMCastEntryDescPortMask( mCastEntry);
+
+		#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+				if(hwwifiEnable)
+				{
+					oldAsicFwdPortMask=mCastEntry->mbr;
+					oldCpuFlag = mCastEntry->cpu;
+				}
+		#endif
+
+		#if defined CONFIG_RT_MULTIPLE_BR_SUPPORT
+				newDescPortMask = 0;
+				newCpuFlag = 0;
+		#if defined CONFIG_RTL_HW_MCAST_WIFI
+				currentCpuFlag = 0;
+		#endif
+				for(br_index = 0; br_index<RTL_IMGP_MAX_BRMODULE; br_index++)
+				{
+					br_moduleIndex=rtl_get_brIgmpModuleIndexbyId(br_index,br_name);
+					if(br_moduleIndex==0xFFFFFFFF)
+						continue;
+
+					/*sync with control plane*/
+					memset(&newFwdDesc, 0 ,sizeof(rtl865x_mcast_fwd_descriptor_t));
+					strcpy(newFwdDesc.netifName,br_name);
+
+					multicastDataInfo.ipVersion=4;
+					multicastDataInfo.sourceIp[0]=	mCastEntry->sip;
+					multicastDataInfo.groupAddr[0]= mCastEntry->dip;
+
+
+					retVal= rtl_getMulticastDataFwdInfo(br_moduleIndex, &multicastDataInfo, &multicastFwdInfo);
+
+				#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+					if(hwwifiEnable)
+					{
+						if(retVal != SUCCESS)
+						{
+							if(multicastFwdInfo.unknownMCast == 1)
+								multicastFwdInfo.cpuFlag = 0;
+							else
+								multicastFwdInfo.cpuFlag = 1;
+						}
+
+						currentCpuFlag = multicastFwdInfo.cpuFlag;
+
+						if(currentCpuFlag)
+							newAsicFwdPortMask = (1<<RTL8651_MAC_NUMBER); //cpu port
+						else
+							newAsicFwdPortMask = 0;
+
+						newFwdDesc.fwdPortMask = newAsicFwdPortMask;
+						newFwdDesc.toCpu = currentCpuFlag;
+					#if defined CONFIG_RTL865X_MUTLICAST_DEBUG
+						printk("newFwdDesc.fwdPortMask = %x, newFwdDesc.toCpu = %d, [%s:%d]\n", newFwdDesc.fwdPortMask, newFwdDesc.toCpu, __FUNCTION__, __LINE__);
+					#endif
+						_rtl865x_mergeMCastFwdDescChain(&mCastEntry->fwdDescChain,&newFwdDesc);
+					}
+				#endif
+
+					if(retVal == SUCCESS)
+					{
+						newCpuFlag |= multicastFwdInfo.cpuFlag;
+					}
+
+				}
+				//printk("br:%s :oldAsicPortMask:%x,newAsicPortMask:%x,oldCpuFlag:%d,newCpuFlag:%d,[%s]:[%d].\n",devName,oldAsicPortMask,newAsicPortMask,oldCpuFlag,newCpuFlag,__FUNCTION__,__LINE__);
+
+				#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+				if(hwwifiEnable)
+				{
+
+					mCastEntry->mbr 		= rtl865x_genMCastEntryAsicFwdMask(mCastEntry);
+					mCastEntry->cpu 	= rtl865x_genMCastEntryCpuFlag(mCastEntry);
+					newAsicFwdPortMask =mCastEntry->mbr;
+					newCpuFlag=mCastEntry->cpu;
+					if(mCastEntry->unKnownMCast==TRUE)
+					{
+						newAsicFwdPortMask = 0;
+						newCpuFlag = 0;
+					}
+
+					if(((newAsicFwdPortMask) & (~(1<<6)))==0)
+					{
+						//only cpu port
+						newAsicFwdPortMask = 0;
+					}
+
+					if((oldCpuFlag != newCpuFlag)||(newAsicFwdPortMask!=oldAsicFwdPortMask))
+					{
+						if(newAsicFwdPortMask == 0){
+							//printk("[%s]:[%d].\n",__FUNCTION__,__LINE__);
+							_rtl865x_freeMCastEntry(mCastEntry, index);
+						}
+
+						_rtl865x_arrangeMulticast(index);
+					}
+				}
+				else
+				{
+					if(mCastEntry->unKnownMCast==TRUE)
+						newCpuFlag = 1;
+
+					if(oldCpuFlag != newCpuFlag)
+					{
+						_rtl865x_freeMCastEntry(mCastEntry, index);
+						_rtl865x_arrangeMulticast(index);
+					}
+				}
+				#else
+				if(mCastEntry->unKnownMCast==TRUE)
+					newCpuFlag = 1;
+				if(oldCpuFlag != newCpuFlag)
+				{
+					_rtl865x_freeMCastEntry(mCastEntry, index);
+					_rtl865x_arrangeMulticast(index);
+				}
+
+				#endif
+		#else  //CONFIG_RT_MULTIPLE_BR_SUPPORT
+
+				/*sync with control plane*/
+				memset(&newFwdDesc, 0 ,sizeof(rtl865x_mcast_fwd_descriptor_t));
+				strcpy(newFwdDesc.netifName,mcastEventContext.devName);
+				multicastDataInfo.ipVersion=4;
+				multicastDataInfo.sourceIp[0]=  mCastEntry->sip;
+				multicastDataInfo.groupAddr[0]= mCastEntry->dip;
+				retVal= rtl_getMulticastDataFwdInfo(mcastEventContext.moduleIndex, &multicastDataInfo, &multicastFwdInfo);
+
+			#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+				if(hwwifiEnable)
+				{
+					if(retVal==SUCCESS)
+					{
+						newCpuFlag = multicastFwdInfo.cpuFlag;
+
+						if(newCpuFlag)
+							newAsicFwdPortMask = (1<<RTL8651_MAC_NUMBER);
+						else
+							newAsicFwdPortMask = 0;
+
+					}
+					else
+					{
+						newAsicFwdPortMask=0;
+						newCpuFlag =1;
+					}
+					//this fwdDesc is used to set cpu port, here to update br fwdDesc
+					newFwdDesc.fwdPortMask = newAsicFwdPortMask;
+					newFwdDesc.toCpu = newCpuFlag;
+
+					//printk("br:%s :oldAsicPortMask:%x,newAsicPortMask:%x,oldCpuFlag:%d,newCpuFlag:%d,[%s]:[%d].\n",mcastEventContext.devName,oldAsicPortMask,newAsicPortMask,oldCpuFlag,newCpuFlag,__FUNCTION__,__LINE__);
+					_rtl865x_mergeMCastFwdDescChain(&mCastEntry->fwdDescChain,&newFwdDesc);
+					mCastEntry->mbr 		= rtl865x_genMCastEntryAsicFwdMask(mCastEntry);
+					mCastEntry->cpu		= rtl865x_genMCastEntryCpuFlag(mCastEntry);
+
+					newAsicFwdPortMask =mCastEntry->mbr;
+					newCpuFlag =mCastEntry->cpu;
+					//printk("br:%s :oldAsicPortMask:%x,newAsicPortMask:%x,oldCpuFlag:%d,newCpuFlag:%d,[%s]:[%d].\n",mcastEventContext.devName,oldAsicPortMask,newAsicPortMask,oldCpuFlag,newCpuFlag,__FUNCTION__,__LINE__);
+					//just cpu port not add hw entry
+					if((newAsicFwdPortMask&(~(1<<6)))==0){
+						newAsicFwdPortMask =0;
+					}
+					if((oldCpuFlag != newCpuFlag)||(newAsicFwdPortMask!=oldAsicFwdPortMask))
+					{
+						if(newAsicFwdPortMask == 0)
+							_rtl865x_freeMCastEntry(mCastEntry, index);
+						_rtl865x_arrangeMulticast(index);
+					}
+				}
+				else
+				{
+					if(retVal!=SUCCESS)
+					{
+						continue;
+					}
+
+					retVal= rtl_getIgmpSnoopingModuleDevInfo(mcastEventContext.moduleIndex, &bridgeMCastDev);
+					if(retVal!=SUCCESS)
+					{
+						continue;
+					}
+					newDescPortMask=multicastFwdInfo.fwdPortMask;
+					//shirley note:oldDescPortMask is always 0, the judge condision is equal to (newDescPortMask & bridgeMCastDev.swPortMask)!=0
+					if(	(oldDescPortMask != newDescPortMask) &&
+						(	((newDescPortMask & bridgeMCastDev.swPortMask)!=0) ||
+							(((oldDescPortMask & bridgeMCastDev.swPortMask) !=0) && ((newDescPortMask & bridgeMCastDev.swPortMask)==0)))	)
+					{
+						/*this multicast entry should be re-generated at linux protocol stack bridge level*/
+						_rtl865x_freeMCastEntry(mCastEntry, index);
+						_rtl865x_arrangeMulticast(index);
+					}
+				}
+			#else
+
+				if(retVal!=SUCCESS)
+				{
+					continue;
+				}
+
+				retVal= rtl_getIgmpSnoopingModuleDevInfo(mcastEventContext.moduleIndex, &bridgeMCastDev);
+				if(retVal!=SUCCESS)
+				{
+					continue;
+				}
+				newDescPortMask=multicastFwdInfo.fwdPortMask;
+				//shirley note:oldDescPortMask is always 0, the judge condision is equal to (newDescPortMask & bridgeMCastDev.swPortMask)!=0
+				if(	(oldDescPortMask != newDescPortMask) &&
+					(	((newDescPortMask & bridgeMCastDev.swPortMask)!=0) ||
+						(((oldDescPortMask & bridgeMCastDev.swPortMask) !=0) && ((newDescPortMask & bridgeMCastDev.swPortMask)==0)))	)
+				{
+					/*this multicast entry should be re-generated at linux protocol stack bridge level*/
+					_rtl865x_freeMCastEntry(mCastEntry, index);
+					_rtl865x_arrangeMulticast(index);
+				}
+			#endif
+		#endif
+			}
+		}
+
+		return EVENT_CONTINUE_EXECUTE;
+	}
+
+/*update ethernet forwarding port mask*/
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if(memcmp(mcastEventContext.devName,"eth*",4)==0 || memcmp(mcastEventContext.devName,RTL_PS_ETH_NAME_ETH2,4)==0)
+#else
+	if(memcmp(mcastEventContext.devName,"eth*",4)==0)
+#endif
+	{
+		#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+		printk("%s:%d,multicast event from %s,mcastEventContext.groupAddr[0] is 0x%x\n",__FUNCTION__,__LINE__,mcastEventContext.devName,mcastEventContext.groupAddr[0]);
+		#endif
+
+		for (index=0; index< RTL8651_MULTICASTTBL_SIZE; index++)
+		{
+			for (mCastEntry = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[index]); mCastEntry; mCastEntry = nextMCastEntry)
+			{
+				nextMCastEntry=TAILQ_NEXT(mCastEntry, nextMCast);
+
+				if ((mcastEventContext.groupAddr!=0) && (mCastEntry->dip != mcastEventContext.groupAddr[0]))
+				{
+					continue;
+				}
+
+				memset(&newFwdDesc, 0 ,sizeof(rtl865x_mcast_fwd_descriptor_t));
+				strcpy(newFwdDesc.netifName,mcastEventContext.devName);
+
+				/*save old multicast entry forward port mask*/
+				oldAsicFwdPortMask=mCastEntry->mbr;
+				oldCpuFlag=mCastEntry->cpu;
+
+				/*sync with control plane*/
+				multicastDataInfo.ipVersion=4;
+				multicastDataInfo.sourceIp[0]=  mCastEntry->sip;
+				multicastDataInfo.groupAddr[0]= mCastEntry->dip;
+
+				retVal= rtl_getMulticastDataFwdInfo(mcastEventContext.moduleIndex, &multicastDataInfo, &multicastFwdInfo);
+
+#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+				if(hwwifiEnable)
+				{
+					if(retVal != SUCCESS)
+					{
+						newFwdDesc.fwdPortMask=0;
+						newFwdDesc.toCpu =1;
+					}
+					else
+					{
+						newFwdDesc.fwdPortMask=multicastFwdInfo.fwdPortMask & (~(1<<mCastEntry->port));
+						newFwdDesc.toCpu=multicastFwdInfo.cpuFlag;
+					}
+				}
+				else
+#endif
+				{
+					/*fix jwj*/
+					if (multicastFwdInfo.unknownMCast == TRUE)
+						multicastFwdInfo.cpuFlag = TRUE;
+					newFwdDesc.fwdPortMask=multicastFwdInfo.fwdPortMask & (~(1<<mCastEntry->port));
+					newFwdDesc.toCpu=multicastFwdInfo.cpuFlag;
+				}
+				#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+					newFwdDesc.fwdPortMask &= mCastEntry->mapPortMbr;
+				#endif
+
+
+				/*update/replace old forward descriptor*/
+
+				_rtl865x_mergeMCastFwdDescChain(&mCastEntry->fwdDescChain,&newFwdDesc);
+				mCastEntry->mbr 		= rtl865x_genMCastEntryAsicFwdMask(mCastEntry);
+				mCastEntry->cpu		= rtl865x_genMCastEntryCpuFlag(mCastEntry);
+
+				newAsicFwdPortMask	= mCastEntry->mbr ;
+				newCpuFlag			=mCastEntry->cpu;
+
+#if defined (CONFIG_RTL_HW_MCAST_WIFI)
+				if(hwwifiEnable)
+				{
+					if((newAsicFwdPortMask&(~(1<<6)))==0)
+						newAsicFwdPortMask =0;
+				}
+#endif
+				#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+				printk("%s:%d,oldAsicFwdPortMask is %d,newAsicFwdPortMask is %d\n",__FUNCTION__,__LINE__,oldAsicFwdPortMask,newAsicFwdPortMask);
+				#endif
+
+#ifndef RTL8651_MCAST_ALWAYS2UPSTREAM
+				if (mCastEntry->flag & RTL865X_MULTICAST_UPLOADONLY)
+				{	/* remove upload term*/
+					if((newAsicFwdPortMask!=0) && (newAsicFwdPortMask!=oldAsicFwdPortMask))
+					{
+						mCastEntry->flag &= ~RTL865X_MULTICAST_UPLOADONLY;
+						/* we assume multicast member will NEVER in External interface, so we remove
+						     external ip now */
+						mCastEntry->flag &= ~RTL865X_MULTICAST_EXTIP_SET;
+						mCastEntry->extIp= 0;
+					}
+				}
+#endif /* RTL8651_MCAST_ALWAYS2UPSTREAM */
+
+				rtl_getGroupInfo(mCastEntry->dip, &groupInfo);
+				if(groupInfo.ownerMask==0)
+				{
+					mCastEntry->unKnownMCast=TRUE;
+				}
+				else
+				{
+					mCastEntry->unKnownMCast=FALSE;
+				}
+
+
+				if((oldCpuFlag != newCpuFlag)||(newAsicFwdPortMask!=oldAsicFwdPortMask))
+				{
+					_rtl865x_patchPppoeWeak(mCastEntry);
+
+					/*reset inAsic flag to re-select or re-write this hardware asic entry*/
+					if(newAsicFwdPortMask==0)
+					{
+						_rtl865x_freeMCastEntry(mCastEntry, index);
+					}
+
+					_rtl865x_arrangeMulticast(index);
+				}
+			}
+
+
+
+		}
+	}
+#endif
+#endif
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 _rtl865x_multicastUnRegisterEvent(void)
+{
+	rtl865x_event_Param_t eventParam;
+
+	eventParam.eventLayerId=DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_UPDATE_MCAST;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_multicastCallbackFn;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_multicastRegisterEvent(void)
+{
+	rtl865x_event_Param_t eventParam;
+
+	eventParam.eventLayerId=DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_UPDATE_MCAST;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_multicastCallbackFn;
+	rtl865x_registerEvent(&eventParam);
+
+	return SUCCESS;
+}
+
+#if defined CONFIG_RTL_L2_HW_MULTICAST_SUPPORT
+extern void ConvertMulticatIPtoMacAddr(__u32 group, unsigned char *gmac);
+extern int rtl_delFilterDatabaseEntryforMCast(unsigned char *mac);
+extern int rtl_addFilterDatabaseEntryforMCast(unsigned char *mac, unsigned int fwdPortMask);
+extern int nicIgmpModuleIndex;
+
+static int32 rtl865x_L2multicastCallbackFn(void *param)
+{
+	rtl_multicastEventContext_t mcastEventContext;
+	struct rtl_multicastDataInfo multicastDataInfo;
+	struct rtl_multicastFwdInfo multicastFwdInfo;
+	int32 retVal=FAILED, ret;
+	unsigned char mac[6]={0};
+
+	if(param==NULL)
+	{
+		return EVENT_CONTINUE_EXECUTE;
+	}
+	memcpy(&mcastEventContext,param,sizeof(rtl_multicastEventContext_t));
+
+	if(strlen(mcastEventContext.devName)==0)
+	{
+		return EVENT_CONTINUE_EXECUTE;
+	}
+
+	if(mcastEventContext.moduleIndex != nicIgmpModuleIndex)
+	{
+		//only deal with eth event.
+		return EVENT_CONTINUE_EXECUTE;
+	}
+
+	if(mcastEventContext.ipVersion != 4)
+	{
+		//only deal with eth event.
+		return EVENT_CONTINUE_EXECUTE;
+	}
+
+	multicastDataInfo.ipVersion=4;
+	//l2 multicast only support igmpv1 and igmpv2, sourceip is not meaningful
+	multicastDataInfo.sourceIp[0]=	mcastEventContext.sourceAddr[0];
+	multicastDataInfo.groupAddr[0]= mcastEventContext.groupAddr[0];
+	ConvertMulticatIPtoMacAddr(mcastEventContext.groupAddr[0], mac);
+	retVal= rtl_getMulticastDataFwdInfo(mcastEventContext.moduleIndex, &multicastDataInfo, &multicastFwdInfo);
+
+	if(retVal!=SUCCESS)
+	{
+		//need to delete l2 table entry
+		ret=rtl_delFilterDatabaseEntryforMCast(mac);
+		//printk("delFilter return:%d\n", ret);
+	}
+	else
+	{
+		//update l2 table entry
+		ret=rtl_addFilterDatabaseEntryforMCast(mac, multicastFwdInfo.fwdPortMask);
+		//printk("addFilter return:%d\n", ret);
+	}
+	return 0;
+}
+static int32 _rtl865x_L2multicastUnRegisterEvent(void)
+{
+	rtl865x_event_Param_t eventParam;
+
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_UPDATE_L2_MCAST;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_L2multicastCallbackFn;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_L2multicastRegisterEvent(void)
+{
+	rtl865x_event_Param_t eventParam;
+
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_UPDATE_L2_MCAST;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_L2multicastCallbackFn;
+	rtl865x_registerEvent(&eventParam);
+
+	return SUCCESS;
+}
+
+#endif
+void _rtl865x_timeUpdateMulticast(uint32 secPassed)
+{
+
+	rtl865x_tblDrv_mCast_t *mCast_t, *nextMCast_t;
+	uint32 entry;
+	uint32 needReArrange=FALSE;
+	uint32 hashLineCnt=0;
+	/* check to Aging and HW swapping */
+	for (entry=0; entry< RTL8651_MULTICASTTBL_SIZE; entry++) {
+		hashLineCnt=0;
+		needReArrange=FALSE;
+		mCast_t = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[entry]);
+		while (mCast_t) {
+			/*save the next entry first*/
+			nextMCast_t=TAILQ_NEXT(mCast_t, nextMCast);
+
+			if (mCast_t->inAsic == TRUE)
+			{
+				/* Entry is in the ASIC */
+				if (mCast_t->age <= secPassed)
+				{
+					if(mCast_t->mbr==0)
+					{
+						_rtl865x_freeMCastEntry(mCast_t, entry);
+						needReArrange=TRUE;
+					}
+					else
+					{
+						mCast_t->age = RTL865X_MULTICAST_TABLE_AGE;
+					}
+				}
+				else
+				{
+					mCast_t->age -= secPassed;
+				}
+			}
+			else
+			{
+				/* Entry is not in the ASIC */
+				if (mCast_t->age <= secPassed)
+				{ /* aging out */
+					_rtl865x_freeMCastEntry(mCast_t, entry);
+				}
+				else
+				{
+					mCast_t->age -= secPassed;
+				}
+			}
+
+			/*won't count multicast entry forwarded by cpu*/
+			if(mCast_t->cpu==0)
+			{
+
+				hashLineCnt++;
+				//printk("------------hashLineCnt:%d,[%s]:[%d].\n",hashLineCnt,__FUNCTION__,__LINE__);
+				if(hashLineCnt>=2)
+				{
+					needReArrange=TRUE;
+				}
+			}
+
+			//mCast_t->count = 0;
+			mCast_t = nextMCast_t;
+		}
+
+		if(needReArrange==TRUE)
+		{
+			//printk("------------entry:%d,hashLineCnt:%d,[%s]:[%d].\n",entry,hashLineCnt,__FUNCTION__,__LINE__);
+			_rtl865x_arrangeMulticast(entry);
+		}
+		mCast_t = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[entry]);
+
+		while (mCast_t) {
+			/*save the next entry first*/
+			nextMCast_t=TAILQ_NEXT(mCast_t, nextMCast);
+
+			if (mCast_t->inAsic == FALSE)
+				mCast_t->count=0;
+
+			mCast_t = nextMCast_t;
+		}
+
+	}
+}
+
+#if defined(__linux__) && defined(__KERNEL__)
+static void _rtl865x_mCastSysTimerExpired(unsigned long expireDada)
+{
+
+	_rtl865x_timeUpdateMulticast(1);
+	mod_timer(&rtl865x_mCastSysTimer, jiffies+HZ);
+
+}
+
+static void _rtl865x_initMCastSysTimer(void)
+{
+	rtl865x_mCastSysTimer.expires=jiffies+HZ;
+	setup_timer(&rtl865x_mCastSysTimer, _rtl865x_mCastSysTimerExpired,
+			(unsigned long)rtl865x_mCastSysTimer.expires);
+	add_timer(&rtl865x_mCastSysTimer);
+}
+
+static void _rtl865x_destroyMCastSysTimer(void)
+{
+	del_timer(&rtl865x_mCastSysTimer);
+}
+
+#endif
+
+/*
+@func int32	| rtl865x_initMulticast	|  Init hardware ip multicast module.
+@parm  rtl865x_mCastConfig_t *	| mCastConfigPtr	| Pointer of hardware multicast configuration.
+@rvalue SUCCESS	|Initialize successfully.
+@rvalue FAILED	|Initialize failed.
+*/
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static void _rtl8198C_initMCastv6SysTimer(void);
+#endif
+int32 rtl865x_initMulticast(rtl865x_mCastConfig_t * mCastConfigPtr)
+{
+	_rtl865x_multicastUnRegisterEvent();
+#if defined CONFIG_RTL_L2_HW_MULTICAST_SUPPORT
+	_rtl865x_L2multicastUnRegisterEvent();
+#endif
+	_rtl865x_initMCastEntryPool();
+	_rtl865x_initMCastFwdDescPool();
+	rtl865x_setMulticastExternalPortMask(0);
+	if(mCastConfigPtr!=NULL)
+	{
+		rtl865x_setMulticastExternalPortMask(mCastConfigPtr->externalPortMask);
+	}
+	#if defined(__linux__) && defined(__KERNEL__)
+	_rtl865x_initMCastSysTimer();
+	#endif
+#if defined CONFIG_RTL_L2_HW_MULTICAST_SUPPORT
+	rtl8651_setAsicOperationLayer(2);
+#else
+	rtl8651_setAsicOperationLayer(3);
+#endif
+	rtl8651_setAsicMulticastMTU(1522);
+#if defined CONFIG_RTL_L2_HW_MULTICAST_SUPPORT
+	rtl8651_setAsicMulticastEnable(FALSE);
+#else
+	rtl8651_setAsicMulticastEnable(TRUE);
+#endif
+	rtl865x_setAsicMulticastAging(TRUE);
+	_rtl865x_multicastRegisterEvent();
+#if defined CONFIG_RTL_L2_HW_MULTICAST_SUPPORT
+	_rtl865x_L2multicastRegisterEvent();
+#endif
+#if (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_MLD_SNOOPING)
+	rtl8198C_initMulticastv6();
+#endif
+	return SUCCESS;
+}
+
+/*
+@func int32	| rtl865x_reinitMulticast	|  Re-init hardware ip multicast module.
+@rvalue SUCCESS	|Re-initialize successfully.
+@rvalue FAILED	|Re-initialize failed.
+*/
+int32 rtl865x_reinitMulticast(void)
+{
+	_rtl865x_multicastUnRegisterEvent();
+#if defined CONFIG_RTL_L2_HW_MULTICAST_SUPPORT
+	_rtl865x_L2multicastUnRegisterEvent();
+#endif
+	/*delete all multicast entry*/
+	rtl8651_setAsicMulticastEnable(FALSE);
+	rtl865x_delMulticastEntry(0);
+
+	#if defined(__linux__) && defined(__KERNEL__)
+	_rtl865x_destroyMCastSysTimer();
+	_rtl865x_initMCastSysTimer();
+	#endif
+
+	/*regfster twice won't cause any side-effect,
+	because event management module will handle duplicate event issue*/
+	rtl8651_setAsicMulticastMTU(1522);
+#if !defined CONFIG_RTL_L2_HW_MULTICAST_SUPPORT
+	rtl8651_setAsicMulticastEnable(TRUE);
+#endif
+	rtl865x_setAsicMulticastAging(TRUE);
+	_rtl865x_multicastRegisterEvent();
+#if defined CONFIG_RTL_L2_HW_MULTICAST_SUPPORT
+	_rtl865x_L2multicastRegisterEvent();
+#endif
+#if 0//defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rtl8198C_reinitMulticastv6();
+#endif
+	return SUCCESS;
+}
+
+
+
+#ifdef CONFIG_PROC_FS
+extern int32 rtl8651_getAsicMulticastSpanningTreePortState(uint32 port, uint32 *portState);
+#ifdef CONFIG_RTL_PROC_NEW
+int32 rtl_dumpSwMulticastInfo(struct seq_file *s)
+{
+	uint32 mCastMtu=0;
+	uint32 mCastEnable=FALSE;
+	uint32 index;
+	int8 isInternal;
+	uint32 portStatus;
+	uint32 internalPortMask=0;
+	uint32 externalPortMask=0;
+	int32 ret=FAILED;
+
+	rtl865x_tblDrv_mCast_t *mCast_t, *nextMCast_t;
+	rtl865x_mcast_fwd_descriptor_t *curDesc,*nextDesc;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rtl8198c_tblDrv_mCastv6_t *mCastv6_t, *nextMCastv6_t;
+	rtl8198c_mcast_fwd_descriptor6_t *curDescv6, *nextDescv6;
+#endif
+	uint32 entry;
+	uint32 cnt;
+	seq_printf(s,"----------------------------------------------------\n");
+	seq_printf(s,"Asic Operation Layer :%d\n", rtl8651_getAsicOperationLayer());
+
+	ret=rtl8651_getAsicMulticastEnable(&mCastEnable);
+	if(ret==SUCCESS)
+	{
+		seq_printf(s,"Asic Multicast Table:%s\n", (mCastEnable==TRUE)?"Enable":"Disable");
+	}
+	else
+	{
+		seq_printf(s,"Read Asic Multicast Table Enable Bit Error\n");
+	}
+	ret=rtl8651_getAsicMulticastMTU(&mCastMtu);
+	if(ret==SUCCESS)
+	{
+		seq_printf(s,"Asic Multicast MTU:%d\n", mCastMtu);
+	}
+	else
+	{
+		seq_printf(s,"Read Asic Multicast MTU Error\n");
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	ret=rtl8198C_getAsicMulticastv6Enable(&mCastEnable);
+	if(ret==SUCCESS)
+	{
+		seq_printf(s,"Asic IPV6 Multicast Table:%s\n", (mCastEnable==TRUE)?"Enable":"Disable");
+	}
+	else
+	{
+		seq_printf(s,"Read Asic IPV6 Multicast Table Enable Bit Error\n");
+	}
+	ret=rtl8198C_getAsicMulticastv6MTU(&mCastMtu);
+	if(ret==SUCCESS)
+	{
+		seq_printf(s,"Asic IPV6 Multicast MTU:%d\n", mCastMtu);
+	}
+	else
+	{
+		seq_printf(s,"Read Asic IPV6 Multicast MTU Error\n");
+	}
+#endif
+	for (index=0; index<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; index++)
+	{
+		ret=rtl8651_getAsicMulticastPortInternal(index, &isInternal);
+		if(ret==SUCCESS)
+		{
+			if(isInternal==TRUE)
+			{
+				internalPortMask |= 1<<index;
+			}
+			else
+			{
+				externalPortMask |= 1<<index;
+			}
+		}
+
+	}
+
+	seq_printf(s,"Internal Port Mask:0x%x\nExternal Port Mask:0x%x\n", internalPortMask,externalPortMask);
+	seq_printf(s,"----------------------------------------------------\n");
+	seq_printf(s,"Multicast STP State:\n");
+	for (index=0; index<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; index++)
+	{
+		ret= rtl8651_getAsicMulticastSpanningTreePortState(index, &portStatus);
+		if(ret==SUCCESS)
+		{
+			seq_printf(s,"port[%d]:",index);
+			if(portStatus==RTL8651_PORTSTA_DISABLED)
+			{
+				seq_printf(s,"disabled\n");
+			}
+			else if(portStatus==RTL8651_PORTSTA_BLOCKING)
+			{
+				seq_printf(s,"blocking\n");
+			}
+			else if(portStatus==RTL8651_PORTSTA_LEARNING)
+			{
+				seq_printf(s,"learning\n");
+			}
+			else if(portStatus==RTL8651_PORTSTA_FORWARDING)
+			{
+				seq_printf(s,"forwarding\n");
+			}
+		}
+
+	}
+	seq_printf(s,"----------------------------------------------------\n");
+	seq_printf(s,"Software Multicast Table:\n");
+	/* check to Aging and HW swapping */
+	for (entry=0; entry< RTL8651_MULTICASTTBL_SIZE; entry++) {
+		#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(entry, WATCHDOG_NUM_OF_TIMES);
+		#endif
+		mCast_t = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[entry]);
+		while (mCast_t) {
+			/*save the next entry first*/
+			nextMCast_t=TAILQ_NEXT(mCast_t, nextMCast);
+			seq_printf(s,"\t[%2d]  dip:%d.%d.%d.%d, sip:%d.%d.%d.%d, mbr:0x%x, svid:%d, spa:%d, \n", entry,
+				mCast_t->dip>>24, (mCast_t->dip&0x00ff0000)>>16, (mCast_t->dip&0x0000ff00)>>8, (mCast_t->dip&0xff),
+				mCast_t->sip>>24, (mCast_t->sip&0x00ff0000)>>16, (mCast_t->sip&0x0000ff00)>>8, (mCast_t->sip&0xff),
+				mCast_t->mbr,mCast_t->svid, mCast_t->port);
+		#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+			seq_printf(s,"\t      extIP:0x%x,age:%d, cpu:%d, count:%d, inAsic:%d, (%s), portMappingMask:0x%x\n",
+				mCast_t->extIp,mCast_t->age, mCast_t->cpu,mCast_t->count,mCast_t->inAsic,mCast_t->unKnownMCast?"UnknownMCast":"KnownMCast", mCast_t->mapPortMbr);
+		#else
+			seq_printf(s,"\t      extIP:0x%x,age:%d, cpu:%d, count:%d, inAsic:%d, (%s)\n",
+				mCast_t->extIp,mCast_t->age, mCast_t->cpu,mCast_t->count,mCast_t->inAsic,mCast_t->unKnownMCast?"UnknownMCast":"KnownMCast");
+		#endif
+			cnt=0;
+			curDesc=MC_LIST_FIRST(&mCast_t->fwdDescChain);
+			while(curDesc)
+			{
+				nextDesc=MC_LIST_NEXT(curDesc, next );
+				seq_printf(s,"\t      netif(%s),descPortMask(0x%x),toCpu(%d),fwdPortMask(0x%x)\n",curDesc->netifName,curDesc->descPortMask,curDesc->toCpu,curDesc->fwdPortMask);
+				curDesc = nextDesc;
+			}
+
+			seq_printf(s,"\n");
+			mCast_t = nextMCast_t;
+		}
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	seq_printf(s,"----------------------------------------------------\n");
+	seq_printf(s,"IPV6 Software Multicast Table:\n");
+	for (entry=0; entry< RTL8651_MULTICASTTBL_SIZE; entry++) {
+		#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(entry, WATCHDOG_NUM_OF_TIMES);
+		#endif
+		mCastv6_t = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[entry]);
+		while (mCastv6_t) {
+			/*save the next entry first*/
+			nextMCastv6_t=TAILQ_NEXT(mCastv6_t, nextMCast);
+			seq_printf(s,"\t[%2d]  dip:%08x:%08x%08x:%08x\n\t      sip:%08x:%08x:%08x:%08x\n\t      mbr:0x%x, svid:%d, spa:%d, ",
+				entry,
+				mCastv6_t->dip.v6_addr32[0],mCastv6_t->dip.v6_addr32[1],
+				mCastv6_t->dip.v6_addr32[2],mCastv6_t->dip.v6_addr32[3],
+				mCastv6_t->sip.v6_addr32[0],mCastv6_t->sip.v6_addr32[1],
+				mCastv6_t->sip.v6_addr32[2],mCastv6_t->sip.v6_addr32[3],
+
+				mCastv6_t->mbr,
+				mCastv6_t->svid,
+				mCastv6_t->port);
+
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+			seq_printf(s,"age:%d, cpu:%d, count:%d, inAsic:%d, (%s), portMappingMask:0x%x\n",
+				mCastv6_t->age, mCastv6_t->cpu,mCastv6_t->count,mCastv6_t->inAsic,mCastv6_t->unKnownMCast?"UnknownMCast":"KnownMCast", mCastv6_t->mapPortMbr);
+#else
+			seq_printf(s,"age:%d, cpu:%d, count:%d, inAsic:%d, (%s)\n",
+				mCastv6_t->age, mCastv6_t->cpu,mCastv6_t->count,mCastv6_t->inAsic,mCastv6_t->unKnownMCast?"UnknownMCast":"KnownMCast");
+#endif
+			cnt=0;
+			curDescv6=MC_LIST_FIRST(&mCastv6_t->fwdDescChain);
+			while(curDescv6)
+			{
+				nextDescv6=MC_LIST_NEXT(curDescv6, next );
+				seq_printf(s,"\t      netif(%s),descPortMask(0x%x),toCpu(%d),fwdPortMask(0x%x)\n",curDescv6->netifName,curDescv6->descPortMask,curDescv6->toCpu,curDescv6->fwdPortMask);
+				curDescv6 = nextDescv6;
+			}
+
+			seq_printf(s,"\n");
+			mCastv6_t = nextMCastv6_t;
+		}
+
+	}
+#endif
+
+	return SUCCESS;
+}
+#else
+int32 rtl_dumpSwMulticastInfo(char *page, int *ret_len)
+{
+	int len = *ret_len;
+	uint32 mCastMtu=0;
+	uint32 mCastEnable=FALSE;
+	uint32 index;
+	int8 isInternal;
+	uint32 portStatus;
+	uint32 internalPortMask=0;
+	uint32 externalPortMask=0;
+	int32 ret=FAILED;
+
+	rtl865x_tblDrv_mCast_t *mCast_t, *nextMCast_t;
+	rtl865x_mcast_fwd_descriptor_t *curDesc,*nextDesc;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rtl8198c_tblDrv_mCastv6_t *mCastv6_t, *nextMCastv6_t;
+	rtl8198c_mcast_fwd_descriptor6_t *curDescv6, *nextDescv6;
+#endif
+	uint32 entry;
+	uint32 cnt;
+	len += sprintf(page+len, "----------------------------------------------------\n");
+	len += sprintf(page+len,"Asic Operation Layer :%d\n", rtl8651_getAsicOperationLayer());
+
+	ret=rtl8651_getAsicMulticastEnable(&mCastEnable);
+	if(ret==SUCCESS)
+	{
+		len += sprintf(page+len,"Asic Multicast Table:%s\n", (mCastEnable==TRUE)?"Enable":"Disable");
+	}
+	else
+	{
+		len += sprintf(page+len,"Read Asic Multicast Table Enable Bit Error\n");
+	}
+	ret=rtl8651_getAsicMulticastMTU(&mCastMtu);
+	if(ret==SUCCESS)
+	{
+		len += sprintf(page+len,"Asic Multicast MTU:%d\n", mCastMtu);
+	}
+	else
+	{
+		len += sprintf(page+len,"Read Asic Multicast MTU Error\n");
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	ret=rtl8198C_getAsicMulticastv6Enable(&mCastEnable);
+	if(ret==SUCCESS)
+	{
+		len += sprintf(page+len,"Asic IPV6 Multicast Table:%s\n", (mCastEnable==TRUE)?"Enable":"Disable");
+	}
+	else
+	{
+		len += sprintf(page+len,"Read Asic IPV6 Multicast Table Enable Bit Error\n");
+	}
+	ret=rtl8198C_getAsicMulticastv6MTU(&mCastMtu);
+	if(ret==SUCCESS)
+	{
+		len += sprintf(page+len,"Asic IPV6 Multicast MTU:%d\n", mCastMtu);
+	}
+	else
+	{
+		len += sprintf(page+len,"Read Asic IPV6 Multicast MTU Error\n");
+	}
+#endif
+	for (index=0; index<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; index++)
+	{
+		ret=rtl8651_getAsicMulticastPortInternal(index, &isInternal);
+		if(ret==SUCCESS)
+		{
+			if(isInternal==TRUE)
+			{
+				internalPortMask |= 1<<index;
+			}
+			else
+			{
+				externalPortMask |= 1<<index;
+			}
+		}
+
+	}
+
+	len += sprintf(page+len,"Internal Port Mask:0x%x\nExternal Port Mask:0x%x\n", internalPortMask,externalPortMask);
+	len += sprintf(page+len,"----------------------------------------------------\n");
+	len += sprintf(page+len,"Multicast STP State:\n");
+	for (index=0; index<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; index++)
+	{
+		ret= rtl8651_getAsicMulticastSpanningTreePortState(index, &portStatus);
+		if(ret==SUCCESS)
+		{
+			len += sprintf(page+len,"port[%d]:",index);
+			if(portStatus==RTL8651_PORTSTA_DISABLED)
+			{
+				len += sprintf(page+len,"disabled\n");
+			}
+			else if(portStatus==RTL8651_PORTSTA_BLOCKING)
+			{
+				len += sprintf(page+len,"blocking\n");
+			}
+			else if(portStatus==RTL8651_PORTSTA_LEARNING)
+			{
+				len += sprintf(page+len,"learning\n");
+			}
+			else if(portStatus==RTL8651_PORTSTA_FORWARDING)
+			{
+				len += sprintf(page+len,"forwarding\n");
+			}
+		}
+
+	}
+	len += sprintf(page+len,"----------------------------------------------------\n");
+	len += sprintf(page+len,"Software Multicast Table:\n");
+	/* check to Aging and HW swapping */
+	for (entry=0; entry< RTL8651_MULTICASTTBL_SIZE; entry++) {
+		#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(entry, WATCHDOG_NUM_OF_TIMES);
+		#endif
+		mCast_t = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[entry]);
+		while (mCast_t) {
+			/*save the next entry first*/
+			nextMCast_t=TAILQ_NEXT(mCast_t, nextMCast);
+			len += sprintf(page+len,"\t[%2d]  dip:%d.%d.%d.%d, sip:%d.%d.%d.%d, mbr:0x%x, svid:%d, spa:%d, \n", entry,
+				mCast_t->dip>>24, (mCast_t->dip&0x00ff0000)>>16, (mCast_t->dip&0x0000ff00)>>8, (mCast_t->dip&0xff),
+				mCast_t->sip>>24, (mCast_t->sip&0x00ff0000)>>16, (mCast_t->sip&0x0000ff00)>>8, (mCast_t->sip&0xff),
+				mCast_t->mbr,mCast_t->svid, mCast_t->port);
+
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+			len += sprintf(page+len,"\t	  extIP:0x%x,age:%d, cpu:%d, count:%d, inAsic:%d, (%s), portMappingMask:0x%x\n",
+				mCast_t->extIp,mCast_t->age, mCast_t->cpu,mCast_t->count,mCast_t->inAsic,mCast_t->unKnownMCast?"UnknownMCast":"KnownMCast", mCast_t->mapPortMbr);
+#else
+			len += sprintf(page+len,"\t      extIP:0x%x,age:%d, cpu:%d, count:%d, inAsic:%d, (%s)\n",
+				mCast_t->extIp,mCast_t->age, mCast_t->cpu,mCast_t->count,mCast_t->inAsic,mCast_t->unKnownMCast?"UnknownMCast":"KnownMCast");
+#endif
+			cnt=0;
+			curDesc=MC_LIST_FIRST(&mCast_t->fwdDescChain);
+			while(curDesc)
+			{
+				nextDesc=MC_LIST_NEXT(curDesc, next );
+				len += sprintf(page+len,"\t      netif(%s),descPortMask(0x%x),toCpu(%d),fwdPortMask(0x%x)\n",curDesc->netifName,curDesc->descPortMask,curDesc->toCpu,curDesc->fwdPortMask);
+				curDesc = nextDesc;
+			}
+
+			len += sprintf(page+len,"\n");
+			mCast_t = nextMCast_t;
+		}
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	len += sprintf(page+len,"----------------------------------------------------\n");
+	len += sprintf(page+len,"IPV6 Software Multicast Table:\n");
+	for (entry=0; entry< RTL8651_MULTICASTTBL_SIZE; entry++) {
+		#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(entry, WATCHDOG_NUM_OF_TIMES);
+		#endif
+		mCastv6_t = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[entry]);
+		while (mCastv6_t) {
+			/*save the next entry first*/
+			nextMCastv6_t=TAILQ_NEXT(mCastv6_t, nextMCast);
+			len += sprintf(page+len,"\t[%2d]  dip:%08x:%08x:%08x:%08x\n\t      sip:%08x:%08x:%08x:%08x\n\t      mbr:0x%x, svid:%d, spa:%d, ",
+				entry,
+				mCastv6_t->dip.v6_addr32[0],mCastv6_t->dip.v6_addr32[1],
+				mCastv6_t->dip.v6_addr32[2],mCastv6_t->dip.v6_addr32[3],
+				mCastv6_t->sip.v6_addr32[0],mCastv6_t->sip.v6_addr32[1],
+				mCastv6_t->sip.v6_addr32[2],mCastv6_t->sip.v6_addr32[3],
+				mCastv6_t->mbr,
+				mCastv6_t->svid,
+				mCastv6_t->port);
+		#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+			len += sprintf(page+len,"age:%d, cpu:%d, count:%d, inAsic:%d, (%s), portMappingMask:0x%x\n",
+				mCastv6_t->age, mCastv6_t->cpu,mCastv6_t->count,mCastv6_t->inAsic,mCastv6_t->unKnownMCast?"UnknownMCast":"KnownMCast", mCastv6_t->mapPortMbr);
+		#else
+			len += sprintf(page+len,"age:%d, cpu:%d, count:%d, inAsic:%d, (%s)\n",
+				mCastv6_t->age, mCastv6_t->cpu,mCastv6_t->count,mCastv6_t->inAsic,mCastv6_t->unKnownMCast?"UnknownMCast":"KnownMCast");
+		#endif
+			cnt=0;
+			curDescv6=MC_LIST_FIRST(&mCastv6_t->fwdDescChain);
+			while(curDescv6)
+			{
+				nextDescv6=MC_LIST_NEXT(curDescv6, next );
+				len += sprintf(page+len,"\t      netif(%s),descPortMask(0x%x),toCpu(%d),fwdPortMask(0x%x)\n",curDescv6->netifName,curDescv6->descPortMask,curDescv6->toCpu,curDescv6->fwdPortMask);
+				curDescv6 = nextDescv6;
+			}
+
+			len += sprintf(page+len,"\n");
+			mCastv6_t = nextMCastv6_t;
+		}
+
+	}
+#endif
+	*ret_len = len;
+	return SUCCESS;
+}
+#endif
+#endif
+
+int rtl865x_genVirtualMCastFwdDescriptor(unsigned int forceToCpu, uint32 fwdPortMask, rtl865x_mcast_fwd_descriptor_t *fwdDescriptor)
+{
+
+	if(fwdDescriptor==NULL)
+	{
+		return FAILED;
+	}
+
+	memset(fwdDescriptor, 0, sizeof(rtl865x_mcast_fwd_descriptor_t ));
+	fwdDescriptor->toCpu=forceToCpu;
+	fwdDescriptor->fwdPortMask=fwdPortMask;
+	return SUCCESS;
+
+}
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+int rtl865x_blockMulticastFlow(unsigned int srcVlanId, unsigned int srcPort,unsigned int srcIpAddr, unsigned int destIpAddr, unsigned int mapPortMask)
+#else
+int rtl865x_blockMulticastFlow(unsigned int srcVlanId, unsigned int srcPort,unsigned int srcIpAddr, unsigned int destIpAddr)
+#endif
+{
+	rtl865x_mcast_fwd_descriptor_t fwdDescriptor;
+	rtl865x_tblDrv_mCast_t * existMCastEntry=NULL;
+	existMCastEntry=rtl865x_findMCastEntry(destIpAddr, srcIpAddr, (uint16)srcVlanId, (uint16)srcPort);
+	if(existMCastEntry!=NULL)
+	{
+		if(existMCastEntry->mbr==0)
+		{
+			return SUCCESS;
+		}
+	}
+	memset(&fwdDescriptor, 0, sizeof(rtl865x_mcast_fwd_descriptor_t ));
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+	rtl865x_addMulticastEntry(destIpAddr, srcIpAddr, (unsigned short)srcVlanId, (unsigned short)srcPort, &fwdDescriptor, TRUE, 0, 0, 0, mapPortMask);
+#else
+	rtl865x_addMulticastEntry(destIpAddr, srcIpAddr, (unsigned short)srcVlanId, (unsigned short)srcPort, &fwdDescriptor, TRUE, 0, 0, 0);
+#endif
+	return SUCCESS;
+}
+
+/*
+@func int32	| rtl865x_flushHWMulticastEntry	|  API to delete all multicast
+forwarding entry
+@rvalue SUCCESS	|Delete hardware multicast forwarding entry successfully.
+@rvalue FAILED	|Delete hardware multicast forwarding entry failed.
+*/
+
+int32 rtl865x_flushHWMulticastEntry(void)
+{
+
+	rtl865x_tblDrv_mCast_t *mCastEntry, *nextMCastEntry;
+	uint32 entry;
+
+
+	for(entry=0; entry<RTL8651_MULTICASTTBL_SIZE; entry++)
+	{
+
+		mCastEntry = TAILQ_FIRST(&mCastTbl.inuseList.mCastTbl[entry]);
+		while (mCastEntry)
+		{
+			nextMCastEntry = TAILQ_NEXT(mCastEntry, nextMCast);
+			if(mCastEntry->dip)
+			{
+
+				_rtl865x_freeMCastEntry(mCastEntry, entry);
+				_rtl865x_arrangeMulticast(entry);
+			}
+
+			mCastEntry = nextMCastEntry;
+		}
+
+
+
+
+	}
+
+	return SUCCESS;
+}
+
+int rtl865x_getMCastHashMethod(unsigned int *hashMethod)
+{
+	return rtl865x_getAsicMCastHashMethod(hashMethod);
+}
+
+int rtl865x_setMCastHashMethod(unsigned int hashMethod)
+{
+	uint32 oldHashMethod = 0;
+	rtl865x_getAsicMCastHashMethod(&oldHashMethod);
+	hashMethod&=0x3;
+	if(hashMethod > 3)
+	{
+		return -1;
+	}
+	if(oldHashMethod != hashMethod)
+	{
+		rtl865x_setAsicMCastHashMethod(hashMethod);
+		/* exclude 0->1 and 1->0 */
+		if(!((hashMethod == HASH_METHOD_SIP_DIP0 && oldHashMethod == HASH_METHOD_SIP_DIP1) ||
+			(hashMethod == HASH_METHOD_SIP_DIP1 && oldHashMethod == HASH_METHOD_SIP_DIP0)))
+		{
+
+			rtl865x_flushHWMulticastEntry();
+		}
+	}
+	return 0;
+}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static int is_ip6_addr_equal(inv6_addr_t addr1,inv6_addr_t addr2)
+{
+	if(addr1.v6_addr32[0]==addr2.v6_addr32[0]&&
+	   addr1.v6_addr32[1]==addr2.v6_addr32[1]&&
+	   addr1.v6_addr32[2]==addr2.v6_addr32[2]&&
+	   addr1.v6_addr32[3]==addr2.v6_addr32[3])
+	   return 1;
+	else
+	   return 0;
+}
+static int32 _rtl8198C_initMCastv6EntryPool(void)
+{
+	int32 index;
+	rtl8198c_tblDrv_mCastv6_t *multiCast_t;
+	struct MCast6_hash_head *mCast6_hash_head;
+	
+	TBL_MEM_ALLOC(multiCast_t, rtl8198c_tblDrv_mCastv6_t ,MAX_MCASTV6_TABLE_ENTRY_CNT);
+	TAILQ_INIT(&mCastTbl6.freeList.freeMultiCast);
+	for(index=0; index<MAX_MCASTV6_TABLE_ENTRY_CNT; index++)
+	{
+		memset( &multiCast_t[index], 0, sizeof(rtl8198c_tblDrv_mCastv6_t));
+		TAILQ_INSERT_HEAD(&mCastTbl6.freeList.freeMultiCast, &multiCast_t[index], nextMCast);
+	}
+
+	TBL_MEM_ALLOC(mCast6_hash_head, struct MCast6_hash_head, RTL8651_MULTICASTTBL_SIZE);
+	memset(mCast6_hash_head, 0,RTL8651_MULTICASTTBL_SIZE* sizeof(struct MCast6_hash_head));
+	mCastTbl6.inuseList.mCastTbl = (void *)mCast6_hash_head;
+
+	for(index=0; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+		TAILQ_INIT(&mCastTbl6.inuseList.mCastTbl[index]);
+	}
+	return SUCCESS;
+}
+
+static int32 _rtl8198C_freeMCastv6FwdDesc(rtl8198c_mcast_fwd_descriptor6_t *descPtr)
+{
+	if(descPtr==NULL)
+	{
+		return SUCCESS;
+	}
+	memset(descPtr,0,sizeof(rtl8198c_mcast_fwd_descriptor6_t));
+	MC_LIST_INSERT_HEAD(&free_mcast_fwd_descriptor_head6, descPtr, next);
+
+	return SUCCESS;
+}
+
+
+static rtl8198c_mcast_fwd_descriptor6_t *_rtl8198C_allocMCastv6FwdDesc(void)
+{
+	rtl8198c_mcast_fwd_descriptor6_t *retDesc=NULL;
+	retDesc = MC_LIST_FIRST(&free_mcast_fwd_descriptor_head6);
+	if(retDesc!=NULL)
+	{
+		MC_LIST_REMOVE(retDesc, next);
+		memset(retDesc,0,sizeof(rtl8198c_mcast_fwd_descriptor6_t));
+	}
+	return retDesc;
+}
+
+static int32 _rtl8198C_mCastv6FwdDescEnqueue(mcast_fwd_descriptor_head6_t * queueHead,
+												rtl8198c_mcast_fwd_descriptor6_t * enqueueDesc)
+{
+	rtl8198c_mcast_fwd_descriptor6_t *newDesc;
+	rtl8198c_mcast_fwd_descriptor6_t *curDesc,*nextDesc;
+	if(queueHead==NULL)
+	{
+		return FAILED;
+	}
+
+	if(enqueueDesc==NULL)
+	{
+		return SUCCESS;
+	}
+
+	/*multicast forward descriptor is internal maintained,always alloc new one*/
+	newDesc=_rtl8198C_allocMCastv6FwdDesc();
+
+	if(newDesc!=NULL)
+	{
+		memcpy(newDesc, enqueueDesc,sizeof(rtl8198c_mcast_fwd_descriptor6_t));
+		memset(&(newDesc->next), 0, sizeof(MC_LIST_ENTRY(rtl8198c_mcast_fwd_descriptor6_t)));
+		newDesc->next.le_next=NULL;
+		newDesc->next.le_prev=NULL;
+	}
+	else
+	{
+		/*no enough memory*/
+		return FAILED;
+	}
+
+
+	for(curDesc=MC_LIST_FIRST(queueHead);curDesc!=NULL;curDesc=nextDesc)
+	{
+
+		nextDesc=MC_LIST_NEXT(curDesc, next);
+
+		/*merge two descriptor*/
+		if((strcmp(curDesc->netifName,newDesc->netifName)==0) && (curDesc->vid==newDesc->vid))
+		if(strcmp(curDesc->netifName,newDesc->netifName)==0)
+		{
+			if(newDesc->descPortMask==0)
+			{
+				newDesc->descPortMask=curDesc->descPortMask;
+			}
+			MC_LIST_REMOVE(curDesc, next);
+			_rtl8198C_freeMCastv6FwdDesc(curDesc);
+
+		}
+	}
+
+	/*not matched descriptor is found*/
+	MC_LIST_INSERT_HEAD(queueHead, newDesc, next);
+
+	return SUCCESS;
+
+}
+
+static int32 _rtl8198C_flushMCastv6FwdDescChain(mcast_fwd_descriptor_head6_t * descChainHead)
+{
+	rtl8198c_mcast_fwd_descriptor6_t * curDesc,*nextDesc;
+
+	if(descChainHead==NULL)
+	{
+		return SUCCESS;
+	}
+
+	curDesc=MC_LIST_FIRST(descChainHead);
+	while(curDesc)
+	{
+		nextDesc=MC_LIST_NEXT(curDesc, next );
+		/*remove from the old descriptor chain*/
+		MC_LIST_REMOVE(curDesc, next);
+		/*return to the free descriptor chain*/
+		_rtl8198C_freeMCastv6FwdDesc(curDesc);
+		curDesc = nextDesc;
+	}
+
+	return SUCCESS;
+}
+
+
+static int32 _rtl8198C_flushMCastv6Entry(rtl8198c_tblDrv_mCastv6_t *mCastEntry)
+{
+	if(mCastEntry==NULL)
+	{
+		return SUCCESS;
+	}
+
+	_rtl8198C_flushMCastv6FwdDescChain(&mCastEntry->fwdDescChain);
+
+	memset(mCastEntry, 0, sizeof(rtl8198c_tblDrv_mCastv6_t));
+	return SUCCESS;
+}
+
+
+static int32 _rtl8198C_freeMCastv6Entry(rtl8198c_tblDrv_mCastv6_t * mCastEntry, uint32 hashIndex)
+{
+	if(mCastEntry==NULL)
+	{
+		return SUCCESS;
+	}
+
+	TAILQ_REMOVE(&mCastTbl6.inuseList.mCastTbl[hashIndex], mCastEntry, nextMCast);
+	_rtl8198C_flushMCastv6Entry(mCastEntry);
+	TAILQ_INSERT_HEAD(&mCastTbl6.freeList.freeMultiCast, mCastEntry, nextMCast);
+	return SUCCESS;
+}
+
+
+static void _rtl8198C_arrangeMulticastv6(uint32 entryIndex)
+{
+	rtl8198C_tblAsicDrv_multiCastv6Param_t asic_mcast;
+	rtl8198c_tblDrv_mCastv6_t *mCast_t=NULL;
+	rtl8198c_tblDrv_mCastv6_t *select_t=NULL;
+	rtl8198c_tblDrv_mCastv6_t *swapOutEntry=NULL;
+	int32 retval;
+	int32 hashMethod=0;
+	rtl8198C_getMCastv6HashMethod(&hashMethod);
+	TAILQ_FOREACH(mCast_t, &mCastTbl6.inuseList.mCastTbl[entryIndex], nextMCast)
+	{
+		if ((mCast_t->cpu == 0) && !(mCast_t->flag & RTL865X_MULTICAST_PPPOEPATCH_CPUBIT))
+		{ /* Ignore cpu=1 */
+
+			if(mCast_t->inAsic==TRUE)
+			{
+				if(swapOutEntry==NULL)
+				{
+					swapOutEntry=mCast_t;
+				}
+				else
+				{
+					/*impossible, two flow in one asic entry*/
+					swapOutEntry->inAsic=FALSE;
+					mCast_t->inAsic = FALSE;
+				}
+			}
+
+			if (select_t)
+			{
+				if ((mCast_t->unKnownMCast==FALSE) && (select_t->unKnownMCast==TRUE))
+				{
+					/*replace unknown multicast*/
+					select_t = mCast_t;
+				}
+				else
+				{
+					/*select the heavy load*/
+					if ((mCast_t->count) > (select_t->count))
+					{
+						select_t = mCast_t;
+					}
+				}
+
+			}
+			else
+			{
+				select_t = mCast_t;
+			}
+
+
+		}
+		else
+		{
+			mCast_t->inAsic = FALSE;	/* reset "inAsic" bit */
+		}
+	}
+
+	if(select_t && swapOutEntry)
+	{
+		if ((swapOutEntry->unKnownMCast==FALSE) && (select_t->unKnownMCast==TRUE))
+		{
+			/*replace unknown multicast*/
+			select_t = swapOutEntry;
+		}
+		else
+		{
+			if((select_t->count <= (swapOutEntry->count+RTL865X_HW_MCAST_SWAP_GAP)))
+				select_t = swapOutEntry;
+		}
+	}
+
+	if (select_t)
+	{
+		if((swapOutEntry==NULL) ||(select_t==swapOutEntry))
+		{
+			select_t->age = RTL865X_MULTICAST_TABLE_ASIC_AGE;
+			bzero(&asic_mcast, sizeof(rtl8198C_tblAsicDrv_multiCastv6Param_t));
+//			memcpy(&asic_mcast, select_t, (uint32)&(((rtl8198c_tblDrv_mCastv6_t *)0)->six_rd_idx));
+			memcpy(&asic_mcast, select_t, sizeof(rtl8198C_tblAsicDrv_multiCastv6Param_t));
+
+			retval = rtl8198C_setAsicIpMulticastv6Table(hashMethod,&asic_mcast);
+
+#ifdef CONFIG_PROC_FS
+			mcastAddOpCnt6++;
+#endif
+			assert(retval == SUCCESS);
+			if(retval==SUCCESS)
+			{
+				select_t->inAsic = TRUE;
+			}
+			else
+			{
+				select_t->inAsic = FALSE;
+				rtl8198C_delAsicIpMulticastv6Table(entryIndex);
+#ifdef CONFIG_PROC_FS
+				mcastDelOpCnt6++;
+#endif
+			}
+
+			assert(retval == SUCCESS);
+			TAILQ_REMOVE(&mCastTbl6.inuseList.mCastTbl[entryIndex], select_t, nextMCast);
+			TAILQ_INSERT_HEAD(&mCastTbl6.inuseList.mCastTbl[entryIndex], select_t, nextMCast);
+		}
+		else/*(swapOutEntry!=NULL) && (select_t!=swapOutEntry)*/
+		{
+
+			/*disable swap and only explicit joined mulicast flow can replace unknown multicast flow*/
+			if(1)
+			{
+				/*don't forget to set swapOutEntry's inAsic flag*/
+				swapOutEntry->inAsic=FALSE;
+
+				select_t->age = RTL865X_MULTICAST_TABLE_ASIC_AGE;
+				bzero(&asic_mcast, sizeof(rtl8198C_tblAsicDrv_multiCastv6Param_t));
+				memcpy(&asic_mcast, select_t, (uintptr_t)&(((rtl8198C_tblAsicDrv_multiCastv6Param_t *)0)->six_rd_idx));
+				retval = rtl8198C_setAsicIpMulticastv6Table(hashMethod,&asic_mcast);
+				//printk("asic_mcast:dip:%x,[%s]:[%d].\n",asic_mcast.dip,__FUNCTION__,__LINE__);
+#ifdef CONFIG_PROC_FS
+				mcastAddOpCnt6++;
+
+#endif
+				assert(retval == SUCCESS);
+				if(retval==SUCCESS)
+				{
+					select_t->inAsic = TRUE;
+				}
+				else
+				{
+					select_t->inAsic = FALSE;
+					rtl8198C_delAsicIpMulticastv6Table(entryIndex);
+#ifdef CONFIG_PROC_FS
+					mcastDelOpCnt6++;
+#endif
+				}
+
+				TAILQ_REMOVE(&mCastTbl6.inuseList.mCastTbl[entryIndex], select_t, nextMCast);
+				TAILQ_INSERT_HEAD(&mCastTbl6.inuseList.mCastTbl[entryIndex], select_t, nextMCast);
+
+			}
+			#if 0
+			else
+			{
+				//printk("swapOutEntry:%d,select:%d,[%s]:[%d].\n",swapOutEntry->unKnownMCast,select_t->unKnownMCast,__FUNCTION__,__LINE__);
+				if(swapOutEntry->inAsic == FALSE)
+				{
+					/*maybe something is wrong, we remove the asic entry*/
+					rtl8651_delAsicIpMulticastTable(entryIndex);
+#ifdef CONFIG_PROC_FS
+					mcastDelOpCnt6++;
+#endif
+				}
+
+			}
+			#endif
+
+		}
+
+	}
+	else
+	{
+		if(swapOutEntry!=NULL)
+		{
+			swapOutEntry->inAsic=FALSE;
+		}
+		rtl8198C_delAsicIpMulticastv6Table(entryIndex);
+#ifdef CONFIG_PROC_FS
+		mcastDelOpCnt6++;
+#endif
+	}
+}
+
+void _rtl8198C_timeUpdateMulticastv6(uint32 secPassed)
+{
+	rtl8198c_tblDrv_mCastv6_t *mCast_t, *nextMCast_t;
+	uint32 entry;
+	uint32 needReArrange=FALSE;
+	uint32 hashLineCnt=0;
+	//printk("[%s:%d]\n",__FUNCTION__,__LINE__);
+	/* check to Aging and HW swapping */
+	for (entry=0; entry< RTL8651_MULTICASTTBL_SIZE; entry++) {
+		hashLineCnt=0;
+		needReArrange=FALSE;
+		mCast_t = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[entry]);
+		while (mCast_t) {
+			/*save the next entry first*/
+			nextMCast_t=TAILQ_NEXT(mCast_t, nextMCast);
+
+			if (mCast_t->inAsic == TRUE)
+			{
+				/* Entry is in the ASIC */
+				if (mCast_t->age <= secPassed)
+				{
+					if(mCast_t->mbr==0)
+					{
+						_rtl8198C_freeMCastv6Entry(mCast_t,entry);
+						needReArrange=TRUE;
+					}
+					else
+					{
+						mCast_t->age = RTL865X_MULTICAST_TABLE_AGE;
+					}
+				}
+				else
+				{
+					mCast_t->age -= secPassed;
+				}
+			}
+			else
+			{
+				//printk("------------mCast_t->count:%d,[%s]:[%d].\n",mCast_t->count,__FUNCTION__,__LINE__);
+
+				//mCast_t->count=0;
+
+				/* Entry is not in the ASIC */
+				if (mCast_t->age <= secPassed)
+				{ /* aging out */
+					_rtl8198C_freeMCastv6Entry(mCast_t, entry);
+				}
+				else
+				{
+					mCast_t->age -= secPassed;
+				}
+			}
+
+			/*won't count multicast entry forwarded by cpu*/
+			if(mCast_t->cpu==0)
+			{
+
+				hashLineCnt++;
+				//printk("------------hashLineCnt:%d,[%s]:[%d].\n",hashLineCnt,__FUNCTION__,__LINE__);
+				if(hashLineCnt>=2)
+				{
+					needReArrange=TRUE;
+				}
+			}
+
+			//mCast_t->count = 0;
+			mCast_t = nextMCast_t;
+		}
+
+		if(needReArrange==TRUE)
+		{
+			//printk("------------entry:%d,hashLineCnt:%d,[%s]:[%d].\n",entry,hashLineCnt,__FUNCTION__,__LINE__);
+			_rtl8198C_arrangeMulticastv6(entry);
+		}
+		mCast_t = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[entry]);
+
+		while (mCast_t) {
+			/*save the next entry first*/
+			nextMCast_t=TAILQ_NEXT(mCast_t, nextMCast);
+
+			if (mCast_t->inAsic == FALSE)
+				mCast_t->count=0;
+
+			mCast_t = nextMCast_t;
+		}
+
+	}
+}
+
+#if defined(__linux__) && defined(__KERNEL__)
+static void _rtl8198C_mCastv6SysTimerExpired(unsigned long expireDada)
+{
+
+	_rtl8198C_timeUpdateMulticastv6(1);
+	mod_timer(&rtl8198c_mCast6SysTimer, jiffies+HZ);
+
+}
+
+static void _rtl8198C_initMCastv6SysTimer(void)
+{
+	rtl865x_mCastSysTimer.expires=jiffies+HZ;
+	setup_timer(&rtl8198c_mCast6SysTimer, _rtl8198C_mCastv6SysTimerExpired,
+			(unsigned long)rtl8198c_mCast6SysTimer.expires);
+	add_timer(&rtl8198c_mCast6SysTimer);
+}
+static void _rtl8198C_destroyMCastv6SysTimer(void)
+{
+	del_timer(&rtl8198c_mCast6SysTimer);
+}
+#endif
+
+
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+
+int rtl8198C_findEmptyCamEntryv6(void)
+{
+	int index=-1;
+
+	for(index=RTL8651_IPMULTICASTTBL_SIZE; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+
+		if(TAILQ_EMPTY(&mCastTbl6.inuseList.mCastTbl[index]))
+		{
+			return index;
+		}
+	}
+
+	return -1;
+}
+#endif
+
+
+static int32 _rtl8198C_initMCastv6FwdDescPool(void)
+{
+	int32 i;
+	MC_LIST_INIT(&free_mcast_fwd_descriptor_head6);
+	TBL_MEM_ALLOC(rtl8198c_mcastFwdDescPool6, rtl8198c_mcast_fwd_descriptor6_t,MAX_MCASTV6_FWD_DESCRIPTOR_CNT);
+
+	if(rtl8198c_mcastFwdDescPool6!=NULL)
+	{
+		memset( rtl8198c_mcastFwdDescPool6, 0, MAX_MCASTV6_FWD_DESCRIPTOR_CNT * sizeof(rtl8198c_mcast_fwd_descriptor6_t));
+	}
+	else
+	{
+		return FAILED;
+	}
+
+	for(i = 0; i<MAX_MCASTV6_FWD_DESCRIPTOR_CNT;i++)
+	{
+		MC_LIST_INSERT_HEAD(&free_mcast_fwd_descriptor_head6, &rtl8198c_mcastFwdDescPool6[i], next);
+	}
+
+	return SUCCESS;
+}
+
+static rtl8198c_tblDrv_mCastv6_t * _rtl8198C_allocMCastv6Entry(uint32 hashIndex)
+{
+	rtl8198c_tblDrv_mCastv6_t *newEntry;
+	newEntry=TAILQ_FIRST(&mCastTbl6.freeList.freeMultiCast);
+	if (newEntry == NULL)
+	{
+		return NULL;
+	}
+
+	TAILQ_REMOVE(&mCastTbl6.freeList.freeMultiCast, newEntry, nextMCast);
+
+
+	/*initialize it*/
+	if(MC_LIST_FIRST(&newEntry->fwdDescChain)!=NULL)
+	{
+		_rtl8198C_flushMCastv6FwdDescChain(&newEntry->fwdDescChain);
+	}
+	MC_LIST_INIT(&newEntry->fwdDescChain);
+
+	memset(newEntry, 0, sizeof(rtl8198c_tblDrv_mCastv6_t));
+
+	TAILQ_INSERT_TAIL(&mCastTbl6.inuseList.mCastTbl[hashIndex], newEntry, nextMCast);
+
+	return newEntry;
+}
+
+static int32 _rtl8198C_mergeMCastv6FwdDescChain(mcast_fwd_descriptor_head6_t * targetChainHead ,
+													rtl8198c_mcast_fwd_descriptor6_t *srcChain)
+{
+	rtl8198c_mcast_fwd_descriptor6_t *curDesc;
+
+	if(targetChainHead==NULL)
+	{
+		return FAILED;
+	}
+
+	for(curDesc=srcChain; curDesc!=NULL; curDesc=MC_LIST_NEXT(curDesc,next))
+	{
+
+		_rtl8198C_mCastv6FwdDescEnqueue(targetChainHead, curDesc);
+
+	}
+
+	return SUCCESS;
+}
+
+static uint32 _rtl8198C_doMCastv6EntrySrcVlanPortFilter(rtl8198c_tblDrv_mCastv6_t *mCastEntry)
+{
+	rtl8198c_mcast_fwd_descriptor6_t * curDesc,*nextDesc;
+	if(mCastEntry==NULL)
+	{
+		return SUCCESS;
+	}
+
+	for(curDesc=MC_LIST_FIRST(&mCastEntry->fwdDescChain);curDesc!=NULL;curDesc=nextDesc)
+	{
+		nextDesc=MC_LIST_NEXT(curDesc, next);
+		{
+			curDesc->fwdPortMask=curDesc->fwdPortMask & (~(1<<mCastEntry->port));
+			if(curDesc->fwdPortMask==0)
+			{
+				/*remove from the old chain*/
+				MC_LIST_REMOVE(curDesc, next);
+				/*return to the free descriptor chain*/
+				_rtl8198C_freeMCastv6FwdDesc(curDesc);
+
+			}
+		}
+
+	}
+
+	return SUCCESS;
+}
+
+
+static uint32 rtl8198C_genMCastv6EntryAsicFwdMask(rtl8198c_tblDrv_mCastv6_t *mCastEntry)
+{
+	uint32 asicFwdPortMask=0;
+	rtl8198c_mcast_fwd_descriptor6_t * curDesc;
+	if(mCastEntry==NULL)
+	{
+		return 0;
+	}
+
+	MC_LIST_FOREACH(curDesc, &(mCastEntry->fwdDescChain), next)
+	{
+		if(curDesc->toCpu==0)
+		{
+			asicFwdPortMask|=(curDesc->fwdPortMask & ((1<<RTL8651_MAC_NUMBER)-1));
+		}
+		else
+		{
+			asicFwdPortMask|=( 0x01<<RTL8651_MAC_NUMBER);
+		}
+	}
+	asicFwdPortMask = asicFwdPortMask & (~(1<<mCastEntry->port));
+	return asicFwdPortMask;
+}
+
+static uint16 rtl8198C_genMCastv6EntryCpuFlag(rtl8198c_tblDrv_mCastv6_t *mCastEntry)
+{
+	uint16 cpuFlag=FALSE;
+	rtl8198c_mcast_fwd_descriptor6_t * curDesc;
+	if(mCastEntry==NULL)
+	{
+		return 0;
+	}
+
+	if(mCastEntry->cpuHold==TRUE)
+	{
+		cpuFlag=TRUE;
+	}
+
+	MC_LIST_FOREACH(curDesc, &(mCastEntry->fwdDescChain), next)
+	{
+		if(	(curDesc->toCpu==TRUE)	||
+			(memcmp(curDesc->netifName, RTL_WLAN_NAME,4)==0)	)
+		{
+			cpuFlag=TRUE;
+		}
+	}
+
+	return cpuFlag;
+}
+
+static void  _rtl8198C_setASICMulticastv6PortStatus(void) {
+	uint32 index;
+	for (index=0; index<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; index++) {
+		rtl8651_setAsicMulticastPortInternal(index, (rtl865x_externalMulticastPortMask&(1<<index))?FALSE:TRUE);
+	}
+}
+
+
+static void _rtl8198C_mCastv6EntryReclaim(void)
+{
+	uint32 index;
+	uint32 freeCnt=0;
+	uint32 asicFwdPortMask=0;
+	uint32 needReArrange=FALSE;
+	rtl8198c_tblDrv_mCastv6_t *curMCastEntry, *nextMCastEntry;
+
+	/*free unused software forward entry*/
+	for(index=0; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+		curMCastEntry = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[index]);
+		while (curMCastEntry)
+		{
+			nextMCastEntry = TAILQ_NEXT(curMCastEntry, nextMCast);
+			if((curMCastEntry->inAsic==FALSE)  && (curMCastEntry->count==0))
+			{
+				_rtl8198C_freeMCastv6Entry(curMCastEntry, index);
+				freeCnt++;
+			}
+			curMCastEntry = nextMCastEntry;
+		}
+
+	}
+
+	if(freeCnt>0)
+	{
+		return;
+	}
+
+	for(index=0; index<RTL8651_MULTICASTTBL_SIZE; index++)
+	{
+		curMCastEntry = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[index]);
+		needReArrange=FALSE;
+		while (curMCastEntry)
+		{
+			nextMCastEntry = TAILQ_NEXT(curMCastEntry, nextMCast);
+			if(curMCastEntry->inAsic)
+			{
+				asicFwdPortMask=rtl8198C_genMCastv6EntryAsicFwdMask(curMCastEntry);
+				if(asicFwdPortMask==0)
+				{
+					_rtl8198C_freeMCastv6Entry(curMCastEntry,index);
+					needReArrange=TRUE;
+				}
+			}
+			curMCastEntry = nextMCastEntry;
+		}
+
+		if(needReArrange==TRUE)
+		{
+			_rtl8198C_arrangeMulticastv6(index);
+		}
+	}
+
+	return;
+}
+
+static inline void _rtl8198C_patchPppoeWeakv6(rtl8198c_tblDrv_mCastv6_t *mCast_t)
+{
+	rtl8198c_mcast_fwd_descriptor6_t * curDesc;
+	uint32 netifType;
+	/* patch: keep cache in software if one vlan's interface is pppoe */
+	MC_LIST_FOREACH(curDesc, &(mCast_t->fwdDescChain), next)
+	{
+		if(rtl865x_getNetifType(curDesc->netifName, &netifType)==SUCCESS)
+		{
+			/*how about pptp,l2tp?*/
+			if(netifType==IF_PPPOE)
+			{
+				mCast_t->flag |= RTL865X_MULTICAST_PPPOEPATCH_CPUBIT;
+				return;
+			}
+		}
+
+	}
+
+	mCast_t->flag &= ~RTL865X_MULTICAST_PPPOEPATCH_CPUBIT;
+}
+//static
+uint32 rtl8198C_getMCastv6EntryDescPortMask(rtl8198c_tblDrv_mCastv6_t *mCastEntry)
+{
+	uint32 descPortMask=0;
+	rtl8198c_mcast_fwd_descriptor6_t * curDesc;
+	if(mCastEntry==NULL)
+	{
+		return 0;
+	}
+
+	MC_LIST_FOREACH(curDesc, &(mCastEntry->fwdDescChain), next)
+	{
+		descPortMask=descPortMask | curDesc->descPortMask;
+	}
+
+	return descPortMask;
+}
+
+static int32 rtl8198C_multicastv6CallbackFn(void *param)
+{
+	#if defined (CONFIG_RTL_MLD_SNOOPING)
+	inv6_addr_t groupAddr;
+	uint32 index;
+#if !defined(CONFIG_RTL_MULTI_LAN_DEV)
+	uint32 oldDescPortMask;
+#if !defined(CONFIG_RT_MULTIPLE_BR_SUPPOR)
+	uint32 newDescPortMask;/*for device decriptor forwarding usage*/
+#endif
+#endif
+	uint32 oldAsicFwdPortMask,newAsicFwdPortMask;/*for physical port forwarding usage*/
+	uint32 oldCpuFlag = 0,newCpuFlag = 0;
+
+	rtl_multicastEventContext_t mcastEventContext;
+
+	rtl8198c_mcast_fwd_descriptor6_t newFwdDesc;
+	struct rtl_multicastDataInfo multicastDataInfo;
+	struct rtl_multicastFwdInfo multicastFwdInfo;
+	rtl8198c_tblDrv_mCastv6_t *mCastEntry,*nextMCastEntry;
+#if !defined(CONFIG_RTL_MULTI_LAN_DEV) && !defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+	struct rtl_multicastDeviceInfo_s bridgeMCastDev;
+#endif
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	struct rtl_groupInfo groupInfo;
+#endif
+
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+	unsigned char br_name[16]={0};
+	int br_index;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+	struct net_bridge* br_dev = NULL;
+#else
+	unsigned int br_moduleIndex = 0xFFFFFFFF;
+#endif
+#endif
+	int32 retVal=FAILED;
+
+	if(param==NULL)
+	{
+		return EVENT_CONTINUE_EXECUTE;
+	}
+	memcpy(&mcastEventContext,param,sizeof(rtl_multicastEventContext_t));
+	/*check device name's validity*/
+	if(strlen(mcastEventContext.devName)==0)
+	{
+		return EVENT_CONTINUE_EXECUTE;
+	}
+	#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+	printk("%s:%d,mcastEventContext.devName is %s, mcastEventContext.groupAddr is 0x%x,mcastEventContext.sourceIP is 0x%x,mcastEventContext.portMask is 0x%x\n",__FUNCTION__,__LINE__,mcastEventContext.devName, mcastEventContext.groupAddr[0], mcastEventContext.sourceAddr[0], mcastEventContext.portMask);
+	#endif
+	bzero(&groupAddr,sizeof(inv6_addr_t));
+	memcpy(&groupAddr,mcastEventContext.groupAddr,sizeof(inv6_addr_t));
+	/*case 1:this is multicast event from bridge(br0) */
+	/*sync wlan and ethernet*/
+	//hyking:[Fix me] the RTL_BR_NAME...
+#if !defined(CONFIG_RTL_MULTI_LAN_DEV)
+#if defined(CONFIG_OPENWRT_SDK)
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,6)==0 || memcmp(mcastEventContext.devName,RTL_BR1_NAME,3)==0)
+#else
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,6)==0)
+#endif
+#else
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,3)==0 || memcmp(mcastEventContext.devName,RTL_BR1_NAME,3)==0)
+#elif defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,2)==0)
+#else
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,3)==0)
+#endif
+#endif
+	{
+		for (index=0; index< RTL8651_MULTICASTTBL_SIZE; index++)
+		{
+			for (mCastEntry = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[index]); mCastEntry; mCastEntry = nextMCastEntry)
+			{
+				nextMCastEntry=TAILQ_NEXT(mCastEntry, nextMCast);
+				if (!is_ip6_addr_equal(mCastEntry->dip,groupAddr))
+				{
+					continue;
+				}
+
+				rtl_getGroupInfov6((uint32*)&mCastEntry->dip, &groupInfo);
+				if(groupInfo.ownerMask==0)
+				{
+					mCastEntry->unKnownMCast=TRUE;
+				}
+				else
+				{
+					mCastEntry->unKnownMCast=FALSE;
+				}
+
+				oldDescPortMask=rtl8198C_getMCastv6EntryDescPortMask( mCastEntry);
+
+				/*sync with control plane*/
+				#if defined CONFIG_RT_MULTIPLE_BR_SUPPORT
+				oldCpuFlag=mCastEntry->cpu;
+				newDescPortMask = 0;
+				newCpuFlag = 0;
+
+				for(br_index = 0; br_index<RTL_IMGP_MAX_BRMODULE; br_index++)
+				{
+					br_moduleIndex=rtl_get_brIgmpModuleIndexbyId(br_index,br_name);
+					if(br_moduleIndex==0xFFFFFFFF)
+						continue;
+
+					/*sync with control plane*/
+					memset(&newFwdDesc, 0 ,sizeof(rtl8198c_mcast_fwd_descriptor6_t));
+					strcpy(newFwdDesc.netifName,br_name);
+
+					multicastDataInfo.ipVersion=6;
+					memcpy(multicastDataInfo.sourceIp, &mCastEntry->sip, sizeof(struct inv6_addr_s));
+					memcpy(multicastDataInfo.groupAddr, &mCastEntry->dip, sizeof(struct inv6_addr_s));
+
+
+					retVal= rtl_getMulticastDataFwdInfo(br_moduleIndex, &multicastDataInfo, &multicastFwdInfo);
+
+
+					if(retVal == SUCCESS)
+					{
+						newCpuFlag |= multicastFwdInfo.cpuFlag;
+					}
+
+				}
+
+				if(mCastEntry->unKnownMCast==TRUE)
+					newCpuFlag = 1;
+
+				if(oldCpuFlag != newCpuFlag)
+				{
+					_rtl8198C_freeMCastv6Entry(mCastEntry,index);
+					_rtl8198C_arrangeMulticastv6(index);
+				}
+				//printk("br:%s :oldAsicPortMask:%x,newAsicPortMask:%x,oldCpuFlag:%d,newCpuFlag:%d,[%s]:[%d].\n",devName,oldAsicPortMask,newAsicPortMask,oldCpuFlag,newCpuFlag,__FUNCTION__,__LINE__);
+				#else
+				memset(&newFwdDesc, 0 ,sizeof(rtl8198c_mcast_fwd_descriptor6_t));
+				strcpy(newFwdDesc.netifName,mcastEventContext.devName);
+				multicastDataInfo.ipVersion=6;
+				memcpy(multicastDataInfo.sourceIp,&mCastEntry->sip,sizeof(inv6_addr_t));
+				memcpy(multicastDataInfo.groupAddr,&mCastEntry->dip,sizeof(inv6_addr_t));
+				retVal= rtl_getMulticastDataFwdInfo(mcastEventContext.moduleIndex, &multicastDataInfo, &multicastFwdInfo);
+
+
+				if(retVal!=SUCCESS)
+				{
+					continue;
+				}
+
+				retVal= rtl_getIgmpSnoopingModuleDevInfo(mcastEventContext.moduleIndex, &bridgeMCastDev);
+				if(retVal!=SUCCESS)
+				{
+					continue;
+				}
+				newDescPortMask=multicastFwdInfo.fwdPortMask;
+				if( (oldDescPortMask != newDescPortMask) &&
+					(	((newDescPortMask & bridgeMCastDev.swPortMask)!=0) ||
+						(((oldDescPortMask & bridgeMCastDev.swPortMask) !=0) && ((newDescPortMask & bridgeMCastDev.swPortMask)==0)))	)
+				{
+					/*this multicast entry should be re-generated at linux protocol stack bridge level*/
+					_rtl8198C_freeMCastv6Entry(mCastEntry,index);
+					_rtl8198C_arrangeMulticastv6(index);
+				}
+				#endif
+
+			}
+		}
+
+		return EVENT_CONTINUE_EXECUTE;
+	}
+
+	/*case 2:this is multicast event from ethernet (eth0)*/
+	/*update ethernet forwarding port mask*/
+
+	#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if(memcmp(mcastEventContext.devName,"eth*",4)==0 || memcmp(mcastEventContext.devName,RTL_PS_ETH_NAME_ETH2,4)==0)
+	#else
+	if(memcmp(mcastEventContext.devName,"eth*",4)==0)
+	#endif
+
+	{
+	#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+		printk("%s:%d,multicast event from ethernet (%s),mcastEventContext.groupAddr[0] is 0x%x\n",__FUNCTION__,__LINE__,mcastEventContext.devName,mcastEventContext.groupAddr[0]);
+	#endif
+
+		for (index=0; index< RTL8651_MULTICASTTBL_SIZE; index++)
+		{
+			for (mCastEntry = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[index]); mCastEntry; mCastEntry = nextMCastEntry)
+			{
+				nextMCastEntry=TAILQ_NEXT(mCastEntry, nextMCast);
+#if	0
+				printk("mCastEntry->dip:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+					mCastEntry->dip.v6_addr16[0],mCastEntry->dip.v6_addr16[1],
+					mCastEntry->dip.v6_addr16[2],mCastEntry->dip.v6_addr16[3],
+					mCastEntry->dip.v6_addr16[4],mCastEntry->dip.v6_addr16[5],
+					mCastEntry->dip.v6_addr16[6],mCastEntry->dip.v6_addr16[7]);
+				printk("groupAddr:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+					groupAddr.v6_addr16[0],groupAddr.v6_addr16[1],
+					groupAddr.v6_addr16[2],groupAddr.v6_addr16[3],
+					groupAddr.v6_addr16[4],groupAddr.v6_addr16[5],
+					groupAddr.v6_addr16[6],groupAddr.v6_addr16[7]);
+#endif
+				if (!is_ip6_addr_equal(mCastEntry->dip,groupAddr))
+				{
+					continue;
+				}
+
+				memset(&newFwdDesc, 0 ,sizeof(rtl8198c_mcast_fwd_descriptor6_t));
+				strcpy(newFwdDesc.netifName,mcastEventContext.devName);
+
+				/*save old multicast entry forward port mask*/
+				oldAsicFwdPortMask=mCastEntry->mbr;
+				oldCpuFlag=mCastEntry->cpu;
+
+				/*sync with control plane*/
+				multicastDataInfo.ipVersion=6;
+				memcpy(multicastDataInfo.sourceIp,&mCastEntry->sip,sizeof(inv6_addr_t));
+				memcpy(multicastDataInfo.groupAddr,&mCastEntry->dip,sizeof(inv6_addr_t));
+				retVal= rtl_getMulticastDataFwdInfo(mcastEventContext.moduleIndex, &multicastDataInfo, &multicastFwdInfo);
+				if (multicastFwdInfo.unknownMCast == TRUE)
+					multicastFwdInfo.cpuFlag = TRUE;
+
+				newFwdDesc.fwdPortMask=multicastFwdInfo.fwdPortMask & (~(1<<mCastEntry->port));
+				newFwdDesc.toCpu=multicastFwdInfo.cpuFlag;
+
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+				newFwdDesc.fwdPortMask &= mCastEntry->mapPortMbr;
+#endif
+
+				/*update/replace old forward descriptor*/
+
+				_rtl8198C_mergeMCastv6FwdDescChain(&mCastEntry->fwdDescChain,&newFwdDesc);
+				mCastEntry->mbr 		= rtl8198C_genMCastv6EntryAsicFwdMask(mCastEntry);
+				mCastEntry->cpu 	= rtl8198C_genMCastv6EntryCpuFlag(mCastEntry);
+
+				newAsicFwdPortMask	= mCastEntry->mbr ;
+				newCpuFlag			=mCastEntry->cpu;
+
+			#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+				printk("%s:%d,oldAsicFwdPortMask is %d,newAsicFwdPortMask is %d\n",__FUNCTION__,__LINE__,oldAsicFwdPortMask,newAsicFwdPortMask);
+			#endif
+
+#ifndef RTL8651_MCAST_ALWAYS2UPSTREAM
+				if (mCastEntry->flag & RTL865X_MULTICAST_UPLOADONLY)
+				{	/* remove upload term*/
+					if((newAsicFwdPortMask!=0) && (newAsicFwdPortMask!=oldAsicFwdPortMask))
+					{
+						mCastEntry->flag &= ~RTL865X_MULTICAST_UPLOADONLY;
+						/* we assume multicast member will NEVER in External interface, so we remove
+								external ip now */
+						mCastEntry->flag &= ~RTL865X_MULTICAST_EXTIP_SET;
+					}
+				}
+#endif /* RTL8651_MCAST_ALWAYS2UPSTREAM */
+#ifdef CONFIG_RTL_MLD_SNOOPING
+				rtl_getGroupInfov6((uint32*)&mCastEntry->dip, &groupInfo);
+				if(groupInfo.ownerMask==0)
+				{
+					mCastEntry->unKnownMCast=TRUE;
+				}
+				else
+				{
+					mCastEntry->unKnownMCast=FALSE;
+				}
+#endif
+				if((oldCpuFlag != newCpuFlag)||(newAsicFwdPortMask!=oldAsicFwdPortMask))
+				{
+					_rtl8198C_patchPppoeWeakv6(mCastEntry);
+
+					/*reset inAsic flag to re-select or re-write this hardware asic entry*/
+					if(newAsicFwdPortMask==0)
+					{
+						_rtl8198C_freeMCastv6Entry(mCastEntry,index);
+					}
+					_rtl8198C_arrangeMulticastv6(index);
+				}
+			}
+
+		}
+	}
+
+#else /*CONFIG_RTL_MULTI_LAN_DEV*/
+#if defined (CONFIG_RT_MULTIPLE_BR_SUPPORT)
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,2)==0)
+#else
+	if(memcmp(mcastEventContext.devName,RTL_BR_NAME,3)==0)
+#endif
+
+	{
+	#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+		printk("%s:%d,multicast event from ethernet (%s),mcastEventContext.groupAddr[0] is 0x%x\n",__FUNCTION__,__LINE__,mcastEventContext.devName,mcastEventContext.groupAddr[0]);
+	#endif
+
+		for (index=0; index< RTL8651_MULTICASTTBL_SIZE; index++)
+		{
+			for (mCastEntry = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[index]); mCastEntry; mCastEntry = nextMCastEntry)
+			{
+				nextMCastEntry=TAILQ_NEXT(mCastEntry, nextMCast);
+#if	0
+				printk("mCastEntry->dip:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+					mCastEntry->dip.v6_addr16[0],mCastEntry->dip.v6_addr16[1],
+					mCastEntry->dip.v6_addr16[2],mCastEntry->dip.v6_addr16[3],
+					mCastEntry->dip.v6_addr16[4],mCastEntry->dip.v6_addr16[5],
+					mCastEntry->dip.v6_addr16[6],mCastEntry->dip.v6_addr16[7]);
+				printk("groupAddr:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+					groupAddr.v6_addr16[0],groupAddr.v6_addr16[1],
+					groupAddr.v6_addr16[2],groupAddr.v6_addr16[3],
+					groupAddr.v6_addr16[4],groupAddr.v6_addr16[5],
+					groupAddr.v6_addr16[6],groupAddr.v6_addr16[7]);
+#endif
+				if (!is_ip6_addr_equal(mCastEntry->dip,groupAddr))
+				{
+					continue;
+				}
+
+				memset(&newFwdDesc, 0 ,sizeof(rtl8198c_mcast_fwd_descriptor6_t));
+				strcpy(newFwdDesc.netifName,mcastEventContext.devName);
+
+				/*save old multicast entry forward port mask*/
+				oldAsicFwdPortMask=mCastEntry->mbr;
+				oldCpuFlag=mCastEntry->cpu;
+
+				/*sync with control plane*/
+				multicastDataInfo.ipVersion=6;
+				memcpy(multicastDataInfo.sourceIp,&mCastEntry->sip,sizeof(inv6_addr_t));
+				memcpy(multicastDataInfo.groupAddr,&mCastEntry->dip,sizeof(inv6_addr_t));
+				retVal= rtl_getMulticastDataFwdInfo(mcastEventContext.moduleIndex, &multicastDataInfo, &multicastFwdInfo);
+				if (multicastFwdInfo.unknownMCast == TRUE)
+					multicastFwdInfo.cpuFlag = TRUE;
+
+				#if defined CONFIG_RT_MULTIPLE_BR_SUPPORT
+				br_dev = NULL;
+				for(br_index = 0; br_index<RTL_IMGP_MAX_BRMODULE; br_index++)
+				{
+					br_dev = rtl_get_brByIndex(br_index, br_name);
+					if(strcmp(br_name, mcastEventContext.devName)==0)
+						break;
+				}
+				if(br_dev==NULL)
+					continue;
+				newFwdDesc.fwdPortMask=rtl865x_getPhyFwdPortMask(br_dev,multicastFwdInfo.fwdPortMask) & (~(1<<mCastEntry->port));
+				#else
+				newFwdDesc.fwdPortMask=rtl865x_getPhyFwdPortMask(bridge0,multicastFwdInfo.fwdPortMask) & (~(1<<mCastEntry->port));
+				#endif
+				newFwdDesc.toCpu=multicastFwdInfo.cpuFlag;
+
+				/*update/replace old forward descriptor*/
+
+				_rtl8198C_mergeMCastv6FwdDescChain(&mCastEntry->fwdDescChain,&newFwdDesc);
+				mCastEntry->mbr 		= rtl8198C_genMCastv6EntryAsicFwdMask(mCastEntry);
+				mCastEntry->cpu 	= rtl8198C_genMCastv6EntryCpuFlag(mCastEntry);
+
+				newAsicFwdPortMask	= mCastEntry->mbr ;
+				newCpuFlag			=mCastEntry->cpu;
+
+			#ifdef CONFIG_RTL865X_MUTLICAST_DEBUG
+				printk("%s:%d,oldAsicFwdPortMask is %d,newAsicFwdPortMask is %d\n",__FUNCTION__,__LINE__,oldAsicFwdPortMask,newAsicFwdPortMask);
+			#endif
+
+#ifndef RTL8651_MCAST_ALWAYS2UPSTREAM
+				if (mCastEntry->flag & RTL865X_MULTICAST_UPLOADONLY)
+				{	/* remove upload term*/
+					if((newAsicFwdPortMask!=0) && (newAsicFwdPortMask!=oldAsicFwdPortMask))
+					{
+						mCastEntry->flag &= ~RTL865X_MULTICAST_UPLOADONLY;
+							/* we assume multicast member will NEVER in External interface, so we remove
+								 external ip now */
+						mCastEntry->flag &= ~RTL865X_MULTICAST_EXTIP_SET;
+					}
+				}
+#endif /* RTL8651_MCAST_ALWAYS2UPSTREAM */
+#ifdef CONFIG_RTL_MLD_SNOOPING
+				rtl_getGroupInfov6((uint32*)&mCastEntry->dip, &groupInfo);
+				if(groupInfo.ownerMask==0)
+				{
+					mCastEntry->unKnownMCast=TRUE;
+				}
+				else
+				{
+					mCastEntry->unKnownMCast=FALSE;
+				}
+#endif
+
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+				newAsicFwdPortMask &= (mCastEntry->mapPortMbr |(0x01<<6));
+#endif
+
+				if((oldCpuFlag != newCpuFlag)||(newAsicFwdPortMask!=oldAsicFwdPortMask))
+				{
+					_rtl8198C_patchPppoeWeakv6(mCastEntry);
+
+					/*reset inAsic flag to re-select or re-write this hardware asic entry*/
+					if(newAsicFwdPortMask==0)
+					{
+						_rtl8198C_freeMCastv6Entry(mCastEntry,index);
+					}
+					_rtl8198C_arrangeMulticastv6(index);
+				}
+			}
+
+		}
+	}
+#endif
+#endif
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 _rtl8198C_multicastv6UnRegisterEvent(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_UPDATE_MCAST6;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl8198C_multicastv6CallbackFn;
+	rtl865x_unRegisterEvent(&eventParam);
+	return SUCCESS;
+}
+static int32 _rtl8198C_multicastv6RegisterEvent(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_UPDATE_MCAST6;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl8198C_multicastv6CallbackFn;
+	rtl865x_registerEvent(&eventParam);
+	return SUCCESS;
+}
+
+
+int32 rtl8198C_initMulticastv6(void)
+{
+	_rtl8198C_multicastv6UnRegisterEvent();
+	_rtl8198C_initMCastv6EntryPool();
+	_rtl8198C_initMCastv6FwdDescPool();
+	#if defined(__linux__) && defined(__KERNEL__)
+	_rtl8198C_initMCastv6SysTimer();
+	#endif
+	_rtl8198C_multicastv6RegisterEvent();
+	rtl8198C_setAsicMulticastv6MTU(1522);
+	rtl8198C_setAsicMulticastv6Enable(TRUE);
+	rtl8198C_setAsicMulticastv6Aging(TRUE);
+	return SUCCESS;
+}
+
+int32 rtl8198C_reinitMulticastv6(void)
+{
+	inv6_addr_t ip6addr0;
+	_rtl8198C_multicastv6UnRegisterEvent();
+	/*delete all multicast entry*/
+	rtl8198C_setAsicMulticastv6Enable(FALSE);
+	memset(&ip6addr0,0,sizeof(inv6_addr_t));
+	rtl8198C_delMulticastv6Entry(ip6addr0);
+	#if defined(__linux__) && defined(__KERNEL__)
+	_rtl8198C_destroyMCastv6SysTimer();
+	_rtl8198C_initMCastv6SysTimer();
+	#endif
+
+	/*regfster twice won't cause any side-effect,
+	because event management module will handle duplicate event issue*/
+
+	rtl8198C_setAsicMulticastv6Enable(TRUE);
+	rtl8198C_setAsicMulticastv6Aging(TRUE);
+
+	_rtl8198C_multicastv6RegisterEvent();
+	return SUCCESS;
+}
+
+int32 rtl8198C_addMulticastv6ExternalPort(uint32 extPort)
+{
+	rtl8198c_externalMulticastPortMask6 |= (1<<extPort);
+	_rtl8198C_setASICMulticastv6PortStatus();
+	return SUCCESS;
+}
+
+int32 rtl8198C_delMulticastv6ExternalPort(uint32 extPort)
+{
+	rtl8198c_externalMulticastPortMask6 &= ~(1<<extPort);
+	_rtl8198C_setASICMulticastv6PortStatus();
+	return SUCCESS;
+}
+
+int32 rtl8198C_setMulticastv6ExternalPortMask(uint32 extPortMask)
+{
+	rtl8198c_externalMulticastPortMask6 =extPortMask;
+	_rtl8198C_setASICMulticastv6PortStatus();
+	return SUCCESS;
+}
+
+int32 rtl8198C_addMulticastv6ExternalPortMask(uint32 extPortMask)
+{
+	rtl8198c_externalMulticastPortMask6|= extPortMask;
+	_rtl8198C_setASICMulticastv6PortStatus();
+	return SUCCESS;
+}
+
+int32 rtl8198C_delMulticastv6ExternalPortMask(uint32 extPortMask)
+{
+	rtl8198c_externalMulticastPortMask6 &= ~extPortMask;
+	_rtl8198C_setASICMulticastv6PortStatus();
+	return SUCCESS;
+}
+
+int32 rtl8198C_getMulticastv6ExternalPortMask(void)
+{
+	return rtl8198c_externalMulticastPortMask6 ;
+}
+
+rtl8198c_tblDrv_mCastv6_t *rtl8198C_findMCastv6Entry(inv6_addr_t dip,inv6_addr_t sip, uint16 svid, uint16 sport)
+{
+	rtl8198c_tblDrv_mCastv6_t *mCast_t;
+	uint32 entry=0;
+	uint32 hashMethod=0;
+	rtl8198C_getMCastv6HashMethod(&hashMethod);
+	entry = rtl8198C_ipMulticastv6TableIndex(hashMethod,sip,dip);
+	TAILQ_FOREACH(mCast_t, &mCastTbl6.inuseList.mCastTbl[entry], nextMCast) {
+		if (is_ip6_addr_equal(mCast_t->dip,dip) && is_ip6_addr_equal(mCast_t->sip,sip) && mCast_t->port==sport)
+		{
+			if (mCast_t->inAsic == FALSE)
+			{
+				mCast_t->age = RTL865X_MULTICAST_TABLE_AGE;
+				mCast_t->count ++;
+			}
+			return mCast_t;
+		}
+	}
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+	for(entry=RTL8651_IPMULTICASTTBL_SIZE; entry<RTL8651_MULTICASTTBL_SIZE; entry++)
+	{
+		TAILQ_FOREACH(mCast_t, &mCastTbl6.inuseList.mCastTbl[entry], nextMCast) {
+			if (is_ip6_addr_equal(mCast_t->dip,dip) && is_ip6_addr_equal(mCast_t->sip,sip) && mCast_t->port==sport)
+			{
+				if (mCast_t->inAsic == FALSE)
+				{
+					mCast_t->age = RTL865X_MULTICAST_TABLE_AGE;
+					mCast_t->count ++;
+				}
+				return mCast_t;
+			}
+
+		}
+	}
+#endif
+	return (rtl8198c_tblDrv_mCastv6_t *)NULL;
+}
+
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+int rtl8198C_addMulticastv6Entry(inv6_addr_t dip,inv6_addr_t sip, unsigned short svid, unsigned short sport,
+									rtl8198c_mcast_fwd_descriptor6_t * newFwdDescChain,
+									int flushOldChain, unsigned int extIp, char cpuHold, unsigned char flag, unsigned int mapPortMask)
+
+#else
+int rtl8198C_addMulticastv6Entry(inv6_addr_t dip,inv6_addr_t sip, unsigned short svid, unsigned short sport,
+									rtl8198c_mcast_fwd_descriptor6_t * newFwdDescChain,
+									int flushOldChain, unsigned int extIp, char cpuHold, unsigned char flag)
+#endif
+{
+	rtl8198c_tblDrv_mCastv6_t *mCast_t;
+	uint32 hashIndex;
+#ifdef CONFIG_RTL_MLD_SNOOPING
+	uint32 groupIpAddr[4];
+#endif
+	#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+	uint32 emptyCamIndex=-1;
+	#endif
+	uint32 hashMethod=0;
+	#if defined (CONFIG_RTL_MLD_SNOOPING)
+	struct rtl_groupInfo groupInfo;
+	#endif
+	rtl8198C_getMCastv6HashMethod(&hashMethod);
+	hashIndex = rtl8198C_ipMulticastv6TableIndex(hashMethod,sip,dip);
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+	mCast_t=rtl8198C_findMCastv6Entry(dip, sip, svid, sport);
+	if(mCast_t==NULL)
+	{
+		/*table entry collided*/
+		if(!TAILQ_EMPTY(&mCastTbl6.inuseList.mCastTbl[hashIndex]))
+		{
+			emptyCamIndex=rtl8198C_findEmptyCamEntryv6();
+			if(emptyCamIndex!=-1)
+			{
+				hashIndex=emptyCamIndex;
+			}
+		}
+	}
+	else
+	{
+		hashIndex=mCast_t->hashIndex;
+	}
+#else
+	/*try to match hash line*/
+	TAILQ_FOREACH(mCast_t, &mCastTbl6.inuseList.mCastTbl[hashIndex], nextMCast)
+	{
+		if (is_ip6_addr_equal(mCast_t->sip,sip) && is_ip6_addr_equal(mCast_t->dip,dip) && mCast_t->port==sport)
+			break;
+	}
+#endif
+
+	if (mCast_t == NULL)
+	{
+		mCast_t=_rtl8198C_allocMCastv6Entry(hashIndex);
+		if (mCast_t == NULL)
+		{
+			_rtl8198C_mCastv6EntryReclaim();
+			mCast_t=_rtl8198C_allocMCastv6Entry(hashIndex);
+			if(mCast_t == NULL)
+			{
+				return FAILED;
+			}
+		}
+		mCast_t->sip		= sip;
+		mCast_t->dip		= dip;
+		mCast_t->port		= sport;
+		mCast_t->mbr		= 0;
+		mCast_t->count		= 0;
+		mCast_t->inAsic		= FALSE;
+		mCast_t->six_rd_eg  = 0;
+		mCast_t->six_rd_idx = 0;
+		mCast_t->svid		= svid;
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+		mCast_t->mapPortMbr = mapPortMask;
+#endif
+	}
+
+	if(flushOldChain)
+	{
+		_rtl8198C_flushMCastv6FwdDescChain(&mCast_t->fwdDescChain);
+
+	}
+
+	_rtl8198C_mergeMCastv6FwdDescChain(&mCast_t->fwdDescChain,newFwdDescChain);
+	_rtl8198C_doMCastv6EntrySrcVlanPortFilter(mCast_t);
+
+	mCast_t->mbr			= rtl8198C_genMCastv6EntryAsicFwdMask(mCast_t);
+
+	mCast_t->age			= RTL865X_MULTICAST_TABLE_AGE;
+#if 0
+	mCast_t->cpu			= (toCpu==TRUE? 1: 0);
+#else
+	mCast_t->cpuHold			= cpuHold;
+	mCast_t->cpu 			= rtl8198C_genMCastv6EntryCpuFlag(mCast_t);
+#endif
+	mCast_t->flag			= flag;
+
+
+	if (extIp)
+		mCast_t->flag |= RTL865X_MULTICAST_EXTIP_SET;
+	else
+		mCast_t->flag &= ~RTL865X_MULTICAST_EXTIP_SET;
+	#if defined (CONFIG_RTL_MLD_SNOOPING)
+	memcpy(groupIpAddr,&dip,sizeof(inv6_addr_t));
+	rtl_getGroupInfov6(groupIpAddr, &groupInfo);
+	if(groupInfo.ownerMask==0)
+	{
+		mCast_t->unKnownMCast=TRUE;
+	}
+	else
+	{
+		mCast_t->unKnownMCast=FALSE;
+	}
+	#endif
+#if defined (CONFIG_RTL_HARDWARE_MULTICAST_CAM)
+	mCast_t->hashIndex=hashIndex;
+#endif
+	_rtl8198C_patchPppoeWeakv6(mCast_t);
+	_rtl8198C_arrangeMulticastv6(hashIndex);
+	return SUCCESS;
+}
+int rtl8198C_delMulticastv6Entry(inv6_addr_t groupAddr)
+{
+	rtl8198c_tblDrv_mCastv6_t *mCastEntry, *nextMCastEntry;
+	uint32 entry;
+	uint32 deleteFlag=FALSE;
+	for(entry=0; entry<RTL8651_MULTICASTTBL_SIZE; entry++)
+	{
+		deleteFlag=FALSE;
+		mCastEntry = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[entry]);
+		while (mCastEntry)
+		{
+			nextMCastEntry = TAILQ_NEXT(mCastEntry, nextMCast);
+			if (is_ip6_addr_equal(groupAddr,mCastEntry->dip))
+			{
+				deleteFlag=TRUE;
+				_rtl8198C_freeMCastv6Entry(mCastEntry, entry);
+			}
+
+			mCastEntry = nextMCastEntry;
+		}
+
+		if(deleteFlag==TRUE)
+		{
+			_rtl8198C_arrangeMulticastv6(entry);
+		}
+	}
+	return SUCCESS;
+}
+int rtl8198C_genVirtualMCastv6FwdDescriptor(unsigned int forceToCpu, unsigned int  fwdPortMask, rtl8198c_mcast_fwd_descriptor6_t *fwdDescriptor)
+{
+	if(fwdDescriptor==NULL)
+	{
+		return FAILED;
+	}
+	memset(fwdDescriptor, 0, sizeof(rtl8198c_mcast_fwd_descriptor6_t ));
+	fwdDescriptor->toCpu=forceToCpu;
+	fwdDescriptor->fwdPortMask=fwdPortMask;
+	return SUCCESS;
+}
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+int rtl8198C_blockMulticastv6Flow(unsigned int srcVlanId,unsigned int srcPort,inv6_addr_t srcIpAddr,inv6_addr_t destIpAddr, unsigned int mapPortMask)
+#else
+int rtl8198C_blockMulticastv6Flow(unsigned int srcVlanId,unsigned int srcPort,inv6_addr_t srcIpAddr,inv6_addr_t destIpAddr)
+#endif
+{
+	rtl8198c_mcast_fwd_descriptor6_t fwdDescriptor;
+	rtl8198c_tblDrv_mCastv6_t * existMCastEntry=NULL;
+	existMCastEntry=rtl8198C_findMCastv6Entry(destIpAddr, srcIpAddr, (uint16)srcVlanId, (uint16)srcPort);
+	if(existMCastEntry!=NULL)
+	{
+		if(existMCastEntry->mbr==0)
+		{
+			return SUCCESS;
+		}
+	}
+	memset(&fwdDescriptor, 0, sizeof(rtl8198c_mcast_fwd_descriptor6_t ));
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+	rtl8198C_addMulticastv6Entry(destIpAddr,srcIpAddr,(unsigned short)srcVlanId,(unsigned short)srcPort,&fwdDescriptor,TRUE,0,0,0, mapPortMask);
+#else
+	rtl8198C_addMulticastv6Entry(destIpAddr,srcIpAddr,(unsigned short)srcVlanId,(unsigned short)srcPort,&fwdDescriptor,TRUE,0,0,0);
+#endif
+	return SUCCESS;
+}
+
+int32 rtl8198C_flushHWMulticastv6Entry(void)
+{
+	rtl8198c_tblDrv_mCastv6_t *mCastEntry, *nextMCastEntry;
+	uint32 entry;
+	inv6_addr_t ip0;
+	memset(&ip0,0,sizeof(inv6_addr_t));
+	for(entry=0; entry<RTL8651_MULTICASTTBL_SIZE; entry++)
+	{
+		mCastEntry = TAILQ_FIRST(&mCastTbl6.inuseList.mCastTbl[entry]);
+		while (mCastEntry)
+		{
+			nextMCastEntry = TAILQ_NEXT(mCastEntry, nextMCast);
+			if(!is_ip6_addr_equal(ip0,mCastEntry->dip))
+			{
+				_rtl8198C_freeMCastv6Entry(mCastEntry, entry);
+				_rtl8198C_arrangeMulticastv6(entry);
+			}
+			mCastEntry = nextMCastEntry;
+		}
+	}
+	return SUCCESS;
+}
+int rtl8198C_getMCastv6HashMethod(unsigned int *hashMethod)
+{
+	return rtl8198C_getAsicMCastv6HashMethod(hashMethod);
+}
+int rtl8198C_setMCastv6HashMethod(unsigned int hashMethod)
+{
+	uint32	  oldHashMethod = 0;
+	rtl8198C_getAsicMCastv6HashMethod(&oldHashMethod);
+	if(hashMethod >3)
+	{
+		return -1;
+	}
+	hashMethod &= 3;
+
+	if (oldHashMethod != hashMethod) /* set IPV6CR Register bit 17~18 and flush multicastv6 table */
+	{
+		rtl8198C_setAsicMCastv6HashMethod(hashMethod);
+		/* exclude 0->1 and 1->0 */
+		if(!((hashMethod == HASH_METHOD_SIP_DIP0 && oldHashMethod == HASH_METHOD_SIP_DIP1) ||
+			(hashMethod == HASH_METHOD_SIP_DIP1 && oldHashMethod == HASH_METHOD_SIP_DIP0)))
+		{
+			rtl8198C_flushHWMulticastv6Entry();
+		}
+
+	}
+	return 0;
+}
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_multipleWan.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_multipleWan.h
new file mode 100644
index 00000000..061e622
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_multipleWan.h
@@ -0,0 +1,31 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2010
+* All rights reserved.
+*
+* Program : multiple wan device driver header file
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865X_MULTIPLEWAN_H
+#define RTL865X_MULTIPLEWAN_H
+
+#if defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+#define RTL_ADVRT_MAX_NUM 16
+#else
+#define RTL_ADVRT_MAX_NUM 4
+#endif
+rtl_advRoute_entry_t* rtl_get_advRt_entry_by_nexthop(ipaddr_t nexthop);
+int rtl_init_advRt(void);
+int rtl_exit_advRt(void);
+int rtl_add_advRt_entry(rtl_advRoute_entry_t *entry);
+int rtl_del_advRt_entry(rtl_advRoute_entry_t *entry);
+int rtl_disable_advRt_by_netifName(const char *name);
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_nexthop.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_nexthop.c
new file mode 100644
index 00000000..10156cb
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_nexthop.c
@@ -0,0 +1,980 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : nexthop table driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+/*      @doc RTL_LAYEREDDRV_API
+
+		@module rtl865x_nexthop.c - RTL865x Home gateway controller Layered driver API documentation       |
+		This document explains the API interface of the table driver module. Functions with rtl865x prefix
+		are external functions.
+		@normal Hyking Liu (Hyking_liu@realsil.com.cn) <date>
+
+		Copyright <cp>2008 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+		@head3 List of Symbols |
+		Here is a list of all functions and variables in this module.
+
+		@index | RTL_LAYEREDDRV_API
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl_errno.h"
+#include "common/rtl865x_netif_local.h"
+#include "rtl865x_ip.h"
+#include "rtl865x_nexthop.h"
+//#include "rtl865x_ppp.h"
+#include "rtl865x_ppp_local.h"
+#include "rtl865x_route.h"
+#include "rtl865x_arp.h"
+
+#include "common/rtl865x_vlan.h"
+#include "common/rtl865x_eventMgr.h" /*call back function....*/
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#endif
+#include "l2Driver/rtl865x_fdb.h"
+#include <net/rtl/rtl865x_fdb_api.h>
+#include <linux/version.h>
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#include "rtl8198c_arpIpv6.h"
+#include "rtl8198c_nexthopIpv6.h"
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+#ifdef CONFIG_RTL_HW_DSLITE_SUPPORT
+#include "l3Driver/rtl865x_dslite.h"
+extern inv6_addr_t gw_ipv6_addr;
+#endif
+#endif
+
+static rtl865x_nextHopEntry_t *rtl865x_nxtHopTable;
+
+#define NEXTHOP_TABLE_INDEX(entry)	(entry - rtl865x_nxtHopTable)
+static int32 _rtl865x_nextHop_register_event(void);
+static int32 _rtl865x_nextHop_unRegister_event(void);
+static int32 _rtl865x_delNxtHop(uint32 attr, uint32 entryIdx);
+
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
+static RTL_DECLARE_MUTEX(nxthop_sem);
+#endif
+#if LINUX_VERSION_CODE > KERNEL_VERSION(3,4,0)
+extern int32 _rtl865x_referPpp(uint32 sessionId);
+extern int32 _rtl865x_deReferPpp(uint32 sessionId);
+#endif
+
+#if 0
+static void _print_softNxtHop(void)
+{
+	int32 i = 0;
+	rtl865x_nextHopEntry_t *entry = rtl865x_nxtHopTable;
+	printk("software nextHop table:\n");
+	for(i = 0; i < NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		printk("idx(%d): valid(%d),dst(%s),nexthop(%d),nexthopType(%d),refCnt(%d)\n",i,entry->valid,entry->dstNetif->name,
+			entry->nexthop,entry->nextHopType,entry->refCnt);
+	}
+}
+#endif
+
+/*
+@func int32 | rtl865x_initNxtHopTable |initialize the nexthop table
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed. system should reboot.
+@comm
+*/
+int32 rtl865x_initNxtHopTable(void)
+{
+	TBL_MEM_ALLOC(rtl865x_nxtHopTable, rtl865x_nextHopEntry_t, NXTHOP_ENTRY_NUM);
+	memset(rtl865x_nxtHopTable,0,sizeof(rtl865x_nextHopEntry_t)*NXTHOP_ENTRY_NUM);
+	_rtl865x_nextHop_register_event();
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865x_reinitNxtHopTable |reinitialize the nexthop table
+@rvalue SUCCESS | success.
+@comm
+*/
+int32 rtl865x_reinitNxtHopTable(void)
+{
+	int32 i;
+	_rtl865x_nextHop_unRegister_event();
+
+	for(i = 0; i < NXTHOP_ENTRY_NUM; i++)
+	{
+		if(rtl865x_nxtHopTable[i].valid)
+			_rtl865x_delNxtHop(NEXTHOP_L3,i);
+	}
+
+	_rtl865x_nextHop_register_event();
+	return SUCCESS;
+}
+#if defined CONFIG_RTL_LOCAL_PUBLIC
+extern  int rtl865x_getLocalPublicArpMapping(unsigned int ip, rtl865x_arpMapping_entry_t * arp_mapping);
+#endif
+static int32 _rtl865x_synNxtHopToAsic(rtl865x_nextHopEntry_t *entry_t)
+{
+	rtl865x_tblAsicDrv_nextHopParam_t asic;
+	ether_addr_t reservedMac;
+	rtl865x_tblAsicDrv_l2Param_t asic_l2;
+	rtl865x_netif_local_t *dstNetif;
+	uint32 fid = 0;
+	uint32 columIdx = 0;
+	int32 retval = 0;
+	int32 ipIdx = 0;
+
+	retval = rtl865x_getReserveMacAddr(&reservedMac);
+
+	bzero(&asic, sizeof(rtl865x_tblAsicDrv_nextHopParam_t));
+
+	if(entry_t == NULL)
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	if (entry_t->nextHopType == IF_ETHER)
+	{
+		rtl865x_arpMapping_entry_t arp_t;
+		int32 ret_arpFound = FAILED;
+
+		/*if the arp info of nexthop is not found, reserved to cpu Mac is used for trap packet to CPU*/
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+		if(entry_t->nexthop)
+		{
+			ret_arpFound = rtl865x_getArpMapping(entry_t->nexthop,&arp_t);
+			if(ret_arpFound!=SUCCESS)
+			{
+				/*try to match local pulbic ip*/
+				ret_arpFound = rtl865x_getLocalPublicArpMapping(entry_t->nexthop, &arp_t);
+
+			}
+		}
+#else
+		if(entry_t->nexthop)
+			ret_arpFound = rtl865x_getArpMapping(entry_t->nexthop,&arp_t);
+#endif
+
+		rtl865x_getVlanFilterDatabaseId(entry_t->dstNetif->vid,&fid);
+		retval = rtl865x_Lookup_fdb_entry(fid, (ret_arpFound == SUCCESS)? &arp_t.mac : &reservedMac, FDB_DYNAMIC, &columIdx,&asic_l2);
+
+		asic.nextHopRow = rtl8651_filterDbIndex( (ret_arpFound == SUCCESS)? &arp_t.mac : &reservedMac, fid );
+		asic.nextHopColumn = (retval == SUCCESS)? columIdx: 0;
+		asic.isPppoe = FALSE;
+		asic.pppoeIdx = 0;
+
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+
+	else if (entry_t->nextHopType == IF_DSLT)
+	{
+		rtl8198c_ipv6_arpMapping_entry_t arp_t;
+		int32 ret_arpFound = FAILED;
+		/*if the arp info of nexthop is not found, reserved to cpu Mac is used for trap packet to CPU*/
+
+		ret_arpFound = rtl8198c_dslite_Ipv6ArpMapping(gw_ipv6_addr, &arp_t);
+		rtl865x_getVlanFilterDatabaseId(entry_t->dstNetif->vid,&fid);
+		retval = rtl865x_Lookup_fdb_entry(fid, (ret_arpFound == SUCCESS)? &arp_t.mac : &reservedMac, FDB_DYNAMIC, &columIdx,&asic_l2);
+
+		asic.nextHopRow = rtl8651_filterDbIndex( (ret_arpFound == SUCCESS)? &arp_t.mac : &reservedMac, fid );
+		asic.nextHopColumn = (retval == SUCCESS)? columIdx: 0;
+		asic.isPppoe = FALSE;
+		asic.pppoeIdx = 0;
+
+		//printk("%d,%d,[%s]:[%d].\n",asic.nextHopRow,asic.nextHopColumn,__FUNCTION__,__LINE__);
+	}
+#endif
+#endif
+	else
+	{
+		/*session based interface type*/
+		rtl865x_ppp_t pppoe;
+		int32 pppidx = 0;
+
+		memset(&pppoe,0,sizeof(rtl865x_ppp_t));
+
+		if(entry_t->nexthop)
+			retval = rtl865x_getPppBySessionId(entry_t->nexthop,&pppoe);
+
+		rtl865x_getVlanFilterDatabaseId(entry_t->dstNetif->vid,&fid);
+
+
+		retval =rtl865x_Lookup_fdb_entry(fid, (pppoe.valid)? &pppoe.server_mac : &reservedMac, FDB_DYNAMIC, &columIdx,&asic_l2);
+
+		#if defined(CONFIG_RTL_CUSTOM_PASSTHRU_PPPOE)
+		if (retval == FAILED) {
+			retval =rtl865x_Lookup_fdb_entry(fid, (pppoe.valid)? &pppoe.server_mac : &reservedMac, FDB_STATIC, &columIdx, &asic_l2);
+			//panic_printk("1: rtl865x_Lookup_fdb_entry ret is %d.....\n", retval);
+		}
+		#endif
+
+		asic.nextHopRow = rtl8651_filterDbIndex( (pppoe.valid)? &pppoe.server_mac : &reservedMac, fid);
+		asic.nextHopColumn = (pppoe.valid)? columIdx: 0;
+		asic.isPppoe = (pppoe.type == IF_PPPOE)? TRUE: FALSE;
+
+		retval = rtl865x_getPppIdx(&pppoe, &pppidx);
+
+		//printk("%s(%d): pppoeIdx(%d), pppoeType(%d), pppoevalid(%d),pppoeSid(%d)\n",__FUNCTION__,__LINE__,pppidx,pppoe.type,pppoe.valid,pppoe.sessionId);
+		asic.pppoeIdx	= (pppoe.type == IF_PPPOE)? pppidx: 0;
+	}
+
+	if(entry_t->dstNetif->is_slave == 1)
+	{
+		dstNetif = entry_t->dstNetif->master;
+
+		if(dstNetif == NULL)
+			dstNetif = _rtl865x_getDefaultWanNetif();
+	}
+	else
+		dstNetif = entry_t->dstNetif;
+
+	if(dstNetif == NULL)
+		printk("_%s(%d), BUG!!!!!!",__FUNCTION__,__LINE__);
+
+	asic.dvid 			= dstNetif->asicIdx;
+
+	if(entry_t->srcIp)
+		retval = rtl865x_getIpIdxByExtIp(entry_t->srcIp, &ipIdx);
+
+	asic.extIntIpIdx	= entry_t->srcIp? ipIdx: 0;
+	rtl8651_setAsicNextHopTable(entry_t->entryIndex,  &asic);
+
+	return SUCCESS;
+}
+
+
+static int32 _rtl865x_arrangeNxtHop(uint32 start, uint32 num)
+{
+	int32 idx;
+	rtl865x_nextHopEntry_t *entry = NULL;
+
+	if(start < 0 || start + num >= NXTHOP_ENTRY_NUM)
+		return RTL_EINVALIDINPUT;
+	for(idx = start; idx < start + num; idx++)
+	{
+		entry = &rtl865x_nxtHopTable[idx];
+
+		if(entry->valid)
+			_rtl865x_synNxtHopToAsic(entry);
+	}
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_addNxtHop(uint32 attr, void *ref_ptr, rtl865x_netif_local_t *netif, uint32 nexthop,uint32 srcIp)
+{
+	int entryIdx;
+	rtl865x_nextHopEntry_t *entry = NULL, *entry1 = NULL;
+	rtl865x_route_t *rt_t = NULL;
+
+	/*
+	  * NOTE:
+	  * parameter description:
+	  * (1) attr: why need to add the nexthop entry? NEXTHOP_L3 or NEXTHOP_DEFREDIRECT_ACL?
+	  * (2) ref_ptr: when attr = NEXTHOP_L3, ref_ptr point to a route structure,
+	  *				   attr = NEXTHOP_DEFREDIRECT_ACL, ref_ptr = NULL,
+	  *				   attr = others, ref_ptr = NULL
+	  * (3) netif: destination network interface
+	  * (4) nexthop:
+	  *		a) netif->if_type == IF_ETHER, nexthop = nexthop ip address,
+	  *		b) netif->if_type == session based type, nexthop = session Id,
+	  *
+	  * following case should be NOTED now:
+	  * (1) ETHERNET type network interface:
+	  *	 a) If nexthop != NULL , it means the entry is added for:
+	  *		nexthop ip&mac information, nextHop = arp entry of nexthop ip address.
+	  *	  b) If nexthop == 0, use default route's nexthop or nexthop TOCPU
+	  *
+	  * (2) PPPoE/PPTP/L2TP type network interface:
+	  *	  The "nexthop" will explicitly specify the PPPoE session (PPTP/L2TP session).
+	  */
+
+	if(netif == NULL)
+		return RTL_EINVALIDINPUT;
+
+	/* Allocate an empty entry for new one */
+	/*Note: all nexthop entry referenced by L3 must be 2 entries aligned(reference l3 Datasheet)*/
+	for(entryIdx = 0; entryIdx < NXTHOP_ENTRY_NUM; entryIdx++)
+	{
+		if(rtl865x_nxtHopTable[entryIdx].valid == 0)
+		{
+			switch(attr)
+			{
+				case NEXTHOP_L3:
+					if( entryIdx%2 == 0 && (entryIdx + 1) < NXTHOP_ENTRY_NUM &&  rtl865x_nxtHopTable[entryIdx+1].valid == 0)
+					{
+						entry = &rtl865x_nxtHopTable[entryIdx];
+						goto found;
+					}
+					break;
+
+				case NEXTHOP_DEFREDIRECT_ACL:
+					entry = &rtl865x_nxtHopTable[entryIdx];
+					goto found;
+					break;
+
+				default:
+					printk("attr(%d) is not support.....\n",attr);
+					break;
+			}
+		}
+	}
+
+	/*if not found proper nextHop entry, return*/
+	entry = NULL;
+
+found:
+	if(entry == NULL)
+		return RTL_ENOFREEBUFFER;
+
+	entry->valid = 1;
+	entry->dstNetif = netif;
+	entry->entryIndex = entryIdx;
+	entry->nextHopType = netif->if_type;
+	entry->srcIp = srcIp;
+	entry->refCnt = 1;
+	entry->flag = attr;
+
+	switch(netif->if_type)
+	{
+		case IF_ETHER:
+	#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+		case IF_DSLT:
+	#endif
+	#endif
+			entry->nexthop = nexthop;
+			break;
+		case IF_PPPOE:
+		case IF_PPTP:
+		case IF_L2TP:
+			/*nexthop is sessionId*/
+			entry->nexthop = nexthop;
+			break;
+
+	}
+
+	if(attr == NEXTHOP_L3)
+	{
+		entry1 = &rtl865x_nxtHopTable[entryIdx+1];
+		memcpy(entry1,entry,sizeof(rtl865x_nextHopEntry_t));
+		entry1->entryIndex = entryIdx + 1;
+
+		_rtl865x_arrangeNxtHop(entryIdx, 2);
+
+		/*entry1 used netif,update reference netif*/
+		rtl865x_referNetif(netif->name);
+		/*entry1 used pppoe!, update reference pppoe*/
+		if((entry1->nextHopType == IF_PPPOE)
+			|| (entry1->nextHopType == IF_PPTP)
+			|| (entry1->nextHopType == IF_L2TP)
+			){
+			#if LINUX_VERSION_CODE > KERNEL_VERSION(3,4,0)
+			_rtl865x_referPpp(nexthop);
+			#else
+			rtl865x_referPpp(nexthop);
+			#endif
+		}
+
+		/*FIXME_hyking:lazy, update the route information right here....*/
+		rt_t = (rtl865x_route_t *)ref_ptr;
+		rt_t ->un.nxthop.nxtHopSta = entryIdx;
+		rt_t ->un.nxthop.nxtHopEnd = entryIdx + 1;
+	}
+	else
+		_rtl865x_arrangeNxtHop(entryIdx, 1);
+
+	/*update reference dstnetif&pppoe arp?*/
+	rtl865x_referNetif(netif->name);
+	if((entry->nextHopType == IF_PPPOE)
+			|| (entry->nextHopType == IF_PPTP)
+			|| (entry->nextHopType == IF_L2TP)
+			){
+			#if LINUX_VERSION_CODE > KERNEL_VERSION(3,4,0)
+			_rtl865x_referPpp(nexthop);
+			#else
+			rtl865x_referPpp(nexthop);
+			#endif
+	}
+
+	return SUCCESS;
+
+}
+
+static int32 _rtl865x_delNxtHop(uint32 attr, uint32 entryIdx)
+{
+	rtl865x_nextHopEntry_t *entry;
+	//int32 retval = 0;
+
+	if(entryIdx >= NXTHOP_ENTRY_NUM)
+		return RTL_EINVALIDINPUT;
+
+	entry = &rtl865x_nxtHopTable[entryIdx];
+
+	if(entry->valid == 0)
+		return RTL_EENTRYNOTFOUND;
+
+	if(entry->refCnt > 1)
+	{
+		printk("%s(%d),refcnt(%d)\n",__FUNCTION__,__LINE__,entry->refCnt);
+		return SUCCESS;
+	}
+
+	/*now delete the entry*/
+	//if(entry->srcIp_t)
+		//retval = rtl865x_delIp(entry->srcIp_t->extIp);
+
+	if((entry->nextHopType == IF_PPPOE)
+			|| (entry->nextHopType == IF_PPTP)
+			|| (entry->nextHopType == IF_L2TP)
+			)
+	{
+
+		#if LINUX_VERSION_CODE > KERNEL_VERSION(3,4,0)
+		_rtl865x_deReferPpp(entry->nexthop);
+		#else
+		rtl865x_deReferPpp(entry->nexthop);
+		#endif
+
+	}
+
+	rtl865x_deReferNetif(entry->dstNetif->name);
+	memset(entry,0,sizeof(rtl865x_nextHopEntry_t));
+
+	/*update asic nextHop table*/
+	//_rtl865x_arrangeNxtHop(entryIdx,1);
+
+	return SUCCESS;
+
+}
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)  ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+static int32 _rtl865x_synNxtHop_by_arp_entry(rtl865x_nextHopEntry_t *entry_t,rtl865x_arpMapping_entry_t *arp)
+{
+	rtl865x_tblAsicDrv_nextHopParam_t asic;
+	ether_addr_t reservedMac;
+	ether_addr_t zero_mac ={{0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
+	rtl865x_tblAsicDrv_l2Param_t asic_l2;
+	rtl865x_netif_local_t *dstNetif;
+	uint32 fid = 0;
+	uint32 columIdx = 0;
+	int32 retval = 0;
+	int32 ipIdx = 0;
+
+	retval = rtl865x_getReserveMacAddr(&reservedMac);
+
+	bzero(&asic, sizeof(rtl865x_tblAsicDrv_nextHopParam_t));
+
+	if(entry_t == NULL || arp == NULL)
+	{
+		return RTL_EINVALIDINPUT;
+	}
+
+	if (entry_t->nextHopType == IF_ETHER)
+	{
+		int mac_valid = 0;
+		mac_valid = memcmp(arp->mac.octet,zero_mac.octet,ETHER_ADDR_LEN);
+
+		rtl865x_getVlanFilterDatabaseId(entry_t->dstNetif->vid,&fid);
+		retval = rtl865x_Lookup_fdb_entry(fid, (mac_valid)? &arp->mac : &reservedMac, FDB_DYNAMIC, &columIdx,&asic_l2);
+
+		asic.nextHopRow = rtl8651_filterDbIndex( (mac_valid)? &arp->mac : &reservedMac, fid );
+		asic.nextHopColumn = (retval == SUCCESS)? columIdx: 0;
+
+		asic.isPppoe = FALSE;
+		asic.pppoeIdx = 0;
+	}
+	else
+	{
+		/*session based interface type*/
+		rtl865x_ppp_t pppoe;
+		int32 pppidx = 0;
+
+		memset(&pppoe,0,sizeof(rtl865x_ppp_t));
+
+		if(entry_t->nexthop)
+			retval = rtl865x_getPppBySessionId(entry_t->nexthop,&pppoe);
+
+		rtl865x_getVlanFilterDatabaseId(entry_t->dstNetif->vid,&fid);
+
+
+		retval =rtl865x_Lookup_fdb_entry(fid, (pppoe.valid)? &pppoe.server_mac : &reservedMac, FDB_DYNAMIC, &columIdx,&asic_l2);
+
+		asic.nextHopRow = rtl8651_filterDbIndex( (pppoe.valid)? &pppoe.server_mac : &reservedMac, fid);
+		asic.nextHopColumn = (pppoe.valid)? columIdx: 0;
+		asic.isPppoe = (pppoe.type == IF_PPPOE)? TRUE: FALSE;
+
+		retval = rtl865x_getPppIdx(&pppoe, &pppidx);
+
+		//printk("%s(%d): pppoeIdx(%d), pppoeType(%d), pppoevalid(%d),pppoeSid(%d)\n",__FUNCTION__,__LINE__,pppidx,pppoe.type,pppoe.valid,pppoe.sessionId);
+		asic.pppoeIdx	= (pppoe.type == IF_PPPOE)? pppidx: 0;
+	}
+
+	if(entry_t->dstNetif->is_slave == 1)
+	{
+		dstNetif = entry_t->dstNetif->master;
+
+		if(dstNetif == NULL)
+			dstNetif = _rtl865x_getDefaultWanNetif();
+	}
+	else
+		dstNetif = entry_t->dstNetif;
+
+	if(dstNetif == NULL)
+		printk("_%s(%d), BUG!!!!!!",__FUNCTION__,__LINE__);
+
+	asic.dvid			= dstNetif->asicIdx;
+
+	if(entry_t->srcIp)
+		retval = rtl865x_getIpIdxByExtIp(entry_t->srcIp, &ipIdx);
+
+	asic.extIntIpIdx	= entry_t->srcIp? ipIdx: 0;
+
+	//printk("%s(%d), entryIdx(%d),asic.isPPPoe(%d),asic.pppoeIdx(%d),asic.dvid(%d)\n", __FUNCTION__,__LINE__,entry_t->entryIndex,asic.isPppoe,asic.pppoeIdx,asic.dvid);
+	rtl8651_setAsicNextHopTable(entry_t->entryIndex,  &asic);
+
+	return SUCCESS;
+}
+
+int32 rtl865x_eventHandle_addArp_for_multiWan(void *param)
+{
+	rtl865x_arpMapping_entry_t *arp;
+	rtl865x_nextHopEntry_t *entry;
+	int32 i;
+
+	if(param == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	arp = (rtl865x_arpMapping_entry_t *)param;
+	entry = rtl865x_nxtHopTable;
+
+	for(i = 0; i < NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		if(entry->valid && entry->nextHopType == IF_ETHER)
+		{
+			/*update nexthop*/
+			if(entry->nexthop == arp->ip)
+			{
+				_rtl865x_synNxtHop_by_arp_entry(entry,arp);
+			}
+		}
+	}
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+int32 rtl865x_eventHandle_delArp_for_multiWan(void *param)
+{
+	rtl865x_arpMapping_entry_t *arp;
+	rtl865x_nextHopEntry_t *entry;
+	int32 i;
+
+	if(param == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	arp = (rtl865x_arpMapping_entry_t *)param;
+	entry = rtl865x_nxtHopTable;
+
+	//set mac to 0 for sync nexthop
+	memset(arp->mac.octet,0,ETHER_ADDR_LEN);
+
+	for(i = 0; i < NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		if(entry->valid && entry->nextHopType == IF_ETHER)
+		{
+			/*update nexthop*/
+			if(entry->nexthop == arp->ip)
+				_rtl865x_synNxtHop_by_arp_entry(entry,arp);
+		}
+	}
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+extern int32 _rtl865x_eventHandle_6rd_addArp(rtl865x_arpMapping_entry_t * arp);
+extern int32 _rtl865x_eventHandle_6rd_delArp(rtl865x_arpMapping_entry_t * arp);
+#endif
+#endif
+
+static int32 _rtl865x_eventHandle_addArp(void *param)
+{
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+	extern int sixrd_hw_fw ;
+#endif
+#endif
+	rtl865x_arpMapping_entry_t *arp;
+	rtl865x_nextHopEntry_t *entry;
+	int32 i;
+
+	if(param == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	arp = (rtl865x_arpMapping_entry_t *)param;
+
+	entry = rtl865x_nxtHopTable;
+	for(i = 0; i < NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		/*skip ipv6 nexthop update to let ipv6 routing packet trap to cpu!!!!*/
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+		if(!sixrd_hw_fw)
+		{
+#endif
+#endif
+		if(entry->valid && entry->nextHopType == IF_ETHER)
+		{
+			/*update nexthop*/
+			if(entry->nexthop == arp->ip)
+				_rtl865x_synNxtHopToAsic(entry);
+		}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+		}
+#endif
+#endif
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+	_rtl865x_eventHandle_6rd_addArp(arp);
+#endif
+#endif
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 _rtl865x_eventHandle_delArp(void *param)
+{
+	rtl865x_arpMapping_entry_t *arp;
+	rtl865x_nextHopEntry_t *entry;
+	int32 i;
+
+	if(param == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	arp = (rtl865x_arpMapping_entry_t *)param;
+
+	entry = rtl865x_nxtHopTable;
+	for(i = 0; i < NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		if((entry->valid && entry->nextHopType == IF_ETHER))
+		{
+			/*update nexthop*/
+			if(entry->nexthop == arp->ip)
+				_rtl865x_synNxtHopToAsic(entry);
+		}
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+	_rtl865x_eventHandle_6rd_delArp(arp);
+#endif
+#endif
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 _rtl865x_eventHandle_delPpp(void *param)
+{
+	rtl865x_ppp_t *pppoe;
+	rtl865x_nextHopEntry_t *entry;
+	int32 i;
+
+	if(param == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	pppoe = (rtl865x_ppp_t *)param;
+
+	entry = rtl865x_nxtHopTable;
+	for(i = 0; i < NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		if(entry->valid )
+			if((entry->nextHopType == IF_PPPOE)
+			|| (entry->nextHopType == IF_PPTP)
+			|| (entry->nextHopType == IF_L2TP)
+			)
+			{
+				/*update nexthop*/
+				if(entry->nexthop == pppoe->sessionId)
+				{
+					/*update the action(TOCPU)*/
+					entry->nexthop  = 0;
+					_rtl865x_synNxtHopToAsic(entry);
+				}
+			}
+	}
+
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 _rtl865x_nextHop_register_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_ARP;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=_rtl865x_eventHandle_delArp;
+	rtl865x_registerEvent(&eventParam);
+
+	memset(&eventParam,0,sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId=DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_ADD_ARP;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=_rtl865x_eventHandle_addArp;
+	rtl865x_registerEvent(&eventParam);
+
+	memset(&eventParam,0,sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId=DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_PPP;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=_rtl865x_eventHandle_delPpp;
+	rtl865x_registerEvent(&eventParam);
+
+	return SUCCESS;
+
+}
+
+static int32 _rtl865x_nextHop_unRegister_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_ARP;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=_rtl865x_eventHandle_delArp;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	memset(&eventParam,0,sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId=DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_ADD_ARP;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=_rtl865x_eventHandle_addArp;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	memset(&eventParam,0,sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId=DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_PPP;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=_rtl865x_eventHandle_delPpp;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	return SUCCESS;
+
+}
+
+
+/*
+@func int32 | rtl865x_addNxtHop |add a nexthop entry
+@parm uint32 | attr | attribute. NEXTHOP_L3/NEXTHOP_REDIRECT.
+@parm void* | ref_ptr | entry pointer who refer this nexthop entry.
+@parm rtl865x_netif_local_t* | netif | network interface.
+@parm uint32 | nexthop | nexthop. ip address when linktype is ethernet, session id when linktype is ppp session based.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl865x_addNxtHop(uint32 attr, void *ref_ptr, rtl865x_netif_local_t *netif, uint32 nexthop,uint32 srcIp)
+{
+	int32 ret = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&nxthop_sem);
+	SMP_LOCK_ETH_HW(flags);
+	ret = _rtl865x_addNxtHop(attr,ref_ptr,netif,nexthop,srcIp);
+	//rtl_up(&nxthop_sem);
+	SMP_UNLOCK_ETH_HW(flags);
+	return ret;
+}
+
+/*
+@func int32 | rtl865x_delNxtHop |delete nexthop entry
+@parm uint32 | attr | attribute. NEXTHOP_L3/NEXTHOP_REDIRECT.
+@parm uint32 | entryIdx | entry index.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl865x_delNxtHop(uint32 attr, uint32 entryIdx)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&nxthop_sem);
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl865x_delNxtHop(attr,entryIdx);
+	//rtl_up(&nxthop_sem);
+	SMP_UNLOCK_ETH_HW(flags);
+	return retval;
+}
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC) || defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)||defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+int32 rtl865x_getNxtHopIdx(uint32 attr, rtl865x_netif_local_t *netif, uint32 nexthop)
+{
+	rtl865x_nextHopEntry_t *entry;
+	int32 i;
+
+	entry = rtl865x_nxtHopTable;
+	for(i = 0; i < NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		if(	(entry->valid) &&
+			(entry->flag == attr)&&
+			(entry->dstNetif == netif) &&
+			(entry->nexthop== nexthop))
+		{
+			return i;
+		}
+	}
+	return -1;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+int32 _rtl865x_eventHandle_addIpv6Arp(rtl8198c_ipv6_arpMapping_entry_t * arp)
+{
+	rtl865x_nextHopEntry_t *entry;
+	int32 i;
+	int32 dsltIndex=FAILED;
+	rtl865x_dslite_s * dsltEntry=NULL;
+	if(arp == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	entry = rtl865x_nxtHopTable;
+	for(i = 0; i < NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		if(entry->valid && entry->nextHopType == IF_DSLT)
+		{
+			/*update nexthop*/
+			if(entry->nexthop )
+			{
+				dsltIndex=_rtl865x_getIpv6DsLiteEntryByName(entry->dstNetif->name);
+				if(dsltIndex!=FAILED)
+					dsltEntry=_rtl865x_getIpv6DsLiteEntryByIndex(dsltIndex);
+
+				if(dsltEntry)
+				{
+					if(memcmp(&gw_ipv6_addr, &arp->ip, sizeof(inv6_addr_t))==0)
+				    {
+						_rtl865x_synNxtHopToAsic(entry);
+					}
+				}
+			}
+		}
+	}
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+int32 _rtl865x_eventHandle_delIpv6Arp(rtl8198c_ipv6_arpMapping_entry_t * arp)
+{
+	rtl865x_nextHopEntry_t *entry;
+	int32 i;
+	int32 dsltIndex=FAILED;
+	rtl865x_dslite_s * dsltEntry=NULL;
+
+	if(arp == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	entry = rtl865x_nxtHopTable;
+	for(i = 0; i < NXTHOP_ENTRY_NUM; i++,entry++)
+	{
+		if(entry->valid && entry->nextHopType == IF_DSLT)
+		{
+			/*update nexthop*/
+			dsltIndex=_rtl865x_getIpv6DsLiteEntryByName(entry->dstNetif->name);
+			if(dsltIndex!=FAILED)
+				dsltEntry=_rtl865x_getIpv6DsLiteEntryByIndex(dsltIndex);
+
+			if(dsltEntry)
+			{
+				if(memcmp(&gw_ipv6_addr, &arp->ip, sizeof(inv6_addr_t))==0)
+				{
+					/*reset the gw ipv6 address to reset the default gw L3 nexthop info*/
+					memset(&gw_ipv6_addr,0,sizeof(inv6_addr_t));
+					_rtl865x_synNxtHopToAsic(entry);
+				}
+			}
+		}
+	}
+	return EVENT_CONTINUE_EXECUTE;
+}
+#endif
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+int32 sw_nexthop_read(struct seq_file *s, void *v)
+{
+
+
+	uint32 idx;
+	rtl865x_nextHopEntry_t *sw_nxthop = NULL;
+
+	seq_printf(s, "%s\n", "SW Next Hop Table:\n");
+	for(idx = 0; idx < NXTHOP_ENTRY_NUM; idx++)
+	{
+		if(rtl865x_nxtHopTable[idx].valid == 0)
+			continue;
+		#if 0
+		{
+	rtl865x_netif_local_t *dstNetif;	/* dst network interface*/
+	uint32	nexthop;			/* ethernet: nexthop ip address, pppoe: session Id */
+	//rtl865x_ip_entry_t *srcIp_t;		/* for nexthop source ip table index, it's invalid  now*/
+	uint32 srcIp;		/* for nexthop source ip table index*/
+
+	uint16 valid:1,		/* 0: Invalid, 1: Invalid */
+		nextHopType:3,			/* IF_ETHER, IF_PPPOE */
+		flag:3;			/* bit0:referenced by l3, bit2:referenced by acl */
+
+	uint16	refCnt;			/* Reference Count */
+	uint32	entryIndex;			/* Entry Index */
+
+}
+#endif
+		sw_nxthop =&rtl865x_nxtHopTable[idx];
+		seq_printf(s,"  [%d]  entryIndex(%d)  type(%d) netif(%s) srcIp(%x)  nextHop(%x) \n", idx,
+			sw_nxthop->entryIndex,sw_nxthop->nextHopType,sw_nxthop->dstNetif->name,
+			sw_nxthop->srcIp, sw_nxthop->nexthop);
+	}
+
+	return 0;
+}
+#else
+int32 sw_nexthop_read( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int len;
+	rtl865x_nextHopEntry_t *sw_nxthop=NULL;
+
+	uint32 idx;
+
+	len = sprintf(page, "%s\n", "SW Next Hop Table:\n");
+	for(idx = 0; idx < NXTHOP_ENTRY_NUM; idx++)
+	{
+		if(rtl865x_nxtHopTable[idx].valid == 0)
+			continue;
+		sw_nxthop =&rtl865x_nxtHopTable[idx];
+		len += sprintf(page + len,"  [%d]  entryIndex(%d)  type(%d) netif(%s) srcIp(%d)  nextHop(%d) n", idx,
+			sw_nxthop->nextHopType,sw_nxthop->entryIndex,sw_nxthop->dstNetif->name,
+			sw_nxthop->srcIp, sw_nxthop->nexthop);
+	}
+
+	return len;
+}
+#endif
+
+int32 sw_nexthop_write( struct file *filp, const char *buff,unsigned long len, void *data )
+{
+	return len;
+}
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_nexthop.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_nexthop.h
new file mode 100644
index 00000000..504d77f
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_nexthop.h
@@ -0,0 +1,74 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : nexthop table driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#ifndef	RTL865X_NEXTHOP_H
+#define	RTL865X_NEXTHOP_H
+
+#if 0//!defined(REDUCE_MEMORY_SIZE_FOR_16M)
+#define REDUCE_MEMORY_SIZE_FOR_16M
+#endif
+
+
+typedef struct rtl865x_nextHopEntry_s
+{
+	rtl865x_netif_local_t *dstNetif;	/* dst network interface*/
+	uint32	nexthop;			/* ethernet: nexthop ip address, pppoe: session Id */
+	//rtl865x_ip_entry_t *srcIp_t;		/* for nexthop source ip table index, it's invalid  now*/
+	uint32 srcIp;		/* for nexthop source ip table index*/
+
+	uint16 valid:1,		/* 0: Invalid, 1: Invalid */
+		nextHopType:3,			/* IF_ETHER, IF_PPPOE */
+		flag:3;			/* bit0:referenced by l3, bit2:referenced by acl */
+
+	uint16	refCnt;			/* Reference Count */
+	uint32	entryIndex;			/* Entry Index */
+
+} rtl865x_nextHopEntry_t;
+
+#define NEXTHOP_L3					0x01
+#define NEXTHOP_DEFREDIRECT_ACL	0x02
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+#define NXTHOP_ENTRY_NUM	16
+#else
+#if defined(REDUCE_MEMORY_SIZE_FOR_16M)
+#define NXTHOP_ENTRY_NUM	4
+#else
+#define NXTHOP_ENTRY_NUM	16
+#endif
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+#undef NXTHOP_ENTRY_NUM
+#if defined(CONFIG_RTL_8198C) ||defined(CONFIG_RTL_8197F)
+#define NXTHOP_ENTRY_NUM	32
+#else
+#define NXTHOP_ENTRY_NUM	16
+#endif
+#endif
+
+int32 rtl865x_initNxtHopTable(void);
+int32 rtl865x_reinitNxtHopTable(void);
+int32 rtl865x_addNxtHop(uint32 attr, void *ref_ptr, rtl865x_netif_local_t *netif, uint32 nexthop,uint32 srcIp);
+int32 rtl865x_delNxtHop(uint32 attr, uint32 entryIdx);
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC) || defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)  ||defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+int32 rtl865x_getNxtHopIdx(uint32 attr, rtl865x_netif_local_t *netif, uint32 nexthop);
+#endif
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+int32 rtl865x_eventHandle_addArp_for_multiWan(void *param);
+int32 rtl865x_eventHandle_delArp_for_multiWan(void *param);
+#endif
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ppp.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ppp.c
new file mode 100644
index 00000000..df47e88
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ppp.c
@@ -0,0 +1,682 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : ppp table driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+/*      @doc RTL_LAYEREDDRV_API
+
+	@module rtl865x_ppp.c - RTL865x Home gateway controller Layered driver API documentation       |
+	This document explains the API interface of the table driver module. Functions with rtl865x prefix
+	are external functions.
+	@normal Hyking Liu (Hyking_liu@realsil.com.cn) <date>
+
+	Copyright <cp>2008 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+	@head3 List of Symbols |
+	Here is a list of all functions and variables in this module.
+
+	@index | RTL_LAYEREDDRV_API
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include <net/rtl/rtl865x_ppp.h>
+#include <net/rtl/rtl865x_netif.h>
+#include <net/rtl/rtl865x_fdb_api.h>
+
+#include "common/rtl_errno.h"
+#include "common/rtl865x_netif_local.h"
+#include "rtl865x_ppp_local.h"
+
+#include "common/rtl865x_eventMgr.h" /*call back function....*/
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#endif
+
+#include "common/rtl865x_vlan.h"
+#include "l2Driver/rtl865x_fdb.h"
+
+static rtl865x_ppp_t *rtl865x_pppTable;
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+static rtl865x_ppp_t rtl865x_pppTable_bak[PPP_NUMBER];
+#endif
+
+#define PPP_TABLE_INDEX(entry)	(entry - rtl865x_pppTable)
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
+static RTL_DECLARE_MUTEX(ppp_sem);
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+extern bool rtl_hwnat_enable;
+#define CHECK_IF_HWNAT_READY if (!rtl_hwnat_enable) return SUCCESS
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+static int32 _rtl865x_ppp_register_event(void);
+static int32 _rtl865x_ppp_unRegister_event(void);
+static int32 _rtl865x_delPpp(uint32 sessionId);
+
+/*
+@func int32 | rtl865x_initPppTable | initialize ppp table.
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed.
+*/
+int32 rtl865x_initPppTable(void)
+{
+	TBL_MEM_ALLOC(rtl865x_pppTable, rtl865x_ppp_t, PPP_NUMBER);
+	memset(rtl865x_pppTable,0,sizeof(rtl865x_ppp_t)*PPP_NUMBER);
+
+	/*event regist....*/
+	_rtl865x_ppp_register_event();
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865x_reinitPppTable | reinitialize ppp table.
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed.
+*/
+int32 rtl865x_reinitPppTable(void)
+{
+	int32 i;
+	_rtl865x_ppp_unRegister_event();
+
+	for(i = 0; i < PPP_NUMBER; i++)
+	{
+		if(rtl865x_pppTable[i].valid == 1)
+			_rtl865x_delPpp(rtl865x_pppTable[i].sessionId);
+	}
+
+	_rtl865x_ppp_register_event();
+	return SUCCESS;
+}
+
+
+
+static int32 _rtl865x_delPpp(uint32 sessionId)
+{
+	int i;
+	rtl865x_ppp_t *entry = NULL;
+	rtl865x_tblAsicDrv_pppoeParam_t asicppp;
+	int32 retval = FAILED;
+	uint32 fid;
+
+	/*found the entry*/
+	for(i = 0; i < PPP_NUMBER; i++)
+	{
+		if(rtl865x_pppTable[i].valid == 1 && rtl865x_pppTable[i].sessionId== sessionId)
+		{
+			entry = &rtl865x_pppTable[i];
+			break;
+		}
+	}
+
+	if (entry==NULL)
+		return SUCCESS;
+	/*check reference count*/
+	if(entry->refCnt > 1)
+	{
+		printk("Please del other table entry which referenced me...ppp sessionId(%d)\n",sessionId);
+		return RTL_EREFERENCEDBYOTHER;
+	}
+
+
+	/*del asic ppp table*/
+	asicppp.age = 0;
+	asicppp.sessionId = 0;
+	rtl8651_setAsicPppoe(PPP_TABLE_INDEX(entry), &asicppp);
+
+	/*FIXME_hyking:dereference netif & mac*/
+	retval = rtl865x_deReferNetif(entry->netif->name);
+
+	retval = rtl865x_getVlanFilterDatabaseId(entry->netif->vid, &fid);
+
+	retval = rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEII, fid, &entry->server_mac);
+
+
+	/*raise event??*/
+	rtl865x_raiseEvent(EVENT_DEL_PPP,(void *)entry);
+
+	memset(entry,0,sizeof(rtl865x_ppp_t));
+
+
+	return SUCCESS;
+
+}
+static int32 _rtl865x_addPpp(uint8 *ifname, ether_addr_t *mac, uint32 sessionId, int32 type)
+{
+	int i;
+	rtl865x_netif_local_t *netif;
+	rtl865x_ppp_t *entry = NULL;
+	rtl865x_tblAsicDrv_pppoeParam_t asicPpp;
+	rtl865x_tblAsicDrv_l2Param_t fdbEntry;
+	rtl865x_filterDbTableEntry_t	 l2temp_entry;
+	uint32 fid,column;
+	int32 retval;
+	uint32 fdb_type[]={ FDB_STATIC, FDB_DYNAMIC };
+
+/*printk("%s(%d): ifname(%s),mac(%02x:%02x:%02x:%02x:%02x:%02x),sid(%d),type(%d)",__FUNCTION__,__LINE__,ifname,
+	mac->octet[0],mac->octet[1],mac->octet[2],mac->octet[3],mac->octet[4],mac->octet[5], sessionId,type);*/
+
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	CHECK_IF_HWNAT_READY;
+	#endif /* CONFIG_RTD_1295_HWNAT */
+#if 1	//Do not add hw ppp info in wisp or bridge mode
+	{
+		extern int rtl865x_curOpMode;
+		if ((rtl865x_curOpMode==1) ||(rtl865x_curOpMode==2)) // BRIDGE_MODE or WISP_MODE
+			return RTL_ENETIFINVALID;
+	}
+#endif
+
+	/*duplicate check*/
+	for(i = 0; i < PPP_NUMBER; i++)
+	{
+		if(rtl865x_pppTable[i].valid && rtl865x_pppTable[i].sessionId == sessionId)
+			return RTL_EENTRYALREADYEXIST;
+	}
+
+	netif = _rtl865x_getSWNetifByName(ifname);
+	if(netif == NULL)
+		return RTL_ENETIFINVALID;
+
+	if(netif->if_type != IF_PPPOE)
+		return RTL_ELINKTYPESHOULDBERESET;
+
+	/*found a valid entry*/
+	for(i = 0; i < PPP_NUMBER; i++)
+		if(rtl865x_pppTable[i].valid == 0)
+		{
+			entry = &rtl865x_pppTable[i];
+			break;
+		}
+
+	if(entry == NULL)
+		return RTL_ENOFREEBUFFER;
+
+
+
+	/*update releated information*/
+	entry->valid = 1;
+	entry->netif = netif;
+	memcpy(&entry->server_mac,mac,sizeof(ether_addr_t));
+	entry->sessionId = sessionId;
+	entry->type = type;
+	entry->refCnt = 1;
+
+	/*add this ip entry to asic*/
+	/* Set asic */
+	bzero(&asicPpp, sizeof(rtl865x_tblAsicDrv_pppoeParam_t));
+	asicPpp.sessionId = sessionId;
+	asicPpp.age = 300;
+
+	rtl8651_setAsicPppoe(PPP_TABLE_INDEX(entry), &asicPpp);
+
+
+	/*FIXME_hyking:reference netif & mac*/
+	retval = rtl865x_referNetif(netif->name);
+
+	/*add fdb entry...*/
+	fid = 0;
+	column = 0;
+	retval = rtl865x_getVlanFilterDatabaseId(netif->vid,&fid);
+
+	for(i = 0; i < 2; i++)
+	{
+		/*
+		printk("%s:%d\n,fid(%d),mac(%02x:%02x:%02x:%02x:%02x:%02x)\n",__FUNCTION__,__LINE__,fid,mac->octet[0],mac->octet[1],
+			mac->octet[2],mac->octet[3],mac->octet[4],mac->octet[5]);
+
+		printk("%s:%d\n",__FUNCTION__,__LINE__);
+		*/
+		if(rtl865x_Lookup_fdb_entry(fid, mac, fdb_type[i], &column,&fdbEntry) != SUCCESS)
+		{
+			continue;
+		}
+
+
+		/*in case of layer2 auto learn, add hardware entry to layer 2 software table*/
+		l2temp_entry.l2type = (fdbEntry.nhFlag==0)?RTL865x_L2_TYPEI: RTL865x_L2_TYPEII;
+		l2temp_entry.process = FDB_TYPE_FWD;
+		l2temp_entry.memberPortMask = fdbEntry.memberPortMask;
+		l2temp_entry.auth = fdbEntry.auth;
+		l2temp_entry.SrcBlk = fdbEntry.srcBlk;
+		memcpy(&(l2temp_entry.macAddr), mac, sizeof(ether_addr_t));
+		rtl865x_addFilterDatabaseEntryExtension(fid, &l2temp_entry);
+//		retval = _rtl865x_addFilterDatabaseEntry((fdbEntry.nhFlag==0)?RTL865x_L2_TYPEI: RTL865x_L2_TYPEII, fid, mac, FDB_TYPE_FWD, fdbEntry.memberPortMask, fdbEntry.auth,fdbEntry.srcBlk);
+		rtl865x_refleshHWL2Table(mac, FDB_DYNAMIC|FDB_STATIC,fid);
+	}
+
+	/*raise event??*/
+	rtl865x_raiseEvent(EVENT_ADD_PPP, (void*)entry);
+
+	return SUCCESS;
+
+}
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl865x_addPpp);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+static int32 _rtl865x_eventHandle_delNetif(void *para)
+{
+	rtl865x_netif_local_t *netif;
+	rtl865x_ppp_t *entry = NULL;
+	int32 i = 0;
+	if(para == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	netif = (rtl865x_netif_local_t *)para;
+
+	entry = rtl865x_pppTable;
+	for(i = 0 ; i < PPP_NUMBER;i++,entry++)
+	{
+		#if !defined(CONFIG_OPENWRT_SDK)
+		if((entry->valid) && entry->netif == netif)
+			printk("%s(%d): BUG....deleted netif is referenced by ppp table!\n",__FUNCTION__,__LINE__);
+		#endif
+	}
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 _rtl865x_eventHandle_delL2Fdb(void * param)
+{
+	rtl865x_filterDbTableEntry_t  *fdbEntry;
+	rtl865x_ppp_t *entry = NULL;
+	int32 i;
+
+	if(param == NULL)
+		return EVENT_CONTINUE_EXECUTE;
+
+	fdbEntry = (rtl865x_filterDbTableEntry_t *)param;
+
+	entry = rtl865x_pppTable;
+	for(i = 0; i < PPP_NUMBER; i++,entry++)
+	{
+		//if((entry->valid) && memcmp(&entry->server_mac,&fdbEntry->macAddr,sizeof(ether_addr_t)) == 0)
+			//printk("%s(%d): BUG....deleted l2 fdb is referenced by ppp table!\n",__FUNCTION__,__LINE__);
+	}
+
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 rtl865x_ppp_eventHandle_delNetif(void *para)
+{
+	int32 retval = EVENT_CONTINUE_EXECUTE;
+	//rtl_down_interruptible(&ppp_sem);
+	retval = _rtl865x_eventHandle_delNetif(para);
+	//rtl_up(&ppp_sem);
+	return retval;
+}
+
+static int32 rtl865x_ppp_eventHandle_delL2Fdb(void *para)
+{
+	int32 retval = EVENT_CONTINUE_EXECUTE;
+	//rtl_down_interruptible(&ppp_sem);
+	retval = _rtl865x_eventHandle_delL2Fdb(para);
+	//rtl_up(&ppp_sem);
+	return retval;
+}
+
+
+static int32 _rtl865x_ppp_register_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_FDB;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_ppp_eventHandle_delL2Fdb;
+	rtl865x_registerEvent(&eventParam);
+
+	memset(&eventParam,0,sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId=DEFAULT_COMMON_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_NETIF;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_ppp_eventHandle_delNetif;
+	rtl865x_registerEvent(&eventParam);
+
+	return SUCCESS;
+
+}
+
+static int32 _rtl865x_ppp_unRegister_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+	eventParam.eventLayerId=DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_FDB;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_ppp_eventHandle_delL2Fdb;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	memset(&eventParam,0,sizeof(rtl865x_event_Param_t));
+	eventParam.eventLayerId=DEFAULT_COMMON_EVENT_LIST_ID;
+	eventParam.eventId=EVENT_DEL_NETIF;
+	eventParam.eventPriority=0;
+	eventParam.event_action_fn=rtl865x_ppp_eventHandle_delNetif;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	return SUCCESS;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,4,0)
+static
+#endif
+int32 _rtl865x_referPpp(uint32 sessionId)
+{
+	int i;
+	rtl865x_ppp_t *entry = NULL;
+
+	entry = rtl865x_pppTable;
+	for(i = 0; i < PPP_NUMBER; i++,entry++)
+		if(entry->valid && (entry->sessionId == sessionId))
+		{
+			entry->refCnt++;
+			return SUCCESS;
+		}
+	return FAILED;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,4,0)
+static
+#endif
+int32 _rtl865x_deReferPpp(uint32 sessionId)
+{
+	int i;
+	rtl865x_ppp_t *entry = NULL;
+
+	entry = rtl865x_pppTable;
+	for(i = 0; i < PPP_NUMBER; i++,entry++)
+		if(entry->valid && (entry->sessionId == sessionId))
+		{
+			entry->refCnt--;
+			return SUCCESS;
+		}
+	return FAILED;
+}
+
+/*
+@func int32 | rtl865x_referPpp |refer ppp table entry.
+@parm uint32 | sessionId | ppp session ID
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_referPpp(uint32 sessionId)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&ppp_sem);
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl865x_referPpp(sessionId);
+	//rtl_up(&ppp_sem);
+	SMP_UNLOCK_ETH_HW(flags);
+	return retval;
+}
+/*
+@func int32 | rtl865x_deReferPpp |dereference ppp table entry.
+@parm uint32 | sessionId | ppp session ID
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_deReferPpp(uint32 sessionId)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&ppp_sem);
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl865x_deReferPpp(sessionId);
+	//rtl_up(&ppp_sem);
+	SMP_UNLOCK_ETH_HW(flags);
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_addPpp |add ppp session information.
+@parm uint8* | ifname | network interface name
+@parm ether_addr_t* | mac | MAC Address of ppp session server
+@parm uint32 | sessionId | ppp session ID
+@parm int32 | type | connect type. should be IF_PPPOE/IF_PPTP/IF_L2TP
+@rvalue SUCCESS | Success.
+@rvalue RTL_EENTRYALREADYEXIST | entry already exist.
+@rvalue RTL_ELINKTYPESHOULDBERESET | link type is error.
+@rvalue RTL_ENOFREEBUFFER | no enough memory buffer in system.
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_addPpp(uint8 *ifname, ether_addr_t *mac, uint32 sessionId, int32 type)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//printk("====================%s(%d): sessionId(%d) ifname(%s) retval(%d)\n",__FUNCTION__,__LINE__,sessionId,ifname,retval);
+	//rtl_down_interruptible(&ppp_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_addPpp(ifname, mac, sessionId, type);
+	//rtl_up(&ppp_sem);
+	SMP_UNLOCK_ETH(flags);
+	//printk("====================%s(%d): sessionId(%d) retval(%d)\n",__FUNCTION__,__LINE__,sessionId,retval);
+	return retval;
+
+}
+
+/*
+@func int32 | rtl865x_delPpp |delete ppp session information.
+@parm uint32 | sessionId | ppp session ID
+@rvalue SUCCESS | Success.
+@rvalue RTL_EREFERENCEDBYOTHER | entry is refered by other table entry.
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_delPpp(uint32 sessionId)
+{
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	//rtl_down_interruptible(&ppp_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_delPpp(sessionId);
+	//rtl_up(&ppp_sem);
+	SMP_UNLOCK_ETH(flags);
+	//printk("====================%s(%d): sessionId(%d) retval(%d)\n",__FUNCTION__,__LINE__,sessionId,retval);
+	return retval;
+
+}
+
+/*
+@func int32 | rtl865x_delPppbyIfName |delete ppp session by network interface name.
+@parm char* | name | network interface name.
+@rvalue SUCCESS | Success.
+@rvalue RTL_EREFERENCEDBYOTHER | entry is refered by other table entry.
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_delPppbyIfName(char *name)
+{
+	int i;
+	rtl865x_ppp_t *entry = NULL;
+	int32 retval = FAILED;
+	unsigned long flags=0;
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	CHECK_IF_HWNAT_READY;
+	#endif /* CONFIG_RTD_1295_HWNAT */
+
+	//rtl_down_interruptible(&ppp_sem);
+	SMP_LOCK_ETH(flags);
+	for(i = 0; i < PPP_NUMBER; i++)
+		#if defined(CONFIG_RTD_1295_HWNAT)
+		if(rtl865x_pppTable[i].valid &&
+			(strlen(rtl865x_pppTable[i].netif->name) == strlen(name)) &&
+			(memcmp(rtl865x_pppTable[i].netif->name,name,strlen(name)) == 0))
+		#else //defined(CONFIG_RTD_1295_HWNAT)
+		if(rtl865x_pppTable[i].valid && (memcmp(rtl865x_pppTable[i].netif->name,name,sizeof(name)) == 0))
+		#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+		{
+			entry = &rtl865x_pppTable[i];
+			break;
+		}
+
+	if(entry)
+		retval = _rtl865x_delPpp(entry->sessionId);
+	//rtl_up(&ppp_sem);
+	SMP_UNLOCK_ETH(flags);
+	return retval;
+}
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl865x_delPppbyIfName);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+/*
+@func int32 | rtl865x_getPppBySessionId |get ppp session information by session ID.
+@parm uint32 | sessionId | ppp session ID
+@parm rtl865x_ppp_t* | entry | ppp entry.
+@rvalue SUCCESS | Success.
+@rvalue FAILED | Failed
+@comm
+*/
+int32 rtl865x_getPppBySessionId(uint32 sessionId,rtl865x_ppp_t *entry)
+{
+	rtl865x_ppp_t *ppp = NULL;
+	int32 retval = FAILED;
+	int i;
+
+	for(i = 0; i < PPP_NUMBER; i++)
+	{
+		if(rtl865x_pppTable[i].valid && rtl865x_pppTable[i].sessionId== sessionId)
+			ppp = &rtl865x_pppTable[i];
+	}
+
+	if(ppp && entry)
+	{
+		memcpy(entry,ppp,sizeof(rtl865x_ppp_t));
+		retval = SUCCESS;
+	}
+
+	return retval;
+
+}
+
+/*
+@func rtl865x_ppp_t* | rtl865x_getPppByNetifName |get ppp session information by network interface name.
+@parm char* | name | network interface name.
+@rvalue NULL | Failed
+@comm
+*/
+rtl865x_ppp_t* rtl865x_getPppByNetifName(char *name)
+{
+	rtl865x_ppp_t *ppp = NULL;
+	int i;
+
+	for(i = 0; i < PPP_NUMBER; i++)
+	{
+		#if defined(CONFIG_RTD_1295_HWNAT)
+		if(rtl865x_pppTable[i].valid &&
+			(strlen(rtl865x_pppTable[i].netif->name) == strlen(name)) &&
+			(memcmp(rtl865x_pppTable[i].netif->name,name,strlen(name)) == 0))
+		#else //defined(CONFIG_RTD_1295_HWNAT)
+		if(rtl865x_pppTable[i].valid && (memcmp(rtl865x_pppTable[i].netif->name,name,sizeof(name)) == 0))
+		#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+		{
+			ppp = &rtl865x_pppTable[i];
+			break;
+		}
+	}
+
+	return ppp;
+
+
+}
+
+/*
+@func int32 | rtl865x_getPppIdx |get ppp session entry index.
+@parm rtl865x_ppp_t* | ppp | ppp entry.
+@parm int32* | idx | return value for index.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl865x_getPppIdx(rtl865x_ppp_t *ppp, int32 *idx)
+{
+	int32 i = 0;
+	rtl865x_ppp_t *entry;
+	entry = rtl865x_pppTable;
+	for(i = 0; i < PPP_NUMBER; i++,entry++)
+	{
+		if(entry->valid && entry->sessionId == ppp->sessionId)
+		{
+			if(idx)
+				*idx = i;
+			return SUCCESS;
+		}
+	}
+
+	return FAILED;
+}
+
+/*
+int32 rtl865x_printPpp(void)
+{
+	int i;
+	for(i = 0; i < PPP_NUMBER; i++)
+	{
+		printk("====idx(%d),rtl865x_pppTable.valid(%d),refcnt(%d),session(%d),type(%d)\n", i,rtl865x_pppTable[i].valid,rtl865x_pppTable[i].refCnt,rtl865x_pppTable[i].sessionId,rtl865x_pppTable[i].type);
+	}
+	return SUCCESS;
+}
+*/
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+int rtl819x_save_hw_ppp_table(void)
+{
+	int i = 0;
+	uint32 fid = RTL_WAN_FID;
+
+	memset((void *)&rtl865x_pppTable_bak,0,sizeof(rtl865x_pppTable_bak));
+
+	for(i = 0; i < PPP_NUMBER; i++)
+	{
+		if(rtl865x_pppTable[i].valid == 1)
+		{
+			rtl865x_pppTable_bak[i].netif = rtl865x_pppTable[i].netif;
+			rtl865x_pppTable_bak[i].sessionId = rtl865x_pppTable[i].sessionId;
+			rtl865x_pppTable_bak[i].valid = rtl865x_pppTable[i].valid;
+			rtl865x_pppTable_bak[i].type = rtl865x_pppTable[i].type;
+			rtl865x_pppTable_bak[i].refCnt = rtl865x_pppTable[i].refCnt;
+			memcpy(rtl865x_pppTable_bak[i].server_mac.octet, rtl865x_pppTable[i].server_mac.octet, ETHER_ADDR_LEN);
+			//save ppp server related l2 entry.
+			rtl865x_getVlanFilterDatabaseId(rtl865x_pppTable[i].netif->vid,&fid);
+			rtl819x_save_inused_l2_entry(0, (ether_addr_t *)&rtl865x_pppTable[i].server_mac, fid);
+		}
+	}
+
+	return SUCCESS;
+}
+int rtl819x_restore_hw_ppp_table(void)
+{
+	int i = 0;
+	rtl865x_ppp_t *entry = NULL;
+
+	for(i = 0; i < PPP_NUMBER; i++)
+	{
+		if (rtl865x_pppTable_bak[i].valid == 1){
+			entry = &rtl865x_pppTable_bak[i];
+			rtl865x_addPpp(entry->netif->name, (ether_addr_t *)&entry->server_mac, entry->sessionId, entry->type);
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ppp_local.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ppp_local.h
new file mode 100644
index 00000000..129286d
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_ppp_local.h
@@ -0,0 +1,38 @@
+/*
+ * Copyright c                  Realtek Semiconductor Corporation, 2008
+ * All rights reserved.
+ *
+ * Program : ppoe table driver
+ * Abstract :
+ * Author : hyking (hyking_liu@realsil.com.cn)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+#ifndef RTL865X_PPP_LOCAL_H
+#define RTL865X_PPP_LOCAL_H
+
+typedef struct rtl865x_ppp_s
+{
+        rtl865x_netif_local_t *netif;   /*dest network interface*/
+        ether_addr_t server_mac;        /*server mac address*/
+        uint32 sessionId;
+        uint16 valid:1,
+                type:5; /*PPPOE, PPTP, L2TP */
+
+        uint16 refCnt;
+} rtl865x_ppp_t;
+
+int32 rtl865x_getPppIdx(rtl865x_ppp_t *entry, int32 *idx);
+int32 rtl865x_getPppBySessionId(uint32 sessionId,rtl865x_ppp_t *entry);
+rtl865x_ppp_t* rtl865x_getPppByNetifName(char *name);
+
+int32 rtl865x_initPppTable(void);
+int32 rtl865x_reinitPppTable(void);
+int32 rtl865x_referPpp(uint32 sessionId);
+int32 rtl865x_deReferPpp(uint32 sessionId);
+
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_route.c b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_route.c
new file mode 100644
index 00000000..3597cde
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_route.c
@@ -0,0 +1,1456 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : route table driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+/*      @doc RTL_LAYEREDDRV_API
+
+		@module rtl865x_route.c - RTL865x Home gateway controller Layered driver API documentation       |
+		This document explains the API interface of the table driver module. Functions with rtl865x prefix
+		are external functions.
+		@normal Hyking Liu (Hyking_liu@realsil.com.cn) <date>
+
+		Copyright <cp>2008 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+		@head3 List of Symbols |
+		Here is a list of all functions and variables in this module.
+
+		@index | RTL_LAYEREDDRV_API
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+//#include <net/rtl/rtl865x_ppp.h>
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl_errno.h"
+//#include "rtl_utils.h"
+#include "common/rtl865x_netif_local.h"
+#include "rtl865x_ppp_local.h"
+#include "rtl865x_route.h"
+#include "rtl865x_ip.h"
+#include "rtl865x_nexthop.h"
+#include "rtl865x_arp.h"
+
+//#include "common/rtl_glue.h"
+#include "common/rtl865x_eventMgr.h" /*call back function....*/
+#include "common/rtl865x_vlan.h"
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#include "AsicDriver/rtl865x_asicL3.h"
+#else
+#include "AsicDriver/rtl865xC_tblAsicDrv.h"
+#endif
+#include "l2Driver/rtl865x_fdb.h"
+#include "AsicDriver/rtl865xc_asicregs.h"
+#include <net/rtl/rtl865x_fdb_api.h>
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#include "rtl8198c_arpIpv6.h"
+#include "rtl8198c_nexthopIpv6.h"
+#endif
+
+static rtl865x_route_t *rtl865x_route_freeHead;
+static rtl865x_route_t *rtl865x_route_inusedHead;
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
+static RTL_DECLARE_MUTEX(route_sem);
+#endif
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+extern int32  _rtl865x_getIpv6DsLiteEntryByName(char * devName);
+extern int32 _rtl865x_delIpv6DsLiteEntry(uint32 entryIdx);
+#endif
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)//&&defined(REINIT_SWITCH_CORE)
+static rtl865x_route_t rtl865x_route_inused_bak[RT_DRV_ENTRY_NUM];
+#endif
+#if 0
+void _rtl865x_route_print(void)
+{
+	int32 i;
+	rtl865x_route_t *rt = NULL;
+	rt = rtl865x_route_inusedHead;
+
+	printk("=============inused list:\n");
+	while(rt)
+	{
+		printk("asicIdx(%d),ip(0x%x),mask(0x%x),nextHop(0x%x),process(0x%x),dst(%s) valid(%d)\n",rt->asicIdx, rt->ipAddr,rt->ipMask,rt->nextHop,rt->process,rt->dstNetif->name,rt->valid);
+		rt = rt->next;
+	}
+
+	i = 0;
+	rt = rtl865x_route_freeHead;
+	while(rt)
+	{
+		i++;
+		rt = rt->next;
+	}
+
+	printk("=======free list count(%d)\n",i);
+}
+#endif
+
+
+static rtl865x_route_t* _rtl865x_getDefaultRoute(void)
+{
+	rtl865x_route_t *rt = NULL;
+	rt = rtl865x_route_inusedHead;
+
+	while(rt)
+	{
+		if((rt->valid==1)&&(rt->asicIdx == RT_ASIC_ENTRY_NUM -1))
+			return rt;
+		rt = rt->next;
+	}
+
+	return NULL;
+}
+
+static rtl865x_route_t* _rtl865x_getRouteEntry(ipaddr_t ipAddr, ipaddr_t ipMask)
+{
+	rtl865x_route_t *rt = NULL;
+	rt = rtl865x_route_inusedHead;
+
+	while(rt)
+	{
+		if((rt->valid==1)&&((rt->ipAddr&rt->ipMask)==(ipAddr&ipMask))&&(rt->ipMask==ipMask))
+			return rt;
+		rt = rt->next;
+	}
+	return NULL;
+}
+
+
+static int32 _rtl865x_synRouteToAsic(rtl865x_route_t *rt_t)
+{
+	int32 ret = FAILED;
+	rtl865x_tblAsicDrv_routingParam_t asic_t;
+	rtl865x_tblAsicDrv_l2Param_t asic_l2;
+	rtl865x_netif_local_t *dstNetif = NULL;
+	uint32 columIdx,fid=0;
+	int32 pppIdx = 0;
+
+	bzero(&asic_t, sizeof(rtl865x_tblAsicDrv_routingParam_t));
+
+	if(rt_t == NULL)
+	{
+		printk("%s(%d):NULL!!!!!!!!!!!!!!!!\n",__FUNCTION__,__LINE__);
+		return FAILED;
+	}
+	/*common information*/
+	asic_t.ipAddr	= rt_t->ipAddr;
+	asic_t.ipMask	= rt_t->ipMask;
+	asic_t.ipAddr = rt_t->ipAddr;
+	asic_t.ipMask = rt_t->ipMask;
+	/*if the dstNetif is attach on another interface, the netifIdx should the master interface's index*/
+	if(rt_t->dstNetif->is_slave == 1)
+	{
+		//printk("========%s(%d), ip(0x%x),mask(0x%x),netif(%s)\n",__FUNCTION__,__LINE__,rt_t->ipAddr,rt_t->ipMask,rt_t->dstNetif->name);
+		dstNetif = _rtl865x_getNetifByName(rt_t->dstNetif->name);
+		if(dstNetif == NULL)
+			dstNetif = _rtl865x_getDefaultWanNetif();
+	}
+	else
+		dstNetif = rt_t->dstNetif;
+
+	if(dstNetif == NULL){
+		printk("%s(%d) BUG!!!!!!\n",__FUNCTION__,__LINE__);
+		return FAILED;
+	}
+
+	asic_t.vidx = dstNetif->asicIdx;
+	asic_t.internal = rt_t->dstNetif->is_wan? 0 : 1;
+	asic_t.DMZFlag = rt_t->dstNetif->dmz? 1 : 0;
+	asic_t.process = rt_t->process;
+
+	switch (rt_t->process)
+	{
+	case RT_PPPOE:
+		ret = rtl865x_getPppIdx(rt_t->un.pppoe.pppInfo, &pppIdx);
+
+		asic_t.pppoeIdx = pppIdx;
+		/*
+		*if process==RT_PPPOE, the mac address of pppoe server is add in pppoe module,
+		*so, we read the FDB information directly....
+		*/
+		ret = rtl865x_getVlanFilterDatabaseId(rt_t->dstNetif->vid,&fid);
+		ret = rtl865x_Lookup_fdb_entry(fid, (ether_addr_t *)rt_t->un.pppoe.macInfo, FDB_DYNAMIC, &columIdx,&asic_l2);
+
+		if(ret != SUCCESS)
+		{
+			printk("can't get l2 entry by mac.....\n");
+
+			#if defined(CONFIG_RTL_CUSTOM_PASSTHRU_PPPOE)
+			/*pppoe passthru will set pppoe pkt vid=100, then pppoe server mac
+			will be learnt on fid=0.Here we need to add it to fid=1 too.*/
+			if (rtl865x_Lookup_fdb_entry(RTL_LAN_FID, (ether_addr_t *)rt_t->un.pppoe.macInfo, FDB_DYNAMIC, &columIdx,&asic_l2) == SUCCESS) {
+				//ret = rtl865x_addFilterDatabaseEntry(fid, (ether_addr_t *)rt_t->un.pppoe.macInfo, asic_l2.memberPortMask, FDB_TYPE_FWD);
+				if (rt_t->un.pppoe.macInfo != NULL)
+				{
+					ret = _rtl865x_addFilterDatabaseEntry(RTL865x_L2_TYPEII, fid,  (ether_addr_t *)rt_t->un.pppoe.macInfo, FDB_TYPE_FWD, asic_l2.memberPortMask, FALSE, FALSE);
+				}
+
+				ret = rtl865x_Lookup_fdb_entry(fid, (ether_addr_t *)rt_t->un.pppoe.macInfo, FDB_STATIC, &columIdx,&asic_l2);
+				//panic_printk("rtl865x_Lookup_fdb_entry ret is %d.....\n", ret);
+			}
+			#endif
+		}
+
+		/*FIXME_hyking: update mac/fdb table reference count*/
+		asic_t.nextHopRow = rtl8651_filterDbIndex( rt_t->un.pppoe.macInfo,fid);
+		asic_t.nextHopColumn = columIdx;
+		break;
+
+	case RT_L2:
+		/*
+		* NOTE:this type not used now...
+		* if we want to use it, please add FDB entry to sure this L2 entry in both software FDB table and Asic L2 table.
+		*/
+		ret = rtl865x_getVlanFilterDatabaseId(rt_t->dstNetif->vid,&fid);
+		ret = rtl865x_Lookup_fdb_entry(fid, (ether_addr_t *)rt_t->un.direct.macInfo, FDB_STATIC, &columIdx,&asic_l2);
+
+		if(ret != SUCCESS)
+			printk("can't get l2 entry by mac.....***************\n");
+
+		/*FIXME_hyking: update mac/fdb table reference count*/
+		asic_t.nextHopRow = rtl8651_filterDbIndex(rt_t->un.direct.macInfo,fid);
+		asic_t.nextHopColumn = columIdx;
+		break;
+
+	case RT_ARP:
+		/*FIXME_hyking: update arp table reference count??*/
+		asic_t.arpStart	= rt_t->un.arp.arpsta;
+		asic_t.arpEnd	= rt_t->un.arp.arpend;
+		asic_t.arpIpIdx	= rt_t->un.arp.arpIpIdx;
+		break;
+
+	case RT_CPU:
+	case RT_DROP:
+		/*do nothing*/
+		break;
+
+	case RT_NEXTHOP:
+
+		asic_t.nhStart		 = rt_t->un.nxthop.nxtHopSta;
+		asic_t.nhNum	 	 = rt_t->un.nxthop.nxtHopEnd - rt_t->un.nxthop.nxtHopSta + 1;
+		asic_t.nhNxt	 	 = asic_t.nhStart;
+		asic_t.ipDomain		 = rt_t->un.nxthop.ipDomain;
+		asic_t.nhAlgo	 	 = rt_t->un.nxthop.nhalog;
+
+		break;
+
+	default:
+		printk("Process_Type(%d) is not support!\n",rt_t->process);
+	}
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+
+	/*for dislite */
+	asic_t.DSLEG =rt_t->DSLEG;
+	asic_t.DSL_IDX =rt_t->DSL_IDX;
+#endif
+#endif
+	if(rt_t->asicIdx > RT_ASIC_ENTRY_NUM-1)
+	{
+		printk("BUG!! %s(%d)....", __FUNCTION__,__LINE__);
+		return FAILED;
+	}
+
+	ret = rtl8651_setAsicRouting(rt_t->asicIdx, &asic_t);
+
+	return ret;
+
+}
+
+static int32 _rtl865x_updateDefaultRoute(rtl865x_route_t *rt, int32 action)
+{
+	int32 i;
+	rtl865x_route_t *entry;
+	int32 retval = FAILED;
+
+	entry = rt;
+	if(entry == NULL)
+		return RTL_EINVALIDINPUT;
+
+	/*delete nexthop which is add by default route*/
+	if(rt->process == RT_NEXTHOP)
+		for ( i = entry->un.nxthop.nxtHopSta; i <= entry->un.nxthop.nxtHopEnd && entry->un.nxthop.nxtHopEnd != 0; i++)
+		{
+			retval = rtl865x_delNxtHop(NEXTHOP_L3, i);
+		}
+
+	entry->un.nxthop.nxtHopSta = 0;
+	entry->un.nxthop.nxtHopEnd = 0;
+	switch(action)
+	{
+		case RT_DEFAULT_RT_NEXTHOP_CPU:
+			retval = rtl865x_addNxtHop(NEXTHOP_L3, (void*)entry, entry->dstNetif, 0,entry->srcIp);
+			break;
+
+		case RT_DEFAULT_RT_NEXTHOP_NORMAL:
+			{
+				rt->process = RT_NEXTHOP;
+				switch(rt->dstNetif->if_type)
+				{
+					case IF_ETHER:
+						retval = rtl865x_addNxtHop(NEXTHOP_L3, (void*)rt, rt->dstNetif, rt->nextHop,entry->srcIp);
+						break;
+					case IF_PPPOE:
+						{
+							rtl865x_ppp_t *pppoe;
+
+							pppoe = rtl865x_getPppByNetifName(rt->dstNetif->name);
+
+							if(pppoe != NULL)
+							{
+								/*got pppoe session*/
+								retval = rtl865x_addNxtHop(NEXTHOP_L3, (void*)rt, rt->dstNetif, pppoe->sessionId,entry->srcIp);
+							}
+							else
+								/*nexthop's action is to CPU*/
+								retval = rtl865x_addNxtHop(NEXTHOP_L3, (void*)rt, rt->dstNetif, 0,entry->srcIp);
+						}
+						break;
+				}
+			}
+			break;
+	}
+	retval = _rtl865x_synRouteToAsic(entry);
+
+	return retval;
+}
+
+static int32 _rtl865x_arrangeRoute(rtl865x_route_t *start_rt, int32 start_idx)
+{
+	int32 count;
+	rtl865x_route_t *rt = NULL;
+
+	rt = start_rt;
+	count = 0;
+	while(rt)
+	{
+		if(rt->valid)
+		{
+			/*if the rule is default route...*/
+			if(rt->ipMask == 0)
+				rt->asicIdx = RT_ASIC_ENTRY_NUM-1;
+			else
+			{
+				/* entry number more than asic table's capacity*/
+				/* entry index=RT_ASIC_ENTRY_NUM-1 is reserved for default route*/
+				if((start_idx + count > RT_ASIC_ENTRY_NUM-2))
+					break;
+
+				/*delete old asic entry firstly...*/
+				if(start_idx+count < rt->asicIdx && rt->asicIdx < RT_ASIC_ENTRY_NUM-1)
+					rtl8651_delAsicRouting(rt->asicIdx);
+
+				rt->asicIdx = start_idx+count;
+				_rtl865x_synRouteToAsic(rt);
+			}
+		}
+
+		/*next entry*/
+		rt= rt->next;
+		count++;
+	}
+
+
+	/*more route entry need to add?*/
+	if(rt)
+	{
+		/*not enough asic table entry! have to update default route's action TOCPU*/
+		rt = _rtl865x_getDefaultRoute();
+		_rtl865x_updateDefaultRoute(rt, RT_DEFAULT_RT_NEXTHOP_CPU);
+	}
+	else
+	{
+		rt = _rtl865x_getDefaultRoute();
+		_rtl865x_updateDefaultRoute(rt, RT_DEFAULT_RT_NEXTHOP_NORMAL);
+	}
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_addRouteToInusedList(rtl865x_route_t *rt)
+{
+	int32 retval = FAILED;
+	int32 start_idx = 0;
+	rtl865x_route_t *entry,*fore_rt,*start_rt;
+
+	fore_rt = NULL;
+	entry = rtl865x_route_inusedHead;
+
+	/*always set 0x0f when init..., this value would be reset in arrange route*/
+	rt->asicIdx = 0x0f;
+	rt->next = NULL;
+
+	/*find the right position...*/
+	while(entry)
+	{
+		if(entry->valid == 1)
+		{
+			if(entry->ipMask < rt->ipMask)
+			{
+				break;
+			}
+		}
+		fore_rt = entry;
+		entry = entry->next;
+	}
+
+	/*insert this rule after insert_entry*/
+	if(fore_rt)
+	{
+		rt->next = fore_rt->next;
+		fore_rt->next = rt;
+		start_idx = fore_rt->asicIdx+1;
+		start_rt = rt;
+	}
+	else
+	{
+		/*insert head...*/
+		rt->next = rtl865x_route_inusedHead;
+		rtl865x_route_inusedHead = rt;
+
+		start_idx = 0;
+		start_rt = rtl865x_route_inusedHead;
+	}
+
+	retval = _rtl865x_arrangeRoute(start_rt, start_idx);
+
+	//_rtl865x_route_print();
+	return retval;
+
+}
+
+static int32 _rtl865x_delRouteFromInusedList(rtl865x_route_t * rt)
+{
+	int32 retval,start_idx;
+	rtl865x_route_t *fore_rt = NULL,*entry = NULL,*start_rt = NULL;
+
+	entry = rtl865x_route_inusedHead;
+	while(entry)
+	{
+		if(entry == rt)
+			break;
+
+		fore_rt = entry;
+		entry = entry->next;
+	}
+
+	/*fore_rt == NULL means delete list head*/
+	if(fore_rt == NULL)
+	{
+		rtl865x_route_inusedHead = rtl865x_route_inusedHead->next;
+		start_rt = rtl865x_route_inusedHead;
+		start_idx = 0;
+	}
+	else
+	{
+		fore_rt->next = rt->next;
+		start_rt = fore_rt->next;
+		start_idx = fore_rt->asicIdx + 1;
+	}
+
+	/*delete route from asic*/
+	if(rt->asicIdx < RT_ASIC_ENTRY_NUM)
+		rtl8651_delAsicRouting(rt->asicIdx);
+
+	retval = _rtl865x_arrangeRoute(start_rt, start_idx);
+	rt->asicIdx = 0x0f;
+
+	//_rtl865x_route_print();
+
+	return retval;
+
+}
+
+
+static int32 _rtl865x_usedNetifInRoute(int8 *ifname)
+{
+
+	rtl865x_route_t *rt = NULL;
+	rt = rtl865x_route_inusedHead;
+
+	while(rt)
+	{
+		if(memcmp(rt->dstNetif->name,ifname,strlen(ifname)) == 0)
+			return SUCCESS;
+		rt = rt->next;
+	}
+	return FAILED;
+}
+
+
+
+static int32 _rtl865x_addRoute(ipaddr_t ipAddr, ipaddr_t ipMask, ipaddr_t nextHop, int8 * ifName,ipaddr_t srcIp)
+{
+	rtl865x_netif_local_t *netif = NULL;
+	rtl865x_route_t *rt = NULL,*tmp_rt = NULL;
+	int32 idx;
+	int32 netSize = 0, usedArpCnt = 0;
+	int32 retval = FAILED;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	int32 dsltIndex = FAILED;
+#endif
+#endif
+
+	if ((ifName==NULL) && (nextHop!=0)) {
+		extern int rtl865x_curOpMode;
+		if ((rtl865x_curOpMode==1) ||(rtl865x_curOpMode==2)) // BRIDGE_MODE or WISP_MODE
+			return RTL_EINVNETIFNAME;
+	}
+
+
+	/*para check*/
+	if(ifName == NULL)
+		netif = _rtl865x_getDefaultWanNetif();
+	else
+		netif = _rtl865x_getSWNetifByName(ifName);
+
+#if 0
+	if ((ipAddr&ipMask) == 0xc0a80200)
+		return RTL_EINVALIDINPUT;
+#endif
+	if(netif == NULL)
+		return RTL_EINVALIDINPUT;
+
+	if(netif->if_type == IF_NONE)
+		return RTL_ENOLLTYPESPECIFY;
+
+	idx = 0;
+	for(idx = 0; idx < 32; idx++)
+		if((1<<idx) & ipMask)
+			break;
+
+	netSize = 1<<idx;
+
+	if(netSize > RT_MAX_ARP_SIZE)
+		return RTL_EINVALIDINPUT;
+
+#if defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+	if (swconfig_vlan_enable) {
+		if (strncmp(netif->name, hw_nat_wan_dev_name, MAX_IFNAMESIZE) &&
+			strncmp(netif->name, RTL_DRV_LAN_NETIF_NAME, MAX_IFNAMESIZE) &&
+			strncmp(netif->name, RTL_SWCONFIG_DRV_PPP_NETIF_NAME, MAX_IFNAMESIZE))
+			return RTL_EINVALIDINPUT;
+	}
+#endif
+
+	/*
+	*duplicate entry check:
+	*	in Driver system, default route is always exist.
+	*	so if ipMask == 0, it's means that default route should be update...
+	*/
+	if(ipMask != 0 && (rt = _rtl865x_getRouteEntry(ipAddr, ipMask)) != NULL)
+	{
+		//rt->ref_count++;
+		#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+		rt->exist_in_ps = 1;
+		#endif
+		return RTL_EENTRYALREADYEXIST;
+	}
+
+	/*add default route: just update the default route becase the default route always exist!*/
+	if(ipMask == 0)
+	{
+		rt = _rtl865x_getDefaultRoute();
+		/*deference rt's orginal netif*/
+		if (rt && rt->dstNetif) {
+			#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+			if (rt->nextHop == nextHop) {
+				if (ifName) {
+					if (strncmp(rt->dstNetif->name, ifName, MAX_IFNAMESIZE) == 0) {
+						rt->exist_in_ps = 1;
+						return RTL_EENTRYALREADYEXIST;
+					}
+				} else {
+					rt->exist_in_ps = 1;
+					return RTL_EENTRYALREADYEXIST;
+				}
+			}
+			#endif
+			rtl865x_deReferNetif(rt->dstNetif->name);
+		}
+	}
+
+	/*allocate a new buffer for adding entry*/
+	if(rt == NULL)
+	{
+		rt = rtl865x_route_freeHead;
+
+		if(rt)
+		{
+			rtl865x_route_freeHead = rt->next;
+
+		}
+	}
+
+	if(rt == NULL)
+	{
+		/*no buffer, default route should be TOCPU?*/
+		return RTL_ENOFREEBUFFER;
+	}
+
+
+	/*common information*/
+	rt->ipAddr 	= ipAddr & ipMask;
+	rt->ipMask 	= ipMask;
+	rt->nextHop	= nextHop;
+	rt->srcIp		= srcIp;
+	rt->dstNetif 	= netif;
+	#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+	rt->exist_in_ps = 1;
+	#endif
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	if(netif->if_type == IF_DSLT)
+	{
+		dsltIndex=_rtl865x_getIpv6DsLiteEntryByName(netif->name);
+
+		/*hook default gw for dslist interface */
+		if(ipAddr ==0 && ipMask ==0 && nextHop!=0 && srcIp!=0)
+		{
+			if(dsltIndex == FAILED){
+				rt->DSLEG	= 0;
+				rt->DSL_IDX = 0;
+			}
+			else
+			{
+				rt->DSLEG	= 1;
+				rt->DSL_IDX = dsltIndex;
+			}
+		}
+	}
+#endif
+#endif
+
+	/*don't specify the nexthop ip address, it's means that:
+	* all packet match this route entry should be forward by network interface with arp
+	*/
+
+	if(nextHop == 0 && ipMask != 0)
+	{
+		switch(netif->if_type)
+		{
+			case IF_ETHER:
+
+				rt->process = RT_ARP;
+				tmp_rt = rtl865x_route_inusedHead;
+				while(tmp_rt)
+				{
+					if(tmp_rt->valid && tmp_rt->process == RT_ARP && tmp_rt->dstNetif == netif)
+						usedArpCnt += tmp_rt->un.arp.arpend - tmp_rt->un.arp.arpend + 1;
+
+					tmp_rt = tmp_rt->next;
+				}
+
+				if((usedArpCnt + netSize) > RT_MAX_ARP_SIZE)
+				{
+					printk("!!!!ERROR!!!usedArp(%d),netsize(%d)\n",usedArpCnt,netSize);
+					goto addFailed;
+				}
+
+				/*allocate arp entry for this route rule...*/
+
+				retval = rtl865x_arp_tbl_alloc(rt);
+				if( retval != SUCCESS)
+				{
+					printk("error!!can't allocate arp for this route entry....retval(%d)\n",retval);
+					goto addFailed;
+				}
+
+				//rt->un.arp.arpIpIdx = 0; /*FIXME_hyking[this field is invalid, right?]*/
+				rtl865x_getIpIdxByIpRange(ipAddr, ipMask, &rt->un.arp.arpIpIdx);
+				//printk("%s %d ipAddr=0x%x ifName=%s rt->un.arp.arpIpIdx=%d\n", __FUNCTION__, __LINE__, ipAddr, ifName, rt->un.arp.arpIpIdx);
+				break;
+
+			case IF_PPPOE:
+				{
+					rtl865x_ppp_t *ppp = NULL;
+
+					rt->process = RT_PPPOE;
+					ppp = rtl865x_getPppByNetifName(netif->name);
+
+					if(ppp == NULL)
+					{
+						printk("error!!can't get pppoe session information by interface name(%s)\n",netif->name);
+						goto addFailed;
+					}
+
+					rt->un.pppoe.macInfo = &ppp->server_mac;
+					rt->un.pppoe.pppInfo = ppp;
+
+					/*update reference...*/
+					rtl865x_referPpp(ppp->sessionId);
+#if 0//defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+					retval = rtl865x_getNxtHopIdx(NEXTHOP_DEFREDIRECT_ACL, netif, ppp->sessionId);
+					if (retval == -1) {
+						retval = rtl865x_addNxtHop(NEXTHOP_DEFREDIRECT_ACL, (void*)rt, netif, ppp->sessionId, srcIp);
+						if (retval != SUCCESS) {
+							printk("Warning!!add pppoe nexthop for redirect acl fail! retval (%d)\n", retval);
+							goto addFailed;
+						}
+					}
+#endif
+				}
+				break;
+			case IF_PPTP:
+			case IF_L2TP:
+				{
+					rtl865x_ppp_t *ppp = NULL;
+
+					rt->process = RT_L2;
+					ppp = rtl865x_getPppByNetifName(netif->name);
+
+					if(ppp == NULL)
+					{
+						/*printk("Warning!!CAn't get pptp/l2tp session information by interface name(%s)\n",netif->name);*/
+						goto addFailed;
+					}
+
+					rt->un.direct.macInfo = &ppp->server_mac;
+				}
+				break;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+			case IF_DSLT:
+				if(dsltIndex!=FAILED)
+				{
+					/*
+						set L3 table
+						All packet dip equal to tunnel local ip,trap to cpu.
+					*/
+					extern int  get_P2P_local_ip(unsigned char *ifname, unsigned int *ipAddr);
+
+					/*get p2p device local ip *******************/
+					if(!get_P2P_local_ip(netif->name,&(rt->ipAddr)))
+					{
+						printk("%s,%d.get local ip fail\n",__FUNCTION__,__LINE__);
+					}
+					rt->process = RT_CPU;
+				}
+				break;
+#endif
+#endif
+			default:
+				printk("lltype(%d) is not support now....\n",netif->if_type);
+				goto addFailed;
+		}
+
+	}
+	else
+	{
+		/*if default is valid, delete nexthop firstly...*/
+		if(rt->valid == 1 && rt->process == RT_NEXTHOP)
+			  {
+						int i;
+						for ( i = rt->un.nxthop.nxtHopSta; i <= rt->un.nxthop.nxtHopEnd; i++)
+						{
+								retval = rtl865x_delNxtHop(NEXTHOP_L3, i);
+						}
+			  }
+
+		/*use nexthop type*/
+		rt->process = RT_NEXTHOP;
+		switch(netif->if_type)
+		{
+			case IF_ETHER:
+				retval = rtl865x_addNxtHop(NEXTHOP_L3, (void*)rt, netif, nextHop,srcIp);
+				break;
+			case IF_PPPOE:
+			case IF_PPTP:
+			case IF_L2TP:
+				{
+					rtl865x_ppp_t *pppoe;
+
+					pppoe = rtl865x_getPppByNetifName(netif->name);
+
+					if(pppoe != NULL)
+					{
+						/*got pppoe session*/
+						retval = rtl865x_addNxtHop(NEXTHOP_L3, (void*)rt, netif, pppoe->sessionId,srcIp);
+					}
+					else
+						/*nexthop's action is to CPU*/
+						retval = rtl865x_addNxtHop(NEXTHOP_L3, (void*)rt, netif, 0,srcIp);
+				}
+				break;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+
+			case IF_DSLT:
+				{
+					retval = rtl865x_addNxtHop(NEXTHOP_L3, (void*)rt, netif, nextHop,srcIp);
+				}
+				break;
+#endif
+#endif
+
+			default:
+				retval = FAILED;
+				break;
+
+		}
+
+		if(retval != SUCCESS)
+		{
+			printk("error!!add nexthop error! retval (%d)\n",retval);
+			goto addFailed;
+		}
+		rt->un.nxthop.nhalog = RT_ALOG_SIP; /* use per-source IP */
+		rt->un.nxthop.ipDomain = RT_DOMAIN_16_1;
+	}
+
+	rt->valid		= 1;
+	rt->ref_count	= 1;
+	/*update reference....*/
+	rtl865x_referNetif(netif->name);
+	if(ipMask == 0)
+		_rtl865x_setDefaultWanNetif(netif->name);
+
+	/**/
+	if(rt->asicIdx == RT_ASIC_ENTRY_NUM-1)
+	{
+		retval = _rtl865x_synRouteToAsic(rt);
+	}
+	else
+	{
+		/*insert the adding route to inused list*/
+		retval = _rtl865x_addRouteToInusedList(rt);
+	}
+
+	/*if route is add, please enable Routing for the releated netif*/
+	retval = rtl865x_enableNetifRouting(netif);
+	return retval;
+
+addFailed:
+	if(rt->asicIdx == RT_ASIC_ENTRY_NUM -1)
+	{
+		_rtl865x_updateDefaultRoute(rt, RT_DEFAULT_RT_NEXTHOP_CPU);
+	}
+	else
+	{
+		/*free this route entry and return error code...*/
+		memset(rt,0,sizeof(rtl865x_route_t));
+		rt->next = rtl865x_route_freeHead;
+		rtl865x_route_freeHead = rt;
+	}
+	return retval;
+
+}
+
+static int32 _rtl865x_delRoute( ipaddr_t ipAddr, ipaddr_t ipMask )
+{
+	rtl865x_route_t *entry;
+	int32 i;
+	int32 retval = 0;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	int32 dsltIndex = FAILED;
+#endif
+#endif
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU_PPPOE)
+	int32 fid = 0;
+#endif
+
+	entry = _rtl865x_getRouteEntry(ipAddr, ipMask);
+
+	if(entry == NULL)
+		return RTL_EENTRYNOTFOUND;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	dsltIndex=_rtl865x_getIpv6DsLiteEntryByName(entry->dstNetif->name);
+	if(dsltIndex !=FAILED)
+	{
+		_rtl865x_delIpv6DsLiteEntry(dsltIndex);
+	}
+#endif
+#endif
+	if(entry->asicIdx == RT_ASIC_ENTRY_NUM-1)
+	{
+		/*if default route
+		* 1. reset default route
+		* 2. reset entry->netif...
+		*/
+		rtl865x_netif_local_t *netif = NULL;
+		_rtl865x_clearDefaultWanNetif(entry->dstNetif->name);
+
+		netif = _rtl865x_getDefaultWanNetif();
+		if(netif==NULL)
+		{
+			return RTL_EINVNETIFNAME;
+		}
+
+		if(netif != entry->dstNetif)
+		{
+			rtl865x_deReferNetif(entry->dstNetif->name);
+			entry->dstNetif = netif;
+			rtl865x_referNetif(netif->name);
+		}
+
+		retval = _rtl865x_updateDefaultRoute(entry, RT_DEFAULT_RT_NEXTHOP_CPU);
+	}
+	else
+	{
+		/*not default route*/
+		switch(entry->process)
+		{
+			case RT_PPPOE:
+				{
+					rtl865x_ppp_t *ppp = entry->un.pppoe.pppInfo;
+					if(ppp)
+						rtl865x_deReferPpp(ppp->sessionId);
+				}
+
+				#if defined(CONFIG_RTL_CUSTOM_PASSTHRU_PPPOE)
+				rtl865x_getVlanFilterDatabaseId(entry->dstNetif->vid, &fid);
+				//rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEII, fid, (ether_addr_t *)entry->un.pppoe.macInfo);
+				if (entry->un.pppoe.macInfo != NULL)
+					_rtl865x_delFilterDatabaseEntry(RTL865x_L2_TYPEII, fid, (ether_addr_t *)entry->un.pppoe.macInfo);
+				#endif
+
+				break;
+			case RT_L2:
+				/*
+				* NOTE:this type not used now...
+				* if we want to use it, please DELETE FDB entry to sure this L2 entry is deleted both software FDB table and Asic L2 table.
+				*/
+				break;
+			case RT_ARP:
+				/*free arp*/
+				retval = rtl865x_arp_tbl_free(entry);
+				if( retval != SUCCESS)
+				{
+					printk("======error!!can't FREE arp entry for this route entry....retval(%d)\n",retval);
+				}
+				break;
+
+			case RT_CPU:
+			case RT_DROP:
+				/*do nothing*/
+
+				break;
+
+			case RT_NEXTHOP:
+				/*delete nexthop which is add by l3*/
+				for ( i = entry->un.nxthop.nxtHopSta; i <= entry->un.nxthop.nxtHopEnd; i++)
+				{
+					retval = rtl865x_delNxtHop(NEXTHOP_L3, i);
+				}
+				break;
+		}
+
+		/*FIXME_hyking: update netif reference count*/
+		rtl865x_deReferNetif(entry->dstNetif->name);
+
+
+		/*remove from inused list...*/
+		_rtl865x_delRouteFromInusedList(entry);
+
+		if(_rtl865x_usedNetifInRoute(entry->dstNetif->name) == FAILED)
+			rtl865x_disableNetifRouting(entry->dstNetif);
+
+		/*add to free list*/
+		memset(entry,0,sizeof(rtl865x_route_t));
+		entry->next = rtl865x_route_freeHead;
+		rtl865x_route_freeHead = entry;
+
+		retval = SUCCESS;
+	}
+
+	//_rtl865x_route_print();
+	return retval;
+
+}
+
+rtl865x_route_t* _rtl85x_getRouteEntry(ipaddr_t dst)
+{
+	rtl865x_route_t *tmpRtEntry = NULL;
+	rtl865x_route_t *rt=rtl865x_route_inusedHead;
+	uint32 mask;
+
+	mask = 0;
+	while(rt)
+	{
+		if (rt->valid == 1 && rt->ipAddr == (rt->ipMask & dst) && mask <= rt->ipMask) {
+			mask = rt->ipMask;
+			tmpRtEntry = rt;
+		}
+		rt = rt->next;
+	}
+	return tmpRtEntry;
+}
+
+/*
+@func int32 | rtl865x_addRoute |add a route entry.
+@parm ipaddr_t | ipAddr | ip address.
+@parm ipaddr_t | ipMask | ip mask.
+@parm ipaddr_t | nextHop | the route's next hop.
+@parm int8* | ifName | destination network interface.
+@parm ipaddr_t | srcIp |source IP
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@rvalue RTL_EINVALIDINPUT | invalid input.
+@rvalue RTL_ENOLLTYPESPECIFY | network interface's link type is not specified.
+@rvalue RTL_EENTRYALREADYEXIST | route entry is already exist.
+@rvalue RTL_ENOFREEBUFFER | not enough memory in system.
+@comm
+	if ifName=NULL, it means the destionation network interface of route entry with ip/ipMask/nextHop is default wan.
+*/
+int32 rtl865x_addRoute(ipaddr_t ipAddr, ipaddr_t ipMask, ipaddr_t nextHop,int8 * ifName,ipaddr_t srcIp)
+{
+	int32 retval = 0;
+	unsigned long flags=0;
+	//printk("========%s(%d), ip(0x%x),mask(0x%x),ifname(%s),nxthop(0x%x)\n",__FUNCTION__,__LINE__,ipAddr,ipMask,ifName,nextHop);
+	//rtl_down_interruptible(&route_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_addRoute(ipAddr,ipMask,nextHop,ifName,srcIp);
+	//rtl_up(&route_sem);
+	SMP_UNLOCK_ETH(flags);
+	//printk("========%s(%d), ip(0x%x),mask(0x%x),ifname(%s),nxthop(0x%x),retval(%d)\n",__FUNCTION__,__LINE__,ipAddr,ipMask,ifName,nextHop,retval);
+	//_rtl865x_route_print();
+	return retval;
+}
+/*
+@func int32 | rtl865x_delRoute |delete a route entry.
+@parm ipaddr_t | ipAddr | ipAddress.
+@parm ipaddr_t | ipMask | ipMask.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@rvalue RTL_EENTRYNOTFOUND | not found the entry.
+@comm
+*/
+int32 rtl865x_delRoute(ipaddr_t ipAddr, ipaddr_t ipMask)
+{
+
+	int32 retval = 0;
+	unsigned long flags=0;
+	//printk("========%s(%d), ip(0x%x),mask(0x%x)\n",__FUNCTION__,__LINE__,ipAddr,ipMask);
+	//rtl_down_interruptible(&route_sem);
+	SMP_LOCK_ETH(flags);
+	retval = _rtl865x_delRoute(ipAddr,ipMask);
+	//rtl_up(&route_sem);
+	SMP_UNLOCK_ETH(flags);
+	//printk("==================================retval(%d)\n",retval);
+	return retval;
+
+}
+
+/*
+@func int32 | rtl865x_getRouteEntry |according the destination ip address, get the matched route entry.
+@parm ipaddr_t | dst | destionation ip address.
+@parm rtl865x_route_t* | rt | retrun value: route entry pointer
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl865x_getRouteEntry(ipaddr_t dst,rtl865x_route_t *rt)
+{
+	int32 retval = FAILED;
+	rtl865x_route_t *ret_entry = NULL;
+
+	ret_entry = _rtl85x_getRouteEntry(dst);
+	if(ret_entry && rt)
+	{
+		memcpy(rt,ret_entry,sizeof(rtl865x_route_t));
+		retval = SUCCESS;
+	}
+	return retval;
+}
+
+/*
+@func int32 | rtl865x_initRouteTable |initialize route tabel.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl865x_initRouteTable(void)
+{
+	int32 i;
+	rtl865x_route_t *rt;
+	rtl865x_route_freeHead = NULL;
+	rtl865x_route_inusedHead = NULL;
+
+	/*malloc buffer*/
+	TBL_MEM_ALLOC(rt, rtl865x_route_t, RT_DRV_ENTRY_NUM);
+	memset(rt,0,sizeof(rtl865x_route_t)*RT_DRV_ENTRY_NUM);
+	for(i = 0; i < RT_DRV_ENTRY_NUM; i++)
+	{
+		rt[i].next = rtl865x_route_freeHead;
+		rtl865x_route_freeHead = &rt[i];
+	}
+
+	#if defined(CONFIG_RTL_HARDWARE_NAT)//&&defined(REINIT_SWITCH_CORE)
+	memset(rtl865x_route_inused_bak, 0, sizeof(rtl865x_route_t)*RT_DRV_ENTRY_NUM);
+	#endif
+
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865x_reinitRouteTable |reinitialize route tabel.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@comm
+*/
+int32 rtl865x_reinitRouteTable(void)
+{
+	rtl865x_route_t *rt;
+
+	rt = rtl865x_route_inusedHead;
+	while(rt && rt->asicIdx != RT_ASIC_ENTRY_NUM -1)
+	{
+		_rtl865x_delRoute(rt->ipAddr,rt->ipMask);
+		rt = rtl865x_route_inusedHead;
+	}
+
+	/*delete the last route*/
+	rt = rtl865x_route_inusedHead;
+	if(rt)
+	{
+		/*FIXME_hyking: update netif reference count*/
+		rtl865x_deReferNetif(rt->dstNetif->name);
+
+		/*remove from inused list...*/
+		_rtl865x_delRouteFromInusedList(rt);
+
+		/*add to free list*/
+		memset(rt,0,sizeof(rtl865x_route_t));
+		rt->next = rtl865x_route_freeHead;
+		rtl865x_route_freeHead = rt;
+	}
+	return SUCCESS;
+}
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+int rtl865x_getLanRoute(rtl865x_route_t routeTbl[], int tblSize )
+{
+	int cnt=0;
+	rtl865x_route_t *rt = NULL;
+	rt = rtl865x_route_inusedHead;
+
+	while(rt)
+	{
+
+		if((rt->valid==1) && (rt->dstNetif->is_wan==0))
+		{
+			memcpy(&routeTbl[cnt], rt, sizeof(rtl865x_route_t) );
+			cnt++;
+		}
+		rt = rt->next;
+	}
+	return cnt;
+}
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+int32 sw_l3_read(struct seq_file *s, void *v)
+{
+	rtl865x_route_t * entry=NULL;
+
+	uint32 idx=0;
+
+	seq_printf(s, "%s\n", "SW L3 Routing Table:\n");
+
+	entry = rtl865x_route_inusedHead;
+	while(entry)
+	{
+		if(entry->valid == 0)
+
+			continue;
+
+		seq_printf(s,"\t[%d]  ip:%x,%x,	%x,nexthop:%x  process(%d)  asicIdx:%d, netif%s \n",
+			idx, entry->ipAddr,entry->ipMask,entry->srcIp,
+			entry->nextHop,entry->process,entry->asicIdx,entry->dstNetif->name);
+		idx++;
+		entry=entry->next;
+	}
+
+	return 0;
+}
+#else
+int32 sw_l3_read( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int len;
+	rtl865x_route_t * entry=NULL;
+	uint32 idx = 0;
+
+	len = sprintf(page, "%s\n", "SW L3 Routing Table:\n");
+	entry = rtl865x_route_inusedHead;
+	while(entry)
+	{
+		if(entry->valid == 0)
+
+			continue;
+
+		len += sprintf(page + len,"\t[%d]  ip:%x,%x,	%x,nexthop:%x  process(%d)  asicIdx:%d, netif:%s \n",
+			idx, entry->ipAddr,entry->ipMask,entry->srcIp,
+			entry->nextHop,entry->process,entry->asicIdx,entry->dstNetif->name);
+		idx++;
+		entry=entry->next;
+	}
+
+
+	return len;
+}
+#endif
+
+int32 sw_l3_write( struct file *filp, const char *buff,unsigned long len, void *data )
+{
+	return len;
+}
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+int rtl865x_checkL3L2Valid(ipaddr_t ipAddr )
+{
+
+	int ret=0;
+	rtl865x_route_t *rt = NULL;
+
+	rtl865x_tblAsicDrv_l2Param_t asic_l2;
+
+	uint32 columIdx,fid;
+
+	rt = rtl865x_route_inusedHead;
+
+	if(ipAddr==0)
+		return ret;
+
+	while(rt)
+	{
+
+		if((rt->valid==1) && (rt->dstNetif->is_wan==1))
+		{
+			if((rt->ipAddr&rt->ipMask)==(ipAddr&rt->ipMask))
+			{
+				switch (rt->process)
+				{
+				case RT_PPPOE:
+					/*fix me: to real check pppoe valid*/
+					return 1;
+					break;
+
+				case RT_L2:
+					/*
+					* NOTE:this type not used now...
+					* if we want to use it, please add FDB entry to sure this L2 entry in both software FDB table and Asic L2 table.
+					*/
+					ret = rtl865x_getVlanFilterDatabaseId(rt->dstNetif->vid,&fid);
+					ret = rtl865x_Lookup_fdb_entry(fid, (ether_addr_t *)rt->un.direct.macInfo, FDB_STATIC, &columIdx,&asic_l2);
+					if(ret == SUCCESS)
+					{
+						return 1;
+					}
+					else
+					{
+						return 0;
+					}
+
+					break;
+
+				case RT_ARP:
+					if(rtl865x_isArpExisted( ipAddr))
+					{
+						return 1;
+					}
+					else
+					{
+						return 0;
+					}
+					break;
+
+				case RT_CPU:
+				case RT_DROP:
+					return 0;
+					break;
+
+				case RT_NEXTHOP:
+
+					switch(rt->dstNetif->if_type)
+					{
+						case IF_ETHER:
+							if( rtl865x_getNxtHopIdx(NEXTHOP_L3,rt->dstNetif,rt->nextHop)!=-1)
+							{
+								return 1;
+							}
+							else
+							{
+								return 0;
+							}
+
+							break;
+						case IF_PPPOE:
+							/*fix me, to really check pppoe nexthop valid or not*/
+							return 1;
+
+						case IF_PPTP:
+						case IF_L2TP:
+							return 0;
+							break;
+
+						default:
+							return 0;
+							break;
+
+					}
+
+					break;
+
+				default:
+					return 0;
+					break;
+				}
+
+			}
+
+		}
+		rt = rt->next;
+	}
+
+	return 0;
+}
+
+#endif
+
+int rtl865x_delPppoeRouter(char *name)
+{
+	int i;
+	rtl865x_route_t *rt;
+
+	for (i=0; i<RT_ASIC_ENTRY_NUM; i++)
+	{
+		rt = rtl865x_route_inusedHead;
+		while (rt)
+		{
+			if ((rt->valid==1) && (strncmp(rt->dstNetif->name, name, 4)==0)) {
+				_rtl865x_delRoute(rt->ipAddr,rt->ipMask);
+				break;
+			}
+			rt = rt->next;
+		}
+	}
+
+	return SUCCESS;
+}
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl865x_delPppoeRouter);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+int rtl_clear_router_exist_in_ps_flag(void)
+{
+	unsigned long flags=0;
+	rtl865x_route_t *rt = NULL;
+
+	SMP_LOCK_ETH(flags);
+	rt = rtl865x_route_inusedHead;
+	while(rt)
+	{
+		if (rt->valid == 1)
+			rt->exist_in_ps = 0;
+
+		rt = rt->next;
+	}
+	SMP_UNLOCK_ETH(flags);
+	return SUCCESS;
+}
+
+int rtl_del_router_not_exist_in_ps(void)
+{
+	int i, count = 0;
+	unsigned long flags=0;
+	rtl865x_route_t *rt = NULL;
+	struct ip_mask_tuple tmp[RT_DRV_ENTRY_NUM];
+
+	SMP_LOCK_ETH(flags);
+
+	memset(tmp, 0, sizeof(struct ip_mask_tuple)*RT_DRV_ENTRY_NUM);
+	rt = rtl865x_route_inusedHead;
+	while(rt)
+	{
+		/*find the router entry who is not in linux ps*/
+		if ((rt->valid==1) && (rt->exist_in_ps==0)) {
+			tmp[count].ip 		= rt->ipAddr;
+			tmp[count].mask	= rt->ipMask;
+			count ++;
+		}
+
+		rt = rt->next;
+	}
+
+	for (i=0; i<count; i++)
+	{
+		_rtl865x_delRoute(tmp[i].ip, tmp[i].mask);
+	}
+
+	SMP_UNLOCK_ETH(flags);
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)//&&defined(REINIT_SWITCH_CORE)
+int rtl819x_save_inused_route(void)
+{
+	int i = 0;
+	rtl865x_route_t *rt = rtl865x_route_inusedHead;
+
+	memset(rtl865x_route_inused_bak, 0, sizeof(rtl865x_route_t)*RT_DRV_ENTRY_NUM);
+	while(rt)
+	{
+		if (rt->valid == 1) {
+			memcpy(&rtl865x_route_inused_bak[i], rt, sizeof(rtl865x_route_t));
+			i++;
+			if (i >= RT_DRV_ENTRY_NUM)
+				break;
+		}
+		rt = rt->next;
+	}
+
+	return SUCCESS;
+}
+
+int rtl819x_restore_inused_route(void)
+{
+	int i = 0;
+	rtl865x_route_t *rt = NULL;
+
+	for (i=0; i<RT_DRV_ENTRY_NUM; i++)
+	{
+		if (rtl865x_route_inused_bak[i].valid == 1) {
+			rt = &rtl865x_route_inused_bak[i];
+			rtl865x_addRoute(rt->ipAddr, rt->ipMask, rt->nextHop, rt->dstNetif->name, rt->srcIp);
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+int rtl_check_default_router_valid(void)
+{
+	int ret = FALSE;
+	rtl865x_route_t *rt = NULL;
+
+	rt = _rtl865x_getDefaultRoute();
+	if (rt && rt->dstNetif) {
+		if ((strncmp(rt->dstNetif->name, hw_nat_wan_dev_name, MAX_IFNAMESIZE) == 0) ||
+		    (strncmp(rt->dstNetif->name, RTL_SWCONFIG_DRV_PPP_NETIF_NAME, MAX_IFNAMESIZE) == 0))
+			ret = TRUE;
+	}
+
+	return ret;
+}
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_route.h b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_route.h
new file mode 100644
index 00000000..34201bd
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l3Driver/rtl865x_route.h
@@ -0,0 +1,114 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : route table driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#ifndef	RTL865X_ROUTE_H
+#define	RTL865X_ROUTE_H
+#include <net/rtl/rtl865x_route_api.h>
+
+typedef struct rtl865x_route_s
+{
+	struct rtl865x_route_s *next;
+	ipaddr_t 	ipAddr;						/* Destination IP Address */
+	ipaddr_t	ipMask;						/* Network mask */
+	ipaddr_t 	nextHop;					/* next hop IP address */
+	ipaddr_t	srcIp;						/* source IP address,only for multiple wan now*/
+	uint32	valid:1,
+			process:4,					/* 000: PPPoE, 001: L2, 010: ARP, 100: CPU, 101: NextHop, 110: Drop*/
+			asicIdx:4;
+
+	uint32            ref_count;                       /*referrence count*/
+	rtl865x_netif_local_t *dstNetif;			/*destination network interface*/
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+	int		exist_in_ps;
+#endif
+	/* nexthop informaiton */
+	union {
+		struct
+		{
+			uint32	arpsta;						/* ARP Table Starting address */
+			uint32	arpend;						/* ARP Table Ending address */
+			uint32	arpIpIdx;					/* External IP selection index */
+		} arp;
+
+		struct
+		{
+			void *macInfo;	/*direct nexthop's mac information*/
+		}direct;
+
+		struct
+		{
+			void *macInfo; /*pppoe server's mac information*/
+			rtl865x_ppp_t *pppInfo;
+		}pppoe;
+
+		struct
+		{
+
+			uint32 nxtHopSta;	/* pointer to Nexthop table: starting range */
+			uint32 nxtHopEnd;		/* pointer to Nexthop table: ending range */
+			uint8 nhalog;							/* algo. for load balance */
+			uint8 ipDomain;						/* IP domain */
+		} nxthop;
+
+	} un;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint32			DSLEG;
+	uint32			DSL_IDX;
+#endif
+
+} rtl865x_route_t;
+
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+struct ip_mask_tuple {
+	unsigned int ip;
+	unsigned int mask;
+};
+#endif
+
+#define RT_DEFAULT_RT_NEXTHOP_CPU 		0x00
+#define RT_DEFAULT_RT_NEXTHOP_NORMAL 	0x01
+
+/* process: */
+#define RT_PPPOE				0x00
+#define RT_L2					0x01
+#define RT_ARP					0x02
+#define RT_CPU					0x04
+#define RT_NEXTHOP				0x05
+#define RT_DROP					0x06
+
+/* nhalog: */
+#define RT_ALOG_PACKET			0x00
+#define RT_ALOG_SESSION		0x01
+#define RT_ALOG_SIP				0x02
+
+/* ipDomain: */
+#define RT_DOMAIN_4_1				0x00
+#define RT_DOMAIN_4_2				0x01
+#define RT_DOMAIN_4_3				0x02
+#define RT_DOMAIN_4_4				0x03
+#define RT_DOMAIN_8_1				0x04
+#define RT_DOMAIN_8_2				0x05
+#define RT_DOMAIN_16_1				0x06
+
+int32 rtl865x_initRouteTable(void);
+int32 rtl865x_reinitRouteTable(void);
+
+//int32 rtl865x_addRoute(ipaddr_t ipAddr, ipaddr_t ipMask, ipaddr_t nextHop, int8 * ifName);
+//int32 rtl865x_delRoute(ipaddr_t ipAddr, ipaddr_t ipMask);
+int32 rtl865x_getRouteEntry(ipaddr_t dst, rtl865x_route_t *rt);
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+int rtl865x_getLanRoute(rtl865x_route_t routeTbl[], int tblSize);
+#endif
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l4Driver/Makefile b/drivers/soc/realtek/rtd129x/hw_nat/l4Driver/Makefile
new file mode 100644
index 00000000..efe37cd
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l4Driver/Makefile
@@ -0,0 +1,39 @@
+#
+# Makefile for the Tulip ethernet driver
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definitions are now in the main makefile...
+#Add mips16 Support
+
+DIR_RTLASIC = $(srctree)/drivers/soc/realtek/rtd129x/hw_nat/
+ifdef CONFIG_RTL865X_KERNEL_MIPS16_LAYERDRIVER
+	CFLAGS_rtl865x_nat.o	= -mips16
+endif
+	ifdef CONFIG_RTL_LAYERED_DRIVER_L4
+		obj-y := rtl865x_nat.o
+	endif
+
+EXTRA_CFLAGS += -O1 -DRTL_TBLDRV -D__linux__ -DRTL865X_OVER_KERNEL -DRTL865X_OVER_LINUX -Werror
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/common
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/AsicDriver
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/l2Driver
+#EXTRA_CFLAGS += -I$(DIR_RTLASIC)/l3Driver
+EXTRA_CFLAGS += -I$(DIR_RTLASIC)
+
+
+
+ifeq ($(CONFIG_RTL865X_MODULE_ROMEDRV),y)
+	EXTRA_CFLAGS += -D__KERNEL__
+	EXTRA_CFLAGS += -G 0
+	EXTRA_CFLAGS += -DMODULE
+	EXTRA_CFLAGS += -mlong-calls
+	EXTRA_CFLAGS += -DEXPORT_SYMTAB
+	EXTRA_CFLAGS += -DCONFIG_RTL865X_MODULE_INTERNAL
+#	EXTRA_CFLAGS += -DMODVERSIONS
+#	EXTRA_CFLAGS += -include $(srctree)/include/linux/modversions.h
+endif
+
+EXTRA_AFLAGS += $(EXTRA_CFLAGS)
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l4Driver/rtl865x_nat.c b/drivers/soc/realtek/rtd129x/hw_nat/l4Driver/rtl865x_nat.c
new file mode 100644
index 00000000..413d602
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l4Driver/rtl865x_nat.c
@@ -0,0 +1,2055 @@
+/*
+* Program : napt table driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+*  Copyright (c) 2011 Realtek Semiconductor Corp.
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License version 2 as
+*  published by the Free Software Foundation.
+*/
+
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include <net/rtl/rtl865x_netif.h>
+#include "common/mbuf.h"
+//#include "assert.h"
+
+//#include "rtl865xc_swNic.h"
+//#include <common/types.h>
+#include "AsicDriver/rtl865x_hwPatch.h"	/* define for chip related spec */
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+
+#include "AsicDriver/rtl865x_asicL4.h"
+#else
+#include "common/rtl8651_aclLocal.h"
+#include "rtl865xC_tblAsicDrv.h"
+#endif
+
+#include "common/rtl_errno.h"
+//#include <net/rtl/rtl_queue.h>
+#include "AsicDriver/rtl865xc_asicregs.h"
+#include "common/rtl865x_eventMgr.h"
+#include "l3Driver/rtl865x_ip.h"
+
+#include <net/rtl/rtl865x_nat.h>
+#include "rtl865x_nat_local.h"
+
+//#include "rtl865x_ppp.h"
+#include "common/rtl865x_netif_local.h"
+#include "l3Driver/rtl865x_ppp_local.h"
+//#include "l3Driver/rtl865x_route.h"
+#include <net/rtl/rtl865x_outputQueue.h>
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT) || defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+#include <net/rtl/rtl865x_arp_api.h>
+#include "l3Driver/rtl865x_route.h"
+#endif
+
+#ifdef CONFIG_RTL_PROC_DEBUG
+#include <linux/seq_file.h>
+#endif
+
+#include <linux/jiffies.h>
+
+#if defined (CONFIG_RTL865X_NAT_ADD_FAIL_CHECK)
+static uint32 failedCount = 0;
+static unsigned long lastJiffies;
+
+#define ADD_FAILURE_TRHREHOLD 100
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#include <linux/uaccess.h>
+
+extern bool rtl_hwnat_enable;
+
+#define CHECK_IF_HWNAT_READY if (!rtl_hwnat_enable) return SUCCESS
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+static struct nat_table nat_tbl;
+static int32 rtl865x_enableNaptFourWay = FALSE;
+static int32 _rtl865x_naptIdleCheck(int32 index);
+
+#if 0
+static int32 rtl865x_nat_callbackFn_for_del_ip(void *param);
+
+static int32 rtl865x_nat_register_event(void);
+
+static int32 rtl865x_nat_callbackFn_for_del_ip(void *param)
+{
+	int i;
+	rtl865x_tblAsicDrv_extIntIpParam_t *natip;
+	struct nat_entry *nat_out, *nat_in;
+	struct nat_tuple nat_tuple;
+
+	natip = (rtl865x_tblAsicDrv_extIntIpParam_t *) param;
+
+	for (i = 0; i < RTL8651_TCPUDPTBL_SIZE; i++) {
+		if ((nat_tbl.nat_bucket[i].flags & NAT_OUTBOUND) &&
+			(nat_tbl.nat_bucket[i].ext_ip_ == natip->extIpAddr)) {
+			memcpy(&nat_tuple, &nat_tbl.nat_bucket[i].tuple_info,
+				sizeof(struct nat_tuple));
+			nat_out = &nat_tbl.nat_bucket[i];
+			nat_in = &nat_tbl.nat_bucket[nat_out->in];
+			rtl8651_delAsicNaptTcpUdpTable(nat_out->in,
+				nat_out->in);
+			rtl8651_delAsicNaptTcpUdpTable(nat_out->out,
+				nat_out->out);
+			memset(nat_in, 0, sizeof(*nat_in));
+			memset(nat_out, 0, sizeof(*nat_out));
+
+			if (nat_tbl.connNum > 0) {
+				nat_tbl.connNum--;
+			}
+		}
+
+	}
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 _rtl865x_nat_unRegister_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+
+	eventParam.eventLayerId = DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_DEL_IP;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = rtl865x_nat_callbackFn_for_del_ip;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_nat_register_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+
+	eventParam.eventLayerId = DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_DEL_IP;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = rtl865x_nat_callbackFn_for_del_ip;
+	rtl865x_registerEvent(&eventParam);
+
+	return SUCCESS;
+}
+#endif
+
+#define	RTL_NAT_AVG_INTERVAL	3
+#define	RTL_NAT_MIN_INTERVAL	1
+
+int32 rtl_nat_expire_interval_update(int proto, int32 interval)
+{
+	int32 asic_interval;
+
+	asic_interval = interval > RTL_NAT_AVG_INTERVAL ?
+		interval - RTL_NAT_AVG_INTERVAL :
+		interval - RTL_NAT_MIN_INTERVAL;
+	asic_interval = asic_interval < RTL_NAT_MIN_INTERVAL ?
+		RTL_NAT_MIN_INTERVAL : asic_interval;
+
+	if (proto == RTL865X_PROTOCOL_UDP) {
+		nat_tbl.tcp_timeout = asic_interval;
+	} else if (proto == RTL865X_PROTOCOL_UDP) {
+		nat_tbl.udp_timeout = asic_interval;
+	} else {
+		return FAILED;
+	}
+
+	/* Set ASIC timeout value */
+	rtl8651_setAsicNaptTcpLongTimeout(nat_tbl.tcp_timeout);
+	rtl8651_setAsicNaptTcpMediumTimeout(nat_tbl.tcp_timeout);
+	rtl8651_setAsicNaptTcpFastTimeout(nat_tbl.tcp_timeout);
+	rtl8651_setAsicNaptUdpTimeout(nat_tbl.udp_timeout);
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_nat_init(void)
+{
+	rtl865x_tblAsicDrv_naptTcpUdpParam_t naptTcpUdp;
+	uint32 flowTblIdx;
+
+	memset(nat_tbl.nat_bucket, 0,
+		sizeof(struct nat_entry) * RTL8651_TCPUDPTBL_SIZE);
+
+	nat_tbl.connNum = 0;
+	nat_tbl.tcp_timeout = TCP_TIMEOUT;	//24*60*60;
+	nat_tbl.udp_timeout = UDP_TIMEOUT;	//60*15;
+	nat_tbl.freeEntryNum = RTL8651_TCPUDPTBL_SIZE;
+
+	/* Set ASIC timeout value */
+	rtl8651_setAsicNaptTcpLongTimeout(TCP_TIMEOUT);
+	rtl8651_setAsicNaptTcpMediumTimeout(TCP_TIMEOUT);
+	rtl8651_setAsicNaptTcpFastTimeout(TCP_TIMEOUT);
+	rtl8651_setAsicNaptUdpTimeout(UDP_TIMEOUT);
+
+	/*enable 865xC enhanced hash1 */
+	_rtl8651_enableEnhancedHash1();
+
+	/* Initial ASIC NAT Table */
+	memset(&naptTcpUdp, 0, sizeof(naptTcpUdp));
+	naptTcpUdp.isCollision = 1;
+	naptTcpUdp.isCollision2 = 1;
+	for (flowTblIdx = 0; flowTblIdx < RTL8651_TCPUDPTBL_SIZE; flowTblIdx++)
+		rtl8651_setAsicNaptTcpUdpTable(TRUE, flowTblIdx, &naptTcpUdp);
+
+	//rtl865x_nat_register_event();
+
+	return SUCCESS;
+}
+
+static struct nat_entry *_rtl865x_nat_outbound_lookup(struct nat_tuple
+	*nat_tuple)
+{
+	struct nat_entry *nat_out;
+	uint32 i, hash;
+
+	hash = rtl8651_naptTcpUdpTableIndex((uint8)nat_tuple->proto,
+		nat_tuple->int_host.ip, nat_tuple->int_host.port,
+		nat_tuple->rem_host.ip, nat_tuple->rem_host.port);
+	if (rtl865x_enableNaptFourWay == TRUE) {
+		for (i = 0; i < 4; i++) {
+			nat_out = &nat_tbl.nat_bucket[hash];
+			if (!memcmp(nat_out, nat_tuple, sizeof(*nat_tuple)) &&
+				(nat_out->flags & NAT_OUTBOUND)) {
+				return nat_out;
+			}
+			hash = (hash & 0xFFFFFFFC) + (hash + 1) % 4;
+			assert(hash <= RTL8651_TCPUDPTBL_SIZE);
+		}
+	} else {
+		nat_out = &nat_tbl.nat_bucket[hash];
+		if (!memcmp(nat_out, nat_tuple, sizeof(*nat_tuple)) &&
+			(nat_out->flags & NAT_OUTBOUND))
+			return nat_out;
+	}
+	return (struct nat_entry *)0;
+}
+
+static struct nat_entry *_rtl865x_nat_inbound_lookup(struct nat_tuple
+	*nat_tuple)
+{
+	struct nat_entry *nat_in;
+	uint32 hash;
+
+	hash = rtl8651_naptTcpUdpTableIndex((uint8)nat_tuple->proto,
+		nat_tuple->rem_host.ip, nat_tuple->rem_host.port,
+		nat_tuple->ext_host.ip, nat_tuple->ext_host.port);
+
+	nat_in = &nat_tbl.nat_bucket[hash];
+	if (!memcmp(nat_in, nat_tuple, sizeof(*nat_tuple)) &&
+		(nat_in->flags & NAT_INBOUND)) {
+		return nat_in;
+	}
+
+	return (struct nat_entry *)0;
+}
+
+#if defined (CONFIG_RTL_INBOUND_COLLISION_AVOIDANCE)
+static int _rtl865x_isEntryPreReserved(uint32 index)
+{
+	struct nat_entry *natEntry;
+
+	if (index >= RTL8651_TCPUDPTBL_SIZE) {
+		return FALSE;
+	}
+
+	natEntry = &nat_tbl.nat_bucket[index];
+
+	if ((natEntry->flags & NAT_PRE_RESERVED)) {
+		if (jiffies >= natEntry->reserveTime) {
+			if (jiffies >
+				(natEntry->reserveTime +
+					RESERVE_EXPIRE_TIME * HZ)) {
+				/*pre-reserve become invalid now */
+				natEntry->flags &= (~(NAT_PRE_RESERVED));
+				natEntry->reserveTime = 0;
+				return FALSE;
+			} else {
+				return TRUE;
+			}
+		} else {
+			/*timer overflow */
+			if (((0xFFFFFFFF - natEntry->reserveTime) + jiffies + 1) >
+				(RESERVE_EXPIRE_TIME * HZ)) {
+				natEntry->flags &= (~(NAT_PRE_RESERVED));
+				natEntry->reserveTime = 0;
+				return FALSE;
+			} else {
+				return TRUE;
+			}
+		}
+		return TRUE;
+	}
+
+	return FALSE;
+}
+
+static int _rtl865x_PreReserveEntry(uint32 index)
+{
+	struct nat_entry *natEntry;
+
+	if (index >= RTL8651_TCPUDPTBL_SIZE) {
+		return FAILED;
+	}
+	natEntry = &nat_tbl.nat_bucket[index];
+
+	if (NAT_INUSE(natEntry)) {
+		/*already used by other napt connection, can not reserve it */
+		natEntry->flags &= (~(NAT_PRE_RESERVED));
+		natEntry->reserveTime = 0;
+	} else {
+		natEntry->flags |= NAT_PRE_RESERVED;
+		natEntry->reserveTime = jiffies;
+	}
+	return SUCCESS;
+}
+
+static int _rtl865x_getNaptHashInfo(rtl865x_napt_entry *naptEntry,
+	rtl865x_naptHashInfo_t * naptHashInfo)
+{
+
+	uint32 in, out;
+	uint32 i, index;
+	struct nat_entry *nat_in, *nat_out;
+	struct nat_entry *natEntry;
+
+	if (naptHashInfo == NULL) {
+		return FAILED;
+	}
+
+	memset(naptHashInfo, 0, sizeof(rtl865x_naptHashInfo_t));
+
+	in = rtl8651_naptTcpUdpTableIndex((uint8)(naptEntry->protocol),
+		naptEntry->remIp, naptEntry->remPort, naptEntry->extIp,
+		naptEntry->extPort);
+	out = rtl8651_naptTcpUdpTableIndex((uint8)(naptEntry->protocol),
+		naptEntry->intIp, naptEntry->intPort, naptEntry->remIp,
+		naptEntry->remPort);
+
+	if (rtl865x_enableNaptFourWay == TRUE) {
+		uint32 outAvailIdx = 0xFFFFFFFF;
+
+		index = out;
+		for (i = 0; i < 4; i++) {
+			natEntry = &nat_tbl.nat_bucket[index];
+			if (NAT_INUSE(natEntry) ||
+				_rtl865x_isEntryPreReserved(index)) {
+
+			} else {
+				if (index == in) {
+					/*collide with inbound */
+				} else {
+					out = index;
+					break;
+				}
+			}
+			index = (index & 0xFFFFFFFC) + (index + 1) % 4;
+			assert(index <= RTL8651_TCPUDPTBL_SIZE);
+
+		}
+
+		if (i >= 4) {
+			/*only one empty entry, but collide with its own inbound */
+			if (outAvailIdx != 0xFFFFFFFF) {
+				out = outAvailIdx;
+			}
+		} else {
+			/*proper empty entry has been found */
+		}
+	}
+
+	naptHashInfo->outIndex = out;
+	naptHashInfo->inIndex = in;
+
+	if ((in & 0xFFFFFFFC) == (out & 0xFFFFFFFC)) {
+		naptHashInfo->sameFourWay = 1;
+	}
+
+	if (in == out) {
+		naptHashInfo->sameLocation = 1;
+
+		nat_out = &nat_tbl.nat_bucket[out];
+		if (NAT_INUSE(nat_out) || _rtl865x_isEntryPreReserved(out)) {
+			naptHashInfo->outCollision = 1;
+		}
+
+		naptHashInfo->inCollision = 1;
+	} else {
+		nat_out = &nat_tbl.nat_bucket[out];
+		nat_in = &nat_tbl.nat_bucket[in];
+
+		if (NAT_INUSE(nat_out) || _rtl865x_isEntryPreReserved(out)) {
+			naptHashInfo->outCollision = 1;
+		}
+
+		if (NAT_INUSE(nat_in) || _rtl865x_isEntryPreReserved(in)) {
+			naptHashInfo->inCollision = 1;
+		}
+	}
+
+	index = in;
+	naptHashInfo->inFreeCnt = 0;
+	for (i = 0; i < 4; i++) {
+		natEntry = &nat_tbl.nat_bucket[index];
+		if (NAT_INUSE(natEntry) || _rtl865x_isEntryPreReserved(index)) {
+
+		} else {
+			naptHashInfo->inFreeCnt++;
+		}
+		index = (index & 0xFFFFFFFC) + (index + 1) % 4;
+		assert(index <= RTL8651_TCPUDPTBL_SIZE);
+	}
+#if 0
+	printk("%s:%d:%s (%u.%u.%u.%u:%u -> %u.%u.%u.%u:%u -> %u.%u.%u.%u:%u) ,out is %d,in is %d\n",
+		__FUNCTION__, __LINE__, protocol ? "tcp" : "udp",
+		NIPQUAD(intIp), intPort, NIPQUAD(extIp), extPort, NIPQUAD(remIp), remPort, out, in);
+#endif
+	return SUCCESS;
+}
+
+int rtl865x_optimizeExtPort(unsigned short origDelta, unsigned int rangeSize,
+	unsigned short *newDelta)
+{
+	int i;
+	int msb;
+	unsigned int bitShift;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	CHECK_IF_HWNAT_READY;
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+	msb = 0;
+	for (i = 0; i < 16; i++) {
+		if ((1 << i) & rangeSize) {
+			msb = i;
+		}
+	}
+
+	if (((1 << msb) + 1) > rangeSize) {
+		if (msb > 1) {
+			msb--;
+		}
+	}
+
+	*newDelta = 0;
+	if (msb < 10) {
+		bitShift = 0x01;
+		for (i = 0; i <= msb; i++) {
+			if (i == 0) {	/*bit0 keep the same */
+				if (origDelta & bitShift) {
+					*newDelta |= bitShift;
+				}
+			} else {	/*original bit1~ bit_maxPower mapped to bit_maxPower~bit1 */
+
+				if (origDelta & bitShift) {
+					*newDelta |= (0x1 << (msb + 1 - i));
+				}
+			}
+
+			bitShift = bitShift << 1;
+		}
+	} else {
+		bitShift = 0x01;
+
+		for (i = 0; i <= msb; i++) {
+			if (i == 0) {	/*bit0 keep the same */
+				if (origDelta & bitShift) {
+					*newDelta |= bitShift;
+				}
+			} else if (i < 10) {	/*bit1~ bit9 mapped to bit 9~bit1 */
+				if (origDelta & bitShift) {
+					*newDelta |= (0x1 << (10 - i));
+				}
+			} else {	/*other bits keep the same */
+
+				if (origDelta & bitShift) {
+					*newDelta |= bitShift;
+				}
+			}
+
+			bitShift = bitShift << 1;
+		}
+
+	}
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl865x_optimizeExtPort);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+int rtl865x_getAsicNaptHashScore(rtl865x_napt_entry *naptEntry,
+	uint32 *naptHashScore)
+{
+	rtl865x_naptHashInfo_t naptHashInfo;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	CHECK_IF_HWNAT_READY;
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+	_rtl865x_getNaptHashInfo(naptEntry, &naptHashInfo);
+
+	/*initialize napt hash score */
+	*naptHashScore = 100;
+
+	/*note:we can not change outbound index */
+
+	if (naptHashInfo.inCollision == FALSE) {
+		if (naptHashInfo.inFreeCnt == 4) {
+			if (!naptHashInfo.sameFourWay) {
+				*naptHashScore = 100;
+			} else {
+				if (!naptHashInfo.sameLocation) {
+					*naptHashScore = 80;
+				} else {
+					*naptHashScore = 0;
+				}
+			}
+		} else if (naptHashInfo.inFreeCnt == 3) {
+			if (!naptHashInfo.sameFourWay) {
+				*naptHashScore = 80;
+			} else {
+				if (!naptHashInfo.sameLocation) {
+					*naptHashScore = 70;
+				} else {
+					*naptHashScore = 0;
+				}
+			}
+		} else if (naptHashInfo.inFreeCnt == 2) {
+			if (!naptHashInfo.sameFourWay) {
+				*naptHashScore = 70;
+			} else {
+				if (!naptHashInfo.sameLocation == FALSE) {
+					*naptHashScore = 60;
+				} else {
+					*naptHashScore = 0;
+				}
+			}
+		} else if (naptHashInfo.inFreeCnt == 1) {
+			if (naptHashInfo.sameFourWay == FALSE) {
+				*naptHashScore = 60;
+			} else {
+				*naptHashScore = 0;
+
+			}
+		} else {
+			*naptHashScore = 0;
+		}
+
+	} else {
+		/*worst case:inbound is collision */
+		*naptHashScore = 0;
+	}
+
+	return SUCCESS;
+
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl865x_getAsicNaptHashScore);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+int32 rtl865x_preReserveConn(rtl865x_napt_entry *naptEntry)
+{
+
+	rtl865x_naptHashInfo_t naptHashInfo;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	CHECK_IF_HWNAT_READY;
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+	_rtl865x_getNaptHashInfo(naptEntry, &naptHashInfo);
+
+	if (naptHashInfo.outCollision == FALSE) {
+		_rtl865x_PreReserveEntry(naptHashInfo.outIndex);
+	}
+
+	if (naptHashInfo.inCollision == FALSE) {
+		_rtl865x_PreReserveEntry(naptHashInfo.inIndex);
+	}
+
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl865x_preReserveConn);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#endif
+#if defined (CONFIG_RTL865X_NAT_ADD_FAIL_CHECK)
+static int32 _rtl865x_addNaptConnectionFailCheck(void)
+{
+
+	if (time_before_eq((lastJiffies + HZ), jiffies)) {
+		lastJiffies = jiffies;
+		failedCount = 0;
+	}
+
+	if (failedCount > ADD_FAILURE_TRHREHOLD) {
+		return RTL_ETOOMANYCOLLISION;
+	}
+	return SUCCESS;
+}
+#endif
+
+static int32 _rtl865x_addNaptConnection(rtl865x_napt_entry *naptEntry,
+	rtl865x_priority * prio)
+{
+	int32 retval;
+	rtl865x_tblAsicDrv_naptTcpUdpParam_t asic_nat;
+	struct nat_entry *nat_in, *nat_out;
+	struct nat_tuple nat_tuple;
+	uint32 in, out, offset, ipidx, i;
+	uint16 very, selEidx_out;
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+	rtl865x_route_t rt;
+	rtl865x_arpMapping_entry_t arpInfo;
+	ipaddr_t sip, dip;
+	uint16 sport, dport;
+	rtl865x_AclRule_t rule4[2], rule2[2];
+	int32 defPriority[2];
+	int32 upDown[2], defUpDown[2];	//0: uplink; 1: downlink
+	#endif
+	int32 priority[2];
+#endif
+	int32 elasped, del_conn_flags;
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	uint32 isExtNaptEntry = 0;
+#endif
+	uint32 outCollision = FALSE;
+	uint32 inCollision = FALSE;
+	uint16 extPort;
+
+	/* Make sure natip */
+	retval = rtl865x_getIpIdxByExtIp(htonl(naptEntry->extIp), &ipidx);
+	if (retval != SUCCESS)
+		return RTL_EINVALIDINPUT;
+#if defined (CONFIG_RTL865X_NAT_ADD_FAIL_CHECK)
+	if (_rtl865x_addNaptConnectionFailCheck() == RTL_ETOOMANYCOLLISION) {
+		return RTL_ETOOMANYCOLLISION;
+	}
+#endif
+	memset(&nat_tuple, 0, sizeof(struct nat_tuple));
+	nat_tuple.int_host.ip = htonl(naptEntry->intIp);
+	nat_tuple.int_host.port = htons((uint16)(naptEntry->intPort));
+	nat_tuple.ext_host.ip = htonl(naptEntry->extIp);
+	nat_tuple.ext_host.port = htons((uint16)(naptEntry->extPort));
+	nat_tuple.rem_host.ip = htonl(naptEntry->remIp);
+	nat_tuple.rem_host.port = htons((uint16)(naptEntry->remPort));
+	nat_tuple.proto = naptEntry->protocol;
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	isExtNaptEntry = naptEntry->isExtNaptEntry;
+#endif
+	nat_out = _rtl865x_nat_outbound_lookup(&nat_tuple);
+	if (nat_out) {
+		return RTL_EENTRYALREADYEXIST;
+	}
+
+	nat_in = _rtl865x_nat_inbound_lookup(&nat_tuple);
+	if (nat_in) {
+		return RTL_EENTRYALREADYEXIST;
+	}
+
+	extPort = htons((uint16)(naptEntry->extPort));
+	offset = (extPort & 0x0000ffff) >> 10;
+	selEidx_out = extPort & 0x3ff;
+
+	very = rtl8651_naptTcpUdpTableIndex(((uint8)naptEntry->protocol) |
+		HASH_FOR_VERI, htonl(naptEntry->remIp),
+		htons((uint16)(naptEntry->remPort)), 0, 0);
+	in = rtl8651_naptTcpUdpTableIndex((uint8)naptEntry->protocol,
+		htonl(naptEntry->remIp), htons((uint16)(naptEntry->remPort)),
+		htonl(naptEntry->extIp), extPort);
+	out = rtl8651_naptTcpUdpTableIndex((uint8)naptEntry->protocol,
+		htonl(naptEntry->intIp), htons((uint16)(naptEntry->intPort)),
+		htonl(naptEntry->remIp), htons((uint16)(naptEntry->remPort)));
+	/*support outbound 4-way */
+	if (rtl865x_enableNaptFourWay == TRUE) {
+
+		uint32 hash = out;
+		uint32 outAvailIdx = 0xFFFFFFFF;
+
+		for (i = 0; i < 4; i++) {
+			nat_out = &nat_tbl.nat_bucket[hash];
+			if (NAT_INUSE(nat_out)) {
+				/* collision with outbound */
+			} else {
+				outAvailIdx = hash;
+				if (hash == in) {
+					/*collision with inbound */
+				} else {
+					out = hash;
+					break;
+				}
+			}
+			hash = (hash & 0xFFFFFFFC) + (hash + 1) % 4;
+			assert(hash <= RTL8651_TCPUDPTBL_SIZE);
+
+		}
+
+		if (i >= 4) {
+			/*only one empty entry,but collide with its own inbound */
+			if (outAvailIdx != 0xFFFFFFFF) {
+				out = outAvailIdx;
+			}
+		}
+	}
+
+	nat_out = &nat_tbl.nat_bucket[out];
+	nat_in = &nat_tbl.nat_bucket[in];
+
+	del_conn_flags = 0;
+	if (NAT_INUSE(nat_out)) {
+		elasped = _rtl865x_naptIdleCheck(out);
+		if (((nat_out->tuple_info.proto == RTL865X_PROTOCOL_UDP) &&
+			(elasped > UDP_OVERRIDE_ELASPED_THRESHOLD)) ||
+			((nat_out->tuple_info.proto == RTL865X_PROTOCOL_TCP) &&
+			(elasped > TCP_OVERRIDE_ELASPED_THRESHOLD))) {
+			NAT_INVALID(nat_out);	/*      invalide        */
+			nat_tbl.freeEntryNum++;
+			del_conn_flags++;
+		}
+	}
+
+	if (NAT_INUSE(nat_in)) {
+		elasped = _rtl865x_naptIdleCheck(in);
+		if (((nat_out->tuple_info.proto == RTL865X_PROTOCOL_UDP) &&
+			(elasped > UDP_OVERRIDE_ELASPED_THRESHOLD)) ||
+			((nat_out->tuple_info.proto == RTL865X_PROTOCOL_TCP) &&
+			(elasped > TCP_OVERRIDE_ELASPED_THRESHOLD))) {
+			NAT_INVALID(nat_in);	/*      invalide        */
+			nat_tbl.freeEntryNum++;
+			del_conn_flags++;
+		}
+	}
+
+	if (del_conn_flags == 2) {
+		nat_tbl.connNum--;
+	}
+
+	if (NAT_INUSE(nat_out) && NAT_INUSE(nat_in)) {
+		/*both outbound and inbound has been occupied */
+#if defined (CONFIG_RTL865X_NAT_ADD_FAIL_CHECK)
+		failedCount++;
+#endif
+		return RTL_EINVALIDINPUT;
+	}
+
+	if (out == in) {
+		outCollision = FALSE;
+		inCollision = TRUE;
+		/*we don't support this case at present, otherwise, when delete napt connection must be very very careful */
+		//return RTL_EENTRYALREADYEXIST;
+	} else {
+		if (NAT_INUSE(nat_out)) {
+			outCollision = TRUE;
+		}
+
+		if (NAT_INUSE(nat_in)) {
+			inCollision = TRUE;
+		}
+	}
+#ifdef CONFIG_HARDWARE_NAT_DEBUG
+	rtlglue_printf("LR(%s):  %s (%u.%u.%u.%u:%u -> %u.%u.%u.%u:%u) g:(%u.%u.%u.%u:%u)\n",
+		("add_nat"), ((naptEntry->protocol) ? "tcp" : "udp"),
+		NIPQUAD(naptEntry->intIp), ntohs(naptEntry->intPort),
+		NIPQUAD(naptEntry->remIp), ntohs(naptEntry->remPort),
+		NIPQUAD(naptEntry->extIp), ntohs(naptEntry->extPort));
+#endif
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	if (isExtNaptEntry) {
+#if 0
+		if (outCollision == TRUE)
+#else
+		if ((outCollision == TRUE) || (inCollision == TRUE))
+#endif
+		{
+#if defined (CONFIG_RTL865X_NAT_ADD_FAIL_CHECK)
+			failedCount++;
+#endif
+			/*we must make sure both direction can be written into asic */
+			return RTL_EINVALIDINPUT;
+		}
+	} else
+#endif
+	{
+#if defined (CONFIG_RTL_HALF_NAPT_ACCELERATION)
+
+#else
+		if ((outCollision == TRUE) || (inCollision == TRUE)) {
+#if defined (CONFIG_RTL865X_NAT_ADD_FAIL_CHECK)
+			failedCount++;
+#endif
+			/*we must make sure both direction can be written into asic */
+			return RTL_EINVALIDINPUT;
+		}
+#endif
+	}
+
+	if (outCollision == FALSE) {
+		memset(nat_out, 0, sizeof(struct nat_entry));
+		*((struct nat_tuple *)nat_out) = nat_tuple;
+		nat_out->out = out;
+		if (inCollision == FALSE) {
+			nat_out->in = in;
+		} else {
+			nat_out->in = 0xFFFFFFFF;
+		}
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+		nat_out->isExtNaptEntry = isExtNaptEntry;
+#endif
+		nat_out->natip_idx = ipidx;
+		SET_NAT_FLAGS(nat_out, NAT_OUTBOUND);
+	} else {
+		nat_out = NULL;
+	}
+
+	if (inCollision == FALSE) {
+		memset(nat_in, 0, sizeof(struct nat_entry));
+		*((struct nat_tuple *)nat_in) = nat_tuple;
+		nat_in->in = in;
+		if (outCollision == FALSE) {
+			nat_in->out = out;
+		} else {
+			nat_in->out = 0xFFFFFFFF;
+		}
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+		nat_in->isExtNaptEntry = isExtNaptEntry;
+#endif
+		nat_in->natip_idx = ipidx;
+		SET_NAT_FLAGS(nat_in, NAT_INBOUND);
+	} else {
+		nat_in = NULL;
+	}
+
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT)
+#if	defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+	sip = naptEntry->intIp;
+	dip = naptEntry->remIp;
+	sport = naptEntry->intPort;
+	dport = naptEntry->remPort;
+
+	//Initial
+	for (i = 0; i < 2; i++) {
+		priority[i] = 0;
+		defPriority[i] = -1;
+		upDown[i] = -1;
+		defUpDown[i] = -1;
+	}
+
+	for (i = 0; i < 2; i++) {
+		if (rtl865x_getRouteEntry(sip, &rt) == SUCCESS) {
+			/*      check ip base rule firstly      */
+
+			memset(&rule4[i], 0, sizeof(rtl865x_AclRule_t));
+			rule4[i].ruleType_ = (naptEntry->protocol == RTL865X_PROTOCOL_TCP ?
+				RTL865X_ACL_TCP : RTL865X_ACL_UDP);
+			rule4[i].srcIpAddr_ = sip;
+			rule4[i].dstIpAddr_ = dip;
+			rule4[i].tcpSrcPortLB_ = sport;
+			rule4[i].tcpDstPortLB_ = dport;
+			rule4[i].netifIdx_ = _rtl865x_getNetifIdxByNameExt(
+							rt.dstNetif->name);
+
+			if (rtl865x_qosCheckNaptPriority(&rule4[i]) == SUCCESS) {
+				priority[i] = rule4[i].priority_;	/* matched priority     */
+				upDown[i] = rule4[i].upDown_;
+				//break;
+
+				if (i == 0) {
+					sip = naptEntry->remIp;
+					dip = naptEntry->intIp;
+					sport = naptEntry->remPort;
+					dport = naptEntry->intPort;
+					continue;
+				}
+
+			} else if (i == 0) {
+				sip = naptEntry->remIp;
+				dip = naptEntry->intIp;
+				sport = naptEntry->remPort;
+				dport = naptEntry->intPort;
+				continue;
+			} else {
+				defPriority[i] = rule4[i].priority_;
+				defUpDown[i] = rule4[i].upDown_;
+			}
+		} else {
+			sip = naptEntry->remIp;
+			dip = naptEntry->intIp;
+			sport = naptEntry->remPort;
+			dport = naptEntry->intPort;
+		}
+	}
+
+	{
+		sip = naptEntry->intIp;
+		for (i = 0; i < 2; i++) {
+			memset(&rule2[i], 0, sizeof(rtl865x_AclRule_t));
+		}
+
+		for (i = 0; i < 2; i++) {
+			if (rtl865x_getArpMapping(sip, &arpInfo) == SUCCESS &&
+				rtl865x_getRouteEntry(sip, &rt) == SUCCESS) {
+				/*      check mac base rule secondly    */
+				//memset(&rule2[i], 0, sizeof(rtl865x_AclRule_t));
+				rule2[i].ruleType_ = RTL865X_ACL_MAC;
+				memcpy(rule2[i].srcMac_.octet,
+					arpInfo.mac.octet, ETHER_ADDR_LEN);
+				memset(rule2[i].srcMacMask_.octet, 0xff,
+					ETHER_ADDR_LEN);
+				rule2[i].netifIdx_ = _rtl865x_getNetifIdxByNameExt(
+								rt.dstNetif->name);
+
+				//printk("----%s[%d], rt.dstNetif->name is %s, rule2[i].srcMac_.octet is 0x%x%x%x%x%x%x\n", __FUNCTION__, __LINE__, rt.dstNetif->name,
+				//rule2[i].srcMac_.octet[0], rule2[i].srcMac_.octet[1],rule2[i].srcMac_.octet[2],rule2[i].srcMac_.octet[3],rule2[i].srcMac_.octet[4],rule2[i].srcMac_.octet[5]);
+
+				if (rtl865x_qosCheckNaptPriority(&rule2[i]) ==
+					SUCCESS) {
+					priority[i] = rule2[i].priority_;	/* matched priority     */
+					upDown[i] = rule2[i].upDown_;
+					//break;
+
+					if (i == 0) {
+						sip = naptEntry->remIp;
+						continue;
+					}
+				} else if (i == 0) {
+					sip = naptEntry->remIp;
+					continue;
+				}
+			} else {
+				sip = naptEntry->remIp;
+			}
+		}
+
+		dip = naptEntry->remIp;
+		for (i = 0; i < 2; i++) {
+			if ((rule2[i].aclIdx == 0) &&
+				rtl865x_getArpMapping(dip, &arpInfo) == SUCCESS &&
+				rtl865x_getRouteEntry(naptEntry->remIp, &rt) == SUCCESS) {
+				/*      check mac base rule secondly  */
+				//memset(&rule2[i], 0, sizeof(rtl865x_AclRule_t));
+				rule2[i].ruleType_ = RTL865X_ACL_MAC;
+				memcpy(rule2[i].dstMac_.octet,
+					arpInfo.mac.octet, ETHER_ADDR_LEN);
+				memset(rule2[i].dstMacMask_.octet, 0xff,
+					ETHER_ADDR_LEN);
+				rule2[i].netifIdx_ = _rtl865x_getNetifIdxByNameExt(
+					rt.dstNetif->name);
+
+				//printk("----%s[%d], rt.dstNetif->name is %s, rule2[i].dstMac_.octet is 0x%x%x%x%x%x%x\n", __FUNCTION__, __LINE__, rt.dstNetif->name,
+				//rule2[i].dstMac_.octet[0], rule2[i].dstMac_.octet[1],rule2[i].dstMac_.octet[2],rule2[i].dstMac_.octet[3],rule2[i].dstMac_.octet[4],rule2[i].dstMac_.octet[5]);
+
+				if (rtl865x_qosCheckNaptPriority(&rule2[i]) ==
+					SUCCESS) {
+					priority[i] = rule2[i].priority_;	/* matched priority     */
+					upDown[i] = rule2[i].upDown_;
+					//break;
+
+					if (i == 0) {
+						dip = naptEntry->intIp;
+						continue;
+					}
+
+				} else if (i == 0) {
+					dip = naptEntry->intIp;
+					continue;
+				} else {
+					defPriority[i] = rule2[i].priority_;
+					defUpDown[i] = rule2[i].upDown_;
+				}
+			} else {
+				dip = naptEntry->intIp;
+			}
+		}
+	}
+
+	for (i = 0; i < 2; i++) {
+		if (rule4[i].aclIdx && rule2[i].aclIdx) {
+			priority[i] = (rule4[i].aclIdx < rule2[i].aclIdx) ?
+				rule4[i].priority_ : rule2[i].priority_;
+			upDown[i] = (rule4[i].aclIdx < rule2[i].aclIdx) ?
+				rule4[i].upDown_ : rule2[i].upDown_;
+		} else if (rule4[i].aclIdx) {
+			priority[i] = rule4[i].priority_;
+			upDown[i] = rule4[i].upDown_;
+		} else if (rule2[i].aclIdx) {
+			priority[i] = rule2[i].priority_;
+			upDown[i] = rule2[i].upDown_;
+		} else if (defPriority[i] > -1) {
+			priority[i] = defPriority[i];
+			upDown[i] = defUpDown[i];
+		}
+	}
+#else /*      defined(CONFIG_RTL_IPTABLES_RULE_2_ACL) */
+	priority[0] = prio->uplinkPrio;
+	priority[1] = prio->downlinkPrio;
+#endif /*      defined(CONFIG_RTL_IPTABLES_RULE_2_ACL) */
+#endif /*      defined(CONFIG_RTL_HW_QOS_SUPPORT)              */
+
+	for (i = 0; i < 2; i++) {
+
+		if (i == 0) {
+			/*check writing outbound connection into asic */
+			if ((outCollision == TRUE) || (nat_out == NULL)) {
+				/*shouldn't be written into asic */
+				continue;
+			}
+		} else if (i == 1) {
+			/*check writing inbound connection into asic */
+			if ((inCollision == TRUE) || (nat_in == NULL)) {
+				/*shouldn't be written into asic */
+				continue;
+			}
+		} else {
+			break;
+		}
+		//If qos enabled, not add inbound napt
+		//That is all downlink pkt will be trapped to CPU for software QoS
+#if 0
+		/* drop pkt in the queue will resolve the wan->lan issue */
+		if ((flags == FLAG_QOS_ENABLE) && (i == 1))
+			break;
+#endif
+
+		memset(&asic_nat, 0, sizeof(asic_nat));
+		asic_nat.insideLocalIpAddr = htonl(naptEntry->intIp);
+		asic_nat.insideLocalPort = htons((uint16)(naptEntry->intPort));
+		asic_nat.isCollision = 0;
+		asic_nat.isCollision2 = 0;
+		asic_nat.isDedicated = 0;
+		asic_nat.isStatic = 1;
+		asic_nat.isTcp = (naptEntry->protocol == RTL865X_PROTOCOL_TCP) ?
+									1 : 0;
+		asic_nat.isValid = 1;
+		asic_nat.offset = ((i == 0) ? offset : (extPort & 0x3f));
+		asic_nat.selEIdx = ((i == 0) ? selEidx_out : very & 0x3ff);
+		asic_nat.selExtIPIdx = ((i == 0) ? ipidx :
+						((extPort & 0x3ff) >> 6));
+		//asic_nat.tcpFlag                      = (((in!=out)? 0x2:0x0) | ((i==0)? 1: 0));
+		/*enhanced hash1 doesn't support outbound/inbound share one connection */
+		asic_nat.tcpFlag = (0x2 | ((i == 0) ? 1 : 0));
+		asic_nat.ageSec = (naptEntry->protocol == RTL865X_PROTOCOL_TCP) ?
+			nat_tbl.tcp_timeout : nat_tbl.udp_timeout;
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT)
+		asic_nat.priValid = FALSE;
+#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+		if (i == 0 && upDown[i] == 0)	//Because ((i==0)?out: in)
+		{
+			//out: uplink
+			asic_nat.priority = priority[i];
+		}
+		if (i == 1 && upDown[i] == 1) {
+			//in: downlink
+			asic_nat.priority = priority[i];
+		}
+#else /*      defined(CONFIG_RTL_IPTABLES_RULE_2_ACL) */
+		asic_nat.priority = priority[i];
+#endif /*      defined(CONFIG_RTL_IPTABLES_RULE_2_ACL) */
+		asic_nat.priValid = TRUE;
+#else
+		asic_nat.priValid = FALSE;
+#endif
+
+		rtl8651_setAsicNaptTcpUdpTable(1, ((i == 0) ? out : in),
+			&asic_nat);
+	}
+
+	nat_tbl.connNum++;
+
+	if ((outCollision == FALSE) && (nat_out != NULL)) {
+		if (nat_tbl.freeEntryNum > 0) {
+			nat_tbl.freeEntryNum--;
+		}
+	}
+
+	if ((inCollision == FALSE) && (nat_in != NULL)) {
+		if (nat_tbl.freeEntryNum > 0) {
+			nat_tbl.freeEntryNum--;
+		}
+	}
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_delNaptConnection(rtl865x_napt_entry *naptEntry)
+{
+	struct nat_entry *nat_out, *nat_in;
+	struct nat_tuple nat_tuple;
+
+	memset(&nat_tuple, 0, sizeof(struct nat_tuple));
+	nat_tuple.int_host.ip = htonl(naptEntry->intIp);
+	nat_tuple.int_host.port = htons((uint16)(naptEntry->intPort));
+	nat_tuple.ext_host.ip = htonl(naptEntry->extIp);
+	nat_tuple.ext_host.port = htons((uint16)(naptEntry->extPort));
+	nat_tuple.rem_host.ip = htonl(naptEntry->remIp);
+	nat_tuple.rem_host.port = htons((uint16)(naptEntry->remPort));
+	nat_tuple.proto = naptEntry->protocol;
+
+	nat_out = _rtl865x_nat_outbound_lookup(&nat_tuple);
+	nat_in = _rtl865x_nat_inbound_lookup(&nat_tuple);
+
+	if ((nat_out == NULL) && (nat_in == NULL)) {
+		return RTL_EENTRYNOTFOUND;
+	}
+
+	if (nat_out == nat_in) {
+		rtl8651_delAsicNaptTcpUdpTable(nat_out->out, nat_out->out);
+		memset(nat_out, 0, sizeof(*nat_out));
+		nat_tbl.freeEntryNum++;
+
+	} else {
+		if (nat_out) {
+			rtl8651_delAsicNaptTcpUdpTable(nat_out->out,
+				nat_out->out);
+			memset(nat_out, 0, sizeof(*nat_out));
+			nat_tbl.freeEntryNum++;
+		}
+
+		if (nat_in) {
+			rtl8651_delAsicNaptTcpUdpTable(nat_in->in, nat_in->in);
+			memset(nat_in, 0, sizeof(*nat_in));
+			nat_tbl.freeEntryNum++;
+		}
+	}
+#ifdef CONFIG_HARDWARE_NAT_DEBUG
+	/*2007-12-19 */
+	rtlglue_printf("LR(%s):  %s (%u.%u.%u.%u:%u -> %u.%u.%u.%u:%u) g:(%u.%u.%u.%u:%u)\n",
+		("del_nat"), ((naptEntry->protocol) ? "tcp" : "udp"),
+		NIPQUAD(naptEntry->intIp), ntohs(naptEntry->intPort),
+		NIPQUAD(naptEntry->remIp), ntohs(naptEntry->remPort),
+		NIPQUAD(naptEntry->extIp), ntohs(naptEntry->extPort));
+#endif
+
+	if (nat_tbl.connNum > 0) {
+		nat_tbl.connNum--;
+	}
+
+	return SUCCESS;
+}
+
+static int32 _rtl865x_naptIdleCheck(int32 index)
+{
+	rtl865x_tblAsicDrv_naptTcpUdpParam_t entry;
+	int32 hw_now;
+
+	rtl8651_getAsicNaptTcpUdpTable(index, &entry);
+
+	hw_now = entry.ageSec;
+
+	if (entry.isTcp) {
+		return (nat_tbl.tcp_timeout > hw_now ?
+			nat_tbl.tcp_timeout - hw_now : 0);
+	} else {
+		return (nat_tbl.udp_timeout > hw_now ?
+			nat_tbl.udp_timeout - hw_now : 0);
+	}
+}
+
+static int32 _rtl865x_naptSync(rtl865x_napt_entry *naptEntry, uint32 refresh)
+{
+	rtl865x_tblAsicDrv_naptTcpUdpParam_t asic_nat_out;
+	rtl865x_tblAsicDrv_naptTcpUdpParam_t asic_nat_in;
+	struct nat_entry *nat_out, *nat_in;
+	struct nat_tuple nat_tuple;
+	int32 rc;
+	int32 hw_now;
+
+	memset(&nat_tuple, 0, sizeof(struct nat_tuple));
+	nat_tuple.int_host.ip = htonl(naptEntry->intIp);
+	nat_tuple.int_host.port = htons((uint16)(naptEntry->intPort));
+	nat_tuple.ext_host.ip = htonl(naptEntry->extIp);
+	nat_tuple.ext_host.port = htons((uint16)(naptEntry->extPort));
+	nat_tuple.rem_host.ip = htonl(naptEntry->remIp);
+	nat_tuple.rem_host.port = htons((uint16)(naptEntry->remPort));
+	nat_tuple.proto = naptEntry->protocol;
+
+	nat_out = _rtl865x_nat_outbound_lookup(&nat_tuple);
+	nat_in = _rtl865x_nat_inbound_lookup(&nat_tuple);
+
+	if ((!nat_out) && (!nat_in)) {
+		return -1;
+	}
+
+	memset(&asic_nat_out, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
+	memset(&asic_nat_in, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
+
+	if ((nat_out != NULL) && (nat_in != NULL)) {
+		rc = rtl8651_getAsicNaptTcpUdpTable(nat_out->out,
+			&asic_nat_out);
+		assert(rc == SUCCESS);
+
+		rc = rtl8651_getAsicNaptTcpUdpTable(nat_in->in, &asic_nat_in);
+		assert(rc == SUCCESS);
+		hw_now = (asic_nat_out.ageSec >
+			asic_nat_in.ageSec) ? asic_nat_out.ageSec : asic_nat_in.
+			ageSec;
+	} else if ((nat_out != NULL) && (nat_in == NULL)) {
+		rc = rtl8651_getAsicNaptTcpUdpTable(nat_out->out,
+			&asic_nat_out);
+		assert(rc == SUCCESS);
+		hw_now = asic_nat_out.ageSec;
+	} else if ((nat_out == NULL) && (nat_in != NULL)) {
+		rc = rtl8651_getAsicNaptTcpUdpTable(nat_in->in, &asic_nat_in);
+		assert(rc == SUCCESS);
+		hw_now = asic_nat_in.ageSec;
+
+	} else {
+		hw_now = 0;
+	}
+
+	if (hw_now == 0) {
+		return -1;
+	} else {
+		if (naptEntry->protocol == RTL865X_PROTOCOL_UDP) {
+			return (nat_tbl.udp_timeout >
+				hw_now ? nat_tbl.udp_timeout - hw_now : 0);
+		} else if (naptEntry->protocol == RTL865X_PROTOCOL_TCP) {
+			return (nat_tbl.tcp_timeout >
+				hw_now ? nat_tbl.tcp_timeout - hw_now : 0);
+		}
+	}
+
+	return -1;
+}
+
+/*
+@func int32 | rtl865x_addNaptConnection |add a napt entry.
+@parm uint32 | protocol | protocol.
+@parm ipaddr_t | intIp | internal ip address.
+@parm uint32 | intPort | internal port.
+@parm ipaddr_t | extIp | external ip address.
+@parm uint32 | extPort | external port.
+@parm ipaddr_t | remIp | remote ip address.
+@parm uint32 | remPort | remote port.
+@parm int32 | flags | flags.
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@rvalue RTL_EINVALIDINPUT | invalid input.
+@rvalue RTL_EENTRYALREADYEXIST | route entry is already exist.
+@rvalue RTL_ENOFREEBUFFER | not enough memory in system.
+@comm
+	value of protocol should be RTL865X_PROTOCOL_TCP/RTL865X_PROTOCOL_UDP
+*/
+int32 rtl865x_addNaptConnection(rtl865x_napt_entry *naptEntry,
+	rtl865x_priority * prio)
+{
+	int32 retval = FAILED;
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl865x_addNaptConnection(naptEntry, prio);
+	SMP_UNLOCK_ETH_HW(flags);
+
+	return retval;
+}
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+static int32 rtl865x_nat_callbackFn_for_del_arp(void *param)
+{
+	uint32 i = 0;
+
+	//int ret=0;
+	struct nat_entry *natEntryPtr = NULL;
+	rtl865x_arpMapping_entry_t *arpEntry = NULL;
+	rtl865x_napt_entry naptEntry;
+
+	if (param == NULL) {
+		return EVENT_CONTINUE_EXECUTE;
+	}
+	arpEntry = (rtl865x_arpMapping_entry_t *)param;
+	memset(&naptEntry, 0, sizeof(rtl865x_napt_entry));
+	for (i = 0; i < RTL8651_TCPUDPTBL_SIZE; i++) {
+		natEntryPtr = &nat_tbl.nat_bucket[i];
+		if (NAT_INUSE(natEntryPtr)) {
+
+			if ((arpEntry->ip == natEntryPtr->int_ip_) ||
+				(arpEntry->ip == natEntryPtr->rem_ip_)) {
+#if 0
+				printk("intIp is 0x%x, intPort is %d, remIp is 0x%x, remPort is %d, extIp is 0x%x, extPort is %d,[%s]:[%d]\n",
+					natEntryPtr->int_ip_, natEntryPtr->int_port_, natEntryPtr->rem_ip_, natEntryPtr->rem_port_,
+					natEntryPtr->ext_ip_, natEntryPtr->ext_port_, __FUNCTION__, __LINE__);
+#endif
+				naptEntry.protocol = natEntryPtr->proto_;
+				naptEntry.intIp = natEntryPtr->int_ip_;
+				naptEntry.intPort = natEntryPtr->int_port_;
+				naptEntry.remIp = natEntryPtr->rem_ip_;
+				naptEntry.remPort = natEntryPtr->rem_port_;
+				naptEntry.extIp = natEntryPtr->ext_ip_;
+				naptEntry.extPort = natEntryPtr->ext_port_;
+				//ret=1;
+				rtl865x_delNaptConnection(&naptEntry);
+			}
+		}
+
+	}
+#if 0
+	if (ret)
+		rtl865x_delNaptConnection(&naptEntry);
+#endif
+	return EVENT_CONTINUE_EXECUTE;
+
+}
+
+static int32 rtl865x_nat_unRegister_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+
+	eventParam.eventLayerId = DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_DEL_ARP;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = rtl865x_nat_callbackFn_for_del_arp;
+	rtl865x_unRegisterEvent(&eventParam);
+	return SUCCESS;
+
+}
+
+static int32 rtl865x_nat_register_event(void)
+{
+	rtl865x_event_Param_t eventParam;
+
+	eventParam.eventLayerId = DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_DEL_ARP;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = rtl865x_nat_callbackFn_for_del_arp;
+	rtl865x_registerEvent(&eventParam);
+	return SUCCESS;
+
+}
+
+#endif
+/*
+@func int32 | rtl865x_delNaptConnection |delete a napt entry.
+@parm uint32 | protocol | protocol.
+@parm ipaddr_t | intIp | internal ip address.
+@parm uint32 | intPort | internal port.
+@parm ipaddr_t | extIp | external ip address.
+@parm uint32 | extPort | external port.
+@parm ipaddr_t | remIp | remote ip address.
+@parm uint32 | remPort | remote port.
+
+@rvalue SUCCESS | success.
+@rvalue FAILED | failed.
+@rvalue RTL_EENTRYNOTFOUND | not found this entry in system.
+@comm
+*/
+int32 rtl865x_delNaptConnection(rtl865x_napt_entry *naptEntry)
+{
+	int32 retval = FAILED;
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_HW(flags);
+	retval = _rtl865x_delNaptConnection(naptEntry);
+	SMP_UNLOCK_ETH_HW(flags);
+
+	return retval;
+}
+
+int32 rtl865x_naptSync(rtl865x_napt_entry *naptEntry, uint32 refresh)
+{
+	return _rtl865x_naptSync(naptEntry, refresh);
+}
+
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+inline static int32 rtl865x_naptSetAsicWithPriority(struct nat_entry *entry,
+	int32 priority)
+{
+	rtl865x_tblAsicDrv_naptTcpUdpParam_t asic_nat;
+	int32 idx;
+
+	//If qos enabled, not add inbound napt
+	//That is all downlink pkt will be trapped to CPU for software QoS
+	if (entry->flags & NAT_INBOUND)
+		return SUCCESS;
+
+	//printk("--%s(%d),entry(%p)\n",__FUNCTION__,__LINE__,entry);
+	idx = (entry->flags & NAT_INBOUND) ? entry->in : entry->out;
+
+	rtl8651_getAsicNaptTcpUdpTable(idx, &asic_nat);
+	asic_nat.priority = priority;
+	asic_nat.priValid = TRUE;
+	rtl8651_setAsicNaptTcpUdpTable(1, idx, &asic_nat);
+
+	return SUCCESS;
+}
+
+static int32 rtl865x_naptCallbackFn_for_qosChange(void *param)
+{
+	int num, i;
+	struct nat_entry *nat_this, *nat_that;
+	ipaddr_t sip, dip;
+	uint16 sport, dport;
+	rtl865x_route_t rt;
+	rtl865x_arpMapping_entry_t arpInfo;
+	rtl865x_AclRule_t rule4, rule2;
+	int32 priority = -1, defPriority = -1;
+
+	num = i = 0;
+
+	while (num < nat_tbl.connNum && i < RTL8651_TCPUDPTBL_SIZE) {
+		if (NAT_INUSE(&nat_tbl.nat_bucket[i])) {
+			nat_this = &nat_tbl.nat_bucket[i];
+			if (nat_this->flags & NAT_INBOUND) {
+				if (nat_this->out != 0xFFFFFFFF) {
+					nat_that = &nat_tbl.nat_bucket[nat_this->out];
+				} else {
+					/*no outbound */
+					nat_that = NULL;
+				}
+
+				sip = nat_this->rem_ip_;
+				dip = nat_this->ext_ip_;
+				sport = nat_this->rem_port_;
+				dport = nat_this->ext_port_;
+			} else {
+				if (nat_this->in != 0xFFFFFFFF) {
+					nat_that = &nat_tbl.nat_bucket[nat_this->in];
+				} else {
+					/*no inbound */
+					nat_that = NULL;
+				}
+
+				sip = nat_this->int_ip_;
+				dip = nat_this->rem_ip_;
+				sport = nat_this->int_port_;
+				dport = nat_this->rem_port_;
+			}
+
+			if (nat_this->flags & NAT_PRI_PROCESSED) {
+				CLR_NAT_FLAGS(nat_this, NAT_PRI_PROCESSED);
+				num++;
+			} else {
+				if (rtl865x_getRouteEntry(sip, &rt) == SUCCESS) {
+					memset(&rule4, 0,
+						sizeof(rtl865x_AclRule_t));
+					rule4.ruleType_ = (nat_this->proto_ == RTL865X_PROTOCOL_TCP ?
+						RTL865X_ACL_TCP : RTL865X_ACL_UDP);
+					rule4.srcIpAddr_ = sip;
+					rule4.dstIpAddr_ = dip;
+					rule4.tcpSrcPortLB_ = sport;
+					rule4.tcpDstPortLB_ = dport;
+					rule4.netifIdx_ = _rtl865x_getNetifIdxByNameExt(rt.dstNetif->name);
+					if (rule4.netifIdx_ < 0 ||
+						rule4.netifIdx_ >= NETIF_NUMBER) {
+						printk("===%s %s(%d) Can't get netif(%s)\n", __FILE__, __FUNCTION__, __LINE__, rt.dstNetif->name);
+					}
+
+					if (rule4.netifIdx_ >= 0 &&
+						rule4.netifIdx_ < NETIF_NUMBER)
+						if (rtl865x_qosCheckNaptPriority(&rule4) != SUCCESS) {
+							if (nat_this->flags & NAT_INBOUND) {
+								rule4.dstIpAddr_ = nat_this->int_ip_;
+								rule4.tcpDstPortLB_ = nat_this->int_port_;
+								if (rtl865x_qosCheckNaptPriority(&rule4) != SUCCESS)
+									defPriority = rule4.priority_;
+							} else
+								defPriority = rule4.priority_;
+						}
+
+					if (rtl865x_getArpMapping(sip,
+							&arpInfo) == SUCCESS) {
+						memset(&rule2, 0,
+							sizeof(rtl865x_AclRule_t));
+						rule2.ruleType_ = RTL865X_ACL_MAC;
+						memcpy(rule2.srcMac_.octet,
+							arpInfo.mac.octet,
+							ETHER_ADDR_LEN);
+						memset(rule2.srcMacMask_.octet,
+							0xff, ETHER_ADDR_LEN);
+						rule2.netifIdx_ = _rtl865x_getNetifIdxByNameExt(rt.dstNetif->name);
+						if (rule4.netifIdx_ < 0 ||
+							rule4.netifIdx_ >=NETIF_NUMBER) {
+							printk("===%s %s(%d) Can't get netif(%s)\n", __FILE__, __FUNCTION__, __LINE__, rt.dstNetif->name);
+						}
+
+						if (rule4.netifIdx_ >= 0 &&
+							rule4.netifIdx_ < NETIF_NUMBER)
+							if (rtl865x_qosCheckNaptPriority(&rule2) != SUCCESS) {
+								if (nat_this->flags & NAT_INBOUND)
+								{
+									if (rtl865x_getArpMapping(nat_this->int_ip_, &arpInfo) == SUCCESS) {
+										memset(&rule2, 0, sizeof(rtl865x_AclRule_t));
+										rule2.ruleType_ = RTL865X_ACL_MAC;
+										memcpy(rule2.dstMac_.octet, arpInfo.mac.octet, ETHER_ADDR_LEN);
+										memset(rule2.dstMacMask_.octet, 0xff, ETHER_ADDR_LEN);
+										rule2.netifIdx_ = _rtl865x_getNetifIdxByNameExt(rt.dstNetif->name);
+										if (rtl865x_qosCheckNaptPriority(&rule2) != SUCCESS)
+											defPriority = rule2.priority_;
+									}
+								} else
+									defPriority = rule2.priority_;
+							}
+					}
+
+					if (rule4.aclIdx && rule2.aclIdx) {
+						priority = (rule4.aclIdx < rule2.aclIdx) ?
+							rule4.priority_ : rule2.priority_;
+					} else if (rule4.aclIdx) {
+						priority = rule4.priority_;
+					} else if (rule2.aclIdx) {
+						priority = rule2.priority_;
+					}
+
+					if (priority > -1) {
+
+						rtl865x_naptSetAsicWithPriority(nat_this, priority);
+
+						if (nat_that != NULL) {
+							rtl865x_naptSetAsicWithPriority(nat_that,
+								priority);
+						}
+
+						if (nat_this->flags & NAT_PRI_HALF_PROCESSED)
+						{
+							CLR_NAT_FLAGS(nat_this,
+								NAT_PRI_HALF_PROCESSED);
+							num++;
+						} else {
+							if (nat_that != NULL) {
+								SET_NAT_FLAGS(nat_that,
+									NAT_PRI_PROCESSED);
+							} else {
+								/*only half accelerated */
+								num++;
+							}
+						}
+					} else {
+						if (nat_this->flags & NAT_PRI_HALF_PROCESSED)
+						{
+							rtl865x_naptSetAsicWithPriority(nat_this,
+								defPriority > -1 ?
+								defPriority : 0);
+							assert(nat_that != NULL);
+							if (nat_that != NULL) {
+								rtl865x_naptSetAsicWithPriority(nat_that,
+									defPriority > -1 ?
+									defPriority : 0);
+							}
+							CLR_NAT_FLAGS(nat_this,
+								NAT_PRI_HALF_PROCESSED);
+							num++;
+						} else {
+							if (nat_that != NULL) {
+								SET_NAT_FLAGS(nat_that,
+									NAT_PRI_HALF_PROCESSED);
+							} else {
+								/*only half accelerated */
+								num++;
+							}
+						}
+					}
+				} else {
+					if (nat_this->flags & NAT_PRI_HALF_PROCESSED)
+					{
+						CLR_NAT_FLAGS(nat_this,
+							NAT_PRI_HALF_PROCESSED);
+						num++;
+					} else {
+						if (nat_that != NULL) {
+							SET_NAT_FLAGS(nat_that,
+								NAT_PRI_HALF_PROCESSED);
+						} else {
+							/*only half accelerated */
+							num++;
+						}
+					}
+				}
+			}
+		}
+
+		i++;
+	}
+	return EVENT_CONTINUE_EXECUTE;
+}
+
+static int32 rtl865x_napt_register_qosEvent(void)
+{
+	rtl865x_event_Param_t eventParam;
+
+	eventParam.eventLayerId = DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_CHANGE_QOSRULE;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = rtl865x_naptCallbackFn_for_qosChange;
+	rtl865x_registerEvent(&eventParam);
+
+	eventParam.eventId = EVENT_FLUSH_QOSRULE;
+	rtl865x_registerEvent(&eventParam);
+
+	eventParam.eventLayerId = DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_ADD_ARP;
+	rtl865x_registerEvent(&eventParam);
+
+	return SUCCESS;
+}
+
+static int32 rtl865x_napt_unRegister_qosEvent(void)
+{
+	rtl865x_event_Param_t eventParam;
+
+	eventParam.eventLayerId = DEFAULT_LAYER2_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_CHANGE_QOSRULE;
+	eventParam.eventPriority = 0;
+	eventParam.event_action_fn = rtl865x_naptCallbackFn_for_qosChange;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	eventParam.eventId = EVENT_FLUSH_QOSRULE;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	eventParam.eventLayerId = DEFAULT_LAYER3_EVENT_LIST_ID;
+	eventParam.eventId = EVENT_ADD_ARP;
+	rtl865x_unRegisterEvent(&eventParam);
+
+	return SUCCESS;
+}
+#endif
+
+/*
+@func int32 | rtl865x_setNatFourWay |enable 4way hash algorithm.
+@parm int32 | enable | enable or disable.
+@rvalue SUCCESS | success.
+@comm
+	default is enable in system.
+*/
+int32 rtl865x_setNatFourWay(int32 enable)
+{
+	_set4WayHash(enable);
+	rtl865x_enableNaptFourWay = enable;
+	return SUCCESS;
+}
+
+/*
+@func int32 | rtl865x_nat_init |initialize napt table.
+@rvalue SUCCESS | success.
+@comm
+*/
+int32 rtl865x_nat_init(void)
+{
+	int32 retval = FAILED;
+
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+	rtl865x_napt_unRegister_qosEvent();
+#endif
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	rtl865x_nat_unRegister_event();
+#endif
+	retval = _rtl865x_nat_init();
+	rtl865x_setNatFourWay(TRUE);
+
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+	rtl865x_napt_register_qosEvent();
+#endif
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	rtl865x_nat_register_event();
+#endif
+	return retval;
+}
+
+int32 rtl865x_nat_reinit(void)
+{
+	return rtl865x_nat_init();
+
+}
+
+#ifdef CONFIG_RTL_PROC_DEBUG
+int32 rtl865x_flushAllNaptConnection(void)
+{
+	uint32 i, outIndex, inIndex;
+	struct nat_entry *nat_out = NULL, *nat_in = NULL, *tmp = NULL;
+
+	for (i = 0; i < RTL8651_TCPUDPTBL_SIZE; i++) {
+		tmp = &nat_tbl.nat_bucket[i];
+
+		if (NAT_INUSE(tmp)) {
+			outIndex = tmp->out;
+			inIndex = tmp->in;
+			if (outIndex != 0xFFFFFFFF) {
+				nat_out = &nat_tbl.nat_bucket[outIndex];
+			} else {
+				nat_out = NULL;
+			}
+
+			if (inIndex != 0xFFFFFFFF) {
+				nat_in = &nat_tbl.nat_bucket[inIndex];
+			} else {
+				nat_in = NULL;
+			}
+
+			if ((nat_out == NULL) && (nat_in == NULL)) {
+				rtl8651_delAsicNaptTcpUdpTable(i, i);
+				continue;
+			}
+
+			if (nat_out == nat_in) {
+				if (nat_out->flags & NAT_OUTBOUND) {
+					rtl8651_delAsicNaptTcpUdpTable(outIndex,
+						outIndex);
+					memset(nat_out, 0, sizeof(*nat_out));
+					nat_tbl.freeEntryNum++;
+				} else if (nat_in->flags & NAT_INBOUND) {
+					rtl8651_delAsicNaptTcpUdpTable(inIndex,
+						inIndex);
+					memset(nat_in, 0, sizeof(*nat_in));
+					nat_tbl.freeEntryNum++;
+				} else {
+					/*fatal error */
+					return RTL_EENTRYNOTFOUND;
+				}
+			} else {
+				if ((nat_out != NULL) &&
+					(nat_out->flags & NAT_OUTBOUND)) {
+					rtl8651_delAsicNaptTcpUdpTable(outIndex,
+						outIndex);
+					memset(nat_out, 0, sizeof(*nat_out));
+					nat_tbl.freeEntryNum++;
+				}
+
+				if ((nat_in != NULL) &&
+					(nat_in->flags & NAT_INBOUND)) {
+					rtl8651_delAsicNaptTcpUdpTable(inIndex,
+						inIndex);
+					memset(nat_in, 0, sizeof(*nat_in));
+					nat_tbl.freeEntryNum++;
+				}
+			}
+
+			if (nat_tbl.connNum > 0) {
+				nat_tbl.connNum--;
+			}
+
+		}
+	}
+
+	return SUCCESS;
+}
+
+int32 rtl865x_sw_napt_seq_read(struct seq_file *s, void *v)
+{
+
+	int i;
+	struct nat_entry *natEntryPtr;
+
+	seq_printf(s, "%s\n", "sw napt table:");
+
+	for (i = 0; i < RTL8651_TCPUDPTBL_SIZE; i++) {
+		natEntryPtr = &nat_tbl.nat_bucket[i];
+		if (NAT_INUSE(natEntryPtr)) {
+			if (natEntryPtr->flags & NAT_OUTBOUND) {
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+				seq_printf(s,
+					"[%4d]%s:%d.%d.%d.%d:%d---->%d.%d.%d.%d:%d---->%d.%d.%d.%d:%d\n	  flags:0x%x,outbound:(%d),inbound:(%d) ,isExtNaptEntry(%d)\n",
+#else
+				seq_printf(s,
+					"[%4d]%s:%d.%d.%d.%d:%d---->%d.%d.%d.%d:%d---->%d.%d.%d.%d:%d\n      flags:0x%x,outbound:(%d),inbound:(%d)\n",
+#endif
+					i,
+					natEntryPtr->proto_ == 1 ? "tcp" : "udp",
+					NIPQUAD(natEntryPtr->int_ip_),
+					natEntryPtr->int_port_,
+					NIPQUAD(natEntryPtr->ext_ip_),
+					natEntryPtr->ext_port_,
+					NIPQUAD(natEntryPtr->rem_ip_),
+					natEntryPtr->rem_port_,
+					natEntryPtr->flags, natEntryPtr->out,
+					natEntryPtr->in
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+					, natEntryPtr->isExtNaptEntry
+#endif
+					);
+			}
+
+			if (natEntryPtr->flags & NAT_INBOUND) {
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+				seq_printf(s,
+					"[%4d]%s:%d.%d.%d.%d:%d<----%d.%d.%d.%d:%d<----%d.%d.%d.%d:%d\n	  flags:0x%x, outbound:(%d), inbound:(%d),isExtNaptEntry(%d)\n",
+#else
+				seq_printf(s,
+					"[%4d]%s:%d.%d.%d.%d:%d<----%d.%d.%d.%d:%d<----%d.%d.%d.%d:%d\n      flags:0x%x, outbound:(%d), inbound:(%d)\n",
+#endif
+					i,
+					natEntryPtr->proto_ == 1 ? "tcp" : "udp",
+					NIPQUAD(natEntryPtr->int_ip_),
+					natEntryPtr->int_port_,
+					NIPQUAD(natEntryPtr->ext_ip_),
+					natEntryPtr->ext_port_,
+					NIPQUAD(natEntryPtr->rem_ip_),
+					natEntryPtr->rem_port_,
+					natEntryPtr->flags, natEntryPtr->out,
+					natEntryPtr->in
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+					, natEntryPtr->isExtNaptEntry
+#endif
+					);
+			}
+		}
+#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(i, WATCHDOG_NUM_OF_TIMES);
+#endif
+
+	}
+
+	seq_printf(s, "total napt connection number is %d\n", nat_tbl.connNum);
+	seq_printf(s, "total free entry number is %d\n", nat_tbl.freeEntryNum);
+	return 0;
+}
+
+int32 rtl865x_sw_napt_seq_write(struct file *filp, const char *buff,
+	unsigned long len, loff_t *off)
+{
+	char tmpbuf[64];
+	uint32 delIndex, inIndex = 0, outIndex = 0;
+	char *strptr, *cmd_addr;
+	char *tokptr;
+	struct nat_entry *nat_out = NULL, *nat_in = NULL, *tmp = NULL;
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+
+		if (!memcmp(cmd_addr, "flush", 5)) {
+			rtl865x_flushAllNaptConnection();
+		} else if (!memcmp(cmd_addr, "del", 3)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+
+			delIndex = simple_strtol(tokptr, NULL, 0);
+			if (delIndex > RTL8651_TCPUDPTBL_SIZE) {
+				printk("error input!\n");
+				return len;
+			}
+			tmp = &nat_tbl.nat_bucket[delIndex];
+
+			if (NAT_INUSE(tmp)) {
+				outIndex = tmp->out;
+				inIndex = tmp->in;
+				if (outIndex != 0xFFFFFFFF) {
+					nat_out = &nat_tbl.nat_bucket[outIndex];
+				} else {
+					nat_out = NULL;
+				}
+
+				if (inIndex != 0xFFFFFFFF) {
+					nat_in = &nat_tbl.nat_bucket[inIndex];
+				} else {
+					nat_in = NULL;
+				}
+
+				if ((nat_out == NULL) && (nat_in == NULL)) {
+					rtl8651_delAsicNaptTcpUdpTable(delIndex,
+						delIndex);
+					goto errout;
+				}
+
+				if (nat_out == nat_in) {
+					rtl8651_delAsicNaptTcpUdpTable(outIndex,
+						outIndex);
+					memset(nat_out, 0, sizeof(*nat_out));
+					nat_tbl.freeEntryNum++;
+				} else {
+					if ((nat_out != NULL) &&
+						(nat_out->flags & NAT_OUTBOUND)) {
+						rtl8651_delAsicNaptTcpUdpTable(outIndex, outIndex);
+						memset(nat_out, 0,
+							sizeof(*nat_out));
+						nat_tbl.freeEntryNum++;
+					}
+
+					if ((nat_in != NULL) &&
+						(nat_in->flags & NAT_INBOUND)) {
+						rtl8651_delAsicNaptTcpUdpTable(inIndex, inIndex);
+						memset(nat_in, 0,
+							sizeof(*nat_in));
+						nat_tbl.freeEntryNum++;
+					}
+				}
+
+				if (nat_tbl.connNum > 0) {
+					nat_tbl.connNum--;
+				}
+				printk("del napt flow,outbound:%d,inbound:%d\n",
+					outIndex, inIndex);
+
+			}
+
+		} else {
+			goto errout;
+		}
+	} else {
+errout:
+		return len;
+	}
+
+	return len;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+int rtl_check_ext_port_napt_entry(uint32 sip, uint16 sport, uint32 dip,
+	uint16 dport, uint8 protocol)
+{
+
+	struct nat_tuple temp;
+	struct nat_tuple *nat_tuple;
+	uint32 i, hash;
+	struct nat_entry *nat_out;
+
+	nat_tuple = &temp;
+	nat_tuple->proto = ((protocol == 6) ? RTL865X_PROTOCOL_TCP :
+					      RTL865X_PROTOCOL_UDP);
+	nat_tuple->int_host.ip = sip;
+	nat_tuple->int_host.port = sport;
+	nat_tuple->rem_host.ip = dip;
+	nat_tuple->rem_host.port = dport;
+
+	//printk("sip is 0x%x, sport is %d, dip is 0x%x, dport is %d\n", sip, sport, dip, dport);
+	//outbound
+	hash = rtl8651_naptTcpUdpTableIndex((uint8)nat_tuple->proto,
+		htonl(nat_tuple->int_host.ip), htons(nat_tuple->int_host.port),
+		htonl(nat_tuple->rem_host.ip), htons(nat_tuple->rem_host.port));
+	//panic_printk("hash:%d,[%s]:[%d].\n",hash,__FUNCTION__,__LINE__);
+	if (rtl865x_enableNaptFourWay == TRUE) {
+		for (i = 0; i < 4; i++) {
+			nat_out = &nat_tbl.nat_bucket[hash];
+			if (((htonl(sip) == nat_out->int_ip_) &&
+					(htons(sport) == nat_out->int_port_) &&
+					(htonl(dip) == nat_out->rem_ip_) &&
+					(htons(dport) == nat_out->rem_port_) &&
+					(nat_tuple->proto == nat_out->proto_) &&
+					(nat_out->flags & NAT_OUTBOUND))
+				) {
+				return 1;
+			}
+			hash = (hash & 0xFFFFFFFC) + (hash + 1) % 4;
+			assert(hash <= RTL8651_TCPUDPTBL_SIZE);
+		}
+	} else {
+		nat_out = &nat_tbl.nat_bucket[hash];
+		if (((htonl(sip) == nat_out->int_ip_) &&
+				(htons(sport) == nat_out->int_port_) &&
+				(htonl(dip) == nat_out->rem_ip_) &&
+				(htons(dport) == nat_out->rem_port_) &&
+				(nat_tuple->proto == nat_out->proto_) &&
+				(nat_out->flags & NAT_OUTBOUND))
+			) {
+			return 1;
+		}
+	}
+	//panic_printk("pro:%d,%d,%x,%d,%x,%d[%s]:[%d].\n",protocol,nat_tuple->proto,
+	//      sip,sport,dip,dport,__FUNCTION__,__LINE__);
+
+	return 0;
+}
+
+int32 rtl865x_flush_ext_port_entry(void)
+{
+	uint32 i, outIndex, inIndex;
+	struct nat_entry *nat_out = NULL, *nat_in = NULL, *tmp = NULL;
+
+	for (i = 0; i < RTL8651_TCPUDPTBL_SIZE; i++) {
+		tmp = &nat_tbl.nat_bucket[i];
+
+		if (NAT_INUSE(tmp)) {
+			outIndex = tmp->out;
+			inIndex = tmp->in;
+			if (outIndex != 0xFFFFFFFF) {
+				nat_out = &nat_tbl.nat_bucket[outIndex];
+			} else {
+				nat_out = NULL;
+			}
+
+			if (inIndex != 0xFFFFFFFF) {
+				nat_in = &nat_tbl.nat_bucket[inIndex];
+			} else {
+				nat_in = NULL;
+			}
+
+			if ((nat_out->isExtNaptEntry) && (nat_out == NULL) &&
+				(nat_in->isExtNaptEntry) && (nat_in == NULL)) {
+				rtl8651_delAsicNaptTcpUdpTable(outIndex,
+					inIndex);
+				continue;
+			}
+
+			if ((nat_out->isExtNaptEntry) && (nat_out == nat_in)) {
+				if (nat_out->flags & NAT_OUTBOUND) {
+					rtl8651_delAsicNaptTcpUdpTable(outIndex,
+						outIndex);
+					memset(nat_out, 0, sizeof(*nat_out));
+					nat_tbl.freeEntryNum++;
+				} else if (nat_in->flags & NAT_INBOUND) {
+					rtl8651_delAsicNaptTcpUdpTable(inIndex,
+						inIndex);
+					memset(nat_in, 0, sizeof(*nat_in));
+					nat_tbl.freeEntryNum++;
+				} else {
+					/*fatal error */
+					return RTL_EENTRYNOTFOUND;
+				}
+			} else {
+				if ((nat_out->isExtNaptEntry) &&
+					(nat_out != NULL) &&
+					(nat_out->flags & NAT_OUTBOUND)) {
+					rtl8651_delAsicNaptTcpUdpTable(outIndex,
+						outIndex);
+					memset(nat_out, 0, sizeof(*nat_out));
+					nat_tbl.freeEntryNum++;
+				}
+
+				if ((nat_in->isExtNaptEntry) &&
+					(nat_in != NULL) &&
+					(nat_in->flags & NAT_INBOUND)) {
+					rtl8651_delAsicNaptTcpUdpTable(inIndex,
+						inIndex);
+					memset(nat_in, 0, sizeof(*nat_in));
+					nat_tbl.freeEntryNum++;
+				}
+			}
+
+			if (nat_tbl.connNum > 0) {
+				nat_tbl.connNum--;
+			}
+
+		}
+	}
+
+	return SUCCESS;
+}
+
+#endif
+
+#if defined(RTL_REFRESH_HW_L2_ENTRY_DECIDE_BY_HW_NAT)
+int rtl865x_check_hw_nat_by_ip(ipaddr_t ip)
+{
+	int i;
+	int ret = FAILED;
+	struct nat_entry *natEntryPtr;
+
+	for (i = 0; i < RTL8651_TCPUDPTBL_SIZE; i++) {
+		natEntryPtr = &nat_tbl.nat_bucket[i];
+		if (NAT_INUSE(natEntryPtr)) {
+			if ((ip == natEntryPtr->int_ip_) ||
+				(ip == natEntryPtr->rem_ip_)) {
+				ret = SUCCESS;
+				break;
+			}
+		}
+	}
+
+	return ret;
+}
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/l4Driver/rtl865x_nat_local.h b/drivers/soc/realtek/rtd129x/hw_nat/l4Driver/rtl865x_nat_local.h
new file mode 100644
index 00000000..be5b39b
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/l4Driver/rtl865x_nat_local.h
@@ -0,0 +1,70 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef	RTL865X_NAT_LOCAL_H
+#define	RTL865X_NAT_LOCAL_H
+
+struct nat_host_info {
+	ipaddr_t						ip;
+	uint16						port;
+};
+
+struct nat_tuple {
+	struct nat_host_info			int_host;
+	struct nat_host_info			ext_host;
+	struct nat_host_info			rem_host;
+	uint32						proto;
+};
+
+
+struct nat_entry {
+	struct nat_tuple				tuple_info;
+
+	uint32						natip_idx;
+	uint32						in;
+	uint32						out;
+	uint32 						flags;
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	uint32 isExtNaptEntry;
+#endif
+#if defined (CONFIG_RTL_INBOUND_COLLISION_AVOIDANCE)
+	uint32						reserveTime;
+#endif
+
+#define int_ip_					tuple_info.int_host.ip
+#define int_port_					tuple_info.int_host.port
+#define ext_ip_					tuple_info.ext_host.ip
+#define ext_port_					tuple_info.ext_host.port
+#define rem_ip_					tuple_info.rem_host.ip
+#define rem_port_					tuple_info.rem_host.port
+#define proto_					tuple_info.proto
+
+};
+
+struct nat_table {
+
+	int32						connNum;		/* MUST equal or more than actually conntrack number */
+	int32						freeEntryNum;
+	int32						tcp_timeout;
+	int32						udp_timeout;
+	struct nat_entry 				nat_bucket[RTL8651_TCPUDPTBL_SIZE];
+};
+
+typedef struct rtl865x_naptHashInfo_s{
+	 uint32 outIndex;
+	 uint32 inIndex;
+	 uint8 outCollision;
+	 uint8 inCollision;
+	 uint8 sameFourWay;
+	 uint8 sameLocation;
+	 uint8  inFreeCnt;
+}rtl865x_naptHashInfo_t;
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/mmap.c b/drivers/soc/realtek/rtd129x/hw_nat/mmap.c
new file mode 100644
index 00000000..edf4fcc
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/mmap.c
@@ -0,0 +1,243 @@
+/*
+ * Simple - REALLY simple memory mapping demonstration.
+ * $Id: mmap.c,v 1.1 2007-12-21 10:28:22 davidhsu Exp $
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __KERNEL__
+#  define __KERNEL__
+#endif
+
+#ifndef NO_MM
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,4,0)
+#include <linux/kconfig.h>
+#else
+#include <linux/config.h>
+#endif
+#include <linux/module.h>
+#include <linux/mm.h>
+
+#include <linux/kernel.h>   /* printk() */
+#include <linux/slab.h>   /* kmalloc() */
+#include <linux/fs.h>       /* everything... */
+#include <linux/errno.h>    /* error codes */
+#include <linux/types.h>    /* size_t */
+#include <linux/init.h>     /* module_init */
+#include <asm/page.h>
+
+#include "common/rtl_glue.h" /*rtlglue_printf()*/
+
+#define	CONFIG_DEFAULTS_KERNEL_2_6	1
+
+static int simple_major = 254;
+
+#ifdef CONFIG_RTL865X_MODULE_ROMEDRV
+#else
+#ifdef CONFIG_DEFAULTS_KERNEL_2_6
+module_param(simple_major, int, S_IRUGO);
+#else
+MODULE_PARM(simple_major, "i");
+#endif
+MODULE_AUTHOR("Jonathan Corbet");
+#endif
+
+/*
+ * Forwards for our methods.
+ */
+int simple_open (struct inode *inode, struct file *filp);
+int simple_release(struct inode *inode, struct file *filp);
+int simple_remap_mmap(struct file *filp, struct vm_area_struct *vma);
+int simple_nopage_mmap(struct file *filp, struct vm_area_struct *vma);
+
+
+/*
+ * Our various sub-devices.
+ */
+/* Device 0 uses remap_page_range */
+struct file_operations simple_remap_ops = {
+    open:    simple_open,
+    release: simple_release,
+    mmap:    simple_remap_mmap,
+};
+
+/* Device 1 uses nopage */
+struct file_operations simple_nopage_ops = {
+    open:    simple_open,
+    release: simple_release,
+    mmap:    simple_nopage_mmap,
+};
+
+#define MAX_SIMPLE_DEV 2
+
+struct file_operations *simple_fops[MAX_SIMPLE_DEV] = {
+    &simple_remap_ops,
+    &simple_nopage_ops,
+};
+
+/*
+ * Open the device; all we have to do here is to up the usage count and
+ * set the right fops.
+ */
+int simple_open (struct inode *inode, struct file *filp)
+{
+    unsigned int dev = MINOR(inode->i_rdev);
+
+    if (dev >= MAX_SIMPLE_DEV)
+        return -ENODEV;
+    filp->f_op = simple_fops[dev];
+#ifdef CONFIG_DEFAULTS_KERNEL_2_6
+#else
+    MOD_INC_USE_COUNT;
+#endif
+    return 0;
+}
+
+
+/*
+ * Closing is even simpler.
+ */
+int simple_release(struct inode *inode, struct file *filp)
+{
+#ifdef CONFIG_DEFAULTS_KERNEL_2_6
+#else
+    MOD_DEC_USE_COUNT;
+#endif
+    return 0;
+}
+
+
+
+/*
+ * Common VMA ops.
+ */
+
+void simple_vma_open(struct vm_area_struct *vma)
+#ifdef CONFIG_DEFAULTS_KERNEL_2_6
+{}
+#else
+{ MOD_INC_USE_COUNT; }
+#endif
+
+void simple_vma_close(struct vm_area_struct *vma)
+#ifdef CONFIG_DEFAULTS_KERNEL_2_6
+{}
+#else
+{ MOD_DEC_USE_COUNT; }
+#endif
+
+
+/*
+ * The remap_pfn_range version of mmap.
+ */
+
+static struct vm_operations_struct simple_remap_vm_ops = {
+    open:  simple_vma_open,
+    close: simple_vma_close,
+};
+
+int simple_remap_mmap(struct file *filp, struct vm_area_struct *vma)
+{
+    unsigned long offset = vma->vm_pgoff << PAGE_SHIFT;
+
+    if (offset >= __pa(high_memory) || (filp->f_flags & O_SYNC))
+        vma->vm_flags |= VM_IO;
+    vma->vm_flags |= VM_RESERVED;
+
+#ifdef CONFIG_DEFAULTS_KERNEL_2_6
+    if (remap_pfn_range(vma, vma->vm_start, offset, vma->vm_end-vma->vm_start, vma->vm_page_prot))
+#else
+    if (remap_page_range(vma->vm_start, offset, vma->vm_end-vma->vm_start, vma->vm_page_prot))
+#endif
+        return -EAGAIN;
+
+    vma->vm_ops = &simple_remap_vm_ops;
+    simple_vma_open(vma);
+    return 0;
+}
+
+
+
+/*
+ * The nopage version.
+ */
+#ifdef CONFIG_DEFAULTS_KERNEL_2_6
+struct page *simple_vma_nopage(struct vm_area_struct *vma, unsigned long address, int* write_access)
+#else
+struct page *simple_vma_nopage(struct vm_area_struct *vma, unsigned long address, int write_access)
+#endif
+{
+    struct page *pageptr;
+    unsigned long physaddr = address - vma->vm_start +
+            (vma->vm_pgoff << PAGE_SHIFT);
+    pageptr = virt_to_page(__va(physaddr));
+    get_page(pageptr);
+    return pageptr;
+}
+
+static struct vm_operations_struct simple_nopage_vm_ops = {
+    open:    simple_vma_open,
+    close:   simple_vma_close,
+    nopage:  simple_vma_nopage,
+};
+
+
+int simple_nopage_mmap(struct file *filp, struct vm_area_struct *vma)
+{
+    unsigned long offset = vma->vm_pgoff << PAGE_SHIFT;
+
+    if (offset >= __pa(high_memory) || (filp->f_flags & O_SYNC))
+        vma->vm_flags |= VM_IO;
+    vma->vm_flags |= VM_RESERVED;
+
+    vma->vm_ops = &simple_nopage_vm_ops;
+    simple_vma_open(vma);
+    return 0;
+}
+
+
+
+/*
+ * Module housekeeping.
+ */
+ #ifdef CONFIG_RTL865X_MODULE_ROMEDRV
+int simple_init(void)
+#else
+static int simple_init(void)
+#endif
+{
+    int result;
+
+    result = register_chrdev(simple_major, "simple", &simple_remap_ops);
+    if (result < 0)
+    {
+        rtlglue_printf("simple: unable to get major %d\n", simple_major);
+        return result;
+    }
+    if (simple_major == 0)
+        simple_major = result;
+    return 0;
+}
+
+ #ifdef CONFIG_RTL865X_MODULE_ROMEDRV
+ void simple_cleanup(void)
+ #else
+static void simple_cleanup(void)
+#endif
+{
+    unregister_chrdev(simple_major, "simple");
+}
+
+#ifdef CONFIG_RTL865X_MODULE_ROMEDRV
+#else
+module_init(simple_init);
+module_exit(simple_cleanup);
+#endif
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rlx5181_perCounter.S b/drivers/soc/realtek/rtd129x/hw_nat/rlx5181_perCounter.S
new file mode 100644
index 00000000..70c4741
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rlx5181_perCounter.S
@@ -0,0 +1,144 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include "asm/rtl865x/regdef.h"
+
+
+	.align  5
+	.section .iram-gen
+
+	.ent init_CP3_counter
+	.globl init_CP3_counter
+init_CP3_counter:
+        mfc0 	t0, $12
+        la 	t1, 0x80000000
+        or 	t0, t1
+        mtc0 	t0, $12
+	nop
+	jr ra
+	nop
+	.end init_CP3_counter
+
+	.ent clear_CP3_counter
+	.globl clear_CP3_counter
+clear_CP3_counter:
+/* stop counters */
+        ctc3 zero, $0
+/* clear counters */
+        mtc3 zero, $8
+        mtc3 zero, $9
+        mtc3 zero, $10
+        mtc3 zero, $11
+        mtc3 zero, $12
+        mtc3 zero, $13
+        mtc3 zero, $14
+        mtc3 zero, $15
+	nop
+	jr ra
+	nop
+	.end clear_CP3_counter
+
+
+/* set counter controls:  0	 1	 2	 3
+** counter0 cycles 	  (0x10) (0x10) (0x10) (0x10)
+** counter1 ifetches   	  (0x11) (0x11) (0x11)
+** counter1 dmiss busy    		       (0x1b)
+** counter2 ld+stores	  (0x16) 	       (0x16)
+** counter2 icache misses	 (0x12) (0x12)
+** counter3 dcache misses (0x1a) (0x1a)        (0x1a)
+** counter3 imiss busy   	        (0x13)
+*/
+	/*a0: counter mode 0 ~ 3*/
+	.ent set_and_start_counter
+	.globl set_and_start_counter
+set_and_start_counter:
+	addiu sp, sp, -8
+	sw t1, 0(sp)
+	sw t3, 4(sp)
+
+	move t3, a0
+        la t1, 0x1a161110
+        beq t3, zero, 1f #cntmode == 0
+        addiu t3, -1
+        la t1, 0x1a121110
+        beq t3, zero, 1f #cntmode == 1
+        addiu t3, -1
+        la t1, 0x13121110
+        beq t3, zero, 1f #cntmode == 2
+        addiu t3, -1
+        la t1, 0x1a161b10
+        beq t3, zero, 1f #cntmode == 3
+        nop
+1:
+	ctc3 t1, $0
+	nop
+
+	lw t1, 0(sp)
+	lw t3, 4(sp)
+	addiu sp, sp, 8
+	jr ra
+	nop
+	.end set_and_start_counter
+
+	.ent stop_counter
+	.globl stop_counter
+stop_counter:
+	ctc3 zero, $0
+	nop
+	jr ra
+	nop
+	.end stop_counter
+
+/*a0: the address for saving counter 0 */
+/*a1: the address for saving counter 1 */
+/*a2: the address for saving counter 2 */
+/*a3: the address for saving counter 3 */
+	.ent save_counter
+	.globl save_counter
+save_counter:
+	addiu sp, sp, -4
+	sw t0, 0(sp)
+
+        mfc3 t0, $9 #counter0[48:32]
+        nop
+        sw t0, 0(a0)
+        mfc3 t0, $8 #counter0[31:0]
+        nop
+        nop
+        sw t0, 4(a0)
+        mfc3 t0, $11 #counter1[48:32]
+        nop
+        sw t0, 8(a0)
+        mfc3 t0, $10 #counter1[31:0]
+        nop
+        nop
+        sw t0, 12(a0)
+        mfc3 t0, $13 #counter2[48:32]
+        nop
+        sw t0, 16(a0)
+        mfc3 t0, $12 #counter2[31:0]
+        nop
+        nop
+        sw t0, 20(a0)
+        mfc3 t0, $15 #counter3[48:32]
+        nop
+        sw t0, 24(a0)
+        mfc3 t0, $14 #counter3[31:0]
+        nop
+        nop
+        sw t0, 28(a0)
+	nop
+
+
+	lw t0, 0(sp)
+	addiu sp, sp, 4
+	jr ra
+	nop
+	.end save_counter
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rlx5281_perCounter.S b/drivers/soc/realtek/rtd129x/hw_nat/rlx5281_perCounter.S
new file mode 100644
index 00000000..ef411e5
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rlx5281_perCounter.S
@@ -0,0 +1,190 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <asm/rtl865x/regdef.h>
+/* CP3 Performance Counter Event list */
+#define INST_FEATCH                (0x01)
+#define ICACHE_MISS                (0x02)
+#define ICACHE_MISS_CYCLE          (0x03)
+#define STORE_INST                 (0x04)
+#define LOAD_INST                  (0x05)
+#define LORDSTROE_INST             (0x06)
+#define COMPLETED_INST             (0x07)
+#define CYCLES                     (0x08)
+#define DCACHE_MISSE               (0x0A)
+#define DCACHE_MISS_CYCLE          (0x0B)
+#define L2_CACHE_HIT               (0x0C)
+#define L2_CACHE_HIT_CYCLE         (0x0D)
+#define L2_CACHE_MISS              (0x0E)
+#define L2_CACHE_MISS_CYCLE        (0x0F)
+#define BRANCEH_PREDICTION         (0x10)
+#define BRANCEH_PREDICTION_MISS    (0x11)
+#define BTB_MISS                   (0x12)
+#define BTB_TARGET_MISS            (0x13)
+#define CBP_MISS                   (0x14)
+#define RS_POP                     (0x15)
+#define RS_MISS                    (0x16)
+#define IBUF_FULL_CYCLE            (0x18)
+#define IBUF_EMPTY_CYCLE           (0x19)
+#define ZERO_INST_COMMIT_CYCLE     (0x20)
+#define PIPE_A_INST_COMMIT_CYCLE   (0x21)
+#define PIPE_B_INST_COMMIT_CYCLE   (0x22)
+#define DUAL_INST_COMMIT_CYCLE     (0x23)
+#define OCP_BUS_READS              (0x24)
+#define OCP_BUS_WRITES             (0x25)
+#define OCP_BUS_UC_READ            (0x26)
+#define OCP_BUS_UC_WRITE           (0x27)
+#define OCP_BUS_DATA_READ          (0x28)
+#define OCP_BUS_DATA_WRITE         (0x29)
+#define OCP_BUS_INS_READ           (0x2A)
+#define CP3_COUTER3(event)         (event << 24)
+#define CP3_COUTER2(event)         (event << 16)
+#define CP3_COUTER1(event)         (event << 8 )
+#define CP3_COUTER0(event)         (event << 0 )
+
+//void clear_CP3_counter(void);
+//void set_and_start_counter(uint32 counter_control);
+//void stop_counter(void);
+//void save_counter(uint32 *addr0, uint32 *addr1,uint32 *addr2,uint32 *addr3);
+
+
+	.align  5
+//	.section .iram-gen
+
+	.ent init_CP3_counter
+	.globl init_CP3_counter
+init_CP3_counter:
+        mfc0 	t0, $12
+        la 	t1, 0x80000000
+        or 	t0, t1
+        mtc0 	t0, $12
+	nop
+	jr ra
+	nop
+	.end init_CP3_counter
+
+	.ent clear_CP3_counter
+	.globl clear_CP3_counter
+clear_CP3_counter:
+/* stop counters */
+        ctc3 zero, $0
+/* clear counters */
+        mtc3 zero, $8
+        mtc3 zero, $9
+        mtc3 zero, $10
+        mtc3 zero, $11
+        mtc3 zero, $12
+        mtc3 zero, $13
+        mtc3 zero, $14
+        mtc3 zero, $15
+	nop
+	jr ra
+	nop
+	.end clear_CP3_counter
+
+/* set counter controls:  0   	 1 	2 	3
+** counter0 cycles	  (0x08) (0x08) (0x08) (0x08)
+** counter1 ifetches 	  (0x01) (0x01) (0x01)
+** counter1 dmiss busy			       (0x0b)
+** counter2 ld+stores 	  (0x06)	       (0x06)
+** counter2 icache misses	 (0x02) (0x02)
+** counter3 dcache misses (0x0a) (0x0a)        (0x0a)
+** counter3 imiss busy	 		(0x03)
+*/
+	/*a0: counter mode 0 ~ 3*/
+	.ent set_and_start_counter
+	.globl set_and_start_counter
+set_and_start_counter:
+	addiu sp, sp, -8
+	sw t1, 0(sp)
+	sw t3, 4(sp)
+
+	move t3, a0
+        la t1, 0x0a060108
+        beq t3, zero, 1f #cntmode == 0
+        addiu t3, -1
+        la t1, 0x0a020108
+        beq t3, zero, 1f #cntmode == 1
+        addiu t3, -1
+        la t1, 0x03020108
+        beq t3, zero, 1f #cntmode == 2
+        addiu t3, -1
+        la t1, 0x0a060b08
+        beq t3, zero, 1f #cntmode == 3
+        nop
+1:
+	ctc3 t1, $0
+	nop
+
+	lw t1, 0(sp)
+	lw t3, 4(sp)
+	addiu sp, sp, 8
+	jr ra
+	nop
+	.end set_and_start_counter
+
+
+	.ent stop_counter
+	.globl stop_counter
+stop_counter:
+	ctc3 zero, $0
+	nop
+	jr ra
+	nop
+	.end stop_counter
+
+
+
+/*a0: the address for saving counter 0 */
+/*a1: the address for saving counter 1 */
+/*a2: the address for saving counter 2 */
+/*a3: the address for saving counter 3 */
+	.ent save_counter
+	.globl save_counter
+save_counter:
+	addiu sp, sp, -4
+	sw t0, 0(sp)
+
+        mfc3 t0, $9 #counter0[48:32]
+        nop
+        sw t0, 0(a0)
+        mfc3 t0, $8 #counter0[31:0]
+        nop
+        nop
+        sw t0, 4(a0)
+        mfc3 t0, $11 #counter1[48:32]
+        nop
+        sw t0, 8(a0)
+        mfc3 t0, $10 #counter1[31:0]
+        nop
+        nop
+        sw t0, 12(a0)
+        mfc3 t0, $13 #counter2[48:32]
+        nop
+        sw t0, 16(a0)
+        mfc3 t0, $12 #counter2[31:0]
+        nop
+        nop
+        sw t0, 20(a0)
+        mfc3 t0, $15 #counter3[48:32]
+        nop
+        sw t0, 24(a0)
+        mfc3 t0, $14 #counter3[31:0]
+        nop
+        nop
+        sw t0, 28(a0)
+	nop
+
+
+	lw t0, 0(sp)
+	addiu sp, sp, 4
+	jr ra
+	nop
+	.end save_counter
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/romeperf.c b/drivers/soc/realtek/rtd129x/hw_nat/romeperf.c
new file mode 100644
index 00000000..be2bbe6df
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/romeperf.c
@@ -0,0 +1,567 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* Program : Performance Profiling for ROME Driver
+* Abstract :
+* Author : Yung-Chieh Lo (yjlou@realtek.com.tw)
+* $Id: romeperf.c,v 1.1 2007-12-21 10:28:22 davidhsu Exp $
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#include "romeperf.h"
+#include <net/rtl/rtl_glue.h>
+#define KERNEL_SYSeALLS
+#include <asm/unistd.h>
+#include <asm/processor.h>
+#include <asm/uaccess.h>
+//#include <asm/mipsregs.h>
+#include <linux/interrupt.h>
+
+#define rtlglue_malloc(size)	kmalloc(size, 0x1f0)
+#define rtlglue_free(p)	kfree(p)
+#ifndef rtlglue_printf
+#define rtlglue_printf printk
+#endif
+
+#undef __IRAM
+#define __IRAM __IRAM_FWD
+
+enum CP3_COUNTER
+{
+	CP3CNT_CYCLES = 0,
+	CP3CNT_NEW_INST_FECTH,
+	CP3CNT_NEW_INST_FETCH_CACHE_MISS,
+	CP3CNT_NEW_INST_MISS_BUSY_CYCLE,
+	CP3CNT_DATA_STORE_INST,
+	CP3CNT_DATA_LOAD_INST,
+	CP3CNT_DATA_LOAD_OR_STORE_INST,
+	CP3CNT_EXACT_RETIRED_INST,
+	CP3CNT_RETIRED_INST_FOR_PIPE_A,
+	CP3CNT_RETIRED_INST_FOR_PIPE_B,
+	CP3CNT_DATA_LOAD_OR_STORE_CACHE_MISS,
+	CP3CNT_DATA_LOAD_OR_STORE_MISS_BUSY_CYCLE,
+	CP3CNT_RESERVED12,
+	CP3CNT_RESERVED13,
+	CP3CNT_RESERVED14,
+	CP3CNT_RESERVED15,
+};
+
+/* Local variables */
+//static uint64 tempVariable64;
+//static uint32 tempVariable32;
+static uint64 currCnt[4];
+
+/* Global variables */
+//uint64 cnt1, cnt2;
+rtl8651_romeperf_stat_t romePerfStat[ROMEPERF_INDEX_MAX];
+rtl8651_romeperf_stat_t statSnapShot[ROMEPERF_INDEX_MAX];
+uint32 rtl8651_romeperf_inited = 0;
+uint32 rtl8651_romeperf_enable = TRUE;
+
+__IRAM static void CP3_COUNTER0_INIT( void )
+{
+#if 0
+__asm__ __volatile__ \
+("  ;\
+	mfc0	$8, $12			;\
+	la		$9, 0x80000000	;\
+	or		$8, $9			;\
+	mtc0	$8, $12			;\
+");
+#else
+	void init_CP3_counter(void);
+	init_CP3_counter();
+#endif
+}
+
+#if 0
+__IRAM static uint32 CP3_COUNTER0_IS_INITED( void )
+{
+__asm__ __volatile__ \
+("  ;\
+	mfc0	$8, $12			;\
+	la		$9, tempVariable32;\
+	sw		$8, 0($9)		;\
+");
+	return tempVariable32;
+}
+#endif
+
+__IRAM static void CP3_COUNTER0_START( void )
+{
+#if 0
+#if 1 /* Inst */
+	tempVariable32 = /* Counter0 */((0x10|CP3CNT_CYCLES)<< 0) |
+	                 /* Counter1 */((0x10|CP3CNT_NEW_INST_FECTH)<< 8) |
+	                 /* Counter2 */((0x10|CP3CNT_NEW_INST_FETCH_CACHE_MISS)<<16) |
+	                 /* Counter3 */((0x10|CP3CNT_NEW_INST_MISS_BUSY_CYCLE)<<24);
+#elif 1 /* Data (LOAD+STORE) */
+	tempVariable32 = /* Counter0 */((0x10|CP3CNT_CYCLES)<< 0) |
+	                 /* Counter1 */((0x10|CP3CNT_DATA_LOAD_OR_STORE_INST)<< 8) |
+	                 /* Counter2 */((0x10|CP3CNT_DATA_LOAD_OR_STORE_CACHE_MISS)<<16) |
+	                 /* Counter3 */((0x10|CP3CNT_DATA_LOAD_OR_STORE_MISS_BUSY_CYCLE)<<24);
+#elif 1 /* Data (STORE) */
+	tempVariable32 = /* Counter0 */((0x10|CP3CNT_DATA_LOAD_INST)<< 0) |
+	                 /* Counter1 */((0x10|CP3CNT_DATA_STORE_INST)<< 8) |
+	                 /* Counter2 */((0x10|CP3CNT_DATA_LOAD_OR_STORE_CACHE_MISS)<<16) |
+	                 /* Counter3 */((0x10|CP3CNT_DATA_LOAD_OR_STORE_MISS_BUSY_CYCLE)<<24);
+#else
+#error
+#endif
+
+__asm__ __volatile__ \
+("  ;\
+	la		$8, tempVariable32	;\
+	lw		$8, 0($8)			;\
+	ctc3 	$8, $0				;\
+");
+#else
+/* set counter controls:  	0   	 	1 		2 		3
+** counter0 cycles	  		(0x08) 	(0x08) 	(0x08) 	(0x08)
+** counter1 ifetches 	  	(0x01) 	(0x01) 	(0x01)
+** counter1 dmiss busy			       				(0x0b)
+** counter2 ld+stores 	  	(0x06)	       			(0x06)
+** counter2 icache misses	 		(0x02) 	(0x02)
+** counter3 dcache misses 	(0x0a) 	(0x0a)        		(0x0a)
+** counter3 imiss busy	 					(0x03)
+*/
+	void set_and_start_counter(uint32 counter_control);
+	set_and_start_counter(2);
+#endif
+}
+
+__IRAM static void CP3_COUNTER0_STOP( void )
+{
+#if 0
+__asm__ __volatile__ \
+("	;\
+	ctc3 	$0, $0			;\
+");
+#else
+	void stop_counter(void);
+	stop_counter();
+#endif
+}
+
+#if 0
+__IRAM static uint64 CP3_COUNTER0_GET( void )
+{
+__asm__ __volatile__ \
+("	;\
+	la		$8, tempVariable64;\
+	mfc3	$9, $9			;\
+	sw		$9, 0($8)		;\
+	mfc3	$9, $8			;\
+	sw		$9, 4($8)		;\
+");
+	return tempVariable64;
+}
+#endif
+
+__IRAM static void CP3_COUNTER0_GET_ALL( void )
+{
+#if 0
+__asm__ __volatile__ \
+("	;\
+	la		$4, currCnt		;\
+	mfc3	$9, $9			;\
+	sw		$9, 0x00($4)	;\
+	mfc3	$9, $8			;\
+	sw		$9, 0x04($4)	;\
+	mfc3	$9, $11			;\
+	sw		$9, 0x08($4)	;\
+	mfc3	$9, $10			;\
+	sw		$9, 0x0C($4)	;\
+	mfc3	$9, $13			;\
+	sw		$9, 0x10($4)	;\
+	mfc3	$9, $12			;\
+	sw		$9, 0x14($4)	;\
+	mfc3	$9, $15			;\
+	sw		$9, 0x18($4)	;\
+	mfc3	$9, $14			;\
+	sw		$9, 0x1C($4)	;\
+");
+#else
+	void save_counter(uint64 *addr0, uint64 *addr1,uint64 *addr2,uint64 *addr3);
+	save_counter(&currCnt[0], &currCnt[1], &currCnt[2], &currCnt[3]);
+#endif
+}
+
+int32 rtl8651_romeperfInit()
+{
+
+	unsigned long flags = 0;
+	local_irq_save(flags);
+
+	CP3_COUNTER0_INIT();
+	CP3_COUNTER0_START();
+
+	rtl8651_romeperf_inited = TRUE;
+	rtl8651_romeperf_enable = TRUE;
+	memset( &romePerfStat, 0, sizeof( romePerfStat ) );
+
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD].desc = "NAPT add_all";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_1].desc = "NAPT add_checkIntIP";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_2].desc = "NAPT add_localServer";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_3].desc = "NAPT add_checkExtIp";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_4].desc = "NAPT add_dupCheck1";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_5].desc = "NAPT add_dupCheck2";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_6].desc = "NAPT add_bPortReused";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_7].desc = "NAPT add_routeCache";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_8].desc = "NAPT add_tooManyConn";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_9].desc = "NAPT add_initConn";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_10].desc = "NAPT add_decisionFlo";
+	romePerfStat[ROMEPERF_INDEX_NAPT_ADD_11].desc = "NAPT add_ambiguous";
+	romePerfStat[ROMEPERF_INDEX_NAPT_DEL].desc = "NAPT del";
+	romePerfStat[ROMEPERF_INDEX_NAPT_FIND_OUTBOUND].desc = "NATP outbound";
+	romePerfStat[ROMEPERF_INDEX_NAPT_FIND_INBOUND].desc = "NAPT inbound";
+	romePerfStat[ROMEPERF_INDEX_NAPT_UPDATE].desc = "NAPT update";
+	romePerfStat[ROMEPERF_INDEX_UNTIL_RXTHREAD].desc = "IntDispatch-RxThread";
+	romePerfStat[ROMEPERF_INDEX_RECVLOOP].desc = "RecvLoop-FwdInput";
+	romePerfStat[ROMEPERF_INDEX_FWDENG_INPUT].desc = "FwdEng_Input()";
+	romePerfStat[ROMEPERF_INDEX_BEFORE_CRYPTO_ENCAP].desc = "FwdInput-Crypto(En)";
+	romePerfStat[ROMEPERF_INDEX_ENCAP].desc = "IPSEC Encap";
+	romePerfStat[ROMEPERF_INDEX_ENCAP_CRYPTO_ENGINE].desc = "Encap Crypto";
+	romePerfStat[ROMEPERF_INDEX_ENCAP_AUTH_ENGINE].desc = "Encap Authtication";
+	romePerfStat[ROMEPERF_INDEX_BEFORE_CRYPTO_DECAP].desc = "FwdInput-Crypto(De)";
+	romePerfStat[ROMEPERF_INDEX_DECAP].desc = "IPSEC Decap";
+	romePerfStat[ROMEPERF_INDEX_DECAP_CRYPTO_ENGINE].desc = "Decap Crypto";
+	romePerfStat[ROMEPERF_INDEX_DECAP_AUTH_ENGINE].desc = "Decap Authtication";
+	romePerfStat[ROMEPERF_INDEX_FASTPATH].desc = "Fast Path";
+	romePerfStat[ROMEPERF_INDEX_SLOWPATH].desc = "Slow Path";
+	romePerfStat[ROMEPERF_INDEX_FWDENG_SEND].desc = "FwdEngSend()";
+	romePerfStat[ROMEPERF_INDEX_UNTIL_ACLDB].desc = "FwdInput() Until ACLDB";
+	romePerfStat[ROMEPERF_INDEX_GET_MTU_AND_SOURCE_MAC].desc = "L3Route_MTU_srcMAC";
+	romePerfStat[ROMEPERF_INDEX_PPTPL2TP_1].desc = "L3Route_PPTPL2TP_1";
+	romePerfStat[ROMEPERF_INDEX_PPPOE_ARP_CACHE].desc = "L3Route_PPPoE_ArpCache";
+	romePerfStat[ROMEPERF_INDEX_PPTPL2TP_SEND].desc = "L3Route_PptpL2tpSend()";
+	romePerfStat[ROMEPERF_INDEX_FRAG].desc = "L3Route_Fragment";
+	romePerfStat[ROMEPERF_INDEX_EGRESS_ACL].desc = "FwdSend_EgressACL";
+	romePerfStat[ROMEPERF_INDEX_PPTPL2TP_ENCAP].desc = "FwdSend_PPTP/L2TP_Encap";
+	romePerfStat[ROMEPERF_INDEX_FROM_PS].desc = "FwdSend_FromPS";
+	romePerfStat[ROMEPERF_INDEX_EXTDEV_SEND].desc = "FwdSend_ExtDevSend()";
+	romePerfStat[ROMEPERF_INDEX_FRAG_2ND_HALF].desc = "FwdSend_Frag_2ndHalf()";
+	romePerfStat[ROMEPERF_INDEX_TXPKTPOST].desc = "rtl8651_txPktPostProcessing()";
+	romePerfStat[ROMEPERF_INDEX_MBUFPAD].desc = "mBuf_padding()";
+	romePerfStat[ROMEPERF_INDEX_TXALIGN].desc = "_swNic_txAlign";
+	romePerfStat[ROMEPERF_INDEX_ISRTXRECYCLE].desc = "_swNic_isrTxRecycle";
+	romePerfStat[ROMEPERF_INDEX_16].desc = "FwdEng_temp_16";
+	romePerfStat[ROMEPERF_INDEX_17].desc = "FwdEng_temp_17";
+	romePerfStat[ROMEPERF_INDEX_18].desc = "FwdEng_temp_18";
+        romePerfStat[ROMEPERF_INDEX_19].desc = "FwdEng_temp_19";
+        romePerfStat[ROMEPERF_INDEX_20].desc = "FwdEng_temp_20";
+        romePerfStat[ROMEPERF_INDEX_21].desc = "FwdEng_temp_21";
+        romePerfStat[ROMEPERF_INDEX_22].desc = "FwdEng_temp_22";
+        romePerfStat[ROMEPERF_INDEX_23].desc = "FwdEng_temp_23";
+        romePerfStat[ROMEPERF_INDEX_24].desc = "FwdEng_temp_24";
+        romePerfStat[ROMEPERF_INDEX_25].desc = "FwdEng_temp_25";
+        romePerfStat[ROMEPERF_INDEX_FLUSHDCACHE].desc = "rtlglue_flushDCache";
+        romePerfStat[ROMEPERF_INDEX_IRAM_1].desc = "IRAM Cached within IRAM";
+        romePerfStat[ROMEPERF_INDEX_IRAM_2].desc = "IRAM Uncached within IRAM";
+        romePerfStat[ROMEPERF_INDEX_IRAM_3].desc = "test ICACHE  (1024*100)";
+        romePerfStat[ROMEPERF_INDEX_IRAM_4].desc = "test Uncached (1024*10)";
+        romePerfStat[ROMEPERF_INDEX_DRAM_1].desc = "DRAM Cached within DRAM";
+        romePerfStat[ROMEPERF_INDEX_DRAM_2].desc = "DRAM Uncached within DRAM";
+        romePerfStat[ROMEPERF_INDEX_DRAM_3].desc = "test DCACHE  (1024*100)";
+        romePerfStat[ROMEPERF_INDEX_DRAM_4].desc = "test Uncached (1024*10)";
+        romePerfStat[ROMEPERF_INDEX_BMP].desc = "KMP Algorithm";
+        romePerfStat[ROMEPERF_INDEX_MDCMDIO].desc = "MDCMDIO PHY Register ACCESS";
+        romePerfStat[ROMEPERF_INDEX_TEST0].desc = "TEST 0";
+        romePerfStat[ROMEPERF_INDEX_TEST1].desc = "TEST 1";
+        romePerfStat[ROMEPERF_INDEX_TEST2].desc = "TEST 2";
+        romePerfStat[ROMEPERF_INDEX_TEST3].desc = "TEST 3";
+        romePerfStat[ROMEPERF_INDEX_TEST4].desc = "TEST 4";
+	 romePerfStat[ROMEPERF_INDEX_PCIE_IRQ].desc = "PCIE_IRQ";
+	romePerfStat[ROMEPERF_INDEX_RX_DSR].desc = "RX DSR";
+	romePerfStat[ROMEPERF_INDEX_RX_ISR].desc = "RX ISR";
+	romePerfStat[ROMEPERF_INDEX_validate_mpdu].desc = "validate mpdu";
+	romePerfStat[ROMEPERF_INDEX_swNic_receive].desc = "swNic_receive";
+	romePerfStat[ROMEPERF_INDEX_rtl_processReceivedInfo].desc = "rtl_processReceivedInfo";
+	romePerfStat[ROMEPERF_INDEX_rtl_decideRxDevice].desc = "rtl_decideRxDevice";
+	romePerfStat[ROMEPERF_INDEX_rtl_processRxFrame].desc = "rtl_processRxFrame";
+	romePerfStat[ROMEPERF_INDEX_rtl_processBridgeShortCut].desc = "rtl_processBridgeShortCut";
+	romePerfStat[ROMEPERF_INDEX_rtl_processRxToProtcolStack].desc = "rtl_processRxToProtcolStack";
+	romePerfStat[ROMEPERF_INDEX_netif_receive_skb].desc = "netif_receive_skb";
+	romePerfStat[ROMEPERF_INDEX_FastPath_Enter].desc = "FastPath_Enter";
+	romePerfStat[ROMEPERF_INDEX_checksum_in_fastpath].desc = "checksum_in_fastpath";
+	romePerfStat[ROMEPERF_INDEX_enter_fast_path].desc = "enter_fast_path";
+	romePerfStat[ROMEPERF_INDEX_ip_finish_output3].desc = "ip_finish_output3";
+	romePerfStat[ROMEPERF_INDEX_ndo_start_xmit].desc = "ndo_start_xmit";
+	romePerfStat[ROMEPERF_INDEX_rtl_preProcess_xmit].desc = "rtl_preProcess_xmit";
+	romePerfStat[ROMEPERF_INDEX_rtl_fill_txInfo].desc = "rtl_fill_txInfo";
+	romePerfStat[ROMEPERF_INDEX_swNic_send].desc = "swNic_send";
+	romePerfStat[ROMEPERF_INDEX_swNic_txDone].desc = "swNic_txDone";
+	romePerfStat[ROMEPERF_INDEX_dev_kfree_skb_any].desc = "dev_kfree_skb_any"	;
+	romePerfStat[ROMEPERF_INDEX_fastpath_1].desc = "fastpath_1";
+	romePerfStat[ROMEPERF_INDEX_fastpath_2].desc = "fastpath_2";
+	romePerfStat[ROMEPERF_INDEX_fastpath_3].desc = "fastpath_3";
+
+
+	local_irq_restore(flags);
+        return SUCCESS;
+}
+
+int32 rtl8651_romeperfReset()
+{
+	rtl8651_romeperfInit();
+
+	return SUCCESS;
+}
+
+#if 0/* old fashion function, for reference only. */
+int32 rtl8651_romeperfStart()
+{
+	if ( rtl8651_romeperf_inited == FALSE ) rtl8651_romeperfInit();
+
+	START_AND_GET_CP3_COUNTER0( cnt1 );
+
+	return SUCCESS;
+}
+
+int32 rtl8651_romeperfStop( uint64 *pDiff )
+{
+	if ( rtl8651_romeperf_inited == FALSE ) rtl8651_romeperfInit();
+
+	STOP_AND_GET_CP3_COUNTER0( cnt2 );
+
+	*pDiff = cnt2 - cnt1;
+	return SUCCESS;
+}
+#endif
+
+#if 0
+int32 rtl8651_romeperfGet( uint64 *pGet )
+{
+	if ( rtl8651_romeperf_inited == FALSE ) return FAILED;
+
+	/* Louis patch: someone will disable CP3 in somewhere. */
+	CP3_COUNTER0_INIT();
+
+	CP3_COUNTER0_STOP();
+	*pGet = CP3_COUNTER0_GET();
+	CP3_COUNTER0_START();
+
+	return SUCCESS;
+}
+#endif
+
+int32 rtl8651_romeperfPause( void )
+{
+	if ( rtl8651_romeperf_inited == FALSE ) return FAILED;
+
+	rtl8651_romeperf_enable = FALSE;
+
+	/* Louis patch: someone will disable CP3 in somewhere. */
+	CP3_COUNTER0_INIT();
+
+	CP3_COUNTER0_STOP();
+
+	return SUCCESS;
+}
+
+int32 rtl8651_romeperfResume( void )
+{
+	if ( rtl8651_romeperf_inited == FALSE ) return FAILED;
+
+	rtl8651_romeperf_enable = TRUE;
+
+	/* Louis patch: someone will disable CP3 in somewhere. */
+	CP3_COUNTER0_INIT();
+
+	CP3_COUNTER0_START();
+
+	return SUCCESS;
+}
+
+__IRAM int rtl8651_romeperfEnterPoint( int index )
+{
+	if ( rtl8651_romeperf_inited == FALSE ||
+	     rtl8651_romeperf_enable == FALSE ) return FAILED;
+	if ( index >= (sizeof(romePerfStat)/sizeof(rtl8651_romeperf_stat_t)) )
+		return FAILED;
+
+	/* Louis patch: someone will disable CP3 in somewhere. */
+	CP3_COUNTER0_INIT();
+
+	CP3_COUNTER0_STOP();
+	CP3_COUNTER0_GET_ALL();
+	romePerfStat[index].tempCycle[0] = currCnt[0];
+	romePerfStat[index].tempCycle[1] = currCnt[1];
+	romePerfStat[index].tempCycle[2] = currCnt[2];
+	romePerfStat[index].tempCycle[3] = currCnt[3];
+	romePerfStat[index].hasTempCycle = TRUE;
+	CP3_COUNTER0_START();
+
+	return SUCCESS;
+}
+
+__IRAM int rtl8651_romeperfExitPoint(int index )
+{
+	if ( rtl8651_romeperf_inited == FALSE ||
+	     rtl8651_romeperf_enable == FALSE ) return FAILED;
+	if ( index >= (sizeof(romePerfStat)/sizeof(rtl8651_romeperf_stat_t)) )
+		return FAILED;
+	if ( romePerfStat[index].hasTempCycle == FALSE )
+		return FAILED;
+
+	/* Louis patch: someone will disable CP3 in somewhere. */
+	CP3_COUNTER0_INIT();
+
+	CP3_COUNTER0_STOP();
+	CP3_COUNTER0_GET_ALL();
+	romePerfStat[index].accCycle[0] += currCnt[0]-romePerfStat[index].tempCycle[0];
+	romePerfStat[index].accCycle[1] += currCnt[1]-romePerfStat[index].tempCycle[1];
+	romePerfStat[index].accCycle[2] += currCnt[2]-romePerfStat[index].tempCycle[2];
+	romePerfStat[index].accCycle[3] += currCnt[3]-romePerfStat[index].tempCycle[3];
+	romePerfStat[index].hasTempCycle = FALSE;
+	romePerfStat[index].executedNum++;
+	CP3_COUNTER0_START();
+
+	return SUCCESS;
+}
+
+int32 rtl8651_romeperfDump( int start, int end )
+{
+#if 0
+	int i;
+
+	rtlglue_printf( "index %30s %12s %8s %10s\n", "description", "accCycle", "totalNum", "Average" );
+	for( i = start; i <= end; i++ )
+	{
+		if ( romePerfStat[i].executedNum == 0 )
+		{
+			rtlglue_printf( "[%3d] %30s %12s %8s %10s\n", i, romePerfStat[i].desc, "--", "--", "--" );
+		}
+		else
+		{
+			int j;
+			rtlglue_printf( "[%3d] %30s ",
+			                i, romePerfStat[i].desc );
+			for( j =0; j < sizeof(romePerfStat[i].accCycle)/sizeof(romePerfStat[i].accCycle[0]);
+			     j++ )
+			{
+				uint32 *pAccCycle = (uint32*)&romePerfStat[i].accCycle[j];
+				uint32 avrgCycle = /* Hi-word */ (pAccCycle[0]*(0xffffffff/romePerfStat[i].executedNum)) +
+				                   /* Low-word */(pAccCycle[1]/romePerfStat[i].executedNum);
+
+				rtlglue_printf( "%12llu %8u %10u\n",
+				                romePerfStat[i].accCycle[j],
+				                romePerfStat[i].executedNum,
+				                avrgCycle
+				                );
+				rtlglue_printf( " %3s  %30s ", "", "" );
+			}
+			rtlglue_printf( "\r" );
+		}
+	}
+
+	return SUCCESS;
+#else
+	int i;
+
+	//rtl8651_romeperf_stat_t* statSnapShot = rtlglue_malloc(sizeof(rtl8651_romeperf_stat_t) * (end - start + 1) );
+	if( statSnapShot == NULL )
+	{
+		rtlglue_printf("statSnapShot mem alloc failed\n");
+		return FAILED;
+	}
+
+	memset( &statSnapShot , 0, sizeof( statSnapShot ) );
+
+	rtlglue_printf( "index %30s %12s %8s %10s\n", "description", "accCycle", "totalNum", "Average" );
+
+	for( i = start; i <= end; i++ )
+	{
+		int j;
+		for( j =0; j < sizeof(romePerfStat[i].accCycle)/sizeof(romePerfStat[i].accCycle[0]); j++ )
+		{
+			statSnapShot[i].accCycle[j]  = romePerfStat[i].accCycle[j];
+			statSnapShot[i].tempCycle[j] = romePerfStat[i].tempCycle[j];
+		}
+		statSnapShot[i].executedNum  = romePerfStat[i].executedNum;
+		statSnapShot[i].hasTempCycle = romePerfStat[i].hasTempCycle;
+	}
+
+	for( i = start; i <= end; i++ )
+	{
+		if ( statSnapShot[i].executedNum == 0 )
+		{
+			rtlglue_printf( "[%3d] %30s %12s %8s %10s\n", i, romePerfStat[i].desc, "--", "--", "--" );
+		}
+		else
+		{
+			int j;
+			rtlglue_printf( "[%3d] %30s ", i, romePerfStat[i].desc );
+			for( j =0; j < sizeof(statSnapShot[i].accCycle)/sizeof(statSnapShot[i].accCycle[0]); j++ )
+			{
+				uint32 *pAccCycle = (uint32*)&statSnapShot[i].accCycle[j];
+				uint32 avrgCycle = /* Hi-word */ (pAccCycle[0]*(0xffffffff/statSnapShot[i].executedNum)) +
+				                   /* Low-word */(pAccCycle[1]/statSnapShot[i].executedNum);
+				rtlglue_printf( "%12llu %8u %10u\n",
+				statSnapShot[i].accCycle[j],
+				statSnapShot[i].executedNum,
+				avrgCycle );
+				rtlglue_printf( " %3s  %30s ", "", "" );
+			}
+			rtlglue_printf( "\r" );
+		}
+	}
+
+	//rtlglue_free(statSnapShot);
+
+	return SUCCESS;
+#endif
+}
+
+int rtl865x_perf_proc_read( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	//unsigned long x;
+	//spin_lock_irq(x);
+	unsigned long flags = 0;
+	local_irq_save(flags);
+
+
+//	rtl8651_romeperfDump(79, 98);
+	rtl8651_romeperfDump(79, 80);
+	local_irq_restore(flags);
+
+	//spin_unlock_irq(x);
+    return 0;
+}
+
+int rtl865x_perf_proc_write(struct file *file, const char *buffer,
+              unsigned long count, void *data)
+{
+	char  tmpbuf[32];
+	int start, end, num;
+	unsigned long x;
+	spin_lock_irq(x);
+	if (buffer && !copy_from_user(tmpbuf, buffer, count))
+	{
+		tmpbuf[count] = '\0';
+		if(!memcmp(tmpbuf, "flush", 5)){
+			rtl8651_romeperfReset();
+		}else{
+			num = sscanf(tmpbuf, "%d %d", &start, &end);
+			if (num !=  2) {
+				printk("invalid romeperf parameter!\n");
+				goto OUT;
+			}
+
+			if((start<0) ||(start>99)||(end<0) ||(end>99) ||(start>end)){
+				printk("Bad index!\n");
+				goto OUT;
+			}
+
+			rtl8651_romeperfDump(start, end);
+		}
+	}
+OUT:
+    spin_unlock_irq(x);
+    return count;
+}
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/romeperf.h b/drivers/soc/realtek/rtd129x/hw_nat/romeperf.h
new file mode 100644
index 00000000..9107689
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/romeperf.h
@@ -0,0 +1,154 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* Program : Performance Profiling Header File for ROME Driver
+* Abstract :
+* Author : Yung-Chieh Lo (yjlou@realtek.com.tw)
+* $Id: romeperf.h,v 1.1 2007-12-21 10:28:22 davidhsu Exp $
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef _ROMEPERF_H_
+#define _ROMEPERF_H_
+
+#include "net/rtl/rtl_types.h"
+
+#if defined(CONFIG_RTL865X_MODULE_ROMEDRV)
+#define	rtl8651_romeperfEnterPoint				module_internal_rtl8651_romeperfEnterPoint
+#define	rtl8651_romeperfExitPoint					module_internal_rtl8651_romeperfExitPoint
+#endif
+
+struct rtl8651_romeperf_stat_s {
+	char *desc;
+	uint64 accCycle[4];
+	uint64 tempCycle[4];
+	uint32 executedNum;
+	uint32 hasTempCycle:1; /* true if tempCycle is valid. */
+};
+typedef struct rtl8651_romeperf_stat_s rtl8651_romeperf_stat_t;
+
+
+/* for rtl8651_romeperfEnterPoint() and rtl8651_romeperfExitPoint() */
+#define ROMEPERF_INDEX_MIN 0
+#define ROMEPERF_INDEX_NAPT_ADD 0
+#define ROMEPERF_INDEX_NAPT_ADD_1 1
+#define ROMEPERF_INDEX_NAPT_ADD_2 2
+#define ROMEPERF_INDEX_NAPT_ADD_3 3
+#define ROMEPERF_INDEX_NAPT_ADD_4 4
+#define ROMEPERF_INDEX_NAPT_ADD_5 5
+#define ROMEPERF_INDEX_NAPT_ADD_6 6
+#define ROMEPERF_INDEX_NAPT_ADD_7 7
+#define ROMEPERF_INDEX_NAPT_ADD_8 8
+#define ROMEPERF_INDEX_NAPT_ADD_9 9
+#define ROMEPERF_INDEX_NAPT_ADD_10 10
+#define ROMEPERF_INDEX_NAPT_ADD_11 11
+#define ROMEPERF_INDEX_NAPT_DEL 12
+#define ROMEPERF_INDEX_NAPT_FIND_OUTBOUND 13
+#define ROMEPERF_INDEX_NAPT_FIND_INBOUND 14
+#define ROMEPERF_INDEX_NAPT_UPDATE 15
+#define ROMEPERF_INDEX_UNTIL_RXTHREAD 20
+#define ROMEPERF_INDEX_RECVLOOP 21
+#define ROMEPERF_INDEX_FWDENG_INPUT 22
+#define ROMEPERF_INDEX_BEFORE_CRYPTO_ENCAP 23
+#define ROMEPERF_INDEX_ENCAP 24
+#define ROMEPERF_INDEX_ENCAP_CRYPTO_ENGINE 25
+#define ROMEPERF_INDEX_ENCAP_AUTH_ENGINE 26
+#define ROMEPERF_INDEX_BEFORE_CRYPTO_DECAP 27
+#define ROMEPERF_INDEX_DECAP 28
+#define ROMEPERF_INDEX_DECAP_CRYPTO_ENGINE 29
+#define ROMEPERF_INDEX_DECAP_AUTH_ENGINE 30
+#define ROMEPERF_INDEX_FASTPATH 31
+#define ROMEPERF_INDEX_SLOWPATH 32
+#define ROMEPERF_INDEX_UNTIL_ACLDB 33
+#define ROMEPERF_INDEX_GET_MTU_AND_SOURCE_MAC 34
+#define ROMEPERF_INDEX_PPTPL2TP_1 35
+#define ROMEPERF_INDEX_PPPOE_ARP_CACHE 36
+#define ROMEPERF_INDEX_PPTPL2TP_SEND 37
+#define ROMEPERF_INDEX_FRAG 38
+#define ROMEPERF_INDEX_FWDENG_SEND 39
+#define ROMEPERF_INDEX_EGRESS_ACL 40
+#define ROMEPERF_INDEX_PPTPL2TP_ENCAP 41
+#define ROMEPERF_INDEX_FROM_PS 42
+#define ROMEPERF_INDEX_EXTDEV_SEND 43
+#define ROMEPERF_INDEX_FRAG_2ND_HALF 44
+#define ROMEPERF_INDEX_TXPKTPOST 45
+#define ROMEPERF_INDEX_MBUFPAD 46
+#define ROMEPERF_INDEX_TXALIGN 47
+#define ROMEPERF_INDEX_ISRTXRECYCLE 48
+#define ROMEPERF_INDEX_16 49
+#define ROMEPERF_INDEX_17 50
+#define ROMEPERF_INDEX_18 51
+#define ROMEPERF_INDEX_19 52
+#define ROMEPERF_INDEX_20 53
+#define ROMEPERF_INDEX_21 54
+#define ROMEPERF_INDEX_22 55
+#define ROMEPERF_INDEX_23 56
+#define ROMEPERF_INDEX_24 57
+#define ROMEPERF_INDEX_25 58
+#define ROMEPERF_INDEX_FLUSHDCACHE 59
+#define ROMEPERF_INDEX_IRAM_1 60
+#define ROMEPERF_INDEX_IRAM_2 61
+#define ROMEPERF_INDEX_IRAM_3 62
+#define ROMEPERF_INDEX_IRAM_4 63
+#define ROMEPERF_INDEX_DRAM_1 64
+#define ROMEPERF_INDEX_DRAM_2 65
+#define ROMEPERF_INDEX_DRAM_3 66
+#define ROMEPERF_INDEX_DRAM_4 67
+#define ROMEPERF_INDEX_BMP 68
+#define ROMEPERF_INDEX_MDCMDIO 69
+#define ROMEPERF_INDEX_TEST0    70
+#define ROMEPERF_INDEX_TEST1    71
+#define ROMEPERF_INDEX_TEST2    72
+#define ROMEPERF_INDEX_TEST3    73
+#define ROMEPERF_INDEX_TEST4    74
+
+#define ROMEPERF_INDEX_PCIE_IRQ 75
+#define ROMEPERF_INDEX_RX_DSR 76
+#define ROMEPERF_INDEX_RX_ISR 77
+#define ROMEPERF_INDEX_validate_mpdu 78
+
+#define ROMEPERF_INDEX_swNic_receive 79
+#define ROMEPERF_INDEX_rtl_processReceivedInfo 80
+#define ROMEPERF_INDEX_rtl_decideRxDevice 81
+#define ROMEPERF_INDEX_rtl_processRxFrame 82
+#define ROMEPERF_INDEX_rtl_processBridgeShortCut 83
+#define ROMEPERF_INDEX_rtl_processRxToProtcolStack 84
+#define ROMEPERF_INDEX_netif_receive_skb 85
+#define ROMEPERF_INDEX_FastPath_Enter 86
+#define ROMEPERF_INDEX_checksum_in_fastpath 87
+#define ROMEPERF_INDEX_enter_fast_path 88
+#define ROMEPERF_INDEX_ip_finish_output3 89
+#define ROMEPERF_INDEX_ndo_start_xmit 90
+#define ROMEPERF_INDEX_rtl_preProcess_xmit 91
+#define ROMEPERF_INDEX_rtl_fill_txInfo 92
+#define ROMEPERF_INDEX_swNic_send 93
+#define ROMEPERF_INDEX_swNic_txDone 94
+#define ROMEPERF_INDEX_dev_kfree_skb_any 95
+#define ROMEPERF_INDEX_fastpath_1 96
+#define ROMEPERF_INDEX_fastpath_2 97
+#define ROMEPERF_INDEX_fastpath_3 98
+
+
+#define ROMEPERF_INDEX_MAX 99
+
+int32 rtl8651_romeperfInit( void );
+inline int32 rtl8651_romeperfStart(void);
+inline int32 rtl8651_romeperfStop(void);
+int32 rtl8651_romeperfReset( void );
+int rtl8651_romeperfEnterPoint( int index );
+int rtl8651_romeperfExitPoint( int index );
+int32 rtl8651_romeperfDump( int start, int end );
+int32 rtl8651_romeperfPause( void );
+int32 rtl8651_romeperfResume( void );
+int32 rtl8651_romeperfGet( uint64 *pGet );
+
+extern rtl8651_romeperf_stat_t romePerfStat[ROMEPERF_INDEX_MAX];
+
+
+
+#endif/* _ROMEPERF_H_ */
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtd129x_link_mon.c b/drivers/soc/realtek/rtd129x/hw_nat/rtd129x_link_mon.c
new file mode 100644
index 00000000..bf59c0d
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtd129x_link_mon.c
@@ -0,0 +1,193 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/kernel.h>
+//#include <linux/delay.h>
+#include <linux/workqueue.h>
+#include <linux/sched.h>
+#include <linux/timer.h>
+#include <linux/string.h>
+#include <linux/if.h>
+#include <asm/uaccess.h> /* jiffies */
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "AsicDriver/asicRegs.h"
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+
+
+#define RTL_DEBUG       1
+#ifdef RTL_DEBUG
+#define DBG(fmt, ...) printk(KERN_ERR "%s:%d: " fmt "\n", \
+			__func__, __LINE__, ## __VA_ARGS__)
+#else
+#define DBG(fmt, ...)
+#endif
+
+extern rtl8651_tblAsic_ethernet_t	rtl8651AsicEthernetTable[];
+extern uint8 hwnat_mac0_enable; /* 0: interface used by SATA, 1: interface used by NAT */
+extern uint8 hwnat_mac0_mode; /* 0:RGMII, 1:SGMII */
+extern uint8 hwnat_mac5_conn_to; /* 0:PHY, 1:MAC */
+
+typedef struct link_mon_s {
+	uint8_t name[IFNAMSIZ];
+	struct timer_list sec_timer; /* kernel timer */
+	struct work_struct work_q; /* work queue (interrupt in the lower half of the method) */
+	uint32_t counter; /* into the statistics of the number of interrupts */
+	uint32_t interval;
+} link_mon_t;
+static link_mon_t mac0_sgmii_lnk;
+
+#define TIMER_OVER 1 /* call interval */
+
+
+void rtd129x_mac0_sgmii_link_chk(void)
+{
+	uint32_t val, remote_ablity;
+	static uint8_t lnk_state = 0;
+	uint8_t speed, duplex;
+
+	/* 1. Get link status */
+	val = READ_MEM32(SERDES_WRP_SDS_LINK) >> SERDES_WRP_SDS_LINK_partner_ablity_shift;
+	remote_ablity = val;
+	//DBG("SERDES_WRP_SDS_LINK_partner_ablity = 0x%05x", val);
+	if ((val & SERDES_WRP_SDS_LINK_partner_fib_linkok) == 0) {
+		if (lnk_state == 0)
+			return;
+		else
+			lnk_state = 0;
+
+		/* clear local ability */
+		WRITE_MEM32(SERDES_WRP_SDS_LINK, 0);
+
+		/* update MAC0 as force 10M link down */
+		val = READ_MEM32(PCRP0) & ~(PauseFlowControl_MASK | AutoNegoSts_MASK | PollLinkStatus | ForceLink);
+		val |= EnForceMode | ForceSpeed10M | EnablePHYIf;
+		DBG("link down!");
+		WRITE_MEM32(PCRP0, val);
+
+		rtl8651_setAsicEthernetLinkStatus(0, FALSE);
+
+	} else {
+		if (lnk_state == 1)
+			return;
+		else
+			lnk_state = 1;
+
+		speed = val & 3;
+		duplex = val & (1 << 2);
+
+		/* 2. Force link down */
+		val = READ_MEM32(PCRP0) & ~(PauseFlowControl_MASK | PollLinkStatus | ForceLink);
+		val |= EnForceMode | EnablePHYIf;
+		//DBG("PCRP0 = 0x%08x", val);
+		WRITE_MEM32(PCRP0, val);
+
+		/* 3. Wait for all queues empty */
+		for (;;) {
+			val = READ_MEM32(P0_DCR0);
+			if (val > 0)
+				goto retry;
+
+			val = READ_MEM32(P0_DCR1);
+			if (val > 0)
+				goto retry;
+
+			val = READ_MEM32(P0_DCR2);
+			if (val > 0)
+				goto retry;
+
+			val = READ_MEM32(P0_DCR3);
+			if ((val & 0xFFFFFC00) > 0)
+				goto retry;
+
+			break;
+retry:
+			//mdelay(100);
+			lnk_state = 0;
+			DBG("val 0x%08x, P0_DCR0: 0x%08x 0x%08x 0x%08x 0x%08x", val, READ_MEM32(P0_DCR0),
+				READ_MEM32(P0_DCR1), READ_MEM32(P0_DCR2), READ_MEM32(P0_DCR3));
+			return;
+		}
+
+		/* Set local ablity as remote ablity */
+		WRITE_MEM32(SERDES_WRP_SDS_LINK, remote_ablity);
+
+		/* 4. Force new speed, duplex and link up */
+		val = READ_MEM32(PCRP0) & ~(PauseFlowControl_MASK | AutoNegoSts_MASK | PollLinkStatus);
+		val |= EnForceMode | ForceLink | PauseFlowControlEtxErx | EnablePHYIf;
+		switch (speed) {
+		case 2:
+			val |= ForceSpeed1000M;
+			DBG("Speed: 1000M");
+			break;
+		case 1:
+			val |= ForceSpeed100M;
+			DBG("Speed: 100M");
+			break;
+		case 0:
+		default:
+			DBG("Speed: 10M");
+			val |= ForceSpeed10M;
+		}
+		if (duplex > 0) {
+			val |= ForceDuplex;
+			DBG("Full duplex");
+		} else {
+			DBG("Half duplex");
+		}
+		//DBG("PCRP0 = 0x%08x", val);
+		WRITE_MEM32(PCRP0, val);
+
+		rtl8651_setAsicEthernetLinkStatus(0, TRUE);
+	}
+
+}
+
+/* timer interrupt service routine */
+static void sec_timer_function(unsigned long data)
+{
+	link_mon_t *ln = (link_mon_t *) data;
+	//scheduler work queue
+	if (schedule_work(&ln->work_q) == 0) {
+		DBG("cannot schedule work!!!");
+	}
+	ln->counter++;
+	//DBG("Timer Expired interval is %d!!", ln->interval);
+	//DBG("name [%s] counter =%d", ln->name, ln->counter);
+}
+
+//Register a kernel timer
+static void sec_timer_register (struct timer_list * ptimer, uintptr_t data) {
+	link_mon_t *ln = (link_mon_t *) data;
+	DBG("periodic task: name [%s] interval %d secs", ln->name, ln->interval);
+	init_timer(ptimer);
+	ptimer->data = data;
+	ptimer->expires = jiffies + (ln->interval * HZ);
+	ptimer->function = sec_timer_function;
+	add_timer(ptimer);
+}
+
+//timer bottom half handler function
+static void lnk_mon_fetch_thread (struct work_struct * work)
+{
+	link_mon_t *ln = container_of(work, struct link_mon_s, work_q);
+	rtd129x_mac0_sgmii_link_chk();
+	mod_timer(&ln->sec_timer, jiffies + (ln->interval * HZ));
+}
+
+void rtk_polling_mac0_lnk_status(void)
+{
+	memset(&mac0_sgmii_lnk, 0, sizeof(struct link_mon_s));
+	strcpy(mac0_sgmii_lnk.name, "mac0_sgmii");
+	mac0_sgmii_lnk.interval = TIMER_OVER;
+	sec_timer_register(&mac0_sgmii_lnk.sec_timer, (uintptr_t) &mac0_sgmii_lnk);
+	INIT_WORK(&mac0_sgmii_lnk.work_q, lnk_mon_fetch_thread);
+}
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_swNic.c b/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_swNic.c
new file mode 100644
index 00000000..0f7a473
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_swNic.c
@@ -0,0 +1,2199 @@
+/*
+ *	Abstract: provide NIC initialization, reception and transmission
+ *			  functions for new descriptor architecture.
+ *
+ *	Author:
+ *		Joey Lin, <joey.lin@realtek.com>
+ *
+ *	Copyright (c) 2015 Realtek Semiconductor Corp.
+ *
+ *	This program is free software; you can redistribute it and/or
+ *	modify it under the terms of the GNU General Public License
+ *	as published by the Free Software Foundation; either version
+ *	2 of the License, or (at your option) any later version.
+ */
+
+#if 0
+TODO: refer	to /linux-3.10/drivers/net/ethernet/broadcom/bcm63xx_enet.c
+			   /linux-3.10/drivers/net/ethernet/realtek/r8169.c
+	  and follow them to use those functions
+
+rtl_open()
+{
+	/*
+	 * Rx and Tx descriptors needs 256 bytes alignment.
+	 * dma_alloc_coherent provides more.
+	 */
+	tp->RxDescArray = dma_alloc_coherent(&pdev->dev, R8169_RX_RING_BYTES,
+						&tp->RxPhyAddr, GFP_KERNEL);
+	.....
+	smp_mb();
+	.....
+	dma_free_coherent(&pdev->dev, R8169_RX_RING_BYTES, tp->RxDescArray,
+			  tp->RxPhyAddr);
+}
+
+static struct sk_buff *rtl8169_alloc_rx_data(struct rtl8169_private *tp,
+						 struct RxDesc *desc)
+{
+	.....
+	mapping = dma_map_single(d, rtl8169_align(data), rx_buf_sz,
+				 DMA_FROM_DEVICE);
+	.....
+}
+
+static netdev_tx_t rtl8169_start_xmit(struct sk_buff *skb,
+					  struct net_device *dev)
+{
+	.....
+	mapping = dma_map_single(d, skb->data, len, DMA_TO_DEVICE);
+	.....
+	wmb();
+
+	wmb();
+
+	mmiowb();
+
+	smp_wmb();
+
+	smp_mb();
+
+	.....
+}
+#endif
+
+#include <linux/version.h>
+#include <linux/kconfig.h>
+#include <linux/skbuff.h>
+#include <linux/ip.h>
+#if defined(CONFIG_RTD_1295_HWNAT)
+#include <linux/dma-mapping.h>
+#include <linux/platform_device.h>
+#include <linux/netdevice.h>
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#include <linux/tcp.h>
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)) && (LINUX_VERSION_CODE < KERNEL_VERSION(3, 3, 0))
+#include <linux/if_ether.h>
+#include <linux/in.h>
+#else
+#include <uapi/linux/if_ether.h>
+#include <uapi/linux/in.h>
+#endif
+#if 1				/* defined(CONFIG_RTL_97F_HW_TX_CSUM) && defined(CONFIG_RTL_EXT_PORT_SUPPORT) */
+#include <linux/if_vlan.h>
+#endif
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#include <asm/cpu-features.h>
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+#include "common/rtl_errno.h"
+#include "AsicDriver/asicRegs.h"
+#include <net/rtl/rtl865x_netif.h>
+#include "rtl865xc_swNic.h"
+#include "common/mbuf.h"
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "rtl819x_swNic.h"
+
+/* #include "m24kctrl.h" //added for romperf testing */
+#if defined(CONFIG_RTD_1295_HWNAT)
+/* #define RTL_DEBUG       1 */
+#ifdef RTL_DEBUG
+#define DBG(fmt, ...) printk(KERN_ERR "%s:%d: " fmt "\n", \
+			__func__, __LINE__, ## __VA_ARGS__)
+#else
+#define DBG(fmt, ...)
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+extern unsigned int rx_noBuffer_cnt;
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+extern int gHwNatEnabled;
+#endif
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+__DRAM_FWD static uint8 extPortMaskToPortNum[_RTL865XB_EXTPORTMASKS + 1] = {
+	5, 6, 7, 5, 8, 5, 5, 5
+};
+#endif
+
+struct ring_info {
+#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t skb;
+	unsigned int dma_len;
+	dma_addr_t dma_addr;
+#else				/* defined(CONFIG_RTD_1295_HWNAT) */
+	unsigned int skb;
+/* unsigned int            frag;   // no used now */
+#endif				/* defined(CONFIG_RTD_1295_HWNAT) */
+};
+
+static struct ring_info *rx_skb[NEW_NIC_MAX_RX_DESC_RING];
+static struct ring_info *tx_skb[NEW_NIC_MAX_TX_DESC_RING];
+
+__DRAM_FWD static int32 New_rxDescRingCnt[NEW_NIC_MAX_RX_DESC_RING];
+static DMA_RX_DESC *New_rxDescRing[NEW_NIC_MAX_RX_DESC_RING] = { NULL };
+
+__DRAM_FWD static int32 New_currRxPkthdrDescIndex[NEW_NIC_MAX_RX_DESC_RING];
+
+__DRAM_FWD static uint32 New_txDescRingCnt[NEW_NIC_MAX_TX_DESC_RING];
+static DMA_TX_DESC *New_txDescRing[NEW_NIC_MAX_TX_DESC_RING];
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+static dma_addr_t New_rxDescRingPhyAddr[NEW_NIC_MAX_RX_DESC_RING];
+static dma_addr_t New_txDescRingPhyAddr[NEW_NIC_MAX_TX_DESC_RING];
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+__DRAM_FWD static uint32 New_currTxPkthdrDescIndex[NEW_NIC_MAX_TX_DESC_RING];
+__DRAM_FWD static uint32 New_txPktDoneDescIndex[NEW_NIC_MAX_TX_DESC_RING];
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+__DRAM_FWD static uintptr_t
+	New_txDescRing_base[RTL865X_SWNIC_TXRING_HW_PKTDESC];
+__DRAM_FWD static uintptr_t
+	New_rxDescRing_base[RTL865X_SWNIC_RXRING_HW_PKTDESC];
+
+static uintptr_t TxCDP_reg[RTL865X_SWNIC_TXRING_HW_PKTDESC];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+__DRAM_FWD static uint32 New_txDescRing_base[RTL865X_SWNIC_TXRING_HW_PKTDESC];
+__DRAM_FWD static uint32 New_rxDescRing_base[RTL865X_SWNIC_RXRING_HW_PKTDESC];
+
+static uint32 TxCDP_reg[RTL865X_SWNIC_TXRING_HW_PKTDESC] =
+	{ CPUTPDCR0, CPUTPDCR1, CPUTPDCR2, CPUTPDCR3 };
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+extern struct platform_device *rtl819x_pdev;
+extern void sync_tx_data_for_device(dma_addr_t addr, int len);
+extern void rtl_dump_data(void *p, int len);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#define NEXT_IDX(N, RING_SIZE) (((N+1) == RING_SIZE) ? 0 : (N+1))
+
+#define _DESC_CACHE_ACCESS_RX			1
+
+/* must define USE_SWITCH_TX_CDP when use _DESC_CACHE_ACCESS_TX */
+/*
+  when _DESC_CACHE_ACCESS_TX and USE_SWITCH_TX_CDP are both defined,
+  in New_swNic_txDone(), for example,
+  it will happen:
+    New_currTxPkthdrDescIndex[0] = 16
+    New_txPktDoneDescIndex[0] = 12
+    hw_cdp_idx = 17
+  after New_swNic_txDone() done, will be:
+    New_currTxPkthdrDescIndex[0] = 16
+    New_txPktDoneDescIndex[0] = 17
+    hw_cdp_idx = 17
+  ==> Tx will STOP.
+ */
+/* #define       _DESC_CACHE_ACCESS_TX           1 */
+
+/* since _DESC_CACHE_ACCESS_TX can not used, we use a local TxDesc to store
+   the setting, then copy the local version to physical desc memory once.
+ */
+#define _LOCAL_TX_DESC	1
+static struct tx_desc local_txd;
+
+#define	USE_SWITCH_TX_CDP	1	/* use Switch Tx Current Descriptor Pointer, instead of OWN bit. */
+
+/*
+  in my	test in	FPGA, RxRing0 desc number is only 32,
+  I	have connect 1 LAN PC and 1	WAN	PC,	then boot up kernel,
+  after	the	ethernet interface up, and New_swNic_receive() be executed first time,
+  the sw_curr_idx is 0 and hw_desc_idx is 0,
+  but HW is	received 32	pkt	and	desc ran out.
+
+  MUST figure out a	solution to	fix	above situation,
+  then USE_SWITCH_RX_CDP flag can be used.
+ */
+#define USE_SWITCH_RX_CDP	1	/* use Switch Rx CDP */
+
+void New_dumpTxRing(struct seq_file *s)
+{
+	uint32 i, j;
+	struct sk_buff *skb;
+	uint32 *p;
+
+	seq_printf(s, "========================= dump tx ring =========================\n");
+
+	for (i = 0; i < NEW_NIC_MAX_TX_DESC_RING; i++) {
+		seq_printf(s, "====== ring %d ======\n", i);
+		seq_printf(s, "txDoneIdx[%d]: %d, txCurrIdx[%d]: %d\n", i,
+			New_txPktDoneDescIndex[i], i,
+			New_currTxPkthdrDescIndex[i]);
+#if defined(CONFIG_RTD_1295_HWNAT)
+		seq_printf(s, "HW CDP: 0x%x,	HW idx (calculated): %ld\n",
+			REG32(TxCDP_reg[i]),
+			(REG32(TxCDP_reg[i]) - New_txDescRing_base[i]) / sizeof(struct dma_tx_desc));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		seq_printf(s, "HW CDP: 0x%x,	HW idx (calculated): %d\n",
+			REG32(TxCDP_reg[i]),
+			(REG32(TxCDP_reg[i]) - New_txDescRing_base[i]) / sizeof(struct dma_tx_desc));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		for (j = 0; j < New_txDescRingCnt[i]; j++) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+			seq_printf(s, "tx_desc[%d][%d]: 0x%lx,", i, j,
+				(uintptr_t) (&New_txDescRing[i][j]));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			seq_printf(s, "tx_desc[%d][%d]: 0x%x,", i, j,
+				(uint32)(&New_txDescRing[i][j]));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+			p = (uint32 *)(&New_txDescRing[i][j]);
+#if !defined(CONFIG_RTD_1295_HWNAT)
+			p = (uint32 *)(((uint32)p) | UNCACHE_MASK);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+			seq_printf(s, "  %s owned\n",
+				((*p) & DESC_OWNED_BIT) ? "SWCORE" : "CPU");
+
+			seq_printf(s,
+				"   6DW: 0x%08x, 0x%08x, 0x%08x, 0x%08x, 0x%08x, 0x%08x\n",
+				(uint32)(*p), (uint32)*(p + 1),
+				(uint32)*(p + 2), (uint32)*(p + 3),
+				(uint32)*(p + 4), (uint32)*(p + 5));
+#if defined(CONFIG_RTL_WTDOG)
+			rtl_periodic_watchdog_kick(j, WATCHDOG_NUM_OF_TIMES);
+#endif
+
+		}
+		seq_printf(s, "\n");
+	}
+
+	seq_printf(s, "========================= dump tx skb =========================\n");
+	for (i = 0; i < NEW_NIC_MAX_TX_DESC_RING; i++) {
+		seq_printf(s, "====== for ring %d ======\n", i);
+		for (j = 0; j < New_txDescRingCnt[i]; j++) {
+			skb = (struct sk_buff *)tx_skb[i][j].skb;
+#if defined(CONFIG_RTD_1295_HWNAT)
+			if (skb == NULL)
+				seq_printf(s,
+					"[%d][%d]: tx_skb: %lx, skb: NULL\n", i,
+					j, (uintptr_t) (&tx_skb[i][j]));
+			else
+				seq_printf(s,
+					"[%d][%d]: tx_skb: %lx, skb: %lx, skb->data: %lx,"
+					" dma_addr: %lx, dma_len %d\n", i, j,
+					(uintptr_t) (&tx_skb[i][j]),
+					(uintptr_t) tx_skb[i][j].skb,
+					(uintptr_t) skb->data,
+					(uintptr_t) (tx_skb[i][j].dma_addr),
+					tx_skb[i][j].dma_len);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			if (skb == NULL)
+				seq_printf(s,
+					"[%d][%d]: tx_skb: %x, skb: NULL\n", i,
+					j, (uint32)(&tx_skb[i][j]));
+			else
+				seq_printf(s,
+					"[%d][%d]: tx_skb: %x, skb: %x, skb->data: %x\n",
+					i, j, (uint32)(&tx_skb[i][j]),
+					(uint32)tx_skb[i][j].skb,
+					(uint32)skb->data);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTL_WTDOG)
+			rtl_periodic_watchdog_kick(j, WATCHDOG_NUM_OF_TIMES);
+#endif
+
+		}
+		seq_printf(s, "\n");
+	}
+}
+
+void New_dumpRxRing(struct seq_file *s)
+{
+	uint32 i, j;
+	struct sk_buff *skb;
+	uint32 *p;
+
+	seq_printf(s, "========================= dump rx ring =========================\n");
+
+	for (i = 0; i < NEW_NIC_MAX_RX_DESC_RING; i++) {
+		seq_printf(s, "====== ring %d ======\n", i);
+		seq_printf(s, "currRxIdx[%d]: %d\n", i,
+			New_currRxPkthdrDescIndex[i]);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		seq_printf(s, "HW CDP: 0x%x,	HW idx (calculated): %ld\n",
+			REG32(CPURPDCR(i)),
+			(REG32(CPURPDCR(i)) - New_rxDescRing_base[i]) / sizeof(struct dma_rx_desc));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		seq_printf(s, "HW CDP: 0x%x,	HW idx (calculated): %d\n",
+			REG32(CPURPDCR(i)),
+			(REG32(CPURPDCR(i)) - New_rxDescRing_base[i]) / sizeof(struct dma_rx_desc));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		for (j = 0; j < New_rxDescRingCnt[i]; j++) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+			seq_printf(s, "rx_desc[%d][%d]: 0x%lx,", i, j,
+				(uintptr_t) (&New_rxDescRing[i][j]));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			seq_printf(s, "rx_desc[%d][%d]: 0x%x,", i, j,
+				(uint32)(&New_rxDescRing[i][j]));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+			p = (uint32 *)(&New_rxDescRing[i][j]);
+#if !defined(CONFIG_RTD_1295_HWNAT)
+			p = (uint32 *)(((uint32)p) | UNCACHE_MASK);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+			seq_printf(s, "  %s owned\n",
+				((*p) & DESC_OWNED_BIT) ? "SWCORE" : "CPU");
+
+			seq_printf(s,
+				"   6DW: 0x%08x, 0x%08x, 0x%08x, 0x%08x, 0x%08x, 0x%08x\n",
+				(uint32)(*p), (uint32)*(p + 1),
+				(uint32)*(p + 2), (uint32)*(p + 3),
+				(uint32)*(p + 4), (uint32)*(p + 5));
+#if defined(CONFIG_RTL_WTDOG)
+			rtl_periodic_watchdog_kick(j, WATCHDOG_NUM_OF_TIMES);
+#endif
+
+		}
+		seq_printf(s, "\n");
+	}
+
+	seq_printf(s, "========================= dump rx skb =========================\n");
+	for (i = 0; i < NEW_NIC_MAX_RX_DESC_RING; i++) {
+		seq_printf(s, "====== for ring %d ======\n", i);
+		for (j = 0; j < New_rxDescRingCnt[i]; j++) {
+			skb = (struct sk_buff *)rx_skb[i][j].skb;
+#if defined(CONFIG_RTD_1295_HWNAT)
+			if (skb == NULL)
+				seq_printf(s,
+					"[%d][%d]: rx_skb: %lx, skb: NULL\n", i,
+					j, (uintptr_t) (&rx_skb[i][j]));
+			else
+				seq_printf(s,
+					"[%d][%d]: rx_skb: %lx, skb: %lx, skb->data: %lx,"
+					" dma_addr: %lx, dma_len %d\n", i, j,
+					(uintptr_t) (&rx_skb[i][j]),
+					(uintptr_t) rx_skb[i][j].skb,
+					(uintptr_t) skb->data,
+					(uintptr_t) (rx_skb[i][j].dma_addr),
+					rx_skb[i][j].dma_len);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			if (skb == NULL)
+				seq_printf(s,
+					"[%d][%d]: rx_skb: %x, skb: NULL\n", i,
+					j, (uint32)(&rx_skb[i][j]));
+			else
+				seq_printf(s,
+					"[%d][%d]: rx_skb: %x, skb: %x, skb->data: %x\n",
+					i, j, (uint32)(&rx_skb[i][j]),
+					(uint32)rx_skb[i][j].skb,
+					(uint32)skb->data);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTL_WTDOG)
+			rtl_periodic_watchdog_kick(j, WATCHDOG_NUM_OF_TIMES);
+#endif
+
+		}
+		seq_printf(s, "\n");
+	}
+}
+
+int32 New_swNic_init(uint32 userNeedRxPkthdrRingCnt[NEW_NIC_MAX_RX_DESC_RING],
+	uint32 userNeedTxPkthdrRingCnt[NEW_NIC_MAX_TX_DESC_RING],
+	uint32 clusterSize)
+{
+	uint32 i, j;
+	static uint32 totalRxPkthdrRingCnt = 0, totalTxPkthdrRingCnt = 0;
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	unsigned long flags = 0;
+	int ret = SUCCESS;
+	int _cpu_dcache_line = cpu_dcache_line_size();	/* in \arch\mips\include\asm\cpu-features.h */
+
+	SMP_LOCK_ETH_RECV(flags);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* 1. Allocate Rx descriptor rings */
+	if (New_rxDescRing[0] == NULL) {
+
+		size_of_cluster = clusterSize;
+		for (i = 0; i < NEW_NIC_MAX_RX_DESC_RING; i++) {
+			New_rxDescRingCnt[i] = userNeedRxPkthdrRingCnt[i];
+			if (New_rxDescRingCnt[i] == 0) {
+				New_rxDescRing[i] = NULL;
+				continue;
+			}
+#if defined(CONFIG_RTD_1295_HWNAT)
+			New_rxDescRing[i] =
+				(struct dma_rx_desc *) dma_alloc_coherent(&rtl819x_pdev->dev,
+				New_rxDescRingCnt[i] * sizeof(struct dma_rx_desc),
+				&New_rxDescRingPhyAddr[i], GFP_KERNEL);
+			ASSERT_CSP((uintptr_t) New_rxDescRing[i]);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			New_rxDescRing[i] =
+				(struct dma_rx_desc *) CACHED_MALLOC((New_rxDescRingCnt[i] + 1) * sizeof(struct dma_rx_desc));
+			ASSERT_CSP((uint32)New_rxDescRing[i] & 0x0fffffff);
+			New_rxDescRing[i] =
+				(struct dma_rx_desc *)(((uint32) New_rxDescRing[i] + (_cpu_dcache_line - 1)) & ~(_cpu_dcache_line - 1));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+			memset(New_rxDescRing[i], 0,
+				New_rxDescRingCnt[i] * sizeof(struct dma_rx_desc));
+
+			totalRxPkthdrRingCnt += New_rxDescRingCnt[i];
+
+			if (New_rxDescRingCnt[i]) {
+
+				/* rx_skb[i]=(struct ring_info *)UNCACHED_MALLOC(sizeof(struct ring_info)*New_rxDescRingCnt[i]); */
+				rx_skb[i] =
+					(struct ring_info *) CACHED_MALLOC(sizeof(struct ring_info) * New_rxDescRingCnt[i]);
+
+				if (!rx_skb[i]) {
+					goto err_out;
+				}
+				memset(rx_skb[i], 0,
+					New_rxDescRingCnt[i] * sizeof(struct ring_info));
+			}
+		}
+
+		if (totalRxPkthdrRingCnt == 0) {
+			goto err_out;
+		}
+
+		/* 2. Allocate Tx descriptor rings */
+		for (i = 0; i < NEW_NIC_MAX_TX_DESC_RING; i++) {
+			New_txDescRingCnt[i] = userNeedTxPkthdrRingCnt[i];
+
+			if (New_txDescRingCnt[i] == 0) {
+				New_txDescRing[i] = NULL;
+				continue;
+			}
+#if defined(CONFIG_RTD_1295_HWNAT)
+			New_txDescRing[i] =
+				(struct dma_tx_desc *) dma_alloc_coherent(&rtl819x_pdev->dev,
+				New_txDescRingCnt[i] * sizeof(struct dma_tx_desc),
+				&New_txDescRingPhyAddr[i], GFP_KERNEL);
+			ASSERT_CSP((uintptr_t) New_txDescRing[i]);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			New_txDescRing[i] =
+				(struct dma_tx_desc *) CACHED_MALLOC((New_txDescRingCnt[i]) *
+				sizeof(struct dma_tx_desc) +
+				(_cpu_dcache_line * 2));
+			ASSERT_CSP((uint32)New_txDescRing[i] & 0x0fffffff);
+			New_txDescRing[i] =
+				(struct dma_tx_desc *)(((uint32) New_txDescRing[i] + (_cpu_dcache_line - 1)) & ~(_cpu_dcache_line - 1));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+			memset(New_txDescRing[i], 0,
+				New_txDescRingCnt[i] * sizeof(struct dma_tx_desc));
+			totalTxPkthdrRingCnt += New_txDescRingCnt[i];
+
+			if (New_txDescRingCnt[i]) {
+
+				tx_skb[i] =
+					(struct ring_info *) CACHED_MALLOC(sizeof(struct ring_info) * New_txDescRingCnt[i]);
+				if (!tx_skb[i]) {
+					goto err_out;
+				}
+				memset(tx_skb[i], 0,
+					New_txDescRingCnt[i] * sizeof(struct ring_info));
+			}
+		}
+
+		if (totalTxPkthdrRingCnt == 0) {
+			goto err_out;
+		}
+	}
+#if defined(CONFIG_RTD_1295_HWNAT)
+	TxCDP_reg[0] = CPUTPDCR0;
+	TxCDP_reg[1] = CPUTPDCR1;
+	TxCDP_reg[2] = CPUTPDCR2;
+	TxCDP_reg[3] = CPUTPDCR3;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* Initialize index of Tx pkthdr descriptor */
+	for (i = 0; i < NEW_NIC_MAX_TX_DESC_RING; i++) {
+		New_txDescRing[i][New_txDescRingCnt[i] - 1].opts1 |= DESC_WRAP;
+		New_currTxPkthdrDescIndex[i] = 0;
+		New_txPktDoneDescIndex[i] = 0;
+#if defined(CONFIG_RTD_1295_HWNAT)
+		New_txDescRing_base[i] = (uintptr_t) New_txDescRingPhyAddr[i];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		New_txDescRing_base[i] =
+			((uint32)New_txDescRing[i]) | UNCACHE_MASK;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		REG32(TxCDP_reg[i]) = New_txDescRing_base[i];
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+		if (New_txDescRing[i] != NULL)
+			_dma_cache_wback_inv((unsigned long)New_txDescRing[i],
+				(unsigned long)(New_txDescRingCnt[i] * sizeof(struct dma_tx_desc)));
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	}
+
+	DBG(" New_txDescRingPhyAddr[0] = 0x%lx\n New_txDescRingPhyAddr[1] = 0x%lx\n"
+		" New_txDescRingPhyAddr[2] = 0x%lx\n New_txDescRingPhyAddr[3] = 0x%lx\n",
+		(uintptr_t) New_txDescRingPhyAddr[0],
+		(uintptr_t) New_txDescRingPhyAddr[1],
+		(uintptr_t) New_txDescRingPhyAddr[2],
+		(uintptr_t) New_txDescRingPhyAddr[3]);
+
+	/* Maximum TX packet header 0 descriptor entries.
+	 * the register only provide 16-bit for each tx ring,
+	 * this way (set TX_RING0_TAIL_AWARE bit) CAN NOT used when tx desc number is larger than 2730.
+	 */
+	REG32(DMA_CR1) = (New_txDescRingCnt[0] - 1) * (sizeof(struct tx_desc));
+	/* REG32(DMA_CR4) = TX_RING0_TAIL_AWARE; */
+
+	/* Initialize Rx packet header descriptors */
+	for (i = 0; i < NEW_NIC_MAX_RX_DESC_RING; i++) {
+		for (j = 0; j < New_rxDescRingCnt[i]; j++) {
+			void *skb;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+			struct sk_buff *skbp;
+			dma_addr_t mapping;
+
+			if (alloc_rx_buf((void **)&skb, clusterSize) > 0) {
+				skbp = (struct sk_buff *)skb;
+				mapping =
+					dma_map_single(&rtl819x_pdev->dev,
+					skbp->data, size_of_cluster,
+					DMA_FROM_DEVICE);
+				if (unlikely(dma_mapping_error(&rtl819x_pdev->dev, mapping))) {
+					DBG("Failed to map RX DMA memory!");
+					dev_kfree_skb_any(skbp);
+					return -1;
+				}
+				New_rxDescRing[i][j].addr = mapping;
+				rx_skb[i][j].dma_addr = mapping;
+				rx_skb[i][j].dma_len = size_of_cluster;
+
+			}
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			New_rxDescRing[i][j].addr =
+				(uint32)alloc_rx_buf((void **)&skb,
+				clusterSize);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+			/* todo: error check, if addr/skb = NULL, .... */
+#if defined(CONFIG_RTD_1295_HWNAT)
+			rx_skb[i][j].skb = (uintptr_t) skb;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			rx_skb[i][j].skb = (uint32)skb;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+			if (j == (New_rxDescRingCnt[i] - 1))
+				New_rxDescRing[i][j].opts1 =
+					(DESC_SWCORE_OWNED | DESC_WRAP |
+					(clusterSize << RD_M_EXTSIZE_OFFSET));
+			else
+				New_rxDescRing[i][j].opts1 =
+					(DESC_SWCORE_OWNED | (clusterSize << RD_M_EXTSIZE_OFFSET));
+#if defined(CONFIG_RTD_1295_HWNAT)
+			New_rxDescRing[i][j].opts5 |= DESC_SWCORE_OWNED2;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		}
+		/* Initialize index of current Rx pkthdr descriptor */
+		New_currRxPkthdrDescIndex[i] = 0;
+#if defined(CONFIG_RTD_1295_HWNAT)
+		New_rxDescRing_base[i] = (uintptr_t) New_rxDescRingPhyAddr[i];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		New_rxDescRing_base[i] =
+			((uint32)New_rxDescRing[i]) | UNCACHE_MASK;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		REG32(CPURPDCR(i)) = New_rxDescRing_base[i];
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+		if (New_rxDescRing[i] != NULL)
+			_dma_cache_wback_inv((unsigned long)New_rxDescRing[i],
+				(unsigned long)(New_rxDescRingCnt[i] * sizeof(struct dma_rx_desc)));
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	}
+
+	DBG(" New_rxDescRingPhyAddr[0] = 0x%lx\n New_rxDescRingPhyAddr[1] = 0x%lx\n"
+		" New_rxDescRingPhyAddr[2] = 0x%lx\n New_rxDescRingPhyAddr[3] = 0x%lx\n"
+		" New_rxDescRingPhyAddr[4] = 0x%lx\n New_rxDescRingPhyAddr[5] = 0x%lx\n",
+		(uintptr_t) New_rxDescRingPhyAddr[0],
+		(uintptr_t) New_rxDescRingPhyAddr[1],
+		(uintptr_t) New_rxDescRingPhyAddr[2],
+		(uintptr_t) New_rxDescRingPhyAddr[3],
+		(uintptr_t) New_rxDescRingPhyAddr[4],
+		(uintptr_t) New_rxDescRingPhyAddr[5]);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	return SUCCESS;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	SMP_UNLOCK_ETH_RECV(flags);
+	return ret;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+err_out:
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	SMP_UNLOCK_ETH_RECV(flags);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	return (-EINVAL);
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define	SET_OWN_BIT(desc) \
+	do { \
+		desc->rx_own = DESC_SWCORE_OWNED; \
+		desc->rx_own2 = DESC_SWCORE_OWNED; \
+	} while (0)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#define	SET_OWN_BIT(desc) \
+	(desc->rx_own = DESC_SWCORE_OWNED)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#define	INC_IDX(ring, idx) \
+	do { \
+		idx = NEXT_IDX(idx, New_rxDescRingCnt[ring]); \
+		New_currRxPkthdrDescIndex[ring]	= idx; \
+	} while (0)
+#define	REUSE_DESC() \
+	do { \
+		SET_OWN_BIT(desc); \
+		INC_IDX(ring_idx, rx_idx); \
+	} while (0)
+
+#if defined(CONFIG_RTL_HARDWARE_NAT) && defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+extern int extPortEnabled;
+
+__MIPS16 __IRAM_FWD
+	inline int32 New_rtl8651_rxPktPreprocess(void *pkt, uint16 *vid)
+{
+	struct rx_desc *desc = (struct rx_desc *)pkt;
+	uint32 srcPortNum = 0;
+
+	srcPortNum = desc->rx_spa;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	srcPortNum &= 0x7;
+#endif
+	*vid = desc->rx_dvlanid;
+
+	if (!extPortEnabled)
+		return SUCCESS;
+
+	if (srcPortNum < RTL8651_CPU_PORT) {
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+		/* rx from physical port */
+		if (extPortEnabled
+			&& ((desc->rx_dp_ext & PKTHDR_EXTPORTMASK_CPU) == 0)) {
+			/* No CPU bit, finished nat translation, only dest ext mbr port... */
+			/*
+			 * if dest ph_extPortList 0x1 => to dst ext port 1 => to dst port 1+5=6
+			 * if dest ph_extPortList 0x2 => to dst ext port 2 => to dst port 2+5=7
+			 * if dest ph_extPortList 0x4 => to dst ext port 3 => to dst port 3+5=8
+			 */
+			/* No CPU bit, only dest ext mbr port... */
+			if (desc->rx_dp_ext &&
+				(5 != extPortMaskToPortNum[desc->rx_dp_ext])) {
+#if defined(CONFIG_RTL_HARDWARE_NAT) && (defined(CONFIG_RTL8192SE) || defined(CONFIG_RTL8192CD))
+
+				/* panic_printk("extPortList:%d,srcPortNum:%d,isOriginal:%d,l2Trans:%d,fwd:%d,*vid=%d [%s]:[%d].\n", */
+				/* desc->rx_dp_ext,srcPortNum,desc->rx_org,desc->rx_l2act,desc->rx_fwd, *vid, __FUNCTION__,__LINE__); */
+				if (desc->rx_l2act != 0) {
+					/*wan-->ext port, finished napt translation */
+					*vid = PKTHDR_EXTPORT_MAGIC;
+#if 0
+					if (net_ratelimit())
+						panic_printk("extPortList:%d,srcPortNum:%d,isOriginal:%d,l2Trans:%d,fwd:%d,*vid=%d [%s]:[%d].\n",
+							desc->rx_dp_ext,
+							srcPortNum,
+							desc->rx_org,
+							desc->rx_l2act,
+							desc->rx_fwd, *vid,
+							__FUNCTION__, __LINE__);
+#endif
+				}
+#endif
+			} else {
+				/*no dst ext port */
+				/*drop it */
+#if 0
+				if (net_ratelimit())
+					panic_printk("extPortList:%d,srcPortNum:%d,isOriginal:%d,l2Trans:%d,fwd:%d,*vid=%d [%s]:[%d].\n",
+						desc->rx_dp_ext, srcPortNum,
+						desc->rx_org, desc->rx_l2act,
+						desc->rx_fwd, *vid,
+						__FUNCTION__, __LINE__);
+#endif
+				return FAILED;
+			}
+		}
+		/*to-do:mark it */
+		else {
+			/* has CPU bit, pkt is original pkt from port 0~5 */
+			/*original packet, let prototocol stack to handle it */
+
+		}
+
+#endif
+	} else {
+		/*rx from extension port */
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+		/*to-do: */
+		if (extPortEnabled) {
+			if ((desc->rx_dp_ext & PKTHDR_EXTPORTMASK_CPU) == 0) {
+
+				/* No CPU bit, finished nat translation, only dest ext mbr port... */
+				/*
+				 * if dest ph_extPortList 0x1 => to dst ext port 1 => to dst port 1+5=6
+				 * if dest ph_extPortList 0x2 => to dst ext port 2 => to dst port 2+5=7
+				 * if dest ph_extPortList 0x4 => to dst ext port 3 => to dst port 3+5=8
+				 */
+				if (desc->rx_dp_ext &&
+					(5 != extPortMaskToPortNum[desc->rx_dp_ext])) {
+#if defined(CONFIG_RTL_HARDWARE_NAT) && (defined(CONFIG_RTL8192SE) || defined(CONFIG_RTL8192CD))
+					/*WISP mode ext port-->ext port, finished napt translation */
+					/* *vid = PKTHDR_EXTPORT_MAGIC2; */
+#if 0
+					if (net_ratelimit())
+						panic_printk("extPortList:%d,srcPortNum:%d,isOriginal:%d,l2Trans:%d,fwd:%d,*vid=%d [%s]:[%d].\n",
+							desc->rx_dp_ext,
+							srcPortNum,
+							desc->rx_org,
+							desc->rx_l2act,
+							desc->rx_fwd, *vid,
+							__FUNCTION__, __LINE__);
+#endif
+					/*drop it, may fix me in future */
+					return FAILED;
+#endif
+				} else {
+					/*no dst ext port */
+					/*drop it */
+#if 0
+					if (net_ratelimit())
+						panic_printk("extPortList:%d,srcPortNum:%d,isOriginal:%d,l2Trans:%d,fwd:%d,*vid=%d [%s]:[%d].\n",
+							desc->rx_dp_ext,
+							srcPortNum,
+							desc->rx_org,
+							desc->rx_l2act,
+							desc->rx_fwd, *vid,
+							__FUNCTION__, __LINE__);
+#endif
+					return FAILED;
+				}
+
+			} else {
+				/* has CPU bit, pkt is original pkt from port 6~8 */
+				/*case 1: not finished napt translation, need roll back interface to wlan ext interface */
+
+#if defined(CONFIG_RTL_HARDWARE_NAT) && (defined(CONFIG_RTL8192SE) || defined(CONFIG_RTL8192CD))
+				*vid = PKTHDR_EXTPORT_MAGIC4;
+				/* srcPortNum = extPortMaskToPortNum[desc->rx_extspa]; */
+				srcPortNum = desc->rx_extspa + 5;
+				desc->rx_spa = srcPortNum;
+#if 0
+				if (net_ratelimit())
+					panic_printk("extPortList:%d,srcPortNum:%d,isOriginal:%d,l2Trans:%d,fwd:%d,*vid=%d desc->rx_extspa=%d [%s]:[%d].\n",
+						desc->rx_dp_ext, srcPortNum,
+						desc->rx_org, desc->rx_l2act,
+						desc->rx_fwd, *vid,
+						desc->rx_extspa, __FUNCTION__,
+						__LINE__);
+#endif
+				/*drop it, may fix me in future */
+				return SUCCESS;
+#endif
+			}
+		} else {
+#if 0
+			if (net_ratelimit())
+				panic_printk("extPortList:%d,desc->rx_extspa:%d, srcPortNum:%d,isOriginal:%d,l2Trans:%d,fwd:%d,*vid=%d [%s]:[%d].\n",
+					desc->rx_dp_ext, desc->rx_extspa,
+					srcPortNum, desc->rx_org,
+					desc->rx_l2act, desc->rx_fwd, *vid,
+					__FUNCTION__, __LINE__);
+#endif
+			return FAILED;
+		}
+
+#else
+		return FAILED;
+#endif
+
+	}
+
+	return SUCCESS;
+}
+#endif
+
+int32 New_swNic_receive(rtl_nicRx_info *info, int retryCount)
+{
+	uint32 rx_idx, ring_idx;
+	struct sk_buff *r_skb;
+	struct rx_desc *desc;
+	unsigned char *buf;
+	void *skb;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	struct sk_buff *skbp;
+	dma_addr_t mapping;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTL_HARDWARE_NAT) && defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	uint16 vid;
+#endif
+
+#ifdef USE_SWITCH_RX_CDP
+	uint32 cdp_value;
+	int hw_idx;
+#endif
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if !defined(CONFIG_SMP)
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_RECV(flags);
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(RTL_MULTIPLE_RX_TX_RING)
+	for (ring_idx = (NEW_NIC_MAX_RX_DESC_RING - 1); ring_idx >= (info->priority); ring_idx--)
+#else
+	for (ring_idx = 0; ring_idx < 1; ring_idx++)
+#endif
+	{
+get_next:
+		rx_idx = New_currRxPkthdrDescIndex[ring_idx];
+
+#ifdef USE_SWITCH_RX_CDP
+		cdp_value = REG32(CPURPDCR(ring_idx));
+		hw_idx = (cdp_value - New_rxDescRing_base[ring_idx]) / sizeof(struct dma_rx_desc);
+		if (rx_idx == hw_idx) {	/* no incoming pkt or Rx desc runout */
+			/* check runout case */
+			desc = (struct rx_desc *) &New_rxDescRing[ring_idx][rx_idx];
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+			if (desc->rx_own || desc->rx_own2)	/* 1: SWCORE owned */
+				continue;	/* go for next rx ring */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			desc = (struct rx_desc *)(((uint32)desc) |
+				UNCACHE_MASK);
+			if (desc->rx_own)	/* SWCORE owned */
+				/* end of "check runout case" */
+				continue;	/* go for next rx ring */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		}
+#endif
+
+		desc = (struct rx_desc *)&New_rxDescRing[ring_idx][rx_idx];
+
+		/* NEEDED, do not removed. when previous interrupt_dsr_rx() is finished, */
+		/* the New_rxDescRing[ring_idx][rx_idx] has been read, and found "no more packet", */
+		/* so its address is cached. */
+		/* if _dma_cache_inv() removed, and one packet come in, read the desc and it own bit */
+		/* is still SWCORE owned. */
+		/* TODO: need to test, remove this one, and add _dma_cache_inv to the next IF (own bit is SWCORE owned) */
+
+		/* todo: in FPGA, when rx_desc use cacheable and do _dma_cache_inv, the rx ring will abnormal */
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#ifdef _DESC_CACHE_ACCESS_RX
+		_dma_cache_inv((unsigned long)desc, sizeof(struct dma_rx_desc));
+#else
+		desc = (struct rx_desc *)(((uint32)desc) | UNCACHE_MASK);
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+#ifndef	USE_SWITCH_RX_CDP
+		/* 1.check desc's own bit */
+#if defined(CONFIG_RTD_1295_HWNAT)
+		if (desc->rx_own || desc->rx_own2)	/* 1: SWCORE owned */
+		{
+			continue;	/* go for next rx ring */
+		}
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		if (desc->rx_own)	/* 1: SWCORE owned */
+		{
+			continue;	/* go for next rx ring */
+		}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+		#if defined(CONFIG_RTL_JUMBO_FRAME)
+		if (!(desc->rx_ls) || !(desc->rx_fs))
+		{
+			#if !defined(CONFIG_RTD_1295_HWNAT)
+			#ifdef _DESC_CACHE_ACCESS_RX
+			desc = (struct rx_desc *)(((uint32)desc) |	UNCACHE_MASK);
+			#endif
+			#endif /* !CONFIG_RTD_1295_HWNAT */
+			REUSE_DESC();
+			goto get_next;
+		}
+		#endif
+
+		/* if checksum failed, reuse this desc, except the ipv6 ready logo case. */
+		if (!(desc->rx_l3csok) || !(desc->rx_l4csok)) {
+#ifdef CONFIG_RTL_IPV6READYLOGO
+			if (!(!(desc->rx_l4csok) &&
+				(desc->rx_ipv6) && (desc->rx_reason == 0x60)))
+#endif
+			{
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#ifdef _DESC_CACHE_ACCESS_RX
+				desc = (struct rx_desc *)(((uint32)desc) |
+					UNCACHE_MASK);
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+				REUSE_DESC();
+				goto get_next;
+			}
+		}
+		DBG("rx desc = &New_rxDescRing[ring_idx %d][rx_idx %d], "
+			"addr 0x%x, opts1 0x%x, opts2 0x%x, opts3 0x%x, opts4 0x%x, opts5 0x%x",
+			ring_idx, rx_idx, desc->mdata, desc->opts1.dw,
+			desc->opts2.dw, desc->opts3.dw, desc->opts4.dw,
+			desc->opts5.dw);
+
+		/* porting from swNic_receive(), need or not ?? */
+#if 0				/* defined(CONFIG_RTL_HARDWARE_NAT) */
+		if (desc->rx_spa >= RTL8651_CPU_PORT) {
+#ifdef _DESC_CACHE_ACCESS_RX
+			desc = (struct rx_desc *)(((uint32)desc) |
+				UNCACHE_MASK);
+#endif
+			REUSE_DESC();
+			goto get_next;
+		}
+#endif
+
+		/* 2.rx skb */
+		r_skb = (struct sk_buff *)(rx_skb[ring_idx][rx_idx].skb);
+		if (r_skb == NULL) {	/* should not happen */
+			/* todo: may call alloc_rx_buf() to get a new skb,.... */
+			/* printk("ETH_ERR: skb_array[%d][%d] is NULL\n",ring_idx,rx_idx); */
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#ifdef _DESC_CACHE_ACCESS_RX
+			desc = (struct rx_desc *)(((uint32)desc) |
+				UNCACHE_MASK);
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+			REUSE_DESC();
+			goto get_next;
+		}
+		/* 3.alloc new rx skb */
+		buf = alloc_rx_buf(&skb, size_of_cluster);
+		if (buf) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+			skbp = (struct sk_buff *)skb;
+			mapping =
+				dma_map_single(&rtl819x_pdev->dev, skbp->data,
+				size_of_cluster, DMA_FROM_DEVICE);
+			if (unlikely(dma_mapping_error(&rtl819x_pdev->dev,
+						mapping))) {
+				DBG("Failed to map RX DMA memory!");
+				dev_kfree_skb_any(skbp);
+				return RTL_NICRX_NULL;
+			}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+			/* update to info struct */
+			/* info->priority = ring_idx; // todo */
+			info->vid = desc->rx_dvlanid;
+			info->pid = desc->rx_spa;
+			info->rxPri = desc->rx_dpri;
+			info->input = (void *)r_skb;
+			info->len = desc->rx_len - 4;
+			/* todo, update the     other field: priority, ... */
+#if defined(CONFIG_RTL_HARDWARE_NAT) && defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+			if (New_rtl8651_rxPktPreprocess((void *)desc,
+					&vid) != SUCCESS) {
+				/* panic_printk("%s %d info->vid=0x%x \n", __FUNCTION__, __LINE__, info->vid); */
+#ifdef _DESC_CACHE_ACCESS_RX
+				desc = (struct rx_desc *)(((uint32)desc) |
+					UNCACHE_MASK);
+#endif
+				REUSE_DESC();
+				goto get_next;
+			}
+			info->vid = vid;
+#endif
+
+			/* after enable Rx scatter gather feature (0xb80100a4 bit5 cf_rx_gather = 1),
+			 * the mdata of second/third/... pkthdr will be updated to 4-byte alignment by hardware.
+			 */
+#if defined(CONFIG_RTD_1295_HWNAT)
+			DBG("info vid %d, pid %d, rxPri %d, len %d\n", info->vid, info->pid, info->rxPri, info->len);
+			DBG("rx_skb[ring_idx %d][rx_idx %d] = 0x%lx, data = 0x%lx, len = %d", ring_idx, rx_idx, (uintptr_t) r_skb, (uintptr_t) r_skb->data, desc->rx_len);
+			//rtl_dump_data(r_skb->data, 64);
+			//DBG("rx_skb[ring_idx][rx_idx].dma_addr 0x%lx, desc->addr 0x%lx", (uintptr_t) rx_skb[ring_idx][rx_idx].dma_addr, (uintptr_t) desc->mdata);
+
+			/* unmap received skb from DMA */
+			dma_unmap_single(&rtl819x_pdev->dev,
+				rx_skb[ring_idx][rx_idx].dma_addr,
+				rx_skb[ring_idx][rx_idx].dma_len,
+				DMA_FROM_DEVICE);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			r_skb->data = (unsigned char *)(desc->mdata);
+
+			/* should remove this note ?? */
+			/* 2015-11-13, since 8198C has a WAN to WLAN throughput low issue (branch 3.4 rev. 34320).
+			 * we do the _dma_cache_inv after allocate a new skb, instead of after packet received.
+			 * David's suggestion: in 8197F and New descriptor architecture, also apply this change.
+			 * so _dma_cache_inv is move down.
+			 */
+			/* _dma_cache_inv((unsigned long)r_skb->data, r_skb->len); */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+			/* 4.hook */
+#if defined(CONFIG_RTD_1295_HWNAT)
+			rx_skb[ring_idx][rx_idx].skb = (uintptr_t) skb;
+
+			rx_skb[ring_idx][rx_idx].dma_addr = mapping;
+			rx_skb[ring_idx][rx_idx].dma_len = size_of_cluster;
+			desc->mdata = mapping;
+
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			rx_skb[ring_idx][rx_idx].skb = (uint32)skb;
+
+#ifdef _DESC_CACHE_ACCESS_RX
+			/* desc->addr = (uint32)buf; */
+			/* _dma_cache_wback_inv((unsigned long)desc,sizeof(struct dma_rx_desc)); */
+			desc = (struct rx_desc *)(((uint32)desc) |
+				UNCACHE_MASK);
+			desc->mdata = (uint32)buf;
+#else
+			desc->mdata = (uint32)buf;
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+			/* 2015-11-13, see the comment above. */
+			_dma_cache_inv((unsigned long)((struct sk_buff *)skb)->
+				data, 1536);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+			/* 5.set own bit, move down */
+			SET_OWN_BIT(desc);
+
+			/* 6. increase rx index */
+			INC_IDX(ring_idx, rx_idx);
+
+			REG32(CPUIISR) = (PKTHDR_DESC_RUNOUT_IP_ALL);
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if !defined(CONFIG_SMP)
+			SMP_UNLOCK_ETH_RECV(flags);
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+			return RTL_NICRX_OK;
+		} else {
+			/* just leave this packet in rx desc */
+			/* do not change own_bit and rx_index */
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+			rx_noBuffer_cnt++;
+#endif
+
+#if	defined(CONFIG_RTL_ETH_PRIV_SKB)
+			/* printk("ETH_ERR: no private skb buffer\n"); */
+#else
+			/* printk("ETH_ERR: kernel allocate skb failed\n"); */
+#endif
+
+			REG32(CPUIISR) = (PKTHDR_DESC_RUNOUT_IP_ALL);
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if !defined(CONFIG_SMP)
+			SMP_UNLOCK_ETH_RECV(flags);
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+			return RTL_NICRX_NULL;
+		}
+	}
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if !defined(CONFIG_SMP)
+	SMP_UNLOCK_ETH_RECV(flags);
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	return (RTL_NICRX_NULL);
+}
+
+static inline void fill_txd_misc(struct tx_desc *txd, rtl_nicTx_info *nicTx,
+	struct sk_buff *skb)
+{
+	/* extract from _swNic_send, purpose: keep a function shortly and easy to read */
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT) || defined(CONFIG_RTK_VOIP_QOS)
+	txd->tx_dpri = nicTx->priority;
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if (*((unsigned short *)(skb->data + ETH_ALEN * 2)) !=
+		htons(ETH_P_8021Q))
+		txd->tx_vlantag = nicTx->tagport;
+	else
+		txd->tx_vlantag = 0;
+#endif
+
+#if defined(CONFIG_RTL_VLAN_8021Q) || defined(CONFIG_SWCONFIG)
+	if (*((unsigned short *)(skb->data + ETH_ALEN * 2)) !=
+		htons(ETH_P_8021Q)) {
+#if defined(CONFIG_RTL_8021Q_VLAN_SUPPORT_SRC_TAG)
+		extern int rtl865x_curOpMode;
+
+		if (rtl865x_curOpMode == 0)
+			txd->tx_vlantag =
+				RTL_WANPORT_MASK & rtk_get_vlan_tagmask(txd->
+				tx_dvlanid);
+		else
+			txd->tx_vlantag =
+				0x3f & rtk_get_vlan_tagmask(txd->tx_dvlanid);
+#else
+		txd->tx_vlantag = 0x3f & rtk_get_vlan_tagmask(txd->tx_dvlanid);
+#endif
+	} else
+		txd->tx_vlantag = 0;
+
+#if defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	if (gHwNatEnabled == 0)
+#endif
+	{
+		if (txd->tx_dp == RTL_WANPORT_MASK
+			&& (txd->tx_vlantag & RTL_WANPORT_MASK)) {
+			if (skb->srcVlanPriority >= 0
+				&& skb->srcVlanPriority <= 7)
+				txd->tx_dpri = skb->srcVlanPriority;
+		}
+	}
+#endif
+
+#elif defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+	if (*((unsigned short *)(skb->data + ETH_ALEN * 2)) !=
+		htons(ETH_P_8021Q)) {
+#ifdef	CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+#ifdef CONFIG_RTL_8367R_SUPPORT
+		rtk_get_real_nicTxVid(skb, &nicTx->vid);
+		txd->tx_dvlanid = nicTx->vid;
+#endif
+		txd->tx_vlantag =
+			(0x3f & rtk_getTagPortmaskByVid(nicTx->vid,
+				(void *)skb->data));
+#else
+		txd->tx_vlantag = auto_set_tag_portmask;
+#endif
+	} else
+		txd->tx_vlantag = 0;
+#endif
+}
+
+static inline void fill_txd_tso(struct tx_desc *txd, char *data)
+{
+	/* TODO:
+	 * check dev->features's NETIF_F_IP_CSUM_BIT/NETIF_F_IPV6_CSUM_BIT/NETIF_F_HW_CSUM_BIT
+	 * bits(set in  re865x_probe), if true then     set     these 2 bits of the     Tx pktHdr,
+	 * NOT  always set.
+	 *
+	 * due  to we enable NETIF_F_IP_CSUM_BIT/NETIF_F_IPV6_CSUM_BIT/NETIF_F_HW_CSUM_BIT bits
+	 * of dev->features in  re865x_probe(), so we must enable hardware L3/L4 checksum offload feature.
+	 */
+	uint16 type = htons(*(uint16 *)(data + 12));
+
+	txd->tx_l4cs = 1;
+	txd->tx_l3cs = 1;
+
+	/* TODO: the type is listed     ?? vi/li/pi/... need to be checked */
+	if (type == ETH_P_IPV6) {
+		txd->tx_type = PKTHDR_IPV6;
+		txd->tx_ipv6 = 1;
+	} else if (type == ETH_P_IP) {
+		struct iphdr *iph;
+
+		iph = (struct iphdr *)(data + 14);
+
+		if (iph->protocol == IPPROTO_TCP)
+			txd->tx_type = PKTHDR_TCP;
+		else if (iph->protocol == IPPROTO_UDP)
+			txd->tx_type = PKTHDR_UDP;
+		else if (iph->protocol == IPPROTO_ICMP)
+			txd->tx_type = PKTHDR_ICMP;
+		else if (iph->protocol == IPPROTO_IGMP)
+			txd->tx_type = PKTHDR_IGMP;
+		else
+			txd->tx_type = PKTHDR_IP;
+		txd->tx_ipv4 = 1;
+		txd->tx_ipv4_1st = 1;
+	} else {
+		txd->tx_type = PKTHDR_ETHERNET;
+	}
+}
+
+static inline uint32 *dw_copy(uint32 *dest, uint32 *src, int cnt)
+{
+	int i;
+	uint32 *org_dest;
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	dest = (uint32 *)(((uint32)dest) | UNCACHE_MASK);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	org_dest = dest;
+	for (i = 0; i < cnt; i++)
+		*dest++ = *src++;
+	return (org_dest);
+}
+
+#if defined(CONFIG_RTL_97F_HW_TX_CSUM) && defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+
+/*
+*  details please refer rtl865x_swNic.c function get_protocol_type
+*  currently, parse packets incomplete.......please fixed me ?
+*/
+static inline int parse_pkt(struct tx_desc *txd, rtl_nicTx_info *nicTx,
+	struct sk_buff *skb)
+{
+	struct iphdr *iph = NULL;
+
+#ifdef CONFIG_IPV6
+	uint8 cur_proto = 0;
+	uint8 next_header = 0;
+#endif
+
+	if ((*(int16 *)(skb->data + (ETH_ALEN << 1))) == (int16)htons(ETH_P_IP)) {
+		iph = (struct iphdr *)(skb->data + (ETH_ALEN << 1) + 2);
+	} else if (((*(int16 *)(skb->data + (ETH_ALEN << 1))) ==
+			(int16)htons(ETH_P_PPP_SES))
+		|| ((*(int16 *)(skb->data + (ETH_ALEN << 1))) ==
+			(int16)htons(ETH_P_PPP_DISC))) {
+		txd->tx_pi = 1;
+		if (*(int16 *)(skb->data + (ETH_ALEN << 1) + 8) ==
+			(int16)htons(0x0021)) {
+			iph = (struct iphdr *)(skb->data + (ETH_ALEN << 1) +
+				10);
+		}
+#ifdef CONFIG_IPV6
+		else if (*(int16 *)(skb->data + (ETH_ALEN << 1) + 8) ==
+			(int16)htons(0x0057)) {
+			next_header =
+				*(uint8 *)(skb->data + (ETH_ALEN << 1) + 8 + 2 + 6);
+			cur_proto = PKTHDR_IPV6;
+		}
+#endif
+
+	} else if ((*(int16 *)(skb->data + (ETH_ALEN << 1))) ==
+		(int16)htons(ETH_P_8021Q)) {
+		txd->tx_vi = 1;
+		if ((*(int16 *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN)) ==
+			(int16)htons(ETH_P_IP)) {
+			iph = (struct iphdr *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN + 2);
+		}
+#ifdef CONFIG_IPV6
+		else if (*(int16 *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN) ==
+			(int16)htons(ETH_P_IPV6)) {
+			next_header =
+				*(uint8 *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN + 2 + 6);
+			cur_proto = PKTHDR_IPV6;
+		}
+#endif
+		else if (((*(int16 *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN)) == (int16)htons(ETH_P_PPP_SES))
+			|| ((*(int16 *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN)) == (int16)htons(ETH_P_PPP_DISC))) {
+			txd->tx_pi = 1;
+			if ((*(int16 *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN + 8)) ==
+				(int16)htons(0x0021)) {
+				iph = (struct iphdr *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN + 8 + 2);
+			}
+#ifdef CONFIG_IPV6
+			else if ((*(int16 *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN + 8)) ==
+				(int16)htons(0x0057)) {
+				next_header =
+					*(uint8 *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN + 8 + 2 + 6);
+				cur_proto = PKTHDR_IPV6;
+			}
+#endif
+		}
+
+	}
+#ifdef CONFIG_IPV6
+	else if (*(int16 *)(skb->data + (ETH_ALEN << 1)) ==
+		(int16)htons(ETH_P_IPV6)) {
+		next_header = *(uint8 *)(skb->data + (ETH_ALEN << 1) + 2 + 6);
+		cur_proto = PKTHDR_IPV6;
+	}
+
+	if (cur_proto) {
+		txd->tx_ipv6 = 1;
+
+		if (next_header == IPPROTO_TCP)
+			txd->tx_type = PKTHDR_TCP;
+		else if (next_header == IPPROTO_UDP)
+			txd->tx_type = PKTHDR_UDP;
+		else if (next_header == IPPROTO_ICMP)
+			txd->tx_type = PKTHDR_ICMP;
+		else if (next_header == IPPROTO_IGMP)
+			txd->tx_type = PKTHDR_IGMP;
+		else if (next_header == IPPROTO_GRE)
+			txd->tx_type = PKTHDR_PPTP;
+		else
+			txd->tx_type = PKTHDR_IPV6;
+
+		return 0;
+	}
+#endif
+
+	if (iph) {
+		txd->tx_ipv4 = 1;
+		txd->tx_ipv4_1st = 1;
+
+		if (iph->protocol == IPPROTO_TCP) {
+			txd->tx_type = PKTHDR_TCP;
+		} else if (iph->protocol == IPPROTO_UDP) {
+			txd->tx_type = PKTHDR_UDP;
+		} else if (iph->protocol == IPPROTO_ICMP) {
+			txd->tx_type = PKTHDR_ICMP;
+		} else if (iph->protocol == IPPROTO_IGMP) {
+			txd->tx_type = PKTHDR_IGMP;
+		} else if (iph->protocol == IPPROTO_GRE) {
+			txd->tx_type = PKTHDR_PPTP;
+		} else {
+			txd->tx_type = PKTHDR_IP;
+		}
+	} else
+		txd->tx_type = PKTHDR_ETHERNET;
+
+	return 0;
+}
+#endif
+
+static inline int get_protocol_type_new_desc(struct sk_buff *skb,
+	struct tx_desc *txd)
+{
+
+	if (*(int16 *)(skb->data + 12) == (int16)htons(ETH_P_IP)) {
+		return PKTHDR_TCP;
+	} else if ((*(int16 *)(skb->data + 12) == (int16)htons(ETH_P_PPP_SES))
+		|| (*(int16 *)(skb->data + 12) ==
+			(int16)htons(ETH_P_PPP_DISC))) {
+		txd->tx_pi = 1;
+		if (*(int16 *)(skb->data + 12 + 8) == (int16)htons(0x0021)) {
+			return PKTHDR_TCP;
+		} else if (*(int16 *)(skb->data + 12 + 8) ==
+			(int16)htons(0x0057)) {
+			txd->tx_ipv6 = 1;
+			return PKTHDR_IPV6;
+		} else {
+			return PKTHDR_ETHERNET;
+		}
+	} else if (*(int16 *)(skb->data + 12) == (int16)htons(ETH_P_8021Q)) {
+		txd->tx_vi = 1;
+		if (*(int16 *)(skb->data + 12 + 4) == (int16)htons(ETH_P_IP)) {
+			return PKTHDR_TCP;
+		} else if (*(int16 *)(skb->data + 12 + 4) ==
+			(int16)htons(ETH_P_IPV6)) {
+			txd->tx_ipv6 = 1;
+			return PKTHDR_IPV6;
+		} else if ((*(int16 *)(skb->data + 12 + 4) ==
+				(int16)htons(ETH_P_PPP_SES))
+			|| (*(int16 *)(skb->data + 12 + 4) ==
+				(int16)htons(ETH_P_PPP_DISC))) {
+			txd->tx_pi = 1;
+			if (*(int16 *)(skb->data + 12 + 4 + 8) ==
+				(int16)htons(0x0021)) {
+				return PKTHDR_TCP;
+			} else if (*(int16 *)(skb->data + 12 + 4 + 8) ==
+				(int16)htons(0x0057)) {
+				txd->tx_ipv6 = 1;
+				return PKTHDR_IPV6;
+			} else
+				return PKTHDR_ETHERNET;
+		}
+
+		else {
+			return PKTHDR_ETHERNET;
+		}
+	} else if (*(int16 *)(skb->data + 12) == (int16)htons(ETH_P_IPV6)) {
+		txd->tx_ipv6 = 1;
+		return PKTHDR_IPV6;
+	} else
+		return PKTHDR_ETHERNET;
+}
+
+/*************************************************************************
+*	FUNCTION
+*		_New_swNic_send
+*
+*	DESCRIPTION
+*		This function writes one packet	to tx descriptors, and waits until
+*		the	packet is successfully sent.
+*
+*	INPUTS
+*		None
+*
+*	OUTPUTS
+*		None
+*************************************************************************/
+
+int32 _New_swNic_send(void *skb, void *output, uint32 len,
+	rtl_nicTx_info *nicTx)
+{
+
+	uint32 tx_idx, ret = SUCCESS;
+	struct tx_desc *txd;
+	uint32 next_index;
+
+	DBG("skb 0x%p, len %d\n", skb, len);
+/* startCP3Ctrl(PERF_EVENT_CYCLE); //added for romperf testing */
+	tx_idx = New_currTxPkthdrDescIndex[nicTx->txIdx];
+
+	next_index = NEXT_IDX(tx_idx, New_txDescRingCnt[nicTx->txIdx]);
+
+	if (next_index == New_txPktDoneDescIndex[nicTx->txIdx]) {
+		/* TX ring full */
+/* stopCP3Ctrl(1, 0);      //added for romperf testing */
+		DBG("check\n");
+		return (FAILED);
+	}
+#ifdef _LOCAL_TX_DESC
+	txd = &local_txd;
+#else
+	txd = (struct tx_desc *)&New_txDescRing[nicTx->txIdx][tx_idx];
+	/* txd should NOT be NULL, otherwise .... */
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#ifndef	_DESC_CACHE_ACCESS_TX
+	txd = (struct tx_desc *)(((uint32)txd) | UNCACHE_MASK);
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+	memset((void *)txd, 0, sizeof(struct tx_desc));
+	/* store the skb pointer for New_swNic_txDone later */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	tx_skb[nicTx->txIdx][tx_idx].skb = (uintptr_t) skb;
+	tx_skb[nicTx->txIdx][tx_idx].dma_addr = (dma_addr_t) output;
+	tx_skb[nicTx->txIdx][tx_idx].dma_len = len;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	tx_skb[nicTx->txIdx][tx_idx].skb = (uint32)skb;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* Pad small packets and hardware will add CRC */
+	if (len < 60)
+		len = 64;
+	else
+		len += 4;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	txd->mdata = ((uintptr_t) output);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	txd->mdata = ((uint32)output);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* do not need to set tail bit after we use DMA_CR1/DMA_CR4 register */
+	if (tx_idx == (New_txDescRingCnt[nicTx->txIdx] - 1))
+		txd->tx_eor = 1;
+	txd->tx_ls = 1;
+	txd->tx_fs = 1;
+	txd->tx_ph_len = len;
+	txd->tx_mlen = len;
+	txd->tx_dvlanid = nicTx->vid;
+	txd->tx_dp = nicTx->portlist;
+
+#ifdef CONFIG_RTL_97F_HW_TX_CSUM
+	/* due to we enable NETIF_F_HW_CSUM in dev->features,
+	 * we need to enable HW Tx CSUM if ip_summed = CHECKSUM_PARTIAL.
+	 * TODO: if this pkt need to do HW Tx CSUM and it is sent to wan interface,
+	 * how can it work?
+	 */
+	if (((struct sk_buff *)skb)->ip_summed == CHECKSUM_PARTIAL) {
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+		/* broadcast and multicast packets using direct tx do hw tx csum
+		 */
+		if ((extPortEnabled)
+			&& ((((struct sk_buff *)skb)->data[0]) & 0x1)) {
+			parse_pkt(txd, nicTx, (struct sk_buff *)skb);
+
+		} else {
+			nicTx->flags |= PKTHDR_HWLOOKUP;
+		}
+#else
+		nicTx->flags |= PKTHDR_HWLOOKUP;
+#endif
+
+		txd->tx_l4cs = 1;
+		txd->tx_l3cs = 1;
+	}
+#endif
+
+	if ((nicTx->flags & PKTHDR_HWLOOKUP) != 0) {
+		txd->tx_hwlkup = 1;
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+		if (nicTx->flags & PKTHDR_BRIDGING)
+			txd->tx_bridge = 1;
+		else
+			txd->tx_bridge = 0;
+#else
+		txd->tx_bridge = 1;
+#endif
+		txd->tx_extspa = PKTHDR_EXTPORT_LIST_CPU;
+	}
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT) || defined(CONFIG_RTK_VOIP_QOS) || defined(CONFIG_RTK_VLAN_WAN_TAG_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q) ||	defined(CONFIG_RTL_HW_VLAN_SUPPORT) || defined(CONFIG_SWCONFIG)
+	fill_txd_misc(txd, nicTx, (struct sk_buff *)skb);
+#endif
+
+	DBG("txd dp 0x%x, mlen %d, dvlanid %d, hwlkup %d, bridge %d, extspa %d\n",
+		txd->tx_dp, txd->tx_mlen, txd->tx_dvlanid, txd->tx_hwlkup,
+		txd->tx_bridge, txd->tx_extspa);
+	//rtl_dump_data(((struct sk_buff *)skb)->data, 64);
+#ifdef _LOCAL_TX_DESC
+	txd = (struct tx_desc *)dw_copy((uint32 *)&New_txDescRing[nicTx->txIdx][tx_idx], (uint32 *)txd,
+		sizeof(struct tx_desc) / 4);
+#else
+#if defined(CONFIG_RTD_1295_HWNAT)
+	sync_tx_data_for_device((dma_addr_t) output,
+		((struct sk_buff *)skb)->len);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	/* note: cache_wback of output data has been done in caller */
+#ifdef _DESC_CACHE_ACCESS_TX
+	_dma_cache_wback((unsigned long)txd,
+		(unsigned long)sizeof(struct tx_desc));
+	txd = (struct tx_desc *)(((uint32)txd) | UNCACHE_MASK);
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+	wmb();
+	DBG("ready\n");
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	txd->tx_own = 1;	/* set     own     bit     after all done. */
+
+	New_currTxPkthdrDescIndex[nicTx->txIdx] = next_index;
+
+	/* Set TXFD     bit     to start transmission */
+	REG32(CPUICR) |= TXFD;
+
+	/* stopCP3Ctrl(1, 0);      //added for romperf testing */
+	return ret;
+}
+
+#if (defined(CONFIG_RTL_TSO) || defined(CONFIG_RTL_GSO))
+inline uint8 find_L3L4_hdr_len(struct sk_buff *skb, uint8 *L4_hdr_len)
+{
+	struct iphdr *iph;
+	struct tcphdr *tcph;
+	uint8 *ptr, L3_hdr_len = 5;
+
+	ptr = skb->data + 12;
+
+	if (*(int16 *)(ptr) == (int16)htons(ETH_P_8021Q))
+		ptr = skb->data + 16;
+
+	if (*(int16 *)(ptr) == (int16)htons(ETH_P_IP)) {
+		/* ipv4 */
+		iph = (struct iphdr *)(ptr + 2);
+		L3_hdr_len = iph->ihl;
+
+		if (iph->protocol == IPPROTO_TCP) {
+			tcph = (void *)iph + iph->ihl * 4;
+			*L4_hdr_len = tcph->doff;
+		}
+	}
+#ifdef CONFIG_IPV6
+	else if (*(int16 *)(ptr) == (int16)htons(ETH_P_IPV6)) {
+		if (*(ptr + 2 + 6) == IPPROTO_TCP) {
+			tcph = (struct tcphdr *)(ptr + 2 + 40);
+			*L4_hdr_len = tcph->doff;
+		}
+	}
+#endif
+	return (L3_hdr_len);
+}
+
+int32 _New_swNic_send_tso_sg(struct sk_buff *skb, void *output, uint32 len,
+	rtl_nicTx_info *nicTx)
+{
+	uint32 tx_idx = 0, ret = SUCCESS, eor = 0;
+	DMA_TX_DESC *txd = NULL, *first_txd = NULL;
+	uint32 next_index;
+	uint32 cur_frag;
+	uint32 first_len;
+	uint32 skb_gso_size = skb_shinfo(skb)->gso_size;
+	uint8 L3_hdr_len = 5, L4_hdr_len = 5, L3_ip6_hdr_len = 40;
+	uint8 proto_type = 0;
+	bool cur_pi = 0, cur_vi = 0;
+
+	DBG("%s:%d: skb 0x%p, len %d\n", __func__, __LINE__, skb, len);
+	first_len = skb->len - skb->data_len;
+/* L3_hdr_len = find_L3L4_hdr_len(skb, &L4_hdr_len); */
+
+	if (first_len) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+		sync_tx_data_for_device((dma_addr_t) output, first_len);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		/* 1.get desc index */
+		tx_idx = New_currTxPkthdrDescIndex[nicTx->txIdx];
+		/* 2.get next desc index */
+		next_index = NEXT_IDX(tx_idx, New_txDescRingCnt[nicTx->txIdx]);
+
+		if (next_index == New_txPktDoneDescIndex[nicTx->txIdx]) {
+			/*      TX ring full    */
+			return (FAILED);
+		}
+#ifdef _LOCAL_TX_DESC
+		txd = (DMA_TX_DESC *) &local_txd;
+		memset((void *)txd, 0, sizeof(DMA_TX_DESC));
+#else
+		/* todo: error check, if txd = NULL.... */
+		txd = &New_txDescRing[nicTx->txIdx][tx_idx];
+#if defined(CONFIG_RTD_1295_HWNAT)
+		first_txd = txd;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		first_txd = (DMA_TX_DESC *) (((uint32)txd) | UNCACHE_MASK);
+
+		/* todo: in FPGA, when tx_desc use cacheable and do _dma_cache_wback, the tx ring will abnormal */
+#ifndef	_DESC_CACHE_ACCESS_TX
+		txd = (DMA_TX_DESC *) (((uint32)txd) | UNCACHE_MASK);
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+		/* skb @ the latest tx_skb */
+		tx_skb[nicTx->txIdx][tx_idx].skb = 0x0;
+		/* Pad small packets */
+		if (skb->len < 60)
+			skb->len = 60;
+
+		/* eor = (tx_idx == (New_txDescRingCnt[nicTx->txIdx] - 1)) ? DESC_WRAP : 0; */
+#if defined(CONFIG_RTD_1295_HWNAT)
+		txd->addr = (uintptr_t) output;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		txd->addr = (uint32)output;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		txd->opts1 =
+			(eor | (((skb->len + 4) & TD_PHLEN_MASK) << TD_PHLEN_OFFSET));
+		txd->opts1 |= FirstFrag;
+#if defined(CONFIG_RTD_1295_HWNAT)
+		tx_skb[nicTx->txIdx][tx_idx].dma_addr = (dma_addr_t) output;
+		tx_skb[nicTx->txIdx][tx_idx].dma_len = first_len;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		if ((skb_shinfo(skb)->nr_frags) == 0)
+			first_len += 4;
+
+		txd->opts2 = ((first_len & TD_M_LEN_MASK) << TD_M_LEN_OFFSET);
+
+		txd->opts4 = ((nicTx->portlist & TD_DP_MASK) << TD_DP_OFFSET);	/* direct tx now */
+
+		proto_type = get_protocol_type_new_desc(skb, (struct tx_desc *)txd);	/* Check Vi, Pi, and type */
+		cur_vi = ((struct tx_desc *)txd)->tx_vi;
+		cur_pi = ((struct tx_desc *)txd)->tx_pi;
+
+		if (skb_gso_size) {
+
+			/* refer to RTL8198E_LSO_spec_v1_150311.doc
+			 * no matter direct_tx or hw_lookup,
+			 * need to check payload more and set txd more.
+			 */
+			L3_hdr_len = find_L3L4_hdr_len(skb, &L4_hdr_len);
+			txd->opts4 |= TD_LSO_MASK;
+			txd->opts1 |= (PKTHDR_TCP << TD_TYPE_OFFSET);	/* type=5 */
+
+			if (proto_type == PKTHDR_IPV6) {	/* IPv6 */
+				txd->opts3 |= TD_L4CS_MASK;
+				txd->opts4 |=
+					((L3_ip6_hdr_len << TD_IPV6_HDRLEN_OFFSET));
+				txd->opts5 |=
+					((skb_gso_size << TD_MSS_OFFSET) |
+					(L4_hdr_len));
+			} else {	/* IPv4 */
+				txd->opts3 |= (TD_L3CS_MASK | TD_L4CS_MASK);
+				txd->opts3 |= (TD_IPV4_MASK | TD_IPV4_1ST_MASK);
+				txd->opts5 |=
+					((skb_gso_size << TD_MSS_OFFSET) |
+					(L3_hdr_len << TD_IPV4_HLEN_OFFSET) |
+					(L4_hdr_len));
+			}
+		} else {	/* fragment only */
+			txd->opts3 |= (TD_L3CS_MASK | TD_L4CS_MASK);
+		}
+
+		txd->opts1 |= (TD_BRIDGE_MASK | TD_HWLKUP_MASK);
+		txd->opts5 |= (PKTHDR_EXTPORT_LIST_CPU << TD_EXTSPA_OFFSET);
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) || defined(CONFIG_RTK_VOIP_QOS) || defined(CONFIG_RTK_VLAN_WAN_TAG_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q) ||	defined(CONFIG_RTL_HW_VLAN_SUPPORT) || defined(CONFIG_SWCONFIG)
+		fill_txd_misc((struct tx_desc *)txd, nicTx,
+			(struct sk_buff *)skb);
+#endif
+
+#ifdef _LOCAL_TX_DESC
+		first_txd =
+			(DMA_TX_DESC *) dw_copy((uint32 *)
+			&New_txDescRing[nicTx->txIdx][tx_idx], (uint32 *)txd,
+			sizeof(struct tx_desc) / 4);
+#else
+#ifdef _DESC_CACHE_ACCESS_TX
+		_dma_cache_wback((unsigned long)txd,
+			(unsigned long)sizeof(struct dma_tx_desc));
+		txd = (DMA_TX_DESC *) (((uint32)txd) | UNCACHE_MASK);
+#endif
+#endif
+
+		New_currTxPkthdrDescIndex[nicTx->txIdx] = next_index;
+	} else {
+		printk("\n !!! TODO: need to support this kind of skb !!!\n");
+	}
+
+	for (cur_frag = 0; cur_frag < skb_shinfo(skb)->nr_frags; cur_frag++) {
+		skb_frag_t *frag = &skb_shinfo(skb)->frags[cur_frag];
+		void *addr;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		dma_addr_t mapping;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		addr = ((void *)page_address(frag->page.p)) + frag->page_offset;
+#if defined(CONFIG_RTD_1295_HWNAT)
+		mapping =
+			dma_map_single(&rtl819x_pdev->dev, addr, frag->size,
+			DMA_TO_DEVICE);
+		if (unlikely(dma_mapping_error(&rtl819x_pdev->dev, mapping))) {
+			if (net_ratelimit())
+				printk("Failed to map TX DMA memory!\n");
+			return (FAILED);
+		}
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		_dma_cache_wback((unsigned long)addr, frag->size);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		/* 1.get desc index */
+		tx_idx = New_currTxPkthdrDescIndex[nicTx->txIdx];
+		/* 2.get next desc index */
+		next_index = NEXT_IDX(tx_idx, New_txDescRingCnt[nicTx->txIdx]);
+		if (next_index == New_txPktDoneDescIndex[nicTx->txIdx]) {
+			/* TX ring full */
+			return (FAILED);
+		}
+#ifdef _LOCAL_TX_DESC
+		txd = (DMA_TX_DESC *) &local_txd;
+		memset((void *)txd, 0, sizeof(DMA_TX_DESC));
+#else
+		/* todo: error check, if txd = NULL.... */
+		txd = &New_txDescRing[nicTx->txIdx][tx_idx];
+#if defined(CONFIG_RTD_1295_HWNAT)
+		if (first_txd == NULL)
+			first_txd = txd;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		if (first_txd == NULL)
+			first_txd =
+				(DMA_TX_DESC *) (((uint32)txd) | UNCACHE_MASK);
+
+		/* todo: in FPGA, when tx_desc use cacheable and do _dma_cache_wback, the tx ring will abnormal */
+#ifndef	_DESC_CACHE_ACCESS_TX
+		txd = (DMA_TX_DESC *) (((uint32)txd) | UNCACHE_MASK);
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+		tx_skb[nicTx->txIdx][tx_idx].skb = 0;
+
+		/* eor   = (tx_idx == (New_txDescRingCnt[nicTx->txIdx] - 1))     ? DESC_WRAP     : 0; */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		txd->addr = (uintptr_t) mapping;
+		tx_skb[nicTx->txIdx][tx_idx].dma_addr = mapping;
+		tx_skb[nicTx->txIdx][tx_idx].dma_len = frag->size;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		txd->addr = (uint32)addr;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		txd->opts1 =
+			(eor | (((skb->len + 4) & TD_PHLEN_MASK) << TD_PHLEN_OFFSET));
+
+		if (cur_frag == ((skb_shinfo(skb)->nr_frags) - 1))
+			txd->opts2 =
+				(((frag->size + 4) & TD_M_LEN_MASK) << TD_M_LEN_OFFSET);
+		else
+			txd->opts2 =
+				((frag->size & TD_M_LEN_MASK) << TD_M_LEN_OFFSET);
+
+		txd->opts4 = ((nicTx->portlist & TD_DP_MASK) << TD_DP_OFFSET);	/* direct tx now */
+
+		/* Vi, Pi from first_len */
+		((struct tx_desc *)txd)->tx_vi = cur_vi;
+		((struct tx_desc *)txd)->tx_pi = cur_pi;
+
+		if (skb_gso_size) {
+			/* refer to RTL8198E_LSO_spec_v1_150311.doc
+			 * no matter direct_tx or hw_lookup,
+			 * need to check payload more and set txd more.
+			 */
+			txd->opts4 |= TD_LSO_MASK;
+			txd->opts1 |= (PKTHDR_TCP << TD_TYPE_OFFSET);	/* type=5 */
+
+			if (proto_type == PKTHDR_IPV6) {	/* IPv6 */
+				txd->opts3 |= (TD_L4CS_MASK | TD_IPV6_MASK);
+				txd->opts4 |=
+					((L3_ip6_hdr_len << TD_IPV6_HDRLEN_OFFSET));
+				txd->opts5 |=
+					((skb_gso_size << TD_MSS_OFFSET) |
+					(L4_hdr_len));
+			} else {	/* IPv4 */
+				txd->opts3 |= (TD_L3CS_MASK | TD_L4CS_MASK);
+				txd->opts3 |= (TD_IPV4_MASK | TD_IPV4_1ST_MASK);
+				txd->opts5 |=
+					((skb_gso_size << TD_MSS_OFFSET) |
+					(L3_hdr_len << TD_IPV4_HLEN_OFFSET) |
+					(L4_hdr_len));
+			}
+
+		} else {	/* fragment only */
+			txd->opts3 |= (TD_L3CS_MASK | TD_L4CS_MASK);
+		}
+
+		txd->opts1 |= (TD_BRIDGE_MASK | TD_HWLKUP_MASK);
+		txd->opts5 |= (PKTHDR_EXTPORT_LIST_CPU << TD_EXTSPA_OFFSET);
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) || defined(CONFIG_RTK_VOIP_QOS) || defined(CONFIG_RTK_VLAN_WAN_TAG_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q) ||	defined(CONFIG_RTL_HW_VLAN_SUPPORT) || defined(CONFIG_SWCONFIG)
+		fill_txd_misc((struct tx_desc *)txd, nicTx,
+			(struct sk_buff *)skb);
+#endif
+
+#ifdef _LOCAL_TX_DESC
+		txd = (DMA_TX_DESC *) dw_copy((uint32 *)&New_txDescRing[nicTx->txIdx][tx_idx], (uint32 *)txd,
+			sizeof(DMA_TX_DESC) / 4);
+#else
+#if !defined(CONFIG_RTD_1295_HWNAT)
+		/* note: cache_wback of output data has been done in caller */
+#ifdef _DESC_CACHE_ACCESS_TX
+		_dma_cache_wback((unsigned long)txd,
+			(unsigned long)sizeof(struct dma_tx_desc));
+		txd = (DMA_TX_DESC *) (((uint32)txd) | UNCACHE_MASK);
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+		wmb();
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		txd->opts1 |= DESC_SWCORE_OWNED;	/* set own bit after all done. */
+
+		New_currTxPkthdrDescIndex[nicTx->txIdx] = next_index;
+	}
+
+#ifdef _LOCAL_TX_DESC
+	if ((skb_shinfo(skb)->nr_frags) == 0)
+		first_txd->opts1 |= LastFrag;
+	else
+#endif
+		txd->opts1 |= LastFrag;
+#if defined(CONFIG_RTD_1295_HWNAT)
+	tx_skb[nicTx->txIdx][tx_idx].skb = (uintptr_t) skb;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	tx_skb[nicTx->txIdx][tx_idx].skb = (uint32)skb;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	wmb();
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* set own bit of first tx_pkthdr after all done. */
+	first_txd->opts1 |= DESC_SWCORE_OWNED;
+
+	/* Set TXFD bit to start send */
+	REG32(CPUICR) |= TXFD;
+	/* REG32(CPUICR) &= ~TXFD; */
+
+	return ret;
+}
+#endif
+
+__IRAM_FWD
+	int32 New_swNic_send(void *skb, void *output, uint32 len,
+	rtl_nicTx_info *nicTx)
+{
+	int ret;
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_XMIT(flags);
+	ret = _New_swNic_send(skb, output, len, nicTx);
+	SMP_UNLOCK_ETH_XMIT(flags);
+	return ret;
+}
+
+#if (defined(CONFIG_RTL_TSO) || defined(CONFIG_RTL_GSO))
+__IRAM_FWD
+	int32 New_swNic_send_tso_sg(void *skb, void *output, uint32 len,
+	rtl_nicTx_info *nicTx)
+{
+	int ret;
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_XMIT(flags);
+	ret = _New_swNic_send_tso_sg(skb, output, len, nicTx);
+	SMP_UNLOCK_ETH_XMIT(flags);
+	return ret;
+}
+#endif
+
+/*
+  Why to use HW	CDP	instead	of own bit (i.e. use USE_SWITCH_TX_CDP flag)?
+  Reason:
+	the	cache line of 8197F	is 32-byte.
+	the	descriptor size	is 24-byte and can not pad to 32-byte because
+		HW CDP will	move to	next 24-byte after it Rx/Tx	a pkt.
+	when _DESC_CACHE_ACCESS_TX is defined, for example:
+		current	Tx index is	5,
+		previous Tx	index is 4,	in cacheable address the own bit is	1(SWCORE ownd),
+			IN CASE	HW is TX done this pkt,	it will	set	own	bit	to 0 (CPU ownd)	in physical	memory,
+		for	current	Tx pkt (idx:5),	it will	do cache writeback the desc	(24-byte) to physical memory,
+			it will	ALSO writeback previous	desc's own bit from	cacheable address (own bit=1) to
+			physical memory	(own bit=0).
+		when New_swNic_txDone()	run	to the "checking of	idx	4",	the	own	bit	will NEVER equal to	"CPU ownd".
+			so the Tx path is failed.
+  i.e. MUST	define USE_SWITCH_TX_CDP when use _DESC_CACHE_ACCESS_TX
+ */
+__IRAM_FWD int32 New_swNic_txDone(int idx)
+{
+	unsigned long flags = 0;
+	struct sk_buff *skb;
+
+#ifdef USE_SWITCH_TX_CDP
+	uint32 hw_cdp_data;
+	int hw_cdp_idx;
+#else
+	DMA_TX_DESC *tx_desc;
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+	dma_addr_t dma_addr;
+	uint32 dma_len;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	SMP_LOCK_ETH_XMIT(flags);
+
+#ifdef USE_SWITCH_TX_CDP
+	hw_cdp_data = REG32(TxCDP_reg[idx]);
+	hw_cdp_idx =
+		(hw_cdp_data - New_txDescRing_base[idx]) / sizeof(struct dma_tx_desc);
+
+	while (New_txPktDoneDescIndex[idx] != hw_cdp_idx) {
+
+		skb = (struct sk_buff *) tx_skb[idx][New_txPktDoneDescIndex[idx]].skb;
+#if defined(CONFIG_RTD_1295_HWNAT)
+		dma_addr = tx_skb[idx][New_txPktDoneDescIndex[idx]].dma_addr;
+		dma_len = tx_skb[idx][New_txPktDoneDescIndex[idx]].dma_len;
+
+		if (dma_addr > 0) {
+			dma_unmap_single(&rtl819x_pdev->dev, dma_addr, dma_len,
+				DMA_TO_DEVICE);
+
+			tx_skb[idx][New_txPktDoneDescIndex[idx]].dma_addr = 0;
+			tx_skb[idx][New_txPktDoneDescIndex[idx]].dma_len = 0;
+		}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		if (skb) {
+			SMP_UNLOCK_ETH_XMIT(flags);
+#if defined(CONFIG_RTL_FAST_BRIDGE)
+			tx_done_callback(skb);
+#else
+			dev_kfree_skb_any(skb);
+#endif
+			SMP_LOCK_ETH_XMIT(flags);
+			tx_skb[idx][New_txPktDoneDescIndex[idx]].skb = 0;
+		}
+
+		if (++New_txPktDoneDescIndex[idx] == New_txDescRingCnt[idx])
+			New_txPktDoneDescIndex[idx] = 0;
+	}
+
+#else
+	while (New_txPktDoneDescIndex[idx] != New_currTxPkthdrDescIndex[idx]) {
+
+		tx_desc = &New_txDescRing[idx][New_txPktDoneDescIndex[idx]];
+#if !defined(CONFIG_RTD_1295_HWNAT)
+		/* or, use _dma_cache_inv((unsigned long)tx_desc,(unsigned long)sizeof(struct dma_tx_desc)); */
+		tx_desc = (DMA_TX_DESC *) (((uint32)tx_desc) | UNCACHE_MASK);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+		if ((tx_desc->opts1 & DESC_OWNED_BIT) == DESC_RISC_OWNED) {
+			skb = (struct sk_buff *)
+				tx_skb[idx][New_txPktDoneDescIndex[idx]].skb;
+#if defined(CONFIG_RTD_1295_HWNAT)
+			dma_addr =
+				tx_skb[idx][New_txPktDoneDescIndex[idx]].dma_addr;
+			dma_len =
+				tx_skb[idx][New_txPktDoneDescIndex[idx]].dma_len;
+
+			if (dma_addr > 0) {
+				dma_unmap_single(&rtl819x_pdev->dev, dma_addr,
+					dma_len, DMA_TO_DEVICE);
+
+				tx_skb[idx][New_txPktDoneDescIndex[idx]].dma_addr = 0;
+				tx_skb[idx][New_txPktDoneDescIndex[idx]].dma_len = 0;
+			}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+			if (skb) {
+				SMP_UNLOCK_ETH_XMIT(flags);
+#if defined(CONFIG_RTL_FAST_BRIDGE)
+				tx_done_callback(skb);
+#else
+				dev_kfree_skb_any(skb);
+#endif
+				SMP_LOCK_ETH_XMIT(flags);
+				tx_skb[idx][New_txPktDoneDescIndex[idx]].skb =
+					0;
+			}
+
+			if (++New_txPktDoneDescIndex[idx] ==
+				New_txDescRingCnt[idx])
+				New_txPktDoneDescIndex[idx] = 0;
+		} else
+			break;
+	}
+#endif
+
+	SMP_UNLOCK_ETH_XMIT(flags);
+	return 0;
+}
+
+void New_swNic_freeRxBuf(void)
+{
+	int i, j;
+
+	/* Initialize index of Tx pkthdr descriptor */
+	for (i = 0; i < NEW_NIC_MAX_TX_DESC_RING; i++) {
+		New_currTxPkthdrDescIndex[i] = 0;
+		New_txPktDoneDescIndex[i] = 0;
+	}
+
+	for (i = 0; i < NEW_NIC_MAX_RX_DESC_RING; i++) {
+		if (rx_skb[i]) {
+			for (j = 0; j < New_rxDescRingCnt[i]; j++) {
+				void *skb;
+
+				skb = (void *)rx_skb[i][j].skb;
+				if (skb) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+					dma_unmap_single(&rtl819x_pdev->dev,
+						rx_skb[i][j].dma_addr,
+						rx_skb[i][j].dma_len,
+						DMA_FROM_DEVICE);
+					rx_skb[i][j].dma_addr = 0;
+					rx_skb[i][j].dma_len = 0;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+					free_rx_buf(skb);
+					rx_skb[i][j].skb = 0;
+				}
+			}
+		}
+		/* Initialize index of current Rx pkthdr descriptor */
+		New_currRxPkthdrDescIndex[i] = 0;
+	}
+}
+
+#if defined(REINIT_SWITCH_CORE)
+__IRAM_FWD void New_swNic_freeTxRing(void)
+{
+	unsigned long flags = 0;
+	struct sk_buff *skb;
+	int i, j;
+
+	SMP_LOCK_ETH_XMIT(flags);
+
+	for (i = 0; i < NEW_NIC_MAX_TX_DESC_RING; i++) {
+		for (j = 0; j < New_txDescRingCnt[i]; j++) {
+
+			skb = (struct sk_buff *)tx_skb[i][j].skb;
+			if (skb) {
+				SMP_UNLOCK_ETH_XMIT(flags);
+#if defined(CONFIG_RTL_FAST_BRIDGE)
+				tx_done_callback(skb);
+#else
+				dev_kfree_skb_any(skb);
+#endif
+				SMP_LOCK_ETH_XMIT(flags);
+				tx_skb[i][j].skb = 0;
+			}
+		}
+	}
+	SMP_UNLOCK_ETH_XMIT(flags);
+	return;
+}
+
+void New_swNic_reConfigRxTxRing(void)
+{
+	int i, j;
+	unsigned long flags = 0;
+	struct tx_desc *txd = 0;
+	struct rx_desc *rxd = 0;
+
+	SMP_LOCK_ETH(flags);
+
+	/* Initialize index     of Tx pkthdr descriptor */
+	for (i = 0; i < NEW_NIC_MAX_TX_DESC_RING; i++) {
+		for (j = 0; j < New_txDescRingCnt[i]; j++) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+			txd = (struct tx_desc *)&New_txDescRing[i][j];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			txd = (struct tx_desc *)(((uint32)(&New_txDescRing[i][j])) |
+				UNCACHE_MASK);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+			txd->tx_own = DESC_RISC_OWNED;
+		}
+		New_currTxPkthdrDescIndex[i] = 0;
+		New_txPktDoneDescIndex[i] = 0;
+#if defined(CONFIG_RTD_1295_HWNAT)
+		New_txDescRing_base[i] = (uintptr_t) New_txDescRingPhyAddr[i];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		New_txDescRing_base[i] =
+			((uint32)New_txDescRing[i]) | UNCACHE_MASK;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		REG32(TxCDP_reg[i]) = New_txDescRing_base[i];
+	}
+
+	REG32(DMA_CR1) = (New_txDescRingCnt[0] - 1) * (sizeof(struct tx_desc));
+	/* REG32(DMA_CR4) = TX_RING0_TAIL_AWARE; */
+
+	/* Initialize Rx packet header descriptors */
+	for (i = 0; i < NEW_NIC_MAX_RX_DESC_RING; i++) {
+		for (j = 0; j < New_rxDescRingCnt[i]; j++) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+			rxd = (struct rx_desc *)&New_rxDescRing[i][j];
+			rxd->rx_own = DESC_RISC_OWNED;
+			rxd->rx_own2 = DESC_RISC_OWNED;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			rxd = (struct rx_desc *)(((uint32)(&New_rxDescRing[i][j])) |
+				UNCACHE_MASK);
+			rxd->rx_own = DESC_RISC_OWNED;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		}
+		rxd->rx_eor = 1;
+		/* Initialize index     of current Rx pkthdr descriptor */
+		New_currRxPkthdrDescIndex[i] = 0;
+#if defined(CONFIG_RTD_1295_HWNAT)
+		New_rxDescRing_base[i] = (uintptr_t) New_rxDescRingPhyAddr[i];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		New_rxDescRing_base[i] =
+			((uint32)New_rxDescRing[i]) | UNCACHE_MASK;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		REG32(CPURPDCR(i)) = New_rxDescRing_base[i];
+	}
+
+	SMP_UNLOCK_ETH(flags);
+	return;
+}
+
+int32 New_swNic_reInit(void)
+{
+	New_swNic_freeTxRing();
+	New_swNic_reConfigRxTxRing();
+	return SUCCESS;
+}
+
+int32 New_check_tx_done_desc_swCore_own(int32 *tx_done_inx)
+{
+	struct tx_desc *txd;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	txd = (struct tx_desc *)(&New_txDescRing[0][New_txPktDoneDescIndex[0]]);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	txd = (struct tx_desc *)(((uint32)(&New_txDescRing[0][New_txPktDoneDescIndex[0]])) |
+		UNCACHE_MASK);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	if (txd->tx_own == DESC_SWCORE_OWNED) {
+		*tx_done_inx = New_txPktDoneDescIndex[0];
+		return SUCCESS;
+	} else
+		return FAILED;
+}
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_swNic.h b/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_swNic.h
new file mode 100644
index 00000000..a1b33ee
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_swNic.h
@@ -0,0 +1,637 @@
+/*
+ *	Abstract: header file for rtl819x_swNic.c
+ *
+ *	Author:
+ *		Joey Lin, <joey.lin@realtek.com>
+ *
+ *	Copyright (c) 2015 Realtek Semiconductor Corp.
+ *
+ *	This program is free software; you can redistribute it and/or
+ *	modify it under the terms of the GNU General Public License
+ *	as published by the Free Software Foundation; either version
+ *	2 of the License, or (at your option) any later version.
+ */
+
+
+#ifndef RTL819X_SWNIC_H
+#define	RTL819X_SWNIC_H
+
+#define	NEW_NIC_MAX_RX_DESC_RING    6
+#define	NEW_NIC_MAX_TX_DESC_RING    4
+
+// DESCRIPTOR BIT MAP
+/*TX/RX share */
+
+#define DescOwn			(1 << 0) /* Descriptor is owned by NIC */
+#define RingEnd			(1 << 1) /* End of descriptor ring */
+#define LastFrag		(1 << 2) /* Final segment of a packet */
+#define FirstFrag		(1 << 3) /* First segment of a packet */
+
+
+
+/* Tx descriptor opts1 */
+
+	#define TD_TYPE_OFFSET			29	/* [31:29] 000: Ethernet, 001:PPTP, 010:IP, 011:ICMP, 100:IGMP, 101:TCP, 110:UDP, 111:IPv6 */
+	#define TD_TYPE_MASK			(0x7)
+	#define TD_VI_OFFSET			28	/* [28] Pkt is VLAN tagged */
+	#define TD_LI_OFFSET			27	/* [27] Pkt has LLC hdr */
+	#define TD_PI_OFFSET			26	/* [26] Pkt has PPPoE hdr */
+	#define TD_PPPIDX_OFFSET		23	/* [25:23] Destination PPPoE Table Idx */
+	#define TD_PPPIDX_MASK			(0x7)
+	#define TD_PHLEN_OFFSET			6	/* [22:6] The packet length In RTL8198E; */
+										/* should support up to 64K bytes for LSO, max. */
+										/* normal packet size (without LSO) need follow PCR accept packet size. */
+	#define TD_PHLEN_MASK			(0x1FFFF)
+	#define TD_BRIDGE_OFFSET		5	/* [5] BRIDGING */
+	#define TD_HWLKUP_OFFSET		4	/* [4] HWLOOKUP */
+	/* { BRIDGING, HWLOOKUP }
+	   2'b00: Send directly as is to the destination portlist assigned.
+	   However, if any of the following offload option bits (in this Tx table) are set,
+	   software should tell SwitchCore ALL protocol types enclosed in the packet via ph_proto field.
+
+	   2'b01: Offload destination portlist resolving to SwitchCore and Do L2/Routing/NAPT,
+	   based on whole packet content. SwitchCore  ignores the ph_proto field.
+
+	   2'b10: Invalid setting.
+
+	   2'b11: Offload destination portlist resolving to SwitchCore and Do L2 lookup(bridging) only,
+	   based on DMAC given. SwitchCore ignores the ph_proto field. */
+										/* [3] FirstFrag */
+										/* [2] LastFrag */
+										/* [1] RingEnd */
+										/* [0] DescOwn */
+	#define TD_BRIDGE_MASK			(1 << 5)
+	#define TD_HWLKUP_MASK			(1 << 4)
+
+
+
+/* Tx descriptor opts2 */
+
+	#define TD_M_LEN_OFFSET			15	/* Length of actual data in associated cluster buffer for Tx */
+	#define TD_M_LEN_MASK			(0x1FFFF)
+	#define TD_QID_OFFSET			12	/* CPU Queue priority for direct Tx */
+	#define TD_QID_MASK				(0x7)
+	#define TD_PQID_OFFSET			9	/* Queue priority for direct Tx */
+	#define TD_PQID_MASK			(0x7)
+	#define TD_VLANTAGSET_OFFSET	0	/* [8:6] Ext port Tag mask; [5:0] port Tag mask; [4:0] physical port; Bit[5] MII port*/
+	#define TD_VLANTAGSET_MASK		(0x1FF)
+
+
+
+/* Tx descriptor opts3 */
+
+	#define TD_PTP_PKT_OFFSET		31	/* [31] PTP packet indication */
+	#define TD_PTP_TYP_OFFSET		27	/* [30:27] msg type */
+	#define TD_PTP_TYP_MASK			(0xF)
+	#define TD_PTP_VER_OFFSET		25	/* [26:25] PTP version, 0: 1588v1; 1: 1588v2 or 802.1as; others: reserved */
+	#define TD_PTP_VER_MASK			(0x3)
+	#define TD_DPRI_OFFSET			22	/* [24:22] Destination Priority */
+	#define TD_DPRI_MASK			(0x7<<22)
+	#define TD_PO_OFFSET			21	/* [21] 0: PPPoE header, if present, already attached */
+										/* 1: Offload PPPoE header generation to SwitchCore */
+	#define TD_L3CS_OFFSET			20	/* [20] 0: IP checksum calculated. Send it as is */
+										/* 1: Offload IPv4 (w/wo option) checksum calculation to SwitchCore */
+	#define TD_L3CS_MASK			(1<<20)
+	#define TD_L4CS_OFFSET			19	/* [19] 0: TCP/UDP/ICMP checksum calculated. Send it as is */
+										/* 1: Offload TCP/UDP/ICMP checksum calculation to SwitchCore */
+	#define TD_L4CS_MASK			(1<<19)
+	#define TD_IPV6_OFFSET			18	/* [18] IPv6 Header flag */
+	#define TD_IPV6_MASK			(1<<18)	/* [18] IPv6 Header flag */
+	#define TD_IPV4_OFFSET			17	/* [17] IPv4 Header flag */
+	#define TD_IPV4_MASK			(1<<17)	/* [17] IPv4 Header flag */
+	#define TD_IPV4_1ST_OFFSET		16	/* [16] IPv4 first header */
+	#define TD_IPV4_1ST_MASK		(1<<16)	/* [16] IPv4 first header */
+										/* [15] Reserved */
+	#define TD_DP_EXT_OFFSET		12	/* [14:12] Destination extension port mask: */
+										/* (only for CPU direct Tx & single ext. port) */
+	#define TD_DP_EXT_MASK			(0x7)
+	#define TD_DVLANID_OFFSET		0	/* [11:0] (1) Source VLAN ID selected for from extension port; */
+									/* (2) Destination VLAN ID from CPU (really work) */
+	#define TD_DVLANID_MASK			(0xFFF)
+
+
+/* Tx descriptor opts4 */
+
+	#define TD_LSO_OFFSET			31	/* [31] LSO flag indication */
+	#define TD_LSO_MASK				(1<<31)
+	#define TD_DP_OFFSET			24	/* [30:24] destination port mask, Bit[6]: CPU port; Bit[5-0]: Port5-Port0 */
+										/* (If pkt was sent to CPU/extension port (ex: to extension port),Bits[6]=1.need refer to dp_ext[2:0] ) */
+	#define TD_DP_MASK				(0x7F)
+										/* [23] Reserved */
+	#define TD_LINKED_OFFSET		16	/* [22:16] For WLAN WDS multiple tunnel */
+	#define TD_LINKED_MASK			(0x7F)
+	#define TD_IPV6_HDRLEN_OFFSET	0	/* [15:0] IPv6 header length */
+	#define TD_IPV6_HDRLEN_MASK		(0xFFFF)
+
+
+
+/* Tx descriptor opts5 */
+	#define TD_EXTSPA_OFFSET		30	/* [31:30] extspa: Source extension port number: 2'd0: from CPU, */
+										/* 2'd1~2'd3: from extension port numbers */
+	#define TD_EXTSPA_MASK			(0x3)
+	#define TD_MSS_OFFSET			16	/* [29:16] if (type==TCP), TCP segmentation size; */
+										/* if (type != TCP), means MTU for UFO/IPF, and (MTU-IP header length) MUST be 8*n. */
+	#define TD_MSS_MASK				(0x3FFF)
+	#define TD_FLAGS_OFFSET			8	/* [15:8] {ECN/2b,URG,ACK,PSH,RST,SYN,FIN} in TCP header, if do TSO, PSH and FIN move to last segment packet */
+	#define TD_FLAGS_MASK			(0xFF)
+	#define TD_IPV4_HLEN_OFFSET		4	/* [7:4] header length field of IPv4 header in packet, unit: 4-byte */
+	#define TD_IPV4_HLEN_MASK		(0xF)
+	#define TD_TCP_HLEN_OFFSET		0	/* [3:0] header length field of TCP header in packet, unit: 4-byte */
+	#define TD_TCP_HLEN_MASK		(0xF)
+
+
+
+/* Rx descriptor opts1 */
+
+	#define	RD_M_EXTSIZE_OFFSET		16	/* [31:16] FirstFrag */
+	#define	RD_M_EXTSIZE_MASK		(0xFFFF)
+										/* [15:4] Reserved */
+										/* [3] FirstFrag */
+										/* [2] LastFrag */
+										/* [1] RingEnd */
+										/* [0] DescOwn */
+
+
+
+/* Rx descriptor opts2 */
+
+	#define	RD_EXTSPA_OFFSET		24	/* [25:24] */
+	#define	RD_EXTSPA_MASK			(0x3 << 24)
+	#define	RD_DP_EXT_OFFSET		20
+	#define	RD_DP_EXT_MASK			(0xF << 20)
+	#define	RD_QID_OFFSET			17
+	#define	RD_QID_MASK				(0x7 << 17)
+										/* [16:14] Reserved */
+	#define	RD_LEN_OFFSET			0
+	#define	RD_LEN_MASK				(0x3FFF << 0)
+
+
+/* Rx descriptor opts3 */
+
+	#define	RD_TYPE_OFFSET			29	/* [31:29] */
+	#define	RD_TYPE_MASK			(0x7 << 28)
+	#define	RD_VO_OFFSET			28	/* [28] */
+	#define	RD_LO_OFFSET			27	/* [27] */
+	#define	RD_PO_OFFSET			26	/* [26] */
+	#define	RD_PPPIDX_OFFSET		23	/* [25:23] */
+	#define	RD_PPPIDX_MASK			(0x7 << 23)
+	#define	RD_LINKID_OFFSET		16	/* [22:16] */
+	#define	RD_LINKID_MASK			(0x7F << 16)
+	#define	RD_REASON_OFFSET		0	/* [15:0] */
+	#define	RD_REASON_MASK			(0xFFFF << 0)
+
+
+/* Rx descriptor opts4 */
+
+	#define	RD_EXT_VLANO_OFFSET		29	/* [31:29] */
+	#define	RD_EXT_VLANO_MASK		(0x7 << 29)
+	#define	RD_L2ACT_OFFSET			28	/* [28] */
+	#define	RD_DVLANID_OFFSET		16	/* [27:16] */
+	#define RD_DVLANID_MASK			(0xfff << 16)
+	#define	RD_SPA_OFFSET			13	/* [15:13] */
+	#define	RD_SPA_MASK				(0x7 << 13)
+	#define	RD_LAST_F_OFFSET		12	/* [12] */
+	#define	RD_FRAG_OFFSET			11	/* [11] */
+	#define	RD_IPV4_1ST_OFFSET		10	/* [10] */
+	#define	RD_IPV6_OFFSET			9	/* [9] */
+	#define	RD_IPV6_MASK			(1<<9)
+	#define	RD_IPV4_OFFSET			8	/* [8] */
+	#define	RD_TOS_OFFSET			0	/* [7:0] */
+	#define	RD_TOS_MASK				(0xFF << 0)
+
+
+/* Rx descriptor opts5 */
+
+	#define	RD_L3CSOK_OFFSET		31	/* [31] */
+	#define	RD_L3CSOK_MASK			(1<<31)
+	#define	RD_L4CSOK_OFFSET		30	/* [30] */
+	#define	RD_L4CSOK_MASK			(1<<30)
+	#define	RD_FWD_OFFSET			29	/* [29] */
+	#define	RD_ORG_OFFSET			28	/* [28] */
+	#define	RD_IP_MDF_OFFSET		25	/* [27:25] */
+	#define	RD_IP_MDF_MASK			(0x7 << 24)
+	#define	RD_VORG_OFFSET			24	/* [24] */
+	#define	RD_LORG_OFFSET			23	/* [23] */
+	#define	RD_PORG_OFFSET			22	/* [22] */
+	#define	RD_DPRI_OFFSET			19	/* [21:19] */
+	#define	RD_DPRI_MASK			(0x7 << 19)
+	#define	RD_SPRI_OFFSET			16	/* [18:16] */
+	#define	RD_SPRI_MASK			(0x7 << 16)
+#if defined(CONFIG_RTD_1295_HWNAT)
+	#define	RD_OWN2_OFFSET			15	/* [15] */
+	#define	RD_OWN2_MASK			(1<<15)
+#else //defined(CONFIG_RTD_1295_HWNAT)
+									/* [15] Reserved */
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+	#define	RD_EXT_TTL_OFFSET		12	/* [14:12] */
+	#define	RD_EXT_TTL_MASK			(0x7 << 12)
+	#define	RD_SVLANID_OFFSET		0	/* [11:0] */
+	#define	RD_SVLANID_MASK			(0xFFF << 0)
+
+struct rx_desc{
+#ifdef _LITTLE_ENDIAN
+	union{
+		struct{
+			uint32 own:1;         //0
+			uint32 eor:1;         //1
+			uint32 ls:1;          //2
+			uint32 fs:1;          //3
+			uint32 rcdf:1;        //4
+			uint32 fae:1;         //5
+			uint32 rsvd:10;       //6~15
+			uint32 m_extsize:16;  //16~31
+		}bit;
+		uint32 dw;
+	}opts1;
+	uint32 mdata;
+	union{
+		struct{
+			uint32 len:14;     //0~13
+			uint32 rsvd:3;       //14~16
+			uint32 qid:3;         //17~19
+			uint32 dp_ext:4;     //20~23
+			uint32 extspa:2;         //24~25
+			uint32 rsvd2:6;         //26~31
+		}bit;
+		uint32 dw;
+	}opts2;
+	union{
+		struct{
+			uint32 reason:16;     //0~15
+			uint32 linkid:7;      //16~22
+			uint32 ppp_idx:3;     //23~25
+			uint32 po:1;          //26
+			uint32 lo:1;          //27
+			uint32 vo:1;          //28
+			uint32 type:3;        //29~31
+		}bit;
+		uint32 dw;
+	}opts3;
+	union{
+		struct{
+			uint32 tos:8;         //0~7
+			uint32 ipv4:1;        //8
+			uint32 ipv6:1;        //9
+			uint32 ipv4_1st:1;    //10
+			uint32 frag:1;        //11
+			uint32 last_f:1;      //12
+			uint32 spa:3;         //13~15
+			uint32 dvlanid:12;    //16~27
+			uint32 l2act:1;       //28
+			uint32 ext_vlano:3;   //29~31
+		}bit;
+		uint32 dw;
+	}opts4;
+	union{
+		struct{
+			uint32 svlanid:12;   //0~11
+			uint32 ext_ttl:3;    //12~14
+#if defined(CONFIG_RTD_1295_HWNAT)
+			uint32 own2:1;       //15
+#else //defined(CONFIG_RTD_1295_HWNAT)
+			uint32 rsvd:1;       //15
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+			uint32 spri:3;        //16~18
+			uint32 dpri:3;       //19~21
+			uint32 porg:1;        //22
+			uint32 lorg:1;    //23
+			uint32 vorg:1;        //24
+			uint32 ip_mdf:3;      //25~27
+			uint32 org:1;         //28
+			uint32 fwd:1;    //29
+			uint32 l4csok:1;       //30
+			uint32 l3csok:1;   //31
+		}bit;
+		uint32 dw;
+	}opts5;
+#else
+	union{
+		struct{
+			uint32 m_extsize:16;  //16~31
+			uint32 rsvd:10;       //6~15
+			uint32 fae:1;         //5
+			uint32 rcdf:1;        //4
+			uint32 fs:1;          //3
+			uint32 ls:1;          //2
+			uint32 eor:1;         //1
+			uint32 own:1;         //0
+		}bit;
+		uint32 dw;
+	}opts1;
+	uint32 mdata;
+	union{
+		struct{
+			uint32 rsvd2:6;         //26~31
+			uint32 extspa:2;         //24~25
+			uint32 dp_ext:4;     //20~23
+			uint32 qid:3;         //17~19
+			uint32 rsvd:3;       //14~16
+			uint32 len:14;     //0~13
+		}bit;
+		uint32 dw;
+	}opts2;
+	union{
+		struct{
+			uint32 type:3;        //29~31
+			uint32 vo:1;          //28
+			uint32 lo:1;          //27
+			uint32 po:1;          //26
+			uint32 ppp_idx:3;     //23~25
+			uint32 linkid:7;      //16~22
+			uint32 reason:16;     //0~15
+		}bit;
+		uint32 dw;
+	}opts3;
+	union{
+		struct{
+			uint32 ext_vlano:3;   //29~31
+			uint32 l2act:1;       //28
+			uint32 dvlanid:12;    //16~27
+			uint32 spa:3;         //13~15
+			uint32 last_f:1;      //12
+			uint32 frag:1;        //11
+			uint32 ipv4_1st:1;    //10
+			uint32 ipv6:1;        //9
+			uint32 ipv4:1;        //8
+			uint32 tos:8;         //0~7
+		}bit;
+		uint32 dw;
+	}opts4;
+	union{
+		struct{
+			uint32 l3csok:1;   //31
+			uint32 l4csok:1;       //30
+			uint32 fwd:1;    //29
+			uint32 org:1;         //28
+			uint32 ip_mdf:3;      //25~27
+			uint32 vorg:1;        //24
+			uint32 lorg:1;    //23
+			uint32 porg:1;        //22
+			uint32 dpri:3;       //19~21
+			uint32 spri:3;        //16~18
+			uint32 rsvd:1;       //15
+			uint32 ext_ttl:3;    //12~14
+			uint32 svlanid:12;   //0~11
+		}bit;
+		uint32 dw;
+	}opts5;
+#endif
+
+#define rx_own			opts1.bit.own
+#define rx_eor			opts1.bit.eor
+#define rx_ls			opts1.bit.ls
+#define rx_fs			opts1.bit.fs
+#define rx_rcdf			opts1.bit.rcdf
+#define rx_fae			opts1.bit.fae
+#define rx_m_extsize	opts1.bit.m_extsize
+#define rx_len			opts2.bit.len
+#define rx_qid			opts2.bit.qid
+#define rx_dp_ext		opts2.bit.dp_ext
+#define rx_extspa		opts2.bit.extspa
+#define rx_reason		opts3.bit.reason
+#define rx_linkid		opts3.bit.linkid
+#define rx_ppp_idx		opts3.bit.ppp_idx
+#define rx_po			opts3.bit.po
+#define rx_lo			opts3.bit.lo
+#define rx_vo			opts3.bit.vo
+#define rx_type			opts3.bit.type
+#define rx_tos			opts4.bit.tos
+#define rx_ipv4			opts4.bit.ipv4
+#define rx_ipv6			opts4.bit.ipv6
+#define rx_ipv4_1st		opts4.bit.ipv4_1st
+#define rx_frag			opts4.bit.frag
+#define rx_last_f		opts4.bit.last_f
+#define rx_spa			opts4.bit.spa
+#define rx_dvlanid		opts4.bit.dvlanid
+#define rx_l2act		opts4.bit.l2act
+#define rx_ext_vlano	opts4.bit.ext_vlano
+#define rx_svlanid		opts5.bit.svlanid
+#define rx_ext_ttl		opts5.bit.ext_ttl
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define rx_own2			opts5.bit.own2
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+#define rx_spri			opts5.bit.spri
+#define rx_dpri			opts5.bit.dpri
+#define rx_porg			opts5.bit.porg
+#define rx_lorg			opts5.bit.lorg
+#define rx_vorg			opts5.bit.vorg
+#define rx_ip_mdf		opts5.bit.ip_mdf
+#define rx_org			opts5.bit.org
+#define rx_fwd			opts5.bit.fwd
+#define rx_l4csok		opts5.bit.l4csok
+#define rx_l3csok		opts5.bit.l3csok
+
+};
+
+
+//ask alan :linked[6:0]	For WLAN WDS multiple tunnel.
+
+struct tx_desc{
+#ifdef _LITTLE_ENDIAN
+	union{
+		struct{
+			uint32 own:1;         //0
+			uint32 eor:1;         //1
+			uint32 ls:1;          //2
+			uint32 fs:1;          //3
+			uint32 hwlkup:1;      //4
+			uint32 bridge:1;      //5
+			uint32 ph_len:17;//6~22
+			uint32 pppidx:3;      //23~25
+			uint32 pi:1;          //26
+			uint32 li:1;          //27
+			uint32 vi:1;          //28
+			uint32 type:3;        //29~31
+		}bit;
+		uint32 dw;//double word
+	}opts1;
+	uint32 mdata;
+	union{
+		struct{
+			uint32 vlantag:9;     //0~8
+			uint32 pqid:3;        //9~11
+			uint32 qid:3;         //12~14
+			uint32 mlen:17;       //15~31
+		}bit;
+		uint32 dw;//double word
+	}opts2;
+	union{
+		struct{
+			uint32 dvlanid:12;     //0~11
+			uint32 dp_ext:3;       //12~14
+			uint32 rsvd:1;         //15
+			uint32 ipv4_1st:1;     //16
+			uint32 ipv4:1;         //17
+			uint32 ipv6:1;         //18
+			uint32 l4cs:1;         //19
+			uint32 l3cs:1;         //20
+			uint32 po:1;           //21
+			uint32 dpri:3;         //22~24
+			uint32 ptp_ver:2;      //25~26
+			uint32 ptp_type:4;     //27~30
+			uint32 ptp_pkt:1;      //31
+		}bit;
+		uint32 dw;//double word
+	}opts3;
+	union{
+		struct{
+			uint32 ipv6_hdrlen:16; //0~15
+			uint32 linkid:7;       //16~22
+			uint32 rsvd:1;          //23
+			uint32 dp:7;           //24~30
+			uint32 lso:1;         //31
+		}bit;
+		uint32 dw;
+	}opts4;
+	union{
+		struct{
+			uint32 tcp_hdrlen:4;   //0~3
+			uint32 ipv4_hdrlen:4;  //4~7
+			uint32 flags:8;        //8~15
+			uint32 mss:14;         //16~29
+			uint32 extspa:2;       //30~31
+		}bit;
+		uint32 dw;
+	}opts5;
+#else
+	union{
+		struct{
+			uint32 type:3;        //29~31
+			uint32 vi:1;          //28
+			uint32 li:1;          //27
+			uint32 pi:1;          //26
+			uint32 pppidx:3;      //23~25
+			uint32 ph_len:17;//6~22
+			uint32 bridge:1;      //5
+			uint32 hwlkup:1;      //4
+			uint32 fs:1;          //3
+			uint32 ls:1;          //2
+			uint32 eor:1;         //1
+			uint32 own:1;         //0
+		}bit;
+		uint32 dw;//double word
+	}opts1;
+	uint32 mdata;
+	union{
+		struct{
+			uint32 mlen:17;       //15~31
+			uint32 qid:3;         //12~14
+			uint32 pqid:3;        //9~11
+			uint32 vlantag:9;     //0~8
+		}bit;
+		uint32 dw;//double word
+	}opts2;
+	union{
+		struct{
+			uint32 ptp_pkt:1;      //31
+			uint32 ptp_type:4;     //27~30
+			uint32 ptp_ver:2;      //25~26
+			uint32 dpri:3;         //22~24
+			uint32 po:1;           //21
+			uint32 l3cs:1;         //20
+			uint32 l4cs:1;         //19
+			uint32 ipv6:1;         //18
+			uint32 ipv4:1;         //17
+			uint32 ipv4_1st:1;     //16
+			uint32 rsvd:1;         //15
+			uint32 dp_ext:3;       //12~14
+			uint32 dvlanid:12;     //0~11
+		}bit;
+		uint32 dw;//double word
+	}opts3;
+	union{
+		struct{
+			uint32 lso:1;         //31
+			uint32 dp:7;           //24~30
+			uint32 rsvd:1;          //23
+			uint32 linkid:7;       //16~22
+			uint32 ipv6_hdrlen:16; //0~15
+		}bit;
+		uint32 dw;
+	}opts4;
+	union{
+		struct{
+			uint32 extspa:2;       //30~31
+			uint32 mss:14;         //16~29
+			uint32 flags:8;        //8~15
+			uint32 ipv4_hdrlen:4;  //4~7
+			uint32 tcp_hdrlen:4;   //0~3
+		}bit;
+		uint32 dw;
+	}opts5;
+#endif
+
+#define tx_own			opts1.bit.own
+#define tx_eor			opts1.bit.eor
+#define tx_ls			opts1.bit.ls
+#define tx_fs			opts1.bit.fs
+#define tx_hwlkup		opts1.bit.hwlkup
+#define tx_bridge		opts1.bit.bridge
+#define tx_ph_len		opts1.bit.ph_len
+#define tx_pppidx		opts1.bit.pppidx
+#define tx_pi			opts1.bit.pi
+#define tx_li			opts1.bit.li
+#define tx_vi			opts1.bit.vi
+#define tx_type			opts1.bit.type
+#define tx_vlantag		opts2.bit.vlantag
+#define tx_pqid			opts2.bit.pqid
+#define tx_qid			opts2.bit.qid
+#define tx_mlen			opts2.bit.mlen
+#define tx_dvlanid		opts3.bit.dvlanid
+#define tx_dp_ext		opts3.bit.dp_ext
+#define tx_ipv4_1st		opts3.bit.ipv4_1st
+#define tx_ipv4			opts3.bit.ipv4
+#define tx_ipv6			opts3.bit.ipv6
+#define tx_l4cs			opts3.bit.l4cs
+#define tx_l3cs			opts3.bit.l3cs
+#define tx_po			opts3.bit.po
+#define tx_dpri			opts3.bit.dpri
+#define tx_ptp_ver		opts3.bit.ptp_ver
+#define tx_ptp_type		opts3.bit.ptp_type
+#define tx_ptp_pkt		opts3.bit.ptp_pkt
+#define tx_ipv6_hdrlen	opts4.bit.ipv6_hdrlen
+#define tx_linkid		opts4.bit.linkid
+#define tx_dp			opts4.bit.dp
+#define tx_lso			opts4.bit.lso
+#define tx_tcp_hdrlen	opts5.bit.tcp_hdrlen
+#define tx_ipv4_hdrlen	opts5.bit.ipv4_hdrlen
+#define tx_flags_		opts5.bit.flags
+#define tx_mss			opts5.bit.mss
+#define tx_extspa		opts5.bit.extspa
+
+};
+
+typedef struct dma_tx_desc {
+	uint32		opts1;
+	uint32		addr;
+	uint32		opts2;
+	uint32		opts3;
+	uint32		opts4;
+	uint32		opts5;
+}DMA_TX_DESC;
+
+typedef struct dma_rx_desc {
+	uint32		opts1;
+	uint32		addr;
+	uint32		opts2;
+	uint32		opts3;
+	uint32		opts4;
+	uint32		opts5;
+}DMA_RX_DESC;
+
+#define IS_SWITCH_NORMAL_DESC() ((REG32(CPUICR1) & CF_PKT_HDR_TYPE_MASK) == TX_PKTHDR_8198C_DEF)
+
+int32 New_swNic_init(uint32 userNeedRxPkthdrRingCnt[RTL865X_SWNIC_RXRING_HW_PKTDESC],
+				 uint32 userNeedTxPkthdrRingCnt[RTL865X_SWNIC_TXRING_HW_PKTDESC],
+				 uint32 clusterSize);
+
+int32 New_swNic_send(void *skb, void * output, uint32 len,rtl_nicTx_info *nicTx);
+int32 New_swNic_txDone(int idx);
+void New_swNic_freeRxBuf(void);
+void New_dumpTxRing(struct seq_file *s);
+void New_dumpRxRing(struct seq_file *s);
+
+extern uint32  size_of_cluster;
+
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_switch.c b/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_switch.c
new file mode 100644
index 00000000..85504d1
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_switch.c
@@ -0,0 +1,535 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/kernel.h>
+#include <linux/device.h>
+#include <linux/switch.h>
+#include "rtl819x_switch.h"
+
+struct rtl819x_smi {
+	struct switch_dev	sw_dev;
+
+	unsigned int		cpu_port;
+	unsigned int		num_ports;
+	unsigned int		num_vlan_mc;
+	unsigned int		num_mib_counters;
+	struct rtl819x_mib_counter *mib_counters;
+
+	//struct rtl8366_smi_ops	*ops;
+	int			vlan_enabled;
+	int			vlan4k_enabled;
+	int			learn_enabled;
+	char			buf[4096];
+};
+
+static struct rtl819x_smi rtl819x_smi_driver;
+
+//############## call driver layer
+
+//extern from rtl_nic.c
+extern void rtk_reset_rtl819x_setting(void);
+extern void rtk_set_vlan_enable(int enable);
+
+//extern unsigned int rtk_get_port_status(int port , char *buf, int buf_len);
+unsigned int rtk_get_port_status(int port, struct switch_port_link *link);
+extern void rtk_reset_mibCounter(void);
+extern char *rtk_get_mibCounter_name(int mib_idx);
+extern unsigned int rtk_get_mibCounter_val(int port, int mib_idx);
+extern int rtk_get_vlan_entry(u32 vid, struct rtl819x_vlan_4k *vlan4k);
+extern int rtk_set_port_pvid(int port, unsigned int pvid);
+extern int rtk_set_hw_vlan(unsigned int vid, unsigned int member,
+	unsigned int untag, unsigned int fid);
+extern int rtk_get_port_pvid(int port, int *val);
+extern int rtk_get_mibCounter_num(void);
+
+static void rtk_reset_layer2_setting(void)
+{
+	rtk_reset_rtl819x_setting();
+}
+
+//###############
+static inline struct rtl819x_smi *sw_to_rtl819x_smi(struct switch_dev *sw)
+{
+	return container_of(sw, struct rtl819x_smi, sw_dev);
+}
+
+static int rtl819x_sw_get_learning_enable(struct switch_dev *dev,
+					const struct switch_attr *attr,
+					struct switch_val *val)
+{
+	struct rtl819x_smi *smi = sw_to_rtl819x_smi(dev);
+
+	//printk(" Not support swconfig get_learning_enable yet! ----- \n");
+
+	val->value.i = smi->learn_enabled;
+
+	return 0;
+}
+
+static int rtl819x_sw_set_learning_enable(struct switch_dev *dev,
+					const struct switch_attr *attr,
+					struct switch_val *val)
+{
+	printk(" Not support swconfig rtl819x_sw_set_learning_enable yet! ----- \n");
+#if 0
+	struct rtl8366_smi *smi = sw_to_rtl8366_smi(dev);
+	u32 portmask = 0;
+	int err = 0;
+
+	if (!val->value.i)
+		portmask = RTL8366S_PORT_ALL;
+
+	/* set learning for all ports */
+	REG_WR(smi, RTL8366S_SSCR0, portmask);
+
+	/* set auto ageing for all ports */
+	REG_WR(smi, RTL8366S_SSCR1, portmask);
+#endif
+	return 0;
+}
+
+int rtl819x_sw_set_vlan_enable(struct switch_dev *dev,
+				const struct switch_attr *attr,
+				struct switch_val *val)
+{
+	struct rtl819x_smi *smi = sw_to_rtl819x_smi(dev);
+
+	//printk("rtl819x_sw_set_vlan_enable ----- \n");
+
+	smi->vlan_enabled = val->value.i;
+	smi->vlan4k_enabled = val->value.i;
+
+	rtk_set_vlan_enable(smi->vlan_enabled);
+
+	return 0;
+}
+
+int rtl819x_sw_get_vlan_enable(struct switch_dev *dev,
+				const struct switch_attr *attr,
+				struct switch_val *val)
+{
+	struct rtl819x_smi *smi = sw_to_rtl819x_smi(dev);
+
+	//printk("rtl819x_sw_get_vlan_enable ----- \n");
+	if (attr->ofs > 2)
+		return -EINVAL;
+
+	if (attr->ofs == 1)
+		val->value.i = smi->vlan_enabled;
+	else
+		val->value.i = smi->vlan4k_enabled;
+
+	return 0;
+}
+
+static struct switch_attr rtl819x_globals[] = {
+	{
+		.type = SWITCH_TYPE_INT,
+		.name = "enable_learning",
+		.description = "Enable learning, enable aging",
+		.set = rtl819x_sw_set_learning_enable,
+		.get = rtl819x_sw_get_learning_enable,
+		.max = 1,
+	}, {
+		.type = SWITCH_TYPE_INT,
+		.name = "enable_vlan",
+		.description = "Enable VLAN mode",
+		.set = rtl819x_sw_set_vlan_enable,
+		.get = rtl819x_sw_get_vlan_enable,
+		.max = 1,
+		.ofs = 1
+	}, {
+		.type = SWITCH_TYPE_INT,
+		.name = "enable_vlan4k",
+		.description = "Enable VLAN 4K mode",
+		.set = rtl819x_sw_set_vlan_enable,
+		.get = rtl819x_sw_get_vlan_enable,
+		.max = 1,
+		.ofs = 2
+	},
+#if 0
+	{
+		.type = SWITCH_TYPE_NOVAL,
+		.name = "reset_mibs",
+		.description = "Reset all MIB counters",
+		.set = rtl8366s_sw_reset_mibs,
+	}, {
+		.type = SWITCH_TYPE_INT,
+		.name = "blinkrate",
+		.description = "Get/Set LED blinking rate (0 = 43ms, 1 = 84ms,"
+		" 2 = 120ms, 3 = 170ms, 4 = 340ms, 5 = 670ms)",
+		.set = rtl8366s_sw_set_blinkrate,
+		.get = rtl8366s_sw_get_blinkrate,
+		.max = 5
+	},
+#endif
+};
+
+#if 0				//mark_bb
+static int rtl819x_sw_get_port_link(struct switch_dev *dev,
+				const struct switch_attr *attr,
+				struct switch_val *val)
+{
+	struct rtl819x_smi *smi = sw_to_rtl819x_smi(dev);
+	int len = 0 ;
+	int port=0;
+
+	if (val->port_vlan >= RTL819X_NUM_PORTS)
+		return -EINVAL;
+	port = val->port_vlan;
+
+	memset(smi->buf, '\0', sizeof(smi->buf));
+
+	len = rtk_get_port_status(port, smi->buf, sizeof(smi->buf));
+
+	val->value.s = smi->buf;
+	val->len = len;
+
+	return 0;
+}
+#endif
+static int rtl819x_sw_get_port_link(struct switch_dev *dev,
+				int port,
+				struct switch_port_link *link)
+{
+	//struct rtl819x_smi *smi = sw_to_rtl819x_smi(dev);
+
+	if (port >= RTL819X_NUM_PORTS)
+		return -EINVAL;
+
+	return rtk_get_port_status(port, link);
+}
+
+static int rtl819x_sw_reset_port_mibs(struct switch_dev *dev,
+				const struct switch_attr *attr,
+				struct switch_val *val)
+{
+	//printk("rtl819x_sw_reset_port_mibs ----- \n");
+	rtk_reset_mibCounter();
+	return 0;
+}
+
+int rtl819x_sw_get_port_mib(struct switch_dev *dev,
+			const struct switch_attr *attr,
+			struct switch_val *val)
+{
+	struct rtl819x_smi *smi = sw_to_rtl819x_smi(dev);
+	int i, len = 0;
+
+	//unsigned long long counter = 0;
+	char *buf = smi->buf;
+
+	//printk("rtl819x_sw_get_port_mib ----- \n");
+
+	if (val->port_vlan >= smi->num_ports)
+		return -EINVAL;
+
+	len += snprintf(buf + len, sizeof(smi->buf) - len,
+		"Port %d MIB counters\n", val->port_vlan);
+
+	for (i = 0; i < smi->num_mib_counters; ++i) {
+		len += snprintf(buf + len, sizeof(smi->buf) - len,
+			"%-36s: ", (char *)rtk_get_mibCounter_name(i));
+
+		len += snprintf(buf + len, sizeof(smi->buf) - len,
+			"%d\n",
+			(unsigned int)rtk_get_mibCounter_val(val->port_vlan,
+				i));
+	}
+
+	val->value.s = buf;
+	val->len = len;
+
+	return 0;
+}
+
+static struct switch_attr rtl819x_port[] = {
+#if 0 //mark_bb , move to main ops in latest swconfig ops
+	{
+		.type = SWITCH_TYPE_STRING,
+		.name = "link",
+		.description = "Get port link information",
+		.max = 1,
+		.set = NULL,
+		.get = rtl819x_sw_get_port_link,
+	},
+#endif
+	{
+		.type = SWITCH_TYPE_NOVAL,
+		.name = "reset_mib",
+		.description = "Reset single port MIB counters",
+		.set = rtl819x_sw_reset_port_mibs,
+	}, {
+		.type = SWITCH_TYPE_STRING,
+		.name = "mib",
+		.description = "Get MIB counters for port",
+		.max = 33,
+		.set = NULL,
+		.get = rtl819x_sw_get_port_mib,
+	},
+#if 0
+	{
+		.type = SWITCH_TYPE_INT,
+		.name = "led",
+		.description = "Get/Set port group (0 - 3) led mode (0 - 15)",
+		.max = 15,
+		.set = rtl8366s_sw_set_port_led,
+		.get = rtl8366s_sw_get_port_led,
+	},
+#endif
+};
+
+static int rtl819x_get_vlan_4k(u32 vid, struct rtl819x_vlan_4k *vlan4k)
+{
+	int ret = 0;
+
+	memset(vlan4k, '\0', sizeof(struct rtl819x_vlan_4k));
+
+	if (vid >= RTL819X_NUM_VIDS || vid == 0)
+		return -EINVAL;
+
+	ret = rtk_get_vlan_entry(vid, vlan4k);
+
+	return ret;
+
+}
+
+int rtl819x_sw_get_vlan_info(struct switch_dev *dev,
+			const struct switch_attr *attr,
+			struct switch_val *val)
+{
+
+	int i;
+	u32 len = 0;
+	struct rtl819x_vlan_4k vlan4k;
+	struct rtl819x_smi *smi = sw_to_rtl819x_smi(dev);
+	char *buf = smi->buf;
+	int err;
+
+	//if (!smi->ops->is_vlan_valid(smi, val->port_vlan))
+	//return -EINVAL;
+
+	memset(buf, '\0', sizeof(smi->buf));
+
+	err = rtl819x_get_vlan_4k(val->port_vlan, &vlan4k);
+
+	if (err)
+		return err;
+
+	len += snprintf(buf + len, sizeof(smi->buf) - len,
+		"VLAN %d: Ports: '", vlan4k.vid);
+
+	for (i = 0; i < smi->num_ports; i++) {
+		if (!(vlan4k.member & (1 << i)))
+			continue;
+
+		len += snprintf(buf + len, sizeof(smi->buf) - len, "%d%s", i,
+			(vlan4k.untag & (1 << i)) ? "" : "t");
+	}
+
+	len += snprintf(buf + len, sizeof(smi->buf) - len,
+		"', members=%04x, untag=%04x, fid=%u",
+		vlan4k.member, vlan4k.untag, vlan4k.fid);
+
+	val->value.s = buf;
+	val->len = len;
+
+	return 0;
+}
+
+int rtl819x_sw_get_vlan_fid(struct switch_dev *dev,
+			const struct switch_attr *attr,
+			struct switch_val *val)
+{
+
+	struct rtl819x_vlan_4k vlan4k;
+
+	//struct rtl819x_smi *smi = sw_to_rtl819x_smi(dev);
+	int err;
+
+	//if (!smi->ops->is_vlan_valid(smi, val->port_vlan))
+	//return -EINVAL;
+
+	err = rtl819x_get_vlan_4k(val->port_vlan, &vlan4k);
+
+	if (err)
+		return err;
+
+	val->value.i = vlan4k.fid;
+
+	return 0;
+}
+
+int rtl819x_sw_set_vlan_fid(struct switch_dev *dev,
+			const struct switch_attr *attr,
+			struct switch_val *val)
+{
+	//printk("rtl819x_sw_set_vlan_fid ----- \n");
+	return 0;
+}
+
+int rtl819x_sw_get_vlan_ports(struct switch_dev *dev, struct switch_val *val)
+{
+
+	struct rtl819x_smi *smi = sw_to_rtl819x_smi(dev);
+	struct switch_port *port;
+	struct rtl819x_vlan_4k vlan4k;
+	int i;
+
+	//printk("rtl819x_sw_get_vlan_ports ----- \n");
+
+	//if (!smi->ops->is_vlan_valid(smi, val->port_vlan))
+	//      return -EINVAL;
+
+	rtl819x_get_vlan_4k(val->port_vlan, &vlan4k);
+
+	port = &val->value.ports[0];
+	val->len = 0;
+	for (i = 0; i < smi->num_ports; i++) {
+		if (!(vlan4k.member & BIT(i)))
+			continue;
+
+		port->id = i;
+		port->flags = (vlan4k.untag & BIT(i)) ?
+			0 : BIT(SWITCH_PORT_FLAG_TAGGED);
+		val->len++;
+		port++;
+	}
+
+	return 0;
+}
+
+int rtl819x_sw_set_vlan_ports(struct switch_dev *dev, struct switch_val *val)
+{
+	//struct rtl819x_smi *smi = sw_to_rtl819x_smi(dev);
+	struct switch_port *port;
+	u32 member = 0;
+	u32 untag = 0;
+	int err;
+	int i;
+
+	//printk("rtl819x_sw_set_vlan_ports -----vid=%d \n",val->port_vlan );
+	port = &val->value.ports[0];
+
+	for (i = 0; i < val->len; i++, port++) {
+		member |= BIT(port->id);
+
+		if (!(port->flags & BIT(SWITCH_PORT_FLAG_TAGGED))) {
+			untag |= BIT(port->id);
+			//only change port's pvid if it is untag port in this vlan
+			err = rtk_set_port_pvid(port->id, val->port_vlan);
+		}
+
+	}
+
+	return rtk_set_hw_vlan(val->port_vlan, member, untag, 0);
+
+}
+
+int rtl819x_sw_get_port_pvid(struct switch_dev *dev, int port, int *val)
+{
+
+	rtk_get_port_pvid(port, val);
+	//printk("rtl819x_sw_get_port_pvid port%d=%d ----- \n",port,*val);
+
+	return 0;
+}
+
+int rtl819x_sw_set_port_pvid(struct switch_dev *dev, int port, int val)
+{
+	int err;
+
+	//printk("rtl819x_sw_set_port_pvid ----- \n");
+	err = rtk_set_port_pvid(port, val);
+
+	return err;
+}
+
+static int rtl819x_sw_reset_switch(struct switch_dev *dev)
+{
+	//printk("rtl819x_sw_reset_switch ----- \n");
+	rtk_reset_layer2_setting();
+	return 0;
+}
+
+static struct switch_attr rtl819x_vlan[] = {
+	{
+		.type = SWITCH_TYPE_STRING,
+		.name = "info",
+		.description = "Get vlan information",
+		.max = 1,
+		.set = NULL,
+		.get = rtl819x_sw_get_vlan_info,
+	}, {
+		.type = SWITCH_TYPE_INT,
+		.name = "fid",
+		.description = "Get/Set vlan FID",
+		.max = RTL819X_FIDMAX,
+		.set = rtl819x_sw_set_vlan_fid,
+		.get = rtl819x_sw_get_vlan_fid,
+	},
+};
+
+static const struct switch_dev_ops rtl819x_swconfig_ops = {
+	.attr_global = {
+		.attr = rtl819x_globals,
+		.n_attr = ARRAY_SIZE(rtl819x_globals),
+	},
+	.attr_port = {
+		.attr = rtl819x_port,
+		.n_attr = ARRAY_SIZE(rtl819x_port),
+	},
+	.attr_vlan = {
+		.attr = rtl819x_vlan,
+		.n_attr = ARRAY_SIZE(rtl819x_vlan),
+	},
+
+	.get_vlan_ports = rtl819x_sw_get_vlan_ports,
+	.set_vlan_ports = rtl819x_sw_set_vlan_ports,
+	.get_port_pvid = rtl819x_sw_get_port_pvid,
+	.set_port_pvid = rtl819x_sw_set_port_pvid,
+	.reset_switch = rtl819x_sw_reset_switch,
+	.get_port_link =  rtl819x_sw_get_port_link, //mark_bb
+};
+
+static int rtl819x_smi_init(struct rtl819x_smi *rtl819x_smi_driver_p)
+{
+	memset((char *)rtl819x_smi_driver_p, 0, sizeof(struct rtl819x_smi));
+
+	rtl819x_smi_driver_p->cpu_port = RTL819X_PORT_NUM_CPU;
+	rtl819x_smi_driver_p->num_ports = RTL819X_NUM_PORTS;
+	//rtl819x_smi_driver_p->num_vlan_mc = RTL8366S_NUM_VLANS;
+	//rtl819x_smi_driver_p->mib_counters = rtl819x_mib_counters;
+	rtl819x_smi_driver_p->num_mib_counters = rtk_get_mibCounter_num();
+	rtl819x_smi_driver_p->learn_enabled = 1;	//mark_bb , default say yes
+	return 0;
+}
+
+int rtl819x_swconfig_init(struct net_device *netdev)
+{
+	struct switch_dev *dev;
+	int err;
+
+	rtl819x_smi_init(&rtl819x_smi_driver);
+	dev = &rtl819x_smi_driver.sw_dev;
+
+	dev->name = "rtl819x";
+	dev->cpu_port = RTL819X_PORT_NUM_CPU;
+	dev->ports = RTL819X_NUM_PORTS;
+	dev->vlans = RTL819X_NUM_VIDS;
+	dev->ops = &rtl819x_swconfig_ops;
+	//dev->alias = dev_name(smi->parent);
+
+	//err = register_switch(dev, NULL);
+	err = register_switch(dev, netdev);
+	if (err)
+		printk("switch device registration failed\n");
+
+	return err;
+}
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_switch.h b/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_switch.h
new file mode 100644
index 00000000..f2128e2
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl819x_switch.h
@@ -0,0 +1,28 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+struct rtl819x_vlan_4k {
+	u16	vid;
+	u8	untag;
+	u8	member;
+	u8	fid;
+};
+
+#define RTL819X_PORT_NUM_CPU		6
+#define RTL819X_NUM_PORTS		7
+#define RTL819X_NUM_VLANS		16
+#define RTL819X_NUM_VIDS		4096
+#define RTL819X_FIDMAX			2
+
+
+#define RTL819X_HW_PORT_NUM_CPU	8
+#define RTL819X_HW_CPUPORT_MASK	(1 << RTL819X_HW_PORT_NUM_CPU)
+#define RTL819X_HW_PORT_ALL_MASK	0x7f // (port0~port6)
+
+int rtl819x_swconfig_init(struct net_device *netdev);
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl865x/Makefile b/drivers/soc/realtek/rtd129x/hw_nat/rtl865x/Makefile
new file mode 100644
index 00000000..146896e
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl865x/Makefile
@@ -0,0 +1,89 @@
+#
+# Makefile for the Tulip ethernet driver
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+# Note 2! The CFLAGS definitions are now in the main makefile...
+
+
+obj-y := ../common/built-in.o
+subdir-y := ../common
+
+obj-y += ../AsicDriver/built-in.o
+subdir-y += ../AsicDriver
+
+ifdef CONFIG_RTL_LAYERED_DRIVER
+	ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+               obj-y += ../l2Driver/built-in.o
+               subdir-y += ../l2Driver
+	else
+		ifdef CONFIG_RTL_STP
+			obj-y += ../l2Driver/built-in.o
+			subdir-y += ../l2Driver
+		endif
+	endif
+else
+	obj-y += ../l2Driver/built-in.o
+	subdir-y += ../l2Driver
+endif
+
+ifdef CONFIG_RTL_LAYERED_DRIVER
+	ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+		obj-y += ../l3Driver/built-in.o
+		subdir-y += ../l3Driver
+	else
+		ifdef CONFIG_RTL_HARDWARE_MULTICAST
+			obj-y += ../l3Driver/built-in.o
+			subdir-y += ../l3Driver
+		endif
+	endif
+else
+	obj-y += ../l3Driver/built-in.o
+	subdir-y += ../l3Driver
+endif
+
+ifdef CONFIG_RTL_LAYERED_DRIVER
+	ifdef CONFIG_RTL_LAYERED_DRIVER_L4
+		obj-y += ../l4Driver/built-in.o
+		subdir-y += ../l4Driver
+	endif
+else
+	obj-y += ../l4Driver/built-in.o
+	subdir-y += ../l4Driver
+endif
+
+ifdef CONFIG_RTL_IGMP_SNOOPING
+obj-y += ../igmpsnooping/built-in.o
+subdir-y += ../igmpsnooping
+endif
+
+ifdef CONFIG_8198_PORT5_RGMII
+	obj-y += ../RTL8370_RTL8367_API/built-in.o
+	subdir-y += ../RTL8370_RTL8367_API
+endif
+
+ifdef CONFIG_RTL_8370_SUPPORT
+	obj-y += ../RTL8370_RTL8367_API/built-in.o
+	subdir-y += ../RTL8370_RTL8367_API
+endif
+
+ifdef CONFIG_RTL_8367R_SUPPORT
+	obj-y += ../rtl8367r/built-in.o
+	subdir-y += ../rtl8367r
+endif
+
+ifdef CONFIG_RTL_8325D_SUPPORT
+	obj-y += ../rtl8325d/built-in.o
+	subdir-y += ../rtl8325d
+endif
+
+ifdef CONFIG_RTL_8198C_8367RB
+	obj-y += ../rtl8367r/built-in.o
+	subdir-y += ../rtl8367r
+endif
+EXTRA_CFLAGS += -O1 -DRTL_TBLDRV -D__linux__ -DRTL865X_OVER_KERNEL -DRTL865X_OVER_LINUX -Werror
+
+EXTRA_AFLAGS += $(EXTRA_CFLAGS)
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl865x_log.h b/drivers/soc/realtek/rtd129x/hw_nat/rtl865x_log.h
new file mode 100644
index 00000000..736312d
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl865x_log.h
@@ -0,0 +1,52 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef	RTL865X_LOG_H
+#define	RTL865X_LOG_H
+
+#if defined(CONFIG_RTL_LOG_DEBUG)
+
+	#if defined(LOG_ERROR)
+	#undef LOG_ERROR
+	#define LOG_ERROR(fmt, args...) do{ \
+		if(RTL_LogTypeMask.ERROR&&RTL_LogModuleMask.NIC&&LOG_LIMIT)scrlog_printk("NIC-ERROR:"fmt, ## args); \
+			}while(0)
+	#endif
+
+	#if defined(LOG_MEM_ERROR)
+	#undef LOG_MEM_ERROR
+	#define LOG_MEM_ERROR(fmt, args...) do{ \
+		if(RTL_LogTypeMask.ERROR&&RTL_LogErrorMask.MEM&&RTL_LogModuleMask.NIC&&LOG_LIMIT)scrlog_printk("NIC-MEM-ERROR:"fmt, ## args); \
+			}while(0)
+	#endif
+
+	#if defined(LOG_SKB_ERROR)
+	#undef LOG_SKB_ERROR
+	#define LOG_SKB_ERROR(fmt, args...) do{ \
+		if(RTL_LogTypeMask.ERROR&&RTL_LogErrorMask.SKB&&RTL_LogModuleMask.NIC&&LOG_LIMIT)scrlog_printk("NIC-SKB-ERROR:"fmt, ## args); \
+			}while(0)
+	#endif
+
+	#if defined(LOG_WARN)
+	#undef LOG_WARN
+	#define LOG_WARN(fmt, args...) do{ \
+		if(RTL_LogTypeMask.WARN&&RTL_LogModuleMask.NIC&&LOG_LIMIT)scrlog_printk("NIC-WARN:"fmt, ## args); \
+			}while(0)
+	#endif
+
+	#if defined(LOG_INFO)
+	#undef LOG_INFO
+	#define LOG_INFO(fmt, args...) do{ \
+		if(RTL_LogTypeMask.INFO&&RTL_LogModuleMask.NIC&&LOG_LIMIT)scrlog_printk("NIC-INFO:"fmt, ## args); \
+			}while(0)
+	#endif
+
+#endif
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl865x_proc_debug.c b/drivers/soc/realtek/rtd129x/hw_nat/rtl865x_proc_debug.c
new file mode 100644
index 00000000..3e941a1
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl865x_proc_debug.c
@@ -0,0 +1,15825 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : just for driver debug
+* Abstract :
+* Author : Hyking Liu (Hyking_liu@realsil.com.tw)
+* -------------------------------------------------------
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "rtl865x_proc_debug.h"
+#include <linux/kernel.h>
+#include <linux/delay.h>
+#if defined(CONFIG_RTD_1295_HWNAT)
+#include <linux/uaccess.h>
+#if defined(CONFIG_RTL_836X_SUPPORT)
+#include <linux/spinlock.h>
+#include "rtl836x/rtk_switch.h"
+#include "rtl836x/rtk_types.h"
+#include "rtl836x/stat.h"
+#include "rtl836x/rtk_rtl8367.h"
+#endif /* CONFIG_RTL_836X_SUPPORT */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl865x_netif_local.h"
+#include "common/rtl865x_eventMgr.h"
+#include "common/rtl_utils.h"
+
+#ifdef CONFIG_RTL_ADAPTABLE_TSO
+#include <linux/netdev_features.h>
+extern netdev_features_t tso_feature;
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+#include <net/rtl/rtl865x_ppp.h>
+#include "l3Driver/rtl865x_ppp_local.h"
+#include "l3Driver/rtl865x_route.h"
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+#include <net/rtl/rtl865x_multipleWan_api.h>
+#include "l3Driver/rtl865x_multipleWan.h"
+#endif
+
+#ifdef CONFIG_RTL_HW_DSLITE_SUPPORT
+#include "l3Driver/rtl865x_dslite.h"
+#endif
+#ifdef CONFIG_RTL_HW_6RD_SUPPORT
+#include <linux/netdevice.h>
+#include <net/ip_tunnels.h>
+#include "l3Driver/rtl865x_6rd.h"
+#endif
+
+#endif
+
+#include "AsicDriver/rtl865x_asicBasic.h"
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#if defined(CONFIG_RTL_LAYERED_ASIC_DRIVER_L3) || defined(CONFIG_OPENWRT_SDK)
+#include "AsicDriver/rtl865x_asicL3.h"
+#endif
+#if defined(CONFIG_RTL_LAYERED_ASIC_DRIVER_L4) || defined(CONFIG_OPENWRT_SDK)
+#include "AsicDriver/rtl865x_asicL4.h"
+#endif
+
+#include "AsicDriver/rtl865xc_asicregs.h"
+#include "AsicDriver/rtl865xC_hs.h"
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+#include <net/rtl/rtl865x_igmpsnooping.h>
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+#include <net/rtl/rtl865x_outputQueue.h>
+#endif
+
+#include "rtl865xc_swNic.h"
+#if defined(CONFIG_RTL_ETH_PRIV_SKB_DEBUG)
+#include <linux/netdevice.h>
+#include <linux/inetdevice.h>
+#include <linux/if.h>
+#include <net/rtl/rtl_nic.h>
+#endif
+
+#if defined(CONFIG_RTL_SWITCH_NEW_DESCRIPTOR)
+#include "rtl819x_swNic.h"
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+/* debug NAPT hash entries */
+#include <net/rtl/rtl865x_nat.h>
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+#include "common/rtl865x_vlan.h"
+extern int32 rtl865xC_setAsicEthernetForceModeRegs(uint32 port,
+	uint32 enForceMode, uint32 forceLink, uint32 forceSpeed,
+	uint32 forceDuplex);
+extern int32 rtl8651_setAsicEthernetPHYSpeed(uint32 port, uint32 speed);
+extern int32 rtl8651_setAsicEthernetPHYDuplex(uint32 port, uint32 duplex);
+extern int32 rtl8651_setAsicEthernetPHYAutoNeg(uint32 port, uint32 autoneg);
+extern int32 rtl8651_setAsicEthernetPHYAdvCapality(uint32 port,
+	uint32 capality);
+extern int32 mmd_read(uint32 phyId, uint32 devId, uint32 regId, uint32 *rData);
+extern int32 mmd_write(uint32 phyId, uint32 devId, uint32 regId, uint32 wData);
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+extern int rtl8367b_getAsicPHYReg(uint32 phyNo, uint32 phyAddr,
+	uint32 *pRegData);
+extern int rtl8367b_setAsicPHYReg(uint32 phyNo, uint32 phyAddr, uint32 phyData);
+extern int rtl8367b_getAsicReg(uint32 reg, uint32 *pValue);
+extern int rtl8367b_setAsicReg(uint32 reg, uint32 value);
+extern int rtk_vlan_get(uint32 vid, uint32 *pMbrmsk, uint32 *pUntagmsk,
+	uint32 *pFid);
+extern int rtk_vlan_portPvid_get(uint32 port, uint32 *pPvid, uint32 *pPriority);
+#endif
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+extern unsigned int rx_noBuffer_cnt;
+extern unsigned int tx_ringFull_cnt;
+extern unsigned int tx_drop_cnt;
+unsigned int statistic_total;
+unsigned int statistic_ps;
+unsigned int statistic_ipv6_fp;
+
+#if !defined(CONFIG_OPENWRT_SDK)
+unsigned int statistic_fp;
+#endif
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#include "m24kctrl.h"		/* added for romperf testing */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_OPENWRT_SDK)
+unsigned int statistic_fastpath;
+EXPORT_SYMBOL(statistic_fastpath);
+#endif
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+extern void __iomem *rtl_hwnat_mmio;
+extern unsigned int rtl_hwnat_base;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+/* #define CONFIG_FORCE_10M_100M_FULL_REFINE 1 */
+#ifndef CONFIG_OPENWRT_SDK
+#define CONFIG_TR181_ETH  1
+#endif
+
+#ifdef CONFIG_TR181_ETH
+struct proc_dir_entry *rtl865x_proc_dir;
+#else
+static struct proc_dir_entry *rtl865x_proc_dir;
+#endif
+
+#ifndef CONFIG_RTL_PROC_NEW
+#ifdef CONFIG_RTL_PROC_DEBUG	/* proc debug flag */
+static struct proc_dir_entry *vlan_entry, *netif_entry, *l2_entry, *arp_entry,
+	*nexthop_entry, *l3_entry, *ip_entry, *pppoe_entry, *napt_entry,
+	*acl_entry, *storm_control, *sw_netif_entry, *sw_nexthop_entry,
+	*sw_l3_entry,
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	*advRt_entry,
+#endif
+#if defined(RTL_DEBUG_NIC_SKB_BUFFER)
+	*nic_skb_buff,
+#endif
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+	*acl_chains_entry,
+#endif
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	*qos_rule_entry,
+#endif
+	*rxRing_entry, *txRing_entry, *mbuf_entry,
+	*hs_entry, *pvid_entry, *mirrorPort_entry,
+#if defined(CONFIG_RTL_LAYERED_DRIVER_L4)
+	*sw_napt_entry,
+#endif
+	*port_bandwidth_entry, *queue_bandwidth_entry,
+	*priority_decision_entry,
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	*swMCast_entry,
+#endif
+#if defined(CONFIG_RTL_ENABLE_RATELIMIT_TABLE)
+	*rateLimit_entry,
+#endif
+	*hwMCast_entry;
+#endif
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+/*#if defined(CONFIG_RTL_ETH_PRIV_SKB_DEBUG)*/
+static struct proc_dir_entry *prive_skb_debug_entry;
+
+/*#endif*/
+
+static struct proc_dir_entry *mmd_entry, *mem_entry, *diagnostic_entry,
+	*asicCnt_entry, *phyReg_entry, *port_status_entry, *mac_entry,
+	*fc_threshold_entry, *stats_debug_entry
+#if defined(CONFIG_RTL_INBAND_CTL_API) && !defined(CONFIG_RTL_PROC_NEW)
+, *portRate_entry
+#endif
+;
+
+#define	PROC_READ_RETURN_VALUE		0
+extern int32 mmd_read(uint32 phyId, uint32 devId, uint32 regId, uint32 *rData);
+extern int32 mmd_write(uint32 phyId, uint32 devId, uint32 regId, uint32 wData);
+
+#if defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8211F_SUPPORT)
+extern int rtl_mdio_read(unsigned int mdio_phyaddr, unsigned int reg,
+	unsigned int *pdata);
+extern int rtl_mdio_write(unsigned int mdio_phyaddr, unsigned int reg,
+	unsigned int data);
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+/* #define CONFIG_RTL_PROC_NEW */
+static struct proc_dir_entry *l3v6_entry, *arp6_entry, *nexthop6_entry,
+	*mcast6_entry, *ip6rd_entry, *dslite_entry, *sw_dslite_entry,
+	*sw_arp6_entry;
+#endif
+
+#endif
+#endif
+
+#ifndef PROC_READ_RETURN_VALUE
+#define	PROC_READ_RETURN_VALUE		0
+#endif
+
+static void ntohl_array(u32 *org_buf, u32 *dst_buf, unsigned int words)
+{
+	int i = 0;
+
+	if (!org_buf || !dst_buf)
+		return;
+	while (words--) {
+		dst_buf[i] = ntohl(org_buf[i]);
+		i++;
+	}
+
+	return;
+}
+
+#if defined CONFIG_RTL_DEBUG_TOOL	/* debug tool flag */
+#ifndef CONFIG_RTL_PROC_DEBUG
+ /* #ifndef RTK_X86_CLE */ /* RTK-CNSD2-NickWu-20061222: for x86 compile */
+ /*cfliu: This function is only for debugging. Should not be used in production code... */
+
+void memDump(void *start, uint32 size, int8 *strHeader)
+{
+	int32 row, column, index, index2, max;
+	uint32 buffer[5];
+	uint8 *buf, *line, ascii[17];
+	int8 empty = ' ';
+
+	if (!start || (size == 0))
+		return;
+	line = (uint8 *)start;
+
+	/*
+	 * 16 bytes per line
+	 */
+	if (strHeader)
+		rtlglue_printf("%s", strHeader);
+	column = size % 16;
+	row = (size / 16) + 1;
+	for (index = 0; index < row; index++, line += 16) {
+#ifdef RTL865X_TEST
+		buf = (uint8 *)line;
+#else
+		/* for un-alignment access */
+		buffer[0] = ntohl(READ_MEM32((((uint32)line) & ~3) + 0));
+		buffer[1] = ntohl(READ_MEM32((((uint32)line) & ~3) + 4));
+		buffer[2] = ntohl(READ_MEM32((((uint32)line) & ~3) + 8));
+		buffer[3] = ntohl(READ_MEM32((((uint32)line) & ~3) + 12));
+		buffer[4] = ntohl(READ_MEM32((((uint32)line) & ~3) + 16));
+		buf = ((uint8 *)buffer) + (((uint32)line) & 3);
+#endif
+
+		memset(ascii, 0, 17);
+
+		max = (index == row - 1) ? column : 16;
+		if (max == 0)
+			break;	/* If we need not dump this line, break it. */
+
+		rtlglue_printf("\n%08x:  ", (memaddr)line);
+
+		/* Hex */
+		for (index2 = 0; index2 < max; index2++) {
+			if (index2 == 8)
+				rtlglue_printf("  ");
+			rtlglue_printf("%02X", (uint8)buf[index2]);
+			ascii[index2] = ((uint8)buf[index2] < 32) ? empty : buf[index2];
+			if ((index2 + 1) % 4 == 0)
+				rtlglue_printf("  ");
+		}
+
+		if (max != 16) {
+			if (max < 8)
+				rtlglue_printf("	");
+			for (index2 = 16 - max; index2 > 0; index2--)
+				rtlglue_printf("	 ");
+		}
+		/* ASCII */
+		rtlglue_printf("	%s", ascii);
+	}
+	rtlglue_printf("\n");
+	return;
+}
+#endif
+#endif
+
+void memDump2(void *start, uint32 size)
+{
+	int i, j;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	const uintptr_t mem_base = (uintptr_t) rtl_hwnat_mmio - rtl_hwnat_base;
+	uint32 phys_addr;
+	uintptr_t addr = 0;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	uint32 addr = 0;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	unsigned char *p = (unsigned char *)start;
+
+	if (!start || (size == 0))
+		return;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	addr = (uintptr_t) start;
+	if (addr > (uintptr_t) rtl_hwnat_mmio
+		&& (addr - (uintptr_t) rtl_hwnat_mmio) < 0x170000) {
+		/* rbus virtual address */
+		phys_addr = addr - mem_base;
+	} else if (addr > rtl_hwnat_base && (addr - rtl_hwnat_base) < 0x170000) {
+		/* rbus physical address */
+		phys_addr = addr;
+		addr += mem_base;
+	} else {
+		phys_addr = virt_to_phys((void *)addr);
+	}
+	rtlglue_printf("physical memory 0x%08x : virtual memory 0x%p\n",
+		phys_addr, start);
+	if (phys_addr < 0x80000000 || phys_addr > 0xbfffffff) {
+		return;
+	}
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	addr = (uint32)start;
+	if (addr < 0x80000000 || addr > 0xbfffffff) {
+		return;
+	}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	while ((addr) & 0x03)
+		addr++;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if ((phys_addr + size) < rtl_hwnat_base
+		|| phys_addr >= (rtl_hwnat_base + 0x170000))
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (addr < 0xb8000000)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	{
+
+		for (i = 0; i < size; i += 16, p += 16) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+			rtlglue_printf("%08lX: ", (uintptr_t) p);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			rtlglue_printf("%08X: ", (unsigned int)p);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+			for (j = 0; j < 16; j++) {
+				rtlglue_printf("%02X ", (unsigned int)(*(p + j)));
+				if (((j + 1) % 4) == 0)
+					rtlglue_printf("  ");
+			}
+			rtlglue_printf("\n");
+		}
+		rtlglue_printf("\n");
+	} else {
+		for (i = 0; i < size; i += 4, addr += 16) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+			phys_addr = addr - mem_base;
+			rtlglue_printf("%08X:	%08X %08X  %08X %08X\n",
+				phys_addr,
+				(unsigned int)*(unsigned long *)(addr),
+				(unsigned int)*(unsigned long *)(addr + 4),
+				(unsigned int)*(unsigned long *)(addr + 8),
+				(unsigned int)*(unsigned long *)(addr + 12));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			rtlglue_printf("%08X:	%08X	%08X	%08X	%08X\n",
+				(unsigned int)addr,
+				(unsigned int)*(unsigned long *)(addr),
+				(unsigned int)*(unsigned long *)(addr+4),
+				(unsigned int)*(unsigned long *)(addr+8),
+				(unsigned int)*(unsigned long *)(addr+12));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		}
+	}
+
+	return;
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+void memDump3(void *start, uint32 size, int8 *strHeader)
+{
+	int32 row, column, index, index2, max;
+	uint32 buffer[5];
+	uint8 *buf, *line, ascii[17];
+	int8 empty = ' ';
+	const uintptr_t mem_base = (uintptr_t) rtl_hwnat_mmio - rtl_hwnat_base;
+	uint32 phys_addr;
+
+	if (!start || (size == 0))
+		return;
+	line = (uint8 *)start;
+	phys_addr = (uintptr_t) start - mem_base;
+
+	/*
+	 * 16 bytes per line
+	 */
+	if (strHeader)
+		rtlglue_printf("%s", strHeader);
+	column = size % 16;
+	row = (size / 16) + 1;
+	for (index = 0; index < row; index++, line += 16) {
+#ifdef RTL865X_TEST
+		buf = (uint8 *)line;
+#else
+		/* for un-alignment access */
+		buffer[0] = ntohl(READ_MEM32((((uintptr_t) line) & ~3) + 0));
+		buffer[1] = ntohl(READ_MEM32((((uintptr_t) line) & ~3) + 4));
+		buffer[2] = ntohl(READ_MEM32((((uintptr_t) line) & ~3) + 8));
+		buffer[3] = ntohl(READ_MEM32((((uintptr_t) line) & ~3) + 12));
+		buffer[4] = ntohl(READ_MEM32((((uintptr_t) line) & ~3) + 16));
+		buf = ((uint8 *)buffer) + (((uintptr_t) line) & 3);
+#endif
+
+		memset(ascii, 0, 17);
+
+		max = (index == row - 1) ? column : 16;
+		if (max == 0)
+			break;	/* If we need not dump this line, break it. */
+
+		rtlglue_printf("\n%08x:  ", phys_addr);
+		phys_addr += 16;
+
+		/* Hex */
+		for (index2 = 0; index2 < max; index2++) {
+			if (index2 == 8)
+				rtlglue_printf("  ");
+			rtlglue_printf("%02X", (uint8)buf[index2]);
+			ascii[index2] = ((uint8)buf[index2] < 32) ? empty : buf[index2];
+			if ((index2 + 1) % 4 == 0)
+				rtlglue_printf("  ");
+		}
+
+		if (max != 16) {
+			if (max < 8)
+				rtlglue_printf("	");
+			for (index2 = 16 - max; index2 > 0; index2--)
+				rtlglue_printf("	 ");
+		}
+		/* ASCII */
+		rtlglue_printf("	%s", ascii);
+	}
+	rtlglue_printf("\n");
+	return;
+}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#ifdef CONFIG_RTL865X_ROMEPERF
+#ifdef CONFIG_RTL_PROC_NEW
+extern int32 rtl865x_perf_proc_read(struct seq_file *s, void *v);
+extern int32 rtl865x_perf_proc_write(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+#else
+static struct proc_dir_entry *perf_dump;
+extern int32 rtl865x_perf_proc_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+extern int32 rtl865x_perf_proc_write(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+#endif
+#endif
+
+#ifdef CONFIG_RTL_PROC_DEBUG
+
+static uint32 queue_bandwidth_record_portmask = 0;
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+#ifdef CONFIG_RTL_PROC_NEW
+int32 rtl_dumpSwMulticastInfo(struct seq_file *s);
+#else
+int32 rtl_dumpSwMulticastInfo(char *page, int *len);
+#endif
+#endif
+
+#ifndef CONFIG_RTL_PROC_NEW
+#if defined(CONFIG_RTL_LAYERED_DRIVER) && defined(CONFIG_RTL865X_EVENT_PROC_DEBUG)
+static struct proc_dir_entry *eventMgr_entry;
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+static struct proc_dir_entry *igmp_entry;
+#endif
+#endif
+
+extern int32 rtl865x_sw_napt_proc_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+extern int32 rtl865x_sw_napt_proc_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+#ifdef CONFIG_RTL_PROC_NEW
+extern int32 rtl865x_sw_l2_proc_read(struct seq_file *s, void *v);
+extern int32 rtl865x_sw_l2_proc_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+#else
+static struct proc_dir_entry *sw_l2_entry;
+extern int32 rtl865x_sw_l2_proc_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+extern int32 rtl865x_sw_l2_proc_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+#endif
+#endif
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+extern int32 sw_arp6_read(struct seq_file *s, void *v);
+#else
+extern int32 sw_arp6_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+#endif
+extern int32 sw_arp6_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+
+#if 0
+int vlan_show(void)
+{
+	int i, j;
+
+	for (i = 0; i < RTL865XC_VLAN_NUMBER; i++) {
+		rtl865x_tblAsicDrv_vlanParam_t vlan;
+
+		if (rtl8651_getAsicVlan(i, &vlan) == FAILED)
+			continue;
+
+		printk("  VID[%d] ", i);
+		printk("\n\tmember ports:");
+
+		for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+			if (vlan.memberPortMask & (1 << j))
+				printk("%d ", j);
+		}
+
+		printk("\n\tUntag member ports:");
+
+		for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+			if (vlan.untagPortMask & (1 << j))
+				printk("%d ", j);
+		}
+
+		printk("\n\tFID:\t%d\n", vlan.fid);
+	}
+
+	return SUCCESS;
+
+}
+#endif
+
+/* static int32 vlan_read( char *page, char **start, off_t off, int count, int *eof, void *data ) */
+static int32 vlan_single_show(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s\n", "ASIC VLAN Table:");
+
+	{
+		int i, j;
+
+		for (i = 0; i < RTL865XC_VLANTBL_SIZE; i++) {
+			rtl865x_tblAsicDrv_vlanParam_t vlan;
+
+			if (rtl8651_getAsicVlan(i, &vlan) == FAILED)
+				continue;
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+			seq_printf(s, "  idx [%d]  VID[%d] ", i, vlan.vid);
+#else
+			seq_printf(s, "  VID[%d] ", i);
+#endif
+			seq_printf(s, "\n\tmember ports:");
+
+			for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+				if (vlan.memberPortMask & (1 << j))
+					seq_printf(s, "%d ", j);
+			}
+
+			seq_printf(s, "\n\tUntag member ports:");
+
+			for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+				if (vlan.untagPortMask & (1 << j))
+					seq_printf(s, "%d ", j);
+			}
+
+			seq_printf(s, "\n\tFID:\t%d\n", vlan.fid);
+#if defined(CONFIG_RTL_8197F)
+			seq_printf(s, "\n\tHP:\t%d\n", vlan.hp);
+#endif
+		}
+
+	}
+
+	return 0;
+}
+
+#if defined(CONFIG_RTL_DYNAMIC_IRAM_MAPPING_FOR_WAPI)
+extern int switch_iram(uint32 addr);
+#endif
+
+extern int32 rtl865x_addVlan(uint16 vid);
+extern int32 rtl865x_addVlanPortMember(uint16 vid, uint32 portMask);
+extern int32 rtl865x_setVlanPortTag(uint16 vid, uint32 portMask, uint8 tag);
+extern int32 rtl865x_setVlanFilterDatabase(uint16 vid, uint32 fid);
+extern int32 rtl865x_delVlan(uint16 vid);
+
+static int32 vlan_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	char tmpbuf[256];
+
+	if (len > 32) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len - 1] = '\0';
+		if (tmpbuf[0] == '1') {
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+			rtl865x_AclRule_t rule;
+
+			memset(&rule, 0, sizeof(rtl865x_AclRule_t));
+			rule.actionType_ = RTL865X_ACL_PRIORITY;
+			rule.ruleType_ = RTL865X_ACL_IP;
+			rule.dstIpAddrLB_ = 0xc0a801fe;
+			rule.dstIpAddrUB_ = 0xc0a801fe;
+			rule.priority_ = 6;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+
+			rtl865x_add_acl(&rule, RTL_DRV_LAN_NETIF_NAME,
+				RTL865X_ACL_SYSTEM_USED);
+#endif
+
+		}
+#if defined(CONFIG_RTL_DYNAMIC_IRAM_MAPPING_FOR_WAPI)
+		else if (tmpbuf[0] == '2') {
+			switch_iram(0);
+
+		} else if (tmpbuf[0] == '3') {
+			switch_iram(1);
+		}
+#endif
+		else {
+			char *strptr, *cmd_addr;
+			char *tokptr;
+			int vid = 0;
+
+			strptr = tmpbuf;
+			cmd_addr = strsep(&strptr, " ");
+			if (cmd_addr == NULL) {
+				goto errout;
+			}
+			rtlglue_printf("cmd %s\n", cmd_addr);
+			if (!memcmp(cmd_addr, "dump", 4)) {
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+
+				vid = simple_strtol(tokptr, NULL, 0);
+				rtlglue_printf("Vlan info:\n");
+				{
+					rtl865x_tblAsicDrv_vlanParam_t vlan;
+					int j;
+
+					if (rtl8651_getAsicVlan(vid, &vlan) == FAILED)
+						return len;
+
+					rtlglue_printf("  VID[%d] ", vid);
+					rtlglue_printf("\n\tmember ports:");
+
+					for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++)
+					{
+						if (vlan.memberPortMask & (1 << j))
+							rtlglue_printf("%d ", j);
+					}
+
+					rtlglue_printf("\n\tUntag member ports:");
+
+					for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++)
+					{
+						if (vlan.untagPortMask & (1 << j))
+							rtlglue_printf("%d ", j);
+					}
+
+					rtlglue_printf("\n\tFID:\t%d\n", vlan.fid);
+				}
+			} else if ((!memcmp(cmd_addr, "add", 3)) ||
+				(!memcmp(cmd_addr, "Add", 3)) ||
+				(!memcmp(cmd_addr, "ADD", 3))) {
+
+				uint32 vid = 0;
+				uint32 portMask = 0;
+				uint32 taggedPortMask = 0;
+				extern int32 rtl865x_addVlanPortMember2(uint16 vid, uint32 portMask, uint32 untagPortMask);
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+
+				vid = simple_strtol(tokptr, NULL, 0);
+
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+
+				portMask = simple_strtol(tokptr, NULL, 16);
+
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+
+				taggedPortMask = simple_strtol(tokptr, NULL, 16);
+
+				rtl865x_addVlan(vid);
+				/* rtl865x_addVlanPortMember(vid & 4095,portMask & 0x13F); */
+				/* rtl865x_setVlanPortTag(vid,taggedPortMask,1); */
+				rtl865x_addVlanPortMember2(vid & 4095, portMask,
+					taggedPortMask);
+				rtl865x_setVlanFilterDatabase(vid, 0);
+			} else if ((!memcmp(cmd_addr, "del", 3)) ||
+				(!memcmp(cmd_addr, "Del", 3)) ||
+				(!memcmp(cmd_addr, "DEL", 3))) {
+				uint32 vid = 0;
+
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+
+				vid = simple_strtol(tokptr, NULL, 0);
+
+				rtl865x_delVlan(vid);
+
+			} else if ((!memcmp(cmd_addr, "mod", 3))) {
+				int i;
+				uint32 vid = 0;
+				uint32 portMask = 0;
+				uint32 untagPortMask = 0;
+				extern int32 rtl865x_addVlanPortMember2(uint16 vid, uint32 portMask, uint32 untagPortMask);
+				extern int update_vlanconfig(uint32 vid, uint32 portMask, uint32 untagPortMask);
+
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+
+				vid = simple_strtol(tokptr, NULL, 0);
+
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+
+				portMask = simple_strtol(tokptr, NULL, 16);
+
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+
+				untagPortMask = simple_strtol(tokptr, NULL, 16);
+
+				rtl865x_addVlanPortMember2(vid & 4095,
+					portMask & 0x1FF,
+					untagPortMask & 0x1FF);
+
+				/* update pvid */
+				for (i = 0; i < RTL8651_PORT_NUMBER + 3; i++) {
+					if (((1 << i) & portMask) != 0) {
+						rtl8651_setAsicPvid(i, vid);
+					}
+				}
+
+				/* update vlanconfig */
+				update_vlanconfig(vid & 4095, portMask & 0x1FF,
+					untagPortMask & 0x1FF);
+			}
+			return len;
+errout:
+			rtlglue_printf("vlan operation only support \"dump\" as the first parameter\n");
+			rtlglue_printf("dump format:	\"dump vid\"\n");
+		}
+	}
+	return len;
+}
+
+int vlan_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, vlan_single_show, NULL));
+}
+
+static ssize_t vlan_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return vlan_write(file, userbuf, count, off);
+}
+
+struct file_operations vlan_single_seq_file_operations = {
+	.open = vlan_single_open,
+	.write = vlan_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER
+#define RTL8651_ACLTBL_DROP_ALL RTL865X_ACLTBL_DROP_ALL
+#define RTL8651_ACLTBL_PERMIT_ALL RTL865X_ACLTBL_PERMIT_ALL
+#define RTL8651_ACLTBL_ALL_TO_CPU RTL865X_ACLTBL_ALL_TO_CPU
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 netif_read(struct seq_file *s, void *v)
+{
+	int8 *pst[] = { "DIS/BLK", "LIS", "LRN", "FWD" };
+	uint8 *mac;
+	int32 i, j;
+
+	seq_printf(s, "%s\n", "ASIC Network Interface Table:");
+	for (i = 0; i < RTL865XC_NETIFTBL_SIZE; i++) {
+		rtl865x_tblAsicDrv_intfParam_t intf;
+		rtl865x_tblAsicDrv_vlanParam_t vlan;
+
+		memset(&vlan, 0x00, sizeof(rtl865x_tblAsicDrv_vlanParam_t));
+
+		if (rtl8651_getAsicNetInterface(i, &intf) == FAILED)
+			continue;
+
+		if (intf.valid) {
+			mac = (uint8 *)&intf.macAddr.octet[0];
+			seq_printf(s, "[%d]  VID[%d] %x:%x:%x:%x:%x:%x",
+				i, intf.vid, mac[0], mac[1], mac[2], mac[3],
+				mac[4], mac[5]);
+			seq_printf(s, "  Routing %s \n",
+				intf.enableRoute == TRUE ? "enabled" : "disabled");
+
+			seq_printf(s, "      ingress ");
+
+			if (RTL8651_ACLTBL_DROP_ALL <= intf.inAclStart) {
+				if (intf.inAclStart == RTL8651_ACLTBL_PERMIT_ALL)
+					seq_printf(s, "permit all,");
+				if (intf.inAclStart == RTL8651_ACLTBL_ALL_TO_CPU)
+					seq_printf(s, "all to cpu,");
+				if (intf.inAclStart == RTL8651_ACLTBL_DROP_ALL)
+					seq_printf(s, "drop all,");
+			} else
+				seq_printf(s, "ACL %d-%d, ", intf.inAclStart,
+					intf.inAclEnd);
+
+			seq_printf(s, "  egress ");
+
+			if (RTL8651_ACLTBL_DROP_ALL <= intf.outAclStart) {
+				if (intf.outAclStart == RTL8651_ACLTBL_PERMIT_ALL)
+					seq_printf(s, "permit all,");
+				if (intf.outAclStart == RTL8651_ACLTBL_ALL_TO_CPU)
+					seq_printf(s, "all to cpu,");
+				if (intf.outAclStart == RTL8651_ACLTBL_DROP_ALL)
+					seq_printf(s, "drop all,");
+			} else
+				seq_printf(s, "ACL %d-%d, ", intf.outAclStart,
+					intf.outAclEnd);
+
+			seq_printf(s,
+				"\n      %d MAC Addresses, MTU %d Bytes\n",
+				intf.macAddrNumber, intf.mtu);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			seq_printf(s, "      enableRouteV6:%d,    mtuv6:%d\n",
+				intf.enableRouteV6, intf.mtuV6);
+#endif
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+			rtl8651_findAsicVlanIndexByVid(&intf.vid);
+#endif
+			rtl8651_getAsicVlan(intf.vid, &vlan);
+
+			seq_printf(s, "\n      Untag member ports:");
+
+			for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+				if (vlan.untagPortMask & (1 << j))
+					seq_printf(s, "%d ", j);
+			}
+			seq_printf(s, "\n      Active member ports:");
+
+			for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+				if (vlan.memberPortMask & (1 << j))
+					seq_printf(s, "%d ", j);
+			}
+
+			seq_printf(s, "\n      Port state(");
+
+			for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+				if ((vlan.memberPortMask & (1 << j)) == 0)
+					continue;
+				if (((READ_MEM32(PCRP0 + j * 4) & STP_PortST_MASK) >> STP_PortST_OFFSET) > 4)
+					seq_printf(s, "--- ");
+				else
+					seq_printf(s, "%d:%s ", j, pst[((READ_MEM32(PCRP0 + j * 4) & STP_PortST_MASK) >> STP_PortST_OFFSET)]);
+
+			}
+			seq_printf(s, ")\n\n");
+		}
+
+	}
+	return 0;
+}
+#else
+static int32 netif_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	int8 *pst[] = { "DIS/BLK", "LIS", "LRN", "FWD" };
+	uint8 *mac;
+	int32 i, j;
+
+	len = sprintf(page, "%s\n", "ASIC Network Interface Table:");
+	for (i = 0; i < RTL865XC_NETIFTBL_SIZE; i++) {
+		rtl865x_tblAsicDrv_intfParam_t intf;
+		rtl865x_tblAsicDrv_vlanParam_t vlan;
+
+		memset(&vlan, 0x00, sizeof(rtl865x_tblAsicDrv_vlanParam_t));
+
+		if (rtl8651_getAsicNetInterface(i, &intf) == FAILED)
+			continue;
+
+		if (intf.valid) {
+			mac = (uint8 *)&intf.macAddr.octet[0];
+			len += sprintf(page + len,
+				"[%d]  VID[%d] %x:%x:%x:%x:%x:%x", i, intf.vid,
+				mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
+			len += sprintf(page + len, "  Routing %s \n",
+				intf.enableRoute == TRUE ? "enabled" : "disabled");
+
+			len += sprintf(page + len, "      ingress ");
+
+			if (RTL8651_ACLTBL_DROP_ALL <= intf.inAclStart) {
+				if (intf.inAclStart == RTL8651_ACLTBL_PERMIT_ALL)
+					len += sprintf(page + len, "permit all,");
+				if (intf.inAclStart == RTL8651_ACLTBL_ALL_TO_CPU)
+					len += sprintf(page + len, "all to cpu,");
+				if (intf.inAclStart == RTL8651_ACLTBL_DROP_ALL)
+					len += sprintf(page + len, "drop all,");
+			} else
+				len += sprintf(page + len, "ACL %d-%d, ",
+					intf.inAclStart, intf.inAclEnd);
+
+			len += sprintf(page + len, "  egress ");
+
+			if (RTL8651_ACLTBL_DROP_ALL <= intf.outAclStart) {
+				if (intf.outAclStart == RTL8651_ACLTBL_PERMIT_ALL)
+					len += sprintf(page + len, "permit all,");
+				if (intf.outAclStart == RTL8651_ACLTBL_ALL_TO_CPU)
+					len += sprintf(page + len, "all to cpu,");
+				if (intf.outAclStart == RTL8651_ACLTBL_DROP_ALL)
+					len += sprintf(page + len, "drop all,");
+			} else
+				len += sprintf(page + len, "ACL %d-%d, ",
+					intf.outAclStart, intf.outAclEnd);
+
+			len += sprintf(page + len,
+				"\n      %d MAC Addresses, MTU %d Bytes\n",
+				intf.macAddrNumber, intf.mtu);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			len += sprintf(page + len,
+				"      enableRouteV6:%d,    mtuv6:%d\n",
+				intf.enableRouteV6, intf.mtuV6);
+#endif
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+			rtl8651_findAsicVlanIndexByVid(&intf.vid);
+#endif
+			rtl8651_getAsicVlan(intf.vid, &vlan);
+
+			len += sprintf(page + len,
+				"\n      Untag member ports:");
+
+			for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+				if (vlan.untagPortMask & (1 << j))
+					len += sprintf(page + len, "%d ", j);
+			}
+			len += sprintf(page + len,
+				"\n      Active member ports:");
+
+			for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+				if (vlan.memberPortMask & (1 << j))
+					len += sprintf(page + len, "%d ", j);
+			}
+
+			len += sprintf(page + len, "\n      Port state(");
+
+			for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+				if ((vlan.memberPortMask & (1 << j)) == 0)
+					continue;
+				if (((READ_MEM32(PCRP0 + j * 4) & STP_PortST_MASK) >> STP_PortST_OFFSET) > 4)
+					len += sprintf(page + len, "--- ");
+				else
+					len += sprintf(page + len, "%d:%s ", j, pst[((READ_MEM32(PCRP0 + j * 4) & STP_PortST_MASK) >> STP_PortST_OFFSET)]);
+
+			}
+			len += sprintf(page + len, ")\n\n");
+		}
+
+	}
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int32 netif_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+extern int32 sw_netif_read(struct seq_file *s, void *v);
+#else
+extern int32 sw_netif_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+
+#endif
+static int32 sw_netif_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+#if 0
+static int32 acl_read(char *page, char **start, off_t off, int count, int *eof,
+	void *data)
+{
+	int len;
+
+	int8 *actionT[] = {
+			"permit", "redirect to ether", "drop", "to cpu",
+			"legacy drop",
+			"drop for log", "mirror", "redirect to pppoe",
+			"default redirect", "mirror keep match",
+			"drop rate exceed pps", "log rate exceed pps",
+			"drop rate exceed bps", "log rate exceed bps",
+			"priority "
+	};
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+	rtl865x_AclRule_t asic_acl;
+#else
+	_rtl8651_tblDrvAclRule_t asic_acl;
+#endif
+	rtl865x_tblAsicDrv_intfParam_t asic_intf;
+	uint32 acl_start, acl_end;
+
+	uint16 vid;
+	int8 outRule;
+
+	len = sprintf(page, "%s\n", "ASIC ACL Table:");
+	for (vid = 0; vid < 8; vid++) {
+		/* Read VLAN Table */
+		if (rtl8651_getAsicNetInterface(vid, &asic_intf) == FAILED)
+			continue;
+		if (asic_intf.valid == FALSE)
+			continue;
+
+		outRule = FALSE;
+		acl_start = asic_intf.inAclStart;
+		acl_end = asic_intf.inAclEnd;
+		len += sprintf(page + len, "\nacl_start(%d), acl_end(%d)",
+			acl_start, acl_end);
+again:
+		if (outRule == FALSE)
+			len += sprintf(page+len, "\n<<Ingress Rule for Netif  %d: (VID %d)>>\n", vid, asic_intf.vid);
+		else
+			len += sprintf(page+len, "\n<<Egress Rule for Netif %d (VID %d)>>:\n", vid, asic_intf.vid);
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+
+		for (; acl_start <= acl_end; acl_start++) {
+			if (_rtl865x_getAclFromAsic(acl_start, &asic_acl) == FAILED)
+				rtlglue_printf("=============%s(%d): get asic acl rule error!\n", __FUNCTION__, __LINE__);
+
+			switch (asic_acl.ruleType_) {
+			case RTL865X_ACL_MAC:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Ethernet",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tether type: %x   ether type mask: %x\n",
+					asic_acl.typeLen_,
+					asic_acl.typeLenMask_);
+				len += sprintf(page + len,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstMac_.octet[0],
+					asic_acl.dstMac_.octet[1],
+					asic_acl.dstMac_.octet[2],
+					asic_acl.dstMac_.octet[3],
+					asic_acl.dstMac_.octet[4],
+					asic_acl.dstMac_.octet[5],
+					asic_acl.dstMacMask_.octet[0],
+					asic_acl.dstMacMask_.octet[1],
+					asic_acl.dstMacMask_.octet[2],
+					asic_acl.dstMacMask_.octet[3],
+					asic_acl.dstMacMask_.octet[4],
+					asic_acl.dstMacMask_.octet[5]
+					);
+
+				len += sprintf(page + len,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcMac_.octet[0],
+					asic_acl.srcMac_.octet[1],
+					asic_acl.srcMac_.octet[2],
+					asic_acl.srcMac_.octet[3],
+					asic_acl.srcMac_.octet[4],
+					asic_acl.srcMac_.octet[5],
+					asic_acl.srcMacMask_.octet[0],
+					asic_acl.srcMacMask_.octet[1],
+					asic_acl.srcMacMask_.octet[2],
+					asic_acl.srcMacMask_.octet[3],
+					asic_acl.srcMacMask_.octet[4],
+					asic_acl.srcMacMask_.octet[5]
+					);
+				break;
+
+			case RTL865X_ACL_IP:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.ipProto_,
+					asic_acl.ipProtoMask_, asic_acl.ipFlag_,
+					asic_acl.ipFlagMask_);
+
+				len += sprintf(page + len,
+					"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					asic_acl.ipFOP_, asic_acl.ipFOM_,
+					asic_acl.ipHttpFilter_,
+					asic_acl.ipHttpFilterM_,
+					asic_acl.ipIdentSrcDstIp_,
+					asic_acl.ipIdentSrcDstIpM_);
+				len += sprintf(page + len,
+					"\t<DF:%x> <MF:%x>\n", asic_acl.ipDF_,
+					asic_acl.ipMF_);
+				break;
+
+			case RTL865X_ACL_IP_RANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IP Range",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.ipProto_,
+					asic_acl.ipProtoMask_, asic_acl.ipFlag_,
+					asic_acl.ipFlagMask_);
+				len += sprintf(page + len,
+					"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					asic_acl.ipFOP_, asic_acl.ipFOM_,
+					asic_acl.ipHttpFilter_,
+					asic_acl.ipHttpFilterM_,
+					asic_acl.ipIdentSrcDstIp_,
+					asic_acl.ipIdentSrcDstIpM_);
+				len += sprintf(page + len,
+					"\t<DF:%x> <MF:%x>\n", asic_acl.ipDF_,
+					asic_acl.ipMF_);
+				break;
+			case RTL865X_ACL_ICMP:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "ICMP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.icmpType_,
+					asic_acl.icmpTypeMask_,
+					asic_acl.icmpCode_,
+					asic_acl.icmpCodeMask_);
+				break;
+			case RTL865X_ACL_ICMP_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "ICMP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.icmpType_,
+					asic_acl.icmpTypeMask_,
+					asic_acl.icmpCode_,
+					asic_acl.icmpCodeMask_);
+				break;
+			case RTL865X_ACL_IGMP:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IGMP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.igmpType_,
+					asic_acl.igmpTypeMask_);
+				break;
+
+			case RTL865X_ACL_IGMP_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IGMP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.igmpType_,
+					asic_acl.igmpTypeMask_);
+				break;
+
+			case RTL865X_ACL_TCP:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "TCP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.tcpSrcPortLB_,
+					asic_acl.tcpSrcPortUB_,
+					asic_acl.tcpDstPortLB_,
+					asic_acl.tcpDstPortUB_);
+				len += sprintf(page + len,
+					"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					asic_acl.tcpFlag_,
+					asic_acl.tcpFlagMask_, asic_acl.tcpURG_,
+					asic_acl.tcpACK_, asic_acl.tcpPSH_,
+					asic_acl.tcpRST_, asic_acl.tcpSYN_,
+					asic_acl.tcpFIN_);
+				break;
+			case RTL865X_ACL_TCP_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "TCP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.tcpSrcPortLB_,
+					asic_acl.tcpSrcPortUB_,
+					asic_acl.tcpDstPortLB_,
+					asic_acl.tcpDstPortUB_);
+				len += sprintf(page + len,
+					"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					asic_acl.tcpFlag_,
+					asic_acl.tcpFlagMask_, asic_acl.tcpURG_,
+					asic_acl.tcpACK_, asic_acl.tcpPSH_,
+					asic_acl.tcpRST_, asic_acl.tcpSYN_,
+					asic_acl.tcpFIN_);
+				break;
+
+			case RTL865X_ACL_UDP:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.udpSrcPortLB_,
+					asic_acl.udpSrcPortUB_,
+					asic_acl.udpDstPortLB_,
+					asic_acl.udpDstPortUB_);
+				break;
+			case RTL865X_ACL_UDP_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.udpSrcPortLB_,
+					asic_acl.udpSrcPortUB_,
+					asic_acl.udpDstPortLB_,
+					asic_acl.udpDstPortUB_);
+				break;
+
+			case RTL865X_ACL_SRCFILTER:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Source Filter",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcFilterMac_.octet[0],
+					asic_acl.srcFilterMac_.octet[1],
+					asic_acl.srcFilterMac_.octet[2],
+					asic_acl.srcFilterMac_.octet[3],
+					asic_acl.srcFilterMac_.octet[4],
+					asic_acl.srcFilterMac_.octet[5],
+					asic_acl.srcFilterMacMask_.octet[0],
+					asic_acl.srcFilterMacMask_.octet[1],
+					asic_acl.srcFilterMacMask_.octet[2],
+					asic_acl.srcFilterMacMask_.octet[3],
+					asic_acl.srcFilterMacMask_.octet[4],
+					asic_acl.srcFilterMacMask_.octet[5]
+					);
+				len += sprintf(page + len,
+					"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					asic_acl.srcFilterVlanIdx_,
+					asic_acl.srcFilterVlanIdxMask_,
+					asic_acl.srcFilterPort_,
+					asic_acl.srcFilterPortMask_,
+					(asic_acl.srcFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.srcFilterIgnoreL4_ == 1 ? 1 : 0))
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d   sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcFilterIpAddr_ >> 24),
+					((asic_acl.srcFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddr_ & 0xff),
+					(asic_acl.srcFilterIpAddrMask_ >> 24),
+					((asic_acl.srcFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsportL: %d   sportU: %d\n",
+					asic_acl.srcFilterPortLowerBound_,
+					asic_acl.srcFilterPortUpperBound_);
+				break;
+
+			case RTL865X_ACL_SRCFILTER_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Source Filter(IP RANGE)",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcFilterMac_.octet[0],
+					asic_acl.srcFilterMac_.octet[1],
+					asic_acl.srcFilterMac_.octet[2],
+					asic_acl.srcFilterMac_.octet[3],
+					asic_acl.srcFilterMac_.octet[4],
+					asic_acl.srcFilterMac_.octet[5],
+					asic_acl.srcFilterMacMask_.octet[0],
+					asic_acl.srcFilterMacMask_.octet[1],
+					asic_acl.srcFilterMacMask_.octet[2],
+					asic_acl.srcFilterMacMask_.octet[3],
+					asic_acl.srcFilterMacMask_.octet[4],
+					asic_acl.srcFilterMacMask_.octet[5]
+					);
+				len += sprintf(page + len,
+					"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					asic_acl.srcFilterVlanIdx_,
+					asic_acl.srcFilterVlanIdxMask_,
+					asic_acl.srcFilterPort_,
+					asic_acl.srcFilterPortMask_,
+					(asic_acl.srcFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.srcFilterIgnoreL4_ == 1 ? 1 : 0))
+					);
+				len += sprintf(page + len,
+					"\tsipU: %d.%d.%d.%d   sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcFilterIpAddr_ >> 24),
+					((asic_acl.srcFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddr_ & 0xff),
+					(asic_acl.srcFilterIpAddrMask_ >> 24),
+					((asic_acl.srcFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsportL: %d   sportU: %d\n",
+					asic_acl.srcFilterPortLowerBound_,
+					asic_acl.srcFilterPortUpperBound_);
+				break;
+
+			case RTL865X_ACL_DSTFILTER:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Deatination Filter",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstFilterMac_.octet[0],
+					asic_acl.dstFilterMac_.octet[1],
+					asic_acl.dstFilterMac_.octet[2],
+					asic_acl.dstFilterMac_.octet[3],
+					asic_acl.dstFilterMac_.octet[4],
+					asic_acl.dstFilterMac_.octet[5],
+					asic_acl.dstFilterMacMask_.octet[0],
+					asic_acl.dstFilterMacMask_.octet[1],
+					asic_acl.dstFilterMacMask_.octet[2],
+					asic_acl.dstFilterMacMask_.octet[3],
+					asic_acl.dstFilterMacMask_.octet[4],
+					asic_acl.dstFilterMacMask_.octet[5]
+					);
+				len += sprintf(page + len,
+					"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					asic_acl.dstFilterVlanIdx_,
+					asic_acl.dstFilterVlanIdxMask_,
+					(asic_acl.dstFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.dstFilterIgnoreL4_ == 1 ? 1 : 0)),
+					asic_acl.dstFilterPortLowerBound_,
+					asic_acl.dstFilterPortUpperBound_);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d   dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstFilterIpAddr_ >> 24),
+					((asic_acl.dstFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddr_ & 0xff),
+					(asic_acl.dstFilterIpAddrMask_ >> 24),
+					((asic_acl.dstFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddrMask_ & 0xff)
+					);
+				break;
+			case RTL865X_ACL_DSTFILTER_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start,
+					"Deatination Filter(IP Range)",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstFilterMac_.octet[0],
+					asic_acl.dstFilterMac_.octet[1],
+					asic_acl.dstFilterMac_.octet[2],
+					asic_acl.dstFilterMac_.octet[3],
+					asic_acl.dstFilterMac_.octet[4],
+					asic_acl.dstFilterMac_.octet[5],
+					asic_acl.dstFilterMacMask_.octet[0],
+					asic_acl.dstFilterMacMask_.octet[1],
+					asic_acl.dstFilterMacMask_.octet[2],
+					asic_acl.dstFilterMacMask_.octet[3],
+					asic_acl.dstFilterMacMask_.octet[4],
+					asic_acl.dstFilterMacMask_.octet[5]
+					);
+				len += sprintf(page + len,
+					"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					asic_acl.dstFilterVlanIdx_,
+					asic_acl.dstFilterVlanIdxMask_,
+					(asic_acl.dstFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.dstFilterIgnoreL4_ == 1 ? 1 : 0)),
+					asic_acl.dstFilterPortLowerBound_,
+					asic_acl.dstFilterPortUpperBound_);
+				len += sprintf(page + len,
+					"\tdipU: %d.%d.%d.%d   dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstFilterIpAddr_ >> 24),
+					((asic_acl.dstFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddr_ & 0xff),
+					(asic_acl.dstFilterIpAddrMask_ >> 24),
+					((asic_acl.dstFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddrMask_ & 0xff)
+					);
+				break;
+
+			default:
+				len += sprintf(page + len,
+					"asic_acl.ruleType_(0x%x)\n",
+					asic_acl.ruleType_);
+
+			}
+
+			/* Action type */
+			switch (asic_acl.actionType_) {
+
+			case RTL865X_ACL_PERMIT:
+			case RTL865X_ACL_REDIRECT_ETHER:
+			case RTL865X_ACL_DROP:
+			case RTL865X_ACL_TOCPU:
+			case RTL865X_ACL_LEGACY_DROP:
+			case RTL865X_ACL_DROPCPU_LOG:
+			case RTL865X_ACL_MIRROR:
+			case RTL865X_ACL_REDIRECT_PPPOE:
+			case RTL865X_ACL_MIRROR_KEEP_MATCH:
+				len += sprintf(page + len,
+					"\tnetifIdx: %d   pppoeIdx: %d   l2Idx:%d  ",
+					asic_acl.netifIdx_, asic_acl.pppoeIdx_,
+					asic_acl.L2Idx_);
+				break;
+
+			case RTL865X_ACL_PRIORITY:
+				len += sprintf(page + len, "\tprioirty: %d   ",
+					asic_acl.priority_);
+				break;
+
+			case RTL865X_ACL_DEFAULT_REDIRECT:
+				len += sprintf(page + len, "\tnextHop:%d  ",
+					asic_acl.nexthopIdx_);
+				break;
+
+			case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+			case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+			case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+			case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+				len += sprintf(page + len,
+					"\tratelimitIdx: %d  ",
+					asic_acl.ratelimtIdx_);
+				break;
+			default:
+				;
+
+			}
+			len += sprintf(page + len, "pktOpApp: %d\n",
+				asic_acl.pktOpApp_);
+
+		}
+#else
+		for (; acl_start <= acl_end; acl_start++) {
+			if (rtl8651_getAsicAclRule(acl_start,
+					&asic_acl) == FAILED)
+				rtlglue_printf("=============%s(%d): get asic acl rule error!\n",
+					__FUNCTION__, __LINE__);
+
+			switch (asic_acl.ruleType_) {
+			case RTL8651_ACL_MAC:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Ethernet",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tether type: %x   ether type mask: %x\n",
+					asic_acl.typeLen_,
+					asic_acl.typeLenMask_);
+				len += sprintf(page + len,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstMac_.octet[0],
+					asic_acl.dstMac_.octet[1],
+					asic_acl.dstMac_.octet[2],
+					asic_acl.dstMac_.octet[3],
+					asic_acl.dstMac_.octet[4],
+					asic_acl.dstMac_.octet[5],
+					asic_acl.dstMacMask_.octet[0],
+					asic_acl.dstMacMask_.octet[1],
+					asic_acl.dstMacMask_.octet[2],
+					asic_acl.dstMacMask_.octet[3],
+					asic_acl.dstMacMask_.octet[4],
+					asic_acl.dstMacMask_.octet[5]
+					);
+
+				len += sprintf(page + len,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcMac_.octet[0],
+					asic_acl.srcMac_.octet[1],
+					asic_acl.srcMac_.octet[2],
+					asic_acl.srcMac_.octet[3],
+					asic_acl.srcMac_.octet[4],
+					asic_acl.srcMac_.octet[5],
+					asic_acl.srcMacMask_.octet[0],
+					asic_acl.srcMacMask_.octet[1],
+					asic_acl.srcMacMask_.octet[2],
+					asic_acl.srcMacMask_.octet[3],
+					asic_acl.srcMacMask_.octet[4],
+					asic_acl.srcMacMask_.octet[5]
+					);
+				break;
+
+			case RTL8651_ACL_IP:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.ipProto_,
+					asic_acl.ipProtoMask_, asic_acl.ipFlag_,
+					asic_acl.ipFlagMask_);
+
+				len += sprintf(page + len,
+					"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					asic_acl.ipFOP_, asic_acl.ipFOM_,
+					asic_acl.ipHttpFilter_,
+					asic_acl.ipHttpFilterM_,
+					asic_acl.ipIdentSrcDstIp_,
+					asic_acl.ipIdentSrcDstIpM_);
+				len += sprintf(page + len,
+					"\t<DF:%x> <MF:%x>\n", asic_acl.ipDF_,
+					asic_acl.ipMF_);
+				break;
+
+			case RTL8652_ACL_IP_RANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IP Range",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.ipProto_,
+					asic_acl.ipProtoMask_, asic_acl.ipFlag_,
+					asic_acl.ipFlagMask_);
+				len += sprintf(page + len,
+					"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					asic_acl.ipFOP_, asic_acl.ipFOM_,
+					asic_acl.ipHttpFilter_,
+					asic_acl.ipHttpFilterM_,
+					asic_acl.ipIdentSrcDstIp_,
+					asic_acl.ipIdentSrcDstIpM_);
+				len += sprintf(page + len,
+					"\t<DF:%x> <MF:%x>\n", asic_acl.ipDF_,
+					asic_acl.ipMF_);
+				break;
+			case RTL8651_ACL_ICMP:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "ICMP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.icmpType_,
+					asic_acl.icmpTypeMask_,
+					asic_acl.icmpCode_,
+					asic_acl.icmpCodeMask_);
+				break;
+			case RTL8652_ACL_ICMP_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "ICMP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.icmpType_,
+					asic_acl.icmpTypeMask_,
+					asic_acl.icmpCode_,
+					asic_acl.icmpCodeMask_);
+				break;
+			case RTL8651_ACL_IGMP:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IGMP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.igmpType_,
+					asic_acl.igmpTypeMask_);
+				break;
+
+			case RTL8652_ACL_IGMP_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IGMP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.igmpType_,
+					asic_acl.igmpTypeMask_);
+				break;
+
+			case RTL8651_ACL_TCP:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "TCP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.tcpSrcPortLB_,
+					asic_acl.tcpSrcPortUB_,
+					asic_acl.tcpDstPortLB_,
+					asic_acl.tcpDstPortUB_);
+				len += sprintf(page + len,
+					"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					asic_acl.tcpFlag_,
+					asic_acl.tcpFlagMask_, asic_acl.tcpURG_,
+					asic_acl.tcpACK_, asic_acl.tcpPSH_,
+					asic_acl.tcpRST_, asic_acl.tcpSYN_,
+					asic_acl.tcpFIN_);
+				break;
+			case RTL8652_ACL_TCP_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "TCP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.tcpSrcPortLB_,
+					asic_acl.tcpSrcPortUB_,
+					asic_acl.tcpDstPortLB_,
+					asic_acl.tcpDstPortUB_);
+				len += sprintf(page + len,
+					"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					asic_acl.tcpFlag_,
+					asic_acl.tcpFlagMask_, asic_acl.tcpURG_,
+					asic_acl.tcpACK_, asic_acl.tcpPSH_,
+					asic_acl.tcpRST_, asic_acl.tcpSYN_,
+					asic_acl.tcpFIN_);
+				break;
+
+			case RTL8651_ACL_UDP:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.udpSrcPortLB_,
+					asic_acl.udpSrcPortUB_,
+					asic_acl.udpDstPortLB_,
+					asic_acl.udpDstPortUB_);
+				break;
+			case RTL8652_ACL_UDP_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.udpSrcPortLB_,
+					asic_acl.udpSrcPortUB_,
+					asic_acl.udpDstPortLB_,
+					asic_acl.udpDstPortUB_);
+				break;
+
+			case RTL8651_ACL_IFSEL:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len, "\tgidxSel: %x\n",
+					asic_acl.gidxSel_);
+				break;
+			case RTL8651_ACL_SRCFILTER:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Source Filter",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcFilterMac_.octet[0],
+					asic_acl.srcFilterMac_.octet[1],
+					asic_acl.srcFilterMac_.octet[2],
+					asic_acl.srcFilterMac_.octet[3],
+					asic_acl.srcFilterMac_.octet[4],
+					asic_acl.srcFilterMac_.octet[5],
+					asic_acl.srcFilterMacMask_.octet[0],
+					asic_acl.srcFilterMacMask_.octet[1],
+					asic_acl.srcFilterMacMask_.octet[2],
+					asic_acl.srcFilterMacMask_.octet[3],
+					asic_acl.srcFilterMacMask_.octet[4],
+					asic_acl.srcFilterMacMask_.octet[5]
+					);
+				len += sprintf(page + len,
+					"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					asic_acl.srcFilterVlanIdx_,
+					asic_acl.srcFilterVlanIdxMask_,
+					asic_acl.srcFilterPort_,
+					asic_acl.srcFilterPortMask_,
+					(asic_acl.srcFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.srcFilterIgnoreL4_ == 1 ? 1 : 0))
+					);
+				len += sprintf(page + len,
+					"\tsip: %d.%d.%d.%d   sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcFilterIpAddr_ >> 24),
+					((asic_acl.srcFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddr_ & 0xff),
+					(asic_acl.srcFilterIpAddrMask_ >> 24),
+					((asic_acl.srcFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsportL: %d   sportU: %d\n",
+					asic_acl.srcFilterPortLowerBound_,
+					asic_acl.srcFilterPortUpperBound_);
+				break;
+
+			case RTL8652_ACL_SRCFILTER_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Source Filter(IP RANGE)",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcFilterMac_.octet[0],
+					asic_acl.srcFilterMac_.octet[1],
+					asic_acl.srcFilterMac_.octet[2],
+					asic_acl.srcFilterMac_.octet[3],
+					asic_acl.srcFilterMac_.octet[4],
+					asic_acl.srcFilterMac_.octet[5],
+					asic_acl.srcFilterMacMask_.octet[0],
+					asic_acl.srcFilterMacMask_.octet[1],
+					asic_acl.srcFilterMacMask_.octet[2],
+					asic_acl.srcFilterMacMask_.octet[3],
+					asic_acl.srcFilterMacMask_.octet[4],
+					asic_acl.srcFilterMacMask_.octet[5]
+					);
+				len += sprintf(page + len,
+					"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					asic_acl.srcFilterVlanIdx_,
+					asic_acl.srcFilterVlanIdxMask_,
+					asic_acl.srcFilterPort_,
+					asic_acl.srcFilterPortMask_,
+					(asic_acl.srcFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.srcFilterIgnoreL4_ == 1 ? 1 : 0))
+					);
+				len += sprintf(page + len,
+					"\tsipU: %d.%d.%d.%d   sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcFilterIpAddr_ >> 24),
+					((asic_acl.srcFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddr_ & 0xff),
+					(asic_acl.srcFilterIpAddrMask_ >> 24),
+					((asic_acl.srcFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddrMask_ & 0xff)
+					);
+				len += sprintf(page + len,
+					"\tsportL: %d   sportU: %d\n",
+					asic_acl.srcFilterPortLowerBound_,
+					asic_acl.srcFilterPortUpperBound_);
+				break;
+
+			case RTL8651_ACL_DSTFILTER:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Deatination Filter",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstFilterMac_.octet[0],
+					asic_acl.dstFilterMac_.octet[1],
+					asic_acl.dstFilterMac_.octet[2],
+					asic_acl.dstFilterMac_.octet[3],
+					asic_acl.dstFilterMac_.octet[4],
+					asic_acl.dstFilterMac_.octet[5],
+					asic_acl.dstFilterMacMask_.octet[0],
+					asic_acl.dstFilterMacMask_.octet[1],
+					asic_acl.dstFilterMacMask_.octet[2],
+					asic_acl.dstFilterMacMask_.octet[3],
+					asic_acl.dstFilterMacMask_.octet[4],
+					asic_acl.dstFilterMacMask_.octet[5]
+					);
+				len += sprintf(page + len,
+					"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					asic_acl.dstFilterVlanIdx_,
+					asic_acl.dstFilterVlanIdxMask_,
+					(asic_acl.dstFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.dstFilterIgnoreL4_ == 1 ? 1 : 0)),
+					asic_acl.dstFilterPortLowerBound_,
+					asic_acl.dstFilterPortUpperBound_);
+				len += sprintf(page + len,
+					"\tdip: %d.%d.%d.%d   dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstFilterIpAddr_ >> 24),
+					((asic_acl.dstFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddr_ & 0xff),
+					(asic_acl.dstFilterIpAddrMask_ >> 24),
+					((asic_acl.dstFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddrMask_ & 0xff)
+					);
+				break;
+			case RTL8652_ACL_DSTFILTER_IPRANGE:
+				len += sprintf(page + len,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start,
+					"Deatination Filter(IP Range)",
+					actionT[asic_acl.actionType_]);
+				len += sprintf(page + len,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstFilterMac_.octet[0],
+					asic_acl.dstFilterMac_.octet[1],
+					asic_acl.dstFilterMac_.octet[2],
+					asic_acl.dstFilterMac_.octet[3],
+					asic_acl.dstFilterMac_.octet[4],
+					asic_acl.dstFilterMac_.octet[5],
+					asic_acl.dstFilterMacMask_.octet[0],
+					asic_acl.dstFilterMacMask_.octet[1],
+					asic_acl.dstFilterMacMask_.octet[2],
+					asic_acl.dstFilterMacMask_.octet[3],
+					asic_acl.dstFilterMacMask_.octet[4],
+					asic_acl.dstFilterMacMask_.octet[5]
+					);
+				len += sprintf(page + len,
+					"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					asic_acl.dstFilterVlanIdx_,
+					asic_acl.dstFilterVlanIdxMask_,
+					(asic_acl.dstFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.dstFilterIgnoreL4_ == 1 ? 1 : 0)),
+					asic_acl.dstFilterPortLowerBound_,
+					asic_acl.dstFilterPortUpperBound_);
+				len += sprintf(page + len,
+					"\tdipU: %d.%d.%d.%d   dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstFilterIpAddr_ >> 24),
+					((asic_acl.dstFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddr_ & 0xff),
+					(asic_acl.dstFilterIpAddrMask_ >> 24),
+					((asic_acl.dstFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddrMask_ & 0xff)
+					);
+				break;
+
+			default:
+				len += sprintf(page + len,
+					"asic_acl.ruleType_(0x%x)\n",
+					asic_acl.ruleType_);
+
+			}
+
+			/* Action type */
+			switch (asic_acl.actionType_) {
+
+			case RTL8651_ACL_PERMIT:	/* 0x00 */
+			case RTL8651_ACL_REDIRECT:	/* 0x01 */
+			case RTL8651_ACL_CPU:	/* 0x03 */
+			case RTL8651_ACL_DROP:	/* 0x02, 0x04 */
+			case RTL8651_ACL_DROP_LOG:	/* 0x05 */
+			case RTL8651_ACL_MIRROR:	/* 0x06 */
+			case RTL8651_ACL_REDIRECT_PPPOE:	/* 0x07 */
+			case RTL8651_ACL_MIRROR_KEEP_MATCH:	/* 0x09 */
+				len += sprintf(page + len,
+					"\tdvidx: %d   hp: %d   pppoeIdx: %d   nxtHop:%d  ",
+					asic_acl.dvid_, asic_acl.priority_,
+					asic_acl.pppoeIdx_, asic_acl.nextHop_);
+				break;
+
+			case RTL8651_ACL_POLICY:	/* 0x08 */
+				len += sprintf(page + len,
+					"\thp: %d   nxtHopIdx: %d  ",
+					asic_acl.priority_, asic_acl.nhIndex);
+				break;
+
+			case RTL8651_ACL_PRIORITY:	/* 0x08 */
+				len += sprintf(page + len, "\tprioirty: %d   ",
+					asic_acl.priority);
+				break;
+
+			case RTL8651_ACL_DROP_RATE_EXCEED_PPS:	/* 0x0a */
+			case RTL8651_ACL_LOG_RATE_EXCEED_PPS:	/* 0x0b */
+			case RTL8651_ACL_DROP_RATE_EXCEED_BPS:	/* 0x0c */
+			case RTL8651_ACL_LOG_RATE_EXCEED_BPS:	/* 0x0d */
+				len += sprintf(page + len, "\trlIdx: %d  ",
+					asic_acl.rlIndex);
+				break;
+			default:
+				;
+
+			}
+			len += sprintf(page + len, "pktOpApp: %d\n",
+				asic_acl.pktOpApp);
+
+		}
+
+#endif
+
+		if (outRule == FALSE) {
+			acl_start = asic_intf.outAclStart;
+			acl_end = asic_intf.outAclEnd;
+			outRule = TRUE;
+			goto again;
+		}
+	}
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+
+static int32 acl_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+
+#if RTL_LAYERED_DRIVER_DEBUG
+	char tmpbuf[32];
+	int32 testNo;
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		testNo = tmpbuf[0] - '0';
+		rtl865x_acl_test(testNo);
+	}
+#endif
+	return len;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 advRt_read(struct seq_file *s, void *v)
+{
+	rtl_show_advRt_table(s);
+	return 0;
+}
+#else
+static int32 advRt_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len = 0;
+
+	rtl_show_advRt_table(page, &len);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int32 advRt_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	char tmpbuf[32];
+	rtl_advRoute_entry_t rule;
+	int retval;
+
+	if (len > 32) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len - 1] = '\0';
+		if (tmpbuf[0] == '1') {
+			/* add rule */
+			memset(&rule, 0, sizeof(rtl_advRoute_entry_t));
+			rule.extIp = 0xc0a8030b;
+			rule.nexthop = 0xc0a80303;
+			rule.pktOpApp_ = 6;
+			memcpy(rule.outIfName, "eth6", 4);
+			rule.ruleType_ = RTL_ADVRT_IP_RANGE;
+			rule.valid_ = 1;
+
+			rule.advrt_srcIpAddrStart_ = 0xc0a80180;
+			rule.advrt_srcIpAddrEnd_ = 0xc0a801ff;
+			rule.advrt_dstIpAddrStart_ = 0x0;
+			rule.advrt_dstIpAddrEnd_ = 0xffffffff;
+
+			retval = rtl_add_advRt_entry(&rule);
+			rtlglue_printf("===%s(%d),retval(%d)\n", __FUNCTION__,
+				__LINE__, retval);
+
+			/* add rule */
+			memset(&rule, 0, sizeof(rtl_advRoute_entry_t));
+			rule.extIp = 0xc0a8020b;
+			rule.nexthop = 0xc0a80203;
+			rule.pktOpApp_ = 6;
+			memcpy(rule.outIfName, "eth1", 4);
+			rule.ruleType_ = RTL_ADVRT_IP_RANGE;
+			rule.valid_ = 1;
+
+			rule.advrt_srcIpAddrStart_ = 0xc0a80101;
+			rule.advrt_srcIpAddrEnd_ = 0xc0a8017f;
+			rule.advrt_dstIpAddrStart_ = 0x0;
+			rule.advrt_dstIpAddrEnd_ = 0xffffffff;
+			retval = rtl_add_advRt_entry(&rule);
+
+			rtlglue_printf("===%s(%d),retval(%d)\n", __FUNCTION__,
+				__LINE__, retval);
+		} else if (tmpbuf[0] == '2') {
+			memset(&rule, 0, sizeof(rtl_advRoute_entry_t));
+			rule.extIp = 0xc0a8030b;
+			rule.nexthop = 0xc0a80303;
+			rule.pktOpApp_ = 6;
+			memcpy(rule.outIfName, "eth6", 4);
+			rule.ruleType_ = RTL_ADVRT_IP_RANGE;
+			rule.valid_ = 1;
+
+			rule.advrt_srcIpAddrStart_ = 0xc0a80180;
+			rule.advrt_srcIpAddrEnd_ = 0xc0a801ff;
+			rule.advrt_dstIpAddrStart_ = 0x0;
+			rule.advrt_dstIpAddrEnd_ = 0xffffffff;
+
+			retval = rtl_del_advRt_entry(&rule);
+			rtlglue_printf("===%s(%d),retval(%d)\n", __FUNCTION__,
+				__LINE__, retval);
+		} else {
+			memset(&rule, 0, sizeof(rtl_advRoute_entry_t));
+			rule.extIp = 0xc0a8020b;
+			rule.nexthop = 0xc0a80203;
+			rule.pktOpApp_ = 6;
+			memcpy(rule.outIfName, "eth1", 4);
+			rule.ruleType_ = RTL_ADVRT_IP_RANGE;
+			rule.valid_ = 1;
+
+			rule.advrt_srcIpAddrStart_ = 0xc0a80101;
+			rule.advrt_srcIpAddrEnd_ = 0xc0a8017f;
+			rule.advrt_dstIpAddrStart_ = 0x0;
+			rule.advrt_dstIpAddrEnd_ = 0xffffffff;
+			retval = rtl_del_advRt_entry(&rule);
+
+			rtlglue_printf("===%s(%d),retval(%d)\n", __FUNCTION__,
+				__LINE__, retval);
+		}
+	} else {
+errout:
+		rtlglue_printf("error input\n");
+	}
+	return len;
+}
+#endif
+
+int acl_show(struct seq_file *s, void *v)
+{
+	int8 *actionT[] =
+		{ "permit", "redirect to ether", "drop", "to cpu",
+			"legacy drop",
+		"drop for log", "mirror", "redirect to pppoe",
+			"default redirect", "mirror keep match",
+		"drop rate exceed pps", "log rate exceed pps",
+			"drop rate exceed bps", "log rate exceed bps",
+			"priority "
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			, "change vid"
+#endif
+	};
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+	rtl865x_AclRule_t asic_acl;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rtl865x_AclRule_t asic_acl2;
+	uint32 acl_temp = 0;
+#endif
+
+#else
+	_rtl8651_tblDrvAclRule_t asic_acl;
+#endif
+	rtl865x_tblAsicDrv_intfParam_t asic_intf;
+	uint32 acl_start, acl_end;
+
+	uint16 vid;
+	int8 outRule;
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC) || defined(CONFIG_RTL_MULTIPLE_WAN) || defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+	unsigned char defInAclStart, defInAclEnd, defOutAclStart, defOutAclEnd;
+#endif
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	inv6_addr_t start_ip, end_ip;
+#endif
+
+	seq_printf(s, "%s\n", "ASIC ACL Table:");
+	for (vid = 0; vid < 8; vid++) {
+		/* Read VLAN Table */
+		if (rtl8651_getAsicNetInterface(vid, &asic_intf) == FAILED)
+			continue;
+		if (asic_intf.valid == FALSE)
+			continue;
+
+		outRule = FALSE;
+		acl_start = asic_intf.inAclStart;
+		acl_end = asic_intf.inAclEnd;
+		seq_printf(s, "\nacl_start(%d), acl_end(%d)", acl_start,
+			acl_end);
+again:
+		if (outRule == FALSE)
+			seq_printf(s,
+				"\n<<Ingress Rule for Netif  %d: (VID %d)>>\n",
+				vid, asic_intf.vid);
+		else
+			seq_printf(s,
+				"\n<<Egress Rule for Netif %d (VID %d)>>:\n",
+				vid, asic_intf.vid);
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+
+		for (; acl_start <= acl_end; acl_start++) {
+			if (_rtl865x_getAclFromAsic(acl_start,
+					&asic_acl) == FAILED)
+				seq_printf(s,
+					"=============%s(%d): get asic acl rule error!\n",
+					__FUNCTION__, __LINE__);
+
+			switch (asic_acl.ruleType_) {
+			case RTL865X_ACL_MAC:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Ethernet",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tether type: %x   ether type mask: %x\n",
+					asic_acl.typeLen_,
+					asic_acl.typeLenMask_);
+				seq_printf(s,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstMac_.octet[0],
+					asic_acl.dstMac_.octet[1],
+					asic_acl.dstMac_.octet[2],
+					asic_acl.dstMac_.octet[3],
+					asic_acl.dstMac_.octet[4],
+					asic_acl.dstMac_.octet[5],
+					asic_acl.dstMacMask_.octet[0],
+					asic_acl.dstMacMask_.octet[1],
+					asic_acl.dstMacMask_.octet[2],
+					asic_acl.dstMacMask_.octet[3],
+					asic_acl.dstMacMask_.octet[4],
+					asic_acl.dstMacMask_.octet[5]
+					);
+
+				seq_printf(s,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcMac_.octet[0],
+					asic_acl.srcMac_.octet[1],
+					asic_acl.srcMac_.octet[2],
+					asic_acl.srcMac_.octet[3],
+					asic_acl.srcMac_.octet[4],
+					asic_acl.srcMac_.octet[5],
+					asic_acl.srcMacMask_.octet[0],
+					asic_acl.srcMacMask_.octet[1],
+					asic_acl.srcMacMask_.octet[2],
+					asic_acl.srcMacMask_.octet[3],
+					asic_acl.srcMacMask_.octet[4],
+					asic_acl.srcMacMask_.octet[5]
+					);
+				break;
+
+			case RTL865X_ACL_IP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.ipProto_,
+					asic_acl.ipProtoMask_, asic_acl.ipFlag_,
+					asic_acl.ipFlagMask_);
+
+				seq_printf(s,
+					"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					asic_acl.ipFOP_, asic_acl.ipFOM_,
+					asic_acl.ipHttpFilter_,
+					asic_acl.ipHttpFilterM_,
+					asic_acl.ipIdentSrcDstIp_,
+					asic_acl.ipIdentSrcDstIpM_);
+				seq_printf(s, "\t<DF:%x> <MF:%x>\n",
+					asic_acl.ipDF_, asic_acl.ipMF_);
+				break;
+
+			case RTL865X_ACL_IP_RANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IP Range",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.ipProto_,
+					asic_acl.ipProtoMask_, asic_acl.ipFlag_,
+					asic_acl.ipFlagMask_);
+				seq_printf(s,
+					"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					asic_acl.ipFOP_, asic_acl.ipFOM_,
+					asic_acl.ipHttpFilter_,
+					asic_acl.ipHttpFilterM_,
+					asic_acl.ipIdentSrcDstIp_,
+					asic_acl.ipIdentSrcDstIpM_);
+				seq_printf(s, "\t<DF:%x> <MF:%x>\n",
+					asic_acl.ipDF_, asic_acl.ipMF_);
+				break;
+			case RTL865X_ACL_ICMP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "ICMP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.icmpType_,
+					asic_acl.icmpTypeMask_,
+					asic_acl.icmpCode_,
+					asic_acl.icmpCodeMask_);
+				break;
+			case RTL865X_ACL_ICMP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "ICMP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.icmpType_,
+					asic_acl.icmpTypeMask_,
+					asic_acl.icmpCode_,
+					asic_acl.icmpCodeMask_);
+				break;
+			case RTL865X_ACL_IGMP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IGMP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.igmpType_,
+					asic_acl.igmpTypeMask_);
+				break;
+
+			case RTL865X_ACL_IGMP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IGMP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.igmpType_,
+					asic_acl.igmpTypeMask_);
+				break;
+
+			case RTL865X_ACL_TCP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "TCP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.tcpSrcPortLB_,
+					asic_acl.tcpSrcPortUB_,
+					asic_acl.tcpDstPortLB_,
+					asic_acl.tcpDstPortUB_);
+				seq_printf(s,
+					"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					asic_acl.tcpFlag_,
+					asic_acl.tcpFlagMask_, asic_acl.tcpURG_,
+					asic_acl.tcpACK_, asic_acl.tcpPSH_,
+					asic_acl.tcpRST_, asic_acl.tcpSYN_,
+					asic_acl.tcpFIN_);
+				break;
+			case RTL865X_ACL_TCP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "TCP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.tcpSrcPortLB_,
+					asic_acl.tcpSrcPortUB_,
+					asic_acl.tcpDstPortLB_,
+					asic_acl.tcpDstPortUB_);
+				seq_printf(s,
+					"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					asic_acl.tcpFlag_,
+					asic_acl.tcpFlagMask_, asic_acl.tcpURG_,
+					asic_acl.tcpACK_, asic_acl.tcpPSH_,
+					asic_acl.tcpRST_, asic_acl.tcpSYN_,
+					asic_acl.tcpFIN_);
+				break;
+
+			case RTL865X_ACL_UDP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.udpSrcPortLB_,
+					asic_acl.udpSrcPortUB_,
+					asic_acl.udpDstPortLB_,
+					asic_acl.udpDstPortUB_);
+				break;
+			case RTL865X_ACL_UDP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.udpSrcPortLB_,
+					asic_acl.udpSrcPortUB_,
+					asic_acl.udpDstPortLB_,
+					asic_acl.udpDstPortUB_);
+				break;
+
+			case RTL865X_ACL_SRCFILTER:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Source Filter",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcFilterMac_.octet[0],
+					asic_acl.srcFilterMac_.octet[1],
+					asic_acl.srcFilterMac_.octet[2],
+					asic_acl.srcFilterMac_.octet[3],
+					asic_acl.srcFilterMac_.octet[4],
+					asic_acl.srcFilterMac_.octet[5],
+					asic_acl.srcFilterMacMask_.octet[0],
+					asic_acl.srcFilterMacMask_.octet[1],
+					asic_acl.srcFilterMacMask_.octet[2],
+					asic_acl.srcFilterMacMask_.octet[3],
+					asic_acl.srcFilterMacMask_.octet[4],
+					asic_acl.srcFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					asic_acl.srcFilterVlanIdx_,
+					asic_acl.srcFilterVlanIdxMask_,
+					asic_acl.srcFilterPort_,
+					asic_acl.srcFilterPortMask_,
+					(asic_acl.srcFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.srcFilterIgnoreL4_ == 1 ? 1 : 0))
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d   sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcFilterIpAddr_ >> 24),
+					((asic_acl.srcFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddr_ & 0xff),
+					(asic_acl.srcFilterIpAddrMask_ >> 24),
+					((asic_acl.srcFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddrMask_ & 0xff)
+					);
+				seq_printf(s, "\tsportL: %d   sportU: %d\n",
+					asic_acl.srcFilterPortLowerBound_,
+					asic_acl.srcFilterPortUpperBound_);
+				break;
+
+			case RTL865X_ACL_SRCFILTER_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Source Filter(IP RANGE)",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcFilterMac_.octet[0],
+					asic_acl.srcFilterMac_.octet[1],
+					asic_acl.srcFilterMac_.octet[2],
+					asic_acl.srcFilterMac_.octet[3],
+					asic_acl.srcFilterMac_.octet[4],
+					asic_acl.srcFilterMac_.octet[5],
+					asic_acl.srcFilterMacMask_.octet[0],
+					asic_acl.srcFilterMacMask_.octet[1],
+					asic_acl.srcFilterMacMask_.octet[2],
+					asic_acl.srcFilterMacMask_.octet[3],
+					asic_acl.srcFilterMacMask_.octet[4],
+					asic_acl.srcFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					asic_acl.srcFilterVlanIdx_,
+					asic_acl.srcFilterVlanIdxMask_,
+					asic_acl.srcFilterPort_,
+					asic_acl.srcFilterPortMask_,
+					(asic_acl.srcFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.srcFilterIgnoreL4_ == 1 ? 1 : 0))
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d   sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcFilterIpAddr_ >> 24),
+					((asic_acl.srcFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddr_ & 0xff),
+					(asic_acl.srcFilterIpAddrMask_ >> 24),
+					((asic_acl.srcFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddrMask_ & 0xff)
+					);
+				seq_printf(s, "\tsportL: %d   sportU: %d\n",
+					asic_acl.srcFilterPortLowerBound_,
+					asic_acl.srcFilterPortUpperBound_);
+				break;
+
+			case RTL865X_ACL_DSTFILTER:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Deatination Filter",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstFilterMac_.octet[0],
+					asic_acl.dstFilterMac_.octet[1],
+					asic_acl.dstFilterMac_.octet[2],
+					asic_acl.dstFilterMac_.octet[3],
+					asic_acl.dstFilterMac_.octet[4],
+					asic_acl.dstFilterMac_.octet[5],
+					asic_acl.dstFilterMacMask_.octet[0],
+					asic_acl.dstFilterMacMask_.octet[1],
+					asic_acl.dstFilterMacMask_.octet[2],
+					asic_acl.dstFilterMacMask_.octet[3],
+					asic_acl.dstFilterMacMask_.octet[4],
+					asic_acl.dstFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					asic_acl.dstFilterVlanIdx_,
+					asic_acl.dstFilterVlanIdxMask_,
+					(asic_acl.dstFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.dstFilterIgnoreL4_ == 1 ? 1 : 0)),
+					asic_acl.dstFilterPortLowerBound_,
+					asic_acl.dstFilterPortUpperBound_);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d   dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstFilterIpAddr_ >> 24),
+					((asic_acl.dstFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddr_ & 0xff),
+					(asic_acl.dstFilterIpAddrMask_ >> 24),
+					((asic_acl.dstFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddrMask_ & 0xff)
+					);
+				break;
+			case RTL865X_ACL_DSTFILTER_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start,
+					"Deatination Filter(IP Range)",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstFilterMac_.octet[0],
+					asic_acl.dstFilterMac_.octet[1],
+					asic_acl.dstFilterMac_.octet[2],
+					asic_acl.dstFilterMac_.octet[3],
+					asic_acl.dstFilterMac_.octet[4],
+					asic_acl.dstFilterMac_.octet[5],
+					asic_acl.dstFilterMacMask_.octet[0],
+					asic_acl.dstFilterMacMask_.octet[1],
+					asic_acl.dstFilterMacMask_.octet[2],
+					asic_acl.dstFilterMacMask_.octet[3],
+					asic_acl.dstFilterMacMask_.octet[4],
+					asic_acl.dstFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					asic_acl.dstFilterVlanIdx_,
+					asic_acl.dstFilterVlanIdxMask_,
+					(asic_acl.dstFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.dstFilterIgnoreL4_ == 1 ? 1 : 0)),
+					asic_acl.dstFilterPortLowerBound_,
+					asic_acl.dstFilterPortUpperBound_);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d   dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstFilterIpAddr_ >> 24),
+					((asic_acl.dstFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddr_ & 0xff),
+					(asic_acl.dstFilterIpAddrMask_ >> 24),
+					((asic_acl.dstFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddrMask_ & 0xff)
+					);
+				break;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			case RTL865X_ACL_IPV6:	/* IP Rule Type: 0x0010 */
+			case RTL865X_ACL_IPV6_RANGE:
+				/* A ipv6 rule occupied two entry,
+				 * function _rtl865x_getAclFromAsic take one entry at a time.
+				 * So we need to call function _rtl865x_getAclFromAsic again. */
+
+				acl_temp = acl_start;
+				acl_temp++;	/* move to the second entry index of ipv6 rule */
+				if (acl_temp <= acl_end) {	/* it should be less than or equal to acl_end. */
+					memset(&asic_acl2, 0x00,
+						sizeof(rtl865x_AclRule_t));
+					if (_rtl865x_getAclFromAsic(acl_temp,
+							&asic_acl2) == FAILED)
+						seq_printf(s,
+							"=============%s(%d): get asic acl rule error!\n",
+							__FUNCTION__, __LINE__);
+					if ((!asic_acl2.ipv6EntryType_)
+						&& asic_acl.ipv6EntryType_) {
+						asic_acl.dstIpV6Addr_.v6_addr32[3] =
+							asic_acl2.dstIpV6Addr_.v6_addr32[3];
+						asic_acl.dstIpV6Addr_.v6_addr32[2] =
+							asic_acl2.dstIpV6Addr_.v6_addr32[2];
+						asic_acl.dstIpV6Addr_.v6_addr32[1] =
+							asic_acl2.dstIpV6Addr_.v6_addr32[1];
+						asic_acl.dstIpV6Addr_.v6_addr32[0] =
+							asic_acl2.dstIpV6Addr_.v6_addr32[0];
+
+						asic_acl.dstIpV6AddrMask_.v6_addr32[3] =
+							asic_acl2.dstIpV6AddrMask_.v6_addr32[3];
+						asic_acl.dstIpV6AddrMask_.v6_addr32[2] =
+							asic_acl2.dstIpV6AddrMask_.v6_addr32[2];
+						asic_acl.dstIpV6AddrMask_.v6_addr32[1] =
+							asic_acl2.dstIpV6AddrMask_.v6_addr32[1];
+						asic_acl.dstIpV6AddrMask_.v6_addr32[0] =
+							asic_acl2.dstIpV6AddrMask_.v6_addr32[0];
+
+						asic_acl.ipv6TrafficClass_ =
+							asic_acl2.ipv6TrafficClass_;
+						asic_acl.ipv6TrafficClassM_ =
+							asic_acl2.ipv6TrafficClassM_;
+						asic_acl.ipv6NextHeader_ =
+							asic_acl2.ipv6NextHeader_;
+						asic_acl.ipv6NextHeaderM_ =
+							asic_acl2.ipv6NextHeaderM_;
+						asic_acl.ipv6HttpFilter_ =
+							asic_acl2.ipv6HttpFilter_;
+						asic_acl.ipv6HttpFilterM_ =
+							asic_acl2.ipv6HttpFilterM_;
+						asic_acl.ipv6IdentSrcDstIp_ =
+							asic_acl2.ipv6IdentSrcDstIp_;
+						asic_acl.ipv6IdentSrcDstIpM_ =
+							asic_acl2.ipv6IdentSrcDstIpM_;
+						/* ActionType and ActionField useless in entry0 */
+						asic_acl.actionType_ =
+							asic_acl2.actionType_;
+						switch (asic_acl.actionType_) {
+
+						case RTL865X_ACL_PERMIT:
+						case RTL865X_ACL_REDIRECT_ETHER:
+						case RTL865X_ACL_DROP:
+						case RTL865X_ACL_TOCPU:
+						case RTL865X_ACL_LEGACY_DROP:
+						case RTL865X_ACL_DROPCPU_LOG:
+						case RTL865X_ACL_MIRROR:
+						case RTL865X_ACL_REDIRECT_PPPOE:
+						case RTL865X_ACL_MIRROR_KEEP_MATCH:
+							asic_acl.L2Idx_ =
+								asic_acl2.L2Idx_;
+							asic_acl.netifIdx_ =
+								asic_acl2.netifIdx_;
+							asic_acl.pppoeIdx_ =
+								asic_acl2.pppoeIdx_;
+							break;
+
+						case RTL865X_ACL_DEFAULT_REDIRECT:
+							asic_acl.nexthopIdx_ =
+								asic_acl2.nexthopIdx_;
+							break;
+
+						case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+						case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+						case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+						case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+							asic_acl.ratelimtIdx_ =
+								asic_acl2.ratelimtIdx_;
+							break;
+						case RTL865X_ACL_PRIORITY:
+							asic_acl.priority_ =
+								asic_acl2.priority_;
+							break;
+						case RTL865X_ACL_VID:
+							asic_acl.aclvid_ =
+								asic_acl2.aclvid_;
+							break;
+						}
+						/* INV useless in entry 0 */
+						asic_acl.ipv6Invert_ =
+							asic_acl2.ipv6Invert_;
+						/* asic_acl.ipv6Combine_  = asic_acl2.ipv6Combine_ ; */
+						/* asic_acl.ipv6IPtunnel_ = asic_acl2.ipv6IPtunnel_; */
+						seq_printf(s,
+							" [%d-%d] rule type: %s   rule action: %s\n",
+							acl_start, acl_temp,
+							"IPv6",
+							actionT[asic_acl.actionType_]);
+						if (RTL865X_ACL_IPV6 ==
+							asic_acl.ruleType_) {
+							memset((void *)
+								&start_ip.v6_addr32[0],
+								0x00,
+								sizeof(start_ip));
+							memset((void *)&end_ip.v6_addr32[0],
+								0x00,
+								sizeof(end_ip));
+							ntohl_array((uint32 *)
+								&asic_acl.srcIpV6Addr_.v6_addr32[0],
+								(void *)&start_ip.v6_addr32[0],
+								4);
+							ntohl_array((uint32 *)
+								&asic_acl.srcIpV6AddrMask_.v6_addr32[0],
+								(void *)&end_ip.v6_addr32[0],
+								4);
+							seq_printf(s,
+								"\tsip: %x:%x:%x:%x:%x:%x:%x:%x  sipM: %x:%x:%x:%x:%x:%x:%x:%x\n",
+								htons(start_ip.v6_addr16[0]),
+								htons(start_ip.v6_addr16[1]),
+								htons(start_ip.v6_addr16[2]),
+								htons(start_ip.v6_addr16[3]),
+								htons(start_ip.v6_addr16[4]),
+								htons(start_ip.v6_addr16[5]),
+								htons(start_ip.v6_addr16[6]),
+								htons(start_ip.v6_addr16[7]),
+								htons(end_ip.v6_addr16[0]),
+								htons(end_ip.v6_addr16[1]),
+								htons(end_ip.v6_addr16[2]),
+								htons(end_ip.v6_addr16[3]),
+								htons(end_ip.v6_addr16[4]),
+								htons(end_ip.v6_addr16[5]),
+								htons(end_ip.v6_addr16[6]),
+								htons(end_ip.v6_addr16[7])
+								);
+
+							memset((void *)
+								&start_ip.v6_addr32[0],
+								0x00,
+								sizeof(start_ip));
+							memset((void *)&end_ip.v6_addr32[0],
+								0x00,
+								sizeof(end_ip));
+							ntohl_array((uint32 *)
+								&asic_acl.dstIpV6Addr_.v6_addr32[0],
+								(void *)&start_ip.v6_addr32[0],
+								4);
+							ntohl_array((uint32 *)
+								&asic_acl.dstIpV6AddrMask_.v6_addr32[0],
+								(void *)&end_ip.v6_addr32[0],
+								4);
+							seq_printf(s,
+								"\tdip: %x:%x:%x:%x:%x:%x:%x:%x  dipM: %x:%x:%x:%x:%x:%x:%x:%x\n",
+								htons(start_ip.v6_addr16[0]),
+								htons(start_ip.v6_addr16[1]),
+								htons(start_ip.v6_addr16[2]),
+								htons(start_ip.v6_addr16[3]),
+								htons(start_ip.v6_addr16[4]),
+								htons(start_ip.v6_addr16[5]),
+								htons(start_ip.v6_addr16[6]),
+								htons(start_ip.v6_addr16[7]),
+								htons(end_ip.v6_addr16[0]),
+								htons(end_ip.v6_addr16[1]),
+								htons(end_ip.v6_addr16[2]),
+								htons(end_ip.v6_addr16[3]),
+								htons(end_ip.v6_addr16[4]),
+								htons(end_ip.v6_addr16[5]),
+								htons(end_ip.v6_addr16[6]),
+								htons(end_ip.v6_addr16[7])
+								);
+
+						} else if
+							(RTL865X_ACL_IPV6_RANGE
+							== asic_acl.ruleType_) {
+							memset((void *)
+								&start_ip.v6_addr32[0],
+								0x00,
+								sizeof(start_ip));
+							memset((void *)&end_ip.v6_addr32[0],
+								0x00,
+								sizeof(end_ip));
+							ntohl_array((uint32 *)
+								&asic_acl.srcIpV6AddrLB_.v6_addr32[0],
+								(void *)
+								&start_ip.v6_addr32[0],
+								4);
+							ntohl_array((uint32 *)
+								&asic_acl.srcIpV6AddrUB_.v6_addr32[0],
+								(void *)&end_ip.v6_addr32[0],
+								4);
+							seq_printf(s,
+								"\tsipLB: %x:%x:%x:%x:%x:%x:%x:%x  sipUB: %x:%x:%x:%x:%x:%x:%x:%x\n",
+								htons(start_ip.v6_addr16[0]),
+								htons(start_ip.v6_addr16[1]),
+								htons(start_ip.v6_addr16[2]),
+								htons(start_ip.v6_addr16[3]),
+								htons(start_ip.v6_addr16[4]),
+								htons(start_ip.v6_addr16[5]),
+								htons(start_ip.v6_addr16[6]),
+								htons(start_ip.v6_addr16[7]),
+								htons(end_ip.v6_addr16[0]),
+								htons(end_ip.v6_addr16[1]),
+								htons(end_ip.v6_addr16[2]),
+								htons(end_ip.v6_addr16[3]),
+								htons(end_ip.v6_addr16[4]),
+								htons(end_ip.v6_addr16[5]),
+								htons(end_ip.v6_addr16[6]),
+								htons(end_ip.v6_addr16[7])
+								);
+							memset((void *)
+								&start_ip.v6_addr32[0],
+								0x00,
+								sizeof(start_ip));
+							memset((void *)&end_ip.v6_addr32[0],
+								0x00,
+								sizeof(end_ip));
+							ntohl_array((uint32 *)
+								&asic_acl.dstIpV6AddrLB_.v6_addr32[0],
+								(void *)
+								&start_ip.v6_addr32[0],
+								4);
+							ntohl_array((uint32 *)
+								&asic_acl.dstIpV6AddrUB_.v6_addr32[0],
+								(void *)&end_ip.v6_addr32[0],
+								4);
+							seq_printf(s,
+								"\tdipLB: %x:%x:%x:%x:%x:%x:%x:%x  dipUB: %x:%x:%x:%x:%x:%x:%x:%x\n",
+								htons(start_ip.v6_addr16[0]),
+								htons(start_ip.v6_addr16[1]),
+								htons(start_ip.v6_addr16[2]),
+								htons(start_ip.v6_addr16[3]),
+								htons(start_ip.v6_addr16[4]),
+								htons(start_ip.v6_addr16[5]),
+								htons(start_ip.v6_addr16[6]),
+								htons(start_ip.v6_addr16[7]),
+								htons(end_ip.v6_addr16[0]),
+								htons(end_ip.v6_addr16[1]),
+								htons(end_ip.v6_addr16[2]),
+								htons(end_ip.v6_addr16[3]),
+								htons(end_ip.v6_addr16[4]),
+								htons(end_ip.v6_addr16[5]),
+								htons(end_ip.v6_addr16[6]),
+								htons(end_ip.v6_addr16[7])
+
+								);
+						}
+						seq_printf(s,
+							"\tFlowLabel: 0x%x   FlowLabelM: 0x%x\n",
+							asic_acl.ipv6FlowLabel_,
+							asic_acl.ipv6FlowLabelM_);
+						seq_printf(s,
+							"\tInvert: %d   Combine1: %d   Combine2: %d   IPtunnel: %d\n",
+							asic_acl.ipv6Invert_,
+							asic_acl.ipv6Combine_,
+							asic_acl2.ipv6Combine_,
+							asic_acl.ipv6IPtunnel_);
+						seq_printf(s,
+							"\tTrafficClassP: %d   TrafficClassM: %d   NextHeaderP: %d   NextHeaderM: %d\n",
+							asic_acl.ipv6TrafficClass_,
+							asic_acl.ipv6TrafficClassM_,
+							asic_acl.ipv6NextHeader_,
+							asic_acl.ipv6NextHeaderM_);
+						seq_printf(s,
+							"\tHTTPP: %d   HTTPM: %d   IdentSDIPP: %d   IdentSDIPM: %d\n",
+							asic_acl.ipv6HttpFilter_,
+							asic_acl.ipv6HttpFilterM_,
+							asic_acl.ipv6IdentSrcDstIp_,
+							asic_acl.ipv6IdentSrcDstIpM_);
+#if defined(CONFIG_RTL_8197F)
+						seq_printf(s,
+							"\tIpfragApply: %d\n",
+							asic_acl.ipfrag_apply_);
+#endif
+						/* update acl index */
+						acl_start = acl_temp;
+					}
+
+				}
+				break;
+#endif
+#if defined(CONFIG_RTL_8197F)
+			case RTL865X_ACL_PM:
+				/* A pattern match rule occupied two entry,
+				 * function _rtl865x_getAclFromAsic take one entry at a time.
+				 * So we need to call function _rtl865x_getAclFromAsic again. */
+				acl_temp = acl_start;
+				acl_temp++;	/* move to the second entry index of pattern match rule */
+				if (acl_temp <= acl_end) {	/* it should be less than or equal to acl_end. */
+					memset(&asic_acl2, 0x00,
+						sizeof(rtl865x_AclRule_t));
+					if (_rtl865x_getAclFromAsic(acl_temp,
+							&asic_acl2) == FAILED)
+						seq_printf(s,
+							"=============%s(%d): get asic acl rule error!\n",
+							__FUNCTION__, __LINE__);
+					if ((!asic_acl2.ipv6EntryType_)
+						&& asic_acl.ipv6EntryType_) {
+						/* ActionType and ActionField useless in entry0 */
+						asic_acl.actionType_ =
+							asic_acl2.actionType_;
+						switch (asic_acl.actionType_) {
+						case RTL865X_ACL_PERMIT:
+						case RTL865X_ACL_REDIRECT_ETHER:
+						case RTL865X_ACL_DROP:
+						case RTL865X_ACL_TOCPU:
+						case RTL865X_ACL_LEGACY_DROP:
+						case RTL865X_ACL_DROPCPU_LOG:
+						case RTL865X_ACL_MIRROR:
+						case RTL865X_ACL_REDIRECT_PPPOE:
+						case RTL865X_ACL_MIRROR_KEEP_MATCH:
+							asic_acl.L2Idx_ =
+								asic_acl2.L2Idx_;
+							asic_acl.netifIdx_ =
+								asic_acl2.netifIdx_;
+							asic_acl.pppoeIdx_ =
+								asic_acl2.pppoeIdx_;
+							break;
+
+						case RTL865X_ACL_DEFAULT_REDIRECT:
+							asic_acl.nexthopIdx_ =
+								asic_acl2.nexthopIdx_;
+							break;
+
+						case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+						case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+						case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+						case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+							asic_acl.ratelimtIdx_ =
+								asic_acl2.ratelimtIdx_;
+							break;
+						case RTL865X_ACL_PRIORITY:
+							asic_acl.priority_ =
+								asic_acl2.priority_;
+							break;
+						case RTL865X_ACL_VID:
+							asic_acl.aclvid_ =
+								asic_acl2.aclvid_;
+							break;
+						}
+						/* INV useless in entry 0 */
+						asic_acl.ipv6Invert_ =
+							asic_acl2.ipv6Invert_;
+						/* asic_acl.ipv6Combine_  = asic_acl2.ipv6Combine_ ; */
+						/* asic_acl.ipv6IPtunnel_ = asic_acl2.ipv6IPtunnel_; */
+						/* output entry0's valid field */
+						seq_printf(s,
+							" [%d-%d] rule type: %s	rule action: %s\n",
+							acl_start, acl_temp,
+							"Pattern match",
+							actionT[asic_acl.actionType_]);
+						seq_printf(s,
+							"\tsportU: %d sportL: %d dportU: %d dportL: %d protocol: %d\n",
+							asic_acl.un_ty.PM._spub,
+							asic_acl.un_ty.PM._splb,
+							asic_acl.un_ty.PM._dpub,
+							asic_acl.un_ty.PM._dplb,
+							asic_acl.un_ty.PM._protocol);
+						seq_printf(s,
+							"\tOffset0: %d Pattern0: 0x%04x PatternMask0: 0x%04x OR0: %d\n",
+							asic_acl.un_ty.PM._offset0,
+							asic_acl.un_ty.PM._pattern0,
+							asic_acl.un_ty.PM._pm0,
+							asic_acl.un_ty.PM._or0);
+						seq_printf(s,
+							"\tOffset1: %d Pattern1: 0x%04x PatternMask1: 0x%04x OR1: %d\n",
+							asic_acl.un_ty.PM._offset1,
+							asic_acl.un_ty.PM._pattern1,
+							asic_acl.un_ty.PM._pm1,
+							asic_acl.un_ty.PM._or1);
+						seq_printf(s,
+							"\tOffset2: %d Pattern2: 0x%04x PatternMask2: 0x%04x OR2: %d\n",
+							asic_acl.un_ty.PM._offset2,
+							asic_acl.un_ty.PM._pattern2,
+							asic_acl.un_ty.PM._pm2,
+							asic_acl.un_ty.PM._or2);
+						seq_printf(s,
+							"\tOffset3: %d Pattern3: 0x%04x PatternMask3: 0x%04x OR3: %d\n",
+							asic_acl.un_ty.PM._offset3,
+							asic_acl.un_ty.PM._pattern3,
+							asic_acl.un_ty.PM._pm3,
+							asic_acl.un_ty.PM._or3);
+
+						/* output entry1's valid field */
+						seq_printf(s,
+							"\tOffset4: %d Pattern4: 0x%04x PatternMask4: 0x%04x OR4: %d\n",
+							asic_acl2.un_ty.PM._offset4,
+							asic_acl2.un_ty.PM._pattern4,
+							asic_acl2.un_ty.PM._pm4,
+							asic_acl2.un_ty.PM._or4);
+						seq_printf(s,
+							"\tOffset5: %d Pattern5: 0x%04x PatternMask5: 0x%04x OR5: %d\n",
+							asic_acl2.un_ty.PM._offset5,
+							asic_acl2.un_ty.PM._pattern5,
+							asic_acl2.un_ty.PM._pm5,
+							asic_acl2.un_ty.PM._or5);
+						seq_printf(s,
+							"\tOffset6: %d Pattern6: 0x%04x PatternMask6: 0x%04x OR6: %d\n",
+							asic_acl2.un_ty.PM._offset6,
+							asic_acl2.un_ty.PM._pattern6,
+							asic_acl2.un_ty.PM._pm6,
+							asic_acl2.un_ty.PM._or6);
+						seq_printf(s,
+							"\tOffset7: %d Pattern7: 0x%04x PatternMask7: 0x%04x OR7: %d\n",
+							asic_acl2.un_ty.PM._offset7,
+							asic_acl2.un_ty.PM._pattern7,
+							asic_acl2.un_ty.PM._pm7,
+							asic_acl2.un_ty.PM._or7);
+						seq_printf(s,
+							"\tSpecialOP: %d SrcPortPattern: %d SrcPortMask: %d PPPCTL: %d PPPCTLM: %d PPPCTLOR: %d\n",
+							asic_acl2.un_ty.PM._specialop,
+							asic_acl2.un_ty.PM._spa,
+							asic_acl2.un_ty.PM._spam,
+							asic_acl2.un_ty.PM._pppctl,
+							asic_acl2.un_ty.PM._pppctlm,
+							asic_acl2.un_ty.PM._pppctlor);
+						seq_printf(s,
+							"\tInvert: %d   Combine1: %d   Combine2: %d   IPtunnel1: %d IPtunnel2: %d IpfragApply: %d\n",
+							asic_acl2.ipv6Invert_,
+							asic_acl2.ipv6Combine_,
+							asic_acl2.ipv6Combine_,
+							asic_acl.ipv6IPtunnel_,
+							asic_acl2.ipv6IPtunnel_,
+							asic_acl2.ipfrag_apply_);
+						/* update acl index */
+						acl_start = acl_temp;
+					}
+
+				}
+				break;
+#endif
+
+			default:
+				seq_printf(s, "asic_acl.ruleType_(0x%x)\n",
+					asic_acl.ruleType_);
+
+			}
+
+			/* Action type */
+			switch (asic_acl.actionType_) {
+
+			case RTL865X_ACL_PERMIT:
+			case RTL865X_ACL_REDIRECT_ETHER:
+			case RTL865X_ACL_DROP:
+			case RTL865X_ACL_TOCPU:
+			case RTL865X_ACL_LEGACY_DROP:
+			case RTL865X_ACL_DROPCPU_LOG:
+			case RTL865X_ACL_MIRROR:
+			case RTL865X_ACL_REDIRECT_PPPOE:
+			case RTL865X_ACL_MIRROR_KEEP_MATCH:
+				seq_printf(s,
+					"\tnetifIdx: %d   pppoeIdx: %d   l2Idx:%d  ",
+					asic_acl.netifIdx_, asic_acl.pppoeIdx_,
+					asic_acl.L2Idx_);
+				break;
+
+			case RTL865X_ACL_PRIORITY:
+				seq_printf(s, "\tprioirty: %d   ",
+					asic_acl.priority_);
+				break;
+
+			case RTL865X_ACL_DEFAULT_REDIRECT:
+				seq_printf(s, "\tnextHop:%d  ",
+					asic_acl.nexthopIdx_);
+				break;
+
+			case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+			case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+			case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+			case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+				seq_printf(s, "\tratelimitIdx: %d  ",
+					asic_acl.ratelimtIdx_);
+				break;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			case RTL865X_ACL_VID:
+				seq_printf(s, "\taclvid: %d  ",
+					asic_acl.aclvid_);
+				break;
+#endif
+			default:
+				;
+
+			}
+			seq_printf(s, "pktOpApp: %d\n", asic_acl.pktOpApp_);
+#if defined(CONFIG_RTL_8197F) || defined(CONFIG_RTL_8198C)
+			if (!((asic_acl.ruleType_ == RTL865X_ACL_IPV6)
+					|| (asic_acl.ruleType_ ==
+						RTL865X_ACL_IPV6_RANGE)
+#if defined(CONFIG_RTL_8197F)
+					|| (asic_acl.ruleType_ ==
+						RTL865X_ACL_PM)
+#endif
+				)) {
+				seq_printf(s,
+					"\tInvert: %d   Combine: %d	IPtunnel: %d",
+					asic_acl.ipv6Invert_,
+					asic_acl.ipv6Combine_,
+					asic_acl.ipv6IPtunnel_);
+#if defined(CONFIG_RTL_8197F)
+				seq_printf(s, " IpfragApply: %d\n",
+					asic_acl.ipfrag_apply_);
+#else
+				seq_printf(s, "\n");
+#endif
+
+			}
+#endif
+		}
+#else
+		for (; acl_start <= acl_end; acl_start++) {
+			if (rtl8651_getAsicAclRule(acl_start,
+					&asic_acl) == FAILED)
+				seq_printf(s,
+					"=============%s(%d): get asic acl rule error!\n",
+					__FUNCTION__, __LINE__);
+
+			switch (asic_acl.ruleType_) {
+			case RTL8651_ACL_MAC:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Ethernet",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tether type: %x   ether type mask: %x\n",
+					asic_acl.typeLen_,
+					asic_acl.typeLenMask_);
+				seq_printf(s,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstMac_.octet[0],
+					asic_acl.dstMac_.octet[1],
+					asic_acl.dstMac_.octet[2],
+					asic_acl.dstMac_.octet[3],
+					asic_acl.dstMac_.octet[4],
+					asic_acl.dstMac_.octet[5],
+					asic_acl.dstMacMask_.octet[0],
+					asic_acl.dstMacMask_.octet[1],
+					asic_acl.dstMacMask_.octet[2],
+					asic_acl.dstMacMask_.octet[3],
+					asic_acl.dstMacMask_.octet[4],
+					asic_acl.dstMacMask_.octet[5]
+					);
+
+				seq_printf(s,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcMac_.octet[0],
+					asic_acl.srcMac_.octet[1],
+					asic_acl.srcMac_.octet[2],
+					asic_acl.srcMac_.octet[3],
+					asic_acl.srcMac_.octet[4],
+					asic_acl.srcMac_.octet[5],
+					asic_acl.srcMacMask_.octet[0],
+					asic_acl.srcMacMask_.octet[1],
+					asic_acl.srcMacMask_.octet[2],
+					asic_acl.srcMacMask_.octet[3],
+					asic_acl.srcMacMask_.octet[4],
+					asic_acl.srcMacMask_.octet[5]
+					);
+				break;
+
+			case RTL8651_ACL_IP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.ipProto_,
+					asic_acl.ipProtoMask_, asic_acl.ipFlag_,
+					asic_acl.ipFlagMask_);
+
+				seq_printf(s,
+					"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					asic_acl.ipFOP_, asic_acl.ipFOM_,
+					asic_acl.ipHttpFilter_,
+					asic_acl.ipHttpFilterM_,
+					asic_acl.ipIdentSrcDstIp_,
+					asic_acl.ipIdentSrcDstIpM_);
+				seq_printf(s, "\t<DF:%x> <MF:%x>\n",
+					asic_acl.ipDF_, asic_acl.ipMF_);
+				break;
+
+			case RTL8652_ACL_IP_RANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IP Range",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.ipProto_,
+					asic_acl.ipProtoMask_, asic_acl.ipFlag_,
+					asic_acl.ipFlagMask_);
+				seq_printf(s,
+					"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					asic_acl.ipFOP_, asic_acl.ipFOM_,
+					asic_acl.ipHttpFilter_,
+					asic_acl.ipHttpFilterM_,
+					asic_acl.ipIdentSrcDstIp_,
+					asic_acl.ipIdentSrcDstIpM_);
+				seq_printf(s, "\t<DF:%x> <MF:%x>\n",
+					asic_acl.ipDF_, asic_acl.ipMF_);
+				break;
+			case RTL8651_ACL_ICMP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "ICMP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.icmpType_,
+					asic_acl.icmpTypeMask_,
+					asic_acl.icmpCode_,
+					asic_acl.icmpCodeMask_);
+				break;
+			case RTL8652_ACL_ICMP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "ICMP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.icmpType_,
+					asic_acl.icmpTypeMask_,
+					asic_acl.icmpCode_,
+					asic_acl.icmpCodeMask_);
+				break;
+			case RTL8651_ACL_IGMP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IGMP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.igmpType_,
+					asic_acl.igmpTypeMask_);
+				break;
+
+			case RTL8652_ACL_IGMP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IGMP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.igmpType_,
+					asic_acl.igmpTypeMask_);
+				break;
+
+			case RTL8651_ACL_TCP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "TCP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.tcpSrcPortLB_,
+					asic_acl.tcpSrcPortUB_,
+					asic_acl.tcpDstPortLB_,
+					asic_acl.tcpDstPortUB_);
+				seq_printf(s,
+					"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					asic_acl.tcpFlag_,
+					asic_acl.tcpFlagMask_, asic_acl.tcpURG_,
+					asic_acl.tcpACK_, asic_acl.tcpPSH_,
+					asic_acl.tcpRST_, asic_acl.tcpSYN_,
+					asic_acl.tcpFIN_);
+				break;
+			case RTL8652_ACL_TCP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "TCP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.tcpSrcPortLB_,
+					asic_acl.tcpSrcPortUB_,
+					asic_acl.tcpDstPortLB_,
+					asic_acl.tcpDstPortUB_);
+				seq_printf(s,
+					"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					asic_acl.tcpFlag_,
+					asic_acl.tcpFlagMask_, asic_acl.tcpURG_,
+					asic_acl.tcpACK_, asic_acl.tcpPSH_,
+					asic_acl.tcpRST_, asic_acl.tcpSYN_,
+					asic_acl.tcpFIN_);
+				break;
+
+			case RTL8651_ACL_UDP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.udpSrcPortLB_,
+					asic_acl.udpSrcPortUB_,
+					asic_acl.udpDstPortLB_,
+					asic_acl.udpDstPortUB_);
+				break;
+			case RTL8652_ACL_UDP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.udpSrcPortLB_,
+					asic_acl.udpSrcPortUB_,
+					asic_acl.udpDstPortLB_,
+					asic_acl.udpDstPortUB_);
+				break;
+
+			case RTL8651_ACL_IFSEL:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s, "\tgidxSel: %x\n",
+					asic_acl.gidxSel_);
+				break;
+			case RTL8651_ACL_SRCFILTER:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Source Filter",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcFilterMac_.octet[0],
+					asic_acl.srcFilterMac_.octet[1],
+					asic_acl.srcFilterMac_.octet[2],
+					asic_acl.srcFilterMac_.octet[3],
+					asic_acl.srcFilterMac_.octet[4],
+					asic_acl.srcFilterMac_.octet[5],
+					asic_acl.srcFilterMacMask_.octet[0],
+					asic_acl.srcFilterMacMask_.octet[1],
+					asic_acl.srcFilterMacMask_.octet[2],
+					asic_acl.srcFilterMacMask_.octet[3],
+					asic_acl.srcFilterMacMask_.octet[4],
+					asic_acl.srcFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					asic_acl.srcFilterVlanIdx_,
+					asic_acl.srcFilterVlanIdxMask_,
+					asic_acl.srcFilterPort_,
+					asic_acl.srcFilterPortMask_,
+					(asic_acl.srcFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.srcFilterIgnoreL4_ == 1 ? 1 : 0))
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d   sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcFilterIpAddr_ >> 24),
+					((asic_acl.srcFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddr_ & 0xff),
+					(asic_acl.srcFilterIpAddrMask_ >> 24),
+					((asic_acl.srcFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddrMask_ & 0xff)
+					);
+				seq_printf(s, "\tsportL: %d   sportU: %d\n",
+					asic_acl.srcFilterPortLowerBound_,
+					asic_acl.srcFilterPortUpperBound_);
+				break;
+
+			case RTL8652_ACL_SRCFILTER_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Source Filter(IP RANGE)",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcFilterMac_.octet[0],
+					asic_acl.srcFilterMac_.octet[1],
+					asic_acl.srcFilterMac_.octet[2],
+					asic_acl.srcFilterMac_.octet[3],
+					asic_acl.srcFilterMac_.octet[4],
+					asic_acl.srcFilterMac_.octet[5],
+					asic_acl.srcFilterMacMask_.octet[0],
+					asic_acl.srcFilterMacMask_.octet[1],
+					asic_acl.srcFilterMacMask_.octet[2],
+					asic_acl.srcFilterMacMask_.octet[3],
+					asic_acl.srcFilterMacMask_.octet[4],
+					asic_acl.srcFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					asic_acl.srcFilterVlanIdx_,
+					asic_acl.srcFilterVlanIdxMask_,
+					asic_acl.srcFilterPort_,
+					asic_acl.srcFilterPortMask_,
+					(asic_acl.srcFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.srcFilterIgnoreL4_ == 1 ? 1 : 0))
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d   sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcFilterIpAddr_ >> 24),
+					((asic_acl.srcFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddr_ & 0xff),
+					(asic_acl.srcFilterIpAddrMask_ >> 24),
+					((asic_acl.srcFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddrMask_ & 0xff)
+					);
+				seq_printf(s, "\tsportL: %d   sportU: %d\n",
+					asic_acl.srcFilterPortLowerBound_,
+					asic_acl.srcFilterPortUpperBound_);
+				break;
+
+			case RTL8651_ACL_DSTFILTER:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Deatination Filter",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstFilterMac_.octet[0],
+					asic_acl.dstFilterMac_.octet[1],
+					asic_acl.dstFilterMac_.octet[2],
+					asic_acl.dstFilterMac_.octet[3],
+					asic_acl.dstFilterMac_.octet[4],
+					asic_acl.dstFilterMac_.octet[5],
+					asic_acl.dstFilterMacMask_.octet[0],
+					asic_acl.dstFilterMacMask_.octet[1],
+					asic_acl.dstFilterMacMask_.octet[2],
+					asic_acl.dstFilterMacMask_.octet[3],
+					asic_acl.dstFilterMacMask_.octet[4],
+					asic_acl.dstFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					asic_acl.dstFilterVlanIdx_,
+					asic_acl.dstFilterVlanIdxMask_,
+					(asic_acl.dstFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.dstFilterIgnoreL4_ == 1 ? 1 : 0)),
+					asic_acl.dstFilterPortLowerBound_,
+					asic_acl.dstFilterPortUpperBound_);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d   dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstFilterIpAddr_ >> 24),
+					((asic_acl.dstFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddr_ & 0xff),
+					(asic_acl.dstFilterIpAddrMask_ >> 24),
+					((asic_acl.dstFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddrMask_ & 0xff)
+					);
+				break;
+			case RTL8652_ACL_DSTFILTER_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start,
+					"Deatination Filter(IP Range)",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstFilterMac_.octet[0],
+					asic_acl.dstFilterMac_.octet[1],
+					asic_acl.dstFilterMac_.octet[2],
+					asic_acl.dstFilterMac_.octet[3],
+					asic_acl.dstFilterMac_.octet[4],
+					asic_acl.dstFilterMac_.octet[5],
+					asic_acl.dstFilterMacMask_.octet[0],
+					asic_acl.dstFilterMacMask_.octet[1],
+					asic_acl.dstFilterMacMask_.octet[2],
+					asic_acl.dstFilterMacMask_.octet[3],
+					asic_acl.dstFilterMacMask_.octet[4],
+					asic_acl.dstFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					asic_acl.dstFilterVlanIdx_,
+					asic_acl.dstFilterVlanIdxMask_,
+					(asic_acl.dstFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.dstFilterIgnoreL4_ == 1 ? 1 : 0)),
+					asic_acl.dstFilterPortLowerBound_,
+					asic_acl.dstFilterPortUpperBound_);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d   dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstFilterIpAddr_ >> 24),
+					((asic_acl.dstFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddr_ & 0xff),
+					(asic_acl.dstFilterIpAddrMask_ >> 24),
+					((asic_acl.dstFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddrMask_ & 0xff)
+					);
+				break;
+
+			default:
+				seq_printf(s, "asic_acl.ruleType_(0x%x)\n",
+					asic_acl.ruleType_);
+
+			}
+
+			/* Action type */
+			switch (asic_acl.actionType_) {
+
+			case RTL8651_ACL_PERMIT:	/* 0x00 */
+			case RTL8651_ACL_REDIRECT:	/* 0x01 */
+			case RTL8651_ACL_CPU:	/* 0x03 */
+			case RTL8651_ACL_DROP:	/* 0x02, 0x04 */
+			case RTL8651_ACL_DROP_LOG:	/* 0x05 */
+			case RTL8651_ACL_MIRROR:	/* 0x06 */
+			case RTL8651_ACL_REDIRECT_PPPOE:	/* 0x07 */
+			case RTL8651_ACL_MIRROR_KEEP_MATCH:	/* 0x09 */
+				seq_printf(s,
+					"\tdvidx: %d   hp: %d   pppoeIdx: %d   nxtHop:%d  ",
+					asic_acl.dvid_, asic_acl.priority_,
+					asic_acl.pppoeIdx_, asic_acl.nextHop_);
+				break;
+
+			case RTL8651_ACL_POLICY:	/* 0x08 */
+				seq_printf(s, "\thp: %d   nxtHopIdx: %d  ",
+					asic_acl.priority_, asic_acl.nhIndex);
+				break;
+
+			case RTL8651_ACL_PRIORITY:	/* 0x08 */
+				seq_printf(s, "\tprioirty: %d   ",
+					asic_acl.priority);
+				break;
+
+			case RTL8651_ACL_DROP_RATE_EXCEED_PPS:	/* 0x0a */
+			case RTL8651_ACL_LOG_RATE_EXCEED_PPS:	/* 0x0b */
+			case RTL8651_ACL_DROP_RATE_EXCEED_BPS:	/* 0x0c */
+			case RTL8651_ACL_LOG_RATE_EXCEED_BPS:	/* 0x0d */
+				seq_printf(s, "\trlIdx: %d  ",
+					asic_acl.rlIndex);
+				break;
+			default:
+				;
+
+			}
+			seq_printf(s, "pktOpApp: %d\n", asic_acl.pktOpApp);
+
+		}
+
+#endif
+
+		if (outRule == FALSE) {
+			acl_start = asic_intf.outAclStart;
+			acl_end = asic_intf.outAclEnd;
+			outRule = TRUE;
+			goto again;
+		}
+	}
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC) || defined(CONFIG_RTL_MULTIPLE_WAN) || defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+	{
+
+		outRule = FALSE;
+		rtl865x_getDefACLForNetDecisionMiss(&defInAclStart,
+			&defInAclEnd, &defOutAclStart, &defOutAclEnd);
+		acl_start = defInAclStart;
+		acl_end = defInAclEnd;
+		seq_printf(s, "\nacl_start(%d), acl_end(%d)", acl_start,
+			acl_end);
+again_forOutAcl:
+		if (outRule == FALSE)
+			seq_printf(s,
+				"\n<<Default Ingress Rule for Netif Missed>>:\n");
+		else
+			seq_printf(s,
+				"\n<<Default Egress Rule for Netif Missed>>:\n");
+
+		for (; acl_start <= acl_end; acl_start++) {
+			if (_rtl865x_getAclFromAsic(acl_start,
+					&asic_acl) == FAILED)
+				seq_printf(s,
+					"=============%s(%d): get asic acl rule error!\n",
+					__FUNCTION__, __LINE__);
+
+			switch (asic_acl.ruleType_) {
+			case RTL865X_ACL_MAC:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Ethernet",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tether type: %x   ether type mask: %x\n",
+					asic_acl.typeLen_,
+					asic_acl.typeLenMask_);
+				seq_printf(s,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstMac_.octet[0],
+					asic_acl.dstMac_.octet[1],
+					asic_acl.dstMac_.octet[2],
+					asic_acl.dstMac_.octet[3],
+					asic_acl.dstMac_.octet[4],
+					asic_acl.dstMac_.octet[5],
+					asic_acl.dstMacMask_.octet[0],
+					asic_acl.dstMacMask_.octet[1],
+					asic_acl.dstMacMask_.octet[2],
+					asic_acl.dstMacMask_.octet[3],
+					asic_acl.dstMacMask_.octet[4],
+					asic_acl.dstMacMask_.octet[5]
+					);
+
+				seq_printf(s,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcMac_.octet[0],
+					asic_acl.srcMac_.octet[1],
+					asic_acl.srcMac_.octet[2],
+					asic_acl.srcMac_.octet[3],
+					asic_acl.srcMac_.octet[4],
+					asic_acl.srcMac_.octet[5],
+					asic_acl.srcMacMask_.octet[0],
+					asic_acl.srcMacMask_.octet[1],
+					asic_acl.srcMacMask_.octet[2],
+					asic_acl.srcMacMask_.octet[3],
+					asic_acl.srcMacMask_.octet[4],
+					asic_acl.srcMacMask_.octet[5]
+					);
+				break;
+
+			case RTL865X_ACL_IP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.ipProto_,
+					asic_acl.ipProtoMask_, asic_acl.ipFlag_,
+					asic_acl.ipFlagMask_);
+
+				seq_printf(s,
+					"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					asic_acl.ipFOP_, asic_acl.ipFOM_,
+					asic_acl.ipHttpFilter_,
+					asic_acl.ipHttpFilterM_,
+					asic_acl.ipIdentSrcDstIp_,
+					asic_acl.ipIdentSrcDstIpM_);
+				seq_printf(s, "\t<DF:%x> <MF:%x>\n",
+					asic_acl.ipDF_, asic_acl.ipMF_);
+				break;
+
+			case RTL865X_ACL_IP_RANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IP Range",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.ipProto_,
+					asic_acl.ipProtoMask_, asic_acl.ipFlag_,
+					asic_acl.ipFlagMask_);
+				seq_printf(s,
+					"\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> \n",
+					asic_acl.ipFOP_, asic_acl.ipFOM_,
+					asic_acl.ipHttpFilter_,
+					asic_acl.ipHttpFilterM_,
+					asic_acl.ipIdentSrcDstIp_,
+					asic_acl.ipIdentSrcDstIpM_);
+				seq_printf(s, "\t<DF:%x> <MF:%x>\n",
+					asic_acl.ipDF_, asic_acl.ipMF_);
+				break;
+			case RTL865X_ACL_ICMP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "ICMP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.icmpType_,
+					asic_acl.icmpTypeMask_,
+					asic_acl.icmpCode_,
+					asic_acl.icmpCodeMask_);
+				break;
+			case RTL865X_ACL_ICMP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "ICMP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.icmpType_,
+					asic_acl.icmpTypeMask_,
+					asic_acl.icmpCode_,
+					asic_acl.icmpCodeMask_);
+				break;
+			case RTL865X_ACL_IGMP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IGMP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.igmpType_,
+					asic_acl.igmpTypeMask_);
+				break;
+
+			case RTL865X_ACL_IGMP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "IGMP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos: %x   TosM: %x   type: %x   typeM: %x\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.igmpType_,
+					asic_acl.igmpTypeMask_);
+				break;
+
+			case RTL865X_ACL_TCP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "TCP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.tcpSrcPortLB_,
+					asic_acl.tcpSrcPortUB_,
+					asic_acl.tcpDstPortLB_,
+					asic_acl.tcpDstPortUB_);
+				seq_printf(s,
+					"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					asic_acl.tcpFlag_,
+					asic_acl.tcpFlagMask_, asic_acl.tcpURG_,
+					asic_acl.tcpACK_, asic_acl.tcpPSH_,
+					asic_acl.tcpRST_, asic_acl.tcpSYN_,
+					asic_acl.tcpFIN_);
+				break;
+			case RTL865X_ACL_TCP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "TCP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.tcpSrcPortLB_,
+					asic_acl.tcpSrcPortUB_,
+					asic_acl.tcpDstPortLB_,
+					asic_acl.tcpDstPortUB_);
+				seq_printf(s,
+					"\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
+					asic_acl.tcpFlag_,
+					asic_acl.tcpFlagMask_, asic_acl.tcpURG_,
+					asic_acl.tcpACK_, asic_acl.tcpPSH_,
+					asic_acl.tcpRST_, asic_acl.tcpSYN_,
+					asic_acl.tcpFIN_);
+				break;
+
+			case RTL865X_ACL_UDP:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.udpSrcPortLB_,
+					asic_acl.udpSrcPortUB_,
+					asic_acl.udpDstPortLB_,
+					asic_acl.udpDstPortUB_);
+				break;
+			case RTL865X_ACL_UDP_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "UDP IP RANGE",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstIpAddr_ >> 24),
+					((asic_acl.dstIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddr_ & 0xff),
+					(asic_acl.dstIpAddrMask_ >> 24),
+					((asic_acl.dstIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcIpAddr_ >> 24),
+					((asic_acl.srcIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddr_ & 0xff),
+					(asic_acl.srcIpAddrMask_ >> 24),
+					((asic_acl.srcIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcIpAddrMask_ & 0xff)
+					);
+				seq_printf(s,
+					"\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
+					asic_acl.tos_, asic_acl.tosMask_,
+					asic_acl.udpSrcPortLB_,
+					asic_acl.udpSrcPortUB_,
+					asic_acl.udpDstPortLB_,
+					asic_acl.udpDstPortUB_);
+				break;
+
+			case RTL865X_ACL_SRCFILTER:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Source Filter",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcFilterMac_.octet[0],
+					asic_acl.srcFilterMac_.octet[1],
+					asic_acl.srcFilterMac_.octet[2],
+					asic_acl.srcFilterMac_.octet[3],
+					asic_acl.srcFilterMac_.octet[4],
+					asic_acl.srcFilterMac_.octet[5],
+					asic_acl.srcFilterMacMask_.octet[0],
+					asic_acl.srcFilterMacMask_.octet[1],
+					asic_acl.srcFilterMacMask_.octet[2],
+					asic_acl.srcFilterMacMask_.octet[3],
+					asic_acl.srcFilterMacMask_.octet[4],
+					asic_acl.srcFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					asic_acl.srcFilterVlanIdx_,
+					asic_acl.srcFilterVlanIdxMask_,
+					asic_acl.srcFilterPort_,
+					asic_acl.srcFilterPortMask_,
+					(asic_acl.srcFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.srcFilterIgnoreL4_ == 1 ? 1 : 0))
+					);
+				seq_printf(s,
+					"\tsip: %d.%d.%d.%d   sipM: %d.%d.%d.%d\n",
+					(asic_acl.srcFilterIpAddr_ >> 24),
+					((asic_acl.srcFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddr_ & 0xff),
+					(asic_acl.srcFilterIpAddrMask_ >> 24),
+					((asic_acl.srcFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddrMask_ & 0xff)
+					);
+				seq_printf(s, "\tsportL: %d   sportU: %d\n",
+					asic_acl.srcFilterPortLowerBound_,
+					asic_acl.srcFilterPortUpperBound_);
+				break;
+
+			case RTL865X_ACL_SRCFILTER_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Source Filter(IP RANGE)",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.srcFilterMac_.octet[0],
+					asic_acl.srcFilterMac_.octet[1],
+					asic_acl.srcFilterMac_.octet[2],
+					asic_acl.srcFilterMac_.octet[3],
+					asic_acl.srcFilterMac_.octet[4],
+					asic_acl.srcFilterMac_.octet[5],
+					asic_acl.srcFilterMacMask_.octet[0],
+					asic_acl.srcFilterMacMask_.octet[1],
+					asic_acl.srcFilterMacMask_.octet[2],
+					asic_acl.srcFilterMacMask_.octet[3],
+					asic_acl.srcFilterMacMask_.octet[4],
+					asic_acl.srcFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
+					asic_acl.srcFilterVlanIdx_,
+					asic_acl.srcFilterVlanIdxMask_,
+					asic_acl.srcFilterPort_,
+					asic_acl.srcFilterPortMask_,
+					(asic_acl.srcFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.srcFilterIgnoreL4_ == 1 ? 1 : 0))
+					);
+				seq_printf(s,
+					"\tsipU: %d.%d.%d.%d   sipL: %d.%d.%d.%d\n",
+					(asic_acl.srcFilterIpAddr_ >> 24),
+					((asic_acl.srcFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddr_ & 0xff),
+					(asic_acl.srcFilterIpAddrMask_ >> 24),
+					((asic_acl.srcFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.srcFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.srcFilterIpAddrMask_ & 0xff)
+					);
+				seq_printf(s, "\tsportL: %d   sportU: %d\n",
+					asic_acl.srcFilterPortLowerBound_,
+					asic_acl.srcFilterPortUpperBound_);
+				break;
+
+			case RTL865X_ACL_DSTFILTER:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start, "Deatination Filter",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstFilterMac_.octet[0],
+					asic_acl.dstFilterMac_.octet[1],
+					asic_acl.dstFilterMac_.octet[2],
+					asic_acl.dstFilterMac_.octet[3],
+					asic_acl.dstFilterMac_.octet[4],
+					asic_acl.dstFilterMac_.octet[5],
+					asic_acl.dstFilterMacMask_.octet[0],
+					asic_acl.dstFilterMacMask_.octet[1],
+					asic_acl.dstFilterMacMask_.octet[2],
+					asic_acl.dstFilterMacMask_.octet[3],
+					asic_acl.dstFilterMacMask_.octet[4],
+					asic_acl.dstFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					asic_acl.dstFilterVlanIdx_,
+					asic_acl.dstFilterVlanIdxMask_,
+					(asic_acl.dstFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.dstFilterIgnoreL4_ == 1 ? 1 : 0)),
+					asic_acl.dstFilterPortLowerBound_,
+					asic_acl.dstFilterPortUpperBound_);
+				seq_printf(s,
+					"\tdip: %d.%d.%d.%d   dipM: %d.%d.%d.%d\n",
+					(asic_acl.dstFilterIpAddr_ >> 24),
+					((asic_acl.dstFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddr_ & 0xff),
+					(asic_acl.dstFilterIpAddrMask_ >> 24),
+					((asic_acl.dstFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddrMask_ & 0xff)
+					);
+				break;
+			case RTL865X_ACL_DSTFILTER_IPRANGE:
+				seq_printf(s,
+					" [%d] rule type: %s   rule action: %s\n",
+					acl_start,
+					"Deatination Filter(IP Range)",
+					actionT[asic_acl.actionType_]);
+				seq_printf(s,
+					"\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
+					asic_acl.dstFilterMac_.octet[0],
+					asic_acl.dstFilterMac_.octet[1],
+					asic_acl.dstFilterMac_.octet[2],
+					asic_acl.dstFilterMac_.octet[3],
+					asic_acl.dstFilterMac_.octet[4],
+					asic_acl.dstFilterMac_.octet[5],
+					asic_acl.dstFilterMacMask_.octet[0],
+					asic_acl.dstFilterMacMask_.octet[1],
+					asic_acl.dstFilterMacMask_.octet[2],
+					asic_acl.dstFilterMacMask_.octet[3],
+					asic_acl.dstFilterMacMask_.octet[4],
+					asic_acl.dstFilterMacMask_.octet[5]
+					);
+				seq_printf(s,
+					"\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
+					asic_acl.dstFilterVlanIdx_,
+					asic_acl.dstFilterVlanIdxMask_,
+					(asic_acl.dstFilterIgnoreL3L4_ == TRUE ? 2 : (asic_acl.dstFilterIgnoreL4_ == 1 ? 1 : 0)),
+					asic_acl.dstFilterPortLowerBound_,
+					asic_acl.dstFilterPortUpperBound_);
+				seq_printf(s,
+					"\tdipU: %d.%d.%d.%d   dipL: %d.%d.%d.%d\n",
+					(asic_acl.dstFilterIpAddr_ >> 24),
+					((asic_acl.dstFilterIpAddr_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddr_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddr_ & 0xff),
+					(asic_acl.dstFilterIpAddrMask_ >> 24),
+					((asic_acl.dstFilterIpAddrMask_ & 0x00ff0000) >> 16),
+					((asic_acl.dstFilterIpAddrMask_ & 0x0000ff00) >> 8),
+					(asic_acl.dstFilterIpAddrMask_ & 0xff)
+					);
+				break;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			case RTL865X_ACL_IPV6:	/* IP Rule Type: 0x0010 */
+			case RTL865X_ACL_IPV6_RANGE:
+				/* a ipv6 rule occupied  two entry, function _rtl865x_getAclFromAsic take one entry at a time,
+				 * so, need to call function _rtl865x_getAclFromAsic again.
+				 */
+				/* rtl865x_AclRule_t asic_acl2; */
+				/* unsigned int acl_temp = acl_start; */
+				acl_temp = acl_start;
+				acl_temp++;
+				if (acl_temp <= acl_end)	/* the second entry index of ipv6 rule, should  less than or equal to acl_end. */
+				{
+					memset(&asic_acl2, 0x00,
+						sizeof(rtl865x_AclRule_t));
+					if (_rtl865x_getAclFromAsic(acl_temp,
+							&asic_acl2) == FAILED)
+						seq_printf(s,
+							"=============%s(%d): get asic acl rule error!\n",
+							__FUNCTION__, __LINE__);
+					if ((!asic_acl2.ipv6EntryType_)
+						&& asic_acl.ipv6EntryType_) {
+						asic_acl.dstIpV6Addr_.v6_addr32[3] =
+							asic_acl2.dstIpV6Addr_.v6_addr32[3];
+						asic_acl.dstIpV6Addr_.v6_addr32[2] =
+							asic_acl2.dstIpV6Addr_.v6_addr32[2];
+						asic_acl.dstIpV6Addr_.v6_addr32[1] =
+							asic_acl2.dstIpV6Addr_.v6_addr32[1];
+						asic_acl.dstIpV6Addr_.v6_addr32[0] =
+							asic_acl2.dstIpV6Addr_.v6_addr32[0];
+
+						asic_acl.dstIpV6AddrMask_.v6_addr32[3] =
+							asic_acl2.dstIpV6AddrMask_.v6_addr32[3];
+						asic_acl.dstIpV6AddrMask_.v6_addr32[2] =
+							asic_acl2.dstIpV6AddrMask_.v6_addr32[2];
+						asic_acl.dstIpV6AddrMask_.v6_addr32[1] =
+							asic_acl2.dstIpV6AddrMask_.v6_addr32[1];
+						asic_acl.dstIpV6AddrMask_.v6_addr32[0] =
+							asic_acl2.dstIpV6AddrMask_.v6_addr32[0];
+
+						asic_acl.ipv6TrafficClass_ =
+							asic_acl2.ipv6TrafficClass_;
+						asic_acl.ipv6TrafficClassM_ =
+							asic_acl2.ipv6TrafficClassM_;
+						asic_acl.ipv6NextHeader_ =
+							asic_acl2.ipv6NextHeader_;
+						asic_acl.ipv6NextHeaderM_ =
+							asic_acl2.ipv6NextHeaderM_;
+						asic_acl.ipv6HttpFilter_ =
+							asic_acl2.ipv6HttpFilter_;
+						asic_acl.ipv6HttpFilterM_ =
+							asic_acl2.ipv6HttpFilterM_;
+						asic_acl.ipv6IdentSrcDstIp_ =
+							asic_acl2.ipv6IdentSrcDstIp_;
+						asic_acl.ipv6IdentSrcDstIpM_ =
+							asic_acl2.ipv6IdentSrcDstIpM_;
+						/* ActionType and ActionField useless in entry0 */
+						asic_acl.actionType_ =
+							asic_acl2.actionType_;
+						switch (asic_acl.actionType_) {
+
+						case RTL865X_ACL_PERMIT:
+						case RTL865X_ACL_REDIRECT_ETHER:
+						case RTL865X_ACL_DROP:
+						case RTL865X_ACL_TOCPU:
+						case RTL865X_ACL_LEGACY_DROP:
+						case RTL865X_ACL_DROPCPU_LOG:
+						case RTL865X_ACL_MIRROR:
+						case RTL865X_ACL_REDIRECT_PPPOE:
+						case RTL865X_ACL_MIRROR_KEEP_MATCH:
+							asic_acl.L2Idx_ =
+								asic_acl2.L2Idx_;
+							asic_acl.netifIdx_ =
+								asic_acl2.netifIdx_;
+							asic_acl.pppoeIdx_ =
+								asic_acl2.pppoeIdx_;
+							break;
+
+						case RTL865X_ACL_DEFAULT_REDIRECT:
+							asic_acl.nexthopIdx_ =
+								asic_acl2.nexthopIdx_;
+							break;
+
+						case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+						case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+						case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+						case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+							asic_acl.ratelimtIdx_ =
+								asic_acl2.ratelimtIdx_;
+							break;
+						case RTL865X_ACL_PRIORITY:
+							asic_acl.priority_ =
+								asic_acl2.priority_;
+							break;
+						case RTL865X_ACL_VID:
+							asic_acl.aclvid_ =
+								asic_acl2.aclvid_;
+							break;
+						}
+						/* INV useless in entry 0 */
+						asic_acl.ipv6Invert_ =
+							asic_acl2.ipv6Invert_;
+						/* asic_acl.ipv6Combine_  = asic_acl2.ipv6Combine_ ; */
+						/* asic_acl.ipv6IPtunnel_ = asic_acl2.ipv6IPtunnel_; */
+						seq_printf(s,
+							" [%d-%d] rule type: %s   rule action: %s\n",
+							acl_start, acl_temp,
+							"IPv6",
+							actionT[asic_acl.actionType_]);
+						if (RTL865X_ACL_IPV6 ==
+							asic_acl.ruleType_) {
+							memset((void *)
+								&start_ip.v6_addr32[0],
+								0x00,
+								sizeof(start_ip));
+							memset((void *)&end_ip.v6_addr32[0],
+								0x00,
+								sizeof(end_ip));
+							ntohl_array((uint32 *)
+								&asic_acl.srcIpV6Addr_.v6_addr32[0],
+								(void *)
+								&start_ip.v6_addr32[0],
+								4);
+							ntohl_array((uint32 *)
+								&asic_acl.srcIpV6AddrMask_.v6_addr32[0],
+								(void *)&end_ip.v6_addr32[0],
+								4);
+							seq_printf(s,
+								"\tsip: %x:%x:%x:%x:%x:%x:%x:%x  sipM: %x:%x:%x:%x:%x:%x:%x:%x\n",
+								htons(start_ip.v6_addr16[0]),
+								htons(start_ip.v6_addr16[1]),
+								htons(start_ip.v6_addr16[2]),
+								htons(start_ip.v6_addr16[3]),
+								htons(start_ip.v6_addr16[4]),
+								htons(start_ip.v6_addr16[5]),
+								htons(start_ip.v6_addr16[6]),
+								htons(start_ip.v6_addr16[7]),
+								htons(end_ip.v6_addr16[0]),
+								htons(end_ip.v6_addr16[1]),
+								htons(end_ip.v6_addr16[2]),
+								htons(end_ip.v6_addr16[3]),
+								htons(end_ip.v6_addr16[4]),
+								htons(end_ip.v6_addr16[5]),
+								htons(end_ip.v6_addr16[6]),
+								htons(end_ip.v6_addr16[7])
+								);
+							memset((void *)
+								&start_ip.v6_addr32[0],
+								0x00,
+								sizeof(start_ip));
+							memset((void *)&end_ip.v6_addr32[0],
+								0x00,
+								sizeof(end_ip));
+							ntohl_array((uint32 *)
+								&asic_acl.dstIpV6Addr_.v6_addr32[0],
+								(void *)
+								&start_ip.v6_addr32[0],
+								4);
+							ntohl_array((uint32 *)
+								&asic_acl.dstIpV6AddrMask_.v6_addr32[0],
+								(void *)&end_ip.v6_addr32[0],
+								4);
+							seq_printf(s,
+								"\tdip: %x:%x:%x:%x:%x:%x:%x:%x  dipM: %x:%x:%x:%x:%x:%x:%x:%x\n",
+								htons(start_ip.v6_addr16[0]),
+								htons(start_ip.v6_addr16[1]),
+								htons(start_ip.v6_addr16[2]),
+								htons(start_ip.v6_addr16[3]),
+								htons(start_ip.v6_addr16[4]),
+								htons(start_ip.v6_addr16[5]),
+								htons(start_ip.v6_addr16[6]),
+								htons(start_ip.v6_addr16[7]),
+								htons(end_ip.v6_addr16[0]),
+								htons(end_ip.v6_addr16[1]),
+								htons(end_ip.v6_addr16[2]),
+								htons(end_ip.v6_addr16[3]),
+								htons(end_ip.v6_addr16[4]),
+								htons(end_ip.v6_addr16[5]),
+								htons(end_ip.v6_addr16[6]),
+								htons(end_ip.v6_addr16[7])
+								);
+
+						} else if
+							(RTL865X_ACL_IPV6_RANGE
+							== asic_acl.ruleType_) {
+
+							memset((void *)
+								&start_ip.v6_addr32[0],
+								0x00,
+								sizeof(start_ip));
+							memset((void *)&end_ip.v6_addr32[0],
+								0x00,
+								sizeof(end_ip));
+							ntohl_array((uint32 *)
+								&asic_acl.srcIpV6AddrLB_.v6_addr32[0],
+								(void *)
+								&start_ip.v6_addr32[0],
+								4);
+							ntohl_array((uint32 *)
+								&asic_acl.srcIpV6AddrUB_.v6_addr32[0],
+								(void *)&end_ip.v6_addr32[0],
+								4);
+							seq_printf(s,
+								"\tsipLB: %x:%x:%x:%x:%x:%x:%x:%x  sipUB: %x:%x:%x:%x:%x:%x:%x:%x\n",
+								htons(start_ip.v6_addr16[0]),
+								htons(start_ip.v6_addr16[1]),
+								htons(start_ip.v6_addr16[2]),
+								htons(start_ip.v6_addr16[3]),
+								htons(start_ip.v6_addr16[4]),
+								htons(start_ip.v6_addr16[5]),
+								htons(start_ip.v6_addr16[6]),
+								htons(start_ip.v6_addr16[7]),
+								htons(end_ip.v6_addr16[0]),
+								htons(end_ip.v6_addr16[1]),
+								htons(end_ip.v6_addr16[2]),
+								htons(end_ip.v6_addr16[3]),
+								htons(end_ip.v6_addr16[4]),
+								htons(end_ip.v6_addr16[5]),
+								htons(end_ip.v6_addr16[6]),
+								htons(end_ip.v6_addr16[7])
+								);
+							memset((void *)
+								&start_ip.v6_addr32[0],
+								0x00,
+								sizeof(start_ip));
+							memset((void *)&end_ip.v6_addr32[0],
+								0x00,
+								sizeof(end_ip));
+							ntohl_array((uint32 *)
+								&asic_acl.dstIpV6AddrLB_.v6_addr32[0],
+								(void *)&start_ip.v6_addr32[0],
+								4);
+							ntohl_array((uint32 *)
+								&asic_acl.dstIpV6AddrUB_.v6_addr32[0],
+								(void *)&end_ip.v6_addr32[0],
+								4);
+							seq_printf(s,
+								"\tdipLB: %x:%x:%x:%x:%x:%x:%x:%x  dipUB: %x:%x:%x:%x:%x:%x:%x:%x\n",
+								htons(start_ip.v6_addr16[0]),
+								htons(start_ip.v6_addr16[1]),
+								htons(start_ip.v6_addr16[2]),
+								htons(start_ip.v6_addr16[3]),
+								htons(start_ip.v6_addr16[4]),
+								htons(start_ip.v6_addr16[5]),
+								htons(start_ip.v6_addr16[6]),
+								htons(start_ip.v6_addr16[7]),
+								htons(end_ip.v6_addr16[0]),
+								htons(end_ip.v6_addr16[1]),
+								htons(end_ip.v6_addr16[2]),
+								htons(end_ip.v6_addr16[3]),
+								htons(end_ip.v6_addr16[4]),
+								htons(end_ip.v6_addr16[5]),
+								htons(end_ip.v6_addr16[6]),
+								htons(end_ip.v6_addr16[7])
+								);
+						}
+						seq_printf(s,
+							"\tFlowLabel: 0x%x   FlowLabelM: 0x%x\n",
+							asic_acl.ipv6FlowLabel_,
+							asic_acl.ipv6FlowLabelM_);
+						seq_printf(s,
+							"\tInvert: %d   Combine: %d   IPtunnel: %d\n",
+							asic_acl.ipv6Invert_,
+							asic_acl.ipv6Combine_,
+							asic_acl.ipv6IPtunnel_);
+						seq_printf(s,
+							"\tTrafficClassP: %d   TrafficClassM: %d   NextHeaderP: %d   NextHeaderM: %d\n",
+							asic_acl.ipv6TrafficClass_,
+							asic_acl.ipv6TrafficClassM_,
+							asic_acl.ipv6NextHeader_,
+							asic_acl.ipv6NextHeaderM_);
+						seq_printf(s,
+							"\tHTTPP: %d   HTTPM: %d   IdentSDIPP: %d   IdentSDIPM: %d\n",
+							asic_acl.ipv6HttpFilter_,
+							asic_acl.ipv6HttpFilterM_,
+							asic_acl.ipv6IdentSrcDstIp_,
+							asic_acl.ipv6IdentSrcDstIpM_);
+						/* update acl index */
+						acl_start = acl_temp;
+					}
+
+				}
+				break;
+#endif
+#if defined(CONFIG_RTL_8197F)
+			case RTL865X_ACL_PM:
+				/* A pattern match rule occupied two entry,
+				 * function _rtl865x_getAclFromAsic take one entry at a time.
+				 * So we need to call function _rtl865x_getAclFromAsic again. */
+				acl_temp = acl_start;
+				acl_temp++;	/* move to the second entry index of pattern match rule */
+				if (acl_temp <= acl_end) {	/* it should be less than or equal to acl_end. */
+					memset(&asic_acl2, 0x00,
+						sizeof(rtl865x_AclRule_t));
+					if (_rtl865x_getAclFromAsic(acl_temp,
+							&asic_acl2) == FAILED)
+						seq_printf(s,
+							"=============%s(%d): get asic acl rule error!\n",
+							__FUNCTION__, __LINE__);
+					if ((!asic_acl2.ipv6EntryType_)
+						&& asic_acl.ipv6EntryType_) {
+						/* ActionType and ActionField useless in entry0 */
+						asic_acl.actionType_ =
+							asic_acl2.actionType_;
+						switch (asic_acl.actionType_) {
+						case RTL865X_ACL_PERMIT:
+						case RTL865X_ACL_REDIRECT_ETHER:
+						case RTL865X_ACL_DROP:
+						case RTL865X_ACL_TOCPU:
+						case RTL865X_ACL_LEGACY_DROP:
+						case RTL865X_ACL_DROPCPU_LOG:
+						case RTL865X_ACL_MIRROR:
+						case RTL865X_ACL_REDIRECT_PPPOE:
+						case RTL865X_ACL_MIRROR_KEEP_MATCH:
+							asic_acl.L2Idx_ =
+								asic_acl2.L2Idx_;
+							asic_acl.netifIdx_ =
+								asic_acl2.netifIdx_;
+							asic_acl.pppoeIdx_ =
+								asic_acl2.pppoeIdx_;
+							break;
+
+						case RTL865X_ACL_DEFAULT_REDIRECT:
+							asic_acl.nexthopIdx_ =
+								asic_acl2.nexthopIdx_;
+							break;
+
+						case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+						case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+						case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+						case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+							asic_acl.ratelimtIdx_ =
+								asic_acl2.ratelimtIdx_;
+							break;
+						case RTL865X_ACL_PRIORITY:
+							asic_acl.priority_ =
+								asic_acl2.priority_;
+							break;
+						case RTL865X_ACL_VID:
+							asic_acl.aclvid_ =
+								asic_acl2.aclvid_;
+							break;
+						}
+						/* INV useless in entry 0 */
+						asic_acl.ipv6Invert_ =
+							asic_acl2.ipv6Invert_;
+						/* asic_acl.ipv6Combine_  = asic_acl2.ipv6Combine_ ; */
+						/* asic_acl.ipv6IPtunnel_ = asic_acl2.ipv6IPtunnel_; */
+						/* output entry0's valid field */
+						seq_printf(s,
+							" [%d-%d] rule type: %s	rule action: %s\n",
+							acl_start, acl_temp,
+							"Pattern match",
+							actionT[asic_acl.actionType_]);
+						seq_printf(s,
+							"\tsportU: %d sportL: %d dportU: %d dportL: %d protocol: %d\n",
+							asic_acl.un_ty.PM._spub,
+							asic_acl.un_ty.PM._splb,
+							asic_acl.un_ty.PM._dpub,
+							asic_acl.un_ty.PM._dplb,
+							asic_acl.un_ty.PM._protocol);
+						seq_printf(s,
+							"\tOffset0: %d Pattern0: 0x%04x PatternMask0: 0x%04x OR0: %d\n",
+							asic_acl.un_ty.PM._offset0,
+							asic_acl.un_ty.PM._pattern0,
+							asic_acl.un_ty.PM._pm0,
+							asic_acl.un_ty.PM._or0);
+						seq_printf(s,
+							"\tOffset1: %d Pattern1: 0x%04x PatternMask1: 0x%04x OR1: %d\n",
+							asic_acl.un_ty.PM._offset1,
+							asic_acl.un_ty.PM._pattern1,
+							asic_acl.un_ty.PM._pm1,
+							asic_acl.un_ty.PM._or1);
+						seq_printf(s,
+							"\tOffset2: %d Pattern2: 0x%04x PatternMask2: 0x%04x OR2: %d\n",
+							asic_acl.un_ty.PM._offset2,
+							asic_acl.un_ty.PM._pattern2,
+							asic_acl.un_ty.PM._pm2,
+							asic_acl.un_ty.PM._or2);
+						seq_printf(s,
+							"\tOffset3: %d Pattern3: 0x%04x PatternMask3: 0x%04x OR3: %d\n",
+							asic_acl.un_ty.PM._offset3,
+							asic_acl.un_ty.PM._pattern3,
+							asic_acl.un_ty.PM._pm3,
+							asic_acl.un_ty.PM._or3);
+
+						/* output entry1's valid field */
+						seq_printf(s,
+							"\tOffset4: %d Pattern4: 0x%04x PatternMask4: 0x%04x OR4: %d\n",
+							asic_acl2.un_ty.PM._offset4,
+							asic_acl2.un_ty.PM._pattern4,
+							asic_acl2.un_ty.PM._pm4,
+							asic_acl2.un_ty.PM._or4);
+						seq_printf(s,
+							"\tOffset5: %d Pattern5: 0x%04x PatternMask5: 0x%04x OR5: %d\n",
+							asic_acl2.un_ty.PM._offset5,
+							asic_acl2.un_ty.PM._pattern5,
+							asic_acl2.un_ty.PM._pm5,
+							asic_acl2.un_ty.PM._or5);
+						seq_printf(s,
+							"\tOffset6: %d Pattern6: 0x%04x PatternMask6: 0x%04x OR6: %d\n",
+							asic_acl2.un_ty.PM._offset6,
+							asic_acl2.un_ty.PM._pattern6,
+							asic_acl2.un_ty.PM._pm6,
+							asic_acl2.un_ty.PM._or6);
+						seq_printf(s,
+							"\tOffset7: %d Pattern7: 0x%04x PatternMask7: 0x%04x OR7: %d\n",
+							asic_acl2.un_ty.PM._offset7,
+							asic_acl2.un_ty.PM._pattern7,
+							asic_acl2.un_ty.PM._pm7,
+							asic_acl2.un_ty.PM._or7);
+						seq_printf(s,
+							"\tSpecialOP: %d SrcPortPattern: %d SrcPortMask: %d PPPCTL: %d PPPCTLM: %d PPPCTLOR: %d\n",
+							asic_acl2.un_ty.PM._specialop,
+							asic_acl2.un_ty.PM._spa,
+							asic_acl2.un_ty.PM._spam,
+							asic_acl2.un_ty.PM._pppctl,
+							asic_acl2.un_ty.PM._pppctlm,
+							asic_acl2.un_ty.PM._pppctlor);
+						seq_printf(s,
+							"\tInvert: %d   Combine1: %d	 Combine2: %d	IPtunnel1: %d IPtunnel2: %d IpfragApply: %d\n",
+							asic_acl2.ipv6Invert_,
+							asic_acl2.ipv6Combine_,
+							asic_acl2.ipv6Combine_,
+							asic_acl.ipv6IPtunnel_,
+							asic_acl2.ipv6IPtunnel_,
+							asic_acl2.ipfrag_apply_);
+						/* update acl index */
+						acl_start = acl_temp;
+					}
+
+				}
+				break;
+#endif
+
+			default:
+				seq_printf(s, "asic_acl.ruleType_(0x%x)\n",
+					asic_acl.ruleType_);
+
+			}
+
+			/* Action type */
+			switch (asic_acl.actionType_) {
+
+			case RTL865X_ACL_PERMIT:
+			case RTL865X_ACL_REDIRECT_ETHER:
+			case RTL865X_ACL_DROP:
+			case RTL865X_ACL_TOCPU:
+			case RTL865X_ACL_LEGACY_DROP:
+			case RTL865X_ACL_DROPCPU_LOG:
+			case RTL865X_ACL_MIRROR:
+			case RTL865X_ACL_REDIRECT_PPPOE:
+			case RTL865X_ACL_MIRROR_KEEP_MATCH:
+				seq_printf(s,
+					"\tnetifIdx: %d   pppoeIdx: %d   l2Idx:%d  ",
+					asic_acl.netifIdx_, asic_acl.pppoeIdx_,
+					asic_acl.L2Idx_);
+				break;
+
+			case RTL865X_ACL_PRIORITY:
+				seq_printf(s, "\tprioirty: %d   ",
+					asic_acl.priority_);
+				break;
+
+			case RTL865X_ACL_DEFAULT_REDIRECT:
+				seq_printf(s, "\tnextHop:%d  ",
+					asic_acl.nexthopIdx_);
+				break;
+
+			case RTL865X_ACL_DROP_RATE_EXCEED_PPS:
+			case RTL865X_ACL_LOG_RATE_EXCEED_PPS:
+			case RTL865X_ACL_DROP_RATE_EXCEED_BPS:
+			case RTL865X_ACL_LOG_RATE_EXCEED_BPS:
+				seq_printf(s, "\tratelimitIdx: %d  ",
+					asic_acl.ratelimtIdx_);
+				break;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			case RTL865X_ACL_VID:
+				seq_printf(s, "\taclvid: %d  ",
+					asic_acl.aclvid_);
+				break;
+#endif
+			default:
+				;
+
+			}
+			seq_printf(s, "pktOpApp: %d\n", asic_acl.pktOpApp_);
+#if defined(CONFIG_RTL_8197F) || defined(CONFIG_RTL_8198C)
+			if (!((asic_acl.ruleType_ == RTL865X_ACL_IPV6)
+					|| (asic_acl.ruleType_ ==
+						RTL865X_ACL_IPV6_RANGE)
+#if defined(CONFIG_RTL_8197F)
+					|| (asic_acl.ruleType_ ==
+						RTL865X_ACL_PM)
+#endif
+				)) {
+				seq_printf(s,
+					"\tInvert: %d   Combine: %d	IPtunnel: %d",
+					asic_acl.ipv6Invert_,
+					asic_acl.ipv6Combine_,
+					asic_acl.ipv6IPtunnel_);
+#if defined(CONFIG_RTL_8197F)
+				seq_printf(s, " IpfragApply: %d\n",
+					asic_acl.ipfrag_apply_);
+#else
+				seq_printf(s, "\n");
+#endif
+
+			}
+#endif
+		}
+
+		if (outRule == FALSE) {
+			acl_start = defOutAclStart;
+			acl_end = defOutAclEnd;
+			outRule = TRUE;
+			goto again_forOutAcl;
+		}
+	}
+#endif
+	return 0;
+}
+
+int acl_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, acl_show, NULL));
+}
+
+struct file_operations acl_single_seq_file_operations = {
+	.open = acl_single_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+extern int igmp_show(struct seq_file *s, void *v);
+extern ssize_t igmp_write(struct file *file, const char __user *buffer,
+	size_t count, loff_t *data);
+int igmp_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, igmp_show, NULL));
+}
+
+struct file_operations igmp_single_seq_file_operations = {
+	.open = igmp_single_open,
+	.read = seq_read,
+	.write = igmp_write,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+int aclChains_show(struct seq_file *s, void *v)
+{
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+	rtl865x_show_allAclChains(s);
+#endif
+	return 0;
+}
+
+int aclChains_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, aclChains_show, NULL));
+}
+
+struct file_operations aclChains_single_seq_file_operations = {
+	.open = aclChains_single_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+int qosRule_show(struct seq_file *s, void *v)
+{
+	rtl865x_show_allQosAcl(s);
+	return 0;
+}
+
+int qosRule_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, qosRule_show, NULL));
+}
+
+struct file_operations qosRule_single_seq_file_operations = {
+	.open = qosRule_single_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 hs_read(struct seq_file *s, void *v)
+{
+	hsb_param_t *hsb_r, dummy_hsb_r;
+	hsa_param_t *hsa_r, dummy_hsa_r;
+	ipaddr_t addr;
+	char addr_s[100];
+
+	hsb_r = &dummy_hsb_r;
+	hsa_r = &dummy_hsa_r;
+	memset((void *)hsb_r, 0, sizeof(hsb_r));
+	memset((void *)hsa_r, 0, sizeof(hsa_r));
+
+	virtualMacGetHsb(hsb_r);
+	{
+		seq_printf(s, "HSB(");
+		seq_printf(s, "\ttype:%d", hsb_r->type);
+
+		seq_printf(s, "\tspa:%d", hsb_r->spa);
+		seq_printf(s, "\tlen:%d", hsb_r->len);
+		seq_printf(s, "\tvid :%d\n", hsb_r->vid);
+		seq_printf(s, "\tpppoe:%d", hsb_r->pppoeif);
+
+		/* Protocol contents */
+		seq_printf(s, "\ttagif:%d\tpppoeId:%d", hsb_r->tagif,
+			hsb_r->pppoeid);
+		seq_printf(s, "\tethrtype:0x%04x\n", hsb_r->ethtype);
+		seq_printf(s, "\tllc_other:%d\tsnap:%d\n", hsb_r->llcothr,
+			hsb_r->snap);
+		seq_printf(s, "\tda:%02x-%02x-%02x-%02x-%02x-%02x",
+			hsb_r->da[0], hsb_r->da[1], hsb_r->da[2], hsb_r->da[3],
+			hsb_r->da[4], hsb_r->da[5]);
+		seq_printf(s, "\tsa:%02x-%02x-%02x-%02x-%02x-%02x\n",
+			hsb_r->sa[0], hsb_r->sa[1], hsb_r->sa[2], hsb_r->sa[3],
+			hsb_r->sa[4], hsb_r->sa[5]);
+
+		addr = ntohl(hsb_r->sip);
+		inet_ntoa_r(addr, addr_s);
+		seq_printf(s, "\tsip:%s(hex:%08x)   ", addr_s, hsb_r->sip);
+		seq_printf(s, "\tsprt:%d (hex:%x)\n ", (int)hsb_r->sprt,
+			hsb_r->sprt);
+		addr = ntohl(hsb_r->dip);
+		inet_ntoa_r(addr, addr_s);
+		seq_printf(s, "\tdip:%s(hex:%08x) ", addr_s, hsb_r->dip);
+		seq_printf(s, "\tdprt:%d(hex:%08x)\n", hsb_r->dprt,
+			hsb_r->dprt);
+
+		seq_printf(s, "\tipptl:%d,", (int)hsb_r->ipptl);
+		seq_printf(s, "\tipflg:%d,", hsb_r->ipfg);
+		seq_printf(s, "\tiptos:%d,", hsb_r->iptos);
+		seq_printf(s, "\ttcpflg:%d\n", hsb_r->tcpfg);
+
+		seq_printf(s, "\tdirtx:%d,", hsb_r->dirtx);
+		seq_printf(s, "\tprtnmat:%d", hsb_r->patmatch);
+
+		seq_printf(s, "\tudp_nocs:%d", hsb_r->udpnocs);
+		seq_printf(s, "\tttlst:0x%x\n", hsb_r->ttlst);
+
+		seq_printf(s, "\thp:%d", hsb_r->hiprior);
+		seq_printf(s, "\tl3csok:%d\tl4csok:%d\tipfragif:%d\n",
+			hsb_r->l3csok, hsb_r->l4csok, hsb_r->ipfo0_n);
+
+		seq_printf(s, "\textspa:%d", hsb_r->extspa);
+		seq_printf(s, "\turlmch:%d\n", hsb_r->urlmch);
+
+#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+
+		seq_printf(s, "\tipv4_opt:%d", hsb_r->ipv4_opt);
+		seq_printf(s, "\tcputag_if:%d\n", hsb_r->cputag_if);
+
+		seq_printf(s, "\tipv6_ext:%d", hsb_r->ipv6_ext);
+		seq_printf(s, "\tipv6fo:%d\n", hsb_r->ipv6fo);
+
+		seq_printf(s, "\tipv6flag:%d", hsb_r->ipv6flag);
+		seq_printf(s, "\tqpri:%d\n", hsb_r->qpri);
+
+		seq_printf(s, "\tptp_pkt:%d", hsb_r->ptp_pkt);
+		seq_printf(s, "\tptp_ver:%d\n", hsb_r->ptp_ver);
+
+		seq_printf(s, "\tptp_typ:%d", hsb_r->ptp_typ);
+		seq_printf(s, "\tipver_1st:%d\n", hsb_r->ipver_1st);
+
+		seq_printf(s,
+			"\tsip6:\t%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+			hsb_r->sipv6_127_96 >> 16, hsb_r->sipv6_127_96 & 0xFFFF,
+			hsb_r->sipv6_95_64 >> 16, hsb_r->sipv6_95_64 & 0xFFFF,
+			hsb_r->sipv6_63_32 >> 16, hsb_r->sipv6_63_32 & 0xFFFF,
+			hsb_r->sipv6_31_0 >> 16, hsb_r->sipv6_31_0 & 0xFFFF);
+
+		seq_printf(s,
+			"\tdip6:\t%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+			hsb_r->dipv6_127_96 >> 16, hsb_r->dipv6_127_96 & 0xFFFF,
+			hsb_r->dipv6_95_64 >> 16, hsb_r->dipv6_95_64 & 0xFFFF,
+			hsb_r->dipv6_63_32 >> 16, hsb_r->dipv6_63_32 & 0xFFFF,
+			hsb_r->dipv6_31_0 >> 16, hsb_r->dipv6_31_0 & 0xFFFF);
+
+		seq_printf(s, "\thop_limit:0x%x", hsb_r->hop_limit);
+		seq_printf(s, "\ttra_cla:0x%x\n", hsb_r->tra_cla);
+
+		seq_printf(s, "\tflow_lab:0x%x", hsb_r->flow_lab);
+		seq_printf(s, "\tnxt_hdr:0x%x\n", hsb_r->nxt_hdr);
+		seq_printf(s, "\tipv4:0x%x", hsb_r->ipv4);
+		seq_printf(s, "\tipv6:0x%x\n", hsb_r->ipv6);
+		seq_printf(s, "\tip_len:0x%x", hsb_r->ip_len);
+
+		seq_printf(s, "\ttun_len:0x%x\n", hsb_r->tun_len);
+#endif
+
+#if	defined(CONFIG_RTL_8197F)
+		seq_printf(s, "\tl3_cso:0x%x", hsb_r->l3_cso);
+		seq_printf(s, "\tl4_cso:0x%x\n", hsb_r->l4_cso);
+
+		seq_printf(s, "\tl3_csum:0x%x", hsb_r->l3_csum);
+		seq_printf(s, "\tl4_csum:0x%x\n", hsb_r->l4_csum);
+#endif
+
+		seq_printf(s, ")\n");
+	}
+
+	virtualMacGetHsa(hsa_r);
+	{
+		seq_printf(s, ("HSA("));
+		seq_printf(s, "\tmac:%02x-%02x-%02x-%02x-%02x-%02x\n",
+			hsa_r->nhmac[0], hsa_r->nhmac[1], hsa_r->nhmac[2],
+			hsa_r->nhmac[3], hsa_r->nhmac[4], hsa_r->nhmac[5]);
+
+		addr = ntohl(hsa_r->trip);
+		inet_ntoa_r(addr, addr_s);
+		seq_printf(s, "\ttrip:%s(hex:%08x)", addr_s, hsa_r->trip);
+		seq_printf(s, "\tprt:%d\tipmcast:%d\n", hsa_r->port,
+			hsa_r->ipmcastr);
+		seq_printf(s, "\tl3cs:0x%x", hsa_r->l3csdt);
+		seq_printf(s, "\tl4cs:0x%x", hsa_r->l4csdt);
+		seq_printf(s, "\tInternal NETIF:%d", hsa_r->egif);
+		seq_printf(s, "\tl2tr:%d,\n ", hsa_r->l2tr);
+		seq_printf(s, "\tl34tr:%d", hsa_r->l34tr);
+		seq_printf(s, "\tdirtx:%d", hsa_r->dirtxo);
+		seq_printf(s, "\ttype:%d", hsa_r->typeo);
+
+#if defined(CONFIG_RTL_8197F)
+		seq_printf(s, "\tsnapo:%d", hsa_r->llcexist);	/* 1: LLC exists */
+#else
+		seq_printf(s, "\tsnapo:%d", hsa_r->snapo);	/* 1: SNAP exists (copy from hsb.snap) */
+#endif
+
+		seq_printf(s, "\twhy2cpu 0x%x (%d)\n", hsa_r->why2cpu,
+			hsa_r->why2cpu);
+		seq_printf(s, "\tpppif:%d", hsa_r->pppoeifo);
+		seq_printf(s, "\tpppid:%d", hsa_r->pppidx);
+		seq_printf(s, "\tttl_1:0x%x", hsa_r->ttl_1if);
+		seq_printf(s, "\tdpc:%d,", hsa_r->dpc);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		seq_printf(s, "\tleno:%d(0x%x) \tmirrort:%d\n", hsa_r->leno,
+			hsa_r->leno, hsa_r->mirrort);
+#else
+		seq_printf(s, "\tleno:%d(0x%x)\n", hsa_r->leno, hsa_r->leno);
+#endif
+		seq_printf(s, "\tl3CrcOk:%d", hsa_r->l3csoko);
+		seq_printf(s, "\tl4CrcOk:%d", hsa_r->l4csoko);
+		seq_printf(s, "\tfrag:%d", hsa_r->frag);
+		seq_printf(s, "\tlastFrag:%d\n", hsa_r->lastfrag);
+
+		seq_printf(s, "\tsvid:0x%x", hsa_r->svid);
+		seq_printf(s, "\tdvid:%d(0x%x)", hsa_r->dvid, hsa_r->dvid);
+		seq_printf(s, "\tdestination interface :%d\n", hsa_r->difid);
+		seq_printf(s, "\trxtag:%d", hsa_r->rxtag);
+		seq_printf(s, "\t\tdvtag:0x%x", hsa_r->dvtag);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		seq_printf(s, "\tspa:%d \tipv4_1st:%d", hsa_r->spao,
+			hsa_r->ipv4_1st);
+#else
+		seq_printf(s, "\tspa:%d", hsa_r->spao);
+#endif
+		seq_printf(s, "\tdpext:0x%x\thwfwrd:%d\n", hsa_r->dpext,
+			hsa_r->hwfwrd);
+		seq_printf(s, "\tspcp:%d", hsa_r->spcp);
+		seq_printf(s, "\t\tpriority:%d", hsa_r->priority);
+
+		seq_printf(s, "\tdp:0x%x\n", hsa_r->dp);
+
+#if	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+
+		seq_printf(s, "\tcputag:%d", hsa_r->cputag);
+		seq_printf(s, "\tptp_pkt:%d", hsa_r->ptp_pkt);
+		seq_printf(s, "\tptp_v2:%d", hsa_r->ptp_v2);
+		seq_printf(s, "\tptp_type:0x%x\n", hsa_r->ptp_type);
+
+		seq_printf(s, "\trmdp:0x%x", hsa_r->rmdp);
+		seq_printf(s, "\tdpri:0x%x", hsa_r->dpri);
+		seq_printf(s, "\tmdf:0x%x\n", hsa_r->mdf);
+/*
+		seq_printf(s,"\tsipv6_31_0:0x%x",hsa_r->sipv6_31_0);
+		seq_printf(s,"\tsipv6_63_32:0x%x",hsa_r->sipv6_63_32);
+		seq_printf(s,"\tsipv6_95_64:0x%x",hsa_r->sipv6_95_64);
+		seq_printf(s,"\tsipv6_127_96:0x%x\n",hsa_r->sipv6_127_96);
+
+		seq_printf(s,"\tdipv6_31_0:0x%x",hsa_r->dipv6_31_0);
+		seq_printf(s,"\tdipv6_63_32:0x%x",hsa_r->dipv6_63_32);
+		seq_printf(s,"\tdipv6_95_64:0x%x",hsa_r->dipv6_95_64);
+		seq_printf(s,"\tdipv6_127_96:0x%x\n",hsa_r->dipv6_127_96);
+*/
+
+		seq_printf(s,
+			"\tsip6:\t%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+			hsa_r->sipv6_127_96 >> 16, hsa_r->sipv6_127_96 & 0xFFFF,
+			hsa_r->sipv6_95_64 >> 16, hsa_r->sipv6_95_64 & 0xFFFF,
+			hsa_r->sipv6_63_32 >> 16, hsa_r->sipv6_63_32 & 0xFFFF,
+			hsa_r->sipv6_31_0 >> 16, hsa_r->sipv6_31_0 & 0xFFFF);
+
+		seq_printf(s,
+			"\tdip6:\t%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+			hsa_r->dipv6_127_96 >> 16, hsa_r->dipv6_127_96 & 0xFFFF,
+			hsa_r->dipv6_95_64 >> 16, hsa_r->dipv6_95_64 & 0xFFFF,
+			hsa_r->dipv6_63_32 >> 16, hsa_r->dipv6_63_32 & 0xFFFF,
+			hsa_r->dipv6_31_0 >> 16, hsa_r->dipv6_31_0 & 0xFFFF);
+
+		seq_printf(s, "\tip_len:0x%x", hsa_r->ip_len);
+		seq_printf(s, "\tipv4_id:0x%x\n", hsa_r->ipv4_id);
+
+#if	defined(CONFIG_RTL_8197F)
+		seq_printf(s, "\thas_ipv4:0x%x", hsa_r->has_ipv4);
+		seq_printf(s, "\thas_ipv6:0x%x\n", hsa_r->has_ipv6);
+#endif
+		seq_printf(s, "\ttun_len:0x%x", hsa_r->tun_len);
+		seq_printf(s, "\tmltcst_v6:0x%x", hsa_r->mltcst_v6);
+		seq_printf(s, "\taddip_pri:0x%x\n", hsa_r->addip_pri);
+
+#endif
+
+#if	defined(CONFIG_RTL_8197F)
+		seq_printf(s, "\tl3_cso:0x%x", hsa_r->l3_cso);
+		seq_printf(s, "\tl4_cso:0x%x", hsa_r->l4_cso);
+#endif
+		seq_printf(s, ")\n");
+	}
+	return 0;
+}
+#else
+static int32 hs_read(char *page, char **start, off_t off, int count, int *eof,
+	void *data)
+{
+	int len;
+	hsb_param_t *hsb_r, dummy_hsb_r;
+	hsa_param_t *hsa_r, dummy_hsa_r;
+	ipaddr_t addr;
+	char addr_s[100];
+
+	len = 0;
+	hsb_r = &dummy_hsb_r;
+	hsa_r = &dummy_hsa_r;
+	memset((void *)hsb_r, 0, sizeof(hsb_r));
+	memset((void *)hsa_r, 0, sizeof(hsa_r));
+
+	virtualMacGetHsb(hsb_r);
+	{
+		len += sprintf(page + len, "HSB(");
+		len += sprintf(page + len, "\ttype:%d", hsb_r->type);
+
+		len += sprintf(page + len, "\tspa:%d", hsb_r->spa);
+		len += sprintf(page + len, "\tlen:%d", hsb_r->len);
+		len += sprintf(page + len, "\tvid :%d\n", hsb_r->vid);
+		len += sprintf(page + len, "\tpppoe:%d", hsb_r->pppoeif);
+
+		/* Protocol contents */
+		len += sprintf(page + len, "\ttagif:%d\tpppoeId:%d",
+			hsb_r->tagif, hsb_r->pppoeid);
+		len += sprintf(page + len, "\tethrtype:0x%04x\n",
+			hsb_r->ethtype);
+		len += sprintf(page + len, "\tllc_other:%d\tsnap:%d\n",
+			hsb_r->llcothr, hsb_r->snap);
+		len += sprintf(page + len, "\tda:%02x-%02x-%02x-%02x-%02x-%02x",
+			hsb_r->da[0], hsb_r->da[1], hsb_r->da[2], hsb_r->da[3],
+			hsb_r->da[4], hsb_r->da[5]);
+		len += sprintf(page + len,
+			"\tsa:%02x-%02x-%02x-%02x-%02x-%02x\n", hsb_r->sa[0],
+			hsb_r->sa[1], hsb_r->sa[2], hsb_r->sa[3], hsb_r->sa[4],
+			hsb_r->sa[5]);
+
+		addr = ntohl(hsb_r->sip);
+		inet_ntoa_r(addr, addr_s);
+		len += sprintf(page + len, "\tsip:%s(hex:%08x)   ", addr_s,
+			hsb_r->sip);
+		len += sprintf(page + len, "\tsprt:%d (hex:%x)\n ",
+			(int)hsb_r->sprt, hsb_r->sprt);
+		addr = ntohl(hsb_r->dip);
+		inet_ntoa_r(addr, addr_s);
+		len += sprintf(page + len, "\tdip:%s(hex:%08x) ", addr_s,
+			hsb_r->dip);
+		len += sprintf(page + len, "\tdprt:%d(hex:%08x)\n", hsb_r->dprt,
+			hsb_r->dprt);
+
+		len += sprintf(page + len, "\tipptl:%d,", (int)hsb_r->ipptl);
+		len += sprintf(page + len, "\tipflg:%d,", hsb_r->ipfg);
+		len += sprintf(page + len, "\tiptos:%d,", hsb_r->iptos);
+		len += sprintf(page + len, "\ttcpflg:%d\n", hsb_r->tcpfg);
+
+		len += sprintf(page + len, "\tdirtx:%d,", hsb_r->dirtx);
+		len += sprintf(page + len, "\tprtnmat:%d", hsb_r->patmatch);
+
+		len += sprintf(page + len, "\tudp_nocs:%d", hsb_r->udpnocs);
+		len += sprintf(page + len, "\tttlst:0x%x\n", hsb_r->ttlst);
+
+		len += sprintf(page + len, "\thp:%d", hsb_r->hiprior);
+		len += sprintf(page + len,
+			"\tl3csok:%d\tl4csok:%d\tipfragif:%d\n", hsb_r->l3csok,
+			hsb_r->l4csok, hsb_r->ipfo0_n);
+
+		len += sprintf(page + len, "\textspa:%d", hsb_r->extspa);
+		len += sprintf(page + len, "\turlmch:%d\n", hsb_r->urlmch);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+
+		len += sprintf(page + len, "\tipv4_opt:%d", hsb_r->ipv4_opt);
+		len += sprintf(page + len, "\tcputag_if:%d\n",
+			hsb_r->cputag_if);
+
+		len += sprintf(page + len, "\tipv6_ext:%d", hsb_r->ipv6_ext);
+		len += sprintf(page + len, "\tipv6fo:%d\n", hsb_r->ipv6fo);
+
+		len += sprintf(page + len, "\tipv6flag:%d", hsb_r->ipv6flag);
+		len += sprintf(page + len, "\tqpri:%d\n", hsb_r->qpri);
+
+		len += sprintf(page + len, "\tptp_pkt:%d", hsb_r->ptp_pkt);
+		len += sprintf(page + len, "\tptp_ver:%d\n", hsb_r->ptp_ver);
+
+		len += sprintf(page + len, "\tptp_typ:%d", hsb_r->ptp_typ);
+		len += sprintf(page + len, "\tipver_1st:%d\n",
+			hsb_r->ipver_1st);
+
+		len += sprintf(page + len,
+			"\tsip6:\t%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+			hsb_r->sipv6_127_96 >> 16, hsb_r->sipv6_127_96 & 0xFFFF,
+			hsb_r->sipv6_95_64 >> 16, hsb_r->sipv6_95_64 & 0xFFFF,
+			hsb_r->sipv6_63_32 >> 16, hsb_r->sipv6_63_32 & 0xFFFF,
+			hsb_r->sipv6_31_0 >> 16, hsb_r->sipv6_31_0 & 0xFFFF);
+
+		len += sprintf(page + len,
+			"\tdip6:\t%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+			hsb_r->dipv6_127_96 >> 16, hsb_r->dipv6_127_96 & 0xFFFF,
+			hsb_r->dipv6_95_64 >> 16, hsb_r->dipv6_95_64 & 0xFFFF,
+			hsb_r->dipv6_63_32 >> 16, hsb_r->dipv6_63_32 & 0xFFFF,
+			hsb_r->dipv6_31_0 >> 16, hsb_r->dipv6_31_0 & 0xFFFF);
+
+		len += sprintf(page + len, "\thop_limit:0x%x",
+			hsb_r->hop_limit);
+		len += sprintf(page + len, "\ttra_cla:0x%x\n", hsb_r->tra_cla);
+
+		len += sprintf(page + len, "\tflow_lab:0x%x", hsb_r->flow_lab);
+		len += sprintf(page + len, "\tnxt_hdr:0x%x\n", hsb_r->nxt_hdr);
+
+		len += sprintf(page + len, "\tipv4:0x%x", hsb_r->ipv4);
+		len += sprintf(page + len, "\tipv6:0x%x\n", hsb_r->ipv6);
+
+		len += sprintf(page + len, "\tip_len:0x%x", hsb_r->ip_len);
+		len += sprintf(page + len, "\ttun_len:0x%x\n", hsb_r->tun_len);
+#endif
+		len += sprintf(page + len, ")\n");
+
+	}
+
+	virtualMacGetHsa(hsa_r);
+	{
+		len += sprintf(page + len, ("HSA("));
+		len += sprintf(page + len,
+			"\tmac:%02x-%02x-%02x-%02x-%02x-%02x\n",
+			hsa_r->nhmac[0], hsa_r->nhmac[1], hsa_r->nhmac[2],
+			hsa_r->nhmac[3], hsa_r->nhmac[4], hsa_r->nhmac[5]);
+
+		addr = ntohl(hsa_r->trip);
+		inet_ntoa_r(addr, addr_s);
+		len += sprintf(page + len, "\ttrip:%s(hex:%08x)", addr_s,
+			hsa_r->trip);
+		len += sprintf(page + len, "\tprt:%d\tipmcast:%d\n",
+			hsa_r->port, hsa_r->ipmcastr);
+		len += sprintf(page + len, "\tl3cs:%d", hsa_r->l3csdt);
+		len += sprintf(page + len, "\tl4cs:%d", hsa_r->l4csdt);
+		len += sprintf(page + len, "\tInternal NETIF:%d", hsa_r->egif);
+		len += sprintf(page + len, "\tl2tr:%d,\n ", hsa_r->l2tr);
+		len += sprintf(page + len, "\tl34tr:%d", hsa_r->l34tr);
+		len += sprintf(page + len, "\tdirtx:%d", hsa_r->dirtxo);
+		len += sprintf(page + len, "\ttype:%d", hsa_r->typeo);
+		len += sprintf(page + len, "\tsnapo:%d", hsa_r->snapo);
+		len += sprintf(page + len, "\twhy2cpu 0x%x (%d)\n",
+			hsa_r->why2cpu, hsa_r->why2cpu);
+		len += sprintf(page + len, "\tpppif:%d", hsa_r->pppoeifo);
+		len += sprintf(page + len, "\tpppid:%d", hsa_r->pppidx);
+		len += sprintf(page + len, "\tttl_1:0x%x", hsa_r->ttl_1if);
+		len += sprintf(page + len, "\tdpc:%d,", hsa_r->dpc);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		len += sprintf(page + len, "\tleno:%d(0x%x) \tmirrort:%d\n",
+			hsa_r->leno, hsa_r->leno, hsa_r->mirrort);
+#else
+		len += sprintf(page + len, "\tleno:%d(0x%x)\n", hsa_r->leno,
+			hsa_r->leno);
+#endif
+		len += sprintf(page + len, "\tl3CrcOk:%d", hsa_r->l3csoko);
+		len += sprintf(page + len, "\tl4CrcOk:%d", hsa_r->l4csoko);
+		len += sprintf(page + len, "\tfrag:%d", hsa_r->frag);
+		len += sprintf(page + len, "\tlastFrag:%d\n", hsa_r->lastfrag);
+
+		len += sprintf(page + len, "\tsvid:0x%x", hsa_r->svid);
+		len += sprintf(page + len, "\tdvid:%d(0x%x)", hsa_r->dvid,
+			hsa_r->dvid);
+		len += sprintf(page + len, "\tdestination interface :%d\n",
+			hsa_r->difid);
+		len += sprintf(page + len, "\trxtag:%d", hsa_r->rxtag);
+		len += sprintf(page + len, "\t\tdvtag:0x%x", hsa_r->dvtag);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		len += sprintf(page + len, "\tspa:%d \tipv4_1st:%d",
+			hsa_r->spao, hsa_r->ipv4_1st);
+#else
+		len += sprintf(page + len, "\tspa:%d", hsa_r->spao);
+#endif
+		len += sprintf(page + len, "\tdpext:0x%x\thwfwrd:%d\n",
+			hsa_r->dpext, hsa_r->hwfwrd);
+		len += sprintf(page + len, "\tspcp:%d", hsa_r->spcp);
+		len += sprintf(page + len, "\t\tpriority:%d", hsa_r->priority);
+
+		len += sprintf(page + len, "\tdp:0x%x\n", hsa_r->dp);
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8881A)
+		len += sprintf(page + len, "\tcputag:%d", hsa_r->cputag);
+		len += sprintf(page + len, "\tptp_pkt:%d", hsa_r->ptp_pkt);
+		len += sprintf(page + len, "\tptp_v2:%d", hsa_r->ptp_v2);
+		len += sprintf(page + len, "\tptp_type:0x%x\n",
+			hsa_r->ptp_type);
+		len += sprintf(page + len, "\trmdp:0x%x", hsa_r->rmdp);
+		len += sprintf(page + len, "\tdpri:0x%x\n", hsa_r->dpri);
+		len += sprintf(page + len, ")\n");
+#elif defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+
+		len += sprintf(page + len, "\tcputag:%d", hsa_r->cputag);
+		len += sprintf(page + len, "\tptp_pkt:%d", hsa_r->ptp_pkt);
+		len += sprintf(page + len, "\tptp_v2:%d", hsa_r->ptp_v2);
+		len += sprintf(page + len, "\tptp_type:0x%x\n",
+			hsa_r->ptp_type);
+
+		len += sprintf(page + len, "\trmdp:0x%x", hsa_r->rmdp);
+		len += sprintf(page + len, "\tdpri:0x%x", hsa_r->dpri);
+		len += sprintf(page + len, "\tmdf:0x%x\n", hsa_r->mdf);
+/*
+		len += sprintf(page+len,"\tsipv6_31_0:0x%x",hsa_r->sipv6_31_0);
+		len += sprintf(page+len,"\tsipv6_63_32:0x%x",hsa_r->sipv6_63_32);
+		len += sprintf(page+len,"\tsipv6_95_64:0x%x",hsa_r->sipv6_95_64);
+		len += sprintf(page+len,"\tsipv6_127_96:0x%x\n",hsa_r->sipv6_127_96);
+
+		len += sprintf(page+len,"\tdipv6_31_0:0x%x",hsa_r->dipv6_31_0);
+		len += sprintf(page+len,"\tdipv6_63_32:0x%x",hsa_r->dipv6_63_32);
+		len += sprintf(page+len,"\tdipv6_95_64:0x%x",hsa_r->dipv6_95_64);
+		len += sprintf(page+len,"\tdipv6_127_96:0x%x\n",hsa_r->dipv6_127_96);
+*/
+
+		len += sprintf(page + len,
+			"\tsip6:\t%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+			hsa_r->sipv6_127_96 >> 16, hsa_r->sipv6_127_96 & 0xFFFF,
+			hsa_r->sipv6_95_64 >> 16, hsa_r->sipv6_95_64 & 0xFFFF,
+			hsa_r->sipv6_63_32 >> 16, hsa_r->sipv6_63_32 & 0xFFFF,
+			hsa_r->sipv6_31_0 >> 16, hsa_r->sipv6_31_0 & 0xFFFF);
+
+		len += sprintf(page + len,
+			"\tdip6:\t%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x\n",
+			hsa_r->dipv6_127_96 >> 16, hsa_r->dipv6_127_96 & 0xFFFF,
+			hsa_r->dipv6_95_64 >> 16, hsa_r->dipv6_95_64 & 0xFFFF,
+			hsa_r->dipv6_63_32 >> 16, hsa_r->dipv6_63_32 & 0xFFFF,
+			hsa_r->dipv6_31_0 >> 16, hsa_r->dipv6_31_0 & 0xFFFF);
+
+		len += sprintf(page + len, "\tip_len:0x%x", hsa_r->ip_len);
+		len += sprintf(page + len, "\tipv4_id:0x%x\n", hsa_r->ipv4_id);
+
+		len += sprintf(page + len, "\ttun_len:0x%x", hsa_r->tun_len);
+		len += sprintf(page + len, "\tmltcst_v6:0x%x",
+			hsa_r->mltcst_v6);
+		len += sprintf(page + len, "\taddip_pri:0x%x\n",
+			hsa_r->addip_pri);
+		len += sprintf(page + len, ")\n");
+#else
+		len += sprintf(page + len, ")\n");
+#endif
+	}
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int32 hs_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	return len;
+}
+
+#if defined(RTL_DEBUG_NIC_SKB_BUFFER)
+int nic_mbuf_show(struct seq_file *s, void *v)
+{
+	rtl819x_debug_skb_memory();
+	return 0;
+}
+
+int nic_mbuf_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, nic_mbuf_show, NULL));
+}
+
+struct file_operations nic_mbuf_single_seq_file_operations = {
+	.open = nic_mbuf_single_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+int rxRing_show(struct seq_file *s, void *v)
+{
+	RTL_dumpRxRing(s);
+	return 0;
+}
+
+static int32 rxRing_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[256];
+	char *strptr;
+	char *tokptr;
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		strptr = tmpbuf;
+
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+		if (strncmp(tokptr, "clear", 5) == 0) {
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+			extern int32 swNic_freeRxRing(void);
+
+			swNic_freeRxRing();
+#endif
+		}
+
+		return len;
+errout:
+		rtlglue_printf("wrong format\n");
+	}
+
+	return len;
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+ssize_t rxRing_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return (ssize_t) rxRing_write(file, userbuf, count, off);
+}
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+int rxRing_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return rxRing_write(file, userbuf, count, off);
+}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+int rxRing_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rxRing_show, NULL));
+}
+
+struct file_operations rxRing_single_seq_file_operations = {
+	.open = rxRing_single_open,
+	.write = rxRing_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+int txRing_show(struct seq_file *s, void *v)
+{
+	RTL_dumpTxRing(s);
+	return 0;
+}
+
+int txRing_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, txRing_show, NULL));
+}
+
+struct file_operations txRing_single_seq_file_operations = {
+	.open = txRing_single_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+int mbuf_show(struct seq_file *s, void *v)
+{
+	RTL_dumpMbufRing(s);
+	return 0;
+}
+
+int mbuf_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, mbuf_show, NULL));
+}
+
+struct file_operations mbuf_single_seq_file_operations = {
+	.open = mbuf_single_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 pvid_read(struct seq_file *s, void *v)
+{
+	uint32 vidp[9];
+	int32 i;
+
+	for (i = 0; i < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; i++) {
+		if (rtl8651_getAsicPVlanId(i, &vidp[i]) != SUCCESS) {
+			seq_printf(s, "ASIC PVID get failed.\n");
+		}
+	}
+	seq_printf(s, ">> PVID Reg:\n");
+	for (i = 0; i < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; i++)
+		seq_printf(s, "p%d: %d,", i, vidp[i]);
+	seq_printf(s, "\n");
+
+	return 0;
+}
+#else
+static int32 pvid_read(char *page, char **start, off_t off, int count, int *eof,
+	void *data)
+{
+	uint32 vidp[9];
+	int32 i;
+	int len;
+
+	len = 0;
+	for (i = 0; i < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; i++) {
+		if (rtl8651_getAsicPVlanId(i, &vidp[i]) != SUCCESS) {
+			len += sprintf(page + len, "ASIC PVID get failed.\n");
+		}
+	}
+	len += sprintf(page + len, ">> PVID Reg:\n");
+	for (i = 0; i < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; i++)
+		len += sprintf(page + len, "p%d: %d,", i, vidp[i]);
+	len += sprintf(page + len, "\n");
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int32 pvid_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	char tmpbuf[256];
+	char *strptr;
+	char *tokptr;
+	uint32 port = 0;
+	uint32 pvid = 0;
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		strptr = tmpbuf;
+
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+
+		port = simple_strtol(tokptr, NULL, 0);
+
+		if (port > (RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum)) {
+			goto errout;
+		}
+
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+
+		pvid = simple_strtol(tokptr, NULL, 0);
+
+		if (pvid > 4096) {
+			goto errout;
+		}
+
+		rtl8651_setAsicPvid(port, pvid);
+
+		return len;
+errout:
+		rtlglue_printf("wrong format\n");
+
+	}
+
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 mirrorPort_read(struct seq_file *s, void *v)
+{
+	uint32 mirrorRx, mirrorTx, mirrorPort;
+
+	rtl8651_getAsicPortMirror(&mirrorRx, &mirrorTx, &mirrorPort);
+	seq_printf(s, ">>Mirror Control Register:\n\n");
+	seq_printf(s, "  Mirror Rx: 0x%x\n", mirrorRx);
+	seq_printf(s, "  Mirror Tx: 0x%x\n", mirrorTx);
+	seq_printf(s, "  Mirror Port: 0x%x\n", mirrorPort);
+
+	return 0;
+}
+#else
+static int32 mirrorPort_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	uint32 mirrorRx, mirrorTx, mirrorPort;
+	int len;
+
+	len = 0;
+	rtl8651_getAsicPortMirror(&mirrorRx, &mirrorTx, &mirrorPort);
+	len += sprintf(page + len, ">>Mirror Control Register:\n\n");
+	len += sprintf(page + len, "  Mirror Rx: 0x%x\n", mirrorRx);
+	len += sprintf(page + len, "  Mirror Tx: 0x%x\n", mirrorTx);
+	len += sprintf(page + len, "  Mirror Port: 0x%x\n", mirrorPort);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int32 mirrorPort_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[64];
+
+	/* uint32        *mem_addr, mem_data, mem_len; */
+	uint32 rx_mask, tx_mask, port_mask;
+	char *strptr, *cmd_addr;
+	char *tokptr;
+
+	if (len > 64) {
+		goto errout;
+	}
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+		rtlglue_printf("cmd %s\n", cmd_addr);
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+
+		if (!memcmp(cmd_addr, "mirror", 6)) {
+			rx_mask = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			tx_mask = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			port_mask = simple_strtol(tokptr, NULL, 0);
+			rtlglue_printf("mirror rx port mask(0x%x) tx port mask(0x%x), mirror port mask(0x%x)\n",
+				rx_mask, tx_mask, port_mask);
+			rtl8651_setAsicPortMirror(rx_mask, tx_mask, port_mask);
+		} else {
+			goto errout;
+		}
+	} else {
+errout:
+		rtlglue_printf("Mirror port configuration only support \"mirror\"as the first parameter\n");
+		rtlglue_printf("mirror: \"mirror rx_portmask tx_portmask mirror_portmask\"\n");
+	}
+
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 l2_read(struct seq_file *s, void *v)
+{
+	rtl865x_tblAsicDrv_l2Param_t asic_l2;
+	uint32 row, col, port, m = 0;
+
+	seq_printf(s, "%s\n", "ASIC L2 Table:");
+	for (row = 0x0; row < RTL8651_L2TBL_ROW; row++) {
+		for (col = 0; col < RTL8651_L2TBL_COLUMN; col++) {
+			memset((void *)&asic_l2, 0, sizeof(asic_l2));
+			if (rtl8651_getAsicL2Table(row, col,
+					&asic_l2) == FAILED) {
+				continue;
+			}
+
+			if (asic_l2.isStatic && asic_l2.ageSec == 0
+				&& asic_l2.cpu && asic_l2.memberPortMask == 0
+				&& asic_l2.auth == 0) {
+				continue;
+			}
+
+			seq_printf(s,
+				"%4d.[%3d,%d] %02x:%02x:%02x:%02x:%02x:%02x FID:%x mbr(",
+				m, row, col, asic_l2.macAddr.octet[0],
+				asic_l2.macAddr.octet[1],
+				asic_l2.macAddr.octet[2],
+				asic_l2.macAddr.octet[3],
+				asic_l2.macAddr.octet[4],
+				asic_l2.macAddr.octet[5], asic_l2.fid);
+
+			m++;
+
+			for (port = 0;
+				port <
+				RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum;
+				port++) {
+				if (asic_l2.memberPortMask & (1 << port)) {
+					seq_printf(s, "%d ", port);
+				}
+			}
+
+			seq_printf(s, ")");
+			seq_printf(s, "%s %s %s %s age:%d ",
+				asic_l2.cpu ? "CPU" : "FWD",
+				asic_l2.isStatic ? "STA" : "DYN",
+				asic_l2.srcBlk ? "BLK" : "",
+				asic_l2.nhFlag ? "NH" : "", asic_l2.ageSec);
+
+			if (asic_l2.auth) {
+				seq_printf(s, "AUTH:%d", asic_l2.auth);
+			} else {
+				seq_printf(s, "AUTH:0");
+			}
+
+			seq_printf(s, "\n");
+		}
+	}
+
+	return 0;
+
+}
+#else
+static int32 l2_read(char *page, char **start, off_t off, int count, int *eof,
+	void *data)
+{
+	int len;
+	rtl865x_tblAsicDrv_l2Param_t asic_l2;
+	uint32 row, col, port, m = 0;
+
+	len = sprintf(page, "%s\n", "ASIC L2 Table:");
+	for (row = 0x0; row < RTL8651_L2TBL_ROW; row++) {
+		for (col = 0; col < RTL8651_L2TBL_COLUMN; col++) {
+			memset((void *)&asic_l2, 0, sizeof(asic_l2));
+			if (rtl8651_getAsicL2Table(row, col,
+					&asic_l2) == FAILED) {
+				continue;
+			}
+
+			if (asic_l2.isStatic && asic_l2.ageSec == 0
+				&& asic_l2.cpu && asic_l2.memberPortMask == 0
+				&& asic_l2.auth == 0) {
+				continue;
+			}
+
+			len += sprintf(page + len,
+				"%4d.[%3d,%d] %02x:%02x:%02x:%02x:%02x:%02x FID:%x mbr(",
+				m, row, col, asic_l2.macAddr.octet[0],
+				asic_l2.macAddr.octet[1],
+				asic_l2.macAddr.octet[2],
+				asic_l2.macAddr.octet[3],
+				asic_l2.macAddr.octet[4],
+				asic_l2.macAddr.octet[5], asic_l2.fid);
+
+			m++;
+
+			for (port = 0;
+				port <
+				RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum;
+				port++) {
+				if (asic_l2.memberPortMask & (1 << port)) {
+					len += sprintf(page + len, "%d ", port);
+				}
+			}
+
+			len += sprintf(page + len, ")");
+			len += sprintf(page + len, "%s %s %s %s age:%d ",
+				asic_l2.cpu ? "CPU" : "FWD",
+				asic_l2.isStatic ? "STA" : "DYN",
+				asic_l2.srcBlk ? "BLK" : "",
+				asic_l2.nhFlag ? "NH" : "", asic_l2.ageSec);
+
+			if (asic_l2.auth) {
+				len += sprintf(page + len, "AUTH:%d",
+					asic_l2.auth);
+			} else {
+				len += sprintf(page + len, "AUTH:0");
+			}
+
+			len += sprintf(page + len, "\n");
+		}
+	}
+
+	return len;
+
+}
+#endif
+static int32 l2_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	return len;
+}
+
+extern uint32 _rtl865x_getAddMcastOpCnt(void);
+extern uint32 _rtl865x_getDelMcastOpCnt(void);
+extern uint32 _rtl865x_getForceAddMcastOpCnt(void);
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rtl865x_proc_hw_mcast_read(struct seq_file *s, void *v)
+{
+	rtl865x_tblAsicDrv_multiCastParam_t asic;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rtl8198C_tblAsicDrv_multiCastv6Param_t asic6;
+#endif
+	uint32 entry;
+
+#if 0
+	uint8 *ucsip, *ucdip;
+#endif
+
+#if 0
+	seq_printf(s, "%s\n", "ASIC Multicast Table:");
+	for (entry = 0; entry < RTL8651_MULTICASTTBL_SIZE; entry++) {
+		if (rtl8651_getAsicIpMulticastTable(entry, &asic) != SUCCESS) {
+#if 0
+			seq_printf(s,
+				"\t[%d]  (INVALID)dip(%d.%d.%d.%d) sip(%d.%d.%d.%d) mbr(0x%x)\n",
+				entry, asic.dip >> 24,
+				(asic.dip & 0x00ff0000) >> 16,
+				(asic.dip & 0x0000ff00) >> 8, (asic.dip & 0xff),
+				asic.sip >> 24, (asic.sip & 0x00ff0000) >> 16,
+				(asic.sip & 0x0000ff00) >> 8, (asic.sip & 0xff),
+				asic.mbr);
+			seq_printf(s,
+				"\t       svid:%d, spa:%d, extIP:%d, age:%d, cpu:%d\n",
+				asic.svid, asic.port, asic.extIdx, asic.age,
+				asic.cpu);
+#endif
+			continue;
+		} else {
+			ucsip = (unsigned char *)&asic.sip;
+			ucdip = (unsigned char *)&asic.dip;
+			seq_printf(s,
+				"\t[%d]  (OK)dip(%d.%d.%d.%d) sip(%d.%d.%d.%d) mbr(0x%x)\n",
+				entry, ucdip[0], ucdip[1], ucdip[2], ucdip[3],
+				ucsip[0], ucsip[1], ucsip[2], ucsip[3],
+				asic.mbr);
+			seq_printf(s,
+				"\t       svid:%d, spa:%d, extIP:%d, age:%d, cpu:%d\n",
+				asic.svid, asic.port, asic.extIdx, asic.age,
+				asic.cpu);
+		}
+	}
+	seq_printf(s,
+		"\n\t TotalOpCnt:AddMcastOpCnt:%d\tDelMcastOpCnt:%d\tForceAddMcastOpCnt:%d\t \n",
+		_rtl865x_getAddMcastOpCnt(), _rtl865x_getDelMcastOpCnt(),
+		_rtl865x_getForceAddMcastOpCnt());
+#else
+	seq_printf(s, "%s\n", "Hardware multicast version: v3.4.11D_DHC_v_1");
+	seq_printf(s, "%s\n", "ASIC Multicast Table:");
+
+	for (entry = 0; entry < RTL8651_MULTICASTTBL_SIZE; entry++) {
+#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(entry, WATCHDOG_NUM_OF_TIMES);
+#endif
+		if (rtl8651_getAsicIpMulticastTable(entry, &asic) != SUCCESS) {
+			continue;
+		}
+		seq_printf(s,
+			"\t[%d]  (OK)dip(%d.%d.%d.%d) sip(%d.%d.%d.%d) mbr(%x)\n",
+			entry, asic.dip >> 24, (asic.dip & 0x00ff0000) >> 16,
+			(asic.dip & 0x0000ff00) >> 8, (asic.dip & 0xff),
+			asic.sip >> 24, (asic.sip & 0x00ff0000) >> 16,
+			(asic.sip & 0x0000ff00) >> 8, (asic.sip & 0xff),
+			asic.mbr);
+		seq_printf(s,
+			"\t       svid:%d, spa:%d, extIP:%d, age:%d, cpu:%d\n",
+			asic.svid, asic.port, asic.extIdx, asic.age, asic.cpu);
+	}
+	seq_printf(s,
+		"\n\t TotalOpCnt:AddMcastOpCnt:%d\tDelMcastOpCnt:%d\tForceAddMcastOpCnt:%d\t \n",
+		_rtl865x_getAddMcastOpCnt(), _rtl865x_getDelMcastOpCnt(),
+		_rtl865x_getForceAddMcastOpCnt());
+#endif
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	seq_printf(s, "----------------------------------------------------\n");
+	seq_printf(s, "%s\n", "ASIC IPV6 Multicast Table:");
+	for (entry = 0; entry < RTL8651_MULTICASTTBL_SIZE; entry++) {
+#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(entry, WATCHDOG_NUM_OF_TIMES);
+#endif
+		if (rtl8198C_getAsicIpMulticastv6Table(entry,
+				&asic6) != SUCCESS) {
+#if 0
+			seq_printf(s,
+				"\t[%d]  (INVALID)dip(%d.%d.%d.%d) sip(%d.%d.%d.%d) mbr(0x%x)\n",
+				entry, asic.dip >> 24,
+				(asic.dip & 0x00ff0000) >> 16,
+				(asic.dip & 0x0000ff00) >> 8, (asic.dip & 0xff),
+				asic.sip >> 24, (asic.sip & 0x00ff0000) >> 16,
+				(asic.sip & 0x0000ff00) >> 8, (asic.sip & 0xff),
+				asic.mbr);
+			seq_printf(s,
+				"\t       svid:%d, spa:%d, extIP:%d, age:%d, cpu:%d\n",
+				asic.svid, asic.port, asic.extIdx, asic.age,
+				asic.cpu);
+#endif
+			continue;
+		} else {
+			seq_printf(s, "\t[%d]  (OK)dip:%08x:%08x:%08x:%08x\n",
+				entry,
+				asic6.dip.v6_addr32[0], asic6.dip.v6_addr32[1],
+				asic6.dip.v6_addr32[2], asic6.dip.v6_addr32[3]);
+			seq_printf(s, "\t          sip:%08x:%08x:%08x:%08x\n",
+				asic6.sip.v6_addr32[0], asic6.sip.v6_addr32[1],
+				asic6.sip.v6_addr32[2], asic6.sip.v6_addr32[3]);
+
+			seq_printf(s,
+				"\t          spa:%d, age:%d, cpu:%d, mbr(0x%x)\n",
+				asic6.port, asic6.age, asic6.cpu, asic6.mbr);
+		}
+	}
+	seq_printf(s,
+		"\n\t TotalOpCntv6:AddMcastOpCntv6:%d\tDelMcastOpCntv6:%d\tForceAddMcastOpCntv6:%d\t \n",
+		_rtl8198C_getAddMcastv6OpCnt(), _rtl8198C_getDelMcastv6OpCnt(),
+		_rtl8198C_getForceAddMcastv6OpCnt());
+#endif
+	return 0;
+}
+#else
+static int32 rtl865x_proc_hw_mcast_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+	rtl865x_tblAsicDrv_multiCastParam_t asic;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rtl8198C_tblAsicDrv_multiCastv6Param_t asic6;
+#endif
+	uint32 entry;
+
+#if 1
+	len = sprintf(page, "%s\n", "ASIC Multicast Table:");
+	for (entry = 0; entry < RTL8651_MULTICASTTBL_SIZE; entry++) {
+#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(entry, WATCHDOG_NUM_OF_TIMES);
+#endif
+		if (rtl8651_getAsicIpMulticastTable(entry, &asic) != SUCCESS) {
+#if 0
+			len += sprintf(page + len,
+				"\t[%d]  (INVALID)dip(%d.%d.%d.%d) sip(%d.%d.%d.%d) mbr(0x%x)\n",
+				entry, asic.dip >> 24,
+				(asic.dip & 0x00ff0000) >> 16,
+				(asic.dip & 0x0000ff00) >> 8, (asic.dip & 0xff),
+				asic.sip >> 24, (asic.sip & 0x00ff0000) >> 16,
+				(asic.sip & 0x0000ff00) >> 8, (asic.sip & 0xff),
+				asic.mbr);
+			len += sprintf(page + len,
+				"\t       svid:%d, spa:%d, extIP:%d, age:%d, cpu:%d\n",
+				asic.svid, asic.port, asic.extIdx, asic.age,
+				asic.cpu);
+#endif
+			continue;
+		} else {
+			len += sprintf(page + len,
+				"\t[%d]  (OK)dip(%d.%d.%d.%d) sip(%d.%d.%d.%d) mbr(0x%x)\n",
+				entry, asic.dip >> 24,
+				(asic.dip & 0x00ff0000) >> 16,
+				(asic.dip & 0x0000ff00) >> 8, (asic.dip & 0xff),
+				asic.sip >> 24, (asic.sip & 0x00ff0000) >> 16,
+				(asic.sip & 0x0000ff00) >> 8, (asic.sip & 0xff),
+				asic.mbr);
+			len += sprintf(page + len,
+				"\t       svid:%d, spa:%d, extIP:%d, age:%d, cpu:%d\n",
+				asic.svid, asic.port, asic.extIdx, asic.age,
+				asic.cpu);
+		}
+	}
+	len += sprintf(page + len,
+		"\n\t TotalOpCnt:AddMcastOpCnt:%d\tDelMcastOpCnt:%d\tForceAddMcastOpCnt:%d\t \n",
+		_rtl865x_getAddMcastOpCnt(), _rtl865x_getDelMcastOpCnt(),
+		_rtl865x_getForceAddMcastOpCnt());
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	len += sprintf(page + len,
+		"----------------------------------------------------\n");
+	len += sprintf(page + len, "%s\n", "ASIC IPV6 Multicast Table:");
+	for (entry = 0; entry < RTL8651_MULTICASTTBL_SIZE; entry++) {
+#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(entry, WATCHDOG_NUM_OF_TIMES);
+#endif
+		if (rtl8198C_getAsicIpMulticastv6Table(entry,
+				&asic6) != SUCCESS) {
+#if 0
+			len += sprintf(page + len,
+				"\t[%d]	(INVALID)dip(%d.%d.%d.%d) sip(%d.%d.%d.%d) mbr(0x%x)\n",
+				entry, asic.dip >> 24,
+				(asic.dip & 0x00ff0000) >> 16,
+				(asic.dip & 0x0000ff00) >> 8,
+				(asic.dip & 0xff), asic.sip >> 24,
+				(asic.sip & 0x00ff0000) >> 16,
+				(asic.sip & 0x0000ff00) >> 8,
+				(asic.sip & 0xff), asic.mbr);
+			len += sprintf(page + len,
+				"\t		 svid:%d, spa:%d, extIP:%d, age:%d, cpu:%d\n",
+				asic.svid, asic.port, asic.extIdx,
+				asic.age, asic.cpu);
+#endif
+			continue;
+		} else {
+			len += sprintf(page + len,
+				"\t[%d]	(OK)dip:%08x-%08x-%08x-%08x\n",
+				entry, asic6.dip.v6_addr32[0],
+				asic6.dip.v6_addr32[1],
+				asic6.dip.v6_addr32[2], asic6.dip.v6_addr32[3]);
+			len += sprintf(page + len,
+				"\t			sip:%08x-%08x-%08x-%08x\n",
+				asic6.sip.v6_addr32[0],
+				asic6.sip.v6_addr32[1],
+				asic6.sip.v6_addr32[2], asic6.sip.v6_addr32[3]);
+
+			len += sprintf(page + len,
+				"\t			spa:%d, age:%d, cpu:%d, mbr:0x%x\n",
+				asic6.port, asic6.age, asic6.cpu, asic6.mbr);
+		}
+	}
+	len += sprintf(page + len,
+		"\n\t TotalOpCntv6:AddMcastOpCntv6:%d\tDelMcastOpCntv6:%d\tForceAddMcastOpCntv6:%d\t \n",
+		_rtl8198C_getAddMcastv6OpCnt(), _rtl8198C_getDelMcastv6OpCnt(),
+		_rtl8198C_getForceAddMcastv6OpCnt());
+#endif
+
+#else
+	len = sprintf(page, "%s\n", "ASIC Multicast Table:");
+
+	for (entry = 0; entry < RTL8651_MULTICASTTBL_SIZE; entry++) {
+		if (rtl8651_getAsicIpMulticastTable(entry, &asic) != SUCCESS) {
+			len += sprintf(page + len, "\t[%d]  (Invalid Entry)\n",
+				entry);
+			continue;
+		}
+		len += sprintf(page + len,
+			"\t[%d]  dip(%d.%d.%d.%d) sip(%d.%d.%d.%d) mbr(%x)\n",
+			entry, asic.dip >> 24, (asic.dip & 0x00ff0000) >> 16,
+			(asic.dip & 0x0000ff00) >> 8, (asic.dip & 0xff),
+			asic.sip >> 24, (asic.sip & 0x00ff0000) >> 16,
+			(asic.sip & 0x0000ff00) >> 8, (asic.sip & 0xff),
+			asic.mbr);
+		len += sprintf(page + len,
+			"\t       svid:%d, spa:%d, extIP:%d, age:%d, cpu:%d\n",
+			asic.svid, asic.port, asic.extIdx, asic.age, asic.cpu);
+	}
+#endif
+
+	if (len <= off + count) {
+		*eof = 1;
+	}
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count) {
+		len = count;
+	}
+
+	if (len < 0) {
+		len = 0;
+	}
+
+	return len;
+}
+#endif
+
+static int32 rtl865x_proc_hw_mcast_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[512];
+	char *strptr;
+	char *tokptr;
+	char *dotPtr;
+	rtl865xc_tblAsic_ipMulticastTable_t entry;
+	int16 age;
+	uint32 idx;
+	uint32 sip, dip;
+	uint32 srcPort, svid, mbr;
+	int32 i;
+
+	if (len > 512) {
+		goto errout;
+	}
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		bzero(&entry, sizeof(entry));
+		tmpbuf[len] = '\0';
+
+		strptr = tmpbuf;
+
+		/*valid */
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+		entry.valid = simple_strtol(tokptr, NULL, 0);
+
+		/*destination ip */
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+
+		dip = 0;
+		for (i = 0; i < 4; i++) {
+			dotPtr = strsep(&tokptr, ".");
+			if (dotPtr == NULL) {
+				break;
+			}
+			dip = (dip << 8) | simple_strtol(dotPtr, NULL, 0);
+		}
+
+		entry.destIPAddrLsbs = dip & 0xfffffff;
+
+		/*source ip */
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+
+		sip = 0;
+		for (i = 0; i < 4; i++) {
+			dotPtr = strsep(&tokptr, ".");
+			if (dotPtr == NULL) {
+				break;
+			}
+			sip = (sip << 8) | simple_strtol(dotPtr, NULL, 0);
+		}
+
+		entry.srcIPAddr = sip;
+
+		/*mbr */
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+		mbr = simple_strtol(tokptr, NULL, 0);
+		entry.portList = mbr & (RTL8651_PHYSICALPORTMASK);
+
+		/*svid */
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+		svid = simple_strtol(tokptr, NULL, 0);
+
+		/*spa */
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+		srcPort = simple_strtol(tokptr, NULL, 0);
+		entry.srcPort = srcPort;
+
+		/*extIP */
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+		entry.extIPIndex = simple_strtol(tokptr, NULL, 0);
+
+		/*age */
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+		age = simple_strtol(tokptr, NULL, 0);
+
+		entry.ageTime = 0;
+		while (age > 0) {
+			if ((++entry.ageTime) == 7)
+				break;
+			age -= 5;
+		}
+
+		/*to cpu */
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+		entry.toCPU = simple_strtol(tokptr, NULL, 0);
+
+		idx = rtl8651_ipMulticastTableIndex(sip, dip);
+		_rtl8651_forceAddAsicEntry(TYPE_MULTICAST_TABLE, idx, &entry);
+
+	} else {
+errout:
+		rtlglue_printf("error input\n");
+	}
+
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rtl865x_proc_sw_mcast_read(struct seq_file *s, void *v)
+{
+	rtl_dumpSwMulticastInfo(s);
+	return 0;
+}
+#else
+static int32 rtl865x_proc_sw_mcast_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+
+	rtl_dumpSwMulticastInfo(page, &len);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+
+}
+#endif
+
+static int32 rtl865x_proc_sw_mcast_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+
+	return len;
+}
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 arp_read(struct seq_file *s, void *v)
+{
+	rtl865x_tblAsicDrv_routingParam_t asic_l3;
+	rtl865x_tblAsicDrv_arpParam_t asic_arp;
+	rtl865x_tblAsicDrv_l2Param_t asic_l2;
+
+	uint32 i, j, port;
+	ipaddr_t ipAddr;
+	int8 ipBuf[sizeof "255.255.255.255"];
+
+	seq_printf(s, "%s\n", "ASIC Arp Table:\n");
+	for (i = 0; i < RTL8651_ARPTBL_SIZE; i++) {
+		if (rtl8651_getAsicArp(i, &asic_arp) == FAILED)
+			continue;
+		for (j = 0; j < RTL8651_ROUTINGTBL_SIZE; j++) {
+			if (rtl8651_getAsicRouting(j, &asic_l3) == FAILED
+				|| asic_l3.process != 0x02 /*RT_ARP */)
+				continue;
+			if (asic_l3.arpStart <= (i >> 3)
+				&& (i >> 3) <= asic_l3.arpEnd) {
+				/* 8197F: change to big endian format for below operation */
+				asic_l3.ipAddr = htonl(asic_l3.ipAddr);
+				asic_l3.ipMask = htonl(asic_l3.ipMask);
+
+				ipAddr = (asic_l3.ipAddr & asic_l3.ipMask) +
+					(i - (asic_l3.arpStart << 3));
+
+				/* 8197F: change to little endian format for display (inet_ntoa_r) */
+				ipAddr = ntohl(ipAddr);
+
+				if (rtl8651_getAsicL2Table_Patch(asic_arp.nextHopRow,
+						asic_arp.nextHopColumn,
+						&asic_l2) == FAILED) {
+					inet_ntoa_r(ipAddr, ipBuf);
+					seq_printf(s, "%-16s [%3d,%d] ", ipBuf,
+						asic_arp.nextHopRow,
+						asic_arp.nextHopColumn);
+				} else {
+					inet_ntoa_r(ipAddr, ipBuf);
+					seq_printf(s,
+						"%-16s %02x-%02x-%02x-%02x-%02x-%02x (",
+						ipBuf, asic_l2.macAddr.octet[0],
+						asic_l2.macAddr.octet[1],
+						asic_l2.macAddr.octet[2],
+						asic_l2.macAddr.octet[3],
+						asic_l2.macAddr.octet[4],
+						asic_l2.macAddr.octet[5]);
+					for (port = 0;
+						port <
+						RTL8651_PORT_NUMBER +
+						rtl8651_totalExtPortNum;
+						port++) {
+						if (asic_l2.memberPortMask & (1 << port))
+							seq_printf(s, "%d ", port);
+						else
+							seq_printf(s, "  ");
+					}
+					seq_printf(s, ") %us", asic_l2.ageSec);
+				}
+				continue;
+			}
+		}
+
+		seq_printf(s, " ARP:%3d  L2:%3d,%d,aging:%d\n", i,
+			asic_arp.nextHopRow, asic_arp.nextHopColumn,
+			asic_arp.aging);
+
+	}
+
+	return 0;
+}
+#else
+static int32 arp_read(char *page, char **start, off_t off, int count, int *eof,
+	void *data)
+{
+	int len;
+	rtl865x_tblAsicDrv_routingParam_t asic_l3;
+	rtl865x_tblAsicDrv_arpParam_t asic_arp;
+	rtl865x_tblAsicDrv_l2Param_t asic_l2;
+
+	uint32 i, j, port;
+	ipaddr_t ipAddr;
+	int8 ipBuf[sizeof "255.255.255.255"];
+
+	len = sprintf(page, "%s\n", "ASIC Arp Table:\n");
+	for (i = 0; i < RTL8651_ARPTBL_SIZE; i++) {
+		if (rtl8651_getAsicArp(i, &asic_arp) == FAILED)
+			continue;
+		for (j = 0; j < RTL8651_ROUTINGTBL_SIZE; j++) {
+			if (rtl8651_getAsicRouting(j, &asic_l3) == FAILED
+				|| asic_l3.process != 0x02 /*RT_ARP */)
+				continue;
+			if (asic_l3.arpStart <= (i >> 3)
+				&& (i >> 3) <= asic_l3.arpEnd) {
+				ipAddr = (asic_l3.ipAddr & asic_l3.ipMask) +
+					(i - (asic_l3.arpStart << 3));
+				if (rtl8651_getAsicL2Table_Patch(asic_arp.nextHopRow,
+						asic_arp.nextHopColumn,
+						&asic_l2) == FAILED) {
+					inet_ntoa_r(ipAddr, ipBuf);
+					len += sprintf(page + len,
+						"%-16s [%3d,%d] ", ipBuf,
+						asic_arp.nextHopRow,
+						asic_arp.nextHopColumn);
+				} else {
+					inet_ntoa_r(ipAddr, ipBuf);
+					len += sprintf(page + len,
+						"%-16s %02x-%02x-%02x-%02x-%02x-%02x (",
+						ipBuf, asic_l2.macAddr.octet[0],
+						asic_l2.macAddr.octet[1],
+						asic_l2.macAddr.octet[2],
+						asic_l2.macAddr.octet[3],
+						asic_l2.macAddr.octet[4],
+						asic_l2.macAddr.octet[5]);
+					for (port = 0;
+						port <
+						RTL8651_PORT_NUMBER +
+						rtl8651_totalExtPortNum;
+						port++) {
+						if (asic_l2.memberPortMask & (1 << port))
+							len += sprintf(page + len, "%d ",
+								port);
+						else
+							len += sprintf(page + len, "  ");
+					}
+					len += sprintf(page + len, ") %us",
+						asic_l2.ageSec);
+				}
+				continue;
+			}
+		}
+
+		len += sprintf(page + len, " ARP:%3d  L2:%3d,%d,aging:%d\n", i,
+			asic_arp.nextHopRow, asic_arp.nextHopColumn,
+			asic_arp.aging);
+
+	}
+
+	return len;
+}
+#endif
+
+static int32 arp_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 nexthop_read(struct seq_file *s, void *v)
+{
+	rtl865x_tblAsicDrv_nextHopParam_t asic_nxthop;
+
+	uint32 idx, refcnt, rt_flag;
+
+	seq_printf(s, "%s\n", "ASIC Next Hop Table:\n");
+	for (idx = 0; idx < RTL8651_NEXTHOPTBL_SIZE; idx++) {
+		refcnt = rt_flag = 0;
+		if (rtl8651_getAsicNextHopTable(idx, &asic_nxthop) == FAILED)
+			continue;
+		seq_printf(s,
+			"  [%d]  type(%s) IPIdx(%d) dstVid(%d) pppoeIdx(%d) nextHop([%d:%d]%d) rf(%d) rt(%d)\n",
+			idx,
+			(asic_nxthop.isPppoe == TRUE ? "pppoe" : "ethernet"),
+			asic_nxthop.extIntIpIdx, asic_nxthop.dvid,
+			asic_nxthop.pppoeIdx, asic_nxthop.nextHopRow,
+			asic_nxthop.nextHopColumn,
+			(asic_nxthop.nextHopRow << 2) +
+			asic_nxthop.nextHopColumn, refcnt, rt_flag);
+	}
+
+	return 0;
+}
+#else
+static int32 nexthop_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	rtl865x_tblAsicDrv_nextHopParam_t asic_nxthop;
+	uint32 idx, refcnt, rt_flag;
+
+	rtlglue_printf("[%s:%d]\n", __FUNCTION__, __LINE__);
+	len = sprintf(page, "%s\n", "ASIC Next Hop Table:\n");
+	for (idx = 0; idx < RTL8651_NEXTHOPTBL_SIZE; idx++) {
+		refcnt = rt_flag = 0;
+		if (rtl8651_getAsicNextHopTable(idx, &asic_nxthop) == FAILED)
+			continue;
+		len += sprintf(page + len,
+			"  [%d]  type(%s) IPIdx(%d) dstVid(%d) pppoeIdx(%d) nextHop(%d) rf(%d) rt(%d)\n",
+			idx,
+			(asic_nxthop.isPppoe == TRUE ? "pppoe" : "ethernet"),
+			asic_nxthop.extIntIpIdx, asic_nxthop.dvid,
+			asic_nxthop.pppoeIdx,
+			(asic_nxthop.nextHopRow << 2) +
+			asic_nxthop.nextHopColumn, refcnt, rt_flag);
+	}
+
+	return len;
+}
+#endif
+
+static int32 nexthop_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 l3_read(struct seq_file *s, void *v)
+{
+#if 0
+	uint32 DSLEG;
+	uint32 DSL_IDX;
+
+#endif
+	rtl865x_tblAsicDrv_routingParam_t asic_l3;
+	int8 *str[] =
+		{ "PPPoE", "L2", "ARP", " ", "CPU", "NxtHop", "DROP", " " };
+	int8 *strNetType[] = { "WAN", "DMZ", "LAN", "RLAN" };
+	uint32 idx, mask;
+	int netIdx;
+	uint8 *ucp;
+
+	seq_printf(s, "%s\n", "ASIC L3 Routing Table:\n");
+	for (idx = 0; idx < RTL8651_ROUTINGTBL_SIZE; idx++) {
+		if (rtl8651_getAsicRouting(idx, &asic_l3) == FAILED) {
+			seq_printf(s, "\t[%d]  (Invalid)\n", idx);
+			continue;
+		}
+
+		asic_l3.ipMask = htonl(asic_l3.ipMask);
+
+		if (idx == RTL8651_ROUTINGTBL_SIZE - 1)
+			mask = 0;
+		else
+			for (mask = 32; !(asic_l3.ipMask & 0x01);
+				asic_l3.ipMask = asic_l3.ipMask >> 1)
+				mask--;
+		netIdx = asic_l3.internal << 1 | asic_l3.DMZFlag;
+/* seq_printf(s,"\t[%d]  %d.%d.%d.%d/%d process(%s) %s DSLEG(%d),DSL_IDX(%d)\n", idx, (asic_l3.ipAddr>>24), */
+/* ((asic_l3.ipAddr&0x00ff0000)>>16), ((asic_l3.ipAddr&0x0000ff00)>>8), (asic_l3.ipAddr&0xff), */
+/* mask, str[asic_l3.process],strNetType[netIdx],asic_l3.DSLEG,asic_l3.DSL_IDX); */
+		ucp = (unsigned char *)&(asic_l3.ipAddr);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		seq_printf(s,
+			"\t[%d]  %d.%d.%d.%d/%d process(%s) %s DSLEG(%d),DSL_IDX(%d)\n",
+			idx, ucp[0], ucp[1], ucp[2], ucp[3], mask,
+			str[asic_l3.process], strNetType[netIdx], asic_l3.DSLEG,
+			asic_l3.DSL_IDX);
+#else
+		seq_printf(s, "\t[%d]  %d.%d.%d.%d/%d process(%s) %s \n", idx,
+			ucp[0], ucp[1], ucp[2], ucp[3], mask,
+			str[asic_l3.process], strNetType[netIdx]);
+#endif
+		switch (asic_l3.process) {
+		case 0x00:	/* PPPoE */
+			seq_printf(s,
+				"\t           dvidx(%d)  pppidx(%d) nxthop(%d)\n",
+				asic_l3.vidx, asic_l3.pppoeIdx,
+				(asic_l3.nextHopRow << 2) +
+				asic_l3.nextHopColumn);
+			break;
+
+		case 0x01:	/* L2 */
+			seq_printf(s, "              dvidx(%d) nexthop(%d)\n",
+				asic_l3.vidx,
+				(asic_l3.nextHopRow << 2) +
+				asic_l3.nextHopColumn);
+			break;
+
+		case 0x02:	/* ARP */
+			seq_printf(s,
+				"             dvidx(%d) ARPSTA(%d) ARPEND(%d) IPIDX(%d)\n",
+				asic_l3.vidx, asic_l3.arpStart << 3,
+				asic_l3.arpEnd << 3, asic_l3.arpIpIdx);
+			break;
+
+		case 0x03:	/* Reserved */
+			;
+
+		case 0x04:	/* CPU */
+			seq_printf(s, "             dvidx(%d)\n", asic_l3.vidx);
+			break;
+
+		case 0x05:	/* NAPT Next Hop */
+			seq_printf(s,
+				"              NHSTA(%d) NHNUM(%d) NHNXT(%d) NHALGO(%d) IPDOMAIN(%d)\n",
+				asic_l3.nhStart, asic_l3.nhNum, asic_l3.nhNxt,
+				asic_l3.nhAlgo, asic_l3.ipDomain);
+			break;
+
+		case 0x06:	/* DROP */
+			seq_printf(s, "             dvidx(%d)\n", asic_l3.vidx);
+			break;
+
+		case 0x07:	/* Reserved */
+			/* pass through */
+		default:
+			;
+		}
+	}
+
+	return 0;
+}
+#else
+static int32 l3_read(char *page, char **start, off_t off, int count, int *eof,
+	void *data)
+{
+	int len;
+	rtl865x_tblAsicDrv_routingParam_t asic_l3;
+	int8 *str[] =
+		{ "PPPoE", "L2", "ARP", " ", "CPU", "NxtHop", "DROP", " " };
+	int8 *strNetType[] = { "WAN", "DMZ", "LAN", "RLAN" };
+	uint32 idx, mask;
+	int netIdx;
+
+	len = sprintf(page, "%s\n", "ASIC L3 Routing Table:\n");
+	for (idx = 0; idx < RTL8651_ROUTINGTBL_SIZE; idx++) {
+		if (rtl8651_getAsicRouting(idx, &asic_l3) == FAILED) {
+			len += sprintf(page + len, "\t[%d]  (Invalid)\n", idx);
+			continue;
+		}
+		if (idx == RTL8651_ROUTINGTBL_SIZE - 1)
+			mask = 0;
+		else
+			for (mask = 32; !(asic_l3.ipMask & 0x01);
+				asic_l3.ipMask = asic_l3.ipMask >> 1)
+				mask--;
+		netIdx = asic_l3.internal << 1 | asic_l3.DMZFlag;
+		len += sprintf(page + len,
+			"\t[%d]  %d.%d.%d.%d/%d process(%s) %s \n", idx,
+			(asic_l3.ipAddr >> 24),
+			((asic_l3.ipAddr & 0x00ff0000) >> 16),
+			((asic_l3.ipAddr & 0x0000ff00) >> 8),
+			(asic_l3.ipAddr & 0xff), mask, str[asic_l3.process],
+			strNetType[netIdx]);
+
+		switch (asic_l3.process) {
+		case 0x00:	/* PPPoE */
+			len += sprintf(page + len,
+				"\t           dvidx(%d)  pppidx(%d) nxthop(%d)\n",
+				asic_l3.vidx, asic_l3.pppoeIdx,
+				(asic_l3.nextHopRow << 2) +
+				asic_l3.nextHopColumn);
+			break;
+
+		case 0x01:	/* L2 */
+			len += sprintf(page + len,
+				"              dvidx(%d) nexthop(%d)\n",
+				asic_l3.vidx,
+				(asic_l3.nextHopRow << 2) +
+				asic_l3.nextHopColumn);
+			break;
+
+		case 0x02:	/* ARP */
+			len += sprintf(page + len,
+				"             dvidx(%d) ARPSTA(%d) ARPEND(%d) IPIDX(%d)\n",
+				asic_l3.vidx, asic_l3.arpStart << 3,
+				asic_l3.arpEnd << 3, asic_l3.arpIpIdx);
+			break;
+
+		case 0x03:	/* Reserved */
+			;
+
+		case 0x04:	/* CPU */
+			len += sprintf(page + len, "             dvidx(%d)\n",
+				asic_l3.vidx);
+			break;
+
+		case 0x05:	/* NAPT Next Hop */
+			len += sprintf(page + len,
+				"              NHSTA(%d) NHNUM(%d) NHNXT(%d) NHALGO(%d) IPDOMAIN(%d)\n",
+				asic_l3.nhStart, asic_l3.nhNum, asic_l3.nhNxt,
+				asic_l3.nhAlgo, asic_l3.ipDomain);
+			break;
+
+		case 0x06:	/* DROP */
+			len += sprintf(page + len, "             dvidx(%d)\n",
+				asic_l3.vidx);
+			break;
+
+		case 0x07:	/* Reserved */
+			/* pass through */
+		default:
+			;
+		}
+	}
+
+	return len;
+}
+#endif
+
+static int32 l3_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 ip_read(struct seq_file *s, void *v)
+{
+	rtl865x_tblAsicDrv_extIntIpParam_t asic_ip;
+	int32 i;
+	int8 intIpBuf[sizeof "255.255.255.255"];
+	int8 extIpBuf[sizeof "255.255.255.255"];
+
+	seq_printf(s, "%s\n", "ASIC IP Table:\n");
+
+	for (i = 0; i < RTL8651_IPTABLE_SIZE; i++) {
+		if (rtl8651_getAsicExtIntIpTable(i, &asic_ip) == FAILED) {
+			seq_printf(s, "  [%d] (Invalid)\n", i);
+			continue;
+		}
+		inet_ntoa_r(asic_ip.intIpAddr, intIpBuf);
+		inet_ntoa_r(asic_ip.extIpAddr, extIpBuf);
+		seq_printf(s,
+			"  [%d] intip(%-14s) extip(%-14s) type(%s) nhIdx(%d)\n",
+			i, intIpBuf, extIpBuf,
+			(asic_ip.localPublic == TRUE ? "LP" : (asic_ip.nat ==
+					TRUE ? "NAT" : "NAPT")),
+			asic_ip.nhIndex);
+	}
+
+	return 0;
+}
+#else
+static int32 ip_read(char *page, char **start, off_t off, int count, int *eof,
+	void *data)
+{
+	int len;
+
+	rtl865x_tblAsicDrv_extIntIpParam_t asic_ip;
+	int32 i;
+	int8 intIpBuf[sizeof "255.255.255.255"];
+	int8 extIpBuf[sizeof "255.255.255.255"];
+
+	len = sprintf(page, "%s\n", "ASIC IP Table:\n");
+
+	for (i = 0; i < RTL8651_IPTABLE_SIZE; i++) {
+		if (rtl8651_getAsicExtIntIpTable(i, &asic_ip) == FAILED) {
+			len += sprintf(page + len, "  [%d] (Invalid)\n", i);
+			continue;
+		}
+		inet_ntoa_r(asic_ip.intIpAddr, intIpBuf);
+		inet_ntoa_r(asic_ip.extIpAddr, extIpBuf);
+		len += sprintf(page + len,
+			"  [%d] intip(%-14s) extip(%-14s) type(%s) nhIdx(%d)\n",
+			i, intIpBuf, extIpBuf,
+			(asic_ip.localPublic == TRUE ? "LP" : (asic_ip.nat ==
+					TRUE ? "NAT" : "NAPT")),
+			asic_ip.nhIndex);
+	}
+
+	return len;
+}
+#endif
+
+static int32 ip_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 pppoe_read(struct seq_file *s, void *v)
+{
+	rtl865x_tblAsicDrv_pppoeParam_t asic_pppoe;
+	int32 i;
+
+	seq_printf(s, "%s\n", "ASIC PPPOE Table:\n");
+	for (i = 0; i < RTL8651_PPPOETBL_SIZE; i++) {
+		if (rtl8651_getAsicPppoe(i, &asic_pppoe) == FAILED)
+			continue;
+		seq_printf(s, "\t[%d]  sessionID(%d)  ageSec(%d)\n", i,
+			asic_pppoe.sessionId, asic_pppoe.age);
+	}
+	return 0;
+}
+#else
+static int32 pppoe_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	rtl865x_tblAsicDrv_pppoeParam_t asic_pppoe;
+	int32 i;
+
+	len = sprintf(page, "%s\n", "ASIC PPPOE Table:\n");
+	for (i = 0; i < RTL8651_PPPOETBL_SIZE; i++) {
+		if (rtl8651_getAsicPppoe(i, &asic_pppoe) == FAILED)
+			continue;
+		len += sprintf(page + len,
+			"\t[%d]  sessionID(%d)  ageSec(%d)\n", i,
+			asic_pppoe.sessionId, asic_pppoe.age);
+	}
+	return len;
+}
+#endif
+
+static int32 pppoe_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	return len;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_LAYERED_DRIVER_L4)
+int32 napt_show(struct seq_file *s, void *v)
+{
+	rtl865x_tblAsicDrv_naptTcpUdpParam_t asic_tcpudp;
+	uint32 idx, entry = 0;
+	uint8 *ucp;
+
+	seq_printf(s, "%s\n", "ASIC NAPT TCP/UDP Table:\n");
+
+	for (idx = 0; idx < RTL8651_TCPUDPTBL_SIZE; idx++) {
+#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(idx, WATCHDOG_NUM_OF_TIMES);
+#endif
+		if (rtl8651_getAsicNaptTcpUdpTable(idx, &asic_tcpudp) == FAILED)
+			continue;
+
+		if (asic_tcpudp.isValid == 1 || asic_tcpudp.isDedicated == 1) {
+/* len += seq_printf(s, "[%4d] %d.%d.%d.%d:%d {V,D}={%d,%d} col1(%d) col2(%d) static(%d) tcp(%d)\n", */
+/* idx, */
+/* asic_tcpudp.insideLocalIpAddr>>24, (asic_tcpudp.insideLocalIpAddr&0x00ff0000) >> 16, */
+/* (asic_tcpudp.insideLocalIpAddr&0x0000ff00)>>8, asic_tcpudp.insideLocalIpAddr&0x000000ff, */
+/* asic_tcpudp.insideLocalPort, */
+/* asic_tcpudp.isValid, asic_tcpudp.isDedicated, */
+/* asic_tcpudp.isCollision, asic_tcpudp.isCollision2, asic_tcpudp.isStatic, asic_tcpudp.isTcp ); */
+			asic_tcpudp.insideLocalIpAddr =
+				ntohl(asic_tcpudp.insideLocalIpAddr);
+			ucp = (unsigned char *)&(asic_tcpudp.insideLocalIpAddr);
+			seq_printf(s,
+				"[%4d] %d.%d.%d.%d:%d {V,D}={%d,%d} col1(%d) col2(%d) static(%d) tcp(%d)\n",
+				idx, ucp[0], ucp[1], ucp[2], ucp[3],
+				asic_tcpudp.insideLocalPort,
+				asic_tcpudp.isValid, asic_tcpudp.isDedicated,
+				asic_tcpudp.isCollision,
+				asic_tcpudp.isCollision2, asic_tcpudp.isStatic,
+				asic_tcpudp.isTcp);
+
+			seq_printf(s,
+				"   age(%d) offset(%d) tcpflag(%d) SelEIdx(%d) SelIPIdx(%d) priValid:%d pri(%d)\n",
+				asic_tcpudp.ageSec, asic_tcpudp.offset << 10,
+				asic_tcpudp.tcpFlag, asic_tcpudp.selEIdx,
+				asic_tcpudp.selExtIPIdx, asic_tcpudp.priValid,
+				asic_tcpudp.priority);
+
+#if defined(CONFIG_RTL_8197F)
+			seq_printf(s, "   NHIDXValid(%d) NHIDX(%d)\n",
+				asic_tcpudp.NHIDXValid, asic_tcpudp.NHIDX);
+#endif
+			entry++;
+		}
+	}
+	seq_printf(s, "Total entry: %d\n", entry);
+
+	return 0;
+}
+
+int napt_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, napt_show, NULL));
+}
+
+struct file_operations napt_single_seq_file_operations = {
+	.open = napt_single_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+#if defined(CONFIG_RTL_LAYERED_DRIVER_L4)
+extern int32 rtl865x_sw_napt_seq_read(struct seq_file *s, void *v);
+extern int32 rtl865x_sw_napt_seq_write(struct file *filp, const char *buff,
+	unsigned long len, loff_t *off);
+
+int sw_napt_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_sw_napt_seq_read, NULL));
+}
+
+static ssize_t sw_napt_proc_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return rtl865x_sw_napt_seq_write(file, userbuf, count, off);
+}
+
+struct file_operations sw_napt_single_seq_file_operations = {
+	.open = sw_napt_single_open,
+	.write = sw_napt_proc_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 port_bandwidth_read(struct seq_file *s, void *v)
+{
+	uint32 regData;
+	uint32 data0, data1;
+	int port;
+
+#if defined(CONFIG_RTL_8197F)
+	uint32 regData2;
+	uint32 pBandwidth_high;
+#endif
+
+	seq_printf(s, "Dump Port Bandwidth Info:\n");
+
+	for (port = 0; port <= CPU; port++) {
+		regData = READ_MEM32(IBCR0 + ((port >> 1) << 2));
+		if (port & 1) {
+			data0 = (regData & IBWC_ODDPORT_MASK) >>
+				IBWC_ODDPORT_OFFSET;
+		} else {
+			data0 = (regData & IBWC_EVENPORT_MASK) >>
+				IBWC_EVENPORT_OFFSET;
+		}
+
+		regData = READ_MEM32(WFQRCRP0 + ((port * 3) << 2));
+		data1 = (regData & APR_MASK) >> APR_OFFSET;
+
+#if defined(CONFIG_RTL_8197F)
+		regData2 = READ_MEM32(IBCR3);
+		pBandwidth_high =
+			(regData2 & (IBCR3_PORT_MASK <<
+				IBCR3_PORT_OFFSET(port))) >>
+			IBCR3_PORT_OFFSET(port);
+		data0 = (pBandwidth_high << IBCR3_HIGH_OFFSET) | data0;
+
+		if (data0) {
+			seq_printf(s, "Port%d Ingress:[%d.%03dMbps]	", port,
+				(data0 << 10) / 1000000,
+				((data0 << 10) % 1000000) / 1000);
+		} else {
+			seq_printf(s, "Port%d Ingress:FullSpeed	", port);
+		}
+
+		if (data1 != (APR_MASK >> APR_OFFSET)) {
+			data1++;
+			seq_printf(s, "Engress:[%d.%03dMbps]\n",
+				(data1 << 10) / 1000000,
+				((data1 << 10) % 1000000) / 1000);
+		} else {
+			seq_printf(s, "Egress:FullSpeed\n");
+		}
+#else
+		data0++;
+		if (data0) {
+			if (data0 < 64)
+				seq_printf(s, "Port%d Ingress:[%dKbps]	", port,
+					(data0 << 4) / 1000);
+			else
+				seq_printf(s,
+					"Port%d Ingress:[%d.%03dMbps]	",
+					port, (data0 << 14) / 1000000,
+					((data0 << 14) % 1000000) / 1000);
+		} else {
+			seq_printf(s, "Port%d Ingress:FullSpeed	", port);
+		}
+
+		if (data1 != (APR_MASK >> APR_OFFSET)) {
+			data1++;
+
+			if (data1 < 16)
+				seq_printf(s, "Engress:[%dKbps]\n",
+					(data1 << 16) / 1000);
+			else
+				seq_printf(s, "Engress:[%d.%03dMbps]\n",
+					(data1 << 16) / 1000000,
+					((data1 << 16) % 1000000) / 1000);
+
+		} else
+			seq_printf(s, "Egress:FullSpeed\n");
+#endif
+	}
+
+	return 0;
+}
+#else
+static int32 port_bandwidth_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	uint32 regData;
+	uint32 data0, data1;
+	int port;
+
+#if defined(CONFIG_RTL_8197F)
+	uint32 regData2;
+	uint32 pBandwidth_high;
+#endif
+
+	len = sprintf(page, "Dump Port Bandwidth Info:\n");
+
+	for (port = 0; port <= CPU; port++) {
+		regData = READ_MEM32(IBCR0 + ((port >> 1) << 2));
+		if (port & 1) {
+			data0 = (regData & IBWC_ODDPORT_MASK) >>
+				IBWC_ODDPORT_OFFSET;
+		} else {
+			data0 = (regData & IBWC_EVENPORT_MASK) >>
+				IBWC_EVENPORT_OFFSET;
+		}
+
+		regData = READ_MEM32(WFQRCRP0 + ((port * 3) << 2));
+		data1 = (regData & APR_MASK) >> APR_OFFSET;
+
+#if defined(CONFIG_RTL_8197F)
+		regData2 = READ_MEM32(IBCR3);
+		pBandwidth_high =
+			(regData2 & (IBCR3_PORT_MASK <<
+				IBCR3_PORT_OFFSET(port))) >>
+			IBCR3_PORT_OFFSET(port);
+		data0 = (pBandwidth_high << IBCR3_HIGH_OFFSET) | data0;
+
+		if (data0) {
+			len += sprintf(page + len,
+				"Port%d Ingress:[%d.%03dMbps]	", port,
+				(data0 << 10) / 1000000,
+				((data0 << 10) % 1000000) / 1000);
+		} else {
+			len += sprintf(page + len,
+				"Port%d Ingress:FullSpeed	", port);
+		}
+
+		if (data1 != (APR_MASK >> APR_OFFSET)) {
+			data1++;
+			len += sprintf(page + len, "Engress:[%d.%03dMbps]\n",
+				(data1 << 10) / 1000000,
+				((data1 << 10) % 1000000) / 1000);
+		} else {
+			len += sprintf(page + len, "Egress:FullSpeed\n");
+		}
+#else
+		data0++;
+		if (data0) {
+			if (data0 < 64)
+				len += sprintf(page + len,
+					"Port%d Ingress:[%dKbps]	", port,
+					(data0 << 4) / 1000);
+			else
+				len += sprintf(page + len,
+					"Port%d Ingress:[%d.%03dMbps]	",
+					port, (data0 << 14) / 1000000,
+					((data0 << 14) % 1000000) / 1000);
+		} else {
+			len += sprintf(page + len,
+				"Port%d Ingress:FullSpeed	", port);
+		}
+
+		if (data1 != (APR_MASK >> APR_OFFSET)) {
+			data1++;
+
+			if (data1 < 16)
+				len += sprintf(page + len, "Engress:[%dKbps]\n",
+					(data1 << 16) / 1000);
+			else
+				len += sprintf(page + len,
+					"Engress:[%d.%03dMbps]\n",
+					(data1 << 16) / 1000000,
+					((data1 << 16) % 1000000) / 1000);
+
+		} else
+			len += sprintf(page + len, "Egress:FullSpeed\n");
+#endif
+	}
+
+	return len;
+}
+#endif
+
+static int32 port_bandwidth_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 queue_bandwidth_read(struct seq_file *s, void *v)
+{
+	uint32 regData;
+	uint32 data0, data1;
+	int port, queue;
+
+	if (queue_bandwidth_record_portmask == 0) {
+		seq_printf(s, "Please set the dump mask firstly.\n");
+		return 0;
+	}
+	seq_printf(s, "Dump Queue Bandwidth Info:\n");
+
+	for (port = PHY0; port <= CPU; port++) {
+		if ((queue_bandwidth_record_portmask & (1 << port)) == 0)
+			continue;
+
+		regData = READ_MEM32(QNUMCR);
+		data0 = (regData >> (port * 3)) & 7;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		seq_printf(s, "Port%d Queue number:	%d\n", port, data0 + 1);
+#else
+		seq_printf(s, "Port%d Queue number:	%d\n", port, data0);
+#endif
+		for (queue = QUEUE0; queue <= QUEUE5; queue++) {
+			rtl8651_getAsicQueueFlowControlConfigureRegister(port,
+				queue, &data0);
+			seq_printf(s, "	==>Queue%d FC %s | ", queue,
+				data0 ? "Enabled" : "Disabled");
+
+			rtl8651_getAsicQueueWeight(port, queue, &data0, &data1);
+			if (data0 == STR_PRIO) {
+				seq_printf(s, "Type: STR\n");
+			} else {
+				seq_printf(s, "Type: WFQ [weight:%d]\n",
+					data1 + 1);
+			}
+
+			regData =
+				READ_MEM32(P0Q0RGCR + (queue << 2) +
+				((port * 6) << 2));
+			data1 = (regData & L1_MASK) >> L1_OFFSET;
+
+			if (data1 == (L1_MASK >> L1_OFFSET)) {
+				seq_printf(s, "	    BurstSize UnLimit | ");
+			} else {
+				seq_printf(s, "	    BurstSize[%dKbps] | ",
+					data1);
+			}
+
+			data0 = (regData & APR_MASK) >> APR_OFFSET;
+			data1 = (regData & PPR_MASK) >> PPR_OFFSET;
+			if (data0 != (APR_MASK >> APR_OFFSET)) {
+				data0++;
+				if (data0 < 16)
+					seq_printf(s,
+						"Engress: avgRate[%dKbps], peakRate[%d]\n",
+						data0 << 6, 1 << data1);
+				else
+					seq_printf(s,
+						"Engress: avgRate[%d.%3dMbps], peakRate[%d]\n",
+						data0 >> 4, (data0 & 0xf) << 6,
+						1 << data1);
+
+			} else
+				seq_printf(s,
+					"Egress: avgRate & peakRateFullSpeed\n");
+
+		}
+	}
+
+	return 0;
+}
+#else
+static int32 queue_bandwidth_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	uint32 regData;
+	uint32 data0, data1;
+	int port, queue;
+
+	if (queue_bandwidth_record_portmask == 0) {
+		len = sprintf(page, "Please set the dump mask firstly.\n");
+		return len;
+	}
+	len = sprintf(page, "Dump Queue Bandwidth Info:\n");
+
+	for (port = PHY0; port <= CPU; port++) {
+		if ((queue_bandwidth_record_portmask & (1 << port)) == 0)
+			continue;
+
+		regData = READ_MEM32(QNUMCR);
+		data0 = (regData >> (port * 3)) & 7;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		len += sprintf(page + len, "Port%d Queue number:	%d\n",
+			port, data0 + 1);
+#else
+		len += sprintf(page + len, "Port%d Queue number:	%d\n",
+			port, data0);
+#endif
+		for (queue = QUEUE0; queue <= QUEUE5; queue++) {
+			rtl8651_getAsicQueueFlowControlConfigureRegister(port,
+				queue, &data0);
+			len += sprintf(page + len, "	==>Queue%d FC %s | ",
+				queue, data0 ? "Enabled" : "Disabled");
+
+			rtl8651_getAsicQueueWeight(port, queue, &data0, &data1);
+			if (data0 == STR_PRIO) {
+				len += sprintf(page + len, "Type: STR\n");
+			} else {
+				len += sprintf(page + len,
+					"Type: WFQ [weight:%d]\n", data1 + 1);
+			}
+
+			regData =
+				READ_MEM32(P0Q0RGCR + (queue << 2) +
+				((port * 6) << 2));
+			data1 = (regData & L1_MASK) >> L1_OFFSET;
+
+			if (data1 == (L1_MASK >> L1_OFFSET)) {
+				len += sprintf(page + len,
+					"	    BurstSize UnLimit | ");
+			} else {
+				len += sprintf(page + len,
+					"	    BurstSize[%dKbps] | ",
+					data1);
+			}
+
+			data0 = (regData & APR_MASK) >> APR_OFFSET;
+			data1 = (regData & PPR_MASK) >> PPR_OFFSET;
+			if (data0 != (APR_MASK >> APR_OFFSET)) {
+				data0++;
+				if (data0 < 16)
+					len += sprintf(page + len,
+						"Engress: avgRate[%dKbps], peakRate[%d]\n",
+						data0 << 6, 1 << data1);
+				else
+					len += sprintf(page + len,
+						"Engress: avgRate[%d.%3dMbps], peakRate[%d]\n",
+						data0 >> 4, (data0 & 0xf) << 6,
+						1 << data1);
+
+			} else
+				len += sprintf(page + len,
+					"Egress: avgRate & peakRateFullSpeed\n");
+
+		}
+	}
+
+	return len;
+}
+#endif
+
+static int32 queue_bandwidth_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[16], *tokptr, *strptr;
+	int port;
+
+	if (len > 16) {
+		goto errout;
+	}
+
+	memset(tmpbuf, 0, 16);
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		strptr = tmpbuf;
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			return len;
+		}
+		queue_bandwidth_record_portmask =
+			(uint32)simple_strtol(tokptr, NULL, 0);
+
+		rtlglue_printf("Dump info of: ");
+		for (port = PHY0; port <= CPU; port++) {
+			if ((1 << port) & queue_bandwidth_record_portmask)
+				rtlglue_printf("port%d ", port);
+		}
+		rtlglue_printf("\n");
+	} else {
+errout:
+		rtlglue_printf("error input\n");
+	}
+
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 priority_decision_read(struct seq_file *s, void *v)
+{
+	uint32 regData;
+	int queue;
+
+	seq_printf(s, "Dump Priority Infor:\n");
+
+	regData = READ_MEM32(QIDDPCR);
+
+	seq_printf(s, "NAPT[%d] ACL[%d] DSCP[%d] 8021Q[%d] PortBase[%d]\n",
+		(regData & NAPT_PRI_MASK) >> NAPT_PRI_OFFSET,
+		(regData & ACL_PRI_MASK) >> ACL_PRI_OFFSET,
+		(regData & DSCP_PRI_MASK) >> DSCP_PRI_OFFSET,
+		(regData & BP8021Q_PRI_MASK) >> BP8021Q_PRI_OFFSET,
+		(regData & PBP_PRI_MASK) >> PBP_PRI_OFFSET);
+
+	for (queue = 0; queue < RTL8651_OUTPUTQUEUE_SIZE; queue++) {
+		if (queue < 6) {
+			regData = READ_MEM32(UPTCMCR0 + (queue << 2));
+			seq_printf(s, "Queue number %d:\n", (queue + 1));
+			seq_printf(s,
+				"Piority[0~7] Mapping to Queue[ %d %d %d %d %d %d %d %d ]\n",
+				regData & 0x7, (regData >> 3) & 0x7,
+				(regData >> 6) & 0x7, (regData >> 9) & 0x7,
+				(regData >> 12) & 0x7, (regData >> 15) & 0x7,
+				(regData >> 18) & 0x7, (regData >> 21) & 0x7);
+		} else {
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			regData = READ_MEM32(UPTCMCR6 + ((queue - 6) << 2));
+			seq_printf(s, "Queue number %d:\n", (queue + 1));
+			seq_printf(s,
+				"Piority[0~7] Mapping to Queue[ %d %d %d %d %d %d %d %d ]\n",
+				regData & 0x7, (regData >> 3) & 0x7,
+				(regData >> 6) & 0x7, (regData >> 9) & 0x7,
+				(regData >> 12) & 0x7, (regData >> 15) & 0x7,
+				(regData >> 18) & 0x7, (regData >> 21) & 0x7);
+#endif
+		}
+	}
+
+	return 0;
+}
+#else
+static int32 priority_decision_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	uint32 regData;
+	int queue;
+
+	len = sprintf(page, "Dump Priority Infor:\n");
+
+	regData = READ_MEM32(QIDDPCR);
+
+	len += sprintf(page + len,
+		"NAPT[%d] ACL[%d] DSCP[%d] 8021Q[%d] PortBase[%d]\n",
+		(regData & NAPT_PRI_MASK) >> NAPT_PRI_OFFSET,
+		(regData & ACL_PRI_MASK) >> ACL_PRI_OFFSET,
+		(regData & DSCP_PRI_MASK) >> DSCP_PRI_OFFSET,
+		(regData & BP8021Q_PRI_MASK) >> BP8021Q_PRI_OFFSET,
+		(regData & PBP_PRI_MASK) >> PBP_PRI_OFFSET);
+
+	for (queue = 0; queue < RTL8651_OUTPUTQUEUE_SIZE; queue++) {
+		regData = READ_MEM32(UPTCMCR0 + (queue << 2));
+		len += sprintf(page + len, "Queue number %d:\n", (queue + 1));
+		len += sprintf(page + len,
+			"Piority[0~7] Mapping to Queue[ %d %d %d %d %d %d %d %d ]\n",
+			regData & 0x7, (regData >> 3) & 0x7,
+			(regData >> 6) & 0x7, (regData >> 9) & 0x7,
+			(regData >> 12) & 0x7, (regData >> 15) & 0x7,
+			(regData >> 18) & 0x7, (regData >> 21) & 0x7);
+	}
+
+	return len;
+}
+#endif
+
+static int32 priority_decision_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+#if defined(CONFIG_RTL_ENABLE_RATELIMIT_TABLE)
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rate_limit_read(struct seq_file *s, void *v)
+{
+	rtl865x_tblAsicDrv_rateLimitParam_t asic_rl;
+	uint32 entry;
+
+	seq_printf(s, "Dump rate limit table:\n");
+	for (entry = 0; entry < RTL8651_RATELIMITTBL_SIZE; entry++) {
+		if (rtl8651_getAsicRateLimitTable(entry, &asic_rl) == SUCCESS) {
+			seq_printf(s,
+				" [%d]  Token(%u)  MaxToken(%u)  remainTime Unit(%u)  \n\trefillTimeUnit(%u)  refillToken(%u)\n",
+				entry, asic_rl.token, asic_rl.maxToken,
+				asic_rl.t_remainUnit, asic_rl.t_intervalUnit,
+				asic_rl.refill_number);
+		} else
+			seq_printf(s, " [%d]  Invalid entry\n", entry);
+	}
+	seq_printf(s, "\n");
+
+	return 0;
+}
+#else
+static int32 rate_limit_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	rtl865x_tblAsicDrv_rateLimitParam_t asic_rl;
+	uint32 entry;
+
+	len = sprintf(page, "Dump rate limit table:\n");
+	for (entry = 0; entry < RTL8651_RATELIMITTBL_SIZE; entry++) {
+		if (rtl8651_getAsicRateLimitTable(entry, &asic_rl) == SUCCESS) {
+			len += sprintf(page + len,
+				" [%d]  Token(%u)  MaxToken(%u)  remainTime Unit(%u)  \n\trefillTimeUnit(%u)  refillToken(%u)\n",
+				entry, asic_rl.token, asic_rl.maxToken,
+				asic_rl.t_remainUnit, asic_rl.t_intervalUnit,
+				asic_rl.refill_number);
+		} else
+			len += sprintf(page + len, " [%d]  Invalid entry\n",
+				entry);
+	}
+	len += sprintf(page + len, "\n");
+
+	return len;
+}
+#endif
+
+static int32 rate_limit_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 storm_read(struct seq_file *s, void *v)
+{
+	uint32 regData;
+	uint32 port;
+	uint32 totalExtPortNum = 3;
+
+	seq_printf(s, "Dump storm control info:\n");
+
+	regData = READ_MEM32(BSCR);
+	seq_printf(s, "rate(%d)\n", regData * 100 / 30360);
+
+	for (port = 0; port < RTL8651_PORT_NUMBER + totalExtPortNum; port++) {
+		regData = READ_MEM32(PCRP0 + port * 4);
+		seq_printf(s, "port%d, %s BCSC, %s BC, %s MC\n", port,
+			regData & ENBCSC ? "enable" : "disable",
+			regData & BCSC_ENBROADCAST ? "enable" : "disable",
+			regData & BCSC_ENMULTICAST ? "enable" : "disable");
+	}
+	return 0;
+}
+#else
+static int32 storm_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	uint32 regData;
+	uint32 port;
+	uint32 totalExtPortNum = 3;
+
+	len = sprintf(page, "Dump storm control info:\n");
+
+	regData = READ_MEM32(BSCR);
+	len += sprintf(page + len, "rate(%d)\n", regData * 100 / 30360);
+
+	for (port = 0; port < RTL8651_PORT_NUMBER + totalExtPortNum; port++) {
+		regData = READ_MEM32(PCRP0 + port * 4);
+		len += sprintf(page + len, "port%d, %s BCSC, %s BC, %s MC\n",
+			port, regData & ENBCSC ? "enable" : "disable",
+			regData & BCSC_ENBROADCAST ? "enable" : "disable",
+			regData & BCSC_ENMULTICAST ? "enable" : "disable");
+	}
+
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int32 storm_write(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	uint32 tmpBuf[32];
+	uint32 stormCtrlType = 0x3;	/* mc & bc */
+	uint32 enableStormCtrl = FALSE;
+	uint32 percentage = 0;
+	uint32 uintVal;
+
+	if (count > 32) {
+		goto errout;
+	}
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		tmpBuf[count - 1] = 0;
+		uintVal = simple_strtoul((char *)tmpBuf, NULL, 0);
+		rtlglue_printf("%s(%d) uintval(%u) \n", __FUNCTION__, __LINE__, uintVal);	/* Added for test */
+		if (uintVal > 100) {
+			enableStormCtrl = FALSE;
+			percentage = 0;
+		} else {
+			enableStormCtrl = TRUE;
+			percentage = uintVal;
+		}
+		/* printk("%s(%d),enableStormCtrl=%d,percentage=%d\n",__FUNCTION__,__LINE__, */
+		/* enableStormCtrl,percentage);//Added for test */
+		rtl865x_setStormControl(stormCtrlType, enableStormCtrl,
+			percentage);
+		return count;
+	} else {
+errout:
+		rtlglue_printf("error input\n");
+	}
+	return -EFAULT;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+/* the following proc default established */
+#ifdef CONFIG_RTL_819X_SWCORE
+extern int cnt_swcore;
+extern int cnt_swcore_tx;
+extern int cnt_swcore_rx;
+extern int cnt_swcore_link;
+extern int cnt_swcore_err;
+#endif
+#if defined(CONFIG_RTL_8197F) &&  defined(CONFIG_FINETUNE_RUNOUT_IRQ)
+extern int freeSkbThreshold;
+#endif
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+extern int get_buf_in_poll(void);
+extern int get_buf_in_rx_skb_queue(void);
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+#if defined(CONFIG_RTD_1295_HWNAT)
+extern atomic_t rtl_rxTxDoneCnt;
+extern atomic_t rtl_devOpened;
+extern int rtl_rx_tasklet_running;
+extern int rtl_tx_tasklet_running;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+static int32 stats_debug_entry_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "  Debug Statistics Info:\n");
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+	seq_printf(s, "    eth_skb_free_num:	%d (pool %d, rtk_que %d)\n",
+		get_buf_in_poll() + get_buf_in_rx_skb_queue(),
+		get_buf_in_poll(), get_buf_in_rx_skb_queue());
+#endif
+	seq_printf(s, "    rx_noBuffer_cnt:	%u\n", rx_noBuffer_cnt);
+	seq_printf(s, "    tx_ringFull_cnt:	%u\n", tx_ringFull_cnt);
+	seq_printf(s, "    tx_drop_cnt:	%u\n", tx_drop_cnt);
+
+	seq_printf(s, "    statistic_total:	%d\n", statistic_total);
+	seq_printf(s, "    statistic_ps:	%d\n", statistic_ps);
+	seq_printf(s, "    statistic_ipv6_fp:	%d\n", statistic_ipv6_fp);
+#if defined(CONFIG_OPENWRT_SDK)
+	seq_printf(s, "    statistic_fastpath:	%d\n", statistic_fastpath);
+#else
+	seq_printf(s, "    statistic_fp:	%d\n", statistic_fp);
+#endif
+
+#ifdef CONFIG_RTL_819X_SWCORE
+	seq_printf(s, "    cnt_swcore:	%d\n", cnt_swcore);
+	seq_printf(s, "    cnt_swcore_tx:	%d\n", cnt_swcore_tx);
+	seq_printf(s, "    cnt_swcore_rx:	%d\n", cnt_swcore_rx);
+	seq_printf(s, "    cnt_swcore_link:	%d\n", cnt_swcore_link);
+	seq_printf(s, "    cnt_swcore_err:	%d\n", cnt_swcore_err);
+
+#endif
+
+#ifdef CONFIG_RTL_ADAPTABLE_TSO
+	seq_printf(s, "    TSO:		%s\n",
+		(tso_feature & (NETIF_F_TSO | NETIF_F_TSO_ECN)) ? "ON" : "OFF");
+#endif
+
+#if defined(CONFIG_RTL_8197F) &&  defined(CONFIG_FINETUNE_RUNOUT_IRQ)
+	if (REG32(CPUIIMR) & (PKTHDR_DESC_RUNOUT_IP_ALL |
+			MBUF_DESC_RUNOUT_IP_ALL)) {
+		seq_printf(s, "    runOutIrq:	enable\n");
+	} else {
+		seq_printf(s, "    runOutIrq:	disable\n");
+	}
+	seq_printf(s, "    freeSkbThreshold:	%d\n", freeSkbThreshold);
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+	seq_printf(s, "    rtl_rxTxDoneCnt:	%d\n",
+		atomic_read(&rtl_rxTxDoneCnt));
+	seq_printf(s, "    rtl_devOpened:	%d\n",
+		atomic_read(&rtl_devOpened));
+	seq_printf(s, "    rtl_rx_tasklet_running:	%d\n",
+		rtl_rx_tasklet_running);
+	seq_printf(s, "    rtl_tx_tasklet_running:	%d\n",
+		rtl_tx_tasklet_running);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	return 0;
+}
+#else
+static int32 stats_debug_entry_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+
+	len = sprintf(page, "  Debug Statistics Info:\n");
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+	len += sprintf(page + len,
+		"    eth_skb_free_num:	%d (pool %d, rtk_que %d)\n",
+		get_buf_in_poll() + get_buf_in_rx_skb_queue(),
+		get_buf_in_poll(), get_buf_in_rx_skb_queue());
+#endif
+	len += sprintf(page + len, "    rx_noBuffer_cnt:	%u\n",
+		rx_noBuffer_cnt);
+	len += sprintf(page + len, "    tx_ringFull_cnt:	%u\n",
+		tx_ringFull_cnt);
+	len += sprintf(page + len, "    tx_drop_cnt:	%u\n", tx_drop_cnt);
+
+	len += sprintf(page + len, "    statistic_total:	%d\n",
+		statistic_total);
+	len += sprintf(page + len, "    statistic_ps:	%d\n", statistic_ps);
+	len += sprintf(page + len, "    statistic_ipv6_fp:	%d\n",
+		statistic_ipv6_fp);
+#if defined(CONFIG_OPENWRT_SDK)
+	len += sprintf(page + len, "    statistic_fastpath:	%d\n",
+		statistic_fastpath);
+#else
+	len += sprintf(page + len, "    statistic_fp:	%d\n", statistic_fp);
+#endif
+#ifdef CONFIG_RTL_819X_SWCORE
+	len += sprintf(page + len, "	  cnt_swcore:	%d\n", cnt_swcore);
+	len += sprintf(page + len, "	  cnt_swcore_tx:	%d\n",
+		cnt_swcore_tx);
+	len += sprintf(page + len, "	  cnt_swcore_rx:	%d\n",
+		cnt_swcore_rx);
+	len += sprintf(page + len, "	  cnt_swcore_link:	%d\n",
+		cnt_swcore_link);
+	len += sprintf(page + len, "	  cnt_swcore_err:	%d\n",
+		cnt_swcore_err);
+#endif
+
+	return len;
+
+}
+#endif
+/*echo clear > /proc/rtl865x/stats to clear the count of tx&rx no buffer count*/
+static int32 stats_debug_entry_write(struct file *file, const char *buffer,
+	unsigned long len, void *data)
+{
+	char tmpBuf[32];
+	char *strptr;
+	char *cmd_addr;
+	char *tokptr;
+
+#ifdef CONFIG_RTL_ROMEPERF_24K
+	char tmpBufperf[32];
+	int i, j;
+#endif
+
+	if (len > 32) {
+		goto errout;
+	}
+	if (buffer && !copy_from_user(tmpBuf, buffer, len)) {
+
+		tmpBuf[len] = '\0';
+
+#ifdef CONFIG_RTL_ROMEPERF_24K
+		for (j = 0; j <= len; j++) {
+			tmpBufperf[j] = tmpBuf[j];
+		}
+#endif
+
+		strptr = tmpBuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+
+		if (strncmp(cmd_addr, "clear", 5) == 0) {
+			rx_noBuffer_cnt = 0;
+			tx_ringFull_cnt = 0;
+			tx_drop_cnt = 0;
+
+			statistic_total = 0;
+			statistic_ps = 0;
+			statistic_ipv6_fp = 0;
+#if defined(CONFIG_OPENWRT_SDK)
+			statistic_fastpath = 0;
+#else
+			statistic_fp = 0;
+#endif
+
+#ifdef CONFIG_RTL_ROMEPERF_24K
+			cp3Value[0] = 0;
+			cp3Count[0] = 0;
+			memset(&cp3romePerfStat, 0, sizeof(cp3romePerfStat));
+			memset(&avrgCycle, 0, sizeof(avrgCycle));
+#endif
+#ifdef CONFIG_RTL_819X_SWCORE
+			cnt_swcore = 0;
+			cnt_swcore_tx = 0;
+			cnt_swcore_rx = 0;
+			cnt_swcore_link = 0;
+			cnt_swcore_err = 0;
+#endif
+
+		} else if (strncmp(cmd_addr, "debug", 5) == 0) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr)
+				_debug_flag = simple_strtoul(tokptr, NULL, 16);
+
+			rtlglue_printf("_debug_flag= 0x%x\n", _debug_flag);
+		}
+#if defined(CONFIG_RTL_8197F) &&  defined(CONFIG_FINETUNE_RUNOUT_IRQ)
+		else if (strncmp(cmd_addr, "freeSkbThreshold", 16) == 0) {
+
+			tokptr = strsep(&strptr, " ");
+
+			if (tokptr)
+				freeSkbThreshold =
+					simple_strtoul(tokptr, NULL, 0);
+			else
+				return -1;
+
+			rtlglue_printf("freeSkbThreshold= %d\n",
+				freeSkbThreshold);
+
+		}
+#endif
+#ifdef CONFIG_RTL_ROMEPERF_24K
+		else {
+
+			int start, end, num;
+			char cmd[10];
+
+			num = sscanf(tmpBufperf, "%s %d %d", cmd, &start, &end);
+
+			if (strncmp(cmd, "dump", 4) != 0) {
+				printk("invalid romeperf command!\n");
+				return -1;
+			}
+
+			if (num != 3) {
+				printk("invalid romeperf parameter!\n");
+				return -1;
+			}
+
+			if ((start < 0) || (start >= CP3ROMEPERF_INDEX_MAX)
+				|| (end < 0) || (end >= CP3ROMEPERF_INDEX_MAX)
+				|| (start > end)) {
+				printk("Bad index!\n");
+				return -1;
+			}
+
+			for (i = start; i <= end; i++) {
+				avrgCycle[i] =
+					div64_u64(cp3romePerfStat[i].accCycle[0],
+					cp3romePerfStat[i].executedNum);
+
+				if (cp3romePerfStat[i].executedNum == 0)
+					avrgCycle[i] = 0;
+
+				printk("index[%d] accCycle[0]=%llu executedNum=%llu average=%llu\n", i, cp3romePerfStat[i].accCycle[0], cp3romePerfStat[i].executedNum, avrgCycle[i]);
+
+				avrgCycle[i] =
+					div64_u64(cp3romePerfStat[i].accCycle[1],
+					cp3romePerfStat[i].executedNum);
+
+				if (cp3romePerfStat[i].executedNum == 0)
+					avrgCycle[i] = 0;
+
+				printk("index[%d] accCycle[1]=%llu executedNum=%llu average=%llu\n", i, cp3romePerfStat[i].accCycle[1], cp3romePerfStat[i].executedNum, avrgCycle[i]);
+			}
+
+		}
+#endif /* end CONFIG_RTL_ROMEPERF_24K */
+
+	} else {
+errout:
+		rtlglue_printf("error input\n");
+	}
+	return len;
+}
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB_DEBUG)
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rtl819x_proc_privSkbInfo_read(struct seq_file *s, void *v)
+{
+	int cpu_queue_cnt, rxRing_cnt, txRing_cnt, wlan_txRing_cnt,
+		wlan_txRing_cnt1, mbuf_pending_cnt;
+	int rx_skb_queue_cnt, poll_buf_cnt;
+	unsigned long flags = 0;
+
+	seq_printf(s, "original eth private buf total(%d)\n", MAX_ETH_SKB_NUM);
+
+	SMP_LOCK_ETH(flags);
+	mbuf_pending_cnt = get_mbuf_pending_times();
+	cpu_queue_cnt = get_cpu_completion_queue_num();
+	rxRing_cnt = get_nic_rxRing_buf();
+	txRing_cnt = get_nic_txRing_buf();
+#if defined(CONFIG_RTL8192CD)
+	wlan_txRing_cnt = get_nic_buf_in_wireless_tx("wlan0");
+	wlan_txRing_cnt1 = get_nic_buf_in_wireless_tx("wlan1");
+#else
+	wlan_txRing_cnt = 0;
+	wlan_txRing_cnt1 = 0;
+#endif
+	rx_skb_queue_cnt = get_buf_in_rx_skb_queue();
+	poll_buf_cnt = get_buf_in_poll();
+	SMP_UNLOCK_ETH(flags);
+
+	seq_printf(s,
+		"cpu completion cnt(%d)\nnic rxring cnt(%d)\nnic txring cnt(%d)\nwlan0 txring cnt(%d)\nwlan1 txring cnt(%d)\nrx skb queue cnt(%d)\npool buf cnt(%d)\nmbuf pending times(%d)\nsum(%d)\n",
+		cpu_queue_cnt, rxRing_cnt, txRing_cnt, wlan_txRing_cnt,
+		wlan_txRing_cnt1, rx_skb_queue_cnt, poll_buf_cnt,
+		mbuf_pending_cnt,
+		cpu_queue_cnt + rxRing_cnt + txRing_cnt + wlan_txRing_cnt +
+		wlan_txRing_cnt1 + rx_skb_queue_cnt + poll_buf_cnt);
+
+	return 0;
+}
+#else
+static int32 rtl819x_proc_privSkbInfo_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	int cpu_queue_cnt, rxRing_cnt, txRing_cnt, wlan_txRing_cnt,
+		wlan_txRing_cnt1, mbuf_pending_cnt;
+	int rx_skb_queue_cnt, poll_buf_cnt;
+	unsigned long flags = 0;
+
+	len = sprintf(page, "original eth private buf total(%d)\n",
+		MAX_ETH_SKB_NUM);
+
+	SMP_LOCK_ETH(flags);
+	mbuf_pending_cnt = get_mbuf_pending_times();
+	cpu_queue_cnt = get_cpu_completion_queue_num();
+	rxRing_cnt = get_nic_rxRing_buf();
+	txRing_cnt = get_nic_txRing_buf();
+#if defined(CONFIG_RTL8192CD)
+	wlan_txRing_cnt = get_nic_buf_in_wireless_tx("wlan0");
+	wlan_txRing_cnt1 = get_nic_buf_in_wireless_tx("wlan1");
+#else
+	wlan_txRing_cnt = 0;
+	wlan_txRing_cnt1 = 0;
+#endif
+	rx_skb_queue_cnt = get_buf_in_rx_skb_queue();
+	poll_buf_cnt = get_buf_in_poll();
+	SMP_UNLOCK_ETH(flags);
+
+	len += sprintf(page + len,
+		"cpu completion cnt(%d)\nnic rxring cnt(%d)\nnic txring cnt(%d)\nwlan0 txring cnt(%d)\nwlan1 txring cnt(%d)\nrx skb queue cnt(%d)\npool buf cnt(%d)\nmbuf pending times(%d)\nsum(%d)\n",
+		cpu_queue_cnt, rxRing_cnt, txRing_cnt, wlan_txRing_cnt,
+		wlan_txRing_cnt1, rx_skb_queue_cnt, poll_buf_cnt,
+		mbuf_pending_cnt,
+		cpu_queue_cnt + rxRing_cnt + txRing_cnt + wlan_txRing_cnt +
+		wlan_txRing_cnt1 + rx_skb_queue_cnt + poll_buf_cnt);
+
+	return len;
+}
+#endif
+
+static int32 rtl819x_proc_privSkbInfo_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+#else
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rtl819x_proc_privSkbInfo_read(struct seq_file *s, void *v)
+{
+	return PROC_READ_RETURN_VALUE;
+}
+#else
+static int32 rtl819x_proc_privSkbInfo_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	return PROC_READ_RETURN_VALUE;
+}
+#endif
+
+static int32 rtl819x_proc_privSkbInfo_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+#if 0
+	char tmpbuf[32];
+
+	if (len > 32) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len - 1] = '\0';
+		if (tmpbuf[0] == '1') {
+			rtl_dumpIndexs();
+		}
+	} else {
+errout:
+		rtlglue_printf("error input\n");
+	}
+#endif
+	return len;
+}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 diagnostic_read(struct seq_file *s, void *v)
+{
+	uint32 regData, regData1;
+	int port, regIdx;
+	uint32 mask, offset;
+
+	seq_printf(s, "Diagnostic Register Info:\n");
+
+	regData = READ_MEM32(GDSR0);
+	seq_printf(s, "MaxUsedDescriptor: %d CurUsed Descriptor: %d\n",
+		(regData & MaxUsedDsc_MASK) >> MaxUsedDsc_OFFSET,
+		(regData & USEDDSC_MASK) >> USEDDSC_OFFSET);
+	seq_printf(s, "DescRunOut: %s TotalDescFC: %s ShareBufFC: %s\n",
+		(regData & DSCRUNOUT) ? "YES" : "NO",
+		(regData & TotalDscFctrl_Flag) ? "YES" : "NO",
+		(regData & SharedBufFCON_Flag) ? "YES" : "NO");
+
+	for (regIdx = 0; regIdx < 2; regIdx++) {
+		regData = READ_MEM32(PCSR0 + (regIdx << 2));
+
+		for (port = 0; port < 4; port++) {
+			switch (port) {
+			case 0:
+				mask = P0OQCgst_MASK;
+				offset = P0OQCgst_OFFSET;
+				break;
+			case 1:
+				mask = P1OQCgst_MASK;
+				offset = P1OQCgst_OFFSET;
+				break;
+			case 2:
+				mask = P2OQCgst_MASK;
+				offset = P2OQCgst_OFFSET;
+				break;
+			default:
+				mask = P3OQCgst_MASK;
+				offset = P3OQCgst_OFFSET;
+				break;
+			}
+			regData1 = (regData & mask) >> offset;
+			if (regData1 == 0)
+				seq_printf(s, "Port%d not congestion\n",
+					port + (regIdx << 2));
+			else {
+				seq_printf(s,
+					"Port%d queue congestion mask 0x%x\n",
+					port + (regIdx << 2), regData1);
+			}
+		}
+	}
+
+	for (port = 0; port <= CPU; port++) {
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		seq_printf(s,
+			"Port%d each queue used descriptor: Queue[0~7]: [ ",
+			port);
+#else
+		seq_printf(s,
+			"Port%d each queue used descriptor: Queue[0~5]: [ ",
+			port);
+#endif
+		for (regIdx = 0; regIdx < 3; regIdx++) {
+			regData =
+				READ_MEM32(P0_DCR0 + (port << 4) +
+				(regIdx << 2));
+			seq_printf(s, "%d %d ",
+				((regData & Pn_EQDSCR_MASK) >>
+					Pn_EVEN_OQDSCR_OFFSET),
+				((regData & Pn_OQDSCR_MASK) >>
+					Pn_ODD_OQDSCR_OFFSET));
+		}
+
+		regData = READ_MEM32(P0_DCR3 + (port << 4));
+
+		/*Level 7&6 priority output queue */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		seq_printf(s, "%d %d ",
+			((regData & (0x3ff << 10)) >> 10),
+			((regData & (0x3ff << 20)) >> 20));
+#endif
+
+		seq_printf(s, "]  Input queue [%d]\n",
+			((regData & Pn_EQDSCR_MASK) >> Pn_EVEN_OQDSCR_OFFSET));
+	}
+
+	return 0;
+}
+#else
+static int32 diagnostic_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	uint32 regData, regData1;
+	int port, regIdx;
+	uint32 mask, offset;
+
+	len = sprintf(page, "Diagnostic Register Info:\n");
+
+	regData = READ_MEM32(GDSR0);
+	len += sprintf(page + len,
+		"MaxUsedDescriptor: %d CurUsed Descriptor: %d\n",
+		(regData & MaxUsedDsc_MASK) >> MaxUsedDsc_OFFSET,
+		(regData & USEDDSC_MASK) >> USEDDSC_OFFSET);
+	len += sprintf(page + len,
+		"DescRunOut: %s TotalDescFC: %s ShareBufFC: %s\n",
+		(regData & DSCRUNOUT) ? "YES" : "NO",
+		(regData & TotalDscFctrl_Flag) ? "YES" : "NO",
+		(regData & SharedBufFCON_Flag) ? "YES" : "NO");
+
+	for (regIdx = 0; regIdx < 2; regIdx++) {
+		regData = READ_MEM32(PCSR0 + (regIdx << 2));
+
+		for (port = 0; port < 4; port++) {
+			switch (port) {
+			case 0:
+				mask = P0OQCgst_MASK;
+				offset = P0OQCgst_OFFSET;
+				break;
+			case 1:
+				mask = P1OQCgst_MASK;
+				offset = P1OQCgst_OFFSET;
+				break;
+			case 2:
+				mask = P2OQCgst_MASK;
+				offset = P2OQCgst_OFFSET;
+				break;
+			default:
+				mask = P3OQCgst_MASK;
+				offset = P3OQCgst_OFFSET;
+				break;
+			}
+			regData1 = (regData & mask) >> offset;
+			if (regData1 == 0)
+				len += sprintf(page + len,
+					"Port%d not congestion\n",
+					port + (regIdx << 2));
+			else {
+				len += sprintf(page + len,
+					"Port%d queue congestion mask 0x%x\n",
+					port + (regIdx << 2), regData1);
+			}
+		}
+	}
+
+	for (port = 0; port <= CPU; port++) {
+		len += sprintf(page + len,
+			"Port%d each queue used descriptor: Queue[0~5]: [ ",
+			port);
+		for (regIdx = 0; regIdx < 3; regIdx++) {
+			regData =
+				READ_MEM32(P0_DCR0 + (port << 4) +
+				(regIdx << 2));
+			len += sprintf(page + len, "%d %d ",
+				((regData & Pn_EQDSCR_MASK) >>
+					Pn_EVEN_OQDSCR_OFFSET),
+				((regData & Pn_OQDSCR_MASK) >>
+					Pn_ODD_OQDSCR_OFFSET));
+		}
+
+		regData = READ_MEM32(P0_DCR3 + (port << 4));
+		len += sprintf(page + len, "]  Input queue [%d]\n",
+			((regData & Pn_EQDSCR_MASK) >> Pn_EVEN_OQDSCR_OFFSET));
+	}
+
+	return len;
+}
+#endif
+
+static int32 diagnostic_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 proc_mem_read(struct seq_file *s, void *v)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	rtlglue_printf("Dump HW NAT registers from 0x%08x to 0x%08x\n",
+		rtl_hwnat_base, rtl_hwnat_base + 0x170000 - 1);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	return PROC_READ_RETURN_VALUE;
+}
+#else
+static int32 proc_mem_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	return PROC_READ_RETURN_VALUE;
+}
+#endif
+
+static int32 proc_mem_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[64];
+	uint32 *mem_addr, mem_data, mem_len;
+	char *strptr, *cmd_addr;
+	char *tokptr;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	const uintptr_t mem_base = (uintptr_t) rtl_hwnat_mmio - rtl_hwnat_base;
+	uint32 phys_addr;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	if (len > 64) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+		rtlglue_printf("cmd %s\n", cmd_addr);
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+
+		if (!memcmp(cmd_addr, "readb", 5)) {
+			mem_addr = (uint32 *)simple_strtol(tokptr, NULL, 0);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			mem_len = simple_strtol(tokptr, NULL, 0);
+			memDump2(mem_addr, mem_len);
+		}
+#if defined(CONFIG_RTD_1295_HWNAT)
+		else if (!memcmp(cmd_addr, "readp", 5)) {
+			phys_addr = simple_strtol(tokptr, NULL, 0);
+			mem_addr = (uint32 *)(mem_base + phys_addr);
+			rtlglue_printf("physical memory 0x%08x : virtual memory 0x%p\n",
+				phys_addr, mem_addr);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			mem_len = simple_strtol(tokptr, NULL, 0);
+			memDump3(mem_addr, mem_len, "");
+		} else if (!memcmp(cmd_addr, "writep", 6)) {
+			phys_addr = simple_strtol(tokptr, NULL, 0);
+			mem_addr = (uint32 *)(mem_base + phys_addr);
+			rtlglue_printf("physical memory 0x%08x : virtual memory 0x%p\n",
+				phys_addr, mem_addr);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			mem_data = simple_strtol(tokptr, NULL, 0);
+			WRITE_MEM32(mem_addr, mem_data);
+			rtlglue_printf("Write memory 0x%08x data 0x%x: 0x%x\n",
+				phys_addr, mem_data, READ_MEM32(mem_addr));
+		}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		else if (!memcmp(cmd_addr, "read", 4)) {
+			mem_addr = (uint32 *)simple_strtol(tokptr, NULL, 0);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			mem_len = simple_strtol(tokptr, NULL, 0);
+			memDump(mem_addr, mem_len, "");
+		} else if (!memcmp(cmd_addr, "write", 5)) {
+			mem_addr = (uint32 *)simple_strtol(tokptr, NULL, 0);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			mem_data = simple_strtol(tokptr, NULL, 0);
+			WRITE_MEM32(mem_addr, mem_data);
+			rtlglue_printf("Write memory 0x%p dat 0x%x: 0x%x\n",
+				mem_addr, mem_data, READ_MEM32(mem_addr));
+		} else {
+			goto errout;
+		}
+	} else {
+errout:
+		rtlglue_printf("Memory operation only support \"read\" and \"write\" as the first parameter\n");
+		rtlglue_printf("Read format:	\"read mem_addr length\"\n");
+		rtlglue_printf("Write format:	\"write mem_addr mem_data\"\n");
+	}
+
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 port_status_read(struct seq_file *s, void *v)
+{
+	int port;
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	seq_printf(s, "Dump Port Status:\n");
+
+	for (port = PHY0; port <= PHY4; port++) {
+		extern int rtk_port_macStatus_get(int port,
+			rtk_port_mac_ability_t *pPortstatus);
+		rtk_port_mac_ability_t sts;
+
+		if ((rtk_port_macStatus_get(port, &sts)) == 0) {
+			seq_printf(s, "Port%d ", port);
+
+			if (sts.link == 0) {
+				seq_printf(s, "LinkDown\n\n");
+				continue;
+			} else {
+				seq_printf(s, "LinkUp | ");
+			}
+			seq_printf(s, "NWay Mode %s\n",
+				(sts.nway) ? "Enabled" : "Disabled");
+			seq_printf(s, "	RXPause %s | ",
+				(sts.rxpause) ? "Enabled" : "Disabled");
+			seq_printf(s, "TXPause %s\n",
+				(sts.txpause) ? "Enabled" : "Disabled");
+			seq_printf(s, "	Duplex %s | ",
+				(sts.duplex) ? "Enabled" : "Disabled");
+			seq_printf(s, "Speed %s\n\n",
+				(sts.speed) ==
+				PortStatusLinkSpeed100M ? "100M" : ((sts.speed) ==
+					PortStatusLinkSpeed1000M ? "1G" : ((sts.speed) ==
+						PortStatusLinkSpeed10M ? "10M" :
+						"Unkown")));
+
+		}
+	}
+#else
+	uint32 regData, data0, regData_PCR;
+
+	seq_printf(s, "Dump Port Status:\n");
+	for (port = PHY0; port <= CPU; port++) {
+		regData = READ_MEM32(PSRP0 + ((port) << 2));
+		regData_PCR = READ_MEM32(PCRP0 + ((port) << 2));
+
+		if (port == CPU)
+			seq_printf(s, "CPUPort ");
+		else
+			seq_printf(s, "Port%d ", port);
+
+		data0 = regData_PCR & EnForceMode;
+		if (data0) {
+			seq_printf(s, "Enforce Mode ");
+			data0 = regData_PCR & PollLinkStatus;
+			if (data0)
+				seq_printf(s, " | polling LinkUp");
+			else {
+				seq_printf(s,
+					" | disable Auto-Negotiation\n\n");
+			}
+		} else {
+			seq_printf(s, "Force Mode disable\n");
+		}
+
+		regData = READ_MEM32(PSRP0 + ((port) << 2));
+		data0 = regData & PortStatusLinkUp;
+
+		if (data0)
+			seq_printf(s, "LinkUp | ");
+		else {
+			seq_printf(s, "LinkDown\n\n");
+			continue;
+		}
+		data0 = regData & PortStatusNWayEnable;
+		seq_printf(s, "NWay Mode %s\n", data0 ? "Enabled" : "Disabled");
+		data0 = regData & PortStatusRXPAUSE;
+		seq_printf(s, "	RXPause %s | ", data0 ? "Enabled" : "Disabled");
+		data0 = regData & PortStatusTXPAUSE;
+		seq_printf(s, "TXPause %s\n", data0 ? "Enabled" : "Disabled");
+		data0 = regData & PortStatusDuplex;
+		seq_printf(s, "	Duplex %s | ", data0 ? "Enabled" : "Disabled");
+		data0 = (regData & PortStatusLinkSpeed_MASK) >>
+			PortStatusLinkSpeed_OFFSET;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		seq_printf(s, "Speed %s\n",
+			data0 == PortStatusLinkSpeed100M ? "100M" : (data0 ==
+				PortStatusLinkSpeed1000M ? "1G" : (data0 ==
+					PortStatusLinkSpeed10M ? "10M" :
+					"500M")));
+#else
+		seq_printf(s, "Speed %s\n",
+			data0 == PortStatusLinkSpeed100M ? "100M" : (data0 ==
+				PortStatusLinkSpeed1000M ? "1G" : (data0 ==
+					PortStatusLinkSpeed10M ? "10M" :
+					"Unkown")));
+#endif
+
+#if defined(CONFIG_RTL_8198C)
+		if (port < 5) {
+			extern rtl8651_tblAsic_ethernet_t
+				rtl8651AsicEthernetTable[];
+			int phyid;
+			uint32 data1;
+
+			phyid = rtl8651AsicEthernetTable[port].phyId;
+
+			rtl8651_setAsicEthernetPHYReg(phyid, 31, 0xa43);
+			rtl8651_getAsicEthernetPHYReg(phyid, 26, &data1);
+			rtl8651_setAsicEthernetPHYReg(phyid, 31, 0);
+
+			seq_printf(s, "	EEE Status: %s.\n\n",
+				(data1 & 0x100) ? "enabled" : "disabled");
+		}
+#else
+		data0 = (regData & (PortEEEStatus_MASK)) >>
+			PortEEEStatus_OFFSET;
+		seq_printf(s, "	EEE Status %0x\n\n", data0);
+#endif
+
+	}
+
+#if defined(CONFIG_RTL_8198C_8367RB)
+	seq_printf(s, "\nDump 8367RB Ports Status:\n");
+
+	for (port = PHY0; port < PHY4; port++) {
+		extern int rtk_port_phyStatus_get(int port, int *pLinkStatus,
+			int *pSpeed, int *pDuplex);
+		int status, speed, duplex;
+
+		if ((rtk_port_phyStatus_get(port, &status, &speed,
+					&duplex)) == 0) {
+			seq_printf(s, "Port%d ", port);
+
+			if (status == 0) {
+				seq_printf(s, "LinkDown\n\n");
+				continue;
+			} else {
+				seq_printf(s, "LinkUp | ");
+			}
+
+			seq_printf(s, "	%s-Duplex | ",
+				duplex ? "Full" : "Half");
+
+			seq_printf(s, "Speed %s\n\n",
+				speed ==
+				PortStatusLinkSpeed100M ? "100M" : (speed ==
+					PortStatusLinkSpeed1000M ? "1G" : (speed
+						==
+						PortStatusLinkSpeed10M ? "10M" :
+						"Unkown")));
+		}
+	}
+#endif
+
+#endif
+
+	return 0;
+}
+#else
+static int32 port_status_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len, port;
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+	len = sprintf(page, "Dump Port Status:\n");
+
+	for (port = PHY0; port < EXT_SWITCH_MAX_PHY_PORT; port++) {
+		extern int rtk_port_macStatus_get(int port,
+			rtk_port_mac_ability_t *pPortstatus);
+		rtk_port_mac_ability_t sts;
+
+		if ((rtk_port_macStatus_get(port, &sts)) == 0) {
+			len += sprintf(page + len, "Port%d ", port);
+
+			if (sts.link == 0) {
+				len += sprintf(page + len, "LinkDown\n\n");
+				continue;
+			} else {
+				len += sprintf(page + len, "LinkUp | ");
+			}
+			len += sprintf(page + len, "NWay Mode %s\n",
+				(sts.nway) ? "Enabled" : "Disabled");
+			len += sprintf(page + len, "	RXPause %s | ",
+				(sts.rxpause) ? "Enabled" : "Disabled");
+			len += sprintf(page + len, "TXPause %s\n",
+				(sts.txpause) ? "Enabled" : "Disabled");
+			len += sprintf(page + len, "	Duplex %s | ",
+				(sts.duplex) ? "Enabled" : "Disabled");
+			len += sprintf(page + len, "Speed %s\n\n",
+				(sts.speed) ==
+				PortStatusLinkSpeed100M ? "100M" : ((sts.speed) ==
+					PortStatusLinkSpeed1000M ? "1G" : ((sts.speed) ==
+						PortStatusLinkSpeed10M ? "10M" :
+						"Unkown")));
+
+		}
+	}
+#else
+	uint32 regData, data0, regData_PCR;
+
+#if defined(CONFIG_RTL_8325D_SUPPORT)
+	int32 rtl8325d_portStat_dump(char *page);
+
+	len = rtl8325d_portStat_dump(page);
+
+	len += sprintf(page + len, "\nDump 8197D Port Status:\n");
+	for (port = 1; port < 5; port++)
+#else
+
+	len = sprintf(page, "Dump Port Status:\n");
+	for (port = PHY0; port <= CPU; port++)
+#endif
+	{
+		regData = READ_MEM32(PSRP0 + ((port) << 2));
+		regData_PCR = READ_MEM32(PCRP0 + ((port) << 2));
+
+		if (port == CPU)
+			len += sprintf(page + len, "CPUPort ");
+		else
+			len += sprintf(page + len, "Port%d ", port);
+
+		data0 = regData_PCR & EnForceMode;
+		if (data0) {
+			len += sprintf(page + len, "Enforce Mode ");
+			data0 = regData_PCR & PollLinkStatus;
+			if (data0)
+				len += sprintf(page + len, " | polling LinkUp");
+			else {
+				len += sprintf(page + len,
+					" | disable Auto-Negotiation\n\n");
+			}
+		} else {
+			len += sprintf(page + len, "Force Mode disable\n");
+		}
+		data0 = (regData & (PortEEEStatus_MASK)) >>
+			PortEEEStatus_OFFSET;
+		len += sprintf(page + len, "EEE Status %0x\n", data0);
+
+		regData = READ_MEM32(PSRP0 + ((port) << 2));
+		data0 = regData & PortStatusLinkUp;
+
+		if (data0)
+			len += sprintf(page + len, "LinkUp | ");
+		else {
+			len += sprintf(page + len, "LinkDown\n\n");
+			continue;
+		}
+		data0 = regData & PortStatusNWayEnable;
+		len += sprintf(page + len, "NWay Mode %s\n",
+			data0 ? "Enabled" : "Disabled");
+		data0 = regData & PortStatusRXPAUSE;
+		len += sprintf(page + len, "	RXPause %s | ",
+			data0 ? "Enabled" : "Disabled");
+		data0 = regData & PortStatusTXPAUSE;
+		len += sprintf(page + len, "TXPause %s\n",
+			data0 ? "Enabled" : "Disabled");
+		data0 = regData & PortStatusDuplex;
+		len += sprintf(page + len, "	Duplex %s | ",
+			data0 ? "Enabled" : "Disabled");
+		data0 = (regData & PortStatusLinkSpeed_MASK) >>
+			PortStatusLinkSpeed_OFFSET;
+		len += sprintf(page + len, "Speed %s\n\n",
+			data0 == PortStatusLinkSpeed100M ? "100M" : (data0 ==
+				PortStatusLinkSpeed1000M ? "1G" : (data0 ==
+					PortStatusLinkSpeed10M ? "10M" :
+					"Unkown")));
+	}
+#endif
+
+	return len;
+}
+#endif
+
+extern int32 rtl8651_setAsicEthernetPHYPowerDown(uint32 port, uint32 pwrDown);
+extern int32 rtl8651_setAsicEthernetPHYSpeed(uint32 port, uint32 speed);
+extern int32 rtl8651_setAsicEthernetPHYDuplex(uint32 port, uint32 duplex);
+extern int32 rtl8651_setAsicEthernetPHYAutoNeg(uint32 port, uint32 autoneg);
+extern int32 rtl8651_setAsicEthernetPHYAdvCapality(uint32 port,
+	uint32 capality);
+extern int32 rtl865xC_setAsicEthernetForceModeRegs(uint32 port,
+	uint32 enForceMode, uint32 forceLink, uint32 forceSpeed,
+	uint32 forceDuplex);
+extern int32 rtl8651_restartAsicEthernetPHYNway(uint32 port);
+
+static int32 port_status_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[64];
+	uint32 port_mask;
+	char *strptr, *cmd_addr;
+	char *tokptr;
+	int type;
+	int port;
+
+#if !defined(CONFIG_RTL_8367R_SUPPORT) && !defined(CONFIG_RTL_8370_SUPPORT)
+	int forceMode = 0;
+	int forceLink = 0;
+	int forceLinkSpeed = 0;
+	int forceDuplex = 0;
+	uint32 advCapability = 0;
+#endif
+
+#define SPEED10M	0
+#define SPEED100M	1
+#define SPEED1000M	2
+
+	if (len > 64) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len - 1] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+
+		if (!memcmp(cmd_addr, "port", 4)) {
+			port_mask = simple_strtol(tokptr, NULL, 0);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+
+			if (strcmp(tokptr, "10_half") == 0)
+				type = HALF_DUPLEX_10M;
+			else if (strcmp(tokptr, "100_half") == 0)
+				type = HALF_DUPLEX_100M;
+			else if (strcmp(tokptr, "1000_half") == 0)
+				type = HALF_DUPLEX_1000M;
+			else if (strcmp(tokptr, "10_full") == 0)
+				type = DUPLEX_10M;
+			else if (strcmp(tokptr, "100_full") == 0)
+				type = DUPLEX_100M;
+			else if (strcmp(tokptr, "1000_full") == 0)
+				type = DUPLEX_1000M;
+			else if (strcmp(tokptr, "down") == 0)
+				type = PORT_DOWN;
+			else if (strcmp(tokptr, "up") == 0)
+				type = PORT_UP;
+			else
+				type = PORT_AUTO;
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+			for (port = 0; port < EXT_SWITCH_MAX_PHY_PORT; port++) {
+				extern int set_83XX_speed_mode(int port,
+					int type);
+				if (((1 << port) & port_mask)
+					&& (type != HALF_DUPLEX_1000M)) {
+					set_83XX_speed_mode(port, type);
+				}
+			}
+#else
+			switch (type) {
+			case HALF_DUPLEX_10M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED10M;
+					forceDuplex = FALSE;
+					advCapability = (1 << HALF_DUPLEX_10M);
+					break;
+				}
+			case HALF_DUPLEX_100M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED100M;
+					forceDuplex = FALSE;
+					advCapability = (1 << HALF_DUPLEX_100M);
+					break;
+				}
+			case HALF_DUPLEX_1000M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED1000M;
+					forceDuplex = FALSE;
+					advCapability =
+						(1 << HALF_DUPLEX_1000M);
+					break;
+				}
+			case DUPLEX_10M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED10M;
+					forceDuplex = TRUE;
+					advCapability = (1 << DUPLEX_10M);
+					break;
+				}
+			case DUPLEX_100M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED100M;
+					forceDuplex = TRUE;
+					advCapability = (1 << DUPLEX_100M);
+					break;
+				}
+			case DUPLEX_1000M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED1000M;
+					forceDuplex = TRUE;
+					advCapability = (1 << DUPLEX_1000M);
+					break;
+				}
+			default:
+				{
+					forceMode = FALSE;
+					forceLink = TRUE;
+					/*all capality */
+					advCapability = (1 << PORT_AUTO);
+				}
+			}
+
+#ifdef CONFIG_RTL_8198C
+			if ((type == HALF_DUPLEX_1000M)
+				|| (type == DUPLEX_1000M)) {
+				forceMode = FALSE;
+				forceLink = TRUE;
+				forceLinkSpeed = SPEED1000M;
+				/*all capality */
+				advCapability = (1 << DUPLEX_1000M);
+			}
+#endif
+
+#ifdef CONFIG_FORCE_10M_100M_FULL_REFINE
+			/* design note:
+			 * 1. When user force port to 100MF, we still set to AN mode but disable 1000MF ability.
+			 * 2. When user force port to 10MF, we still set to AN mode but disable 100MF/100MH/1000MF ability.
+			 * 3. When user force port to 10MF/100MF, we process it as old way.
+			 */
+
+			if (type == DUPLEX_10M) {
+				for (port = 0; port < CPU; port++) {
+					if ((1 << port) & port_mask) {
+						rtl8651_setAsicEthernetPHYAutoNeg(port, TRUE);
+						rtl8651_setAsicEthernetPHYAdvCapality(port,
+							((1 << HALF_DUPLEX_10M) |
+							(1 << DUPLEX_10M)));
+						REG32(PCRP0 + (port * 4)) =
+							(REG32(PCRP0 + (port * 4)) |
+							AutoNegoSts_MASK) &
+							~(EnForceMode |
+							PollLinkStatus |
+							NwayAbility100MF |
+							NwayAbility100MH |
+							NwayAbility1000MF);
+
+						rtl8651_restartAsicEthernetPHYNway(port);
+					}
+				}
+			} else if (type == DUPLEX_100M) {
+				for (port = 0; port < CPU; port++) {
+					if ((1 << port) & port_mask) {
+						rtl8651_setAsicEthernetPHYAutoNeg(port, TRUE);
+						rtl8651_setAsicEthernetPHYAdvCapality(port,
+							((1 << HALF_DUPLEX_10M) |
+							(1 << DUPLEX_10M) |
+							(1 << HALF_DUPLEX_100M) |
+							(1 << DUPLEX_100M)));
+						REG32(PCRP0 + (port * 4)) =
+							(REG32(PCRP0 + (port * 4)) |
+							AutoNegoSts_MASK) &
+							~(EnForceMode |
+							PollLinkStatus |
+							NwayAbility1000MF);
+
+						rtl8651_restartAsicEthernetPHYNway
+							(port);
+					}
+				}
+			} else if ((type == DUPLEX_1000M)
+				|| (type == PORT_AUTO)) {
+				for (port = 0; port < CPU; port++) {
+					if ((1 << port) & port_mask) {
+						rtl8651_setAsicEthernetPHYAutoNeg(port, TRUE);
+						rtl8651_setAsicEthernetPHYAdvCapality
+							(port,
+							((1 << HALF_DUPLEX_10M) |
+							(1 << DUPLEX_10M) |
+							(1 << HALF_DUPLEX_100M) |
+							(1 << DUPLEX_100M) |
+							(1 << DUPLEX_1000M)));
+						REG32(PCRP0 + (port * 4)) =
+							(REG32(PCRP0 + (port * 4)) |
+							AutoNegoSts_MASK) &
+							~(EnForceMode |
+							PollLinkStatus);
+
+						rtl8651_restartAsicEthernetPHYNway(port);
+					}
+				}
+			} else
+#endif
+
+				for (port = 0; port < CPU; port++) {
+#if defined(CONFIG_RTL_8198C_8367RB)
+					if (port >= 5)
+						continue;
+#endif
+
+					if ((1 << port) & port_mask) {
+						if (type == PORT_DOWN) {
+							rtl8651_setAsicEthernetPHYPowerDown(port, 1);
+						} else if (type == PORT_UP) {
+							rtl8651_setAsicEthernetPHYPowerDown(port, 0);
+						} else {
+							/*Set PHY Register */
+							rtl8651_setAsicEthernetPHYSpeed(port,
+								forceLinkSpeed);
+							rtl8651_setAsicEthernetPHYDuplex(port,
+								forceDuplex);
+							rtl8651_setAsicEthernetPHYAutoNeg(port,
+								forceMode ? FALSE : TRUE);
+							rtl8651_setAsicEthernetPHYAdvCapality(port,
+								advCapability);
+
+							rtl865xC_setAsicEthernetForceModeRegs(port,
+								forceMode,
+								forceLink,
+								forceLinkSpeed,
+								forceDuplex);
+
+							rtl8651_restartAsicEthernetPHYNway(port);
+							mdelay(10);
+						}
+					}
+				}
+
+#if defined(CONFIG_RTL_8198C_8367RB)
+			for (port = 5; port < 9; port++) {
+				extern int set_83XX_speed_mode(int port,
+					int type);
+				if (((1 << port) & port_mask)
+					&& (type != HALF_DUPLEX_1000M)) {
+					set_83XX_speed_mode(port - 5, type);
+				}
+			}
+#endif
+#endif
+
+		} else if (!memcmp(cmd_addr, "dump", 4)) {
+#if defined(CONFIG_RTL_FE_AUTO_DOWN_SPEED)
+			if (!memcmp(tokptr, "ads", 3)) {
+				extern void ads_debug(void);
+
+				ads_debug();
+			}
+#endif
+		} else {
+			goto errout;
+		}
+	} else {
+errout:
+		rtlglue_printf("port status only support \"port\" as the first parameter\n");
+		rtlglue_printf("format: \"port port_mask 10_half/100_half/10_full/100_full/1000_full/auto\"\n");
+	}
+	return len;
+}
+
+/* debug NAPT hash entries */
+static int32 rtl_test_napt_mode = 0;
+
+static void rtl_fill_hw_napt_table(void)
+{
+	#if defined(CONFIG_RTL_LAYERED_DRIVER_L4)
+	rtl865x_napt_entry *naptEntry;
+	rtl865x_priority rtl865xPrio;
+	uint16 in, out;
+	int i;
+	static rtl865x_napt_entry p[] =
+	{
+	{0, htonl(0xc0a8000a), htons(10000), htonl(0xc0a80109), htons(10000),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10001), htonl(0xc0a80109), htons(10001),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10002), htonl(0xc0a80109), htons(10002),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10003), htonl(0xc0a80109), htons(10003),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10004), htonl(0xc0a80109), htons(10004),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10005), htonl(0xc0a80109), htons(10005),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10006), htonl(0xc0a80109), htons(10006),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10007), htonl(0xc0a80109), htons(10007),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10008), htonl(0xc0a80109), htons(10008),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10009), htonl(0xc0a80109), htons(10009),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10010), htonl(0xc0a80109), htons(10010),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10011), htonl(0xc0a80109), htons(10011),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10012), htonl(0xc0a80109), htons(10012),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10013), htonl(0xc0a80109), htons(10013),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10014), htonl(0xc0a80109), htons(10014),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10015), htonl(0xc0a80109), htons(10015),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10024), htonl(0xc0a80109), htons(10024),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10025), htonl(0xc0a80109), htons(10025),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10026), htonl(0xc0a80109), htons(10026),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10027), htonl(0xc0a80109), htons(10027),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10028), htonl(0xc0a80109), htons(10028),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10029), htonl(0xc0a80109), htons(10029),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10030), htonl(0xc0a80109), htons(10030),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10031), htonl(0xc0a80109), htons(10031),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10032), htonl(0xc0a80109), htons(10032),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10033), htonl(0xc0a80109), htons(10033),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10034), htonl(0xc0a80109), htons(10034),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10035), htonl(0xc0a80109), htons(10035),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10038), htonl(0xc0a80109), htons(10038),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10044), htonl(0xc0a80109), htons(10044),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10046), htonl(0xc0a80109), htons(10046),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10048), htonl(0xc0a80109), htons(10048),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10049), htonl(0xc0a80109), htons(10049),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10050), htonl(0xc0a80109), htons(10050),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10051), htonl(0xc0a80109), htons(10051),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10052), htonl(0xc0a80109), htons(10052),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10053), htonl(0xc0a80109), htons(10053),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10054), htonl(0xc0a80109), htons(10054),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10055), htonl(0xc0a80109), htons(10055),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10056), htonl(0xc0a80109), htons(10056),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10057), htonl(0xc0a80109), htons(10057),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10058), htonl(0xc0a80109), htons(10058),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10059), htonl(0xc0a80109), htons(10059),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10060), htonl(0xc0a80109), htons(10060),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10061), htonl(0xc0a80109), htons(10061),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10062), htonl(0xc0a80109), htons(10062),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10063), htonl(0xc0a80109), htons(10063),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10064), htonl(0xc0a80109), htons(10064),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10065), htonl(0xc0a80109), htons(10065),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10066), htonl(0xc0a80109), htons(10066),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10067), htonl(0xc0a80109), htons(10067),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10068), htonl(0xc0a80109), htons(10068),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10069), htonl(0xc0a80109), htons(10069),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10070), htonl(0xc0a80109), htons(10070),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10071), htonl(0xc0a80109), htons(10071),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10072), htonl(0xc0a80109), htons(10072),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10073), htonl(0xc0a80109), htons(10073),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10074), htonl(0xc0a80109), htons(10074),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10075), htonl(0xc0a80109), htons(10075),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10076), htonl(0xc0a80109), htons(10076),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10077), htonl(0xc0a80109), htons(10077),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10078), htonl(0xc0a80109), htons(10078),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10079), htonl(0xc0a80109), htons(10079),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10080), htonl(0xc0a80109), htons(10080),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10082), htonl(0xc0a80109), htons(10082),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10084), htonl(0xc0a80109), htons(10084),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10086), htonl(0xc0a80109), htons(10086),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10088), htonl(0xc0a80109), htons(10088),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10090), htonl(0xc0a80109), htons(10090),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10092), htonl(0xc0a80109), htons(10092),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10094), htonl(0xc0a80109), htons(10094),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10096), htonl(0xc0a80109), htons(10096),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10098), htonl(0xc0a80109), htons(10098),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10100), htonl(0xc0a80109), htons(10100),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10102), htonl(0xc0a80109), htons(10102),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10104), htonl(0xc0a80109), htons(10104),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10106), htonl(0xc0a80109), htons(10106),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10108), htonl(0xc0a80109), htons(10108),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10110), htonl(0xc0a80109), htons(10110),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10112), htonl(0xc0a80109), htons(10112),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10113), htonl(0xc0a80109), htons(10113),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10114), htonl(0xc0a80109), htons(10114),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10116), htonl(0xc0a80109), htons(10116),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10117), htonl(0xc0a80109), htons(10117),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10118), htonl(0xc0a80109), htons(10118),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10120), htonl(0xc0a80109), htons(10120),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10121), htonl(0xc0a80109), htons(10121),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10122), htonl(0xc0a80109), htons(10122),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10124), htonl(0xc0a80109), htons(10124),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10125), htonl(0xc0a80109), htons(10125),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10126), htonl(0xc0a80109), htons(10126),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10128), htonl(0xc0a80109), htons(10128),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10129), htonl(0xc0a80109), htons(10129),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10130), htonl(0xc0a80109), htons(10130),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10132), htonl(0xc0a80109), htons(10132),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10133), htonl(0xc0a80109), htons(10133),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10134), htonl(0xc0a80109), htons(10134),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10136), htonl(0xc0a80109), htons(10136),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10137), htonl(0xc0a80109), htons(10137),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10138), htonl(0xc0a80109), htons(10138),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10140), htonl(0xc0a80109), htons(10140),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10141), htonl(0xc0a80109), htons(10141),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10142), htonl(0xc0a80109), htons(10142),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10144), htonl(0xc0a80109), htons(10144),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10145), htonl(0xc0a80109), htons(10145),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10146), htonl(0xc0a80109), htons(10146),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10148), htonl(0xc0a80109), htons(10148),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10149), htonl(0xc0a80109), htons(10149),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10150), htonl(0xc0a80109), htons(10150),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10152), htonl(0xc0a80109), htons(10152),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10153), htonl(0xc0a80109), htons(10153),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10154), htonl(0xc0a80109), htons(10154),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10156), htonl(0xc0a80109), htons(10156),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10157), htonl(0xc0a80109), htons(10157),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10158), htonl(0xc0a80109), htons(10158),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10160), htonl(0xc0a80109), htons(10160),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10161), htonl(0xc0a80109), htons(10161),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10162), htonl(0xc0a80109), htons(10162),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10164), htonl(0xc0a80109), htons(10164),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10165), htonl(0xc0a80109), htons(10165),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10166), htonl(0xc0a80109), htons(10166),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10168), htonl(0xc0a80109), htons(10168),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10169), htonl(0xc0a80109), htons(10169),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10170), htonl(0xc0a80109), htons(10170),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10172), htonl(0xc0a80109), htons(10172),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10173), htonl(0xc0a80109), htons(10173),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10174), htonl(0xc0a80109), htons(10174),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10176), htonl(0xc0a80109), htons(10176),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10178), htonl(0xc0a80109), htons(10178),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10180), htonl(0xc0a80109), htons(10180),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10182), htonl(0xc0a80109), htons(10182),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10184), htonl(0xc0a80109), htons(10184),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10186), htonl(0xc0a80109), htons(10186),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10188), htonl(0xc0a80109), htons(10188),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10190), htonl(0xc0a80109), htons(10190),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10192), htonl(0xc0a80109), htons(10192),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10194), htonl(0xc0a80109), htons(10194),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10196), htonl(0xc0a80109), htons(10196),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10198), htonl(0xc0a80109), htons(10198),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10200), htonl(0xc0a80109), htons(10200),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10202), htonl(0xc0a80109), htons(10202),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10204), htonl(0xc0a80109), htons(10204),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10206), htonl(0xc0a80109), htons(10206),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10208), htonl(0xc0a80109), htons(10208),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10210), htonl(0xc0a80109), htons(10210),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10212), htonl(0xc0a80109), htons(10212),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10214), htonl(0xc0a80109), htons(10214),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10216), htonl(0xc0a80109), htons(10216),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10218), htonl(0xc0a80109), htons(10218),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10220), htonl(0xc0a80109), htons(10220),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10222), htonl(0xc0a80109), htons(10222),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10224), htonl(0xc0a80109), htons(10224),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10226), htonl(0xc0a80109), htons(10226),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10228), htonl(0xc0a80109), htons(10228),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10230), htonl(0xc0a80109), htons(10230),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10232), htonl(0xc0a80109), htons(10232),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10234), htonl(0xc0a80109), htons(10234),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10236), htonl(0xc0a80109), htons(10236),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10238), htonl(0xc0a80109), htons(10238),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10240), htonl(0xc0a80109), htons(10240),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10241), htonl(0xc0a80109), htons(10241),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10242), htonl(0xc0a80109), htons(10242),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10243), htonl(0xc0a80109), htons(10243),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10244), htonl(0xc0a80109), htons(10244),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10245), htonl(0xc0a80109), htons(10245),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10246), htonl(0xc0a80109), htons(10246),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10247), htonl(0xc0a80109), htons(10247),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10248), htonl(0xc0a80109), htons(10248),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10249), htonl(0xc0a80109), htons(10249),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10250), htonl(0xc0a80109), htons(10250),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10251), htonl(0xc0a80109), htons(10251),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10252), htonl(0xc0a80109), htons(10252),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10253), htonl(0xc0a80109), htons(10253),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10254), htonl(0xc0a80109), htons(10254),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10255), htonl(0xc0a80109), htons(10255),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10256), htonl(0xc0a80109), htons(10256),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10257), htonl(0xc0a80109), htons(10257),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10258), htonl(0xc0a80109), htons(10258),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10259), htonl(0xc0a80109), htons(10259),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10260), htonl(0xc0a80109), htons(10260),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10261), htonl(0xc0a80109), htons(10261),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10262), htonl(0xc0a80109), htons(10262),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10263), htonl(0xc0a80109), htons(10263),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10264), htonl(0xc0a80109), htons(10264),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10265), htonl(0xc0a80109), htons(10265),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10266), htonl(0xc0a80109), htons(10266),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10267), htonl(0xc0a80109), htons(10267),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10268), htonl(0xc0a80109), htons(10268),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10269), htonl(0xc0a80109), htons(10269),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10270), htonl(0xc0a80109), htons(10270),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10271), htonl(0xc0a80109), htons(10271),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10272), htonl(0xc0a80109), htons(10272),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10273), htonl(0xc0a80109), htons(10273),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10274), htonl(0xc0a80109), htons(10274),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10275), htonl(0xc0a80109), htons(10275),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10276), htonl(0xc0a80109), htons(10276),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10277), htonl(0xc0a80109), htons(10277),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10278), htonl(0xc0a80109), htons(10278),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10279), htonl(0xc0a80109), htons(10279),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10280), htonl(0xc0a80109), htons(10280),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10281), htonl(0xc0a80109), htons(10281),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10282), htonl(0xc0a80109), htons(10282),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10283), htonl(0xc0a80109), htons(10283),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10284), htonl(0xc0a80109), htons(10284),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10285), htonl(0xc0a80109), htons(10285),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10286), htonl(0xc0a80109), htons(10286),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10287), htonl(0xc0a80109), htons(10287),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10288), htonl(0xc0a80109), htons(10288),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10289), htonl(0xc0a80109), htons(10289),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10290), htonl(0xc0a80109), htons(10290),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10291), htonl(0xc0a80109), htons(10291),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10292), htonl(0xc0a80109), htons(10292),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10293), htonl(0xc0a80109), htons(10293),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10294), htonl(0xc0a80109), htons(10294),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10295), htonl(0xc0a80109), htons(10295),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10296), htonl(0xc0a80109), htons(10296),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10297), htonl(0xc0a80109), htons(10297),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10298), htonl(0xc0a80109), htons(10298),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10299), htonl(0xc0a80109), htons(10299),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10300), htonl(0xc0a80109), htons(10300),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10301), htonl(0xc0a80109), htons(10301),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10302), htonl(0xc0a80109), htons(10302),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10303), htonl(0xc0a80109), htons(10303),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10304), htonl(0xc0a80109), htons(10304),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10305), htonl(0xc0a80109), htons(10305),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10306), htonl(0xc0a80109), htons(10306),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10307), htonl(0xc0a80109), htons(10307),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10308), htonl(0xc0a80109), htons(10308),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10309), htonl(0xc0a80109), htons(10309),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10310), htonl(0xc0a80109), htons(10310),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10311), htonl(0xc0a80109), htons(10311),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10312), htonl(0xc0a80109), htons(10312),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10313), htonl(0xc0a80109), htons(10313),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10314), htonl(0xc0a80109), htons(10314),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10315), htonl(0xc0a80109), htons(10315),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10316), htonl(0xc0a80109), htons(10316),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10317), htonl(0xc0a80109), htons(10317),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10318), htonl(0xc0a80109), htons(10318),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10319), htonl(0xc0a80109), htons(10319),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10320), htonl(0xc0a80109), htons(10320),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10321), htonl(0xc0a80109), htons(10321),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10322), htonl(0xc0a80109), htons(10322),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10323), htonl(0xc0a80109), htons(10323),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10324), htonl(0xc0a80109), htons(10324),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10325), htonl(0xc0a80109), htons(10325),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10326), htonl(0xc0a80109), htons(10326),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10327), htonl(0xc0a80109), htons(10327),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10328), htonl(0xc0a80109), htons(10328),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10329), htonl(0xc0a80109), htons(10329),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10330), htonl(0xc0a80109), htons(10330),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10331), htonl(0xc0a80109), htons(10331),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10332), htonl(0xc0a80109), htons(10332),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10333), htonl(0xc0a80109), htons(10333),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10334), htonl(0xc0a80109), htons(10334),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10335), htonl(0xc0a80109), htons(10335),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10336), htonl(0xc0a80109), htons(10336),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10337), htonl(0xc0a80109), htons(10337),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10338), htonl(0xc0a80109), htons(10338),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10339), htonl(0xc0a80109), htons(10339),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10340), htonl(0xc0a80109), htons(10340),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10341), htonl(0xc0a80109), htons(10341),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10342), htonl(0xc0a80109), htons(10342),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10343), htonl(0xc0a80109), htons(10343),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10344), htonl(0xc0a80109), htons(10344),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10345), htonl(0xc0a80109), htons(10345),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10346), htonl(0xc0a80109), htons(10346),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10347), htonl(0xc0a80109), htons(10347),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10348), htonl(0xc0a80109), htons(10348),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10349), htonl(0xc0a80109), htons(10349),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10350), htonl(0xc0a80109), htons(10350),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10351), htonl(0xc0a80109), htons(10351),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10352), htonl(0xc0a80109), htons(10352),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10353), htonl(0xc0a80109), htons(10353),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10354), htonl(0xc0a80109), htons(10354),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10355), htonl(0xc0a80109), htons(10355),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10356), htonl(0xc0a80109), htons(10356),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10357), htonl(0xc0a80109), htons(10357),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10358), htonl(0xc0a80109), htons(10358),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10359), htonl(0xc0a80109), htons(10359),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10360), htonl(0xc0a80109), htons(10360),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10361), htonl(0xc0a80109), htons(10361),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10362), htonl(0xc0a80109), htons(10362),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10363), htonl(0xc0a80109), htons(10363),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10364), htonl(0xc0a80109), htons(10364),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10365), htonl(0xc0a80109), htons(10365),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10366), htonl(0xc0a80109), htons(10366),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10367), htonl(0xc0a80109), htons(10367),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10432), htonl(0xc0a80109), htons(10432),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10433), htonl(0xc0a80109), htons(10433),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10434), htonl(0xc0a80109), htons(10434),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10435), htonl(0xc0a80109), htons(10435),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10436), htonl(0xc0a80109), htons(10436),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10437), htonl(0xc0a80109), htons(10437),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10438), htonl(0xc0a80109), htons(10438),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10439), htonl(0xc0a80109), htons(10439),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10440), htonl(0xc0a80109), htons(10440),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10441), htonl(0xc0a80109), htons(10441),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10442), htonl(0xc0a80109), htons(10442),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10448), htonl(0xc0a80109), htons(10448),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10450), htonl(0xc0a80109), htons(10450),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10452), htonl(0xc0a80109), htons(10452),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10454), htonl(0xc0a80109), htons(10454),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10456), htonl(0xc0a80109), htons(10456),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10458), htonl(0xc0a80109), htons(10458),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10460), htonl(0xc0a80109), htons(10460),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10462), htonl(0xc0a80109), htons(10462),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10464), htonl(0xc0a80109), htons(10464),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10465), htonl(0xc0a80109), htons(10465),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10466), htonl(0xc0a80109), htons(10466),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10468), htonl(0xc0a80109), htons(10468),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10469), htonl(0xc0a80109), htons(10469),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10470), htonl(0xc0a80109), htons(10470),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10472), htonl(0xc0a80109), htons(10472),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10473), htonl(0xc0a80109), htons(10473),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10474), htonl(0xc0a80109), htons(10474),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10476), htonl(0xc0a80109), htons(10476),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10477), htonl(0xc0a80109), htons(10477),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10478), htonl(0xc0a80109), htons(10478),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10480), htonl(0xc0a80109), htons(10480),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10481), htonl(0xc0a80109), htons(10481),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10482), htonl(0xc0a80109), htons(10482),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10484), htonl(0xc0a80109), htons(10484),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10485), htonl(0xc0a80109), htons(10485),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10486), htonl(0xc0a80109), htons(10486),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10488), htonl(0xc0a80109), htons(10488),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10489), htonl(0xc0a80109), htons(10489),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10490), htonl(0xc0a80109), htons(10490),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10492), htonl(0xc0a80109), htons(10492),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10493), htonl(0xc0a80109), htons(10493),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10494), htonl(0xc0a80109), htons(10494),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10536), htonl(0xc0a80109), htons(10536),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10538), htonl(0xc0a80109), htons(10538),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10540), htonl(0xc0a80109), htons(10540),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10542), htonl(0xc0a80109), htons(10542),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10546), htonl(0xc0a80109), htons(10546),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10548), htonl(0xc0a80109), htons(10548),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10556), htonl(0xc0a80109), htons(10556),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10558), htonl(0xc0a80109), htons(10558),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10624), htonl(0xc0a80109), htons(10624),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10626), htonl(0xc0a80109), htons(10626),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10628), htonl(0xc0a80109), htons(10628),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10630), htonl(0xc0a80109), htons(10630),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10632), htonl(0xc0a80109), htons(10632),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10634), htonl(0xc0a80109), htons(10634),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10636), htonl(0xc0a80109), htons(10636),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10638), htonl(0xc0a80109), htons(10638),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10640), htonl(0xc0a80109), htons(10640),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10642), htonl(0xc0a80109), htons(10642),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10644), htonl(0xc0a80109), htons(10644),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10646), htonl(0xc0a80109), htons(10646),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10648), htonl(0xc0a80109), htons(10648),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10650), htonl(0xc0a80109), htons(10650),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10652), htonl(0xc0a80109), htons(10652),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10654), htonl(0xc0a80109), htons(10654),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10656), htonl(0xc0a80109), htons(10656),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10658), htonl(0xc0a80109), htons(10658),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10660), htonl(0xc0a80109), htons(10660),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10662), htonl(0xc0a80109), htons(10662),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10664), htonl(0xc0a80109), htons(10664),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10666), htonl(0xc0a80109), htons(10666),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10668), htonl(0xc0a80109), htons(10668),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10670), htonl(0xc0a80109), htons(10670),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10672), htonl(0xc0a80109), htons(10672),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10674), htonl(0xc0a80109), htons(10674),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10676), htonl(0xc0a80109), htons(10676),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10678), htonl(0xc0a80109), htons(10678),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10680), htonl(0xc0a80109), htons(10680),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10682), htonl(0xc0a80109), htons(10682),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10684), htonl(0xc0a80109), htons(10684),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10686), htonl(0xc0a80109), htons(10686),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10688), htonl(0xc0a80109), htons(10688),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10690), htonl(0xc0a80109), htons(10690),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10692), htonl(0xc0a80109), htons(10692),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10694), htonl(0xc0a80109), htons(10694),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10696), htonl(0xc0a80109), htons(10696),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10698), htonl(0xc0a80109), htons(10698),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10700), htonl(0xc0a80109), htons(10700),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10702), htonl(0xc0a80109), htons(10702),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10704), htonl(0xc0a80109), htons(10704),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10706), htonl(0xc0a80109), htons(10706),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10708), htonl(0xc0a80109), htons(10708),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10710), htonl(0xc0a80109), htons(10710),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10712), htonl(0xc0a80109), htons(10712),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10714), htonl(0xc0a80109), htons(10714),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10716), htonl(0xc0a80109), htons(10716),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10718), htonl(0xc0a80109), htons(10718),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10720), htonl(0xc0a80109), htons(10720),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10722), htonl(0xc0a80109), htons(10722),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10724), htonl(0xc0a80109), htons(10724),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10726), htonl(0xc0a80109), htons(10726),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10728), htonl(0xc0a80109), htons(10728),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10730), htonl(0xc0a80109), htons(10730),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10732), htonl(0xc0a80109), htons(10732),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10734), htonl(0xc0a80109), htons(10734),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10736), htonl(0xc0a80109), htons(10736),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10738), htonl(0xc0a80109), htons(10738),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10740), htonl(0xc0a80109), htons(10740),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10742), htonl(0xc0a80109), htons(10742),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10744), htonl(0xc0a80109), htons(10744),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10746), htonl(0xc0a80109), htons(10746),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10748), htonl(0xc0a80109), htons(10748),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10750), htonl(0xc0a80109), htons(10750),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10753), htonl(0xc0a80109), htons(10753),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10757), htonl(0xc0a80109), htons(10757),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10758), htonl(0xc0a80109), htons(10758),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10761), htonl(0xc0a80109), htons(10761),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10765), htonl(0xc0a80109), htons(10765),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10766), htonl(0xc0a80109), htons(10766),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10769), htonl(0xc0a80109), htons(10769),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10773), htonl(0xc0a80109), htons(10773),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10774), htonl(0xc0a80109), htons(10774),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10777), htonl(0xc0a80109), htons(10777),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10781), htonl(0xc0a80109), htons(10781),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10782), htonl(0xc0a80109), htons(10782),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10785), htonl(0xc0a80109), htons(10785),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10789), htonl(0xc0a80109), htons(10789),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10790), htonl(0xc0a80109), htons(10790),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10793), htonl(0xc0a80109), htons(10793),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10797), htonl(0xc0a80109), htons(10797),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10798), htonl(0xc0a80109), htons(10798),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10813), htonl(0xc0a80109), htons(10813),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10814), htonl(0xc0a80109), htons(10814),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10953), htonl(0xc0a80109), htons(10953),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10977), htonl(0xc0a80109), htons(10977),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10978), htonl(0xc0a80109), htons(10978),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10981), htonl(0xc0a80109), htons(10981),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10982), htonl(0xc0a80109), htons(10982),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10985), htonl(0xc0a80109), htons(10985),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10986), htonl(0xc0a80109), htons(10986),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10989), htonl(0xc0a80109), htons(10989),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10990), htonl(0xc0a80109), htons(10990),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10993), htonl(0xc0a80109), htons(10993),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10994), htonl(0xc0a80109), htons(10994),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10997), htonl(0xc0a80109), htons(10997),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10998), htonl(0xc0a80109), htons(10998),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(11001), htonl(0xc0a80109), htons(11001),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(11002), htonl(0xc0a80109), htons(11002),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(11005), htonl(0xc0a80109), htons(11005),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(11006), htonl(0xc0a80109), htons(11006),  htonl(0xc0a8010a), htons(50000)},
+	{0, htonl(0xc0a8000a), htons(10548), htonl(0xc0a80109), htons(10548),  htonl(0xc0a8010a), htons(50001)},
+	{0, htonl(0xc0a8000a), htons(10046), htonl(0xc0a80109), htons(10046),  htonl(0xc0a8010a), htons(50002)},
+	{0, htonl(0xc0a8000a), htons(10556), htonl(0xc0a80109), htons(10556),  htonl(0xc0a8010a), htons(50002)},
+	{0, htonl(0xc0a8000a), htons(10558), htonl(0xc0a80109), htons(10558),  htonl(0xc0a8010a), htons(50002)},
+	{0, htonl(0xc0a8000a), htons(10813), htonl(0xc0a80109), htons(10813),  htonl(0xc0a8010a), htons(50002)},
+	{0, htonl(0xc0a8000a), htons(10953), htonl(0xc0a80109), htons(10953),  htonl(0xc0a8010a), htons(50002)},
+	{0, htonl(0xc0a8000a), htons(10813), htonl(0xc0a80109), htons(10813),  htonl(0xc0a8010a), htons(50004)},
+	{0, htonl(0xc0a8000a), htons(10031), htonl(0xc0a80109), htons(10031),  htonl(0xc0a8010a), htons(50007)},
+	{0, htonl(0xc0a8000a), htons(10790), htonl(0xc0a80109), htons(10790),  htonl(0xc0a8010a), htons(50008)},
+	{0, htonl(0xc0a8000a), htons(10789), htonl(0xc0a80109), htons(10789),  htonl(0xc0a8010a), htons(50010)},
+	{0, htonl(0xc0a8000a), htons(10540), htonl(0xc0a80109), htons(10540),  htonl(0xc0a8010a), htons(50014)},
+	{0, htonl(0xc0a8000a), htons(10467), htonl(0xc0a80109), htons(10467),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10468), htonl(0xc0a80109), htons(10468),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10475), htonl(0xc0a80109), htons(10475),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10476), htonl(0xc0a80109), htons(10476),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10483), htonl(0xc0a80109), htons(10483),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10491), htonl(0xc0a80109), htons(10491),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10492), htonl(0xc0a80109), htons(10492),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10979), htonl(0xc0a80109), htons(10979),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10983), htonl(0xc0a80109), htons(10983),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10987), htonl(0xc0a80109), htons(10987),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10991), htonl(0xc0a80109), htons(10991),  htonl(0xc0a8010a), htons(50017)},
+	{0, htonl(0xc0a8000a), htons(10548), htonl(0xc0a80109), htons(10548),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10753), htonl(0xc0a80109), htons(10753),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10754), htonl(0xc0a80109), htons(10754),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10757), htonl(0xc0a80109), htons(10757),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10761), htonl(0xc0a80109), htons(10761),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10762), htonl(0xc0a80109), htons(10762),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10765), htonl(0xc0a80109), htons(10765),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10769), htonl(0xc0a80109), htons(10769),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10770), htonl(0xc0a80109), htons(10770),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10773), htonl(0xc0a80109), htons(10773),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10777), htonl(0xc0a80109), htons(10777),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10778), htonl(0xc0a80109), htons(10778),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10781), htonl(0xc0a80109), htons(10781),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10801), htonl(0xc0a80109), htons(10801),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10802), htonl(0xc0a80109), htons(10802),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10805), htonl(0xc0a80109), htons(10805),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10810), htonl(0xc0a80109), htons(10810),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10813), htonl(0xc0a80109), htons(10813),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10982), htonl(0xc0a80109), htons(10982),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10990), htonl(0xc0a80109), htons(10990),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10998), htonl(0xc0a80109), htons(10998),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(11006), htonl(0xc0a80109), htons(11006),  htonl(0xc0a8010a), htons(50018)},
+	{0, htonl(0xc0a8000a), htons(10805), htonl(0xc0a80109), htons(10805),  htonl(0xc0a8010a), htons(50020)},
+	{0, htonl(0xc0a8000a), htons(10806), htonl(0xc0a80109), htons(10806),  htonl(0xc0a8010a), htons(50024)},
+	{0, htonl(0xc0a8000a), htons(10548), htonl(0xc0a80109), htons(10548),  htonl(0xc0a8010a), htons(50026)},
+	{0, htonl(0xc0a8000a), htons(10810), htonl(0xc0a80109), htons(10810),  htonl(0xc0a8010a), htons(50026)},
+	{0, htonl(0xc0a8000a), htons(10981), htonl(0xc0a80109), htons(10981),  htonl(0xc0a8010a), htons(50026)},
+	{0, htonl(0xc0a8000a), htons(10989), htonl(0xc0a80109), htons(10989),  htonl(0xc0a8010a), htons(50026)},
+	{0, htonl(0xc0a8000a), htons(10757), htonl(0xc0a80109), htons(10757),  htonl(0xc0a8010a), htons(50036)},
+	{0, htonl(0xc0a8000a), htons(10765), htonl(0xc0a80109), htons(10765),  htonl(0xc0a8010a), htons(50036)},
+	{0, htonl(0xc0a8000a), htons(10773), htonl(0xc0a80109), htons(10773),  htonl(0xc0a8010a), htons(50046)},
+	{0, htonl(0xc0a8000a), htons(10781), htonl(0xc0a80109), htons(10781),  htonl(0xc0a8010a), htons(50046)},
+	{0, htonl(0xc0a8000a), htons(10113), htonl(0xc0a80109), htons(10113),  htonl(0xc0a8010a), htons(50112)},
+	{0, htonl(0xc0a8000a), htons(10117), htonl(0xc0a80109), htons(10117),  htonl(0xc0a8010a), htons(50112)},
+	{0, htonl(0xc0a8000a), htons(10121), htonl(0xc0a80109), htons(10121),  htonl(0xc0a8010a), htons(50112)},
+	{0, htonl(0xc0a8000a), htons(10125), htonl(0xc0a80109), htons(10125),  htonl(0xc0a8010a), htons(50112)},
+	{0, htonl(0xc0a8000a), htons(10173), htonl(0xc0a80109), htons(10173),  htonl(0xc0a8010a), htons(50112)},
+	{0, htonl(0xc0a8000a), htons(10116), htonl(0xc0a80109), htons(10116),  htonl(0xc0a8010a), htons(50113)},
+	{0, htonl(0xc0a8000a), htons(10120), htonl(0xc0a80109), htons(10120),  htonl(0xc0a8010a), htons(50113)},
+	{0, htonl(0xc0a8000a), htons(10124), htonl(0xc0a80109), htons(10124),  htonl(0xc0a8010a), htons(50113)},
+	{0, htonl(0xc0a8000a), htons(10164), htonl(0xc0a80109), htons(10164),  htonl(0xc0a8010a), htons(50113)},
+	{0, htonl(0xc0a8000a), htons(10172), htonl(0xc0a80109), htons(10172),  htonl(0xc0a8010a), htons(50113)},
+	{0, htonl(0xc0a8000a), htons(10149), htonl(0xc0a80109), htons(10149),  htonl(0xc0a8010a), htons(50116)},
+	{0, htonl(0xc0a8000a), htons(10173), htonl(0xc0a80109), htons(10173),  htonl(0xc0a8010a), htons(50116)},
+	{0, htonl(0xc0a8000a), htons(10320), htonl(0xc0a80109), htons(10320),  htonl(0xc0a8010a), htons(50117)},
+	{0, htonl(0xc0a8000a), htons(10114), htonl(0xc0a80109), htons(10114),  htonl(0xc0a8010a), htons(50122)},
+	{0, htonl(0xc0a8000a), htons(10122), htonl(0xc0a80109), htons(10122),  htonl(0xc0a8010a), htons(50122)},
+	{0, htonl(0xc0a8000a), htons(10126), htonl(0xc0a80109), htons(10126),  htonl(0xc0a8010a), htons(50122)},
+	{0, htonl(0xc0a8000a), htons(10123), htonl(0xc0a80109), htons(10123),  htonl(0xc0a8010a), htons(50123)},
+	{0, htonl(0xc0a8000a), htons(10127), htonl(0xc0a80109), htons(10127),  htonl(0xc0a8010a), htons(50123)},
+	{0, htonl(0xc0a8000a), htons(10139), htonl(0xc0a80109), htons(10139),  htonl(0xc0a8010a), htons(50171)}
+	};
+
+	memset(&rtl865xPrio, 0, sizeof(rtl865x_priority));
+
+	for (i = 0; i < 512; i++)
+	{
+
+		naptEntry = &p[i];
+
+		rtl865x_addNaptConnection(naptEntry, &rtl865xPrio);
+
+		in = rtl8651_naptTcpUdpTableIndex((uint8)naptEntry->protocol,
+			htonl(naptEntry->remIp), htons((uint16)(naptEntry->remPort)),
+			htonl(naptEntry->extIp), htons((uint16)(naptEntry->extPort)));
+		out = rtl8651_naptTcpUdpTableIndex((uint8)naptEntry->protocol,
+			htonl(naptEntry->intIp), htons((uint16)(naptEntry->intPort)),
+			htonl(naptEntry->remIp), htons((uint16)(naptEntry->remPort)));
+
+		pr_err("UDP %u.%u.%u.%u:%u <--> %u.%u.%u.%u:%u <--> %u.%u.%u.%u:%u up %3d down %3d\n",
+			NIPQUAD(naptEntry->intIp), htons((uint16)(naptEntry->intPort)),
+			NIPQUAD(naptEntry->extIp), htons((uint16)(naptEntry->extPort)),
+			NIPQUAD(naptEntry->remIp), htons((uint16)(naptEntry->remPort)),
+			out, in);
+	}
+	#endif /* CONFIG_RTL_LAYERED_DRIVER_L4 */
+}
+
+static int32 proc_test_napt_read(struct seq_file *s, void *v)
+{
+
+	seq_printf(s, "NAPT test mode is %d\n", rtl_test_napt_mode);
+
+	return 0;
+}
+
+
+static int32 proc_test_napt_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[80];
+	int32 mode;
+
+	if (len > 80) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+
+		mode = simple_strtol(tmpbuf, NULL, 0);
+
+		if (mode > 0 && mode != rtl_test_napt_mode) {
+			rtl_test_napt_mode = mode;
+			pr_err("Enable HW NAPT test mode\n");
+			rtl_fill_hw_napt_table();
+
+		} else if (mode == 0 && mode != rtl_test_napt_mode) {
+			rtl_test_napt_mode = mode;
+			pr_err("Disable HW NAPT test mode\n");
+			#if defined(CONFIG_RTL_LAYERED_DRIVER_L4)
+			rtl865x_nat_reinit();
+			#endif /* CONFIG_RTL_LAYERED_DRIVER_L4 */
+		}
+	} else {
+errout:
+		rtlglue_printf("error input\n");
+	}
+
+	return len;
+}
+
+int test_napt_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, proc_test_napt_read, NULL));
+}
+
+static ssize_t test_napt_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return proc_test_napt_write(file, userbuf, count, off);
+}
+
+struct file_operations test_napt_proc_fops = {
+	.open = test_napt_single_open,
+	.write = test_napt_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/* end of debug NAPT hash entries */
+
+static int32 proc_rgmii_read(struct seq_file *s, void *v)
+{
+	uint32_t regData;
+	uint32_t temp;
+
+	seq_printf(s, "Dump RGMII Configuration:\n\n");
+
+	/* P0 RGMII */
+	regData = READ_MEM32(P0GMIICR);
+	seq_printf(s, "Port0 : 0x%08X\n", regData);
+
+	seq_printf(s, "# TX CPU tag: %s\n",
+		(regData & CFG_TX_CPUC_TAG) ? "Enabled" : "Disabled");
+	seq_printf(s, "# CPU tag: %s\n",
+		(regData & CFG_CPUC_TAG) ? "Enabled" : "Disabled");
+
+	seq_printf(s, "# MAC interface mode: ");
+	temp = (regData & CFG_GMAC_MASK);
+	switch (temp) {
+	case CFG_GMAC_RGMII:
+		seq_printf(s, "RGMII mode\n");
+		break;
+	case CFG_GMAC_GMII_MII_MAC:
+		seq_printf(s, "GMII/MII MAC mode\n");
+		break;
+	case CFG_GMAC_GMII_MII_PHY:
+		seq_printf(s, "GMII/MII PHY mode\n");
+		break;
+	case CFG_GMAC_Reserved:
+	default:
+		seq_printf(s, "Reserved\n");
+	}
+
+	temp = ((regData & CF_SEL_RGTXC_MASK) >> CF_SEL_RGTXC_OFFSET) |
+		((regData & (1 << 4)) ? (1 << 2) : 0);
+	seq_printf(s, "# TX delay: %d x 0.5ns\n", temp);
+	seq_printf(s, "# RX delay: %d x 0.5ns\n", (regData & 7));
+	seq_printf(s, "# Config done: %s\n\n",
+		(regData & Conf_done) ? "Yes" : "No");
+
+	/* P5 RGMII */
+	regData = READ_MEM32(P5GMIICR);
+	seq_printf(s, "Port5 : 0x%08X\n", regData);
+
+	seq_printf(s, "# TX CPU tag: %s\n",
+		(regData & CFG_TX_CPUC_TAG) ? "Enabled" : "Disabled");
+	seq_printf(s, "# CPU tag: %s\n",
+		(regData & CFG_CPUC_TAG) ? "Enabled" : "Disabled");
+
+	seq_printf(s, "# MAC interface mode: ");
+	temp = (regData & CFG_GMAC_MASK);
+	switch (temp) {
+	case CFG_GMAC_RGMII:
+		seq_printf(s, "RGMII mode\n");
+		break;
+	case CFG_GMAC_GMII_MII_MAC:
+		seq_printf(s, "GMII/MII MAC mode\n");
+		break;
+	case CFG_GMAC_GMII_MII_PHY:
+		seq_printf(s, "GMII/MII PHY mode\n");
+		break;
+	case CFG_GMAC_Reserved:
+	default:
+		seq_printf(s, "Reserved\n");
+	}
+
+	temp = ((regData & CF_SEL_RGTXC_MASK) >> CF_SEL_RGTXC_OFFSET) |
+		((regData & (1 << 4)) ? (1 << 2) : 0);
+	seq_printf(s, "# TX delay: %d x 0.5ns\n", temp);
+	seq_printf(s, "# RX delay: %d x 0.5ns\n", (regData & 7));
+	seq_printf(s, "# Config done: %s\n\n",
+		(regData & Conf_done) ? "Yes" : "No");
+
+	return 0;
+}
+
+
+static int32 proc_rgmii_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[512];
+	char *strptr;
+	char *cmdptr;
+	uint32 portNum = 0xFFFFFFFF;
+	uint32 *regAddr;
+	uint32 regData;
+	uint32 txDelay, rxDelay;
+
+	if (len > 512) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+
+		strptr = tmpbuf;
+
+		if (strlen(strptr) == 0) {
+			goto errout;
+		}
+
+		cmdptr = strsep(&strptr, " ");
+		if (cmdptr == NULL) {
+			goto errout;
+		}
+
+		/*parse command */
+		if (strncmp(cmdptr, "port", 4) == 0) {
+			cmdptr = strsep(&strptr, " ");
+			if (cmdptr == NULL) {
+				goto errout;
+			}
+			portNum = simple_strtol(cmdptr, NULL, 0);
+			switch (portNum) {
+			case PHY0:
+				regAddr = (uint32 *)P0GMIICR;
+				break;
+			case PHY5:
+				regAddr = (uint32 *)P5GMIICR;
+				break;
+			default:
+				pr_err("RGMII is not existed in port %d\n", portNum);
+				goto errout;
+			}
+
+			cmdptr = strsep(&strptr, " ");
+			if (cmdptr == NULL) {
+				goto errout;
+			}
+
+			if (strncmp(cmdptr, "delay", 5) == 0) {
+				/* port 0/5 delay [tx delay] [rx delay] */
+				cmdptr = strsep(&strptr, " ");
+				if (cmdptr == NULL) {
+					goto errout;
+				}
+				txDelay = simple_strtol(cmdptr, NULL, 0);
+				if (txDelay > 7) {
+					pr_err("valid tx delay is between 0 and 7\n");
+					goto errout;
+				}
+
+				cmdptr = strsep(&strptr, " ");
+				if (cmdptr == NULL) {
+					goto errout;
+				}
+				rxDelay = simple_strtol(cmdptr, NULL, 0);
+				if (rxDelay > 7) {
+					pr_err("valid rx delay is between 0 and 7\n");
+					goto errout;
+				}
+
+				regData = READ_MEM32(regAddr) &
+					~((7 << 0) | (1 << 4) | CF_SEL_RGTXC_MASK);
+				regData |= (txDelay & 3) << CF_SEL_RGTXC_OFFSET |
+					   ((txDelay & (1 << 2)) ? (1 << 4) : 0) |
+					   rxDelay;
+				pr_err("Port %d RGMII new tx delay %d, rx delay %d\n"
+					"old data 0x%08X, new data 0x%08X\n",
+					portNum, txDelay, rxDelay,
+					READ_MEM32(regAddr), regData);
+				WRITE_MEM32(regAddr, regData);
+			} else {
+				goto errout;
+			}
+		} else {
+			goto errout;
+		}
+	} else {
+errout:
+		rtlglue_printf("error input\n");
+	}
+
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rtl865x_proc_mibCounter_read(struct seq_file *s, void *v)
+{
+	uint32 i;
+	extern uint32 rtl8651_returnAsicCounter(uint32 offset);
+	extern uint64 rtl865xC_returnAsicCounter64(uint32 offset);
+
+	for (i = 0; i <= RTL8651_PORT_NUMBER; i++) {
+		uint32 addrOffset_fromP0 = i * MIB_ADDROFFSETBYPORT;
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) || defined(CONFIG_RTL_8197F)
+		if (i == 5)
+			continue;
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+		if (i == RTL8651_PORT_NUMBER)
+			seq_printf(s, "<CPU port (extension port included)>\n");
+		else
+			seq_printf(s, "<Port: %d>\n", i);
+
+		seq_printf(s, "Rx counters\n");
+		seq_printf(s,
+			"	 Rcv %llu bytes, TpPortInDiscard %u, DropEvent %u",
+			rtl865xC_returnAsicCounter64(OFFSET_IFINOCTETS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0),
+			rtl8651_returnAsicCounter(OFFSET_ETHERSTATSDROPEVENTS_P0
+				+ addrOffset_fromP0));
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) || \
+	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		seq_printf(s, ", QmDiscard  %u",
+			rtl8651_returnAsicCounter(OFFSET_QMDISCARDCNT_P0 +
+				addrOffset_fromP0));
+#endif
+		seq_printf(s,
+			"\n	 CRCAlignErr %u, SymbolErr %u, FragErr %u, JabberErr %u\n",
+			rtl8651_returnAsicCounter
+			(OFFSET_DOT3STATSFCSERRORS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_DOT3STATSSYMBOLERRORS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSFRAGMEMTS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSJABBERS_P0 + addrOffset_fromP0));
+		seq_printf(s,
+			"	 Unicast %u pkts, Multicast %u pkts, Broadcast %u pkts\n",
+			rtl8651_returnAsicCounter(OFFSET_IFINUCASTPKTS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSMULTICASTPKTS_P0 + addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSBROADCASTPKTS_P0 +
+				addrOffset_fromP0));
+		seq_printf(s,
+			"	 < 64: %u pkts, 64: %u pkts, 65 -127: %u pkts, 128 -255: %u pkts\n",
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSUNDERSIZEPKTS_P0 + addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSPKTS64OCTETS_P0 + addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSPKTS65TO127OCTETS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSPKTS128TO255OCTETS_P0 +
+				addrOffset_fromP0));
+		seq_printf(s,
+			"	 256 - 511: %u pkts, 512 - 1023: %u pkts, 1024 - 1518: %u pkts\n",
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSPKTS256TO511OCTETS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSPKTS512TO1023OCTETS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSPKTS1024TO1518OCTETS_P0 +
+				addrOffset_fromP0));
+		seq_printf(s,
+			"	 oversize: %u pkts, Control unknown %u pkts, Pause %u pkts\n",
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSOVERSIZEPKTS_P0 + addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_DOT3CONTROLINUNKNOWNOPCODES_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter(OFFSET_DOT3INPAUSEFRAMES_P0 +
+				addrOffset_fromP0));
+
+		seq_printf(s, "Output counters\n");
+		seq_printf(s,
+			"	 Snd %llu bytes, Unicast %u pkts, Multicast %u pkts\n",
+			rtl865xC_returnAsicCounter64(OFFSET_IFOUTOCTETS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter(OFFSET_IFOUTUCASTPKTS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter(OFFSET_IFOUTMULTICASTPKTS_P0 +
+				addrOffset_fromP0));
+		seq_printf(s,
+			"	 Broadcast %u pkts, Late collision %u, Deferred transmission %u\n",
+			rtl8651_returnAsicCounter(OFFSET_IFOUTBROADCASTPKTS_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_DOT3STATSLATECOLLISIONS_P0 + addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_DOT3STATSDEFERREDTRANSMISSIONS_P0 +
+				addrOffset_fromP0));
+		seq_printf(s,
+			"	 Collisions %u, Single collision %u, Multiple collision %u, pause %u\n",
+			rtl8651_returnAsicCounter(OFFSET_ETHERSTATSCOLLISIONS_P0
+				+ addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_DOT3STATSSINGLECOLLISIONFRAMES_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter
+			(OFFSET_DOT3STATSMULTIPLECOLLISIONFRAMES_P0 +
+				addrOffset_fromP0),
+			rtl8651_returnAsicCounter(OFFSET_DOT3OUTPAUSEFRAMES_P0 +
+				addrOffset_fromP0));
+
+	}
+
+	seq_printf(s, "<Whole system counters>\n");
+	seq_printf(s, "	 CpuEvent %u pkts\n",
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSCPUEVENTPKT));
+
+	/* return SUCCESS; */
+
+	/* rtl865xC_dumpAsicDiagCounter(s); */
+	return 0;
+}
+#else
+static int32 rtl865x_proc_mibCounter_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+
+	rtl865xC_dumpAsicDiagCounter(page, &len);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8198C_8367RB) || defined(CONFIG_RTL_836X_SUPPORT)
+extern uint32 r8367_cpu_port;
+extern rtk_stat_port_cntr_t port_cntrs;
+extern spinlock_t rtl836x_ext_lock;
+
+void display_8367r_port_stat(uint32 port, rtk_stat_port_cntr_t *pPort_cntrs)
+{
+	if (port > 4)
+		rtlglue_printf("\n<CPU port>\n");
+	else
+		rtlglue_printf("\n<Port: %d>\n", port);
+
+	rtlglue_printf("Rx counters\n");
+
+	rtlglue_printf("   ifInOctets  %llu\n", pPort_cntrs->ifInOctets);
+	rtlglue_printf("   etherStatsOctets  %llu\n",
+		pPort_cntrs->etherStatsOctets);
+	rtlglue_printf("   ifInUcastPkts  %u\n", pPort_cntrs->ifInUcastPkts);
+	rtlglue_printf("   ifInMulticastPkts %u\n",
+		pPort_cntrs->ifInMulticastPkts);
+	rtlglue_printf("   ifInBroadcastPkts %u\n",
+		pPort_cntrs->ifInBroadcastPkts);
+
+	rtlglue_printf("   StatsFCSErrors  %u\n",
+		pPort_cntrs->dot3StatsFCSErrors);
+	rtlglue_printf("   StatsSymbolErrors  %u\n",
+		pPort_cntrs->dot3StatsSymbolErrors);
+	rtlglue_printf("   InPauseFrames  %u\n",
+		pPort_cntrs->dot3InPauseFrames);
+	rtlglue_printf("   ControlInUnknownOpcodes  %u\n",
+		pPort_cntrs->dot3ControlInUnknownOpcodes);
+	rtlglue_printf("   etherStatsFragments  %u\n",
+		pPort_cntrs->etherStatsFragments);
+	rtlglue_printf("   etherStatsJabbers  %u\n",
+		pPort_cntrs->etherStatsJabbers);
+	rtlglue_printf("   etherStatsDropEvents  %u\n",
+		pPort_cntrs->etherStatsDropEvents);
+
+	rtlglue_printf("   etherStatsUndersizePkts  %u\n",
+		pPort_cntrs->etherStatsUndersizePkts);
+	rtlglue_printf("   etherStatsOversizePkts  %u\n",
+		pPort_cntrs->etherStatsOversizePkts);
+
+	rtlglue_printf("   Len= 64: %u pkts, 65 - 127: %u pkts, 128 - 255: %u pkts\n",
+		pPort_cntrs->etherStatsPkts64Octets,
+		pPort_cntrs->etherStatsPkts65to127Octets,
+		pPort_cntrs->etherStatsPkts128to255Octets);
+	rtlglue_printf("       256 - 511: %u pkts, 512 - 1023: %u pkts, 1024 - 1518: %u pkts\n",
+		pPort_cntrs->etherStatsPkts256to511Octets,
+		pPort_cntrs->etherStatsPkts512to1023Octets,
+		pPort_cntrs->etherStatsPkts1024toMaxOctets);
+
+	rtlglue_printf("\nOutput counters\n");
+
+	rtlglue_printf("   ifOutOctets  %llu\n", pPort_cntrs->ifOutOctets);
+	rtlglue_printf("   ifOutUcastPkts  %u\n", pPort_cntrs->ifOutUcastPkts);
+	rtlglue_printf("   ifOutMulticastPkts  %u\n",
+		pPort_cntrs->ifOutMulticastPkts);
+	rtlglue_printf("   ifOutBrocastPkts  %u\n",
+		pPort_cntrs->ifOutBrocastPkts);
+
+	rtlglue_printf("   StatsSingleCollisionFrames  %u\n",
+		pPort_cntrs->dot3StatsSingleCollisionFrames);
+	rtlglue_printf("   StatsMultipleCollisionFrames  %u\n",
+		pPort_cntrs->dot3StatsMultipleCollisionFrames);
+	rtlglue_printf("   StatsDeferredTransmissions  %u\n",
+		pPort_cntrs->dot3StatsDeferredTransmissions);
+	rtlglue_printf("   StatsLateCollisions  %u\n",
+		pPort_cntrs->dot3StatsLateCollisions);
+	rtlglue_printf("   etherStatsCollisions  %u\n",
+		pPort_cntrs->etherStatsCollisions);
+	rtlglue_printf("   StatsExcessiveCollisions  %u\n",
+		pPort_cntrs->dot3StatsExcessiveCollisions);
+	rtlglue_printf("   OutPauseFrames  %u\n",
+		pPort_cntrs->dot3OutPauseFrames);
+	rtlglue_printf("   dot1dBasePortDelayExceededDiscards  %u\n",
+		pPort_cntrs->dot1dBasePortDelayExceededDiscards);
+	rtlglue_printf("   dot1dTpPortInDiscards  %u\n",
+		pPort_cntrs->dot1dTpPortInDiscards);
+	rtlglue_printf("   outOampduPkts  %u\n", pPort_cntrs->outOampduPkts);
+	rtlglue_printf("   inOampduPkts  %u\n", pPort_cntrs->inOampduPkts);
+	rtlglue_printf("   pktgenPkts  %u\n", pPort_cntrs->pktgenPkts);
+
+}
+#endif
+
+#ifdef CONFIG_RTL_8370_SUPPORT
+extern rtk_stat_port_cntr_t port_cntrs;
+
+void display_8370_port_stat(uint32 port, rtk_stat_port_cntr_t *p)
+{
+	if (port == 9)
+		rtlglue_printf("\n<CPU port>\n");
+	else
+		rtlglue_printf("\n<Port: %d>\n", port);
+
+	rtlglue_printf("Rx counters:\n");
+
+	rtlglue_printf("   Rcv %llu bytes, Unicast %u pkts, Multicast %u pkts, Broadcast %u pkts\n",
+		p->ifInOctets, p->ifInUcastPkts, p->etherStatsMcastPkts,
+		p->etherStatsBcastPkts);
+	rtlglue_printf("   64: %u pkts, 65 -127: %u pkts, 128 -255: %u pkts\n",
+		p->etherStatsPkts64Octets, p->etherStatsPkts65to127Octets,
+		p->etherStatsPkts128to255Octets);
+	rtlglue_printf("   256 - 511: %u pkts, 512 - 1023: %u pkts, 1024 - max: %u pkts\n",
+		p->etherStatsPkts256to511Octets,
+		p->etherStatsPkts512to1023Octets,
+		p->etherStatsPkts1024toMaxOctets);
+	rtlglue_printf("   Drop: %u, FCSError: %u, Fragment: %u, JabberErr: %u\n",
+		p->etherStatsDropEvents, p->dot3StatsFCSErrors,
+		p->etherStatsFragments, p->etherStatsJabbers);
+	rtlglue_printf("   OverSize: %u, UnderSize: %u, Unknown: %u, inOampdu: %u\n",
+		p->etherStatsOversizePkts, p->etherStatsUndersizePkts,
+		p->dot3ControlInUnknownOpcodes, p->inOampduPkts);
+	rtlglue_printf("   PortInDiscard: %u, SymbolErr: %u, Pause: %u\n",
+		p->dot1dTpPortInDiscards, p->dot3StatsSymbolErrors,
+		p->dot3InPauseFrames);
+	rtlglue_printf("   etherStatsOctets  %llu\n", p->etherStatsOctets);
+
+	rtlglue_printf("\nOutput counters:\n");
+
+	rtlglue_printf("   Snd %llu bytes, Unicast %u pkts, Multicast %u pkts, Broadcast %u pkts\n",
+		p->ifOutOctets, p->ifOutUcastPkts, p->ifOutMulticastPkts,
+		p->ifOutBrocastPkts);
+	rtlglue_printf("   Collision: %u, SingleCol: %u, MultipleCol: %u, LateCol: %u\n",
+		p->etherStatsCollisions, p->dot3StatsSingleCollisionFrames,
+		p->dot3StatsMultipleCollisionFrames,
+		p->dot3StatsLateCollisions);
+	rtlglue_printf("   ExcessiveCol: %u, DeferredTx: %u, DelayExceededDiscard: %u\n",
+		p->dot3StatsExcessiveCollisions,
+		p->dot3StatsDeferredTransmissions,
+		p->dot1dBasePortDelayExceededDiscards);
+	rtlglue_printf("   outOampdu: %u, pktgen: %u, Pause: %u\n",
+		p->outOampduPkts, p->pktgenPkts, p->dot3OutPauseFrames);
+}
+#endif
+
+static int32 rtl865x_proc_mibCounter_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[512];
+	char *strptr;
+	char *cmdptr;
+	uint32 portNum = 0xFFFFFFFF;
+
+	if (len > 512) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+
+		strptr = tmpbuf;
+
+		if (strlen(strptr) == 0) {
+			goto errout;
+		}
+
+		cmdptr = strsep(&strptr, " ");
+		if (cmdptr == NULL) {
+			goto errout;
+		}
+
+		/*parse command */
+		if (strncmp(cmdptr, "clear", 5) == 0) {
+			rtl8651_clearAsicCounter();
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT) || defined(CONFIG_RTL_8325D_SUPPORT) || defined(CONFIG_RTL_8198C_8367RB) || defined(CONFIG_RTL_836X_SUPPORT)
+			spin_lock(&rtl836x_ext_lock);
+			rtk_stat_global_reset();
+			spin_unlock(&rtl836x_ext_lock);
+#endif
+		} else if (strncmp(cmdptr, "dump", 4) == 0) {
+			cmdptr = strsep(&strptr, " ");
+			if (cmdptr == NULL) {
+				goto errout;
+			}
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8198C_8367RB)
+			if (strncmp(cmdptr, "8367", 4) == 0) {
+
+				for (portNum = 0; portNum < 7; portNum++) {
+					if ((portNum > 4) && (portNum != r8367_cpu_port))	/* skip port 6 in 8367R; skip port 5 in 8367RB */
+						continue;
+
+					memset(&port_cntrs, 0,
+						sizeof(rtk_stat_port_cntr_t));
+					rtk_stat_port_getAll(portNum,
+						&port_cntrs);
+					display_8367r_port_stat(portNum,
+						&port_cntrs);
+				}
+				return len;
+			}
+#endif
+#ifdef CONFIG_RTL_8370_SUPPORT
+			if (strncmp(cmdptr, "8370", 4) == 0) {	/* 8370 or 83700 ~ 83709 */
+
+				if ((cmdptr[4] >= '0') && (cmdptr[4] <= '9')) {
+					memset(&port_cntrs, 0,
+						sizeof(rtk_stat_port_cntr_t));
+					rtk_stat_port_getAll((cmdptr[4] - '0'),
+						&port_cntrs);
+					display_8370_port_stat((cmdptr[4] -
+							'0'), &port_cntrs);
+				} else {
+					for (portNum = 0; portNum <= 9;
+						portNum++) {
+						memset(&port_cntrs, 0,
+							sizeof
+							(rtk_stat_port_cntr_t));
+						rtk_stat_port_getAll(portNum,
+							&port_cntrs);
+						display_8370_port_stat(portNum,
+							&port_cntrs);
+					}
+				}
+				return len;
+			}
+#endif
+#ifdef CONFIG_RTL_8325D_SUPPORT
+			if (strncmp(cmdptr, "8325", 4) == 0) {	/* 8325 or 83250 ~ 8325g */
+				extern int32 rtl8325d_mibCounter_dump(int port);
+
+				if ((cmdptr[4] >= '0') && (cmdptr[4] <= '9')) {
+					rtl8325d_mibCounter_dump((cmdptr[4] -
+							'0'));
+				} else if ((cmdptr[4] >= 'a')
+					&& (cmdptr[4] <= 'f')) {
+					rtl8325d_mibCounter_dump((cmdptr[4] -
+							'a' + 10));
+				} else if ((cmdptr[4] == 'g')) {
+					rtl8325d_mibCounter_dump(24);
+				} else {
+					for (portNum = 0; portNum < 16;
+						portNum++) {
+						rtl8325d_mibCounter_dump
+							(portNum);
+					}
+					rtl8325d_mibCounter_dump(24);
+				}
+				return len;
+			}
+#endif
+#if defined(CONFIG_RTL_836X_SUPPORT)
+			if (strncmp(cmdptr, "836x", 4) == 0) {
+
+				cmdptr = strsep(&strptr, " ");
+				if (cmdptr == NULL) {
+					goto errout;
+				}
+				portNum = simple_strtol(cmdptr, NULL, 0);
+
+				memset(&port_cntrs, 0, sizeof(rtk_stat_port_cntr_t));
+				spin_lock(&rtl836x_ext_lock);
+				rtk_stat_port_getAll(portNum, &port_cntrs);
+				spin_unlock(&rtl836x_ext_lock);
+				display_8367r_port_stat(portNum, &port_cntrs);
+				return len;
+			}
+#endif /* CONFIG_RTL_836X_SUPPORT */
+			if (strncmp(cmdptr, "port", 4) != 0) {
+				goto errout;
+			}
+
+			cmdptr = strsep(&strptr, " ");
+			if (cmdptr == NULL) {
+				goto errout;
+			}
+			portNum = simple_strtol(cmdptr, NULL, 0);
+
+			if ((portNum >= 0) && (portNum <= RTL8651_PORT_NUMBER)) {
+				extern uint32 rtl8651_returnAsicCounter(uint32
+					offset);
+				extern uint64
+					rtl865xC_returnAsicCounter64(uint32
+					offset);
+				uint32 addrOffset_fromP0 =
+					portNum * MIB_ADDROFFSETBYPORT;
+
+				if (portNum == RTL8651_PORT_NUMBER)
+					rtlglue_printf("<CPU port (extension port included)>\n");
+				else
+					rtlglue_printf("<Port: %d>\n", portNum);
+
+				rtlglue_printf("Rx counters\n");
+				rtlglue_printf("   Rcv %llu bytes, TpPortInDiscard %u, DropEvent %u",
+					rtl865xC_returnAsicCounter64
+					(OFFSET_IFINOCTETS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_DOT1DTPPORTINDISCARDS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSDROPEVENTS_P0 +
+						addrOffset_fromP0));
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8881A) || \
+	defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+				rtlglue_printf(", QmDiscard  %u",
+					rtl8651_returnAsicCounter
+					(OFFSET_QMDISCARDCNT_P0 +
+						addrOffset_fromP0));
+#endif
+				rtlglue_printf("\n   CRCAlignErr %u, SymbolErr %u, FragErr %u, JabberErr %u\n",
+					rtl8651_returnAsicCounter
+					(OFFSET_DOT3STATSFCSERRORS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_DOT3STATSSYMBOLERRORS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSFRAGMEMTS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSJABBERS_P0 +
+						addrOffset_fromP0));
+				rtlglue_printf("   Unicast %u pkts, Multicast %u pkts, Broadcast %u pkts\n",
+					rtl8651_returnAsicCounter
+					(OFFSET_IFINUCASTPKTS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSMULTICASTPKTS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSBROADCASTPKTS_P0 +
+						addrOffset_fromP0));
+				rtlglue_printf("   < 64: %u pkts, 64: %u pkts, 65 -127: %u pkts, 128 -255: %u pkts\n",
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSUNDERSIZEPKTS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSPKTS64OCTETS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSPKTS65TO127OCTETS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSPKTS128TO255OCTETS_P0
+						+ addrOffset_fromP0));
+				rtlglue_printf("   256 - 511: %u pkts, 512 - 1023: %u pkts, 1024 - 1518: %u pkts\n",
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSPKTS256TO511OCTETS_P0
+						+ addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSPKTS512TO1023OCTETS_P0
+						+ addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSPKTS1024TO1518OCTETS_P0
+						+ addrOffset_fromP0));
+				rtlglue_printf("   oversize: %u pkts, Control unknown %u pkts, Pause %u pkts\n",
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSOVERSIZEPKTS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_DOT3CONTROLINUNKNOWNOPCODES_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_DOT3INPAUSEFRAMES_P0 +
+						addrOffset_fromP0));
+
+				rtlglue_printf("Output counters\n");
+				rtlglue_printf("   Snd %llu bytes, Unicast %u pkts, Multicast %u pkts\n",
+					rtl865xC_returnAsicCounter64
+					(OFFSET_IFOUTOCTETS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_IFOUTUCASTPKTS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_IFOUTMULTICASTPKTS_P0 +
+						addrOffset_fromP0));
+				rtlglue_printf("   Broadcast %u pkts, Late collision %u, Deferred transmission %u\n",
+					rtl8651_returnAsicCounter
+					(OFFSET_IFOUTBROADCASTPKTS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_DOT3STATSLATECOLLISIONS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_DOT3STATSDEFERREDTRANSMISSIONS_P0
+						+ addrOffset_fromP0));
+				rtlglue_printf("   Collisions %u, Single collision %u, Multiple collision %u, pause %u\n",
+					rtl8651_returnAsicCounter
+					(OFFSET_ETHERSTATSCOLLISIONS_P0 +
+						addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_DOT3STATSSINGLECOLLISIONFRAMES_P0
+						+ addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_DOT3STATSMULTIPLECOLLISIONFRAMES_P0
+						+ addrOffset_fromP0),
+					rtl8651_returnAsicCounter
+					(OFFSET_DOT3OUTPAUSEFRAMES_P0 +
+						addrOffset_fromP0));
+
+			} else {
+				goto errout;
+			}
+		} else {
+			goto errout;
+		}
+
+	} else {
+errout:
+		rtlglue_printf("error input\n");
+	}
+
+	return len;
+}
+
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+extern int rtl_get_portRate(unsigned int port, unsigned long *rxRate,
+	unsigned long *txRate);
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rtl865x_proc_portRate_read(struct seq_file *s, void *v)
+{
+
+	unsigned int port;
+	unsigned long rxRate = 0;
+	unsigned long txRate = 0;
+
+	seq_printf(s, "Port Rate Info:\n");
+	for (port = 0; port < 4; port++) {
+		rtl_get_portRate(port, &rxRate, &txRate);
+		seq_printf(s, "port%d rx:%ld tx:%ld(kbps)\n", port, rxRate,
+			txRate);
+	}
+
+	return 0;
+
+}
+#else
+static int32 rtl865x_proc_portRate_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+
+	int port;
+	unsigned long rxRate = 0;
+	unsigned long txRate = 0;
+
+	len = sprintf(page, "Port Rate Info:\n");
+	for (port = 0; port < 4; port++) {
+		rtl_get_portRate(port, &rxRate, &txRate);
+		len += sprintf(page + len, "port%d rx:%ld tx:%ld(kbps)\n", port,
+			rxRate, txRate);
+	}
+
+	return len;
+
+}
+#endif
+
+static int32 rtl865x_proc_portRate_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 proc_phyReg_read(struct seq_file *s, void *v)
+{
+	return PROC_READ_RETURN_VALUE;
+}
+#else
+static int32 proc_phyReg_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	return PROC_READ_RETURN_VALUE;
+}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 proc_mmd_read(struct seq_file *s, void *v)
+{
+	return PROC_READ_RETURN_VALUE;
+}
+#else
+static int32 proc_mmd_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	return PROC_READ_RETURN_VALUE;
+}
+#endif
+
+extern int32 mmd_read(uint32 phyId, uint32 devId, uint32 regId, uint32 *rData);
+extern int32 mmd_write(uint32 phyId, uint32 devId, uint32 regId, uint32 wData);
+
+/*
+	echo read phy_id device_id reg_addr  > /proc/rtl865x/mmd
+	echo write phy_id device_id reg_addr data_for_write > /proc/rtl865x/mmd
+ */
+static int32 proc_mmd_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[64];
+	uint32 phyId, regId, regData, devId, dataReadBack;
+	char *strptr, *cmd_addr;
+	char *tokptr;
+	int32 ret;
+
+	if (len > 64) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+
+		if (!memcmp(cmd_addr, "read", 4)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			devId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			ret = mmd_read(phyId, devId, regId, &regData);
+
+			if (ret == SUCCESS) {
+				rtlglue_printf("read phyId(%d), devId(%d), regId(%d), regData:0x%x\n",
+					phyId, devId, regId, regData);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		} else if (!memcmp(cmd_addr, "write", 5)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			devId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 0);
+
+			mmd_write(phyId, devId, regId, regData);
+
+			/* confirm result */
+			rtl8651_setAsicEthernetPHYReg(phyId, 13,
+				(devId | 0x4000));
+			ret = rtl8651_getAsicEthernetPHYReg(phyId, 14,
+				&dataReadBack);
+
+			if (ret == SUCCESS) {
+				rtlglue_printf("extWrite phyId(%d), devId(%d), regId(%d), regData:0x%x, regData(read back):0x%x\n",
+					phyId, devId, regId, regData,
+					dataReadBack);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		}
+	} else {
+errout:
+		rtlglue_printf("error input!\n");
+	}
+
+	return len;
+}
+
+static const int _8198_phy_page[] = { 0, 1, 2, 3, 4, 5, 6, 32,
+	33, 34, 35, 36, 40, 44, 45, 46,
+	64, 65, 66, 69, 70, 80, 81, 161
+};
+
+#if defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+void getPhyByPortPage(int port, int page)
+{
+	uint32 regData;
+	int reg;
+
+	/* change page num */
+	if (page >= 31) {
+		rtl8651_setAsicEthernetPHYReg(port, 31, 7);
+		rtl8651_setAsicEthernetPHYReg(port, 30, page);
+	} else if (page > 0) {
+		rtl8651_setAsicEthernetPHYReg(port, 31, page);
+	}
+
+	for (reg = 0; reg < 32; reg++) {
+		rtl8651_getAsicEthernetPHYReg(port, reg, &regData);
+		rtlglue_printf("port:%d,page:%d,regId:%d,regData:0x%x\n", port,
+			page, reg, regData);
+	}
+	/* if(page!=3) */
+	/* { */
+	rtlglue_printf("------------------------------------------\n");
+	/* } */
+
+	/* change back to page 0 */
+	rtl8651_setAsicEthernetPHYReg(port, 31, 0);
+
+}
+
+#elif defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+void getPhyByPortPage(int port, int page)
+{
+	uint32 regData, phyid;
+	int reg;
+
+	if (port == 0)
+		phyid = 8;
+	else
+		phyid = port;
+
+	rtl8651_setAsicEthernetPHYReg(phyid, 31, page);
+
+	for (reg = 0; reg < 32; reg++) {
+		rtl8651_getAsicEthernetPHYReg(phyid, reg, &regData);
+		rtlglue_printf("port:%d,page:0x%x,regId:%d,regData:0x%x\n",
+			port, page, reg, regData);
+	}
+	rtlglue_printf("------------------------------------------\n");
+
+	rtl8651_setAsicEthernetPHYReg(phyid, 31, 0);
+}
+#endif
+
+static int32 proc_phyReg_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[64];
+	uint32 phyId, pageId, regId, regData;
+	char *strptr, *cmd_addr;
+	char *tokptr;
+	int32 ret = 0;
+	int i, j;
+
+	if (len > 64) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+
+		if (!memcmp(cmd_addr, "read", 4)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+#if defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8211F_SUPPORT)
+			if (gpio_simulate_mdc_mdio) {
+				if ((8 > phyId) && (phyId > 4))
+					ret = rtl_mdio_read(phyId, regId,
+						&regData);
+				else
+					ret = rtl8651_getAsicEthernetPHYReg
+						(phyId, regId, &regData);
+			} else
+#endif
+			{
+				ret = rtl8651_getAsicEthernetPHYReg(phyId,
+					regId, &regData);
+			}
+
+			if (ret == SUCCESS) {
+				rtlglue_printf("read phyId(%d), regId(%d),regData:0x%x\n",
+					phyId, regId, regData);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		} else if (!memcmp(cmd_addr, "write", 5)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 0);
+#if defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8211F_SUPPORT)
+			if (gpio_simulate_mdc_mdio) {
+				if ((8 > phyId) && (phyId > 4))
+					ret = rtl_mdio_write(phyId, regId,
+						regData);
+				else
+					ret = rtl8651_setAsicEthernetPHYReg
+						(phyId, regId, regData);
+			} else
+#endif
+			{
+				ret = rtl8651_setAsicEthernetPHYReg(phyId,
+					regId, regData);
+			}
+			if (ret == SUCCESS) {
+				rtlglue_printf("Write phyId(%d), regId(%d), regData:0x%x\n",
+					phyId, regId, regData);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		}
+#ifdef CONFIG_8198_PORT5_RGMII
+		else if (!memcmp(cmd_addr, "8370read", 8)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 16);
+			ret = rtl8370_getAsicReg(regId, &regData);
+
+			if (ret == 0) {
+				rtlglue_printf("rtl8370_getAsicReg: reg= %x, data= %x\n",
+					regId, regData);
+			} else {
+				rtlglue_printf("get fail %d\n", ret);
+			}
+		} else if (!memcmp(cmd_addr, "8370write", 9)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 16);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 16);
+
+			ret = rtl8370_setAsicReg(regId, regData);
+
+			if (ret == 0) {
+				rtlglue_printf("rtl8370_setAsicReg: reg= %x, data= %x\n",
+					regId, regData);
+			} else {
+				rtlglue_printf("set fail %d\n", ret);
+			}
+		}
+#endif
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8198C_8367RB)
+		else if (!memcmp(cmd_addr, "8367read", 8)) {
+			extern int rtl8367b_getAsicReg(unsigned int reg,
+				unsigned int *pValue);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 16);
+			ret = rtl8367b_getAsicReg(regId, &regData);
+
+			if (ret == 0) {
+				rtlglue_printf("rtl8367b_getAsicReg: reg= %x, data= %x\n",
+					regId, regData);
+			} else {
+				rtlglue_printf("get fail %d\n", ret);
+			}
+		} else if (!memcmp(cmd_addr, "8367write", 9)) {
+			extern int rtl8367b_setAsicReg(unsigned int reg,
+				unsigned int pValue);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 16);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 16);
+
+			ret = rtl8367b_setAsicReg(regId, regData);
+
+			if (ret == 0) {
+				rtlglue_printf("rtl8367b_setAsicReg: reg= %x, data= %x\n",
+					regId, regData);
+			} else {
+				rtlglue_printf("set fail %d\n", ret);
+			}
+		} else if (!memcmp(cmd_addr, "8367phyr", 8)) {
+			extern int rtl8367b_getAsicPHYReg(uint32 phyNo,
+				uint32 phyAddr, uint32 *pRegData);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			ret = rtl8367b_getAsicPHYReg(phyId, regId, &regData);
+			if (ret == SUCCESS) {
+				rtlglue_printf("read 8367R/RB phyId(%d), regId(%d), regData:0x%x\n",
+					phyId, regId, regData);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		} else if (!memcmp(cmd_addr, "8367phyw", 8)) {
+			extern int rtl8367b_setAsicPHYReg(uint32 phyNo,
+				uint32 phyAddr, uint32 phyData);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 16);
+
+			ret = rtl8367b_setAsicPHYReg(phyId, regId, regData);
+			if (ret == SUCCESS) {
+				rtlglue_printf("Write 8367R/RB phyId(%d), regId(%d), regData:0x%x\n",
+					phyId, regId, regData);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		} else if (!memcmp(cmd_addr, "8367test", 8)) {
+			extern int rtk_port_phyTestMode_set(uint32 port,
+				int mode);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			if (tokptr[0] == 'm') {
+				extern int rtk_port_phyMdx_set(uint32 port,
+					int mode);
+				if (strncmp(tokptr, "mdi_auto", 8) == 0)
+					regId = 0;	/* PHY_AUTO_CROSSOVER_MODE */
+				else if (strncmp(tokptr, "mdix", 4) == 0)
+					regId = 2;	/* PHY_FORCE_MDIX_MODE */
+				else if (strncmp(tokptr, "mdi", 3) == 0)
+					regId = 1;	/* PHY_FORCE_MDI_MODE */
+				else
+					regId = 3;
+				ret = rtk_port_phyMdx_set(phyId, regId);
+				if (ret == SUCCESS)
+					rtlglue_printf("set 8367RB phyId(%d) to mdi mode: %d\n",
+						phyId, regId);
+				else
+					rtlglue_printf("rtk_port_phyMdx_set return error\n");
+			} else {
+				regId = simple_strtol(tokptr, NULL, 0);
+
+				ret = rtk_port_phyTestMode_set(phyId, regId);
+				if (ret == SUCCESS)
+					rtlglue_printf("set  8367RB phyId(%d) to mode: %d\n",
+						phyId, regId);
+				else
+					rtlglue_printf("rtk_port_phyTestMode_set return error\n");
+			}
+		} else if (!memcmp(cmd_addr, "8367init", 8)) {
+			extern void init_8367r(void);
+
+			init_8367r();
+		}
+#endif
+#ifdef CONFIG_RTL_8370_SUPPORT
+		else if (!memcmp(cmd_addr, "8370read", 8)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			if (!memcmp(tokptr, "l2", 2)) {
+				extern void get_all_L2(void);
+
+				get_all_L2();
+			} else {
+				regId = simple_strtol(tokptr, NULL, 16);
+				ret = rtl8370_getAsicReg(regId, &regData);
+
+				if (ret == 0)
+					rtlglue_printf("rtl8370_getAsicReg: reg= %x, data= %x\n",
+						regId, regData);
+				else
+					rtlglue_printf("get fail %d\n", ret);
+			}
+		} else if (!memcmp(cmd_addr, "8370write", 9)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 16);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 16);
+
+			ret = rtl8370_setAsicReg(regId, regData);
+
+			if (ret == 0) {
+				rtlglue_printf("rtl8370_setAsicReg: reg= %x, data= %x\n",
+					regId, regData);
+			} else {
+				rtlglue_printf("set fail %d\n", ret);
+			}
+		} else if (!memcmp(cmd_addr, "8370phyr", 8)) {
+			extern int rtl8370_getAsicPHYReg(uint32 phyNo,
+				uint32 phyAddr, uint32 *pRegData);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			ret = rtl8370_getAsicPHYReg(phyId, regId, &regData);
+			if (ret == SUCCESS) {
+				rtlglue_printf("read 8370 phyId(%d), regId(%d), regData:0x%x\n",
+					phyId, regId, regData);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		} else if (!memcmp(cmd_addr, "8370phyw", 8)) {
+			extern int rtl8370_setAsicPHYReg(uint32 phyNo,
+				uint32 phyAddr, uint32 phyData);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 16);
+
+			ret = rtl8370_setAsicPHYReg(phyId, regId, regData);
+			if (ret == SUCCESS) {
+				rtlglue_printf("Write 8370 phyId(%d), regId(%d), regData:0x%x\n",
+					phyId, regId, regData);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		} else if (!memcmp(cmd_addr, "8370test", 8)) {
+			extern int rtk_port_phyTestMode_set(uint32 port,
+				int mode);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			ret = rtk_port_phyTestMode_set(phyId, regId);
+			if (ret == SUCCESS) {
+				rtlglue_printf("set 8370 phyId(%d) to mode: %d\n",
+					phyId, regId);
+			} else {
+				rtlglue_printf("rtk_port_phyTestMode_set return error\n");
+			}
+		}
+#endif
+
+#ifdef CONFIG_RTL_8325D_SUPPORT
+		else if (!memcmp(cmd_addr, "8325read", 8)) {
+			int32 rtlglue_reg32_read_data(uint32 reg,
+				uint32 *value);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 16);
+			ret = rtlglue_reg32_read_data(regId, &regData);
+
+			if (ret == 0)
+				rtlglue_printf("reg_read: reg= %x, data= %x\n",
+					regId, regData);
+			else
+				rtlglue_printf("get fail %d\n", ret);
+		} else if (!memcmp(cmd_addr, "8325write", 9)) {
+			int32 rtlglue_reg32_write(uint32 reg, uint32 value);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 16);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 16);
+
+			ret = rtlglue_reg32_write(regId, regData);
+
+			if (ret == 0) {
+				rtlglue_printf("reg_write: reg= %x, data= %x\n",
+					regId, regData);
+			} else {
+				rtlglue_printf("set fail %d\n", ret);
+			}
+		} else if (!memcmp(cmd_addr, "8325phyr", 8)) {
+			extern int32 phy_reg_read(uint32 phyaddr,
+				uint32 regaddr, uint32 page, uint16 *reg_data);
+			uint16 data;
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			ret = phy_reg_read(phyId, regId, 0, &data);
+			if (ret == SUCCESS) {
+				rtlglue_printf("read 8325 phyId(%d), regId(%d), regData:0x%x\n",
+					phyId, regId, data);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		} else if (!memcmp(cmd_addr, "8325phyw", 8)) {
+			extern int32 phy_reg_write(uint32 phyaddr,
+				uint32 regaddr, uint32 page, uint16 reg_data);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 16);
+
+			ret = phy_reg_write(phyId, regId, 0, regData);
+			if (ret == SUCCESS) {
+				rtlglue_printf("Write 8325 phyId(%d), regId(%d), regData:0x%x\n",
+					phyId, regId, regData);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		}
+#endif
+#if defined(CONFIG_RTL_836X_SUPPORT)
+		else if (!memcmp(cmd_addr, "836xread", 8)) {
+			extern int rtl8367c_getAsicReg(unsigned int reg,
+				unsigned int *pValue);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 16);
+			spin_lock(&rtl836x_ext_lock);
+			ret = rtl8367c_getAsicReg(regId, &regData);
+			spin_unlock(&rtl836x_ext_lock);
+
+			if (ret == 0) {
+				rtlglue_printf("rtl8367c_getAsicReg: reg= %x, data= %x\n",
+					regId, regData);
+			} else {
+				rtlglue_printf("get fail %d\n", ret);
+			}
+		} else if (!memcmp(cmd_addr, "836xwrite", 9)) {
+			extern int rtl8367c_setAsicReg(unsigned int reg,
+				unsigned int pValue);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 16);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 16);
+
+			spin_lock(&rtl836x_ext_lock);
+			ret = rtl8367c_setAsicReg(regId, regData);
+			spin_unlock(&rtl836x_ext_lock);
+
+			if (ret == 0) {
+				rtlglue_printf("rtl8367c_setAsicReg: reg= %x, data= %x\n",
+					regId, regData);
+			} else {
+				rtlglue_printf("set fail %d\n", ret);
+			}
+		} else if (!memcmp(cmd_addr, "836xphyr", 8)) {
+			extern int rtl8367c_getAsicPHYReg(uint32 phyNo,
+				uint32 phyAddr, uint32 *pRegData);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			spin_lock(&rtl836x_ext_lock);
+			ret = rtl8367c_getAsicPHYReg(phyId, regId, &regData);
+			spin_unlock(&rtl836x_ext_lock);
+			if (ret == SUCCESS) {
+				rtlglue_printf("read 8367R/RB phyId(%d), regId(%d), regData:0x%x\n",
+					phyId, regId, regData);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		} else if (!memcmp(cmd_addr, "836xphyw", 8)) {
+			extern int rtl8367c_setAsicPHYReg(uint32 phyNo,
+				uint32 phyAddr, uint32 phyData);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 16);
+
+			spin_lock(&rtl836x_ext_lock);
+			ret = rtl8367c_setAsicPHYReg(phyId, regId, regData);
+			spin_unlock(&rtl836x_ext_lock);
+			if (ret == SUCCESS) {
+				rtlglue_printf("Write 8367R/RB phyId(%d), regId(%d), regData:0x%x\n",
+					phyId, regId, regData);
+			} else {
+				rtlglue_printf("error input!\n");
+			}
+		}
+#endif /* CONFIG_RTL_836X_SUPPORT */
+		else if (!memcmp(cmd_addr, "extRead", 7)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			pageId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			/* switch page */
+#if !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F)
+			if (pageId >= 31) {
+				rtl8651_setAsicEthernetPHYReg(phyId, 31, 7);
+				rtl8651_setAsicEthernetPHYReg(phyId, 30,
+					pageId);
+			} else
+#endif
+#if defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8211F_SUPPORT)
+			if (gpio_simulate_mdc_mdio) {
+				if ((8 > phyId) && (phyId > 4)) {
+					if (pageId > 0) {
+						rtl_mdio_write(phyId, 31,
+							pageId);
+					}
+
+					ret = rtl_mdio_read(phyId, regId,
+						&regData);
+
+					if (ret == SUCCESS) {
+						rtlglue_printf("extRead phyId(%d), pageId(%d), regId(%d), regData:0x%x\n",
+							phyId, pageId, regId,
+							regData);
+					} else {
+						rtlglue_printf("error input!\n");
+					}
+
+					/* change back to page 0 */
+					rtl_mdio_write(phyId, 31, 0);
+				} else {
+					if (pageId > 0) {
+						rtl8651_setAsicEthernetPHYReg
+							(phyId, 31, pageId);
+					}
+
+					ret = rtl8651_getAsicEthernetPHYReg
+						(phyId, regId, &regData);
+
+					if (ret == SUCCESS) {
+						rtlglue_printf("extRead phyId(%d), pageId(%d), regId(%d), regData:0x%x\n",
+							phyId, pageId, regId,
+							regData);
+					} else {
+						rtlglue_printf("error input!\n");
+					}
+
+					/* change back to page 0 */
+					rtl8651_setAsicEthernetPHYReg(phyId, 31,
+						0);
+				}
+			} else
+#endif
+			{
+				if (pageId > 0) {
+					rtl8651_setAsicEthernetPHYReg(phyId, 31,
+						pageId);
+				}
+
+				ret = rtl8651_getAsicEthernetPHYReg(phyId,
+					regId, &regData);
+
+				if (ret == SUCCESS) {
+					rtlglue_printf("extRead phyId(%d), pageId(%d), regId(%d), regData:0x%x\n",
+						phyId, pageId, regId, regData);
+				} else {
+					rtlglue_printf("error input!\n");
+				}
+
+				/* change back to page 0 */
+				rtl8651_setAsicEthernetPHYReg(phyId, 31, 0);
+			}
+
+		} else if (!memcmp(cmd_addr, "extWrite", 8)) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			pageId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regData = simple_strtol(tokptr, NULL, 0);
+
+			/* switch page */
+#if !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F)
+			if (pageId >= 31) {
+				rtl8651_setAsicEthernetPHYReg(phyId, 31, 7);
+				rtl8651_setAsicEthernetPHYReg(phyId, 30,
+					pageId);
+			} else
+#endif
+#if defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8211F_SUPPORT)
+			if (gpio_simulate_mdc_mdio) {
+				if ((8 > phyId) && (phyId > 4)) {
+					if (pageId > 0) {
+						rtl_mdio_write(phyId, 31,
+							pageId);
+					}
+
+					ret = rtl_mdio_write(phyId, regId,
+						regData);
+
+					if (ret == SUCCESS) {
+						rtlglue_printf("extWrite phyId(%d), pageId(%d), regId(%d), regData:0x%x\n",
+							phyId, pageId, regId,
+							regData);
+					} else {
+						rtlglue_printf("error input!\n");
+					}
+
+					/* change back to page 0 */
+					rtl_mdio_write(phyId, 31, 0);
+				} else {
+					if (pageId > 0) {
+						rtl8651_setAsicEthernetPHYReg
+							(phyId, 31, pageId);
+					}
+
+					ret = rtl8651_setAsicEthernetPHYReg
+						(phyId, regId, regData);
+
+					if (ret == SUCCESS) {
+						rtlglue_printf("extWrite phyId(%d), pageId(%d), regId(%d), regData:0x%x\n",
+							phyId, pageId, regId,
+							regData);
+					} else {
+						rtlglue_printf("error input!\n");
+					}
+
+					/* change back to page 0 */
+					rtl8651_setAsicEthernetPHYReg(phyId, 31,
+						0);
+				}
+
+			} else
+#endif
+			{
+				if (pageId > 0) {
+					rtl8651_setAsicEthernetPHYReg(phyId, 31,
+						pageId);
+				}
+
+				ret = rtl8651_setAsicEthernetPHYReg(phyId,
+					regId, regData);
+
+				if (ret == SUCCESS) {
+					rtlglue_printf("extWrite phyId(%d), pageId(%d), regId(%d), regData:0x%x\n",
+						phyId, pageId, regId, regData);
+				} else {
+					rtlglue_printf("error input!\n");
+				}
+
+				/* change back to page 0 */
+				rtl8651_setAsicEthernetPHYReg(phyId, 31, 0);
+			}
+
+		}
+#ifdef CONFIG_RTL_8198C
+		else if (!memcmp(cmd_addr, "sram98c", 7)) {
+			/* command: echo sram98c [phyid: 8/1/2/3/4/999] [oper: 0=read, 1=write]
+			 * [reg] [sramdata:write only] > /proc/rtl865x/phyReg
+			 */
+			extern void Sram98C(uint32 phyid, uint32 oper,
+				uint32 RegAddr, uint32 sramdata);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			pageId = simple_strtol(tokptr, NULL, 0);
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			if (pageId == 1) {	/* write */
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+				regData = simple_strtol(tokptr, NULL, 0);
+			}
+			Sram98C(phyId, pageId, regId, regData);
+			rtlglue_printf("command done.\n");
+		} else if (!memcmp(cmd_addr, "gigalite", 8)) {
+			extern void set_giga_lite(int mode);
+
+			/* command: echo gigalite [0(disable)/1(enable)] > /proc/rtl865x/phyReg */
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			if ((phyId == 0) || (phyId == 1)) {
+				set_giga_lite(phyId);
+				for (i = 0; i < 5; i++)
+					rtl8651_restartAsicEthernetPHYNway(i);
+				rtlglue_printf("giga lite is %sabled.\n",
+					(phyId ? "en" : "dis"));
+			} else
+				goto errout;
+		} else if (!memcmp(cmd_addr, "ado", 3)) {
+			extern void ado_setting(int mode);
+
+			/* command: echo ado [0(default)/1(modified)] > /proc/rtl865x/phyReg */
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			phyId = simple_strtol(tokptr, NULL, 0);
+
+			if (phyId == 0) {
+				ado_setting(phyId);
+				rtlglue_printf("ado default\n");
+			} else if (phyId == 1) {
+				ado_setting(0);
+				ado_setting(phyId);
+				rtlglue_printf("ado default and modified\n");
+			} else
+				goto errout;
+		}
+#endif
+		else if (!memcmp(cmd_addr, "snr", 3)) {
+			uint32 sum;
+
+			for (i = 0; i < 5; i++) {
+				if (REG32(PSRP0 + (i * 4)) & PortStatusLinkUp) {
+					for (j = 0, sum = 0; j < 10; j++) {
+						rtl8651_getAsicEthernetPHYReg(i,
+							29, &regData);
+						sum += regData;
+						mdelay(10);
+					}
+					sum /= 10;
+					/* db = -(10 * log(sum/262144)); */
+					/* printk("  port %d SNR = %d dB\n", i, db); */
+					rtlglue_printf("  port %d SUM = %d\n",
+						i, sum);
+				} else {
+					rtlglue_printf("  port %d is link down\n", i);
+				}
+			}
+		} else if (!memcmp(cmd_addr, "dumpAll", 7)) {
+			int port;
+
+#ifdef CONFIG_RTL_8196C
+			int page, reg;
+#endif
+			for (port = 0; port < 5; port++) {
+				rtlglue_printf("==========================================\n");
+
+#ifdef CONFIG_RTL_8196C
+				for (page = 0; page < 4; page++) {
+					/* change page num */
+					rtl8651_setAsicEthernetPHYReg(port, 31,
+						page);
+					for (reg = 0; reg < 32; reg++) {
+						rtl8651_getAsicEthernetPHYReg
+							(port, reg, &regData);
+						rtlglue_printf("port:%d,page:%d,regId:%d,regData:0x%x\n",
+							port, page, reg,
+							regData);
+					}
+					if (page != 3) {
+						rtlglue_printf("------------------------------------------\n");
+					}
+					/* change back to page 0 */
+					rtl8651_setAsicEthernetPHYReg(port, 31,
+						0);
+				}
+#elif defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8197F)
+				/* set pageNum {0 1 2 3 4 5 6 32 33 34 35 36 40 44 45 46 64 65 66 69 70 80 81 161} */
+				for (i = 0; i < 24; i++)
+					getPhyByPortPage(port,
+						_8198_phy_page[i]);
+
+#elif defined(CONFIG_RTL_8198C)
+				/* set pageNum: 0xa40 ~ 0xa72; 0xbc0 ~ 0xbc7; 0xc80 ~ 0xc81 */
+				for (i = 0; i < 51; i++) {
+					getPhyByPortPage(port, (0xa40 + i));
+				}
+				for (i = 0; i < 8; i++) {
+					getPhyByPortPage(port, (0xbc0 + i));
+				}
+				getPhyByPortPage(port, 0xc80);
+				getPhyByPortPage(port, 0xc81);
+#endif
+			}
+		}
+	} else {
+errout:
+		rtlglue_printf("error input!\n");
+	}
+
+	return len;
+}
+
+/* MACCR porc-------------------------------------------------------------------------------------------- */
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 mac_config_read(struct seq_file *s, void *v)
+{
+	uint32 regData;
+	uint32 data0;
+
+	seq_printf(s, "MAC Configuration Register Info:\n");
+	regData = READ_MEM32(MACCR);
+
+	data0 = regData & IPG_SEL;
+	seq_printf(s, "IfgSel:  ");
+	if (data0)
+		seq_printf(s, "internal counter =352\n");
+	else
+		seq_printf(s, "internal counter =480\n");
+
+	data0 = regData & INFINITE_PAUSE_FRAMES;
+	seq_printf(s, "INFINITE_PAUSE_FRAMES:  ");
+	if (data0)
+		seq_printf(s, "Infinite pause frame count\n");
+	else
+		seq_printf(s, "Maximum of 128 consecutive pause frames\n");
+
+	data0 = regData & LONG_TXE;
+	seq_printf(s, "LONG_TXE:  ");
+	if (data0)
+		seq_printf(s, "Carrier-based backpressure\n");
+	else
+		seq_printf(s, "Collision-based backpressure\n");
+
+	data0 = regData & EN_48_DROP;
+	seq_printf(s, "EN_48_DROP:  ");
+	if (data0)
+		seq_printf(s, "Enabled\n");
+	else
+		seq_printf(s, "Disabled\n");
+
+	data0 = (regData & SELIPG_MASK) >> SELIPG_OFFSET;
+	seq_printf(s, "SELIPG:  ");
+	if (data0 == 0x00)
+		seq_printf(s, "7 byte-time\n");
+	else if (data0 == 0x01)
+		seq_printf(s, "8 byte-time\n");
+	else if (data0 == 0x10)
+		seq_printf(s, "10 byte-time\n");
+	else
+		seq_printf(s, "12 byte-time\n");
+
+	data0 = (regData & CF_SYSCLK_SEL_MASK) >> CF_SYSCLK_SEL_OFFSET;
+	seq_printf(s, "CF_SYSCLK_SEL:  ");
+	if (data0 == 0x00)
+		seq_printf(s, "50MHz\n");
+	else if (data0 == 0x01)
+		seq_printf(s, "100MHz\n");
+	else
+		seq_printf(s, "reserved status\n");
+
+	data0 = (regData & CF_FCDSC_MASK) >> CF_FCDSC_OFFSET;
+	seq_printf(s, "CF_FCDSC:  %d pages\n", data0);
+
+	data0 = (regData & CF_RXIPG_MASK);
+	seq_printf(s, "CF_RXIPG:  %d pkts\n", data0);
+
+	return 0;
+
+}
+#else
+static int32 mac_config_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	uint32 regData;
+	uint32 data0;
+
+	len = sprintf(page, "MAC Configuration Register Info:\n");
+	regData = READ_MEM32(MACCR);
+
+	data0 = regData & IPG_SEL;
+	len += sprintf(page + len, "IfgSel:  ");
+	if (data0)
+		len += sprintf(page + len, "internal counter =352\n");
+	else
+		len += sprintf(page + len, "internal counter =480\n");
+
+	data0 = regData & INFINITE_PAUSE_FRAMES;
+	len += sprintf(page + len, "INFINITE_PAUSE_FRAMES:  ");
+	if (data0)
+		len += sprintf(page + len, "Infinite pause frame count\n");
+	else
+		len += sprintf(page + len,
+			"Maximum of 128 consecutive pause frames\n");
+
+	data0 = regData & LONG_TXE;
+	len += sprintf(page + len, "LONG_TXE:  ");
+	if (data0)
+		len += sprintf(page + len, "Carrier-based backpressure\n");
+	else
+		len += sprintf(page + len, "Collision-based backpressure\n");
+
+	data0 = regData & EN_48_DROP;
+	len += sprintf(page + len, "EN_48_DROP:  ");
+	if (data0)
+		len += sprintf(page + len, "Enabled\n");
+	else
+		len += sprintf(page + len, "Disabled\n");
+
+	data0 = (regData & SELIPG_MASK) >> SELIPG_OFFSET;
+	len += sprintf(page + len, "SELIPG:  ");
+	if (data0 == 0x00)
+		len += sprintf(page + len, "7 byte-time\n");
+	else if (data0 == 0x01)
+		len += sprintf(page + len, "8 byte-time\n");
+	else if (data0 == 0x10)
+		len += sprintf(page + len, "10 byte-time\n");
+	else
+		len += sprintf(page + len, "12 byte-time\n");
+
+	data0 = (regData & CF_SYSCLK_SEL_MASK) >> CF_SYSCLK_SEL_OFFSET;
+	len += sprintf(page + len, "CF_SYSCLK_SEL:  ");
+	if (data0 == 0x00)
+		len += sprintf(page + len, "50MHz\n");
+	else if (data0 == 0x01)
+		len += sprintf(page + len, "100MHz\n");
+	else
+		len += sprintf(page + len, "reserved status\n");
+
+	data0 = (regData & CF_FCDSC_MASK) >> CF_FCDSC_OFFSET;
+	len += sprintf(page + len, "CF_FCDSC:  %d pages\n", data0);
+
+	data0 = (regData & CF_RXIPG_MASK);
+	len += sprintf(page + len, "CF_RXIPG:  %d pkts\n", data0);
+
+	return len;
+
+}
+#endif
+
+static int32 mac_config_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+/* FC threshold-------------------------------------------------------------------------- */
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 fc_threshold_read(struct seq_file *s, void *v)
+{
+	uint32 regData;
+	uint32 data0;
+	int port;
+	int group = 3;
+
+	seq_printf(s, "Dump FC threshold Information:\n");
+
+	/* SBFCR0 */
+	regData = READ_MEM32(SBFCR0);
+	data0 = regData & S_DSC_RUNOUT_MASK;
+	seq_printf(s, "S_DSC_RUNOUT:%d\n", data0);
+	/* SBFCR1 */
+	regData = READ_MEM32(SBFCR1);
+	data0 = (regData & SDC_FCOFF_MASK) >> SDC_FCOFF_OFFSET;
+	seq_printf(s, "SDC_FCOFF:%d, ", data0);
+	data0 = (regData & SDC_FCON_MASK) >> SDC_FCON_OFFSET;
+	seq_printf(s, "SDC_FCON:%d\n", data0);
+	/* SBFCR2 */
+	regData = READ_MEM32(SBFCR2);
+	data0 = (regData & S_Max_SBuf_FCOFF_MASK) >> S_Max_SBuf_FCOFF_OFFSET;
+	seq_printf(s, "S_MaxSBuf_FCOFF:%d, ", data0);
+	data0 = (regData & S_Max_SBuf_FCON_MASK) >> S_Max_SBuf_FCON_OFFSET;
+	seq_printf(s, "S_MaxSBuf_FCON:%d\n", data0);
+	/* FCCR0,FCCR1 */
+	regData = READ_MEM32(FCCR0);
+	data0 = (regData & Q_P0_EN_FC_MASK) >> (Q_P0_EN_FC_OFFSET);
+	seq_printf(s, "Q_P0_EN_FC:%0x, ", data0);
+	data0 = (regData & Q_P1_EN_FC_MASK) >> (Q_P1_EN_FC_OFFSET);
+	seq_printf(s, "Q_P1_EN_FC:%0x, ", data0);
+	data0 = (regData & Q_P2_EN_FC_MASK) >> (Q_P2_EN_FC_OFFSET);
+	seq_printf(s, "Q_P2_EN_FC:%0x\n", data0);
+	data0 = (regData & Q_P3_EN_FC_MASK) >> (Q_P3_EN_FC_OFFSET);
+	seq_printf(s, "Q_P3_EN_FC:%0x, ", data0);
+	regData = READ_MEM32(FCCR1);
+	data0 = (regData & Q_P4_EN_FC_MASK) >> (Q_P4_EN_FC_OFFSET);
+	seq_printf(s, "Q_P4_EN_FC:%0x, ", data0);
+	regData = READ_MEM32(FCCR0);
+	data0 = (regData & Q_P5_EN_FC_MASK) >> (Q_P5_EN_FC_OFFSET);
+	seq_printf(s, "Q_P5_EN_FC:%0x\n", data0);
+	/* PQPLGR */
+	regData = READ_MEM32(PQPLGR);
+	data0 = regData & QLEN_GAP_MASK;
+	seq_printf(s, "QLEN_GAP:%d\n", data0);
+	/* QRR */
+	regData = READ_MEM32(QRR);
+	data0 = regData & QRST;
+	seq_printf(s, "QRST:%d\n", data0);
+	/* IQFCTCR */
+	regData = READ_MEM32(IQFCTCR);
+	data0 = (regData & IQ_DSC_FCON_MASK) >> IQ_DSC_FCON_OFFSET;
+	seq_printf(s, "IQ_DSC_FCON:%d, ", data0);
+	data0 = (regData & IQ_DSC_FCOFF_MASK) >> IQ_DSC_FCOFF_OFFSET;
+	seq_printf(s, "IQ_DSC_FCOFF:%d\n", data0);
+	/* QNUMCR */
+	regData = READ_MEM32(QNUMCR);
+	seq_printf(s, "The number of output queue for port(0~6) :\n");
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	data0 = (regData & P0QNum_MASK) >> (P0QNum_OFFSET);
+	seq_printf(s, "P0QNum%d, ", data0 + 1);
+	data0 = (regData & P1QNum_MASK) >> (P1QNum_OFFSET);
+	seq_printf(s, "P1QNum%d, ", data0 + 1);
+	data0 = (regData & P2QNum_MASK) >> (P2QNum_OFFSET);
+	seq_printf(s, "P2QNum%d, ", data0 + 1);
+	data0 = (regData & P3QNum_MASK) >> (P3QNum_OFFSET);
+	seq_printf(s, "P3QNum%d, ", data0 + 1);
+	data0 = (regData & P4QNum_MASK) >> (P4QNum_OFFSET);
+	seq_printf(s, "P4QNum%d, ", data0 + 1);
+	data0 = (regData & P5QNum_MASK) >> (P5QNum_OFFSET);
+	seq_printf(s, "P5QNum%d, ", data0 + 1);
+	data0 = (regData & P6QNum_MASK) >> (P6QNum_OFFSET);
+	seq_printf(s, "P6QNum%d\n", data0 + 1);
+#else
+	data0 = (regData & P0QNum_MASK) >> (P0QNum_OFFSET);
+	seq_printf(s, "P0QNum%d, ", data0);
+	data0 = (regData & P1QNum_MASK) >> (P1QNum_OFFSET);
+	seq_printf(s, "P1QNum%d, ", data0);
+	data0 = (regData & P2QNum_MASK) >> (P2QNum_OFFSET);
+	seq_printf(s, "P2QNum%d, ", data0);
+	data0 = (regData & P3QNum_MASK) >> (P3QNum_OFFSET);
+	seq_printf(s, "P3QNum%d, ", data0);
+	data0 = (regData & P4QNum_MASK) >> (P4QNum_OFFSET);
+	seq_printf(s, "P4QNum%d, ", data0);
+	data0 = (regData & P5QNum_MASK) >> (P5QNum_OFFSET);
+	seq_printf(s, "P5QNum%d, ", data0);
+	data0 = (regData & P6QNum_MASK) >> (P6QNum_OFFSET);
+	seq_printf(s, "P6QNum%d\n", data0);
+#endif
+	/* per port */
+	for (port = PHY0; port <= CPU; port++) {
+		if (port == CPU)
+			seq_printf(s, "\nCPUPort\n");
+		else
+			seq_printf(s, "\nPort%d\n", port);
+
+		regData = READ_MEM32(PBFCR0 + ((port) << 2));
+		data0 = (regData & P_MaxDSC_FCOFF_MASK) >>
+			P_MaxDSC_FCOFF_OFFSET;
+		seq_printf(s, "   P_MaxDSC_FCOFF:%d, ", data0);
+		data0 = (regData & P_MaxDSC_FCON_MASK) >> P_MaxDSC_FCON_OFFSET;
+		seq_printf(s, "P_MaxDSC_FCON:%d\n", data0);
+		/* if(port<CPU) */
+		{
+			for (group = GR0; group <= GR2; group++) {
+				seq_printf(s, "   Port%dGroup%d\n", port,
+					group);
+				/* QDBFCRP0G0,QDBFCRP0G1,QDBFCRP0G2
+				 * QDBFCRP1G0,QDBFCRP1G1,QDBFCRP1G2
+				 * QDBFCRP2G0,QDBFCRP2G1,QDBFCRP2G2
+				 * QDBFCRP3G0,QDBFCRP3G1,QDBFCRP3G2
+				 * QDBFCRP4G0,QDBFCRP4G1,QDBFCRP4G2
+				 * QDBFCRP5G0,QDBFCRP5G1,QDBFCRP5G2
+				 * - Queue-Descriptor=Based Flow Control Threshold for Port 0 Group 0 */
+				regData =
+					READ_MEM32(QDBFCRP0G0 + ((port) * 0xC) +
+					((group) << 2));
+				/* seq_printf(s,"address:%0x",(QDBFCRP0G0+((port)<<2)+((group)<<2))); */
+				data0 = (regData & QG_DSC_FCOFF_MASK) >>
+					QG_DSC_FCOFF_OFFSET;
+				seq_printf(s, "   QG_DSC_FCOFF:%d, ", data0);
+				data0 = (regData & QG_DSC_FCON_MASK) >>
+					QG_DSC_FCON_OFFSET;
+				seq_printf(s, "QG_DSC_FCON:%d, ", data0);
+
+				/* QPKTFCRP0G0,QPKTFCRP0G1,QPKTFCRP0G2
+				 * QPKTFCRP1G0,QPKTFCRP1G1,QPKTFCRP1G2
+				 * QPKTFCRP2G0,QPKTFCRP2G1,QPKTFCRP2G2
+				 * QPKTFCRP3G0,QPKTFCRP3G1,QPKTFCRP3G2
+				 * QPKTFCRP4G0,QPKTFCRP4G1,QPKTFCRP4G2
+				 * QPKTFCRP5G0,QPKTFCRP5G1,QPKTFCRP5G2
+				 - Queue-Packet-Based Flow Control Register for Port 0 Group 0 */
+				regData =
+					READ_MEM32(QPKTFCRP0G0 +
+					((port) * 0xC) + ((group) << 2));
+				/* seq_printf(s,"address:%0x",(QPKTFCRP0G0+((port)<<2)+((group)<<2))); */
+				data0 = (regData & QG_QLEN_FCOFF_MASK) >>
+					QG_QLEN_FCOFF_OFFSET;
+				seq_printf(s, "QG_QLEN_FCOFF:%d, ", data0);
+				data0 = (regData & QG_QLEN_FCON_MASK) >>
+					QG_QLEN_FCON_OFFSET;
+				seq_printf(s, "QG_QLEN_FCON:%d\n", data0);
+
+			}
+		}
+	}
+
+	return 0;
+}
+#else
+static int32 fc_threshold_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+
+	int len;
+	uint32 regData;
+	uint32 data0;
+	int port;
+	int group = 3;
+
+	len = sprintf(page, "Dump FC threshold Information:\n");
+
+	/* SBFCR0 */
+	regData = READ_MEM32(SBFCR0);
+	data0 = regData & S_DSC_RUNOUT_MASK;
+	len += sprintf(page + len, "S_DSC_RUNOUT:%d\n", data0);
+	/* SBFCR1 */
+	regData = READ_MEM32(SBFCR1);
+	data0 = (regData & SDC_FCOFF_MASK) >> SDC_FCOFF_OFFSET;
+	len += sprintf(page + len, "SDC_FCOFF:%d, ", data0);
+	data0 = (regData & SDC_FCON_MASK) >> SDC_FCON_OFFSET;
+	len += sprintf(page + len, "SDC_FCON:%d\n", data0);
+	/* SBFCR2 */
+	regData = READ_MEM32(SBFCR2);
+	data0 = (regData & S_Max_SBuf_FCOFF_MASK) >> S_Max_SBuf_FCOFF_OFFSET;
+	len += sprintf(page + len, "S_MaxSBuf_FCOFF:%d, ", data0);
+	data0 = (regData & S_Max_SBuf_FCON_MASK) >> S_Max_SBuf_FCON_OFFSET;
+	len += sprintf(page + len, "S_MaxSBuf_FCON:%d\n", data0);
+	/* FCCR0,FCCR1 */
+	regData = READ_MEM32(FCCR0);
+	data0 = (regData & Q_P0_EN_FC_MASK) >> (Q_P0_EN_FC_OFFSET);
+	len += sprintf(page + len, "Q_P0_EN_FC:%0x, ", data0);
+	data0 = (regData & Q_P1_EN_FC_MASK) >> (Q_P1_EN_FC_OFFSET);
+	len += sprintf(page + len, "Q_P1_EN_FC:%0x, ", data0);
+	data0 = (regData & Q_P2_EN_FC_MASK) >> (Q_P2_EN_FC_OFFSET);
+	len += sprintf(page + len, "Q_P2_EN_FC:%0x\n", data0);
+	data0 = (regData & Q_P3_EN_FC_MASK) >> (Q_P3_EN_FC_OFFSET);
+	len += sprintf(page + len, "Q_P3_EN_FC:%0x, ", data0);
+	regData = READ_MEM32(FCCR1);
+	data0 = (regData & Q_P4_EN_FC_MASK) >> (Q_P4_EN_FC_OFFSET);
+	len += sprintf(page + len, "Q_P4_EN_FC:%0x, ", data0);
+	regData = READ_MEM32(FCCR0);
+	data0 = (regData & Q_P5_EN_FC_MASK) >> (Q_P5_EN_FC_OFFSET);
+	len += sprintf(page + len, "Q_P5_EN_FC:%0x\n", data0);
+	/* PQPLGR */
+	regData = READ_MEM32(PQPLGR);
+	data0 = regData & QLEN_GAP_MASK;
+	len += sprintf(page + len, "QLEN_GAP:%d\n", data0);
+	/* QRR */
+	regData = READ_MEM32(QRR);
+	data0 = regData & QRST;
+	len += sprintf(page + len, "QRST:%d\n", data0);
+	/* IQFCTCR */
+	regData = READ_MEM32(IQFCTCR);
+	data0 = (regData & IQ_DSC_FCON_MASK) >> IQ_DSC_FCON_OFFSET;
+	len += sprintf(page + len, "IQ_DSC_FCON:%d, ", data0);
+	data0 = (regData & IQ_DSC_FCOFF_MASK) >> IQ_DSC_FCOFF_OFFSET;
+	len += sprintf(page + len, "IQ_DSC_FCOFF:%d\n", data0);
+	/* QNUMCR */
+	regData = READ_MEM32(QNUMCR);
+	len += sprintf(page + len,
+		"The number of output queue for port(0~6) :\n");
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	data0 = (regData & P0QNum_MASK) >> (P0QNum_OFFSET);
+	len += sprintf(page + len, "P0QNum%d, ", data0 + 1);
+	data0 = (regData & P1QNum_MASK) >> (P1QNum_OFFSET);
+	len += sprintf(page + len, "P1QNum%d, ", data0 + 1);
+	data0 = (regData & P2QNum_MASK) >> (P2QNum_OFFSET);
+	len += sprintf(page + len, "P2QNum%d, ", data0 + 1);
+	data0 = (regData & P3QNum_MASK) >> (P3QNum_OFFSET);
+	len += sprintf(page + len, "P3QNum%d, ", data0 + 1);
+	data0 = (regData & P4QNum_MASK) >> (P4QNum_OFFSET);
+	len += sprintf(page + len, "P4QNum%d, ", data0 + 1);
+	data0 = (regData & P5QNum_MASK) >> (P5QNum_OFFSET);
+	len += sprintf(page + len, "P5QNum%d, ", data0 + 1);
+	data0 = (regData & P6QNum_MASK) >> (P6QNum_OFFSET);
+	len += sprintf(page + len, "P6QNum%d\n", data0 + 1);
+#else
+	data0 = (regData & P0QNum_MASK) >> (P0QNum_OFFSET);
+	len += sprintf(page + len, "P0QNum%d, ", data0);
+	data0 = (regData & P1QNum_MASK) >> (P1QNum_OFFSET);
+	len += sprintf(page + len, "P1QNum%d, ", data0);
+	data0 = (regData & P2QNum_MASK) >> (P2QNum_OFFSET);
+	len += sprintf(page + len, "P2QNum%d, ", data0);
+	data0 = (regData & P3QNum_MASK) >> (P3QNum_OFFSET);
+	len += sprintf(page + len, "P3QNum%d, ", data0);
+	data0 = (regData & P4QNum_MASK) >> (P4QNum_OFFSET);
+	len += sprintf(page + len, "P4QNum%d, ", data0);
+	data0 = (regData & P5QNum_MASK) >> (P5QNum_OFFSET);
+	len += sprintf(page + len, "P5QNum%d, ", data0);
+	data0 = (regData & P6QNum_MASK) >> (P6QNum_OFFSET);
+	len += sprintf(page + len, "P6QNum%d\n", data0);
+#endif
+	/* per port */
+	for (port = PHY0; port <= CPU; port++) {
+		if (port == CPU)
+			len += sprintf(page + len, "\nCPUPort\n");
+		else
+			len += sprintf(page + len, "\nPort%d\n", port);
+
+		regData = READ_MEM32(PBFCR0 + ((port) << 2));
+		data0 = (regData & P_MaxDSC_FCOFF_MASK) >>
+			P_MaxDSC_FCOFF_OFFSET;
+		len += sprintf(page + len, "   P_MaxDSC_FCOFF:%d, ", data0);
+		data0 = (regData & P_MaxDSC_FCON_MASK) >> P_MaxDSC_FCON_OFFSET;
+		len += sprintf(page + len, "P_MaxDSC_FCON:%d\n", data0);
+		/* if(port<CPU) */
+		{
+			for (group = GR0; group <= GR2; group++) {
+				len += sprintf(page + len, "   Port%dGroup%d\n",
+					port, group);
+				/* QDBFCRP0G0,QDBFCRP0G1,QDBFCRP0G2
+				 * QDBFCRP1G0,QDBFCRP1G1,QDBFCRP1G2
+				 * QDBFCRP2G0,QDBFCRP2G1,QDBFCRP2G2
+				 * QDBFCRP3G0,QDBFCRP3G1,QDBFCRP3G2
+				 * QDBFCRP4G0,QDBFCRP4G1,QDBFCRP4G2
+				 * QDBFCRP5G0,QDBFCRP5G1,QDBFCRP5G2
+				 * - Queue-Descriptor=Based Flow Control Threshold for Port 0 Group 0 */
+				regData =
+					READ_MEM32(QDBFCRP0G0 + ((port) << 2) +
+					((group) << 2));
+				/* len+=sprintf(page+len,"address:%0x",(QDBFCRP0G0+((port)<<2)+((group)<<2))); */
+				data0 = (regData & QG_DSC_FCOFF_MASK) >>
+					QG_DSC_FCOFF_OFFSET;
+				len += sprintf(page + len,
+					"   QG_DSC_FCOFF:%d, ", data0);
+				data0 = (regData & QG_DSC_FCON_MASK) >>
+					QG_DSC_FCON_OFFSET;
+				len += sprintf(page + len, "QG_DSC_FCON:%d, ",
+					data0);
+
+				/* QPKTFCRP0G0,QPKTFCRP0G1,QPKTFCRP0G2
+				 * QPKTFCRP1G0,QPKTFCRP1G1,QPKTFCRP1G2
+				 * QPKTFCRP2G0,QPKTFCRP2G1,QPKTFCRP2G2
+				 * QPKTFCRP3G0,QPKTFCRP3G1,QPKTFCRP3G2
+				 * QPKTFCRP4G0,QPKTFCRP4G1,QPKTFCRP4G2
+				 * QPKTFCRP5G0,QPKTFCRP5G1,QPKTFCRP5G2
+				 - Queue-Packet-Based Flow Control Register for Port 0 Group 0 */
+				regData =
+					READ_MEM32(QPKTFCRP0G0 + ((port) << 2) +
+					((group) << 2));
+				/* len+=sprintf(page+len,"address:%0x",(QPKTFCRP0G0+((port)<<2)+((group)<<2))); */
+				data0 = (regData & QG_QLEN_FCOFF_MASK) >>
+					QG_QLEN_FCOFF_OFFSET;
+				len += sprintf(page + len, "QG_QLEN_FCOFF:%d, ",
+					data0);
+				data0 = (regData & QG_QLEN_FCON_MASK) >>
+					QG_QLEN_FCON_OFFSET;
+				len += sprintf(page + len, "QG_QLEN_FCON:%d\n",
+					data0);
+
+			}
+		}
+	}
+
+	return len;
+}
+#endif
+
+static int32 fc_threshold_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+/* l3v6-------------------------------------------------------------------------- */
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 l3v6_read(struct seq_file *s, void *v)
+{
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	uint32 idx, mask;
+	rtl8198C_tblAsicDrv_routingv6Param_t asic_l3v6;
+	inv6_addr_t tmp_ip;
+	int8 *str[] =
+		{ "PPPoE", "L2", "ARP", " ", "CPU", "NxtHop", "DROP", " " };
+
+	seq_printf(s, "%s\n", "ASIC L3V6 Routing Table:\n");
+	for (idx = 0; idx < RTL8198C_ROUTINGV6TBL_SIZE; idx++) {
+		if (rtl8198C_getAsicRoutingv6(idx, &asic_l3v6) == FAILED) {
+			seq_printf(s, "\t[%d]  (Invalid)\n", idx);
+			continue;
+		}
+		ntohl_array((uint32 *)&asic_l3v6.ipAddr.v6_addr32[0],
+			(void *)&tmp_ip.v6_addr32[0], 4);
+		mask = asic_l3v6.ipMask;
+
+		seq_printf(s,
+			"\t[%d]  %04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x/%d process(%s) \n",
+			idx, htons(tmp_ip.v6_addr16[0]),
+			htons(tmp_ip.v6_addr16[1]), htons(tmp_ip.v6_addr16[2]),
+			htons(tmp_ip.v6_addr16[3]), htons(tmp_ip.v6_addr16[4]),
+			htons(tmp_ip.v6_addr16[5]), htons(tmp_ip.v6_addr16[6]),
+			htons(tmp_ip.v6_addr16[7]), mask,
+			str[asic_l3v6.process]);
+
+		switch (asic_l3v6.process) {
+		case 0x00:	/* PPPoE */
+			seq_printf(s,
+				"\t           dvidx(%d)  pppidx(%d) nxthop(%d)\n",
+				asic_l3v6.vidx, asic_l3v6.pppoeIdx,
+				(asic_l3v6.nextHopRow << 2) +
+				asic_l3v6.nextHopColumn);
+			break;
+
+		case 0x01:	/* L2 */
+			seq_printf(s, "              dvidx(%d) nexthop(%d)\n",
+				asic_l3v6.vidx,
+				(asic_l3v6.nextHopRow << 2) +
+				asic_l3v6.nextHopColumn);
+			break;
+
+		case 0x02:	/* ARP */
+			seq_printf(s, "             dvidx(%d) SUBNETIDX(%d)\n",
+				asic_l3v6.vidx, asic_l3v6.subnet_idx);
+			break;
+
+		case 0x03:	/* Reserved */
+			;
+
+		case 0x04:	/* CPU */
+			seq_printf(s, "             dvidx(%d)\n",
+				asic_l3v6.vidx);
+			break;
+
+		case 0x05:	/* NAPT Next Hop */
+			seq_printf(s,
+				"              NHSTA(%d) NHNUM(%d) NHNXT(%d) NHALGO(%d)\n",
+				asic_l3v6.nhStart, asic_l3v6.nhNum,
+				asic_l3v6.nhNxt, asic_l3v6.nhAlgo);
+			break;
+
+		case 0x06:	/* DROP */
+			seq_printf(s, "             dvidx(%d)\n",
+				asic_l3v6.vidx);
+			break;
+
+		case 0x07:	/* Reserved */
+			/* pass through */
+		default:
+			;
+		}
+
+		seq_printf(s, "\tsix_rd_eg :0x%x\tsix_rd_idx:0x%x\n",
+			asic_l3v6.six_rd_eg, asic_l3v6.six_rd_idx);
+	}
+#endif
+	return 0;
+}
+#else
+static int32 l3v6_read(char *page, char **start, off_t off, int count, int *eof,
+	void *data)
+{
+	int len;
+	uint32 idx, mask;
+	rtl8198C_tblAsicDrv_routingv6Param_t asic_l3v6;
+	inv6_addr_t tmp_ip;
+	int8 *str[] =
+		{ "PPPoE", "L2", "ARP", " ", "CPU", "NxtHop", "DROP", " " };
+
+	len = sprintf(page, "%s\n", "ASIC L3V6 Routing Table:\n");
+	for (idx = 0; idx < RTL8198C_ROUTINGV6TBL_SIZE; idx++) {
+		if (rtl8198C_getAsicRoutingv6(idx, &asic_l3v6) == FAILED) {
+			len += sprintf(page + len, "\t[%d]  (Invalid)\n", idx);
+			continue;
+		}
+		ntohl_array((uint32 *)&asic_l3v6.ipAddr.v6_addr32[0],
+			(void *)&tmp_ip.v6_addr32[0], 4);
+		mask = asic_l3v6.ipMask;
+
+		len += sprintf(page + len,
+			"\t[%d]  %04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x/%d process(%s) \n",
+			idx, htons(tmp_ip.v6_addr16[0]),
+			htons(tmp_ip.v6_addr16[1]), htons(tmp_ip.v6_addr16[2]),
+			htons(tmp_ip.v6_addr16[3]), htons(tmp_ip.v6_addr16[4]),
+			htons(tmp_ip.v6_addr16[5]), htons(tmp_ip.v6_addr16[6]),
+			htons(tmp_ip.v6_addr16[7]), mask,
+			str[asic_l3v6.process]);
+
+		switch (asic_l3v6.process) {
+		case 0x00:	/* PPPoE */
+			len += sprintf(page + len,
+				"\t           dvidx(%d)  pppidx(%d) nxthop(%d)\n",
+				asic_l3v6.vidx, asic_l3v6.pppoeIdx,
+				(asic_l3v6.nextHopRow << 2) +
+				asic_l3v6.nextHopColumn);
+			break;
+
+		case 0x01:	/* L2 */
+			len += sprintf(page + len,
+				"              dvidx(%d) nexthop(%d)\n",
+				asic_l3v6.vidx,
+				(asic_l3v6.nextHopRow << 2) +
+				asic_l3v6.nextHopColumn);
+			break;
+
+		case 0x02:	/* ARP */
+			len += sprintf(page + len,
+				"             dvidx(%d) SUBNETIDX(%d)\n",
+				asic_l3v6.vidx, asic_l3v6.subnet_idx);
+			break;
+
+		case 0x03:	/* Reserved */
+			;
+
+		case 0x04:	/* CPU */
+			len += sprintf(page + len, "             dvidx(%d)\n",
+				asic_l3v6.vidx);
+			break;
+
+		case 0x05:	/* NAPT Next Hop */
+			len += sprintf(page + len,
+				"              NHSTA(%d) NHNUM(%d) NHNXT(%d) NHALGO(%d)\n",
+				asic_l3v6.nhStart, asic_l3v6.nhNum,
+				asic_l3v6.nhNxt, asic_l3v6.nhAlgo);
+			break;
+
+		case 0x06:	/* DROP */
+			len += sprintf(page + len, "             dvidx(%d)\n",
+				asic_l3v6.vidx);
+			break;
+
+		case 0x07:	/* Reserved */
+			/* pass through */
+		default:
+			;
+		}
+
+		len += sprintf(page + len,
+			"\tsix_rd_eg :0x%x\tsix_rd_idx:0x%x\n",
+			asic_l3v6.six_rd_eg, asic_l3v6.six_rd_idx);
+	}
+
+	return len;
+}
+#endif
+
+static int32 l3v6_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	return len;
+}
+
+/* arp6-------------------------------------------------------------------------- */
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 arp6_read(struct seq_file *s, void *v)
+{
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	int i = 0;
+	rtl8198C_tblAsicDrv_arpV6Param_t asic_arpv6;
+
+	seq_printf(s, "%s\n", "ASIC ArpV6 Table:\n");
+	for (i = 0; i < RTL8198C_ARPV6TBL_SIZE; i++) {
+		if (rtl8198C_getAsicArpV6(i, &asic_arpv6) == FAILED)
+			continue;
+
+		seq_printf(s,
+			" ARPv6: idx:%3d  L2:(%3d,%d), subnet_idx:%d HOSTID==>(%x:%x:%x:%x) aging:%d\n",
+			i, asic_arpv6.nextHopRow, asic_arpv6.nextHopColumn,
+			asic_arpv6.subnet_id, asic_arpv6.hostid.v6_addr32[0],
+			asic_arpv6.hostid.v6_addr32[1],
+			asic_arpv6.hostid.v6_addr32[2],
+			asic_arpv6.hostid.v6_addr32[3], asic_arpv6.aging);
+	}
+#endif
+	return 0;
+}
+#else
+static int32 arp6_read(char *page, char **start, off_t off, int count, int *eof,
+	void *data)
+{
+	int len = 0, i;
+	rtl8198C_tblAsicDrv_arpV6Param_t asic_arpv6;
+
+	len = sprintf(page, "%s\n", "ASIC ArpV6 Table:\n");
+	for (i = 0; i < RTL8198C_ARPV6TBL_SIZE; i++) {
+		if (rtl8198C_getAsicArpV6(i, &asic_arpv6) == FAILED)
+			continue;
+
+		len += sprintf(page + len,
+			" ARPv6: idx:%3d  L2:(%3d,%d), subnet_idx:%d HOSTID==>::%04x:%04x:%04x:%04x aging:%d\n",
+			i, asic_arpv6.nextHopRow, asic_arpv6.nextHopColumn,
+			asic_arpv6.subnet_id, asic_arpv6.hostid.v6_addr16[4],
+			asic_arpv6.hostid.v6_addr16[5],
+			asic_arpv6.hostid.v6_addr16[6],
+			asic_arpv6.hostid.v6_addr16[7], asic_arpv6.aging);
+	}
+
+	return len;
+}
+#endif
+
+static int32 arp6_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	return len;
+}
+
+/* nexthop6-------------------------------------------------------------------------- */
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 nexthop6_read(struct seq_file *s, void *v)
+{
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	uint32 idx;
+	rtl8198C_tblAsicDrv_nextHopV6Param_t asic_nxthopv6;
+
+	seq_printf(s, "%s\n", "ASIC Next Hop V6 Table:\n");
+	for (idx = 0; idx < RTL8198C_NEXTHOPV6TBL_SIZE; idx++) {
+		if (rtl8198C_getAsicNextHopTableV6(idx,
+				&asic_nxthopv6) == FAILED)
+			continue;
+
+		seq_printf(s,
+			"  [%d]  type(%s) dstVid(%d) pppoeIdx(%d) nextHop(%d)(0x%x)\n",
+			idx,
+			(asic_nxthopv6.isPppoe == TRUE ? "pppoe" : "ethernet"),
+			asic_nxthopv6.dvid, asic_nxthopv6.pppoeIdx,
+			(asic_nxthopv6.nextHopRow << 2) +
+			asic_nxthopv6.nextHopColumn,
+			(asic_nxthopv6.nextHopRow << 2) +
+			asic_nxthopv6.nextHopColumn);
+	}
+#endif
+	return 0;
+}
+#else
+static int32 nexthop6_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	uint32 idx;
+	rtl8198C_tblAsicDrv_nextHopV6Param_t asic_nxthopv6;
+
+	len = sprintf(page, "%s\n", "ASIC Next Hop V6 Table:\n");
+	for (idx = 0; idx < RTL8198C_NEXTHOPV6TBL_SIZE; idx++) {
+		if (rtl8198C_getAsicNextHopTableV6(idx,
+				&asic_nxthopv6) == FAILED)
+			continue;
+
+		len += sprintf(page + len,
+			"  [%d]  type(%s) dstVid(%d) pppoeIdx(%d) nextHop(%d)(0x%x)\n",
+			idx,
+			(asic_nxthopv6.isPppoe == TRUE ? "pppoe" : "ethernet"),
+			asic_nxthopv6.dvid, asic_nxthopv6.pppoeIdx,
+			(asic_nxthopv6.nextHopRow << 2) +
+			asic_nxthopv6.nextHopColumn,
+			(asic_nxthopv6.nextHopRow << 2) +
+			asic_nxthopv6.nextHopColumn);
+	}
+
+	return len;
+}
+#endif
+
+static int32 nexthop6_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+/* mcast6-------------------------------------------------------------------------- */
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 mcast6_read(struct seq_file *s, void *v)
+{
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	uint32 entry;
+	rtl8198C_tblAsicDrv_multiCastv6Param_t asic;
+
+#if 1
+	seq_printf(s, "%s\n", "ASIC Multicast V6 Table:");
+	for (entry = 0; entry < RTL8198C_MULTICASTV6TBL_SIZE; entry++) {
+#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(entry, WATCHDOG_NUM_OF_TIMES);
+#endif
+		if (rtl8198C_getAsicIpMulticastv6Table(entry, &asic) != SUCCESS) {
+			continue;
+		} else {
+			seq_printf(s,
+				"\t[%d]  (OK)dip(%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x) sip(%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x) mbr(0x%x)\n",
+				entry, asic.dip.v6_addr16[0],
+				asic.dip.v6_addr16[1], asic.dip.v6_addr16[2],
+				asic.dip.v6_addr16[3], asic.dip.v6_addr16[4],
+				asic.dip.v6_addr16[5], asic.dip.v6_addr16[6],
+				asic.dip.v6_addr16[7], asic.sip.v6_addr16[0],
+				asic.sip.v6_addr16[1], asic.sip.v6_addr16[2],
+				asic.sip.v6_addr16[3], asic.sip.v6_addr16[4],
+				asic.sip.v6_addr16[5], asic.sip.v6_addr16[6],
+				asic.sip.v6_addr16[7], asic.mbr);
+			seq_printf(s,
+				"\t       spa:%d, age:%d, cpu:%d, 6rd_eg_en:%d, 6rd_eg_idx:%d\n",
+				asic.port, asic.age, asic.cpu, asic.six_rd_eg,
+				asic.six_rd_idx);
+		}
+	}
+
+	/* //rtlglue_printf("\n\t TotalOpCnt:AddMcastOpCnt:%d\tDelMcastOpCnt:%d\tForceAddMcastOpCnt:%d\t \n", _rtl865x_getAddMcastOpCnt(),_rtl865x_getDelMcastOpCnt(),_rtl865x_getForceAddMcastOpCnt()); */
+#else
+	seq_printf(s, "%s\n", "ASIC Multicast Table:");
+
+	for (entry = 0; entry < RTL8651_MULTICASTTBL_SIZE; entry++) {
+		if (rtl8651_getAsicIpMulticastTable(entry, &asic) != SUCCESS) {
+			seq_printf(s, "\t[%d]  (Invalid Entry)\n", entry);
+			continue;
+		}
+		seq_printf(s,
+			"\t[%d]  dip(%d.%d.%d.%d) sip(%d.%d.%d.%d) mbr(%x)\n",
+			entry, asic.dip >> 24, (asic.dip & 0x00ff0000) >> 16,
+			(asic.dip & 0x0000ff00) >> 8, (asic.dip & 0xff),
+			asic.sip >> 24, (asic.sip & 0x00ff0000) >> 16,
+			(asic.sip & 0x0000ff00) >> 8, (asic.sip & 0xff),
+			asic.mbr);
+		seq_printf(s,
+			"\t       svid:%d, spa:%d, extIP:%d, age:%d, cpu:%d\n",
+			asic.svid, asic.port, asic.extIdx, asic.age, asic.cpu);
+	}
+#endif
+#endif
+
+	return 0;
+}
+#else
+static int32 mcast6_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len = 0;
+	uint32 entry;
+	rtl8198C_tblAsicDrv_multiCastv6Param_t asic;
+
+#if 1
+	len = sprintf(page, "%s\n", "ASIC Multicast V6 Table:");
+	for (entry = 0; entry < RTL8198C_MULTICASTV6TBL_SIZE; entry++) {
+#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(entry, WATCHDOG_NUM_OF_TIMES);
+#endif
+		if (rtl8198C_getAsicIpMulticastv6Table(entry, &asic) != SUCCESS) {
+			continue;
+		} else {
+			len += sprintf(page + len,
+				"\t[%d]  (OK)dip(%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x) sip(%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x) mbr(0x%x)\n",
+				entry, asic.dip.v6_addr16[0],
+				asic.dip.v6_addr16[1], asic.dip.v6_addr16[2],
+				asic.dip.v6_addr16[3], asic.dip.v6_addr16[4],
+				asic.dip.v6_addr16[5], asic.dip.v6_addr16[6],
+				asic.dip.v6_addr16[7], asic.sip.v6_addr16[0],
+				asic.sip.v6_addr16[1], asic.sip.v6_addr16[2],
+				asic.sip.v6_addr16[3], asic.sip.v6_addr16[4],
+				asic.sip.v6_addr16[5], asic.sip.v6_addr16[6],
+				asic.sip.v6_addr16[7], asic.mbr);
+			len += sprintf(page + len,
+				"\t       spa:%d, age:%d, cpu:%d, 6rd_eg_en:%d, 6rd_eg_idx:%d\n",
+				asic.port, asic.age, asic.cpu, asic.six_rd_eg,
+				asic.six_rd_idx);
+		}
+	}
+
+	/* //len += sprintf(page+len, "\n\t TotalOpCnt:AddMcastOpCnt:%d\tDelMcastOpCnt:%d\tForceAddMcastOpCnt:%d\t \n", _rtl865x_getAddMcastOpCnt(),_rtl865x_getDelMcastOpCnt(),_rtl865x_getForceAddMcastOpCnt()); */
+#else
+	len = sprintf(page, "%s\n", "ASIC Multicast Table:");
+
+	for (entry = 0; entry < RTL8651_MULTICASTTBL_SIZE; entry++) {
+		if (rtl8651_getAsicIpMulticastTable(entry, &asic) != SUCCESS) {
+			len += sprintf(page + len, "\t[%d]  (Invalid Entry)\n",
+				entry);
+			continue;
+		}
+		len += sprintf(page + len,
+			"\t[%d]  dip(%d.%d.%d.%d) sip(%d.%d.%d.%d) mbr(%x)\n",
+			entry, asic.dip >> 24, (asic.dip & 0x00ff0000) >> 16,
+			(asic.dip & 0x0000ff00) >> 8, (asic.dip & 0xff),
+			asic.sip >> 24, (asic.sip & 0x00ff0000) >> 16,
+			(asic.sip & 0x0000ff00) >> 8, (asic.sip & 0xff),
+			asic.mbr);
+		len += sprintf(page + len,
+			"\t       svid:%d, spa:%d, extIP:%d, age:%d, cpu:%d\n",
+			asic.svid, asic.port, asic.extIdx, asic.age, asic.cpu);
+	}
+#endif
+
+	if (len <= off + count) {
+		*eof = 1;
+	}
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count) {
+		len = count;
+	}
+
+	if (len < 0) {
+		len = 0;
+	}
+
+	return len;
+}
+#endif
+
+static int32 mcast6_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+/* 6rd-------------------------------------------------------------------------- */
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 ip6rd_read(struct seq_file *s, void *v)
+{
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	uint32 idx;
+	rtl8198C_tblAsicDrv_6rdParam_t asic;
+	inv6_addr_t tmp_ip;
+
+	seq_printf(s, "%s\n", "ASIC 6RD Table:\n");
+	for (idx = 0; idx < RTL8198C_6RDTBL_SIZE; idx++) {
+		if (rtl8198C_getAsic6rdTable(idx, &asic) == FAILED)
+			continue;
+
+		ntohl_array((uint32 *)&asic.six_rd_prefix.v6_addr32[0],
+			(void *)&tmp_ip.v6_addr32[0], 4);
+
+		seq_printf(s,
+			"  [%d]  ceip(%d.%d.%d.%d)/ceipm:(%d) 6RD prefix=> ::%04x:%04x:%04x:%04x/%d\n",
+			idx, (asic.ce_ip_addr >> 24),
+			((asic.ce_ip_addr & 0x00ff0000) >> 16),
+			((asic.ce_ip_addr & 0x0000ff00) >> 8),
+			(asic.ce_ip_addr & 0xff), asic.ce_ip_mask_len,
+			htons(tmp_ip.v6_addr16[0]), htons(tmp_ip.v6_addr16[1]),
+			htons(tmp_ip.v6_addr16[2]), htons(tmp_ip.v6_addr16[3]),
+			asic.six_rd_prefix_len);
+		seq_printf(s,
+			"        brip(%d.%d.%d.%d)/bripm:(%d) 6RD MTU:%d(0x%x) valid:%d\n",
+			(asic.br_ip_addr >> 24),
+			((asic.br_ip_addr & 0x00ff0000) >> 16),
+			((asic.br_ip_addr & 0x0000ff00) >> 8),
+			(asic.br_ip_addr & 0xff), asic.br_ip_mask_len, asic.mtu,
+			asic.mtu, asic.valid);
+	}
+#endif
+	return 0;
+}
+#else
+static int32 ip6rd_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	uint32 idx;
+	rtl8198C_tblAsicDrv_6rdParam_t asic;
+
+	len = sprintf(page, "%s\n", "ASIC 6RD Table:\n");
+	for (idx = 0; idx < RTL8198C_6RDTBL_SIZE; idx++) {
+		if (rtl8198C_getAsic6rdTable(idx, &asic) == FAILED)
+			continue;
+
+		len += sprintf(page + len,
+			"  [%d]  ceip(%d.%d.%d.%d)/ceipm:(%d) 6RD prefix=> ::%04x:%04x:%04x:%04x/%d\n",
+			idx, (asic.ce_ip_addr >> 24),
+			((asic.ce_ip_addr & 0x00ff0000) >> 16),
+			((asic.ce_ip_addr & 0x0000ff00) >> 8),
+			(asic.ce_ip_addr & 0xff), asic.ce_ip_mask_len,
+			asic.six_rd_prefix.v6_addr16[0],
+			asic.six_rd_prefix.v6_addr16[1],
+			asic.six_rd_prefix.v6_addr16[2],
+			asic.six_rd_prefix.v6_addr16[3],
+			asic.six_rd_prefix_len);
+		len += sprintf(page + len,
+			"        brip(%d.%d.%d.%d)/bripm:(%d) 6RD MTU:%d(0x%x) valid:%d\n",
+			(asic.br_ip_addr >> 24),
+			((asic.br_ip_addr & 0x00ff0000) >> 16),
+			((asic.br_ip_addr & 0x0000ff00) >> 8),
+			(asic.br_ip_addr & 0xff), asic.br_ip_mask_len, asic.mtu,
+			asic.mtu, asic.valid);
+	}
+
+	return len;
+}
+#endif
+
+static int32 ip6rd_write(struct file *filp, const char *buff, unsigned long len,
+	void *data)
+{
+	return len;
+}
+
+/* dslite-------------------------------------------------------------------------- */
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 dslite_read(struct seq_file *s, void *v)
+{
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	uint32 idx;
+	rtl8198C_tblAsicDrv_dsliteParam_t asic;
+	inv6_addr_t tmp_ip;
+
+	seq_printf(s, "%s\n", "ASIC DSLITE Table:\n");
+	for (idx = 0; idx < RTL8198C_DSLITETBL_SIZE; idx++) {
+		if (rtl8198C_getAsicDsliteTable(idx, &asic) == FAILED)
+			continue;
+
+		memset((void *)&tmp_ip.v6_addr32[0], 0x00, sizeof(tmp_ip));
+		ntohl_array((uint32 *)&asic.host_ipv6_addr.v6_addr32[0],
+			(void *)&tmp_ip.v6_addr32[0], 4);
+
+		seq_printf(s,
+			"\t[%d]  HOSTIP/MASK:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x/%d \n",
+			idx, htons(tmp_ip.v6_addr16[0]),
+			htons(tmp_ip.v6_addr16[1]), htons(tmp_ip.v6_addr16[2]),
+			htons(tmp_ip.v6_addr16[3]), htons(tmp_ip.v6_addr16[4]),
+			htons(tmp_ip.v6_addr16[5]), htons(tmp_ip.v6_addr16[6]),
+			htons(tmp_ip.v6_addr16[7]), asic.host_ipv6_mask);
+		memset((void *)&tmp_ip.v6_addr32[0], 0x00, sizeof(tmp_ip));
+		ntohl_array((uint32 *)&asic.aftr_ipv6_addr.v6_addr32[0],
+			(void *)&tmp_ip.v6_addr32[0], 4);
+
+		seq_printf(s,
+			"\t      AFTRIP/MASK:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x/%d MTU:%d(0x%x) valid:%d\n",
+			htons(tmp_ip.v6_addr16[0]), htons(tmp_ip.v6_addr16[1]),
+			htons(tmp_ip.v6_addr16[2]), htons(tmp_ip.v6_addr16[3]),
+			htons(tmp_ip.v6_addr16[4]), htons(tmp_ip.v6_addr16[5]),
+			htons(tmp_ip.v6_addr16[6]), htons(tmp_ip.v6_addr16[7]),
+			asic.aftr_ipv6_mask, asic.mtu, asic.mtu, asic.valid);
+	}
+#endif
+	return 0;
+}
+#else
+static int32 dslite_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len = 0;
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	uint32 idx;
+	rtl8198C_tblAsicDrv_dsliteParam_t asic;
+	inv6_addr_t tmp_ip;
+
+	len = sprintf(page, "%s\n", "ASIC DSLITE Table:\n");
+	for (idx = 0; idx < RTL8198C_DSLITETBL_SIZE; idx++) {
+		if (rtl8198C_getAsicDsliteTable(idx, &asic) == FAILED)
+			continue;
+
+		memset((void *)&tmp_ip.v6_addr32[0], 0x00, sizeof(tmp_ip));
+		ntohl_array((uint32 *)&asic.host_ipv6_addr.v6_addr32[0],
+			(void *)&tmp_ip.v6_addr32[0], 4);
+
+		len += sprintf(page + len,
+			"\t[%d]  HOSTIP/MASK:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x/%d \n",
+			idx, htons(tmp_ip.v6_addr16[0]),
+			htons(tmp_ip.v6_addr16[1]), htons(tmp_ip.v6_addr16[2]),
+			htons(tmp_ip.v6_addr16[3]), htons(tmp_ip.v6_addr16[4]),
+			htons(tmp_ip.v6_addr16[5]), htons(tmp_ip.v6_addr16[6]),
+			htons(tmp_ip.v6_addr16[7]), asic.host_ipv6_mask);
+
+		memset((void *)&tmp_ip.v6_addr32[0], 0x00, sizeof(tmp_ip));
+		ntohl_array((uint32 *)&asic.aftr_ipv6_addr.v6_addr32[0],
+			(void *)&tmp_ip.v6_addr32[0], 4);
+
+		len += sprintf(page + len,
+			"\t      AFTRIP/MASK:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x/%d MTU:%d(0x%x) valid:%d\n",
+			htons(tmp_ip.v6_addr16[0]), htons(tmp_ip.v6_addr16[1]),
+			htons(tmp_ip.v6_addr16[2]), htons(tmp_ip.v6_addr16[3]),
+			htons(tmp_ip.v6_addr16[4]), htons(tmp_ip.v6_addr16[5]),
+			htons(tmp_ip.v6_addr16[6]), htons(tmp_ip.v6_addr16[7]),
+			asic.aftr_ipv6_mask, asic.mtu, asic.mtu, asic.valid);
+	}
+#endif
+	return len;
+}
+#endif
+
+static int32 dslite_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+/* sw_dslite-------------------------------------------------------------------------- */
+#if defined(CONFIG_RTL_PROC_NEW) && defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+static int32 sw_dslite_read(struct seq_file *s, void *v)
+{
+	uint32 idx;
+	rtl865x_dslite_s entry;
+
+	seq_printf(s, "%s\n", "SW DSLITE Table:\n");
+	for (idx = 0; idx < RTL8198C_DSLITETBL_SIZE; idx++) {
+		if (_rtl865x_getIpv6DsLiteEntrybyIndex(idx, &entry) == FAILED)
+			continue;
+		seq_printf(s,
+			"\t[%d]  HOSTIP/MASK:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x/%d \n",
+			idx, entry.host_ipv6_addr.v6_addr16[0],
+			entry.host_ipv6_addr.v6_addr16[1],
+			entry.host_ipv6_addr.v6_addr16[2],
+			entry.host_ipv6_addr.v6_addr16[3],
+			entry.host_ipv6_addr.v6_addr16[4],
+			entry.host_ipv6_addr.v6_addr16[5],
+			entry.host_ipv6_addr.v6_addr16[6],
+			entry.host_ipv6_addr.v6_addr16[7],
+			entry.host_ipv6_mask);
+		seq_printf(s,
+			"\t      AFTRIP/MASK:%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x/%d MTU:%d(0x%x) valid:%d\n",
+			entry.aftr_ipv6_addr.v6_addr16[0],
+			entry.aftr_ipv6_addr.v6_addr16[1],
+			entry.aftr_ipv6_addr.v6_addr16[2],
+			entry.aftr_ipv6_addr.v6_addr16[3],
+			entry.aftr_ipv6_addr.v6_addr16[4],
+			entry.aftr_ipv6_addr.v6_addr16[5],
+			entry.aftr_ipv6_addr.v6_addr16[6],
+			entry.aftr_ipv6_addr.v6_addr16[7], entry.aftr_ipv6_mask,
+			entry.mtu, entry.mtu, entry.valid);
+	}
+	return 0;
+}
+#else
+static int32 sw_dslite_read(struct seq_file *s, void *v)
+{
+	return 0;
+}
+#endif
+
+static int32 sw_dslite_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+#endif /* //end of CONFIG_RTL_8198C */
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+extern struct proc_dir_entry proc_root;
+
+/*stats*/
+int stats_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, stats_debug_entry_read, NULL));
+}
+
+static ssize_t stats_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return stats_debug_entry_write(file, userbuf, count, off);
+}
+
+struct file_operations stats_proc_fops = {
+	.open = stats_single_open,
+	.write = stats_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#ifdef CONFIG_RTL865X_ROMEPERF
+/*perf_dump*/
+int perf_dump_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_perf_proc_read, NULL));
+}
+
+static ssize_t perf_dump_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_perf_proc_write(file, userbuf, count, off);
+}
+
+struct file_operations perf_dump_proc_fops = {
+	.open = perf_dump_single_open,
+	.write = perf_dump_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#ifdef CONFIG_RTL_PROC_DEBUG
+/*netif*/
+int netif_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, netif_read, NULL));
+}
+
+static ssize_t netif_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return netif_write(file, userbuf, count, off);
+}
+
+struct file_operations netif_proc_fops = {
+	.open = netif_single_open,
+	.write = netif_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*netif*/
+int sw_netif_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, sw_netif_read, NULL));
+}
+
+static ssize_t sw_netif_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return sw_netif_write(file, userbuf, count, off);
+}
+
+struct file_operations sw_netif_proc_fops = {
+	.open = sw_netif_single_open,
+	.write = sw_netif_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*acl*/
+/* int acl_single_open(struct inode *inode, struct file *file) */
+/* { */
+/* return(single_open(file, acl_show, NULL)); */
+/* } */
+/* static ssize_t acl_single_write(struct file * file, const char __user * userbuf, */
+/* size_t count, loff_t * off) */
+/* { */
+/* return acl_write(file, userbuf,count, off); */
+/* } */
+struct file_operations acl_proc_fops = {
+	.open = acl_single_open,
+/* .write                    = acl_single_write, */
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*advRt*/
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+int advRt_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, advRt_read, NULL));
+}
+
+static ssize_t advRt_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return advRt_write(file, userbuf, count, off);
+}
+
+struct file_operations advRt_proc_fops = {
+	.open = advRt_single_open,
+	.write = advRt_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+/*storm_control*/
+int storm_control_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, storm_read, NULL));
+}
+
+static ssize_t storm_control_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return storm_write(file, userbuf, count, off);
+}
+
+struct file_operations storm_control_proc_fops = {
+	.open = storm_control_single_open,
+	.write = storm_control_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*hs*/
+int hs_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, hs_read, NULL));
+}
+
+static ssize_t hs_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return hs_write(file, userbuf, count, off);
+}
+
+struct file_operations hs_proc_fops = {
+	.open = hs_single_open,
+	.write = hs_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*pvid*/
+int pvid_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, pvid_read, NULL));
+}
+
+static ssize_t pvid_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return pvid_write(file, userbuf, count, off);
+}
+
+struct file_operations pvid_proc_fops = {
+	.open = pvid_single_open,
+	.write = pvid_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*mirrorPort*/
+int mirrorPort_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, mirrorPort_read, NULL));
+}
+
+static ssize_t mirrorPort_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return mirrorPort_write(file, userbuf, count, off);
+}
+
+struct file_operations mirrorPort_proc_fops = {
+	.open = mirrorPort_single_open,
+	.write = mirrorPort_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*l2*/
+int l2_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, l2_read, NULL));
+}
+
+static ssize_t l2_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return l2_write(file, userbuf, count, off);
+}
+
+struct file_operations l2_proc_fops = {
+	.open = l2_single_open,
+	.write = l2_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*hwMCast*/
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+int hwMCast_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_proc_hw_mcast_read, NULL));
+}
+
+static ssize_t hwMCast_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_proc_hw_mcast_write(file, userbuf, count, off);
+}
+
+struct file_operations hwMCast_proc_fops = {
+	.open = hwMCast_single_open,
+	.write = hwMCast_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*swMCast*/
+int swMCast_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_proc_sw_mcast_read, NULL));
+}
+
+static ssize_t swMCast_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_proc_sw_mcast_write(file, userbuf, count, off);
+}
+
+struct file_operations swMCast_proc_fops = {
+	.open = swMCast_single_open,
+	.write = swMCast_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+/*arp*/
+int arp_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, arp_read, NULL));
+}
+
+static ssize_t arp_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return arp_write(file, userbuf, count, off);
+}
+
+struct file_operations arp_proc_fops = {
+	.open = arp_single_open,
+	.write = arp_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*nexthop*/
+int nexthop_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, nexthop_read, NULL));
+}
+
+static ssize_t nexthop_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return nexthop_write(file, userbuf, count, off);
+}
+
+struct file_operations nexthop_proc_fops = {
+	.open = nexthop_single_open,
+	.write = nexthop_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+extern int32 sw_nexthop_read(struct seq_file *s, void *v);
+extern int32 sw_nexthop_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+
+int sw_nexthop_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, sw_nexthop_read, NULL));
+}
+
+static ssize_t sw_nexthop_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return sw_nexthop_write(file, userbuf, count, off);
+}
+
+struct file_operations sw_nexthop_proc_fops = {
+	.open = sw_nexthop_single_open,
+	.write = sw_nexthop_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*l3*/
+int l3_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, l3_read, NULL));
+}
+
+static ssize_t l3_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return l3_write(file, userbuf, count, off);
+}
+
+struct file_operations l3_proc_fops = {
+	.open = l3_single_open,
+	.write = l3_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*sw_l3*/
+extern int32 sw_l3_read(struct seq_file *s, void *v);
+extern int32 sw_l3_write(struct file *filp, const char *buff, unsigned long len,
+	void *data);
+
+int sw_l3_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, sw_l3_read, NULL));
+}
+
+static ssize_t sw_l3_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return sw_l3_write(file, userbuf, count, off);
+}
+
+struct file_operations sw_l3_proc_fops = {
+	.open = sw_l3_single_open,
+	.write = sw_l3_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*ip*/
+int ip_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, ip_read, NULL));
+}
+
+static ssize_t ip_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return ip_write(file, userbuf, count, off);
+}
+
+struct file_operations ip_proc_fops = {
+	.open = ip_single_open,
+	.write = ip_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*pppoe*/
+int pppoe_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, pppoe_read, NULL));
+}
+
+static ssize_t pppoe_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return pppoe_write(file, userbuf, count, off);
+}
+
+struct file_operations pppoe_proc_fops = {
+	.open = pppoe_single_open,
+	.write = pppoe_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+/*sw_l2*/
+int sw_l2_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_sw_l2_proc_read, NULL));
+}
+
+static ssize_t sw_l2_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return rtl865x_sw_l2_proc_write(file, userbuf, count, off);
+}
+
+struct file_operations sw_l2_proc_fops = {
+	.open = sw_l2_single_open,
+	.write = sw_l2_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+/*port_bandwidth*/
+int port_bandwidth_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, port_bandwidth_read, NULL));
+}
+
+static ssize_t port_bandwidth_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return port_bandwidth_write(file, userbuf, count, off);
+}
+
+struct file_operations port_bandwidth_proc_fops = {
+	.open = port_bandwidth_single_open,
+	.write = port_bandwidth_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*queue_bandwidth*/
+int queue_bandwidth_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, queue_bandwidth_read, NULL));
+}
+
+static ssize_t queue_bandwidth_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return queue_bandwidth_write(file, userbuf, count, off);
+}
+
+struct file_operations queue_bandwidth_proc_fops = {
+	.open = queue_bandwidth_single_open,
+	.write = queue_bandwidth_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*priority_decision*/
+int priority_decision_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, priority_decision_read, NULL));
+}
+
+static ssize_t priority_decision_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return priority_decision_write(file, userbuf, count, off);
+}
+
+struct file_operations priority_decision_proc_fops = {
+	.open = priority_decision_single_open,
+	.write = priority_decision_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#if defined(CONFIG_RTL_ENABLE_RATELIMIT_TABLE)
+/*rateLimit*/
+int rateLimit_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rate_limit_read, NULL));
+}
+
+static ssize_t rateLimit_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rate_limit_write(file, userbuf, count, off);
+}
+
+struct file_operations rateLimit_proc_fops = {
+	.open = rateLimit_single_open,
+	.write = rateLimit_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#if defined(CONFIG_RTL_LAYERED_DRIVER) && defined(CONFIG_RTL865X_EVENT_PROC_DEBUG)
+/*eventMgr*/
+int eventMgr_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_event_proc_read, NULL));
+}
+
+static ssize_t eventMgr_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_event_proc_write(file, userbuf, count, off);
+}
+
+struct file_operations eventMgr_proc_fops = {
+	.open = eventMgr_single_open,
+	.write = eventMgr_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#endif
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+/*privSkbInfo*/
+int privSkbInfo_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl819x_proc_privSkbInfo_read, NULL));
+}
+
+static ssize_t privSkbInfo_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl819x_proc_privSkbInfo_write(file, userbuf, count, off);
+}
+
+struct file_operations privSkbInfo_proc_fops = {
+	.open = privSkbInfo_single_open,
+	.write = privSkbInfo_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*memory*/
+int memory_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, proc_mem_read, NULL));
+}
+
+static ssize_t memory_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return proc_mem_write(file, userbuf, count, off);
+}
+
+struct file_operations memory_proc_fops = {
+	.open = memory_single_open,
+	.write = memory_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*diagnostic*/
+int diagnostic_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, diagnostic_read, NULL));
+}
+
+static ssize_t diagnostic_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return diagnostic_write(file, userbuf, count, off);
+}
+
+struct file_operations diagnostic_proc_fops = {
+	.open = diagnostic_single_open,
+	.write = diagnostic_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*port_status*/
+int port_status_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, port_status_read, NULL));
+}
+
+static ssize_t port_status_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return port_status_write(file, userbuf, count, off);
+}
+
+struct file_operations port_status_proc_fops = {
+	.open = port_status_single_open,
+	.write = port_status_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*phyReg*/
+int phyReg_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, proc_phyReg_read, NULL));
+}
+
+static ssize_t phyReg_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return proc_phyReg_write(file, userbuf, count, off);
+}
+
+struct file_operations phyReg_proc_fops = {
+	.open = phyReg_single_open,
+	.write = phyReg_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*rgmii*/
+int rgmii_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, proc_rgmii_read, NULL));
+}
+
+static ssize_t rgmii_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return proc_rgmii_write(file, userbuf, count, off);
+}
+
+struct file_operations rgmii_proc_fops = {
+	.open = rgmii_single_open,
+	.write = rgmii_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*asicCounter*/
+int asicCounter_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_proc_mibCounter_read, NULL));
+}
+
+static ssize_t asicCounter_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_proc_mibCounter_write(file, userbuf, count, off);
+}
+
+struct file_operations asicCounter_proc_fops = {
+	.open = asicCounter_single_open,
+	.write = asicCounter_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*mmd*/
+int mmd_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, proc_mmd_read, NULL));
+}
+
+static ssize_t mmd_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return proc_mmd_write(file, userbuf, count, off);
+}
+
+struct file_operations mmd_proc_fops = {
+	.open = mmd_single_open,
+	.write = mmd_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*mac*/
+int mac_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, mac_config_read, NULL));
+}
+
+static ssize_t mac_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return mac_config_write(file, userbuf, count, off);
+}
+
+struct file_operations mac_proc_fops = {
+	.open = mac_single_open,
+	.write = mac_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*fc_threshold*/
+int fc_threshold_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, fc_threshold_read, NULL));
+}
+
+static ssize_t fc_threshold_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return fc_threshold_write(file, userbuf, count, off);
+}
+
+struct file_operations fc_threshold_proc_fops = {
+	.open = fc_threshold_single_open,
+	.write = fc_threshold_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+int portRate_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_proc_portRate_read, NULL));
+}
+
+static ssize_t portRate_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_proc_portRate_write(file, userbuf, count, off);
+}
+
+struct file_operations portRate_proc_fops = {
+	.open = portRate_single_open,
+	.write = portRate_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+/*l3v6*/
+int l3v6_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, l3v6_read, NULL));
+}
+
+static ssize_t l3v6_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return l3v6_write(file, userbuf, count, off);
+}
+
+struct file_operations l3v6_proc_fops = {
+	.open = l3v6_single_open,
+	.write = l3v6_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*arp6*/
+int arp6_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, arp6_read, NULL));
+}
+
+static ssize_t arp6_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return arp6_write(file, userbuf, count, off);
+}
+
+struct file_operations arp6_proc_fops = {
+	.open = arp6_single_open,
+	.write = arp6_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*sw_arp6*/
+int sw_arp6_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, sw_arp6_read, NULL));
+}
+
+static ssize_t sw_arp6_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return sw_arp6_write(file, userbuf, count, off);
+}
+
+struct file_operations sw_arp6_proc_fops = {
+	.open = sw_arp6_single_open,
+	.write = sw_arp6_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*nexthop6*/
+int nexthop6_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, nexthop6_read, NULL));
+}
+
+static ssize_t nexthop6_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return nexthop6_write(file, userbuf, count, off);
+}
+
+struct file_operations nexthop6_proc_fops = {
+	.open = nexthop6_single_open,
+	.write = nexthop6_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*mcast6*/
+int mcast6_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, mcast6_read, NULL));
+}
+
+static ssize_t mcast6_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return mcast6_write(file, userbuf, count, off);
+}
+
+struct file_operations mcast6_proc_fops = {
+	.open = mcast6_single_open,
+	.write = mcast6_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*6rd*/
+int sixrd_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, ip6rd_read, NULL));
+}
+
+static ssize_t sixrd_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return ip6rd_write(file, userbuf, count, off);
+}
+
+struct file_operations sixrd_proc_fops = {
+	.open = sixrd_single_open,
+	.write = sixrd_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*dslite*/
+int dslite_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, dslite_read, NULL));
+}
+
+static ssize_t dslite_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return dslite_write(file, userbuf, count, off);
+}
+
+struct file_operations dslite_proc_fops = {
+	.open = dslite_single_open,
+	.write = dslite_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*sw_dslite*/
+int sw_dslite_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, sw_dslite_read, NULL));
+}
+
+static ssize_t sw_dslite_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return sw_dslite_write(file, userbuf, count, off);
+}
+
+struct file_operations sw_dslite_proc_fops = {
+	.open = sw_dslite_single_open,
+	.write = sw_dslite_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#endif
+
+#else /* CONFIG_RTL_PROC_NEW */
+
+#ifdef CONFIG_RTL_PROC_DEBUG
+extern int32 sw_nexthop_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+extern int32 sw_nexthop_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+extern int32 sw_l3_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+extern int32 sw_l3_write(struct file *filp, const char *buff, unsigned long len,
+	void *data);
+#endif
+
+#endif /* CONFIG_RTL_PROC_NEW */
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) && defined(CONFIG_OPENWRT_SDK)	/* mark_bb */
+
+static int32 vlan_8367_pvid_single_show(struct seq_file *s, void *v)
+{
+	uint32 vidp[9], pPriority;
+	int32 i;
+
+	for (i = 0; i < 8; i++) {
+		if (rtk_vlan_portPvid_get(i, &vidp[i], &pPriority) != SUCCESS) {
+			seq_printf(s, "%s\n", "ASIC PVID get failed.");
+		}
+	}
+	seq_printf(s, "%s\n", ">> PVID Reg:");
+	for (i = 0; i < 8; i++)
+		seq_printf(s, "p%d: %d,", i, vidp[i]);
+
+	seq_printf(s, "%s\n", ".");
+
+	return 0;
+
+}
+
+static int32 vlan_8367_single_show(struct seq_file *s, void *v)
+{
+	/* seq_printf(s,"%s\n", "ASIC VLAN Table:"); */
+	rtlglue_printf("%s\n", "ASIC VLAN Table:");
+	{
+		int i, j;
+
+		for (i = 0; i < 4095; i++) {
+			rtl865x_tblAsicDrv_vlanParam_t vlan;
+			unsigned int pMbrmsk, pUntagmsk, pFid;
+
+			if (rtk_vlan_get(i, &pMbrmsk, &pUntagmsk,
+					&pFid) == FAILED)
+				continue;
+
+			if (pMbrmsk == 0)
+				continue;
+
+			vlan.memberPortMask = pMbrmsk;
+			vlan.untagPortMask = pUntagmsk;
+			vlan.fid = pFid;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			rtlglue_printf("  VID[%d] ", i);
+#else
+			vlan.vid = (unsigned short)i;
+			rtlglue_printf("  VID[%d] ", vlan.vid);
+#endif
+			rtlglue_printf("\n\tmember ports:");
+
+			for (j = 0;
+				j <
+				RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum;
+				j++) {
+				if (vlan.memberPortMask & (1 << j))
+					rtlglue_printf("%d ", j);
+			}
+
+			rtlglue_printf("\n\tUntag member ports:");
+
+			for (j = 0;
+				j <
+				RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum;
+				j++) {
+				if (vlan.untagPortMask & (1 << j))
+					rtlglue_printf("%d ", j);
+			}
+
+			rtlglue_printf("\n\tFID:\t%d\n", vlan.fid);
+		}
+
+	}
+
+	return 0;
+}
+
+static int vlan_8367_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, vlan_8367_single_show, NULL));
+}
+
+static int vlan_8367_pvid_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, vlan_8367_pvid_single_show, NULL));
+}
+
+struct file_operations vlan_8367_single_seq_file_operations = {
+	.open = vlan_8367_single_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+struct file_operations vlan_8367_pvid_single_seq_file_operations = {
+	.open = vlan_8367_pvid_single_open,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+int32 rtl865x_proc_debug_init(void)
+{
+	int32 retval;
+
+#if defined(CONFIG_RTL_LOG_DEBUG)
+	extern void log_print_proc_init(void);
+
+	log_print_proc_init();
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+	rtl865x_proc_dir = proc_mkdir(RTL865X_PROC_DIR_NAME, &proc_root);
+	retval = SUCCESS;
+#else
+	rtl865x_proc_dir = proc_mkdir(RTL865X_PROC_DIR_NAME, NULL);
+#endif
+	if (rtl865x_proc_dir) {
+#ifdef CONFIG_RTL_PROC_DEBUG
+#if !defined(CONFIG_RTL_8198C) &&  !defined(CONFIG_RTL_8197F)	/* "/proc/rtl865x/stats" is duplicated */
+		/*stats */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("stats", 0, rtl865x_proc_dir,
+				&stats_proc_fops, NULL);
+#else
+			stats_debug_entry =
+				create_proc_entry("stats", 0, rtl865x_proc_dir);
+			if (stats_debug_entry != NULL) {
+				stats_debug_entry->read_proc =
+					stats_debug_entry_read;
+				stats_debug_entry->write_proc =
+					stats_debug_entry_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for stats");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#endif
+		/*vlan */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("vlan", 0, rtl865x_proc_dir,
+				&vlan_single_seq_file_operations, NULL);
+#else
+			vlan_entry =
+				create_proc_entry("vlan", 0, rtl865x_proc_dir);
+			if (vlan_entry != NULL) {
+				/* vlan_entry->read_proc = vlan_read; */
+				/* vlan_entry->write_proc= vlan_write; */
+				vlan_entry->proc_fops =
+					&vlan_single_seq_file_operations;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for vlan");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*netif */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("netif", 0, rtl865x_proc_dir,
+				&netif_proc_fops, NULL);
+#else
+			netif_entry =
+				create_proc_entry("netif", 0, rtl865x_proc_dir);
+			if (netif_entry != NULL) {
+				netif_entry->read_proc = netif_read;
+				netif_entry->write_proc = netif_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for netif");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*swnetif */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("sw_netif", 0, rtl865x_proc_dir,
+				&sw_netif_proc_fops, NULL);
+#else
+			sw_netif_entry =
+				create_proc_entry("sw_netif", 0,
+				rtl865x_proc_dir);
+			if (sw_netif_entry != NULL) {
+				sw_netif_entry->read_proc = sw_netif_read;
+				sw_netif_entry->write_proc = sw_netif_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for sw netif");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) && defined(CONFIG_OPENWRT_SDK)	/* mark_bb */
+		{
+			proc_create_data("8367_vlan", 0, rtl865x_proc_dir,
+				&vlan_8367_single_seq_file_operations, NULL);
+
+		}
+		/*pvid */
+		{
+			proc_create_data("8367_pvid", 0, rtl865x_proc_dir,
+				&vlan_8367_pvid_single_seq_file_operations,
+				NULL);
+
+		}
+#endif
+		/*acl */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("acl", 0, rtl865x_proc_dir,
+				&acl_proc_fops, NULL);
+#else
+			acl_entry =
+				create_proc_entry("acl", 0, rtl865x_proc_dir);
+			if (acl_entry != NULL) {
+				/*acl_entry->read_proc = acl_read;
+				 * acl_entry->write_proc= acl_write;
+				 * acl_entry->owner = THIS_MODULE;
+				 */
+				acl_entry->proc_fops =
+					&acl_single_seq_file_operations;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for acl");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("advRt", 0, rtl865x_proc_dir,
+				&advRt_proc_fops, NULL);
+#else
+			advRt_entry =
+				create_proc_entry("advRt", 0, rtl865x_proc_dir);
+			if (advRt_entry != NULL) {
+				advRt_entry->read_proc = advRt_read;
+				advRt_entry->write_proc = advRt_write;
+				/* advRt_entry->owner = THIS_MODULE; */
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for advRt");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#endif
+
+		/*storm control */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("storm_control", 0, rtl865x_proc_dir,
+				&storm_control_proc_fops, NULL);
+#else
+			storm_control =
+				create_proc_entry("storm_control", 0,
+				rtl865x_proc_dir);
+			if (storm_control != NULL) {
+				storm_control->read_proc = storm_read;
+				storm_control->write_proc = storm_write;
+			} else {
+				rtlglue_printf("can't create proc entry for storm control");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+		/*soft acl chains */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("soft_aclChains", 0, rtl865x_proc_dir,
+				&aclChains_single_seq_file_operations, NULL);
+#else
+			acl_chains_entry =
+				create_proc_entry("soft_aclChains", 0,
+				rtl865x_proc_dir);
+			if (acl_chains_entry != NULL) {
+				acl_chains_entry->proc_fops =
+					&aclChains_single_seq_file_operations;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for aclChains");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+		/*qos rules */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("soft_qosRules", 0, rtl865x_proc_dir,
+				&qosRule_single_seq_file_operations, NULL);
+#else
+			qos_rule_entry =
+				create_proc_entry("soft_qosRules", 0,
+				rtl865x_proc_dir);
+			if (qos_rule_entry != NULL) {
+				/*acl_entry->read_proc = acl_read;
+				 * acl_entry->write_proc= acl_write;
+				 * acl_entry->owner = THIS_MODULE;
+				 */
+				qos_rule_entry->proc_fops =
+					&qosRule_single_seq_file_operations;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for aclChains");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#endif
+		/*hs */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("hs", 0, rtl865x_proc_dir,
+				&hs_proc_fops, NULL);
+#else
+			hs_entry = create_proc_entry("hs", 0, rtl865x_proc_dir);
+			if (hs_entry != NULL) {
+				hs_entry->read_proc = hs_read;
+				hs_entry->write_proc = hs_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for hs");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#if defined(RTL_DEBUG_NIC_SKB_BUFFER)
+		/*nic mbuf */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("nic_mbuf", 0, rtl865x_proc_dir,
+				&nic_mbuf_single_seq_file_operations, NULL);
+#else
+			nic_skb_buff =
+				create_proc_entry("nic_mbuf", 0,
+				rtl865x_proc_dir);
+			if (nic_skb_buff != NULL) {
+				nic_skb_buff->proc_fops =
+					&nic_mbuf_single_seq_file_operations;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create nic_mbuf entry for hs");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#endif
+		/*rx ring */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("rxRing", 0, rtl865x_proc_dir,
+				&rxRing_single_seq_file_operations, NULL);
+#else
+			rxRing_entry =
+				create_proc_entry("rxRing", 0,
+				rtl865x_proc_dir);
+			if (rxRing_entry != NULL) {
+				rxRing_entry->proc_fops =
+					&rxRing_single_seq_file_operations;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create rxRing entry for hs");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*tx ring */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("txRing", 0, rtl865x_proc_dir,
+				&txRing_single_seq_file_operations, NULL);
+#else
+			txRing_entry =
+				create_proc_entry("txRing", 0,
+				rtl865x_proc_dir);
+			if (txRing_entry != NULL) {
+				txRing_entry->proc_fops =
+					&txRing_single_seq_file_operations;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create txRing entry for hs");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*mbufRing */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("mbufRing", 0, rtl865x_proc_dir,
+				&mbuf_single_seq_file_operations, NULL);
+#else
+			mbuf_entry =
+				create_proc_entry("mbufRing", 0,
+				rtl865x_proc_dir);
+			if (mbuf_entry != NULL) {
+				mbuf_entry->proc_fops =
+					&mbuf_single_seq_file_operations;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create mbuf entry for mbufRing");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*pvid */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("pvid", 0, rtl865x_proc_dir,
+				&pvid_proc_fops, NULL);
+#else
+			pvid_entry =
+				create_proc_entry("pvid", 0, rtl865x_proc_dir);
+			if (pvid_entry != NULL) {
+				pvid_entry->read_proc = pvid_read;
+				pvid_entry->write_proc = pvid_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for pvid");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*mirrorPort */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("mirrorPort", 0, rtl865x_proc_dir,
+				&mirrorPort_proc_fops, NULL);
+#else
+			mirrorPort_entry =
+				create_proc_entry("mirrorPort", 0,
+				rtl865x_proc_dir);
+			if (mirrorPort_entry != NULL) {
+				mirrorPort_entry->read_proc = mirrorPort_read;
+				mirrorPort_entry->write_proc = mirrorPort_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for mirrorPort");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*l2 */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("l2", 0, rtl865x_proc_dir,
+				&l2_proc_fops, NULL);
+#else
+			l2_entry = create_proc_entry("l2", 0, rtl865x_proc_dir);
+			if (l2_entry != NULL) {
+				l2_entry->read_proc = l2_read;
+				l2_entry->write_proc = l2_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for l2");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("hwMCast", 0, rtl865x_proc_dir,
+				&hwMCast_proc_fops, NULL);
+#else
+			hwMCast_entry =
+				create_proc_entry("hwMCast", 0,
+				rtl865x_proc_dir);
+			if (hwMCast_entry != NULL) {
+				hwMCast_entry->read_proc =
+					rtl865x_proc_hw_mcast_read;
+				hwMCast_entry->write_proc =
+					rtl865x_proc_hw_mcast_write;
+				retval = SUCCESS;
+			}
+#endif
+		}
+
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("swMCast", 0, rtl865x_proc_dir,
+				&swMCast_proc_fops, NULL);
+#else
+			swMCast_entry =
+				create_proc_entry("swMCast", 0,
+				rtl865x_proc_dir);
+			if (swMCast_entry != NULL) {
+				swMCast_entry->read_proc =
+					rtl865x_proc_sw_mcast_read;
+				swMCast_entry->write_proc =
+					rtl865x_proc_sw_mcast_write;
+				retval = SUCCESS;
+			}
+#endif
+		}
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+		/*arp */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("arp", 0, rtl865x_proc_dir,
+				&arp_proc_fops, NULL);
+#else
+			arp_entry =
+				create_proc_entry("arp", 0, rtl865x_proc_dir);
+			if (arp_entry != NULL) {
+				arp_entry->read_proc = arp_read;
+				arp_entry->write_proc = arp_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for arp");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*nextHop */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("nexthop", 0, rtl865x_proc_dir,
+				&nexthop_proc_fops, NULL);
+#else
+			nexthop_entry =
+				create_proc_entry("nexthop", 0,
+				rtl865x_proc_dir);
+			if (nexthop_entry != NULL) {
+				nexthop_entry->read_proc = nexthop_read;
+				nexthop_entry->write_proc = nexthop_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for nexthop");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*sw nextHop */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("sw_nexthop", 0, rtl865x_proc_dir,
+				&sw_nexthop_proc_fops, NULL);
+#else
+			sw_nexthop_entry =
+				create_proc_entry("sw_nexthop", 0,
+				rtl865x_proc_dir);
+			if (sw_nexthop_entry != NULL) {
+				sw_nexthop_entry->read_proc = sw_nexthop_read;
+				sw_nexthop_entry->write_proc = sw_nexthop_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for nexthop");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*l3 */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("l3", 0, rtl865x_proc_dir,
+				&l3_proc_fops, NULL);
+#else
+			l3_entry = create_proc_entry("l3", 0, rtl865x_proc_dir);
+			if (l3_entry != NULL) {
+				l3_entry->read_proc = l3_read;
+				l3_entry->write_proc = l3_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for l3");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*sw l3 */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("sw_l3", 0, rtl865x_proc_dir,
+				&sw_l3_proc_fops, NULL);
+#else
+			sw_l3_entry =
+				create_proc_entry("sw_l3", 0, rtl865x_proc_dir);
+			if (sw_l3_entry != NULL) {
+				sw_l3_entry->read_proc = sw_l3_read;
+				sw_l3_entry->write_proc = sw_l3_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for l3");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*ip */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("ip", 0, rtl865x_proc_dir,
+				&ip_proc_fops, NULL);
+#else
+			ip_entry = create_proc_entry("ip", 0, rtl865x_proc_dir);
+			if (ip_entry != NULL) {
+				ip_entry->read_proc = ip_read;
+				ip_entry->write_proc = ip_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for ip");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*pppoe */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("pppoe", 0, rtl865x_proc_dir,
+				&pppoe_proc_fops, NULL);
+#else
+			pppoe_entry =
+				create_proc_entry("pppoe", 0, rtl865x_proc_dir);
+			if (pppoe_entry != NULL) {
+				pppoe_entry->read_proc = pppoe_read;
+				pppoe_entry->write_proc = pppoe_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for pppoe");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+#endif
+#if defined(CONFIG_RTL_LAYERED_DRIVER_L4)
+		/*napt */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("napt", 0, rtl865x_proc_dir,
+				&napt_single_seq_file_operations, NULL);
+#else
+			napt_entry =
+				create_proc_entry("napt", 0, rtl865x_proc_dir);
+			if (napt_entry != NULL) {
+#if 1
+				napt_entry->proc_fops =
+					&napt_single_seq_file_operations;
+#else
+				napt_entry->read_proc = napt_read;
+				napt_entry->write_proc = napt_write;
+				napt_entry->owner = THIS_MODULE;
+#endif
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for napt");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*software napt */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("sw_napt", 0, rtl865x_proc_dir,
+				&sw_napt_single_seq_file_operations, NULL);
+#else
+			sw_napt_entry =
+				create_proc_entry("sw_napt", 0,
+				rtl865x_proc_dir);
+			if (sw_napt_entry != NULL) {
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+				sw_napt_entry->proc_fops =
+					&sw_napt_single_seq_file_operations;
+#else
+				sw_napt_entry->read_proc =
+					rtl865x_sw_napt_proc_read;
+				sw_napt_entry->write_proc =
+					rtl865x_sw_napt_proc_write;
+#endif
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for sw_napt");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+		/*software l2 */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("sw_l2", 0, rtl865x_proc_dir,
+				&sw_l2_proc_fops, NULL);
+#else
+			sw_l2_entry =
+				create_proc_entry("sw_l2", 0, rtl865x_proc_dir);
+			if (sw_l2_entry != NULL) {
+				sw_l2_entry->read_proc =
+					rtl865x_sw_l2_proc_read;
+				sw_l2_entry->write_proc =
+					rtl865x_sw_l2_proc_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for sw_l2");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#endif
+
+		/*port_bandwidth */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("port_bandwidth", 0, rtl865x_proc_dir,
+				&port_bandwidth_proc_fops, NULL);
+#else
+			port_bandwidth_entry =
+				create_proc_entry("port_bandwidth", 0,
+				rtl865x_proc_dir);
+			if (port_bandwidth_entry != NULL) {
+				port_bandwidth_entry->read_proc =
+					port_bandwidth_read;
+				port_bandwidth_entry->write_proc =
+					port_bandwidth_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for port_bandwidth");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*queue_bandwidth */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("queue_bandwidth", 0, rtl865x_proc_dir,
+				&queue_bandwidth_proc_fops, NULL);
+#else
+			queue_bandwidth_entry =
+				create_proc_entry("queue_bandwidth", 0,
+				rtl865x_proc_dir);
+			if (queue_bandwidth_entry != NULL) {
+				queue_bandwidth_entry->read_proc =
+					queue_bandwidth_read;
+				queue_bandwidth_entry->write_proc =
+					queue_bandwidth_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for queue_bandwidth");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*priority_decision */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("priority_decision", 0,
+				rtl865x_proc_dir, &priority_decision_proc_fops,
+				NULL);
+#else
+			priority_decision_entry =
+				create_proc_entry("priority_decision", 0,
+				rtl865x_proc_dir);
+			if (priority_decision_entry != NULL) {
+				priority_decision_entry->read_proc =
+					priority_decision_read;
+				priority_decision_entry->write_proc =
+					priority_decision_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for priority_decision");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#if defined(CONFIG_RTL_ENABLE_RATELIMIT_TABLE)
+		/* rate limit table */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("rateLimit", 0, rtl865x_proc_dir,
+				&rateLimit_proc_fops, NULL);
+#else
+			rateLimit_entry =
+				create_proc_entry("rateLimit", 0,
+				rtl865x_proc_dir);
+			if (rateLimit_entry != NULL) {
+				rateLimit_entry->read_proc = rate_limit_read;
+				rateLimit_entry->write_proc = rate_limit_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for rate limit table");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#endif
+#if defined(CONFIG_RTL_LAYERED_DRIVER) && defined(CONFIG_RTL865X_EVENT_PROC_DEBUG)
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("eventMgr", 0, rtl865x_proc_dir,
+				&eventMgr_proc_fops, NULL);
+#else
+			eventMgr_entry =
+				create_proc_entry("eventMgr", 0,
+				rtl865x_proc_dir);
+			if (eventMgr_entry != NULL) {
+				eventMgr_entry->read_proc =
+					rtl865x_event_proc_read;
+				eventMgr_entry->write_proc =
+					rtl865x_event_proc_write;
+				retval = SUCCESS;
+			}
+#endif
+		}
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("igmp", 0, rtl865x_proc_dir,
+				&igmp_single_seq_file_operations, NULL);
+#else
+			igmp_entry =
+				create_proc_entry("igmp", 0, rtl865x_proc_dir);
+			if (igmp_entry != NULL) {
+				/*
+				 * igmp_entry->read_proc = rtl865x_proc_igmpsnooping_read;
+				 * igmp_entry->write_proc = rtl865x_proc_igmpsnooping_write;
+				 * igmp_entry->owner = THIS_MODULE;
+				 */
+				igmp_entry->proc_fops =
+					&igmp_single_seq_file_operations;
+				retval = SUCCESS;
+			}
+#endif
+		}
+#endif
+#endif
+
+#ifdef CONFIG_RTL865X_ROMEPERF
+		/*rome perf dump */
+		{
+			rtl8651_romeperfInit();
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("perf_dump", 0, rtl865x_proc_dir,
+				&perf_dump_proc_fops, NULL);
+#else
+			perf_dump =
+				create_proc_entry("perf_dump", 0,
+				rtl865x_proc_dir);
+			if (perf_dump != NULL) {
+				perf_dump->read_proc = rtl865x_perf_proc_read;
+				perf_dump->write_proc = rtl865x_perf_proc_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for dump_perf");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#endif
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+
+		/*stats */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("stats", 0, rtl865x_proc_dir,
+				&stats_proc_fops, NULL);
+#else
+			stats_debug_entry =
+				create_proc_entry("stats", 0, rtl865x_proc_dir);
+			if (stats_debug_entry != NULL) {
+				stats_debug_entry->read_proc =
+					stats_debug_entry_read;
+				stats_debug_entry->write_proc =
+					stats_debug_entry_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for stats");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*      #if defined(CONFIG_RTL_ETH_PRIV_SKB_DEBUG)      */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("privSkbInfo", 0, rtl865x_proc_dir,
+				&privSkbInfo_proc_fops, NULL);
+#else
+			prive_skb_debug_entry =
+				create_proc_entry("privSkbInfo", 0,
+				rtl865x_proc_dir);
+			if (prive_skb_debug_entry != NULL) {
+				prive_skb_debug_entry->read_proc =
+					rtl819x_proc_privSkbInfo_read;
+				prive_skb_debug_entry->write_proc =
+					rtl819x_proc_privSkbInfo_write;
+				retval = SUCCESS;
+			}
+#endif
+		}
+
+		/*memory */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("memory", 0, rtl865x_proc_dir,
+				&memory_proc_fops, NULL);
+#else
+			mem_entry =
+				create_proc_entry("memory", 0,
+				rtl865x_proc_dir);
+			if (mem_entry != NULL) {
+				mem_entry->read_proc = proc_mem_read;
+				mem_entry->write_proc = proc_mem_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for memory");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*diagnostic */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("diagnostic", 0, rtl865x_proc_dir,
+				&diagnostic_proc_fops, NULL);
+#else
+			diagnostic_entry =
+				create_proc_entry("diagnostic", 0,
+				rtl865x_proc_dir);
+			if (diagnostic_entry != NULL) {
+				diagnostic_entry->read_proc = diagnostic_read;
+				diagnostic_entry->write_proc = diagnostic_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for diagnostic");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*port_status */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("port_status", 0, rtl865x_proc_dir,
+				&port_status_proc_fops, NULL);
+#else
+			port_status_entry =
+				create_proc_entry("port_status", 0,
+				rtl865x_proc_dir);
+			if (port_status_entry != NULL) {
+				port_status_entry->read_proc = port_status_read;
+				port_status_entry->write_proc =
+					port_status_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for port_status");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*phy */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("phyReg", 0, rtl865x_proc_dir,
+				&phyReg_proc_fops, NULL);
+#else
+			phyReg_entry =
+				create_proc_entry("phyReg", 0,
+				rtl865x_proc_dir);
+			if (phyReg_entry != NULL) {
+				phyReg_entry->read_proc = proc_phyReg_read;
+				phyReg_entry->write_proc = proc_phyReg_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for phyTeg");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/* rgmii */
+		{
+			proc_create_data("rgmii", 0, rtl865x_proc_dir,
+				&rgmii_proc_fops, NULL);
+		}
+
+		/* test_napt */
+		{
+			proc_create_data("test_napt", 0, rtl865x_proc_dir,
+				&test_napt_proc_fops, NULL);
+		}
+
+		/*asicCnt */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("asicCounter", 0, rtl865x_proc_dir,
+				&asicCounter_proc_fops, NULL);
+#else
+			asicCnt_entry =
+				create_proc_entry("asicCounter", 0,
+				rtl865x_proc_dir);
+			if (asicCnt_entry != NULL) {
+				asicCnt_entry->read_proc =
+					rtl865x_proc_mibCounter_read;
+				asicCnt_entry->write_proc =
+					rtl865x_proc_mibCounter_write;
+				retval = SUCCESS;
+			}
+#endif
+		}
+
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+		/*trafficRate */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("portRate", 0, rtl865x_proc_dir,
+				&portRate_proc_fops, NULL);
+#else
+			portRate_entry =
+				create_proc_entry("portRate", 0,
+				rtl865x_proc_dir);
+			if (portRate_entry != NULL) {
+				portRate_entry->read_proc =
+					rtl865x_proc_portRate_read;
+				portRate_entry->write_proc =
+					rtl865x_proc_portRate_write;
+				retval = SUCCESS;
+			}
+#endif
+		}
+#endif
+
+		/* indirect access for special phy register */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("mmd", 0, rtl865x_proc_dir,
+				&mmd_proc_fops, NULL);
+#else
+			mmd_entry =
+				create_proc_entry("mmd", 0, rtl865x_proc_dir);
+			if (mmd_entry != NULL) {
+				mmd_entry->read_proc = proc_mmd_read;
+				mmd_entry->write_proc = proc_mmd_write;
+
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for mmd");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*maccr */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("mac", 0, rtl865x_proc_dir,
+				&mac_proc_fops, NULL);
+#else
+			mac_entry =
+				create_proc_entry("mac", 0, rtl865x_proc_dir);
+			if (mac_entry != NULL) {
+				mac_entry->read_proc = mac_config_read;
+				mac_entry->write_proc = mac_config_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for mac");
+				retval = FAILED;
+				goto out;
+			}
+
+#endif
+		}
+		/*FC threshold */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("fc_threshold", 0, rtl865x_proc_dir,
+				&fc_threshold_proc_fops, NULL);
+#else
+			fc_threshold_entry =
+				create_proc_entry("fc_threshold", 0,
+				rtl865x_proc_dir);
+			if (fc_threshold_entry != NULL) {
+				fc_threshold_entry->read_proc =
+					fc_threshold_read;
+				fc_threshold_entry->write_proc =
+					fc_threshold_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for fc_threshold");
+				retval = FAILED;
+				goto out;
+			}
+
+#endif
+		}
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+		/*l3v6 */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("l3v6", 0, rtl865x_proc_dir,
+				&l3v6_proc_fops, NULL);
+#else
+			l3v6_entry =
+				create_proc_entry("l3v6", 0, rtl865x_proc_dir);
+			if (l3v6_entry != NULL) {
+				l3v6_entry->read_proc = l3v6_read;
+				l3v6_entry->write_proc = l3v6_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for l3v6");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*arp6 */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("arp6", 0, rtl865x_proc_dir,
+				&arp6_proc_fops, NULL);
+#else
+			arp6_entry =
+				create_proc_entry("arp6", 0, rtl865x_proc_dir);
+			if (arp6_entry != NULL) {
+				arp6_entry->read_proc = arp6_read;
+				arp6_entry->write_proc = arp6_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for arp6");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+/*sw-arp6*/
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("sw-arp6", 0, rtl865x_proc_dir,
+				&sw_arp6_proc_fops, NULL);
+#else
+			sw_arp6_entry =
+				create_proc_entry("sw_arp6", 0,
+				rtl865x_proc_dir);
+			if (sw_arp6_entry != NULL) {
+				sw_arp6_entry->read_proc = sw_arp6_read;
+				sw_arp6_entry->write_proc = sw_arp6_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for arp6");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*nexthop6 */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("nexthop6", 0, rtl865x_proc_dir,
+				&nexthop6_proc_fops, NULL);
+#else
+			nexthop6_entry =
+				create_proc_entry("nexthop6", 0,
+				rtl865x_proc_dir);
+			if (nexthop6_entry != NULL) {
+				nexthop6_entry->read_proc = nexthop6_read;
+				nexthop6_entry->write_proc = nexthop6_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for nexthop6");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*mcast6 */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("mcast6", 0, rtl865x_proc_dir,
+				&mcast6_proc_fops, NULL);
+#else
+			mcast6_entry =
+				create_proc_entry("mcast6", 0,
+				rtl865x_proc_dir);
+			if (mcast6_entry != NULL) {
+				mcast6_entry->read_proc = mcast6_read;
+				mcast6_entry->write_proc = mcast6_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for mcast6");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*6rd */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("6rd", 0, rtl865x_proc_dir,
+				&sixrd_proc_fops, NULL);
+#else
+			ip6rd_entry =
+				create_proc_entry("6rd", 0, rtl865x_proc_dir);
+			if (ip6rd_entry != NULL) {
+				ip6rd_entry->read_proc = ip6rd_read;
+				ip6rd_entry->write_proc = ip6rd_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for 6rd");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+		/*dslite */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("dslite", 0, rtl865x_proc_dir,
+				&dslite_proc_fops, NULL);
+#else
+			dslite_entry =
+				create_proc_entry("dslite", 0,
+				rtl865x_proc_dir);
+			if (dslite_entry != NULL) {
+				dslite_entry->read_proc = dslite_read;
+				dslite_entry->write_proc = dslite_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for dslite");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+
+		/*sw-dslite */
+		{
+#ifdef CONFIG_RTL_PROC_NEW
+			proc_create_data("sw_dslite", 0, rtl865x_proc_dir,
+				&sw_dslite_proc_fops, NULL);
+#else
+			sw_dslite_entry =
+				create_proc_entry("sw_dslite", 0,
+				rtl865x_proc_dir);
+			if (sw_dslite_entry != NULL) {
+				sw_dslite_entry->read_proc = sw_dslite_read;
+				sw_dslite_entry->write_proc = sw_dslite_write;
+				retval = SUCCESS;
+			} else {
+				rtlglue_printf("can't create proc entry for dslite");
+				retval = FAILED;
+				goto out;
+			}
+#endif
+		}
+#endif /* end of #if defined(CONFIG_RTL_8198C) */
+#endif
+
+	} else {
+		retval = FAILED;
+	}
+#ifndef CONFIG_RTL_PROC_NEW
+out:
+#endif
+	if (retval == FAILED)
+		rtl865x_proc_debug_cleanup();
+
+	return retval;
+
+}
+
+int32 rtl865x_proc_debug_cleanup(void)
+{
+	if (rtl865x_proc_dir) {
+#ifdef CONFIG_RTL_PROC_DEBUG
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("vlan", rtl865x_proc_dir);
+#else
+		if (vlan_entry) {
+			remove_proc_entry("vlan", rtl865x_proc_dir);
+			vlan_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("netif", rtl865x_proc_dir);
+#else
+		if (netif_entry) {
+			remove_proc_entry("netif", rtl865x_proc_dir);
+			netif_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("acl", rtl865x_proc_dir);
+#else
+		if (acl_entry) {
+			remove_proc_entry("acl", rtl865x_proc_dir);
+			acl_entry = NULL;
+		}
+#endif
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("advRt", rtl865x_proc_dir);
+#else
+		if (advRt_entry) {
+			remove_proc_entry("advRt", rtl865x_proc_dir);
+			advRt_entry = NULL;
+		}
+#endif
+#endif
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("soft_aclChains", rtl865x_proc_dir);
+#else
+		if (acl_chains_entry) {
+			remove_proc_entry("soft_aclChains", rtl865x_proc_dir);
+			acl_chains_entry = NULL;
+		}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("soft_qosRules", rtl865x_proc_dir);
+#else
+		if (qos_rule_entry) {
+			remove_proc_entry("soft_qosRules", rtl865x_proc_dir);
+			qos_rule_entry = NULL;
+		}
+#endif
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("hs", rtl865x_proc_dir);
+#else
+		if (hs_entry) {
+			remove_proc_entry("hs", rtl865x_proc_dir);
+			hs_entry = NULL;
+		}
+#endif
+#if defined(RTL_DEBUG_NIC_SKB_BUFFER)
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("nic_mbuf", rtl865x_proc_dir);
+#else
+		if (nic_skb_buff) {
+			remove_proc_entry("nic_mbuf", rtl865x_proc_dir);
+			nic_skb_buff = NULL;
+		}
+#endif
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("rxRing", rtl865x_proc_dir);
+#else
+		if (rxRing_entry) {
+			remove_proc_entry("rxRing", rtl865x_proc_dir);
+			rxRing_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("txRing", rtl865x_proc_dir);
+#else
+		if (txRing_entry) {
+			remove_proc_entry("txRing", rtl865x_proc_dir);
+			txRing_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("mbufRing", rtl865x_proc_dir);
+#else
+		if (mbuf_entry) {
+			remove_proc_entry("mbufRing", rtl865x_proc_dir);
+			mbuf_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("l2", rtl865x_proc_dir);
+#else
+		if (l2_entry) {
+			remove_proc_entry("l2", rtl865x_proc_dir);
+			l2_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("arp", rtl865x_proc_dir);
+#else
+		if (arp_entry) {
+			remove_proc_entry("arp", rtl865x_proc_dir);
+			arp_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("nexthop", rtl865x_proc_dir);
+#else
+		if (nexthop_entry) {
+			remove_proc_entry("nexthop", rtl865x_proc_dir);
+			nexthop_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("l3", rtl865x_proc_dir);
+#else
+		if (l3_entry) {
+			remove_proc_entry("l3", rtl865x_proc_dir);
+			l3_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("ip", rtl865x_proc_dir);
+#else
+		if (ip_entry) {
+			remove_proc_entry("ip", rtl865x_proc_dir);
+			ip_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("pppoe", rtl865x_proc_dir);
+#else
+		if (pppoe_entry) {
+			remove_proc_entry("pppoe", rtl865x_proc_dir);
+			pppoe_entry = NULL;
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("napt", rtl865x_proc_dir);
+#else
+		if (napt_entry) {
+			remove_proc_entry("napt", rtl865x_proc_dir);
+		}
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("port_bandwidth", rtl865x_proc_dir);
+#else
+		if (port_bandwidth_entry) {
+			remove_proc_entry("port_bandwidth", rtl865x_proc_dir);
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("queue_bandwidth", rtl865x_proc_dir);
+#else
+		if (queue_bandwidth_entry) {
+			remove_proc_entry("queue_bandwidth", rtl865x_proc_dir);
+		}
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("priority_decision", rtl865x_proc_dir);
+#else
+		if (priority_decision_entry) {
+			remove_proc_entry("priority_decision",
+				rtl865x_proc_dir);
+		}
+#endif
+#if defined(CONFIG_RTL_LAYERED_DRIVER_L4)
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("sw_napt", rtl865x_proc_dir);
+#else
+		if (sw_napt_entry) {
+			remove_proc_entry("sw_napt", rtl865x_proc_dir);
+		}
+#endif
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("sw_l2", rtl865x_proc_dir);
+#else
+		if (sw_l2_entry) {
+			remove_proc_entry("sw_l2", rtl865x_proc_dir);
+		}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_LAYERED_DRIVER) && defined(CONFIG_RTL865X_EVENT_PROC_DEBUG)
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("eventMgr", rtl865x_proc_dir);
+#else
+		if (eventMgr_entry != NULL) {
+			remove_proc_entry("eventMgr", rtl865x_proc_dir);
+		}
+#endif
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("hwMCast", rtl865x_proc_dir);
+#else
+		if (hwMCast_entry != NULL) {
+			remove_proc_entry("hwMCast", rtl865x_proc_dir);
+		}
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("swMCast", rtl865x_proc_dir);
+#else
+		if (swMCast_entry != NULL) {
+			remove_proc_entry("swMCast", rtl865x_proc_dir);
+		}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("igmp", rtl865x_proc_dir);
+#else
+		if (igmp_entry != NULL) {
+			remove_proc_entry("igmp", rtl865x_proc_dir);
+		}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_ENABLE_RATELIMIT_TABLE)
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("rateLimit", rtl865x_proc_dir);
+#else
+		if (rateLimit_entry != NULL) {
+			remove_proc_entry("rateLimit", rtl865x_proc_dir);
+		}
+#endif
+#endif
+
+#endif
+
+#ifdef CONFIG_RTL865X_ROMEPERF
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("perf_dump", rtl865x_proc_dir);
+#else
+		if (perf_dump) {
+			remove_proc_entry("perf_dump", rtl865x_proc_dir);
+		}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("stats", rtl865x_proc_dir);
+#else
+		if (stats_debug_entry) {
+			remove_proc_entry("stats", rtl865x_proc_dir);
+			stats_debug_entry = NULL;
+		}
+#endif
+
+		/*#if defined(CONFIG_RTL_ETH_PRIV_SKB_DEBUG) */
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("privSkbInfo", rtl865x_proc_dir);
+#else
+		if (prive_skb_debug_entry != NULL) {
+			remove_proc_entry("privSkbInfo", rtl865x_proc_dir);
+		}
+#endif
+		/*#endif */
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("memory", rtl865x_proc_dir);
+#else
+		if (mem_entry) {
+			remove_proc_entry("memory", mem_entry);
+			mem_entry = NULL;
+		}
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("diagnostic", rtl865x_proc_dir);
+#else
+		if (diagnostic_entry) {
+			remove_proc_entry("diagnostic", rtl865x_proc_dir);
+		}
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("port_status", rtl865x_proc_dir);
+#else
+		if (port_status_entry) {
+			remove_proc_entry("port_status", rtl865x_proc_dir);
+		}
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("phyReg", rtl865x_proc_dir);
+#else
+		if (phyReg_entry) {
+			remove_proc_entry("phyReg", rtl865x_proc_dir);
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("mmd", rtl865x_proc_dir);
+#else
+		if (mmd_entry) {
+			remove_proc_entry("mmd", rtl865x_proc_dir);
+		}
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("asicCounter", rtl865x_proc_dir);
+#else
+		if (asicCnt_entry != NULL) {
+			remove_proc_entry("asicCounter", rtl865x_proc_dir);
+		}
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("mac", rtl865x_proc_dir);
+#else
+		if (mac_entry != NULL) {
+			remove_proc_entry("mac", rtl865x_proc_dir);
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("fc_threshold", rtl865x_proc_dir);
+#else
+		if (fc_threshold_entry != NULL) {
+			remove_proc_entry("fc_threshold", rtl865x_proc_dir);
+		}
+#endif
+
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("l3v6", rtl865x_proc_dir);
+#else
+		if (l3v6_entry != NULL) {
+			remove_proc_entry("l3v6", rtl865x_proc_dir);
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("arp6", rtl865x_proc_dir);
+#else
+		if (arp6_entry != NULL) {
+			remove_proc_entry("arp6", rtl865x_proc_dir);
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("nexthop6", rtl865x_proc_dir);
+#else
+		if (nexthop6_entry != NULL) {
+			remove_proc_entry("nexthop6", rtl865x_proc_dir);
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("mcast6", rtl865x_proc_dir);
+#else
+		if (mcast6_entry != NULL) {
+			remove_proc_entry("mcast6", rtl865x_proc_dir);
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("6rd", rtl865x_proc_dir);
+#else
+		if (ip6rd_entry != NULL) {
+			remove_proc_entry("6rd", rtl865x_proc_dir);
+		}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry("dslite", rtl865x_proc_dir);
+#else
+		if (dslite_entry != NULL) {
+			remove_proc_entry("dslite", rtl865x_proc_dir);
+		}
+#endif
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+		remove_proc_entry(RTL865X_PROC_DIR_NAME, &proc_root);
+#else
+		remove_proc_entry(RTL865X_PROC_DIR_NAME, NULL);
+		rtl865x_proc_dir = NULL;
+#endif
+
+	}
+
+	return SUCCESS;
+}
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl865x_proc_debug.h b/drivers/soc/realtek/rtd129x/hw_nat/rtl865x_proc_debug.h
new file mode 100644
index 00000000..68ee6a1
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl865x_proc_debug.h
@@ -0,0 +1,25 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : just for driver debug
+* Abstract :
+* Author : Hyking Liu (Hyking_liu@realsil.com.tw)
+* -------------------------------------------------------
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#ifndef RTL865X_PROC_DEBUG_H
+#define RTL865X_PROC_DEBUG_H
+#include <linux/proc_fs.h>
+#include <linux/seq_file.h>
+
+#define RTL865X_PROC_DIR_NAME "rtl865x"
+
+int32 rtl865x_proc_debug_init(void);
+int32 rtl865x_proc_debug_cleanup(void);
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl865xc_swNic.c b/drivers/soc/realtek/rtd129x/hw_nat/rtl865xc_swNic.c
new file mode 100644
index 00000000..b8b8ec3
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl865xc_swNic.c
@@ -0,0 +1,2761 @@
+/*
+* ----------------------------------------------------------------
+* $Header: /home/cvsroot/linux-2.6.19/linux-2.6.x/drivers/net/re865x/rtl865xc_swNic.c,v 1.11 2008/04/11 10:49:14 bo_zhao Exp $
+*
+* Abstract: Switch core polling mode NIC driver source code.
+*
+* $Author: bo_zhao $
+*
+*  Copyright (c) 2011 Realtek Semiconductor Corp.
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License version 2 as
+*  published by the Free Software Foundation.
+* ---------------------------------------------------------------
+*/
+#if defined(CONFIG_RTD_1295_HWNAT)
+#include <linux/dma-mapping.h>
+#include <linux/platform_device.h>
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#include <linux/skbuff.h>
+#include <linux/netdevice.h>
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+#include "common/rtl_errno.h"
+#include "AsicDriver/asicRegs.h"
+#include "rtl865xc_swNic.h"
+#include <net/rtl/rtl865x_netif.h>
+#include "common/mbuf.h"
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#include "AsicDriver/rtl865xC_hs.h"
+#ifdef	CONFIG_RTL865X_ROMEPERF
+#include "romeperf.h"
+#endif
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT) || defined(CONFIG_RTK_VLAN_WAN_TAG_SUPPORT)
+#include <linux/if_ether.h>
+#endif
+
+#ifdef CONFIG_RTL_HW_TX_CSUM
+#include <linux/etherdevice.h>
+#include <net/rtl/rtk_vlan.h>
+#include <linux/ip.h>
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+/* #define RTL_DEBUG       1 */
+#ifdef RTL_DEBUG
+#define DBG(fmt, ...) printk(KERN_ERR "%s:%d: " fmt "\n", \
+						__func__, __LINE__, ## __VA_ARGS__)
+#else
+#define DBG(fmt, ...)
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+extern void (*_dma_cache_wback_inv)(unsigned long start, unsigned long size);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+/* RX Ring */
+#if defined(CONFIG_RTD_1295_HWNAT)
+static uintptr_t *rxPkthdrRing[RTL865X_SWNIC_RXRING_HW_PKTDESC];	/* Point to the starting address of RX pkt Hdr Ring */
+static dma_addr_t rxPkthdrRingPhyAddr[RTL865X_SWNIC_RXRING_HW_PKTDESC];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+static uint32 *rxPkthdrRing[RTL865X_SWNIC_RXRING_HW_PKTDESC];	/* Point to the starting address of RX pkt Hdr Ring */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+__DRAM_FWD static uint32 rxPkthdrRingCnt[RTL865X_SWNIC_RXRING_HW_PKTDESC];	/* Total pkt count for each Rx descriptor Ring */
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+__DRAM_FWD static uint32 rxPkthdrRefillThreshold[RTL865X_SWNIC_RXRING_HW_PKTDESC];	/* Ether refill threshold for each Rx descriptor Ring */
+#endif
+
+/* TX Ring */
+#if defined(CONFIG_RTD_1295_HWNAT)
+static uintptr_t *txPkthdrRing[RTL865X_SWNIC_TXRING_HW_PKTDESC];	/* Point to the starting address of TX pkt Hdr Ring */
+static dma_addr_t txPkthdrRingPhyAddr[RTL865X_SWNIC_TXRING_HW_PKTDESC];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+static uint32 *txPkthdrRing[RTL865X_SWNIC_TXRING_HW_PKTDESC];	/* Point to the starting address of TX pkt Hdr Ring */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8881A) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define CONFIG_RTL_ENHANCE_RELIABILITY		1
+#endif
+
+#ifdef CONFIG_RTL_ENHANCE_RELIABILITY
+__DRAM_FWD static uint32 txPkthdrRing_base[RTL865X_SWNIC_TXRING_HW_PKTDESC];
+__DRAM_FWD static uint32 rxPkthdrRing_base[RTL865X_SWNIC_RXRING_HW_PKTDESC];
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+__DRAM_FWD uint32 rxMbufRing_base;
+#endif
+#endif
+
+#if defined(CONFIG_RTL8196C_REVISION_B)
+__DRAM_FWD static uint32 rtl_chip_version;
+static uint32 *txPkthdrRing_backup[RTL865X_SWNIC_TXRING_HW_PKTDESC];	/* Point to the starting address of TX pkt Hdr Ring */
+#endif
+
+__DRAM_FWD static uint32 txPkthdrRingCnt[RTL865X_SWNIC_TXRING_HW_PKTDESC];	/* Total pkt count for each Tx descriptor Ring */
+
+#define txPktHdrRingFull(idx)   (((txPkthdrRingFreeIndex[idx] + 1) & (txPkthdrRingMaxIndex[idx])) == (txPkthdrRingDoneIndex[idx]))
+
+/* Mbuf */
+#if defined(CONFIG_RTD_1295_HWNAT)
+uintptr_t *rxMbufRing = NULL;	/* Point to the starting address of MBUF Ring */
+dma_addr_t rxMbufRingPhyAddr;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+uint32 *rxMbufRing = NULL;	/* Point to the starting address of MBUF Ring */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+__DRAM_FWD uint32 rxMbufRingCnt;	/* Total MBUF count */
+
+__DRAM_FWD uint32 size_of_cluster;
+
+/* descriptor ring tracing pointers */
+__DRAM_FWD static int32 currRxPkthdrDescIndex[RTL865X_SWNIC_RXRING_HW_PKTDESC];	/* Rx pkthdr descriptor to be handled by CPU */
+__DRAM_FWD static int32 currRxMbufDescIndex;	/* Rx mbuf descriptor to be handled by CPU */
+
+__DRAM_FWD static int32 currTxPkthdrDescIndex[RTL865X_SWNIC_TXRING_HW_PKTDESC];	/* Tx pkthdr descriptor to be handled by CPU */
+__DRAM_FWD static int32 txPktDoneDescIndex[RTL865X_SWNIC_TXRING_HW_PKTDESC];
+
+/* debug counters */
+/* __DRAM_FWD static int32   rxPktCounter; */
+/* __DRAM_FWD static int32   txPktCounter; */
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+__DRAM_FWD static int32 rxDescReadyForHwIndex[RTL865X_SWNIC_RXRING_HW_PKTDESC];
+__DRAM_FWD static int32 rxDescCrossBoundFlag[RTL865X_SWNIC_RXRING_HW_PKTDESC];
+#endif
+
+__DRAM_FWD static uint8 extPortMaskToPortNum[_RTL865XB_EXTPORTMASKS + 1] = {
+	5, 6, 7, 5, 8, 5, 5, 5
+};
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+extern int extPortEnabled;
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+int set_portmask_tag;
+int32 swNic_setVlanPortTag(int portmask)
+{
+	set_portmask_tag = portmask & 0x3f;
+	return 0;
+}
+#endif
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+__DRAM_FWD unsigned int rx_noBuffer_cnt;
+__DRAM_FWD unsigned int tx_ringFull_cnt;
+__DRAM_FWD unsigned int tx_drop_cnt;
+#endif
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+int32 auto_set_tag_portmask;
+int32 swNic_setVlanPortTag(int portmask)
+{
+	auto_set_tag_portmask = portmask & 0x3f;
+	return 0;
+}
+
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+extern uint32 rtk_getTagPortmaskByVid(uint16 vid, void *data_p);	/* rtl_nic.c */
+extern void rtk_get_real_nicTxVid(struct sk_buff *skb,
+	unsigned short *nictx_vid);
+#endif
+#endif
+#if defined(CONFIG_RTL_VLAN_8021Q) || defined(CONFIG_SWCONFIG)
+#include <linux/if_ether.h>
+extern uint32 rtk_get_vlan_tagmask(uint16 vid);
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+extern struct platform_device *rtl819x_pdev;
+extern void sync_rx_data_for_device(dma_addr_t addr, int len);
+extern void sync_rx_data_for_cpu(dma_addr_t addr, int len);
+extern void sync_tx_data_for_device(dma_addr_t addr, int len);
+extern void rtl_dump_data(void *p, int len);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#ifdef CONFIG_RTL_ETH_TX_SG
+#define SG_MBUF_NUM 	(NUM_TX_PKTHDR_DESC+200)
+uint32 sg_mbuf[SG_MBUF_NUM];
+int sg_mbuf_idx = 0;
+#endif
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+extern int gHwNatEnabled;
+#endif
+
+/*************************************************************************
+*   FUNCTION
+*       swNic_intHandler
+*
+*   DESCRIPTION
+*       This function is the handler of NIC interrupts
+*
+*   INPUTS
+*       intPending      Pending interrupt sources.
+*
+*   OUTPUTS
+*       None
+*************************************************************************/
+void swNic_intHandler(uint32 intPending)
+{
+	return;
+}
+
+__MIPS16 __IRAM_FWD
+	inline int32 rtl8651_rxPktPreprocess(void *pkt, unsigned int *vid)
+{
+	struct rtl_pktHdr *m_pkthdr = (struct rtl_pktHdr *)pkt;
+	uint32 srcPortNum;
+
+	srcPortNum = m_pkthdr->ph_portlist;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	srcPortNum &= 0x7;
+#endif
+	*vid = m_pkthdr->ph_vlanId;
+
+	if (srcPortNum < RTL8651_CPU_PORT) {
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+		/* rx from physical port */
+		if (extPortEnabled
+			&& ((m_pkthdr->ph_extPortList & PKTHDR_EXTPORTMASK_CPU)
+				== 0)) {
+			/* No CPU bit, finished nat translation, only dest ext mbr port... */
+			/*
+			 * if dest ph_extPortList 0x1 => to dst ext port 1 => to dst port 1+5=6
+			 * if dest ph_extPortList 0x2 => to dst ext port 2 => to dst port 2+5=7
+			 * if dest ph_extPortList 0x4 => to dst ext port 3 => to dst port 3+5=8
+			 */
+			/* No CPU bit, only dest ext mbr port... */
+			if (m_pkthdr->ph_extPortList &&
+				(5 != extPortMaskToPortNum[m_pkthdr->ph_extPortList])) {
+#if defined(CONFIG_RTL_HARDWARE_NAT) && (defined(CONFIG_RTL8192SE) || defined(CONFIG_RTL8192CD))
+
+				/* printk("ph_extPortList:%d,srcPortNum:%d,ph_isOriginal:%d,ph_l2Trans:%d,hwfwd:%d,[%s]:[%d].\n", */
+				/* m_pkthdr->ph_extPortList,srcPortNum,m_pkthdr->ph_isOriginal,m_pkthdr->ph_l2Trans,m_pkthdr->ph_hwFwd,__FUNCTION__,__LINE__); */
+				if (m_pkthdr->ph_l2Trans != 0) {
+					/*wan-->ext port, finished napt translation */
+					*vid = PKTHDR_EXTPORT_MAGIC;
+				}
+#endif
+			} else {
+				/*no dst ext port */
+				/*drop it */
+				return FAILED;
+			}
+		}
+		/*to-do:mark it */
+		else {
+			/* has CPU bit, pkt is original pkt from port 0~5 */
+			/*original packet, let prototocol stack to handle it */
+
+		}
+
+#endif
+	} else {
+		/*rx from extension port */
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+		/*to-do: */
+		if (extPortEnabled) {
+			if ((m_pkthdr->ph_extPortList & PKTHDR_EXTPORTMASK_CPU)
+				== 0) {
+
+				/* No CPU bit, finished nat translation, only dest ext mbr port... */
+				/*
+				 * if dest ph_extPortList 0x1 => to dst ext port 1 => to dst port 1+5=6
+				 * if dest ph_extPortList 0x2 => to dst ext port 2 => to dst port 2+5=7
+				 * if dest ph_extPortList 0x4 => to dst ext port 3 => to dst port 3+5=8
+				 */
+				if (m_pkthdr->ph_extPortList &&
+					(5 != extPortMaskToPortNum[m_pkthdr->ph_extPortList])) {
+#if defined(CONFIG_RTL_HARDWARE_NAT) && (defined(CONFIG_RTL8192SE) || defined(CONFIG_RTL8192CD))
+					/*WISP mode ext port-->ext port, finished napt translation */
+					/* *vid = PKTHDR_EXTPORT_MAGIC2; */
+					/*drop it, may fix me in future */
+					return FAILED;
+#endif
+				} else {
+					/*no dst ext port */
+					/*drop it */
+					return FAILED;
+				}
+
+			} else {
+				/* has CPU bit, pkt is original pkt from port 6~8 */
+				/*case 1: not finished napt translation, need roll back interface to wlan ext interface */
+
+#if defined(CONFIG_RTL_HARDWARE_NAT) && (defined(CONFIG_RTL8192SE) || defined(CONFIG_RTL8192CD))
+				*vid = PKTHDR_EXTPORT_MAGIC4;
+				srcPortNum =
+					extPortMaskToPortNum[m_pkthdr->ph_extPortList];
+				m_pkthdr->ph_portlist = srcPortNum;
+				/*drop it, may fix me in future */
+				return SUCCESS;
+#endif
+			}
+		} else {
+			return FAILED;
+		}
+
+#else
+		return FAILED;
+#endif
+
+	}
+
+	return SUCCESS;
+}
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+inline int return_to_rxing_check(int ringIdx)
+{
+	int ret;
+
+	/* unsigned long flags=0; */
+	/* local_irq_save(flags); */
+	ret = ((rxDescReadyForHwIndex[ringIdx] != currRxPkthdrDescIndex[ringIdx])
+		&& (rxPkthdrRingCnt[ringIdx] != 0)) ? 1 : 0;
+	/* local_irq_restore(flags); */
+	return ret;
+}
+
+static inline int buffer_reuse(int ringIdx)
+{
+	int index1, index2, gap;
+
+#if !defined(CONFIG_SMP)
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_RECV(flags);
+#endif
+	index1 = rxDescReadyForHwIndex[ringIdx];
+	index2 = currRxPkthdrDescIndex[ringIdx] + 1;
+	gap = (index2 > index1) ? (index2 - index1) : (index2 + rxPkthdrRingCnt[ringIdx] - index1);
+
+	if ((rxPkthdrRingCnt[ringIdx] - gap) < (rxPkthdrRefillThreshold[ringIdx])) {
+#if !defined(CONFIG_SMP)
+		SMP_UNLOCK_ETH_RECV(flags);
+#endif
+		return 1;
+	} else {
+#if !defined(CONFIG_SMP)
+		SMP_UNLOCK_ETH_RECV(flags);
+#endif
+		return 0;
+	}
+}
+
+static inline void set_RxPkthdrRing_OwnBit(uint32 rxRingIdx)
+{
+	rxPkthdrRing[rxRingIdx][rxDescReadyForHwIndex[rxRingIdx]] |=
+		DESC_SWCORE_OWNED;
+
+	if (++rxDescReadyForHwIndex[rxRingIdx] == rxPkthdrRingCnt[rxRingIdx]) {
+		rxDescReadyForHwIndex[rxRingIdx] = 0;
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+		rxDescCrossBoundFlag[rxRingIdx]--;
+#endif
+	}
+}
+
+__MIPS16 __IRAM_FWD static void release_pkthdr(struct sk_buff *skb, int idx)
+{
+	struct rtl_pktHdr *pReadyForHw;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	dma_addr_t mapping;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	uint32 mbufIndex;
+
+	/* unsigned long flags=0; */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	mapping =
+		dma_map_single(&rtl819x_pdev->dev, skb->head, skb->truesize,
+		DMA_FROM_DEVICE);
+	if (unlikely(dma_mapping_error(&rtl819x_pdev->dev, mapping))) {
+		if (net_ratelimit())
+			DBG("Failed to map RX DMA memory!");
+		/* netif_err(NETDRV_PRIV(skb->dev), drv, skb->dev, "Failed to map RX DMA memory!\n"); */
+		return;
+	}
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	_dma_cache_inv((unsigned long)skb->data, 1536);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* local_irq_save(flags); */
+	pReadyForHw =
+		(struct rtl_pktHdr *)(rxPkthdrRing[idx][rxDescReadyForHwIndex[idx]] &
+		~(DESC_OWNED_BIT | DESC_WRAP));
+	mbufIndex =
+		((uint32)(pReadyForHw->ph_mbuf) - (rxMbufRing[0] & ~(DESC_OWNED_BIT | DESC_WRAP))) /
+		(sizeof(struct rtl_mBuf));
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	pReadyForHw->ph_mbuf->m_extbuf = pReadyForHw->ph_mbuf->m_data =
+		(uint8 *)(mapping + skb_headroom(skb));
+	pReadyForHw->dma_addr = mapping;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	pReadyForHw->ph_mbuf->m_data = skb->data;
+	pReadyForHw->ph_mbuf->m_extbuf = skb->data;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	pReadyForHw->ph_mbuf->skb = skb;
+
+#ifdef _PKTHDR_CACHEABLE
+	/* _dma_cache_wback_inv((unsigned long)pReadyForHw, sizeof(struct rtl_pktHdr)); */
+	_dma_cache_wback_inv((unsigned long)(pReadyForHw->ph_mbuf),
+		sizeof(struct rtl_mBuf));
+#endif
+
+	rxMbufRing[mbufIndex] |= DESC_SWCORE_OWNED;
+	set_RxPkthdrRing_OwnBit(idx);
+	/* local_irq_restore(flags); */
+}
+
+__IRAM_FWD int check_rx_pkthdr_ring(int idx, int *return_idx)
+{
+	int i;
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_RECV(flags);
+	for (i = idx; i >= 0; i--) {
+		if (return_to_rxing_check(i)) {
+			*return_idx = i;
+			SMP_UNLOCK_ETH_RECV(flags);
+			return SUCCESS;
+		}
+	}
+
+	*return_idx = -1;
+	SMP_UNLOCK_ETH_RECV(flags);
+	return FAILED;
+}
+
+__IRAM_FWD int check_and_return_to_rx_pkthdr_ring(void *skb, int idx)
+{
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_RECV(flags);
+	if (return_to_rxing_check(idx)) {
+		release_pkthdr(skb, idx);
+		SMP_UNLOCK_ETH_RECV(flags);
+		return SUCCESS;
+	} else {
+		SMP_UNLOCK_ETH_RECV(flags);
+		return FAILED;
+	}
+}
+
+/*
+	return value: 1 ==> success, returned to rx pkt hdr desc
+	return value: 0 ==> failed, no return ==> release to priv skb buf pool
+ */
+extern struct sk_buff *dev_alloc_8190_skb(unsigned char *data, int size);
+
+__IRAM_FWD int return_to_rx_pkthdr_ring(unsigned char *head)
+{
+	struct sk_buff *skb;
+	int ret, i;
+	unsigned long flags = 0;
+
+	ret = FAILED;
+	SMP_LOCK_ETH_RECV(flags);
+	for (i = RTL865X_SWNIC_RXRING_MAX_PKTDESC - 1; i >= 0; i--) {
+		if (return_to_rxing_check(i)) {
+			skb = dev_alloc_8190_skb(head, CROSS_LAN_MBUF_LEN);
+			if (skb == NULL) {
+				goto _ret1;
+			}
+
+			skb_reserve(skb, RX_OFFSET);
+			release_pkthdr(skb, i);
+			ret = SUCCESS;
+			REG32(CPUIISR) =
+				(MBUF_DESC_RUNOUT_IP_ALL |
+				PKTHDR_DESC_RUNOUT_IP_ALL);
+			break;
+		}
+	}
+
+_ret1:
+	SMP_UNLOCK_ETH_RECV(flags);
+	return ret;
+}
+#endif /* DELAY_REFILL_ETH_RX_BUF */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+static void increase_rx_idx_release_pkthdr(struct sk_buff *skb, dma_addr_t addr,
+	int idx)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+__IRAM_FWD
+	static void increase_rx_idx_release_pkthdr(struct sk_buff *skb, int idx)
+#endif				/* defined(CONFIG_RTD_1295_HWNAT) */
+{
+	struct rtl_pktHdr *pReadyForHw;
+	uint32 mbufIndex;
+
+#if !defined(CONFIG_SMP)
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_RECV(flags);
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	sync_rx_data_for_device(addr, skb->truesize);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	_dma_cache_inv((unsigned long)skb->data, 1536);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+	pReadyForHw =
+		(struct rtl_pktHdr *)(rxPkthdrRing[idx][rxDescReadyForHwIndex[idx]] &
+		~(DESC_OWNED_BIT | DESC_WRAP));
+#else
+
+#if defined(CONFIG_RTL_ENHANCE_RELIABILITY) && (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F))
+	pReadyForHw =
+		(struct rtl_pktHdr *)(rxPkthdrRing_base[idx] + (sizeof(struct rtl_pktHdr) * currRxPkthdrDescIndex[idx]));
+#else
+	pReadyForHw =
+		(struct rtl_pktHdr *)(rxPkthdrRing[idx][currRxPkthdrDescIndex[idx]] &
+		~(DESC_OWNED_BIT | DESC_WRAP));
+#endif
+
+#endif
+
+#if defined(CONFIG_RTL_ENHANCE_RELIABILITY) && (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F))
+#if defined(CONFIG_RTD_1295_HWNAT)
+	mbufIndex =
+		((uintptr_t) (pReadyForHw->ph_mbuf) - rxMbufRing_base) / (sizeof(struct rtl_mBuf));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	mbufIndex =
+		((uint32)(pReadyForHw->ph_mbuf) - rxMbufRing_base) / (sizeof(struct rtl_mBuf));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#else
+	mbufIndex =
+		((uint32)(pReadyForHw->ph_mbuf) - (rxMbufRing[0] & ~(DESC_OWNED_BIT | DESC_WRAP))) /
+		(sizeof(struct rtl_mBuf));
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	pReadyForHw->ph_mbuf->m_extbuf = pReadyForHw->ph_mbuf->m_data =
+		(uint8 *)(addr + skb_headroom(skb));
+	pReadyForHw->dma_addr = addr;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	pReadyForHw->ph_mbuf->m_data = skb->data;
+	pReadyForHw->ph_mbuf->m_extbuf = skb->data;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	pReadyForHw->ph_mbuf->skb = skb;
+
+#ifdef _PKTHDR_CACHEABLE
+	/* _dma_cache_wback_inv((unsigned long)pReadyForHw, sizeof(struct rtl_pktHdr)); */
+	_dma_cache_wback_inv((unsigned long)(pReadyForHw->ph_mbuf),
+		sizeof(struct rtl_mBuf));
+#endif
+
+	rxMbufRing[mbufIndex] |= DESC_SWCORE_OWNED;
+
+#if !defined(DELAY_REFILL_ETH_RX_BUF) && !defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+	/* set own bit to siwtch in the final step */
+	rxPkthdrRing[idx][currRxPkthdrDescIndex[idx]] |= DESC_SWCORE_OWNED;
+#endif
+	if (++currRxPkthdrDescIndex[idx] == rxPkthdrRingCnt[idx]) {
+		currRxPkthdrDescIndex[idx] = 0;
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+		rxDescCrossBoundFlag[idx]++;
+#endif
+	}
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+	set_RxPkthdrRing_OwnBit(idx);
+#endif
+#if !defined(CONFIG_SMP)
+	SMP_UNLOCK_ETH_RECV(flags);
+#endif
+
+}
+
+__IRAM_FWD
+	static int __swNic_geRxRingIdx(uint32 rxRingIdx,
+	uint32 *currRxPktDescIdx)
+{
+#if !defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	if (rxPkthdrRingCnt[rxRingIdx] == 0) {
+		return FAILED;
+	}
+#if !defined(CONFIG_SMP)
+	SMP_LOCK_ETH_RECV(flags);
+#endif
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+	if ((rxDescCrossBoundFlag[rxRingIdx] == 0
+		&& (currRxPkthdrDescIndex[rxRingIdx] >= rxDescReadyForHwIndex[rxRingIdx]))
+		|| (rxDescCrossBoundFlag[rxRingIdx] == 1
+		&& (currRxPkthdrDescIndex[rxRingIdx] < rxDescReadyForHwIndex[rxRingIdx])))
+#endif
+	{
+		if ((rxPkthdrRing[rxRingIdx][currRxPkthdrDescIndex[rxRingIdx]] &
+				DESC_OWNED_BIT) == DESC_RISC_OWNED) {
+			/* SMP_UNLOCK_ETH_RECV(flags); */
+			*currRxPktDescIdx = currRxPkthdrDescIndex[rxRingIdx];
+#if !defined(CONFIG_SMP)
+			SMP_UNLOCK_ETH_RECV(flags);
+#endif
+			return SUCCESS;
+		}
+	}
+#if !defined(CONFIG_SMP)
+	SMP_UNLOCK_ETH_RECV(flags);
+#endif
+	return FAILED;
+}
+
+#if defined(RTL_MULTIPLE_RX_TX_RING)
+/*	It's the caller's responsibility to make sure "rxRingIdx" and
+*	"currRxPktDescIdx" NOT NULL, since the callee never check
+*	sanity of the parameters, in order to speed up.
+*/
+/*
+	Should protected by Caller
+*/
+__MIPS16 __IRAM_FWD
+	static inline int32 swNic_getRxringIdx(uint32 *rxRingIdx,
+	uint32 *currRxPktDescIdx, uint32 policy)
+{
+	int32 i;
+	int32 priority;
+
+	priority = policy;
+
+	for (i = RTL865X_SWNIC_RXRING_MAX_PKTDESC - 1; i >= priority; i--) {
+		if (__swNic_geRxRingIdx(i, currRxPktDescIdx) == SUCCESS) {
+			*rxRingIdx = i;
+			return SUCCESS;
+		}
+	}
+	return FAILED;
+}
+#endif
+
+__IRAM_FWD int swNic_increaseRxIdx(int rxRingIdx)
+{
+#if !defined(CONFIG_SMP)
+	unsigned long flags = 0;
+
+	/* int32         nextIdx; */
+
+	SMP_LOCK_ETH_RECV(flags);
+#endif
+	if (++currRxPkthdrDescIndex[rxRingIdx] == rxPkthdrRingCnt[rxRingIdx]) {
+		currRxPkthdrDescIndex[rxRingIdx] = 0;
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+		rxDescCrossBoundFlag[rxRingIdx]++;
+#endif
+	}
+#if !defined(CONFIG_SMP)
+	SMP_UNLOCK_ETH_RECV(flags);
+#endif
+
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB_DEBUG)
+int mbuf_pending_times = 0;
+int get_mbuf_pending_times(void)
+{
+	return mbuf_pending_times;
+}
+
+int get_nic_txRing_buf(void)
+{
+	int txCnt = 0;
+	int i, j;
+	struct rtl_pktHdr *pPkthdr;
+
+	for (i = RTL865X_SWNIC_TXRING_HW_PKTDESC - 1; i >= 0; i--) {
+		if (txPkthdrRingCnt[i] == 0)
+			continue;
+
+		for (j = 0; j < txPkthdrRingCnt[i]; j++) {
+
+			pPkthdr =
+				(struct rtl_pktHdr *)((int32)txPkthdrRing[i][j]
+				& ~(DESC_OWNED_BIT | DESC_WRAP));
+
+			if (pPkthdr->ph_mbuf->skb) {
+				if (is_rtl865x_eth_priv_buf(((struct sk_buff *)
+							pPkthdr->ph_mbuf->skb)->head))
+					txCnt++;
+			}
+		}
+	}
+
+	return txCnt;
+}
+
+int get_nic_rxRing_buf(void)
+{
+	int rxCnt = 0;
+	int i, j;
+	struct rtl_pktHdr *pPkthdr;
+
+	for (i = RTL865X_SWNIC_RXRING_HW_PKTDESC - 1; i >= 0; i--) {
+		if (rxPkthdrRingCnt[i] == 0)
+			continue;
+
+		for (j = 0; j < rxPkthdrRingCnt[i]; j++) {
+			{
+				pPkthdr =
+					(struct rtl_pktHdr *)(rxPkthdrRing[i][j]
+					& ~(DESC_OWNED_BIT | DESC_WRAP));
+				if (pPkthdr->ph_mbuf->skb) {
+					if (is_rtl865x_eth_priv_buf(((struct sk_buff *)pPkthdr->ph_mbuf->skb)->head))
+						rxCnt++;
+				}
+			}
+		}
+	}
+
+	return rxCnt;
+}
+#endif
+
+int32 swNic_flushRxRingByPriority(int priority)
+{
+	int32 i;
+	struct rtl_pktHdr *pPkthdr;
+	void *skb;
+	unsigned long flags = 0;
+
+#if defined(CONFIG_RTL865X_WTDOG)
+	REG32(WDTCNR) |= WDTCLR;	/* reset watchdog timer */
+#endif
+	SMP_LOCK_ETH_RECV(flags);
+	for (i = priority - 1; i >= 0; i--) {
+		if (rxPkthdrRingCnt[i] == 0)
+			continue;
+
+		while ((rxPkthdrRing[i][currRxPkthdrDescIndex[i]] &
+				DESC_OWNED_BIT) == DESC_RISC_OWNED) {
+			pPkthdr =
+				(struct rtl_pktHdr *)(rxPkthdrRing[i][currRxPkthdrDescIndex[i]] &
+				~(DESC_OWNED_BIT | DESC_WRAP));
+			skb = pPkthdr->ph_mbuf->skb;
+#if defined(CONFIG_RTD_1295_HWNAT)
+			increase_rx_idx_release_pkthdr((struct sk_buff *)skb,
+				pPkthdr->dma_addr, i);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			increase_rx_idx_release_pkthdr((void *)skb, i);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		}
+	}
+	SMP_UNLOCK_ETH_RECV(flags);
+	REG32(CPUIISR) = (MBUF_DESC_RUNOUT_IP_ALL | PKTHDR_DESC_RUNOUT_IP_ALL);
+	return SUCCESS;
+}
+
+/*************************************************************************
+*   FUNCTION
+*       swNic_receive
+*
+*   DESCRIPTION
+*       This function reads one packet from rx descriptors, and return the
+*       previous read one to the switch core. This mechanism is based on
+*       the assumption that packets are read only when the handling
+*       previous read one is done.
+*
+*   INPUTS
+*       None
+*
+*   OUTPUTS
+*       None
+*************************************************************************/
+#define	RTL_NIC_RX_RETRY_MAX		(256)
+
+/* #if   defined(DELAY_REFILL_ETH_RX_BUF) */
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define	RTL_ETH_NIC_DROP_RX_PKT_RESTART		\
+	do {\
+		increase_rx_idx_release_pkthdr(pPkthdr->ph_mbuf->skb, pPkthdr->dma_addr, rxRingIdx); \
+		REG32(CPUIISR) = (MBUF_DESC_RUNOUT_IP_ALL|PKTHDR_DESC_RUNOUT_IP_ALL); \
+	} while (0)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#define	RTL_ETH_NIC_DROP_RX_PKT_RESTART		\
+	do {\
+		increase_rx_idx_release_pkthdr(pPkthdr->ph_mbuf->skb, rxRingIdx); \
+		REG32(CPUIISR) = (MBUF_DESC_RUNOUT_IP_ALL|PKTHDR_DESC_RUNOUT_IP_ALL); \
+	} while (0)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+/* #else */
+/* #define       RTL_ETH_NIC_DROP_RX_PKT_RESTART         #error  "check here" */
+/* #endif */
+
+__MIPS16 __IRAM_FWD int32 swNic_receive(rtl_nicRx_info *info, int retryCount)
+{
+	struct rtl_pktHdr *pPkthdr;
+	unsigned char *buf;
+	void *skb;
+	uint32 rxRingIdx;
+	uint32 currRxPktDescIdx;
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+	uint32 vid;
+#endif
+#ifdef CONFIG_RTL_JUMBO_FRAME
+	struct sk_buff *pskb = NULL;
+	struct rtl_mBuf *m_next = NULL;
+	uint32 mbufIndex_tmp = 0;
+	unsigned char *buf_tmp = NULL;
+	unsigned int offset;
+	struct rtl_mBuf *mbuf = NULL;
+	void *skb_tmp = NULL;
+#endif
+#if defined(CONFIG_SMP)
+	/* unsigned long flags = 0; */
+	/* SMP_LOCK_ETH_RECV(flags); */
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+	struct sk_buff *skbp;
+	dma_addr_t mapping;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+get_next:
+	/* Check OWN bit of descriptors */
+#if defined(RTL_MULTIPLE_RX_TX_RING)
+	if (swNic_getRxringIdx(&rxRingIdx, &currRxPktDescIdx,
+			info->priority) == SUCCESS)
+#else
+	rxRingIdx = 0;
+	if (__swNic_geRxRingIdx(rxRingIdx, &currRxPktDescIdx) == SUCCESS)
+#endif
+	{
+		/* Fetch pkthdr */
+#ifdef CONFIG_RTL_ENHANCE_RELIABILITY
+		pPkthdr =
+			(struct rtl_pktHdr *)(rxPkthdrRing_base[rxRingIdx] +
+			(sizeof(struct rtl_pktHdr) * currRxPktDescIdx));
+#else
+		pPkthdr =
+			(struct rtl_pktHdr *)(rxPkthdrRing[rxRingIdx][currRxPktDescIdx] &
+			~(DESC_OWNED_BIT | DESC_WRAP));
+#endif
+		/* Increment counter */
+		/* rxPktCounter++; */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		sync_rx_data_for_cpu((dma_addr_t) pPkthdr->ph_mbuf->m_data,
+			pPkthdr->ph_len);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(_PKTHDR_CACHEABLE)
+		_dma_cache_inv((unsigned long)pPkthdr,
+			sizeof(struct rtl_pktHdr));
+		_dma_cache_inv((unsigned long)(pPkthdr->ph_mbuf),
+			sizeof(struct rtl_mBuf));
+#endif
+		/* _dma_cache_inv((unsigned long)(((struct sk_buff *)pPkthdr->ph_mbuf->skb)->data), pPkthdr->ph_len-4); */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		/*      checksum error drop it  */
+		if ((pPkthdr->ph_flags & (CSUM_TCPUDP_OK | CSUM_IP_OK)) !=
+			(CSUM_TCPUDP_OK | CSUM_IP_OK)) {
+#ifdef CONFIG_RTL_IPV6READYLOGO
+			if (!(((pPkthdr->ph_flags & (CSUM_TCPUDP_OK)) != CSUM_TCPUDP_OK)
+				&& ((pPkthdr->ph_portlist & 0x38) == 0x10)
+				&& ((pPkthdr->ph_reason == 0x0060)
+				|| (pPkthdr->ph_reason == 0x0008))))
+#endif
+			{
+				RTL_ETH_NIC_DROP_RX_PKT_RESTART;
+				goto get_next;
+			}
+		}
+#ifdef CONFIG_RTL_JUMBO_FRAME
+		mbuf = pPkthdr->ph_mbuf;
+		if (mbuf && mbuf->m_next) {	/*we will process jumbo frame here */
+			/* allocate a big space to hold jumbo frame */
+			m_next = mbuf->m_next;
+
+			buf_tmp = alloc_rx_buf(&skb_tmp, pPkthdr->ph_len - 4);
+			offset = 0;
+			/*cp data from frag mbuf to continious big space */
+			while (buf_tmp != NULL && mbuf != NULL) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+				sync_rx_data_for_cpu(mbuf->m_pkthdr->dma_addr,
+					mbuf->m_len);
+				pskb = (struct sk_buff *)mbuf->skb;
+				memcpy(buf_tmp + offset, pskb->data,
+					mbuf->m_len);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+				memcpy(buf_tmp + offset, mbuf->m_data,
+					mbuf->m_len);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+				offset += mbuf->m_len;
+				mbuf = mbuf->m_next;
+			}
+			/*release frag mbuf and pkt header */
+#if defined(CONFIG_RTD_1295_HWNAT)
+			increase_rx_idx_release_pkthdr(pPkthdr->ph_mbuf->skb,
+				pPkthdr->dma_addr, rxRingIdx);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			increase_rx_idx_release_pkthdr(pPkthdr->ph_mbuf->skb,
+				rxRingIdx);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+			while (m_next) {
+				pskb = (struct sk_buff *)m_next->skb;
+#if defined(CONFIG_RTD_1295_HWNAT)
+				mbufIndex_tmp =
+					((uintptr_t)(m_next) -
+					(rxMbufRing[0] & ~(DESC_OWNED_BIT | DESC_WRAP))) /
+					(sizeof(struct rtl_mBuf));
+				/*m_data must be the same as skb->data */
+				m_next->m_extbuf = m_next->m_data =
+					(uint8 *)(m_next->m_pkthdr->dma_addr +
+					skb_headroom(pskb));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+				mbufIndex_tmp =
+					((uint32)(m_next) -
+					(rxMbufRing[0] & ~(DESC_OWNED_BIT | DESC_WRAP))) /
+					(sizeof(struct rtl_mBuf));
+				/*m_data must be the same as skb->data */
+				m_next->m_data = pskb->data;
+				m_next->m_extbuf = pskb->data;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+				rxMbufRing[mbufIndex_tmp] |= DESC_SWCORE_OWNED;
+				/* panic_printk("mbufIndex_tmp:%d\n",mbufIndex_tmp); */
+				m_next = m_next->m_next;
+			}
+
+			REG32(CPUIISR) =
+				(MBUF_DESC_RUNOUT_IP_ALL |
+				PKTHDR_DESC_RUNOUT_IP_ALL);
+			if (buf_tmp == NULL)
+				goto get_next;
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+			if (rtl8651_rxPktPreprocess(pPkthdr, &vid) != 0) {
+				RTL_ETH_NIC_DROP_RX_PKT_RESTART;
+				goto get_next;
+			}
+			info->vid = vid;
+#else
+			/*
+			 * vid is assigned in rtl8651_rxPktPreprocess()
+			 * do not update it when CONFIG_RTL_HARDWARE_NAT is defined
+			 */
+			info->vid = pPkthdr->ph_vlanId;
+#endif
+			info->pid = pPkthdr->ph_portlist;
+			info->input = skb_tmp;
+			info->len = pPkthdr->ph_len - 4;
+#if defined(RTL_MULTIPLE_RX_TX_RING)
+			info->priority = rxRingIdx;
+#endif
+#if defined(CONFIG_SMP)
+			/* SMP_UNLOCK_ETH_RECV(flags); */
+#endif
+			return RTL_NICRX_OK;
+		}
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+		if (rtl8651_rxPktPreprocess(pPkthdr, &vid) != 0) {
+			RTL_ETH_NIC_DROP_RX_PKT_RESTART;
+			goto get_next;
+		} else {
+#if defined(SKIP_ALLOC_RX_BUFF)
+			buf = NULL;
+#else
+			buf = alloc_rx_buf(&skb, size_of_cluster);
+#endif
+		}
+		info->vid = vid;
+#else
+		/*
+		 * vid is assigned in rtl8651_rxPktPreprocess()
+		 * do not update it when CONFIG_RTL_HARDWARE_NAT is defined
+		 */
+		info->vid = pPkthdr->ph_vlanId;
+#if defined(SKIP_ALLOC_RX_BUFF)
+		buf = NULL;
+#else
+		buf = alloc_rx_buf(&skb, size_of_cluster);
+#endif
+#endif
+#ifdef CONFIG_RTL_VLAN_8021Q
+		/* info->srcvid=pPkthdr->ph_svlanId; */
+		info->srcvid = pPkthdr->ph_vlanId;
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		info->pid = (pPkthdr->ph_portlist & 0x7);
+#else
+		info->pid = pPkthdr->ph_portlist;
+#endif
+		if (buf) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+			dma_unmap_single(&rtl819x_pdev->dev, pPkthdr->dma_addr,
+				((struct sk_buff *)pPkthdr->ph_mbuf->skb)->
+				truesize, DMA_FROM_DEVICE);
+			skbp = (struct sk_buff *)skb;
+			mapping =
+				dma_map_single(&rtl819x_pdev->dev, skbp->head,
+				skbp->truesize, DMA_FROM_DEVICE);
+			if (unlikely(dma_mapping_error(&rtl819x_pdev->dev,
+						mapping))) {
+				DBG("Failed to map RX DMA memory!");
+				dev_kfree_skb_any(skbp);
+				return RTL_NICRX_NULL;
+			}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+			info->input = pPkthdr->ph_mbuf->skb;
+			info->len = pPkthdr->ph_len - 4;
+			/* Increment index */
+#if defined(CONFIG_RTD_1295_HWNAT)
+			increase_rx_idx_release_pkthdr(skb, mapping, rxRingIdx);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			increase_rx_idx_release_pkthdr(skb, rxRingIdx);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+			REG32(CPUIISR) =
+				(MBUF_DESC_RUNOUT_IP_ALL |
+				PKTHDR_DESC_RUNOUT_IP_ALL);
+		}
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+		else if (!buffer_reuse(rxRingIdx)) {
+			info->input = pPkthdr->ph_mbuf->skb;
+			info->len = pPkthdr->ph_len - 4;
+			/* printk("====CPU is pending====\n"); */
+#if defined(CONFIG_RTL_ETH_PRIV_SKB_DEBUG)
+			mbuf_pending_times++;
+#endif
+			/* we do not free this skbuff in swNic_freeRxBuf() */
+			pPkthdr->ph_mbuf->skb = NULL;
+
+			/* Increment index */
+			swNic_increaseRxIdx(rxRingIdx);
+		}
+#endif
+		else {
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+			rx_noBuffer_cnt++;
+#endif
+#if 0
+			if (retryCount > RTL_NIC_RX_RETRY_MAX) {
+				/* drop pkt */
+				increase_rx_idx_release_pkthdr((void *)pPkthdr->
+					ph_mbuf->skb, rxRingIdx);
+			}
+#if defined(CONFIG_SMP)
+			SMP_UNLOCK_ETH_RECV(flags);
+#endif
+			return RTL_NICRX_REPEAT;
+#else
+#if defined(CONFIG_SMP)
+			/* SMP_UNLOCK_ETH_RECV(flags); */
+#endif
+			return RTL_NICRX_NULL;
+#endif
+		}
+
+#if defined(RTL_MULTIPLE_RX_TX_RING)
+		info->priority = rxRingIdx;
+#endif
+
+#if defined(CONFIG_SMP)
+		/* SMP_UNLOCK_ETH_RECV(flags); */
+#endif
+
+		return RTL_NICRX_OK;
+	} else {
+#if defined(CONFIG_SMP)
+		/* SMP_UNLOCK_ETH_RECV(flags); */
+#endif
+
+		return RTL_NICRX_NULL;
+	}
+}
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+int32 swNic_freeRxRing(void)
+{
+	struct rtl_pktHdr *pPkthdr;
+	uint32 rxRingIdx;
+	uint32 currRxPktDescIdx;
+
+	printk("[%s]:[%d].\n", __FUNCTION__, __LINE__);
+	/* Check OWN bit of descriptors */
+#if defined(RTL_MULTIPLE_RX_TX_RING)
+	/*to-do:free each rx ring one by one */
+#else
+	rxRingIdx = 0;
+	while (__swNic_geRxRingIdx(rxRingIdx, &currRxPktDescIdx) == SUCCESS)
+#endif
+	{
+
+		/* Fetch pkthdr */
+#ifdef CONFIG_RTL_ENHANCE_RELIABILITY
+		pPkthdr =
+			(struct rtl_pktHdr *)(rxPkthdrRing_base[rxRingIdx] +
+			(sizeof(struct rtl_pktHdr) * currRxPktDescIdx));
+#else
+		pPkthdr =
+			(struct rtl_pktHdr *)(rxPkthdrRing[rxRingIdx][currRxPktDescIdx] &
+			~(DESC_OWNED_BIT | DESC_WRAP));
+#endif
+		/* Increment counter */
+		/* rxPktCounter++; */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		sync_rx_data_for_cpu(pPkthdr->dma_addr,
+			((struct sk_buff *)pPkthdr->ph_mbuf->skb)->truesize);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(_PKTHDR_CACHEABLE)
+		_dma_cache_inv((unsigned long)pPkthdr,
+			sizeof(struct rtl_pktHdr));
+		_dma_cache_inv((unsigned long)(pPkthdr->ph_mbuf),
+			sizeof(struct rtl_mBuf));
+#endif
+		_dma_cache_inv((unsigned long)(((struct sk_buff *)pPkthdr->ph_mbuf->skb)->data),
+			pPkthdr->ph_len - 4);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		RTL_ETH_NIC_DROP_RX_PKT_RESTART;
+
+	}
+
+	return 0;
+}
+#endif
+
+#undef	RTL_ETH_NIC_DROP_RX_PKT_RESTART
+
+#ifdef CONFIG_RTL_HW_TX_CSUM
+static inline struct iphdr *getIpv4Header(uint8 *macFrame)
+{
+	uint8 *ptr;
+	struct iphdr *iph = NULL;
+
+	ptr = macFrame + 12;
+
+	/*it's not ipv4 packet */
+	if (*(int16 *)(ptr) != (int16)htons(ETH_P_IP)) {
+		return NULL;
+	}
+
+	iph = (struct iphdr *)(ptr + 2);
+
+	return iph;
+}
+
+static inline int get_protocol_type2(struct sk_buff *skb)
+{
+	struct iphdr *iph;
+	struct udphdr *udph;
+
+	iph = getIpv4Header(skb->data);
+	if (iph == NULL)
+		return PKTHDR_ETHERNET;
+	udph = (void *)iph + iph->ihl * 4;
+	if (iph->protocol == IPPROTO_UDP)
+		return PKTHDR_UDP;
+	else if (iph->protocol == IPPROTO_TCP)
+		return PKTHDR_TCP;
+	else if (iph->protocol == IPPROTO_ICMP)
+		return PKTHDR_ICMP;
+	else if (iph->protocol == IPPROTO_IGMP)
+		return PKTHDR_IGMP;
+	else
+		return PKTHDR_IP;
+}
+
+/*
+  for 8198C: only can use direct tx mode when use tx checksum feature
+  software need to parse pkt and fill: type/Vi/Li/Pi/ipv6/ipv4/ipv4_1st/ipv6_hdrlen of pkthdr
+  Vi: pkt has vlan tag
+  Li: pkt has llc snap header
+  Pi: pkt has pppoe header
+  ipv6: pkt has ipv6 hdr
+  ipv4: pkt has ipv4 hdr
+  ipv4_1st: the first layer is ipv4
+  ipv6_hdrlen: ipv6=1 must assign ipv6_hdrlen, it include base+extension, minimum is 40 bytes.
+
+  for example:
+    pure ipv6 pkt: ipv6=1, ipv4=0, ipv4_1st=0
+    pure ipv4 pkt: ipv6=0, ipv4=1, ipv4_1st=1
+    DS-Lite pkt (ipv6+ipv4): ipv6=1, ipv4=1, ipv4_1st=0
+    6-RD pkt (ipv4+ipv6): ipv6=1, ipv4=1, ipv4_1st=1
+
+  type: no matter ipv4 or ipv6, parse to L4 (if have)
+	ICMP	: L4 is icmp
+	IGMP	: L4 is igmp
+	TCP		: L4 is tcp
+	UDP		: L4 is udp
+	PPTP	: L4 is gre
+	IP		: L3 ipv4 (no L4)
+	IPV6	: L3 ipv6 (no L4)
+	ETHERNET: L2 pkt
+
+  above setting are complicated, however for 8197F, HW Tx checksum support HW_lookup mode,
+  so if want to use HW Tx checksum feature, please ALWAYS use HW_lookup mode,
+  even broadcast/multicast pkt, even MULTIPLE_LAN defined,
+  even RTK_VLAN defined and vlan is enabled, even ...
+ */
+static inline int get_protocol_type(struct sk_buff *skb,
+	struct rtl_pktHdr *pPkthdr)
+{
+	struct iphdr *iph = NULL;
+
+#ifdef CONFIG_IPV6
+	uint8 proto_type = PKTHDR_ETHERNET;
+	uint8 next_header;
+#endif
+
+	pPkthdr->ph_vlanTagged = 0;
+	pPkthdr->ph_pppeTagged = 0;
+	if (*(int16 *)(skb->data + 12) == (int16)htons(ETH_P_IP)) {
+		iph = (struct iphdr *)(skb->data + 14);
+	} else if ((*(int16 *)(skb->data + 12) == (int16)htons(ETH_P_PPP_SES))
+		|| (*(int16 *)(skb->data + 12) == (int16)htons(ETH_P_PPP_DISC))) {
+		pPkthdr->ph_pppeTagged = 1;
+		if (*(int16 *)(skb->data + 12 + 8) == (int16)htons(0x0021)) {
+			iph = (struct iphdr *)(skb->data + 12 + 10);
+		}
+#ifdef CONFIG_IPV6
+		else if (*(int16 *)(skb->data + 12 + 8) == (int16)htons(0x0057)) {
+			proto_type = PKTHDR_IPV6;
+			next_header = *(uint8 *)(skb->data + 12 + 8 + 2 + 6);
+		}
+#endif
+
+	} else if (*(int16 *)(skb->data + 12) == (int16)htons(ETH_P_8021Q)) {
+		pPkthdr->ph_vlanTagged = 1;
+		if (*(int16 *)(skb->data + 12 + 4) == (int16)htons(ETH_P_IP)) {
+			iph = (struct iphdr *)(skb->data + 12 + 4 + 2);
+		}
+#ifdef CONFIG_IPV6
+		else if (*(int16 *)(skb->data + 12 + 4) == (int16)htons(ETH_P_IPV6)) {
+			proto_type = PKTHDR_IPV6;
+			next_header = *(uint8 *)(skb->data + 12 + 4 + 2 + 6);
+		}
+#endif
+		else if ((*(int16 *)(skb->data + 12 + 4) == (int16)htons(ETH_P_PPP_SES))
+			|| (*(int16 *)(skb->data + 12 + 4) == (int16)htons(ETH_P_PPP_DISC))) {
+			pPkthdr->ph_pppeTagged = 1;
+			if (*(int16 *)(skb->data + 12 + 4 + 8) == (int16)htons(0x0021)) {
+				iph = (struct iphdr *)(skb->data + 12 + 4 + 10);
+			}
+#ifdef CONFIG_IPV6
+			else if (*(int16 *)(skb->data + 12 + 4 + 8) ==
+				(int16)htons(0x0057)) {
+				proto_type = PKTHDR_IPV6;
+				next_header =
+					*(uint8 *)(skb->data + 12 + 4 + 8 + 2 + 6);
+			}
+#endif
+		}
+	}
+#ifdef CONFIG_IPV6
+	else if (*(int16 *)(skb->data + 12) == (int16)htons(ETH_P_IPV6)) {
+		proto_type = PKTHDR_IPV6;
+		next_header = *(uint8 *)(skb->data + 12 + 2 + 6);
+	}
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#ifdef CONFIG_IPV6
+	if (proto_type == PKTHDR_IPV6) {
+		pPkthdr->ph_ipIpv6 = 1;
+		pPkthdr->ph_ipIpv6HdrLen = 40;
+		/* IPv4 fileds should be 0 */
+		pPkthdr->ph_ipIpv4 = 0;
+		pPkthdr->ph_ipIpv4_1st = 0;
+
+		if (next_header == IPPROTO_TCP)
+			return PKTHDR_TCP;
+		else if (next_header == IPPROTO_UDP)
+			return PKTHDR_UDP;
+		else if (next_header == IPPROTO_ICMP)
+			return PKTHDR_ICMP;
+		else if (next_header == IPPROTO_IGMP)
+			return PKTHDR_IGMP;
+		else if (next_header == IPPROTO_GRE)
+			return PKTHDR_PPTP;
+		else
+			return PKTHDR_IPV6;
+	} else
+#endif
+	{
+		pPkthdr->ph_ipIpv4 = 1;
+		pPkthdr->ph_ipIpv4_1st = 1;
+		/* IPv6 fileds should be 0 */
+		pPkthdr->ph_ipIpv6 = 0;
+		pPkthdr->ph_ipIpv6HdrLen = 0;
+	}
+#endif
+
+	if (iph == NULL)
+		return PKTHDR_ETHERNET;
+
+	if (iph->protocol == IPPROTO_TCP)
+		return PKTHDR_TCP;
+	else if (iph->protocol == IPPROTO_UDP)
+		return PKTHDR_UDP;
+	else if (iph->protocol == IPPROTO_ICMP)
+		return PKTHDR_ICMP;
+	else if (iph->protocol == IPPROTO_IGMP)
+		return PKTHDR_IGMP;
+	else if (iph->protocol == IPPROTO_GRE)
+		return PKTHDR_PPTP;
+	else
+		return PKTHDR_IP;
+}
+#endif
+
+/*************************************************************************
+*   FUNCTION
+*       swNic_send
+*
+*   DESCRIPTION
+*       This function writes one packet to tx descriptors, and waits until
+*       the packet is successfully sent.
+*
+*   INPUTS
+*       None
+*
+*   OUTPUTS
+*       None
+*************************************************************************/
+__MIPS16 __IRAM_FWD inline int32 _swNic_send(void *skb, void *output,
+	uint32 len, rtl_nicTx_info *nicTx)
+{
+	struct rtl_pktHdr *pPkthdr;
+	int next_index, ret;
+
+#ifdef CONFIG_RTL_ETH_TX_SG
+	struct rtl_mBuf *pMbuf2, *pMbuf3 = NULL;
+	struct sk_buff *pskb = (struct sk_buff *)skb;
+	int i;
+#endif
+
+	if ((currTxPkthdrDescIndex[nicTx->txIdx] + 1) ==
+		txPkthdrRingCnt[nicTx->txIdx])
+		next_index = 0;
+	else
+		next_index = currTxPkthdrDescIndex[nicTx->txIdx] + 1;
+
+	if (next_index == txPktDoneDescIndex[nicTx->txIdx]) {
+		/*      TX ring full    */
+		return -1;
+	}
+#if defined(CONFIG_RTL_ENHANCE_RELIABILITY) && (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F))
+	pPkthdr = (struct rtl_pktHdr *)((int32)txPkthdrRing_base[nicTx->txIdx] +
+		(sizeof(struct rtl_pktHdr) * currTxPkthdrDescIndex[nicTx->txIdx]));
+
+#else
+	/* Fetch packet header from Tx ring */
+	pPkthdr =
+		(struct rtl_pktHdr *)((int32)txPkthdrRing[nicTx->txIdx][currTxPkthdrDescIndex[nicTx->txIdx]]
+		& ~(DESC_OWNED_BIT | DESC_WRAP));
+
+#endif
+
+	/* Pad small packets and add CRC */
+	if (len < 60)
+		len = 64;
+	else
+		len += 4;
+
+#ifdef CONFIG_RTL_ETH_TX_SG
+	if (skb_shinfo(pskb)->nr_frags > 0) {
+		pPkthdr->ph_mbuf->m_len = pskb->len - pskb->data_len;
+		pPkthdr->ph_mbuf->m_extsize = pskb->len - pskb->data_len;
+		pPkthdr->ph_mbuf->m_flags = MBUF_USED | MBUF_EXT | MBUF_PKTHDR;
+	} else {
+		pPkthdr->ph_mbuf->m_len = len;
+		pPkthdr->ph_mbuf->m_extsize = len;
+		pPkthdr->ph_mbuf->m_flags =
+			MBUF_USED | MBUF_EXT | MBUF_PKTHDR | MBUF_EOR;
+		pPkthdr->ph_mbuf->m_next = NULL;
+	}
+#else
+	pPkthdr->ph_mbuf->m_len = len;
+	pPkthdr->ph_mbuf->m_extsize = len;
+#endif
+
+	pPkthdr->ph_mbuf->skb = skb;
+	pPkthdr->ph_len = len;
+
+	pPkthdr->ph_vlanId = nicTx->vid;
+
+#if defined(CONFIG_8198_PORT5_GMII) || defined(CONFIG_8198_PORT5_RGMII) || defined(CONFIG_8198C_8211FS) || defined(CONFIG_RTL_8198C_8211F) || defined(CONFIG_RTL_8198C_8367RB)
+	pPkthdr->ph_portlist = nicTx->portlist & 0x3f;
+#else
+	pPkthdr->ph_portlist = nicTx->portlist & 0x1f;
+#endif
+	pPkthdr->ph_srcExtPortNum = nicTx->srcExtPort;
+	pPkthdr->ph_flags = nicTx->flags;
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT) || defined(CONFIG_RTK_VOIP_QOS)
+	pPkthdr->ph_txPriority = nicTx->priority;
+#endif
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if (*((unsigned short *)((unsigned char *)output + ETH_ALEN * 2)) !=
+		__constant_htons(ETH_P_8021Q))
+		pPkthdr->ph_txCVlanTagAutoAdd = nicTx->tagport;
+	else
+		pPkthdr->ph_txCVlanTagAutoAdd = 0;
+#endif
+
+#if ((defined(CONFIG_RTL_VLAN_8021Q) || defined(CONFIG_SWCONFIG)) && defined(CONFIG_RTL_QOS_8021P_SUPPORT)) || defined(CONFIG_RTL_HW_TX_CSUM)
+	pPkthdr->ph_vlanTagged = 0;
+#endif
+
+#if defined(CONFIG_RTL_VLAN_8021Q) || defined(CONFIG_SWCONFIG)
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (*((unsigned short *)((unsigned char *)((struct sk_buff *)skb)->data + ETH_ALEN * 2)) !=
+		__constant_htons(ETH_P_8021Q))
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (*((unsigned short *)((unsigned char *)output + ETH_ALEN * 2)) !=
+		__constant_htons(ETH_P_8021Q))
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	{
+#if defined(CONFIG_RTL_8021Q_VLAN_SUPPORT_SRC_TAG)
+		extern int rtl865x_curOpMode;
+
+		if (rtl865x_curOpMode == 0)
+			pPkthdr->ph_txCVlanTagAutoAdd =
+				RTL_WANPORT_MASK &
+				rtk_get_vlan_tagmask(pPkthdr->ph_vlanId);
+		else
+			pPkthdr->ph_txCVlanTagAutoAdd =
+				0x3f & rtk_get_vlan_tagmask(pPkthdr->ph_vlanId);
+#else
+		pPkthdr->ph_txCVlanTagAutoAdd =
+			0x3f & rtk_get_vlan_tagmask(pPkthdr->ph_vlanId);
+#endif
+	} else
+		pPkthdr->ph_txCVlanTagAutoAdd = 0;
+
+#if defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	if (gHwNatEnabled == 0)
+#endif
+	{
+		if (pPkthdr->ph_portlist == RTL_WANPORT_MASK) {
+			if (((struct sk_buff *)skb)->srcVlanPriority > 0
+				&& ((struct sk_buff *)skb)->srcVlanPriority <= 7) {
+				if (*(unsigned short *)((unsigned char *)output + ETH_ALEN * 2) == __constant_htons(ETH_P_8021Q)) {
+					pPkthdr->ph_vlanTagged = 1;
+					pPkthdr->ph_txCVlanTagAutoAdd =
+						RTL_WANPORT_MASK;
+					pPkthdr->ph_txPriority =
+						((struct sk_buff *)skb)->srcVlanPriority;
+				}
+			}
+		}
+	}
+#endif
+
+#if 0
+	panic_printk
+		("%s %d pPkthdr->ph_txCVlanTagAutoAdd=0x%x pPkthdr->ph_portlist=0x%x pPkthdr->ph_vlanId=%d\n",
+		__FUNCTION__, __LINE__, pPkthdr->ph_txCVlanTagAutoAdd,
+		pPkthdr->ph_portlist, pPkthdr->ph_vlanId);
+#endif
+#elif defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+	if (*((unsigned short *)((unsigned char *)output + ETH_ALEN * 2)) !=
+		__constant_htons(ETH_P_8021Q))
+	{
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+#ifdef CONFIG_RTL_8367R_SUPPORT	/* mark_8367 */
+		rtk_get_real_nicTxVid((struct sk_buff *)skb, &nicTx->vid);
+		pPkthdr->ph_vlanId = nicTx->vid;
+#endif
+		pPkthdr->ph_txCVlanTagAutoAdd =
+			(0x3f) & rtk_getTagPortmaskByVid(pPkthdr->ph_vlanId,
+			output);
+#else
+		pPkthdr->ph_txCVlanTagAutoAdd = auto_set_tag_portmask;
+#endif
+	} else
+		pPkthdr->ph_txCVlanTagAutoAdd = 0;
+#endif
+
+#ifdef CONFIG_RTL_HW_TX_CSUM
+	if (((struct sk_buff *)skb)->ip_summed == CHECKSUM_PARTIAL) {
+		pPkthdr->ph_proto = get_protocol_type(skb, pPkthdr);
+		pPkthdr->ph_flags =
+			(PKTHDR_USED | PKT_OUTGOING | CSUM_TCPUDP | CSUM_IP);
+	} else {
+		/* set these fields to 0 which we may used before. */
+		pPkthdr->ph_proto = 0;
+		pPkthdr->ph_pppeTagged = 0;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		pPkthdr->ph_ipIpv4 = 0;
+		pPkthdr->ph_ipIpv4_1st = 0;
+		pPkthdr->ph_ipIpv6 = 0;
+		pPkthdr->ph_ipIpv6HdrLen = 0;
+#endif
+	}
+#endif
+
+	/* Set cluster pointer to buffer */
+	pPkthdr->ph_mbuf->m_data = (output);
+	pPkthdr->ph_mbuf->m_extbuf = (output);
+
+#ifdef CONFIG_RTL_ETH_TX_SG
+	for (i = 0; i < skb_shinfo(pskb)->nr_frags; i++) {
+		skb_frag_t *frag = &skb_shinfo(pskb)->frags[i];
+		void *addr;
+
+		addr = ((void *)page_address(frag->page.p)) + frag->page_offset;
+		_dma_cache_wback((unsigned long)addr, frag->size);
+
+		if (i == 0) {	/* first one */
+			pMbuf2 = (struct rtl_mBuf *)sg_mbuf[sg_mbuf_idx++];
+			if (sg_mbuf_idx >= SG_MBUF_NUM)
+				sg_mbuf_idx = 0;
+			pPkthdr->ph_mbuf->m_next = pMbuf2;
+		} else {
+			pMbuf2 = pMbuf3;
+		}
+		pMbuf2->m_data = addr;
+		pMbuf2->m_extbuf = addr;
+		pMbuf2->m_pkthdr = pPkthdr;
+		if (i == (skb_shinfo(pskb)->nr_frags - 1)) {	/* last one */
+			pMbuf2->m_len = frag->size + 4;
+			pMbuf2->m_extsize = frag->size + 4;
+			pMbuf2->m_flags = MBUF_USED | MBUF_EXT | MBUF_EOR;
+			pMbuf2->m_next = NULL;
+		} else {
+			pMbuf2->m_len = frag->size;
+			pMbuf2->m_extsize = frag->size;
+			pMbuf2->m_flags = MBUF_USED | MBUF_EXT;
+			pMbuf3 = (struct rtl_mBuf *)sg_mbuf[sg_mbuf_idx++];
+			if (sg_mbuf_idx >= SG_MBUF_NUM)
+				sg_mbuf_idx = 0;
+			pMbuf2->m_next = pMbuf3;
+		}
+#if !defined(CONFIG_RTD_1295_HWNAT)
+		_dma_cache_wback((unsigned long)pMbuf2,
+			sizeof(struct rtl_mBuf));
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	}
+#endif
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	pPkthdr->ph_ptpPkt = 0;
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	sync_tx_data_for_device((dma_addr_t) output,
+		((struct sk_buff *)skb)->len);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#ifdef _PKTHDR_CACHEABLE
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	_dma_cache_wback((unsigned long)pPkthdr, sizeof(struct rtl_pktHdr));
+	_dma_cache_wback((unsigned long)(pPkthdr->ph_mbuf),
+		sizeof(struct rtl_mBuf));
+#else
+	_dma_cache_wback_inv((unsigned long)pPkthdr, sizeof(struct rtl_pktHdr));
+	_dma_cache_wback_inv((unsigned long)(pPkthdr->ph_mbuf),
+		sizeof(struct rtl_mBuf));
+#endif
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	ret = currTxPkthdrDescIndex[nicTx->txIdx];
+	currTxPkthdrDescIndex[nicTx->txIdx] = next_index;
+	/* Give descriptor to switch core */
+	txPkthdrRing[nicTx->txIdx][ret] |= DESC_SWCORE_OWNED;
+
+#if defined(CONFIG_RTL_ENHANCE_RELIABILITY) && !defined(CONFIG_RTL_8198C) &&  !defined(CONFIG_RTL_8197F)
+	{
+		uint32 pkthdr2 = (uint32)txPkthdrRing[nicTx->txIdx][ret];
+
+		if ((pkthdr2 & DESC_OWNED_BIT) == 0)
+			rtlglue_printf("_swNic_send: idx= %d, read back pkthdr= 0x%x.\n",
+				ret, pkthdr2);
+	}
+#endif
+
+#if 0
+	memDump((void *)output, 64, "TX");
+	printk("index %d address 0x%p, 0x%x 0x%p.\n", ret,
+		&txPkthdrRing[nicTx->txIdx][ret],
+		(*(volatile uint32 *)&txPkthdrRing[nicTx->txIdx][ret]),
+		pPkthdr);
+	printk("Flags 0x%x proto 0x%x portlist 0x%x vid %d extPort %d srcExtPort %d len %d.\n",
+		pPkthdr->ph_flags, pPkthdr->ph_proto, pPkthdr->ph_portlist,
+		pPkthdr->ph_vlanId, pPkthdr->ph_extPortList,
+		pPkthdr->ph_srcExtPortNum, pPkthdr->ph_len);
+#endif
+
+	/* Set TXFD bit to start send */
+#if defined(CONFIG_RTL_8197F)
+	REG32(CPUICR) = REG32(CPUICR) & (~(0x1 << 29));
+#endif
+	REG32(CPUICR) |= TXFD;
+
+	return ret;
+}
+
+__IRAM_FWD
+	int32 swNic_send(void *skb, void *output, uint32 len,
+	rtl_nicTx_info *nicTx)
+{
+	int ret;
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_XMIT(flags);
+	ret = _swNic_send(skb, output, len, nicTx);
+	SMP_UNLOCK_ETH_XMIT(flags);
+	return ret;
+}
+
+__IRAM_FWD int32 swNic_txDone(int idx)
+{
+	struct rtl_pktHdr *pPkthdr;
+
+	/* int                           free_num; */
+	unsigned long flags = 0;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	struct sk_buff *tx_skb;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	SMP_LOCK_ETH_XMIT(flags);
+	/* free_num = 0; */
+	{
+		while (txPktDoneDescIndex[idx] != currTxPkthdrDescIndex[idx]) {
+			if ((*(volatile uint32 *) &txPkthdrRing[idx][txPktDoneDescIndex[idx]]
+					& DESC_OWNED_BIT) == DESC_RISC_OWNED) {
+#ifdef CONFIG_RTL8196C_REVISION_B
+				if (rtl_chip_version == RTL8196C_REVISION_A)
+					txPkthdrRing[idx][txPktDoneDescIndex[idx]] = txPkthdrRing_backup[idx][txPktDoneDescIndex[idx]];
+#endif
+
+#ifdef CONFIG_RTL_ENHANCE_RELIABILITY
+				pPkthdr =
+					(struct rtl_pktHdr *)(txPkthdrRing_base[idx] +
+					(sizeof(struct rtl_pktHdr) * txPktDoneDescIndex[idx]));
+#else
+				pPkthdr =
+					(struct rtl_pktHdr *)((int32) txPkthdrRing[idx][txPktDoneDescIndex[idx]]
+					& ~(DESC_OWNED_BIT | DESC_WRAP));
+#endif
+
+				if (pPkthdr->ph_mbuf->skb) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+					tx_skb = (struct sk_buff *)pPkthdr->
+						ph_mbuf->skb;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#if !(defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) || !defined(CONFIG_RPS)
+					SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+#if defined(CONFIG_RTL_FAST_BRIDGE)
+					tx_done_callback(pPkthdr->ph_mbuf->skb);
+#else
+#if defined(CONFIG_RTD_1295_HWNAT)
+					dma_unmap_single(&rtl819x_pdev->dev,
+						pPkthdr->dma_addr, tx_skb->len,
+						DMA_TO_DEVICE);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+					dev_kfree_skb_any((struct sk_buff *)
+						pPkthdr->ph_mbuf->skb);
+#endif
+#if !(defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) || !defined(CONFIG_RPS)
+					SMP_LOCK_ETH_XMIT(flags);
+#endif
+					pPkthdr->ph_mbuf->skb = NULL;
+				}
+
+				if (++txPktDoneDescIndex[idx] == txPkthdrRingCnt[idx])
+					txPktDoneDescIndex[idx] = 0;
+
+				/* free_num++; */
+			} else
+				break;
+		}
+	}
+
+	SMP_UNLOCK_ETH_XMIT(flags);
+	return 0;		/* free_num; */
+}
+
+#ifdef CONFIG_RTL865X_MODEL_TEST_FT2
+int32 swNic_send_portmbr(void *output, uint32 len, uint32 portmbr)
+{
+	struct rtl_pktHdr *pPkthdr;
+	uint8 pktbuf[2048];
+	uint8 *pktbuf_alligned =
+		(uint8 *)(((uint32)pktbuf & 0xfffffffc) | 0xa0000000);
+
+	/* Copy Packet Content */
+	memcpy(pktbuf_alligned, output, len);
+
+	ASSERT_CSP(((int32)txPkthdrRing[0][currTxPkthdrDescIndex] &
+			DESC_OWNED_BIT) == DESC_RISC_OWNED);
+
+	/* Fetch packet header from Tx ring */
+	pPkthdr =
+		(struct rtl_pktHdr *)((int32) txPkthdrRing[0][currTxPkthdrDescIndex]
+		& ~(DESC_OWNED_BIT | DESC_WRAP));
+
+	/* Pad small packets and add CRC */
+	if (len < 60)
+		pPkthdr->ph_len = 64;
+	else
+		pPkthdr->ph_len = len + 4;
+
+	pPkthdr->ph_mbuf->m_len = pPkthdr->ph_len;
+	pPkthdr->ph_mbuf->m_extsize = pPkthdr->ph_len;
+
+	/* Set cluster pointer to buffer */
+	pPkthdr->ph_mbuf->m_data = pktbuf_alligned;
+	pPkthdr->ph_mbuf->m_extbuf = pktbuf_alligned;
+
+	/* Set destination port */
+	pPkthdr->ph_portlist = portmbr;
+
+	/* Give descriptor to switch core */
+	txPkthdrRing[0][currTxPkthdrDescIndex] |= DESC_SWCORE_OWNED;
+
+	/* Set TXFD bit to start send */
+	REG32(CPUICR) |= TXFD;
+
+	/* Wait until packet is successfully sent */
+#if 1
+	while ((*(volatile uint32 *)&txPkthdrRing[0][currTxPkthdrDescIndex] & DESC_OWNED_BIT) == DESC_SWCORE_OWNED);
+#endif
+	/* txPktCounter++; */
+
+	if (++currTxPkthdrDescIndex == txPkthdrRingCnt[0])
+		currTxPkthdrDescIndex = 0;
+
+	return 0;
+}
+#endif
+
+void swNic_freeRxBuf(void)
+{
+	int i;
+
+	/* int idx; */
+	/* struct rtl_pktHdr * pPkthdr; */
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	/* Initialize index of Tx pkthdr descriptor */
+	for (i = 0; i < RTL865X_SWNIC_TXRING_HW_PKTDESC; i++) {
+		currTxPkthdrDescIndex[i] = 0;
+		txPktDoneDescIndex[i] = 0;
+	}
+
+	for (i = RTL865X_SWNIC_RXRING_HW_PKTDESC - 1; i >= 0; i--) {
+		/* Initialize index of current Rx pkthdr descriptor */
+		currRxPkthdrDescIndex[i] = 0;
+		/* Initialize index of current Rx Mbuf descriptor */
+		currRxMbufDescIndex = 0;
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+		rxDescReadyForHwIndex[i] = 0;
+		rxDescCrossBoundFlag[i] = 0;
+#endif
+#if 0
+		for (idx = 0; idx < rxPkthdrRingCnt[i]; idx++) {
+			if (!((rxPkthdrRing[i][idx] & DESC_OWNED_BIT) == DESC_RISC_OWNED)) {
+				pPkthdr =
+					(struct rtl_pktHdr *)(rxPkthdrRing[i][idx] &
+					~(DESC_OWNED_BIT | DESC_WRAP));
+
+				/*if(pPkthdr == NULL || pPkthdr->ph_mbuf == NULL)
+				 *      continue;
+				 */
+				if (pPkthdr->ph_mbuf->skb) {
+					free_rx_buf(pPkthdr->ph_mbuf->skb);
+					pPkthdr->ph_mbuf->skb = NULL;
+				}
+
+				pPkthdr->ph_mbuf->m_data = NULL;
+				pPkthdr->ph_mbuf->m_extbuf = NULL;
+			}
+		}
+#endif
+	}
+	if (rxMbufRing) {
+		struct rtl_mBuf *pMbuf;
+
+		for (i = 0; i < rxMbufRingCnt; i++) {
+#if defined(CONFIG_SMP)
+			SMP_LOCK_ETH_RECV(flags);
+#endif
+			pMbuf = (struct rtl_mBuf *)(rxMbufRing[i] &
+				~(DESC_OWNED_BIT | DESC_WRAP));
+
+			if (pMbuf->skb) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+				dma_unmap_single(&rtl819x_pdev->dev,
+					pMbuf->m_pkthdr->dma_addr,
+					((struct sk_buff *)pMbuf->skb)->truesize, DMA_FROM_DEVICE);
+				pMbuf->m_pkthdr->dma_addr = 0;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_SMP)
+				SMP_UNLOCK_ETH_RECV(flags);
+#endif
+				free_rx_buf(pMbuf->skb);
+#if defined(CONFIG_SMP)
+				SMP_LOCK_ETH_RECV(flags);
+#endif
+				pMbuf->skb = NULL;
+			}
+#if defined(CONFIG_SMP)
+			SMP_UNLOCK_ETH_RECV(flags);
+#endif
+
+#ifdef INIT_RX_RING_ERR_HANDLE
+			if ((rxMbufRing[i] & DESC_WRAP) != 0)
+				break;
+#endif
+		}
+	}
+}
+
+#if defined(REINIT_SWITCH_CORE)
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+int swNic_refillRxRing(void)
+{
+	unsigned long flags = 0;
+	unsigned int i;
+	void *skb;
+	unsigned char *buf;
+
+	SMP_LOCK_ETH_RECV(flags);
+	for (i = 0; i < RTL865X_SWNIC_RXRING_MAX_PKTDESC; i++) {
+		while (return_to_rxing_check(i)) {
+			skb = NULL;
+			buf = alloc_rx_buf(&skb, size_of_cluster);
+
+			if ((buf == NULL) || (skb == NULL)) {
+				SMP_UNLOCK_ETH_RECV(flags);
+				return -1;
+			}
+
+			release_pkthdr(skb, i);
+		}
+		REG32(CPUIISR) =
+			(MBUF_DESC_RUNOUT_IP_ALL | PKTHDR_DESC_RUNOUT_IP_ALL);
+	}
+
+	SMP_UNLOCK_ETH_RECV(flags);
+	return 0;
+}
+#endif
+
+void swNic_freeTxRing(void)
+{
+	struct rtl_pktHdr *pPkthdr;
+	uint32 idx;
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH_XMIT(flags);
+	/* free_num = 0; */
+
+	/* Initialize index of Tx pkthdr descriptor */
+	for (idx = 0; idx < RTL865X_SWNIC_TXRING_HW_PKTDESC; idx++) {
+		while (txPktDoneDescIndex[idx] != currTxPkthdrDescIndex[idx]) {
+
+#ifdef CONFIG_RTL8196C_REVISION_B
+			if (rtl_chip_version == RTL8196C_REVISION_A)
+				txPkthdrRing[idx][txPktDoneDescIndex[idx]] = txPkthdrRing_backup[idx][txPktDoneDescIndex[idx]];
+#endif
+
+#ifdef CONFIG_RTL_ENHANCE_RELIABILITY
+			pPkthdr =
+				(struct rtl_pktHdr *)(txPkthdrRing_base[idx] +
+				(sizeof(struct rtl_pktHdr) * txPktDoneDescIndex[idx]));
+#else
+			pPkthdr =
+				(struct rtl_pktHdr *)((int32)
+				txPkthdrRing[idx][txPktDoneDescIndex[idx]]
+				& ~(DESC_OWNED_BIT | DESC_WRAP));
+#endif
+
+			if (pPkthdr->ph_mbuf->skb) {
+
+#if defined(CONFIG_RTL_FAST_BRIDGE)
+				tx_done_callback(pPkthdr->ph_mbuf->skb);
+#else
+				dev_kfree_skb_any((struct sk_buff *)pPkthdr->
+					ph_mbuf->skb);
+#endif
+
+				pPkthdr->ph_mbuf->skb = NULL;
+			}
+
+			txPkthdrRing[idx][txPktDoneDescIndex[idx]] &=
+				~DESC_SWCORE_OWNED;
+
+			if (++txPktDoneDescIndex[idx] == txPkthdrRingCnt[idx])
+				txPktDoneDescIndex[idx] = 0;
+
+		}
+
+	}
+
+	SMP_UNLOCK_ETH_XMIT(flags);
+	return;			/* free_num; */
+}
+
+int32 swNic_reConfigRxTxRing(void)
+{
+	uint32 i, j, k;
+
+	/* struct rtl_pktHdr     *pPkthdr; */
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH(flags);
+
+	k = 0;
+
+	for (i = 0; i < RTL865X_SWNIC_RXRING_HW_PKTDESC; i++) {
+		for (j = 0; j < rxPkthdrRingCnt[i]; j++) {
+			/* Setup descriptors */
+			rxPkthdrRing[i][j] =
+				rxPkthdrRing[i][j] | DESC_SWCORE_OWNED;
+			rxMbufRing[k] = rxMbufRing[k] | DESC_SWCORE_OWNED;
+			k++;
+		}
+
+		/* Initialize index of current Rx pkthdr descriptor */
+		currRxPkthdrDescIndex[i] = 0;
+
+		/* Initialize index of current Rx Mbuf descriptor */
+		currRxMbufDescIndex = 0;
+
+		/* Set wrap bit of the last descriptor */
+		if (rxPkthdrRingCnt[i] > 0)
+			rxPkthdrRing[i][rxPkthdrRingCnt[i] - 1] |= DESC_WRAP;
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+		rxDescReadyForHwIndex[i] = 0;
+		rxDescCrossBoundFlag[i] = 0;
+#endif
+	}
+
+	rxMbufRing[rxMbufRingCnt - 1] |= DESC_WRAP;
+
+	for (i = 0; i < RTL865X_SWNIC_TXRING_HW_PKTDESC; i++) {
+		for (j = 0; j < txPkthdrRingCnt[i]; j++) {
+			txPkthdrRing[i][j] &= ~DESC_SWCORE_OWNED;
+		}
+
+		if (txPkthdrRingCnt[i] > 0) {
+			txPkthdrRing[i][txPkthdrRingCnt[i] - 1] |= DESC_WRAP;
+		}
+		currTxPkthdrDescIndex[i] = 0;
+		txPktDoneDescIndex[i] = 0;
+	}
+
+	/* Fill Tx packet header FDP */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	REG32(CPUTPDCR0) = txPkthdrRingPhyAddr[0];
+	REG32(CPUTPDCR1) = txPkthdrRingPhyAddr[1];
+	REG32(CPUTPDCR2) = txPkthdrRingPhyAddr[2];
+	REG32(CPUTPDCR3) = txPkthdrRingPhyAddr[3];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	REG32(CPUTPDCR0) = (uint32)txPkthdrRing[0];
+	REG32(CPUTPDCR1) = (uint32)txPkthdrRing[1];
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	REG32(CPUTPDCR2) = (uint32)txPkthdrRing[2];
+	REG32(CPUTPDCR3) = (uint32)txPkthdrRing[3];
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* Fill Rx packet header FDP */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	REG32(CPURPDCR0) = rxPkthdrRingPhyAddr[0];
+	REG32(CPURPDCR1) = rxPkthdrRingPhyAddr[1];
+	REG32(CPURPDCR2) = rxPkthdrRingPhyAddr[2];
+	REG32(CPURPDCR3) = rxPkthdrRingPhyAddr[3];
+	REG32(CPURPDCR4) = rxPkthdrRingPhyAddr[4];
+	REG32(CPURPDCR5) = rxPkthdrRingPhyAddr[5];
+
+	REG32(CPURMDCR0) = (uint32)rxMbufRingPhyAddr;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	REG32(CPURPDCR0) = (uint32)rxPkthdrRing[0];
+	REG32(CPURPDCR1) = (uint32)rxPkthdrRing[1];
+	REG32(CPURPDCR2) = (uint32)rxPkthdrRing[2];
+	REG32(CPURPDCR3) = (uint32)rxPkthdrRing[3];
+	REG32(CPURPDCR4) = (uint32)rxPkthdrRing[4];
+	REG32(CPURPDCR5) = (uint32)rxPkthdrRing[5];
+
+	REG32(CPURMDCR0) = (uint32)rxMbufRing;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	SMP_UNLOCK_ETH(flags);
+
+	return 0;
+}
+
+int32 swNic_reInit(void)
+{
+	swNic_freeTxRing();
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+	swNic_refillRxRing();
+#endif
+	swNic_reConfigRxTxRing();
+	return SUCCESS;
+}
+
+#endif
+/* #pragma ghs section text=default */
+/*************************************************************************
+*   FUNCTION
+*       swNic_init
+*
+*   DESCRIPTION
+*       This function initializes descriptors and data structures.
+*
+*   INPUTS
+*       userNeedRxPkthdrRingCnt[RTL865X_SWNIC_RXRING_HW_PKTDESC] :
+*          Number of Rx pkthdr descriptors of each ring.
+*       userNeedRxMbufRingCnt :
+*          Number of Tx mbuf descriptors.
+*       userNeedTxPkthdrRingCnt[RTL865X_SWNIC_TXRING_HW_PKTDESC] :
+*          Number of Tx pkthdr descriptors of each ring.
+*       clusterSize :
+*          Size of cluster.
+*
+*   OUTPUTS
+*       Status.
+*************************************************************************/
+
+#if (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(_PKTHDR_CACHEABLE)
+#include <asm/cpu-features.h>
+#endif
+
+int32 swNic_init(uint32
+	userNeedRxPkthdrRingCnt[RTL865X_SWNIC_RXRING_HW_PKTDESC],
+	uint32 userNeedRxMbufRingCnt,
+	uint32 userNeedTxPkthdrRingCnt[RTL865X_SWNIC_TXRING_HW_PKTDESC],
+	uint32 clusterSize)
+{
+	uint32 i, j, k;
+	static uint32 totalRxPkthdrRingCnt = 0, totalTxPkthdrRingCnt = 0;
+	static struct rtl_pktHdr *pPkthdrList_start;
+	static struct rtl_mBuf *pMbufList_start;
+	struct rtl_pktHdr *pPkthdrList;
+	struct rtl_mBuf *pMbufList;
+	struct rtl_pktHdr *pPkthdr;
+	struct rtl_mBuf *pMbuf;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	static dma_addr_t pkthdrListPhyAddr;
+	static dma_addr_t mbufListPhyAddr;
+	struct sk_buff *skbp;
+	dma_addr_t mapping;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	unsigned long flags = 0;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	int ret;
+
+#ifdef ALLOW_RX_RING_PARTIAL_EMPTY
+	int mem_not_enough, ready_for_hw_idx;
+#endif
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(_PKTHDR_CACHEABLE)
+	int _cpu_dcache_line;
+
+#if (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F))
+	_cpu_dcache_line = cpu_dcache_line_size();	/* in \arch\mips\include\asm\cpu-features.h */
+#else
+	_cpu_dcache_line = cpu_dcache_line;
+#endif
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* init const array for rx pre-process  */
+	extPortMaskToPortNum[0] = 5;
+	extPortMaskToPortNum[1] = 6;
+	extPortMaskToPortNum[2] = 7;
+	extPortMaskToPortNum[3] = 5;
+	extPortMaskToPortNum[4] = 8;
+	extPortMaskToPortNum[5] = 5;
+	extPortMaskToPortNum[6] = 5;
+	extPortMaskToPortNum[7] = 5;
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+	rxPkthdrRefillThreshold[0] = ETH_REFILL_THRESHOLD;
+	rxPkthdrRefillThreshold[1] = ETH_REFILL_THRESHOLD1;
+	rxPkthdrRefillThreshold[2] = ETH_REFILL_THRESHOLD2;
+	rxPkthdrRefillThreshold[3] = ETH_REFILL_THRESHOLD3;
+	rxPkthdrRefillThreshold[4] = ETH_REFILL_THRESHOLD4;
+	rxPkthdrRefillThreshold[5] = ETH_REFILL_THRESHOLD5;
+#endif
+
+#if defined(CONFIG_RTL8196C_REVISION_B)
+	rtl_chip_version = REG32(REVR);
+#endif
+
+	/* rtlglue_printf("\n#######################################################\n"); */
+	/* rtlglue_printf("  NUM_RX_PKTHDR_DESC= %d, eth_skb_free_num= %d\n", */
+	/* NUM_RX_PKTHDR_DESC, get_buf_in_poll()); */
+	/* rtlglue_printf("#######################################################\n"); */
+
+	ret = SUCCESS;
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	SMP_LOCK_ETH_RECV(flags);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	if (rxMbufRing == NULL) {
+		size_of_cluster = clusterSize;
+
+		/* Allocate Rx descriptors of rings */
+		for (i = 0; i < RTL865X_SWNIC_RXRING_HW_PKTDESC; i++) {
+			rxPkthdrRingCnt[i] = userNeedRxPkthdrRingCnt[i];
+			if (rxPkthdrRingCnt[i] == 0) {
+				rxPkthdrRing[i] = NULL;
+				continue;
+			}
+#if defined(CONFIG_RTD_1295_HWNAT)
+			rxPkthdrRing[i] =
+				(uintptr_t *) dma_alloc_coherent(&rtl819x_pdev->dev,
+				rxPkthdrRingCnt[i] * sizeof(uintptr_t *),
+				&rxPkthdrRingPhyAddr[i], GFP_KERNEL);
+			ASSERT_CSP((uintptr_t) rxPkthdrRing[i]);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			rxPkthdrRing[i] =
+				(uint32 *)UNCACHED_MALLOC(rxPkthdrRingCnt[i] * sizeof(uint32 *));
+			ASSERT_CSP((uint32)rxPkthdrRing[i] & 0x0fffffff);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+			totalRxPkthdrRingCnt += rxPkthdrRingCnt[i];
+		}
+
+		if (totalRxPkthdrRingCnt == 0) {
+			ret = EINVAL;
+			goto out;
+		}
+
+		/* Allocate Tx descriptors of rings */
+		for (i = 0; i < RTL865X_SWNIC_TXRING_HW_PKTDESC; i++) {
+			txPkthdrRingCnt[i] = userNeedTxPkthdrRingCnt[i];
+
+			if (txPkthdrRingCnt[i] == 0) {
+				txPkthdrRing[i] = NULL;
+				continue;
+			}
+#if defined(CONFIG_RTD_1295_HWNAT)
+			txPkthdrRing[i] =
+				(uintptr_t *) dma_alloc_coherent(&rtl819x_pdev->dev,
+				txPkthdrRingCnt[i] * sizeof(uintptr_t *),
+				&txPkthdrRingPhyAddr[i], GFP_KERNEL);
+			ASSERT_CSP((uintptr_t) txPkthdrRing[i]);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			txPkthdrRing[i] =
+				(uint32 *)UNCACHED_MALLOC(txPkthdrRingCnt[i] * sizeof(uint32 *));
+#ifdef CONFIG_RTL8196C_REVISION_B
+			if (rtl_chip_version == RTL8196C_REVISION_A)
+				txPkthdrRing_backup[i] =
+					(uint32 *) UNCACHED_MALLOC(txPkthdrRingCnt[i] * sizeof(uint32));
+#endif
+
+			ASSERT_CSP((uint32)txPkthdrRing[i] & 0x0fffffff);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+			totalTxPkthdrRingCnt += txPkthdrRingCnt[i];
+		}
+
+		if (totalTxPkthdrRingCnt == 0) {
+			ret = EINVAL;
+			goto out;
+		}
+
+		/* Allocate MBuf descriptors of rings */
+		rxMbufRingCnt = userNeedRxMbufRingCnt;
+
+		if (userNeedRxMbufRingCnt == 0) {
+			ret = EINVAL;
+			goto out;
+		}
+#if defined(CONFIG_RTD_1295_HWNAT)
+		rxMbufRing =
+			(uintptr_t *) dma_alloc_coherent(&rtl819x_pdev->dev,
+			(rxMbufRingCnt + RESERVERD_MBUF_RING_NUM) * sizeof(uintptr_t *),
+			&rxMbufRingPhyAddr, GFP_KERNEL);
+		ASSERT_CSP((uintptr_t) rxMbufRing);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		rxMbufRing =
+			(uint32 *)UNCACHED_MALLOC((rxMbufRingCnt +
+				RESERVERD_MBUF_RING_NUM) * sizeof(uint32 *));
+		ASSERT_CSP((uint32)rxMbufRing & 0x0fffffff);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		/* Allocate pkthdr */
+#ifdef _PKTHDR_CACHEABLE
+
+#if 0				/* defined(CONFIG_RTL_8198C) */
+		pPkthdrList_start = (struct rtl_pktHdr *)kmalloc(
+			(totalRxPkthdrRingCnt + totalTxPkthdrRingCnt) * sizeof(struct rtl_pktHdr),
+			GFP_ATOMIC);
+		ASSERT_CSP((uint32)pPkthdrList_start & 0x0fffffff);
+
+		/* Allocate mbufs */
+		pMbufList_start = (struct rtl_mBuf *)kmalloc(
+			(rxMbufRingCnt + RESERVERD_MBUF_RING_NUM + totalTxPkthdrRingCnt) * sizeof(struct rtl_mBuf),
+			GFP_ATOMIC);
+		ASSERT_CSP((uint32)pMbufList_start & 0x0fffffff);
+
+#else
+		pPkthdrList_start = (struct rtl_pktHdr *)kmalloc(
+			(totalRxPkthdrRingCnt + totalTxPkthdrRingCnt + 1) * sizeof(struct rtl_pktHdr),
+			GFP_ATOMIC);
+		ASSERT_CSP((uint32)pPkthdrList_start & 0x0fffffff);
+
+		pPkthdrList_start =
+			(struct rtl_pktHdr *)(((uint32)pPkthdrList_start + (_cpu_dcache_line - 1)) & ~(_cpu_dcache_line - 1));
+		memset(pPkthdrList_start, 0,
+			(totalRxPkthdrRingCnt + totalTxPkthdrRingCnt) * sizeof(struct rtl_pktHdr));
+
+		/* Allocate mbufs */
+#ifdef CONFIG_RTL_ETH_TX_SG
+		pMbufList_start = (struct rtl_mBuf *)kmalloc(
+			(rxMbufRingCnt + RESERVERD_MBUF_RING_NUM + (totalTxPkthdrRingCnt) + 1 + SG_MBUF_NUM + 2) * sizeof(struct rtl_mBuf),
+			GFP_ATOMIC);
+#else
+		pMbufList_start = (struct rtl_mBuf *)kmalloc(
+			(rxMbufRingCnt + RESERVERD_MBUF_RING_NUM + totalTxPkthdrRingCnt + 1) * sizeof(struct rtl_mBuf),
+			GFP_ATOMIC);
+#endif
+		ASSERT_CSP((uint32)pMbufList_start & 0x0fffffff);
+
+		pMbufList_start =
+			(struct rtl_mBuf *)(((uint32)pMbufList_start + (_cpu_dcache_line - 1)) & ~(_cpu_dcache_line - 1));
+#ifdef CONFIG_RTL_ETH_TX_SG
+		memset(pMbufList_start, 0,
+			(rxMbufRingCnt + RESERVERD_MBUF_RING_NUM + (totalTxPkthdrRingCnt) + SG_MBUF_NUM + 2) * sizeof(struct rtl_mBuf));
+#else
+		memset(pMbufList_start, 0,
+			(rxMbufRingCnt + RESERVERD_MBUF_RING_NUM + totalTxPkthdrRingCnt) * sizeof(struct rtl_mBuf));
+#endif
+#endif
+
+#else
+#if defined(CONFIG_RTD_1295_HWNAT)
+		pPkthdrList_start =
+			(struct rtl_pktHdr *)dma_alloc_coherent(&rtl819x_pdev->dev,
+			(totalRxPkthdrRingCnt + totalTxPkthdrRingCnt) * sizeof(struct rtl_pktHdr),
+			&pkthdrListPhyAddr, GFP_KERNEL);
+		ASSERT_CSP((uintptr_t) pPkthdrList_start);
+
+		/* Allocate mbufs */
+		pMbufList_start =
+			(struct rtl_mBuf *)dma_alloc_coherent(&rtl819x_pdev->dev,
+			(rxMbufRingCnt + RESERVERD_MBUF_RING_NUM + totalTxPkthdrRingCnt) * sizeof(struct rtl_mBuf),
+			&mbufListPhyAddr, GFP_KERNEL);
+		ASSERT_CSP((uintptr_t) pMbufList_start);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		pPkthdrList_start = (struct rtl_pktHdr *)UNCACHED_MALLOC(
+			(totalRxPkthdrRingCnt + totalTxPkthdrRingCnt) * sizeof(struct rtl_pktHdr));
+		ASSERT_CSP((uint32)pPkthdrList_start & 0x0fffffff);
+
+		/* Allocate mbufs */
+		pMbufList_start = (struct rtl_mBuf *)UNCACHED_MALLOC(
+			(rxMbufRingCnt + RESERVERD_MBUF_RING_NUM + totalTxPkthdrRingCnt) * sizeof(struct rtl_mBuf));
+		ASSERT_CSP((uint32)pMbufList_start & 0x0fffffff);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+#if defined(CONFIG_RTL_8198C)
+		SMP_UNLOCK_ETH_RECV(flags);
+		return ret;
+#endif
+	}
+
+	/* Initialize interrupt statistics counter */
+	/* rxPktCounter = txPktCounter = 0; */
+
+	/* Initialize index of Tx pkthdr descriptor */
+	for (i = 0; i < RTL865X_SWNIC_TXRING_HW_PKTDESC; i++) {
+		currTxPkthdrDescIndex[i] = 0;
+		txPktDoneDescIndex[i] = 0;
+	}
+
+	pPkthdrList = pPkthdrList_start;
+	pMbufList = pMbufList_start;
+
+	/* Initialize Tx packet header descriptors */
+	for (i = 0; i < RTL865X_SWNIC_TXRING_HW_PKTDESC; i++) {
+		for (j = 0; j < txPkthdrRingCnt[i]; j++) {
+			/* Dequeue pkthdr and mbuf */
+			pPkthdr = pPkthdrList++;
+			pMbuf = pMbufList++;
+
+			bzero((void *)pPkthdr, sizeof(struct rtl_pktHdr));
+			bzero((void *)pMbuf, sizeof(struct rtl_mBuf));
+
+			pPkthdr->ph_mbuf = pMbuf;
+			pPkthdr->ph_len = 0;
+			pPkthdr->ph_flags = PKTHDR_USED | PKT_OUTGOING;
+			pPkthdr->ph_type = PKTHDR_ETHERNET;
+			pPkthdr->ph_portlist = 0;
+
+			pMbuf->m_next = NULL;
+			pMbuf->m_pkthdr = pPkthdr;
+			pMbuf->m_flags =
+				MBUF_USED | MBUF_EXT | MBUF_PKTHDR | MBUF_EOR;
+			pMbuf->m_data = NULL;
+			pMbuf->m_extbuf = NULL;
+			pMbuf->m_extsize = 0;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+			txPkthdrRing[i][j] =
+				(uintptr_t) pPkthdr | DESC_RISC_OWNED;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			txPkthdrRing[i][j] = (int32)pPkthdr | DESC_RISC_OWNED;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#ifdef CONFIG_RTL8196C_REVISION_B
+			if (rtl_chip_version == RTL8196C_REVISION_A)
+				txPkthdrRing_backup[i][j] =
+					(int32)pPkthdr | DESC_RISC_OWNED;
+#endif
+		}
+
+#ifdef CONFIG_RTL_ENHANCE_RELIABILITY
+		txPkthdrRing_base[i] = txPkthdrRing[i][0];
+#endif
+
+		if (txPkthdrRingCnt[i] > 0) {
+			/* Set wrap bit of the last descriptor */
+			txPkthdrRing[i][txPkthdrRingCnt[i] - 1] |= DESC_WRAP;
+#ifdef CONFIG_RTL8196C_REVISION_B
+			if (rtl_chip_version == RTL8196C_REVISION_A)
+				txPkthdrRing_backup[i][txPkthdrRingCnt[i] - 1] |= DESC_WRAP;
+#endif
+		}
+
+	}
+
+#ifdef CONFIG_RTL_ETH_TX_SG
+	for (i = 0; i < SG_MBUF_NUM; i++) {
+		pMbuf = pMbufList++;
+		sg_mbuf[i] = (uint32)pMbuf;
+	}
+#endif
+
+	/* Fill Tx packet header FDP */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	REG32(CPUTPDCR0) = txPkthdrRingPhyAddr[0];
+	REG32(CPUTPDCR1) = txPkthdrRingPhyAddr[1];
+	REG32(CPUTPDCR2) = txPkthdrRingPhyAddr[2];
+	REG32(CPUTPDCR3) = txPkthdrRingPhyAddr[3];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	REG32(CPUTPDCR0) = (uint32)txPkthdrRing[0];
+	REG32(CPUTPDCR1) = (uint32)txPkthdrRing[1];
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	REG32(CPUTPDCR2) = (uint32)txPkthdrRing[2];
+	REG32(CPUTPDCR3) = (uint32)txPkthdrRing[3];
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* Initialize Rx packet header descriptors */
+	k = 0;
+
+	for (i = 0; i < RTL865X_SWNIC_RXRING_HW_PKTDESC; i++) {
+#if defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+		mem_not_enough = 0;
+		ready_for_hw_idx = 0;
+#endif
+
+		for (j = 0; j < rxPkthdrRingCnt[i]; j++) {
+			/* Dequeue pkthdr and mbuf */
+			pPkthdr = pPkthdrList++;
+			pMbuf = pMbufList++;
+
+			bzero((void *)pPkthdr, sizeof(struct rtl_pktHdr));
+			bzero((void *)pMbuf, sizeof(struct rtl_mBuf));
+
+			/* Setup pkthdr and mbuf */
+			pPkthdr->ph_mbuf = pMbuf;
+			pPkthdr->ph_len = 0;
+			pPkthdr->ph_flags = PKTHDR_USED | PKT_INCOMING;
+			pPkthdr->ph_type = PKTHDR_ETHERNET;
+			pPkthdr->ph_portlist = 0;
+			pMbuf->m_next = NULL;
+			pMbuf->m_pkthdr = pPkthdr;
+			pMbuf->m_len = 0;
+			pMbuf->m_flags =
+				MBUF_USED | MBUF_EXT | MBUF_PKTHDR | MBUF_EOR;
+			pMbuf->m_extsize = size_of_cluster;
+
+#if defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+			if (mem_not_enough == 0) {
+
+#ifdef PRIV_BUF_CAN_USE_KERNEL_BUF
+				pMbuf->m_data = pMbuf->m_extbuf =
+					alloc_rx_buf_init(&pPkthdr->ph_mbuf->skb,
+					size_of_cluster);
+#else
+				pMbuf->m_data = pMbuf->m_extbuf =
+					alloc_rx_buf(&pPkthdr->ph_mbuf->skb,
+					size_of_cluster);
+#endif
+
+				if (pMbuf->m_data == NULL) {
+					mem_not_enough = 1;
+					ready_for_hw_idx = j;
+					rxPkthdrRing[i][j] = (int32)pPkthdr;
+					rxMbufRing[k++] = (int32)pMbuf;
+				} else {
+					/* Setup descriptors */
+					rxPkthdrRing[i][j] =
+						(int32)pPkthdr |
+						DESC_SWCORE_OWNED;
+					rxMbufRing[k++] =
+						(int32)pMbuf |
+						DESC_SWCORE_OWNED;
+				}
+
+			} else {
+				pMbuf->m_data = pMbuf->m_extbuf =
+					pPkthdr->ph_mbuf->skb = NULL;
+				rxPkthdrRing[i][j] = (int32)pPkthdr;
+				rxMbufRing[k++] = (int32)pMbuf;
+			}
+#else
+#ifdef PRIV_BUF_CAN_USE_KERNEL_BUF
+			pMbuf->m_data = pMbuf->m_extbuf =
+				alloc_rx_buf_init(&pPkthdr->ph_mbuf->skb,
+				size_of_cluster);
+#else
+#if defined(CONFIG_RTD_1295_HWNAT)
+			pMbuf->m_data = pMbuf->m_extbuf = NULL;
+			if (alloc_rx_buf(&pPkthdr->ph_mbuf->skb,
+					size_of_cluster) > 0) {
+				skbp = (struct sk_buff *)pPkthdr->ph_mbuf->skb;
+				mapping =
+					dma_map_single(&rtl819x_pdev->dev,
+					skbp->head, skbp->truesize,
+					DMA_FROM_DEVICE);
+				if (unlikely(dma_mapping_error(&rtl819x_pdev->dev,
+					mapping))) {
+					DBG("Failed to map RX DMA memory!");
+					dev_kfree_skb_any(skbp);
+					ret = EPERM;
+					goto out;
+				}
+				pMbuf->m_data = pMbuf->m_extbuf =
+					(uint8 *)(mapping + skb_headroom(skbp));
+				pPkthdr->dma_addr = mapping;
+			}
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			pMbuf->m_data = pMbuf->m_extbuf =
+				alloc_rx_buf(&pPkthdr->ph_mbuf->skb,
+				size_of_cluster);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+#ifdef INIT_RX_RING_ERR_HANDLE
+			if (pMbuf->m_data == NULL) {
+				rxPkthdrRingCnt[i] = j;
+				rxMbufRingCnt = k;
+				break;
+			} else
+#endif
+			{
+				/* Setup descriptors */
+#if defined(CONFIG_RTD_1295_HWNAT)
+				rxPkthdrRing[i][j] =
+					(uintptr_t) pPkthdr | DESC_SWCORE_OWNED;
+				rxMbufRing[k++] =
+					(uintptr_t) pMbuf | DESC_SWCORE_OWNED;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+				rxPkthdrRing[i][j] =
+					(int32)pPkthdr | DESC_SWCORE_OWNED;
+				rxMbufRing[k++] =
+					(int32)pMbuf | DESC_SWCORE_OWNED;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+			}
+#endif
+		}
+
+#ifdef CONFIG_RTL_ENHANCE_RELIABILITY
+		rxPkthdrRing_base[i] = rxPkthdrRing[i][0] & ~DESC_OWNED_BIT;
+#endif
+
+		/* Initialize index of current Rx pkthdr descriptor */
+		currRxPkthdrDescIndex[i] = 0;
+
+		/* Initialize index of current Rx Mbuf descriptor */
+		currRxMbufDescIndex = 0;
+
+		/* Set wrap bit of the last descriptor */
+		if (rxPkthdrRingCnt[i] > 0)
+			rxPkthdrRing[i][rxPkthdrRingCnt[i] - 1] |= DESC_WRAP;
+
+#if	defined(DELAY_REFILL_ETH_RX_BUF)
+		rxDescReadyForHwIndex[i] = 0;
+		rxDescCrossBoundFlag[i] = 0;
+#endif
+
+#if defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+		if (mem_not_enough == 1) {
+			rxDescReadyForHwIndex[i] = ready_for_hw_idx;
+			rxDescCrossBoundFlag[i] = 1;
+		} else {
+			rxDescReadyForHwIndex[i] = 0;
+			rxDescCrossBoundFlag[i] = 0;
+		}
+#endif
+	}
+
+#if defined(CONFIG_RTL_ENHANCE_RELIABILITY) && (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F))
+	rxMbufRing_base = rxMbufRing[0] & ~DESC_OWNED_BIT;
+#endif
+
+	rxMbufRing[rxMbufRingCnt - 1] |= DESC_WRAP;
+
+	/* Fill Rx packet header FDP */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	REG32(CPURPDCR0) = rxPkthdrRingPhyAddr[0];
+	REG32(CPURPDCR1) = rxPkthdrRingPhyAddr[1];
+	REG32(CPURPDCR2) = rxPkthdrRingPhyAddr[2];
+	REG32(CPURPDCR3) = rxPkthdrRingPhyAddr[3];
+	REG32(CPURPDCR4) = rxPkthdrRingPhyAddr[4];
+	REG32(CPURPDCR5) = rxPkthdrRingPhyAddr[5];
+
+	REG32(CPURMDCR0) = (uint32)rxMbufRingPhyAddr;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	REG32(CPURPDCR0) = (uint32)rxPkthdrRing[0];
+	REG32(CPURPDCR1) = (uint32)rxPkthdrRing[1];
+	REG32(CPURPDCR2) = (uint32)rxPkthdrRing[2];
+	REG32(CPURPDCR3) = (uint32)rxPkthdrRing[3];
+	REG32(CPURPDCR4) = (uint32)rxPkthdrRing[4];
+	REG32(CPURPDCR5) = (uint32)rxPkthdrRing[5];
+
+	REG32(CPURMDCR0) = (uint32)rxMbufRing;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+out:
+
+#ifdef _PKTHDR_CACHEABLE
+	_dma_cache_wback_inv((unsigned long)pPkthdrList_start,
+		(totalRxPkthdrRingCnt + totalTxPkthdrRingCnt) * sizeof(struct rtl_pktHdr));
+#ifdef CONFIG_RTL_ETH_TX_SG
+	_dma_cache_wback_inv((unsigned long)pMbufList_start,
+		(rxMbufRingCnt + RESERVERD_MBUF_RING_NUM + (totalTxPkthdrRingCnt) + SG_MBUF_NUM + 2) * sizeof(struct rtl_mBuf));
+#else
+	_dma_cache_wback_inv((unsigned long)pMbufList_start,
+		(rxMbufRingCnt + RESERVERD_MBUF_RING_NUM + totalTxPkthdrRingCnt) * sizeof(struct rtl_mBuf));
+#endif
+#endif
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	SMP_UNLOCK_ETH_RECV(flags);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	return ret;
+}
+
+#ifdef FAT_CODE
+/*************************************************************************
+*   FUNCTION
+*       swNic_resetDescriptors
+*
+*   DESCRIPTION
+*       This function resets descriptors.
+*
+*   INPUTS
+*       None.
+*
+*   OUTPUTS
+*       None.
+*************************************************************************/
+void swNic_resetDescriptors(void)
+{
+	/* Disable Tx/Rx and reset all descriptors */
+	REG32(CPUICR) &= ~(TXCMD | RXCMD);
+	return;
+}
+#endif /* FAT_CODE */
+
+#if 	defined(CONFIG_RTL_PROC_DEBUG)
+/*	dump the rx ring info	*/
+int32 rtl_dumpRxRing(struct seq_file *s)
+{
+	int idx, cnt;
+	struct rtl_pktHdr *pPkthdr;
+
+	for (idx = 0; idx < RTL865X_SWNIC_RXRING_HW_PKTDESC; idx++) {
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+		seq_printf(s,
+			"**********************************************\nRxRing%d: cnt %d crossFlags[%d]\n",
+			idx, rxPkthdrRingCnt[idx], rxDescCrossBoundFlag[idx]);
+#else
+		seq_printf(s,
+			"**********************************************\nRxRing%d: cnt %d\n",
+			idx, rxPkthdrRingCnt[idx]);
+#endif
+		/*      skip the null rx ring */
+		if (rxPkthdrRingCnt[idx] == 0)
+			continue;
+
+		/*      dump all the pkt header */
+		for (cnt = 0; cnt < rxPkthdrRingCnt[idx]; cnt++) {
+			pPkthdr =
+				(struct rtl_pktHdr *)(rxPkthdrRing[idx][cnt] &
+				~(DESC_OWNED_BIT | DESC_WRAP));
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+			seq_printf(s,
+				"  idx[%03d]: 0x%p-->mbuf[0x%p],skb[0x%p]%s%s%s%s\n",
+				cnt, pPkthdr, pPkthdr->ph_mbuf,
+				pPkthdr->ph_mbuf->skb,
+				(rxPkthdrRing[idx][cnt] & DESC_OWNED_BIT) == DESC_RISC_OWNED ? " :CPU" : " :SWCORE",
+				(rxPkthdrRing[idx][cnt] & DESC_WRAP) != 0 ? " :WRAP" : "",
+				cnt == currRxPkthdrDescIndex[idx] ? "  <===currIdx" : "",
+				cnt == rxDescReadyForHwIndex[idx] ? " <===readyForHw" : "");
+#else
+			seq_printf(s,
+				"  idx[%03d]: 0x%p-->mbuf[0x%p],skb[0x%p]%s%s%s\n",
+				cnt, pPkthdr, pPkthdr->ph_mbuf,
+				pPkthdr->ph_mbuf->skb,
+				(rxPkthdrRing[idx][cnt] & DESC_OWNED_BIT) == DESC_RISC_OWNED ? " :CPU" : " :SWCORE",
+				(rxPkthdrRing[idx][cnt] & DESC_WRAP) != 0 ? " :WRAP" : "",
+				cnt == currRxPkthdrDescIndex[idx] ? "  <===currIdx" : "");
+#endif
+#if defined(CONFIG_RTL_WTDOG)
+			rtl_periodic_watchdog_kick(cnt, WATCHDOG_NUM_OF_TIMES);
+#endif
+
+		}
+	}
+	return SUCCESS;
+}
+
+/*	dump the tx ring info	*/
+int32 rtl_dumpTxRing(struct seq_file *s)
+{
+	int idx, cnt;
+	struct rtl_pktHdr *pPkthdr = NULL;
+
+	for (idx = 0; idx < RTL865X_SWNIC_TXRING_HW_PKTDESC; idx++) {
+		seq_printf(s,
+			"**********************************************\nTxRing%d: cnt %d\n",
+			idx, txPkthdrRingCnt[idx]);
+
+		/*      skip the null rx ring */
+		if (txPkthdrRingCnt[idx] == 0)
+			continue;
+
+		/*      dump all the pkt header */
+		for (cnt = 0; cnt < txPkthdrRingCnt[idx]; cnt++) {
+#ifdef CONFIG_RTL8196C_REVISION_B
+			if (rtl_chip_version == RTL8196C_REVISION_A)
+				pPkthdr =
+					(struct rtl_pktHdr *)(txPkthdrRing_backup[idx][cnt] & ~(DESC_OWNED_BIT | DESC_WRAP));
+			else
+#endif
+				pPkthdr =
+					(struct rtl_pktHdr *)(txPkthdrRing[idx][cnt] & ~(DESC_OWNED_BIT | DESC_WRAP));
+
+			seq_printf(s,
+				"  idx[%03d]: 0x%p-->mbuf[0x%p],skb[0x%p]%s%s%s%s\n",
+				cnt, pPkthdr, pPkthdr->ph_mbuf,
+				pPkthdr->ph_mbuf->skb,
+				(txPkthdrRing[idx][cnt] & DESC_OWNED_BIT) == DESC_RISC_OWNED ? " :CPU" : " :SWCORE",
+				(txPkthdrRing[idx][cnt] & DESC_WRAP) != 0 ? " :WRAP" : "",
+				cnt == currTxPkthdrDescIndex[idx] ? "  <===currIdx" : "",
+				cnt == txPktDoneDescIndex[idx] ? "  <===txDoneIdx" : "");
+
+#if defined(CONFIG_RTL_WTDOG)
+			rtl_periodic_watchdog_kick(cnt, WATCHDOG_NUM_OF_TIMES);
+#endif
+
+		}
+	}
+	return SUCCESS;
+}
+
+/*	dump the tx ring info	*/
+int32 rtl_dumpMbufRing(struct seq_file *s)
+{
+	int idx;
+	struct rtl_mBuf *mbuf;
+
+	idx = 0;
+	seq_printf(s,
+		"**********************************************\nMbufRing:\n");
+	while (1) {
+		mbuf = (struct rtl_mBuf *)(rxMbufRing[idx] & ~(DESC_OWNED_BIT |
+				DESC_WRAP));
+		seq_printf(s,
+			"mbuf[%03d]: 0x%p: ==> pkthdr[0x%p] ==> skb[0x%p]%s%s%s\n",
+			idx, mbuf, mbuf->m_pkthdr, mbuf->skb,
+			(rxMbufRing[idx] & DESC_OWNED_BIT) == DESC_RISC_OWNED ? " :CPU" : " :SWCORE",
+			(rxMbufRing[idx] & DESC_WRAP) == DESC_ENG_OWNED ? " :WRAP" : "",
+			idx == currRxMbufDescIndex ? "  <===currIdx" : "");
+		if ((rxMbufRing[idx] & DESC_WRAP) != 0)
+			break;
+#if defined(CONFIG_RTL_WTDOG)
+		rtl_periodic_watchdog_kick(idx, WATCHDOG_NUM_OF_TIMES);
+#endif
+		idx++;
+	}
+	return SUCCESS;
+}
+
+/* dump brief info */
+int32 rtl_dumpIndexs(void)
+{
+	int i;
+
+	rtlglue_printf("Dump RX infos:\n");
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+	for (i = 0; i < RTL865X_SWNIC_RXRING_HW_PKTDESC; i++) {
+		rtlglue_printf("	TotalCnt: %d, currPkthdrIdx: %d currMbufIdx: %d readyForHwIdx: %d crossBoundFlag: %d.\n",
+			rxPkthdrRingCnt[i], currRxPkthdrDescIndex[i],
+			currRxMbufDescIndex, rxDescReadyForHwIndex[i],
+			rxDescCrossBoundFlag[i]);
+	}
+#else
+	for (i = 0; i < RTL865X_SWNIC_RXRING_HW_PKTDESC; i++) {
+		rtlglue_printf("	TotalCnt: %d, currPkthdrIdx: %d currMbufIdx: %d\n",
+			rxPkthdrRingCnt[i], currRxPkthdrDescIndex[i],
+			currRxMbufDescIndex);
+	}
+#endif
+
+	rtlglue_printf("\nDump TX infos:\n");
+	for (i = 0; i < RTL865X_SWNIC_TXRING_HW_PKTDESC; i++) {
+		rtlglue_printf("	TotalCnt: %d, currPkthdrIdx: %d pktDoneIdx: %d.\n",
+			txPkthdrRingCnt[i], currTxPkthdrDescIndex[i],
+			txPktDoneDescIndex[i]);
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#if defined(REINIT_SWITCH_CORE)
+int32 rtl_check_tx_done_desc_swCore_own(int32 *tx_done_inx)
+{
+	int ret = FAILED;
+	int tx_ring_idx = 0;	/* default use tx ring0 */
+
+	if ((*(volatile uint32 *) &txPkthdrRing[tx_ring_idx][txPktDoneDescIndex[tx_ring_idx]] & DESC_OWNED_BIT) == DESC_SWCORE_OWNED) {
+		*tx_done_inx = txPktDoneDescIndex[tx_ring_idx];
+		ret = SUCCESS;
+	}
+
+	return ret;
+}
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl865xc_swNic.h b/drivers/soc/realtek/rtd129x/hw_nat/rtl865xc_swNic.h
new file mode 100644
index 00000000..61c5d50
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl865xc_swNic.h
@@ -0,0 +1,581 @@
+/*
+* ----------------------------------------------------------------
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* $Header: /home/cvsroot/linux-2.6.19/linux-2.6.x/drivers/net/re865x/rtl865xc_swNic.h,v 1.3 2008/04/11 10:12:38 bo_zhao Exp $
+*
+* Abstract: Switch core polling mode NIC header file.
+*
+* $Author: bo_zhao $
+*
+* $Log: rtl865xc_swNic.h,v $
+* Revision 1.3  2008/04/11 10:12:38  bo_zhao
+* *: swap nic drive to 8186 style
+*
+* Revision 1.2  2007/11/11 02:51:27  davidhsu
+* Fix the bug that do not fre rx skb in rx descriptor when driver is shutdown
+*
+* Revision 1.1.1.1  2007/08/06 10:04:52  root
+* Initial import source to CVS
+*
+* Revision 1.4  2006/09/15 03:53:39  ghhuang
+* +: Add TFTP download support for RTL8652 FPGA
+*
+* Revision 1.3  2005/09/22 05:22:31  bo_zhao
+* *** empty log message ***
+*
+* Revision 1.1.1.1  2005/09/05 12:38:24  alva
+* initial import for add TFTP server
+*
+* Revision 1.2  2004/03/31 01:49:20  yjlou
+* *: all text files are converted to UNIX format.
+*
+* Revision 1.1  2004/03/16 06:36:13  yjlou
+* *** empty log message ***
+*
+* Revision 1.1.1.1  2003/09/25 08:16:56  tony
+*  initial loader tree
+*
+* Revision 1.1.1.1  2003/05/07 08:16:07  danwu
+* no message
+*
+* ---------------------------------------------------------------
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865XC_SWNIC_H
+#define	RTL865XC_SWNIC_H
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+/* #define	RTL_MULTIPLE_RX_TX_RING		1 */	/*enable multiple input queue(multiple rx ring)*/
+#endif
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) && !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F)
+#define SKIP_ALLOC_RX_BUFF 1
+#endif
+
+#define RTL865X_SWNIC_RXRING_HW_PKTDESC	6
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define RTL865X_SWNIC_TXRING_HW_PKTDESC	4
+#else
+#define RTL865X_SWNIC_TXRING_HW_PKTDESC	2
+#endif
+#define RESERVERD_MBUF_RING_NUM			8
+
+#if defined(CONFIG_RTL_NFJROM_MP)
+#define MAX_PRE_ALLOC_RX_SKB		64
+#define NUM_RX_PKTHDR_DESC		8
+#define NUM_TX_PKTHDR_DESC		64
+#define	ETH_REFILL_THRESHOLD		4	/* must < NUM_RX_PKTHDR_DESC */
+#elif defined(CONFIG_RTL_8198) && !defined(CONFIG_RTL_8198_AP_ROOT)
+#if defined(SKIP_ALLOC_RX_BUFF)
+#define MAX_PRE_ALLOC_RX_SKB		0
+#ifdef CONFIG_RTL_ULINKER
+#define NUM_RX_PKTHDR_DESC		1022	/* 512+510 */
+#else
+#define NUM_RX_PKTHDR_DESC		1024	/* 512+512 */
+#endif
+#else
+#define MAX_PRE_ALLOC_RX_SKB		512
+#ifdef CONFIG_RTL_ULINKER
+#define NUM_RX_PKTHDR_DESC		510
+#else
+#define NUM_RX_PKTHDR_DESC		512
+#endif
+#endif
+#define NUM_TX_PKTHDR_DESC		1024
+#define	ETH_REFILL_THRESHOLD		8	/* must < NUM_RX_PKTHDR_DESC */
+#elif defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+#ifndef CONFIG_RTL_SHRINK_MEMORY_SIZE
+#if defined(SKIP_ALLOC_RX_BUFF)
+#define MAX_PRE_ALLOC_RX_SKB		0
+#define NUM_RX_PKTHDR_DESC		1412
+#else
+#if defined(CONFIG_WLAN_HAL_8822BE)
+#define MAX_PRE_ALLOC_RX_SKB		768
+#define NUM_RX_PKTHDR_DESC		900
+#else
+#define MAX_PRE_ALLOC_RX_SKB		512
+#define NUM_RX_PKTHDR_DESC		900
+#endif
+#endif
+#define	ETH_REFILL_THRESHOLD		8	/* must < NUM_RX_PKTHDR_DESC */
+#define NUM_TX_PKTHDR_DESC		768
+#else
+#if defined(SKIP_ALLOC_RX_BUFF)
+#define MAX_PRE_ALLOC_RX_SKB		0
+#define NUM_RX_PKTHDR_DESC		1412
+#else
+#define MAX_PRE_ALLOC_RX_SKB		256
+#define NUM_RX_PKTHDR_DESC		450
+#endif
+#define	ETH_REFILL_THRESHOLD		8	/* must < NUM_RX_PKTHDR_DESC */
+#define NUM_TX_PKTHDR_DESC		300
+#endif
+#elif defined(CONFIG_RTL_819XD)
+#if defined(SKIP_ALLOC_RX_BUFF)
+#define MAX_PRE_ALLOC_RX_SKB		0
+#define NUM_RX_PKTHDR_DESC		1024	/* 512+512 */
+#else
+#define MAX_PRE_ALLOC_RX_SKB		512
+#define NUM_RX_PKTHDR_DESC		512
+#endif
+#define ETH_REFILL_THRESHOLD		8	/* must < NUM_RX_PKTHDR_DESC */
+#define NUM_TX_PKTHDR_DESC		512
+#elif defined(CONFIG_RTL_8198C)
+
+#if defined(SKIP_ALLOC_RX_BUFF)
+	/*
+	 * Note: Rx=448, Tx=448: Chariot LAN<->WAN 3D3U test for 1 minute (throughput is about 588Mbps for software NAT),
+	 * the result is no Rx_drop, Tx_retry, Tx_drop.
+	 * for LAN<->WLAN or LAN<->Samba application, please enlarge them if need.
+	 */
+#define MAX_PRE_ALLOC_RX_SKB		0
+#define NUM_RX_PKTHDR_DESC		448
+#define NUM_TX_PKTHDR_DESC		448
+#else
+
+#if defined(DELAY_REFILL_ETH_RX_BUF)
+#define MAX_PRE_ALLOC_RX_SKB		512
+#else
+#if defined(CONFIG_WLAN_HAL_8814AE)
+#define MAX_PRE_ALLOC_RX_SKB		2048
+#else
+#define MAX_PRE_ALLOC_RX_SKB		1024
+#endif
+#endif
+
+#if defined(CONFIG_WLAN_HAL_8814AE)
+#define NUM_RX_PKTHDR_DESC		2048
+#define NUM_TX_PKTHDR_DESC		2048
+#else
+#define NUM_RX_PKTHDR_DESC		512
+#define NUM_TX_PKTHDR_DESC		1024
+#endif
+#endif
+#define	ETH_REFILL_THRESHOLD		8	/* must < NUM_RX_PKTHDR_DESC */
+
+#elif defined(CONFIG_RTL_8197F)
+#ifndef CONFIG_RTL_SHRINK_MEMORY_SIZE
+#if defined(SKIP_ALLOC_RX_BUFF)
+	/*
+	 * Note: Rx=448, Tx=448: Chariot LAN<->WAN 3D3U test for 1 minute (throughput is about 588Mbps for software NAT),
+	 * the result is no Rx_drop, Tx_retry, Tx_drop.
+	 * for LAN<->WLAN or LAN<->Samba application, please enlarge them if need.
+	 */
+#define MAX_PRE_ALLOC_RX_SKB		0
+#define NUM_RX_PKTHDR_DESC		448
+#define NUM_TX_PKTHDR_DESC		448
+#else
+
+#if defined(DELAY_REFILL_ETH_RX_BUF)
+#define MAX_PRE_ALLOC_RX_SKB		512
+#else
+#define MAX_PRE_ALLOC_RX_SKB		512
+#endif
+
+#define NUM_RX_PKTHDR_DESC		900
+#define NUM_TX_PKTHDR_DESC		768
+#endif
+#else
+#if defined(SKIP_ALLOC_RX_BUFF)
+#define MAX_PRE_ALLOC_RX_SKB		0
+#define NUM_RX_PKTHDR_DESC		292
+#define NUM_TX_PKTHDR_DESC		284
+#else
+#define MAX_PRE_ALLOC_RX_SKB		192
+#define NUM_RX_PKTHDR_DESC		256
+#define NUM_TX_PKTHDR_DESC		300
+#endif
+#endif
+#define	ETH_REFILL_THRESHOLD		8	/* must < NUM_RX_PKTHDR_DESC */
+
+#elif defined(CONFIG_RTL_8881A)
+#define ETH_REFILL_THRESHOLD		8	/* must < NUM_RX_PKTHDR_DESC */
+#if defined(CONFIG_USE_PCIE_SLOT_0)
+#if defined(SKIP_ALLOC_RX_BUFF)
+#define MAX_PRE_ALLOC_RX_SKB		0
+#define NUM_RX_PKTHDR_DESC		912	/* 400+512 */
+#else
+#define MAX_PRE_ALLOC_RX_SKB		400	/* 512 */
+#define NUM_RX_PKTHDR_DESC		512
+#endif
+#define NUM_TX_PKTHDR_DESC		1024	/* 768 */
+#else
+#if defined(SKIP_ALLOC_RX_BUFF)
+#define MAX_PRE_ALLOC_RX_SKB		0
+#define NUM_RX_PKTHDR_DESC		556	/* 256+300 */
+#else
+#define MAX_PRE_ALLOC_RX_SKB		256	/* 512 */
+#define NUM_RX_PKTHDR_DESC		300	/* 512 */
+#endif
+#define NUM_TX_PKTHDR_DESC		512
+#endif
+#elif defined(CONFIG_RTL_8196E)
+#define ETH_REFILL_THRESHOLD		8	/* must < NUM_RX_PKTHDR_DESC */
+#ifdef CONFIG_RTL_SDRAM_GE_32M
+#if defined(SKIP_ALLOC_RX_BUFF)
+#define MAX_PRE_ALLOC_RX_SKB		0
+#if defined(CONFIG_RTL_DISABLE_ETH_MIPS16)
+#define NUM_RX_PKTHDR_DESC		518
+#else
+#define NUM_RX_PKTHDR_DESC		428	/* 128+300 */
+#endif
+#else
+#define MAX_PRE_ALLOC_RX_SKB		128
+#define NUM_RX_PKTHDR_DESC		300	/* 160 */
+#endif
+#define NUM_TX_PKTHDR_DESC		400
+#else
+#if defined(SKIP_ALLOC_RX_BUFF)
+#define MAX_PRE_ALLOC_RX_SKB		0
+#define NUM_RX_PKTHDR_DESC		292
+#define NUM_TX_PKTHDR_DESC		284
+#else
+#define MAX_PRE_ALLOC_RX_SKB		192
+#define NUM_RX_PKTHDR_DESC		256
+#define NUM_TX_PKTHDR_DESC		300
+#endif
+#endif
+#else
+#if defined(SKIP_ALLOC_RX_BUFF)
+#define MAX_PRE_ALLOC_RX_SKB		0
+#define NUM_RX_PKTHDR_DESC		1024	/* 512+512 */
+#else
+#define MAX_PRE_ALLOC_RX_SKB		512
+#define NUM_RX_PKTHDR_DESC		512
+#endif
+#define ETH_REFILL_THRESHOLD		8	/* must < NUM_RX_PKTHDR_DESC */
+#define NUM_TX_PKTHDR_DESC		256
+#endif
+
+#if defined(RTL_MULTIPLE_RX_TX_RING)
+
+#define	RTL_CPU_QOS_ENABLED		1
+
+#define	RTL865X_SWNIC_RXRING_MAX_PKTDESC	6
+#define	RTL865X_SWNIC_TXRING_MAX_PKTDESC	2
+#define	RTL_CPU_RX_RING_NUM			4
+/*	By default, only using rxring 0 and rxring 5
+*	in order to make different between low/high
+*	priority
+*/
+#define	NUM_RX_PKTHDR_DESC1		2
+#define	NUM_RX_PKTHDR_DESC2		2
+#define	NUM_RX_PKTHDR_DESC3		2
+#define	NUM_RX_PKTHDR_DESC4		2
+#define	NUM_RX_PKTHDR_DESC5		NUM_RX_PKTHDR_DESC
+#define	NUM_TX_PKTHDR_DESC1		NUM_TX_PKTHDR_DESC
+
+#define	ETH_REFILL_THRESHOLD1		0	/* must < NUM_RX_PKTHDR_DESC1 */
+#define	ETH_REFILL_THRESHOLD2		0	/* must < NUM_RX_PKTHDR_DESC2 */
+#define	ETH_REFILL_THRESHOLD3		0	/* must < NUM_RX_PKTHDR_DESC3 */
+#define	ETH_REFILL_THRESHOLD4		0	/* must < NUM_RX_PKTHDR_DESC4 */
+#define	ETH_REFILL_THRESHOLD5		ETH_REFILL_THRESHOLD	/* must < NUM_RX_PKTHDR_DESC5 */
+
+#define	QUEUEID0_RXRING_MAPPING		0x0000
+#define	QUEUEID1_RXRING_MAPPING		0x0000
+#define	QUEUEID2_RXRING_MAPPING		0x5555
+#define	QUEUEID3_RXRING_MAPPING		0x5555
+#define	QUEUEID4_RXRING_MAPPING		0x5555
+#define	QUEUEID5_RXRING_MAPPING		0x5555
+#else
+#define	RTL865X_SWNIC_RXRING_MAX_PKTDESC	1
+#define	RTL865X_SWNIC_TXRING_MAX_PKTDESC	1
+#define	RTL_CPU_RX_RING_NUM			1
+#define	NUM_RX_PKTHDR_DESC1		2
+#define	NUM_RX_PKTHDR_DESC2		2
+#define	NUM_RX_PKTHDR_DESC3		2
+#define	NUM_RX_PKTHDR_DESC4		2
+#define	NUM_RX_PKTHDR_DESC5		2
+#define	NUM_TX_PKTHDR_DESC1		2
+
+#define	ETH_REFILL_THRESHOLD1		0	/* must < NUM_RX_PKTHDR_DESC */
+#define	ETH_REFILL_THRESHOLD2		0	/* must < NUM_RX_PKTHDR_DESC */
+#define	ETH_REFILL_THRESHOLD3		0	/* must < NUM_RX_PKTHDR_DESC */
+#define	ETH_REFILL_THRESHOLD4		0	/* must < NUM_RX_PKTHDR_DESC */
+#define	ETH_REFILL_THRESHOLD5		0	/* must < NUM_RX_PKTHDR_DESC */
+
+#define	QUEUEID0_RXRING_MAPPING		0
+#define	QUEUEID1_RXRING_MAPPING		0
+#define	QUEUEID2_RXRING_MAPPING		0
+#define	QUEUEID3_RXRING_MAPPING		0
+#define	QUEUEID4_RXRING_MAPPING		0
+#define	QUEUEID5_RXRING_MAPPING		0
+#endif
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define	NUM_TX_PKTHDR_DESC2		2
+#define	NUM_TX_PKTHDR_DESC3		2
+#endif
+
+/* refer to rtl865xc_swNic.c & rtl865xc_swNic.h
+ */
+#define	UNCACHE_MASK			0x20000000
+
+/* rxPreProcess */
+#define	RTL8651_CPU_PORT		0x07	/* in rtl8651_tblDrv.h */
+#define	_RTL865XB_EXTPORTMASKS		7
+#define CONFIG_RTL_CUSTOM_PASSTHRU
+
+typedef struct {
+	uint16 vid;
+	uint16 pid;
+	uint16 len;
+	uint16 priority:3;
+	uint16 rxPri:3;
+	void *input;
+	struct dev_priv *priv;
+	uint32 isPdev;
+#if 0				/* defined(CONFIG_RTL_STP) */
+	int8 isStpVirtualDev;
+#endif
+
+#ifdef CONFIG_RTL_VLAN_8021Q
+	uint16 srcvid;
+#endif
+
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU) && defined(CONFIG_IPV6)
+	struct dev_priv *oriPriv;
+#endif
+
+} rtl_nicRx_info;
+
+typedef struct {
+	uint16 vid;
+	uint16 portlist;
+	uint16 srcExtPort;
+	uint16 flags;
+	void *out_skb;
+
+	/* total: 16 bits */
+	uint16 txIdx:2;
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) || defined(CONFIG_RTL_QOS_PATCH) || defined(CONFIG_RTK_VOIP_QOS)
+	uint16 priority:3;
+	uint16 queueId:3;
+#else
+	uint16 resv2:6;
+#endif
+#if defined(CONFIG_RTL_8197F)
+	uint16 extPortList:4;
+	uint16 tx_qid:3;
+#else
+	uint16 resv3:7;
+#endif
+	uint16 resv4:1;
+
+#if defined(CONFIG_RTK_VLAN_WAN_TAG_SUPPORT)
+	uint16 tagport;
+#endif
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	uint16 wFlags;
+#endif
+
+	/* todo: check they are needed or not !! */
+#if defined(CONFIG_RTL_8197F)
+
+	/* defined for new Tx Shortcut */
+	/* opts1 */
+	uint32 type:3;		/* [31:29] */
+	uint32 vi:1;		/* [28] */
+	uint32 li:1;		/* [27] */
+	uint32 pi:1;		/* [26] */
+	uint32 pppidx:3;	/* [25:23] */
+	uint32 len:17;		/* [22:6] */
+	uint32 bridge:1;	/* [5] */
+	uint32 hwlkup:1;	/* [4] */
+	uint32 fs:1;		/* [3] */
+	uint32 ls:1;		/* [2] */
+	uint32 eor:1;		/* [1] */
+	uint32 own:1;		/* [0] */
+
+	/* opts2 */
+	uint32 m_len:17;	/* [31:15] */
+	uint32 qid:3;		/* [14:12] */
+	uint32 pqid:3;		/* [11:9] */
+	uint32 vlantagset:9;	/* [8:0] */
+
+	/* opts3 */
+	uint32 ptp_pkt:1;	/* [31] */
+	uint32 ptp_typ:4;	/* [30:27] */
+	uint32 ptp_ver:2;	/* [26:25] */
+	uint32 dpri:3;		/* [24:22] */
+	uint32 po:1;		/* [21] */
+	uint32 l3cs:1;		/* [20] */
+	uint32 l4cs:1;		/* [19] */
+	uint32 ipv6:1;		/* [18] */
+	uint32 ipv4:1;		/* [17] */
+	uint32 ipv4_1st:1;	/* [16] */
+	/* [15] Reserved */
+	uint32 dp_ext:3;	/* [14:12] */
+	uint32 dvlanid:12;	/* [11:0] */
+
+	/* opts4 */
+	uint32 lso:1;		/* [31] */
+	uint32 dp:7;		/* [30:24] */
+	/* [23] Reserved */
+	uint32 linked:7;	/* [22:16] */
+	uint32 ipv6_hdrlen:16;	/* [15:0] */
+
+	/* opts5 */
+	uint32 extspa:2;	/* [31:30] */
+	uint32 mss:14;		/* [29:16] */
+/* uint32 flags:8;		// [15:8]	// duplicated */
+	uint32 ipv4_hllen:4;	/* [7:4] */
+	uint32 tcp_hlen:4;	/* [3:0] */
+#endif
+} rtl_nicTx_info;
+
+#if defined(RTL_CPU_QOS_ENABLED)
+#define	RTL_NIC_QUEUE_LEN		(32)
+#define	RTL_CPUQOS_PKTCNT_THRESHOLD	(1000)
+#define	RTL_ASSIGN_RX_PRIORITY		((highestPriority < cpuQosHoldLow) ? ((totalLowQueueCnt < RTL_CPUQOS_PKTCNT_THRESHOLD) ? highestPriority : cpuQosHoldLow) : highestPriority)
+
+typedef struct {
+	int cnt;
+	int start;
+	int end;
+	rtl_nicRx_info entry[RTL_NIC_QUEUE_LEN];
+} rtl_queue_entry;
+#else
+#define	RTL_ASSIGN_RX_PRIORITY		0
+#endif
+/* --------------------------------------------------------------------
+ * ROUTINE NAME - swNic_init
+ * --------------------------------------------------------------------
+ * FUNCTION: This service initializes the switch NIC.
+ * INPUT   :
+		userNeedRxPkthdrRingCnt[RTL865X_SWNIC_RXRING_MAX_PKTDESC]: Number of Rx pkthdr descriptors. of each ring
+		userNeedRxMbufRingCnt: Number of Rx mbuf descriptors.
+		userNeedTxPkthdrRingCnt[RTL865X_SWNIC_TXRING_MAX_PKTDESC]: Number of Tx pkthdr descriptors. of each ring
+		clusterSize: Size of a mbuf cluster.
+ * OUTPUT  : None.
+ * RETURN  : Upon successful completion, the function returns ENOERR.
+		Otherwise,
+		EINVAL: Invalid argument.
+ * NOTE    : None.
+ * -------------------------------------------------------------------*/
+int32 swNic_init(uint32 userNeedRxPkthdrRingCnt[],
+	uint32 userNeedRxMbufRingCnt,
+	uint32 userNeedTxPkthdrRingCnt[],
+	uint32 clusterSize);
+
+/* --------------------------------------------------------------------
+ * ROUTINE NAME - swNic_intHandler
+ * --------------------------------------------------------------------
+ * FUNCTION: This function is the NIC interrupt handler.
+ * INPUT   :
+		intPending: Pending interrupts.
+ * OUTPUT  : None.
+ * RETURN  : None.
+ * NOTE    : None.
+ * -------------------------------------------------------------------*/
+void swNic_intHandler(uint32 intPending);
+int32 swNic_flushRxRingByPriority(int priority);
+__MIPS16 __IRAM_FWD int32 swNic_receive(rtl_nicRx_info *info, int retryCount);
+int32 swNic_send(void *skb, void *output, uint32 len, rtl_nicTx_info *nicTx);
+
+/* __MIPS16 */
+int32 swNic_txDone(int idx);
+void swNic_freeRxBuf(void);
+int32 swNic_txRunout(void);
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+extern int check_rx_pkthdr_ring(int idx, int *return_idx);
+extern int check_and_return_to_rx_pkthdr_ring(void *skb, int idx);
+extern int return_to_rx_pkthdr_ring(unsigned char *head);
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+extern uintptr_t *rxMbufRing;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+extern uint32 *rxMbufRing;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+extern unsigned char *alloc_rx_buf(void **skb, int buflen);
+extern unsigned char *alloc_rx_buf_init(void **skb, int buflen);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+static inline void free_rx_buf(void *skb)
+{
+	dev_kfree_skb_any((struct sk_buff *)skb);
+}
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+extern void free_rx_buf(void *skb);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTL_FAST_BRIDGE)
+extern void tx_done_callback(void *skb);
+#endif
+extern void eth_save_and_cli(unsigned long *flags);
+extern void eth_restore_flags(unsigned long flags);
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+int32 swNic_setVlanPortTag(int portmask);
+#endif
+
+#define	RTL8651_IOCTL_GETWANLINKSTATUS			2000
+#define	RTL8651_IOCTL_GETLANLINKSTATUS			2001
+#define	RTL8651_IOCTL_GETWANTHROUGHPUT			2002
+#define	RTL8651_IOCTL_GETLANPORTLINKSTATUS		2003
+#define	RTL8651_IOCTL_GETWANPORTLINKSTATUS		2004
+#define 	RTL8651_IOCTL_GETWANLINKSPEED 		2100
+/* #define 	RTL8651_IOCTL_SETWANLINKSPEED 		2101 */
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+#define RTL8651_IOCTL_SET_GETLINKSTATUS_PID		2102
+#endif
+#define RTL8651_IOCTL_GETLANLINKSTATUSALL		2105
+
+#define	RTL8651_IOCTL_SETWANLINKSTATUS			2200
+
+#define	RTL8651_IOCTL_CLEARBRSHORTCUTENTRY		2210
+
+#define	RTL8651_IOCTL_GETPORTIDBYCLIENTMAC		2013
+
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+#define	RTL8651_IOCTL_DOT1X_SETPID			2300
+#define RTL8651_IOCTL_DOT1X_GET_INFO			2301
+#define RTL8651_IOCTL_DOT1X_SET_AUTH_RESULT		2302
+#endif
+
+#define	RTL_NICRX_OK			0
+#define	RTL_NICRX_REPEAT		-2
+#define	RTL_NICRX_NULL			-1
+#if defined(REINIT_SWITCH_CORE)
+int32 swNic_reInit(void);
+#endif
+#if 	defined(CONFIG_RTL_PROC_DEBUG)
+int32 rtl_dumpRxRing(struct seq_file *s);
+int32 rtl_dumpTxRing(struct seq_file *s);
+int32 rtl_dumpMbufRing(struct seq_file *s);
+int32 rtl_dumpIndexs(void);
+#endif
+
+struct ring_que {
+	int qlen;
+	int qmax;
+	int head;
+	int tail;
+	struct sk_buff **ring;
+};
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+static inline void *UNCACHED_MALLOC(int size)
+{
+	return ((void *)(((uint32)kmalloc(size, GFP_ATOMIC)) | UNCACHE_MASK));
+}
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+static inline void *CACHED_MALLOC(int size)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	return ((void *)(((uintptr_t) kmalloc(size, GFP_ATOMIC))));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	return ((void *)(((uint32)kmalloc(size, GFP_ATOMIC))));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}
+
+#endif /* _SWNIC_H */
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl_dot1x.c b/drivers/soc/realtek/rtd129x/hw_nat/rtl_dot1x.c
new file mode 100644
index 00000000..33d67ef
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl_dot1x.c
@@ -0,0 +1,1855 @@
+/*
+ * Copyright c                Realtek Semiconductor Corporation, 2013
+ * All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ */
+
+#include <linux/version.h>
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,4,0)
+#include <linux/kconfig.h>
+#else
+#include <linux/config.h>
+#include <linux/autoconf.h>
+#endif
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/compiler.h>
+#include <linux/netdevice.h>
+#include <linux/inetdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/init.h>
+#include <linux/pci.h>
+#include <linux/delay.h>
+#include <linux/ethtool.h>
+#include <linux/mii.h>
+#include <linux/if_vlan.h>
+#include <linux/crc32.h>
+#include <asm/io.h>
+#include <asm/uaccess.h>
+#include <linux/slab.h>
+#include <linux/signal.h>
+#include <linux/proc_fs.h>
+#include <linux/time.h>
+#include <linux/rtc.h>
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#include <bsp/bspchip.h>
+#endif //!defined(CONFIG_RTD_1295_HWNAT)
+#include <linux/timer.h>
+
+
+#include "version.h"
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+
+#include "AsicDriver/asicRegs.h"
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER_L3
+#include "AsicDriver/rtl865x_asicL3.h"
+#endif
+
+#include "common/mbuf.h"
+#include <net/rtl/rtl_queue.h>
+#include "common/rtl_errno.h"
+#include "rtl865xc_swNic.h"
+
+/*common*/
+#include "common/rtl865x_vlan.h"
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl865x_netif_local.h"
+
+/*l2*/
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+#include "l2Driver/rtl865x_fdb.h"
+#include <net/rtl/rtl865x_fdb_api.h>
+#endif
+
+/*l3*/
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+#include "l3Driver/rtl865x_ip.h"
+#include "l3Driver/rtl865x_nexthop.h"
+#include <net/rtl/rtl865x_ppp.h>
+#include "l3Driver/rtl865x_ppp_local.h"
+#include "l3Driver/rtl865x_route.h"
+#include "l3Driver/rtl865x_arp.h"
+#include <net/rtl/rtl865x_nat.h>
+#endif
+
+#include <net/rtl/rtl_dot1x.h>
+
+static unsigned int old_link_port_mask=0;
+static unsigned int new_link_port_mask=0;
+rtl802Dot1xConfig dot1x_config;
+struct pid *_authapp_pid;
+pid_t       authapp_pid;
+rtl802Dot1xQueue dot1x_queue;
+CTAILQ_HEAD(dot1x_list_inuse_head, __rtl802Dot1xCacheEntry) dot1x_list_inuse;
+CTAILQ_HEAD(dot1x_list_free_head, __rtl802Dot1xCacheEntry) dot1x_list_free;
+
+struct __rtl802Dot1xCacheTable *table_dot1x;
+static int dot1x_table_list_max;
+
+
+
+extern int32 rtl865x_updateAuthState(int32 auth, const unsigned char *addr);
+unsigned int rtl865x_getPhysicalPortLinkStatus(void);
+
+#define rtl_82dot1xIsEmptyQueue(q) (q->item_num==0 ? 1:0)
+#define rtl_82dot1xIsFullQueue(q) (q->item_num==q->max_item? 1:0)
+#define rtl_82dot1xNumItemQueue(q) q->item_num
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,4,0)
+#define NETDRV_PRIV(X) netdev_priv(X)
+#else
+#define NETDRV_PRIV(X) ((X)->priv)
+#endif
+
+#if defined(CONFIG_RTL_PROC_NEW)
+extern struct proc_dir_entry proc_root;
+
+static int32 read_proc_8021x_type(struct seq_file *s, void *v);
+static int32 read_proc_8021x_enable(struct seq_file *s, void *v);
+static int32 read_proc_8021x_auth_port_mode(struct seq_file *s, void *v);
+static int32 read_proc_8021x_entry(struct seq_file *s, void *v);
+static int32 read_proc_8021x_auth_server_port(struct seq_file *s, void *v);
+
+static int32 write_proc_8021x_enable( struct file *filp, const char *buff,unsigned long len, void *data );
+static int32 write_proc_8021x_type( struct file *filp, const char *buff,unsigned long len, void *data );
+static int32 write_proc_8021x_auth_server_port( struct file *filp, const char *buff,unsigned long len, void *data );
+static int32 write_proc_8021x_auth_port_mode( struct file *filp, const char *buff,unsigned long len, void *data );
+
+
+int dot1x_enable_single_open(struct inode *inode, struct file *file)
+{
+		return(single_open(file, read_proc_8021x_enable, PDE_DATA(inode)));
+}
+static ssize_t dot1x_enable_single_write(struct file * file, const char __user * userbuf,
+		     size_t count, loff_t * off)
+{
+	    return write_proc_8021x_enable(file, userbuf,count, off);
+}
+struct file_operations dot1x_enable_proc_fops= {
+		.open           = dot1x_enable_single_open,
+		.write		    = dot1x_enable_single_write,
+		.read           = seq_read,
+		.llseek         = seq_lseek,
+		.release        = single_release,
+};
+
+int dot1x_type_single_open(struct inode *inode, struct file *file)
+{
+		return(single_open(file, read_proc_8021x_type, PDE_DATA(inode)));
+}
+static ssize_t dot1x_type_single_write(struct file * file, const char __user * userbuf,
+		     size_t count, loff_t * off)
+{
+	    return write_proc_8021x_type(file, userbuf,count, off);
+}
+struct file_operations dot1x_type_proc_fops= {
+		.open           = dot1x_type_single_open,
+		.write		    = dot1x_type_single_write,
+		.read           = seq_read,
+		.llseek         = seq_lseek,
+		.release        = single_release,
+};
+
+int dot1x_mode_single_open(struct inode *inode, struct file *file)
+{
+		return(single_open(file, read_proc_8021x_auth_port_mode, PDE_DATA(inode)));
+}
+static ssize_t dot1x_mode_single_write(struct file * file, const char __user * userbuf,
+		     size_t count, loff_t * off)
+{
+	    return write_proc_8021x_auth_port_mode(file, userbuf,count, off);
+}
+struct file_operations dot1x_mode_proc_fops= {
+		.open           = dot1x_mode_single_open,
+		.write		    = dot1x_mode_single_write,
+		.read           = seq_read,
+		.llseek         = seq_lseek,
+		.release        = single_release,
+};
+
+
+int dot1x_server_port_single_open(struct inode *inode, struct file *file)
+{
+		return(single_open(file, read_proc_8021x_auth_server_port, PDE_DATA(inode)));
+}
+static ssize_t dot1x_server_port_single_write(struct file * file, const char __user * userbuf,
+		     size_t count, loff_t * off)
+{
+	    return write_proc_8021x_auth_server_port(file, userbuf,count, off);
+}
+struct file_operations dot1x_server_port_proc_fops= {
+		.open           = dot1x_server_port_single_open,
+		.write		    = dot1x_server_port_single_write,
+		.read           = seq_read,
+		.llseek         = seq_lseek,
+		.release        = single_release,
+};
+
+int dot1x_entry_single_open(struct inode *inode, struct file *file)
+{
+		return(single_open(file, read_proc_8021x_entry, PDE_DATA(inode)));
+}
+struct file_operations dot1x_entry_proc_fops= {
+		.open           = dot1x_entry_single_open,
+		.write		    = NULL,
+		.read           = seq_read,
+		.llseek         = seq_lseek,
+		.release        = single_release,
+};
+
+#endif
+
+
+__IRAM_GEN inline static uint32
+rtl_82dot1xHashEntry(uint8 *mac_addr)
+{
+	register uint32 hash;
+
+	if (mac_addr == NULL)
+		return 0;
+
+	hash = mac_addr[0] | (mac_addr[1]<<8);
+	hash ^= (mac_addr[2] | (mac_addr[3]<<8));
+	hash ^= (mac_addr[4] | (mac_addr[5]<<8));
+
+	return (dot1x_table_list_max-1) & (hash ^ (hash >> 12));
+
+
+}
+
+int rtl_82dot1xAddEntry(uint8 *mac_addr,
+								uint32 id,
+								uint8  rx_port_num,
+							    uint8 auth_state)
+{
+	uint32 hash = 0;
+	rtl802Dot1xCacheEntry *ep;
+
+	if (mac_addr == NULL)
+		return FAILED;
+
+	hash = rtl_82dot1xHashEntry(mac_addr);
+
+	printk("%s %d: mac=0x%x:%x:%x:%x:%x:%x id=%u portnum=%d state=%d\n", __FUNCTION__, __LINE__, mac_addr[0], mac_addr[1], mac_addr[2], mac_addr[3], mac_addr[4], mac_addr[5], id, rx_port_num, auth_state);
+	/* Lookup */
+	CTAILQ_FOREACH(ep, &table_dot1x->list[hash], cache_link) {
+		if ((!memcmp(mac_addr, ep->mac_addr, ETH_ALEN))&&(ep->valid == DOT1X_TABLE_ENTRY_VALID)){
+			ep->id = id;
+			ep->rx_port_num = rx_port_num;
+			ep->auth_state = auth_state;
+			printk("already exist! \n");
+			return SUCCESS;
+		}
+	}
+
+	/* Create */
+	if(!CTAILQ_EMPTY(&dot1x_list_free)) {
+		rtl802Dot1xCacheEntry *entry;
+		entry = CTAILQ_FIRST(&dot1x_list_free);
+		entry->id = id;
+		memcpy(entry->mac_addr, mac_addr, ETH_ALEN);
+		entry->rx_port_num = rx_port_num;
+		entry->auth_state = auth_state;
+		entry->valid = DOT1X_TABLE_ENTRY_VALID;
+		CTAILQ_REMOVE(&dot1x_list_free, entry, tqe_link);
+		CTAILQ_INSERT_TAIL(&dot1x_list_inuse, entry, tqe_link);
+		CTAILQ_INSERT_TAIL(&table_dot1x->list[hash], entry, cache_link);
+	} else {
+		printk("add: ERROR - dot1x_list_free is empty! \n");
+		return FAILED;
+	}
+
+	return SUCCESS;
+}
+
+int rtl_82dot1xModifyEntryByMac(uint8 *mac_addr,
+											uint32 id,
+											uint8  rx_port_num,
+										    uint8 auth_state)
+{
+	uint32 hash = 0;
+	rtl802Dot1xCacheEntry *ep;
+	if (mac_addr == NULL)
+		return FAILED;
+
+	hash = rtl_82dot1xHashEntry(mac_addr);
+
+	printk("%s %d: mac=0x%x:%x:%x:%x:%x:%x id=%u portnum=%d state=%d\n", __FUNCTION__, __LINE__, mac_addr[0], mac_addr[1], mac_addr[2], mac_addr[3], mac_addr[4], mac_addr[5], id, rx_port_num, auth_state);
+	/* Lookup */
+	CTAILQ_FOREACH(ep, &table_dot1x->list[hash], cache_link) {
+		if ((!memcmp(mac_addr, ep->mac_addr, ETH_ALEN))&&(ep->valid == DOT1X_TABLE_ENTRY_VALID)){
+			ep->id = id;
+			ep->rx_port_num = rx_port_num;
+			ep->auth_state = auth_state;
+			return SUCCESS;
+		}
+	}
+
+	return SUCCESS;
+}
+
+static inline rtl802Dot1xCacheEntry *rtl_82dot1xFindEntryByMac(uint8 *mac_addr)
+{
+
+	uint32 hash = 0;
+	rtl802Dot1xCacheEntry *entry;
+	if (mac_addr == NULL)
+		return NULL;
+
+	hash = rtl_82dot1xHashEntry(mac_addr);
+
+	CTAILQ_FOREACH(entry, &table_dot1x->list[hash], cache_link)
+	{
+		if ((!memcmp(mac_addr, entry->mac_addr, ETH_ALEN))&&(entry->valid == DOT1X_TABLE_ENTRY_VALID))
+		{
+			return ((rtl802Dot1xCacheEntry *)entry);
+		}
+	}
+	return NULL;
+}
+
+static inline rtl802Dot1xCacheEntry *rtl_82dot1xFindEntryById(uint32 id)
+{
+	rtl802Dot1xCacheEntry *entry;
+
+	printk("%s %d: id=%u \n", __FUNCTION__, __LINE__, id);
+	CTAILQ_FOREACH(entry, &dot1x_list_inuse, cache_link)
+	{
+		if ((entry->id == id) && (entry->valid == DOT1X_TABLE_ENTRY_VALID))
+		{
+			return ((rtl802Dot1xCacheEntry *)entry);
+		}
+	}
+
+	return NULL;
+}
+
+int rtl_82dot1xModifyEntryById(uint32 id,
+									    uint8 auth_state,
+									    uint8 *mac_addr,
+									    uint8 *portnum)
+{
+	rtl802Dot1xCacheEntry *ep;
+
+	printk("%s %d: id=%u state=%d\n", __FUNCTION__, __LINE__, id, auth_state);
+	/* Lookup */
+	CTAILQ_FOREACH(ep, &dot1x_list_inuse, cache_link) {
+		if ((ep->id == id) && (ep->valid == DOT1X_TABLE_ENTRY_VALID)){
+			if (mac_addr != NULL)
+				memcpy(mac_addr, ep->mac_addr, ETH_ALEN);
+			*portnum = ep->rx_port_num;
+			ep->auth_state = auth_state;
+			return SUCCESS;
+		}
+	}
+
+	return FAILED;
+}
+
+
+
+int rtl_82dot1xdelEntryByMac(uint8 *mac_addr)
+{
+	uint32 hash = 0;
+	rtl802Dot1xCacheEntry *ep;
+
+	if (mac_addr == NULL)
+		return FAILED;
+
+	hash = rtl_82dot1xHashEntry(mac_addr);
+
+
+	printk("%s %d: mac=0x%x:%x:%x:%x:%x:%x \n", __FUNCTION__, __LINE__, mac_addr[0], mac_addr[1], mac_addr[2], mac_addr[3], mac_addr[4], mac_addr[5]);
+	/* Lookup */
+	CTAILQ_FOREACH(ep, &table_dot1x->list[hash], cache_link) {
+		if (!memcmp(mac_addr, ep->mac_addr, ETH_ALEN)){
+			ep->valid = DOT1X_TABLE_ENTRY_INVALID;
+			CTAILQ_REMOVE(&table_dot1x->list[hash], ep, cache_link);
+			CTAILQ_REMOVE(&dot1x_list_inuse, ep, tqe_link);
+			CTAILQ_INSERT_TAIL(&dot1x_list_free, ep, tqe_link);
+			return SUCCESS;
+		}
+	}
+
+	return FAILED;
+}
+
+int rtl_82dot1xdelEntryByPid(uint32 pid)
+{
+	rtl802Dot1xCacheEntry *ep;
+	uint32 hash = 0;
+	#if defined(DOT1X_DEBUG)
+	panic_printk("%s %d: pid=%d \n", __FUNCTION__, __LINE__, pid);
+	#endif
+	//if ((dot1x_config.mode[pid].auth_mode == DOT1X_AUTH_MODE_SNOOPING)&&
+		//(dot1x_config.mode[pid].port_enable))
+	{
+		/* Lookup snooping mode port down handle //other mode handle by auth daemon */
+		CTAILQ_FOREACH(ep, &dot1x_list_inuse, cache_link) {
+			if (ep->rx_port_num == pid) {
+				ep->valid = DOT1X_TABLE_ENTRY_INVALID;
+				hash = rtl_82dot1xHashEntry(ep->mac_addr);
+				CTAILQ_REMOVE(&table_dot1x->list[hash], ep, cache_link);
+				CTAILQ_REMOVE(&dot1x_list_inuse, ep, tqe_link);
+				CTAILQ_INSERT_TAIL(&dot1x_list_free, ep, tqe_link);
+				if (dot1x_config.type==DOT1X_AUTH_TYPE_MAC_BASED)
+				{
+					rtl865x_updateAuthState(0, ep->mac_addr);
+				}
+			}
+		}
+
+		if (dot1x_config.type==DOT1X_AUTH_TYPE_PORT_BASED)
+		{
+			rtl_802dot1xSetPortAuthState(pid, 0);
+		}
+	}
+
+	return SUCCESS;
+}
+
+
+
+void rtl_82dot1xInitQueue(rtl802Dot1xQueue *q)
+{
+	if (q == NULL)
+		return ;
+	memset(q, 0x00, sizeof(rtl802Dot1xQueue));
+
+	q->head = 0;
+	q->tail = 0;
+	q->item_num = 0;
+	q->max_item = DOT1X_MAX_QUEUE_SIZE;
+
+	return ;
+}
+
+int rtl_82dot1xEnQueue(unsigned long task_priv, rtl802Dot1xQueue *q, unsigned char *item, int item_size)
+{
+#if 0//def __KERNEL__
+	struct dev_priv	*priv = (struct dev_priv	*)task_priv;
+#endif
+	unsigned long flags;
+
+	if(rtl_82dot1xIsFullQueue(q))
+		return DOT1X_ERROR_QFULL;
+	if(item_size > DOT1X_MAX_DATA_LEN)
+		return DOT1X_ERROR_2LARGE;
+
+	//SAVE_INT_AND_CLI(flags);
+	local_irq_save(flags);
+	q->item_array[q->tail].item_size = item_size;
+	memset(q->item_array[q->tail].item, 0, sizeof(q->item_array[q->tail].item));
+	memcpy(q->item_array[q->tail].item, item, item_size);
+	q->item_num++;
+
+	if((q->tail+1) == DOT1X_MAX_QUEUE_SIZE)
+		q->tail = 0;
+	else
+		q->tail++;
+
+	//RESTORE_INT(flags);
+	local_irq_restore(flags);
+
+	return 0;
+}
+
+int rtl_82dot1xDeQueue(unsigned long task_priv, rtl802Dot1xQueue *q, unsigned char *item, int *itemsize)
+{
+#if 0//def __KERNEL__
+	struct dev_priv	*priv = (struct dev_priv	*)task_priv;
+#endif
+	unsigned long flags;
+	rtl802Dot1xEapPkt *pdata;
+
+
+	if ((q == NULL) || (item == NULL))
+		return DOT1X_ERROR_ERROR;
+
+	if(rtl_82dot1xIsEmptyQueue(q))
+		return DOT1X_ERROR_QEMPTY;
+
+	memset(item, 0x00, DOT1X_MAX_DATA_LEN);
+	//SAVE_INT_AND_CLI(flags);
+	local_irq_save(flags);
+	memcpy(item, &q->item_array[q->head].item, q->item_array[q->head].item_size);
+	q->item_num--;
+	pdata = (rtl802Dot1xEapPkt *)item;
+	pdata->flag = q->item_num;//update remain pkts number
+	*itemsize = q->item_array[q->head].item_size;
+
+	if((q->head+1) == DOT1X_MAX_QUEUE_SIZE)
+		q->head = 0;
+	else
+		q->head++;
+
+	//RESTORE_INT(flags);
+	local_irq_restore(flags);
+
+	return 0;
+}
+
+int32  rtl_802dot1xSetPortAuthState(int port_num, int auth_state)
+{
+	if (port_num > RTL8651_PORT_NUMBER || port_num < 0)
+		return FAILED;
+
+	if (auth_state)
+	{
+		WRITE_MEM32(DOT1XPORTCR, (READ_MEM32(DOT1XPORTCR)|(0x1<<((port_num*3) + 1))));
+	}
+	else
+	{
+		WRITE_MEM32(DOT1XPORTCR, (READ_MEM32(DOT1XPORTCR)&(~(0x1<<((port_num*3) + 1)))));
+	}
+
+	return 0;
+
+}
+
+int rtl_802dot1xIoctl(struct net_device *dev, struct ifreq *rq, int cmd)
+{
+	struct dev_priv	*priv = NETDRV_PRIV(dev);
+	//int32 rc = 0;
+	rtl802Dot1xAuthResult auth_result;
+	unsigned int *data;
+	uint32 args[4];
+	static uint8 queue_data[DOT1X_MAX_DATA_LEN+4];
+	int		queue_data_len;
+	uint32 *pdata;
+
+	data = (unsigned int *)rq->ifr_data;
+	if (copy_from_user(args, data, 4*sizeof(unsigned int)))
+	{
+		return -EFAULT;
+	}
+
+	switch (args[0])
+	{
+		case RTL8651_IOCTL_DOT1X_GET_INFO:
+			pdata = (uint32 *)args[3];
+			rtl_82dot1xDeQueue((unsigned long)priv, &dot1x_queue, queue_data, &queue_data_len);
+			if (copy_to_user((void *)pdata, (void *)queue_data, queue_data_len)) {
+				return -EFAULT;
+			}
+			break;
+		case RTL8651_IOCTL_DOT1X_SETPID:
+			authapp_pid = -1;
+			pdata = (uint32 *)args[1];
+			if (pdata != NULL)
+				authapp_pid = *pdata;
+			if (authapp_pid != -1)
+			{
+				rcu_read_lock();
+				_authapp_pid = get_pid(find_vpid(authapp_pid));
+				rcu_read_unlock();
+			}
+			#if defined(DOT1X_DEBUG)
+			panic_printk("%s %d authapp_pid=%d\n", __FUNCTION__, __LINE__, authapp_pid);
+			#endif
+			break;
+		case RTL8651_IOCTL_DOT1X_SET_AUTH_RESULT:
+			pdata = (uint32 *)args[1];
+			memset(&auth_result, 0x00, sizeof(rtl802Dot1xAuthResult));
+			if (copy_from_user((void *)&auth_result, (void *)pdata, sizeof(rtl802Dot1xAuthResult))) {
+				return -EFAULT;
+			}
+			//set to hw
+			#if defined(DOT1X_DEBUG)
+			panic_printk("%s %d args=0x%x portnum=%d state=%d type=%d mac:0x%x:%x:%x:%x:%x:%x\n",
+			__FUNCTION__, __LINE__, args[1], auth_result.port_num, auth_result.auth_state, auth_result.type,
+			auth_result.mac_addr[0], auth_result.mac_addr[1], auth_result.mac_addr[2], auth_result.mac_addr[3]
+			, auth_result.mac_addr[4], auth_result.mac_addr[5]);
+			#endif
+			if (auth_result.type == DOT1X_AUTH_TYPE_PORT_BASED)
+				rtl_802dot1xSetPortAuthState(auth_result.port_num, auth_result.auth_state);
+			else if (auth_result.type == DOT1X_AUTH_TYPE_MAC_BASED)
+				rtl865x_updateAuthState(auth_result.auth_state, auth_result.mac_addr);
+			break;
+		#if 0
+		case RTL8651_IOCTL_DOT1X_GET_PORT_STATE_INFO:
+			pdata = (uint32 *)args[1];
+			if (copy_to_user(pdata, (void *)&port_state, sizeof(rtl802Dot1xPortStateInfo))) {
+				return -EFAULT;
+			}
+			break;
+		#endif
+		 default:
+			return -EOPNOTSUPP;
+			break;
+	}
+	return SUCCESS;
+
+}
+
+void rtl_82dot1xEventInform(int event)
+{
+	#ifdef __KERNEL__
+	if (authapp_pid > 0)
+		//#ifdef LINUX_2_6_27_
+		#if LINUX_VERSION_CODE >= 0x02061B
+	{
+		kill_pid(_authapp_pid, SIGIO, event);
+	}
+		#else
+		kill_proc(authapp_pid, SIGIO, event);
+		#endif
+	#endif
+
+	return ;
+}
+
+void rtl_82dot1xCheckPortState(void)
+{
+	unsigned int port_num=0, ret = 0;
+	rtl802Dot1xPortStateInfo port_down_state;
+	rtl802Dot1xPortStateInfo port_up_state;
+	new_link_port_mask = rtl865x_getPhysicalPortLinkStatus();
+	//panic_printk("%s %d new_link_port_mask = 0x%x cur_link_port_mask=0x%x\n", __FUNCTION__, __LINE__, new_link_port_mask, old_link_port_mask);
+	if (new_link_port_mask != old_link_port_mask)
+	{
+
+		memset(&port_down_state, 0x00, sizeof(rtl802Dot1xPortStateInfo));
+		memset(&port_up_state, 0x00, sizeof(rtl802Dot1xPortStateInfo));
+		for(port_num = 0; port_num <= RTL8651_PHY_NUMBER; port_num++)
+		{
+
+			if ((((1<<port_num) & new_link_port_mask)==0)&&
+				(((1<<port_num) & old_link_port_mask)!=0))
+			{
+				//up->down , delete entry by pid
+
+				if ((dot1x_config.mode[port_num].auth_mode == DOT1X_AUTH_MODE_SNOOPING)&&
+					(dot1x_config.mode[port_num].port_enable))
+				{
+					rtl_82dot1xdelEntryByPid(port_num);
+				}
+				port_down_state.port_mask |= (1<<port_num);
+			}
+			else if((((1<<port_num) & new_link_port_mask)!= 0)&&
+				(((1<<port_num) & old_link_port_mask)==0)){
+				//down -->up
+				port_up_state.port_mask |= (1<<port_num);
+			}
+		}
+		if (port_down_state.port_mask != 0)
+		{
+
+			#if defined(DOT1X_DEBUG)
+			panic_printk("%s %d port_state.port_mask = 0x%x \n", __FUNCTION__, __LINE__, port_down_state.port_mask);
+			#endif
+			port_down_state.event_id = DOT1X_EVENT_PORT_DOWN;
+			ret = rtl_82dot1xEnQueue(0, &dot1x_queue,
+				(unsigned char*)&port_down_state, sizeof(rtl802Dot1xPortStateInfo));
+
+		}
+		if (port_up_state.port_mask != 0)
+		{
+
+			#if defined(DOT1X_DEBUG)
+			panic_printk("%s %d port_state.port_mask = 0x%x \n", __FUNCTION__, __LINE__, port_down_state.port_mask);
+			#endif
+			port_up_state.event_id = DOT1X_EVENT_PORT_UP;
+			ret = rtl_82dot1xEnQueue(0, &dot1x_queue,
+				(unsigned char*)&port_up_state, sizeof(rtl802Dot1xPortStateInfo));
+
+		}
+		if(port_up_state.port_mask != 0 || port_down_state.port_mask != 0){
+			if (ret == 0)
+			{
+				//tell auth daemon some port down.....
+				rtl_82dot1xEventInform(1);
+			}
+			else
+				printk("%s %d enqueue error ret = %d\n", __FUNCTION__, __LINE__, ret);
+		}
+	}
+	old_link_port_mask = new_link_port_mask;
+
+	return;
+}
+#if 0
+static int read_proc_8021x_l2_mac_entry(char *page, char **start, off_t off,
+		int count, int *eof, void *data)
+{
+	return 0;
+}
+static int write_proc_8021x_l2_mac_entry(struct file *file, const char *buffer,
+			  unsigned long count, void *data)
+{
+	return 0;
+}
+
+static int read_proc_8021x_mac_based_ctrl(char *page, char **start, off_t off,
+		int count, int *eof, void *data)
+{
+	return 0;
+}
+static int write_proc_8021x_mac_based_ctrl(struct file *file, const char *buffer,
+			  unsigned long count, void *data)
+{
+	return 0;
+}
+
+static int read_proc_8021x_port_based_ctrl(char *page, char **start, off_t off,
+		int count, int *eof, void *data)
+{
+	return 0;
+}
+static int write_proc_8021x_port_based_ctrl(struct file *file, const char *buffer,
+			  unsigned long count, void *data)
+{
+	/* usage: echo "portnum enable/disable auth/unauth direction" > /proc/802dot1x/rtl_8021x_port_based_ctrl
+		*           eg:port0 enable auth BOTH direction
+		*           echo "0 1 1 0" >/proc/802dot1x/rtl_8021x_port_based_ctrl
+		*/
+	int portnum = 0;
+	int enable = 0;
+	int auth = 0;
+	int direction = 0;
+	#define	MAX_802DOT1X_INPUT_LEN	128
+	char *tmp;
+
+	tmp = kmalloc(MAX_802DOT1X_INPUT_LEN, GFP_KERNEL);
+	if (count < 2 || tmp==NULL)
+		goto out;
+
+	if(rtl_802dot1x_enable_type != 1)
+		goto out;
+
+	if (buffer && !copy_from_user(tmp, buffer, MAX_802DOT1X_INPUT_LEN))
+	{
+			int num = sscanf(tmp, "%d %d %d %d",
+			&portnum, &enable,
+			&auth, &direction
+			);
+
+		if (num !=4)
+		{
+			printk("invalid 802dot1x portbased parameter!\n");
+			goto out;
+		}
+
+		//WRITE_MEM32(DOT1XPORTCR, REG32(REG32)|0x00);
+
+	}
+
+out:
+	if(tmp)
+		kfree(tmp);
+
+	return count;
+}
+#endif
+
+#if defined(CONFIG_RTL_PROC_NEW)
+static int32 read_proc_8021x_entry(struct seq_file *s, void *v)
+{
+	rtl802Dot1xCacheEntry *ep;
+
+	/* Lookup */
+	CTAILQ_FOREACH(ep, &dot1x_list_inuse, cache_link) {
+		if ((ep->valid == DOT1X_TABLE_ENTRY_VALID)){
+			seq_printf(s, "portnum:%d mac:0x%x:%x:%x:%x:%x:%x authstate:%d id:%d\n", ep->rx_port_num, ep->mac_addr[0],ep->mac_addr[1]
+				, ep->mac_addr[2],ep->mac_addr[3], ep->mac_addr[4],ep->mac_addr[5], ep->auth_state, ep->id);
+			}
+		}
+
+	return 0;
+}
+static int32 read_proc_8021x_auth_server_port(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s %d\n", "802dot1x server port:",dot1x_config.server_port);
+
+	return 0;
+}
+
+#else
+static int32 read_proc_8021x_entry( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int len = 0;
+
+	rtl802Dot1xCacheEntry *ep;
+
+	/* Lookup */
+	CTAILQ_FOREACH(ep, &dot1x_list_inuse, cache_link) {
+		if ((ep->valid == DOT1X_TABLE_ENTRY_VALID)){
+			len += sprintf(page+len, "portnum:%d mac:0x%x:%x:%x:%x:%x:%x authstate:%d id:%d\n", ep->rx_port_num, ep->mac_addr[0],ep->mac_addr[1]
+				, ep->mac_addr[2],ep->mac_addr[3], ep->mac_addr[4],ep->mac_addr[5], ep->auth_state, ep->id);
+			}
+		}
+	if (len <= off+count) *eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len>count)
+		len = count;
+	if (len<0)
+	  	len = 0;
+
+	return len;
+}
+
+static int32 read_proc_8021x_auth_server_port( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int len;
+	len = sprintf(page, "%s %d\n", "802dot1x server port:",dot1x_config.server_port);
+
+
+	if (len <= off+count) *eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len>count)
+		len = count;
+	if (len<0)
+	  	len = 0;
+
+	return len;
+}
+#endif
+static int32 write_proc_8021x_auth_server_port( struct file *filp, const char *buff,unsigned long len, void *data )
+{
+	char 		tmpbuf[32];
+	int num;
+	int32 port;
+
+
+	if(!dot1x_config.enable)
+	{
+		printk("rtl ethernet 8021x support not enabled!!!\n");
+		return len;
+	}
+
+	if (buff && !copy_from_user(tmpbuf, buff, len))
+	{
+
+		num = sscanf(tmpbuf,"%d",&port);
+
+		if((num != 1) ||(port > RTL8651_PORT_NUMBER || port < 0))
+		{
+			printk("rtl ethernet 8021x set server port parameter error!!\n");
+			return len;
+		}
+
+		dot1x_config.server_port = port;
+
+	}
+
+	return len;
+}
+
+#if defined(CONFIG_RTL_PROC_NEW)
+static int32 read_proc_8021x_auth_port_mode(struct seq_file *s, void *v)
+{
+	int i = 0;
+
+	seq_printf(s, "%s\n", "port config:");
+
+	for (i = 0; i < RTL8651_PORT_NUMBER; i++)
+	{
+		seq_printf(s, "%s %d %s %d %s %d %s %d\n",
+			"mode:",dot1x_config.mode[i].auth_mode, "portnum:", i, "enable:", dot1x_config.mode[i].port_enable,
+			"dir", dot1x_config.mode[i].auth_dir);
+	}
+
+	return 0;
+}
+#else
+static int32 read_proc_8021x_auth_port_mode( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int len, i;
+
+	len = sprintf(page, "%s\n", "port config:");
+	for (i = 0; i < RTL8651_PORT_NUMBER; i++)
+	{
+		len += sprintf(page+len, "%s %d %s %d %s %d %s %d\n",
+			"mode:",dot1x_config.mode[i].auth_mode, "portnum:", i, "enable:", dot1x_config.mode[i].port_enable,
+			"dir", dot1x_config.mode[i].auth_dir);
+	}
+
+
+	if (len <= off+count) *eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len>count)
+		len = count;
+	if (len<0)
+	  	len = 0;
+
+	return len;
+}
+#endif
+static int32 write_proc_8021x_auth_port_mode( struct file *filp, const char *buff,unsigned long len, void *data )
+{
+	char 		tmpbuf[32];
+	int mode, portnum, enable, num, dir;
+
+	if(!dot1x_config.enable)
+	{
+		printk("rtl ethernet 8021x support not enabled!!!\n");
+		return len;
+	}
+
+	if (buff && !copy_from_user(tmpbuf, buff, len))
+	{
+
+		num=sscanf(tmpbuf,"%d %d %d %d",&enable, &portnum, &mode, &dir);
+
+		if(num!=4){
+			printk("set 801dot1x mode parameter error !!!\n");
+			return len;
+		}
+		if (portnum > RTL8651_PORT_NUMBER || portnum < 0)
+		{
+			printk("set 801dot1x mode portnum invalid!!!\n");
+			return len;
+		}
+		if (mode > 3 || mode < 1)
+		{
+			printk("set 801dot1x mode mode invalid!!!\n");
+			return len;
+		}
+
+		dot1x_config.mode[portnum].auth_mode = mode & 0xff;
+		dot1x_config.mode[portnum].port_enable = enable & 0xff;
+		dot1x_config.mode[portnum].auth_dir = dir & 0xff;
+
+		//should set dot1xConfig.type first
+		if ((mode == DOT1X_AUTH_MODE_SNOOPING) || (mode == DOT1X_AUTH_MODE_PROXY))
+		{
+			if (dot1x_config.type == DOT1X_AUTH_TYPE_PORT_BASED)
+			{
+				rtl_enablePortbase802dot1x(enable, portnum);
+				rtl_setPortbase802dot1xDir(dir, portnum);
+			}
+			else if (dot1x_config.type == DOT1X_AUTH_TYPE_MAC_BASED)
+			{
+				rtl_enableMacbase802dot1x(enable, portnum);
+				rtl_setMacbase802dot1xDir(dir, portnum);
+			}
+		}
+		else if (mode == DOT1X_AUTH_MODE_CLIENT)
+		{
+			//donot need set register, clear....portbase/mac base
+			if (dot1x_config.type == DOT1X_AUTH_TYPE_PORT_BASED)
+			{
+				rtl_enablePortbase802dot1x(0, portnum);
+			}
+			else if (dot1x_config.type == DOT1X_AUTH_TYPE_MAC_BASED)
+			{
+				rtl_enableMacbase802dot1x(0, portnum);
+			}
+		}
+		else
+		{
+			printk("current support: 1/2/3\n");
+			return len;
+		}
+
+
+	}
+	return len;
+}
+#if defined(CONFIG_RTL_PROC_NEW)
+static int32 read_proc_8021x_type(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s %d\n", "802dot1x auth type:",dot1x_config.type);
+
+	return 0;
+}
+
+static int32 read_proc_8021x_enable(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s %d %s %d\n", "802dot1x enable:",dot1x_config.enable, "unicast response enable", dot1x_config.enable_unicastresp);
+
+	return 0;
+}
+
+#else
+static int32 read_proc_8021x_type( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int len;
+	len = sprintf(page, "%s %d\n", "802dot1x auth type:",dot1x_config.type);
+
+
+	if (len <= off+count) *eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len>count)
+		len = count;
+	if (len<0)
+	  	len = 0;
+
+	return len;
+}
+
+static int32 read_proc_8021x_enable( char *page, char **start, off_t off, int count, int *eof, void *data )
+{
+	int len;
+	len = sprintf(page, "%s %d %s %d\n", "802dot1x enable:",dot1x_config.enable, "unicast response enable", dot1x_config.enable_unicastresp);
+
+
+	if (len <= off+count) *eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len>count)
+		len = count;
+	if (len<0)
+	  	len = 0;
+
+	return len;
+}
+#endif
+int32  rtl_disable802dot1x(void)
+{
+	/* clear hw register */
+	WRITE_MEM32(DOT1XPORTCR, 0x00);
+	WRITE_MEM32(DOT1XMACCR, 0x00);
+	WRITE_MEM32(GVGCR, 0x00);
+	WRITE_MEM32(RMACR, (READ_MEM32(RMACR)&(~MADDR03)));
+
+	/* reinit l2 table?? */
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+	rtl865x_layer2_reinit();
+#endif
+
+	//memset(&dot1xPortBasedInfo, 0x00, RTL8651_PORT_NUMBER*sizeof(rtl802Dot1xPortBasedInfo));
+
+#if 0//test8021x
+#if 1//enable port based
+	WRITE_MEM32(DOT1XPORTCR, 0x25b); //port0/port1 authorized,port2/port3 unauthorized
+	WRITE_MEM32(GVGCR, 1<<12);//trap unauthenticated frame to CPU
+#else//enable mac based
+	//bind authenticated host (macaddr:0x00:21:70:9d:a9:2f) to a specified port3
+	WRITE_MEM32(DOT1XMACCR, 0xf); //port0/port1/port2/port3 enable mac based
+	WRITE_MEM32(GVGCR, 1<<12);//trap unauthenticated frame to CPU
+#endif
+#endif
+
+	return 0;
+
+}
+
+#if 0
+static void rtl_802dot1x_portbase_timeout(unsigned long arg)
+{
+	rtl802Dot1xPortBasedInfo *entry = (rtl802Dot1xPortBasedInfo *)arg;
+	/* if a client from the beginning (send out EAPOL-Start) to timeout still in state of DOT1X_AUTH_STATE_START
+		* will regard as  un-authentication, clear related info wait for another EAPOL-Start
+		*/
+	if (entry->authState == DOT1X_AUTH_STATE_START)
+	{
+		entry->authState = DOT1X_AUTH_STATE_INACTIVE;
+		entry->portNum = -1;
+		memset(entry->macaddr, 0x00, ETH_ALEN);
+	}
+	mod_timer(&entry->expire_timer, jiffies + DOT1X_AUTH_TIME_OUT);
+
+	return;
+}
+#endif
+int32  rtl_enablePortbase802dot1x(int32 enable, int32 portnum)
+{
+
+	if (portnum > RTL8651_PORT_NUMBER || portnum < 0)
+	{
+		printk("%s %d port number invalid\n", __FUNCTION__, __LINE__);
+		return FAILED;
+	}
+
+	/* enable/disable  Port-based Access Control */
+	if (enable)
+	    WRITE_MEM32(DOT1XPORTCR, (READ_MEM32(DOT1XPORTCR)|(0x1<<(portnum*3))));
+	else
+	    WRITE_MEM32(DOT1XPORTCR, (READ_MEM32(DOT1XPORTCR)&(~(0x1<<(portnum*3)))));
+
+	return 0;
+
+}
+
+int32  rtl_enableMacbase802dot1x(int32 enable, int32 portnum)
+{
+
+	if (portnum > RTL8651_PORT_NUMBER || portnum < 0)
+	{
+		printk("%s %d port number invalid\n", __FUNCTION__, __LINE__);
+		return FAILED;
+	}
+
+	/* enable/disable MAC Address Based Control on each port  */
+	if (enable)
+	    WRITE_MEM32(DOT1XMACCR, (READ_MEM32(DOT1XMACCR)|(0x1<<portnum)));
+	else
+	    WRITE_MEM32(DOT1XMACCR, (READ_MEM32(DOT1XMACCR)&(~(0x1<<portnum))));
+
+	return 0;
+
+}
+
+int32  rtl_setPortbase802dot1xDir(int32 value, int32 portnum)
+{
+
+	if (portnum > RTL8651_PORT_NUMBER || portnum < 0)
+	{
+		printk("%s %d port number invalid\n", __FUNCTION__, __LINE__);
+		return FAILED;
+	}
+
+	if (dot1x_config.enable_unicastresp)
+	{
+		/*
+		  *If enable authenticator response EAP packet's destination MAC address as unicast, auth direction 's value must be 1(IN direction only) ,
+		  *otherwise, cannot send unicast packets out in unauthorized port or MAC address.
+		  */
+		WRITE_MEM32(DOT1XPORTCR, (READ_MEM32(DOT1XPORTCR)|(0x1<<((portnum*3) +2))));
+	}
+	else
+	{
+		if (value)
+			WRITE_MEM32(DOT1XPORTCR, (READ_MEM32(DOT1XPORTCR)|(0x1<<((portnum*3) +2))));
+		else
+			WRITE_MEM32(DOT1XPORTCR, (READ_MEM32(DOT1XPORTCR)&(~(0x1<<((portnum*3)+2)))));
+	}
+
+	return 0;
+
+}
+
+int32  rtl_setMacbase802dot1xDir(int32 value, int32 portnum)
+{
+	#if 0
+	if (portnum > RTL8651_PORT_NUMBER || portnum < 0)
+	{
+		printk("%s %d port number invalid\n", __FUNCTION__, __LINE__);
+		return FAILED;
+	}
+	#endif
+
+	if (dot1x_config.enable_unicastresp)
+	{
+		/* if enable authenticater respones eap packets dmac as unicast, auth_dir's value must be 1(IN direction only)
+		  * otherwise cannot send unicast packets out in unauth port/mac
+		  */
+		WRITE_MEM32(DOT1XMACCR, (READ_MEM32(DOT1XMACCR)|(Dot1xMAC_OPDIR)));
+	}
+	else
+	{
+		if (value)
+			WRITE_MEM32(DOT1XMACCR, (READ_MEM32(DOT1XMACCR)|(Dot1xMAC_OPDIR)));
+		else
+			WRITE_MEM32(DOT1XMACCR, (READ_MEM32(DOT1XMACCR)&~(Dot1xMAC_OPDIR)));
+	}
+
+	return 0;
+
+}
+
+void  rtl_trapDot1xFrameToCpu(int enabletrap)
+{
+
+	/* disable/enable trap 802dot1x frame to cpu */
+	if (enabletrap)
+		WRITE_MEM32(RMACR, (READ_MEM32(RMACR)|MADDR03));
+	else
+		WRITE_MEM32(RMACR, (READ_MEM32(RMACR)&(~MADDR03)));
+
+	return;
+
+}
+
+#if 0
+int32  enable_portbase_802dot1x(void)
+{
+	int i;
+
+	/* clear related register */
+	WRITE_MEM32(DOT1XPORTCR, 0x00);
+	WRITE_MEM32(DOT1XMACCR, 0x00);
+	WRITE_MEM32(GVGCR, 0x00);
+	/* reinit l2 table?? */
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+	rtl865x_layer2_reinit();
+#endif
+	memset(&dot1xPortBasedInfo, 0x00, RTL8651_PORT_NUMBER*sizeof(rtl802Dot1xPortBasedInfo));
+
+	/* enable each Port-based Access Control and in a state of  unauthorized */
+	for(i = 0; i < RTL8651_PORT_NUMBER; i++)
+	{
+		WRITE_MEM32(DOT1XPORTCR, (READ_MEM32(DOT1XPORTCR)|(0x1<<(i*3))));
+		dot1xPortBasedInfo[i].portAuthEnable = 1;
+		init_timer(&dot1xPortBasedInfo[i].expire_timer);
+		dot1xPortBasedInfo[i].expire_timer.data = (unsigned long)&dot1xPortBasedInfo[i];
+		dot1xPortBasedInfo[i].expire_timer.function = rtl_802dot1x_portbase_timeout;		/* expire function	*/
+		dot1xPortBasedInfo[i].expire_timer.expires = jiffies + DOT1X_AUTH_TIME_OUT;
+		add_timer(&dot1xPortBasedInfo[i].expire_timer);
+
+	}
+	/* only trap 802dot1x frame to cpu */
+	WRITE_MEM32(RMACR, (READ_MEM32(RMACR)|MADDR03));
+
+	return 0;
+
+}
+
+int32  enable_macbase_802dot1x(void)
+{
+
+	int i;
+
+	/* clear hw register */
+	WRITE_MEM32(DOT1XPORTCR, 0x00);
+	WRITE_MEM32(DOT1XMACCR, 0x00);
+	WRITE_MEM32(GVGCR, 0x00);
+	/* reinit l2 table?? */
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+	rtl865x_layer2_reinit();
+#endif
+
+	/* enable MAC Address Based Control on each port and all mac addresses in a state of unauthorized */
+	for(i = 0; i < 5; i++)
+	{
+		WRITE_MEM32(DOT1XMACCR, (READ_MEM32(DOT1XMACCR)|(0x1<<i)));
+	}
+	/* only trap 802dot1x frame to cpu */
+	WRITE_MEM32(RMACR, (READ_MEM32(RMACR)|MADDR03));
+
+	return 0;
+
+}
+#endif
+
+static int32 write_proc_8021x_type( struct file *filp, const char *buff,unsigned long len, void *data )
+{
+	char 		tmpbuf[32];
+
+	if (buff && !copy_from_user(tmpbuf, buff, len))
+	{
+		tmpbuf[len] = '\0';
+		if(tmpbuf[0] == '1')
+		{
+		    /* enable port-based 802dot1x */
+			dot1x_config.type = DOT1X_AUTH_TYPE_PORT_BASED;
+			//enable_portbase_802dot1x();
+
+		}
+		else if(tmpbuf[0] == '2')
+		{
+			/* enable mac-based 802dot1x  */
+			dot1x_config.type = DOT1X_AUTH_TYPE_MAC_BASED;
+			//enable_macbase_802dot1x();
+		}
+		else
+		{
+			printk("current support: 1/2\n");
+			return len;
+		}
+
+
+	}
+	return len;
+}
+
+static int32 write_proc_8021x_enable( struct file *filp, const char *buff,unsigned long len, void *data )
+{
+	char 		tmpbuf[32];
+	int num, enable_1x, enable_unicast;
+
+	if (buff && !copy_from_user(tmpbuf, buff, len))
+	{
+
+		num=sscanf(tmpbuf,"%d %d",&enable_1x, &enable_unicast);
+
+		if(num!=2){
+			printk("set 801dot1x enable parameter error !!!\n");
+			return len;
+		}
+		dot1x_config.enable_unicastresp = enable_unicast & 0xff;
+
+		if (enable_1x == 1)
+		{
+			dot1x_config.enable = 1;
+			rtl_trapDot1xFrameToCpu(1);
+		}
+		else if (!enable_1x)
+		{
+			dot1x_config.enable = 0;
+			rtl_disable802dot1x();
+			rtl_trapDot1xFrameToCpu(0);
+		}
+		else
+		{
+			printk("current support: 0/1\n");
+			return len;
+		}
+		#if 0
+		tmpbuf[len] = '\0';
+		if(tmpbuf[0] == '0')
+		{
+			dot1x_config.enable = 0;
+			rtl_disable802dot1x();
+			rtl_trapDot1xFrameToCpu(0);
+		}
+		else if(tmpbuf[0] == '1')
+		{
+			dot1x_config.enable = 1;
+			rtl_trapDot1xFrameToCpu(1);
+		}
+		else
+		{
+			printk("current support: 0/1\n");
+			return len;
+		}
+		#endif
+
+
+	}
+	return len;
+}
+
+int rtl_initDot1xtable(int dot1x_tbl_list_max, int dot1x_tbl_entry_max)
+{
+	int i;
+
+	table_dot1x = (rtl802Dot1xCacheTable *)kmalloc(sizeof(rtl802Dot1xCacheTable), GFP_ATOMIC);
+	if (table_dot1x == NULL) {
+		printk("MALLOC Failed! (dot1x Table) \n");
+		return -1;
+	}
+	CTAILQ_INIT(&dot1x_list_inuse);
+	CTAILQ_INIT(&dot1x_list_free);
+
+	dot1x_table_list_max=dot1x_tbl_list_max;
+	table_dot1x->list=(struct __rtl802Dot1xCacheListEntryHead *)kmalloc(dot1x_tbl_list_max*sizeof(struct __rtl802Dot1xCacheListEntryHead), GFP_ATOMIC);
+	if (table_dot1x->list == NULL) {
+		printk("MALLOC Failed! (dot1x Table list) \n");
+		return -1;
+	}
+	for (i=0; i<dot1x_tbl_list_max; i++) {
+		CTAILQ_INIT(&table_dot1x->list[i]);
+	}
+
+	/* entry -List Init */
+	for (i=0; i<dot1x_tbl_entry_max; i++) {
+		rtl802Dot1xCacheEntry *entry = (rtl802Dot1xCacheEntry *)kmalloc(sizeof(rtl802Dot1xCacheEntry), GFP_ATOMIC);
+		if (entry == NULL) {
+			printk("MALLOC Failed! (dot1x Table Entry) \n");
+			return -2;
+		}
+		CTAILQ_INSERT_TAIL(&dot1x_list_free, entry, tqe_link);
+	}
+
+	return 0;
+}
+
+int rtl_init802dot1x(void)
+{
+	struct proc_dir_entry *root_8021x;
+	#ifndef CONFIG_RTL_PROC_NEW
+	struct proc_dir_entry *res_stats;
+	#endif
+	int ret;
+
+	memset(&dot1x_config, 0x00, sizeof(rtl802Dot1xConfig)); //clear sw
+	/* init queue */
+	rtl_82dot1xInitQueue(&dot1x_queue);
+	rtl_disable802dot1x();//clear hw
+
+
+	/* dot1x Table Init */
+	ret=rtl_initDot1xtable(DOT1X_TABLE_LIST_MAX,DOT1X_TABLE_ENTRY_MAX);
+	if(ret!=0) {
+		printk("rtl_initDot1xtable Failed!\n");
+	}
+
+#if defined(CONFIG_RTL_PROC_NEW)
+	root_8021x = proc_mkdir("802dot1x", &proc_root);
+#else
+	root_8021x = proc_mkdir("802dot1x", NULL);
+#endif
+	if (root_8021x == NULL)
+	{
+		printk("proc_mkdir 8021x failed!\n");
+	}
+
+#if defined(CONFIG_RTL_PROC_NEW)
+	proc_create_data("enable",0644,root_8021x,&dot1x_enable_proc_fops,NULL);
+
+	proc_create_data("type",0644,root_8021x,&dot1x_type_proc_fops,NULL);
+
+	proc_create_data("mode",0644,root_8021x,&dot1x_mode_proc_fops,NULL);
+
+	proc_create_data("server_port",0644,root_8021x,&dot1x_server_port_proc_fops,NULL);
+
+	proc_create_data("entry",0644,root_8021x,&dot1x_entry_proc_fops,NULL);
+
+#else
+	if ((res_stats = create_proc_read_entry("enable", 0644, root_8021x,
+		read_proc_8021x_enable, NULL)) == NULL)
+	{
+		printk("create_proc_read_entry failed!\n");
+	}
+	res_stats->write_proc = write_proc_8021x_enable;
+
+	if ((res_stats = create_proc_read_entry("type", 0644, root_8021x,
+		read_proc_8021x_type, NULL)) == NULL)
+	{
+		printk("create_proc_read_entry failed!\n");
+	}
+	res_stats->write_proc = write_proc_8021x_type;
+
+	if ((res_stats = create_proc_read_entry("mode", 0644, root_8021x,
+		read_proc_8021x_auth_port_mode, NULL)) == NULL)
+	{
+		printk("create_proc_read_entry failed!\n");
+	}
+	res_stats->write_proc = write_proc_8021x_auth_port_mode;
+
+
+	if ((res_stats = create_proc_read_entry("server_port", 0644, root_8021x,
+		read_proc_8021x_auth_server_port, NULL)) == NULL)
+	{
+		printk("create_proc_read_entry failed!\n");
+	}
+	res_stats->write_proc = write_proc_8021x_auth_server_port;
+	#if 1
+	if ((res_stats = create_proc_read_entry("entry", 0644, root_8021x,
+		read_proc_8021x_entry, NULL)) == NULL)
+	{
+		printk("create_proc_read_entry failed!\n");
+	}
+	#endif
+#endif
+	#if 0
+	if ((res_stats = create_proc_read_entry("rtl_8021x_port_based_ctrl", 0644, root_8021x,
+		read_proc_8021x_port_based_ctrl, NULL)) == NULL)
+	{
+		printk("create_proc_read_entry failed!\n");
+	}
+	res_stats->write_proc = write_proc_8021x_port_based_ctrl;
+
+
+	if ((res_stats = create_proc_read_entry("rtl_8021x_mac_based_ctrl", 0644, root_8021x,
+		read_proc_8021x_mac_based_ctrl, NULL)) == NULL)
+	{
+		printk("create_proc_read_entry failed!\n");
+	}
+	res_stats->write_proc = write_proc_8021x_mac_based_ctrl;
+
+
+	if ((res_stats = create_proc_read_entry("rtl_8021x_l2_mac_entry", 0644, root_8021x,
+		read_proc_8021x_l2_mac_entry, NULL)) == NULL)
+	{
+		printk("create_proc_read_entry failed!\n");
+	}
+	res_stats->write_proc = write_proc_8021x_l2_mac_entry;
+	#endif
+
+	return 0;
+}
+
+int rtl_is802dot1xFrame(uint8 *macFrame)
+{
+
+	uint8 *ptr;
+
+	ptr = macFrame + 12;
+	if((*(int16 *)(ptr)) == (int16)htons(ETH_P_8021Q))
+	{
+	    /* skip vlan header */
+		ptr=ptr+4;
+	}
+
+	/* is 802dot1x frame? */
+	if((*(int16 *)(ptr)) == (int16)htons(ETH_P_PAE))
+	{
+		return 1;
+	}
+	else
+	{
+		return 0;
+	}
+
+}
+
+inline int rtl_parse802dot1xFrame(uint8 *macFrame, uint32 *id)
+{
+
+	uint8 *ptr, *ptype, *pcode, *pid;
+
+	ptr = macFrame + 12;
+	if((*(int16 *)(ptr)) == (int16)htons(ETH_P_8021Q))
+	{
+	    /* skip vlan header */
+		ptr=ptr+4;
+	}
+
+	/* is 802dot1x frame? */
+	if((*(int16 *)(ptr)) == (int16)htons(ETH_P_PAE))
+	{
+	    ptype = ptr + DOT1X_EAPOL_PACKET_TYPE_OFFSET;//skip protocol version
+	    if (*ptype == DOT1X_EAPOL_TYPE_START)
+		{
+			return DOT1X_EAPOL_TYPE_START;
+		}
+		else if (*ptype == DOT1X_EAPOL_TYPE_LOGOFF)
+		{
+			return DOT1X_EAPOL_TYPE_LOGOFF;
+		}
+		else if (*ptype == DOT1X_EAPOL_TYPE_EAP_PACKET)
+		{
+			pcode = ptr + DOT1X_EAPOL_PACKET_CODE_OFFSET;
+			pid = ptr + DOT1X_EAPOL_PACKET_ID_OFFSET;
+			*id = *pid;
+			if (*pcode == DOT1X_EAPOL_PACKET_CODE_REQUEST)
+			{
+				return DOT1X_EAPOL_TYPE_EAP_REQUEST;
+			}
+			else if (*pcode == DOT1X_EAPOL_PACKET_CODE_RESPONSE)
+			{
+				return DOT1X_EAPOL_TYPE_EAP_RESPONSE;
+			}
+			else if (*pcode == DOT1X_EAPOL_PACKET_CODE_SUCCESS)
+			{
+				return DOT1X_EAPOL_TYPE_EAP_SUCCESS;
+			}
+			else if (*pcode == DOT1X_EAPOL_PACKET_CODE_FAILURE)
+			{
+				return DOT1X_EAPOL_TYPE_EAP_FAILURE;
+			}
+		}
+
+	}
+
+	return FAILED;
+
+
+}
+#if 0
+inline int rtl_82dot1xFindPortNumByMac(uint8 *mac)
+{
+	int i;
+
+	if (mac == NULL)
+		return FAILED;
+
+	for (i = 0; i < RTL8651_PORT_NUMBER; i++)
+	{
+	   if (!memcmp(dot1xPortBasedInfo[i].macaddr, mac, ETH_ALEN))
+		   return dot1xPortBasedInfo[i].portNum;
+	}
+
+	return FAILED;
+
+}
+#endif
+
+static inline void rtl_802dot1xRelayTrapped(struct sk_buff *skb,rtl_nicRx_info *info, uint32 id)
+{
+	rtl_nicTx_info  nic_tx;
+	int vid=info->vid;
+	int pid=info->pid;
+	uint32 forward_portmsk = (~(1<<pid)) & ((1<<RTL8651_MAC_NUMBER)-1) ;
+	rtl802Dot1xCacheEntry *entry;
+
+	//unicast relay
+	if((skb->data[0] &0x01) ==0)
+	{
+		rtl_hwLookup_txInfo(&nic_tx);
+	}
+	else//multicast/broadcast relay
+	{
+		if (pid != dot1x_config.server_port)
+		{
+			//rx from client,tx to server port msk
+			rtl_direct_txInfo((1<<dot1x_config.server_port), &nic_tx);
+			#if defined(DOT1X_DEBUG)
+			panic_printk("%s %d forward_portmsk=0x%x (1<<dot1x_config.server_port)=0x%x pid=%d id=%u\n", __FUNCTION__, __LINE__, forward_portmsk, (1<<dot1x_config.server_port),pid, id);
+			#endif
+		}
+		else
+		{
+			#if 0
+			//rx from server,flooding to client
+			rtl_direct_txInfo(forward_portmsk, &nic_tx);
+			panic_printk("%s %d forward_portmsk=0x%x (1<<dot1x_config.server_port)=0x%x pid=%d\n", __FUNCTION__, __LINE__, forward_portmsk, (1<<dot1x_config.server_port),pid);
+			#else
+			//rx from server,tx to related port
+			entry = rtl_82dot1xFindEntryById(id-1);
+			if (entry)
+			{
+				//normal case .....???????
+				forward_portmsk = (1<<entry->rx_port_num);
+				#if defined(DOT1X_DEBUG)
+				panic_printk("%s %d entry->rx_port_num=%d pid=%d id=%u\n", __FUNCTION__, __LINE__, entry->rx_port_num,pid, id);
+				#endif
+			}
+			rtl_direct_txInfo(forward_portmsk, &nic_tx);
+			#if defined(DOT1X_DEBUG)
+			panic_printk("%s %d forward_portmsk=0x%x (1<<dot1x_config.server_port)=0x%x pid=%d id=%u\n", __FUNCTION__, __LINE__, forward_portmsk, (1<<dot1x_config.server_port),pid, id);
+			#endif
+			#endif
+		}
+	}
+
+	/////vlan process????
+   if(skb!=NULL)
+   {
+		nic_tx.txIdx=0;
+
+
+		nic_tx.vid = vid;
+		//nicTx.srcExtPort = 0;
+		//nicTx.flags = (PKTHDR_USED|PKT_OUTGOING);
+
+
+		_dma_cache_wback_inv((unsigned long)skb->data, skb->len);
+		//panic_printk("%s %d vid=%d srcmac=0x%x:%x:%x:%x:%x:%x forward_portmsk=0x%x\n", __FUNCTION__, __LINE__,vid,
+			//skb->data[6], skb->data[7], skb->data[8],skb->data[9], skb->data[10], skb->data[11], forward_portmsk);
+		if (RTL_swNic_send((void *)skb, skb->data, skb->len, &nic_tx) < 0)
+		{
+			printk("%s %d nic send error!!!!\n", __FUNCTION__, __LINE__);
+			dev_kfree_skb_any(skb);
+		}
+
+	}
+	return;
+}
+
+
+int  rtl_802dot1xSnoopingModeRxHandle(struct sk_buff *skb,rtl_nicRx_info *info)
+{
+	int pid=info->pid;
+	int pkttype = -1;
+	uint32 id = 0;
+	uint8 supplicant_mac[ETH_ALEN] = {0};
+	uint8 portnum = 0;
+
+	#if 0
+	if ((pid != dot1x_config.server_port) && (!dot1x_config.mode[pid].port_enable))
+		return SUCCESS;
+	#endif
+
+	pkttype = rtl_parse802dot1xFrame(skb->data, &id);
+	#if defined(DOT1X_DEBUG)
+	panic_printk("%s %d pkttype=%d pid=%d id=%d srcmac=0x%x:%x:%x:%x:%x:%x\n", __FUNCTION__, __LINE__, pkttype, pid, id,
+		skb->data[6], skb->data[7], skb->data[8],skb->data[9], skb->data[10], skb->data[11]);
+	#endif
+	if (pkttype == FAILED)
+		return FAILED;
+
+	if ((pkttype == DOT1X_EAPOL_TYPE_START) || (pkttype == DOT1X_EAPOL_TYPE_EAP_RESPONSE))
+	{
+		//add supplicant's mac to cache
+		if (rtl_82dot1xAddEntry(&skb->data[ETH_ALEN], id, pid, DOT1X_AUTH_STATE_START)!=SUCCESS)
+		{
+			#if defined(DOT1X_DEBUG)
+			panic_printk("%s %d rtl_82dot1xAddEntry error!!!\n", __FUNCTION__, __LINE__);
+			#endif
+		}
+	}
+	else if ((pkttype == DOT1X_EAPOL_TYPE_EAP_SUCCESS)&&
+		    (dot1x_config.server_port == pid))
+	{
+		//rx from server port and authentication success
+		if (rtl_82dot1xModifyEntryById(id, DOT1X_AUTH_STATE_SUCCESS,supplicant_mac,&portnum)==SUCCESS)
+		{
+			if (dot1x_config.type == DOT1X_AUTH_TYPE_PORT_BASED)
+			{
+				rtl_802dot1xSetPortAuthState(portnum, 1);
+			}
+			else if (dot1x_config.type == DOT1X_AUTH_TYPE_MAC_BASED)
+			{
+	            rtl865x_updateAuthState(1, supplicant_mac);
+			}
+		}
+		else
+			printk("%s %d rtl_82dot1xModifyEntryById error!!!\n", __FUNCTION__, __LINE__);
+	}
+	else if (pkttype == DOT1X_EAPOL_TYPE_LOGOFF)
+	{
+		if (rtl_82dot1xdelEntryByMac(&skb->data[ETH_ALEN]) == SUCCESS)
+		{
+
+			if (dot1x_config.type == DOT1X_AUTH_TYPE_PORT_BASED)
+			{
+				rtl_802dot1xSetPortAuthState(portnum, 0);
+			}
+			else if (dot1x_config.type == DOT1X_AUTH_TYPE_MAC_BASED)
+			{
+	            rtl865x_updateAuthState(0, supplicant_mac);
+			}
+		}
+		else
+			printk("%s %d rtl_82dot1xdelEntryByMac error!!!\n", __FUNCTION__, __LINE__);
+	}
+	#if 0
+	else if ((dot1x_config.server_port != pid))
+	{
+		//update id and rx port number
+		if (rtl_82dot1xModifyEntryByMac(&skb->data[ETH_ALEN], id, pid, DOT1X_AUTH_STATE_PROCESSING)!=SUCCESS)
+		{
+			panic_printk("%s %d rtl_82dot1xModifyEntryByMac error!!!\n", __FUNCTION__, __LINE__);
+		}
+	}
+	#endif
+
+	//tx process???
+	 rtl_802dot1xRelayTrapped(skb, info, id);
+	return DOT1X_CONSUME_PKT;
+
+
+}
+
+
+int  rtl_802dot1xProxyModeRxHandle(struct sk_buff *skb,rtl_nicRx_info *info)
+{
+	int ret;
+	static rtl802Dot1xEapPkt eap;
+	if (skb == NULL || info == NULL)
+		return FAILED;
+
+	memset(&eap, 0x00, sizeof(rtl802Dot1xEapPkt));
+	eap.event_id = DOT1X_EVENT_EAP_PACKET;
+	eap.rx_port_num = info->pid;
+	eap.item_size = ((skb->len > DOT1X_MAX_EAP_PACKET_LEN)? DOT1X_MAX_EAP_PACKET_LEN:skb->len);
+	memcpy(&eap.item[0], skb->data, eap.item_size);
+	ret = rtl_82dot1xEnQueue((unsigned long)info->priv, &dot1x_queue,
+		(unsigned char*)&eap, sizeof(rtl802Dot1xEapPkt));
+	if (ret == 0)
+	{
+		rtl_82dot1xEventInform(1);
+
+		dev_kfree_skb_any(skb);
+		return DOT1X_CONSUME_PKT;
+	}
+	else
+	{
+		printk("%s %d dot1x enqueue error!", __FUNCTION__, __LINE__);
+		return ret;
+	}
+}
+
+int  rtl_802dot1xClientModeRxHandle(struct sk_buff *skb,rtl_nicRx_info *info)
+{
+	int ret;
+	static rtl802Dot1xEapPkt eap;
+
+	if (skb == NULL || info == NULL)
+		return FAILED;
+
+	memset(&eap, 0x00, sizeof(rtl802Dot1xEapPkt));
+	eap.event_id = DOT1X_EVENT_EAP_PACKET;
+	eap.rx_port_num = info->pid;
+	eap.item_size = ((skb->len > DOT1X_MAX_EAP_PACKET_LEN)? DOT1X_MAX_EAP_PACKET_LEN:skb->len);
+	memcpy(&eap.item[0], skb->data, eap.item_size);
+	ret = rtl_82dot1xEnQueue((unsigned long)info->priv, &dot1x_queue,
+		(unsigned char*)&eap, sizeof(rtl802Dot1xEapPkt));
+	if (ret == 0)
+	{
+		rtl_82dot1xEventInform(1);
+
+		dev_kfree_skb_any(skb);
+		return DOT1X_CONSUME_PKT;
+	}
+	else
+	{
+		printk("%s %d dot1x enqueue error!", __FUNCTION__, __LINE__);
+		return ret;
+	}
+}
+
+
+__MIPS16
+int  rtl_802dot1xRxHandle(struct sk_buff *skb,rtl_nicRx_info *info)
+{
+	int ret = 0;
+
+	/* dot1x function disable or not 1x frame just return */
+	#if 0
+	if ((!dot1x_config.enable)||(rtl_is802dot1xFrame(skb->data) == 0))
+	{
+		return SUCCESS;
+	}
+	#endif
+	if ((dot1x_config.mode[info->pid].port_enable)&&
+		(dot1x_config.mode[info->pid].auth_mode==DOT1X_AUTH_MODE_PROXY))
+	{
+		ret = rtl_802dot1xProxyModeRxHandle(skb,info);
+	}
+	else if ((dot1x_config.mode[info->pid].port_enable)&&
+		(dot1x_config.mode[info->pid].auth_mode==DOT1X_AUTH_MODE_CLIENT))
+	{
+		ret = rtl_802dot1xClientModeRxHandle(skb,info);
+	}
+	else if (((dot1x_config.mode[info->pid].port_enable)&&
+		(dot1x_config.mode[info->pid].auth_mode==DOT1X_AUTH_MODE_SNOOPING))||
+		(info->pid == dot1x_config.server_port))
+	{
+		ret = rtl_802dot1xSnoopingModeRxHandle(skb,info);
+	}
+	#if 0
+	switch (dot1x_config.mode[info->pid].auth_mode)
+	{
+		case DOT1X_AUTH_MODE_SNOOPING:
+			ret = rtl_802dot1xSnoopingModeRxHandle(skb,info);
+			break;
+
+		case DOT1X_AUTH_MODE_PROXY:
+			ret = rtl_802dot1xProxyModeRxHandle(skb,info);
+			break;
+		case DOT1X_AUTH_MODE_CLIENT:
+			ret = rtl_802dot1xClientModeRxHandle(skb,info);
+			break;
+
+		default:
+			printk("%s %d unknown dot1x auth mode!!", __FUNCTION__, __LINE__);
+			return SUCCESS;
+
+	}
+	#endif
+
+	return ret;
+}
+
+void  rtl_802dot1xFilltxInfo(struct sk_buff *skb,rtl_nicTx_info *info)
+{
+	unsigned char *p;
+	unsigned int pad = 0;
+	int port_offset = 0;
+	unsigned int portlist = 0, portnum = 0;
+
+	if (!skb || !info)
+		return;
+
+	port_offset = skb->len - sizeof(unsigned int);
+	p = skb->data + port_offset;
+	if (!p)
+		return;
+	memcpy((void *)&pad, (void *)p, sizeof(unsigned int));
+
+	if (!((DOT1X_SPECIAL_IDENTITY<<16)&pad))
+		return;
+
+	//check port mode
+	portnum = (pad&0xffff);
+	if (dot1x_config.mode[portnum].auth_mode != DOT1X_AUTH_MODE_PROXY)
+		return;
+
+	portlist = 1 << portnum;
+	rtl_direct_txInfo(portlist, info);
+	skb->len -= sizeof(unsigned int);
+	#if defined(DOT1X_DEBUG)
+	panic_printk("%s %d pad=0x%x portnum=%d portlist=0x%x skb->len=%d\n", __FUNCTION__, __LINE__, pad, portnum, info->portlist, skb->len);
+	#endif
+
+	return;
+
+}
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl_glue.c b/drivers/soc/realtek/rtd129x/hw_nat/rtl_glue.c
new file mode 100644
index 00000000..0662a9b
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl_glue.c
@@ -0,0 +1,102 @@
+/*
+* Program : Implementation of Glue Functions of Model Code
+* Abstract :
+* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)
+* $Id: rtl_glue.c,v 1.5 2008/04/11 10:12:38 bo_zhao Exp $
+
+*  Copyright (c) 2011 Realtek Semiconductor Corp.
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License version 2 as
+*  published by the Free Software Foundation.
+*/
+
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+
+#if 0
+int rtl_down_interruptible(struct semaphore * sem)
+{
+	//return 0;
+	return down_interruptible(sem);
+}
+
+void rtl_up(struct semaphore * sem)
+{
+	up(sem);
+}
+
+int32 rtlglue_drvMutexLock(void)
+{
+#if 0
+	spinlock_t lockForCC = SPIN_LOCK_UNLOCKED;
+	int flagsForCC;
+	int needLock;
+
+	spin_lock_irqsave(&lockForCC,flagsForCC);
+
+	needLock = (int_cc >= 1)?FALSE:TRUE;
+	int_cc ++;
+
+	if ( needLock == TRUE )
+	{
+		uint32 dummy;
+ 		saveGimr = READ_MEM32( GIMR );
+
+#if defined (CONFIG_RTK_VOIP_DRIVERS_PCM865xC)
+		WRITE_MEM32( GIMR, 0x00080000 );		/* Note: DO NOT disable PCM interrupt because users might be already on the phone call at this time
+												==> Keep PCM interrupt enable for RTK VoIP applications
+													==> RTL865xC, bit19: PCM_IE
+											*/
+#elif defined (CONFIG_RTK_VOIP_DRIVERS_PCM8651)
+		WRITE_MEM32( GIMR, 0x00040000 );		/* RTL865xB, bit18: PCM_IE */
+#else
+		WRITE_MEM32( GIMR, 0 );
+#endif
+		/*
+			For RLX5181, LW/SW for external IPs (ex. GIMR) would be slow because one
+			CMD queue is implement.
+
+			So, we would always read GIMR back before calling <spin_unlock_irqrestore()> to
+			make sure GIMR has be set before spin-unlock.
+		*/
+		dummy = READ_MEM32( GIMR );
+
+ 	}
+
+	spin_unlock_irqrestore(&lockForCC, flagsForCC);
+#endif
+	return 0;
+}
+
+int32 rtlglue_drvMutexUnlock(void)
+{
+#if 0
+	spinlock_t lockForCC = SPIN_LOCK_UNLOCKED;
+	int flagsForCC;
+	int needUnlock;
+
+	spin_lock_irqsave(&lockForCC,flagsForCC);
+
+	int_cc--;
+	needUnlock = ( int_cc==0 )?TRUE:FALSE;
+
+	if ( needUnlock == TRUE )
+	{
+ 		WRITE_MEM32( GIMR, saveGimr );
+		/*
+			For RLX5181, LW/SW for external IPs (ex. GIMR) would be slow because one
+			CMD queue is implement.
+
+			So, we would always read GIMR back before calling <spin_unlock_irqrestore()> to
+			make sure GIMR has be set before spin-unlock.
+		*/
+		saveGimr = READ_MEM32( GIMR );
+	}
+
+	spin_unlock_irqrestore(&lockForCC, flagsForCC);
+#endif
+	return 0;
+}
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl_multi_wan.c b/drivers/soc/realtek/rtd129x/hw_nat/rtl_multi_wan.c
new file mode 100644
index 00000000..6859662
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl_multi_wan.c
@@ -0,0 +1,1647 @@
+/***************************************************************************
+ * File Name    : rtl_multi_wan.c
+ * Description  : smux mean server mux.
+ ***************************************************************************/
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <asm/uaccess.h>
+#include <linux/capability.h>
+#include <linux/module.h>
+#include <linux/mm.h>
+#include <linux/in.h>
+#include <linux/init.h>
+#include <linux/rtnetlink.h>
+#include <linux/notifier.h>
+//#include <net/rtl/rtl_multi_wan.h>
+#include <net/rtl/rtl_types.h>
+#ifdef CONFIG_IP_MROUTE
+#include <linux/inetdevice.h>
+#endif
+#include <linux/if_vlan.h>
+#include <linux/etherdevice.h>
+#include <linux/ethtool.h>
+#include <net/rtl/rtl_multi_wan.h>
+#include <net/rtl/rtl_nic.h>
+//#include <net/rtl/rtl867x_hwnat_api.h>
+#include "../../net/bridge/br_private.h"
+
+static char vlan_passthru = 0;
+
+extern int rtl_register_multi_wan_dev(char *ifname, int proto, int vid, int napt);
+extern int rtl_update_port_mapping_multi_wan_dev(char *ifname,unsigned int member);
+extern int rtl_unregister_multi_wan_dev(char *ifname);
+extern int rtl_set_multi_wan_netif_mac_addr(char *ifname, char *addr);
+
+int smux_dev_open(struct net_device *vdev);
+int smux_dev_stop(struct net_device *dev);
+int smux_dev_ioctl(struct net_device *vdev, struct ifreq *ifr, int cmd);
+int smux_dev_change_mtu(struct net_device *vdev, int new_mtu);
+int smux_dev_set_mac_address(struct net_device *dev, void *addr_struct_p);
+__IRAM int smux_dev_hard_start_xmit(struct sk_buff *skb, struct net_device *dev);
+
+#ifdef CONFIG_PORT_MIRROR
+extern void nic_tx_mirror (struct sk_buff *skb);
+static inline void smux_mirror_pkt(struct sk_buff *skb,
+			const struct smux_dev_info *dev_info, const int flag);
+
+#define IN  0x1
+#define OUT 0x2
+#endif
+
+#ifdef DEBUG
+#define DPRINTK(format, args...) printk(KERN_DEBUG "SMUX: " format, ##args)
+#else
+#define DPRINTK(format, args...)
+#endif
+
+//extern unsigned int pvid_per_port[RTL8651_PORT_NUMBER+3];
+
+//#define UNIQUE_MAC_PER_DEV
+#undef UNIQUE_MAC_PER_DEV
+
+/***************************************************************************
+			 Global variables
+ ***************************************************************************/
+#define SET_MODULE_OWNER(dev) do { } while (0)
+
+static DEFINE_RWLOCK(smux_lock);
+
+static LIST_HEAD(smux_grp_devs);
+
+static int smux_device_event(struct notifier_block *, unsigned long, void *);
+
+static struct notifier_block smux_notifier_block = {
+	.notifier_call = smux_device_event,
+};
+
+#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+#else
+static const struct net_device_ops smux_netdev_ops = {
+	.ndo_open			= smux_dev_open,
+	.ndo_stop			= smux_dev_stop,
+	.ndo_validate_addr	= eth_validate_addr,
+	.ndo_set_mac_address 	= smux_dev_set_mac_address,
+	.ndo_do_ioctl			= smux_dev_ioctl,
+	.ndo_start_xmit		= smux_dev_hard_start_xmit,
+	.ndo_change_mtu		= smux_dev_change_mtu,
+	.ndo_get_stats 		= smux_dev_get_stats,
+};
+#endif
+
+#ifdef UNIQUE_MAC_PER_DEV
+unsigned char wan_dev_def_vid[9]={[0 ... 8]=0};//index 0 is reserved
+
+/*
+ * return value: -1 : FAIL
+ */
+int allocSmuxDevVid(void)
+{
+	int i;
+
+	for (i=1; i<9; i++)
+	{
+		if (!wan_dev_def_vid[i])
+			break;
+	}
+	if (i<9)
+		return i;
+
+	return -1;
+}
+
+int freeSmuxDevVid(int vid)
+{
+	if ((vid >= 9) || (vid <= 0))
+		return -1;
+
+	wan_dev_def_vid[vid] = 0;
+
+	return 0;
+}
+#endif
+
+/***************************************************************************
+			 Function Definisions
+ ***************************************************************************/
+
+static int smux_ioctl_handler(void __user *);
+static inline struct smux_group *list_entry_smuxgrp(const struct list_head *le)
+{
+	return list_entry(le, struct smux_group, smux_grp_devs);
+}
+
+/***************************************************************************
+ * Function Name: __find_smux_group
+ * Description  : returns the smux group of interfaces/devices from list
+ * Returns      : struct smux_group.
+ ***************************************************************************/
+static struct smux_group *__find_smux_group(const char *ifname)
+{
+	struct list_head *lh;
+	struct smux_group *smux_grp;
+	struct smux_group *ret_smux = NULL;
+
+	read_lock(&smux_lock);
+	list_for_each(lh, &smux_grp_devs) {
+		smux_grp = (struct smux_group *)list_entry_smuxgrp(lh);
+		if (!strncmp(smux_grp->real_dev->name, ifname, IFNAMSIZ)) {
+			ret_smux = smux_grp;
+			break;
+		}
+	}
+	read_unlock(&smux_lock);
+
+	return ret_smux;
+} /* __find_smux_group */
+
+static inline struct smux_dev_info *list_entry_smuxdev(const struct list_head *le)
+{
+  return list_entry(le, struct smux_dev_info, list);
+}
+
+void open_smux_device(char *ifname)
+{
+	struct list_head *lg, *lh;
+	struct smux_group *smux_grp;
+	struct smux_dev_info * sdev = NULL;
+
+	read_lock(&smux_lock);
+	list_for_each(lh, &smux_grp_devs){
+		smux_grp = (struct smux_group *)list_entry_smuxgrp(lh);
+		if (!strncmp(smux_grp->real_dev->name, ifname, IFNAMSIZ)){
+			list_for_each(lg, &smux_grp->virtual_devs){
+				sdev = list_entry_smuxdev(lg);
+				netif_wake_queue(sdev->vdev);
+			}
+			break;
+		}
+	}
+	read_unlock(&smux_lock);
+
+} /* open_smux_device */
+
+
+void close_smux_device(char *ifname)
+{
+	struct list_head *lg, *lh;
+	struct smux_group *smux_grp;
+	struct smux_dev_info * sdev = NULL;
+
+	read_lock(&smux_lock);
+	list_for_each(lh, &smux_grp_devs){
+		smux_grp = (struct smux_group *)list_entry_smuxgrp(lh);
+		if (!strncmp(smux_grp->real_dev->name, ifname, IFNAMSIZ)){
+			list_for_each(lg, &smux_grp->virtual_devs){
+				sdev = list_entry_smuxdev(lg);
+				netif_stop_queue(sdev->vdev);
+			}
+			break;
+		}
+	}
+	read_unlock(&smux_lock);
+
+} /* close_smux_device */
+
+/***************************************************************************
+ * Function Name: __find_smux_in_smux_group
+ * Description  : returns the smux device from smux group of devices
+ * Returns      : struct net_device
+ ***************************************************************************/
+static struct net_device *__find_smux_in_smux_group(
+				     struct smux_group *smux_grp,
+				     const char *ifname)
+{
+	struct list_head *lh;
+	struct smux_dev_info * sdev = NULL;
+	struct net_device    * ret_dev = NULL;
+
+	read_lock(&smux_lock);
+	list_for_each(lh, &smux_grp->virtual_devs) {
+		sdev = list_entry_smuxdev(lh);
+		if(!strncmp(sdev->vdev->name, ifname, IFNAMSIZ)) {
+			ret_dev = sdev->vdev;
+			break;
+		}
+	}
+	read_unlock(&smux_lock);
+
+	return ret_dev;
+} /* __find_smux_in_smux_group */
+
+static void smux_eat_vlan(struct sk_buff *skb, struct smux_dev_info *info)
+{
+//	struct vlan_hdr *vhdr=NULL;
+	struct net_bridge_port *p;
+
+	if ((skb->dev->priv_flags & IFF_VSMUX) && (skb->protocol ==  __constant_htons(ETH_P_8021Q))) {
+		if (info->proto == SMUX_PROTO_BRIDGE) { // smux tagged bridge interface: do not passthrough vlan.
+			skb_push(skb, ETH_HLEN);
+			memmove(skb->data + VLAN_HLEN, skb->data, VLAN_ETH_ALEN<<1);
+			skb_pull(skb, VLAN_HLEN);
+			skb->protocol = eth_type_trans(skb, skb->dev);
+			//printk("brg protocol 0x%x\n", skb->protocol);
+		} else { // pull out vlan tag
+			#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,4,0)
+			p = br_port_get_rcu(skb->dev);
+			#else
+			p = skb->dev->br_port;
+			#endif
+			if ((p!=NULL) && (p->br!=NULL)) {
+				skb_push(skb, ETH_HLEN);
+				memmove(skb->data + VLAN_HLEN, skb->data, VLAN_ETH_ALEN<<1);
+				skb_pull(skb, VLAN_HLEN);
+				skb->protocol = eth_type_trans(skb, skb->dev);
+			} else {
+				#if 0
+				/*Here still keep the vlan hdr*/
+				vhdr = (struct vlan_hdr *)(skb->data);
+				skb->protocol = vhdr->h_vlan_encapsulated_proto;
+				skb_pull(skb, VLAN_HLEN);
+				#else
+				skb_push(skb, ETH_HLEN);
+				memmove(skb->data + VLAN_HLEN, skb->data, VLAN_ETH_ALEN<<1);
+				skb_pull(skb, VLAN_HLEN);
+				skb->protocol = eth_type_trans(skb, skb->dev);
+				#endif
+			}
+			//printk("rt protocol 0x%x\n", skb->protocol);
+		}
+	}
+}
+
+#if defined(CONFIG_RTL_MAC_BASED_NETIF)
+/*
+ *	Return Value:
+ *	0: smux device not accept this packet
+ *	1: smux device accept this packet
+ */
+static inline int smux_check_mac(struct smux_dev_info *dev_info, struct sk_buff *skb)
+{
+	struct net_device *vdev;
+
+	vdev = dev_info->vdev;
+
+	if (!memcmp(eth_hdr(skb)->h_dest, vdev->dev_addr, ETH_ALEN))
+		return 1;
+
+	return 0;
+}
+#else
+/*
+ *	Return Value:
+ *	0: smux device not accept this packet
+ *	1: smux device accept this packet
+ */
+static inline int smux_check_vlan(struct smux_dev_info *dev_info, struct sk_buff *skb)
+{
+	struct net_device *vdev;
+	unsigned short tpid_check = skb->protocol;
+	unsigned short vid = 0;
+	struct vlan_hdr *vhdr=NULL;
+
+	if (tpid_check == __constant_htons(ETH_P_8021Q)){
+		vhdr = (struct vlan_hdr *)(skb->data);
+		vid = (vhdr->h_vlan_TCI)&VLAN_VID_MASK;
+	}
+
+	vdev = dev_info->vdev;
+
+	if (vdev->priv_flags & IFF_VSMUX) { // tagged wan
+		if (vid == 0) // untagged packet
+			return 0;
+		if (vid != dev_info->vid)
+			return 0;
+	} else { // untagged wan
+		if (vid) { // tagged packet
+			if (vlan_passthru){ // vlan passthrough on untagged bridged wan
+				if (dev_info->proto != SMUX_PROTO_BRIDGE)
+					return 0;
+			} else {
+				return 0;
+			}
+		}
+	}
+
+	return 1;
+}
+#endif
+
+/***************************************************************************
+ * Function Name: rtl_smux_pkt_recv
+ * Description  : packet recv routine for all smux devices from real dev.
+ * Returns      : 0 on Success
+ ***************************************************************************/
+int rtl_smux_pkt_recv(struct sk_buff *skb, struct net_device *dev)
+{
+	struct smux_group *grp;
+	unsigned char *dstAddr;
+	struct sk_buff *skb2;
+	struct smux_dev_info *dev_info;
+	struct smux_dev_info *dev_info_first;
+	struct list_head *lh;
+	struct net_device *vdev = NULL;
+	struct vlan_hdr *vhdr=NULL;
+	unsigned short protocol=skb->protocol;
+	int isTxDone = 0;
+
+	if (dev == NULL) {
+		dev_kfree_skb(skb);
+		return 1;
+	}
+
+	grp = __find_smux_group(dev->name);
+	if (grp == NULL) {
+		dev_kfree_skb(skb);
+		return 1;
+	}
+
+	if (protocol ==  __constant_htons(ETH_P_8021Q)) {
+		vhdr = (struct vlan_hdr *)(skb->data);
+		protocol = vhdr->h_vlan_encapsulated_proto;
+	}
+
+	dstAddr = eth_hdr(skb)->h_dest;
+	//printk("%s %d enter=================>\n", __FUNCTION__, __LINE__);
+	read_lock(&smux_lock);
+	/* Multicast Traffic will go on all intf.*/
+	if (dstAddr[0] & 1)
+	{
+		dev_info_first = NULL;
+		/* multicast or broadcast frames */
+		list_for_each(lh, &grp->virtual_devs)
+		{
+			dev_info = list_entry_smuxdev(lh);
+			vdev = dev_info->vdev;
+
+#if defined(CONFIG_RTL_MAC_BASED_NETIF)
+#else
+			if (!smux_check_vlan(dev_info, skb))
+				continue;
+#endif
+
+#if 0
+#if 0
+			if (((dev_info->proto == SMUX_PROTO_PPPOE) && (protocol != htons(ETH_P_PPP_DISC)) && (protocol != htons(ETH_P_PPP_SES))) ||
+				((dev_info->proto == SMUX_PROTO_IPOE) && ((protocol == htons(ETH_P_PPP_DISC)) || (protocol == htons(ETH_P_PPP_SES)))))
+			{
+				DPRINTK("TRACE %d: packet dropped on RX dev %s\n", __LINE__, vdev->name);
+				continue;
+			}
+#else
+			if ((dev_info->proto == SMUX_PROTO_IPOE))
+			{
+#ifdef CONFIG_RTL_IGMP_PROXY_MULTIWAN
+				if((dstAddr[0]==0x01) && (dstAddr[1]==0x00)&& (dstAddr[2]==0x5e))
+				{
+					if(!dev_info->igmpproxy_enable)
+					{
+						//drop all multicast packets
+						DPRINTK("TRACE %d: packet dropped on RX dev %s\n", __LINE__, vdev->name);
+						continue;
+					}
+					else
+					{
+						if((protocol == htons(ETH_P_PPP_DISC)) || (protocol == htons(ETH_P_PPP_SES)))
+						{
+							DPRINTK("TRACE %d: packet dropped on RX dev %s\n", __LINE__, vdev->name);
+							continue;
+						}
+					}
+				}
+				else
+#endif
+				{
+					if((protocol == htons(ETH_P_PPP_DISC)) || (protocol == htons(ETH_P_PPP_SES)))
+					{
+						DPRINTK("TRACE %d: packet dropped on RX dev %s\n", __LINE__, vdev->name);
+						continue;
+					}
+				}
+			}
+
+
+			if (dev_info->proto == SMUX_PROTO_PPPOE)
+			{
+#ifdef CONFIG_RTL_IGMP_PROXY_MULTIWAN
+				if((dstAddr[0]==0x01) && (dstAddr[1]==0x00)&& (dstAddr[2]==0x5e))
+				{
+					if(!dev_info->igmpproxy_enable)
+					{
+						//drop all multicast packets
+						DPRINTK("TRACE %d: packet dropped on RX dev %s\n", __LINE__, vdev->name);
+						continue;
+					}
+					else
+					{
+						if((dev_info->on_phy) && ((protocol == htons(ETH_P_PPP_DISC)) || (protocol == htons(ETH_P_PPP_SES))))
+						{
+							DPRINTK("TRACE %d: packet dropped on RX dev %s\n", __LINE__, vdev->name);
+							continue;
+						}
+						else if((!dev_info->on_phy) && ((protocol != htons(ETH_P_PPP_DISC)) && (protocol != htons(ETH_P_PPP_SES))))
+						{
+							DPRINTK("TRACE %d: packet dropped on RX dev %s\n", __LINE__, vdev->name);
+							continue;
+						}
+					}
+				}
+				else
+#endif
+				{
+					if((protocol != htons(ETH_P_PPP_DISC)) && (protocol != htons(ETH_P_PPP_SES)))
+					{
+						DPRINTK("TRACE %d: packet dropped on RX dev %s\n", __LINE__, vdev->name);
+						continue;
+					}
+				}
+			}
+
+#endif
+#endif
+
+			if (dev_info_first == NULL) {
+				dev_info_first = dev_info;
+				continue;
+			}
+
+#ifdef	CONFIG_PORT_MIRROR
+			if(IN_NEED_MIR(dev_info->port_mirror))
+			{
+				smux_mirror_pkt(skb, dev_info, IN);
+			}
+#endif
+			skb2 = skb_clone(skb, GFP_ATOMIC);
+			dev_info->stats.rx_packets++;
+			//printk("%s %d vdev is %s, rdev is %s\n", __FUNCTION__, __LINE__, vdev->name, skb2->dev->name);
+			dev_info->stats.rx_bytes += skb2->len;
+			skb2->dev = vdev;
+			skb2->from_dev = vdev;
+			//skb2->pkt_type = PACKET_HOST;
+
+			smux_eat_vlan(skb2, dev_info);
+			netif_rx(skb2);
+		}
+
+		if (dev_info_first == NULL) {
+			dev_kfree_skb(skb);
+			read_unlock(&smux_lock);
+			return 1;
+		} else {
+			//printk("%s %d vdev is %s, rdev is %s\n", __FUNCTION__, __LINE__, dev_info_first->vdev->name, skb->dev->name);
+
+			dev_info_first->stats.rx_packets++;
+			dev_info_first->stats.rx_bytes += skb->len;
+			skb->dev = dev_info_first->vdev;
+			skb->from_dev = dev_info_first->vdev;
+			//skb->pkt_type = PACKET_HOST;
+#ifdef	CONFIG_PORT_MIRROR
+			if(IN_NEED_MIR(dev_info->port_mirror))
+			{
+				smux_mirror_pkt(skb, dev_info, IN);
+			}
+#endif
+			smux_eat_vlan(skb, dev_info_first);
+			netif_rx(skb);
+		}
+		isTxDone = 1;
+	}
+	else /* route Traffic.*/
+	{
+		#ifndef UNIQUE_MAC_PER_DEV
+		dev_info_first = NULL;
+		#endif
+		/* Routing Interface Traffic : check dst mac */
+		list_for_each(lh, &grp->virtual_devs)
+		{
+			dev_info = list_entry_smuxdev(lh);
+			if (dev_info->proto == SMUX_PROTO_BRIDGE)
+				continue;
+
+			vdev = dev_info->vdev;
+#if defined(CONFIG_RTL_MAC_BASED_NETIF)
+			if (!smux_check_mac(dev_info, skb))
+				continue;
+#else
+			if (!smux_check_vlan(dev_info, skb))
+				continue;
+#endif
+
+#if 0
+			if (((dev_info->proto == SMUX_PROTO_PPPOE) && (protocol != htons(ETH_P_PPP_DISC)) && (protocol != htons(ETH_P_PPP_SES))) ||
+				((dev_info->proto == SMUX_PROTO_IPOE) && ((protocol == htons(ETH_P_PPP_DISC)) || (protocol == htons(ETH_P_PPP_SES)))))
+			{
+				DPRINTK("TRACE %d: packet dropped on RX dev %s\n", __LINE__, vdev->name);
+				continue;
+			}
+#endif
+
+			#ifndef UNIQUE_MAC_PER_DEV
+			if (!memcmp(dstAddr, vdev->dev_addr, ETH_ALEN))
+			{
+				if(dev_info_first == NULL) {
+					dev_info_first = dev_info;
+					continue;
+				}
+
+				skb2 = skb_copy(skb, GFP_ATOMIC);
+			//printk("%s %d vdev is %s, rdev is %s\n", __FUNCTION__, __LINE__, vdev->name, skb2->dev->name);
+
+				skb2->dev = vdev;
+				skb2->from_dev = vdev;
+				dev_info->stats.rx_packets++;
+				dev_info->stats.rx_bytes += skb2->len;
+				skb2->pkt_type = PACKET_HOST;
+				//printk("(route) receive from %s\n", vdev->name);
+#ifdef	CONFIG_PORT_MIRROR
+				if(IN_NEED_MIR(dev_info->port_mirror))
+				{
+					smux_mirror_pkt(skb, dev_info, IN);
+				}
+#endif
+				smux_eat_vlan(skb2, dev_info);
+				netif_rx(skb2);
+
+				isTxDone = 1;
+			}
+			#else
+			if (!memcmp(dstAddr, vdev->dev_addr, ETH_ALEN))
+			{
+				skb->dev = vdev;
+				skb->from_dev = vdev;
+				dev_info->stats.rx_packets++;
+				dev_info->stats.rx_bytes += skb->len;
+				skb->pkt_type = PACKET_HOST;
+				//printk("(route) receive from %s\n", vdev->name);
+
+#ifdef	CONFIG_PORT_MIRROR
+				if(IN_NEED_MIR(dev_info->port_mirror))
+				{
+					smux_mirror_pkt(skb, dev_info, IN);
+				}
+#endif
+				smux_eat_vlan(skb, dev_info);
+				netif_rx(skb);
+
+				isTxDone = 1;
+				break;
+			}
+			#endif
+		}
+
+		#ifndef UNIQUE_MAC_PER_DEV
+		if (dev_info_first) {
+			dev_info_first->stats.rx_packets++;
+			dev_info_first->stats.rx_bytes += skb->len;
+			//printk("%s %d vdev is %s, rdev is %s\n", __FUNCTION__, __LINE__, vdev->name, skb->dev->name);
+
+			skb->dev = dev_info_first->vdev;
+			skb->from_dev = dev_info_first->vdev;
+			skb->pkt_type = PACKET_HOST;
+			//printk("(route) receive from %s\n", dev_info_first->vdev->name);
+#ifdef	CONFIG_PORT_MIRROR
+			if(IN_NEED_MIR(dev_info->port_mirror))
+			{
+				smux_mirror_pkt(skb, dev_info, IN);
+			}
+#endif
+			smux_eat_vlan(skb, dev_info_first);
+			netif_rx(skb);
+
+			isTxDone = 1;
+		}
+		#endif
+	}
+
+	if (isTxDone != 1)
+	{
+		/* Bridging Interface Traffic */
+		list_for_each(lh, &grp->virtual_devs)
+		{
+			dev_info = list_entry_smuxdev(lh);
+			if (dev_info->proto != SMUX_PROTO_BRIDGE && !dev_info->brpppoe)
+				continue;
+
+			vdev = dev_info->vdev;
+
+#if defined(CONFIG_RTL_MAC_BASED_NETIF)
+#else
+			if (!smux_check_vlan(dev_info, skb))
+				continue;
+#endif
+
+			if (vdev->promiscuity)
+			{
+				skb->dev = vdev;
+				skb->from_dev = vdev;
+				dev_info->stats.rx_packets++;
+				dev_info->stats.rx_bytes += skb->len;
+				skb->pkt_type = PACKET_OTHERHOST;
+				//printk("(bridge) receive from %s\n", vdev->name);
+#ifdef	CONFIG_PORT_MIRROR
+				if(IN_NEED_MIR(dev_info->port_mirror))
+				{
+					smux_mirror_pkt(skb, dev_info, IN);
+				}
+#endif
+				smux_eat_vlan(skb, dev_info);
+				netif_rx(skb);
+				isTxDone = 1;
+				break;
+			}
+		}
+	}
+	read_unlock(&smux_lock);
+
+	if (isTxDone == 0) {
+		DPRINTK("dropping packet that has wrong dest. on RX dev %s\n", dev->name);
+		dev_kfree_skb(skb);
+		return 1;
+	}
+
+	return 0;
+} /* rtl_smux_pkt_recv */
+/*Start:add by caoxiafei cKF24361 20100426 for fastpath*/
+/***************************************************************************
+ * Function Name: rtl_get_smux_dev
+ * Description  : fetch smux devices according to real dev.
+ * Returns      : 0 on fail
+ ***************************************************************************/
+ /*jwj: It not used now, later....*/
+struct net_device * rtl_get_smux_dev(struct sk_buff *skb)
+{
+	struct smux_group *grp;
+	unsigned char *dstAddr;
+	struct smux_dev_info *dev_info;
+	struct list_head *lh;
+	struct net_device *vdev;
+
+	grp = __find_smux_group(skb->dev->name);
+	if (!grp)
+		return NULL;
+	dstAddr = eth_hdr(skb)->h_dest;
+	if (dstAddr[0]&0x01)
+		return NULL;
+	read_lock(&smux_lock);
+	list_for_each(lh, &grp->virtual_devs)
+	{
+		dev_info = list_entry_smuxdev(lh);
+		vdev = dev_info->vdev;
+		if (!compare_ether_addr(dstAddr, vdev->dev_addr)) {
+			skb->dev = vdev;
+			read_unlock(&smux_lock);
+			return vdev;
+		}
+	}
+
+	read_unlock(&smux_lock);
+	return NULL;
+}
+/*End:add by caoxiafei cKF24361 20100426 for fastpath*/
+
+/***************************************************************************
+ * Function Name: smux_dev_hard_start_xmit
+ * Description  : xmit routine for all smux devices on real dev.
+ * Returns      : 0 on Success
+ ***************************************************************************/
+__IRAM
+int smux_dev_hard_start_xmit(struct sk_buff *skb, struct net_device *dev)
+{
+	struct net_device_stats *stats = smux_dev_get_stats(dev);
+	struct smux_dev_info *dev_info;
+
+	stats->tx_packets++;
+	stats->tx_bytes += skb->len;
+
+	dev_info = SMUX_DEV_INFO(dev);
+	skb->dev = dev_info->smux_grp->real_dev;	//replace as the real dev
+	if (dev_info->vid == -1) {
+		#if defined(CONFIG_RTL_8676HWNAT)
+		if (dev_info->proto == SMUX_PROTO_BRIDGE)
+			skb->vlan_tci = RTL_BRIDGE_WANVLANID;
+		else
+			skb->vlan_tci = RTL_WANVLANID;
+		#else
+		skb->vlan_tci = 0;
+		#endif
+	} else {
+		if (dev_info->m_1p == 0)
+			skb->vlan_tci = (dev_info->vid&VLAN_VID_MASK);
+		else
+			skb->vlan_tci = (dev_info->vid&VLAN_VID_MASK) |((dev_info->m_1p-1)<<13);
+	}
+
+	skb->vlan_member = dev_info->member;
+#ifdef CONFIG_PORT_MIRROR
+	if ((OUT_NEED_MIR(dev_info->port_mirror))) {
+		smux_mirror_pkt(skb, dev_info, OUT);
+	}
+#endif
+	//printk("%s,%d::dev_info->member: %x\n",__FUNCTION__,__LINE__,skb->vlan_member);
+
+	//skb->dev->hard_start_xmit(skb, skb->dev);
+	skb->dev->netdev_ops->ndo_start_xmit(skb,skb->dev);
+
+	//dev_queue_xmit(skb);
+
+	return 0;
+} /* smux_dev_hard_start_xmit */
+
+/***************************************************************************
+ * Function Name: smux_dev_open
+ * Description  :
+ * Returns      : 0 on Success
+ ***************************************************************************/
+int smux_dev_open(struct net_device *vdev)
+{
+	if (!(SMUX_DEV_INFO(vdev)->smux_grp->real_dev->flags & IFF_UP))
+		return -ENETDOWN;
+
+	return 0;
+} /* smux_dev_open */
+
+/***************************************************************************
+ * Function Name: smux_dev_stop
+ * Description  :
+ * Returns      : 0 on Success
+ ***************************************************************************/
+int smux_dev_stop(struct net_device *dev)
+{
+	return 0;
+} /* smux_dev_stop */
+
+/***************************************************************************
+ * Function Name: smux_dev_set_mac_address
+ * Description  : sets the mac for devs
+ * Returns      : 0 on Success
+ ***************************************************************************/
+int smux_dev_set_mac_address(struct net_device *dev, void *addr_struct_p)
+{
+	struct sockaddr *addr = (struct sockaddr *)(addr_struct_p);
+	//int i, flgs;
+
+	if (netif_running(dev))
+		return -EBUSY;
+
+	memcpy(dev->dev_addr, addr->sa_data, ETH_ALEN);
+	memset(dev->broadcast, 0xff, ETH_ALEN);
+
+//#if defined(CONFIG_RTL_HARDWARE_NAT) && defined(CONFIG_RTL_FLOW_BASE_HWNAT)
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+	rtl_set_multi_wan_netif_mac_addr(dev->name, addr->sa_data);
+#endif
+
+	return 0;
+} /* smux_dev_set_mac_address */
+
+
+/***************************************************************************
+ * Function Name: smux_dev_ioctl
+ * Description  : handles device related ioctls
+ * Returns      : 0 on Success
+ ***************************************************************************/
+int smux_dev_ioctl(struct net_device *vdev, struct ifreq *ifr, int cmd)
+{
+	struct net_device *real_dev = SMUX_DEV_INFO(vdev)->smux_grp->real_dev;
+	struct ifreq ifrr;
+	int err = -EOPNOTSUPP;
+#ifdef CONFIG_RTL_8676HWNAT
+	extern int set_port_mapping(struct net_device *dev, struct ifreq *rq, int cmd);
+#endif
+
+	strncpy(ifrr.ifr_name, real_dev->name, IFNAMSIZ);
+	ifrr.ifr_ifru = ifr->ifr_ifru;
+
+	//printk("%s %d cmd 0x%x (dev:%s)\n", __FUNCTION__, __LINE__, cmd, vdev->name);
+	switch(cmd) {
+		case SIOCGMIIPHY:
+		case SIOCGMIIREG:
+		case SIOCSMIIREG:
+			//if (real_dev->do_ioctl && netif_device_present(real_dev))
+			//err = real_dev->do_ioctl(real_dev, &ifrr, cmd);
+			if (real_dev->netdev_ops->ndo_do_ioctl && netif_device_present(real_dev))
+				err = real_dev->netdev_ops->ndo_do_ioctl(real_dev, &ifrr, cmd);
+			break;
+
+		case SIOCETHTOOL:
+			err = dev_ethtool(&init_net, &ifrr);
+
+			if (!err)
+				ifr->ifr_ifru = ifrr.ifr_ifru;
+			break;
+
+#ifdef CONFIG_PORT_MIRROR
+		case SIOCPORTMIRROR:
+		{
+			struct portmir *pmr;
+			struct smux_dev_info *dev_info = SMUX_DEV_INFO(vdev);
+			struct net_device *dev = NULL;
+
+			pmr = (struct portmir *)ifr->ifr_data;
+			//AUG_DBG("the pmr->mir_dev_name is %s\n", pmr->mir_dev_name);
+
+			dev = dev_get_by_name(&init_net, pmr->mir_dev_name);
+			if(!dev)
+			{
+				printk("error lan device!\n");
+				break;
+			}
+			if((dev->priv_flags & IFF_DOMAIN_ELAN) == 0)
+			{
+				printk("error lan device!\n");
+				break;
+			}
+			dev_info->port_mirror = pmr->port_mirror;
+			dev_info->mirror_dev  = dev;
+
+			err = 0;
+			break;
+		}
+#endif
+
+		case SIOCSITFGROUP:
+			{
+				struct ifvlan *ifvl;
+				struct smux_dev_info *dev_info = SMUX_DEV_INFO(vdev);
+
+				ifvl = (struct ifvlan *)ifr->ifr_data;
+				if (ifvl->enable)
+					dev_info->member = ifvl->member;
+				else
+					dev_info->member = 0xFFFFFFFF;
+				printk("%s %d set portmapping  (dev:%s  member:0x%x) \n", __FUNCTION__, __LINE__,vdev->name,dev_info->member);
+#ifdef CONFIG_RTL_8676HWNAT
+				err = set_port_mapping(vdev, ifr, cmd);
+#else
+				err = 0;
+#endif
+				#if defined(CONFIG_RTL_HARDWARE_NAT)
+				rtl_update_port_mapping_multi_wan_dev(vdev->name,dev_info->member);
+				#endif
+			}
+			//rtl865x_updateNetifForPortmapping();
+
+			return err;
+	}
+
+	return err;
+} /* smux_dev_ioctl */
+
+/***************************************************************************
+ * Function Name: smux_dev_change_mtu
+ * Description  : changes mtu for dev
+ * Returns      : 0 on Success
+ ***************************************************************************/
+int smux_dev_change_mtu(struct net_device *vdev, int new_mtu)
+{
+	//MTU should be larger than real device.
+	if (SMUX_DEV_INFO(vdev)->smux_grp->real_dev->mtu < new_mtu)
+		return -ERANGE;
+
+	//vdev->mtu = new_mtu;
+	//SMUX_DEV_INFO(vdev)->smux_grp->real_dev->change_mtu(vdev, new_mtu);
+	SMUX_DEV_INFO(vdev)->smux_grp->real_dev->netdev_ops->ndo_change_mtu(vdev, new_mtu);
+
+	return 0;
+}
+
+/***************************************************************************
+ * Function Name: smux_setup
+ * Description  : inits device api
+ * Returns      : None
+ ***************************************************************************/
+static void smux_setup(struct net_device *new_dev)
+{
+	SET_MODULE_OWNER(new_dev);
+	//new_dev->get_stats = smux_dev_get_stats;
+	//new_dev->netdev_ops->ndo_get_stats = smux_dev_get_stats;
+	/* Make this thing known as a SMUX device */
+	new_dev->priv_flags |= IFF_OSMUX;
+	new_dev->tx_queue_len = 0;
+
+#ifdef CONFIG_COMPAT_NET_DEV_OPS
+	/* set up method calls */
+	new_dev->change_mtu = smux_dev_change_mtu;
+	new_dev->open = smux_dev_open;
+	new_dev->stop = smux_dev_stop;
+	new_dev->set_mac_address = smux_dev_set_mac_address;
+	/*new_dev->set_multicast_list = smux_dev_set_multicast_list; TODO: */
+	new_dev->destructor = free_netdev;
+	new_dev->do_ioctl = smux_dev_ioctl;
+#endif
+} /* smux_setup */
+
+/***************************************************************************
+ * Function Name: smux_transfer_operstate
+ * Description  : updates the operstate of overlay device
+ * Returns      : None.
+ ***************************************************************************/
+static void smux_transfer_operstate(const struct net_device *rdev,
+				    struct net_device *vdev)
+{
+
+	if (rdev->operstate == IF_OPER_DORMANT)
+		netif_dormant_on(vdev);
+	else
+		netif_dormant_off(vdev);
+
+	if (netif_carrier_ok(rdev)) {
+		if (!netif_carrier_ok(vdev))
+			netif_carrier_on(vdev);
+	} else {
+		if (netif_carrier_ok(vdev))
+			netif_carrier_off(vdev);
+	}
+} /* smux_transfer_operstate */
+
+static const struct ethtool_ops smux_ethtool_ops = {
+	.get_link = ethtool_op_get_link,
+};
+
+/***************************************************************************
+ * Function Name: smux_register_device
+ * Description  : regists new overlay device on real device & registers for
+		  packet handlers depending on the protocol types
+ * Returns      : 0 on Success
+ ***************************************************************************/
+#ifdef CONFIG_RTL_IGMP_PROXY_MULTIWAN
+static struct net_device *smux_register_device(const char *rifname,
+					       const char *nifname, int smux_proto, int vid, int napt, int brpppoe, int enable, int on_phy)
+#else
+static struct net_device *smux_register_device(const char *rifname,
+					       const char *nifname, int smux_proto, int vid, int napt, int brpppoe)
+#endif
+{
+	struct net_device *new_dev = NULL;
+	struct net_device *real_dev = NULL;
+	struct smux_group *grp = NULL;
+	struct smux_dev_info *vdev_info = NULL;
+	#ifdef UNIQUE_MAC_PER_DEV
+	int    mac_reused = 0;
+	unsigned char LSB=0;
+	struct list_head *lh;
+	#endif
+
+	//printk("%s %d rifname is %s, nifname is %s\n", __FUNCTION__, __LINE__, rifname, nifname);
+	real_dev = dev_get_by_name(&init_net, rifname);
+	if (real_dev == NULL)
+		goto real_dev_invalid;
+
+	if (!(real_dev->flags & IFF_UP))
+		goto real_dev_invalid;
+
+	new_dev = alloc_netdev(sizeof(struct smux_dev_info), nifname, smux_setup);
+	if (new_dev == NULL) {
+		printk("smux netdev alloc failure\n");
+		goto new_dev_invalid;
+	}
+
+	ether_setup(new_dev);
+	if (vid != -1)
+		new_dev->priv_flags |= IFF_VSMUX;
+
+	new_dev->flags &= ~IFF_UP;
+	new_dev->flags &= ~IFF_MULTICAST;
+	new_dev->priv_flags |= IFF_DOMAIN_WAN;
+	real_dev->priv_flags |= IFF_RSMUX;
+
+	new_dev->state = (real_dev->state &
+		    ((1<<__LINK_STATE_NOCARRIER) |
+		     (1<<__LINK_STATE_DORMANT))) |
+		     (1<<__LINK_STATE_PRESENT);
+
+	new_dev->mtu = real_dev->mtu;
+	new_dev->type = real_dev->type;
+	new_dev->hard_header_len = real_dev->hard_header_len;
+#ifdef CONFIG_COMPAT_NET_DEV_OPS
+	new_dev->hard_start_xmit = smux_dev_hard_start_xmit;
+	new_dev->set_mac_address = smux_dev_set_mac_address;
+#else
+	new_dev->netdev_ops = &smux_netdev_ops;
+#endif
+	SET_ETHTOOL_OPS(new_dev, &smux_ethtool_ops);
+
+	/* find smux group name. if not found create all new smux group */
+	/*One real wan dev has one grp, and one grp can have some virtual wan dev.*/
+	grp = __find_smux_group(rifname);
+	if (grp == NULL) {
+		grp = kzalloc(sizeof(struct smux_group), GFP_KERNEL);
+
+		if (grp) {
+			INIT_LIST_HEAD(&grp->virtual_devs);
+			INIT_LIST_HEAD(&grp->smux_grp_devs);
+
+			grp->real_dev = real_dev;
+
+			write_lock_irq(&smux_lock);
+			list_add_tail(&grp->smux_grp_devs, &smux_grp_devs);
+			write_unlock_irq(&smux_lock);
+		} else {
+			free_netdev(new_dev);
+			new_dev = NULL;
+		}
+	}
+
+	if (grp && new_dev) {
+		/* Assign default mac to bridge so that we can add it to linux bridge */
+		if (smux_proto == SMUX_PROTO_BRIDGE) {
+			memcpy( new_dev->dev_addr, "\xFE\xFF\xFF\xFF\xFF\xFF", ETH_ALEN );
+		} else {
+			#ifdef UNIQUE_MAC_PER_DEV
+			if (list_empty(&grp->virtual_devs)) {
+				memcpy(new_dev->dev_addr, real_dev->dev_addr, ETH_ALEN);
+			} else {
+				list_for_each(lh, &grp->virtual_devs)
+				{
+					vdev_info = list_entry_smuxdev(lh);
+					if (!memcmp(real_dev->dev_addr, vdev_info->vdev->dev_addr, ETH_ALEN)) {
+		            			mac_reused = 1;
+					}
+					if (LSB < vdev_info->vdev->dev_addr[5])
+						LSB = vdev_info->vdev->dev_addr[5];
+				}
+
+				memcpy(new_dev->dev_addr, real_dev->dev_addr, ETH_ALEN);
+				if (mac_reused) {
+					//generate new mac address, real_addr mac addr increased by 1.
+					new_dev->dev_addr[5] = LSB+1;
+				}
+			}
+			#else
+			memcpy(new_dev->dev_addr, real_dev->dev_addr, ETH_ALEN);
+			#endif
+		}
+	}
+
+	if (grp && new_dev) {
+		struct net_device *ret_dev;
+		/*find new smux in smux group if it does not exit create one*/
+		if ((ret_dev=__find_smux_in_smux_group(grp, nifname)) == NULL) {
+			vdev_info = SMUX_DEV_INFO(new_dev);
+			memset(vdev_info, 0, sizeof(struct smux_dev_info));
+			//m_1p : 0~8, 0 is meaning disable
+			if (vid>=0)
+				vdev_info->m_1p = vid>>13;
+			else
+				vdev_info->m_1p=0;
+			vdev_info->smux_grp = grp;
+			vdev_info->vdev = new_dev;
+			vdev_info->proto = smux_proto;	//pppoe or DHCP or bridge
+		#ifdef CONFIG_RTL_IGMP_PROXY_MULTIWAN
+			vdev_info->igmpproxy_enable = enable;
+			vdev_info->on_phy = on_phy;
+			//printk("igmpproxy enable: %d, on Phy: %d, [%s:%d]\n", vdev_info->igmpproxy_enable, vdev_info->on_phy, __FUNCTION__, __LINE__);
+		#endif
+			#ifdef UNIQUE_MAC_PER_DEV
+			if ((vid == -1) && (smux_proto != SMUX_PROTO_BRIDGE)) {
+				if ((vid = allocSmuxDevVid()) == -1)
+					printk("fatal error, too many wan interface created.\n");
+			}
+			#endif
+			if (vid != -1)
+				vdev_info->vid = (vid&VLAN_VID_MASK);
+			else
+				vdev_info->vid = vid;
+			vdev_info->napt = napt;
+			vdev_info->brpppoe = brpppoe;
+			vdev_info->member = 0xFFFFFFFF;	//init membership to include all interface.
+#ifdef CONFIG_PORT_MIRROR
+			vdev_info->port_mirror = 0;
+			vdev_info->mirror_dev = NULL;
+#endif
+			if (smux_proto == SMUX_PROTO_BRIDGE) {
+				new_dev->promiscuity = 1;
+			} else if(smux_proto == SMUX_PROTO_IPOE) {
+				new_dev->flags |= IFF_MULTICAST;
+			}
+
+			if (register_netdev(new_dev)) {
+				printk("register_netdev failed\n");
+				//list_del(&vdev_info->list);
+				free_netdev(new_dev);
+				new_dev = NULL;
+			} else {
+				INIT_LIST_HEAD(&vdev_info->list);
+				write_lock_irq(&smux_lock);
+				list_add_tail(&vdev_info->list, &grp->virtual_devs);
+				write_unlock_irq(&smux_lock);
+				smux_transfer_operstate(real_dev, new_dev);
+			}
+			#ifdef CONFIG_RTL_HARDWARE_NAT
+			if (new_dev) {
+				if (smux_proto != SMUX_PROTO_BRIDGE && brpppoe) {
+					//char ifname_extend[IFNAMSIZ];
+					//strcpy(ifname_extend,vdev_info->vdev->name);
+					//strcat(ifname_extend,"_B");
+					//#if defined(CONFIG_RTL_FLOW_BASE_HWNAT)
+					rtl_register_multi_wan_dev(vdev_info->vdev->name, smux_proto, vid, napt);
+					//rtl_register_multi_wan_dev(ifname_extend, SMUX_PROTO_BRIDGE, vid, napt);
+					//#endif
+				} else {
+//#if defined(CONFIG_RTL_FLOW_BASE_HWNAT)
+					rtl_register_multi_wan_dev(vdev_info->vdev->name, smux_proto, vid, napt);
+//#endif
+				}
+			}
+			#endif
+		} else {
+			printk("device %s already exist.\n", nifname);
+			free_netdev(new_dev);
+			new_dev = ret_dev;
+		}
+	}
+
+	return new_dev;
+
+real_dev_invalid:
+new_dev_invalid:
+
+	return NULL;
+} /* smux_register_device */
+
+/***************************************************************************
+ * Function Name: smux_unregister_device
+ * Description  : unregisters the smux devices along with releasing mem.
+ * Returns      : 0 on Success
+ ***************************************************************************/
+static int smux_unregister_device(const char* vifname)
+{
+	struct net_device *vdev = NULL;
+	struct net_device *real_dev = NULL;
+	int ret;
+	struct smux_dev_info *dev_info;
+	ret = -EINVAL;
+
+	vdev = dev_get_by_name(&init_net, vifname);
+	if (vdev) {
+		printk("%s[%d] remove smux dev %s\n", __FUNCTION__, __LINE__, vifname);
+		/* remove related acl rule */
+		#if 0
+		#ifdef CONFIG_RTL8676_Dynamic_ACL
+		rtl865x_acl_control_delete_all_by_netif(vdev->name);
+		#endif
+		rtl865x_delNetif(vdev->name);
+		#endif
+
+		dev_info = SMUX_DEV_INFO(vdev);
+		#if defined(CONFIG_RTL_HARDWARE_NAT)
+		#if defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+		rtl_disable_advRt_by_netifName(vdev->name);
+		#endif
+		rtl_unregister_multi_wan_dev(vdev->name);
+		{
+			char ifname_extend[IFNAMSIZ];
+			strcpy(ifname_extend,vdev->name);
+			strcat(ifname_extend,"_B");
+			if(rtl865x_netif_exist(ifname_extend))
+				rtl865x_unregisterDev(ifname_extend);
+		}
+		#endif
+		#ifdef UNIQUE_MAC_PER_DEV
+		freeSmuxDevVid(dev_info->vid);
+		#endif
+		real_dev = dev_info->smux_grp->real_dev;
+
+		write_lock_irq(&smux_lock);
+		list_del(&dev_info->list);
+		write_unlock_irq(&smux_lock);
+
+		if (list_empty(&dev_info->smux_grp->virtual_devs)) {
+			write_lock_irq(&smux_lock);
+			list_del(&dev_info->smux_grp->smux_grp_devs);
+			write_unlock_irq(&smux_lock);
+
+			kfree(dev_info->smux_grp);
+		}
+
+		dev_put(vdev);
+		unregister_netdev(vdev);
+
+		synchronize_net();
+		dev_put(real_dev);
+
+		ret = 0;
+	}
+
+	return ret;
+} /* smux_unregister_device */
+
+/***************************************************************************
+ * Function Name: smux_device_event
+ * Description  : handles real device events to update overlay devs. status
+ * Returns      : 0 on Success
+ ***************************************************************************/
+static int smux_device_event(struct notifier_block *unused, unsigned long event, void *ptr)
+{
+	struct net_device *rdev = ptr;
+	struct smux_group *grp = __find_smux_group(rdev->name);
+	int flgs;
+	struct list_head *lh;
+	struct list_head *lhp;
+	struct smux_dev_info *dev_info;
+
+	if (!grp)
+		goto out;
+
+	switch (event) {
+		case NETDEV_CHANGE:
+
+			/* Propagate real device state to overlay devices */
+			read_lock(&smux_lock);
+			list_for_each(lh, &grp->virtual_devs) {
+				dev_info = list_entry_smuxdev(lh);
+				if(dev_info) {
+					smux_transfer_operstate(rdev, dev_info->vdev);
+				}
+			}
+			read_unlock(&smux_lock);
+			break;
+
+		case NETDEV_DOWN:
+
+			/* Put all Overlay devices for this dev in the down state too.*/
+			read_lock(&smux_lock);
+			list_for_each(lh, &grp->virtual_devs) {
+				dev_info = list_entry_smuxdev(lh);
+				if(dev_info) {
+					flgs = dev_info->vdev->flags;
+
+					if (!(flgs & IFF_UP))
+						continue;
+
+					dev_change_flags(dev_info->vdev, flgs & ~IFF_UP);
+				}
+			}
+			read_unlock(&smux_lock);
+			break;
+
+		case NETDEV_UP:
+
+			/* Put all Overlay devices for this dev in the up state too.  */
+			read_lock(&smux_lock);
+			list_for_each(lh, &grp->virtual_devs) {
+				dev_info = list_entry_smuxdev(lh);
+				if(dev_info) {
+					flgs = dev_info->vdev->flags;
+
+					if (flgs & IFF_UP)
+						continue;
+
+					dev_change_flags(dev_info->vdev, flgs & IFF_UP);
+				}
+			}
+			read_unlock(&smux_lock);
+			break;
+
+		case NETDEV_UNREGISTER:
+
+			/* Delete all Overlay devices for this dev. */
+			write_lock_irq(&smux_lock);
+			list_for_each_safe(lh, lhp, &grp->virtual_devs) {
+				dev_info = list_entry_smuxdev(lh);
+				if(dev_info) {
+					/* delete by l67530 for cpu0 when reboot system. HG551c.2010/12/07 */
+					//list_del(&dev_info->list);
+					smux_unregister_device(dev_info->vdev->name);
+				}
+			}
+			write_unlock_irq(&smux_lock);
+			break;
+		}
+
+out:
+  return NOTIFY_DONE;
+} /* smux_device_event */
+
+/***************************************************************************
+ * Function Name: smux_ioctl_handler
+ * Description  : ioctl handler for user apps
+ * Returns      : 0 on Success
+ ***************************************************************************/
+static int smux_ioctl_handler(void __user *arg)
+{
+	int err = 0;
+	struct smux_ioctl_args args;
+
+	if (copy_from_user(&args, arg, sizeof(struct smux_ioctl_args)))
+		return -EFAULT;
+
+	args.rsmux_ifname[IFNAMSIZ-1] = 0;
+	args.osmux_ifname[IFNAMSIZ-1] = 0;
+
+	switch (args.cmd) {
+		case ADD_SMUX_CMD:
+			if (!capable(CAP_NET_ADMIN))
+				return -EPERM;
+		#ifdef CONFIG_RTL_IGMP_PROXY_MULTIWAN
+			if(smux_register_device(args.rsmux_ifname, args.osmux_ifname, args.proto, args.vid, args.napt, args.brpppoe, args.igmpproxy_enable, args.on_phy))
+		#else
+			if(smux_register_device(args.rsmux_ifname, args.osmux_ifname, args.proto, args.vid, args.napt, args.brpppoe))
+		#endif
+			{
+				err = 0;
+			} else {
+				err = -EINVAL;
+			}
+			break;
+
+		case REM_SMUX_CMD:
+			if (!capable(CAP_NET_ADMIN))
+				return -EPERM;
+			err = smux_unregister_device(args.u.ifname);
+			break;
+
+		default:
+			printk("%s: Unknown SMUX CMD: %x \n", __FUNCTION__, args.cmd);
+			return -EINVAL;
+	}
+
+	return err;
+} /* smux_ioctl_handler */
+
+static int vlan_passthru_write(struct file *file, const char *buffer,
+		      unsigned long count, void *data)
+{
+    unsigned char chartmp;
+
+    if (count > 1){
+	if (buffer && !copy_from_user(&chartmp, buffer, 1)){
+	    	vlan_passthru = chartmp - '0';
+			printk("vlan passthru  : %s\n", vlan_passthru ? "Enable" : "Disable");
+	}
+	} else {
+		printk("write fail\n");
+		return -EFAULT;
+	}
+
+	return count;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+extern struct proc_dir_entry proc_root;
+static int32 vlan_passthru_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "vlan passthru  : %s\n",  vlan_passthru ? "Enable" : "Disable");
+
+	return 0;
+}
+/*rtk_vlan_support*/
+int vlan_passthru_single_open(struct inode *inode, struct file *file)
+{
+	return(single_open(file, vlan_passthru_read,NULL));
+}
+
+static ssize_t vlan_passthru_single_write(struct file * file, const char __user * userbuf,
+		     size_t count, loff_t * off)
+{
+	return vlan_passthru_write(file, userbuf,count, off);
+}
+
+struct file_operations vlan_passthru_proc_fops = {
+	.open          	= vlan_passthru_single_open,
+	.write		= vlan_passthru_single_write,
+	.read           	= seq_read,
+	.llseek         	= seq_lseek,
+	.release        	= single_release,
+};
+#else/*CONFIG_RTL_PROC_NEW*/
+static struct proc_dir_entry *vlan_passthru_proc=NULL;
+static int vlan_passthru_read(char *page, char **start, off_t off,
+		int count, int *eof, void *data)
+{
+      int len;
+      len = sprintf(page, "vlan passthru  : %s\n",  vlan_passthru ? "Enable" : "Disable");
+
+      if (len <= off+count) *eof = 1;
+      *start = page + off;
+      len -= off;
+      if (len>count) len = count;
+      if (len<0) len = 0;
+      return len;
+}
+#endif
+
+static int initVlanPassThruProc(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("vlan_passthru",0, &proc_root, &vlan_passthru_proc_fops, NULL);
+#else
+	vlan_passthru_proc = create_proc_entry("vlan_passthru", 0, NULL);
+	if(vlan_passthru_proc)
+	{
+		vlan_passthru_proc->read_proc = vlan_passthru_read;
+		vlan_passthru_proc->write_proc = vlan_passthru_write;
+	}
+#endif
+	return 0;
+}
+
+/***************************************************************************
+ * Function Name: smux_drv_init
+ * Description  : Initialization of smux driver
+ * Returns      : struct net_device
+ ***************************************************************************/
+static int __init smux_drv_init(void)
+{
+	register_netdevice_notifier(&smux_notifier_block);
+	smux_ioctl_set(smux_ioctl_handler);
+	initVlanPassThruProc();
+
+	return 0;
+} /* smux_drv_init */
+
+/***************************************************************************
+ * Function Name: smux_cleanup_devices
+ * Description  : cleans up all the smux devices and releases memory on exit
+ * Returns      : None
+ ***************************************************************************/
+static void __exit smux_cleanup_devices(void)
+{
+	struct net_device *dev;
+	struct list_head *lh;
+	struct list_head *lhp;
+	struct smux_dev_info *dev_info;
+	struct smux_group *grp;
+
+	/* clean up all the smux devices */
+	rtnl_lock();
+	for_each_netdev(&init_net, dev)
+	{
+		if (dev->priv_flags & IFF_OSMUX) {
+			dev_info = SMUX_DEV_INFO(dev);
+			write_lock_irq(&smux_lock);
+			list_del(&dev_info->list);
+			write_unlock_irq(&smux_lock);
+			unregister_netdevice(dev);
+		}
+	}
+	rtnl_unlock();
+
+	/* cleanup all smux groups  */
+	write_lock_irq(&smux_lock);
+	list_for_each_safe(lh, lhp, &smux_grp_devs) {
+		grp = list_entry_smuxgrp(lh);
+		if(grp) {
+			list_del(&grp->virtual_devs);
+		}
+	}
+	write_unlock_irq(&smux_lock);
+} /* smux_cleanup_devices */
+
+/***************************************************************************
+ * Function Name: smux_drv_exit
+ * Description  : smux module clean routine
+ * Returns      : None
+ ***************************************************************************/
+static void __exit smux_drv_exit(void)
+{
+	smux_ioctl_set(NULL);
+
+	/* Un-register us from receiving netdevice events */
+	unregister_netdevice_notifier(&smux_notifier_block);
+	smux_cleanup_devices();
+	synchronize_net();
+} /* smux_drv_exit */
+
+/*jwj: It is not used now.*/
+int rtl_get_vid_of_smux_dev(char *name)
+{
+	struct smux_dev_info *dev_info;
+	struct net_device *vdev;
+
+	vdev = dev_get_by_name(&init_net, name);
+	if (!vdev)
+		return -1;
+
+	dev_put(vdev);
+	dev_info = SMUX_DEV_INFO(vdev);
+
+	if (dev_info->vid != -1)
+		return dev_info->vid;
+	else {
+		if (dev_info->proto == SMUX_PROTO_BRIDGE)
+			return RTL_BRIDGE_WANVLANID;
+		else
+			return RTL_WANVLANID;
+	}
+}
+
+/*jwj: This API is used for hw multicast member port set. ?????*/
+unsigned int rtl_get_member_of_smux_dev_by_vid(unsigned int vid)
+{
+	struct smux_dev_info *dev_info;
+	struct net_device *vdev;
+	unsigned char name[MAX_IFNAMESIZE];
+
+	rtl865x_get_master_netif_by_vid(vid, name);
+
+	vdev = dev_get_by_name(&init_net, name);
+	if (!vdev)
+		return -1;
+
+	dev_put(vdev);
+
+	dev_info = SMUX_DEV_INFO(vdev);
+
+	return dev_info->member;
+}
+
+int rtl_smux_upstream_port_mapping_check(struct sk_buff *skb)
+{
+	struct net_device *from, *to;
+	struct smux_dev_info *dev_info;
+	unsigned int member, port;
+
+	from = skb->from_dev;
+	to = skb->dev;
+
+	dev_info = SMUX_DEV_INFO(to);
+	member = dev_info->member;
+
+	if (from->priv_flags & IFF_DOMAIN_ELAN) {
+		TOKEN_NUM(from->name, &port);
+		port -= 1;
+	} else if (from->priv_flags & IFF_DOMAIN_WLAN) {
+	    	TOKEN_NUM(from->name,&port);
+	} else {
+		//printk("%s not from lan dev.\n", __function__);
+		return 0;
+	}
+
+	if (member & (1<<port)) {
+		return 1;
+	}
+
+	return 0;
+}
+
+int rtl_smux_downstream_port_mapping_check(struct sk_buff *skb)
+{
+	struct net_device *from, *to;
+	struct smux_dev_info *dev_info;
+	unsigned int member, port_mask;
+
+	from = skb->from_dev;
+	to = skb->dev;
+
+	dev_info = SMUX_DEV_INFO(from);
+	member = dev_info->member;
+
+ #if 0
+	if (to->priv_flags & IFF_DOMAIN_ELAN) {
+		TOKEN_NUM(to->name, &port);
+		if (port > 1)
+			port -= 1;
+	} else if (to->priv_flags & IFF_DOMAIN_WLAN) {
+		/*jwj: wlan dev name index???*/
+	    	TOKEN_NUM(to->name, &port);
+	} else {
+		//	printk("%s not to lan dev.\n", __function__);
+		return 0;
+	}
+
+	if (member & (1<<port)) {
+		printk("%s %d from %s to %s member0x%x  member & (1<<port)=true \n", __FUNCTION__, __LINE__, from->name, to->name, member);
+		return 1;
+	}
+#else
+	port_mask = rtl_get_bind_port_mask_by_dev_name(to->name);
+	if (member & port_mask) {
+		//printk("%s %d from %s to %s member0x%x  member & port_mask=true \n", __FUNCTION__, __LINE__, from->name, to->name, member);
+		return 1;
+	}
+#endif
+
+	return 0;
+}
+
+#ifdef CONFIG_PORT_MIRROR
+static inline void smux_mirror_pkt(struct sk_buff *skb,
+					const struct smux_dev_info *dev_info, const int flag)
+{
+	struct sk_buff *skb2;
+	//AUG_DBG("the dev_info->port_mirror is %d\n", dev_info->port_mirror);
+	if ((skb2 = skb_clone(skb, GFP_ATOMIC)) != NULL)
+	{
+		skb2->dev = dev_info->mirror_dev;
+
+		if(IN == flag)
+			skb_push(skb2, ETH_HLEN);
+
+		//AUG_DBG("the dev_info->mirror_dev is %s\n", dev_info->mirror_dev->name);
+		nic_tx_mirror(skb2);
+	}
+}
+#endif
+module_init(smux_drv_init);
+module_exit(smux_drv_exit);
+
+EXPORT_SYMBOL(rtl_smux_pkt_recv);
+
+
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/rtl_nic.c b/drivers/soc/realtek/rtd129x/hw_nat/rtl_nic.c
new file mode 100644
index 00000000..969b0d8
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/rtl_nic.c
@@ -0,0 +1,29282 @@
+/*
+ * Copyright c                Realtek Semiconductor Corporation, 2003
+ * All rights reserved.
+ *
+ * $Header: /home/cvsroot/linux-2.6.19/linux-2.6.x/drivers/net/re865x/rtl_nic.c,v 1.22 2008/04/11 10:49:14 bo_zhao Exp $
+ *
+ * $Author: bo_zhao $
+ *
+ * Abstract: Pure L2 NIC driver, without RTL865X's advanced L3/4 features.
+ *
+ *   re865x_nic.c: NIC driver for the RealTek 865*
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ */
+
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+#define DRV_RELDATE		"Jan 27, 2014"
+#include <linux/kconfig.h>
+#else
+#define DRV_RELDATE		"Mar 25, 2004"
+#include <linux/config.h>
+#endif
+/* #include <linux/autoconf.h> */
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/compiler.h>
+#include <linux/netdevice.h>
+#include <linux/inetdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/netfilter.h>
+#include <linux/init.h>
+#include <linux/pci.h>
+#include <linux/delay.h>
+#include <linux/ethtool.h>
+#include <linux/mii.h>
+#include <linux/if_vlan.h>
+#include <linux/crc32.h>
+#if defined(CONFIG_RTD_1295_HWNAT)
+#include <linux/io.h>
+#include <linux/uaccess.h>
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#include <asm/io.h>
+#include <asm/uaccess.h>
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#include <linux/slab.h>
+#include <linux/signal.h>
+#include <linux/proc_fs.h>
+#include <linux/time.h>
+#include <linux/rtc.h>
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_SOC_RTL8198C) && defined(CONFIG_OPENWRT_SDK)
+#include <asm/mach-realtek/bspchip.h>
+#elif defined(CONFIG_SOC_RTL8197F) && defined(CONFIG_OPENWRT_SDK)
+#include <asm/mach-rtl8197f/bspchip.h>
+#else
+#include <bsp/bspchip.h>
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+#include <linux/timer.h>
+#include <linux/if_bridge.h>
+#include <../net/bridge/br_private.h>
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+#include <net/rtl/rtk_vlan.h>
+#endif
+
+#ifdef CONFIG_RTL_VLAN_8021Q
+#include <linux/if_vlan.h>
+#endif
+
+/* if you need to use the fake eth driver, please also disable the "CONFIG_RTL_ETH_PRIV_SK" in kernel */
+/* #define CONFIG_RTK_FAKE_ETH 1 */
+
+#include "version.h"
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_glue.h>
+
+#include "AsicDriver/asicRegs.h"
+#include "AsicDriver/rtl865x_asicCom.h"
+#include "AsicDriver/rtl865x_asicL2.h"
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER_L3
+#include "AsicDriver/rtl865x_asicL3.h"
+#endif
+
+#include "common/mbuf.h"
+#include <net/rtl/rtl_queue.h>
+#include "common/rtl_errno.h"
+#include "rtl865xc_swNic.h"
+
+/*common*/
+#include "common/rtl865x_vlan.h"
+#include <net/rtl/rtl865x_netif.h>
+#include "common/rtl865x_netif_local.h"
+
+/*l2*/
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+#include "l2Driver/rtl865x_fdb.h"
+#include <net/rtl/rtl865x_fdb_api.h>
+#endif
+
+/*l3*/
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+#include "l3Driver/rtl865x_ip.h"
+#include "l3Driver/rtl865x_nexthop.h"
+#include <net/rtl/rtl865x_ppp.h>
+#include "l3Driver/rtl865x_ppp_local.h"
+#include "l3Driver/rtl865x_route.h"
+#include "l3Driver/rtl865x_arp.h"
+#include <net/rtl/rtl865x_nat.h>
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+#include "l3Driver/rtl8198c_nexthopIpv6.h"
+#include "l3Driver/rtl8198c_routeIpv6.h"
+#include "l3Driver/rtl8198c_arpIpv6.h"
+#endif
+
+#include "rtl865xc_swNic.h"
+
+#ifdef CONFIG_RTL_836X_SUPPORT
+#include "rtl836x/rtk_switch.h"
+#include "rtl836x/rtk_types.h"
+#include "rtl836x/rtk_error.h"
+#include "rtl836x/vlan.h"
+#include "rtl836x/cpu.h"
+#include "rtl836x/stat.h"
+#include "rtl836x/port.h"
+#include "rtl836x/l2.h"
+#include "rtl836x/rtk_rtl8367.h"
+extern spinlock_t rtl836x_ext_lock;
+#endif
+
+/*l4*/
+#ifdef	CONFIG_RTL865X_ROMEPERF
+#include "romeperf.h"
+#endif
+#include <net/rtl/rtl_nic.h>
+#if defined(CONFIG_RTL_FASTBRIDGE)
+#include <net/rtl/features/fast_bridge.h>
+#endif
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_NET_SCHED) && defined(CONFIG_RTL_LAYERED_DRIVER)
+#include <net/rtl/rtl865x_outputQueue.h>
+#endif
+
+#ifdef CONFIG_RTL_STP
+#include <net/rtl/rtk_stp.h>
+#endif
+
+#if defined(CONFIG_RTL_HW_STP)
+#include <net/rtl/rtk_stp.h>
+#endif
+
+#if defined(CONFIG_RTL_8196C_ESD) || defined(CONFIG_RTL_8198_ESD)
+#include <linux/reboot.h>
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+#include "rtl8367r/rtk_types.h"
+#endif
+
+#if defined(CONFIG_RTL_SWITCH_NEW_DESCRIPTOR)
+#include "rtl819x_swNic.h"
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+extern int gHwNatEnabled;
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+#include <net/rtl/rtl865x_igmpsnooping.h>
+#include <linux/if_ether.h>
+#include <linux/ip.h>
+#if defined(CONFIG_RTL_MLD_SNOOPING) || defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+#if defined(CONFIG_RTD_1295_HWNAT)
+#include <uapi/linux/ipv6.h>
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#include <linux/ipv6.h>
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+int mldSnoopEnabled;
+#endif
+uint32 nicIgmpModuleIndex = 0xFFFFFFFF;
+extern int igmpsnoopenabled;
+extern uint32 brIgmpModuleIndex;
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+extern struct net_bridge *bridge0;
+extern uint32 br0SwFwdPortMask;
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS) || defined(CONFIG_RTL_HARDWARE_MULTICAST)
+int rtl_enable_netif_routing(void);
+#endif
+#if defined(CONFIG_RTL_HW_MCAST_WIFI)
+extern int hwwifiEnable;
+#endif
+#endif
+extern int igmp_netfilter;
+#if defined (IMPROVE_MCAST_PERFORMANCE_WITH_RTL8367)
+extern int rtl_initMcastImprove(void);
+#endif
+#ifndef TEST_PACKETS
+#define TEST_PACKETS(mac) ((mac[0] == 0x01 && mac[1] == 0x00 && mac[2] == 0x5e && mac[3] == 0x01 && mac[4] == 0x02 && mac[5] == 0x03) || (mac[0] == 0x33 && mac[1] == 0x33 && mac[2] == 0x00 && mac[3] == 0x00 && mac[4] == 0x00 && mac[5] == 0x01))
+#endif
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define MODULENAME "rtd1295-hwnat"
+#include <linux/dma-mapping.h>
+#include <linux/platform_device.h>
+#include <linux/suspend.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_net.h>
+#include <linux/of_address.h>
+#include <linux/of_gpio.h>
+#include <linux/gpio.h>
+#include <linux/workqueue.h>
+#include <soc/realtek/rtk_cpu.h>
+#include "AsicDriver/rtl865x_asicBasic.h"
+
+#define RTL_DEBUG	1
+#ifdef RTL_DEBUG
+#define DBG(fmt, ...) pr_err("%s:%d: " fmt "\n", \
+				__func__, __LINE__, ## __VA_ARGS__)
+#else
+#define DBG(fmt, ...)
+#endif
+
+void __iomem *rtl_hwnat_mmio;
+void __iomem *rtl_hwnat_clk_mmio;
+void __iomem *rtl_hwnat_sata_mmio;
+unsigned int rtl_hwnat_base;
+struct platform_device *rtl819x_pdev;
+void rtl_dump_data(void *p, int len);
+extern uint8 hwnat_mac0_enable;	/* 0: interface used by SATA, 1: interface used by NAT */
+extern uint8 hwnat_mac0_mode;	/* 0:RGMII to PHY, 1:SGMII to PHY, 2: RGMII to MAC, 3: SGMII to MAC */
+extern uint8 hwnat_mac5_conn_to;	/* 0:PHY, 1:MAC */
+extern uint8 hwnat_rgmii_voltage;	/* 1:1.8V, 2:2.5V, 3:3.3V */
+extern uint8 hwnat_rgmii_enable;	/* 0:disable, 1:enable */
+extern uint8 hwnat_rgmii0_tx_delay;	/* 0 to 7: 0.5ns per step */
+extern uint8 hwnat_rgmii0_rx_delay;	/* 0 to 7: 0.5ns per step */
+extern uint8 hwnat_rgmii1_tx_delay;	/* 0 to 7: 0.5ns per step */
+extern uint8 hwnat_rgmii1_rx_delay;	/* 0 to 7: 0.5ns per step */
+extern uint8 hwnat_led_mode;		/* 0~3: SCAN_0~3, 4~6: DIRECT 0~2 */
+static uint8 hwnat_gpio_link_led_enable;	/* 0:disable, 1:enable */
+static uint8 hwnat_gpio_link_led;
+
+unsigned int RTL_LANPORT_MASK = RTL_DEF_LANPORT_MASK;
+#define RTL_SWNAT	1
+#if defined(RTL_SWNAT)
+bool rtl_hwnat_enable = false;
+
+void ntohl_array(u32 *org_buf, u32 *dst_buf, unsigned int words)
+{
+	int i = 0;
+
+	if (!org_buf || !dst_buf)
+		return;
+	while (words--) {
+		dst_buf[i] = ntohl(org_buf[i]);
+		i++;
+	}
+
+}
+
+int rtl819x_retore_hw_ip(void) {
+	return SUCCESS;
+}
+
+int get_dev_ip_mask(const char *name, unsigned int *ip, unsigned int *mask)
+{
+	struct in_device *in_dev;
+	struct net_device *landev;
+	struct in_ifaddr *ifap = NULL;
+
+	if ((name == NULL) || (ip == NULL) || (mask == NULL)) {
+		return -1;
+	}
+
+	if ((landev = __dev_get_by_name(&init_net, name)) != NULL) {
+		in_dev = (struct in_device *)(landev->ip_ptr);
+		if (in_dev != NULL) {
+			for (ifap = in_dev->ifa_list; ifap != NULL;
+				ifap = ifap->ifa_next) {
+				if (strcmp(name, ifap->ifa_label) == 0) {
+					*ip = ifap->ifa_address;
+					*mask = ifap->ifa_mask;
+					return 0;
+				}
+			}
+
+		}
+	}
+
+	return -1;
+}
+#else /* defined(RTL_SWNAT) */
+extern bool rtl_hwnat_enable;
+#endif /* defined(RTL_SWNAT) */
+extern void rtd129x_hwnat_clk_init(struct device *dev);
+extern void rtk_polling_mac0_lnk_status(void);
+#define CHECK_IF_HWNAT_READY if (!rtl_hwnat_enable) return SUCCESS
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+uint16 sw_pvid[RTL8651_PORT_NUMBER];
+#endif
+
+#ifndef TEST_PACKETS
+#define TEST_PACKETS(mac) ((mac[0] == 0x01 && mac[1] == 0x00 && mac[2] == 0x5e && mac[3] == 0x01 && mac[4] == 0x02 && mac[5] == 0x03) || (mac[0] == 0x33 && mac[1] == 0x33 && mac[2] == 0x00 && mac[3] == 0x00 && mac[4] == 0x00 && mac[5] == 0x01))
+#endif
+
+__DRAM_FWD unsigned int _debug_flag;
+
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+#include <net/rtl/rtl_dot1x.h>
+extern rtl802Dot1xConfig dot1x_config;
+extern void rtl_82dot1xCheckPortState(void);
+extern int rtl_802dot1xIoctl(struct net_device *dev, struct ifreq *rq, int cmd);
+extern __MIPS16
+	int rtl_802dot1xRxHandle(struct sk_buff *skb, rtl_nicRx_info *info);
+extern int rtl_is802dot1xFrame(uint8 *macFrame);
+extern void rtl_802dot1xFilltxInfo(struct sk_buff *skb, rtl_nicTx_info *info);
+#endif
+
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+#define LINK_TRUNK_HASH_TYPE_DA_SA     (0x00)
+#define LINK_TRUNK_HASH_TYPE_DA        (0x01)
+#define LINK_TRUNK_HASH_TYPE_SA        (0x02)
+
+#define LINK_TRUNK_HASH_MAX_INDEX      (0x07)
+
+#define LAG_MASK_TO_PORT(x) (ffs(x) - (1))
+
+uint32 last_up_trunk_msk = 0;
+uint32 last_down_trunk_msk = 0;
+
+void rtl_lag_check_trunk_port_state(void);
+#endif
+
+#if defined(CONFIG_NET_SCHED)
+extern int32 rtl_qos_init(void);
+#endif
+
+#if defined(CONFIG_RTL_DNS_TRAP)
+int rtl_add_Acl_for_dns_trap(struct rtl865x_vlanConfig *vlanConfig);
+int rtl_remove_Acl_for_dns_trap(struct rtl865x_vlanConfig *vlanConfig);
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+extern int rtl_8367_add_acl_for_dns(unsigned int acl_idx);
+extern int rtl_8367_remove_acl_for_dns(unsigned int acl_idx);
+#endif
+#endif
+
+/* to_be_checked !!! */
+#if !defined(CONFIG_RTL_8198C) &&  !defined(CONFIG_RTL_8197F) &&  !defined(CONFIG_OPENWRT_SDK)
+#define CONFIG_TR181_ETH		1
+#endif
+
+#if defined(CONFIG_RLX) && (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 10, 0))	/* added by lynn_pu, 2014-10-30 */
+#undef CONFIG_TR181_ETH
+#endif
+
+/* #define CONFIG_RTL_JATE_TEST		1 */
+#ifdef CONFIG_RTL_JATE_TEST
+static int32 rtl819x_jate_proc_init(void);
+#endif
+
+#if defined(CONFIG_RTK_VLAN_WAN_TAG_SUPPORT)
+uint32 nicIgmpModuleIndex_2 = 0xFFFFFFFF;
+extern uint32 brIgmpModuleIndex_2;
+#define VLAN_CONFIG_SIZE sizeof(vlanconfig)/sizeof(struct rtl865x_vlanConfig)
+#define VLAN_CONFIG_PPPOE_INDEX (VLAN_CONFIG_SIZE-1)
+#endif
+
+#if defined(CONFIG_RTL_8198_INBAND_AP) || defined(CONFIG_RTL_8198_NFBI_BOARD)
+#define CONFIG_819X_PHY_RW 1
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+#include <net/rtl/rtl_multi_wan.h>
+#define RTL_BRIDGE_WAN_SUPPORT_PORT_MAPPING 1
+int enable_port_mapping = 1;
+int enable_vlan_grouping = 0;
+static unsigned int pvid_per_port[RTL8651_PORT_NUMBER + 3] =
+	{[0 ... RTL8651_PORT_NUMBER + 2] = RTL_LANVLANID };
+static struct lan_dev_bind_mask_drv
+	lan_dev_bind_mask_mapping_drv[LAN_DEV_NUM_MAX] = {
+	{RTL_DRV_ETHLAN_P0_NETIF_NAME, RTL_ETH_LAN0_BIND_MASK},
+	{RTL_DRV_LAN_P1_NETIF_NAME, RTL_ETH_LAN1_BIND_MASK},
+	{RTL_DRV_LAN_P2_NETIF_NAME, RTL_ETH_LAN2_BIND_MASK},
+	{RTL_DRV_LAN_P3_NETIF_NAME, RTL_ETH_LAN3_BIND_MASK},
+	{RTL_DRV_WLAN0_DEV_NAME, RTL_WLAN0_BIND_MASK},
+	{RTL_DRV_WLAN0_VA0_DEV_NAME, RTL_WLAN0_VA0_BIND_MASK},
+	{RTL_DRV_WLAN0_VA1_DEV_NAME, RTL_WLAN0_VA1_BIND_MASK},
+	{RTL_DRV_WLAN0_VA2_DEV_NAME, RTL_WLAN0_VA2_BIND_MASK},
+	{RTL_DRV_WLAN0_VA3_DEV_NAME, RTL_WLAN0_VA3_BIND_MASK},
+	{RTL_DRV_WLAN1_DEV_NAME, RTL_WLAN1_BIND_MASK},
+	{RTL_DRV_WLAN1_VA0_DEV_NAME, RTL_WLAN1_VA0_BIND_MASK},
+	{RTL_DRV_WLAN1_VA1_DEV_NAME, RTL_WLAN1_VA1_BIND_MASK},
+	{RTL_DRV_WLAN1_VA2_DEV_NAME, RTL_WLAN1_VA2_BIND_MASK},
+	{RTL_DRV_WLAN1_VA3_DEV_NAME, RTL_WLAN1_VA3_BIND_MASK},
+};
+#endif
+
+#ifdef CONFIG_SMP
+int lock_owner = -1;
+int lock_owner_rx = -1;
+int lock_owner_tx = -1;
+int lock_owner_buf = -1;
+int lock_owner_hw = -1;
+int lock_owner_event = -1;
+spinlock_t lock_eth_other;
+spinlock_t lock_eth_rx;
+spinlock_t lock_eth_tx;
+spinlock_t lock_eth_buf;
+spinlock_t lock_eth_hw;
+spinlock_t lock_eth_event;
+#endif
+
+#if defined(CONFIG_SMP) && defined(CONFIG_RTL_IGMP_SNOOPING)
+int lock_owner_igmp = -1;
+spinlock_t lock_igmp;
+int lock_owner_igmp_concurrent = -1;
+spinlock_t lock_igmp_concurrent;
+#endif
+
+static unsigned int curLinkPortMask = 0;
+static unsigned int newLinkPortMask = 0;
+
+#ifdef CONFIG_RTL_JUMBO_FRAME
+uint32 jumboFrameFlag = 0;
+static uint32 jumboFrameSize = 0;
+#define JUMBO_FRAME_SIZE_NORMAL	1536
+#define JUMBO_FRAME_SIZE_9K	9000
+#define JUMBO_FRAME_SIZE_16K	16000
+#endif
+
+#if defined(CONFIG_RTL_8197D_DYN_THR) || defined(CONFIG_RTL_LONG_ETH_CABLE_REFINE)
+int do_it_once = 0;
+#endif
+
+#ifdef CONFIG_RTL_8198C
+#define CONFIG_RTL_8198C_10M_REFINE		1
+static int _8198c_link_check = 0;
+extern int giga_lite_enabled;
+#endif
+
+extern rtl8651_tblAsic_ethernet_t rtl8651AsicEthernetTable[];
+
+#define SET_MODULE_OWNER(dev) do { } while (0)
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+#include <net/rtl/rtl865x_multicast.h>
+#endif
+
+#ifdef CONFIG_RTK_VOIP_PORT_LINK
+#include <net/netlink.h>
+#include <linux/rtnetlink.h>
+static int rtnl_fill_ifinfo_voip(struct sk_buff *skb, struct net_device *dev,
+	int type, u32 pid, u32 seq, u32 change, unsigned int flags);
+static void rtmsg_ifinfo_voip(int type, struct net_device *dev,
+	unsigned change);
+#endif
+
+#if defined(CONFIG_OPENWRT_SDK)
+#define CONFIG_RTK_PORT_LINK
+#endif
+#ifdef CONFIG_RTK_PORT_LINK
+#include <net/netlink.h>
+#include <linux/rtnetlink.h>
+static int ethernet_rtnl_fill_ifinfo(struct sk_buff *skb,
+	struct net_device *dev, int type, u32 pid, u32 seq, u32 change,
+	unsigned int flags, unsigned int status);
+static void ethernet_rtmsg_ifinfo(int type, struct net_device *dev,
+	unsigned change, unsigned int status);
+int rtl_get_net_device_by_port(struct net_device **dev, unsigned int port);
+int curLinkCheck = 0;
+#endif
+
+#ifdef CONFIG_RTK_OPENVPN_HW_CRYPTO
+extern int rtk_openvpn_hw_encrypto(struct sk_buff *skb, int flag);
+extern int rtk_openvpn_hw_decrypto(struct sk_buff *skb, int flag);
+extern int get_openvpn_port(void);
+#endif
+#ifdef CONFIG_RTK_VOIP_ETHERNET_DSP
+void voip_dsp_L2_pkt_rx(unsigned char *eth_pkt);
+#endif
+
+#ifdef CONFIG_RTK_VOIP_ETHERNET_DSP
+/* merged from r8627 may conflict later */
+void (*voip_dsp_L2_pkt_rx_trap)(unsigned char *eth_pkt, unsigned long size) = NULL;	/* pkshih: eth_pkt content may be modified!! */
+#endif
+
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+__DRAM_FWD static int oldStatus;
+static char passThru_flag[1];
+static int32 __init rtl8651_customPassthru_init(void);
+static inline int32 rtl_isPassthruFrame(uint8 *data);
+extern unsigned int _br0_ip;
+extern unsigned int _br0_mask;
+#endif
+
+static int32 rtl8651_initStormCtrl(void);
+/* #define CONFIG_RTL_WAN_PORT_SETTING 1 */
+#if defined(CONFIG_RTL_WAN_PORT_SETTING)
+static int32 rtl819x_initWanPortSetting(void);
+static void __exit rtl819x_exitWanPortSetting(void);
+#endif
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB) && (defined(CONFIG_NET_WIRELESS_AGN) || defined(CONFIG_NET_WIRELESS_AG) || defined(CONFIG_WIRELESS))
+#include <net/dst.h>
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+#define NETDRV_PRIV(X) netdev_priv(X)
+#else
+#define NETDRV_PRIV(X) ((X)->priv)
+#endif
+
+#if 0
+#define DEBUG_ERR printk
+#else
+#define DEBUG_ERR(format, args...)
+#endif
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+#include <net/rtl/rtl865x_localPublic.h>
+#endif
+
+extern int eee_enabled;
+
+static int32 __865X_Config;
+#if defined(DYNAMIC_ADJUST_TASKLET) || defined(BR_SHORTCUT)
+#if 0
+static int eth_flag = 12;	/* 0 dynamic tasklet, 1 - disable tasklet, 2 - always tasklet , bit2 - bridge shortcut enabled */
+#endif
+#endif
+#if defined(BR_SHORTCUT)
+__DRAM_FWD unsigned char cached_eth_addr[ETHER_ADDR_LEN];
+EXPORT_SYMBOL(cached_eth_addr);
+__DRAM_FWD struct net_device *cached_dev;
+EXPORT_SYMBOL(cached_dev);
+#if defined(CONFIG_WIRELESS_LAN_MODULE)
+struct net_device *(*wirelessnet_hook_shortcut)(unsigned char *da) = NULL;
+EXPORT_SYMBOL(wirelessnet_hook_shortcut);
+int (*wirelessnet_hook)(void) = NULL;
+EXPORT_SYMBOL(wirelessnet_hook);
+#endif
+__DRAM_FWD unsigned char cached_eth_addr2[ETHER_ADDR_LEN];
+EXPORT_SYMBOL(cached_eth_addr2);
+__DRAM_FWD struct net_device *cached_dev2;
+EXPORT_SYMBOL(cached_dev2);
+int last_used = 1;
+__DRAM_FWD unsigned char cached_eth_addr3[ETHER_ADDR_LEN];
+EXPORT_SYMBOL(cached_eth_addr3);
+__DRAM_FWD struct net_device *cached_dev3;
+EXPORT_SYMBOL(cached_dev3);
+__DRAM_FWD unsigned char cached_eth_addr4[ETHER_ADDR_LEN];
+EXPORT_SYMBOL(cached_eth_addr4);
+__DRAM_FWD struct net_device *cached_dev4;
+EXPORT_SYMBOL(cached_dev4);
+#ifdef CONFIG_SWCONFIG		/* mark_brc */
+__DRAM_FWD uint16 cached_eth_vid;
+EXPORT_SYMBOL(cached_eth_vid);
+#endif
+#endif
+
+#if defined(REINIT_SWITCH_CORE)
+#define STATE_NO_ERROR 0
+#define STATE_SW_CLK_ENABLE_WAITING 1
+#define STATE_TO_REINIT_SWITCH_CORE  2
+int rtl865x_duringReInitSwtichCore = 0;
+int rtl865x_reInitState = STATE_NO_ERROR;
+int rtl865x_reInitWaitCnt = 0;
+/* #if defined(CONFIG_RTL_CHECK_SWITCH_TX_HANGUP) */
+static int32 rtl_last_tx_done_idx = 0;
+static int32 rtl_swCore_tx_hang_cnt = 0;
+static uint32 rtl_check_swCore_timer = 0;
+static int32 rtl_check_swCore_tx_hang_interval = 10;
+static int32 rtl_reinit_swCore_threshold = 3;
+static int32 rtl_reinit_swCore_counter = 0;
+static int32 rtl_check_tx_hang_flag = 1;
+int rtl_check_swCore_tx_hang(void);
+extern int32 rtl_check_tx_done_desc_swCore_own(int32 *tx_done_inx);
+/* #endif */
+#endif
+#if defined(CONFIG_RTL_UNKOWN_UNICAST_CONTROL)
+static rtlMacRecord macRecord[RTL_MAC_RECORD_NUM];
+/* static uint32 macRecordIdx; */
+static spinlock_t unknown_unicast_lock;
+static uint8 lanIfName[NETIF_NUMBER];
+static void rtl_unkownUnicastUpdate(struct sk_buff *skb);
+static void rtl_unkownUnicastTimer(unsigned long data);
+static void rtl_clearUnknownUnicastCnt(void);
+#endif
+
+#if defined(DYNAMIC_ADJUST_TASKLET) || defined(RTL8196C_EEE_MAC) || defined(CONFIG_RTL_8198_ESD)
+static void one_sec_timer(unsigned long task_priv);
+#endif
+
+#ifdef CONFIG_RTL8196C_GREEN_ETHERNET
+static void power_save_timer(unsigned long task_priv);
+#endif
+
+/* #define CONFIG_RTL_LINKSTATE */
+#if defined(CONFIG_RTL_LINKSTATE)
+static struct timer_list s_timer;
+static void linkup_time_handle(unsigned long arg);
+static int32 initPortStateCtrl(void);
+static void exitPortStateCtrl(void);
+#endif
+
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT
+#define PORT_NUMBER 6
+struct hw_vlan_port_setting {
+	int32 vlan_port_enabled;
+	int32 vlan_port_bridge;
+	int32 vlan_port_tag;
+	int32 vlan_port_vid;
+};
+int rtl_hw_vlan_ignore_tagged_mc = 1;
+
+struct hw_vlan_port_setting hw_vlan_info[PORT_NUMBER];
+
+__DRAM_FWD int32 rtl_hw_vlan_enable = 0;
+#endif
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+__MIPS16 __IRAM_FWD static struct sk_buff *dev_alloc_skb_priv_eth(unsigned int
+	size);
+static void init_priv_eth_skb_buf(void);
+#endif
+
+#if defined(CONFIG_RTK_QOS_FOR_CABLE_MODEM)
+static void rtl_initVlanTableForCableMode(void);
+#endif
+
+static int32 rtl819x_eee_proc_init(void);
+
+__DRAM_FWD static struct ring_que rx_skb_queue;
+int skb_num = 0;
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN) || defined(CONFIG_RTL_MAC_BASED_NETIF)
+#define MULTICAST_NETIF_VLAN_ID		678
+static char multiCastNetIf[20] = { "multiCastNetIf" };
+static char multiCastNetIfMac[6] = { 0x00, 0x11, 0x12, 0x13, 0x14, 0x15 };
+
+static int rtl865x_addMultiCastNetif(void);
+#endif
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+#include <linux/if_arp.h>
+static struct net_device *rtl_multiWan_net_dev;
+#if defined(CONFIG_RTD_1295_HWNAT)
+static char igmp_proxy_wan_dev[MAX_IFNAMESIZE] = { "eth0" };
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+static char igmp_proxy_wan_dev[MAX_IFNAMESIZE] = { "eth1" };
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#ifndef CONFIG_RTL_PROC_NEW
+static struct proc_dir_entry *res_igmp_proxy_wan_dev = NULL;
+#endif
+static int rtl_regist_multipleWan_dev(void);
+static int rtl_config_multipleWan_netif(int32 cmd);
+static int rtl_port_used_by_device(uint32 portMask);
+
+static int rtl865x_isArpFrame(struct sk_buff *skb, int *ah_offset);
+extern int get_dev_ip_mask(const char *name, unsigned int *ip,
+	unsigned int *mask);
+static inline int rtl865x_decideUcDevice(unsigned char *data, int pid,
+	rtl_nicRx_info *info);
+static inline int rtl865x_decideMcDevice(int pid, rtl_nicRx_info *info);
+static inline int rtl865x_decideBcDevice(struct sk_buff *skb, int pid,
+	rtl_nicRx_info *info);
+static int32 rtl819x_igmp_proxy_wan_dev_proc_init(void);
+#if 0
+static int rtl865x_delMultiCastNetif(void);
+int rtl865x_setMultiCastSrcMac(unsigned char *srcMac);
+#endif
+#endif
+
+#ifdef CONFIG_OPENWRT_SDK
+#include "common/rtl865x_eventMgr.h"
+#include "rtl865x_proc_debug.h"
+
+#define RTK_WRT_MAC_FROM_HWSET 1	/* mark_wrt */
+
+int rtl865x_reinitSwitchCore(void);
+int32 phyRegTest_init(void);
+int rtl865x_creatReInitSwitchCoreProc(void);
+extern void FullAndSemiReset(void);
+extern int32 rtl865x_layer2_reinit(void);
+extern uint64 rtl865xC_returnAsicCounter64(uint32 offset);
+int32 rtl8651_initStormCtrl(void);
+#ifdef CONFIG_RTL_8367R_SUPPORT
+extern int rtl865x_disableRtl8367ToCpuAcl(void);
+extern int rtk_port_phyStatus_get(uint32 port, uint32 *pLinkStatus,
+	uint32 *pSpeed, uint32 *pDuplex);
+#endif
+
+#endif
+
+#ifdef CONFIG_SWCONFIG
+#include "rtl819x_switch.h"
+#include <linux/switch.h>
+static struct dev_priv *rtk_decide_vlan_cp(int pid, struct sk_buff *skb);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static void rtk_add_cpuport_tag(uint16 vid, uint32 pid, struct sk_buff *skb);
+#else
+static void rtk_add_cpuport_tag(uint16 vid, struct sk_buff *skb);
+#endif
+static void rtk_fill_vlan_txinfo(struct sk_buff *skb, uint16 *vid,
+	uint16 *member);
+static inline void rtk_rm_skb_vid(struct sk_buff *skb);
+static inline uint16 rtk_get_skb_vid(struct sk_buff *skb);
+
+int swconfig_vlan_enable = 0;
+EXPORT_SYMBOL(swconfig_vlan_enable);	/* for wifi shortcu */
+
+#if defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+uint32 hw_nat_lan_vid = 1;
+uint32 hw_nat_wan_vid = 2;
+char hw_nat_wan_dev_name[MAX_IFNAMESIZE] = { "eth0.2" };
+
+static int rtl_create_hw_nat_vid_proc(void);
+static int32 rtl_process_hw_netif(uint16 vid);
+static int32 rtl_process_hw_l3_default_router(void);
+#endif
+#endif
+
+int32 rtl865x_init(void);
+int32 rtl865x_config(struct rtl865x_vlanConfig vlanconfig[]);
+
+/* These identify the driver base version and may not be removed. */
+MODULE_DESCRIPTION("RealTek RTL-8650 series 10/100 Ethernet driver");
+MODULE_LICENSE("GPL");
+
+#ifdef CONFIG_DEFAULTS_KERNEL_2_6
+static char *multicast_filter_limit =
+	"maximum number of filtered multicast addresses";
+module_param(multicast_filter_limit, charp, S_IRUGO);
+#else
+/* Maximum number of multicast addresses to filter (vs. Rx-all-multicast).
+   The RTL chips use a 64 element hash table based on the Ethernet CRC.  */
+MODULE_PARM(multicast_filter_limit, "i");
+MODULE_PARM_DESC(multicast_filter_limit,
+	"maximum number of filtered multicast addresses");
+#endif
+
+#define DRV_NAME		"re865x_nic"
+#define PFX			DRV_NAME ": "
+#define DRV_VERSION		"0.1"
+#define TX_TIMEOUT		(10*HZ)
+#define BDINFO_ADDR 0xbe3fc000
+
+#define CONFIG_RTL_REPORT_LINK_STATUS
+
+#define CONFIG_RTL_PHY_POWER_CTRL
+
+#if defined(CONFIG_RTL_8197F) &&  defined(CONFIG_FINETUNE_RUNOUT_IRQ)
+
+#define DEF_FREE_PRIV_SKB_TRHRESHOLD 128
+int freeSkbThreshold = 128;
+
+/*
+unsigned long flags=0;
+local_irq_restore(flags);
+local_irq_restore(flags);
+
+*/
+
+inline void rtl865x_disableRunoutIrq(void);
+inline void rtl865x_enableRunoutIrq(void);
+inline int rtl865x_rxbufAvailable(void);
+#endif
+
+#if defined(CONFIG_RTL_PHY_POWER_CTRL)
+static int32 rtl865x_initPhyPowerCtrl(void);
+#endif
+
+#ifdef CONFIG_TR181_ETH
+#ifdef CONFIG_RTL_PROC_NEW
+static int tr181_eth_link_read(struct seq_file *s, void *v);
+static int tr181_eth_if_read(struct seq_file *s, void *v);
+static int tr181_eth_stats_read(struct seq_file *s, void *v);
+static int tr181_eth_set_read(struct seq_file *s, void *v);
+#else
+static int tr181_eth_link_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+static int tr181_eth_if_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+static int tr181_eth_stats_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+static int tr181_eth_set_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+#endif
+static int tr181_eth_link_write(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+static int tr181_eth_if_write(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+static int tr181_eth_stats_write(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+static int tr181_eth_set_write(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+#endif
+
+#ifdef CONFIG_RTL_INBAND_CTL_ACL
+#ifdef CONFIG_RTL_PROC_NEW
+static int inband_ctl_acl_read(struct seq_file *s, void *v);
+#else
+static int inband_ctl_acl_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+#endif
+static int inband_ctl_acl_write(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+static int inband_ctl_acl_ethernet_type;
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+int dslite_hw_fw = 0;
+#endif
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+int sixrd_hw_fw = 0;
+#endif
+#endif
+
+#if	defined(CONFIG_PPPOE_VLANTAG)
+struct vlan_info *rtl_get_PPPOE_vlanInfo(void);
+
+static int read_PPPOE_proc_vlan(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+
+static int write_PPPOE_proc_vlan(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+
+#endif
+
+#if defined(RX_TASKLET)
+__DRAM_GEN int rtl_rx_tasklet_running;
+#endif
+#if defined(TX_TASKLET)
+__DRAM_GEN int rtl_tx_tasklet_running;
+#endif
+
+__IRAM_GEN static inline void rtl_rx_interrupt_process(unsigned int status,
+	struct dev_priv *cp);
+__IRAM_GEN static inline void rtl_tx_interrupt_process(unsigned int status,
+	struct dev_priv *cp);
+#if	defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_RTL_LINKCHG_PROCESS) || defined(CONFIG_RTL_PHY_PATCH) || defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+__IRAM_GEN static inline void rtl_link_change_interrupt_process(unsigned int
+	status, struct dev_priv *cp);
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+atomic_t rtl_rxTxDoneCnt;
+atomic_t rtl_devOpened;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+static int rtl_rxTxDoneCnt = 0;
+static atomic_t rtl_devOpened;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+extern unsigned int rx_noBuffer_cnt;
+extern unsigned int tx_ringFull_cnt;
+extern unsigned int tx_drop_cnt;
+#endif
+
+#if defined(CONFIG_RTL_819XD)
+static int rtl_port0Refined = 0;
+#endif
+
+#if defined(CONFIG_RTL_8370_SUPPORT)
+static int rtl8211eLinkStsSpeed = 0;
+#endif
+
+__MIPS16 __IRAM_GEN void rtl_rxSetTxDone(int enable)
+{
+	if (unlikely(rtl_devOpened.counter == 0))
+		return;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (FALSE == enable) {
+		atomic_dec(&rtl_rxTxDoneCnt);
+		if (atomic_read(&rtl_rxTxDoneCnt) == -1)
+			REG32(CPUIIMR) &= ~(TX_ALL_DONE_IE_ALL);
+	} else {
+		atomic_inc(&rtl_rxTxDoneCnt);
+		if (atomic_read(&rtl_rxTxDoneCnt) == 0)
+			REG32(CPUIIMR) |= (TX_ALL_DONE_IE_ALL);
+	}
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (FALSE == enable) {
+		rtl_rxTxDoneCnt--;
+		if (rtl_rxTxDoneCnt == -1)
+			REG32(CPUIIMR) &= ~(TX_ALL_DONE_IE_ALL);
+	} else {
+		rtl_rxTxDoneCnt++;
+		if (rtl_rxTxDoneCnt == 0)
+			REG32(CPUIIMR) |= (TX_ALL_DONE_IE_ALL);
+	}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}
+
+#define NEXT_DEV(cp)			(cp->dev_next ? cp->dev_next : cp->dev_prev)
+#define NEXT_CP(cp)			((struct dev_priv *)((NEXT_DEV(cp))->priv))
+#define IS_FIRST_DEV(cp)	(NEXT_CP(cp)->opened ? 0 : 1)
+#define GET_IRQ_OWNER(cp) (cp->irq_owner ? cp->dev : NEXT_DEV(cp))
+
+#define MAX_PORT_NUM 9
+
+static unsigned int rxRingSize[RTL865X_SWNIC_RXRING_HW_PKTDESC] =
+	{NUM_RX_PKTHDR_DESC,
+	NUM_RX_PKTHDR_DESC1,
+	NUM_RX_PKTHDR_DESC2,
+	NUM_RX_PKTHDR_DESC3,
+	NUM_RX_PKTHDR_DESC4,
+	NUM_RX_PKTHDR_DESC5};
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static unsigned int txRingSize[RTL865X_SWNIC_TXRING_HW_PKTDESC] =
+	{NUM_TX_PKTHDR_DESC,
+	NUM_TX_PKTHDR_DESC1,
+	NUM_TX_PKTHDR_DESC2,
+	NUM_TX_PKTHDR_DESC3
+	};
+#else
+static unsigned int txRingSize[RTL865X_SWNIC_TXRING_HW_PKTDESC] =
+	{NUM_TX_PKTHDR_DESC,
+	NUM_TX_PKTHDR_DESC1};
+#endif
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q) || defined(CONFIG_RTL_DNS_TRAP)
+static struct rtl865x_vlanConfig packedVlanConfig[NETIF_NUMBER * 2];
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+int vlan_tag;
+int vlan_host_pri;
+int vlan_bridge_tag;
+int vlan_bridge_port;
+int vlan_bridge_multicast_tag;
+#endif
+
+/*
+linux protocol stack netif VS rtl819x driver network interface
+the name of ps netif maybe different with driver.
+*/
+static ps_drv_netif_mapping_t ps_drv_netif_mapping[NETIF_NUMBER];
+#ifndef CONFIG_SWCONFIG
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+static struct rtl865x_vlanConfig vlanconfig[] = {
+/*		ifName  W/L      If type		VID	 FID	   Member Port	UntagSet		mtu		MAC Addr	is_slave	proto							*/
+/*		=====  ===   =======	===	 ===   =========   =======	====	====================================	*/
+
+/* LAN interface */
+#ifdef CONFIG_RTL_MULTI_LAN_DEV
+	{	RTL_DRV_LAN_P0_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_4,		RTL_LANPORT_MASK_4,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0, 0 },
+	{	RTL_DRV_LAN_P4_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_LAN_P1_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_3,		RTL_LANPORT_MASK_3,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0, 0 },
+	{	RTL_DRV_LAN_P2_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_2,		RTL_LANPORT_MASK_2,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0, 0 },
+	{	RTL_DRV_LAN_P3_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID, 		RTL_LANPORT_MASK_1,		RTL_LANPORT_MASK_1,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0, 0 },
+#else
+	{	RTL_DRV_LAN_NETIF_NAME,		0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID, 		RTL_LANPORT_MASK,		RTL_LANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0, 0 },
+#endif
+
+/*	Multi-WAN interface (all vid = 0 by default, it means all multi-wan netif's "name" have not been used yet, "net_device" will be created in smux)
+	When you create a new WAN connection , please call rtl_set_wanport_vlanconfig() (or rtl_register_multi_wan_dev)
+	This function will help you handle the setting of Network interface table, VLAN table and PVID in hw.
+*/
+#ifndef CONFIG_RTL_MULTI_LAN_DEV
+	{	RTL_DRV_WAN0_NETIF_NAME,		1,	IF_ETHER,	RTL_WANVLANID,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+#endif
+	{	RTL_DRV_ETHWAN1_NETIF_NAME,		1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN2_NETIF_NAME,		1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN3_NETIF_NAME,		1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN4_NETIF_NAME,		1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN5_NETIF_NAME,		1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN6_NETIF_NAME,		1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN7_NETIF_NAME,		1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+
+	{	RTL_DRV_ETHWAN1_NETIF_NAME_EXTEND,	1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN2_NETIF_NAME_EXTEND,	1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN3_NETIF_NAME_EXTEND,	1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN4_NETIF_NAME_EXTEND,	1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN5_NETIF_NAME_EXTEND,	1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN6_NETIF_NAME_EXTEND,	1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+	{	RTL_DRV_ETHWAN7_NETIF_NAME_EXTEND,	1,	IF_ETHER,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0, 0 },
+
+/* PPP interface , please use rtl_add_ppp_netif() to create sw_netif (just data structure, not the actual net_device) in driver layer */
+	{	RTL_DRV_PPP0_NETIF_NAME,		1,	IF_PPPOE,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 1, 0 },
+	{	RTL_DRV_PPP1_NETIF_NAME,		1,	IF_PPPOE,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 1, 0 },
+	{	RTL_DRV_PPP2_NETIF_NAME,		1,	IF_PPPOE,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 1, 0 },
+	{	RTL_DRV_PPP3_NETIF_NAME,		1,	IF_PPPOE,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 1, 0 },
+	{	RTL_DRV_PPP4_NETIF_NAME,		1,	IF_PPPOE,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 1, 0 },
+	{	RTL_DRV_PPP5_NETIF_NAME,		1,	IF_PPPOE,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 1, 0 },
+	{	RTL_DRV_PPP6_NETIF_NAME,		1,	IF_PPPOE,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 1, 0 },
+	{	RTL_DRV_PPP7_NETIF_NAME,		1,	IF_PPPOE,		0,	RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 1, 0 },
+
+	RTL865X_CONFIG_END,
+};
+#else
+static struct rtl865x_vlanConfig vlanconfig[] = {
+/*		ifName  W/L      If type		VID	 FID	   Member Port	UntagSet		mtu		MAC Addr	is_slave								*/
+/*		=====  ===   =======	===	 ===   =========   =======	====	====================================	*/
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+#if defined(CONFIG_RTL_CPU_TAG)
+	{	RTL_DRV_LAN_P5_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x94 } }, 0 },
+	{	RTL_DRV_LAN_P1_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_1,		RTL_LANPORT_MASK_1,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x95 } }, 0 },
+	{	RTL_DRV_LAN_P2_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_2,		RTL_LANPORT_MASK_2,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x95 } }, 0 },
+#if 0
+	{	RTL_DRV_LAN_P3_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_3,		RTL_LANPORT_MASK_3,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x95 } }, 0 },
+	{	RTL_DRV_LAN_P0_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_0,		RTL_LANPORT_MASK_0,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x95 } }, 0 },
+#endif
+#else /* CONFIG_RTL_CPU_TAG */
+#if defined(CONFIG_RTL_WAN_MAC5)
+	{	RTL_DRV_LAN_P5_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_5,		RTL_LANPORT_MASK_5,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x95 } }, 0 },
+#else /* CONFIG_RTL_WAN_MAC5 */
+	{	RTL_DRV_LAN_P4_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x94 } }, 0 },
+	{	RTL_DRV_LAN_P5_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_5,		RTL_LANPORT_MASK_5,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x95 } }, 0 },
+	{	RTL_DRV_LAN_P0_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_1,		RTL_LANPORT_MASK_1,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+#endif /* CONFIG_RTL_WAN_MAC5 */
+#endif /* CONFIG_RTL_CPU_TAG */
+#else /* CONFIG_RTL_MULTI_LAN_DEV */
+#if defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)
+	{	RTL_DRV_LAN_P5_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x95 } }, 0 },
+#else /* CONFIG_RTL_2_RGMII_PORTS_ONLY */
+	{	RTL_DRV_LAN_P4_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x94 } }, 0 },
+#endif /* CONFIG_RTL_2_RGMII_PORTS_ONLY */
+	{	RTL_DRV_LAN_NETIF_NAME,		0,	IF_ETHER, 	RTL_LANVLANID,		RTL_LAN_FID,		RTL_DEF_LANPORT_MASK,		RTL_DEF_LANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+#endif /* CONFIG_RTL_MULTI_LAN_DEV */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#ifdef CONFIG_BRIDGE
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+	{	RTL_DRV_LAN_P0_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_4,		RTL_LANPORT_MASK_4,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+	{	RTL_DRV_LAN_P4_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0 },
+	{	RTL_DRV_LAN_P1_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_3,		RTL_LANPORT_MASK_3,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+	{	RTL_DRV_LAN_P2_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_2,		RTL_LANPORT_MASK_2,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+	{	RTL_DRV_LAN_P3_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_1,		RTL_LANPORT_MASK_1,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+#ifdef CONFIG_8198_PORT5_GMII
+	{	RTL_DRV_LAN_P5_NETIF_NAME, 	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_5,		RTL_LANPORT_MASK_5,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x95 } }, 0 },
+#endif /* CONFIG_8198_PORT5_GMII */
+#if defined(CONFIG_RTK_VLAN_SUPPORT) && defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+	{	RTL_DRV_LAN_P7_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		0,				0, 				1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x97 } }, 0 },
+#endif
+#else /*CONFIG_RTL_MULTI_LAN_DEV */
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	{	RTL_DRV_LAN_NETIF_NAME,		0,	IF_ETHER, 	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_4,		RTL_LANPORT_MASK_4,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+#else
+	{	RTL_DRV_LAN_NETIF_NAME,		0,	IF_ETHER, 	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK,		RTL_LANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+#endif
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+	{	RTL_GW_WAN_DEVICE_NAME,		1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0 },
+#else
+	{	RTL_DRV_WAN0_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0 },
+#endif
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	{	RTL_DRV_LAN_P1_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_3,		RTL_LANPORT_MASK_3,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x92 } }, 0 },
+	{	RTL_DRV_LAN_P2_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_2,		RTL_LANPORT_MASK_2,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x93 } }, 0 },
+	{	RTL_DRV_LAN_P3_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_1,		RTL_LANPORT_MASK_1,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x94 } }, 0 },
+#ifdef CONFIG_8198_PORT5_GMII
+	{	RTL_DRV_LAN_P5_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_5,		RTL_LANPORT_MASK_5,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x95 } }, 0 },
+#endif /* CONFIG_8198_PORT5_GMII */
+#ifdef CONFIG_RTK_BRIDGE_VLAN_SUPPORT
+	{	RTL_DRV_LAN_P7_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		0,				0,				1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x97 } }, 0 },
+#endif
+#endif
+#endif
+#else /* CONFIG_BRIDGE */
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+	{	RTL_DRV_LAN_P0_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_4,		RTL_LANPORT_MASK_4,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+	{	RTL_DRV_LAN_P4_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0 },
+	{	RTL_DRV_LAN_P1_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_3,		RTL_LANPORT_MASK_3,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+	{	RTL_DRV_LAN_P2_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_2,		RTL_LANPORT_MASK_2,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+	{	RTL_DRV_LAN_P3_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_1,		RTL_LANPORT_MASK_1,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+#if defined(CONFIG_RTK_VLAN_SUPPORT) && defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+	{	RTL_DRV_LAN_P7_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		0,				0,				1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x97 } }, 0 },
+#endif
+#else /* CONFIG_RTL_MULTI_LAN_DEV */
+	{	RTL_DRV_LAN_NETIF_NAME,		0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK, 		RTL_LANPORT_MASK,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+	{	RTL_DRV_WAN0_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 0 },
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	{	RTL_DRV_LAN_P1_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_3,		RTL_LANPORT_MASK_3,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x92 } }, 0 },
+	{	RTL_DRV_LAN_P2_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_2,		RTL_LANPORT_MASK_2,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x93 } }, 0 },
+	{	RTL_DRV_LAN_P3_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_1,		RTL_LANPORT_MASK_1,		1500, 	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x94 } }, 0 },
+#ifdef CONFIG_RTK_BRIDGE_VLAN_SUPPORT
+	{	RTL_DRV_LAN_P7_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		0,				0,				1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x97 } }, 0 },
+#endif
+#endif
+#endif
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	{	RTL_DRV_PPP_NETIF_NAME,		1,	IF_PPPOE,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, { { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 1 },
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	{	RTL_DRV_DSLT_NETIF_NAME,	1,	IF_DSLT,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, { { 0x00, 0x12, 0x34, 0x56, 0x78, 0x99 } }, 1 },
+#endif
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+	{	RTL_DRV_6RD_NETIF_NAME,		1,	IF_6RD,		RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500, { { 0x00, 0x12, 0x34, 0x56, 0x78, 0x98 } }, 1 },
+#endif
+#endif
+	RTL865X_CONFIG_END,
+};
+#endif
+#else /* CONFIG_SWCONFIG */
+static struct rtl865x_vlanConfig vlanconfig[] = {
+#if defined(CONFIG_RTD_1295_HWNAT)
+	{	RTL_DRV_LAN_P4_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x94 } }, 0 },
+	{	RTL_DRV_LAN_P5_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_5,		RTL_LANPORT_MASK_5,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x95 } }, 0 },
+	{	RTL_DRV_LAN_P0_NETIF_NAME,	0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK_1,		RTL_LANPORT_MASK_1,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } }, 0 },
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	{	RTL_DRV_LAN_NETIF_NAME,		0,	IF_ETHER,	RTL_LANVLANID,		RTL_LAN_FID,		RTL_LANPORT_MASK,		RTL_LANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x96 } }, 0 },
+	{	RTL_DRV_WAN0_NETIF_NAME,	1,	IF_ETHER,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x99 } }, 0 },
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+	{	RTL_DRV_PPP_NETIF_NAME,		1,	IF_PPPOE,	RTL_WANVLANID,		RTL_WAN_FID,		RTL_WANPORT_MASK,		RTL_WANPORT_MASK,		1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x91 } }, 1 },
+#endif
+	RTL865X_CONFIG_END,
+};
+#endif
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+int get_P2P_local_ip(unsigned char *ifname, unsigned int *ipAddr)
+{
+	struct in_ifaddr *ifap = NULL;
+	struct net_device *dev = NULL;
+	struct in_device *dslite_dev = NULL;
+
+	if (NULL == ifname || NULL == ipAddr)
+		return FAILED;
+
+	dev = __dev_get_by_name(&init_net, ifname);
+	dslite_dev = (struct in_device *)(dev->ip_ptr);
+	if (dslite_dev != NULL) {
+		for (ifap = dslite_dev->ifa_list; ifap != NULL;
+			ifap = ifap->ifa_next) {
+			if (strcmp(ifname, ifap->ifa_label) == 0) {
+				*ipAddr = htonl(ifap->ifa_local);
+				/* printk("%s,%d........p2p local ip(%u)\n",__FUNCTION__,__LINE__,ifap->ifa_local); */
+				return 1;
+			}
+		}
+	}
+	return 0;
+}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+static struct rtl865x_vlanConfig rtl_multiWan_config = { RTL_DRV_WAN1_NETIF_NAME,	1,	IF_ETHER,	RTL_WAN_1_VLANID,	RTL_WAN_FID,	RTL_WANPORT_MASK,	RTL_WANPORT_MASK,	1500,	{ { 0x00, 0x12, 0x34, 0x56, 0x78, 0x99 } }, 0 };
+#endif
+
+#if (defined(CONFIG_PROC_FS) && defined(CONFIG_NET_SCHED) && defined(CONFIG_RTL_LAYERED_DRIVER)) || (defined(CONFIG_RTL_HW_QOS_SUPPORT))
+static uint8 netIfName[NETIF_NUMBER][IFNAMSIZ] = { {0} };
+#endif
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+/*	The following structure's field orders was arranged for special purpose,
+	it should NOT be modify	*/
+
+struct priv_skb_buf2 {
+	unsigned char magic[ETH_MAGIC_LEN];
+	void *buf_pointer;
+	/* the below 2 filed MUST together */
+	struct list_head list;
+	unsigned char buf[ETH_SKB_BUF_SIZE];
+};
+
+static struct priv_skb_buf2 eth_skb_buf[MAX_ETH_SKB_NUM + 1];
+__DRAM_FWD static struct list_head eth_skbbuf_list;
+__DRAM_FWD int eth_skb_free_num;
+EXPORT_SYMBOL(eth_skb_free_num);
+extern struct sk_buff *dev_alloc_8190_skb(unsigned char *data, int size);
+struct sk_buff *priv_skb_copy(struct sk_buff *skb);
+#endif
+
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+struct vlan_info management_vlan;
+#endif
+
+#if defined(CONFIG_POCKET_AP_SUPPORT) || defined(CONFIG_RTL_AP_PACKAGE)
+int rtl865x_curOpMode = BRIDGE_MODE;
+#else
+int rtl865x_curOpMode = GATEWAY_MODE;
+#endif
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+extern int extPortEnabled;
+#endif
+
+EXPORT_SYMBOL(rtl865x_curOpMode);
+
+__DRAM_FWD static struct re865x_priv _rtl86xx_dev;
+
+#ifdef CONFIG_RTL8196C_GREEN_ETHERNET
+static struct timer_list expire_timer2;
+#endif
+
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+#define RTL865X_NAPI_WEIGHT 64
+static int rtl865x_poll(struct napi_struct *napi, int budget);
+#endif
+
+static int re865x_ioctl(struct net_device *dev, struct ifreq *rq, int cmd);
+static int32 reinit_vlan_configure(struct rtl865x_vlanConfig new_vlanconfig[]);
+#if defined(CONFIG_RTL_REPORT_LINK_STATUS)
+/*FIX ME if mutiple-wan*/
+static unsigned char rtk_linkEvent;
+static int block_link_change = 0;
+#define RTK_BLOCK_LINK_CHANGE_PERIOD 1
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rtk_link_event_read(struct seq_file *s, void *v);
+static int32 rtk_link_status_read(struct seq_file *s, void *v);
+#else
+static int32 rtk_link_event_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+static int32 rtk_link_status_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+#endif
+static int32 rtk_link_event_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+static int32 rtk_link_status_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+#endif
+
+#ifdef CONFIG_RTL_VLAN_8021Q
+extern linux_vlan_ctl_t *vlan_ctl_p;
+extern int linux_vlan_enable;
+extern int linux_vlan_hw_support_enable;
+extern uint16 rtk_vlan_wan_vid;
+extern uint16 rtk_vlan_hw_nat_lan_vid;
+
+#define RTK_DEDICATE_WAN_IF 1	/* mark_vc , use eth1 as nat wan , not eth0.xxx */
+
+#if 1
+#define RTK_WAN_PORT_MASK RTL_WANPORT_MASK
+#else
+#define RTK_WAN_PORT_IDX 4
+#define RTK_WAN_PORT_MASK  (0x3f & (1 << RTK_WAN_PORT_IDX))
+#endif
+
+#define RTK_CPU_PORT_IDX 6
+#define RTK_CPU_PORT_MASK  (1 << RTK_CPU_PORT_IDX)
+
+/* switch internal port maping */
+#define RTK_HW_CPU_PORT_IDX 8
+#define RTK_HW_CPU_PORT_MASK  (1 << RTK_HW_CPU_PORT_IDX)
+
+#define RTK_PHY_PORT_MASK  (0x1ff)
+#define RTK_PHY_PORT_NUM  9
+
+#define VID_FROM_PVID 0
+#define VID_FROM_PACKET 1
+
+/* static  struct rtl865x_vlanConfig packVlanConfig[NETIF_NUMBER];  //mark_vc , compatible */
+
+static int is_nat_wan_vlan(uint16 vid);
+static inline int rtk_isHwlookup_vlan(uint16 vid, struct sk_buff *skb,
+	uint32 *portlist);
+static int rtk_decide_vlan_id(int pid, struct sk_buff *skb, uint16 *vid);
+static struct dev_priv *rtk_decide_vlan_cp(int pid, struct sk_buff *skb);
+#if defined(CONFIG_OPENWRT_SDK)
+static int rtk_process_11q_rx(int port, struct sk_buff *skb);
+#else
+static int rtk_process_11q_rx(int port, struct sk_buff *skb,
+	struct sk_buff **pskb1, rtl_nicRx_info *info);
+#endif
+static inline int32 rtl_isWanPort(struct dev_priv *cp, uint16 vid,
+	struct sk_buff *skb, int pid, int vid_type);
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+#if defined(CONFIG_RTL_MULTICAST_PORT_MAPPING)
+static int rtl865x_nic_MulticastHardwareAccelerate(unsigned int brFwdPortMask,
+	unsigned int srcPort, unsigned int srcVlanId,
+	unsigned int srcIpAddr, unsigned int destIpAddr,
+	unsigned int mapPortMask);
+
+#else
+
+static int rtl865x_nic_MulticastHardwareAccelerate(unsigned int brFwdPortMask,
+	unsigned int srcPort, unsigned int srcVlanId,
+	unsigned int srcIpAddr, unsigned int destIpAddr);
+#endif
+#endif
+uint32 rtk_get_vlan_portmask(uint16 vid);
+uint32 rtk_get_vlan_tagmask(uint16 vid);
+uint8 rtk_get_vlan_type(uint16 vid);
+uint16 rtk_get_vid_by_port(int pid);
+void rtk_init_11q_setting(void);
+void rtk_add_eth_vlan(uint16 vid, uint32 portmask, uint32 tagmask,
+	uint32 vlantype);
+static void rtk_rm_skb_vid(struct sk_buff *skb);
+uint16 rtk_get_skb_vid(struct sk_buff *skb);
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+extern int rtl865x_disableRtl8367ToCpuAcl(void);
+extern int rtl865x_enableRtl8367ToCpuAcl(void);
+extern rtk_api_ret_t rtk_vlan_init(void);
+extern int rtl_vlan_RTL8367R_set(unsigned short vid, unsigned int tagmask,
+	unsigned int mask, unsigned int fid);
+#endif
+
+static inline void rtk_insert_vlan_tag(uint16 vid, struct sk_buff *skb)
+{
+	if (skb_headroom(skb) < VLAN_HLEN && skb_cow(skb, VLAN_HLEN) != 0) {
+		panic_printk("%s-%d: error! (skb_headroom(skb) == %d < 4). Enlarge it!\n",
+			__func__, __LINE__, skb_headroom(skb));
+		while (1);
+	}
+
+	memmove(skb->data - VLAN_HLEN, skb->data, ETH_ALEN << 1);
+	skb_push(skb, VLAN_HLEN);
+	*((uint16 *)(skb->data + (ETH_ALEN << 1))) =
+		__constant_htons(ETH_P_8021Q);
+	*((uint16 *)(skb->data + (ETH_ALEN << 1) + 2)) = htons(vid);
+}
+
+#define REMOVE_TAG(skb) { \
+	memmove(skb->data+VLAN_HLEN, skb->data, ETH_ALEN*2); \
+	skb_pull(skb, VLAN_HLEN); \
+}
+#endif
+
+/* for ipv6 ready logo */
+#ifdef CONFIG_RTL_HARDWARE_IPV6_SUPPORT
+int rtk_hwL3v6_enable;
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rtk_hwL3v6_read(struct seq_file *s, void *v);
+#else
+static int32 rtk_hwL3v6_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+#endif
+static int32 rtk_hwL3v6_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+#define CONFIG_RTK_REFINE_PORT_DUPLEX_MODE 1
+#if defined(CONFIG_RTK_REFINE_PORT_DUPLEX_MODE)
+extern int rtk_refinePortDuplexMode(void);
+#endif
+#endif
+
+#ifdef CONFIG_RTL_JUMBO_FRAME
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 jumbo_frame_support_read(struct seq_file *s, void *v);
+static int32 jumbo_frame_support_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+
+int jumbo_frame_single_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, jumbo_frame_support_read, NULL);
+}
+
+static ssize_t jumbo_frame_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return jumbo_frame_support_write(file, userbuf, count, off);
+}
+
+struct file_operations jumbo_frame_proc_fops = {
+	.open = jumbo_frame_single_open,
+	.write = jumbo_frame_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#else
+static int32 jumbo_frame_support_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+static int32 jumbo_frame_support_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+#endif
+#endif
+
+/* static void rtl_print_vlanconfig(struct rtl865x_vlanConfig new_vlanconfig[]); */
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+static int read_proc_vlan(struct seq_file *s, void *v);
+static int32 rtk_vlan_support_read(struct seq_file *s, void *v);
+#else
+static int read_proc_vlan(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+static int32 rtk_vlan_support_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+#endif
+static int write_proc_vlan(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+static int32 rtk_vlan_support_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtk_vlan_management_read(struct seq_file *s, void *v);
+#else
+static int rtk_vlan_management_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+#endif
+static int rtk_vlan_management_write(struct file *file, const char *buffer,
+	unsigned long len, void *data);
+#endif
+
+/* __DRAM_FWD int rtk_vlan_support_enable; */
+int rtk_vlan_support_enable;
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+extern int rtl865x_enableRtl8367ToCpuAcl(void);
+extern int rtl865x_disableRtl8367ToCpuAcl(void);
+extern int RTL8367R_vlan_set(void);
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+static int32 rtk_vlan_wan_tag_getportmask(int bridge_port);
+#if defined(CONFIG_RTL_PROC_NEW)
+static int32 rtk_vlan_wan_tag_support_read(struct seq_file *s, void *v);
+#else
+static int32 rtk_vlan_wan_tag_support_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+#endif
+static int32 rtk_vlan_wan_tag_support_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+#endif
+
+#ifdef CONFIG_RTL_LINK_AGGREGATION
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 link_aggregation_read(struct seq_file *s, void *v);
+static int32 link_aggregation_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+
+int link_aggregation_single_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, link_aggregation_read, NULL);
+}
+
+static ssize_t link_aggregation_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return link_aggregation_write(file, userbuf, count, off);
+}
+
+struct file_operations link_aggregation_proc_fops = {
+	.open = link_aggregation_single_open,
+	.write = link_aggregation_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#else
+static int32 link_aggregation_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+static int32 link_aggregation_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+#endif
+#endif
+
+#if defined(CONFIG_819X_PHY_RW)	/* #if defined(CONFIG_RTK_VLAN_FOR_CABLE_MODEM) */
+static int32 rtl_phy_status_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+static int32 rtl_phy_status_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+static int32 port_mibStats_read_proc(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+static int32 port_mibStats_write_proc(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+
+struct port_mibStatistics {
+
+	/* here is in counters  definition */
+	uint32 ifInOctets;
+	uint64 ifHCInOctets;
+	uint32 ifInUcastPkts;
+	uint64 ifHCInUcastPkts;
+	uint32 ifInMulticastPkts;
+	uint64 ifHCInMulticastPkts;
+	uint64 ifHCInBroadcastPkts;
+	uint32 ifInBroadcastPkts;
+	uint32 ifInDiscards;
+	uint32 ifInErrors;
+	uint64 etherStatsOctets;
+	uint32 etherStatsUndersizePkts;
+	uint32 etherStatsFraments;
+	uint32 etherStatsPkts64Octets;
+	uint32 etherStatsPkts65to127Octets;
+	uint32 etherStatsPkts128to255Octets;
+	uint32 etherStatsPkts256to511Octets;
+	uint32 etherStatsPkts512to1023Octets;
+	uint32 etherStatsPkts1024to1518Octets;
+	uint32 etherStatsOversizePkts;
+	uint32 etherStatsJabbers;
+	uint32 dot1dTpPortInDiscards;
+	uint32 etherStatusDropEvents;
+	uint32 dot3FCSErrors;
+	uint32 dot3StatsSymbolErrors;
+	uint32 dot3ControlInUnknownOpcodes;
+	uint32 dot3InPauseFrames;
+
+	/* here is out counters  definition */
+	uint32 ifOutOctets;
+	uint64 ifHCOutOctets;
+	uint32 ifOutUcastPkts;
+	uint64 ifHCOutUcastPkts;
+	uint64 ifHCOutMulticastPkts;
+	uint64 ifHCOutBroadcastPkts;
+	uint32 ifOutMulticastPkts;
+	uint32 ifOutBroadcastPkts;
+	uint32 ifOutDiscards;
+	uint32 ifOutErrors;
+	uint32 dot3StatsSingleCollisionFrames;
+	uint32 dot3StatsMultipleCollisionFrames;
+	uint32 dot3StatsDefferedTransmissions;
+	uint32 dot3StatsLateCollisions;
+	uint32 dot3StatsExcessiveCollisions;
+	uint32 dot3OutPauseFrames;
+	uint32 dot1dBasePortDelayExceededDiscards;
+	uint32 etherStatsCollisions;
+
+	/* here is whole system couters definition */
+	uint32 dot1dTpLearnedEntryDiscards;
+	uint32 etherStatsCpuEventPkts;
+	uint32 ifInUnknownProtos;
+	uint32 ifSpeed;
+	uint32 ifHighSpeed;
+	uint32 ifConnectorPresent;
+	uint32 ifCounterDiscontinuityTime;
+};
+#endif /* #if defined(CONFIG_819X_PHY_RW) */
+#endif
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+#if defined(CONFIG_RTL_PROC_NEW)
+static int rtl_hw_vlan_support_read(struct seq_file *s, void *v);
+#else
+static int32 rtl_hw_vlan_support_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+#endif
+static int32 rtl_hw_vlan_support_write(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+#if defined(CONFIG_RTL_PROC_NEW)
+static int rtl_hw_vlan_tagged_bridge_multicast_read(struct seq_file *s,
+	void *v);
+#else
+static int32 rtl_hw_vlan_tagged_bridge_multicast_read(char *page, char **start,
+	off_t off, int count, int *eof, void *data);
+#endif
+static int32 rtl_hw_vlan_tagged_bridge_multicast_write(struct file *filp,
+	const char *buff, unsigned long len, void *data);
+int rtl_process_hw_vlan_tx(rtl_nicTx_info *txInfo);
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+extern int rtk_vlan_init(void);
+extern int rtk_vlan_set(uint32 vid, uint32 mbrmsk, uint32 untagmsk, uint32 fid);
+extern int rtk_port_efid_set(uint32 port, uint32 efid);
+extern int rtk_vlan_portPvid_set(uint32 port, uint32 pvid, uint32 priority);
+extern int rtk_vlan_get(uint32 vid, uint32 *pMbrmsk, uint32 *pUntagmsk,
+	uint32 *pFid);
+extern int rtl865x_enableRtl8367ToCpuAcl(void);
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+#if defined(CONFIG_RTL_PROC_NEW)
+int32 rtl_8367r_vlan_read(struct seq_file *s, void *v);
+#else
+int32 rtl_8367r_vlan_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+#endif
+#endif
+
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+/* #define RTK_WAN_PORT_IDX 4 */
+#define RTK_WAN_PORT_IDX (ffs(RTL_WANPORT_MASK) - (1))
+#define RTK_MASK_TO_PORT(x) (ffs(x) - (1))
+#define RTK_CPU_PORT 8
+
+#define FW_BRIDGE_VLAN 1
+#define FW_NAT_VLAN 2
+#define RTL_CPUPORT_MASK (1 << RTK_CPU_PORT)
+
+int RTK_NAT_VLANID = 10;
+int RTK_NAT_WAN_TAGGED = 0;
+int RTK_MC_VLANID = 50;
+int RTK_QUERYFORBRIDGEPORT = 1;
+#define RTK_MANAGE_VLAN_IF 1	/* use new eth interface as management vlan */
+
+#define VLAN_CONFIG_SIZE sizeof(vlanconfig)/sizeof(struct rtl865x_vlanConfig)
+#define VLAN_CONFIG_PPPOE_INDEX (VLAN_CONFIG_SIZE-2)
+
+struct net_device *manage_vlan_dev = NULL;
+
+#ifdef RTK_MANAGE_VLAN_IF
+static void rtk_add_manage_vlan_dev(uint32 vid);
+void rtk_add_manage_vlan(void);
+struct vlan_info *rtl_get_man_vlaninfo(void);
+#define RTK_MANAGE_IFNAME  ("eth7")
+/* #define  RTK_MANAGE_VLAN_IF_DEBUG_MSG  1  //mark_manv */
+#endif
+
+#if defined(CONFIG_RTL8192CD)
+extern int is_rtl_nat_wlan_vlan(struct net_device *dev);	/* from wlan driver */
+#endif
+static struct vlan_info wan_management_vlan;
+
+static struct dev_priv *rtl_get_wan_cp(void)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	return (struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[RTL_WAN_IDX]);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	return (struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}
+
+static uint16 get_skb_vid(struct sk_buff *skb)
+{
+	uint16 vid = 0;		/* untag or NoVlan group */
+
+	if (skb->tag.f.tpid == htons(ETH_P_8021Q))
+		vid = ntohs(skb->tag.f.pci & 0xfff);
+
+	return vid;
+}
+
+int is_rtl_nat_vlan(struct sk_buff *skb)
+{
+	uint16 vid = get_skb_vid(skb);
+
+	if (vid == 0 || vid == RTK_NAT_VLANID)	/* vid =0 is vlan disable */
+		return 1;
+
+	return 0;
+}
+
+int is_rtl_multi_nat_vlan(struct sk_buff *skb, uint16 *vid)
+{
+	uint16 skb_vid = get_skb_vid(skb);
+
+	if (skb_vid != 0 && skb_vid != RTK_NAT_VLANID) {	/* vid =0 is vlan disable */
+		*vid = skb_vid;	/* mark_wvlan , what if wlan nat vid untag ?? FIXME */
+		return 1;
+	}
+
+	return 0;
+}
+
+int is_rtl_wan_mac(struct sk_buff *skb)
+{
+	/* NOTE , this can only be called when skb is come from WAN (is not LAN) */
+	if (!memcmp(skb->dev->dev_addr, skb->data, 6))
+		return 1;
+
+	return 0;
+}
+
+int rtl_is_lan_mac(uint8 mac_addr[])
+{
+	if (!mac_addr)
+		return -1;
+
+	if (!memcmp((_rtl86xx_dev.dev[0])->dev_addr, mac_addr, 6))
+		return 1;
+
+	return 0;
+}
+
+int rtl_vlan_pass_frame_up(struct sk_buff *skb)
+{
+	if (!rtl_hw_vlan_enable)
+		return 1;
+	/* if it is a NAT paclet , pass up */
+	if (is_rtl_nat_vlan(skb))
+		return 1;
+
+	/* if it is from wlan , then maybe natvid is other */
+#if defined(CONFIG_RTL8192CD)
+	if (memcmp(skb->dev->name, "wlan", 4) == 0)	/* check if come from wlan */
+		if (is_rtl_nat_wlan_vlan(skb->dev))	/* from wlan driver */
+			return 1;
+#endif
+
+	return 0;
+}
+
+static void rtl_update_lan_cp_vinfo(struct dev_priv *cp, int enable, int vid,
+	int fw, int wan_tag)
+{
+	cp->vlan_setting.global_vlan = 1;
+	cp->vlan_setting.vlan = enable;
+	cp->vlan_setting.is_lan = 1;
+	cp->vlan_setting.id = vid;
+	cp->vlan_setting.tag = wan_tag;
+	cp->vlan_setting.forwarding_rule = fw;
+}
+
+static void rtl_update_wan_cp_vinfo(struct dev_priv *cp, int enable, int vid,
+	int wan_tag)
+{
+	cp->vlan_setting.global_vlan = 1;
+	cp->vlan_setting.vlan = enable;
+	cp->vlan_setting.is_lan = 0;
+	cp->vlan_setting.id = vid;
+	cp->vlan_setting.tag = wan_tag;
+	cp->vlan_setting.forwarding_rule = FW_NAT_VLAN;
+}
+
+static void rtl_update_manage_vlan(int enable, int vid, int wan_tag)
+{
+
+	wan_management_vlan.global_vlan = 1;
+	wan_management_vlan.vlan = enable;
+	wan_management_vlan.id = vid;
+	wan_management_vlan.tag = wan_tag;
+	wan_management_vlan.forwarding_rule = FW_NAT_VLAN;
+#ifdef RTK_MANAGE_VLAN_IF
+
+	if (manage_vlan_dev != NULL) {
+		/* update manage cp info */
+		rtl_update_wan_cp_vinfo((struct dev_priv *)
+			NETDRV_PRIV(manage_vlan_dev), enable, vid, wan_tag);
+		/* update cp vid */
+		((struct dev_priv *)NETDRV_PRIV(manage_vlan_dev))->id = vid;
+	}
+#endif
+
+}
+
+static inline int is_ARP_packet(struct sk_buff *skb)
+{
+	uint8 *ptr;
+	uint8 *macFrame = skb->data;
+
+	ptr = macFrame + 12;
+
+	/*it's arp packet */
+	if (*(int16 *) (ptr) == (int16) htons(ETH_P_ARP))
+		return 1;
+
+	return 0;
+}
+
+static inline struct iphdr *getIpv4Header(uint8 *macFrame)
+{
+	uint8 *ptr;
+	struct iphdr *iph = NULL;
+
+	ptr = macFrame + 12;
+
+	/*it's not ipv4 packet */
+	if (*(int16 *) (ptr) != (int16) htons(ETH_P_IP))
+		return NULL;
+
+	iph = (struct iphdr *)(ptr + 2);
+
+	return iph;
+}
+
+static inline int is_DHCP_packet(struct sk_buff *skb)
+{
+	struct iphdr *iph;
+	struct udphdr *udph;
+
+	iph = getIpv4Header(skb->data);
+	if (iph == NULL)
+		return 0;
+
+	udph = (void *)iph + iph->ihl * 4;
+	if (iph->protocol == IPPROTO_UDP)
+		if (udph->source == 68 || udph->source == 67)	/* DHCP packet */
+			return 1;
+
+	return 0;
+}
+
+struct net_device *rtl_get_dev_by_vid(uint16 vid)
+{
+	int i;
+	struct dev_priv *cp = NULL;
+	struct net_device *dev = NULL;
+
+	if (vid == 0)
+		return NULL;
+
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		dev = (struct net_device *)_rtl86xx_dev.dev[i];
+		if (!dev)
+			continue;
+		cp = NETDRV_PRIV(dev);
+		if (cp && cp->opened && (cp->id == vid))
+			return (struct net_device *)cp->dev;
+
+	}
+	return NULL;
+}
+
+static struct dev_priv *rtl_get_cp_by_vid(uint16 vid)
+{
+	int i;
+	struct dev_priv *cp = NULL;
+	struct net_device *dev = NULL;
+
+	if (wan_management_vlan.vlan && (vid == wan_management_vlan.id)) {
+#ifdef RTK_MANAGE_VLAN_IF
+		if (manage_vlan_dev) {
+#ifdef RTK_MANAGE_VLAN_IF_DEBUG_MSG
+			printk("retrun  mana vlan cp = %x\n",
+				(int)manage_vlan_dev->priv);
+#endif
+			return ((struct dev_priv *)
+				NETDRV_PRIV(manage_vlan_dev));
+		} else
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+		return ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[RTL_WAN_IDX]));	/* default return Wan nat if */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		return ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]));	/* default return Wan nat if */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	}
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		dev = (struct net_device *)_rtl86xx_dev.dev[i];
+		if (!dev)
+			continue;
+		cp = NETDRV_PRIV(dev);
+		if (cp && cp->opened && (cp->id == vid))
+			return (struct dev_priv *)cp;
+
+	}
+	/* printk("cant find cp , unknow vid default go to eht1 !!\n"); */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	return ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[RTL_WAN_IDX]));	/* default return Wan nat if */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	return ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]));	/* default return Wan nat if */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}
+
+struct vlan_info *rtl_get_vinfo_by_vid(uint16 vid)
+{
+	int i;
+	struct dev_priv *cp = NULL;
+	struct net_device *dev = NULL;
+
+	if (vid == 0)
+		return NULL;
+#ifdef RTK_MANAGE_VLAN_IF
+	if (wan_management_vlan.vlan && (vid == wan_management_vlan.id))
+		return ((struct vlan_info *)rtl_get_man_vlaninfo());
+#endif
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		dev = (struct net_device *)_rtl86xx_dev.dev[i];
+		if (!dev)
+			continue;
+		cp = NETDRV_PRIV(dev);
+		if (cp && cp->opened && (cp->id == vid))
+			return (struct vlan_info *)&cp->vlan_setting;
+
+	}
+	return NULL;
+}
+
+int is_rtl_manage_vlan_tagged(struct sk_buff *skb, uint16 *vid)
+{
+	uint16 skb_vid = 0;
+	*vid = (unsigned short)wan_management_vlan.id;
+	/* bypass if manage vlan not enable or tag */
+#ifdef RTK_MANAGE_VLAN_IF
+	if ((wan_management_vlan.vlan) && (wan_management_vlan.tag)) {
+		/* if txIf is manage vlan interface and set to tagout , then  insert mana vlan tag */
+		if (!strcmp((char *)skb->dev->name, RTK_MANAGE_IFNAME)) {	/* mark_test */
+#ifdef RTK_MANAGE_VLAN_IF_DEBUG_MSG
+			printk("tx to manage eth interface(%s) and add tag\n",
+				skb->dev->name);
+#endif
+			return 1;
+		}
+	}
+
+	return 0;
+	/* ignore below */
+#endif
+	if ((!wan_management_vlan.vlan) || (!wan_management_vlan.tag))
+		return 0;
+	/* if it is already a manage vlan packet */
+	skb_vid = get_skb_vid(skb);
+	if (skb_vid == wan_management_vlan.id)
+		return 1;
+
+	/* bypass if skb not come from Wan protocol stack , from PS skb->tag = 0 */
+	if (skb->tag.f.tpid != 0)
+		return 0;
+	else {			/* bypass special case  even it is from Wan protocol stack but only belong to NAT vlan */
+		/* bypass if not arp , dhcp , igmp */
+		if (is_ARP_packet(skb))
+			return 0;
+		if (is_DHCP_packet(skb))
+			return 0;
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+		if ((skb->data[0] == 0x01) && (skb->data[1] == 0x00)
+			&& (skb->data[2] == 0x5e))
+			return 0;
+#endif
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+		if ((skb->data[0] == 0x33) && (skb->data[1] == 0x33)
+			&& (skb->data[2] != 0xff))
+			return 0;
+#endif
+	}
+
+	return 1;
+}
+
+int is_multicast_pkt_towan(struct sk_buff *skb)
+{
+	struct iphdr *iph;
+	struct icmphdr *icmph;
+	struct ipv6hdr *ipv6h = NULL;
+	uint8 *ptr;
+
+	if (skb == NULL)
+		return 0;
+
+	ptr = skb->data + 12;
+	/* untag */
+	if (*(int16 *) (ptr) == (int16) htons(ETH_P_IP)) {
+		/* ipv4 */
+		iph = (struct iphdr *)(ptr + 2);
+		icmph = (void *)iph + iph->ihl * 4;
+		if (((skb->data[0] & 0x01) && (skb->data[0] != 0xFF))
+			&& (skb->tag.f.tpid == 0)
+			&& (!memcmp(skb->dev->dev_addr, skb->data + 6, 6))) {	/* from protocol stack */
+			/* using wan vlan information */
+			return 1;
+
+		}
+	} else if (*(int16 *) (ptr) == (int16) htons(ETH_P_IPV6)) {
+		/* ipv6 */
+		ipv6h = (struct ipv6hdr *)(ptr + 2);
+		if (((skb->data[0] & 0x01) && (skb->data[0] != 0xFF))
+			&& (skb->tag.f.tpid == 0)
+			&& (!memcmp(skb->dev->dev_addr, skb->data + 6, 6))) {	/* from protocol stack */
+			/* using wan vlan information */
+			return 1;
+
+		}
+
+	}
+
+	return 0;
+}
+
+int is_rtl_mc_vlan_tagged2(struct sk_buff *skb, uint16 *vid)
+{
+	struct vlan_info *mc_info = rtl_get_vinfo_by_vid(RTK_MC_VLANID);
+	struct vlan_info *info;
+
+	if (is_multicast_pkt_towan(skb) == 1) {
+		/* panic_printk("%s %d\n", __FUNCTION__, __LINE__); */
+#ifdef RTK_MANAGE_VLAN_IF
+		if (wan_management_vlan.vlan) {
+			info = ((struct vlan_info *)rtl_get_man_vlaninfo());
+			if (info) {
+				*vid = info->id;
+				/* panic_printk("%s %d *vid=%d \n", __FUNCTION__, __LINE__, *vid); */
+				return info->tag;
+			}
+		}
+#endif
+	}
+	*vid = RTK_MC_VLANID;
+	if ((mc_info)) {
+		return mc_info->tag;
+	}
+
+	return 0;
+}
+
+int is_rtl_mc_vlan_tagged(uint16 *vid)
+{
+	struct vlan_info *mc_info = rtl_get_vinfo_by_vid(RTK_MC_VLANID);
+	*vid = RTK_MC_VLANID;
+	if ((mc_info)) {
+		return mc_info->tag;
+	}
+	return 0;
+}
+
+void rtl_set_nat_vlan_info(int vid, int wan_tag)
+{
+	RTK_NAT_VLANID = vid;
+	RTK_NAT_WAN_TAGGED = wan_tag;
+}
+
+static uint32 rtl_get_WanTagPortmask(int tag)
+{
+	uint32 portmask = 0;
+
+	if (tag)
+		portmask = 0x3f & (1 << RTK_WAN_PORT_IDX);
+
+	return portmask;
+}
+
+uint32 rtk_getTagPortmaskByVid(uint16 vid, void *data_p)
+{
+	uint16 tag_portmask = 0;
+	struct vlan_info *info = NULL;
+	unsigned char *data = (unsigned char *)data_p;
+
+	/* if( hw_vlan_support) */
+	if (!rtl_hw_vlan_enable)
+		return 0;
+	info = rtl_get_vinfo_by_vid(vid);
+	if (info)
+		tag_portmask = rtl_get_WanTagPortmask(info->tag);
+
+	if (tag_portmask) {
+		/* if it is a mc and if mc is untag out ,then Wan port should not tag Wan port out for this Mc packet. */
+		if (((data[0] & 0x01) && (data[0] != 0xFF))
+			&& (RTK_MC_VLANID != 0)
+			&& (!is_rtl_mc_vlan_tagged(&vid)))
+			tag_portmask = 0;	/* mark_hwv */
+	}
+	return tag_portmask;
+}
+
+static int rtl_get_vlan_num(struct rtl865x_vlanConfig s_vlanconfig[])
+{
+	int32 totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		1;
+	int i, vlan_num = 0;
+
+	for (i = 0; i < totalVlans; i++)	/* ignore eth0 , eth1 , and nat vid ,just find br vid num */
+	{
+		if (s_vlanconfig[i].vid != 0) {
+			if ((i > 1) && (s_vlanconfig[i].vid == RTK_NAT_VLANID))	/* mark_hwv ,bypass pp case ? ,FIXME */
+				continue;
+			vlan_num++;
+		}
+	}
+	return vlan_num;
+}
+
+static int rtk_multicast_scream_vid_write(struct file *file, const char *buffer,
+	unsigned long len, void *data)
+{
+	char tmpbuf[128];
+	int num;
+
+	if (buffer && !copy_from_user(tmpbuf, buffer, len)) {
+		tmpbuf[len] = '\0';
+
+		num = sscanf(tmpbuf, "%d", &RTK_MC_VLANID);
+
+		if (num != 1) {
+			printk("invalid  parameter!\n");
+		}
+
+	}
+
+	return len;
+}
+
+#if defined(CONFIG_RTL_PROC_NEW)
+static int32 rtk_multicast_scream_vid_read(struct seq_file *s, void *v)
+{
+
+	seq_printf(s, "%s %d\n", "rtk_multicast_scream_vid:", RTK_MC_VLANID);
+
+	return 0;
+}
+#else
+static int32 rtk_multicast_scream_vid_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	len = sprintf(page, "%s %d\n", "rtk_multicast_scream_vid:",
+		RTK_MC_VLANID);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+static int rtk_query_for_bridge_port_write(struct file *file,
+	const char *buffer, unsigned long len, void *data)
+{
+	char tmpbuf[128];
+	int num;
+
+	if (buffer && !copy_from_user(tmpbuf, buffer, len)) {
+		tmpbuf[len] = '\0';
+
+		num = sscanf(tmpbuf, "%d", &RTK_QUERYFORBRIDGEPORT);
+
+		if (num != 1) {
+			printk("invalid  parameter!\n");
+		}
+
+	}
+
+	return len;
+}
+
+#if defined(CONFIG_RTL_PROC_NEW)
+static int32 rtk_query_for_bridge_port_read(struct seq_file *s, void *v)
+{
+
+	seq_printf(s, "%s %d\n", "query for bridge port:",
+		RTK_QUERYFORBRIDGEPORT);
+
+	return 0;
+}
+#else
+static int32 rtk_query_for_bridge_port_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	len = sprintf(page, "%s %d\n", "query for bridge port:",
+		RTK_QUERYFORBRIDGEPORT);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+int checkMulticatTxInfo(struct sk_buff *skb, struct net_device *dev,
+	rtl_nicTx_info *nicTx)
+{
+	uint16 vid = 0;
+	struct dev_priv *cp;
+
+	cp = NETDRV_PRIV(dev);
+
+	if (!rtl_hw_vlan_enable)
+		return 0;
+
+	if (cp->vlan_setting.forwarding_rule == 1)	/* Bridge out */
+	{
+		if (!RTK_QUERYFORBRIDGEPORT)
+			return 0;
+
+		if ((skb == NULL) || (dev == NULL) || (nicTx == NULL)) {
+			return -1;
+		}
+
+		vid = get_skb_vid(skb);
+		if ((skb->tag.f.tpid == 0) && (skb->data[0] & 0x01)
+			&& (skb->data[0] != 0xff) && (vid == 0)) {
+			if (!strncmp(dev->name, "eth0", strlen("eth0"))
+				|| !strncmp(dev->name, "eth2", strlen("eth2"))
+				|| !strncmp(dev->name, "eth3", strlen("eth3"))
+				|| !strncmp(dev->name, "eth4",
+					strlen("eth4"))) {
+				nicTx->portlist &= ~RTL_WANPORT_MASK;
+			}
+		}
+	}
+
+	return 0;
+}
+
+#ifdef CONFIG_RTL_8367R_SUPPORT	/* mark_8367 */
+/* sycn some define from rtk_api.c */
+#define RTL8367R_LAN_EFID				2
+extern uint32 r8367_cpu_port;
+
+void rtk_8367_vlan_mapping(void)
+{
+	int i;
+	int retVal = 0;
+	struct net_device *dev;
+	struct dev_priv *dp;
+	uint32 pvid;
+	uint32 portmsk = 0, untagmsk = 0, fid = 0;
+	int32 totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		2;
+
+	/* clear all vlan */
+	for (i = 0; i < 4096; i++) {
+		/* retVal=rtk_vlan_set(i, BIT(RTL8367R_WAN) |BIT(r8367_cpu_port) , 0, 0); */
+		retVal = rtk_vlan_set(i, 0, 0, 0);	/* mark_8367 */
+	}
+	/* clear efid seeting */
+	for (i = 0; i < 5; i++) {
+		retVal = rtk_port_efid_set(i, RTL8367R_LAN_EFID);
+	}
+	/* map  real 819x vlan setting to 8367 */
+	for (i = 0; i < totalVlans; i++) {
+		dev = (struct net_device *)_rtl86xx_dev.dev[i];
+		if (!dev)
+			continue;
+		dp = NETDRV_PRIV(dev);
+		if (!dp)
+			continue;
+		if (dp->id != 0) {
+			rtl865x_tblAsicDrv_vlanParam_t vlan;
+			unsigned short vid;
+			vid = dp->id;
+			rtl8651_findAsicVlanIndexByVid(&vid);
+			printk("dp->id = %d , vid = %d \n", dp->id, vid);
+			if (rtl8651_getAsicVlan(vid, &vlan) == FAILED) {
+				printk("no HW vlan entry found \n");
+				continue;
+			}
+			/* if this vlan tagge to CPU in 819x then transfer it to tagged to  8367 CPU */
+			/* if wan port untag ,then to CPU no need tag */
+			/* if((vlan.memberPortMask & vlan.untagPortMask  & BIT(RTL8367R_WAN)) == BIT(RTL8367R_WAN)) */
+			if ((vlan.memberPortMask & vlan.
+					untagPortMask & RTL_WANPORT_MASK) ==
+				RTL_WANPORT_MASK)
+				vlan.untagPortMask =
+					(vlan.
+					untagPortMask & 0x3f) |
+					BIT(r8367_cpu_port);
+			else if ((vlan.memberPortMask & vlan.
+					untagPortMask & RTL_CPUPORT_MASK) ==
+				RTL_CPUPORT_MASK)
+				vlan.untagPortMask =
+					(vlan.
+					untagPortMask & 0x3f) |
+					BIT(r8367_cpu_port);
+			else
+				vlan.untagPortMask =
+					(vlan.untagPortMask & 0x3f);
+			/* exclude 819x cpu port , and always add 8367 cpu port */
+			vlan.memberPortMask =
+				(vlan.
+				memberPortMask & 0x3f) | BIT(r8367_cpu_port);
+			/* mark_mcdebug */
+			if (i == 1)	/* wan dev, always set wan vlan with all port and untag to lan port to avoid some issue when 819X  CPU tag enabled. */
+			{
+#if 0
+				vlan.memberPortMask = vlan.memberPortMask | 0xf;	/* include port0~port3 */
+				vlan.untagPortMask = vlan.untagPortMask | 0xf;	/* include port0~port3 */
+#else
+				vlan.memberPortMask = vlan.memberPortMask | (RTL_LANPORT_MASK & 0x1f);	/* include port0~port3 */
+				vlan.untagPortMask = vlan.untagPortMask | (RTL_LANPORT_MASK & 0x1f);	/* include port0~port3 */
+#endif
+			}
+			retVal = rtk_vlan_set(vlan.vid, vlan.memberPortMask,
+				vlan.untagPortMask, vlan.fid);
+		}
+
+	}
+
+	if (wan_management_vlan.vlan) {
+
+		retVal = rtk_vlan_get(wan_management_vlan.id, &portmsk,
+			&untagmsk, &fid);
+		if (retVal == 0) {
+			/* wan vlan already exist. wan equal nat vlan, tag behavior should consistency. */
+			portmsk |= RTL_WANPORT_MASK | BIT(r8367_cpu_port);
+			retVal = rtk_vlan_set(wan_management_vlan.id, portmsk,
+				untagmsk, 1);
+		} else {
+			if (wan_management_vlan.tag)
+				/* retVal=rtk_vlan_set(wan_management_vlan.id, BIT(RTL8367R_WAN) |BIT(r8367_cpu_port) , 0, 1); */
+				retVal = rtk_vlan_set(wan_management_vlan.id,
+					RTL_WANPORT_MASK | BIT(r8367_cpu_port),
+					0, 1);
+			else	/* wan untag out */
+				/* retVal=rtk_vlan_set(wan_management_vlan.id, BIT(RTL8367R_WAN) |BIT(r8367_cpu_port) , BIT(RTL8367R_WAN) , 1); */
+				retVal = rtk_vlan_set(wan_management_vlan.id,
+					RTL_WANPORT_MASK | BIT(r8367_cpu_port),
+					RTL_WANPORT_MASK, 1);
+		}
+	}
+	/* map  real 819x pvid setting to 8367 */
+	for (i = 0; i < 5; i++) {
+		retVal = rtl8651_getAsicPVlanId(i, &pvid);
+		retVal = rtk_vlan_portPvid_set(i, pvid, 0);
+	}
+	/* 819x cpu pvid to 8367 */
+	retVal = rtl8651_getAsicPVlanId(RTK_CPU_PORT, &pvid);
+	retVal = rtk_vlan_portPvid_set(r8367_cpu_port, pvid, 0);
+
+	/* set p4(wan) -> p6(cpu) transpatent , p6-> p4 transparent */
+	/* retVal = rtk_vlan_transparent_set(RTL8367R_WAN, BIT(r8367_cpu_port), 1); //mark_8367 */
+	/* retVal = rtk_vlan_transparent_set(r8367_cpu_port, BIT(RTL8367R_WAN), 1); */
+
+}
+
+void rtk_get_real_nicTxVid(struct sk_buff *skb, unsigned short *nictx_vid)
+{
+	unsigned short vid;
+	if (!rtl_hw_vlan_enable)
+		return;
+
+	if ((*nictx_vid) != RTK_NAT_VLANID)	/* only NAT WAN port need to consider how to direct tx a vid , if it need to be changed for, manage or MC */
+		return;
+
+	if (((skb->data[0] & 0x01) && (skb->data[0] != 0xFF))
+		&& is_rtl_mc_vlan_tagged(&vid))
+		(*nictx_vid) = vid;
+#ifndef RTK_MANAGE_VLAN_IF
+	else if (is_rtl_manage_vlan_tagged(skb, &vid))	/* if it is manamgat vlan packet from CPU ? */
+		(*nictx_vid) = vid;
+#endif
+
+	return;
+}
+#endif
+#endif
+
+#if defined(RTL8196C_EEE_MAC)
+extern int eee_enabled;
+extern void eee_phy_enable(void);
+extern void eee_phy_disable(void);
+#ifdef CONFIG_RTL8196C_REVISION_B
+static unsigned char prev_port_sts[MAX_PORT_NUMBER] = { 0, 0, 0, 0, 0 };
+#endif
+#endif
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+static int32 rtl865x_getPortlistByMac(const unsigned char *mac,
+	uint32 *portlist);
+#endif
+static inline int rtl_isWanDev(struct dev_priv *cp);
+
+#ifdef CONFIG_RTL8196C_ETH_IOT
+uint32 port_link_sts = 0;	/* the port which already linked up does not need to check ... */
+uint32 port_linkpartner_eee = 0;
+#endif
+
+#ifdef CONFIG_RTL_8196C_ESD
+int _96c_esd_counter = 0;
+int _96c_esd_reboot_counter = 0;
+#endif
+
+#if defined(PATCH_GPIO_FOR_LED)
+#define MIB_RX_PKT_CNT	0
+#define MIB_TX_PKT_CNT	1
+
+#ifdef CONFIG_RTL_8197F
+#define PORT_GPIO_BASE		22	/* Base of P0~P4 at PEFGH, port 0~4: G6~H2 */
+#define PGPIO_CNR 			PEFGH_CNR
+#define PGPIO_DIR 			PEFGH_DIR
+#define PGPIO_DAT 			PEFGH_DAT
+#else
+#define PORT_PABCD_BASE	10	/* Base of P0~P1 at PABCD */
+#define P0_PABCD_BIT		10
+#define P1_PABCD_BIT		11
+#define P2_PABCD_BIT		12
+#define P3_PABCD_BIT		13
+#define P4_PABCD_BIT		14
+#define PORT_GPIO_BASE		PORT_PABCD_BASE
+#define PGPIO_CNR 			PABCD_CNR
+#define PGPIO_DIR 			PABCD_DIR
+#define PGPIO_DAT 			PABCD_DAT
+#endif
+
+#define SUCCESS 0
+#define FAILED -1
+
+#define GPIO_LED_NOBLINK_TIME		(12*HZ/10)	/* time more than 1-sec timer interval */
+#define GPIO_LED_ON_TIME			(4*HZ/100)	/* 40ms */
+#define GPIO_LED_ON					0
+#define GPIO_LED_OFF					1
+#define GPIO_LINK_STATUS			1
+#define GPIO_LINK_STATE_CHANGE 0x80000000
+
+#define GPIO_UINT32_DIFF(a, b)		((a >= b) ? (a - b):(0xffffffff - b + a + 1))
+
+struct ctrl_led {
+	struct timer_list LED_Timer;
+	unsigned int LED_Interval;
+	unsigned char LED_Toggle;
+	unsigned char LED_ToggleStart;
+	unsigned int LED_tx_cnt_log;
+	unsigned int LED_rx_cnt_log;
+	unsigned int LED_tx_cnt;
+	unsigned int LED_rx_cnt;
+	unsigned int link_status;
+	unsigned char blink_once_done;	/* 1: blink once done */
+} led_cb[5];
+
+static int32 rtl819x_getAsicMibCounter(int port, uint32 counter, uint32 *value)
+{
+	rtl865x_tblAsicDrv_simpleCounterParam_t simpleCounter;
+	rtl8651_getSimpleAsicMIBCounter(port, &simpleCounter);
+
+	switch (counter) {
+	case MIB_RX_PKT_CNT:
+		*value = simpleCounter.rxPkts;
+		break;
+	case MIB_TX_PKT_CNT:
+		*value = simpleCounter.txPkts;
+		break;
+	default:
+		return FAILED;
+	}
+	return SUCCESS;
+}
+
+static void gpio_set_led(int port, int flag)
+{
+	if (flag == GPIO_LED_OFF) {
+/*		RTL_W32(PGPIO_CNR, RTL_R32(PGPIO_CNR) & (~((0x1<<port)<<PORT_GPIO_BASE)));	//set GPIO pin
+*		RTL_W32(PGPIO_DIR, RTL_R32(PGPIO_DIR) | ((0x1<<port)<<PORT_GPIO_BASE));//output pin
+*/
+		RTL_W32(PGPIO_DAT, (RTL_R32(PGPIO_DAT) | ((0x1 << port) << PORT_GPIO_BASE)));	/* set 1 */
+	} else {
+/*		RTL_W32(PGPIO_CNR, RTL_R32(PGPIO_CNR) & (~((0x1<<port)<<PORT_GPIO_BASE)));	//set GPIO pin
+*		RTL_W32(PGPIO_DIR, RTL_R32(PGPIO_DIR) | ((0x1<<port)<<PORT_GPIO_BASE));//output pin
+*/
+		RTL_W32(PGPIO_DAT, (RTL_R32(PGPIO_DAT) & (~((0x1 << port) << PORT_GPIO_BASE))));	/* set 0 */
+	}
+}
+
+static void gpio_led_Interval_timeout(unsigned long port)
+{
+	struct ctrl_led *cb = &led_cb[port];
+#ifndef CONFIG_RTL_8198C
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH(flags);
+#endif
+
+	if (cb->link_status & GPIO_LINK_STATE_CHANGE) {
+		cb->link_status &= ~GPIO_LINK_STATE_CHANGE;
+		if (cb->link_status & GPIO_LINK_STATUS)
+			cb->LED_ToggleStart = GPIO_LED_ON;
+		else
+			cb->LED_ToggleStart = GPIO_LED_OFF;
+		cb->LED_Toggle = cb->LED_ToggleStart;
+		gpio_set_led(port, cb->LED_Toggle);
+	} else {
+		if (cb->link_status & GPIO_LINK_STATUS)
+			gpio_set_led(port, cb->LED_Toggle);
+	}
+
+	if (cb->link_status & GPIO_LINK_STATUS) {
+		if (cb->LED_Toggle == cb->LED_ToggleStart) {
+			mod_timer(&cb->LED_Timer, jiffies + cb->LED_Interval);
+			cb->blink_once_done = 1;
+		} else {
+			mod_timer(&cb->LED_Timer, jiffies + GPIO_LED_ON_TIME);
+			cb->blink_once_done = 0;
+		}
+
+		cb->LED_Toggle = (cb->LED_Toggle + 1) & 0x1;	/* cb->LED_Toggle = (cb->LED_Toggle + 1) % 2; */
+	}
+#ifndef CONFIG_RTL_8198C
+	SMP_UNLOCK_ETH(flags);
+#endif
+}
+
+void calculate_led_interval(int port)
+{
+	struct ctrl_led *cb = &led_cb[port];
+
+	unsigned int delta = 0;
+
+	/* calculate counter delta      */
+	delta += GPIO_UINT32_DIFF(cb->LED_tx_cnt, cb->LED_tx_cnt_log);
+	delta += GPIO_UINT32_DIFF(cb->LED_rx_cnt, cb->LED_rx_cnt_log);
+	cb->LED_tx_cnt_log = cb->LED_tx_cnt;
+	cb->LED_rx_cnt_log = cb->LED_rx_cnt;
+
+	/* update interval according to delta   */
+	if (delta == 0) {
+		if (cb->LED_Interval == GPIO_LED_NOBLINK_TIME)
+			mod_timer(&(cb->LED_Timer), jiffies + cb->LED_Interval);
+		else {
+			cb->LED_Interval = GPIO_LED_NOBLINK_TIME;
+			if (cb->blink_once_done == 1) {
+				mod_timer(&(cb->LED_Timer),
+					jiffies + cb->LED_Interval);
+				cb->blink_once_done = 0;
+			}
+		}
+	} else {
+		if (delta > 25) {	/* That is: 200/delta-GPIO_LED_ON_TIME < GPIO_LED_ON_TIME */
+			cb->LED_Interval = GPIO_LED_ON_TIME;
+		} else {
+			/*      if delta is odd, should be +1 into even.                */
+			/*      just make led blink more stable and smooth.     */
+			if ((delta & 0x1) == 1)
+				delta++;
+
+			cb->LED_Interval = 200 / delta - GPIO_LED_ON_TIME;	/* rx 1pkt + tx 1pkt => blink one time! */
+
+/*			if (cb->LED_Interval < GPIO_LED_ON_TIME)
+*				cb->LED_Interval = GPIO_LED_ON_TIME;
+*/
+		}
+	}
+}
+
+void update_mib_counter(int port)
+{
+	uint32 regVal;
+	struct ctrl_led *cb = &led_cb[port];
+
+	regVal = READ_MEM32(PSRP0 + (port << 2));
+	if ((regVal & PortStatusLinkUp) != 0) {
+		/* link up */
+		if (!(cb->link_status & GPIO_LINK_STATUS)) {
+			cb->link_status = GPIO_LINK_STATE_CHANGE | 1;
+		}
+		rtl819x_getAsicMibCounter(port, MIB_TX_PKT_CNT,
+			(uint32 *)&cb->LED_tx_cnt);
+		rtl819x_getAsicMibCounter(port, MIB_RX_PKT_CNT,
+			(uint32 *)&cb->LED_rx_cnt);
+	} else {
+		/* link down */
+		if (cb->link_status & GPIO_LINK_STATUS) {
+			cb->link_status = GPIO_LINK_STATE_CHANGE;
+		}
+	}
+}
+
+void init_led_ctrl(int port)
+{
+	struct ctrl_led *cb = &led_cb[port];
+
+	RTL_W32(PGPIO_CNR, RTL_R32(PGPIO_CNR) & (~((0x1 << port) << PORT_GPIO_BASE)));	/* set GPIO pin */
+	RTL_W32(PGPIO_DIR, RTL_R32(PGPIO_DIR) | ((0x1 << port) << PORT_GPIO_BASE));	/* output pin */
+
+	memset(cb, '\0', sizeof(struct ctrl_led));
+
+	update_mib_counter(port);
+	calculate_led_interval(port);
+	cb->link_status |= GPIO_LINK_STATE_CHANGE;
+
+	init_timer(&cb->LED_Timer);
+	cb->LED_Timer.expires = jiffies + cb->LED_Interval;
+	cb->LED_Timer.data = (unsigned long)port;
+	cb->LED_Timer.function = gpio_led_Interval_timeout;
+	mod_timer(&cb->LED_Timer, jiffies + cb->LED_Interval);
+
+	gpio_led_Interval_timeout(port);
+}
+
+void disable_led_ctrl(int port)
+{
+	struct ctrl_led *cb = &led_cb[port];
+	gpio_set_led(port, GPIO_LED_OFF);
+
+	if (timer_pending(&cb->LED_Timer))
+		del_timer_sync(&cb->LED_Timer);
+}
+#endif /* PATCH_GPIO_FOR_LED */
+
+#if defined(CONFIG_RTL_819XD) && defined(CONFIG_RTL_8211DS_SUPPORT) && defined(CONFIG_RTL_8197D)
+int lanPortMask = 0x10f;
+int wanPortMask = 0x10;
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_MULTI_LAN_DEV)
+int lanPortMask1 = 0x8;
+int lanPortMask2 = 0x4;
+int lanPortMask3 = 0x2;
+int lanPortMask4 = 0x1;
+#endif
+
+#undef	RTL_WANPORT_MASK
+#undef	RTL_LANPORT_MASK
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_MULTI_LAN_DEV)
+#undef 	RTL_LANPORT_MASK_1
+#undef	RTL_LANPORT_MASK_2
+#undef 	RTL_LANPORT_MASK_3
+#undef 	RTL_LANPORT_MASK_4
+#endif
+
+#define	RTL_WANPORT_MASK		wanPortMask
+#define	RTL_LANPORT_MASK		lanPortMask
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_MULTI_LAN_DEV)
+#define 	RTL_LANPORT_MASK_1	lanPortMask1
+#define	RTL_LANPORT_MASK_2	lanPortMask2
+#define 	RTL_LANPORT_MASK_3	lanPortMask3
+#define 	RTL_LANPORT_MASK_4	lanPortMask4
+#endif
+
+void rtl_setPppMask(void)
+{
+	int i;
+	int totalVlans;
+	totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		1;
+	for (i = 0; i < totalVlans; i++) {
+		if (vlanconfig[i].if_type == IF_PPPOE) {
+			vlanconfig[i].memPort = 0x1;
+			vlanconfig[i].untagSet = 0x1;
+		}
+	}
+}
+
+void rtl_resetRegisterNotFound8211ds(void)
+{
+	REG32(0xbb804104) = 0x00FF2039;
+	REG32(0xbb80414c) = 0;
+	REG32(0xbb804100) = 0;
+}
+
+void rtl_setPortMask(uint32 reg_data)
+{
+	if ((reg_data != 0) && (reg_data != 0xFFFF)) {
+		/*8211ds is found */
+		lanPortMask = 0x11e;
+		wanPortMask = 0x1;
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_MULTI_LAN_DEV)
+		lanPortMask1 = 0x10;
+		lanPortMask2 = 0x8;
+		lanPortMask3 = 0x4;
+		lanPortMask4 = 0x2;
+#endif
+		rtl_setPppMask();
+
+		/* Flow control DSC tolerance: change to 32 pages to fix "port 0 (8211D) has Rx CRC" issue. */
+		REG32(MACCR) =
+			(REG32(MACCR) & ~CF_FCDSC_MASK) | (0x20 <<
+			CF_FCDSC_OFFSET);
+	} else {
+		/*8211ds is not found */
+		lanPortMask = 0x10f;
+		wanPortMask = 0x10;
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_MULTI_LAN_DEV)
+		lanPortMask1 = 0x8;
+		lanPortMask2 = 0x4;
+		lanPortMask3 = 0x2;
+		lanPortMask4 = 0x1;
+#endif
+		rtl_resetRegisterNotFound8211ds();
+	}
+}
+#endif
+
+/*
+device mapping mainten
+*/
+struct rtl865x_vlanConfig *rtl_get_vlanconfig_by_netif_name(const char *name)
+{
+	int i;
+	for (i = 0; vlanconfig[i].vid != 0; i++) {
+		if (memcmp(vlanconfig[i].ifname, name, strlen(name)) == 0)
+			return &vlanconfig[i];
+	}
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	/* check multiple wan device */
+	if (memcmp(rtl_multiWan_config.ifname, name, strlen(name)) == 0)
+		return &rtl_multiWan_config;
+#endif
+
+	return NULL;
+}
+
+#if 1
+void rtl_ps_drv_netif_mapping_show(void)
+{
+	int i;
+	DEBUG_ERR("linux netif name VS driver netif name mapping:\n");
+	for (i = 0; i < NETIF_NUMBER; i++) {
+		DEBUG_ERR
+			("valid(%d),linux netif name(%s) <---->drv netif name(%s)\n",
+			ps_drv_netif_mapping[i].valid,
+			ps_drv_netif_mapping[i].
+			ps_netif ? ps_drv_netif_mapping[i].ps_netif->
+			name : NULL, ps_drv_netif_mapping[i].drvName);
+	}
+}
+#endif
+
+static int rtl_ps_drv_netif_mapping_init(void)
+{
+	memset(ps_drv_netif_mapping, 0,
+		NETIF_NUMBER * sizeof(ps_drv_netif_mapping_t));
+	return SUCCESS;
+}
+
+int rtl_get_ps_drv_netif_mapping_by_psdev_name(const char *psname,
+	char *netifName)
+{
+	int i;
+	if (netifName == NULL || strlen(psname) >= MAX_IFNAMESIZE)
+		return FAILED;
+
+	for (i = 0; i < NETIF_NUMBER; i++) {
+		if (ps_drv_netif_mapping[i].valid == 1
+			&& memcmp(ps_drv_netif_mapping[i].ps_netif->name,
+				psname, strlen(psname)) == 0) {
+			memcpy(netifName, ps_drv_netif_mapping[i].drvName,
+				MAX_IFNAMESIZE);
+			return SUCCESS;
+		}
+	}
+
+	/* back compatible,user use br0 to get lan netif */
+	if (memcmp(psname, RTL_PS_BR0_DEV_NAME,
+			strlen(RTL_PS_BR0_DEV_NAME)) == 0) {
+		for (i = 0; i < NETIF_NUMBER; i++) {
+			if (ps_drv_netif_mapping[i].valid == 1 &&
+				memcmp(ps_drv_netif_mapping[i].drvName,
+					RTL_DRV_LAN_NETIF_NAME,
+					strlen(RTL_DRV_LAN_NETIF_NAME)) == 0) {
+				memcpy(netifName,
+					ps_drv_netif_mapping[i].drvName,
+					MAX_IFNAMESIZE);
+				return SUCCESS;
+			}
+		}
+	}
+
+	return FAILED;
+}
+
+ps_drv_netif_mapping_t *rtl_get_ps_drv_netif_mapping_by_psdev(struct net_device
+	*dev)
+{
+	int i;
+	for (i = 0; i < NETIF_NUMBER; i++) {
+		if (ps_drv_netif_mapping[i].valid == 1
+			&& ps_drv_netif_mapping[i].ps_netif == dev)
+			return &ps_drv_netif_mapping[i];
+	}
+
+	/* back compatible,user use br0 to get lan netif */
+	if (memcmp(dev->name, RTL_PS_BR0_DEV_NAME,
+			strlen(RTL_PS_BR0_DEV_NAME)) == 0) {
+		for (i = 0; i < NETIF_NUMBER; i++) {
+			if (ps_drv_netif_mapping[i].valid == 1 &&
+				memcmp(ps_drv_netif_mapping[i].drvName,
+					RTL_DRV_LAN_NETIF_NAME,
+					strlen(RTL_DRV_LAN_NETIF_NAME)) == 0)
+				return &ps_drv_netif_mapping[i];
+		}
+	}
+
+	return NULL;
+}
+
+int rtl_add_ps_drv_netif_mapping(struct net_device *dev, const char *name)
+{
+	int i;
+
+	/* duplicate check */
+	if (rtl_get_ps_drv_netif_mapping_by_psdev(dev) != NULL)
+		return FAILED;
+
+	for (i = 0; i < NETIF_NUMBER; i++) {
+		if (ps_drv_netif_mapping[i].valid == 0)
+			break;
+	}
+
+	if (i == NETIF_NUMBER)
+		return FAILED;
+
+	ps_drv_netif_mapping[i].ps_netif = dev;
+	memcpy(ps_drv_netif_mapping[i].drvName, name, strlen(name));
+	ps_drv_netif_mapping[i].valid = 1;
+	return SUCCESS;
+}
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl_add_ps_drv_netif_mapping);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+int rtl_del_ps_drv_netif_mapping(struct net_device *dev)
+{
+	ps_drv_netif_mapping_t *entry;
+	entry = rtl_get_ps_drv_netif_mapping_by_psdev(dev);
+	if (entry)
+		entry->valid = 0;
+
+	return SUCCESS;
+}
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl_del_ps_drv_netif_mapping);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+int rtl_del_ps_drv_netif_mapping_by_name(const char *name)
+{
+	int i;
+
+	for (i = 0; i < NETIF_NUMBER; i++) {
+		if ((ps_drv_netif_mapping[i].valid == 1)
+			&& (strncmp(ps_drv_netif_mapping[i].drvName, name,
+					MAX_IFNAMESIZE) == 0)) {
+			ps_drv_netif_mapping[i].valid = 0;
+			return SUCCESS;
+		}
+	}
+
+	return FAILED;
+}
+#if defined(CONFIG_RTD_1295_HWNAT)
+EXPORT_SYMBOL(rtl_del_ps_drv_netif_mapping_by_name);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+/*
+ * Disable TX/RX through IO_CMD register
+ */
+static void rtl8186_stop_hw(struct net_device *dev, struct dev_priv *cp)
+{
+
+#if defined(PATCH_GPIO_FOR_LED)
+	if (cp->id == RTL_LANVLANID) {
+		int port;
+		for (port = 0; port < RTL8651_PHY_NUMBER; port++)
+			disable_led_ctrl(port);
+	}
+#endif
+
+}
+
+/* #ifndef CONFIG_RTL_8198C // modified by lynn_pu, 2014-10-16 */
+#if !defined(CONFIG_RTL_8198C) && (LINUX_VERSION_CODE < KERNEL_VERSION(3, 10, 0))
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)) && (LINUX_VERSION_CODE < KERNEL_VERSION(3, 3, 0))
+#else
+/* Set or clear the multicast filter for this adaptor.
+ * This routine is not state sensitive and need not be SMP locked.
+ */
+#ifndef CONFIG_OPENWRT_SDK
+static void re865x_set_rx_mode(struct net_device *dev)
+{
+/*	Not yet implemented.
+	unsigned long flags;
+	spin_lock_irqsave (&_rtl86xx_dev.lock, flags);
+	spin_unlock_irqrestore (&_rtl86xx_dev.lock, flags);
+*/
+}
+#endif
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT) || \
+	defined(CONFIG_RTL_8198C_8367RB) || defined(CONFIG_RTL_836X_SUPPORT)
+rtk_stat_port_cntr_t port_cntrs;
+#endif
+
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+struct port_stats port_stats[6];
+int rtl_get_portRate(unsigned int port, unsigned long *rxRate,
+	unsigned long *txRate)
+{
+	int ret = FAILED;
+	if ((port >= 0) && port < CPU) {
+		*rxRate = port_stats[port].rx_rate >> 7;	/* byte->kb */
+		*txRate = port_stats[port].tx_rate >> 7;
+		ret = SUCCESS;
+	}
+	return ret;
+}
+#endif
+
+#if defined(CONFIG_RTL_NIC_HWSTATS)
+void re865x_accumulate_port_stats(uint32 portnum,
+	struct net_device_stats *net_stats)
+{
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT) || \
+	(defined(CONFIG_RTL_CPU_TAG) && defined(CONFIG_RTL_836X_SUPPORT))
+#ifdef CONFIG_RTL_8367R_SUPPORT
+	if (portnum < 0 || portnum > CPU)
+		return;
+#endif
+
+	#if defined(CONFIG_RTL_836X_SUPPORT)
+	spin_lock(&rtl836x_ext_lock);
+	rtk_stat_port_getAll(rtl836x_portmap(portnum), &port_cntrs);
+	spin_unlock(&rtl836x_ext_lock);
+	#else
+	rtk_stat_port_getAll(portnum, &port_cntrs);
+	#endif /* CONFIG_RTL_836X_SUPPORT */
+
+	/* rx_pkt = rx_unicast +rx_multicast + rx_broadcast */
+	#if defined(CONFIG_RTL_836X_SUPPORT)
+	net_stats->rx_packets += port_cntrs.ifInUcastPkts;
+	net_stats->rx_packets += port_cntrs.ifInMulticastPkts;
+	net_stats->rx_packets += port_cntrs.ifInBroadcastPkts;
+	#else
+	net_stats->rx_packets += port_cntrs.ifInUcastPkts;
+	net_stats->rx_packets += port_cntrs.etherStatsMcastPkts;
+	net_stats->rx_packets += port_cntrs.etherStatsBcastPkts;
+	#endif /* CONFIG_RTL_836X_SUPPORT */
+
+	/* tx_pkt = tx_unicast +tx_multicast + tx_broadcast */
+	net_stats->tx_packets += port_cntrs.ifOutUcastPkts;
+	net_stats->tx_packets += port_cntrs.ifOutMulticastPkts;
+	net_stats->tx_packets += port_cntrs.ifOutBrocastPkts;
+
+	net_stats->rx_bytes += port_cntrs.ifInOctets;
+	net_stats->tx_bytes += port_cntrs.ifOutOctets;
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+	port_stats[portnum].rx_bytes_current = port_cntrs.ifInOctets;
+	port_stats[portnum].tx_bytes_current = port_cntrs.ifOutOctets;
+#endif
+
+	/*rx_errors = CRC error + Jabber error  + Fragment error */
+	net_stats->rx_errors += port_cntrs.dot3StatsFCSErrors;
+	net_stats->rx_errors += port_cntrs.etherStatsJabbers;
+	net_stats->rx_errors += port_cntrs.etherStatsFragments;
+	#if defined(CONFIG_RTL_836X_SUPPORT)
+	net_stats->tx_dropped += port_cntrs.ifOutDiscards;
+	#else
+	net_stats->tx_dropped += port_cntrs.dot1dTpPortInDiscards;
+	#endif /* CONFIG_RTL_836X_SUPPORT */
+	net_stats->multicast += port_cntrs.etherStatsMcastPkts;
+
+	net_stats->collisions += port_cntrs.etherStatsCollisions;
+	net_stats->rx_crc_errors += port_cntrs.dot3StatsFCSErrors;
+#else
+	uint32 addrOffset_fromP0 = 0;
+
+	if (portnum < 0 || portnum > CPU)
+		return;
+	addrOffset_fromP0 = portnum * MIB_ADDROFFSETBYPORT;
+	/* rx_pkt = rx_unicast +rx_multicast + rx_broadcast */
+	net_stats->rx_packets +=
+		rtl8651_returnAsicCounter(OFFSET_IFINUCASTPKTS_P0 +
+		addrOffset_fromP0);
+	net_stats->rx_packets +=
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSMULTICASTPKTS_P0 +
+		addrOffset_fromP0);
+	net_stats->rx_packets +=
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSBROADCASTPKTS_P0 +
+		addrOffset_fromP0);
+	/* tx_pkt = tx_unicast +tx_multicast + tx_broadcast */
+	net_stats->tx_packets +=
+		rtl8651_returnAsicCounter(OFFSET_IFOUTUCASTPKTS_P0 +
+		addrOffset_fromP0);
+	net_stats->tx_packets +=
+		rtl8651_returnAsicCounter(OFFSET_IFOUTMULTICASTPKTS_P0 +
+		addrOffset_fromP0);
+	net_stats->tx_packets +=
+		rtl8651_returnAsicCounter(OFFSET_IFOUTBROADCASTPKTS_P0 +
+		addrOffset_fromP0);
+
+	net_stats->rx_bytes +=
+		rtl8651_returnAsicCounter(OFFSET_IFINOCTETS_P0 +
+		addrOffset_fromP0);
+	net_stats->rx_bytes +=
+		(rtl8651_returnAsicCounter(OFFSET_IFINOCTETS_P0 + 4 +
+			addrOffset_fromP0) << 22);
+	net_stats->tx_bytes +=
+		rtl8651_returnAsicCounter(OFFSET_IFOUTOCTETS_P0 +
+		addrOffset_fromP0);
+	net_stats->tx_bytes +=
+		(rtl8651_returnAsicCounter(OFFSET_IFOUTOCTETS_P0 + 4 +
+			addrOffset_fromP0) << 22);
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+	port_stats[portnum].rx_bytes_current =
+		rtl8651_returnAsicCounter(OFFSET_IFINOCTETS_P0 +
+		addrOffset_fromP0);
+	port_stats[portnum].rx_bytes_current +=
+		(rtl8651_returnAsicCounter(OFFSET_IFINOCTETS_P0 + 4 +
+			addrOffset_fromP0) << 22);
+	port_stats[portnum].tx_bytes_current =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTOCTETS_P0 +
+		addrOffset_fromP0);
+	port_stats[portnum].tx_bytes_current +=
+		(rtl8651_returnAsicCounter(OFFSET_IFOUTOCTETS_P0 + 4 +
+			addrOffset_fromP0) << 22);
+#endif
+
+	/*rx_errors = CRC error + Jabber error  + Fragment error */
+	net_stats->rx_errors +=
+		rtl8651_returnAsicCounter(OFFSET_DOT3STATSFCSERRORS_P0 +
+		addrOffset_fromP0);
+	net_stats->rx_errors +=
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSJABBERS_P0 +
+		addrOffset_fromP0);
+	net_stats->rx_errors +=
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSOVERSIZEPKTS_P0 +
+		addrOffset_fromP0);
+	/* OFFSET_DOT1DTPPORTINDISCARDS_P0? */
+	/* net_stats->rx_dropped += rtl8651_returnAsicCounter( OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0 ) ; */
+	net_stats->tx_dropped +=
+		rtl8651_returnAsicCounter(OFFSET_IFOUTDISCARDS +
+		addrOffset_fromP0);
+	net_stats->multicast +=
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSMULTICASTPKTS_P0 +
+		addrOffset_fromP0);
+
+	net_stats->collisions +=
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSCOLLISIONS_P0 +
+		addrOffset_fromP0);
+	net_stats->rx_crc_errors +=
+		rtl8651_returnAsicCounter(OFFSET_DOT3STATSFCSERRORS_P0 +
+		addrOffset_fromP0);
+#endif
+	return;
+}
+
+void re865x_get_hardwareStats(struct dev_priv *priv)
+{
+	uint32 portmask;
+	uint32 port;
+
+	portmask = priv->portmask;
+	/* rx_dropped = priv->net_stats.rx_dropped; */
+	/* memset( &priv->net_stats, 0, sizeof(struct net_device_stats) ); */
+	/* reset counters to 0 */
+	priv->net_stats.rx_packets = 0;
+	priv->net_stats.tx_packets = 0;
+	priv->net_stats.rx_bytes = 0;
+	priv->net_stats.tx_bytes = 0;
+	priv->net_stats.rx_errors = 0;
+	priv->net_stats.tx_dropped = 0;
+	priv->net_stats.multicast = 0;
+	priv->net_stats.collisions = 0;
+	priv->net_stats.rx_crc_errors = 0;
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+	for (port = 0; port < CPU; port++) {
+		port_stats[port].rx_rate = 0;
+		port_stats[port].tx_rate = 0;
+	}
+#endif
+
+#ifdef CONFIG_RTL_8370_SUPPORT
+	if (priv->id == RTL_LANVLANID) {
+		for (port = 0; port < 8; port++) {
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+			port_stats[port].rx_bytes_last =
+				port_stats[port].rx_bytes_current;
+			port_stats[port].tx_bytes_last =
+				port_stats[port].tx_bytes_current;
+#endif
+			re865x_accumulate_port_stats(port, &priv->net_stats);
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+			port_stats[port].rx_rate =
+				port_stats[port].rx_bytes_current -
+				port_stats[port].rx_bytes_last;
+			port_stats[port].tx_rate =
+				port_stats[port].tx_bytes_current -
+				port_stats[port].tx_bytes_last;
+#endif
+		}
+	} else if (priv->id == RTL_WANVLANID) {
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+		port_stats[RTL83XX_WAN].rx_bytes_last =
+			port_stats[RTL83XX_WAN].rx_bytes_current;
+		port_stats[RTL83XX_WAN].tx_bytes_last =
+			port_stats[RTL83XX_WAN].tx_bytes_current;
+#endif
+		re865x_accumulate_port_stats(RTL83XX_WAN, &priv->net_stats);
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+		port_stats[RTL83XX_WAN].rx_rate =
+			port_stats[RTL83XX_WAN].rx_bytes_current -
+			port_stats[RTL83XX_WAN].rx_bytes_last;
+		port_stats[RTL83XX_WAN].tx_rate =
+			port_stats[RTL83XX_WAN].tx_bytes_current -
+			port_stats[RTL83XX_WAN].tx_bytes_last;
+#endif
+
+	}
+	return;
+#endif
+
+	for (port = 0; port < CPU; port++) {
+		if ((1 << port) & portmask) {
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+			port_stats[port].rx_bytes_last =
+				port_stats[port].rx_bytes_current;
+			port_stats[port].tx_bytes_last =
+				port_stats[port].tx_bytes_current;
+#endif
+			re865x_accumulate_port_stats(port, &priv->net_stats);
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+			port_stats[port].rx_rate =
+				port_stats[port].rx_bytes_current -
+				port_stats[port].rx_bytes_last;
+			port_stats[port].tx_rate =
+				port_stats[port].tx_bytes_current -
+				port_stats[port].tx_bytes_last;
+#endif
+		}
+
+	}
+	return;
+}
+#endif
+
+static struct net_device_stats *re865x_get_stats(struct net_device *dev)
+{
+	struct dev_priv *dp;
+	dp = NETDRV_PRIV(dev);
+#if defined(CONFIG_RTL_NIC_HWSTATS)
+	re865x_get_hardwareStats(dp);
+#endif
+	return &dp->net_stats;
+}
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q) || defined(CONFIG_RTL_DNS_TRAP) || defined(RTL_DROP_OUT_OF_BR_SUBNET_FRAME)
+static int32 re865x_packVlanConfig(struct rtl865x_vlanConfig vlanConfig1[],
+	struct rtl865x_vlanConfig vlanConfig2[])
+{
+	int i, j;
+	uint32 vlanCnt = 0;
+	uint32 found = FALSE;
+	/*get input vlan config entry number */
+	for (i = 0; vlanConfig1[i].ifname[0] != '\0'; i++) {
+		if (vlanConfig1[i].vid != 0)
+			vlanCnt++;
+	}
+
+	if (vlanCnt + 1 > NETIF_NUMBER)
+		DEBUG_ERR("ERROR,vlanCnt(%d) > max size %d\n", vlanCnt,
+			NETIF_NUMBER - 1);
+
+	/*initialize output vlan config */
+	memset(vlanConfig2, 0,
+		(vlanCnt + 1) * sizeof(struct rtl865x_vlanConfig));
+
+	for (i = 0; vlanConfig1[i].ifname[0] != '\0'; i++) {
+
+		found = FALSE;
+
+		if (vlanConfig1[i].vid == 0)
+			continue;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		if (vlanConfig1[i].memPort == 0)
+			continue;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		for (j = 0; j < vlanCnt; j++) {
+			if (vlanConfig1[i].if_type != vlanConfig2[j].if_type) {
+				continue;
+			} else {
+				if (vlanConfig1[i].if_type == IF_ETHER) {
+					/*ethernet interface */
+#if defined(CONFIG_RTL_MAC_BASED_NETIF)
+					/* Multiple WAN can has the same vlan id */
+					if ((vlanConfig1[i].isWan == 1)
+						|| (vlanConfig1[i].vid !=
+							vlanConfig2[j].vid))
+#else
+
+					/*if multiple vlan config has the same vlan id */
+					/*the first one will decide the  real network interface name/asic mtu/hardware address */
+
+					/*ethernet interface */
+					if (vlanConfig1[i].vid !=
+						vlanConfig2[j].vid)
+#endif
+					{
+						continue;
+					} else {
+						found = TRUE;
+						break;
+					}
+				} else {
+					/*PPP interface */
+					if (strcmp(vlanConfig1[i].ifname,
+							vlanConfig2[j].
+							ifname)) {
+						continue;
+					} else {
+						found = TRUE;
+						break;
+					}
+				}
+			}
+		}
+
+		if (found == TRUE) {
+			/*merge port mask */
+
+			vlanConfig2[j].memPort |= vlanConfig1[i].memPort;
+			vlanConfig2[j].untagSet |= vlanConfig1[i].untagSet;
+		} else {
+			/*find an empty entry to store this vlan config */
+			for (j = 0; j < vlanCnt; j++) {
+				if (vlanConfig2[j].vid == 0) {
+					memcpy(&vlanConfig2[j], &vlanConfig1[i],
+						sizeof(struct
+							rtl865x_vlanConfig));
+
+					if ((vlanConfig1[i].if_type == IF_ETHER)
+						&& (vlanConfig1[i].isWan ==
+							FALSE)) {
+						/*add cpu port to lan member list */
+						vlanConfig2[j].memPort |= 0x100;
+						vlanConfig2[j].untagSet |=
+							0x100;
+					}
+					break;
+
+				}
+			}
+		}
+
+	}
+	return SUCCESS;
+}
+#endif
+
+static void rtl865x_disableDevPortForward(struct net_device *dev,
+	struct dev_priv *cp)
+{
+	int port;
+
+#if defined(CONFIG_RTL_8370_SUPPORT)
+	extern int rtk_port_adminEnable_set(uint32 port, uint32 enable);
+	if (dev->name[3] == '0') {	/* eth0 */
+		for (port = 0; port < 8; port++)
+			rtk_port_adminEnable_set(port, 0);
+	} else if (dev->name[3] == '1') {	/* eth1 */
+		rtk_port_adminEnable_set(RTL83XX_WAN, 0);
+	}
+	return;
+#endif
+
+	for (port = 0; port < RTL8651_AGGREGATOR_NUMBER; port++) {
+		if ((1 << port) & cp->portmask) {
+#ifdef CONFIG_RTL_8367R_SUPPORT
+			if (port <= 4) {
+				/* extern int rtk_stp_mstpState_set(int msti, int port, int stp_state); */
+				/* rtk_stp_mstpState_set(0 , port, 1); // 1: STP_STATE_BLOCKING */
+				extern int rtk_port_adminEnable_set(uint32 port,
+					uint32 enable);
+				rtk_port_adminEnable_set(port, 0);
+			}
+#elif defined(CONFIG_RTD_1295_HWNAT) && \
+	defined(CONFIG_RTL_CPU_TAG) && \
+	defined(CONFIG_RTL_836X_SUPPORT)
+			if (port <= 5) {
+				spin_lock(&rtl836x_ext_lock);
+				rtk_port_adminEnable_set(rtl836x_portmap(port), 0);
+				spin_unlock(&rtl836x_ext_lock);
+			}
+#elif defined(CONFIG_RTD_1295_HWNAT) && \
+	defined(CONFIG_RTL_2_RGMII_PORTS_ONLY) && \
+	defined(CONFIG_RTL_836X_SUPPORT)
+			if (port == 0) {
+				spin_lock(&rtl836x_ext_lock);
+				rtk_port_adminEnable_set(rtl836x_portmap(0), 0);
+				rtk_port_adminEnable_set(rtl836x_portmap(1), 0);
+				rtk_port_adminEnable_set(rtl836x_portmap(2), 0);
+				rtk_port_adminEnable_set(rtl836x_portmap(3), 0);
+				spin_unlock(&rtl836x_ext_lock);
+			} else if (port == 5) {
+				spin_lock(&rtl836x_ext_lock);
+				rtk_port_adminEnable_set(rtl836x_portmap(5), 0);
+				spin_unlock(&rtl836x_ext_lock);
+			}
+#else
+			REG32(PCRP0 + (port << 2)) =
+				((REG32(PCRP0 + (port << 2))) & (~ForceLink));
+			REG32(PCRP0 + (port << 2)) =
+				((REG32(PCRP0 + (port << 2))) & (~EnablePHYIf));
+			TOGGLE_BIT_IN_REG_TWICE(PCRP0 + (port << 2),
+				EnablePHYIf);
+			TOGGLE_BIT_IN_REG_TWICE(PCRP0 + (port << 2), ForceLink);
+			TOGGLE_BIT_IN_REG_TWICE(PCRP0 + (port << 2),
+				EnForceMode);
+#endif
+		}
+	}
+#ifdef CONFIG_RTL_8196C_ESD
+	if ((cp->portmask) & 0x10)	/* port 4 */
+		_96c_esd_counter = 0;	/* stop counting */
+#endif
+}
+
+#if !(defined(CONFIG_RTD_1295_HWNAT) && (defined(CONFIG_RTL_CPU_TAG) || \
+	defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)) && \
+	defined(CONFIG_RTL_836X_SUPPORT))
+#if !defined(CONFIG_RTL_8196C)
+static void rtl865x_restartDevPHYNway(struct net_device *dev,
+	struct dev_priv *cp)
+{
+	int port;
+	for (port = 0; port < RTL8651_AGGREGATOR_NUMBER; port++) {
+		if ((1 << port) & cp->portmask) {
+			rtl8651_restartAsicEthernetPHYNway(port);
+		}
+	}
+	return;
+}
+#endif
+#endif /* !(CONFIG_RTD_1295_HWNAT && ONFIG_RTL_CPU_TAG && CONFIG_RTL_836X_SUPPORT) */
+
+#if defined(CONFIG_819X_PHY_RW) || defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+static void rtl865x_setPortForward(int port_num, int forward)
+{
+	if (port_num < 0 || port_num >= RTL8651_AGGREGATOR_NUMBER)
+		return;
+
+	if (forward == FALSE) {
+		REG32(PCRP0 + (port_num << 2)) =
+			((REG32(PCRP0 + (port_num << 2))) & (~EnablePHYIf));
+#ifdef CONFIG_RTL_8196C_ESD
+		if (port_num == 4)	/* port 4 */
+			_96c_esd_counter = 0;	/* stop counting */
+#endif
+	} else {
+		REG32(PCRP0 + (port_num << 2)) =
+			((REG32(PCRP0 + (port_num << 2))) | (EnablePHYIf));
+
+#ifdef CONFIG_RTL_8196C_ESD
+		if (port_num == 4) {	/* port 4 */
+			_96c_esd_counter = 1;	/* start counting and check ESD */
+			_96c_esd_reboot_counter = 0;	/* reset counter */
+		}
+#endif
+	}
+	TOGGLE_BIT_IN_REG_TWICE(PCRP0 + (port_num << 2), EnForceMode);
+
+}
+#endif /* #if defined(CONFIG_819X_PHY_RW) */
+
+static void rtl865x_enableDevPortForward(struct net_device *dev,
+	struct dev_priv *cp)
+{
+	int port;
+
+#if defined(CONFIG_RTL_8370_SUPPORT)
+	extern int rtk_port_adminEnable_set(uint32 port, uint32 enable);
+	if (dev->name[3] == '0') {	/* eth0 */
+		for (port = 0; port < 8; port++)
+			rtk_port_adminEnable_set(port, 1);
+	} else if (dev->name[3] == '1') {	/* eth1 */
+		rtk_port_adminEnable_set(RTL83XX_WAN, 1);
+	}
+	return;
+#endif
+
+	for (port = 0; port < RTL8651_AGGREGATOR_NUMBER; port++) {
+		if ((1 << port) & cp->portmask) {
+#ifdef CONFIG_RTL_8367R_SUPPORT
+			if (port <= 4) {
+				/* extern int rtk_stp_mstpState_set(int msti, int port, int stp_state); */
+				/* rtk_stp_mstpState_set(0 , port, 3); // 3: STP_STATE_FORWARDING */
+				extern int rtk_port_adminEnable_set(uint32 port,
+					uint32 enable);
+				rtk_port_adminEnable_set(port, 1);
+			}
+#else
+#if defined(CONFIG_RTD_1295_HWNAT) && \
+	defined(CONFIG_RTL_836X_SUPPORT)
+#if defined(CONFIG_RTL_CPU_TAG)
+			if (port <= 5) {
+				spin_lock(&rtl836x_ext_lock);
+				rtk_port_adminEnable_set(rtl836x_portmap(port), 1);
+				spin_unlock(&rtl836x_ext_lock);
+			}
+#elif defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)
+			if (port == 0) {
+				spin_lock(&rtl836x_ext_lock);
+				rtk_port_adminEnable_set(rtl836x_portmap(0), 1);
+				rtk_port_adminEnable_set(rtl836x_portmap(1), 1);
+				rtk_port_adminEnable_set(rtl836x_portmap(2), 1);
+				rtk_port_adminEnable_set(rtl836x_portmap(3), 1);
+				spin_unlock(&rtl836x_ext_lock);
+			} else if (port == 5) {
+				spin_lock(&rtl836x_ext_lock);
+				rtk_port_adminEnable_set(rtl836x_portmap(5), 1);
+				spin_unlock(&rtl836x_ext_lock);
+			}
+#endif /* CONFIG_RTL_CPU_TAG || CONFIG_RTL_2_RGMII_PORTS_ONLY */
+#endif /* CONFIG_RTD_1295_HWNAT && CONFIG_RTL_836X_SUPPORT */
+			REG32(PCRP0 + (port << 2)) =
+				((REG32(PCRP0 + (port << 2))) | (ForceLink));
+			REG32(PCRP0 + (port << 2)) =
+				((REG32(PCRP0 + (port << 2))) | (EnablePHYIf));
+			TOGGLE_BIT_IN_REG_TWICE(PCRP0 + (port << 2),
+				EnablePHYIf);
+			TOGGLE_BIT_IN_REG_TWICE(PCRP0 + (port << 2), ForceLink);
+#endif
+		}
+	}
+#ifdef CONFIG_RTL_8196C_ESD
+	if ((cp->portmask) & 0x10) {	/* port 4 */
+		_96c_esd_counter = 1;	/* start counting and check ESD */
+		_96c_esd_reboot_counter = 0;	/* reset counter */
+	}
+#endif
+}
+
+static void rtl865x_disableInterrupt(void)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	REG32(CPUICR) = 0;
+	REG32(CPUIIMR) = 0;
+	REG32(CPUIISR) = REG32(CPUIISR);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	SMP_UNLOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}
+
+static void rtk_queue_init(struct ring_que *que)
+{
+	memset(que, 0, sizeof(struct ring_que));
+	que->ring = (struct sk_buff **)kmalloc(
+		(sizeof(struct skb_buff *) * (rtl865x_maxPreAllocRxSkb + 1))
+		, GFP_ATOMIC);
+	memset(que->ring, 0,
+		(sizeof(struct sk_buff *)) * (rtl865x_maxPreAllocRxSkb + 1));
+	que->qmax = rtl865x_maxPreAllocRxSkb;
+}
+
+static void rtk_queue_exit(struct ring_que *que)
+{
+
+	if (que->ring != NULL) {
+		kfree(que->ring);
+		que->ring = NULL;
+	}
+}
+
+__MIPS16 __IRAM_FWD
+	static int rtk_queue_tail(struct ring_que *que, struct sk_buff *skb)
+{
+	int next;
+
+	if (que->head == que->qmax)
+		next = 0;
+	else
+		next = que->head + 1;
+
+	if (que->qlen >= que->qmax || next == que->tail) {
+		return 0;
+	}
+
+	que->ring[que->head] = skb;
+	que->head = next;
+	que->qlen++;
+
+	return 1;
+}
+
+__MIPS16 __IRAM_FWD static struct sk_buff *rtk_dequeue(struct ring_que *que)
+{
+	struct sk_buff *skb;
+
+	if (que->qlen <= 0 || que->tail == que->head) {
+		return NULL;
+	}
+
+	skb = que->ring[que->tail];
+
+	if (que->tail == que->qmax)
+		que->tail = 0;
+	else
+		que->tail++;
+
+	que->qlen--;
+
+	return (struct sk_buff *)skb;
+}
+
+/* #if defined(CONFIG_RTL_ETH_PRIV_SKB_DEBUG) */
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+int get_buf_in_rx_skb_queue(void)
+{
+	return rx_skb_queue.qlen;
+}
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+int get_buf_in_poll(void)
+{
+	return eth_skb_free_num;
+}
+#endif
+#endif
+
+/* __MIPS16 */
+__IRAM_FWD static void refill_rx_skb(void)
+{
+	struct sk_buff *skb;
+	unsigned long flags = 0;
+	int idx;
+
+	idx = RTL865X_SWNIC_RXRING_MAX_PKTDESC - 1;
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+	while (rx_skb_queue.qlen < rtl865x_maxPreAllocRxSkb || ((idx >= 0)
+			&& (SUCCESS == check_rx_pkthdr_ring(idx, &idx))))
+#else
+	while (rx_skb_queue.qlen < rtl865x_maxPreAllocRxSkb)
+#endif
+	{
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+		skb = dev_alloc_skb_priv_eth(CROSS_LAN_MBUF_LEN);
+#else
+		skb = dev_alloc_skb(CROSS_LAN_MBUF_LEN);
+#endif
+
+		if (skb == NULL) {
+			DEBUG_ERR("EthDrv: dev_alloc_skb() failed!\n");
+			return;
+		}
+		skb_reserve(skb, RX_OFFSET);
+
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+		/* return to rx descriptor ring first if the rings still have the OWN bit which be RISC_OWNED. */
+		if (idx >= 0) {
+			if (SUCCESS == check_and_return_to_rx_pkthdr_ring(skb,
+					idx)) {
+				continue;
+			}
+		}
+#endif
+
+#if defined(RTK_QUE)
+		SMP_LOCK_ETH_BUF(flags);
+		rtk_queue_tail(&rx_skb_queue, skb);
+		SMP_UNLOCK_ETH_BUF(flags);
+#else
+		__skb_queue_tail(&rx_skb_queue, skb);
+#endif
+	}
+}
+
+/* --------------------------------------------------------------------------- */
+static void free_rx_skb(void)
+{
+	struct sk_buff *skb;
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+#endif
+
+	RTL_swNic_freeRxBuf();
+
+	while (rx_skb_queue.qlen > 0) {
+#if defined(CONFIG_SMP)
+		SMP_LOCK_ETH_BUF(flags);
+#endif
+#if defined(RTK_QUE)
+		skb = rtk_dequeue(&rx_skb_queue);
+#else
+		skb = __skb_dequeue(&rx_skb_queue);
+#endif
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_ETH_BUF(flags);
+#endif
+		dev_kfree_skb_any(skb);
+	}
+}
+
+/* --------------------------------------------------------------------------- */
+__IRAM_FWD unsigned char *alloc_rx_buf(void **skb, int buflen)
+{
+	struct sk_buff *new_skb;
+	unsigned long flags = 0;
+#ifdef CONFIG_RTL_JUMBO_FRAME
+	if (buflen > CROSS_LAN_MBUF_LEN) {
+		new_skb = dev_alloc_skb(buflen);
+		if (new_skb == NULL) {
+			DEBUG_ERR("EthDrv: alloc skb failed!\n");
+		} else
+			skb_reserve(new_skb, RX_OFFSET);
+	} else {
+#endif
+		if (rx_skb_queue.qlen == 0) {
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+			new_skb = dev_alloc_skb_priv_eth(CROSS_LAN_MBUF_LEN);
+#else
+			new_skb = dev_alloc_skb(CROSS_LAN_MBUF_LEN);
+#endif
+			if (new_skb == NULL) {
+				DEBUG_ERR("EthDrv: alloc skb failed!\n");
+			} else
+				skb_reserve(new_skb, RX_OFFSET);
+		} else {
+#if defined(RTK_QUE)
+			SMP_LOCK_ETH_BUF(flags);
+			new_skb = rtk_dequeue(&rx_skb_queue);
+			SMP_UNLOCK_ETH_BUF(flags);
+#else
+			new_skb = __skb_dequeue(&rx_skb_queue);
+#endif
+		}
+#ifdef CONFIG_RTL_JUMBO_FRAME
+	}
+#endif
+	if (new_skb == NULL)
+		return NULL;
+
+#if 0				/* defined(CONFIG_RTL_ULINKER_BRSC) */
+	skb_reserve(new_skb, 2);
+#endif
+
+	*skb = new_skb;
+
+	return new_skb->data;
+}
+
+#ifdef PRIV_BUF_CAN_USE_KERNEL_BUF
+__IRAM_FWD unsigned char *alloc_rx_buf_init(void **skb, int buflen)
+{
+	struct sk_buff *new_skb;
+	unsigned long flags = 0;
+#ifdef CONFIG_RTL_JUMBO_FRAME
+	if (buflen > CROSS_LAN_MBUF_LEN) {
+		new_skb = dev_alloc_skb(buflen);
+		if (new_skb == NULL) {
+			DEBUG_ERR("EthDrv: alloc skb failed!\n");
+		} else
+			skb_reserve(new_skb, RX_OFFSET);
+	} else {
+#endif
+		if (rx_skb_queue.qlen == 0) {
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+			new_skb = dev_alloc_skb_priv_eth(CROSS_LAN_MBUF_LEN);
+			if (new_skb == NULL) {
+				new_skb = dev_alloc_skb(CROSS_LAN_MBUF_LEN);
+			}
+#else
+			new_skb = dev_alloc_skb(CROSS_LAN_MBUF_LEN);
+#endif
+			if (new_skb == NULL) {
+				DEBUG_ERR("EthDrv: alloc skb failed!\n");
+			} else
+				skb_reserve(new_skb, RX_OFFSET);
+		} else {
+#if defined(RTK_QUE)
+			SMP_LOCK_ETH_BUF(flags);
+			new_skb = rtk_dequeue(&rx_skb_queue);
+			SMP_UNLOCK_ETH_BUF(flags);
+#else
+			new_skb = __skb_dequeue(&rx_skb_queue);
+#endif
+		}
+#ifdef CONFIG_RTL_JUMBO_FRAME
+	}
+#endif
+	if (new_skb == NULL)
+		return NULL;
+
+	*skb = new_skb;
+
+	return new_skb->data;
+}
+#endif
+
+/* --------------------------------------------------------------------------- */
+#if !defined(CONFIG_RTD_1295_HWNAT)
+inline void free_rx_buf(void *skb)
+{
+	dev_kfree_skb_any((struct sk_buff *)skb);
+}
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+void sync_rx_data_for_device(dma_addr_t addr, int len)
+{
+	struct device *d;
+
+	d = &rtl819x_pdev->dev;
+	dma_sync_single_for_device(d, addr, len, DMA_FROM_DEVICE);
+	return;
+}
+
+/* skb->len and skb->data_len are invalid in the meanwhile. */
+void sync_rx_data_for_cpu(dma_addr_t addr, int len)
+{
+	struct device *d;
+
+	d = &rtl819x_pdev->dev;
+	dma_sync_single_for_cpu(d, addr, len, DMA_FROM_DEVICE);
+	return;
+}
+
+void sync_tx_data_for_device(dma_addr_t addr, int len)
+{
+	struct device *d;
+
+	d = &rtl819x_pdev->dev;
+	dma_sync_single_for_device(d, addr, len, DMA_TO_DEVICE);
+	return;
+}
+
+void rtl_dump_data(void *p, int len)
+{
+	int i;
+	unsigned char *ptr;
+
+	ptr = (unsigned char *)p;
+	for (i = 0; i < len; i++) {
+		if ((i % 16) == 0)
+			printk("\n%04X  ", i);
+		if ((i % 8) == 0)
+			printk("  ");
+
+		printk("%02x ", ptr[i]);
+	}
+	printk("\n");
+}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+/* --------------------------------------------------------------------------- */
+#if defined(CONFIG_RTL_FAST_BRIDGE)
+void tx_done_callback(void *skb)
+{
+#if defined(CONFIG_RTL_FAST_BRIDGE)
+#define RTL_PRIV_DATA_SIZE	128
+	unsigned long flags = 0;
+	/* hyking: */
+	/* queue private skb and buffer */
+	if (((struct sk_buff *)skb)->fast_br_forwarding_flags == 1
+		&& is_rtl865x_eth_priv_buf(((struct sk_buff *)skb)->head)) {
+		if (!(skb_cloned(skb))) {
+			/* disable irq */
+			SMP_LOCK_ETH_BUF(flags);
+			if (rtk_queue_tail(&rx_skb_queue,
+					(struct sk_buff *)skb)) {
+				unsigned char *data;
+				struct skb_shared_info *shinfo;
+				int size;
+				data = (((struct sk_buff *)skb)->head);
+
+				memset(skb, 0, offsetof(struct sk_buff,
+						truesize));
+				atomic_set(&((struct sk_buff *)skb)->users, 1);
+				((struct sk_buff *)skb)->head = data;
+				((struct sk_buff *)skb)->data = data;
+				((struct sk_buff *)skb)->tail = data;
+
+				size = (CROSS_LAN_MBUF_LEN + 128 + NET_SKB_PAD);
+
+				((struct sk_buff *)skb)->end = data + size;
+				((struct sk_buff *)skb)->truesize =
+					size + sizeof(struct sk_buff);
+
+				/* make sure we initialize shinfo sequentially */
+				shinfo = skb_shinfo(skb);
+				atomic_set(&shinfo->dataref, 1);
+				shinfo->nr_frags = 0;
+				shinfo->gso_size = 0;
+				shinfo->gso_segs = 0;
+				shinfo->gso_type = 0;
+				shinfo->ip6_frag_id = 0;
+				shinfo->frag_list = NULL;
+
+#ifdef CONFIG_RTK_VOIP_VLAN_ID
+				((struct sk_buff *)skb)->rx_vlan = 0;
+				((struct sk_buff *)skb)->rx_wlan = 0;
+				((struct sk_buff *)skb)->priority = 0;
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST) || defined(CONFIG_RTL_QOS_VLANID_SUPPORT)
+				((struct sk_buff *)skb)->srcPort = 0xFFFF;
+				((struct sk_buff *)skb)->srcVlanId = 0;
+#endif
+
+#if defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+				((struct sk_buff *)skb)->srcVlanPriority = 0;
+#endif
+
+#if defined(CONFIG_RTL_VLANPRI_IPTABLE_CHECK)
+				((struct sk_buff *)skb)->original_vlanpri = 0;
+#endif
+
+#if defined(CONFIG_NETFILTER_XT_MATCH_PHYPORT) || defined(CONFIG_RTL_FAST_FILTER) || defined(CONFIG_RTL_QOS_PATCH) || defined(CONFIG_RTK_VOIP_QOS) || defined(CONFIG_RTK_VLAN_WAN_TAG_SUPPORT) || defined(CONFIG_RTL_MAC_FILTER_CARE_INPORT) || defined(CONFIG_RTL_HW_QOS_SUPPORT_WLAN)
+				((struct sk_buff *)skb)->srcPhyPort = 0xFF;
+				((struct sk_buff *)skb)->dstPhyPort = 0xFF;
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+				((struct sk_buff *)skb)->tag.v = 0;
+#endif
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+				((struct sk_buff *)skb)->srcLocalPublicIp = 0;
+				((struct sk_buff *)skb)->fromLocalPublic = 0;
+				((struct sk_buff *)skb)->toLocalPublic = 0;
+#endif
+
+#ifdef CONFIG_RTK_VOIP_VLAN_ID
+				skb_reserve(((struct sk_buff *)skb), RTL_PRIV_DATA_SIZE + 4);	/* for VLAN TAG insertion */
+#else
+				skb_reserve(((struct sk_buff *)skb),
+					RTL_PRIV_DATA_SIZE);
+#endif
+				/* reserve for 4 byte alignment */
+				skb_reserve(((struct sk_buff *)skb), RX_OFFSET);
+				/* enable irq */
+				SMP_UNLOCK_ETH_BUF(flags);
+				return;
+			}
+			/* enable irq */
+			SMP_UNLOCK_ETH_BUF(flags);
+		}
+	}
+#endif
+	dev_kfree_skb_any((struct sk_buff *)skb);
+}
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+#if defined(CONFIG_BRIDGE) && !defined(CONFIG_OPENWRT_SDK)
+extern void br_signal_igmpProxy(void);
+#endif
+
+static inline struct iphdr *re865x_getIpv4Header(uint8 *macFrame)
+{
+	uint8 *ptr;
+	struct iphdr *iph = NULL;
+
+	ptr = macFrame + 12;
+	if (*(int16 *) (ptr) == (int16) htons(ETH_P_8021Q)) {
+		ptr = ptr + 4;
+	}
+	if (*(int16 *) (ptr) == (int16) htons(ETH_P_IPV6)) {
+		ptr = ptr + sizeof(struct ipv6hdr);
+	}
+	/*it's not ipv4 packet */
+	if (*(int16 *) (ptr) != (int16) htons(ETH_P_IP)) {
+		return NULL;
+	}
+
+	iph = (struct iphdr *)(ptr + 2);
+
+	return iph;
+}
+
+#if defined(CONFIG_RTL_MLD_SNOOPING) || defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+static inline struct ipv6hdr *re865x_getIpv6Header(uint8 *macFrame)
+{
+	uint8 *ptr;
+	struct ipv6hdr *ipv6h = NULL;
+
+	ptr = macFrame + 12;
+	if (*(int16 *) (ptr) == (int16) htons(ETH_P_8021Q)) {
+		ptr = ptr + 4;
+	}
+
+	if (*(int16 *) (ptr) == (int16) htons(ETH_P_IP)) {
+		ptr = ptr + sizeof(struct iphdr);
+	}
+
+	/*it's not ipv6 packet */
+	if (*(int16 *) (ptr) != (int16) htons(ETH_P_IPV6)) {
+		return NULL;
+	}
+
+	ipv6h = (struct ipv6hdr *)(ptr + 2);
+
+	return ipv6h;
+}
+
+#define IPV4_MCAST_PACKET 	0x1
+#define	IPV6_MCAST_PACKET 	0x2
+#define DSLITE_MCAST_PACKET 	0x3
+#define	SIXRD_MCAST_PACKET 	0x4
+#define	IPV6_MCAST_PACKET2 	0x5
+
+#define IN6_IS_ADDR_MULTICAST(a) ((a[0] & htonl(0xff000000)) == htonl(0xff000000))
+/* #define IN6_IS_ADDR_MULTICAST(a) (((__const uint8_t *) (a))[0] == 0xff) */
+
+static inline int rtl_isMcastPkt(struct sk_buff *skb)
+{
+	int ret = 0;
+	struct iphdr *iph = NULL;
+	struct ipv6hdr *ipv6h = NULL;
+	uint8 *ptr;
+	if ((skb->data[0] & 0x1) && (skb->data[0] != 0xff)) {
+
+		if ((skb->data[0] == 0x01) && (skb->data[1] == 0x00)
+			&& (skb->data[2] == 0x5e)) {
+			ret = IPV4_MCAST_PACKET;
+		} else if ((skb->data[0] == 0x33) && (skb->data[1] == 0x33)
+			&& (skb->data[2] != 0xff)) {
+			ret = IPV6_MCAST_PACKET;
+		} else if ((skb->data[0] == 0x33) && (skb->data[1] == 0x33)
+			&& (skb->data[2] == 0xff)) {
+			ret = IPV6_MCAST_PACKET2;
+		}
+		goto out;
+	}
+	iph = re865x_getIpv4Header(skb->data);
+
+	/*6rd multicast packet */
+	if (iph) {
+		if (iph->protocol == IPPROTO_IPV6) {
+			ptr = (uint8 *)iph;
+			ptr = ptr + sizeof(struct iphdr);
+			ipv6h = (struct ipv6hdr *)ptr;
+			if (ipv6h && (ipv6h->version == IP_VERSION6)
+				&& (IN6_IS_ADDR_MULTICAST(ipv6h->daddr.
+						s6_addr32))) {
+				ret = SIXRD_MCAST_PACKET;
+				goto out;
+			}
+		}
+	}
+	ipv6h = re865x_getIpv6Header(skb->data);
+	/*dslite multicast packet */
+	if (ipv6h) {
+		if (ipv6h->nexthdr == IPPROTO_IPIP)
+		{
+			ptr = (uint8 *)ipv6h;
+			ptr = ptr + sizeof(struct ipv6hdr);
+			iph = (struct iphdr *)ptr;
+			if (iph && (iph->version == IP_VERSION4)
+				&& (ipv4_is_multicast(iph->daddr))) {
+				ret = DSLITE_MCAST_PACKET;
+				goto out;
+			}
+
+		}
+	}
+out:
+	return ret;
+}
+
+#define IPV6_ROUTER_ALTER_OPTION 0x05020000
+#define  HOP_BY_HOP_OPTIONS_HEADER 0
+#define ROUTING_HEADER 43
+#define  FRAGMENT_HEADER 44
+#define DESTINATION_OPTION_HEADER 60
+
+#define PIM_PROTOCOL 103
+#define MOSPF_PROTOCOL 89
+#define TCP_PROTOCOL 6
+#define UDP_PROTOCOL 17
+#define NO_NEXT_HEADER 59
+#define ICMP_PROTOCOL 58
+
+#define MLD_QUERY 130
+#define MLDV1_REPORT 131
+#define MLDV1_DONE 132
+#define MLDV2_REPORT 143
+
+#define IS_IPV6_PIM_ADDR(ipv6addr) ((ipv6addr[0] == 0xFF020000) && (ipv6addr[1] == 0x00000000) && (ipv6addr[2] == 0x00000000) && (ipv6addr[3] == 0x0000000D))
+#define IS_IPV6_MOSPF_ADDR1(ipv6addr) ((ipv6addr[0] == 0xFF020000) && (ipv6addr[1] == 0x00000000) && (ipv6addr[2] == 0x00000000) && (ipv6addr[3] == 0x00000005))
+#define IS_IPV6_MOSPF_ADDR2(ipv6addr) ((ipv6addr[0] == 0xFF020000) && (ipv6addr[1] == 0x00000000) && (ipv6addr[2] == 0x00000000) && (ipv6addr[3] == 0x00000006))
+
+int re865x_getIpv6TransportProtocol(struct ipv6hdr *ipv6h)
+{
+
+	unsigned char *ptr = NULL;
+	unsigned char *startPtr = NULL;
+	unsigned char *lastPtr = NULL;
+	unsigned char nextHeader = 0;
+	unsigned short extensionHdrLen = 0;
+
+	unsigned char optionDataLen = 0;
+	unsigned char optionType = 0;
+	unsigned int ipv6RAO = 0;
+	unsigned int ipv6addr[4] = { 0 };
+
+	if (ipv6h == NULL) {
+		return -1;
+	}
+
+	if (ipv6h->version != 6) {
+		return -1;
+	}
+
+	startPtr = (unsigned char *)ipv6h;
+	lastPtr = startPtr + sizeof(struct ipv6hdr) + ntohs(ipv6h->payload_len);
+	nextHeader = ipv6h->nexthdr;
+	ptr = startPtr + sizeof(struct ipv6hdr);
+
+	ipv6addr[0] = ntohl(ipv6h->daddr.s6_addr32[0]);
+	ipv6addr[1] = ntohl(ipv6h->daddr.s6_addr32[1]);
+	ipv6addr[2] = ntohl(ipv6h->daddr.s6_addr32[2]);
+	ipv6addr[3] = ntohl(ipv6h->daddr.s6_addr32[3]);
+
+	while (ptr < lastPtr) {
+		switch (nextHeader) {
+		case HOP_BY_HOP_OPTIONS_HEADER:
+			/*parse hop-by-hop option */
+			nextHeader = ptr[0];
+			extensionHdrLen = ((uint16)(ptr[1]) + 1) * 8;
+			ptr = ptr + 2;
+
+			while (ptr <
+				(startPtr + extensionHdrLen +
+					sizeof(struct ipv6hdr))) {
+				optionType = ptr[0];
+				/*pad1 option */
+				if (optionType == 0) {
+					ptr = ptr + 1;
+					continue;
+				}
+
+				/*padN option */
+				if (optionType == 1) {
+					optionDataLen = ptr[1];
+					ptr = ptr + optionDataLen + 2;
+					continue;
+				}
+
+				/*router altert option */
+				if (ntohl(*(uint32 *)(ptr)) ==
+					IPV6_ROUTER_ALTER_OPTION) {
+					ipv6RAO = IPV6_ROUTER_ALTER_OPTION;
+					ptr = ptr + 4;
+					continue;
+				}
+
+				/*other TLV option */
+				if ((optionType != 0) && (optionType != 1)) {
+					optionDataLen = ptr[1];
+					ptr = ptr + optionDataLen + 2;
+					continue;
+				}
+
+			}
+
+			break;
+
+		case ROUTING_HEADER:
+			nextHeader = ptr[0];
+			extensionHdrLen = ((uint16)(ptr[1]) + 1) * 8;
+			ptr = ptr + extensionHdrLen;
+			break;
+
+		case FRAGMENT_HEADER:
+			nextHeader = ptr[0];
+			ptr = ptr + 8;
+			break;
+
+		case DESTINATION_OPTION_HEADER:
+			nextHeader = ptr[0];
+			extensionHdrLen = ((uint16)(ptr[1]) + 1) * 8;
+			ptr = ptr + extensionHdrLen;
+			break;
+
+		case ICMP_PROTOCOL:
+			nextHeader = NO_NEXT_HEADER;
+			if ((ptr[0] == MLD_QUERY) || (ptr[0] == MLDV1_REPORT)
+				|| (ptr[0] == MLDV1_DONE)
+				|| (ptr[0] == MLDV2_REPORT)) {
+				return ICMP_PROTOCOL;
+
+			}
+			break;
+
+		case PIM_PROTOCOL:
+			nextHeader = NO_NEXT_HEADER;
+			if (IS_IPV6_PIM_ADDR(ipv6addr)) {
+				return PIM_PROTOCOL;
+			}
+
+			break;
+
+		case MOSPF_PROTOCOL:
+			nextHeader = NO_NEXT_HEADER;
+			if (IS_IPV6_MOSPF_ADDR1(ipv6addr)
+				|| IS_IPV6_MOSPF_ADDR2(ipv6addr)) {
+				return MOSPF_PROTOCOL;
+			}
+			break;
+
+		case TCP_PROTOCOL:
+			nextHeader = NO_NEXT_HEADER;
+			return TCP_PROTOCOL;
+
+			break;
+
+		case UDP_PROTOCOL:
+			nextHeader = NO_NEXT_HEADER;
+			return UDP_PROTOCOL;
+
+			break;
+
+		default:
+			/*not ipv6 multicast protocol */
+			return -1;
+		}
+
+	}
+	return -1;
+}
+#endif
+static inline void re865x_relayTrappedMCast(struct sk_buff *skb,
+	unsigned int vid, unsigned int mcastFwdPortMask,
+	unsigned int keepOrigSkb)
+{
+	rtl_nicTx_info nicTx;
+	struct sk_buff *skb2 = NULL;
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	struct sk_buff *skb_wan = NULL;
+	rtl_nicTx_info nicTx_wan;
+#endif
+
+#if 0				/* def CONFIG_RTL_VLAN_8021Q */
+	uint8 portMask;
+	uint8 tagMask;
+	uint8 untagMask;
+	struct sk_buff *pskb = NULL;
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	dma_addr_t mapping = 0;
+	struct dev_priv *cp;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	if (mcastFwdPortMask == 0) {
+		return;
+	}
+
+	if (keepOrigSkb == TRUE) {
+		skb2 = skb_clone(skb, GFP_ATOMIC);
+	} else {
+		skb2 = skb;
+	}
+
+	if (skb2 != NULL) {
+		nicTx.txIdx = 0;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	cp = NETDRV_PRIV(skb2->dev);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+		if (vlan_bridge_tag && vlan_bridge_multicast_tag
+			&& (vid == vlan_bridge_tag)
+			&& (mcastFwdPortMask & RTL_WANPORT_MASK)) {
+			mcastFwdPortMask &= (~RTL_WANPORT_MASK);
+			skb_wan = skb_copy(skb, GFP_ATOMIC);
+			if (skb_wan != NULL) {
+				nicTx_wan.txIdx = 0;
+				nicTx_wan.vid = vlan_bridge_multicast_tag;
+				nicTx_wan.portlist = RTL_WANPORT_MASK;
+				nicTx_wan.srcExtPort = 0;
+
+				nicTx_wan.tagport = RTL_WANPORT_MASK;
+
+				/* flush cache 0515 by tim */
+				RTL_CACHE_WBACK((unsigned long)skb_wan->data,
+					skb_wan->len);
+				if (RTL_swNic_send((void *)skb_wan,
+						skb_wan->data, skb_wan->len,
+						&nicTx_wan) < 0) {
+					dev_kfree_skb_any(skb_wan);
+				}
+			}
+		}
+
+		if (!mcastFwdPortMask) {
+			dev_kfree_skb_any(skb2);
+			return;
+		}
+#endif
+
+#if defined(CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT)
+		rtl_process_vlan_passthrough_tx(&skb2);
+#endif
+		nicTx.txIdx = 0;
+
+#if defined(CONFIG_RTL_QOS_PATCH) || defined(CONFIG_RTK_VOIP_QOS)
+		if (((struct sk_buff *)skb)->srcPhyPort ==
+			QOS_PATCH_RX_FROM_LOCAL) {
+			nicTx.priority = QOS_PATCH_HIGH_QUEUE_PRIO;
+			nicTx.txIdx = RTL865X_SWNIC_TXRING_MAX_PKTDESC - 1;	/* use the highest tx ring index, note: not RTL865X_SWNIC_TXRING_HW_PKTDESC-1 */
+		}
+#endif
+		nicTx.vid = vid;
+#ifndef CONFIG_RTL_VLAN_8021Q
+		nicTx.portlist =
+			mcastFwdPortMask & ((struct dev_priv
+				*)(NETDRV_PRIV(skb->dev)))->portmask;
+#else
+		nicTx.portlist = mcastFwdPortMask;
+#endif
+		nicTx.srcExtPort = 0;
+		nicTx.flags = (PKTHDR_USED | PKT_OUTGOING);
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+		if ((vlan_tag && vid == vlan_tag) || (vlan_bridge_tag
+				&& (vid == vlan_bridge_tag))) {
+			nicTx.tagport = RTL_WANPORT_MASK;
+		}
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		mapping = dma_map_single(&rtl819x_pdev->dev, skb2->data,
+					skb2->len, DMA_TO_DEVICE);
+		if (unlikely(dma_mapping_error(&rtl819x_pdev->dev, mapping))) {
+			if (net_ratelimit())
+				netif_err(cp, drv, skb2->dev,
+					"Failed to map TX DMA!\n");
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+			tx_drop_cnt++;
+#endif
+			dev_kfree_skb_any(skb2);
+			return;
+		}
+
+		if (RTL_swNic_send((void *)skb2, (void *)mapping,
+			skb2->len, &nicTx) <0) {
+			dev_kfree_skb_any(skb2);
+		}
+
+#else /* CONFIG_RTD_1295_HWNAT */
+		RTL_CACHE_WBACK((unsigned long)skb2->data, skb2->len);
+
+		if (RTL_swNic_send((void *)skb2, skb2->data, skb2->len,
+				&nicTx) < 0) {
+			dev_kfree_skb_any(skb2);
+		}
+#endif /* CONFIG_RTD_1295_HWNAT */
+	}
+
+	return;
+}
+
+extern void rtl865x_igmpLinkStatusChangeCallback(uint32 moduleIndex,
+	rtl_igmpPortInfo_t *portInfo);
+void rtl865x_igmpSyncLinkStatus(void)
+{
+	rtl_igmpPortInfo_t portInfo;
+
+	portInfo.linkPortMask = newLinkPortMask;
+	/* rtl865x_igmpLinkStatusChangeCallback(nicIgmpModuleIndex, &portInfo); */
+
+#if defined(CONFIG_BRIDGE)
+	if ((newLinkPortMask & (~curLinkPortMask)) != 0) {
+#if !defined(CONFIG_OPENWRT_SDK)
+		/*there is some port linking up */
+		/*notice igmp proxy daemon to send general query to newly link up client */
+#ifdef CONFIG_RTL8196BU_8186SDK_MP_SPI
+#else
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+		br_signal_igmpProxy();
+#endif /* defined(CONFIG_RTL_IGMP_SNOOPING) */
+#endif
+#endif
+	}
+#endif
+
+	return;
+
+}
+
+#endif /*      defined(CONFIG_RTL_IGMP_SNOOPING)      */
+
+#if defined(CONFIG_BRIDGE_IGMP_SNOOPING) || defined(CONFIG_RTL_IGMP_SNOOPING)
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+#if defined(CONFIG_NETFILTER)
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,3,0)
+unsigned int (*IgmpRxFilter_Hook)(struct sk_buff *skb,
+		 const struct nf_hook_state *state,
+		 struct xt_table *table);
+#else
+unsigned int (*IgmpRxFilter_Hook)(struct sk_buff *skb,
+		 unsigned int hook,
+		 const struct nf_hook_state *state,
+		 struct xt_table *table);
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(4,3,0) */
+#else
+unsigned int (*IgmpRxFilter_Hook)(struct sk_buff *skb,
+	     unsigned int hook,
+	     const struct net_device *in,
+	     const struct net_device *out,
+	     struct xt_table *table);
+#endif
+EXPORT_SYMBOL(IgmpRxFilter_Hook);
+static bool rtl_MulticastRxFilterOff(struct sk_buff *skb, int ipversion)
+{
+	bool ret = true;
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	unsigned char *data_ori = skb->data;
+	int type = rtl_is_pppoe_igmp_bridge_frame(skb, 1, skb->data);
+#endif
+
+	if (IgmpRxFilter_Hook == NULL) {
+		DEBUG_ERR("IgmpRxFilter_hook is NULL\n");
+		return false;
+	}
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (ipversion == 4) {
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+		if (type == PPPOE_IGMP) {
+			/* only filer igmp packets */
+			skb_set_network_header(skb,
+				(int)((uint8 *)rtl_get_pppoe_ipv4_hdr(skb->data,
+						1, 0) - skb->data));
+		} else
+#endif
+			skb_set_network_header(skb,
+				(int)((uint8 *)re865x_getIpv4Header(skb->data) -
+					skb->data));
+	}
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	else if (ipversion == 6)
+		skb_set_network_header(skb,
+			(int)((uint8 *)re865x_getIpv6Header(skb->data) -
+				skb->data));
+#endif
+	else
+		return ret;	/* error shouldn't happen */
+	skb_reset_mac_header(skb);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (ipversion == 4) {
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+		if (type == PPPOE_IGMP) {
+			/* only filer igmp packets */
+			skb->network_header =
+				(sk_buff_data_t) rtl_get_pppoe_ipv4_hdr(skb->
+				data, 1, 0);
+		} else
+#endif
+			skb->network_header =
+				(sk_buff_data_t) re865x_getIpv4Header(skb->
+				data);
+	}
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	else if (ipversion == 6)
+		skb->network_header =
+			(sk_buff_data_t) re865x_getIpv6Header(skb->data);
+#endif
+	else
+		return ret;	/* error shouldn't happen */
+#ifdef NET_SKBUFF_DATA_USES_OFFSET
+	skb->mac_header = (sk_buff_data_t) (skb->data - skb->head);
+#else
+	skb->mac_header = (sk_buff_data_t) skb->data;
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* data should point to l3 header while doing iptables check */
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	if (type == PPPOE_IGMP)
+		skb->data =
+			(unsigned char *)rtl_get_pppoe_ipv4_hdr(skb->data, 1,
+			0);
+	else
+#endif
+		skb->data = skb->data + ETH_HLEN;
+
+	if (ipversion == 4) {
+		struct net_device *origDev = skb->dev;
+#if defined(CONFIG_RTD_1295_HWNAT)
+		struct nf_hook_state state;
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+/* #ifndef CONFIG_RTL_8198C // modified by lynn_pu, 2014-10-22 */
+#if !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F) && (!defined(CONFIG_RLX) && (LINUX_VERSION_CODE < KERNEL_VERSION(3, 10, 0)))
+		if ((skb->dev->br_port != NULL)) {
+			skb->dev =
+				__dev_get_by_name(dev_net(skb->dev),
+				RTL_PS_BR0_DEV_NAME);
+		}
+#else
+		if (skb->dev->priv_flags & IFF_BRIDGE_PORT) {
+			skb->dev =
+				__dev_get_by_name(dev_net(skb->dev),
+				RTL_PS_BR0_DEV_NAME);
+		}
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		state.hook = NF_INET_LOCAL_IN;
+		state.in = skb->dev;
+		state.out = NULL;
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,3,0)
+		ret = (IgmpRxFilter_Hook(skb, &state, dev_net(skb->dev)->ipv4.iptable_filter)
+				!= NF_ACCEPT);
+#else
+		ret = (IgmpRxFilter_Hook(skb, NF_INET_LOCAL_IN, &state, dev_net(skb->dev)->ipv4.iptable_filter)
+				!= NF_ACCEPT);
+#endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(4,3,0) */
+#else
+		ret = ((IgmpRxFilter_Hook(skb, NF_INET_LOCAL_IN, skb->dev, NULL,
+					dev_net(skb->dev)->ipv4.
+					iptable_filter)) != NF_ACCEPT);
+#endif
+		skb->dev = origDev;
+	} else if (ipversion == 6)
+		ret = false;	/* ipv6 hava no iptables rule now */
+
+	if (ret) {
+		DEBUG_ERR(" filter a v%d pkt\n", ipversion);
+	}
+	/* return point to l2 header */
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	if (type == PPPOE_IGMP)
+		skb->data = data_ori;
+	else
+#endif
+		skb->data = skb->data - ETH_HLEN;
+	return ret;
+}
+#endif /*CONFIG_NETFILTER */
+#endif /*CONFIG_RTL_IGMP_SNOOPING */
+
+extern uint32 rtl865x_getVlanPortMask(uint32 vid);
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+unsigned int rtl_get_brIgmpModuleIndexbyVid(unsigned int vid);
+unsigned int rtl_get_brIgmpModuleIndexbyId(int idx, char *name);
+int rtl_get_brIgmpModuleIndexbyName(char *name, int *index);
+#endif
+__MIPS16 int rtl_MulticastRxCheck(struct sk_buff *skb, rtl_nicRx_info *info,
+	int mCastFlag)
+{
+	unsigned int vlanRelayPortMask = 0;
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+	struct iphdr *iph = NULL;
+	struct rtl_multicastDataInfo multicastDataInfo;
+	struct rtl_multicastFwdInfo nicMCastFwdInfo;
+	struct rtl_multicastFwdInfo br0MCastFwdInfo;
+	unsigned int l4Protocol = 0;
+	int ret = FAILED;
+#endif
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	int pppoe_type = 0;
+#endif
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	struct ipv6hdr *ipv6h = NULL;
+#endif
+#if defined(CONFIG_RTL_MLD_SNOOPING) || ((!defined(CONFIG_RTL_VLAN_8021Q) || defined(CONFIG_RTK_VLAN_WAN_TAG_SUPPORT)) && defined(CONFIG_RTL_IGMP_SNOOPING))
+	struct dev_priv *cp_this = info->priv;
+#endif
+#ifdef CONFIG_RTL_VLAN_8021Q
+	/* unsigned int  vlanportmask=0; */
+	int type = 0;
+#endif
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+	uint32 res_mask = 0;
+	int32 ret_flag = 0;
+#endif
+
+#ifdef CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT
+	int pvid = 0;
+#endif
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+	unsigned int igmpModuleIndex = 0xFFFFFFFF;
+	struct rtl_multicastFwdInfo multicastFwdInfo;
+	int br_index = 0;
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	unsigned int mapPortMask = 0xFFFFFFFF;
+	char brName[16] = { 0 };
+	int toCpuFlag = 0;
+	int i = 0;
+	int joinBrNum = 0;
+	/* int igmpcnt=0; */
+#endif
+#endif
+#if defined(CONFIG_RTL_HW_MCAST_WIFI)
+	rtl865x_tblDrv_mCast_t *existMulticastEntry;
+#endif
+
+	int vid = info->vid;
+	int pid = info->pid;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if ((info->vid == 0)
+		&& (rtl819x_getSwEthPvid(pid, &(info->vid)) == SUCCESS))
+		vid = info->vid;
+#endif
+
+#if 0
+	if ((skb->data[0] & 0x01) == 0) {
+		return -1;
+	}
+#endif
+
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	pppoe_type = rtl_is_pppoe_igmp_bridge_frame(skb,1,skb->data);
+#endif
+
+	if (skb->data[0] == 0xff)	/* broadcast packets just return */
+	{
+		return 0;
+	}
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU) && (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 4, 0))
+	/* linux2.6.30 no passThruFlag support */
+	if (strncmp(skb->dev->name, "peth", 4) == 0) {
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+		skb->srcVlanId = vid;
+		skb->srcPort = pid;
+#endif
+
+#if defined(CONFIG_RTL_VLAN_8021Q) && defined(CONFIG_RTL_8021Q_VLAN_SUPPORT_SRC_TAG)
+		if (linux_vlan_enable)
+			skb->passThruFlag = IS_IP6_MC_PASSTHRU;
+#endif
+		return 0;
+	}
+#endif
+#ifdef CONFIG_RTL_VLAN_8021Q
+	/* if (linux_vlan_enable && linux_vlan_hw_support_enable) */
+	if (linux_vlan_enable) {
+		uint16 skb_vid;
+
+		/* change vid to  the packet's real vlan group */
+		type = rtk_decide_vlan_id(pid, skb, &skb_vid);
+#if 0
+		if (TEST_PACKETS(skb->data))
+			printk("vid=%d, [%s:%d]\n", vid, __FUNCTION__,
+				__LINE__);
+#endif
+		if (type == VID_FROM_PACKET) {
+			/* if packet with tag inside , we need reomve it here and recover it */
+			/* after mc relay done.  bcz hw can auto add tag . */
+			REMOVE_TAG(skb);
+		}
+		vid = skb_vid;
+		if (type != VID_FROM_PACKET &&
+			*(uint16 *)skb->linux_vlan_src_tag ==
+			__constant_htons(ETH_P_8021Q))
+			vid = __constant_ntohs(*(unsigned short *)(skb->
+					linux_vlan_src_tag + 2)) & 0xfff;
+	}
+#endif
+
+	/*set flooding port mask first */
+#ifdef CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT
+	rtl8651_getAsicPVlanId(pid, &pvid);
+	vlanRelayPortMask =
+		rtl865x_getVlanPortMask(pvid) & (~(1 << pid)) & ((1 <<
+			RTL8651_MAC_NUMBER) - 1);
+#else
+	vlanRelayPortMask =
+		rtl865x_getVlanPortMask(vid) & (~(1 << pid)) & ((1 <<
+			RTL8651_MAC_NUMBER) - 1);
+#endif
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+	ret_flag = rtl_lag_check_port_in_trunkmask(pid, &res_mask);
+	if (ret_flag) {
+		/* if port is link aggregation port group, remove other link aggregation ports too. */
+		vlanRelayPortMask &= ~(res_mask);
+	}
+#endif
+
+	/* panic_printk("[%s, %d] vid=%d, pid=%d, vlanRelayPortMask=%02x\n",__FUNCTION__,__LINE__,vid,pid,vlanRelayPortMask); */
+#if 0
+	if ((skb->data[0] == 0x01) && (skb->data[1] == 0x00)
+		&& (skb->data[2] == 0x5e))
+#else
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	if ((mCastFlag == IPV4_MCAST_PACKET)
+		|| (mCastFlag == DSLITE_MCAST_PACKET)
+		|| (pppoe_type>0 && pppoe_type<=PPPOE_TCP))
+#else
+	if ((mCastFlag == IPV4_MCAST_PACKET)
+		|| mCastFlag == DSLITE_MCAST_PACKET)
+#endif
+#endif
+	{
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+		if (rtk_vlan_support_enable) {
+			/*let bridge handle it */
+#ifdef CONFIG_RTL_VLAN_8021Q
+			goto relay_out;
+#else
+			return 0;
+#endif
+		}
+#endif
+
+
+//#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		#ifdef CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT
+        if (*(uint16*)skb->vlan_passthrough_saved_tag == __constant_htons(ETH_P_8021Q))
+        {
+            vid = *((unsigned short *)(skb->vlan_passthrough_saved_tag+2));
+			vid = __constant_ntohs(vid) & 0xfff;
+			skb->srcVlanId = vid;
+		} else {
+			skb->srcVlanId = pvid;
+			vid = pvid;
+		}
+#else
+		skb->srcVlanId = vid;
+#endif
+		skb->srcPort = pid;
+#if 0
+		if (net_ratelimit())
+			printk("[%s:%d]skb->srcVlanId is %d\n", __FUNCTION__,
+				__LINE__, skb->srcVlanId);
+#endif
+//#endif
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+#ifdef CONFIG_RTL_VLAN_8021Q
+		goto relay_out;
+#else
+		return 0;
+#endif
+#endif
+
+		/*not process multicast packet from wan */
+#if defined(CONFIG_RTL_VLAN_8021Q)
+		if (linux_vlan_enable) {
+			/* panic_printk("%s %d vid=%d pid=%d ret=%d\n", __FUNCTION__, __LINE__, vid, pid, rtl_isWanPort(info->priv, vid, skb, pid)); */
+			if (rtl_isWanPort(info->priv, vid, skb, pid, type)) {
+				/* panic_printk("%s %d vid=%d pid=%d \n", __FUNCTION__, __LINE__, vid, pid); */
+				goto relay_out;
+			}
+		} else {
+			if (rtl_isWanDev(info->priv))
+				return 0;
+		}
+#else
+		if (rtl_isWanDev(info->priv))
+			return 0;
+#endif
+
+		/* panic_printk("[%s, %d] Not dropped yet!\n",__FUNCTION__,__LINE__); */
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+		/*hardware ip multicast table will trap 0x01-00-5e-XX-XX-XX type packets */
+		/*how about other packets not trapped by hardware multicast table?---->we assume it has been flooded by l2 table */
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+		if ((pppoe_type>0 && pppoe_type<=PPPOE_TCP))
+			iph = rtl_get_pppoe_ipv4_hdr(skb->data, 1, skb->protocol);
+		else
+#endif
+			iph = re865x_getIpv4Header(skb->data);
+
+		if (iph != NULL) {
+			/*udp or tcp packet */
+			l4Protocol = iph->protocol;
+
+			if ((l4Protocol == IPPROTO_UDP)
+				|| (l4Protocol == IPPROTO_TCP)
+				|| (l4Protocol == Any_0_hop_protocl)) {
+				/*relay packets which are trapped by hardware multicast table */
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+				if (vlan_bridge_tag
+					&& !strcmp(cp_this->dev->name,
+						RTL_PS_ETH_NAME_ETH2)) {
+					if (igmpsnoopenabled
+						&& (nicIgmpModuleIndex_2 !=
+							0xFFFFFFFF)) {
+						multicastDataInfo.ipVersion = 4;
+						multicastDataInfo.sourceIp[0] =
+							(uint32)(iph->saddr);
+						multicastDataInfo.groupAddr[0] =
+							(uint32)(iph->daddr);
+
+						multicastDataInfo.sourceIp[0] =
+							ntohl(multicastDataInfo.
+							sourceIp[0]);
+						multicastDataInfo.groupAddr[0] =
+							ntohl(multicastDataInfo.
+							groupAddr[0]);
+
+						ret = rtl_getMulticastDataFwdInfo(nicIgmpModuleIndex_2, &multicastDataInfo, &nicMCastFwdInfo);
+#ifdef CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT
+						vlanRelayPortMask =
+							rtl865x_getVlanPortMask
+							(pvid) & (~(1 << pid)) &
+							nicMCastFwdInfo.
+							fwdPortMask & cp_this->
+							portmask & ((1 <<
+								RTL8651_MAC_NUMBER)
+							- 1);
+#else
+						vlanRelayPortMask =
+							rtl865x_getVlanPortMask
+							(vid) & (~(1 << pid)) &
+							nicMCastFwdInfo.
+							fwdPortMask & cp_this->
+							portmask & ((1 <<
+								RTL8651_MAC_NUMBER)
+							- 1);
+#endif
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+						if (ret_flag) {
+							/* if port is link aggregation port group, remove other link aggregation ports too. */
+							vlanRelayPortMask &=
+								~(res_mask);
+						}
+#endif
+						if (ret == SUCCESS) {
+
+						} else {
+							ret = rtl_getMulticastDataFwdInfo(brIgmpModuleIndex_2, &multicastDataInfo, &br0MCastFwdInfo);
+							if (ret == SUCCESS) {
+								/*there is wireless client,can not flooding in vlan */
+								vlanRelayPortMask
+									= 0;
+							}
+						}
+
+					}
+				} else
+#endif
+				if (igmpsnoopenabled
+					&& (nicIgmpModuleIndex != 0xFFFFFFFF)) {
+
+#if defined(CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+					/* multicast data with mac not in L2 will be flooded by hw, do noting here */
+					return 0;
+#endif
+					multicastDataInfo.ipVersion = 4;
+#if defined(CONFIG_RTL_ULINKER_BRSC)	/* assign value will cause coredump */
+					memcpy(&multicastDataInfo.sourceIp,
+						&iph->saddr, 4);
+					memcpy(&multicastDataInfo.groupAddr,
+						&iph->daddr, 4);
+					multicastDataInfo.sourceIp[0] =
+						ntohl(multicastDataInfo.
+						sourceIp[0]);
+					multicastDataInfo.groupAddr[0] =
+						ntohl(multicastDataInfo.
+						groupAddr[0]);
+#else
+					multicastDataInfo.sourceIp[0] =
+						(uint32)(iph->saddr);
+					multicastDataInfo.groupAddr[0] =
+						(uint32)(iph->daddr);
+					multicastDataInfo.sourceIp[0] =
+						ntohl(multicastDataInfo.
+						sourceIp[0]);
+					multicastDataInfo.groupAddr[0] =
+						ntohl(multicastDataInfo.
+						groupAddr[0]);
+#endif
+
+#if defined(CONFIG_RTL_HW_MCAST_WIFI)
+					if (hwwifiEnable) {
+						existMulticastEntry =
+							rtl865x_findMCastEntry
+							(multicastDataInfo.
+							groupAddr[0],
+							multicastDataInfo.
+							sourceIp[0],
+							(unsigned short)vid,
+							(unsigned short)pid);
+						if (existMulticastEntry != NULL) {
+							/*it's already in cache */
+#if defined(CONFIG_RTL_VLAN_8021Q)
+							if (linux_vlan_enable)
+								goto relay_out;
+							else
+								return 0;
+#else
+							return 0;
+#endif
+						}
+					}
+#endif
+
+					ret = rtl_getMulticastDataFwdInfo
+						(nicIgmpModuleIndex,
+						&multicastDataInfo,
+						&nicMCastFwdInfo);
+#ifndef CONFIG_RTL_VLAN_8021Q
+#ifdef CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT
+					vlanRelayPortMask =
+						rtl865x_getVlanPortMask(pvid) &
+						(~(1 << pid)) & nicMCastFwdInfo.
+						fwdPortMask & cp_this->
+						portmask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1);
+#else
+					vlanRelayPortMask =
+						rtl865x_getVlanPortMask(vid) &
+						(~(1 << pid)) & nicMCastFwdInfo.
+						fwdPortMask & cp_this->
+						portmask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1);
+#endif
+#else
+					vlanRelayPortMask =
+						rtl865x_getVlanPortMask(vid) &
+						(~(1 << pid)) & nicMCastFwdInfo.
+						fwdPortMask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1);
+#endif
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+					if (ret_flag) {
+						/* if port is link aggregation port group, remove other link aggregation ports too. */
+						vlanRelayPortMask &=
+							~(res_mask);
+					}
+#endif
+					if (ret == SUCCESS) {
+						/* group exsits in nic module. */
+#if defined(CONFIG_RTL_VLAN_8021Q)
+						if (linux_vlan_enable) {
+							if (vlanRelayPortMask ==
+								0) {
+								int nicRelayPortMaskTemp = (~(1 << pid)) & nicMCastFwdInfo.fwdPortMask & ((1 << RTL8651_MAC_NUMBER) - 1);
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+								int ret2 =
+									FAILED;
+								igmpModuleIndex
+									=
+									rtl_get_brIgmpModuleIndexbyVid
+									(vid);
+								if (igmpModuleIndex != 0xFFFFFFFF) {
+									ret2 = rtl_getMulticastDataFwdInfo(igmpModuleIndex, &multicastDataInfo, &multicastFwdInfo);
+								}
+#endif
+								if (nicRelayPortMaskTemp != 0
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+									|| ret2
+									!=
+									SUCCESS
+#endif
+									) {
+
+									/*current br module eth client not join, but the other br module eth client join -> flooding
+									 * current vlan eth client not join, but other vlan group member join */
+									vlanRelayPortMask
+										=
+										rtl865x_getVlanPortMask
+										(vid)
+										&
+										(~
+										(1 << pid)) & ((1 << RTL8651_MAC_NUMBER) - 1);
+								}
+
+							}
+						}
+#endif
+					} else {
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT) && defined(CONFIG_RTL_VLAN_8021Q)
+						if (linux_vlan_enable) {
+							igmpModuleIndex =
+								rtl_get_brIgmpModuleIndexbyVid
+								(vid);
+							if (igmpModuleIndex !=
+								0xFFFFFFFF) {
+								ret = rtl_getMulticastDataFwdInfo(igmpModuleIndex, &multicastDataInfo, &multicastFwdInfo);
+								if (ret ==
+									SUCCESS)
+								{
+									vlanRelayPortMask
+										=
+										0;
+								}
+							}
+						} else {
+							igmpModuleIndex =
+								rtl_get_brIgmpModuleIndexbyName
+								(RTL_BR_NAME,
+								&br_index);
+							ret = rtl_getMulticastDataFwdInfo(igmpModuleIndex, &multicastDataInfo, &br0MCastFwdInfo);
+							if (ret == SUCCESS) {
+								/*there is wireless client,can not flooding in vlan */
+								vlanRelayPortMask
+									= 0;
+							}
+						}
+
+#else
+						{
+							ret = rtl_getMulticastDataFwdInfo(brIgmpModuleIndex, &multicastDataInfo, &br0MCastFwdInfo);
+							if (ret == SUCCESS) {
+								/*there is wireless client,can not flooding in vlan */
+								vlanRelayPortMask
+									= 0;
+							}
+						}
+#endif
+
+					}
+				}
+#ifdef CONFIG_RTL_VLAN_8021Q
+				if (linux_vlan_enable
+					&& linux_vlan_hw_support_enable) {
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+					if (is_nat_wan_vlan(vid)) {
+						/* special case: lan-wan bridge and lan-wan nat have same vid */
+						for (i = 0;
+							i <
+							RTL_IMGP_MAX_BRMODULE;
+							i++) {
+							igmpModuleIndex =
+								rtl_get_brIgmpModuleIndexbyId
+								(i, brName);
+							if (igmpModuleIndex ==
+								0xFFFFFFFF)
+								continue;
+
+							ret = rtl_getMulticastDataFwdInfo(igmpModuleIndex, &multicastDataInfo, &multicastFwdInfo);
+							if (ret == SUCCESS) {
+								toCpuFlag |=
+									multicastFwdInfo.
+									cpuFlag;
+								joinBrNum++;
+							}
+
+						}
+						if (toCpuFlag == 0
+							&& joinBrNum != 0) {
+#if defined(CONFIG_RTL_MULTICAST_PORT_MAPPING)
+							/* mapPortMask need to be checked! */
+							mapPortMask =
+								rtl865x_getVlanPortMask
+								(vid) & ((1 <<
+									RTL8651_MAC_NUMBER)
+								- 1);
+							rtl865x_nic_MulticastHardwareAccelerate
+								(nicMCastFwdInfo.
+								fwdPortMask,
+								pid, vid,
+								multicastDataInfo.
+								sourceIp[0],
+								multicastDataInfo.
+								groupAddr[0],
+								mapPortMask);
+#else
+							rtl865x_nic_MulticastHardwareAccelerate
+								(nicMCastFwdInfo.
+								fwdPortMask,
+								pid, vid,
+								multicastDataInfo.
+								sourceIp[0],
+								multicastDataInfo.
+								groupAddr[0]);
+#endif
+						}
+					}
+#else
+					if (is_nat_wan_vlan(vid)
+						|| (vid != info->priv->id)) {
+						rtl865x_nic_MulticastHardwareAccelerate
+							(nicMCastFwdInfo.
+							fwdPortMask, pid, vid,
+							multicastDataInfo.
+							sourceIp[0],
+							multicastDataInfo.
+							groupAddr[0]);
+					}
+#endif
+				}
+#if 0
+				vlanportmask =
+					(~(1 << pid)) & nicMCastFwdInfo.
+					fwdPortMask & cp_this->
+					portmask & ((1 << RTL8651_MAC_NUMBER) -
+					1);
+				if (linux_vlan_enable)
+					re865x_relayTrappedMCast(skb, vid,
+						vlanportmask, TRUE);
+				else
+#endif
+#endif
+					re865x_relayTrappedMCast(skb, vid,
+						vlanRelayPortMask, TRUE);
+#endif /*end of CONFIG_RTL_HARDWARE_MULTICAST */
+			} else if (l4Protocol == IPPROTO_IGMP) {
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+				if (vlan_bridge_tag
+					&& !strcmp(cp_this->dev->name,
+						RTL_PS_ETH_NAME_ETH2)) {
+					if (igmpsnoopenabled
+						&& (nicIgmpModuleIndex_2 !=
+							0xFFFFFFFF)) {
+						rtl_igmpMldProcess
+							(nicIgmpModuleIndex_2,
+							skb->data, pid,
+							&vlanRelayPortMask);
+						/* just flooding */
+						vlanRelayPortMask =
+							rtl865x_getVlanPortMask
+							(vid) & (~(1 << pid)) &
+							((1 << RTL8651_MAC_NUMBER) - 1);
+					}
+				} else {
+#endif
+					if (igmpsnoopenabled
+						&& (nicIgmpModuleIndex !=
+							0xFFFFFFFF)) {
+						/*igmp packet */
+#if defined(CONFIG_NETFILTER)
+						if (igmp_netfilter && rtl_MulticastRxFilterOff
+							(skb, 4) == true) {
+#ifdef CONFIG_RTL_VLAN_8021Q
+							if (linux_vlan_enable)
+								goto relay_out;
+							else
+								return 0;
+#else
+							return 0;	/* filter by iptables */
+#endif
+						}
+#endif
+						rtl_igmpMldProcess
+							(nicIgmpModuleIndex,
+							skb->data, pid,
+							&vlanRelayPortMask);
+#ifdef CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT
+						vlanRelayPortMask =
+							rtl865x_getVlanPortMask
+							(pvid) &
+							vlanRelayPortMask & ((1
+								<<
+								RTL8651_MAC_NUMBER)
+							- 1);
+#else
+						vlanRelayPortMask =
+							rtl865x_getVlanPortMask
+							(vid) &
+							vlanRelayPortMask & ((1
+								<<
+								RTL8651_MAC_NUMBER)
+							- 1);
+#endif
+					}
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+				}
+#endif
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+				if (ret_flag) {
+					/* if port is link aggregation port group, remove other link aggregation ports too. */
+					vlanRelayPortMask &= ~(res_mask);
+				}
+#endif
+				re865x_relayTrappedMCast(skb, vid,
+					vlanRelayPortMask, TRUE);
+
+			} else {
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+				if (ret_flag) {
+					/* if port is link aggregation port group, remove other link aggregation ports too. */
+					vlanRelayPortMask &= ~(res_mask);
+				}
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+				re865x_relayTrappedMCast(skb, vid,
+					vlanRelayPortMask, TRUE);
+#endif
+
+			}
+		}
+#endif
+
+	}
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+#if 0
+	else if ((skb->data[0] == 0x33) && (skb->data[1] == 0x33)
+		&& (skb->data[2] != 0xff))
+#else
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	else if((mCastFlag ==IPV6_MCAST_PACKET)||mCastFlag ==SIXRD_MCAST_PACKET ||(pppoe_type>=PPPOE_ICMPV6))
+#else
+	else if((mCastFlag ==IPV6_MCAST_PACKET)||mCastFlag ==SIXRD_MCAST_PACKET )
+#endif
+#endif
+	{
+
+		//#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		skb->srcVlanId=vid;
+		skb->srcPort=pid;
+		//#endif
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+		skb->srcVlanId = vid;
+		skb->srcPort = pid;
+#endif
+
+		if (mldSnoopEnabled != TRUE) {
+#ifdef CONFIG_RTL_VLAN_8021Q
+			if (linux_vlan_enable)
+				goto relay_out;
+			else
+				return 0;
+#else
+			return 0;
+#endif
+		}
+#if 1				/* defined(CONFIG_RTL_CUSTOM_PASSTHRU) */
+#if defined(CONFIG_RTL_VLAN_8021Q)
+		if (linux_vlan_enable) {
+			if (rtl_isWanPort(info->priv, vid, skb, pid, type)) {
+				goto relay_out;
+			}
+		} else {
+			if (rtl_isWanDev(cp_this) == TRUE) {
+				/*don't relay it,let linux protocol stack bridge handle it */
+				return 0;
+			}
+
+		}
+#else
+		if (rtl_isWanDev(cp_this) == TRUE) {
+			/*don't relay it,let linux protocol stack bridge handle it */
+			return 0;
+		}
+#endif
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+		if (rtk_vlan_support_enable) {
+			/*let bridge handle it */
+#ifdef CONFIG_RTL_VLAN_8021Q
+			goto relay_out;
+#else
+			return 0;
+#endif
+		}
+#endif
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+		return 0;
+#endif
+
+		/*when enable mld snooping, gateway will add acl to trap packet with dmac equal to 0x33-33-xx-xx-xx-xx */
+	#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+		if(pppoe_type>=PPPOE_ICMPV6)
+			ipv6h = rtl_get_pppoe_ipv6_hdr(skb->data,1 ,skb->protocol);
+		else
+	#endif
+		ipv6h=re865x_getIpv6Header(skb->data);
+		if(ipv6h!=NULL)
+		{
+			l4Protocol=re865x_getIpv6TransportProtocol(ipv6h);
+			/*udp or tcp packet*/
+			if((l4Protocol==IPPROTO_UDP) || (l4Protocol==IPPROTO_TCP)|| (l4Protocol==Any_0_hop_protocl))
+			{
+
+				if (nicIgmpModuleIndex != 0xFFFFFFFF) {
+					multicastDataInfo.ipVersion = 6;
+					memcpy(&multicastDataInfo.sourceIp,
+						&ipv6h->saddr, 16);
+					memcpy(&multicastDataInfo.groupAddr,
+						&ipv6h->daddr, 16);
+
+					multicastDataInfo.sourceIp[0] =
+						ntohl(multicastDataInfo.
+						sourceIp[0]);
+					multicastDataInfo.sourceIp[1] =
+						ntohl(multicastDataInfo.
+						sourceIp[1]);
+					multicastDataInfo.sourceIp[2] =
+						ntohl(multicastDataInfo.
+						sourceIp[2]);
+					multicastDataInfo.sourceIp[3] =
+						ntohl(multicastDataInfo.
+						sourceIp[3]);
+					multicastDataInfo.groupAddr[0] =
+						ntohl(multicastDataInfo.
+						groupAddr[0]);
+					multicastDataInfo.groupAddr[1] =
+						ntohl(multicastDataInfo.
+						groupAddr[1]);
+					multicastDataInfo.groupAddr[2] =
+						ntohl(multicastDataInfo.
+						groupAddr[2]);
+					multicastDataInfo.groupAddr[3] =
+						ntohl(multicastDataInfo.
+						groupAddr[3]);
+
+					ret = rtl_getMulticastDataFwdInfo
+						(nicIgmpModuleIndex,
+						&multicastDataInfo,
+						&nicMCastFwdInfo);
+#ifndef CONFIG_RTL_VLAN_8021Q
+#ifdef CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT
+					vlanRelayPortMask =
+						rtl865x_getVlanPortMask(pvid) &
+						(~(1 << pid)) & nicMCastFwdInfo.
+						fwdPortMask & cp_this->
+						portmask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1);
+#else
+					vlanRelayPortMask =
+						rtl865x_getVlanPortMask(vid) &
+						(~(1 << pid)) & nicMCastFwdInfo.
+						fwdPortMask & cp_this->
+						portmask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1);
+#endif
+#else
+					vlanRelayPortMask =
+						rtl865x_getVlanPortMask(vid) &
+						(~(1 << pid)) & nicMCastFwdInfo.
+						fwdPortMask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1);
+#endif
+					if (ret == SUCCESS) {
+#if defined(CONFIG_RTL_VLAN_8021Q)
+						if (linux_vlan_enable) {
+							if (vlanRelayPortMask ==
+								0) {
+
+								int nicRelayPortMaskTemp = (~(1 << pid)) & nicMCastFwdInfo.fwdPortMask & ((1 << RTL8651_MAC_NUMBER) - 1);
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+								int ret2 =
+									FAILED;
+								igmpModuleIndex
+									=
+									rtl_get_brIgmpModuleIndexbyVid
+									(vid);
+								if (igmpModuleIndex != 0xFFFFFFFF) {
+									ret2 = rtl_getMulticastDataFwdInfo(igmpModuleIndex, &multicastDataInfo, &multicastFwdInfo);
+								}
+#endif
+								if (nicRelayPortMaskTemp != 0
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+									|| ret2
+									!=
+									SUCCESS
+#endif
+									) {
+									/*current br module eth client not join, but the other br module eth client join -> flooding
+									 * current vlan eth client not join, but other vlan group member join */
+									vlanRelayPortMask
+										=
+										rtl865x_getVlanPortMask
+										(vid)
+										&
+										(~
+										(1 << pid)) & ((1 << RTL8651_MAC_NUMBER) - 1);
+								}
+
+							}
+						}
+#endif
+					} else {
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT) && defined(CONFIG_RTL_VLAN_8021Q)
+						if (linux_vlan_enable) {
+							igmpModuleIndex =
+								rtl_get_brIgmpModuleIndexbyVid
+								(vid);
+							if (igmpModuleIndex !=
+								0xFFFFFFFF) {
+								ret = rtl_getMulticastDataFwdInfo(igmpModuleIndex, &multicastDataInfo, &multicastFwdInfo);
+								if (ret ==
+									SUCCESS)
+								{
+									vlanRelayPortMask
+										=
+										0;
+								}
+							}
+						} else {
+							igmpModuleIndex =
+								rtl_get_brIgmpModuleIndexbyName
+								(RTL_BR_NAME,
+								&br_index);
+							ret = rtl_getMulticastDataFwdInfo(igmpModuleIndex, &multicastDataInfo, &br0MCastFwdInfo);
+							if (ret == SUCCESS) {
+								/*there is wireless client,can not flooding in vlan */
+								vlanRelayPortMask
+									= 0;
+							}
+						}
+
+#else
+						ret = rtl_getMulticastDataFwdInfo(brIgmpModuleIndex, &multicastDataInfo, &br0MCastFwdInfo);
+						if (ret == SUCCESS) {
+							/*there is wireless client,can not flooding in vlan */
+							vlanRelayPortMask = 0;
+						}
+#endif
+					}
+				}
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+				if (ret_flag) {
+					/* if port is link aggregation port group, remove other link aggregation ports too. */
+					vlanRelayPortMask &= ~(res_mask);
+				}
+#endif
+				re865x_relayTrappedMCast(skb, vid,
+					vlanRelayPortMask, TRUE);
+
+			} else if (l4Protocol == IPPROTO_ICMPV6) {
+				/*icmp packet */
+				if (nicIgmpModuleIndex != 0xFFFFFFFF) {
+					rtl_igmpMldProcess(nicIgmpModuleIndex,
+						skb->data, pid,
+						&vlanRelayPortMask);
+#ifdef CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT
+					vlanRelayPortMask =
+						rtl865x_getVlanPortMask(pvid) &
+						vlanRelayPortMask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1);
+#else
+					vlanRelayPortMask =
+						rtl865x_getVlanPortMask(vid) &
+						vlanRelayPortMask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1);
+#endif
+				}
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+				if (ret_flag) {
+					/* if port is link aggregation port group, remove other link aggregation ports too. */
+					vlanRelayPortMask &= ~(res_mask);
+				}
+#endif
+
+				re865x_relayTrappedMCast(skb, vid,
+					vlanRelayPortMask, TRUE);
+
+			} else {
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+				if (ret_flag) {
+					/* if port is link aggregation port group, remove other link aggregation ports too. */
+					vlanRelayPortMask &= ~(res_mask);
+				}
+#endif
+				re865x_relayTrappedMCast(skb, vid,
+					vlanRelayPortMask, TRUE);
+			}
+		} else {
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+			if (ret_flag) {
+				/* if port is link aggregation port group, remove other link aggregation ports too. */
+				vlanRelayPortMask &= ~(res_mask);
+			}
+#endif
+			re865x_relayTrappedMCast(skb, vid, vlanRelayPortMask,
+				TRUE);
+		}
+
+	}
+#if ((defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_HARDWARE_MULTICAST))
+	else if (mCastFlag == IPV6_MCAST_PACKET2) {
+//#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		skb->srcVlanId = vid;
+		skb->srcPort = pid;
+//#endif
+		vlanRelayPortMask =
+			rtl865x_getVlanPortMask(vid) & (~(1 << pid)) & cp_this->
+			portmask & ((1 << RTL8651_MAC_NUMBER) - 1);
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+		if (ret_flag) {
+			/* if port is link aggregation port group, remove other link aggregation ports too. */
+			vlanRelayPortMask &= ~(res_mask);
+		}
+#endif
+		re865x_relayTrappedMCast(skb, vid, vlanRelayPortMask, TRUE);
+	}
+#endif
+#endif
+	else {
+		//#if defined (CONFIG_RTL_HARDWARE_MULTICAST)
+		skb->srcVlanId = 0;
+		skb->srcPort = 0xFFFF;
+		//#endif
+	}
+
+#if 0
+	if (rx_skb_queue.qlen < (rtl865x_maxPreAllocRxSkb / 3)) {
+		refill_rx_skb();
+	}
+#endif
+
+#ifdef CONFIG_RTL_VLAN_8021Q
+relay_out:
+	if (vlan_ctl_p->flag)	/* vlan enable */
+	{
+		if (type == VID_FROM_PACKET) {
+			/* recover packet's tag if exist here for protcol stack process */
+			rtk_insert_vlan_tag(vid, skb);
+		}
+	}
+#endif
+	return 0;
+}
+#endif /*end of CONFIG_RTL865X_IGMP_SNOOPING */
+
+static inline int32 rtl_isWanDev(struct dev_priv *cp)
+{
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	return (!cp->vlan_setting.is_lan);
+#else
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	return (cp->id == RTL_WANVLANID || cp->id == RTL_WAN_1_VLANID);
+#else
+#if defined(CONFIG_RTL_VLAN_8021Q)
+	if (linux_vlan_enable && linux_vlan_hw_support_enable)
+		return (cp->id == rtk_vlan_wan_vid);	/* mark_vc */
+	else
+#endif
+		return (cp->id == RTL_WANVLANID);
+#endif
+#endif
+}
+
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+static inline int32 rtl_isPassthruFrame(uint8 *data)
+{
+	int ret;
+
+	ret = FAILED;
+	if (oldStatus) {
+		if (oldStatus & IP6_PASSTHRU_MASK) {
+			if ((*((uint16 *)(data + (ETH_ALEN << 1))) ==
+					__constant_htons(ETH_P_IPV6))
+				|| ((*((uint16 *)(data + (ETH_ALEN << 1))) ==
+						__constant_htons(ETH_P_8021Q))
+					&& (*((uint16 *)(data + (ETH_ALEN << 1)
+								+ VLAN_HLEN)) ==
+						__constant_htons(ETH_P_IPV6))))
+			{
+				ret = SUCCESS;
+			}
+		}
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU_PPPOE)
+		if (oldStatus & PPPOE_PASSTHRU_MASK) {
+			if (((*((uint16 *)(data + (ETH_ALEN << 1))) ==
+						__constant_htons(ETH_P_PPP_SES))
+					|| (*((uint16 *)(data + (ETH_ALEN <<
+									1))) ==
+						__constant_htons
+						(ETH_P_PPP_DISC)))
+				|| ((*((uint16 *)(data + (ETH_ALEN << 1))) ==
+						__constant_htons(ETH_P_8021Q))
+					&& ((*((uint16 *)(data + (ETH_ALEN << 1)
+									+
+									VLAN_HLEN))
+							==
+							__constant_htons
+							(ETH_P_PPP_SES))
+						|| (*((uint16 *)(data + (ETH_ALEN << 1) + VLAN_HLEN)) == __constant_htons(ETH_P_PPP_DISC))))) {
+				ret = SUCCESS;
+			}
+		}
+#endif
+	}
+
+	return ret;
+}
+
+int rtl_getPassthruMask(void)
+{
+
+	return oldStatus;
+}
+
+#if defined(CONFIG_IPV6)
+int rtl_isIpv6McFrame(char *data)
+{
+	int ret = FAILED;
+
+	if ((data[0] == 0x33) && (data[1] == 0x33))
+		ret = SUCCESS;
+
+	return ret;
+}
+#endif
+#endif
+
+#if defined(RTL_CPU_QOS_ENABLED)
+#define MAX_HIGH_PRIO_TRY	20	/* Try to rx high prio pkt for MAX_HIGH_PRIO_TRY times. */
+__DRAM_FWD static int highPrioRxTryCnt;
+__DRAM_FWD static int highestPriority;
+__DRAM_FWD static int cpuQosHoldLow;
+__DRAM_FWD static int totalLowQueueCnt;
+
+static rtl_queue_entry pktQueueByPri[RTL865X_SWNIC_RXRING_MAX_PKTDESC] =
+	{ {0} };
+
+__MIPS16 __IRAM_FWD int rtl_enqueueSkb(rtl_nicRx_info *info)
+{
+	rtl_queue_entry *entry;
+
+	entry = &pktQueueByPri[info->priority];
+
+	if (info->priority < cpuQosHoldLow)
+		totalLowQueueCnt++;
+
+	memcpy(&entry->entry[entry->end], info, sizeof(rtl_nicRx_info));
+	entry->cnt++;
+	entry->end =
+		(entry->end == (RTL_NIC_QUEUE_LEN - 1)) ? 0 : (entry->end + 1);
+
+	if (entry->cnt == RTL_NIC_QUEUE_LEN)
+		return SUCCESS;
+	else
+		return FAILED;
+}
+
+__MIPS16 __IRAM_FWD int rtl_dequeueSkb(rtl_nicRx_info *info)
+{
+	rtl_queue_entry *entry;
+
+	entry = &pktQueueByPri[info->priority];
+
+	if (entry->cnt == 0) {
+		return FAILED;
+	} else {
+		memcpy(info, &entry->entry[entry->start],
+			sizeof(rtl_nicRx_info));
+		entry->cnt--;
+		entry->start =
+			(entry->start ==
+			(RTL_NIC_QUEUE_LEN - 1)) ? 0 : (entry->start + 1);
+		return SUCCESS;
+	}
+}
+#endif
+
+#if defined(RTL_CPU_QOS_ENABLED)
+__MIPS16 __IRAM_FWD
+	static inline int32 rtl_processReceivedInfo(rtl_nicRx_info *info,
+	int nicRxRet)
+{
+	int ret;
+
+	ret = RTL_RX_PROCESS_RETURN_BREAK;
+	switch (nicRxRet) {
+	case RTL_NICRX_OK:
+		{
+			if (highestPriority < info->priority) {
+				highestPriority = info->priority;
+				cpuQosHoldLow = highestPriority;
+			}
+
+			if (info->priority ==
+				(RTL865X_SWNIC_RXRING_MAX_PKTDESC - 1)) {
+				ret = RTL_RX_PROCESS_RETURN_SUCCESS;
+			} else if (rtl_enqueueSkb(info) == SUCCESS) {
+				rtl_dequeueSkb(info);
+				ret = RTL_RX_PROCESS_RETURN_SUCCESS;
+			} else
+				ret = RTL_RX_PROCESS_RETURN_CONTINUE;
+
+			break;
+		}
+	case RTL_NICRX_NULL:
+		{
+			info->priority = cpuQosHoldLow;
+			if (rtl_dequeueSkb(info) == SUCCESS) {
+				ret = RTL_RX_PROCESS_RETURN_SUCCESS;
+			} else if ((highestPriority > 0)
+				&& ((--highPrioRxTryCnt) < 0)) {
+				/* Only for using rxring 0 and rxring 5 */
+				highPrioRxTryCnt = MAX_HIGH_PRIO_TRY;
+				highestPriority = 0;
+				cpuQosHoldLow = highestPriority;
+				ret = RTL_RX_PROCESS_RETURN_CONTINUE;
+			} else if (highestPriority == 0) {
+				/* highestPriority=0 */
+				if (cpuQosHoldLow > 0) {
+					swNic_flushRxRingByPriority
+						(cpuQosHoldLow);
+				}
+				ret = RTL_RX_PROCESS_RETURN_BREAK;
+			}
+
+			break;
+		}
+	case RTL_NICRX_REPEAT:
+		ret = RTL_RX_PROCESS_RETURN_BREAK;
+		break;
+	}
+	return ret;
+}
+#else /*      defined(RTL_CPU_QOS_ENABLED)    */
+__MIPS16 __IRAM_FWD
+	static inline int32 rtl_processReceivedInfo(rtl_nicRx_info *info,
+	int nicRxRet)
+{
+	int ret;
+
+	ret = RTL_RX_PROCESS_RETURN_BREAK;
+	switch (nicRxRet) {
+	case RTL_NICRX_OK:
+		{
+			ret = RTL_RX_PROCESS_RETURN_SUCCESS;
+			break;
+		}
+	case RTL_NICRX_NULL:
+	case RTL_NICRX_REPEAT:
+		break;
+	}
+	return ret;
+}
+#endif /*      defined(RTL_CPU_QOS_ENABLED)    */
+
+__MIPS16 __IRAM_FWD static inline int32 rtl_decideRxDevice(rtl_nicRx_info *info)
+{
+	struct dev_priv *cp;
+	int32 pid, i, ret;
+	struct sk_buff *skb;
+	uint8 *data;
+#if 0				/* defined(CONFIG_RTL_STP) */
+	int32 dev_no;
+#endif
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+	unsigned char dest_mac[MAX_ADDR_LEN];
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	int32 vid = 0;
+	vid = info->vid;
+#endif
+	pid = info->pid;
+	skb = info->input;
+
+	data = skb->data;
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+	memcpy(dest_mac, data, 6);
+#if defined(CONFIG_IPV6)
+	info->oriPriv = NULL;
+#endif
+#endif
+
+	info->isPdev = FALSE;
+	ret = SUCCESS;
+
+#ifdef CONFIG_SWCONFIG
+	if (swconfig_vlan_enable) {
+		cp = rtk_decide_vlan_cp(pid, skb);
+		info->priv = cp;
+		return SUCCESS;
+	}
+#endif
+
+#if 0				/* defined(CONFIG_RTL_STP) */
+	info->isStpVirtualDev = FALSE;
+	if ((data[0] & 0x01) && !memcmp(data, STPmac, 5) && !(data[5] & 0xF0)) {
+		/* It's a BPDU */
+		dev_no = re865x_stp_get_pseudodevno(pid);
+		if (dev_no != NO_MAPPING) {
+			info->priv = _rtl86xx_dev.stp_port[dev_no]->priv;
+			info->isStpVirtualDev = TRUE;
+		} else {
+			dev_kfree_skb_any(skb);
+			ret = FAILED;
+		}
+	} else
+#endif
+	{
+#ifdef CONFIG_RTL_VLAN_8021Q
+		if (linux_vlan_enable && linux_vlan_hw_support_enable) {
+			cp = (struct dev_priv *)rtk_decide_vlan_cp(pid, skb);
+			if (cp) {
+				info->priv = cp;
+				/* panic_printk("%s %d cp->dev->name %s\n", __FUNCTION__, __LINE__, cp->dev->name); */
+				goto out;
+			}
+		}
+#endif
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+		if (rtl865x_curOpMode == GATEWAY_MODE) {
+			if (0 == (skb->data[0] & 0x01)) {
+				if (rtl865x_decideUcDevice(skb->data, pid,
+						info) == SUCCESS) {
+					ret = SUCCESS;
+					goto out;
+				}
+			} else {
+				if (skb->data[0] != 0xff) {
+					if (rtl865x_decideMcDevice(pid,
+							info) == SUCCESS) {
+						ret = SUCCESS;
+						goto out;
+					}
+				} else {
+					if (rtl865x_decideBcDevice(skb, pid,
+							info) == SUCCESS) {
+						ret = SUCCESS;
+						goto out;
+					}
+				}
+			}
+		}
+#endif
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+		/* wan port always use wan cp */
+		if (rtl_hw_vlan_enable && (pid == RTK_WAN_PORT_IDX)) {
+			cp = (struct dev_priv *)rtl_get_wan_cp();
+			info->priv = cp;
+			goto out;
+		}
+		/* p0~03 , decide by cp port-base search below */
+#endif
+
+		for (i = 0; i < ETH_INTF_NUM; i++) {
+			cp = ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.
+					dev[i]));
+			/* printk("=========%s(%d),cp(%s),i(%d)\n",__FUNCTION__,__LINE__,cp->dev->name,i); */
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+			if (*((unsigned short *)(skb->data +
+						(ETH_ALEN << 1))) ==
+				__constant_htons(ETH_P_8021Q)) {
+				vid = *((unsigned short *)(skb->data +
+						(ETH_ALEN << 1) + 2)) & 0x0fff;
+
+				if (vlan_tag && vid == vlan_tag) {
+					if (rtl865x_curOpMode == BRIDGE_MODE)
+						vid = RTL_LANVLANID;
+				} else if (vlan_bridge_tag
+					&& vid == vlan_bridge_tag) {
+					vid = vlan_bridge_tag;
+				} else if (vlan_bridge_multicast_tag
+					&& vid == vlan_bridge_multicast_tag) {
+					vid = vlan_bridge_tag;
+				}
+#ifdef CONFIG_VLAN_8021Q
+				else {
+#if defined(CONFIG_RTD_1295_HWNAT)
+					vid = vlanconfig[RTL_WAN_IDX].vid;	/* default from WAN eth1 */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+					vid = vlanconfig[1].vid;	/* default from WAN eth1 */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+				}
+#endif
+				if (_rtl86xx_dev.dev[i] && cp && cp->opened
+					&& (vid == cp->id)) {
+					info->priv = cp;
+					ret = SUCCESS;
+					break;
+				}
+			} else {
+				if (_rtl86xx_dev.dev[i] && cp && cp->opened
+					&& (cp->portmask & (1 << pid))) {
+					info->priv = cp;
+					ret = SUCCESS;
+					break;
+				}
+			}
+#elif (defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)) && !defined(CONFIG_RTL_CPU_TAG)
+			if (_rtl86xx_dev.dev[i] && cp && cp->opened
+				&& (cp->id == info->vid)) {
+				info->priv = cp;
+				ret = SUCCESS;
+				break;
+			}
+#else
+			if (_rtl86xx_dev.dev[i] && cp && cp->opened
+				&& (cp->portmask & (1 << pid))) {
+
+				info->priv = cp;
+				break;
+			}
+#endif
+		}
+
+		/* printk("====%s(%d),dev(%s),i(%d)\n",__FUNCTION__,__LINE__,cp->dev->name,i); */
+		if (ETH_INTF_NUM == i) {
+			info->priv = NULL;
+			dev_kfree_skb_any(skb);
+			ret = FAILED;
+		}
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+#if defined(CONFIG_RTD_1295_HWNAT)
+		else if (SUCCESS == rtl_isPassthruFrame(data)
+			&& (rtl_isWanDev(cp) == TRUE)
+			&& (!ether_addr_equal((char *)cp->dev->dev_addr,
+					(char *)dest_mac)))
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		else if (SUCCESS == rtl_isPassthruFrame(data)
+			&& (rtl_isWanDev(cp) == TRUE)
+			&& (compare_ether_addr((char *)cp->dev->dev_addr,
+					(char *)dest_mac)))
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		{
+#if defined(CONFIG_IPV6)
+			if (rtl_isIpv6McFrame(data) == SUCCESS)
+				info->oriPriv = info->priv;
+#endif
+			info->priv = NETDRV_PRIV(_rtl86xx_dev.pdev);
+			info->isPdev = TRUE;
+		}
+#endif
+	}
+#if defined(CONFIG_RTL_MULTIPLE_WAN) || defined(CONFIG_RTL_VLAN_8021Q) ||  defined(CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT)
+out:
+#endif
+	return ret;
+}
+
+#if defined(CONFIG_RTL_ULINKER_BRSC)
+#include "linux/ulinker_brsc.h"
+#endif
+
+#if defined(CONFIG_RTL_HTTP_REDIRECT)
+inline int is_skb_http_packet(struct sk_buff *skb)
+{
+	if (!skb)
+		return 0;
+	if (*(unsigned short *)(skb->data + ETH_ALEN * 2) == htons(0x0800) &&
+		*(unsigned char *)(skb->data + 0x17) == 6 &&
+		*(unsigned short *)(skb->data + 0x24) == htons(80))
+		return 1;
+	return 0;
+}
+#endif
+#if defined(CONFIG_RTL_DNS_TRAP)
+int rtl_add_Acl_for_dns_trap(struct rtl865x_vlanConfig *vlanConfig)
+{
+	int i;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	static struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER];
+#endif
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+	rtl865x_AclRule_t rule;
+	int ret = FAILED;
+
+	if (vlanConfig == NULL) {
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	re865x_packVlanConfig(vlanConfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+#else
+	pVlanConfig = vlanConfig;
+#endif
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+
+		if (pVlanConfig[i].isWan == 0) {	/*lan config */
+
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_DNSTRAP_USED, RTL865X_ACL_INGRESS);
+
+			/* permit  from cpu port */
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_SRCFILTER;
+			rule.actionType_ = RTL865X_ACL_PERMIT;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+
+			rule.srcFilterPort_ = 1 << 8;	/* cpu port */
+			rule.srcFilterPortMask_ = 1 << 8;
+
+			rule.srcFilterPortUpperBound_ = 65535;
+			rule.srcFilterPortLowerBound_ = 0;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_DNSTRAP_USED);
+
+			/* trap dns packets to cpu */
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_DSTFILTER;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+
+			rule.dstFilterPortUpperBound_ = 53;
+			rule.dstFilterPortLowerBound_ = 53;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_DNSTRAP_USED);
+
+		} else {	/*wan config */
+
+			/* trap dns packets to cpu */
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_DNSTRAP_USED, RTL865X_ACL_INGRESS);
+
+			/* permit  from cpu port */
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_SRCFILTER;
+			rule.actionType_ = RTL865X_ACL_PERMIT;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+
+			rule.srcFilterPort_ = 1 << 8;	/* cpu port */
+			rule.srcFilterPortMask_ = 1 << 8;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_DNSTRAP_USED);
+
+			/* trap dns packets to cpu */
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_DSTFILTER;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+
+			rule.dstFilterPortUpperBound_ = 53;
+			rule.dstFilterPortLowerBound_ = 53;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_DNSTRAP_USED);
+		}
+
+#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+		if (rtl865x_curOpMode == WISP_MODE)
+#endif
+			rtl865x_reConfigDefaultAcl(pVlanConfig[i].ifname);
+	}
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	rtl_8367_add_acl_for_dns(0);
+#endif
+	return SUCCESS;
+}
+
+int rtl_remove_Acl_for_dns_trap(struct rtl865x_vlanConfig *vlanConfig)
+{
+	int i;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER];
+#endif
+
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+
+	if (vlanConfig == NULL) {
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	re865x_packVlanConfig(vlanConfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+#else
+	pVlanConfig = vlanConfig;
+#endif
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+
+		if (pVlanConfig[i].isWan == 0) {	/*lan config */
+			rtl865x_unRegist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_DNSTRAP_USED, RTL865X_ACL_INGRESS);
+		} else {	/*wan config */
+
+			rtl865x_unRegist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_DNSTRAP_USED, RTL865X_ACL_INGRESS);
+		}
+
+	}
+
+#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+
+#else
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	if (rtk_vlan_support_enable == 0) {
+		rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_PERMIT_ALL,
+			RTL865X_ACLTBL_PERMIT_ALL, RTL865X_ACLTBL_PERMIT_ALL,
+			RTL865X_ACLTBL_PERMIT_ALL);
+	} else {
+		rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_ALL_TO_CPU,
+			RTL865X_ACLTBL_ALL_TO_CPU, RTL865X_ACLTBL_PERMIT_ALL,
+			RTL865X_ACLTBL_PERMIT_ALL);
+	}
+#else
+	rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_PERMIT_ALL,
+		RTL865X_ACLTBL_PERMIT_ALL, RTL865X_ACLTBL_PERMIT_ALL,
+		RTL865X_ACLTBL_PERMIT_ALL);
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	rtl_8367_remove_acl_for_dns(0);
+#endif
+
+	return SUCCESS;
+}
+
+inline int is_skb_dns_packet(struct sk_buff *skb)
+{
+	if (!skb)
+		return 0;
+	if (*(unsigned short *)(skb->data + ETH_ALEN * 2) == htons(0x0800) &&
+		*(unsigned char *)(skb->data + 0x17) == 17 &&
+		*(unsigned short *)(skb->data + 0x24) == htons(53))
+		return 1;
+	return 0;
+}
+#endif
+
+#if defined(BR_SHORTCUT)
+__MIPS16 __IRAM_FWD
+	static inline int32 rtl_processBridgeShortCut(struct sk_buff *skb,
+	struct dev_priv *cp_this, rtl_nicRx_info *info)
+{
+	struct net_device *dev;
+#if defined(CONFIG_RTL_VLAN_8021Q) && defined(CONFIG_RTL_BRSHORTCUT_LINUX_VLAN_CTL)
+	unsigned short vid = 0;
+	struct sk_buff *newskb;
+#endif
+
+#ifdef __KERNEL__
+	struct net_bridge_port *br_port;
+#endif
+
+	/*2011-09-13 fix wlan sta can not access internet when wan mac clone sta mac */
+	if (rtl_isWanDev(cp_this) && (rtl865x_curOpMode == GATEWAY_MODE)) {
+#if defined(CONFIG_RTL_ULINKER_BRSC)
+		;		/* tmp, fixme */
+#else
+		return FAILED;
+#endif
+	}
+
+#ifdef __KERNEL__
+	br_port = GET_BR_PORT(cp_this->dev);
+	if (br_port) {
+		if (br_port->br->stp_enabled
+			&& br_port->state != BR_STATE_FORWARDING) {
+			return FAILED;
+		}
+	}
+#endif
+
+	/*if lltd, don't go shortcut */
+	if (*(unsigned short *)(skb->data + ETH_ALEN * 2) == htons(0x88d9))
+		return FAILED;
+
+#if defined(CONFIG_RTL_HTTP_REDIRECT)
+	if (is_skb_http_packet(skb))
+		return FAILED;
+#endif
+#if defined(CONFIG_RTL_DNS_TRAP)
+	if (is_skb_dns_packet(skb))
+		return FAILED;
+#endif
+
+	if (
+#if 0
+		(eth_flag & BIT(2)) &&
+#endif
+#if defined(CONFIG_DOMAIN_NAME_QUERY_SUPPORT) || defined(CONFIG_RTL_ULINKER)
+		(skb->data[37] != 68) &&	/*port 68 is dhcp dest port. In order to hack dns ip, so dhcp packag                                                           can't enter bridge short cut. */
+#endif
+#if defined(CONFIG_WIRELESS_LAN_MODULE)
+		(wirelessnet_hook_shortcut != NULL)
+		&& ((dev = wirelessnet_hook_shortcut(skb->data)) != NULL)
+#else
+#if defined(CONFIG_RTL_ULINKER_BRSC)
+		(((dev = brsc_get_cached_dev(0, skb->data)) != NULL)
+			|| ((dev = get_shortcut_dev(skb->data)) != NULL))
+#else
+		((dev = get_shortcut_dev(skb->data)) != NULL)
+#endif
+#endif
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+		&& rtl865x_same_root(skb->dev, dev)
+#endif
+		) {
+#if defined(CONFIG_RTL_ULINKER_BRSC)
+		if (cached_usb.dev && dev == cached_usb.dev) {
+			BRSC_COUNTER_UPDATE(tx_eth_sc);
+			BDBG_BRSC("BRSC: get shortcut dev[%s]\n",
+				cached_usb.dev->name);
+
+			if (skb->dev)
+				brsc_cache_dev(2, skb->dev,
+					skb->data + ETH_ALEN);
+		} else
+#endif /* #if defined(CONFIG_RTL_ULINKER_BRSC) */
+		{
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+			if (memcmp(&skb->data[ETH_ALEN], cp_this->dev->dev_addr,
+					ETH_ALEN))
+#endif
+			{
+				if (memcmp(cached_eth_addr,
+						&skb->data[ETH_ALEN],
+						ETH_ALEN) == 0) {
+					/* memcpy(cached_eth_addr, &skb->data[ETH_ALEN], ETH_ALEN); */
+					cached_dev = cp_this->dev;
+					last_used = 0;
+				} else if (memcmp(cached_eth_addr2,
+						&skb->data[ETH_ALEN],
+						ETH_ALEN) == 0) {
+					/* memcpy(cached_eth_addr2, &skb->data[ETH_ALEN], ETH_ALEN); */
+					cached_dev2 = cp_this->dev;
+					last_used = 1;
+				} else if (memcmp(cached_eth_addr3,
+						&skb->data[ETH_ALEN],
+						ETH_ALEN) == 0) {
+					cached_dev3 = cp_this->dev;
+					last_used = 2;
+				} else if (memcmp(cached_eth_addr4,
+						&skb->data[ETH_ALEN],
+						ETH_ALEN) == 0) {
+					cached_dev4 = cp_this->dev;
+					last_used = 3;
+				} else if (last_used == 3) {
+					memcpy(cached_eth_addr3,
+						&skb->data[ETH_ALEN], ETH_ALEN);
+					cached_dev3 = cp_this->dev;
+					last_used = 2;
+				} else if (last_used == 2) {
+					memcpy(cached_eth_addr2,
+						&skb->data[ETH_ALEN], ETH_ALEN);
+					cached_dev2 = cp_this->dev;
+					last_used = 1;
+				} else if (last_used == 1) {
+					memcpy(cached_eth_addr,
+						&skb->data[ETH_ALEN], ETH_ALEN);
+					cached_dev = cp_this->dev;
+					last_used = 0;
+				} else {
+					memcpy(cached_eth_addr4,
+						&skb->data[ETH_ALEN], ETH_ALEN);
+					cached_dev4 = cp_this->dev;
+					last_used = 3;
+				}
+#ifdef CONFIG_SWCONFIG		/* mark_brc */
+				/* record thevlan id in shorcut cache */
+				if (swconfig_vlan_enable) {
+					uint16 skb_vid = 0;
+					skb_vid = rtk_get_skb_vid(skb);
+					if (skb_vid != 0)
+						cached_eth_vid = skb_vid;
+					else
+						cached_eth_vid = 1;	/* default vid , FIXME */
+				}
+#endif
+			}
+		}
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_RTL_HARDWARE_NAT)
+		skb->cb[0] = info->rxPri;
+#endif
+#ifdef CONFIG_SWCONFIG		/* mark_brc */
+		/* remove vlan tag before going to wifi shortcut */
+		if (swconfig_vlan_enable)
+			rtk_rm_skb_vid(skb);
+#endif
+
+#if defined(CONFIG_RTL_VLAN_8021Q) && defined(CONFIG_RTL_BRSHORTCUT_LINUX_VLAN_CTL)
+		/* remove vlan tag if it is not need to tagged out */
+		if (linux_vlan_enable) {
+			if (*((unsigned short *)(skb->data +
+						(ETH_ALEN << 1))) ==
+				__constant_htons(ETH_P_8021Q)) {
+				vid = ntohs(*(uint16 *)(skb->data +
+						(ETH_ALEN << 1) + 2)) & 0x0fff;
+				if (!(vlan_ctl_p->group[vid].
+						tagMemberMask & (1 << dev->
+							vlan_member_map))) {
+					if (skb_cloned(skb)) {
+						newskb = skb_copy(skb,
+							GFP_ATOMIC);
+						if (newskb == NULL) {
+							return FAILED;
+						}
+						dev_kfree_skb_any(skb);
+						skb = newskb;
+					}
+					memmove(skb->data + VLAN_HLEN,
+						skb->data, ETH_ALEN << 1);
+					skb_pull(skb, VLAN_HLEN);
+				}
+			}
+		}
+#endif
+		/*skb->dev = dev;*/ /* for performance */
+		#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+		dev->hard_start_xmit(skb, dev);
+#else
+		dev->netdev_ops->ndo_start_xmit(skb, dev);
+#endif
+		DEBUG_ERR("[%s][%d]-[%s]\n", __FUNCTION__, __LINE__,
+			skb->dev->name);
+		return SUCCESS;
+#if 0
+	} else if (info->vid == PKTHDR_EXTPORT_MAGIC) {
+		/*      the pkt should be tx out by a wlanx interface.
+		 *      But we don't not which one...
+		 *      Pass it to protocol stack.
+		 */
+		/*
+		 * cp_this->net_stats.rx_dropped++;
+		 * dev_kfree_skb_any(skb);
+		 * return SUCCESS;
+		 */
+#endif
+	}
+	return FAILED;
+}
+#elif defined(CONFIG_RTL_HARDWARE_NAT) && (defined(CONFIG_RTL8192SE) || defined(CONFIG_RTL8192CD))
+#if 0
+__MIPS16 __IRAM_FWD
+	static inline int32 rtl_processExtensionPortShortCut(struct sk_buff
+	*skb, struct dev_priv *cp_this, rtl_nicRx_info *info)
+{
+	struct net_device *dev;
+
+	if ((PKTHDR_EXTPORT_MAGIC != info->vid)
+		|| (info->pid != PKTHDR_EXTPORT_P3))
+		return FAILED;
+
+	dev = get_shortcut_dev(skb->data);
+
+	if (dev != NULL) {
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_RTL_HARDWARE_NAT)
+		skb->cb[0] = info->rxPri;
+#endif
+		/*skb->dev = dev;*/ /* for performance */
+#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+		dev->hard_start_xmit(skb, dev);
+#else
+		dev->netdev_ops->ndo_start_xmit(skb, dev);
+#endif
+		DEBUG_ERR("[%s][%d]-[%s]\n", __FUNCTION__, __LINE__,
+			skb->dev->name);
+
+		return SUCCESS;
+#if 0
+	} else {
+		/*      the pkt should be tx out by a wlanx interface.
+		 *      But we don't not which one...
+		 *      Pass it to protocol stack.
+		 */
+		/*
+		 * cp_this->net_stats.rx_dropped++;
+		 * dev_kfree_skb_any(skb);
+		 */
+#endif
+	}
+
+	return FAILED;
+}
+#endif
+#endif
+
+__MIPS16 __IRAM_FWD
+	static inline void rtl_processRxToProtcolStack(struct sk_buff *skb,
+	struct dev_priv *cp_this)
+{
+#ifdef CONFIG_RTL_8198C
+	unsigned long flags = 0;
+	SMP_LOCK_ETH(flags);
+#endif
+
+	skb->protocol = eth_type_trans(skb, skb->dev);
+
+#ifdef CONFIG_RTL_IPV6READYLOGO
+	if (skb->protocol == 0x86dd)
+		skb->ip_summed = CHECKSUM_NONE;
+	else
+		skb->ip_summed = CHECKSUM_UNNECESSARY;
+#else
+	/* skb->ip_summed = CHECKSUM_NONE; */
+	/* It must be a TCP or UDP packet with a valid checksum */
+	skb->ip_summed = CHECKSUM_UNNECESSARY;
+	/* printk("[%s][%d]-skb->dev[%s],proto(0x%x)\n", __FUNCTION__, __LINE__, skb->dev->name,skb->protocol); */
+#endif
+
+#if defined(CONFIG_RTL_IP_POLICY_ROUTING_SUPPORT)
+	/* skb->vlan_member = cp_this->port_member; */
+	/* skb->src_port = IF_SWITCH; */
+	skb->switch_port = skb->dev->name;
+#endif
+
+#ifndef CONFIG_OPENWRT_SDK
+#if defined(RX_TASKLET)
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+	skb->localPublicFlags = 0;
+#endif
+#if defined(CONFIG_RTL_FAST_BRIDGE)
+	skb->fast_br_forwarding_flags = 0;
+#endif
+
+#ifdef CONFIG_SMP
+#ifdef CONFIG_RTL_ETH_NAPI_SUPPORT
+	skb_queue_tail(&cp_this->rx_napi_skb_queue, skb);
+	napi_schedule(&cp_this->napi);
+#else
+	netif_rx(skb);
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+#else
+
+#ifdef CONFIG_RTL_8197F
+#ifdef CONFIG_RTL_ETH_NAPI_GRO_SUPPORT
+	napi_gro_receive(&cp_this->napi, skb);
+#else
+	netif_rx(skb);
+#endif /* CONFIG_RTL_ETH_NAPI_GRO_SUPPORT */
+#else
+	netif_receive_skb(skb);
+#endif
+#endif
+
+#else /*      defined(RX_TASKLET)     */
+	netif_rx(skb);
+#endif /*      defined(RX_TASKLET)     */
+#else /* CONFIG_OPENWRT_SDK */
+#if !defined(CONFIG_RTL_IPTABLES_FAST_PATH)	/* || defined(CONFIG_RTL_8197F) */
+	netif_rx(skb);
+#else
+	netif_receive_skb(skb);
+#endif
+
+#endif
+#ifdef CONFIG_RTL_8198C
+	SMP_UNLOCK_ETH(flags);
+#endif
+}
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT) || defined(CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT)
+extern int rx_vlan_process(struct net_device *dev, struct vlan_info *info_ori,
+	struct sk_buff *skb, struct sk_buff **new_skb);
+extern int tx_vlan_process(struct net_device *dev, struct vlan_info *info_ori,
+	struct sk_buff *skb, int wlan_pri);
+#else
+extern int rx_vlan_process(struct net_device *dev, struct vlan_info *info,
+	struct sk_buff *skb);
+extern int tx_vlan_process(struct net_device *dev, struct vlan_info *info,
+	struct sk_buff *skb, int wlan_pri);
+#endif
+#endif
+
+#ifdef CONFIG_RTK_SUPPORT_DHCP_PORT_IP_BIND
+#define SUPPORT_DHCP_PORT_IP_BIND
+#endif
+
+#ifdef SUPPORT_DHCP_PORT_IP_BIND
+typedef struct dhcp_port_mac {
+	uint8 client_mac[6];
+	uint16 port_id;
+} DHCP_PORT_MAC;
+
+DHCP_PORT_MAC port_mac_table[RTL8651_PHY_NUMBER];
+#endif
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+extern struct net_device *rtl_get_wlan_dev_by_mac(unsigned char *da);
+int rtl_checkDstToExtPort(rtl_nicRx_info *info)
+{
+
+	if (info->vid == PKTHDR_EXTPORT_MAGIC) {
+		return SUCCESS;
+	}
+
+	return FAILED;
+}
+
+int rtl_checkSrcFromExtPort(rtl_nicRx_info *info)
+{
+
+	if (info->vid == PKTHDR_EXTPORT_MAGIC4) {
+		return SUCCESS;
+	}
+
+	return FAILED;
+}
+
+static inline int32 rtl_fwdToExtPort(struct sk_buff *skb,
+	struct dev_priv *cp_this, rtl_nicRx_info *info)
+{
+	struct net_device *dev = NULL;
+	int ret = FAILED;
+
+	if (rtl_checkDstToExtPort(info) != SUCCESS) {
+		return FAILED;
+	}
+
+	dev = rtl_get_wlan_dev_by_mac(skb->data);
+	if (dev != NULL) {
+#if 0
+		if (net_ratelimit()) {
+			printk("dev:%s,%x,%x,[%s]:[%d].\n", dev->name,
+				info->vid, info->pid, __FUNCTION__, __LINE__);
+			memDump((void *)skb->data, 64, "RX");
+		}
+#endif
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_RTL_HARDWARE_NAT)
+#endif
+		skb->dev = dev;
+#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+		ret = dev->hard_start_xmit(skb, dev);
+#else
+		ret = dev->netdev_ops->ndo_start_xmit(skb, dev);
+#endif
+
+		return SUCCESS;
+	} else {
+#if 0
+		printk("[%s]:[%d].\n", __FUNCTION__, __LINE__);
+		memDump((void *)skb->data, 64, "TX");
+#endif
+		panic_printk
+			("eth ext Tx:can not find dst  ext  port device!\n");
+		dev_kfree_skb_any(skb);
+		return SUCCESS;
+	}
+	return FAILED;
+}
+
+static int32 rtl_fwdFromExtPort(struct sk_buff *skb, struct dev_priv *cp_this,
+	rtl_nicRx_info *info)
+{
+	int ret = FAILED;
+	struct net_device *ori_wlan_dev = NULL;
+	ret = rtl_checkSrcFromExtPort(info);
+	if (ret == SUCCESS) {
+		if (1)		/* (info->pid==PKTHDR_EXTPORT_P3) */
+		{
+			/*just use PKTHDR_EXTPORT_P3<->wlan */
+			ori_wlan_dev =
+				rtl_get_wlan_dev_by_mac(skb->data + ETH_ALEN);
+			if (ori_wlan_dev) {
+				skb->dev = ori_wlan_dev;
+				/*to-do, for vlan consideration, may add back vlan tag */
+				rtl_processRxToProtcolStack(skb, cp_this);
+				return SUCCESS;
+			} else {
+				panic_printk
+					("eth ext Rx:can not find src ext port device!\n");
+				dev_kfree_skb_any(skb);
+				return SUCCESS;
+			}
+		}
+	}
+	return FAILED;
+}
+#endif
+
+__MIPS16 __IRAM_FWD static inline void rtl_processRxFrame(rtl_nicRx_info *info)
+{
+	struct dev_priv *cp_this;
+	struct sk_buff *skb;
+	uint32 vid, pid, len;
+	uint8 *data;
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	int ret;
+#endif
+#ifdef CONFIG_RTK_OPENVPN_HW_CRYPTO
+	int vpn_port;
+	int dec_ret = 1;
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+	int mCastFlag = 0;
+#endif
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	int type;
+#endif
+
+	cp_this = info->priv;
+	skb = info->input;
+	vid = info->vid;
+#if defined(CONFIG_RTD_1295_HWNAT)
+	data = skb->data;
+	skb_reset_tail_pointer(skb);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	data = skb->tail = skb->data;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	type = rtl_is_pppoe_igmp_bridge_frame(skb,1,skb->data);
+#endif
+
+	#if 0
+	if(net_ratelimit())
+		printk("[%s:%d]vid=%d\n",__FUNCTION__,__LINE__,vid);
+	#endif
+#if 0				/* defined(CONFIG_RTL_STP) */
+	if (info->isStpVirtualDev) {
+		pid = info->pid;
+		len = info->len;
+		skb->len = 0;
+		skb_put(skb, len);
+		skb->dev = info->priv->dev;
+		goto RxToPs;
+	}
+#endif
+#if 0
+	/*      sanity check    */
+	if ((memcmp(&data[ETH_ALEN], cp_this->dev->dev_addr, ETH_ALEN) == 0) || PKTHDR_EXTPORT_MAGIC2 == vid || PKTHDR_EXTPORT_MAGIC == vid)	/* check source mac */
+	{
+#if defined(CONFIG_RTL_HARDWARE_NAT) && (defined(CONFIG_RTL8192SE) || defined(CONFIG_RTL8192CD))
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+		if ((PKTHDR_EXTPORT_MAGIC != vid)
+			|| (info->pid != PKTHDR_EXTPORT_P3
+				&& info->pid != PKTHDR_EXTPORT_P2))
+#else
+		if ((PKTHDR_EXTPORT_MAGIC != vid)
+			|| (info->pid != PKTHDR_EXTPORT_P3))
+#endif
+#endif
+		{
+			cp_this->net_stats.rx_dropped++;
+			dev_kfree_skb_any(skb);
+			return;
+		}
+	}
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (skb->head == NULL || skb->end == 0)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (skb->head == NULL || skb->end == NULL)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	{
+		dev_kfree_skb_any(skb);
+		return;
+	}
+	/*      sanity check end        */
+
+	pid = info->pid;
+	len = info->len;
+	skb->len = 0;
+	skb_put(skb, len);
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	if (extPortEnabled && ((skb->data[0] & 0x1) == 0)) {
+		if (rtl_fwdToExtPort(skb, cp_this, info) == SUCCESS) {
+			return;
+		} else if (rtl_fwdFromExtPort(skb, cp_this, info) == SUCCESS) {
+			return;
+		}
+	}
+#endif
+
+#if defined(CONFIG_OPENWRT_SDK) && !defined(CONFIG_RTL_CUSTOM_PASSTHRU)	/* mark_bb */
+	skb->dev = info->priv->dev;
+#else
+	skb->dev = info->isPdev ? _rtl86xx_dev.pdev : info->priv->dev;
+#endif
+
+	/* skb->dev=cp_this->dev; */
+
+	/* if((1 << pid) & RTL_WANPORT_MASK) */
+	/* if(skb->data[0]&0x01 && skb->data[0]!=0xff) */
+	/* panic_printk("WAN recv mc pkt!\n"); */
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	skb->from_dev = skb->dev;
+#endif
+
+#ifdef CONFIG_RTK_VOIP_ETHERNET_DSP
+	/* merged from r8627 may conflict later */
+	/* printk("type: %x, skb->mac=%p, skb->data=%p\n", skb->mac.ethernet->h_proto, skb->mac.ethernet, skb->data); */
+	/* extern void voip_dsp_L2_pkt_rx(unsigned char* eth_pkt); */
+	if (*(uint16 *)(&(skb->data[12])) == htons(0x8899)
+		&& voip_dsp_L2_pkt_rx_trap) {
+		/* dsp_id = *(uint16*)(&(skb->data[14]); */
+		voip_dsp_L2_pkt_rx_trap(skb->data, skb->len);
+		dev_kfree_skb_any(skb);
+		/* printk("0x%x ", *(uint16*)(&(skb->data[12]))); */
+		return;
+	}
+#endif
+
+#ifdef CONFIG_SWCONFIG
+	if (*((uint16 *)(skb->data + (ETH_ALEN << 1))) !=
+		__constant_htons(ETH_P_8021Q)) {
+		/* if packet without tag then add tag in packet if cpuport is tag member this vlan */
+		if (swconfig_vlan_enable) {
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			rtk_add_cpuport_tag(vid, pid, skb);
+#else
+			rtk_add_cpuport_tag(vid, skb);
+#endif
+		}
+#if 0
+		printk("rx frame phHvid=%d,pid=%d \n,dev=%s \n", info->vid, pid, skb->dev->name);	/* mark_sw */
+		printk("skb + 6=  %2x %2x %2x %2x %2x %2x | %2x %2x %2x %2x \n", skb->data[0 + 6], skb->data[1 + 6], skb->data[2 + 6], skb->data[3 + 6], skb->data[4 + 6], skb->data[5 + 6], skb->data[6 + 6], skb->data[7 + 6], skb->data[8 + 6], skb->data[9 + 6]);	/* mark_sw */
+#endif
+	}
+	goto reserve_vlan_tag;
+#endif
+
+#if defined(CONFIG_NETFILTER_XT_MATCH_PHYPORT) || defined(CONFIG_RTL_FAST_FILTER) || defined(CONFIG_RTL_QOS_PATCH) || defined(CONFIG_RTK_VOIP_QOS) || defined(CONFIG_RTK_VLAN_WAN_TAG_SUPPORT) || defined(CONFIG_RTL_MAC_FILTER_CARE_INPORT) || defined(CONFIG_RTL_HW_QOS_SUPPORT_WLAN)
+	skb->srcPhyPort = (uint8)pid;
+#endif
+
+	/* printk("=======%s(%d),skb->dev:%s,cp_this(%s),vlan:%d,is_lan:%d,id(%d)\n",__FUNCTION__,__LINE__,skb->dev->name,cp_this->dev->name, cp_this->vlan_setting.global_vlan,cp_this->vlan_setting.is_lan,cp_this->vlan_setting.id); */
+	/*      vlan process (including strip vlan tag) */
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+	if (cp_this->vlan_setting.global_vlan)
+#else
+	if (rtk_vlan_support_enable && cp_this->vlan_setting.global_vlan)
+#endif
+	{
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT) || defined(CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT)
+		struct sk_buff *new_skb = NULL;
+		int vlan_check;
+		vlan_check =
+			rx_vlan_process(cp_this->dev, &cp_this->vlan_setting,
+			skb, &new_skb);
+		if ((vlan_check == 0) && new_skb) {
+			rtl_processRxToProtcolStack(new_skb, cp_this);
+		} else if (vlan_check == 1) {
+			cp_this->net_stats.rx_dropped++;
+			dev_kfree_skb_any(skb);
+			return;
+		} else if ((vlan_check == 2) && new_skb) {
+			dev_kfree_skb_any(new_skb);
+		}
+#else
+		if (rx_vlan_process(cp_this->dev, &cp_this->vlan_setting, skb)) {
+			cp_this->net_stats.rx_dropped++;
+			dev_kfree_skb_any(skb);
+			return;
+		}
+#endif
+
+#if defined(CONFIG_RTK_VLAN_FOR_CABLE_MODEM)
+		if (rtk_vlan_support_enable == 2) {
+			DEBUG_ERR
+				("====%s(%d),cp(%s),cp->vlan.id(%d),skb->tag.vid(%d)\n",
+				__FUNCTION__, __LINE__, cp_this->dev->name,
+				cp_this->vlan_setting.id,
+				skb->tag.f.pci & 0xfff);
+			if (cp_this->vlan_setting.vlan
+				&& skb->tag.f.tpid == htons(ETH_P_8021Q)
+				&& (skb->tag.f.pci & 0xfff) !=
+				cp_this->vlan_setting.id) {
+				if (cp_this->vlan_setting.is_lan == 0) {
+					struct net_device *vap;
+					/*      look up vap     */
+					vap = get_dev_by_vid(skb->tag.f.
+						pci & 0xfff);
+					if (vap) {
+
+						skb->dev = vap;
+						vap->netdev_ops->
+							ndo_start_xmit(skb,
+							vap);
+						return;
+					}
+				}
+			}
+		}
+#endif
+	}
+#endif /*      defined(CONFIG_RTK_VLAN_SUPPORT)        */
+
+	/* add for 802.1p qos */
+	if (*((uint16 *)(skb->data + (ETH_ALEN << 1))) ==
+		__constant_htons(ETH_P_8021Q)) {
+		vid = ntohs(*(uint16 *)(skb->data + (ETH_ALEN << 1) +
+				2)) & 0x0fff;
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+		skb->srcVlanPriority =
+			ntohs(*(uint16 *)(data + (ETH_ALEN << 1) + 2)) >> 13;
+#endif
+
+#if defined(CONFIG_RTL_VLANPRI_IPTABLE_CHECK)
+		skb->original_vlanpri =
+			ntohs(*(uint16 *)(data + (ETH_ALEN << 1) + 2)) >> 13;
+#endif
+	}
+#ifdef CONFIG_RTL_VLAN_8021Q
+	if (linux_vlan_enable && linux_vlan_hw_support_enable) {
+		struct sk_buff *skb1 = NULL;
+		struct dev_priv *cp1 = NULL;
+
+#if defined(CONFIG_OPENWRT_SDK)
+		if (rtk_process_11q_rx(pid, skb)) {
+			data = skb->data;
+			goto reserve_vlan_tag;
+		}
+#else
+		ret = rtk_process_11q_rx(pid, skb, &skb1, info);
+		if (ret == 1) {
+			if (skb1) {
+#if defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+				static rtl_nicRx_info info1 = { 0 };
+#endif
+
+				cp1 = netdev_priv(skb1->dev);
+
+#if !defined(CONFIG_RTL_NIC_HWSTATS)
+				cp1->net_stats.rx_packets++;
+				cp1->net_stats.rx_bytes += cp1->len;
+#endif
+				cp1->dev->last_rx = jiffies;
+
+				/* Untag NAT + untag bridge case, MC pkt just skb-cloned(bridge). */
+#if defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+				if (((mCastFlag = rtl_isMcastPkt(skb1)) != 0) || (type != 0))	/* multicast               */
+#else
+				if ((mCastFlag = rtl_isMcastPkt(skb1)) != 0)	/*  multicast               */
+#endif
+				{
+					memcpy((void *)&info1, info,
+						sizeof(rtl_nicRx_info));
+					info1.vid =
+						ntohs(*(uint16 *)(skb1->
+							linux_vlan_src_tag +
+							2));
+					info1.priv =
+						NETDRV_PRIV(_rtl86xx_dev.
+						dev[1]);
+					info1.isPdev = FALSE;
+
+					/*      multicast process       */
+#if defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+					rtl_MulticastRxCheck(skb1, &info1,
+						mCastFlag);
+#endif
+				}
+#endif
+
+				rtl_processRxToProtcolStack(skb1, cp1);
+			}
+
+			data = skb->data;
+			info->priv = cp_this = netdev_priv(skb->dev);
+
+			goto reserve_vlan_tag;
+		} else if (ret == 2) {
+			cp_this->net_stats.rx_dropped++;
+			dev_kfree_skb_any(skb);
+			return;
+		}
+#endif
+	}
+
+	if (linux_vlan_enable && (!linux_vlan_hw_support_enable)) {
+		/*add vlan tag if pkt is untagged */
+		if (*((uint16 *)(skb->data + (ETH_ALEN << 1))) !=
+			__constant_htons(ETH_P_8021Q)) {
+#if 0
+			if ((info->srcvid != RTL_LANVLANID)
+				&& (info->srcvid != RTL_WANVLANID))
+#endif
+				if ((vlan_ctl_p->pvid[info->pid] !=
+						RTL_LANVLANID)
+					&& (vlan_ctl_p->pvid[info->pid] !=
+						RTL_WANVLANID)) {
+					memmove(skb->data - VLAN_HLEN,
+						skb->data, ETH_ALEN << 1);
+					skb_push(skb, VLAN_HLEN);
+					*((uint16 *)(skb->data +
+							(ETH_ALEN << 1))) =
+						__constant_htons(ETH_P_8021Q);
+#if 0
+					if (info->srcvid) {
+						*((uint16 *)(skb->data +
+								(ETH_ALEN << 1)
+								+ 2)) =
+							info->srcvid;
+					} else {
+						*((uint16 *)(skb->data +
+								(ETH_ALEN << 1)
+								+ 2)) =
+							vlan_ctl_p->pvid[info->
+							pid];
+					}
+#else
+					*((uint16 *)(skb->data +
+							(ETH_ALEN << 1) + 2)) =
+						__constant_htons(vlan_ctl_p->
+						pvid[info->pid]);
+#endif
+					data = skb->data;
+				}
+		}
+	} else
+#endif
+
+	if (*((uint16 *)(skb->data + (ETH_ALEN << 1))) ==
+		__constant_htons(ETH_P_8021Q)) {
+#if defined(CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT)
+		memcpy(skb->vlan_passthrough_saved_tag,
+			skb->data + ETH_ALEN * 2, 4);
+#endif
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+		if ((skb->data[0] & 1) || ((skb->data[0] == 0x33)
+				&& (skb->data[1] == 0x33)
+				&& (skb->data[2] != 0xFF))) {
+			memcpy(&skb->tag, skb->data + ETH_ALEN * 2,
+				sizeof(struct vlan_tag));
+		}
+#endif
+		vid = ntohs(*(uint16 *)(data + (ETH_ALEN << 1) + 2)) & 0x0fff;
+#if 0
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+		/* skb->srcVlanPriority = (vid>>13)&0x7; */
+		skb->srcVlanPriority =
+			ntohs(*(uint16 *)(data + (ETH_ALEN << 1) + 2)) >> 13;
+#endif
+#if defined(CONFIG_RTL_VLANPRI_IPTABLE_CHECK)
+		/* skb->original_vlanpri = (vid>>13)&0x7; */
+		skb->original_vlanpri =
+			ntohs(*(uint16 *)(data + (ETH_ALEN << 1) + 2)) >> 13;
+#endif
+#endif
+		/* vid &= 0x0fff; */
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+		/* for later arp reply to WAN port */
+		/* memcpy(&(skb->tag), skb->data+ETH_ALEN*2, VLAN_HLEN); */
+
+		if (vlan_tag && vid == vlan_tag) {
+			goto Remove_tag;
+		} else if (vlan_bridge_tag && vid == vlan_bridge_tag) {
+			if (vlan_bridge_multicast_tag) {
+				if ((skb->data[0] == 0x01)
+					&& (skb->data[1] == 0x00)
+					&& (skb->data[2] == 0x5e)) {
+					cp_this->net_stats.rx_dropped++;
+					dev_kfree_skb_any(skb);
+					return;
+				}
+			}
+			goto Remove_tag;
+		} else if (vlan_bridge_multicast_tag
+			&& vid == vlan_bridge_multicast_tag) {
+			if ((skb->data[0] == 0x01) && (skb->data[1] == 0x00)
+				&& (skb->data[2] == 0x5e)) {
+				info->vid = vlan_bridge_tag;	/* for later check ??? */
+				goto Remove_tag;
+			}
+		} else {
+#ifndef CONFIG_VLAN_8021Q
+			cp_this->net_stats.rx_dropped++;
+			dev_kfree_skb_any(skb);
+			return;
+#endif
+		}
+#ifdef CONFIG_VLAN_8021Q
+		goto Reserve_tag;
+#endif
+Remove_tag:
+#endif
+#if !defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT) || (!defined(CONFIG_VLAN_8021Q) && defined(CONFIG_OPENWRT_SDK))
+		memmove(data + VLAN_HLEN, data, VLAN_ETH_ALEN << 1);
+		skb_pull(skb, VLAN_HLEN);
+#endif
+#if defined(CONFIG_VLAN_8021Q) && defined(CONFIG_RTK_VLAN_WAN_TAG_SUPPORT)
+Reserve_tag:
+		;		/* don't remove tag */
+#endif
+	}
+	/*      vlan process end (vlan tag has already stripped)        */
+#if defined(CONFIG_RTL_VLAN_8021Q) || defined(CONFIG_SWCONFIG)
+reserve_vlan_tag:
+#endif
+
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU) && defined(CONFIG_IPV6)
+	if (info->oriPriv) {
+		struct sk_buff *newSkb;
+		newSkb = skb_clone(skb, GFP_ATOMIC);
+
+		/*Send this newSkb to IPv6 protocol stack */
+		if (newSkb) {
+			newSkb->dev = info->oriPriv->dev;
+			rtl_processRxToProtcolStack(newSkb, info->oriPriv);
+		}
+	}
+#endif
+
+	/*      update statistics       */
+#if !defined(CONFIG_RTL_NIC_HWSTATS)
+	cp_this->net_stats.rx_packets++;
+	cp_this->net_stats.rx_bytes += skb->len;
+#endif
+	cp_this->dev->last_rx = jiffies;
+	/*      update statistics end   */
+
+#ifdef SUPPORT_DHCP_PORT_IP_BIND
+	if (isDHCPpkt(skb)) {
+		uint16 port_id;
+		uint8 i = 0;
+		uint8 client_mac[ETH_ALEN];
+		port_id = info->pid;
+		memcpy(client_mac, data + ETH_ALEN, ETH_ALEN);
+		if (port_id < RTL8651_PHY_NUMBER) {
+			port_mac_table[port_id].port_id = port_id + 1;
+			memcpy(port_mac_table[port_id].client_mac, client_mac,
+				ETH_ALEN);
+			for (i = 0; i < RTL8651_PHY_NUMBER; i++) {
+				if ((i != port_id)
+					&& (memcmp(port_mac_table[i].client_mac,
+							client_mac,
+							ETH_ALEN) == 0))
+					memset(port_mac_table[i].client_mac, 0,
+						ETH_ALEN);
+			}
+		} else
+			panic_printk("%s:%d port_id=%d\n", __FUNCTION__,
+				__LINE__, port_id);
+	}
+#endif
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+	if (rtl_hw_vlan_enable) {
+		/* the cp_this ,  vid  is possbile chaged in rx_vlan_process due to wan have multiple vid. */
+		/* map updated vid to real cp_this here */
+		uint16 newvid = 0;
+		newvid = get_skb_vid(skb);
+		/* bypass some case that no need to update cp */
+		if (cp_this->id == RTL_LANVLANID)	/* bypass nat LAN group , nerver change */
+			goto updated_end;
+		if ((newvid == 0))	/* from vlan disable (LAN) */
+			goto updated_end;
+
+/* if(newvid == wan_management_vlan.id )  // management always from wan cp , bypass */
+/* goto updated_end;   //mark_manv */
+
+		if (newvid == cp_this->id)	/* no need change */
+			goto updated_end;
+
+		/* now , find the real mapping cp_this */
+		cp_this = (struct dev_priv *)rtl_get_cp_by_vid(newvid);
+
+		/* update other info , and skb->dev */
+		skb->dev = cp_this->dev;
+		info->priv = cp_this;
+		info->vid = cp_this->id;
+		vid = info->vid;
+		cp_this->dev->last_rx = jiffies;	/* last_rx at new cp */
+	}
+updated_end:
+#endif
+
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+	/* if (dot1x_config.enable) */
+	if ((dot1x_config.enable) && (rtl_is802dot1xFrame(skb->data))) {
+		ret = rtl_802dot1xRxHandle(skb, info);
+		/* panic_printk("%s %d ret=%d\n", __FUNCTION__, __LINE__, ret); */
+		if (ret == DOT1X_CONSUME_PKT || ret == DOT1X_DROP_PKT) {
+			if (ret == DOT1X_DROP_PKT)
+				cp_this->net_stats.rx_dropped++;
+			return;
+		}
+	}
+#endif
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	if ((0 == (data[0] & 0x01)) && (type == 0))
+#else
+	if (0 == (data[0] & 0x01))
+#endif /*      unicast pkt only        */
+	{
+#ifdef CONFIG_RTK_OPENVPN_HW_CRYPTO
+		vpn_port = get_openvpn_port();
+		if (vpn_port > 0 && vpn_port < 65536) {
+			/* if(skb->len>43 && *((uint16*)(skb->data+36))==vpn_port  && (*((uint16*)(skb->data+20)) & 0x3fff) ==0) */
+			if (skb->len > 43 && *((uint8 *)(skb->data + 23)) == 17
+				&& *((uint16 *)(skb->data + 36)) == vpn_port
+				&& (*((uint16 *)(skb->data +
+							20)) & ntohs(0x3fff)) ==
+				0)
+				dec_ret = rtk_openvpn_hw_decrypto(skb, 1);	/* static/dhcp */
+			else if (skb->len > 51
+				&& *((uint8 *)(skb->data + 31)) == 17
+				&& *((uint16 *)(skb->data + 44)) == vpn_port
+				&& (*((uint16 *)(skb->data +
+							28)) & ntohs(0x3fff)) ==
+				0)
+				dec_ret = rtk_openvpn_hw_decrypto(skb, 2);	/* pppoe */
+		}
+		if (dec_ret < 1) {
+			if (dec_ret < 0) {
+				cp_this->net_stats.rx_dropped++;
+				dev_kfree_skb_any(skb);
+			}
+			return;
+		}
+#endif
+#if defined(CONFIG_RTL_QOS_VLANID_SUPPORT)
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		if ((info->vid == 0)
+			&& (rtl819x_getSwEthPvid(pid, &(info->vid)) == SUCCESS))
+			vid = info->vid;
+#endif
+		skb->srcVlanId = vid;
+#endif
+
+#if !defined(CONFIG_RTL_BRSHORTCUT_LINUX_VLAN_CTL)
+#ifdef CONFIG_RTL_VLAN_8021Q
+		if (!linux_vlan_enable) {
+#endif
+#endif
+			/*      shortcut process        */
+#if defined(BR_SHORTCUT)
+			if (SUCCESS == rtl_processBridgeShortCut(skb, cp_this,
+					info)) {
+				return;
+			}
+#elif defined(CONFIG_RTL_HARDWARE_NAT) && (defined(CONFIG_RTL8192SE) || defined(CONFIG_RTL8192CD))
+			/*
+			 * if (SUCCESS==rtl_processExtensionPortShortCut(skb,cp_this, info)) {
+			 * return;
+			 * }
+			 */
+#endif
+
+#if defined(CONFIG_RTL_FASTBRIDGE)
+			if (RTL_FB_RETURN_SUCCESS == rtl_fb_process_in_nic(skb,
+					cp_this->dev))
+				return;
+#endif
+			/*      shortcut process end    */
+
+			/*      unknow unicast control  */
+#if defined(CONFIG_RTL_UNKOWN_UNICAST_CONTROL)
+			rtl_unkownUnicastUpdate(skb);
+#endif
+#if !defined(CONFIG_RTL_BRSHORTCUT_LINUX_VLAN_CTL)
+#ifdef CONFIG_RTL_VLAN_8021Q
+		}
+#endif
+#endif
+		/*      unknow unicast control end      */
+	}
+#if defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	if ((mCastFlag = rtl_isMcastPkt(skb)) != 0 || type != 0)	/*  multicast               */
+#else
+	if ((mCastFlag = rtl_isMcastPkt(skb)) != 0)	/*  multicast               */
+#endif
+
+	{
+		/*      multicast process       */
+#if defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+		/* rtl_MulticastRxCheck(skb, cp_this, vid, pid); */
+		rtl_MulticastRxCheck(skb, info, mCastFlag);
+#endif /*end of CONFIG_RTL865X_IGMP_SNOOPING */
+		/*      multicast process end   */
+	}
+#endif
+
+#if 0				/* defined(CONFIG_RTL_STP) */
+RxToPs:
+#endif
+
+	/*      finally successfuly rx to protocol stack        */
+	rtl_processRxToProtcolStack(skb, cp_this);
+}
+
+#if defined(CONFIG_RTK_VOIP_QOS)
+int (*check_voip_channel_loading)(void);
+#endif
+
+__DRAM_FWD rtlInterruptRxData RxIntData;
+
+#if defined(CONFIG_RTK_VOIP_QOS) && !defined(CONFIG_RTK_VOIP_ETHERNET_DSP_IS_HOST)
+__IRAM_FWD
+	static inline int32 interrupt_dsr_rx_per_packe_check(rtlInterruptRxData
+	*rxData, unsigned long task_priv)
+{
+	if (((rxData->voip_rx_cnt++ > 100)
+			|| ((jiffies - rxData->voip_rx_start_time) >= 1))
+		&& (check_voip_channel_loading
+			&& (check_voip_channel_loading() > 0))) {
+#ifdef RX_TASKLET
+		/* avoid cp  change! */
+		tasklet_schedule(&((struct dev_priv *)task_priv)->
+			rx_dsr_tasklet);
+#endif
+		return RTL_RX_PROCESS_RETURN_BREAK;
+	}
+	return RTL_RX_PROCESS_RETURN_SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTK_VOIP_QOS) && !defined(CONFIG_RTK_VOIP_ETHERNET_DSP_IS_HOST)
+static inline int32 interrupt_dsr_rx_check(rtlInterruptRxData *rxData)
+{
+	rxData->voip_rx_start_time = jiffies;
+	rxData->voip_rx_cnt = 0;
+	return RTL_RX_PROCESS_RETURN_SUCCESS;
+}
+#endif
+
+__IRAM_FWD static void interrupt_dsr_rx_done(rtlInterruptRxData *rxData)
+{
+#ifdef RX_TASKLET
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH(flags);
+	rtl_rxSetTxDone(TRUE);
+#if defined(CONFIG_RTL_8197F) &&  defined(CONFIG_FINETUNE_RUNOUT_IRQ)
+	REG32(CPUIIMR) |= RX_DONE_IE_ALL;
+	if (rtl865x_rxbufAvailable()) {
+		rtl865x_enableRunoutIrq();
+	}
+#else
+	REG32(CPUIIMR) |= (RX_DONE_IE_ALL | PKTHDR_DESC_RUNOUT_IE_ALL);
+#endif
+	rtl_rx_tasklet_running = 0;
+	SMP_UNLOCK_ETH(flags);
+#endif
+}
+
+__MIPS16 __IRAM_FWD
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+static int32 interrupt_dsr_rx(struct dev_priv *task_priv, uint32 budget)
+#else
+static int32 interrupt_dsr_rx(unsigned long task_priv)
+#endif
+{
+	static __DRAM_FWD rtl_nicRx_info info;
+	int ret, count, rx_ok = 0;
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+	uint32 rx_left;
+#endif
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+	SMP_LOCK_ETH_RECV(flags);
+#endif
+
+	/* int MAX_RX_NUM = 160; */
+
+	/* RTL_swNic_txDone(0); */
+
+#if defined(CONFIG_RTK_VOIP_QOS) && !defined(CONFIG_RTK_VOIP_ETHERNET_DSP_IS_HOST)
+	interrupt_dsr_rx_check(&RxIntData);
+#endif
+	rx_ok = 0;
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+	for (rx_left = budget; rx_left > 0; rx_left--)
+#else
+	while (1)
+#endif
+	{
+#if !defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+		if (rx_ok > (NUM_RX_PKTHDR_DESC))
+			break;
+#endif
+
+#if defined(CONFIG_RTK_VOIP_QOS) && !defined(CONFIG_RTK_VOIP_ETHERNET_DSP_IS_HOST)
+		if (RTL_RX_PROCESS_RETURN_BREAK ==
+			interrupt_dsr_rx_per_packe_check(&RxIntData, task_priv))
+			break;
+#endif
+
+#if defined(RTL_MULTIPLE_RX_TX_RING)
+		info.priority = RTL_ASSIGN_RX_PRIORITY;
+#endif
+
+		count = 0;
+		do {
+			ret = RTL_swNic_receive(&info, count++);
+		} while (ret == RTL_NICRX_REPEAT);
+		rx_ok++;
+
+		switch (rtl_processReceivedInfo(&info, ret)) {
+		case RTL_RX_PROCESS_RETURN_SUCCESS:
+			if (SUCCESS == rtl_decideRxDevice(&info)) {
+				rtl_processRxFrame(&info);
+			}
+			break;
+		case RTL_RX_PROCESS_RETURN_BREAK:
+			{
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+				rx_left++;
+#endif
+				goto rx_out;
+			}
+		default:
+			break;
+		}
+	}
+
+rx_out:
+/* panic_printk("%s:%d rx_ok=%d\n", __FUNCTION__, __LINE__, rx_ok); */
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_ETH_RECV(flags);
+#endif
+	interrupt_dsr_rx_done(&RxIntData);
+	return RTL_NICRX_OK;
+}
+
+__IRAM_FWD static void interrupt_dsr_tx(unsigned long task_priv)
+{
+	int32 idx;
+#ifdef TX_TASKLET
+	unsigned long flags = 0;
+#endif
+
+	for (idx = RTL865X_SWNIC_TXRING_MAX_PKTDESC - 1; idx >= 0; idx--) {
+		RTL_swNic_txDone(idx);
+	}
+
+	refill_rx_skb();
+#ifdef TX_TASKLET
+	SMP_LOCK_ETH(flags);
+	rtl_rxSetTxDone(TRUE);
+	rtl_tx_tasklet_running = 0;
+
+#if defined(CONFIG_RTL_8197F) &&  defined(CONFIG_FINETUNE_RUNOUT_IRQ)
+	if (rtl865x_rxbufAvailable()) {
+		rtl865x_enableRunoutIrq();
+	}
+#endif
+
+	SMP_UNLOCK_ETH(flags);
+#endif
+}
+
+#ifdef CONFIG_RTL8196C_ETH_IOT
+static int re865x_setPhyGrayCode(void)
+{
+	uint32 agc, cb0, snr, val;
+	uint32 DUT_eee, Linkpartner_eee;
+	int i;
+
+	for (i = 0; i < 5; i++) {
+
+		if ((curLinkPortMask & (1 << i)) != (newLinkPortMask & (1 << i))) {	/* port i link changed */
+
+			if (newLinkPortMask & (1 << i)) {	/* link up */
+
+				/*=========== ###03 ===========*/
+				/* read DUT eee 100 ability */
+				rtl8651_setAsicEthernetPHYReg(i, 13, 0x7);
+				rtl8651_setAsicEthernetPHYReg(i, 14, 0x3c);
+				rtl8651_setAsicEthernetPHYReg(i, 13, 0x4007);
+				rtl8651_getAsicEthernetPHYReg(i, 14, &DUT_eee);
+
+				/* read Link partner eee 100 ability */
+				rtl8651_setAsicEthernetPHYReg(i, 13, 0x7);
+				rtl8651_setAsicEthernetPHYReg(i, 14, 0x3d);
+				rtl8651_setAsicEthernetPHYReg(i, 13, 0x4007);
+				rtl8651_getAsicEthernetPHYReg(i, 14,
+					&Linkpartner_eee);
+
+				if ((((DUT_eee & 0x2)) != 0)
+					&& (((Linkpartner_eee & 0x2)) != 0)) {
+					rtl8651_getAsicEthernetPHYReg(i, 21,
+						&snr);
+					snr = snr | 0x4000;
+					rtl8651_setAsicEthernetPHYReg(i, 21,
+						snr);
+				}
+
+				if (((Linkpartner_eee & 0x2)) != 0)
+					port_linkpartner_eee |= (1 << i);
+				else
+					port_linkpartner_eee &= ~(1 << i);
+
+				/*=========== ###02 ===========*/
+				/*
+				 * 1.      reg17 = 0x1f10!Aread reg29, for SNR
+				 * 2.      reg17 =  0x1f11!Aread reg29, for AGC
+				 * 3.      reg17 = 0x1f18!Aread reg29, for cb0
+				 */
+				/* 1. for SNR */
+				snr = 0;
+				for (val = 0; val < 3; val++) {
+					rtl8651_getAsicEthernetPHYReg(i, 29,
+						&agc);
+					snr += agc;
+				}
+				snr = snr / 3;
+
+				/* 3. for cb0 */
+				rtl8651_getAsicEthernetPHYReg(i, 17, &val);
+				val = (val & 0xfff0) | 0x8;
+				rtl8651_setAsicEthernetPHYReg(i, 17, val);
+				rtl8651_getAsicEthernetPHYReg(i, 29, &cb0);
+
+				/* 2. for AGC */
+				val = (val & 0xfff0) | 0x1;
+				rtl8651_setAsicEthernetPHYReg(i, 17, val);
+				rtl8651_getAsicEthernetPHYReg(i, 29, &agc);
+
+				/* set bit 3~0 to 0x0 for reg 17 */
+				val = val & 0xfff0;
+				rtl8651_setAsicEthernetPHYReg(i, 17, val);
+
+				if (((((agc & 0x70) >> 4) < 4) && ((cb0 & 0x80) != 0)) || (snr > 4150)) {	/* "> 4150" = "< 18dB" */
+					rtl8651_restartAsicEthernetPHYNway(i);
+				}
+			} else {	/* link down */
+
+				/*=========== ###01 ===========*/
+				extern void set_gray_code_by_port(int);
+
+				/*=========== ###03 ===========*/
+				/* read DUT eee 100 ability */
+				rtl8651_setAsicEthernetPHYReg(i, 13, 0x7);
+				rtl8651_setAsicEthernetPHYReg(i, 14, 0x3c);
+				rtl8651_setAsicEthernetPHYReg(i, 13, 0x4007);
+				rtl8651_getAsicEthernetPHYReg(i, 14, &DUT_eee);
+
+				/* due to the RJ45 cable is plug out now, we can't read the eee 100 ability of link partner. */
+				/* we use the variable port_linkpartner_eee to keep link partner's eee 100 ability after RJ45 cable is plug in. */
+				if ((((DUT_eee & 0x2)) == 0)
+					|| ((port_linkpartner_eee & (1 << i)) ==
+						0)) {
+					rtl8651_getAsicEthernetPHYReg(i, 21,
+						&val);
+					val = val & ~(0x4000);
+					rtl8651_setAsicEthernetPHYReg(i, 21,
+						val);
+				}
+				set_gray_code_by_port(i);
+			}
+		}
+	}
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTL_PHY_PATCH)
+#define SNR_THRESHOLD 1000
+
+/* db = -(10 * log10(sum/262144)); */
+/* 18db:SNR_THRESHOLD=4155 */
+/* 20db:SNR_THRESHOLD=2621 */
+/* 21db:SNR_THRESHOLD=2082 */
+/* 22db:SNR_THRESHOLD=1654 */
+/* 24.18db:SNR_THRESHOLD=1000 */
+#define MAX_RESTART_NWAY_INTERVAL		(60*HZ)
+#define MAX_RESTART_NWAY_CNT		3
+
+struct rtl_nWayCtrl_s {
+	unsigned long restartNWayTime;
+	unsigned long restartNWayCnt;
+};
+
+struct rtl_nWayCtrl_s re865x_restartNWayCtrl[RTL8651_PHY_NUMBER];
+
+unsigned int re865x_getPhySnr(unsigned int port)
+{
+	unsigned int sum = 0;
+	unsigned int j;
+	unsigned int regData;
+
+	if (port >= RTL8651_PHY_NUMBER) {
+		return -1;
+	}
+
+	if (REG32(PSRP0 + (port * 4)) & PortStatusLinkUp) {
+		for (j = 0, sum = 0; j < 10; j++) {
+			rtl8651_getAsicEthernetPHYReg(port, 29, &regData);
+			sum += regData;
+			mdelay(10);
+		}
+		sum /= 10;
+		return sum;
+	}
+
+	return 0;
+}
+
+#if defined(CONFIG_RTL_8196C)
+#if 1
+int re865x_checkPhySnr(void)
+{
+
+	unsigned int port;
+	unsigned int snr = 0;
+	unsigned int val, cb0, agc;
+	for (port = 0; port < RTL8651_PHY_NUMBER; port++) {
+		if ((1 << port) & (newLinkPortMask & (~curLinkPortMask))) {
+			snr = re865x_getPhySnr(port);
+
+			/* 3. for cb0 */
+			rtl8651_getAsicEthernetPHYReg(port, 17, &val);
+			val = (val & 0xfff0) | 0x8;
+			rtl8651_setAsicEthernetPHYReg(port, 17, val);
+			rtl8651_getAsicEthernetPHYReg(port, 29, &cb0);
+
+			/* 2. for AGC */
+			val = (val & 0xfff0) | 0x1;
+			rtl8651_setAsicEthernetPHYReg(port, 17, val);
+			rtl8651_getAsicEthernetPHYReg(port, 29, &agc);
+			/* printk("snr is %d\n",snr); */
+			/* printk("cb0 is 0x%x,agc is 0x%x\n",cb0,agc); */
+			/* if( ((cb0 & 0x80) != 0)|| (snr>4155)) */
+			if (((((agc & 0x70) >> 4) < 4) && ((cb0 & 0x80) != 0))
+				|| (snr > 4155)) {
+				/* printk("restart nway\n"); */
+				rtl8651_restartAsicEthernetPHYNway(port);
+			}
+			val = val & 0xfff0;
+			rtl8651_setAsicEthernetPHYReg(port, 17, val);
+
+		}
+
+	}
+	return 0;
+
+}
+#else
+static int re865x_checkPhySnr(void)
+{
+
+	unsigned int port;
+	unsigned int snr = 0;
+
+	for (port = 0; port < RTL8651_PHY_NUMBER; port++) {
+		if ((1 << port) & (newLinkPortMask & (~curLinkPortMask))) {
+			snr = re865x_getPhySnr(port);
+			/* printk("%s:%d, port is %d, snr is %d\n",__FUNCTION__,__LINE__,port,snr); */
+			if (snr > SNR_THRESHOLD) {
+				/*poor snr, we should restart n-way */
+				if (re865x_restartNWayCtrl[port].
+					restartNWayTime == 0) {
+					/*last time snr is good */
+					re865x_restartNWayCtrl[port].
+						restartNWayTime = jiffies;
+					re865x_restartNWayCtrl[port].
+						restartNWayCnt = 1;
+
+					rtl8651_restartAsicEthernetPHYNway
+						(port);
+
+				} else if (time_after(jiffies,
+						re865x_restartNWayCtrl[port].
+						restartNWayTime +
+						MAX_RESTART_NWAY_INTERVAL)) {
+					/*last time SNR is bad, but interval is long enough, we can take another restart n-way action */
+					re865x_restartNWayCtrl[port].
+						restartNWayTime = jiffies;
+					re865x_restartNWayCtrl[port].
+						restartNWayCnt = 1;
+					rtl8651_restartAsicEthernetPHYNway
+						(port);
+
+				} else if (re865x_restartNWayCtrl[port].
+					restartNWayCnt > MAX_RESTART_NWAY_CNT) {
+					/*within restart n-way interval and exceed max try cnt */
+					/*shouldn't do it any more, otherwise it will cause phy link up/down repeatly */
+					/* printk("%s:%d,restartNWayCnt>MAX_RESTART_NWAY_CNT,stop do restart n-way\n",__FUNCTION__,__LINE__); */
+				} else {
+					/* printk("%s:%d,restartNWayCnt is %lu\n",__FUNCTION__,__LINE__,re865x_restartNWayCtrl[port].restartNWayCnt); */
+					re865x_restartNWayCtrl[port].
+						restartNWayCnt++;
+					rtl8651_restartAsicEthernetPHYNway
+						(port);
+				}
+			} else {
+				re865x_restartNWayCtrl[port].restartNWayTime =
+					0;
+				re865x_restartNWayCtrl[port].restartNWayCnt = 0;
+			}
+
+		}
+
+	}
+	return 0;
+
+}
+#endif
+#endif
+#endif
+
+unsigned int rtl865x_getPhysicalPortLinkStatus(void)
+{
+	unsigned int port_num = 0;
+	unsigned int linkPortMask = 0;
+	for (port_num = 0; port_num <= RTL8651_PHY_NUMBER; port_num++) {
+		if ((READ_MEM32(PSRP0 + (port_num << 2)) & PortStatusLinkUp) !=
+			0) {
+			linkPortMask |= 1 << port_num;
+		}
+
+	}
+	return linkPortMask;
+}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+static void rtd129x_send_uevent_work(struct work_struct *work)
+{
+	struct dev_priv *cp =
+		container_of((work), struct dev_priv, link_event_work);
+
+	if (cp->link_event == KOBJ_LINKUP) {
+		netif_carrier_on(cp->dev);
+		if (hwnat_gpio_link_led_enable &&
+			(strcmp(cp->dev->name, "eth0") == 0))
+			gpio_set_value(hwnat_gpio_link_led, 1);
+		pr_info("%s link up\n", cp->dev->name);
+	} else {
+		netif_carrier_off(cp->dev);
+		if (hwnat_gpio_link_led_enable &&
+			(strcmp(cp->dev->name, "eth0") == 0))
+			gpio_set_value(hwnat_gpio_link_led, 0);
+		pr_info("%s link down\n", cp->dev->name);
+	}
+	kobject_uevent(&cp->dev->dev.kobj, cp->link_event);
+}
+
+void rtd129x_send_uevent(unsigned int curportmask, unsigned int newportmask)
+{
+	int i;
+	struct dev_priv *cp = NULL;
+
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		cp = ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[i]));
+		if (_rtl86xx_dev.dev[i] && cp && cp->opened) {
+			if (((cp->portmask & curportmask) == 0)
+				&& (cp->portmask & newportmask)) {
+				cp->link_event = KOBJ_LINKUP;
+				schedule_work(&cp->link_event_work);
+			} else if ((cp->portmask & curportmask)
+				&& ((cp->portmask & newportmask) == 0)) {
+				cp->link_event = KOBJ_LINKDOWN;
+				schedule_work(&cp->link_event_work);
+			}
+		}
+	}
+}
+
+#if defined(CONFIG_RTL_836X_SUPPORT)
+#if defined(CONFIG_RTL_CPU_TAG) || defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)
+void rtd129x_update_link_status(void)
+{
+	newLinkPortMask = rtl836x_link_status_get();
+	rtd129x_send_uevent(curLinkPortMask, newLinkPortMask);
+	curLinkPortMask = newLinkPortMask;
+}
+#endif /* CONFIG_RTL_CPU_TAG || CONFIG_RTL_2_RGMII_PORTS_ONLY */
+#endif /* CONFIG_RTL_836X_SUPPORT */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTL_REPORT_LINK_STATUS)
+/* #if LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0) */
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+void rtl_signal_linkdetect(void);
+static struct sock *nl_eventd_sk = NULL;
+struct sock *get_nl_eventd_sk(void);
+struct sock *rtk_eventd_netlink_init(void);
+int get_nl_eventd_pid(void);
+void rtk_eventd_netlink_send(int pid, struct sock *nl_sk, int eventID,
+	char *ifname, char *data, int data_len);
+
+int rtl_event_indicate_api(unsigned int curLinkPortMask,
+	unsigned int newportmask)
+{
+	/* struct sock *nl_eventd_sk = NULL; */
+	int rtk_eventd_pid = 0;
+	char data[32] = { 0 };
+	int data_len = 0;
+
+	int event;
+	int portId = -1;
+	unsigned int offPortMask = 0;
+	unsigned int onPortMask = 0;
+	onPortMask = (newportmask & (~curLinkPortMask));
+	offPortMask = ((~newportmask) & curLinkPortMask);
+#define WIRE_PLUG_OFF 2
+#define WIRE_PLUG_ON 3
+	/* panic_printk("%x,%x,%x,%x[%s]:[%d].\n",newportmask,curLinkPortMask,offPortMask,onPortMask,__FUNCTION__,__LINE__); */
+
+	/*
+	 * if(!(nl_eventd_sk = get_nl_eventd_sk()))
+	 * {
+	 * nl_eventd_sk = rtk_eventd_netlink_init();
+	 * }
+	 */
+
+	rtk_eventd_pid = get_nl_eventd_pid();
+
+	if ((rtk_eventd_pid == 0) || (nl_eventd_sk == NULL)) {
+		/* panic_printk("%s:%d ERROR!###########\n",__FUNCTION__,__LINE__); */
+		return -1;
+	}
+	/* plug off */
+	if (offPortMask != 0) {
+		event = WIRE_PLUG_OFF;
+		portId = (ffs(offPortMask) - (1));
+		sprintf(data, "%x", portId);
+		data_len = strlen(data);
+		/* panic_printk("OFF:%x,%d,[%s]:[%d].\n",offPortMask,portId,__FUNCTION__,__LINE__); */
+		if (portId != -1)
+			rtk_eventd_netlink_send(rtk_eventd_pid, nl_eventd_sk,
+				event, NULL, data, data_len);
+	}
+	portId = -1;
+	/* plug on */
+	if (onPortMask != 0) {
+		event = WIRE_PLUG_ON;
+		portId = (ffs(onPortMask) - (1));
+		sprintf(data, "%x", portId);
+		data_len = strlen(data);
+
+		/* panic_printk("On:%x,%d,[%s]:[%d].\n",onPortMask,portId,__FUNCTION__,__LINE__); */
+		if (portId != -1)
+			rtk_eventd_netlink_send(rtk_eventd_pid, nl_eventd_sk,
+				event, NULL, data, data_len);
+	}
+
+	return 0;
+}
+#endif
+unsigned int rtl865x_setLinkEventFlag(unsigned int curLinkPortMask,
+	unsigned int newportmask)
+{
+	int i;
+	struct dev_priv *cp = NULL;
+
+#ifdef CONFIG_RTK_PORT_LINK
+	unsigned int status = 0;
+	struct net_device *dev = NULL;
+#define NETIFD_UPDOWN_BIT  16	/* NETIFD use bit 16 to mark port status */
+#define ETHERNET_EVENT_MASK  (1<<31)	/*bit 31 present ethernet link up/down event */
+
+	/* check which port's link status has changed */
+	for (i = 0; i < RTL8651_PHY_NUMBER; i++) {
+		/* check if link up or down */
+		status = 0;
+		/* panic_printk("\n curLinkPortMask is %x, newLinkPortMask is %x \n", curLinkPortMask,newLinkPortMask ); */
+		if (((curLinkPortMask & (1 << i)) == 0)
+			&& ((newLinkPortMask & (1 << i)) == (1 << i)))
+			status = 0x1 << NETIFD_UPDOWN_BIT;
+
+		if ((curLinkPortMask ^ newLinkPortMask) & (1 << i)) {
+			/* get interface net_device struct of link change port and send link change event to netifd */
+			if (rtl_get_net_device_by_port(&dev, i) == SUCCESS) {
+				status |= (1 << i);	/* add port number flags */
+				status |= ETHERNET_EVENT_MASK;	/*add ethernet event flags  */
+				ethernet_rtmsg_ifinfo(RTM_NEWLINK, dev, ~0U,
+					status);
+			}
+
+		}
+	}
+#endif
+/* #if LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0) */
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+	rtl_event_indicate_api(curLinkPortMask, newportmask);
+#endif
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		for (i = 0; i < ETH_INTF_NUM; i++) {
+			cp = ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.
+					dev[i]));
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT) || defined(CONFIG_RTD_1295_HWNAT)
+			if (_rtl86xx_dev.dev[i] && cp && cp->opened
+				&& rtl_isWanDev(cp))
+#else
+			if (cp && cp->opened && rtl_isWanDev(cp))
+#endif
+			{
+				/*#ifdef CONFIG_AUTO_DHCP_CHECK
+				 * if((newportmask & cp->portmask)^((curLinkPortMask & cp->portmask)))
+				 * {
+				 * rtl_signal_linkdetect();
+				 * }
+				 * #endif */
+				if (_rtl86xx_dev.dev[i]
+					&& ((cp->portmask & curLinkPortMask) ==
+						0)
+					&& (cp->portmask & newportmask)) {
+					rtk_linkEvent = 1;
+					return SUCCESS;
+				}
+			}
+		}
+	}
+	/*#ifdef CONFIG_AUTO_DHCP_CHECK
+	 * if(newportmask !=curLinkPortMask)
+	 * {
+	 * rtl_signal_linkdetect();
+	 * }
+	 * if(rtk_linkEvent)
+	 * return SUCCESS;
+	 * else
+	 * #endif */
+	return 0;
+}
+
+#endif
+
+#ifdef CONFIG_RTL_819X_SWCORE
+int cnt_swcore = 0;
+int cnt_swcore_tx = 0;
+int cnt_swcore_rx = 0;
+int cnt_swcore_link = 0;
+int cnt_swcore_err = 0;
+#endif
+
+#ifdef CONFIG_RTL_8198_ESD
+static uint32 phy_reg30[RTL8651_PHY_NUMBER] = { 0, 0, 0, 0, 0 };
+
+static int one_second_counter = 0;
+static int first_time_read_reg6 = 1;
+static int need_to_check_esd2 = 1;
+static int esd3_skip_one = 1;
+
+static inline int diff_more_than_1(uint32 a, uint32 b)
+{
+	uint32 c;
+
+	if (a == b)
+		return 0;
+	if (a < b) {
+		c = a;
+		a = b;
+		b = c;
+	}
+	if ((a - b) >= 2)
+		return 1;
+	else
+		return 0;
+}
+
+static int esd_recovery(void)
+{
+	uint32 val;
+	int i;
+
+	for (i = 0; i < RTL8651_PHY_NUMBER; i++) {
+		/************ Link down  ************/
+		if ((REG32(PSRP0 + (i * 4)) & PortStatusLinkUp) == 0) {
+			phy_reg30[i] = 0;
+		}
+		/************ Link up  ************/
+		else if (phy_reg30[i] == 0) {
+			rtl8651_getAsicEthernetPHYReg(i, 22, &val);
+			rtl8651_setAsicEthernetPHYReg(i, 22,
+				((val & (0xff00)) | 0x17));
+			rtl8651_getAsicEthernetPHYReg(i, 30, &val);
+			phy_reg30[i] = BIT(31) | (val & 0xfff);
+		}
+	}
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+/*
+krammer add this according to " Jim Hsieh/5458 "'s algorithm
+Description:
+when phy0's link partner link in force mode, we will force to half duplex mode,
+in this condition, if there is some traffic in port0's rx, sometimes port0 will die.
+so we add this patch, only work when phy0's link state change, if link partner
+is link in force mode, we will change our port0 into full duplex.
+*/
+void rtl819x_port0_force_refined(void)
+{
+	unsigned int regData;
+
+	if ((curLinkPortMask & 0x01) == (newLinkPortMask & 0x01)) {
+		/* no change -> return */
+		return;
+	}
+	/* default disable phy i/f(0xbb804104 b0=0) */
+	REG32(PCRP0) &= ~(EnablePHYIf);
+
+	/* if port#0=link up */
+	if (newLinkPortMask & 0x01) {
+		/* if AN =0(reg6[0]) */
+		rtl8651_getAsicEthernetPHYReg(rtl8651_tblAsicDrvPara.
+			externalPHYId[0], 6, &regData);
+		if ((regData & 0x01) == 0) {
+			rtl8651_getAsicEthernetPHYReg(rtl8651_tblAsicDrvPara.
+				externalPHYId[0], 5, &regData);
+			if (regData & 0x080) {	/* if spd = 100M(reg5[7]) */
+				/* force MAC 100M Full duplex */
+				/* (set 0xbb804104 b25=1 b24=1 b23=0 b20-19=1 b18=1 b17-16=0x3) */
+				regData = REG32(PCRP0);
+				regData |=
+					(EnForceMode | PollLinkStatus |
+					ForceDuplex | PauseFlowControlEtxErx);
+				regData &= ~(ForceLink | ForceSpeedMask);
+				regData |= (ForceSpeed100M);
+				/* panic_printk("phy0 link partner is force 100M, we force to 100M Full duplex!regData = 0x%x\n", regData); */
+				REG32(PCRP0) = regData;
+			} else if (regData & 0x20) {	/* else spd = 10M(reg5[5]) */
+				/* force MAC 10M Full duplex */
+				/* (set 0xbb804104 b25=1 b24=1 b23=0 b20-19=0 b18=1 b17-16=0x3) */
+				regData = REG32(PCRP0);
+				regData |=
+					(EnForceMode | PollLinkStatus |
+					ForceDuplex | PauseFlowControlEtxErx);
+				regData &= ~(ForceLink | ForceSpeedMask);
+				regData |= (ForceSpeed10M);
+				/* panic_printk("phy0 link partner is force 10M, we force to 10M Full duplex!regData = 0x%x\n", regData); */
+				REG32(PCRP0) = regData;
+			}
+		}
+		/* enable phy i/f */
+		/* set 0xbb804104 b0=1 */
+		REG32(PCRP0) |= EnablePHYIf;
+		/* panic_printk("phy0 link up, PCRP0 = 0x%x\n", REG32(PCRP0)); */
+	} else {		/* if port#0=link down */
+		/* recovery MAC AN setting and disable phy i/f */
+		/* (set 0xbb804104 b25=0 b20-18 0x7 b0=0) */
+		regData = REG32(PCRP0);
+		regData &= ~(EnForceMode | EnablePHYIf);
+		regData |= (ForceSpeed1000M | ForceDuplex);
+		/* panic_printk("phy0 link down, we reset phy0!regData = 0x%x\n", regData); */
+		REG32(PCRP0) = regData;
+	}
+}
+
+#if !defined(CONFIG_RTL_8367R_SUPPORT)
+#define CONFIG_RTK_CHECK_ETH_PORT_RX_HANG 1
+
+static uint32 AutoDownSpeed_10M[MAX_PORT_NUMBER];
+static uint32 DownSpeed_counter[MAX_PORT_NUMBER];
+static uint32 ReverSpeed_flag[MAX_PORT_NUMBER];
+static uint32 match_count[MAX_PORT_NUMBER];
+void Set_GPHYWB(uint32 phyid, uint32 page, uint32 reg, uint32 mask, uint32 val);
+
+#if defined(CONFIG_RTL_8211F_SUPPORT)
+#define CHECK_SNR_START_PORT	1
+#else
+#define CHECK_SNR_START_PORT	0
+#endif
+
+#ifdef CONFIG_RTK_CHECK_ETH_PORT_RX_HANG
+static uint64 pre_asic_rx_bytes[MAX_PORT_NUMBER];
+static uint64 pre_asic_tx_bytes[MAX_PORT_NUMBER];
+static uint32 count_no_rx[MAX_PORT_NUMBER];
+static uint32 count_tx_increase[MAX_PORT_NUMBER];
+static uint32 count_no_tx[MAX_PORT_NUMBER];
+int rtl819xD_check_eth_port_rx_hang(uint32 port);
+#endif
+
+#ifdef CONFIG_RTL_REPORT_LINK_STATUS
+#define _BLOCK_LINK_CHANGE() {block_link_change = RTK_BLOCK_LINK_CHANGE_PERIOD; }
+#else
+#define _BLOCK_LINK_CHANGE()
+#endif
+
+static int rtl819xD_check_phy_cb_snr(void)
+{
+	int curr_sts = 0;
+	uint32 val = 0, cb = 0, snr = 0, cache_lpi = 0;
+	uint8 cb_low = 0, cb_high = 0, link_speed_10M, port;
+	uint8 cb_flag, snr_flag, phyid;
+
+	for (port = CHECK_SNR_START_PORT; port < RTL8651_PHY_NUMBER; port++) {
+
+#ifdef CONFIG_RTK_CHECK_ETH_PORT_RX_HANG
+		if (!rtl819xD_check_eth_port_rx_hang(port))
+			continue;
+#endif
+
+		cb_flag = 0;
+		snr_flag = 0;
+
+		curr_sts = (REG32(PSRP0 + (port * 4)) & PortStatusLinkUp) >> 4;
+		/* PortStatusLinkSpeed10M */
+		if ((REG32(PSRP0 + (port * 4)) & PortStatusLinkSpeed_MASK) ==
+			PortStatusLinkSpeed10M)
+			link_speed_10M = 1;
+		else
+			link_speed_10M = 0;
+
+		/* link_speed_10M= (REG32(PSRP0 + (port * 4)) & PortStatusLinkSpeed10M); */
+
+		if (AutoDownSpeed_10M[port] == 0x12345678) {
+			DownSpeed_counter[port] = DownSpeed_counter[port] + 1;
+			if ((!curr_sts) && (ReverSpeed_flag[port] == 1)) {
+				REG32(PCRP0 + (port * 4)) |=
+					(NwayAbility1000MF | NwayAbility100MF |
+					NwayAbility100MH);
+				DownSpeed_counter[port] = 0;
+				AutoDownSpeed_10M[port] = 0;
+				ReverSpeed_flag[port] = 0;
+				match_count[port] = 0;
+				_BLOCK_LINK_CHANGE();
+				rtl8651_restartAsicEthernetPHYNway(port);
+				/* rtlglue_printf(" => check_cb_snr: port= %d, ph1\n", port); */
+			}
+			if ((!curr_sts) && (DownSpeed_counter[port] > 5)) {
+				REG32(PCRP0 + (port * 4)) |=
+					(NwayAbility1000MF | NwayAbility100MF |
+					NwayAbility100MH);
+				DownSpeed_counter[port] = 0;
+				AutoDownSpeed_10M[port] = 0;
+				ReverSpeed_flag[port] = 0;
+				match_count[port] = 0;
+				_BLOCK_LINK_CHANGE();
+				rtl8651_restartAsicEthernetPHYNway(port);
+				/* rtlglue_printf(" => check_cb_snr: port= %d, ph2\n", port); */
+			} else if (curr_sts && (DownSpeed_counter[port] < 5)) {
+				/* Connect to 10M Successfully */
+				ReverSpeed_flag[port] = 1;
+				/* rtlglue_printf(" => check_cb_snr: port= %d, ph3\n", port); */
+			}
+		} else {
+			AutoDownSpeed_10M[port] = 0;
+			DownSpeed_counter[port] = 0;
+			ReverSpeed_flag[port] = 0;
+		}
+
+		if ((curr_sts == 1) && (!link_speed_10M)) {
+
+			phyid = rtl8651AsicEthernetTable[port].phyId;
+			/* Read CB (bit[15]&[7])==1 */
+			rtl8651_setAsicEthernetPHYReg(phyid, 25, (0x6964));
+			rtl8651_getAsicEthernetPHYReg(phyid, 26, &val);
+			rtl8651_setAsicEthernetPHYReg(phyid, 26, ((val & 0xBF00) | 0x9E));	/* Close new_SD. */
+			rtl8651_getAsicEthernetPHYReg(phyid, 17, &val);
+			rtl8651_setAsicEthernetPHYReg(phyid, 17, ((val & 0xFFF0) | 0x8));	/* CB bit */
+			rtl8651_getAsicEthernetPHYReg(phyid, 29, &cb);
+
+			cb_low = cb & 0xff;
+			cb_high = (cb & 0xff00) >> 8;
+			if ((((cb & (1 << 15)) >> 15) || (cb_high <= 5))
+				&& (((cb & (1 << 7)) >> 7) || (cb_low <= 5))) {
+				cb_flag = 1;
+				match_count[port]++;
+				_BLOCK_LINK_CHANGE();
+				rtl8651_restartAsicEthernetPHYNway(port);
+				/* rtlglue_printf("AN1-->cb\r\n" ); */
+			}
+			rtl8651_setAsicEthernetPHYReg(phyid, 25, (0x6964));
+			rtl8651_getAsicEthernetPHYReg(phyid, 26, &val);
+			rtl8651_setAsicEthernetPHYReg(phyid, 26, ((val & 0xBF00) | 0x9E));	/* Close new_SD. */
+			rtl8651_getAsicEthernetPHYReg(phyid, 17, &val);
+			rtl8651_setAsicEthernetPHYReg(phyid, 17, ((val & 0xFFF0)));	/* SNR bit */
+			rtl8651_getAsicEthernetPHYReg(phyid, 29, &snr);
+			if (snr > 0x1000) {
+				if (cb_flag == 0) {
+					snr_flag = 1;
+					match_count[port]++;
+					_BLOCK_LINK_CHANGE();
+					rtl8651_restartAsicEthernetPHYNway
+						(port);
+					/* rtlglue_printf("AN2-->snr\r\n" ); */
+				}
+			}
+			/* panic_printk("cb:%x snr:%x\r\n",cb,snr ); */
+			rtl8651_setAsicEthernetPHYReg(phyid, 25, (0x2040));
+			rtl8651_getAsicEthernetPHYReg(phyid, 26, &val);
+			rtl8651_setAsicEthernetPHYReg(phyid, 26, ((val & 0xBF00) | 0x0c));	/* Close new_SD. */
+			Set_GPHYWB(port, 4, 25, 0xffff - (0xf << 0), 0x3 << 0);
+			rtl8651_getAsicEthernetPHYReg(phyid, 29, &cache_lpi);
+
+			if (cache_lpi & 0x60) {
+				if ((cb_flag == 0) && (snr_flag == 0)) {
+					match_count[port]++;
+					_BLOCK_LINK_CHANGE();
+					rtl8651_restartAsicEthernetPHYNway
+						(port);
+					/* rtlglue_printf("AN3-->cache_lpi\r\n" ); */
+				}
+			}
+
+			if (match_count[port] >= 5) {
+				REG32(PCRP0 + (port * 4)) &=
+					~(NwayAbility1000MF | NwayAbility100MF |
+					NwayAbility100MH);
+				_BLOCK_LINK_CHANGE();
+#if defined(CONFIG_RTL_LONG_ETH_CABLE_REFINE)
+				local_bh_disable();
+				fe_ads[port].down_speed_renway = 1;
+				fe_ads[port].cb_snr_cache_lpi_down_speed = 1;	/* for debug only */
+				local_bh_enable();
+#endif
+				rtl8651_restartAsicEthernetPHYNway(port);
+				AutoDownSpeed_10M[port] = 0x12345678;
+				DownSpeed_counter[port] = 0;
+				ReverSpeed_flag[port] = 0;
+				match_count[port] = 0;
+				/* rtlglue_printf("Down speed to 10M for port %d\n", port); */
+			}
+		}
+	}
+	return 0;
+}
+
+#ifdef CONFIG_RTK_CHECK_ETH_PORT_RX_HANG
+uint64 rtl819xD_get_trx_bytes(uint32 port, int direction)
+{
+	uint32 addrOffset_fromP0 = port * MIB_ADDROFFSETBYPORT;
+
+	if (port > RTL8651_PORT_NUMBER)
+		return 0;
+
+	if (0 == direction)
+		return rtl865xC_returnAsicCounter64(OFFSET_IFINOCTETS_P0 +
+			addrOffset_fromP0);
+
+	if (1 == direction)
+		return rtl865xC_returnAsicCounter64(OFFSET_IFOUTOCTETS_P0 +
+			addrOffset_fromP0);
+
+	return 0;
+}
+
+int rtl819xD_check_eth_port_rx_hang(uint32 port)
+{
+	uint64 asic_rx_bytes;
+	uint64 asic_tx_bytes;
+
+	/*If eth port link down. do not check */
+	if ((REG32(PSRP0 + (port * 4)) & PortStatusLinkUp) == 0)
+		return 2;
+
+	asic_rx_bytes = rtl819xD_get_trx_bytes(port, 0);
+	asic_tx_bytes = rtl819xD_get_trx_bytes(port, 1);
+
+	/* diag_printf("rx %llu tx %llu\n",asic_rx_bytes,asic_tx_bytes); */
+	/* diag_printf("pre rx %llu pre tx %llu\n",pre_asic_rx_bytes,pre_asic_tx_bytes); */
+
+	if (asic_rx_bytes == pre_asic_rx_bytes[port]) {
+		count_no_rx[port]++;
+		if (asic_tx_bytes == pre_asic_tx_bytes[port]) {
+			count_no_tx[port]++;
+		} else {
+			count_tx_increase[port]++;
+		}
+	} else {
+		count_no_rx[port] = 0;
+		count_tx_increase[port] = 0;
+	}
+
+	pre_asic_rx_bytes[port] = asic_rx_bytes;
+	pre_asic_tx_bytes[port] = asic_tx_bytes;
+
+	/* diag_printf("count_no_rx %d count_tx_increase %d\n",count_no_rx,count_tx_increase); */
+	/*never see rx in 20 seconds but there is tx exists */
+	/* if ((count_no_rx[port]>20) && (count_tx_increase[port]>1)) { */
+	if (count_no_rx[port] > 20) {
+		/*recount */
+		count_no_rx[port] = 0;
+		count_tx_increase[port] = 0;
+		return 1;
+	}
+
+	return 0;
+}
+#endif
+
+#endif /* end of #if defined(CONFIG_RTL_8367R_SUPPORT) */
+
+#endif /* end of #if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) */
+
+#if defined(CONFIG_RTL_8881A)
+#define SNR_DOWN_SPEED_THRESHOLD	0x4E0
+#elif defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+#define SNR_DOWN_SPEED_THRESHOLD	0x800
+#elif defined(CONFIG_RTL_8197F) || defined(CONFIG_RTL_8196C)
+#define SNR_DOWN_SPEED_THRESHOLD	0x660
+#endif
+
+#if defined(CONFIG_RTL_LONG_ETH_CABLE_REFINE)
+/*
+ * this function is for the port can linked with long cable, but link quality is poor.
+ * there are 2 results: link down (and link up / link down again and again)
+ *     or keep linked but Tx/Rx packet do not work.
+ * we can check cb and snr, and then down speed to 10M when it reach the criteria.
+ */
+static int long_cable_check_with_linked(uint32 port)
+{
+	uint32 val = 0, cb = 0, snr = 0, snr_tmp = 0;
+	int i, phyid;
+	uint8 cb_low = 0;
+
+	if ((REG32(PSRP0 + (port * 4)) & PortStatusLinkSpeed_MASK) ==
+		PortStatusLinkSpeed10M)
+		return SUCCESS;
+
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+	rtl8651_setAsicEthernetPHYReg(phyid, 25, (0x6964));
+	rtl8651_getAsicEthernetPHYReg(phyid, 26, &val);
+	rtl8651_setAsicEthernetPHYReg(phyid, 26, ((val & 0xBF00) | 0x9E));	/* Close new_SD. */
+	rtl8651_getAsicEthernetPHYReg(phyid, 17, &val);
+	rtl8651_setAsicEthernetPHYReg(phyid, 17, ((val & 0xFFF0) | 0x8));
+	rtl8651_getAsicEthernetPHYReg(phyid, 29, &cb);
+
+	cb_low = cb & 0xff;
+	if (_debug_flag & _DEBUG_ETH_PHY)
+		rtlglue_printf(" ==> port[%d] link up, cb_low= 0x%x\n", port,
+			cb_low);
+
+	if (!((cb_low & 0x80) && (cb_low <= 0xfa)))
+		return SUCCESS;
+
+	for (i = 0; i < 10; i++) {
+		rtl8651_setAsicEthernetPHYReg(phyid, 25, (0x6964));
+		rtl8651_getAsicEthernetPHYReg(phyid, 26, &val);
+		rtl8651_setAsicEthernetPHYReg(phyid, 26, ((val & 0xBF00) | 0x9E));	/* Close new_SD. */
+		rtl8651_getAsicEthernetPHYReg(phyid, 17, &val);
+		rtl8651_setAsicEthernetPHYReg(phyid, 17, ((val & 0xFFF0)));
+		rtl8651_getAsicEthernetPHYReg(phyid, 29, &snr_tmp);
+
+		snr += snr_tmp;
+	}
+	snr = snr / 10;
+
+	if (_debug_flag & _DEBUG_ETH_PHY)
+		rtlglue_printf(" ==> port[%d]: snr= 0x%x\n", port, snr);
+
+	if (snr >= SNR_DOWN_SPEED_THRESHOLD) {
+		REG32(PCRP0 + (port * 4)) &=
+			~(NwayAbility1000MF | NwayAbility100MF |
+			NwayAbility100MH);
+		local_bh_disable();
+		fe_ads[port].down_speed_renway = 1;
+		fe_ads[port].cb_snr_down_speed = 1;	/* for debug only */
+		local_bh_enable();
+		rtl8651_restartAsicEthernetPHYNway(port);
+		/* rtlglue_printf("port %d down speed to 10M by cb and snr!\n", port); */
+	}
+	return SUCCESS;
+}
+
+static int long_cable_check(void)
+{
+	uint32 port;
+
+	/* Check each port. */
+	for (port = ADS_PORT_START; port < RTL8651_PHY_NUMBER; port++) {
+		/* Read Port Status Register to know the port is link-up or link-down. */
+		if (((REG32(PSRP0 + (port * 4))) & PortStatusLinkUp) == FALSE) {
+			/* Link is down. */
+			if ((1 << port) & curLinkPortMask) {
+				local_bh_disable();
+				if (fe_ads[port].down_speed_renway == 0) {
+					/* rtlglue_printf("Port[%d] link down, down_speed_renway is %d\n", port, fe_ads[port].down_speed_renway); */
+					if (!(REG32(PCRP0 + (port * 4)) &
+							EnForceMode))
+						REG32(PCRP0 + (port * 4)) |=
+							(NwayAbility1000MF |
+							NwayAbility100MF |
+							NwayAbility100MH);
+					fe_ads[port].cb_snr_down_speed = 0;
+					fe_ads[port].
+						cb_snr_cache_lpi_down_speed = 0;
+				} else {
+					/* this link down is caused by calling rtl8651_restartAsicEthernetPHYNway() func in long_cable_check_with_linked()
+					 *              or by calling rtl8651_restartAsicEthernetPHYNway() func in rtl819xD_check_phy_cb_snr().
+					 * do not set 100M Ability in PCR
+					 */
+					/* rtlglue_printf("Port[%d] link down, down_speed_renway is %d\n", port, fe_ads[port].down_speed_renway); */
+					fe_ads[port].down_speed_renway = 0;
+				}
+				local_bh_enable();
+			}
+		} else {
+			/* Link is up. */
+			if (((1 << port) & curLinkPortMask) == 0)
+				long_cable_check_with_linked(port);
+		}
+	}
+	return SUCCESS;
+}
+#endif
+
+#ifdef CONFIG_RTL_8198C_10M_REFINE
+int32 rtl8198c_10M_refine(uint32 old_sts, uint32 new_sts)
+{
+	int32 i, phyid;
+	uint32 data;
+
+	if (old_sts == new_sts)
+		return SUCCESS;
+
+	for (i = 0; i < 5; i++) {
+		if ((old_sts & BIT(i)) != (new_sts & BIT(i))) {	/* port i link status changed */
+
+			if (new_sts & BIT(i)) {	/* link up */
+				phyid = rtl8651AsicEthernetTable[i].phyId;
+
+				rtl8651_setAsicEthernetPHYReg(phyid, 31, 0xbcc);
+				rtl8651_getAsicEthernetPHYReg(phyid, 16, &data);
+				rtl8651_setAsicEthernetPHYReg(phyid, 16,
+					(data | BIT(3)));
+				rtl8651_getAsicEthernetPHYReg(phyid, 18, &data);
+				if ((REG32(PSRP0 + (i * 4)) & 0x3) == 0) {	/* 10M */
+					rtl8651_setAsicEthernetPHYReg(phyid, 18,
+						((data & 0x00ff) | 0xcc00));
+				} else {	/* 100M or Giga */
+					rtl8651_setAsicEthernetPHYReg(phyid, 18,
+						(data & 0x00ff));
+				}
+				rtl8651_setAsicEthernetPHYReg(phyid, 31, 0);
+			} else {	/* link down */
+				phyid = rtl8651AsicEthernetTable[i].phyId;
+				rtl8651_setAsicEthernetPHYReg(phyid, 31, 0xbcc);
+				rtl8651_getAsicEthernetPHYReg(phyid, 18, &data);
+				rtl8651_setAsicEthernetPHYReg(phyid, 18,
+					(data & 0x00ff));
+				rtl8651_setAsicEthernetPHYReg(phyid, 31, 0);
+			}
+
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#if 0
+void clearL2Table_forLinkDownPort(uint32 old_sts, uint32 new_sts)
+{
+	int32 i;
+
+	if (old_sts != new_sts)
+		for (i = 0; i < 5; i++) {
+			if (((old_sts & BIT(i)) != (new_sts & BIT(i))) &&
+				(!(new_sts & BIT(i)))) {
+				_rtl865x_ClearFDBEntryByPort(i);
+			}
+		}
+}
+#endif
+
+static void interrupt_dsr_link(unsigned long task_priv)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	unsigned long flags = 0;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#ifdef CONFIG_RTL_8198_ESD
+	esd_recovery();
+#endif
+
+#if !defined(CONFIG_RTL_CPU_TAG)
+	newLinkPortMask = rtl865x_getPhysicalPortLinkStatus();
+#endif /* !CONFIG_RTL_CPU_TAG */
+
+	/* clearL2Table_forLinkDownPort(curLinkPortMask, newLinkPortMask); */
+
+#ifdef CONFIG_RTL8196C_ETH_IOT
+	re865x_setPhyGrayCode();
+#endif
+
+#ifdef CONFIG_RTL_8197D_DYN_THR
+	rtl819x_setQosThreshold(curLinkPortMask, newLinkPortMask);
+#endif
+
+#if defined(CONFIG_RTL_REPORT_LINK_STATUS)
+/* rtl865x_setLinkStatusFlag(newLinkPortMask); */
+	if (block_link_change == 0)
+		rtl865x_setLinkEventFlag(curLinkPortMask, newLinkPortMask);
+#endif
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+	rtl865x_igmpSyncLinkStatus();
+#endif
+
+#if defined(CONFIG_RTL_LINKCHG_PROCESS)
+	rtl865x_LinkChange_Process();
+#endif
+
+#if defined(CONFIG_RTL_LONG_ETH_CABLE_REFINE)
+	long_cable_check();
+#endif
+
+#if 0				/* defined(CONFIG_RTL_8196C) && defined(CONFIG_RTL_PHY_PATCH) */
+	/* re865x_checkPhySnr() function is done in re865x_setPhyGrayCode() funtion. */
+	re865x_checkPhySnr();
+#endif
+
+#if defined(CONFIG_RTL_819XD)
+	if (rtl_port0Refined == 1) {
+		rtl819x_port0_force_refined();
+	}
+#endif
+
+#ifdef CONFIG_RTL_8198C_10M_REFINE
+	rtl8198c_10M_refine(curLinkPortMask, newLinkPortMask);
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if !defined(CONFIG_RTL_CPU_TAG)
+	rtd129x_send_uevent(curLinkPortMask, newLinkPortMask);
+#endif /* !CONFIG_RTL_CPU_TAG */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if !defined(CONFIG_RTL_CPU_TAG)
+	curLinkPortMask = newLinkPortMask;
+#endif /* !CONFIG_RTL_CPU_TAG */
+
+#ifdef LINK_TASKLET
+#if defined(CONFIG_RTD_1295_HWNAT)
+	SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	REG32(CPUIIMR) |= (LINK_CHANGE_IP);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	SMP_UNLOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+	return;
+}
+
+__IRAM_GEN static inline void rtl_rx_interrupt_process(unsigned int status,
+	struct dev_priv *cp)
+{
+#if defined(REINIT_SWITCH_CORE)
+	if (rtl865x_duringReInitSwtichCore == 1) {
+		return;
+	}
+#endif
+
+#ifdef CONFIG_RTL_8197F
+	if (status & (RX_DONE_IP_ALL | PKTHDR_DESC_RUNOUT_IP_ALL))
+#else
+	/* if (status & (RX_DONE_IP_ALL | PKTHDR_DESC_RUNOUT_IP_ALL)) */
+#endif
+	{
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+#if defined(CONFIG_RTD_1295_HWNAT)
+		unsigned long flags = 0;
+
+		SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		if ((rtl_rx_tasklet_running == 0) && (cp->napi.poll)) {
+			rtl_rx_tasklet_running = 1;
+			REG32(CPUIIMR) &=
+				~(RX_DONE_IE_ALL | PKTHDR_DESC_RUNOUT_IE_ALL);
+			rtl_rxSetTxDone(FALSE);
+
+			tasklet_hi_schedule(&cp->rx_dsr_tasklet);
+		}
+#if defined(CONFIG_RTD_1295_HWNAT)
+		SMP_UNLOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#else
+#if defined(RX_TASKLET)
+#if defined(CONFIG_RTD_1295_HWNAT)
+		unsigned long flags = 0;
+
+		SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		if (rtl_rx_tasklet_running == 0) {
+			rtl_rx_tasklet_running = 1;
+			REG32(CPUIIMR) &=
+				~(RX_DONE_IE_ALL | PKTHDR_DESC_RUNOUT_IE_ALL);
+			rtl_rxSetTxDone(FALSE);
+			tasklet_hi_schedule(&cp->rx_dsr_tasklet);
+		}
+#if defined(CONFIG_RTD_1295_HWNAT)
+		SMP_UNLOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#else
+		interrupt_dsr_rx((unsigned long)cp);
+#endif
+#endif
+	}
+}
+
+__IRAM_GEN static inline void rtl_tx_interrupt_process(unsigned int status,
+	struct dev_priv *cp)
+{
+	if (status & TX_ALL_DONE_IP_ALL) {
+#if defined(TX_TASKLET)
+#if defined(CONFIG_RTD_1295_HWNAT)
+		unsigned long flags = 0;
+
+		SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		if (rtl_tx_tasklet_running == 0) {
+			rtl_tx_tasklet_running = 1;
+			rtl_rxSetTxDone(FALSE);
+			tasklet_hi_schedule(&cp->tx_dsr_tasklet);
+		}
+#if defined(CONFIG_RTD_1295_HWNAT)
+		SMP_UNLOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#else
+		interrupt_dsr_tx((unsigned long)cp);
+#endif
+	}
+}
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_RTL_LINKCHG_PROCESS) || defined(CONFIG_RTL_PHY_PATCH) || defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+__IRAM_GEN static inline void rtl_link_change_interrupt_process(unsigned int
+	status, struct dev_priv *cp)
+{
+	if (status & LINK_CHANGE_IP) {
+#if defined(LINK_TASKLET)
+#if defined(CONFIG_RTD_1295_HWNAT)
+		unsigned long flags = 0;
+
+		SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		REG32(CPUIIMR) &= ~LINK_CHANGE_IP;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		SMP_UNLOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		tasklet_schedule(&cp->link_dsr_tasklet);
+#else
+		interrupt_dsr_link((unsigned long)cp);
+#endif
+#ifdef CONFIG_RTK_VOIP_PORT_LINK
+		if (cp->opened)
+			rtmsg_ifinfo_voip(RTM_LINKCHANGE, cp->dev, ~0U);
+#endif
+	}
+}
+#endif
+
+__MIPS16 __IRAM_FWD irqreturn_t interrupt_isr(int irq, void *dev_instance)
+{
+	struct net_device *dev = dev_instance;
+	struct dev_priv *cp;
+	unsigned int status, old_status;
+	cp = NETDRV_PRIV(dev);
+	status = REG32(CPUIISR);
+	old_status = status;
+	status &= REG32(CPUIIMR);
+
+#ifdef CONFIG_RTL_819X_SWCORE
+	cnt_swcore++;
+	if (status & (RX_DONE_IP_ALL))
+		cnt_swcore_rx++;
+	if (status & TX_ALL_DONE_IP_ALL)
+		cnt_swcore_tx++;
+	if (status & LINK_CHANGE_IP)
+		cnt_swcore_link++;
+	if (status & (PKTHDR_DESC_RUNOUT_IP_ALL | MBUF_DESC_RUNOUT_IP_ALL))
+		cnt_swcore_err++;
+#endif
+
+#if defined(CONFIG_RTL_8197F) &&  defined(CONFIG_FINETUNE_RUNOUT_IRQ)
+	if (status & (PKTHDR_DESC_RUNOUT_IP_ALL | MBUF_DESC_RUNOUT_IP_ALL)) {
+		rtl865x_disableRunoutIrq();
+	}
+#endif
+
+	rtl_rx_interrupt_process(status, cp);
+
+	rtl_tx_interrupt_process(status, cp);
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING) || defined(CONFIG_RTL_LINKCHG_PROCESS) || defined(CONFIG_RTL_PHY_PATCH) || defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT) || defined(CONFIG_RTL_8198C_10M_REFINE)
+	if (status & LINK_CHANGE_IP)
+		rtl_link_change_interrupt_process(status, cp);
+#endif
+
+	REG32(CPUIISR) = old_status;
+
+	return IRQ_HANDLED;
+}
+
+static int rtl865x_init_hw(void)
+{
+	unsigned int mbufRingSize;
+	int i, ret;
+
+	mbufRingSize = rtl865x_rxSkbPktHdrDescNum;	/* rx ring 0    */
+	for (i = 1; i < RTL865X_SWNIC_RXRING_HW_PKTDESC; i++) {
+		mbufRingSize += rxRingSize[i];
+	}
+
+	/* Initialize NIC module */
+	ret = RTL_swNic_init(rxRingSize, mbufRingSize, txRingSize, MBUF_LEN);
+
+	if (ret != SUCCESS) {
+		printk("819x-nic: swNic_init failed!\n");
+		return FAILED;
+	}
+	return SUCCESS;
+}
+
+#ifdef CONFIG_RTL_HARDWARE_NAT
+static void reset_hw_mib_counter(struct net_device *dev)
+{
+	int i, port;
+	int32 totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		1;
+	uint32 set_value = 0;
+
+#if defined(CONFIG_RTL_8370_SUPPORT)
+	extern int rtk_stat_port_reset(int port);
+	if (dev->name[3] == '0') {	/* eth0 */
+		for (port = 0; port < 8; port++)
+			rtk_stat_port_reset(port);
+	} else if (dev->name[3] == '1') {	/* eth1 */
+		rtk_stat_port_reset(RTL83XX_WAN);
+	}
+	return;
+#endif
+
+	for (i = 0; i < totalVlans; i++) {
+		if (IF_ETHER != vlanconfig[i].if_type) {
+			continue;
+		}
+		if (!memcmp(vlanconfig[i].mac.octet, dev->dev_addr, 6)) {
+			for (port = 0; port < RTL8651_AGGREGATOR_NUMBER; port++) {
+				if (vlanconfig[i].memPort & (1 << port)) {
+					/* WRITE_MEM32(MIB_CONTROL, (1<<port*2) | (1<<(port*2+1))); */
+					set_value |=
+						((1 << port * 2) | (1 << (port *
+								2 + 1)));
+#ifdef CONFIG_RTL_8367R_SUPPORT
+					{
+						extern int
+							rtk_stat_port_reset(int
+							port);
+						rtk_stat_port_reset(port);
+					}
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_CPU_TAG) && defined(CONFIG_RTL_836X_SUPPORT)
+					spin_lock(&rtl836x_ext_lock);
+					rtk_stat_port_reset(rtl836x_portmap(port));
+					spin_unlock(&rtl836x_ext_lock);
+#elif defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)
+					if (port == 0) {
+						spin_lock(&rtl836x_ext_lock);
+						rtk_stat_port_reset(rtl836x_portmap(0));
+						rtk_stat_port_reset(rtl836x_portmap(1));
+						rtk_stat_port_reset(rtl836x_portmap(2));
+						rtk_stat_port_reset(rtl836x_portmap(3));
+						spin_unlock(&rtl836x_ext_lock);
+					} else if (port == 5) {
+						spin_lock(&rtl836x_ext_lock);
+						rtk_stat_port_reset(rtl836x_portmap(5));
+						spin_unlock(&rtl836x_ext_lock);
+					}
+#endif /* CONFIG_RTL_CPU_TAG && CONFIG_RTL_836X_SUPPORT */
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+				}
+				WRITE_MEM32(MIB_CONTROL, set_value);
+			}
+			return;
+		}
+	}
+}
+#endif
+#if defined(CONFIG_RTL_8197D)
+/* extern void rtl819x_poll_sw(void); */
+#endif
+#ifdef CONFIG_RTL8196C_GREEN_ETHERNET
+int total_time_for_5_port = 15 * HZ;
+int port_pwr_save_low = 0;
+#endif
+
+#ifdef CONFIG_RTL_8196E
+void refine_phy_setting(void)
+{
+	int i, start_port = 0;
+	uint32 val;
+
+	val = (REG32(BOND_OPTION) & BOND_ID_MASK);
+	if ((val == BOND_8196ES) || (val == BOND_8196ES1)
+		|| (val == BOND_8196ES2) || (val == BOND_8196ES3))
+		return;
+
+	if ((val == BOND_8196EU) || (val == BOND_8196EU1)
+		|| (val == BOND_8196EU2) || (val == BOND_8196EU3))
+		start_port = 4;
+
+	for (i = start_port; i < 5; i++) {
+		rtl8651_setAsicEthernetPHYReg(i, 25, 0x6964);
+		rtl8651_getAsicEthernetPHYReg(i, 26, &val);
+		rtl8651_setAsicEthernetPHYReg(i, 26, ((val & (0xff00)) | 0x9E));
+
+		rtl8651_getAsicEthernetPHYReg(i, 17, &val);
+		rtl8651_setAsicEthernetPHYReg(i, 17, ((val & (0xfff0)) | 0x8));
+
+		rtl8651_getAsicEthernetPHYReg(i, 29, &val);
+		if ((val & 0x8080) == 0x8080) {
+			rtl8651_getAsicEthernetPHYReg(i, 21, &val);
+			rtl8651_setAsicEthernetPHYReg(i, 21, (val | 0x8000));
+			rtl8651_setAsicEthernetPHYReg(i, 21, (val & ~0x8000));
+		}
+	}
+	return;
+}
+#endif
+
+#if defined(CONFIG_RTL_IVL_SUPPORT)
+uint32 port_link_sts2 = 0;
+
+int flush_l2(void)
+{
+	int port;
+	uint32 cur_link_sts = 0;
+
+	for (port = 0; port < 5; port++) {
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+		uint32 phyData;
+		extern int rtl8367b_getAsicPHYReg(unsigned int phyNo,
+			unsigned int phyAddr, unsigned int *pRegData);
+		/*Get PHY status register */
+		if (0 != rtl8367b_getAsicPHYReg(port, 1 /* PHY_STATUS_REG */,
+				&phyData))
+			return (-1);
+
+		/*check link status */
+		if (phyData & (1 << 2))
+			cur_link_sts |= (1 << port);
+#else
+		if ((REG32(PSRP0 + (port * 4)) & PortStatusLinkUp) != 0) {
+			cur_link_sts |= (1 << port);
+		}
+#endif
+	}
+
+	if (port_link_sts2 != cur_link_sts) {
+		/* clear wan port entries in SoC L2 table */
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+		if ((cur_link_sts & (1 << RTL83XX_WAN)) && (cur_link_sts & (0x1f & ~(1 << RTL83XX_WAN))))	/* wan is up and "one of LANs" is link up */
+		{
+			extern int32 _rtl865x_ClearFDBEntryByPort(int32
+				port_num);
+			_rtl865x_ClearFDBEntryByPort(RTL83XX_WAN);
+		}
+#else
+#if defined(CONFIG_RTD_1295_HWNAT)
+		if ((cur_link_sts & (vlanconfig[RTL_WAN_IDX].memPort))
+			&& (cur_link_sts & (0x1f
+			& ~(vlanconfig[RTL_WAN_IDX].memPort))))	/* wan is up and "one of LANs" is link up */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		if ((cur_link_sts & (vlanconfig[1].memPort))
+			&& (cur_link_sts & (0x1f
+			& ~(vlanconfig[1].memPort))))	/* wan is up and "one of LANs" is link up */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		{
+			extern int32 _rtl865x_ClearFDBEntryByPort(int32
+				port_num);
+			/* memPort is port mask, draw out the wan port by the for loop. */
+			for (port = 0; port < 5; port++)
+#if defined(CONFIG_RTD_1295_HWNAT)
+				if ((vlanconfig[RTL_WAN_IDX].memPort
+					& (1 << port)))
+					break;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+				if ((vlanconfig[1].memPort & (1 << port)))
+					break;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+			_rtl865x_ClearFDBEntryByPort(port);
+		}
+#endif
+		port_link_sts2 = cur_link_sts;
+	}
+	return 0;
+}
+#endif
+
+#if defined(CONFIG_TR181_ETH)
+
+extern unsigned int get_uptime_by_sec(void);
+
+unsigned int port_change_time[8] = { 0, 0, 0, 0, 0, 0, 1, 0 };
+unsigned int if_change_time[2] = { 0, 0 };
+
+uint32 port_link_sts3 = 0;
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+int check_link_change(void)
+{
+	int port;
+	uint32 cur_link_sts = 0;
+
+	for (port = 0; port < 5; port++) {
+		uint32 phyData;
+
+		/*Get PHY status register */
+		if (0 != rtl8367b_getAsicPHYReg(port, 1 /* PHY_STATUS_REG */,
+				&phyData))
+			return (-1);
+
+		/*check link status */
+		if (phyData & (1 << 2))
+			cur_link_sts |= (1 << port);
+
+		if ((port_link_sts3 & (1 << port)) !=
+			(cur_link_sts & (1 << port)))
+			/* record uptime to port_change_time[] */
+			port_change_time[port] = get_uptime_by_sec();
+	}
+	port_link_sts3 = cur_link_sts;
+	return 0;
+}
+#endif
+#endif
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+uint32 rtl_get_8367r_port_link_status(void)
+{
+	uint32 port;
+	uint32 linkPortMask = 0;
+
+	for (port = PHY0; port <= PHY4; port++) {
+		extern int rtk_port_macStatus_get(int port,
+			rtk_port_mac_ability_t *pPortstatus);
+		rtk_port_mac_ability_t sts;
+
+		if ((rtk_port_macStatus_get(port, &sts)) == 0) {
+
+			if (sts.link == 1)
+				linkPortMask |= 1 << port;
+		}
+	}
+
+	return linkPortMask;
+}
+#endif
+
+inline void link_enhancement(void)
+{
+#if defined(CONFIG_RTL_FE_AUTO_DOWN_SPEED)
+	extern void ads_check(void);
+	ads_check();
+#endif
+
+#if (defined(CONFIG_RTL_819XD) && !defined(CONFIG_RTL_8367R_SUPPORT)) || defined(CONFIG_RTL_8196E)
+	if (eee_enabled == FALSE)
+		rtl819xD_check_phy_cb_snr();
+#endif
+
+#ifdef CONFIG_RTL_8196E
+	refine_phy_setting();
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) && defined(CONFIG_RTK_REFINE_PORT_DUPLEX_MODE)
+	rtk_refinePortDuplexMode();
+#endif
+}
+
+#ifdef CONFIG_RTL_ADAPTABLE_TSO
+#include <linux/kernel_stat.h>
+#include <asm/uaccess.h>
+#define INT_HIGH_WATER_MARK 3200
+#define INT_LOW_WATER_MARK  800
+#define INT_WINDOW_SIZE_MAX 10
+static int suspend_check_high_water_mark = INT_HIGH_WATER_MARK;
+static int suspend_check_low_water_mark = INT_LOW_WATER_MARK;
+static int suspend_check_win_size = 5;
+static int index = 0;
+static int wlan1_int_count[INT_WINDOW_SIZE_MAX];
+static int wlan_int_count[INT_WINDOW_SIZE_MAX];
+static int tso_can_stop = 1;
+netdev_features_t tso_feature;
+
+static void suspend_check_timer_fn(void)
+{
+	int count, j;
+
+	index++;
+	if (INT_WINDOW_SIZE_MAX <= index)
+		index = 0;
+	wlan1_int_count[index] = kstat_irqs(BSP_WLAN_MAC_IRQ);
+	wlan_int_count[index] = kstat_irqs(BSP_PCIE_IRQ);
+
+	j = index - suspend_check_win_size;
+	if (j < 0)
+		j += INT_WINDOW_SIZE_MAX;
+	count = (wlan1_int_count[index] - wlan1_int_count[j]) + (wlan_int_count[index] - wlan_int_count[j]);	/* unit: number of interrupt occurred */
+
+	if (tso_can_stop == 1) {
+		if (count > suspend_check_high_water_mark) {
+			_rtl86xx_dev.dev[0]->features &=
+				~(NETIF_F_TSO | NETIF_F_TSO_ECN |
+				NETIF_F_HW_CSUM | NETIF_F_SG | NETIF_F_GSO);
+			tso_can_stop = 0;
+		}
+	} else {
+		if (count < suspend_check_low_water_mark) {
+			_rtl86xx_dev.dev[0]->features |=
+				(NETIF_F_TSO | NETIF_F_TSO_ECN | NETIF_F_HW_CSUM
+				| NETIF_F_SG | NETIF_F_GSO);
+			tso_can_stop = 1;
+		}
+	}
+
+	tso_feature = _rtl86xx_dev.dev[0]->features;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8211F_SUPPORT)
+int rp;
+unsigned int regData, regData1, regData2, prelink;
+extern int rtl_mdio_read(unsigned int mdio_phyaddr, unsigned int reg,
+	unsigned int *pdata);
+int extphyid = 0x5;
+#define BIT10F 	(1<<6)
+#define BIT100H 	(1<<7)
+#define BIT100F 	(1<<8)
+
+static void ckeck_link_speed(void)
+{
+
+	for (rp = 0; rp < 2; rp++)
+		rtl_mdio_read(extphyid, 1, &regData);
+
+	if (regData & (1 << 2) && !(prelink & (1 << 2))) {
+
+		for (rp = 0; rp < 2; rp++)
+			rtl_mdio_read(extphyid, 9, &regData1);
+
+		for (rp = 0; rp < 2; rp++)
+			rtl_mdio_read(extphyid, 10, &regData2);
+
+		if (((regData1 >> 8) & (regData2 >> 10)) & (1 << 1)) {	/* force Giga */
+			REG32(PCRP0) = (REG32(PCRP0) & ~AutoNegoSts_MASK)
+				| (EnForceMode | ForceLink | ForceSpeed1000M |
+				ForceDuplex);
+		} else {
+			for (rp = 0; rp < 2; rp++)
+				rtl_mdio_read(extphyid, 4, &regData1);
+
+			for (rp = 0; rp < 2; rp++)
+				rtl_mdio_read(extphyid, 5, &regData2);
+
+			if (regData1 & regData2 & BIT100H) {	/* 100M */
+				if (regData1 & regData2 & BIT100F) {
+					REG32(PCRP0) =
+						(REG32(PCRP0) &
+						~AutoNegoSts_MASK)
+						| (EnForceMode | ForceLink | ForceSpeed100M | ForceDuplex);	/* 100F */
+				} else {
+					REG32(PCRP0) =
+						(REG32(PCRP0) &
+						~AutoNegoSts_MASK)
+						| (EnForceMode | ForceLink | ForceSpeed100M);	/* 100H */
+				}
+			} else {	/* 10M */
+				if (regData1 & regData2 & BIT10F) {
+					REG32(PCRP0) =
+						(REG32(PCRP0) &
+						~AutoNegoSts_MASK)
+						| (EnForceMode | ForceLink | ForceSpeed10M | ForceDuplex);	/* 10F */
+				} else {
+					REG32(PCRP0) =
+						(REG32(PCRP0) &
+						~AutoNegoSts_MASK)
+						| (EnForceMode | ForceLink | ForceSpeed10M);	/* 10H */
+				}
+			}
+		}
+	}
+
+	prelink = regData;
+}
+
+#endif
+
+#if defined(DYNAMIC_ADJUST_TASKLET) || defined(CONFIG_RTL8196C_REVISION_B) || defined(CONFIG_RTL_8198) || defined(RTL_CPU_QOS_ENABLED) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+extern int rtl865x_reinitSwitchCore(void);
+static void one_sec_timer(unsigned long task_priv)
+{
+	unsigned long flags = 0;
+	struct dev_priv *cp;
+
+	cp = NETDRV_PRIV((struct net_device *)task_priv);
+
+	/* spin_lock_irqsave (&cp->lock, flags); */
+	SMP_LOCK_ETH(flags);
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(PATCH_GPIO_FOR_LED)
+	if (((struct net_device *)task_priv)->name[3] == '0') {	/* eth0 */
+		int port;
+
+		for (port = 0; port < RTL8651_PHY_NUMBER; port++) {
+			update_mib_counter(port);
+			calculate_led_interval(port);
+			if (led_cb[port].link_status & GPIO_LINK_STATE_CHANGE) {
+				gpio_led_Interval_timeout(port);
+			}
+		}
+	}
+#endif
+
+#if defined(DYNAMIC_ADJUST_TASKLET)
+	if (((struct net_device *)task_priv)->name[3] == '0' && rx_pkt_thres > 0
+		&& ((eth_flag & TASKLET_MASK) == 0)) {
+		if (rx_cnt > rx_pkt_thres) {
+			if (!rx_tasklet_enabled) {
+				rx_tasklet_enabled = 1;
+			}
+		} else {
+			if (rx_tasklet_enabled) {	/* tasklet enabled */
+				rx_tasklet_enabled = 0;
+			}
+		}
+		rx_cnt = 0;
+	}
+#endif
+
+#if defined(CONFIG_RTL_8197D_DYN_THR) || defined(CONFIG_RTL_LONG_ETH_CABLE_REFINE)
+	/* for the case: plug in ethernet cable first, then power on the device. */
+	if (do_it_once == 0) {
+		newLinkPortMask = rtl865x_getPhysicalPortLinkStatus();
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+		curLinkPortMask = 0;
+#endif
+
+#ifdef CONFIG_RTL_8197D_DYN_THR
+		rtl819x_setQosThreshold(curLinkPortMask, newLinkPortMask);
+#endif
+
+#if defined(CONFIG_RTL_LONG_ETH_CABLE_REFINE)
+		long_cable_check();
+#endif
+
+		curLinkPortMask = newLinkPortMask;
+		do_it_once = 1;
+	}
+#endif
+
+#ifdef CONFIG_RTK_PORT_LINK
+	if (curLinkCheck == 0) {
+		curLinkPortMask = rtl865x_getPhysicalPortLinkStatus();
+		curLinkCheck = 1;
+	}
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	newLinkPortMask = rtl_get_8367r_port_link_status();
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+	rtl865x_setLinkEventFlag(curLinkPortMask, newLinkPortMask);
+#endif
+	curLinkPortMask = newLinkPortMask;
+#endif
+#ifdef CONFIG_RTL8196C_REVISION_B
+	if ((REG32(REVR) == RTL8196C_REVISION_A) && (eee_enabled)) {
+		int i, curr_sts;
+		uint32 reg;
+
+		/*
+		 * prev_port_sts[] = 0, current = 0     :       do nothing
+		 * prev_port_sts[] = 0, current = 1     :       update prev_port_sts[]
+		 * prev_port_sts[] = 1, current = 0     :       update prev_port_sts[], disable EEE
+		 * prev_port_sts[] = 1, current = 1     :       enable EEE if EEE is disabled
+		 */
+		for (i = 0; i < MAX_PORT_NUMBER; i++) {
+			curr_sts =
+				(REG32(PSRP0 +
+					(i * 4)) & PortStatusLinkUp) >> 4;
+
+			if ((prev_port_sts[i] == 1) && (curr_sts == 0)) {
+				/* disable EEE MAC */
+				REG32(EEECR) =
+					(REG32(EEECR) & ~(0x1f << (i *
+							5))) | ((EN_P0_FRC_EEE |
+						FRC_P0_EEE_100) << (i * 5));
+				/* printk("      disable EEE for port %d\n", i); */
+			} else if ((prev_port_sts[i] == 1) && (curr_sts == 1)) {
+				reg = REG32(EEECR);
+				if ((reg & (1 << (i * 5))) == 0) {
+					/* enable EEE MAC */
+					REG32(EEECR) =
+						(reg & ~(0x1f << (i *
+								5))) |
+						((FRC_P0_EEE_100 | EN_P0_TX_EEE
+							| EN_P0_RX_EEE) << (i *
+							5));
+					/* printk("      enable EEE for port %d\n", i); */
+				}
+			}
+			prev_port_sts[i] = curr_sts;
+		}
+		/* printk(" %d %d %d %d %d\n", port_sts[0], port_sts[1], port_sts[2], port_sts[3], port_sts[4]); */
+	}
+#endif
+
+#if defined(RTL_CPU_QOS_ENABLED)
+	totalLowQueueCnt = 0;
+#endif
+
+#ifdef CONFIG_RTL_8198_ESD
+#if defined(CONFIG_PRINTK)
+#define panic_printk         printk
+#endif
+	{
+		int phy;
+		uint32 val;
+		if (first_time_read_reg6) {
+			first_time_read_reg6 = 0;
+
+			for (phy = 0; phy < 5; phy++) {
+				rtl8651_setAsicEthernetPHYReg(phy, 31, 5);
+				rtl8651_getAsicEthernetPHYReg(phy, 1, &val);
+				rtl8651_setAsicEthernetPHYReg(phy, 1,
+					val | 0x4);
+
+				rtl8651_setAsicEthernetPHYReg(phy, 5, 0xfff6);
+				rtl8651_getAsicEthernetPHYReg(phy, 6, &val);
+				rtl8651_setAsicEthernetPHYReg(phy, 31, 0);
+
+				if ((val & 0xff) == 0xFF) {
+					need_to_check_esd2 = 0;
+				}
+				if (phy_reg30[phy] != 0) {
+					rtl8651_getAsicEthernetPHYReg(phy, 22,
+						&val);
+					rtl8651_setAsicEthernetPHYReg(phy, 22,
+						((val & (0xff00)) | 0x17));
+					rtl8651_getAsicEthernetPHYReg(phy, 30,
+						&val);
+
+					phy_reg30[phy] =
+						BIT(31) | (val & 0xfff);
+				}
+			}
+		}
+
+		if (++one_second_counter >= 10) {
+			for (phy = 0; phy < 5; phy++) {
+				if (phy_reg30[phy] != 0) {
+					rtl8651_setAsicEthernetPHYReg(phy, 31,
+						5);
+					rtl8651_setAsicEthernetPHYReg(phy, 5,
+						0);
+
+					rtl8651_getAsicEthernetPHYReg(phy, 6,
+						&val);
+					rtl8651_setAsicEthernetPHYReg(phy, 31,
+						0);
+
+					if ((val & 0xffff) != 0xAE04) {
+						panic_printk("  ESD-1\n");
+						/* do {} while(1); // reboot */
+						machine_restart(NULL);
+					}
+
+					if (need_to_check_esd2) {
+						rtl8651_setAsicEthernetPHYReg
+							(phy, 31, 5);
+						rtl8651_setAsicEthernetPHYReg
+							(phy, 5, 0xfff6);
+
+						rtl8651_getAsicEthernetPHYReg
+							(phy, 6, &val);
+						rtl8651_setAsicEthernetPHYReg
+							(phy, 31, 0);
+
+						if ((val & 0xff) != 0xFC) {
+							panic_printk
+								("  ESD-2\n");
+							/* do {} while(1); // reboot */
+							machine_restart(NULL);
+						}
+					}
+
+					rtl8651_getAsicEthernetPHYReg(phy, 22,
+						&val);
+					rtl8651_setAsicEthernetPHYReg(phy, 22,
+						((val & (0xff00)) | 0x17));
+					rtl8651_getAsicEthernetPHYReg(phy, 30,
+						&val);
+
+					if (esd3_skip_one == 1) {
+						phy_reg30[phy] =
+							BIT(31) | (val & 0xfff);
+					} else if ((phy_reg30[phy] & 0xfff) !=
+						(val & 0xfff)) {
+						if (diff_more_than_1((phy_reg30
+									[phy] &
+									0xf),
+								(val & 0xf))
+							||
+							diff_more_than_1((
+									(phy_reg30
+										[phy]
+										>>
+										4)
+									& 0xf),
+								((val >> 4) &
+									0xf))
+							||
+							diff_more_than_1((
+									(phy_reg30
+										[phy]
+										>>
+										8)
+									& 0xf),
+								((val >> 8) &
+									0xf))
+							) {
+							panic_printk
+								("  ESD-3: old= 0x%x, new= 0x%x\n",
+								phy_reg30[phy] &
+								0xfff,
+								val & 0xfff);
+							/* do {} while(1); // reboot */
+							machine_restart(NULL);
+						}
+						phy_reg30[phy] =
+							BIT(31) | (val & 0xfff);
+					}
+				}
+
+			}
+			if (esd3_skip_one == 1) {
+				esd3_skip_one = 0;
+			}
+			one_second_counter = 0;
+		}
+	}
+#endif
+
+#ifdef CONFIG_RTL_8196C_ESD
+#if defined(CONFIG_PRINTK)
+#define panic_printk         printk
+#endif
+	if (_96c_esd_counter) {
+		if ((RTL_R32(PCRP4) & EnablePHYIf) == 0) {
+			if (++_96c_esd_reboot_counter >= 20) {
+				panic_printk("  ESD reboot...\n");
+				machine_restart(NULL);
+			}
+		} else {
+			_96c_esd_reboot_counter = 0;
+		}
+	}
+#endif
+
+#if defined(REINIT_SWITCH_CORE)	/* && defined(CONFIG_RTL_CHECK_SWITCH_TX_HANGUP) && defined(CONFIG_RTL_8197F) */
+	if (rtl_check_swCore_tx_hang()) {
+		mod_timer(&cp->expire_timer, jiffies + HZ);
+		SMP_UNLOCK_ETH(flags);
+		rtl865x_reinitSwitchCore();
+		return;
+	}
+#endif
+
+#ifdef CONFIG_RTL_REPORT_LINK_STATUS
+	if (block_link_change > 0)
+		block_link_change = 0;
+#endif
+
+	link_enhancement();
+
+#if defined(CONFIG_RTL_IVL_SUPPORT)
+	if ((rtl865x_curOpMode == BRIDGE_MODE)
+		|| (rtl865x_curOpMode == WISP_MODE))
+		flush_l2();
+#endif
+
+#ifdef CONFIG_RTL_8881A
+	{
+		extern int Lx1_check(void);
+		Lx1_check();
+	}
+#endif
+
+#if defined(CONFIG_TR181_ETH)
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	check_link_change();
+#endif
+#endif
+
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+	if (dot1x_config.enable) {
+		rtl_82dot1xCheckPortState();
+	}
+#endif
+
+#ifdef CONFIG_RTL_8198C_10M_REFINE
+	if (_8198c_link_check == 0) {	/* just do it once */
+		curLinkPortMask = 0;
+		newLinkPortMask = rtl865x_getPhysicalPortLinkStatus();
+		rtl8198c_10M_refine(curLinkPortMask, newLinkPortMask);
+		curLinkPortMask = newLinkPortMask;
+		_8198c_link_check = 1;
+	}
+#endif
+
+#if defined(CONFIG_RTL_8370_SUPPORT)
+	/* due to the RTL8370 RGMII port limitation (it must be set to FORCE mode),
+	 * we must polling the RTL8211E link status and speed, then set RTL8370 EXT1 port.
+	 */
+	{
+		extern void RTL8370_Ext1_set(int speed);	/* SPD_10M=0, SPD_100M=1,SPD_1000M=2 */
+		uint32 rData;
+
+		/* IEEE 802.3
+		 * 22.2.4.2.13 Link Status
+		 * When read as a logic one, bit 1.2 indicates that the PHY has determined that a valid link has been established.
+		 * When read as a logic zero, bit 1.2 indicates that the link is not valid. The criteria for determining link
+		 * validity is PHY specific. The Link Status bit shall be implemented with a latching function, such that the
+		 * occurrence of a link failure condition will cause the Link Status bit to become cleared and remain cleared
+		 * until it is read via the management interface. This status indication is intended to support the management
+		 * attribute definedin 30.5.1.1.4, aMediaAvailable.
+		 */
+		/* so we read it twice */
+		rtl8651_getAsicEthernetPHYReg(P0_EXT_PHY_ID, 1, &rData);
+		rtl8651_getAsicEthernetPHYReg(P0_EXT_PHY_ID, 1, &rData);
+
+		if ((rtl8211eLinkStsSpeed & BIT(2)) != (rData & BIT(2))) {	/* status changed */
+			if (rData & BIT(2)) {	/* link up */
+				rtl8651_getAsicEthernetPHYReg(P0_EXT_PHY_ID, 17,
+					&rData);
+				RTL8370_Ext1_set((rData & 0xC000) >> 14);	/* reconfigure RTL8370 EXT1 port */
+				rtl8211eLinkStsSpeed = (rtl8211eLinkStsSpeed & (~0x3)) | ((rData & 0xC000) >> 14) | BIT(2);	/* update status */
+			} else {	/* link down */
+				rtl8211eLinkStsSpeed &= ~BIT(2);	/* update status */
+			}
+		}
+	}
+#endif
+
+#ifdef CONFIG_RTL_GIGA_LITE_REFINE
+	if (giga_lite_enabled) {
+		extern void set_giga_lite2(void);
+		set_giga_lite2();
+	}
+#endif
+
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU_PPPOE)
+	/*If br0 mask less than 255.255.255.0, set_firewall will echo -1 > /proc/hw_nat,
+	 * then it will call rtl865x_reChangeOpMode, it will delete passthru vlan entry. */
+	if (((_br0_mask != 0) && (_br0_mask < 0xffffff00))
+		&& (oldStatus & PPPOE_PASSTHRU_MASK)) {
+		if (_rtl8651_getVlanTableEntry(PASSTHRU_VLAN_ID) == NULL) {
+			SMP_UNLOCK_ETH(flags);
+			rtl865x_addVlan(PASSTHRU_VLAN_ID);
+#if defined(CONFIG_POCKET_ROUTER_SUPPORT)
+			rtl865x_addVlanPortMember(PASSTHRU_VLAN_ID,
+				rtl865x_lanPortMask | rtl865x_wanPortMask |
+				0x100);
+#else
+			rtl865x_addVlanPortMember(PASSTHRU_VLAN_ID,
+				rtl865x_lanPortMask | rtl865x_wanPortMask);
+#endif
+			SMP_LOCK_ETH(flags);
+		}
+	}
+#endif
+
+#if defined(CONFIG_RTL_NIC_HWSTATS) && defined(CONFIG_RTL_INBAND_CTL_API)
+	re865x_get_hardwareStats(cp);
+	/* printk("rx_bytes_ps:%d,[%s]:[%d].\n",rx_bytes_ps,__FUNCTION__,__LINE__); */
+#endif
+
+#if defined(CONFIG_RTL_8197F) && defined(RX_TASKLET)
+	if (rtl_rx_tasklet_running == 0) {
+		rtl_rx_tasklet_running = 1;
+		REG32(CPUIIMR) &= ~(RX_DONE_IE_ALL | PKTHDR_DESC_RUNOUT_IE_ALL);
+		rtl_rxSetTxDone(FALSE);
+		tasklet_hi_schedule(&cp->rx_dsr_tasklet);
+	}
+#endif
+
+#if defined(CONFIG_RTL_UNKOWN_UNICAST_CONTROL)
+	rtl_clearUnknownUnicastCnt();
+#endif
+
+#ifdef CONFIG_RTL_ADAPTABLE_TSO
+	suspend_check_timer_fn();
+#endif
+
+#if defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8211F_SUPPORT)
+	if (gpio_simulate_mdc_mdio)
+		ckeck_link_speed();
+#endif
+#endif /* !CONFIG_RTD_1295_HWNAT */
+
+	mod_timer(&cp->expire_timer, jiffies + HZ);
+
+	/* spin_unlock_irqrestore(&cp->lock, flags); */
+	SMP_UNLOCK_ETH(flags);
+}
+#endif
+
+#ifdef CONFIG_RTL8196C_GREEN_ETHERNET
+static void power_save_timer(unsigned long task_priv)
+{
+	unsigned long flags = 0;
+	/* struct dev_priv       *cp; */
+
+	/* cp = ((struct net_device *)task_priv)->priv; */
+
+	/* spin_lock_irqsave (&cp->lock, flags); */
+	SMP_LOCK_ETH(flags);
+
+	set_phy_pwr_save(port_pwr_save_low, 1);
+
+	port_pwr_save_low = (port_pwr_save_low + 1) % 5;
+	set_phy_pwr_save(port_pwr_save_low, 0);
+
+	/* mod_timer(&cp->expire_timer2, jiffies + (total_time_for_5_port / 5 / 10)); */
+	mod_timer(&expire_timer2, jiffies + (total_time_for_5_port / 5 / 10));
+
+	/* spin_unlock_irqrestore(&cp->lock, flags); */
+	SMP_UNLOCK_ETH(flags);
+}
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+int32 rtd129x_set_phy_power_down(uint32 port, uint32 pwr_down)
+{
+	switch (port) {
+	case 0:
+		if (hwnat_mac0_enable == 0 || (hwnat_mac0_mode & 2) > 0)
+			goto out;
+		break;
+	case 1:
+	case 2:
+	case 3:
+		goto out;
+	case 4:
+		break;
+	case 5:
+		if ((hwnat_mac5_conn_to != 0) || (hwnat_rgmii_enable == 0))
+			goto out;
+		break;
+	default:
+		pr_err("set PHY power down to unknown port %d\n", port);
+		goto out;
+	}
+
+	rtl8651_setAsicEthernetPHYPowerDown(port, pwr_down);
+out:
+	return 0;
+}
+
+#if defined(CONFIG_RTL_WAN_MAC5)
+extern int linux_vlan_enable;
+extern int linux_vlan_hw_support_enable;
+extern uint16 rtk_vlan_wan_vid;
+extern uint16 rtk_vlan_hw_nat_lan_vid;
+
+extern void rtl_vlan_reinit(bool enable);
+extern int32 rtl_vlan_group_set(uint32 flag, uint32 mask, uint32 tagMask,
+				uint32 vid, uint32 vlanType);
+extern int32 rtl_vlan_pvid_set(int32 port, uint32 pvid);
+#endif /* CONFIG_RTL_WAN_MAC5 */
+
+static int rtl_nat_net_init(void)
+{
+	#if defined(CONFIG_RTL_WAN_MAC5)
+	#if defined(CONFIG_RTL_836X_SUPPORT)
+	rtk_vlan_cfg_t vlan;
+	#endif /* CONFIG_RTL_836X_SUPPORT */
+
+	rtl_vlan_reinit(true);
+
+	/* tag member: port 6 (CPU), port 5 */
+	rtl_vlan_group_set(1, 0x60, 0x60, 100, 1);
+	rtl_vlan_group_set(1, 0x60, 0x60, 200, 1);
+
+	/* untagged packets are sent to LAN */
+	rtl_vlan_pvid_set(5, 200);
+
+	#if defined(CONFIG_RTL_836X_SUPPORT)
+	spin_lock(&rtl836x_ext_lock);
+	memset(&vlan, 0x00, sizeof(rtk_vlan_cfg_t));
+
+	RTK_PORTMASK_PORT_SET(vlan.mbr, UTP_PORT0);
+	RTK_PORTMASK_PORT_SET(vlan.mbr, EXT_PORT0);
+	RTK_PORTMASK_PORT_SET(vlan.untag, UTP_PORT0);
+
+	rtk_vlan_set(100, &vlan);
+
+	memset(&vlan, 0x00, sizeof(rtk_vlan_cfg_t));
+
+	RTK_PORTMASK_PORT_SET(vlan.mbr, UTP_PORT1);
+	RTK_PORTMASK_PORT_SET(vlan.mbr, UTP_PORT2);
+	RTK_PORTMASK_PORT_SET(vlan.mbr, EXT_PORT0);
+	RTK_PORTMASK_PORT_SET(vlan.untag, UTP_PORT1);
+	RTK_PORTMASK_PORT_SET(vlan.untag, UTP_PORT2);
+
+	rtk_vlan_set(200, &vlan);
+
+	rtk_vlan_portPvid_set(UTP_PORT0, 100, 0);
+	rtk_vlan_portPvid_set(UTP_PORT1, 200, 0);
+	rtk_vlan_portPvid_set(UTP_PORT2, 200, 0);
+	rtk_vlan_portPvid_set(EXT_PORT0, 200, 0);
+	spin_unlock(&rtl836x_ext_lock);
+	#endif /* CONFIG_RTL_836X_SUPPORT */
+	#endif /* CONFIG_RTL_WAN_MAC5 */
+
+	#if defined(CONFIG_RTL_CPU_TAG) || defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)
+	#if defined(CONFIG_RTL_836X_SUPPORT)
+	/* for external switch */
+	rtk_l2_ucastAddr_t l2_entry;
+	rtk_mac_t mac;
+	rtk_api_ret_t ret;
+	rtk_portmask_t portmask;
+	rtk_vlan_cfg_t vlan;
+	struct rtl865x_vlanConfig *vlancfg_entry;
+
+	memset(&mac, 0x00, sizeof(rtk_mac_t));
+	memset(&l2_entry, 0x00, sizeof(rtk_l2_ucastAddr_t));
+	memset(&vlan, 0x00, sizeof(rtk_vlan_cfg_t));
+
+
+	spin_lock(&rtl836x_ext_lock);
+	/* set switch port isolation */
+	/* EFID 1: UTP_PORT0, EXT_PORT0 */
+	/* EFID 0: UTP_PORT1, UTP_PORT2, EXT_PORT1 */
+	RTK_PORTMASK_CLEAR(portmask);
+	RTK_PORTMASK_PORT_SET(portmask, EXT_PORT0);
+	rtk_port_isolation_set(UTP_PORT0, &portmask);
+
+	RTK_PORTMASK_CLEAR(portmask);
+	RTK_PORTMASK_PORT_SET(portmask, UTP_PORT0);
+	rtk_port_isolation_set(EXT_PORT0, &portmask);
+
+	RTK_PORTMASK_CLEAR(portmask);
+	RTK_PORTMASK_PORT_SET(portmask, UTP_PORT2);
+	RTK_PORTMASK_PORT_SET(portmask, EXT_PORT1);
+	rtk_port_isolation_set(UTP_PORT1, &portmask);
+
+	RTK_PORTMASK_CLEAR(portmask);
+	RTK_PORTMASK_PORT_SET(portmask, UTP_PORT1);
+	RTK_PORTMASK_PORT_SET(portmask, EXT_PORT1);
+	rtk_port_isolation_set(UTP_PORT2, &portmask);
+
+	RTK_PORTMASK_CLEAR(portmask);
+	RTK_PORTMASK_PORT_SET(portmask, UTP_PORT1);
+	RTK_PORTMASK_PORT_SET(portmask, UTP_PORT2);
+	rtk_port_isolation_set(EXT_PORT1, &portmask);
+
+	rtk_port_efid_set(UTP_PORT0, 1);
+	rtk_port_efid_set(EXT_PORT0, 1);
+	rtk_port_efid_set(UTP_PORT1, 0);
+	rtk_port_efid_set(UTP_PORT2, 0);
+	rtk_port_efid_set(EXT_PORT1, 0);
+
+	#if !defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)
+	/* Let 8367 remove RTL_LANVLANID: 9 */
+	RTK_PORTMASK_PORT_SET(vlan.mbr, UTP_PORT1);
+	RTK_PORTMASK_PORT_SET(vlan.mbr, UTP_PORT2);
+	RTK_PORTMASK_PORT_SET(vlan.mbr, EXT_PORT1);
+	RTK_PORTMASK_PORT_SET(vlan.untag, UTP_PORT1);
+	RTK_PORTMASK_PORT_SET(vlan.untag, UTP_PORT2);
+	RTK_PORTMASK_PORT_SET(vlan.untag, EXT_PORT1);
+
+	ret = rtk_vlan_set(RTL_LANVLANID, &vlan);
+
+	rtk_vlan_portPvid_set(UTP_PORT1, RTL_LANVLANID, 0);
+	rtk_vlan_portPvid_set(UTP_PORT2, RTL_LANVLANID, 0);
+	rtk_vlan_portPvid_set(EXT_PORT1, RTL_LANVLANID, 0);
+	#endif /* CONFIG_RTL_2_RGMII_PORTS_ONLY */
+
+	/* add WAN MAC to EXT_PORT0 */
+	vlancfg_entry = rtl_get_vlanconfig_by_netif_name(RTL_DRV_WAN0_NETIF_NAME);
+	if (vlancfg_entry) {
+		mac.octet[0] = vlancfg_entry->mac.octet[0];
+		mac.octet[1] = vlancfg_entry->mac.octet[1];
+		mac.octet[2] = vlancfg_entry->mac.octet[2];
+		mac.octet[3] = vlancfg_entry->mac.octet[3];
+		mac.octet[4] = vlancfg_entry->mac.octet[4];
+		mac.octet[5] = vlancfg_entry->mac.octet[5];
+
+		l2_entry.port = EXT_PORT0 ;
+		l2_entry.cvid = 1;
+		l2_entry.efid = 1;
+		l2_entry.is_static = 1;
+
+		if ((ret = rtk_l2_addr_add(&mac, &l2_entry)) != RT_ERR_OK)
+			pr_err("Add WAN MAC to switch failed!\n");
+	}
+
+	/* add LAN MAC to EXT_PORT1 */
+	vlancfg_entry = rtl_get_vlanconfig_by_netif_name(RTL_DRV_LAN_NETIF_NAME);
+	if (vlancfg_entry) {
+		mac.octet[0] = vlancfg_entry->mac.octet[0];
+		mac.octet[1] = vlancfg_entry->mac.octet[1];
+		mac.octet[2] = vlancfg_entry->mac.octet[2];
+		mac.octet[3] = vlancfg_entry->mac.octet[3];
+		mac.octet[4] = vlancfg_entry->mac.octet[4];
+		mac.octet[5] = vlancfg_entry->mac.octet[5];
+
+		l2_entry.port = EXT_PORT1 ;
+		l2_entry.cvid = 1;
+		l2_entry.efid = 0;
+		l2_entry.is_static = 1;
+
+		if ((ret = rtk_l2_addr_add(&mac, &l2_entry)) != RT_ERR_OK)
+			pr_err("Add LAN MAC to switch failed!\n");
+
+		/* also add pseudo MAC */
+		mac.octet[0] |= 0x2;
+		if ((ret = rtk_l2_addr_add(&mac, &l2_entry)) != RT_ERR_OK)
+			pr_err("Add OTT MAC to switch failed!\n");
+	}
+	spin_unlock(&rtl836x_ext_lock);
+	#endif /* CONFIG_RTL_836X_SUPPORT */
+	#endif /* CONFIG_RTL_CPU_TAG || CONFIG_RTL_2_RGMII_PORTS_ONLY */
+
+	return 0;
+}
+
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+static struct net_device *irqDev = NULL;
+static int re865x_open(struct net_device *dev)
+{
+	struct dev_priv *cp;
+	unsigned long flags = 0;
+	int rc;
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	char drvNetif_name[MAX_IFNAMESIZE];
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+	unsigned int port;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	cp = NETDRV_PRIV(dev);
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+	/* printk("re865x_open dev=%s , id = %d \n",dev->name,cp->id); */
+	if (cp->id == 0) {
+		/* printk("FAILED open vid=0"); */
+		return FAILED;
+	}
+#endif
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+	napi_enable(&cp->napi);
+#if defined(CONFIG_RTL_ETH_NAPI_GRO_SUPPORT)
+	dev->gro_flush_timeout = 10000;
+#endif /* CONFIG_RTL_ETH_NAPI_GRO_SUPPORT */
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+
+	if (cp->opened)
+		return SUCCESS;
+
+	/*      The first device be opened      */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (atomic_inc_return(&rtl_devOpened) == 1)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (atomic_read(&rtl_devOpened) == 0)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	{
+		/* this is the first open dev */
+		/* should not call rtl865x_down() here */
+		/* rtl865x_down(); */
+#ifdef CONFIG_RTL_8198
+		{
+			extern void disable_phy_power_down(void);
+			disable_phy_power_down();
+		}
+#endif
+		/* spin_lock_irqsave(&cp->lock, flags); */
+		SMP_LOCK_ETH_BUF(flags);
+		rtk_queue_init(&rx_skb_queue);
+		SMP_UNLOCK_ETH_BUF(flags);
+#if !defined(CONFIG_RTD_1295_HWNAT)
+		SMP_LOCK_ETH(flags);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+		rc = rtl865x_init_hw();
+#if !defined(CONFIG_RTD_1295_HWNAT)
+		SMP_UNLOCK_ETH(flags);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+		atomic_inc(&rtl_devOpened);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+		refill_rx_skb();
+		/* spin_unlock_irqrestore(&cp->lock, flags); */
+		if (rc) {
+			/* printk("rtl865x_init_hw() failed!\n"); */
+			atomic_dec(&rtl_devOpened);
+			return FAILED;
+		}
+
+#if defined(RX_TASKLET) || defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+		tasklet_init(&cp->rx_dsr_tasklet, (void *)interrupt_dsr_rx,
+				(unsigned long)cp);
+#endif /* RX_TASKLET || CONFIG_RTL_ETH_NAPI_SUPPORT */
+
+#ifdef TX_TASKLET
+		tasklet_init(&cp->tx_dsr_tasklet, interrupt_dsr_tx,
+			(unsigned long)cp);
+#endif
+
+#ifdef LINK_TASKLET
+		tasklet_init(&cp->link_dsr_tasklet, interrupt_dsr_link,
+			(unsigned long)cp);
+#ifdef CONFIG_RTD_1295_MAC0_SGMII_LINK_MON
+		if (hwnat_mac0_enable == 1 && hwnat_mac0_mode == 1 /*SGMII*/ &&
+			get_rtd129x_cpu_revision() == RTD129x_CHIP_REVISION_A00)
+			rtk_polling_mac0_lnk_status();
+#endif /* CONFIG_RTD_1295_MAC0_SGMII_LINK_MON */
+#endif
+
+#ifdef CONFIG_RTL_PHY_PATCH
+		memset(re865x_restartNWayCtrl, 0,
+			sizeof(re865x_restartNWayCtrl));
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		rc = request_irq(dev->irq, interrupt_isr, IRQF_SHARED,
+			dev->name, dev);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		rc = request_irq(dev->irq, interrupt_isr, IRQF_DISABLED,
+			dev->name, dev);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		if (rc) {
+			printk("request_irq() error!\n");
+			atomic_dec(&rtl_devOpened);
+			goto err_out_hw;
+		}
+		irqDev = dev;
+		/* cp->irq_owner =1; */
+#if defined(CONFIG_RTD_1295_HWNAT)
+		SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		rtl865x_start();
+#if defined(CONFIG_RTD_1295_HWNAT)
+		SMP_UNLOCK_ETH(flags);
+
+		/* post init after the 1st dev is opened */
+		rtl_nat_net_init();
+
+		/* start one_sec_timer */
+		init_timer(&cp->expire_timer);
+		cp->expire_timer.expires = jiffies + HZ;
+		cp->expire_timer.data = (unsigned long)dev;
+		cp->expire_timer.function = one_sec_timer;
+		mod_timer(&cp->expire_timer, jiffies + HZ);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	}
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	else {
+		atomic_inc(&rtl_devOpened);
+	}
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	cp->opened = 1;
+
+#ifdef CONFIG_RTL_HARDWARE_NAT
+	reset_hw_mib_counter(dev);
+#endif
+
+	netif_start_queue(dev);
+
+#if defined(CONFIG_TR181_ETH)
+	if (dev->name[3] == '0')
+		if_change_time[0] = get_uptime_by_sec();
+	else
+		if_change_time[1] = get_uptime_by_sec();
+#endif
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(DYNAMIC_ADJUST_TASKLET) || defined(CONFIG_RTL8196C_REVISION_B) || defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (dev->name[3] == '0') {
+#ifdef CONFIG_RTL_ADAPTABLE_TSO
+		int window;
+		for (window = 0; window < INT_WINDOW_SIZE_MAX; window++) {
+			wlan_int_count[window] = 0;
+			wlan1_int_count[window] = 0;
+		}
+#endif
+		init_timer(&cp->expire_timer);
+		cp->expire_timer.expires = jiffies + HZ;
+		cp->expire_timer.data = (unsigned long)dev;
+		cp->expire_timer.function = one_sec_timer;
+		mod_timer(&cp->expire_timer, jiffies + HZ);
+#ifdef DYNAMIC_ADJUST_TASKLET
+		rx_cnt = 0;
+#endif
+	}
+#endif
+#endif /* !CONFIG_RTD_1295_HWNAT */
+
+#ifdef CONFIG_RTL8196C_GREEN_ETHERNET
+	if (REG32(REVR) == RTL8196C_REVISION_B) {
+		/* if (dev->name[3] == '0') */
+		if (atomic_read(&rtl_devOpened) == 1) {
+#if 0
+			init_timer(&cp->expire_timer2);
+			cp->expire_timer2.expires = jiffies + HZ;
+			cp->expire_timer2.data = (unsigned long)dev;
+			cp->expire_timer2.function = power_save_timer;
+			mod_timer(&cp->expire_timer2, jiffies + HZ);
+#else
+			init_timer(&expire_timer2);
+			expire_timer2.expires = jiffies + HZ;
+			expire_timer2.data = (unsigned long)dev;
+			expire_timer2.function = power_save_timer;
+			mod_timer(&expire_timer2, jiffies + HZ);
+#endif
+		}
+	}
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	/*FIXME_hyking: should add default route to cpu.... */
+	if (rtl865x_curOpMode == GATEWAY_MODE)
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+		rtl865x_addRoute(0, 0, 0, RTL_GW_WAN_DEVICE_NAME, 0);
+#else
+		rtl865x_addRoute(0, 0, 0, RTL_DRV_WAN0_NETIF_NAME, 0);
+#endif
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		inv6_addr_t ipAddr, nexthop;
+		memset(&ipAddr, 0, sizeof(inv6_addr_t));
+		memset(&nexthop, 0, sizeof(inv6_addr_t));
+
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+		rtl8198c_addIpv6Route(ipAddr, 0, nexthop,
+			RTL_GW_WAN_DEVICE_NAME);
+#else
+		rtl8198c_addIpv6Route(ipAddr, 0, nexthop,
+			RTL_DRV_WAN0_NETIF_NAME);
+#endif
+	}
+#endif
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	memset(drvNetif_name, 0, MAX_IFNAMESIZE);
+	if (rtl_get_ps_drv_netif_mapping_by_psdev_name(dev->name,
+			drvNetif_name) == SUCCESS)
+		rtl_enable_advRt_by_netifName(drvNetif_name);
+#endif
+	rtl865x_enableDevPortForward(dev, cp);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	/* set PHY power up to enable traffic */
+	for (port = 0; port <= RTL8651_PHY_NUMBER; port++) {
+		if ((1 << port) & cp->portmask) {
+			rtd129x_set_phy_power_down(port, false);
+			break;
+		}
+	}
+
+	#if !defined(CONFIG_RTL_836X_SUPPORT)
+	if (cp->link_event == KOBJ_MAX) {
+		newLinkPortMask = rtl865x_getPhysicalPortLinkStatus();
+		if (cp->portmask & newLinkPortMask) {
+			curLinkPortMask |= cp->portmask;
+			cp->link_event = KOBJ_LINKUP;
+			schedule_work(&cp->link_event_work);
+		} else {
+			cp->link_event = KOBJ_LINKDOWN;
+			schedule_work(&cp->link_event_work);
+		}
+	}
+	#endif /* !CONFIG_RTL_836X_SUPPORT */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	return SUCCESS;
+
+err_out_hw:
+	rtl8186_stop_hw(dev, cp);
+#if defined(CONFIG_RTD_1295_HWNAT)
+	SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	rtl865x_down();
+#if defined(CONFIG_RTD_1295_HWNAT)
+	SMP_UNLOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	return rc;
+}
+
+static int re865x_close(struct net_device *dev)
+{
+	struct dev_priv *cp;
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	char drvNetif_name[MAX_IFNAMESIZE];
+#endif
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	unsigned long flags;
+#endif /* !CONFIG_RTD_1295_HWNAT */
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	unsigned int port;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	cp = NETDRV_PRIV(dev);
+	if (!cp->opened)
+		return SUCCESS;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	/* set PHY power down to stop traffic */
+	for (port = 0; port <= RTL8651_PHY_NUMBER; port++) {
+		if ((1 << port) & cp->portmask) {
+			rtd129x_set_phy_power_down(port, true);
+			break;
+		}
+	}
+	msleep(100);
+	flush_work(&cp->link_event_work);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+	napi_disable(&cp->napi);
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+
+	netif_stop_queue(dev);
+	/* The last opened device       */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (atomic_dec_return(&rtl_devOpened) == 0)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (atomic_read(&rtl_devOpened) == 1)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	{
+#if defined(CONFIG_RTD_1295_HWNAT)
+		struct dev_priv *cp;
+
+		if (!irqDev) {
+			pr_err(" no irqDev found\n");
+			BUG();
+		}
+		cp = NETDRV_PRIV(irqDev);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		/*      warning:
+		 * 1.if we don't reboot,we shouldn't hold switch core from rx/tx, otherwise there will be some problem during change operation mode
+		 * 2.only when two devices go down,can we shut down nic interrupt
+		 * 3.the interrupt will be re_enable by rtl865x_start()
+		 */
+		rtl865x_disableInterrupt();
+
+		/* free_irq(dev->irq, GET_IRQ_OWNER(cp)); */
+		/* ((struct dev_priv *)((GET_IRQ_OWNER(cp))->priv))->irq_owner = 0; */
+		free_irq(dev->irq, irqDev);
+		/* ((struct dev_priv *)(irqDev->priv))->irq_owner = 0; */
+
+#if defined(RX_TASKLET) || defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+		tasklet_kill(&cp->rx_dsr_tasklet);
+#endif /* RX_TASKLET || CONFIG_RTL_ETH_NAPI_SUPPORT */
+
+#ifdef TX_TASKLET
+		tasklet_kill(&cp->tx_dsr_tasklet);
+#endif
+
+#ifdef LINK_TASKLET
+		tasklet_kill(&cp->link_dsr_tasklet);
+#endif
+
+#ifdef CONFIG_RTL_PHY_PATCH
+		memset(re865x_restartNWayCtrl, 0,
+			sizeof(re865x_restartNWayCtrl));
+#endif
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+		atomic_dec(&rtl_devOpened);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+		free_rx_skb();
+
+		rtk_queue_exit(&rx_skb_queue);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		if (timer_pending(&cp->expire_timer))
+			del_timer_sync(&cp->expire_timer);
+		irqDev = NULL;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	}
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+	if (strncmp(dev->name, irqDev->name, IFNAMSIZ) == 0) {
+		local_irq_save(flags);
+		napi_disable(&cp->napi);
+		netif_napi_del(&cp->napi);
+		cp->napi.poll = NULL;
+		local_irq_restore(flags);
+	}
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+	memset(&cp->net_stats, '\0', sizeof(struct net_device_stats));
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	if (atomic_read(&rtl_devOpened) > 0)
+		atomic_dec(&rtl_devOpened);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	cp->opened = 0;
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	memset(drvNetif_name, 0, MAX_IFNAMESIZE);
+	if (rtl_get_ps_drv_netif_mapping_by_psdev_name(dev->name,
+			drvNetif_name) == SUCCESS)
+		rtl_disable_advRt_by_netifName(drvNetif_name);
+
+	if (rtl_port_used_by_device(cp->portmask) == FAILED)
+#endif
+	{
+		rtl865x_disableDevPortForward(dev, cp);
+#if !(defined(CONFIG_RTD_1295_HWNAT) && (defined(CONFIG_RTL_CPU_TAG) || \
+	defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)) && \
+	defined(CONFIG_RTL_836X_SUPPORT))
+#if !defined(CONFIG_RTL_8196C)
+		/*for lan dhcp client to renew ip address */
+		rtl865x_restartDevPHYNway(dev, cp);
+#endif
+#endif /* !(CONFIG_RTD_1295_HWNAT && CONFIG_RTL_CPU_TAG && CONFIG_RTL_836X_SUPPORT) */
+		rtl8186_stop_hw(dev, cp);
+	}
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(DYNAMIC_ADJUST_TASKLET) || defined(BR_SHORTCUT) || defined(CONFIG_RTL8196C_REVISION_B) || defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	if (timer_pending(&cp->expire_timer))
+		del_timer_sync(&cp->expire_timer);
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_TR181_ETH)
+	if (dev->name[3] == '0')
+		if_change_time[0] = get_uptime_by_sec();
+	else
+		if_change_time[1] = get_uptime_by_sec();
+#endif
+
+#ifdef CONFIG_RTL8196C_GREEN_ETHERNET
+	if (atomic_read(&rtl_devOpened) == 0) {
+		if (REG32(REVR) == RTL8196C_REVISION_B) {
+#if 0
+			if (timer_pending(&cp->expire_timer2))
+				del_timer_sync(&cp->expire_timer2);
+#else
+			if (timer_pending(&expire_timer2))
+				del_timer_sync(&expire_timer2);
+#endif
+		}
+	}
+#endif
+
+#ifdef BR_SHORTCUT
+	if (dev == cached_dev)
+		cached_dev = NULL;
+
+	if (dev == cached_dev2)
+		cached_dev2 = NULL;
+
+	if (dev == cached_dev3)
+		cached_dev3 = NULL;
+
+	if (dev == cached_dev4)
+		cached_dev4 = NULL;
+#endif
+#ifdef CONFIG_RTL_HARDWARE_NAT
+	reset_hw_mib_counter(dev);
+#endif
+
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_STP) || (defined(CONFIG_RTL_CUSTOM_PASSTHRU))
+static int re865x_pseudo_open(struct net_device *dev)
+{
+	struct dev_priv *cp;
+
+	cp = NETDRV_PRIV(dev);
+	if (cp->opened)
+		return SUCCESS;
+
+	cp->opened = 1;
+	netif_start_queue(dev);
+	return SUCCESS;
+}
+
+static int re865x_pseudo_close(struct net_device *dev)
+{
+	struct dev_priv *cp;
+
+	cp = NETDRV_PRIV(dev);
+
+	if (!cp->opened)
+		return SUCCESS;
+	netif_stop_queue(dev);
+
+	memset(&cp->net_stats, '\0', sizeof(struct net_device_stats));
+	cp->opened = 0;
+
+#ifdef BR_SHORTCUT
+	if (dev == cached_dev)
+		cached_dev = NULL;
+
+	if (dev == cached_dev2)
+		cached_dev2 = NULL;
+
+	if (dev == cached_dev3)
+		cached_dev3 = NULL;
+
+	if (dev == cached_dev4)
+		cached_dev4 = NULL;
+#endif
+	return SUCCESS;
+}
+#endif
+
+#if 0				/* defined(CONFIG_RTL_STP) */
+static int re865x_stp_mapping_init(void)
+{
+	int i, j, k, totalVlans;
+	totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		1;
+
+	for (i = 0; i < MAX_RE865X_STP_PORT; i++) {
+		STP_PortDev_Mapping[i] = NO_MAPPING;
+	}
+
+	STP_PortDev_Mapping[WLAN_PSEUDO_IF_INDEX] = WLAN_PSEUDO_IF_INDEX;
+#ifdef CONFIG_RTK_MESH
+	STP_PortDev_Mapping[WLAN_MESH_PSEUDO_IF_INDEX] =
+		WLAN_MESH_PSEUDO_IF_INDEX;
+#endif
+
+	j = 0;
+	for (k = 0; k < totalVlans; k++) {
+		if (vlanconfig[k].isWan == FALSE) {
+			for (i = 0; i < MAX_RE865X_ETH_STP_PORT; i++) {
+				if ((1 << i) & vlanconfig[k].memPort) {
+					STP_PortDev_Mapping[j] = i;
+					j++;
+				}
+			}
+
+			break;
+		}
+	}
+
+	return SUCCESS;
+}
+
+static int re865x_stp_mapping_reinit(void)
+{
+	int i, j, k, totalVlans;
+	totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		1;
+
+	for (i = 0; i < MAX_RE865X_STP_PORT; i++) {
+		STP_PortDev_Mapping[i] = NO_MAPPING;
+	}
+
+	STP_PortDev_Mapping[WLAN_PSEUDO_IF_INDEX] = WLAN_PSEUDO_IF_INDEX;
+#ifdef CONFIG_RTK_MESH
+	STP_PortDev_Mapping[WLAN_MESH_PSEUDO_IF_INDEX] =
+		WLAN_MESH_PSEUDO_IF_INDEX;
+#endif
+
+	j = 0;
+	for (k = 0; k < totalVlans; k++) {
+		if (vlanconfig[k].isWan == FALSE) {
+			for (i = 0; i < MAX_RE865X_ETH_STP_PORT; i++) {
+				if ((1 << i) & vlanconfig[k].memPort) {
+					STP_PortDev_Mapping[j] = i;
+					j++;
+				}
+			}
+
+			break;
+		}
+	}
+
+	return SUCCESS;
+}
+
+static int re865x_stp_get_pseudodevno(uint32 port_num)
+{
+	int i, dev_no;
+	for (i = 0; i < MAX_RE865X_STP_PORT - 1; i++) {
+		if (STP_PortDev_Mapping[i] == port_num) {
+			dev_no = i;
+			return dev_no;
+		}
+	}
+	return NO_MAPPING;
+
+}
+
+static int getVidByPort(uint32 port_num)
+{
+	int i, totalVlans, retVid;
+
+	retVid = 0;
+	totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		1;
+
+	for (i = 0; i < totalVlans; i++) {
+		if ((1 << port_num) & vlanconfig[i].memPort) {
+			retVid = vlanconfig[i].vid;
+			break;
+		}
+	}
+
+	return retVid;
+}
+#endif
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+/* hyking:this function should move to rtl865x_fdb.c */
+/* implement it at here just for releaae to natami... */
+/* 2010-02-22 */
+static int32 rtl865x_getPortlistByMac(const unsigned char *mac,
+	uint32 *portlist)
+{
+	int32 found = FAILED;
+	ether_addr_t *macAddr;
+	int32 column;
+	rtl865x_tblAsicDrv_l2Param_t fdbEntry;
+
+	macAddr = (ether_addr_t *)(mac);
+	found = rtl865x_Lookup_fdb_entry(0, macAddr, FDB_DYNAMIC, &column,
+		&fdbEntry);
+	if (found == SUCCESS) {
+		if (portlist)
+			*portlist = fdbEntry.memberPortMask;
+	}
+
+	return found;
+
+}
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+int re865x_setMCastTxInfo(struct sk_buff *skb, struct net_device *dev,
+	rtl_nicTx_info *nicTx)
+{
+	int32 ret;
+	struct dev_priv *cp;
+	struct iphdr *iph = NULL;
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	struct ipv6hdr *ipv6h = NULL;
+#endif
+	unsigned int l4Protocol = 0;
+	struct rtl_multicastDataInfo multicastDataInfo;
+	struct rtl_multicastFwdInfo multicastFwdInfo;
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	struct sk_buff *skb_wan = NULL;
+	rtl_nicTx_info nicTx_wan;
+#endif
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	int type;
+#endif
+
+#if defined(CONFIG_RTL_VLAN_8021Q)
+	int src_port = skb->srcPort;
+#endif
+
+	if ((skb == NULL) || (dev == NULL) || (nicTx == NULL)) {
+		return -1;
+	}
+
+	if (nicIgmpModuleIndex == 0xFFFFFFFF) {
+		return -1;
+	}
+
+	if (igmpsnoopenabled != TRUE
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+		&& mldSnoopEnabled != TRUE
+#endif
+		) {
+		return -1;
+	}
+	cp = NETDRV_PRIV(dev);
+#ifndef CONFIG_RTL_VLAN_8021Q
+	nicTx->portlist = cp->portmask;
+#endif
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	type = rtl_is_pppoe_igmp_bridge_frame(skb, 1, skb->data);
+	if(((skb->data[0]==0x01) && (skb->data[1]==0x00) && (skb->data[2]==0x5e)) || (type>0&&type<=PPPOE_TCP))
+#else
+	if ((skb->data[0] == 0x01) && (skb->data[1] == 0x00)
+		&& (skb->data[2] == 0x5e))
+#endif
+	{
+		if (igmpsnoopenabled != TRUE) {
+			return -1;
+		}
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+		if(type>0&&type<=PPPOE_TCP)
+			iph = rtl_get_pppoe_ipv4_hdr(skb->data, 1, 0);
+		else
+#endif
+			iph = re865x_getIpv4Header(skb->data);
+		if (iph) {
+			l4Protocol = iph->protocol;
+			if ((l4Protocol == IPPROTO_UDP)
+				|| (l4Protocol == IPPROTO_TCP)) {
+				if (cp->portnum <= 1) {
+					return -1;
+				}
+
+				/*only process tcp/udp in igmp snooping data plane */
+				multicastDataInfo.ipVersion = 4;
+				memcpy(multicastDataInfo.sourceIp,
+					&(iph->saddr), 4);
+				memcpy(multicastDataInfo.groupAddr,
+					&(iph->daddr), 4);
+				multicastDataInfo.sourceIp[0] =
+					ntohl(multicastDataInfo.sourceIp[0]);
+				multicastDataInfo.groupAddr[0] =
+					ntohl(multicastDataInfo.groupAddr[0]);
+				/*
+				 * multicastDataInfo.sourceIp[0]=  (uint32)(iph->saddr);
+				 * multicastDataInfo.groupAddr[0]=  (uint32)(iph->daddr);
+				 */
+				ret = rtl_getMulticastDataFwdInfo
+					(nicIgmpModuleIndex, &multicastDataInfo,
+					&multicastFwdInfo);
+#ifdef CONFIG_RTL_VLAN_8021Q
+				if (linux_vlan_enable) {
+					nicTx->portlist &=
+						multicastFwdInfo.
+						fwdPortMask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1) & (~(1 << src_port));
+				} else
+					nicTx->portlist =
+						multicastFwdInfo.
+						fwdPortMask & cp->
+						portmask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1);
+#else
+				nicTx->portlist =
+					multicastFwdInfo.fwdPortMask & cp->
+					portmask & ((1 << RTL8651_MAC_NUMBER) -
+					1);
+#endif
+				/* printk("Portmask:%x ,%x[%s]:[%d].\n",multicastFwdInfo.fwdPortMask,nicTx->portlist,__FUNCTION__,__LINE__); */
+
+			}
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+			/* fix tim; upnp */
+			if (vlan_bridge_multicast_tag) {
+				if ((cp->id == vlan_bridge_tag)
+					&& (nicTx->
+						portlist & RTL_WANPORT_MASK)) {
+					nicTx->portlist &= (~RTL_WANPORT_MASK);
+					skb_wan = skb_copy(skb, GFP_ATOMIC);
+					if (skb_wan != NULL) {
+						nicTx_wan.txIdx = 0;
+						nicTx_wan.vid =
+							vlan_bridge_multicast_tag;
+						nicTx_wan.portlist =
+							RTL_WANPORT_MASK;
+						nicTx_wan.srcExtPort = 0;
+						nicTx_wan.flags =
+							(PKTHDR_USED |
+							PKT_OUTGOING);
+						nicTx_wan.tagport =
+							RTL_WANPORT_MASK;
+						RTL_CACHE_WBACK((unsigned long)
+							skb_wan->data,
+							skb_wan->len);
+						if (RTL_swNic_send((void *)
+								skb_wan,
+								skb_wan->data,
+								skb_wan->len,
+								&nicTx_wan) <
+							0) {
+							dev_kfree_skb_any
+								(skb_wan);
+						}
+					}
+				}
+			}	/* hw-vlan */
+#endif
+		}
+	}
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+#if defined (CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	else if (((skb->data[0]==0x33) && (skb->data[1]==0x33) && (skb->data[2]!=0xff))||(type>=PPPOE_ICMPV6))
+#else
+	else if ((skb->data[0]==0x33) && (skb->data[1]==0x33) && (skb->data[2]!=0xff))
+#endif
+	{
+
+		if (mldSnoopEnabled != TRUE) {
+			return -1;
+		}
+		if (cp->portnum <= 1) {
+			return -1;
+		}
+#if defined (CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+		if(type>=PPPOE_ICMPV6)
+			ipv6h=rtl_get_pppoe_ipv6_hdr(skb->data,1,0);
+		else
+#endif
+			ipv6h=re865x_getIpv6Header(skb->data);
+
+		if (ipv6h != NULL) {
+			l4Protocol = re865x_getIpv6TransportProtocol(ipv6h);
+			/*udp or tcp packet */
+			if((l4Protocol==IPPROTO_UDP) || (l4Protocol==IPPROTO_TCP))
+			{
+				/*only process tcp/udp in igmp snooping data plane */
+				multicastDataInfo.ipVersion = 6;
+				memcpy(&multicastDataInfo.sourceIp,
+					&ipv6h->saddr, 16);
+				memcpy(&multicastDataInfo.groupAddr,
+					&ipv6h->daddr, 16);
+				multicastDataInfo.sourceIp[0] =
+					ntohl(multicastDataInfo.sourceIp[0]);
+				multicastDataInfo.sourceIp[1] =
+					ntohl(multicastDataInfo.sourceIp[1]);
+				multicastDataInfo.sourceIp[2] =
+					ntohl(multicastDataInfo.sourceIp[2]);
+				multicastDataInfo.sourceIp[3] =
+					ntohl(multicastDataInfo.sourceIp[3]);
+				multicastDataInfo.groupAddr[0] =
+					ntohl(multicastDataInfo.groupAddr[0]);
+				multicastDataInfo.groupAddr[1] =
+					ntohl(multicastDataInfo.groupAddr[1]);
+				multicastDataInfo.groupAddr[2] =
+					ntohl(multicastDataInfo.groupAddr[2]);
+				multicastDataInfo.groupAddr[3] =
+					ntohl(multicastDataInfo.groupAddr[3]);
+				ret = rtl_getMulticastDataFwdInfo
+					(nicIgmpModuleIndex, &multicastDataInfo,
+					&multicastFwdInfo);
+
+#ifdef CONFIG_RTL_VLAN_8021Q
+				if (linux_vlan_enable) {
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU) && defined(CONFIG_RTL_8021Q_VLAN_SUPPORT_SRC_TAG) && (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 4, 0))
+					if ((skb->passThruFlag &
+							IS_IP6_MC_PASSTHRU)
+						&& (skb->
+							passThruFlag &
+							FLOOD_IN_BRIDGE))
+						nicTx->portlist &=
+							((1 << RTL8651_MAC_NUMBER) - 1) & (~(1 << src_port));
+					else
+						nicTx->portlist &=
+							multicastFwdInfo.
+							fwdPortMask & ((1 <<
+								RTL8651_MAC_NUMBER)
+							-
+							1) & (~(1 << src_port));
+#else
+					nicTx->portlist &=
+						multicastFwdInfo.
+						fwdPortMask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1) & (~(1 << src_port));
+#endif
+				} else
+					nicTx->portlist =
+						multicastFwdInfo.
+						fwdPortMask & cp->
+						portmask & ((1 <<
+							RTL8651_MAC_NUMBER) -
+						1);
+#else
+				nicTx->portlist =
+					multicastFwdInfo.fwdPortMask & cp->
+					portmask & ((1 << RTL8651_MAC_NUMBER) -
+					1);
+#endif
+			}
+
+		}
+
+	}
+#endif
+	return 0;
+}
+#endif
+
+/* #if defined(CONFIG_RTK_VLAN_SUPPORT) && defined(CONFIG_RTK_VLAN_FOR_CABLE_MODEM) */
+struct net_device *re865x_get_netdev_by_name(const char *name)
+{
+	int i;
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		if (_rtl86xx_dev.dev[i]
+			&& (strcmp(_rtl86xx_dev.dev[i]->name, name) == 0))
+			return _rtl86xx_dev.dev[i];
+	}
+	return NULL;
+}
+
+/* #endif */
+
+#if 0				/* defined(CONFIG_RTL_STP) */
+static inline int rtl_process_stp_tx(rtl_nicTx_info *txInfo)
+{
+	struct net_device *dev;
+	struct sk_buff *skb = NULL;
+	struct dev_priv *cp;
+	uint8 stpPortNum;
+
+	skb = txInfo->out_skb;
+	dev = skb->dev;
+	cp = NETDRV_PRIV(dev);
+	if (!dev->irq) {
+		/* virtual interfaces have no IRQ assigned. */
+		/* We use device name to identify STP port interfaces(virtual devices). */
+		if (memcmp((void *)(dev->name), "port", 4) == 0) {
+			if ((skb->data[0] & 0x01)
+				&& !memcmp(&(skb->data[0]), STPmac, 5)
+				&& !(skb->data[5] & 0xF0)) {
+				stpPortNum =
+					dev->name[strlen(dev->name) - 1] - '0';
+				if (STP_PortDev_Mapping[stpPortNum] !=
+					NO_MAPPING) {
+					cp->id = getVidByPort(stpPortNum);
+					cp->portmask =
+						1 <<
+						STP_PortDev_Mapping[stpPortNum];
+					cp->portnum = 1;	/* Multicast process will check this entry. */
+				} else {
+					dev_kfree_skb_any(skb);
+					return FAILED;
+				}
+			} else {
+				/* To STP port interfaces(virtual devices), drop non bpdu tx pkt. */
+				dev_kfree_skb_any(skb);
+				return FAILED;
+			}
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+static inline int rtl_process_vlan_tag(rtl_nicTx_info *txInfo)
+{
+
+	struct sk_buff *skb = NULL;
+	struct sk_buff *newskb;
+	struct net_device *dev;
+	struct dev_priv *cp;
+
+	skb = txInfo->out_skb;
+	dev = skb->dev;
+	cp = NETDRV_PRIV(dev);
+
+	if (vlan_tag && skb->srcPhyPort == RX_FROM_LOCAL) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+		if ((rtl865x_curOpMode == GATEWAY_MODE
+			&& cp->id == vlanconfig[RTL_WAN_IDX].vid)
+			|| (rtl865x_curOpMode == BRIDGE_MODE))
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		if ((rtl865x_curOpMode == GATEWAY_MODE
+			&& cp->id == vlanconfig[1].vid)
+			|| (rtl865x_curOpMode == BRIDGE_MODE))
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		{
+
+			newskb = NULL;
+			if (skb_cloned(skb)) {
+				newskb = skb_copy(skb, GFP_ATOMIC);
+				if (newskb == NULL) {
+					cp->net_stats.tx_dropped++;
+					dev_kfree_skb_any(skb);
+					return FAILED;
+				}
+				dev_kfree_skb_any(skb);
+				skb = newskb;
+				txInfo->out_skb = skb;
+			}
+			if (*((unsigned short *)(skb->data + ETH_ALEN * 2)) !=
+				__constant_htons(ETH_P_8021Q)) {
+				if (skb_headroom(skb) < VLAN_HLEN
+					&& skb_cow(skb, VLAN_HLEN) != 0) {
+					printk("%s-%d: error! (skb_headroom(skb) == %d < %d). Enlarge it!\n", __FUNCTION__, __LINE__, skb_headroom(skb), VLAN_HLEN);
+					while (1);
+				}
+				skb_push(skb, VLAN_HLEN);
+				memmove(skb->data, skb->data + VLAN_HLEN,
+					VLAN_ETH_ALEN << 1);
+				*(uint16 *)(&(skb->data[12])) =
+					__constant_htons(ETH_P_8021Q);
+				*(uint16 *)(&(skb->data[14])) = htons(vlan_tag) & 0x0fff;	/* VID */
+				*(uint8 *)(&(skb->data[14])) |=
+					(((uint8)vlan_host_pri) & 0x7) << 5;
+			}
+		}
+	}
+	return SUCCESS;
+}
+#endif
+
+/* __MIPS16 */
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+static inline int rtl_process_passthru_tx(rtl_nicTx_info *txInfo)
+{
+	struct net_device *dev;
+	struct sk_buff *skb = NULL;
+	struct dev_priv *cp;
+
+	if (oldStatus) {
+		skb = txInfo->out_skb;
+		dev = skb->dev;
+		if (dev == _rtl86xx_dev.pdev) {
+			if (SUCCESS == rtl_isPassthruFrame(skb->data)) {
+				cp = NETDRV_PRIV(_rtl86xx_dev.pdev);
+				skb->dev = cp->dev;
+
+			} else {
+				dev_kfree_skb_any(skb);
+				return FAILED;
+			}
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+static inline int rtl_process_rtk_vlan_tx(rtl_nicTx_info *txInfo)
+{
+	struct net_device *dev;
+	struct sk_buff *skb = NULL;
+	struct sk_buff *newskb;
+	struct dev_priv *cp;
+#if	definedCONFIG_PPPOE_VLANTAG
+	struct vlan_tag tag, *adding_tag;
+	struct vlan_info *info;
+	uint8 *data;
+#endif
+
+	if (rtk_vlan_support_enable) {
+		skb = txInfo->out_skb;
+		dev = skb->dev;
+		cp = NETDRV_PRIV(dev);
+		if (cp->vlan_setting.global_vlan) {
+			newskb = NULL;
+			if (skb_cloned(skb)) {
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+				newskb = priv_skb_copy(skb);
+#else
+				newskb = skb_copy(skb, GFP_ATOMIC);
+#endif
+				if (newskb == NULL) {
+					cp->net_stats.tx_dropped++;
+					dev_kfree_skb_any(skb);
+					return FAILED;
+				}
+				dev_kfree_skb_any(skb);
+				skb = newskb;
+				txInfo->out_skb = skb;
+			}
+
+			if (tx_vlan_process(dev, &cp->vlan_setting, skb, 0)) {
+				cp->net_stats.tx_dropped++;
+				dev_kfree_skb_any(skb);
+				return FAILED;
+			}
+		}
+	}
+#if	defined(CONFIG_PPPOE_VLANTAG)
+
+	info = rtl_get_PPPOE_vlanInfo();
+	if (info->vlan && info->tag) {
+		skb = txInfo->out_skb;
+		cp = skb->dev->priv;
+		if (skb_cloned(skb)) {
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+			newskb = priv_skb_copy(skb);
+#else
+			newskb = skb_copy(skb, GFP_ATOMIC);
+#endif
+			if (newskb == NULL) {
+				cp->net_stats.tx_dropped++;
+				dev_kfree_skb_any(skb);
+				return FAILED;
+			}
+			dev_kfree_skb_any(skb);
+			skb = newskb;
+			txInfo->out_skb = skb;
+		}
+
+		data = skb->data;
+		if (((*((uint16 *)(data + (ETH_ALEN << 1))) ==
+					__constant_htons(ETH_P_PPP_SES))
+				|| (*((uint16 *)(data + (ETH_ALEN << 1))) ==
+					__constant_htons(ETH_P_PPP_DISC)))
+			|| ((*((uint16 *)(data + (ETH_ALEN << 1))) ==
+					__constant_htons(ETH_P_8021Q))
+				&& ((*((uint16 *)(data + (ETH_ALEN << 1) +
+								VLAN_HLEN)) ==
+						__constant_htons(ETH_P_PPP_SES))
+					|| (*((uint16 *)(data + (ETH_ALEN << 1)
+								+ VLAN_HLEN)) ==
+						__constant_htons
+						(ETH_P_PPP_DISC))))) {
+
+			/* add vlan tag */
+			memcpy(&tag, skb->data + ETH_ALEN * 2, VLAN_HLEN);
+			if (tag.f.tpid != htons(ETH_P_8021Q)) {	/* tag not existed, insert tag */
+				if (skb_headroom(skb) < VLAN_HLEN
+					&& skb_cow(skb, VLAN_HLEN) != 0) {
+					printk("%s-%d: error! (skb_headroom(skb) == %d < 4). Enlarge it!\n", __FUNCTION__, __LINE__, skb_headroom(skb));
+					while (1);
+				}
+				skb_push(skb, VLAN_HLEN);
+				memmove(skb->data, skb->data + VLAN_HLEN,
+					ETH_ALEN * 2);
+			}
+			COPY_TAG(tag, info);
+
+			adding_tag = &tag;
+
+			memcpy(skb->data + ETH_ALEN * 2, adding_tag, VLAN_HLEN);
+
+		}
+	}
+#endif
+
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT)
+int rtl_process_vlan_passthrough_tx(struct sk_buff **ppskb)
+{
+	struct sk_buff *skb = NULL, *newskb = NULL;
+	struct dev_priv *cp = NULL;
+
+	if (!ppskb)
+		return FAILED;
+
+	skb = *ppskb;
+	if (!skb)
+		return FAILED;
+	cp = skb->dev->priv;
+
+	/* Tag already existed. */
+	if (*(uint16 *)(&skb->data[ETH_ALEN << 1]) ==
+		__constant_htons(ETH_P_8021Q))
+		return SUCCESS;
+
+	if (*(uint16 *)skb->vlan_passthrough_saved_tag ==
+		__constant_htons(ETH_P_8021Q)) {
+		newskb = NULL;
+
+		if (skb_cloned(skb)) {
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+			newskb = priv_skb_copy(skb);
+#else
+			newskb = skb_copy(skb, GFP_ATOMIC);
+#endif
+
+			if (newskb == NULL) {
+				cp->net_stats.tx_dropped++;
+				dev_kfree_skb_any(skb);
+				*ppskb = NULL;
+				return FAILED;
+			}
+			dev_kfree_skb_any(skb);
+			skb = newskb;
+			*ppskb = newskb;
+		}
+
+		if (skb_headroom(skb) < VLAN_HLEN
+			&& skb_cow(skb, VLAN_HLEN) != 0) {
+			printk("%s-%d: error! (skb_headroom(skb) == %d < 4). Enlarge it!\n", __FUNCTION__, __LINE__, skb_headroom(skb));
+			while (1);
+		}
+
+		skb_push(skb, VLAN_HLEN);
+		memmove(skb->data, skb->data + VLAN_HLEN, ETH_ALEN * 2);
+		memcpy(skb->data + ETH_ALEN * 2,
+			skb->vlan_passthrough_saved_tag, VLAN_HLEN);
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTL_8021Q_VLAN_SUPPORT_SRC_TAG)
+/* Skb must be rcved from WAN port. */
+uint16 rtl_get_linux_vlan_src_tag_vid(struct sk_buff *skb)
+{
+	struct dev_priv *cp = NULL;
+
+	if (!skb)
+		return RTL_WANVLANID;
+
+	cp = (struct dev_priv *)NETDRV_PRIV(skb->dev);
+
+	/* Tag already existed. */
+	if (*(uint16 *)(&skb->data[ETH_ALEN << 1]) ==
+		__constant_htons(ETH_P_8021Q))
+		return RTL_WANVLANID;
+
+	/* Pkt from NAT LAN group. */
+	if (*(uint16 *)skb->linux_vlan_src_tag == __constant_htons(ETH_P_8021Q)) {
+		return ntohs(*(short *)(skb->linux_vlan_src_tag + 2)) & 0x0fff;
+	} else			/* Pkt from DUT itself. */
+	{
+		return rtk_vlan_wan_vid;
+	}
+}
+
+int rtl_process_linux_vlan_tx_check(rtl_nicTx_info *txInfo)
+{
+	struct dev_priv *cp = NULL;
+	struct sk_buff *skb = NULL;
+	uint16 vid = 0;
+
+	skb = (struct sk_buff *)txInfo->out_skb;
+	cp = (struct dev_priv *)NETDRV_PRIV(skb->dev);
+
+	if (cp->id != rtk_vlan_wan_vid)	/* LAN tx. */
+	{
+		/* Hw-NAT wan->lan, change hw-NAT vid to 9. */
+		if (*(unsigned short *)(skb->data + (ETH_ALEN << 1)) ==
+			__constant_htons(ETH_P_8021Q)) {
+			vid = ntohs(*(unsigned short *)(skb->data +
+					(ETH_ALEN << 1) + 2));
+			if ((vid & 0x0fff) == rtk_vlan_wan_vid) {
+				vid = (vid & 0xf000) | RTL_LANVLANID;
+				*(unsigned short *)(skb->data +
+					(ETH_ALEN << 1) + 2) = htons(vid);
+			}
+		}
+	}
+
+	if (cp->id == rtk_vlan_wan_vid)	/* WAN tx. */
+	{
+		/* When NAT group is configured, packet forwarding from vid 9 lan to wan is blocked. */
+		if (rtk_vlan_wan_vid != RTL_WANVLANID &&
+			*(unsigned short *)(skb->linux_vlan_src_tag) ==
+			__constant_htons(ETH_P_8021Q)) {
+			vid = ntohs(*(unsigned short *)(skb->
+					linux_vlan_src_tag + 2));
+			if ((vid & 0x0fff) == RTL_LANVLANID)
+				return FAILED;
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+static inline int rtl_pstProcess_xmit(struct dev_priv *cp,
+	struct net_device *dev, int len)
+{
+#if !defined(CONFIG_RTL_NIC_HWSTATS)
+	cp->net_stats.tx_packets++;
+	cp->net_stats.tx_bytes += len;
+#endif
+	/*jwj: directly use skb->dev may more safer. */
+	/* cp->dev->trans_start = jiffies; */
+	#if defined(CONFIG_RTD_1295_HWNAT) && LINUX_VERSION_CODE >= KERNEL_VERSION(4, 7, 0)
+	if (dev)
+		netif_trans_update(dev);
+	#else
+	if (dev)
+		dev->trans_start = jiffies;
+	#endif /* CONFIG_RTD_1295_HWNAT */
+
+	return SUCCESS;
+}
+
+static inline int rtl_preProcess_xmit(rtl_nicTx_info *txInfo)
+{
+	int retval = SUCCESS;
+
+#if 0				/* defined(CONFIG_RTL_STP) */
+	retval = rtl_process_stp_tx(txInfo);
+	if (FAILED == retval)
+		return retval;
+#endif
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+	retval = rtl_process_passthru_tx(txInfo);
+	if (FAILED == retval)
+		return retval;
+#endif
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+	retval = rtl_process_hw_vlan_tx(txInfo);
+	if (FAILED == retval)
+		return retval;
+#endif
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	retval = rtl_process_rtk_vlan_tx(txInfo);
+	if (FAILED == retval)
+		return retval;
+#endif
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	retval = rtl_process_vlan_tag(txInfo);
+	return retval;
+#endif
+#if defined(CONFIG_RTL_VLAN_PASSTHROUGH_SUPPORT)
+	retval = rtl_process_vlan_passthrough_tx((struct sk_buff **)&txInfo->
+		out_skb);
+	if (FAILED == retval)
+		return retval;
+#endif
+#if defined(CONFIG_RTL_8021Q_VLAN_SUPPORT_SRC_TAG)
+	if (linux_vlan_enable) {
+		if (rtl865x_curOpMode == GATEWAY_MODE) {
+			retval = rtl_process_linux_vlan_tx_check(txInfo);
+			if (FAILED == retval) {
+				dev_kfree_skb_any(txInfo->out_skb);
+				return retval;
+			}
+		}
+	}
+#endif
+#if defined(REINIT_SWITCH_CORE)
+	if (rtl865x_duringReInitSwtichCore == 1) {
+		dev_kfree_skb_any(txInfo->out_skb);
+		return FAILED;
+	}
+#endif
+
+	return retval;
+}
+
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+inline void rtl_direct_txInfo(uint32 port_mask, rtl_nicTx_info *txInfo)
+#else
+static inline void rtl_direct_txInfo(uint32 port_mask, rtl_nicTx_info *txInfo)
+#endif
+{
+#ifdef CONFIG_SWCONFIG
+	if (swconfig_vlan_enable) {
+		/* keep portlist decide previos */
+		txInfo->portlist = txInfo->portlist & 0x3f;
+		/* remove packet tag if need for autotag HW support to overcome mc/bc tag member is not fixed. */
+		rtk_rm_skb_vid((struct sk_buff *)txInfo->out_skb);
+	} else
+#endif
+		txInfo->portlist = port_mask & 0x3f;
+	txInfo->srcExtPort = 0;	/* PKTHDR_EXTPORT_LIST_CPU; */
+	txInfo->flags = (PKTHDR_USED | PKT_OUTGOING);
+#ifdef CONFIG_RTL_VLAN_8021Q
+	if (vlan_ctl_p->flag)
+		rtk_rm_skb_vid((struct sk_buff *)txInfo->out_skb);
+#endif
+}
+
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+inline void rtl_hwLookup_txInfo(rtl_nicTx_info *txInfo)
+#else
+static inline void rtl_hwLookup_txInfo(rtl_nicTx_info *txInfo)
+#endif
+{
+	txInfo->portlist = RTL8651_CPU_PORT;	/* must be set 0x7 */
+	txInfo->srcExtPort = PKTHDR_EXTPORT_LIST_CPU;
+	txInfo->flags =
+		(PKTHDR_USED | PKTHDR_HWLOOKUP | PKTHDR_BRIDGING |
+		PKT_OUTGOING);
+}
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+static inline void rtl_direct_txInfo3(uint32 port_mask, rtl_nicTx_info *txInfo)
+{
+	txInfo->portlist = port_mask & 0x3f;
+	txInfo->srcExtPort = PKTHDR_EXTPORT_LIST_CPU;	/* PKTHDR_EXTPORT_LIST_CPU; */
+	txInfo->flags = (PKTHDR_USED | PKT_OUTGOING);
+}
+
+static inline void rtl_hwLookup_txInfo3(rtl_nicTx_info *txInfo)
+{
+	txInfo->portlist = RTL8651_CPU_PORT;	/* must be set 0x7 */
+	txInfo->srcExtPort = PKTHDR_EXTPORT_LIST_CPU;	/* 2->7 */
+	/* txInfo->flags = (PKTHDR_USED|PKTHDR_HWLOOKUP|PKT_OUTGOING|CSUM_TCPUDP|CSUM_IP); */
+	txInfo->flags = (PKTHDR_USED | PKTHDR_HWLOOKUP | PKT_OUTGOING);
+
+}
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+static inline void rtl_hwLookup_txInfo2(rtl_nicTx_info *txInfo)
+{
+	txInfo->portlist = RTL8651_CPU_PORT;	/* must be set 0x7 */
+	txInfo->srcExtPort = PKTHDR_EXTPORT_LIST_P2;	/* 2->7 */
+	txInfo->flags =
+		(PKTHDR_USED | PKTHDR_HWLOOKUP | PKTHDR_BRIDGING |
+		PKT_OUTGOING);
+}
+#endif
+static inline int rtl_ip_option_check(struct sk_buff *skb)
+{
+	int flag = FALSE;
+	if (((*((unsigned short *)(skb->data + ETH_ALEN * 2)) ==
+				__constant_htons(ETH_P_IP))
+			&& ((*((unsigned char *)(skb->data + ETH_ALEN * 2 +
+							2)) != 0x45)))
+		|| ((*((unsigned short *)(skb->data + ETH_ALEN * 2)) ==
+				__constant_htons(ETH_P_8021Q))
+			&& (*((unsigned short *)(skb->data + ETH_ALEN * 2 +
+						2)) ==
+				__constant_htons(ETH_P_IP))
+			&& ((*((unsigned char *)(skb->data + ETH_ALEN * 2 +
+							4)) != 0x45))))
+		flag = TRUE;
+	return flag;
+}
+
+#if defined(CONFIG_RTL_HW_TX_CSUM)
+unsigned char hw_csum_cache_mac[6];
+unsigned int hw_csum_cache_port;
+#endif
+
+#ifndef CONFIG_RTL_VLAN_8021Q
+static inline int rtl_isHwlookup(struct sk_buff *skb, struct dev_priv *cp,
+	uint32 *portlist)
+#else
+static inline int rtl_isHwlookup(uint16 vid, struct sk_buff *skb,
+	struct dev_priv *cp, uint32 *portlist)
+#endif
+{
+	int flag = FALSE;
+
+#if defined(CONFIG_RTL_HTTP_REDIRECT_LOCAL)
+	if (is_skb_http_packet(skb)) {
+		*portlist = cp->portmask;
+		return FALSE;
+	}
+#endif
+
+/* #if defined(CONFIG_RTL_MULTI_LAN_DEV) ||defined(CONFIG_POCKET_ROUTER_SUPPORT) */
+#if defined(CONFIG_POCKET_ROUTER_SUPPORT)
+	*portlist = cp->portmask;
+	return FALSE;
+#elif defined(CONFIG_RTK_VLAN_SUPPORT)
+	if (rtk_vlan_support_enable == 1) {
+		*portlist = cp->portmask;
+		return FALSE;
+	}
+#endif
+
+#if defined(CONFIG_RTL_HW_TX_CSUM) && !defined(CONFIG_RTL_MULTI_LAN_DEV)
+	if (skb->ip_summed == CHECKSUM_PARTIAL) {
+		/* L4 checksum is un-complete, need to enable HW Tx checksum feature */
+		/* in 8198C and before IC, it only can use direct Tx mode */
+
+		if (rtl_isWanDev(cp) != TRUE) {	/* LAN interface */
+			int portmask;
+			extern int getL2MbrByMac(unsigned char *mac);
+
+			if (memcmp(skb->data, hw_csum_cache_mac, 6) == 0) {
+				*portlist = hw_csum_cache_port;
+			} else {
+				portmask = getL2MbrByMac(skb->data);
+				if (portmask != -1) {
+					*portlist = portmask;
+
+					hw_csum_cache_port = portmask;
+					memcpy(hw_csum_cache_mac, skb->data, 6);
+				} else	/* not found, broadcast it */
+					*portlist = cp->portmask;
+			}
+			return FALSE;	/* direct Tx always */
+
+		} else {
+			*portlist = cp->portmask;
+			return FALSE;
+		}
+	}
+#endif
+
+#ifdef CONFIG_RTL_VLAN_8021Q
+	/* if (linux_vlan_enable&&linux_vlan_hw_support_enable) */
+	if (linux_vlan_enable) {
+		return rtk_isHwlookup_vlan(vid, skb, portlist);
+	}
+#endif
+
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+	if ((rtl_ip_option_check(skb) != TRUE))
+#else
+	if ((rtl_isWanDev(cp) != TRUE) && (rtl_ip_option_check(skb) != TRUE))
+#endif
+	{
+#if defined(CONFIG_RTL_INBAND_CTL_ACL)
+		int portNum = -1;
+		if (*((uint16 *)(skb->data + (ETH_ALEN << 1))) ==
+			__constant_htons(inband_ctl_acl_ethernet_type))
+			portNum = rtl865x_getPortNum(skb->data);
+		if (portNum != -1) {
+			*portlist = 1 << portNum;
+			flag = FALSE;
+			return flag;
+		} else
+#endif
+			flag = TRUE;
+	} else {
+		flag = FALSE;
+	}
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+#ifndef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT	/* new hw vlan , bridge can use HW look due to Brigger vlan will add tag when UC !! */
+	if ((rtk_vlan_support_enable == 0)
+		&& ((!memcmp(cp->dev->name, "eth2", 5))
+			|| (!memcmp(cp->dev->name, "eth3", 5))
+			|| (!memcmp(cp->dev->name, "eth4", 5))))
+		flag = FALSE;
+#endif
+#endif
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+	/* hyking: */
+	/* when hw local public and sw localpublic exist at same time, */
+	/* pkt to sw local public would be trap to cpu by default ACL */
+	/* 2010-02-22 */
+	flag = FALSE;
+	if (rtl_isWanDev(cp) != TRUE) {
+		/* hyking: default acl issue, direct tx now... */
+		rtl865x_getPortlistByMac(skb->data, portlist);
+	} else
+#endif
+	if (flag == FALSE) {
+		*portlist = cp->portmask;
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+		if (rtl_isWanDev(cp) == TRUE)
+			*portlist = (*portlist) & RTL_WANPORT_MASK;	/* to wan UC only to Wan port */
+#endif
+	}
+
+	return flag;
+}
+
+static inline int rtl_fill_txInfo(rtl_nicTx_info *txInfo)
+{
+	uint32 portlist;
+	struct sk_buff *skb = txInfo->out_skb;
+	struct dev_priv *cp;
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	int type;
+#endif
+
+	cp = NETDRV_PRIV(skb->dev);
+
+#ifdef CONFIG_RTL_VLAN_8021Q
+	if (vlan_ctl_p->flag) {
+		uint16 skb_vid = 0;
+		/* if packet with tag , then use the vid as nictx vid. */
+		/* if packet without tag  use cp->id as its vlan */
+		skb_vid = rtk_get_skb_vid(skb);
+		if (skb_vid != 0) {
+			txInfo->vid = skb_vid;
+			txInfo->portlist = rtk_get_vlan_portmask(skb_vid);	/* only 0~5 port */
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+			txInfo->portlist &= cp->portmask;
+#endif
+		} else {
+#ifdef CONFIG_RTL_8021Q_VLAN_SUPPORT_SRC_TAG
+			if (rtl865x_curOpMode == GATEWAY_MODE
+				&& cp->id == rtk_vlan_wan_vid) {
+				txInfo->vid =
+					rtl_get_linux_vlan_src_tag_vid(skb);
+				txInfo->portlist = RTL_WANPORT_MASK;
+			} else
+#endif
+			{
+				txInfo->vid = cp->id;
+				txInfo->portlist = cp->portmask;
+			}
+		}
+	} else
+#endif
+		txInfo->vid = cp->id;
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	if ((skb->dev->priv_flags & IFF_DOMAIN_WAN)
+		&& (skb->vlan_tci & VLAN_VID_MASK)) {
+		txInfo->vid = skb->vlan_tci & VLAN_VID_MASK;
+	}
+#endif
+
+#if defined(CONFIG_RTK_VOIP_QOS)
+	txInfo->priority = 0;
+#endif
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	txInfo->priority = rtl_qosGetPriorityByVid(cp->id, skb->mark);
+#endif
+
+	/* default output queue is 0 */
+	txInfo->txIdx = 0;
+
+#if (defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)) && !defined(CONFIG_RTL_CPU_TAG)
+	rtl_direct_txInfo((0x1 << RTL8197D_RGMII_PORT), txInfo);	/* always send to 8197D port 0 */
+	return SUCCESS;
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	txInfo->tagport = 0;
+#endif
+
+#ifdef CONFIG_SWCONFIG
+	rtk_fill_vlan_txinfo(skb, &txInfo->vid, &txInfo->portlist);
+#endif
+
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+	type = rtl_is_pppoe_igmp_bridge_frame(skb, 1, skb->data);
+	if ((skb->data[0] & 0x01) == 0 && type == 0)
+#else
+	if ((skb->data[0] & 0x01) == 0)
+#endif
+	{
+#ifndef CONFIG_RTL_VLAN_8021Q
+		if (rtl_isHwlookup(skb, cp, &portlist) == TRUE)
+#else
+		if (rtl_isHwlookup(txInfo->vid, skb, cp, &portlist) == TRUE)
+#endif
+		{
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+			if (vlan_bridge_tag && cp->id == vlan_bridge_tag) {
+				rtl_hwLookup_txInfo2(txInfo);
+			} else
+#endif
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+			if (txInfo->wFlags == 1) {
+				rtl_hwLookup_txInfo3(txInfo);
+			} else
+#endif
+				rtl_hwLookup_txInfo(txInfo);
+		} else {
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+			if (txInfo->wFlags == 1) {
+				rtl_direct_txInfo3(portlist, txInfo);
+			} else
+#endif
+				rtl_direct_txInfo(portlist, txInfo);
+		}
+	} else {
+		/*multicast process */
+#if defined(CONFIG_RTL_VLAN_8021Q) && !defined(CONFIG_OPENWRT_SDK)
+		if (vlan_ctl_p->flag) {
+			rtl_direct_txInfo(txInfo->portlist, txInfo);
+		} else {
+			rtl_direct_txInfo(cp->portmask, txInfo);
+		}
+#else
+		rtl_direct_txInfo(cp->portmask, txInfo);
+#endif
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+		/*multicast process */
+		if (((skb->data[0] == 0x01) && (skb->data[1] == 0x00)
+				&& (skb->data[2] == 0x5e))
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+			|| ((skb->data[0] == 0x33) && (skb->data[1] == 0x33)
+				&& (skb->data[2] != 0xFF))
+#endif
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+			|| (type != 0)
+#endif
+			) {
+			re865x_setMCastTxInfo(skb, cp->dev, txInfo);
+		}
+#endif
+
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+		checkMulticatTxInfo(skb, cp->dev, txInfo);
+#endif
+
+	}
+
+	/* for WAN Tag */
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+	if ((vlan_bridge_tag && cp->id == vlan_bridge_tag) || (vlan_tag
+			&& cp->id == vlan_tag))
+		txInfo->tagport = RTL_WANPORT_MASK;
+#endif
+
+	if (txInfo->portlist == 0) {
+		dev_kfree_skb_any(skb);
+		return FAILED;
+	}
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+static int rtl_bridge_wan_start_xmit(struct sk_buff *skb,
+	struct net_device *dev)
+{
+	struct net_device *wan_dev = NULL;
+	if (!memcmp(lan_macaddr, skb->data + 6, 6)) {
+		dev_kfree_skb_any(skb);
+		return 0;
+	}
+	/* printk("[%s][%d]-skb->dev[%s],proto(0x%x)\n", __FUNCTION__, __LINE__, skb->dev->name,skb->protocol); */
+	wan_dev = rtl_get_wan_from_vlan_info();
+
+	if (wan_dev) {
+		skb->dev = wan_dev;
+		wan_dev->netdev_ops->ndo_start_xmit(skb, wan_dev);
+	}
+	return 0;
+}
+#endif
+
+#if ((defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)) && !defined(CONFIG_RTL_CPU_TAG)) || defined(CONFIG_RTL_LINK_AGGREGATION)
+struct sk_buff *insert_vlan_tag(struct sk_buff *skb, int vid)
+{
+	struct sk_buff *newskb = NULL;
+
+	if (*((unsigned short *)(skb->data + ETH_ALEN * 2)) !=
+		__constant_htons(ETH_P_8021Q)) {
+		if (skb_cloned(skb) /* && skb->ppp_cloned == 0 */) {
+			newskb = skb_copy(skb, GFP_ATOMIC);
+			if (newskb == NULL) {
+				return NULL;
+			}
+			dev_kfree_skb_any(skb);
+			skb = newskb;
+		}
+		if (skb_headroom(skb) < VLAN_HLEN)
+			skb_cow(skb, VLAN_HLEN);
+
+		/* vlan tag */
+		skb_push(skb, VLAN_HLEN);
+		memmove(skb->data, skb->data + VLAN_HLEN, VLAN_ETH_ALEN << 1);
+
+		*(uint16 *)(&(skb->data[14])) = htons(vid);	/* VID */
+		*(uint16 *)(&(skb->data[12])) = __constant_htons(ETH_P_8021Q);	/* TPID */
+		*(uint8 *)(&(skb->data[14])) &= 0x0f;	/* clear most-significant nibble of byte 14 */
+	}
+	return skb;
+}
+#endif
+
+#if  defined(CONFIG_RTL_PPPOE_DIRECT_REPLY)
+void extract_magicNum(struct sk_buff *skb);
+extern int magicNum;
+#endif
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+static int rtl_insert_vlan_tag(struct sk_buff **skb, unsigned int vid,
+	unsigned int priority)
+{
+	struct sk_buff *tmpskb;
+	unsigned char insert[16];
+	u16 *vlan_tci;
+	struct ethhdr *eth;
+	struct vlan_ethhdr *veth;
+
+	if (skb_cloned(*skb)) {
+		tmpskb = skb_copy(*skb, GFP_ATOMIC);
+		dev_kfree_skb_any(*skb);
+		if (tmpskb == NULL)
+			return 0;
+		*skb = tmpskb;
+	}
+
+	if (skb_headroom(*skb) < 4) {
+		tmpskb = skb_realloc_headroom(*skb, 4);
+		dev_kfree_skb_any(*skb);
+		if (tmpskb == NULL)
+			return 0;
+		*skb = tmpskb;
+	}
+#ifdef CONFIG_E8B
+#ifdef CONFIG_NETFILTER
+	if ((*skb)->mark & (1 << 16)) {	/* marked by IPQoS */
+		insert[0] =
+			(((*skb)->
+				mark & 0x7) << 5) | (priority << 5) | (vid >>
+			8);
+	} else if (((*skb)->mark & 0x7) >= 1) {
+		insert[0] =
+			((((*skb)->mark & 0x7) -
+				1) << 5) | (priority << 5) | (vid >> 8);
+	} else
+#endif
+		insert[0] = (priority << 5) | (vid >> 8);
+#else
+#ifdef CONFIG_NETFILTER
+	insert[0] = (priority << 5) | (vid >> 8);
+#else
+	insert[0] = vid >> 8;
+#endif
+#endif
+	insert[1] = vid & 0xff;
+	vlan_tci = (u16 *)insert;
+
+	eth = (struct ethhdr *)(*skb)->data;
+	if (eth->h_proto != htons(ETH_P_8021Q)) {
+		veth = (struct vlan_ethhdr *)skb_push(*skb, VLAN_HLEN);
+		/* Move the mac addresses to the beginning of the new header. */
+		memmove((*skb)->data, (*skb)->data + VLAN_HLEN,
+			2 * VLAN_ETH_ALEN);
+		/* first, the ethernet type */
+		veth->h_vlan_proto = htons(ETH_P_8021Q);
+
+		/* now, the TCI */
+		veth->h_vlan_TCI = htons(*vlan_tci);
+	} else {
+		veth = (struct vlan_ethhdr *)(*skb)->data;
+		/* the TCI */
+		veth->h_vlan_TCI = htons(*vlan_tci);
+	}
+
+	return 1;
+}
+#endif
+#define	RTL_NIC_TX_RETRY_MAX		(128)
+__MIPS16 __IRAM_FWD
+	static int re865x_start_xmit(struct sk_buff *skb,
+	struct net_device *dev)
+{
+	int retval, tx_retry_cnt;
+	struct dev_priv *cp;
+	struct sk_buff *tx_skb;
+	rtl_nicTx_info nicTx;
+
+#ifdef CONFIG_RTK_OPENVPN_HW_CRYPTO
+	int vpn_port, encrypt_ret = 0;
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	dma_addr_t mapping = 0;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_SMP)
+	unsigned long flags = 0;
+	SMP_LOCK_ETH_XMIT(flags);
+#endif
+#ifdef CONFIG_RTK_OPENVPN_HW_CRYPTO
+	vpn_port = get_openvpn_port();
+	/* printk("\n%s vpn_port=%d\n",__FUNCTION__,vpn_port); */
+	if (vpn_port > 0 && vpn_port < 65536) {
+		if (skb->len > 43 && *((uint8 *)(skb->data + 23)) == 17
+			&& *((uint16 *)(skb->data + 34)) == vpn_port
+			&& (*((uint16 *)(skb->data + 20)) & ntohs(0x3fff)) == 0)
+			/* if(skb->len>43 && *((uint8*)(skb->data+23))==17 && *((uint16*)(skb->data+34))==vpn_port) */
+		{
+			/* printk("\n%s calling rtk_openvpn_hw_encrypto()!\n",__FUNCTION__); */
+			encrypt_ret = rtk_openvpn_hw_encrypto(skb, 1);	/* static/dhcp */
+		}
+		/* else if(skb->len>51 && *((uint8*)(skb->data+31))==17  && *((uint16*)(skb->data+42))==vpn_port  && (*((uint16*)(skb->data+28)) & 0x3fff)==0) */
+		else if (skb->len > 51 && *((uint8 *)(skb->data + 31)) == 17
+			&& *((uint16 *)(skb->data + 42)) == vpn_port
+			&& (*((uint16 *)(skb->data + 28)) & ntohs(0x3fff)) ==
+			0) {
+			/* printk("\n%s calling rtk_openvpn_hw_encrypto()!\n",__FUNCTION__); */
+			encrypt_ret = rtk_openvpn_hw_encrypto(skb, 2);	/* pppoe */
+		}
+		if (encrypt_ret < 0) {
+			printk("\n%s free skb!\n", __FUNCTION__);
+			dev_kfree_skb_any(skb);
+
+#if defined(CONFIG_SMP)
+			SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+
+			return 0;
+		}
+	}
+#endif
+#if defined(CONFIG_RTL_PPPOE_DIRECT_REPLY)
+	if (magicNum == -1)
+		extract_magicNum(skb);
+#endif
+
+	memset((void *)&nicTx, 0, sizeof(rtl_nicTx_info));
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	if (dev && (strncmp(dev->name, "wlan", 4) == 0))
+		nicTx.wFlags = 1;
+	else
+		nicTx.wFlags = 0;
+#endif
+	nicTx.out_skb = skb;
+	retval = rtl_preProcess_xmit(&nicTx);
+
+	if (FAILED == retval) {
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+		return 0;
+	}
+
+	tx_skb = nicTx.out_skb;
+	cp = NETDRV_PRIV(tx_skb->dev);
+
+	if (
+#ifndef CONFIG_RTL_ISP_MULTI_WAN_SUPPORT
+		(cp->id == 0) ||
+#else
+		((tx_skb->dev->priv_flags & IFF_DOMAIN_ELAN) && (cp->id == 0))
+		||
+#endif
+		(cp->portmask == 0)) {
+		dev_kfree_skb_any(tx_skb);
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+		return 0;
+	}
+#if (defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)) && !defined(CONFIG_RTL_CPU_TAG)
+	tx_skb = nicTx.out_skb = insert_vlan_tag(skb, cp->id);
+	if (tx_skb == NULL) {
+		dev_kfree_skb_any(skb);
+		return 0;
+	}
+#endif
+
+	retval = rtl_fill_txInfo(&nicTx);
+	if (FAILED == retval) {
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+		return 0;
+	}
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+	if ((cp->portmask & RTL_WANPORT_MASK)
+		&& (nicTx.flags & PKTHDR_HWLOOKUP)) {
+		skb = nicTx.out_skb;
+		/* panic_printk("%s %d cp->id=%d dev->name=%s \n", __FUNCTION__, __LINE__, cp->id, dev->name); */
+		/* tx_skb = nicTx.out_skb = insert_vlan_tag(skb, cp->id); */
+		tx_skb = nicTx.out_skb = insert_vlan_tag(skb, RTL_WANVLANID);
+		if (tx_skb == NULL) {
+			/* dev_kfree_skb_any(skb); */
+			return 0;
+		}
+	}
+#endif
+
+#if defined(CONFIG_RTL_QOS_PATCH) || defined(CONFIG_RTK_VOIP_QOS)
+	if (((struct sk_buff *)tx_skb)->srcPhyPort == QOS_PATCH_RX_FROM_LOCAL) {
+		nicTx.priority = QOS_PATCH_HIGH_QUEUE_PRIO;
+		nicTx.txIdx = RTL865X_SWNIC_TXRING_MAX_PKTDESC - 1;	/* use the highest tx ring index, note: not RTL865X_SWNIC_TXRING_HW_PKTDESC-1 */
+	}
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT_WLAN)
+	if (((struct sk_buff *)tx_skb)->srcPhyPort ==
+		QOS_PATCH_RX_FROM_WIRELESS) {
+		if (strncmp(tx_skb->dev->name, RTL_DRV_WAN0_NETIF_NAME,
+				IFNAMSIZ) == 0) {
+			nicTx.priority =
+				rtl_qosGetPriorityByMark(tx_skb->dev->name,
+				skb->mark);
+			nicTx.txIdx = RTL865X_SWNIC_TXRING_MAX_PKTDESC - 1;	/* use the highest tx ring index, note: not RTL865X_SWNIC_TXRING_HW_PKTDESC-1 */
+		}
+	}
+#endif
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+	if ((dot1x_config.enable) && (rtl_is802dot1xFrame(skb->data))
+		&& (!dot1x_config.enable_unicastresp)) {
+		rtl_802dot1xFilltxInfo(skb, &nicTx);
+	}
+#endif
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	if (enable_port_mapping) {
+		int port_mask = 0;
+
+		if ((tx_skb->from_dev && (tx_skb->from_dev->priv_flags & (IFF_DOMAIN_ELAN | IFF_DOMAIN_WLAN))) && (tx_skb->dev->priv_flags & IFF_DOMAIN_WAN)) {	/* upstream */
+#if 0
+			if (tx_skb->from_dev->priv_flags & IFF_DOMAIN_ELAN) {
+				TOKEN_NUM(tx_skb->from_dev->name, &port);
+				if (port > 1)
+					port -= 1;
+			} else if (tx_skb->from_dev->
+				priv_flags & IFF_DOMAIN_WLAN) {
+				TOKEN_NUM(tx_skb->from_dev->name, &port);
+			}
+#else
+			port_mask =
+				rtl_get_bind_port_mask_by_dev_name(tx_skb->
+				from_dev->name);
+#endif
+
+			if (!(tx_skb->vlan_member & port_mask)) {
+				if (net_ratelimit())
+					printk("upstream packet[%s -> %s] block by port mapping rule (member 0x%x).\n", tx_skb->from_dev->name, tx_skb->dev->name, tx_skb->vlan_member);
+				dev_kfree_skb_any(tx_skb);
+#if defined(CONFIG_SMP)
+				SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+
+				return 0;
+			}
+		} else if (tx_skb->from_dev
+			&& (tx_skb->from_dev->priv_flags & IFF_DOMAIN_WAN)) {
+			if (!rtl_smux_downstream_port_mapping_check(tx_skb)) {
+				if (net_ratelimit())
+					printk("downstream packet[%s -> %s] block by port mapping rule (member 0x%x).\n", tx_skb->from_dev->name, tx_skb->dev->name, tx_skb->vlan_member);
+				dev_kfree_skb_any(tx_skb);
+#if defined(CONFIG_SMP)
+				SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+
+				return 0;
+			}
+		}
+	}
+
+	if ((RTL_WANVLANID != nicTx.vid) && (RTL_LANVLANID != nicTx.vid)
+		&& (RTL_BRIDGE_WANVLANID != nicTx.vid)) {
+		if (!rtl_insert_vlan_tag(&tx_skb, nicTx.vid,
+				tx_skb->vlan_tci >> 13)) {
+#if defined(CONFIG_SMP)
+			SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+			return 0;
+		}
+	} else if ((tx_skb->mark & (1 << 7)) && ((tx_skb->mark >> 20) > 0)
+		&& (dev->priv_flags & IFF_DOMAIN_WAN)) {
+		/* nicTx.vid is RTL_WANVLANID  or RTL_LANVLANID or RTL_BRIDGE_WANVLANID */
+		/* means no configured VLAN ID for this WAN interface, so checking mark setting in skb by the QoS/VLAN rules */
+		/* and replace the vid/priority. */
+
+		if (!rtl_insert_vlan_tag(&tx_skb, tx_skb->mark >> 20,
+				tx_skb->mark & 0x7)) {
+#if defined(CONFIG_SMP)
+			SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+			return 0;
+		}
+	}
+#endif
+
+#if defined(CONFIG_RTL_VLAN_8021Q)
+#if defined(CONFIG_RTL_QOS_8021P_SUPPORT) && !defined(CONFIG_RTL_SWITCH_NEW_DESCRIPTOR)
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	if (gHwNatEnabled == 0)
+#endif
+	{
+		if (rtl865x_curOpMode == GATEWAY_MODE &&
+			(nicTx.portlist & 0x1f) == RTL_WANPORT_MASK &&
+			(rtk_get_vlan_tagmask(nicTx.vid) & RTL_WANPORT_MASK)) {
+			rtk_insert_vlan_tag(nicTx.vid, tx_skb);
+		}
+	}
+#endif
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_ETH_TX_SG) || defined(CONFIG_RTL_TSO) || defined(CONFIG_RTL_GSO)
+	if (skb_shinfo(tx_skb)->nr_frags > 0) {
+		uint32 dlen;
+		dlen = tx_skb->len - tx_skb->data_len;
+
+		if (dlen > 0) {
+			mapping =
+				dma_map_single(&rtl819x_pdev->dev, tx_skb->data,
+				dlen, DMA_TO_DEVICE);
+			/* DBG("dma_map_single(dev 0x%p, start 0x%p, len %d, dir %d) = mapping 0x%x", &rtl819x_pdev->dev, tx_skb->data, dlen, DMA_TO_DEVICE, (uint) mapping); */
+			if (unlikely(dma_mapping_error(&rtl819x_pdev->dev,
+						mapping))) {
+				if (net_ratelimit())
+					netif_err(cp, drv, tx_skb->dev,
+						"Failed to map TX DMA!\n");
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+				tx_drop_cnt++;
+#endif
+				dev_kfree_skb_any(tx_skb);
+#if defined(CONFIG_SMP)
+				SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+				return 0;
+			}
+		}
+	} else {
+		mapping =
+			dma_map_single(&rtl819x_pdev->dev, tx_skb->data,
+			tx_skb->len, DMA_TO_DEVICE);
+		/* DBG("dma_map_single(dev 0x%p, start 0x%p, len %d, dir %d) = mapping 0x%x", &rtl819x_pdev->dev, tx_skb->data, tx_skb->len, DMA_TO_DEVICE, (uint) mapping); */
+		if (unlikely(dma_mapping_error(&rtl819x_pdev->dev, mapping))) {
+			if (net_ratelimit())
+				netif_err(cp, drv, tx_skb->dev,
+					"Failed to map TX DMA!\n");
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+			tx_drop_cnt++;
+#endif
+			dev_kfree_skb_any(tx_skb);
+#if defined(CONFIG_SMP)
+			SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+			return 0;
+		}
+	}
+#else
+	mapping =
+		dma_map_single(&rtl819x_pdev->dev, tx_skb->data, tx_skb->len,
+		DMA_TO_DEVICE);
+	/* DBG("dma_map_single(dev 0x%p, start 0x%p, len %d, dir %d) = mapping 0x%x", &rtl819x_pdev->dev, tx_skb->data, tx_skb->len, DMA_TO_DEVICE, (uint) mapping); */
+	if (unlikely(dma_mapping_error(&rtl819x_pdev->dev, mapping))) {
+		if (net_ratelimit())
+			netif_err(cp, drv, tx_skb->dev,
+				"Failed to map TX DMA!\n");
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+		tx_drop_cnt++;
+#endif
+		dev_kfree_skb_any(tx_skb);
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+		return 0;
+	}
+#endif
+#else /* !defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTL_ETH_TX_SG) || defined(CONFIG_RTL_TSO) || defined(CONFIG_RTL_GSO)
+	{
+		if (skb_shinfo(tx_skb)->nr_frags > 0)
+			RTL_CACHE_WBACK((unsigned long)tx_skb->data,
+				(tx_skb->len - tx_skb->data_len));
+		else
+			RTL_CACHE_WBACK((unsigned long)tx_skb->data,
+				tx_skb->len);
+	}
+#else
+	RTL_CACHE_WBACK((unsigned long)tx_skb->data, tx_skb->len);
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	tx_retry_cnt = 0;
+	while (1) {
+		/* do not suitable to use RTL_swNic_send */
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_SWITCH_NEW_DESCRIPTOR)
+#if (defined(CONFIG_RTL_TSO) || defined(CONFIG_RTL_GSO))
+		if ((skb_shinfo(tx_skb)->nr_frags > 0)
+			|| (skb_shinfo(tx_skb)->gso_size > 0)) {
+			retval = _New_swNic_send_tso_sg((void *)tx_skb,
+				(void *)mapping, tx_skb->len, &nicTx);
+		} else {
+			retval = _New_swNic_send((void *)tx_skb,
+				(void *)mapping, tx_skb->len, &nicTx);
+		}
+#else
+		retval = _New_swNic_send((void *)tx_skb, (void *)mapping,
+			tx_skb->len, &nicTx);
+#endif
+#else
+#if defined(CONFIG_SMP)
+		retval = _swNic_send((void *)tx_skb, (void *)mapping,
+			tx_skb->len, &nicTx);
+#else
+		retval = swNic_send((void *)tx_skb, (void *)mapping,
+			tx_skb->len, &nicTx);
+#endif
+#endif
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTL_SWITCH_NEW_DESCRIPTOR)
+#if (defined(CONFIG_RTL_TSO) || defined(CONFIG_RTL_GSO))
+		if ((skb_shinfo(tx_skb)->nr_frags > 0)
+			|| (skb_shinfo(tx_skb)->gso_size > 0)) {
+			retval = New_swNic_send_tso_sg(tx_skb, tx_skb->data,
+				tx_skb->len, &nicTx);
+		} else {
+			retval = New_swNic_send((void *)tx_skb, tx_skb->data,
+				tx_skb->len, &nicTx);
+		}
+#else
+		retval = New_swNic_send((void *)tx_skb, tx_skb->data,
+			tx_skb->len, &nicTx);
+#endif
+#else
+#if defined(CONFIG_SMP)
+		retval = _swNic_send((void *)tx_skb, tx_skb->data, tx_skb->len,
+			&nicTx);
+#else
+		retval = swNic_send((void *)tx_skb, tx_skb->data, tx_skb->len,
+			&nicTx);
+#endif
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		if (retval >= 0)
+			break;
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+		tx_ringFull_cnt++;
+#endif
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_SMP)
+		SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+
+		RTL_swNic_txDone(nicTx.txIdx);
+
+#if defined(CONFIG_SMP)
+		SMP_LOCK_ETH_XMIT(flags);
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+		if ((tx_retry_cnt++) > RTL_NIC_TX_RETRY_MAX) {
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+			tx_drop_cnt++;
+#endif
+			dev_kfree_skb_any(tx_skb);
+#if defined(CONFIG_SMP)
+			SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+			return 0;
+		}
+	}
+
+	rtl_pstProcess_xmit(cp, tx_skb->dev, tx_skb->len);
+	/* cp->net_stats.tx_packets++; */
+	/* cp->net_stats.tx_bytes += tx_skb->len; */
+#if defined(CONFIG_SMP)
+	SMP_UNLOCK_ETH_XMIT(flags);
+#endif
+
+	return 0;
+}
+
+static void re865x_tx_timeout(struct net_device *dev)
+{
+	rtlglue_printf("Tx Timeout!!! Can't send packet\n");
+}
+
+#if defined(RTL819X_PRIV_IOCTL_ENABLE)
+int rtl819x_get_port_status(int portnum, struct lan_port_status *port_status)
+{
+	uint32 regData;
+	uint32 data0;
+
+	if (portnum < 0 || portnum > CPU)
+		return -1;
+
+	regData = READ_MEM32(PSRP0 + ((portnum) << 2));
+
+	/* printk("rtl819x_get_port_status port = %d data=%x\n", portnum,regData); //mark_debug */
+	data0 = regData & PortStatusLinkUp;
+	if (data0)
+		port_status->link = 1;
+	else
+		port_status->link = 0;
+
+	data0 = regData & PortStatusNWayEnable;
+	if (data0)
+		port_status->nway = 1;
+	else
+		port_status->nway = 0;
+
+	data0 = regData & PortStatusDuplex;
+	if (data0)
+		port_status->duplex = 1;
+	else
+		port_status->duplex = 0;
+
+	data0 = (regData & PortStatusLinkSpeed_MASK) >>
+		PortStatusLinkSpeed_OFFSET;
+	port_status->speed = data0;	/* 0 = 10M , 1= 100M , 2=1G , */
+
+	return 0;
+}
+
+int rtl819x_get_port_stats(int portnum, struct port_statistics *port_stats)
+{
+
+	uint32 addrOffset_fromP0 = 0;
+
+	/* printk("rtl819x_get_port_stats port = %d \n", portnum); //mark_debug */
+	if (portnum < 0 || portnum > CPU)
+		return -1;
+
+	addrOffset_fromP0 = portnum * MIB_ADDROFFSETBYPORT;
+
+	/* port_stats->rx_bytes =(uint32) (rtl865xC_returnAsicCounter64( OFFSET_IFINOCTETS_P0 + addrOffset_fromP0 )) ; */
+	port_stats->rx_bytes =
+		rtl8651_returnAsicCounter(OFFSET_IFINOCTETS_P0 +
+		addrOffset_fromP0);
+	port_stats->rx_unipkts =
+		rtl8651_returnAsicCounter(OFFSET_IFINUCASTPKTS_P0 +
+		addrOffset_fromP0);
+	port_stats->rx_mulpkts =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSMULTICASTPKTS_P0 +
+		addrOffset_fromP0);
+	port_stats->rx_bropkts =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSBROADCASTPKTS_P0 +
+		addrOffset_fromP0);
+	port_stats->rx_discard =
+		rtl8651_returnAsicCounter(OFFSET_DOT1DTPPORTINDISCARDS_P0 +
+		addrOffset_fromP0);
+	port_stats->rx_error =
+		(rtl8651_returnAsicCounter(OFFSET_DOT3STATSFCSERRORS_P0 +
+			addrOffset_fromP0) +
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSJABBERS_P0 +
+			addrOffset_fromP0));
+
+	/* port_stats->tx_bytes =(uint32) (rtl865xC_returnAsicCounter64( OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0 )) ; */
+	port_stats->tx_bytes =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTOCTETS_P0 +
+		addrOffset_fromP0);
+	port_stats->tx_unipkts =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTUCASTPKTS_P0 +
+		addrOffset_fromP0);
+	port_stats->tx_mulpkts =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTMULTICASTPKTS_P0 +
+		addrOffset_fromP0);
+	port_stats->tx_bropkts =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTBROADCASTPKTS_P0 +
+		addrOffset_fromP0);
+	port_stats->tx_discard =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTDISCARDS +
+		addrOffset_fromP0);
+	port_stats->tx_error =
+		(rtl8651_returnAsicCounter(OFFSET_ETHERSTATSCOLLISIONS_P0 +
+			addrOffset_fromP0) +
+		rtl8651_returnAsicCounter
+		(OFFSET_DOT3STATSDEFERREDTRANSMISSIONS_P0 + addrOffset_fromP0));
+
+	return 0;
+}
+
+int re865x_priv_ioctl(struct net_device *dev, struct ifreq *rq, int cmd)
+{
+	int32 rc = 0;
+	unsigned long *data_32;
+	int portnum = 0;
+	struct lan_port_status port_status;
+	struct port_statistics port_stats;
+
+	data_32 = (unsigned long *)rq->ifr_data;
+	if (copy_from_user(&portnum, data_32, 1 * sizeof(unsigned long))) {
+		return -EFAULT;
+	}
+
+	switch (cmd) {
+	case RTL819X_IOCTL_READ_PORT_STATUS:
+		rc = rtl819x_get_port_status(portnum, &port_status);	/* portnumber */
+		if (rc != 0) {
+			return -EFAULT;
+		}
+		if (copy_to_user((void *)rq->ifr_data, (void *)&port_status,
+				sizeof(struct lan_port_status))) {
+			return -EFAULT;
+		}
+		break;
+	case RTL819X_IOCTL_READ_PORT_STATS:
+		rc = rtl819x_get_port_stats(portnum, &port_stats);	/* portnumber */
+		if (rc != 0)
+			return -EFAULT;
+		if (copy_to_user((void *)rq->ifr_data, (void *)&port_stats,
+				sizeof(struct port_statistics)))
+			return -EFAULT;
+		break;
+		break;
+	default:
+		rc = -EOPNOTSUPP;
+		break;
+	}
+	return SUCCESS;
+
+}
+#endif
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+#define MAX_LINK_STATUS_PID		8
+struct link_status {
+	uint16 valid;
+	int pid;
+};
+struct link_status link_status_pid[MAX_LINK_STATUS_PID];
+
+int rtl_link_status_pid_init(void)
+{
+	int ret = 0;
+	int i = 0;
+
+	for (i = 0; i < MAX_LINK_STATUS_PID; i++) {
+
+		link_status_pid[i].valid = 0;
+		link_status_pid[i].pid = 0;
+	}
+
+	return ret;
+}
+
+int rtl_set_linkstatus_pid(int pid)
+{
+	int ret = FAILED;
+	int i = 0;
+	for (i = 0; i < MAX_LINK_STATUS_PID; i++) {
+		if (link_status_pid[i].valid == 0) {
+			link_status_pid[i].valid = 1;
+			link_status_pid[i].pid = pid;
+			ret = SUCCESS;
+			return ret;
+		}
+	}
+
+	return ret;
+}
+
+void rtl_signal_linkdetect(void)
+{
+
+	struct task_struct *task;
+	int i;
+	int pid = 0;
+	int cnt = 0;
+	for (i = 0; i < MAX_LINK_STATUS_PID; i++) {
+		if (link_status_pid[i].valid) {
+			pid = link_status_pid[i].pid;
+			if (pid) {
+				read_lock(&tasklist_lock);
+				task = find_task_by_vpid(pid);
+				read_unlock(&tasklist_lock);
+				if (task) {
+					send_sig(SIGUSR2, task, 0);
+				} else {
+					panic_printk
+						("Path selection daemon pid: %d does not exist\n",
+						pid);
+				}
+				cnt++;
+			}
+		}
+	}
+
+	if (cnt == 0)
+		panic_printk
+			("Path selection daemon pid: %d does not register\n",
+			pid);
+
+	return;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtk_linkstatus_pid_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s %d\n", "rtk_auto_dhcp_enable:", 0);
+	return 0;
+}
+#else
+static int32 rtk_linkstatus_pid_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+	int i = 0;
+	len += sprintf(page, "dump wan link status pid\n");
+	for (i = 0; i < MAX_LINK_STATUS_PID; i++) {
+
+		if (link_status_pid[i].valid)
+			len += sprintf(page + len, "[%d]:%d \n", i,
+				link_status_pid[i].pid);
+
+	}
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+	return len;
+
+}
+#endif
+static int32 rtk_linkstatus_pid_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[64];
+	char *tokptr, *strptr;
+	int index, valid, pid;
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		strptr = tmpbuf;
+		tokptr = strsep(&strptr, " ");
+		if (tokptr != NULL) {
+			index = simple_strtol(tokptr, NULL, 0);
+			if (index < 0 || index >= MAX_LINK_STATUS_PID)
+				goto errout;
+			/* if(!memcmp(tokptr,"eth1",4)) */
+			{
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL)
+					goto errout;
+				valid = simple_strtol(tokptr, NULL, 0);
+				if (valid)
+					valid = 1;
+
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL)
+					goto errout;
+
+				pid = simple_strtol(tokptr, NULL, 0);
+				printk("%d, %d, %d,[%s]:[%d].\n", index, valid,
+					pid, __FUNCTION__, __LINE__);
+				link_status_pid[index].valid = valid;
+				link_status_pid[index].pid = pid;
+
+			}
+
+		}
+
+	}
+
+	return len;
+errout:
+	printk("invaild parameter!\n");
+	return -EFAULT;
+}
+#endif
+int re865x_ioctl(struct net_device *dev, struct ifreq *rq, int cmd)
+{
+	int32 rc = 0;
+	unsigned long *data;
+#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t args[4];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	int32 args[4];
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	int32 *pRet;
+
+#ifdef SUPPORT_DHCP_PORT_IP_BIND
+	uint8 client_mac[ETH_ALEN];
+	uint8 *pargs = (uint8 *)&args[1];
+	int i;
+	uint16 port_id = 0;
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT) || \
+	(defined(CONFIG_RTL_CPU_TAG) && defined(CONFIG_RTL_836X_SUPPORT))
+	extern int rtk_port_phyStatus_get(uint32 port, uint32 *pLinkStatus,
+		uint32 *pSpeed, uint32 *pDuplex);
+	uint32 linkStatus, speed, duplex;
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (!netif_running(dev))
+		return -ENODEV;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	if (cmd == RTL8651_IOCTL_CLEARBRSHORTCUTENTRY) {
+#ifdef BR_SHORTCUT
+		cached_dev = NULL;
+		cached_dev2 = NULL;
+		cached_dev3 = NULL;
+		cached_dev4 = NULL;
+#endif
+		return 0;
+	}
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+	rc = rtl_802dot1xIoctl(dev, rq, cmd);
+	if (rc != -EOPNOTSUPP) {
+		return rc;
+	}
+#endif
+
+	if (cmd != SIOCDEVPRIVATE) {
+#if defined(RTL819X_PRIV_IOCTL_ENABLE)
+		rc = re865x_priv_ioctl(dev, rq, cmd);
+		return rc;
+#else
+		goto normal;
+#endif
+	}
+
+	data = (unsigned long *)rq->ifr_data;
+
+	if (copy_from_user(args, data, 4 * sizeof(unsigned long))) {
+		return -EFAULT;
+	}
+
+	switch (args[0]) {
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT) || \
+	(defined(CONFIG_RTL_CPU_TAG) && defined(CONFIG_RTL_836X_SUPPORT))
+	case RTL8651_IOCTL_GETWANLINKSTATUS:
+		{
+			pRet = (int32 *)args[3];
+			*pRet = FAILED;
+			rc = SUCCESS;
+
+			spin_lock(&rtl836x_ext_lock);
+			rc = rtk_port_phyStatus_get(RTL83XX_WAN, &linkStatus,
+				&speed, &duplex);
+			spin_unlock(&rtl836x_ext_lock);
+
+			if (rc == SUCCESS) {
+				if (linkStatus == 1) {
+					*pRet = SUCCESS;
+				}
+			}
+			break;
+		}
+#else
+	case RTL8651_IOCTL_GETWANLINKSTATUS:
+		{
+			int i;
+			int wanPortMask;
+			int32 totalVlans;
+
+			pRet = (int32 *)args[3];
+			*pRet = FAILED;
+			rc = SUCCESS;
+
+			wanPortMask = 0;
+			totalVlans =
+				((sizeof(vlanconfig)) /
+				(sizeof(struct rtl865x_vlanConfig))) - 1;
+			for (i = 0; i < totalVlans; i++) {
+				if (vlanconfig[i].isWan == TRUE)
+					wanPortMask = vlanconfig[i].memPort;
+			}
+			if (wanPortMask == 0) {
+				/* no wan port exist */
+				break;
+			}
+
+			for (i = 0; i < RTL8651_AGGREGATOR_NUMBER; i++) {
+				if ((1 << i) & wanPortMask) {
+					if ((READ_MEM32(PSRP0 + (i << 2)) &
+							PortStatusLinkUp) !=
+						0) {
+								*pRet = SUCCESS;
+							}
+					break;
+				}
+			}
+			break;
+		}
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT) || \
+	(defined(CONFIG_RTL_CPU_TAG) && defined(CONFIG_RTL_836X_SUPPORT))
+	case RTL8651_IOCTL_GETWANLINKSPEED:
+		{
+			pRet = (int32 *)args[3];
+			*pRet = FAILED;
+
+			spin_lock(&rtl836x_ext_lock);
+			rc = rtk_port_phyStatus_get(RTL83XX_WAN, &linkStatus,
+				&speed, &duplex);
+			spin_unlock(&rtl836x_ext_lock);
+
+			if (rc == SUCCESS) {
+				*pRet = speed;
+			}
+			break;
+		}
+#else
+	case RTL8651_IOCTL_GETWANLINKSPEED:
+		{
+			int i;
+			int wanPortMask;
+			int32 totalVlans;
+
+			pRet = (int32 *)args[3];
+			*pRet = FAILED;
+			rc = FAILED;
+
+			wanPortMask = 0;
+			totalVlans =
+				((sizeof(vlanconfig)) /
+				(sizeof(struct rtl865x_vlanConfig))) - 1;
+			for (i = 0; i < totalVlans; i++) {
+				if (vlanconfig[i].isWan == TRUE)
+					wanPortMask = vlanconfig[i].memPort;
+			}
+
+			if (wanPortMask == 0) {
+				/* no wan port exist */
+				break;
+			}
+
+			for (i = 0; i < RTL8651_AGGREGATOR_NUMBER; i++) {
+				if ((1 << i) & wanPortMask) {
+					break;
+				}
+			}
+
+			switch (READ_MEM32(PSRP0 +
+					(i << 2)) & PortStatusLinkSpeed_MASK) {
+			case PortStatusLinkSpeed10M:
+				*pRet = PortStatusLinkSpeed10M;
+				rc = SUCCESS;
+				break;
+			case PortStatusLinkSpeed100M:
+				*pRet = PortStatusLinkSpeed100M;
+				rc = SUCCESS;
+				break;
+			case PortStatusLinkSpeed1000M:
+				*pRet = PortStatusLinkSpeed1000M;
+				rc = SUCCESS;
+				break;
+			default:
+				break;
+			}
+			break;
+		}
+#endif
+
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+	case RTL8651_IOCTL_SET_GETLINKSTATUS_PID:
+		{
+			rc = rtl_set_linkstatus_pid(args[1]);
+			break;
+
+		}
+#endif
+#ifdef SUPPORT_DHCP_PORT_IP_BIND
+	case RTL8651_IOCTL_GETPORTIDBYCLIENTMAC:
+		{
+			memcpy(client_mac, pargs, ETH_ALEN);
+			for (i = 0; i < RTL8651_PHY_NUMBER; i++) {
+				if (memcmp(port_mac_table[i].client_mac,
+						client_mac, ETH_ALEN) == 0) {
+					port_id = port_mac_table[i].port_id;
+					break;
+				}
+			}
+			if (port_id > 0)
+				copy_to_user(rq->ifr_data, &port_id,
+					sizeof(port_id));
+			break;
+		}
+#endif
+	default:
+		rc = SUCCESS;
+		break;
+	}
+
+	return rc;
+#if !defined(RTL819X_PRIV_IOCTL_ENABLE)
+normal:
+#endif
+	if (!netif_running(dev))
+		return -EINVAL;
+	switch (cmd) {
+	default:
+		rc = -EOPNOTSUPP;
+		break;
+	}
+	return rc;
+}
+
+static int rtl865x_set_hwaddr(struct net_device *dev, void *addr)
+{
+	unsigned long flags = 0;
+	int i;
+	unsigned char *p;
+	ps_drv_netif_mapping_t *mapp_entry;
+	struct rtl865x_vlanConfig *vlancfg_entry;
+
+	p = ((struct sockaddr *)addr)->sa_data;
+	SMP_LOCK_ETH(flags);
+
+	for (i = 0; i < ETHER_ADDR_LEN; ++i) {
+		dev->dev_addr[i] = p[i];
+	}
+
+	mapp_entry = rtl_get_ps_drv_netif_mapping_by_psdev(dev);
+	if (mapp_entry == NULL)
+		goto out;
+
+	vlancfg_entry = rtl_get_vlanconfig_by_netif_name(mapp_entry->drvName);
+	if (vlancfg_entry == NULL)
+		goto out;
+
+	if (vlancfg_entry->vid != 0) {
+		rtl865x_netif_t netif;
+		memcpy(vlancfg_entry->mac.octet, dev->dev_addr, ETHER_ADDR_LEN);
+		memcpy(netif.macAddr.octet, vlancfg_entry->mac.octet,
+			ETHER_ADDR_LEN);
+		memcpy(netif.name, vlancfg_entry->ifname, MAX_IFNAMESIZE);
+		rtl865x_setNetifMac(&netif);
+	}
+
+out:
+	SMP_UNLOCK_ETH(flags);
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL8186_LINK_CHANGE)
+static int rtl865x_set_link(struct net_device *dev, int enable)
+{
+	int32 i;
+	struct dev_priv *cp;
+	int32 portmask;
+	int32 totalVlans;
+
+	cp = NETDRV_PRIV(dev);
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+	portmask = cp->portmask;
+#else
+	portmask = 0;
+	totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		1;
+
+	for (i = 0; i < totalVlans; i++) {
+		if (vlanconfig[i].vid == cp->id) {
+			portmask = vlanconfig[i].memPort;
+			break;
+		}
+	}
+#endif
+	if (portmask) {
+		if (enable) {
+			for (i = 0; i < RTL8651_PHY_NUMBER; i++) {
+				if (portmask & (1 << i)) {
+					rtl865xC_setAsicEthernetForceModeRegs(i,
+						FALSE, TRUE, 1, TRUE);
+					rtl8651_restartAsicEthernetPHYNway(i);
+				}
+			}
+		} else {
+			for (i = 0; i < RTL8651_PHY_NUMBER; i++) {
+				if (portmask & (1 << i))
+					rtl865xC_setAsicEthernetForceModeRegs(i,
+						TRUE, FALSE, 1, TRUE);
+			}
+		}
+	}
+
+	return SUCCESS;
+}
+#endif
+
+static int rtl865x_set_mtu(struct net_device *dev, int new_mtu)
+{
+	unsigned long flags = 0;
+	ps_drv_netif_mapping_t *mapp_entry;
+	struct rtl865x_vlanConfig *vlancfg_entry;
+
+	SMP_LOCK_ETH(flags);
+	dev->mtu = new_mtu;
+
+	mapp_entry = rtl_get_ps_drv_netif_mapping_by_psdev(dev);
+	if (mapp_entry == NULL)
+		goto out;
+
+	vlancfg_entry = rtl_get_vlanconfig_by_netif_name(mapp_entry->drvName);
+	if (vlancfg_entry == NULL)
+		goto out;
+
+	if (vlancfg_entry->vid != 0) {
+		rtl865x_netif_t netif;
+		vlancfg_entry->mtu = new_mtu;
+		netif.mtu = new_mtu;
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		netif.mtuV6 = new_mtu;
+#endif
+		memcpy(netif.name, vlancfg_entry->ifname, MAX_IFNAMESIZE);
+
+		rtl865x_setNetifMtu(&netif);
+	}
+#ifdef CONFIG_HARDWARE_NAT_DEBUG
+	/*2007-12-19 */
+	rtlglue_printf("%s:%d:new_mtu is %d\n", __FUNCTION__, __LINE__,
+		new_mtu);
+#endif
+
+out:
+	SMP_UNLOCK_ETH(flags);
+
+	return SUCCESS;
+}
+
+#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+#else
+static const struct net_device_ops rtl819x_netdev_ops = {
+	.ndo_open = re865x_open,
+	.ndo_stop = re865x_close,
+	.ndo_validate_addr = eth_validate_addr,
+	.ndo_set_mac_address = rtl865x_set_hwaddr,
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3, 2, 0)
+	.ndo_set_multicast_list = re865x_set_rx_mode,
+#endif
+	.ndo_get_stats = re865x_get_stats,
+	.ndo_do_ioctl = re865x_ioctl,
+	.ndo_start_xmit = re865x_start_xmit,
+	.ndo_tx_timeout = re865x_tx_timeout,
+#if defined(CP_VLAN_TAG_USED)
+	.ndo_vlan_rx_register = cp_vlan_rx_register,
+#endif
+	.ndo_change_mtu = rtl865x_set_mtu,
+
+};
+
+#if !defined(CONFIG_COMPAT_NET_DEV_OPS) && defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+static const struct net_device_ops rtl819x_netdev_ops_bridge = {
+	.ndo_open = re865x_open,
+	.ndo_stop = re865x_close,
+	.ndo_validate_addr = eth_validate_addr,
+	.ndo_set_mac_address = rtl865x_set_hwaddr,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3, 4, 0)
+	.ndo_set_multicast_list = re865x_set_rx_mode,
+#endif
+	.ndo_get_stats = re865x_get_stats,
+	.ndo_do_ioctl = re865x_ioctl,
+	.ndo_start_xmit = rtl_bridge_wan_start_xmit,
+	.ndo_tx_timeout = re865x_tx_timeout,
+#if defined(CP_VLAN_TAG_USED)
+	.ndo_vlan_rx_register = cp_vlan_rx_register,
+#endif
+	.ndo_change_mtu = rtl865x_set_mtu,
+
+};
+#endif
+
+#endif
+
+#if (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_IPV6READYLOGO)
+static int rtl865x_addAclForIPV6ReadyLogo(struct rtl865x_vlanConfig *vlanConfig)
+{
+#if 1
+	int i;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	static struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER];
+#endif
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+
+	rtl865x_AclRule_t rule;
+	int ret = FAILED;
+
+	if (vlanConfig == NULL) {
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	re865x_packVlanConfig(vlanConfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+#else
+	pVlanConfig = vlanConfig;
+#endif
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+
+		if (pVlanConfig[i].isWan == 0) {	/*lan config */
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED, RTL865X_ACL_INGRESS);
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_IPV6;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.ipv6EntryType_ = 1;
+			/*::1/128 */
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[0] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[1] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[2] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[3] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[4] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[5] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[6] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[7] = ntohs(0x01);
+			ntohl_array((u32 *)&rule.un_ty.L3V6._dstIpV6Addr.
+				v6_addr32[0],
+				(u32 *)&rule.un_ty.L3V6._dstIpV6Addr.
+				v6_addr32[0], 4);
+
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[0] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[1] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[2] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[3] =
+				0xffffffff;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+
+			rule.ipv6EntryType_ = 0;
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+
+#if 0
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_IPV6;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.ipv6EntryType_ = 1;
+			/*3ffe:501:ffff:0:200:ff:fe00:100/128 */
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[0] = 0x3ffe;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[1] = 0x0501;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[2] = 0xffff;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[3] = 0x0;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[4] = 0x200;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[5] = 0x00ff;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[6] = 0xfe00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[7] = 0x100;
+
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[0] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[1] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[2] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[3] =
+				0xffffffff;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+
+			rule.ipv6EntryType_ = 0;
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+#endif
+		} else {	/*wan config */
+
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED, RTL865X_ACL_INGRESS);
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_IPV6;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.ipv6EntryType_ = 1;
+			/*fe80::3a83:45ff:fef3:974 */
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[0] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[1] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[2] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[3] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[4] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[5] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[6] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[7] = ntohs(0x01);
+			ntohl_array((u32 *)&rule.un_ty.L3V6._dstIpV6Addr.
+				v6_addr32[0],
+				(u32 *)&rule.un_ty.L3V6._dstIpV6Addr.
+				v6_addr32[0], 4);
+
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[0] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[1] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[2] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[3] =
+				0xffffffff;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+
+			rule.ipv6EntryType_ = 0;
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_IPV6;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.ipv6EntryType_ = 1;
+			/*fe80::/64 */
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[0] =
+				ntohs(0xfe80);
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[1] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[2] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[3] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[4] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[5] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[6] = 0x00;
+			rule.un_ty.L3V6._dstIpV6Addr.v6_addr16[7] = 0x00;
+			ntohl_array((u32 *)&rule.un_ty.L3V6._dstIpV6Addr.
+				v6_addr32[0],
+				(u32 *)&rule.un_ty.L3V6._dstIpV6Addr.
+				v6_addr32[0], 4);
+
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[0] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[1] =
+				0xffffffff;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[2] =
+				0x0;
+			rule.un_ty.L3V6._dstIpV6AddrMask.inv6_u.u6_addr32[3] =
+				0x0;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+
+			rule.ipv6EntryType_ = 0;
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+		}
+	}
+#endif
+	return SUCCESS;
+}
+#endif
+#if  defined(CONFIG_RTL_HARDWARE_MULTICAST)
+static int rtl865x_addAclForIgmpSnooping(struct rtl865x_vlanConfig *vlanConfig)
+{
+#if  defined(CONFIG_RTL_HARDWARE_MULTICAST)
+
+	int i;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT)
+	static struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER];
+#endif
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+
+	rtl865x_AclRule_t rule;
+	int ret = FAILED;
+
+	if (vlanConfig == NULL) {
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT)
+	re865x_packVlanConfig(vlanConfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+#else
+	pVlanConfig = vlanConfig;
+#endif
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+
+		if (pVlanConfig[i].isWan == 0) {	/*lan config */
+
+			/* trap igmp packet to cpu enable hw multicast */
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IGMP_USED, RTL865X_ACL_INGRESS);
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_IP;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.ipProto_ = IPPROTO_IGMP;
+			rule.ipProtoMask_ = 0xff;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IGMP_USED);
+
+		} else {	/*wan config */
+
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IGMP_USED, RTL865X_ACL_INGRESS);
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_IP;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.ipProto_ = IPPROTO_IGMP;
+			rule.ipProtoMask_ = 0xff;
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IGMP_USED);
+
+		}
+
+#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+		if (rtl865x_curOpMode == WISP_MODE)
+#endif
+			rtl865x_reConfigDefaultAcl(pVlanConfig[i].ifname);
+
+	}
+#endif
+	return SUCCESS;
+}
+
+static int rtl865x_removeAclForIgmpSnooping(struct rtl865x_vlanConfig
+	*vlanConfig)
+{
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	int i;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT)
+	struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER];
+#endif
+
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+
+	if (vlanConfig == NULL) {
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT)
+	re865x_packVlanConfig(vlanConfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+#else
+	pVlanConfig = vlanConfig;
+#endif
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+
+		if (pVlanConfig[i].isWan == 0) {	/*lan config */
+			rtl865x_unRegist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IGMP_USED, RTL865X_ACL_INGRESS);
+		} else {	/*wan config */
+
+			rtl865x_unRegist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IGMP_USED, RTL865X_ACL_INGRESS);
+		}
+
+	}
+
+#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+
+#else
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	if (rtk_vlan_support_enable == 0) {
+		rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_PERMIT_ALL,
+			RTL865X_ACLTBL_PERMIT_ALL, RTL865X_ACLTBL_PERMIT_ALL,
+			RTL865X_ACLTBL_PERMIT_ALL);
+	} else {
+		rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_ALL_TO_CPU,
+			RTL865X_ACLTBL_ALL_TO_CPU, RTL865X_ACLTBL_PERMIT_ALL,
+			RTL865X_ACLTBL_PERMIT_ALL);
+	}
+#else
+	rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_PERMIT_ALL,
+		RTL865X_ACLTBL_PERMIT_ALL, RTL865X_ACLTBL_PERMIT_ALL,
+		RTL865X_ACLTBL_PERMIT_ALL);
+#endif
+#endif
+#endif
+
+	return SUCCESS;
+}
+
+int rtl_processAclForIgmpSnooping(int aclEnabled)
+{
+	int ret;
+	if (aclEnabled) {
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+		ret = rtl865x_addAclForIgmpSnooping(packedVlanConfig);
+#else
+		ret = rtl865x_addAclForIgmpSnooping(vlanconfig);
+#endif
+	} else {
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+		ret = rtl865x_removeAclForIgmpSnooping(packedVlanConfig);
+#else
+		ret = rtl865x_removeAclForIgmpSnooping(vlanconfig);
+#endif
+	}
+
+	return ret;
+}
+
+#endif
+#if defined(CONFIG_RTL_INBAND_CTL_ACL)
+static int rtl865x_addAclForInbandCtl(struct rtl865x_vlanConfig *vlanConfig)
+{
+	int i;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER];
+#endif
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+	rtl865x_AclRule_t rule;
+	int ret = FAILED;
+
+	if (vlanConfig == NULL) {
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	re865x_packVlanConfig(vlanConfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+#else
+	pVlanConfig = vlanConfig;
+#endif
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+
+		if (pVlanConfig[i].isWan == 0) {	/*lan config */
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_TEST_USED, RTL865X_ACL_INGRESS);
+			/*drop all packet */
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+
+			rule.typeLen_ = 0x8899;
+			rule.typeLenMask_ = 0xFFFF;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_TEST_USED);
+
+		} else {	/*wan config */
+
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_TEST_USED, RTL865X_ACL_INGRESS);
+			/*drop all packet */
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.typeLen_ = 0x8899;
+			rule.typeLenMask_ = 0xFFFF;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_TEST_USED);
+		}
+
+#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+		if (rtl865x_curOpMode == WISP_MODE)
+#endif
+			rtl865x_reConfigDefaultAcl(pVlanConfig[i].ifname);
+
+	}
+	return SUCCESS;
+}
+
+static int rtl865x_removeAclForInbandCtl(struct rtl865x_vlanConfig *vlanConfig)
+{
+	return 0;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_HTTP_REDIRECT_LOCAL)
+static int rtl865x_addAclForHttpRedirect(struct rtl865x_vlanConfig *vlanConfig)
+{
+	int i;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER];
+#endif
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+	rtl865x_AclRule_t rule;
+	int ret = FAILED;
+	if (vlanConfig == NULL) {
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	re865x_packVlanConfig(vlanConfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+#else
+	pVlanConfig = vlanConfig;
+#endif
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+		if (pVlanConfig[i].isWan == 0) {	/*lan config */
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_HTTP_REDIRECT_USED,
+				RTL865X_ACL_INGRESS);
+			/*to cpu */
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_TCP;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.tcpDstPortUB_ = 80;
+			rule.tcpDstPortLB_ = 80;
+			rule.tcpSrcPortUB_ = 65535;
+			rule.tcpSrcPortLB_ = 0;
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_HTTP_REDIRECT_USED);
+		}
+#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+		if (rtl865x_curOpMode == WISP_MODE)
+#endif
+			rtl865x_reConfigDefaultAcl(pVlanConfig[i].ifname);
+	}
+	return SUCCESS;
+}
+
+static int rtl865x_removeAclForHttpRedirect(struct rtl865x_vlanConfig
+	*vlanConfig)
+{
+	int i;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER];
+#endif
+
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+
+	if (vlanConfig == NULL) {
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	re865x_packVlanConfig(vlanConfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+#else
+	pVlanConfig = vlanConfig;
+#endif
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+
+		if (pVlanConfig[i].isWan == 0) {	/*lan config */
+			rtl865x_unRegist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_HTTP_REDIRECT_USED,
+				RTL865X_ACL_INGRESS);
+		}
+	}
+	return SUCCESS;
+}
+
+void set_http_redirect_acl(int enable)
+{
+	if (enable) {
+		rtl865x_addAclForHttpRedirect(packedVlanConfig);
+	} else {
+		rtl865x_removeAclForHttpRedirect(packedVlanConfig);
+	}
+}
+#endif
+
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+static int rtl865x_addAclForMldSnooping(struct rtl865x_vlanConfig *vlanConfig)
+{
+	int i;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	static struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER];
+#endif
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+
+#if !((defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_HARDWARE_MULTICAST))
+	rtl865x_AclRule_t rule;
+	int ret = FAILED;
+#endif
+	if (vlanConfig == NULL) {
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	re865x_packVlanConfig(vlanConfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+#else
+	pVlanConfig = vlanConfig;
+#endif
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+
+		if (pVlanConfig[i].isWan == 0) {	/*lan config */
+#if !((defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_HARDWARE_MULTICAST))
+			/* no need acl to trap ipv6 multicast packet to cpu enabel 8198C v6 hw multicast */
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED, RTL865X_ACL_INGRESS);
+			/*ping6 issue */
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.actionType_ = RTL865X_ACL_PERMIT;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.dstMac_.octet[0] = 0x33;
+			rule.dstMac_.octet[1] = 0x33;
+			rule.dstMac_.octet[2] = 0xFF;
+
+			rule.dstMacMask_.octet[0] = 0xFF;
+			rule.dstMacMask_.octet[1] = 0xFF;
+			rule.dstMacMask_.octet[2] = 0xFF;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+
+			/*ipv6 multicast data issue */
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.dstMac_.octet[0] = 0x33;
+			rule.dstMac_.octet[1] = 0x33;
+			rule.dstMac_.octet[2] = 0x00;
+			rule.dstMac_.octet[3] = 0x00;
+			rule.dstMac_.octet[4] = 0x00;
+			rule.dstMac_.octet[5] = 0x00;
+
+			rule.dstMacMask_.octet[0] = 0xFF;
+			rule.dstMacMask_.octet[1] = 0xFF;
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+#endif
+
+		} else {	/*wan config */
+
+#if !((defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_HARDWARE_MULTICAST))
+
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED, RTL865X_ACL_INGRESS);
+			/*ipv6 multicast data issue */
+			bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+			rule.ruleType_ = RTL865X_ACL_MAC;
+			rule.actionType_ = RTL865X_ACL_TOCPU;
+			rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+			rule.dstMac_.octet[0] = 0x33;
+			rule.dstMac_.octet[1] = 0x33;
+			rule.dstMac_.octet[2] = 0x00;
+			rule.dstMac_.octet[3] = 0x00;
+			rule.dstMac_.octet[4] = 0x00;
+			rule.dstMac_.octet[5] = 0x00;
+
+			rule.dstMacMask_.octet[0] = 0xFF;
+			rule.dstMacMask_.octet[1] = 0xFF;
+
+			ret = rtl865x_add_acl(&rule, pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED);
+#endif
+		}
+
+#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+		if (rtl865x_curOpMode == WISP_MODE)
+#endif
+			rtl865x_reConfigDefaultAcl(pVlanConfig[i].ifname);
+	}
+	return SUCCESS;
+}
+
+static int rtl865x_removeAclForMldSnooping(struct rtl865x_vlanConfig
+	*vlanConfig)
+{
+#if (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_HARDWARE_MULTICAST)
+
+	/* no need acl to trap ipv6 multicast packet to cpu */
+#else
+
+	int i;
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER];
+#endif
+
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+
+	if (vlanConfig == NULL) {
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	re865x_packVlanConfig(vlanConfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+#else
+	pVlanConfig = vlanConfig;
+#endif
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+
+		if (pVlanConfig[i].isWan == 0) {	/*lan config */
+			rtl865x_unRegist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED, RTL865X_ACL_INGRESS);
+		} else {	/*wan config */
+
+			rtl865x_unRegist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED, RTL865X_ACL_INGRESS);
+		}
+
+	}
+#endif
+
+#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+
+#else
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	if (rtk_vlan_support_enable == 0) {
+		rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_PERMIT_ALL,
+			RTL865X_ACLTBL_PERMIT_ALL, RTL865X_ACLTBL_PERMIT_ALL,
+			RTL865X_ACLTBL_PERMIT_ALL);
+	} else {
+		rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_ALL_TO_CPU,
+			RTL865X_ACLTBL_ALL_TO_CPU, RTL865X_ACLTBL_PERMIT_ALL,
+			RTL865X_ACLTBL_PERMIT_ALL);
+	}
+#else
+	rtl865x_setDefACLForAllNetif(RTL865X_ACLTBL_PERMIT_ALL,
+		RTL865X_ACLTBL_PERMIT_ALL, RTL865X_ACLTBL_PERMIT_ALL,
+		RTL865X_ACLTBL_PERMIT_ALL);
+#endif
+#endif
+
+	return SUCCESS;
+}
+#endif
+
+#if !defined(CONFIG_COMPAT_NET_DEV_OPS) && (defined(CONFIG_RTL_CUSTOM_PASSTHRU) || defined(CONFIG_RTL_STP))
+static const struct net_device_ops rtl819x_pseudodev_ops = {
+	.ndo_open = re865x_pseudo_open,
+	.ndo_stop = re865x_pseudo_close,
+
+	.ndo_get_stats = re865x_get_stats,
+	.ndo_do_ioctl = re865x_ioctl,
+	.ndo_start_xmit = re865x_start_xmit,
+};
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+extern struct proc_dir_entry proc_root;
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+/*mib_vlan*/
+int mib_vlan_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, read_proc_vlan, PDE_DATA(inode)));
+}
+
+static ssize_t mib_vlan_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return write_proc_vlan(file, userbuf, count, off);
+}
+
+struct file_operations mib_vlan_proc_fops = {
+	.open = mib_vlan_single_open,
+	.write = mib_vlan_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+/*up_event*/
+int up_event_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtk_link_event_read, NULL));
+}
+
+static ssize_t up_event_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtk_link_event_write(file, userbuf, count, off);
+}
+
+struct file_operations up_event_proc_fops = {
+	.open = up_event_single_open,
+	.write = up_event_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*link_status*/
+int link_status_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtk_link_status_read,
+			(void *)PDE_DATA(inode)));
+}
+
+static ssize_t link_status_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtk_link_status_write(file, userbuf, count, off);
+}
+
+struct file_operations link_status_proc_fops = {
+	.open = link_status_single_open,
+	.write = link_status_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+#ifdef CONFIG_RTL_PROC_NEW
+int auto_dhcp_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtk_linkstatus_pid_read, NULL));
+}
+
+static ssize_t auto_dhcp_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtk_linkstatus_pid_write(file, userbuf, count, off);
+}
+
+struct file_operations rtk_auto_dhcp_proc_fops = {
+	.open = auto_dhcp_single_open,
+	.write = auto_dhcp_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#endif
+
+#ifdef CONFIG_RTL_HARDWARE_IPV6_SUPPORT
+#ifdef CONFIG_RTL_PROC_NEW
+
+int hwL3v6_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtk_hwL3v6_read, NULL));
+}
+
+static ssize_t hwL3v6_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtk_hwL3v6_write(file, userbuf, count, off);
+}
+
+struct file_operations rtk_hwL3v6_proc_fops = {
+	.open = hwL3v6_single_open,
+	.write = hwL3v6_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+/*rtk_vlan_support*/
+int rtk_vlan_support_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtk_vlan_support_read, NULL));
+}
+
+static ssize_t rtk_vlan_support_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtk_vlan_support_write(file, userbuf, count, off);
+}
+
+struct file_operations rtk_vlan_support_proc_fops = {
+	.open = rtk_vlan_support_single_open,
+	.write = rtk_vlan_support_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+/*rtk_vlan_management_entry*/
+int rtk_vlan_management_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtk_vlan_management_read, NULL));
+}
+
+static ssize_t rtk_vlan_management_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtk_vlan_management_write(file, userbuf, count, off);
+}
+
+struct file_operations rtk_vlan_management_proc_fops = {
+	.open = rtk_vlan_management_single_open,
+	.write = rtk_vlan_management_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+/*rtk_vlan_wan_tag*/
+int rtk_vlan_wan_tag_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtk_vlan_wan_tag_support_read, NULL));
+}
+
+static ssize_t rtk_vlan_wan_tag_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtk_vlan_wan_tag_support_write(file, userbuf, count, off);
+}
+
+struct file_operations rtk_vlan_wan_tag_proc_fops = {
+	.open = rtk_vlan_wan_tag_single_open,
+	.write = rtk_vlan_wan_tag_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#ifdef CONFIG_RTL_INBAND_CTL_ACL
+int rtk_inband_ctl_acl_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, inband_ctl_acl_read, NULL));
+}
+
+static ssize_t rtk_inband_ctl_acl_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return inband_ctl_acl_write(file, userbuf, count, off);
+}
+
+struct file_operations rtk_inband_ctl_acl_proc_fops = {
+	.open = rtk_inband_ctl_acl_single_open,
+	.write = rtk_inband_ctl_acl_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+static int dslite_hw_fw_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "Ds-lite Hw forward %s\n",
+		(dslite_hw_fw > 0) ? "enabled" : "disabled");
+	return 0;
+}
+
+static int dslite_hw_fw_write(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	uint32 tmpBuf[32];
+	uint32 uintVal;
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		tmpBuf[count - 1] = 0;
+		uintVal = simple_strtol((const char *)tmpBuf, NULL, 0);
+		if (uintVal != 0)
+			dslite_hw_fw = uintVal;
+		else
+			dslite_hw_fw = 0;
+
+		printk("%s.%d. dslite_hw_fw value(%d)\n", __FUNCTION__,
+			__LINE__, dslite_hw_fw);
+		return count;
+	}
+	return -EFAULT;
+}
+
+int rtk_dslite_hw_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, dslite_hw_fw_read, NULL));
+}
+
+static ssize_t rtk_dslite_hw_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return dslite_hw_fw_write(file, userbuf, count, off);
+}
+
+struct file_operations rtk_dslite_hw_forward_proc_fops = {
+	.open = rtk_dslite_hw_single_open,
+	.write = rtk_dslite_hw_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#endif
+#ifdef CONFIG_RTL_HW_6RD_SUPPORT
+static int sixrd_hw_fw_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "6RD Hw forward %s\n",
+		(sixrd_hw_fw > 0) ? "enabled" : "disabled");
+	return 0;
+}
+
+static int sixrd_hw_fw_write(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	uint32 tmpBuf[32];
+	uint32 uintVal;
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		tmpBuf[count - 1] = 0;
+		uintVal = simple_strtol((const char *)tmpBuf, NULL, 0);
+		if (uintVal != 0)
+			sixrd_hw_fw = uintVal;
+		else
+			sixrd_hw_fw = 0;
+
+		/* printk("%s.%d. sixrd_hw_fw value(%d)\n",__FUNCTION__,__LINE__,sixrd_hw_fw); */
+		return count;
+	}
+	return -EFAULT;
+}
+
+int rtk_6rd_hw_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, sixrd_hw_fw_read, NULL));
+}
+
+static ssize_t rtk_6rd_hw_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return sixrd_hw_fw_write(file, userbuf, count, off);
+}
+
+struct file_operations rtk_6rd_hw_forward_proc_fops = {
+	.open = rtk_6rd_hw_single_open,
+	.write = rtk_6rd_hw_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#endif
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+/*rtl_hw_vlan_support*/
+int rtl_hw_vlan_support_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl_hw_vlan_support_read, NULL));
+}
+
+static ssize_t rtl_hw_vlan_support_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl_hw_vlan_support_write(file, userbuf, count, off);
+}
+
+struct file_operations rtl_hw_vlan_support_proc_fops = {
+	.open = rtl_hw_vlan_support_single_open,
+	.write = rtl_hw_vlan_support_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*rtl_hw_vlan_tagged_mc*/
+int rtl_hw_vlan_tagged_mc_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl_hw_vlan_tagged_bridge_multicast_read,
+			NULL));
+}
+
+static ssize_t rtl_hw_vlan_tagged_mc_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl_hw_vlan_tagged_bridge_multicast_write(file, userbuf, count,
+		off);
+}
+
+struct file_operations rtl_hw_vlan_tagged_mc_proc_fops = {
+	.open = rtl_hw_vlan_tagged_mc_single_open,
+	.write = rtl_hw_vlan_tagged_mc_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+/*rtk_multicast_scream_vid*/
+int rtk_multicast_scream_vid_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtk_multicast_scream_vid_read, NULL));
+}
+
+static ssize_t rtk_multicast_scream_vid_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtk_multicast_scream_vid_write(file, userbuf, count, off);
+}
+
+struct file_operations rtk_multicast_scream_vid_proc_fops = {
+	.open = rtk_multicast_scream_vid_single_open,
+	.write = rtk_multicast_scream_vid_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*rtk_query_for_bridge_port*/
+int rtk_query_for_bridge_port_single_open(struct inode *inode,
+	struct file *file)
+{
+	return (single_open(file, rtk_query_for_bridge_port_read, NULL));
+}
+
+static ssize_t rtk_query_for_bridge_port_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtk_query_for_bridge_port_write(file, userbuf, count, off);
+}
+
+struct file_operations rtk_query_for_bridge_port_proc_fops = {
+	.open = rtk_query_for_bridge_port_single_open,
+	.write = rtk_query_for_bridge_port_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+/*rtl_8367r_vlan*/
+int rtl_8367r_vlan_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl_8367r_vlan_read, NULL));
+}
+
+static ssize_t rtl_8367r_vlan_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return 0;
+}
+
+struct file_operations rtl_8367r_vlan_proc_fops = {
+	.open = rtl_8367r_vlan_single_open,
+	.write = rtl_8367r_vlan_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+#if defined(CONFIG_819X_PHY_RW)
+/*rtl_phy_status*/
+int rtl_phy_status_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl_phy_status_read, NULL));
+}
+
+static ssize_t rtl_phy_status_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl_phy_status_write(file, userbuf, count, off);
+}
+
+struct file_operations rtl_phy_status_proc_fops = {
+	.open = rtl_phy_status_single_open,
+	.write = rtl_phy_status_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*port_mibEntry*/
+int port_mibEntry_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, port_mibStats_read_proc, PDE_DATA(inode)));
+}
+
+static ssize_t port_mibEntry_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return port_mibStats_write_proc(file, userbuf, count, off);
+}
+
+struct file_operations port_mibEntry_proc_fops = {
+	.open = port_mibEntry_single_open,
+	.write = port_mibEntry_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#ifdef CONFIG_TR181_ETH
+/*tr181_eth_link*/
+int tr181_eth_link_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, tr181_eth_link_read, NULL));
+}
+
+static ssize_t tr181_eth_link_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return tr181_eth_link_write(file, userbuf, count, off);
+}
+
+struct file_operations tr181_eth_link_proc_fops = {
+	.open = tr181_eth_link_single_open,
+	.write = tr181_eth_link_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*tr181_eth_if*/
+int tr181_eth_if_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, tr181_eth_if_read, NULL));
+}
+
+static ssize_t tr181_eth_if_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return tr181_eth_if_write(file, userbuf, count, off);
+}
+
+struct file_operations tr181_eth_if_proc_fops = {
+	.open = tr181_eth_if_single_open,
+	.write = tr181_eth_if_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*tr181_eth_stats*/
+int tr181_eth_stats_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, tr181_eth_stats_read, NULL));
+}
+
+static ssize_t tr181_eth_stats_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return tr181_eth_stats_write(file, userbuf, count, off);
+}
+
+struct file_operations tr181_eth_stats_proc_fops = {
+	.open = tr181_eth_stats_single_open,
+	.write = tr181_eth_stats_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/*tr181_eth_set*/
+int tr181_eth_set_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, tr181_eth_set_read, NULL));
+}
+
+static ssize_t tr181_eth_set_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return tr181_eth_set_write(file, userbuf, count, off);
+}
+
+struct file_operations tr181_eth_set_proc_fops = {
+	.open = tr181_eth_set_single_open,
+	.write = tr181_eth_set_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#ifdef CONFIG_RTL_CUSTOM_PASSTHRU	/* mark_bb */
+static int custom_Passthru_read_proc(struct seq_file *s, void *v);
+static int custom_Passthru_write_proc(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+/*custom_Passthru*/
+int custom_Passthru_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, custom_Passthru_read_proc, NULL));
+}
+
+static ssize_t custom_Passthru_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return custom_Passthru_write_proc(file, userbuf, count, off);
+}
+
+struct file_operations custom_Passthru_proc_fops = {
+	.open = custom_Passthru_single_open,
+	.write = custom_Passthru_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+static int rtl865x_stormCtrlReadProc(struct seq_file *s, void *v);
+static int rtl865x_stormCtrlWriteProc(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+/*StormCtrl*/
+int StormCtrl_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_stormCtrlReadProc, NULL));
+}
+
+static ssize_t StormCtrl_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_stormCtrlWriteProc(file, userbuf, count, off);
+}
+
+struct file_operations StormCtrl_proc_fops = {
+	.open = StormCtrl_single_open,
+	.write = StormCtrl_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#if 0				/* defined(CONFIG_RTL_8197F) */
+static int rtl865x_extendStormCtrlReadProc(struct seq_file *s, void *v);
+static int rtl865x_extendStormCtrlWriteProc(struct file *file,
+	const char *buffer, unsigned long count, void *data);
+/*ExtendStormCtrl*/
+int extendStormCtrl_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_extendStormCtrlReadProc, NULL));
+}
+
+static ssize_t extendStormCtrl_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_extendStormCtrlWriteProc(file, userbuf, count, off);
+}
+
+struct file_operations extendStormCtrl_proc_fops = {
+	.open = extendStormCtrl_single_open,
+	.write = extendStormCtrl_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+#if defined(CONFIG_RTL_WAN_PORT_SETTING)
+static int wan_port_setting_read(struct seq_file *s, void *v);
+static int wan_port_setting_write(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+int wan_port_setting_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, wan_port_setting_read, NULL));
+}
+
+static ssize_t wan_port_setting_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return wan_port_setting_write(file, userbuf, count, off);
+}
+
+struct file_operations wan_port_setting_proc_fops = {
+	.open = wan_port_setting_single_open,
+	.write = wan_port_setting_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+static int proc_phyTest_read(struct seq_file *s, void *v);
+static int32 proc_phyTest_write(struct file *filp, const char *buff,
+	unsigned long len1, void *data);
+/*phyRegTest*/
+int phyRegTest_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, proc_phyTest_read, NULL));
+}
+
+static ssize_t phyRegTest_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return proc_phyTest_write(file, userbuf, count, off);
+}
+
+struct file_operations phyRegTest_proc_fops = {
+	.open = phyRegTest_single_open,
+	.write = phyRegTest_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+static int rtl865x_mldSnoopingReadProc(struct seq_file *s, void *v);
+static int rtl865x_mldSnoopingWriteProc(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+/*br_mldsnoop*/
+int br_mldsnoop_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_mldSnoopingReadProc, NULL));
+}
+
+static ssize_t br_mldsnoop_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_mldSnoopingWriteProc(file, userbuf, count, off);
+}
+
+struct file_operations br_mldsnoop_proc_fops = {
+	.open = br_mldsnoop_single_open,
+	.write = br_mldsnoop_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#if defined(CONFIG_RTL_PHY_POWER_CTRL)
+static int rtl865x_phyPowerCtrlReadProc(struct seq_file *s, void *v);
+static int rtl865x_phyPowerCtrlWriteProc(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+/*phyPower*/
+int phyPower_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_phyPowerCtrlReadProc, NULL));
+}
+
+static ssize_t phyPower_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_phyPowerCtrlWriteProc(file, userbuf, count, off);
+}
+
+struct file_operations phyPower_proc_fops = {
+	.open = phyPower_single_open,
+	.write = phyPower_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#if defined(CONFIG_RTL_LINKSTATE)
+static int port_state_read_proc(struct seq_file *s, void *v);
+static int32 port_state_write_proc(struct file *filp, const char *buff,
+	unsigned long len, void *data);
+/*portState*/
+int portState_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, port_state_read_proc, NULL));
+}
+
+static ssize_t portState_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return port_state_write_proc(file, userbuf, count, off);
+}
+
+struct file_operations portState_proc_fops = {
+	.open = portState_single_open,
+	.write = portState_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#if defined(REINIT_SWITCH_CORE)
+static int rtl865x_reInitSwitchCoreReadProc(struct seq_file *s, void *v);
+static int rtl865x_reInitSwitchCoreWriteProc(struct file *file,
+	const char *buffer, unsigned long count, void *data);
+/*reInitSwitchCore*/
+int reInitSwitchCore_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_reInitSwitchCoreReadProc, NULL));
+}
+
+static ssize_t reInitSwitchCore_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_reInitSwitchCoreWriteProc(file, userbuf, count, off);
+}
+
+struct file_operations reInitSwitchCore_proc_fops = {
+	.open = reInitSwitchCore_single_open,
+	.write = reInitSwitchCore_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/* #if defined(CONFIG_RTL_CHECK_SWITCH_TX_HANGUP) */
+static int rtl_check_swCore_tx_hang_read_proc(struct seq_file *s, void *v);
+static int rtl_check_swCore_tx_hang_write_proc(struct file *file,
+	const char *buffer, unsigned long count, void *data);
+int rtl_check_swCore_tx_hang_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl_check_swCore_tx_hang_read_proc, NULL));
+}
+
+static ssize_t rtl_check_swCore_tx_hang_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl_check_swCore_tx_hang_write_proc(file, userbuf, count, off);
+}
+
+struct file_operations rtl_check_swCore_tx_hang_proc_fops = {
+	.open = rtl_check_swCore_tx_hang_single_open,
+	.write = rtl_check_swCore_tx_hang_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+/* #endif */
+#endif
+#if defined(CONFIG_RTL_SOCK_DEBUG)
+static int32 rtl865x_sockDebugReadProc(struct seq_file *s, void *v);
+static int rtl865x_sockDebugWriteProc(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+/*sockDebug*/
+int sockDebug_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl865x_sockDebugReadProc, NULL));
+}
+
+static ssize_t sockDebug_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl865x_sockDebugWriteProc(file, userbuf, count, off);
+}
+
+struct file_operations sockDebug_proc_fops = {
+	.open = sockDebug_single_open,
+	.write = sockDebug_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+static int eee_read_proc(struct seq_file *s, void *v);
+static int eee_write_proc(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+/*eee*/
+int eee_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, eee_read_proc, NULL));
+}
+
+static ssize_t eee_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return eee_write_proc(file, userbuf, count, off);
+}
+
+struct file_operations eee_proc_fops = {
+	.open = eee_single_open,
+	.write = eee_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+#ifdef CONFIG_RTL_JATE_TEST
+static int jate_read_proc(struct seq_file *s, void *v);
+static int jate_write_proc(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+/*jate*/
+int jate_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, jate_read_proc, NULL));
+}
+
+static ssize_t jate_single_write(struct file *file, const char __user *userbuf,
+	size_t count, loff_t *off)
+{
+	return jate_write_proc(file, userbuf, count, off);
+}
+
+struct file_operations jate_proc_fops = {
+	.open = jate_single_open,
+	.write = jate_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+#else
+static int eee_read_proc(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+static int eee_write_proc(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+#ifdef CONFIG_RTL_JATE_TEST
+static int jate_read_proc(char *page, char **start, off_t off, int count,
+	int *eof, void *data);
+static int jate_write_proc(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+#endif
+#endif
+
+extern void FullAndSemiReset(void);
+#if defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+extern int32 phyRegTest_init(void);
+#endif
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+extern int32 rtl8651_initMldSnooping(void);
+#endif
+#if defined(REINIT_SWITCH_CORE)
+extern int rtl865x_creatReInitSwitchCoreProc(void);
+#endif
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+extern int32 rtl865x_proc_debug_cleanup(void);
+#endif
+#if defined(CONFIG_RTL_LAYERED_ASIC_DRIVER_L3) || defined(CONFIG_OPENWRT_SDK)
+extern int32 rtl865x_initAsicL3(void);
+#endif
+
+#if defined(CONFIG_RTL_LAYERED_ASIC_DRIVER_L4) || defined(CONFIG_OPENWRT_SDK)
+extern int32 rtl865x_initAsicL4(void);
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+/* get MAC address from uMAC regs and update it in vlanconfig[] */
+#define RTL_UMAC_R8(reg)	readb((void __iomem *)(((uintptr_t)rtl_umac_mmio) + (reg)))
+static int rtl_set_vlanconfig_mac_addr(void)
+{
+	char *path = "/gmac@98016000";
+	struct device_node *dt_node;
+	void __iomem *rtl_umac_mmio;
+	uint32 i, j;
+	uint8 mac[ETH_ALEN], ifname[IFNAMSIZ];
+	struct rtl865x_vlanConfig *vlancfg_entry;
+	const uint8 *macp;
+
+	if ((macp = of_get_mac_address(rtl819x_pdev->dev.of_node)) != NULL) {
+		memcpy(mac, macp, ETH_ALEN);
+	} else {
+		dt_node = of_find_node_by_path(path);
+		if (!dt_node) {
+			pr_err("Failed to find uMAC device-tree node: %s\n",
+				path);
+			return -ENODEV;
+		}
+
+		rtl_umac_mmio = of_iomap(dt_node, 0);
+		if (!rtl_umac_mmio) {
+			pr_err("HWNAT MMIO : no mmio space for rtl_umac_mmio\n");
+			return -EINVAL;
+		}
+
+		for (i = 0; i < ETH_ALEN; i++)
+			mac[i] = RTL_UMAC_R8(i);
+	}
+	/* DBG("MAC address base = %pM", mac); */
+
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		#if defined(CONFIG_RTL_WAN_MAC5)
+		sprintf(ifname, "eth%d", i);
+		#else /* CONFIG_RTL_WAN_MAC5 */
+		if (i == RTL_LAN_IDX)
+			sprintf(ifname, RTL_DRV_LAN_NETIF_NAME);
+		else
+			sprintf(ifname, "eth%d", i);
+		#endif /* CONFIG_RTL_WAN_MAC5 */
+
+		vlancfg_entry = rtl_get_vlanconfig_by_netif_name(ifname);
+
+		if (vlancfg_entry) {
+			memcpy(vlancfg_entry->mac.octet, mac, ETHER_ADDR_LEN);
+			for (j = ETHER_ADDR_LEN - 1; j >= 3; j--) {
+				if (mac[j] == 0xFF) {
+					mac[j] = 0;
+				} else {
+					mac[j] += 1;
+					break;
+				}
+			}
+
+		} else {
+			/* printk(KERN_ERR "Failed to get %s vlanconfig entry\n", ifname); */
+			return -EINVAL;
+		}
+	}
+
+	return SUCCESS;
+}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+extern int rtl_hw_nat_init_refine(void);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+static int re865x_probe(struct platform_device *pdev)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+int __init re865x_probe(void)
+#endif				/* defined(CONFIG_RTD_1295_HWNAT) */
+{
+/*2007-12-19*/
+	int32 i, j;
+	int32 totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		1;
+#if defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	rtl865x_mCastConfig_t mCastConfig;
+#endif
+#endif
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+	int32 retVal;
+	int32 igmpInitFlag = FAILED;
+	struct rtl_mCastSnoopingGlobalConfig mCastSnoopingGlobalConfig;
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	rtl865x_mCastConfig_t mCastConfig;
+#endif
+#endif
+#if defined(CONFIG_RTL_REPORT_LINK_STATUS) || defined(CONFIG_RTK_VLAN_SUPPORT)
+	struct proc_dir_entry *res_stats_root;
+#endif
+#if defined(CONFIG_RTL_819XD) && defined(CONFIG_RTL_8211DS_SUPPORT) && defined(CONFIG_RTL_8197D)
+	uint32 reg_tmp = 0;
+#endif
+
+#ifndef CONFIG_RTL_PROC_NEW
+#if defined(CONFIG_RTL_REPORT_LINK_STATUS)
+	struct proc_dir_entry *rtk_link_event_entry;
+	struct proc_dir_entry *rtk_link_status_entry;
+#endif
+
+#if defined(CONFIG_TR181_ETH)
+	struct proc_dir_entry *tr181_eth_link, *tr181_eth_if, *tr181_eth_stats,
+		*tr181_eth_set;
+#endif
+#endif
+
+#if defined(CONFIG_RTL_IPV6READYLOGO) && defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+#ifndef CONFIG_RTL_PROC_NEW
+	struct proc_dir_entry *hwL3v6;
+#endif
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+#ifndef CONFIG_RTL_PROC_NEW
+	struct proc_dir_entry *res_stats;
+	struct proc_dir_entry *rtk_vlan_support_entry;
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+	struct proc_dir_entry *rtk_vlan_management_entry;
+#endif
+#endif
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+#ifdef CONFIG_RTL_PROC_NEW
+#else
+	struct proc_dir_entry *proc;
+#endif
+#endif
+#if defined(CONFIG_819X_PHY_RW)	/* #if defined(CONFIG_RTK_VLAN_FOR_CABLE_MODEM) */
+	uint32 portnum;
+	char port_mibEntry_name[10];
+	struct proc_dir_entry *rtl_phy;
+	struct proc_dir_entry *port_mibStats_root;
+	struct proc_dir_entry *port_mibStats_entry;
+#endif /* #if defined(CONFIG_819X_PHY_RW) */
+#endif
+
+#if defined(CONFIG_RTL_JUMBO_FRAME) && !defined(CONFIG_RTL_PROC_NEW)
+	struct proc_dir_entry *jumbo_frame_support_entry = NULL;
+#endif
+
+#if defined(CONFIG_RTL_LINK_AGGREGATION) && !defined(CONFIG_RTL_PROC_NEW)
+	struct proc_dir_entry *link_aggregation_entry = NULL;
+#endif
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+#else
+	struct proc_dir_entry *rtl_hw_vlan_support_entry;
+	struct proc_dir_entry *rtl_hw_vlan_tagged_bridge_multicast_entry;
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+	struct proc_dir_entry *rtk_multicast_scream_vid_entry;
+	struct proc_dir_entry *rtk_query_for_bridge_port_entry;
+#endif
+	memset(hw_vlan_info, 0,
+		PORT_NUMBER * sizeof(struct hw_vlan_port_setting));
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT) && !defined(CONFIG_RTL_PROC_NEW)
+	struct proc_dir_entry *rtl_8367r_vlan;
+#endif
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+	struct rtl865x_interface_info ifInfo;
+#endif
+
+#if defined(PATCH_GPIO_FOR_LED)
+	int port;
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+#ifndef CONFIG_RTL_PROC_NEW
+	struct proc_dir_entry *rtk_vlan_wan_tag_support_entry;
+#endif
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	int irq;
+	int dt_tmp;
+	unsigned dt_array[6];
+
+	rtl819x_pdev = pdev;
+	_rtl86xx_dev.plat_dev = pdev;
+	/* initialize memory map of registers and IRQ */
+	printk(KERN_ERR "%s driver loaded\n", MODULENAME);
+
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (irq < 0) {
+		dev_err(&pdev->dev, "no irq\n");
+		return -EINVAL;
+	}
+
+	DBG("IRQ = %d", irq);
+
+	rtl_hwnat_mmio = of_iomap(pdev->dev.of_node, 0);
+	if (!rtl_hwnat_mmio) {
+		dev_err(&pdev->dev, "HWNAT MMIO : no NAT mmio space\n");
+		return -EINVAL;
+	}
+
+	rtl_hwnat_clk_mmio = of_iomap(pdev->dev.of_node, 1);
+	if (!rtl_hwnat_clk_mmio) {
+		dev_err(&pdev->dev, "HWNAT MMIO : no CLK mmio space\n");
+		return -EINVAL;
+	}
+
+	rtl_hwnat_sata_mmio = of_iomap(pdev->dev.of_node, 2);
+	if (!rtl_hwnat_sata_mmio) {
+		dev_err(&pdev->dev, "HWNAT MMIO : no SATA mmio space\n");
+		return -EINVAL;
+	}
+
+	of_property_read_u32_array(pdev->dev.of_node, "reg", dt_array, 6);
+	rtl_hwnat_base = dt_array[0];
+	DBG("HWNAT start 0x%x, rtl_hwnat_mmio = 0x%p", dt_array[0],
+		rtl_hwnat_mmio);
+
+	of_property_read_u32(pdev->dev.of_node, "offload_enable", &dt_tmp);
+	DBG("HW NAT offload_enable = %s", dt_tmp > 0 ? "enable" : "disable");
+	rtl_hwnat_enable = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "rgmii_enable", &dt_tmp);
+	DBG("rgmii_enable = %s", dt_tmp > 0 ? "enable" : "disable");
+	hwnat_rgmii_enable = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "rgmii_voltage", &dt_tmp);
+	DBG("RGMII voltage = %d (1:1.8V, 2:2.5V, 3:3.3V)", dt_tmp);
+	hwnat_rgmii_voltage = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "rgmii0_tx_delay", &dt_tmp);
+	DBG("RGMII0 TX delay = %d (0.5 ns per step)", dt_tmp);
+	hwnat_rgmii0_tx_delay = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "rgmii0_rx_delay", &dt_tmp);
+	DBG("RGMII0 RX delay = %d (0.5 ns per step)", dt_tmp);
+	hwnat_rgmii0_rx_delay = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "rgmii1_tx_delay", &dt_tmp);
+	DBG("RGMII1 TX delay = %d (0.5 ns per step)", dt_tmp);
+	hwnat_rgmii1_tx_delay = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "rgmii1_rx_delay", &dt_tmp);
+	DBG("RGMII1 RX delay = %d (0.5 ns per step)", dt_tmp);
+	hwnat_rgmii1_rx_delay = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "mac0_enable", &dt_tmp);
+	DBG("mac0_enable = %s", dt_tmp > 0 ? "enable" : "disable");
+	hwnat_mac0_enable = dt_tmp;
+	#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+	#if !defined(CONFIG_RTL_CPU_TAG)
+	if (hwnat_mac0_enable == 0) {
+		vlanconfig[2].if_type = IF_NONE;
+		vlanconfig[2].memPort = 0;
+		RTL_LANPORT_MASK &= ~RTL_LANPORT_MASK_1;
+	}
+	#endif /* !CONFIG_RTL_CPU_TAG */
+	#endif /* CONFIG_RTL_MULTI_LAN_DEV */
+
+	of_property_read_u32(pdev->dev.of_node, "mac0_mode", &dt_tmp);
+	DBG("mac0_mode = %s to %s", (dt_tmp & 1) > 0 ? "SGMII" : "RGMII",
+		(dt_tmp & 2) > 0 ? "MAC" : "PHY");
+	hwnat_mac0_mode = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "mac5_conn_to", &dt_tmp);
+	DBG("mac5_conn_to = %s", dt_tmp > 0 ? "MAC" : "PHY");
+	hwnat_mac5_conn_to = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "mac0_phy_id", &dt_tmp);
+	DBG("mac0_phy_id = %d", dt_tmp);
+	rtl8651AsicEthernetTable[0].phyId = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "mac4_phy_id", &dt_tmp);
+	DBG("mac4_phy_id = %d", dt_tmp);
+	rtl8651AsicEthernetTable[4].phyId = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "mac5_phy_id", &dt_tmp);
+	DBG("mac5_phy_id = %d", dt_tmp);
+	rtl8651AsicEthernetTable[5].phyId = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "led_mode", &dt_tmp);
+	DBG("LED mode = %d", dt_tmp);
+	hwnat_led_mode = dt_tmp;
+
+	of_property_read_u32(pdev->dev.of_node, "gpio_link_led_enable", &dt_tmp);
+	DBG("gpio_link_led_enable = %d", dt_tmp);
+	hwnat_gpio_link_led_enable = dt_tmp;
+
+	if (hwnat_gpio_link_led_enable) {
+		hwnat_gpio_link_led = of_get_gpio(pdev->dev.of_node, 0);
+	}
+
+	/* get MAC address from uMAC regs and update it in vlanconfig[] */
+	rtl_set_vlanconfig_mac_addr();
+
+	/* Init RGMII/SGMII/PHY clock */
+	/* Init ASIC table */
+	rtd129x_hwnat_clk_init(&pdev->dev);
+
+	/* enable interrupt migration
+	 * timeout = 800 * 512ns = 400us
+	 * pkt count = 32 */
+	WRITE_MEM32(CPUIMTTR0, 0x320C8320);
+	WRITE_MEM32(CPUIMTTR1, 0x320C8320);
+	WRITE_MEM32(CPUIMTTR2, 0x320C8320);
+	WRITE_MEM32(CPUIMTTR3, 0x00000320);
+	WRITE_MEM32(CPUIMPNTR0, 0x20202020);
+	WRITE_MEM32(CPUIMPNTR1, 0x00002020);
+	WRITE_MEM32(CPUIMPNTR2, 0x20202020);
+	WRITE_MEM32(CPUIMCR, 0x00000F3F);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_FPGA_V6_HWNAT)
+	{
+		/* reset FPGA PHY daughter boards */
+		uint32 phy_db_addr;
+
+		phy_db_addr =
+			((uint32)rtl_hwnat_mmio) + HWNAT_CPUIR_OFFSET + 0x9100;
+		WRITE_MEM32(phy_db_addr, 0);
+		mdelay(50);
+		WRITE_MEM32(phy_db_addr, 3);
+		mdelay(50);
+	}
+#endif /* defined(CONFIG_FPGA_V6_HWNAT) */
+
+#ifdef CONFIG_SMP
+	spin_lock_init(&lock_eth_other);
+	spin_lock_init(&lock_eth_rx);
+	spin_lock_init(&lock_eth_tx);
+	spin_lock_init(&lock_eth_buf);
+	spin_lock_init(&lock_eth_hw);
+	spin_lock_init(&lock_eth_event);
+#endif
+
+	/* initial the global variables in dmem. */
+	rx_noBuffer_cnt = 0;
+	tx_ringFull_cnt = 0;
+	tx_drop_cnt = 0;
+	_debug_flag = 0;
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	rtlglue_printf("\nProbing RTL819X NIC-kenel stack size order[%d]...\n",
+		THREAD_SIZE_ORDER);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	REG32(CPUIIMR) = 0x00;
+	REG32(CPUICR) &= ~(TXCMD | RXCMD);
+	rxMbufRing = NULL;
+
+#if defined(CONFIG_RTL_819XD)
+	if ((REG32(REVR) == 0x8197C000) || (REG32(REVR) == 0x8197C001)) {
+		rtl_port0Refined = 1;
+	}
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	memset(sw_pvid, 0, sizeof(uint16) * RTL8651_PORT_NUMBER);
+#endif
+
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	/* for RTD1295, we use reg 0x98000000 bit1 in rtd129x_hwnat_clk_init() to reset NAT */
+	/*Initial ASIC table */
+	FullAndSemiReset();
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+	{
+		rtl8651_tblAsic_InitPara_t para;
+
+		memset(&para, 0, sizeof(rtl8651_tblAsic_InitPara_t));
+
+		/*
+		 * For DEMO board layout, RTL865x platform define corresponding PHY setting and PHYID.
+		 */
+
+		rtl865x_wanPortMask = RTL865X_PORTMASK_UNASIGNED;
+
+		INIT_CHECK(rtl865x_initAsicL2(&para));
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER_L3
+		INIT_CHECK(rtl865x_initAsicL3());
+#endif
+#if defined(CONFIG_RTL_LAYERED_ASIC_DRIVER_L4)
+		INIT_CHECK(rtl865x_initAsicL4());
+#endif
+
+		/*
+		 * Re-define the wan port according the wan port detection result.
+		 * NOTE:
+		 * There are a very strong assumption that if port5 was giga port,
+		 * then wan port was port 5.
+		 */
+		if (RTL865X_PORTMASK_UNASIGNED == rtl865x_wanPortMask) {
+			/* keep the original mask */
+			assert(RTL865X_PORTMASK_UNASIGNED ==
+				rtl865x_lanPortMask);
+			rtl865x_wanPortMask = RTL_WANPORT_MASK;
+			rtl865x_lanPortMask = RTL_LANPORT_MASK;
+
+#if defined(CONFIG_RTL_8881A)
+			if (REG32(BOND_OPTION) == 0x0a) {	/* Check is RTL8881AM */
+
+				REG32(PIN_MUX_SEL) = (REG32(PIN_MUX_SEL) & ~(0x7 << 7)) | (0x3 << 7);	/* Set MUX to GPIO */
+				REG32(PEFGH_CNR) = REG32(PEFGH_CNR) & ~(0x80);	/* Set E7 for  Gpio */
+				REG32(PEFGH_DIR) = REG32(PEFGH_DIR) & ~(0x80);	/* Set E7 for Input Mode */
+				if ((REG32(PEFGH_DAT) & 0x80) == 0x80) {	/* Pull high */
+					rtl865x_wanPortMask = 0;
+					rtl865x_lanPortMask = 0x110;
+					vlanconfig[0].memPort =
+						vlanconfig[0].untagSet = 0x110;
+					vlanconfig[1].memPort =
+						vlanconfig[1].untagSet = 0;
+					if (totalVlans >= 3)
+						vlanconfig[2].memPort =
+							vlanconfig[2].untagSet =
+							0;
+				}
+			}
+#elif defined(CONFIG_RTL_8197F)
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if !defined(CONFIG_RTL_8367R_SUPPORT) && !defined(CONFIG_RTL_8211F_SUPPORT)
+			{
+				extern uint32 rtl819x_bond_option(void);
+				if (rtl819x_bond_option() == 3) {
+					rtl865x_wanPortMask = 0;
+					rtl865x_lanPortMask = 0x110;
+					for (i = 0; i < totalVlans; i++) {
+						if (vlanconfig[i].isWan == 0) {
+							vlanconfig[i].memPort =
+								vlanconfig[i].
+								untagSet =
+								0x110;
+						} else {
+							vlanconfig[i].memPort =
+								vlanconfig[i].
+								untagSet = 0;
+						}
+					}
+				}
+			}
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+		} else {
+			/* redefine wan port mask */
+			assert(RTL865X_PORTMASK_UNASIGNED !=
+				rtl865x_lanPortMask);
+			for (i = 0; i < totalVlans; i++) {
+				if (TRUE == vlanconfig[i].isWan) {
+					vlanconfig[i].memPort =
+						vlanconfig[i].untagSet =
+						rtl865x_wanPortMask;
+				} else {
+					vlanconfig[i].memPort =
+						vlanconfig[i].untagSet =
+						rtl865x_lanPortMask;
+				}
+			}
+		}
+#if 1				/*      10/100 & giga use the same pre-allocated skb number */
+		/*
+		 * Re-define the pre-allocated skb number according the wan
+		 * port detection result.
+		 * NOTE:
+		 * There are a very strong assumption that if port1~port4 were
+		 * all giga port, then the sdram was 32M.
+		 */
+		{
+			if (RTL865X_PREALLOC_SKB_UNASIGNED ==
+				rtl865x_maxPreAllocRxSkb) {
+				assert(rtl865x_rxSkbPktHdrDescNum ==
+					rtl865x_txSkbPktHdrDescNum ==
+					RTL865X_PREALLOC_SKB_UNASIGNED);
+
+				rtl865x_maxPreAllocRxSkb = MAX_PRE_ALLOC_RX_SKB;
+				rtl865x_rxSkbPktHdrDescNum = NUM_RX_PKTHDR_DESC;
+				rtl865x_txSkbPktHdrDescNum = NUM_TX_PKTHDR_DESC;
+			} else {
+				assert(rtl865x_rxSkbPktHdrDescNum !=
+					RTL865X_PREALLOC_SKB_UNASIGNED);
+				assert(rtl865x_txSkbPktHdrDescNum !=
+					RTL865X_PREALLOC_SKB_UNASIGNED);
+				/* Assigned value in function of rtl8651_initAsic() */
+				rxRingSize[0] = rtl865x_rxSkbPktHdrDescNum;
+				txRingSize[0] = rtl865x_txSkbPktHdrDescNum;
+			}
+
+			for (i = 1; i < RTL865X_SWNIC_RXRING_HW_PKTDESC; i++) {
+				rtl865x_maxPreAllocRxSkb += rxRingSize[i];
+			}
+		}
+#else
+		{
+			rtl865x_maxPreAllocRxSkb = MAX_PRE_ALLOC_RX_SKB;
+			rtl865x_rxSkbPktHdrDescNum = NUM_RX_PKTHDR_DESC;
+			rtl865x_txSkbPktHdrDescNum = NUM_TX_PKTHDR_DESC;
+		}
+#endif
+	}
+
+#ifdef BR_SHORTCUT
+	cached_dev = NULL;
+	cached_dev2 = NULL;
+	cached_dev3 = NULL;
+	cached_dev4 = NULL;
+#endif
+
+	/*init PHY LED style */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (hwnat_gpio_link_led_enable) {
+		if (gpio_request(hwnat_gpio_link_led, "NAT link LED") < 0)
+			pr_err("NAT: fail to request GPIO pin %d\n", hwnat_gpio_link_led);
+	}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198)
+
+	/* config LED mode */
+#if defined(CONFIG_RTK_VOIP_BOARD)
+	WRITE_MEM32(LEDCR, 0x00055500);	/* 15 LED */
+	/* avoiv bad voip quality */
+	WRITE_MEM32(0xb8000048, REG32(0xb8000048) & 0xfffffff3);
+#else
+	WRITE_MEM32(LEDCR, 0x00000000);	/* 15 LED */
+#endif
+	WRITE_MEM32(SWTAA, PORT5_PHY_CONTROL);
+	WRITE_MEM32(TCR0, 0x000002C7);	/* 8651 demo board default: 15 LED boards */
+	WRITE_MEM32(SWTACR, CMD_FORCE | ACTION_START);	/* force add */
+#endif
+
+/*2007-12-19*/
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	/* port based decision */
+	rtl865xC_setNetDecisionPolicy(NETIF_PORT_BASED);
+	WRITE_MEM32(PLITIMR, 0);
+
+#endif
+
+#if defined(CONFIG_RTL_VLAN_BASED_NETIF)
+	rtl865xC_setNetDecisionPolicy(NETIF_VLAN_BASED);
+#elif defined(CONFIG_RTL_MAC_BASED_NETIF)
+	rtl865xC_setNetDecisionPolicy(NETIF_MAC_BASED);	/* Net interface Multilayer-Decision-Based Control -- Set to MAC-Based mode. */
+#endif
+
+#if defined(CONFIG_RTL_819XD) && defined(CONFIG_RTL_8211DS_SUPPORT) && defined(CONFIG_RTL_8197D)
+	rtl8651_getAsicEthernetPHYReg(0x6, 0, &reg_tmp);
+	rtl_setPortMask(reg_tmp);
+#endif
+
+	INIT_CHECK(rtl865x_init());
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+	INIT_CHECK(rtl865x_config(packedVlanConfig));
+#else
+	INIT_CHECK(rtl865x_config(vlanconfig));
+#endif
+
+#if defined(CONFIG_RTL_8198C)
+	INIT_CHECK(rtl865x_init_hw());
+#ifdef PRIV_BUF_CAN_USE_KERNEL_BUF
+	/* RTL_swNic_freeRxBuf(); */
+#endif
+#endif
+
+#if defined(CONFIG_RTL_SWITCH_NEW_DESCRIPTOR)
+	REG32(CPUICR1) =
+		(REG32(CPUICR1) & ~CF_PKT_HDR_TYPE_MASK) |
+		TX_PKTHDR_SHORTCUT_LSO;
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+	REG32(CPUICR1) |= BIT(CF_RX_GATHER_OFFSET);
+#endif
+#endif
+#if defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_TSO) || defined(CONFIG_RTL_GSO)
+	REG32(CPUICR1) |= BIT(CF_TX_GATHER_OFFSET);
+#endif
+#endif
+	/* create all default VLANs */
+/* rtlglue_printf("        creating eth0~eth%d...\n",totalVlans-1 ); */
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+#if defined(CONFIG_SMP)
+	spin_lock_init(&lock_igmp);
+	spin_lock_init(&lock_igmp_concurrent);
+#endif
+	memset(&mCastSnoopingGlobalConfig, 0,
+		sizeof(struct rtl_mCastSnoopingGlobalConfig));
+	mCastSnoopingGlobalConfig.maxGroupNum = 256;
+	mCastSnoopingGlobalConfig.maxSourceNum = 300;
+	mCastSnoopingGlobalConfig.hashTableSize = 64;
+
+	mCastSnoopingGlobalConfig.groupMemberAgingTime = 600;
+	mCastSnoopingGlobalConfig.lastMemberAgingTime = 2;
+	mCastSnoopingGlobalConfig.querierPresentInterval = 260;
+
+	mCastSnoopingGlobalConfig.dvmrpRouterAgingTime = 120;
+	mCastSnoopingGlobalConfig.mospfRouterAgingTime = 120;
+	mCastSnoopingGlobalConfig.pimRouterAgingTime = 120;
+
+	igmpInitFlag = rtl_initMulticastSnooping(mCastSnoopingGlobalConfig);
+	if (igmpInitFlag == FAILED) {
+		printk(KERN_ERR
+				"HW_MCAST:%s:%d Failed to rtl_initMulticastSnooping\n", __func__, __LINE__);
+	}
+
+#if defined(IMPROVE_MCAST_PERFORMANCE_WITH_RTL8367)
+	rtl_initMcastImprove();
+#endif
+#endif
+
+	for (i = 0; i < totalVlans; i++) {
+		struct net_device *dev;
+		struct dev_priv *dp;
+		int rc;
+
+		if (IF_ETHER != vlanconfig[i].if_type) {
+			continue;
+		}
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+		if (vlanconfig[i].isWan
+			&& (strncmp((vlanconfig[i].ifname),
+					RTL_DRV_WAN0_NETIF_NAME, IFNAMSIZ)))
+			continue;
+#endif
+		dev = alloc_etherdev(sizeof(struct dev_priv));
+		if (!dev) {
+			printk("failed to allocate dev %d", i);
+			return -1;
+		}
+		SET_MODULE_OWNER(dev);
+		dp = NETDRV_PRIV(dev);
+		memset(dp, 0, sizeof(*dp));
+		dp->dev = dev;
+#if defined(CONFIG_RTD_1295_HWNAT)
+		SET_NETDEV_DEV(dev, &pdev->dev);
+		dp->plat_dev = pdev;
+		INIT_WORK(&dp->link_event_work, rtd129x_send_uevent_work);
+		dp->link_event = KOBJ_MAX;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+		dp->id = vlanconfig[i].vid;
+		dp->portmask = vlanconfig[i].memPort;
+		dp->portnum = 0;
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+		dp->vlan_setting.is_lan = (dp->id != RTL_WANVLANID);
+#endif
+		for (j = 0; j < RTL8651_AGGREGATOR_NUMBER; j++) {
+			if (dp->portmask & (1 << j))
+				dp->portnum++;
+		}
+
+		memcpy((char *)dev->dev_addr, (char *)(&(vlanconfig[i].mac)),
+			ETHER_ADDR_LEN);
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+		if (vlanconfig[i].isWan == 0) {
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+			if (strncmp((vlanconfig[i].ifname),
+					RTL_DRV_LAN_P0_NETIF_NAME,
+					IFNAMSIZ) == 0)
+				strncpy(dev->name, RTL_DRV_ETHLAN_P0_NETIF_NAME,
+					IFNAMSIZ);
+			else
+				strncpy(dev->name, vlanconfig[i].ifname,
+					IFNAMSIZ);
+#endif
+			dev->priv_flags = IFF_DOMAIN_ELAN;
+		} else {
+			strncpy(dev->name, vlanconfig[i].ifname, IFNAMSIZ);
+			dev->priv_flags = IFF_DOMAIN_WAN;
+		}
+#endif
+
+#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+		dev->open = re865x_open;
+		dev->stop = re865x_close;
+		dev->set_multicast_list = re865x_set_rx_mode;
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+		if (memcmp((vlanconfig[i].ifname), RTL_DRV_LAN_P7_NETIF_NAME,
+				4) == 0) {
+			memcpy((char *)dev->name,
+				(char *)(&(vlanconfig[i].ifname)), 5);
+			dev->hard_start_xmit = rtl_bridge_wan_start_xmit;
+		} else
+#endif
+			dev->hard_start_xmit = re865x_start_xmit;
+		dev->get_stats = re865x_get_stats;
+		dev->do_ioctl = re865x_ioctl;
+		dev->tx_timeout = re865x_tx_timeout;
+		dev->set_mac_address = rtl865x_set_hwaddr;
+		dev->change_mtu = rtl865x_set_mtu;
+#if defined(CONFIG_RTL8186_LINK_CHANGE)
+		dev->change_link = rtl865x_set_link;
+#endif
+#ifdef CP_VLAN_TAG_USED
+		dev->features |= NETIF_F_HW_VLAN_TX | NETIF_F_HW_VLAN_RX;
+		dev->vlan_rx_register = cp_vlan_rx_register;
+		dev->vlan_rx_kill_vid = cp_vlan_rx_kill_vid;
+#endif
+
+#else
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+		if (memcmp((vlanconfig[i].ifname), RTL_DRV_LAN_P7_NETIF_NAME,
+				4) == 0) {
+			memcpy((char *)dev->name,
+				(char *)(&(vlanconfig[i].ifname)), 5);
+			dev->netdev_ops = &rtl819x_netdev_ops_bridge;
+		} else
+#endif
+			dev->netdev_ops = &rtl819x_netdev_ops;
+#endif
+		dev->watchdog_timeo = TX_TIMEOUT;
+#if 0
+		dev->features |= NETIF_F_SG | NETIF_F_IP_CSUM;
+#endif
+#ifdef CP_VLAN_TAG_USED
+		dev->features |= NETIF_F_HW_VLAN_TX | NETIF_F_HW_VLAN_RX;
+#endif
+
+		if (vlanconfig[i].isWan != 1) {
+#if (defined(CONFIG_RTL_ETH_TX_SG) || defined(CONFIG_RTL_GSO))
+			dev->features |= (NETIF_F_SG | NETIF_F_GSO);
+#endif
+
+#if (defined(CONFIG_RTL_HW_TX_CSUM) || defined(CONFIG_RTL_97F_HW_TX_CSUM))
+			dev->features |= NETIF_F_HW_CSUM;
+#endif
+
+#ifdef CONFIG_RTL_TSO
+			dev->features |= (NETIF_F_TSO | NETIF_F_TSO_ECN);
+#ifdef CONFIG_IPV6
+			dev->features |= NETIF_F_TSO6;
+#endif
+#endif
+		}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		dev->irq = irq;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		dev->irq = BSP_SWCORE_IRQ;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		rc = register_netdev(dev);
+
+		if (!rc) {
+			_rtl86xx_dev.dev[i] = dev;
+			rtl_add_ps_drv_netif_mapping(dev, vlanconfig[i].ifname);
+			/*2007-12-19 */
+			rtlglue_printf
+				("eth%d added. vid=%d Member port 0x%x...\n", i,
+				vlanconfig[i].vid, vlanconfig[i].memPort);
+		} else
+			rtlglue_printf("Failed to allocate eth%d\n", i);
+
+#ifdef CONFIG_RTL_ETH_NAPI_SUPPORT
+		netif_napi_add(dev, &dp->napi, rtl865x_poll,
+			RTL865X_NAPI_WEIGHT);
+		skb_queue_head_init(&dp->rx_napi_skb_queue);
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_REPORT_LINK_STATUS)
+#ifdef CONFIG_RTL_PROC_NEW
+		res_stats_root = proc_mkdir(dev->name, &proc_root);
+#else
+		res_stats_root = proc_mkdir(dev->name, NULL);
+#endif
+		if (res_stats_root == NULL) {
+			printk("proc_mkdir failed!\n");
+		}
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+		proc_create_data("mib_vlan", 0644, res_stats_root,
+			&mib_vlan_proc_fops, (void *)dev);
+#else
+		if ((res_stats = create_proc_read_entry("mib_vlan", 0644,
+					res_stats_root, read_proc_vlan,
+					(void *)dev)) == NULL) {
+			printk("create_proc_read_entry failed!\n");
+		}
+		res_stats->write_proc = write_proc_vlan;
+#endif
+
+#endif
+
+#if defined(CONFIG_RTL_REPORT_LINK_STATUS)
+		/*FIXME if mutliple-WAN */
+		rtk_linkEvent = 0;
+#ifdef CONFIG_RTL_PROC_NEW
+		proc_create_data("up_event", 0, res_stats_root,
+			&up_event_proc_fops, NULL);
+		proc_create_data("link_status", 0644, res_stats_root,
+			&link_status_proc_fops, (void *)dev);
+#else /*CONFIG_RTL_PROC_NEW */
+		rtk_link_event_entry =
+			create_proc_entry("up_event", 0, res_stats_root);
+		if (rtk_link_event_entry) {
+			rtk_link_event_entry->read_proc = rtk_link_event_read;
+			rtk_link_event_entry->write_proc = rtk_link_event_write;
+		}
+
+		if ((rtk_link_status_entry =
+				create_proc_read_entry("link_status", 0644,
+					res_stats_root, rtk_link_status_read,
+					(void *)dev)) == NULL) {
+			printk("create_proc_read_entry failed!\n");
+		}
+		rtk_link_status_entry->write_proc = rtk_link_status_write;
+#endif /*CONFIG_RTL_PROC_NEW */
+
+#endif
+
+	}
+
+#ifdef CONFIG_SWCONFIG
+	rtl819x_swconfig_init(_rtl86xx_dev.dev[0]);
+#if defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+	rtl_create_hw_nat_vid_proc();
+#endif
+#endif
+
+#if	defined(CONFIG_PPPOE_VLANTAG)
+
+	res_stats_root = proc_mkdir("ppp", NULL);
+	if (res_stats_root == NULL) {
+		printk("proc_mkdir failed!\n");
+	}
+
+	if ((res_stats = create_proc_entry("mib_vlan", 0644, res_stats_root))
+		== NULL) {
+		printk("create_proc_entry failed!\n");
+	}
+	res_stats->write_proc = write_PPPOE_proc_vlan;
+	res_stats->read_proc = read_PPPOE_proc_vlan;
+#endif
+
+#ifdef RTK_MANAGE_VLAN_IF
+	rtk_add_manage_vlan_dev(RTL_WANVLANID);	/* just create for default */
+#endif
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	rtl_config_multipleWan_netif(RTL_MULTIWAN_ADD);
+	/* rtl865x_addMultiCastNetif(); */
+	rtl_regist_multipleWan_dev();
+	rtl819x_igmp_proxy_wan_dev_proc_init();
+#elif defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+	rtl_init_advRt();
+#endif
+#if defined(CONFIG_RTL_MULTIPLE_WAN) || defined(CONFIG_RTL_MAC_BASED_NETIF)
+	rtl865x_addMultiCastNetif();
+#endif
+
+#if defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	memset(&mCastConfig, 0, sizeof(rtl865x_mCastConfig_t));
+	for (i = 0; i < totalVlans; i++) {
+		if (TRUE == vlanconfig[i].isWan) {
+			mCastConfig.externalPortMask |= vlanconfig[i].memPort;
+		}
+	}
+	rtl865x_initMulticast(&mCastConfig);
+#endif
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+	retVal = rtl_registerIgmpSnoopingModule(&nicIgmpModuleIndex);
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	if (retVal == SUCCESS) {
+		rtl_multicastDeviceInfo_t devInfo;
+		memset(&devInfo, 0, sizeof(rtl_multicastDeviceInfo_t));
+		strcpy(devInfo.devName, "eth*");
+		for (i = 0; i < totalVlans; i++) {
+			if (vlanconfig[i].if_type == IF_ETHER) {
+				devInfo.portMask |= vlanconfig[i].memPort;
+			}
+		}
+		devInfo.swPortMask =
+			devInfo.portMask & (~((1 << RTL8651_MAC_NUMBER) - 1));
+		rtl_setIgmpSnoopingModuleDevInfo(nicIgmpModuleIndex, &devInfo);
+	}
+#endif
+	rtl_setIpv4UnknownMCastFloodMap(nicIgmpModuleIndex, 0xFFFFFFFF);
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	rtl_setIpv6UnknownMCastFloodMap(nicIgmpModuleIndex, 0xFFFFFFFF);
+#endif
+	curLinkPortMask = rtl865x_getPhysicalPortLinkStatus();
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	memset(&mCastConfig, 0, sizeof(rtl865x_mCastConfig_t));
+	for (i = 0; i < totalVlans; i++) {
+		if (TRUE == vlanconfig[i].isWan) {
+			mCastConfig.externalPortMask |= vlanconfig[i].memPort;
+		}
+	}
+	rtl865x_initMulticast(&mCastConfig);
+
+#endif
+#endif
+
+#if 0				/* def CONFIG_RTL_STP */
+	printk("Configuration ether driver to process port 0 ~ port %d for Spanning tree process\n", MAX_RE865X_ETH_STP_PORT - 1);
+	/* Initial: disable Realtek Hardware STP */
+	rtl865x_setSpanningEnable(FALSE);
+
+	for (i = 0; i < MAX_RE865X_ETH_STP_PORT; i++) {
+		struct net_device *dev;
+		struct dev_priv *dp;
+		int rc;
+		struct re865x_priv *rp;
+
+		rp = &_rtl86xx_dev;
+		dev = alloc_etherdev(sizeof(struct dev_priv));
+		if (!dev) {
+			rtlglue_printf("failed to allocate dev %d", i);
+			return -1;
+		}
+		strcpy(dev->name, "port%d");
+		memcpy((char *)dev->dev_addr, (char *)(&(vlanconfig[0].mac)),
+			ETHER_ADDR_LEN);
+		dp = NETDRV_PRIV(dev);
+		memset(dp, 0, sizeof(*dp));
+		dp->dev = dev;
+#ifdef CONFIG_COMPAT_NET_DEV_OPS
+		dev->open = re865x_pseudo_open;
+		dev->stop = re865x_pseudo_close;
+		dev->set_multicast_list = NULL;
+		dev->hard_start_xmit = re865x_start_xmit;
+		dev->get_stats = re865x_get_stats;
+		dev->do_ioctl = re865x_ioctl;
+		dev->tx_timeout = NULL;
+#else
+		dev->netdev_ops = &rtl819x_pseudodev_ops;
+#endif
+		dev->watchdog_timeo = TX_TIMEOUT;
+		dev->irq = 0;	/* virtual interfaces has no IRQ allocated */
+		rc = register_netdev(dev);
+		if (rc == 0) {
+			_rtl86xx_dev.stp_port[i] = dev;
+			printk("=> [stp pseudo port%d] done\n", i);
+		} else {
+			printk("=> Failed to register [stp pseudo port%d]", i);
+			return -1;
+		}
+	}
+
+	re865x_stp_mapping_init();
+#endif
+#if defined(CONFIG_RTL_HW_STP) || defined(CONFIG_RTL_STP)
+	/* Initial: disable Realtek Hardware STP */
+	rtl865x_setSpanningEnable(FALSE);
+#endif
+
+	#if defined(CONFIG_RTL_WAN_MAC5)
+	((struct dev_priv *)(NETDRV_PRIV(_rtl86xx_dev.dev[0])))->dev_next =
+		NULL;
+	#else /* CONFIG_RTL_WAN_MAC5 */
+	((struct dev_priv *)(NETDRV_PRIV(_rtl86xx_dev.dev[0])))->dev_next =
+		_rtl86xx_dev.dev[1];
+	((struct dev_priv *)(NETDRV_PRIV(_rtl86xx_dev.dev[1])))->dev_prev =
+		_rtl86xx_dev.dev[0];
+	#endif /* CONFIG_RTL_WAN_MAC5 */
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+	init_priv_eth_skb_buf();
+#endif
+
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+	/* cary */
+	rtl8651_customPassthru_init();
+#endif
+
+	rtl8651_initStormCtrl();
+
+#if 0				/* defined(CONFIG_RTL_8197F) */
+	rtl8651_initExtendStormCtrl();
+#endif
+
+#if defined(CONFIG_RTL_WAN_PORT_SETTING)
+	rtl819x_initWanPortSetting();
+#endif
+
+	rtl819x_eee_proc_init();
+
+#ifdef CONFIG_RTL_JATE_TEST
+	rtl819x_jate_proc_init();
+#endif
+
+#if defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	/* initial proc for phyRegTest */
+	phyRegTest_init();
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER_L3
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST) && !defined(CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+	rtl8651_setAsicMulticastEnable(TRUE);
+#else
+	rtl8651_setAsicMulticastEnable(FALSE);
+#endif
+#endif
+
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+#ifdef CONFIG_RTL_PROC_NEW
+	rtl_link_status_pid_init();
+	proc_create_data("rtk_linkstatus_pid", 0, &proc_root,
+		&rtk_auto_dhcp_proc_fops, NULL);
+#else
+	rtl_link_status_pid_init();
+	proc = create_proc_entry("rtk_linkstatus_pid", 0, NULL);
+	if (proc) {
+		proc->read_proc = rtk_linkstatus_pid_read;
+		proc->write_proc = rtk_linkstatus_pid_write;
+	}
+#endif
+#endif
+
+#ifdef CONFIG_RTL_HARDWARE_IPV6_SUPPORT
+	rtk_hwL3v6_enable = 1;
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("hwL3v6", 0, &proc_root, &rtk_hwL3v6_proc_fops, NULL);
+#else
+	hwL3v6 = create_proc_entry("hwL3v6", 0, NULL);
+	if (hwL3v6) {
+		hwL3v6->read_proc = rtk_hwL3v6_read;
+		hwL3v6->write_proc = rtk_hwL3v6_write;
+	}
+#endif
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+
+	rtk_vlan_support_enable = 0;
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("rtk_vlan_support", 0, &proc_root,
+		&rtk_vlan_support_proc_fops, NULL);
+#else
+	rtk_vlan_support_entry = create_proc_entry("rtk_vlan_support", 0, NULL);
+	if (rtk_vlan_support_entry) {
+		rtk_vlan_support_entry->read_proc = rtk_vlan_support_read;
+		rtk_vlan_support_entry->write_proc = rtk_vlan_support_write;
+	}
+#endif
+
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+	memset(&management_vlan, 0, sizeof(struct vlan_info *));
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("rtk_vlan_management_entry", 0, &proc_root,
+		&rtk_vlan_management_proc_fops, NULL);
+#else
+	rtk_vlan_management_entry =
+		create_proc_entry("rtk_vlan_management_entry", 0, NULL);
+	if (rtk_vlan_management_entry) {
+		rtk_vlan_management_entry->read_proc = rtk_vlan_management_read;
+		rtk_vlan_management_entry->write_proc =
+			rtk_vlan_management_write;
+	}
+#endif
+#endif
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("rtk_vlan_wan_tag", 0, &proc_root,
+		&rtk_vlan_wan_tag_proc_fops, NULL);
+#else
+	rtk_vlan_wan_tag_support_entry =
+		create_proc_entry("rtk_vlan_wan_tag", 0, NULL);
+	if (rtk_vlan_wan_tag_support_entry) {
+		rtk_vlan_wan_tag_support_entry->read_proc =
+			rtk_vlan_wan_tag_support_read;
+		rtk_vlan_wan_tag_support_entry->write_proc =
+			rtk_vlan_wan_tag_support_write;
+	}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("jumbo_frame_support", 0, &proc_root,
+		&jumbo_frame_proc_fops, NULL);
+#else
+	jumbo_frame_support_entry =
+		create_proc_entry("jumbo_frame_support", 0, NULL);
+	if (jumbo_frame_support_entry) {
+		jumbo_frame_support_entry->read_proc = jumbo_frame_support_read;
+		jumbo_frame_support_entry->write_proc =
+			jumbo_frame_support_write;
+	}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("link_aggregation", 0, &proc_root,
+		&link_aggregation_proc_fops, NULL);
+#else
+	link_aggregation_entry = create_proc_entry("link_aggregation", 0, NULL);
+	if (link_aggregation_entry) {
+		link_aggregation_entry->read_proc = link_aggregation_read;
+		link_aggregation_entry->write_proc = link_aggregation_write;
+	}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("rtl_hw_vlan_support", 0, &proc_root,
+		&rtl_hw_vlan_support_proc_fops, NULL);
+	proc_create_data("rtl_hw_vlan_tagged_mc", 0, &proc_root,
+		&rtl_hw_vlan_tagged_mc_proc_fops, NULL);
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+	proc_create_data("rtk_multicast_scream_vid", 0, &proc_root,
+		&rtk_multicast_scream_vid_proc_fops, NULL);
+	proc_create_data("rtk_query_for_bridge_port", 0, &proc_root,
+		&rtk_query_for_bridge_port_proc_fops, NULL);
+#endif
+#else
+	rtl_hw_vlan_support_entry =
+		create_proc_entry("rtl_hw_vlan_support", 0, NULL);
+	if (rtl_hw_vlan_support_entry) {
+		rtl_hw_vlan_support_entry->read_proc = rtl_hw_vlan_support_read;
+		rtl_hw_vlan_support_entry->write_proc =
+			rtl_hw_vlan_support_write;
+	}
+	rtl_hw_vlan_tagged_bridge_multicast_entry =
+		create_proc_entry("rtl_hw_vlan_tagged_mc", 0, NULL);
+	if (rtl_hw_vlan_tagged_bridge_multicast_entry) {
+		rtl_hw_vlan_tagged_bridge_multicast_entry->read_proc =
+			rtl_hw_vlan_tagged_bridge_multicast_read;
+		rtl_hw_vlan_tagged_bridge_multicast_entry->write_proc =
+			rtl_hw_vlan_tagged_bridge_multicast_write;
+	}
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+	rtk_multicast_scream_vid_entry =
+		create_proc_entry("rtk_multicast_scream_vid", 0, NULL);
+	if (rtk_multicast_scream_vid_entry) {
+		rtk_multicast_scream_vid_entry->read_proc =
+			rtk_multicast_scream_vid_read;
+		rtk_multicast_scream_vid_entry->write_proc =
+			rtk_multicast_scream_vid_write;
+	}
+
+	rtk_query_for_bridge_port_entry =
+		create_proc_entry("rtk_query_for_bridge_port", 0, NULL);
+	if (rtk_query_for_bridge_port_entry) {
+		rtk_query_for_bridge_port_entry->read_proc =
+			rtk_query_for_bridge_port_read;
+		rtk_query_for_bridge_port_entry->write_proc =
+			rtk_query_for_bridge_port_write;
+	}
+#endif
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("rtl_8367r_vlan", 0, &proc_root,
+		&rtl_8367r_vlan_proc_fops, NULL);
+#else
+	rtl_8367r_vlan = create_proc_entry("rtl_8367r_vlan", 0, NULL);
+	if (rtl_8367r_vlan) {
+		rtl_8367r_vlan->read_proc = rtl_8367r_vlan_read;
+	}
+#endif
+#endif
+
+#if defined(CONFIG_819X_PHY_RW)
+/* #if defined(CONFIG_RTK_VLAN_FOR_CABLE_MODEM) */
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("rtl_phy_status", 0, &proc_root,
+		&rtl_phy_status_proc_fops, NULL);
+#else
+	rtl_phy = create_proc_entry("rtl_phy_status", 0, NULL);
+	if (rtl_phy) {
+		rtl_phy->read_proc = rtl_phy_status_read;
+		rtl_phy->write_proc = rtl_phy_status_write;
+	}
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+	port_mibStats_root = proc_mkdir("ethPort_mibStats", &proc_root);
+#else
+	port_mibStats_root = proc_mkdir("ethPort_mibStats", NULL);
+#endif
+	if (port_mibStats_root == NULL) {
+		printk("proc_mkdir failed!\n");
+	}
+	for (portnum = 0; portnum < CPU; portnum++) {
+		sprintf(&port_mibEntry_name[0], "port%u", portnum);
+#ifdef CONFIG_RTL_PROC_NEW
+		proc_create_data(port_mibEntry_name, 0, port_mibStats_root,
+			&port_mibEntry_proc_fops, (void *)portnum);
+#else
+		port_mibStats_entry =
+			create_proc_entry(port_mibEntry_name, 0,
+			port_mibStats_root);
+		port_mibStats_entry->data = (void *)portnum;
+		if (port_mibStats_entry) {
+			port_mibStats_entry->read_proc =
+				port_mibStats_read_proc;
+			port_mibStats_entry->write_proc =
+				port_mibStats_write_proc;
+		}
+#endif
+	}
+#endif /* #if defined(CONFIG_819X_PHY_RW) */
+
+#if defined(CONFIG_TR181_ETH)
+	{
+		extern struct proc_dir_entry *rtl865x_proc_dir;
+
+#ifdef CONFIG_RTL_PROC_NEW
+		proc_create_data("tr181_eth_link", 0, rtl865x_proc_dir,
+			&tr181_eth_link_proc_fops, NULL);
+		proc_create_data("tr181_eth_if", 0, rtl865x_proc_dir,
+			&tr181_eth_if_proc_fops, NULL);
+		proc_create_data("tr181_eth_stats", 0, rtl865x_proc_dir,
+			&tr181_eth_stats_proc_fops, NULL);
+		proc_create_data("tr181_eth_set", 0, rtl865x_proc_dir,
+			&tr181_eth_set_proc_fops, NULL);
+#else
+		tr181_eth_link =
+			create_proc_entry("tr181_eth_link", 0,
+			rtl865x_proc_dir);
+		if (tr181_eth_link) {
+			tr181_eth_link->read_proc = tr181_eth_link_read;
+			tr181_eth_link->write_proc = tr181_eth_link_write;
+		}
+		tr181_eth_if =
+			create_proc_entry("tr181_eth_if", 0, rtl865x_proc_dir);
+		if (tr181_eth_if) {
+			tr181_eth_if->read_proc = tr181_eth_if_read;
+			tr181_eth_if->write_proc = tr181_eth_if_write;
+		}
+		tr181_eth_stats =
+			create_proc_entry("tr181_eth_stats", 0,
+			rtl865x_proc_dir);
+		if (tr181_eth_stats) {
+			tr181_eth_stats->read_proc = tr181_eth_stats_read;
+			tr181_eth_stats->write_proc = tr181_eth_stats_write;
+		}
+		tr181_eth_set =
+			create_proc_entry("tr181_eth_set", 0, rtl865x_proc_dir);
+		if (tr181_eth_set) {
+			tr181_eth_set->read_proc = tr181_eth_set_read;
+			tr181_eth_set->write_proc = tr181_eth_set_write;
+		}
+#endif
+	}
+#endif
+
+#ifdef CONFIG_RTL_INBAND_CTL_ACL
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("inband_ctl_acl", 0, &proc_root,
+		&rtk_inband_ctl_acl_proc_fops, NULL);
+#else
+	inband_ctl_acl = create_proc_entry("inband_ctl_acl", 0, NULL);
+	if (inband_ctl_acl) {
+		inband_ctl_acl->read_proc = inband_ctl_acl_read;
+		inband_ctl_acl->write_proc = inband_ctl_acl_write;
+	}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("dslite_hw_fw", 0, &proc_root,
+		&rtk_dslite_hw_forward_proc_fops, NULL);
+#endif
+#endif
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("6rd_hw_fw", 0, &proc_root,
+		&rtk_6rd_hw_forward_proc_fops, NULL);
+#endif
+#endif
+#endif
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+	rtl865x_initLocalPublic(NULL);
+
+	memset(&ifInfo, 0, sizeof(struct rtl865x_interface_info));
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+	strcpy(ifInfo.ifname, RTL_GW_WAN_DEVICE_NAME);
+#else
+	strcpy(ifInfo.ifname, RTL_DRV_WAN0_NETIF_NAME);
+#endif
+	ifInfo.isWan = 1;
+	for (i = 0; i < totalVlans; i++) {
+		if ((TRUE == vlanconfig[i].isWan)
+			&& (vlanconfig[i].if_type == IF_ETHER)) {
+			ifInfo.memPort |= vlanconfig[i].memPort;
+			ifInfo.fid = vlanconfig[i].fid;
+		}
+	}
+	rtl865x_setLpIfInfo(&ifInfo);
+
+	memset(&ifInfo, 0, sizeof(struct rtl865x_interface_info));
+	strcpy(ifInfo.ifname, RTL_DRV_LAN_NETIF_NAME);
+	ifInfo.isWan = 0;
+	for (i = 0; i < totalVlans; i++) {
+		if ((FALSE == vlanconfig[i].isWan)
+			&& (vlanconfig[i].if_type == IF_ETHER)) {
+			ifInfo.memPort |= vlanconfig[i].memPort;
+			ifInfo.fid = vlanconfig[i].fid;
+		}
+	}
+	rtl865x_setLpIfInfo(&ifInfo);
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	atomic_set(&rtl_rxTxDoneCnt, 0);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	rtl_rxTxDoneCnt = 0;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	atomic_set(&rtl_devOpened, 0);
+
+#if defined(PATCH_GPIO_FOR_LED)
+	for (port = 0; port < RTL8651_PHY_NUMBER; port++)
+		init_led_ctrl(port);
+#endif
+
+#if defined(CONFIG_RTL_LINKSTATE)
+	initPortStateCtrl();
+#endif
+
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	rtl8651_initMldSnooping();
+#endif
+
+#if defined(CONFIG_RTL_8367_QOS_SUPPORT) || defined(CONFIG_RTL_8367_QOS_TEST)
+	rtl_init8367QosProc();
+#endif
+
+#if defined(CONFIG_RTL_PHY_POWER_CTRL)
+	rtl865x_initPhyPowerCtrl();
+#endif
+
+#if defined(RTL_CPU_QOS_ENABLED)
+	highPrioRxTryCnt = MAX_HIGH_PRIO_TRY;
+	highestPriority = 0;
+	cpuQosHoldLow = 0;
+	totalLowQueueCnt = 0;
+	memset(pktQueueByPri, 0,
+		sizeof(rtl_queue_entry) * (RTL865X_SWNIC_RXRING_MAX_PKTDESC));
+#endif
+
+	rtl865x_config_callback_for_get_drv_netifName
+		(rtl_get_ps_drv_netif_mapping_by_psdev_name);
+#if defined(REINIT_SWITCH_CORE)
+	rtl865x_creatReInitSwitchCoreProc();
+#endif
+
+#if defined(RX_TASKLET)
+	rtl_rx_tasklet_running = 0;
+#endif
+#if defined(TX_TASKLET)
+	rtl_tx_tasklet_running = 0;
+#endif
+#if defined(CONFIG_RTL_SOCK_DEBUG)
+	rtl865x_creatSockDebugProc();
+#endif
+
+#if 0				/* def CONFIG_RTL_ULINKER //led */
+	REG32(PIN_MUX_SEL_2) = REG32(PIN_MUX_SEL_2) | 0x00003000;
+	REG32(PABCD_CNR) = REG32(PABCD_CNR) & ~(0x00004000);
+	REG32(PABCD_DIR) = REG32(PABCD_DIR) | 0x00004000;
+	REG32(PABCD_DAT) = REG32(PABCD_DAT) & ~(0x00004000);
+#endif
+
+	memset(&rx_skb_queue, 0, sizeof(struct ring_que));
+
+#if defined(CONFIG_RTL_ETH_802DOT1X_SUPPORT)
+	/* extern int init_802dot1x(void); */
+	rtl_init802dot1x();
+#endif
+
+#ifdef SUPPORT_DHCP_PORT_IP_BIND
+	memset(port_mac_table, 0, sizeof(DHCP_PORT_MAC) * RTL8651_PHY_NUMBER);
+#endif
+
+#if defined(CONFIG_RTL_DNS_TRAP)	/* && defined(CONFIG_RTL_AP_PACKAGE) */
+	re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+	rtl_remove_Acl_for_dns_trap(packedVlanConfig);
+	rtl_add_Acl_for_dns_trap(packedVlanConfig);
+#endif
+
+#if defined(CONFIG_OPENWRT_SDK)
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	rtl_enable_netif_routing();
+#endif
+
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+	rtl_hw_nat_init_refine();
+#endif
+#if defined(CONFIG_NET_SCHED)
+	rtl_qos_init();
+#endif
+#endif
+
+#ifdef CONFIG_RTL_836X_SUPPORT
+	rtl836x_init();
+#endif
+
+	return 0;
+}
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+
+/* --------------------------------------------------------------------------- */
+static void init_priv_eth_skb_buf(void)
+{
+	int i;
+
+	DEBUG_ERR("Init priv skb.\n");
+	memset(eth_skb_buf, '\0',
+		sizeof(struct priv_skb_buf2) * (MAX_ETH_SKB_NUM));
+	INIT_LIST_HEAD(&eth_skbbuf_list);
+	eth_skb_free_num = MAX_ETH_SKB_NUM;
+
+	for (i = 0; i < MAX_ETH_SKB_NUM; i++) {
+		memcpy(eth_skb_buf[i].magic, ETH_MAGIC_CODE, ETH_MAGIC_LEN);
+		eth_skb_buf[i].buf_pointer = (void *)(&eth_skb_buf[i]);
+		INIT_LIST_HEAD(&eth_skb_buf[i].list);
+		list_add_tail(&eth_skb_buf[i].list, &eth_skbbuf_list);
+	}
+}
+
+static inline unsigned char *get_buf_from_poll(struct list_head *phead,
+	unsigned int *count)
+{
+	unsigned long flags = 0;
+	unsigned char *buf;
+	struct list_head *plist;
+
+	SMP_LOCK_ETH_BUF(flags);
+
+	if (list_empty(phead)) {
+		SMP_UNLOCK_ETH_BUF(flags);
+		DEBUG_ERR("eth_drv: phead=%X buf is empty now!\n",
+			(unsigned int)phead);
+		DEBUG_ERR("free count %d\n", *count);
+		return NULL;
+	}
+
+	if (*count == 1) {
+		SMP_UNLOCK_ETH_BUF(flags);
+		DEBUG_ERR("eth_drv: phead=%X under-run!\n",
+			(unsigned int)phead);
+		return NULL;
+	}
+
+	*count = *count - 1;
+	plist = phead->next;
+	list_del_init(plist);
+	buf = (unsigned char *)((unsigned int)plist + sizeof(struct list_head));
+	SMP_UNLOCK_ETH_BUF(flags);
+	return buf;
+}
+
+static inline void release_buf_to_poll(unsigned char *pbuf,
+	struct list_head *phead, unsigned int *count)
+{
+	unsigned long flags = 0;
+	struct list_head *plist;
+
+	SMP_LOCK_ETH_BUF(flags);
+
+	*count = *count + 1;
+	plist = (struct list_head *)((unsigned int)pbuf -
+		sizeof(struct list_head));
+	list_add_tail(plist, phead);
+	SMP_UNLOCK_ETH_BUF(flags);
+}
+
+__IRAM_GEN void free_rtl865x_eth_priv_buf(unsigned char *head)
+{
+#if defined(DELAY_REFILL_ETH_RX_BUF) || defined(ALLOW_RX_RING_PARTIAL_EMPTY)
+	if (((atomic_read(&rtl_devOpened) > 0)
+			&& (FAILED == return_to_rx_pkthdr_ring(head)))
+		|| (atomic_read(&rtl_devOpened) == 0))
+#endif
+	{
+		release_buf_to_poll(head, &eth_skbbuf_list,
+			(unsigned int *)&eth_skb_free_num);
+	}
+}
+
+__MIPS16 __IRAM_FWD
+	static struct sk_buff *dev_alloc_skb_priv_eth(unsigned int size)
+{
+	struct sk_buff *skb;
+	unsigned char *data;
+
+	/* first argument is not used */
+	if (eth_skb_free_num > 0) {
+		data = get_buf_from_poll(&eth_skbbuf_list,
+			(unsigned int *)&eth_skb_free_num);
+		if (data == NULL) {
+			DEBUG_ERR("eth_drv: priv_skb buffer empty!\n");
+			return NULL;
+		}
+
+		skb = dev_alloc_8190_skb(data, size);
+
+		if (skb == NULL) {
+			/* free_rtl865x_eth_priv_buf(data); */
+			release_buf_to_poll(data, &eth_skbbuf_list,
+				(unsigned int *)&eth_skb_free_num);
+			DEBUG_ERR("alloc linux_skb buff failed!\n");
+			return NULL;
+		}
+		return skb;
+	}
+
+	return NULL;
+}
+
+__MIPS16 __IRAM_FWD int is_rtl865x_eth_priv_buf(unsigned char *head)
+{
+	unsigned long offset =
+		(unsigned long)(&((struct priv_skb_buf2 *)0)->buf);
+	struct priv_skb_buf2 *priv_buf =
+		(struct priv_skb_buf2 *)(((unsigned long)head) - offset);
+
+	if ((!memcmp(priv_buf->magic, ETH_MAGIC_CODE, ETH_MAGIC_LEN)) &&
+		(priv_buf->buf_pointer == (void *)(priv_buf))) {
+		return 1;
+	} else {
+		return 0;
+	}
+}
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB) || defined(CONFIG_NET_WIRELESS_AGN) || defined(CONFIG_NET_WIRELESS_AG)
+extern void copy_skb_header(struct sk_buff *new, const struct sk_buff *old);
+struct sk_buff *priv_skb_copy(struct sk_buff *skb)
+{
+	struct sk_buff *n;
+	unsigned long flags = 0;
+
+	if (rx_skb_queue.qlen == 0) {
+		n = dev_alloc_skb_priv_eth(CROSS_LAN_MBUF_LEN);
+	} else {
+#if defined(RTK_QUE)
+		SMP_LOCK_ETH_BUF(flags);
+		n = rtk_dequeue(&rx_skb_queue);
+		SMP_UNLOCK_ETH_BUF(flags);
+#else
+		n = __skb_dequeue(&rx_skb_queue);
+#endif
+	}
+
+	if (n == NULL) {
+		return NULL;
+	}
+
+	/* Set the tail pointer and length */
+	skb_put(n, skb->len);
+	n->csum = skb->csum;
+	n->ip_summed = skb->ip_summed;
+	memcpy(n->data, skb->data, skb->len);
+
+	copy_skb_header(n, skb);
+	return n;
+}
+
+EXPORT_SYMBOL(priv_skb_copy);
+#endif /* defined(CONFIG_NET_WIRELESS_AGN) || defined(CONFIG_NET_WIRELESS_AG) */
+#endif /* CONFIG_RTL_ETH_PRIV_SKB */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+static int re865x_exit(struct platform_device *pdev)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+static void __exit re865x_exit(void)
+#endif				/* defined(CONFIG_RTD_1295_HWNAT) */
+{
+#if defined(RX_TASKLET) || defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+	struct net_device *dev = platform_get_drvdata(pdev);
+	struct dev_priv *cp = netdev_priv(dev);
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+	struct sk_buff *skb;
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+#endif /* RX_TASKLET || CONFIG_RTL_ETH_NAPI_SUPPORT */
+#if defined(RX_TASKLET) || defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+	int i;
+#endif /* RX_TASKLET || CONFIG_RTL_ETH_NAPI_SUPPORT */
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+
+	rtl865x_proc_debug_cleanup();
+#endif
+
+#if defined(CONFIG_PROC_FS) && defined(CONFIG_NET_SCHED) && defined(CONFIG_RTL_LAYERED_DRIVER)
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	rtl865x_exitOutputQueue();
+#endif
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+	rtl_exitMulticastSnooping();
+#endif
+
+#if defined(CONFIG_RTL_LINKSTATE)
+	exitPortStateCtrl();
+#endif
+#if defined(CONFIG_RTL_WAN_PORT_SETTING)
+	rtl819x_exitWanPortSetting();
+#endif
+
+#if defined(RX_TASKLET) || defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		dev = (struct net_device *)_rtl86xx_dev.dev[i];
+		if (!dev)
+			continue;
+
+		cp = NETDRV_PRIV(dev);
+#ifdef CONFIG_RTL_ETH_NAPI_SUPPORT
+		netif_napi_del(&cp->napi);
+		cp->napi.poll = NULL;
+		if (skb_queue_len(&cp->rx_napi_skb_queue)) {
+			printk(KERN_WARNING "rx_napi_skb_queue not empty\n");
+			while ((skb = skb_dequeue(&cp->rx_napi_skb_queue)) != NULL)
+				dev_kfree_skb_any(skb);
+		}
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+	}
+#endif /* RX_TASKLET || CONFIG_RTL_ETH_NAPI_SUPPORT */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (hwnat_gpio_link_led_enable)
+		gpio_free(hwnat_gpio_link_led);
+
+	return 0;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	return;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}
+
+#ifdef CONFIG_RTK_FAKE_ETH
+
+int32 rtl8651_EthernetPowerDown(void)
+{
+	uint32 statCtrlReg0;
+	int i;
+
+	/* ## from rtl8651_setAllAsicEthernetPHYPowerDown */
+	for (i = 0; i < 5; i++) {
+
+		/* read current PHY reg 0 value */
+		rtl8651_getAsicEthernetPHYReg(i, 0, &statCtrlReg0);
+
+		REG32(PCRP0 + (i * 4)) |= EnForceMode;
+		statCtrlReg0 |= POWER_DOWN;
+
+		/* write PHY reg 0 */
+		rtl8651_setAsicEthernetPHYReg(i, 0, statCtrlReg0);
+	}
+	/* ####################################### */
+
+	/* then set bit 9 of 0xb800-0010 to 0. deactive switch core */
+
+	REG32(SYS_CLK_MAG) &= (~(SYS_SW_CLK_ENABLE));
+
+	return SUCCESS;
+}
+
+int re865x_ioctl_fake(struct net_device *dev, struct ifreq *rq, int cmd)
+{
+	int32 rc = 0;
+	unsigned long *data;
+	int32 args[4];
+	int32 *pRet;
+
+	data = (unsigned long *)rq->ifr_data;
+
+	if (copy_from_user(args, data, 4 * sizeof(unsigned long))) {
+		return -EFAULT;
+	}
+
+	switch (args[0]) {
+	case RTL8651_IOCTL_GETWANLINKSTATUS:
+		{
+			pRet = (int32 *)args[3];
+			*pRet = FAILED;
+			rc = SUCCESS;
+
+			break;
+		}
+
+	case RTL8651_IOCTL_GETWANLINKSPEED:
+		{
+			int wanPortMask;
+
+			pRet = (int32 *)args[3];
+			*pRet = FAILED;
+			rc = SUCCESS;
+
+			wanPortMask = 0;
+
+			/* no wan port exist */
+			break;
+		}
+	default:
+		rc = SUCCESS;
+		break;
+	}
+
+	return rc;
+
+}
+
+static int rtl865x_set_mtu_fake(struct net_device *dev, int new_mtu)
+{
+	unsigned long flags = 0;
+
+	SMP_LOCK_ETH(flags);
+	dev->mtu = new_mtu;
+
+	SMP_UNLOCK_ETH(flags);
+
+	return SUCCESS;
+}
+
+static int rtl865x_set_hwaddr_fake(struct net_device *dev, void *addr)
+{
+	unsigned long flags = 0;
+	int i;
+	unsigned char *p;
+
+	p = ((struct sockaddr *)addr)->sa_data;
+	SMP_LOCK_ETH(flags);
+
+	for (i = 0; i < ETHER_ADDR_LEN; ++i) {
+		dev->dev_addr[i] = p[i];
+	}
+
+	SMP_UNLOCK_ETH(flags);
+	return SUCCESS;
+}
+
+static int re865x_start_xmit_fake(struct sk_buff *skb, struct net_device *dev)
+{
+
+	dev_kfree_skb_any(skb);
+	return 0;
+
+}
+
+static int re865x_open_fake(struct net_device *dev)
+{
+	struct dev_priv *cp;
+
+	cp = NETDRV_PRIV(dev);
+	if (cp->opened)
+		return SUCCESS;
+
+	cp->opened = 1;
+	netif_start_queue(dev);
+	return SUCCESS;
+}
+
+static int re865x_close_fake(struct net_device *dev)
+{
+	struct dev_priv *cp;
+
+	cp = NETDRV_PRIV(dev);
+
+	if (!cp->opened)
+		return SUCCESS;
+	netif_stop_queue(dev);
+
+/* memset(&cp->net_stats, '\0', sizeof(struct net_device_stats)); */
+	cp->opened = 0;
+
+#ifdef BR_SHORTCUT
+	if (dev == cached_dev)
+		cached_dev = NULL;
+#endif
+	return SUCCESS;
+}
+
+#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+#else
+static const struct net_device_ops rtl819x_netdev_ops_fake = {
+	.ndo_open = re865x_open_fake,
+	.ndo_stop = re865x_close_fake,
+/* .ndo_validate_addr      = eth_validate_addr_fake, */
+	.ndo_set_mac_address = rtl865x_set_hwaddr_fake,
+/* .ndo_set_multicast_list = re865x_set_rx_mode_fake, */
+/* .ndo_get_stats          = re865x_get_stats_fake, */
+	.ndo_do_ioctl = re865x_ioctl_fake,
+	.ndo_start_xmit = re865x_start_xmit_fake,
+/* .ndo_tx_timeout         = re865x_tx_timeout_fake, */
+/* #if defined(CP_VLAN_TAG_USED) */
+/* .ndo_vlan_rx_register   = cp_vlan_rx_register, */
+/* endif */
+	.ndo_change_mtu = rtl865x_set_mtu_fake,
+
+};
+#endif
+
+int __init re865x_probe_fake(void)
+{
+	struct net_device *dev;
+	struct dev_priv *dp;
+	int rc;
+
+	dev = alloc_etherdev(sizeof(struct dev_priv));
+	if (!dev) {
+		printk("failed to allocate dev %d", 0);
+		return -1;
+	}
+
+	dp = NETDRV_PRIV(dev);
+	memset(dp, 0, sizeof(*dp));
+	dp->dev = dev;
+
+	memcpy((char *)dev->dev_addr, (char *)(&(vlanconfig[0].mac)), ETHER_ADDR_LEN);	/* mark_FIXME. */
+
+#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+	dev->open = re865x_open_fake;
+	dev->stop = re865x_close_fake;
+	/* dev->set_multicast_list = re865x_set_rx_mode; */
+	dev->hard_start_xmit = re865x_start_xmit_fake;
+	/* dev->get_stats = re865x_get_stats; */
+	dev->do_ioctl = re865x_ioctl_fake;
+	/* dev->tx_timeout = re865x_tx_timeout; */
+	dev->set_mac_address = rtl865x_set_hwaddr_fake;
+	dev->change_mtu = rtl865x_set_mtu_fake;
+#else
+	dev->netdev_ops = &rtl819x_netdev_ops_fake;
+#endif
+
+	dev->watchdog_timeo = TX_TIMEOUT;
+
+	rc = register_netdev(dev);
+
+#ifdef BR_SHORTCUT
+	cached_dev = NULL;
+#endif
+
+	if (rc)
+		rtlglue_printf("Failed to allocate eth%d\n", 0);
+
+	rc = rtl8651_EthernetPowerDown();
+
+	return 0;
+}
+
+static void __exit re865x_exit_fake(void)
+{
+	return;
+}
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#ifdef CONFIG_PM
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+void rtl819x_save_hw_tables(void);
+#endif /* CONFIG_RTL_HARDWARE_NAT */
+void rtd129x_save_regs(void);
+void rtd129x_restore_regs(void);
+void rtd129x_restore_alecr_regs(void);
+static bool rtl_hwnat_enable_orig;
+
+static int rtd129x_nat_suspend(struct device *dev)
+{
+	struct net_device *ndev;
+	int i;
+	struct dev_priv *cp;
+
+	printk(KERN_ERR "[RTD129X_NAT] Enter %s\n", __func__);
+
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		ndev = _rtl86xx_dev.dev[i];
+		if (ndev) {
+			cp = NETDRV_PRIV(ndev);
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+			napi_disable(&cp->napi);
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+			if (netif_running(ndev)) {
+				DBG(KERN_ERR "[RTD129X_NAT] stop portmask 0x%x\n",
+						cp->portmask);
+				netif_device_detach(ndev);
+				netif_stop_queue(ndev);
+			}
+		}
+	}
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		/* For idle mode */
+		printk(KERN_ERR "[RTD129X_NAT] %s Idle mode\n", __func__);
+	} else {
+		/* For suspend mode */
+		printk(KERN_ERR "[RTD129X_NAT] %s Suspend mode\n", __func__);
+	}
+	rtd129x_save_regs();
+	#if defined(CONFIG_RTL_HARDWARE_NAT)
+	rtl819x_save_hw_tables();
+	#endif /* CONFIG_RTL_HARDWARE_NAT */
+
+	rtl_hwnat_enable_orig = rtl_hwnat_enable;
+	rtl_hwnat_enable = false;
+
+	printk(KERN_ERR "[RTD129X_NAT] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static int rtd129x_nat_resume(struct device *dev)
+{
+	struct net_device *ndev;
+	int i;
+	struct dev_priv *cp;
+
+	printk(KERN_ERR "[RTD129X_NAT] Enter %s\n", __func__);
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		/* For idle mode */
+		printk(KERN_ERR "[RTD129X_NAT] %s Idle mode\n", __func__);
+	} else {
+		/* For suspend mode */
+		printk(KERN_ERR "[RTD129X_NAT] %s Suspend mode\n", __func__);
+	}
+
+	/* Enable clk and release reset module */
+	rtd129x_hwnat_clk_init(dev);
+
+	/* reset driver */
+	rtd129x_restore_regs();
+	rtl865x_reinitSwitchCore();
+	/* Workaround:
+	 * MSCR is changed when calling rtl865x_reinitSwitchCore().
+	 * Therefore, we restore ALECR regs again */
+	rtd129x_restore_alecr_regs();
+
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		ndev = _rtl86xx_dev.dev[i];
+		if (ndev) {
+			cp = NETDRV_PRIV(ndev);
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+			napi_enable(&cp->napi);
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+			if (netif_running(ndev)) {
+				DBG(KERN_ERR "[RTD129X_NAT] resume portmask 0x%x\n",
+						cp->portmask);
+				netif_device_attach(ndev);
+			}
+		}
+	}
+
+	rtl_hwnat_enable = rtl_hwnat_enable_orig;
+
+	printk(KERN_ERR "[RTD129X_NAT] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static const struct dev_pm_ops rtd129x_nat_pm_ops = {
+	.suspend = rtd129x_nat_suspend,
+	.resume = rtd129x_nat_resume,
+};
+
+#define RTD129X_NAT_PM_OPS	(&rtd129x_nat_pm_ops)
+
+#else /* CONFIG_PM */
+#define RTD129X_NAT_PM_OPS	NULL
+#endif /* CONFIG_PM */
+
+static const struct of_device_id rtd1295_nic_dt_ids[] = {
+	{.compatible = "Realtek,rtd1295-hwnat",},
+	{},
+};
+
+MODULE_DEVICE_TABLE(of, rtd1295_nic_dt_ids);
+
+static struct platform_driver rtd1295_nic_driver = {
+	.probe = re865x_probe,
+	.remove = re865x_exit,
+	.driver = {
+			.name = MODULENAME,
+			.owner = THIS_MODULE,
+			.pm = RTD129X_NAT_PM_OPS,
+			.of_match_table = of_match_ptr(rtd1295_nic_dt_ids),
+		},
+};
+
+extern rtd129x_hwnat_reset_nat(struct device *dev);
+void rtd129x_nat_driver_restart(void)
+{
+	struct net_device *ndev;
+	int i;
+	struct dev_priv *cp;
+
+	pr_info("[RTD129X_NAT] restart\n");
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		ndev = _rtl86xx_dev.dev[i];
+		if (ndev) {
+			cp = NETDRV_PRIV(ndev);
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+			napi_disable(&cp->napi);
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+			if (netif_running(ndev)) {
+				netif_device_detach(ndev);
+				netif_stop_queue(ndev);
+			}
+		}
+	}
+
+	rtd129x_save_regs();
+	#if defined(CONFIG_RTL_HARDWARE_NAT)
+	rtl819x_save_hw_tables();
+	#endif /* CONFIG_RTL_HARDWARE_NAT */
+
+	rtl_hwnat_enable_orig = rtl_hwnat_enable;
+	rtl_hwnat_enable = false;
+	rtd129x_hwnat_reset_nat(&_rtl86xx_dev.pdev->dev);
+	msleep(10);
+
+
+	/* Enable clk and release reset module */
+	//rtd129x_hwnat_clk_init(&_rtl86xx_dev.plat_dev->dev);
+
+	/* reset driver */
+	rtd129x_restore_regs();
+	rtl865x_reinitSwitchCore();
+	/* Workaround:
+	 * MSCR is changed when calling rtl865x_reinitSwitchCore().
+	 * Therefore, we restore ALECR regs again */
+	rtd129x_restore_alecr_regs();
+
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		ndev = _rtl86xx_dev.dev[i];
+		if (ndev) {
+			cp = NETDRV_PRIV(ndev);
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+			napi_enable(&cp->napi);
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+			if (netif_running(ndev)) {
+				netif_device_attach(ndev);
+			}
+		}
+	}
+
+	rtl_hwnat_enable = rtl_hwnat_enable_orig;
+
+	pr_info("[RTD129X_NAT] restart done.\n");
+}
+
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#ifdef CONFIG_RTK_FAKE_ETH
+module_init(re865x_probe_fake);
+module_exit(re865x_exit_fake);
+#else
+#if defined(CONFIG_RTD_1295_HWNAT)
+module_platform_driver(rtd1295_nic_driver);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_OPENWRT_SDK)
+module_init(re865x_probe);
+#else
+device_initcall_sync(re865x_probe);
+#endif
+module_exit(re865x_exit);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+#include "./common/rtl865x_eventMgr.h"
+extern int32 rtl865x_initEventMgr(rtl865x_eventMgr_param_t *param);
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+extern int32 rtl865x_proc_debug_init(void);
+#endif
+
+/*
+@func enum RTL_RESULT | rtl865x_init | Initialize light rome driver and RTL865x ASIC.
+@rvalue RTL_SUCCESS | Initial success.
+@comm
+	Its important to call this API before using the driver. Note taht you can not call this API twice !
+*/
+int32 rtl865x_init(void)
+{
+	int32 retval = 0;
+
+	__865X_Config = 0;
+
+/*common*/
+	retval = rtl865x_initNetifTable();
+	retval = rtl865x_initVlanTable();
+#ifdef CONFIG_RTL_LAYERED_DRIVER_ACL
+	retval = rtl865x_init_acl();
+#endif
+	retval = rtl865x_initEventMgr(NULL);
+
+/*l2*/
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+	retval = rtl865x_layer2_init();
+#endif
+
+/*layer3*/
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	retval = rtl865x_initIpTable();
+	retval = rtl865x_initPppTable();
+	retval = rtl865x_initRouteTable();
+	retval = rtl865x_initNxtHopTable();
+	retval = rtl865x_arp_init();
+#endif
+
+/*layer4*/
+#if defined(CONFIG_RTL_LAYERED_DRIVER_L4)
+	rtl865x_nat_init();
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+	retval = rtl8198c_initIpv6RouteTable();
+	retval = rtl8198c_initIpv6NxtHopTable();
+	retval = rtl8198c_ipv6_arp_init();
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+	retval = rtl8198c_initIpv6DsLiteTable();
+#endif
+#if defined(CONFIG_RTL_HW_6RD_SUPPORT)
+	retval = rtl8198c_initIpv66RDTable();
+#endif
+#endif
+
+	/*queue id & rx ring descriptor mapping */
+	/*queue id & rx ring descriptor mapping */
+	REG32(CPUQDM0) =
+		QUEUEID1_RXRING_MAPPING | (QUEUEID0_RXRING_MAPPING << 16);
+	REG32(CPUQDM2) =
+		QUEUEID3_RXRING_MAPPING | (QUEUEID2_RXRING_MAPPING << 16);
+	REG32(CPUQDM4) =
+		QUEUEID5_RXRING_MAPPING | (QUEUEID4_RXRING_MAPPING << 16);
+
+	rtl8651_setAsicOutputQueueNumber(CPU, RTL_CPU_RX_RING_NUM);
+
+#if defined(CONFIG_RTL_PROC_DEBUG) || defined(CONFIG_RTL_DEBUG_TOOL)
+	rtl865x_proc_debug_init();
+#endif
+
+#if defined(PATCH_GPIO_FOR_LED)
+	rtl8651_resetAllAsicMIBCounter();
+#endif
+
+	rtl_ps_drv_netif_mapping_init();
+/* #if LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0) */
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+	if (!(nl_eventd_sk = get_nl_eventd_sk())) {
+		nl_eventd_sk = rtk_eventd_netlink_init();
+	}
+#endif
+	return SUCCESS;
+}
+
+int update_vlanconfig(uint32 vid, uint32 portMask, uint32 untagPortMask)
+{
+	int i;
+
+	for (i = 0; vlanconfig[i].vid != 0; i++) {
+		if (vlanconfig[i].vid == vid) {
+			vlanconfig[i].memPort = portMask;
+			vlanconfig[i].untagSet = untagPortMask;
+			return 0;
+		}
+	}
+	return 0;
+}
+
+/*
+@func enum RTL_RESULT | rtl865x_config | Configure light rome driver. Create VLAN and Network interface.
+@parm struct rtl865x_vlanConfig * | vlanconfig |
+@rvlaue RTL_SUCCESS | Sucessful configuration.
+@rvalue RTL_INVVID | Invalid VID.
+@comm
+	struct rtl865x_vlanConfig is definedas follows:
+
+			ifname:		Layer 3 Network Interface name, eg: eth0, eth1, ppp0...etc,. If it is specified, both layer 2 vlan and layer 3
+						netwrok interface are created and bound together. It also can be a NULL value. In this case, only a layer 2 VLAN
+						is created.
+			isWan:		1 for WAN interface and 0 for LAN interface in a layer 4 mode.
+			if_type:		IF_ETHER sets a network interface to be ETHER type. Instead, IF_PPPOE sets a netwrok to be PPPoE type.
+						This field is meaningful only when the ifname is specified.
+			vid:			VLAN ID to create a vlan.
+			memPort:		VLAN member port.
+			untagSet:	VLAN untag Set.
+			mtu:			MTU.
+			mac:		MAC address of the VLAN or network interface.
+	eg1:
+
+	struct rtl865x_vlanConfig vlanconfig[] = {
+		{ 	"eth0",	 1,   IF_ETHER, 	8, 	   1, 	0x01, 		0x01,		1500, 	{ { 0x00, 0x00, 0xda, 0xcc, 0xcc, 0x08 } }	},
+		{	"eth1",	 0,   IF_ETHER,	9,	   1,		0x1e,		0x1e,		1500,	{ { 0x00, 0x00, 0xda, 0xcc, 0xcc, 0x09 } }	},
+
+		LRCONFIG_END,
+	}
+*/
+int32 rtl865x_config(struct rtl865x_vlanConfig vlanconfig[])
+{
+	uint16 pvid;
+	int32 i, j;
+	int32 retval = 0;
+	uint32 valid_port_mask = 0;
+
+	if (!vlanconfig[0].vid)
+		return RTL_EINVALIDVLANID;
+
+	INIT_CHECK(rtl8651_setAsicOperationLayer(2));
+
+	for (i = 0; vlanconfig[i].vid != 0; i++) {
+		rtl865x_netif_t netif;
+
+		if (vlanconfig[i].memPort == 0)
+			continue;
+
+#if defined(CONFIG_OPENWRT_SDK) && !defined(CONFIG_RTL_LAYERED_DRIVER_L3)
+		/* always add cpu port in every vlan in switch HW Layer2 only mode. */
+		vlanconfig[i].memPort |= 0x100;
+#endif
+		valid_port_mask = vlanconfig[i].memPort;
+		if (vlanconfig[i].isWan == 0)
+			valid_port_mask |= 0x100;
+
+		/*add vlan */
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+		if (vlanconfig[i].if_type == IF_ETHER) {
+#endif
+			retval = rtl865x_addVlan(vlanconfig[i].vid);
+
+			if (retval == SUCCESS) {
+				rtl865x_addVlanPortMember(vlanconfig[i].vid,
+					vlanconfig[i].
+					memPort & valid_port_mask);
+
+#if (defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)) && !defined(CONFIG_RTL_CPU_TAG)
+				/* remove untagPortMask in 8197D hardware VLAN table */
+				rtl865x_setVlanPortTag(vlanconfig[i].vid,
+					vlanconfig[i].memPort, TRUE);
+#endif
+				rtl865x_setVlanFilterDatabase(vlanconfig[i].vid,
+					vlanconfig[i].fid);
+			}
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+		}
+#endif
+		/*add network interface */
+		memset(&netif, 0, sizeof(rtl865x_netif_t));
+		memcpy(netif.name, vlanconfig[i].ifname, MAX_IFNAMESIZE);
+		memcpy(netif.macAddr.octet, vlanconfig[i].mac.octet,
+			ETHER_ADDR_LEN);
+		netif.mtu = vlanconfig[i].mtu;
+		netif.if_type = vlanconfig[i].if_type;
+		netif.vid = vlanconfig[i].vid;
+		netif.is_wan = vlanconfig[i].isWan;
+		netif.is_slave = vlanconfig[i].is_slave;
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST) || defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+		netif.enableRoute = 1;
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		/* netif.enableRouteV6 =1; */	/*jwj:enable ipv6, then enable v6 router*/
+		netif.mtuV6 = vlanconfig[i].mtu;
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT) || (defined(CONFIG_RTL_MLD_SNOOPING) && defined(CONFIG_RTL_HARDWARE_MULTICAST))
+		netif.enableRouteV6 = 1;	/*jwj:enable ipv6, then enable v6 router */
+#endif
+#endif
+
+		retval = rtl865x_addNetif(&netif);
+
+#ifndef CONFIG_RTL_ISP_MULTI_WAN_SUPPORT
+		if (netif.is_slave == 1)
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+			rtl865x_attachMasterNetif(netif.name,
+				RTL_GW_WAN_DEVICE_NAME);
+#else
+			rtl865x_attachMasterNetif(netif.name,
+				RTL_DRV_WAN0_NETIF_NAME);
+#endif
+#endif
+#if defined(CONFIG_PROC_FS) && defined(CONFIG_NET_SCHED) && defined(CONFIG_RTL_LAYERED_DRIVER)
+		memcpy(&netIfName[i][0], vlanconfig[i].ifname,
+			sizeof(vlanconfig[i].ifname));
+#endif
+
+#if defined(CONFIG_RTL_UNKOWN_UNICAST_CONTROL)
+		if (vlanconfig[i].isWan == 0)
+			memcpy(lanIfName, vlanconfig[i].ifname,
+				sizeof(vlanconfig[i].ifname));
+#endif
+		if (retval != SUCCESS && retval != RTL_EVLANALREADYEXISTS)
+			return retval;
+	}
+
+#if (defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)) && !defined(CONFIG_RTL_CPU_TAG)
+	{
+		extern int RTL83XX_vlan_init(void);
+		RTL83XX_vlan_init();
+	}
+#endif
+
+	/*this is a one-shot config */
+	if ((++__865X_Config) == 1) {
+		for (i = 0; i < RTL8651_PORT_NUMBER + 3; i++) {
+			/* Set each port's PVID */
+			for (j = 0, pvid = 0; vlanconfig[j].vid != 0; j++) {
+				if ((1 << i) & vlanconfig[j].memPort) {
+					pvid = vlanconfig[j].vid;
+					break;
+				}
+			}
+
+			if (pvid != 0) {
+#ifdef CONFIG_HARDWARE_NAT_DEBUG
+				/*2007-12-19 */
+				rtlglue_printf
+					("%s:%d:lrconfig[j].vid is %d,pvid is %d, j is %d,i is %d\n",
+					__FUNCTION__, __LINE__,
+					vlanconfig[j].vid, pvid, j, i);
+#endif
+
+				CONFIG_CHECK(rtl8651_setAsicPvid(i, pvid));
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+				rtl865x_setPortToNetif(vlanconfig[j].ifname, i);
+#endif
+			}
+		}
+	}
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+	rtl865x_initOutputQueue((uint8 **)netIfName);
+#endif
+
+#ifdef CONFIG_RTK_VOIP_QOS
+	rtl8651_setAsicOutputQueueNumber(0, QNUM3);
+	rtl8651_setAsicOutputQueueNumber(1, QNUM3);
+	rtl8651_setAsicOutputQueueNumber(2, QNUM3);
+	rtl8651_setAsicOutputQueueNumber(3, QNUM3);
+	rtl8651_setAsicOutputQueueNumber(4, QNUM3);
+	rtl8651_setAsicOutputQueueNumber(6, QNUM2);
+	REG32(CPUQIDMCR0) = 0x55550000;
+#if defined(CONFIG_RTL_8197F)
+	rtl8651_setAsicPriorityDecision(2, 1, 2, 1, 1, 1);
+#else
+	rtl8651_setAsicPriorityDecision(2, 1, 2, 1, 1);
+#endif
+	rtl8651_resetAsicOutputQueue();
+#endif
+
+#if defined(CONFIG_RTL_UNKOWN_UNICAST_CONTROL)
+	{
+		rtl865x_tblAsicDrv_rateLimitParam_t asic_rl;
+		/*
+		 * jwj: RTL_MAC_REFILL_TOKEN=10, asic_rl.t_intervalUnit = 63, so
+		 * it will rate limit to 10/(63*0.0001) = 1587 pps.
+		 */
+		bzero(&asic_rl, sizeof(rtl865x_tblAsicDrv_rateLimitParam_t));
+		asic_rl.maxToken = RTL_MAC_REFILL_TOKEN;
+		asic_rl.refill_number = RTL_MAC_REFILL_TOKEN;
+		asic_rl.t_intervalUnit = 63;
+		asic_rl.t_remainUnit = 63;
+		asic_rl.token = RTL_MAC_REFILL_TOKEN;
+		rtl8651_setAsicRateLimitTable(0, &asic_rl);
+
+		/* macRecordIdx = 0; */
+		spin_lock_init(&unknown_unicast_lock);
+		bzero(macRecord, RTL_MAC_RECORD_NUM * sizeof(rtlMacRecord));
+
+		for (i = 0; i < RTL_MAC_RECORD_NUM; i++) {
+			init_timer(&macRecord[i].timer);
+			macRecord[i].timer.function = rtl_unkownUnicastTimer;
+		}
+
+		WRITE_MEM32(TEACR, (READ_MEM32(TEACR) | EnRateLimitTbAging));
+	}
+#endif
+
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_UNKOWN_UNICAST_CONTROL)
+static void rtl_unkownUnicastTimer(unsigned long data)
+{
+	int ret;
+	rtlMacRecord *record;
+	rtl865x_AclRule_t rule;
+
+	spin_lock_bh(&unknown_unicast_lock);
+	record = (rtlMacRecord *) data;
+	bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+	rule.ruleType_ = RTL865X_ACL_MAC;
+	rule.pktOpApp_ = RTL865X_ACL_ONLY_L2;
+	rule.actionType_ = RTL865X_ACL_DROP_RATE_EXCEED_PPS;
+	memset(rule.dstMacMask_.octet, 0xff, ETHER_ADDR_LEN);
+	memcpy(rule.dstMac_.octet, record->mac, ETHER_ADDR_LEN);
+	ret = rtl865x_del_acl(&rule, RTL_DRV_LAN_NETIF_NAME,
+		RTL865X_ACL_IPV6_USED);
+
+	bzero(record, sizeof(rtlMacRecord));
+	init_timer(&record->timer);
+	record->timer.function = rtl_unkownUnicastTimer;
+	spin_unlock_bh(&unknown_unicast_lock);
+}
+
+static void rtl_clearUnknownUnicastCnt(void)
+{
+	int idx;
+
+	/*jwj: Make sure unknown unicast flow pps >= RTL_MAC_THRESHOLD, then we will
+	 * add rate limit acl for it. */
+	spin_lock_bh(&unknown_unicast_lock);
+	for (idx = 0; idx < RTL_MAC_RECORD_NUM; idx++) {
+		if ((macRecord[idx].enable == 1)
+			&& (macRecord[idx].acl_config == 0))
+			macRecord[idx].cnt = 0;
+	}
+	spin_unlock_bh(&unknown_unicast_lock);
+
+	return;
+}
+
+static void rtl_unkownUnicastUpdate(struct sk_buff *skb)
+{
+	int ret;
+	int idx;
+	int empty_idx = -1;
+	int found = 0;
+	rtl865x_AclRule_t rule;
+	uint8 mac[ETHER_ADDR_LEN] = { 0 };
+
+	memcpy(mac, skb->data, ETHER_ADDR_LEN);
+	/*only care unknown l2 unicast. */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (ether_addr_equal(mac, skb->dev->dev_addr))
+		return;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (!compare_ether_addr(mac, skb->dev->dev_addr))
+		return;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	spin_lock_bh(&unknown_unicast_lock);
+	for (idx = 0; idx < RTL_MAC_RECORD_NUM; idx++) {
+		if (macRecord[idx].enable == 0) {
+			if (empty_idx < 0)
+				empty_idx = idx;
+			continue;
+		}
+
+		if (memcmp(mac, macRecord[idx].mac, ETHER_ADDR_LEN))
+			continue;
+
+		/*      The mac has already recorded    */
+		found = 1;
+		if ((macRecord[idx].cnt == RTL_MAC_THRESHOLD)
+			|| (++macRecord[idx].cnt < RTL_MAC_THRESHOLD)) {
+			spin_unlock_bh(&unknown_unicast_lock);
+			return;
+		}
+
+		break;
+	}
+
+	/*      add/del the rules at lan side */
+	bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+	rule.ruleType_ = RTL865X_ACL_MAC;
+	rule.pktOpApp_ = RTL865X_ACL_ONLY_L2;
+	rule.actionType_ = RTL865X_ACL_DROP_RATE_EXCEED_PPS;
+	memset(rule.dstMacMask_.octet, 0xff, ETHER_ADDR_LEN);
+
+	if (found == 0) {
+		if (empty_idx >= 0) {	/* have empty entry exist, just use it for new dmac */
+			macRecord[empty_idx].enable = 1;
+			macRecord[empty_idx].cnt = 0;
+			memcpy(macRecord[empty_idx].mac, mac, ETHER_ADDR_LEN);
+		}
+	} else {
+		/*jwj: The mac has already recorded, and pkt cnt access threshold,
+		 * so need to add rate limit acl */
+		memcpy(rule.dstMac_.octet, mac, ETHER_ADDR_LEN);
+		ret = rtl865x_add_acl(&rule, RTL_DRV_LAN_NETIF_NAME,
+			RTL865X_ACL_IPV6_USED);
+		if (ret == RTL_EENTRYNOTFOUND) {
+			rtl865x_regist_aclChain(RTL_DRV_LAN_NETIF_NAME,
+				RTL865X_ACL_IPV6_USED, RTL865X_ACL_INGRESS);
+			ret = rtl865x_add_acl(&rule, RTL_DRV_LAN_NETIF_NAME,
+				RTL865X_ACL_IPV6_USED);
+		}
+		macRecord[idx].acl_config = 1;
+		macRecord[idx].timer.data = (unsigned long)&(macRecord[idx]);
+		mod_timer(&macRecord[idx].timer, jiffies + RTL_MAC_TIMEOUT);
+	}
+
+	spin_unlock_bh(&unknown_unicast_lock);
+	return;
+}
+#endif
+
+#if !defined(CONFIG_RTL_IVL_SUPPORT) && (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F))
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST) && defined(CONFIG_RTL_MLD_SNOOPING)
+static int32 rtl_enable_netif_routingV6_in_bridge_mode(int mode)
+{
+	int32 retval = FAILED;
+	rtl865x_netif_local_t *netif = NULL;
+
+	if (mode != BRIDGE_MODE)
+		return retval;
+
+	netif = _rtl865x_getNetifByName(RTL_DRV_LAN_NETIF_NAME);
+
+	rtl8651_setAsicOperationLayer(3);
+	retval = rtl865x_enableNetifRoutingV6(netif);
+
+	return retval;
+}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+extern int32 rtl_setIgmpSnoopingModuleStaticRouterPortMask(uint32 moduleIndex,
+	uint32 staticRouterPortMask);
+static int re865x_reInitIgmpSetting(int mode)
+{
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+#else
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	rtl_multicastDeviceInfo_t devInfo;
+	uint32 externalPortMask = 0;
+#endif
+	int32 i;
+	int32 totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		1;
+
+	for (i = 0; i < totalVlans; i++) {
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+		if (TRUE == vlanconfig[i].isWan) {
+			externalPortMask |= vlanconfig[i].memPort;
+		} else {
+			devInfo.portMask |= vlanconfig[i].memPort;
+		}
+#endif
+
+		if (mode == GATEWAY_MODE) {
+			rtl_setIgmpSnoopingModuleStaticRouterPortMask
+				(nicIgmpModuleIndex, 0);
+		} else {
+			rtl_setIgmpSnoopingModuleStaticRouterPortMask
+				(nicIgmpModuleIndex, 0x01);
+		}
+
+		/* rtl_setIgmpSnoopingModuleUnknownMCastFloodMap(nicIgmpModuleIndex, 0x0); */
+		rtl_setIpv4UnknownMCastFloodMap(nicIgmpModuleIndex, 0xFFFFFFFF);
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+		rtl_setIpv6UnknownMCastFloodMap(nicIgmpModuleIndex, 0xFFFFFFFF);
+#endif
+	}
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	rtl865x_reinitMulticast();
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	rtl8198C_reinitMulticastv6();
+#endif
+	/* rtl865x_setMulticastExternalPortMask(externalPortMask); */
+	rtl865x_setMulticastExternalPortMask(0);
+#endif
+	rtl865x_igmpSyncLinkStatus();
+	return SUCCESS;
+}
+#endif
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+unsigned int rtl865x_getEthDevLinkStatus(struct net_device *dev)
+{
+	if (dev != NULL) {
+		struct dev_priv *cp = NETDRV_PRIV(dev);
+		return (cp->portmask & rtl865x_getPhysicalPortLinkStatus());
+
+	} else {
+		return 0;
+	}
+}
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+extern int32 rtl865x_layer2_reinit(void);
+#endif
+
+static int32 rtl_reinit_hw_table(void)
+{
+	/*re-init sequence eventmgr->l4->l3->l2->common is to make sure delete asic entry,
+	 * if not following this sequence,
+	 * some asic entry can't be deleted due to reference count is not zero */
+
+	/*to-do:in each layer reinit function, memset all software entry to zero,
+	 * and force to clear all asic entry of own module,
+	 * then the re-init sequence can be common->l2->l3->l4 */
+	/* FullAndSemiReset should not be called here
+	 * it will make switch core action totally wrong
+	 */
+
+	/*event management */
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+	unsigned long flags = 0;
+	SMP_LOCK_ETH(flags);
+#endif
+	rtl865x_reInitEventMgr();
+
+	/*l4 */
+#if defined(CONFIG_RTL_LAYERED_DRIVER_L4)
+	rtl865x_nat_reinit();
+#endif
+
+	/*l3 */
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	rtl865x_reinitRouteTable();
+	rtl865x_reinitNxtHopTable();
+	rtl865x_reinitIpTable();
+	rtl865x_reinitPppTable();
+	rtl865x_arp_reinit();
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+	rtl8198c_reinitIpv6RouteTable();
+	rtl8198c_reinitIpv6NxtHopTable();
+	rtl8198c_ipv6_arp_reinit();
+#endif
+
+	/*l2 */
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+	rtl865x_layer2_reinit();
+#endif
+
+	/*common */
+	rtl865x_reinitNetifTable();
+	rtl865x_reinitVlantable();
+	rtl865x_reinit_acl();
+
+	/*queue id & rx ring descriptor mapping */
+	/* Use REG32 instead of REG16 because CPUQDM4 is set to 0 unexpectedly when use REG16 */
+	REG32(CPUQDM0) =
+		QUEUEID1_RXRING_MAPPING | (QUEUEID0_RXRING_MAPPING << 16);
+	REG32(CPUQDM2) =
+		QUEUEID3_RXRING_MAPPING | (QUEUEID2_RXRING_MAPPING << 16);
+	REG32(CPUQDM4) =
+		QUEUEID5_RXRING_MAPPING | (QUEUEID4_RXRING_MAPPING << 16);
+
+	WRITE_MEM32(PLITIMR, 0);
+
+	rtl8651_setAsicOperationLayer(2);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+	SMP_UNLOCK_ETH(flags);
+#endif
+
+	return SUCCESS;
+
+}
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_MULTI_LAN_DEV)
+static int rtl_config_perport_perdev_vlanconfig(int mode)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	#if defined(CONFIG_RTL_CPU_TAG)
+	if ((mode == BRIDGE_MODE) || (mode == WISP_MODE)) {
+		vlanconfig[0].isWan = 0;
+		vlanconfig[0].vid = RTL_LANVLANID;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = RTL_LANVLANID;	/* eth0 */
+	} else {
+		vlanconfig[0].isWan = 1;
+		vlanconfig[0].vid = RTL_WANVLANID;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = RTL_WANVLANID;	/* eth0 */
+	}
+	vlanconfig[0].memPort = RTL_WANPORT_MASK;
+	vlanconfig[0].untagSet = RTL_WANPORT_MASK;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_WANPORT_MASK;	/* eth0 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portnum = 1;
+
+	vlanconfig[1].isWan = 0;
+	vlanconfig[1].vid = RTL_LANVLANID;
+	vlanconfig[1].memPort = RTL_LANPORT_MASK_1;
+	vlanconfig[1].untagSet = RTL_LANPORT_MASK_1;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = RTL_LANPORT_MASK_1;	/* eth1 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = RTL_LANVLANID_1;	/* eth1 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portnum = 1;
+
+	vlanconfig[2].isWan = 0;
+	vlanconfig[2].vid = RTL_LANVLANID;
+	vlanconfig[2].memPort = RTL_LANPORT_MASK_2;
+	vlanconfig[2].untagSet = RTL_LANPORT_MASK_2;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->portmask = RTL_LANPORT_MASK_2;	/* eth2 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->id = RTL_LANVLANID_2;	/* eth2 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->portnum = 1;
+
+	#if 0
+	vlanconfig[3].isWan = 0;
+	vlanconfig[3].vid = RTL_LANVLANID;
+	vlanconfig[3].memPort = RTL_LANPORT_MASK_3;
+	vlanconfig[3].untagSet = RTL_LANPORT_MASK_3;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[3]))->portmask = RTL_LANPORT_MASK_3;	/* eth3 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[3]))->id = RTL_LANVLANID_3;	/* eth3 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[3]))->portnum = 1;
+
+	vlanconfig[4].isWan = 0;
+	vlanconfig[4].vid = RTL_LANVLANID;
+	vlanconfig[4].memPort = RTL_LANPORT_MASK_0;
+	vlanconfig[4].untagSet = RTL_LANPORT_MASK_0;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[4]))->portmask = RTL_LANPORT_MASK_0;	/* eth4 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[4]))->id = RTL_LANVLANID_0;	/* eth4 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[4]))->portnum = 1;
+	#endif
+
+	#else /* CONFIG_RTL_CPU_TAG */
+	#if defined(CONFIG_RTL_WAN_MAC5)
+	vlanconfig[0].isWan = 0;
+	vlanconfig[0].vid = RTL_LANVLANID;
+	vlanconfig[0].memPort = RTL_LANPORT_MASK_5;
+	vlanconfig[0].untagSet = RTL_LANPORT_MASK_5;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_LANPORT_MASK_5;	/* eth0 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = RTL_WANVLANID;	/* eth0 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portnum = 1;
+	#else /* CONFIG_RTL_WAN_MAC5 */
+	if ((mode == BRIDGE_MODE) || (mode == WISP_MODE)) {
+		vlanconfig[0].isWan = 0;
+		vlanconfig[0].vid = RTL_LANVLANID;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = RTL_LANVLANID;	/* eth0 */
+	} else {
+		vlanconfig[0].isWan = 1;
+		vlanconfig[0].vid = RTL_WANVLANID;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = RTL_WANVLANID;	/* eth0 */
+	}
+	vlanconfig[0].memPort = RTL_WANPORT_MASK;
+	vlanconfig[0].untagSet = RTL_WANPORT_MASK;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_WANPORT_MASK;	/* eth0 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portnum = 1;
+
+	vlanconfig[1].isWan = 0;
+	vlanconfig[1].vid = RTL_LANVLANID;
+	vlanconfig[1].memPort = RTL_LANPORT_MASK_5;
+	vlanconfig[1].untagSet = RTL_LANPORT_MASK_5;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = RTL_LANPORT_MASK_5;	/* eth1 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = RTL_LANVLANID_5;	/* eth1 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portnum = 1;
+
+	if (hwnat_mac0_enable > 0) {
+		vlanconfig[2].isWan = 0;
+		vlanconfig[2].vid = RTL_LANVLANID;
+		vlanconfig[2].memPort = RTL_LANPORT_MASK_1;
+		vlanconfig[2].untagSet = RTL_LANPORT_MASK_1;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->portmask = RTL_LANPORT_MASK_1;	/* eth2 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->id = RTL_LANVLANID_1;	/* eth2 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->portnum = 1;
+	}
+	#endif /* CONFIG_RTL_WAN_MAC5 */
+	#endif /* CONFIG_RTL_CPU_TAG */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	vlanconfig[0].vid = RTL_LANVLANID;
+	vlanconfig[0].memPort = RTL_LANPORT_MASK_4;
+	vlanconfig[0].untagSet = RTL_LANPORT_MASK_4;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_LANPORT_MASK_4;	/* eth0 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = RTL_LANVLANID_1;	/* eth0 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portnum = 1;
+
+	if ((mode == BRIDGE_MODE) || (mode == WISP_MODE)) {
+#if defined(CONFIG_RTL_IVL_SUPPORT)
+		vlanconfig[1].vid = RTL_WANVLANID;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id =
+			RTL_WANVLANID;
+#else
+		vlanconfig[1].vid = RTL_LANVLANID;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id =
+			RTL_LANVLANID;
+#endif
+	} else {
+		vlanconfig[1].vid = RTL_WANVLANID;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id =
+			RTL_WANVLANID;
+	}
+#if defined(CONFIG_RTL_AP_PACKAGE)
+	vlanconfig[1].memPort = RTL_LANPORT_MASK_0;
+	vlanconfig[1].untagSet = RTL_LANPORT_MASK_0;
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(3, 10, 0))
+	((struct dev_priv *)_rtl86xx_dev.dev[1]->priv)->portmask = RTL_LANPORT_MASK_0;	/* eth1 */
+#endif
+#else
+	vlanconfig[1].memPort = RTL_WANPORT_MASK;
+	vlanconfig[1].untagSet = RTL_WANPORT_MASK;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = RTL_WANPORT_MASK;	/* eth1 */
+	/* ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = RTL_WANVLANID; //eth1 */
+#endif
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portnum = 1;
+
+	vlanconfig[2].vid = RTL_LANVLANID;
+	vlanconfig[2].memPort = RTL_LANPORT_MASK_3;
+	vlanconfig[2].untagSet = RTL_LANPORT_MASK_3;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->portmask = RTL_LANPORT_MASK_3;	/* eth2 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->id = RTL_LANVLANID_2;	/* eth2 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->portnum = 1;
+
+	vlanconfig[3].vid = RTL_LANVLANID;
+	vlanconfig[3].memPort = RTL_LANPORT_MASK_2;
+	vlanconfig[3].untagSet = RTL_LANPORT_MASK_2;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[3]))->portmask = RTL_LANPORT_MASK_2;	/* eth3 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[3]))->id = RTL_LANVLANID_3;	/* eth3 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[3]))->portnum = 1;
+
+	vlanconfig[4].vid = RTL_LANVLANID;
+	vlanconfig[4].memPort = RTL_LANPORT_MASK_1;
+	vlanconfig[4].untagSet = RTL_LANPORT_MASK_1;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[4]))->portmask = RTL_LANPORT_MASK_1;	/* eth4 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[4]))->id = RTL_LANVLANID_4;	/* eth4 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[4]))->portnum = 1;
+
+#if defined(CONFIG_8198_PORT5_GMII)
+	vlanconfig[5].vid = RTL_LANVLANID;
+	vlanconfig[5].memPort = RTL_LANPORT_MASK_5;
+	vlanconfig[5].untagSet = RTL_LANPORT_MASK_5;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[5]))->portmask = RTL_LANPORT_MASK_5;	/* eth5 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[5]))->id = RTL_LANVLANID_5;	/* eth5 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[5]))->portnum = 1;
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	return SUCCESS;
+}
+#endif
+
+#if !defined(CONFIG_RTL_MULTI_LAN_DEV)
+static int rtl_config_lanwan_dev_vlanconfig(int mode)
+{
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_8197F)
+#if !defined(CONFIG_RTL_8367R_SUPPORT) && !defined(CONFIG_RTL_8211F_SUPPORT)
+	extern uint32 rtl819x_bond_option(void);
+	if (rtl819x_bond_option() == 3)
+		return SUCCESS;
+#endif
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+	/*lan config */
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	{
+		vlanconfig[2].vid = 0;	/* eth2 */
+		vlanconfig[3].vid = 0;	/* eth3 */
+		vlanconfig[4].vid = 0;	/* eth4 */
+#if defined(CONFIG_8198_PORT5_GMII)
+		vlanconfig[5].vid = 0;
+#endif
+	}
+#endif
+
+#if defined(CONFIG_RTL_IVL_SUPPORT)
+#if defined(CONFIG_POCKET_ROUTER_SUPPORT)
+	if (mode == GATEWAY_MODE) {
+		vlanconfig[0].memPort = 0;
+		vlanconfig[0].vid = RTL_LANVLANID;
+		vlanconfig[0].untagSet = 0;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = 0;	/* eth0 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id =
+			RTL_LANVLANID;
+		vlanconfig[1].vid = RTL_WANVLANID;
+		vlanconfig[1].memPort = RTL_WANPORT_MASK;
+		vlanconfig[1].untagSet = RTL_WANPORT_MASK;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = RTL_WANPORT_MASK;	/* eth1 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = RTL_WANVLANID;	/* eth1 */
+	} else {
+		vlanconfig[0].memPort = RTL_LANPORT_MASK;
+		vlanconfig[0].vid = RTL_LANVLANID;
+		vlanconfig[0].untagSet = RTL_LANPORT_MASK;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_LANPORT_MASK;	/* eth0 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id =
+			RTL_LANVLANID;
+
+		vlanconfig[1].vid = 0;
+		vlanconfig[1].memPort = 0;
+		vlanconfig[1].untagSet = 0;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = 0;	/* eth1 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = RTL_WANVLANID;	/* eth1 */
+	}
+
+#else /* else CONFIG_POCKET_ROUTER_SUPPORT */
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	if (mode == BRIDGE_MODE || mode == WISP_MODE) {
+		vlanconfig[0].isWan = 0;
+		vlanconfig[0].vid = RTL_LANVLANID;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = RTL_LANVLANID;
+	} else {
+		vlanconfig[0].isWan = 1;
+		vlanconfig[0].vid = RTL_WANVLANID;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = RTL_WANVLANID;
+	}
+	vlanconfig[0].memPort = RTL_WANPORT_MASK;
+	vlanconfig[0].untagSet = RTL_WANPORT_MASK;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_WANPORT_MASK;
+
+	vlanconfig[1].isWan = 0;
+	vlanconfig[1].vid = RTL_LANVLANID;
+	vlanconfig[1].memPort = RTL_LANPORT_MASK;
+	vlanconfig[1].untagSet = RTL_LANPORT_MASK;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = RTL_LANPORT_MASK;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = RTL_LANVLANID;
+	#else /* CONFIG_RTD_1295_HWNAT */
+	vlanconfig[0].memPort = RTL_LANPORT_MASK;
+	vlanconfig[0].vid = RTL_LANVLANID;
+	vlanconfig[0].untagSet = RTL_LANPORT_MASK;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_LANPORT_MASK;	/* eth0 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id =
+		RTL_LANVLANID;
+
+	vlanconfig[1].vid = RTL_WANVLANID;
+	vlanconfig[1].memPort = RTL_WANPORT_MASK;
+	vlanconfig[1].untagSet = RTL_WANPORT_MASK;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = RTL_WANPORT_MASK;	/* eth1 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = RTL_WANVLANID;	/* eth1 */
+	#endif /* CONFIG_RTD_1295_HWNAT */
+
+#endif /* endif CONFIG_POCKET_ROUTER_SUPPORT */
+
+#else
+	if (mode == BRIDGE_MODE || mode == WISP_MODE) {
+		vlanconfig[0].memPort = RTL_LANPORT_MASK | RTL_WANPORT_MASK;
+		vlanconfig[0].untagSet = RTL_LANPORT_MASK | RTL_WANPORT_MASK;
+		vlanconfig[0].vid = RTL_LANVLANID;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_LANPORT_MASK | RTL_WANPORT_MASK;	/* eth0 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id =
+			RTL_LANVLANID;
+
+		vlanconfig[1].vid = 0;
+		vlanconfig[1].memPort = 0x0;
+		vlanconfig[1].untagSet = 0x0;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = 0x0;	/* eth1 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = 0;
+	} else {
+		vlanconfig[0].memPort = RTL_LANPORT_MASK;
+		vlanconfig[0].vid = RTL_LANVLANID;
+		vlanconfig[0].untagSet = RTL_LANPORT_MASK;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_LANPORT_MASK;	/* eth0 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id =
+			RTL_LANVLANID;
+
+		vlanconfig[1].vid = RTL_WANVLANID;
+		vlanconfig[1].memPort = RTL_WANPORT_MASK;
+		vlanconfig[1].untagSet = RTL_WANPORT_MASK;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = RTL_WANPORT_MASK;	/* eth1 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = RTL_WANVLANID;	/* eth1 */
+	}
+#endif
+
+	return SUCCESS;
+}
+#endif
+
+#if	defined(CONFIG_RTL_MULTI_LAN_DEV)
+static int rtl_config_multi_lan_dev_vlanconfig(int mode)
+{
+	rtl_config_perport_perdev_vlanconfig(mode);
+	return SUCCESS;
+
+}
+
+int rtl_is_lan_dev(struct net_device *dev)
+{
+	int ret = FALSE;
+
+	if (dev == NULL)
+		return ret;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_CPU_TAG)
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		if ((strcmp(dev->name, "eth1") == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P2_NETIF_NAME) == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P3_NETIF_NAME) == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P0_NETIF_NAME) == 0))
+			ret = TRUE;
+	} else if ((rtl865x_curOpMode == WISP_MODE)
+		|| (rtl865x_curOpMode == BRIDGE_MODE)) {
+		if ((strcmp(dev->name, "eth1") == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P2_NETIF_NAME) == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P3_NETIF_NAME) == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P0_NETIF_NAME) == 0)
+#if !defined(CONFIG_RTL_IVL_SUPPORT)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P5_NETIF_NAME) == 0)
+#endif
+			)
+			ret = TRUE;
+	}
+#else /* CONFIG_RTL_CPU_TAG */
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		if ((strcmp(dev->name, "eth1") == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P0_NETIF_NAME) == 0))
+			ret = TRUE;
+	} else if ((rtl865x_curOpMode == WISP_MODE)
+		|| (rtl865x_curOpMode == BRIDGE_MODE)) {
+		if ((strcmp(dev->name, "eth1") == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P0_NETIF_NAME) == 0)
+#if !defined(CONFIG_RTL_IVL_SUPPORT)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P4_NETIF_NAME) == 0)
+#endif
+			)
+			ret = TRUE;
+	}
+#endif /* CONFIG_RTL_CPU_TAG */
+#else /* CONFIG_RTD_1295_HWNAT */
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		if ((strcmp(dev->name, "eth0") == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P1_NETIF_NAME) == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P2_NETIF_NAME) == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P3_NETIF_NAME) == 0))
+			ret = TRUE;
+	} else if ((rtl865x_curOpMode == WISP_MODE)
+		|| (rtl865x_curOpMode == BRIDGE_MODE)) {
+		if ((strcmp(dev->name, "eth0") == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P1_NETIF_NAME) == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P2_NETIF_NAME) == 0)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P3_NETIF_NAME) == 0)
+#if !defined(CONFIG_RTL_IVL_SUPPORT)
+			|| (strcmp(dev->name, RTL_DRV_LAN_P4_NETIF_NAME) == 0)
+#endif
+			)
+			ret = TRUE;
+	}
+#endif /* CONFIG_RTD_1295_HWNAT */
+
+	return ret;
+}
+#endif
+
+/* #if (defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)) && !defined(CONFIG_RTL_MULTI_LAN_DEV) */
+#if (defined(CONFIG_RTK_VLAN_SUPPORT)) && !defined(CONFIG_RTL_MULTI_LAN_DEV)
+static int rtl_config_rtkVlan_vlanconfig(int mode)
+{
+	if (!rtk_vlan_support_enable)
+		rtl_config_lanwan_dev_vlanconfig(mode);
+	else if (rtk_vlan_support_enable == 1) {
+		rtl_config_perport_perdev_vlanconfig(mode);
+	} else if (rtk_vlan_support_enable == 2)
+		rtl_config_lanwan_dev_vlanconfig(mode);
+
+	return SUCCESS;
+}
+#endif
+
+static int rtl_config_operation_layer(int mode)
+{
+#if (defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)) && !defined(CONFIG_RTL_CPU_TAG)
+	rtl8651_setAsicOperationLayer(1);
+	WRITE_MEM32(FFCR, READ_MEM32(FFCR) | EN_UNUNICAST_TOCPU);
+	return SUCCESS;
+#endif
+
+#if defined(CONFIG_RTL_LAYERED_DRIVER)
+	switch (mode) {
+	case GATEWAY_MODE:
+		rtl8651_setAsicOperationLayer(4);
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+		rtl_enable_netif_routing();
+#endif
+		break;
+	case BRIDGE_MODE:
+#if defined(CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+		rtl8651_setAsicOperationLayer(2);
+		break;
+#endif
+	case WISP_MODE:
+		rtl8651_setAsicOperationLayer(3);
+		break;
+	default:
+		rtl8651_setAsicOperationLayer(2);
+	}
+#endif
+	return SUCCESS;
+}
+
+static int rtl_config_vlanconfig(int mode)
+{
+#if !defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_8197F)
+#if !defined(CONFIG_RTL_8367R_SUPPORT) && !defined(CONFIG_RTL_8211F_SUPPORT)
+	extern uint32 rtl819x_bond_option(void);
+	if (rtl819x_bond_option() == 3)
+		return SUCCESS;
+#endif
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+#if	defined(CONFIG_RTL_MULTI_LAN_DEV)
+	rtl_config_multi_lan_dev_vlanconfig(mode);
+#else
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	rtl_config_rtkVlan_vlanconfig(mode);
+#else
+	rtl_config_lanwan_dev_vlanconfig(mode);
+#endif
+#endif
+
+	return SUCCESS;
+
+}
+
+int32 rtl865x_changeOpMode(int mode)
+{
+#ifdef CONFIG_RTK_FAKE_ETH
+	return SUCCESS;
+#endif
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+	struct rtl865x_interface_info ifInfo;
+#endif
+
+#if (defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)) && \
+	!defined(CONFIG_RTL_CPU_TAG) && !defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)
+	{
+		extern int RTL83XX_vlan_reinit(int mode);
+
+		rtl8651_setAsicOperationLayer(1);
+		WRITE_MEM32(FFCR, READ_MEM32(FFCR) | EN_UNUNICAST_TOCPU);
+		RTL83XX_vlan_reinit(mode);
+
+		/*update current operation mode */
+		rtl865x_curOpMode = mode;
+		return SUCCESS;
+	}
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	if (rtk_vlan_support_enable == 0) {
+		if (mode == rtl865x_curOpMode) {
+			return SUCCESS;
+		}
+	}
+#else
+	if (mode == rtl865x_curOpMode) {
+		return SUCCESS;
+	}
+#endif
+
+	/*config vlan config */
+	rtl_config_vlanconfig(mode);
+
+	if (!vlanconfig[0].vid && !vlanconfig[1].vid)
+		return RTL_EINVALIDVLANID;
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC)
+	if (mode == GATEWAY_MODE) {
+		memset(&ifInfo, 0, sizeof(struct rtl865x_interface_info));
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+		strcpy(ifInfo.ifname, RTL_GW_WAN_DEVICE_NAME);
+#else
+		strcpy(ifInfo.ifname, RTL_DRV_WAN0_NETIF_NAME);
+#endif
+		ifInfo.isWan = 1;
+		for (i = 0; vlanconfig[i].vid != 0; i++) {
+			if ((TRUE == vlanconfig[i].isWan)
+				&& (vlanconfig[i].if_type == IF_ETHER)) {
+				ifInfo.memPort |= vlanconfig[i].memPort;
+				ifInfo.fid = vlanconfig[i].fid;
+			}
+		}
+		rtl865x_setLpIfInfo(&ifInfo);
+
+		memset(&ifInfo, 0, sizeof(struct rtl865x_interface_info));
+		strcpy(ifInfo.ifname, RTL_DRV_LAN_NETIF_NAME);
+		ifInfo.isWan = 0;
+		for (i = 0; vlanconfig[i].vid != 0; i++) {
+			if ((FALSE == vlanconfig[i].isWan)
+				&& (vlanconfig[i].if_type == IF_ETHER)) {
+				ifInfo.memPort |= vlanconfig[i].memPort;
+				ifInfo.fid = vlanconfig[i].fid;
+			}
+		}
+		rtl865x_setLpIfInfo(&ifInfo);
+	} else if (mode == WISP_MODE) {
+		memset(&ifInfo, 0, sizeof(struct rtl865x_interface_info));
+		strcpy(ifInfo.ifname, RTL_PS_WLAN0_DEV_NAME);
+		ifInfo.isWan = 1;
+		rtl865x_setLpIfInfo(&ifInfo);
+
+		memset(&ifInfo, 0, sizeof(struct rtl865x_interface_info));
+		strcpy(ifInfo.ifname, RTL_DRV_LAN_NETIF_NAME);
+		ifInfo.isWan = 0;
+		for (i = 0; vlanconfig[i].vid != 0; i++) {
+			if ((FALSE == vlanconfig[i].isWan)
+				&& (vlanconfig[i].if_type == IF_ETHER)) {
+				ifInfo.memPort |= vlanconfig[i].memPort;
+				ifInfo.fid = vlanconfig[i].fid;
+			}
+		}
+		rtl865x_setLpIfInfo(&ifInfo);
+	} else {
+		memset(&ifInfo, 0, sizeof(struct rtl865x_interface_info));
+		ifInfo.isWan = 1;
+		rtl865x_setLpIfInfo(&ifInfo);
+
+		memset(&ifInfo, 0, sizeof(struct rtl865x_interface_info));
+		strcpy(ifInfo.ifname, RTL_DRV_LAN_NETIF_NAME);
+		ifInfo.isWan = 0;
+		for (i = 0; vlanconfig[i].vid != 0; i++) {
+			if ((FALSE == vlanconfig[i].isWan)
+				&& (vlanconfig[i].if_type == IF_ETHER)) {
+				ifInfo.memPort |= vlanconfig[i].memPort;
+				ifInfo.fid = vlanconfig[i].fid;
+			}
+		}
+		rtl865x_setLpIfInfo(&ifInfo);
+	}
+#endif
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_VLAN_8021Q)
+	re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+#endif
+
+	/*reinit hw tables */
+	rtl_reinit_hw_table();
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTK_VLAN_SUPPORT)
+	reinit_vlan_configure(packedVlanConfig);
+#else
+	reinit_vlan_configure(vlanconfig);
+#endif
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+	re865x_reInitIgmpSetting(mode);
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	if ((mldSnoopEnabled == TRUE) && (rtk_vlan_support_enable == 0))
+#else
+	if (mldSnoopEnabled == TRUE)
+#endif
+	{
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+		rtl865x_addAclForMldSnooping(packedVlanConfig);
+#else
+		rtl865x_addAclForMldSnooping(vlanconfig);
+#endif
+	}
+#endif
+#if  defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	rtl_processAclForIgmpSnooping(igmpsnoopenabled);
+#endif
+#endif
+
+#if defined(CONFIG_RTL_HTTP_REDIRECT_LOCAL)
+	rtl865x_removeAclForHttpRedirect(packedVlanConfig);
+	rtl865x_addAclForHttpRedirect(packedVlanConfig);
+#endif
+
+#if (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_IPV6READYLOGO)
+	{
+		rtl865x_addAclForIPV6ReadyLogo(packedVlanConfig);
+	}
+#endif
+#if defined(CONFIG_RTL_DNS_TRAP)
+	rtl_remove_Acl_for_dns_trap(packedVlanConfig);
+	rtl_add_Acl_for_dns_trap(packedVlanConfig);
+#endif
+
+#if defined(CONFIG_RTL_IVL_SUPPORT)
+	if (mode == GATEWAY_MODE) {
+		WRITE_MEM32(FFCR, READ_MEM32(FFCR) & ~EN_UNUNICAST_TOCPU);
+	} else if ((mode == BRIDGE_MODE) || (mode == WISP_MODE)) {
+		WRITE_MEM32(FFCR, READ_MEM32(FFCR) | EN_UNUNICAST_TOCPU);
+	} else {
+		WRITE_MEM32(FFCR, READ_MEM32(FFCR) & ~EN_UNUNICAST_TOCPU);
+	}
+#endif
+
+	/*update current operation mode */
+	rtl865x_curOpMode = mode;
+
+	/* setAsicOperationLayer */
+	rtl_config_operation_layer(mode);
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+	if (rtl865x_curOpMode != GATEWAY_MODE)
+		extPortEnabled = 0;
+#endif
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	if (rtl865x_curOpMode != GATEWAY_MODE)
+		rtl865xC_setNetDecisionPolicy(NETIF_PORT_BASED);
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	/* always init the default route... */
+	if (rtl8651_getAsicOperationLayer() > 2) {
+		rtl865x_addRoute(0, 0, 0, RTL_DRV_WAN0_NETIF_NAME, 0);
+	}
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+	if (rtl8651_getAsicOperationLayer() > 2) {
+		inv6_addr_t ipAddr, nexthop;
+		memset(&ipAddr, 0, sizeof(inv6_addr_t));
+		memset(&nexthop, 0, sizeof(inv6_addr_t));
+
+		rtl8198c_addIpv6Route(ipAddr, 0, nexthop,
+			RTL_DRV_WAN0_NETIF_NAME);
+	}
+#endif
+
+	/* checksum control register */
+	switch (mode) {
+	case GATEWAY_MODE:
+		WRITE_MEM32(CSCR, READ_MEM32(CSCR) & ~ALLOW_L2_CHKSUM_ERR);
+		WRITE_MEM32(CSCR, READ_MEM32(CSCR) & ~ALLOW_L3_CHKSUM_ERR);
+		WRITE_MEM32(CSCR, READ_MEM32(CSCR) & ~ALLOW_L4_CHKSUM_ERR);
+		break;
+	case BRIDGE_MODE:
+	case WISP_MODE:
+		WRITE_MEM32(CSCR, READ_MEM32(CSCR) & ~ALLOW_L2_CHKSUM_ERR);
+		WRITE_MEM32(CSCR, READ_MEM32(CSCR) | ALLOW_L3_CHKSUM_ERR);
+		WRITE_MEM32(CSCR, READ_MEM32(CSCR) | ALLOW_L4_CHKSUM_ERR);
+		break;
+	default:
+		WRITE_MEM32(CSCR, READ_MEM32(CSCR) & ~ALLOW_L2_CHKSUM_ERR);
+		WRITE_MEM32(CSCR, READ_MEM32(CSCR) & ~ALLOW_L3_CHKSUM_ERR);
+		WRITE_MEM32(CSCR, READ_MEM32(CSCR) & ~ALLOW_L4_CHKSUM_ERR);
+	}
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	RTL8367R_vlan_set();
+#endif
+
+	return SUCCESS;
+}
+
+int rtl865x_reChangeOpMode(void)
+{
+	unsigned long flags = 0;
+	/* SMP_LOCK_ETH(flags); */
+	local_irq_save(flags);
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		rtl865x_changeOpMode(BRIDGE_MODE);
+		rtl865x_changeOpMode(GATEWAY_MODE);
+	} else if (rtl865x_curOpMode == BRIDGE_MODE) {
+		rtl865x_changeOpMode(GATEWAY_MODE);
+		rtl865x_changeOpMode(BRIDGE_MODE);
+	} else if (rtl865x_curOpMode == WISP_MODE) {
+		rtl865x_changeOpMode(GATEWAY_MODE);
+		rtl865x_changeOpMode(WISP_MODE);
+	}
+	/* SMP_UNLOCK_ETH(flags); */
+	local_irq_restore(flags);
+	return 0;
+}
+
+static int32 reinit_vlan_configure(struct rtl865x_vlanConfig new_vlanconfig[])
+{
+	uint16 pvid;
+	int32 i, j;
+	uint32 valid_port_mask = 0;
+	struct rtl865x_vlanConfig *pvlanconfig = NULL;
+	int32 totalVlans = 0;
+	pvlanconfig = new_vlanconfig;
+
+	/*get input vlan config entry number */
+	for (i = 0; pvlanconfig[i].ifname[0] != '\0'; i++) {
+		if (pvlanconfig[i].vid != 0)
+			totalVlans++;
+	}
+	/* because the new_vlanconfig should be packedVlanConfig */
+	totalVlans = totalVlans > NETIF_NUMBER ? NETIF_NUMBER : totalVlans;
+
+	for (i = 0; i < totalVlans; i++) {
+		rtl865x_netif_t netif;
+
+		if (pvlanconfig[i].vid == 0)
+			continue;
+
+		valid_port_mask = pvlanconfig[i].memPort;
+		if (pvlanconfig[i].isWan == 0)
+			valid_port_mask |= 0x100;
+
+		/*add vlan */
+		if (pvlanconfig[i].if_type == IF_ETHER) {
+			rtl865x_addVlan(pvlanconfig[i].vid);
+#if defined(CONFIG_RTL_8198C) && defined(CONFIG_RTL_HW_6RD_SUPPORT) && defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT) && !defined(CONFIG_OPENWRT_SDK)
+			if (pvlanconfig[i].isWan) {
+				rtl865x_addVlanPortMember(pvlanconfig[i].vid,
+					(pvlanconfig[i].
+						memPort & valid_port_mask) |
+					0x100);
+			} else
+#endif
+				rtl865x_addVlanPortMember(pvlanconfig[i].vid,
+					pvlanconfig[i].
+					memPort & valid_port_mask);
+
+#if (defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)) && !defined(CONFIG_RTL_CPU_TAG)
+			/* remove untagPortMask in 8197D hardware VLAN table */
+			rtl865x_setVlanPortTag(pvlanconfig[i].vid,
+				pvlanconfig[i].memPort, TRUE);
+#endif
+			rtl865x_setVlanFilterDatabase(pvlanconfig[i].vid,
+				pvlanconfig[i].fid);
+		}
+
+		/*add network interface */
+		memset(&netif, 0, sizeof(rtl865x_netif_t));
+		memcpy(netif.name, pvlanconfig[i].ifname, MAX_IFNAMESIZE);
+		memcpy(netif.macAddr.octet, pvlanconfig[i].mac.octet,
+			ETHER_ADDR_LEN);
+		netif.mtu = pvlanconfig[i].mtu;
+		netif.if_type = pvlanconfig[i].if_type;
+		netif.vid = pvlanconfig[i].vid;
+		netif.is_wan = pvlanconfig[i].isWan;
+		netif.is_slave = pvlanconfig[i].is_slave;
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST) || defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+		netif.enableRoute = 1;
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		netif.mtuV6 = pvlanconfig[i].mtu;
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT) || (defined(CONFIG_RTL_MLD_SNOOPING) && defined(CONFIG_RTL_HARDWARE_MULTICAST))
+		netif.enableRouteV6 = 1;	/*jwj:enable ipv6, then enable v6 router */
+#endif
+#endif
+
+		rtl865x_addNetif(&netif);
+#ifndef CONFIG_RTL_ISP_MULTI_WAN_SUPPORT
+		if (netif.is_slave == 1)
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+			rtl865x_attachMasterNetif(netif.name,
+				RTL_GW_WAN_DEVICE_NAME);
+#else
+			rtl865x_attachMasterNetif(netif.name,
+				RTL_DRV_WAN0_NETIF_NAME);
+#endif
+#endif
+	}
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	rtl_config_multipleWan_netif(RTL_MULTIWAN_ADD);
+	/* rtl865x_addMultiCastNetif(); */
+#elif defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+	rtl_init_advRt();
+#endif
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN) || defined(CONFIG_RTL_MAC_BASED_NETIF)
+	rtl865x_addMultiCastNetif();
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	if (rtk_vlan_support_enable == 1)
+		rtl865x_enable_acl(0);
+	else
+		rtl865x_enable_acl(1);
+#endif
+
+	for (i = 0; i < RTL8651_PORT_NUMBER + 3; i++) {
+		/* Set each port's PVID */
+		for (j = 0, pvid = 0; pvlanconfig[j].vid != 0; j++) {
+			if ((1 << i) & pvlanconfig[j].memPort) {
+				pvid = pvlanconfig[j].vid;
+				break;
+			}
+		}
+
+		if (pvid != 0) {
+			CONFIG_CHECK(rtl8651_setAsicPvid(i, pvid));
+			rtl865x_setPortToNetif(pvlanconfig[j].ifname, i);
+		}
+	}
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+	if (rtl_hw_vlan_enable) {
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+		if (RTK_NAT_WAN_TAGGED) {
+#else
+		if ((hw_vlan_info[1].vlan_port_enabled)
+			&& hw_vlan_info[1].vlan_port_tag) {
+#endif
+			rtl865x_setVlanPortTag(vlanconfig[1].vid, RTL_WANPORT_MASK, 1);	/* eth1 vlan port 1 tag */
+			swNic_setVlanPortTag(RTL_WANPORT_MASK);	/* packet from CPU, HW add tag */
+		} else
+			swNic_setVlanPortTag(0);
+
+		if ((hw_vlan_info[0].vlan_port_enabled)
+			&& (hw_vlan_info[0].vlan_port_bridge == 1)) {
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+			if (hw_vlan_info[0].vlan_port_tag == 0) {
+				if (RTK_NAT_WAN_TAGGED) {
+					rtl8651_setAsicPvid(RTK_WAN_PORT_IDX,
+						hw_vlan_info[0].vlan_port_vid);
+					rtl865x_setVlanPortTag(hw_vlan_info[0].vlan_port_vid, RTL_CPUPORT_MASK, 1);	/* to idefiy untag from bridge */
+				} else	/* nat and bridge all untag */
+				{
+					rtl865x_addVlanPortMember(vlanconfig[1].vid, RTL_LANPORT_MASK_4);	/* mark_rus */
+					/* rtl8651_setAsicPvid(0,vlanconfig[1].vid); //set brige port pvid to WAN netif vid ,for HW L2 */
+					rtl8651_setAsicPvid(RTK_MASK_TO_PORT(RTL_LANPORT_MASK_4), vlanconfig[1].vid);	/* set brige port pvid to WAN netif vid ,for HW L2 */
+				}
+			} else	/* tag brigde */
+				rtl865x_setVlanPortTag(hw_vlan_info[0].vlan_port_vid, RTL_WANPORT_MASK | RTL_CPUPORT_MASK, 1);	/* wan port tag */
+#else
+			rtl865x_addVlan(hw_vlan_info[0].vlan_port_vid);
+			rtl865x_addVlanPortMember(hw_vlan_info[0].vlan_port_vid,
+				RTL_LANPORT_MASK_4 | RTL_WANPORT_MASK);
+			rtl865x_setVlanPortTag(hw_vlan_info[0].vlan_port_vid, RTL_WANPORT_MASK, 1);	/* wan port tag */
+			if (hw_vlan_info[0].vlan_port_tag) {
+				rtl865x_setVlanPortTag(hw_vlan_info[0].vlan_port_vid, RTL_LANPORT_MASK_4, 1);	/* wan port tag */
+			}
+			rtl865x_setVlanFilterDatabase(hw_vlan_info[0].
+				vlan_port_vid, 0);
+			/* rtl8651_setAsicPvid(0, hw_vlan_info[0].vlan_port_vid); //port vid */
+			rtl8651_setAsicPvid(RTK_MASK_TO_PORT(RTL_LANPORT_MASK_4), hw_vlan_info[0].vlan_port_vid);	/* port vid */
+#endif
+			rtl865x_setPortForward(RTL_LANPORT_MASK_4, TRUE);
+		}
+		if ((hw_vlan_info[2].vlan_port_enabled)
+			&& (hw_vlan_info[2].vlan_port_bridge == 1)) {
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+			if (hw_vlan_info[2].vlan_port_tag == 0) {
+				if (RTK_NAT_WAN_TAGGED) {
+					rtl8651_setAsicPvid(RTK_WAN_PORT_IDX,
+						hw_vlan_info[2].vlan_port_vid);
+					rtl865x_setVlanPortTag(hw_vlan_info[2].vlan_port_vid, RTL_CPUPORT_MASK, 1);	/* to idefiy untag from bridge */
+				} else {
+					rtl865x_addVlanPortMember(vlanconfig[1].vid, RTL_LANPORT_MASK_3);	/* mark_rus */
+					/* rtl8651_setAsicPvid(1,vlanconfig[1].vid); //set brige port pvid to WAN netif vid */
+					rtl8651_setAsicPvid(RTK_MASK_TO_PORT(RTL_LANPORT_MASK_3), vlanconfig[1].vid);	/* set brige port pvid to WAN netif vid */
+				}
+
+			} else	/* tag brigde */
+				rtl865x_setVlanPortTag(hw_vlan_info[2].vlan_port_vid, RTL_WANPORT_MASK | RTL_CPUPORT_MASK, 1);	/* wan port tag */
+#else
+			rtl865x_addVlan(hw_vlan_info[2].vlan_port_vid);
+			rtl865x_addVlanPortMember(hw_vlan_info[2].vlan_port_vid,
+				RTL_LANPORT_MASK_3 | RTL_WANPORT_MASK);
+			rtl865x_setVlanPortTag(hw_vlan_info[2].vlan_port_vid, RTL_WANPORT_MASK, 1);	/* wan port tag */
+			if (hw_vlan_info[2].vlan_port_tag) {
+				rtl865x_setVlanPortTag(hw_vlan_info[2].vlan_port_vid, RTL_LANPORT_MASK_3, 1);	/* wan port tag */
+			}
+			rtl865x_setVlanFilterDatabase(hw_vlan_info[2].
+				vlan_port_vid, 0);
+			/* rtl8651_setAsicPvid(1, hw_vlan_info[2].vlan_port_vid); //port vid */
+			rtl8651_setAsicPvid(RTK_MASK_TO_PORT(RTL_LANPORT_MASK_3), hw_vlan_info[2].vlan_port_vid);	/* port vid */
+#endif
+			rtl865x_setPortForward(RTL_LANPORT_MASK_3, TRUE);
+		}
+		if ((hw_vlan_info[3].vlan_port_enabled)
+			&& (hw_vlan_info[3].vlan_port_bridge == 1)) {
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+			if (hw_vlan_info[3].vlan_port_tag == 0) {
+				if (RTK_NAT_WAN_TAGGED) {
+					rtl8651_setAsicPvid(RTK_WAN_PORT_IDX,
+						hw_vlan_info[3].vlan_port_vid);
+					rtl865x_setVlanPortTag(hw_vlan_info[3].vlan_port_vid, RTL_CPUPORT_MASK, 1);	/* to idefiy untag from bridge */
+				} else {
+					rtl865x_addVlanPortMember(vlanconfig[1].vid, RTL_LANPORT_MASK_2);	/* mark_rus */
+					/* rtl8651_setAsicPvid(2,vlanconfig[1].vid); //set brige port pvid to WAN netif vid */
+					rtl8651_setAsicPvid(RTK_MASK_TO_PORT(RTL_LANPORT_MASK_2), vlanconfig[1].vid);	/* set brige port pvid to WAN netif vid */
+				}
+			} else	/* tag brigde */
+				rtl865x_setVlanPortTag(hw_vlan_info[3].vlan_port_vid, RTL_WANPORT_MASK | RTL_CPUPORT_MASK, 1);	/* wan port tag */
+#else
+			rtl865x_addVlan(hw_vlan_info[3].vlan_port_vid);
+			rtl865x_addVlanPortMember(hw_vlan_info[3].vlan_port_vid,
+				RTL_LANPORT_MASK_2 | RTL_WANPORT_MASK);
+			rtl865x_setVlanPortTag(hw_vlan_info[3].vlan_port_vid, RTL_WANPORT_MASK, 1);	/* wan port tag */
+			if (hw_vlan_info[3].vlan_port_tag) {
+				rtl865x_setVlanPortTag(hw_vlan_info[3].vlan_port_vid, RTL_LANPORT_MASK_2, 1);	/* wan port tag */
+			}
+			rtl865x_setVlanFilterDatabase(hw_vlan_info[3].
+				vlan_port_vid, 0);
+			/* rtl8651_setAsicPvid(2, hw_vlan_info[3].vlan_port_vid); //port vid */
+			rtl8651_setAsicPvid(RTK_MASK_TO_PORT(RTL_LANPORT_MASK_2), hw_vlan_info[3].vlan_port_vid);	/* port vid */
+#endif
+			rtl865x_setPortForward(RTL_LANPORT_MASK_2, TRUE);
+		}
+		if ((hw_vlan_info[4].vlan_port_enabled)
+			&& (hw_vlan_info[4].vlan_port_bridge == 1)) {
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+			if (hw_vlan_info[4].vlan_port_tag == 0) {
+				if (RTK_NAT_WAN_TAGGED) {
+					rtl8651_setAsicPvid(RTK_WAN_PORT_IDX,
+						hw_vlan_info[4].vlan_port_vid);
+					rtl865x_setVlanPortTag(hw_vlan_info[4].vlan_port_vid, RTL_CPUPORT_MASK, 1);	/* to idefiy untag from bridge */
+				} else {
+					rtl865x_addVlanPortMember(vlanconfig[1].vid, RTL_LANPORT_MASK_1);	/* mark_rus */
+					/* rtl8651_setAsicPvid(3,vlanconfig[1].vid); //set brige port pvid to WAN netif vid */
+					rtl8651_setAsicPvid(RTK_MASK_TO_PORT(RTL_LANPORT_MASK_1), vlanconfig[1].vid);	/* set brige port pvid to WAN netif vid */
+				}
+			} else	/* tag brigde */
+				rtl865x_setVlanPortTag(hw_vlan_info[4].vlan_port_vid, RTL_WANPORT_MASK | RTL_CPUPORT_MASK, 1);	/* wan port tag */
+#else
+			rtl865x_addVlan(hw_vlan_info[4].vlan_port_vid);
+			rtl865x_addVlanPortMember(hw_vlan_info[4].vlan_port_vid,
+				RTL_LANPORT_MASK_1 | RTL_WANPORT_MASK);
+			rtl865x_setVlanPortTag(hw_vlan_info[4].vlan_port_vid, RTL_WANPORT_MASK, 1);	/* wan port tag */
+			if (hw_vlan_info[4].vlan_port_tag) {
+				rtl865x_setVlanPortTag(hw_vlan_info[4].vlan_port_vid, RTL_LANPORT_MASK_1, 1);	/* wan port tag */
+			}
+			rtl865x_setVlanFilterDatabase(hw_vlan_info[4].
+				vlan_port_vid, 0);
+			/* rtl8651_setAsicPvid(3, hw_vlan_info[4].vlan_port_vid); //port vid */
+			rtl8651_setAsicPvid(RTK_MASK_TO_PORT(RTL_LANPORT_MASK_1), hw_vlan_info[4].vlan_port_vid);	/* port vid */
+#endif
+			rtl865x_setPortForward(RTL_LANPORT_MASK_1, TRUE);
+		}
+#ifdef RTK_MANAGE_VLAN_IF
+		/* if manage vlan enable */
+		rtk_add_manage_vlan();
+#endif
+	} else {
+		swNic_setVlanPortTag(0);
+	}
+#endif
+
+#if 0				/* def CONFIG_RTL_STP */
+	re865x_stp_mapping_reinit();
+#endif
+
+#if !defined(CONFIG_RTL_IVL_SUPPORT) && (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F))
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST) && defined(CONFIG_RTL_MLD_SNOOPING)
+	rtl_enable_netif_routingV6_in_bridge_mode(rtl865x_curOpMode);
+#endif
+#endif
+
+	rtl_config_operation_layer(rtl865x_curOpMode);
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+	if (rtl865x_curOpMode != GATEWAY_MODE)
+		rtl865xC_setNetDecisionPolicy(NETIF_PORT_BASED);
+#endif
+	return SUCCESS;
+}
+
+#if defined(CONFIG_RTL_REPORT_LINK_STATUS)
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtk_link_event_read(struct seq_file *s, void *v)
+#else
+static int32 rtk_link_event_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+#endif
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	seq_printf(s, "%d\n", rtk_linkEvent);
+	return 0;
+#else
+	int len;
+	len = sprintf(page, "%d\n", rtk_linkEvent);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+#endif
+}
+
+static int32 rtk_link_event_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[4];
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		if (0 == (tmpbuf[0] - '0'))
+			rtk_linkEvent = 0;
+	}
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtk_link_status_read(struct seq_file *s, void *v)
+#else
+static int32 rtk_link_status_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+#endif
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	struct net_device *dev = (struct net_device *)(s->private);
+#else
+	struct net_device *dev = (struct net_device *)data;
+	int len;
+#endif
+	struct dev_priv *cp = NETDRV_PRIV(dev);
+	int rtk_linkStatus = 0;
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+	int eth0_portLinkStatus = 0;
+#endif
+
+#if defined(CONFIG_RTL_8196C) && defined(CONFIG_SUPPORT_RUSSIA_FEATURES)
+	static int flag = 0;
+	if (flag == 0) {
+		curLinkPortMask = rtl865x_getPhysicalPortLinkStatus();
+
+/* panic_printk("####%s:%d curLinkPortMask=%u\n",__FUNCTION__,__LINE__,curLinkPortMask); */
+		flag++;
+	}
+#endif
+
+	if (cp &&
+		((cp->portmask & curLinkPortMask & ((1 << RTL8651_MAC_NUMBER) -
+					1)) != 0)) {
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+		if ((memcmp(cp->dev->name, "eth0", 4) == 0)
+			&& (curLinkPortMask & RTL_LANPORT_MASK_4)) {
+			eth0_portLinkStatus = 1;
+		}
+#endif
+		rtk_linkStatus = 1;
+	} else {
+		rtk_linkStatus = 0;
+	}
+
+#ifdef CONFIG_RTL_PROC_NEW
+	seq_printf(s, "%d\n", rtk_linkStatus);
+	return 0;
+#else
+	len = sprintf(page, "%d\n", rtk_linkStatus);
+#if defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE)
+	len += sprintf(page + len, "%d %x", eth0_portLinkStatus,
+		curLinkPortMask);
+	len += sprintf(page + len, "\n");
+#endif
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+#endif
+}
+
+static int32 rtk_link_status_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+#endif
+
+#ifdef CONFIG_RTL_JUMBO_FRAME
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 jumbo_frame_support_read(struct seq_file *s, void *v)
+#else
+static int32 jumbo_frame_support_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+#endif
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	seq_printf(s, "%d %d\n", jumboFrameFlag, jumboFrameSize);
+	return 0;
+#else
+	int len;
+
+	len = sprintf(page, "%d %d\n", jumboFrameFlag, jumboFrameSize);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+#endif
+}
+
+extern int32 rtl865x_set_jumbo_frame_size(uint32 size, int op_mode);
+
+static int32 jumbo_frame_support_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[32];
+	int32 size;
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		sscanf(tmpbuf, "%d %d", &jumboFrameFlag, &jumboFrameSize);
+		if (jumboFrameFlag) {
+			switch (jumboFrameSize) {
+			case 1500:
+				size = JUMBO_FRAME_SIZE_NORMAL;
+				break;
+			case 9000:
+				size = JUMBO_FRAME_SIZE_9K;
+				break;
+			case 16000:
+				size = JUMBO_FRAME_SIZE_16K;
+				break;
+			default:
+				printk("Wrong Jumbo frame size:%d\n",
+					jumboFrameSize);
+				return len;
+			}
+			rtl865x_set_jumbo_frame_size(size, rtl865x_curOpMode);
+		} else {
+			rtl865x_set_jumbo_frame_size(JUMBO_FRAME_SIZE_NORMAL,
+				rtl865x_curOpMode);
+		}
+	}
+
+	return len;
+}
+#endif
+
+#ifdef CONFIG_RTL_HARDWARE_IPV6_SUPPORT
+extern int rtl819x_save_inused_ipv6_route(void);
+extern int rtl819x_restore_inused_ipv6_route(void);
+extern void rtl819x_save_hw_ipv6_arp_table(void);
+extern int rtl819x_restore_hw_ipv6_arp_table(void);
+
+void rtl819x_save_ipv6_hw_tables(void)
+{
+	rtl819x_save_hw_ipv6_arp_table();
+	rtl819x_save_inused_ipv6_route();
+}
+
+void rtl819x_restore_ipv6_hw_tables(void)
+{
+	rtl819x_restore_inused_ipv6_route();
+	rtl819x_restore_hw_ipv6_arp_table();
+
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtk_hwL3v6_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s %d\n", "rtk_hwL3v6_enable:", rtk_hwL3v6_enable);
+	return 0;
+}
+#else
+static int32 rtk_hwL3v6_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	len = sprintf(page, "%s %d\n", "rtk_hwL3v6_enable:", rtk_hwL3v6_enable);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+static int32 rtk_hwL3v6_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[128] = { '\0' };
+	char *strptr = NULL, *cmd_addr = NULL;
+	uint32 enable = 0;
+	inv6_addr_t ipAddr, nexthop;
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+
+		if (cmd_addr
+			&& !memcmp(cmd_addr, "by_ipv6_route",
+				strlen("by_ipv6_route"))) {
+			sscanf(strptr, "%x", &enable);
+			/* panic_printk("%s %d enable=%d \n", __FUNCTION__, __LINE__, enable); */
+			if (enable) {
+				/* restore. */
+				rtl819x_restore_ipv6_hw_tables();
+			} else {
+				/* clear hw ipv6 routing, and default to cpu. */
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+				/* store hw table */
+				rtl819x_save_ipv6_hw_tables();
+
+				/* clear */
+				rtl8198c_reinitIpv6RouteTable();
+				rtl8198c_reinitIpv6NxtHopTable();
+				/* rtl8198c_ipv6_arp_reinit(); */
+
+				/* add default route. */
+				if (rtl8651_getAsicOperationLayer() > 2) {
+					memset(&ipAddr, 0, sizeof(inv6_addr_t));
+					memset(&nexthop, 0,
+						sizeof(inv6_addr_t));
+
+					rtl8198c_addIpv6Route(ipAddr, 0,
+						nexthop,
+						RTL_DRV_WAN0_NETIF_NAME);
+				}
+#endif
+			}
+
+		}
+#if 0
+		else if (!memcmp(cmd_addr, "by_ipv6_netif",
+				strlen("by_ipv6_netif"))) {
+			sscanf(strptr, "%x", &enable);
+			/* panic_printk("%s %d enable=%d \n", __FUNCTION__, __LINE__, enable); */
+			if (enable) {
+				rtk_hwL3v6_enable = 1;
+				/* enable netif's ipv6 routing */
+				rtl_set_netif_v6_route(rtk_hwL3v6_enable);
+				/* rtl_config_operation_layer(rtl865x_curOpMode); */
+			} else {
+				rtk_hwL3v6_enable = 0;
+				/* disbale netif's ipv6 routing */
+				rtl_set_netif_v6_route(rtk_hwL3v6_enable);
+				/* rtl8651_setAsicOperationLayer(2); */
+			}
+
+		}
+#endif
+		else {
+			if (tmpbuf[0] == '1') {
+				rtk_hwL3v6_enable = 1;
+				/* enable netif's ipv6 routing */
+				rtl_set_netif_v6_route(rtk_hwL3v6_enable);
+				/* rtl_config_operation_layer(rtl865x_curOpMode); */
+			} else if (tmpbuf[0] == '0') {
+				rtk_hwL3v6_enable = 0;
+				/* disbale netif's ipv6 routing */
+				rtl_set_netif_v6_route(rtk_hwL3v6_enable);
+				/* rtl8651_setAsicOperationLayer(2); */
+			} else {
+				printk("echo \"by_ipv6_route $enable\" >/proc/hwL3v6\n");
+				/* printk("echo \"by_ipv6_netif $enable\" >/proc/hwL3v6\n"); */
+				printk("echo \"$enable\" >/proc/hwL3v6\n");
+				printk("$enable means enable or disable hardware layer3 ipv6 support, valid value is 0/1\n");
+				return len;
+			}
+		}
+	}
+
+	return len;
+}
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+static int32 rtk_vlan_wan_tag_getportmask(int bridge_port)
+{
+	int32 port_mask = 0x80;	/* PKTHDR_EXTPORT_LIST_P2 2=> bit 7 */
+
+	if (vlan_bridge_port & (1 << 3))
+		port_mask |= RTL_LANPORT_MASK_1;
+
+	if (vlan_bridge_port & (1 << 2))
+		port_mask |= RTL_LANPORT_MASK_2;
+
+	if (vlan_bridge_port & (1 << 1))
+		port_mask |= RTL_LANPORT_MASK_3;
+
+	if (vlan_bridge_port & (1 << 0))
+		port_mask |= RTL_LANPORT_MASK_4;
+
+	return port_mask;
+}
+
+static int32 rtk_vlan_wan_tag_support_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[100];
+	int lan_portmask;
+	int num;
+	int i = 0;
+	int j = 0;
+	struct net_device *dev;
+	struct dev_priv *dp;
+#ifdef CONFIG_RTL_IGMP_SNOOPING
+	int ret = 0;
+	rtl_multicastDeviceInfo_t devInfo;
+#endif
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+
+		num = sscanf(tmpbuf, "%d %d %d %d %d", &vlan_tag,
+			&vlan_host_pri, &vlan_bridge_tag, &vlan_bridge_port,
+			&vlan_bridge_multicast_tag);
+		if (num != 5) {
+			printk("invalid rtk_vlan_wan_tag_support_write parameter!\n");
+			return len;
+		}
+		if (rtl865x_curOpMode == WISP_MODE)	/* not support in WISP mode */
+		{
+			vlan_tag = 0;
+			vlan_bridge_tag = 0;
+		} else if (rtl865x_curOpMode == BRIDGE_MODE) {
+			vlan_bridge_tag = 0;
+		}
+		if (vlan_bridge_tag == vlan_tag)
+			vlan_bridge_tag = 0;
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+		rtl_config_vlanconfig(rtl865x_curOpMode);
+#else
+		rtl_config_rtkVlan_vlanconfig(rtl865x_curOpMode);
+#endif
+
+		/* Reset PPPoE vlan id to original */
+		vlanconfig[VLAN_CONFIG_PPPOE_INDEX].vid = RTL_WANVLANID;
+
+		lan_portmask = 0;
+
+		if (vlan_bridge_tag) {
+			lan_portmask =
+				rtk_vlan_wan_tag_getportmask(vlan_bridge_port);
+			vlanconfig[2].vid = vlan_bridge_tag;
+			vlanconfig[2].memPort = lan_portmask | RTL_WANPORT_MASK;
+			vlanconfig[2].untagSet = lan_portmask;
+
+			/* need verify */
+			vlanconfig[2].fid = 1;
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->
+				portmask = lan_portmask | RTL_WANPORT_MASK;
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->id = vlan_bridge_tag;	/* eth2 */
+			/* vlanconfig[0].vid= RTL_LANVLANID; */
+			vlanconfig[0].memPort =
+				RTL_LANPORT_MASK & (~lan_portmask);
+			vlanconfig[0].untagSet =
+				RTL_LANPORT_MASK & (~lan_portmask);
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_LANPORT_MASK & (~lan_portmask);	/* eth0 */
+			/* ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = RTL_LANVLANID; */
+		}
+
+		if (rtl865x_curOpMode == GATEWAY_MODE && vlan_tag) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+			vlanconfig[RTL_WAN_IDX].vid = vlan_tag;
+			vlanconfig[RTL_WAN_IDX].memPort = RTL_WANPORT_MASK;
+			vlanconfig[RTL_WAN_IDX].untagSet = 0;	/* need tag */
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[RTL_WAN_IDX]))->portmask = RTL_WANPORT_MASK;	/* eth1 */
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[RTL_WAN_IDX]))->id = vlan_tag;	/* eth1 */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			vlanconfig[1].vid = vlan_tag;
+			vlanconfig[1].memPort = RTL_WANPORT_MASK;
+			vlanconfig[1].untagSet = 0;	/* need tag */
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = RTL_WANPORT_MASK;	/* eth1 */
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = vlan_tag;	/* eth1 */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+			/* PPPOE */
+			vlanconfig[VLAN_CONFIG_PPPOE_INDEX].vid = vlan_tag;
+		}
+
+		re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+		rtl_reinit_hw_table();
+		if (vlan_bridge_tag) {
+			packedVlanConfig[2].memPort &= (~0x100);	/* eth2 use port 7, not port 8 */
+			packedVlanConfig[2].untagSet &= (~0x100);
+		}
+		reinit_vlan_configure(packedVlanConfig);
+
+		if (rtl865x_curOpMode == GATEWAY_MODE && vlan_tag) {
+			rtl865x_setVlanPortTag(vlan_tag, RTL_WANPORT_MASK, true);	/* eth1 vlan port 1 tag */
+		}
+		if (rtl865x_curOpMode == BRIDGE_MODE && vlan_tag) {
+			rtl865x_addVlan(vlan_tag);
+			rtl865x_addVlanPortMember(vlan_tag,
+				RTL_LANPORT_MASK | RTL_WANPORT_MASK);
+			rtl865x_setVlanPortTag(vlan_tag,
+				(RTL_LANPORT_MASK | RTL_WANPORT_MASK) &
+				(~0x100), 1);
+			rtl865x_setVlanFilterDatabase(vlan_tag, 0);
+		}
+
+		if (vlan_bridge_tag) {
+			rtl865x_setVlanPortTag(vlan_bridge_tag, RTL_WANPORT_MASK, true);	/* eth1 vlan port 1 tag */
+			if (nicIgmpModuleIndex_2 == 0xFFFFFFFF) {
+				ret = rtl_registerIgmpSnoopingModule
+					(&nicIgmpModuleIndex_2);
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+				memset(&devInfo, 0,
+					sizeof(rtl_multicastDeviceInfo_t));
+				strcpy(devInfo.devName, RTL_PS_ETH_NAME_ETH2);
+				if (ret == 0)
+					rtl_setIgmpSnoopingModuleDevInfo
+						(nicIgmpModuleIndex_2,
+						&devInfo);
+#endif
+			}
+			if (vlan_bridge_multicast_tag) {
+				if (vlan_bridge_multicast_tag ==
+					vlan_bridge_tag) {
+					vlan_bridge_multicast_tag = 0;
+				} else {
+					rtl865x_addVlan
+						(vlan_bridge_multicast_tag);
+					rtl865x_addVlanPortMember
+						(vlan_bridge_multicast_tag,
+						RTL_WANPORT_MASK);
+					rtl865x_setVlanPortTag(vlan_bridge_multicast_tag, RTL_WANPORT_MASK, 1);	/* wan port tag */
+					rtl865x_setVlanFilterDatabase
+						(vlan_bridge_multicast_tag, 1);
+				}
+			}
+		} else {
+			if (nicIgmpModuleIndex_2 != 0xFFFFFFFF)
+				rtl_unregisterIgmpSnoopingModule
+					(nicIgmpModuleIndex_2);
+			/* rtl865x_setVlanPortTag(vlanconfig[1].vid,RTL_WANPORT_MASK,false); //eth1 vlan port 1 tag */
+#ifdef CONFIG_RTL_IGMP_SNOOPING
+			if (nicIgmpModuleIndex_2 != 0xFFFFFFFF)
+				rtl_unregisterIgmpSnoopingModule
+					(nicIgmpModuleIndex_2);
+#endif
+		}
+
+		/*update dev port number */
+		for (i = 0; vlanconfig[i].vid != 0; i++) {
+			if (IF_ETHER != vlanconfig[i].if_type) {
+				continue;
+			}
+
+			dev = _rtl86xx_dev.dev[i];
+			dp = NETDRV_PRIV(dev);
+			dp->portnum = 0;
+			for (j = 0; j < RTL8651_AGGREGATOR_NUMBER; j++) {
+				if (dp->portmask & (1 << j))
+					dp->portnum++;
+			}
+
+		}
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+		re865x_reInitIgmpSetting(rtl865x_curOpMode);
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+		if (mldSnoopEnabled) {
+			re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+			rtl865x_addAclForMldSnooping(packedVlanConfig);
+		}
+#endif
+#if  defined(CONFIG_RTL_HARDWARE_MULTICAST)
+		if (igmpsnoopenabled) {
+			rtl_processAclForIgmpSnooping(igmpsnoopenabled);
+		}
+#endif
+#endif
+
+#if defined(CONFIG_RTL_DNS_TRAP)
+		re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+		rtl_remove_Acl_for_dns_trap(packedVlanConfig);
+		rtl_add_Acl_for_dns_trap(packedVlanConfig);
+#endif
+		/* always init the default route... */
+		if (rtl8651_getAsicOperationLayer() > 2) {
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+			rtl865x_addRoute(0, 0, 0, RTL_DRV_WAN0_NETIF_NAME, 0);
+#endif
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+			{
+				inv6_addr_t ipAddr, nexthop;
+				memset(&ipAddr, 0, sizeof(inv6_addr_t));
+				memset(&nexthop, 0, sizeof(inv6_addr_t));
+
+				rtl8198c_addIpv6Route(ipAddr, 0, nexthop,
+					RTL_DRV_WAN0_NETIF_NAME);
+			}
+#endif
+		}
+		WRITE_MEM32(SWTCR0, (READ_MEM32(SWTCR0) | EnUkVIDtoCPU));
+
+	}
+
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rtk_vlan_wan_tag_support_read(struct seq_file *s, void *v)
+{
+	seq_printf(s,
+		"vlan_tag: %d vlan_host_pri: %d \nvlan_bridge_tag: %d, vlan_bridge_port: 0x%x vlan_bridge_stream_tag: %d\n",
+		vlan_tag, vlan_host_pri, vlan_bridge_tag, vlan_bridge_port,
+		vlan_bridge_multicast_tag);
+	return 0;
+}
+#else
+static int32 rtk_vlan_wan_tag_support_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	len = sprintf(page,
+		"vlan_tag: %d vlan_host_pri: %d \nvlan_bridge_tag: %d, vlan_bridge_port: 0x%x vlan_bridge_stream_tag: %d\n",
+		vlan_tag, vlan_host_pri, vlan_bridge_tag, vlan_bridge_port,
+		vlan_bridge_multicast_tag);
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+	return len;
+}
+#endif
+
+#endif
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtk_vlan_support_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s %d\n", "rtk_vlan_support_enable:",
+		rtk_vlan_support_enable);
+	return 0;
+}
+#else
+static int32 rtk_vlan_support_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	len = sprintf(page, "%s %d\n", "rtk_vlan_support_enable:",
+		rtk_vlan_support_enable);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+static int32 rtk_vlan_support_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[32];
+	int i = 0;
+	int j = 0;
+	struct net_device *dev;
+	struct dev_priv *dp;
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+#if defined(CONFIG_RTL_IGMP_SNOOPING) && defined(CONFIG_RTL_MLD_SNOOPING)
+		if (mldSnoopEnabled) {
+			rtl865x_removeAclForMldSnooping(vlanconfig);
+		}
+#if  defined(CONFIG_RTL_HARDWARE_MULTICAST)
+		if (igmpsnoopenabled) {
+			/* remove igmp acl */
+			rtl_processAclForIgmpSnooping(0);
+		}
+#endif
+#endif
+		if (tmpbuf[0] == '0') {
+			rtk_vlan_support_enable = 0;
+#if	defined(CONFIG_RTL_MULTI_LAN_DEV)
+			rtl_config_vlanconfig(rtl865x_curOpMode);
+#else
+			rtl_config_rtkVlan_vlanconfig(rtl865x_curOpMode);
+#endif
+			re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+			rtl_reinit_hw_table();
+			reinit_vlan_configure(packedVlanConfig);
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+			rtl865x_disableRtl8367ToCpuAcl();
+#endif
+
+			/* unknow vlan drop */
+			REG32(SWTCR0) &= ~(1 << 15);
+
+#if defined(CONFIG_RTL_LAYERED_DRIVER_ACL)
+			rtl865x_enable_acl(1);	/* enable acl feature */
+#endif
+		} else if (tmpbuf[0] == '1') {
+			rtk_vlan_support_enable = 1;
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+			rtl_config_vlanconfig(rtl865x_curOpMode);
+#else
+			rtl_config_rtkVlan_vlanconfig(rtl865x_curOpMode);
+#endif
+
+			re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+			rtl_reinit_hw_table();
+			reinit_vlan_configure(packedVlanConfig);
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+			rtl865x_enableRtl8367ToCpuAcl();
+#endif
+
+			/* unknow vid to cpu */
+			REG32(SWTCR0) |= 1 << 15;
+#if defined(CONFIG_RTL_LAYERED_DRIVER_ACL)
+			rtl865x_enable_acl(0);	/* disable acl feature */
+#endif
+		}
+#if defined(CONFIG_RTK_VLAN_FOR_CABLE_MODEM)
+		else if (tmpbuf[0] == '2') {
+			rtk_vlan_support_enable = 2;
+			/* unknow vid to cpu */
+			REG32(SWTCR0) |= 1 << 15;
+		}
+#endif
+		else {
+			printk("current support: 0/1/2\n");
+			return len;
+		}
+
+		/*update dev port number */
+		for (i = 0; vlanconfig[i].vid != 0; i++) {
+			if (IF_ETHER != vlanconfig[i].if_type) {
+				continue;
+			}
+
+			dev = _rtl86xx_dev.dev[i];
+			dp = NETDRV_PRIV(dev);
+			dp->portnum = 0;
+			for (j = 0; j < RTL8651_AGGREGATOR_NUMBER; j++) {
+				if (dp->portmask & (1 << j))
+					dp->portnum++;
+			}
+
+		}
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+		re865x_reInitIgmpSetting(rtl865x_curOpMode);
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+		if (mldSnoopEnabled && (rtk_vlan_support_enable == 0)) {
+			re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+			rtl865x_addAclForMldSnooping(packedVlanConfig);
+		}
+#endif
+#if  defined(CONFIG_RTL_HARDWARE_MULTICAST)
+		if (igmpsnoopenabled) {
+			rtl_processAclForIgmpSnooping(igmpsnoopenabled);
+		}
+#endif
+#endif
+#if (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_IPV6READYLOGO)
+		{
+			rtl865x_addAclForIPV6ReadyLogo(packedVlanConfig);
+		}
+#endif
+
+#if defined(CONFIG_RTL_HTTP_REDIRECT_LOCAL)
+		re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+		rtl865x_removeAclForHttpRedirect(packedVlanConfig);
+		rtl865x_addAclForHttpRedirect(packedVlanConfig);
+#endif
+#if defined(CONFIG_RTL_DNS_TRAP)
+		re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+		rtl_remove_Acl_for_dns_trap(packedVlanConfig);
+		rtl_add_Acl_for_dns_trap(packedVlanConfig);
+#endif
+		/* always init the default route... */
+		if (rtl8651_getAsicOperationLayer() > 2) {
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+			rtl865x_addRoute(0, 0, 0, RTL_DRV_WAN0_NETIF_NAME, 0);
+#endif
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+			{
+				inv6_addr_t ipAddr, nexthop;
+				memset(&ipAddr, 0, sizeof(inv6_addr_t));
+				memset(&nexthop, 0, sizeof(inv6_addr_t));
+
+				rtl8198c_addIpv6Route(ipAddr, 0, nexthop,
+					RTL_DRV_WAN0_NETIF_NAME);
+			}
+#endif
+		}
+
+	}
+	return len;
+}
+
+#if defined(CONFIG_819X_PHY_RW)	/* #if defined(CONFIG_RTK_VLAN_FOR_CABLE_MODEM) */
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtl_phy_status_read(struct seq_file *s, void *v)
+#else
+static int32 rtl_phy_status_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+#endif
+{
+	int len;
+	uint32 regData;
+	uint32 data0;
+	int port;
+
+#ifdef CONFIG_RTL_PROC_NEW
+	seq_printf(s, "Port Status:\n");
+#else
+	len = sprintf(page, "Port Status:\n");
+#endif
+
+	for (port = PHY0; port < CPU; port++) {
+		regData = READ_MEM32(PSRP0 + ((port) << 2));
+
+#ifdef CONFIG_RTL_PROC_NEW
+		seq_printf(s, "Port%d ", port);
+#else
+		len += sprintf(page + len, "Port%d ", port);
+#endif
+		data0 = regData & PortStatusLinkUp;
+
+		if (data0) {
+#ifdef CONFIG_RTL_PROC_NEW
+			seq_printf(s, "LinkUp | ");
+#else
+			len += sprintf(page + len, "LinkUp | ");
+#endif
+		} else {
+#ifdef CONFIG_RTL_PROC_NEW
+			seq_printf(s, "LinkDown\n\n");
+#else
+			len += sprintf(page + len, "LinkDown\n\n");
+#endif
+			continue;
+		}
+		data0 = regData & PortStatusDuplex;
+#ifdef CONFIG_RTL_PROC_NEW
+		seq_printf(s, "	Duplex %s | ", data0 ? "Enabled" : "Disabled");
+#else
+		len += sprintf(page + len, "	Duplex %s | ",
+			data0 ? "Enabled" : "Disabled");
+#endif
+		data0 = (regData & PortStatusLinkSpeed_MASK) >>
+			PortStatusLinkSpeed_OFFSET;
+#ifdef CONFIG_RTL_PROC_NEW
+		seq_printf(s, "Speed %s\n\n",
+			data0 == PortStatusLinkSpeed100M ? "100M" : (data0 ==
+				PortStatusLinkSpeed1000M ? "1G" : (data0 ==
+					PortStatusLinkSpeed10M ? "10M" :
+					"Unkown")));
+#else
+		len += sprintf(page + len, "Speed %s\n\n",
+			data0 == PortStatusLinkSpeed100M ? "100M" : (data0 ==
+				PortStatusLinkSpeed1000M ? "1G" : (data0 ==
+					PortStatusLinkSpeed10M ? "10M" :
+					"Unkown")));
+#endif
+	}
+
+#ifdef CONFIG_RTL_PROC_NEW
+	return 0;
+#else
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+#endif
+}
+
+static int32 rtl_phy_status_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[64];
+	uint32 port_mask;
+	char *strptr, *cmd_addr;
+	char *tokptr;
+	int type;
+	int port;
+	int forceMode = 0;
+	int forceLink = 0;
+	int forceLinkSpeed = 0;
+	int forceDuplex = 0;
+	uint32 advCapability = 0;
+	int forwardEnable = TRUE;
+
+#define SPEED10M 	0
+#define SPEED100M 	1
+#define SPEED1000M 	2
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len - 1] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+
+		if (!memcmp(cmd_addr, "port", 4)) {
+			port_mask = simple_strtol(tokptr, NULL, 0);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+
+			if (strcmp(tokptr, "10_half") == 0)
+				type = HALF_DUPLEX_10M;
+			else if (strcmp(tokptr, "100_half") == 0)
+				type = HALF_DUPLEX_100M;
+			else if (strcmp(tokptr, "1000_half") == 0)
+				type = HALF_DUPLEX_1000M;
+			else if (strcmp(tokptr, "10_full") == 0)
+				type = DUPLEX_10M;
+			else if (strcmp(tokptr, "100_full") == 0)
+				type = DUPLEX_100M;
+			else if (strcmp(tokptr, "1000_full") == 0)
+				type = DUPLEX_1000M;
+			else
+				type = PORT_AUTO;
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL)
+				goto errout;
+
+			forwardEnable = simple_strtol(tokptr, NULL, 0);
+
+			switch (type) {
+			case HALF_DUPLEX_10M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED10M;
+					forceDuplex = FALSE;
+					advCapability = (1 << HALF_DUPLEX_10M);
+					break;
+				}
+			case HALF_DUPLEX_100M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED100M;
+					forceDuplex = FALSE;
+					advCapability = (1 << HALF_DUPLEX_100M);
+					break;
+				}
+			case HALF_DUPLEX_1000M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED1000M;
+					forceDuplex = FALSE;
+					advCapability =
+						(1 << HALF_DUPLEX_1000M);
+					break;
+				}
+			case DUPLEX_10M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED10M;
+					forceDuplex = TRUE;
+					advCapability = (1 << DUPLEX_10M);
+					break;
+				}
+			case DUPLEX_100M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED100M;
+					forceDuplex = TRUE;
+					advCapability = (1 << DUPLEX_100M);
+					break;
+				}
+			case DUPLEX_1000M:
+				{
+					forceMode = TRUE;
+					forceLink = TRUE;
+					forceLinkSpeed = SPEED1000M;
+					forceDuplex = TRUE;
+					advCapability = (1 << DUPLEX_1000M);
+					break;
+				}
+			default:
+				{
+					forceMode = FALSE;
+					forceLink = TRUE;
+					/*all capality */
+					advCapability = (1 << PORT_AUTO);
+				}
+			}
+
+			for (port = 0; port < CPU; port++) {
+				if ((1 << port) & port_mask) {
+					rtl865xC_setAsicEthernetForceModeRegs
+						(port, forceMode, forceLink,
+						forceLinkSpeed, forceDuplex);
+
+					/*Set PHY Register */
+					rtl8651_setAsicEthernetPHYSpeed(port,
+						forceLinkSpeed);
+					rtl8651_setAsicEthernetPHYDuplex(port,
+						forceDuplex);
+					rtl8651_setAsicEthernetPHYAutoNeg(port,
+						forceMode ? FALSE : TRUE);
+					rtl8651_setAsicEthernetPHYAdvCapality
+						(port, advCapability);
+					rtl8651_restartAsicEthernetPHYNway
+						(port);
+					rtl865x_setPortForward(port,
+						forwardEnable);
+				}
+			}
+
+		} else {
+			goto errout;
+		}
+	} else {
+errout:
+		printk("port status only support \"port\" as the first parameter\n");
+		printk("format:	\"port port_mask 10_half/100_half/10_full/100_full/1000_full/auto\"\n");
+	}
+	return len;
+}
+
+/* mib counter */
+int rtl819x_get_port_mibStats(int port, struct port_mibStatistics *port_stats)
+{
+	uint32 addrOffset_fromP0 = 0;
+
+	if ((port > CPU) || (port_stats == NULL)) {
+		return FAILED;
+	}
+
+	addrOffset_fromP0 = port * MIB_ADDROFFSETBYPORT;
+
+	memset(port_stats, 0, sizeof(struct port_mibStatistics));
+	/* update the mib64 counters from 32bit counters */
+	/* rtl8651_updateAdvancedMibCounter((unsigned long)(&rtl865x_updateMib64Param)); //mark_rm */
+
+	port_stats->ifInOctets =
+		rtl8651_returnAsicCounter(OFFSET_IFINOCTETS_P0 +
+		addrOffset_fromP0);
+	/* rtl865xC_getAsicCounter64(OFFSET_IFINOCTETS_P0 + addrOffset_fromP0, &(port_stats->ifHCInOctets)); //mark_rm */
+	port_stats->ifHCInOctets = port_stats->ifInOctets;
+
+	port_stats->ifInUcastPkts =
+		rtl8651_returnAsicCounter(OFFSET_IFINUCASTPKTS_P0 +
+		addrOffset_fromP0);
+	/* port_stats->ifHCInUcastPkts = rtl865x_updateMib64Param[port].ifHCInUcastPkts; */
+	port_stats->ifHCInUcastPkts = port_stats->ifInUcastPkts;
+
+	port_stats->ifInDiscards = rtl8651_returnAsicCounter(OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0);	/* ?? */
+	port_stats->ifInErrors =
+		(rtl8651_returnAsicCounter(OFFSET_DOT3STATSFCSERRORS_P0 +
+			addrOffset_fromP0) +
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSJABBERS_P0 +
+			addrOffset_fromP0));
+	port_stats->ifInMulticastPkts =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSMULTICASTPKTS_P0 +
+		addrOffset_fromP0);
+	/* port_stats->ifHCInMulticastPkts= rtl865x_updateMib64Param[port].ifHCInMulticastPkts; */
+	port_stats->ifHCInMulticastPkts = port_stats->ifInMulticastPkts;
+
+	port_stats->ifInBroadcastPkts =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSBROADCASTPKTS_P0 +
+		addrOffset_fromP0);
+	/* port_stats->ifHCInBroadcastPkts= rtl865x_updateMib64Param[port].ifHCInBroadcastPkts; */
+	port_stats->ifHCInBroadcastPkts = port_stats->ifInBroadcastPkts;
+
+	/* rtl865xC_getAsicCounter64(OFFSET_ETHERSTATSOCTETS_P0 + addrOffset_fromP0, &port_stats->etherStatsOctets ); */
+	port_stats->etherStatsOctets = rtl8651_returnAsicCounter(OFFSET_ETHERSTATSOCTETS_P0 + addrOffset_fromP0);	/* replace above , mark_rm */
+	/* port_stats->etherStatsOctets=rtl865xC_returnAsicCounter64(OFFSET_ETHERSTATSOCTETS_P0 + addrOffset_fromP0); //not by mark_rm */
+	port_stats->etherStatsUndersizePkts =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSUNDERSIZEPKTS_P0 +
+		addrOffset_fromP0);
+	port_stats->etherStatsFraments =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSFRAGMEMTS_P0 +
+		addrOffset_fromP0);
+	port_stats->etherStatsPkts64Octets =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSPKTS64OCTETS_P0 +
+		addrOffset_fromP0);
+	port_stats->etherStatsPkts65to127Octets =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSPKTS65TO127OCTETS_P0
+		+ addrOffset_fromP0);
+	port_stats->etherStatsPkts128to255Octets =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSPKTS128TO255OCTETS_P0
+		+ addrOffset_fromP0);
+	port_stats->etherStatsPkts256to511Octets =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSPKTS256TO511OCTETS_P0
+		+ addrOffset_fromP0);
+	port_stats->etherStatsPkts512to1023Octets =
+		rtl8651_returnAsicCounter
+		(OFFSET_ETHERSTATSPKTS512TO1023OCTETS_P0 + addrOffset_fromP0);
+	port_stats->etherStatsPkts1024to1518Octets =
+		rtl8651_returnAsicCounter
+		(OFFSET_ETHERSTATSPKTS1024TO1518OCTETS_P0 + addrOffset_fromP0);
+	port_stats->etherStatsOversizePkts =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSOVERSIZEPKTS_P0 +
+		addrOffset_fromP0);
+	port_stats->etherStatsJabbers =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSJABBERS_P0 +
+		addrOffset_fromP0);
+	port_stats->etherStatusDropEvents =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSDROPEVENTS_P0 +
+		addrOffset_fromP0);
+	port_stats->dot3FCSErrors =
+		rtl8651_returnAsicCounter(OFFSET_DOT3STATSFCSERRORS_P0 +
+		addrOffset_fromP0);
+	port_stats->dot3StatsSymbolErrors =
+		rtl8651_returnAsicCounter(OFFSET_DOT3STATSSYMBOLERRORS_P0 +
+		addrOffset_fromP0);
+	port_stats->dot3ControlInUnknownOpcodes =
+		rtl8651_returnAsicCounter(OFFSET_DOT3CONTROLINUNKNOWNOPCODES_P0
+		+ addrOffset_fromP0);
+	port_stats->dot3InPauseFrames =
+		rtl8651_returnAsicCounter(OFFSET_DOT3INPAUSEFRAMES_P0 +
+		addrOffset_fromP0);
+
+	port_stats->ifOutOctets =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTOCTETS_P0 +
+		addrOffset_fromP0);
+	/* rtl865xC_getAsicCounter64(OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0, &port_stats->ifHCOutOctets); */
+	port_stats->ifHCOutOctets = port_stats->ifOutOctets;
+
+	/* port_stats->ifHCOutOctets=rtl865xC_returnAsicCounter64(OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0);//not by mark_rm */
+	port_stats->ifOutUcastPkts =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTUCASTPKTS_P0 +
+		addrOffset_fromP0);
+	/* port_stats->ifHCOutUcastPkts = rtl865x_updateMib64Param[port].ifHCOutUcastPkts; */
+	port_stats->ifHCOutUcastPkts = port_stats->ifOutUcastPkts;
+	port_stats->ifOutDiscards =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTDISCARDS +
+		addrOffset_fromP0);
+	port_stats->ifOutErrors =
+		(rtl8651_returnAsicCounter(OFFSET_ETHERSTATSCOLLISIONS_P0 +
+			addrOffset_fromP0) +
+		rtl8651_returnAsicCounter
+		(OFFSET_DOT3STATSDEFERREDTRANSMISSIONS_P0 + addrOffset_fromP0));
+	port_stats->ifOutMulticastPkts =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTMULTICASTPKTS_P0 +
+		addrOffset_fromP0);
+	port_stats->ifOutBroadcastPkts =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTBROADCASTPKTS_P0 +
+		addrOffset_fromP0);
+	/* port_stats->ifHCOutMulticastPkts=rtl865x_updateMib64Param[port].ifHCOutMulticastPkts; */
+	port_stats->ifHCOutMulticastPkts = port_stats->ifOutMulticastPkts;
+	/* port_stats->ifHCOutBroadcastPkts=rtl865x_updateMib64Param[port].ifHCOutBroadcastPkts; */
+	port_stats->ifHCOutBroadcastPkts = port_stats->ifOutBroadcastPkts;
+
+	port_stats->ifOutDiscards =
+		rtl8651_returnAsicCounter(OFFSET_IFOUTDISCARDS +
+		addrOffset_fromP0);
+	port_stats->dot3StatsSingleCollisionFrames =
+		rtl8651_returnAsicCounter
+		(OFFSET_DOT3STATSSINGLECOLLISIONFRAMES_P0 + addrOffset_fromP0);
+	port_stats->dot3StatsMultipleCollisionFrames =
+		rtl8651_returnAsicCounter
+		(OFFSET_DOT3STATSMULTIPLECOLLISIONFRAMES_P0 +
+		addrOffset_fromP0);
+	port_stats->dot3StatsDefferedTransmissions =
+		rtl8651_returnAsicCounter
+		(OFFSET_DOT3STATSDEFERREDTRANSMISSIONS_P0 + addrOffset_fromP0);
+	port_stats->dot3StatsLateCollisions =
+		rtl8651_returnAsicCounter(OFFSET_DOT3STATSLATECOLLISIONS_P0 +
+		addrOffset_fromP0);
+	port_stats->dot3StatsExcessiveCollisions =
+		rtl8651_returnAsicCounter(OFFSET_DOT3STATSEXCESSIVECOLLISIONS_P0
+		+ addrOffset_fromP0);
+	port_stats->dot3OutPauseFrames =
+		rtl8651_returnAsicCounter(OFFSET_DOT3OUTPAUSEFRAMES_P0 +
+		addrOffset_fromP0);
+	port_stats->dot1dBasePortDelayExceededDiscards =
+		rtl8651_returnAsicCounter
+		(OFFSET_DOT1DBASEPORTDELAYEXCEEDEDDISCARDS_P0 +
+		addrOffset_fromP0);
+	port_stats->etherStatsCollisions =
+		rtl8651_returnAsicCounter(OFFSET_ETHERSTATSCOLLISIONS_P0 +
+		addrOffset_fromP0);
+
+	/* port_stats->ifInUnknownProtos = ethPortInUnknownProtos[port]; //mark_rm */
+	port_stats->ifInUnknownProtos = 0;
+	port_stats->dot1dTpLearnedEntryDiscards =
+		rtl8651_returnAsicCounter(MIB_ADDROFFSETBYPORT);
+	port_stats->etherStatsCpuEventPkts =
+		rtl8651_returnAsicCounter(MIB_ADDROFFSETBYPORT);
+
+	return SUCCESS;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int show_port_mibStats(struct seq_file *s,
+	struct port_mibStatistics *port_stats, int port)
+{
+	/* struct lan_port_status tmp_port_status; */
+	/*here is in counters  definition */
+	seq_printf(s, "%s%u\n", "ifInOctets=", port_stats->ifInOctets);
+	seq_printf(s, "%s%llu\n", "ifHCInOctets=", port_stats->ifHCInOctets);
+	seq_printf(s, "%s%u\n", "ifInUcastPkts=", port_stats->ifInUcastPkts);
+	seq_printf(s, "%s%llu\n", "ifHCInUcastPkts=",
+		port_stats->ifHCInUcastPkts);
+	seq_printf(s, "%s%u\n", "ifInMulticastPkts=",
+		port_stats->ifInMulticastPkts);
+	seq_printf(s, "%s%llu\n", "ifHCInMulticastPkts=",
+		port_stats->ifHCInMulticastPkts);
+	seq_printf(s, "%s%u\n", "ifInBroadcastPkts=",
+		port_stats->ifInBroadcastPkts);
+	seq_printf(s, "%s%llu\n", "ifHCInBroadcastPkts=",
+		port_stats->ifHCInBroadcastPkts);
+	seq_printf(s, "%s%u\n", "ifInDiscards=", port_stats->ifInDiscards);
+	seq_printf(s, "%s%u\n", "ifInErrors=", port_stats->ifInErrors);
+	seq_printf(s, "%s%llu\n", "etherStatsOctets=",
+		port_stats->etherStatsOctets);
+	seq_printf(s, "%s%u\n", "etherStatsUndersizePkts=",
+		port_stats->etherStatsUndersizePkts);
+	seq_printf(s, "%s%u\n", "etherStatsFraments=",
+		port_stats->etherStatsFraments);
+	seq_printf(s, "%s%u\n", "etherStatsPkts64Octets=",
+		port_stats->etherStatsPkts64Octets);
+	seq_printf(s, "%s%u\n", "etherStatsPkts65to127Octets=",
+		port_stats->etherStatsPkts65to127Octets);
+	seq_printf(s, "%s%u\n", "etherStatsPkts128to255Octets=",
+		port_stats->etherStatsPkts128to255Octets);
+	seq_printf(s, "%s%u\n", "etherStatsPkts256to511Octets=",
+		port_stats->etherStatsPkts256to511Octets);
+	seq_printf(s, "%s%u\n", "etherStatsPkts512to1023Octets=",
+		port_stats->etherStatsPkts512to1023Octets);
+	seq_printf(s, "%s%u\n", "etherStatsPkts1024to1518Octets=",
+		port_stats->etherStatsPkts1024to1518Octets);
+	seq_printf(s, "%s%u\n", "etherStatsOversizePkts=",
+		port_stats->etherStatsOversizePkts);
+	seq_printf(s, "%s%u\n", "etherStatsJabbers=",
+		port_stats->etherStatsJabbers);
+	seq_printf(s, "%s%u\n", "dot1dTpPortInDiscards=",
+		port_stats->dot1dTpPortInDiscards);
+	seq_printf(s, "%s%u\n", "etherStatusDropEvents=",
+		port_stats->etherStatusDropEvents);
+	seq_printf(s, "%s%u\n", "dot3FCSErrors=", port_stats->dot3FCSErrors);
+	seq_printf(s, "%s%u\n", "dot3StatsSymbolErrors=",
+		port_stats->dot3StatsSymbolErrors);
+	seq_printf(s, "%s%u\n", "dot3ControlInUnknownOpcodes=",
+		port_stats->dot3ControlInUnknownOpcodes);
+	seq_printf(s, "%s%u\n", "dot3InPauseFrames=",
+		port_stats->dot3InPauseFrames);
+	/*here is out counters  definition */
+	seq_printf(s, "%s%u\n", "ifOutOctets=", port_stats->ifOutOctets);
+	seq_printf(s, "%s%llu\n", "ifHCOutOctets=", port_stats->ifHCOutOctets);
+	seq_printf(s, "%s%u\n", "ifOutUcastPkts=", port_stats->ifOutUcastPkts);
+	seq_printf(s, "%s%llu\n", "ifHCOutUcastPkts=",
+		port_stats->ifHCOutUcastPkts);
+	seq_printf(s, "%s%u\n", "ifOutMulticastPkts=",
+		port_stats->ifOutMulticastPkts);
+	seq_printf(s, "%s%llu\n", "ifHCOutMulticastPkts=",
+		port_stats->ifHCOutMulticastPkts);
+	seq_printf(s, "%s%u\n", "ifOutBroadcastPkts=",
+		port_stats->ifOutBroadcastPkts);
+	seq_printf(s, "%s%llu\n", "ifHCOutBroadcastPkts=",
+		port_stats->ifHCOutBroadcastPkts);
+	seq_printf(s, "%s%u\n", "ifOutDiscards=", port_stats->ifOutDiscards);
+	seq_printf(s, "%s%u\n", "ifOutErrors=", port_stats->ifOutErrors);
+	seq_printf(s, "%s%u\n", "dot3StatsSingleCollisionFrames=",
+		port_stats->dot3StatsSingleCollisionFrames);
+	seq_printf(s, "%s%u\n", "dot3StatsMultipleCollisionFrames=",
+		port_stats->dot3StatsMultipleCollisionFrames);
+	seq_printf(s, "%s%u\n", "dot3StatsDefferedTransmissions=",
+		port_stats->dot3StatsDefferedTransmissions);
+	seq_printf(s, "%s%u\n", "dot3StatsLateCollisions=",
+		port_stats->dot3StatsLateCollisions);
+	seq_printf(s, "%s%u\n", "dot3StatsExcessiveCollisions=",
+		port_stats->dot3StatsExcessiveCollisions);
+	seq_printf(s, "%s%u\n", "dot3OutPauseFrames=",
+		port_stats->dot3OutPauseFrames);
+	seq_printf(s, "%s%u\n", "dot1dBasePortDelayExceededDiscards=",
+		port_stats->dot1dBasePortDelayExceededDiscards);
+	seq_printf(s, "%s%u\n", "etherStatsCollisions=",
+		port_stats->etherStatsCollisions);
+	/*here is whole system couters definition */
+	/* mark_rm seq_printf(s, "%s%u\n", "dot1dTpLearnedEntryDiscards=", port_stats->dot1dTpLearnedEntryDiscards); */
+	/* mark_rm seq_printf(s, "%s%u\n", "etherStatsCpuEventPkts=", port_stats->etherStatsCpuEventPkts); */
+	/* seq_printf(s, "%s%u\n", "ifInUnknownProtos=", port_stats->ifInUnknownProtos); //mark_rm */
+	/* seq_printf(s, "%s%u\n", "ifAdminStatus=", PortAdminStatus[port]);//mark_rm */
+	/* seq_printf(s, "%s%u\n", "ifOperStatus=", PortifOperStatus[port]);//mark_rm */
+	/* seq_printf(s, "%s%u\n", "ifLastChange=", PortLastChange[port]);//mark_rm */
+	/* seq_printf(s, "%s%u\n", "ifSpeed=",port_stats->ifSpeed); */
+	/* seq_printf(s, "%s%u\n", "ifHighSpeed=",port_stats->ifHighSpeed); */
+	/* seq_printf(s, "%s%u\n", "ifCounterDiscontinuityTime=", port_stats->ifCounterDiscontinuityTime); */
+	/*//mark_rm
+	 * rtl819x_get_port_status(port, &tmp_port_status);
+	 * if(tmp_port_status.link == 1)
+	 * port_stats->ifConnectorPresent = 1;//link
+	 * else
+	 * port_stats->ifConnectorPresent = 2;//unlink
+	 * seq_printf(s, "%s%u\n", "ifConnectorPresent=", port_stats->ifConnectorPresent);
+	 */
+
+	return 0;
+}
+#else
+static int show_port_mibStats(struct port_mibStatistics *port_stats, int port,
+	char *page, int off)
+{
+	int len;
+	/* struct lan_port_status tmp_port_status; */
+	len = off;
+	/*here is in counters  definition */
+	len += sprintf(page + len, "%s%u\n", "ifInOctets=",
+		port_stats->ifInOctets);
+	len += sprintf(page + len, "%s%llu\n", "ifHCInOctets=",
+		port_stats->ifHCInOctets);
+	len += sprintf(page + len, "%s%u\n", "ifInUcastPkts=",
+		port_stats->ifInUcastPkts);
+	len += sprintf(page + len, "%s%llu\n", "ifHCInUcastPkts=",
+		port_stats->ifHCInUcastPkts);
+	len += sprintf(page + len, "%s%u\n", "ifInMulticastPkts=",
+		port_stats->ifInMulticastPkts);
+	len += sprintf(page + len, "%s%llu\n", "ifHCInMulticastPkts=",
+		port_stats->ifHCInMulticastPkts);
+	len += sprintf(page + len, "%s%u\n", "ifInBroadcastPkts=",
+		port_stats->ifInBroadcastPkts);
+	len += sprintf(page + len, "%s%llu\n", "ifHCInBroadcastPkts=",
+		port_stats->ifHCInBroadcastPkts);
+	len += sprintf(page + len, "%s%u\n", "ifInDiscards=",
+		port_stats->ifInDiscards);
+	len += sprintf(page + len, "%s%u\n", "ifInErrors=",
+		port_stats->ifInErrors);
+	len += sprintf(page + len, "%s%llu\n", "etherStatsOctets=",
+		port_stats->etherStatsOctets);
+	len += sprintf(page + len, "%s%u\n", "etherStatsUndersizePkts=",
+		port_stats->etherStatsUndersizePkts);
+	len += sprintf(page + len, "%s%u\n", "etherStatsFraments=",
+		port_stats->etherStatsFraments);
+	len += sprintf(page + len, "%s%u\n", "etherStatsPkts64Octets=",
+		port_stats->etherStatsPkts64Octets);
+	len += sprintf(page + len, "%s%u\n", "etherStatsPkts65to127Octets=",
+		port_stats->etherStatsPkts65to127Octets);
+	len += sprintf(page + len, "%s%u\n", "etherStatsPkts128to255Octets=",
+		port_stats->etherStatsPkts128to255Octets);
+	len += sprintf(page + len, "%s%u\n", "etherStatsPkts256to511Octets=",
+		port_stats->etherStatsPkts256to511Octets);
+	len += sprintf(page + len, "%s%u\n", "etherStatsPkts512to1023Octets=",
+		port_stats->etherStatsPkts512to1023Octets);
+	len += sprintf(page + len, "%s%u\n", "etherStatsPkts1024to1518Octets=",
+		port_stats->etherStatsPkts1024to1518Octets);
+	len += sprintf(page + len, "%s%u\n", "etherStatsOversizePkts=",
+		port_stats->etherStatsOversizePkts);
+	len += sprintf(page + len, "%s%u\n", "etherStatsJabbers=",
+		port_stats->etherStatsJabbers);
+	len += sprintf(page + len, "%s%u\n", "dot1dTpPortInDiscards=",
+		port_stats->dot1dTpPortInDiscards);
+	len += sprintf(page + len, "%s%u\n", "etherStatusDropEvents=",
+		port_stats->etherStatusDropEvents);
+	len += sprintf(page + len, "%s%u\n", "dot3FCSErrors=",
+		port_stats->dot3FCSErrors);
+	len += sprintf(page + len, "%s%u\n", "dot3StatsSymbolErrors=",
+		port_stats->dot3StatsSymbolErrors);
+	len += sprintf(page + len, "%s%u\n", "dot3ControlInUnknownOpcodes=",
+		port_stats->dot3ControlInUnknownOpcodes);
+	len += sprintf(page + len, "%s%u\n", "dot3InPauseFrames=",
+		port_stats->dot3InPauseFrames);
+	/*here is out counters  definition */
+	len += sprintf(page + len, "%s%u\n", "ifOutOctets=",
+		port_stats->ifOutOctets);
+	len += sprintf(page + len, "%s%llu\n", "ifHCOutOctets=",
+		port_stats->ifHCOutOctets);
+	len += sprintf(page + len, "%s%u\n", "ifOutUcastPkts=",
+		port_stats->ifOutUcastPkts);
+	len += sprintf(page + len, "%s%llu\n", "ifHCOutUcastPkts=",
+		port_stats->ifHCOutUcastPkts);
+	len += sprintf(page + len, "%s%u\n", "ifOutMulticastPkts=",
+		port_stats->ifOutMulticastPkts);
+	len += sprintf(page + len, "%s%llu\n", "ifHCOutMulticastPkts=",
+		port_stats->ifHCOutMulticastPkts);
+	len += sprintf(page + len, "%s%u\n", "ifOutBroadcastPkts=",
+		port_stats->ifOutBroadcastPkts);
+	len += sprintf(page + len, "%s%llu\n", "ifHCOutBroadcastPkts=",
+		port_stats->ifHCOutBroadcastPkts);
+	len += sprintf(page + len, "%s%u\n", "ifOutDiscards=",
+		port_stats->ifOutDiscards);
+	len += sprintf(page + len, "%s%u\n", "ifOutErrors=",
+		port_stats->ifOutErrors);
+	len += sprintf(page + len, "%s%u\n", "dot3StatsSingleCollisionFrames=",
+		port_stats->dot3StatsSingleCollisionFrames);
+	len += sprintf(page + len, "%s%u\n",
+		"dot3StatsMultipleCollisionFrames=",
+		port_stats->dot3StatsMultipleCollisionFrames);
+	len += sprintf(page + len, "%s%u\n", "dot3StatsDefferedTransmissions=",
+		port_stats->dot3StatsDefferedTransmissions);
+	len += sprintf(page + len, "%s%u\n", "dot3StatsLateCollisions=",
+		port_stats->dot3StatsLateCollisions);
+	len += sprintf(page + len, "%s%u\n", "dot3StatsExcessiveCollisions=",
+		port_stats->dot3StatsExcessiveCollisions);
+	len += sprintf(page + len, "%s%u\n", "dot3OutPauseFrames=",
+		port_stats->dot3OutPauseFrames);
+	len += sprintf(page + len, "%s%u\n",
+		"dot1dBasePortDelayExceededDiscards=",
+		port_stats->dot1dBasePortDelayExceededDiscards);
+	len += sprintf(page + len, "%s%u\n", "etherStatsCollisions=",
+		port_stats->etherStatsCollisions);
+	/*here is whole system couters definition */
+	/* mark_rm len += sprintf(page+len, "%s%u\n", "dot1dTpLearnedEntryDiscards=", port_stats->dot1dTpLearnedEntryDiscards); */
+	/* mark_rm len += sprintf(page+len, "%s%u\n", "etherStatsCpuEventPkts=", port_stats->etherStatsCpuEventPkts); */
+	/* len += sprintf(page+len, "%s%u\n", "ifInUnknownProtos=", port_stats->ifInUnknownProtos); //mark_rm */
+	/* len += sprintf(page+len, "%s%u\n", "ifAdminStatus=", PortAdminStatus[port]);//mark_rm */
+	/* len += sprintf(page+len, "%s%u\n", "ifOperStatus=", PortifOperStatus[port]);//mark_rm */
+	/* len += sprintf(page+len, "%s%u\n", "ifLastChange=", PortLastChange[port]);//mark_rm */
+	/* len += sprintf(page+len, "%s%u\n", "ifSpeed=",port_stats->ifSpeed); */
+	/* len += sprintf(page+len, "%s%u\n", "ifHighSpeed=",port_stats->ifHighSpeed); */
+	/* len += sprintf(page+len, "%s%u\n", "ifCounterDiscontinuityTime=", port_stats->ifCounterDiscontinuityTime); */
+	/* //mark_rm
+	 * rtl819x_get_port_status(port, &tmp_port_status);
+	 * if(tmp_port_status.link == 1)
+	 * port_stats->ifConnectorPresent = 1;//link
+	 * else
+	 * port_stats->ifConnectorPresent = 2;//unlink
+	 * len += sprintf(page+len, "%s%u\n", "ifConnectorPresent=", port_stats->ifConnectorPresent);
+	 */
+
+	return len;
+}
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int port_mibStats_read_proc(struct seq_file *s, void *v)
+#else
+static int port_mibStats_read_proc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+#endif
+{				/* TODO */
+	int len;
+	uint32 port;
+	struct port_mibStatistics port_stats;
+	len = 0;
+#ifdef CONFIG_RTL_PROC_NEW
+	port = (uint32)(s->private);
+#else
+	port = (uint32)data;
+#endif
+	if (port > CPU)
+		return 0;
+	rtl819x_get_port_mibStats(port, &port_stats);
+#ifdef CONFIG_RTL_PROC_NEW
+	show_port_mibStats(struct seq_file *s, &port_stats, port);
+	return 0;
+#else
+	len = show_port_mibStats(&port_stats, port, page, len);
+
+	return len;
+#endif
+}
+
+static int32 port_mibStats_write_proc(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	if (len < 2)
+		return -EFAULT;
+
+	rtl8651_clearAsicCounter();
+	return len;
+}
+
+#endif /* #if defined(CONFIG_819X_PHY_RW) */
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 read_proc_vlan(struct seq_file *s, void *v)
+{
+	struct net_device *dev = (struct net_device *)(s->private);
+	struct dev_priv *cp;
+	/* int len; */
+
+	cp = NETDRV_PRIV(dev);
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT) || defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+	seq_printf(s,
+		"gvlan=%d, lan=%d, vlan=%d, tag=%d, vid=%d, priority=%d, cfi=%d, forwarding_rule=%d\n",
+#else
+	seq_printf(s,
+		"gvlan=%d, lan=%d, vlan=%d, tag=%d, vid=%d, priority=%d, cfi=%d\n",
+#endif
+		cp->vlan_setting.global_vlan, cp->vlan_setting.is_lan,
+		cp->vlan_setting.vlan, cp->vlan_setting.tag,
+		cp->vlan_setting.id, cp->vlan_setting.pri, cp->vlan_setting.cfi
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT) || defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+		, cp->vlan_setting.forwarding_rule
+#endif
+		);
+	return 0;
+}
+#else /*CONFIG_RTL_PROC_NEW */
+static int read_proc_vlan(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+
+	struct net_device *dev = (struct net_device *)data;
+	struct dev_priv *cp;
+	int len;
+
+	cp = NETDRV_PRIV(dev);
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT) || defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+	len = sprintf(page,
+		"gvlan=%d, lan=%d, vlan=%d, tag=%d, vid=%d, priority=%d, cfi=%d, forwarding_rule=%d\n",
+#else
+	len = sprintf(page,
+		"gvlan=%d, lan=%d, vlan=%d, tag=%d, vid=%d, priority=%d, cfi=%d\n",
+#endif
+		cp->vlan_setting.global_vlan, cp->vlan_setting.is_lan,
+		cp->vlan_setting.vlan, cp->vlan_setting.tag,
+		cp->vlan_setting.id, cp->vlan_setting.pri, cp->vlan_setting.cfi
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT) || defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+		, cp->vlan_setting.forwarding_rule
+#endif
+		);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+	return len;
+}
+#endif /*CONFIG_RTL_PROC_NEW */
+
+static int write_proc_vlan(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	struct net_device *dev = PDE_DATA(file_inode(file));
+#else
+	struct net_device *dev = (struct net_device *)data;
+#endif
+	struct dev_priv *cp;
+#define	VLAN_MAX_INPUT_LEN	128
+	char *tmp;
+
+	tmp = kmalloc(VLAN_MAX_INPUT_LEN, GFP_KERNEL);
+	if (count < 2 || tmp == NULL)
+		goto out;
+
+	cp = NETDRV_PRIV(dev);
+	if (rtk_vlan_support_enable == 0)
+		goto out;
+
+	if (buffer && !copy_from_user(tmp, buffer, VLAN_MAX_INPUT_LEN)) {
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT) || defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+		int num = sscanf(tmp, "%d %d %d %d %d %d %d %d",
+#else
+		int num = sscanf(tmp, "%d %d %d %d %d %d %d",
+#endif
+			&cp->vlan_setting.global_vlan, &cp->vlan_setting.is_lan,
+			&cp->vlan_setting.vlan, &cp->vlan_setting.tag,
+			&cp->vlan_setting.id, &cp->vlan_setting.pri,
+			&cp->vlan_setting.cfi
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT) || defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+			, &cp->vlan_setting.forwarding_rule
+#endif
+			);
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT) || defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+		if (num != 8)
+#else
+		if (num != 7)
+#endif
+		{
+			printk("invalid vlan parameter!\n");
+			goto out;
+		}
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+		rtl_add_vlan_info(&cp->vlan_setting, dev);
+#endif
+#if 0
+		printk("===%s(%d), cp->name(%s),global_vlan(%d),is_lan(%d),vlan(%d),tag(%d),id(%d),pri(%d),cfi(%d)", __FUNCTION__, __LINE__, cp->dev->name, cp->vlan_setting.global_vlan, cp->vlan_setting.is_lan, cp->vlan_setting.vlan, cp->vlan_setting.tag, cp->vlan_setting.id, cp->vlan_setting.pri, cp->vlan_setting.cfi);
+		printk("-------------%s(%d),cp->portmask(%d)\n", __FUNCTION__,
+			__LINE__, cp->portmask);
+#endif
+	}
+out:
+	if (tmp)
+		kfree(tmp);
+
+	return count;
+}
+#endif /* CONFIG_RTK_VLAN_SUPPORT */
+
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtk_vlan_management_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "Management vlan: vid=%d, priority=%d, cfi=%d\n",
+		management_vlan.id, management_vlan.pri, management_vlan.cfi);
+	return 0;
+}
+#else
+static int rtk_vlan_management_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+
+	int len;
+
+	len = sprintf(page, "Management vlan: vid=%d, priority=%d, cfi=%d\n",
+		management_vlan.id, management_vlan.pri, management_vlan.cfi);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+	return len;
+}
+#endif
+
+static int rtk_vlan_management_write(struct file *file, const char *buffer,
+	unsigned long len, void *data)
+{
+	char tmpbuf[128];
+	int num;
+
+	if (buffer && !copy_from_user(tmpbuf, buffer, len)) {
+		tmpbuf[len] = '\0';
+
+		num = sscanf(tmpbuf, "%d %d %d",
+			&management_vlan.id, &management_vlan.pri,
+			&management_vlan.cfi);
+
+		if (num != 3) {
+			printk("invalid vlan parameter!\n");
+		}
+
+	}
+
+	return len;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+
+uint32 rtl_hw_vlan_get_tagged_portmask(void)
+{
+	uint32 portmask = 0;
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+	/* wan port dont add hw mc */
+	portmask = 1 << RTK_WAN_PORT_IDX;
+#else
+	int i, temp;
+
+	for (i = 0; i < PORT_NUMBER; i++) {
+		if ((hw_vlan_info[i].vlan_port_enabled)
+			&& (hw_vlan_info[i].vlan_port_tag)) {
+			temp = (i == 0) ? 0 : (i - 1);
+			portmask |= 1 << temp;
+		}
+	}
+#endif
+	return portmask;
+}
+
+int rtl_process_hw_vlan_tx(rtl_nicTx_info *txInfo)
+{
+	int i, temp;
+	int flag = 0;
+	unsigned short vid;
+	struct sk_buff *newskb;
+	struct sk_buff *skb = NULL;
+	/* unsigned short vid; */
+	struct vlan_tag tag, port_tag;
+	struct vlan_tag *adding_tag = NULL;
+	struct net_device *dev;
+	struct dev_priv *cp;
+
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+	if (!rtl_hw_vlan_enable)
+		return SUCCESS;
+#endif
+
+	memset(&tag, 0, sizeof(struct vlan_tag));
+	memset(&port_tag, 0, sizeof(struct vlan_tag));
+	skb = txInfo->out_skb;
+	dev = skb->dev;
+	cp = NETDRV_PRIV(dev);
+
+	newskb = NULL;
+	if (skb_cloned(skb)) {
+		if (cp->vlan_setting.is_lan
+			&& (cp->vlan_setting.forwarding_rule == 2)) {
+			/* if tx to lan port and forwarding rule as nat, not need skb copy. */
+		} else {
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+			newskb = priv_skb_copy(skb);
+#else
+			newskb = skb_copy(skb, GFP_ATOMIC);
+#endif
+			if (newskb == NULL) {
+				cp->net_stats.tx_dropped++;
+				dev_kfree_skb_any(skb);
+				return FAILED;
+			}
+			dev_kfree_skb_any(skb);
+			skb = newskb;
+			txInfo->out_skb = skb;
+		}
+
+	}
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+	/* go normal sw tx vlan path , FIXME  is real need  skb_cloned(skb) ?? */
+	if (tx_vlan_process(dev, &cp->vlan_setting, skb, 0)) {
+		cp->net_stats.tx_dropped++;
+		dev_kfree_skb_any(skb);
+		return FAILED;
+	}
+	return SUCCESS;
+#endif
+
+	/* if((skb->data[0]&1) ||((skb->data[0]==0x33) &&(skb->data[1]==0x33) && (skb->data[2]!=0xFF))) */
+	{
+		if (skb->tag.f.tpid == htons(ETH_P_8021Q)) {
+			vid = ntohs(skb->tag.f.pci & 0xfff);
+			for (i = 0; i < PORT_NUMBER; i++) {
+				temp = (i == 0) ? i : (i - 1);
+				if ((((struct dev_priv *)NETDRV_PRIV(skb->
+								dev))->
+						portmask & (0x1 << temp))
+					&& (vid ==
+						hw_vlan_info[i].vlan_port_vid)
+					&& (hw_vlan_info[i].vlan_port_bridge ==
+						1)
+					&& (hw_vlan_info[i].vlan_port_tag)
+					&& (hw_vlan_info[i].
+						vlan_port_enabled)) {
+					flag = 1;
+					break;
+				}
+			}
+
+			if (flag) {
+				/* printk("dev name is %s, portmask is 0x%x, i is %d, vid is %d\n", skb->dev->name, ((struct dev_priv*)NETDRV_PRIV(skb->dev))->portmask, i, vid); */
+				adding_tag = &skb->tag;
+			}
+		} else {
+			for (i = 0; i < PORT_NUMBER; i++) {
+				if (((struct dev_priv *)NETDRV_PRIV(skb->dev))->
+					portmask & (0x1 << i)) {
+					flag = 1;
+					break;
+				}
+			}
+			temp = (i == 0) ? i : (i + 1);
+			if ((flag) && (hw_vlan_info[temp].vlan_port_bridge == 1)
+				&& (hw_vlan_info[temp].vlan_port_tag)
+				&& (hw_vlan_info[temp].vlan_port_enabled)) {
+				port_tag.f.tpid = htons(ETH_P_8021Q);
+				port_tag.f.pci =
+					(unsigned short)((0x3 << 13) | (0x1 <<
+						12) | ((unsigned
+							short)(hw_vlan_info
+							[temp].
+							vlan_port_vid &
+							0xfff)));
+				port_tag.f.pci = htons(port_tag.f.pci);
+				adding_tag = &port_tag;
+			}
+		}
+
+		if (adding_tag != NULL) {
+			memcpy(&tag, skb->data + ETH_ALEN * 2, VLAN_HLEN);
+			if (tag.f.tpid != htons(ETH_P_8021Q)) {	/* tag not existed, insert tag */
+				if (skb_headroom(skb) < VLAN_HLEN
+					&& skb_cow(skb, VLAN_HLEN) != 0) {
+					printk("%s-%d: error! (skb_headroom(skb) == %d < 4). Enlarge it!\n", __FUNCTION__, __LINE__, skb_headroom(skb));
+					while (1);
+				}
+				skb_push(skb, VLAN_HLEN);
+				memmove(skb->data, skb->data + VLAN_HLEN,
+					ETH_ALEN * 2);
+			}
+
+			memcpy(skb->data + ETH_ALEN * 2, adding_tag, VLAN_HLEN);
+		}
+
+	}
+
+	return SUCCESS;
+
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtl_hw_vlan_support_read(struct seq_file *s, void *v)
+{
+	int i;
+	seq_printf(s, "rtl_hw_vlan_enable: %d\n", rtl_hw_vlan_enable);
+	for (i = 0; i < PORT_NUMBER; i++) {
+		if (i == 1)
+			continue;
+
+		seq_printf(s,
+			"lan_%d_bridge_enabled: %d, lan_%d_bridge: %d, lan_%d_tag: %d, lan_%d_vid: %d\n",
+			((i == 0) ? i : i - 1),
+			hw_vlan_info[i].vlan_port_enabled,
+			((i == 0) ? i : i - 1),
+			hw_vlan_info[i].vlan_port_bridge,
+			((i == 0) ? i : i - 1), hw_vlan_info[i].vlan_port_tag,
+			((i == 0) ? i : i - 1), hw_vlan_info[i].vlan_port_vid);
+	}
+
+	seq_printf(s,
+		"wan_port_enabled: %d, wan_port_tag: %d, wan_port_vid: %d\n",
+		hw_vlan_info[1].vlan_port_enabled,
+		hw_vlan_info[1].vlan_port_tag, hw_vlan_info[1].vlan_port_vid);
+
+	return 0;
+}
+#else
+static int32 rtl_hw_vlan_support_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	int i;
+
+	len = sprintf(page, "rtl_hw_vlan_enable: %d\n", rtl_hw_vlan_enable);
+	for (i = 0; i < PORT_NUMBER; i++) {
+		if (i == 1)
+			continue;
+
+		len += sprintf(page + len,
+			"lan_%d_bridge_enabled: %d, lan_%d_bridge: %d, lan_%d_tag: %d, lan_%d_vid: %d\n",
+			((i == 0) ? i : i - 1),
+			hw_vlan_info[i].vlan_port_enabled,
+			((i == 0) ? i : i - 1),
+			hw_vlan_info[i].vlan_port_bridge,
+			((i == 0) ? i : i - 1), hw_vlan_info[i].vlan_port_tag,
+			((i == 0) ? i : i - 1), hw_vlan_info[i].vlan_port_vid);
+	}
+
+	len += sprintf(page + len,
+		"wan_port_enabled: %d, wan_port_tag: %d, wan_port_vid: %d\n",
+		hw_vlan_info[1].vlan_port_enabled,
+		hw_vlan_info[1].vlan_port_tag, hw_vlan_info[1].vlan_port_vid);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+	return len;
+}
+#endif
+
+static int32 rtl_hw_vlan_config(void)
+{
+	int lan_portmask = 0;
+	int i = 0;
+	int j = 0;
+	int bridge_num = 0;
+	struct net_device *dev;
+	struct dev_priv *dp;
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+	int mc_tag = 0;
+#endif
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+	rtl_config_vlanconfig(rtl865x_curOpMode);
+#else
+	rtl_config_rtkVlan_vlanconfig(rtl865x_curOpMode);
+#endif
+
+	/*get rid of port who bridge with wan from RTL_LANPORT_MASK */
+	if (rtl_hw_vlan_enable && (rtl865x_curOpMode == GATEWAY_MODE)) {
+		lan_portmask = RTL_LANPORT_MASK;
+
+		if ((hw_vlan_info[0].vlan_port_enabled == 1)
+			&& (hw_vlan_info[0].vlan_port_bridge == 1))
+			lan_portmask &= ~RTL_LANPORT_MASK_4;	/* port0 is bridge, so port0 need to get out of lan_port_mask */
+		if ((hw_vlan_info[2].vlan_port_enabled == 1)
+			&& (hw_vlan_info[2].vlan_port_bridge == 1))
+			lan_portmask &= ~RTL_LANPORT_MASK_3;
+		if ((hw_vlan_info[3].vlan_port_enabled == 1)
+			&& (hw_vlan_info[3].vlan_port_bridge == 1))
+			lan_portmask &= ~RTL_LANPORT_MASK_2;
+		if ((hw_vlan_info[4].vlan_port_enabled == 1)
+			&& (hw_vlan_info[4].vlan_port_bridge == 1))
+			lan_portmask &= ~RTL_LANPORT_MASK_1;
+
+		vlanconfig[0].memPort = lan_portmask;
+		vlanconfig[0].vid = RTL_LANVLANID;
+		vlanconfig[0].untagSet = lan_portmask;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = lan_portmask;	/* eth0 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id =
+			RTL_LANVLANID;
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+		rtl_set_nat_vlan_info(10, 0);	/* reset default nat vid */
+		for (i = 0; i < PORT_NUMBER; i++) {
+			if (i == 1)	/*bypass eth1 */
+				continue;
+			/* find any NAT group then update NAT group vlan info */
+			if (hw_vlan_info[i].vlan_port_enabled == 1
+				&& hw_vlan_info[i].vlan_port_bridge ==
+				FW_NAT_VLAN)
+				rtl_set_nat_vlan_info(hw_vlan_info[i].
+					vlan_port_vid,
+					hw_vlan_info[i].vlan_port_tag);
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT	/* mark_hwv */
+			/* check mc vlan is tag or not */
+			if (hw_vlan_info[i].vlan_port_enabled == 1
+				&& hw_vlan_info[i].vlan_port_bridge ==
+				FW_BRIDGE_VLAN)
+				if ((RTK_MC_VLANID != 0)
+					&& (hw_vlan_info[i].vlan_port_vid ==
+						RTK_MC_VLANID)
+					&& (hw_vlan_info[i].vlan_port_tag == 1))
+					mc_tag = 1;
+#endif
+		}
+		rtl_update_lan_cp_vinfo((struct dev_priv *)
+			NETDRV_PRIV(_rtl86xx_dev.dev[0]), 1, RTK_NAT_VLANID,
+			FW_NAT_VLAN, RTK_NAT_WAN_TAGGED);
+#endif
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+		vlanconfig[1].vid = RTK_NAT_VLANID;
+#else
+		vlanconfig[1].vid = hw_vlan_info[1].vlan_port_vid;
+#endif
+		vlanconfig[1].memPort = RTL_WANPORT_MASK;
+		vlanconfig[1].untagSet = 0;	/* need tag */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = RTL_WANPORT_MASK;	/* eth1 */
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = vlanconfig[1].vid;	/* eth1 */
+
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+		/* always sync with NAT froup  WAN/LAN */
+		rtl_update_wan_cp_vinfo((struct dev_priv *)
+			NETDRV_PRIV(_rtl86xx_dev.dev[1]), 1, RTK_NAT_VLANID,
+			RTK_NAT_WAN_TAGGED);
+		/* p4 (or CPU port) setting is chaged to used by Management vlan */
+		if (hw_vlan_info[1].vlan_port_enabled)
+			rtl_update_manage_vlan(hw_vlan_info[1].
+				vlan_port_enabled,
+				hw_vlan_info[1].vlan_port_vid,
+				hw_vlan_info[1].vlan_port_tag);
+		else
+			rtl_update_manage_vlan(hw_vlan_info[1].
+				vlan_port_enabled, RTK_NAT_VLANID,
+				RTK_NAT_WAN_TAGGED);
+#endif
+		for (i = 0; i < PORT_NUMBER; i++) {
+			if (i == 1)	/*bypass eth1 */
+				continue;
+
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+			if (i > (PORT_NUMBER - 2))
+				continue;
+#endif
+			if ((hw_vlan_info[i].vlan_port_enabled == 1)
+				&& (hw_vlan_info[i].vlan_port_bridge == 1)) {
+				if (i == 0) {
+#if 0
+					vlanconfig[2 + bridge_num].memPort =
+						1 << i;
+#else
+					vlanconfig[2 + bridge_num].memPort =
+						RTL_LANPORT_MASK_4;
+#endif
+					vlanconfig[2 + bridge_num].vid =
+						hw_vlan_info[i].vlan_port_vid;
+#if 0
+					vlanconfig[2 + bridge_num].untagSet =
+						1 << i;
+#else
+					vlanconfig[2 + bridge_num].untagSet =
+						RTL_LANPORT_MASK_4;
+#endif
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+					vlanconfig[2 + bridge_num].memPort |=
+						RTL_WANPORT_MASK;
+					if (hw_vlan_info[i].vlan_port_tag == 0) {
+						/* if(!RTK_NAT_WAN_TAGGED) //if nat Wab also untagged , then  set this brigge port to Wan vlan. //mark_rus */
+						/* vlanconfig[2+bridge_num].vid = RTK_NAT_VLANID; */
+						/* else if (mc_tag == 0) // untag bridge vlan always belong to MC vlan group */
+						if ((RTK_MC_VLANID != 0) && (mc_tag == 0))	/* untag bridge vlan always belong to MC vlan group */
+						{
+							vlanconfig[2 + bridge_num].vid = RTK_MC_VLANID;	/* mark_hwv */
+							hw_vlan_info[i].vlan_port_vid = RTK_MC_VLANID;	/* update vid if this untag bridge is not MC vlan */
+						}
+					}
+					rtl_update_lan_cp_vinfo(((struct
+								dev_priv *)
+							NETDRV_PRIV
+							(_rtl86xx_dev.dev[2 +
+									bridge_num])),
+						1,
+						vlanconfig[2 + bridge_num].vid,
+						FW_BRIDGE_VLAN,
+						hw_vlan_info[i].vlan_port_tag);
+#endif
+					((struct dev_priv *)
+						NETDRV_PRIV(_rtl86xx_dev.dev[2 +
+								bridge_num]))->
+						portmask = 1 << i;
+					((struct dev_priv *)
+						NETDRV_PRIV(_rtl86xx_dev.dev[2 +
+								bridge_num]))->
+						id =
+						vlanconfig[2 + bridge_num].vid;
+					bridge_num++;
+				} else {
+#if 0
+					vlanconfig[2 + bridge_num].memPort =
+						1 << (i - 1);
+#else
+					vlanconfig[2 + bridge_num].memPort =
+						((i == 2) ? RTL_LANPORT_MASK_3
+						: ((i == 3) ? RTL_LANPORT_MASK_2
+							: ((i == 4) ?
+								RTL_LANPORT_MASK_1
+								: 0)));
+#endif
+					vlanconfig[2 + bridge_num].vid =
+						hw_vlan_info[i].vlan_port_vid;
+#if 0
+					vlanconfig[2 + bridge_num].untagSet =
+						1 << (i - 1);
+#else
+					vlanconfig[2 + bridge_num].untagSet =
+						((i == 2) ? RTL_LANPORT_MASK_3
+						: ((i == 3) ? RTL_LANPORT_MASK_2
+							: ((i == 4) ?
+								RTL_LANPORT_MASK_1
+								: 0)));
+#endif
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+					vlanconfig[2 + bridge_num].memPort |=
+						RTL_WANPORT_MASK;
+					if (hw_vlan_info[i].vlan_port_tag == 0) {
+						/* if(!RTK_NAT_WAN_TAGGED) //if nat Wab also untagged , then  set this brigge port to Wan vlan. //mark_rus */
+						/* vlanconfig[2+bridge_num].vid = RTK_NAT_VLANID; */
+						/* else if (mc_tag == 0) // untag bridge vlan always belong to MC vlan group */
+						if ((RTK_MC_VLANID != 0) && (mc_tag == 0))	/* untag bridge vlan always belong to MC vlan group */
+						{
+							vlanconfig[2 +
+								bridge_num].
+								vid =
+								RTK_MC_VLANID;
+							hw_vlan_info[i].vlan_port_vid = RTK_MC_VLANID;	/* update vid if this untag bridge is not MC vlan */
+						}
+					}
+					rtl_update_lan_cp_vinfo(((struct
+								dev_priv *)
+							NETDRV_PRIV
+							(_rtl86xx_dev.dev[2 +
+									bridge_num])),
+						1,
+						vlanconfig[2 + bridge_num].vid,
+						FW_BRIDGE_VLAN,
+						hw_vlan_info[i].vlan_port_tag);
+#endif
+					((struct dev_priv *)
+						NETDRV_PRIV(_rtl86xx_dev.dev[2 +
+								bridge_num]))->
+						portmask = 1 << (i - 1);
+					((struct dev_priv *)
+						NETDRV_PRIV(_rtl86xx_dev.dev[2 +
+								bridge_num]))->
+						id =
+						vlanconfig[2 + bridge_num].vid;
+					bridge_num++;
+				}
+			}
+		}
+		/* PPPOE */
+		vlanconfig[VLAN_CONFIG_PPPOE_INDEX].vid = vlanconfig[1].vid;	/* mark_hwv */
+		/* panic_printk("%s %d vlanconfig[5].vid=%d vlanconfig[5].ifname=%s \n", __FUNCTION__, __LINE__, vlanconfig[5].vid, vlanconfig[5].ifname); */
+	}
+
+	re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+
+	rtl_reinit_hw_table();
+	reinit_vlan_configure(packedVlanConfig);
+
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+#ifdef RTK_CPU_FC_DISABLE
+	{
+		unsigned int val;
+		val = REG32(0xbb8045d4);
+		/* printk("cpu port queue fc register= %x\n",val); //mark_fc */
+		val = val & ~(0x003f0000);	/* 16~21 bit to disable cpu queue fc */
+		REG32(0xbb8045d4) = val;
+		printk("new cpu port queue fc register= %x\n", val);	/* mark_fc */
+	}
+#endif
+#ifdef CONFIG_RTL_8367R_SUPPORT	/* mark_8367 */
+	rtk_vlan_init();
+	rtk_stat_global_reset();
+	if (!rtl_hw_vlan_enable)
+		RTL8367R_vlan_set();
+#endif
+	/* unknow vlan enabled */
+	if (rtl_hw_vlan_enable && (rtl865x_curOpMode == GATEWAY_MODE)) {
+		int vlan_num = 0;
+		int32 totalVlans =
+			((sizeof(vlanconfig)) /
+			(sizeof(struct rtl865x_vlanConfig))) - 2;
+		vlan_num = rtl_get_vlan_num(packedVlanConfig);
+		/* update cp portmask to real vlan portmask */
+		for (i = 0; i < vlan_num; i++) {
+			dev = (struct net_device *)_rtl86xx_dev.dev[i];
+			if (!dev)
+				continue;
+			dp = NETDRV_PRIV(dev);
+			if (!dp)
+				continue;
+			dp->id = packedVlanConfig[i].vid;
+			dp->portmask = (packedVlanConfig[i].memPort) & 0x3f;
+
+			printk("cp i = %d , vid =%d, portmask=0x%x vlan_num=%d \n", i, dp->id, dp->portmask, vlan_num);
+		}
+
+		REG32(SWTCR0) |= EnUkVIDtoCPU;	/* important for manage vlan */
+
+		/* clear otjer cp */
+		for (i = vlan_num; i < totalVlans; i++)	/* mark_hwv ,  pp case? */
+		{
+			dev = (struct net_device *)_rtl86xx_dev.dev[i];
+			if (!dev)
+				continue;
+			dp = NETDRV_PRIV(dev);
+			if (!dp)
+				continue;
+			dp->id = 0;
+			dp->portmask = 0;
+		}
+#ifdef CONFIG_RTL_8367R_SUPPORT	/* mark_8367 */
+		rtk_8367_vlan_mapping();
+		rtl865x_enableRtl8367ToCpuAcl();
+#endif
+	}
+#endif
+	/* unknow vlan drop */
+	/* REG32(SWTCR0) &= ~(1 << 15); */
+
+	/*update dev port number */
+	for (i = 0; vlanconfig[i].vid != 0; i++) {
+		if (IF_ETHER != vlanconfig[i].if_type) {
+			continue;
+		}
+
+		dev = _rtl86xx_dev.dev[i];
+		if (!dev)
+			continue;
+		dp = NETDRV_PRIV(dev);
+		if (!dp)
+			continue;
+		dp->portnum = 0;
+		for (j = 0; j < RTL8651_AGGREGATOR_NUMBER; j++) {
+			if (dp->portmask & (1 << j))
+				dp->portnum++;
+		}
+
+	}
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+	re865x_reInitIgmpSetting(rtl865x_curOpMode);
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	if (mldSnoopEnabled && (rtk_vlan_support_enable == 0)) {
+		re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+		rtl865x_addAclForMldSnooping(packedVlanConfig);
+	}
+#endif
+#if  defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	if (igmpsnoopenabled) {
+		rtl_processAclForIgmpSnooping(igmpsnoopenabled);
+	}
+#endif
+#endif
+
+#if (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_IPV6READYLOGO)
+	{
+		rtl865x_addAclForIPV6ReadyLogo(packedVlanConfig);
+	}
+#endif
+
+#if defined(CONFIG_RTL_HTTP_REDIRECT_LOCAL)
+	rtl865x_removeAclForHttpRedirect(packedVlanConfig);
+	rtl865x_addAclForHttpRedirect(packedVlanConfig);
+#endif
+
+#if defined(CONFIG_RTL_DNS_TRAP)
+	rtl_remove_Acl_for_dns_trap(packedVlanConfig);
+	rtl_add_Acl_for_dns_trap(packedVlanConfig);
+#endif
+	/* always init the default route... */
+	if (rtl8651_getAsicOperationLayer() > 2) {
+		rtl865x_addRoute(0, 0, 0, RTL_DRV_WAN0_NETIF_NAME, 0);
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+		{
+			inv6_addr_t ipAddr, nexthop;
+			memset(&ipAddr, 0, sizeof(inv6_addr_t));
+			memset(&nexthop, 0, sizeof(inv6_addr_t));
+
+			rtl8198c_addIpv6Route(ipAddr, 0, nexthop,
+				RTL_DRV_WAN0_NETIF_NAME);
+		}
+#endif
+	}
+
+	rtl8651_setAsicMulticastEnable(TRUE);
+
+	return 0;
+}
+
+static int32 rtl_hw_vlan_support_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[100];
+	int num = 0;
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		num = sscanf(tmpbuf,
+			"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
+			&rtl_hw_vlan_enable, &hw_vlan_info[1].vlan_port_enabled,
+			&hw_vlan_info[1].vlan_port_tag,
+			&hw_vlan_info[1].vlan_port_vid,
+			&hw_vlan_info[0].vlan_port_enabled,
+			&hw_vlan_info[0].vlan_port_bridge,
+			&hw_vlan_info[0].vlan_port_tag,
+			&hw_vlan_info[0].vlan_port_vid,
+			&hw_vlan_info[2].vlan_port_enabled,
+			&hw_vlan_info[2].vlan_port_bridge,
+			&hw_vlan_info[2].vlan_port_tag,
+			&hw_vlan_info[2].vlan_port_vid,
+			&hw_vlan_info[3].vlan_port_enabled,
+			&hw_vlan_info[3].vlan_port_bridge,
+			&hw_vlan_info[3].vlan_port_tag,
+			&hw_vlan_info[3].vlan_port_vid,
+			&hw_vlan_info[4].vlan_port_enabled,
+			&hw_vlan_info[4].vlan_port_bridge,
+			&hw_vlan_info[4].vlan_port_tag,
+			&hw_vlan_info[4].vlan_port_vid);
+
+		if (num != 20) {
+			printk("invalid rtl_hw_vlan_support_write parameter!\n");
+			return len;
+		}
+
+		rtl_hw_vlan_config();
+
+	}
+	return len;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtl_hw_vlan_tagged_bridge_multicast_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s %d\n", "rtl_hw_vlan_tagged_mc:",
+		rtl_hw_vlan_ignore_tagged_mc);
+	return 0;
+}
+#else
+static int32 rtl_hw_vlan_tagged_bridge_multicast_read(char *page, char **start,
+	off_t off, int count, int *eof, void *data)
+{
+	int len;
+	len = sprintf(page, "%s %d\n", "rtl_hw_vlan_tagged_mc:",
+		rtl_hw_vlan_ignore_tagged_mc);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int32 rtl_hw_vlan_tagged_bridge_multicast_write(struct file *filp,
+	const char *buff, unsigned long len, void *data)
+{
+	char tmpbuf[32];
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+
+		rtl_hw_vlan_ignore_tagged_mc = tmpbuf[0] - '0';
+	}
+	return len;
+}
+
+#ifdef RTK_MANAGE_VLAN_IF
+void rtk_add_manage_vlan(void)
+{
+	struct dev_priv *cp;
+
+	if (!wan_management_vlan.vlan)	/* manage vlan disable */
+		return;
+
+	if (!manage_vlan_dev) {
+		printk("manage_vlan_dev not exist\n");
+		return;
+	}
+	cp = (struct dev_priv *)NETDRV_PRIV(manage_vlan_dev);
+
+	if (cp->vlan_setting.vlan) {
+		rtl865x_addVlan(cp->vlan_setting.id);
+		/* add cpu port and wan port */
+		rtl865x_addVlanPortMember(cp->vlan_setting.id,
+			(1 << RTK_WAN_PORT_IDX) | RTL_CPUPORT_MASK);
+		if (cp->vlan_setting.tag)
+			rtl865x_setVlanPortTag(cp->vlan_setting.id,
+				(1 << RTK_WAN_PORT_IDX) | RTL_CPUPORT_MASK, 1);
+		else
+			rtl865x_setVlanPortTag(cp->vlan_setting.id, (1 << RTK_WAN_PORT_IDX), 0);	/* set Wan port untag */
+		/* P4 PVID ? ,mark_manv */
+		rtl865x_setVlanFilterDatabase(cp->vlan_setting.id, 1);	/* fid to 1 , wan vlan? */
+	}
+}
+
+struct net_device *rtk_add_vlan_if(uint32 vid, uint32 memPort, char *name)
+{
+	struct net_device *dev;
+	struct dev_priv *dp;
+	int rc, j;
+
+	dev = alloc_etherdev(sizeof(struct dev_priv));
+	if (!dev) {
+		printk("failed to allocate dev (rtk_add_vlan_if)\n");
+		return NULL;
+	}
+	SET_MODULE_OWNER(dev);
+	dp = NETDRV_PRIV(dev);
+	memset(dp, 0, sizeof(*dp));
+	dp->dev = dev;
+	dp->id = vid;
+	dp->portmask = memPort;
+	dp->portnum = 0;
+
+	for (j = 0; j < RTL8651_AGGREGATOR_NUMBER; j++) {
+		if (dp->portmask & (1 << j))
+			dp->portnum++;
+	}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	memcpy((char *)dev->dev_addr, (char *)(&(vlanconfig[RTL_WAN_IDX].mac)), ETHER_ADDR_LEN);	/* mark_manv */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	memcpy((char *)dev->dev_addr, (char *)(&(vlanconfig[1].mac)), ETHER_ADDR_LEN);	/* mark_manv */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	strcpy(dev->name, name);
+#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+	dev->open = re865x_open;
+	dev->stop = re865x_close;
+	dev->set_multicast_list = re865x_set_rx_mode;
+	dev->hard_start_xmit = re865x_start_xmit;
+	dev->get_stats = re865x_get_stats;
+	dev->do_ioctl = re865x_ioctl;
+	dev->tx_timeout = re865x_tx_timeout;
+	dev->set_mac_address = rtl865x_set_hwaddr;
+	dev->change_mtu = rtl865x_set_mtu;
+#else
+	dev->netdev_ops = &rtl819x_netdev_ops;
+#endif
+	dev->watchdog_timeo = TX_TIMEOUT;
+
+	dev->irq = BSP_SWCORE_IRQ;
+	rc = register_netdev(dev);
+
+	if (!rc) {
+		/* _rtl86xx_dev.dev[i]=dev; */
+		rtl_add_ps_drv_netif_mapping(dev, name);
+		return (struct net_device *)dev;
+		/* rtlglue_printf("eth%d added. vid=%d Member port 0x%x...\n", i,vlanconfig[i].vid ,vlanconfig[i].memPort ); */
+	} else
+		rtlglue_printf("Failed to allocate %s", name);
+
+	return NULL;
+}
+
+static void rtk_add_manage_vlan_dev(uint32 vid)
+{
+	uint32 portmask = 0x3f & (1 << RTK_WAN_PORT_IDX);
+	manage_vlan_dev =
+		(struct net_device *)rtk_add_vlan_if(vid, portmask,
+		RTK_MANAGE_IFNAME);
+}
+
+#endif
+
+struct net_device *rtl_get_man_dev(void)
+{
+#ifdef RTK_MANAGE_VLAN_IF
+	if (!wan_management_vlan.vlan)	/* manage vlan disable */
+		return NULL;
+	if (manage_vlan_dev)
+		return (struct net_device *)manage_vlan_dev;
+#endif
+	return NULL;
+}
+
+struct vlan_info *rtl_get_man_vlaninfo(void)
+{
+
+#ifdef RTK_MANAGE_VLAN_IF
+	struct dev_priv *cp;
+
+	if (!wan_management_vlan.vlan)	/* manage vlan disable */
+		return NULL;
+
+	if (manage_vlan_dev) {
+		cp = ((struct dev_priv *)NETDRV_PRIV(manage_vlan_dev));
+		return (struct vlan_info *)&cp->vlan_setting;
+	}
+#endif
+	return NULL;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+
+static unsigned long atoi_dec(char *s)
+{
+	unsigned long k = 0;
+
+	k = 0;
+	while (*s != '\0' && *s >= '0' && *s <= '9') {
+		k = 10 * k + (*s - '0');
+		s++;
+	}
+	return k;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int custom_Passthru_read_proc(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s\n", passThru_flag);
+	return 0;
+}
+#else
+static int custom_Passthru_read_proc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	len = sprintf(page, "%s\n", passThru_flag);
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int custom_createPseudoDevForPassThru(void)
+{
+	struct net_device *dev, *wanDev;
+	struct dev_priv *dp;
+	int rc, i;
+	unsigned long flags = 0;
+#if defined(CONFIG_RTL_REPORT_LINK_STATUS)  ||  defined(CONFIG_RTK_VLAN_SUPPORT)
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+#ifndef CONFIG_RTL_PROC_NEW
+	struct proc_dir_entry *res_stats;
+#endif
+#endif
+	struct proc_dir_entry *res_stats_root;
+#endif
+
+	wanDev = NULL;
+	/*      find wan device first   */
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+		if (!_rtl86xx_dev.dev[i])
+			continue;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		dp = NETDRV_PRIV(_rtl86xx_dev.dev[i]);
+		if (rtl_isWanDev(dp) == TRUE) {
+			wanDev = _rtl86xx_dev.dev[i];
+			break;
+		}
+	}
+
+	/*      can't find any wan device, just return  */
+	if (wanDev == NULL)
+		return -1;
+
+	dev = alloc_etherdev(sizeof(struct dev_priv));
+	if (!dev) {
+		rtlglue_printf("failed to allocate passthru pseudo dev.\n");
+		return -1;
+	}
+	strcpy(dev->name, "peth%d");
+	/*      default set lan side mac                */
+	memcpy((char *)dev->dev_addr, (char *)(&(vlanconfig[0].mac)),
+		ETHER_ADDR_LEN);
+	dp = NETDRV_PRIV(dev);
+	memset(dp, 0, sizeof(*dp));
+	dp->dev = wanDev;
+#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+	dev->open = re865x_pseudo_open;
+	dev->stop = re865x_pseudo_close;
+	dev->set_multicast_list = NULL;
+	dev->hard_start_xmit = re865x_start_xmit;
+	dev->get_stats = re865x_get_stats;
+	dev->do_ioctl = re865x_ioctl;
+#ifdef CP_VLAN_TAG_USED
+	dev->features |= NETIF_F_HW_VLAN_TX | NETIF_F_HW_VLAN_RX;
+	dev->vlan_rx_register = cp_vlan_rx_register;
+	dev->vlan_rx_kill_vid = cp_vlan_rx_kill_vid;
+#endif
+
+#else
+	dev->netdev_ops = &rtl819x_pseudodev_ops;
+#endif
+
+#ifdef CP_VLAN_TAG_USED
+	dev->features |= NETIF_F_HW_VLAN_TX | NETIF_F_HW_VLAN_RX;
+#endif
+	dev->watchdog_timeo = TX_TIMEOUT;
+
+	dev->irq = 0;
+	rc = register_netdev(dev);
+	if (!rc) {
+		SMP_LOCK_ETH(flags);
+		/* spin_lock_irqsave(&_rtl86xx_dev.lock, flags); */
+		_rtl86xx_dev.pdev = dev;
+		/* spin_unlock_irqrestore(&_rtl86xx_dev.lock, flags); */
+		SMP_UNLOCK_ETH(flags);
+		rtlglue_printf("[%s] added, mapping to [%s]...\n", dev->name,
+			dp->dev->name);
+	} else
+		rtlglue_printf("Failed to allocate [%s]\n", dev->name);
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_REPORT_LINK_STATUS)
+#ifdef CONFIG_RTL_PROC_NEW
+	res_stats_root = proc_mkdir(dev->name, &proc_root);
+#else
+	res_stats_root = proc_mkdir(dev->name, NULL);
+#endif
+	if (res_stats_root == NULL) {
+		printk("proc_mkdir failed!\n");
+	}
+#endif
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("mib_vlan", 0644, res_stats_root, &mib_vlan_proc_fops,
+		(void *)dev);
+#else
+	if ((res_stats = create_proc_read_entry("mib_vlan", 0644,
+				res_stats_root, read_proc_vlan,
+				(void *)dev)) == NULL) {
+		printk("create_proc_read_entry failed!\n");
+	}
+	res_stats->write_proc = write_proc_vlan;
+#endif
+
+#endif
+	return 0;
+}
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+
+extern int rtl8367_setProtocolBasedVLAN(uint32 proto_type, uint32 cvid,
+	int cmdFlag);
+#endif
+
+static int custom_Passthru_write_proc(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	int flag, i;
+#ifdef CONFIG_RTL_8367R_SUPPORT
+	int cmdFlag = 0;
+#endif
+
+#if	!defined(CONFIG_RTL_LAYERED_DRIVER)
+	struct rtl865x_vlanConfig passThruVlanConf =
+		{ "passThru", 0, IF_ETHER, PASSTHRU_VLAN_ID, 0,
+		rtl865x_lanPortMask | rtl865x_wanPortMask,
+		rtl865x_lanPortMask | rtl865x_wanPortMask,
+		1500, { { 0x00, 0x12, 0x34, 0x56, 0x78, 0x90 } } };
+#endif
+
+	if (buffer && !copy_from_user(&passThru_flag, buffer, count)) {
+		flag = (int)atoi_dec(passThru_flag);
+
+		if (flag ^ oldStatus) {
+			/* IPv6 PassThru */
+			if ((flag & IP6_PASSTHRU_MASK) ^ (oldStatus &
+					IP6_PASSTHRU_MASK)) {
+				if (flag & IP6_PASSTHRU_MASK) {	/* add */
+					for (i = 0; i < RTL865XC_PORT_NUMBER;
+						i++) {
+						rtl8651_setProtocolBasedVLAN
+							(IP6_PASSTHRU_RULEID, i,
+							TRUE, PASSTHRU_VLAN_ID);
+					}
+#ifdef CONFIG_RTL_8367R_SUPPORT
+					cmdFlag = TRUE;
+#endif
+				} else {	/* delete */
+					for (i = 0; i < RTL865XC_PORT_NUMBER;
+						i++) {
+						rtl8651_setProtocolBasedVLAN
+							(IP6_PASSTHRU_RULEID, i,
+							FALSE,
+							PASSTHRU_VLAN_ID);
+					}
+#ifdef CONFIG_RTL_8367R_SUPPORT
+					cmdFlag = FALSE;
+#endif
+				}
+#ifdef CONFIG_RTL_8367R_SUPPORT
+				rtl8367_setProtocolBasedVLAN(ETH_P_IPV6,
+					PASSTHRU_VLAN_ID, cmdFlag);
+#endif
+			}
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU_PPPOE)
+			/* PPPoE PassThru */
+			if ((flag & PPPOE_PASSTHRU_MASK) ^ (oldStatus &
+					PPPOE_PASSTHRU_MASK)) {
+				if (flag & PPPOE_PASSTHRU_MASK) {	/* add */
+					for (i = 0; i < RTL865XC_PORT_NUMBER;
+						i++) {
+						rtl8651_setProtocolBasedVLAN
+							(RTL8651_PBV_RULE_PPPOE_CONTROL,
+							i, TRUE,
+							PASSTHRU_VLAN_ID);
+						rtl8651_setProtocolBasedVLAN
+							(RTL8651_PBV_RULE_PPPOE_SESSION,
+							i, TRUE,
+							PASSTHRU_VLAN_ID);
+					}
+#ifdef CONFIG_RTL_8367R_SUPPORT
+					cmdFlag = TRUE;
+#endif
+				} else {	/* delete */
+					for (i = 0; i < RTL865XC_PORT_NUMBER;
+						i++) {
+						rtl8651_setProtocolBasedVLAN
+							(RTL8651_PBV_RULE_PPPOE_CONTROL,
+							i, FALSE,
+							PASSTHRU_VLAN_ID);
+						rtl8651_setProtocolBasedVLAN
+							(RTL8651_PBV_RULE_PPPOE_SESSION,
+							i, FALSE,
+							PASSTHRU_VLAN_ID);
+					}
+#ifdef CONFIG_RTL_8367R_SUPPORT
+					cmdFlag = FALSE;
+#endif
+				}
+#ifdef CONFIG_RTL_8367R_SUPPORT
+				rtl8367_setProtocolBasedVLAN(ETH_P_PPP_SES,
+					PASSTHRU_VLAN_ID, cmdFlag);
+				rtl8367_setProtocolBasedVLAN(ETH_P_PPP_DISC,
+					PASSTHRU_VLAN_ID, cmdFlag);
+#endif
+			}
+#endif
+		}
+		/* passthru vlan */
+		if (flag == 0) {
+			/* To del passthru vlan */
+			/* Do nothing here because change_op_mode reinit vlan already */
+		} else {
+			/* To add passthru vlan */
+			rtl865x_addVlan(PASSTHRU_VLAN_ID);
+#if defined(CONFIG_POCKET_ROUTER_SUPPORT)
+			rtl865x_addVlanPortMember(PASSTHRU_VLAN_ID,
+				rtl865x_lanPortMask | rtl865x_wanPortMask |
+				0x100);
+#else
+			rtl865x_addVlanPortMember(PASSTHRU_VLAN_ID,
+				rtl865x_lanPortMask | rtl865x_wanPortMask);
+#endif
+		}
+
+		oldStatus = flag;
+		return count;
+	}
+	return -EFAULT;
+}
+
+#ifndef CONFIG_RTL_PROC_NEW
+static struct proc_dir_entry *res = NULL;
+#endif
+
+static int32 rtl8651_customPassthru_init(void)
+{
+	oldStatus = 0;
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("custom_Passthru", 0, &proc_root,
+		&custom_Passthru_proc_fops, NULL);
+#else
+	res = create_proc_entry("custom_Passthru", 0, NULL);
+	if (res) {
+		res->read_proc = custom_Passthru_read_proc;
+		res->write_proc = custom_Passthru_write_proc;
+	}
+#endif
+	rtl8651_defineProtocolBasedVLAN(IP6_PASSTHRU_RULEID, 0x0, ETH_P_IPV6);
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU_PPPOE)
+	rtl8651_defineProtocolBasedVLAN(PPPOE_PASSTHRU_RULEID1, 0x0,
+		__constant_htons(ETH_P_PPP_SES));
+	rtl8651_defineProtocolBasedVLAN(PPPOE_PASSTHRU_RULEID2, 0x0,
+		__constant_htons(ETH_P_PPP_DISC));
+#endif
+	custom_createPseudoDevForPassThru();
+	return 0;
+}
+
+static void __exit rtl8651_customPassthru_exit(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("custom_Passthru", &proc_root);
+#else
+	if (res) {
+		remove_proc_entry("custom_Passthru", res);
+		res = NULL;
+	}
+#endif
+}
+#endif
+
+#define	MULTICAST_STORM_CONTROL	1
+#define	BROADCAST_STORM_CONTROL	2
+#if defined(CONFIG_RTL_8197F)
+#define UNKNOWN_UNICAST_STORM_CONTROL 1
+#define UNKNOWN_MULTICAST_SOTRM_CONTROL 2
+#define ARP_STORM_CONTROL 4
+#define DHCP_STORM_CONTROL 8
+#define IGMP_MLD_STORM_CONTROL 16
+#define UNKOWN_UNICAST_COUNTER 0
+#define UNKOWN_MULTICAST_COUNTER 1
+#define ARP_COUNTER 2
+#define DHCP_COUNTER 3
+#define IGMP_MLD_COUNTER 3
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtl865x_stormCtrlReadProc(struct seq_file *s, void *v)
+{
+	return 0;
+}
+#else
+static struct proc_dir_entry *stormCtrlProc = NULL;
+static int rtl865x_stormCtrlReadProc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int rtl865x_stormCtrlWriteProc(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	char tmpBuf[128];
+	uint32 stormCtrlType = MULTICAST_STORM_CONTROL;
+	uint32 enableStormCtrl = FALSE;
+	uint32 percentage = 0;
+	uint32 uintVal;
+	char *strptr = NULL, *tokptr = NULL;
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count))
+	{
+		tmpBuf[count-1]=0;
+		strptr = tmpBuf;
+		tokptr = strsep(&strptr," ");
+		//uintVal=simple_strtol((const char *)tmpBuf, NULL, 0);
+		//printk("%s(%d),tmpBuf=%s,count=%d,uintVal=%d\n",__FUNCTION__,__LINE__,
+		//	tmpBuf,count,uintVal);//Added for test
+		if(tokptr!=NULL)
+		{
+			uintVal=simple_strtol(tokptr, NULL, 0);
+			tokptr = strsep(&strptr," ");
+			if(tokptr!=NULL)
+				stormCtrlType = simple_strtol(tokptr, NULL, 0);
+
+			if(uintVal>100)
+			{
+				enableStormCtrl=FALSE;
+				percentage=0;
+		}
+			else
+			{
+				enableStormCtrl=TRUE;
+				percentage=uintVal;
+			}
+			printk("type:%d, enable:%d, percent%d\n", stormCtrlType, enableStormCtrl, percentage);
+			rtl865x_setStormControl(stormCtrlType,enableStormCtrl,percentage);
+		}
+		return count;
+	}
+	return -EFAULT;
+}
+
+int32 rtl8651_initStormCtrl(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("StormCtrl", 0, &proc_root, &StormCtrl_proc_fops,
+		NULL);
+#else
+	stormCtrlProc = create_proc_entry("StormCtrl", 0, NULL);
+	if (stormCtrlProc) {
+		stormCtrlProc->read_proc = rtl865x_stormCtrlReadProc;
+		stormCtrlProc->write_proc = rtl865x_stormCtrlWriteProc;
+	}
+#endif
+	//rtl865x_setStormControl(0x3,TRUE,1);
+	return 0;
+}
+
+void __exit rtl8651_exitStormCtrl(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("StormCtrl", &proc_root);
+#else
+	if (stormCtrlProc) {
+		remove_proc_entry("StormCtrl", stormCtrlProc);
+		stormCtrlProc = NULL;
+	}
+#endif
+}
+
+#if 0				/* defined(CONFIG_RTL_8197F) */
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtl865x_extendStormCtrlReadProc(struct seq_file *s, void *v)
+{
+	uint32 regData, regDataCounter;
+	uint32 i;
+	char *str = NULL;
+
+	uint32 timeUnit;
+
+	regDataCounter = READ_MEM32(EXTSTMCR3);
+	regData = READ_MEM32(EXTSTMCR4);
+	timeUnit = (regDataCounter & TUSSCM0) >> TUSSCM0_OFFSET;
+
+	switch (timeUnit) {
+	case 0:
+		str = "25ms";
+		break;
+	case 1:
+		str = "2.5ms";
+		break;
+	case 2:
+		str = "0.25ms";
+		break;
+	case 3:
+		str = "0.5ms";
+		break;
+	default:
+		break;
+	}
+
+	seq_printf(s, "extend storm control setting:\n");
+	seq_printf(s, "counter 0, %s drop, timing unit %s, rate(%d)\n",
+		regDataCounter & ENDROPSC0 ? "enable" : "disable",
+		regDataCounter & ENDROPSC0 ? str : "0",
+		((regData << 16) >> 16) * 100 * 4 / 30360);
+
+#if 0
+	regData = READ_MEM32(EXTSTMCR4);
+	seq_printf(s, "counter 1, %s drop, timing unit %s, rate(%d)\n",
+		regDataCounter & ENDROPSC1 ? "enable" : "disable",
+		regDataCounter & ENDROPSC1 ? str : "0",
+		(regData >> 16) * 100 * 4 / 30360);
+
+	regData = READ_MEM32(EXTSTMCR5);
+	seq_printf(s, "counter 2, %s drop, timing unit %s, rate(%d)\n",
+		regDataCounter & ENDROPSC2 ? "enable" : "disable",
+		regDataCounter & ENDROPSC2 ? str : "0",
+		((regData << 16) >> 16) * 100 * 4 / 30360);
+
+	regData = READ_MEM32(EXTSTMCR5);
+	seq_printf(s, "counter 3, %s drop, timing unit %s, rate(%d)\n\n",
+		regDataCounter & ENDROPSC3 ? "enable" : "disable",
+		regDataCounter & ENDROPSC3 ? str : "0",
+		(regData >> 16) * 100 * 4 / 30360);
+#endif
+
+	for (i = 0; i < RTL8651_PORT_NUMBER; i++) {
+
+		regData = READ_MEM32(EXTSTMCR0 + (i >> 1) * 4);
+
+		if (i & 0x1) {
+			seq_printf(s,
+				"port%d, %s unknown unicast, counter %d\n", i,
+				regData & OUUSCS ? "enable" : "disable",
+				(regData & OPUUSC) >> OPUUSC_OFFSET);
+#if 0
+			seq_printf(s,
+				"port%d, %s unknown multicast, counter %d\n", i,
+				regData & OUMSCS ? "enable" : "disable",
+				(regData & OPUMSC) >> OPUMSC_OFFSET);
+			seq_printf(s, "port%d, %s ARP, counter %d\n", i,
+				regData & OASCS ? "enable" : "disable",
+				(regData & OPASC) >> OPASC_OFFSET);
+			seq_printf(s, "port%d, %s DHCP, counter %d\n", i,
+				regData & ODSCS ? "enable" : "disable",
+				(regData & OPDSC) >> OPDSC_OFFSET);
+			seq_printf(s, "port%d, %s IGMP/MLD, counter %d\n\n", i,
+				regData & OIMSCS ? "enable" : "disable",
+				(regData & OPIMSC) >> OPIMSC_OFFSET);
+#endif
+		} else {
+			seq_printf(s,
+				"port%d, %s unknown unicast, counter %d\n", i,
+				regData & EUUSCS ? "enable" : "disable",
+				(regData & EPUUSC) >> EPUUSC_OFFSET);
+#if 0
+			seq_printf(s,
+				"port%d, %s unknown multicast, counter %d\n", i,
+				regData & EUMSCS ? "enable" : "disable",
+				(regData & EPUMSC) >> EPUMSC_OFFSET);
+			seq_printf(s, "port%d, %s ARP, counter %d\n", i,
+				regData & EASCS ? "enable" : "disable",
+				(regData & EPASC) >> EPASC_OFFSET);
+			seq_printf(s, "port%d, %s DHCP, counter %d\n", i,
+				regData & EDSCS ? "enable" : "disable",
+				(regData & EPDSC) >> EPDSC_OFFSET);
+			seq_printf(s, "port%d, %s IGMP/MLD, counter %d\n\n", i,
+				regData & EIMSCS ? "enable" : "disable",
+				(regData & EPIMSC) >> EPIMSC_OFFSET);
+#endif
+		}
+	}
+
+	return 0;
+}
+#else
+static struct proc_dir_entry *extendStormCtrlProc = NULL;
+static int rtl865x_extendStormCtrlReadProc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int rtl865x_extendStormCtrlWriteProc(struct file *file,
+	const char *buffer, unsigned long count, void *data)
+{
+	/* uint32 tmpBuf[32]; */
+	char tmpBuf[128];
+	uint32 enableStormCtrl = FALSE;
+	uint32 percentage = 0;
+	char *strptr, *tokptr, *endstr = NULL;
+	int32 stormCtrlType = -1;
+	int32 uintVal = -1;
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		/* tmpBuf[count-1]=0; */
+		/* uintVal=simple_strtol((const char *)tmpBuf, NULL, 0); */
+
+		tmpBuf[count - 1] = '\0';
+		/* printk("=====buf: %s\n", tmpBuf); */
+
+		strptr = tmpBuf;
+		tokptr = strsep(&strptr, " ");
+		/* printk("tokptr: %s\n", tokptr); */
+
+		if (!tokptr)
+			goto ESC_ERROR;
+
+		if (!memcmp(tokptr, "type", 4)) {
+			tokptr = strsep(&strptr, " ");
+			if (!tokptr)
+				goto ESC_ERROR;
+
+			if (strcmp(tokptr, "ukn-unicast") == 0) {
+				stormCtrlType = UNKNOWN_UNICAST_STORM_CONTROL;
+			}
+#if 0
+			else if (strcmp(tokptr, "ukn-multicast") == 0) {
+				stormCtrlType = UNKNOWN_MULTICAST_SOTRM_CONTROL;
+			} else if (strcmp(tokptr, "arp") == 0) {
+				stormCtrlType = ARP_STORM_CONTROL;
+			} else if (strcmp(tokptr, "dhcp") == 0) {
+				stormCtrlType = DHCP_STORM_CONTROL;
+			} else if (strcmp(tokptr, "igmp/mld") == 0) {
+				stormCtrlType = IGMP_MLD_STORM_CONTROL;
+			}
+#endif
+			else
+				goto ESC_ERROR;
+		}
+
+		tokptr = strsep(&strptr, " ");
+		if (!tokptr)
+			goto ESC_ERROR;
+
+		if (!memcmp(tokptr, "rate", 4)) {
+			tokptr = strsep(&strptr, " ");
+			uintVal = simple_strtol(tokptr, &endstr, 0);
+			if (strcmp(endstr, "") != 0) {
+				printk("endstr: %s\n", endstr);
+				goto ESC_ERROR;
+			}
+
+			if (uintVal > 100) {
+				enableStormCtrl = FALSE;
+				percentage = 100;
+			} else {
+				enableStormCtrl = TRUE;
+				percentage = uintVal;
+			}
+		}
+
+		rtl865x_setExtendStormControl(stormCtrlType, enableStormCtrl,
+			percentage);
+
+		return count;
+	}
+ESC_ERROR:
+	printk("Invalid params. \n");
+	return -EFAULT;
+
+}
+
+int32 rtl8651_initExtendStormCtrl(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("ExtendStormCtrl", 0, &proc_root,
+		&extendStormCtrl_proc_fops, NULL);
+#else
+	extendStormCtrlProc = create_proc_entry("ExtendStormCtrl", 0, NULL);
+	if (extendStormCtrlProc) {
+		extendStormCtrlProc->read_proc =
+			rtl865x_extendStormCtrlReadProc;
+		extendStormCtrlProc->write_proc =
+			rtl865x_extendStormCtrlWriteProc;
+	}
+#endif
+
+	return 0;
+}
+
+void __exit rtl8651_exitextendStormCtrl(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("ExtendStormCtrl", &proc_root);
+#else
+	if (extendStormCtrlProc) {
+		remove_proc_entry("ExtendStormCtrl", extendStormCtrlProc);
+		extendStormCtrlProc = NULL;
+	}
+#endif
+}
+#endif
+
+#if defined(CONFIG_RTL_WAN_PORT_SETTING)
+static int32 rtl_reinit_hw_table_2(void)
+{
+	/*re-init sequence eventmgr->l4->l3->l2->common is to make sure delete asic entry,
+	 * if not following this sequence,
+	 * some asic entry can't be deleted due to reference count is not zero */
+
+	/*to-do:in each layer reinit function, memset all software entry to zero,
+	 * and force to clear all asic entry of own module,
+	 * then the re-init sequence can be common->l2->l3->l4 */
+	/* FullAndSemiReset should not be called here
+	 * it will make switch core action totally wrong
+	 */
+
+	/*event management */
+	rtl865x_reInitEventMgr();
+
+	/*l4 */
+#if defined(CONFIG_RTL_LAYERED_DRIVER_L4)
+	rtl865x_nat_reinit();
+#endif
+
+	/*l3 */
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+	/* rtl865x_reinitRouteTable(); */
+	/* rtl865x_reinitNxtHopTable(); */
+	/* rtl865x_reinitIpTable(); */
+	/* rtl865x_reinitPppTable(); */
+	rtl865x_arp_reinit();
+#endif
+
+	/*l2 */
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L2
+	rtl865x_layer2_reinit();
+#endif
+
+	/*common */
+	/* rtl865x_reinitNetifTable(); */
+	rtl865x_reinitVlantable();
+	rtl865x_reinit_acl();
+
+	/*queue id & rx ring descriptor mapping */
+	/* Use REG32 instead of REG16 because CPUQDM4 is set to 0 unexpectedly when use REG16 */
+	REG32(CPUQDM0) =
+		QUEUEID1_RXRING_MAPPING | (QUEUEID0_RXRING_MAPPING << 16);
+	REG32(CPUQDM2) =
+		QUEUEID3_RXRING_MAPPING | (QUEUEID2_RXRING_MAPPING << 16);
+	REG32(CPUQDM4) =
+		QUEUEID5_RXRING_MAPPING | (QUEUEID4_RXRING_MAPPING << 16);
+
+	WRITE_MEM32(PLITIMR, 0);
+
+	/* rtl8651_setAsicOperationLayer(2); */
+
+	return SUCCESS;
+
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int wan_port_setting_read(struct seq_file *s, void *v)
+{
+	int j;
+
+	seq_printf(s, "  Lan Port ");
+	for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+		if (vlanconfig[0].memPort & (1 << j))
+			seq_printf(s, "%d ", j);
+	}
+	seq_printf(s, "\n");
+
+	seq_printf(s, "  Wan Port ");
+	for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+		if (vlanconfig[1].memPort & (1 << j))
+			seq_printf(s, "%d ", j);
+	}
+	seq_printf(s, "\n");
+
+	return 0;
+}
+#else
+static struct proc_dir_entry *wan_port_setting_proc = NULL;
+static int wan_port_setting_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int j, len = 0;
+
+	len += sprintf(page + len, "  Lan Port ");
+	for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+		if (vlanconfig[0].memPort & (1 << j))
+			len += sprintf(page + len, "%d ", j);
+	}
+	len += sprintf(page + len, "\n");
+
+	len += sprintf(page + len, "  Wan Port ");
+	for (j = 0; j < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum; j++) {
+		if (vlanconfig[1].memPort & (1 << j))
+			len += sprintf(page + len, "%d ", j);
+	}
+	len += sprintf(page + len, "\n");
+
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+static int wan_port_setting_write(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	char tmpbuf[32];
+
+	if (buffer && !copy_from_user(tmpbuf, buffer, count)) {
+		char *strptr, *cmd_addr;
+		char *tokptr;
+		struct net_device *dev;
+		struct dev_priv *dp;
+
+		tmpbuf[count - 1] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+		if (!memcmp(cmd_addr, "portmask", 8)) {
+			int j, portNum = -1;
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+
+			portNum = simple_strtol(tokptr, NULL, 0);
+			if (portNum < 0 || portNum > 31)
+				goto errout;
+
+			/* remove port form lan */
+			vlanconfig[0].vid = RTL_LANVLANID;
+			vlanconfig[1].vid = RTL_WANVLANID;
+			for (j = 0; j < 5; j++) {
+				if (portNum & (1 << j)) {
+					/* remove port form lan */
+					vlanconfig[0].memPort =
+						vlanconfig[0].
+						memPort & (~(1 << j));
+					vlanconfig[0].untagSet =
+						vlanconfig[0].
+						untagSet & (~(1 << j));
+
+					/* add port to wan */
+					vlanconfig[1].memPort =
+						vlanconfig[1].
+						memPort | (1 << j);
+					vlanconfig[1].untagSet =
+						vlanconfig[1].
+						untagSet | (1 << j);
+				} else {
+					/* add port form lan */
+					vlanconfig[0].memPort =
+						vlanconfig[0].
+						memPort | (1 << j);
+					vlanconfig[0].untagSet =
+						vlanconfig[0].
+						untagSet | (1 << j);
+
+					/* remove port to wan */
+					vlanconfig[1].memPort =
+						vlanconfig[1].
+						memPort & (~(1 << j));
+					vlanconfig[1].untagSet =
+						vlanconfig[1].
+						untagSet & (~(1 << j));
+				}
+			}
+
+			/* add CPU port */
+			vlanconfig[0].memPort =
+				vlanconfig[0].memPort | (1 << 8);
+			vlanconfig[0].untagSet =
+				vlanconfig[0].untagSet | (1 << 8);
+
+			memset((void *)&vlanconfig[2], 0,
+				sizeof(struct rtl865x_vlanConfig));
+
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = vlanconfig[0].memPort;	/* eth0 */
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->
+				id = vlanconfig[0].vid;
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = vlanconfig[1].vid;	/* eth1 */
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = vlanconfig[1].memPort;	/* eth1 */
+
+			dev = _rtl86xx_dev.dev[0];
+			dp = (struct dev_priv *)NETDRV_PRIV(dev);
+			dp->portnum = 0;
+			for (j = 0; j < RTL8651_AGGREGATOR_NUMBER; j++) {
+				if (dp->portmask & (1 << j))
+					dp->portnum++;
+			}
+
+			dev = _rtl86xx_dev.dev[1];
+			/* dp = dev->priv; */
+			dp = (struct dev_priv *)NETDRV_PRIV(dev);
+			dp->portnum = 0;
+			for (j = 0; j < RTL8651_AGGREGATOR_NUMBER; j++) {
+				if (dp->portmask & (1 << j))
+					dp->portnum++;
+			}
+
+			/* relint hw table */
+			rtl_reinit_hw_table_2();
+			reinit_vlan_configure(vlanconfig);
+		}
+		return count;
+	}
+
+errout:
+	printk("\nformat:	port 0 1 2 3 4 as bitmap and input in decimal\n");
+	printk("example:	echo \"portmask 12\">/proc/wan_port_setting\n");
+	printk("port 2 and 3 will be wan port.\n");
+	return count;
+
+}
+
+int32 rtl819x_initWanPortSetting(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("wan_port_setting", 0, &proc_root,
+		&wan_port_setting_proc_fops, NULL);
+#else
+	wan_port_setting_proc = create_proc_entry("wan_port_setting", 0, NULL);
+	if (wan_port_setting_proc) {
+		wan_port_setting_proc->read_proc = wan_port_setting_read;
+		wan_port_setting_proc->write_proc = wan_port_setting_write;
+	}
+#endif
+	return 0;
+}
+
+void __exit rtl819x_exitWanPortSetting(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("wan_port_setting", &proc_root);
+#else
+	if (wan_port_setting_proc) {
+		remove_proc_entry("wan_port_setting", wan_port_setting_proc);
+		wan_port_setting_proc = NULL;
+	}
+#endif
+}
+#endif
+
+#if defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#ifdef CONFIG_RTL_PROC_NEW
+static int proc_phyTest_read(struct seq_file *s, void *v)
+{
+	return 0;
+}
+#else
+static int32 proc_phyTest_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	return 0;
+}
+#endif
+
+enum _IOL_TEST {
+	IOL_100_MDI = 0,
+	IOL_100_MDIX,
+	IOL_100_finish,
+	IOL_10_MDI,
+	IOL_10_MDIX,
+	IOL_10_finish,
+	IOL_pktGen_allFF,
+	IOL_pktGen_random,
+	IOL_pktGen_disable,
+	IOL_TEST_MAX,
+};
+
+static uint8 iol_test_str[IOL_TEST_MAX][16] = {
+	"100_MDI",
+	"100_MDIX",
+	"100_finish",
+	"10_MDI",
+	"10_MDIX",
+	"10_finish",
+	"pktGen_allFF",
+	"pktGen_random",
+	"pktGen_disable"
+};
+
+static int32 proc_phyTest_write(struct file *filp, const char *buff,
+	unsigned long len1, void *data)
+{
+	char tmpbuf[64];
+	uint32 phyId = 0, regId = 0, iNo = 0, iPort = 0, len = 0, regData = 0;
+	char *strptr, *cmd_addr;
+	char *tokptr;
+	int32 i = 0, port = 0;
+	int32 ret = FAILED;
+#if defined(CONFIG_RTD_1295_HWNAT)
+	uintptr_t regAddr = 0;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	if (buff && !copy_from_user(tmpbuf, buff, len1)) {
+		tmpbuf[len1 - 1] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+
+		if (!memcmp(cmd_addr, "read", 4)) {
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			regId = simple_strtol(tokptr, NULL, 0);
+
+			ret = rtl8651_getAsicEthernetPHYReg(phyId, regId,
+				&regData);
+			if (ret == SUCCESS) {
+				printk("read phyId(%d), regId(%d),regData:0x%x\n", phyId, regId, regData);
+			} else {
+				printk("error input!\n");
+/* goto errout; */
+			}
+		}
+#ifdef CONFIG_RTL_8198C
+		else if (!memcmp(cmd_addr, "testdv", 6))	/* differential voltage test */
+		{
+			extern void Set_GPHYWB(uint32 phyid, uint32 page,
+				uint32 reg, uint32 mask, uint32 val);
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL)
+				goto errout;
+
+			iNo = simple_strtol(tokptr, NULL, 0);
+			if (iNo > 3)
+				goto errout;
+
+			if (iNo == 1) {
+				Set_GPHYWB(999, 0xbcc, 18, 0, 0xbf);
+				Set_GPHYWB(999, 0xbcc, 16, 0, 0xa408);
+			} else if (iNo == 2) {
+				Set_GPHYWB(999, 0xbcc, 18, 0, 0);
+				Set_GPHYWB(999, 0xbcc, 16, 0, 0xa438);
+			} else if (iNo == 3) {
+				Set_GPHYWB(999, 0xbcc, 18, 0, 0xbf);
+				Set_GPHYWB(999, 0xbcc, 16, 0, 0xa438);
+			} else if (iNo == 0) {
+				Set_GPHYWB(999, 0xbcc, 18, 0, 0);
+				Set_GPHYWB(999, 0xbcc, 16, 0, 0xa408);
+			}
+			printk("set PHY registers to level %d for differential voltage test.\n", iNo);
+		}
+#endif
+		else if (!memcmp(cmd_addr, "testIOL", 7)) {
+			printk("\n");
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL)
+				goto errout2;
+
+			iPort = simple_strtol(tokptr, NULL, 0);
+			if ((iPort < 0) || (iPort > 4))
+				goto errout2;
+			if (iPort == 0)
+				phyId = 8;
+			else
+				phyId = iPort;
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL)
+				goto errout2;
+
+			iNo = IOL_100_finish;
+			if (!memcmp(tokptr, iol_test_str[IOL_100_MDIX],
+					strlen(iol_test_str[IOL_100_MDIX])))
+				iNo = IOL_100_MDIX;
+			else if (!memcmp(tokptr, iol_test_str[IOL_100_MDI],
+					strlen(iol_test_str[IOL_100_MDI])))
+				iNo = IOL_100_MDI;
+			else if (!memcmp(tokptr, iol_test_str[IOL_100_finish],
+					strlen(iol_test_str[IOL_100_finish])))
+				iNo = IOL_100_finish;
+			else if (!memcmp(tokptr, iol_test_str[IOL_10_MDIX],
+					strlen(iol_test_str[IOL_10_MDIX])))
+				iNo = IOL_10_MDIX;
+			else if (!memcmp(tokptr, iol_test_str[IOL_10_MDI],
+					strlen(iol_test_str[IOL_10_MDI])))
+				iNo = IOL_10_MDI;
+			else if (!memcmp(tokptr, iol_test_str[IOL_10_finish],
+					strlen(iol_test_str[IOL_10_finish])))
+				iNo = IOL_10_finish;
+			else if (!memcmp(tokptr, iol_test_str[IOL_pktGen_allFF],
+					strlen(iol_test_str[IOL_pktGen_allFF])))
+				iNo = IOL_pktGen_allFF;
+			else if (!memcmp(tokptr,
+					iol_test_str[IOL_pktGen_random],
+					strlen(iol_test_str
+						[IOL_pktGen_random])))
+				iNo = IOL_pktGen_random;
+			else if (!memcmp(tokptr,
+					iol_test_str[IOL_pktGen_disable],
+					strlen(iol_test_str
+						[IOL_pktGen_disable])))
+				iNo = IOL_pktGen_disable;
+			else
+				goto errout2;
+
+			switch (iNo) {
+			case IOL_100_MDI:
+				REG32(PCRP0 + (iPort * 4)) |= (EnForceMode);
+				rtl8651_setAsicEthernetPHYReg(phyId, 24, 0x0310);	/* disable ALDPS */
+				rtl8651_setAsicEthernetPHYReg(phyId, 0, 0x2120);	/* force 100F + undirection */
+				rtl8651_setAsicEthernetPHYReg(phyId, 28, 0x40C2);	/* force MDI mode */
+				break;
+			case IOL_100_MDIX:
+				REG32(PCRP0 + (iPort * 4)) |= (EnForceMode);
+				rtl8651_setAsicEthernetPHYReg(phyId, 24, 0x0310);	/* disable ALDPS */
+				rtl8651_setAsicEthernetPHYReg(phyId, 0, 0x2120);	/* force 100F + undirection */
+				rtl8651_setAsicEthernetPHYReg(phyId, 28, 0x40C0);	/* force MDIX mode */
+				break;
+			case IOL_100_finish:
+				REG32(PCRP0 + (iPort * 4)) &= ~(EnForceMode);
+				rtl8651_setAsicEthernetPHYReg(phyId, 28, 0x40C6);	/* enable Auto MDI/MDIX */
+				rtl8651_setAsicEthernetPHYReg(phyId, 0, 0x9200);	/* reset phy */
+				break;
+			case IOL_10_MDI:
+				REG32(PCRP0 + (iPort * 4)) |= (EnForceMode);
+				rtl8651_setAsicEthernetPHYReg(phyId, 24, 0x0310);	/* disable ALDPS */
+				rtl8651_setAsicEthernetPHYReg(phyId, 0, 0x0120);	/* force 10F + undirection */
+				rtl8651_setAsicEthernetPHYReg(phyId, 28, 0x40C2);	/* force MDI mode */
+				rtl8651_getAsicEthernetPHYReg(phyId, 23,
+					&regData);
+				rtl8651_setAsicEthernetPHYReg(phyId, 23, regData | 0x8000);	/* enable force phy Link, to enable PHY receive pkt from MAC */
+				break;
+			case IOL_10_MDIX:
+				REG32(PCRP0 + (iPort * 4)) |= (EnForceMode);
+				rtl8651_setAsicEthernetPHYReg(phyId, 24, 0x0310);	/* disable ALDPS */
+				rtl8651_setAsicEthernetPHYReg(phyId, 0, 0x0120);	/* force 10F + undirection */
+				rtl8651_setAsicEthernetPHYReg(phyId, 28, 0x40C0);	/* force MDIX mode */
+				rtl8651_getAsicEthernetPHYReg(phyId, 23,
+					&regData);
+				rtl8651_setAsicEthernetPHYReg(phyId, 23, regData | 0x8000);	/* enable force phy Link, to enable PHY receive pkt from MAC */
+				break;
+			case IOL_10_finish:
+				REG32(PCRP0 + (iPort * 4)) &= ~(EnForceMode);
+				rtl8651_setAsicEthernetPHYReg(phyId, 28, 0x40C6);	/* enable Auto MDI/MDIX */
+				rtl8651_setAsicEthernetPHYReg(phyId, 0, 0x9200);	/* reset phy */
+				rtl8651_getAsicEthernetPHYReg(phyId, 23,
+					&regData);
+				rtl8651_setAsicEthernetPHYReg(phyId, 23, regData & (~0x8000));	/* disable force phy Link */
+				break;
+			case IOL_pktGen_allFF:
+				REG32(PGGCR1) = (REG32(PGGCR1) & ~(0x3 << (iPort * 4))) | BIT(EnSMBMode_OFFSET + iPort);	/* enable portN pktGen Mode */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+				regAddr = PGFPCR + (0x80 * iPort);
+				REG32(regAddr) =
+					(REG32(regAddr) & ~(0x001B07FF))
+					| ((1 << 16) | 1518);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+				regData = PGFPCR + (0x80 * iPort);
+				REG32(regData) =
+					(REG32(regData) & ~(0x001B07FF))
+					| ((1 << 16) | 1518);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+				REG32(PGDPR + (0x80 * iPort)) |= 0xFF;
+				REG32(PGGCR1) =
+					(REG32(PGGCR1)
+					& ~(0x3 << (iPort * 4))) |
+					(StopTXcommandPulse << (iPort * 4));
+				mdelay(50);
+				REG32(PGGCR1) =
+					(REG32(PGGCR1)
+					& ~(0x3 << (iPort * 4))) |
+					(StartTXcommandPulse << (iPort * 4));
+
+#if defined(REINIT_SWITCH_CORE)
+				rtl_check_tx_hang_flag = 0;
+#endif
+				break;
+			case IOL_pktGen_random:
+				REG32(PGGCR1) = (REG32(PGGCR1) & ~(0x3 << (iPort * 4))) | BIT(EnSMBMode_OFFSET + iPort);	/* enable portN pktGen Mode */
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+				regAddr = PGFPCR + (0x80 * iPort);
+				REG32(regAddr) =
+					(REG32(regAddr) & ~(0x001B07FF)) |
+					(1518);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+				regData = PGFPCR + (0x80 * iPort);
+				REG32(regData) =
+					(REG32(regData) & ~(0x001B07FF)) |
+					(1518);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+				REG32(PGGCR1) =
+					(REG32(PGGCR1)
+					& ~(0x3 << (iPort * 4))) |
+					(StopTXcommandPulse << (iPort * 4));
+				mdelay(50);
+				REG32(PGGCR1) =
+					(REG32(PGGCR1)
+					& ~(0x3 << (iPort * 4))) |
+					(StartTXcommandPulse << (iPort * 4));
+
+#if defined(REINIT_SWITCH_CORE)
+				rtl_check_tx_hang_flag = 0;
+#endif
+				break;
+			case IOL_pktGen_disable:
+				REG32(PGGCR1) =
+					(REG32(PGGCR1)
+					& ~(0x3 << (iPort * 4))) |
+					(StopTXcommandPulse << (iPort * 4));
+				mdelay(500);
+				REG32(PGGCR1) &= ~BIT(EnSMBMode_OFFSET + iPort);
+				break;
+			default:
+				break;
+			}
+			printk("set to the test mode: %s\n", iol_test_str[iNo]);
+		} else if (!memcmp(cmd_addr, "test", 4)) {
+			printk("\r\n");
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			iNo = simple_strtol(tokptr, NULL, 0);
+			if (iNo == 1)	/* test mode 1 */
+			{
+#if defined(CONFIG_RTL_8198C)
+				printk("PHY Test Mode #1\n");
+				for (len = 0; len < 5; len++)
+					REG32(PCRP0 + (len * 4)) |=
+						(EnForceMode);
+
+				for (i = 0; i < 5; i++) {
+					port = rtl8651AsicEthernetTable[i].
+						phyId;
+					rtl8651_setAsicEthernetPHYReg(port,
+						0x09, 0x2E00);
+					mdelay(50);
+				}
+#else
+				unsigned int default_val_t1[] = {
+					4, 0x1f, 0x0002,
+					4, 0x13, 0xAA00,
+					4, 0x14, 0xAA00,
+					4, 0x15, 0xAA00,
+					4, 0x16, 0xFA00,
+					4, 0x17, 0xAF00
+				};
+				printk("PHY Test 1 Mode: No\n");
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) |= (EnForceMode);
+				len = sizeof(default_val_t1) /
+					sizeof(unsigned int);
+
+				for (i = 0; i < len; i = i + 3) {
+					port = default_val_t1[i];
+					rtl8651_setAsicEthernetPHYReg(port,
+						default_val_t1[i + 1],
+						default_val_t1[i + 2]);
+				}
+				for (i = 0; i < 5; i++) {
+					rtl8651_setAsicEthernetPHYReg(i, 0x1f,
+						0x0000);
+					rtl8651_setAsicEthernetPHYReg(i, 0x09,
+						0x2E00);
+				}
+#endif
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) &= ~(EnForceMode);
+				printk("Please reset the target after leaving Test Mode\n");
+				ret = SUCCESS;
+			}
+#if 0
+			else if (iNo == 2)	/* test mode 2 */
+			{
+
+				unsigned int default_val_t2[] = {
+					1, 0x1f, 0x0002,
+					1, 0x11, 0x5E00,
+					1, 0x1f, 0x0000,
+					4, 0x1f, 0x0002,
+					4, 0x11, 0x5E00,
+					4, 0x1f, 0x0000
+				};
+				printk("PHY Test 2 Mode: No\n");
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) |= (EnForceMode);
+				len = sizeof(default_val_t2) /
+					sizeof(unsigned int);
+
+				for (i = 0; i < len; i = i + 3) {
+					port = default_val_t2[i];
+					rtl8651_setAsicEthernetPHYReg(port,
+						default_val_t2[i + 1],
+						default_val_t2[i + 2]);
+				}
+				for (i = 0; i < 5; i++) {
+					rtl8651_setAsicEthernetPHYReg(i, 0x1f,
+						0x0000);
+					rtl8651_setAsicEthernetPHYReg(i, 0x09,
+						0x4E00);
+				}
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) &= ~(EnForceMode);
+				printk("Please reset the target after leaving Test Mode\n");
+				ret = SUCCESS;
+			} else if (iNo == 3)	/* test mode 3 */
+			{
+				unsigned int default_val_t3[] = {
+					1, 0x1f, 0x0002,
+					1, 0x11, 0x4000,
+				};
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) |= (EnForceMode);
+
+				printk("PHY Test 3 Mode: No  Port{0~4} Channel{A,B,C,D}\n");
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+				iPort = simple_strtol(tokptr, NULL, 0);
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+				len = sizeof(default_val_t3) /
+					sizeof(unsigned int);
+				for (i = 0; i < len; i = i + 3) {
+					port = default_val_t3[i];
+					rtl8651_setAsicEthernetPHYReg(port,
+						default_val_t3[i + 1],
+						default_val_t3[i + 2]);
+				}
+
+				switch (*tokptr) {
+
+				case 'A':
+					rtl8651_setAsicEthernetPHYReg(1, 0x10,
+						0x1100);
+					rtl8651_setAsicEthernetPHYReg(1, 0x1f,
+						0x0000);
+					printk("A channel\n");
+
+					break;
+				case 'B':
+					rtl8651_setAsicEthernetPHYReg(1, 0x10,
+						0x1300);
+					rtl8651_setAsicEthernetPHYReg(1, 0x1f,
+						0x0000);
+					printk("B channel\n");
+					break;
+				case 'C':
+					rtl8651_setAsicEthernetPHYReg(1, 0x10,
+						0x1500);
+					rtl8651_setAsicEthernetPHYReg(1, 0x1f,
+						0x0000);
+					printk("C channel\n");
+					break;
+				case 'D':
+					rtl8651_setAsicEthernetPHYReg(1, 0x10,
+						0x1700);
+					rtl8651_setAsicEthernetPHYReg(1, 0x1f,
+						0x0000);
+					printk("D channel\n");
+					break;
+				}
+				rtl8651_setAsicEthernetPHYReg(iPort, 0x1f,
+					0x0000);
+				rtl8651_setAsicEthernetPHYReg(iPort, 0x09,
+					0x6e00);
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) &= ~(EnForceMode);
+				printk("Please reset the target after leaving Test Mode\n");
+				ret = SUCCESS;
+			}
+#endif
+			else if (iNo == 4)	/* test mode 4 */
+			{
+#if defined(CONFIG_RTL_8198C)
+
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) |= (EnForceMode);
+
+				tokptr = strsep(&strptr, " ");
+				printk("PHY Test Mode #4 for ");
+				if (tokptr != NULL) {
+					iPort = simple_strtol(tokptr, NULL, 0);
+					printk("port %d\n", iPort);
+					if (iPort == 0)
+						iPort = 8;
+					rtl8651_setAsicEthernetPHYReg(iPort,
+						0x09, 0x8E00);
+				} else {
+					printk("all ports\n");
+					for (i = 0; i < 5; i++) {
+						phyId = rtl8651AsicEthernetTable
+							[i].phyId;
+						rtl8651_setAsicEthernetPHYReg
+							(phyId, 0x09, 0x8E00);
+						mdelay(50);
+					}
+				}
+#else
+				unsigned int default_val_t4[] = {
+					0, 0x1f, 0x0002,
+					0, 0x07, 0x3678,
+					0, 0x1f, 0x0000,
+					0, 0x09, 0x8e00
+				};
+
+				tokptr = strsep(&strptr, " ");
+				if (tokptr == NULL) {
+					goto errout;
+				}
+				iPort = simple_strtol(tokptr, NULL, 0);
+				printk("PHY Test 4 Mode: No:%d  Port:%d \n",
+					iNo, iPort);
+
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) |= (EnForceMode);
+
+				len = sizeof(default_val_t4) /
+					sizeof(unsigned int);
+
+				for (i = 0; i < len; i = i + 3) {
+					rtl8651_setAsicEthernetPHYReg(iPort,
+						default_val_t4[i + 1],
+						default_val_t4[i + 2]);
+				}
+#endif
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) &= ~(EnForceMode);
+				printk("Please reset the target after leaving Test Mode\n");
+				ret = SUCCESS;
+			}
+#if defined(CONFIG_RTL_8198C)
+			else if (iNo == 0) {
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) |= (EnForceMode);
+
+				for (i = 0; i < 5; i++) {
+					phyId = rtl8651AsicEthernetTable[i].
+						phyId;
+					rtl8651_setAsicEthernetPHYReg(phyId,
+						0x09, 0xE00);
+					mdelay(50);
+				}
+				for (i = 0; i < 5; i++)
+					REG32(PCRP0 + i * 4) &= ~(EnForceMode);
+				printk("set to normal mode\n");
+				ret = SUCCESS;
+			}
+#endif
+
+			if (ret == SUCCESS) {
+				/* printk("Write phyId(%d), regId(%d), regData:0x%x\n", phyId, regId, regData); */
+			} else {
+				printk("error input!\n");
+/* goto errout; */
+			}
+		} else {
+			goto errout;
+		}
+
+		return len1;
+
+errout:
+		printk("\nTest  format:	\"Test 1~4\"\n");
+		printk("PHY Test 1 Mode: No\n");
+		/* printk("PHY Test 2 Mode: No\n"); */
+		/* printk("PHY Test 3 Mode: No  Port{0~4} Channel{A,B,C,D}\n"); */
+		printk("PHY Test 4 Mode: No  Port{0~4} \n");
+
+		return len1;
+
+errout2:
+		printk("error input!\n");
+		return len1;
+	}
+
+	return -EFAULT;
+}
+#endif
+
+#ifndef CONFIG_RTL_PROC_NEW
+static struct proc_dir_entry *phyTest_entry = NULL;
+#endif
+
+int32 phyRegTest_init(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("phyRegTest", 0, &proc_root, &phyRegTest_proc_fops,
+		NULL);
+#else
+	phyTest_entry = create_proc_entry("phyRegTest", 0, NULL);
+	if (phyTest_entry != NULL) {
+		phyTest_entry->read_proc = proc_phyTest_read;
+		phyTest_entry->write_proc = proc_phyTest_write;
+	}
+#endif
+
+	return 0;
+}
+
+void __exit phyRegTest_exit(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("phyTest_entry", &proc_root);
+#else
+	if (phyTest_entry) {
+		remove_proc_entry("phyTest_entry", phyTest_entry);
+		phyTest_entry = NULL;
+	}
+#endif
+}
+
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtl865x_mldSnoopingReadProc(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s\n", (mldSnoopEnabled == TRUE) ? "enable" : "disable");
+	return 0;
+}
+#else
+static struct proc_dir_entry *mldSnoopingProc = NULL;
+static int rtl865x_mldSnoopingReadProc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	len = sprintf(page, "%s\n",
+		(mldSnoopEnabled == TRUE) ? "enable" : "disable");
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int rtl865x_mldSnoopingWriteProc(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	uint32 tmpBuf[32];
+	uint32 uintVal;
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		tmpBuf[count - 1] = 0;
+		uintVal = simple_strtol((const char *)tmpBuf, NULL, 0);
+
+		if (uintVal != 0) {
+			if (mldSnoopEnabled == FALSE) {
+				rtl865x_removeAclForMldSnooping(vlanconfig);
+				rtl865x_addAclForMldSnooping(vlanconfig);
+
+				mldSnoopEnabled = TRUE;
+			}
+		} else {
+			if (mldSnoopEnabled == TRUE) {
+				rtl865x_removeAclForMldSnooping(vlanconfig);
+				mldSnoopEnabled = FALSE;
+			}
+		}
+		if (mldSnoopEnabled == FALSE) {
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			rtl8198C_reinitMulticastv6();
+#endif
+#endif
+			rtl_flushAllIgmpRecord(FLUSH_MLD_RECORD);
+		}
+		return count;
+	}
+	return -EFAULT;
+}
+
+int32 rtl8651_initMldSnooping(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("br_mldsnoop", 0, &proc_root, &br_mldsnoop_proc_fops,
+		NULL);
+#else
+	mldSnoopingProc = create_proc_entry("br_mldsnoop", 0, NULL);
+	if (mldSnoopingProc) {
+		mldSnoopingProc->read_proc = rtl865x_mldSnoopingReadProc;
+		mldSnoopingProc->write_proc = rtl865x_mldSnoopingWriteProc;
+	}
+#endif
+	mldSnoopEnabled = FALSE;
+	return 0;
+}
+
+void __exit rtl8651_exitMldSnoopingCtrl(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("br_mldsnoop", &proc_root);
+#else
+	if (mldSnoopingProc) {
+		remove_proc_entry("br_mldsnoop", mldSnoopingProc);
+		mldSnoopingProc = NULL;
+	}
+#endif
+}
+#endif
+
+#if defined(CONFIG_RTL_PHY_POWER_CTRL)
+#ifndef CONFIG_RTL_PROC_NEW
+static struct proc_dir_entry *phyPowerCtrlProc = NULL;
+#endif
+#define PHY_POWER_OFF 0
+#define PHY_POWER_ON 1
+int rtl865x_setPhyPowerOff(unsigned int port)
+{
+	unsigned int offset = port * 4;
+	unsigned int pcr = 0;
+	unsigned int regData, phyid;
+	unsigned int macLinkStatus;
+	unsigned int phyLinkStatus;
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (port > RTL8651_PHY_NUMBER)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (port >= RTL8651_PHY_NUMBER)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	{
+		return -1;
+	}
+
+	/*must set mac force link down first */
+	pcr = READ_MEM32(PCRP0 + offset);
+	pcr |= EnForceMode;
+	pcr &= ~ForceLink;
+	WRITE_MEM32(PCRP0 + offset, pcr);
+	TOGGLE_BIT_IN_REG_TWICE(PCRP0 + offset, EnForceMode);
+
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+	rtl8651_getAsicEthernetPHYReg(phyid, 0, &regData);
+	regData = regData | POWER_DOWN;
+	rtl8651_setAsicEthernetPHYReg(phyid, 0, regData);
+
+	/*confirm shutdown phy power successfully */
+	regData = READ_MEM32(PSRP0 + offset);
+	macLinkStatus = regData & PortStatusLinkUp;
+
+	rtl8651_getAsicEthernetPHYReg(phyid, 0, &regData);
+	phyLinkStatus = !(regData & POWER_DOWN);
+	while ((macLinkStatus) || (phyLinkStatus)) {
+		/* printk("port is %d,macLinkStatus is %d,phyLinkStatus is %d\n",port,macLinkStatus,phyLinkStatus); */
+		pcr = READ_MEM32(PCRP0 + offset);
+		pcr |= EnForceMode;
+		pcr &= ~ForceLink;
+		WRITE_MEM32(PCRP0 + offset, pcr);
+		TOGGLE_BIT_IN_REG_TWICE(PCRP0 + offset, EnForceMode);
+
+		rtl8651_getAsicEthernetPHYReg(phyid, 0, &regData);
+		regData = regData | POWER_DOWN;
+		rtl8651_setAsicEthernetPHYReg(phyid, 0, regData);
+
+		regData = READ_MEM32(PSRP0 + offset);
+		macLinkStatus = regData & PortStatusLinkUp;
+
+		rtl8651_getAsicEthernetPHYReg(phyid, 0, &regData);
+		phyLinkStatus = !(regData & POWER_DOWN);
+	}
+	return 0;
+
+}
+
+int rtl865x_setPhyPowerOn(unsigned int port)
+{
+	unsigned int offset = port * 4;
+	unsigned int pcr = 0;
+
+	unsigned int regData, phyid;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (port > RTL8651_PHY_NUMBER)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (port >= RTL8651_PHY_NUMBER)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	{
+		return -1;
+	}
+
+	pcr = READ_MEM32(PCRP0 + offset);
+	pcr |= EnForceMode;
+
+	WRITE_MEM32(PCRP0 + offset, pcr);
+	TOGGLE_BIT_IN_REG_TWICE(PCRP0 + offset, EnForceMode);
+
+	phyid = rtl8651AsicEthernetTable[port].phyId;
+	rtl8651_getAsicEthernetPHYReg(phyid, 0, &regData);
+	regData = regData & (~POWER_DOWN);
+	rtl8651_setAsicEthernetPHYReg(phyid, 0, regData);
+
+	pcr &= ~EnForceMode;
+	WRITE_MEM32(PCRP0 + offset, pcr);
+	TOGGLE_BIT_IN_REG_TWICE(PCRP0 + offset, EnForceMode);
+	return 0;
+
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtl865x_phyPowerCtrlReadProc(struct seq_file *s, void *v)
+{
+	int port;
+	unsigned int regData;
+#ifndef CONFIG_RTL_8367R_SUPPORT
+	unsigned int phyid;
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT)
+	for (port = 0; port <= RTL8651_PHY_NUMBER; port++)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	for (port = 0; port < RTL8651_PHY_NUMBER; port++)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	{
+#ifdef CONFIG_RTL_8367R_SUPPORT
+		{
+			extern int rtk_port_phyReg_get(int port, int reg,
+				uint32 *pData);
+			rtk_port_phyReg_get(port, 0, &regData);
+		}
+#else
+		phyid = rtl8651AsicEthernetTable[port].phyId;
+		rtl8651_getAsicEthernetPHYReg(phyid, 0, &regData);
+#endif
+		if (regData & POWER_DOWN) {
+			seq_printf(s, "port[%d] phy is power off\n", port);
+		} else {
+			seq_printf(s, "port[%d] phy is power on\n", port);
+		}
+	}
+	return 0;
+}
+#else
+static int rtl865x_phyPowerCtrlReadProc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+	int port;
+	unsigned int regData, phyid;
+#if defined(CONFIG_RTD_1295_HWNAT)
+	for (port = 0; port <= RTL8651_PHY_NUMBER; port++)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	for (port = 0; port < RTL8651_PHY_NUMBER; port++)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	{
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+		{
+			extern int rtk_port_phyReg_get(int port, int reg,
+				uint32 *pData);
+			rtk_port_phyReg_get(port, 0, &regData);
+		}
+#else
+		phyid = rtl8651AsicEthernetTable[port].phyId;
+		rtl8651_getAsicEthernetPHYReg(phyid, 0, &regData);
+#endif
+		if (regData & POWER_DOWN) {
+			len += sprintf(page + len,
+				"port[%d] phy is power off\n", port);
+		} else {
+			len += sprintf(page + len, "port[%d] phy is power on\n",
+				port);
+		}
+	}
+
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int rtl865x_phyPowerCtrlWriteProc(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	char tmpBuf[256];
+	char *strptr;
+	char *tokptr;
+	unsigned int portMask;
+	unsigned int action;
+	int i;
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		tmpBuf[count - 1] = 0;
+		strptr = tmpBuf;
+
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errOut;
+		}
+		portMask = simple_strtol(tokptr, NULL, 0);
+
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errOut;
+		}
+		action = simple_strtol(tokptr, NULL, 0);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		for (i = 0; i <= RTL8651_PHY_NUMBER; i++)
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		for (i = 0; i < RTL8651_PHY_NUMBER; i++)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		{
+			if ((1 << i) & portMask) {
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+				{
+					extern int rtk_port_phyReg_get(int port,
+						int reg, uint32 *pData);
+					extern int rtk_port_phyReg_set(int port,
+						int reg, uint32 regData);
+					uint32 regData;
+
+					rtk_port_phyReg_get(i, 0, &regData);
+
+					if (action == PHY_POWER_OFF) {
+						regData |= POWER_DOWN;
+					} else if (action == PHY_POWER_ON) {
+						regData &= ~POWER_DOWN;
+					}
+					rtk_port_phyReg_set(i, 0, regData);
+				}
+#else
+				if (action == PHY_POWER_OFF) {
+					rtl865x_setPhyPowerOff(i);
+				} else if (action == PHY_POWER_ON) {
+					rtl865x_setPhyPowerOn(i);
+				}
+#endif
+			}
+
+		}
+
+		return count;
+	}
+
+errOut:
+	return -EFAULT;
+}
+
+static int32 rtl865x_initPhyPowerCtrl(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("phyPower", 0, &proc_root, &phyPower_proc_fops, NULL);
+#else
+	phyPowerCtrlProc = create_proc_entry("phyPower", 0, NULL);
+	if (phyPowerCtrlProc) {
+		phyPowerCtrlProc->read_proc = rtl865x_phyPowerCtrlReadProc;
+		phyPowerCtrlProc->write_proc = rtl865x_phyPowerCtrlWriteProc;
+	}
+#endif
+
+	return 0;
+}
+
+void __exit rtl865x_exitPhyPowerCtrl(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("phyPower", &proc_root);
+#else
+	if (phyPowerCtrlProc) {
+		remove_proc_entry("phyPower", phyPowerCtrlProc);
+		phyPowerCtrlProc = NULL;
+	}
+#endif
+}
+
+#endif
+
+#if defined(CONFIG_RTL_LINKSTATE)
+
+static struct proc_dir_entry *portStateProc = NULL;
+static unsigned int linkUpTime[RTL8651_PHY_NUMBER] = { 0, 0, 0, 0, 0 };
+
+static void init_linkup_time(void)
+{
+	init_timer(&s_timer);
+	s_timer.function = &linkup_time_handle;
+	s_timer.expires = jiffies + HZ;
+	add_timer(&s_timer);
+}
+
+static void linkup_time_handle(unsigned long arg)
+{
+	int port;
+	uint32 regData;
+	uint32 data0;
+	mod_timer(&s_timer, jiffies + HZ);
+	for (port = PHY0; port < PHY5; port++) {
+		regData = READ_MEM32(PSRP0 + ((port) << 2));
+		data0 = regData & PortStatusLinkUp;
+		if (data0) {
+			linkUpTime[port]++;
+		} else {
+			linkUpTime[port] = 0;
+		}
+	}
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int port_state_read_proc(struct seq_file *s, void *v)
+{
+	int len;
+	uint32 regData;
+	uint32 data0;
+	int port;
+
+	seq_printf(s, "Port Link State:\n");
+
+	for (port = PHY0; port < PHY5; port++) {
+		regData = READ_MEM32(PSRP0 + ((port) << 2));
+
+		/* if (port==CPU) */
+		/* seq_printf(s, "CPUPort "); */
+		/* else */
+		seq_printf(s, "Port[%d]:", port);
+		data0 = regData & PortStatusLinkUp;
+
+		if (data0) {
+			seq_printf(s, "LinkUp|");
+		} else {
+			seq_printf(s, "LinkDown\n");
+			continue;
+		}
+		/* data0 = regData & PortStatusNWayEnable; */
+		/* seq_printf(s, "NWay Mode %s\n", data0?"Enabled":"Disabled"); */
+		data0 = regData & PortStatusRXPAUSE;
+		seq_printf(s, "RXPause:%s|", data0 ? "Enable" : "Disable");
+		data0 = regData & PortStatusTXPAUSE;
+		seq_printf(s, "TXPause:%s|", data0 ? "Enable" : "Disable");
+		data0 = regData & PortStatusDuplex;
+		seq_printf(s, "Duplex:%s|", data0 ? "Enable" : "Disable");
+		data0 = (regData & PortStatusLinkSpeed_MASK) >>
+			PortStatusLinkSpeed_OFFSET;
+		seq_printf(s, "Speed:%s|",
+			data0 == PortStatusLinkSpeed100M ? "100M" : (data0 ==
+				PortStatusLinkSpeed1000M ? "1G" : (data0 ==
+					PortStatusLinkSpeed10M ? "10M" :
+					"Unkown")));
+		seq_printf(s, "UpTime:%ds\n", linkUpTime[port]);
+	}
+
+	return 0;
+}
+#else
+static int32 port_state_read_proc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	uint32 regData;
+	uint32 data0;
+	int port;
+
+	len = sprintf(page, "Port Link State:\n");
+
+	for (port = PHY0; port < PHY5; port++) {
+		regData = READ_MEM32(PSRP0 + ((port) << 2));
+
+		/* if (port==CPU) */
+		/* len += sprintf(page+len, "CPUPort "); */
+		/* else */
+		len += sprintf(page + len, "Port[%d]:", port);
+		data0 = regData & PortStatusLinkUp;
+
+		if (data0) {
+			len += sprintf(page + len, "LinkUp|");
+		} else {
+			len += sprintf(page + len, "LinkDown\n");
+			continue;
+		}
+		/* data0 = regData & PortStatusNWayEnable; */
+		/* len += sprintf(page+len, "NWay Mode %s\n", data0?"Enabled":"Disabled"); */
+		data0 = regData & PortStatusRXPAUSE;
+		len += sprintf(page + len, "RXPause:%s|",
+			data0 ? "Enable" : "Disable");
+		data0 = regData & PortStatusTXPAUSE;
+		len += sprintf(page + len, "TXPause:%s|",
+			data0 ? "Enable" : "Disable");
+		data0 = regData & PortStatusDuplex;
+		len += sprintf(page + len, "Duplex:%s|",
+			data0 ? "Enable" : "Disable");
+		data0 = (regData & PortStatusLinkSpeed_MASK) >>
+			PortStatusLinkSpeed_OFFSET;
+		len += sprintf(page + len, "Speed:%s|",
+			data0 == PortStatusLinkSpeed100M ? "100M" : (data0 ==
+				PortStatusLinkSpeed1000M ? "1G" : (data0 ==
+					PortStatusLinkSpeed10M ? "10M" :
+					"Unkown")));
+		len += sprintf(page + len, "UpTime:%ds\n", linkUpTime[port]);
+	}
+
+	return len;
+}
+#endif
+
+static int32 port_state_write_proc(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	return len;
+}
+
+static int32 initPortStateCtrl(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("portState", 0, &proc_root, &portState_proc_fops,
+		NULL);
+#else
+	portStateProc = create_proc_entry("portState", 0, NULL);
+	if (portStateProc) {
+		portStateProc->read_proc = port_state_read_proc;
+		portStateProc->write_proc = port_state_write_proc;
+	}
+#endif
+	memset(linkUpTime, 0, sizeof(linkUpTime));
+	init_linkup_time();
+
+	return 0;
+}
+
+static void exitPortStateCtrl(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("portState", &proc_root);
+#else
+	if (portStateProc) {
+		remove_proc_entry("portState", portStateProc);
+		portStateProc = NULL;
+	}
+#endif
+	del_timer(&s_timer);
+}
+#endif
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+static int rtl_port_used_by_device(uint32 portMask)
+{
+	int i;
+	struct dev_priv *cp;
+	int retval = FAILED;
+
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		cp = ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[i]));
+		if (_rtl86xx_dev.dev[i] && cp && cp->opened
+			&& (cp->portmask & portMask)) {
+			retval = SUCCESS;
+			break;
+		}
+
+	}
+
+	cp = (struct dev_priv *)NETDRV_PRIV(rtl_multiWan_net_dev);
+	if (rtl_multiWan_net_dev && cp && cp->opened
+		&& (cp->portmask & portMask))
+		retval = SUCCESS;
+
+	return retval;
+}
+
+static int rtl_regist_multipleWan_dev(void)
+{
+	int j;
+	struct net_device *dev;
+	struct dev_priv *dp;
+	int rc;
+
+	dev = alloc_etherdev(sizeof(struct dev_priv));
+	if (!dev) {
+		printk("====%s(%d) failed to allocate\n", __FUNCTION__,
+			__LINE__);
+		return FAILED;
+	}
+	SET_MODULE_OWNER(dev);
+	dp = NETDRV_PRIV(dev);
+	memset(dp, 0, sizeof(*dp));
+	dp->dev = dev;
+	dp->id = rtl_multiWan_config.vid;
+	dp->portmask = rtl_multiWan_config.memPort;
+	dp->portnum = 0;
+	for (j = 0; j < RTL8651_AGGREGATOR_NUMBER; j++) {
+		if (dp->portmask & (1 << j))
+			dp->portnum++;
+	}
+
+	memcpy((char *)dev->dev_addr, (char *)(&(rtl_multiWan_config.mac)),
+		ETHER_ADDR_LEN);
+#if defined(CONFIG_COMPAT_NET_DEV_OPS)
+	dev->open = re865x_open;
+	dev->stop = re865x_close;
+	dev->set_multicast_list = re865x_set_rx_mode;
+	dev->hard_start_xmit = re865x_start_xmit;
+	dev->get_stats = re865x_get_stats;
+	dev->do_ioctl = re865x_ioctl;
+	dev->tx_timeout = re865x_tx_timeout;
+	dev->set_mac_address = rtl865x_set_hwaddr;
+	dev->change_mtu = rtl865x_set_mtu;
+#if defined(CONFIG_RTL8186_LINK_CHANGE)
+	dev->change_link = rtl865x_set_link;
+#endif
+#ifdef CP_VLAN_TAG_USED
+	dev->features |= NETIF_F_HW_VLAN_TX | NETIF_F_HW_VLAN_RX;
+	dev->vlan_rx_register = cp_vlan_rx_register;
+	dev->vlan_rx_kill_vid = cp_vlan_rx_kill_vid;
+#endif
+
+#else
+	dev->netdev_ops = &rtl819x_netdev_ops;
+#endif
+	dev->watchdog_timeo = TX_TIMEOUT;
+
+#ifdef CP_VLAN_TAG_USED
+	dev->features |= NETIF_F_HW_VLAN_TX | NETIF_F_HW_VLAN_RX;
+#endif
+
+	dev->irq = 0;
+	memcpy((char *)dev->name, rtl_multiWan_config.ifname, MAX_IFNAMESIZE);
+	rc = register_netdev(dev);
+	if (!rc) {
+		rtl_multiWan_net_dev = dev;
+		rtl_add_ps_drv_netif_mapping(dev, rtl_multiWan_config.ifname);
+		printk("==%s(%d) %s added. vid=%d Member port 0x%x...\n",
+			__FUNCTION__, __LINE__, dev->name,
+			rtl_multiWan_config.vid, rtl_multiWan_config.memPort);
+	} else
+		printk("===%s(%d) Failed to allocate,rc(%d)\n", __FUNCTION__,
+			__LINE__, rc);
+
+	return SUCCESS;
+	/* } */
+
+#if 0
+static int rtl_unregist_multipleWan_dev(void)
+{
+	if (rtl_multiWan_net_dev)
+		unregister_netdev(rtl_multiWan_net_dev);
+
+	rtl_multiWan_net_dev = NULL;
+	return SUCCESS;
+}
+#endif
+static int rtl_config_multipleWan_netif(int32 cmd)
+{
+	int retval = FAILED;
+	switch (cmd) {
+	case RTL_MULTIWAN_ADD:
+		{
+			rtl865x_netif_t netif;
+
+			/*add vlan */
+			retval = rtl865x_addVlan(rtl_multiWan_config.vid);
+			if (retval == SUCCESS) {
+				rtl865x_addVlanPortMember(rtl_multiWan_config.
+					vid, rtl_multiWan_config.memPort);
+				rtl865x_setVlanFilterDatabase
+					(rtl_multiWan_config.vid,
+					rtl_multiWan_config.fid);
+
+			} else if (retval == RTL_EVLANALREADYEXISTS) {
+				/* only add memberport to vlan */
+				rtl865x_addVlanPortMember(rtl_multiWan_config.
+					vid, rtl_multiWan_config.memPort);
+			}
+
+			/*add network interface */
+			memset(&netif, 0, sizeof(rtl865x_netif_t));
+			memcpy(netif.name, rtl_multiWan_config.ifname,
+				MAX_IFNAMESIZE);
+			memcpy(netif.macAddr.octet,
+				rtl_multiWan_config.mac.octet, ETHER_ADDR_LEN);
+			netif.mtu = rtl_multiWan_config.mtu;
+			netif.if_type = rtl_multiWan_config.if_type;
+			netif.vid = rtl_multiWan_config.vid;
+			netif.is_wan = rtl_multiWan_config.isWan;
+			netif.is_slave = rtl_multiWan_config.is_slave;
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+			netif.enableRoute = 1;
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			netif.mtuV6 = rtl_multiWan_config.mtu;
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT) || (defined(CONFIG_RTL_MLD_SNOOPING) && defined(CONFIG_RTL_HARDWARE_MULTICAST))
+			netif.enableRouteV6 = 1;	/*jwj:enable ipv6, then enable v6 router */
+#endif
+#endif
+
+			retval = rtl865x_addNetif(&netif);
+			rtl865x_reConfigDefaultAcl(netif.name);
+
+			if (retval != SUCCESS
+				&& retval != RTL_EVLANALREADYEXISTS) {
+				printk("=======%s(%d),retval(%d)\n",
+					__FUNCTION__, __LINE__, retval);
+			}
+		}
+		rtl_init_advRt();
+		break;
+	case RTL_MULTIWAN_DEL:
+		rtl_exit_advRt();
+		rtl865x_delNetif(rtl_multiWan_config.ifname);
+		rtl865x_delVlanPortMember(rtl_multiWan_config.vid,
+			rtl_multiWan_config.memPort);
+		break;
+	default:
+		retval = FAILED;
+	}
+
+	return retval;
+}
+
+static int rtl865x_isArpFrame(struct sk_buff *skb, int *ah_offset)
+{
+	int ret = FALSE;
+
+	if (*((uint16 *)(skb->data + (ETH_ALEN << 1))) ==
+		__constant_htons(ETH_P_ARP)) {
+		*ah_offset = ETH_HLEN;
+		ret = TRUE;
+	} else if ((*((uint16 *)(skb->data + (ETH_ALEN << 1))) ==
+			__constant_htons(ETH_P_8021Q))
+		&& (*((uint16 *)(skb->data + (ETH_ALEN << 1) + VLAN_HLEN)) ==
+			__constant_htons(ETH_P_ARP))) {
+		*ah_offset = ETH_HLEN + VLAN_HLEN;
+		ret = TRUE;
+	}
+
+	return ret;
+}
+
+static inline int rtl865x_decideUcDevice(unsigned char *data, int pid,
+	rtl_nicRx_info *info)
+{
+	int i;
+	struct dev_priv *cp;
+
+	/* mac based decision */
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		cp = (struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[i]);
+		if (_rtl86xx_dev.dev[i] && cp && cp->opened
+			&& (memcmp(data, cp->dev->dev_addr, 6) == 0)) {
+			info->priv = cp;
+			return SUCCESS;
+		}
+	}
+	/* rtl_multiWan_config */
+	if (rtl_multiWan_net_dev) {
+		cp = (struct dev_priv *)NETDRV_PRIV(rtl_multiWan_net_dev);
+		if (rtl_multiWan_net_dev && cp && cp->opened
+			&& (memcmp(data, cp->dev->dev_addr, 6) == 0)) {
+			info->priv = cp;
+			return SUCCESS;
+		}
+	}
+
+	return FAILED;
+}
+
+static inline int rtl865x_decideMcDevice(int pid, rtl_nicRx_info *info)
+{
+	int i;
+	struct dev_priv *cp;
+
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		cp = (struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[i]);
+		if (_rtl86xx_dev.dev[i] && cp && cp->opened
+			&& (cp->portmask & (1 << pid))) {
+			if (strncmp(cp->dev->name, igmp_proxy_wan_dev,
+					MAX_IFNAMESIZE) == 0) {
+				info->priv = cp;
+				return SUCCESS;
+			}
+		}
+	}
+
+	if (rtl_multiWan_net_dev) {
+		cp = (struct dev_priv *)NETDRV_PRIV(rtl_multiWan_net_dev);
+		if (rtl_multiWan_net_dev && cp && cp->opened
+			&& (cp->portmask & (1 << pid))) {
+			if (strncmp(cp->dev->name, igmp_proxy_wan_dev,
+					MAX_IFNAMESIZE) == 0) {
+				info->priv = cp;
+				return SUCCESS;
+			}
+		}
+	}
+
+	return FAILED;
+}
+
+static inline int rtl865x_decideBcDevice(struct sk_buff *skb, int pid,
+	rtl_nicRx_info *info)
+{
+	int i;
+	struct dev_priv *cp;
+	struct arphdr *arp;
+	unsigned char *arp_ptr;
+	__be32 tip, dev_ip, dev_mask;
+	int ah_offset = 0;
+
+	if (rtl865x_isArpFrame(skb, &ah_offset) == TRUE) {
+		arp = (struct arphdr *)(skb->data + ah_offset);
+		if ((arp->ar_hrd == htons(ARPHRD_ETHER))
+			&& (arp->ar_pro == htons(ETH_P_IP))) {
+			arp_ptr = (unsigned char *)(arp + 1);
+			arp_ptr += (ETH_ALEN << 1) + 4;
+			memcpy(&tip, arp_ptr, 4);
+
+			for (i = 0; i < ETH_INTF_NUM; i++) {
+				cp = ((struct dev_priv *)
+					NETDRV_PRIV(_rtl86xx_dev.dev[i]));
+				if (_rtl86xx_dev.dev[i] && cp && cp->opened
+					&& (cp->portmask & (1 << pid))) {
+					if ((get_dev_ip_mask(cp->dev->name,
+								&dev_ip,
+								&dev_mask) == 0)
+						&& (ntohl(tip) == dev_ip)) {
+						info->priv = cp;
+						return SUCCESS;
+					}
+				}
+			}
+
+			if (rtl_multiWan_net_dev) {
+				cp = (struct dev_priv *)
+					NETDRV_PRIV(rtl_multiWan_net_dev);
+				if (rtl_multiWan_net_dev && cp && cp->opened
+					&& (cp->portmask & (1 << pid))) {
+					if ((get_dev_ip_mask(cp->dev->name,
+								&dev_ip,
+								&dev_mask) == 0)
+						&& (ntohl(tip) == dev_ip)) {
+						info->priv = cp;
+						return SUCCESS;
+					}
+				}
+			}
+		}
+	}
+
+	return FAILED;
+}
+
+#if 0
+static int rtl865x_delMultiCastNetif(void)
+{
+	int ret = FAILED;
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	{
+		rtl865x_AclRule_t rule;
+		bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+		rule.ruleType_ = RTL865X_ACL_MAC;
+		rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+		rule.actionType_ = RTL865X_ACL_PERMIT;
+		ret = rtl865x_del_acl(&rule, multiCastNetIf,
+			RTL865X_ACL_SYSTEM_USED);
+	}
+#endif
+
+	ret = rtl865x_delNetif(multiCastNetIf);
+
+	if (ret == SUCCESS) {
+		ret = rtl865x_delVlan(MULTICAST_NETIF_VLAN_ID);
+	}
+	return ret;
+
+}
+
+int rtl865x_setMultiCastSrcMac(unsigned char *srcMac)
+{
+
+	if (srcMac == NULL) {
+		return FAILED;
+	}
+
+	memcpy(multiCastNetIfMac, srcMac, 6);
+
+	if (_rtl865x_getNetifByName(multiCastNetIf) != NULL) {
+		rtl865x_delMCastNetif();
+		rtl865x_addMCastNetif();
+	}
+
+	return SUCCESS;
+}
+#endif
+
+#endif
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN) || defined(CONFIG_RTL_MAC_BASED_NETIF)
+static int rtl865x_addMultiCastNetif(void)
+{
+	rtl865x_netif_t netif;
+	int ret = FAILED;
+
+	rtl865x_delVlan(MULTICAST_NETIF_VLAN_ID);
+	rtl865x_addVlan(MULTICAST_NETIF_VLAN_ID);
+#if defined(CONFIG_RTL_MAC_BASED_NETIF)
+	ret = rtl865x_addVlanPortMember(MULTICAST_NETIF_VLAN_ID,
+		RTL_WANPORT_MASK);
+	ret = rtl865x_setVlanFilterDatabase(MULTICAST_NETIF_VLAN_ID,
+		RTL_WAN_FID);
+#else
+	ret = rtl865x_addVlanPortMember(MULTICAST_NETIF_VLAN_ID,
+		rtl_multiWan_config.memPort);
+	ret = rtl865x_setVlanFilterDatabase(MULTICAST_NETIF_VLAN_ID,
+		rtl_multiWan_config.fid);
+#endif
+	if (_rtl865x_getNetifByName(multiCastNetIf) != NULL) {
+		return SUCCESS;
+	}
+
+	memset(&netif, 0, sizeof(rtl865x_netif_t));
+	strcpy(netif.name, multiCastNetIf);
+	memcpy(&netif.macAddr, multiCastNetIfMac, 6);
+	netif.mtu = 1500;
+	netif.if_type = IF_ETHER;
+	netif.vid = MULTICAST_NETIF_VLAN_ID;
+	netif.is_wan = 1;
+	netif.is_slave = 0;
+	netif.enableRoute = 1;
+	netif.forMacBasedMCast = TRUE;
+	/* printk("%s:%d,entry->lpNetif is %s \n",__FUNCTION__,__LINE__,entry->lpNetif); */
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL8197F)
+	netif.mtuV6 = 1500;
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT) || (defined(CONFIG_RTL_MLD_SNOOPING) && defined(CONFIG_RTL_HARDWARE_MULTICAST))
+	netif.enableRouteV6 = 1;	/*disable v6 router as this netif is multicast netif. */
+#endif
+#endif
+
+	ret = rtl865x_addNetif(&netif);
+	if (ret != SUCCESS) {
+		rtl865x_delVlan(MULTICAST_NETIF_VLAN_ID);
+		return FAILED;
+	}
+#if 1				/* defined(CONFIG_RTK_VLAN_SUPPORT) */
+	{
+		rtl865x_AclRule_t rule;
+		bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+		rule.ruleType_ = RTL865X_ACL_MAC;
+		rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+		rule.actionType_ = RTL865X_ACL_PERMIT;
+		ret = rtl865x_add_acl(&rule, multiCastNetIf,
+			RTL865X_ACL_SYSTEM_USED);
+	}
+#endif
+
+	return ret;
+}
+#endif
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+#ifdef CONFIG_RTL_PROC_NEW
+static int igmp_proxy_wan_dev_read_proc(struct seq_file *s, void *v)
+{
+
+	seq_printf(s, "Igmp proxy wan dev name is %s.\n", igmp_proxy_wan_dev);
+
+	return 0;
+}
+#else
+static int igmp_proxy_wan_dev_read_proc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+
+	len += sprintf(page + len, "Igmp proxy wan dev name is %s.\n",
+		igmp_proxy_wan_dev);
+
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int igmp_proxy_wan_dev_write_proc(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	char tmpBuf[32];
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		tmpBuf[count - 1] = '\0';
+		memset(igmp_proxy_wan_dev, 0, MAX_IFNAMESIZE);
+		strncpy(igmp_proxy_wan_dev, tmpBuf, MAX_IFNAMESIZE);
+
+		return count;
+	}
+	return -EFAULT;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+int igmp_proxy_wan_dev_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, igmp_proxy_wan_dev_read_proc, NULL));
+}
+
+static ssize_t igmp_proxy_wan_dev_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return igmp_proxy_wan_dev_write_proc(file, userbuf, count, off);
+}
+
+struct file_operations igmp_proxy_wan_dev_proc_fops = {
+	.open = igmp_proxy_wan_dev_single_open,
+	.write = igmp_proxy_wan_dev_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+static int32 rtl819x_igmp_proxy_wan_dev_proc_init(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("igmp_proxy_wan_dev", 0, &proc_root,
+		&igmp_proxy_wan_dev_proc_fops, NULL);
+#else
+	res_igmp_proxy_wan_dev =
+		create_proc_entry("igmp_proxy_wan_dev", 0, NULL);
+	if (res_igmp_proxy_wan_dev) {
+		res_igmp_proxy_wan_dev->read_proc =
+			igmp_proxy_wan_dev_read_proc;
+		res_igmp_proxy_wan_dev->write_proc =
+			igmp_proxy_wan_dev_write_proc;
+	}
+#endif
+	return 0;
+}
+
+void __exit rtl819x_igmp_proxy_wan_dev_proc_exit(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("igmp_proxy_wan_dev", &proc_root);
+#else
+	if (res_igmp_proxy_wan_dev) {
+		remove_proc_entry("igmp_proxy_wan_dev", res_igmp_proxy_wan_dev);
+		res_igmp_proxy_wan_dev = NULL;
+	}
+#endif
+}
+#endif
+
+#if defined(REINIT_SWITCH_CORE)
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+uint32 swtcr0_value = 0;
+uint32 plitimr_value = 0;
+extern int rtl819x_save_inused_route(void);
+extern int rtl819x_restore_inused_route(void);
+extern void rtl819x_save_hw_arp_table(void);
+extern void rtl819x_restore_hw_arp_table(void);
+extern int rtl819x_retore_hw_ip(void);
+extern void rtl819x_save_hw_ppp_table(void);
+extern void rtl819x_restore_hw_ppp_table(void);
+void rtl819x_save_netif_based_way(void)
+{
+	swtcr0_value = READ_MEM32(SWTCR0);
+	plitimr_value = READ_MEM32(PLITIMR);
+}
+
+void rtl819x_retore_netif_based_way(void)
+{
+	WRITE_MEM32(SWTCR0, swtcr0_value);
+	WRITE_MEM32(PLITIMR, plitimr_value);
+}
+
+void rtl819x_save_hw_tables(void)
+{
+	rtl819x_save_netif_based_way();
+	rtl819x_save_hw_arp_table();
+	rtl819x_save_hw_ppp_table();
+	rtl819x_save_inused_route();
+	#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+	rtl819x_save_ipv6_hw_tables();
+	#endif /* CONFIG_RTL_HARDWARE_IPV6_SUPPORT */
+}
+
+void rtl819x_restore_hw_tables(void)
+{
+	rtl819x_retore_netif_based_way();
+	rtl819x_retore_hw_ip();
+	rtl819x_restore_hw_l2_table();
+	rtl819x_restore_hw_ppp_table();
+	rtl819x_restore_inused_route();
+	rtl819x_restore_hw_arp_table();
+	#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+	rtl819x_restore_ipv6_hw_tables();
+	#endif /* CONFIG_RTL_HARDWARE_IPV6_SUPPORT */
+}
+
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+/* 981C_0000(CPUIR) */
+#define CPUIR_REG_NUM	43
+static uint32 cpuir_reg[CPUIR_REG_NUM];
+
+void rtd129x_save_cpuir_regs(void)
+{
+	int i;
+	unsigned long flags = 0;
+
+	/*disable switch core interrupt */
+	SMP_LOCK_ETH(flags);
+	REG32(CPUIIMR) = 0;
+	REG32(CPUIISR) = REG32(CPUIISR);
+	REG32(CPUICR) = 0;
+	REG32(SIRR) = 0;
+	SMP_UNLOCK_ETH(flags);
+
+	for (i = 0; i < CPUIR_REG_NUM; i++) {
+		cpuir_reg[i] = REG32(CPUICR + (i * 4));
+	}
+}
+
+void rtd129x_restore_cpuir_regs(void)
+{
+	int i;
+
+	for (i = 0; i < CPUIR_REG_NUM; i++) {
+		REG32(CPUICR + (i * 4)) = cpuir_reg[i];
+	}
+}
+
+/* 981C_4000(GPCR) */
+#define GPCR_REG_NUM	27
+static uint32 gpcr_reg[GPCR_REG_NUM];
+
+void rtd129x_save_gpcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < GPCR_REG_NUM; i++) {
+		gpcr_reg[i] = REG32(MACCR + (i * 4));
+	}
+}
+
+void rtd129x_restore_gpcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < GPCR_REG_NUM; i++) {
+		REG32(MACCR + (i * 4)) = gpcr_reg[i];
+	}
+}
+
+/* 981C_4100(PITCR) */
+#define PITCR_REG_NUM	46
+static uint32 pitcr_reg[PITCR_REG_NUM];
+
+void rtd129x_save_pitcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < PITCR_REG_NUM; i++) {
+		pitcr_reg[i] = REG32(PITCR + (i * 4));
+	}
+}
+
+void rtd129x_restore_pitcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < PITCR_REG_NUM; i++) {
+		REG32(PITCR + (i * 4)) = pitcr_reg[i];
+	}
+}
+
+/* 981C_4300(LEDCR) */
+#define LEDCR_REG_NUM	5
+static uint32 ledcr_reg[LEDCR_REG_NUM];
+
+void rtd129x_save_ledcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < LEDCR_REG_NUM; i++) {
+		ledcr_reg[i] = REG32(LEDCR0 + (i * 4));
+	}
+}
+
+void rtd129x_restore_ledcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < LEDCR_REG_NUM; i++) {
+		REG32(LEDCR0 + (i * 4)) = ledcr_reg[i];
+	}
+}
+
+/* 981C_4400(ALECR) */
+#define ALECR_REG_NUM	44
+static uint32 alecr_reg[ALECR_REG_NUM];
+
+void rtd129x_save_alecr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < ALECR_REG_NUM; i++) {
+		alecr_reg[i] = REG32(TEACR + (i * 4));
+	}
+}
+
+void rtd129x_restore_alecr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < ALECR_REG_NUM; i++) {
+		REG32(TEACR + (i * 4)) = alecr_reg[i];
+	}
+}
+
+/* 981C_4500(BMCR) */
+#define BMCR_REG_NUM	57
+static uint32 bmcr_reg[BMCR_REG_NUM];
+
+void rtd129x_save_bmcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < BMCR_REG_NUM; i++) {
+		bmcr_reg[i] = REG32(SBFCR0 + (i * 4));
+	}
+}
+
+void rtd129x_restore_bmcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < BMCR_REG_NUM; i++) {
+		REG32(SBFCR0 + (i * 4)) = bmcr_reg[i];
+	}
+}
+
+/* 981C_4700(QOSFR) */
+#define QOSFR_REG_NUM	32
+static uint32 qosfr_reg[QOSFR_REG_NUM];
+
+void rtd129x_save_qosfr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < QOSFR_REG_NUM; i++) {
+		qosfr_reg[i] = REG32(QOSFCR + (i * 4));
+	}
+}
+
+void rtd129x_restore_qosfr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < QOSFR_REG_NUM; i++) {
+		REG32(QOSFCR + (i * 4)) = qosfr_reg[i];
+	}
+}
+
+/* 981C_4800(MRGCR) */
+#define MRGCR_REG_NUM	65
+static uint32 mrgcr_reg[MRGCR_REG_NUM];
+
+void rtd129x_save_mrgcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < MRGCR_REG_NUM; i++) {
+		mrgcr_reg[i] = REG32(P0Q0RGCR + (i * 4));
+	}
+}
+
+void rtd129x_restore_mrgcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < MRGCR_REG_NUM; i++) {
+		REG32(P0Q0RGCR + (i * 4)) = mrgcr_reg[i];
+	}
+}
+
+/* 981C_4900(LBPCR) */
+#define LBPCR_REG_NUM	4
+static uint32 lbpcr_reg[LBPCR_REG_NUM];
+
+void rtd129x_save_lbpcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < LBPCR_REG_NUM; i++) {
+		lbpcr_reg[i] = REG32(ELBPCR + (i * 4));
+	}
+}
+
+void rtd129x_restore_lbpcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < LBPCR_REG_NUM; i++) {
+		REG32(ELBPCR + (i * 4)) = lbpcr_reg[i];
+	}
+}
+
+/* 981C_4A00(VCR) */
+#define VCR_REG_NUM	39
+static uint32 vcr_reg[VCR_REG_NUM];
+
+void rtd129x_save_vcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < VCR_REG_NUM; i++) {
+		vcr_reg[i] = REG32(VCR0 + (i * 4));
+	}
+}
+
+void rtd129x_restore_vcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < VCR_REG_NUM; i++) {
+		REG32(VCR0 + (i * 4)) = vcr_reg[i];
+	}
+}
+
+/* 981C_4B00(PBACR) */
+#define PBACR_REG_NUM	3
+static uint32 pbacr_reg[PBACR_REG_NUM];
+
+void rtd129x_save_pbacr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < PBACR_REG_NUM; i++) {
+		pbacr_reg[i] = REG32(DOT1XPORTCR + (i * 4));
+	}
+}
+
+void rtd129x_restore_pbacr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < PBACR_REG_NUM; i++) {
+		REG32(DOT1XPORTCR + (i * 4)) = pbacr_reg[i];
+	}
+}
+
+/* 981C_4C00(LACR) */
+#define LACR_REG_NUM	3
+static uint32 lacr_reg[LACR_REG_NUM];
+
+void rtd129x_save_lacr_regs(void)
+{
+	lacr_reg[0] = REG32(LAGHPMR0);
+	lacr_reg[2] = REG32(LAGCR0);
+}
+
+void rtd129x_restore_lacr_regs(void)
+{
+	REG32(LAGHPMR0) = lacr_reg[0];
+	REG32(LAGCR0) = lacr_reg[2];
+}
+
+/* 981C_5000(8PQGCR) */
+#define PQGCR_REG_NUM	62
+static uint32 pqgcr_reg[PQGCR_REG_NUM];
+
+void rtd129x_save_pqgcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < PQGCR_REG_NUM; i++) {
+		pqgcr_reg[i] = REG32(PQGCR8 + (i * 4));
+	}
+}
+
+void rtd129x_restore_pqgcr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < PQGCR_REG_NUM; i++) {
+		REG32(PQGCR8 + (i * 4)) = pqgcr_reg[i];
+	}
+}
+
+/* 981C_5100(EMACCR) */
+#define EMACCR_REG_NUM	17
+static uint32 emaccr_reg[EMACCR_REG_NUM];
+
+void rtd129x_save_emaccr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < EMACCR_REG_NUM; i++) {
+		emaccr_reg[i] = REG32(MACCTRL1 + (i * 4));
+	}
+}
+
+void rtd129x_restore_emaccr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < EMACCR_REG_NUM; i++) {
+		REG32(MACCTRL1 + (i * 4)) = emaccr_reg[i];
+	}
+}
+
+/* 981C_5200(IPv6CR) */
+#define IPV6CR_REG_NUM	25
+static uint32 ipv6cr_reg[IPV6CR_REG_NUM];
+
+void rtd129x_save_ipv6cr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < IPV6CR_REG_NUM; i++) {
+		ipv6cr_reg[i] = REG32(IPV6CR0 + (i * 4));
+	}
+}
+
+void rtd129x_restore_ipv6cr_regs(void)
+{
+	int i;
+
+	for (i = 0; i < IPV6CR_REG_NUM; i++) {
+		REG32(IPV6CR0 + (i * 4)) = ipv6cr_reg[i];
+	}
+}
+
+/* End of regs */
+void rtd129x_save_regs(void)
+{
+	rtd129x_save_cpuir_regs();
+	rtd129x_save_gpcr_regs();
+	rtd129x_save_pitcr_regs();
+	rtd129x_save_ledcr_regs();
+	rtd129x_save_alecr_regs();
+	rtd129x_save_bmcr_regs();
+	rtd129x_save_qosfr_regs();
+	rtd129x_save_mrgcr_regs();
+	rtd129x_save_lbpcr_regs();
+	rtd129x_save_vcr_regs();
+	rtd129x_save_lacr_regs();
+	rtd129x_save_pqgcr_regs();
+	rtd129x_save_emaccr_regs();
+	rtd129x_save_ipv6cr_regs();
+}
+
+void rtd129x_restore_regs(void)
+{
+	rtd129x_restore_cpuir_regs();
+	rtd129x_restore_gpcr_regs();
+	rtd129x_restore_pitcr_regs();
+	rtd129x_restore_ledcr_regs();
+	rtd129x_restore_alecr_regs();
+	rtd129x_restore_bmcr_regs();
+	rtd129x_restore_qosfr_regs();
+	rtd129x_restore_mrgcr_regs();
+	rtd129x_restore_lbpcr_regs();
+	rtd129x_restore_vcr_regs();
+	rtd129x_restore_lacr_regs();
+	rtd129x_restore_pqgcr_regs();
+	rtd129x_restore_emaccr_regs();
+	rtd129x_restore_ipv6cr_regs();
+}
+
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+int re865x_reProbe(void)
+{
+	rtl8651_tblAsic_InitPara_t para;
+	unsigned long flags = 0;
+#if defined(CONFIG_RTL_819XD) && defined(CONFIG_RTL_8211DS_SUPPORT) && defined(CONFIG_RTL_8197D)
+	uint32 reg_tmp = 0;
+#endif
+
+	SMP_LOCK_ETH(flags);
+	/* WRITE_MEM32(PIN_MUX_SEL_2, 0x7<<21); */
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	/*Initial ASIC table */
+	FullAndSemiReset();
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+	memset(&para, 0, sizeof(rtl8651_tblAsic_InitPara_t));
+
+	/*
+	 * For DEMO board layout, RTL865x platform define corresponding PHY setting and PHYID.
+	 */
+
+	INIT_CHECK(rtl865x_initAsicL2(&para));
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER_L3
+	INIT_CHECK(rtl865x_initAsicL3());
+#endif
+#if defined(CONFIG_RTL_LAYERED_ASIC_DRIVER_L4)
+	INIT_CHECK(rtl865x_initAsicL4());
+#endif
+
+	/*init PHY LED style */
+#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198)
+	/* config LED mode */
+	WRITE_MEM32(LEDCR, 0x00000000);	/* 15 LED */
+	WRITE_MEM32(SWTAA, PORT5_PHY_CONTROL);
+	WRITE_MEM32(TCR0, 0x000002C7);	/* 8651 demo board default: 15 LED boards */
+	WRITE_MEM32(SWTACR, CMD_FORCE | ACTION_START);	/* force add */
+#endif
+
+/*2007-12-19*/
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	/* port based decision */
+	rtl865xC_setNetDecisionPolicy(NETIF_PORT_BASED);
+	WRITE_MEM32(PLITIMR, 0);
+#endif
+
+#if defined(CONFIG_RTL_819XD) && defined(CONFIG_RTL_8211DS_SUPPORT) && defined(CONFIG_RTL_8197D)
+	rtl8651_getAsicEthernetPHYReg(0x6, 0, &reg_tmp);
+	rtl_setPortMask(reg_tmp);
+#endif
+
+	/*queue id & rx ring descriptor mapping */
+	REG32(CPUQDM0) =
+		QUEUEID1_RXRING_MAPPING | (QUEUEID0_RXRING_MAPPING << 16);
+	REG32(CPUQDM2) =
+		QUEUEID3_RXRING_MAPPING | (QUEUEID2_RXRING_MAPPING << 16);
+	REG32(CPUQDM4) =
+		QUEUEID5_RXRING_MAPPING | (QUEUEID4_RXRING_MAPPING << 16);
+
+	rtl8651_setAsicOutputQueueNumber(CPU, RTL_CPU_RX_RING_NUM);
+
+#if defined(CONFIG_RTL_HW_STP)
+	/* Initial: disable Realtek Hardware STP */
+	rtl865x_setSpanningEnable(FALSE);
+#endif
+
+#ifdef CONFIG_RTL_LAYERED_ASIC_DRIVER_L3
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST) && !defined(CONFIG_RTL_L2_HW_MULTICAST_SUPPORT)
+	rtl8651_setAsicMulticastEnable(TRUE);
+#else
+	rtl8651_setAsicMulticastEnable(FALSE);
+#endif
+#endif
+
+#ifdef CONFIG_RTL_8198_ESD
+	esd3_skip_one = 1;
+	one_second_counter = 0;
+	first_time_read_reg6 = 1;
+	phy_reg30[0] = phy_reg30[1] = phy_reg30[2] = phy_reg30[3] =
+		phy_reg30[4] = 0;
+#endif
+
+#ifdef CONFIG_RTL_8198
+	{
+		extern void disable_phy_power_down(void);
+		disable_phy_power_down();
+	}
+#endif
+
+#if defined(CONFIG_RTL_SWITCH_NEW_DESCRIPTOR)
+	REG32(CPUICR1) =
+		(REG32(CPUICR1) & ~CF_PKT_HDR_TYPE_MASK) |
+		TX_PKTHDR_SHORTCUT_LSO;
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+	REG32(CPUICR1) |= BIT(CF_RX_GATHER_OFFSET);
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_TSO) || defined(CONFIG_RTL_GSO)
+	REG32(CPUICR1) |= BIT(CF_TX_GATHER_OFFSET);
+#endif
+#endif
+
+	SMP_UNLOCK_ETH(flags);
+	return 0;
+}
+
+#define BSP_SW_IE           (1 << 15)
+int rtl865x_reinitSwitchCore(void)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	unsigned long flags = 0;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	rtl865x_duringReInitSwtichCore = 1;
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	/*disable switch core interrupt */
+	REG32(CPUIIMR) = 0;
+	REG32(CPUIISR) = REG32(CPUIISR);
+	REG32(GIMR) &= ~(BSP_SW_IE);
+	REG32(CPUICR) = 0;
+	REG32(SIRR) = 0;
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+	rtl819x_save_hw_tables();
+#endif
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+
+	re865x_reProbe();
+	RTL_swNic_reInit();
+	rtl865x_reChangeOpMode();
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+	rtl819x_restore_hw_tables();
+#endif
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT)
+	if (rtl_hw_vlan_enable)
+		rtl_hw_vlan_config();
+#endif
+
+#if defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTD_1295_HWNAT)
+	REG32(DMA_CR0) =
+		(REG32(DMA_CR0) & ~(LowFifoMark_MASK | HiFifoMark_MASK)) |
+		((0x80 << LowFifoMark_OFFSET) | 0xC0);
+	{
+		rtl865xc_tblAsic_aclTable_t tmp_rule;
+		memset(&tmp_rule, 0, sizeof(rtl865xc_tblAsic_aclTable_t));
+
+		_rtl8651_readAsicEntry(TYPE_ACL_RULE_TABLE, 0, &tmp_rule);
+		_rtl8651_forceAddAsicEntry(TYPE_ACL_RULE_TABLE, 0, &tmp_rule);
+	}
+#else /* CONFIG_RTD_1295_HWNAT */
+	REG32(DMA_CR0) =
+		(REG32(DMA_CR0) & ~(LowFifoMark_MASK | HiFifoMark_MASK)) |
+		((0x30 << LowFifoMark_OFFSET) | 0xD7);
+	REG32(0xbb0c0000) = REG32(0xbb0c0000);
+#endif /* CONFIG_RTD_1295_HWNAT */
+#endif
+
+	/*enable switch core interrupt */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	REG32(CPUICR) = TXCMD | RXCMD | BUSBURST_128WORDS | MBUF_2048BYTES;
+	REG32(CPUIISR) = REG32(CPUIISR);
+	REG32(CPUIIMR) =
+		RX_DONE_IE_ALL | TX_ALL_DONE_IE_ALL | LINK_CHANGE_IE |
+		PKTHDR_DESC_RUNOUT_IE_ALL;
+	REG32(SIRR) |= TRXRDY;
+#if !defined(CONFIG_RTD_1295_HWNAT)
+	REG32(GIMR) |= (BSP_SW_IE);
+#endif /* !defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	SMP_UNLOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	rtl865x_duringReInitSwtichCore = 0;
+	return 0;
+}
+
+#ifndef CONFIG_RTL_PROC_NEW	/* mark_bb */
+static struct proc_dir_entry *reInitSwitchCoreProc = NULL;
+#endif
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtl865x_reInitSwitchCoreReadProc(struct seq_file *s, void *v)
+{
+	return 0;
+}
+#else
+static int rtl865x_reInitSwitchCoreReadProc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int rtl865x_reInitSwitchCoreWriteProc(struct file *file,
+	const char *buffer, unsigned long count, void *data)
+{
+	char tmpBuf[256];
+	char *strptr;
+	char *tokptr;
+	unsigned int action;
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		tmpBuf[count - 1] = 0;
+		strptr = tmpBuf;
+
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errOut;
+		}
+
+		if (rtl865x_duringReInitSwtichCore) {
+			goto errOut;
+		}
+		/* printk("here to reset switch core\n"); */
+		action = simple_strtol(tokptr, NULL, 0);
+		if (action == 1) {
+			rtl865x_reinitSwitchCore();
+		}
+
+		return count;
+	}
+
+errOut:
+	return -EFAULT;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int rtl_check_swCore_tx_hang_read_proc(struct seq_file *s, void *v)
+{
+	seq_printf(s,
+		"check_tx_hang_interval=%d, reinit_swCore_threshold=%d, rtl_reinit_swCore_counter=%d\n",
+		rtl_check_swCore_tx_hang_interval, rtl_reinit_swCore_threshold,
+		rtl_reinit_swCore_counter);
+
+	return 0;
+}
+#else
+static struct proc_dir_entry *rtl_check_swCore_tx_hang_proc = NULL;
+static int rtl_check_swCore_tx_hang_read_proc(char *page, char **start,
+	off_t off, int count, int *eof, void *data)
+{
+	int len = 0;
+
+	len = sprintf(page,
+		"check_tx_hang_interval=%d, reinit_swCore_threshold=%d, rtl_reinit_swCore_counter=%d\n",
+		rtl_check_swCore_tx_hang_interval, rtl_reinit_swCore_threshold,
+		rtl_reinit_swCore_counter);
+
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int rtl_check_swCore_tx_hang_write_proc(struct file *file,
+	const char *buffer, unsigned long count, void *data)
+{
+	char tmpBuf[64];
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		int num =
+			sscanf(tmpBuf, "%d %d",
+			&rtl_check_swCore_tx_hang_interval,
+			&rtl_reinit_swCore_threshold);
+
+		if (num != 2) {
+			panic_printk("invalid parameter!\n");
+			goto errOut;
+		}
+
+		return count;
+	}
+
+errOut:
+	return -EFAULT;
+}
+
+int rtl865x_creatReInitSwitchCoreProc(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("reInitSwitchCore", 0, &proc_root,
+		&reInitSwitchCore_proc_fops, NULL);
+	proc_create_data("check_swCore_tx_hang", 0, &proc_root,
+		&rtl_check_swCore_tx_hang_proc_fops, NULL);
+#else
+	reInitSwitchCoreProc = create_proc_entry("reInitSwitchCore", 0, NULL);
+	if (reInitSwitchCoreProc) {
+		reInitSwitchCoreProc->read_proc =
+			rtl865x_reInitSwitchCoreReadProc;
+		reInitSwitchCoreProc->write_proc =
+			rtl865x_reInitSwitchCoreWriteProc;
+	}
+	rtl_check_swCore_tx_hang_proc =
+		create_proc_entry("check_swCore_tx_hang", 0, NULL);
+	if (rtl_check_swCore_tx_hang_proc) {
+		rtl_check_swCore_tx_hang_proc->read_proc =
+			rtl_check_swCore_tx_hang_read_proc;
+		rtl_check_swCore_tx_hang_proc->write_proc =
+			rtl_check_swCore_tx_hang_write_proc;
+	}
+#endif
+
+	return 0;
+}
+
+void __exit rtl865x_destroyReInitResetSwitchCore(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("reInitSwitchCore", &proc_root);
+	remove_proc_entry("check_swCore_tx_hang", &proc_root);
+#else
+	if (reInitSwitchCoreProc) {
+		remove_proc_entry("reInitSwitchCore", reInitSwitchCoreProc);
+		reInitSwitchCoreProc = NULL;
+	}
+	if (rtl_check_swCore_tx_hang_proc) {
+		remove_proc_entry("check_swCore_tx_hang",
+			rtl_check_swCore_tx_hang_proc);
+		rtl_check_swCore_tx_hang_proc = NULL;
+	}
+#endif
+}
+
+int rtl_check_swCore_tx_hang(void)
+{
+	int32 tx_done_index_tmp = 0;
+
+	if (!rtl_check_tx_hang_flag)
+		return 0;
+
+	/*jwj: Remove (rtl_swCore_tx_hang_cnt>0) to avoid misjudge swCore tx hang */
+	/* if ((rtl_swCore_tx_hang_cnt>0) ||(((rtl_check_swCore_timer++) % rtl_check_swCore_tx_hang_interval)==0)) { */
+	if (((rtl_check_swCore_timer++) % rtl_check_swCore_tx_hang_interval) ==
+		0) {
+		if (RTL_check_tx_own(&tx_done_index_tmp) == SUCCESS) {
+			if (rtl_last_tx_done_idx != tx_done_index_tmp) {
+				rtl_last_tx_done_idx = tx_done_index_tmp;
+				rtl_swCore_tx_hang_cnt = 1;
+			} else {
+				rtl_swCore_tx_hang_cnt++;
+			}
+		} else {
+			rtl_swCore_tx_hang_cnt = 0;
+		}
+
+		if (rtl_swCore_tx_hang_cnt >= rtl_reinit_swCore_threshold) {
+			panic_printk("SwCore tx hang is detected!\n");
+			rtl_swCore_tx_hang_cnt = 0;
+
+			if (rtl865x_duringReInitSwtichCore == 0) {
+				panic_printk("Switch will reinit now!\n");
+				rtl_reinit_swCore_counter++;
+				/* rtl865x_reinitSwitchCore(); */
+				return 1;
+			}
+		}
+	}
+
+	return 0;
+}
+
+#endif
+
+#ifdef CONFIG_RTK_VOIP_QOS
+int wan_port_check(int port)
+{
+	if (1 << port & RTL_WANPORT_MASK)
+		return TRUE;
+	else
+		return FALSE;
+}
+#endif
+
+#ifdef CONFIG_RTK_PORT_LINK
+int rtl_get_net_device_by_port(struct net_device **dev, unsigned int port)
+{
+	int i;
+	unsigned int port_mask = (RTL_LANPORT_MASK | RTL_WANPORT_MASK);
+	rtl865x_tblAsicDrv_vlanParam_t vlan;
+	unsigned int vid = 0;
+	unsigned char buff[16] = { 0 };
+	struct dev_priv *cp = NULL;
+
+#define RTL_PREFIX_NAME "eth0"
+
+	/* panic_printk("%s %d port=%d port_mask=0x%x \n", __FUNCTION__, __LINE__, port, port_mask); */
+	/* parameter check */
+	if (!((1 << port) & port_mask))
+		return FAILED;
+
+#if defined(CONFIG_SWCONFIG)
+	/* get the first vlan including this port, fix me?? */
+	if (swconfig_vlan_enable) {
+		for (i = 0; i < RTL865XC_VLANTBL_SIZE; i++) {
+			memset((void *)&vlan, 0x00, sizeof(vlan));
+			if (rtl8651_getAsicVlan(i, &vlan) == FAILED)
+				continue;
+			if (vlan.memberPortMask & (1 << port)) {
+				/* first match */
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+				vid = vlan.vid;
+#else
+				vid = i;
+#endif
+				memset((void *)&buff, '\0', sizeof(buff));
+				sprintf(buff, "%s.%d", RTL_PREFIX_NAME, vid);
+				/* panic_printk("%s %d buff=%s mask=0x%x \n", __FUNCTION__, __LINE__, buff, vlan.memberPortMask); */
+				if (dev) {
+					/* panic_printk("%s %d buff=%s \n", __FUNCTION__, __LINE__, buff); */
+					/* #if 0 */
+					if ((*dev = __dev_get_by_name(&init_net,
+								buff)) !=
+						NULL) {
+						/* panic_printk("%s %d buff=%s \n", __FUNCTION__, __LINE__, buff); */
+						return SUCCESS;
+					}
+					/* #endif */
+				}
+			}
+		}
+	} else {
+		for (i = 0; i < ETH_INTF_NUM; i++) {
+			cp = (struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.
+				dev[i]);
+			if (cp)
+				/* panic_printk("%s %d cp->portmask=0x%x i=%d\n", __FUNCTION__, __LINE__, cp->portmask, i); */
+				if (_rtl86xx_dev.dev[i] && cp && cp->opened
+					&& ((1 << port) & cp->portmask)) {
+					/* panic_printk("%s %d cp->portmask=0x%x i=%d\n", __FUNCTION__, __LINE__, cp->portmask, i); */
+					if (dev) {
+						*dev = _rtl86xx_dev.dev[i];
+						return SUCCESS;
+					}
+				}
+		}
+	}
+#else
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		cp = (struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[i]);
+		if (_rtl86xx_dev.dev[i] && cp && cp->opened
+			&& ((1 << port) & cp->portmask)) {
+			if (dev) {
+				*dev = _rtl86xx_dev.dev[i];
+				return SUCCESS;
+			}
+		}
+	}
+#endif
+
+	return FAILED;
+}
+
+static int ethernet_rtnl_fill_ifinfo(struct sk_buff *skb,
+	struct net_device *dev, int type, u32 pid, u32 seq, u32 change,
+	unsigned int flags, unsigned int status)
+{
+	struct ifinfomsg *ifm;
+	struct nlmsghdr *nlh;
+
+	nlh = nlmsg_put(skb, pid, seq, type, sizeof(*ifm), flags);
+	if (nlh == NULL)
+		return -ENOBUFS;
+
+	ifm = nlmsg_data(nlh);
+	ifm->ifi_family = AF_UNSPEC;
+	ifm->__ifi_pad = 0;
+	ifm->ifi_type = dev->type;
+	ifm->ifi_index = dev->ifindex;
+	ifm->ifi_flags = status;
+	ifm->ifi_change = change;
+
+	if (nla_put_string(skb, IFLA_IFNAME, dev->name))
+		goto nla_put_failure;
+
+	return nlmsg_end(skb, nlh);
+
+nla_put_failure:
+	nlmsg_cancel(skb, nlh);
+	return -EMSGSIZE;
+}
+
+static void ethernet_rtmsg_ifinfo(int type, struct net_device *dev,
+	unsigned change, unsigned int status)
+{
+	struct net *net = dev_net(dev);
+	struct sk_buff *skb;
+	int err = -ENOBUFS;
+
+	skb = nlmsg_new(NLMSG_GOODSIZE, GFP_ATOMIC);
+	if (skb == NULL)
+		goto errout;
+
+	err = ethernet_rtnl_fill_ifinfo(skb, dev, type, 0, 0, change, 0,
+		status);
+	if (err < 0) {
+		/* -EMSGSIZE implies BUG in if_nlmsg_size() */
+		WARN_ON(err == -EMSGSIZE);
+		kfree_skb(skb);
+		goto errout;
+	}
+	rtnl_notify(skb, net, 0, RTNLGRP_LINK, NULL, GFP_ATOMIC);
+	return;
+errout:
+	if (err < 0)
+		rtnl_set_sk_err(net, RTNLGRP_LINK, err);
+}
+#endif
+
+#ifdef CONFIG_RTK_VOIP_PORT_LINK
+static int rtnl_fill_ifinfo_voip(struct sk_buff *skb, struct net_device *dev,
+	int type, u32 pid, u32 seq, u32 change, unsigned int flags)
+{
+	struct ifinfomsg *ifm;
+	struct nlmsghdr *nlh;
+
+	nlh = nlmsg_put(skb, pid, seq, type, sizeof(*ifm), flags);
+	if (nlh == NULL)
+		return -ENOBUFS;
+
+	ifm = nlmsg_data(nlh);
+	ifm->ifi_family = AF_UNSPEC;
+	ifm->__ifi_pad = 0;
+	ifm->ifi_type = dev->type;
+	ifm->ifi_index = dev->ifindex;
+	ifm->ifi_flags = dev_get_flags(dev);
+	ifm->ifi_change = change;
+	return nlmsg_end(skb, nlh);
+}
+
+static void rtmsg_ifinfo_voip(int type, struct net_device *dev, unsigned change)
+{
+	struct net *net = dev_net(dev);
+	struct sk_buff *skb;
+	int err = -ENOBUFS;
+
+	skb = nlmsg_new(NLMSG_GOODSIZE, GFP_ATOMIC);
+	if (skb == NULL)
+		goto errout;
+
+	err = rtnl_fill_ifinfo_voip(skb, dev, type, 0, 0, change, 0);
+	if (err < 0) {
+		/* -EMSGSIZE implies BUG in if_nlmsg_size() */
+		WARN_ON(err == -EMSGSIZE);
+		kfree_skb(skb);
+		goto errout;
+	}
+	rtnl_notify(skb, net, 0, RTNLGRP_LINK, NULL, GFP_ATOMIC);
+	return;
+errout:
+	if (err < 0)
+		rtnl_set_sk_err(net, RTNLGRP_LINK, err);
+}
+#endif
+
+#if defined(CONFIG_RTL_SOCK_DEBUG)
+static struct proc_dir_entry *rtl865x_sockDebugProc = NULL;
+extern int dumpRawSockInfo(char *buf);
+extern int dumpUdpSockInfo(char *buf);
+extern int dumpTcpSockInfo(char *buf);
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 rtl865x_sockDebugReadProc(struct seq_file *s, void *v)
+{
+	dumpRawSockInfo();
+	dumpUdpSockInfo();
+	dumpTcpSockInfo();
+	return 0;
+}
+#else
+static int rtl865x_sockDebugReadProc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+
+	len += dumpRawSockInfo(page + len);
+	len += dumpUdpSockInfo(page + len);
+	len += dumpTcpSockInfo(page + len);
+
+	return len;
+}
+#endif
+
+static int rtl865x_sockDebugWriteProc(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	return count;
+}
+
+int rtl865x_creatSockDebugProc(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("sockDebug", 0, &proc_root, &sockDebug_proc_fops,
+		NULL);
+#else
+	rtl865x_sockDebugProc = create_proc_entry("sockDebug", 0, NULL);
+	if (rtl865x_sockDebugProc) {
+		rtl865x_sockDebugProc->read_proc = rtl865x_sockDebugReadProc;
+		rtl865x_sockDebugProc->write_proc = rtl865x_sockDebugWriteProc;
+	}
+#endif
+
+	return 0;
+}
+
+void __exit rtl865x_removeSockDebugProc(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("sockDebug", &proc_root);
+#else
+	if (rtl865x_sockDebugProc) {
+		remove_proc_entry("sockDebug", rtl865x_sockDebugProc);
+		rtl865x_sockDebugProc = NULL;
+	}
+#endif
+}
+#endif
+
+#ifdef CONFIG_RTL_ULINKER
+void eth_led_recover(void)
+{
+	REG32(PIN_MUX_SEL_2) = REG32(PIN_MUX_SEL_2) & ~(0x00003000);
+}
+#endif
+
+#if defined(RTL8198_EEE_MAC)
+extern void eee_phy_enable_98(void);
+extern void eee_phy_disable_98(void);
+#endif
+
+#ifndef CONFIG_RTL_PROC_NEW
+static struct proc_dir_entry *res_eee = NULL;
+#endif
+extern void enable_EEE(void);
+extern void disable_EEE(void);
+
+static int32 rtl819x_eee_proc_init(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("eee", 0, &proc_root, &eee_proc_fops, NULL);
+#else
+	res_eee = create_proc_entry("eee", 0, NULL);
+	if (res_eee) {
+		res_eee->read_proc = eee_read_proc;
+		res_eee->write_proc = eee_write_proc;
+	}
+#endif
+	return 0;
+}
+
+void __exit rtl819x_eee_proc_exit(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("eee", &proc_root);
+#else
+	if (res_eee) {
+		remove_proc_entry("eee", res_eee);
+		res_eee = NULL;
+	}
+#endif
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int eee_read_proc(struct seq_file *s, void *v)
+{
+#if defined(CONFIG_RTL_8198C)
+	int i;
+	seq_printf(s, "EEE setting:\n");
+
+	for (i = 0; i < 4; i++) {
+		seq_printf(s, "port %d: eee %sabled.\n", i,
+			((REG32(EEECR) & BIT(i * 8)) ? "en" : "dis"));
+	}
+	seq_printf(s, "port 4: eee %sabled.\n",
+		((REG32(EEEABICR1) & BIT(0)) ? "en" : "dis"));
+
+#ifdef CONFIG_RTL_8198C_8367RB
+	{
+		uint32 enable;
+		int ret, j;
+		extern int rtk_eee_portEnable_get(uint32 port, uint32 *enable);
+		seq_printf(s, "\nRTL8367RB EEE status:\n");
+		for (j = 0; j < 5; j++) {
+			ret = rtk_eee_portEnable_get(j, &enable);
+			if (ret != 0)
+				seq_printf(s,
+					"  port %d: read 8367RB EEE status error.\n",
+					j);
+			else
+				seq_printf(s,
+					"  port %d: 8367RB EEE %sabled.\n", j,
+					((enable == 1) ? "en" : "dis"));
+		}
+	}
+#endif
+#else
+	seq_printf(s, "eee %sabled.\n", ((eee_enabled) ? "en" : "dis"));
+#endif
+	return 0;
+}
+#else
+static int eee_read_proc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len = 0;
+
+	len += sprintf(page + len, "eee %sabled.\n",
+		((eee_enabled) ? "en" : "dis"));
+
+	if (len <= off + count)
+		*eof = 1;
+
+	*start = page + off;
+	len -= off;
+
+	if (len > count)
+		len = count;
+
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif
+
+static int eee_write_proc(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	char tmpBuf[32];
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+#if defined(CONFIG_RTL_8198C)
+		int mode;
+		uint32 port_mask = 0x1f;
+		char *strptr, *tokptr;
+		extern void set_8198C_EEE(int mode, uint32 port_mask);
+
+		if ((tmpBuf[0] == '0') || (tmpBuf[0] == '1')) {
+			mode = tmpBuf[0] - '0';
+			eee_enabled = mode;
+
+			if (count >= 3) {
+				tmpBuf[count] = '\0';
+				strptr = tmpBuf + 2;
+
+				tokptr = strsep(&strptr, " ");
+				if (tokptr != NULL) {
+					port_mask =
+						simple_strtol(tokptr, NULL, 16);
+				}
+			}
+
+			set_8198C_EEE(mode, port_mask);
+
+#ifdef CONFIG_RTL_8198C_8367RB
+			{
+				int i;
+				extern int rtk_eee_portEnable_set(uint32 port,
+					uint32 enable);
+				for (i = 0; i < 5; i++)
+					rtk_eee_portEnable_set(i, mode);
+			}
+#endif
+		} else {
+			return -EFAULT;
+		}
+#else
+		if (tmpBuf[0] == '0') {
+			eee_enabled = FALSE;
+			disable_EEE();
+		} else if (tmpBuf[0] == '1') {
+			eee_enabled = TRUE;
+			enable_EEE();
+		} else {
+			return -EFAULT;
+		}
+#endif
+
+#ifdef CONFIG_RTL_8198_ESD
+		esd3_skip_one = 1;
+#endif
+		return count;
+	}
+	return -EFAULT;
+}
+
+#ifdef CONFIG_RTL865X_LANPORT_RESTRICTION
+char *rtl_getDevNameByPort(int32 port_num)
+{
+	int i;
+	struct dev_priv *cp;
+
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		cp = ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[i]));
+		if (_rtl86xx_dev.dev[i] && cp && cp->opened
+			&& (cp->portmask & (1 << port_num)))
+			return cp->dev->name;
+	}
+
+	return NULL;
+}
+#endif
+
+#ifdef CONFIG_RTL_JATE_TEST
+
+#include <linux/random.h>
+
+#define PKT_LEN		1500
+#define DEF_PKT_INTERVAL 		50	/* uint: ms */
+static const unsigned char eth_da_sa[] = {
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x12, 0x34, 0x56, 0x78, 0x9a
+};
+
+/*
+static const unsigned char pkt02[] = {
+  0x01 ,0x00 ,0x5e ,0x00 ,0x00 ,0x01 ,0x00 ,0x11  ,0x85 ,0xae ,0x7f ,0x2c ,0x08 ,0x00 ,0x45 ,0x00,
+  0x00 ,0x76 ,0xbb ,0xfb ,0x00 ,0x00 ,0x01 ,0x11  ,0x3b ,0x65 ,0xac ,0x12 ,0x35 ,0x03 ,0xe1 ,0x00,
+  0x00 ,0x01 ,0x27 ,0x0f ,0x27 ,0x0f ,0x00 ,0x62  ,0xc6 ,0x39 ,0x54 ,0x19 ,0x98 ,0x04 ,0xf4 ,0x03,
+  0x52 ,0x00 ,0x91 ,0x65 ,0x30 ,0x35 ,0x39 ,0x31  ,0x38 ,0x33 ,0x38 ,0x33 ,0x36 ,0x37 ,0x30 ,0x36,
+  0x00 ,0x62 ,0x12 ,0x00 ,0x38 ,0x31 ,0x36 ,0x38  ,0x34 ,0x30 ,0x30 ,0x00 ,0x26 ,0x00 ,0xe8 ,0x61,
+  0x00 ,0x00 ,0x36 ,0x36 ,0x34 ,0x36 ,0x38 ,0x36  ,0x32 ,0x32 ,0x00 ,0x38 ,0x31 ,0x37 ,0x39 ,0x39,
+  0x33 ,0x31 ,0x38 ,0x36 ,0x00 ,0x39 ,0x33 ,0x36  ,0x32 ,0x00 ,0x00 ,0x30 ,0x00 ,0x00 ,0x02 ,0x00,
+  0x00 ,0x17 ,0x1e ,0x00 ,0x01 ,0x00 ,0x00 ,0x00  ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00,
+  0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00
+}; */
+
+#ifndef CONFIG_RTL_PROC_NEW
+static struct proc_dir_entry *res_jate = NULL;
+#endif
+
+static int32 rtl819x_jate_proc_init(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("jate", 0, &proc_root, &jate_proc_fops, NULL);
+#else
+	res_jate = create_proc_entry("jate", 0, NULL);
+	if (res_jate) {
+		res_jate->read_proc = jate_read_proc;
+		res_jate->write_proc = jate_write_proc;
+	}
+#endif
+	return 0;
+}
+
+void __exit rtl819x_jate_proc_exit(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("jate", &proc_root);
+#else
+	if (res_jate) {
+		remove_proc_entry("jate", res_jate);
+		res_jate = NULL;
+	}
+#endif
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int jate_read_proc(struct seq_file *s, void *v)
+{
+	return 0;
+}
+#else
+static int jate_read_proc(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	return 0;
+}
+#endif
+
+static int jate_write_proc(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[64];
+	uint32 port, mode, tx_time, tx_cnt, interval = DEF_PKT_INTERVAL;
+	int i, j;
+	char *strptr, *cmd_addr, *tokptr;
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+	extern int set_83XX_speed_mode(int port, int type);
+#else
+	uint32 phy_mode;
+#endif
+
+	if (len > 64) {
+		goto errout;
+	}
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			goto errout;
+		}
+
+		if (!memcmp(cmd_addr, "port", 4)) {
+			port = (uint32)simple_strtol(tokptr, NULL, 0);
+			if (port > 5)
+				goto errout;
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+#if defined(CONFIG_RTL_8367R_SUPPORT) || defined(CONFIG_RTL_8370_SUPPORT)
+			/* refer to port_status_write() in rtl865x_proc_debug.c */
+			if (!memcmp(tokptr, "10H", 3)) {
+				mode = HALF_DUPLEX_10M;
+			} else if (!memcmp(tokptr, "10F", 3)) {
+				mode = DUPLEX_10M;
+			} else if (!memcmp(tokptr, "100H", 4)) {
+				mode = HALF_DUPLEX_100M;
+			} else if (!memcmp(tokptr, "100F", 4)) {
+				mode = DUPLEX_100M;
+			} else if (!memcmp(tokptr, "1000F", 5)) {
+				mode = DUPLEX_1000M;
+			} else if (!memcmp(tokptr, "Auto", 4)) {
+				mode = PORT_AUTO;
+			} else
+				goto errout;
+
+			if (port == 5) {
+				for (i = 0; i < 5; i++) {
+					set_83XX_speed_mode(i, mode);
+				}
+			} else {
+				set_83XX_speed_mode(port, mode);
+			}
+#else
+			if (!memcmp(tokptr, "10H", 3)) {
+				mode = EnForceMode | ForceLink;
+				phy_mode = 0;
+			} else if (!memcmp(tokptr, "10F", 3)) {
+				mode = EnForceMode | ForceLink | ForceDuplex;
+				phy_mode = SELECT_FULL_DUPLEX;
+			} else if (!memcmp(tokptr, "100H", 4)) {
+				mode = EnForceMode | ForceLink | ForceSpeed100M;
+				phy_mode = SPEED_SELECT_100M;
+			} else if (!memcmp(tokptr, "100F", 4)) {
+				mode = EnForceMode | ForceLink | ForceSpeed100M
+					| ForceDuplex;
+				phy_mode =
+					SPEED_SELECT_100M | SELECT_FULL_DUPLEX;
+			} else if (!memcmp(tokptr, "Auto", 4)) {
+				mode = NwayAbility10MH | NwayAbility10MF |
+					NwayAbility100MH | NwayAbility100MF |
+					NwayAbility1000MF;
+				phy_mode = ENABLE_AUTONEGO | SELECT_FULL_DUPLEX;
+			} else
+				goto errout;
+
+			if (port == 5) {
+				for (i = 0; i < 5; i++) {
+					/* REG32(PCRP0+(i*4)) |= EnForceMode; */
+					/* rtl8651_setAsicEthernetPHYReg( i, 0, POWER_DOWN ); */
+					/* mdelay(1000); */
+					REG32(PCRP0 + (i * 4)) =
+						(REG32(PCRP0 +
+							(i * 4)) &
+						~(0x03fc0000)) | mode;
+					rtl8651_setAsicEthernetPHYReg(i, 0,
+						(phy_mode | RESTART_AUTONEGO));
+					/* rtl8651_restartAsicEthernetPHYNway(i); */
+				}
+			} else {
+				/* REG32(PCRP0+(port*4)) |= EnForceMode; */
+				/* rtl8651_setAsicEthernetPHYReg( port, 0, POWER_DOWN ); */
+				/* mdelay(1000); */
+				REG32(PCRP0 + (port * 4)) =
+					(REG32(PCRP0 +
+						(port * 4)) & ~(0x03fc0000)) |
+					mode;
+				rtl8651_setAsicEthernetPHYReg(port, 0,
+					(phy_mode | RESTART_AUTONEGO));
+				/* rtl8651_restartAsicEthernetPHYNway(port); */
+			}
+#endif
+
+			panic_printk("successfully set port %d to %s", port,
+				tokptr);
+		}
+
+		else if (!memcmp(cmd_addr, "tx", 2)) {
+			port = (uint32)simple_strtol(tokptr, NULL, 16);	/* portmask, port 0 = 1<<0, port 1 = 1<<1, and so on */
+			if (port < 1 || port > 0x1f)
+				goto errout;
+
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			mode = simple_strtol(tokptr, NULL, 0);	/* 0 - random data pattern; 1 - all0 data pattern; 2 - all1 data pattern */
+			if (mode > 2)
+				goto errout;
+
+			/* packet output time: valid value is from 1 to 1000 */
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL)
+				goto errout;
+
+			tx_time = simple_strtol(tokptr, NULL, 0);	/* 1 ~ 1000, unit: second */
+			if (tx_time < 1 || tx_time > 1000)
+				goto errout;
+
+			/* packet output interval: valid value is from 1 to 500; optional argument; 50ms by default */
+			tokptr = strsep(&strptr, " ");
+			if (tokptr != NULL) {
+				interval = simple_strtol(tokptr, NULL, 0);	/* 1 ~ 500, unit: ms */
+				if (interval < 1 || interval > 500)
+					goto errout;
+			}
+
+			{
+				struct sk_buff *skb;
+				rtl_nicTx_info nicTx;
+				/* unsigned long wtval; */
+
+#ifdef CONFIG_RTL_WTDOG
+				/* wtval = *((volatile unsigned long *)WDTCNR); */
+				/* *((volatile unsigned long *)WDTCNR) = (WDSTOP_PATTERN << WDTE_OFFSET); */
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+				unsigned long flags = 0;
+
+				SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+				REG32(CPUIIMR) &= ~RX_DONE_IE_ALL;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+				SMP_UNLOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+				nicTx.txIdx = 0;
+				nicTx.vid = RTL_LANVLANID;
+				nicTx.portlist = port;
+				nicTx.srcExtPort = 0;
+				nicTx.flags = (PKTHDR_USED | PKT_OUTGOING);
+
+				tx_cnt = tx_time * 1000 / interval;
+				panic_printk("test packet transmitting...");
+				for (j = 0; j < tx_cnt; j++)	/* for sending multiple packets */
+				{
+					alloc_rx_buf((void **)&skb, MBUF_LEN);
+
+					memcpy(skb->data, eth_da_sa,
+						sizeof(eth_da_sa));
+					*(unsigned short *)(skb->data + 12) =
+						PKT_LEN;
+
+					if (mode == 0) {
+						for (i = 0; i < MBUF_LEN;
+							i += 4)
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+							*(unsigned int *)(skb->data + 14 + i) = prandom_u32();	/* skb->data is 2 bytes alignment */
+#else
+							*(unsigned int *)(skb->data + 14 + i) = random32();	/* skb->data is 2 bytes alignment */
+#endif
+					} else if (mode == 1)
+						memset(skb->data + 14, 0,
+							PKT_LEN);
+					else if (mode == 2)
+						memset(skb->data + 14, 0xff,
+							PKT_LEN);
+
+					/* skb->len = sizeof(pkt02); */
+					skb->len = PKT_LEN + 14;
+					/* memcpy(skb->data, pkt02, skb->len); */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+					RTL_CACHE_WBACK((unsigned long)skb->
+						data, skb->len);
+#else
+/* RTL_CACHE_WBACK((unsigned long) skb->data, skb->len); */
+#endif
+					RTL_swNic_send((void *)skb,
+						(void *)skb->data, skb->len,
+						&nicTx);
+					mdelay(interval);
+					if (j % (1000 / interval) == 0)
+						panic_printk(".");
+
+#if defined(CONFIG_RTL_WTDOG)
+					rtl_periodic_watchdog_kick(j,
+						WATCHDOG_NUM_OF_TIMES);
+#endif
+				}
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+				SMP_LOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+				REG32(CPUIIMR) |= RX_DONE_IE_ALL;
+#if defined(CONFIG_RTD_1295_HWNAT)
+				SMP_UNLOCK_ETH(flags);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#ifdef CONFIG_RTL_WTDOG
+				/* *((volatile unsigned long *)WDTCNR) |=  WDTCLR; */
+				/* *((volatile unsigned long *)WDTCNR) = wtval; */
+#endif
+				panic_printk
+					("\n  ==> %d packet(s) with type %d sent out to portmask 0x%x, packet interval: %d ms.\n",
+					tx_cnt, mode, port, interval);
+			}
+
+		} else {
+			goto errout;
+		}
+	} else {
+errout:
+		panic_printk("invalid command.\n");
+	}
+
+	return len;
+}
+#endif
+
+#if defined(CONFIG_TR181_ETH)
+
+#define NUMOFIFENTRY		5
+#define NUMOFLINKENTRY		2
+
+typedef struct {
+	unsigned long long BytesSent;
+	unsigned long long BytesReceived;
+	unsigned long long PacketsSent;
+	unsigned long long PacketsReceived;
+	unsigned int ErrorsSent;
+	unsigned int ErrorsReceived;
+	unsigned long long UnicastPacketsSent;
+	unsigned long long UnicastPacketsReceived;
+	unsigned int DiscardPacketsSent;
+	unsigned int DiscardPacketsReceived;
+	unsigned long long MulticastPacketsSent;
+	unsigned long long MulticastPacketsReceived;
+	unsigned long long BroadcastPacketsSent;
+	unsigned long long BroadcastPacketsReceived;
+} tr181_eth_if_stats;
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int tr181_eth_link_read(struct seq_file *s, void *v)
+{
+	int i, j;
+
+	for (i = 0; i < NUMOFLINKENTRY; i++) {
+		if (!(_rtl86xx_dev.dev[i]) || !NETDRV_PRIV(_rtl86xx_dev.dev[i]))
+			continue;
+
+		if (((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[i]))->
+			opened)
+			seq_printf(s, "eth%d: %s %s ", i, "true", "Up");
+		else
+			seq_printf(s, "eth%d: %s %s ", i, "false", "Down");
+
+		seq_printf(s, "%s %d ", _rtl86xx_dev.dev[i]->name,
+			get_uptime_by_sec() - if_change_time[i]);
+
+		for (j = 0; j < 5; j++)
+			seq_printf(s, "%02x:",
+				_rtl86xx_dev.dev[i]->dev_addr[j]);
+
+		seq_printf(s, "%02x", _rtl86xx_dev.dev[i]->dev_addr[j]);
+
+		seq_printf(s, "\n");
+	}
+	return 0;
+}
+#else
+static int tr181_eth_link_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len = 0, i, j;
+
+	for (i = 0; i < NUMOFLINKENTRY; i++) {
+		if (!(_rtl86xx_dev.dev[i]) || !NETDRV_PRIV(_rtl86xx_dev.dev[i]))
+			continue;
+
+		if (((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[i]))->
+			opened)
+			len += sprintf(page + len, "eth%d: %s %s ", i, "true",
+				"Up");
+		else
+			len += sprintf(page + len, "eth%d: %s %s ", i, "false",
+				"Down");
+
+		len += sprintf(page + len, "%s %d ", _rtl86xx_dev.dev[i]->name,
+			get_uptime_by_sec() - if_change_time[i]);
+
+		for (j = 0; j < 5; j++)
+			len += sprintf(page + len, "%02x:",
+				_rtl86xx_dev.dev[i]->dev_addr[j]);
+
+		len += sprintf(page + len, "%02x",
+			_rtl86xx_dev.dev[i]->dev_addr[j]);
+
+		len += sprintf(page + len, "\n");
+	}
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+	return len;
+}
+#endif
+
+static int tr181_eth_link_write(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	return count;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int tr181_eth_if_read(struct seq_file *s, void *v)
+{
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	int i;
+	for (i = 0; i < (NUMOFIFENTRY + 3); i++) {
+		extern int rtk_port_phyStatus_get(uint32 port,
+			uint32 *pLinkStatus, uint32 *pSpeed, uint32 *pDuplex);
+		uint32 status = 0, speed = PortStatusLinkSpeed10M, duplex = 0;
+
+		if (i == 5 || i == 6)
+			continue;
+
+		if (i == 7) {
+			if (port_change_time[6] == 0)
+				seq_printf(s, "port%d: %s %s ", i, "false",
+					"Down");
+			else
+				seq_printf(s, "port%d: %s %s ", i, "true",
+					"Up");
+
+			seq_printf(s, "%d ",
+				get_uptime_by_sec() - port_change_time[i]);
+			seq_printf(s, "%s %d %s\n", "false", -1, "Auto");
+			continue;
+		}
+		rtk_port_phyStatus_get(i, &status, &speed, &duplex);
+
+		if (status == 0)
+			seq_printf(s, "port%d: %s %s ", i, "false", "Down");
+		else
+			seq_printf(s, "port%d: %s %s ", i, "true", "Up");
+
+		seq_printf(s, "%d ", get_uptime_by_sec() - port_change_time[i]);
+		seq_printf(s, "%s ", (i == RTL83XX_WAN) ? "true" : "false");
+		seq_printf(s, "%d ",
+			(speed == PortStatusLinkSpeed1000M) ? 1000 : (speed ==
+				PortStatusLinkSpeed100M) ? 100 : 10);
+		seq_printf(s, "%s\n", (duplex) ? "Full" : "Half");
+	}
+#else
+#endif
+	return 0;
+}
+#else
+static int tr181_eth_if_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len = 0;
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	int i;
+	for (i = 0; i < (NUMOFIFENTRY + 3); i++) {
+		extern int rtk_port_phyStatus_get(uint32 port,
+			uint32 *pLinkStatus, uint32 *pSpeed, uint32 *pDuplex);
+		uint32 status = 0, speed = PortStatusLinkSpeed10M, duplex = 0;
+
+		if (i == 5 || i == 6)
+			continue;
+
+		if (i == 7) {
+			if (port_change_time[6] == 0)
+				len += sprintf(page + len, "port%d: %s %s ", i,
+					"false", "Down");
+			else
+				len += sprintf(page + len, "port%d: %s %s ", i,
+					"true", "Up");
+
+			len += sprintf(page + len, "%d ",
+				get_uptime_by_sec() - port_change_time[i]);
+			len += sprintf(page + len, "%s %d %s\n", "false", -1,
+				"Auto");
+			continue;
+		}
+		rtk_port_phyStatus_get(i, &status, &speed, &duplex);
+
+		if (status == 0)
+			len += sprintf(page + len, "port%d: %s %s ", i, "false",
+				"Down");
+		else
+			len += sprintf(page + len, "port%d: %s %s ", i, "true",
+				"Up");
+
+		len += sprintf(page + len, "%d ",
+			get_uptime_by_sec() - port_change_time[i]);
+		len += sprintf(page + len, "%s ",
+			(i == RTL83XX_WAN) ? "true" : "false");
+		len += sprintf(page + len, "%d ",
+			(speed == PortStatusLinkSpeed1000M) ? 1000 : (speed ==
+				PortStatusLinkSpeed100M) ? 100 : 10);
+		len += sprintf(page + len, "%s\n", (duplex) ? "Full" : "Half");
+	}
+#else
+#endif
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+	return len;
+}
+#endif
+
+static int tr181_eth_if_write(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	return count;
+}
+
+static tr181_eth_if_stats eth0_stats, eth1_stats;
+
+#define ENABLE_8367RB_RGMII2	1
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int tr181_eth_stats_read(struct seq_file *s, void *v)
+{
+#ifdef CONFIG_RTL_8367R_SUPPORT
+	int i;
+#endif
+	uint32 eth0_portmask = 0, eth1_portmask = 0;
+
+	/* refer to net/core/dev.c dev_seq_show() and dev_seq_printf_stats() */
+	seq_printf(s, "%s%s", "Inter-|   Receive                            ",
+		"                    |  Transmit\n");
+	seq_printf(s, "%s%s%s", " face |bytes    packets errs drop fifo frame ",
+		"compressed multicast|bytes    packets errs ",
+		"drop fifo colls carrier compressed");
+
+	seq_printf(s, "%s", "  rx_uc  rx_bc  tx_uc  tx_mc  tx_bc\n");
+
+	if ((_rtl86xx_dev.dev[0]) && NETDRV_PRIV(_rtl86xx_dev.dev[0]))
+		eth0_portmask =
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->
+			portmask;
+
+	if ((_rtl86xx_dev.dev[1]) && NETDRV_PRIV(_rtl86xx_dev.dev[1]))
+		eth1_portmask =
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->
+			portmask;
+
+	memset(&eth0_stats, 0, sizeof(tr181_eth_if_stats));
+	memset(&eth1_stats, 0, sizeof(tr181_eth_if_stats));
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+#ifdef ENABLE_8367RB_RGMII2
+	for (i = 0; i < 8; i++)
+#else
+	for (i = 0; i < 5; i++)
+#endif
+	{
+#ifdef ENABLE_8367RB_RGMII2
+		if (i == 5 || i == 6)
+			continue;
+#endif
+
+		rtk_stat_port_getAll(i, &port_cntrs);
+
+		seq_printf(s, "port%d: %llu %u %u %u  0  0  0  %u  ", i,
+			port_cntrs.ifInOctets,
+			port_cntrs.ifInUcastPkts +
+			port_cntrs.etherStatsMcastPkts +
+			port_cntrs.etherStatsBcastPkts,
+			port_cntrs.dot3StatsFCSErrors +
+			port_cntrs.dot3StatsSymbolErrors,
+			port_cntrs.dot1dTpPortInDiscards,
+			port_cntrs.etherStatsMcastPkts);
+
+		seq_printf(s, "%llu %u %u %u  0  0  0 0  ",
+			port_cntrs.ifOutOctets,
+			port_cntrs.ifOutUcastPkts +
+			port_cntrs.ifOutMulticastPkts +
+			port_cntrs.ifOutBrocastPkts,
+			port_cntrs.etherStatsCollisions,
+			port_cntrs.dot1dBasePortDelayExceededDiscards);
+
+		seq_printf(s, "%u %u %u %u  %u\n",
+			port_cntrs.ifInUcastPkts,
+			port_cntrs.etherStatsBcastPkts,
+			port_cntrs.ifOutUcastPkts,
+			port_cntrs.ifOutMulticastPkts,
+			port_cntrs.ifOutBrocastPkts);
+
+		if (eth0_portmask & (1 << i)) {
+			eth0_stats.BytesSent += port_cntrs.ifOutOctets;
+			eth0_stats.BytesReceived += port_cntrs.ifInOctets;
+			eth0_stats.ErrorsSent +=
+				port_cntrs.etherStatsCollisions;
+			eth0_stats.ErrorsReceived +=
+				port_cntrs.dot3StatsFCSErrors +
+				port_cntrs.dot3StatsSymbolErrors;
+			eth0_stats.UnicastPacketsSent +=
+				port_cntrs.ifOutUcastPkts;
+			eth0_stats.UnicastPacketsReceived +=
+				port_cntrs.ifInUcastPkts;
+			eth0_stats.DiscardPacketsSent +=
+				port_cntrs.dot1dBasePortDelayExceededDiscards;
+			eth0_stats.DiscardPacketsReceived +=
+				port_cntrs.dot1dTpPortInDiscards;
+			eth0_stats.MulticastPacketsSent +=
+				port_cntrs.ifOutMulticastPkts;
+			eth0_stats.MulticastPacketsReceived +=
+				port_cntrs.etherStatsMcastPkts;
+			eth0_stats.BroadcastPacketsSent +=
+				port_cntrs.ifOutBrocastPkts;
+			eth0_stats.BroadcastPacketsReceived +=
+				port_cntrs.etherStatsBcastPkts;
+			eth0_stats.PacketsSent +=
+				port_cntrs.ifOutUcastPkts +
+				port_cntrs.ifOutMulticastPkts +
+				port_cntrs.ifOutBrocastPkts;
+			eth0_stats.PacketsReceived +=
+				port_cntrs.ifInUcastPkts +
+				port_cntrs.etherStatsMcastPkts +
+				port_cntrs.etherStatsBcastPkts;
+		}
+		if (eth1_portmask & (1 << i)) {
+			eth1_stats.BytesSent += port_cntrs.ifOutOctets;
+			eth1_stats.BytesReceived += port_cntrs.ifInOctets;
+			eth1_stats.ErrorsSent +=
+				port_cntrs.etherStatsCollisions;
+			eth1_stats.ErrorsReceived +=
+				port_cntrs.dot3StatsFCSErrors +
+				port_cntrs.dot3StatsSymbolErrors;
+			eth1_stats.UnicastPacketsSent +=
+				port_cntrs.ifOutUcastPkts;
+			eth1_stats.UnicastPacketsReceived +=
+				port_cntrs.ifInUcastPkts;
+			eth1_stats.DiscardPacketsSent +=
+				port_cntrs.dot1dBasePortDelayExceededDiscards;
+			eth1_stats.DiscardPacketsReceived +=
+				port_cntrs.dot1dTpPortInDiscards;
+			eth1_stats.MulticastPacketsSent +=
+				port_cntrs.ifOutMulticastPkts;
+			eth1_stats.MulticastPacketsReceived +=
+				port_cntrs.etherStatsMcastPkts;
+			eth1_stats.BroadcastPacketsSent +=
+				port_cntrs.ifOutBrocastPkts;
+			eth1_stats.BroadcastPacketsReceived +=
+				port_cntrs.etherStatsBcastPkts;
+			eth1_stats.PacketsSent +=
+				port_cntrs.ifOutUcastPkts +
+				port_cntrs.ifOutMulticastPkts +
+				port_cntrs.ifOutBrocastPkts;
+			eth1_stats.PacketsReceived +=
+				port_cntrs.ifInUcastPkts +
+				port_cntrs.etherStatsMcastPkts +
+				port_cntrs.etherStatsBcastPkts;
+		}
+	}
+
+	seq_printf(s, "eth0: %llu %llu %u %u  0  0  0  %llu  ",
+		eth0_stats.BytesReceived, eth0_stats.PacketsReceived,
+		eth0_stats.ErrorsReceived, eth0_stats.DiscardPacketsReceived,
+		eth0_stats.MulticastPacketsReceived);
+
+	seq_printf(s, "%llu %llu %u %u  0  0  0 0  ",
+		eth0_stats.BytesSent, eth0_stats.PacketsSent,
+		eth0_stats.ErrorsSent, eth0_stats.DiscardPacketsSent);
+
+	seq_printf(s, "%llu %llu %llu %llu  %llu\n",
+		eth0_stats.UnicastPacketsReceived,
+		eth0_stats.BroadcastPacketsReceived,
+		eth0_stats.UnicastPacketsSent, eth0_stats.MulticastPacketsSent,
+		eth0_stats.BroadcastPacketsSent);
+
+	seq_printf(s, "eth1: %llu %llu %u %u  0  0  0  %llu  ",
+		eth1_stats.BytesReceived, eth1_stats.PacketsReceived,
+		eth1_stats.ErrorsReceived, eth1_stats.DiscardPacketsReceived,
+		eth1_stats.MulticastPacketsReceived);
+
+	seq_printf(s, "%llu %llu %u %u  0  0  0 0  ",
+		eth1_stats.BytesSent, eth1_stats.PacketsSent,
+		eth1_stats.ErrorsSent, eth1_stats.DiscardPacketsSent);
+
+	seq_printf(s, "%llu %llu %llu %llu  %llu\n",
+		eth1_stats.UnicastPacketsReceived,
+		eth1_stats.BroadcastPacketsReceived,
+		eth1_stats.UnicastPacketsSent, eth1_stats.MulticastPacketsSent,
+		eth1_stats.BroadcastPacketsSent);
+
+#else
+/*
+	for(i = 0; i < 5; i++)
+	{
+		uint32 addrOffset_fromP0 = i * MIB_ADDROFFSETBYPORT;
+
+		if (portmask & (1 << i)) {
+			pStats->BytesSent += rtl865xC_returnAsicCounter64( OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0 );
+			pStats->BytesReceived += rtl865xC_returnAsicCounter64( OFFSET_IFINOCTETS_P0 + addrOffset_fromP0 );
+			pStats->ErrorsSent += rtl8651_returnAsicCounter( OFFSET_ETHERSTATSCOLLISIONS_P0 + addrOffset_fromP0 );
+			pStats->ErrorsReceived += rtl8651_returnAsicCounter( OFFSET_DOT3STATSFCSERRORS_P0 + addrOffset_fromP0 );
+			pStats->UnicastPacketsSent += rtl8651_returnAsicCounter( OFFSET_IFOUTUCASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->UnicastPacketsReceived += rtl8651_returnAsicCounter( OFFSET_IFINUCASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->DiscardPacketsSent += rtl8651_returnAsicCounter( OFFSET_IFOUTDISCARDS + addrOffset_fromP0 );
+			pStats->DiscardPacketsReceived += rtl8651_returnAsicCounter( OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0 );
+			pStats->MulticastPacketsSent += rtl8651_returnAsicCounter( OFFSET_IFOUTMULTICASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->MulticastPacketsReceived += rtl8651_returnAsicCounter( OFFSET_ETHERSTATSMULTICASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->BroadcastPacketsSent += rtl8651_returnAsicCounter( OFFSET_IFOUTBROADCASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->BroadcastPacketsReceived += rtl8651_returnAsicCounter( OFFSET_ETHERSTATSBROADCASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->PacketsSent += pStats->UnicastPacketsSent + pStats->MulticastPacketsSent + pStats->BroadcastPacketsSent;
+			pStats->PacketsReceived += pStats->UnicastPacketsReceived + pStats->MulticastPacketsReceived + pStats->BroadcastPacketsReceived;
+		}
+	}
+*/
+#endif
+	return 0;
+}
+#else
+static int tr181_eth_stats_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len = 0;
+#ifdef CONFIG_RTL_8367R_SUPPORT
+	int i;
+#endif
+	uint32 eth0_portmask = 0, eth1_portmask = 0;
+
+	/* refer to net/core/dev.c dev_seq_show() and dev_seq_printf_stats() */
+	len += sprintf(page + len, "%s%s",
+		"Inter-|   Receive                            ",
+		"                    |  Transmit\n");
+	len += sprintf(page + len, "%s%s%s",
+		" face |bytes    packets errs drop fifo frame ",
+		"compressed multicast|bytes    packets errs ",
+		"drop fifo colls carrier compressed");
+
+	len += sprintf(page + len, "%s",
+		"  rx_uc  rx_bc  tx_uc  tx_mc  tx_bc\n");
+
+	if ((_rtl86xx_dev.dev[0]) && NETDRV_PRIV(_rtl86xx_dev.dev[0]))
+		eth0_portmask =
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->
+			portmask;
+
+	if ((_rtl86xx_dev.dev[1]) && NETDRV_PRIV(_rtl86xx_dev.dev[1]))
+		eth1_portmask =
+			((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->
+			portmask;
+
+	memset(&eth0_stats, 0, sizeof(tr181_eth_if_stats));
+	memset(&eth1_stats, 0, sizeof(tr181_eth_if_stats));
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+#ifdef ENABLE_8367RB_RGMII2
+	for (i = 0; i < 8; i++)
+#else
+	for (i = 0; i < 5; i++)
+#endif
+	{
+#ifdef ENABLE_8367RB_RGMII2
+		if (i == 5 || i == 6)
+			continue;
+#endif
+
+		rtk_stat_port_getAll(i, &port_cntrs);
+
+		len += sprintf(page + len,
+			"port%d: %llu %u %u %u  0  0  0  %u  ", i,
+			port_cntrs.ifInOctets,
+			port_cntrs.ifInUcastPkts +
+			port_cntrs.etherStatsMcastPkts +
+			port_cntrs.etherStatsBcastPkts,
+			port_cntrs.dot3StatsFCSErrors +
+			port_cntrs.dot3StatsSymbolErrors,
+			port_cntrs.dot1dTpPortInDiscards,
+			port_cntrs.etherStatsMcastPkts);
+
+		len += sprintf(page + len, "%llu %u %u %u  0  0  0 0  ",
+			port_cntrs.ifOutOctets,
+			port_cntrs.ifOutUcastPkts +
+			port_cntrs.ifOutMulticastPkts +
+			port_cntrs.ifOutBrocastPkts,
+			port_cntrs.etherStatsCollisions,
+			port_cntrs.dot1dBasePortDelayExceededDiscards);
+
+		len += sprintf(page + len, "%u %u %u %u  %u\n",
+			port_cntrs.ifInUcastPkts,
+			port_cntrs.etherStatsBcastPkts,
+			port_cntrs.ifOutUcastPkts,
+			port_cntrs.ifOutMulticastPkts,
+			port_cntrs.ifOutBrocastPkts);
+
+		if (eth0_portmask & (1 << i)) {
+			eth0_stats.BytesSent += port_cntrs.ifOutOctets;
+			eth0_stats.BytesReceived += port_cntrs.ifInOctets;
+			eth0_stats.ErrorsSent +=
+				port_cntrs.etherStatsCollisions;
+			eth0_stats.ErrorsReceived +=
+				port_cntrs.dot3StatsFCSErrors +
+				port_cntrs.dot3StatsSymbolErrors;
+			eth0_stats.UnicastPacketsSent +=
+				port_cntrs.ifOutUcastPkts;
+			eth0_stats.UnicastPacketsReceived +=
+				port_cntrs.ifInUcastPkts;
+			eth0_stats.DiscardPacketsSent +=
+				port_cntrs.dot1dBasePortDelayExceededDiscards;
+			eth0_stats.DiscardPacketsReceived +=
+				port_cntrs.dot1dTpPortInDiscards;
+			eth0_stats.MulticastPacketsSent +=
+				port_cntrs.ifOutMulticastPkts;
+			eth0_stats.MulticastPacketsReceived +=
+				port_cntrs.etherStatsMcastPkts;
+			eth0_stats.BroadcastPacketsSent +=
+				port_cntrs.ifOutBrocastPkts;
+			eth0_stats.BroadcastPacketsReceived +=
+				port_cntrs.etherStatsBcastPkts;
+			eth0_stats.PacketsSent +=
+				port_cntrs.ifOutUcastPkts +
+				port_cntrs.ifOutMulticastPkts +
+				port_cntrs.ifOutBrocastPkts;
+			eth0_stats.PacketsReceived +=
+				port_cntrs.ifInUcastPkts +
+				port_cntrs.etherStatsMcastPkts +
+				port_cntrs.etherStatsBcastPkts;
+		}
+		if (eth1_portmask & (1 << i)) {
+			eth1_stats.BytesSent += port_cntrs.ifOutOctets;
+			eth1_stats.BytesReceived += port_cntrs.ifInOctets;
+			eth1_stats.ErrorsSent +=
+				port_cntrs.etherStatsCollisions;
+			eth1_stats.ErrorsReceived +=
+				port_cntrs.dot3StatsFCSErrors +
+				port_cntrs.dot3StatsSymbolErrors;
+			eth1_stats.UnicastPacketsSent +=
+				port_cntrs.ifOutUcastPkts;
+			eth1_stats.UnicastPacketsReceived +=
+				port_cntrs.ifInUcastPkts;
+			eth1_stats.DiscardPacketsSent +=
+				port_cntrs.dot1dBasePortDelayExceededDiscards;
+			eth1_stats.DiscardPacketsReceived +=
+				port_cntrs.dot1dTpPortInDiscards;
+			eth1_stats.MulticastPacketsSent +=
+				port_cntrs.ifOutMulticastPkts;
+			eth1_stats.MulticastPacketsReceived +=
+				port_cntrs.etherStatsMcastPkts;
+			eth1_stats.BroadcastPacketsSent +=
+				port_cntrs.ifOutBrocastPkts;
+			eth1_stats.BroadcastPacketsReceived +=
+				port_cntrs.etherStatsBcastPkts;
+			eth1_stats.PacketsSent +=
+				port_cntrs.ifOutUcastPkts +
+				port_cntrs.ifOutMulticastPkts +
+				port_cntrs.ifOutBrocastPkts;
+			eth1_stats.PacketsReceived +=
+				port_cntrs.ifInUcastPkts +
+				port_cntrs.etherStatsMcastPkts +
+				port_cntrs.etherStatsBcastPkts;
+		}
+	}
+
+	len += sprintf(page + len, "eth0: %llu %llu %u %u  0  0  0  %llu  ",
+		eth0_stats.BytesReceived, eth0_stats.PacketsReceived,
+		eth0_stats.ErrorsReceived, eth0_stats.DiscardPacketsReceived,
+		eth0_stats.MulticastPacketsReceived);
+
+	len += sprintf(page + len, "%llu %llu %u %u  0  0  0 0  ",
+		eth0_stats.BytesSent, eth0_stats.PacketsSent,
+		eth0_stats.ErrorsSent, eth0_stats.DiscardPacketsSent);
+
+	len += sprintf(page + len, "%llu %llu %llu %llu  %llu\n",
+		eth0_stats.UnicastPacketsReceived,
+		eth0_stats.BroadcastPacketsReceived,
+		eth0_stats.UnicastPacketsSent, eth0_stats.MulticastPacketsSent,
+		eth0_stats.BroadcastPacketsSent);
+
+	len += sprintf(page + len, "eth1: %llu %llu %u %u  0  0  0  %llu  ",
+		eth1_stats.BytesReceived, eth1_stats.PacketsReceived,
+		eth1_stats.ErrorsReceived, eth1_stats.DiscardPacketsReceived,
+		eth1_stats.MulticastPacketsReceived);
+
+	len += sprintf(page + len, "%llu %llu %u %u  0  0  0 0  ",
+		eth1_stats.BytesSent, eth1_stats.PacketsSent,
+		eth1_stats.ErrorsSent, eth1_stats.DiscardPacketsSent);
+
+	len += sprintf(page + len, "%llu %llu %llu %llu  %llu\n",
+		eth1_stats.UnicastPacketsReceived,
+		eth1_stats.BroadcastPacketsReceived,
+		eth1_stats.UnicastPacketsSent, eth1_stats.MulticastPacketsSent,
+		eth1_stats.BroadcastPacketsSent);
+
+#else
+/*
+	for(i = 0; i < 5; i++)
+	{
+		uint32 addrOffset_fromP0 = i * MIB_ADDROFFSETBYPORT;
+
+		if (portmask & (1 << i)) {
+			pStats->BytesSent += rtl865xC_returnAsicCounter64( OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0 );
+			pStats->BytesReceived += rtl865xC_returnAsicCounter64( OFFSET_IFINOCTETS_P0 + addrOffset_fromP0 );
+			pStats->ErrorsSent += rtl8651_returnAsicCounter( OFFSET_ETHERSTATSCOLLISIONS_P0 + addrOffset_fromP0 );
+			pStats->ErrorsReceived += rtl8651_returnAsicCounter( OFFSET_DOT3STATSFCSERRORS_P0 + addrOffset_fromP0 );
+			pStats->UnicastPacketsSent += rtl8651_returnAsicCounter( OFFSET_IFOUTUCASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->UnicastPacketsReceived += rtl8651_returnAsicCounter( OFFSET_IFINUCASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->DiscardPacketsSent += rtl8651_returnAsicCounter( OFFSET_IFOUTDISCARDS + addrOffset_fromP0 );
+			pStats->DiscardPacketsReceived += rtl8651_returnAsicCounter( OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0 );
+			pStats->MulticastPacketsSent += rtl8651_returnAsicCounter( OFFSET_IFOUTMULTICASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->MulticastPacketsReceived += rtl8651_returnAsicCounter( OFFSET_ETHERSTATSMULTICASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->BroadcastPacketsSent += rtl8651_returnAsicCounter( OFFSET_IFOUTBROADCASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->BroadcastPacketsReceived += rtl8651_returnAsicCounter( OFFSET_ETHERSTATSBROADCASTPKTS_P0 + addrOffset_fromP0 );
+			pStats->PacketsSent += pStats->UnicastPacketsSent + pStats->MulticastPacketsSent + pStats->BroadcastPacketsSent;
+			pStats->PacketsReceived += pStats->UnicastPacketsReceived + pStats->MulticastPacketsReceived + pStats->BroadcastPacketsReceived;
+		}
+	}
+*/
+#endif
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+	return len;
+}
+#endif
+
+static int tr181_eth_stats_write(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	return count;
+}
+
+#undef TRUE
+#define TRUE 1
+
+#undef FALSE
+#define FALSE 0
+
+typedef struct {
+	unsigned int InterfaceNumberOfEntries;
+	unsigned int LinkNumberOfEntries;
+} tr181_ethernet;
+
+typedef struct {
+	int Enable;
+	unsigned char Status[16];
+	unsigned int LastChange;
+	int Upstream;
+	int MaxBitRate;
+	unsigned char DuplexMode[6];
+} tr181_eth_interface;
+
+#define TR181_ETH_IF_DUPLEX_HALF	0
+#define TR181_ETH_IF_DUPLEX_FULL	1
+#define TR181_ETH_IF_DUPLEX_AUTO	2
+
+typedef struct {
+	int Enable;
+	unsigned char Status[16];
+	unsigned char Name[16];
+	unsigned char MACAddress[16];
+	unsigned int LastChange;
+} tr181_eth_link;
+
+/* typedef tr181_eth_if_stats tr181_eth_link_stats; */
+
+/* ======================================================== */
+/* ========== get function */
+/* ======================================================== */
+
+int tr181_get_eth(tr181_ethernet *pEth)
+{
+	pEth->InterfaceNumberOfEntries = NUMOFIFENTRY;
+	pEth->LinkNumberOfEntries = NUMOFLINKENTRY;
+
+	return 0;
+}
+
+int tr181_get_eth_if(int if_link_num, tr181_eth_interface *pIf)
+{
+	if (if_link_num < 0 || if_link_num >= NUMOFIFENTRY)
+		return (-1);
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	{
+		extern int rtk_port_phyStatus_get(uint32 port,
+			uint32 *pLinkStatus, uint32 *pSpeed, uint32 *pDuplex);
+		uint32 status, speed, duplex;
+
+		if ((rtk_port_phyStatus_get(if_link_num, &status, &speed,
+					&duplex)) == 0) {
+
+			if (status == 0) {
+				pIf->Enable = FALSE;
+				strcpy(pIf->Status, "Down");
+			} else {
+				pIf->Enable = TRUE;
+				strcpy(pIf->Status, "Up");
+
+				if (duplex)
+					strcpy(pIf->DuplexMode, "Full");
+				else
+					strcpy(pIf->DuplexMode, "Half");
+
+				if (speed == PortStatusLinkSpeed100M)
+					pIf->MaxBitRate = 100;
+				else if (speed == PortStatusLinkSpeed1000M)
+					pIf->MaxBitRate = 1000;
+				else
+					pIf->MaxBitRate = 10;
+			}
+		}
+		if (if_link_num == RTL83XX_WAN)
+			pIf->Upstream = TRUE;
+		else
+			pIf->Upstream = FALSE;
+
+		pIf->LastChange =
+			get_uptime_by_sec() - port_change_time[if_link_num];
+	}
+#else
+#endif
+
+	return 0;
+}
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+extern rtk_stat_port_cntr_t port_cntrs;
+#endif
+
+int tr181_get_eth_if_stats(int if_link_num, tr181_eth_if_stats *pStats)
+{
+	if (if_link_num < 0 || if_link_num >= NUMOFIFENTRY)
+		return (-1);
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+
+	rtk_stat_port_getAll(if_link_num, &port_cntrs);
+
+	pStats->BytesSent = port_cntrs.ifOutOctets;
+	pStats->BytesReceived = port_cntrs.ifInOctets;
+	pStats->ErrorsSent = port_cntrs.etherStatsCollisions;
+	pStats->ErrorsReceived =
+		port_cntrs.dot3StatsFCSErrors +
+		port_cntrs.dot3StatsSymbolErrors;
+	pStats->UnicastPacketsSent = port_cntrs.ifOutUcastPkts;
+	pStats->UnicastPacketsReceived = port_cntrs.ifInUcastPkts;
+	pStats->DiscardPacketsSent =
+		port_cntrs.dot1dBasePortDelayExceededDiscards;
+	pStats->DiscardPacketsReceived = port_cntrs.dot1dTpPortInDiscards;
+	pStats->MulticastPacketsSent = port_cntrs.ifOutMulticastPkts;
+	pStats->MulticastPacketsReceived = port_cntrs.etherStatsMcastPkts;
+	pStats->BroadcastPacketsSent = port_cntrs.ifOutBrocastPkts;
+	pStats->BroadcastPacketsReceived = port_cntrs.etherStatsBcastPkts;
+	pStats->PacketsSent =
+		pStats->UnicastPacketsSent + pStats->MulticastPacketsSent +
+		pStats->BroadcastPacketsSent;
+	pStats->PacketsReceived =
+		pStats->UnicastPacketsReceived +
+		pStats->MulticastPacketsReceived +
+		pStats->BroadcastPacketsReceived;
+
+#else
+	{
+		uint32 addrOffset_fromP0 = if_link_num * MIB_ADDROFFSETBYPORT;
+
+		pStats->BytesSent =
+			rtl865xC_returnAsicCounter64(OFFSET_IFOUTOCTETS_P0 +
+			addrOffset_fromP0);
+		pStats->BytesReceived =
+			rtl865xC_returnAsicCounter64(OFFSET_IFINOCTETS_P0 +
+			addrOffset_fromP0);
+		pStats->ErrorsSent =
+			rtl8651_returnAsicCounter(OFFSET_ETHERSTATSCOLLISIONS_P0
+			+ addrOffset_fromP0);
+		pStats->ErrorsReceived =
+			rtl8651_returnAsicCounter(OFFSET_DOT3STATSFCSERRORS_P0 +
+			addrOffset_fromP0);
+		pStats->UnicastPacketsSent =
+			rtl8651_returnAsicCounter(OFFSET_IFOUTUCASTPKTS_P0 +
+			addrOffset_fromP0);
+		pStats->UnicastPacketsReceived =
+			rtl8651_returnAsicCounter(OFFSET_IFINUCASTPKTS_P0 +
+			addrOffset_fromP0);
+		pStats->DiscardPacketsSent =
+			rtl8651_returnAsicCounter(OFFSET_IFOUTDISCARDS +
+			addrOffset_fromP0);
+		pStats->DiscardPacketsReceived =
+			rtl8651_returnAsicCounter
+			(OFFSET_DOT1DTPPORTINDISCARDS_P0 + addrOffset_fromP0);
+		pStats->MulticastPacketsSent =
+			rtl8651_returnAsicCounter(OFFSET_IFOUTMULTICASTPKTS_P0 +
+			addrOffset_fromP0);
+		pStats->MulticastPacketsReceived =
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSMULTICASTPKTS_P0 + addrOffset_fromP0);
+		pStats->BroadcastPacketsSent =
+			rtl8651_returnAsicCounter(OFFSET_IFOUTBROADCASTPKTS_P0 +
+			addrOffset_fromP0);
+		pStats->BroadcastPacketsReceived =
+			rtl8651_returnAsicCounter
+			(OFFSET_ETHERSTATSBROADCASTPKTS_P0 + addrOffset_fromP0);
+		pStats->PacketsSent =
+			pStats->UnicastPacketsSent +
+			pStats->MulticastPacketsSent +
+			pStats->BroadcastPacketsSent;
+		pStats->PacketsReceived =
+			pStats->UnicastPacketsReceived +
+			pStats->MulticastPacketsReceived +
+			pStats->BroadcastPacketsReceived;
+	}
+#endif
+
+	return 0;
+}
+
+int tr181_get_eth_link(int if_link_num, tr181_eth_link *pLink)
+{
+	int i;
+
+	if (if_link_num < 0 || if_link_num >= NUMOFLINKENTRY)
+		return (-1);
+
+	if (!(_rtl86xx_dev.dev[if_link_num])
+		|| !NETDRV_PRIV(_rtl86xx_dev.dev[if_link_num]))
+		return (-1);
+
+	pLink->Enable =
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.
+			dev[if_link_num]))->opened;
+	if (pLink->Enable == TRUE)
+		strcpy(pLink->Status, "Up");
+	else
+		strcpy(pLink->Status, "Down");
+
+	strcpy(pLink->Name, _rtl86xx_dev.dev[if_link_num]->name);
+
+	for (i = 0; i < 6; i++)
+		sprintf(pLink->MACAddress + (i * 2), "%02x",
+			_rtl86xx_dev.dev[if_link_num]->dev_addr[i]);
+	pLink->LastChange = get_uptime_by_sec() - if_change_time[if_link_num];
+
+	return 0;
+}
+
+int tr181_get_eth_link_stats(int if_link_num, tr181_eth_if_stats *pStats)
+{
+	uint32 portmask;
+	int i;
+
+	if (if_link_num < 0 || if_link_num >= NUMOFLINKENTRY)
+		return (-1);
+
+	if (!(_rtl86xx_dev.dev[if_link_num])
+		|| !NETDRV_PRIV(_rtl86xx_dev.dev[if_link_num]))
+		return (-1);
+
+	portmask =
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.
+			dev[if_link_num]))->portmask;
+	memset(pStats, 0, sizeof(tr181_eth_if_stats));
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+	for (i = 0; i < 5; i++) {
+		if (portmask & (1 << i)) {
+			rtk_stat_port_getAll(i, &port_cntrs);
+
+			pStats->BytesSent += port_cntrs.ifOutOctets;
+			pStats->BytesReceived += port_cntrs.ifInOctets;
+			pStats->ErrorsSent += port_cntrs.etherStatsCollisions;
+			pStats->ErrorsReceived +=
+				port_cntrs.dot3StatsFCSErrors +
+				port_cntrs.dot3StatsSymbolErrors;
+			pStats->UnicastPacketsSent += port_cntrs.ifOutUcastPkts;
+			pStats->UnicastPacketsReceived +=
+				port_cntrs.ifInUcastPkts;
+			pStats->DiscardPacketsSent +=
+				port_cntrs.dot1dBasePortDelayExceededDiscards;
+			pStats->DiscardPacketsReceived +=
+				port_cntrs.dot1dTpPortInDiscards;
+			pStats->MulticastPacketsSent +=
+				port_cntrs.ifOutMulticastPkts;
+			pStats->MulticastPacketsReceived +=
+				port_cntrs.etherStatsMcastPkts;
+			pStats->BroadcastPacketsSent +=
+				port_cntrs.ifOutBrocastPkts;
+			pStats->BroadcastPacketsReceived +=
+				port_cntrs.etherStatsBcastPkts;
+			pStats->PacketsSent +=
+				pStats->UnicastPacketsSent +
+				pStats->MulticastPacketsSent +
+				pStats->BroadcastPacketsSent;
+			pStats->PacketsReceived +=
+				pStats->UnicastPacketsReceived +
+				pStats->MulticastPacketsReceived +
+				pStats->BroadcastPacketsReceived;
+		}
+	}
+#else
+	for (i = 0; i < 5; i++) {
+		uint32 addrOffset_fromP0 = i * MIB_ADDROFFSETBYPORT;
+
+		if (portmask & (1 << i)) {
+			pStats->BytesSent +=
+				rtl865xC_returnAsicCounter64
+				(OFFSET_IFOUTOCTETS_P0 + addrOffset_fromP0);
+			pStats->BytesReceived +=
+				rtl865xC_returnAsicCounter64
+				(OFFSET_IFINOCTETS_P0 + addrOffset_fromP0);
+			pStats->ErrorsSent +=
+				rtl8651_returnAsicCounter
+				(OFFSET_ETHERSTATSCOLLISIONS_P0 +
+				addrOffset_fromP0);
+			pStats->ErrorsReceived +=
+				rtl8651_returnAsicCounter
+				(OFFSET_DOT3STATSFCSERRORS_P0 +
+				addrOffset_fromP0);
+			pStats->UnicastPacketsSent +=
+				rtl8651_returnAsicCounter
+				(OFFSET_IFOUTUCASTPKTS_P0 + addrOffset_fromP0);
+			pStats->UnicastPacketsReceived +=
+				rtl8651_returnAsicCounter
+				(OFFSET_IFINUCASTPKTS_P0 + addrOffset_fromP0);
+			pStats->DiscardPacketsSent +=
+				rtl8651_returnAsicCounter(OFFSET_IFOUTDISCARDS +
+				addrOffset_fromP0);
+			pStats->DiscardPacketsReceived +=
+				rtl8651_returnAsicCounter
+				(OFFSET_DOT1DTPPORTINDISCARDS_P0 +
+				addrOffset_fromP0);
+			pStats->MulticastPacketsSent +=
+				rtl8651_returnAsicCounter
+				(OFFSET_IFOUTMULTICASTPKTS_P0 +
+				addrOffset_fromP0);
+			pStats->MulticastPacketsReceived +=
+				rtl8651_returnAsicCounter
+				(OFFSET_ETHERSTATSMULTICASTPKTS_P0 +
+				addrOffset_fromP0);
+			pStats->BroadcastPacketsSent +=
+				rtl8651_returnAsicCounter
+				(OFFSET_IFOUTBROADCASTPKTS_P0 +
+				addrOffset_fromP0);
+			pStats->BroadcastPacketsReceived +=
+				rtl8651_returnAsicCounter
+				(OFFSET_ETHERSTATSBROADCASTPKTS_P0 +
+				addrOffset_fromP0);
+			pStats->PacketsSent +=
+				pStats->UnicastPacketsSent +
+				pStats->MulticastPacketsSent +
+				pStats->BroadcastPacketsSent;
+			pStats->PacketsReceived +=
+				pStats->UnicastPacketsReceived +
+				pStats->MulticastPacketsReceived +
+				pStats->BroadcastPacketsReceived;
+		}
+	}
+#endif
+
+	return 0;
+}
+
+/* ======================================================== */
+/* ========== set function */
+/* ======================================================== */
+
+int tr181_set_eth_if_enable(int if_link_num, int enable)
+{
+	extern int rtk_rgmii_set(int enable);
+
+	if (if_link_num < 0 || if_link_num >= (NUMOFIFENTRY + 3))
+		return (-1);
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+	if (enable == FALSE) {
+		extern int rtk_port_adminEnable_set(uint32 port, uint32 enable);
+		if (if_link_num == 7) {
+			rtk_rgmii_set(0);
+			port_change_time[6] = 0;
+			port_change_time[7] = get_uptime_by_sec();
+		} else
+			rtk_port_adminEnable_set(if_link_num, 0);
+	} else if (enable == TRUE) {
+		extern int rtk_port_adminEnable_set(uint32 port, uint32 enable);
+		if (if_link_num == 7) {
+			rtk_rgmii_set(1);
+			port_change_time[6] = 1;
+			port_change_time[7] = get_uptime_by_sec();
+		} else
+			rtk_port_adminEnable_set(if_link_num, 1);
+	}
+#else
+#endif
+
+	return 0;
+}
+
+typedef struct rtk_port_phy_ability_s {
+	uint32 AutoNegotiation;	/*PHY register 0.12 setting for auto-negotiation process */
+	uint32 Half_10;		/*PHY register 4.5 setting for 10BASE-TX half duplex capable */
+	uint32 Full_10;		/*PHY register 4.6 setting for 10BASE-TX full duplex capable */
+	uint32 Half_100;	/*PHY register 4.7 setting for 100BASE-TX half duplex capable */
+	uint32 Full_100;	/*PHY register 4.8 setting for 100BASE-TX full duplex capable */
+	uint32 Full_1000;	/*PHY register 9.9 setting for 1000BASE-T full duplex capable */
+	uint32 FC;		/*PHY register 4.10 setting for flow control capability */
+	uint32 AsyFC;		/*PHY register 4.11 setting for  asymmetric flow control capability */
+} rtk_port_phy_ability_t;
+
+int tr181_set_eth_lf_MaxBitRate(int if_link_num, int rate)
+{
+	if (if_link_num < 0 || if_link_num >= NUMOFIFENTRY)
+		return (-1);
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+	{
+		extern int rtk_port_phyAutoNegoAbility_get(uint32 port,
+			rtk_port_phy_ability_t *pAbility);
+		extern int rtk_port_phyAutoNegoAbility_set(uint32 port,
+			rtk_port_phy_ability_t *pAbility);
+		rtk_port_phy_ability_t Ability;
+
+		rtk_port_phyAutoNegoAbility_get(if_link_num, &Ability);
+		if (rate == 10) {
+			Ability.Half_10 = 1;
+			Ability.Full_10 = 1;
+			Ability.Half_100 = 0;
+			Ability.Full_100 = 0;
+			Ability.Full_1000 = 0;
+		} else if (rate == 100) {
+			Ability.Half_10 = 1;
+			Ability.Full_10 = 1;
+			Ability.Half_100 = 1;
+			Ability.Full_100 = 1;
+			Ability.Full_1000 = 0;
+		} else if (rate == 1000) {
+			Ability.Half_10 = 1;
+			Ability.Full_10 = 1;
+			Ability.Half_100 = 1;
+			Ability.Full_100 = 1;
+			Ability.Full_1000 = 1;
+		} else if (rate == -1) {
+			Ability.Half_10 = 1;
+			Ability.Full_10 = 1;
+			Ability.Half_100 = 1;
+			Ability.Full_100 = 1;
+			Ability.Full_1000 = 1;
+		}
+		rtk_port_phyAutoNegoAbility_set(if_link_num, &Ability);
+	}
+#else
+#endif
+
+	return 0;
+}
+
+int tr181_set_eth_if_DuplexMode(int if_link_num, int mode)
+{
+	if (if_link_num < 0 || if_link_num >= NUMOFIFENTRY)
+		return (-1);
+
+#ifdef CONFIG_RTL_8367R_SUPPORT
+	{
+		extern int rtk_port_phyAutoNegoAbility_get(uint32 port,
+			rtk_port_phy_ability_t *pAbility);
+		extern int rtk_port_phyAutoNegoAbility_set(uint32 port,
+			rtk_port_phy_ability_t *pAbility);
+		rtk_port_phy_ability_t Ability;
+
+		rtk_port_phyAutoNegoAbility_get(if_link_num, &Ability);
+		if (mode == TR181_ETH_IF_DUPLEX_HALF) {
+			Ability.Half_10 = 1;
+			Ability.Full_10 = 0;
+			Ability.Half_100 = 1;
+			Ability.Full_100 = 0;
+			Ability.Full_1000 = 0;
+		} else if (mode == TR181_ETH_IF_DUPLEX_FULL) {
+			Ability.Half_10 = 0;
+			Ability.Full_10 = 1;
+			Ability.Half_100 = 0;
+			Ability.Full_100 = 1;
+			Ability.Full_1000 = 1;
+		} else if (mode == TR181_ETH_IF_DUPLEX_AUTO) {
+			Ability.Half_10 = 1;
+			Ability.Full_10 = 1;
+			Ability.Half_100 = 1;
+			Ability.Full_100 = 1;
+			Ability.Full_1000 = 1;
+		}
+		rtk_port_phyAutoNegoAbility_set(if_link_num, &Ability);
+	}
+#else
+#endif
+
+	return 0;
+}
+
+int tr181_set_eth_link_enable(int if_link_num, int enable)
+{
+	rtlglue_printf("  ==> %s: %d %d\n", __FUNCTION__, if_link_num, enable);
+	return 0;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int tr181_eth_set_read(struct seq_file *s, void *v)
+{
+	return 0;
+}
+#else
+static int tr181_eth_set_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	return 0;
+}
+#endif
+
+static int tr181_eth_set_write(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	char tmpBuf[100];
+	char *strptr;
+	char *tokptr;
+	int cmd, if_link, if_link_num, rate;
+
+	tr181_ethernet Eth;
+	tr181_eth_if_stats Stats;
+	tr181_eth_interface If;
+	tr181_eth_link Link;
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		tmpBuf[count] = '\0';
+
+		strptr = tmpBuf;
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL)
+			goto errout;
+
+		if (!memcmp(tokptr, "get", 3))
+			cmd = 1;
+		else if (!memcmp(tokptr, "set", 3))
+			cmd = 2;
+		else
+			goto errout;
+
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL)
+			goto errout;
+
+		if (memcmp(tokptr, "eth", 3))
+			goto errout;
+
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			if (cmd == 1) {
+				tr181_get_eth(&Eth);
+				return count;
+			} else
+				goto errout;
+		}
+
+		if (!memcmp(tokptr, "if", 2)) {
+			if_link = 1;
+			if_link_num = tokptr[2] - 0x30;
+		} else if (!memcmp(tokptr, "link", 4)) {
+			if_link = 2;
+			if_link_num = tokptr[4] - 0x30;
+		} else
+			goto errout;
+
+		tokptr = strsep(&strptr, " ");
+		if (tokptr == NULL) {
+			if (cmd == 1 && if_link == 1) {
+				memset(&If, 0, sizeof(tr181_eth_interface));
+				tr181_get_eth_if(if_link_num, &If);
+				return count;
+			} else if (cmd == 1 && if_link == 2) {
+				memset(&Link, 0, sizeof(tr181_eth_link));
+				tr181_get_eth_link(if_link_num, &Link);
+				return count;
+			} else
+				goto errout;
+		}
+
+		if (!memcmp(tokptr, "stats", 5)) {
+			if (cmd == 1 && if_link == 1) {
+				tr181_get_eth_if_stats(if_link_num, &Stats);
+			} else if (cmd == 1 && if_link == 2) {
+				tr181_get_eth_link_stats(if_link_num, &Stats);
+			} else
+				goto errout;
+		} else if (!memcmp(tokptr, "Enable", 6)) {
+			if (cmd == 1)
+				goto errout;
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL)
+				goto errout;
+
+			if (!memcmp(tokptr, "true", 4)) {
+				if (if_link == 1)
+					tr181_set_eth_if_enable(if_link_num, 1);
+				else if (if_link == 2)
+					tr181_set_eth_link_enable(if_link_num,
+						1);
+			} else if (!memcmp(tokptr, "false", 5)) {
+				if (if_link == 1)
+					tr181_set_eth_if_enable(if_link_num, 0);
+				else if (if_link == 2)
+					tr181_set_eth_link_enable(if_link_num,
+						0);
+			} else
+				goto errout;
+		} else if (!memcmp(tokptr, "MaxBitRate", 10)) {
+			if (cmd == 1 || if_link == 2)
+				goto errout;
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL)
+				goto errout;
+
+			rate = simple_strtol(tokptr, NULL, 0);
+			if (rate == -1 || rate == 10 || rate == 100
+				|| rate == 1000)
+				tr181_set_eth_lf_MaxBitRate(if_link_num, rate);
+			else
+				goto errout;
+		} else if (!memcmp(tokptr, "DuplexMode", 10)) {
+			if (cmd == 1 || if_link == 2)
+				goto errout;
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL)
+				goto errout;
+
+			if (!memcmp(tokptr, "Half", 4)) {
+				tr181_set_eth_if_DuplexMode(if_link_num,
+					TR181_ETH_IF_DUPLEX_HALF);
+			} else if (!memcmp(tokptr, "Full", 4)) {
+				tr181_set_eth_if_DuplexMode(if_link_num,
+					TR181_ETH_IF_DUPLEX_FULL);
+			} else if (!memcmp(tokptr, "Auto", 4)) {
+				tr181_set_eth_if_DuplexMode(if_link_num,
+					TR181_ETH_IF_DUPLEX_AUTO);
+			} else
+				goto errout;
+		} else
+			goto errout;
+
+	} else {
+errout:
+		rtlglue_printf("error input!\n");
+	}
+
+	return count;
+}
+#endif
+
+#ifdef CONFIG_RTL_INBAND_CTL_ACL
+#ifdef CONFIG_RTL_PROC_NEW
+static int inband_ctl_acl_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "Inband Control Ethternet Type : 0x%x\n",
+		inband_ctl_acl_ethernet_type);
+	return 0;
+}
+#else
+static int inband_ctl_acl_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len;
+	len = sprintf(page, "Inband Control Ethternet Type : 0x%x\n",
+		inband_ctl_acl_ethernet_type);
+	return len;
+}
+#endif
+static int inband_ctl_acl_write(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	uint32 tmpBuf[32];
+	uint32 uintVal;
+
+	if (buffer && !copy_from_user(tmpBuf, buffer, count)) {
+		tmpBuf[count - 1] = 0;
+		uintVal = simple_strtol((const char *)tmpBuf, NULL, 0);
+		if (uintVal != 0) {
+			inband_ctl_acl_ethernet_type = uintVal;
+			rtl865x_removeAclForInbandCtl(vlanconfig);
+			rtl865x_addAclForInbandCtl(vlanconfig);
+		} else {
+			rtl865x_removeAclForInbandCtl(vlanconfig);
+		}
+		return count;
+	}
+	return -EFAULT;
+}
+#endif
+
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+/* using packVlanConfig store vlan group  */
+#define RTL_DRV_GENERAL_NETIF_NAME "eth0"
+
+typedef struct _netif_name_mapping_s {
+	char dev_name[MAX_IFNAMESIZE];	/* protocol stack device name */
+	char netif_Name[MAX_IFNAMESIZE];	/* netif name in driver */
+	int valid;		/* control which br interface using hw nat */
+} netif_name_mapping_t;
+/* used for eth0.x as bridge port */
+static netif_name_mapping_t netif_name_mapping[NETIF_NUMBER];
+/*  flag:1 ->brctl addif
+ *  flag: 2 ->brctl delif
+ */
+int rtk_dev_name_netif_mapping(char *br_name, char *br_port_name, int flag)
+{
+	unsigned char prefix[MAX_IFNAMESIZE];
+	int i = 0;
+
+	if (!br_name || !br_port_name)
+		return FAILED;
+
+	memset(prefix, '\0', sizeof(prefix));
+	sprintf(prefix, "%s.", RTL_DRV_GENERAL_NETIF_NAME);
+	/* panic_printk("%s %d br_name=%s br_port_name=%s flag=%d \n", __FUNCTION__, __LINE__, br_name, br_port_name, flag); */
+
+	switch (flag) {
+	case 1:
+		for (i = 0; i < NETIF_NUMBER; i++) {
+			/* null space */
+			if (netif_name_mapping[i].netif_Name[0] == '\0') {
+				memcpy(netif_name_mapping[i].dev_name, br_name,
+					MAX_IFNAMESIZE);
+				memcpy(netif_name_mapping[i].netif_Name,
+					br_port_name, MAX_IFNAMESIZE);
+				break;
+			}
+
+		}
+		if (i == NETIF_NUMBER)
+			printk("%s %d netif_name_mapping is full!\n",
+				__FUNCTION__, __LINE__);
+		break;
+	case 2:
+		for (i = 0; i < NETIF_NUMBER; i++) {
+			/* find it, clear */
+			if (!memcmp(netif_name_mapping[i].netif_Name,
+					br_port_name, MAX_IFNAMESIZE)) {
+				memset((void *)&netif_name_mapping[i], '\0',
+					sizeof(netif_name_mapping_t));
+				break;
+			}
+
+		}
+		if (i == NETIF_NUMBER)
+			printk("%s %d cannot find br_port_name=%s !\n",
+				__FUNCTION__, __LINE__, br_port_name);
+		break;
+	default:
+		break;
+	}
+
+	return SUCCESS;
+}
+
+#if 0
+int rtk_get_devname_by_netifname(char *dev_name, char *netif_name)
+{
+	int i = 0;
+	if (!dev_name || !netif_name)
+		return 0;
+
+	for (i = 0; i < NETIF_NUMBER; i++) {
+		if ((!memcmp(netif_name_mapping[i].netif_Name, netif_name,
+					MAX_IFNAMESIZE))) {
+			memcpy(dev_name, netif_name_mapping[i].dev_name,
+				MAX_IFNAMESIZE);
+			return 1;
+		}
+	}
+
+	return 0;
+}
+
+int rtk_get_netif_name_by_devname(char *dev_name, char *netif_name)
+{
+	int i = 0;
+
+	if (!dev_name || !netif_name)
+		return FAILED;
+
+	for (i = 0; i < NETIF_NUMBER; i++) {
+		if ((!memcmp(netif_name_mapping[i].dev_name, dev_name,
+					MAX_IFNAMESIZE))) {
+			/* panic_printk("%s %d dev_name=%s netif_name=%s \n", __FUNCTION__, __LINE__, dev_name, netif_name); */
+			if ((netif_name_mapping[i].valid)) {
+				/* valid should add to l3 table */
+				memcpy(netif_name,
+					netif_name_mapping[i].netif_Name,
+					MAX_IFNAMESIZE);
+				return SUCCESS;
+			} else {
+				/*  valid=0, means forward by software, add acl for it, donot add to l3 table */
+				/* panic_printk("%s %d dev_name=%s netif_name_mapping[i].netif_Name=%s netif_name_mapping[i].valid=%d \n", __FUNCTION__, __LINE__, dev_name, netif_name_mapping[i].netif_Name, netif_name_mapping[i].valid); */
+				rtk_add_acl_for_sw_forward(netif_name_mapping
+					[i].netif_Name, dev_name,
+					netif_name_mapping[i].valid);
+				return FAILED;
+			}
+		}
+	}
+
+	return FAILED;
+}
+#endif
+int rtk_get_devname_by_netif_name(char *dev_name, char *netif_Name)
+{
+#if 1
+	int i = 0;
+
+	if (!dev_name || !netif_Name)
+		return FAILED;
+
+	for (i = 0; i < NETIF_NUMBER; i++) {
+		if ((!memcmp(netif_name_mapping[i].netif_Name, netif_Name,
+					MAX_IFNAMESIZE))) {
+			memcpy(dev_name, netif_name_mapping[i].dev_name,
+				MAX_IFNAMESIZE);
+			/* panic_printk("%s %d dev_name=%s netif_name=%s \n", __FUNCTION__, __LINE__, dev_name, netif_Name); */
+			return SUCCESS;
+		}
+	}
+
+	return FAILED;
+#endif
+
+}
+
+int rtk_get_devname_by_vid(char *dev_name, int vid)
+{
+	int i = 0;
+	char *strvlanid = NULL;
+
+	if (vid == 0)
+		return FAILED;
+
+	for (i = 0; i < NETIF_NUMBER; i++) {
+
+		/* panic_printk("%s %d dev_name=%s netif_name=%s \n", __FUNCTION__, __LINE__, netif_name_mapping[i].dev_name, netif_name_mapping[i].netif_Name); */
+		if (!memcmp(netif_name_mapping[i].netif_Name, RTL_WLAN_NAME, 4))
+			continue;
+
+		strvlanid = strchr(netif_name_mapping[i].netif_Name, '.');
+		if (strvlanid != NULL) {
+			strvlanid++;
+			if ((strvlanid != NULL)
+				&& (vid == simple_strtol(strvlanid, NULL, 0))) {
+				memcpy(dev_name, netif_name_mapping[i].dev_name,
+					MAX_IFNAMESIZE);
+				/* panic_printk("%s %d dev_name=%s netif_name=%s \n", __FUNCTION__, __LINE__, dev_name, netif_Name); */
+				return SUCCESS;
+			}
+		}
+	}
+
+	return FAILED;
+
+}
+
+extern int rtl_get_brIgmpModuleIndexbyName(char *name, int *index);
+
+unsigned int rtl_get_brIgmpModuleIndexbyVid(unsigned int vid)
+{
+#if 1
+	/* unsigned char netif_Name[MAX_IFNAMESIZE]={0}; */
+	unsigned char dev_name[MAX_IFNAMESIZE] = { 0 };
+	int ret = FAILED;
+	int index = 0;
+	unsigned int igmpModuleIndex = 0xFFFFFFFF;
+#if 0
+	memset(netif_Name, '\0', sizeof(netif_Name));
+	sprintf(netif_Name, "%s.%d", RTL_DRV_GENERAL_NETIF_NAME, vid);
+	ret = rtk_get_devname_by_netif_name(dev_name, netif_Name);
+#endif
+	ret = rtk_get_devname_by_vid(dev_name, vid);
+	if (ret == SUCCESS)
+		igmpModuleIndex =
+			rtl_get_brIgmpModuleIndexbyName(dev_name, &index);
+	/* printk("vid:%d,netif_Name:%s,dev:%s,igmpModuleIndex:%x,[%s]:[%d].\n",vid,netif_Name,dev_name,igmpModuleIndex,__FUNCTION__,__LINE__); */
+	return igmpModuleIndex;
+#endif
+
+}
+#endif
+
+#ifdef CONFIG_RTL_VLAN_8021Q
+struct dev_priv *rtk_get_default_cp(void)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	return ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[RTL_LAN_IDX]));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	return ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}
+
+struct dev_priv *rtk_get_default_wan_cp(void)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	return ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[RTL_WAN_IDX]));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	return ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}
+
+static int is_nat_wan_vlan(uint16 vid)
+{
+	if (rtl865x_curOpMode == GATEWAY_MODE)
+		if (vid == rtk_vlan_wan_vid)
+			return 1;
+	return 0;
+}
+
+static inline int rtk_isHwlookup_vlan(uint16 vid, struct sk_buff *skb,
+	uint32 *portlist)
+{
+	int flag = TRUE;
+
+#if defined(CONFIG_RTL_8021Q_VLAN_SUPPORT_SRC_TAG)
+	struct dev_priv *cp;
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		cp = NETDRV_PRIV(skb->dev);
+		if (cp->id == rtk_vlan_wan_vid && rtk_get_skb_vid(skb) == 0) {
+			/* If bridge wan tag out, it already has tag here. */
+			/* So only use direct-tx (for UC) when nat wan out. */
+			*portlist = RTK_WAN_PORT_MASK;
+			flag = FALSE;
+		} else
+			flag = TRUE;
+	} else
+#endif
+	{
+		*portlist = rtk_get_vlan_portmask(vid);
+
+		/* if the packet is belong to wan nat vlan , then we will not send it with HW lay2 lookup */
+		/* only forwad it with nic direct tx way and set the portmask to only wan port(don;t support mulitable wan for now) */
+		if (vid == rtk_vlan_wan_vid) {
+			*portlist = (*portlist) & RTK_WAN_PORT_MASK;	/* to wan UC only to Wan nat only port */
+			flag = FALSE;
+		}
+		/* else if(rtl_ip_option_check(skb) != TRUE)    //mark_vc , need this check ? */
+	}
+
+	return flag;
+}
+
+struct dev_priv *rtk_get_cp_by_vid_pid(uint16 vid, int pid, struct sk_buff *skb)
+{
+	struct dev_priv *dp = NULL;
+
+	if (!vid)
+		return NULL;
+
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		if ((1 << pid) & RTL_WANPORT_MASK) {
+			dp = rtk_get_default_wan_cp();
+		} else {
+			dp = rtk_get_default_cp();
+		}
+	} else			/* BRIDGE_MODE or WISP_MODE */
+	{
+#ifdef CONFIG_RTL_IVL_SUPPORT
+		if (vid == RTL_WANVLANID)
+			dp = rtk_get_default_wan_cp();
+		else
+			dp = rtk_get_default_cp();
+#else
+		dp = rtk_get_default_cp();
+#endif
+	}
+
+	return dp;
+}
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+struct dev_priv *rtk_get_multi_lan_dev_cp(uint16 vid, int pid)
+{
+	struct dev_priv *dp = NULL;
+	int j = 0;
+
+	if (!vid)
+		return NULL;
+
+	/* usually , if enable multiple lan dev, we use pid to get cp */
+	for (j = 0; j < ETH_INTF_NUM; j++) {
+		dp = ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[j]));
+		if (_rtl86xx_dev.dev[j] && dp && dp->opened
+			&& (dp->portmask & (1 << pid))) {
+			break;
+		}
+	}
+
+	if (j == ETH_INTF_NUM)
+		dp = rtk_get_default_cp();
+
+#ifdef RTK_DEDICATE_WAN_IF
+	/* if  eth1 is dedicate to wan nat infterface  and it is gatewaymode */
+	/* check vid , then reurn eth1's cp */
+	if (is_nat_wan_vlan(vid)) {
+		dp = rtk_get_default_wan_cp();
+	}
+#endif
+
+	return dp;
+}
+#endif
+
+#if defined(CONFIG_OPENWRT_SDK)
+struct dev_priv *rtk_get_cp_by_vid(uint16 vid)
+{
+	struct dev_priv *dp = NULL;
+
+	if (!vid)
+		return NULL;
+
+	/* usually , we only have  eth0 cp */
+	dp = rtk_get_default_cp();
+
+#ifdef RTK_DEDICATE_WAN_IF
+	/* if  eth1 is dedicate to wan nat infterface  and it is gatewaymode */
+	/* check vid , then reurn eth1's cp */
+	if (is_nat_wan_vlan(vid)) {
+		dp = rtk_get_default_wan_cp();
+	}
+#endif
+
+	return dp;
+}
+#endif
+
+uint16 rtk_get_vid_by_port(int pid)
+{
+	/* get pvid */
+	return (uint16)vlan_ctl_p->pvid[pid];
+}
+
+uint16 rtk_get_skb_vid(struct sk_buff *skb)
+{
+	uint16 vid = 0;
+
+	if (*((unsigned short *)(skb->data + (ETH_ALEN << 1))) ==
+		__constant_htons(ETH_P_8021Q)) {
+		vid = ntohs(*(uint16 *)(skb->data + (ETH_ALEN << 1) +
+				2)) & 0x0fff;
+	}
+
+	return vid;
+}
+
+#if 1
+static void rtk_rm_skb_vid(struct sk_buff *skb)
+{
+	/* if nic decide to directTx , then we need to remove packet's tag if exist */
+	/* then  use HW auto tag function in swNic.c to decide packet tag or not */
+	uint16 vid = rtk_get_skb_vid(skb);
+	if (vid != 0)
+		REMOVE_TAG(skb);
+}
+#endif
+static int rtk_decide_vlan_id(int pid, struct sk_buff *skb, uint16 *vid)
+{
+	uint16 skb_vid = 0;
+	int type = VID_FROM_PVID;
+	/* get packet vid from skb */
+	skb_vid = rtk_get_skb_vid(skb);
+
+	if (!skb_vid)
+		skb_vid = rtk_get_vid_by_port(pid);
+	else			/* packet with tag */
+		type = VID_FROM_PACKET;
+
+	*vid = skb_vid;
+
+	return type;
+}
+
+static struct dev_priv *rtk_decide_vlan_cp(int pid, struct sk_buff *skb)
+{
+	struct dev_priv *dp = NULL;
+	uint16 skb_vid = 0;
+
+	if (!vlan_ctl_p->flag)
+		return NULL;
+
+	rtk_decide_vlan_id(pid, skb, &skb_vid);
+
+#if defined(CONFIG_OPENWRT_SDK)
+	dp = (struct dev_priv *)rtk_get_cp_by_vid(skb_vid);
+#else
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+	dp = (struct dev_priv *)rtk_get_multi_lan_dev_cp(skb_vid, pid);
+#else
+	dp = (struct dev_priv *)rtk_get_cp_by_vid_pid(skb_vid, pid, skb);
+#endif
+#endif
+
+	return dp;
+}
+
+inline uint32 rtk_get_vlan_tagmask(uint16 vid)
+{
+	uint32 mask;
+
+	if (!vlan_ctl_p->flag)
+		return 0;
+
+	mask = (vlan_ctl_p->group[vid].memberMask) & (vlan_ctl_p->group[vid].
+		tagMemberMask);
+	return mask;
+}
+
+inline uint32 rtk_get_vlan_portmask(uint16 vid)
+{
+	uint32 mask;
+	mask = vlan_ctl_p->group[vid].memberMask;
+
+	return mask;
+}
+
+inline uint8 rtk_get_vlan_type(uint16 vid)
+{
+	uint32 vlan_type;
+	vlan_type = vlan_ctl_p->group[vid].vlanType;
+
+	return vlan_type;
+}
+
+static inline int is_cpu_port_tagged(uint16 vid)
+{
+	uint32 mask;
+	mask = (vlan_ctl_p->group[vid].memberMask) & (vlan_ctl_p->group[vid].
+		tagMemberMask);
+
+	if ((mask & RTK_CPU_PORT_MASK) == RTK_CPU_PORT_MASK)
+		return 1;
+	else
+		return 0;
+}
+
+#if defined(CONFIG_OPENWRT_SDK)
+static int rtk_process_11q_rx(int port, struct sk_buff *skb)
+{
+	uint16 vid = 0;
+
+	if (!vlan_ctl_p->flag)
+		return 0;
+
+	vid = rtk_get_skb_vid(skb);
+
+	if (vid == 0)		/* if packet without tag .  check pvid , to add tag */
+	{
+		vid = rtk_get_vid_by_port(port);
+		if (is_cpu_port_tagged(vid)) {
+#ifdef RTK_DEDICATE_WAN_IF	/* if it is nat wan vlan , not add tag, otherwise all add pvid tag to skb */
+			if (!is_nat_wan_vlan(vid))
+#endif
+				rtk_insert_vlan_tag(vid, skb);
+		}
+	} else			/* if packet with tag , mostly don't touch */
+	{
+#ifdef RTK_DEDICATE_WAN_IF
+		/* if packet with tag , but it is to wan nat vlan . remove the tag */
+		if (is_nat_wan_vlan(vid)) {
+			REMOVE_TAG(skb);
+			return 1;
+		}
+#endif
+		if (!is_cpu_port_tagged(vid))	/* if cpu port is unatagged */
+			REMOVE_TAG(skb);
+
+	}
+	/* panic_printk("%s %d vid=%d rtk_vlan_wan_vid=%d\n", __FUNCTION__, __LINE__,vid, rtk_vlan_wan_vid); */
+	return 1;
+}
+#else
+/*static inline int rtk_isArp(struct sk_buff *skb)
+{
+	if (*(uint16*)(skb->data+(ETH_ALEN<<1)) == __constant_htons(ETH_P_ARP) ||
+		*(uint16*)(skb->data+(ETH_ALEN<<1)+VLAN_HLEN) == __constant_htons(ETH_P_ARP))
+		return TRUE;
+
+	return FALSE;
+}
+
+static inline int rtk_isDHCP(struct sk_buff *skb)
+{
+	uint8 *data;
+
+	data = skb->data + (ETH_ALEN<<1);
+	if(*(unsigned short *)(skb->data+(ETH_ALEN<<1)) == __constant_htons(ETH_P_8021Q))
+		data += VLAN_HLEN;
+
+	if (*(uint16*)data == __constant_htons(ETH_P_IP))
+	{
+		data += 2;
+		if(data[9] == IPPROTO_UDP)
+		{
+			data += (data[0]&0x0f)<<2;
+			if(*(uint16*)data == __constant_htons(67))
+				return TRUE;
+		}
+	}
+
+	return FALSE;
+}*/
+
+static int rtk_process_11q_rx(int port, struct sk_buff *skb,
+	struct sk_buff **pskb1, rtl_nicRx_info *info)
+{
+	uint16 vid = 0, skb_vlan_type = VLAN_TYPE_NAT;
+	struct dev_priv *dp = NULL;
+
+	if (!vlan_ctl_p->flag || !pskb1)
+		return 0;
+
+	vid = rtk_get_skb_vid(skb);
+	dp = netdev_priv(skb->dev);
+	*pskb1 = NULL;
+
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+#if !defined(CONFIG_RTL_MULTI_LAN_DEV)
+		/* Sometimes(mostly 8367r) LAN ports rcved pkts carry wrong vlan tag. */
+		/* Use sw vlan pvid to decide vid. */
+		if (!((1 << port) & RTL_WANPORT_MASK) && vid != 0) {
+			/* panic_printk("LAN pkt carry tag, remove!\n"); */
+			REMOVE_TAG(skb);
+			vid = 0;
+		}
+		/* Bridge lan port -> eth1. */
+		if (!((1 << port) & RTL_WANPORT_MASK)) {
+			if (rtk_get_vlan_type(rtk_get_vid_by_port(port)) ==
+				VLAN_TYPE_BRIDGE) {
+#if defined(CONFIG_RTD_1295_HWNAT)
+				skb->dev = _rtl86xx_dev.dev[RTL_WAN_IDX];
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+				skb->dev = _rtl86xx_dev.dev[1];
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+				dp = netdev_priv(skb->dev);
+				skb_vlan_type = VLAN_TYPE_BRIDGE;
+			}
+		}
+#endif
+
+		/* For untag group (NAT/bridge or both exist), 8367r may add tag, remove it. */
+		/* For untag NAT + untag bridge working correctly. */
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+		if (((1 << port) & RTL_WANPORT_MASK) && vid != 0) {
+			if ((rtk_get_vlan_portmask(vid) & RTL_WANPORT_MASK) &&
+				!(rtk_get_vlan_tagmask(vid) & RTL_WANPORT_MASK))
+			{
+				REMOVE_TAG(skb);
+				vid = 0;
+			}
+		}
+#endif
+
+		/* BC/MC special process (already decided to eth0). */
+		if ((1 << port) & RTL_WANPORT_MASK && skb->data[0] & 0x01) {
+			if (vid == 0) {
+				int pvid = rtk_get_vid_by_port(port);
+
+				if (rtk_get_vlan_type(pvid) == VLAN_TYPE_BRIDGE) {
+					skb_vlan_type = VLAN_TYPE_BRIDGE;
+
+					/* Untag NAT group also exists. */
+					if (!(rtk_get_vlan_tagmask(dp->
+								id) &
+							RTL_WANPORT_MASK)) {
+						/* panic_printk("Untag BC/MC, skb copyed!\n"); */
+						*pskb1 = skb_copy(skb,
+							GFP_ATOMIC);
+
+						rtk_insert_vlan_tag(pvid,
+							*pskb1);
+						*(uint16 *)((*pskb1)->
+							linux_vlan_src_tag) =
+							__constant_htons
+							(ETH_P_8021Q);
+						*(uint16 *)((*pskb1)->
+							linux_vlan_src_tag +
+							2) =
+							__constant_htons(pvid);
+
+						/* skb1 is bridge processed (eth1->eth1.xxx->brx), skb is nat processed (eth1). */
+						skb_vlan_type = VLAN_TYPE_NAT;
+						info->vid = dp->id;
+					}
+				}
+			} else {
+				if (rtk_get_vlan_type(vid) == VLAN_TYPE_BRIDGE)
+					skb_vlan_type = VLAN_TYPE_BRIDGE;
+			}
+		}
+		/* UC special process. */
+		if ((1 << port) & RTL_WANPORT_MASK && !(skb->data[0] & 0x01)) {
+			if (memcmp(skb->data, dp->dev->dev_addr, 6) != 0)
+				skb_vlan_type = VLAN_TYPE_BRIDGE;
+		}
+		/* NAT WAN ingress check(UC/MC/BC). */
+		if ((1 << port) & RTL_WANPORT_MASK &&
+			skb_vlan_type == VLAN_TYPE_NAT) {
+			if (vid == 0 &&
+				(rtk_get_vlan_tagmask(dp->
+						id) & RTL_WANPORT_MASK))
+				return 2;
+
+			if (vid != 0 &&
+				(!(rtk_get_vlan_tagmask(vid) & RTL_WANPORT_MASK)
+					|| vid != dp->id))
+				return 2;
+		}
+	}
+	/* Tagging process */
+	if (vid == 0)		/* if packet without tag, check pvid to add tag */
+	{
+		vid = rtk_get_vid_by_port(port);
+
+		if (rtl865x_curOpMode == GATEWAY_MODE) {
+			if (dp->id != rtk_vlan_wan_vid)
+				rtk_insert_vlan_tag(vid, skb);
+
+			if (dp->id == rtk_vlan_wan_vid
+				&& skb_vlan_type == VLAN_TYPE_BRIDGE)
+				rtk_insert_vlan_tag(vid, skb);
+		} else
+			rtk_insert_vlan_tag(vid, skb);
+	} else			/* if packet with tag , mostly don't touch */
+	{
+		/* if packet with tag , but it is to wan nat vlan . remove the tag */
+		if (rtl865x_curOpMode == GATEWAY_MODE) {
+			if (dp->id == rtk_vlan_wan_vid
+				&& skb_vlan_type == VLAN_TYPE_NAT)
+				REMOVE_TAG(skb);
+		}
+	}
+
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+	if (SUCCESS == rtl_isPassthruFrame(skb->data) && (skb->data[0] & 0x01)
+		&& dp->id == rtk_vlan_wan_vid
+		&& skb_vlan_type == VLAN_TYPE_NAT) {
+#if defined(CONFIG_IPV6)
+		if (rtl_isIpv6McFrame(skb->data) == SUCCESS)
+			info->oriPriv = info->priv;
+#endif
+
+		vid = dp->id;
+		skb->dev = _rtl86xx_dev.pdev;
+		dp = info->priv = NETDRV_PRIV(_rtl86xx_dev.pdev);
+		info->isPdev = TRUE;
+
+		rtk_rm_skb_vid(skb);
+	}
+#endif
+
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		/* For multicast portmask correct. */
+		/* Current wan port pvid may be bridge vid (if an untag bridge group exists). */
+		if (dp->id == rtk_vlan_wan_vid
+			&& skb_vlan_type == VLAN_TYPE_NAT) {
+			vid = rtk_vlan_wan_vid;
+		}
+	}
+
+	*(uint16 *)(skb->linux_vlan_src_tag) = __constant_htons(ETH_P_8021Q);
+	*(uint16 *)(skb->linux_vlan_src_tag + 2) = __constant_htons(vid);
+
+	return 1;
+}
+
+#endif
+
+void rtk_init_11q_setting(void)
+{
+	/* HW */
+#if defined(CONFIG_OPENWRT_SDK)
+	rtl865xC_setNetDecisionPolicy(NETIF_PORT_BASED);
+#endif
+	/* REG32(SWTCR0) |= EnUkVIDtoCPU; */
+
+	REG32(SWTCR0) &= ~EnUkVIDtoCPU;
+}
+
+#if defined(CONFIG_RTL_LAYERED_DRIVER_ACL)
+int32 rtl865x_enable_acl(uint32 enable);
+#endif
+
+void rtk_default_eth_setting(void)	/* copy from rtk_vlan_support=0 switch setting */
+{
+	int i = 0;
+	int j = 0;
+	struct net_device *dev;
+	struct dev_priv *dp;
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	if (mldSnoopEnabled) {
+		rtl865x_removeAclForMldSnooping(vlanconfig);
+	}
+#endif
+#if  defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	if (igmpsnoopenabled) {
+		/* remove igmp acl */
+		rtl_processAclForIgmpSnooping(0);
+	}
+#endif
+#endif
+	/* rtl_config_rtkVlan_vlanconfig(rtl865x_curOpMode); //mark_vc */
+	/* rtl_config_lanwan_dev_vlanconfig(rtl865x_curOpMode); */
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+	rtl_config_vlanconfig(rtl865x_curOpMode);
+#else
+	/* rtl_config_rtkVlan_vlanconfig(rtl865x_curOpMode); */
+	rtl_config_lanwan_dev_vlanconfig(rtl865x_curOpMode);
+#endif
+	re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+	rtl_reinit_hw_table();
+	reinit_vlan_configure(packedVlanConfig);
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	rtk_vlan_init();
+	rtk_stat_global_reset();
+#ifdef CONFIG_RTL_CPU_TAG
+	RTL8367R_vlan_set();
+	rtl865x_enableRtl8367ToCpuAcl();
+#else
+	RTL83XX_vlan_init();
+#endif
+
+	/* rtl865x_disableRtl8367ToCpuAcl(); */
+#endif
+
+#if defined(CONFIG_OPENWRT_SDK)
+	/* unknow vlan drop */
+	REG32(SWTCR0) &= ~(1 << 15);
+#endif
+
+#if defined(CONFIG_RTL_LAYERED_DRIVER_ACL)
+	rtl865x_enable_acl(1);	/* enable acl feature */
+#endif
+/*update dev port number*/
+	for (i = 0; vlanconfig[i].vid != 0; i++) {
+		if (IF_ETHER != vlanconfig[i].if_type) {
+			continue;
+		}
+
+		dev = _rtl86xx_dev.dev[i];
+		dp = ((struct dev_priv *)(NETDRV_PRIV(dev)));
+		dp->portnum = 0;
+		for (j = 0; j < RTL8651_AGGREGATOR_NUMBER; j++) {
+			if (dp->portmask & (1 << j))
+				dp->portnum++;
+		}
+
+	}
+
+#if defined(CONFIG_RTL_IGMP_SNOOPING)
+	re865x_reInitIgmpSetting(rtl865x_curOpMode);
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	if (mldSnoopEnabled) {
+		re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+		rtl865x_addAclForMldSnooping(packedVlanConfig);
+	}
+#endif
+#if  defined(CONFIG_RTL_HARDWARE_MULTICAST)
+	if (igmpsnoopenabled) {
+		rtl_processAclForIgmpSnooping(igmpsnoopenabled);
+	}
+#endif
+#endif
+
+#if (defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)) && defined(CONFIG_RTL_IPV6READYLOGO)
+	{
+		rtl865x_addAclForIPV6ReadyLogo(packedVlanConfig);
+	}
+#endif
+
+#if defined(CONFIG_RTL_HTTP_REDIRECT_LOCAL)
+	rtl865x_removeAclForHttpRedirect(packedVlanConfig);
+	rtl865x_addAclForHttpRedirect(packedVlanConfig);
+#endif
+#if defined(CONFIG_RTL_DNS_TRAP)
+	rtl_remove_Acl_for_dns_trap(packedVlanConfig);
+	rtl_add_Acl_for_dns_trap(packedVlanConfig);
+#endif
+
+	/* always init the default route... */
+	if (rtl8651_getAsicOperationLayer() > 2) {
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+		rtl865x_addRoute(0, 0, 0, RTL_DRV_WAN0_NETIF_NAME, 0);
+#endif
+	}
+}
+
+#if 0
+static void rtk_set_eth_pvid(int port, uint16 pvid)
+{
+	/* 819x */
+#ifdef CONFIG_RTL_819X_SWCORE
+	if (port == RTK_CPU_PORT_IDX)	/* map to real cpu port */
+		port = RTK_HW_CPU_PORT_IDX;
+	rtl8651_setAsicPvid(port, pvid);
+#endif
+	/* mark_vc, 8367 or other integrated switch */
+
+}
+#endif
+static inline uint32 rtk_hw_port_map(uint16 vid, uint32 portmask)
+{
+	uint32 mask = portmask & RTK_PHY_PORT_MASK;	/* 819x hw max */
+
+	if (vid == rtk_vlan_wan_vid)	/* mark_vc , wan vlan no cpu port added , remove it */
+		mask = mask & (~RTK_CPU_PORT_MASK);
+
+	/* convert  CPU port define */
+	if ((mask & RTK_CPU_PORT_MASK) == RTK_CPU_PORT_MASK)
+		mask = ((mask) & (~RTK_CPU_PORT_MASK)) | (RTK_HW_CPU_PORT_MASK);
+
+	return mask;
+}
+
+static void rtk_update_netif_vlan(int netif_idx, uint16 vid, uint32 portmask)
+{
+	struct net_device *dev;
+	struct dev_priv *dp;
+	int j;
+
+	/* update hw netif table vid , depend on vlanconfig idx */
+	rtl865x_setNetifVid(vlanconfig[netif_idx].ifname, vid);
+	/* update wan slave netif(ppp0) vid */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (netif_idx == RTL_WAN_IDX)
+		rtl865x_setNetifVid(RTL_DRV_PPP_NETIF_NAME, vid);
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (netif_idx == 1)
+		rtl865x_setNetifVid(RTL_DRV_PPP_NETIF_NAME, vid);
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+	/* update sw info */
+	vlanconfig[netif_idx].vid = vid;
+	vlanconfig[netif_idx].memPort = portmask;
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+	/* Not update lan-dev portmask in multi-lan mode. */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	if (netif_idx == RTL_LAN_IDX)
+		return;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (netif_idx == 0)
+		return;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[netif_idx]))->id = vid;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[netif_idx]))->portmask = portmask;
+
+	dev = _rtl86xx_dev.dev[netif_idx];
+	dp = NETDRV_PRIV(dev);
+	dp->portnum = 0;
+	for (j = 0; j < RTL8651_AGGREGATOR_NUMBER; j++) {
+		if (dp->portmask & (1 << j))
+			dp->portnum++;
+	}
+}
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+static void rtk_update_netif_vlan_multi_lan_dev(int netif_idx, uint16 vid,
+	uint32 portmask)
+{
+
+	/* update hw netif table vid , depend on vlanconfig idx */
+#if defined(CONFIG_RTD_1295_HWNAT)
+	#if defined(CONFIG_RTL_CPU_TAG)
+	if (portmask & RTL_LANPORT_MASK_1) {
+		/* avoid exchange port mask, store in the fixed position  */
+		vlanconfig[1].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = vid;
+	}
+	if (portmask & RTL_LANPORT_MASK_2) {
+		vlanconfig[2].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->id = vid;
+	}
+	#if 0
+	if (portmask & RTL_LANPORT_MASK_3) {
+		vlanconfig[3].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[3]))->id = vid;
+	}
+	if (portmask & RTL_LANPORT_MASK_0) {
+		vlanconfig[4].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[4]))->id = vid;
+	}
+	#endif
+	#else /* CONFIG_RTL_CPU_TAG */
+	#if defined(CONFIG_RTL_WAN_MAC5)
+	if (portmask & RTL_LANPORT_MASK_5) {
+		/* avoid exchange port mask, store in the fixed position  */
+		vlanconfig[0].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = vid;
+	}
+	#else /* CONFIG_RTL_WAN_MAC5 */
+	if (portmask & RTL_LANPORT_MASK_5) {
+		/* avoid exchange port mask, store in the fixed position  */
+		vlanconfig[1].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = vid;
+	}
+	if (portmask & RTL_LANPORT_MASK_1) {
+		if (hwnat_mac0_enable == 0)
+			return;
+		vlanconfig[2].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->id = vid;
+	}
+	#endif /* CONFIG_RTL_WAN_MAC5 */
+	#endif /* CONFIG_RTL_CPU_TAG */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (portmask & RTL_LANPORT_MASK_4) {
+		/* avoid exchange port mask, store in the fixed position  */
+		vlanconfig[0].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = vid;
+	}
+	if (portmask & RTL_LANPORT_MASK_3) {
+		vlanconfig[2].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->id = vid;
+	}
+	if (portmask & RTL_LANPORT_MASK_2) {
+		vlanconfig[3].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[3]))->id = vid;
+	}
+	if (portmask & RTL_LANPORT_MASK_1) {
+		vlanconfig[4].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[4]))->id = vid;
+	}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}
+
+static void rtk_update_vlan_multi_lan_dev(uint16 vid, uint32 portmask)
+{
+#if defined(CONFIG_RTD_1295_HWNAT)
+	#if defined(CONFIG_RTL_CPU_TAG)
+	if (portmask & RTL_LANPORT_MASK_1) {
+		/* avoid exchange port mask, store in the fixed position  */
+		vlanconfig[1].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = vid;
+	} else if (portmask & RTL_LANPORT_MASK_2) {
+		vlanconfig[2].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->id = vid;
+	#if 0
+	} else if (portmask & RTL_LANPORT_MASK_3) {
+		vlanconfig[3].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[3]))->id = vid;
+	} else if (portmask & RTL_LANPORT_MASK_0) {
+		vlanconfig[4].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[4]))->id = vid;
+	#endif
+	}
+	#else /* CONFIG_RTL_CPU_TAG */
+	#if defined(CONFIG_RTL_WAN_MAC5)
+	if (portmask & RTL_LANPORT_MASK_5) {
+		/* avoid exchange port mask, store in the fixed position  */
+		vlanconfig[0].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = vid;
+	}
+	#else /* CONFIG_RTL_WAN_MAC5 */
+	if (portmask & RTL_LANPORT_MASK_5) {
+		/* avoid exchange port mask, store in the fixed position  */
+		vlanconfig[1].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = vid;
+	} else if (portmask & RTL_LANPORT_MASK_1) {
+		if (hwnat_mac0_enable == 0)
+			return;
+		vlanconfig[2].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->id = vid;
+	}
+	#endif /* CONFIG_RTL_WAN_MAC5 */
+	#endif /* CONFIG_RTL_CPU_TAG */
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+	if (portmask & RTL_LANPORT_MASK_4) {
+		/* avoid exchange port mask, store in the fixed position  */
+		vlanconfig[0].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id = vid;
+	} else if (portmask & RTL_LANPORT_MASK_3) {
+		vlanconfig[2].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[2]))->id = vid;
+	} else if (portmask & RTL_LANPORT_MASK_2) {
+		vlanconfig[3].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[3]))->id = vid;
+	} else if (portmask & RTL_LANPORT_MASK_1) {
+		vlanconfig[4].vid = vid;
+		((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[4]))->id = vid;
+	}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}
+
+#endif
+
+void rtk_add_eth_vlan(uint16 vid, uint32 portmask, uint32 tagmask,
+	uint32 vlantype)
+{
+	/* 819x */
+#ifdef CONFIG_RTL_819X_SWCORE
+
+#ifdef CONFIG_RTL_8021Q_VLAN_SUPPORT_SRC_TAG
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		if (vlantype == VLAN_TYPE_NAT && vid != RTL_LANVLANID) {
+			/* nat group, only CPU/WAN port. */
+			portmask &= (~0x1f) | RTL_WANPORT_MASK;
+			tagmask &= (~0x1f) | RTL_WANPORT_MASK;
+		} else if (vid == RTL_LANVLANID) {
+			/* only CPU port tagged. */
+			portmask &= ~RTL_WANPORT_MASK;
+			tagmask &= ~0x1f;
+		} else {
+			/* Bridge group, only CPU/WAN port tagged. */
+			tagmask &= (~0x1f) | RTL_WANPORT_MASK;
+		}
+	}
+#endif
+
+	/*add vlan info to switch */
+	rtl865x_addVlan(vid);
+	/* rtl865x_addVlanPortMember(vid,(portmask &0x1ff)|0x100); */
+	/* convert cpu port mapping */
+	rtl865x_addVlanPortMember(vid, rtk_hw_port_map(vid, portmask));	/* mark_vc , need cpu port ? */
+	rtl865x_setVlanPortTag(vid, rtk_hw_port_map(vid, tagmask), TRUE);
+
+	/* if portmask has wan prot then set fid to 1 */
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+#ifdef CONFIG_RTL_8021Q_VLAN_SUPPORT_SRC_TAG
+		if ((portmask & RTK_WAN_PORT_MASK) == RTK_WAN_PORT_MASK) {
+			rtl865x_setVlanFilterDatabase(vid, RTL_WAN_FID);
+
+			if (vlantype == VLAN_TYPE_NAT) {
+				/* NAT group, update hw netif and sw device. */
+#if defined(CONFIG_RTD_1295_HWNAT)
+				rtk_update_netif_vlan(RTL_WAN_IDX, vid,
+					rtk_hw_port_map(vid, portmask));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+				rtk_update_netif_vlan(1, vid,
+					rtk_hw_port_map(vid, portmask));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+			}
+		} else {
+			rtl865x_setVlanFilterDatabase(vid, RTL_LAN_FID);
+		}
+#else
+		if ((portmask & RTK_WAN_PORT_MASK) == RTK_WAN_PORT_MASK) {
+			rtl865x_setVlanFilterDatabase(vid, RTL_WAN_FID);
+
+			if (vid == rtk_vlan_wan_vid)	/* if it is nat wan vlan , need to update netif table ,mark_vc */
+			{
+				/* update wan nat  netif , vlanconfig and cp info */
+#if defined(CONFIG_RTD_1295_HWNAT)
+				rtk_update_netif_vlan(RTL_WAN_IDX, vid,
+					rtk_hw_port_map(vid, portmask));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+				rtk_update_netif_vlan(1, vid,
+					rtk_hw_port_map(vid, portmask));	/* wan 1 */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+				if (portmask & (~(RTK_WAN_PORT_MASK |
+							RTK_CPU_PORT_MASK))) {
+					/* bridge lan, bridge vid equal nat vid case */
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+					rtk_update_vlan_multi_lan_dev(vid,
+						portmask);
+#endif
+				}
+			} else if (portmask & (~(RTK_WAN_PORT_MASK |
+						RTK_CPU_PORT_MASK))) {
+				/* bridge lan, bridge vid not equal nat vid case */
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+				rtk_update_vlan_multi_lan_dev(vid, portmask);
+#endif
+			}
+		} else {
+			rtl865x_setVlanFilterDatabase(vid, RTL_LAN_FID);
+
+			/* if  portmask is not include wan port , then also set eth0 netif to this vlan */
+			/* update lan nat  netif , vlanconfig and cp info */
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+#if defined(CONFIG_RTD_1295_HWNAT)
+			rtk_update_netif_vlan_multi_lan_dev(RTL_LAN_IDX, vid,
+				rtk_hw_port_map(vid, portmask));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+			rtk_update_netif_vlan_multi_lan_dev(0, vid,
+				rtk_hw_port_map(vid, portmask));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+			if (vid == rtk_vlan_hw_nat_lan_vid)
+#if defined(CONFIG_RTD_1295_HWNAT)
+				rtk_update_netif_vlan(RTL_LAN_IDX, vid,
+					rtk_hw_port_map(vid, portmask));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+				rtk_update_netif_vlan(0, vid,
+					rtk_hw_port_map(vid, portmask));	/* lan 0 */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+		}
+#endif
+	} else			/* bridge mode no need to deal netif table */
+	{
+		rtl865x_setVlanFilterDatabase(vid, RTL_LAN_FID);
+
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+#if defined(CONFIG_RTD_1295_HWNAT)
+		rtk_update_netif_vlan_multi_lan_dev(RTL_LAN_IDX, vid,
+			rtk_hw_port_map(vid, portmask));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		rtk_update_netif_vlan_multi_lan_dev(0, vid,
+			rtk_hw_port_map(vid, portmask));
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+		rtk_update_netif_vlan(RTL_LAN_IDX, vid,
+			rtk_hw_port_map(vid, portmask));
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+		rtk_update_netif_vlan(0, vid,
+			rtk_hw_port_map(vid, portmask));	/* lan 0 */
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+	}
+#endif
+
+	/* mark_vc, 8367 or other integrated switch */
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+
+	if (portmask & RTK_WAN_PORT_MASK)
+		tagmask |= RTK_CPU_PORT_MASK;
+
+	if (rtl865x_curOpMode == GATEWAY_MODE) {
+		if ((portmask & RTK_WAN_PORT_MASK) == RTK_WAN_PORT_MASK) {
+			/* Nat WAN include port0~port3, avoid (wan to lan hw multicast) tx to lan with tag. */
+			if (is_nat_wan_vlan(vid))
+				portmask |= 0x0f;
+
+			/* Untag bridge also include all lan ports, for avoiding the same bug: */
+			/* when untag bridge+untag NAT exist, NAT wan->lan mcast may carry bridge tag out. */
+			if (vlantype == VLAN_TYPE_BRIDGE
+				&& !(tagmask & RTK_WAN_PORT_MASK))
+				portmask |= 0x0f;
+
+			rtl_vlan_RTL8367R_set(vid, tagmask, portmask, 1);
+		} else {
+			rtl_vlan_RTL8367R_set(vid, tagmask, portmask, 0);
+		}
+	} else {
+		rtl_vlan_RTL8367R_set(vid, tagmask, portmask, 0);
+	}
+#endif
+}
+
+static inline int32 rtl_isWanPort(struct dev_priv *cp, uint16 vid,
+	struct sk_buff *skb, int pid, int vid_type)
+{
+	struct iphdr *iph = NULL;
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	struct ipv6hdr *ipv6h = NULL;
+#endif
+	unsigned int l4Protocol = 0;
+
+	if (!cp || !skb)
+		return 0;
+
+	/* panic_printk("%s %d vid=%d pid=%d cp->portnum=%d\n", __FUNCTION__, __LINE__, vid, pid, cp->portnum); */
+	if (linux_vlan_enable && linux_vlan_hw_support_enable) {
+		/* bridge vid equal nat vid case */
+		if ((is_nat_wan_vlan(vid)) && (cp->portnum > 1)) {
+			if ((1 << pid) & RTL_WANPORT_MASK) {
+				if ((skb->data[0] == 0x01)
+					&& (skb->data[1] == 0x00)
+					&& (skb->data[2] == 0x5e)) {
+					iph = re865x_getIpv4Header(skb->data);
+					if (iph != NULL) {
+						l4Protocol = iph->protocol;
+						if (l4Protocol == IPPROTO_IGMP) {
+							return 1;
+						}
+					}
+				}
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+				else if ((skb->data[0] == 0x33)
+					&& (skb->data[1] == 0x33)
+					&& (skb->data[2] != 0xff)) {
+					ipv6h = re865x_getIpv6Header(skb->data);
+					if (ipv6h != NULL) {
+						l4Protocol =
+							re865x_getIpv6TransportProtocol
+							(ipv6h);
+						if (l4Protocol ==
+							IPPROTO_ICMPV6) {
+							return 1;
+						}
+					}
+				}
+#endif
+			}
+		} else {
+			/* bridge vid not equal nat case */
+
+			/* bridge rcved skb also use eth1, but it keeps tag here. */
+			if (cp->id == rtk_vlan_wan_vid
+				&& (1 << pid) == RTL_WANPORT_MASK
+				&& vid_type != VID_FROM_PACKET)
+				return 1;
+
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+			if (cp == NETDRV_PRIV(_rtl86xx_dev.pdev))
+				return 1;
+#endif
+		}
+	} else if (linux_vlan_enable && !linux_vlan_hw_support_enable) {
+		if (cp->id == RTL_WANVLANID)
+			return 1;
+	}
+
+	return 0;
+}
+
+#if 0
+static void rtk_del_eth_vlan(uint16 vid)
+{
+	/* 819x */
+#ifdef CONFIG_RTL_819X_SWCORE
+	rtl865x_delVlan(vid);
+#endif
+	/* mark_vc, 8367 or other integrated switch */
+
+}
+
+static int32 rtk_vlan_ctl_read(char *page, char **start, off_t off, int count,
+	int *eof, void *data)
+{
+	int len = 0;
+
+	len = sprintf(page, "rtk_vlan_ctl = %d\n", vlan_ctl_p->flag);
+	return len;
+}
+
+static int32 rtk_vlan_tbl_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[100];
+	int num;
+	int index;
+	uint32 mask;
+	uint32 tagMask;
+	uint32 vid;
+	linux_vlan_group_t *vlan_group_p = NULL;
+
+	if (!vlan_ctl_p->flag) {
+		printk("rtk 11q vlan support not enabled!!!\n");
+		return len;
+	}
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		num = sscanf(tmpbuf, "%d %d %x %x", &index, &vid, &mask,
+			&tagMask);
+
+		if (num != 4)
+			return len;
+
+		if (index > RTK_MAX_VLAN_GROUP)
+			return len;
+
+		if (vid <= 0 || vid > 4095)
+			return len;
+
+		/*clear the old one and delete old vlan group */
+		if (rtk_vlan_idx[index] != 0)	/* remove previous vlan if exist */
+		{
+			rtk_del_eth_vlan(rtk_vlan_idx[index]);
+		}
+
+		rtk_vlan_idx[index] = vid;
+		vlan_group_p = &vlan_ctl_p->group[vid];
+
+		memset(vlan_group_p, 0, sizeof(linux_vlan_group_t));
+		/*add new vlan group */
+		vlan_group_p->memberMask = mask;
+		vlan_group_p->tagMemberMask = tagMask;
+		vlan_group_p->vid = (uint16)vid;
+
+		rtk_add_eth_vlan(vlan_group_p->vid, vlan_group_p->memberMask,
+			vlan_group_p->tagMemberMask);
+
+	}
+
+	return len;
+}
+#endif
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST)
+#if defined(CONFIG_RTL_MULTICAST_PORT_MAPPING)
+static int rtl865x_nic_MulticastHardwareAccelerate(unsigned int brFwdPortMask,
+	unsigned int srcPort, unsigned int srcVlanId,
+	unsigned int srcIpAddr, unsigned int destIpAddr,
+	unsigned int mapPortMask)
+#else
+static int rtl865x_nic_MulticastHardwareAccelerate(unsigned int brFwdPortMask,
+	unsigned int srcPort, unsigned int srcVlanId,
+	unsigned int srcIpAddr, unsigned int destIpAddr)
+#endif
+{
+	int ret;
+	/* int fwdDescCnt; */
+	/* unsigned short port_bitmask=0; */
+
+	/* unsigned int tagged_portmask=0; */
+
+	struct rtl_multicastDataInfo multicastDataInfo;
+	struct rtl_multicastFwdInfo multicastFwdInfo;
+
+	rtl865x_tblDrv_mCast_t *existMulticastEntry;
+	rtl865x_mcast_fwd_descriptor_t fwdDescriptor;
+
+#if 0
+	printk("%s:%d,srcPort is %d,srcVlanId is %d,srcIpAddr is 0x%x,destIpAddr is 0x%x\n", __FUNCTION__, __LINE__, srcPort, srcVlanId, srcIpAddr, destIpAddr);
+#endif
+
+#if 0
+	if (brFwdPortMask & br0SwFwdPortMask) {
+		return -1;
+	}
+#endif
+	/* printk("%s:%d,destIpAddr is 0x%x, srcIpAddr is 0x%x, srcVlanId is %d, srcPort is %d\n",__FUNCTION__,__LINE__,destIpAddr, srcIpAddr, srcVlanId, srcPort); */
+	existMulticastEntry =
+		rtl865x_findMCastEntry(destIpAddr, srcIpAddr,
+		(unsigned short)srcVlanId, (unsigned short)srcPort);
+	if (existMulticastEntry != NULL) {
+		/*it's already in cache */
+		return 0;
+
+	}
+
+	if (brFwdPortMask == 0) {
+#if defined(CONFIG_RTL_MULTICAST_PORT_MAPPING)
+		rtl865x_blockMulticastFlow(srcVlanId, srcPort, srcIpAddr,
+			destIpAddr, mapPortMask);
+#else
+		rtl865x_blockMulticastFlow(srcVlanId, srcPort, srcIpAddr,
+			destIpAddr);
+#endif
+		return 0;
+	}
+
+	multicastDataInfo.ipVersion = 4;
+	multicastDataInfo.sourceIp[0] = srcIpAddr;
+	multicastDataInfo.groupAddr[0] = destIpAddr;
+
+	/*add hardware multicast entry */
+
+	memset(&fwdDescriptor, 0, sizeof(rtl865x_mcast_fwd_descriptor_t));
+	strcpy(fwdDescriptor.netifName, "eth*");
+	fwdDescriptor.fwdPortMask = 0xFFFFFFFF;
+
+	ret = rtl_getMulticastDataFwdInfo(nicIgmpModuleIndex,
+		&multicastDataInfo, &multicastFwdInfo);
+
+	if (ret != 0) {
+		return -1;
+	} else {
+		if (multicastFwdInfo.cpuFlag) {
+			fwdDescriptor.toCpu = 1;
+		}
+		fwdDescriptor.fwdPortMask =
+			multicastFwdInfo.fwdPortMask & (~(1 << srcPort));
+	}
+
+#if defined(CONFIG_RTL_MULTICAST_PORT_MAPPING)
+	fwdDescriptor.fwdPortMask &= mapPortMask;
+#endif
+
+	if (fwdDescriptor.fwdPortMask != 0) {
+		/* printk(" rtl865x_nic_MulticastHardwareAccelerate  , %s:%d,srcPort is %d,srcVlanId is %d,srcIpAddr is 0x%x,destIpAddr is 0x%x ,mask= %02x \n",__FUNCTION__,__LINE__,srcPort,srcVlanId,srcIpAddr,destIpAddr, */
+		/* fwdDescriptor.fwdPortMask); */
+#if defined(CONFIG_RTL_MULTICAST_PORT_MAPPING)
+		ret = rtl865x_addMulticastEntry(destIpAddr, srcIpAddr,
+			(unsigned short)srcVlanId, (unsigned short)srcPort,
+			&fwdDescriptor, 1, 0, 0, 0, mapPortMask);
+#else
+		ret = rtl865x_addMulticastEntry(destIpAddr, srcIpAddr,
+			(unsigned short)srcVlanId, (unsigned short)srcPort,
+			&fwdDescriptor, 1, 0, 0, 0);
+#endif
+	}
+
+	return 0;
+}
+
+#endif
+#endif
+
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+static int napi_recv(struct dev_priv *cp, int budget)
+{
+	struct sk_buff *pskb;
+	int work_done = 0;
+
+	while ((work_done < budget) &&
+	       (!skb_queue_empty(&cp->rx_napi_skb_queue))) {
+		pskb = skb_dequeue(&cp->rx_napi_skb_queue);
+		if (!pskb)
+			break;
+
+#ifdef CONFIG_RTL_ETH_NAPI_GRO_SUPPORT
+		if (napi_gro_receive(&cp->napi, pskb) != GRO_DROP)
+			work_done++;
+#else
+		if (netif_receive_skb(pskb) != NET_RX_DROP)
+			work_done++;
+#endif /* CONFIG_RTL_ETH_NAPI_GRO_SUPPORT */
+	}
+
+	return work_done;
+}
+
+static int rtl865x_poll(struct napi_struct *napi, int budget)
+{
+	struct dev_priv *cp = container_of(napi, struct dev_priv, napi);
+	int work_done = 0;
+
+	work_done = napi_recv(cp, budget);
+
+	if (work_done < budget) {
+#ifdef CONFIG_RTL_ETH_NAPI_GRO_SUPPORT
+		napi_complete_done(napi, work_done);
+#else
+		napi_complete(napi);
+#endif /* CONFIG_RTL_ETH_NAPI_GRO_SUPPORT */
+	}
+
+	return work_done;
+}
+#endif /* CONFIG_RTL_ETH_NAPI_SUPPORT */
+
+#ifdef CONFIG_SWCONFIG
+
+#define RTK_ETH_ALL_PORT_MASK 0x13f
+#define RTK_SWITCH_DEFAULT_VID 1
+/* #define RTK_SWITCH_DEFAULT_VID 9 */
+struct rtl819x_mib_counter {
+	unsigned base;
+	unsigned offset;
+	unsigned length;
+	unsigned memidx;	/* const char *name; */
+};
+/* 8367 mib stats */
+#define     STAT_IfInOctets 0
+#define    STAT_Dot3StatsFCSErrors 1
+#define    STAT_Dot3StatsSymbolErrors 2
+#define    STAT_Dot3InPauseFrames 3
+#define    STAT_Dot3ControlInUnknownOpcodes 4
+#define    STAT_EtherStatsFragments 5
+#define    STAT_EtherStatsJabbers 6
+#define    STAT_IfInUcastPkts 7
+#define    STAT_EtherStatsDropEvents 8
+#define    STAT_EtherStatsOctets 9
+#define    STAT_EtherStatsUnderSizePkts 10
+#define    STAT_EtherOversizeStats 11
+#define    STAT_EtherStatsPkts64Octets 12
+#define    STAT_EtherStatsPkts65to127Octets 13
+#define    STAT_EtherStatsPkts128to255Octets 14
+#define    STAT_EtherStatsPkts256to511Octets 15
+#define    STAT_EtherStatsPkts512to1023Octets 16
+#define    STAT_EtherStatsPkts1024to1518Octets 17
+#define    STAT_EtherStatsMulticastPkts 18
+#define    STAT_EtherStatsBroadcastPkts 19
+#define    STAT_IfOutOctets 20
+#define    STAT_Dot3StatsSingleCollisionFrames 21
+#define    STAT_Dot3StatsMultipleCollisionFrames 22
+#define    STAT_Dot3StatsDeferredTransmissions 23
+#define    STAT_Dot3StatsLateCollisions 24
+#define    STAT_EtherStatsCollisions 25
+#define    STAT_Dot3StatsExcessiveCollisions 26
+#define    STAT_Dot3OutPauseFrames 27
+#define    STAT_Dot1dBasePortDelayExceededDiscards 28
+#define    STAT_Dot1dTpPortInDiscards 29
+#define    STAT_IfOutUcastPkts 30
+#define    STAT_IfOutMulticastPkts 31
+#define    STAT_IfOutBroadcastPkts 32
+#define    STAT_OutOampduPkts 33
+#define    STAT_InOampduPkts 34
+#define    STAT_PktgenPkts 35
+#define    STAT_InMldChecksumError 36
+#define    STAT_InIgmpChecksumError 37
+#define    STAT_InMldSpecificQuery 38
+#define    STAT_InMldGeneralQuery 39
+#define   STAT_InIgmpSpecificQuery 40
+#define   STAT_InIgmpGeneralQuery 41
+#define   STAT_InMldLeaves 42
+#define   STAT_InIgmpInterfaceLeaves 43
+#define   STAT_InIgmpJoinsSuccess 44
+#define   STAT_InIgmpJoinsFail 45
+#define    STAT_InMldJoinsSuccess 46
+#define    STAT_InMldJoinsFail 47
+#define    STAT_InReportSuppressionDrop 48
+#define    STAT_InLeaveSuppressionDrop 49
+#define    STAT_OutIgmpReports 50
+#define   STAT_OutIgmpLeaves 51
+#define   STAT_OutIgmpGeneralQuery 52
+#define   STAT_OutIgmpSpecificQuery 53
+#define   STAT_OutMldReports 54
+#define   STAT_OutMldLeaves 55
+#define   STAT_OutMldGeneralQuery 56
+#define    STAT_OutMldSpecificQuery 57
+#define    STAT_InKnownMulticastPkts 58
+#define   STAT_IfInMulticastPkts 59
+#define   STAT_IfInBroadcastPkts 60
+
+static struct rtl819x_mib_counter rtl819x_mib_counters[] = {
+	{0, OFFSET_IFINOCTETS_P0, 8, STAT_IfInOctets, "IfInOctets"},
+	{0, OFFSET_ETHERSTATSUNDERSIZEPKTS_P0, 4, STAT_EtherStatsUnderSizePkts,
+			"EtherStatsUnderSizePkts"},
+	{0, OFFSET_ETHERSTATSFRAGMEMTS_P0, 4, STAT_EtherStatsFragments,
+			"EtherFragments"},
+	{0, OFFSET_ETHERSTATSPKTS64OCTETS_P0, 4, STAT_EtherStatsPkts64Octets,
+			"EtherStatsPkts64Octets"},
+	{0, OFFSET_ETHERSTATSPKTS65TO127OCTETS_P0, 4,
+			STAT_EtherStatsPkts65to127Octets,
+			"EtherStatsPkts65to127Octets"},
+	{0, OFFSET_ETHERSTATSPKTS128TO255OCTETS_P0, 4,
+			STAT_EtherStatsPkts128to255Octets,
+			"EtherStatsPkts128to255Octets"},
+	{0, OFFSET_ETHERSTATSPKTS256TO511OCTETS_P0, 4,
+			STAT_EtherStatsPkts256to511Octets,
+			"EtherStatsPkts256to511Octets"},
+	{0, OFFSET_ETHERSTATSPKTS512TO1023OCTETS_P0, 4,
+			STAT_EtherStatsPkts512to1023Octets,
+			"EtherStatsPkts512to1023Octets"},
+	{0, OFFSET_ETHERSTATSPKTS1024TO1518OCTETS_P0, 4,
+			STAT_EtherStatsPkts1024to1518Octets,
+			"EtherStatsPkts1024to1518Octets"},
+	{0, OFFSET_ETHERSTATSOVERSIZEPKTS_P0, 4, STAT_EtherOversizeStats,
+			"EtherOversizeStats"},
+	{0, OFFSET_ETHERSTATSJABBERS_P0, 4, STAT_EtherStatsJabbers,
+			"EtherStatsJabbers"},
+	{0, OFFSET_IFINUCASTPKTS_P0, 4, STAT_IfInUcastPkts, "IfInUcastPkts"},
+	{0, OFFSET_ETHERSTATSMULTICASTPKTS_P0, 4, STAT_EtherStatsMulticastPkts,
+			"EtherStatsMulticastPkts"},
+	{0, OFFSET_ETHERSTATSBROADCASTPKTS_P0, 4, STAT_EtherStatsBroadcastPkts,
+			"EtherStatsBroadcastPkts"},
+	{0, OFFSET_DOT1DTPPORTINDISCARDS_P0, 4, STAT_EtherStatsDropEvents,
+			"EtherStatsDropEvents"},
+	{0, OFFSET_DOT3STATSFCSERRORS_P0, 4, STAT_Dot3StatsFCSErrors,
+			"Dot3StatsFCSErrors"},
+	{0, OFFSET_DOT3INPAUSEFRAMES_P0, 4, STAT_Dot3InPauseFrames,
+			"Dot3InPauseFrames"},
+	{0, OFFSET_DOT3CONTROLINUNKNOWNOPCODES_P0, 4,
+			STAT_Dot3ControlInUnknownOpcodes,
+			"Dot3ControlInUnknownOpcodes"},
+	/* out */
+	{0, OFFSET_IFOUTOCTETS_P0, 8, STAT_IfOutOctets, "IfOutOctets"},
+	{0, OFFSET_DOT3STATSSINGLECOLLISIONFRAMES_P0, 4,
+			STAT_Dot3StatsSingleCollisionFrames,
+			"Dot3StatsSingleCollisionFrames"},
+	{0, OFFSET_DOT3STATSMULTIPLECOLLISIONFRAMES_P0, 4,
+			STAT_Dot3StatsMultipleCollisionFrames,
+			"Dot3StatMultipleCollisionFrames"},
+	{0, OFFSET_DOT3STATSDEFERREDTRANSMISSIONS_P0, 4,
+			STAT_Dot3StatsDeferredTransmissions,
+			"Dot3sDeferredTransmissions"},
+	{0, OFFSET_DOT3STATSLATECOLLISIONS_P0, 4, STAT_Dot3StatsLateCollisions,
+			"Dot3StatsLateCollisions"},
+	{0, OFFSET_ETHERSTATSCOLLISIONS_P0, 4, STAT_EtherStatsCollisions,
+			"EtherStatsCollisions"},
+	{0, OFFSET_DOT3OUTPAUSEFRAMES_P0, 4, STAT_Dot3OutPauseFrames,
+			"Dot3OutPauseFrames"},
+	{0, OFFSET_IFOUTUCASTPKTS_P0, 4, STAT_IfOutUcastPkts, "IfOutUcastPkts"},
+	{0, OFFSET_IFOUTMULTICASTPKTS_P0, 4, STAT_IfOutMulticastPkts,
+			"IfOutMulticastPkts"},
+	{0, OFFSET_IFOUTBROADCASTPKTS_P0, 4, STAT_IfOutBroadcastPkts,
+			"IfOutBroadcastPkts"},
+};
+
+static inline void insert_vlan_tag(uint16 vid, struct sk_buff *skb)
+{
+	memmove(skb->data - VLAN_HLEN, skb->data, ETH_ALEN << 1);
+	skb_push(skb, VLAN_HLEN);
+	*((uint16 *)(skb->data + (ETH_ALEN << 1))) =
+		__constant_htons(ETH_P_8021Q);
+	/* *((uint16*)(skb->data+(ETH_ALEN<<1)+2)) = vid; */
+	*((uint16 *)(skb->data + (ETH_ALEN << 1) + 2)) = __constant_htons(vid);	/* mark_97f */
+}
+
+#define REMOVE_TAG(skb) { \
+	memmove(skb->data+VLAN_HLEN, skb->data, ETH_ALEN*2); \
+	skb_pull(skb, VLAN_HLEN); \
+}
+#if 0
+static const char *rtl819x_speed_str(unsigned int speed)
+{
+	switch (speed) {
+	case PortStatusLinkSpeed10M:
+		return "10baseT";
+	case PortStatusLinkSpeed100M:
+		return "100baseT";
+	case PortStatusLinkSpeed1000M:
+		return "1000baseT";
+	}
+
+	return "unknown";
+}
+#endif
+
+static inline uint16 rtk_get_skb_vid(struct sk_buff *skb)
+{
+	uint16 vid = 0;
+
+	if (*((unsigned short *)(skb->data + (ETH_ALEN << 1))) ==
+		__constant_htons(ETH_P_8021Q)) {
+		/* vid = *((unsigned short *)(skb->data+(ETH_ALEN<<1)+2))&0x0fff; */
+		vid = ntohs(*(uint16 *)(skb->data + (ETH_ALEN << 1) + 2)) & 0x0fff;	/* mark_97f */
+	}
+
+	return vid;
+}
+
+static inline unsigned int rtk_get_vlan_portmask(uint16 vid)
+{
+	rtl865x_vlan_entry_t *vlan_entry;
+
+	vlan_entry = _rtl8651_getVlanTableEntry(vid);
+
+	if (!vlan_entry)
+		return 0;
+	else
+		return (vlan_entry->memberPortMask & 0x3f);	/* not include  cpuport */
+
+}
+
+uint32 rtk_get_vlan_tagmask(uint16 vid)
+{
+	uint32 mask;
+	rtl865x_vlan_entry_t *vlan_entry;
+
+	vlan_entry = _rtl8651_getVlanTableEntry(vid);
+
+	if (!vlan_entry)
+		return 0;
+
+	mask = vlan_entry->memberPortMask & (~vlan_entry->untagPortMask);
+	return mask;
+}
+
+static inline void rtk_rm_skb_vid(struct sk_buff *skb)
+{
+	/* if nic decide to directTx , then we need to remove packet's tag if exist */
+	/* then  use HW auto tag function in swNic.c to decide packet tag or not */
+	uint16 vid = rtk_get_skb_vid(skb);
+	if (vid != 0)
+		REMOVE_TAG(skb);
+}
+
+static void rtk_fill_vlan_txinfo(struct sk_buff *skb, uint16 *vid,
+	uint16 *member)
+{
+	uint16 skb_vid = 0;
+
+	if (!swconfig_vlan_enable)
+		return;
+	/* if packet with tag , then use the vid as nictx vid. */
+	/* if packet without tag  use cp->id as its vlan */
+	skb_vid = rtk_get_skb_vid(skb);
+	if (skb_vid != 0) {
+		*vid = skb_vid;
+		*member = (uint16)(rtk_get_vlan_portmask(skb_vid));	/* only 0~5 port */
+	}
+}
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+static void rtk_add_cpuport_tag(uint16 vid, uint32 pid, struct sk_buff *skb)
+#else
+static void rtk_add_cpuport_tag(uint16 vid, struct sk_buff *skb)
+#endif
+{
+	rtl865x_vlan_entry_t *vlan_entry;
+
+	vlan_entry = _rtl8651_getVlanTableEntry(vid);
+
+	if (!vlan_entry) {
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		/*jwj: multicast packet will with vid=0.But I am not sure wether
+		 * 97f has the same issue??? */
+		if ((vid == 0) && (rtl819x_getSwEthPvid(pid, &vid) == SUCCESS)) {
+			insert_vlan_tag(vid, skb);
+			return;
+		} else
+#endif
+		{
+			printk("cann't find vlan=%d in hw entry\n", vid);
+			return;
+		}
+	}
+	/* check if cpu port is tagged then add tag into skb data(packet content) */
+	if (((~vlan_entry->untagPortMask) & RTK_ETH_ALL_PORT_MASK
+			& RTL819X_HW_CPUPORT_MASK) == RTL819X_HW_CPUPORT_MASK)
+		insert_vlan_tag(vid, skb);
+}
+
+static struct dev_priv *rtk_decide_vlan_cp(int pid, struct sk_buff *skb)
+{
+	struct dev_priv *dp = NULL;
+	/* usually , we only report eth0 to kerenl in switch mode */
+	dp = (struct dev_priv *)(netdev_priv(_rtl86xx_dev.dev[0]));
+	return dp;
+}
+
+static inline unsigned int to_swconfig_portmask(unsigned int portmask)
+{
+	unsigned int mask;
+	mask = portmask;
+	if ((portmask & BIT(RTL819X_HW_PORT_NUM_CPU)) ==
+		BIT(RTL819X_HW_PORT_NUM_CPU))
+		mask = ((mask) & (~(BIT(RTL819X_HW_PORT_NUM_CPU)))) |
+			BIT(RTL819X_PORT_NUM_CPU);
+
+	return mask;
+}
+
+static inline unsigned int to_rtl819x_portmask(unsigned int portmask)
+{
+	unsigned int mask;
+	mask = portmask;
+	if ((portmask & BIT(RTL819X_PORT_NUM_CPU)) == BIT(RTL819X_PORT_NUM_CPU))
+		mask = ((mask) & (~(BIT(RTL819X_PORT_NUM_CPU)))) |
+			(RTL819X_HW_CPUPORT_MASK);
+
+	return mask;
+}
+
+#if 0
+static void rtk_init_legacy_vconfig(void)
+{
+	/* eth0  default setting for gatway mode */
+	vlanconfig[0].memPort = RTL_LANPORT_MASK;
+	vlanconfig[0].vid = RTL_LANVLANID;
+	vlanconfig[0].untagSet = RTL_LANPORT_MASK;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->portmask = RTL_LANPORT_MASK;	/* eth0 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[0]))->id =
+		RTL_LANVLANID;
+	((struct dev_priv *)(netdev_priv(_rtl86xx_dev.dev[0])))->portnum = 4;
+	/* eth1 default setting for gatway mode */
+	vlanconfig[1].vid = RTL_WANVLANID;
+	vlanconfig[1].memPort = RTL_WANPORT_MASK;
+	vlanconfig[1].untagSet = RTL_WANPORT_MASK;
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->portmask = RTL_WANPORT_MASK;	/* eth1 */
+	((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[1]))->id = RTL_WANVLANID;	/* eth1 */
+	((struct dev_priv *)(netdev_priv(_rtl86xx_dev.dev[0])))->portnum = 1;
+}
+#endif
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+#define RTL8367R_LAN_EFID     2
+
+extern int rtk_stat_port_get(uint32 port, uint32 cntr_idx, uint64 *pCntr);
+extern int rtk_vlan_init(void);
+extern int rtk_vlan_set(uint32 vid, uint32 mbrmsk, uint32 untagmsk, uint32 fid);
+extern int rtk_port_efid_set(uint32 port, uint32 efid);
+extern int rtk_vlan_portPvid_set(uint32 port, uint32 pvid, uint32 priority);
+
+static unsigned int rtk_get_rtl8367_mibCounter_val(int port, int mib_idx)
+{
+	uint64 mibCnt = 0;
+	uint32 *counter32;
+
+	counter32 = (uint32 *)&mibCnt;
+	rtk_stat_port_get(port, rtl819x_mib_counters[mib_idx].memidx, &mibCnt);
+
+	/* f(port==0) */
+	/* printk("mib_idx=%d , mibCnt=%d ,mibCnt32=%d",rtl819x_mib_counters[mib_idx].memidx,*counter32,*(counter32+1)); //mark_bb */
+	return *(counter32 + 1);
+}
+
+unsigned int rtk_get_8367_port_status(int port, struct switch_port_link *link)
+{
+	int status, speed, duplex;
+
+	rtk_port_phyStatus_get(port, &status, &speed, &duplex);
+
+	/* workaround for port5 and cpu port status issue */
+	if (port == 5)
+		status = 0;
+	if (port == 6)
+		speed = PortStatusLinkSpeed1000M;
+
+	if (status)
+		link->link = 1;
+	else
+		link->link = 0;
+
+	if (!link->link)
+		return 0;
+
+	if (duplex)
+		link->duplex = 1;
+	else
+		link->duplex = 0;
+
+	link->tx_flow = 1;	/* mark_bb , FIXME */
+	link->rx_flow = 1;
+	link->aneg = 1;
+
+	switch (speed) {
+	case PortStatusLinkSpeed10M:
+		link->speed = SWITCH_PORT_SPEED_10;
+		break;
+	case PortStatusLinkSpeed100M:
+		link->speed = SWITCH_PORT_SPEED_100;
+		break;
+	case PortStatusLinkSpeed1000M:
+		link->speed = SWITCH_PORT_SPEED_1000;
+		break;
+	default:
+		link->speed = SWITCH_PORT_SPEED_UNKNOWN;
+	}
+	return 0;
+}
+
+void rtk_init_8367_vconfig(void)
+{
+	int i;
+	int retVal = 0;
+	int32 totalVlans =
+		((sizeof(vlanconfig)) / (sizeof(struct rtl865x_vlanConfig))) -
+		1;
+
+	/* 8367_VLAN */
+	rtk_vlan_init();
+
+	/* clear mib counter */
+	rtk_stat_global_reset();
+
+	/* clear all vlan */
+	for (i = 0; i < 4096; i++) {
+		/* retVal=rtk_vlan_set(i, BIT(RTL8367R_WAN) |BIT(r8367_cpu_port) , 0, 0); */
+		retVal = rtk_vlan_set(i, 0, 0, 0);	/* mark_8367 */
+	}
+
+	/* clear efid seeting , ok? */
+	for (i = 0; i < 5; i++) {
+		retVal = rtk_port_efid_set(i, RTL8367R_LAN_EFID);
+	}
+
+	/* map  real 819x vlan setting to 8367 */
+	for (i = 0; i < totalVlans; i++) {
+		if (vlanconfig[i].vid)
+			retVal = rtk_vlan_set(vlanconfig[i].vid, vlanconfig[i].memPort, vlanconfig[i].untagSet, 0);	/* mark_bb , fid defaut 0 , FIXME */
+	}
+
+	RTL8367R_cpu_tag(1);
+
+}
+
+#endif
+
+static void rtk_init_swconfig_vconfig(void)
+{
+	/* init vconfig with only one vlan with all port */
+	vlanconfig[0].memPort = RTK_ETH_ALL_PORT_MASK;
+	vlanconfig[0].untagSet = RTK_ETH_ALL_PORT_MASK;
+
+	vlanconfig[0].vid = RTK_SWITCH_DEFAULT_VID;
+	vlanconfig[0].isWan = 0;
+
+	((struct dev_priv *)(netdev_priv(_rtl86xx_dev.dev[0])))->portmask =
+		RTK_ETH_ALL_PORT_MASK;
+	((struct dev_priv *)(netdev_priv(_rtl86xx_dev.dev[0])))->id =
+		vlanconfig[0].vid;
+	((struct dev_priv *)(netdev_priv(_rtl86xx_dev.dev[0])))->portnum =
+		RTL819X_NUM_PORTS;
+
+	/* wan config disable */
+	vlanconfig[1].vid = 0;
+	vlanconfig[1].memPort = 0;
+	vlanconfig[1].untagSet = 0;
+	vlanconfig[1].isWan = 0;
+	((struct dev_priv *)(netdev_priv(_rtl86xx_dev.dev[1])))->portmask = 0;
+	((struct dev_priv *)(netdev_priv(_rtl86xx_dev.dev[1])))->id = 0;
+	((struct dev_priv *)(netdev_priv(_rtl86xx_dev.dev[1])))->portnum = 0;
+
+}
+
+void rtk_reset_rtl819x_setting(void)	/* copy from rtk_vlan_support=0 switch setting */
+{
+	swconfig_vlan_enable = 0;
+	rtk_init_swconfig_vconfig();
+
+	rtl_reinit_hw_table();
+	reinit_vlan_configure(vlanconfig);
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	rtk_init_8367_vconfig();
+	rtl865x_disableRtl8367ToCpuAcl();
+#endif
+
+	/* unknow vlan drop */
+	REG32(SWTCR0) &= ~(1 << 15);	/* FIXME , mark_sw , need trap unkow vlan , ok? */
+
+#if defined(CONFIG_RTL_LAYERED_DRIVER_ACL)
+	/* rtl865x_enable_acl(1); //FIXME , mark_sw */
+#endif
+
+	rtl865xC_setNetDecisionPolicy(NETIF_PORT_BASED);
+
+}
+
+void rtk_set_vlan_enable(int enable)
+{
+	if (enable) {
+		swconfig_vlan_enable = 1;
+		WRITE_MEM32(VCR0, READ_MEM32(VCR0) & (~EN_ALL_PORT_VLAN_INGRESS_FILTER));	/* Disable VLAN ingress filter of all ports */
+	} else			/* disable */
+	{
+		swconfig_vlan_enable = 0;
+		printk("Not support vlan disable fuction \n");
+		/* WRITE_MEM32( VCR0, READ_MEM32( VCR0 ) | ( EN_ALL_PORT_VLAN_INGRESS_FILTER) ); */		/* Enable VLAN ingress filter of all ports */
+		/* or turn on 8021q ignore mode ? */
+	}
+}
+
+int rtk_get_vlan_entry(u32 vid, struct rtl819x_vlan_4k *vlan4k)
+{
+	rtl865x_vlan_entry_t *vlan_entry;
+
+	vlan_entry = _rtl8651_getVlanTableEntry(vid);
+
+	if (!vlan_entry)
+		return -1;
+
+	vlan4k->member = to_swconfig_portmask(vlan_entry->memberPortMask);
+	vlan4k->untag = to_swconfig_portmask(vlan_entry->untagPortMask);
+	vlan4k->vid = vid;
+	vlan4k->fid = vlan_entry->fid;
+
+	return 0;
+}
+
+int rtk_set_port_pvid(int port, unsigned int pvid)
+{
+
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	rtk_vlan_portPvid_set(port, pvid, 0);
+#endif
+	/* 819x */
+#ifdef CONFIG_RTL_819X_SWCORE
+	if (port == RTL819X_PORT_NUM_CPU)	/* map to real cpu port */
+		port = RTL819X_HW_PORT_NUM_CPU;
+	rtl8651_setAsicPvid(port, pvid);
+#endif
+
+	return 0;
+}
+
+int rtk_set_hw_vlan(unsigned int vid, unsigned int member, unsigned int untag,
+	unsigned int fid)
+{
+	unsigned int tag_mask;
+#if defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+	if (vid == hw_nat_wan_vid)
+		fid = RTL_WAN_FID;
+#endif
+#ifdef CONFIG_RTL_819X_SWCORE
+	/* del vlan first */
+	rtl865x_delVlan(vid);
+	/*add vlan info to switch */
+	rtl865x_addVlan(vid);
+	rtl865x_addVlanPortMember(vid, to_rtl819x_portmask(member));	/* mark_vc , need cpu port ? */
+	tag_mask = ((~untag) & RTL819X_HW_PORT_ALL_MASK);
+	rtl865x_setVlanPortTag(vid, to_rtl819x_portmask(tag_mask), TRUE);
+	rtl865x_setVlanFilterDatabase(vid, fid);
+	/* rtk_update_netif_vlan(1,vid,rtk_hw_port_map(vid,portmask));  //mark_sw */
+#endif
+	/* 8367 here , mark_sw */
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	rtk_vlan_set(vid, member, untag, fid);	/* mark_bb , fid defaut 0 , FIXME */
+#endif
+
+#if defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+	rtl_process_hw_netif(vid);
+	rtl_process_hw_l3_default_router();
+#endif
+
+	return 0;
+}
+
+int rtk_get_port_pvid(int port, int *val)
+{
+
+#ifdef CONFIG_RTL_819X_SWCORE
+	if (port == RTL819X_PORT_NUM_CPU)	/* map to real cpu port */
+		port = RTL819X_HW_PORT_NUM_CPU;
+	rtl8651_getAsicPVlanId(port, val);
+#endif
+
+	return 0;
+}
+
+unsigned int rtk_get_819x_port_status(int port, struct switch_port_link *link)
+{
+	uint32 regData;
+	uint32 speedData;
+
+	regData = READ_MEM32(PSRP0 + ((port) << 2));
+	speedData =
+		(regData & PortStatusLinkSpeed_MASK) >>
+		PortStatusLinkSpeed_OFFSET;
+
+	if (regData & PortStatusLinkUp)
+		link->link = 1;
+	else
+		link->link = 0;
+
+	if (!link->link)
+		return 0;
+
+	if (regData & PortStatusDuplex)
+		link->duplex = 1;
+	else
+		link->duplex = 0;
+
+	if (regData & PortStatusTXPAUSE)
+		link->tx_flow = 1;
+	else
+		link->tx_flow = 0;
+
+	if (regData & PortStatusRXPAUSE)
+		link->rx_flow = 1;
+	else
+		link->rx_flow = 0;
+
+	if (regData & PortStatusNWayEnable)
+		link->aneg = 1;
+	else
+		link->aneg = 0;
+
+	switch (speedData) {
+	case PortStatusLinkSpeed10M:
+		link->speed = SWITCH_PORT_SPEED_10;
+		break;
+	case PortStatusLinkSpeed100M:
+		link->speed = SWITCH_PORT_SPEED_100;
+		break;
+	case PortStatusLinkSpeed1000M:
+		link->speed = SWITCH_PORT_SPEED_1000;
+		break;
+	default:
+		link->speed = SWITCH_PORT_SPEED_UNKNOWN;
+	}
+	return 0;
+}
+
+unsigned int rtk_get_port_status(int port, struct switch_port_link *link)
+{
+#if defined(CONFIG_RTL_8367R_SUPPORT)
+	return rtk_get_8367_port_status(port, link);
+#else
+	return rtk_get_819x_port_status(port, link);
+#endif
+
+}
+
+void rtk_reset_mibCounter(void)
+{
+	rtl8651_clearAsicCounter();
+#ifdef CONFIG_RTL_8367R_SUPPORT
+	rtk_stat_global_reset();
+#endif
+}
+
+char *rtk_get_mibCounter_name(int mib_idx)
+{
+	return (char *)rtl819x_mib_counters[mib_idx].name;
+}
+
+unsigned int rtk_get_mibCounter_val(int port, int mib_idx)
+{
+#ifndef CONFIG_RTL_8367R_SUPPORT
+	/* extern uint64 rtl865xC_returnAsicCounter64(uint32 offset); */
+	uint32 addrOffset_fromP0 = port * MIB_ADDROFFSETBYPORT;
+	unsigned int counter32 = 0;
+
+	/* if(rtl819x_mib_counters[mib_idx].length == 8 ) */
+	/* counter = rtl865xC_returnAsicCounter64( rtl819x_mib_counters[mib_idx].offset+ addrOffset_fromP0 ); */
+	/* else */
+	counter32 =
+		rtl8651_returnAsicCounter(rtl819x_mib_counters[mib_idx].offset +
+		addrOffset_fromP0);
+	return counter32;
+#else
+	return rtk_get_rtl8367_mibCounter_val(port, mib_idx);
+#endif
+}
+
+int rtk_get_mibCounter_num(void)
+{
+	return ARRAY_SIZE(rtl819x_mib_counters);
+}
+
+#if defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 hw_nat_vid_read(struct seq_file *s, void *v)
+{
+	seq_printf(s, "%s %u %s %u\n", "hw_nat_lan_vid:", hw_nat_lan_vid,
+		"hw_nat_wan_vid:", hw_nat_wan_vid);
+
+	return 0;
+}
+#else /*CONFIG_RTL_PROC_NEW */
+static int hw_nat_vid_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+	int len;
+	len = sprintf(page, "%s %u %s %u\n", "hw_nat_lan_vid:", hw_nat_lan_vid,
+		"hw_nat_wan_vid:", hw_nat_wan_vid);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+}
+#endif /*CONFIG_RTL_PROC_NEW */
+
+static int hw_nat_vid_write(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+	char tmp[32];
+
+	if (buffer && !copy_from_user(tmp, buffer, count)) {
+		int num =
+			sscanf(tmp, "%u %u", &hw_nat_lan_vid, &hw_nat_wan_vid);
+		if (num != 2) {
+			printk("invalid vlan parameter!\n");
+		}
+
+	}
+
+	return count;
+}
+
+int hw_nat_vid_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, hw_nat_vid_read, PDE_DATA(inode)));
+}
+
+static ssize_t hw_nat_vid_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return hw_nat_vid_write(file, userbuf, count, off);
+}
+
+struct file_operations hw_nat_vid_proc_fops = {
+	.open = hw_nat_vid_single_open,
+	.write = hw_nat_vid_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+static int rtl_create_hw_nat_vid_proc(void)
+{
+
+#ifndef CONFIG_RTL_PROC_NEW
+	struct proc_dir_entry *hw_nat_vid_entry;
+
+	hw_nat_vid_entry = create_proc_entry("hw_nat_vid", 0, NULL);
+	if (hw_nat_vid_entry) {
+		hw_nat_vid_entry->read_proc = hw_nat_vid_read;
+		hw_nat_vid_entry->write_proc = hw_nat_vid_write;
+	}
+#else
+	proc_create_data("hw_nat_vid", 0644, &proc_root, &hw_nat_vid_proc_fops,
+		NULL);
+#endif
+
+	return SUCCESS;
+}
+
+static void rtl_set_vlanconfig(uint16 vid)
+{
+	int32 i;
+	int32 count = sizeof(vlanconfig) / sizeof(struct rtl865x_vlanConfig);
+
+	for (i = 0; i < count; i++) {
+		if (strncmp(vlanconfig[i].ifname, RTL_DRV_WAN0_NETIF_NAME,
+				MAX_IFNAMESIZE) == 0) {
+			vlanconfig[i].isWan = 1;	/* roll back wan config */
+			vlanconfig[i].vid = vid;
+		} else if (strncmp(vlanconfig[i].ifname, "ppp", 3) == 0) {
+			vlanconfig[i].isWan = 1;	/* roll back wan config */
+			vlanconfig[i].vid = vid;
+			strncpy(vlanconfig[i].ifname,
+				RTL_SWCONFIG_DRV_PPP_NETIF_NAME, IFNAMSIZ);
+		}
+	}
+}
+
+static int32 rtl_process_hw_netif(uint16 vid)
+{
+	int32 i;
+	int32 retval;
+
+	/*Add wan netif */
+	/* printk("====%s[%d], vid is %d====\n", __FUNCTION__, __LINE__, vid); */
+	if (vid == hw_nat_lan_vid) {
+		uint32 netif_vid = 0;
+
+		if (rtl865x_getNetifVid(RTL_DRV_LAN_NETIF_NAME,
+				&netif_vid) == SUCCESS) {
+			if (netif_vid != hw_nat_lan_vid) {
+				rtl865x_setNetifVid(RTL_DRV_LAN_NETIF_NAME,
+					hw_nat_lan_vid);
+			}
+		}
+	} else if (vid == hw_nat_wan_vid) {
+		rtl_set_vlanconfig(vid);
+
+		for (i = 0; vlanconfig[i].vid != 0; i++) {
+			rtl865x_netif_t netif;
+			struct net_device *wan_dev;
+
+			if (vlanconfig[i].isWan == 0)
+				continue;
+
+			memset(&netif, 0, sizeof(rtl865x_netif_t));
+			if (strncmp(vlanconfig[i].ifname, "ppp", 3)) {
+				sprintf(hw_nat_wan_dev_name, "eth0.%d", vid);
+				strncpy(netif.name, hw_nat_wan_dev_name,
+					MAX_IFNAMESIZE);
+				if ((wan_dev = __dev_get_by_name(&init_net,
+							hw_nat_wan_dev_name)) !=
+					NULL)
+					memcpy(netif.macAddr.octet,
+						wan_dev->dev_addr,
+						ETHER_ADDR_LEN);
+				else
+					memcpy(netif.macAddr.octet,
+						vlanconfig[i].mac.octet,
+						ETHER_ADDR_LEN);
+			} else {
+				memcpy(netif.name, vlanconfig[i].ifname,
+					MAX_IFNAMESIZE);
+				memcpy(netif.macAddr.octet,
+					vlanconfig[i].mac.octet,
+					ETHER_ADDR_LEN);
+			}
+
+			netif.vid = vid;
+			netif.mtu = vlanconfig[i].mtu;
+			netif.if_type = vlanconfig[i].if_type;
+			netif.is_wan = vlanconfig[i].isWan;
+			netif.is_slave = vlanconfig[i].is_slave;
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST) || defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+			netif.enableRoute = 1;
+#endif
+#if defined(CONFIG_RTL_8198C)
+			netif.mtuV6 = vlanconfig[i].mtu;
+#if defined(CONFIG_IPV6) || (defined(CONFIG_RTL_MLD_SNOOPING) && defined(CONFIG_RTL_HARDWARE_MULTICAST))
+			netif.enableRouteV6 = 1;	/*jwj:enable ipv6, then enable v6 router */
+#endif
+#endif
+
+			retval = rtl865x_addNetif(&netif);
+			if (netif.is_slave == 1)
+				rtl865x_attachMasterNetif(netif.name,
+					hw_nat_wan_dev_name);
+			rtl865x_reConfigDefaultAcl(netif.name);
+
+			if ((retval != SUCCESS)
+				&& (retval != RTL_EVLANALREADYEXISTS)) {
+				printk("=======%s(%d),retval(%d)\n",
+					__FUNCTION__, __LINE__, retval);
+			}
+			/* printk("====%s[%d], vid is %d====\n", __FUNCTION__, __LINE__, vid); */
+		}
+		return SUCCESS;
+	}
+
+	return FAILED;
+}
+
+static int32 rtl_process_hw_l3_default_router(void)
+{
+	int ret = FAILED;
+
+	if (rtl_check_default_router_valid() == FALSE) {
+		/*Add hw l3 default router to hw_nat_wan_dev_name */
+#ifdef CONFIG_RTL_LAYERED_DRIVER_L3
+		/*FIXME_hyking: should add default route to cpu.... */
+		if (rtl865x_curOpMode == GATEWAY_MODE) {
+			ret = rtl865x_addRoute(0, 0, 0, hw_nat_wan_dev_name, 0);
+		}
+#endif
+	}
+
+	return ret;
+}
+#endif
+#endif
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+int rtl819x_setSwEthPvid(uint16 port, uint16 pvid)
+{
+	if (port >= RTL8651_PORT_NUMBER)
+		return FAILED;
+
+	sw_pvid[port] = pvid;
+	return SUCCESS;
+}
+
+int rtl819x_getSwEthPvid(uint16 port, uint16 *pvid)
+{
+	if (port >= RTL8651_PORT_NUMBER)
+		return FAILED;
+
+	*pvid = sw_pvid[port];
+	return SUCCESS;
+}
+#endif
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+int rtl_get_bind_port_mask_by_dev_name(char *name)
+{
+	int i;
+
+	for (i = 0; i < LAN_DEV_NUM_MAX; i++) {
+		if (strncmp(name, lan_dev_bind_mask_mapping_drv[i].ifname,
+				IFNAMSIZ) == 0) {
+			return lan_dev_bind_mask_mapping_drv[i].bind_mask;
+		}
+	}
+
+	return 0;
+}
+
+static int _rtl_update_vlan_table(int vlan_id)
+{
+	int i;
+	int _the_num_of_this_vid_WAN = 0;
+	int _has_bridged_WAN = 0;
+
+	/*      member ports are always WAN + LAN       */
+	for (i = 0; vlanconfig[i].ifname[0] != '\0'; i++) {
+		if (vlanconfig[i].isWan && (vlanconfig[i].is_slave == 0)
+			&& (vlanconfig[i].vid == vlan_id)) {
+			_the_num_of_this_vid_WAN++;
+			if (vlanconfig[i].protocol == SMUX_PROTO_BRIDGE)
+				_has_bridged_WAN = 1;
+		}
+	}
+
+	if (_the_num_of_this_vid_WAN > 0) {
+		uint32 memPort;
+		uint32 untagSet;
+		int ret;
+
+		if (_has_bridged_WAN) {
+			memPort = (RTL_LANPORT_MASK | RTL_WANPORT_MASK);
+			if (vlan_id == RTL_BRIDGE_WANVLANID)
+				untagSet =
+					(RTL_LANPORT_MASK | RTL_WANPORT_MASK);
+			else
+				untagSet = RTL_LANPORT_MASK;
+		} else {
+			memPort = RTL_WANPORT_MASK;
+			if (vlan_id == RTL_WANVLANID)
+				untagSet = RTL_WANPORT_MASK;
+			else
+				untagSet = 0;
+		}
+
+		ret = rtl865x_addVlan(vlan_id);
+		if (ret == SUCCESS) {
+			/*  this vlan is the first time to setup , set its fid */
+			if (rtl865x_setVlanFilterDatabase(vlan_id,
+					RTL_WAN_FID) != SUCCESS) {
+				printk("Leave %s @ %d \n", __FUNCTION__,
+					__LINE__);
+				return FAILED;
+			}
+		} else if (ret != RTL_EVLANALREADYEXISTS) {
+			printk("Leave %s @ %d \n", __FUNCTION__, __LINE__);
+			return FAILED;
+		}
+
+		/*  No matter whether we has setup this vlan table before or not , reset its member/untag ports  */
+		if (rtl865x_modVlanPortMember(vlan_id, memPort,
+				untagSet) != SUCCESS) {
+			printk("Leave %s @ %d \n", __FUNCTION__, __LINE__);
+			return FAILED;
+		}
+	} else {
+		if (rtl865x_delVlan(vlan_id) != SUCCESS) {
+			printk("Leave %s @ %d \n", __FUNCTION__, __LINE__);
+			return FAILED;
+		}
+	}
+
+	return SUCCESS;
+}
+
+static int32 _rtl_update_pvid(void)
+{
+	int i, j;
+	int bridged_wan_exist = 0;
+	int novlantag_bridged_wan_exist = 0;
+	int novlantag_routing_wan_exist = 0;
+
+	re865x_packVlanConfig(vlanconfig, packedVlanConfig);
+
+	for (j = 0; packedVlanConfig[j].vid != 0; j++) {
+		if (packedVlanConfig[j].isWan) {
+			if (packedVlanConfig[j].protocol == SMUX_PROTO_BRIDGE) {
+				bridged_wan_exist = 1;
+				if (packedVlanConfig[j].vid ==
+					RTL_BRIDGE_WANVLANID)
+					novlantag_bridged_wan_exist = 1;
+			} else {
+				if (packedVlanConfig[j].vid == RTL_WANVLANID)
+					novlantag_routing_wan_exist = 1;
+			}
+		}
+	}
+
+	/* printk("(%s) bridged_wan_exist:%d   novlantag_bridged_wan_exist:%d  novlantag_routing_wan_exist:%d \n" */
+	/* ,__FUNCTION__,bridged_wan_exist,novlantag_bridged_wan_exist,novlantag_routing_wan_exist); */
+
+	for (i = 0; i < RTL8651_PORT_NUMBER + 3; i++) {
+		uint16 pvid;
+		/* wan port */
+		if ((1 << i) & RTL_WANPORT_MASK) {
+			/*
+			 * vlan 7's mbr = WAN + LAN     (for downstream bridging unicast hwacc)
+			 * vlan 8's mbr = WAN           (for downstream routing unicast hwacc)
+			 *
+			 * downstream bridging unicast hwacc
+			 * : vid has to be 7
+			 * downstream IPoE unicast hwacc
+			 * : vid could be either 7 or 8
+			 * downstream PPPoE unicast hwacc
+			 * : vid could be either 7 or 8
+			 *
+			 * downstream bridging multicast hwacc  : vid could be either 7 or 8
+			 * downstream IPoE multicast hwacc      : vid could be either 7 or 8
+			 * downstream PPPoE multicast hwacc     : vid has to be 8 (for DA changes from GMAC to 01:00:5e:xx:xx:xx)
+			 *
+			 * Hence, Default WAN port's pvid is 8 , but...
+			 * (1) If there existed one bridged WAN, pvid should be 7
+			 * (2) If there existed both bridged and PPPoE WAN, pvid is 7 and set pppoe's pvid = 8
+			 */
+			if (novlantag_bridged_wan_exist)
+				pvid = RTL_BRIDGE_WANVLANID;
+			else
+				pvid = RTL_WANVLANID;
+
+/* //support untag L2 unicast pppoe passthrough hwacc, but l3 pppoe multicast will no hwacc
+			if(novlantag_bridged_wan_exist && novlantag_routing_wan_exist)
+				rtl8651_setProtocolBasedVLAN(RTL8651_PBV_RULE_PPPOE_SESSION,i,1,RTL_WANVLANID);
+			else
+				rtl8651_setProtocolBasedVLAN(RTL8651_PBV_RULE_PPPOE_SESSION,i,0,0);
+*/
+		} else {	/* lan port */
+#if defined(CONFIG_RTL8685) || defined(CONFIG_RTL8685S)
+			pvid = RTL_LANVLANID;
+#else
+			if (!bridged_wan_exist)
+				pvid = RTL_LANVLANID;
+			else {
+				/* if the lan port only  exist in only one bridged WAN, we can set pvid as its vid for upstream hw l2 forwarding */
+				int this_port_exist_in_bridged_wan_num = 0;
+				int the_first_vid_exist_in_bridged_wan = -1;
+
+				for (j = 0; packedVlanConfig[j].vid != 0; j++) {
+					if (packedVlanConfig[j].isWan
+						&& (packedVlanConfig[j].
+							memPort !=
+							RTL_WANPORT_MASK)
+						&& (packedVlanConfig[j].
+							memPort & (1 << i))) {
+						this_port_exist_in_bridged_wan_num++;
+						if (the_first_vid_exist_in_bridged_wan == -1)
+							the_first_vid_exist_in_bridged_wan
+								=
+								packedVlanConfig
+								[j].vid;
+					}
+				}
+
+				if (this_port_exist_in_bridged_wan_num == 1)
+					pvid = the_first_vid_exist_in_bridged_wan;
+				else
+					pvid = RTL_LANVLANID;
+			}
+#endif
+		}
+
+		/* extport patch */
+		if (i == RTL_CPU_PORT)
+			pvid = RTL_LANVLANID;
+
+		/* set pvid */
+		CONFIG_CHECK(rtl8651_setAsicPvid(i, pvid));
+		pvid_per_port[i] = pvid;
+
+		/* set port to netif */
+		for (j = 0; packedVlanConfig[j].vid != 0; j++)
+			if (packedVlanConfig[j].vid == pvid)
+				break;
+
+		rtl865x_setPortToNetif(packedVlanConfig[j].ifname, i);
+	}
+
+	return SUCCESS;
+}
+
+int rtl_set_wanport_vlanconfig(char *ifname, int proto, int vid, int napt)
+{
+	int idx = -1;
+	int vlan_id;
+	rtl865x_netif_t netif;
+	int i;
+
+	/* printk("Enter %s (ifname:%s  protio:%d   vid:%d  napt:%d)\n",__FUNCTION__,ifname,proto,vid,napt); */
+
+	/* we has to check whether ifname existed and has not been used yet
+	 * Otherwise, there will exist two same netif_name in "vlanconfig"
+	 */
+	for (i = 0; vlanconfig[i].ifname[0] != '\0'; i++) {
+		if (vlanconfig[i].isWan && (vlanconfig[i].is_slave == 0)
+			&& !strcmp(vlanconfig[i].ifname, ifname)) {
+			if (vlanconfig[i].vid == 0) {	/* this wan has not been used */
+				idx = i;
+				break;
+			}
+		}
+	}
+
+	if (idx == -1) {
+		printk("Leave %s @ %d \n", __FUNCTION__, __LINE__);
+		return FAILED;
+	}
+
+	/* Note.  the fields except for vid,isWan,proto in "vlanconfig" have no change */
+	/* update  vid  in "vlanconfig"  */
+	if (vid != -1) {
+		vlan_id = vid & VLAN_VID_MASK;
+	} else {
+		if (proto == SMUX_PROTO_BRIDGE)
+			vlan_id = RTL_BRIDGE_WANVLANID;
+		else {
+			vlan_id = RTL_WANVLANID;
+			/*jwj: To fix wan2lan hw nat fail when vlan based netif,
+			 * because 2 wan netif point to vid 8. */
+#if defined(CONFIG_RTL_VLAN_BASED_NETIF)
+			rtl865x_setNetifVid(RTL_DRV_WAN0_NETIF_NAME, 1);
+#endif
+		}
+	}
+	vlanconfig[idx].vid = vlan_id;
+	/* printk("(%s)vid:%d\n", __FUNCTION__, vlan_id); */
+	/* update  proto  in "vlanconfig"  */
+	vlanconfig[idx].protocol = proto;
+
+	/* sanity check , this netifname does not exist in sw_netif  */
+	if (rtl865x_netif_exist(ifname)) {
+		/* BUG !  vlanconfig & sw_neif no sync ??  */
+		printk("Leave %s @ %d \n", __FUNCTION__, __LINE__);
+		return FAILED;
+	}
+
+	/* Update VLAN table */
+	if (_rtl_update_vlan_table(vlan_id) != SUCCESS) {
+		printk("Leave %s @ %d \n", __FUNCTION__, __LINE__);
+		return FAILED;
+	}
+
+	/* Update netif table */
+	memset(&netif, 0, sizeof(rtl865x_netif_t));
+	memcpy(netif.name, ifname, MAX_IFNAMESIZE);
+	netif.mtu = 1500;
+	netif.if_type = IF_ETHER;
+	netif.vid = vlan_id;
+	if (proto != SMUX_PROTO_BRIDGE) {
+		netif.is_wan = napt;
+	} else {
+		netif.is_wan = 0;
+#if defined(CONFIG_RTL_MULTI_ETH_WAN_MAC_BASED)
+		netif.if_feature |= IF_FEATURE_IS_BRIDGE;
+#endif
+	}
+
+	netif.is_slave = 0;
+	netif.enableRoute = 1;
+	if (rtl865x_addNetif(&netif) != SUCCESS) {
+		printk("Leave %s @ %d \n", __FUNCTION__, __LINE__);
+		return FAILED;
+	}
+#if defined(CONFIG_RTL8196E_IPCHECKSUM_ERROR_PATCH) && defined(CONFIG_RTL_LAYERED_DRIVER_ACL)
+	/* Trap the brdiged packet with both vlan and pppoe packet  */
+	if ((proto == SMUX_PROTO_BRIDGE) && (vid != -1)) {
+		rtl865x_AclRule_t rule;
+
+		/* printk("(%s) Add ACL to trap the brdiged unicast packet with both vlan and pppoe tag \n", __FUNCTION__); */
+		memset(&rule, 0, sizeof(rtl865x_AclRule_t));
+		rule.ruleType_ = RTL865X_ACL_MAC;
+		rule.actionType_ = RTL865X_ACL_TOCPU;
+		rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+		rule.direction_ = RTL865X_ACL_INGRESS;
+		rule.un_ty.typeLen_ = 0x8864;
+		rule.un_ty.typeLenMask_ = 0xffff;
+		if (rtl865x_add_acl(&rule, netif.name, RTL865X_ACL_ICBUG_PATCH,
+				1, 1) != SUCCESS) {
+			/* printk("Leave %s @ %d \n", __FUNCTION__, __LINE__); */
+			return FAILED;
+		}
+	}
+#endif
+
+#if defined(CONFIG_RTL_MULTI_ETH_WAN_VLAN_BASED)
+	/* For untagged bridge + untagged route WAN and VLAN-Based setting,
+	 * because WAN port pvid = 7, untagged routing WAN down-stream packet will lookup NETIF of vid=7 to check DMAC==GMAC.
+	 * jwj: If vlan_id == RTL_BRIDGE_WANVLANID, then this netif is used for bridge with lan and wan port.
+	 * But now we need set wan port pvid as RTL_BRIDGE_WANVLANID, so if now the untag route wan exist,
+	 * it will also match this netif, so if this netif GMAC is the same with vid8 netif, then
+	 * the untag route packet can be trap to CPU by vid7 netif as the same as vid8 netif.
+	 */
+	/* If this vid =7 , use vid 8's mac addr */
+	if (vlan_id == RTL_BRIDGE_WANVLANID) {
+		char vid_8_netif_name[30];
+		/* printk("(%s) this netif's vid =7 , check whether vid 8 existed , use vid 8's mac addr ... \n",__FUNCTION__); */
+
+		rtl865x_get_master_netif_by_vid(RTL_WANVLANID,
+			vid_8_netif_name);
+
+		if (strcmp(vid_8_netif_name, "")) {
+			rtl865x_netif_local_t *netif_vid_8 =
+				_rtl865x_getNetifByName(vid_8_netif_name);
+			rtl865x_netif_t netif_set_mac;
+			if (netif_vid_8 == NULL) {
+				printk("Leave %s @ %d \n", __FUNCTION__,
+					__LINE__);
+				return FAILED;
+			}
+
+			memcpy(netif_set_mac.macAddr.octet,
+				netif_vid_8->macAddr.octet, ETHER_ADDR_LEN);
+			memcpy(netif_set_mac.name, ifname, MAX_IFNAMESIZE);
+
+			if (rtl865x_setNetifMac(&netif_set_mac) != SUCCESS) {
+				/* printk("Leave %s @ %d \n",__FUNCTION__,__LINE__); */
+				return FAILED;
+			}
+		}
+	}
+#endif
+
+	/* set pvid */
+	_rtl_update_pvid();
+
+	return SUCCESS;
+}
+
+/*
+	In RTL8676 (it cannot change VID by using ACL rules) , after calling rtl_set_wanport_vlanconfig()
+		you should call rtl_set_wanport_portmapping() to set each WAN's binding member ports.
+		If the LAN ports binding to more than one Bridged WAN, the LAN port's pvid = 9 (cannot hwacc)
+
+	In RTL8685 , we could use acl to change vid , so we do not care about port-binding relationship
+*/
+int rtl_set_wanport_portmapping(char *ifname, unsigned int member)
+{
+	/*jwj: Because 8685 can change vid by acl rule. */
+#if !(defined(CONFIG_RTL8685) || defined(CONFIG_RTL8685S))
+	int i;
+	int idx = -1;
+#if defined(RTL_BRIDGE_WAN_SUPPORT_PORT_MAPPING)
+	unsigned int lan_netif_port_mask = 0;
+	unsigned int lan_netif_untag_port_mask = 0;
+#endif
+
+	/* printk("Enter %s (ifname:%s  member:0x%X)\n", __FUNCTION__, ifname,member); */
+
+	for (i = 0; vlanconfig[i].ifname[0] != '\0'; i++) {
+		if (vlanconfig[i].isWan && (vlanconfig[i].is_slave == 0)
+			&& (!strcmp(vlanconfig[i].ifname, ifname))) {
+			if (vlanconfig[i].vid != 0) {	/* we are really using this wan now */
+				idx = i;
+				break;
+			}
+		}
+	}
+
+	if (idx < 0) {
+		/* printk("Leave %s @ %d \n", __FUNCTION__, __LINE__); */
+		return FAILED;
+	}
+	/* printk("(%s) idx = %d  \n", __FUNCTION__, idx); */
+
+	vlanconfig[idx].memPort = RTL_WANPORT_MASK;
+	vlanconfig[idx].untagSet = RTL_WANPORT_MASK;
+
+	if (vlanconfig[idx].protocol == SMUX_PROTO_BRIDGE) {
+		/* set membership */
+		if (member == 0xFFFFFFFF) {
+			vlanconfig[idx].memPort |=
+				(RTL_LANPORT_MASK | RTL_WANPORT_MASK);
+			vlanconfig[idx].untagSet |=
+				(RTL_LANPORT_MASK | RTL_WANPORT_MASK);
+		} else {
+			vlanconfig[idx].memPort |= (member & RTL_LANPORT_MASK);
+			vlanconfig[idx].untagSet |= (member & RTL_LANPORT_MASK);
+			/*  protocol == bridge, and vid != RTL_BRIDGE_WANVLANID, set wan port as tagged port.
+			 *  add cpu port to bridge vlan group too.
+			 */
+			vlanconfig[idx].memPort |= (1 << RTL_CPU_PORT);
+			vlanconfig[idx].untagSet |= (1 << RTL_CPU_PORT);
+			if (((vlanconfig[idx].vid != RTL_BRIDGE_WANVLANID))) {
+				vlanconfig[idx].untagSet &= (~RTL_WANPORT_MASK);
+				vlanconfig[idx].untagSet &=
+					(~(1 << RTL_CPU_PORT));
+				/* panic_printk("(%s:%d) idx = %d        memport=0x%x untag=0x%x ifname=%s member=0x%x\n", __FUNCTION__,__LINE__, idx, vlanconfig[idx].memPort, vlanconfig[idx].untagSet, ifname, member); */
+			}
+#if defined(RTL_BRIDGE_WAN_SUPPORT_PORT_MAPPING)
+			rtl865x_modVlanPortMember(vlanconfig[idx].vid,
+				vlanconfig[idx].memPort,
+				vlanconfig[idx].untagSet);
+			/*jwj: Delete wan bridge bind lan port from br0 port mask.now all lan neitf
+			 * port are untag. */
+			lan_netif_port_mask =
+				rtl865x_getVlanPortMask(RTL_LANVLANID);
+			lan_netif_untag_port_mask =
+				rtl865x_getVlanPortMask(RTL_LANVLANID);
+			rtl865x_modVlanPortMember(RTL_LANVLANID,
+				lan_netif_port_mask & (~member),
+				lan_netif_untag_port_mask & (~member));
+#endif
+		}
+	}
+
+	if (((vlanconfig[idx].vid != RTL_BRIDGE_WANVLANID)
+			&& (vlanconfig[idx].vid != RTL_WANVLANID))
+#ifdef UNIQUE_MAC_PER_DEV
+		&& (vid > 8)
+#endif
+		) {
+		vlanconfig[idx].untagSet &= (~RTL_WANPORT_MASK);
+	}
+
+	/* set pvid */
+	_rtl_update_pvid();
+#endif
+
+	return SUCCESS;
+
+}
+
+int rtl865x_unregisterDev(char *ifname)
+{
+	int idx = -1;
+	int i;
+	int vlan_id = -1;
+
+	/* printk("Enter %s (ifname:%s)\n",__func__,ifname); */
+
+	for (i = 0; vlanconfig[i].ifname[0] != '\0'; i++) {
+		if (vlanconfig[i].isWan && vlanconfig[i].is_slave == 0
+			&& !strcmp(vlanconfig[i].ifname, ifname)) {
+			if (vlanconfig[i].vid != 0) {	/* we are really using this wan now */
+				idx = i;
+				vlan_id = vlanconfig[i].vid;
+				break;
+			}
+		}
+	}
+	if (idx < 0) {
+		printk("Leave %s @ %d \n", __func__, __LINE__);
+		return FAILED;
+	}
+#if defined(CONFIG_RTL_VLAN_BASED_NETIF)
+	/*jwj: When delete untag wan, please set the default wan netif to RTL_WANVLANID. */
+	if (vlan_id == RTL_WANVLANID)
+		rtl865x_setNetifVid(RTL_DRV_WAN0_NETIF_NAME, RTL_WANVLANID);
+#endif
+
+#if defined(RTL_BRIDGE_WAN_SUPPORT_PORT_MAPPING)
+	if ((vlanconfig[idx].protocol == SMUX_PROTO_BRIDGE)
+		&& (vlanconfig[idx].memPort !=
+			(RTL_LANPORT_MASK | RTL_WANPORT_MASK))) {
+		/*jwj: Add wan bridge bind lan port to br0 port mask.now all lan neitf
+		 * port are untag. */
+		unsigned int lan_netif_port_mask =
+			rtl865x_getVlanPortMask(RTL_LANVLANID);
+		unsigned int lan_netif_untag_port_mask =
+			rtl865x_getVlanPortMask(RTL_LANVLANID);
+
+		rtl865x_modVlanPortMember(RTL_LANVLANID,
+			lan_netif_port_mask | (vlanconfig[idx].
+				memPort & (~RTL_WANPORT_MASK)),
+			lan_netif_untag_port_mask | (vlanconfig[idx].
+				memPort & (~RTL_WANPORT_MASK)));
+	}
+#endif
+
+	/* Update vlanconfig (reassign vid back to 0) */
+	vlanconfig[idx].isWan = 1;
+	vlanconfig[idx].if_type = IF_ETHER;
+	vlanconfig[idx].vid = 0;
+	vlanconfig[idx].fid = RTL_WAN_FID;
+	vlanconfig[idx].memPort = RTL_WANPORT_MASK;
+	vlanconfig[idx].untagSet = RTL_WANPORT_MASK;
+	vlanconfig[idx].is_slave = 0;
+
+	/* sanity check , this netifname exists in sw_netif actually */
+	if (!rtl865x_netif_exist(ifname)) {
+		/* BUG !  vlanconfig & sw_neif no sync ??  */
+		printk("Leave %s @ %d \n", __func__, __LINE__);
+		return FAILED;
+	}
+
+	/* Update netif table */
+	if (rtl865x_delNetif(ifname) != SUCCESS) {
+		printk("Leave %s @ %d \n", __func__, __LINE__);
+		return FAILED;
+	}
+
+	/* Update VLAN table */
+	if (_rtl_update_vlan_table(vlan_id) != SUCCESS) {
+		printk("Leave %s @ %d \n", __func__, __LINE__);
+		return FAILED;
+	}
+
+	/* set pvid */
+	_rtl_update_pvid();
+
+	return SUCCESS;
+
+}
+
+int rtl865x_setNetifMacAddr(char *ifname, unsigned char *addr)
+{
+	int vid;
+	rtl865x_netif_t netif;
+
+	/* printk("Enter %s (ifname:%s   addr:%02X:%02X:%02X:%02X:%02X:%02X:) \n", __FUNCTION__, ifname, */
+	/* addr[0],addr[1],addr[2],addr[3],addr[4],addr[5]); */
+
+	memcpy(netif.macAddr.octet, addr, ETHER_ADDR_LEN);
+	memcpy(netif.name, ifname, MAX_IFNAMESIZE);
+	if (rtl865x_setNetifMac(&netif) != SUCCESS) {
+		printk("Leave %s @ %d \n", __FUNCTION__, __LINE__);
+		return FAILED;
+	}
+
+	vid = 0;
+	/*jwj: If update vid8 netif mac, we need update vid7 netif mac, the reason
+	 * please see rtl_set_wanport_vlanconfig. */
+#if defined(CONFIG_RTL_MULTI_ETH_WAN_VLAN_BASED)
+	if (rtl865x_getNetifVid(ifname, &vid) == SUCCESS) {
+		if (vid == RTL_WANVLANID) {
+			char vid_7_netif_name[30];
+			/* printk("(%s) this netif's vid =8 ,  set vid 7 either... \n",__FUNCTION__); */
+
+			rtl865x_get_master_netif_by_vid(RTL_BRIDGE_WANVLANID,
+				vid_7_netif_name);
+
+			if (strcmp(vid_7_netif_name, "")) {
+				memcpy(netif.name, vid_7_netif_name,
+					MAX_IFNAMESIZE);
+				if (rtl865x_setNetifMac(&netif) != SUCCESS) {
+					/* printk("Leave %s @ %d \n",__FUNCTION__,__LINE__); */
+					return FAILED;
+				}
+			}
+		}
+	} else {
+		/* printk("Leave %s @ %d \n",__FUNCTION__,__LINE__); */
+		return FAILED;
+	}
+#endif
+
+	return SUCCESS;
+}
+
+/*
+ *	Function Name:	rtl_register_multi_wan_dev
+ *	Description:	set netif to vlanconfig
+ *
+ *	Input:		ifname		:	network interface name
+ *				proto		:	0: pppoe, 1: ipoe, 2: bridge
+ *				vid			:	vlan id
+ *				napt			:	0: not support napt, 1: support napt
+ *
+ *	Return:		SUCCESS	:	set hwnat successfully
+ * 				FAILED		:	set hwnat failed
+ */
+
+int rtl_register_multi_wan_dev(char *ifname, int proto, int vid, int napt)
+{
+	return rtl_set_wanport_vlanconfig(ifname, proto, vid, napt);
+}
+
+/*
+ *	Function Name:	rtl_update_port_mapping_multi_wan_dev
+ *	Description:	set group member of netif to vlanconfig
+ *
+ *	Input:		ifname		:	network interface name
+ *				member 	:	network interface group member
+ *
+ *	Return:		SUCCESS	:	set 8676hwnat successfully
+ *				FAILED		:	set 8676hwnat failed
+ */
+
+int rtl_update_port_mapping_multi_wan_dev(char *ifname, unsigned int member)
+{
+	return rtl_set_wanport_portmapping(ifname, member);
+}
+
+/*
+ *	Function Name:	rtl_unregister_multi_wan_dev
+ *	Description:	reset vlanconfig & netif/acl in 8676 hwnat switch
+ *
+ *	Input:		ifname		:	network interface name
+ *
+ *	Return:		SUCCESS	:	set 8676hwnat successfully
+ *				FAILED		:	set 8676hwnat failed
+ */
+
+int rtl_unregister_multi_wan_dev(char *ifname)
+{
+	return rtl865x_unregisterDev(ifname);
+}
+
+/*
+ *	Function Name:	rtl8676_setNetifMacAddr
+ *	Description:	update netif mac address in 8676 hwnat switch
+ *
+ *	Input:		ifname		:	network interface name
+ *				addr			:	mac address
+ *
+ *	Return:		SUCCESS	:	set 8676hwnat successfully
+ *				FAILED		:	set 8676hwnat failed
+ */
+
+int rtl_set_multi_wan_netif_mac_addr(char *ifname, char *addr)
+{
+	return rtl865x_setNetifMacAddr(ifname, addr);
+}
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+/*jwj: ?????*/
+int set_port_mapping(struct net_device *dev, struct ifreq *rq, int cmd)
+{
+	struct ifvlan *ifv = rq->ifr_data;
+
+	printk("port mapping %s: dev %s member:0x%x\n",
+		ifv->enable ? "enable" : "disable", dev->name, ifv->member);
+	/*
+	 * jwj port mapping mechanism: all packets are trapped to cpu by default, if it pass through firewall and port mapping rule, then
+	 * acl rule will be written to asic table and portmapping will take effect.
+	 */
+	if ((ifv->enable == 0) && enable_port_mapping) {
+		enable_port_mapping = 0;
+		/* printk("rtl865x_syncRouteToAsic\n"); */
+		rtl865x_syncRouteToAsic();
+	} else if ((ifv->enable == 1) && !enable_port_mapping) {
+		enable_port_mapping = 1;
+		/* clear routing asic table. */
+		/* printk("rtl865x_clearAsicRoutingTable\n"); */
+		rtl865x_clearAsicRoutingTable();
+	}
+#ifdef CONFIG_RTL867X_IPTABLES_FAST_PATH
+	/* reset fastpath */
+	rtl867x_clearFastPathEntry();
+#endif
+
+	/* reset hw-acc */
+#ifdef CONFIG_RTL8676_Static_ACL
+	rtl865x_nat_init();
+#else /* CONFIG_RTL8676_Dynamic_ACL */
+	rtl8676_clean_L34Unicast_hwacc();
+#endif
+
+	return 0;
+}
+#endif
+
+#if defined(CONFIG_RTL_PPPOE_HWACC)
+int32 rtl_add_ppp_netif(char *ifname)
+{
+	struct rtl865x_netif_s netif;
+	int idx = -1;
+	int i;
+	int retval;
+
+	if (strncmp(ifname, "ppp", 3))
+		return FAILED;
+
+	for (i = 0; vlanconfig[i].ifname[0] != '\0'; i++) {
+		if (vlanconfig[i].isWan && vlanconfig[i].is_slave
+			&& (!strcmp(vlanconfig[i].ifname, ifname))) {
+			idx = i;
+			break;
+		}
+	}
+
+	if (-1 == idx) {
+		printk("%s: no vlanconfig entry availble for %s!\n",
+			__FUNCTION__, ifname);
+		return FAILED;
+	}
+
+	/*add network interface */
+	memset(&netif, 0, sizeof(rtl865x_netif_t));
+	memcpy(netif.name, vlanconfig[idx].ifname, MAX_IFNAMESIZE);
+	memcpy(netif.macAddr.octet, vlanconfig[idx].mac.octet, ETHER_ADDR_LEN);
+	netif.mtu = vlanconfig[idx].mtu;
+	netif.if_type = vlanconfig[idx].if_type;
+	netif.vid = vlanconfig[idx].vid;
+	netif.is_wan = vlanconfig[idx].isWan;
+	netif.is_slave = vlanconfig[idx].is_slave;
+	/* #if defined(CONFIG_RTL_HARDWARE_MULTICAST) */
+	netif.enableRoute = 1;
+	/* #endif */
+	retval = rtl865x_addNetif(&netif);
+
+	return retval;
+}
+#endif
+
+#endif
+#if	defined(CONFIG_PPPOE_VLANTAG)
+static struct vlan_info PPPOE_vlanInfo;
+
+struct vlan_info *rtl_get_PPPOE_vlanInfo(void)
+{
+	return &PPPOE_vlanInfo;
+}
+
+static int read_PPPOE_proc_vlan(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+{
+
+	int len;
+
+	len = sprintf(page, "vlan=%d, tag=%d, vid=%d, priority=%d, cfi=%d\n",
+		PPPOE_vlanInfo.vlan, PPPOE_vlanInfo.tag, PPPOE_vlanInfo.id,
+		PPPOE_vlanInfo.pri, PPPOE_vlanInfo.cfi);
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+	return len;
+}
+
+static int write_PPPOE_proc_vlan(struct file *file, const char *buffer,
+	unsigned long count, void *data)
+{
+#define	VLAN_MAX_INPUT_LEN	128
+	char *tmp;
+
+	tmp = kmalloc(VLAN_MAX_INPUT_LEN, GFP_KERNEL);
+	if (count < 2 || tmp == NULL)
+		goto out;
+
+	memset(&PPPOE_vlanInfo, 0, sizeof(struct vlan_info));
+	if (buffer && !copy_from_user(tmp, buffer, VLAN_MAX_INPUT_LEN)) {
+
+		int num = sscanf(tmp, "%d %d %d %d %d",
+
+			&PPPOE_vlanInfo.vlan,
+			&PPPOE_vlanInfo.tag,
+			&PPPOE_vlanInfo.id,
+			&PPPOE_vlanInfo.pri,
+			&PPPOE_vlanInfo.cfi);
+
+		if (num != 5) {
+			printk("invalid vlan parameter!\n");
+			goto out;
+		}
+
+#if 0
+		printk("===%s(%d), global_vlan(%d),is_lan(%d),vlan(%d),tag(%d),id(%d),pri(%d),cfi(%d)", __FUNCTION__, __LINE__, PPPOE_vlanInfo.global_vlan, PPPOE_vlanInfo.is_lan, PPPOE_vlanInfo.vlan, PPPOE_vlanInfo.tag, PPPOE_vlanInfo.id, PPPOE_vlanInfo.pri, PPPOE_vlanInfo.cfi);
+#endif
+	}
+	if (PPPOE_vlanInfo.vlan) {
+		WRITE_MEM32(SWTCR0, (READ_MEM32(SWTCR0) | EnUkVIDtoCPU));
+	}
+out:
+	if (tmp)
+		kfree(tmp);
+
+	return count;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_WTDOG)
+
+#if defined(CONFIG_RTL_8198B)
+#define _WDTCNR_			BSP_WDTCNTRR
+#else
+#define _WDTCNR_			WDTCNR
+#endif
+
+#define _WDTKICK_			WDTCLR
+
+void rtl_watchdog_kick(void)
+{
+	*((volatile unsigned long *)_WDTCNR_) |= _WDTKICK_;
+}
+
+void rtl_periodic_watchdog_kick(unsigned int count, unsigned int times)
+{
+
+	if ((count % times) == 0) {
+		rtl_watchdog_kick();
+	}
+
+}
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+int rtl_getPortlistByDevName(char *name, uint32 *portlist)
+{
+	int i;
+	struct dev_priv *cp;
+
+	if (name == NULL || portlist == NULL)
+		return FAILED;
+
+	for (i = 0; i < ETH_INTF_NUM; i++) {
+		cp = ((struct dev_priv *)NETDRV_PRIV(_rtl86xx_dev.dev[i]));
+		if (_rtl86xx_dev.dev[i] && cp
+			&& (strcmp(name, cp->dev->name) == 0)) {
+			*portlist = cp->portmask;
+			return SUCCESS;
+		}
+	}
+
+	return FAILED;
+}
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if defined(CONFIG_RTL_LINK_AGGREGATION)
+static int _is_hex(char c)
+{
+	return (((c >= '0') && (c <= '9')) ||
+		((c >= 'A') && (c <= 'F')) || ((c >= 'a') && (c <= 'f')));
+}
+
+static int string_to_hex(char *string, unsigned char *key, int len)
+{
+	char tmpBuf[4];
+	int idx, ii = 0;
+	for (idx = 0; idx < len; idx += 2) {
+		tmpBuf[0] = string[idx];
+		tmpBuf[1] = string[idx + 1];
+		tmpBuf[2] = 0;
+		if (!_is_hex(tmpBuf[0]) || !_is_hex(tmpBuf[1]))
+			return 0;
+
+		key[ii++] =
+			(unsigned char)simple_strtol(tmpBuf, (char **)NULL, 16);
+	}
+	return 1;
+}
+
+int32 rtl_lag_check_port_in_trunkmask(uint32 port, uint32 *remain_mask)
+{
+	uint32 trunk_mask = 0;
+	int32 ret = 0;
+
+	if (!remain_mask)
+		return false;
+
+	ret = rtl8651_getLATrunkMask(&trunk_mask);
+	if (ret != SUCCESS) {
+		return false;
+	}
+
+	if ((1 << port) & trunk_mask) {
+		*remain_mask = (trunk_mask & (~(1 << port)));
+		return true;
+	}
+
+	return false;
+}
+
+/* hash function  */
+int32 rtl_lag_hash_function(uint8 *src_mac, uint8 *dst_mac, uint32 *hash,
+	int32 hash_sel)
+{
+	/* uint32 hash_sel = 0; */
+	/* int32 ret = FAILED; */
+	uint32 sid0h = 0, sid1h = 0, sidmah = 0;
+	uint32 did0h = 0, did1h = 0, didmah = 0, didmbh = 0;
+	uint32 tmp_hash[4] = { 0 };
+
+#if 0
+	ret = rtl8651_getLAHashSel(&hash_sel);
+	if (ret != SUCCESS) {
+		return ret;
+	}
+#endif
+
+	/*  SA[47]   SA[45]   SA[43]   SA[41] !-.   SA[5]   SA[3]  ? SA[1] */
+	if (src_mac) {
+		/* panic_printk("%s %d srcmac=0x%x:%x:%x:%x:%x:%x \n", __FUNCTION__, __LINE__, src_mac[0], src_mac[1], src_mac[2], src_mac[3], src_mac[4], src_mac[5]); */
+		sid0h = ((src_mac[5] >> 7) ^ (src_mac[5] >> 5) ^ (src_mac[5] >>
+				3) ^ (src_mac[5] >> 1) ^ (src_mac[4] >> 7) ^
+			(src_mac[4] >> 5) ^ (src_mac[4] >> 3) ^ (src_mac[4] >>
+				1) ^ (src_mac[3] >> 7) ^ (src_mac[3] >> 5) ^
+			(src_mac[3] >> 3) ^ (src_mac[3] >> 1) ^ (src_mac[2] >>
+				7) ^ (src_mac[2] >> 5) ^ (src_mac[2] >> 3) ^
+			(src_mac[2] >> 1) ^ (src_mac[1] >> 7) ^ (src_mac[1] >>
+				5) ^ (src_mac[1] >> 3) ^ (src_mac[1] >> 1) ^
+			(src_mac[0] >> 7) ^ (src_mac[0] >> 5) ^ (src_mac[0] >>
+				3) ^ (src_mac[0] >> 1)
+			) & 0x01;
+		sid1h = ((src_mac[5] >> 6) ^ (src_mac[5] >> 4) ^ (src_mac[5] >>
+				2) ^ (src_mac[5]) ^ (src_mac[4] >> 6) ^
+			(src_mac[4] >> 4) ^ (src_mac[4] >> 2) ^ (src_mac[4]) ^
+			(src_mac[3] >> 6) ^ (src_mac[3] >> 4) ^ (src_mac[3] >>
+				2) ^ (src_mac[3]) ^ (src_mac[2] >> 6) ^
+			(src_mac[2] >> 4) ^ (src_mac[2] >> 2) ^ (src_mac[2]) ^
+			(src_mac[1] >> 6) ^ (src_mac[1] >> 4) ^ (src_mac[1] >>
+				2) ^ (src_mac[1]) ^ (src_mac[0] >> 6) ^
+			(src_mac[0] >> 4) ^ (src_mac[0] >> 2) ^ (src_mac[0])
+			) & 0x01;
+		sidmah = ((src_mac[5] >> 4) ^ (src_mac[5] >> 3) ^ (src_mac[5] >>
+				2) ^ (src_mac[4] >> 4) ^ (src_mac[4] >> 3) ^
+			(src_mac[4] >> 2) ^ (src_mac[3] >> 4) ^ (src_mac[3] >>
+				3) ^ (src_mac[3] >> 2) ^ (src_mac[2] >> 4) ^
+			(src_mac[2] >> 3) ^ (src_mac[2] >> 2) ^ (src_mac[1] >>
+				4) ^ (src_mac[1] >> 3) ^ (src_mac[1] >> 2) ^
+			(src_mac[0] >> 4) ^ (src_mac[0] >> 3) ^ (src_mac[0] >>
+				2)
+			) & 0x01;
+	}
+	if (dst_mac) {
+		/* panic_printk("%s %d dstmac=0x%x:%x:%x:%x:%x:%x \n", __FUNCTION__, __LINE__, dst_mac[0], dst_mac[1], dst_mac[2], dst_mac[3], dst_mac[4], dst_mac[5]); */
+		did0h = ((dst_mac[5] >> 7) ^ (dst_mac[5] >> 5) ^ (dst_mac[5] >>
+				3) ^ (dst_mac[5] >> 1) ^ (dst_mac[4] >> 7) ^
+			(dst_mac[4] >> 5) ^ (dst_mac[4] >> 3) ^ (dst_mac[4] >>
+				1) ^ (dst_mac[3] >> 7) ^ (dst_mac[3] >> 5) ^
+			(dst_mac[3] >> 3) ^ (dst_mac[3] >> 1) ^ (dst_mac[2] >>
+				7) ^ (dst_mac[2] >> 5) ^ (dst_mac[2] >> 3) ^
+			(dst_mac[2] >> 1) ^ (dst_mac[1] >> 7) ^ (dst_mac[1] >>
+				5) ^ (dst_mac[1] >> 3) ^ (dst_mac[1] >> 1) ^
+			(dst_mac[0] >> 7) ^ (dst_mac[0] >> 5) ^ (dst_mac[0] >>
+				3) ^ (dst_mac[0] >> 1)
+			) & 0x01;
+
+		did1h = ((dst_mac[5] >> 6) ^ (dst_mac[5] >> 4) ^ (dst_mac[5] >>
+				2) ^ (dst_mac[5]) ^ (dst_mac[4] >> 6) ^
+			(dst_mac[4] >> 4) ^ (dst_mac[4] >> 2) ^ (dst_mac[4]) ^
+			(dst_mac[3] >> 6) ^ (dst_mac[3] >> 4) ^ (dst_mac[3] >>
+				2) ^ (dst_mac[3]) ^ (dst_mac[2] >> 6) ^
+			(dst_mac[2] >> 4) ^ (dst_mac[2] >> 2) ^ (dst_mac[2]) ^
+			(dst_mac[1] >> 6) ^ (dst_mac[1] >> 4) ^ (dst_mac[1] >>
+				2) ^ (dst_mac[1]) ^ (dst_mac[0] >> 6) ^
+			(dst_mac[0] >> 4) ^ (dst_mac[0] >> 2) ^ (dst_mac[0])
+			) & 0x01;
+		didmah = ((dst_mac[5] >> 4) ^ (dst_mac[5] >> 3) ^ (dst_mac[5] >>
+				2) ^ (dst_mac[4] >> 4) ^ (dst_mac[4] >> 3) ^
+			(dst_mac[4] >> 2) ^ (dst_mac[3] >> 4) ^ (dst_mac[3] >>
+				3) ^ (dst_mac[3] >> 2) ^ (dst_mac[2] >> 4) ^
+			(dst_mac[2] >> 3) ^ (dst_mac[2] >> 2) ^ (dst_mac[1] >>
+				4) ^ (dst_mac[1] >> 3) ^ (dst_mac[1] >> 2) ^
+			(dst_mac[0] >> 4) ^ (dst_mac[0] >> 3) ^ (dst_mac[0] >>
+				2)
+			) & 0x01;
+		didmbh = ((dst_mac[5] >> 7) ^ (dst_mac[5] >> 6) ^ (dst_mac[5] >>
+				5) ^ (dst_mac[4] >> 7) ^ (dst_mac[4] >> 6) ^
+			(dst_mac[4] >> 5) ^ (dst_mac[3] >> 7) ^ (dst_mac[3] >>
+				6) ^ (dst_mac[3] >> 5) ^ (dst_mac[2] >> 7) ^
+			(dst_mac[2] >> 6) ^ (dst_mac[2] >> 5) ^ (dst_mac[1] >>
+				7) ^ (dst_mac[1] >> 6) ^ (dst_mac[1] >> 5) ^
+			(dst_mac[0] >> 7) ^ (dst_mac[0] >> 6) ^ (dst_mac[0] >>
+				5)
+			) & 0x01;
+	}
+	if (hash_sel == LINK_TRUNK_HASH_TYPE_DA_SA) {
+		if (!src_mac || !dst_mac) {
+			return FAILED;
+		}
+		tmp_hash[0] = sid0h ^ did1h;
+		tmp_hash[1] = sidmah ^ didmbh;
+		tmp_hash[2] = sid1h ^ did0h;
+		if (hash) {
+			*hash = (tmp_hash[0] | (tmp_hash[1] << 1) | (tmp_hash[2]
+					<< 2)) & 0x7;
+			/* panic_printk("%s %d hash=%u tmp_hash[0]=0x%x tmp_hash[1]=0x%x tmp_hash[2]=0x%x\n", __FUNCTION__, __LINE__, *hash, tmp_hash[0], tmp_hash[1], tmp_hash[2]); */
+			return SUCCESS;
+		}
+	} else if (hash_sel == LINK_TRUNK_HASH_TYPE_DA) {
+		if (!dst_mac) {
+			return FAILED;
+		}
+		tmp_hash[0] = did0h;
+		tmp_hash[1] = didmah;
+		tmp_hash[2] = did1h;
+		if (hash) {
+			*hash = (tmp_hash[0] | (tmp_hash[1] << 1) | (tmp_hash[2]
+					<< 2)) & 0x7;
+			/* panic_printk("%s %d hash=%u tmp_hash[0]=0x%x tmp_hash[1]=0x%x tmp_hash[2]=0x%x\n", __FUNCTION__, __LINE__, *hash, tmp_hash[0], tmp_hash[1], tmp_hash[2]); */
+			return SUCCESS;
+		}
+	} else if (hash_sel == LINK_TRUNK_HASH_TYPE_SA) {
+		if (!src_mac) {
+			return FAILED;
+		}
+		tmp_hash[0] = sid0h;
+		tmp_hash[1] = sidmah;
+		tmp_hash[2] = sid1h;
+		if (hash) {
+			*hash = (tmp_hash[0] | (tmp_hash[1] << 1) | (tmp_hash[2]
+					<< 2)) & 0x7;
+			/* panic_printk("%s %d hash=%u tmp_hash[0]=0x%x tmp_hash[1]=0x%x tmp_hash[2]=0x%x\n", __FUNCTION__, __LINE__, *hash, tmp_hash[0], tmp_hash[1], tmp_hash[2]); */
+			return SUCCESS;
+		}
+	} else {
+		panic_printk("%s %d hash_sel=%u currently not support!\n",
+			__FUNCTION__, __LINE__, hash_sel);
+	}
+
+	return FAILED;
+}
+
+void rtl_lag_check_trunk_port_state(void)
+{
+	int32 i = 0, j = 0, ret = FAILED;
+	uint32 trunk_mask = 0, up_trunk_msk = 0, down_trunk_msk = 0;
+	uint32 hash_sel = 0;
+#if 0
+	struct dev_priv *cp = NULL;
+	uint32 hash1 = 0, hash2 = 0;
+#endif
+	uint32 tmp_port = 0, cnt = 0;
+	uint32 new_link_port_mask = rtl865x_getPhysicalPortLinkStatus();
+
+	ret = rtl8651_getLATrunkMask(&trunk_mask);
+	if (ret != SUCCESS || !trunk_mask) {
+		return;
+	}
+	/* panic_printk("%s %d new_link_port_mask = 0x%x \n", __FUNCTION__, __LINE__, new_link_port_mask); */
+	up_trunk_msk = trunk_mask;
+	for (i = 0; i <= RTL8651_PHY_NUMBER; i++) {
+		if (((new_link_port_mask & (1 << i)) == 0)
+			&& (trunk_mask & (1 << i))) {
+			/* port down and port is lag trunk port */
+			up_trunk_msk &= ~(1 << i);
+		}
+	}
+
+	down_trunk_msk = trunk_mask & (~up_trunk_msk);
+	/* get first bit in trunk_mask, fix me???? */
+	tmp_port = LAG_MASK_TO_PORT(up_trunk_msk);
+
+	if (!up_trunk_msk) {
+		/* all lag trunk ports are down. */
+		/* panic_printk("%s %d \n", __FUNCTION__, __LINE__); */
+	} else if ((up_trunk_msk == trunk_mask)
+		&& (up_trunk_msk == last_up_trunk_msk)) {
+		/* all lag trunk ports up all the time. */
+		/* panic_printk("%s %d \n", __FUNCTION__, __LINE__); */
+	} else if ((up_trunk_msk == last_up_trunk_msk)
+		&& (down_trunk_msk == last_down_trunk_msk)) {
+		/* panic_printk("%s %d \n", __FUNCTION__, __LINE__); */
+	} else if ((up_trunk_msk == trunk_mask) && (last_down_trunk_msk)) {
+		/* all lag trunk ports up now, some ports down ->up, need set hash index to port mapping again? */
+		ret = rtl8651_getLAHashSel(&hash_sel);
+		if (ret != SUCCESS) {
+			return;
+		}
+		/* set hash index to portmapping first,
+		 * eg: index 0->port3, index 1->port4, index 2->port3, index 3->port4..... */
+		/* panic_printk("%s %d \n", __FUNCTION__, __LINE__); */
+		for (i = 0; i <= LINK_TRUNK_HASH_MAX_INDEX; i = i + cnt) {
+			cnt = 0;
+			for (j = 0; j <= RTL8651_PHY_NUMBER; j++) {
+				if ((up_trunk_msk & (1 << j))) {
+					rtl8651_setLAHashIndexToPortMapping(i +
+						cnt, j);
+					cnt++;
+				}
+			}
+		}
+#if 0
+		if (hash_sel == LINK_TRUNK_HASH_TYPE_SA) {
+			/*can get real hash index when using dual wan's source mac to hash,
+			 * eg: eth1's hash index ->port3, eth6's hash index ->port4 */
+			for (i = 0; i < ETH_INTF_NUM; i++) {
+				cp = ((struct dev_priv *)
+					NETDRV_PRIV(_rtl86xx_dev.dev[i]));
+				if (_rtl86xx_dev.dev[i] && cp && cp->opened
+					&& !(memcmp(cp->dev->name,
+							RTL_DRV_WAN0_NETIF_NAME,
+							strlen
+							(RTL_DRV_WAN0_NETIF_NAME))))
+				{
+					ret = rtl_lag_hash_function(cp->dev->
+						dev_addr, NULL, &hash1,
+						hash_sel);
+					if (ret == SUCCESS) {
+						rtl8651_setLAHashIndexToPortMapping
+							(hash1, tmp_port);
+					}
+				}
+			}
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+			if (rtl_multiWan_net_dev) {
+				ret = rtl_lag_hash_function
+					(rtl_multiWan_net_dev->dev_addr, NULL,
+					&hash2, hash_sel);
+				/* when eth6's hash index == eth1's hash index, follow the default hash index mapping */
+				if (ret == SUCCESS && (hash1 != hash2)) {
+					tmp_port =
+						LAG_MASK_TO_PORT(up_trunk_msk &
+						(~(1 << tmp_port)));
+					rtl8651_setLAHashIndexToPortMapping
+						(hash2, tmp_port);
+				}
+			}
+#endif
+		}
+#endif
+
+	} else if ((up_trunk_msk != trunk_mask) && (down_trunk_msk)) {
+		/* panic_printk("%s %d \n", __FUNCTION__, __LINE__); */
+		for (i = 0; i <= LINK_TRUNK_HASH_MAX_INDEX; i = i + cnt) {
+			cnt = 0;
+			for (j = 0; j <= RTL8651_PHY_NUMBER; j++) {
+				if ((up_trunk_msk & (1 << j))) {
+					/* panic_printk("%s %d i=%d j=%d cnt=%u \n", __FUNCTION__, __LINE__, i, j, cnt); */
+					rtl8651_setLAHashIndexToPortMapping(i +
+						cnt, j);
+					cnt++;
+				}
+			}
+		}
+	}
+	last_up_trunk_msk = up_trunk_msk;
+	last_down_trunk_msk = down_trunk_msk;
+
+	return;
+}
+
+#ifdef CONFIG_RTL_PROC_NEW
+static int32 link_aggregation_read(struct seq_file *s, void *v)
+#else
+static int32 link_aggregation_read(char *page, char **start, off_t off,
+	int count, int *eof, void *data)
+#endif
+{
+	uint32 trunk_mask = 0, hash_sel = 0, port_num = 0;
+	int32 i = 0;
+
+	rtl8651_getLATrunkMask(&trunk_mask);
+	rtl8651_getLAHashSel(&hash_sel);
+
+#ifdef CONFIG_RTL_PROC_NEW
+	seq_printf(s, "Port mask for the aggregator: 0x%x \n", trunk_mask);
+	if (hash_sel == LINK_TRUNK_HASH_TYPE_DA_SA)
+		seq_printf(s, "Trunk Hash algorithm selection: DA+SA\n");
+	else if (hash_sel == LINK_TRUNK_HASH_TYPE_DA)
+		seq_printf(s, "Trunk Hash algorithm selection: DA\n");
+	else if (hash_sel == LINK_TRUNK_HASH_TYPE_SA)
+		seq_printf(s, "Trunk Hash algorithm selection: SA\n");
+	else
+		seq_printf(s, "Trunk Hash algorithm selection: Unkown\n");
+
+	seq_printf(s, "Hash Index to Physical Port Mapping:\n");
+	for (i = 0; i <= LINK_TRUNK_HASH_MAX_INDEX; i++) {
+		port_num = 0xffff;
+		rtl8651_getLAHashIndexToPortMapping(i, &port_num);
+		seq_printf(s, "Hash Index %d Physical port %u\n", i, port_num);
+	}
+
+	return 0;
+#else
+	int len = 0;
+
+	len += sprintf(page + len, "Port mask for the aggregator: 0x%x \n",
+		trunk_mask);
+	if (hash_sel == LINK_TRUNK_HASH_TYPE_DA_SA)
+		len += sprintf(page + len,
+			"Trunk Hash algorithm selection: DA+SA\n");
+	else if (hash_sel == LINK_TRUNK_HASH_TYPE_DA)
+		len += sprintf(page + len,
+			"Trunk Hash algorithm selection: DA\n");
+	else if (hash_sel == LINK_TRUNK_HASH_TYPE_SA)
+		len += sprintf(page + len,
+			"Trunk Hash algorithm selection: SA\n");
+	else
+		len += sprintf(page + len,
+			"Trunk Hash algorithm selection: Unkown\n");
+
+	len += sprintf(page + len, "Hash Index to Physical Port Mapping:\n");
+	for (i = 0; i <= LINK_TRUNK_HASH_MAX_INDEX; i++) {
+		port_num = 0xffff;
+		rtl8651_getLAHashIndexToPortMapping(i, &port_num);
+		len += sprintf(page + len, "Hash Index %d Physical port %u\n",
+			i, port_num);
+	}
+
+	if (len <= off + count)
+		*eof = 1;
+	*start = page + off;
+	len -= off;
+	if (len > count)
+		len = count;
+	if (len < 0)
+		len = 0;
+
+	return len;
+#endif
+}
+
+/*
+* echo "trunkmask $trunk_mask" >/proc/link_aggregation
+* echo "hashselect $hash_sel" >/proc/link_aggregation
+* echo "hashmapping $hash_index $phy_port" >/proc/link_aggregation
+* echo "hashcalculate $hash_type $sa/$da/$sa $da" >/proc/link_aggregation
+*/
+static int32 link_aggregation_write(struct file *filp, const char *buff,
+	unsigned long len, void *data)
+{
+	char tmpbuf[256] = { 0 };
+	char *strptr = NULL, *cmd_addr = NULL;
+	uint32 trunk_mask = 0, hash_sel = 0, hash_type = 0, hash_value = 0;
+	int32 hash_index = 0, phy_port = 0;
+	char *tokptr = NULL;
+	uint8 srcmac_str[16] = { '\0' }, src_mac[6] = {
+	'\0'};
+	uint8 dstmac_str[16] = { '\0' }, dst_mac[6] = {
+	'\0'};
+
+	if (buff && !copy_from_user(tmpbuf, buff, len)) {
+		tmpbuf[len - 1] = '\0';
+		strptr = tmpbuf;
+		cmd_addr = strsep(&strptr, " ");
+		/* panic_printk("%s %d tmpbuf=%s strptr=%s cmd_addr=%s \n", __FUNCTION__, __LINE__, tmpbuf, strptr, cmd_addr); */
+		if (cmd_addr == NULL) {
+			goto errout;
+		}
+		if (!memcmp(cmd_addr, "trunkmask", strlen("trunkmask"))) {
+			sscanf(strptr, "%x", &trunk_mask);
+			/* panic_printk("%s %d trunk_mask=%d trunk_mask=0x%x \n", __FUNCTION__, __LINE__, trunk_mask, trunk_mask); */
+			rtl8651_setLATrunkMask(trunk_mask);
+
+		} else if (!memcmp(cmd_addr, "hashselect",
+				strlen("hashselect"))) {
+			sscanf(strptr, "%x", &hash_sel);
+			/* panic_printk("%s %d hash_sel=%d hash_sel=0x%x \n", __FUNCTION__, __LINE__, hash_sel, hash_sel); */
+			rtl8651_setLAHashSel(hash_sel);
+		} else if (!memcmp(cmd_addr, "hashmapping",
+				strlen("hashmapping"))) {
+			sscanf(strptr, "%d %d", &hash_index, &phy_port);
+			/* panic_printk("%s %d hash_index=%d phy_port=%d \n", __FUNCTION__, __LINE__, hash_index, phy_port); */
+			rtl8651_setLAHashIndexToPortMapping(hash_index,
+				phy_port);
+		} else if (!memcmp(cmd_addr, "hashcalculate",
+				strlen("hashcalculate"))) {
+			tokptr = strsep(&strptr, " ");
+			if (tokptr == NULL) {
+				goto errout;
+			}
+			hash_type = simple_strtol(tokptr, NULL, 0);
+			/* panic_printk("%s %d hash_type=%u \n", __FUNCTION__, __LINE__, hash_type); */
+			if (hash_type == LINK_TRUNK_HASH_TYPE_DA_SA) {
+				sscanf(strptr, "%s %s", srcmac_str, dstmac_str);
+				string_to_hex(srcmac_str, src_mac, 12);
+				string_to_hex(dstmac_str, dst_mac, 12);
+				rtl_lag_hash_function(src_mac, dst_mac,
+					&hash_value, hash_type);
+				panic_printk
+					("%s %d srcmacstr=%s dstmacstr=%s hash type =0x%x hash value = 0x%x \n",
+					__FUNCTION__, __LINE__, srcmac_str,
+					dstmac_str, hash_type, hash_value);
+			} else if ((hash_type == LINK_TRUNK_HASH_TYPE_DA)) {
+				sscanf(strptr, "%s", dstmac_str);
+				string_to_hex(dstmac_str, dst_mac, 12);
+				rtl_lag_hash_function(NULL, dst_mac,
+					&hash_value, hash_type);
+				panic_printk
+					("%s %d srcmacstr=%s dstmacstr=%s hash type =0x%x hash value = 0x%x \n",
+					__FUNCTION__, __LINE__, srcmac_str,
+					dstmac_str, hash_type, hash_value);
+			} else if ((hash_type == LINK_TRUNK_HASH_TYPE_SA)) {
+				sscanf(strptr, "%s", srcmac_str);
+				/* sscanf(strptr, "0x%x:%x:%x:%x:%x:%x", srcmac_str); */
+				string_to_hex(srcmac_str, src_mac, 12);
+				rtl_lag_hash_function(src_mac, NULL,
+					&hash_value, hash_type);
+				panic_printk
+					("%s %d srcmacstr=%s dstmacstr=%s hash type =0x%x hash value = 0x%x \n",
+					__FUNCTION__, __LINE__, srcmac_str,
+					dstmac_str, hash_type, hash_value);
+			} else {
+				goto errout;
+			}
+
+		} else {
+			goto errout;
+		}
+	} else {
+errout:
+		printk("echo \"trunkmask $trunk_mask\" >/proc/link_aggregation\n");
+		printk("echo \"hashselect $hash_sel\" >/proc/link_aggregation\n");
+		printk("echo \"hashmapping $hash_index $phy_port\" >/proc/link_aggregation\n");
+		printk("echo \"hashcalculate $hash_type $sa/$da/$sa $da\" >/proc/link_aggregation\n");
+		printk("$trunk_mask and $hash_sel are specified in hexadecimal format pattern\n");
+		printk("$hash_index and $phy_port are specified in decimal format pattern\n");
+	}
+
+	return len;
+}
+
+#endif
+
+#if defined(CONFIG_RTL_8367_QOS_SUPPORT) || defined(CONFIG_RTL_8367_QOS_TEST)
+#if defined(CONFIG_RTL_8367_QOS_TEST)
+extern int rtl8367_qos_test(void);
+#endif
+#if defined(CONFIG_RTL_PROC_NEW)
+extern int rtl_8367QosReadProc(struct seq_file *s, void *v);
+#else
+struct proc_dir_entry *rtl_8367QosProc = NULL;
+extern int rtl_8367QosReadProc(char *page, char **start, off_t off,
+	int count, int *eof, void *data);
+#endif
+extern int rtl_8367QosWriteProc(struct file *file, const char *buffer,
+	unsigned long count, void *data);
+
+#if definedCONFIG_RTL_PROC_NEW
+int rtl_8367Qos_single_open(struct inode *inode, struct file *file)
+{
+	return (single_open(file, rtl_8367QosReadProc, NULL));
+}
+
+static ssize_t rtl_8367Qos_single_write(struct file *file,
+	const char __user *userbuf, size_t count, loff_t *off)
+{
+	return rtl_8367QosWriteProc(file, userbuf, count, off);
+}
+
+struct file_operations rtl_8367Qos_proc_fops = {
+	.open = rtl_8367Qos_single_open,
+	.write = rtl_8367Qos_single_write,
+	.read = seq_read,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+#endif
+
+int32 rtl_init8367QosProc(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	proc_create_data("rtl_8367Qos", 0, &proc_root, &rtl_8367Qos_proc_fops,
+		NULL);
+#else
+	rtl_8367QosProc = create_proc_entry("rtl_8367Qos", 0, NULL);
+	if (rtl_8367QosProc) {
+		rtl_8367QosProc->read_proc = rtl_8367QosReadProc;
+		rtl_8367QosProc->write_proc = rtl_8367QosWriteProc;
+	}
+#endif
+
+#if definedCONFIG_RTL_8367_QOS_TEST
+	rtl8367_qos_test();
+#endif
+
+	return 0;
+}
+
+void __exit rtl_exit8367QosCtrl(void)
+{
+#ifdef CONFIG_RTL_PROC_NEW
+	remove_proc_entry("rtl_8367Qos", &proc_root);
+#else
+	if (rtl_8367QosProc) {
+		remove_proc_entry("rtl_8367Qos", rtl_8367QosProc);
+		rtl_8367QosProc = NULL;
+	}
+#endif
+}
+#endif
+
+#if defined(RTL_DROP_OUT_OF_BR_SUBNET_FRAME)
+static unsigned int _br0_ip_bak = 0;
+static unsigned int _br0_mask_bak = 0;
+extern int get_dev_ip_mask(const char *name, unsigned int *ip,
+	unsigned int *mask);
+int rtl_add_Acl_for_out_of_br_subnet(void)
+{
+	int i;
+	static struct rtl865x_vlanConfig tmpVlanConfig[NETIF_NUMBER * 2];
+	struct rtl865x_vlanConfig *pVlanConfig = NULL;
+	rtl865x_AclRule_t rule;
+	int ret = FAILED;
+	unsigned int _br0_ip_tmp = 0;
+	unsigned int _br0_mask_tmp = 0;
+
+	get_dev_ip_mask(RTL_PS_BR0_DEV_NAME, &_br0_ip_tmp, &_br0_mask_tmp);
+	_br0_ip_tmp = htonl(_br0_ip_tmp);
+	_br0_mask_tmp = htonl(_br0_mask_tmp);
+
+	re865x_packVlanConfig(vlanconfig, tmpVlanConfig);
+	pVlanConfig = tmpVlanConfig;
+
+	for (i = 0; pVlanConfig[i].vid != 0; i++) {
+		if (IF_ETHER != pVlanConfig[i].if_type) {
+			continue;
+		}
+
+		if ((pVlanConfig[i].isWan == 0) && (_br0_ip_tmp != 0) && (_br0_mask_tmp != 0)) {	/*lan config */
+			rtl865x_regist_aclChain(pVlanConfig[i].ifname,
+				RTL865X_ACL_IPV6_USED, RTL865X_ACL_INGRESS);
+
+			if ((_br0_ip_bak != 0) && (_br0_mask_bak != 0)) {
+				bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+				rule.ruleType_ = RTL865X_ACL_IP_RANGE;
+				rule.actionType_ = RTL865X_ACL_DROP;
+				rule.pktOpApp_ = RTL865X_ACL_L3_AND_L4;
+
+				rule.srcIpAddrStart_ = 0x1;
+				rule.srcIpAddrEnd_ =
+					(_br0_ip_bak & _br0_mask_bak) - 1;
+				rule.dstIpAddrStart_ = 0x0;
+				rule.dstIpAddrEnd_ = 0xffffffff;
+
+				ret = rtl865x_del_acl(&rule,
+					pVlanConfig[i].ifname,
+					RTL865X_ACL_IPV6_USED);
+
+				bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+				rule.ruleType_ = RTL865X_ACL_IP_RANGE;
+				rule.actionType_ = RTL865X_ACL_DROP;
+				rule.pktOpApp_ = RTL865X_ACL_L3_AND_L4;
+
+				rule.srcIpAddrStart_ =
+					(_br0_ip_bak & _br0_mask_bak) +
+					(~_br0_mask_bak) + 1;
+				rule.srcIpAddrEnd_ = 0xffffffff;
+				rule.dstIpAddrStart_ = 0x0;
+				rule.dstIpAddrEnd_ = 0xffffffff;
+
+				ret = rtl865x_del_acl(&rule,
+					pVlanConfig[i].ifname,
+					RTL865X_ACL_IPV6_USED);
+			}
+
+			if (rtl865x_curOpMode == GATEWAY_MODE) {
+				/* permit  from cpu port */
+				bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+				rule.ruleType_ = RTL865X_ACL_SRCFILTER;
+				rule.actionType_ = RTL865X_ACL_PERMIT;
+				rule.pktOpApp_ = RTL865X_ACL_ALL_LAYER;
+				rule.srcFilterIgnoreL4_ = 1;
+
+				rule.srcFilterPort_ = 1 << 8;	/* cpu port */
+				rule.srcFilterPortMask_ = 1 << 8;
+
+				ret = rtl865x_add_acl(&rule,
+					pVlanConfig[i].ifname,
+					RTL865X_ACL_IPV6_USED);
+
+				bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+				rule.ruleType_ = RTL865X_ACL_IP_RANGE;
+				rule.actionType_ = RTL865X_ACL_DROP;
+				rule.pktOpApp_ = RTL865X_ACL_L3_AND_L4;
+
+				rule.srcIpAddrStart_ = 0x1;
+				rule.srcIpAddrEnd_ =
+					(_br0_ip_tmp & _br0_mask_tmp) - 1;
+
+				rule.dstIpAddrStart_ = 0x0;
+				rule.dstIpAddrEnd_ = 0xffffffff;
+
+				ret = rtl865x_add_acl(&rule,
+					pVlanConfig[i].ifname,
+					RTL865X_ACL_IPV6_USED);
+
+				bzero((void *)&rule, sizeof(rtl865x_AclRule_t));
+				rule.ruleType_ = RTL865X_ACL_IP_RANGE;
+				rule.actionType_ = RTL865X_ACL_DROP;
+				rule.pktOpApp_ = RTL865X_ACL_L3_AND_L4;
+
+				rule.srcIpAddrStart_ =
+					(_br0_ip_tmp & _br0_mask_tmp) +
+					(~_br0_mask_tmp) + 1;
+				rule.srcIpAddrEnd_ = 0xffffffff;
+				rule.dstIpAddrStart_ = 0x0;
+				rule.dstIpAddrEnd_ = 0xffffffff;
+
+				ret = rtl865x_add_acl(&rule,
+					pVlanConfig[i].ifname,
+					RTL865X_ACL_IPV6_USED);
+
+				_br0_ip_bak = _br0_ip_tmp;
+				_br0_mask_bak = _br0_mask_tmp;
+			} else {
+				_br0_ip_bak = 0;
+				_br0_mask_bak = 0;
+			}
+		}
+#if defined(CONFIG_RTL_IPTABLES_RULE_2_ACL)
+		if (rtl865x_curOpMode == WISP_MODE)
+#endif
+			rtl865x_reConfigDefaultAcl(pVlanConfig[i].ifname);
+	}
+
+	return SUCCESS;
+}
+#endif
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+#define	IS_MULTICAST(a)		((((long int) (a)) & 0xf0000000) == 0xe0000000)
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+#define	IS_V6_MULTICAST(a)	((((long int) (a)) & 0xff000000) == 0xff000000)
+#define PPP_IPV6_PROTOCOL 0x0057
+#endif
+
+#define PPP_IPV4_PROTOCOL 0x0021
+
+struct iphdr *rtl_get_pppoe_ipv4_hdr(unsigned char *data, int check_from_mac,
+	unsigned short protocol)
+{
+	uint8 *ptr;
+	struct iphdr *iph = NULL;
+	int is_pppoe_ipv4 = 0;
+
+	if (check_from_mac == 1) {
+		ptr = data + 12;
+
+		if (*(int16 *) (ptr) == (int16) htons(ETH_P_8021Q)) {
+			ptr = ptr + 4;
+		}
+
+		if (*(int16 *) (ptr) == (int16) htons(ETH_P_PPP_SES)) {
+			ptr = ptr + 2 + 6;
+			if (*(int16 *) (ptr) ==
+				(int16) htons(PPP_IPV4_PROTOCOL)) {
+				ptr = ptr + 2;
+				is_pppoe_ipv4 = 1;
+			}
+		}
+		if (is_pppoe_ipv4)
+			iph = (struct iphdr *)ptr;
+	} else if (protocol == htons(ETH_P_PPP_SES)) {
+		ptr = data + 6;
+		if (*(int16 *) (ptr) == (int16) htons(PPP_IPV4_PROTOCOL)) {
+			ptr = ptr + 2;
+			is_pppoe_ipv4 = 1;
+		}
+		if (is_pppoe_ipv4)
+			iph = (struct iphdr *)ptr;
+	}
+	return iph;
+}
+
+inline struct ipv6hdr * rtl_get_pppoe_ipv6_hdr(unsigned char *data, int check_from_mac, unsigned short protocol)
+{
+	uint8 *ptr;
+	struct ipv6hdr *ip6h = NULL;
+	int is_pppoe_ipv6 = 0;
+
+	if (check_from_mac == 1) {
+		ptr = data+12;
+
+		if (*(uint16 *)(ptr) == (uint16)htons(ETH_P_8021Q))
+		{
+			ptr=ptr+4;
+		}
+
+		if (*(uint16 *)(ptr) == (uint16)htons(ETH_P_PPP_SES))
+		{
+			ptr = ptr+2+6;
+			if(*(uint16 *)(ptr) == (uint16)htons(PPP_IPV6_PROTOCOL))
+			{
+				ptr = ptr+2;
+				is_pppoe_ipv6=1;
+			}
+		}
+		if(is_pppoe_ipv6)
+			ip6h = (struct ipv6hdr *)ptr;
+	}
+	else if (protocol == htons(ETH_P_PPP_SES))
+	{
+		ptr = data+6;
+		if(*(uint16 *)(ptr) == (uint16)htons(PPP_IPV6_PROTOCOL))
+		{
+			ptr = ptr+2;
+			is_pppoe_ipv6=1;
+		}
+		if(is_pppoe_ipv6)
+			ip6h = (struct ipv6hdr *)ptr;
+	}
+	return ip6h;
+}
+
+inline int rtl_is_pppoe_igmp_bridge_frame(struct sk_buff *skb,int check_from_mac,unsigned char *dest)
+{
+	int ret = 0;
+	struct iphdr *iph = NULL;
+
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	struct ipv6hdr *ipv6h=NULL;
+	int l4_proto = 0;
+#endif
+	/*jwj: need to check bridge port??*/
+	//if (rtl865x_curOpMode != BRIDGE_MODE)
+		//return 0;
+	if (!((*((uint16*)(dest+(ETH_ALEN<<1))) == __constant_htons(ETH_P_PPP_SES))
+		|| (*((uint16*)(dest+(ETH_ALEN<<1)+4)) == __constant_htons(ETH_P_PPP_SES))))
+		return 0;
+
+	//if(check_from_mac && (dest[0]&0x01))
+	//	return 0;
+
+	//if(!check_from_mac && (dest[0]&0x01))
+		//return 0;
+	if(dest[0]&0x01)
+		return 0;
+
+	iph = rtl_get_pppoe_ipv4_hdr(skb->data, check_from_mac, skb->protocol);
+	if (iph && IS_MULTICAST(ntohl(iph->daddr))) {
+		if (iph->protocol == IPPROTO_IGMP)
+			ret = PPPOE_IGMP;
+		else if (iph->protocol == IPPROTO_UDP)
+			ret = PPPOE_UDP;
+		else if (iph->protocol == IPPROTO_TCP)
+			ret = PPPOE_TCP;
+		else
+			ret = 0;
+	}
+
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+	ipv6h = rtl_get_pppoe_ipv6_hdr(skb->data, check_from_mac, skb->protocol);
+	if(ipv6h && IS_V6_MULTICAST(ntohl(ipv6h->daddr.s6_addr32[0])))
+	{
+		l4_proto = re865x_getIpv6TransportProtocol(ipv6h);
+		if(l4_proto==UDP_PROTOCOL)
+			ret = PPPOE_UDPV6;
+		else if(l4_proto==TCP_PROTOCOL)
+			ret = PPPOE_TCPV6;
+		#if 0
+		/*for gateway, mld query from wan will be handle by kernel and mld report without pppoe header
+		  for brdige, mld packets will be forwarded by hw
+		  if mld packets is handled here, unkno
+		  wn packets will be duplicated*/
+		else if(l4_proto==ICMP_PROTOCOL)
+			ret = PPPOE_ICMPV6;
+		#endif
+		else
+			ret = 0;
+	}
+#endif
+
+	return ret;
+}
+#endif
+
+#if defined(CONFIG_RTL_8197F) &&  defined(CONFIG_FINETUNE_RUNOUT_IRQ)
+inline void rtl865x_disableRunoutIrq(void)
+{
+
+	REG32(CPUIIMR) =
+		REG32(CPUIIMR) & (~(PKTHDR_DESC_RUNOUT_IP_ALL |
+			MBUF_DESC_RUNOUT_IP_ALL));
+	return;
+}
+
+inline void rtl865x_enableRunoutIrq(void)
+{
+
+	REG32(CPUIISR) =
+		REG32(CPUIISR) | PKTHDR_DESC_RUNOUT_IP_ALL |
+		MBUF_DESC_RUNOUT_IP_ALL;
+	REG32(CPUIIMR) =
+		REG32(CPUIIMR) | PKTHDR_DESC_RUNOUT_IP_ALL |
+		MBUF_DESC_RUNOUT_IP_ALL;
+
+	return;
+}
+
+inline int rtl865x_rxbufAvailable(void)
+{
+	/* if((eth_skb_free_num>FREE_PRIV_BUF_TRHRESHOLD) || (rx_skb_queue.qlen>FREE_PRIV_SKB_TRHRESHOLD)) */
+
+	if (rx_skb_queue.qlen > freeSkbThreshold) {
+		return 1;
+	}
+
+	return 0;
+}
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/hw_nat/version.h b/drivers/soc/realtek/rtd129x/hw_nat/version.h
new file mode 100644
index 00000000..01cd385
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/hw_nat/version.h
@@ -0,0 +1,12 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#define PKG_VERSION "0.71"
+#define ROMEDRIVER_VERSION "4.1"
+#define WLANDRVPKG_VERSION "1.14"
diff --git a/drivers/soc/realtek/rtd129x/rtd129x_cpu_hotplug.S b/drivers/soc/realtek/rtd129x/rtd129x_cpu_hotplug.S
new file mode 100644
index 00000000..084d5bd
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtd129x_cpu_hotplug.S
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/linkage.h>
+#include <asm/assembler.h>
+#include <asm/sysreg.h>
+#include <asm/virt.h>
+
+#define SCTLR_ELx_I (1 << 12)
+#define SCTLR_ELx_SA (1 << 3)
+#define SCTLR_ELx_C (1 << 2)
+#define SCTLR_ELx_A (1 << 1)
+
+#define SCTLR_ELx_FLAGS (SCTLR_ELx_M | SCTLR_ELx_A | SCTLR_ELx_C | SCTLR_ELx_SA | SCTLR_ELx_I)
+
+.text
+.pushsection 	.idmap.text, "ax"
+
+ENTRY(__cpu_do_lowpower)
+	mrs x12, sctlr_el1 /* Clear sctlr_el1 flags. */
+	ldr x13, =SCTLR_ELx_FLAGS
+	bic x12, x12, x13
+	msr sctlr_el1, x12
+	isb
+	mrs	x12, S3_1_C15_C2_1
+	bic	x12, x12, #0x1 << 6 /* Disable CPUECTLR.SMP bit */
+	msr	S3_1_C15_C2_1, x12
+	isb
+	dsb	sy
+	wfi
+loop:
+	wfi
+	bl loop
+ENDPROC(__cpu_do_lowpower)
+
+.popsection
diff --git a/drivers/soc/realtek/rtd129x/rtd129x_cpu_hotplug.h b/drivers/soc/realtek/rtd129x/rtd129x_cpu_hotplug.h
new file mode 100644
index 00000000..cf2c8ff
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtd129x_cpu_hotplug.h
@@ -0,0 +1,28 @@
+/*
+ * rtd129x_cpu_hotplug.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef RTD129x_CPU_HOTPLUG_H_
+#define RTD129x_CPU_HOTPLUG_H_
+
+#include <asm/virt.h>
+
+void __cpu_do_lowpower(unsigned long secondary_entry_addr);
+
+static inline void cpu_do_lowpower(unsigned long secondary_entry_addr)
+{
+	typeof(__cpu_do_lowpower) *cpu_lowpower_fn;
+	cpu_lowpower_fn = (void *)virt_to_phys(__cpu_do_lowpower);
+	cpu_lowpower_fn(secondary_entry_addr);
+	unreachable();
+}
+
+#endif /* RTD129x_CPU_HOTPLUG_H_ */
diff --git a/drivers/soc/realtek/rtd129x/rtd129x_cpu_wrapper.c b/drivers/soc/realtek/rtd129x/rtd129x_cpu_wrapper.c
new file mode 100644
index 00000000..d2b698d
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtd129x_cpu_wrapper.c
@@ -0,0 +1,335 @@
+/*
+ * rtd129x_cpu_wrapper.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/delay.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <asm/cacheflush.h>
+#include <asm/cpu_ops.h>
+#include <asm/cputype.h>
+#include <asm/smp_plat.h>
+#include <asm/system_misc.h>
+
+#define DEV_NAME "RTK_SCPU_WRAPPER"
+#define DBG_INT 0x230
+#define DBG_ADDR 0x234
+#define DBG_ADDR_MODE 0x238
+
+#define CR_M (1 << 0) /* MMU enable */
+#define CR_C (1 << 2) /* D-cache enable */
+
+static void __iomem *scpu_wrap_addr;
+
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w);
+
+static inline unsigned int current_el(void)
+{
+	unsigned int el;
+
+	asm volatile("mrs %0, CurrentEL" : "=r" (el) : : "cc");
+	return el >> 2;
+}
+
+static inline void set_sctlr(unsigned int val)
+{
+	unsigned int el = current_el();
+
+	if (el == 1)
+		asm volatile("msr sctlr_el1, %0" : : "r" (val) : "cc");
+	else if (el == 2)
+		asm volatile("msr sctlr_el2, %0" : : "r" (val) : "cc");
+	else
+		asm volatile("msr sctlr_el3, %0" : : "r" (val) : "cc");
+
+	asm volatile("isb");
+}
+
+static inline unsigned int get_sctlr(void)
+{
+	unsigned int el = current_el();
+	unsigned int val;
+
+	if (el == 1)
+		asm volatile("mrs %0, sctlr_el1" : "=r" (val) : : "cc");
+	else if (el == 2)
+		asm volatile("mrs %0, sctlr_el2" : "=r" (val) : : "cc");
+	else
+		asm volatile("mrs %0, sctlr_el3" : "=r" (val) : : "cc");
+	return val;
+}
+
+void dcache_disable(void)
+{
+	u32 sctlr = get_sctlr();
+
+	/* if cache isn't enabled no need to disable */
+	if (!(sctlr & CR_C) && !(sctlr & CR_M))
+		return;
+
+	set_sctlr(sctlr & ~(CR_C|CR_M));
+	flush_cache_all();
+}
+
+void _rtk_cpu_power_up(int cpu)
+{
+	u32 tmp = 0;
+
+	/* 5. Wait for SMPEN to be set. */
+	tmp = readl(scpu_wrap_addr + 0x104);
+	if (unlikely(((tmp >> (16 + cpu)) & 1) != 1)) {
+		WARN_ON(1);
+		pr_err("Waiting for CPU%d SMPEN to be set\n", cpu);
+	}
+
+	/*
+	 * 6. Assert DBGPWRDUP HIGH to
+	 * allow external debug access to the core.
+	 */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp |= 1UL << (24 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x100);
+}
+EXPORT_SYMBOL(_rtk_cpu_power_up);
+
+void rtk_cpu_power_up(int cpu)
+{
+	u32 tmp = 0;
+
+	/*
+	 * 1. Assert nCPUPORESET LOW.
+	 * Ensure DBGPWRDUP is held LOW to prevent any
+	 * external debug access to the core.
+	 */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp &= ~(1UL << (24 + cpu));
+	tmp &= ~(1UL << (4 + cpu));
+	tmp &= ~(1UL << (0 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x100);
+
+	/*
+	 * 2. Apply power to the PDCPU power domain.
+	 * Keep the state of the signals nCPUPORESET and DBGPWRDUP LOW.
+	 */
+	tmp = readl(scpu_wrap_addr + 0x530);
+	tmp |= 1UL << (8 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x530);
+	//mdelay(3);
+	tmp = readl(scpu_wrap_addr + 0x530);
+	tmp |= 1UL << (12 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x530);
+
+	tmp = readl(scpu_wrap_addr + 0x534);
+	if ((unlikely((tmp >> cpu) & 0x1) == 0x1)) {
+		WARN_ON(1);
+		pr_err("[%s] L1 cache is in power-saving mode.\n", DEV_NAME);
+		pr_err("[%s] 0x9801D534 = %x\n",
+			DEV_NAME,
+			readl(scpu_wrap_addr + 0x534));
+	}
+
+	/* 3. Release the core output clamps */
+	tmp = readl(scpu_wrap_addr + 0x530);
+	tmp &= ~(1UL << (0 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x530);
+
+	/* 4. Dessert resets: nCOREPORESET, nCORERESET */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp |= 1UL << (0 + cpu);
+	tmp |= 1UL << (4 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x100);
+}
+EXPORT_SYMBOL(rtk_cpu_power_up);
+
+void rtk_cpu_power_down(int cpu)
+{
+	u32 tmp = 0;
+
+	/*
+	 * Step 1 to 6 is done in rtd129x_cpu_hotplug.S
+	 * Wait for WFI in step 6.
+	 */
+	mdelay(5);
+	tmp = readl(scpu_wrap_addr + 0x104);
+	if (unlikely(((tmp >> cpu) & 0x1) != 0x1)) {
+		pr_err("[%s] Processor is not in WFI standby mode.\n",
+			DEV_NAME);
+		pr_err("[%s] 0x9801D104 = %x\n",
+			DEV_NAME,
+			readl(scpu_wrap_addr + 0x104));
+	}
+
+	/*
+	 * 7. Dessert DBGPWRDUP LOW.
+	 * This prevents any external debug access to the core.
+	 */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp &= ~(1UL << (24 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x100);
+
+	/* 8. Activate the core output clamps.*/
+	tmp = readl(scpu_wrap_addr + 0x530);
+	tmp |= 1UL << (0 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x530);
+
+#if 0
+	/* Assert nCPUPORESET LOW */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp &= ~(1UL << (0 + cpu));
+	tmp &= ~(1UL << (4 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x100);
+#endif
+
+	/* 9. Remove power from the PDCPU power domain. */
+	tmp = readl(scpu_wrap_addr + 0x530);
+	tmp &= ~(1UL << (8 + cpu));
+	tmp &= ~(1UL << (12 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x530);
+}
+EXPORT_SYMBOL(rtk_cpu_power_down);
+
+irqreturn_t scpu_wrapper_isr(int irq, void *reg_base)
+{
+	struct pt_regs *regs;
+	u32 intr = readl(scpu_wrap_addr + DBG_INT);
+	u32 addr = readl(scpu_wrap_addr + DBG_ADDR);
+	u32 cause = readl(scpu_wrap_addr + DBG_ADDR_MODE);
+	char buf[128];
+
+	regs = get_irq_regs();
+
+	pr_err("[%s] scpu wrapper get int 0x%08x", DEV_NAME, intr);
+	if (intr & (BIT(4) | BIT(2))) {
+		writel((intr & ~(BIT(3)|BIT(1))), scpu_wrap_addr + DBG_INT);
+		pr_err("[%s] scpu addr:0x%08x mode:%s",
+			DEV_NAME, addr, (cause & 1) ? "W" : "R");
+
+		sprintf(buf, "[%s] Memory 0x%08x trashed with %s\n",
+			DEV_NAME, addr, (cause & 1) ? "W" : "R");
+		die(buf, regs, 0);
+
+		return IRQ_HANDLED;
+	}
+
+	return IRQ_NONE;
+}
+
+static const struct of_device_id rtk_scpu_wrapper_ids[] __initconst = {
+	{.compatible = "Realtek,rtk-scpu_wrapper"},
+	{},
+};
+
+static int __init scpu_wrapper_init(void)
+{
+	struct device_node *np;
+	int irq = 0;
+	int i = 0;
+	int results = 0;
+
+	np = of_find_matching_node(NULL, rtk_scpu_wrapper_ids);
+	if (unlikely(np == NULL))
+		return -1;
+
+	irq = irq_of_parse_and_map(np, 0);
+
+	scpu_wrap_addr = of_iomap(np, 0);
+	pr_info("[%s] scpu wrappee irq %d, scpu_wrap_addr 0x%08llx\n",
+		DEV_NAME, irq, (u64)scpu_wrap_addr);
+
+	of_node_put(np);
+
+	results = request_irq(irq,
+		scpu_wrapper_isr,
+		IRQF_SHARED,
+		"scpu_wrapper",
+		scpu_wrap_addr);
+
+	if (results != 0) {
+		pr_err("[%s] cannot get IRQ\n", DEV_NAME);
+		return -1;
+	}
+
+	/* clear dbg trap addr */
+	for (i = 0 ; i < 8 ; i++)
+		writel(0, scpu_wrap_addr + 0x200 + i * 4);
+	writel(0x98000000, scpu_wrap_addr + 0x200); // 1st set start
+	writel(0x98000040, scpu_wrap_addr + 0x210); // 1st set end
+
+	writel(0x98000040, scpu_wrap_addr + 0x204); // 2nd set start
+	writel(0x98000080, scpu_wrap_addr + 0x214); // 2nd set end
+
+	writel(0x98000080, scpu_wrap_addr + 0x208); // 3th set start
+	writel(0x980000c0, scpu_wrap_addr + 0x218); // 3th set end
+
+	writel(0x980000c0, scpu_wrap_addr + 0x20c); // 4th set start
+	writel(0x98000100, scpu_wrap_addr + 0x21c); // 4th set end
+
+	writel(0x9, scpu_wrap_addr + DBG_INT);	// enable interrupt
+
+	pr_info("[%s] initialized\n", DEV_NAME);
+
+	pr_info("[%s] memory monitor 0x98013b00 - 0x98013c00\n", DEV_NAME);
+
+	scpu_dbg_scpu_monitor(0, 0x98013b00, 0x98013c00, 0x0);
+
+	return 0;
+}
+late_initcall(scpu_wrapper_init);
+
+void scpu_dbg_disable_mem_monitor(int which)
+{
+	void __iomem  *reg_ctrl;
+
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220);
+	reg_ctrl += which;
+	writel((1 << 13) | (1 << 9) | (1 << 1), reg_ctrl);
+}
+EXPORT_SYMBOL(scpu_dbg_disable_mem_monitor);
+
+static void scpu_dbg_set_mem_monitor(int which, u32 start, u32 end, u32 flags)
+{
+	void __iomem  *reg_start;
+	void __iomem  *reg_end;
+	void __iomem  *reg_ctrl;
+
+	/* disable this set first */
+	scpu_dbg_disable_mem_monitor(which);
+
+	reg_start = (void __iomem  *)(scpu_wrap_addr + 0x200 + which);
+	reg_end = (void __iomem  *)(scpu_wrap_addr + 0x210 + which);
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220 + which);
+
+	writel(start, reg_start);
+	writel(end, reg_end);
+	writel(flags, reg_ctrl);
+}
+
+/*
+ * which: 0~7, which register set
+ * d_i: SB2_DBG_MONITOR_DATA|SB2_DBG_MONITOR_INST
+ * r_w: SB2_DBG_MONITOR_READ|SB2_DBG_MONITOR_WRITE
+ */
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w)
+{
+	scpu_dbg_set_mem_monitor(which * 4, start, end, (3 << 8) | r_w | 3);
+}
+EXPORT_SYMBOL(scpu_dbg_scpu_monitor);
diff --git a/drivers/soc/realtek/rtd129x/rtd129x_fan.c b/drivers/soc/realtek/rtd129x/rtd129x_fan.c
new file mode 100644
index 00000000..ab067f7
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtd129x_fan.c
@@ -0,0 +1,434 @@
+/*
+ * rtd129x_fan.c - fan driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/device.h>
+#include <linux/platform_device.h>
+#include <linux/io.h>
+#include <linux/interrupt.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_device.h>
+#include <linux/slab.h>
+#include <linux/reset.h>
+#include <linux/clk.h>
+#include <linux/clkdev.h>
+#include <linux/clk-provider.h>
+#include <linux/pwm.h>
+
+#define REG_FAN_CTRL 0x0
+#define REG_FAN_DEBOUNCE 0x4
+#define REG_FAN_TIMER_TV 0x8
+#define REG_FAN_TIMER_CV 0xC
+#define REG_FAN_COUNTER_CV 0x10
+
+#define FAN_EN BIT(0)
+#define FAN_INT_EN BIT(1)
+
+#define FAN_DEBOUNCE_W_EN BIT(3)
+#define FAN_DEBOUNCE_MASK 0x7
+
+#define FAN_DEBOUNCE_DEFAULT 0x0
+#define FAN_TIMER_TV_DEFAULT 0x100
+
+#define SB2_MUXPAD4_FAN_EN_MASK (0x3 << 22)
+#define SB2_MUXPAD4_FAN_EN (0x2 << 22)
+
+struct rtk_fan_data {
+	void __iomem *reg_base;
+
+	struct device *dev;
+	struct pwm_device *pwm;
+
+	int fan_debounce;
+	int timer_target;
+	uint64_t speed;
+
+	int ctrl_speed;
+#define MAX_CTRL_SPEED 10
+};
+
+static int rtk_fan_enable(struct rtk_fan_data *fan_data) {
+	void __iomem *reg_base = fan_data->reg_base;
+
+	writel(FAN_EN | FAN_INT_EN, reg_base + REG_FAN_CTRL);
+
+	dev_dbg(fan_data->dev, "%s REG_FAN_CTRL=0x%x",
+			__func__, readl(reg_base + REG_FAN_CTRL));
+
+	return 0;
+}
+
+static int rtk_fan_disable(struct rtk_fan_data *fan_data) {
+	void __iomem *reg_base = fan_data->reg_base;
+
+	writel(0x0, reg_base + REG_FAN_CTRL);
+
+	dev_dbg(fan_data->dev, "%s REG_FAN_CTRL=0x%x",
+			__func__, readl(reg_base + REG_FAN_CTRL));
+
+	return 0;
+}
+
+static int rtk_fan_get_debound_time(struct rtk_fan_data *fan_data) {
+	void __iomem *reg_base = fan_data->reg_base;
+	int fan_debounce;
+
+	fan_debounce = readl(reg_base + REG_FAN_DEBOUNCE) & FAN_DEBOUNCE_MASK;
+
+	if (fan_debounce != fan_data->fan_debounce) {
+		dev_err(fan_data->dev, "%s ERROR fan_debounce = %x, but set fan_debounce = %x",
+			__func__, fan_debounce, fan_data->fan_debounce);
+	}
+	return fan_debounce;
+}
+
+static int rtk_fan_set_debound_time(struct rtk_fan_data *fan_data, int fan_debounce_new) {
+	void __iomem *reg_base = fan_data->reg_base;
+	int fan_debounce;
+
+	fan_debounce = rtk_fan_get_debound_time(fan_data);
+	if (fan_debounce != fan_debounce_new) {
+		writel(FAN_DEBOUNCE_W_EN |
+				(fan_debounce_new & FAN_DEBOUNCE_MASK),
+				reg_base + REG_FAN_DEBOUNCE);
+		fan_data->fan_debounce = fan_debounce;
+	}
+	return 0;
+}
+
+static int rtk_fan_get_timer_target(struct rtk_fan_data *fan_data) {
+	void __iomem *reg_base = fan_data->reg_base;
+	int timer_target;
+
+	timer_target = readl(reg_base + REG_FAN_TIMER_TV);
+
+	if (timer_target != fan_data->timer_target) {
+		dev_err(fan_data->dev, "%s ERROR timer_target = %d, but set timer_target = %d",
+			__func__, timer_target, fan_data->timer_target);
+	}
+	return timer_target;
+}
+
+static int rtk_fan_set_timer_target(struct rtk_fan_data *fan_data, int timer_target_new) {
+	void __iomem *reg_base = fan_data->reg_base;
+	int timer_target;
+
+	timer_target = rtk_fan_get_timer_target(fan_data);
+	if (timer_target != timer_target_new) {
+		writel(timer_target_new, reg_base + REG_FAN_TIMER_TV);
+		fan_data->timer_target = timer_target_new;
+	}
+	return 0;
+}
+
+static int rtk_fan_get_speed(struct rtk_fan_data *fan_data) {
+	return fan_data->speed;
+}
+
+static int rtk_fan_ctrl_speed(struct rtk_fan_data *fan_data, int ctrl_speed) {
+	if (ctrl_speed > MAX_CTRL_SPEED) ctrl_speed = MAX_CTRL_SPEED;
+
+	if (fan_data->pwm) {
+		int period_ns = pwm_get_period(fan_data->pwm);
+		int duty_ns = period_ns * ctrl_speed / MAX_CTRL_SPEED;
+		dev_dbg(fan_data->dev, "%s to set pwm default duty_ns =%d,  period_ns = %d!",
+		__func__, duty_ns, period_ns);
+		pwm_config(fan_data->pwm, duty_ns, period_ns);
+	}
+	fan_data->ctrl_speed = ctrl_speed;
+}
+
+static int rtk_fan_compute_speed(struct rtk_fan_data *fan_data) {
+	void __iomem *reg_base = fan_data->reg_base;
+
+	int timer_target, counter_value;
+	uint64_t factor = 90000*60/2;
+	uint64_t speed;
+
+	timer_target = fan_data->timer_target;
+	counter_value = readl(reg_base + REG_FAN_COUNTER_CV);
+
+	//(9801bc10[31:0]/2) / (9801bc08[31:0]/90000/60)
+	speed = (counter_value * factor) / timer_target;
+
+	fan_data->speed = speed;
+
+	dev_dbg(fan_data->dev, "%s speed =%u, timer_target=%d, counter_value=%d\n", __func__, speed, timer_target, counter_value);
+
+	return 0;
+}
+
+static irqreturn_t rtk_fan_irq(int irq, void *data) {
+	struct rtk_fan_data *fan_data = (struct rtk_fan_data *) data;
+	struct device *dev = fan_data->dev;
+	unsigned long flags;
+
+	dev_dbg(dev, "%s Enter ...", __func__);
+
+	rtk_fan_compute_speed(fan_data);
+
+	dev_dbg(dev, "%s Exit ...", __func__);
+	return IRQ_HANDLED;
+}
+
+static ssize_t fan_debounce_show(struct device *dev, struct device_attribute *attr, char *buffer) {
+	struct rtk_fan_data *fan_data = dev_get_drvdata(dev);
+
+	return sprintf(buffer, "%d\n", rtk_fan_get_debound_time(fan_data));
+}
+
+static ssize_t fan_debounce_store(struct device *dev, struct device_attribute *attr,
+		const char *buffer, size_t size) {
+	struct rtk_fan_data *fan_data = dev_get_drvdata(dev);
+	int ret;
+	int value;
+
+	ret = sscanf(buffer, "%d", &value);
+	if (ret != 1)
+		return -EINVAL;
+
+	rtk_fan_set_debound_time(fan_data, value);
+
+	return size;
+}
+
+static ssize_t fan_timer_target_show(struct device *dev,
+		struct device_attribute *attr, char *buffer) {
+	struct rtk_fan_data *fan_data = dev_get_drvdata(dev);
+
+	return sprintf(buffer, "%d\n", rtk_fan_get_timer_target(fan_data));
+}
+
+static ssize_t fan_timer_target_store(struct device *dev, struct device_attribute *attr,
+		const char *buffer, size_t size) {
+	struct rtk_fan_data *fan_data = dev_get_drvdata(dev);
+	int ret;
+	int value;
+
+	ret = sscanf(buffer, "%d", &value);
+	if (ret != 1)
+		return -EINVAL;
+
+	rtk_fan_set_timer_target(fan_data, value);
+
+	return size;
+}
+
+static ssize_t fan_timer_value_show(struct device *dev,
+		struct device_attribute *attr, char *buffer) {
+	struct rtk_fan_data *fan_data = dev_get_drvdata(dev);
+
+	return sprintf(buffer, "real-time timer value %d\n", readl(fan_data->reg_base + REG_FAN_TIMER_CV));
+}
+
+static ssize_t fan_counter_value_show(struct device *dev,
+		struct device_attribute *attr, char *buffer) {
+	struct rtk_fan_data *fan_data = dev_get_drvdata(dev);
+
+	return sprintf(buffer, "real-time counter value %d\n", readl(fan_data->reg_base + REG_FAN_COUNTER_CV));
+}
+
+static ssize_t fan_speed_show(struct device *dev,
+		struct device_attribute *attr, char *buffer) {
+	struct rtk_fan_data *fan_data = dev_get_drvdata(dev);
+
+	return sprintf(buffer, "%u\n", rtk_fan_get_speed(fan_data));
+}
+
+static ssize_t fan_ctrl_speed_show(struct device *dev,
+		struct device_attribute *attr, char *buffer) {
+	struct rtk_fan_data *fan_data = dev_get_drvdata(dev);
+
+	return sprintf(buffer, "now %d of %d (set 0~10)\n", fan_data->ctrl_speed, MAX_CTRL_SPEED);
+}
+
+static ssize_t fan_ctrl_speed_store(struct device *dev, struct device_attribute *attr,
+		const char *buffer, size_t size) {
+	struct rtk_fan_data *fan_data = dev_get_drvdata(dev);
+	int ret;
+	int value;
+
+	ret = sscanf(buffer, "%d", &value);
+	if (ret != 1)
+		return -EINVAL;
+
+	rtk_fan_disable(fan_data);
+
+	rtk_fan_ctrl_speed(fan_data, value);
+
+	rtk_fan_enable(fan_data);
+
+	return size;
+}
+
+static DEVICE_ATTR(fan_debounce, 0644, fan_debounce_show, fan_debounce_store);
+static DEVICE_ATTR(fan_timer_target, 0644, fan_timer_target_show, fan_timer_target_store);
+static DEVICE_ATTR_RO(fan_timer_value);
+static DEVICE_ATTR_RO(fan_counter_value);
+static DEVICE_ATTR_RO(fan_speed);
+static DEVICE_ATTR(fan_ctrl_speed, 0644, fan_ctrl_speed_show, fan_ctrl_speed_store);
+
+static const struct attribute *rtk_fan_attrs[] = {
+	&dev_attr_fan_debounce.attr,
+	&dev_attr_fan_timer_target.attr,
+	&dev_attr_fan_timer_value.attr,
+	&dev_attr_fan_counter_value.attr,
+	&dev_attr_fan_speed.attr,
+	&dev_attr_fan_ctrl_speed.attr,
+	NULL
+};
+
+static int rtk_fan_create_sysfs(struct rtk_fan_data *fan_data)
+{
+	struct device *dev = fan_data->dev;
+	int retval;
+
+	retval = sysfs_create_files(&dev->kobj,
+			(const struct attribute **)rtk_fan_attrs);
+
+	return retval;
+}
+
+static int rtk_fan_init(struct rtk_fan_data *fan_data, struct platform_device *pdev) {
+	struct device *dev = &pdev->dev;
+	struct device_node *node = pdev->dev.of_node;
+	int ret;
+	int fan_debounce, timer_target;
+	u32 value;
+
+	/* GET clock */
+	struct clk *clk_fan = clk_get(dev, NULL);
+	/* GET reset controller */
+	struct reset_control *reset_fan = reset_control_get(dev, NULL);
+
+	reset_control_deassert(reset_fan);
+	clk_prepare_enable(clk_fan);
+
+	ret = of_property_read_u32(node, "fan_debounce",
+					&fan_debounce);
+	if (ret < 0) {
+		dev_info(dev, "%s NO set debounce time!", __func__);
+		fan_debounce = FAN_DEBOUNCE_DEFAULT;
+	}
+	rtk_fan_set_debound_time(fan_data, fan_debounce);
+
+	ret = of_property_read_u32(node, "timer_target",
+					&timer_target);
+	if (ret < 0) {
+		dev_info(dev, "%s NO set timer_target!", __func__);
+		timer_target = FAN_TIMER_TV_DEFAULT;
+	}
+
+	fan_data->pwm = pwm_get(dev, NULL);
+
+	rtk_fan_ctrl_speed(fan_data, MAX_CTRL_SPEED / 2);
+
+	rtk_fan_set_timer_target(fan_data, timer_target);
+
+	rtk_fan_enable(fan_data);
+
+	return 0;
+}
+
+static int rtk_fan_probe(struct platform_device *pdev) {
+	struct device *dev = &pdev->dev;
+	struct device_node *node = NULL;
+	struct rtk_fan_data *fan_data;
+	int irq, ret;
+
+	dev_info(dev, "%s Enter ..", __func__);
+	node = pdev->dev.of_node;
+	if (!node) {
+		dev_err(dev, "%s Fail to get device tree node", __func__);
+		return -ENODEV;
+	}
+
+	fan_data = devm_kzalloc(&pdev->dev, sizeof(*fan_data), GFP_KERNEL);
+	if (!fan_data) {
+		dev_err(dev, "%s No memory!", __func__);
+		return -ENOMEM;
+	}
+
+	fan_data->dev = dev;
+
+	fan_data->reg_base = of_iomap(node, 0);
+
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (irq <= 0) {
+		dev_err(&pdev->dev, "%s No IRQ. Check %s setup!\n",
+				__func__, dev_name(&pdev->dev));
+		ret = -ENODEV;
+		goto err1;
+	}
+
+	ret = request_irq(irq, rtk_fan_irq,
+			IRQF_SHARED, "rtk_fan_irq", fan_data);
+
+	if (ret < 0) {
+		dev_err(dev, "%s Fail to request_irq (ret=%d)", __func__, ret);
+		goto err1;
+	}
+
+	ret = rtk_fan_init(fan_data, pdev);
+	if (ret < 0) {
+		dev_err(dev, "%s Fail to init rtk_fan (ret=%d)", __func__, ret);
+		goto err1;
+	}
+
+	ret = rtk_fan_create_sysfs(fan_data);
+	if (ret < 0) {
+		dev_err(dev, "%s Fail to create sysfs (ret=%d)", __func__, ret);
+		goto err1;
+	}
+
+	platform_set_drvdata(pdev, fan_data);
+
+	dev_info(dev, "%s Exit", __func__);
+	return 0;
+
+err1:
+	kfree(fan_data);
+	dev_err(dev, "%s Probe Fail (ret=%d)", __func__, ret);
+	return ret;
+}
+
+static int rtk_fan_remove(struct platform_device *pdev) {
+	struct rtk_fan_data *fan_data = platform_get_drvdata(pdev);
+
+	platform_set_drvdata(pdev, NULL);
+	if (fan_data)
+		kfree(fan_data);
+
+	return 0;
+}
+
+static const struct of_device_id rtk_fan_of_match[] = {
+	{.compatible = "Realtek,rtd129x-fan",},
+	{ /* Sentinel */ },
+};
+
+static struct platform_driver rtk_fan_driver = {
+	.probe = rtk_fan_probe,
+	.remove = rtk_fan_remove,
+	.driver = {
+		.name = "rtk-fan",
+		.owner = THIS_MODULE,
+		.of_match_table = of_match_ptr(rtk_fan_of_match),
+	},
+};
+
+static int __init rtk_fan_probe_init(void)
+{
+	return platform_driver_probe(&rtk_fan_driver, rtk_fan_probe);
+}
+
+late_initcall(rtk_fan_probe_init);
+
diff --git a/drivers/soc/realtek/rtd129x/rtd129x_lockapi.c b/drivers/soc/realtek/rtd129x/rtd129x_lockapi.c
new file mode 100644
index 00000000..2bec307
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtd129x_lockapi.c
@@ -0,0 +1,952 @@
+/*
+ * rtd129x_lockapi.c - Realtek lock API
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#define pr_fmt(fmt) "lockapi: " fmt
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/delay.h>
+#include <linux/suspend.h>
+#include <linux/semaphore.h>
+#include <linux/spinlock.h>
+#include <linux/module.h>
+#include <linux/device.h>
+#include <linux/fs.h>
+#include <linux/miscdevice.h>
+#include <linux/uaccess.h>
+#include <linux/io.h>
+#include <asm/system_misc.h>
+#include <asm/atomic.h>
+
+#include <soc/realtek/rtd129x_lockapi.h>
+#include <soc/realtek/rtk_cpu.h>
+
+static long locakapi_lcounter;
+static int locakapi_counter;
+static int iemmc_flag;
+static int ichip_id;
+static int ichip_revision;
+static int imagic_num;
+static unsigned int debug_nop_count;
+
+struct semaphore lockapi_sema;
+spinlock_t lockapi_slock;
+//static int lockapi_flags;
+static DEFINE_MUTEX(lockapi_mutex);
+
+#if 0 /* defined but not used */
+static atomic_t lockapi_atom = ATOMIC_INIT(0);
+#endif
+
+static struct device *myproc_lockapi_dev;
+static char caller_name1[MAX_LOG_MSG_LEN];
+static char caller_name2[MAX_LOG_MSG_LEN];
+static char caller_name3[MAX_LOG_MSG_LEN];
+
+static char caller_name1emmc[MAX_LOG_MSG_LEN];
+static char caller_name2emmc[MAX_LOG_MSG_LEN];
+static char caller_name3emmc[MAX_LOG_MSG_LEN];
+
+static char caller_name1dwc3[MAX_LOG_MSG_LEN];
+static char caller_name2dwc3[MAX_LOG_MSG_LEN];
+static char caller_name3dwc3[MAX_LOG_MSG_LEN];
+
+static char caller_name1debug[MAX_LOG_MSG_LEN];
+static char caller_name2debug[MAX_LOG_MSG_LEN];
+static char caller_name3debug[MAX_LOG_MSG_LEN];
+
+/*
+ *
+ *
+ *
+ */
+int lockapi_trylock( unsigned long * pflags )
+{
+	int iret;
+
+	iret = LOCKAPI_NO_ERR;
+
+#if defined(EN_SPINLOCK) || defined(EN_SPINLOCK_IRQ)
+	if( spin_trylock( &lockapi_slock ) == 0 ) {
+		iret = -LOCKAPI_ERR_BUSY;
+	}
+	else {
+		iret = LOCKAPI_NO_ERR;
+	}
+#endif
+#ifdef EN_SEMAPHORE
+	if( down_trylock( &lockapi_sema ) == 0 ) {
+		iret = LOCKAPI_NO_ERR;
+	}
+	else {
+		iret = -LOCKAPI_ERR_BUSY;
+	}
+#endif
+#ifdef EN_MUTEX
+	if( mutex_trylock() == 1 ) {
+		iret = LOCKAPI_NO_ERR;
+	}
+	else {
+		iret = -LOCKAPI_ERR_BUSY;
+	}
+#endif
+	return iret;
+}
+
+int lockapi_lock( unsigned long * pflags )
+{
+	int iret;
+
+	iret = LOCKAPI_NO_ERR;
+
+#ifdef EN_SPINLOCK
+	spin_lock( &lockapi_slock);
+#endif
+#ifdef EN_SPINLOCK_IRQ
+	spin_lock_irqsave( &lockapi_slock, (*pflags) );
+#endif
+#ifdef EN_SEMAPHORE
+	iret = down_interruptible( &lockapi_sema );
+#endif
+#ifdef EN_MUTEX
+	mutex_lock(&lockapi_mutex);
+#endif
+	return iret;
+}
+
+int lockapi_unlock( unsigned long flags )
+{
+	int iret;
+
+	iret = LOCKAPI_NO_ERR;
+
+#ifdef EN_SPINLOCK
+	spin_unlock( &lockapi_slock);
+#endif
+#ifdef EN_SPINLOCK_IRQ
+	spin_unlock_irqrestore( &lockapi_slock, flags );
+#endif
+#ifdef EN_SEMAPHORE
+	up( &lockapi_sema );
+#endif
+#ifdef EN_MUTEX
+	mutex_lock(&lockapi_mutex);
+#endif
+	return LOCKAPI_NO_ERR;
+}
+
+
+/*
+ *
+ *
+ *
+ */
+int _rtk_lockapi_trylock( unsigned long * pflags, char * log_msg )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int nop_loop;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	iret = lockapi_trylock(pflags);
+
+	if( iret != LOCKAPI_NO_ERR )
+		return iret;
+
+	LOCK_NOP_DELAY;
+
+	locakapi_counter++;
+	locakapi_lcounter++;
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name1, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			strcpy( caller_name1, log_msg );
+		else
+			strcpy( caller_name1, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name1, "no log msg" );
+	}
+
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+EXPORT_SYMBOL_GPL(_rtk_lockapi_trylock);
+
+/*
+ * Input 1: please use __FUNCTION__ or others readable log mesage
+ *
+ *
+ */
+
+
+int _rtk_lockapi_lock( unsigned long * pflags, char * log_msg )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int nop_loop;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	iret = lockapi_lock(pflags);
+
+	LOCK_NOP_DELAY;
+
+	locakapi_counter++;
+	locakapi_lcounter++;
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name2, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			strcpy( caller_name2, log_msg );
+		else
+			strcpy( caller_name2, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name2, "no log msg" );
+	}
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+EXPORT_SYMBOL_GPL(_rtk_lockapi_lock);
+
+/*
+ * Input 1: please use __FUNCTION__ or others readable log mesage
+ *
+ *
+ */
+int _rtk_lockapi_unlock( unsigned long flags, char * log_msg )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int nop_loop;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name3, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			strcpy( caller_name3, log_msg );
+		else
+			strcpy( caller_name3, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name3, "no log msg" );
+	}
+
+	if( locakapi_counter ) {
+		locakapi_counter--;
+	}
+	else {
+		printk(KERN_ERR "locakapi:counter %d is zero, unlock twice?\n", locakapi_counter);
+		printk(KERN_ERR "locakapi:log %s, %s, %s\n", caller_name1, caller_name2, caller_name3);
+		printk(KERN_ERR "locakapi:log %s, %s, %s\n", caller_name1emmc, caller_name2emmc, caller_name3emmc);
+		printk(KERN_ERR "locakapi:log %s, %s, %s\n", caller_name1dwc3, caller_name2dwc3, caller_name3dwc3);
+	}
+
+	UNLOCK_NOP_DELAY;
+
+	iret = lockapi_unlock(flags);
+
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+EXPORT_SYMBOL_GPL(_rtk_lockapi_unlock);
+
+/*
+ *
+ *
+ *
+ */
+int _rtk_lockapi_trylock2( unsigned long * pflags, char * log_msg )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int nop_loop;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	iret = lockapi_trylock(pflags);
+
+	if( iret != LOCKAPI_NO_ERR )
+		return iret;
+
+	LOCK_NOP_DELAY;
+
+	locakapi_counter++;
+	locakapi_lcounter++;
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name1emmc, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			strcpy( caller_name1emmc, log_msg );
+		else
+			strcpy( caller_name1emmc, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name1emmc, "no log msg" );
+	}
+
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+EXPORT_SYMBOL_GPL(_rtk_lockapi_trylock2);
+
+/*
+ * Input 1: please use __FUNCTION__ or others readable log mesage
+ *
+ *
+ */
+
+
+int _rtk_lockapi_lock2( unsigned long * pflags, char * log_msg )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int nop_loop;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	iret = lockapi_lock(pflags);
+
+	LOCK_NOP_DELAY;
+
+	locakapi_counter++;
+	locakapi_lcounter++;
+	iemmc_flag = 1;
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name2emmc, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			strcpy( caller_name2emmc, log_msg );
+		else
+			strcpy( caller_name2emmc, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name2emmc, "no log msg" );
+	}
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+EXPORT_SYMBOL_GPL(_rtk_lockapi_lock2);
+
+/*
+ * Input 1: please use __FUNCTION__ or others readable log mesage
+ *
+ *
+ */
+int _rtk_lockapi_unlock2( unsigned long flags, char * log_msg )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int nop_loop;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name3emmc, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			strcpy( caller_name3emmc, log_msg );
+		else
+			strcpy( caller_name3emmc, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name3emmc, "no log msg" );
+	}
+
+	if( locakapi_counter ) {
+		locakapi_counter--;
+	}
+	else {
+		printk(KERN_ERR "locakapi2:counter %d is zero, unlock twice?\n", locakapi_counter);
+		printk(KERN_ERR "locakapi2:log %s, %s, %s\n", caller_name1, caller_name2, caller_name3);
+		printk(KERN_ERR "locakapi2:log %s, %s, %s\n", caller_name1emmc, caller_name2emmc, caller_name3emmc);
+		printk(KERN_ERR "locakapi2:log %s, %s, %s\n", caller_name1dwc3, caller_name2dwc3, caller_name3dwc3);
+	}
+	iemmc_flag = 0;
+
+	UNLOCK_NOP_DELAY;
+
+	iret = lockapi_unlock(flags);
+
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+EXPORT_SYMBOL_GPL(_rtk_lockapi_unlock2);
+
+/*
+ *
+ *
+ *
+ */
+int _rtk_lockapi_trylock3( unsigned long * pflags, char * log_msg, int log_line )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int nop_loop;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	iret = lockapi_trylock(pflags);
+
+	if( iret != LOCKAPI_NO_ERR )
+		return iret;
+
+	LOCK_NOP_DELAY;
+
+	locakapi_counter++;
+	locakapi_lcounter++;
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name1dwc3, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			sprintf(caller_name1dwc3, "%s %d", log_msg, log_line);
+		else
+			strcpy( caller_name1dwc3, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name1dwc3, "no log msg" );
+	}
+
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+EXPORT_SYMBOL_GPL(_rtk_lockapi_trylock3);
+
+/*
+ * Input 1: please use __FUNCTION__ or others readable log mesage
+ *
+ *
+ */
+
+
+int _rtk_lockapi_lock3( unsigned long * pflags, char * log_msg, int log_line )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int nop_loop;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	iret = lockapi_lock(pflags);
+
+	LOCK_NOP_DELAY;
+
+	locakapi_counter++;
+	locakapi_lcounter++;
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name2dwc3, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			sprintf(caller_name2dwc3, "%s %d", log_msg, log_line);
+		else
+			strcpy( caller_name2dwc3, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name2dwc3, "no log msg" );
+	}
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+EXPORT_SYMBOL_GPL(_rtk_lockapi_lock3);
+
+/*
+ * Input 1: please use __FUNCTION__ or others readable log mesage
+ *
+ *
+ */
+int _rtk_lockapi_unlock3( unsigned long flags, char * log_msg, int log_line )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int nop_loop;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name3dwc3, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			sprintf(caller_name3dwc3, "%s %d", log_msg, log_line);
+		else
+			strcpy( caller_name3dwc3, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name3dwc3, "no log msg" );
+	}
+
+	if( locakapi_counter ) {
+		locakapi_counter--;
+	}
+	else {
+		printk(KERN_ERR "locakapi3:counter %d is zero, unlock twice?\n", locakapi_counter);
+		printk(KERN_ERR "locakapi3:log %s, %s, %s\n", caller_name1, caller_name2, caller_name3);
+		printk(KERN_ERR "locakapi3:log %s, %s, %s\n", caller_name1emmc, caller_name2emmc, caller_name3emmc);
+		printk(KERN_ERR "locakapi3:log %s, %s, %s\n", caller_name1dwc3, caller_name2dwc3, caller_name3dwc3);
+	}
+
+	UNLOCK_NOP_DELAY;
+
+	iret = lockapi_unlock(flags);
+
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+EXPORT_SYMBOL_GPL(_rtk_lockapi_unlock3);
+
+/*
+ *
+ *
+ *
+ */
+static int rtk_lockapi_init(void)
+{
+	ichip_id = 0;//get_rtd129x_cpu_id();
+	ichip_revision = get_rtd129x_cpu_revision();
+	locakapi_counter = 0;
+	locakapi_lcounter = 0;
+	iemmc_flag = 0;
+	memset( caller_name1, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name2, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name3, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name1emmc, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name2emmc, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name3emmc, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name1dwc3, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name2dwc3, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name3dwc3, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name1debug, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name2debug, 0, MAX_LOG_MSG_LEN );
+	memset( caller_name3debug, 0, MAX_LOG_MSG_LEN );
+	strcpy( caller_name1, "clear" );
+	strcpy( caller_name2, "clear" );
+	strcpy( caller_name3, "clear" );
+	strcpy( caller_name1emmc, "clear" );
+	strcpy( caller_name2emmc, "clear" );
+	strcpy( caller_name3emmc, "clear" );
+	strcpy( caller_name1dwc3, "clear" );
+	strcpy( caller_name2dwc3, "clear" );
+	strcpy( caller_name3dwc3, "clear" );
+	strcpy( caller_name1debug, "clear" );
+	strcpy( caller_name2debug, "clear" );
+	strcpy( caller_name3debug, "clear" );
+	imagic_num = LOCKAPI_MAGICNUM;
+
+	printk(KERN_ERR "****** %s %d, chip: id=0x%08x, revision=0x%08x\n", __FUNCTION__, __LINE__, ichip_id, ichip_revision);
+
+	// ID: 0x9801a200
+	// Rev.: 0x9801a204
+	if( ichip_revision >= (int)RTD129x_CHIP_REVISION_B00 )
+	{
+		imagic_num = LOCKAPI_BY_PASS;
+		printk(KERN_ERR "****** %s %d, bypass mode\n", __FUNCTION__, __LINE__);
+	}
+
+
+	sema_init( &lockapi_sema, 1 );
+	spin_lock_init( &lockapi_slock );
+
+	return 0;
+}
+arch_initcall(rtk_lockapi_init);
+
+int debug_lockapi_lock( unsigned long * pflags, char * log_msg )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int looptest;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	iret = LOCKAPI_NO_ERR;//lockapi_lock(pflags);
+
+	locakapi_counter++;
+	locakapi_lcounter++;
+
+	looptest = debug_nop_count;
+	while(looptest--) {
+		asm volatile("nop" : : : );
+	}
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name2debug, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			strcpy( caller_name2debug, log_msg );
+		else
+			strcpy( caller_name2debug, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name2debug, "no log msg" );
+	}
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+
+/*
+ * Input 1: please use __FUNCTION__ or others readable log mesage
+ *
+ *
+ */
+int debug_lockapi_unlock( unsigned long flags, char * log_msg )
+{
+#ifdef LOCKAPI_EN
+	int iret;
+	int ilen;
+	unsigned int looptest;
+
+	if( imagic_num == LOCKAPI_BY_PASS )
+		return LOCKAPI_NO_ERR;
+
+	if( imagic_num != LOCKAPI_MAGICNUM )
+		return -LOCKAPI_ERR_DRV_NOT_READY;
+
+	if( log_msg ) {
+		ilen = strlen(log_msg);
+		memset( caller_name3debug, 0, MAX_LOG_MSG_LEN );
+		if( ilen < MAX_LOG_MSG_LEN )
+			strcpy( caller_name3debug, log_msg );
+		else
+			strcpy( caller_name3debug, "log name over 128" );
+	}
+	else {
+		strcpy( caller_name3debug, "no log msg" );
+	}
+
+	if( locakapi_counter ) {
+		locakapi_counter--;
+	}
+	else {
+		printk(KERN_ERR "locakapi:counter %d is zero, unlock twice?\n", locakapi_counter);
+		printk(KERN_ERR "locakapi:log %s, %s, %s\n", caller_name1debug, caller_name2debug, caller_name3debug);
+		printk(KERN_ERR "locakapi:log %s, %s, %s\n", caller_name1emmc, caller_name2emmc, caller_name3emmc);
+		printk(KERN_ERR "locakapi:log %s, %s, %s\n", caller_name1dwc3, caller_name2dwc3, caller_name3dwc3);
+	}
+
+	looptest = debug_nop_count;
+	while(looptest--) {
+		asm volatile("nop" : : : );
+	}
+
+	iret = LOCKAPI_NO_ERR;//lockapi_unlock(flags);
+
+	return iret;
+#else
+	return LOCKAPI_NO_ERR;
+#endif
+}
+
+
+/*
+ *
+ *
+ *
+ */
+void debug_lockapi_entry( int mode, unsigned int refloop, unsigned int nop_loop )
+{
+	unsigned long start_jiffies;
+	unsigned long end_jiffies;
+	unsigned long flags;
+	unsigned int looptest;
+
+	debug_nop_count = nop_loop;
+
+	start_jiffies = end_jiffies = 0;
+
+	if( mode == 0 ) {
+		looptest = refloop;
+		printk(KERN_ERR "start\n");
+		start_jiffies = jiffies;
+		while( looptest-- ) {
+			debug_lockapi_lock(&flags,"_");
+		}
+		end_jiffies = jiffies;
+		printk(KERN_ERR "end, %lud, %lud in loop %d, nop loop %d\n", start_jiffies, end_jiffies, refloop, debug_nop_count);
+	}
+	if( mode == 1 ) {
+		looptest = refloop;
+		locakapi_counter = looptest<<1;
+		printk(KERN_ERR "start\n");
+		start_jiffies = jiffies;
+		while( looptest-- ) {
+			debug_lockapi_unlock(flags,"_");
+		}
+		end_jiffies = jiffies;
+		printk(KERN_ERR "end, %lud, %lud in loop %d, nop loop %d\n", start_jiffies, end_jiffies, refloop, debug_nop_count);
+	}
+	if( mode == 2 ) {
+		looptest = refloop;
+		printk(KERN_ERR "start\n");
+		start_jiffies = jiffies;
+		while( looptest-- ) {
+			debug_lockapi_lock(&flags,"_");
+			debug_lockapi_unlock(flags,"_");
+		}
+		end_jiffies = jiffies;
+		printk(KERN_ERR "end, %lud, %lud in loop %d, nop loop %d\n", start_jiffies, end_jiffies, refloop, debug_nop_count);
+	}
+}
+/*
+ *
+ *
+ *
+ */
+void lockapi_show_status( void )
+{
+	printk(KERN_ERR "\n--------------------------------------------------------------------------\n");
+	printk(KERN_ERR "****** chip id 0x%08x\n", ichip_id);
+	printk(KERN_ERR "****** chip rev. 0x%08x\n", ichip_revision);
+	printk(KERN_ERR "****** magic_num 0x%08x(%s)\n", imagic_num, (imagic_num == LOCKAPI_BY_PASS) ? "bypass" : "--" );
+	printk(KERN_ERR "****** iemmc_flag %d\n", iemmc_flag);
+	printk(KERN_ERR "****** locakapi_counter %d\n", locakapi_counter);
+	printk(KERN_ERR "****** locakapi_lcounter %ld\n", locakapi_lcounter);
+	printk(KERN_ERR "****** caller_name %s, %s, %s\n", caller_name1, caller_name2, caller_name3);
+	printk(KERN_ERR "****** caller_name %s, %s, %s\n", caller_name1emmc, caller_name2emmc, caller_name3emmc);
+	printk(KERN_ERR "****** caller_name %s, %s, %s\n", caller_name1dwc3, caller_name2dwc3, caller_name3dwc3);
+#if defined(EN_SPINLOCK)
+	printk(KERN_ERR "****** EN_SPINLOCK defined\n");
+#endif
+#if defined(EN_SPINLOCK_IRQ)
+	printk(KERN_ERR "****** EN_SPINLOCK_IRQ defined\n");
+#endif
+#if defined(EN_SEMAPHORE)
+	printk(KERN_ERR "****** EN_SEMAPHORE defined\n");
+#endif
+#if defined(EN_MUTEX)
+	printk(KERN_ERR "****** EN_MUTEX defined\n");
+#endif
+#if !defined(LOCKAPI_EN)
+	printk(KERN_ERR "****** Lock api is not enabled\n");
+#endif
+}
+EXPORT_SYMBOL_GPL(lockapi_show_status);
+
+/*
+ * any read request will free coherent memory, eg.
+ * cat /dev/rtk_lockapi
+ *
+ */
+static ssize_t
+myproc_lockapi_read(struct file *file, char __user *buf, size_t count, loff_t *ppos)
+{
+	lockapi_show_status();
+	return 0;
+}
+
+/*
+ * any write request will alloc coherent memory, eg.
+ * echo xxxxxxx > /dev/rtk_lockapi
+ *
+ */
+static ssize_t
+myproc_lockapi_write(struct file *file, const char __user *buf, size_t count, loff_t *ppos)
+{
+	char input[128] = {0};
+	char * ptr_input;
+	int str_len;
+	int reminder_str_len;
+	int ret_val;
+	unsigned int input_nop_count;
+	unsigned int test_loop;
+	int test_mode;
+
+	ptr_input = input;
+	str_len = count-1;
+	reminder_str_len = str_len;
+
+	if( ( 1 < count ) && ( count < 128 ) ) {
+		ret_val = copy_from_user(input, buf, (count-1));
+	}
+	else {
+		printk(KERN_ERR "****** %s %03d, invalid count(%d)\n", __FUNCTION__, __LINE__, (int)count);
+		return count;
+	}
+	printk(KERN_ERR "****** %s %03d, input = %s\n", __FUNCTION__, __LINE__, input);
+	printk(KERN_ERR "****** %s %03d -----------------------------------------\n", __FUNCTION__, __LINE__);
+
+	test_mode = -1;
+	input_nop_count = 0;
+	test_loop = 0;
+
+	if( strncmp( ptr_input, "lock", 4 ) == 0 ) {
+		if( str_len > 5 ) {
+			ptr_input += 5;
+			reminder_str_len -= 5;
+		}
+		test_mode = 0;
+	}
+	else if( strncmp( ptr_input, "unlock", 6 ) == 0 ) {
+		if( str_len > 7 ) {
+			ptr_input += 7;
+			reminder_str_len -= 7;
+		}
+		test_mode = 1;
+	}
+	else if( strncmp( ptr_input, "lockunlock", 10 ) == 0 ) {
+		if( str_len > 11 ) {
+			ptr_input += 11;
+			reminder_str_len -= 11;
+		}
+		test_mode = 2;
+	}
+
+	if( reminder_str_len ) {
+		if( strncmp( ptr_input, "A", 1 ) == 0 ) {
+			test_loop = 10000000;
+			ptr_input++;
+			reminder_str_len--;
+		}
+		else if( strncmp( ptr_input, "B", 1 ) == 0 ) {
+			test_loop = 20000000;
+			ptr_input++;
+			reminder_str_len--;
+		}
+		else if( strncmp( ptr_input, "C", 1 ) == 0 ) {
+			test_loop = 30000000;
+			ptr_input++;
+			reminder_str_len--;
+		}
+	}
+
+	if( reminder_str_len ) {
+		input_nop_count = simple_strtol(ptr_input, &ptr_input + reminder_str_len, 10);
+		input_nop_count = input_nop_count * 10;
+	}
+	printk(KERN_ERR "****** %s %03d, mode %d, test_loop=%d, nop count %d\n", __FUNCTION__, __LINE__, test_mode, test_loop, input_nop_count);
+
+	debug_lockapi_entry(test_mode, test_loop, input_nop_count);
+
+	return count;
+}
+
+static const struct file_operations myproc_lockapi_fops = {
+	.owner =    THIS_MODULE,
+	.read  =    myproc_lockapi_read,
+	.write =    myproc_lockapi_write,
+};
+
+static struct miscdevice myproc_lockapi_misc = {
+	.minor = MISC_DYNAMIC_MINOR,
+	.name = "rtk_lockapi",
+	.fops = &myproc_lockapi_fops,
+};
+
+static int __init proc_lockapi_init(void)
+{
+	int ret = 0;
+
+	ret = misc_register(&myproc_lockapi_misc);
+	if (unlikely(ret)) {
+		pr_err("failed to register cma test misc device!\n");
+		return ret;
+	}
+	myproc_lockapi_dev = myproc_lockapi_misc.this_device;
+	myproc_lockapi_dev->coherent_dma_mask = ~0;
+	_dev_info(myproc_lockapi_dev, "registered.\n");
+
+	return ret;
+}
+module_init(proc_lockapi_init);
+
+static void __exit proc_lockapi_exit(void)
+{
+	misc_deregister(&myproc_lockapi_misc);
+}
+module_exit(proc_lockapi_exit);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("jinn <jinn.cheng@reaktek.com>");
+MODULE_DESCRIPTION("kernel module to help the debug of lockapi");
+MODULE_ALIAS("PROC LOCKAPI");
diff --git a/drivers/soc/realtek/rtd129x/rtd129x_restart.c b/drivers/soc/realtek/rtd129x/rtd129x_restart.c
new file mode 100644
index 00000000..8846ccb
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtd129x_restart.c
@@ -0,0 +1,214 @@
+/*
+ * rtd129x_restart.c - restart function
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <soc/realtek/rtk_rstctl.h>
+
+#include <asm/system_misc.h>
+
+static void __iomem * wdt_base;
+static int wdt_oe;
+static void __iomem * rst_ctrl_base;
+unsigned int rst_ctrl_reg_offset = 0;
+
+#define WDT_CLR 4
+#define WDT_CTL 0
+#define WDT_OVERFLOW 0xC
+#define WDT_NMI 8
+#define WDT_RSTB_CNT 0x40
+#define WDT_OE 0x44 //0x980076C4
+
+static void setup_restart_action(RESET_ACTION action)
+{
+	unsigned int reset_action = RESET_MAGIC;
+
+	if (!rst_ctrl_base) {
+		pr_err("%s, Skip set reset action\n", __func__);
+		return;
+	}
+
+	reset_action |= action;
+	writel(reset_action, rst_ctrl_base + rst_ctrl_reg_offset);
+}
+
+void rtk_machine_restart(char mode, const char *cmd)
+{
+	if (cmd) {
+		if (!strncmp("bootloader", cmd, 11)) {
+			setup_restart_action(RESET_ACTION_FASTBOOT);
+		} else if (!strncmp("recovery", cmd, 9)) {
+			setup_restart_action(RESET_ACTION_RECOVERY);
+		} else {
+			setup_restart_action(RESET_ACTION_NO_ACTION);
+		}
+	} else {
+		setup_restart_action(RESET_ACTION_NO_ACTION);
+	}
+
+	if (wdt_oe >= 0)
+		writel(wdt_oe, wdt_base + WDT_OE);
+
+	writel(0x00800000, wdt_base + WDT_RSTB_CNT);
+	writel(BIT(0), wdt_base + WDT_CLR);
+	writel(0x00800000, wdt_base + WDT_OVERFLOW);
+	writel(0x000000FF, wdt_base + WDT_CTL);
+
+	while (1)
+		mdelay(100);
+}
+
+static struct of_device_id rtk_restart_ids[] = {
+	{.compatible = "realtek,rtk-watchdog", .data = rtk_machine_restart},
+	{}
+};
+
+static struct of_device_id rtk_reset_control_ids[] = {
+	{.compatible = "Realtek,rtk-rstctrl"},
+	{}
+};
+
+static int rtk_setup_restart(void)
+{
+	const struct of_device_id *of_id;
+	struct device_node *np;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		pr_info("%s: skip under DomU\n", __func__);
+		return 0;
+	}
+#endif
+	/* setup Watchdog */
+	np = of_find_matching_node(NULL, rtk_restart_ids);
+	if (WARN(!np, "Unable to setup watchdog restart"))
+		return 1;
+
+	wdt_base = of_iomap(np, 0);
+	WARN(!wdt_base, "failed to map IO base for watchdog");
+
+	if (of_property_read_u32_index(np, "rst-oe", 0, &wdt_oe))
+		wdt_oe = -1;
+
+	of_id = of_match_node(rtk_restart_ids, np);
+	WARN(!of_id, "restart not available");
+
+	arm_pm_restart = of_id->data;
+
+	/* setup Reset Control */
+	np = of_find_matching_node(NULL, rtk_reset_control_ids);
+	if (WARN(!np, "Unable to setup reset-control"))
+		return 1;
+
+	rst_ctrl_base = of_iomap(np, 0);
+	WARN(!rst_ctrl_base, "failed to map IO base for reset-control");
+
+	if (of_property_read_u32_index(np, "rst-reg-offset", 0, &rst_ctrl_reg_offset)) {
+		pr_err("reset-control rst-reg-offset not defined");
+		rst_ctrl_base = NULL;
+		return 1;
+	}
+
+	printk("rst-control : base %p, offset 0x%x\n", rst_ctrl_base, rst_ctrl_reg_offset);
+	setup_restart_action(RESET_ACTION_ABNORMAL);
+
+	return 0;
+}
+
+arch_initcall(rtk_setup_restart);
+
+#if defined(CONFIG_RTK_XEN_SUPPORT) && defined(CONFIG_RTK_RPC)
+#include <xen/xen.h>
+#include <xen/xen-ops.h>
+#include <soc/realtek/rtk_ipc_shm.h>
+
+void rtk_xen_acpu_notify(int state)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+	unsigned int reg = __be32_to_cpu(readl(&ipc->xen_domu_boot_st));
+	int ret = -1, max_loop = 10;
+	if ((XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK & reg) != XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK) {
+		pr_err("[%s] Magic ERR!\n", __func__);
+		goto err;
+	}
+
+	reg = 0;
+	reg |= XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK;
+	reg |= XEN_DOMU_BOOT_ST_VERSION_SET(XEN_DOMU_BOOT_ST_VERSION);
+	reg |= XEN_DOMU_BOOT_ST_AUTHOR_SET(XEN_DOMU_BOOT_ST_AUTHOR_SCPU);
+	reg |= XEN_DOMU_BOOT_ST_STATE_SET(state);
+	writel(__cpu_to_be32(reg), &ipc->xen_domu_boot_st);
+
+	do {
+		reg = __be32_to_cpu(readl(&ipc->xen_domu_boot_st));
+		if (XEN_DOMU_BOOT_ST_AUTHOR_GET(reg) == XEN_DOMU_BOOT_ST_AUTHOR_ACPU &&
+		    XEN_DOMU_BOOT_ST_STATE_GET(reg) == XEN_DOMU_BOOT_ST_STATE_ACPU_ENTER_IDLE)
+			break;
+
+		if (max_loop-- <= 0) {
+			pr_err("[%s] Timeout waiting ACPU respond!\n", __func__);
+			goto err;
+		}
+
+		mdelay(100);
+	} while(1);
+
+	reg = 0;
+	reg |= XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK;
+	reg |= XEN_DOMU_BOOT_ST_VERSION_SET(XEN_DOMU_BOOT_ST_VERSION);
+	reg |= XEN_DOMU_BOOT_ST_AUTHOR_SET(XEN_DOMU_BOOT_ST_AUTHOR_SCPU);
+	reg |= XEN_DOMU_BOOT_ST_STATE_SET(XEN_DOMU_BOOT_ST_STATE_SCPU_WAIT_DONE);
+	writel(__cpu_to_be32(reg), &ipc->xen_domu_boot_st);
+
+	ret = 0;
+err:
+	if (ret)
+		printk("[%s] Error! xen_domu_boot_st=0x%08x\n", __func__, reg);
+	return;
+}
+
+void rtk_xen_restart_notify(void)
+{
+	rtk_xen_acpu_notify(XEN_DOMU_BOOT_ST_STATE_SCPU_RESTART);
+}
+
+void rtk_xen_power_off_notify(void)
+{
+	rtk_xen_acpu_notify(XEN_DOMU_BOOT_ST_STATE_SCPU_POWOFF);
+}
+
+static int rtk_xen_setup_restart(void)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+	unsigned int reg = 0;
+
+	if (xen_initial_domain())
+		return 0;
+
+	reg |= XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK;
+	reg |= XEN_DOMU_BOOT_ST_VERSION_SET(XEN_DOMU_BOOT_ST_VERSION);
+	reg |= XEN_DOMU_BOOT_ST_AUTHOR_SET(XEN_DOMU_BOOT_ST_AUTHOR_SCPU);
+	reg |= XEN_DOMU_BOOT_ST_STATE_SET(XEN_DOMU_BOOT_ST_STATE_SCPU_BOOT);
+	writel(__cpu_to_be32(reg), &ipc->xen_domu_boot_st);
+
+	xen_pre_restart = rtk_xen_restart_notify;
+	xen_pre_power_off = rtk_xen_power_off_notify;
+	return 0;
+}
+
+late_initcall(rtk_xen_setup_restart);
+#endif /* End of CONFIG_RTK_XEN_SUPPORT && CONFIG_RTK_RPC */
diff --git a/drivers/soc/realtek/rtd129x/rtd129x_spin_table.c b/drivers/soc/realtek/rtd129x/rtd129x_spin_table.c
new file mode 100644
index 00000000..d7050de
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtd129x_spin_table.c
@@ -0,0 +1,216 @@
+/*
+ * rtd129x_spin_table.c - boot method
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/delay.h>
+#include <linux/init.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/printk.h>
+#include <asm/cacheflush.h>
+#include <asm/cpu_ops.h>
+#include <asm/cputype.h>
+#include <asm/smp_plat.h>
+
+#include "rtd129x_cpu_hotplug.h"
+#include <soc/realtek/rtk_cpu.h>
+
+#ifdef CONFIG_SMP
+
+static u32 uboot_secondary_entry;
+
+extern void rtk_cpu_power_up(int cpu);
+extern void _rtk_cpu_power_up(int cpu);
+extern void secondary_holding_pen(void);
+
+volatile unsigned long rtk_secondary_holding_pen_release = INVALID_HWID;
+
+static phys_addr_t cpu_release_addr[NR_CPUS];
+static int cpu_hotplug[NR_CPUS] = {0};
+
+/*
+ * Write rtk_secondary_holding_pen_release in a way that is guaranteed to be
+ * visible to all observers, irrespective of whether they're taking part
+ * in coherency or not.  This is necessary for the hotplug code to work
+ * reliably.
+ */
+static void write_pen_release(u64 val)
+{
+	void *start = (void *)&rtk_secondary_holding_pen_release;
+	unsigned long size = sizeof(rtk_secondary_holding_pen_release);
+
+	rtk_secondary_holding_pen_release = val;
+	__flush_dcache_area(start, size);
+}
+
+static int smp_spin_table_cpu_init(unsigned int cpu)
+{
+	static int flag = 0;
+	struct device_node *dn;
+	struct device_node *uboot;
+
+	uboot_secondary_entry = 0x00020000;
+
+	if (flag == 0) {
+		uboot = of_find_compatible_node(NULL, NULL, "Realtek,rtk_boot");
+		if (of_property_read_u32(uboot, "resume-entry-addr", &uboot_secondary_entry)) {
+			pr_err("missing or invalid resume-entry-addr property\n");
+			return -1;
+		}
+		flag = 1;
+	}
+
+	dn = of_get_cpu_node(cpu, NULL);
+	if (!dn)
+		return -ENODEV;
+
+	/*
+	 * Determine the address from which the CPU is polling.
+	 */
+	if (of_property_read_u64(dn, "cpu-release-addr", &cpu_release_addr[cpu])) {
+		pr_err("CPU %d: missing or invalid cpu-release-addr property\n", cpu);
+		return -1;
+	}
+
+	return 0;
+}
+
+static int smp_spin_table_cpu_prepare(unsigned int cpu)
+{
+	__le64 __iomem *release_addr;
+
+	/*
+	 * The cpu-release-addr may or may not be inside the linear mapping.
+	 * As ioremap_cache will either give us a new mapping or reuse the
+	 * existing linear mapping, we can use it to cover both cases. In
+	 * either case the memory will be MT_NORMAL.
+	 */
+
+	release_addr = ioremap(cpu_release_addr[cpu], sizeof(*release_addr));
+
+	if (!release_addr)
+		return -ENOMEM;
+
+	/*
+	 * We write the release address as LE regardless of the native
+	 * endianess of the kernel. Therefore, any boot-loaders that
+	 * read this address need to convert this address to the
+	 * boot-loader's endianess before jumping. This is mandated by
+	 * the boot protocol.
+	 */
+	writel_relaxed(__pa(secondary_holding_pen), release_addr);
+
+	__flush_dcache_area((__force void *)release_addr, sizeof(*release_addr));
+
+	/*
+	 * Send an event to wake up the secondary CPU.
+	 */
+	sev();
+
+	iounmap(release_addr);
+
+	return 0;
+}
+
+static int smp_spin_table_cpu_boot(unsigned int cpu)
+{
+	if (cpu_hotplug[cpu] == 1) {
+		__le64 __iomem *release_addr;
+
+		release_addr = ioremap(cpu_release_addr[cpu], sizeof(*release_addr));
+
+		rtk_cpu_power_up(cpu);
+
+		/*
+		 * From B00, start to support TEE suspend/resume
+		 * B00 romcode: core123 resume jump address is fixed to FSBL
+		 */
+		if (get_rtd129x_cpu_revision() < RTD129x_CHIP_REVISION_B00) {
+			writel_relaxed(uboot_secondary_entry, release_addr);
+
+			mdelay(1);
+			sev();
+			mdelay(1);
+		}
+
+		_rtk_cpu_power_up(cpu);
+
+		writel_relaxed(__pa(secondary_holding_pen), release_addr);
+
+		__flush_dcache_area((__force void *)release_addr, sizeof(*release_addr));
+
+		smp_send_reschedule(cpu);
+		iounmap(release_addr);
+	}
+
+	/*
+	 * Update the pen release flag.
+	 */
+	write_pen_release(cpu_logical_map(cpu));
+
+	/*
+	 * Send an event, causing the secondaries to read pen_release.
+	 */
+
+	sev();
+	return 0;
+}
+
+#ifdef CONFIG_HOTPLUG_CPU
+static int smp_spin_table_cpu_disable(unsigned int cpu)
+{
+	if (!cpu_release_addr[cpu])
+		return -EOPNOTSUPP;
+
+	return 0;
+}
+
+static void smp_spin_table_cpu_die(unsigned int cpu)
+{
+	/*
+	 * From B00, start to support TEE suspend/resume
+	 * Set the fake core0 resume address to BL31 to let Bl31 know slave cpu will resume
+	 */
+	if (get_rtd129x_cpu_revision() >= RTD129x_CHIP_REVISION_B00) {
+		asm volatile("isb" : : : "cc");
+		asm volatile("ldr x1, =0x20000" : : : "cc");
+		asm volatile("ldr x0, =0x8400ff04" : : : "cc"); //RTK_SET_KERNEL_REUMSE_ENTRY
+		asm volatile("isb" : : : "cc");
+		asm volatile("smc #0" : : : "cc");
+		asm volatile("isb" : : : "cc");
+	}
+
+	cpu_hotplug[cpu] = 1;
+	flush_cache_all();
+	setup_mm_for_reboot();
+	cpu_do_lowpower(cpu_release_addr[cpu]);
+}
+#endif
+
+const struct cpu_operations rtk_smp_spin_table_ops = {
+	.name = "rtk-spin-table",
+	.cpu_init = smp_spin_table_cpu_init,
+	.cpu_prepare = smp_spin_table_cpu_prepare,
+	.cpu_boot = smp_spin_table_cpu_boot,
+#ifdef CONFIG_HOTPLUG_CPU
+	.cpu_disable = smp_spin_table_cpu_disable,
+	.cpu_die = smp_spin_table_cpu_die,
+#endif
+};
+
+#endif /* CONFIG_SMP */
diff --git a/drivers/soc/realtek/rtd129x/rtd129x_suspend.c b/drivers/soc/realtek/rtd129x/rtd129x_suspend.c
new file mode 100755
index 00000000..2f4f33e
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtd129x_suspend.c
@@ -0,0 +1,1678 @@
+/*
+ * rtd129x_suspend.c - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/pm.h>
+#include <linux/suspend.h>
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/cpu.h>
+#include <linux/delay.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/reboot.h>
+#include <linux/clocksource.h>
+#include <linux/clockchips.h>
+#include <linux/cpu_pm.h>
+#include <linux/vmalloc.h>
+#include <linux/tick.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/irqchip/arm-gic.h>
+#include <linux/cpumask.h>
+#include <asm/system_misc.h>
+#include <asm/cacheflush.h>
+#include <asm/suspend.h>
+#include <soc/realtek/memory.h>
+#include <soc/realtek/rtk_cpu.h>
+
+#include "rtd129x_suspend.h"
+
+#define DEV_NAME "RTD129x_PM"
+#define SYS_GROUP1_CK_SEL 0x98000018
+#define SYS_PLL_SCPU1 0x98000104
+#define SUSPEND_VERSION_MASK(v) ((v&0xffff) << 16)
+#define BT_WAKEUP_IGPIO(n) (0x1 << n)//n:0 to 20
+
+extern void rtk_cpu_power_down(int cpu);
+
+static int suspend_version = 2;
+static unsigned int suspend_context;
+unsigned int pm_state;
+
+/*
+wakelock count mode:
+0: original mode
+1: deep sleep mode
+*/
+unsigned int pm_wakelock_mode;
+/**
+ * some sync mechanism between kernel suspend
+ * and android wakelock control
+ */
+unsigned int pm_block_wakelock;
+
+void __iomem *RTK_CRT_BASE;
+void __iomem *RTK_AIO_BASE;
+void __iomem *RTK_ISO_BASE;
+void __iomem *RTK_TVE_BASE;
+void __iomem *RTK_SB2_BASE;
+void __iomem *RTK_MISC_BASE;
+void __iomem *RTK_GIC_DIST_BASE;
+void __iomem *RTK_CPU_WRAPPER_BASE;
+
+int RTK_CHIP_VERSION;
+
+#define rtk_suspend_shm_func(_name, _offset, _def) \
+void rtk_suspend_##_name##_set(unsigned int val) \
+{ \
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT; \
+	writel(__cpu_to_be32(SUSPEND_MAGIC_MASK | _def##_MASK(val)), \
+	&(ipc->_offset)); \
+} \
+unsigned int rtk_suspend_##_name##_get(void) \
+{ \
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT; \
+	unsigned int val = __be32_to_cpu(readl(&(ipc->_offset))); \
+	if (SUSPEND_MAGIC_GET(val) != SUSPEND_MAGIC_KEY) { \
+		pr_err("[%s] Error! val = 0x%08x\n", DEV_NAME, val); \
+		return -1; \
+	} \
+	return _def##_GET(val); \
+}
+
+rtk_suspend_shm_func(wakeup_flags, suspend_wakeup_flag, WAKEUP_FLAGS);
+rtk_suspend_shm_func(resume_state, acpu_resume_state, RESUME_STATE);
+rtk_suspend_shm_func(resume_data, acpu_resume_state, RESUME_DATA);
+rtk_suspend_shm_func(gpio_wakeup_en, gpio_wakeup_enable, GPIO_WAKEUP_EN);
+rtk_suspend_shm_func(gpio_wakeup_act, gpio_wakeup_activity, GPIO_WAKEUP_ACT);
+rtk_suspend_shm_func(gpio_out_en, gpio_output_change_enable,
+	GPIO_OUTPUT_CHANGE_EN);
+rtk_suspend_shm_func(gpio_out_act, gpio_output_change_activity,
+	GPIO_OUTPUT_CHANGE_ACT);
+rtk_suspend_shm_func(gpio_wakeup_en2, gpio_wakeup_enable2, GPIO_WAKEUP_EN2);
+rtk_suspend_shm_func(gpio_wakeup_act2, gpio_wakeup_activity2,
+	GPIO_WAKEUP_ACT2);
+rtk_suspend_shm_func(gpio_out_en2, gpio_output_change_enable2,
+	GPIO_OUTPUT_CHANGE_EN2);
+rtk_suspend_shm_func(gpio_out_act2, gpio_output_change_activity2,
+	GPIO_OUTPUT_CHANGE_ACT2);
+rtk_suspend_shm_func(timer_sec, audio_reciprocal_timer_sec,
+	AUDIO_RECIPROCAL_TIMER);
+
+
+static void hexdump(char *note, unsigned char *buf, unsigned int len)
+{
+	pr_crit("%s\n", note);
+	print_hex_dump(KERN_CONT, "", DUMP_PREFIX_OFFSET, 16, 1, buf, len,
+		false);
+}
+
+void acpu_set_flag(uint32_t flag)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	writel(__cpu_to_be32(SUSPEND_VERSION_MASK(suspend_version)),
+		&(ipc->suspend_mask));
+
+	if (suspend_version == 1)
+		writel(__cpu_to_be32(flag), &(ipc->suspend_flag));
+	else
+		writel(__cpu_to_be32(flag | AUTHOR_MASK(AUTHOR_SCPU)),
+			&(ipc->suspend_flag));
+}
+
+void notify_acpu(enum _notify_flag flag)
+{
+	pr_info("[%s] Notify ACPU, flag= %d\n", DEV_NAME, flag);
+
+	switch (flag) {
+	case NOTIFY_SUSPEND_TO_RAM:
+	case NOTIFY_SUSPEND_TO_COOLBOOT:
+	case NOTIFY_SUSPEND_TO_WFI:
+		if (suspend_version == 1) {
+			acpu_set_flag(0x000018ff);
+			return;
+		}
+		break;
+	case NOTIFY_RESUME_PLATFORM:
+		if (suspend_version == 1) {
+			acpu_set_flag(0x00000000);
+			return;
+		}
+		break;
+	default:
+		break;
+	}
+
+	if (suspend_version == 1)
+		return;
+	acpu_set_flag(NOTIFY_MASK(flag));
+}
+
+int rtk_suspend_wakeup_acpu(void)
+{
+	pr_info("[%s] Wakeup ACPU\n", DEV_NAME);
+
+	writel(0x00000000, RTK_SB2_BASE + 0x138);
+	__delay(1000);
+	writel(0x00000008, RTK_CRT_BASE + 0x328);
+	writel(0x0000ace7, RTK_CRT_BASE + 0x320);
+	writel(0x0000000c, RTK_CRT_BASE + 0x328);
+	__delay(1000);
+	return 0;
+}
+
+struct _memory_verified_handle {
+	unsigned char *memAddress;
+	size_t memByte;
+};
+
+struct _memory_verified_handle phys_wb_area[] = {
+	{(unsigned char *)0x0a000000, 0x20},
+	{(unsigned char *)0x0a001000, 0x20}
+};
+
+unsigned char memory_verified_datagen(int i)
+{
+	return (unsigned char) (i & 0xff);
+}
+
+struct _memory_verified_handle *memory_verified_handle_create(size_t byte)
+{
+	int i = 0;
+
+	struct _memory_verified_handle *handle =
+		(struct _memory_verified_handle *)
+		kmalloc(sizeof(struct _memory_verified_handle), GFP_KERNEL);
+
+	if (!handle)
+		return NULL;
+
+	/*
+	 * > 32KB : vmalloc
+	 * < 32KB : kmalloc
+	 */
+	if (byte > 0x8000)
+		handle->memAddress = vmalloc(byte);
+	else
+		handle->memAddress = kmalloc(byte, GFP_KERNEL);
+
+	if (!handle->memAddress) {
+		kfree(handle);
+		return NULL;
+	}
+
+	for (i = 0; i < byte ; i++)
+		handle->memAddress[i] = memory_verified_datagen(i);
+
+	handle->memByte = byte;
+
+	return handle;
+}
+
+int memory_verified_release(struct _memory_verified_handle *handle)
+{
+	int ret = 0, i = 0;
+	unsigned char data;
+
+	if (!handle) {
+		pr_err("[%s] handle is NULL !\n", DEV_NAME);
+		return -1;
+	}
+
+	if (!handle->memByte) {
+		ret = -2;
+		pr_info("[%s] handle %p ", DEV_NAME, (void *) handle);
+		pr_info("(memByte = %ld, memAddress = 0x%08lx)\n",
+			(long int) handle->memByte,
+			(unsigned long) handle->memAddress);
+
+		if (handle->memAddress)
+			goto free1;
+		else
+			goto free0;
+	}
+
+	for (i = 0 ; i < handle->memByte ; i++) {
+		data = memory_verified_datagen(i);
+
+		if (handle->memAddress[i] != data) {
+			pr_info("[%s] handle %p memAddress[0x%x]",
+				DEV_NAME, (void *) handle, i);
+			pr_info("=> 0x%x != 0x%x (%ld bytes at 0x%08lx)\n",
+				handle->memAddress[i], data,
+				(long int) handle->memByte,
+				(unsigned long) handle->memAddress);
+			ret = -4;
+		}
+	}
+
+	if (ret == -4) {
+		pr_err("[%s] memory phyAddt 0x%08llx\n",
+			DEV_NAME, __pa(handle->memAddress));
+		hexdump("[%s] memory verified error\n",
+			handle->memAddress, handle->memByte);
+	}
+
+free1:
+	kfree(handle->memAddress);
+free0:
+	kfree(handle);
+
+	return ret;
+}
+
+struct _memory_verified_handle *memory_writeback_handle_create(
+	struct _memory_verified_handle *phys_area)
+{
+	void *tmp_addr;
+
+	struct _memory_verified_handle *handle =
+		(struct _memory_verified_handle *)
+		kmalloc(sizeof(struct _memory_verified_handle), GFP_KERNEL);
+
+	if (!handle)
+		goto out;
+
+	handle->memAddress = kmalloc(phys_area->memByte, GFP_KERNEL);
+
+	if (!handle->memAddress) {
+		kfree(handle);
+		handle = NULL;
+		goto out;
+	}
+
+	handle->memByte = phys_area->memByte;
+	tmp_addr = phys_to_virt((phys_addr_t) phys_area->memAddress);
+	hexdump("[RTD129x_PM] Before write back dump:",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+	memcpy(handle->memAddress, tmp_addr, phys_area->memByte);
+	__flush_dcache_area(handle->memAddress, phys_area->memByte);
+out:
+	return handle;
+}
+
+int memory_writeback_release(struct _memory_verified_handle *handle,
+	struct _memory_verified_handle *phys_area)
+{
+	int ret = 0;
+	void *tmp_addr;
+
+	if (!handle) {
+		ret = -1;
+		goto out;
+	}
+
+	if (!handle->memAddress) {
+		ret = -1;
+		goto free_out;
+	}
+
+	tmp_addr = phys_to_virt((phys_addr_t)phys_area->memAddress);
+	hexdump("[RTD129x_PM] Resume back dump:**********************",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+	memcpy(tmp_addr, handle->memAddress, handle->memByte);
+	__flush_dcache_area(tmp_addr, phys_area->memByte);
+	hexdump("[RTD129x_PM] After write back dump:",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+
+	kfree(handle->memAddress);
+
+free_out:
+	kfree(handle);
+out:
+	return ret;
+}
+
+int rtk_suspend_valid(suspend_state_t state)
+{
+	return state == PM_SUSPEND_MEM || state == PM_SUSPEND_STANDBY;
+}
+
+static int notrace rtk_iso_suspend(unsigned long param)
+{
+	enum _suspend_mode mode = (enum _suspend_mode)param;
+	int max_count = 100;
+	int i = 0;
+
+	pr_info("[%s] Flush Cache ...\n", DEV_NAME);
+
+	flush_cache_all();
+
+#ifdef CONFIG_SMP
+	dsb(ishst);
+	sev();
+#endif
+
+	pr_info("[%s] Ready to Suspend ! (mode:%d)", DEV_NAME, mode);
+
+	if (mode == SUSPEND_TO_COOLBOOT)
+		notify_acpu(NOTIFY_SUSPEND_TO_COOLBOOT);
+	else if (mode == SUSPEND_TO_RAM) {
+		notify_acpu(NOTIFY_SUSPEND_TO_RAM);
+	} else {
+		pr_err("[%s] Suspend Mode Not Support : %d\n", DEV_NAME, mode);
+		BUG();
+	}
+
+	for (i = max_count; i > 0 ; i--)
+		__delay(10000000);
+
+	BUG();
+
+	return  -EINVAL;
+}
+
+enum irq_report_state {
+	IRQ_REPORT_PREPARE,
+	IRQ_REPORT_PRINT,
+};
+
+static void rtk_suspend_irq_report(enum irq_report_state state)
+{
+	int i;
+	int j;
+	int irq;
+	unsigned int mask;
+	unsigned int temp;
+	static unsigned int data[32];
+	void __iomem *irq_state = RTK_GIC_DIST_BASE + 0x200;
+
+	switch (state) {
+	case IRQ_REPORT_PREPARE:
+		for (i = 0 ; i < 32 ; i++)
+			data[i] = *(unsigned int *)
+				(irq_state + (i * 4));
+		break;
+	case IRQ_REPORT_PRINT:
+		for (i = 0 ; i < 32 ; i++) {
+			irq = i * 32;
+			temp = *(unsigned int *)(irq_state + (i * 4));
+			if (temp != data[i]) {
+				pr_warn("[%s] Interrupt Addr:0x%08lx State: 0x%08x",
+					DEV_NAME,
+					(unsigned long)(irq_state + (i * 4)),
+					data[i]);
+				pr_warn(" => 0x%08x\n", temp);
+
+				for (j = 0 ; j < 32 ; j++) {
+					mask = 0x1U << j;
+					if (mask & temp)
+						pr_warn("[%s] IRQ: %d\n",
+							DEV_NAME, (irq + j));
+				}
+			}
+		}
+		break;
+	default:
+		pr_err("[%s] Unknow CMD! %d\n", DEV_NAME, state);
+	}
+}
+
+static int rtk_suspend_to_wfi(void)
+{
+	void __iomem *reg_sel = ioremap(SYS_GROUP1_CK_SEL, 0x4);
+	void __iomem *reg_pll = ioremap(SYS_PLL_SCPU1, 0x4);
+
+	notify_acpu(NOTIFY_SUSPEND_TO_WFI);
+
+	rtk_suspend_irq_report(IRQ_REPORT_PREPARE);
+
+	/* switch clk_scpu to osc (27 MHz) */
+	pr_info("[%s] switch scpu_clk to osc\n", DEV_NAME);
+	writel(readl(reg_sel) | 0x4, reg_sel);
+
+	/* disable pll_scpu*/
+	pr_info("[%s] disable scpu_pll\n", DEV_NAME);
+	writel(0x4, reg_pll);
+
+	pr_info("[%s] wait for interrupt\n", DEV_NAME);
+
+	asm("WFI");
+
+	/* enable pll_scpu, delay to wait it stable */
+	pr_info("[%s] enable scpu_pll\n", DEV_NAME);
+	writel(0x3, reg_pll);
+	__delay(100);
+
+	/* NOTE: ACPU also set SYS_GROUP1_CK_SEL later */
+	pr_info("[%s] switch scpu_clk to scpu_pll\n", DEV_NAME);
+	writel(readl(reg_sel) & ~0x4, reg_sel);
+
+	iounmap(reg_pll);
+	iounmap(reg_sel);
+
+	rtk_suspend_irq_report(IRQ_REPORT_PRINT);
+
+	return 0;
+}
+
+
+static int rtk_suspend_to_ram(void)
+{
+	const int  MEM_VERIFIED_CNT = 20;
+	int ret = 0;
+	int i = 0;
+	int size_tmp1 = 0;
+	int size_tmp2 = 0;
+	int size_tmp3 = 0;
+	struct _memory_verified_handle *mem_vhandle[MEM_VERIFIED_CNT];
+	struct _memory_verified_handle **mem_wbhandle;
+	void __iomem *resumeAddr = RTK_ISO_BASE + 0x54;
+	unsigned int ISODummy1Data = readl(resumeAddr);
+
+	pr_info("[%s] CPU Resume vaddr: 0x%08lx paddr: 0x%08lx\n",
+		DEV_NAME, (unsigned long)cpu_resume,
+		(unsigned long)__pa(cpu_resume));
+
+	hexdump("CPU Resume Entry Dump:",
+		(unsigned char *) cpu_resume, 0x100);
+
+	/*
+	 * From B00, start to support TEE suspend/resume
+	 * B00 romcode: core0 resume jump address is fixed to FSBL.
+	 */
+	if (RTD129x_CHIP_REVISION_B00 <= RTK_CHIP_VERSION) {
+		asm volatile("isb" : : : "cc");
+		asm volatile("mov x1, %0" : : "r" (__pa(cpu_resume)) : "cc");
+		/* RTK_SET_KERNEL_REUMSE_ENTRY */
+		asm volatile("ldr x0, =0x8400ff04" : : : "cc");
+		asm volatile("isb" : : : "cc");
+		asm volatile("smc #0" : : : "cc");
+		asm volatile("isb" : : : "cc");
+	} else {
+		writel(__pa(cpu_resume), resumeAddr);
+	}
+
+	BUG_ON(!irqs_disabled());
+
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		mem_vhandle[i] = memory_verified_handle_create(0x4000);
+
+	size_tmp1 = sizeof(phys_wb_area);
+	size_tmp2 = sizeof(struct _memory_verified_handle);
+	size_tmp3 = sizeof(struct _memory_verified_handle *);
+	mem_wbhandle = kmalloc(size_tmp1 / size_tmp2 * size_tmp3, GFP_KERNEL);
+	if (mem_wbhandle) {
+		for (i = 0 ; i < (size_tmp1 / size_tmp2) ; i++)
+			mem_wbhandle[i] = memory_writeback_handle_create(
+					&phys_wb_area[i]);
+	}
+
+	ret = cpu_suspend((unsigned long)SUSPEND_TO_RAM, rtk_iso_suspend);
+
+	if (ret)
+		return ret;
+
+	/* Restore iso dummy data */
+	writel(ISODummy1Data, resumeAddr);
+
+	writel(readl(RTK_ISO_BASE + 0x0418) | BIT(0), RTK_ISO_BASE + 0x0418);
+	writel(readl(RTK_ISO_BASE + 0x0410) & ~BIT(10), RTK_ISO_BASE + 0x0410);
+
+	rtk_suspend_irq_report(IRQ_REPORT_PRINT);
+
+	rtk_suspend_wakeup_acpu();
+
+	flush_cache_all();
+
+	mdelay(5);
+
+	pr_info("[%s] Resume Memory Verifying ... State 0\n", DEV_NAME);
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		memory_verified_release(mem_vhandle[i]);
+
+
+	pr_info("[%s] Resume Memory Verifying ... State 1\n", DEV_NAME);
+	for (i = 0 ; i < MEM_VERIFIED_CNT; i++)
+		mem_vhandle[i] = memory_verified_handle_create(0x4000);
+
+	for (i = 0; i < MEM_VERIFIED_CNT; i++)
+		memory_verified_release(mem_vhandle[i]);
+
+	if (mem_wbhandle) {
+		for (i = 0 ; i < (size_tmp1 / size_tmp2) ; i++)
+			memory_writeback_release(
+				mem_wbhandle[i], &phys_wb_area[i]);
+		kfree(mem_wbhandle);
+	}
+
+#ifdef CONFIG_SMP
+	dsb(ishst);
+	sev();
+#endif
+
+	return ret;
+}
+
+static int rtk_suspend_to_coolboot(void)
+{
+	int ret = 0;
+
+	ret = cpu_suspend((unsigned long)SUSPEND_TO_COOLBOOT, rtk_iso_suspend);
+	return ret;
+}
+
+void rtk_suspend_gpip_output_change_suspend(void)
+{
+	int i = 0;
+	unsigned int val;
+	unsigned int mask;
+	int tmp;
+
+	/* IGPIO0 ~ IGPIO23 */
+	val = rtk_suspend_gpio_out_en_get();
+	for (i = 0 ; i < GPIO_OUTPUT_CHANGE_EN_BITS ; i++) {
+		mask = 0x1U << i;
+
+		if (!(val & mask))
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			(rtk_suspend_gpio_out_act_get() & mask) ?
+			"HIGH" : "LOW");
+		tmp = (rtk_suspend_gpio_out_act_get() & mask) ? 1 : 0;
+		gpio_direction_output(i + SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+
+	/* IGPIO24 ~ IGPIO34 */
+	val = rtk_suspend_gpio_out_en2_get();
+	i = GPIO_OUTPUT_CHANGE_EN_BITS;
+	for (; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		mask = 0x1U << (i-GPIO_OUTPUT_CHANGE_EN_BITS);
+
+		if (!(val & mask))
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			(rtk_suspend_gpio_out_act2_get() & mask) ?
+			"HIGH" : "LOW");
+		tmp = (rtk_suspend_gpio_out_act2_get() & mask) ? 1 : 0;
+		gpio_direction_output(i+SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+}
+
+void rtk_suspend_gpip_output_change_resume(void)
+{
+	int i = 0;
+	unsigned int val;
+	unsigned int mask;
+	int tmp;
+
+	/* IGPIO0 ~ IGPIO23 */
+	val = rtk_suspend_gpio_out_en_get();
+	for (i = 0 ; i < GPIO_OUTPUT_CHANGE_EN_BITS ; i++) {
+		mask = 0x1U << i;
+
+		if (!(val & mask))
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			(rtk_suspend_gpio_out_act_get() & mask) ?
+			"LOW" : "HIGH");
+		tmp = (rtk_suspend_gpio_out_act_get() & mask) ? 0 : 1;
+		gpio_direction_output(i + SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+
+	/* IGPIO24 ~ IGPIO34 */
+	val = rtk_suspend_gpio_out_en2_get();
+	i = GPIO_OUTPUT_CHANGE_EN_BITS;
+	for (; i < SUSPEND_ISO_GPIO_SIZE ; i++) {
+		mask = 0x1U << (i-GPIO_OUTPUT_CHANGE_EN_BITS);
+
+		if (!(val & mask))
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			(rtk_suspend_gpio_out_act2_get() & mask) ?
+			"LOW" : "HIGH");
+		tmp = (rtk_suspend_gpio_out_act2_get() & mask) ? 0 : 1;
+		gpio_direction_output(i + SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+}
+
+static void rtk_suspend_cpu_pwr_down(void) {
+	unsigned int cpu = 1;
+
+	for (cpu = 1 ; cpu < NR_CPUS ; cpu++) {
+		rtk_cpu_power_down(cpu);
+	}
+}
+
+static int rtk_suspend_enter(suspend_state_t suspend_state)
+{
+	int ret = 0;
+
+	pr_info("[%s] Platform Suspend Enter ...\n", DEV_NAME);
+
+	rtk_suspend_cpu_pwr_down();
+
+	if (!rtk_suspend_valid(suspend_state)) {
+		pr_err("[%s] suspend_state:%d not support !\n",
+			DEV_NAME, (int) suspend_state);
+		return  -EINVAL;
+	}
+
+	switch (suspend_state) {
+	case PM_SUSPEND_STANDBY:
+		ret = rtk_suspend_to_wfi();
+
+		suspend_context++;
+
+		pr_info("[%s] Platform Resume ...\n", DEV_NAME);
+		notify_acpu(NOTIFY_RESUME_PLATFORM);
+		break;
+	case PM_SUSPEND_MEM:
+		rtk_suspend_gpip_output_change_suspend();
+
+		ret = rtk_suspend_to_ram();
+
+		suspend_context++;
+
+		if (ret) {
+			pr_err("[%s] ERROR ! to suspend! (%d)\n",
+				DEV_NAME, ret);
+			BUG();
+			break;
+		}
+
+		pr_info("[%s] Platform Resume ...\n", DEV_NAME);
+
+		notify_acpu(NOTIFY_RESUME_PLATFORM);
+		rtk_suspend_gpip_output_change_resume();
+
+		break;
+	default:
+		ret = -EINVAL;
+		break;
+	}
+
+	return  ret;
+}
+
+static int rtk_suspend_begin(suspend_state_t suspend_state)
+{
+	pr_info("[%s] Suspend Begin\n", DEV_NAME);
+
+	if (!rtk_suspend_valid(suspend_state)) {
+		pr_err("[%s] suspend_state:%d not Support!\n",
+			DEV_NAME, (int) suspend_state);
+		return -EINVAL;
+	}
+
+	switch (suspend_state) {
+	case PM_SUSPEND_STANDBY:
+		cpu_idle_poll_ctrl(true);
+		break;
+	case PM_SUSPEND_MEM:
+		cpu_idle_poll_ctrl(true);
+		break;
+	default:
+		return  -EINVAL;
+	}
+
+	return 0;
+}
+
+static void rtk_suspend_end(void)
+{
+	pr_info("[%s] Suspend End\n", DEV_NAME);
+
+	notify_acpu(NOTIFY_RESUME_END);
+	cpu_idle_poll_ctrl(false);
+}
+
+const struct platform_suspend_ops rtk_suspend_ops = {
+	.begin = rtk_suspend_begin,
+	.end = rtk_suspend_end,
+	.enter = rtk_suspend_enter,
+	.valid = rtk_suspend_valid,
+};
+
+static void rtk_poweroff(void)
+{
+	pr_info("[%s] Power off\n", DEV_NAME);
+
+	rtk_suspend_to_coolboot();
+
+	return;
+};
+
+static void rtk_gpio_init_wu(struct device_node *nd)
+{
+	const u32 *prop_en;
+	const u32 *prop_act;
+	int wu_gpio_en = 0;
+	int wu_gpio_act = 0;
+	int wu_gpio_list = 0;
+	int en;
+	int act;
+	int wu_gpio;
+	int gpio_iso_num;
+	int tmp;
+	unsigned int val;
+	int i = 0;
+
+	wu_gpio_list = of_gpio_named_count(nd, "wakeup-gpio-list");
+	prop_en = of_get_property(nd, "wakeup-gpio-enable", &wu_gpio_en);
+	prop_act = of_get_property(nd, "wakeup-gpio-activity", &wu_gpio_act);
+	wu_gpio_en  /= sizeof(u32);
+	wu_gpio_act /= sizeof(u32);
+
+	pr_info("[%s] wakeup-gpio Cnt: en(%d) act(%d) list(%d)\n",
+		DEV_NAME, wu_gpio_en, wu_gpio_act, wu_gpio_list);
+
+	if (wu_gpio_en != 0 && (wu_gpio_en == wu_gpio_act)
+		&& (wu_gpio_act == wu_gpio_list)) {
+
+		for (i = 0 ; i < wu_gpio_list ; i++) {
+			en  = of_read_number(prop_en, 1 + i);
+			act = of_read_number(prop_act, 1 + i);
+			wu_gpio = of_get_named_gpio(nd, "wakeup-gpio-list", i);
+			gpio_iso_num = wu_gpio - SUSPEND_ISO_GPIO_BASE;
+
+			if (!en) {
+				pr_err("[%s] wakeup-gpio[%d] States is disable!",
+					DEV_NAME, i);
+				pr_err(" (en:%d act:%d gpio:%d)\n",
+					en, act, wu_gpio);
+				continue;
+			}
+
+			tmp = gpio_iso_num < 0 || gpio_iso_num;
+			if (tmp >= SUSPEND_ISO_GPIO_SIZE) {
+				pr_err("[%s] wakeup-gpio[%d] Out of iso range!",
+					DEV_NAME, i);
+
+				pr_err(" (en:%d act:%d gpio:%d)\n",
+					en, act, wu_gpio);
+				continue;
+			}
+
+			if (gpio_request(wu_gpio, nd->name)) {
+				pr_err("[%s] wakeup-gpio[%d] Request failed!",
+					DEV_NAME, i);
+				pr_err(" (en:%d act:%d gpio:%d)\n",
+					en, act, wu_gpio);
+			} else {
+				gpio_free(wu_gpio);
+			}
+
+			pr_info("[%s] wakeup-gpio[%d] Successful registration!",
+				DEV_NAME, i);
+			pr_info(" (en:%d act:%d gpio:%d)\n",
+				en, act, wu_gpio);
+
+			/* IGPIO0 ~ IGPIO23 */
+			if (gpio_iso_num < GPIO_WAKEUP_EN_BITS) {
+				val = rtk_suspend_gpio_wakeup_en_get();
+				tmp = gpio_iso_num;
+				val = en ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_wakeup_en_set(val);
+
+				val = rtk_suspend_gpio_wakeup_act_get();
+				tmp = gpio_iso_num;
+				val = act ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_wakeup_act_set(val);
+			} else {
+				/* IGPIO24 ~ IGPIO34 */
+				val = rtk_suspend_gpio_wakeup_en2_get();
+				tmp = (gpio_iso_num - GPIO_WAKEUP_EN_BITS);
+				val = en ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_wakeup_en2_set(val);
+
+				val = rtk_suspend_gpio_wakeup_act2_get();
+				tmp = (gpio_iso_num - GPIO_WAKEUP_EN_BITS);
+				val = act ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_wakeup_act2_set(val);
+			}
+		}
+	}
+}
+
+static void rtk_gpio_init_out(struct device_node *nd)
+{
+	const u32 *prop_en;
+	const u32 *prop_act;
+	int out_gpio_en = 0;
+	int out_gpio_act = 0;
+	int out_gpio_list = 0;
+	int en;
+	int act;
+	int gpio_iso_num;
+	int output_change_gpio;
+	int tmp;
+	unsigned int val;
+	int i = 0;
+
+	out_gpio_list = of_gpio_named_count(nd, "gpio-output-change-list");
+	prop_en = of_get_property(nd, "gpio-output-change-enable",
+		&out_gpio_en);
+	prop_act = of_get_property(nd, "gpio-output-change-activity",
+		&out_gpio_act);
+	out_gpio_en /= sizeof(u32);
+	out_gpio_act /= sizeof(u32);
+
+	pr_info("[%s] gpio-output-change Cnt: en(%d) act(%d) list(%d)\n",
+			DEV_NAME, out_gpio_en, out_gpio_act, out_gpio_list);
+
+	if (out_gpio_en != 0 && (out_gpio_en == out_gpio_act)
+		&& (out_gpio_act == out_gpio_list)) {
+
+		for (i = 0 ; i < out_gpio_list ; i++) {
+			en  = of_read_number(prop_en, 1 + i);
+			act = of_read_number(prop_act, 1 + i);
+			output_change_gpio = of_get_named_gpio(nd,
+				"gpio-output-change-list", i);
+			gpio_iso_num = output_change_gpio -
+				SUSPEND_ISO_GPIO_BASE;
+
+			if (!en) {
+				pr_warn("[%s] gpio-output-change[%d]",
+					DEV_NAME, i);
+				pr_warn(" States is disable! ");
+				pr_warn("(en:%d act:%d gpio:%d)\n",
+					en, act, output_change_gpio);
+				continue;
+			}
+
+			if (gpio_iso_num < 0 ||
+				gpio_iso_num >= SUSPEND_ISO_GPIO_SIZE) {
+				pr_err("[%s] gpio-output-change[%d]",
+					DEV_NAME, i);
+				pr_err(" Out of iso range! ");
+				pr_err("(en:%d act:%d gpio:%d)\n",
+					en, act, output_change_gpio);
+				continue;
+			}
+
+			if (gpio_request(output_change_gpio, nd->name)) {
+				pr_err("[%s] gpio-output-change[%d]",
+					DEV_NAME, i);
+				pr_err(" Request failed! ");
+				pr_err("(en:%d act:%d gpio:%d)\n",
+					en, act, output_change_gpio);
+			} else {
+				gpio_free(output_change_gpio);
+			}
+
+			pr_info("[%s] gpio-output-change[%d]",
+				DEV_NAME, i);
+			pr_info(" Successful registration! ");
+			pr_info("(en:%d act:%d gpio:%d)\n",
+				en, act, output_change_gpio);
+
+			/* IGPIO0 ~ IGPIO23 */
+			if (gpio_iso_num < GPIO_OUTPUT_CHANGE_EN_BITS) {
+				val = rtk_suspend_gpio_out_en_get();
+				tmp = gpio_iso_num;
+				val = en ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_out_en_set(val);
+
+				val = rtk_suspend_gpio_out_act_get();
+				tmp = gpio_iso_num;
+				val = act ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_out_act_set(val);
+			} else {
+				/* IGPIO24 ~ IGPIO34 */
+				val = rtk_suspend_gpio_out_en2_get();
+				tmp = gpio_iso_num -
+					GPIO_OUTPUT_CHANGE_EN_BITS;
+				val = en ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_out_en2_set(val);
+
+				val = rtk_suspend_gpio_out_act2_get();
+				tmp = gpio_iso_num -
+					GPIO_OUTPUT_CHANGE_EN_BITS;
+				val = act ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_out_act2_set(val);
+			}
+		}
+	}
+}
+
+static void rtk_gpio_init(struct device_node *nd)
+{
+	rtk_gpio_init_wu(nd);
+	rtk_gpio_init_out(nd);
+}
+
+int __init rtk_suspend_init(void)
+{
+	struct device_node *p_suspend_nd = NULL;
+	struct device_node *p_gic_nd = NULL;
+	struct device_node *p_cpu_wrapper_nd = NULL;
+	const u32 *prop;
+	int size;
+	int temp;
+
+	acpu_set_flag(0x00000000);
+	rtk_suspend_wakeup_flags_set(0);
+	rtk_suspend_resume_state_set(RESUME_NONE);
+	rtk_suspend_resume_data_set(0);
+	rtk_suspend_gpio_wakeup_en_set(0);
+	rtk_suspend_gpio_wakeup_act_set(0);
+	rtk_suspend_gpio_out_en_set(0);
+	rtk_suspend_gpio_out_act_set(0);
+	rtk_suspend_gpio_wakeup_en2_set(0);
+	rtk_suspend_gpio_wakeup_act2_set(0);
+	rtk_suspend_gpio_out_en2_set(0);
+	rtk_suspend_gpio_out_act2_set(0);
+	rtk_suspend_timer_sec_set(0);
+
+	pr_info("[%s] Initial Power Management Driver\n", DEV_NAME);
+
+	p_suspend_nd =
+		of_find_compatible_node(NULL, NULL, "Realtek,power-management");
+	p_gic_nd =
+		of_find_compatible_node(NULL, NULL, "arm,cortex-a15-gic");
+	p_cpu_wrapper_nd =
+		of_find_compatible_node(NULL, NULL, "Realtek,rtk-scpu_wrapper");
+
+	RTK_CPU_WRAPPER_BASE = of_iomap(p_cpu_wrapper_nd, 0);
+	RTK_GIC_DIST_BASE = of_iomap(p_gic_nd, 0);
+	RTK_CRT_BASE = of_iomap(p_suspend_nd, 0);
+	RTK_AIO_BASE = of_iomap(p_suspend_nd, 1);
+	RTK_ISO_BASE = of_iomap(p_suspend_nd, 2);
+	RTK_TVE_BASE = of_iomap(p_suspend_nd, 3);
+	RTK_SB2_BASE = of_iomap(p_suspend_nd, 4);
+	RTK_MISC_BASE = of_iomap(p_suspend_nd, 5);
+
+	RTK_CHIP_VERSION = get_rtd129x_cpu_revision();
+
+	if (p_suspend_nd && of_device_is_available(p_suspend_nd)) {
+
+		rtk_gpio_init(p_suspend_nd);
+
+		/* wakeup flags */
+		prop = of_get_property(p_suspend_nd, "wakeup-flags", &size);
+		if (prop) {
+			temp = of_read_number(prop, 1);
+			if (temp < 0) {
+				pr_err("[%s] Set wakeup-flags error! 0x%x\n",
+					DEV_NAME, temp);
+				rtk_suspend_wakeup_flags_set(
+#ifdef CONFIG_RTK_IR
+					fWAKEUP_ON_IR |
+#endif
+					fWAKEUP_ON_GPIO |
+					fWAKEUP_ON_ALARM | fWAKEUP_ON_CEC);
+				pr_info("[%s] wakeup flags set default : 0x%x\n",
+					DEV_NAME,
+					rtk_suspend_wakeup_flags_get());
+			} else {
+				rtk_suspend_wakeup_flags_set(temp);
+				pr_info("[%s] Set set wakeup-flags = 0x%x\n",
+					DEV_NAME,
+					rtk_suspend_wakeup_flags_get());
+			}
+		} else {
+			rtk_suspend_wakeup_flags_set(
+#ifdef CONFIG_RTK_IR
+			fWAKEUP_ON_IR |
+#endif
+			fWAKEUP_ON_GPIO |
+				fWAKEUP_ON_ALARM | fWAKEUP_ON_CEC);
+			pr_info("[%s] Wakeup Flags Set Default : 0x%x\n",
+				DEV_NAME, rtk_suspend_wakeup_flags_get());
+		}
+	}
+
+	suspend_set_ops(&rtk_suspend_ops);
+
+	if (of_device_is_system_power_controller(p_suspend_nd)) {
+		if (!pm_power_off) {
+			pr_info("[%s] as system-power-controller\n", DEV_NAME);
+			pm_power_off = rtk_poweroff;
+		} else {
+			pr_warn("[%s] pm_power_off is already defined\n",
+				DEV_NAME);
+		}
+	}
+
+	return 0;
+}
+
+subsys_initcall(rtk_suspend_init);
+
+#ifdef CONFIG_SYSFS
+#define RTK_SUSPEND_ATTR(_name) \
+{ \
+	.attr = {.name = #_name, .mode = 0644}, \
+	.show =  rtk_suspend_##_name##_show, \
+	.store = rtk_suspend_##_name##_store, \
+}
+
+static enum _suspend_wakeup rtk_suspend_decode_wakeup(const char *buf,
+	size_t n)
+{
+	const char *const *s;
+	char *p;
+	int len;
+	int i;
+
+	p = memchr(buf, '\n', n);
+	len = p ? p - buf : n;
+
+	for (i = 0 ; i < eWAKEUP_ON_MAX ; i++) {
+		s = &rtk_suspend_wakeup_states[i];
+		if (*s && len == strlen(*s) && !strncmp(buf, *s, len))
+			return i;
+	}
+
+	return eWAKEUP_ON_MAX;
+}
+
+static ssize_t rtk_suspend_wakeup_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val = rtk_suspend_wakeup_flags_get();
+
+	for (i = 0 ; i < eWAKEUP_ON_MAX ; i++) {
+
+		if (val & (0x1U << i))
+			n += sprintf(buf + n, " * ");
+		else
+			n += sprintf(buf + n, "   ");
+		n += sprintf(buf + n, "%s\n", rtk_suspend_wakeup_states[i]);
+	}
+	n += sprintf(buf + n, "\n");
+	return n;
+}
+
+static ssize_t rtk_suspend_wakeup_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	enum _suspend_wakeup wakeup = rtk_suspend_decode_wakeup(buf, count);
+
+	if (wakeup < eWAKEUP_ON_MAX) {
+		rtk_suspend_wakeup_flags_set(
+			rtk_suspend_wakeup_flags_get() ^ (0x1U << wakeup));
+		return count;
+	}
+	return -ENOMEM;
+}
+
+static ssize_t rtk_suspend_resume_state_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int n = 0;
+	unsigned int val = rtk_suspend_resume_state_get();
+
+	if (val >= RESUME_MAX_STATE) {
+		n += sprintf(buf + n, "(not ready)\n");
+		goto done;
+	}
+
+	if (val == RESUME_GPIO)
+		n += sprintf(buf + n, " %s %d\n",
+			rtk_suspend_resume_states[val],
+			rtk_suspend_resume_data_get() + SUSPEND_ISO_GPIO_BASE);
+	else
+		n += sprintf(buf + n, " %s %d\n",
+			rtk_suspend_resume_states[val],
+			rtk_suspend_resume_data_get());
+
+done:
+	n += sprintf(buf + n, " (write reset => change state to 'none')\n");
+	return n;
+}
+
+static ssize_t rtk_suspend_resume_state_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	const char *const s = "reset";
+	char *p;
+	int len;
+
+	p = memchr(buf, '\n', count);
+
+	len = p ? p - buf : count;
+
+	if (s && len == strlen(s) && !strncmp(buf, s, len))
+		rtk_suspend_resume_state_set(RESUME_NONE);
+
+	return count;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_en_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val;
+	unsigned int val2;
+
+	val = rtk_suspend_gpio_wakeup_en_get();
+	val2 = rtk_suspend_gpio_wakeup_en2_get();
+
+	if ((val == -1U) && (val2 == -1U))
+		return sprintf(buf, "(not ready)\n");
+
+	n += sprintf(buf + n, " En | GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < GPIO_WAKEUP_EN_BITS ; i++) {
+		if (val == -1U)
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (val & (0x1U << i))
+			n += sprintf(buf + n, "  * | %d\n", i);
+		else
+			n += sprintf(buf + n, "	| %d\n", i);
+	}
+
+	for (i = 0 ; i < GPIO_WAKEUP_EN2_BITS ; i++) {
+		if (val2 == -1U)
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_EN_BITS);
+		else if (val2 & (0x1U << i))
+			n += sprintf(buf + n, "  * | %d\n",
+				i + GPIO_WAKEUP_EN_BITS);
+		else
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_EN_BITS);
+	}
+	n += sprintf(buf + n, "\n");
+	return n;
+
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_en_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#endif
+
+	if (val < GPIO_WAKEUP_EN_BITS)
+		rtk_suspend_gpio_wakeup_en_set(
+			rtk_suspend_gpio_wakeup_en_get() ^ (0x1U << val));
+	else
+		rtk_suspend_gpio_wakeup_en2_set(
+			rtk_suspend_gpio_wakeup_en2_get() ^ (0x1U <<
+			(val-GPIO_WAKEUP_EN_BITS)));
+
+	return count;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_act_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val;
+	unsigned int val2;
+
+	val = rtk_suspend_gpio_wakeup_act_get();
+	val2 = rtk_suspend_gpio_wakeup_act2_get();
+
+	if ((val == -1U) && (val2 == -1U))
+		return sprintf(buf, "(not ready)\n");
+
+	n += sprintf(buf + n, " Act| GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < GPIO_WAKEUP_ACT_BITS ; i++) {
+		if (val == -1U)
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (!(rtk_suspend_gpio_wakeup_en_get() & (0x1U << i)))
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (val & (0x1U << i))
+			n += sprintf(buf + n, "  H | %d\n", i);
+		else
+			n += sprintf(buf + n, "  L | %d\n", i);
+	}
+
+	for (i = 0 ; i < GPIO_WAKEUP_ACT2_BITS ; i++) {
+		if (val2 == -1U)
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_ACT_BITS);
+		else if (!(rtk_suspend_gpio_wakeup_en2_get() & (0x1U << i)))
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_ACT_BITS);
+		else if (val2 & (0x1U << i))
+			n += sprintf(buf + n, "  H | %d\n",
+				i + GPIO_WAKEUP_ACT_BITS);
+		else
+			n += sprintf(buf + n, "  L | %d\n",
+				i + GPIO_WAKEUP_ACT_BITS);
+	}
+	n += sprintf(buf + n, "\n");
+
+	return n;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_act_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+	int tmp;
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#endif
+
+	if (val < GPIO_WAKEUP_ACT_BITS) {
+		tmp = (0x1U << val);
+		if (rtk_suspend_gpio_wakeup_en_get() & tmp)
+			rtk_suspend_gpio_wakeup_act_set(
+				rtk_suspend_gpio_wakeup_act_get() ^ tmp);
+	} else {
+		tmp = (0x1U << (val - GPIO_WAKEUP_ACT_BITS));
+		if (rtk_suspend_gpio_wakeup_en2_get() & tmp) {
+			rtk_suspend_gpio_wakeup_act2_set(
+				rtk_suspend_gpio_wakeup_act2_get() ^
+				(0x1U << (val-GPIO_WAKEUP_ACT_BITS)));
+		}
+	}
+
+	return count;
+}
+
+static ssize_t rtk_suspend_gpio_out_en_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val;
+	unsigned int val2;
+
+	val = rtk_suspend_gpio_out_en_get();
+	val2 = rtk_suspend_gpio_out_en2_get();
+
+	if ((val == -1U) && (val2 == -1U))
+		return sprintf(buf, "(not ready)\n");
+
+	n += sprintf(buf + n, " En | GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < GPIO_OUTPUT_CHANGE_EN_BITS ; i++) {
+		if (val == -1U)
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (val & (0x1U << i))
+			n += sprintf(buf + n, "  * | %d\n", i);
+		else
+			n += sprintf(buf + n, "	| %d\n", i);
+	}
+
+	for (i = 0 ; i < GPIO_OUTPUT_CHANGE_EN2_BITS ; i++) {
+		if (val2 == -1U)
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_OUTPUT_CHANGE_EN_BITS);
+		else if (val2 & (0x1U << i))
+			n += sprintf(buf + n, "  * | %d\n",
+				i + GPIO_OUTPUT_CHANGE_EN_BITS);
+		else
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_OUTPUT_CHANGE_EN_BITS);
+	}
+	n += sprintf(buf + n, "\n");
+	return n;
+
+}
+
+static ssize_t rtk_suspend_gpio_out_en_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#endif
+
+	if (val < GPIO_OUTPUT_CHANGE_EN_BITS)
+		rtk_suspend_gpio_out_en_set(
+			rtk_suspend_gpio_out_en_get() ^ (0x1U << val));
+	else
+		rtk_suspend_gpio_out_en2_set(rtk_suspend_gpio_out_en2_get() ^
+			(0x1U << (val-GPIO_OUTPUT_CHANGE_EN_BITS)));
+
+	return count;
+}
+
+static ssize_t rtk_suspend_gpio_out_act_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val;
+	unsigned int val2;
+
+	val = rtk_suspend_gpio_out_act_get();
+	val2 = rtk_suspend_gpio_out_act2_get();
+
+	if ((val == -1U) && (val2 == -1U))
+		return sprintf(buf, "(not ready)\n");
+
+	n += sprintf(buf + n, " Act| GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < GPIO_OUTPUT_CHANGE_ACT_BITS ; i++) {
+		if (val == -1U)
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (!(rtk_suspend_gpio_out_en_get() & (0x1U << i)))
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (val & (0x1U << i))
+			n += sprintf(buf + n, "  H | %d\n", i);
+		else
+			n += sprintf(buf + n, "  L | %d\n", i);
+	}
+
+	for (i = 0 ; i < GPIO_WAKEUP_ACT2_BITS ; i++) {
+		if (val2 == -1U)
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_OUTPUT_CHANGE_ACT_BITS);
+		else if (!(rtk_suspend_gpio_out_en2_get() &  (0x1U << i)))
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_OUTPUT_CHANGE_ACT_BITS);
+		else if (val2 & (0x1U << i))
+			n += sprintf(buf + n, "  H | %d\n",
+				i + GPIO_OUTPUT_CHANGE_ACT_BITS);
+		else
+			n += sprintf(buf + n, "  L | %d\n",
+				i + GPIO_OUTPUT_CHANGE_ACT_BITS);
+	}
+	n += sprintf(buf + n, "\n");
+
+	return n;
+}
+
+static ssize_t rtk_suspend_gpio_out_act_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+	int tmp;
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#endif
+
+	if (val < GPIO_OUTPUT_CHANGE_ACT_BITS) {
+		if (rtk_suspend_gpio_out_en_get() &  (0x1U << val)) {
+			tmp = (0x1U << val);
+			rtk_suspend_gpio_out_act_set(
+				rtk_suspend_gpio_out_act_get() ^ tmp);
+		}
+	} else {
+		if (rtk_suspend_gpio_out_en2_get() &
+			(0x1U << (val-GPIO_OUTPUT_CHANGE_ACT_BITS))) {
+			tmp = (0x1U << (val-GPIO_OUTPUT_CHANGE_ACT_BITS));
+			rtk_suspend_gpio_out_act2_set(
+				rtk_suspend_gpio_out_act2_get() ^ tmp);
+		}
+	}
+
+	return count;
+}
+
+static ssize_t rtk_suspend_timer_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	return sprintf(buf, " %d sec (reciprocal timer)\n",
+		rtk_suspend_timer_sec_get());
+}
+
+static ssize_t rtk_suspend_timer_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val > (AUDIO_RECIPROCAL_TIMER_GET(-1UL)))
+		return -ENOMEM;
+
+	rtk_suspend_timer_sec_set(val);
+	return count;
+}
+
+static ssize_t rtk_suspend_context_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	return sprintf(buf, "%d\n", suspend_context);
+}
+
+static ssize_t rtk_suspend_context_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	suspend_context = val;
+	return count;
+}
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+void rtk_domu_suspend_context_increase(void)
+{
+	suspend_context++;
+}
+#endif
+
+static struct kobj_attribute rtk_suspend_wakeup_attr =
+	RTK_SUSPEND_ATTR(wakeup);
+static struct kobj_attribute rtk_suspend_resume_state_attr =
+	RTK_SUSPEND_ATTR(resume_state);
+static struct kobj_attribute rtk_suspend_gpio_wakeup_en_attr =
+	RTK_SUSPEND_ATTR(gpio_wakeup_en);
+static struct kobj_attribute rtk_suspend_gpio_wakeup_act_attr =
+	RTK_SUSPEND_ATTR(gpio_wakeup_act);
+static struct kobj_attribute rtk_suspend_gpio_out_en_attr =
+	RTK_SUSPEND_ATTR(gpio_out_en);
+static struct kobj_attribute rtk_suspend_gpio_out_act_attr =
+	RTK_SUSPEND_ATTR(gpio_out_act);
+static struct kobj_attribute rtk_suspend_timer_attr =
+	RTK_SUSPEND_ATTR(timer);
+static struct kobj_attribute rtk_suspend_context_attr =
+	RTK_SUSPEND_ATTR(context);
+
+static struct attribute *rtk_suspend_attrs[] = {
+	&rtk_suspend_wakeup_attr.attr,
+	&rtk_suspend_resume_state_attr.attr,
+	&rtk_suspend_gpio_wakeup_en_attr.attr,
+	&rtk_suspend_gpio_wakeup_act_attr.attr,
+	&rtk_suspend_gpio_out_en_attr.attr,
+	&rtk_suspend_gpio_out_act_attr.attr,
+	&rtk_suspend_timer_attr.attr,
+	&rtk_suspend_context_attr.attr,
+	NULL,
+};
+
+static struct attribute_group rtk_suspend_attr_group = {
+	.attrs = rtk_suspend_attrs,
+};
+
+static struct kobject *rtk_suspend_kobj;
+
+static ssize_t pm_state_show(struct device *dev, struct device_attribute *attr,
+	char *buf)
+{
+	return sprintf(buf, "%d\n", pm_state);
+}
+
+static ssize_t pm_state_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_state = val;
+
+	return count;;
+}
+
+static ssize_t pm_wakelock_mode_show(struct device *dev, struct device_attribute *attr,
+	char *buf)
+{
+	return sprintf(buf, "%d\n", pm_wakelock_mode);
+}
+
+static ssize_t pm_wakelock_mode_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_wakelock_mode = val;
+
+	return count;;
+}
+
+static ssize_t pm_block_wakelock_show(
+    struct device *dev,
+    struct device_attribute *attr,
+    char *buf)
+{
+	return sprintf(buf, "%d\n", pm_block_wakelock);
+}
+
+static ssize_t pm_block_wakelock_store(
+    struct device *dev,
+    struct device_attribute *attr,
+    const char *buf,
+    size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_block_wakelock = val;
+
+	return count;;
+}
+
+static struct device_attribute pm_state_attr =
+	__ATTR(pm_state, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_state_show, pm_state_store);
+
+static struct device_attribute pm_wakelock_mode_attr =
+	__ATTR(pm_wakelock_mode, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_wakelock_mode_show, pm_wakelock_mode_store);
+
+static struct device_attribute pm_block_wakelock_attr =
+	__ATTR(pm_block_wakelock, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_block_wakelock_show, pm_block_wakelock_store);
+
+struct class *rtk_pm_class;
+struct device *rtk_pm_dev;
+
+static int __init suspend_sysfs_init(void)
+{
+	int ret;
+
+	pm_state = 0;
+	pm_wakelock_mode = 0;
+    pm_block_wakelock = 0;
+
+	rtk_pm_class = class_create(THIS_MODULE, "rtk_pm");
+	if (IS_ERR(rtk_pm_class))
+		return PTR_ERR(rtk_pm_class);
+
+	rtk_pm_dev =  device_create(rtk_pm_class, NULL,
+		MKDEV(0, 1), NULL, "android_control");
+	if (IS_ERR(rtk_pm_dev))
+		return PTR_ERR(rtk_pm_dev);
+
+	ret = device_create_file(rtk_pm_dev, &pm_state_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	ret = device_create_file(rtk_pm_dev, &pm_wakelock_mode_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	ret = device_create_file(rtk_pm_dev, &pm_block_wakelock_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	rtk_suspend_kobj = kobject_create_and_add("suspend", kernel_kobj);
+	if (!rtk_suspend_kobj)
+		return -ENOMEM;
+	ret = sysfs_create_group(rtk_suspend_kobj, &rtk_suspend_attr_group);
+	if (ret)
+		kobject_put(rtk_suspend_kobj);
+	return ret;
+}
+
+module_init(suspend_sysfs_init);
+#endif
+
diff --git a/drivers/soc/realtek/rtd129x/rtd129x_suspend.h b/drivers/soc/realtek/rtd129x/rtd129x_suspend.h
new file mode 100644
index 00000000..8d2714087
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtd129x_suspend.h
@@ -0,0 +1,184 @@
+/*
+ * rtd129x_suspend.h - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef DRIVERS_SOC_REALTEK_RTD129X_RTD129X_SUSPEND_H_
+#define DRIVERS_SOC_REALTEK_RTD129X_RTD129X_SUSPEND_H_
+
+#include <soc/realtek/rtk_ipc_shm.h>
+
+#define SETMASK(bits, pos) (((-1U) >> (32-bits)) << (pos))
+#define CLRMASK(bits, pos) (~(SETMASK(bits, pos)))
+#define SET_VAL(val,bits,pos) ((val << pos) & SETMASK(bits, pos))
+#define GET_VAL(reg,bits,pos) ((reg & SETMASK(bits, pos)) >> pos)
+
+#define AUTHOR_SHIFFT 30
+#define AUTHOR_BITS 2
+#define AUTHOR_MASK(val) SET_VAL(val,AUTHOR_BITS,AUTHOR_SHIFFT)
+#define AUTHOR_GET(reg) GET_VAL(reg,AUTHOR_BITS,AUTHOR_SHIFFT)
+#define AUTHOR_IS_SCPU(reg) (AUTHOR_GET(reg) == AUTHOR_SCPU)
+#define AUTHOR_IS_ACPU(reg) (AUTHOR_GET(reg) == AUTHOR_ACPU)
+
+#define NOTIFY_SHIFFT 0
+#define NOTIFY_BITS 8
+#define NOTIFY_MASK(val) SET_VAL(val,NOTIFY_BITS,NOTIFY_SHIFFT)
+#define NOTIFY_GET(reg) GET_VAL(reg,NOTIFY_BITS,NOTIFY_SHIFFT)
+
+#define SUSPEND_ISO_GPIO_BASE 101
+#define SUSPEND_ISO_GPIO_SIZE 35
+
+#define SUSPEND_MAGIC_KEY 0xEA
+#define SUSPEND_MAGIC_SHIFFT 24
+#define SUSPEND_MAGIC_BITS 8
+#define SUSPEND_MAGIC_MASK (SUSPEND_MAGIC_KEY << SUSPEND_MAGIC_SHIFFT)
+#define SUSPEND_MAGIC_GET(val) GET_VAL(val, 8, 24)
+
+#define WAKEUP_FLAGS_SHIFFT	 0
+#define WAKEUP_FLAGS_BITS (eWAKEUP_ON_MAX)
+#define WAKEUP_FLAGS_MASK(val) SET_VAL(val, WAKEUP_FLAGS_BITS, WAKEUP_FLAGS_SHIFFT)
+#define WAKEUP_FLAGS_GET(reg) GET_VAL(reg, WAKEUP_FLAGS_BITS, WAKEUP_FLAGS_SHIFFT)
+
+#define RESUME_STATE_SHIFFT 16
+#define RESUME_STATE_BITS 8
+#define RESUME_STATE_MASK(val) SET_VAL(val, RESUME_STATE_BITS, RESUME_STATE_SHIFFT)
+#define RESUME_STATE_GET(reg) GET_VAL(reg, RESUME_STATE_BITS, RESUME_STATE_SHIFFT)
+
+#define RESUME_DATA_SHIFFT 0
+#define RESUME_DATA_BITS 16
+#define RESUME_DATA_MASK(val) SET_VAL(val, RESUME_DATA_BITS, RESUME_DATA_SHIFFT)
+#define RESUME_DATA_GET(reg) GET_VAL(reg, RESUME_DATA_BITS, RESUME_DATA_SHIFFT)
+
+#define GPIO_WAKEUP_EN_SHIFFT 0
+#define GPIO_WAKEUP_EN_BITS	 24
+#define GPIO_WAKEUP_EN_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+#define GPIO_WAKEUP_EN_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+
+#define GPIO_WAKEUP_ACT_SHIFFT 0
+#define GPIO_WAKEUP_ACT_BITS 24
+#define GPIO_WAKEUP_ACT_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+#define GPIO_WAKEUP_ACT_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_EN_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_EN_BITS 24
+#define GPIO_OUTPUT_CHANGE_EN_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_ACT_BITS 24
+#define GPIO_OUTPUT_CHANGE_ACT_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+
+#define GPIO_WAKEUP_EN2_SHIFFT 0
+#define GPIO_WAKEUP_EN2_BITS 11
+#define GPIO_WAKEUP_EN2_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+#define GPIO_WAKEUP_EN2_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+
+#define GPIO_WAKEUP_ACT2_SHIFFT 0
+#define GPIO_WAKEUP_ACT2_BITS 11
+#define GPIO_WAKEUP_ACT2_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+#define GPIO_WAKEUP_ACT2_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_EN2_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_EN2_BITS 11
+#define GPIO_OUTPUT_CHANGE_EN2_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN2_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT2_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_ACT2_BITS 11
+#define GPIO_OUTPUT_CHANGE_ACT2_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT2_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+
+#define AUDIO_RECIPROCAL_TIMER_SHIFFT 0
+#define AUDIO_RECIPROCAL_TIMER_BITS 24
+#define AUDIO_RECIPROCAL_TIMER_MASK(val) SET_VAL(val, AUDIO_RECIPROCAL_TIMER_BITS, AUDIO_RECIPROCAL_TIMER_SHIFFT)
+#define AUDIO_RECIPROCAL_TIMER_GET(reg) GET_VAL(reg, AUDIO_RECIPROCAL_TIMER_BITS, AUDIO_RECIPROCAL_TIMER_SHIFFT)
+
+enum {
+	AUTHOR_SCPU = 0x1,
+	AUTHOR_ACPU,
+};
+
+enum _notify_flag{
+	NOTIFY_NONE,
+	NOTIFY_SUSPEND_TO_RAM = 0x01,
+	NOTIFY_SUSPEND_TO_COOLBOOT,
+	NOTIFY_SUSPEND_TO_WFI,
+
+	NOTIFY_RESUME_PLATFORM = 0x10,
+	NOTIFY_RESUME_END,
+	NOTIFY_SCPU_READY,
+	NOTIFY_ACPU_READY,
+};
+
+enum _suspend_mode {
+	SUSPEND_TO_RAM,
+	SUSPEND_TO_COOLBOOT,
+	SUSPEND_TO_WFI,
+	MAX_SUSPEND_MODE,
+};
+
+const char *const rtk_suspend_states[MAX_SUSPEND_MODE] = {
+	[SUSPEND_TO_RAM] = "ram",
+	[SUSPEND_TO_COOLBOOT] = "coolboot",
+	[SUSPEND_TO_WFI] = "wfi",
+};
+
+enum _suspend_wakeup {
+	eWAKEUP_ON_LAN,
+	eWAKEUP_ON_IR,
+	eWAKEUP_ON_GPIO,
+	eWAKEUP_ON_ALARM,
+	eWAKEUP_ON_TIMER,
+	eWAKEUP_ON_CEC,
+	eWAKEUP_ON_MAX,
+};
+
+const char *const rtk_suspend_wakeup_states[eWAKEUP_ON_MAX] = {
+	[eWAKEUP_ON_LAN] = "lan",
+	[eWAKEUP_ON_IR] = "ir",
+	[eWAKEUP_ON_GPIO] = "gpio",
+	[eWAKEUP_ON_ALARM] = "alarm",
+	[eWAKEUP_ON_TIMER] = "timer",
+	[eWAKEUP_ON_CEC] = "cec",
+};
+
+enum _wakeup_flags {
+	fWAKEUP_ON_LAN = 0x1U << eWAKEUP_ON_LAN,
+	fWAKEUP_ON_IR = 0x1U << eWAKEUP_ON_IR,
+	fWAKEUP_ON_GPIO = 0x1U << eWAKEUP_ON_GPIO,
+	fWAKEUP_ON_ALARM = 0x1U << eWAKEUP_ON_ALARM,
+	fWAKEUP_ON_TIMER = 0x1U << eWAKEUP_ON_TIMER,
+	fWAKEUP_ON_CEC = 0x1U << eWAKEUP_ON_CEC,
+};
+
+enum _RESUME_STATE {
+	RESUME_NONE	 = 0,
+	RESUME_UNKNOW,
+	RESUME_IR,
+	RESUME_GPIO,
+	RESUME_LAN,
+	RESUME_ALARM,
+	RESUME_TIMER,
+	RESUME_CEC,
+	RESUME_MAX_STATE,
+};
+
+const char *const rtk_suspend_resume_states[RESUME_MAX_STATE] = {
+	[RESUME_NONE] = "none",
+	[RESUME_UNKNOW] = "unknow",
+	[RESUME_IR] = "ir",
+	[RESUME_GPIO] = "gpio",
+	[RESUME_LAN] = "lan",
+	[RESUME_ALARM] = "alarm",
+	[RESUME_TIMER] = "timer",
+	[RESUME_CEC] = "cec",
+};
+
+#endif /* DRIVERS_SOC_REALTEK_RTD129X_RTD129X_SUSPEND_H_ */
diff --git a/drivers/soc/realtek/rtd129x/rtk_chip.c b/drivers/soc/realtek/rtd129x/rtk_chip.c
new file mode 100644
index 00000000..a285aa5
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_chip.c
@@ -0,0 +1,62 @@
+/*
+ * rtk_chip.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/io.h>
+#include <soc/realtek/rtk_chip.h>
+
+#define SB2_BASE_ADDR		0x9801A000
+#define	CHIP_ID				0x00000200
+#define CHIP_REV			0x00000204
+
+#define EFUSE_ADDR			0x980171d8
+#define CHIP_INFO1			0x98007028
+
+#define RTK1296_CPU_MASK	0x00000800
+
+int get_rtd_chip_id(void) {
+	int cpu_id = CHIP_ID_RTD1295;
+	void __iomem *chip_info1_addr = ioremap(CHIP_INFO1, 0x4);
+
+	if (readl(chip_info1_addr) & RTK1296_CPU_MASK) {
+		cpu_id = CHIP_ID_RTD1296;
+	}
+	__iounmap(chip_info1_addr);
+	return cpu_id;
+}
+
+#define RTD129x_CHIP_A00 (0x00000000)
+#define RTD129x_CHIP_A01 (0x00010000)
+#define RTD129x_CHIP_B00 (0x00020000)
+#define RTD129x_CHIP_B01 (0x00030000)
+
+int get_rtd_chip_revision(void) {
+	void __iomem *chip_revision_addr = ioremap(SB2_BASE_ADDR + CHIP_REV, 0x4);
+
+	int val = readl(chip_revision_addr);
+
+	__iounmap(chip_revision_addr);
+
+	switch (val) {
+	case (RTD129x_CHIP_A00):
+		return RTD_CHIP_A00;
+	case (RTD129x_CHIP_A01):
+		return RTD_CHIP_A01;
+	case (RTD129x_CHIP_B00):
+		return RTD_CHIP_B00;
+	case (RTD129x_CHIP_B01):
+		return RTD_CHIP_B01;
+	default:
+		printk("%s: Not define chip revision 0x%x\n", __func__, val);
+	}
+	return 0;
+}
+
+
diff --git a/drivers/soc/realtek/rtd129x/rtk_usb.c b/drivers/soc/realtek/rtd129x/rtk_usb.c
new file mode 100644
index 00000000..d1bc085
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_usb.c
@@ -0,0 +1,526 @@
+/*
+ * rtk_usb.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/delay.h>
+#include <soc/realtek/power-control.h>
+#include <soc/realtek/rtk_usb.h>
+#include <soc/realtek/rtk_chip.h>
+
+struct rtk_usb {
+	struct power_ctrl_reg {
+		u32 usb_ctrl;
+		/* Port 0~2 */
+		u32 usb0_sram_pwr;
+		u32 usb0_sram_pwr_ctrl;
+		/* Port 3 */
+		u32 usb1_sram_pwr;
+		u32 usb1_sram_pwr_ctrl;
+		/* l4_icg */
+		u32 p0_l4_icg;
+		u32 p1_l4_icg;
+		u32 p2_l4_icg;
+		u32 p3_l4_icg;
+
+		/* for power cut */
+		u32 usb_phy_ctrl;
+
+		u32 p0_utmi_reset;
+		u32 p1_utmi_reset;
+		u32 p2_utmi_reset;
+		u32 p3_utmi_reset;
+
+		u32 p0_pipe_reset;
+		u32 p1_pipe_reset;
+		u32 p2_pipe_reset;
+		u32 p3_pipe_reset;
+
+		/* for suspend */
+		u32 p0_gusb2phycfg;
+		u32 p0_gusb3pipectl;
+
+		u32 p1_gusb2phycfg;
+		u32 p1_gusb3pipectl;
+
+		u32 p2_gusb2phycfg;
+		u32 p2_gusb3pipectl;
+
+		u32 p3_gusb2phycfg;
+		u32 p3_gusb3pipectl;
+
+		u32 usb_charger;
+	} power_ctrl_reg;
+
+	bool usb_power_cut;
+
+	struct type_c {
+		u32 usb_typec_ctrl_cc1_0;
+	} type_c;
+};
+
+static struct rtk_usb *rtk_usb;
+
+#define TYPE_C_EN_SWITCH BIT(29)
+#define TYPE_C_TxRX_sel (BIT(28) | BIT(27))
+#define TYPE_C_SWITCH_MASK (TYPE_C_EN_SWITCH | TYPE_C_TxRX_sel)
+#define TYPE_C_enable_cc1 TYPE_C_EN_SWITCH
+#define TYPE_C_enable_cc2 (TYPE_C_EN_SWITCH | TYPE_C_TxRX_sel)
+#define TYPE_C_disable_cc ~TYPE_C_SWITCH_MASK
+#define disable_cc 0x0
+#define enable_cc1 0x1
+#define enable_cc2 0x2
+
+/* set usb charger power */
+void rtk_usb_set_charger_power(struct rtk_usb *rtk_usb, unsigned int val)
+{
+	void __iomem *reg_charger;
+
+	if (!rtk_usb || !rtk_usb->power_ctrl_reg.usb_charger) return;
+
+	reg_charger  = ioremap(rtk_usb->power_ctrl_reg.usb_charger, 0x4);
+
+	pr_debug("set usb_charger to 0x%08x\n", val);
+
+	writel(val, reg_charger);
+
+	iounmap(reg_charger);
+}
+
+int rtk_usb_set_hw_l4icg_on_off(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool on)
+{
+	void __iomem *reg;
+
+	if (!rtk_usb)
+		return 0;
+
+	switch (port_num) {
+	case USB_PORT_0:
+		if (rtk_usb->power_ctrl_reg.p0_l4_icg) {
+			reg = ioremap(rtk_usb->power_ctrl_reg.p0_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	case USB_PORT_1:
+		if (rtk_usb->power_ctrl_reg.p1_l4_icg) {
+			reg = ioremap(rtk_usb->power_ctrl_reg.p1_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	case USB_PORT_2:
+		if (rtk_usb->power_ctrl_reg.p2_l4_icg) {
+			reg = ioremap(rtk_usb->power_ctrl_reg.p3_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	case USB_PORT_3:
+		if (rtk_usb->power_ctrl_reg.p3_l4_icg) {
+			reg = ioremap(rtk_usb->power_ctrl_reg.p3_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	default:
+		pr_err("%s Error Port num %d\n", __func__, port_num);
+		break;
+	}
+
+	return 0;
+}
+
+static int __isolate_phy_from_a_to_d(struct rtk_usb *rtk_usb)
+{
+	void __iomem *reg;
+
+	/* isolate UPHY A->D */
+	if (!rtk_usb) return 0;
+
+	pr_debug("%s START\n", __func__);
+
+	pr_debug("set USB Analog phy power off\n");
+
+	if (rtk_usb->power_ctrl_reg.usb_phy_ctrl) {
+		reg = ioremap(rtk_usb->power_ctrl_reg.usb_phy_ctrl, 0x4);
+		writel(BIT(0) | BIT(1) | readl(reg), reg);
+		iounmap(reg);
+	}
+	if (rtk_usb->power_ctrl_reg.p0_utmi_reset) {
+		reg = ioremap(rtk_usb->power_ctrl_reg.p0_utmi_reset, 0x4);
+		writel(BIT(0) | readl(reg), reg);
+		iounmap(reg);
+	}
+	if (rtk_usb->power_ctrl_reg.p1_utmi_reset) {
+		reg = ioremap(rtk_usb->power_ctrl_reg.p1_utmi_reset, 0x4);
+		writel(BIT(0) | readl(reg), reg);
+		iounmap(reg);
+	}
+	if (rtk_usb->power_ctrl_reg.p2_utmi_reset) {
+		reg = ioremap(rtk_usb->power_ctrl_reg.p2_utmi_reset, 0x4);
+		writel(BIT(0) | readl(reg), reg);
+		iounmap(reg);
+	}
+	if (get_rtd_chip_id() == CHIP_ID_RTD1296 &&
+		    rtk_usb->power_ctrl_reg.p3_utmi_reset) {
+		reg = ioremap(rtk_usb->power_ctrl_reg.p3_utmi_reset, 0x4);
+		writel(BIT(0) | readl(reg), reg);
+		iounmap(reg);
+	}
+	if (rtk_usb->power_ctrl_reg.usb_ctrl) {
+		reg = ioremap(rtk_usb->power_ctrl_reg.usb_ctrl, 0x4);
+		writel(~(BIT(4) | BIT(5) | BIT(6)) & readl(reg), reg);
+
+		iounmap(reg);
+	}
+	pr_debug("%s END\n", __func__);
+
+	return 0;
+}
+
+static inline void __power_control_set_power(const char *name, bool power_on)
+{
+	struct power_control * pctrl = power_control_get(name);
+	if (!pctrl) {
+		pr_debug("%s: Failed to get power_control %s\n",  __func__, name);
+		return;
+	}
+
+	if (power_on)
+		power_control_power_on(pctrl);
+	else
+		power_control_power_off(pctrl);
+}
+
+int rtk_usb_iso_power_ctrl(struct rtk_usb *rtk_usb,
+	    bool power_on)
+{
+	if (!rtk_usb) return 0;
+
+	pr_debug("%s START\n", __func__);
+
+	if (rtk_usb->power_ctrl_reg.usb_ctrl &&
+		    rtk_usb->power_ctrl_reg.usb0_sram_pwr &&
+		    rtk_usb->power_ctrl_reg.usb0_sram_pwr_ctrl &&
+		    rtk_usb->power_ctrl_reg.usb1_sram_pwr &&
+		    rtk_usb->power_ctrl_reg.usb1_sram_pwr_ctrl) {
+		void __iomem *usb_ctrl =
+			    ioremap(rtk_usb->power_ctrl_reg.usb_ctrl, 0x4);
+		void __iomem *usb0_sram_pwr =
+			    ioremap(rtk_usb->power_ctrl_reg.usb0_sram_pwr, 0x4);
+		void __iomem *usb0_sram_pwr_ctrl =
+			    ioremap(rtk_usb->power_ctrl_reg.usb0_sram_pwr_ctrl, 0x4);
+		void __iomem *usb1_sram_pwr =
+			    ioremap(rtk_usb->power_ctrl_reg.usb1_sram_pwr, 0x4);
+		void __iomem *usb1_sram_pwr_ctrl =
+			   ioremap(rtk_usb->power_ctrl_reg.usb1_sram_pwr_ctrl, 0x4);
+
+		pr_info("%s power_%s ([0x%x=0x%08x)\n", __func__, power_on?"on":"off",
+			    rtk_usb->power_ctrl_reg.usb_ctrl, readl(usb_ctrl));
+
+		if (power_on) {
+			pr_debug("%s power_on\n", __func__);
+
+			pr_debug("set usb_power_domain/p0 on\n");
+#if 1
+			/* set power gating control */
+				writel((BIT(0) | BIT(4) | BIT(6)) |
+				     readl(usb_ctrl), usb_ctrl);
+			/* port0-port2 sram power */
+			//writel(0, usb0_sram_pwr);
+			writel(0x00000f00, usb0_sram_pwr_ctrl);
+			/* port3 sram power */
+			if (get_rtd_chip_id() == CHIP_ID_RTD1296) {
+				pr_info("set usb_power_domain/p3 on\n");
+				writel((BIT(1) | BIT(5)) |
+				     readl(usb_ctrl), usb_ctrl);
+				//writel(0, usb1_sram_pwr);
+				if (get_rtd_chip_revision() < RTD_CHIP_A01)
+					writel(0x00000f05, usb1_sram_pwr_ctrl);
+				else
+					writel(0x00000f00, usb1_sram_pwr_ctrl);
+			}
+			/* disable isolation cell */
+			writel(~(BIT(8) | BIT(9)) & readl(usb_ctrl), usb_ctrl);
+#else
+			__power_control_set_power("pctrl_usb_p0_mac", 1);
+			__power_control_set_power("pctrl_usb_p0_phy", 1);
+			__power_control_set_power("pctrl_usb_p0_iso", 0);
+			if (get_rtd_chip_id() == CHIP_ID_RTD1296) {
+				pr_info("set usb_power_domain/p3 on\n");
+				__power_control_set_power("pctrl_usb_p3_phy", 1);
+				__power_control_set_power("pctrl_usb_p3_mac", 1);
+				__power_control_set_power("pctrl_usb_p3_iso", 0);
+			}
+#endif
+		} else {
+			pr_debug("%s power_off\n", __func__);
+			__isolate_phy_from_a_to_d(rtk_usb);
+			if (rtk_usb->usb_power_cut &&
+				    get_rtd_chip_revision() >= RTD_CHIP_B00) {
+				writel((BIT(8) | BIT(9)) | readl(usb_ctrl), usb_ctrl);
+				// port0-port2 sram
+				writel(0, usb0_sram_pwr);
+				writel(0x00000f01, usb0_sram_pwr_ctrl);
+				// port3 sram
+				writel(0, usb1_sram_pwr);
+				if (get_rtd_chip_revision() < RTD_CHIP_A01)
+					writel(0x00000f06, usb1_sram_pwr_ctrl);
+				else
+					writel(0x00000f01, usb1_sram_pwr_ctrl);
+
+				writel(~(BIT(0) | BIT(1) | BIT(4) | BIT(5) |BIT(6)) &
+				     readl(usb_ctrl), usb_ctrl);
+			}
+		}
+		pr_info("set power_domain %s ([0x%x]=0x%08x)\n", power_on?"on":"off",
+			    rtk_usb->power_ctrl_reg.usb_ctrl, readl(usb_ctrl));
+		iounmap(usb_ctrl);
+		iounmap(usb0_sram_pwr);
+		iounmap(usb0_sram_pwr_ctrl);
+		iounmap(usb1_sram_pwr);
+		iounmap(usb1_sram_pwr_ctrl);
+	}
+	pr_debug("%s END\n", __func__);
+
+	return 0;
+}
+
+int rtk_usb_port_suspend_resume(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool is_suspend)
+{
+	void __iomem *reg_u3_port;
+	void __iomem *reg_u2_port;
+
+	if (!rtk_usb) return 0;
+
+	pr_debug("%s START\n", __func__);
+	switch (port_num) {
+	case USB_PORT_0:
+		pr_debug("set port 0 phy suspend\n");
+		if (rtk_usb->power_ctrl_reg.p0_gusb3pipectl) {
+			reg_u3_port = ioremap(rtk_usb->power_ctrl_reg.p0_gusb3pipectl, 0x4);
+			if (is_suspend)
+				writel(readl(reg_u3_port) | BIT(17), reg_u3_port);
+			else
+				writel(readl(reg_u3_port) & ~BIT(17), reg_u3_port);
+			iounmap(reg_u3_port);
+		}
+		if (rtk_usb->power_ctrl_reg.p0_gusb2phycfg) {
+			reg_u2_port = ioremap(rtk_usb->power_ctrl_reg.p0_gusb2phycfg, 0x4);
+			if (is_suspend)
+				writel(readl(reg_u2_port) | BIT(6), reg_u2_port);
+			else
+				writel(readl(reg_u2_port) & ~BIT(6), reg_u2_port);
+			iounmap(reg_u2_port);
+		}
+	break;
+	case USB_PORT_1:
+		pr_debug("set port 1 phy suspend\n");
+		if (rtk_usb->power_ctrl_reg.p1_gusb3pipectl) {
+			reg_u3_port = ioremap(rtk_usb->power_ctrl_reg.p1_gusb3pipectl, 0x4);
+			writel(readl(reg_u3_port) | BIT(17), reg_u3_port);
+			iounmap(reg_u3_port);
+		}
+		if (rtk_usb->power_ctrl_reg.p1_gusb2phycfg) {
+			reg_u2_port = ioremap(rtk_usb->power_ctrl_reg.p1_gusb2phycfg, 0x4);
+			writel(readl(reg_u2_port) | BIT(6), reg_u2_port);
+			iounmap(reg_u2_port);
+		}
+	break;
+	case USB_PORT_2:
+		pr_debug("TODO set port 2 phy suspend\n");
+	break;
+	case USB_PORT_3:
+		pr_debug("set port 3 phy suspend\n");
+		if (rtk_usb->power_ctrl_reg.p3_gusb3pipectl) {
+			reg_u3_port = ioremap(rtk_usb->power_ctrl_reg.p3_gusb3pipectl, 0x4);
+			writel(readl(reg_u3_port) | BIT(17), reg_u3_port);
+			iounmap(reg_u3_port);
+		}
+		if (rtk_usb->power_ctrl_reg.p3_gusb2phycfg) {
+			reg_u2_port = ioremap(rtk_usb->power_ctrl_reg.p3_gusb2phycfg, 0x4);
+			writel(readl(reg_u2_port) | BIT(6), reg_u2_port);
+			iounmap(reg_u2_port);
+		}
+	break;
+	default:
+		pr_err("Error port num %d\n", port_num);
+	}
+	pr_debug("%s END\n", __func__);
+	return 0;
+}
+
+int rtk_type_c_init(struct rtk_usb *rtk_usb)
+{
+	if (!rtk_usb) {
+		pr_info("%s: rtk_usb is NULL\n", __func__);
+		return 0;
+	}
+}
+
+int rtk_type_c_plug_config(struct rtk_usb *rtk_usb, int dr_mode, int cc)
+{
+	void __iomem *usb_typec_ctrl_cc1_0;
+	int val_cc;
+
+	if (!rtk_usb) {
+		pr_info("%s: rtk_usb is NULL\n", __func__);
+		return 0;
+	} if (!rtk_usb->type_c.usb_typec_ctrl_cc1_0) {
+		pr_info("%s: rtk_usb no usb_typec_ctrl_cc1_0 reg\n", __func__);
+		return 0;
+	}
+
+	usb_typec_ctrl_cc1_0 = ioremap(rtk_usb->type_c.usb_typec_ctrl_cc1_0, 0x4);
+	val_cc = readl(usb_typec_ctrl_cc1_0);
+	val_cc &= ~TYPE_C_SWITCH_MASK;
+
+	if (cc == disable_cc) {
+		val_cc |= TYPE_C_disable_cc;
+	} else if (cc == enable_cc1) {
+		val_cc |= TYPE_C_enable_cc1;
+	} else if (cc == enable_cc2) {
+		val_cc |= TYPE_C_enable_cc2;
+	} else {
+		pr_err("%s: Error cc setting cc=0x%x\n", __func__, cc);
+		return -1;
+	}
+	writel(val_cc, usb_typec_ctrl_cc1_0);
+
+	mdelay(1);
+
+	pr_info("%s: cc=0x%x usb_typec_ctrl_cc1_0=0x%x\n",
+		    __func__, cc, readl(usb_typec_ctrl_cc1_0));
+
+	return 0;
+}
+
+struct rtk_usb *rtk_usb_soc_init(struct device_node *node)
+{
+	struct device_node *sub_node;
+	int ret;
+
+	if (!rtk_usb)
+		rtk_usb = kzalloc(sizeof(struct rtk_usb), GFP_KERNEL);
+	if (!rtk_usb) {
+		pr_err("%s: No memory to kzalloc rtk_usb!\n", __func__);
+		return NULL;
+	}
+
+	pr_info("%s START (%s)\n", __func__, __FILE__);
+
+	sub_node = of_get_child_by_name(node, "power_ctrl_reg");
+	if (sub_node) {
+		pr_debug("%s sub_node %s\n", __func__, sub_node->name);
+		of_property_read_u32(sub_node,
+			    "usb_ctrl", &rtk_usb->power_ctrl_reg.usb_ctrl);
+		/* Port 0~2 */
+		of_property_read_u32(sub_node,
+			    "usb0_sram_pwr", &rtk_usb->power_ctrl_reg.usb0_sram_pwr);
+		of_property_read_u32(sub_node,
+			    "usb0_sram_pwr_ctrl",
+			    &rtk_usb->power_ctrl_reg.usb0_sram_pwr_ctrl);
+		/* Port 3 */
+		of_property_read_u32(sub_node,
+			    "usb1_sram_pwr", &rtk_usb->power_ctrl_reg.usb1_sram_pwr);
+		of_property_read_u32(sub_node,
+			    "usb1_sram_pwr_ctrl",
+			    &rtk_usb->power_ctrl_reg.usb1_sram_pwr_ctrl);
+
+		of_property_read_u32(sub_node,
+			    "p0_l4_icg", &rtk_usb->power_ctrl_reg.p0_l4_icg);
+		of_property_read_u32(sub_node,
+			    "p1_l4_icg", &rtk_usb->power_ctrl_reg.p1_l4_icg);
+		of_property_read_u32(sub_node,
+			    "p2_l4_icg", &rtk_usb->power_ctrl_reg.p2_l4_icg);
+		of_property_read_u32(sub_node,
+			    "p3_l4_icg", &rtk_usb->power_ctrl_reg.p3_l4_icg);
+
+		/* for power cut */
+		of_property_read_u32(sub_node,
+			    "usb_phy_ctrl", &rtk_usb->power_ctrl_reg.usb_phy_ctrl);
+
+		of_property_read_u32(sub_node,
+			    "p0_utmi_reset", &rtk_usb->power_ctrl_reg.p0_utmi_reset);
+		of_property_read_u32(sub_node,
+			    "p1_utmi_reset", &rtk_usb->power_ctrl_reg.p1_utmi_reset);
+		of_property_read_u32(sub_node,
+			    "p2_utmi_reset", &rtk_usb->power_ctrl_reg.p2_utmi_reset);
+		of_property_read_u32(sub_node,
+			    "p3_utmi_reset", &rtk_usb->power_ctrl_reg.p3_utmi_reset);
+
+		of_property_read_u32(sub_node,
+			    "p0_pipe_reset", &rtk_usb->power_ctrl_reg.p0_pipe_reset);
+		of_property_read_u32(sub_node,
+			    "p1_pipe_reset", &rtk_usb->power_ctrl_reg.p1_pipe_reset);
+		of_property_read_u32(sub_node,
+			    "p2_pipe_reset", &rtk_usb->power_ctrl_reg.p2_pipe_reset);
+		of_property_read_u32(sub_node,
+			    "p3_pipe_reset", &rtk_usb->power_ctrl_reg.p3_pipe_reset);
+
+		/* for suspend */
+		of_property_read_u32(sub_node,
+			    "p0_gusb2phycfg", &rtk_usb->power_ctrl_reg.p0_gusb2phycfg);
+		of_property_read_u32(sub_node,
+			    "p0_gusb3pipectl", &rtk_usb->power_ctrl_reg.p0_gusb3pipectl);
+
+		of_property_read_u32(sub_node,
+			    "p1_gusb2phycfg", &rtk_usb->power_ctrl_reg.p1_gusb2phycfg);
+		of_property_read_u32(sub_node,
+			    "p1_gusb3pipectl", &rtk_usb->power_ctrl_reg.p1_gusb3pipectl);
+
+		of_property_read_u32(sub_node,
+			    "p2_gusb2phycfg", &rtk_usb->power_ctrl_reg.p2_gusb2phycfg);
+		of_property_read_u32(sub_node,
+			    "p2_gusb3pipectl", &rtk_usb->power_ctrl_reg.p2_gusb3pipectl);
+
+		of_property_read_u32(sub_node,
+			    "p3_gusb2phycfg", &rtk_usb->power_ctrl_reg.p3_gusb2phycfg);
+		of_property_read_u32(sub_node,
+			    "p3_gusb3pipectl", &rtk_usb->power_ctrl_reg.p3_gusb3pipectl);
+
+		of_property_read_u32(sub_node,
+			    "usb_charger", &rtk_usb->power_ctrl_reg.usb_charger);
+
+		if (of_property_read_bool(sub_node, "usb_power_cut"))
+			rtk_usb->usb_power_cut = true;
+		else
+			rtk_usb->usb_power_cut = false;
+
+	}
+
+	sub_node = of_get_child_by_name(node, "type_c");
+	if (sub_node) {
+		pr_debug("%s sub_node %s\n", __func__, sub_node->name);
+
+		ret = of_property_read_u32(sub_node,
+			    "usb_typec_ctrl_cc1_0", &rtk_usb->type_c.usb_typec_ctrl_cc1_0);
+		if (ret)
+			rtk_usb->type_c.usb_typec_ctrl_cc1_0 = 0;
+	}
+
+	pr_debug("%s END\n", __func__);
+
+	return rtk_usb;
+}
+
+int rtk_usb_soc_free(struct rtk_usb **rtk_usb)
+{
+	if (*rtk_usb) {
+		kfree(*rtk_usb);
+		*rtk_usb = NULL;
+	}
+	return 0;
+}
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/Kconfig b/drivers/soc/realtek/rtd129x/rtk_ve/Kconfig
new file mode 100644
index 00000000..4cab12a
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/Kconfig
@@ -0,0 +1,29 @@
+#
+# Realtek codec configuration
+#
+
+menuconfig RTK_CODEC
+	bool "Realtek Codec"
+	default n
+
+if RTK_CODEC
+
+if ION
+config RTK_RESERVE_MEMORY
+	bool "RTK Reserve Memory for Video/Image Codec"
+	default n
+endif # ION
+
+config VE1_CODEC
+	bool "RTK Video Engine 1 Codec"
+	default n
+
+config VE3_CODEC
+	bool "RTK Video Engine 3 Codec"
+	default n
+
+config IMAGE_CODEC
+	bool "RTK Image Codec"
+	default n
+
+endif # RTK_CODEC
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/Makefile b/drivers/soc/realtek/rtd129x/rtk_ve/Makefile
new file mode 100644
index 00000000..b1bf783
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/Makefile
@@ -0,0 +1,8 @@
+#
+# Makefile for the Realtek codec drivers.
+#
+
+obj-$(CONFIG_RTK_CODEC)		+= puwrap.o
+obj-$(CONFIG_VE1_CODEC)		+= ve1/
+obj-$(CONFIG_VE3_CODEC)		+= ve3/
+obj-$(CONFIG_IMAGE_CODEC)	+= jdi/
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/jdi/Makefile b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/Makefile
new file mode 100644
index 00000000..40bef4c
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/Makefile
@@ -0,0 +1,6 @@
+# rtk_jcodec
+
+obj-$(CONFIG_IMAGE_CODEC) += jpu.o
+ifdef CONFIG_COMPAT
+obj-$(CONFIG_IMAGE_CODEC) += compat_jpu.o
+endif
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.c b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.c
new file mode 100644
index 00000000..247231c
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.c
@@ -0,0 +1,267 @@
+/*
+ * drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/compat.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#include "jpu.h"
+#include "compat_jpu.h"
+
+/* See drivers/soc/realtek/rtd129x/rtk_ve/jdi/jpu.h for the definition of these structs */
+typedef struct compat_jpudrv_buffer_t {
+    compat_uint_t size;
+    compat_ulong_t phys_addr;
+    compat_ulong_t base;							/* kernel logical address in use kernel */
+    compat_ulong_t virt_addr;				/* virtual user space address */
+} compat_jpudrv_buffer_t;
+
+typedef struct compat_jpudrv_intr_info_t {
+    compat_uint_t timeout;
+    compat_int_t intr_reason;
+} compat_jpudrv_intr_info_t;
+
+#define COMPAT_JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(JDI_IOCTL_MAGIC, 0)
+#define COMPAT_JDI_IOCTL_FREE_PHYSICALMEMORY _IO(JDI_IOCTL_MAGIC, 1)
+#define COMPAT_JDI_IOCTL_WAIT_INTERRUPT _IO(JDI_IOCTL_MAGIC, 2)
+#define COMPAT_JDI_IOCTL_GET_INSTANCE_POOL _IO(JDI_IOCTL_MAGIC, 5)
+#define COMPAT_JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(JDI_IOCTL_MAGIC, 6)
+#define COMPAT_JDI_IOCTL_GET_REGISTER_INFO _IO(JDI_IOCTL_MAGIC, 11)
+#define COMPAT_JDI_IOCTL_GET_BONDING_INFO _IO(JDI_IOCTL_MAGIC, 13)
+
+static int compat_get_jpu_buffer_data(
+    compat_jpudrv_buffer_t __user *data32,
+    jpudrv_buffer_t __user *data)
+{
+    compat_uint_t s;
+    compat_ulong_t p;
+    compat_ulong_t b;
+    compat_ulong_t v;
+    int err;
+
+    err = get_user(s, &data32->size);
+    err |= put_user(s, &data->size);
+    err |= get_user(p, &data32->phys_addr);
+    err |= put_user(p, &data->phys_addr);
+    err |= get_user(b, &data32->base);
+    err |= put_user(b, &data->base);
+    err |= get_user(v, &data32->virt_addr);
+    err |= put_user(v, &data->virt_addr);
+
+    return err;
+}
+
+static int compat_get_jpu_intr_info_data(
+    compat_jpudrv_intr_info_t __user *data32,
+    jpudrv_intr_info_t __user *data)
+{
+    compat_uint_t t;
+    compat_int_t i;
+    int err;
+
+    err = get_user(t, &data32->timeout);
+    err |= put_user(t, &data->timeout);
+    err |= get_user(i, &data32->intr_reason);
+    err |= put_user(i, &data->intr_reason);
+
+    return err;
+}
+
+static int compat_put_jpu_buffer_data(
+    compat_jpudrv_buffer_t __user *data32,
+    jpudrv_buffer_t __user *data)
+{
+    compat_uint_t s;
+    compat_ulong_t p;
+    compat_ulong_t b;
+    compat_ulong_t v;
+    int err;
+
+    err = get_user(s, &data->size);
+    err |= put_user(s, &data32->size);
+    err |= get_user(p, &data->phys_addr);
+    err |= put_user(p, &data32->phys_addr);
+    err |= get_user(b, &data->base);
+    err |= put_user(b, &data32->base);
+    err |= get_user(v, &data->virt_addr);
+    err |= put_user(v, &data32->virt_addr);
+
+    return err;
+}
+
+static int compat_put_jpu_intr_info_data(
+    compat_jpudrv_intr_info_t __user *data32,
+    jpudrv_intr_info_t __user *data)
+{
+    compat_uint_t t;
+    compat_int_t i;
+    int err;
+
+    err = get_user(t, &data->timeout);
+    err |= put_user(t, &data32->timeout);
+    err |= get_user(i, &data->intr_reason);
+    err |= put_user(i, &data32->intr_reason);
+
+    return err;
+}
+
+long compat_jpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+    long ret = 0;
+
+    if (!filp->f_op->unlocked_ioctl)
+        return -ENOTTY;
+
+    switch (cmd)
+    {
+    case COMPAT_JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_FREE_PHYSICALMEMORY:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+
+        return filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_FREE_PHYSICALMEMORY, (unsigned long)data);
+    }
+
+    case COMPAT_JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_WAIT_INTERRUPT:
+    {
+        compat_jpudrv_intr_info_t __user *data32;
+        jpudrv_intr_info_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_intr_info_data(data32, data);
+        if (err)
+            return err;
+
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_WAIT_INTERRUPT, (unsigned long)data);
+        err = compat_put_jpu_intr_info_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case JDI_IOCTL_ENABLE_INTERRUPT:
+    case JDI_IOCTL_SET_CLOCK_GATE:
+    case JDI_IOCTL_OPEN_INSTANCE:
+    case JDI_IOCTL_CLOSE_INSTANCE:
+    case JDI_IOCTL_GET_INSTANCE_NUM:
+    case JDI_IOCTL_RESET:
+    case JDI_IOCTL_SET_CLOCK_ENABLE:
+    {
+        return filp->f_op->unlocked_ioctl(filp, cmd,
+                                          (unsigned long)compat_ptr(arg));
+    }
+
+    case COMPAT_JDI_IOCTL_GET_INSTANCE_POOL:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_INSTANCE_POOL, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_GET_REGISTER_INFO:
+    case COMPAT_JDI_IOCTL_GET_BONDING_INFO:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        if (cmd == COMPAT_JDI_IOCTL_GET_REGISTER_INFO)
+            ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_REGISTER_INFO, (unsigned long)data);
+        else
+            ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_BONDING_INFO, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    default:
+    {
+        printk(KERN_ERR "[COMPAT JPU]No such IOCTL, cmd is %d\n", cmd);
+        return -ENOIOCTLCMD;
+    }
+    }
+}
+
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h
new file mode 100644
index 00000000..2d920c9
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h
@@ -0,0 +1,31 @@
+/*
+
+ * drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_COMPAT_JPU_H
+#define _LINUX_COMPAT_JPU_H
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+long compat_jpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+
+#else
+
+#define compat_jpu_ioctl  NULL
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_JPU_H */
+
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/jdi/jmm.h b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/jmm.h
new file mode 100644
index 00000000..e54a228
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/jmm.h
@@ -0,0 +1,647 @@
+#ifndef __JPU_MM_H__
+#define __JPU_MM_H__
+
+
+typedef unsigned long long  jmem_key_t;
+
+#define JMEM_PAGE_SIZE           (16*1024)
+#define MAKE_KEY(_a, _b)        (((jmem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key)      (_key>>32)
+
+typedef struct page_struct {
+    int             pageno;
+    unsigned long   addr;
+    int             used;
+    int             alloc_pages;
+    int             first_pageno;
+} page_t;
+
+
+typedef struct avl_node_struct {
+    jmem_key_t   key;
+    int     height;
+    page_t* page;
+    struct avl_node_struct* left;
+    struct avl_node_struct* right;
+} avl_node_t;
+
+
+typedef struct _jpu_mm_struct {
+    avl_node_t*     free_tree;
+    avl_node_t*     alloc_tree;
+    page_t*         page_list;
+    int             num_pages;
+    unsigned long   base_addr;
+    unsigned long   mem_size;
+    int             free_page_count;
+    int             alloc_page_count;
+} jpu_mm_t;
+
+
+
+#define VMEM_P_ALLOC(_x)         kmalloc(_x, GFP_KERNEL)
+#define VMEM_P_FREE(_x)          kfree(_x)
+
+#define VMEM_ASSERT(_exp)        if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/
+}
+#define VMEM_HEIGHT(_tree)       (_tree==NULL ? -1 : _tree->height)
+
+
+#define MAX(_a, _b)         (_a >= _b ? _a : _b)
+
+typedef enum {
+    LEFT,
+    RIGHT
+} rotation_dir_t;
+
+
+
+typedef struct avl_node_data_struct {
+    int     key;
+    page_t* page;
+} avl_node_data_t;
+
+static avl_node_t*
+make_avl_node(
+    jmem_key_t key,
+    page_t* page
+)
+{
+    avl_node_t* node = (avl_node_t*)VMEM_P_ALLOC(sizeof(avl_node_t));
+    node->key     = key;
+    node->page    = page;
+    node->height  = 0;
+    node->left    = NULL;
+    node->right   = NULL;
+
+    return node;
+}
+
+
+static int
+get_balance_factor(
+    avl_node_t* tree
+)
+{
+    int factor = 0;
+    if (tree) {
+        factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+    }
+
+    return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *      A                      B
+ *       \                    / \
+ *        B         =>       A   C
+ *       /  \                 \
+ *      D    C                 D
+ *
+ */
+static avl_node_t*
+rotation_left(
+    avl_node_t* tree
+)
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    rchild = tree->right;
+    if (rchild == NULL) {
+        return tree;
+    }
+
+    lchild = rchild->left;
+    rchild->left = tree;
+    tree->right = lchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+    return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *         A                  B
+ *       \                  /  \
+ *      B         =>       D    A
+ *    /  \                     /
+ *   D    C                   C
+ *
+ */
+static avl_node_t*
+rotation_right(
+    avl_node_t* tree
+)
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    lchild = tree->left;
+    if (lchild == NULL) return NULL;
+
+    rchild = lchild->right;
+    lchild->right = tree;
+    tree->left = rchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+    return lchild;
+}
+
+static avl_node_t*
+do_balance(
+    avl_node_t* tree
+)
+{
+    int bfactor = 0, child_bfactor;       /* balancing factor */
+
+    bfactor = get_balance_factor(tree);
+
+    if (bfactor >= 2) {
+        child_bfactor = get_balance_factor(tree->right);
+        if (child_bfactor == 1 || child_bfactor == 0) {
+            tree = rotation_left(tree);
+        } else if (child_bfactor == -1) {
+            tree->right = rotation_right(tree->right);
+            tree        = rotation_left(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    } else if (bfactor <= -2) {
+        child_bfactor = get_balance_factor(tree->left);
+        if (child_bfactor == -1 || child_bfactor == 0) {
+            tree = rotation_right(tree);
+        } else if (child_bfactor == 1) {
+            tree->left = rotation_left(tree->left);
+            tree       = rotation_right(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    }
+
+    return tree;
+}
+static avl_node_t*
+unlink_end_node(
+    avl_node_t* tree,
+    int dir,
+    avl_node_t** found_node
+)
+{
+    avl_node_t* node;
+    *found_node = NULL;
+
+    if (tree == NULL) return NULL;
+
+    if (dir == LEFT) {
+        if (tree->left == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    } else {
+        if (tree->right == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    }
+
+    if (dir == LEFT) {
+        node = tree->left;
+        tree->left = unlink_end_node(tree->left, LEFT, found_node);
+        if (tree->left == NULL) {
+            tree->left = (*found_node)->right;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    } else {
+        node = tree->right;
+        tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+        if (tree->right == NULL) {
+            tree->right = (*found_node)->left;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    }
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return do_balance(tree);
+}
+
+
+static avl_node_t*
+avltree_insert(
+    avl_node_t* tree,
+    jmem_key_t key,
+    page_t* page
+)
+{
+    if (tree == NULL) {
+        tree = make_avl_node(key, page);
+    } else {
+        if (key >= tree->key) {
+            tree->right = avltree_insert(tree->right, key, page);
+        } else {
+            tree->left  = avltree_insert(tree->left, key, page);
+        }
+    }
+
+    tree = do_balance(tree);
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return tree;
+}
+
+static avl_node_t*
+do_unlink(
+    avl_node_t* tree
+)
+{
+    avl_node_t* node;
+    avl_node_t* end_node;
+    node = unlink_end_node(tree->right, LEFT, &end_node);
+    if (node) {
+        tree->right = node;
+    } else {
+        node = unlink_end_node(tree->left, RIGHT, &end_node);
+        if (node) tree->left = node;
+    }
+
+    if (node == NULL) {
+        node = tree->right ? tree->right : tree->left;
+        end_node = node;
+    }
+
+    if (end_node) {
+        end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+        end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+        end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+    }
+
+    tree = end_node;
+
+    return tree;
+}
+
+static avl_node_t*
+avltree_remove(
+    avl_node_t* tree,
+    avl_node_t** found_node,
+    jmem_key_t key
+)
+{
+    *found_node = NULL;
+    if (tree == NULL) {
+        printk(KERN_INFO "failed to find key %d\n", (int)key);
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found_node = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = avltree_remove(tree->right, found_node, key);
+    } else {
+        tree->left  = avltree_remove(tree->left, found_node, key);
+    }
+
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+void
+jpu_avltree_free(
+    avl_node_t* tree
+)
+{
+    if (tree == NULL) return;
+    if (tree->left == NULL && tree->right == NULL) {
+        VMEM_P_FREE(tree);
+        return;
+    }
+
+    jpu_avltree_free(tree->left);
+    tree->left = NULL;
+    jpu_avltree_free(tree->right);
+    tree->right = NULL;
+}
+
+
+
+
+static avl_node_t*
+remove_approx_value(
+    avl_node_t* tree,
+    avl_node_t** found,
+    jmem_key_t key
+)
+{
+    *found = NULL;
+    if (tree == NULL) {
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = remove_approx_value(tree->right, found, key);
+    } else {
+        tree->left  = remove_approx_value(tree->left, found, key);
+        if (*found == NULL) {
+            *found = tree;
+            tree = do_unlink(tree);
+        }
+    }
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+static void
+set_blocks_free(
+    jpu_mm_t *mm,
+    int pageno,
+    int npages
+)
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    VMEM_ASSERT(npages);
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+    last_page   = &mm->page_list[last_pageno];
+    last_page->first_pageno = pageno;
+
+    mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void
+set_blocks_alloc(
+    jpu_mm_t *mm,
+    int pageno,
+    int npages
+)
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 1;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+
+    last_page   = &mm->page_list[last_pageno];
+    last_page->first_pageno = pageno;
+
+    mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int
+jmem_init(
+    jpu_mm_t* mm,
+    unsigned long addr,
+    unsigned long size
+)
+{
+    int i;
+
+
+    mm->base_addr  = (addr+(JMEM_PAGE_SIZE-1))&~(JMEM_PAGE_SIZE-1);
+    mm->mem_size   = size&~JMEM_PAGE_SIZE;
+    mm->num_pages  = mm->mem_size/JMEM_PAGE_SIZE;
+    mm->page_list  = (page_t*)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = mm->num_pages;
+    mm->alloc_page_count = 0;
+
+    for (i=0; i<mm->num_pages; i++) {
+        mm->page_list[i].pageno       = i;
+        mm->page_list[i].addr         = mm->base_addr + i*JMEM_PAGE_SIZE;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    set_blocks_free(mm, 0, mm->num_pages);
+
+    return 0;
+}
+
+int
+jmem_exit(
+    jpu_mm_t* mm
+)
+{
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_exit: invalid handle\n");
+        return -1;
+    }
+
+    if (mm->free_tree) {
+        jpu_avltree_free(mm->free_tree);
+    }
+    if (mm->alloc_tree) {
+        jpu_avltree_free(mm->alloc_tree);
+    }
+
+    VMEM_P_FREE(mm->page_list);
+
+    mm->base_addr  = 0;
+    mm->mem_size   = 0;
+    mm->num_pages  = 0;
+    mm->page_list  = NULL;
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = 0;
+    mm->alloc_page_count = 0;
+    return 0;
+}
+
+unsigned long
+jmem_alloc(
+    jpu_mm_t* mm,
+    int size,
+    unsigned long pid
+)
+{
+    avl_node_t* node;
+    page_t*     free_page;
+    int         npages, free_size;
+    int         alloc_pageno;
+    unsigned long  ptr;
+
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_alloc: invalid handle\n");
+        return -1;
+    }
+
+    if (size <= 0) return -1;
+
+    npages = (size + JMEM_PAGE_SIZE -1)/JMEM_PAGE_SIZE;
+
+    mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+    if (node == NULL) {
+        return -1;
+    }
+    free_page = node->page;
+    free_size = KEY_TO_VALUE(node->key);
+
+    alloc_pageno = free_page->pageno;
+    set_blocks_alloc(mm, alloc_pageno, npages);
+    if (npages != free_size) {
+        int free_pageno = alloc_pageno + npages;
+        set_blocks_free(mm, free_pageno, (free_size-npages));
+    }
+
+    VMEM_P_FREE(node);
+
+    ptr = mm->page_list[alloc_pageno].addr;
+    mm->alloc_page_count += npages;
+    mm->free_page_count  -= npages;
+
+
+    return ptr;
+}
+
+int
+jmem_free(
+    jpu_mm_t* mm,
+    unsigned long ptr,
+    unsigned long pid
+)
+{
+    unsigned long addr;
+    avl_node_t* found;
+    page_t* page;
+    int pageno, prev_free_pageno, next_free_pageno;
+    int prev_size, next_size;
+    int merge_page_no, merge_page_size, free_page_size;
+
+
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_free: invalid handle\n");
+        return -1;
+    }
+
+    addr = ptr;
+
+    mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+    if (found == NULL) {
+        printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+        VMEM_ASSERT(0);
+        return -1;
+    }
+
+    /* find previous free block */
+    page = found->page;
+    pageno = page->pageno;
+    free_page_size = page->alloc_pages;
+    prev_free_pageno = pageno-1;
+    prev_size = -1;
+    if (prev_free_pageno >= 0) {
+        if (mm->page_list[prev_free_pageno].used == 0) {
+            prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+            prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+        }
+    }
+
+    /* find next free block */
+    next_free_pageno = pageno + page->alloc_pages;
+    next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+    next_size = -1;
+    if (next_free_pageno >= 0) {
+        if (mm->page_list[next_free_pageno].used == 0) {
+            next_size = mm->page_list[next_free_pageno].alloc_pages;
+        }
+    }
+    VMEM_P_FREE(found);
+
+    /* merge */
+    merge_page_no = page->pageno;
+    merge_page_size = page->alloc_pages;
+    if (prev_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_no = found->page->pageno;
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+    if (next_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+
+    page->alloc_pages  = 0;
+    page->first_pageno = -1;
+
+    set_blocks_free(mm, merge_page_no, merge_page_size);
+
+    mm->alloc_page_count -= free_page_size;
+    mm->free_page_count  += free_page_size;
+
+    return 0;
+}
+
+
+
+#endif /* __JPU_MM_H__ */
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/jdi/jpu.c b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/jpu.c
new file mode 100755
index 00000000..8ad5523
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/jpu.c
@@ -0,0 +1,1084 @@
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+
+#include "jpu.h"
+#include "compat_jpu.h"
+#include "../puwrap.h"
+
+//from jpuconfig.h
+#define MAX_NUM_INSTANCE 8
+#define MAX_INST_HANDLE_SIZE (12*1024)
+
+/* definitions to be changed as customer  configuration */
+//#define JPU_SUPPORT_CLOCK_CONTROL /if you want to have clock gating scheme frame by frame
+#define JPU_SUPPORT_ISR
+/* if the platform driver knows the name of this driver. JPU_PLATFORM_DEVICE_NAME */
+#define JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+#ifndef CONFIG_RTK_RESERVE_MEMORY
+/* if this driver knows the dedicated video memory address */
+//#define JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#endif
+//#define JPU_IRQ_CONTROL
+#ifdef JPU_FRAGMENT_FRAME_BITSTREAM
+#define JPU_IRQ_CONTROL
+#endif
+#define DEV_NAME "[RTK_JPU]"
+#define JPU_PLATFORM_DEVICE_NAME "jdec"
+#define JPU_CLK_NAME "jpeg"
+#define JPU_DEV_NAME "jpu"
+
+#define JPU_BASE_ADDR 0x9803e000
+#define JPU_REG_SIZE 0x1000
+
+#ifdef JPU_SUPPORT_ISR
+#define JPU_IRQ_NUM 84+32
+#endif
+
+#ifndef VM_RESERVED /* for kernel up to 3.7.0 version */
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+typedef struct jpu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long interrupt_reason;
+} jpu_drv_context_t;
+
+/* To track the allocated memory buffer */
+typedef struct jpudrv_buffer_pool_t {
+	struct list_head list;
+	struct jpudrv_buffer_t jb;
+	struct file *filp;
+} jpudrv_buffer_pool_t;
+
+/* To track the instance index and buffer in instance pool */
+typedef struct jpudrv_instanace_list_t {
+	struct list_head list;
+	unsigned long inst_idx;
+	struct file *filp;
+} jpudrv_instanace_list_t;
+
+typedef struct jpudrv_instance_pool_t {
+	unsigned char jpgInstPool[MAX_NUM_INSTANCE][MAX_INST_HANDLE_SIZE];
+} jpudrv_instance_pool_t;
+
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#define JPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)
+#define JPU_DRAM_PHYSICAL_BASE (0x8AA00000)
+#include "jmm.h"
+static jpu_mm_t s_jmem;
+static jpudrv_buffer_t s_image_memory = {0};
+#endif
+
+static int jpu_hw_reset(void);
+static void jpu_clk_disable(struct clk *clk);
+static int jpu_clk_enable(struct clk *clk);
+static struct clk *jpu_clk_get(struct device *dev);
+static void jpu_clk_put(struct clk *clk);
+// end customer definition
+
+static jpudrv_buffer_t s_jpu_instance_pool = {0};
+static jpu_drv_context_t s_jpu_drv_context;
+static struct miscdevice s_jpu_dev;
+static int s_jpu_open_count;
+static struct clk *s_jpu_clk;
+static struct reset_control *rstc_jpeg = NULL;
+#ifdef JPU_SUPPORT_ISR
+static int s_jpu_irq = JPU_IRQ_NUM;
+static atomic_t s_interrupt_flag;
+#endif
+static unsigned long s_jpu_reg_phy_base = JPU_BASE_ADDR;
+static void __iomem *s_jpu_reg_virt_base;
+static jpudrv_buffer_t s_jpu_register = {0};
+static jpudrv_buffer_t s_bonding_register = {0};
+
+static unsigned long s_jpu_pll_phy_base = 0;
+static void __iomem *s_jpu_pll_virt_base = NULL;
+static unsigned long s_jpu_pll_size = 0;
+
+static wait_queue_head_t s_interrupt_wait_q;
+static int dbus_en = 1;
+
+#define JPEG_DBUS_REG (0x0000 + 0xF00)
+
+static spinlock_t s_jpu_lock = __SPIN_LOCK_UNLOCKED(s_jpu_lock);
+static DEFINE_SEMAPHORE(s_jpu_sem);
+static struct list_head s_jbp_head = LIST_HEAD_INIT(s_jbp_head);
+static struct list_head s_jpu_inst_list_head = LIST_HEAD_INIT(s_jpu_inst_list_head);
+
+/* implement to power management functions */
+#define ReadJpuRegister(addr) *(volatile unsigned int *)(s_jpu_reg_virt_base + addr)
+#define WriteJpuRegister(addr, val) *(volatile unsigned int *)(s_jpu_reg_virt_base + addr) = (unsigned int)val;
+
+#if 0 /* Fuchun disable 20160204, set clock gating by jdi.c */
+static void jpu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable)
+{
+	if (s_jpu_pll_phy_base == 0 || s_jpu_pll_virt_base == 0 || s_jpu_pll_size == 0) {
+		pr_warn("%s In[%s][%d] didn't get pll register\n", DEV_NAME, __FUNCTION__, __LINE__);
+		return;
+	} else if (offset > s_jpu_pll_size) {
+		pr_warn("%s In[%s][%d] offset over than register size\n", DEV_NAME, __FUNCTION__, __LINE__);
+		return;
+	}
+
+	if (bOverwrite == 1) {
+		__raw_writel(value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+	} else {
+		if (bEnable)
+			__raw_writel(__raw_readl((volatile u8 *)(s_jpu_pll_virt_base+offset)) | value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+		else
+			__raw_writel(__raw_readl((volatile u8 *)(s_jpu_pll_virt_base+offset)) & value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+	}
+}
+#endif
+
+static int jpu_alloc_dma_buffer(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	jb->phys_addr = (unsigned long)jmem_alloc(&s_jmem, jb->size, 0);
+
+	if ((unsigned long)jb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+
+	jb->base = (unsigned long)(s_image_memory.base + (jb->phys_addr - s_image_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	unsigned int ret;
+	ret = pu_alloc_dma_buffer(jb->size, &jb->phys_addr, &jb->base, 0);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#else
+	jb->base = (unsigned long)dma_alloc_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (dma_addr_t *) (&jb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#endif
+	pr_info("%s base:0x%08x, phy_addr:0x%08x, size:%d\n", DEV_NAME, (unsigned int)jb->base, (unsigned int)jb->phys_addr, jb->size);
+	return 0;
+}
+
+static int jpu_alloc_dma_buffer2(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	jb->phys_addr = (unsigned long)jmem_alloc(&s_jmem, jb->size, 0);
+
+	if ((unsigned long)jb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+
+	jb->base = (unsigned long)(s_image_memory.base + (jb->phys_addr - s_image_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	unsigned int ret;
+	ret = pu_alloc_dma_buffer(jb->size, &jb->phys_addr, &jb->base, 0);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+	jb->base = pu_mmap_kernel_buffer(jb->phys_addr, jb->size);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s pu_mmap_kernel_buffer error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#else
+	jb->base = (unsigned long)dma_alloc_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (dma_addr_t *) (&jb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#endif
+//	pr_info("%s base:0x%08x, phy_addr:0x%08x, size:%d\n", DEV_NAME, (unsigned int)jb->base, (unsigned int)jb->phys_addr, jb->size);
+	return 0;
+}
+
+static void jpu_free_dma_buffer(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (jb->base)
+		jmem_free(&s_jmem, jb->phys_addr, 0);
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	pu_free_dma_buffer(jb->base, jb->phys_addr);
+#else
+	if (jb->base)
+		dma_free_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (void *)jb->base, jb->phys_addr);
+#endif
+}
+
+static int jpu_free_instances(struct file *filp)
+{
+	u32 inst_idx;
+	jpudrv_instanace_list_t *jil, *n;
+	jpudrv_instance_pool_t *jip;
+	void *jip_base;
+	void* jdi_mutex_base;
+	const unsigned int PTHREAD_MUTEX_T_DESTROY_VALUE = 0xdead10cc;
+
+	list_for_each_entry_safe(jil, n, &s_jpu_inst_list_head, list) {
+		if (jil->filp == filp) {
+			inst_idx = jil->inst_idx;
+			jip_base = (void *)(s_jpu_instance_pool.base);
+			jip = (jpudrv_instance_pool_t *)jip_base;
+			if (jip) {
+				memset(&jip->jpgInstPool[inst_idx], 0x00, 4);	// only first 4 byte is key point to free the corresponding instance.
+#define PTHREAD_MUTEX_T_HANDLE_SIZE 40
+				jdi_mutex_base = (jip_base + (s_jpu_instance_pool.size - PTHREAD_MUTEX_T_HANDLE_SIZE));
+				if (jdi_mutex_base) {
+					memcpy(jdi_mutex_base, &PTHREAD_MUTEX_T_DESTROY_VALUE, PTHREAD_MUTEX_T_HANDLE_SIZE);
+				}
+			}
+			s_jpu_open_count--;
+			list_del(&jil->list);
+			kfree(jil);
+		}
+	}
+
+	return s_jpu_open_count;
+}
+
+static int jpu_free_buffers(struct file *filp)
+{
+	jpudrv_buffer_pool_t *pool, *n;
+	jpudrv_buffer_t jb;
+
+	list_for_each_entry_safe(pool, n, &s_jbp_head, list) {
+		if (pool->filp == filp) {
+			jb = pool->jb;
+			if (jb.base) {
+				jpu_free_dma_buffer(&jb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+
+	return 0;
+}
+
+#ifdef JPU_SUPPORT_ISR
+static irqreturn_t jpu_irq_handler(int irq, void *dev_id)
+{
+	jpu_drv_context_t *dev = (jpu_drv_context_t *)dev_id;
+#ifdef JPU_FRAGMENT_FRAME_BITSTREAM
+	unsigned long value = 0;
+
+	value = ReadJpuRegister(0x004); /* MJPEG_PIC_STATUS_REG */
+	if(value == 0)
+		return IRQ_HANDLED;
+#endif
+
+#ifdef JPU_IRQ_CONTROL
+	disable_irq_nosync(s_jpu_irq);
+#endif
+
+#ifdef JPU_FRAGMENT_FRAME_BITSTREAM
+	dev->interrupt_reason = value;
+#else
+	dev->interrupt_reason = ReadJpuRegister(0x004); /* MJPEG_PIC_STATUS_REG */
+	WriteJpuRegister(0x004, dev->interrupt_reason);
+#endif
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN); /* notify the interrupt to userspace */
+
+	atomic_set(&s_interrupt_flag, 1);
+
+	//pr_info("%s jpu_irq_handler\n", DEV_NAME);
+	wake_up_interruptible(&s_interrupt_wait_q);
+
+	return IRQ_HANDLED;
+}
+#endif
+
+static int jpu_open(struct inode *inode, struct file *filp)
+{
+	spin_lock(&s_jpu_lock);
+
+	filp->private_data = (void *)(&s_jpu_drv_context);
+	spin_unlock(&s_jpu_lock);
+	return 0;
+}
+
+static long jpu_ioctl(struct file *filp, u_int cmd, u_long arg)
+{
+	int ret = 0;
+	struct jpu_drv_context_t *dev = (struct jpu_drv_context_t *)filp->private_data;
+	jpudrv_buffer_pool_t *jbp;
+	jpudrv_buffer_pool_t *n;
+	jpudrv_buffer_t jb;
+	jpudrv_intr_info_t info;
+	jpudrv_instanace_list_t *jil;
+	jpudrv_instanace_list_t *tmp;
+	u32 inst_idx;
+	u32 clkgate;
+	u32 val;
+
+	switch (cmd) {
+	case JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+		down(&s_jpu_sem);
+
+		jbp = kzalloc(sizeof(*jbp), GFP_KERNEL);
+		if (!jbp) {
+			up(&s_jpu_sem);
+			return -ENOMEM;
+		}
+
+		ret = copy_from_user(&(jbp->jb), (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+		if (ret) {
+			kfree(jbp);
+			up(&s_jpu_sem);
+			return -EFAULT;
+		}
+
+		ret = jpu_alloc_dma_buffer(&(jbp->jb));
+		if (ret == -1) {
+			ret = -ENOMEM;
+			kfree(jbp);
+			up(&s_jpu_sem);
+			break;
+		}
+
+		ret = copy_to_user((void __user *)arg, &(jbp->jb), sizeof(jpudrv_buffer_t));
+		if (ret) {
+			kfree(jbp);
+			ret = -EFAULT;
+			up(&s_jpu_sem);
+			break;
+		}
+
+		jbp->filp = filp;
+		spin_lock(&s_jpu_lock);
+		list_add(&jbp->list, &s_jbp_head);
+		spin_unlock(&s_jpu_lock);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_FREE_PHYSICALMEMORY:
+		down(&s_jpu_sem);
+
+		ret = copy_from_user(&jb, (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+		if (ret) {
+			up(&s_jpu_sem);
+			return -EACCES;
+		}
+
+		if (jb.base)
+			jpu_free_dma_buffer(&jb);
+
+		spin_lock(&s_jpu_lock);
+		list_for_each_entry_safe(jbp, n, &s_jbp_head, list) {
+			if (jbp->jb.base == jb.base) {
+				list_del(&jbp->list);
+				kfree(jbp);
+				break;
+			}
+		}
+		spin_unlock(&s_jpu_lock);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+		if (s_image_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_image_memory, sizeof(jpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = -EFAULT;
+		}
+#endif
+		break;
+#ifdef JPU_SUPPORT_ISR
+	case JDI_IOCTL_WAIT_INTERRUPT:
+		ret = copy_from_user(&info, (jpudrv_intr_info_t*)arg, sizeof(jpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		smp_rmb();
+		ret = wait_event_interruptible_timeout(s_interrupt_wait_q, atomic_read(&s_interrupt_flag) != 0, msecs_to_jiffies(info.timeout));
+		if (!ret) {
+			ret = -ETIME;
+			//pr_info("%s JDI_IOCTL_WAIT_INTERRUPT fail\n", DEV_NAME);
+			break;
+		}
+
+		if (signal_pending(current)) {
+			ret = -ERESTARTSYS;
+			break;
+		}
+
+		atomic_set(&s_interrupt_flag, 0);
+		info.intr_reason = dev->interrupt_reason;
+		ret = copy_to_user((void __user *)arg, &info, sizeof(jpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		//pr_info("%s JDI_IOCTL_WAIT_INTERRUPT done, info.intr_reason:0x%x\n", DEV_NAME, info.intr_reason);
+		break;
+#endif /* JPU_SUPPORT_ISR */
+	case JDI_IOCTL_ENABLE_INTERRUPT:
+#ifdef JPU_IRQ_CONTROL
+		enable_irq(s_jpu_irq);
+#endif
+		break;
+	case JDI_IOCTL_SET_CLOCK_GATE:
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+
+#ifdef JPU_SUPPORT_CLOCK_CONTROL
+		if (clkgate)
+			jpu_clk_enable(s_jpu_clk);
+		else
+			jpu_clk_disable(s_jpu_clk);
+#endif
+
+		break;
+	case JDI_IOCTL_GET_INSTANCE_POOL:
+		down(&s_jpu_sem);
+
+		if (s_jpu_instance_pool.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_jpu_instance_pool, sizeof(jpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = copy_from_user(&s_jpu_instance_pool, (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+			if (ret == 0) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+				s_jpu_instance_pool.size = PAGE_ALIGN(s_jpu_instance_pool.size);
+				s_jpu_instance_pool.base = (unsigned long)vmalloc(s_jpu_instance_pool.size);
+				s_jpu_instance_pool.phys_addr = s_jpu_instance_pool.base;
+
+				if (s_jpu_instance_pool.base != 0)
+#else
+				if (jpu_alloc_dma_buffer2(&s_jpu_instance_pool) != -1)
+#endif
+				{
+					memset((void *)s_jpu_instance_pool.base, 0x0, s_jpu_instance_pool.size);
+					ret = copy_to_user((void __user *)arg, &s_jpu_instance_pool, sizeof(jpudrv_buffer_t));
+					if (ret == 0) {
+						// success to get memory for instance pool
+						up(&s_jpu_sem);
+						break;
+					}
+				}
+			}
+			ret = -EFAULT;
+		}
+		up(&s_jpu_sem);
+
+		break;
+	case JDI_IOCTL_OPEN_INSTANCE:
+		jil = kzalloc(sizeof(*jil), GFP_KERNEL);
+		if (!jil)
+			return -ENOMEM;
+
+		if (get_user(inst_idx, (u32 __user *) arg))
+			return -EFAULT;
+
+		jil->inst_idx = inst_idx;
+		jil->filp = filp;
+		spin_lock(&s_jpu_lock);
+		list_add(&jil->list, &s_jpu_inst_list_head);
+		s_jpu_open_count++;
+		spin_unlock(&s_jpu_lock);
+		break;
+	case JDI_IOCTL_CLOSE_INSTANCE:
+		if (get_user(inst_idx, (u32 __user *) arg))
+			return -EFAULT;
+
+		spin_lock(&s_jpu_lock);
+
+		list_for_each_entry_safe(jil, tmp, &s_jpu_inst_list_head, list) {
+			if (jil->inst_idx == inst_idx) {
+				s_jpu_open_count--;
+				list_del(&jil->list);
+				kfree(jil);
+				printk(KERN_INFO "[JPUDRV] JDI_IOCTL_CLOSE_INSTANCE inst_idx=%d, open_count=%d\n", (int)inst_idx, s_jpu_open_count);
+				break;
+			}
+		}
+		spin_unlock(&s_jpu_lock);
+		break;
+	case JDI_IOCTL_GET_INSTANCE_NUM:
+		down(&s_jpu_sem);
+
+		ret = copy_to_user((void __user *)arg, &s_jpu_open_count, sizeof(int));
+		if (ret != 0)
+			ret = -EFAULT;
+
+		//printk(KERN_INFO "[JPUDRV] VDI_IOCTL_GET_INSTANCE_NUM open_count=%d\n", s_jpu_open_count);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_RESET:
+		jpu_hw_reset();
+		break;
+	case JDI_IOCTL_GET_REGISTER_INFO:
+		ret = copy_to_user((void __user *)arg, &s_jpu_register, sizeof(jpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		break;
+	case JDI_IOCTL_GET_BONDING_INFO:
+		ret = copy_to_user((void __user *)arg, &s_bonding_register, sizeof(jpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		break;
+	case JDI_IOCTL_SET_CLOCK_ENABLE:
+
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+
+		if (clkgate) {
+			reset_control_deassert(rstc_jpeg);
+			jpu_clk_enable(s_jpu_clk);
+			val = ReadJpuRegister(JPEG_DBUS_REG);
+			val |= (dbus_en << 0);
+			val &= ~(1 << 1); //Disable idle gating, fix it later.
+			WriteJpuRegister(JPEG_DBUS_REG, val);
+		} else {
+			jpu_clk_disable(s_jpu_clk);
+			reset_control_assert(rstc_jpeg);
+		}
+		break;
+	default:
+		printk(KERN_ERR "No such IOCTL, cmd is %d\n", cmd);
+		break;
+	}
+
+	return ret;
+}
+
+static ssize_t jpu_read(struct file *filp, char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static ssize_t jpu_write(struct file *filp, const char __user *buf, size_t len, loff_t *ppos)
+{
+
+	return -1;
+}
+
+static int jpu_release(struct inode *inode, struct file *filp)
+{
+	pr_info("%s jpu_release s_jpu_open_count=%d\n", DEV_NAME, s_jpu_open_count);
+
+	spin_lock(&s_jpu_lock);
+
+
+	if (s_jpu_open_count > 0) {
+		/* found and free the not handled buffer by user applications */
+		jpu_free_buffers(filp);
+
+		/* found and free the not closed instance by user applications */
+		jpu_free_instances(filp);
+	}
+
+#if 1 //Fuchun 20150909, we must not free instance pool and common memory
+	if (s_jpu_open_count == 0) {
+		if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_jpu_instance_pool.base);
+#else
+			pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+			jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+			s_jpu_instance_pool.base = 0;
+			pr_info("%s jpu_release - free s_jpu_instance_pool\n", DEV_NAME);
+		}
+	}
+#endif
+
+	spin_unlock(&s_jpu_lock);
+
+	return 0;
+}
+
+static int jpu_fasync(int fd, struct file *filp, int mode)
+{
+	struct jpu_drv_context_t *dev = (struct jpu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+static int jpu_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	pfn = vm->vm_pgoff;
+
+	return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int jpu_map_to_physical_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+	return pu_mmap_dma_buffer(vm);
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif
+}
+
+static int jpu_map_to_instance_pool_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	int ret;
+	long length = vm->vm_end - vm->vm_start;
+	unsigned long start = vm->vm_start;
+	char *vmalloc_area_ptr = (char *)s_jpu_instance_pool.base;
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_RESERVED;
+
+	/* loop over all pages, map it page individually */
+	while (length > 0) {
+		pfn = vmalloc_to_pfn(vmalloc_area_ptr);
+		if ((ret = remap_pfn_range(vm, start, pfn, PAGE_SIZE, PAGE_SHARED)) < 0) {
+			return ret;
+		}
+		start += PAGE_SIZE;
+		vmalloc_area_ptr += PAGE_SIZE;
+		length -= PAGE_SIZE;
+	}
+
+	return 0;
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif
+}
+
+/*!
+ * @brief memory map interface for jpu file operation
+ * @return  0 on success or negative error code on error
+ */
+static int jpu_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	if (vm->vm_pgoff == 0)
+		return jpu_map_to_instance_pool_memory(fp, vm);
+
+	if ((vm->vm_pgoff == (s_jpu_register.phys_addr>>PAGE_SHIFT)) || (vm->vm_pgoff == (s_bonding_register.phys_addr>>PAGE_SHIFT)))
+		return jpu_map_to_register(fp, vm);
+
+	return jpu_map_to_physical_memory(fp, vm);
+#else
+	if (vm->vm_pgoff) {
+		if (vm->vm_pgoff == (s_jpu_instance_pool.phys_addr>>PAGE_SHIFT))
+			return  jpu_map_to_instance_pool_memory(fp, vm);
+
+		return jpu_map_to_physical_memory(fp, vm);
+	} else
+		return jpu_map_to_register(fp, vm);
+#endif
+}
+
+struct file_operations jpu_fops = {
+	.owner = THIS_MODULE,
+	.open = jpu_open,
+	.read = jpu_read,
+	.write = jpu_write,
+	.unlocked_ioctl = jpu_ioctl,
+	.compat_ioctl   = compat_jpu_ioctl,
+	.release = jpu_release,
+	.fasync = jpu_fasync,
+	.mmap = jpu_mmap,
+};
+
+static int jpu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+	struct resource res;
+	void __iomem *iobase;
+	int irq;
+	struct device_node *node = pdev->dev.of_node;
+
+	pr_info("%s jpu_probe\n", DEV_NAME);
+
+	of_address_to_resource(node, 0, &res);
+	iobase = of_iomap(node, 0);
+
+	s_jpu_reg_phy_base = res.start;
+	s_jpu_reg_virt_base = iobase;
+	s_jpu_register.phys_addr = res.start;
+	s_jpu_register.virt_addr = (unsigned long)iobase;
+	s_jpu_register.size = res.end - res.start + 1;
+
+	pr_info("%s jpu base address get from DTB physical base addr=0x%lx, virtual base=0x%lx, size=0x%x\n", DEV_NAME, (unsigned long)s_jpu_reg_phy_base, (unsigned long)s_jpu_reg_virt_base, (unsigned int)(res.end - res.start + 1));
+
+	of_address_to_resource(node, 1, &res);
+	iobase = of_iomap(node, 1);
+
+	s_jpu_pll_phy_base = res.start;
+	s_jpu_pll_virt_base = iobase;
+	s_jpu_pll_size = res.end - res.start + 1;
+
+	of_address_to_resource(node, 2, &res);
+	iobase = of_iomap(node, 2);
+
+	s_bonding_register.phys_addr = res.start;
+	s_bonding_register.virt_addr = (unsigned long)iobase;
+	s_bonding_register.size = res.end - res.start + 1;
+
+	s_jpu_dev.minor = MISC_JPU_MINOR;
+	s_jpu_dev.name = JPU_DEV_NAME;
+	s_jpu_dev.fops = &jpu_fops;
+	s_jpu_dev.parent = NULL;
+	if (misc_register(&s_jpu_dev)) {
+		pr_info("%s failed to register misc device.", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (pdev)
+		s_jpu_clk = jpu_clk_get(&pdev->dev);
+	else
+		s_jpu_clk = jpu_clk_get(NULL);
+
+	if (!s_jpu_clk)
+		pr_err("%s fail to get clock controller, but, do not treat as error, \n", DEV_NAME);
+	else
+		pr_info("%s get clock controller s_jpu_clk=0x%p\n", DEV_NAME, s_jpu_clk);
+
+#ifdef JPU_SUPPORT_CLOCK_CONTROL
+	jpu_clk_enable(s_jpu_clk);
+#endif
+
+	rstc_jpeg = reset_control_get(&pdev->dev, NULL);
+
+	/* RTK clock setting */
+	reset_control_deassert(rstc_jpeg); // RESET disable
+#if 0 //Fuchun disable 20160204, set clock gating by jdi.c
+	jpu_pll_setting(0x10, (1 << jpg_clk_enable_bit), 0, 1); // CLK enable
+
+	val = ReadJpuRegister(JPEG_DBUS_REG);
+	val |= (dbus_en << 0);
+	WriteJpuRegister(JPEG_DBUS_REG, val);
+#endif
+
+#ifdef JPU_SUPPORT_ISR
+	irq = irq_of_parse_and_map(node, 0);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_jpu_irq = irq;
+	pr_info("%s s_jpu_irq:%d want to register jpu_irq_handler\n", DEV_NAME, s_jpu_irq);
+	err = request_irq(s_jpu_irq, jpu_irq_handler, 0, "JPEG_CODEC_IRQ", (void *)(&s_jpu_drv_context));
+	err = 0;
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_jpu_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_jpu_irq <%d> busy, change your config\n", DEV_NAME, s_jpu_irq);
+
+		goto ERROR_PROVE_DEVICE;
+	}
+#endif
+
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	s_image_memory.size = JPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+	s_image_memory.phys_addr = JPU_DRAM_PHYSICAL_BASE;
+	s_image_memory.base = (unsigned long)ioremap(s_image_memory.phys_addr, PAGE_ALIGN(s_image_memory.size));
+
+	if (!s_image_memory.base) {
+		pr_err("%s fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", DEV_NAME, (int)s_image_memory.phys_addr, (int)s_image_memory.base, (int)s_image_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (jmem_init(&s_jmem, s_image_memory.phys_addr, s_image_memory.size) < 0) {
+		pr_err("%s fail to init vmem system\n", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	pr_info("%s success to probe jpu device with reserved video memory phys_addr=0x%x, base = 0x%x\n", DEV_NAME, (int) s_image_memory.phys_addr, (int)s_image_memory.base);
+#else
+	pr_info("%s success to probe jpu device with non reserved video memory\n", DEV_NAME);
+#endif
+
+	reset_control_assert(rstc_jpeg);
+
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+	misc_deregister(&s_jpu_dev);
+
+	if (s_jpu_reg_virt_base)
+		iounmap(s_jpu_reg_virt_base);
+
+	return err;
+}
+
+static int jpu_remove(struct platform_device *pdev)
+{
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	pr_info("%s jpu_remove\n", DEV_NAME);
+
+	if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_jpu_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+		jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+		s_jpu_instance_pool.base = 0;
+	}
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_image_memory.base) {
+		iounmap((void *)s_image_memory.base);
+		s_image_memory.base = 0;
+		jmem_exit(&s_jmem);
+	}
+#endif
+
+	misc_deregister(&s_jpu_dev);
+
+#ifdef JPU_SUPPORT_ISR
+	if (s_jpu_irq)
+		free_irq(s_jpu_irq, &s_jpu_drv_context);
+#endif
+
+	if (s_jpu_reg_virt_base)
+		iounmap(s_jpu_reg_virt_base);
+
+	if (rstc_jpeg != NULL)
+		reset_control_put(rstc_jpeg);
+
+	jpu_clk_put(s_jpu_clk);
+
+#endif //JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+static int jpu_suspend(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+	reset_control_deassert(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+#if 0
+	if (s_jpu_open_count > 0) {
+		u32 inst_idx;
+		jpudrv_instanace_list_t *jil, *n;
+		jpudrv_instance_pool_t *jip;
+		void *jip_base;
+		jpudrv_buffer_pool_t *pool, *n;
+		jpudrv_buffer_t jb;
+
+		s_jpu_open_count = 0;
+		atomic_set(&s_interrupt_flag, 0);
+		wake_up_interruptible_all(&s_interrupt_wait_q);
+
+		if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_jpu_instance_pool.base);
+#else
+			jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+			s_jpu_instance_pool.base = 0;
+			pr_info("%s jpu_release - free s_jpu_instance_pool\n", DEV_NAME);
+		}
+
+		list_for_each_entry_safe(jil, n, &s_jpu_inst_list_head, list) {
+			inst_idx = jil->inst_idx;
+			jip_base = (void *)(s_jpu_instance_pool.base);
+			jip = (jpudrv_instance_pool_t *)jip_base;
+			if (jip) {
+				memset(&jip->jpgInstPool[inst_idx], 0x00, 4);	// only first 4 byte is key point to free the corresponding instance.
+			}
+			list_del(&jil->list);
+			kfree(jil);
+		}
+
+		list_for_each_entry_safe(pool, n, &s_jbp_head, list) {
+			jb = pool->jb;
+			if (jb.base) {
+				jpu_free_dma_buffer(&jb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+#endif
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_assert(rstc_jpeg);
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+
+}
+
+static int jpu_resume(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+	reset_control_deassert(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_assert(rstc_jpeg);
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+#else
+#define jpu_suspend NULL
+#define jpu_resume NULL
+#endif /* !CONFIG_PM */
+
+static int __init jpu_init(void)
+{
+	int res;
+	res = 0;
+
+	pr_info("%s jpu_init\n", DEV_NAME);
+	init_waitqueue_head(&s_interrupt_wait_q);
+	s_jpu_instance_pool.base = 0;
+
+	pr_info("%s end jpu_init result=0x%x\n", DEV_NAME, res);
+	return res;
+}
+
+static void __exit jpu_exit(void)
+{
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	pr_info("%s jpu_exit\n", DEV_NAME);
+#else
+	if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_jpu_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+		jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+		s_jpu_instance_pool.base = 0;
+	}
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_image_memory.base) {
+		iounmap((void *)s_image_memory.base);
+		s_image_memory.base = 0;
+	}
+#endif
+
+	misc_deregister(&s_jpu_dev);
+
+#ifdef JPU_SUPPORT_ISR
+	if (s_jpu_irq)
+		free_irq(s_jpu_irq, &s_jpu_drv_context);
+#endif
+
+	if (rstc_jpeg != NULL)
+		reset_control_put(rstc_jpeg);
+
+	jpu_clk_put(s_jpu_clk);
+
+
+	if (s_jpu_reg_virt_base) {
+		iounmap(s_jpu_reg_virt_base);
+		s_jpu_reg_virt_base = (void *)0x00;
+	}
+
+#endif //JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	return;
+}
+
+MODULE_AUTHOR("A customer using RTK JPU, Inc.");
+MODULE_DESCRIPTION("JPU linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(jpu_init);
+module_exit(jpu_exit);
+
+int jpu_hw_reset(void)
+{
+	u32 val;
+
+	pr_info("%s request jpu reset from application\n", DEV_NAME);
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_reset(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+	val = ReadJpuRegister(JPEG_DBUS_REG);
+	val |= (dbus_en << 0);
+	val &= ~(1 << 1); //Disable idle gating, fix it later.
+	WriteJpuRegister(JPEG_DBUS_REG, val);
+	return 0;
+}
+
+struct clk *jpu_clk_get(struct device *dev)
+{
+	return clk_get(dev, JPU_CLK_NAME);
+}
+
+void jpu_clk_put(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk)))
+		clk_put(clk);
+}
+
+int jpu_clk_enable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+		pr_info("%s jpu_clk_enable\n", DEV_NAME);
+		return clk_prepare_enable(clk);
+	}
+	return 0;
+}
+
+void jpu_clk_disable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+		pr_info("%s jpu_clk_disable\n", DEV_NAME);
+		clk_disable_unprepare(clk);
+	}
+}
+
+static const struct of_device_id rtk_jpeg_dt_match[] = {
+	{ .compatible = "Realtek,rtk1295-jpeg" },
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtk_jpeg_dt_match);
+
+const struct dev_pm_ops rtk_jpeg_pmops = {
+	.suspend = jpu_suspend,
+	.resume = jpu_resume,
+};
+
+static struct platform_driver rtk_jpeg_driver = {
+	.driver = {
+		.name = "rtk-jpeg",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_jpeg_dt_match,
+		.pm = &rtk_jpeg_pmops,
+	},
+	.probe = jpu_probe,
+	.remove = jpu_remove,
+};
+
+module_platform_driver(rtk_jpeg_driver);
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/jdi/jpu.h b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/jpu.h
new file mode 100644
index 00000000..51968bd
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/jdi/jpu.h
@@ -0,0 +1,41 @@
+
+
+#ifndef __JPU_DRV_H__
+#define __JPU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+#define J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+
+#define JDI_IOCTL_MAGIC  'J'
+#define JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY			_IO(JDI_IOCTL_MAGIC, 0)
+#define JDI_IOCTL_FREE_PHYSICALMEMORY			_IO(JDI_IOCTL_MAGIC, 1)
+#define JDI_IOCTL_WAIT_INTERRUPT			_IO(JDI_IOCTL_MAGIC, 2)
+#define JDI_IOCTL_SET_CLOCK_GATE			_IO(JDI_IOCTL_MAGIC, 3)
+#define JDI_IOCTL_RESET						_IO(JDI_IOCTL_MAGIC, 4)
+#define JDI_IOCTL_GET_INSTANCE_POOL			_IO(JDI_IOCTL_MAGIC, 5)
+#define JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO			_IO(JDI_IOCTL_MAGIC, 6)
+#define JDI_IOCTL_OPEN_INSTANCE				_IO(JDI_IOCTL_MAGIC, 7)
+#define JDI_IOCTL_CLOSE_INSTANCE			_IO(JDI_IOCTL_MAGIC, 8)
+#define JDI_IOCTL_GET_INSTANCE_NUM			_IO(JDI_IOCTL_MAGIC, 9)
+#define JDI_IOCTL_ENABLE_INTERRUPT			_IO(JDI_IOCTL_MAGIC, 10)
+#define JDI_IOCTL_GET_REGISTER_INFO			_IO(JDI_IOCTL_MAGIC, 11)
+
+/* RTK ioctl */
+#define JDI_IOCTL_SET_CLOCK_ENABLE			_IO(JDI_IOCTL_MAGIC, 12)
+#define JDI_IOCTL_GET_BONDING_INFO			_IO(JDI_IOCTL_MAGIC, 13)
+
+typedef struct jpudrv_buffer_t {
+    unsigned int size;
+    unsigned long phys_addr;
+    unsigned long base;							/* kernel logical address in use kernel */
+    unsigned long virt_addr;				/* virtual user space address */
+} jpudrv_buffer_t;
+
+typedef struct jpudrv_intr_info_t {
+    unsigned int timeout;
+    int intr_reason;
+} jpudrv_intr_info_t;
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/puwrap.c b/drivers/soc/realtek/rtd129x/rtk_ve/puwrap.c
new file mode 100644
index 00000000..96c38b3
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/puwrap.c
@@ -0,0 +1,539 @@
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/module.h>
+
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/dma-buf.h>
+#include <linux/reservation.h>
+
+#include "puwrap.h"
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#define USE_ION_ALLOCATOR
+#ifdef USE_ION_ALLOCATOR
+#define NUM_ION_STRUCT 256
+#include "../../../../staging/android/ion/ion.h"
+#include "../../../../staging/android/uapi/ion_rtk.h"
+struct rtkdrv_ion_buffer_t {
+    unsigned int size;
+    unsigned int inUse;
+    unsigned long phys_addr;
+    unsigned long dmabuf;
+    unsigned long pIonHandle;
+};
+extern struct ion_device *rtk_phoenix_ion_device;
+struct ion_client *pu_client = NULL;
+struct rtkdrv_ion_buffer_t pu_ion_buffer[NUM_ION_STRUCT];
+static DEFINE_MUTEX(s_pu_mutex);
+#else /* else USE_ION_ALLOCATOR */
+typedef struct rtkdrv_buffer_t {
+    unsigned int size;
+    unsigned long phys_addr;
+    unsigned long base;							/* kernel logical address in use kernel */
+    unsigned long virt_addr;				/* virtual user space address */
+} rtkdrv_buffer_t;
+
+#define RTK_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)
+#define RTK_DRAM_PHYSICAL_BASE 0x06000000
+#include "rtk_mm.h"
+static video_mm_t s_mem;
+static rtkdrv_buffer_t s_memory = {0};
+#endif /* endif USE_ION_ALLOCATOR */
+#define VE_SECURE_NORMAL 1
+#define VE_SECURE_PROTECTION 2
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+unsigned long pll_phy_register = 0;
+unsigned long pll_virt_register = 0;
+unsigned long pll_size_register = 0;
+
+
+#define PU_PLATFORM_DEVICE_NAME "rtk_puwrap"
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+int pu_alloc_dma_buffer(unsigned int size, unsigned long *phys_addr, unsigned long *base, unsigned int mem_type)
+{
+#ifdef USE_ION_ALLOCATOR
+    int ret = -1;
+
+    if (!size)
+        return -1;
+
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct ion_handle *handle;
+        struct dma_buf *dmabuf;
+        ion_phys_addr_t dat;
+        size_t len;
+        int heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+        int flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].inUse == 0)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] NUM_ION_STRUCT is too small!!!");
+            break;
+        }
+
+        switch(mem_type)
+        {
+            case VE_SECURE_NORMAL:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+                    flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED | ION_FLAG_VE_SPEC);
+                    break;
+                }
+            case VE_SECURE_PROTECTION:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_SECURE_MASK;
+                    flags = (ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+                    break;
+                }
+            default:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+                    flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+                    break;
+                }
+        }
+
+        handle = ion_alloc(pu_client, size, 1024, heap, flags);
+        if (IS_ERR(handle))
+        {
+            printk(KERN_ERR "[PUWRAP] ion_alloc allocation error size=%d\n", size);
+            break;
+        }
+
+        if(ion_phys(pu_client, handle, &dat, &len) != 0)
+        {
+            ion_free(pu_client, handle);
+            printk(KERN_ERR "[PUWRAP] ion_alloc allocation error size=%d\n", size);
+            break;
+        }
+
+        dmabuf = ion_share_dma_buf(pu_client, handle);
+        if (IS_ERR(dmabuf)) {
+            ion_unmap_kernel(pu_client, handle);
+            ion_free(pu_client, handle);
+            printk(KERN_ERR "[PUWRAP] ion_share_dma_buf error %p (size=%d)\n", dmabuf, size);
+            break;
+        }
+
+        *base = (unsigned long) dmabuf; // we didn't need base address on user space, but we also need it has value to do detection
+        *phys_addr = (unsigned long)dat;
+
+        pu_ion_buffer[i].size = size;
+        pu_ion_buffer[i].inUse = 1;
+        pu_ion_buffer[i].phys_addr = (unsigned long)*phys_addr;
+        pu_ion_buffer[i].dmabuf = (unsigned long)dmabuf;
+        pu_ion_buffer[i].pIonHandle = (unsigned long)handle;
+
+        ret = 0;
+        break;
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+    return ret;
+
+#else /* else USE_ION_ALLOCATOR */
+    if (!size)
+        return -1;
+
+    *phys_addr = (unsigned long)vmem_alloc(&s_mem, size, 0);
+    if (*phys_addr  == (unsigned long)-1)
+    {
+        printk(KERN_ERR "[PUWRAP] Physical memory allocation error size=%d\n", size);
+        return -1;
+    }
+
+    *base = (unsigned long)(s_memory.base + (*phys_addr - s_memory.phys_addr));
+    //printk("[PUWARP] base:0x%lx, phy_addr:0x%lx, size:%d\n", *base, (unsigned long)*phys_addr, size);
+
+    return 0;
+#endif /* endif USE_ION_ALLOCATOR */
+}
+
+void pu_free_dma_buffer(unsigned long base, unsigned long phys_addr)
+{
+    if (!base)
+        return;
+
+#ifdef USE_ION_ALLOCATOR
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct ion_handle *handle;
+        struct dma_buf *dmabuf;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if (dmabuf != NULL)
+        {
+            dma_buf_put(dmabuf);
+            pu_ion_buffer[i].dmabuf = (unsigned long) NULL;
+        }
+
+        handle = (struct ion_handle *)pu_ion_buffer[i].pIonHandle;
+        if(handle != NULL)
+        {
+            ion_free(pu_client, handle);
+        }
+        memset(&pu_ion_buffer[i], 0, sizeof(struct rtkdrv_ion_buffer_t));
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+#else
+    vmem_free(&s_mem, (unsigned long)phys_addr, 0);
+#endif
+}
+
+int pu_mmap_dma_buffer(struct vm_area_struct *vm)
+{
+#ifdef USE_ION_ALLOCATOR
+    u32 i;
+    int ret = 0;
+    struct dma_buf *dmabuf;
+    unsigned long phys_addr = (unsigned long)(vm->vm_pgoff << PAGE_SHIFT);
+    mutex_lock(&s_pu_mutex);
+
+    for (i = 0; i < NUM_ION_STRUCT; i++)
+    {
+        if (pu_ion_buffer[i].phys_addr == phys_addr)
+            break;
+    }
+    if (i == NUM_ION_STRUCT)
+    {
+        printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+        mutex_unlock(&s_pu_mutex);
+        return -EINVAL;
+    }
+
+    dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+    ret = dma_buf_mmap(dmabuf, vm, 0);
+
+    mutex_unlock(&s_pu_mutex);
+
+    return ret;
+#else
+    return -EINVAL;
+#endif
+}
+
+unsigned long pu_mmap_kernel_buffer(unsigned long phys_addr, unsigned int size)
+{
+#ifdef USE_ION_ALLOCATOR
+    unsigned long ret = 0;
+
+    if (!size)
+        return 0;
+
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct dma_buf *dmabuf;
+        void * virt_addr;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if(dmabuf != NULL)
+        {
+            ret = dma_buf_begin_cpu_access(dmabuf, 0);
+            if (ret) {
+                printk(KERN_ERR "[PUWRAP] dma_buf_begin_cpu_access error ret=%d (size=%d) \n", ret, size);
+                break;
+            }
+            virt_addr = dma_buf_kmap(dmabuf, 0);
+            if (IS_ERR_OR_NULL(virt_addr)) {
+                printk(KERN_ERR "[PUWRAP] dma_buf_kmap error %p (size=%d) \n", virt_addr, size);
+                break;
+            }
+
+            ret = (unsigned long)virt_addr;
+        }
+    } while(0);
+    mutex_unlock(&s_pu_mutex);
+
+    return ret;
+#endif
+}
+
+void pu_unmap_kernel_buffer(unsigned long base, unsigned long phys_addr)
+{
+    if (!base)
+        return;
+
+#ifdef USE_ION_ALLOCATOR
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct dma_buf *dmabuf;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if(dmabuf != NULL)
+        {
+            dma_buf_kunmap(dmabuf, 0, (void *)base);
+            dma_buf_end_cpu_access(dmabuf, 0);
+        }
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+#endif
+}
+#endif //#ifdef CONFIG_RTK_RESERVE_MEMORY
+
+void pu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable)
+{
+    if (pll_phy_register == 0 || pll_virt_register == 0 || pll_size_register == 0)
+    {
+        printk(KERN_WARNING "In[%s][%d] didn't get pll register\n", __FUNCTION__, __LINE__);
+        return;
+    }
+    else if (offset > pll_size_register)
+    {
+        printk(KERN_WARNING "In[%s][%d] offset over than register size\n", __FUNCTION__, __LINE__);
+        return;
+    }
+
+    if (bOverwrite == 1)
+    {
+        __raw_writel(value, (volatile u8 *)(pll_virt_register+offset));
+    }
+    else
+    {
+        if (bEnable)
+        {
+            __raw_writel(__raw_readl((volatile u8 *)(pll_virt_register+offset)) | value, (volatile u8 *)(pll_virt_register+offset));
+        }
+        else
+        {
+            __raw_writel(__raw_readl((volatile u8 *)(pll_virt_register+offset)) & value, (volatile u8 *)(pll_virt_register+offset));
+        }
+    }
+}
+
+static int pu_probe(struct platform_device *pdev)
+{
+    struct resource res;
+    void __iomem *iobase;
+    struct device_node *node;
+
+    printk(KERN_INFO "[PUWRAP] pu_probe\n");
+
+    node = pdev->dev.of_node;
+    of_address_to_resource(node, 0, &res);
+    iobase = of_iomap(node, 0);
+
+    pll_phy_register = res.start;
+    pll_virt_register = (unsigned long)iobase;
+    pll_size_register = res.end - res.start + 1;
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifdef USE_ION_ALLOCATOR
+    pu_client = ion_client_create(rtk_phoenix_ion_device, "PUDriver");
+    memset(pu_ion_buffer, 0, sizeof(struct rtkdrv_ion_buffer_t)*NUM_ION_STRUCT);
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device with USE_ION_ALLOCATOR\n");
+#else /* else USE_ION_ALLOCATOR */
+    if(pdev)
+        res = platform_get_resource(pdev, IORESOURCE_MEM, 1);
+    if(res)
+    {
+        s_memory.size = res->end - res->start;
+        s_memory.phys_addr = res->start;
+    }
+    else
+    {
+        s_memory.size = RTK_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+        s_memory.phys_addr = RTK_DRAM_PHYSICAL_BASE;
+    }
+
+    s_memory.base = (unsigned long)ioremap(s_memory.phys_addr, PAGE_ALIGN(s_memory.size));
+    if (!s_memory.base)
+    {
+        printk(KERN_ERR "[PUWRAP] :  fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", (int)s_memory.phys_addr, (int)s_memory.base, (int)s_memory.size);
+        goto ERROR_PROVE_DEVICE;
+    }
+    if (vmem_init(&s_mem, s_memory.phys_addr, s_memory.size) < 0)
+    {
+        printk(KERN_ERR "[PUWRAP] :  fail to init vmem system\n");
+        goto ERROR_PROVE_DEVICE;
+    }
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device with reserved video memory phys_addr=0x%x, base = 0x%x\n", (int) s_memory.phys_addr, (int)s_memory.base);
+#endif /* endif USE_ION_ALLOCATOR */
+#else /* else CONFIG_RTK_RESERVE_MEMORY */
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device\n");
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+
+    return 0;
+
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifndef USE_ION_ALLOCATOR
+ERROR_PROVE_DEVICE:
+
+    return 0;
+#endif
+#endif
+}
+
+static int pu_remove(struct platform_device *pdev)
+{
+    printk(KERN_INFO "[PUWRAP] pu_remove\n");
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifdef USE_ION_ALLOCATOR
+    if(pu_client != NULL)
+    {
+        ion_client_destroy(pu_client);
+        pu_client = NULL;
+    }
+#else /* else USE_ION_ALLOCATOR */
+    if (s_memory.base)
+    {
+        iounmap((void *)s_memory.base);
+        s_memory.base = 0;
+        vmem_exit(&s_mem);
+    }
+#endif /* endif USE_ION_ALLOCATOR */
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+    return 0;
+}
+
+#if 0
+static struct platform_driver pu_driver = {
+    .driver = {
+        .name = PU_PLATFORM_DEVICE_NAME,
+    },
+    .probe = pu_probe,
+    .remove = pu_remove,
+};
+#endif
+
+static ssize_t pu_memsize_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    return sprintf(buf, "%d\n", (int)(get_num_physpages() << PAGE_SHIFT));
+}
+
+static struct kobj_attribute pu_memsize_attr =
+    __ATTR(pu_memsize, 0644, pu_memsize_show, NULL);
+
+static struct attribute *pu_attrs[] = {
+    &pu_memsize_attr.attr,
+    NULL,
+};
+
+static struct attribute_group rtk_pu_attr_group = {
+    .attrs = pu_attrs,
+};
+
+static struct kobject *pu_kobj;
+
+static int __init pu_init(void)
+{
+    int res = 0;
+
+    pu_kobj = kobject_create_and_add("rtk_pu", kernel_kobj);
+    if (pu_kobj)
+    {
+        res = sysfs_create_group(pu_kobj, &rtk_pu_attr_group);
+        if (res)
+            printk(KERN_WARNING "[PUWRAP] %d: unable to create sysfs entry\n", __LINE__);
+    }
+    else
+        printk(KERN_WARNING "[PUWRAP] %d: unable to create sysfs entry\n", __LINE__);
+
+    printk(KERN_INFO "[PUWRAP] begin pu_init\n");
+    //res = platform_driver_register(&pu_driver);
+    printk(KERN_INFO "[PUWRAP] end pu_init result=0x%x\n", res);
+    return res;
+}
+
+static void __exit pu_exit(void)
+{
+    printk(KERN_INFO "[PUWRAP] pu_exit\n");
+    //platform_driver_unregister(&pu_driver);
+    return;
+}
+
+
+static const struct of_device_id rtk_pu_dt_match[] = {
+    { .compatible = "Realtek,rtk1295-pu_pll" },
+    {}
+};
+MODULE_DEVICE_TABLE(of, rtk_pu_dt_match);
+
+const struct dev_pm_ops rtk_pu_pmops = {
+    .suspend    = NULL,
+    .resume     = NULL,
+};
+
+static struct platform_driver rtk_pu_driver = {
+    .driver		= {
+        .name	= "rtk-pu",
+        .owner	= THIS_MODULE,
+        .of_match_table = rtk_pu_dt_match,
+        //.pm	= SDHCI_PLTFM_PMOPS,
+        .pm	= &rtk_pu_pmops,
+    },
+    .probe		= pu_probe,
+    .remove		= pu_remove,
+};
+
+module_platform_driver(rtk_pu_driver);
+
+MODULE_AUTHOR("RTK Wrapper for JPU & VPU, Inc.");
+MODULE_DESCRIPTION("PU WRAPPER linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(pu_init);
+module_exit(pu_exit);
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/puwrap.h b/drivers/soc/realtek/rtd129x/rtk_ve/puwrap.h
new file mode 100644
index 00000000..70733a5
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/puwrap.h
@@ -0,0 +1,43 @@
+
+
+#ifndef __PU_DRV_H__
+#define __PU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+
+#define PDI_IOCTL_MAGIC  'V'
+
+#define PLL_CLK_715 (0x10D336)
+#define PLL_CLK_702 (0x10C186)
+#define PLL_CLK_675 (0x10C176)
+#define PLL_CLK_648 (0x10C166)
+#define PLL_CLK_594 (0x10C146)
+#define PLL_CLK_567 (0x10C136)
+#define PLL_CLK_337 (0x12C176)
+#define PLL_CLK_297 (0x12C146)
+
+#define UNUSED_PARAMETER(p) (void)(p)
+
+#define MISC_JPU_MINOR 107
+#define MISC_MEM_MINOR 108
+#define MISC_VE3_MINOR 109
+#define MISC_VE1_MINOR 110
+
+typedef struct pu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long jpu_interrupt_reason;
+	unsigned long vpu_interrupt_reason;
+} pu_drv_context_t;
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+int pu_alloc_dma_buffer(unsigned int size, unsigned long *phys_addr, unsigned long *base, unsigned int mem_type);
+void pu_free_dma_buffer(unsigned long base, unsigned long phys_addr);
+int pu_mmap_dma_buffer(struct vm_area_struct *vm);
+unsigned long pu_mmap_kernel_buffer(unsigned long phys_addr, unsigned int size);
+void pu_unmap_kernel_buffer(unsigned long base, unsigned long phys_addr);
+#endif
+void pu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable);
+
+#endif
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve1/Makefile b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/Makefile
new file mode 100644
index 00000000..7217604
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/Makefile
@@ -0,0 +1,6 @@
+# rtk_vcodec
+
+obj-$(CONFIG_VE1_CODEC) += ve1.o
+ifdef CONFIG_COMPAT
+obj-$(CONFIG_VE1_CODEC) += compat_ve1.o
+endif
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve1/compat_ve1.c b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/compat_ve1.c
new file mode 100644
index 00000000..8291d8d
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/compat_ve1.c
@@ -0,0 +1,555 @@
+/*
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/compat.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#include "ve1.h"
+#include "compat_ve1.h"
+
+/* See drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1.h for the definition of these structs */
+typedef struct compat_vpudrv_buffer_t {
+	compat_uint_t size;
+	compat_ulong_t phys_addr;
+	compat_ulong_t base; /* kernel logical address in use kernel */
+	compat_ulong_t virt_addr; /* virtual user space address */
+	compat_uint_t mem_type;
+} compat_vpudrv_buffer_t;
+
+typedef struct compat_vpu_clock_info_t{
+	compat_uint_t core_idx;
+	compat_uint_t enable;
+	compat_uint_t value;
+} compat_vpu_clock_info_t;
+
+typedef struct compat_vpudrv_inst_info_t {
+	compat_uint_t core_idx;
+	compat_uint_t inst_idx;
+	compat_int_t inst_open_count;	/* for output only*/
+} compat_vpudrv_inst_info_t;
+
+typedef struct compat_vpudrv_intr_info_t {
+	compat_uint_t core_idx;
+	compat_uint_t timeout;
+	compat_int_t intr_reason;
+} compat_vpudrv_intr_info_t;
+
+#define COMPAT_VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(VDI_IOCTL_MAGIC, 0)
+#define COMPAT_VDI_IOCTL_FREE_PHYSICALMEMORY _IO(VDI_IOCTL_MAGIC, 1)
+#define COMPAT_VDI_IOCTL_WAIT_INTERRUPT _IO(VDI_IOCTL_MAGIC, 2)
+#define COMPAT_VDI_IOCTL_GET_INSTANCE_POOL _IO(VDI_IOCTL_MAGIC, 5)
+#define COMPAT_VDI_IOCTL_GET_COMMON_MEMORY _IO(VDI_IOCTL_MAGIC, 6)
+#define COMPAT_VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(VDI_IOCTL_MAGIC, 8)
+#define COMPAT_VDI_IOCTL_OPEN_INSTANCE _IO(VDI_IOCTL_MAGIC, 9)
+#define COMPAT_VDI_IOCTL_CLOSE_INSTANCE _IO(VDI_IOCTL_MAGIC, 10)
+#define COMPAT_VDI_IOCTL_GET_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 11)
+#define COMPAT_VDI_IOCTL_GET_REGISTER_INFO _IO(VDI_IOCTL_MAGIC, 12)
+
+/* RTK ioctl */
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_GATING _IO(VDI_IOCTL_MAGIC, 16)
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 17)
+#define COMPAT_VDI_IOCTL_GET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 18)
+#define COMPAT_VDI_IOCTL_GET_RTK_SUPPORT_TYPE _IO(VDI_IOCTL_MAGIC, 19)
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 21)
+#define COMPAT_VDI_IOCTL_GET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 22)
+
+static int compat_get_ve1_buffer_data(
+	compat_vpudrv_buffer_t __user *data32,
+	vpudrv_buffer_t __user *data)
+{
+	compat_uint_t s;
+	compat_ulong_t p;
+	compat_ulong_t b;
+	compat_ulong_t v;
+	compat_uint_t m;
+	int err;
+
+	err = get_user(s, &data32->size);
+	err |= put_user(s, &data->size);
+	err |= get_user(p, &data32->phys_addr);
+	err |= put_user(p, &data->phys_addr);
+	err |= get_user(b, &data32->base);
+	err |= put_user(b, &data->base);
+	err |= get_user(v, &data32->virt_addr);
+	err |= put_user(v, &data->virt_addr);
+	err |= get_user(m, &data32->mem_type);
+	err |= put_user(m, &data->mem_type);
+
+	return err;
+}
+
+static int compat_get_ve1_inst_info_data(
+	compat_vpudrv_inst_info_t __user *data32,
+	vpudrv_inst_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_int_t ioc;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(i, &data32->inst_idx);
+	err |= put_user(i, &data->inst_idx);
+	err |= get_user(ioc, &data32->inst_open_count);
+	err |= put_user(ioc, &data->inst_open_count);
+
+	return err;
+}
+
+static int compat_get_ve1_intr_info_data(
+	compat_vpudrv_intr_info_t __user *data32,
+	vpudrv_intr_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t t;
+	compat_int_t i;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(t, &data32->timeout);
+	err |= put_user(t, &data->timeout);
+	err |= get_user(i, &data32->intr_reason);
+	err |= put_user(i, &data->intr_reason);
+
+	return err;
+}
+
+static int compat_get_ve1_clock_info(
+	compat_vpu_clock_info_t __user *data32,
+	vpu_clock_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_uint_t v;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(e, &data32->enable);
+	err |= put_user(e, &data->enable);
+	err |= get_user(v, &data32->value);
+	err |= put_user(v, &data->value);
+
+	return err;
+}
+
+static int compat_put_ve1_buffer_data(
+	compat_vpudrv_buffer_t __user *data32,
+	vpudrv_buffer_t __user *data)
+{
+	compat_uint_t s;
+	compat_ulong_t p;
+	compat_ulong_t b;
+	compat_ulong_t v;
+	compat_uint_t m;
+	int err;
+
+	err = get_user(s, &data->size);
+	err |= put_user(s, &data32->size);
+	err |= get_user(p, &data->phys_addr);
+	err |= put_user(p, &data32->phys_addr);
+	err |= get_user(b, &data->base);
+	err |= put_user(b, &data32->base);
+	err |= get_user(v, &data->virt_addr);
+	err |= put_user(v, &data32->virt_addr);
+	err |= get_user(m, &data->mem_type);
+	err |= put_user(m, &data32->mem_type);
+
+	return err;
+}
+
+static int compat_put_ve1_inst_info_data(
+	compat_vpudrv_inst_info_t __user *data32,
+	vpudrv_inst_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_int_t ioc;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(i, &data->inst_idx);
+	err |= put_user(i, &data32->inst_idx);
+	err |= get_user(ioc, &data->inst_open_count);
+	err |= put_user(ioc, &data32->inst_open_count);
+
+	return err;
+}
+
+static int compat_put_ve1_intr_info_data(
+	compat_vpudrv_intr_info_t __user *data32,
+	vpudrv_intr_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t t;
+	compat_int_t i;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(t, &data->timeout);
+	err |= put_user(t, &data32->timeout);
+	err |= get_user(i, &data->intr_reason);
+	err |= put_user(i, &data32->intr_reason);
+
+	return err;
+}
+
+static int compat_put_ve1_clock_info(
+	compat_vpu_clock_info_t __user *data32,
+	vpu_clock_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_int_t v;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(e, &data->enable);
+	err |= put_user(e, &data32->enable);
+	err |= get_user(v, &data->value);
+	err |= put_user(v, &data32->value);
+
+	return err;
+}
+
+long compat_vpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	long ret = 0;
+
+	if (!filp->f_op->unlocked_ioctl)
+		return -ENOTTY;
+
+	switch (cmd) {
+	case COMPAT_VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_FREE_PHYSICALMEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_FREE_PHYSICALMEMORY, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_WAIT_INTERRUPT:
+	{
+		compat_vpudrv_intr_info_t __user *data32;
+		vpudrv_intr_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_intr_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_WAIT_INTERRUPT, (unsigned long)data);
+		err = compat_put_ve1_intr_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case VDI_IOCTL_SET_CLOCK_GATE:
+	case VDI_IOCTL_RESET:
+	case VDI_IOCTL_GET_RTK_ASIC_REVISION:
+	{
+		return filp->f_op->unlocked_ioctl(filp, cmd,
+										  (unsigned long)compat_ptr(arg));
+	}
+
+	case COMPAT_VDI_IOCTL_GET_INSTANCE_POOL:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_INSTANCE_POOL, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_COMMON_MEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_COMMON_MEMORY, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_OPEN_INSTANCE:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_OPEN_INSTANCE, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_CLOSE_INSTANCE:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_CLOSE_INSTANCE, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_INSTANCE_NUM:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_INSTANCE_NUM, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_REGISTER_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_REGISTER_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_GATING:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_GATING, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_PLL:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_PLL, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_CLK_PLL:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_CLK_PLL, (unsigned long)data);
+		err = compat_put_ve1_clock_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_SELECT:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_SELECT, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_CLK_SELECT:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_CLK_SELECT, (unsigned long)data);
+		err = compat_put_ve1_clock_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_SUPPORT_TYPE:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_SUPPORT_TYPE, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	default:
+	{
+		printk(KERN_ERR "[COMPAT_VPUDRV] No such IOCTL, cmd is %d\n", cmd);
+		return -ENOIOCTLCMD;
+	}
+	}
+}
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve1/compat_ve1.h b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/compat_ve1.h
new file mode 100644
index 00000000..15c1161
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/compat_ve1.h
@@ -0,0 +1,42 @@
+/*
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_COMPAT_VE1_H
+#define _LINUX_COMPAT_VE1_H
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+typedef struct compat_vpu_bit_firmware_info_t {
+	compat_uint_t size; /* size of this structure*/
+	compat_uint_t core_idx;
+	compat_ulong_t reg_base_offset;
+	compat_ushort_t bit_code[512];
+} compat_vpu_bit_firmware_info_t;
+
+long compat_vpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+
+#else
+
+typedef struct compat_vpu_bit_firmware_info_t {
+	unsigned int size; /* size of this structure*/
+	unsigned int core_idx;
+	unsigned long reg_base_offset;
+	unsigned short bit_code[512];
+} compat_vpu_bit_firmware_info_t;
+
+#define compat_vpu_ioctl  NULL
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_VE1_H */
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1.c b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1.c
new file mode 100644
index 00000000..188941e
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1.c
@@ -0,0 +1,2157 @@
+/*
+ * ve1.c
+ *
+ * linux device driver for VE1.
+ *
+ * Copyright (C) 2006 - 2013  REALTEK INC.
+ *
+ * This library is free software; you can redistribute it and/or modify it under
+ * the terms of the GNU Lesser General Public License as published by the Free
+ * Software Foundation; either version 2.1 of the License, or (at your option)
+ * any later version.
+ *
+ * This library is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+ * details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this library; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301  USA
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <soc/realtek/rtk_cpu.h>
+
+#ifdef CONFIG_COMPAT
+#include <linux/compat.h>
+#endif
+
+#ifdef CONFIG_POWER_CONTROL
+#include <soc/realtek/power-control.h>
+#endif
+
+#include "ve1config.h"
+#include "ve1.h"
+#include "compat_ve1.h"
+#include "../puwrap.h"
+
+//#define ENABLE_DEBUG_MSG
+#ifdef ENABLE_DEBUG_MSG
+#define DPRINTK(args...) pr_info(args);
+#else
+#define DPRINTK(args...)
+#endif /* ENABLE_DEBUG_MSG */
+
+#define DEV_NAME "[RTK_VE1]"
+#define DISABLE_ORIGIN_SUSPEND
+
+/* definitions to be changed as customer  configuration */
+/* if you want to have clock gating scheme frame by frame */
+/* #define VPU_SUPPORT_CLOCK_CONTROL */
+
+/* if the driver want to use interrupt service from kernel ISR */
+#define VPU_SUPPORT_ISR
+
+/* if the platform driver knows the name of this driver */
+/* VPU_PLATFORM_DEVICE_NAME */
+#define VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+/* if this driver knows the dedicated video memory address */
+#ifndef CONFIG_RTK_RESERVE_MEMORY
+#ifdef CONFIG_RTK_PLATFORM_FPGA
+#define VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#endif
+#endif
+
+#define VPU_PLATFORM_DEVICE_NAME "vdec"
+#define VPU_CLK_NAME "vcodec"
+#define VPU_DEV_NAME "vpu"
+
+/* if the platform driver knows this driver */
+/* the definition of VPU_REG_BASE_ADDR and VPU_REG_SIZE are not meaningful */
+
+#define VPU_REG_BASE_ADDR 0x98040000
+#define VPU_REG_SIZE (0x4000*MAX_NUM_VPU_CORE)
+
+#ifdef VPU_SUPPORT_ISR
+#define VE1_IRQ_NUM (85)
+#define VE2_IRQ_NUM (86)
+#endif
+
+/* this definition is only for realtek FPGA board env */
+/* so for SOC env of customers can be ignored */
+
+#ifndef VM_RESERVED	/*for kernel up to 3.7.0 version*/
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+typedef struct vpu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long interrupt_reason_ve1;
+	unsigned long interrupt_reason_ve2;
+	/* !<< device reference count. Not instance count */
+	u32 open_count;
+} vpu_drv_context_t;
+
+/* To track the allocated memory buffer */
+typedef struct vpudrv_buffer_pool_t {
+	struct list_head list;
+	struct vpudrv_buffer_t vb;
+	struct file *filp;
+} vpudrv_buffer_pool_t;
+
+/* To track the instance index and buffer in instance pool */
+typedef struct vpudrv_instanace_list_t {
+	struct list_head list;
+	unsigned long inst_idx;
+	unsigned long core_idx;
+	struct file *filp;
+} vpudrv_instanace_list_t;
+
+typedef struct vpudrv_instance_pool_t {
+	unsigned char codecInstPool[MAX_NUM_INSTANCE][MAX_INST_HANDLE_SIZE];
+	long long pendingInstIdxPlus1;
+	void *pendingInst;
+} vpudrv_instance_pool_t;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#define VPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE 0x0b800000 //(62*1024*1024)
+#define VPU_DRAM_PHYSICAL_BASE 0x03200000 //0x86C00000
+#include "vmm.h"
+static video_mm_t s_vmem;
+static vpudrv_buffer_t s_video_memory = {0};
+#endif /*VPU_SUPPORT_RESERVED_VIDEO_MEMORY*/
+
+static int vpu_hw_reset(u32 coreIdx);
+#ifdef CONFIG_POWER_CONTROL
+static void vpu_pctrl_off(struct power_control *pctrl);
+static void vpu_pctrl_on(struct power_control *pctrl);
+static struct power_control *vpu_pctrl_get(u32 coreIdx);
+#endif /* CONFIG_POWER_CONTROL */
+
+/* end customer definition */
+static vpudrv_buffer_t s_instance_pool = {0};
+static vpudrv_buffer_t s_common_memory = {0};
+static vpu_drv_context_t s_vpu_drv_context;
+static struct miscdevice s_vpu_dev;
+
+static struct clk *s_vpu_clk_ve1;
+static struct clk *s_vpu_clk_ve2;
+#ifdef CONFIG_ARCH_RTD139x
+static struct clk *s_vpu_clk_ve2_bpu;
+#endif /* CONFIG_ARCH_RTD139x */
+static struct clk *s_vpu_clk_sysh;
+static struct clk *s_vpu_pll_ve1;
+static struct clk *s_vpu_pll_ve2;
+static struct device *p_vpu_dev;
+static int s_vpu_open_ref_count;
+static struct reset_control *rstc_ve1;
+static struct reset_control *rstc_ve2;
+
+#ifdef VPU_SUPPORT_ISR
+static int s_ve1_irq = VE1_IRQ_NUM;
+static int s_ve2_irq = VE2_IRQ_NUM;
+#endif /* VPU_SUPPORT_ISR */
+
+#ifdef CONFIG_POWER_CONTROL
+static struct power_control *s_pctrl_ve1;
+static struct power_control *s_pctrl_ve2;
+#endif /* CONFIG_POWER_CONTROL */
+
+static int ve_cti_en = 1;
+/* FIX ME after ver.B IC */
+static int ve_idle_en = 0;
+
+static vpudrv_buffer_t s_vpu_register = {0};
+static vpudrv_buffer_t s_vpll_register = {0};
+static vpudrv_buffer_t s_bond_register = {0};
+
+static atomic_t s_interrupt_flag_ve1;
+static wait_queue_head_t s_interrupt_wait_q_ve1;
+static atomic_t s_interrupt_flag_ve2;
+static wait_queue_head_t s_interrupt_wait_q_ve2;
+
+static spinlock_t s_vpu_lock = __SPIN_LOCK_UNLOCKED(s_vpu_lock);
+static spinlock_t s_ve1_lock = __SPIN_LOCK_UNLOCKED(s_ve1_lock);
+static spinlock_t s_ve2_lock = __SPIN_LOCK_UNLOCKED(s_ve2_lock);
+static DEFINE_SEMAPHORE(s_vpu_sem);
+static struct list_head s_vbp_head = LIST_HEAD_INIT(s_vbp_head);
+static struct list_head s_inst_list_head = LIST_HEAD_INIT(s_inst_list_head);
+
+static vpu_bit_firmware_info_t s_bit_firmware_info[MAX_NUM_VPU_CORE];
+
+#define BIT_BASE 0x0000
+#define BIT_INT_STS (BIT_BASE + 0x010)
+#define BIT_INT_REASON (BIT_BASE + 0x174)
+#define BIT_INT_CLEAR (BIT_BASE + 0x00C)
+#define VE_CTRL_REG (BIT_BASE + 0x3000)
+#define VE_CTI_GRP_REG (BIT_BASE + 0x3004)
+
+#define W4_REG_BASE 0x0000
+#define W4_VPU_INT_CLEAR (W4_REG_BASE + 0x003C)
+#define W4_VPU_INT_STS (W4_REG_BASE + 0x0044)
+#define W4_VPU_INT_REASON (W4_REG_BASE + 0x004c)
+#define W4_VPU_INT_REASON_CLEAR (W4_REG_BASE + 0x0034)
+#define W4_VE_CTRL_REG (W4_REG_BASE + 0x3E00)
+#define W4_VE_CTI_GRP_REG (W4_REG_BASE + 0x3E04)
+
+#ifdef CONFIG_PM
+/* implement to power management functions */
+#define BIT_CODE_RUN (BIT_BASE + 0x000)
+#define BIT_CODE_DOWN (BIT_BASE + 0x004)
+#define BIT_CODE_RESET (BIT_BASE + 0x014)
+#define BIT_BUSY_FLAG (BIT_BASE + 0x160)
+#define BIT_RUN_COMMAND (BIT_BASE + 0x164)
+#define BIT_RUN_INDEX (BIT_BASE + 0x168)
+#define BIT_RUN_COD_STD (BIT_BASE + 0x16C)
+
+/* WAVE4 registers */
+#define W4_VPU_BUSY_STATUS (W4_REG_BASE + 0x0070)
+
+#define W4_RET_SUCCESS (W4_REG_BASE + 0x0110)
+#define W4_RET_FAIL_REASON (W4_REG_BASE + 0x0114)
+
+/* WAVE4 INIT, WAKEUP */
+#define W4_PO_CONF (W4_REG_BASE + 0x0000)
+#define W4_VCPU_CUR_PC	 (W4_REG_BASE + 0x0004)
+
+#define W4_VPU_INT_ENABLE (W4_REG_BASE + 0x0048)
+
+#define W4_RESET_REQ (W4_REG_BASE + 0x0050)
+#define W4_RESET_STATUS (W4_REG_BASE + 0x0054)
+
+#define W4_VPU_REMAP_CTRL (W4_REG_BASE + 0x0060)
+#define W4_VPU_REMAP_VADDR	(W4_REG_BASE + 0x0064)
+#define W4_VPU_REMAP_PADDR (W4_REG_BASE + 0x0068)
+#define W4_VPU_REMAP_PROC_START (W4_REG_BASE + 0x006C)
+#define W4_VPU_BUSY_STATUS (W4_REG_BASE + 0x0070)
+
+#define W4_REMAP_CODE_INDEX 0
+
+enum {
+	W4_INT_INIT_VPU = 0,
+	W4_INT_DEC_PIC_HDR = 1,
+	W4_INT_FINI_SEQ = 2,
+	W4_INT_DEC_PIC = 3,
+	W4_INT_SET_FRAMEBUF = 4,
+	W4_INT_FLUSH_DEC = 5,
+	W4_INT_GET_FW_VERSION = 9,
+	W4_INT_QUERY_DEC = 10,
+	W4_INT_SLEEP_VPU = 11,
+	W4_INT_WAKEUP_VPU = 12,
+	W4_INT_CHANGE_INT = 13,
+	W4_INT_CREATE_INSTANCE = 14,
+	/*!<< Bitstream buffer empty */
+	W4_INT_BSBUF_EMPTY = 15,
+	W4_INT_ENC_SLICE_INT = 15,
+};
+
+#define W4_HW_OPTION (W4_REG_BASE + 0x0124)
+#define W4_CODE_SIZE (W4_REG_BASE + 0x011C)
+/* Note: W4_INIT_CODE_BASE_ADDR should be aligned to 4KB */
+#define W4_ADDR_CODE_BASE (W4_REG_BASE + 0x0118)
+#define W4_CODE_PARAM (W4_REG_BASE + 0x0120)
+/* Note: W4_INIT_STACK_BASE_ADDR should be aligned to 4KB */
+#define W4_ADDR_STACK_BASE (W4_REG_BASE + 0x012C)
+#define W4_STACK_SIZE (W4_REG_BASE + 0x0130)
+#define W4_INIT_VPU_TIME_OUT_CNT (W4_REG_BASE + 0x0134)
+
+/* WAVE4 Wave4BitIssueCommand */
+#define W4_CORE_INDEX (W4_REG_BASE + 0x0104)
+#define W4_INST_INDEX (W4_REG_BASE + 0x0108)
+#define W4_COMMAND (W4_REG_BASE + 0x0100)
+#define W4_VPU_HOST_INT_REQ (W4_REG_BASE + 0x0038)
+
+/* Product register */
+#define VPU_PRODUCT_CODE_REGISTER   (BIT_BASE + 0x1044)
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+static u32 s_vpu_reg_store[MAX_NUM_VPU_CORE][64];
+#endif
+#endif /* CONFIG_PM */
+
+/*
+ * common struct and definition
+ */
+#define ReadVpuRegister(addr, core) *(volatile unsigned int *)(s_vpu_register.virt_addr + (0x4000 * core) + addr)
+#define WriteVpuRegister(addr, val, core) *(volatile unsigned int *)(s_vpu_register.virt_addr + (0x4000 * core) + addr) = (unsigned int)val
+#define WriteVpu(addr, val) *(volatile unsigned int *)(addr) = (unsigned int)val;
+
+struct clk *vpu_clk_get(struct device *dev, u32 coreIdx)
+{
+	if (coreIdx == 0)
+		return clk_get(dev, "clk_ve1");
+	else
+		return clk_get(dev, "clk_ve2");
+	//return clk_get(dev, VPU_CLK_NAME);
+}
+
+void vpu_clk_put(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk)))
+		clk_put(clk);
+}
+
+unsigned long vpu_clk_get_rate(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+		DPRINTK("%s vpu_clk_get_rate\n", DEV_NAME);
+		return clk_get_rate(clk);
+	}
+
+	return 0;
+}
+
+int vpu_clk_enable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+#if 0 /* the bellow is for EVB.*/
+		{
+			struct clk *s_vpuext_clk = NULL;
+			s_vpuext_clk = clk_get(NULL, "vcore");
+			if (s_vpuext_clk) {
+				DPRINTK("%s vcore clk=%p\n", DEV_NAME, s_vpuext_clk);
+				clk_enable(s_vpuext_clk);
+			}
+
+			DPRINTK("%s vbus clk=%p\n", DEV_NAME, s_vpuext_clk);
+			if (s_vpuext_clk) {
+				s_vpuext_clk = clk_get(NULL, "vbus");
+				clk_enable(s_vpuext_clk);
+			}
+		}
+#endif /* for EVB. */
+
+		DPRINTK("%s vpu_clk_enable\n", DEV_NAME);
+		return clk_prepare_enable(clk)/*clk_enable(clk)*/;
+	}
+
+	return 0;
+}
+
+void vpu_clk_disable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+		DPRINTK("%s vpu_clk_disable\n", DEV_NAME);
+		//clk_disable(clk);
+		while (__clk_is_enabled(clk))
+			clk_disable_unprepare(clk);
+	}
+}
+
+static int vpu_clk_pll_set_rate(struct clk *clk, unsigned int rate)
+{
+	struct clk *pclk;
+
+	/* check if the parent clk is clk_sysh */
+	pclk = clk_get_parent(clk);
+	if (clk_is_match(pclk, s_vpu_clk_sysh)) {
+	        pr_warn("[VPUDRV] %s: set clk_sysh is not allowed\n", __func__);
+		return -EPERM;
+	}
+
+	/* set rate */
+	clk_set_rate(clk, rate);
+
+	return 0;
+}
+
+static void ve1_wrapper_setup(unsigned int coreIdx)
+{
+	unsigned int ctrl_1;
+	unsigned int ctrl_2;
+
+	/* coreIdx == 0 */
+	if ((coreIdx & (1 << 0)) != 0) {
+		ctrl_1 = ReadVpuRegister(VE_CTRL_REG, 0);
+		ctrl_2 = ReadVpuRegister(VE_CTI_GRP_REG, 0);
+		ctrl_1 |= (ve_cti_en << 1 | ve_idle_en << 6);
+		/* ve1_cti_cmd_depth for 1296 timing issue */
+		ctrl_2 = (ctrl_2 & ~(0x3f << 24)) | (0x1a << 24);
+		WriteVpuRegister(VE_CTRL_REG, ctrl_1, 0);
+		WriteVpuRegister(VE_CTI_GRP_REG, ctrl_2, 0);
+	}
+
+	/* coreIdx == 1 */
+	if ((coreIdx & (1 << 1)) != 0) {
+		ctrl_1 = ReadVpuRegister(W4_VE_CTRL_REG, 1);
+		ctrl_2 = ReadVpuRegister(W4_VE_CTI_GRP_REG, 1);
+		ctrl_1 |= (ve_cti_en << 1 | ve_idle_en << 6);
+		/* ve2_cti_cmd_depth for 1296 timing issue */
+		ctrl_2 = (ctrl_2 & ~(0x3f << 24)) | (0x1a << 24);
+		WriteVpuRegister(W4_VE_CTRL_REG, ctrl_1, 1);
+		WriteVpuRegister(W4_VE_CTI_GRP_REG, ctrl_2, 1);
+	}
+}
+
+int vpu_hw_reset(u32 coreIdx)
+{
+	struct reset_control *rstc;
+
+#if 1 /* RTK, workaround for demo */
+	DPRINTK("%s request vpu reset from application\n", DEV_NAME);
+
+	rstc = (coreIdx == 0 ? rstc_ve1 : rstc_ve2);
+	reset_control_reset(rstc);
+
+	ve1_wrapper_setup((1 << coreIdx));
+#endif
+	return 0;
+}
+
+static int vpu_alloc_dma_buffer(vpudrv_buffer_t *vb)
+{
+	unsigned int ret;
+
+	if (!vb)
+		return -1;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	UNUSED_PARAMETER(ret);
+	vb->phys_addr = (unsigned long)vmem_alloc(&s_vmem, vb->size, 0);
+	if ((unsigned long)vb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+
+	vb->base = (unsigned long)(s_video_memory.base + (vb->phys_addr - s_video_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	ret = pu_alloc_dma_buffer(vb->size, &vb->phys_addr, &vb->base, vb->mem_type);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#else
+	UNUSED_PARAMETER(ret);
+	vb->base = (unsigned long)dma_alloc_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (dma_addr_t *) (&vb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	DPRINTK("%s base:0x%lx, phy_addr:0x%lx, size:%d\n", DEV_NAME, vb->base, vb->phys_addr, vb->size);
+	return 0;
+}
+
+static int vpu_alloc_dma_buffer2(vpudrv_buffer_t *vb)
+{
+	unsigned int ret;
+
+	if (!vb)
+		return -1;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	UNUSED_PARAMETER(ret);
+	vb->phys_addr = (unsigned long)vmem_alloc(&s_vmem, vb->size, 0);
+	if ((unsigned long)vb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+
+	vb->base = (unsigned long)(s_video_memory.base + (vb->phys_addr - s_video_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	ret = pu_alloc_dma_buffer(vb->size, &vb->phys_addr, &vb->base, vb->mem_type);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+	vb->base = pu_mmap_kernel_buffer(vb->phys_addr, vb->size);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s pu_mmap_kernel_buffer error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#else
+	UNUSED_PARAMETER(ret);
+	vb->base = (unsigned long)dma_alloc_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (dma_addr_t *) (&vb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	DPRINTK("%s base:0x%lx, phy_addr:0x%lx, size:%d\n", DEV_NAME, vb->base, vb->phys_addr, vb->size);
+	return 0;
+}
+
+static void vpu_free_dma_buffer(vpudrv_buffer_t *vb)
+{
+	if (!vb)
+		return;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (vb->base)
+		vmem_free(&s_vmem, vb->phys_addr, 0);
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	pu_free_dma_buffer(vb->base, vb->phys_addr);
+#else
+	if (vb->base) {
+		dma_free_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (void *)vb->base, vb->phys_addr);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+}
+
+/* size=40 for Android M */
+#define PTHREAD_MUTEX_T_HANDLE_SIZE 40
+
+static int vpu_free_instances(struct file *filp)
+{
+	vpudrv_instanace_list_t *vil, *n;
+	vpudrv_instance_pool_t *vip;
+	void *vip_base;
+	int instance_pool_size_per_core;
+	void *vdi_mutexes_base;
+	const int PTHREAD_MUTEX_T_DESTROY_VALUE = 0xdead10cc;
+
+	DPRINTK("%s vpu_free_instances\n", DEV_NAME);
+
+	/* s_instance_pool.size  assigned to the size of all core once call VDI_IOCTL_GET_INSTANCE_POOL by user. */
+	instance_pool_size_per_core = (s_instance_pool.size/MAX_NUM_VPU_CORE);
+
+	list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+		if (vil->filp == filp) {
+			vip_base = (void *)(s_instance_pool.base + (instance_pool_size_per_core*vil->core_idx));
+			DPRINTK("%s vpu_free_instances detect instance crash instIdx=%d, coreIdx=%d, vip_base=%p, instance_pool_size_per_core=%d\n", DEV_NAME, (int)vil->inst_idx, (int)vil->core_idx, vip_base, (int)instance_pool_size_per_core);
+			vip = (vpudrv_instance_pool_t *)vip_base;
+
+			if (vip) {
+				/* only first 4 byte is key point(inUse of CodecInst in vpuapi) to free the corresponding instance. */
+				memset(&vip->codecInstPool[vil->inst_idx], 0x00, 4);
+
+				if (vil->inst_idx == (vip->pendingInstIdxPlus1-1) && vip->pendingInst != 0) {
+					pr_warn("%s vil->inst_idx:%d, vil->core_idx:%d is pending, clear in here\n", DEV_NAME, (int)vil->inst_idx, (int)vil->core_idx);
+					vip->pendingInst = 0;
+					vip->pendingInstIdxPlus1 = 0;
+				}
+
+				vdi_mutexes_base = (vip_base + (instance_pool_size_per_core - PTHREAD_MUTEX_T_HANDLE_SIZE*4));
+				DPRINTK("%s vpu_free_instances : force to destroy vdi_mutexes_base=%p in userspace \n", DEV_NAME, vdi_mutexes_base);
+				if (vdi_mutexes_base) {
+					int i;
+					for (i = 0; i < 4; i++) {
+						memcpy(vdi_mutexes_base, &PTHREAD_MUTEX_T_DESTROY_VALUE, PTHREAD_MUTEX_T_HANDLE_SIZE);
+						vdi_mutexes_base += PTHREAD_MUTEX_T_HANDLE_SIZE;
+					}
+				}
+			}
+			s_vpu_open_ref_count--;
+			list_del(&vil->list);
+			kfree(vil);
+		}
+	}
+	return 1;
+}
+
+static int vpu_free_buffers(struct file *filp)
+{
+	vpudrv_buffer_pool_t *pool, *n;
+	vpudrv_buffer_t vb;
+
+	DPRINTK("%s vpu_free_buffers\n", DEV_NAME);
+
+	list_for_each_entry_safe(pool, n, &s_vbp_head, list) {
+		if (pool->filp == filp) {
+			vb = pool->vb;
+			if (vb.base) {
+				vpu_free_dma_buffer(&vb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+
+	return 0;
+}
+
+static irqreturn_t ve1_irq_handler(int irq, void *dev_id)
+{
+	vpu_drv_context_t *dev = (vpu_drv_context_t *)dev_id;
+
+	/* this can be removed. it also work in VPU_WaitInterrupt of API function */
+	int core = 0;
+	unsigned long interrupt_reason_ve1 = 0;
+	unsigned int vpu_int_sts_ve1 = 0;
+	unsigned long flags;
+
+	//DPRINTK("%s [+]%s\n", DEV_NAME, __func__);
+
+	/* it means that we didn't get an information the current core from API layer. No core activated.*/
+	if (s_bit_firmware_info[core].size == 0) {
+		pr_err("[VPUDRV] :  s_bit_firmware_info[core].size is zero\n");
+		return IRQ_HANDLED;
+	}
+
+	vpu_int_sts_ve1 = ReadVpuRegister(BIT_INT_STS, core);
+	if (vpu_int_sts_ve1) {
+		interrupt_reason_ve1 = ReadVpuRegister(BIT_INT_REASON, core);
+		WriteVpuRegister(BIT_INT_REASON, 0, core);
+		WriteVpuRegister(BIT_INT_CLEAR, 0x1, core);
+	}
+
+	//DPRINTK("%s VE1 intr_reason: 0x%08lx\n", DEV_NAME, dev->interrupt_reason_ve1);
+
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN); /* notify the interrupt to user space */
+
+	if (vpu_int_sts_ve1) {
+		spin_lock_irqsave(&s_ve1_lock, flags);
+		dev->interrupt_reason_ve1 = interrupt_reason_ve1;
+		atomic_set(&s_interrupt_flag_ve1, 1);
+		spin_unlock_irqrestore(&s_ve1_lock, flags);
+		wake_up_interruptible(&s_interrupt_wait_q_ve1);
+		//DPRINTK("%s [-]%s\n", DEV_NAME, __func__);
+	}
+
+	return IRQ_HANDLED;
+}
+
+static irqreturn_t ve2_irq_handler(int irq, void *dev_id)
+{
+	vpu_drv_context_t *dev = (vpu_drv_context_t *)dev_id;
+
+	/* this can be removed. it also work in VPU_WaitInterrupt of API function */
+	int core = 1;
+	unsigned long interrupt_reason_ve2 = 0;
+	unsigned int vpu_int_sts_ve2 = 0;
+	unsigned long flags;
+
+	//DPRINTK("%s [+]%s\n", DEV_NAME, __func__);
+
+	if (s_bit_firmware_info[core].size == 0) {/* it means that we didn't get an information the current core from API layer. No core activated.*/
+		pr_err("[VPUDRV] :  s_bit_firmware_info[core].size is zero\n");
+		return IRQ_HANDLED;
+	}
+
+	vpu_int_sts_ve2 = ReadVpuRegister(W4_VPU_INT_STS, core);
+	if (vpu_int_sts_ve2) {
+		interrupt_reason_ve2 = ReadVpuRegister(W4_VPU_INT_REASON, core);
+		WriteVpuRegister(W4_VPU_INT_REASON_CLEAR, interrupt_reason_ve2, core);
+		WriteVpuRegister(W4_VPU_INT_CLEAR, 0x1, core);
+	}
+	//DPRINTK("%s VE2 intr_reason: 0x%08lx\n", DEV_NAME, dev->interrupt_reason_ve2);
+
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN);	/* notify the interrupt to user space */
+
+	if (vpu_int_sts_ve2) {
+		spin_lock_irqsave(&s_ve2_lock, flags);
+		dev->interrupt_reason_ve2 = interrupt_reason_ve2;
+		atomic_set(&s_interrupt_flag_ve2, 1);
+		spin_unlock_irqrestore(&s_ve2_lock, flags);
+		wake_up_interruptible(&s_interrupt_wait_q_ve2);
+		//DPRINTK("%s [-]%s\n", DEV_NAME, __func__);
+	}
+
+	return IRQ_HANDLED;
+}
+
+static int vpu_open(struct inode *inode, struct file *filp)
+{
+	DPRINTK("%s [+] %s\n", DEV_NAME, __func__);
+	spin_lock(&s_vpu_lock);
+
+	s_vpu_drv_context.open_count++;
+
+	filp->private_data = (void *)(&s_vpu_drv_context);
+	spin_unlock(&s_vpu_lock);
+
+	DPRINTK("%s [-] %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+
+/*static int vpu_ioctl(struct inode *inode, struct file *filp, u_int cmd, u_long arg) // for kernel 2.6.9*/
+static long vpu_ioctl(struct file *filp, u_int cmd, u_long arg)
+{
+	int ret = 0;
+	struct vpu_drv_context_t *dev = (struct vpu_drv_context_t *)filp->private_data;
+
+	switch (cmd) {
+	case VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+	{
+		vpudrv_buffer_pool_t *vbp;
+
+		DPRINTK("%s [+]VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			vbp = kzalloc(sizeof(*vbp), GFP_KERNEL);
+			if (!vbp) {
+				up(&s_vpu_sem);
+				return -ENOMEM;
+			}
+
+			ret = copy_from_user(&(vbp->vb), (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret) {
+				kfree(vbp);
+				up(&s_vpu_sem);
+				return -EFAULT;
+			}
+
+			ret = vpu_alloc_dma_buffer(&(vbp->vb));
+			if (ret == -1) {
+				ret = -ENOMEM;
+				kfree(vbp);
+				up(&s_vpu_sem);
+				break;
+			}
+
+			ret = copy_to_user((void __user *)arg, &(vbp->vb), sizeof(vpudrv_buffer_t));
+			if (ret) {
+				kfree(vbp);
+				ret = -EFAULT;
+				up(&s_vpu_sem);
+				break;
+			}
+
+			vbp->filp = filp;
+			spin_lock(&s_vpu_lock);
+			list_add(&vbp->list, &s_vbp_head);
+			spin_unlock(&s_vpu_lock);
+
+			up(&s_vpu_sem);
+		}
+		DPRINTK("%s [-]VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_FREE_PHYSICALMEMORY:
+	{
+		vpudrv_buffer_pool_t *vbp, *n;
+		vpudrv_buffer_t vb;
+
+		DPRINTK("%s [+]VDI_IOCTL_FREE_PHYSICALMEMORY\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			ret = copy_from_user(&vb, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret) {
+				up(&s_vpu_sem);
+				return -EACCES;
+			}
+
+			if (vb.base)
+				vpu_free_dma_buffer(&vb);
+
+			spin_lock(&s_vpu_lock);
+			list_for_each_entry_safe(vbp, n, &s_vbp_head, list) {
+				if (vbp->vb.phys_addr == vb.phys_addr/*vbp->vb.base == vb.base*/) {
+					list_del(&vbp->list);
+					kfree(vbp);
+					break;
+				}
+			}
+			spin_unlock(&s_vpu_lock);
+
+			up(&s_vpu_sem);
+		}
+		DPRINTK("%s [-]VDI_IOCTL_FREE_PHYSICALMEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+	{
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+		DPRINTK("%s [+]VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO\n", DEV_NAME);
+		if (s_video_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_video_memory, sizeof(vpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = -EFAULT;
+		}
+		DPRINTK("%s [-]VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO\n", DEV_NAME);
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+	}
+	break;
+
+	case VDI_IOCTL_WAIT_INTERRUPT:
+	{
+		vpudrv_intr_info_t info;
+		unsigned long flags;
+		//DPRINTK("[VPUDRV][+]VDI_IOCTL_WAIT_INTERRUPT\n");
+		ret = copy_from_user(&info, (vpudrv_intr_info_t *)arg, sizeof(vpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		/* VE1 */
+		if (info.core_idx == 0) {
+			smp_rmb();
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve1, atomic_read(&s_interrupt_flag_ve1) != 0, msecs_to_jiffies(info.timeout));
+			if (!ret) {
+				ret = -ETIME;
+				break;
+			}
+
+			if (signal_pending(current)) {
+				ret = -ERESTARTSYS;
+				break;
+			}
+
+			//DPRINTK("[VPUDRV] s_interrupt_flag_ve1(%d), reason(0x%08lx)\n", atomic_read(&s_interrupt_flag_ve1), dev->interrupt_reason_ve1);
+			spin_lock_irqsave(&s_ve1_lock, flags);
+			atomic_set(&s_interrupt_flag_ve1, 0);
+			info.intr_reason = dev->interrupt_reason_ve1;
+			dev->interrupt_reason_ve1 = 0;
+			spin_unlock_irqrestore(&s_ve1_lock, flags);
+		} else { /* VE2 */
+			smp_rmb();
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve2, atomic_read(&s_interrupt_flag_ve2) != 0, msecs_to_jiffies(info.timeout));
+			if (!ret) {
+				ret = -ETIME;
+				break;
+			}
+
+			if (signal_pending(current)) {
+				ret = -ERESTARTSYS;
+				break;
+			}
+
+			//DPRINTK("[VPUDRV] s_interrupt_flag_ve2(%d), reason(0x%08lx)\n", atomic_read(&s_interrupt_flag_ve2), dev->interrupt_reason_ve2);
+			spin_lock_irqsave(&s_ve2_lock, flags);
+			atomic_set(&s_interrupt_flag_ve2, 0);
+			info.intr_reason = dev->interrupt_reason_ve2;
+			dev->interrupt_reason_ve2 = 0;
+			spin_unlock_irqrestore(&s_ve2_lock, flags);
+		}
+
+		ret = copy_to_user((void __user *)arg, &info, sizeof(vpudrv_intr_info_t));
+		//DPRINTK("[VPUDRV][-]VDI_IOCTL_WAIT_INTERRUPT\n");
+		if (ret != 0)
+			return -EFAULT;
+	}
+	break;
+
+	case VDI_IOCTL_SET_CLOCK_GATE:
+	{
+		u32 clkgate;
+
+		//DPRINTK("[VPUDRV][+]VDI_IOCTL_SET_CLOCK_GATE\n");
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+#ifdef VPU_SUPPORT_CLOCK_CONTROL
+		if (clkgate)
+			vpu_clk_enable(s_vpu_clk);
+		else
+			vpu_clk_disable(s_vpu_clk);
+#endif /* VPU_SUPPORT_CLOCK_CONTROL */
+		//DPRINTK("[VPUDRV][-]VDI_IOCTL_SET_CLOCK_GATE\n");
+	}
+	break;
+	case VDI_IOCTL_GET_INSTANCE_POOL:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_INSTANCE_POOL\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			if (s_instance_pool.base != 0) {
+				ret = copy_to_user((void __user *)arg, &s_instance_pool, sizeof(vpudrv_buffer_t));
+				if (ret != 0)
+					ret = -EFAULT;
+			} else {
+				ret = copy_from_user(&s_instance_pool, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+				if (ret == 0) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+					s_instance_pool.size = PAGE_ALIGN(s_instance_pool.size);
+					s_instance_pool.base = (unsigned long)vmalloc(s_instance_pool.size);
+					s_instance_pool.phys_addr = s_instance_pool.base;
+
+					if (s_instance_pool.base != 0)
+#else
+					if (vpu_alloc_dma_buffer2(&s_instance_pool) != -1)
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+					{
+						memset((void *)s_instance_pool.base, 0x0, s_instance_pool.size); /*clearing memory*/
+						ret = copy_to_user((void __user *)arg, &s_instance_pool, sizeof(vpudrv_buffer_t));
+						if (ret == 0) {
+							/* success to get memory for instance pool */
+							up(&s_vpu_sem);
+							break;
+						}
+					}
+
+				}
+				ret = -EFAULT;
+			}
+
+			up(&s_vpu_sem);
+		}
+
+		DPRINTK("%s [-]VDI_IOCTL_GET_INSTANCE_POOL\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_GET_COMMON_MEMORY:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_COMMON_MEMORY\n", DEV_NAME);
+		if (s_common_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_common_memory, sizeof(vpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = copy_from_user(&s_common_memory, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret == 0) {
+				if (vpu_alloc_dma_buffer(&s_common_memory) != -1) {
+					ret = copy_to_user((void __user *)arg, &s_common_memory, sizeof(vpudrv_buffer_t));
+					if (ret == 0) {
+						/* success to get memory for common memory */
+						break;
+					}
+				}
+			}
+
+			ret = -EFAULT;
+		}
+		DPRINTK("%s [-]VDI_IOCTL_GET_COMMON_MEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_OPEN_INSTANCE:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+
+		vil = kzalloc(sizeof(*vil), GFP_KERNEL);
+		if (!vil)
+			return -ENOMEM;
+
+		if (copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t))) {
+			kfree(vil);
+			return -EFAULT;
+		}
+
+		vil->inst_idx = inst_info.inst_idx;
+		vil->core_idx = inst_info.core_idx;
+		vil->filp = filp;
+
+		spin_lock(&s_vpu_lock);
+		list_add(&vil->list, &s_inst_list_head);
+
+		inst_info.inst_open_count = 0; /* counting the current open instance number */
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		s_vpu_open_ref_count++; /* flag just for that vpu is in opened or closed */
+
+		if (copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t))) {
+			kfree(vil);
+			return -EFAULT;
+		}
+
+		DPRINTK("%s VDI_IOCTL_OPEN_INSTANCE core_idx=%d, inst_idx=%d, s_vpu_open_ref_count=%d, inst_open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, s_vpu_open_ref_count, inst_info.inst_open_count);
+	}
+	break;
+	case VDI_IOCTL_CLOSE_INSTANCE:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+
+		DPRINTK("%s [+]VDI_IOCTL_CLOSE_INSTANCE\n", DEV_NAME);
+		if (copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t)))
+			return -EFAULT;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->inst_idx == inst_info.inst_idx && vil->core_idx == inst_info.core_idx) {
+				list_del(&vil->list);
+				kfree(vil);
+				break;
+			}
+		}
+
+		inst_info.inst_open_count = 0; /* counting the current open instance number */
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		s_vpu_open_ref_count--; /* flag just for that vpu is in opened or closed */
+
+		if (copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t)))
+			return -EFAULT;
+
+		DPRINTK("%s VDI_IOCTL_CLOSE_INSTANCE core_idx=%d, inst_idx=%d, s_vpu_open_ref_count=%d, inst_open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, s_vpu_open_ref_count, inst_info.inst_open_count);
+	}
+	break;
+	case VDI_IOCTL_GET_INSTANCE_NUM:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+		DPRINTK("%s [+]VDI_IOCTL_GET_INSTANCE_NUM\n", DEV_NAME);
+
+		ret = copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t));
+		if (ret != 0)
+			break;
+
+		inst_info.inst_open_count = 0;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		ret = copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t));
+
+		DPRINTK("%s VDI_IOCTL_GET_INSTANCE_NUM core_idx=%d, inst_idx=%d, open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, inst_info.inst_open_count);
+
+	}
+	break;
+	case VDI_IOCTL_RESET:
+	{
+		u32 coreIdx;
+		if (get_user(coreIdx, (u32 __user *) arg))
+			return -EFAULT;
+		vpu_hw_reset(coreIdx);
+	}
+	break;
+	case VDI_IOCTL_GET_REGISTER_INFO:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_REGISTER_INFO\n", DEV_NAME);
+		ret = copy_to_user((void __user *)arg, &s_vpu_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		DPRINTK("%s [-]VDI_IOCTL_GET_REGISTER_INFO s_vpu_register.phys_addr=0x%lx, s_vpu_register.virt_addr=0x%lx, s_vpu_register.size=%d\n", DEV_NAME, s_vpu_register.phys_addr, s_vpu_register.virt_addr, s_vpu_register.size);
+	}
+	break;
+	/* RTK ioctl */
+	case VDI_IOCTL_SET_RTK_CLK_GATING:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+#ifdef CONFIG_POWER_CONTROL
+		struct power_control *pctrl;
+#endif
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_GATING\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		/* VE1 */
+		if (clockInfo.core_idx == 0) {
+			s_vpu_clk = s_vpu_clk_ve1;
+#ifdef CONFIG_POWER_CONTROL
+			pctrl = s_pctrl_ve1;
+#endif
+		} else {/* VE2 */
+			s_vpu_clk = s_vpu_clk_ve2;
+#ifdef CONFIG_POWER_CONTROL
+			pctrl = s_pctrl_ve2;
+#endif
+		}
+
+		if (clockInfo.enable == 1) {
+#ifdef CONFIG_POWER_CONTROL
+			pr_info("%s before pctrl_on for laterncy watching!!\n", DEV_NAME);
+			vpu_pctrl_on(pctrl);
+			pr_info("%s after pctrl_on for laterncy watching!!\n", DEV_NAME);
+#endif
+			vpu_clk_enable(s_vpu_clk);
+#ifdef CONFIG_ARCH_RTD139x
+			if (s_vpu_clk == s_vpu_clk_ve2)
+				vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+			ve1_wrapper_setup((1 << clockInfo.core_idx));
+		} else {
+			vpu_clk_disable(s_vpu_clk);
+#ifdef CONFIG_POWER_CONTROL
+			vpu_pctrl_off(pctrl);
+#endif
+		}
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_GATING clockInfo.core_idx:%d, clockInfo.enable:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.enable);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_CLK_PLL:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_PLL\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		s_vpu_clk = clockInfo.core_idx == 0 ? s_vpu_clk_ve1 : s_vpu_clk_ve2;
+		if (vpu_clk_pll_set_rate(s_vpu_clk, clockInfo.value))
+			break;
+			ve1_wrapper_setup((1 << clockInfo.core_idx));
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_PLL clockInfo.core_idx:%d, clockInfo.value:0x%x\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_CLK_PLL:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+
+		DPRINTK("%s [+]VDI_IOCTL_GET_RTK_CLK_PLL\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		/* VE1 */
+		if (clockInfo.core_idx == 0) {
+			s_vpu_clk = s_vpu_clk_ve1;
+		} else { /* VE2 */
+			s_vpu_clk = s_vpu_clk_ve2;
+		}
+		clockInfo.value = (unsigned int)clk_get_rate(s_vpu_clk);
+		ret = copy_to_user((vpu_clock_info_t *)arg, &clockInfo, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_GET_RTK_CLK_PLL clockInfo.core_idx:%d, clockInfo.value:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_CLK_SELECT:
+	{
+		vpu_clock_info_t clockInfo;
+		unsigned int value;
+		struct clk *s_vpu_clk;
+		struct clk *s_pclk = NULL;
+
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_SELECT\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		s_vpu_clk = clockInfo.core_idx == 0 ? s_vpu_clk_ve1 : s_vpu_clk_ve2;
+		switch(clockInfo.value)
+		{
+			case VE_PLL_SYSH:
+				s_pclk = s_vpu_clk_sysh;
+				break;
+			case VE_PLL_VE1:
+				s_pclk = s_vpu_pll_ve1;
+				break;
+			case VE_PLL_VE2:
+				s_pclk = s_vpu_pll_ve2;
+				break;
+			default:
+				pr_warn("%s  %s %d, wrong value:0x%x\n", DEV_NAME, __func__, __LINE__, clockInfo.value);
+				break;
+		}
+		if (s_pclk != NULL)
+			clk_set_parent(s_vpu_clk, s_pclk);
+
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_SELECT clockInfo.core_idx:%d, clockInfo.value:0x%x\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_CLK_SELECT:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+		struct clk *s_pclk;
+		DPRINTK("%s [+]VDI_IOCTL_GET_RTK_CLK_SELECT\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		s_vpu_clk = clockInfo.core_idx == 0 ? s_vpu_clk_ve1 : s_vpu_clk_ve2;
+		s_pclk = clk_get_parent(s_vpu_clk);
+		if (clk_is_match(s_pclk, s_vpu_clk_sysh))
+		{
+			clockInfo.value = (unsigned int)VE_PLL_SYSH;
+		}
+		else if (clk_is_match(s_pclk, s_vpu_pll_ve1))
+		{
+			clockInfo.value = (unsigned int)VE_PLL_VE1;
+		}
+		else if (clk_is_match(s_pclk, s_vpu_pll_ve2))
+		{
+			clockInfo.value = (unsigned int)VE_PLL_VE2;
+		}
+
+		ret = copy_to_user((vpu_clock_info_t *)arg, &clockInfo, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_GET_RTK_CLK_SELECT clockInfo.core_idx:%d, clockInfo.value:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_SUPPORT_TYPE:
+	{
+		ret = copy_to_user((void __user *)arg, &s_bond_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_ASIC_REVISION:
+	{
+		__put_user(get_rtd129x_cpu_revision()|get_rtd129x_cpu_id(), (unsigned int *) arg);
+	}
+	break;
+	default:
+	{
+		pr_err("%s No such IOCTL, cmd is %d\n", DEV_NAME, cmd);
+	}
+	break;
+	}
+
+	return ret;
+}
+
+static ssize_t vpu_read(struct file *filp, char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static int compat_get_vpu_bit_firmware_info_data(
+	compat_vpu_bit_firmware_info_t __user *data32,
+	vpu_bit_firmware_info_t __user *data)
+{
+	//compat_uint_t s;
+	compat_uint_t c;
+	compat_ulong_t r;
+	compat_ushort_t b[512];
+	int err;
+
+	//err = get_user(s, &data32->size);
+	//err |= put_user(s, &data->size);
+	data->size = sizeof(vpu_bit_firmware_info_t);
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(r, &data32->reg_base_offset);
+	err |= put_user(r, &data->reg_base_offset);
+	err |= copy_from_user(b, data32->bit_code, sizeof(b));
+	err |= copy_to_user(data->bit_code, b, sizeof(b));
+
+	return err;
+};
+
+static ssize_t vpu_write(struct file *filp, const char __user *buf, size_t len, loff_t *ppos)
+{
+
+	/* DPRINTK("[VPUDRV] vpu_write len=%d\n", (int)len); */
+	if (!buf) {
+		pr_err("%s vpu_write buf = NULL error \n", DEV_NAME);
+		return -EFAULT;
+	}
+
+	if (len == sizeof(vpu_bit_firmware_info_t) || len == sizeof(compat_vpu_bit_firmware_info_t))	{
+		vpu_bit_firmware_info_t *bit_firmware_info;
+
+		bit_firmware_info = kmalloc(sizeof(vpu_bit_firmware_info_t), GFP_KERNEL);
+		if (!bit_firmware_info) {
+			pr_err("%s vpu_write  bit_firmware_info allocation error\n", DEV_NAME);
+			return -EFAULT;
+		}
+
+		if (len == sizeof(vpu_bit_firmware_info_t)) {
+			if (copy_from_user(bit_firmware_info, buf, len)) {
+				pr_err("%s vpu_write copy_from_user error for bit_firmware_info\n", DEV_NAME);
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+		}
+#ifdef CONFIG_COMPAT
+		 else {
+			int err;
+			compat_vpu_bit_firmware_info_t __user *data32;
+			vpu_bit_firmware_info_t __user *data;
+
+			data32 = (compat_vpu_bit_firmware_info_t __user *) buf;
+			data = compat_alloc_user_space(sizeof(*data));
+			if (data == NULL) {
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+
+			err = compat_get_vpu_bit_firmware_info_data(data32, data);
+			if (err) {
+				kfree(bit_firmware_info);
+				return err;
+			}
+
+			if (copy_from_user(bit_firmware_info, data, sizeof(vpu_bit_firmware_info_t))) {
+				pr_err("%s vpu_write copy_from_user error for bit_firmware_info\n", DEV_NAME);
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+		}
+#endif /* CONFIG_COMPAT */
+
+		if (bit_firmware_info->size == sizeof(vpu_bit_firmware_info_t)) {
+			DPRINTK("%s vpu_write set bit_firmware_info coreIdx=0x%x, reg_base_offset=0x%x size=0x%x, bit_code[0]=0x%x\n",
+					DEV_NAME, bit_firmware_info->core_idx, (int)bit_firmware_info->reg_base_offset, bit_firmware_info->size, bit_firmware_info->bit_code[0]);
+
+			if (bit_firmware_info->core_idx > MAX_NUM_VPU_CORE) {
+				pr_err("%s vpu_write coreIdx[%d] is exceeded than MAX_NUM_VPU_CORE[%d]\n", DEV_NAME, bit_firmware_info->core_idx, MAX_NUM_VPU_CORE);
+				kfree(bit_firmware_info);
+				return -ENODEV;
+			}
+
+			memcpy((void *)&s_bit_firmware_info[bit_firmware_info->core_idx], bit_firmware_info, sizeof(vpu_bit_firmware_info_t));
+			kfree(bit_firmware_info);
+
+			return len;
+		}
+
+		kfree(bit_firmware_info);
+	}
+
+	return -1;
+}
+
+static int vpu_release(struct inode *inode, struct file *filp)
+{
+	int ret = 0;
+
+	DPRINTK("%s vpu_release\n", DEV_NAME);
+
+	ret = down_interruptible(&s_vpu_sem);
+	if (ret == 0) {
+		/* found and free the not handled buffer by user applications */
+		vpu_free_buffers(filp);
+		/* found and free the not closed instance by user applications */
+		vpu_free_instances(filp);
+		s_vpu_drv_context.open_count--;
+		if (s_vpu_drv_context.open_count == 0) {
+			if (s_instance_pool.base) {
+				DPRINTK("%s free instance pool\n", DEV_NAME);
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+				vfree((const void *)s_instance_pool.base);
+#else
+				pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+				vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+				s_instance_pool.base = 0;
+			}
+#if 0 /* Fuchun 20150909, we must not free instance pool and common memory */
+			if (s_common_memory.base) {
+				DPRINTK("%s free common memory\n", DEV_NAME);
+				vpu_free_dma_buffer(&s_common_memory);
+				s_common_memory.base = 0;
+			}
+#endif
+		}
+	}
+	up(&s_vpu_sem);
+
+	return 0;
+}
+
+static int vpu_fasync(int fd, struct file *filp, int mode)
+{
+	struct vpu_drv_context_t *dev = (struct vpu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+static int vpu_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	pfn = vm->vm_pgoff;
+
+	return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int vpu_map_to_physical_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+	return pu_mmap_dma_buffer(vm);
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif /* CONFIG_RTK_RESERVE_MEMORY */
+}
+
+static int vpu_map_to_instance_pool_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	int ret;
+	long length = vm->vm_end - vm->vm_start;
+	unsigned long start = vm->vm_start;
+	char *vmalloc_area_ptr = (char *)s_instance_pool.base;
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_RESERVED;
+
+	/* loop over all pages, map it page individually */
+	while (length > 0) {
+		pfn = vmalloc_to_pfn(vmalloc_area_ptr);
+		ret = remap_pfn_range(vm, start, pfn, PAGE_SIZE, PAGE_SHARED);
+		if (ret < 0) {
+			return ret;
+		}
+		start += PAGE_SIZE;
+		vmalloc_area_ptr += PAGE_SIZE;
+		length -= PAGE_SIZE;
+	}
+
+	return 0;
+#else
+	vm->vm_flags |= VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+}
+
+/*!
+ * @brief memory map interface for vpu file operation
+ * @return  0 on success or negative error code on error
+ */
+static int vpu_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	if (vm->vm_pgoff == 0)
+		return vpu_map_to_instance_pool_memory(fp, vm);
+
+	if ((vm->vm_pgoff == (s_vpu_register.phys_addr>>PAGE_SHIFT)) || (vm->vm_pgoff == (s_bond_register.phys_addr>>PAGE_SHIFT)))
+		return vpu_map_to_register(fp, vm);
+
+	return vpu_map_to_physical_memory(fp, vm);
+#else
+	if (vm->vm_pgoff) {
+		if (vm->vm_pgoff == (s_instance_pool.phys_addr>>PAGE_SHIFT))
+			return vpu_map_to_instance_pool_memory(fp, vm);
+
+		return vpu_map_to_physical_memory(fp, vm);
+	} else {
+		return vpu_map_to_register(fp, vm);
+	}
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+}
+
+struct file_operations vpu_fops = {
+	.owner = THIS_MODULE,
+	.open = vpu_open,
+	.read = vpu_read,
+	.write = vpu_write,
+	/*.ioctl = vpu_ioctl, // for kernel 2.6.9*/
+	.unlocked_ioctl = vpu_ioctl,
+	.compat_ioctl = compat_vpu_ioctl,
+	.release = vpu_release,
+	.fasync = vpu_fasync,
+	.mmap = vpu_mmap,
+};
+
+
+static int vpu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+	u32 bonding_value;
+	unsigned long virt_addr;
+	struct resource res;
+	void __iomem *iobase;
+	int irq;
+	struct device_node *node = pdev->dev.of_node;
+#if 0 //Fuchun disable 20160204, set clock gating by vdi.c
+	unsigned int val = 0;
+#endif
+
+	pr_info("%s vpu_probe\n", DEV_NAME);
+
+	of_address_to_resource(node, 0, &res);
+	iobase = of_iomap(node, 0);
+
+	s_vpu_register.phys_addr = res.start;
+	s_vpu_register.virt_addr = (unsigned long)iobase;
+	s_vpu_register.size = res.end - res.start + 1;
+
+	pr_info("%s vpu base address get from DTB physical base addr=0x%lx, virtual base=0x%lx, size=0x%x\n", DEV_NAME, s_vpu_register.phys_addr, s_vpu_register.virt_addr, s_vpu_register.size);
+
+	of_address_to_resource(node, 1, &res);
+	iobase = of_iomap(node, 1);
+
+	s_vpll_register.phys_addr = res.start;
+	s_vpll_register.virt_addr = (unsigned long)iobase;
+	s_vpll_register.size = res.end - res.start + 1;
+
+	s_vpu_dev.minor = MISC_VE1_MINOR;
+	s_vpu_dev.name = VPU_DEV_NAME;
+	s_vpu_dev.fops = &vpu_fops;
+	s_vpu_dev.parent = NULL;
+	if (misc_register(&s_vpu_dev)) {
+		pr_err("%s failed to register misc device.", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	of_address_to_resource(node, 2, &res);
+	iobase = of_iomap(node, 2);
+
+	s_bond_register.phys_addr = res.start;
+	s_bond_register.virt_addr = (unsigned long)iobase;
+	s_bond_register.size = res.end - res.start + 1;
+
+	virt_addr = (unsigned long)iobase;
+	bonding_value = __raw_readl((volatile u8 *)virt_addr);
+
+	pr_info("%s res.start:0x%llx, bonding_value:0x%x\n", DEV_NAME, res.start, bonding_value);
+
+	s_vpu_clk_ve1 = vpu_clk_get(&pdev->dev, 0);
+	s_vpu_clk_ve2 = vpu_clk_get(&pdev->dev, 1);
+#ifdef CONFIG_ARCH_RTD139x
+	s_vpu_clk_ve2_bpu = clk_get(&pdev->dev, "clk_ve2_bpu");
+#endif /* CONFIG_ARCH_RTD139x */
+	s_vpu_clk_sysh = clk_get(&pdev->dev, "clk_sysh");
+	s_vpu_pll_ve1 = clk_get(&pdev->dev, "pll_ve1");
+	s_vpu_pll_ve2 = clk_get(&pdev->dev, "pll_ve2");
+
+#ifdef CONFIG_POWER_CONTROL
+	s_pctrl_ve1 = vpu_pctrl_get(0);
+	s_pctrl_ve2 = vpu_pctrl_get(1);
+#endif
+
+	p_vpu_dev = &pdev->dev;
+
+#ifdef VPU_SUPPORT_CLOCK_CONTROL
+	vpu_clk_enable(s_vpu_clk_ve1);
+	vpu_clk_enable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+#endif
+
+	irq = irq_of_parse_and_map(node, 0);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_ve1_irq = irq;
+	pr_info("%s s_ve1_irq:%d want to register ve1_irq_handler\n", DEV_NAME, s_ve1_irq);
+	err = request_irq(s_ve1_irq, ve1_irq_handler, 0, "VE1_CODEC_IRQ", (void *)(&s_vpu_drv_context));
+	err = 0;
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_ve1_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_ve1_irq <%d> busy, change your config\n", DEV_NAME, s_ve1_irq);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	irq = irq_of_parse_and_map(node, 1);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_ve2_irq = irq;
+	pr_info("%s s_ve2_irq:%d want to register ve2_irq_handler\n", DEV_NAME, s_ve2_irq);
+	err = request_irq(s_ve2_irq, ve2_irq_handler, 0, "VE2_CODEC_IRQ", (void *)(&s_vpu_drv_context));
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_ve2_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_ve2_irq <%d> busy, change your config\n", DEV_NAME, s_ve2_irq);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	s_video_memory.size = VPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+	s_video_memory.phys_addr = VPU_DRAM_PHYSICAL_BASE;
+	s_video_memory.base = (unsigned long)ioremap_nocache(s_video_memory.phys_addr, PAGE_ALIGN(s_video_memory.size));
+	if (!s_video_memory.base) {
+		pr_err("%s fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", DEV_NAME, (int)s_video_memory.phys_addr, (int)s_video_memory.base, (int)s_video_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (vmem_init(&s_vmem, s_video_memory.phys_addr, s_video_memory.size) < 0) {
+		pr_err("%s fail to init vmem system\n", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+	pr_info("%s success to probe vpu device with reserved video memory phys_addr=0x%x, base = 0x%x\n", DEV_NAME, (int) s_video_memory.phys_addr, (int)s_video_memory.base);
+#else
+	pr_info("%s success to probe vpu device with non reserved video memory\n", DEV_NAME);
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+#ifndef CONFIG_RTK_PLATFORM_FPGA
+	/* RESET disable */
+	rstc_ve1 = reset_control_get(&pdev->dev, "ve1");
+	rstc_ve2 = reset_control_get(&pdev->dev, "ve2");
+
+	reset_control_deassert(rstc_ve1);
+	reset_control_deassert(rstc_ve2);
+#endif /* CONFIG_RTK_PLATFORM_FPGA */
+
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_off(s_pctrl_ve1);
+	vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+
+#if 0 /* Fuchun disable 20160204, set clock gating by vdi.c */
+	val = ReadVpuRegister(VE_CTRL_REG, 0);
+	val |= (ve_cti_en << 1 | ve_idle_en << 6);
+	WriteVpuRegister(VE_CTRL_REG, val, 0);
+
+	pr_info("%s VE1_CTRL_REG = 0x%08x (0x%08x)\n", DEV_NAME, val, ReadVpuRegister(VE_CTRL_REG, 0));
+
+	val = ReadVpuRegister(W4_VE_CTRL_REG, 1);
+	val |= (ve_cti_en << 1 | ve_idle_en << 6);
+	WriteVpuRegister(W4_VE_CTRL_REG, val, 1);
+
+	pr_info("%s VE2_CTRL_REG = 0x%08x (0x%08x)\n", DEV_NAME, val, ReadVpuRegister(W4_VE_CTRL_REG, 1));
+#endif
+
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+	misc_deregister(&s_vpu_dev);
+
+	return err;
+}
+
+static int vpu_remove(struct platform_device *pdev)
+{
+	DPRINTK("%s vpu_remove\n", DEV_NAME);
+
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+		vpu_free_dma_buffer(&s_instance_pool);
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+		s_instance_pool.base = 0;
+	}
+
+	if (s_common_memory.base) {
+		vpu_free_dma_buffer(&s_common_memory);
+		s_common_memory.base = 0;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_video_memory.base) {
+		iounmap((void *)s_video_memory.base);
+		s_video_memory.base = 0;
+		vmem_exit(&s_vmem);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	misc_deregister(&s_vpu_dev);
+
+#ifdef VPU_SUPPORT_ISR
+	if (s_ve1_irq)
+		free_irq(s_ve1_irq, &s_vpu_drv_context);
+	if (s_ve2_irq)
+		free_irq(s_ve2_irq, &s_vpu_drv_context);
+#endif /* VPU_SUPPORT_ISR */
+
+
+	vpu_clk_put(s_vpu_clk_ve1);
+	vpu_clk_put(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_put(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+/* DO NOT CHANGE */
+#define WAVE4_STACK_SIZE (8*1024)
+#define W4_MAX_CODE_BUF_SIZE (512*1024)
+#define W4_CMD_INIT_VPU (0x0001)
+#define W4_CMD_SLEEP_VPU (0x0400)
+#define W4_CMD_WAKEUP_VPU (0x0800)
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+static void Wave4BitIssueCommand(u32 cmd)
+{
+	WriteVpuRegister(W4_VPU_BUSY_STATUS, 1, 1);
+	WriteVpuRegister(W4_CORE_INDEX,  0, 1);
+	/* coreIdx = ReadVpuRegister(W4_VPU_BUSY_STATUS, 1);*/
+	/* coreIdx = 0;*/
+	/* WriteVpuRegister(W4_INST_INDEX,  (instanceIndex&0xffff)|(codecMode<<16), 1);*/
+	WriteVpuRegister(W4_COMMAND, cmd, 1);
+	WriteVpuRegister(W4_VPU_HOST_INT_REQ, 1, 1);
+
+	return;
+}
+#endif /* DISABLE_ORIGIN_SUSPEND */
+
+static int vpu_suspend(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_on(s_pctrl_ve1);
+	vpu_pctrl_on(s_pctrl_ve2);
+#endif
+	vpu_clk_enable(s_vpu_clk_ve1);
+	vpu_clk_enable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+
+	/* RTK wrapper */
+	ve1_wrapper_setup((1 << 1) | 1);
+
+	if (s_vpu_open_ref_count > 0) {
+#ifdef DISABLE_ORIGIN_SUSPEND
+		vpudrv_instanace_list_t *vil, *n;
+		vpudrv_instance_pool_t *vip;
+		void *vip_base;
+		int instance_pool_size_per_core;
+		vpudrv_buffer_pool_t *pool, *nn;
+		vpudrv_buffer_t vb;
+		s_vpu_drv_context.open_count = 0;
+		s_vpu_open_ref_count = 0;
+
+		/* s_instance_pool.size  assigned to the size of all core once call VDI_IOCTL_GET_INSTANCE_POOL by user. */
+		instance_pool_size_per_core = (s_instance_pool.size/MAX_NUM_VPU_CORE);
+
+		wake_up_interruptible_all(&s_interrupt_wait_q_ve1);
+		wake_up_interruptible_all(&s_interrupt_wait_q_ve2);
+
+		atomic_set(&s_interrupt_flag_ve1, 0);
+		atomic_set(&s_interrupt_flag_ve2, 0);
+
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			vip_base = (void *)(s_instance_pool.base + (instance_pool_size_per_core*vil->core_idx));
+			vip = (vpudrv_instance_pool_t *)vip_base;
+			if (vip) {
+				/* only first 4 byte is key point(inUse of CodecInst in vpuapi) to free the corresponding instance. */
+				memset(&vip->codecInstPool[vil->inst_idx], 0x00, 4);
+			}
+			list_del(&vil->list);
+			kfree(vil);
+		}
+
+		list_for_each_entry_safe(pool, nn, &s_vbp_head, list) {
+			vb = pool->vb;
+			if (vb.base) {
+				vpu_free_dma_buffer(&vb);
+			}
+			list_del(&pool->list);
+			kfree(pool);
+		}
+
+		if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_instance_pool.base);
+#else
+			pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+			vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+			s_instance_pool.base = 0;
+		}
+#else /* else of DISABLE_ORIGIN_SUSPEND */
+		int i;
+		int core;
+		unsigned long timeout = jiffies + HZ; /* vpu wait timeout to 1sec */
+		int product_code = 0;
+
+		for (core = 0; core < MAX_NUM_VPU_CORE; core++) {
+			if (s_bit_firmware_info[core].size == 0)
+				continue;
+			product_code = ReadVpuRegister(VPU_PRODUCT_CODE_REGISTER, core);
+			if (product_code == WAVE410_CODE || product_code == WAVE4102_CODE || product_code == WAVE420_CODE) {
+				while (ReadVpuRegister(W4_VPU_BUSY_STATUS, core)) {
+					if (time_after(jiffies, timeout)) {
+						DPRINTK("%s SLEEP_VPU BUSY timeout", DEV_NAME);
+						goto DONE_SUSPEND;
+					}
+				}
+				Wave4BitIssueCommand(W4_CMD_SLEEP_VPU);
+
+				while (ReadVpuRegister(W4_VPU_BUSY_STATUS, core)) {
+					if (time_after(jiffies, timeout)) {
+						DPRINTK("%s SLEEP_VPU BUSY timeout", DEV_NAME);
+						goto DONE_SUSPEND;
+					}
+				}
+				if (ReadVpuRegister(W4_RET_SUCCESS, core) == 0) {
+					DPRINTK("%s SLEEP_VPU failed [0x%x]", DEV_NAME, ReadVpuRegister(W4_RET_FAIL_REASON, core));
+					goto DONE_SUSPEND;
+				}
+			} else {
+				while (ReadVpuRegister(BIT_BUSY_FLAG, core)) {
+					if (time_after(jiffies, timeout))
+						goto DONE_SUSPEND;
+				}
+
+				for (i = 0; i < 64; i++)
+					s_vpu_reg_store[core][i] = ReadVpuRegister(BIT_BASE+(0x100+(i * 4)), core);
+			}
+		}
+#endif /* end of DISABLE_ORIGIN_SUSPEND */
+	}
+
+	vpu_clk_disable(s_vpu_clk_ve1);
+	vpu_clk_disable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_disable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_off(s_pctrl_ve1);
+	vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+DONE_SUSPEND:
+#endif
+
+	vpu_clk_disable(s_vpu_clk_ve1);
+	vpu_clk_disable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_disable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_off(s_pctrl_ve1);
+	vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return -EAGAIN;
+}
+
+static int vpu_resume(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_on(s_pctrl_ve1);
+	vpu_pctrl_on(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+
+	vpu_clk_enable(s_vpu_clk_ve1);
+	vpu_clk_enable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+
+	//RTK wrapper
+	ve1_wrapper_setup((1 << 1) | 1);
+
+#ifdef DISABLE_ORIGIN_SUSPEND
+#else /* else of DISABLE_ORIGIN_SUSPEND */
+	int i;
+	int core;
+	int regVal;
+	int product_code = 0;
+	unsigned long timeout = jiffies + HZ; /* vpu wait timeout to 1sec */
+	unsigned long code_base;
+	unsigned long stack_base;
+	u32 val;
+	u32 code_size;
+	u32 stack_size;
+	u32 remap_size;
+	u32 hwOption  = 0;
+
+	for (core = 0; core < MAX_NUM_VPU_CORE; core++) {
+
+		if (s_bit_firmware_info[core].size == 0) {
+			continue;
+		}
+
+		product_code = ReadVpuRegister(VPU_PRODUCT_CODE_REGISTER, core);
+
+		if (product_code == WAVE410_CODE || product_code == WAVE4102_CODE || product_code == WAVE420_CODE) {
+
+			code_base = s_common_memory.phys_addr;
+			/* ALIGN TO 4KB */
+			code_size = (W4_MAX_CODE_BUF_SIZE&~0xfff);
+			if (code_size < s_bit_firmware_info[core].size*2) {
+				goto DONE_WAKEUP;
+			}
+			stack_base = code_base + code_size;
+			stack_size = WAVE4_STACK_SIZE;
+
+			/*---- LOAD BOOT CODE*/
+			//for (i = 0; i < 512; i++) {
+			//	val = s_bit_firmware_info[core].bit_code[i];
+			//	WriteVpu(code_base+(i*4), val);
+			//}
+
+			regVal = 0;
+			WriteVpuRegister(W4_PO_CONF, regVal, core);
+
+			/* Reset All blocks */
+			regVal = 0x7ffffff;
+			WriteVpuRegister(W4_RESET_REQ, regVal, core);	/*Reset All blocks*/
+
+			/* Waiting reset done */
+			while (ReadVpuRegister(W4_RESET_STATUS, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+			WriteVpuRegister(W4_RESET_REQ, 0, core);
+
+			/* remap page size */
+			remap_size = (code_size >> 12) & 0x1ff;
+			regVal = 0x80000000 | (W4_REMAP_CODE_INDEX<<12) | (0 << 16) | (1<<11) | remap_size;
+			WriteVpuRegister(W4_VPU_REMAP_CTRL,	 regVal, core);
+			WriteVpuRegister(W4_VPU_REMAP_VADDR,	0x00000000, core);	/* DO NOT CHANGE! */
+			WriteVpuRegister(W4_VPU_REMAP_PADDR,	code_base, core);
+			WriteVpuRegister(W4_ADDR_CODE_BASE,	 code_base, core);
+			WriteVpuRegister(W4_CODE_SIZE,		  code_size, core);
+			WriteVpuRegister(W4_CODE_PARAM,		 0, core);
+			WriteVpuRegister(W4_INIT_VPU_TIME_OUT_CNT,   timeout, core);
+
+			/* Stack */
+			WriteVpuRegister(W4_ADDR_STACK_BASE, stack_base, core);
+			WriteVpuRegister(W4_STACK_SIZE,	  stack_size, core);
+			WriteVpuRegister(W4_HW_OPTION, hwOption, core);
+
+			/* Interrupt */
+			regVal  = (1<<W4_INT_DEC_PIC_HDR);
+			regVal |= (1<<W4_INT_DEC_PIC);
+			regVal |= (1<<W4_INT_QUERY_DEC);
+			regVal |= (1<<W4_INT_SLEEP_VPU);
+			regVal |= (1<<W4_INT_BSBUF_EMPTY);
+
+			WriteVpuRegister(W4_VPU_INT_ENABLE,  regVal, core);
+
+			Wave4BitIssueCommand(W4_CMD_INIT_VPU);
+			WriteVpuRegister(W4_VPU_REMAP_PROC_START, 1, core);
+
+			while (ReadVpuRegister(W4_VPU_BUSY_STATUS, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+			if (ReadVpuRegister(W4_RET_SUCCESS, core) == 0) {
+				DPRINTK("%s WAKEUP_VPU failed [0x%x]", DEV_NAME, ReadVpuRegister(W4_RET_FAIL_REASON, core));
+				goto DONE_WAKEUP;
+			}
+		} else {
+
+			WriteVpuRegister(BIT_CODE_RUN, 0, core);
+
+			/*---- LOAD BOOT CODE*/
+			for (i = 0; i < 512; i++) {
+				val = s_bit_firmware_info[core].bit_code[i];
+				WriteVpuRegister(BIT_CODE_DOWN, ((i << 16) | val), core);
+			}
+
+			for (i = 0 ; i < 64 ; i++)
+				WriteVpuRegister(BIT_BASE+(0x100+(i * 4)), s_vpu_reg_store[core][i], core);
+
+			WriteVpuRegister(BIT_BUSY_FLAG, 1, core);
+			WriteVpuRegister(BIT_CODE_RESET, 1, core);
+			WriteVpuRegister(BIT_CODE_RUN, 1, core);
+
+			while (ReadVpuRegister(BIT_BUSY_FLAG, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+		}
+
+	}
+#endif /* end of DISABLE_ORIGIN_SUSPEND */
+
+	if (s_vpu_open_ref_count == 0) {
+		vpu_clk_disable(s_vpu_clk_ve1);
+		vpu_clk_disable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+		vpu_clk_disable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+#ifdef CONFIG_POWER_CONTROL
+		vpu_pctrl_off(s_pctrl_ve1);
+		vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+	}
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+DONE_WAKEUP:
+#endif /* DISABLE_ORIGIN_SUSPEND */
+
+	if (s_vpu_open_ref_count > 0) {
+		vpu_clk_enable(s_vpu_clk_ve1);
+		vpu_clk_enable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+		vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+#ifdef CONFIG_POWER_CONTROL
+		vpu_pctrl_off(s_pctrl_ve1);
+		vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+	}
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+#else
+static int vpu_suspend(struct device *pdev);
+static int vpu_resume(struct device *pdev);
+#endif /* CONFIG_PM */
+
+static int __init vpu_init(void)
+{
+	int res = 0;
+
+	DPRINTK("%s begin vpu_init\n", DEV_NAME);
+
+	init_waitqueue_head(&s_interrupt_wait_q_ve1);
+	init_waitqueue_head(&s_interrupt_wait_q_ve2);
+	s_common_memory.base = 0;
+	s_instance_pool.base = 0;
+
+	DPRINTK("%s end vpu_init result=0x%x\n", DEV_NAME, res);
+	return res;
+}
+
+static void __exit vpu_exit(void)
+{
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	DPRINTK("%s vpu_exit\n", DEV_NAME);
+#else
+
+	vpu_clk_put(s_vpu_clk_ve1);
+	vpu_clk_put(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_put(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+
+	if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+		vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+		s_instance_pool.base = 0;
+	}
+
+	if (s_common_memory.base) {
+		vpu_free_dma_buffer(&s_common_memory);
+		s_common_memory.base = 0;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_video_memory.base) {
+		iounmap((void *)s_video_memory.base);
+		s_video_memory.base = 0;
+
+		vmem_exit(&s_vmem);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	misc_deregister(&s_vpu_dev);
+
+#ifdef VPU_SUPPORT_ISR
+	if (s_ve1_irq)
+		free_irq(s_ve1_irq, &s_vpu_drv_context);
+	if (s_ve2_irq)
+		free_irq(s_ve2_irq, &s_vpu_drv_context);
+#endif /* VPU_SUPPORT_ISR */
+
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+
+	return;
+}
+
+MODULE_AUTHOR("A customer using RTK VPU, Inc.");
+MODULE_DESCRIPTION("VPU linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(vpu_init);
+module_exit(vpu_exit);
+
+#ifdef CONFIG_POWER_CONTROL
+
+static int vpu_pcrtl_callback(struct notifier_block *nb,
+			      unsigned long action,
+			      void *p)
+{
+	struct power_control *pctrl = p;
+
+	if (action != POWER_CONTROL_ACTION_POST_POWER_ON)
+		return NOTIFY_DONE;
+
+	if (s_pctrl_ve1 == pctrl)
+		reset_control_reset(rstc_ve1);
+	if (s_pctrl_ve2 == pctrl)
+		reset_control_reset(rstc_ve2);
+	return NOTIFY_OK;
+}
+
+struct notifier_block vpu_pctrl_nb = {
+	.notifier_call = vpu_pcrtl_callback,
+};
+
+struct power_control *vpu_pctrl_get(u32 coreIdx)
+{
+	struct power_control *pctrl;
+
+	if (coreIdx == 0)
+		pctrl = power_control_get("pctrl_ve1");
+	else
+		pctrl = power_control_get("pctrl_ve2");
+
+	if (WARN_ON(IS_ERR_OR_NULL(pctrl)))
+		return NULL;
+	power_control_register_notifier(pctrl, &vpu_pctrl_nb);
+	return pctrl;
+}
+
+void vpu_pctrl_on(struct power_control *pctrl)
+{
+	if (!(pctrl == NULL || IS_ERR(pctrl))) {
+		DPRINTK("%s vpu_pctrl_on\n", DEV_NAME);
+		power_control_power_on(pctrl);
+	}
+
+	if (s_pctrl_ve1 == pctrl)
+		reset_control_reset(rstc_ve1);
+	if (s_pctrl_ve2 == pctrl)
+		reset_control_reset(rstc_ve2);
+}
+
+void vpu_pctrl_off(struct power_control *pctrl)
+{
+	if (!(pctrl == NULL || IS_ERR(pctrl))) {
+		DPRINTK("%s vpu_pctrl_off\n", DEV_NAME);
+		power_control_power_off(pctrl);
+	}
+}
+#endif /* CONFIG_POWER_CONTROL */
+
+static const struct of_device_id rtk_ve1_dt_match[] = {
+	{ .compatible = "Realtek,rtk1295-ve1" },
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtk_ve1_dt_match);
+
+const struct dev_pm_ops rtk_ve1_pmops = {
+	.suspend = vpu_suspend,
+	.resume = vpu_resume,
+};
+
+static struct platform_driver rtk_ve1_driver = {
+	.driver = {
+		.name = "rtk-ve1",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_ve1_dt_match,
+		.pm = &rtk_ve1_pmops,
+	},
+	.probe = vpu_probe,
+	.remove = vpu_remove,
+};
+
+module_platform_driver(rtk_ve1_driver);
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1.h b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1.h
new file mode 100644
index 00000000..16753d5
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1.h
@@ -0,0 +1,92 @@
+/**
+  ve1.c
+
+  linux device driver for VPU.
+
+ Copyright (C) 2006 - 2013  REALTEK INC.
+
+  This library is free software; you can redistribute it and/or modify it under
+  the terms of the GNU Lesser General Public License as published by the Free
+  Software Foundation; either version 2.1 of the License, or (at your option)
+  any later version.
+
+  This library is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+  details.
+
+  You should have received a copy of the GNU Lesser General Public License
+  along with this library; if not, write to the Free Software Foundation, Inc.,
+  51 Franklin St, Fifth Floor, Boston, MA
+  02110-1301  USA
+
+*/
+
+#ifndef __VPU_DRV_H__
+#define __VPU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+#define USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+
+#define VDI_IOCTL_MAGIC 'V'
+#define VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(VDI_IOCTL_MAGIC, 0)
+#define VDI_IOCTL_FREE_PHYSICALMEMORY _IO(VDI_IOCTL_MAGIC, 1)
+#define VDI_IOCTL_WAIT_INTERRUPT _IO(VDI_IOCTL_MAGIC, 2)
+#define VDI_IOCTL_SET_CLOCK_GATE _IO(VDI_IOCTL_MAGIC, 3)
+#define VDI_IOCTL_RESET _IO(VDI_IOCTL_MAGIC, 4)
+#define VDI_IOCTL_GET_INSTANCE_POOL _IO(VDI_IOCTL_MAGIC, 5)
+#define VDI_IOCTL_GET_COMMON_MEMORY _IO(VDI_IOCTL_MAGIC, 6)
+#define VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(VDI_IOCTL_MAGIC, 8)
+#define VDI_IOCTL_OPEN_INSTANCE _IO(VDI_IOCTL_MAGIC, 9)
+#define VDI_IOCTL_CLOSE_INSTANCE _IO(VDI_IOCTL_MAGIC, 10)
+#define VDI_IOCTL_GET_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 11)
+#define VDI_IOCTL_GET_REGISTER_INFO _IO(VDI_IOCTL_MAGIC, 12)
+
+/* RTK ioctl */
+#define VDI_IOCTL_SET_RTK_CLK_GATING _IO(VDI_IOCTL_MAGIC, 16)
+#define VDI_IOCTL_SET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 17)
+#define VDI_IOCTL_GET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 18)
+#define VDI_IOCTL_GET_RTK_SUPPORT_TYPE _IO(VDI_IOCTL_MAGIC, 19)
+#define VDI_IOCTL_GET_RTK_ASIC_REVISION _IO(VDI_IOCTL_MAGIC, 20)
+#define VDI_IOCTL_SET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 21)
+#define VDI_IOCTL_GET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 22)
+
+#define VE_PLL_SYSH	0x000
+#define VE_PLL_VE1	0x001
+#define VE_PLL_VE2	0x010
+
+typedef struct vpudrv_buffer_t {
+	unsigned int size;
+	unsigned long phys_addr;
+	unsigned long base; /* kernel logical address in use kernel */
+	unsigned long virt_addr; /* virtual user space address */
+	unsigned int mem_type; /* RTK, for protect memory */
+} vpudrv_buffer_t;
+
+typedef struct vpu_bit_firmware_info_t {
+	unsigned int size; /* size of this structure*/
+	unsigned int core_idx;
+	unsigned long reg_base_offset;
+	unsigned short bit_code[512];
+} vpu_bit_firmware_info_t;
+
+typedef struct vpu_clock_info_t{
+	unsigned int core_idx;
+	unsigned int enable;
+	unsigned int value;
+} vpu_clock_info_t;
+
+typedef struct vpudrv_inst_info_t {
+	unsigned int core_idx;
+	unsigned int inst_idx;
+	int inst_open_count; /* for output only*/
+} vpudrv_inst_info_t;
+
+typedef struct vpudrv_intr_info_t {
+	unsigned int core_idx;
+	unsigned int timeout;
+	int intr_reason;
+} vpudrv_intr_info_t;
+#endif
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1config.h b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1config.h
new file mode 100644
index 00000000..88363b2
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1config.h
@@ -0,0 +1,105 @@
+/* =========================================================================
+ *  This file is a part of VE1 Reference API project
+ * -----------------------------------------------------------------------------
+ *
+ * This confidential and proprietary software may be used only
+ * as authorized by a licensing agreement from Realtek Inc.
+ * In the event of publication, the following notice is applicable:
+ *
+ * (C) COPYRIGHT 2006 - 2011  REALTEK INC.
+ * ALL RIGHTS RESERVED
+ *
+ * The entire notice above must be reproduced on all authorized
+ * copies.
+ * This file should be modified by some customers according to their SOC configuration.
+ * =========================================================================
+ */
+
+#ifndef _VPU_CONFIG_H_
+#define _VPU_CONFIG_H_
+
+#define BODA7503_CODE 0x7503
+#define CODA7542_CODE 0x7542
+#define BODA950_CODE 0x9500
+#define CODA960_CODE 0x9600
+#define CODA980_CODE 0x9800
+#define WAVE320_CODE 0x3200
+#define WAVE410_CODE 0x4100 /* Wave410 version 1: Single vcore */
+#define WAVE4102_CODE 0x4102 /* Wave410 version 2: Multi vcore */
+#define WAVE420_CODE 0x4200 /* Wave420 */
+#define WAVE412_CODE 0x4120
+
+#define MAX_INST_HANDLE_SIZE (32*1024)
+#define MAX_NUM_INSTANCE 8
+#define MAX_NUM_VPU_CORE 2
+#define MAX_NUM_VCORE 1
+
+#define MAX_ENC_AVC_PIC_WIDTH 4096
+#define MAX_ENC_AVC_PIC_HEIGHT 2304
+#define MAX_ENC_PIC_WIDTH 4096
+#define MAX_ENC_PIC_HEIGHT 2304
+#define MIN_ENC_PIC_WIDTH 96
+#define MIN_ENC_PIC_HEIGHT 16
+
+/* for WAVE420 */
+#define W4_MIN_ENC_PIC_WIDTH 256
+#define W4_MIN_ENC_PIC_HEIGHT 128
+#define W4_MAX_ENC_PIC_WIDTH 8192
+#define W4_MAX_ENC_PIC_HEIGHT 8192
+
+#define MAX_DEC_PIC_WIDTH 4096
+#define MAX_DEC_PIC_HEIGHT 2304
+
+/* Application specific configuration */
+#define VPU_ENC_TIMEOUT 5000
+#define VPU_DEC_TIMEOUT 10000
+#define VPU_BUSY_CHECK_TIMEOUT 5000
+
+/* codec specific configuration */
+/* it can be set to 1 to handle reordering DPB in host side. */
+#define VPU_REORDER_ENABLE 1
+/*
+ * [default 1 for BW checking with RTKViedo Conformance] 0 (chroma separate mode), 1 (chroma interleave mode)
+ * if the type of tiledmap uses the kind of MB_RASTER_MAP. must set to enable CBCR_INTERLEAVE
+ */
+#define CBCR_INTERLEAVE 1
+#define VPU_ENABLE_BWB 1
+#define VPU_REPORT_USERDATA	 0
+
+#define HOST_ENDIAN  VDI_128BIT_LITTLE_ENDIAN
+#define VPU_FRAME_ENDIAN HOST_ENDIAN
+#define VPU_STREAM_ENDIAN HOST_ENDIAN
+#define VPU_USER_DATA_ENDIAN HOST_ENDIAN
+#define DRAM_BUS_WIDTH	 16
+
+/************************************************************************/
+/* VPU COMMON MEMORY */
+/************************************************************************/
+#define SIZE_COMMON (2*1024*1024)
+
+/*=====4. VPU REPORT MEMORY  ======================*/
+#define SIZE_REPORT_BUF (0x10000)
+
+#define STREAM_END_SIZE 0
+#define STREAM_END_SET_FLAG 0
+#define STREAM_END_CLEAR_FLAG -1
+
+#define USE_BIT_INTERNAL_BUF 1
+#define USE_IP_INTERNAL_BUF 1
+#define USE_DBKY_INTERNAL_BUF 1
+#define USE_DBKC_INTERNAL_BUF 1
+#define USE_OVL_INTERNAL_BUF 1
+#define USE_BTP_INTERNAL_BUF 1
+#define USE_ME_INTERNAL_BUF 1
+
+/* WAVE410 only */
+#define USE_BPU_INTERNAL_BUF 1
+#define USE_VCE_IP_INTERNAL_BUF 1
+#define USE_VCE_LF_ROW_INTERNAL_BUF 1
+
+/* WAVE420 only */
+#define USE_IMD_INTERNAL_BUF 1
+#define USE_RDO_INTERNAL_BUF 1
+#define USE_LF_INTERNAL_BUF 1
+
+#endif  /* _VPU_CONFIG_H_ */
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve1/vmm.h b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/vmm.h
new file mode 100644
index 00000000..5ad5792
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve1/vmm.h
@@ -0,0 +1,634 @@
+/**
+  vmm.h
+
+  memory allocator for VE
+
+ Copyright (C) 2006 - 2013  REALTEK INC.
+
+  This library is free software; you can redistribute it and/or modify it under
+  the terms of the GNU Lesser General Public License as published by the Free
+  Software Foundation; either version 2.1 of the License, or (at your option)
+  any later version.
+
+  This library is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+  details.
+
+  You should have received a copy of the GNU Lesser General Public License
+  along with this library; if not, write to the Free Software Foundation, Inc.,
+  51 Franklin St, Fifth Floor, Boston, MA
+  02110-1301  USA
+
+*/
+
+#ifndef __RTK_VIDEO_MEMORY_MANAGEMENT_H__
+#define __RTK_VIDEO_MEMORY_MANAGEMENT_H__
+
+typedef struct _video_mm_info_struct {
+	unsigned long   total_pages;
+	unsigned long   alloc_pages;
+	unsigned long   free_pages;
+	unsigned long   page_size;
+} vmem_info_t;
+
+typedef unsigned long long  vmem_key_t;
+
+#define VMEM_PAGE_SIZE (16*1024)
+#define MAKE_KEY(_a, _b) (((vmem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key) (_key>>32)
+
+typedef struct page_struct {
+	int pageno;
+	unsigned long addr;
+	int used;
+	int alloc_pages;
+	int first_pageno;
+} page_t;
+
+typedef struct avl_node_struct {
+	vmem_key_t key;
+	int height;
+	page_t *page;
+	struct avl_node_struct *left;
+	struct avl_node_struct *right;
+} avl_node_t;
+
+typedef struct _video_mm_struct {
+	avl_node_t *free_tree;
+	avl_node_t *alloc_tree;
+	page_t *page_list;
+	int num_pages;
+	unsigned long base_addr;
+	unsigned long mem_size;
+	int free_page_count;
+	int  alloc_page_count;
+} video_mm_t;
+
+#define VMEM_P_ALLOC(_x) vmalloc(_x)
+#define VMEM_P_FREE(_x) vfree(_x)
+
+#define VMEM_ASSERT(_exp) if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/
+#define VMEM_HEIGHT(_tree) (_tree == NULL ? -1 : _tree->height)
+
+#define MAX(_a, _b) (_a >= _b ? _a : _b)
+
+typedef enum {
+	LEFT,
+	RIGHT
+} rotation_dir_t;
+
+typedef struct avl_node_data_struct {
+	int	 key;
+	page_t *page;
+} avl_node_data_t;
+
+static avl_node_t* make_avl_node( vmem_key_t key, page_t *page)
+{
+	avl_node_t *node = (avl_node_t *)VMEM_P_ALLOC(sizeof(avl_node_t));
+	node->key	 = key;
+	node->page	= page;
+	node->height  = 0;
+	node->left	= NULL;
+	node->right   = NULL;
+
+	return node;
+}
+
+static int get_balance_factor(avl_node_t *tree)
+{
+	int factor = 0;
+	if (tree) {
+		factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+	}
+
+	return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *	  A					  B
+ *	   \					/ \
+ *		B		 =>	   A   C
+ *	   /  \				 \
+ *	  D	C				 D
+ *
+ */
+static avl_node_t* rotation_left(avl_node_t *tree)
+{
+	avl_node_t *rchild;
+	avl_node_t *lchild;
+
+	if (tree == NULL)
+		return NULL;
+
+	rchild = tree->right;
+	if (rchild == NULL) {
+		return tree;
+	}
+
+	lchild = rchild->left;
+	rchild->left = tree;
+	tree->right = lchild;
+
+	tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+	rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+	return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *		 A				  B
+ *	   \				  /  \
+ *	  B		 =>	   D	A
+ *	/  \					 /
+ *   D	C				   C
+ *
+ */
+static avl_node_t *rotation_right(avl_node_t *tree)
+{
+	avl_node_t *rchild;
+	avl_node_t *lchild;
+
+	if (tree == NULL)
+		return NULL;
+
+	lchild = tree->left;
+	if (lchild == NULL)
+		return NULL;
+
+	rchild = lchild->right;
+	lchild->right = tree;
+	tree->left = rchild;
+
+	tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+	lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+	return lchild;
+}
+
+static avl_node_t *do_balance(avl_node_t *tree)
+{
+	int bfactor = 0, child_bfactor;	   /* balancing factor */
+
+	bfactor = get_balance_factor(tree);
+
+	if (bfactor >= 2) {
+		child_bfactor = get_balance_factor(tree->right);
+		if (child_bfactor == 1 || child_bfactor == 0) {
+			tree = rotation_left(tree);
+		} else if (child_bfactor == -1) {
+			tree->right = rotation_right(tree->right);
+			tree		= rotation_left(tree);
+		} else {
+			printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+			VMEM_ASSERT(0);
+			return NULL;
+		}
+	} else if (bfactor <= -2) {
+		child_bfactor = get_balance_factor(tree->left);
+		if (child_bfactor == -1 || child_bfactor == 0) {
+			tree = rotation_right(tree);
+		} else if (child_bfactor == 1) {
+			tree->left = rotation_left(tree->left);
+			tree	   = rotation_right(tree);
+		} else {
+			printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+			VMEM_ASSERT(0);
+			return NULL;
+		}
+	}
+
+	return tree;
+}
+
+static avl_node_t *unlink_end_node(avl_node_t *tree, int dir, avl_node_t **found_node)
+{
+	avl_node_t *node;
+	*found_node = NULL;
+
+	if (tree == NULL)
+		return NULL;
+
+	if (dir == LEFT) {
+		if (tree->left == NULL) {
+			*found_node = tree;
+			return NULL;
+		}
+	} else {
+		if (tree->right == NULL) {
+			*found_node = tree;
+			return NULL;
+		}
+	}
+
+	if (dir == LEFT) {
+		node = tree->left;
+		tree->left = unlink_end_node(tree->left, LEFT, found_node);
+		if (tree->left == NULL) {
+			tree->left = (*found_node)->right;
+			(*found_node)->left  = NULL;
+			(*found_node)->right = NULL;
+		}
+	} else {
+		node = tree->right;
+		tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+		if (tree->right == NULL) {
+			tree->right = (*found_node)->left;
+			(*found_node)->left  = NULL;
+			(*found_node)->right = NULL;
+		}
+	}
+
+	tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	return do_balance(tree);
+}
+
+
+static avl_node_t *avltree_insert(avl_node_t *tree, vmem_key_t key, page_t *page)
+{
+	if (tree == NULL) {
+		tree = make_avl_node(key, page);
+	} else {
+		if (key >= tree->key) {
+			tree->right = avltree_insert(tree->right, key, page);
+		} else {
+			tree->left  = avltree_insert(tree->left, key, page);
+		}
+	}
+
+	tree = do_balance(tree);
+
+	tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	return tree;
+}
+
+static avl_node_t *do_unlink(avl_node_t *tree)
+{
+	avl_node_t *node;
+	avl_node_t *end_node;
+
+	node = unlink_end_node(tree->right, LEFT, &end_node);
+	if (node) {
+		tree->right = node;
+	} else {
+		node = unlink_end_node(tree->left, RIGHT, &end_node);
+		if (node)
+			tree->left = node;
+	}
+
+	if (node == NULL) {
+		node = tree->right ? tree->right : tree->left;
+		end_node = node;
+	}
+
+	if (end_node) {
+		end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+		end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+		end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+	}
+
+	tree = end_node;
+
+	return tree;
+}
+
+static avl_node_t *avltree_remove(avl_node_t *tree, avl_node_t **found_node, vmem_key_t key)
+{
+	*found_node = NULL;
+	if (tree == NULL) {
+		printk(KERN_INFO "failed to find key %d\n", (int)key);
+		return NULL;
+	}
+
+	if (key == tree->key) {
+		*found_node = tree;
+		tree = do_unlink(tree);
+	} else if (key > tree->key) {
+		tree->right = avltree_remove(tree->right, found_node, key);
+	} else {
+		tree->left  = avltree_remove(tree->left, found_node, key);
+	}
+
+	if (tree)
+		tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	tree = do_balance(tree);
+
+	return tree;
+}
+
+void avltree_free(avl_node_t *tree)
+{
+	if (tree == NULL)
+		return;
+	if (tree->left == NULL && tree->right == NULL) {
+		VMEM_P_FREE(tree);
+		return;
+	}
+
+	avltree_free(tree->left);
+	tree->left = NULL;
+	avltree_free(tree->right);
+	tree->right = NULL;
+	VMEM_P_FREE(tree);
+}
+
+static avl_node_t *remove_approx_value(avl_node_t *tree, avl_node_t **found, vmem_key_t key)
+{
+	*found = NULL;
+	if (tree == NULL) {
+		return NULL;
+	}
+
+	if (key == tree->key) {
+		*found = tree;
+		tree = do_unlink(tree);
+	} else if (key > tree->key) {
+		tree->right = remove_approx_value(tree->right, found, key);
+	} else {
+		tree->left  = remove_approx_value(tree->left, found, key);
+		if (*found == NULL) {
+			*found = tree;
+			tree = do_unlink(tree);
+		}
+	}
+	if (tree)
+		tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	tree = do_balance(tree);
+
+	return tree;
+}
+
+static void set_blocks_free(video_mm_t *mm, int pageno, int npages)
+{
+	int last_pageno	 = pageno + npages - 1;
+	int i;
+	page_t *page;
+	page_t *last_page;
+
+	VMEM_ASSERT(npages);
+
+	if (last_pageno >= mm->num_pages) {
+		printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+		VMEM_ASSERT(0);
+		return;
+	}
+
+	for (i = pageno; i <= last_pageno; i++) {
+		mm->page_list[i].used		 = 0;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	page		= &mm->page_list[pageno];
+	page->alloc_pages = npages;
+	last_page   = &mm->page_list[last_pageno];
+	last_page->first_pageno = pageno;
+
+	mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void set_blocks_alloc(video_mm_t *mm, int pageno, int npages)
+{
+	int last_pageno	 = pageno + npages - 1;
+	int i;
+	page_t *page;
+	page_t *last_page;
+
+	if (last_pageno >= mm->num_pages) {
+		printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+		VMEM_ASSERT(0);
+		return;
+	}
+
+	for (i = pageno; i <= last_pageno; i++) {
+		mm->page_list[i].used		 = 1;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	page		= &mm->page_list[pageno];
+	page->alloc_pages = npages;
+
+	last_page   = &mm->page_list[last_pageno];
+	last_page->first_pageno = pageno;
+
+	mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int vmem_init(video_mm_t *mm, unsigned long addr, unsigned long size)
+{
+	int i;
+
+	if (NULL == mm)
+		return -1;
+
+	mm->base_addr  = (addr+(VMEM_PAGE_SIZE-1))&~(VMEM_PAGE_SIZE-1);
+	mm->mem_size   = size&~VMEM_PAGE_SIZE;
+	mm->num_pages  = mm->mem_size/VMEM_PAGE_SIZE;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = mm->num_pages;
+	mm->alloc_page_count = 0;
+	mm->page_list  = (page_t *)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+	if (mm->page_list == NULL) {
+		printk(KERN_ERR "%s:%d failed to kmalloc(%d)\n", __func__, __LINE__, mm->num_pages*sizeof(page_t));
+		return -1;
+	}
+
+	for (i = 0; i < mm->num_pages; i++) {
+		mm->page_list[i].pageno	   = i;
+		mm->page_list[i].addr		 = mm->base_addr + i * VMEM_PAGE_SIZE;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].used		 = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	set_blocks_free(mm, 0, mm->num_pages);
+
+	return 0;
+}
+
+int vmem_exit(video_mm_t *mm)
+{
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_exit: invalid handle\n");
+		return -1;
+	}
+
+	if (mm->free_tree) {
+		avltree_free(mm->free_tree);
+	}
+	if (mm->alloc_tree) {
+		avltree_free(mm->alloc_tree);
+	}
+
+	if (mm->page_list) {
+		VMEM_P_FREE(mm->page_list);
+		mm->page_list = NULL;
+	}
+
+	mm->base_addr  = 0;
+	mm->mem_size   = 0;
+	mm->num_pages  = 0;
+	mm->page_list  = NULL;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = 0;
+	mm->alloc_page_count = 0;
+	return 0;
+}
+
+unsigned long vmem_alloc(video_mm_t *mm, int size, unsigned long pid)
+{
+	avl_node_t *node;
+	page_t *free_page;
+	int		 npages, free_size;
+	int		 alloc_pageno;
+	unsigned long  ptr;
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_alloc: invalid handle\n");
+		return -1;
+	}
+
+	if (size <= 0)
+		return -1;
+
+	npages = (size + VMEM_PAGE_SIZE - 1)/VMEM_PAGE_SIZE;
+
+	mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+	if (node == NULL) {
+		return -1;
+	}
+	free_page = node->page;
+	free_size = KEY_TO_VALUE(node->key);
+
+	alloc_pageno = free_page->pageno;
+	set_blocks_alloc(mm, alloc_pageno, npages);
+	if (npages != free_size) {
+		int free_pageno = alloc_pageno + npages;
+		set_blocks_free(mm, free_pageno, (free_size-npages));
+	}
+
+	VMEM_P_FREE(node);
+
+	ptr = mm->page_list[alloc_pageno].addr;
+	mm->alloc_page_count += npages;
+	mm->free_page_count  -= npages;
+
+
+	return ptr;
+}
+
+int vmem_free(video_mm_t *mm, unsigned long ptr, unsigned long pid)
+{
+	unsigned long addr;
+	avl_node_t *found;
+	page_t *page;
+	int pageno, prev_free_pageno, next_free_pageno;
+	int prev_size, next_size;
+	int merge_page_no, merge_page_size, free_page_size;
+
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_free: invalid handle\n");
+		return -1;
+	}
+
+	addr = ptr;
+
+	mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+	if (found == NULL) {
+		printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+		VMEM_ASSERT(0);
+		return -1;
+	}
+
+	/* find previous free block */
+	page = found->page;
+	pageno = page->pageno;
+	free_page_size = page->alloc_pages;
+	prev_free_pageno = pageno-1;
+	prev_size = -1;
+	if (prev_free_pageno >= 0) {
+		if (mm->page_list[prev_free_pageno].used == 0) {
+			prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+			prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+		}
+	}
+
+	/* find next free block */
+	next_free_pageno = pageno + page->alloc_pages;
+	next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+	next_size = -1;
+	if (next_free_pageno >= 0) {
+		if (mm->page_list[next_free_pageno].used == 0) {
+			next_size = mm->page_list[next_free_pageno].alloc_pages;
+		}
+	}
+	VMEM_P_FREE(found);
+
+	/* merge */
+	merge_page_no = page->pageno;
+	merge_page_size = page->alloc_pages;
+	if (prev_size >= 0) {
+		mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+		if (found == NULL) {
+			VMEM_ASSERT(0);
+			return -1;
+		}
+		merge_page_no = found->page->pageno;
+		merge_page_size += found->page->alloc_pages;
+		VMEM_P_FREE(found);
+	}
+	if (next_size >= 0) {
+		mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+		if (found == NULL) {
+			VMEM_ASSERT(0);
+			return -1;
+		}
+		merge_page_size += found->page->alloc_pages;
+		VMEM_P_FREE(found);
+	}
+
+	page->alloc_pages  = 0;
+	page->first_pageno = -1;
+
+	set_blocks_free(mm, merge_page_no, merge_page_size);
+
+	mm->alloc_page_count -= free_page_size;
+	mm->free_page_count  += free_page_size;
+
+	return 0;
+}
+
+int vmem_get_info(video_mm_t *mm, vmem_info_t *info)
+{
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_get_info: invalid handle\n");
+		return -1;
+	}
+
+	if (info == NULL) {
+		return -1;
+	}
+
+	info->total_pages = mm->num_pages;
+	info->alloc_pages = mm->alloc_page_count;
+	info->free_pages  = mm->free_page_count;
+	info->page_size   = VMEM_PAGE_SIZE;
+
+	return 0;
+}
+
+#endif /* __RTK_VIDEO_MEMORY_MANAGEMENT_H__ */
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve3/Makefile b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/Makefile
new file mode 100644
index 00000000..cb1fb5e
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/Makefile
@@ -0,0 +1,8 @@
+# rtk_vcodec
+
+obj-$(CONFIG_VE3_CODEC) += ve3.o
+obj-$(CONFIG_VE3_CODEC) += memalloc.o
+ifdef CONFIG_COMPAT
+obj-$(CONFIG_VE3_CODEC) += compat_ve3.o
+obj-$(CONFIG_VE3_CODEC) += compat_memalloc.o
+endif
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_memalloc.c b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_memalloc.c
new file mode 100644
index 00000000..9f4018b
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_memalloc.c
@@ -0,0 +1,70 @@
+/*
+ * drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_memalloc.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/compat.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#include "memalloc.h"
+#include "compat_memalloc.h"
+
+#define COMPAT_MEMALLOC_IOCSFREEBUFFER _IOW(MEMALLOC_IOC_MAGIC, 2, compat_ulong_t)
+
+long compat_memalloc_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+    long ret = 0;
+
+    if (!filp->f_op->unlocked_ioctl)
+        return -ENOTTY;
+
+    switch (cmd)
+    {
+    case MEMALLOC_IOCHARDRESET:
+    case MEMALLOC_IOCXGETBUFFER:
+    {
+        return filp->f_op->unlocked_ioctl(filp, cmd,
+                                          (unsigned long)compat_ptr(arg));
+    }
+
+    case COMPAT_MEMALLOC_IOCSFREEBUFFER:
+    {
+        compat_ulong_t __user *data32;
+        unsigned long __user *data;
+        compat_ulong_t n;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = get_user(n, data32);
+        err |= put_user(n, data);
+        if (err)
+            return err;
+
+        ret = filp->f_op->unlocked_ioctl(filp, MEMALLOC_IOCSFREEBUFFER, (unsigned long)data);
+        err = get_user(n, data);
+        err |= put_user(n, data32);
+        return ret ? ret : err;
+    }
+    default:
+    {
+        printk(KERN_ERR "[COMPAT_MEMALLOC] No such IOCTL, cmd is %d\n", cmd);
+        return -ENOIOCTLCMD;
+    }
+    }
+}
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_memalloc.h b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_memalloc.h
new file mode 100644
index 00000000..16f548b
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_memalloc.h
@@ -0,0 +1,30 @@
+/*
+
+ * drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_memalloc.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_COMPAT_MEMALLOC_H
+#define _LINUX_COMPAT_MEMALLOC_H
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+long compat_memalloc_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+
+#else
+
+#define compat_memalloc_ioctl  NULL
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_MEMALLOC_H */
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_ve3.c b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_ve3.c
new file mode 100644
index 00000000..795925f
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_ve3.c
@@ -0,0 +1,330 @@
+/*
+ * drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_ve3.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/compat.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#include "ve3.h"
+#include "compat_ve3.h"
+
+/* See drivers/soc/realtek/rtd129x/rtk_ve/ve3/ve3.h for the definition of these structs */
+struct compat_core_desc
+{
+    compat_uint_t id; /* id of the core */
+    compat_ulong_t regs; /* pointer to user registers */
+    compat_uint_t size; /* size of register space */
+};
+
+#define COMPAT_HANTRODEC_IOCGHWOFFSET _IOR(HANTRODEC_IOC_MAGIC, 3, compat_ulong_t)
+#define COMPAT_HANTRODEC_IOCGHWIOSIZE _IOR(HANTRODEC_IOC_MAGIC, 4, compat_uint_t)
+#define COMPAT_HANTRODEC_IOC_MC_OFFSETS _IOR(HANTRODEC_IOC_MAGIC, 7, compat_ulong_t)
+#define COMPAT_HANTRODEC_IOC_MC_CORES _IOR(HANTRODEC_IOC_MAGIC, 8, compat_uint_t)
+#define COMPAT_HANTRODEC_IOCS_DEC_PUSH_REG _IOW(HANTRODEC_IOC_MAGIC, 9, struct compat_core_desc)
+#define COMPAT_HANTRODEC_IOCX_DEC_WAIT _IOWR(HANTRODEC_IOC_MAGIC, 15, struct compat_core_desc)
+#define COMPAT_HANTRODEC_IOCS_DEC_PULL_REG _IOWR(HANTRODEC_IOC_MAGIC, 17, struct compat_core_desc)
+#define COMPAT_HANTRODEC_IOCG_CORE_WAIT _IOR(HANTRODEC_IOC_MAGIC, 19, compat_int_t)
+#define COMPAT_HANTRODEC_IOX_ASIC_ID _IOWR(HANTRODEC_IOC_MAGIC, 20, compat_uint_t)
+#define COMPAT_HANTRODEC_GET_ASIC_REG _IOWR(HANTRODEC_IOC_MAGIC, 24, struct compat_core_desc)
+#define COMPAT_HANTRODEC_BONDINGOFFSET      _IOR(HANTRODEC_IOC_MAGIC,  23, compat_ulong_t)
+#define COMPAT_HANTRODEC_BONDINGIOSIZE      _IOR(HANTRODEC_IOC_MAGIC,  22, compat_uint_t)
+
+static int compat_get_ve3_core_desc_data(
+    struct compat_core_desc __user *data32,
+    struct core_desc __user *data)
+{
+    compat_uint_t i;
+    compat_ulong_t r;
+    compat_uint_t s;
+    int err;
+
+    err = get_user(i, &data32->id);
+    err |= put_user(i, &data->id);
+    err = get_user(r, &data32->regs);
+    err |= put_user(r, &data->regs);
+    err |= get_user(s, &data32->size);
+    err |= put_user(s, &data->size);
+
+    return err;
+}
+
+static int compat_put_ve3_core_desc_data(
+    struct compat_core_desc __user *data32,
+    struct core_desc __user *data)
+{
+    compat_uint_t i;
+    compat_ulong_t r;
+    compat_uint_t s;
+    int err;
+
+    err = get_user(i, &data->id);
+    err |= put_user(i, &data32->id);
+    err = get_user(r, &data->regs);
+    err |= put_user(r, &data32->regs);
+    err |= get_user(s, &data->size);
+    err |= put_user(s, &data32->size);
+
+    return err;
+}
+
+long compat_hantrodec_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+    long ret = 0;
+
+    if (!filp->f_op->unlocked_ioctl)
+        return -ENOTTY;
+
+    switch (cmd)
+    {
+    case HANTRODEC_IOC_CLI:
+    case HANTRODEC_IOC_STI:
+    case HANTRODEC_IOCH_DEC_RESERVE:
+    case HANTRODEC_IOCT_DEC_RELEASE:
+    case HANTRODEC_DEBUG_STATUS:
+    case HANTRODEC_SET_CLOCK_ENABLE:
+    case HANTRODEC_RESET_CLK_GATING:
+    case HANTRODEC_NOTIFY_RELEASE:
+    case HANTRODEC_GET_ASIC_REVISION:
+    {
+        return filp->f_op->unlocked_ioctl(filp, cmd,
+                                          (unsigned long)compat_ptr(arg));
+    }
+
+    case COMPAT_HANTRODEC_IOCGHWOFFSET:
+    case COMPAT_HANTRODEC_BONDINGOFFSET:
+    {
+        compat_ulong_t __user *data32;
+        unsigned long __user *data;
+        compat_ulong_t n;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = get_user(n, data32);
+        err |= put_user(n, data);
+        if (err)
+            return err;
+
+        if (cmd == COMPAT_HANTRODEC_IOCGHWOFFSET)
+            ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_IOCGHWOFFSET, (unsigned long)data);
+        else
+            ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_BONDINGOFFSET, (unsigned long)data);
+        err = get_user(n, data);
+        err |= put_user(n, data32);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_HANTRODEC_IOCGHWIOSIZE:
+    case COMPAT_HANTRODEC_BONDINGIOSIZE:
+    {
+        compat_uint_t __user *data32;
+        unsigned int __user *data;
+        compat_uint_t n;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = get_user(n, data32);
+        err |= put_user(n, data);
+        if (err)
+            return err;
+
+        if (cmd == COMPAT_HANTRODEC_IOCGHWIOSIZE)
+            ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_IOCGHWIOSIZE, (unsigned long)data);
+        else
+            ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_BONDINGIOSIZE, (unsigned long)data);
+        err = get_user(n, data);
+        err |= put_user(n, data32);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_HANTRODEC_IOC_MC_OFFSETS:
+    {
+        compat_ulong_t __user *data32;
+        u64 __user data[HXDEC_MAX_CORES];
+        compat_ulong_t n[HXDEC_MAX_CORES];
+        int err;
+
+        data32 = compat_ptr(arg);
+
+        err = copy_from_user(n, data32, sizeof(n));
+        err |= copy_to_user(data, n, sizeof(data));
+        if (err)
+            return err;
+
+        ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_IOC_MC_OFFSETS, (unsigned long)data);
+        err = copy_from_user(n, data, sizeof(data));
+        err |= copy_to_user(n, data32, sizeof(n));
+        return ret ? ret : err;
+    }
+
+    case COMPAT_HANTRODEC_IOC_MC_CORES:
+    {
+        compat_uint_t __user *data32;
+        unsigned int __user *data;
+        compat_uint_t n;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = get_user(n, data32);
+        err |= put_user(n, data);
+        if (err)
+            return err;
+
+        ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_IOC_MC_CORES, (unsigned long)data);
+        err = get_user(n, data);
+        err |= put_user(n, data32);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_HANTRODEC_IOCS_DEC_PUSH_REG:
+    {
+        struct compat_core_desc __user *data32;
+        struct core_desc __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_ve3_core_desc_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_IOCS_DEC_PUSH_REG, (unsigned long)data);
+        err = compat_put_ve3_core_desc_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_HANTRODEC_IOCS_DEC_PULL_REG:
+    {
+        struct compat_core_desc __user *data32;
+        struct core_desc __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_ve3_core_desc_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_IOCS_DEC_PULL_REG, (unsigned long)data);
+        err = compat_put_ve3_core_desc_data(data32, data);
+        return ret ? ret : err;
+    }
+
+
+    case COMPAT_HANTRODEC_IOCX_DEC_WAIT:
+    {
+        struct compat_core_desc __user *data32;
+        struct core_desc __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_ve3_core_desc_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_IOCX_DEC_WAIT, (unsigned long)data);
+        err = compat_put_ve3_core_desc_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_HANTRODEC_IOCG_CORE_WAIT:
+    {
+        compat_uint_t __user *data32;
+        unsigned int __user *data;
+        compat_uint_t n;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = get_user(n, data32);
+        err |= put_user(n, data);
+        if (err)
+            return err;
+
+        ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_IOCG_CORE_WAIT, (unsigned long)data);
+        err = get_user(n, data);
+        err |= put_user(n, data32);
+        return ret ? ret : err;
+    }
+    case COMPAT_HANTRODEC_IOX_ASIC_ID:
+    {
+        compat_uint_t __user *data32;
+        unsigned int __user *data;
+        compat_uint_t n;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = get_user(n, data32);
+        err |= put_user(n, data);
+        if (err)
+            return err;
+
+        ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_IOX_ASIC_ID, (unsigned long)data);
+        err = get_user(n, data);
+        err |= put_user(n, data32);
+        return ret ? ret : err;
+    }
+    case COMPAT_HANTRODEC_GET_ASIC_REG:
+    {
+        struct compat_core_desc __user *data32;
+        struct core_desc __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_ve3_core_desc_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, HANTRODEC_GET_ASIC_REG, (unsigned long)data);
+        err = compat_put_ve3_core_desc_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    default:
+    {
+        printk(KERN_ERR "[COMPAT_VE3] No such IOCTL, cmd is 0x%x[0x%x, 0x%x]\n", cmd, COMPAT_HANTRODEC_BONDINGOFFSET, COMPAT_HANTRODEC_BONDINGIOSIZE);
+        return -ENOIOCTLCMD;
+    }
+    }
+}
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_ve3.h b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_ve3.h
new file mode 100644
index 00000000..8404288
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_ve3.h
@@ -0,0 +1,30 @@
+/*
+
+ * drivers/soc/realtek/rtd129x/rtk_ve/ve3/compat_ve3.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_COMPAT_VE3_H
+#define _LINUX_COMPAT_VE3_H
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+long compat_hantrodec_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+
+#else
+
+#define compat_hantrodec_ioctl  NULL
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_VE3_H */
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve3/dwl_defs.h b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/dwl_defs.h
new file mode 100644
index 00000000..fd74ff8
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/dwl_defs.h
@@ -0,0 +1,52 @@
+/* Copyright 2013 Google Inc. All Rights Reserved. */
+/* Author: attilanagy@google.com (Atti Nagy) */
+
+#ifndef SOFTWARE_LINUX_DWL_DWL_DEFS_H_
+#define SOFTWARE_LINUX_DWL_DWL_DEFS_H_
+
+#define DWL_MPEG2_E 31 /* 1 bit */
+#define DWL_VC1_E 29   /* 2 bits */
+#define DWL_JPEG_E 28  /* 1 bit */
+#define DWL_MPEG4_E 26 /* 2 bits */
+#define DWL_H264_E 24  /* 2 bits */
+#define DWL_VP6_E 23   /* 1 bit */
+#define DWL_RV_E 26    /* 2 bits */
+#define DWL_VP8_E 23   /* 1 bit */
+#define DWL_VP7_E 24   /* 1 bit */
+#define DWL_WEBP_E 19  /* 1 bit */
+#define DWL_AVS_E 22   /* 1 bit */
+#define DWL_PP_E 31    /* 1 bit */
+#define DWL_HEVC_E 5   /* 2 bits */
+#define DWL_VP9_E 3    /* 2 bits */
+
+#define DWL_HEVC_ENA 0  /* 1 bits */
+#define DWL_VP9_ENA 1   /* 1 bits */
+#define DWL_RFC_E 2     /* 1 bits */
+#define DWL_DS_E 3      /* 1 bits */
+#define DWL_HEVC_VER 8  /* 4 bits */
+#define DWL_VP9_PROFILE 12 /* 3 bits */
+#define DWL_RING_E 16   /* 1 bits */
+
+#define HANTRODEC_IRQ_STAT_DEC 1
+#define HANTRODEC_IRQ_STAT_DEC_OFF (HANTRODEC_IRQ_STAT_DEC * 4)
+
+#define HANTRODECPP_SYNTH_CFG 60
+#define HANTRODECPP_SYNTH_CFG_OFF (HANTRODECPP_SYNTH_CFG * 4)
+#define HANTRODEC_SYNTH_CFG 50
+#define HANTRODEC_SYNTH_CFG_OFF (HANTRODEC_SYNTH_CFG * 4)
+#define HANTRODEC_SYNTH_CFG_2 54
+#define HANTRODEC_SYNTH_CFG_2_OFF (HANTRODEC_SYNTH_CFG_2 * 4)
+#define HANTRODEC_SYNTH_CFG_3 56
+#define HANTRODEC_SYNTH_CFG_3_OFF (HANTRODEC_SYNTH_CFG_3 * 4)
+#define HANTRODEC_CFG_STAT 23
+#define HANTRODEC_CFG_STAT_OFF (HANTRODEC_CFG_STAT * 4)
+
+
+#define HANTRODEC_DEC_E 0x01
+#define HANTRODEC_PP_E 0x01
+#define HANTRODEC_DEC_ABORT 0x20
+#define HANTRODEC_DEC_IRQ_DISABLE 0x10
+#define HANTRODEC_DEC_IRQ 0x100
+
+
+#endif /* SOFTWARE_LINUX_DWL_DWL_DEFS_H_ */
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve3/memalloc.c b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/memalloc.c
new file mode 100644
index 00000000..24da344
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/memalloc.c
@@ -0,0 +1,482 @@
+/* Copyright 2012 Google Inc. All Rights Reserved. */
+
+#include <asm/io.h>
+#include <asm/uaccess.h>
+#include <linux/errno.h>
+#include <linux/fs.h>
+#include <linux/init.h>
+#include <linux/ioport.h>
+#include <linux/kernel.h>
+#include <linux/list.h>
+#include <linux/mm.h>
+#include <linux/module.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/vmalloc.h>
+
+#include <linux/platform_device.h>
+#include <linux/miscdevice.h>
+#include <linux/dma-mapping.h>
+#include <linux/mm.h>
+
+#include "memalloc.h"
+#include "compat_memalloc.h"
+#include "../puwrap.h"
+
+#ifndef CONFIG_RTK_RESERVE_MEMORY
+//#define SUPPORT_RESERVED_VIDEO_MEMORY
+#endif
+
+#ifndef HLINA_START_ADDRESS
+#define HLINA_START_ADDRESS 0x02000000
+#endif
+
+#ifndef HLINA_SIZE
+#define HLINA_SIZE 96
+#endif
+
+#ifndef HLINA_TRANSL_OFFSET
+#define HLINA_TRANSL_OFFSET 0x0
+#endif
+
+/* the size of chunk in MEMALLOC_DYNAMIC */
+#define CHUNK_SIZE (PAGE_SIZE * 4)
+
+/* memory size in MBs for MEMALLOC_DYNAMIC */
+unsigned long alloc_size = HLINA_SIZE;
+unsigned long alloc_base = HLINA_START_ADDRESS;
+
+/* user space SW will substract HLINA_TRANSL_OFFSET from the bus address
+ * and decoder HW will use the result as the address translated base
+ * address. The SW needs the original host memory bus address for memory
+ * mapping to virtual address. */
+unsigned long addr_transl = HLINA_TRANSL_OFFSET;
+
+static struct miscdevice s_memalloc_dev;
+
+#ifndef VM_RESERVED	/*for kernel up to 3.7.0 version*/
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+/* module_param(name, type, perm) */
+module_param(alloc_size, ulong, 0);
+module_param(alloc_base, ulong, 0);
+module_param(addr_transl, ulong, 0);
+
+static spinlock_t s_mem_lock = __SPIN_LOCK_UNLOCKED(s_mem_lock);
+
+typedef struct hlinc {
+    u64 bus_address;
+    u32 chunks_reserved;
+    const struct file *filp; /* Client that allocated this chunk */
+} hlina_chunk;
+
+typedef struct rtk_hlinc {
+    unsigned long phys_addr;
+    unsigned long base;
+    u32 size;
+    const struct file *filp; /* Client that allocated this chunk */
+} rtk_hlina_chunk;
+
+#define RTK_CHUNKS 1024
+
+#ifdef SUPPORT_RESERVED_VIDEO_MEMORY
+static hlina_chunk *hlina_chunks = NULL;
+#endif
+static rtk_hlina_chunk *rtk_hlina_chunks = NULL;
+static size_t chunks = 0;
+
+static int AllocMemory(unsigned *busaddr, unsigned long size, unsigned int mem_type,
+                       const struct file *filp);
+static int FreeMemory(unsigned long busaddr, const struct file *filp);
+static void ResetMems(void);
+
+static long memalloc_ioctl(struct file *filp, unsigned int cmd,
+                           unsigned long arg) {
+    int ret = 0;
+    MemallocParams memparams;
+    unsigned long busaddr;
+
+    PDEBUG("ioctl cmd 0x%08x\n", cmd);
+
+    /*
+     * extract the type and number bitfields, and don't decode
+     * wrong cmds: return ENOTTY (inappropriate ioctl) before access_ok()
+     */
+    if (_IOC_TYPE(cmd) != MEMALLOC_IOC_MAGIC) return -ENOTTY;
+    if (_IOC_NR(cmd) > MEMALLOC_IOC_MAXNR) return -ENOTTY;
+
+    if (_IOC_DIR(cmd) & _IOC_READ)
+        ret = !access_ok(VERIFY_WRITE, arg, _IOC_SIZE(cmd));
+    else if (_IOC_DIR(cmd) & _IOC_WRITE)
+        ret = !access_ok(VERIFY_READ, arg, _IOC_SIZE(cmd));
+    if (ret) return -EFAULT;
+
+    switch (cmd) {
+    case MEMALLOC_IOCHARDRESET:
+        PDEBUG("HARDRESET\n");
+        ResetMems();
+        break;
+    case MEMALLOC_IOCXGETBUFFER:
+        PDEBUG("GETBUFFER");
+
+        ret = copy_from_user(&memparams, (MemallocParams *)arg,
+                             sizeof(MemallocParams));
+        if (ret) break;
+
+        ret = AllocMemory(&memparams.bus_address, memparams.size, memparams.mem_type, filp);
+
+        memparams.translation_offset = addr_transl;
+
+        ret |= copy_to_user((MemallocParams *)arg, &memparams,
+                            sizeof(MemallocParams));
+
+        break;
+    case MEMALLOC_IOCSFREEBUFFER:
+        PDEBUG("FREEBUFFER\n");
+
+        __get_user(busaddr, (unsigned long *)arg);
+        ret = FreeMemory(busaddr, filp);
+        break;
+    }
+
+
+    return ret ? -EFAULT : 0;
+}
+
+static int memalloc_open(struct inode *inode, struct file *filp) {
+
+    PDEBUG("dev opened\n");
+    return 0;
+}
+
+static int memalloc_release(struct inode *inode, struct file *filp) {
+    int i = 0;
+
+#ifdef SUPPORT_RESERVED_VIDEO_MEMORY
+    for (i = 0; i < chunks; i++) {
+        spin_lock(&s_mem_lock);
+        if (hlina_chunks[i].filp == filp) {
+            printk(KERN_WARNING "memalloc: Found unfreed memory at release time!\n");
+
+            hlina_chunks[i].filp = NULL;
+            hlina_chunks[i].chunks_reserved = 0;
+        }
+        spin_unlock(&s_mem_lock);
+    }
+#else /* else of SUPPORT_RESERVED_VIDEO_MEMORY */
+    unsigned long phys_addr = 0;
+    unsigned long base = 0;
+    u32 size = 0;
+    for (i = 0; i < chunks; i++)
+    {
+        spin_lock(&s_mem_lock);
+        phys_addr = 0;
+        base = 0;
+        size = 0;
+        if (rtk_hlina_chunks[i].filp == filp)
+        {
+            printk(KERN_WARNING "memalloc: Found unfreed memory at release time!\n");
+            phys_addr = rtk_hlina_chunks[i].phys_addr;
+            base = rtk_hlina_chunks[i].base;
+            size = rtk_hlina_chunks[i].size;
+            rtk_hlina_chunks[i].filp = NULL;
+        }
+        spin_unlock(&s_mem_lock);
+
+        if (phys_addr != 0 && base!= 0 && size != 0)
+        {
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+            pu_free_dma_buffer(base, phys_addr);
+#else
+            if (base)
+                dma_free_coherent(s_memalloc_dev.this_device, PAGE_ALIGN(size), (void *)base, phys_addr);
+#endif
+        }
+    }
+#endif /* end of SUPPORT_RESERVED_VIDEO_MEMORY */
+
+    PDEBUG("dev closed\n");
+    return 0;
+}
+
+void __exit memalloc_cleanup(void) {
+#ifdef SUPPORT_RESERVED_VIDEO_MEMORY
+    if (hlina_chunks != NULL) vfree(hlina_chunks);
+#else
+    if (rtk_hlina_chunks != NULL) vfree(rtk_hlina_chunks);
+#endif
+
+#if 0
+    unregister_chrdev(memalloc_major, "memalloc");
+#else
+    misc_deregister(&s_memalloc_dev);
+#endif
+
+    PDEBUG("module removed\n");
+    return;
+}
+
+static int memalloc_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+    return pu_mmap_dma_buffer(vm);
+#else
+    vm->vm_flags |= VM_IO | VM_RESERVED;
+    vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+    return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif
+}
+
+/* VFS methods */
+static struct file_operations memalloc_fops = {
+    .owner = THIS_MODULE,
+    .open = memalloc_open,
+    .release = memalloc_release,
+    .unlocked_ioctl = memalloc_ioctl,
+    .compat_ioctl = compat_memalloc_ioctl,
+    .mmap = memalloc_mmap
+};
+
+int __init memalloc_init(void) {
+    int result;
+
+    PDEBUG("module init\n");
+    printk("memalloc: Linear Memory Allocator\n");
+
+#ifdef SUPPORT_RESERVED_VIDEO_MEMORY
+    printk("memalloc: Linear memory base = 0x%08x\n", alloc_base);
+
+    chunks = (alloc_size * 1024 * 1024) / CHUNK_SIZE;
+
+    printk(KERN_INFO
+           "memalloc: Total size %d MB; %d chunks"
+           " of size %lu\n",
+           alloc_size, chunks, CHUNK_SIZE);
+
+    hlina_chunks = (hlina_chunk *)vmalloc(chunks * sizeof(hlina_chunk));
+    if (hlina_chunks == NULL) {
+        printk(KERN_ERR "memalloc: cannot allocate hlina_chunks\n");
+        result = -ENOMEM;
+        goto err;
+    }
+#else /* else of SUPPORT_RESERVED_VIDEO_MEMORY */
+    chunks = RTK_CHUNKS;
+    rtk_hlina_chunks = (rtk_hlina_chunk *)vmalloc(chunks * sizeof(rtk_hlina_chunk));
+    if (rtk_hlina_chunks == NULL) {
+        printk(KERN_ERR "memalloc: cannot allocate rtk_hlina_chunks\n");
+        result = -ENOMEM;
+        goto err;
+    }
+#endif /* end of SUPPORT_RESERVED_VIDEO_MEMORY */
+
+#if 0
+    result = register_chrdev(memalloc_major, "memalloc", &memalloc_fops);
+    if (result < 0) {
+        PDEBUG("memalloc: unable to get major %d\n", memalloc_major);
+        goto err;
+    } else if (result != 0) {/* this is for dynamic major */
+        memalloc_major = result;
+    }
+#else
+    s_memalloc_dev.minor = MISC_MEM_MINOR;
+    s_memalloc_dev.name = "memalloc";
+    s_memalloc_dev.fops = &memalloc_fops;
+    s_memalloc_dev.parent = NULL;
+    if (misc_register(&s_memalloc_dev)) {
+        printk("memalloc: failed to register misc device.");
+        goto err;
+    }
+#endif
+
+    ResetMems();
+
+    return 0;
+
+err:
+#ifdef SUPPORT_RESERVED_VIDEO_MEMORY
+    if (hlina_chunks != NULL) vfree(hlina_chunks);
+#else
+    if (rtk_hlina_chunks != NULL) vfree(rtk_hlina_chunks);
+#endif
+
+    return result;
+}
+
+/* Cycle through the buffers we have, give the first free one */
+static int AllocMemory(unsigned *busaddr, unsigned long size, unsigned int mem_type,
+                       const struct file *filp) {
+
+    int i = 0;
+
+    *busaddr = 0;
+
+    /* run through the chunk table */
+#ifdef SUPPORT_RESERVED_VIDEO_MEMORY
+    /* calculate how many chunks we need; round up to chunk boundary */
+    unsigned int alloc_chunks = (size + CHUNK_SIZE - 1) / CHUNK_SIZE;
+
+    spin_lock(&s_mem_lock);
+    for (i = 0; i < chunks;) {
+        int j = 0;
+        unsigned int skip_chunks = 0;
+        skip_chunks = 0;
+        /* if this chunk is available */
+        if (!hlina_chunks[i].chunks_reserved) {
+            /* check that there is enough memory left */
+            if (i + alloc_chunks > chunks) break;
+
+            /* check that there is enough consecutive chunks available */
+            for (j = i; j < i + alloc_chunks; j++) {
+                if (hlina_chunks[j].chunks_reserved) {
+                    skip_chunks = 1;
+                    /* skip the used chunks */
+                    i = j + hlina_chunks[j].chunks_reserved;
+                    break;
+                }
+            }
+
+            /* if enough free memory found */
+            if (!skip_chunks) {
+                *busaddr = hlina_chunks[i].bus_address;
+                hlina_chunks[i].filp = filp;
+                hlina_chunks[i].chunks_reserved = alloc_chunks;
+                break;
+            }
+        } else {
+            /* skip the used chunks */
+            i += hlina_chunks[i].chunks_reserved;
+        }
+    }
+    spin_unlock(&s_mem_lock);
+#else /* else of SUPPORT_RESERVED_VIDEO_MEMORY */
+    unsigned long phys_addr;
+    unsigned long base;
+    unsigned long nSize = size;
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+    unsigned int ret = pu_alloc_dma_buffer(nSize, &phys_addr, &base, mem_type);
+    if(ret == -1)
+    {
+        printk(KERN_ERR "memalloc: Physical memory allocation error size=%d\n", nSize);
+        return -EFAULT;
+    }
+#else /* else of CONFIG_RTK_RESERVE_MEMORY */
+    base = (unsigned long)dma_alloc_coherent(s_memalloc_dev.this_device, PAGE_ALIGN(nSize), (dma_addr_t *) (&phys_addr), GFP_DMA | GFP_KERNEL);
+    if ((void *)(base) == NULL)	{
+        printk(KERN_ERR "memalloc: Physical memory allocation error size=%d\n", (int)nSize);
+        return -EFAULT;
+    }
+#endif /* end of CONFIG_RTK_RESERVE_MEMORY */
+    spin_lock(&s_mem_lock);
+    for (i = 0; i < chunks; i++)
+    {
+        if (!rtk_hlina_chunks[i].filp)
+        {
+            rtk_hlina_chunks[i].size = size;
+            rtk_hlina_chunks[i].base = base;
+            rtk_hlina_chunks[i].phys_addr = phys_addr;
+            rtk_hlina_chunks[i].filp = filp;
+            *busaddr = rtk_hlina_chunks[i].phys_addr;
+            PDEBUG("memalloc: base:0x%lx, phy_addr:0x%lx, size:%d\n", rtk_hlina_chunks[i].base, rtk_hlina_chunks[i].phys_addr, rtk_hlina_chunks[i].size);
+            break;
+        }
+    }
+    spin_unlock(&s_mem_lock);
+#endif /* end of SUPPORT_RESERVED_VIDEO_MEMORY */
+
+    if (*busaddr == 0) {
+        printk("memalloc: Allocation FAILED: size = %d\n", (int)size);
+        return -EFAULT;
+    } else {
+        PDEBUG("MEMALLOC OK: size: %d, reserved: %ld\n", (int)size,
+               alloc_chunks * CHUNK_SIZE);
+    }
+
+    return 0;
+}
+
+/* Free a buffer based on bus address */
+static int FreeMemory(unsigned long busaddr, const struct file *filp) {
+    int i = 0;
+
+#ifdef SUPPORT_RESERVED_VIDEO_MEMORY
+    spin_lock(&s_mem_lock);
+    for (i = 0; i < chunks; i++) {
+        /* user space SW has stored the translated bus address, add addr_transl to
+         * translate back to our address space */
+        if (hlina_chunks[i].bus_address == busaddr + addr_transl) {
+            if (hlina_chunks[i].filp == filp) {
+                hlina_chunks[i].filp = NULL;
+                hlina_chunks[i].chunks_reserved = 0;
+            } else {
+                printk(KERN_WARNING "memalloc: Owner mismatch while freeing memory!\n");
+            }
+            break;
+        }
+    }
+    spin_unlock(&s_mem_lock);
+#else /* else of SUPPORT_RESERVED_VIDEO_MEMORY */
+    unsigned long phys_addr = 0;
+    unsigned long base = 0;
+    unsigned long size = 0;
+    spin_lock(&s_mem_lock);
+    for (i = 0; i < chunks; i++)
+    {
+        if (rtk_hlina_chunks[i].phys_addr == busaddr)
+        {
+            if (rtk_hlina_chunks[i].filp == filp)
+            {
+                phys_addr = rtk_hlina_chunks[i].phys_addr;
+                base = rtk_hlina_chunks[i].base;
+                size = rtk_hlina_chunks[i].size;
+                rtk_hlina_chunks[i].filp = NULL;
+            }
+            else
+            {
+                printk(KERN_WARNING "memalloc: Owner mismatch while freeing memory (0x%x)!\n", (int)busaddr);
+            }
+            break;
+        }
+    }
+    spin_unlock(&s_mem_lock);
+    if (phys_addr != 0 && base!= 0 && size != 0)
+    {
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+        pu_free_dma_buffer(base, phys_addr);
+#else
+        if (base)
+            dma_free_coherent(s_memalloc_dev.this_device, PAGE_ALIGN(size), (void *)base, phys_addr);
+#endif
+    }
+#endif /* end of SUPPORT_RESERVED_VIDEO_MEMORY */
+    return 0;
+}
+
+/* Reset "used" status */
+static void ResetMems(void) {
+    spin_lock(&s_mem_lock);
+#ifdef SUPPORT_RESERVED_VIDEO_MEMORY
+    int i = 0;
+    unsigned long ba = alloc_base;
+
+    for (i = 0; i < chunks; i++) {
+        hlina_chunks[i].bus_address = ba;
+        hlina_chunks[i].filp = NULL;
+        hlina_chunks[i].chunks_reserved = 0;
+
+        ba += CHUNK_SIZE;
+    }
+#else /* else of SUPPORT_RESERVED_VIDEO_MEMORY */
+    memset(rtk_hlina_chunks, 0, (chunks * sizeof(rtk_hlina_chunk)));
+#endif /* end of SUPPORT_RESERVED_VIDEO_MEMORY */
+    spin_unlock(&s_mem_lock);
+}
+
+module_init(memalloc_init);
+module_exit(memalloc_cleanup);
+
+/* module description */
+MODULE_LICENSE("Proprietary");
+MODULE_AUTHOR("Google Finland Oy");
+MODULE_DESCRIPTION("Linear RAM allocation");
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve3/memalloc.h b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/memalloc.h
new file mode 100644
index 00000000..2b49075
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/memalloc.h
@@ -0,0 +1,35 @@
+/* Copyright 2012 Google Inc. All Rights Reserved. */
+
+#ifndef MEMALLOC_H
+#define MEMALLOC_H
+
+#include <linux/ioctl.h>
+
+#undef PDEBUG
+//#define MEMALLOC_DEBUG
+#ifdef MEMALLOC_DEBUG
+#ifdef __KERNEL__
+#define PDEBUG(fmt, args...) printk(KERN_INFO "memalloc: " fmt, ##args)
+#else
+#define PDEBUG(fmt, args...) fprintf(stderr, fmt, ##args)
+#endif
+#else
+#define PDEBUG(fmt, args...)
+#endif
+
+typedef struct {
+    unsigned bus_address;
+    unsigned size;
+    unsigned translation_offset;
+    unsigned mem_type;
+} MemallocParams;
+
+#define MEMALLOC_IOC_MAGIC 'k'
+
+#define MEMALLOC_IOCXGETBUFFER _IOWR(MEMALLOC_IOC_MAGIC, 1, MemallocParams)
+#define MEMALLOC_IOCSFREEBUFFER _IOW(MEMALLOC_IOC_MAGIC, 2, unsigned long)
+
+#define MEMALLOC_IOCHARDRESET _IO(MEMALLOC_IOC_MAGIC, 15) /* debugging tool */
+#define MEMALLOC_IOC_MAXNR 15
+
+#endif /* MEMALLOC_H */
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve3/ve3.c b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/ve3.c
new file mode 100755
index 00000000..7580d08
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/ve3.c
@@ -0,0 +1,1416 @@
+/* Copyright 2013 Google Inc. All Rights Reserved. */
+#include <linux/io.h>
+#include <linux/uaccess.h>
+#include <linux/errno.h>
+#include <linux/fs.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/pci.h>
+#include <linux/sched.h>
+#include <linux/semaphore.h>
+#include <linux/spinlock.h>
+#include <linux/slab.h>
+#include <linux/version.h>
+#include <linux/wait.h>
+#include <linux/delay.h>
+#include <linux/platform_device.h>
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+
+#include <soc/realtek/rtk_cpu.h>
+
+#ifdef CONFIG_POWER_CONTROL
+#include <soc/realtek/power-control.h>
+#endif
+
+#include "ve3.h"
+#include "compat_ve3.h"
+#include "dwl_defs.h"
+#include "../puwrap.h"
+
+#define HANTRO_DEC_REGS 265
+
+#define DEV_NAME "[RTK_VE3]"
+#define HANTRO_DEC_FIRST_REG 0
+#define HANTRO_DEC_LAST_REG	 HANTRO_DEC_REGS-1
+#define HANTRO_DEV_NAME "ve3"
+
+/* Logic module IRQs */
+#define HXDEC_NO_IRQ -1
+/* module defaults */
+#define DEC_IO_SIZE (HANTRO_DEC_REGS * 4) /* bytes, PP regs included
+within dec regs. */
+#define DEC_IRQ HXDEC_NO_IRQ
+
+static const int DecHwId[] = {0x6732};
+
+unsigned long base_port = -1;
+volatile u8 *base_address = NULL;
+
+unsigned long s_pll_phy_register = 0;
+unsigned long s_pll_virt_register = 0;
+unsigned long s_pll_size_register = 0;
+unsigned long s_bonding_phy_register = 0;
+unsigned long s_bonding_size_register = 0;
+
+unsigned long multicorebase[HXDEC_MAX_CORES] = {-1};
+
+int ve3_irq = DEC_IRQ;
+int elements = 0;
+
+#ifndef VM_RESERVED	/*for kernel up to 3.7.0 version*/
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+/* module_param(name, type, perm) */
+module_param(base_port, ulong, 0);
+module_param(ve3_irq, int, 0);
+module_param_array(multicorebase, ulong, &elements, 0);
+
+static int hantrodec_major = 0; /* dynamic allocation */
+static struct miscdevice s_ve3_dev;
+
+/* here's all the must remember stuff */
+typedef struct{
+	char *buffer;
+	unsigned int iosize;
+	volatile u8 *hwregs[HXDEC_MAX_CORES];
+	int irq;
+	int cores;
+	struct fasync_struct *async_queue_dec;
+	struct fasync_struct *async_queue_pp;
+} hantrodec_t;
+
+static hantrodec_t hantrodec_data; /* dynamic allocation? */
+static unsigned int inst_cnt = 0;
+static int ReserveIO(void);
+static void ReleaseIO(void);
+
+static void ResetAsic(hantrodec_t * dev);
+
+#ifdef HANTRODEC_DEBUG
+static void dump_regs(hantrodec_t *dev);
+#endif
+
+/* IRQ handler */
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18))
+static irqreturn_t hantrodec_isr(int irq, void *dev_id, struct pt_regs *regs);
+#else
+static irqreturn_t hantrodec_isr(int irq, void *dev_id);
+#endif
+
+static u32 dec_regs[HXDEC_MAX_CORES][DEC_IO_SIZE/4];
+static u32 asic_dec_regs[HXDEC_MAX_CORES][DEC_IO_SIZE/4];
+struct semaphore dec_core_sem;
+
+static int dec_irq = 0;
+static int dec_release = 0;
+
+static atomic_t irq_rx = ATOMIC_INIT(0);
+static atomic_t irq_tx = ATOMIC_INIT(0);
+
+static struct file* dec_owner[HXDEC_MAX_CORES];
+
+static spinlock_t owner_lock = __SPIN_LOCK_UNLOCKED(owner_lock);
+
+DECLARE_WAIT_QUEUE_HEAD(dec_wait_queue);
+
+DECLARE_WAIT_QUEUE_HEAD(hw_queue);
+
+#define DWL_CLIENT_TYPE_PP 4U
+#define DWL_CLIENT_TYPE_VP9_DEC 11U
+#define DWL_CLIENT_TYPE_HEVC_DEC 12U
+
+static u32 cfg[HXDEC_MAX_CORES];
+
+static struct clk *s_ve3_clk;
+static struct reset_control *rstc_ve3 = NULL;
+#ifdef CONFIG_POWER_CONTROL
+static struct power_control *s_pctrl_ve3;
+#endif
+
+static void ve3_clk_disable(struct clk *clk);
+static int ve3_clk_enable(struct clk *clk);
+static struct clk *ve3_clk_get(struct device *dev);
+static void ve3_clk_put(struct clk *clk);
+#ifdef CONFIG_POWER_CONTROL
+static void ve3_pctrl_off(struct power_control *pctrl);
+static void ve3_pctrl_on(struct power_control *pctrl);
+static struct power_control *ve3_pctrl_get(void);
+#endif
+
+static void ve3_wrapper_setup(volatile u8 * base)
+{
+	unsigned int ctrl_1 = __raw_readl(base+0x3F00);
+	unsigned int ctrl_2 = __raw_readl(base+0x3F04);
+	if (get_rtd129x_cpu_revision() >= RTD129x_CHIP_REVISION_B00)
+		ctrl_1 = (ctrl_1 & ~0x7) | 0x3; /* ve3_ack_div_sel 'b011 = 8 */
+	else
+		ctrl_1 = (ctrl_1 & ~0x7) | 0x2; /* ve3_ack_div_sel 'b010 = 16 //HW has bug, we must use this value */
+	ctrl_1 |= 0x10; /* ve3_axi2cti_en */
+	ctrl_2 = (ctrl_2 & ~0x3f) | 0x1a; /* ve3_cti_cmd_depth for 1296 timing issue */
+	__raw_writel(ctrl_1, (base+0x3F00));
+	__raw_writel(ctrl_2, (base+0x3F04));
+}
+
+static void ve3_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable)
+{
+	if (s_pll_phy_register == 0 || s_pll_virt_register == 0 || s_pll_size_register == 0) {
+		pr_warn("%s In[%s][%d] didn't get pll register\n", DEV_NAME, __FUNCTION__, __LINE__);
+		return;
+	} else if (offset > s_pll_size_register) {
+		pr_warn("%s In[%s][%d] offset over than register size\n", DEV_NAME, __FUNCTION__, __LINE__);
+		return;
+	}
+
+	if (bOverwrite == 1) {
+		__raw_writel(value, (volatile u8 *)(s_pll_virt_register+offset));
+	} else {
+		if (bEnable)
+			__raw_writel(__raw_readl((volatile u8 *)(s_pll_virt_register+offset)) | value, (volatile u8 *)(s_pll_virt_register+offset));
+		else
+			__raw_writel(__raw_readl((volatile u8 *)(s_pll_virt_register+offset)) & value, (volatile u8 *)(s_pll_virt_register+offset));
+	}
+}
+
+static void ReadCoreConfig(hantrodec_t *dev)
+{
+	int i, c;
+	u32 reg, tmp;
+
+	memset(cfg, 0, sizeof(cfg));
+
+	for(c = 0; c < dev->cores; c++) {
+		/* Decoder configuration */
+		reg = ioread32(dev->hwregs[c] + HANTRODEC_SYNTH_CFG_2 * 4);
+
+		tmp = (reg >> DWL_HEVC_E) & 0x3U;
+		if(tmp)
+			pr_info("%s core[%d] has HEVC\n", DEV_NAME, c);
+		cfg[c] |= tmp ? 1 << DWL_CLIENT_TYPE_HEVC_DEC : 0;
+
+		tmp = (reg >> DWL_VP9_E) & 0x03U;
+		if(tmp)
+			pr_info("%s core[%d] has VP9\n", DEV_NAME, c);
+		cfg[c] |= tmp ? 1 << DWL_CLIENT_TYPE_VP9_DEC : 0;
+
+		/* Post-processor configuration */
+		reg = ioread32(dev->hwregs[c] + HANTRODECPP_SYNTH_CFG * 4);
+
+		tmp = (reg >> DWL_PP_E) & 0x01U;
+		if(tmp)
+			pr_info("%s core[%d] has PP\n", DEV_NAME, c);
+		cfg[c] |= tmp ? 1 << DWL_CLIENT_TYPE_PP : 0;
+
+		for(i = 0; i <= HANTRO_DEC_LAST_REG; i++)
+			asic_dec_regs[c][i] = ioread32(dev->hwregs[c] + i*4);
+	}
+}
+
+static int CoreHasFormat(const u32 *cfg, int core, u32 format)
+{
+	return (cfg[core] & (1 << format)) ? 1 : 0;
+}
+
+int GetDecCore(long core, hantrodec_t *dev, struct file* filp)
+{
+	int success = 0;
+	unsigned long flags;
+
+	spin_lock_irqsave(&owner_lock, flags);
+	if(dec_owner[core] == NULL ) {
+		dec_owner[core] = filp;
+		success = 1;
+	}
+
+	spin_unlock_irqrestore(&owner_lock, flags);
+
+	return success;
+}
+
+int GetDecCoreAny(long *core, hantrodec_t *dev, struct file* filp,
+				  unsigned long format)
+{
+	int success = 0;
+	long c;
+
+	*core = -1;
+
+	for(c = 0; c < dev->cores; c++) {
+		/* a free core that has format */
+		if(CoreHasFormat(cfg, c, format) && GetDecCore(c, dev, filp)) {
+			success = 1;
+			*core = c;
+			break;
+		}
+	}
+
+	return success;
+}
+
+long ReserveDecoder(hantrodec_t *dev, struct file* filp, unsigned long format)
+{
+	long core = -1;
+
+	/* reserve a core */
+	if (down_interruptible(&dec_core_sem))
+		return -ERESTARTSYS;
+
+	/* lock a core that has specific format*/
+	if(wait_event_interruptible(hw_queue,
+								GetDecCoreAny(&core, dev, filp, format) != 0 ))
+		return -ERESTARTSYS;
+
+	return core;
+}
+
+void ReleaseDecoder(hantrodec_t *dev, long core)
+{
+	u32 status;
+	unsigned long flags;
+
+	status = ioread32(dev->hwregs[core] + HANTRODEC_IRQ_STAT_DEC_OFF);
+
+	/* make sure HW is disabled */
+	if(status & HANTRODEC_DEC_E)
+	{
+		pr_info("%s DEC[%li] still enabled -> reset\n", DEV_NAME, core);
+
+		/* abort decoder */
+		status |= HANTRODEC_DEC_ABORT | HANTRODEC_DEC_IRQ_DISABLE;
+		iowrite32(status, dev->hwregs[core] + HANTRODEC_IRQ_STAT_DEC_OFF);
+	}
+
+	spin_lock_irqsave(&owner_lock, flags);
+
+	dec_owner[core] = NULL;
+
+	spin_unlock_irqrestore(&owner_lock, flags);
+
+	up(&dec_core_sem);
+
+	wake_up_interruptible_all(&hw_queue);
+}
+
+long DecFlushRegs(hantrodec_t *dev, struct core_desc *core)
+{
+	long ret = 0, i;
+
+	u32 id = core->id;
+
+	ret = copy_from_user(dec_regs[id], (u32 *)core->regs, HANTRO_DEC_REGS*4);
+	if (ret)
+	{
+		PDEBUG("%s copy_from_user failed, returned %li\n", DEV_NAME, ret);
+		return -EFAULT;
+	}
+
+	/* write all regs but the status reg[1] to hardware */
+	for(i = 2; i <= HANTRO_DEC_LAST_REG; i++)
+		iowrite32(dec_regs[id][i], dev->hwregs[id] + i*4);
+
+	/* write the status register, which may start the decoder */
+	iowrite32(dec_regs[id][1], dev->hwregs[id] + 4);
+
+	PDEBUG("%s flushed registers on core %d\n", DEV_NAME, id);
+
+	return 0;
+}
+
+long DecRefreshRegs(hantrodec_t *dev, struct core_desc *core)
+{
+	long ret, i;
+	u32 id = core->id;
+
+	/* user has to know exactly what they are asking for */
+	if(core->size != (HANTRO_DEC_REGS * 4))
+		return -EFAULT;
+
+	/* read all registers from hardware */
+	for(i = 0; i <= HANTRO_DEC_LAST_REG; i++)
+		dec_regs[id][i] = ioread32(dev->hwregs[id] + i*4);
+
+	/* put registers to user space*/
+	ret = copy_to_user((u32 *)core->regs, dec_regs[id], HANTRO_DEC_REGS*4);
+	if (ret)
+	{
+		PDEBUG("%s copy_to_user failed, returned %li\n", DEV_NAME, ret);
+		return -EFAULT;
+	}
+
+	return 0;
+}
+
+static int CheckDecIrq(hantrodec_t *dev, int id)
+{
+	unsigned long flags;
+	int rdy = 0;
+
+	const u32 irq_mask = (1 << id);
+
+	spin_lock_irqsave(&owner_lock, flags);
+
+	if(dec_irq & irq_mask)
+	{
+		/* reset the wait condition(s) */
+		dec_irq &= ~irq_mask;
+		rdy = 1;
+	}
+
+	spin_unlock_irqrestore(&owner_lock, flags);
+
+	return rdy;
+}
+
+long WaitDecReadyAndRefreshRegs(hantrodec_t *dev, struct core_desc *core)
+{
+	u32 id = core->id;
+
+	PDEBUG("%s wait_event_interruptible DEC[%d]\n", DEV_NAME, id);
+
+	if(wait_event_interruptible(dec_wait_queue, CheckDecIrq(dev, id)))
+	{
+		PDEBUG("%s DEC[%d]  wait_event_interruptible interrupted\n", DEV_NAME, id);
+		return -ERESTARTSYS;
+	}
+
+	atomic_inc(&irq_tx);
+
+	/* refresh registers */
+	return DecRefreshRegs(dev, core);
+}
+
+static int CheckCoreIrq(hantrodec_t *dev, const struct file *filp, int *id)
+{
+	unsigned long flags;
+	int rdy = 0, n = 0;
+
+	do
+	{
+		u32 irq_mask = (1 << n);
+
+		spin_lock_irqsave(&owner_lock, flags);
+
+		if(dec_irq & irq_mask)
+		{
+			if (dec_owner[n] == filp)
+			{
+				/* we have an IRQ for our client */
+
+				/* reset the wait condition(s) */
+				dec_irq &= ~irq_mask;
+
+				/* signal ready core no. for our client */
+				*id = n;
+
+				rdy = 1;
+
+				spin_unlock_irqrestore(&owner_lock, flags);
+				break;
+			}
+			else if(dec_owner[n] == NULL)
+			{
+				/* zombie IRQ */
+				pr_info("%s IRQ on core[%d], but no owner!!!\n", DEV_NAME, n);
+
+				/* reset the wait condition(s) */
+				dec_irq &= ~irq_mask;
+				if (dec_release == 1) /* RTK, workaround for memory leak when decoder release */
+				{
+					dec_release = 0;
+					*id = n;
+					rdy = 1;
+					spin_unlock_irqrestore(&owner_lock, flags);
+					break;
+				}
+			}
+		}
+
+		spin_unlock_irqrestore(&owner_lock, flags);
+
+		n++; /* next core */
+	}
+	while(n < dev->cores);
+
+	return rdy;
+}
+
+long WaitCoreReady(hantrodec_t *dev, const struct file *filp, int *id)
+{
+	PDEBUG("%s wait_event_interruptible CORE\n", DEV_NAME);
+
+	if(wait_event_interruptible(dec_wait_queue, CheckCoreIrq(dev, filp, id)))
+	{
+		PDEBUG("%s CORE  wait_event_interruptible interrupted\n", DEV_NAME);
+		return -ERESTARTSYS;
+	}
+
+	atomic_inc(&irq_tx);
+
+	return 0;
+}
+
+/*------------------------------------------------------------------------------
+ Function name   : hantrodec_ioctl
+ Description	 : communication method to/from the user space
+
+ Return type	 : long
+------------------------------------------------------------------------------*/
+static long hantrodec_ioctl(struct file *filp, unsigned int cmd,
+	unsigned long arg)
+{
+	int err = 0;
+	long tmp;
+
+#ifdef HW_PERFORMANCE
+	struct timeval *end_time_arg;
+#endif
+
+	PDEBUG("%s ioctl cmd 0x%08x\n", DEV_NAME, cmd);
+	/*
+	 * extract the type and number bitfields, and don't decode
+	 * wrong cmds: return ENOTTY (inappropriate ioctl) before access_ok()
+	 */
+	if (_IOC_TYPE(cmd) != HANTRODEC_IOC_MAGIC)
+		return -ENOTTY;
+	if (_IOC_NR(cmd) > HANTRODEC_IOC_MAXNR)
+		return -ENOTTY;
+
+	/*
+	 * the direction is a bitmask, and VERIFY_WRITE catches R/W
+	 * transfers. `Type' is user-oriented, while
+	 * access_ok is kernel-oriented, so the concept of "read" and
+	 * "write" is reversed
+	 */
+	if (_IOC_DIR(cmd) & _IOC_READ)
+		err = !access_ok(VERIFY_WRITE, (void *) arg, _IOC_SIZE(cmd));
+	else if (_IOC_DIR(cmd) & _IOC_WRITE)
+		err = !access_ok(VERIFY_READ, (void *) arg, _IOC_SIZE(cmd));
+
+	if (err)
+		return -EFAULT;
+
+	switch (cmd)
+	{
+	case HANTRODEC_IOC_CLI:
+		disable_irq(hantrodec_data.irq);
+		break;
+	case HANTRODEC_IOC_STI:
+		enable_irq(hantrodec_data.irq);
+		break;
+	case HANTRODEC_IOCGHWOFFSET:
+		__put_user(multicorebase[0], (unsigned long *) arg);
+		break;
+	case HANTRODEC_IOCGHWIOSIZE:
+		__put_user(hantrodec_data.iosize, (unsigned int *) arg);
+		break;
+	case HANTRODEC_BONDINGOFFSET:
+		__put_user(s_bonding_phy_register, (unsigned long *) arg);
+		break;
+	case HANTRODEC_BONDINGIOSIZE:
+		__put_user(s_bonding_size_register, (unsigned int *) arg);
+		break;
+	case HANTRODEC_IOC_MC_OFFSETS:
+	{
+		tmp = copy_to_user((u64 *) arg, multicorebase, sizeof(multicorebase));
+		if (err)
+		{
+			PDEBUG("%s copy_to_user failed, returned %li\n", DEV_NAME, tmp);
+			return -EFAULT;
+		}
+		break;
+	}
+	case HANTRODEC_IOC_MC_CORES:
+		__put_user(hantrodec_data.cores, (unsigned int *) arg);
+		break;
+	case HANTRODEC_IOCS_DEC_PUSH_REG:
+	{
+		struct core_desc core;
+
+		/* get registers from user space*/
+		tmp = copy_from_user(&core, (void*)arg, sizeof(struct core_desc));
+		if (tmp)
+		{
+			PDEBUG("%s copy_from_user failed, returned %li\n", DEV_NAME tmp);
+			return -EFAULT;
+		}
+
+		DecFlushRegs(&hantrodec_data, &core);
+		break;
+	}
+	case HANTRODEC_IOCS_DEC_PULL_REG:
+	{
+		struct core_desc core;
+
+		/* get registers from user space*/
+		tmp = copy_from_user(&core, (void*)arg, sizeof(struct core_desc));
+		if (tmp)
+		{
+			PDEBUG("%s copy_from_user failed, returned %li\n", DEV_NAME, tmp);
+			return -EFAULT;
+		}
+
+		return DecRefreshRegs(&hantrodec_data, &core);
+	}
+	case HANTRODEC_IOCH_DEC_RESERVE:
+	{
+		PDEBUG("%s Reserve DEC core, format = %li\n", DEV_NAME, arg);
+		return ReserveDecoder(&hantrodec_data, filp, arg);
+	}
+	case HANTRODEC_IOCT_DEC_RELEASE:
+	{
+		if(arg >= hantrodec_data.cores || dec_owner[arg] != filp)
+		{
+			PDEBUG("%s bogus DEC release, core = %li\n", DEV_NAME, arg);
+			return -EFAULT;
+		}
+
+		PDEBUG("%s Release DEC, core = %li\n", DEV_NAME, arg);
+
+		ReleaseDecoder(&hantrodec_data, arg);
+
+		break;
+	}
+	case HANTRODEC_IOCX_DEC_WAIT:
+	{
+		struct core_desc core;
+
+		/* get registers from user space */
+		tmp = copy_from_user(&core, (void*)arg, sizeof(struct core_desc));
+		if (tmp)
+		{
+			PDEBUG("%s copy_from_user failed, returned %li\n", DEV_NAME, tmp);
+			return -EFAULT;
+		}
+
+		return WaitDecReadyAndRefreshRegs(&hantrodec_data, &core);
+	}
+	case HANTRODEC_IOCG_CORE_WAIT:
+	{
+		int id;
+		tmp = WaitCoreReady(&hantrodec_data, filp, &id);
+		__put_user(id, (int *) arg);
+		return tmp;
+	}
+	case HANTRODEC_IOX_ASIC_ID:
+	{
+		u32 id;
+		__get_user(id, (u32*)arg);
+
+		if(id >= hantrodec_data.cores)
+		{
+			return -EFAULT;
+		}
+		id = ioread32(hantrodec_data.hwregs[id]);
+		__put_user(id, (u32 *) arg);
+	}
+	break;
+	case HANTRODEC_DEBUG_STATUS:
+	{
+		pr_info("%s dec_irq = 0x%08x \n", DEV_NAME, dec_irq);
+		pr_info("%s IRQs received/sent2user = %d / %d \n",
+			DEV_NAME, atomic_read(&irq_rx), atomic_read(&irq_tx));
+
+		for (tmp = 0; tmp < hantrodec_data.cores; tmp++)
+		{
+			pr_info("%s dec_core[%li] %s\n",
+				DEV_NAME, tmp, dec_owner[tmp] == NULL ? "FREE" : "RESERVED");
+		}
+	}
+	break;
+	case HANTRODEC_SET_CLOCK_ENABLE:
+	{
+		u32 clkgate;
+
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+
+		PDEBUG("%s HANTRODEC_SET_CLOCK_ENABLE:%d\n", DEV_NAME, clkgate);
+
+		if (clkgate)
+		{
+#ifdef CONFIG_POWER_CONTROL
+			pr_info("%s before pctrl_on for laterncy watching!!\n", DEV_NAME);
+			ve3_pctrl_on(s_pctrl_ve3);
+			pr_info("%s after pctrl_on for laterncy watching!!\n", DEV_NAME);
+#endif
+			ve3_clk_enable(s_ve3_clk);
+			ve3_wrapper_setup(base_address);
+			msleep(1);
+			dec_release = 0;
+		}
+		else
+		{
+			ve3_clk_disable(s_ve3_clk);
+#ifdef CONFIG_POWER_CONTROL
+			ve3_pctrl_off(s_pctrl_ve3);
+#endif
+		}
+	}
+	break;
+	case HANTRODEC_GET_ASIC_REVISION:
+	{
+		__put_user(get_rtd129x_cpu_revision()|get_rtd129x_cpu_id(), (unsigned int *) arg);
+	}
+	break;
+	case HANTRODEC_RESET_CLK_GATING:
+	{
+		PDEBUG("%s HANTRODEC_RESET_CLK_GATING\n", DEV_NAME);
+		ve3_clk_disable(s_ve3_clk);
+		reset_control_reset(rstc_ve3);
+		ve3_clk_enable(s_ve3_clk);
+
+		ve3_wrapper_setup(base_address);
+		//msleep(1);
+	}
+	break;
+	case HANTRODEC_NOTIFY_RELEASE:
+	{
+		dec_release = 1;
+		dec_irq |= (1 << 0);
+		wake_up_interruptible_all(&dec_wait_queue);
+	}
+	break;
+	case HANTRODEC_GET_ASIC_REG:
+	{
+		struct core_desc core;
+
+		/* get registers from user space*/
+		tmp = copy_from_user(&core, (void*)arg, sizeof(struct core_desc));
+		if (tmp)
+		{
+			PDEBUG("%s copy_from_user failed, returned %li\n", DEV_NAME, tmp);
+			return -EFAULT;
+		}
+
+		tmp = copy_to_user((u32 *)core.regs, asic_dec_regs[core.id], HANTRO_DEC_REGS*4);
+		if (tmp)
+		{
+			PDEBUG("%s copy_to_user failed, returned %li\n", DEV_NAME, tmp);
+			return -EFAULT;
+		}
+	}
+	break;
+    case HANTRODEC_GET_INSTANCE:
+	{
+		__put_user(inst_cnt, (unsigned int *) arg);
+		break;
+	}
+	default:
+		return -ENOTTY;
+	}
+
+	return 0;
+}
+
+/*------------------------------------------------------------------------------
+ Function name   : hantrodec_open
+ Description	 : open method
+
+ Return type	 : int
+------------------------------------------------------------------------------*/
+
+static int hantrodec_open(struct inode *inode, struct file *filp)
+{
+	PDEBUG("%s dev opened\n", DEV_NAME);
+	inst_cnt++;
+	return 0;
+}
+
+/*------------------------------------------------------------------------------
+ Function name   : hantrodec_release
+ Description	 : Release driver
+
+ Return type	 : int
+------------------------------------------------------------------------------*/
+
+static int hantrodec_release(struct inode *inode, struct file *filp)
+{
+	int n;
+	hantrodec_t *dev = &hantrodec_data;
+
+	PDEBUG("%s closing ...\n", DEV_NAME);
+
+	inst_cnt--;
+
+	for(n = 0; n < dev->cores; n++)
+	{
+		if(dec_owner[n] == filp)
+		{
+			PDEBUG("%s releasing dec core %i lock\n", DEV_NAME, n);
+			ReleaseDecoder(dev, n);
+		}
+	}
+
+	PDEBUG("%s closed\n", DEV_NAME);
+	return 0;
+}
+
+static int ve3_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+	if ((vm->vm_pgoff == (multicorebase[0]>>PAGE_SHIFT)) || (vm->vm_pgoff == (s_bonding_phy_register>>PAGE_SHIFT)))
+	{
+		unsigned long pfn;
+
+		vm->vm_flags |= VM_IO | VM_RESERVED;
+		vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+		pfn = vm->vm_pgoff;
+
+		return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+	}
+	else
+	{
+		vm->vm_flags |= VM_IO | VM_RESERVED;
+		vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+		return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+	}
+}
+
+/* VFS methods */
+static struct file_operations hantrodec_fops =
+{
+	.owner = THIS_MODULE,
+	.open = hantrodec_open,
+	.release = hantrodec_release,
+	.unlocked_ioctl = hantrodec_ioctl,
+	.compat_ioctl = compat_hantrodec_ioctl,
+	.fasync = NULL,
+	.mmap = ve3_mmap
+};
+
+/*------------------------------------------------------------------------------
+ Function name   : hantrodec_init
+ Description	 : Initialize the driver
+
+ Return type	 : int
+------------------------------------------------------------------------------*/
+
+int __init hantrodec_init(void)
+{
+	int result = 0;
+
+	PDEBUG("%s module init\n", DEV_NAME);
+
+#if 0 //Fuchun, move to probe function
+	int i = 0;
+	pr_info("%s dec/pp kernel module\n", DEV_NAME);
+
+	multicorebase[0] = base_port;
+	elements = 1;
+	pr_info("%s Init single core at 0x%08x IRQ=%i\n",
+		DEV_NAME, multicorebase[0], ve3_irq);
+
+	hantrodec_data.iosize = DEC_IO_SIZE;
+	hantrodec_data.irq = ve3_irq;
+
+	for(i=0; i< HXDEC_MAX_CORES; i++)
+	{
+		hantrodec_data.hwregs[i] = 0;
+		/* If user gave less core bases that we have by default,
+		 * invalidate default bases
+		 */
+		if(elements && i>=elements)
+		{
+			multicorebase[i] = -1;
+		}
+	}
+
+	hantrodec_data.async_queue_dec = NULL;
+
+	result = register_chrdev(hantrodec_major, "hantrodec", &hantrodec_fops);
+	if(result < 0)
+	{
+		pr_info("%s unable to get major %d\n", DEV_NAME, hantrodec_major);
+		goto err;
+	}
+	else if(result != 0)	/* this is for dynamic major */
+	{
+		hantrodec_major = result;
+	}
+
+	result = ReserveIO();
+	if(result < 0)
+	{
+		goto err;
+	}
+
+	memset(dec_owner, 0, sizeof(dec_owner));
+
+	sema_init(&dec_core_sem, hantrodec_data.cores);
+
+	/* read configuration fo all cores */
+	ReadCoreConfig(&hantrodec_data);
+
+	/* reset hardware */
+	ResetAsic(&hantrodec_data);
+
+	/* get the IRQ line */
+	if(ve3_irq > 0) {
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 18))
+		result = request_irq(ve3_irq, hantrodec_isr, SA_INTERRUPT | SA_SHIRQ, "VE3_CODEC_IRQ", (void *) &hantrodec_data);
+#else
+		result = request_irq(ve3_irq, hantrodec_isr, IRQF_SHARED, "VE3_CODEC_IRQ", (void *) &hantrodec_data);
+#endif
+		if(result != 0) {
+			if(result == -EINVAL)
+				pr_err("%s Bad irq number or handler\n", DEV_NAME);
+			else if(result == -EBUSY)
+				pr_err("%s IRQ <%d> busy, change your config\n", DEV_NAME, hantrodec_data.irq);
+
+			ReleaseIO();
+			goto err;
+		}
+	}else{
+		pr_info("%s IRQ not in use!\n", DEV_NAME);
+	}
+
+	return 0;
+
+err:
+	pr_info("%s module not inserted\n", DEV_NAME);
+	unregister_chrdev(hantrodec_major, "hantrodec");
+
+#endif
+	return result;
+}
+
+/*------------------------------------------------------------------------------
+ Function name   : hantrodec_cleanup
+ Description	 : clean up
+
+ Return type	 : int
+------------------------------------------------------------------------------*/
+
+void __exit hantrodec_cleanup(void)
+{
+#if 0 //Fuchun, move to remove function
+	hantrodec_t *dev = &hantrodec_data;
+
+	/* reset hardware */
+	ResetAsic(dev);
+
+	/* free the IRQ */
+	if(dev->irq != -1)
+		free_irq(dev->irq, (void *) dev);
+
+	ReleaseIO();
+
+	misc_deregister(&s_ve3_dev);
+#endif
+	pr_info("%s module exit\n", DEV_NAME);
+	return;
+}
+
+static int ve3_probe(struct platform_device *pdev)
+{
+	int err = 0, i;
+	struct resource res;
+	void __iomem *iobase;
+	int irq;
+	struct device_node *node = pdev->dev.of_node;
+	if (!of_device_is_available(pdev->dev.of_node))
+		return -ENODEV;
+	of_address_to_resource(node, 0, &res);
+	iobase = of_iomap(node, 0);
+
+	base_port = res.start;
+	base_address = (volatile u8 *)iobase;
+	hantrodec_data.iosize = res.end - res.start + 1;
+
+	pr_info("%s base address get from DTB physical base addr=0x%lx, virtual base=0x%lx, size=0x%x(actually=0x%x)\n",
+		DEV_NAME, base_port, (unsigned long)base_address, hantrodec_data.iosize, DEC_IO_SIZE);
+
+	of_address_to_resource(node, 1, &res);
+	iobase = of_iomap(node, 1);
+
+	s_pll_phy_register = res.start;
+	s_pll_virt_register = (unsigned long)iobase;
+	s_pll_size_register = res.end - res.start + 1;
+
+	of_address_to_resource(node, 2, &res);
+	s_bonding_phy_register = res.start;
+	s_bonding_size_register = res.end - res.start + 1;
+
+	s_ve3_dev.minor = MISC_VE3_MINOR;
+	s_ve3_dev.name = HANTRO_DEV_NAME;
+	s_ve3_dev.fops = &hantrodec_fops;
+	s_ve3_dev.parent = NULL;
+	if (misc_register(&s_ve3_dev)) {
+		pr_info("%s failed to register misc device.", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	irq = irq_of_parse_and_map(node, 0);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	ve3_irq = irq;
+
+	if (pdev)
+		s_ve3_clk = ve3_clk_get(&pdev->dev);
+	else
+		s_ve3_clk = ve3_clk_get(NULL);
+
+	if (!s_ve3_clk)
+		pr_err("%s fail to get clock controller, but, do not treat as error, \n", DEV_NAME);
+	else
+		pr_info("%s get clock controller s_ve3_clk=0x%p\n", DEV_NAME, s_ve3_clk);
+
+#ifdef CONFIG_POWER_CONTROL
+	s_pctrl_ve3 = ve3_pctrl_get();
+	ve3_pctrl_on(s_pctrl_ve3);
+#endif
+
+	rstc_ve3 = reset_control_get(&pdev->dev, NULL);
+
+	/* RTK clock setting */
+	ve3_pll_setting(0x114, PLL_CLK_594, 1, 0); // VE1 PLL
+	ve3_pll_setting(0x118, (0x7), 1, 0); // VE1 PLL disable
+	__delay(100);
+	ve3_pll_setting(0x118, (0x3), 1, 0); // VE1 PLL enable
+	reset_control_deassert(rstc_ve3); // RESET disable
+	ve3_clk_enable(s_ve3_clk);
+
+	ve3_wrapper_setup(base_address);
+	msleep(1);
+	pr_info("%s Get cti: 0x%x\n", DEV_NAME, __raw_readl(base_address+0x3F00));
+
+	/* hantrodec_init start */
+	pr_info("%s dec kernel module\n", DEV_NAME);
+
+	multicorebase[0] = base_port;
+	elements = 1;
+	pr_info("%s Init single core at 0x%16llx IRQ=%i\n",
+		DEV_NAME, multicorebase[0], ve3_irq);
+
+	hantrodec_data.iosize = DEC_IO_SIZE;
+	hantrodec_data.irq = ve3_irq;
+
+	for (i = 0 ; i < HXDEC_MAX_CORES ; i++) {
+		hantrodec_data.hwregs[i] = 0;
+		/* If user gave less core bases that we have by default,
+		 * invalidate default bases
+		 */
+		if(elements && i>=elements)
+			multicorebase[i] = -1;
+	}
+
+	hantrodec_data.async_queue_dec = NULL;
+
+	err = ReserveIO();
+	if(err < 0)
+		goto ERROR_PROVE_DEVICE;
+
+	memset(dec_owner, 0, sizeof(dec_owner));
+
+	sema_init(&dec_core_sem, hantrodec_data.cores);
+
+	/* read configuration fo all cores */
+	ReadCoreConfig(&hantrodec_data);
+
+	/* reset hardware */
+	ResetAsic(&hantrodec_data);
+
+	/* get the IRQ line */
+	if(ve3_irq > 0) {
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 18))
+		err = request_irq(ve3_irq, hantrodec_isr, SA_INTERRUPT | SA_SHIRQ, "VE3_CODEC_IRQ", (void *) &hantrodec_data);
+#else
+		err = request_irq(ve3_irq, hantrodec_isr, IRQF_SHARED, "VE3_CODEC_IRQ", (void *) &hantrodec_data);
+#endif
+
+		if(err != 0) {
+			if(err == -EINVAL)
+				pr_err("%s Bad irq number or handler\n", DEV_NAME);
+			else if(err == -EBUSY)
+				pr_err("%s IRQ <%d> busy, change your config\n",
+					DEV_NAME, hantrodec_data.irq);
+			ReleaseIO();
+			goto ERROR_PROVE_DEVICE;
+		}
+	} else
+		pr_info("%s IRQ not in use!\n", DEV_NAME);
+
+	pr_info("%s module inserted. Major = %d\n", DEV_NAME, hantrodec_major);
+	/* hantrodec_init end */
+
+	ve3_clk_disable(s_ve3_clk);
+#ifdef CONFIG_POWER_CONTROL
+	ve3_pctrl_off(s_pctrl_ve3);
+#endif
+	return 0;
+
+ERROR_PROVE_DEVICE:
+
+	pr_info("%s module not inserted\n", DEV_NAME);
+
+	if (rstc_ve3 != NULL)
+		reset_control_put(rstc_ve3);
+
+	ve3_clk_put(s_ve3_clk);
+	misc_deregister(&s_ve3_dev);
+
+	return err;
+}
+
+static int ve3_remove(struct platform_device *pdev)
+{
+	hantrodec_t *dev = (hantrodec_t *)&hantrodec_data;
+
+	pr_info("%s ve3_remove\n", DEV_NAME);
+
+	/* reset hardware */
+	ResetAsic(dev);
+
+	/* free the IRQ */
+	if(dev->irq != -1)
+	{
+		free_irq(dev->irq, (void *) dev);
+	}
+
+	ReleaseIO();
+
+	if (rstc_ve3 != NULL)
+		reset_control_put(rstc_ve3);
+
+	ve3_clk_put(s_ve3_clk);
+
+	misc_deregister(&s_ve3_dev);
+
+	pr_info("%s hantrodec: module removed\n", DEV_NAME);
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+static int ve3_suspend(struct device *pdev)
+{
+
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+#ifdef CONFIG_POWER_CONTROL
+	ve3_pctrl_on(s_pctrl_ve3);
+#endif
+	ve3_clk_enable(s_ve3_clk);
+
+	if (dec_owner[0] != NULL)
+	{
+		up(&dec_core_sem);
+		wake_up_interruptible_all(&hw_queue);
+		wake_up_interruptible_all(&dec_wait_queue);
+		dec_irq = 0;
+		dec_owner[0] = NULL;
+	}
+
+	ve3_clk_disable(s_ve3_clk);
+#ifdef CONFIG_POWER_CONTROL
+	ve3_pctrl_off(s_pctrl_ve3);
+#endif
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+
+static int ve3_resume(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME,  __func__);
+
+#ifdef CONFIG_POWER_CONTROL
+	ve3_pctrl_on(s_pctrl_ve3);
+#endif
+	ve3_clk_enable(s_ve3_clk);
+	/* RTK clock setting */
+	ve3_pll_setting(0x114, PLL_CLK_594, 1, 0); // VE1 PLL
+	ve3_pll_setting(0x118, (0x7), 1, 0); // VE1 PLL disable
+	__delay(100);
+	ve3_pll_setting(0x118, (0x3), 1, 0); // VE1 PLL enable
+	ve3_clk_disable(s_ve3_clk);
+#ifdef CONFIG_POWER_CONTROL
+	ve3_pctrl_off(s_pctrl_ve3);
+#endif
+
+	pr_info("%s  Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+#else
+#define ve3_suspend NULL
+#define ve3_resume NULL
+#endif /* !CONFIG_PM */
+
+/*------------------------------------------------------------------------------
+ Function name   : ReserveIO
+ Description	 : IO reserve
+
+ Return type	 : int
+------------------------------------------------------------------------------*/
+static int ReserveIO(void)
+{
+	int i;
+
+	for (i = 0 ; i < HXDEC_MAX_CORES ; i++) {
+		if (multicorebase[i] != -1) {
+#if 0
+			if (!request_mem_region(multicorebase[i], hantrodec_data.iosize, "hantrodec0")) {
+				pr_info("%s failed to reserve HW regs\n", DEV_NAME);
+				return -EBUSY;
+			}
+
+			hantrodec_data.hwregs[i] = (volatile u8 *) ioremap_nocache(multicorebase[i], hantrodec_data.iosize);
+#else
+			hantrodec_data.hwregs[i] = base_address;
+#endif
+			if (hantrodec_data.hwregs[i] == NULL ) {
+				pr_info("%s failed to ioremap HW regs\n", DEV_NAME);
+				ReleaseIO();
+				return -EBUSY;
+			}
+			hantrodec_data.cores++;
+		}
+	}
+
+	return 0;
+}
+
+/*------------------------------------------------------------------------------
+ Function name : releaseIO
+ Description	 : release
+
+ Return type : void
+------------------------------------------------------------------------------*/
+
+static void ReleaseIO(void)
+{
+	int i;
+
+	for (i = 0 ; i < hantrodec_data.cores ; i++) {
+#if 0
+		if (hantrodec_data.hwregs[i])
+			iounmap((void *) hantrodec_data.hwregs[i]);
+		release_mem_region(multicorebase[i], hantrodec_data.iosize);
+#endif
+	}
+}
+
+/*------------------------------------------------------------------------------
+ Function name   : hantrodec_isr
+ Description	 : interrupt handler
+
+ Return type	 : irqreturn_t
+------------------------------------------------------------------------------*/
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18))
+irqreturn_t hantrodec_isr(int irq, void *dev_id, struct pt_regs *regs)
+#else
+irqreturn_t hantrodec_isr(int irq, void *dev_id)
+#endif
+{
+	unsigned long flags;
+	unsigned int handled = 0;
+	int i;
+
+	hantrodec_t *dev = (hantrodec_t *) dev_id;
+	u32 irq_status_dec;
+
+	spin_lock_irqsave(&owner_lock, flags);
+
+	for (i = 0 ; i < dev->cores ; i++) {
+		volatile u8 *hwregs = dev->hwregs[i];
+
+		/* interrupt status register read */
+		irq_status_dec = ioread32(hwregs + HANTRODEC_IRQ_STAT_DEC_OFF);
+
+		if(irq_status_dec & HANTRODEC_DEC_IRQ) {
+			/* clear dec IRQ */
+			irq_status_dec &= (~HANTRODEC_DEC_IRQ);
+			iowrite32(irq_status_dec, hwregs + HANTRODEC_IRQ_STAT_DEC_OFF);
+
+			PDEBUG("%s decoder IRQ received! core %d\n", DEV_NAME, i);
+
+			atomic_inc(&irq_rx);
+
+			dec_irq |= (1 << i);
+
+			wake_up_interruptible_all(&dec_wait_queue);
+			handled++;
+		}
+	}
+
+	spin_unlock_irqrestore(&owner_lock, flags);
+
+	if(!handled)
+		PDEBUG("%s IRQ received, but not VE3's!\n", DEV_NAME);
+
+	return IRQ_RETVAL(handled);
+}
+
+/*------------------------------------------------------------------------------
+ Function name   : ResetAsic
+ Description	 : reset asic
+
+ Return type	 :
+------------------------------------------------------------------------------*/
+void ResetAsic(hantrodec_t * dev)
+{
+	int i;
+	int j;
+	u32 status;
+
+	for (j = 0 ; j < dev->cores ; j++) {
+		status = ioread32(dev->hwregs[j] + HANTRODEC_IRQ_STAT_DEC_OFF);
+
+		if( status & HANTRODEC_DEC_E) {
+			/* abort with IRQ disabled */
+			status = HANTRODEC_DEC_ABORT | HANTRODEC_DEC_IRQ_DISABLE;
+			iowrite32(status, dev->hwregs[j] + HANTRODEC_IRQ_STAT_DEC_OFF);
+		}
+
+		for (i = 4 ; i < dev->iosize ; i += 4) {
+			iowrite32(0, dev->hwregs[j] + i);
+		}
+	}
+}
+
+/*------------------------------------------------------------------------------
+ Function name   : dump_regs
+ Description	 : Dump registers
+
+ Return type	 :
+------------------------------------------------------------------------------*/
+#ifdef HANTRODEC_DEBUG
+void dump_regs(hantrodec_t *dev)
+{
+	int i,c;
+
+	PDEBUG("%s Reg Dump Start\n", DEV_NAME);
+	for(c = 0 ; c < dev->cores ; c++) {
+		for(i = 0 ; i < dev->iosize ; i += 4*4) {
+			PDEBUG("%s \toffset %04X: %08X  %08X  %08X  %08X\n",
+				DEV_NAME,
+				i,
+				ioread32(dev->hwregs[c] + i),
+				ioread32(dev->hwregs[c] + i + 4),
+				ioread32(dev->hwregs[c] + i + 16),
+				ioread32(dev->hwregs[c] + i + 24));
+		}
+	}
+	PDEBUG("%s Reg Dump End\n", DEV_NAME);
+}
+#endif
+
+struct clk *ve3_clk_get(struct device *dev)
+{
+	return clk_get(dev, "clk_ve3");
+}
+
+void ve3_clk_put(struct clk *clk)
+{
+	if (clk)
+		clk_put(clk);
+}
+
+int ve3_clk_enable(struct clk *clk)
+{
+	if (clk) {
+		PDEBUG("%s ve3_clk_enable\n", DEV_NAME);
+		return clk_prepare_enable(clk);
+	}
+	return 0;
+}
+
+void ve3_clk_disable(struct clk *clk)
+{
+	if (clk) {
+		PDEBUG("%s ve3_clk_disable\n", DEV_NAME);
+		while(__clk_is_enabled(clk))
+			clk_disable_unprepare(clk);
+	}
+}
+
+#ifdef CONFIG_POWER_CONTROL
+
+static int ve3_pcrtl_callback(struct notifier_block *nb,
+			      unsigned long action,
+			      void *p)
+{
+	struct power_control *pctrl = p;
+
+	if (action != POWER_CONTROL_ACTION_POST_POWER_ON)
+		return NOTIFY_DONE;
+
+	reset_control_reset(rstc_ve3);
+	return NOTIFY_OK;
+}
+
+struct notifier_block ve3_pctrl_nb = {
+	.notifier_call = ve3_pcrtl_callback,
+};
+
+struct power_control *ve3_pctrl_get(void)
+{
+	 struct power_control *pctrl;
+
+	pctrl = power_control_get("pctrl_ve3");
+	if (WARN_ON(IS_ERR_OR_NULL(pctrl)))
+		return NULL;
+	power_control_register_notifier(pctrl, &ve3_pctrl_nb);
+	return pctrl;
+}
+
+void ve3_pctrl_on(struct power_control *pctrl)
+{
+	if (!(pctrl == NULL || IS_ERR(pctrl))) {
+		printk(KERN_INFO "ve3_pctrl_on\n");
+		power_control_power_on(pctrl);
+	}
+}
+
+void ve3_pctrl_off(struct power_control *pctrl)
+{
+	if (!(pctrl == NULL || IS_ERR(pctrl))) {
+		printk(KERN_INFO "ve3_pctrl_off\n");
+		power_control_power_off(pctrl);
+	}
+}
+#endif
+
+static const struct of_device_id rtk_ve3_dt_match[] = {
+	{.compatible = "Realtek,rtk1295-ve3"},
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtk_ve3_dt_match);
+
+const struct dev_pm_ops rtk_ve3_pmops = {
+	.suspend = ve3_suspend,
+	.resume = ve3_resume,
+};
+
+static struct platform_driver rtk_ve3_driver = {
+	.driver = {
+		.name = "rtk-ve3",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_ve3_dt_match,
+		.pm = &rtk_ve3_pmops,
+	},
+	.probe = ve3_probe,
+	.remove = ve3_remove,
+};
+
+module_platform_driver(rtk_ve3_driver);
+
+module_init(hantrodec_init);
+module_exit(hantrodec_cleanup);
+
+/* module description */
+MODULE_LICENSE("Proprietary");
+MODULE_AUTHOR("A customer using RTK VPU, Inc.");
+MODULE_DESCRIPTION("Driver module for VE3");
diff --git a/drivers/soc/realtek/rtd129x/rtk_ve/ve3/ve3.h b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/ve3.h
new file mode 100755
index 00000000..fa07202
--- /dev/null
+++ b/drivers/soc/realtek/rtd129x/rtk_ve/ve3/ve3.h
@@ -0,0 +1,76 @@
+/* Copyright 2013 Google Inc. All Rights Reserved. */
+
+#ifndef _VE3DEC_H_
+#define _VE3DEC_H_
+#include <linux/ioctl.h>
+#include <linux/types.h>
+
+#undef PDEBUG
+//#define HANTRODEC_DEBUG
+#ifdef HANTRODEC_DEBUG
+#  ifdef __KERNEL__
+#    define PDEBUG(fmt, args...) pr_info(fmt, ## args)
+#  else
+#    define PDEBUG(fmt, args...) fprintf(stderr, fmt, ## args)
+#  endif
+#else
+#  define PDEBUG(fmt, args...)
+#endif
+
+#define HXDEC_MAX_CORES                 1
+
+struct core_desc
+{
+    __u32 id; /* id of the core */
+    unsigned long regs; /* pointer to user registers */
+    __u32 size; /* size of register space */
+};
+
+/* Use 'k' as magic number */
+#define HANTRODEC_IOC_MAGIC  'k'
+
+/*
+ * S means "Set" through a ptr,
+ * T means "Tell" directly with the argument value
+ * G means "Get": reply by setting through a pointer
+ * Q means "Query": response is on the return value
+ * X means "eXchange": G and S atomically
+ * H means "sHift": T and Q atomically
+ */
+
+#define HANTRODEC_HW_PERFORMANCE    _IO(HANTRODEC_IOC_MAGIC, 2)
+#define HANTRODEC_IOCGHWOFFSET      _IOR(HANTRODEC_IOC_MAGIC,  3, unsigned long)
+#define HANTRODEC_IOCGHWIOSIZE      _IOR(HANTRODEC_IOC_MAGIC,  4, unsigned int)
+
+#define HANTRODEC_IOC_CLI           _IO(HANTRODEC_IOC_MAGIC,  5)
+#define HANTRODEC_IOC_STI           _IO(HANTRODEC_IOC_MAGIC,  6)
+#define HANTRODEC_IOC_MC_OFFSETS    _IOR(HANTRODEC_IOC_MAGIC, 7, unsigned long)
+#define HANTRODEC_IOC_MC_CORES      _IOR(HANTRODEC_IOC_MAGIC, 8, unsigned int)
+
+
+#define HANTRODEC_IOCS_DEC_PUSH_REG  _IOW(HANTRODEC_IOC_MAGIC, 9, struct core_desc)
+
+#define HANTRODEC_IOCH_DEC_RESERVE   _IO(HANTRODEC_IOC_MAGIC, 11)
+#define HANTRODEC_IOCT_DEC_RELEASE   _IO(HANTRODEC_IOC_MAGIC, 12)
+
+#define HANTRODEC_IOCX_DEC_WAIT      _IOWR(HANTRODEC_IOC_MAGIC, 15, struct core_desc)
+
+#define HANTRODEC_IOCS_DEC_PULL_REG  _IOWR(HANTRODEC_IOC_MAGIC, 17, struct core_desc)
+
+#define HANTRODEC_IOCG_CORE_WAIT     _IOR(HANTRODEC_IOC_MAGIC, 19, int)
+
+#define HANTRODEC_IOX_ASIC_ID        _IOWR(HANTRODEC_IOC_MAGIC, 20, __u32)
+
+#define HANTRODEC_DEBUG_STATUS       _IO(HANTRODEC_IOC_MAGIC, 29)
+
+/* RTK ioctl */
+#define HANTRODEC_SET_CLOCK_ENABLE   _IO(HANTRODEC_IOC_MAGIC, 28)
+#define HANTRODEC_RESET_CLK_GATING   _IO(HANTRODEC_IOC_MAGIC, 27)
+#define HANTRODEC_NOTIFY_RELEASE     _IO(HANTRODEC_IOC_MAGIC, 26)
+#define HANTRODEC_GET_ASIC_REVISION  _IOR(HANTRODEC_IOC_MAGIC, 25, unsigned int)
+#define HANTRODEC_GET_ASIC_REG       _IOWR(HANTRODEC_IOC_MAGIC, 24, struct core_desc)
+#define HANTRODEC_BONDINGOFFSET      _IOR(HANTRODEC_IOC_MAGIC,  23, unsigned long)
+#define HANTRODEC_BONDINGIOSIZE      _IOR(HANTRODEC_IOC_MAGIC,  22, unsigned int)
+#define HANTRODEC_GET_INSTANCE     _IO(HANTRODEC_IOC_MAGIC, 32)
+#define HANTRODEC_IOC_MAXNR 35
+#endif /* !_HANTRODEC_H_ */
diff --git a/drivers/soc/realtek/rtd139x/Kconfig b/drivers/soc/realtek/rtd139x/Kconfig
new file mode 100644
index 00000000..5c102b7
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/Kconfig
@@ -0,0 +1,5 @@
+menu "RTD139x Device Drivers"
+
+source "drivers/soc/realtek/rtd139x/rtk_ve/Kconfig"
+
+endmenu #RTD139x Device Drivers
diff --git a/drivers/soc/realtek/rtd139x/Makefile b/drivers/soc/realtek/rtd139x/Makefile
new file mode 100644
index 00000000..fa3a418
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/Makefile
@@ -0,0 +1,10 @@
+ifndef CONFIG_CPU_V7
+obj-$(CONFIG_ARCH_RTD139x) += rtd139x_spin_table.o rtd139x_cpu_hotplug.o rtd139x_cpu_wrapper.o
+endif
+obj-$(CONFIG_ARCH_RTD139x) += rtk_chip.o rtd139x_restart.o
+obj-$(CONFIG_ARCH_RTD139x) += rtk_usb.o
+obj-$(CONFIG_RTK_SW_LOCK_API) += rtd139x_lockapi.o
+obj-$(CONFIG_RTK_ACPU_RELOAD) += avcpu.o
+obj-$(CONFIG_SUSPEND) += rtd139x_suspend.o
+obj-$(CONFIG_RTK_CODEC) += rtk_ve/
+obj-$(CONFIG_CPU_V7) += aarch32/
diff --git a/drivers/soc/realtek/rtd139x/aarch32/Makefile b/drivers/soc/realtek/rtd139x/aarch32/Makefile
new file mode 100644
index 00000000..8111c12
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/aarch32/Makefile
@@ -0,0 +1 @@
+obj-$(CONFIG_ARCH_RTD139x) += rtd139x_cpu_wrapper.o rtd139x_cpu_hotplug.o
diff --git a/drivers/soc/realtek/rtd139x/aarch32/rtd139x_cpu_hotplug.S b/drivers/soc/realtek/rtd139x/aarch32/rtd139x_cpu_hotplug.S
new file mode 100755
index 00000000..0fc7863
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/aarch32/rtd139x_cpu_hotplug.S
@@ -0,0 +1,38 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/linkage.h>
+#include <asm/cp15.h>
+#include <asm/virt.h>
+
+#define SCTLR_ELx_I (1 << 12)
+#define SCTLR_ELx_SA (1 << 3)
+#define SCTLR_ELx_C (1 << 2)
+#define SCTLR_ELx_A (1 << 1)
+
+//#define SCTLR_ELx_FLAGS (SCTLR_ELx_M | SCTLR_ELx_A | SCTLR_ELx_C | SCTLR_ELx_SA | SCTLR_ELx_I)
+#define SCTLR_ELx_FLAGS 0x100E
+
+ENTRY(__cpu_do_lowpower)
+	/* Clear sctlr flags. */
+	mrc	p15, 0, r1, c1, c0, 0
+	ldr	r2, =0xEFF1 /* SCTLR_ELx_FLAGS */
+	and	r1, r1, r2
+	mcr	p15, 0, r1, c1, c0, 0
+	isb
+	mrrc	p15, 1, r1, r2, c15
+	bic	r1, #0x0040 //Disable CPUECTLR.SMP bit
+	mcrr	p15, 1, r1, r2, c15
+	isb
+	dsb	sy
+loop:
+	wfi
+	bl	loop
+ENDPROC(__cpu_do_lowpower)
diff --git a/drivers/soc/realtek/rtd139x/aarch32/rtd139x_cpu_wrapper.c b/drivers/soc/realtek/rtd139x/aarch32/rtd139x_cpu_wrapper.c
new file mode 100755
index 00000000..b33d7c5
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/aarch32/rtd139x_cpu_wrapper.c
@@ -0,0 +1,310 @@
+/*
+ * rtd139x_cpu_wrapper.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/delay.h>
+#include <linux/debugfs.h>
+#include <linux/init.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <linux/delay.h>
+#include <asm/io.h>
+#include <asm/cacheflush.h>
+#include <asm/cputype.h>
+#include <asm/io.h>
+#include <asm/smp_plat.h>
+#include <asm/cp15.h>
+
+#include <asm/system_misc.h>
+
+#include "../../common/include/debug.h"
+
+void __cpu_do_lowpower(void);
+
+#define DBG_INT 0x230
+#define DBG_ADDR 0x234
+#define DBG_ADDR_MODE 0x238
+
+#define SCTLR __ACCESS_CP15(c1, 0, c0, 0)
+
+static void __iomem *scpu_wrap_addr;
+
+void dcache_disable(void)
+{
+	u32 sctlr;
+	sctlr =  read_sysreg(SCTLR);
+
+	/* if cache isn't enabled no need to disable */
+	if (!(sctlr & CR_C && !(sctlr & CR_M)))
+		return;
+
+	write_sysreg(sctlr & ~(CR_C|CR_M), SCTLR);
+
+	flush_cache_all();
+}
+
+void _rtk_cpu_power_up(int cpu){
+
+	u32 tmp = 0;
+
+	/* 5. Wait for SMPEN to be set */
+
+	/* 6. Assert DBGPWRDUP HIGH to allow external debug
+	 * access to the core. */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp |= 1UL << (24 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x100);
+}
+EXPORT_SYMBOL(_rtk_cpu_power_up);
+
+void rtk_cpu_power_up(int cpu)
+{
+	u32 tmp = 0;
+
+	/* 1. Assert nCPUPORESET LOW. Ensure DBGPWRDUP is held LOW to prevent
+	 * any external debug access to the core. */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp &= ~(1UL << (24 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x100);
+
+	/* 2. Apply power to the PDCPU power domain. Keep the state of the
+	 * signals nCPUPORESET and DBGPWRDUP LOW. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (4 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (8 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	mdelay(3);
+
+	tmp = readl(scpu_wrap_addr + 0x53C);
+	if((unlikely((tmp >> (4 + cpu)) & 0x1) != 0x1)) {
+		pr_err("%s: 0x9801D53C = %x\n", __func__, readl(scpu_wrap_addr + 0x53C));
+	}
+
+	/* 3. Release the core output clamps */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (0 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* 4. Dessert resets: nCOREPORESET, nCORERESET */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp |= 1UL << (0 + cpu);
+	tmp |= 1UL << (4 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x100);
+}
+EXPORT_SYMBOL(rtk_cpu_power_up);
+
+void rtk_cpu_power_down(int cpu)
+{
+	u32 tmp = 0;
+
+	/* Step 1 to 6 is done in rtd139x_cpu_hotplug.S
+	 * Wait for WFI in step 6. */
+	tmp = readl(scpu_wrap_addr + 0x104);
+	if (unlikely(((tmp >> cpu) & 0x1) != 0x1)) {
+		pr_err("%s: Processor is not in WFI standby mode.\n", __func__);
+		pr_err("0x9801D104 = %x\n", readl(scpu_wrap_addr + 0x104));
+	}
+
+	/* 7. Dessert DBGPWRDUP LOW.
+	 * This prevents any external debug access to the core. */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp &= ~(1UL << (24 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x100);
+
+	/* 8. Activate the core output clamps. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (0 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* 9. Assert nCPUPORESET LOW */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp &= ~(1UL << (0 + cpu));
+	tmp &= ~(1UL << (4 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x100);
+
+	/* 10. Remove power from the PDCPU power domain. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (4 + cpu));
+	tmp &= ~(1UL << (8 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+}
+EXPORT_SYMBOL(rtk_cpu_power_down);
+
+void cpu_do_lowpower(void)
+{
+	__cpu_do_lowpower();
+}
+EXPORT_SYMBOL(cpu_do_lowpower);
+
+static int set_l4_icg(void *base)
+{
+	unsigned int val;
+
+	val = readl(scpu_wrap_addr + 0x000);
+	val |= 0xFF3C0000;
+	writel(val, scpu_wrap_addr + 0x000);
+
+	val = readl(scpu_wrap_addr + 0x100);
+	val |= 0x8000000;
+	writel(val, scpu_wrap_addr + 0x100);
+
+	return 0;
+}
+
+static int arm_pmu_int_enable(void *base)
+{
+	unsigned int val;
+
+	val = readl(base + 0x120);
+	val |= 0xf;
+	writel(val, base + 0x120);
+
+	return 0;
+}
+
+
+irqreturn_t scpu_wrapper_isr(int irq, void *reg_base)
+{
+	struct pt_regs *regs;
+	u32 intr = readl(scpu_wrap_addr + DBG_INT);
+	u32 addr = readl(scpu_wrap_addr + DBG_ADDR);
+	u32 cause = readl(scpu_wrap_addr + DBG_ADDR_MODE);
+	char buf[128];
+
+	regs = get_irq_regs();
+
+	dbg_err("scpu wrapper get int 0x%08x", intr);
+	if(intr & (BIT(4) | BIT(2))){
+		writel((intr & ~(BIT(3)|BIT(1))), scpu_wrap_addr + DBG_INT);
+		dbg_err("scpu addr:0x%08x mode:%s", addr, (cause & 1) ? "W" : "R");
+
+		sprintf(buf, "[SCUP] Memory 0x%08x trashed with %s\n", addr,
+				(cause & 1) ? "W" : "R");
+		die(buf, regs, 0);
+
+		return IRQ_HANDLED;
+	}
+
+	return IRQ_NONE;
+}
+
+static const struct of_device_id rtk_scpu_wrapper_ids[] __initconst = {
+	{.compatible = "Realtek,rtk-scpu_wrapper"},
+	{},
+};
+
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w);
+
+static int __init scpu_wrapper_init(void)
+{
+	struct device_node *np;
+	int irq = 0;
+	int i = 0;
+
+	np = of_find_matching_node(NULL, rtk_scpu_wrapper_ids);
+	if(unlikely(np == NULL))
+		return -1;
+
+	irq = irq_of_parse_and_map(np, 0);
+
+	scpu_wrap_addr = of_iomap(np, 0);
+	pr_info("scpu wrappee irq %d, scpu_wrap_addr 0x%08x\n", irq, (u32)scpu_wrap_addr);
+
+	of_node_put(np);
+
+	if(request_irq(irq, scpu_wrapper_isr, IRQF_SHARED, "scpu_wrapper", scpu_wrap_addr) != 0){
+		dbg_err("Cannot get IRQ\n");
+		return -1;
+	}
+
+	/* clear dbg trap addr*/
+	for(i = 0 ; i < 8 ; i++ )
+		writel(0, scpu_wrap_addr + 0x200 + i * 4);
+	writel(0x98000000, scpu_wrap_addr + 0x200);	// 1st set start
+	writel(0x98000040, scpu_wrap_addr + 0x210);	// 1st set end
+
+	writel(0x98000040, scpu_wrap_addr + 0x204);	// 2nd set start
+	writel(0x98000080, scpu_wrap_addr + 0x214);	// 2nd set end
+
+	writel(0x98000080, scpu_wrap_addr + 0x208);	// 3th set start
+	writel(0x980000c0, scpu_wrap_addr + 0x218);	// 3th set end
+
+	writel(0x980000c0, scpu_wrap_addr + 0x20c);	// 4th set start
+	writel(0x98000100, scpu_wrap_addr + 0x21c);	// 4th set end
+
+	writel(0x9, scpu_wrap_addr + DBG_INT);	// enable interrupt
+
+	pr_info("[SCPU_WRAPPER] initialized\n");
+
+	pr_info("[SCPU_WRAPPER][%s] memory monitor 0x98013b00 - 0x98013c00\n", __func__);
+	scpu_dbg_scpu_monitor(0, 0x98013b00, 0x98013c00, 0x0);
+
+	set_l4_icg(scpu_wrap_addr);
+	arm_pmu_int_enable(scpu_wrap_addr);
+
+	return 0;
+}
+late_initcall(scpu_wrapper_init);
+
+void scpu_dbg_disable_mem_monitor(int which)
+{
+	void __iomem  *reg_ctrl;
+
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220);
+	reg_ctrl += which;
+	writel((1 << 13) | (1 << 9) | (1 << 1), reg_ctrl);
+}
+EXPORT_SYMBOL(scpu_dbg_disable_mem_monitor);
+
+static void scpu_dbg_set_mem_monitor(int which, u32 start, u32 end, u32 flags)
+{
+	void __iomem  *reg_start;
+	void __iomem  *reg_end;
+	void __iomem  *reg_ctrl;
+
+	/* disable this set first */
+	scpu_dbg_disable_mem_monitor(which);
+
+	reg_start = (void __iomem  *)(scpu_wrap_addr + 0x200 + which);
+	reg_end = (void __iomem  *)(scpu_wrap_addr + 0x210 + which);
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220 + which);
+
+	writel(start, reg_start);
+	writel(end, reg_end);
+
+	writel(flags, reg_ctrl);
+}
+
+/*
+ * which: 0~7, which register set
+ * d_i: SB2_DBG_MONITOR_DATA|SB2_DBG_MONITOR_INST
+ * r_w: SB2_DBG_MONITOR_READ|SB2_DBG_MONITOR_WRITE
+ */
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w)
+{
+	scpu_dbg_set_mem_monitor(which * 4, start, end, (3 << 8) | r_w | 3);
+}
+EXPORT_SYMBOL(scpu_dbg_scpu_monitor);
diff --git a/drivers/soc/realtek/rtd139x/avcpu.c b/drivers/soc/realtek/rtd139x/avcpu.c
new file mode 100644
index 00000000..0d4b705
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/avcpu.c
@@ -0,0 +1,799 @@
+/*
+ * Realtek Audio & Video cpu driver
+ *
+ * Copyright (c) 2011 EJ Hsu <ejhsu@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License.
+ *
+ * History:
+ *
+ * 2011-12-02:  EJ Hsu: first version
+ * 2013-05-02:  EJ Hsu: port to arm platform
+ */
+
+#include <generated/autoconf.h>
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/device.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/fs.h>
+#include <linux/sched.h>
+#include <linux/platform_device.h>
+#include <linux/mtd/mtd.h>
+#include <linux/delay.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/byteorder/generic.h>
+#include <asm/uaccess.h>
+#include <asm/cacheflush.h>
+#include <asm/io.h>
+#include <soc/realtek/rtk_ipc_shm.h>
+#include <soc/realtek/avcpu.h>
+
+//#define DUBUG_FW_DESC_TABLE
+
+#define DRIVER_NAME "RTK_AVCPU"
+
+
+#define EMMC_FW_TABLE_OFFSET  0x620000
+
+#define HEADER_OFFSET         EMMC_FW_TABLE_OFFSET//0x2000000
+#define EMMC_BLOCK_SIZE       (0x200)
+
+#define MIPS_KSEG0BASE 0x80000000
+
+#define DEVICE_EMMC             1
+#define BLK_READ_SIZE		SZ_256K
+
+static void __iomem *crt_base = NULL;
+static void __iomem *rpc_base = NULL;
+
+#define AVCPU_IPC_SHM	(rpc_base + 0xc4)
+
+#ifdef CONFIG_PM
+static int rtk_avcpu_suspend(struct platform_device *dev, pm_message_t state);
+static int rtk_avcpu_resume(struct platform_device *dev);
+#endif
+
+static BLOCKING_NOTIFIER_HEAD(avcpu_chain_head);
+
+static avcpu_info avpriv;
+static struct class *avcpu_class = NULL;
+static struct cdev avcpu_cdev;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+extern void rtk_xen_acpu_notify(int state);
+#endif //CONFIG_RTK_XEN_SUPPORT
+
+static int avcpu_ipc_shm_reset(void)
+{
+	int ret = 0;
+	struct rtk_ipc_shm old_shm = {0};
+	struct rtk_ipc_shm new_shm = {0};
+
+	memcpy(&old_shm, AVCPU_IPC_SHM, sizeof(struct rtk_ipc_shm));
+
+	/* start to copy some static variable from old shm */
+	new_shm.sys_assign_serial = old_shm.sys_assign_serial;
+	new_shm.pov_boot_vd_std_ptr = old_shm.pov_boot_vd_std_ptr; // maybe this item should be changed since it's one-step info?
+	new_shm.u_boot_version_magic = old_shm.u_boot_version_magic;
+	new_shm.u_boot_version_info = old_shm.u_boot_version_info;
+
+	memcpy_toio(AVCPU_IPC_SHM, &new_shm, sizeof(struct rtk_ipc_shm));
+
+	return ret;
+}
+
+int register_avcpu_notifier(struct notifier_block *nb)
+{
+	return blocking_notifier_chain_register(&avcpu_chain_head, nb);
+}
+EXPORT_SYMBOL_GPL(register_avcpu_notifier);
+
+int unregister_avcpu_notifier(struct notifier_block *nb)
+{
+	return blocking_notifier_chain_unregister(&avcpu_chain_head, nb);
+}
+EXPORT_SYMBOL_GPL(unregister_avcpu_notifier);
+
+int avcpu_notifier_call_chain(unsigned long val)
+{
+	return (blocking_notifier_call_chain(&avcpu_chain_head, val, NULL) == NOTIFY_BAD) ? -EINVAL : 0;
+}
+
+#ifdef CONFIG_PM
+static int rtk_avcpu_suspend(struct platform_device *dev, pm_message_t state)
+{
+	avcpu_notifier_call_chain(AVCPU_SUSPEND);
+	return 0;
+}
+
+static int rtk_avcpu_resume(struct platform_device *dev)
+{
+	avcpu_notifier_call_chain(AVCPU_RESUME);
+	return 0;
+}
+#endif
+
+static int avcpu_reset(resetav_struct *rs)
+{
+	blocking_notifier_call_chain(&avcpu_chain_head, AVCPU_RESET_PREPARE, NULL);
+	load_av_image(rs->audio_image, rs->audio_start,
+			rs->video_image_1, rs->video_start_1, rs->video_image_2, rs->video_start_2);
+	blocking_notifier_call_chain(&avcpu_chain_head, AVCPU_RESET_DONE, NULL);
+	avpriv.status = AVSTAT_NORMAL;
+	pr_info("\033[33m%s:%d status:%d\033[m\n", __func__, __LINE__, avpriv.status);
+	return 0;
+}
+
+static int avcpu_stop(void)
+{
+	unsigned int mask = 0;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	// Notify ACPU if not in idle state
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+	unsigned int reg = __be32_to_cpu(readl(&ipc->xen_domu_boot_st));
+
+	if (XEN_DOMU_BOOT_ST_AUTHOR_GET(reg) != XEN_DOMU_BOOT_ST_AUTHOR_SCPU ||
+		XEN_DOMU_BOOT_ST_STATE_GET(reg) != XEN_DOMU_BOOT_ST_STATE_SCPU_WAIT_DONE) {
+		pr_info("Notify ACPU enter idle before take it off...\n");
+		rtk_xen_acpu_notify(XEN_DOMU_BOOT_ST_STATE_SCPU_POWOFF);
+	}
+#endif //CONFIG_RTK_XEN_SUPPORT
+
+	blocking_notifier_call_chain(&avcpu_chain_head, AVCPU_RESET_PREPARE, NULL);
+
+	/* TBD : r/w clk & rst should how hwsem */
+	writel(0x4, crt_base + 0x264); //PLL_VODMA2
+	writel(0x0, crt_base + 0x24);  //DISP_PLL_DIV2
+	writel(0x0, crt_base + 0x190); //PLL_HDMI
+	wmb();
+
+	/* Turn off CLK */
+	writel(readl(crt_base + 0x10) & ~BIT(4), crt_base + 0x10); //CLK : ACPU
+	mask = ~(unsigned int)(BIT(17) | BIT(15) | BIT(14) | BIT(8));
+	writel(readl(crt_base + 0x0c) & mask, crt_base + 0x0c); //CLK : SE, VO, TVE, HDMI
+	wmb();
+
+	/* Hold RST */
+	/* TBD : ACPU RST is secure register which will failed to operate if S-ON */
+	writel(readl(crt_base + 0x54) & ~BIT(2), crt_base + 0x54); //RST : ACPU
+
+	mask = ~(unsigned int)(BIT(28) | BIT(22) | BIT(20) | BIT(19) | BIT(12));
+	writel(readl(crt_base) & mask, crt_base); // RST : AE, SE, VO, TVE, HDMI
+	writel(readl(crt_base + 0x50) & ~BIT(15), crt_base + 0x50); //RST : DISP
+	wmb();
+	pr_info("\033[33mstop avcpu\033[m\n");
+	return 0;
+}
+
+static int avcpu_start(void)
+{
+	void __iomem *vomap = NULL;
+
+	/* TBD : VO release magic is stored under secure-dummy-reg */
+	if (!(vomap = ioremap(0x98081000, PAGE_SIZE))) {
+		pr_err("Couldn't map VO region!!\n");
+		return -EINVAL;
+	}
+
+	writel(0x3, crt_base + 0x264); //PLL_VODMA2
+	wmb();
+	msleep(50);
+
+	writel(readl(crt_base + 0x50) | BIT(15), crt_base + 0x50); //RST : DISP
+	wmb();
+
+	writel(readl(crt_base) | BIT(20), crt_base); // RST : VO
+	wmb();
+
+	writel(readl(crt_base + 0x0c) | BIT(15), crt_base + 0x0c); //CLK : VO
+	wmb();
+
+	writel(0xacd1, vomap + 0x340);
+	wmb();
+
+	/* TBD : ACPU RST is secure register which will failed to operate if S-ON */
+	writel(readl(crt_base + 0x54) | BIT(2), crt_base + 0x54);
+	wmb();
+	msleep(50);
+	writel(readl(crt_base + 0x10) | BIT(4), crt_base + 0x10);
+	wmb();
+	pr_info("\033[33mstart avcpu\033[m\n");
+
+	iounmap(vomap);
+	return 0;
+}
+
+int avcpu_alive(void)
+{
+	int ret = 0;
+
+	/* TBD : ACPU RST is secure register which will failed to operate if S-ON */
+	ret = !!(readl(crt_base + 0x54) & BIT(2));
+	ret &= !!(readl(crt_base + 0x10) & BIT(4));
+	ret &= !!(readl(crt_base + 0x0c) & BIT(15));
+
+	return ret;
+}
+
+long avcpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	//avcpu_info *info = (avcpu_info *)filp->private_data;
+	resetav_struct rs;
+	int ret = 0;
+	status_struct *st = NULL;
+
+	switch (cmd) {
+		case AVCPU_IOCTRESET:
+			ret = copy_from_user(&rs, (void *)arg, sizeof(rs));
+			if (ret != 0)
+				break;
+			avcpu_reset(&rs);
+			break;
+		case AVCPU_IOCTSTOP:
+			avcpu_stop();
+			break;
+		case AVCPU_IOCTSTART:
+			avcpu_start();
+			break;
+		case AVCPU_IOCGSTATUS:
+			st = (status_struct *)arg;
+			ret = wait_event_interruptible_timeout(avpriv.status_wq, (avpriv.status >= AVSTAT_RESUME), st->timeout * HZ / 1000);
+			st->status = avpriv.status;
+			if(avpriv.status == AVSTAT_RESUME)
+				avpriv.status = AVSTAT_RESETAV;
+			//pr_debug("\033[33m%s:%d status:%d\033[m\n", __func__, __LINE__, avpriv.status);
+			break;
+		case AVCPU_IOCGALIVE:
+			if(!avcpu_alive()) {
+				pr_info("AVCPU not up!\n");
+				ret = -1;
+			}
+			break;
+		default:
+			ret = -EINVAL;
+			break;
+	};
+
+	return ret;
+}
+
+struct file_operations avcpu_fops = {
+	.owner = THIS_MODULE,
+	.unlocked_ioctl = avcpu_ioctl,
+};
+
+static char *avcpu_devnode(struct device *dev, umode_t *mode)
+{
+	return NULL;
+}
+
+static unsigned int get_device_type(void)
+{
+	return DEVICE_EMMC;
+}
+
+static int load_av_from_file(int cpu, char *load_file, unsigned int load_addr)
+{
+	pr_err("avcpu: load from file not supported yet!\n");
+	return -1;
+}
+
+#ifdef CONFIG_MMC_RTK_EMMC
+extern int mmc_fast_read(unsigned int, unsigned int, unsigned char *);
+#else
+int mmc_fast_read( unsigned int blk_addr,
+		unsigned int data_size,
+		unsigned char * buffer )
+{
+	/*TODO : avcpu porting by victor 20140211*/
+	return -1;
+}
+#endif
+
+static int read_emmc_data(unsigned int blk_offset, size_t size, void *buf)
+{
+	int ret = 0;
+	unsigned int blk_end = 0;
+	size_t blk_read_size = 0;
+
+	size = (size + (EMMC_BLOCK_SIZE -1)) & ~(EMMC_BLOCK_SIZE - 1);
+	blk_end = blk_offset + (size / EMMC_BLOCK_SIZE);
+	blk_read_size = BLK_READ_SIZE / EMMC_BLOCK_SIZE;
+	pr_debug("avcpu: %s offset: %x, size: %lx, buf: %p \n", __func__, blk_offset, size / EMMC_BLOCK_SIZE, buf);
+
+	while (blk_offset < blk_end) {
+		if (blk_end - blk_offset < (BLK_READ_SIZE / EMMC_BLOCK_SIZE))
+			blk_read_size = blk_end - blk_offset;
+		if ((ret = mmc_fast_read(blk_offset, blk_read_size, buf)) < 0)
+			break;
+		blk_offset += BLK_READ_SIZE / EMMC_BLOCK_SIZE;
+		buf += BLK_READ_SIZE;
+	}
+
+	return ret;
+}
+
+int read_emmc_data_to_ioremap(unsigned long offset, unsigned int size, void  __iomem *ioptr)
+{
+	int ret = 0;
+	void *buf = NULL;
+	unsigned long read_end = offset + size;
+	unsigned int read_size = 0;
+	unsigned int read_left = 0;
+
+	if (!size) {
+		pr_err("bad size\n");
+		return -EINVAL;
+	}
+
+	if (!ioptr) {
+		pr_err("bad ioptr\n");
+		return -EINVAL;
+	}
+
+	if (!(buf = (void*)__get_free_page(GFP_KERNEL))) {
+		pr_err("couldn't allocate page\n");
+		return -ENOMEM;
+	}
+
+	/* only read 1 PAGE in each iteration since mmc_fast_rw only
+	   supports physical-continuous buffer */
+	do {
+		read_left = read_end - offset;
+		if (read_left >= PAGE_SIZE)
+			read_size = PAGE_SIZE;
+		else
+			read_size = ALIGN(read_left, EMMC_BLOCK_SIZE);
+
+		ret = read_emmc_data(offset / EMMC_BLOCK_SIZE, read_size, buf);
+		if (ret < 0)
+			goto out;
+
+		memcpy_toio(ioptr, buf, PAGE_SIZE);
+		offset += PAGE_SIZE;
+		ioptr += PAGE_SIZE;
+	} while (offset < read_end);
+out:
+	free_page((unsigned long)buf);
+	return ret;
+}
+
+#ifdef DUBUG_FW_DESC_TABLE
+void dump_fw_desc_table_v1(fw_desc_table_v1_t *fw_desc_table_v1)
+{
+	if (fw_desc_table_v1 != NULL) {
+		printk("## Fw Desc Table ##############################\n");
+		printk("## fw_desc_table_v1                = 0x%08lx\n", (unsigned long)fw_desc_table_v1);
+		printk("## fw_desc_table_v1->signature     = %s\n", fw_desc_table_v1->signature);
+		printk("## fw_desc_table_v1->checksum      = 0x%08x\n", fw_desc_table_v1->checksum);
+		printk("## fw_desc_table_v1->version       = 0x%08x\n", fw_desc_table_v1->version);
+		printk("## fw_desc_table_v1->paddings      = 0x%08x\n", fw_desc_table_v1->paddings);
+		printk("## fw_desc_table_v1->part_list_len = 0x%08x\n", fw_desc_table_v1->part_list_len);
+		printk("## fw_desc_table_v1->fw_list_len   = 0x%08x\n", fw_desc_table_v1->fw_list_len);
+		printk("###############################################\n\n");
+	}
+	else {
+		printk("[ERR] %s:%d fw_desc_table_v1 is NULL.\n", __FUNCTION__, __LINE__);
+	}
+}
+
+void dump_part_desc_entry_v1(part_desc_entry_v1_t *part_entry)
+{
+	if (part_entry != NULL) {
+		printk("## Part Desc Entry ############################\n");
+		printk("## part_entry                      = 0x%08lx\n", (unsigned long)part_entry);
+		printk("## part_entry->type                = 0x%08x\n", part_entry->type);
+		printk("## part_entry->ro                  = 0x%08x\n", part_entry->ro);
+		printk("## part_entry->length              = %llu\n", part_entry->length);
+		printk("## part_entry->fw_count            = 0x%08x\n", part_entry->fw_count);
+		printk("## part_entry->fw_type             = 0x%08x\n", part_entry->fw_type);
+		printk("###############################################\n\n");
+	}
+	else {
+		printk("[ERR] %s:%d part_entry is NULL.\n", __FUNCTION__, __LINE__);
+	}
+}
+
+void dump_fw_desc_entry_v1(fw_desc_entry_v1_t *fw_entry)
+{
+	if (fw_entry != NULL) {
+		printk("## Fw Desc Entry ##############################\n");
+		printk("## fw_entry                        = 0x%08lx\n", (unsigned long)fw_entry);
+		printk("## fw_entry->type                  = 0x%08x\n", fw_entry->type);
+		printk("## fw_entry->lzma                  = 0x%08x\n", fw_entry->lzma);
+		printk("## fw_entry->ro                    = 0x%08x\n", fw_entry->ro);
+		printk("## fw_entry->version               = 0x%08x\n", fw_entry->version);
+		printk("## fw_entry->target_addr           = 0x%08x\n", fw_entry->target_addr);
+		printk("## fw_entry->offset                = 0x%08x\n", fw_entry->offset);
+		printk("## fw_entry->length                = 0x%08x\n", fw_entry->length);
+		printk("## fw_entry->paddings              = 0x%08x\n", fw_entry->paddings);
+		printk("## fw_entry->checksum              = 0x%08x\n", fw_entry->checksum);
+		printk("###############################################\n\n");
+	}
+	else {
+		printk("[ERR] %s:%d fw_entry is NULL.\n", __FUNCTION__, __LINE__);
+	}
+}
+
+void dump_fw_desc_entry_v2(fw_desc_entry_v2_t *fw_entry)
+{
+	int i;
+
+	if (fw_entry != NULL) {
+		printf("## Fw Desc Entry ##############################\n");
+		printf("## fw_entry                        = 0x%08x\n", fw_entry);
+		printf("## fw_entry->type                  = 0x%08x\n", fw_entry->type);
+		printf("## fw_entry->lzma                  = 0x%08x\n", fw_entry->lzma);
+		printf("## fw_entry->ro                    = 0x%08x\n", fw_entry->ro);
+		printf("## fw_entry->version               = 0x%08x\n", fw_entry->version);
+		printf("## fw_entry->target_addr           = 0x%08x\n", fw_entry->target_addr);
+		printf("## fw_entry->offset                = 0x%08lx\n", fw_entry->offset);
+		printf("## fw_entry->length                = 0x%08x\n", fw_entry->length);
+		printf("## fw_entry->paddings              = 0x%08x\n", fw_entry->paddings);
+		printf("## fw_entry->sha_hash              = ");
+		for (i = 0 ; i < 32 ; i++)
+			printf("%02x", fw_entry->sha_hash[i]);
+		printf("\n");
+		printf("###############################################\n\n");
+	} else {
+		printf("[ERR] %s:%d fw_entry is NULL.\n", __FUNCTION__, __LINE__);
+	}
+}
+#endif
+
+
+int load_av_from_emmc(char *audio_image, unsigned int audio_start,
+		char *video_image_1, unsigned int video_start_1, char *video_image_2, unsigned int video_start_2)
+{
+	fw_desc_table_v1_t *fw_desc_table_v1;
+	void *fw_entry = NULL, *audio_fw_entry = NULL, *fw_desc_ptr = NULL;
+	part_desc_entry_v1_t *part_entry;
+	unsigned int part_count = 0;
+	unsigned long fw_desc_table_base = 0;
+	unsigned int fw_entry_num = 0;
+	unsigned int fw_entry_size = 0;
+	unsigned char fw_desc_version;
+	unsigned int eMMC_fw_desc_table_start = 0x620000;
+	unsigned char *ptr = NULL;
+	int i, ret = 0;
+	unsigned int __iomem *afwPtr = NULL;
+	/* common data in both V1/V2 */
+	unsigned char entry_type = 0;
+	unsigned int entry_target_addr = 0, audio_fw_target_addr = 0;
+	u64 entry_offset = 0, audio_fw_offset = 0;
+	unsigned int entry_length = 0, audio_fw_length = 0;
+
+	fw_desc_table_base = __get_free_page(GFP_KERNEL);
+	if (!fw_desc_table_base) {
+		pr_info("avcpu: can not allocate enough memory...\n");
+		return -ENOMEM;
+	}
+
+	ret = read_emmc_data(HEADER_OFFSET / EMMC_BLOCK_SIZE, PAGE_SIZE, (void *)fw_desc_table_base);
+	if (ret < 0)
+		goto out;
+
+	fw_desc_table_v1 = (fw_desc_table_v1_t*)fw_desc_table_base;
+	ptr = (unsigned char *)fw_desc_table_base;
+	printk("%.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x\n", ptr[0], ptr[1], ptr[2], ptr[3], ptr[4], ptr[5], ptr[6], ptr[7]); 
+
+	printk("avcpu: fw_desc_table_v1->signature = %s \n", fw_desc_table_v1->signature);
+	printk("avcpu: fw_desc_table_v1->version = 0x%x \n", fw_desc_table_v1->version);
+	printk("avcpu: fw_desc_table_v1->paddings = %d!!\n", fw_desc_table_v1->paddings);
+	fw_desc_version = fw_desc_table_v1->version;
+#ifdef DUBUG_FW_DESC_TABLE
+	dump_fw_desc_table_v1(fw_desc_table_v1);
+#endif
+
+	/* Check partition existence */
+	if (fw_desc_table_v1->part_list_len == 0) {
+		printk("[ERR] %s:No partition found!\n", __func__);
+	} else {
+		part_count = fw_desc_table_v1->part_list_len / sizeof(part_desc_entry_v1_t);
+	}
+
+	printk("avcpu: part_count = %d\n", part_count);
+
+	switch (fw_desc_version) {
+		case FW_DESC_TABLE_V1_T_VERSION_1:
+			fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v1_t);
+			fw_entry_size = sizeof(fw_desc_entry_v1_t);
+			break;
+		case FW_DESC_TABLE_V1_T_VERSION_11:
+			fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v11_t);
+			fw_entry_size = sizeof(fw_desc_entry_v11_t);
+			break;
+		case FW_DESC_TABLE_V1_T_VERSION_21:
+			fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v21_t);
+			fw_entry_size = sizeof(fw_desc_entry_v21_t);
+			break;
+		case FW_DESC_TABLE_V2_T_VERSION_2:
+			fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v2_t);
+			fw_entry_size = sizeof(fw_desc_entry_v2_t);
+			break;
+		case FW_DESC_TABLE_V2_T_VERSION_12:
+			fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v12_t);
+			fw_entry_size = sizeof(fw_desc_entry_v12_t);
+			break;
+		case FW_DESC_TABLE_V2_T_VERSION_22:
+			fw_entry_num = fw_desc_table_v1->fw_list_len / sizeof(fw_desc_entry_v22_t);
+			fw_entry_size = sizeof(fw_desc_entry_v22_t);
+			break;
+		default:
+			printk("**** Error fw_desc_version 0x%x\n", fw_desc_version);
+			ret = RTK_PLAT_ERR_PARSE_FW_DESC;
+			goto out;
+	}
+
+	printk("[INFO] fw desc table base: 0x%08x, count: %d\n", eMMC_fw_desc_table_start, fw_entry_num);
+
+	part_entry = (part_desc_entry_v1_t *)((unsigned long)fw_desc_table_base + sizeof(fw_desc_table_v1_t));
+	fw_entry = (void*)((unsigned long)fw_desc_table_base + sizeof(fw_desc_table_v1_t) + fw_desc_table_v1->part_list_len);
+
+	for (i = 0; i < part_count; i++) {
+		part_entry[i].length = part_entry[i].length;
+		printk("===> i=%d  part_entry[%d].type=%d\n", i, i, part_entry[i].type);
+#ifdef DUBUG_FW_DESC_TABLE
+		dump_part_desc_entry_v1(&(part_entry[i]));
+#endif
+	}
+
+	/* Parse firmware entries and compute fw_total_len */
+	printk("@@@@ fw_desc_table_v1->version = 0x%.8x\n", fw_desc_table_v1->version);
+
+	for (i = 0 ; i < fw_entry_num ; i++) {
+		fw_desc_ptr = (void*)fw_entry + (i * fw_entry_size);
+		FW_ENTRY_MEMBER_GET(entry_type, fw_desc_ptr, type, fw_desc_version);
+		FW_ENTRY_MEMBER_GET(entry_target_addr, fw_desc_ptr, target_addr, fw_desc_version);
+		FW_ENTRY_MEMBER_GET(entry_offset, fw_desc_ptr, offset, fw_desc_version);
+		FW_ENTRY_MEMBER_GET(entry_length, fw_desc_ptr, length, fw_desc_version);
+
+		printk("[OK] fw_entry[%d], type=%d, offset = 0x%lx, length = 0x%x, target_addr:0x%x\n",
+				i, entry_type, (unsigned long)entry_offset, entry_length, entry_target_addr);
+
+		if (entry_type == FW_TYPE_AUDIO) {
+			audio_fw_entry = fw_desc_ptr;
+			audio_fw_target_addr = entry_target_addr;
+			audio_fw_offset = entry_offset;
+			audio_fw_length = entry_length;
+			printk("##### got fw_entry[%d].type == FW_TYPE_AUDIO ###\n", i);
+			printk("avcpu: Audio FW found\n");
+		}
+#ifdef DUBUG_FW_DESC_TABLE
+		if (FW_DESC_BASE_VERSION(fw_desc_version) == 1)
+			dump_fw_desc_entry_v1((fw_desc_entry_v1_t*)fw_desc_ptr);
+		else if (FW_DESC_BASE_VERSION(fw_desc_version) == 2)
+			dump_fw_desc_entry_v2((fw_desc_entry_v2_t*)fw_desc_ptr);
+#endif //DUBUG_FW_DESC_TABLE
+	}
+
+	printk("====> audio_image=0x%.8lx audio_start=0x%.8x\n", (unsigned long)audio_image, audio_start);
+
+	if (audio_image) {
+		if ((ret = load_av_from_file(AUDIO_CPU, audio_image, audio_start))) {
+			printk("avcpu: load audio image error %d...\n", ret);
+			goto out;
+		}
+	} else {
+		if (audio_fw_entry == NULL) {
+			printk("avcpu: can not find audio firmware from NAND flash...\n");
+			ret = -ENODEV;
+			goto out;
+		}
+
+		printk("avcpu: audio_fw_entry->offset = 0x%lx \n", (unsigned long)audio_fw_offset);
+		printk("avcpu: audio_fw_entry->length = 0x%x \n", audio_fw_length);
+		printk("avcpu: audio_fw_entry->target_addr = 0x%x \n", audio_fw_target_addr);
+
+		// currently we only support align access...
+		if (audio_fw_offset & (EMMC_BLOCK_SIZE - 1))
+			BUG();
+
+#ifdef CONFIG_RTK_IPCSHM_RESET // perform IPC_SHM reset before setting entry value
+		printk("avcpu: reseting IPC share-mem\n");
+
+		if ((ret = avcpu_ipc_shm_reset()) != 0) {
+			pr_err("avcpu: error occured during reset IPC_SHM\n");
+			goto out;
+		}
+#endif
+		writel(cpu_to_be32(audio_fw_target_addr | MIPS_KSEG0BASE), rpc_base + 0xe0);
+		printk("audio entry value: %08x \n", *((unsigned int *)(rpc_base + 0xe0)));
+
+		if (!(afwPtr = ioremap(audio_fw_target_addr, audio_fw_length))) {
+			pr_err("avcpu: ioremap fail for ACPU FW region!\n");
+			ret = -EFAULT;
+			goto out;
+		}
+
+		ret = read_emmc_data_to_ioremap(audio_fw_offset, audio_fw_length, (void *)(afwPtr));
+
+		if (ret < 0)
+			goto out;
+
+		printk("ret: %x length: %x \n", ret * EMMC_BLOCK_SIZE, audio_fw_length);
+
+		if (FW_DESC_EXT_VERSION(fw_desc_version) != 0) {
+			printk("%s, extend version 0x%x, not supported YET!!\n", __func__, FW_DESC_EXT_VERSION(fw_desc_version));
+			ret = RTK_PLAT_ERR_PARSE_FW_DESC;
+			goto out;
+		}
+	}
+
+out:
+	free_page(fw_desc_table_base);
+
+	if (afwPtr)
+		iounmap(afwPtr);
+
+	return ret;
+}
+
+int load_av_image(char *audio_image, unsigned int audio_start,
+		char *video_image_1, unsigned int video_start_1, char *video_image_2, unsigned int video_start_2)
+{
+	unsigned int flash_type;
+	int ret;
+
+	flash_type = get_device_type();
+	printk("avcpu: flash_type: %d \n", flash_type);
+
+	// load firmware image
+	if ((audio_image != 0) && (video_image_1 != 0) && (video_image_2 != 0)) {
+		if ((ret = load_av_from_file(AUDIO_CPU, audio_image, audio_start)))
+			printk("avcpu: load audio image error %d...\n", ret);
+	} else if (flash_type == DEVICE_EMMC) {
+		load_av_from_emmc(audio_image, audio_start, video_image_1, video_start_1, video_image_2, video_start_2);
+	} else {
+		printk("avcpu: unsupported operation...\n");
+		BUG();
+	}
+
+	return 0;
+}
+
+static ssize_t store_reset_cmd(struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+	unsigned long val;
+	char *endp;
+
+	if(count == 0)
+		return -EINVAL;
+
+	val = simple_strtoul(buf, &endp, 16);
+
+	if(endp == buf)
+		return -EINVAL;
+
+	if(val != 0x20141209)
+		return -EINVAL;
+
+	avpriv.status = AVSTAT_RESUME;
+	pr_info("\033[33m%s status:%d\033[m\n", __func__, avpriv.status);
+	wake_up_interruptible(&avpriv.status_wq);
+
+	return count;
+}
+
+static DEVICE_ATTR(reset, S_IWUSR, NULL, store_reset_cmd);
+
+static int rtk_avcpu_probe(struct platform_device *pdev)
+{
+	int result;
+	struct device *avdev = NULL;
+	struct device_node *node = NULL;
+	dev_t dev = MKDEV(AVCPU_MAJOR, 0);
+
+	printk("avcpu: audio & video cpu driver for Realtek Media Processors\n");
+
+	node = of_get_child_by_name(pdev->dev.of_node, "crt");
+
+	if (!(crt_base = of_iomap(node, 0))) {
+		pr_err("avcpu: ioremap CRT fail!\n");
+		result = -EFAULT;
+		goto fail_iomap;
+	}
+
+	node = of_get_child_by_name(pdev->dev.of_node, "rpc");
+
+	if (!(rpc_base = of_iomap(node, 0))) {
+		pr_err("avcpu: ioremap CRT fail!\n");
+		result = -EFAULT;
+		goto fail_iomap;
+	}
+
+	result = register_chrdev_region(dev, 1, "avcpu");
+
+	if (result) {
+		printk("avcpu: can not get chrdev region...\n");
+		result = -EFAULT;
+		goto fail_cdev_reg;
+	}
+
+	cdev_init(&avcpu_cdev, &avcpu_fops);
+	avcpu_cdev.owner = THIS_MODULE;
+	result = cdev_add(&avcpu_cdev, dev, 1);
+
+	if (result) {
+		printk("avcpu: can not add character device...\n");
+		result = -EFAULT;
+		goto fail_cdev_init;
+	}
+
+	avcpu_class = class_create(THIS_MODULE, "avcpu");
+
+	if (IS_ERR(avcpu_class)) {
+		printk("avcpu: can not create class...\n");
+		result = PTR_ERR(avcpu_class);
+		goto fail_class_create;
+	}
+
+	avcpu_class->devnode = avcpu_devnode;
+	avdev = device_create(avcpu_class, NULL, dev, NULL, "avcpu");
+	device_create_file(avdev, &dev_attr_reset);
+	memset(&avpriv, 0, sizeof(avpriv));
+	init_waitqueue_head(&avpriv.status_wq);
+
+	return 0;
+
+fail_class_create:
+	class_destroy(avcpu_class);
+	avcpu_class = NULL;
+fail_cdev_init:
+	unregister_chrdev_region(dev, 1);
+fail_cdev_reg:
+fail_iomap:
+	if (crt_base)
+		iounmap(crt_base);
+	if (rpc_base)
+		iounmap(rpc_base);
+
+	return result;
+}
+
+static int rtk_avcpu_remove(struct platform_device *pdev)
+{
+	dev_t dev = MKDEV(AVCPU_MAJOR, 0);
+
+	if (crt_base)
+		iounmap(crt_base);
+
+	if (rpc_base)
+		iounmap(rpc_base);
+
+	device_destroy(avcpu_class, dev);
+	cdev_del(&avcpu_cdev);
+	class_destroy(avcpu_class);
+	avcpu_class = NULL;
+	unregister_chrdev_region(dev, 1);
+
+	return 0;
+}
+
+static struct of_device_id rtk_avcpu_ids[] = {
+	{ .compatible = "Realtek,rtk-avcpu" },
+	{ /* Sentinel */ },
+};
+
+static struct platform_driver rtk_avcpu_driver = {
+	.probe = rtk_avcpu_probe,
+	.remove = rtk_avcpu_remove,
+#ifdef CONFIG_PM
+	.suspend = rtk_avcpu_suspend,
+	.resume = rtk_avcpu_resume,
+#endif
+	.driver = {
+		.name = DRIVER_NAME,
+		.bus = &platform_bus_type,
+		.owner = THIS_MODULE,
+		.of_match_table = of_match_ptr(rtk_avcpu_ids),
+	},
+};
+
+module_platform_driver(rtk_avcpu_driver);
+
diff --git a/drivers/soc/realtek/rtd139x/rtd139x_cpu_hotplug.S b/drivers/soc/realtek/rtd139x/rtd139x_cpu_hotplug.S
new file mode 100755
index 00000000..f6d4424
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtd139x_cpu_hotplug.S
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/linkage.h>
+#include <asm/assembler.h>
+#include <asm/sysreg.h>
+#include <asm/virt.h>
+
+#define SCTLR_ELx_I (1 << 12)
+#define SCTLR_ELx_SA (1 << 3)
+#define SCTLR_ELx_C (1 << 2)
+#define SCTLR_ELx_A (1 << 1)
+
+#define SCTLR_ELx_FLAGS (SCTLR_ELx_M | SCTLR_ELx_A | SCTLR_ELx_C | SCTLR_ELx_SA | SCTLR_ELx_I)
+
+	.text
+	.pushsection .idmap.text, "ax"
+
+ENTRY(__cpu_do_lowpower)
+	/* Clear sctlr_el1 flags. */
+	mrs x12, sctlr_el1
+	ldr x13, =0xEFF1 /* SCTLR_ELx_FLAGS */
+	and x12, x12, x13
+	msr sctlr_el1, x12
+	isb
+	mrs x12, S3_1_C15_C2_1
+	bic x12, x12, #0x0040 //Disable CPUECTLR.SMP bit
+	msr S3_1_C15_C2_1, x12
+	isb
+	dsb sy
+loop:
+	wfi
+	bl loop
+ENDPROC(__cpu_do_lowpower)
+
+	.popsection
diff --git a/drivers/soc/realtek/rtd139x/rtd139x_cpu_wrapper.c b/drivers/soc/realtek/rtd139x/rtd139x_cpu_wrapper.c
new file mode 100644
index 00000000..19aa5be
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtd139x_cpu_wrapper.c
@@ -0,0 +1,339 @@
+/*
+ * rtd139x_cpu_wrapper.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/delay.h>
+#include <linux/debugfs.h>
+#include <linux/init.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <linux/delay.h>
+#include <asm/io.h>
+#include <asm/cacheflush.h>
+#include <asm/cpu_ops.h>
+#include <asm/cputype.h>
+#include <asm/io.h>
+#include <asm/smp_plat.h>
+
+#include <asm/system_misc.h>
+
+#include "../common/include/debug.h"
+
+#define DBG_INT 0x230
+#define DBG_ADDR 0x234
+#define DBG_ADDR_MODE 0x238
+
+#define CR_M (1 << 0) /* MMU enable */
+#define CR_C (1 << 2) /* Dcache enable */
+
+static void __iomem *scpu_wrap_addr;
+
+static inline unsigned int current_el(void)
+{
+	unsigned int el;
+
+	asm volatile("mrs %0, CurrentEL" : "=r" (el) : : "cc");
+	return el >> 2;
+}
+
+static inline void set_sctlr(unsigned int val)
+{
+	unsigned int el;
+	el = current_el();
+
+	if (el == 1)
+		asm volatile("msr sctlr_el1, %0" : : "r" (val) : "cc");
+	else if (el == 2)
+		asm volatile("msr sctlr_el2, %0" : : "r" (val) : "cc");
+	else
+		asm volatile("msr sctlr_el3, %0" : : "r" (val) : "cc");
+
+	asm volatile("isb");
+}
+
+static inline unsigned int get_sctlr(void)
+{
+	unsigned int el, val;
+	el = current_el();
+
+	if (el == 1)
+		asm volatile("mrs %0, sctlr_el1" : "=r" (val) : : "cc");
+	else if (el == 2)
+		asm volatile("mrs %0, sctlr_el2" : "=r" (val) : : "cc");
+	else
+		asm volatile("mrs %0, sctlr_el3" : "=r" (val) : : "cc");
+	return val;
+}
+
+void dcache_disable(void)
+{
+	u32 sctlr;
+	sctlr = get_sctlr();
+
+	/* if cache isn't enabled no need to disable */
+	if (!(sctlr & CR_C) && !(sctlr & CR_M))
+		return;
+
+	set_sctlr(sctlr & ~(CR_C|CR_M));
+	flush_cache_all();
+}
+
+void _rtk_cpu_power_up(int cpu){
+
+	u32 tmp = 0;
+
+	/* 5. Wait for SMPEN to be set */
+
+	/* 6. Assert DBGPWRDUP HIGH to allow external debug
+	 * access to the core. */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp |= 1UL << (24 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x100);
+}
+EXPORT_SYMBOL(_rtk_cpu_power_up);
+
+void rtk_cpu_power_up(int cpu)
+{
+	u32 tmp = 0;
+
+	/* 1. Assert nCPUPORESET LOW. Ensure DBGPWRDUP is held LOW to prevent
+	 * any external debug access to the core. */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp &= ~(1UL << (24 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x100);
+
+	/* 2. Apply power to the PDCPU power domain. Keep the state of the
+	 * signals nCPUPORESET and DBGPWRDUP LOW. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (4 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (8 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	mdelay(3);
+
+	tmp = readl(scpu_wrap_addr + 0x53C);
+	if((unlikely((tmp >> (4 + cpu)) & 0x1) != 0x1)) {
+		pr_err("%s: 0x9801D53C = %x\n", __func__, readl(scpu_wrap_addr + 0x53C));
+	}
+
+	/* 3. Release the core output clamps */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (0 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* 4. Dessert resets: nCOREPORESET, nCORERESET */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp |= 1UL << (0 + cpu);
+	tmp |= 1UL << (4 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x100);
+}
+EXPORT_SYMBOL(rtk_cpu_power_up);
+
+void rtk_cpu_power_down(int cpu)
+{
+	u32 tmp = 0;
+
+	/* Step 1 to 6 is done in rtd139x_cpu_hotplug.S
+	 * Wait for WFI in step 6. */
+	tmp = readl(scpu_wrap_addr + 0x104);
+	if (unlikely(((tmp >> cpu) & 0x1) != 0x1)) {
+		pr_err("%s: Processor is not in WFI standby mode.\n", __func__);
+		pr_err("0x9801D104 = %x\n", readl(scpu_wrap_addr + 0x104));
+	}
+
+	/* 7. Dessert DBGPWRDUP LOW.
+	 * This prevents any external debug access to the core. */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp &= ~(1UL << (24 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x100);
+
+	/* 8. Activate the core output clamps. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (0 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* 9. Assert nCPUPORESET LOW */
+	tmp = readl(scpu_wrap_addr + 0x100);
+	tmp &= ~(1UL << (0 + cpu));
+	tmp &= ~(1UL << (4 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x100);
+
+	/* 10. Remove power from the PDCPU power domain. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (4 + cpu));
+	tmp &= ~(1UL << (8 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+}
+EXPORT_SYMBOL(rtk_cpu_power_down);
+
+static int set_l4_icg(void *base)
+{
+	unsigned int val;
+
+	val = readl(scpu_wrap_addr + 0x000);
+	val |= 0xFF3C0000;
+	writel(val, scpu_wrap_addr + 0x000);
+
+	val = readl(scpu_wrap_addr + 0x100);
+	val |= 0x8000000;
+	writel(val, scpu_wrap_addr + 0x100);
+
+	return 0;
+}
+
+static int arm_pmu_int_enable(void *base)
+{
+	unsigned int val;
+
+	val = readl(base + 0x120);
+	val |= 0xf;
+	writel(val, base + 0x120);
+
+	return 0;
+}
+
+
+irqreturn_t scpu_wrapper_isr(int irq, void *reg_base)
+{
+	struct pt_regs *regs;
+	u32 intr = readl(scpu_wrap_addr + DBG_INT);
+	u32 addr = readl(scpu_wrap_addr + DBG_ADDR);
+	u32 cause = readl(scpu_wrap_addr + DBG_ADDR_MODE);
+	char buf[128];
+
+	regs = get_irq_regs();
+
+	dbg_err("scpu wrapper get int 0x%08x", intr);
+	if(intr & (BIT(4) | BIT(2))){
+		writel((intr & ~(BIT(3)|BIT(1))), scpu_wrap_addr + DBG_INT);
+		dbg_err("scpu addr:0x%08x mode:%s", addr, (cause & 1) ? "W" : "R");
+
+		sprintf(buf, "[SCUP] Memory 0x%08x trashed with %s\n", addr,
+				(cause & 1) ? "W" : "R");
+		die(buf, regs, 0);
+
+		return IRQ_HANDLED;
+	}
+
+	return IRQ_NONE;
+}
+
+static const struct of_device_id rtk_scpu_wrapper_ids[] __initconst = {
+	{.compatible = "Realtek,rtk-scpu_wrapper"},
+	{},
+};
+
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w);
+
+static int __init scpu_wrapper_init(void)
+{
+	struct device_node *np;
+	int irq = 0;
+	int i = 0;
+
+	np = of_find_matching_node(NULL, rtk_scpu_wrapper_ids);
+	if(unlikely(np == NULL))
+		return -1;
+
+	irq = irq_of_parse_and_map(np, 0);
+
+	scpu_wrap_addr = of_iomap(np, 0);
+	dbg_info("scpu wrappee irq %d, scpu_wrap_addr 0x%08llx\n", irq, (u64)scpu_wrap_addr);
+
+	of_node_put(np);
+
+	if(request_irq(irq, scpu_wrapper_isr, IRQF_SHARED, "scpu_wrapper", scpu_wrap_addr) != 0){
+		dbg_err("Cannot get IRQ\n");
+		return -1;
+	}
+
+	/* clear dbg trap addr*/
+	for(i = 0 ; i < 8 ; i++ )
+		writel(0, scpu_wrap_addr + 0x200 + i * 4);
+	writel(0x98000000, scpu_wrap_addr + 0x200);	// 1st set start
+	writel(0x98000040, scpu_wrap_addr + 0x210);	// 1st set end
+
+	writel(0x98000040, scpu_wrap_addr + 0x204);	// 2nd set start
+	writel(0x98000080, scpu_wrap_addr + 0x214);	// 2nd set end
+
+	writel(0x98000080, scpu_wrap_addr + 0x208);	// 3th set start
+	writel(0x980000c0, scpu_wrap_addr + 0x218);	// 3th set end
+
+	writel(0x980000c0, scpu_wrap_addr + 0x20c);	// 4th set start
+	writel(0x98000100, scpu_wrap_addr + 0x21c);	// 4th set end
+
+	writel(0x9, scpu_wrap_addr + DBG_INT);	// enable interrupt
+
+	printk(KERN_INFO "[SCPU_WRAPPER] initialized\n");
+
+	printk(KERN_INFO "[SCPU_WRAPPER][%s] memory monitor 0x98013b00 - 0x98013c00\n",__FUNCTION__);
+	scpu_dbg_scpu_monitor(0, 0x98013b00, 0x98013c00, 0x0);
+
+	set_l4_icg(scpu_wrap_addr);
+	arm_pmu_int_enable(scpu_wrap_addr);
+
+	return 0;
+}
+late_initcall(scpu_wrapper_init);
+
+void scpu_dbg_disable_mem_monitor(int which)
+{
+	void __iomem  *reg_ctrl;
+
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220);
+	reg_ctrl += which;
+	writel((1 << 13) | (1 << 9) | (1 << 1), reg_ctrl);
+}
+EXPORT_SYMBOL(scpu_dbg_disable_mem_monitor);
+
+static void scpu_dbg_set_mem_monitor(int which, u32 start, u32 end, u32 flags)
+{
+	void __iomem  *reg_start;
+	void __iomem  *reg_end;
+	void __iomem  *reg_ctrl;
+
+	/* disable this set first */
+	scpu_dbg_disable_mem_monitor(which);
+
+	reg_start = (void __iomem  *)(scpu_wrap_addr + 0x200 + which);
+	reg_end = (void __iomem  *)(scpu_wrap_addr + 0x210 + which);
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220 + which);
+
+	writel(start, reg_start);
+	writel(end, reg_end);
+
+	writel(flags, reg_ctrl);
+}
+
+/*
+ * which: 0~7, which register set
+ * d_i: SB2_DBG_MONITOR_DATA|SB2_DBG_MONITOR_INST
+ * r_w: SB2_DBG_MONITOR_READ|SB2_DBG_MONITOR_WRITE
+ */
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w)
+{
+	scpu_dbg_set_mem_monitor(which * 4, start, end, (3 << 8) | r_w | 3);
+}
+EXPORT_SYMBOL(scpu_dbg_scpu_monitor);
diff --git a/drivers/soc/realtek/rtd139x/rtd139x_restart.c b/drivers/soc/realtek/rtd139x/rtd139x_restart.c
new file mode 100644
index 00000000..a03f291
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtd139x_restart.c
@@ -0,0 +1,215 @@
+/*
+ * rtd139x_restart.c - restart function
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <soc/realtek/rtk_rstctl.h>
+#include <soc/realtek/rtk_wdt.h>
+
+#include <asm/system_misc.h>
+
+static void __iomem * wdt_base;
+static int wdt_oe;
+static void __iomem * rst_ctrl_base;
+unsigned int rst_ctrl_reg_offset = 0;
+
+#define WDT_CLR 4
+#define WDT_CTL 0
+#define WDT_OVERFLOW 0xC
+#define WDT_NMI 8
+
+static void setup_restart_action(RESET_ACTION action)
+{
+	unsigned int reset_action = RESET_MAGIC;
+
+	if (!rst_ctrl_base) {
+		pr_err("%s, Skip set reset action\n", __func__);
+		return;
+	}
+
+	reset_action |= action;
+	writel(reset_action, rst_ctrl_base + rst_ctrl_reg_offset);
+}
+
+void rtk_machine_restart(char mode, const char *cmd)
+{
+	if (cmd) {
+		set_wdt_oe();
+
+		if (!strncmp("bootloader", cmd, 11)) {
+			setup_restart_action(RESET_ACTION_FASTBOOT);
+		} else if (!strncmp("recovery", cmd, 9)) {
+			setup_restart_action(RESET_ACTION_RECOVERY);
+#ifdef CONFIG_RTK_VMX_ULTRA
+		} else if (!strncmp("dm-verity device corrupted", cmd, 27)) {
+			setup_restart_action(RESET_ACTION_RESCUE);
+#endif
+		} else {
+			setup_restart_action(RESET_ACTION_NO_ACTION);
+		}
+	} else {
+		setup_restart_action(RESET_ACTION_NO_ACTION);
+	}
+
+	writel(BIT(0), wdt_base + WDT_CLR);
+	writel(0x00800000, wdt_base + WDT_OVERFLOW);
+	writel(0x000000FF, wdt_base + WDT_CTL);
+
+	while (1)
+		mdelay(100);
+}
+
+static struct of_device_id rtk_restart_ids[] = {
+	{.compatible = "realtek,rtk-watchdog", .data = rtk_machine_restart},
+	{}
+};
+
+static struct of_device_id rtk_reset_control_ids[] = {
+	{.compatible = "Realtek,rtk-rstctrl"},
+	{}
+};
+
+static int rtk_setup_restart(void)
+{
+	const struct of_device_id *of_id;
+	struct device_node *np;
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (xen_domain() && !xen_initial_domain()) {
+		pr_info("%s: skip under DomU\n", __func__);
+		return 0;
+	}
+#endif
+	/* setup Watchdog */
+	np = of_find_matching_node(NULL, rtk_restart_ids);
+	if (WARN(!np, "Unable to setup watchdog restart"))
+		return 1;
+
+	wdt_base = of_iomap(np, 0);
+	WARN(!wdt_base, "failed to map IO base for watchdog");
+
+	if (of_property_read_u32_index(np, "rst-oe", 0, &wdt_oe))
+		wdt_oe = -1;
+
+	of_id = of_match_node(rtk_restart_ids, np);
+	WARN(!of_id, "restart not available");
+
+	arm_pm_restart = of_id->data;
+
+	/* setup Reset Control */
+	np = of_find_matching_node(NULL, rtk_reset_control_ids);
+	if (WARN(!np, "Unable to setup reset-control"))
+		return 1;
+
+	rst_ctrl_base = of_iomap(np, 0);
+	WARN(!rst_ctrl_base, "failed to map IO base for reset-control");
+
+	if (of_property_read_u32_index(np, "rst-reg-offset", 0, &rst_ctrl_reg_offset)) {
+		pr_err("reset-control rst-reg-offset not defined");
+		rst_ctrl_base = NULL;
+		return 1;
+	}
+
+	printk("rst-control : base %p, offset 0x%x\n", rst_ctrl_base, rst_ctrl_reg_offset);
+	setup_restart_action(RESET_ACTION_ABNORMAL);
+
+	return 0;
+}
+
+arch_initcall(rtk_setup_restart);
+
+#if defined(CONFIG_RTK_XEN_SUPPORT) && defined(CONFIG_RTK_RPC)
+#include <xen/xen.h>
+#include <xen/xen-ops.h>
+#include <soc/realtek/rtk_ipc_shm.h>
+
+void rtk_xen_acpu_notify(int state)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+	unsigned int reg = __be32_to_cpu(readl(&ipc->xen_domu_boot_st));
+	int ret = -1, max_loop = 10;
+	if ((XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK & reg) != XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK) {
+		pr_err("[%s] Magic ERR!\n", __func__);
+		goto err;
+	}
+
+	reg = 0;
+	reg |= XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK;
+	reg |= XEN_DOMU_BOOT_ST_VERSION_SET(XEN_DOMU_BOOT_ST_VERSION);
+	reg |= XEN_DOMU_BOOT_ST_AUTHOR_SET(XEN_DOMU_BOOT_ST_AUTHOR_SCPU);
+	reg |= XEN_DOMU_BOOT_ST_STATE_SET(state);
+	writel(__cpu_to_be32(reg), &ipc->xen_domu_boot_st);
+
+	do {
+		reg = __be32_to_cpu(readl(&ipc->xen_domu_boot_st));
+		if (XEN_DOMU_BOOT_ST_AUTHOR_GET(reg) == XEN_DOMU_BOOT_ST_AUTHOR_ACPU &&
+		    XEN_DOMU_BOOT_ST_STATE_GET(reg) == XEN_DOMU_BOOT_ST_STATE_ACPU_ENTER_IDLE)
+			break;
+
+		if (max_loop-- <= 0) {
+			pr_err("[%s] Timeout waiting ACPU respond!\n", __func__);
+			goto err;
+		}
+
+		 mdelay(100);
+	} while(1);
+
+	reg = 0;
+	reg |= XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK;
+	reg |= XEN_DOMU_BOOT_ST_VERSION_SET(XEN_DOMU_BOOT_ST_VERSION);
+	reg |= XEN_DOMU_BOOT_ST_AUTHOR_SET(XEN_DOMU_BOOT_ST_AUTHOR_SCPU);
+	reg |= XEN_DOMU_BOOT_ST_STATE_SET(XEN_DOMU_BOOT_ST_STATE_SCPU_WAIT_DONE);
+	writel(__cpu_to_be32(reg), &ipc->xen_domu_boot_st);
+
+	ret = 0;
+err:
+	if (ret)
+		printk("[%s] Error! xen_domu_boot_st=0x%08x\n", __func__, reg);
+	return;
+}
+
+void rtk_xen_restart_notify(void)
+{
+	rtk_xen_acpu_notify(XEN_DOMU_BOOT_ST_STATE_SCPU_RESTART);
+}
+
+void rtk_xen_power_off_notify(void)
+{
+	rtk_xen_acpu_notify(XEN_DOMU_BOOT_ST_STATE_SCPU_POWOFF);
+}
+
+static int rtk_xen_setup_restart(void)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+	unsigned int reg = 0;
+
+	if (xen_initial_domain())
+		return 0;
+
+	reg |= XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK;
+	reg |= XEN_DOMU_BOOT_ST_VERSION_SET(XEN_DOMU_BOOT_ST_VERSION);
+	reg |= XEN_DOMU_BOOT_ST_AUTHOR_SET(XEN_DOMU_BOOT_ST_AUTHOR_SCPU);
+	reg |= XEN_DOMU_BOOT_ST_STATE_SET(XEN_DOMU_BOOT_ST_STATE_SCPU_BOOT);
+	writel(__cpu_to_be32(reg), &ipc->xen_domu_boot_st);
+
+	xen_pre_restart = rtk_xen_restart_notify;
+	xen_pre_power_off = rtk_xen_power_off_notify;
+	return 0;
+}
+
+late_initcall(rtk_xen_setup_restart);
+#endif /* End of CONFIG_RTK_XEN_SUPPORT && CONFIG_RTK_RPC */
diff --git a/drivers/soc/realtek/rtd139x/rtd139x_spin_table.c b/drivers/soc/realtek/rtd139x/rtd139x_spin_table.c
new file mode 100755
index 00000000..96489a6
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtd139x_spin_table.c
@@ -0,0 +1,202 @@
+/*
+ * rtd139x_spin_table.c - boot method
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/delay.h>
+#include <linux/init.h>
+#include <linux/of.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/delay.h>
+#include <linux/printk.h>
+#include <asm/io.h>
+
+#include <asm/cacheflush.h>
+#include <asm/cpu_ops.h>
+#include <asm/cputype.h>
+#include <asm/io.h>
+#include <asm/smp_plat.h>
+
+#ifdef CONFIG_SMP
+
+extern void rtk_cpu_power_up(int cpu);
+extern void _rtk_cpu_power_up(int cpu);
+extern void secondary_holding_pen(void);
+
+void __cpu_do_lowpower(void);
+
+volatile unsigned long rtk_secondary_holding_pen_release = INVALID_HWID;
+
+static phys_addr_t cpu_release_addr[NR_CPUS];
+static int cpu_hotplug[NR_CPUS] = {0};
+/*
+ * Write rtk_secondary_holding_pen_release in a way that is guaranteed to be
+ * visible to all observers, irrespective of whether they're taking part
+ * in coherency or not.  This is necessary for the hotplug code to work
+ * reliably.
+ */
+static void write_pen_release(u64 val)
+{
+	void *start = (void *)&rtk_secondary_holding_pen_release;
+	unsigned long size = sizeof(rtk_secondary_holding_pen_release);
+
+	rtk_secondary_holding_pen_release = val;
+	__flush_dcache_area(start, size);
+}
+
+static int smp_spin_table_cpu_init(unsigned int cpu)
+{
+
+	struct device_node *dn;
+
+	dn = of_get_cpu_node(cpu, NULL);
+	if (!dn)
+		return -ENODEV;
+
+	/*
+	 * Determine the address from which the CPU is polling.
+	 */
+
+	if(of_property_read_u64(dn, "cpu-release-addr", &cpu_release_addr[cpu])){
+		pr_err("CPU %d: missing or invalid cpu-release-addr property\n", cpu);
+		return -1;
+	}
+
+	return 0;
+}
+
+static int smp_spin_table_cpu_prepare(unsigned int cpu)
+{
+	__le64 __iomem *release_addr;
+
+	/*
+	 * The cpu-release-addr may or may not be inside the linear mapping.
+	 * As ioremap_cache will either give us a new mapping or reuse the
+	 * existing linear mapping, we can use it to cover both cases. In
+	 * either case the memory will be MT_NORMAL.
+	 */
+
+	release_addr = ioremap(cpu_release_addr[cpu], sizeof(*release_addr));
+
+	if (!release_addr)
+		return -ENOMEM;
+
+	/*
+	 * We write the release address as LE regardless of the native
+	 * endianess of the kernel. Therefore, any boot-loaders that
+	 * read this address need to convert this address to the
+	 * boot-loader's endianess before jumping. This is mandated by
+	 * the boot protocol.
+	 */
+	writel_relaxed(__pa(secondary_holding_pen), release_addr);
+
+	__flush_dcache_area((__force void *)release_addr, sizeof(*release_addr));
+
+	/*
+	 * Send an event to wake up the secondary CPU.
+	 */
+	sev();
+
+	iounmap(release_addr);
+
+	return 0;
+}
+
+static int smp_spin_table_cpu_boot(unsigned int cpu)
+{
+	if(cpu_hotplug[cpu] == 1){
+		__le64 __iomem *release_addr;
+		release_addr = ioremap(cpu_release_addr[cpu], sizeof(*release_addr));
+
+		rtk_cpu_power_up(cpu);
+
+		_rtk_cpu_power_up(cpu);
+
+		writel_relaxed(__pa(secondary_holding_pen), release_addr);
+
+		__flush_dcache_area((__force void *)release_addr, sizeof(*release_addr));
+
+		smp_send_reschedule(cpu);
+		iounmap(release_addr);
+	}
+
+	/*
+	 * Update the pen release flag.
+	 */
+	write_pen_release(cpu_logical_map(cpu));
+
+	/*
+	 * Send an event, causing the secondaries to read pen_release.
+	 */
+
+	sev();
+	return 0;
+}
+
+#ifdef CONFIG_HOTPLUG_CPU
+static int smp_spin_table_cpu_disable(unsigned int cpu)
+{
+	if (!cpu_release_addr[cpu])
+		return -EOPNOTSUPP;
+
+	return 0;
+}
+
+static void smp_spin_table_cpu_die(unsigned int cpu)
+{
+#ifndef CONFIG_RTK_VMX_ULTRA
+	/*
+	 * Set the fake core0 resume address to BL31
+	 * to let Bl31 know slave cpu will resume
+	 */
+	asm volatile("isb" : : : "cc");
+	asm volatile("ldr x1, =0x20000" : : : "cc");
+	asm volatile("ldr x0, =0x8400ff04" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+#else
+	__le64 __iomem *cpu0_resume_addr;
+	cpu0_resume_addr = ioremap(0x98007660, sizeof(*cpu0_resume_addr));
+	if (!cpu0_resume_addr)
+		pr_err("smp_spin_table_cpu_die - fail to ioremap\n");
+	writel_relaxed(0x20000, cpu0_resume_addr);
+	__flush_dcache_area((__force void *)cpu0_resume_addr, sizeof(*cpu0_resume_addr));
+	iounmap(cpu0_resume_addr);
+#endif
+
+	cpu_hotplug[cpu] = 1;
+	flush_cache_all();
+	setup_mm_for_reboot();
+	__cpu_do_lowpower();
+}
+#endif
+
+const struct cpu_operations rtk_smp_spin_table_ops = {
+	.name = "rtk-spin-table",
+	.cpu_init = smp_spin_table_cpu_init,
+	.cpu_prepare = smp_spin_table_cpu_prepare,
+	.cpu_boot = smp_spin_table_cpu_boot,
+#ifdef CONFIG_HOTPLUG_CPU
+	.cpu_disable = smp_spin_table_cpu_disable,
+	.cpu_die = smp_spin_table_cpu_die,
+#endif
+};
+
+#endif /* CONFIG_SMP */
diff --git a/drivers/soc/realtek/rtd139x/rtd139x_suspend.c b/drivers/soc/realtek/rtd139x/rtd139x_suspend.c
new file mode 100755
index 00000000..6575723
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtd139x_suspend.c
@@ -0,0 +1,1807 @@
+/*
+ * rtd139x_suspend.c - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/pm.h>
+#include <linux/suspend.h>
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/cpu.h>
+#include <linux/delay.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/reboot.h>
+#include <linux/clocksource.h>
+#include <linux/clockchips.h>
+#include <linux/cpu_pm.h>
+#include <linux/vmalloc.h>
+#include <linux/tick.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/irqchip/arm-gic.h>
+#include <linux/cpumask.h>
+#include <asm/system_misc.h>
+#include <asm/cacheflush.h>
+#include <asm/suspend.h>
+#include <soc/realtek/memory.h>
+
+#include "rtd139x_suspend.h"
+
+#define DEV_NAME "RTD139x_PM"
+#define SYS_GROUP1_CK_SEL 0x98000018
+#define SYS_PLL_SCPU1 0x98000104
+#define SUSPEND_VERSION_MASK(v) ((v&0xffff) << 16)
+#define BT_WAKEUP_IGPIO(n) (0x1 << n)//n:0 to 20
+#define CPU0_RESUME_ADDR 0x000006A4
+
+extern void rtk_cpu_power_down(int cpu);
+extern void rtk_cpu_power_up(int cpu);
+
+static int suspend_version = 2;
+static unsigned int suspend_context;
+unsigned int pm_state;
+
+/*
+wakelock count mode:
+0: original mode
+1: deep sleep mode
+*/
+unsigned int pm_wakelock_mode;
+/**
+ * some sync mechanism between kernel suspend
+ * and android wakelock control
+ */
+unsigned int pm_block_wakelock;
+
+void __iomem *RTK_CRT_BASE;
+void __iomem *RTK_AIO_BASE;
+void __iomem *RTK_ISO_BASE;
+void __iomem *RTK_TVE_BASE;
+void __iomem *RTK_SB2_BASE;
+void __iomem *RTK_MISC_BASE;
+void __iomem *RTK_GIC_DIST_BASE;
+void __iomem *RTK_CPU_WRAPPER_BASE;
+
+#define rtk_suspend_shm_func(_name, _offset, _def) \
+void rtk_suspend_##_name##_set(unsigned int val) \
+{ \
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT; \
+	writel(__cpu_to_be32(SUSPEND_MAGIC_MASK | _def##_MASK(val)), \
+	&(ipc->_offset)); \
+} \
+unsigned int rtk_suspend_##_name##_get(void) \
+{ \
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT; \
+	unsigned int val = __be32_to_cpu(readl(&(ipc->_offset))); \
+	if (SUSPEND_MAGIC_GET(val) != SUSPEND_MAGIC_KEY) { \
+		pr_err("[%s] Error! val = 0x%08x\n", DEV_NAME, val); \
+		return -1; \
+	} \
+	return _def##_GET(val); \
+}
+
+rtk_suspend_shm_func(wakeup_flags, suspend_wakeup_flag, WAKEUP_FLAGS);
+rtk_suspend_shm_func(resume_state, acpu_resume_state, RESUME_STATE);
+rtk_suspend_shm_func(resume_data, acpu_resume_state, RESUME_DATA);
+rtk_suspend_shm_func(gpio_wakeup_en, gpio_wakeup_enable, GPIO_WAKEUP_EN);
+rtk_suspend_shm_func(gpio_wakeup_act, gpio_wakeup_activity, GPIO_WAKEUP_ACT);
+rtk_suspend_shm_func(gpio_out_en, gpio_output_change_enable,
+	GPIO_OUTPUT_CHANGE_EN);
+rtk_suspend_shm_func(gpio_out_act, gpio_output_change_activity,
+	GPIO_OUTPUT_CHANGE_ACT);
+rtk_suspend_shm_func(gpio_wakeup_en2, gpio_wakeup_enable2, GPIO_WAKEUP_EN2);
+rtk_suspend_shm_func(gpio_wakeup_act2, gpio_wakeup_activity2,
+	GPIO_WAKEUP_ACT2);
+rtk_suspend_shm_func(gpio_out_en2, gpio_output_change_enable2,
+	GPIO_OUTPUT_CHANGE_EN2);
+rtk_suspend_shm_func(gpio_out_act2, gpio_output_change_activity2,
+	GPIO_OUTPUT_CHANGE_ACT2);
+
+rtk_suspend_shm_func(gpio_wakeup_en3, gpio_wakeup_enable3, GPIO_WAKEUP_EN3);
+rtk_suspend_shm_func(gpio_wakeup_act3, gpio_wakeup_activity3,
+	GPIO_WAKEUP_ACT3);
+
+rtk_suspend_shm_func(timer_sec, audio_reciprocal_timer_sec,
+	AUDIO_RECIPROCAL_TIMER);
+
+static void hexdump(char *note, unsigned char *buf, unsigned int len)
+{
+	pr_crit("%s\n", note);
+	print_hex_dump(KERN_CONT, "", DUMP_PREFIX_OFFSET, 16, 1, buf, len,
+		false);
+}
+
+void acpu_set_flag(uint32_t flag)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	writel(__cpu_to_be32(SUSPEND_VERSION_MASK(suspend_version)),
+		&(ipc->suspend_mask));
+
+	if (suspend_version == 1)
+		writel(__cpu_to_be32(flag), &(ipc->suspend_flag));
+	else
+		writel(__cpu_to_be32(flag | AUTHOR_MASK(AUTHOR_SCPU)),
+			&(ipc->suspend_flag));
+}
+
+void notify_acpu(enum _notify_flag flag)
+{
+	pr_info("[%s] Notify ACPU, flag= %d\n", DEV_NAME, flag);
+
+	switch (flag) {
+	case NOTIFY_SUSPEND_TO_RAM:
+	case NOTIFY_SUSPEND_TO_COOLBOOT:
+	case NOTIFY_SUSPEND_TO_WFI:
+		if (suspend_version == 1) {
+			acpu_set_flag(0x000018ff);
+			return;
+		}
+		break;
+	case NOTIFY_RESUME_PLATFORM:
+		if (suspend_version == 1) {
+			acpu_set_flag(0x00000000);
+			return;
+		}
+		break;
+	default:
+		break;
+	}
+
+	if (suspend_version == 1)
+		return;
+	acpu_set_flag(NOTIFY_MASK(flag));
+}
+
+int rtk_suspend_wakeup_acpu(void)
+{
+	pr_info("[%s] Wakeup ACPU\n", DEV_NAME);
+
+	writel(0x00000000, RTK_SB2_BASE + 0x138);
+	__delay(1000);
+	writel(0x00000008, RTK_CRT_BASE + 0x328);
+	writel(0x0000ace7, RTK_CRT_BASE + 0x320);
+	writel(0x0000000c, RTK_CRT_BASE + 0x328);
+	__delay(1000);
+
+	return 0;
+}
+
+struct _memory_verified_handle {
+	unsigned char *memAddress;
+	size_t memByte;
+};
+
+struct _memory_verified_handle phys_wb_area[] = {
+	{(unsigned char *)0x0a000000, 0x20},
+	{(unsigned char *)0x0a001000, 0x20}
+};
+
+unsigned char memory_verified_datagen(int i)
+{
+	return (unsigned char) (i & 0xff);
+}
+
+struct _memory_verified_handle *memory_verified_handle_create(size_t byte)
+{
+	int i = 0;
+
+	struct _memory_verified_handle *handle =
+		(struct _memory_verified_handle *)
+		kmalloc(sizeof(struct _memory_verified_handle), GFP_KERNEL);
+
+	if (!handle)
+		return NULL;
+
+	/*
+	 * > 32KB : vmalloc
+	 * < 32KB : kmalloc
+	 */
+	if (byte > 0x8000)
+		handle->memAddress = vmalloc(byte);
+	else
+		handle->memAddress = kmalloc(byte, GFP_KERNEL);
+
+	if (!handle->memAddress) {
+		kfree(handle);
+		return NULL;
+	}
+
+	for (i = 0; i < byte ; i++)
+		handle->memAddress[i] = memory_verified_datagen(i);
+
+	handle->memByte = byte;
+
+	return handle;
+}
+
+int memory_verified_release(struct _memory_verified_handle *handle)
+{
+	int ret = 0, i = 0;
+	unsigned char data;
+
+	if (!handle) {
+		pr_err("[%s] handle is NULL !\n", DEV_NAME);
+		return -1;
+	}
+
+	if (!handle->memByte) {
+		ret = -2;
+		pr_info("[%s] handle %p ", DEV_NAME, (void *) handle);
+		pr_info("(memByte = %ld, memAddress = 0x%08lx)\n",
+			(long int) handle->memByte,
+			(unsigned long) handle->memAddress);
+
+		if (handle->memAddress)
+			goto free1;
+		else
+			goto free0;
+	}
+
+	for (i = 0 ; i < handle->memByte ; i++) {
+		data = memory_verified_datagen(i);
+
+		if (handle->memAddress[i] != data) {
+			pr_info("[%s] handle %p memAddress[0x%x]",
+				DEV_NAME, (void *) handle, i);
+			pr_info("=> 0x%x != 0x%x (%ld bytes at 0x%08lx)\n",
+				handle->memAddress[i], data,
+				(long int) handle->memByte,
+				(unsigned long) handle->memAddress);
+			ret = -4;
+		}
+	}
+
+	if (ret == -4) {
+		pr_err("[%s] memory phyAddt 0x%08llx\n",
+			DEV_NAME, __pa(handle->memAddress));
+		hexdump("[%s] memory verified error\n",
+			handle->memAddress, handle->memByte);
+	}
+
+free1:
+	kfree(handle->memAddress);
+free0:
+	kfree(handle);
+
+	return ret;
+}
+
+struct _memory_verified_handle *memory_writeback_handle_create(
+	struct _memory_verified_handle *phys_area)
+{
+	void *tmp_addr;
+
+	struct _memory_verified_handle *handle =
+		(struct _memory_verified_handle *)
+		kmalloc(sizeof(struct _memory_verified_handle), GFP_KERNEL);
+
+	if (!handle)
+		goto out;
+
+	handle->memAddress = kmalloc(phys_area->memByte, GFP_KERNEL);
+
+	if (!handle->memAddress) {
+		kfree(handle);
+		handle = NULL;
+		goto out;
+	}
+
+	handle->memByte = phys_area->memByte;
+	tmp_addr = phys_to_virt((phys_addr_t) phys_area->memAddress);
+	hexdump("[RTD139x_PM] Before write back dump:",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+	memcpy(handle->memAddress, tmp_addr, phys_area->memByte);
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(handle->memAddress, phys_area->memByte);
+#else
+	__flush_dcache_area(handle->memAddress, phys_area->memByte);
+#endif /* CONFIG_CPU_V7 */
+out:
+	return handle;
+}
+
+int memory_writeback_release(struct _memory_verified_handle *handle,
+	struct _memory_verified_handle *phys_area)
+{
+	int ret = 0;
+	void *tmp_addr;
+
+	if (!handle) {
+		ret = -1;
+		goto out;
+	}
+
+	if (!handle->memAddress) {
+		ret = -1;
+		goto free_out;
+	}
+
+	tmp_addr = phys_to_virt((phys_addr_t)phys_area->memAddress);
+	hexdump("[RTD139x_PM] Resume back dump:**********************",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+	memcpy(tmp_addr, handle->memAddress, handle->memByte);
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(tmp_addr, phys_area->memByte);
+#else
+	__flush_dcache_area(tmp_addr, phys_area->memByte);
+#endif /* CONFIG_CPU_V7 */
+	hexdump("[RTD139x_PM] After write back dump:",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+
+	kfree(handle->memAddress);
+
+free_out:
+	kfree(handle);
+out:
+	return ret;
+}
+
+int rtk_suspend_valid(suspend_state_t state)
+{
+	return state == PM_SUSPEND_MEM || state == PM_SUSPEND_STANDBY;
+}
+
+static int notrace rtk_iso_suspend(unsigned long param)
+{
+	enum _suspend_mode mode = (enum _suspend_mode)param;
+	int max_count = 100;
+	int i = 0;
+
+	pr_info("[%s] Flush Cache ...\n", DEV_NAME);
+
+	flush_cache_all();
+
+#ifdef CONFIG_SMP
+	dsb(ishst);
+	sev();
+#endif
+
+	pr_info("[%s] Ready to Suspend ! (mode:%d)\n", DEV_NAME, mode);
+
+#if defined(CONFIG_CPU_V7)
+	if (mode == SUSPEND_TO_COOLBOOT) {
+		notify_acpu(NOTIFY_SUSPEND_TO_COOLBOOT);
+		pr_info("BL31 enter DDR self refresh\n");
+		asm volatile(".arch_extension sec" : : : "cc");
+		asm volatile("ldr r0, =0x8400ff05" : : : "cc");
+		asm volatile("isb" : : : "cc");
+		asm volatile("smc #0" : : : "cc");
+		asm volatile("isb" : : : "cc");
+	} else if (mode == SUSPEND_TO_RAM) {
+		notify_acpu(NOTIFY_SUSPEND_TO_RAM);
+		pr_info("BL31 enter DDR self refresh\n");
+		asm volatile(".arch_extension sec" : : : "cc");
+		asm volatile("ldr r0, =0x8400ff05" : : : "cc");
+		asm volatile("isb" : : : "cc");
+		asm volatile("smc #0" : : : "cc");
+		asm volatile("isb" : : : "cc");
+	} else {
+		pr_err("[%s] Suspend Mode Not Support : %d\n", DEV_NAME, mode);
+		BUG();
+	}
+#else
+	if (mode == SUSPEND_TO_COOLBOOT) {
+		notify_acpu(NOTIFY_SUSPEND_TO_COOLBOOT);
+		pr_info("BL31 enter DDR self refresh\n");
+		asm volatile("ldr x0, =0x8400ff05" : : : "cc");
+		asm volatile("isb" : : : "cc");
+		asm volatile("smc #0" : : : "cc");
+		asm volatile("isb" : : : "cc");
+	} else if (mode == SUSPEND_TO_RAM) {
+		notify_acpu(NOTIFY_SUSPEND_TO_RAM);
+		pr_info("BL31 enter DDR self refresh\n");
+		asm volatile("ldr x0, =0x8400ff05" : : : "cc");
+		asm volatile("isb" : : : "cc");
+		asm volatile("smc #0" : : : "cc");
+		asm volatile("isb" : : : "cc");
+	} else {
+		pr_err("[%s] Suspend Mode Not Support : %d\n", DEV_NAME, mode);
+		BUG();
+	}
+#endif /* CONFIG_CPU_V7 */
+	for (i = max_count; i > 0 ; i--)
+		__delay(10000000);
+
+	BUG();
+
+	return  -EINVAL;
+}
+
+enum irq_report_state {
+	IRQ_REPORT_PREPARE,
+	IRQ_REPORT_PRINT,
+};
+
+static void rtk_suspend_irq_report(enum irq_report_state state)
+{
+	int i;
+	int j;
+	int irq;
+	unsigned int mask;
+	unsigned int temp;
+	static unsigned int data[32];
+	void __iomem *irq_state = RTK_GIC_DIST_BASE + 0x200;
+
+	switch (state) {
+	case IRQ_REPORT_PREPARE:
+		for (i = 0 ; i < 32 ; i++)
+			data[i] = *(unsigned int *)
+				(irq_state + (i * 4));
+		break;
+	case IRQ_REPORT_PRINT:
+		for (i = 0 ; i < 32 ; i++) {
+			irq = i * 32;
+			temp = *(unsigned int *)(irq_state + (i * 4));
+			if (temp != data[i]) {
+				pr_warn("[%s] Interrupt Addr:0x%08lx State: 0x%08x",
+					DEV_NAME,
+					(unsigned long)(irq_state + (i * 4)),
+					data[i]);
+				pr_warn(" => 0x%08x\n", temp);
+
+				for (j = 0 ; j < 32 ; j++) {
+					mask = 0x1U << j;
+					if (mask & temp)
+						pr_warn("[%s] IRQ: %d\n",
+							DEV_NAME, (irq + j));
+				}
+			}
+		}
+		break;
+	default:
+		pr_err("[%s] Unknow CMD! %d\n", DEV_NAME, state);
+	}
+}
+
+static int rtk_suspend_to_wfi(void)
+{
+#if 0
+	void __iomem *reg_sel = ioremap(SYS_GROUP1_CK_SEL, 0x4);
+	void __iomem *reg_pll = ioremap(SYS_PLL_SCPU1, 0x4);
+#endif
+
+	notify_acpu(NOTIFY_SUSPEND_TO_WFI);
+
+	rtk_suspend_irq_report(IRQ_REPORT_PREPARE);
+#if 0
+	/* switch clk_scpu to osc (27 MHz) */
+	pr_info("[%s] switch scpu_clk to osc\n", DEV_NAME);
+	writel(readl(reg_sel) | 0x4, reg_sel);
+
+	/* disable pll_scpu*/
+	pr_info("[%s] disable scpu_pll\n", DEV_NAME);
+	writel(0x4, reg_pll);
+#endif
+	pr_info("[%s] wait for interrupt\n", DEV_NAME);
+
+	asm("WFI");
+
+#if 0
+	/* enable pll_scpu, delay to wait it stable */
+	pr_info("[%s] enable scpu_pll\n", DEV_NAME);
+	writel(0x3, reg_pll);
+	__delay(100);
+
+	/* NOTE: ACPU also set SYS_GROUP1_CK_SEL later */
+	pr_info("[%s] switch scpu_clk to scpu_pll\n", DEV_NAME);
+	writel(readl(reg_sel) & ~0x4, reg_sel);
+
+	iounmap(reg_pll);
+	iounmap(reg_sel);
+#endif
+	rtk_suspend_irq_report(IRQ_REPORT_PRINT);
+
+	return 0;
+}
+
+static int rtk_suspend_to_ram(void)
+{
+	const int  MEM_VERIFIED_CNT = 20;
+	int ret = 0;
+	int i = 0;
+	int size_tmp1 = 0;
+	int size_tmp2 = 0;
+	int size_tmp3 = 0;
+	struct _memory_verified_handle *mem_vhandle[MEM_VERIFIED_CNT];
+	struct _memory_verified_handle **mem_wbhandle;
+	void __iomem *resumeAddr = RTK_ISO_BASE + CPU0_RESUME_ADDR;
+	unsigned int ISODummy1Data = readl(resumeAddr);
+#ifdef CONFIG_RTK_VMX_ULTRA
+	__le64 __iomem *cpu0_resume_addr;
+#endif
+
+	pr_info("[%s] CPU Resume vaddr: 0x%08lx paddr: 0x%08lx\n",
+		DEV_NAME, (unsigned long)cpu_resume,
+		(unsigned long)__pa(cpu_resume));
+
+	hexdump("CPU Resume Entry Dump:",
+		(unsigned char *) cpu_resume, 0x100);
+
+#ifndef CONFIG_RTK_VMX_ULTRA
+
+#if defined(CONFIG_CPU_V7)
+	asm volatile(".arch_extension sec" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("mov r1, %0" : : "r" (__pa(cpu_resume)) : "cc");
+	/* RTK_SET_KERNEL_REUMSE_ENTRY */
+	asm volatile("ldr r0, =0x8400ff04" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+#else
+	asm volatile("isb" : : : "cc");
+	asm volatile("mov x1, %0" : : "r" (__pa(cpu_resume)) : "cc");
+	/* RTK_SET_KERNEL_REUMSE_ENTRY */
+	asm volatile("ldr x0, =0x8400ff04" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+#endif /* CONFIG_CPU_V7 */
+
+#else // #ifndef CONFIG_RTK_VMX_ULTRA
+	cpu0_resume_addr = ioremap(0x98007660, sizeof(*cpu0_resume_addr));
+	writel_relaxed(__pa(cpu_resume), cpu0_resume_addr);
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area((__force void *)cpu0_resume_addr, sizeof(*cpu0_resume_addr));
+#else
+	__flush_dcache_area((__force void *)cpu0_resume_addr, sizeof(*cpu0_resume_addr));
+#endif
+	iounmap(cpu0_resume_addr);
+#endif
+
+	BUG_ON(!irqs_disabled());
+
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		mem_vhandle[i] = memory_verified_handle_create(0x4000);
+
+	size_tmp1 = sizeof(phys_wb_area);
+	size_tmp2 = sizeof(struct _memory_verified_handle);
+	size_tmp3 = sizeof(struct _memory_verified_handle *);
+	mem_wbhandle = kmalloc(size_tmp1 / size_tmp2 * size_tmp3, GFP_KERNEL);
+	if (mem_wbhandle) {
+		for (i = 0 ; i < (size_tmp1 / size_tmp2) ; i++)
+			mem_wbhandle[i] = memory_writeback_handle_create(
+					&phys_wb_area[i]);
+	}
+
+	ret = cpu_suspend((unsigned long)SUSPEND_TO_RAM, rtk_iso_suspend);
+
+	if (ret)
+		return ret;
+
+	/* Restore iso dummy data */
+	writel(ISODummy1Data, resumeAddr);
+
+	writel(readl(RTK_ISO_BASE + 0x0418) | BIT(0), RTK_ISO_BASE + 0x0418);
+	writel(readl(RTK_ISO_BASE + 0x0410) & ~BIT(10), RTK_ISO_BASE + 0x0410);
+
+	rtk_suspend_irq_report(IRQ_REPORT_PRINT);
+
+	flush_cache_all();
+
+	pr_info("[%s] Resume Memory Verifying ... State 0\n", DEV_NAME);
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		memory_verified_release(mem_vhandle[i]);
+
+
+	pr_info("[%s] Resume Memory Verifying ... State 1\n", DEV_NAME);
+	for (i = 0 ; i < MEM_VERIFIED_CNT; i++)
+		mem_vhandle[i] = memory_verified_handle_create(0x4000);
+
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		memory_verified_release(mem_vhandle[i]);
+
+	if (mem_wbhandle) {
+		for (i = 0 ; i < (size_tmp1 / size_tmp2) ; i++)
+			memory_writeback_release(
+				mem_wbhandle[i], &phys_wb_area[i]);
+		kfree(mem_wbhandle);
+	}
+
+#ifdef CONFIG_SMP
+	dsb(ishst);
+	sev();
+#endif
+
+	return ret;
+}
+
+static int rtk_suspend_to_coolboot(void)
+{
+	int ret = 0;
+
+	ret = cpu_suspend((unsigned long)SUSPEND_TO_COOLBOOT, rtk_iso_suspend);
+	return ret;
+}
+
+void rtk_suspend_gpip_output_change_suspend(void)
+{
+	int i = 0;
+	unsigned int val;
+	unsigned int mask;
+	int tmp;
+
+	/* IGPIO0 ~ IGPIO23 */
+	val = rtk_suspend_gpio_out_en_get();
+	for (i = 0 ; i < GPIO_OUTPUT_CHANGE_EN_BITS ; i++) {
+		mask = 0x1U << i;
+
+		if (!(val & mask))
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			(rtk_suspend_gpio_out_act_get() & mask) ?
+			"HIGH" : "LOW");
+		tmp = (rtk_suspend_gpio_out_act_get() & mask) ? 1 : 0;
+		gpio_direction_output(i + SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+
+	/* IGPIO24 ~ IGPIO47 */
+	val = rtk_suspend_gpio_out_en2_get();
+	i = GPIO_OUTPUT_CHANGE_EN_BITS;
+	for (; i < GPIO_OUTPUT_CHANGE_EN_BITS + GPIO_OUTPUT_CHANGE_EN2_BITS  ; i++) {
+		mask = 0x1U << (i - GPIO_OUTPUT_CHANGE_EN_BITS);
+
+		if (!(val & mask))
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			(rtk_suspend_gpio_out_act2_get() & mask) ?
+			"HIGH" : "LOW");
+		tmp = (rtk_suspend_gpio_out_act2_get() & mask) ? 1 : 0;
+		gpio_direction_output(i+SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+
+}
+
+void rtk_suspend_gpip_output_change_resume(void)
+{
+	int i = 0;
+	unsigned int val;
+	unsigned int mask;
+	int tmp;
+
+	/* IGPIO0 ~ IGPIO23 */
+	val = rtk_suspend_gpio_out_en_get();
+	for (i = 0 ; i < GPIO_OUTPUT_CHANGE_EN_BITS ; i++) {
+		mask = 0x1U << i;
+
+		if (!(val & mask))
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			(rtk_suspend_gpio_out_act_get() & mask) ?
+			"LOW" : "HIGH");
+		tmp = (rtk_suspend_gpio_out_act_get() & mask) ? 0 : 1;
+		gpio_direction_output(i + SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+
+	/* IGPIO24 ~ IGPIO47 */
+	val = rtk_suspend_gpio_out_en2_get();
+	i = GPIO_OUTPUT_CHANGE_EN_BITS;
+	for (; i < GPIO_OUTPUT_CHANGE_EN_BITS + GPIO_OUTPUT_CHANGE_EN2_BITS; i++) {
+		mask = 0x1U << (i - GPIO_OUTPUT_CHANGE_EN_BITS);
+
+		if (!(val & mask))
+			continue;
+
+		pr_info("[%s] gpio:%d set ouput =>  %s\n",
+			DEV_NAME, i + SUSPEND_ISO_GPIO_BASE,
+			(rtk_suspend_gpio_out_act2_get() & mask) ?
+			"LOW" : "HIGH");
+		tmp = (rtk_suspend_gpio_out_act2_get() & mask) ? 0 : 1;
+		gpio_direction_output(i + SUSPEND_ISO_GPIO_BASE, tmp);
+	}
+
+}
+
+static void rtk_suspend_cpu_pwr_down(void) {
+	unsigned int cpu = 1;
+
+	for (cpu = 1 ; cpu < NR_CPUS ; cpu++) {
+		rtk_cpu_power_down(cpu);
+	}
+}
+
+static int rtk_suspend_enter(suspend_state_t suspend_state)
+{
+	int ret = 0;
+
+	pr_info("[%s] Platform Suspend Enter ...\n", DEV_NAME);
+
+	rtk_suspend_cpu_pwr_down();
+
+	if (!rtk_suspend_valid(suspend_state)) {
+		pr_err("[%s] suspend_state:%d not support !\n",
+			DEV_NAME, (int) suspend_state);
+		return  -EINVAL;
+	}
+
+	switch (suspend_state) {
+	case PM_SUSPEND_STANDBY:
+		ret = rtk_suspend_to_wfi();
+
+		suspend_context++;
+
+		pr_info("[%s] Platform Resume ...\n", DEV_NAME);
+		notify_acpu(NOTIFY_RESUME_PLATFORM);
+		break;
+	case PM_SUSPEND_MEM:
+		rtk_suspend_gpip_output_change_suspend();
+
+		ret = rtk_suspend_to_ram();
+
+		suspend_context++;
+
+		if (ret) {
+			pr_err("[%s] ERROR ! to suspend! (%d)\n",
+				DEV_NAME, ret);
+			BUG();
+			break;
+		}
+
+		pr_info("[%s] Platform Resume ...\n", DEV_NAME);
+
+		rtk_suspend_gpip_output_change_resume();
+
+		break;
+	default:
+		ret = -EINVAL;
+		break;
+	}
+
+	return  ret;
+}
+
+static int rtk_suspend_begin(suspend_state_t suspend_state)
+{
+	pr_info("[%s] Suspend Begin\n", DEV_NAME);
+
+	if (!rtk_suspend_valid(suspend_state)) {
+		pr_err("[%s] suspend_state:%d not Support!\n",
+			DEV_NAME, (int) suspend_state);
+		return -EINVAL;
+	}
+
+	switch (suspend_state) {
+	case PM_SUSPEND_STANDBY:
+		cpu_idle_poll_ctrl(true);
+		break;
+	case PM_SUSPEND_MEM:
+		cpu_idle_poll_ctrl(true);
+		break;
+	default:
+		return  -EINVAL;
+	}
+
+	return 0;
+}
+
+static void rtk_suspend_wake(void)
+{
+	pr_info("[%s] Suspend wake\n", DEV_NAME);
+
+	/* Enable ACPU clock */
+	writel_relaxed(readl(RTK_CRT_BASE + 0x10) | 0x40000034, RTK_CRT_BASE + 0x10);
+
+	rtk_suspend_wakeup_acpu();
+}
+
+static void rtk_suspend_finish(void)
+{
+	pr_info("[%s] Suspend finish\n", DEV_NAME);
+
+	notify_acpu(NOTIFY_RESUME_PLATFORM);
+}
+
+static void rtk_suspend_end(void)
+{
+	pr_info("[%s] Suspend End\n", DEV_NAME);
+
+	notify_acpu(NOTIFY_RESUME_END);
+	cpu_idle_poll_ctrl(false);
+}
+
+const struct platform_suspend_ops rtk_suspend_ops = {
+	.begin = rtk_suspend_begin,
+	.end = rtk_suspend_end,
+	.enter = rtk_suspend_enter,
+	.valid = rtk_suspend_valid,
+	.finish = rtk_suspend_finish,
+	.wake = rtk_suspend_wake,
+};
+
+static void rtk_poweroff(void)
+{
+	pr_info("[%s] Power off\n", DEV_NAME);
+
+	rtk_suspend_gpip_output_change_suspend();
+
+	rtk_suspend_to_coolboot();
+
+	return;
+};
+
+static void rtk_gpio_init_wu(struct device_node *nd)
+{
+	const u32 *prop_en;
+	const u32 *prop_act;
+	int wu_gpio_en = 0;
+	int wu_gpio_act = 0;
+	int wu_gpio_list = 0;
+	int en;
+	int act;
+	int wu_gpio;
+	int gpio_iso_num;
+	int tmp;
+	unsigned int val;
+	int i = 0;
+
+	wu_gpio_list = of_gpio_named_count(nd, "wakeup-gpio-list");
+	prop_en = of_get_property(nd, "wakeup-gpio-enable", &wu_gpio_en);
+	prop_act = of_get_property(nd, "wakeup-gpio-activity", &wu_gpio_act);
+	wu_gpio_en  /= sizeof(u32);
+	wu_gpio_act /= sizeof(u32);
+
+	pr_info("[%s] wakeup-gpio Cnt: en(%d) act(%d) list(%d)\n",
+		DEV_NAME, wu_gpio_en, wu_gpio_act, wu_gpio_list);
+
+	if (wu_gpio_en != 0 && (wu_gpio_en == wu_gpio_act)
+		&& (wu_gpio_act == wu_gpio_list)) {
+
+		for (i = 0 ; i < wu_gpio_list ; i++) {
+			en  = of_read_number(prop_en, 1 + i);
+			act = of_read_number(prop_act, 1 + i);
+			wu_gpio = of_get_named_gpio(nd, "wakeup-gpio-list", i);
+			gpio_iso_num = wu_gpio - SUSPEND_ISO_GPIO_BASE;
+
+			if (!en) {
+				pr_err("[%s] wakeup-gpio[%d] States is disable!",
+					DEV_NAME, i);
+				pr_err(" (en:%d act:%d gpio:%d)\n",
+					en, act, wu_gpio);
+				continue;
+			}
+
+			tmp = gpio_iso_num < 0 || gpio_iso_num;
+			if (tmp >= SUSPEND_ISO_GPIO_SIZE) {
+				pr_err("[%s] wakeup-gpio[%d] Out of iso range!",
+					DEV_NAME, i);
+
+				pr_err(" (en:%d act:%d gpio:%d)\n",
+					en, act, wu_gpio);
+				continue;
+			}
+
+			if (gpio_request(wu_gpio, nd->name)) {
+				pr_err("[%s] wakeup-gpio[%d] Request failed!",
+					DEV_NAME, i);
+				pr_err(" (en:%d act:%d gpio:%d)\n",
+					en, act, wu_gpio);
+			} else {
+				gpio_free(wu_gpio);
+			}
+
+			gpio_direction_input(wu_gpio);
+
+			pr_info("[%s] wakeup-gpio[%d] Successful registration!",
+				DEV_NAME, i);
+			pr_info(" (en:%d act:%d gpio:%d)\n",
+				en, act, wu_gpio);
+
+			/* IGPIO0 ~ IGPIO23 */
+			if (gpio_iso_num < GPIO_WAKEUP_EN_BITS) {
+				val = rtk_suspend_gpio_wakeup_en_get();
+				tmp = gpio_iso_num;
+				val = en ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_wakeup_en_set(val);
+
+				val = rtk_suspend_gpio_wakeup_act_get();
+				tmp = gpio_iso_num;
+				val = act ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_wakeup_act_set(val);
+			} else if (gpio_iso_num >= GPIO_WAKEUP_EN_BITS && gpio_iso_num < GPIO_WAKEUP_EN_BITS + GPIO_WAKEUP_EN2_BITS) {
+				/* IGPIO24 ~ IGPIO47 */
+				val = rtk_suspend_gpio_wakeup_en2_get();
+				tmp = (gpio_iso_num - GPIO_WAKEUP_EN_BITS);
+				val = en ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_wakeup_en2_set(val);
+
+				val = rtk_suspend_gpio_wakeup_act2_get();
+				tmp = (gpio_iso_num - GPIO_WAKEUP_EN_BITS);
+				val = act ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_wakeup_act2_set(val);
+			} else {
+				/* IGPIO48 ~ IGPIO56 */
+				val = rtk_suspend_gpio_wakeup_en3_get();
+				tmp = (gpio_iso_num - GPIO_WAKEUP_EN2_BITS - GPIO_WAKEUP_EN_BITS);
+				val = en ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_wakeup_en3_set(val);
+
+				val = rtk_suspend_gpio_wakeup_act3_get();
+				tmp = (gpio_iso_num - GPIO_WAKEUP_EN2_BITS - GPIO_WAKEUP_EN_BITS);
+				val = act ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_wakeup_act3_set(val);
+			}
+		}
+	}
+}
+
+static void rtk_gpio_init_out(struct device_node *nd)
+{
+	const u32 *prop_en;
+	const u32 *prop_act;
+	int out_gpio_en = 0;
+	int out_gpio_act = 0;
+	int out_gpio_list = 0;
+	int en;
+	int act;
+	int gpio_iso_num;
+	int output_change_gpio;
+	int tmp;
+	unsigned int val;
+	int i = 0;
+
+	out_gpio_list = of_gpio_named_count(nd, "gpio-output-change-list");
+	prop_en = of_get_property(nd, "gpio-output-change-enable",
+		&out_gpio_en);
+	prop_act = of_get_property(nd, "gpio-output-change-activity",
+		&out_gpio_act);
+	out_gpio_en /= sizeof(u32);
+	out_gpio_act /= sizeof(u32);
+
+	pr_info("[%s] gpio-output-change Cnt: en(%d) act(%d) list(%d)\n",
+			DEV_NAME, out_gpio_en, out_gpio_act, out_gpio_list);
+
+	if (out_gpio_en != 0 && (out_gpio_en == out_gpio_act)
+		&& (out_gpio_act == out_gpio_list)) {
+
+		for (i = 0 ; i < out_gpio_list ; i++) {
+			en  = of_read_number(prop_en, 1 + i);
+			act = of_read_number(prop_act, 1 + i);
+			output_change_gpio = of_get_named_gpio(nd,
+				"gpio-output-change-list", i);
+			gpio_iso_num = output_change_gpio -
+				SUSPEND_ISO_GPIO_BASE;
+
+			if (!en) {
+				pr_warn("[%s] gpio-output-change[%d]",
+					DEV_NAME, i);
+				pr_warn(" States is disable! ");
+				pr_warn("(en:%d act:%d gpio:%d)\n",
+					en, act, output_change_gpio);
+				continue;
+			}
+
+			if (gpio_iso_num < 0 ||
+				gpio_iso_num >= SUSPEND_ISO_GPIO_SIZE) {
+				pr_err("[%s] gpio-output-change[%d]",
+					DEV_NAME, i);
+				pr_err(" Out of iso range! ");
+				pr_err("(en:%d act:%d gpio:%d)\n",
+					en, act, output_change_gpio);
+				continue;
+			}
+
+			if (gpio_request(output_change_gpio, nd->name)) {
+				pr_err("[%s] gpio-output-change[%d]",
+					DEV_NAME, i);
+				pr_err(" Request failed! ");
+				pr_err("(en:%d act:%d gpio:%d)\n",
+					en, act, output_change_gpio);
+			} else {
+				gpio_free(output_change_gpio);
+			}
+
+			pr_info("[%s] gpio-output-change[%d]",
+				DEV_NAME, i);
+			pr_info(" Successful registration! ");
+			pr_info("(en:%d act:%d gpio:%d)\n",
+				en, act, output_change_gpio);
+
+			/* IGPIO0 ~ IGPIO23 */
+			if (gpio_iso_num < GPIO_OUTPUT_CHANGE_EN_BITS) {
+				val = rtk_suspend_gpio_out_en_get();
+				tmp = gpio_iso_num;
+				val = en ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_out_en_set(val);
+
+				val = rtk_suspend_gpio_out_act_get();
+				tmp = gpio_iso_num;
+				val = act ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_out_act_set(val);
+			} else if (gpio_iso_num >= GPIO_OUTPUT_CHANGE_EN_BITS && gpio_iso_num < GPIO_WAKEUP_EN_BITS + GPIO_OUTPUT_CHANGE_EN2_BITS) {
+				/* IGPIO24 ~ IGPIO47 */
+				val = rtk_suspend_gpio_out_en2_get();
+				tmp = gpio_iso_num -
+					GPIO_OUTPUT_CHANGE_EN_BITS;
+				val = en ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_out_en2_set(val);
+
+				val = rtk_suspend_gpio_out_act2_get();
+				tmp = gpio_iso_num -
+					GPIO_OUTPUT_CHANGE_EN_BITS;
+				val = act ?
+					val | (0x1U << tmp) :
+					val & ~(0x1U << tmp);
+				rtk_suspend_gpio_out_act2_set(val);
+			}
+		}
+	}
+}
+
+static void rtk_gpio_init(struct device_node *nd)
+{
+	rtk_gpio_init_wu(nd);
+	rtk_gpio_init_out(nd);
+}
+
+int __init rtk_suspend_init(void)
+{
+	struct device_node *p_suspend_nd = NULL;
+	struct device_node *p_gic_nd = NULL;
+	struct device_node *p_cpu_wrapper_nd = NULL;
+	const u32 *prop;
+	int size;
+	int temp;
+
+	acpu_set_flag(0x00000000);
+	rtk_suspend_wakeup_flags_set(0);
+	rtk_suspend_resume_state_set(RESUME_NONE);
+	rtk_suspend_resume_data_set(0);
+	rtk_suspend_gpio_wakeup_en_set(0);
+	rtk_suspend_gpio_wakeup_act_set(0);
+	rtk_suspend_gpio_out_en_set(0);
+	rtk_suspend_gpio_out_act_set(0);
+	rtk_suspend_gpio_wakeup_en2_set(0);
+	rtk_suspend_gpio_wakeup_act2_set(0);
+	rtk_suspend_gpio_out_en2_set(0);
+	rtk_suspend_gpio_out_act2_set(0);
+	rtk_suspend_gpio_wakeup_en3_set(0);
+	rtk_suspend_gpio_wakeup_act3_set(0);
+	rtk_suspend_timer_sec_set(0);
+
+	pr_info("[%s] Initial Power Management Driver\n", DEV_NAME);
+
+	p_suspend_nd =
+		of_find_compatible_node(NULL, NULL, "Realtek,power-management");
+	p_gic_nd =
+		of_find_compatible_node(NULL, NULL, "arm,gic-400");
+	p_cpu_wrapper_nd =
+		of_find_compatible_node(NULL, NULL, "Realtek,rtk-scpu_wrapper");
+
+	RTK_CPU_WRAPPER_BASE = of_iomap(p_cpu_wrapper_nd, 0);
+	RTK_GIC_DIST_BASE = of_iomap(p_gic_nd, 0);
+	RTK_CRT_BASE = of_iomap(p_suspend_nd, 0);
+	RTK_AIO_BASE = of_iomap(p_suspend_nd, 1);
+	RTK_ISO_BASE = of_iomap(p_suspend_nd, 2);
+	RTK_TVE_BASE = of_iomap(p_suspend_nd, 3);
+	RTK_SB2_BASE = of_iomap(p_suspend_nd, 4);
+	RTK_MISC_BASE = of_iomap(p_suspend_nd, 5);
+
+	if (p_suspend_nd && of_device_is_available(p_suspend_nd)) {
+
+		rtk_gpio_init(p_suspend_nd);
+
+		/* wakeup flags */
+		prop = of_get_property(p_suspend_nd, "wakeup-flags", &size);
+		if (prop) {
+			temp = of_read_number(prop, 1);
+			if (temp < 0) {
+				pr_err("[%s] Set wakeup-flags error! 0x%x\n",
+					DEV_NAME, temp);
+				rtk_suspend_wakeup_flags_set(
+					fWAKEUP_ON_IR | fWAKEUP_ON_GPIO |
+					fWAKEUP_ON_ALARM | fWAKEUP_ON_CEC);
+				pr_info("[%s] wakeup flags set default : 0x%x\n",
+					DEV_NAME,
+					rtk_suspend_wakeup_flags_get());
+			} else {
+				rtk_suspend_wakeup_flags_set(temp);
+				pr_info("[%s] Set set wakeup-flags = 0x%x\n",
+					DEV_NAME,
+					rtk_suspend_wakeup_flags_get());
+			}
+		} else {
+			rtk_suspend_wakeup_flags_set(
+				fWAKEUP_ON_IR | fWAKEUP_ON_GPIO |
+				fWAKEUP_ON_ALARM | fWAKEUP_ON_CEC);
+			pr_info("[%s] Wakeup Flags Set Default : 0x%x\n",
+				DEV_NAME, rtk_suspend_wakeup_flags_get());
+		}
+	}
+
+	suspend_set_ops(&rtk_suspend_ops);
+
+	if (of_device_is_system_power_controller(p_suspend_nd)) {
+		if (!pm_power_off) {
+			pr_info("[%s] as system-power-controller\n", DEV_NAME);
+			pm_power_off = rtk_poweroff;
+		} else {
+			pr_warn("[%s] pm_power_off is already defined\n",
+				DEV_NAME);
+		}
+	}
+
+	return 0;
+}
+
+subsys_initcall(rtk_suspend_init);
+
+#ifdef CONFIG_SYSFS
+#define RTK_SUSPEND_ATTR(_name) \
+{ \
+	.attr = {.name = #_name, .mode = 0644}, \
+	.show =  rtk_suspend_##_name##_show, \
+	.store = rtk_suspend_##_name##_store, \
+}
+
+static enum _suspend_wakeup rtk_suspend_decode_wakeup(const char *buf,
+	size_t n)
+{
+	const char *const *s;
+	char *p;
+	int len;
+	int i;
+
+	p = memchr(buf, '\n', n);
+	len = p ? p - buf : n;
+
+	for (i = 0 ; i < eWAKEUP_ON_MAX ; i++) {
+		s = &rtk_suspend_wakeup_states[i];
+		if (*s && len == strlen(*s) && !strncmp(buf, *s, len))
+			return i;
+	}
+
+	return eWAKEUP_ON_MAX;
+}
+
+static ssize_t rtk_suspend_wakeup_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val = rtk_suspend_wakeup_flags_get();
+
+	for (i = 0 ; i < eWAKEUP_ON_MAX ; i++) {
+
+		if (val & (0x1U << i))
+			n += sprintf(buf + n, " * ");
+		else
+			n += sprintf(buf + n, "   ");
+		n += sprintf(buf + n, "%s\n", rtk_suspend_wakeup_states[i]);
+	}
+	n += sprintf(buf + n, "\n");
+	return n;
+}
+
+static ssize_t rtk_suspend_wakeup_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	enum _suspend_wakeup wakeup = rtk_suspend_decode_wakeup(buf, count);
+
+	if (wakeup < eWAKEUP_ON_MAX) {
+		rtk_suspend_wakeup_flags_set(
+			rtk_suspend_wakeup_flags_get() ^ (0x1U << wakeup));
+		return count;
+	}
+	return -ENOMEM;
+}
+
+static ssize_t rtk_suspend_resume_state_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int n = 0;
+	unsigned int val = rtk_suspend_resume_state_get();
+
+	if (val >= RESUME_MAX_STATE) {
+		n += sprintf(buf + n, "(not ready)\n");
+		goto done;
+	}
+
+	if (val == RESUME_GPIO)
+		n += sprintf(buf + n, " %s %d\n",
+			rtk_suspend_resume_states[val],
+			rtk_suspend_resume_data_get() + SUSPEND_ISO_GPIO_BASE);
+	else
+		n += sprintf(buf + n, " %s %d\n",
+			rtk_suspend_resume_states[val],
+			rtk_suspend_resume_data_get());
+
+done:
+	n += sprintf(buf + n, " (write reset => change state to 'none')\n");
+	return n;
+}
+
+static ssize_t rtk_suspend_resume_state_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	const char *const s = "reset";
+	char *p;
+	int len;
+
+	p = memchr(buf, '\n', count);
+
+	len = p ? p - buf : count;
+
+	if (s && len == strlen(s) && !strncmp(buf, s, len))
+		rtk_suspend_resume_state_set(RESUME_NONE);
+
+	return count;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_en_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val;
+	unsigned int val2;
+	unsigned int val3;
+
+	val = rtk_suspend_gpio_wakeup_en_get();
+	val2 = rtk_suspend_gpio_wakeup_en2_get();
+	val3 = rtk_suspend_gpio_wakeup_en3_get();
+
+	if ((val == -1U) && (val2 == -1U) && (val3 == -1U))
+		return sprintf(buf, "(not ready)\n");
+
+	n += sprintf(buf + n, " En | GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < GPIO_WAKEUP_EN_BITS ; i++) {
+		if (val == -1U)
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (val & (0x1U << i))
+			n += sprintf(buf + n, "  * | %d\n", i);
+		else
+			n += sprintf(buf + n, "	| %d\n", i);
+	}
+
+	for (i = 0 ; i < GPIO_WAKEUP_EN2_BITS ; i++) {
+		if (val2 == -1U)
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_EN_BITS);
+		else if (val2 & (0x1U << i))
+			n += sprintf(buf + n, "  * | %d\n",
+				i + GPIO_WAKEUP_EN_BITS);
+		else
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_EN_BITS);
+	}
+
+	for (i = 0 ; i < GPIO_WAKEUP_EN3_BITS ; i++) {
+		if (val3 == -1U)
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_EN_BITS + GPIO_WAKEUP_EN2_BITS);
+		else if (val3 & (0x1U << i))
+			n += sprintf(buf + n, "  * | %d\n",
+				i + GPIO_WAKEUP_EN_BITS + GPIO_WAKEUP_EN2_BITS);
+		else
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_EN_BITS + GPIO_WAKEUP_EN2_BITS);
+	}
+	n += sprintf(buf + n, "\n");
+	return n;
+
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_en_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#endif
+
+	if (val < GPIO_WAKEUP_EN_BITS)
+		rtk_suspend_gpio_wakeup_en_set(
+			rtk_suspend_gpio_wakeup_en_get() ^ (0x1U << val));
+	else if ((val >= GPIO_WAKEUP_EN_BITS) && (val < GPIO_WAKEUP_EN_BITS + GPIO_WAKEUP_EN2_BITS))
+		rtk_suspend_gpio_wakeup_en2_set(
+			rtk_suspend_gpio_wakeup_en2_get() ^ (0x1U <<
+			(val-GPIO_WAKEUP_EN_BITS)));
+	else
+		rtk_suspend_gpio_wakeup_en3_set(
+			rtk_suspend_gpio_wakeup_en3_get() ^ (0x1U <<
+			(val-GPIO_WAKEUP_EN_BITS-GPIO_WAKEUP_EN2_BITS)));
+	return count;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_act_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val;
+	unsigned int val2;
+	unsigned int val3;
+
+	val = rtk_suspend_gpio_wakeup_act_get();
+	val2 = rtk_suspend_gpio_wakeup_act2_get();
+	val3 = rtk_suspend_gpio_wakeup_act3_get();
+
+	if ((val == -1U) && (val2 == -1U) && (val3 == -1U))
+		return sprintf(buf, "(not ready)\n");
+
+	n += sprintf(buf + n, " Act| GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < GPIO_WAKEUP_ACT_BITS ; i++) {
+		if (val == -1U)
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (!(rtk_suspend_gpio_wakeup_en_get() & (0x1U << i)))
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (val & (0x1U << i))
+			n += sprintf(buf + n, "  H | %d\n", i);
+		else
+			n += sprintf(buf + n, "  L | %d\n", i);
+	}
+
+	for (i = 0 ; i < GPIO_WAKEUP_ACT2_BITS ; i++) {
+		if (val2 == -1U)
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_ACT_BITS);
+		else if (!(rtk_suspend_gpio_wakeup_en2_get() & (0x1U << i)))
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_ACT_BITS);
+		else if (val2 & (0x1U << i))
+			n += sprintf(buf + n, "  H | %d\n",
+				i + GPIO_WAKEUP_ACT_BITS);
+		else
+			n += sprintf(buf + n, "  L | %d\n",
+				i + GPIO_WAKEUP_ACT_BITS);
+	}
+
+	for (i = 0 ; i < GPIO_WAKEUP_ACT3_BITS ; i++) {
+		if (val3 == -1U)
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_ACT_BITS + GPIO_WAKEUP_ACT2_BITS);
+		else if (!(rtk_suspend_gpio_wakeup_en3_get() & (0x1U << i)))
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_WAKEUP_ACT_BITS + GPIO_WAKEUP_ACT2_BITS);
+		else if (val3 & (0x1U << i))
+			n += sprintf(buf + n, "  H | %d\n",
+				i + GPIO_WAKEUP_ACT_BITS + GPIO_WAKEUP_ACT2_BITS);
+		else
+			n += sprintf(buf + n, "  L | %d\n",
+				i + GPIO_WAKEUP_ACT_BITS + GPIO_WAKEUP_ACT2_BITS);
+	}
+	n += sprintf(buf + n, "\n");
+
+	return n;
+}
+
+static ssize_t rtk_suspend_gpio_wakeup_act_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+	int tmp;
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#endif
+
+	if (val < GPIO_WAKEUP_ACT_BITS) {
+		tmp = (0x1U << val);
+		if (rtk_suspend_gpio_wakeup_en_get() & tmp)
+			rtk_suspend_gpio_wakeup_act_set(
+				rtk_suspend_gpio_wakeup_act_get() ^ tmp);
+	} else {
+		tmp = (0x1U << (val - GPIO_WAKEUP_ACT_BITS));
+		if (rtk_suspend_gpio_wakeup_en2_get() & tmp) {
+			rtk_suspend_gpio_wakeup_act2_set(
+				rtk_suspend_gpio_wakeup_act2_get() ^
+				(0x1U << (val-GPIO_WAKEUP_ACT_BITS)));
+		}
+	}
+
+	return count;
+}
+
+static ssize_t rtk_suspend_gpio_out_en_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val;
+	unsigned int val2;
+
+	val = rtk_suspend_gpio_out_en_get();
+	val2 = rtk_suspend_gpio_out_en2_get();
+	if ((val == -1U) && (val2 == -1U) && (val2 == -1U))
+		return sprintf(buf, "(not ready)\n");
+
+	n += sprintf(buf + n, " En | GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < GPIO_OUTPUT_CHANGE_EN_BITS ; i++) {
+		if (val == -1U)
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (val & (0x1U << i))
+			n += sprintf(buf + n, "  * | %d\n", i);
+		else
+			n += sprintf(buf + n, "	| %d\n", i);
+	}
+
+	for (i = 0 ; i < GPIO_OUTPUT_CHANGE_EN2_BITS ; i++) {
+		if (val2 == -1U)
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_OUTPUT_CHANGE_EN_BITS);
+		else if (val2 & (0x1U << i))
+			n += sprintf(buf + n, "  * | %d\n",
+				i + GPIO_OUTPUT_CHANGE_EN_BITS);
+		else
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_OUTPUT_CHANGE_EN_BITS);
+	}
+	n += sprintf(buf + n, "\n");
+	return n;
+
+}
+
+static ssize_t rtk_suspend_gpio_out_en_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#endif
+
+	if (val < GPIO_OUTPUT_CHANGE_EN_BITS)
+		rtk_suspend_gpio_out_en_set(
+			rtk_suspend_gpio_out_en_get() ^ (0x1U << val));
+	else
+		rtk_suspend_gpio_out_en2_set(rtk_suspend_gpio_out_en2_get() ^
+			(0x1U << (val-GPIO_OUTPUT_CHANGE_EN_BITS)));
+
+	return count;
+}
+
+static ssize_t rtk_suspend_gpio_out_act_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val;
+	unsigned int val2;
+
+	val = rtk_suspend_gpio_out_act_get();
+	val2 = rtk_suspend_gpio_out_act2_get();
+
+	if ((val == -1U) && (val2 == -1U))
+		return sprintf(buf, "(not ready)\n");
+
+	n += sprintf(buf + n, " Act| GPIO(ISO)\n");
+	n += sprintf(buf + n, " ---+----------\n");
+	for (i = 0 ; i < GPIO_OUTPUT_CHANGE_ACT_BITS ; i++) {
+		if (val == -1U)
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (!(rtk_suspend_gpio_out_en_get() & (0x1U << i)))
+			n += sprintf(buf + n, "	| %d\n", i);
+		else if (val & (0x1U << i))
+			n += sprintf(buf + n, "  H | %d\n", i);
+		else
+			n += sprintf(buf + n, "  L | %d\n", i);
+	}
+
+	for (i = 0 ; i < GPIO_WAKEUP_ACT2_BITS ; i++) {
+		if (val2 == -1U)
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_OUTPUT_CHANGE_ACT_BITS);
+		else if (!(rtk_suspend_gpio_out_en2_get() &  (0x1U << i)))
+			n += sprintf(buf + n, "	| %d\n",
+				i + GPIO_OUTPUT_CHANGE_ACT_BITS);
+		else if (val2 & (0x1U << i))
+			n += sprintf(buf + n, "  H | %d\n",
+				i + GPIO_OUTPUT_CHANGE_ACT_BITS);
+		else
+			n += sprintf(buf + n, "  L | %d\n",
+				i + GPIO_OUTPUT_CHANGE_ACT_BITS);
+	}
+	n += sprintf(buf + n, "\n");
+
+	return n;
+}
+
+static ssize_t rtk_suspend_gpio_out_act_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+	int tmp;
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val >= SUSPEND_ISO_GPIO_SIZE)
+		return -ENOMEM;
+
+#if 1
+	return count;
+#endif
+
+	if (val < GPIO_OUTPUT_CHANGE_ACT_BITS) {
+		if (rtk_suspend_gpio_out_en_get() &  (0x1U << val)) {
+			tmp = (0x1U << val);
+			rtk_suspend_gpio_out_act_set(
+				rtk_suspend_gpio_out_act_get() ^ tmp);
+		}
+	} else {
+		if (rtk_suspend_gpio_out_en2_get() &
+			(0x1U << (val-GPIO_OUTPUT_CHANGE_ACT_BITS))) {
+			tmp = (0x1U << (val-GPIO_OUTPUT_CHANGE_ACT_BITS));
+			rtk_suspend_gpio_out_act2_set(
+				rtk_suspend_gpio_out_act2_get() ^ tmp);
+		}
+	}
+
+	return count;
+}
+
+static ssize_t rtk_suspend_timer_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	return sprintf(buf, " %d sec (reciprocal timer)\n",
+		rtk_suspend_timer_sec_get());
+}
+
+static ssize_t rtk_suspend_timer_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val > (AUDIO_RECIPROCAL_TIMER_GET(-1UL)))
+		return -ENOMEM;
+
+	rtk_suspend_timer_sec_set(val);
+	return count;
+}
+
+static ssize_t rtk_suspend_context_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	return sprintf(buf, "%d\n", suspend_context);
+}
+
+static ssize_t rtk_suspend_context_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	suspend_context = val;
+	return count;
+}
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+void rtk_domu_suspend_context_increase(void)
+{
+	suspend_context++;
+}
+#endif
+
+static struct kobj_attribute rtk_suspend_wakeup_attr =
+	RTK_SUSPEND_ATTR(wakeup);
+static struct kobj_attribute rtk_suspend_resume_state_attr =
+	RTK_SUSPEND_ATTR(resume_state);
+static struct kobj_attribute rtk_suspend_gpio_wakeup_en_attr =
+	RTK_SUSPEND_ATTR(gpio_wakeup_en);
+static struct kobj_attribute rtk_suspend_gpio_wakeup_act_attr =
+	RTK_SUSPEND_ATTR(gpio_wakeup_act);
+static struct kobj_attribute rtk_suspend_gpio_out_en_attr =
+	RTK_SUSPEND_ATTR(gpio_out_en);
+static struct kobj_attribute rtk_suspend_gpio_out_act_attr =
+	RTK_SUSPEND_ATTR(gpio_out_act);
+static struct kobj_attribute rtk_suspend_timer_attr =
+	RTK_SUSPEND_ATTR(timer);
+static struct kobj_attribute rtk_suspend_context_attr =
+	RTK_SUSPEND_ATTR(context);
+
+static struct attribute *rtk_suspend_attrs[] = {
+	&rtk_suspend_wakeup_attr.attr,
+	&rtk_suspend_resume_state_attr.attr,
+	&rtk_suspend_gpio_wakeup_en_attr.attr,
+	&rtk_suspend_gpio_wakeup_act_attr.attr,
+	&rtk_suspend_gpio_out_en_attr.attr,
+	&rtk_suspend_gpio_out_act_attr.attr,
+	&rtk_suspend_timer_attr.attr,
+	&rtk_suspend_context_attr.attr,
+	NULL,
+};
+
+static struct attribute_group rtk_suspend_attr_group = {
+	.attrs = rtk_suspend_attrs,
+};
+
+static struct kobject *rtk_suspend_kobj;
+
+static ssize_t pm_state_show(struct device *dev, struct device_attribute *attr,
+	char *buf)
+{
+	return sprintf(buf, "%d\n", pm_state);
+}
+
+static ssize_t pm_state_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_state = val;
+
+	return count;;
+}
+
+static ssize_t pm_wakelock_mode_show(struct device *dev, struct device_attribute *attr,
+	char *buf)
+{
+	return sprintf(buf, "%d\n", pm_wakelock_mode);
+}
+
+static ssize_t pm_wakelock_mode_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_wakelock_mode = val;
+
+	return count;;
+}
+
+static ssize_t pm_block_wakelock_show(
+    struct device *dev,
+    struct device_attribute *attr,
+    char *buf)
+{
+	return sprintf(buf, "%d\n", pm_block_wakelock);
+}
+
+static ssize_t pm_block_wakelock_store(
+    struct device *dev,
+    struct device_attribute *attr,
+    const char *buf,
+    size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_block_wakelock = val;
+
+	return count;;
+}
+
+static struct device_attribute pm_state_attr =
+	__ATTR(pm_state, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_state_show, pm_state_store);
+
+static struct device_attribute pm_wakelock_mode_attr =
+	__ATTR(pm_wakelock_mode, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_wakelock_mode_show, pm_wakelock_mode_store);
+
+static struct device_attribute pm_block_wakelock_attr =
+	__ATTR(pm_block_wakelock, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_block_wakelock_show, pm_block_wakelock_store);
+
+struct class *rtk_pm_class;
+struct device *rtk_pm_dev;
+
+static int __init suspend_sysfs_init(void)
+{
+	int ret;
+
+	pm_state = 0;
+	pm_wakelock_mode = 0;
+    pm_block_wakelock = 0;
+
+	rtk_pm_class = class_create(THIS_MODULE, "rtk_pm");
+	if (IS_ERR(rtk_pm_class))
+		return PTR_ERR(rtk_pm_class);
+
+	rtk_pm_dev =  device_create(rtk_pm_class, NULL,
+		MKDEV(0, 1), NULL, "android_control");
+	if (IS_ERR(rtk_pm_dev))
+		return PTR_ERR(rtk_pm_dev);
+
+	ret = device_create_file(rtk_pm_dev, &pm_state_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	ret = device_create_file(rtk_pm_dev, &pm_wakelock_mode_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	ret = device_create_file(rtk_pm_dev, &pm_block_wakelock_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	rtk_suspend_kobj = kobject_create_and_add("suspend", kernel_kobj);
+	if (!rtk_suspend_kobj)
+		return -ENOMEM;
+
+	ret = sysfs_create_group(rtk_suspend_kobj, &rtk_suspend_attr_group);
+	if (ret)
+		kobject_put(rtk_suspend_kobj);
+
+	return ret;
+}
+
+module_init(suspend_sysfs_init);
+#endif
+
diff --git a/drivers/soc/realtek/rtd139x/rtd139x_suspend.h b/drivers/soc/realtek/rtd139x/rtd139x_suspend.h
new file mode 100644
index 00000000..032e430
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtd139x_suspend.h
@@ -0,0 +1,193 @@
+/*
+ * rtd139x_suspend.h - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef RTD139X_SUSPEND_H_
+#define RTD139X_SUSPEND_H_
+
+#include <soc/realtek/rtk_ipc_shm.h>
+
+#define SETMASK(bits, pos) (((-1U) >> (32-bits)) << (pos))
+#define CLRMASK(bits, pos) (~(SETMASK(bits, pos)))
+#define SET_VAL(val,bits,pos) ((val << pos) & SETMASK(bits, pos))
+#define GET_VAL(reg,bits,pos) ((reg & SETMASK(bits, pos)) >> pos)
+
+#define AUTHOR_SHIFFT 30
+#define AUTHOR_BITS 2
+#define AUTHOR_MASK(val) SET_VAL(val,AUTHOR_BITS,AUTHOR_SHIFFT)
+#define AUTHOR_GET(reg) GET_VAL(reg,AUTHOR_BITS,AUTHOR_SHIFFT)
+#define AUTHOR_IS_SCPU(reg) (AUTHOR_GET(reg) == AUTHOR_SCPU)
+#define AUTHOR_IS_ACPU(reg) (AUTHOR_GET(reg) == AUTHOR_ACPU)
+
+#define NOTIFY_SHIFFT 0
+#define NOTIFY_BITS 8
+#define NOTIFY_MASK(val) SET_VAL(val,NOTIFY_BITS,NOTIFY_SHIFFT)
+#define NOTIFY_GET(reg) GET_VAL(reg,NOTIFY_BITS,NOTIFY_SHIFFT)
+
+#define SUSPEND_ISO_GPIO_BASE 0
+#define SUSPEND_ISO_GPIO_SIZE 57
+
+#define SUSPEND_MAGIC_KEY 0xEA
+#define SUSPEND_MAGIC_SHIFFT 24
+#define SUSPEND_MAGIC_BITS 8
+#define SUSPEND_MAGIC_MASK (SUSPEND_MAGIC_KEY << SUSPEND_MAGIC_SHIFFT)
+#define SUSPEND_MAGIC_GET(val) GET_VAL(val, 8, 24)
+
+#define WAKEUP_FLAGS_SHIFFT	 0
+#define WAKEUP_FLAGS_BITS (eWAKEUP_ON_MAX)
+#define WAKEUP_FLAGS_MASK(val) SET_VAL(val, WAKEUP_FLAGS_BITS, WAKEUP_FLAGS_SHIFFT)
+#define WAKEUP_FLAGS_GET(reg) GET_VAL(reg, WAKEUP_FLAGS_BITS, WAKEUP_FLAGS_SHIFFT)
+
+#define RESUME_STATE_SHIFFT 16
+#define RESUME_STATE_BITS 8
+#define RESUME_STATE_MASK(val) SET_VAL(val, RESUME_STATE_BITS, RESUME_STATE_SHIFFT)
+#define RESUME_STATE_GET(reg) GET_VAL(reg, RESUME_STATE_BITS, RESUME_STATE_SHIFFT)
+
+#define RESUME_DATA_SHIFFT 0
+#define RESUME_DATA_BITS 16
+#define RESUME_DATA_MASK(val) SET_VAL(val, RESUME_DATA_BITS, RESUME_DATA_SHIFFT)
+#define RESUME_DATA_GET(reg) GET_VAL(reg, RESUME_DATA_BITS, RESUME_DATA_SHIFFT)
+
+#define GPIO_WAKEUP_EN_SHIFFT 0
+#define GPIO_WAKEUP_EN_BITS	 24
+#define GPIO_WAKEUP_EN_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+#define GPIO_WAKEUP_EN_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN_BITS, GPIO_WAKEUP_EN_SHIFFT)
+
+#define GPIO_WAKEUP_ACT_SHIFFT 0
+#define GPIO_WAKEUP_ACT_BITS 24
+#define GPIO_WAKEUP_ACT_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+#define GPIO_WAKEUP_ACT_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT_BITS, GPIO_WAKEUP_ACT_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_EN_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_EN_BITS 24
+#define GPIO_OUTPUT_CHANGE_EN_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN_BITS, GPIO_OUTPUT_CHANGE_EN_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_ACT_BITS 24
+#define GPIO_OUTPUT_CHANGE_ACT_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT_BITS, GPIO_OUTPUT_CHANGE_ACT_SHIFFT)
+
+#define GPIO_WAKEUP_EN2_SHIFFT 0
+#define GPIO_WAKEUP_EN2_BITS 24
+#define GPIO_WAKEUP_EN2_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN2_BITS, GPIO_WAKEUP_EN2_SHIFFT)
+#define GPIO_WAKEUP_EN2_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN2_BITS, GPIO_WAKEUP_EN2_SHIFFT)
+
+#define GPIO_WAKEUP_ACT2_SHIFFT 0
+#define GPIO_WAKEUP_ACT2_BITS 24
+#define GPIO_WAKEUP_ACT2_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT2_BITS, GPIO_WAKEUP_ACT2_SHIFFT)
+#define GPIO_WAKEUP_ACT2_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT2_BITS, GPIO_WAKEUP_ACT2_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_EN2_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_EN2_BITS 24
+#define GPIO_OUTPUT_CHANGE_EN2_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_EN2_BITS, GPIO_OUTPUT_CHANGE_EN2_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_EN2_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_EN2_BITS, GPIO_OUTPUT_CHANGE_EN2_SHIFFT)
+
+#define GPIO_OUTPUT_CHANGE_ACT2_SHIFFT 0
+#define GPIO_OUTPUT_CHANGE_ACT2_BITS 24
+#define GPIO_OUTPUT_CHANGE_ACT2_MASK(val) SET_VAL(val, GPIO_OUTPUT_CHANGE_ACT2_BITS, GPIO_OUTPUT_CHANGE_ACT2_SHIFFT)
+#define GPIO_OUTPUT_CHANGE_ACT2_GET(reg) GET_VAL(reg, GPIO_OUTPUT_CHANGE_ACT2_BITS, GPIO_OUTPUT_CHANGE_ACT2_SHIFFT)
+
+#define GPIO_WAKEUP_EN3_SHIFFT 0
+#define GPIO_WAKEUP_EN3_BITS 9
+#define GPIO_WAKEUP_EN3_MASK(val) SET_VAL(val, GPIO_WAKEUP_EN3_BITS, GPIO_WAKEUP_EN3_SHIFFT)
+#define GPIO_WAKEUP_EN3_GET(reg) GET_VAL(reg, GPIO_WAKEUP_EN3_BITS, GPIO_WAKEUP_EN3_SHIFFT)
+
+#define GPIO_WAKEUP_ACT3_SHIFFT 0
+#define GPIO_WAKEUP_ACT3_BITS 9
+#define GPIO_WAKEUP_ACT3_MASK(val) SET_VAL(val, GPIO_WAKEUP_ACT3_BITS, GPIO_WAKEUP_ACT3_SHIFFT)
+#define GPIO_WAKEUP_ACT3_GET(reg) GET_VAL(reg, GPIO_WAKEUP_ACT3_BITS, GPIO_WAKEUP_ACT3_SHIFFT)
+
+#define AUDIO_RECIPROCAL_TIMER_SHIFFT 0
+#define AUDIO_RECIPROCAL_TIMER_BITS 24
+#define AUDIO_RECIPROCAL_TIMER_MASK(val) SET_VAL(val, AUDIO_RECIPROCAL_TIMER_BITS, AUDIO_RECIPROCAL_TIMER_SHIFFT)
+#define AUDIO_RECIPROCAL_TIMER_GET(reg) GET_VAL(reg, AUDIO_RECIPROCAL_TIMER_BITS, AUDIO_RECIPROCAL_TIMER_SHIFFT)
+
+enum {
+	AUTHOR_SCPU = 0x1,
+	AUTHOR_ACPU,
+};
+
+enum _notify_flag{
+	NOTIFY_NONE,
+	NOTIFY_SUSPEND_TO_RAM = 0x01,
+	NOTIFY_SUSPEND_TO_COOLBOOT,
+	NOTIFY_SUSPEND_TO_WFI,
+
+	NOTIFY_RESUME_PLATFORM = 0x10,
+	NOTIFY_RESUME_END,
+	NOTIFY_SCPU_READY,
+	NOTIFY_ACPU_READY,
+};
+
+enum _suspend_mode {
+	SUSPEND_TO_RAM,
+	SUSPEND_TO_COOLBOOT,
+	SUSPEND_TO_WFI,
+	MAX_SUSPEND_MODE,
+};
+
+const char *const rtk_suspend_states[MAX_SUSPEND_MODE] = {
+	[SUSPEND_TO_RAM] = "ram",
+	[SUSPEND_TO_COOLBOOT] = "coolboot",
+	[SUSPEND_TO_WFI] = "wfi",
+};
+
+enum _suspend_wakeup {
+	eWAKEUP_ON_LAN,
+	eWAKEUP_ON_IR,
+	eWAKEUP_ON_GPIO,
+	eWAKEUP_ON_ALARM,
+	eWAKEUP_ON_TIMER,
+	eWAKEUP_ON_CEC,
+	eWAKEUP_ON_MAX,
+};
+
+const char *const rtk_suspend_wakeup_states[eWAKEUP_ON_MAX] = {
+	[eWAKEUP_ON_LAN] = "lan",
+	[eWAKEUP_ON_IR] = "ir",
+	[eWAKEUP_ON_GPIO] = "gpio",
+	[eWAKEUP_ON_ALARM] = "alarm",
+	[eWAKEUP_ON_TIMER] = "timer",
+	[eWAKEUP_ON_CEC] = "cec",
+};
+
+enum _wakeup_flags {
+	fWAKEUP_ON_LAN = 0x1U << eWAKEUP_ON_LAN,
+	fWAKEUP_ON_IR = 0x1U << eWAKEUP_ON_IR,
+	fWAKEUP_ON_GPIO = 0x1U << eWAKEUP_ON_GPIO,
+	fWAKEUP_ON_ALARM = 0x1U << eWAKEUP_ON_ALARM,
+	fWAKEUP_ON_TIMER = 0x1U << eWAKEUP_ON_TIMER,
+	fWAKEUP_ON_CEC = 0x1U << eWAKEUP_ON_CEC,
+};
+
+enum _RESUME_STATE {
+	RESUME_NONE	 = 0,
+	RESUME_UNKNOW,
+	RESUME_IR,
+	RESUME_GPIO,
+	RESUME_LAN,
+	RESUME_ALARM,
+	RESUME_TIMER,
+	RESUME_CEC,
+	RESUME_MAX_STATE,
+};
+
+const char *const rtk_suspend_resume_states[RESUME_MAX_STATE] = {
+	[RESUME_NONE] = "none",
+	[RESUME_UNKNOW] = "unknow",
+	[RESUME_IR] = "ir",
+	[RESUME_GPIO] = "gpio",
+	[RESUME_LAN] = "lan",
+	[RESUME_ALARM] = "alarm",
+	[RESUME_TIMER] = "timer",
+	[RESUME_CEC] = "cec",
+};
+
+#endif /* RTD139X_SUSPEND_H_ */
diff --git a/drivers/soc/realtek/rtd139x/rtk_chip.c b/drivers/soc/realtek/rtd139x/rtk_chip.c
new file mode 100644
index 00000000..ac1b91d
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_chip.c
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <soc/realtek/rtk_chip.h>
+#include <linux/module.h>
+#include <linux/io.h>
+
+#define SB2_BASE_ADDR   0x9801A000
+#define CHIP_ID_ADDR    0x98007028
+
+#define	CHIP_ID		0x00000200
+#define CHIP_REV	0x00000204
+
+#define RTK1392_CPU_MASK 0x00001000
+
+#define RTD139x_CHIP_A00 (0x00000000)
+#define RTD139x_CHIP_A01 (0x00010000)
+#define RTD139x_CHIP_A02 (0x00020000)
+
+int get_rtd_chip_id(void)
+{
+	int cpu_id;
+	void __iomem *id_addr = ioremap(CHIP_ID_ADDR, 0x4);
+
+	cpu_id = CHIP_ID_RTD1395;
+
+	if (readl(id_addr) & RTK1392_CPU_MASK)
+		cpu_id = CHIP_ID_RTD1392;
+
+	__iounmap(id_addr);
+
+	return cpu_id;
+}
+EXPORT_SYMBOL(get_rtd_chip_id);
+
+int get_rtd_chip_revision(void)
+{
+	int chip_revision = RTD_CHIP_A00;
+	void __iomem *chip_revision_addr = ioremap(SB2_BASE_ADDR + CHIP_REV, 0x4);
+
+	int val = readl(chip_revision_addr);
+
+	__iounmap(chip_revision_addr);
+
+	switch (val) {
+	case (RTD139x_CHIP_A00):
+		return RTD_CHIP_A00;
+	case (RTD139x_CHIP_A01):
+		return RTD_CHIP_A01;
+	case (RTD139x_CHIP_A02):
+		return RTD_CHIP_A02;
+	default:
+		printk("%s: Not define chip revision 0x%x\n", __func__, val);
+	}
+	return 0;
+}
+EXPORT_SYMBOL(get_rtd_chip_revision);
diff --git a/drivers/soc/realtek/rtd139x/rtk_usb.c b/drivers/soc/realtek/rtd139x/rtk_usb.c
new file mode 100644
index 00000000..e5178de
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_usb.c
@@ -0,0 +1,228 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_gpio.h>
+#include <linux/usb/otg.h>
+#include <soc/realtek/rtk_usb.h>
+#include <soc/realtek/rtk_chip.h>
+
+struct rtk_usb {
+	struct power_ctrl_reg {
+		u32 usb_ctrl;
+		/* Port 0~2 */
+		u32 usb0_sram_pwr3;
+		u32 usb0_sram_pwr4;
+		/* l4_icg */
+		u32 p0_l4_icg;
+		u32 p1_l4_icg;
+	} power_ctrl_reg;
+
+	bool usb_power_cut;
+
+	struct type_c {
+		int connector_switch_gpio;
+	} type_c;
+};
+
+static struct rtk_usb *rtk_usb;
+
+/* set usb charger power */
+void rtk_usb_set_charger_power(struct rtk_usb *rtk_usb, unsigned int val)
+{
+	if (!rtk_usb)
+		return;
+
+	return;
+}
+
+int rtk_usb_set_hw_l4icg_on_off(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool on)
+{
+	void __iomem *reg;
+
+	if (!rtk_usb)
+		return 0;
+
+	switch (port_num) {
+	case USB_PORT_0:
+		if (rtk_usb->power_ctrl_reg.p0_l4_icg) {
+			pr_info("%s set l4_icg port %d\n", __func__, port_num);
+			reg = ioremap(rtk_usb->power_ctrl_reg.p0_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	case USB_PORT_1:
+	case USB_PORT_2:
+		if (rtk_usb->power_ctrl_reg.p1_l4_icg) {
+			pr_info("%s set l4_icg port %d\n", __func__, port_num);
+			reg = ioremap(rtk_usb->power_ctrl_reg.p1_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	default:
+		pr_err("%s Error Port num %d\n", __func__, port_num);
+		break;
+	}
+
+	return 0;
+}
+
+int rtk_usb_iso_power_ctrl(struct rtk_usb *rtk_usb,
+	    bool power_on)
+{
+	if (!rtk_usb)
+		return 0;
+
+	pr_debug("%s START\n", __func__);
+
+	if (rtk_usb->usb_power_cut &&
+		    rtk_usb->power_ctrl_reg.usb_ctrl &&
+		    rtk_usb->power_ctrl_reg.usb0_sram_pwr3 &&
+		    rtk_usb->power_ctrl_reg.usb0_sram_pwr4) {
+		void __iomem *usb0_sram_pwr3 =
+			    ioremap(rtk_usb->power_ctrl_reg.usb0_sram_pwr3, 0x4);
+		void __iomem *usb0_sram_pwr4 =
+			    ioremap(rtk_usb->power_ctrl_reg.usb0_sram_pwr4, 0x4);
+		void __iomem *usb_ctrl = ioremap(rtk_usb->power_ctrl_reg.usb_ctrl, 0x4);
+
+		pr_info("%s power_%s ([0x%x=0x%08x)\n", __func__, power_on?"on":"off",
+			    rtk_usb->power_ctrl_reg.usb_ctrl, readl(usb_ctrl));
+		if (power_on) {
+			writel((BIT(0) | BIT(1) | BIT(4) | BIT(5) |BIT(6)) |
+				     readl(usb_ctrl), usb_ctrl);
+			writel(0x00000f00, usb0_sram_pwr4);
+			writel(~(BIT(8) | BIT(9)) & readl(usb_ctrl), usb_ctrl);
+		} else {
+			writel((BIT(8) | BIT(9)) | readl(usb_ctrl), usb_ctrl);
+			// port0-port2 sram
+			writel(0, usb0_sram_pwr3);
+			writel(0x00000f01, usb0_sram_pwr4);
+			writel(~(BIT(0) | BIT(1) | BIT(4) | BIT(5) |BIT(6)) &
+				     readl(usb_ctrl), usb_ctrl);
+		}
+		pr_info("set power_domain %s ([0x%x]=0x%08x)\n", power_on?"on":"off",
+			    rtk_usb->power_ctrl_reg.usb_ctrl, readl(usb_ctrl));
+		iounmap(usb_ctrl);
+		iounmap(usb0_sram_pwr3);
+		iounmap(usb0_sram_pwr4);
+	}
+	pr_debug("%s END\n", __func__);
+	return 0;
+}
+
+int rtk_usb_port_suspend_resume(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool is_suspend)
+{
+	if (!rtk_usb)
+		return 0;
+
+	return 0;
+}
+
+int rtk_type_c_init(struct rtk_usb *rtk_usb)
+{
+	if (!rtk_usb)
+		return 0;
+
+	return 0;
+}
+
+int rtk_type_c_plug_config(struct rtk_usb *rtk_usb, int dr_mode, int cc)
+{
+	bool high;
+
+	/* host / device */
+	if (dr_mode == USB_DR_MODE_PERIPHERAL) {
+		high = true;
+	} else if (dr_mode == USB_DR_MODE_HOST) {
+		high = false;
+	} else {
+		goto out;
+	}
+
+	if (rtk_usb->type_c.connector_switch_gpio != -1 &&
+		    gpio_is_valid(rtk_usb->type_c.connector_switch_gpio)) {
+		pr_info("%s Set connector to %s by gpio %d\n",
+			    __func__, high?"device":"host",
+			    rtk_usb->type_c.connector_switch_gpio);
+		if (gpio_direction_output(rtk_usb->type_c.connector_switch_gpio, high))
+			pr_err("%s ERROR set connector_switch_gpio fail\n",
+				    __func__);
+	}
+
+out:
+	return 0;
+}
+
+
+struct rtk_usb *rtk_usb_soc_init(struct device_node *node)
+{
+	struct device_node *sub_node;
+
+	if (!rtk_usb)
+		rtk_usb = kzalloc(sizeof(struct rtk_usb), GFP_KERNEL);
+
+	pr_info("%s START (%s)\n", __func__, __FILE__);
+	sub_node = of_get_child_by_name(node, "power_ctrl_reg");
+	if (sub_node) {
+		pr_debug("%s sub_node %s\n", __func__, sub_node->name);
+		of_property_read_u32(sub_node,
+			    "usb_ctrl", &rtk_usb->power_ctrl_reg.usb_ctrl);
+		/* Port 0~2 */
+		of_property_read_u32(sub_node,
+			    "usb0_sram_pwr3",
+			    &rtk_usb->power_ctrl_reg.usb0_sram_pwr3);
+		of_property_read_u32(sub_node,
+			    "usb0_sram_pwr4",
+			    &rtk_usb->power_ctrl_reg.usb0_sram_pwr4);
+
+		of_property_read_u32(sub_node,
+			    "p0_l4_icg", &rtk_usb->power_ctrl_reg.p0_l4_icg);
+		of_property_read_u32(sub_node,
+			    "p1_l4_icg", &rtk_usb->power_ctrl_reg.p1_l4_icg);
+
+		if (of_property_read_bool(sub_node, "usb_power_cut"))
+			rtk_usb->usb_power_cut = true;
+		else
+			rtk_usb->usb_power_cut = false;
+
+	}
+
+	sub_node = of_get_child_by_name(node, "type_c");
+	if (sub_node) {
+		int gpio;
+		pr_debug("%s sub_node %s\n", __func__, sub_node->name);
+
+		gpio = of_get_named_gpio(sub_node, "realtek,connector_switch-gpio", 0);
+		if (gpio_is_valid(gpio)) {
+			rtk_usb->type_c.connector_switch_gpio = gpio;
+			pr_info("%s get connector_switch-gpio (id=%d) OK\n",
+				    __func__, gpio);
+		} else {
+			pr_info("connector_switch-gpio no found");
+			rtk_usb->type_c.connector_switch_gpio = -1;
+		}
+	}
+
+	pr_info("%s END\n", __func__);
+	return rtk_usb;
+}
+
+int rtk_usb_soc_free(struct rtk_usb **rtk_usb)
+{
+	if (*rtk_usb) {
+		kfree(*rtk_usb);
+		*rtk_usb = NULL;
+	}
+	return 0;
+}
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/Kconfig b/drivers/soc/realtek/rtd139x/rtk_ve/Kconfig
new file mode 100644
index 00000000..226e865
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/Kconfig
@@ -0,0 +1,25 @@
+#
+# Realtek codec configuration
+#
+
+menuconfig RTK_CODEC
+	bool "Realtek Codec"
+	default n
+
+if RTK_CODEC
+
+if ION
+config RTK_RESERVE_MEMORY
+	bool "RTK Reserve Memory for Video/Image Codec"
+	default n
+endif # ION
+
+config VE1_CODEC
+	bool "RTK Video Engine 1 Codec"
+	default n
+
+config IMAGE_CODEC
+	bool "RTK Image Codec"
+	default n
+
+endif # RTK_CODEC
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/Makefile b/drivers/soc/realtek/rtd139x/rtk_ve/Makefile
new file mode 100644
index 00000000..bcb1bfb
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/Makefile
@@ -0,0 +1,7 @@
+#
+# Makefile for the Realtek codec drivers.
+#
+
+obj-$(CONFIG_RTK_CODEC)		+= puwrap.o
+obj-$(CONFIG_VE1_CODEC)		+= ve1/
+obj-$(CONFIG_IMAGE_CODEC)	+= jdi/
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/jdi/Makefile b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/Makefile
new file mode 100644
index 00000000..40bef4c
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/Makefile
@@ -0,0 +1,6 @@
+# rtk_jcodec
+
+obj-$(CONFIG_IMAGE_CODEC) += jpu.o
+ifdef CONFIG_COMPAT
+obj-$(CONFIG_IMAGE_CODEC) += compat_jpu.o
+endif
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/jdi/compat_jpu.c b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/compat_jpu.c
new file mode 100644
index 00000000..fb5d79f
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/compat_jpu.c
@@ -0,0 +1,324 @@
+/*
+ * drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/compat.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#include "jpu.h"
+#include "compat_jpu.h"
+
+/* See drivers/soc/realtek/rtd129x/rtk_ve/jdi/jpu.h for the definition of these structs */
+typedef struct compat_jpudrv_buffer_t {
+    compat_uint_t size;
+    compat_ulong_t phys_addr;
+    compat_ulong_t base;							/* kernel logical address in use kernel */
+    compat_ulong_t virt_addr;				/* virtual user space address */
+} compat_jpudrv_buffer_t;
+
+typedef struct compat_jpudrv_intr_info_t {
+    compat_uint_t timeout;
+    compat_int_t intr_reason;
+} compat_jpudrv_intr_info_t;
+
+typedef struct compat_jpudrv_dovi_info_t{
+	compat_uint_t inst_idx;
+	compat_uint_t enable;
+} compat_jpudrv_dovi_info_t;
+
+#define COMPAT_JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(JDI_IOCTL_MAGIC, 0)
+#define COMPAT_JDI_IOCTL_FREE_PHYSICALMEMORY _IO(JDI_IOCTL_MAGIC, 1)
+#define COMPAT_JDI_IOCTL_WAIT_INTERRUPT _IO(JDI_IOCTL_MAGIC, 2)
+#define COMPAT_JDI_IOCTL_GET_INSTANCE_POOL _IO(JDI_IOCTL_MAGIC, 5)
+#define COMPAT_JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(JDI_IOCTL_MAGIC, 6)
+#define COMPAT_JDI_IOCTL_GET_REGISTER_INFO _IO(JDI_IOCTL_MAGIC, 11)
+#define COMPAT_JDI_IOCTL_GET_BONDING_INFO _IO(JDI_IOCTL_MAGIC, 13)
+#define COMPAT_JDI_IOCTL_SET_RTK_DOVI_FLAG _IO(JDI_IOCTL_MAGIC, 14)
+
+static int compat_get_jpu_buffer_data(
+    compat_jpudrv_buffer_t __user *data32,
+    jpudrv_buffer_t __user *data)
+{
+    compat_uint_t s;
+    compat_ulong_t p;
+    compat_ulong_t b;
+    compat_ulong_t v;
+    int err;
+
+    err = get_user(s, &data32->size);
+    err |= put_user(s, &data->size);
+    err |= get_user(p, &data32->phys_addr);
+    err |= put_user(p, &data->phys_addr);
+    err |= get_user(b, &data32->base);
+    err |= put_user(b, &data->base);
+    err |= get_user(v, &data32->virt_addr);
+    err |= put_user(v, &data->virt_addr);
+
+    return err;
+}
+
+static int compat_get_jpu_intr_info_data(
+    compat_jpudrv_intr_info_t __user *data32,
+    jpudrv_intr_info_t __user *data)
+{
+    compat_uint_t t;
+    compat_int_t i;
+    int err;
+
+    err = get_user(t, &data32->timeout);
+    err |= put_user(t, &data->timeout);
+    err |= get_user(i, &data32->intr_reason);
+    err |= put_user(i, &data->intr_reason);
+
+    return err;
+}
+
+static int compat_get_jpu_dovi_info(
+	compat_jpudrv_dovi_info_t __user *data32,
+	jpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t e;
+	compat_uint_t i;
+	int err;
+
+	err |= get_user(i, &data32->inst_idx);
+	err |= put_user(i, &data->inst_idx);
+	err |= get_user(e, &data32->enable);
+	err |= put_user(e, &data->enable);
+
+	return err;
+}
+
+static int compat_put_jpu_buffer_data(
+    compat_jpudrv_buffer_t __user *data32,
+    jpudrv_buffer_t __user *data)
+{
+    compat_uint_t s;
+    compat_ulong_t p;
+    compat_ulong_t b;
+    compat_ulong_t v;
+    int err;
+
+    err = get_user(s, &data->size);
+    err |= put_user(s, &data32->size);
+    err |= get_user(p, &data->phys_addr);
+    err |= put_user(p, &data32->phys_addr);
+    err |= get_user(b, &data->base);
+    err |= put_user(b, &data32->base);
+    err |= get_user(v, &data->virt_addr);
+    err |= put_user(v, &data32->virt_addr);
+
+    return err;
+}
+
+static int compat_put_jpu_intr_info_data(
+    compat_jpudrv_intr_info_t __user *data32,
+    jpudrv_intr_info_t __user *data)
+{
+    compat_uint_t t;
+    compat_int_t i;
+    int err;
+
+    err = get_user(t, &data->timeout);
+    err |= put_user(t, &data32->timeout);
+    err |= get_user(i, &data->intr_reason);
+    err |= put_user(i, &data32->intr_reason);
+
+    return err;
+}
+
+static int compat_put_jpu_dovi_info(
+	compat_jpudrv_dovi_info_t __user *data32,
+	jpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t i;
+	compat_uint_t e;
+	int err;
+
+	err |= get_user(i, &data->inst_idx);
+	err |= put_user(i, &data32->inst_idx);
+	err |= get_user(e, &data->enable);
+	err |= put_user(e, &data32->enable);
+
+	return err;
+}
+
+long compat_jpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+    long ret = 0;
+
+    if (!filp->f_op->unlocked_ioctl)
+        return -ENOTTY;
+
+    switch (cmd)
+    {
+    case COMPAT_JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_FREE_PHYSICALMEMORY:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+
+        return filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_FREE_PHYSICALMEMORY, (unsigned long)data);
+    }
+
+    case COMPAT_JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_WAIT_INTERRUPT:
+    {
+        compat_jpudrv_intr_info_t __user *data32;
+        jpudrv_intr_info_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_intr_info_data(data32, data);
+        if (err)
+            return err;
+
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_WAIT_INTERRUPT, (unsigned long)data);
+        err = compat_put_jpu_intr_info_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case JDI_IOCTL_ENABLE_INTERRUPT:
+    case JDI_IOCTL_SET_CLOCK_GATE:
+    case JDI_IOCTL_OPEN_INSTANCE:
+    case JDI_IOCTL_CLOSE_INSTANCE:
+    case JDI_IOCTL_GET_INSTANCE_NUM:
+    case JDI_IOCTL_RESET:
+    case JDI_IOCTL_SET_CLOCK_ENABLE:
+    {
+        return filp->f_op->unlocked_ioctl(filp, cmd,
+                                          (unsigned long)compat_ptr(arg));
+    }
+
+    case COMPAT_JDI_IOCTL_GET_INSTANCE_POOL:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_INSTANCE_POOL, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_GET_REGISTER_INFO:
+    case COMPAT_JDI_IOCTL_GET_BONDING_INFO:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        if (cmd == COMPAT_JDI_IOCTL_GET_REGISTER_INFO)
+            ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_REGISTER_INFO, (unsigned long)data);
+        else
+            ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_BONDING_INFO, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+	case COMPAT_JDI_IOCTL_SET_RTK_DOVI_FLAG:
+	{
+		compat_jpudrv_dovi_info_t __user *data32;
+		jpudrv_dovi_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_jpu_dovi_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_SET_RTK_DOVI_FLAG, (unsigned long)data);
+		err = compat_put_jpu_dovi_info(data32, data);
+		return ret ? ret : err;
+	}
+
+    default:
+    {
+        printk(KERN_ERR "[COMPAT JPU]No such IOCTL, cmd is %d\n", cmd);
+        return -ENOIOCTLCMD;
+    }
+    }
+}
+
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/jdi/compat_jpu.h b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/compat_jpu.h
new file mode 100644
index 00000000..2d920c9
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/compat_jpu.h
@@ -0,0 +1,31 @@
+/*
+
+ * drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_COMPAT_JPU_H
+#define _LINUX_COMPAT_JPU_H
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+long compat_jpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+
+#else
+
+#define compat_jpu_ioctl  NULL
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_JPU_H */
+
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/jdi/jmm.h b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/jmm.h
new file mode 100644
index 00000000..e54a228
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/jmm.h
@@ -0,0 +1,647 @@
+#ifndef __JPU_MM_H__
+#define __JPU_MM_H__
+
+
+typedef unsigned long long  jmem_key_t;
+
+#define JMEM_PAGE_SIZE           (16*1024)
+#define MAKE_KEY(_a, _b)        (((jmem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key)      (_key>>32)
+
+typedef struct page_struct {
+    int             pageno;
+    unsigned long   addr;
+    int             used;
+    int             alloc_pages;
+    int             first_pageno;
+} page_t;
+
+
+typedef struct avl_node_struct {
+    jmem_key_t   key;
+    int     height;
+    page_t* page;
+    struct avl_node_struct* left;
+    struct avl_node_struct* right;
+} avl_node_t;
+
+
+typedef struct _jpu_mm_struct {
+    avl_node_t*     free_tree;
+    avl_node_t*     alloc_tree;
+    page_t*         page_list;
+    int             num_pages;
+    unsigned long   base_addr;
+    unsigned long   mem_size;
+    int             free_page_count;
+    int             alloc_page_count;
+} jpu_mm_t;
+
+
+
+#define VMEM_P_ALLOC(_x)         kmalloc(_x, GFP_KERNEL)
+#define VMEM_P_FREE(_x)          kfree(_x)
+
+#define VMEM_ASSERT(_exp)        if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/
+}
+#define VMEM_HEIGHT(_tree)       (_tree==NULL ? -1 : _tree->height)
+
+
+#define MAX(_a, _b)         (_a >= _b ? _a : _b)
+
+typedef enum {
+    LEFT,
+    RIGHT
+} rotation_dir_t;
+
+
+
+typedef struct avl_node_data_struct {
+    int     key;
+    page_t* page;
+} avl_node_data_t;
+
+static avl_node_t*
+make_avl_node(
+    jmem_key_t key,
+    page_t* page
+)
+{
+    avl_node_t* node = (avl_node_t*)VMEM_P_ALLOC(sizeof(avl_node_t));
+    node->key     = key;
+    node->page    = page;
+    node->height  = 0;
+    node->left    = NULL;
+    node->right   = NULL;
+
+    return node;
+}
+
+
+static int
+get_balance_factor(
+    avl_node_t* tree
+)
+{
+    int factor = 0;
+    if (tree) {
+        factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+    }
+
+    return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *      A                      B
+ *       \                    / \
+ *        B         =>       A   C
+ *       /  \                 \
+ *      D    C                 D
+ *
+ */
+static avl_node_t*
+rotation_left(
+    avl_node_t* tree
+)
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    rchild = tree->right;
+    if (rchild == NULL) {
+        return tree;
+    }
+
+    lchild = rchild->left;
+    rchild->left = tree;
+    tree->right = lchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+    return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *         A                  B
+ *       \                  /  \
+ *      B         =>       D    A
+ *    /  \                     /
+ *   D    C                   C
+ *
+ */
+static avl_node_t*
+rotation_right(
+    avl_node_t* tree
+)
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    lchild = tree->left;
+    if (lchild == NULL) return NULL;
+
+    rchild = lchild->right;
+    lchild->right = tree;
+    tree->left = rchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+    return lchild;
+}
+
+static avl_node_t*
+do_balance(
+    avl_node_t* tree
+)
+{
+    int bfactor = 0, child_bfactor;       /* balancing factor */
+
+    bfactor = get_balance_factor(tree);
+
+    if (bfactor >= 2) {
+        child_bfactor = get_balance_factor(tree->right);
+        if (child_bfactor == 1 || child_bfactor == 0) {
+            tree = rotation_left(tree);
+        } else if (child_bfactor == -1) {
+            tree->right = rotation_right(tree->right);
+            tree        = rotation_left(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    } else if (bfactor <= -2) {
+        child_bfactor = get_balance_factor(tree->left);
+        if (child_bfactor == -1 || child_bfactor == 0) {
+            tree = rotation_right(tree);
+        } else if (child_bfactor == 1) {
+            tree->left = rotation_left(tree->left);
+            tree       = rotation_right(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    }
+
+    return tree;
+}
+static avl_node_t*
+unlink_end_node(
+    avl_node_t* tree,
+    int dir,
+    avl_node_t** found_node
+)
+{
+    avl_node_t* node;
+    *found_node = NULL;
+
+    if (tree == NULL) return NULL;
+
+    if (dir == LEFT) {
+        if (tree->left == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    } else {
+        if (tree->right == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    }
+
+    if (dir == LEFT) {
+        node = tree->left;
+        tree->left = unlink_end_node(tree->left, LEFT, found_node);
+        if (tree->left == NULL) {
+            tree->left = (*found_node)->right;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    } else {
+        node = tree->right;
+        tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+        if (tree->right == NULL) {
+            tree->right = (*found_node)->left;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    }
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return do_balance(tree);
+}
+
+
+static avl_node_t*
+avltree_insert(
+    avl_node_t* tree,
+    jmem_key_t key,
+    page_t* page
+)
+{
+    if (tree == NULL) {
+        tree = make_avl_node(key, page);
+    } else {
+        if (key >= tree->key) {
+            tree->right = avltree_insert(tree->right, key, page);
+        } else {
+            tree->left  = avltree_insert(tree->left, key, page);
+        }
+    }
+
+    tree = do_balance(tree);
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return tree;
+}
+
+static avl_node_t*
+do_unlink(
+    avl_node_t* tree
+)
+{
+    avl_node_t* node;
+    avl_node_t* end_node;
+    node = unlink_end_node(tree->right, LEFT, &end_node);
+    if (node) {
+        tree->right = node;
+    } else {
+        node = unlink_end_node(tree->left, RIGHT, &end_node);
+        if (node) tree->left = node;
+    }
+
+    if (node == NULL) {
+        node = tree->right ? tree->right : tree->left;
+        end_node = node;
+    }
+
+    if (end_node) {
+        end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+        end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+        end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+    }
+
+    tree = end_node;
+
+    return tree;
+}
+
+static avl_node_t*
+avltree_remove(
+    avl_node_t* tree,
+    avl_node_t** found_node,
+    jmem_key_t key
+)
+{
+    *found_node = NULL;
+    if (tree == NULL) {
+        printk(KERN_INFO "failed to find key %d\n", (int)key);
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found_node = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = avltree_remove(tree->right, found_node, key);
+    } else {
+        tree->left  = avltree_remove(tree->left, found_node, key);
+    }
+
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+void
+jpu_avltree_free(
+    avl_node_t* tree
+)
+{
+    if (tree == NULL) return;
+    if (tree->left == NULL && tree->right == NULL) {
+        VMEM_P_FREE(tree);
+        return;
+    }
+
+    jpu_avltree_free(tree->left);
+    tree->left = NULL;
+    jpu_avltree_free(tree->right);
+    tree->right = NULL;
+}
+
+
+
+
+static avl_node_t*
+remove_approx_value(
+    avl_node_t* tree,
+    avl_node_t** found,
+    jmem_key_t key
+)
+{
+    *found = NULL;
+    if (tree == NULL) {
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = remove_approx_value(tree->right, found, key);
+    } else {
+        tree->left  = remove_approx_value(tree->left, found, key);
+        if (*found == NULL) {
+            *found = tree;
+            tree = do_unlink(tree);
+        }
+    }
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+static void
+set_blocks_free(
+    jpu_mm_t *mm,
+    int pageno,
+    int npages
+)
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    VMEM_ASSERT(npages);
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+    last_page   = &mm->page_list[last_pageno];
+    last_page->first_pageno = pageno;
+
+    mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void
+set_blocks_alloc(
+    jpu_mm_t *mm,
+    int pageno,
+    int npages
+)
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 1;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+
+    last_page   = &mm->page_list[last_pageno];
+    last_page->first_pageno = pageno;
+
+    mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int
+jmem_init(
+    jpu_mm_t* mm,
+    unsigned long addr,
+    unsigned long size
+)
+{
+    int i;
+
+
+    mm->base_addr  = (addr+(JMEM_PAGE_SIZE-1))&~(JMEM_PAGE_SIZE-1);
+    mm->mem_size   = size&~JMEM_PAGE_SIZE;
+    mm->num_pages  = mm->mem_size/JMEM_PAGE_SIZE;
+    mm->page_list  = (page_t*)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = mm->num_pages;
+    mm->alloc_page_count = 0;
+
+    for (i=0; i<mm->num_pages; i++) {
+        mm->page_list[i].pageno       = i;
+        mm->page_list[i].addr         = mm->base_addr + i*JMEM_PAGE_SIZE;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    set_blocks_free(mm, 0, mm->num_pages);
+
+    return 0;
+}
+
+int
+jmem_exit(
+    jpu_mm_t* mm
+)
+{
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_exit: invalid handle\n");
+        return -1;
+    }
+
+    if (mm->free_tree) {
+        jpu_avltree_free(mm->free_tree);
+    }
+    if (mm->alloc_tree) {
+        jpu_avltree_free(mm->alloc_tree);
+    }
+
+    VMEM_P_FREE(mm->page_list);
+
+    mm->base_addr  = 0;
+    mm->mem_size   = 0;
+    mm->num_pages  = 0;
+    mm->page_list  = NULL;
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = 0;
+    mm->alloc_page_count = 0;
+    return 0;
+}
+
+unsigned long
+jmem_alloc(
+    jpu_mm_t* mm,
+    int size,
+    unsigned long pid
+)
+{
+    avl_node_t* node;
+    page_t*     free_page;
+    int         npages, free_size;
+    int         alloc_pageno;
+    unsigned long  ptr;
+
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_alloc: invalid handle\n");
+        return -1;
+    }
+
+    if (size <= 0) return -1;
+
+    npages = (size + JMEM_PAGE_SIZE -1)/JMEM_PAGE_SIZE;
+
+    mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+    if (node == NULL) {
+        return -1;
+    }
+    free_page = node->page;
+    free_size = KEY_TO_VALUE(node->key);
+
+    alloc_pageno = free_page->pageno;
+    set_blocks_alloc(mm, alloc_pageno, npages);
+    if (npages != free_size) {
+        int free_pageno = alloc_pageno + npages;
+        set_blocks_free(mm, free_pageno, (free_size-npages));
+    }
+
+    VMEM_P_FREE(node);
+
+    ptr = mm->page_list[alloc_pageno].addr;
+    mm->alloc_page_count += npages;
+    mm->free_page_count  -= npages;
+
+
+    return ptr;
+}
+
+int
+jmem_free(
+    jpu_mm_t* mm,
+    unsigned long ptr,
+    unsigned long pid
+)
+{
+    unsigned long addr;
+    avl_node_t* found;
+    page_t* page;
+    int pageno, prev_free_pageno, next_free_pageno;
+    int prev_size, next_size;
+    int merge_page_no, merge_page_size, free_page_size;
+
+
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_free: invalid handle\n");
+        return -1;
+    }
+
+    addr = ptr;
+
+    mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+    if (found == NULL) {
+        printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+        VMEM_ASSERT(0);
+        return -1;
+    }
+
+    /* find previous free block */
+    page = found->page;
+    pageno = page->pageno;
+    free_page_size = page->alloc_pages;
+    prev_free_pageno = pageno-1;
+    prev_size = -1;
+    if (prev_free_pageno >= 0) {
+        if (mm->page_list[prev_free_pageno].used == 0) {
+            prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+            prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+        }
+    }
+
+    /* find next free block */
+    next_free_pageno = pageno + page->alloc_pages;
+    next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+    next_size = -1;
+    if (next_free_pageno >= 0) {
+        if (mm->page_list[next_free_pageno].used == 0) {
+            next_size = mm->page_list[next_free_pageno].alloc_pages;
+        }
+    }
+    VMEM_P_FREE(found);
+
+    /* merge */
+    merge_page_no = page->pageno;
+    merge_page_size = page->alloc_pages;
+    if (prev_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_no = found->page->pageno;
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+    if (next_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+
+    page->alloc_pages  = 0;
+    page->first_pageno = -1;
+
+    set_blocks_free(mm, merge_page_no, merge_page_size);
+
+    mm->alloc_page_count -= free_page_size;
+    mm->free_page_count  += free_page_size;
+
+    return 0;
+}
+
+
+
+#endif /* __JPU_MM_H__ */
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/jdi/jpu.c b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/jpu.c
new file mode 100644
index 00000000..4da1d15
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/jpu.c
@@ -0,0 +1,1089 @@
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+
+#include "jpu.h"
+#include "compat_jpu.h"
+#include "../puwrap.h"
+
+//from jpuconfig.h
+#define MAX_NUM_INSTANCE 8
+#define MAX_INST_HANDLE_SIZE (12*1024)
+
+/* definitions to be changed as customer  configuration */
+//#define JPU_SUPPORT_CLOCK_CONTROL /if you want to have clock gating scheme frame by frame
+#define JPU_SUPPORT_ISR
+/* if the platform driver knows the name of this driver. JPU_PLATFORM_DEVICE_NAME */
+#define JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+#ifndef CONFIG_RTK_RESERVE_MEMORY
+/* if this driver knows the dedicated video memory address */
+//#define JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#endif
+//#define JPU_IRQ_CONTROL
+#define DEV_NAME "[RTK_JPU]"
+#define JPU_PLATFORM_DEVICE_NAME "jdec"
+#define JPU_CLK_NAME "jpeg"
+#define JPU_DEV_NAME "jpu"
+
+#define JPU_BASE_ADDR 0x9803e000
+#define JPU_REG_SIZE 0x1000
+
+#ifdef JPU_SUPPORT_ISR
+#define JPU_IRQ_NUM 84+32
+#endif
+
+#ifndef VM_RESERVED /* for kernel up to 3.7.0 version */
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+typedef struct jpu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long interrupt_reason;
+} jpu_drv_context_t;
+
+/* To track the allocated memory buffer */
+typedef struct jpudrv_buffer_pool_t {
+	struct list_head list;
+	struct jpudrv_buffer_t jb;
+	struct file *filp;
+} jpudrv_buffer_pool_t;
+
+/* To track the instance index and buffer in instance pool */
+typedef struct jpudrv_instanace_list_t {
+	struct list_head list;
+	unsigned long inst_idx;
+	struct file *filp;
+} jpudrv_instanace_list_t;
+
+typedef struct jpudrv_instance_pool_t {
+	unsigned char jpgInstPool[MAX_NUM_INSTANCE][MAX_INST_HANDLE_SIZE];
+} jpudrv_instance_pool_t;
+
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#define JPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)
+#define JPU_DRAM_PHYSICAL_BASE (0x8AA00000)
+#include "jmm.h"
+static jpu_mm_t s_jmem;
+static jpudrv_buffer_t s_image_memory = {0};
+#endif
+
+static int jpu_hw_reset(void);
+static void jpu_clk_disable(struct clk *clk);
+static int jpu_clk_enable(struct clk *clk);
+static struct clk *jpu_clk_get(struct device *dev);
+static void jpu_clk_put(struct clk *clk);
+// end customer definition
+
+static jpudrv_buffer_t s_jpu_instance_pool = {0};
+static jpu_drv_context_t s_jpu_drv_context;
+static struct miscdevice s_jpu_dev;
+static int s_jpu_open_count;
+static struct clk *s_jpu_clk;
+static struct reset_control *rstc_jpeg = NULL;
+#ifdef JPU_SUPPORT_ISR
+static int s_jpu_irq = JPU_IRQ_NUM;
+static atomic_t s_interrupt_flag;
+#endif
+static unsigned long s_jpu_reg_phy_base = JPU_BASE_ADDR;
+static void __iomem *s_jpu_reg_virt_base;
+static jpudrv_buffer_t s_jpu_register = {0};
+static jpudrv_buffer_t s_bonding_register = {0};
+
+static unsigned long s_jpu_pll_phy_base = 0;
+static void __iomem *s_jpu_pll_virt_base = NULL;
+static unsigned long s_jpu_pll_size = 0;
+
+static wait_queue_head_t s_interrupt_wait_q;
+static int dbus_en = 1;
+
+#define JPEG_DBUS_REG (0x0000 + 0xF00)
+
+static spinlock_t s_jpu_lock = __SPIN_LOCK_UNLOCKED(s_jpu_lock);
+static DEFINE_SEMAPHORE(s_jpu_sem);
+static struct list_head s_jbp_head = LIST_HEAD_INIT(s_jbp_head);
+static struct list_head s_jpu_inst_list_head = LIST_HEAD_INIT(s_jpu_inst_list_head);
+
+/* implement to power management functions */
+#define ReadJpuRegister(addr) *(volatile unsigned int *)(s_jpu_reg_virt_base + addr)
+#define WriteJpuRegister(addr, val) *(volatile unsigned int *)(s_jpu_reg_virt_base + addr) = (unsigned int)val;
+
+#if 0 /* Fuchun disable 20160204, set clock gating by jdi.c */
+static void jpu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable)
+{
+	if (s_jpu_pll_phy_base == 0 || s_jpu_pll_virt_base == 0 || s_jpu_pll_size == 0) {
+		pr_warn("%s In[%s][%d] didn't get pll register\n", DEV_NAME, __FUNCTION__, __LINE__);
+		return;
+	} else if (offset > s_jpu_pll_size) {
+		pr_warn("%s In[%s][%d] offset over than register size\n", DEV_NAME, __FUNCTION__, __LINE__);
+		return;
+	}
+
+	if (bOverwrite == 1) {
+		__raw_writel(value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+	} else {
+		if (bEnable)
+			__raw_writel(__raw_readl((volatile u8 *)(s_jpu_pll_virt_base+offset)) | value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+		else
+			__raw_writel(__raw_readl((volatile u8 *)(s_jpu_pll_virt_base+offset)) & value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+	}
+}
+#endif
+
+static int jpu_alloc_dma_buffer(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	jb->phys_addr = (unsigned long)jmem_alloc(&s_jmem, jb->size, 0);
+
+	if ((unsigned long)jb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+
+	jb->base = (unsigned long)(s_image_memory.base + (jb->phys_addr - s_image_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	unsigned int ret;
+	ret = pu_alloc_dma_buffer(jb->size, &jb->phys_addr, &jb->base, 0);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#else
+	jb->base = (unsigned long)dma_alloc_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (dma_addr_t *) (&jb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#endif
+//	pr_info("%s base:0x%08x, phy_addr:0x%08x, size:%d\n", DEV_NAME, (unsigned int)jb->base, (unsigned int)jb->phys_addr, jb->size);
+	return 0;
+}
+
+static int jpu_alloc_dma_buffer2(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	jb->phys_addr = (unsigned long)jmem_alloc(&s_jmem, jb->size, 0);
+
+	if ((unsigned long)jb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+
+	jb->base = (unsigned long)(s_image_memory.base + (jb->phys_addr - s_image_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	unsigned int ret;
+	ret = pu_alloc_dma_buffer(jb->size, &jb->phys_addr, &jb->base, 0);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+	jb->base = pu_mmap_kernel_buffer(jb->phys_addr, jb->size);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s pu_mmap_kernel_buffer error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#else
+	jb->base = (unsigned long)dma_alloc_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (dma_addr_t *) (&jb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#endif
+//	pr_info("%s base:0x%08x, phy_addr:0x%08x, size:%d\n", DEV_NAME, (unsigned int)jb->base, (unsigned int)jb->phys_addr, jb->size);
+	return 0;
+}
+
+static void jpu_free_dma_buffer(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (jb->base)
+		jmem_free(&s_jmem, jb->phys_addr, 0);
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	pu_free_dma_buffer(jb->base, jb->phys_addr);
+#else
+	if (jb->base)
+		dma_free_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (void *)jb->base, jb->phys_addr);
+#endif
+}
+
+static int jpu_free_instances(struct file *filp)
+{
+	u32 inst_idx;
+	jpudrv_instanace_list_t *jil, *n;
+	jpudrv_instance_pool_t *jip;
+	void *jip_base;
+	void* jdi_mutex_base;
+	const unsigned int PTHREAD_MUTEX_T_DESTROY_VALUE = 0xdead10cc;
+
+	list_for_each_entry_safe(jil, n, &s_jpu_inst_list_head, list) {
+		if (jil->filp == filp) {
+			int i;
+			for (i = 0; i < MAX_NUM_INSTANCE; i++) /* reset dovi flag */
+			{
+				pu_set_dovi_flag(2, i, 0);
+			}
+
+			inst_idx = jil->inst_idx;
+			jip_base = (void *)(s_jpu_instance_pool.base);
+			jip = (jpudrv_instance_pool_t *)jip_base;
+			if (jip) {
+				memset(&jip->jpgInstPool[inst_idx], 0x00, 4);	// only first 4 byte is key point to free the corresponding instance.
+#define PTHREAD_MUTEX_T_HANDLE_SIZE 40
+				jdi_mutex_base = (jip_base + (s_jpu_instance_pool.size - PTHREAD_MUTEX_T_HANDLE_SIZE));
+				if (jdi_mutex_base) {
+					memcpy(jdi_mutex_base, &PTHREAD_MUTEX_T_DESTROY_VALUE, PTHREAD_MUTEX_T_HANDLE_SIZE);
+				}
+			}
+			s_jpu_open_count--;
+			list_del(&jil->list);
+			kfree(jil);
+		}
+	}
+
+	return s_jpu_open_count;
+}
+
+static int jpu_free_buffers(struct file *filp)
+{
+	jpudrv_buffer_pool_t *pool, *n;
+	jpudrv_buffer_t jb;
+
+	list_for_each_entry_safe(pool, n, &s_jbp_head, list) {
+		if (pool->filp == filp) {
+			jb = pool->jb;
+			if (jb.base) {
+				jpu_free_dma_buffer(&jb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+
+	return 0;
+}
+
+#ifdef JPU_SUPPORT_ISR
+static irqreturn_t jpu_irq_handler(int irq, void *dev_id)
+{
+	jpu_drv_context_t *dev = (jpu_drv_context_t *)dev_id;
+#ifdef JPU_IRQ_CONTROL
+	disable_irq_nosync(s_jpu_irq);
+#endif
+
+	dev->interrupt_reason = ReadJpuRegister(0x004); /* MJPEG_PIC_STATUS_REG */
+	WriteJpuRegister(0x004, dev->interrupt_reason);
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN); /* notify the interrupt to userspace */
+
+	atomic_set(&s_interrupt_flag, 1);
+
+	//pr_info("%s jpu_irq_handler\n", DEV_NAME);
+	wake_up_interruptible(&s_interrupt_wait_q);
+
+	return IRQ_HANDLED;
+}
+#endif
+
+static int jpu_open(struct inode *inode, struct file *filp)
+{
+	spin_lock(&s_jpu_lock);
+
+	filp->private_data = (void *)(&s_jpu_drv_context);
+	spin_unlock(&s_jpu_lock);
+	return 0;
+}
+
+static long jpu_ioctl(struct file *filp, u_int cmd, u_long arg)
+{
+	int ret = 0;
+	struct jpu_drv_context_t *dev = (struct jpu_drv_context_t *)filp->private_data;
+	jpudrv_buffer_pool_t *jbp;
+	jpudrv_buffer_pool_t *n;
+	jpudrv_buffer_t jb;
+	jpudrv_intr_info_t info;
+	jpudrv_instanace_list_t *jil;
+	jpudrv_instanace_list_t *tmp;
+	jpudrv_dovi_info_t doviInfo;
+	u32 inst_idx;
+	u32 clkgate;
+	u32 val;
+
+	switch (cmd) {
+	case JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+		down(&s_jpu_sem);
+
+		jbp = kzalloc(sizeof(*jbp), GFP_KERNEL);
+		if (!jbp) {
+			up(&s_jpu_sem);
+			return -ENOMEM;
+		}
+
+		ret = copy_from_user(&(jbp->jb), (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+		if (ret) {
+			kfree(jbp);
+			up(&s_jpu_sem);
+			return -EFAULT;
+		}
+
+		ret = jpu_alloc_dma_buffer(&(jbp->jb));
+		if (ret == -1) {
+			ret = -ENOMEM;
+			kfree(jbp);
+			up(&s_jpu_sem);
+			break;
+		}
+
+		ret = copy_to_user((void __user *)arg, &(jbp->jb), sizeof(jpudrv_buffer_t));
+		if (ret) {
+			kfree(jbp);
+			ret = -EFAULT;
+			up(&s_jpu_sem);
+			break;
+		}
+
+		jbp->filp = filp;
+		spin_lock(&s_jpu_lock);
+		list_add(&jbp->list, &s_jbp_head);
+		spin_unlock(&s_jpu_lock);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_FREE_PHYSICALMEMORY:
+		down(&s_jpu_sem);
+
+		ret = copy_from_user(&jb, (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+		if (ret) {
+			up(&s_jpu_sem);
+			return -EACCES;
+		}
+
+		if (jb.base)
+			jpu_free_dma_buffer(&jb);
+
+		spin_lock(&s_jpu_lock);
+		list_for_each_entry_safe(jbp, n, &s_jbp_head, list) {
+			if (jbp->jb.phys_addr == jb.phys_addr) {
+				list_del(&jbp->list);
+				kfree(jbp);
+				break;
+			}
+		}
+		spin_unlock(&s_jpu_lock);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+		if (s_image_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_image_memory, sizeof(jpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = -EFAULT;
+		}
+#endif
+		break;
+#ifdef JPU_SUPPORT_ISR
+	case JDI_IOCTL_WAIT_INTERRUPT:
+		ret = copy_from_user(&info, (jpudrv_intr_info_t*)arg, sizeof(jpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		smp_rmb();
+		ret = wait_event_interruptible_timeout(s_interrupt_wait_q, atomic_read(&s_interrupt_flag) != 0, msecs_to_jiffies(info.timeout));
+		if (!ret) {
+			ret = -ETIME;
+			//pr_info("%s JDI_IOCTL_WAIT_INTERRUPT fail\n", DEV_NAME);
+			break;
+		}
+
+		if (signal_pending(current)) {
+			ret = -ERESTARTSYS;
+			break;
+		}
+
+		atomic_set(&s_interrupt_flag, 0);
+		info.intr_reason = dev->interrupt_reason;
+		ret = copy_to_user((void __user *)arg, &info, sizeof(jpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		//pr_info("%s JDI_IOCTL_WAIT_INTERRUPT done, info.intr_reason:0x%x\n", DEV_NAME, info.intr_reason);
+		break;
+#endif /* JPU_SUPPORT_ISR */
+	case JDI_IOCTL_ENABLE_INTERRUPT:
+#ifdef JPU_IRQ_CONTROL
+		enable_irq(s_jpu_irq);
+#endif
+		break;
+	case JDI_IOCTL_SET_CLOCK_GATE:
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+
+#ifdef JPU_SUPPORT_CLOCK_CONTROL
+		if (clkgate)
+			jpu_clk_enable(s_jpu_clk);
+		else
+			jpu_clk_disable(s_jpu_clk);
+#endif
+
+		break;
+	case JDI_IOCTL_GET_INSTANCE_POOL:
+		down(&s_jpu_sem);
+
+		if (s_jpu_instance_pool.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_jpu_instance_pool, sizeof(jpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = copy_from_user(&s_jpu_instance_pool, (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+			if (ret == 0) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+				s_jpu_instance_pool.size = PAGE_ALIGN(s_jpu_instance_pool.size);
+				s_jpu_instance_pool.base = (unsigned long)vmalloc(s_jpu_instance_pool.size);
+				s_jpu_instance_pool.phys_addr = s_jpu_instance_pool.base;
+
+				if (s_jpu_instance_pool.base != 0)
+#else
+				if (jpu_alloc_dma_buffer2(&s_jpu_instance_pool) != -1)
+#endif
+				{
+					memset((void *)s_jpu_instance_pool.base, 0x0, s_jpu_instance_pool.size);
+					ret = copy_to_user((void __user *)arg, &s_jpu_instance_pool, sizeof(jpudrv_buffer_t));
+					if (ret == 0) {
+						// success to get memory for instance pool
+						up(&s_jpu_sem);
+						break;
+					}
+				}
+			}
+			ret = -EFAULT;
+		}
+		up(&s_jpu_sem);
+
+		break;
+	case JDI_IOCTL_OPEN_INSTANCE:
+		jil = kzalloc(sizeof(*jil), GFP_KERNEL);
+		if (!jil)
+			return -ENOMEM;
+
+		if (get_user(inst_idx, (u32 __user *) arg))
+			return -EFAULT;
+
+		jil->inst_idx = inst_idx;
+		jil->filp = filp;
+		spin_lock(&s_jpu_lock);
+		list_add(&jil->list, &s_jpu_inst_list_head);
+		s_jpu_open_count++;
+		spin_unlock(&s_jpu_lock);
+		break;
+	case JDI_IOCTL_CLOSE_INSTANCE:
+		if (get_user(inst_idx, (u32 __user *) arg))
+			return -EFAULT;
+
+		spin_lock(&s_jpu_lock);
+
+		list_for_each_entry_safe(jil, tmp, &s_jpu_inst_list_head, list) {
+			if (jil->inst_idx == inst_idx) {
+				s_jpu_open_count--;
+				list_del(&jil->list);
+				kfree(jil);
+//				printk(KERN_INFO "[JPUDRV] JDI_IOCTL_CLOSE_INSTANCE inst_idx=%d, open_count=%d\n", (int)inst_idx, s_jpu_open_count);
+				break;
+			}
+		}
+		spin_unlock(&s_jpu_lock);
+		break;
+	case JDI_IOCTL_GET_INSTANCE_NUM:
+		down(&s_jpu_sem);
+
+		ret = copy_to_user((void __user *)arg, &s_jpu_open_count, sizeof(int));
+		if (ret != 0)
+			ret = -EFAULT;
+
+		//printk(KERN_INFO "[JPUDRV] VDI_IOCTL_GET_INSTANCE_NUM open_count=%d\n", s_jpu_open_count);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_RESET:
+		jpu_hw_reset();
+		break;
+	case JDI_IOCTL_GET_REGISTER_INFO:
+		ret = copy_to_user((void __user *)arg, &s_jpu_register, sizeof(jpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		break;
+	case JDI_IOCTL_GET_BONDING_INFO:
+		ret = copy_to_user((void __user *)arg, &s_bonding_register, sizeof(jpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		break;
+	case JDI_IOCTL_SET_CLOCK_ENABLE:
+
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+
+		if (clkgate) {
+			reset_control_deassert(rstc_jpeg);
+			jpu_clk_enable(s_jpu_clk);
+			val = ReadJpuRegister(JPEG_DBUS_REG);
+			val |= (dbus_en << 0);
+			val &= ~(1 << 1); //Disable idle gating, fix it later.
+			WriteJpuRegister(JPEG_DBUS_REG, val);
+		} else {
+			jpu_clk_disable(s_jpu_clk);
+			reset_control_assert(rstc_jpeg);
+		}
+		break;
+	case JDI_IOCTL_SET_RTK_DOVI_FLAG:
+		//pr_info("%s [+]JDI_IOCTL_SET_RTK_DOVI_FLAG\n", DEV_NAME);
+		ret = copy_from_user(&doviInfo, (jpudrv_dovi_info_t *)arg, sizeof(jpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+
+		doviInfo.enable = pu_set_dovi_flag(2, doviInfo.inst_idx, doviInfo.enable);
+
+		ret = copy_to_user((jpudrv_dovi_info_t *)arg, &doviInfo, sizeof(jpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+		//pr_info("%s [-]JDI_IOCTL_SET_RTK_DOVI_FLAG doviInfo.inst_idx:%d, doviInfo.value:%d\n", DEV_NAME, doviInfo.inst_idx, doviInfo.enable);
+		break;
+	default:
+		printk(KERN_ERR "No such IOCTL, cmd is %d\n", cmd);
+		break;
+	}
+
+	return ret;
+}
+
+static ssize_t jpu_read(struct file *filp, char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static ssize_t jpu_write(struct file *filp, const char __user *buf, size_t len, loff_t *ppos)
+{
+
+	return -1;
+}
+
+static int jpu_release(struct inode *inode, struct file *filp)
+{
+//	pr_info("%s jpu_release s_jpu_open_count=%d\n", DEV_NAME, s_jpu_open_count);
+
+	spin_lock(&s_jpu_lock);
+
+
+	if (s_jpu_open_count > 0) {
+		/* found and free the not handled buffer by user applications */
+		jpu_free_buffers(filp);
+
+		/* found and free the not closed instance by user applications */
+		jpu_free_instances(filp);
+	}
+
+#if 1 //Fuchun 20150909, we must not free instance pool and common memory
+	if (s_jpu_open_count == 0) {
+		if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_jpu_instance_pool.base);
+#else
+			pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+			jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+			s_jpu_instance_pool.base = 0;
+//			pr_info("%s jpu_release - free s_jpu_instance_pool\n", DEV_NAME);
+		}
+	}
+#endif
+
+	spin_unlock(&s_jpu_lock);
+
+	return 0;
+}
+
+static int jpu_fasync(int fd, struct file *filp, int mode)
+{
+	struct jpu_drv_context_t *dev = (struct jpu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+static int jpu_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	pfn = vm->vm_pgoff;
+
+	return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int jpu_map_to_physical_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+	return pu_mmap_dma_buffer(vm);
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif
+}
+
+static int jpu_map_to_instance_pool_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	int ret;
+	long length = vm->vm_end - vm->vm_start;
+	unsigned long start = vm->vm_start;
+	char *vmalloc_area_ptr = (char *)s_jpu_instance_pool.base;
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_RESERVED;
+
+	/* loop over all pages, map it page individually */
+	while (length > 0) {
+		pfn = vmalloc_to_pfn(vmalloc_area_ptr);
+		if ((ret = remap_pfn_range(vm, start, pfn, PAGE_SIZE, PAGE_SHARED)) < 0) {
+			return ret;
+		}
+		start += PAGE_SIZE;
+		vmalloc_area_ptr += PAGE_SIZE;
+		length -= PAGE_SIZE;
+	}
+
+	return 0;
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif
+}
+
+/*!
+ * @brief memory map interface for jpu file operation
+ * @return  0 on success or negative error code on error
+ */
+static int jpu_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	if (vm->vm_pgoff == 0)
+		return jpu_map_to_instance_pool_memory(fp, vm);
+
+	if ((vm->vm_pgoff == (s_jpu_register.phys_addr>>PAGE_SHIFT)) || (vm->vm_pgoff == (s_bonding_register.phys_addr>>PAGE_SHIFT)))
+		return jpu_map_to_register(fp, vm);
+
+	return jpu_map_to_physical_memory(fp, vm);
+#else
+	if (vm->vm_pgoff) {
+		if (vm->vm_pgoff == (s_jpu_instance_pool.phys_addr>>PAGE_SHIFT))
+			return  jpu_map_to_instance_pool_memory(fp, vm);
+
+		return jpu_map_to_physical_memory(fp, vm);
+	} else
+		return jpu_map_to_register(fp, vm);
+#endif
+}
+
+struct file_operations jpu_fops = {
+	.owner = THIS_MODULE,
+	.open = jpu_open,
+	.read = jpu_read,
+	.write = jpu_write,
+	.unlocked_ioctl = jpu_ioctl,
+	.compat_ioctl   = compat_jpu_ioctl,
+	.release = jpu_release,
+	.fasync = jpu_fasync,
+	.mmap = jpu_mmap,
+};
+
+static int jpu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+	struct resource res;
+	void __iomem *iobase;
+	int irq;
+	struct device_node *node = pdev->dev.of_node;
+
+	pr_info("%s jpu_probe\n", DEV_NAME);
+
+	of_address_to_resource(node, 0, &res);
+	iobase = of_iomap(node, 0);
+
+	s_jpu_reg_phy_base = res.start;
+	s_jpu_reg_virt_base = iobase;
+	s_jpu_register.phys_addr = res.start;
+	s_jpu_register.virt_addr = (unsigned long)iobase;
+	s_jpu_register.size = res.end - res.start + 1;
+
+	pr_info("%s jpu base address get from DTB physical base addr=0x%lx, virtual base=0x%lx, size=0x%x\n", DEV_NAME, (unsigned long)s_jpu_reg_phy_base, (unsigned long)s_jpu_reg_virt_base, (unsigned int)(res.end - res.start + 1));
+
+	of_address_to_resource(node, 1, &res);
+	iobase = of_iomap(node, 1);
+
+	s_jpu_pll_phy_base = res.start;
+	s_jpu_pll_virt_base = iobase;
+	s_jpu_pll_size = res.end - res.start + 1;
+
+	of_address_to_resource(node, 2, &res);
+	iobase = of_iomap(node, 2);
+
+	s_bonding_register.phys_addr = res.start;
+	s_bonding_register.virt_addr = (unsigned long)iobase;
+	s_bonding_register.size = res.end - res.start + 1;
+
+	s_jpu_dev.minor = MISC_JPU_MINOR;
+	s_jpu_dev.name = JPU_DEV_NAME;
+	s_jpu_dev.fops = &jpu_fops;
+	s_jpu_dev.parent = NULL;
+	if (misc_register(&s_jpu_dev)) {
+		pr_info("%s failed to register misc device.", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (pdev)
+		s_jpu_clk = jpu_clk_get(&pdev->dev);
+	else
+		s_jpu_clk = jpu_clk_get(NULL);
+
+	if (!s_jpu_clk)
+		pr_err("%s fail to get clock controller, but, do not treat as error, \n", DEV_NAME);
+	else
+		pr_info("%s get clock controller s_jpu_clk=0x%p\n", DEV_NAME, s_jpu_clk);
+
+#ifdef JPU_SUPPORT_CLOCK_CONTROL
+	jpu_clk_enable(s_jpu_clk);
+#endif
+
+	rstc_jpeg = reset_control_get(&pdev->dev, NULL);
+
+	/* RTK clock setting */
+	reset_control_deassert(rstc_jpeg); // RESET disable
+#if 0 //Fuchun disable 20160204, set clock gating by jdi.c
+	jpu_pll_setting(0x10, (1 << jpg_clk_enable_bit), 0, 1); // CLK enable
+
+	val = ReadJpuRegister(JPEG_DBUS_REG);
+	val |= (dbus_en << 0);
+	WriteJpuRegister(JPEG_DBUS_REG, val);
+#endif
+
+#ifdef JPU_SUPPORT_ISR
+	irq = irq_of_parse_and_map(node, 0);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_jpu_irq = irq;
+	pr_info("%s s_jpu_irq:%d want to register jpu_irq_handler\n", DEV_NAME, s_jpu_irq);
+	err = request_irq(s_jpu_irq, jpu_irq_handler, 0, "JPEG_CODEC_IRQ", (void *)(&s_jpu_drv_context));
+	err = 0;
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_jpu_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_jpu_irq <%d> busy, change your config\n", DEV_NAME, s_jpu_irq);
+
+		goto ERROR_PROVE_DEVICE;
+	}
+#endif
+
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	s_image_memory.size = JPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+	s_image_memory.phys_addr = JPU_DRAM_PHYSICAL_BASE;
+	s_image_memory.base = (unsigned long)ioremap(s_image_memory.phys_addr, PAGE_ALIGN(s_image_memory.size));
+
+	if (!s_image_memory.base) {
+		pr_err("%s fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", DEV_NAME, (int)s_image_memory.phys_addr, (int)s_image_memory.base, (int)s_image_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (jmem_init(&s_jmem, s_image_memory.phys_addr, s_image_memory.size) < 0) {
+		pr_err("%s fail to init vmem system\n", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	pr_info("%s success to probe jpu device with reserved video memory phys_addr=0x%x, base = 0x%x\n", DEV_NAME, (int) s_image_memory.phys_addr, (int)s_image_memory.base);
+#else
+	pr_info("%s success to probe jpu device with non reserved video memory\n", DEV_NAME);
+#endif
+
+	reset_control_assert(rstc_jpeg);
+
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+	misc_deregister(&s_jpu_dev);
+
+	if (s_jpu_reg_virt_base)
+		iounmap(s_jpu_reg_virt_base);
+
+	return err;
+}
+
+static int jpu_remove(struct platform_device *pdev)
+{
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	pr_info("%s jpu_remove\n", DEV_NAME);
+
+	if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_jpu_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+		jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+		s_jpu_instance_pool.base = 0;
+	}
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_image_memory.base) {
+		iounmap((void *)s_image_memory.base);
+		s_image_memory.base = 0;
+		jmem_exit(&s_jmem);
+	}
+#endif
+
+	misc_deregister(&s_jpu_dev);
+
+#ifdef JPU_SUPPORT_ISR
+	if (s_jpu_irq)
+		free_irq(s_jpu_irq, &s_jpu_drv_context);
+#endif
+
+	if (s_jpu_reg_virt_base)
+		iounmap(s_jpu_reg_virt_base);
+
+	if (rstc_jpeg != NULL)
+		reset_control_put(rstc_jpeg);
+
+	jpu_clk_put(s_jpu_clk);
+
+#endif //JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+static int jpu_suspend(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+	reset_control_deassert(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+#if 0
+	if (s_jpu_open_count > 0) {
+		u32 inst_idx;
+		jpudrv_instanace_list_t *jil, *n;
+		jpudrv_instance_pool_t *jip;
+		void *jip_base;
+		jpudrv_buffer_pool_t *pool, *n;
+		jpudrv_buffer_t jb;
+
+		s_jpu_open_count = 0;
+		atomic_set(&s_interrupt_flag, 0);
+		wake_up_interruptible_all(&s_interrupt_wait_q);
+
+		if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_jpu_instance_pool.base);
+#else
+			jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+			s_jpu_instance_pool.base = 0;
+			pr_info("%s jpu_release - free s_jpu_instance_pool\n", DEV_NAME);
+		}
+
+		list_for_each_entry_safe(jil, n, &s_jpu_inst_list_head, list) {
+			inst_idx = jil->inst_idx;
+			jip_base = (void *)(s_jpu_instance_pool.base);
+			jip = (jpudrv_instance_pool_t *)jip_base;
+			if (jip) {
+				memset(&jip->jpgInstPool[inst_idx], 0x00, 4);	// only first 4 byte is key point to free the corresponding instance.
+			}
+			list_del(&jil->list);
+			kfree(jil);
+		}
+
+		list_for_each_entry_safe(pool, n, &s_jbp_head, list) {
+			jb = pool->jb;
+			if (jb.base) {
+				jpu_free_dma_buffer(&jb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+#endif
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_assert(rstc_jpeg);
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+
+}
+
+static int jpu_resume(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+	reset_control_deassert(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_assert(rstc_jpeg);
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+#else
+#define jpu_suspend NULL
+#define jpu_resume NULL
+#endif /* !CONFIG_PM */
+
+static int __init jpu_init(void)
+{
+	int res;
+	res = 0;
+
+	pr_info("%s jpu_init\n", DEV_NAME);
+	init_waitqueue_head(&s_interrupt_wait_q);
+	s_jpu_instance_pool.base = 0;
+
+	pr_info("%s end jpu_init result=0x%x\n", DEV_NAME, res);
+	return res;
+}
+
+static void __exit jpu_exit(void)
+{
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	pr_info("%s jpu_exit\n", DEV_NAME);
+#else
+	if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_jpu_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+		jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+		s_jpu_instance_pool.base = 0;
+	}
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_image_memory.base) {
+		iounmap((void *)s_image_memory.base);
+		s_image_memory.base = 0;
+	}
+#endif
+
+	misc_deregister(&s_jpu_dev);
+
+#ifdef JPU_SUPPORT_ISR
+	if (s_jpu_irq)
+		free_irq(s_jpu_irq, &s_jpu_drv_context);
+#endif
+
+	if (rstc_jpeg != NULL)
+		reset_control_put(rstc_jpeg);
+
+	jpu_clk_put(s_jpu_clk);
+
+
+	if (s_jpu_reg_virt_base) {
+		iounmap(s_jpu_reg_virt_base);
+		s_jpu_reg_virt_base = (void *)0x00;
+	}
+
+#endif //JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	return;
+}
+
+MODULE_AUTHOR("A customer using RTK JPU, Inc.");
+MODULE_DESCRIPTION("JPU linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(jpu_init);
+module_exit(jpu_exit);
+
+int jpu_hw_reset(void)
+{
+	u32 val;
+
+	pr_info("%s request jpu reset from application\n", DEV_NAME);
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_reset(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+	val = ReadJpuRegister(JPEG_DBUS_REG);
+	val |= (dbus_en << 0);
+	val &= ~(1 << 1); //Disable idle gating, fix it later.
+	WriteJpuRegister(JPEG_DBUS_REG, val);
+	return 0;
+}
+
+struct clk *jpu_clk_get(struct device *dev)
+{
+	return clk_get(dev, JPU_CLK_NAME);
+}
+
+void jpu_clk_put(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk)))
+		clk_put(clk);
+}
+
+int jpu_clk_enable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+//		pr_info("%s jpu_clk_enable\n", DEV_NAME);
+		return clk_prepare_enable(clk);
+	}
+	return 0;
+}
+
+void jpu_clk_disable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+//		pr_info("%s jpu_clk_disable\n", DEV_NAME);
+		clk_disable_unprepare(clk);
+	}
+}
+
+static const struct of_device_id rtk_jpeg_dt_match[] = {
+	{ .compatible = "Realtek,rtk1295-jpeg" },
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtk_jpeg_dt_match);
+
+const struct dev_pm_ops rtk_jpeg_pmops = {
+	.suspend = jpu_suspend,
+	.resume = jpu_resume,
+};
+
+static struct platform_driver rtk_jpeg_driver = {
+	.driver = {
+		.name = "rtk-jpeg",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_jpeg_dt_match,
+		.pm = &rtk_jpeg_pmops,
+	},
+	.probe = jpu_probe,
+	.remove = jpu_remove,
+};
+
+module_platform_driver(rtk_jpeg_driver);
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/jdi/jpu.h b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/jpu.h
new file mode 100644
index 00000000..fce5113
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/jdi/jpu.h
@@ -0,0 +1,47 @@
+
+
+#ifndef __JPU_DRV_H__
+#define __JPU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+#define J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+
+#define JDI_IOCTL_MAGIC  'J'
+#define JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY			_IO(JDI_IOCTL_MAGIC, 0)
+#define JDI_IOCTL_FREE_PHYSICALMEMORY			_IO(JDI_IOCTL_MAGIC, 1)
+#define JDI_IOCTL_WAIT_INTERRUPT			_IO(JDI_IOCTL_MAGIC, 2)
+#define JDI_IOCTL_SET_CLOCK_GATE			_IO(JDI_IOCTL_MAGIC, 3)
+#define JDI_IOCTL_RESET						_IO(JDI_IOCTL_MAGIC, 4)
+#define JDI_IOCTL_GET_INSTANCE_POOL			_IO(JDI_IOCTL_MAGIC, 5)
+#define JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO			_IO(JDI_IOCTL_MAGIC, 6)
+#define JDI_IOCTL_OPEN_INSTANCE				_IO(JDI_IOCTL_MAGIC, 7)
+#define JDI_IOCTL_CLOSE_INSTANCE			_IO(JDI_IOCTL_MAGIC, 8)
+#define JDI_IOCTL_GET_INSTANCE_NUM			_IO(JDI_IOCTL_MAGIC, 9)
+#define JDI_IOCTL_ENABLE_INTERRUPT			_IO(JDI_IOCTL_MAGIC, 10)
+#define JDI_IOCTL_GET_REGISTER_INFO			_IO(JDI_IOCTL_MAGIC, 11)
+
+/* RTK ioctl */
+#define JDI_IOCTL_SET_CLOCK_ENABLE			_IO(JDI_IOCTL_MAGIC, 12)
+#define JDI_IOCTL_GET_BONDING_INFO			_IO(JDI_IOCTL_MAGIC, 13)
+#define JDI_IOCTL_SET_RTK_DOVI_FLAG			_IO(JDI_IOCTL_MAGIC, 14)
+
+typedef struct jpudrv_buffer_t {
+    unsigned int size;
+    unsigned long phys_addr;
+    unsigned long base;							/* kernel logical address in use kernel */
+    unsigned long virt_addr;				/* virtual user space address */
+} jpudrv_buffer_t;
+
+typedef struct jpudrv_intr_info_t {
+    unsigned int timeout;
+    int intr_reason;
+} jpudrv_intr_info_t;
+
+typedef struct jpudrv_dovi_info_t{
+	unsigned int inst_idx;
+	unsigned int enable;
+} jpudrv_dovi_info_t;
+
+#endif
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/puwrap.c b/drivers/soc/realtek/rtd139x/rtk_ve/puwrap.c
new file mode 100644
index 00000000..84bb804
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/puwrap.c
@@ -0,0 +1,577 @@
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/module.h>
+
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/dma-buf.h>
+#include <linux/reservation.h>
+
+#include "puwrap.h"
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#define USE_ION_ALLOCATOR
+#ifdef USE_ION_ALLOCATOR
+#define NUM_ION_STRUCT 256
+#include "../../../../staging/android/ion/ion.h"
+#include "../../../../staging/android/uapi/ion_rtk.h"
+struct rtkdrv_ion_buffer_t {
+    unsigned int size;
+    unsigned int inUse;
+    unsigned long phys_addr;
+    unsigned long dmabuf;
+    unsigned long pIonHandle;
+};
+extern struct ion_device *rtk_phoenix_ion_device;
+struct ion_client *pu_client = NULL;
+struct rtkdrv_ion_buffer_t pu_ion_buffer[NUM_ION_STRUCT];
+static DEFINE_MUTEX(s_pu_mutex);
+#else /* else USE_ION_ALLOCATOR */
+typedef struct rtkdrv_buffer_t {
+    unsigned int size;
+    unsigned long phys_addr;
+    unsigned long base;							/* kernel logical address in use kernel */
+    unsigned long virt_addr;				/* virtual user space address */
+} rtkdrv_buffer_t;
+
+#define RTK_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)
+#define RTK_DRAM_PHYSICAL_BASE 0x06000000
+#include "rtk_mm.h"
+static video_mm_t s_mem;
+static rtkdrv_buffer_t s_memory = {0};
+#endif /* endif USE_ION_ALLOCATOR */
+#define VE_SECURE_NORMAL 1
+#define VE_SECURE_PROTECTION 2
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+typedef struct rtkdrv_dovi_flag_t{
+	int nCoreIdx;
+	int nInstIdx;
+	unsigned int bEnable;
+} rtkdrv_dovi_flag_t;
+
+unsigned long pll_phy_register = 0;
+unsigned long pll_virt_register = 0;
+unsigned long pll_size_register = 0;
+rtkdrv_dovi_flag_t dovi_flag = {-1, -1, 0};
+static DEFINE_MUTEX(s_dovi_mutex);
+
+
+#define PU_PLATFORM_DEVICE_NAME "rtk_puwrap"
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+int pu_alloc_dma_buffer(unsigned int size, unsigned long *phys_addr, unsigned long *base, unsigned int mem_type)
+{
+#ifdef USE_ION_ALLOCATOR
+    int ret = -1;
+
+    if (!size)
+        return -1;
+
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct ion_handle *handle;
+        struct dma_buf *dmabuf;
+        ion_phys_addr_t dat;
+        size_t len;
+        int heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+        int flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].inUse == 0)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] NUM_ION_STRUCT is too small!!!");
+            break;
+        }
+
+        switch(mem_type)
+        {
+            case VE_SECURE_NORMAL:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+                    flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED | ION_FLAG_VE_SPEC);
+                    break;
+                }
+            case VE_SECURE_PROTECTION:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_SECURE_MASK;
+                    flags = (ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+                    break;
+                }
+            default:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+                    flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+                    break;
+                }
+        }
+
+        handle = ion_alloc(pu_client, size, 1024, heap, flags);
+        if (IS_ERR(handle))
+        {
+            printk(KERN_ERR "[PUWRAP] ion_alloc allocation error size=%d\n", size);
+            break;
+        }
+
+        if(ion_phys(pu_client, handle, &dat, &len) != 0)
+        {
+            ion_free(pu_client, handle);
+            printk(KERN_ERR "[PUWRAP] ion_alloc allocation error size=%d\n", size);
+            break;
+        }
+
+        dmabuf = ion_share_dma_buf(pu_client, handle);
+        if (IS_ERR(dmabuf)) {
+            ion_unmap_kernel(pu_client, handle);
+            ion_free(pu_client, handle);
+            printk(KERN_ERR "[PUWRAP] ion_share_dma_buf error %p (size=%d)\n", dmabuf, size);
+            break;
+        }
+
+        *base = (unsigned long) dmabuf; // we didn't need base address on user space, but we also need it has value to do detection
+        *phys_addr = (unsigned long)dat;
+
+        pu_ion_buffer[i].size = size;
+        pu_ion_buffer[i].inUse = 1;
+        pu_ion_buffer[i].phys_addr = (unsigned long)*phys_addr;
+        pu_ion_buffer[i].dmabuf = (unsigned long)dmabuf;
+        pu_ion_buffer[i].pIonHandle = (unsigned long)handle;
+
+        ret = 0;
+        break;
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+    return ret;
+
+#else /* else USE_ION_ALLOCATOR */
+    if (!size)
+        return -1;
+
+    *phys_addr = (unsigned long)vmem_alloc(&s_mem, size, 0);
+    if (*phys_addr  == (unsigned long)-1)
+    {
+        printk(KERN_ERR "[PUWRAP] Physical memory allocation error size=%d\n", size);
+        return -1;
+    }
+
+    *base = (unsigned long)(s_memory.base + (*phys_addr - s_memory.phys_addr));
+    //printk("[PUWARP] base:0x%lx, phy_addr:0x%lx, size:%d\n", *base, (unsigned long)*phys_addr, size);
+
+    return 0;
+#endif /* endif USE_ION_ALLOCATOR */
+}
+
+void pu_free_dma_buffer(unsigned long base, unsigned long phys_addr)
+{
+    if (!base)
+        return;
+
+#ifdef USE_ION_ALLOCATOR
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct ion_handle *handle;
+        struct dma_buf *dmabuf;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if (dmabuf != NULL)
+        {
+            dma_buf_put(dmabuf);
+            pu_ion_buffer[i].dmabuf = (unsigned long) NULL;
+        }
+
+        handle = (struct ion_handle *)pu_ion_buffer[i].pIonHandle;
+        if(handle != NULL)
+        {
+            ion_free(pu_client, handle);
+        }
+        memset(&pu_ion_buffer[i], 0, sizeof(struct rtkdrv_ion_buffer_t));
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+#else
+    vmem_free(&s_mem, (unsigned long)phys_addr, 0);
+#endif
+}
+
+int pu_mmap_dma_buffer(struct vm_area_struct *vm)
+{
+#ifdef USE_ION_ALLOCATOR
+    u32 i;
+    int ret = 0;
+    struct dma_buf *dmabuf;
+    unsigned long phys_addr = (unsigned long)(vm->vm_pgoff << PAGE_SHIFT);
+    mutex_lock(&s_pu_mutex);
+
+    for (i = 0; i < NUM_ION_STRUCT; i++)
+    {
+        if (pu_ion_buffer[i].phys_addr == phys_addr)
+            break;
+    }
+    if (i == NUM_ION_STRUCT)
+    {
+        printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+        mutex_unlock(&s_pu_mutex);
+        return -EINVAL;
+    }
+
+    dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+    ret = dma_buf_mmap(dmabuf, vm, 0);
+
+    mutex_unlock(&s_pu_mutex);
+
+    return ret;
+#else
+    return -EINVAL;
+#endif
+}
+
+unsigned long pu_mmap_kernel_buffer(unsigned long phys_addr, unsigned int size)
+{
+#ifdef USE_ION_ALLOCATOR
+    unsigned long ret = 0;
+
+    if (!size)
+        return 0;
+
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct dma_buf *dmabuf;
+        void * virt_addr;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if(dmabuf != NULL)
+        {
+            ret = dma_buf_begin_cpu_access(dmabuf, 0);
+            if (ret) {
+                printk(KERN_ERR "[PUWRAP] dma_buf_begin_cpu_access error ret=%d (size=%d) \n", ret, size);
+                break;
+            }
+            virt_addr = dma_buf_kmap(dmabuf, 0);
+            if (IS_ERR_OR_NULL(virt_addr)) {
+                printk(KERN_ERR "[PUWRAP] dma_buf_kmap error %p (size=%d) \n", virt_addr, size);
+                break;
+            }
+
+            ret = (unsigned long)virt_addr;
+        }
+    } while(0);
+    mutex_unlock(&s_pu_mutex);
+
+    return ret;
+#endif
+}
+
+void pu_unmap_kernel_buffer(unsigned long base, unsigned long phys_addr)
+{
+    if (!base)
+        return;
+
+#ifdef USE_ION_ALLOCATOR
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct dma_buf *dmabuf;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if(dmabuf != NULL)
+        {
+            dma_buf_kunmap(dmabuf, 0, (void *)base);
+            dma_buf_end_cpu_access(dmabuf, 0);
+        }
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+#endif
+}
+#endif //#ifdef CONFIG_RTK_RESERVE_MEMORY
+
+void pu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable)
+{
+    if (pll_phy_register == 0 || pll_virt_register == 0 || pll_size_register == 0)
+    {
+        printk(KERN_WARNING "In[%s][%d] didn't get pll register\n", __FUNCTION__, __LINE__);
+        return;
+    }
+    else if (offset > pll_size_register)
+    {
+        printk(KERN_WARNING "In[%s][%d] offset over than register size\n", __FUNCTION__, __LINE__);
+        return;
+    }
+
+    if (bOverwrite == 1)
+    {
+        __raw_writel(value, (volatile u8 *)(pll_virt_register+offset));
+    }
+    else
+    {
+        if (bEnable)
+        {
+            __raw_writel(__raw_readl((volatile u8 *)(pll_virt_register+offset)) | value, (volatile u8 *)(pll_virt_register+offset));
+        }
+        else
+        {
+            __raw_writel(__raw_readl((volatile u8 *)(pll_virt_register+offset)) & value, (volatile u8 *)(pll_virt_register+offset));
+        }
+    }
+}
+
+int pu_set_dovi_flag(int nCoreIdx, int nInstIdx, unsigned int bEnable)
+{
+	int ret = 0;
+	//pr_info("VE1: dovi_flag[%p, %d, %d, %d], input[%d, %d, %d]\n", &dovi_flag, dovi_flag.nCoreIdx, dovi_flag.nInstIdx, dovi_flag.bEnable, nCoreIdx, nInstIdx, bEnable);
+
+	mutex_lock(&s_dovi_mutex);
+	if (bEnable == 1)
+	{
+		if (dovi_flag.bEnable == 0)
+		{
+			dovi_flag.bEnable = 1;
+			dovi_flag.nCoreIdx = nCoreIdx;
+			dovi_flag.nInstIdx = nInstIdx;
+			ret = 1;
+		}
+	}
+	else
+	{
+		if (dovi_flag.bEnable == 1 && dovi_flag.nCoreIdx == nCoreIdx && dovi_flag.nInstIdx == nInstIdx)
+		{
+			dovi_flag.bEnable = 0;
+			dovi_flag.nCoreIdx = -1;
+			dovi_flag.nInstIdx = -1;
+		}
+	}
+	mutex_unlock(&s_dovi_mutex);
+
+	return ret;
+}
+
+static int pu_probe(struct platform_device *pdev)
+{
+    struct resource res;
+    void __iomem *iobase;
+    struct device_node *node;
+
+    printk(KERN_INFO "[PUWRAP] pu_probe\n");
+
+    node = pdev->dev.of_node;
+    of_address_to_resource(node, 0, &res);
+    iobase = of_iomap(node, 0);
+
+    pll_phy_register = res.start;
+    pll_virt_register = (unsigned long)iobase;
+    pll_size_register = res.end - res.start + 1;
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifdef USE_ION_ALLOCATOR
+    pu_client = ion_client_create(rtk_phoenix_ion_device, "PUDriver");
+    memset(pu_ion_buffer, 0, sizeof(struct rtkdrv_ion_buffer_t)*NUM_ION_STRUCT);
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device with USE_ION_ALLOCATOR\n");
+#else /* else USE_ION_ALLOCATOR */
+    if(pdev)
+        res = platform_get_resource(pdev, IORESOURCE_MEM, 1);
+    if(res)
+    {
+        s_memory.size = res->end - res->start;
+        s_memory.phys_addr = res->start;
+    }
+    else
+    {
+        s_memory.size = RTK_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+        s_memory.phys_addr = RTK_DRAM_PHYSICAL_BASE;
+    }
+
+    s_memory.base = (unsigned long)ioremap(s_memory.phys_addr, PAGE_ALIGN(s_memory.size));
+    if (!s_memory.base)
+    {
+        printk(KERN_ERR "[PUWRAP] :  fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", (int)s_memory.phys_addr, (int)s_memory.base, (int)s_memory.size);
+        goto ERROR_PROVE_DEVICE;
+    }
+    if (vmem_init(&s_mem, s_memory.phys_addr, s_memory.size) < 0)
+    {
+        printk(KERN_ERR "[PUWRAP] :  fail to init vmem system\n");
+        goto ERROR_PROVE_DEVICE;
+    }
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device with reserved video memory phys_addr=0x%x, base = 0x%x\n", (int) s_memory.phys_addr, (int)s_memory.base);
+#endif /* endif USE_ION_ALLOCATOR */
+#else /* else CONFIG_RTK_RESERVE_MEMORY */
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device\n");
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+
+    return 0;
+
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifndef USE_ION_ALLOCATOR
+ERROR_PROVE_DEVICE:
+
+    return 0;
+#endif
+#endif
+}
+
+static int pu_remove(struct platform_device *pdev)
+{
+    printk(KERN_INFO "[PUWRAP] pu_remove\n");
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifdef USE_ION_ALLOCATOR
+    if(pu_client != NULL)
+    {
+        ion_client_destroy(pu_client);
+        pu_client = NULL;
+    }
+#else /* else USE_ION_ALLOCATOR */
+    if (s_memory.base)
+    {
+        iounmap((void *)s_memory.base);
+        s_memory.base = 0;
+        vmem_exit(&s_mem);
+    }
+#endif /* endif USE_ION_ALLOCATOR */
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+    return 0;
+}
+
+#if 0
+static struct platform_driver pu_driver = {
+    .driver = {
+        .name = PU_PLATFORM_DEVICE_NAME,
+    },
+    .probe = pu_probe,
+    .remove = pu_remove,
+};
+#endif
+
+static ssize_t pu_memsize_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    return sprintf(buf, "%d\n", (int)(get_num_physpages() << PAGE_SHIFT));
+}
+
+static struct kobj_attribute pu_memsize_attr =
+    __ATTR(pu_memsize, 0644, pu_memsize_show, NULL);
+
+static struct attribute *pu_attrs[] = {
+    &pu_memsize_attr.attr,
+    NULL,
+};
+
+static struct attribute_group rtk_pu_attr_group = {
+    .attrs = pu_attrs,
+};
+
+static struct kobject *pu_kobj;
+
+static int __init pu_init(void)
+{
+    int res = 0;
+
+    pu_kobj = kobject_create_and_add("rtk_pu", kernel_kobj);
+    if (pu_kobj)
+    {
+        res = sysfs_create_group(pu_kobj, &rtk_pu_attr_group);
+        if (res)
+            printk(KERN_WARNING "[PUWRAP] %d: unable to create sysfs entry\n", __LINE__);
+    }
+    else
+        printk(KERN_WARNING "[PUWRAP] %d: unable to create sysfs entry\n", __LINE__);
+
+    printk(KERN_INFO "[PUWRAP] begin pu_init\n");
+    //res = platform_driver_register(&pu_driver);
+    printk(KERN_INFO "[PUWRAP] end pu_init result=0x%x\n", res);
+    return res;
+}
+
+static void __exit pu_exit(void)
+{
+    printk(KERN_INFO "[PUWRAP] pu_exit\n");
+    //platform_driver_unregister(&pu_driver);
+    return;
+}
+
+
+static const struct of_device_id rtk_pu_dt_match[] = {
+    { .compatible = "Realtek,rtk1295-pu_pll" },
+    {}
+};
+MODULE_DEVICE_TABLE(of, rtk_pu_dt_match);
+
+const struct dev_pm_ops rtk_pu_pmops = {
+    .suspend    = NULL,
+    .resume     = NULL,
+};
+
+static struct platform_driver rtk_pu_driver = {
+    .driver		= {
+        .name	= "rtk-pu",
+        .owner	= THIS_MODULE,
+        .of_match_table = rtk_pu_dt_match,
+        //.pm	= SDHCI_PLTFM_PMOPS,
+        .pm	= &rtk_pu_pmops,
+    },
+    .probe		= pu_probe,
+    .remove		= pu_remove,
+};
+
+module_platform_driver(rtk_pu_driver);
+
+MODULE_AUTHOR("RTK Wrapper for JPU & VPU, Inc.");
+MODULE_DESCRIPTION("PU WRAPPER linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(pu_init);
+module_exit(pu_exit);
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/puwrap.h b/drivers/soc/realtek/rtd139x/rtk_ve/puwrap.h
new file mode 100644
index 00000000..f065d21
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/puwrap.h
@@ -0,0 +1,44 @@
+
+
+#ifndef __PU_DRV_H__
+#define __PU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+
+#define PDI_IOCTL_MAGIC  'V'
+
+#define PLL_CLK_715 (0x10D336)
+#define PLL_CLK_702 (0x10C186)
+#define PLL_CLK_675 (0x10C176)
+#define PLL_CLK_648 (0x10C166)
+#define PLL_CLK_594 (0x10C146)
+#define PLL_CLK_567 (0x10C136)
+#define PLL_CLK_337 (0x12C176)
+#define PLL_CLK_297 (0x12C146)
+
+#define UNUSED_PARAMETER(p) (void)(p)
+
+#define MISC_JPU_MINOR 107
+#define MISC_MEM_MINOR 108
+#define MISC_VE3_MINOR 109
+#define MISC_VE1_MINOR 110
+
+typedef struct pu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long jpu_interrupt_reason;
+	unsigned long vpu_interrupt_reason;
+} pu_drv_context_t;
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+int pu_alloc_dma_buffer(unsigned int size, unsigned long *phys_addr, unsigned long *base, unsigned int mem_type);
+void pu_free_dma_buffer(unsigned long base, unsigned long phys_addr);
+int pu_mmap_dma_buffer(struct vm_area_struct *vm);
+unsigned long pu_mmap_kernel_buffer(unsigned long phys_addr, unsigned int size);
+void pu_unmap_kernel_buffer(unsigned long base, unsigned long phys_addr);
+#endif
+void pu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable);
+int pu_set_dovi_flag(int nCoreIdx, int nInstIdx, unsigned int bEnable);
+
+#endif
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/ve1/Makefile b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/Makefile
new file mode 100644
index 00000000..7217604
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/Makefile
@@ -0,0 +1,6 @@
+# rtk_vcodec
+
+obj-$(CONFIG_VE1_CODEC) += ve1.o
+ifdef CONFIG_COMPAT
+obj-$(CONFIG_VE1_CODEC) += compat_ve1.o
+endif
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/ve1/compat_ve1.c b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/compat_ve1.c
new file mode 100755
index 00000000..c9b4619
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/compat_ve1.c
@@ -0,0 +1,666 @@
+/*
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/compat.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#include "ve1.h"
+#include "compat_ve1.h"
+
+/* See drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1.h for the definition of these structs */
+typedef struct compat_vpudrv_buffer_t {
+	compat_uint_t size;
+	compat_ulong_t phys_addr;
+	compat_ulong_t base; /* kernel logical address in use kernel */
+	compat_ulong_t virt_addr; /* virtual user space address */
+	compat_uint_t mem_type;
+} compat_vpudrv_buffer_t;
+
+typedef struct compat_vpu_clock_info_t{
+	compat_uint_t core_idx;
+	compat_uint_t enable;
+	compat_uint_t value;
+} compat_vpu_clock_info_t;
+
+typedef struct compat_vpudrv_inst_info_t {
+	compat_uint_t core_idx;
+	compat_uint_t inst_idx;
+	compat_int_t inst_open_count;	/* for output only*/
+} compat_vpudrv_inst_info_t;
+
+typedef struct compat_vpudrv_intr_info_t {
+	compat_uint_t core_idx;
+	compat_uint_t timeout;
+	compat_int_t intr_reason;
+#ifdef SUPPORT_MULTI_INST_INTR
+	compat_int_t intr_inst_index;
+#endif
+} compat_vpudrv_intr_info_t;
+
+typedef struct compat_vpudrv_dovi_info_t{
+	compat_uint_t core_idx;
+	compat_uint_t inst_idx;
+	compat_uint_t enable;
+} compat_vpudrv_dovi_info_t;
+
+#define COMPAT_VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(VDI_IOCTL_MAGIC, 0)
+#define COMPAT_VDI_IOCTL_FREE_PHYSICALMEMORY _IO(VDI_IOCTL_MAGIC, 1)
+#define COMPAT_VDI_IOCTL_WAIT_INTERRUPT _IO(VDI_IOCTL_MAGIC, 2)
+#define COMPAT_VDI_IOCTL_GET_INSTANCE_POOL _IO(VDI_IOCTL_MAGIC, 5)
+#define COMPAT_VDI_IOCTL_GET_COMMON_MEMORY _IO(VDI_IOCTL_MAGIC, 6)
+#define COMPAT_VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(VDI_IOCTL_MAGIC, 8)
+#define COMPAT_VDI_IOCTL_OPEN_INSTANCE _IO(VDI_IOCTL_MAGIC, 9)
+#define COMPAT_VDI_IOCTL_CLOSE_INSTANCE _IO(VDI_IOCTL_MAGIC, 10)
+#define COMPAT_VDI_IOCTL_GET_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 11)
+#define COMPAT_VDI_IOCTL_GET_REGISTER_INFO _IO(VDI_IOCTL_MAGIC, 12)
+
+/* RTK ioctl */
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_GATING _IO(VDI_IOCTL_MAGIC, 16)
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 17)
+#define COMPAT_VDI_IOCTL_GET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 18)
+#define COMPAT_VDI_IOCTL_GET_RTK_SUPPORT_TYPE _IO(VDI_IOCTL_MAGIC, 19)
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 21)
+#define COMPAT_VDI_IOCTL_GET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 22)
+#define COMPAT_VDI_IOCTL_SET_RTK_DOVI_FLAG _IO(VDI_IOCTL_MAGIC, 23)
+#define COMPAT_VDI_IOCTL_GET_TOTAL_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 24)
+#define COMPAT_VDI_IOCTL_GET_RTK_DCSYS_INFO _IO(VDI_IOCTL_MAGIC, 25)
+
+static int compat_get_ve1_buffer_data(
+	compat_vpudrv_buffer_t __user *data32,
+	vpudrv_buffer_t __user *data)
+{
+	compat_uint_t s;
+	compat_ulong_t p;
+	compat_ulong_t b;
+	compat_ulong_t v;
+	compat_uint_t m;
+	int err;
+
+	err = get_user(s, &data32->size);
+	err |= put_user(s, &data->size);
+	err |= get_user(p, &data32->phys_addr);
+	err |= put_user(p, &data->phys_addr);
+	err |= get_user(b, &data32->base);
+	err |= put_user(b, &data->base);
+	err |= get_user(v, &data32->virt_addr);
+	err |= put_user(v, &data->virt_addr);
+	err |= get_user(m, &data32->mem_type);
+	err |= put_user(m, &data->mem_type);
+
+	return err;
+}
+
+static int compat_get_ve1_inst_info_data(
+	compat_vpudrv_inst_info_t __user *data32,
+	vpudrv_inst_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_int_t ioc;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(i, &data32->inst_idx);
+	err |= put_user(i, &data->inst_idx);
+	err |= get_user(ioc, &data32->inst_open_count);
+	err |= put_user(ioc, &data->inst_open_count);
+
+	return err;
+}
+
+static int compat_get_ve1_intr_info_data(
+	compat_vpudrv_intr_info_t __user *data32,
+	vpudrv_intr_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t t;
+	compat_int_t i;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(t, &data32->timeout);
+	err |= put_user(t, &data->timeout);
+	err |= get_user(i, &data32->intr_reason);
+	err |= put_user(i, &data->intr_reason);
+#ifdef SUPPORT_MULTI_INST_INTR
+	err |= get_user(i, &data32->intr_inst_index);
+	err |= put_user(i, &data->intr_inst_index);
+#endif
+
+	return err;
+}
+
+static int compat_get_ve1_clock_info(
+	compat_vpu_clock_info_t __user *data32,
+	vpu_clock_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_uint_t v;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(e, &data32->enable);
+	err |= put_user(e, &data->enable);
+	err |= get_user(v, &data32->value);
+	err |= put_user(v, &data->value);
+
+	return err;
+}
+
+static int compat_get_ve1_dovi_info(
+	compat_vpudrv_dovi_info_t __user *data32,
+	vpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_uint_t i;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(i, &data32->inst_idx);
+	err |= put_user(i, &data->inst_idx);
+	err |= get_user(e, &data32->enable);
+	err |= put_user(e, &data->enable);
+
+	return err;
+}
+
+static int compat_put_ve1_buffer_data(
+	compat_vpudrv_buffer_t __user *data32,
+	vpudrv_buffer_t __user *data)
+{
+	compat_uint_t s;
+	compat_ulong_t p;
+	compat_ulong_t b;
+	compat_ulong_t v;
+	compat_uint_t m;
+	int err;
+
+	err = get_user(s, &data->size);
+	err |= put_user(s, &data32->size);
+	err |= get_user(p, &data->phys_addr);
+	err |= put_user(p, &data32->phys_addr);
+	err |= get_user(b, &data->base);
+	err |= put_user(b, &data32->base);
+	err |= get_user(v, &data->virt_addr);
+	err |= put_user(v, &data32->virt_addr);
+	err |= get_user(m, &data->mem_type);
+	err |= put_user(m, &data32->mem_type);
+
+	return err;
+}
+
+static int compat_put_ve1_inst_info_data(
+	compat_vpudrv_inst_info_t __user *data32,
+	vpudrv_inst_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_int_t ioc;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(i, &data->inst_idx);
+	err |= put_user(i, &data32->inst_idx);
+	err |= get_user(ioc, &data->inst_open_count);
+	err |= put_user(ioc, &data32->inst_open_count);
+
+	return err;
+}
+
+static int compat_put_ve1_intr_info_data(
+	compat_vpudrv_intr_info_t __user *data32,
+	vpudrv_intr_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t t;
+	compat_int_t i;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(t, &data->timeout);
+	err |= put_user(t, &data32->timeout);
+	err |= get_user(i, &data->intr_reason);
+	err |= put_user(i, &data32->intr_reason);
+
+	return err;
+}
+
+static int compat_put_ve1_clock_info(
+	compat_vpu_clock_info_t __user *data32,
+	vpu_clock_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_uint_t v;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(e, &data->enable);
+	err |= put_user(e, &data32->enable);
+	err |= get_user(v, &data->value);
+	err |= put_user(v, &data32->value);
+
+	return err;
+}
+
+static int compat_put_ve1_dovi_info(
+	compat_vpudrv_dovi_info_t __user *data32,
+	vpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_uint_t e;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(i, &data->inst_idx);
+	err |= put_user(i, &data32->inst_idx);
+	err |= get_user(e, &data->enable);
+	err |= put_user(e, &data32->enable);
+
+	return err;
+}
+
+long compat_vpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	long ret = 0;
+
+	if (!filp->f_op->unlocked_ioctl)
+		return -ENOTTY;
+
+	switch (cmd) {
+	case COMPAT_VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_FREE_PHYSICALMEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_FREE_PHYSICALMEMORY, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_WAIT_INTERRUPT:
+	{
+		compat_vpudrv_intr_info_t __user *data32;
+		vpudrv_intr_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_intr_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_WAIT_INTERRUPT, (unsigned long)data);
+		err = compat_put_ve1_intr_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case VDI_IOCTL_SET_CLOCK_GATE:
+	case VDI_IOCTL_RESET:
+	case VDI_IOCTL_GET_RTK_ASIC_REVISION:
+	{
+		return filp->f_op->unlocked_ioctl(filp, cmd,
+										  (unsigned long)compat_ptr(arg));
+	}
+
+	case COMPAT_VDI_IOCTL_GET_INSTANCE_POOL:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_INSTANCE_POOL, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_COMMON_MEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_COMMON_MEMORY, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_OPEN_INSTANCE:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_OPEN_INSTANCE, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_CLOSE_INSTANCE:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_CLOSE_INSTANCE, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_INSTANCE_NUM:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_INSTANCE_NUM, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_REGISTER_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_REGISTER_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_GATING:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_GATING, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_PLL:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_PLL, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_CLK_PLL:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_CLK_PLL, (unsigned long)data);
+		err = compat_put_ve1_clock_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_SELECT:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_SELECT, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_CLK_SELECT:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_CLK_SELECT, (unsigned long)data);
+		err = compat_put_ve1_clock_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_DOVI_FLAG:
+	{
+		compat_vpudrv_dovi_info_t __user *data32;
+		vpudrv_dovi_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_dovi_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_DOVI_FLAG, (unsigned long)data);
+		err = compat_put_ve1_dovi_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_SUPPORT_TYPE:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_SUPPORT_TYPE, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_DCSYS_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_DCSYS_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_TOTAL_INSTANCE_NUM:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_TOTAL_INSTANCE_NUM, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	default:
+	{
+		printk(KERN_ERR "[COMPAT_VPUDRV] No such IOCTL, cmd is %d\n", cmd);
+		return -ENOIOCTLCMD;
+	}
+	}
+}
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/ve1/compat_ve1.h b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/compat_ve1.h
new file mode 100644
index 00000000..15c1161
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/compat_ve1.h
@@ -0,0 +1,42 @@
+/*
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_COMPAT_VE1_H
+#define _LINUX_COMPAT_VE1_H
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+typedef struct compat_vpu_bit_firmware_info_t {
+	compat_uint_t size; /* size of this structure*/
+	compat_uint_t core_idx;
+	compat_ulong_t reg_base_offset;
+	compat_ushort_t bit_code[512];
+} compat_vpu_bit_firmware_info_t;
+
+long compat_vpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+
+#else
+
+typedef struct compat_vpu_bit_firmware_info_t {
+	unsigned int size; /* size of this structure*/
+	unsigned int core_idx;
+	unsigned long reg_base_offset;
+	unsigned short bit_code[512];
+} compat_vpu_bit_firmware_info_t;
+
+#define compat_vpu_ioctl  NULL
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_VE1_H */
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/ve1/ve1.c b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/ve1.c
new file mode 100644
index 00000000..dc824c7
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/ve1.c
@@ -0,0 +1,2506 @@
+/*
+ * ve1.c
+ *
+ * linux device driver for VE1.
+ *
+ * Copyright (C) 2006 - 2013  REALTEK INC.
+ *
+ * This library is free software; you can redistribute it and/or modify it under
+ * the terms of the GNU Lesser General Public License as published by the Free
+ * Software Foundation; either version 2.1 of the License, or (at your option)
+ * any later version.
+ *
+ * This library is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+ * details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this library; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301  USA
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/kfifo.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <soc/realtek/rtk_cpu.h>
+
+#ifdef CONFIG_COMPAT
+#include <linux/compat.h>
+#endif
+
+#ifdef CONFIG_POWER_CONTROL
+#include <soc/realtek/power-control.h>
+#endif
+
+#include "ve1config.h"
+#include "ve1.h"
+#include "compat_ve1.h"
+#include "../puwrap.h"
+
+//#define ENABLE_DEBUG_MSG
+#ifdef ENABLE_DEBUG_MSG
+#define DPRINTK(args...) pr_info(args);
+#else
+#define DPRINTK(args...)
+#endif /* ENABLE_DEBUG_MSG */
+
+#define DEV_NAME "[RTK_VE1]"
+#define DISABLE_ORIGIN_SUSPEND
+#define USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+
+/* definitions to be changed as customer  configuration */
+/* if you want to have clock gating scheme frame by frame */
+/* #define VPU_SUPPORT_CLOCK_CONTROL */
+
+/* if the driver want to use interrupt service from kernel ISR */
+#define VPU_SUPPORT_ISR
+
+/* if the platform driver knows the name of this driver */
+/* VPU_PLATFORM_DEVICE_NAME */
+#define VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+/* if this driver knows the dedicated video memory address */
+#ifndef CONFIG_RTK_RESERVE_MEMORY
+#ifdef CONFIG_RTK_PLATFORM_FPGA
+#define VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#endif
+#endif
+
+#define VPU_PLATFORM_DEVICE_NAME "vdec"
+#define VPU_CLK_NAME "vcodec"
+#define VPU_DEV_NAME "vpu"
+
+/* if the platform driver knows this driver */
+/* the definition of VPU_REG_BASE_ADDR and VPU_REG_SIZE are not meaningful */
+
+#define VPU_REG_BASE_ADDR 0x98040000
+#define VPU_REG_SIZE (0x4000*MAX_NUM_VPU_CORE)
+#define MS_TO_NS(x) (x * 1E6L)
+
+#ifdef VPU_SUPPORT_ISR
+#define VE1_IRQ_NUM (85)
+#define VE2_IRQ_NUM (86)
+#endif
+
+/* this definition is only for realtek FPGA board env */
+/* so for SOC env of customers can be ignored */
+
+#ifndef VM_RESERVED	/*for kernel up to 3.7.0 version*/
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+typedef struct vpu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long interrupt_reason_ve1;
+#ifdef SUPPORT_MULTI_INST_INTR
+	unsigned long interrupt_reason_ve2[MAX_NUM_INSTANCE];
+#else
+	unsigned long interrupt_reason_ve2;
+#endif
+	/* !<< device reference count. Not instance count */
+	u32 open_count;
+} vpu_drv_context_t;
+
+/* To track the allocated memory buffer */
+typedef struct vpudrv_buffer_pool_t {
+	struct list_head list;
+	struct vpudrv_buffer_t vb;
+	struct file *filp;
+} vpudrv_buffer_pool_t;
+
+/* To track the instance index and buffer in instance pool */
+typedef struct vpudrv_instanace_list_t {
+	struct list_head list;
+	unsigned long inst_idx;
+	unsigned long core_idx;
+	struct file *filp;
+} vpudrv_instanace_list_t;
+
+typedef struct vpudrv_instance_pool_t {
+	unsigned char codecInstPool[MAX_NUM_INSTANCE][MAX_INST_HANDLE_SIZE];
+	long long pendingInstIdxPlus1;
+	void *pendingInst;
+} vpudrv_instance_pool_t;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#define VPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE 0x0b800000 //(62*1024*1024)
+#define VPU_DRAM_PHYSICAL_BASE 0x03200000 //0x86C00000
+#include "vmm.h"
+static video_mm_t s_vmem;
+static vpudrv_buffer_t s_video_memory = {0};
+#endif /*VPU_SUPPORT_RESERVED_VIDEO_MEMORY*/
+
+static int vpu_hw_reset(u32 coreIdx);
+#ifdef CONFIG_POWER_CONTROL
+static void vpu_pctrl_off(struct power_control *pctrl);
+static void vpu_pctrl_on(struct power_control *pctrl);
+static struct power_control *vpu_pctrl_get(u32 coreIdx);
+#endif /* CONFIG_POWER_CONTROL */
+
+/* end customer definition */
+static vpudrv_buffer_t s_instance_pool = {0};
+static vpudrv_buffer_t s_common_memory = {0};
+static vpu_drv_context_t s_vpu_drv_context;
+static struct miscdevice s_vpu_dev;
+
+static struct clk *s_vpu_clk_ve1;
+static struct clk *s_vpu_clk_ve2;
+#ifdef CONFIG_ARCH_RTD139x
+static struct clk *s_vpu_clk_ve2_bpu;
+#endif /* CONFIG_ARCH_RTD139x */
+static struct clk *s_vpu_clk_sysh;
+static struct clk *s_vpu_pll_ve1;
+static struct clk *s_vpu_pll_ve2;
+static struct device *p_vpu_dev;
+static int s_vpu_open_ref_count;
+static struct reset_control *rstc_ve1;
+static struct reset_control *rstc_ve2;
+
+#ifdef VPU_SUPPORT_ISR
+static int s_ve1_irq = VE1_IRQ_NUM;
+static int s_ve2_irq = VE2_IRQ_NUM;
+#endif /* VPU_SUPPORT_ISR */
+
+#ifdef CONFIG_POWER_CONTROL
+static struct power_control *s_pctrl_ve1;
+static struct power_control *s_pctrl_ve2;
+#endif /* CONFIG_POWER_CONTROL */
+
+static int ve_cti_en = 1;
+/* FIX ME after ver.B IC */
+static int ve_idle_en = 0;
+
+static vpudrv_buffer_t s_vpu_register = {0};
+static vpudrv_buffer_t s_dc_register = {0};
+static vpudrv_buffer_t s_bond_register = {0};
+
+static atomic_t s_interrupt_flag_ve1;
+static wait_queue_head_t s_interrupt_wait_q_ve1;
+#ifdef SUPPORT_MULTI_INST_INTR
+static atomic_t s_interrupt_flag_ve2[MAX_NUM_INSTANCE];
+static wait_queue_head_t s_interrupt_wait_q_ve2[MAX_NUM_INSTANCE];
+typedef struct kfifo kfifo_t;
+static kfifo_t s_interrupt_pending_q_ve2[MAX_NUM_INSTANCE];
+#else
+static atomic_t s_interrupt_flag_ve2;
+static wait_queue_head_t s_interrupt_wait_q_ve2;
+#endif
+
+static spinlock_t s_vpu_lock = __SPIN_LOCK_UNLOCKED(s_vpu_lock);
+static spinlock_t s_ve1_lock = __SPIN_LOCK_UNLOCKED(s_ve1_lock);
+static spinlock_t s_ve2_lock = __SPIN_LOCK_UNLOCKED(s_ve2_lock);
+static DEFINE_SEMAPHORE(s_vpu_sem);
+static struct list_head s_vbp_head = LIST_HEAD_INIT(s_vbp_head);
+static struct list_head s_inst_list_head = LIST_HEAD_INIT(s_inst_list_head);
+
+static vpu_bit_firmware_info_t s_bit_firmware_info[MAX_NUM_VPU_CORE];
+
+#define BIT_BASE 0x0000
+#define BIT_INT_STS (BIT_BASE + 0x010)
+#define BIT_INT_REASON (BIT_BASE + 0x174)
+#define BIT_INT_CLEAR (BIT_BASE + 0x00C)
+#define VE_CTRL_REG (BIT_BASE + 0x3000)
+#define VE_CTI_GRP_REG (BIT_BASE + 0x3004)
+
+#define W5_REG_BASE 0x0000
+#define W5_VPU_INT_CLEAR (W5_REG_BASE + 0x003C)
+#define W5_VPU_INT_STS (W5_REG_BASE + 0x0044)
+#define W5_VPU_INT_REASON (W5_REG_BASE + 0x004c)
+#define W5_VPU_INT_REASON_CLEAR (W5_REG_BASE + 0x0034)
+#ifdef SUPPORT_MULTI_INST_INTR
+#define W5_RET_BS_EMPTY_INST        (W5_REG_BASE + 0x01E4)
+#define W5_RET_QUEUE_CMD_DONE_INST  (W5_REG_BASE + 0x01E8)
+#define W5_RET_DONE_INSTANCE_INFO   (W5_REG_BASE + 0x01FC)
+typedef enum {
+    INT_WAVE5_INIT_VPU          = 0,
+    INT_WAVE5_WAKEUP_VPU        = 1,
+    INT_WAVE5_SLEEP_VPU         = 2,
+    INT_WAVE5_CREATE_INSTANCE   = 3,
+    INT_WAVE5_FLUSH_INSTANCE    = 4,
+    INT_WAVE5_DESTORY_INSTANCE  = 5,
+    INT_WAVE5_INIT_SEQ          = 6,
+    INT_WAVE5_SET_FRAMEBUF      = 7,
+    INT_WAVE5_DEC_PIC           = 8,
+    INT_WAVE5_ENC_PIC           = 8,
+    INT_WAVE5_ENC_SET_PARAM     = 9,
+    INT_WAVE5_DEC_QUERY         = 14,
+    INT_WAVE5_BSBUF_EMPTY       = 15,
+    INT_WAVE5_BSBUF_FULL        = 15,
+} Wave5InterruptBit;
+#endif
+
+#define W5_VE_CTRL_REG (W5_REG_BASE + 0x3E00)
+#define W5_VE_CTI_GRP_REG (W5_REG_BASE + 0x3E04)
+
+#ifdef CONFIG_PM
+/* implement to power management functions */
+#define BIT_CODE_RUN (BIT_BASE + 0x000)
+#define BIT_CODE_DOWN (BIT_BASE + 0x004)
+#define BIT_CODE_RESET (BIT_BASE + 0x014)
+#define BIT_BUSY_FLAG (BIT_BASE + 0x160)
+#define BIT_RUN_COMMAND (BIT_BASE + 0x164)
+#define BIT_RUN_INDEX (BIT_BASE + 0x168)
+#define BIT_RUN_COD_STD (BIT_BASE + 0x16C)
+
+/* WAVE5 registers */
+#define W5_VPU_BUSY_STATUS (W5_REG_BASE + 0x0070)
+
+#define W5_RET_SUCCESS (W5_REG_BASE + 0x0110)
+#define W5_RET_FAIL_REASON (W5_REG_BASE + 0x0114)
+
+/* WAVE5 INIT, WAKEUP */
+#define W5_PO_CONF (W5_REG_BASE + 0x0000)
+#define W5_VCPU_CUR_PC	 (W5_REG_BASE + 0x0004)
+
+#define W5_VPU_INT_ENABLE (W5_REG_BASE + 0x0048)
+
+#define W5_RESET_REQ (W5_REG_BASE + 0x0050)
+#define W5_RESET_STATUS (W5_REG_BASE + 0x0054)
+
+#define W5_VPU_REMAP_CTRL (W5_REG_BASE + 0x0060)
+#define W5_VPU_REMAP_VADDR	(W5_REG_BASE + 0x0064)
+#define W5_VPU_REMAP_PADDR (W5_REG_BASE + 0x0068)
+#define W5_VPU_REMAP_PROC_START (W5_REG_BASE + 0x006C)
+#define W5_VPU_BUSY_STATUS (W5_REG_BASE + 0x0070)
+
+#define W5_REMAP_CODE_INDEX 0
+
+enum {
+	W5_INT_INIT_VPU = 0,
+	W5_INT_DEC_PIC_HDR = 1,
+	W5_INT_FINI_SEQ = 2,
+	W5_INT_DEC_PIC = 3,
+	W5_INT_SET_FRAMEBUF = 4,
+	W5_INT_FLUSH_DEC = 5,
+	W5_INT_GET_FW_VERSION = 9,
+	W5_INT_QUERY_DEC = 10,
+	W5_INT_SLEEP_VPU = 11,
+	W5_INT_WAKEUP_VPU = 12,
+	W5_INT_CHANGE_INT = 13,
+	W5_INT_CREATE_INSTANCE = 14,
+	/*!<< Bitstream buffer empty */
+	W5_INT_BSBUF_EMPTY = 15,
+	W5_INT_ENC_SLICE_INT = 15,
+};
+
+#define W5_HW_OPTION (W5_REG_BASE + 0x0124)
+#define W5_CODE_SIZE (W5_REG_BASE + 0x011C)
+/* Note: W5_INIT_CODE_BASE_ADDR should be aligned to 4KB */
+#define W5_ADDR_CODE_BASE (W5_REG_BASE + 0x0118)
+#define W5_CODE_PARAM (W5_REG_BASE + 0x0120)
+/* Note: W5_INIT_STACK_BASE_ADDR should be aligned to 4KB */
+#define W5_ADDR_STACK_BASE (W5_REG_BASE + 0x012C)
+#define W5_STACK_SIZE (W5_REG_BASE + 0x0130)
+#define W5_INIT_VPU_TIME_OUT_CNT (W5_REG_BASE + 0x0134)
+
+/* WAVE5 Wave5BitIssueCommand */
+#define W5_CORE_INDEX (W5_REG_BASE + 0x0104)
+#define W5_INST_INDEX (W5_REG_BASE + 0x0108)
+#define W5_COMMAND (W5_REG_BASE + 0x0100)
+#define W5_VPU_HOST_INT_REQ (W5_REG_BASE + 0x0038)
+
+/* Product register */
+#define VPU_PRODUCT_CODE_REGISTER   (BIT_BASE + 0x1044)
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+static u32 s_vpu_reg_store[MAX_NUM_VPU_CORE][64];
+#endif
+#endif /* CONFIG_PM */
+
+/*
+ * common struct and definition
+ */
+#define ReadVpuRegister(addr, core) *(volatile unsigned int *)(s_vpu_register.virt_addr + (0x4000 * core) + addr)
+#define WriteVpuRegister(addr, val, core) *(volatile unsigned int *)(s_vpu_register.virt_addr + (0x4000 * core) + addr) = (unsigned int)val
+#define WriteVpu(addr, val) *(volatile unsigned int *)(addr) = (unsigned int)val;
+
+struct clk *vpu_clk_get(struct device *dev, u32 coreIdx)
+{
+	if (coreIdx == 0)
+		return clk_get(dev, "clk_ve1");
+	else
+		return clk_get(dev, "clk_ve2");
+	//return clk_get(dev, VPU_CLK_NAME);
+}
+
+void vpu_clk_put(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk)))
+		clk_put(clk);
+}
+
+unsigned long vpu_clk_get_rate(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+		DPRINTK("%s vpu_clk_get_rate\n", DEV_NAME);
+		return clk_get_rate(clk);
+	}
+
+	return 0;
+}
+
+int vpu_clk_enable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+#if 0 /* the bellow is for EVB.*/
+		{
+			struct clk *s_vpuext_clk = NULL;
+			s_vpuext_clk = clk_get(NULL, "vcore");
+			if (s_vpuext_clk) {
+				DPRINTK("%s vcore clk=%p\n", DEV_NAME, s_vpuext_clk);
+				clk_enable(s_vpuext_clk);
+			}
+
+			DPRINTK("%s vbus clk=%p\n", DEV_NAME, s_vpuext_clk);
+			if (s_vpuext_clk) {
+				s_vpuext_clk = clk_get(NULL, "vbus");
+				clk_enable(s_vpuext_clk);
+			}
+		}
+#endif /* for EVB. */
+
+		DPRINTK("%s vpu_clk_enable\n", DEV_NAME);
+		return clk_prepare_enable(clk)/*clk_enable(clk)*/;
+	}
+
+	return 0;
+}
+
+void vpu_clk_disable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+		DPRINTK("%s vpu_clk_disable\n", DEV_NAME);
+		//clk_disable(clk);
+		while (__clk_is_enabled(clk))
+			clk_disable_unprepare(clk);
+	}
+}
+
+static int vpu_clk_pll_set_rate(struct clk *clk, unsigned int rate)
+{
+	struct clk *pclk;
+
+	/* check if the parent clk is clk_sysh */
+	pclk = clk_get_parent(clk);
+	if (clk_is_match(pclk, s_vpu_clk_sysh)) {
+	        pr_warn("[VPUDRV] %s: set clk_sysh is not allowed\n", __func__);
+		return -EPERM;
+	}
+
+	/* set rate */
+	clk_set_rate(clk, rate);
+
+	return 0;
+}
+
+static void ve1_wrapper_setup(unsigned int coreIdx)
+{
+	unsigned int ctrl_1;
+	unsigned int ctrl_2;
+
+	/* coreIdx == 0 */
+	if ((coreIdx & (1 << 0)) != 0) {
+		ctrl_1 = ReadVpuRegister(VE_CTRL_REG, 0);
+		ctrl_2 = ReadVpuRegister(VE_CTI_GRP_REG, 0);
+		ctrl_1 |= (ve_cti_en << 1 | ve_idle_en << 6);
+		/* ve1_cti_cmd_depth for 1296 timing issue */
+		ctrl_2 = (ctrl_2 & ~(0x3f << 24)) | (0x1a << 24);
+		WriteVpuRegister(VE_CTRL_REG, ctrl_1, 0);
+		WriteVpuRegister(VE_CTI_GRP_REG, ctrl_2, 0);
+	}
+
+	/* coreIdx == 1 */
+	if ((coreIdx & (1 << 1)) != 0) {
+		ctrl_1 = ReadVpuRegister(W5_VE_CTRL_REG, 1);
+		ctrl_2 = ReadVpuRegister(W5_VE_CTI_GRP_REG, 1);
+		ctrl_1 |= (ve_cti_en << 1 | ve_idle_en << 6);
+		/* ve2_cti_cmd_depth for 1296 timing issue */
+		ctrl_2 = (ctrl_2 & ~(0x3f << 24)) | (0x1a << 24);
+		WriteVpuRegister(W5_VE_CTRL_REG, ctrl_1, 1);
+		WriteVpuRegister(W5_VE_CTI_GRP_REG, ctrl_2, 1);
+	}
+}
+
+int vpu_hw_reset(u32 coreIdx)
+{
+	struct reset_control *rstc;
+
+#if 1 /* RTK, workaround for demo */
+	DPRINTK("%s request vpu reset from application\n", DEV_NAME);
+
+	rstc = (coreIdx == 0 ? rstc_ve1 : rstc_ve2);
+	reset_control_reset(rstc);
+
+	ve1_wrapper_setup((1 << coreIdx));
+#endif
+	return 0;
+}
+
+static int vpu_alloc_dma_buffer(vpudrv_buffer_t *vb)
+{
+	unsigned int ret;
+
+	if (!vb)
+		return -1;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	UNUSED_PARAMETER(ret);
+	vb->phys_addr = (unsigned long)vmem_alloc(&s_vmem, vb->size, 0);
+	if ((unsigned long)vb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+
+	vb->base = (unsigned long)(s_video_memory.base + (vb->phys_addr - s_video_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	ret = pu_alloc_dma_buffer(vb->size, &vb->phys_addr, &vb->base, vb->mem_type);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#else
+	UNUSED_PARAMETER(ret);
+	vb->base = (unsigned long)dma_alloc_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (dma_addr_t *) (&vb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	DPRINTK("%s base:0x%lx, phy_addr:0x%lx, size:%d\n", DEV_NAME, vb->base, vb->phys_addr, vb->size);
+	return 0;
+}
+
+static int vpu_alloc_dma_buffer2(vpudrv_buffer_t *vb)
+{
+	unsigned int ret;
+
+	if (!vb)
+		return -1;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	UNUSED_PARAMETER(ret);
+	vb->phys_addr = (unsigned long)vmem_alloc(&s_vmem, vb->size, 0);
+	if ((unsigned long)vb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+
+	vb->base = (unsigned long)(s_video_memory.base + (vb->phys_addr - s_video_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	ret = pu_alloc_dma_buffer(vb->size, &vb->phys_addr, &vb->base, vb->mem_type);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+	vb->base = pu_mmap_kernel_buffer(vb->phys_addr, vb->size);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s pu_mmap_kernel_buffer error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#else
+	UNUSED_PARAMETER(ret);
+	vb->base = (unsigned long)dma_alloc_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (dma_addr_t *) (&vb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	DPRINTK("%s base:0x%lx, phy_addr:0x%lx, size:%d\n", DEV_NAME, vb->base, vb->phys_addr, vb->size);
+	return 0;
+}
+
+static void vpu_free_dma_buffer(vpudrv_buffer_t *vb)
+{
+	if (!vb)
+		return;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (vb->base)
+		vmem_free(&s_vmem, vb->phys_addr, 0);
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	pu_free_dma_buffer(vb->base, vb->phys_addr);
+#else
+	if (vb->base) {
+		dma_free_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (void *)vb->base, vb->phys_addr);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+}
+
+/* size=40 for Android M */
+#define PTHREAD_MUTEX_T_HANDLE_SIZE 40
+
+static int vpu_free_instances(struct file *filp)
+{
+	vpudrv_instanace_list_t *vil, *n;
+	vpudrv_instance_pool_t *vip;
+	void *vip_base;
+	int instance_pool_size_per_core;
+	void *vdi_mutexes_base;
+	const int PTHREAD_MUTEX_T_DESTROY_VALUE = 0xdead10cc;
+
+	DPRINTK("%s vpu_free_instances\n", DEV_NAME);
+
+	/* s_instance_pool.size  assigned to the size of all core once call VDI_IOCTL_GET_INSTANCE_POOL by user. */
+	instance_pool_size_per_core = (s_instance_pool.size/MAX_NUM_VPU_CORE);
+
+	list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+		if (vil->filp == filp) {
+			int i, j;
+			for (i = 0; i < MAX_NUM_INSTANCE; i++) /* reset dovi flag */
+			{
+				for (j = 0; j < MAX_NUM_VPU_CORE; j++)
+				{
+					pu_set_dovi_flag(j, i, 0);
+				}
+			}
+
+			vip_base = (void *)(s_instance_pool.base + (instance_pool_size_per_core*vil->core_idx));
+			DPRINTK("%s vpu_free_instances detect instance crash instIdx=%d, coreIdx=%d, vip_base=%p, instance_pool_size_per_core=%d\n", DEV_NAME, (int)vil->inst_idx, (int)vil->core_idx, vip_base, (int)instance_pool_size_per_core);
+			vip = (vpudrv_instance_pool_t *)vip_base;
+
+			if (vip) {
+				/* only first 4 byte is key point(inUse of CodecInst in vpuapi) to free the corresponding instance. */
+				memset(&vip->codecInstPool[vil->inst_idx], 0x00, 4);
+
+				if (vil->inst_idx == (vip->pendingInstIdxPlus1-1) && vip->pendingInst != 0) {
+					pr_warn("%s vil->inst_idx:%d, vil->core_idx:%d is pending, clear in here\n", DEV_NAME, (int)vil->inst_idx, (int)vil->core_idx);
+					vip->pendingInst = 0;
+					vip->pendingInstIdxPlus1 = 0;
+				}
+
+				vdi_mutexes_base = (vip_base + (instance_pool_size_per_core - PTHREAD_MUTEX_T_HANDLE_SIZE*4));
+				DPRINTK("%s vpu_free_instances : force to destroy vdi_mutexes_base=%p in userspace \n", DEV_NAME, vdi_mutexes_base);
+				if (vdi_mutexes_base) {
+					int i;
+					for (i = 0; i < 4; i++) {
+						memcpy(vdi_mutexes_base, &PTHREAD_MUTEX_T_DESTROY_VALUE, PTHREAD_MUTEX_T_HANDLE_SIZE);
+						vdi_mutexes_base += PTHREAD_MUTEX_T_HANDLE_SIZE;
+					}
+				}
+			}
+			s_vpu_open_ref_count--;
+			list_del(&vil->list);
+			kfree(vil);
+		}
+	}
+	return 1;
+}
+
+static int vpu_free_buffers(struct file *filp)
+{
+	vpudrv_buffer_pool_t *pool, *n;
+	vpudrv_buffer_t vb;
+
+	DPRINTK("%s vpu_free_buffers\n", DEV_NAME);
+
+	list_for_each_entry_safe(pool, n, &s_vbp_head, list) {
+		if (pool->filp == filp) {
+			vb = pool->vb;
+			if (vb.base) {
+				vpu_free_dma_buffer(&vb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+
+	return 0;
+}
+
+static irqreturn_t ve1_irq_handler(int irq, void *dev_id)
+{
+	vpu_drv_context_t *dev = (vpu_drv_context_t *)dev_id;
+
+	/* this can be removed. it also work in VPU_WaitInterrupt of API function */
+	int core = 0;
+	unsigned long interrupt_reason_ve1 = 0;
+	unsigned int vpu_int_sts_ve1 = 0;
+	unsigned long flags;
+
+	//DPRINTK("%s [+]%s\n", DEV_NAME, __func__);
+
+	/* it means that we didn't get an information the current core from API layer. No core activated.*/
+	if (s_bit_firmware_info[core].size == 0) {
+		pr_err("[VPUDRV] :  s_bit_firmware_info[core].size is zero\n");
+		return IRQ_HANDLED;
+	}
+
+	vpu_int_sts_ve1 = ReadVpuRegister(BIT_INT_STS, core);
+	if (vpu_int_sts_ve1) {
+		interrupt_reason_ve1 = ReadVpuRegister(BIT_INT_REASON, core);
+		WriteVpuRegister(BIT_INT_REASON, 0, core);
+		WriteVpuRegister(BIT_INT_CLEAR, 0x1, core);
+	}
+
+	//DPRINTK("%s VE1 intr_reason: 0x%08lx\n", DEV_NAME, dev->interrupt_reason_ve1);
+
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN); /* notify the interrupt to user space */
+
+	if (vpu_int_sts_ve1) {
+		spin_lock_irqsave(&s_ve1_lock, flags);
+		dev->interrupt_reason_ve1 = interrupt_reason_ve1;
+		atomic_set(&s_interrupt_flag_ve1, 1);
+		spin_unlock_irqrestore(&s_ve1_lock, flags);
+		wake_up_interruptible(&s_interrupt_wait_q_ve1);
+		//DPRINTK("%s [-]%s\n", DEV_NAME, __func__);
+	}
+
+	return IRQ_HANDLED;
+}
+
+#ifdef SUPPORT_MULTI_INST_INTR
+static inline u32 get_inst_idx(u32 reg_val)
+{
+	u32 inst_idx;
+	int i;
+	for (i=0; i < MAX_NUM_INSTANCE; i++)
+	{
+		if(((reg_val >> i)&0x01) == 1)
+			break;
+	}
+	inst_idx = i;
+	return inst_idx;
+}
+
+static u32 get_vpu_inst_idx(vpu_drv_context_t *dev, u32 *reason, u32 empty_inst, u32 done_inst, u32 other_inst)
+{
+	u32 inst_idx;
+	u32 reg_val;
+	u32 int_reason;
+
+	int_reason = *reason;
+	DPRINTK("%s [+]%s, int_reason=0x%x, empty_inst=0x%x, done_inst=0x%x\n", DEV_NAME, __func__, int_reason, empty_inst, done_inst);
+
+	if (int_reason & (1 << INT_WAVE5_BSBUF_EMPTY))
+	{
+		reg_val = empty_inst;
+		inst_idx = get_inst_idx(reg_val);
+		*reason = (1 << INT_WAVE5_BSBUF_EMPTY);
+		DPRINTK("%s	%s, W5_RET_BS_EMPTY_INST reg_val=0x%x, inst_idx=%d\n", DEV_NAME, __func__, reg_val, inst_idx);
+		goto GET_VPU_INST_IDX_HANDLED;
+	}
+
+	if (int_reason & (1 << INT_WAVE5_DEC_PIC))
+	{
+		reg_val = done_inst;
+		inst_idx = get_inst_idx(reg_val);
+		*reason  = (1 << INT_WAVE5_DEC_PIC);
+		DPRINTK("[VPUDRV]  %s, W5_RET_QUEUE_CMD_DONE_INST DEC_PIC reg_val=0x%x, inst_idx=%d\n", __func__, reg_val, inst_idx);
+		goto GET_VPU_INST_IDX_HANDLED;
+	}
+
+	if (int_reason & (1 << INT_WAVE5_INIT_SEQ))
+	{
+		reg_val = done_inst;
+		inst_idx = get_inst_idx(reg_val);
+		*reason  = (1 << INT_WAVE5_INIT_SEQ);
+		DPRINTK("[VPUDRV]  %s, W5_RET_QUEUE_CMD_DONE_INST INIT_SEQ reg_val=0x%x, inst_idx=%d\n", __func__, reg_val, inst_idx);
+		goto GET_VPU_INST_IDX_HANDLED;
+	}
+
+	// if  interrupt is not for empty and dec_pic and init_seq.
+	reg_val = (other_inst&0xFF);
+	inst_idx = reg_val;
+	*reason  = int_reason;
+	DPRINTK("%s	%s, W5_RET_DONE_INSTANCE_INFO reg_val=0x%x, inst_idx=%d\n", DEV_NAME, __func__, reg_val, inst_idx);
+GET_VPU_INST_IDX_HANDLED:
+
+	DPRINTK("%s [-]%s, inst_idx=%d. *reason=0x%x\n", DEV_NAME, __func__, inst_idx, *reason);
+
+	return inst_idx;
+}
+#endif
+static irqreturn_t ve2_irq_handler(int irq, void *dev_id)
+{
+	vpu_drv_context_t *dev = (vpu_drv_context_t *)dev_id;
+
+	/* this can be removed. it also work in VPU_WaitInterrupt of API function */
+	int core = 1;
+	unsigned int vpu_int_sts_ve2 = 0;
+	unsigned long flags;
+#ifdef SUPPORT_MULTI_INST_INTR
+	u32 intr_reason = 0;
+	u32 intr_inst_index = 0;
+#endif
+
+	//DPRINTK("%s [+]%s\n", DEV_NAME, __func__);
+
+	if (s_bit_firmware_info[core].size == 0) {/* it means that we didn't get an information the current core from API layer. No core activated.*/
+		pr_err("[VPUDRV] :  s_bit_firmware_info[core].size is zero\n");
+		return IRQ_HANDLED;
+	}
+
+	vpu_int_sts_ve2 = ReadVpuRegister(W5_VPU_INT_STS, core);
+	if (vpu_int_sts_ve2) {
+#ifdef SUPPORT_MULTI_INST_INTR
+		u32 intr_reason_reg;
+		u32 empty_inst;
+		u32 done_inst;
+		u32 other_inst;
+
+		intr_reason_reg = ReadVpuRegister(W5_VPU_INT_REASON, core);
+		empty_inst = ReadVpuRegister(W5_RET_BS_EMPTY_INST, core);
+		done_inst = ReadVpuRegister(W5_RET_QUEUE_CMD_DONE_INST, core);
+		other_inst = ReadVpuRegister(W5_RET_DONE_INSTANCE_INFO, core);
+
+		DPRINTK("%s %s reason=0x%x, empty_inst=0x%x, done_inst=0x%x, other_inst=0x%x \n", DEV_NAME,  __func__, intr_reason_reg, empty_inst, done_inst, other_inst);
+
+		intr_reason = intr_reason_reg;
+
+		intr_inst_index = get_vpu_inst_idx(dev, &intr_reason, empty_inst, done_inst, other_inst);
+#ifdef SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+		if (intr_inst_index >= 0 && intr_inst_index < MAX_NUM_INSTANCE)
+		{
+#define FIX_MULTI_INSTANCE_CLEAR_BS_EMPTY_AT_HOST
+#ifdef FIX_MULTI_INSTANCE_CLEAR_BS_EMPTY_AT_HOST
+			if (intr_reason == (1 << INT_WAVE5_BSBUF_EMPTY))
+			{
+				empty_inst = empty_inst & ~(1 << intr_inst_index);
+				WriteVpuRegister(W5_RET_BS_EMPTY_INST, empty_inst, core);
+				DPRINTK("[VPUDRV]   %s, W5_RET_BS_EMPTY_INST Clear empty_inst=0x%x, intr_inst_index=%d\n", __func__, empty_inst, intr_inst_index);
+			}
+
+			if ((intr_reason == (1 << INT_WAVE5_DEC_PIC)) || (intr_reason == (1 << INT_WAVE5_INIT_SEQ)))
+			{
+				done_inst = done_inst & ~(1 << intr_inst_index);
+				WriteVpuRegister(W5_RET_QUEUE_CMD_DONE_INST, done_inst, core);
+				DPRINTK("[VPUDRV]  %s, W5_RET_QUEUE_CMD_DONE_INST Clear done_inst=0x%x, intr_inst_index=%d\n", __func__, done_inst, intr_inst_index);
+			}
+#endif
+		}
+		if (intr_inst_index >= 0 && intr_inst_index < MAX_NUM_INSTANCE) {
+			if (!kfifo_is_full(&s_interrupt_pending_q_ve2[intr_inst_index])) {
+				kfifo_in(&s_interrupt_pending_q_ve2[intr_inst_index], &intr_reason, sizeof(u32));
+			}
+			else {
+				pr_err("%s :  kfifo_is_full kfifo_count=%d \n", DEV_NAME, kfifo_len(&s_interrupt_pending_q_ve2[intr_inst_index]));
+			}
+		}
+		else {
+			pr_err("%s :  intr_inst_index is wrong intr_inst_index=%d \n", DEV_NAME, intr_inst_index);
+		}
+
+#else
+		kfifo_in(&s_interrupt_pending_q_ve2[intr_inst_index], &intr_reason, sizeof(u32));
+#endif
+		WriteVpuRegister(W5_VPU_INT_REASON_CLEAR, intr_reason, core);
+#else
+		unsigned long interrupt_reason_ve2 = 0;
+		interrupt_reason_ve2 = ReadVpuRegister(W5_VPU_INT_REASON, core);
+		WriteVpuRegister(W5_VPU_INT_REASON_CLEAR, interrupt_reason_ve2, core);
+#endif
+		WriteVpuRegister(W5_VPU_INT_CLEAR, 0x1, core);
+	}
+	DPRINTK("%s VE2 intr_reason: 0x%08lx, intr_inst_index:%d\n", DEV_NAME, intr_reason, intr_inst_index);
+
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN);	/* notify the interrupt to user space */
+
+	if (vpu_int_sts_ve2) {
+#ifdef SUPPORT_MULTI_INST_INTR
+#ifdef SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+		if (intr_inst_index >= 0 && intr_inst_index < MAX_NUM_INSTANCE) {
+			spin_lock_irqsave(&s_ve2_lock, flags);
+			atomic_set(&s_interrupt_flag_ve2[intr_inst_index], 1);
+			spin_unlock_irqrestore(&s_ve2_lock, flags);
+			wake_up_interruptible(&s_interrupt_wait_q_ve2[intr_inst_index]);
+		}
+#else
+		spin_lock_irqsave(&s_ve2_lock, flags);
+		atomic_set(&s_interrupt_flag_ve2[intr_inst_index], 1);
+		spin_unlock_irqrestore(&s_ve2_lock, flags);
+		wake_up_interruptible(&s_interrupt_wait_q_ve2[intr_inst_index]);
+#endif
+#else
+		spin_lock_irqsave(&s_ve2_lock, flags);
+		dev->interrupt_reason_ve2 = interrupt_reason_ve2;
+		atomic_set(&s_interrupt_flag_ve2, 1);
+		spin_unlock_irqrestore(&s_ve2_lock, flags);
+		wake_up_interruptible(&s_interrupt_wait_q_ve2);
+#endif
+		DPRINTK("%s [-]%s\n", DEV_NAME, __func__);
+	}
+
+	return IRQ_HANDLED;
+}
+
+static int vpu_open(struct inode *inode, struct file *filp)
+{
+	DPRINTK("%s [+] %s\n", DEV_NAME, __func__);
+	spin_lock(&s_vpu_lock);
+
+	s_vpu_drv_context.open_count++;
+
+	filp->private_data = (void *)(&s_vpu_drv_context);
+	spin_unlock(&s_vpu_lock);
+
+	DPRINTK("%s [-] %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+
+/*static int vpu_ioctl(struct inode *inode, struct file *filp, u_int cmd, u_long arg) // for kernel 2.6.9*/
+static long vpu_ioctl(struct file *filp, u_int cmd, u_long arg)
+{
+	int ret = 0;
+	struct vpu_drv_context_t *dev = (struct vpu_drv_context_t *)filp->private_data;
+
+	switch (cmd) {
+	case VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+	{
+		vpudrv_buffer_pool_t *vbp;
+
+		DPRINTK("%s [+]VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			vbp = kzalloc(sizeof(*vbp), GFP_KERNEL);
+			if (!vbp) {
+				up(&s_vpu_sem);
+				return -ENOMEM;
+			}
+
+			ret = copy_from_user(&(vbp->vb), (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret) {
+				kfree(vbp);
+				up(&s_vpu_sem);
+				return -EFAULT;
+			}
+
+			ret = vpu_alloc_dma_buffer(&(vbp->vb));
+			if (ret == -1) {
+				ret = -ENOMEM;
+				kfree(vbp);
+				up(&s_vpu_sem);
+				break;
+			}
+
+			ret = copy_to_user((void __user *)arg, &(vbp->vb), sizeof(vpudrv_buffer_t));
+			if (ret) {
+				kfree(vbp);
+				ret = -EFAULT;
+				up(&s_vpu_sem);
+				break;
+			}
+
+			vbp->filp = filp;
+			spin_lock(&s_vpu_lock);
+			list_add(&vbp->list, &s_vbp_head);
+			spin_unlock(&s_vpu_lock);
+
+			up(&s_vpu_sem);
+		}
+		DPRINTK("%s [-]VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_FREE_PHYSICALMEMORY:
+	{
+		vpudrv_buffer_pool_t *vbp, *n;
+		vpudrv_buffer_t vb;
+
+		DPRINTK("%s [+]VDI_IOCTL_FREE_PHYSICALMEMORY\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			ret = copy_from_user(&vb, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret) {
+				up(&s_vpu_sem);
+				return -EACCES;
+			}
+
+			if (vb.base)
+				vpu_free_dma_buffer(&vb);
+
+			spin_lock(&s_vpu_lock);
+			list_for_each_entry_safe(vbp, n, &s_vbp_head, list) {
+				if (vbp->vb.phys_addr == vb.phys_addr/*vbp->vb.base == vb.base*/) {
+					list_del(&vbp->list);
+					kfree(vbp);
+					break;
+				}
+			}
+			spin_unlock(&s_vpu_lock);
+
+			up(&s_vpu_sem);
+		}
+		DPRINTK("%s [-]VDI_IOCTL_FREE_PHYSICALMEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+	{
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+		DPRINTK("%s [+]VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO\n", DEV_NAME);
+		if (s_video_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_video_memory, sizeof(vpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = -EFAULT;
+		}
+		DPRINTK("%s [-]VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO\n", DEV_NAME);
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+	}
+	break;
+
+	case VDI_IOCTL_WAIT_INTERRUPT:
+	{
+		vpudrv_intr_info_t info;
+		unsigned long flags;
+#ifdef SUPPORT_MULTI_INST_INTR
+		u32 intr_inst_index;
+		u32 intr_reason_in_q;
+		u32 interrupt_flag_in_q;
+#endif
+		DPRINTK("[VPUDRV][+]VDI_IOCTL_WAIT_INTERRUPT\n");
+		ret = copy_from_user(&info, (vpudrv_intr_info_t *)arg, sizeof(vpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		/* VE1 */
+		if (info.core_idx == 0) {
+			smp_rmb();
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve1, atomic_read(&s_interrupt_flag_ve1) != 0, msecs_to_jiffies(info.timeout));
+			if (!ret) {
+				ret = -ETIME;
+				break;
+			}
+
+			if (signal_pending(current)) {
+				ret = -ERESTARTSYS;
+				break;
+			}
+
+			//DPRINTK("[VPUDRV] s_interrupt_flag_ve1(%d), reason(0x%08lx)\n", atomic_read(&s_interrupt_flag_ve1), dev->interrupt_reason_ve1);
+			spin_lock_irqsave(&s_ve1_lock, flags);
+			atomic_set(&s_interrupt_flag_ve1, 0);
+			info.intr_reason = dev->interrupt_reason_ve1;
+			dev->interrupt_reason_ve1 = 0;
+			spin_unlock_irqrestore(&s_ve1_lock, flags);
+		} else { /* VE2 */
+#ifdef USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+			ktime_t ktime;
+			unsigned long delay_in_ms = 1L;
+			ktime = ktime_set(0, MS_TO_NS(delay_in_ms));
+			//ktime = ktime_set(0, MS_TO_NS((u64)info.timeout));
+#endif /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+
+#ifdef SUPPORT_MULTI_INST_INTR
+			intr_inst_index = info.intr_inst_index;
+
+			intr_reason_in_q = 0;
+			interrupt_flag_in_q = kfifo_out(&s_interrupt_pending_q_ve2[intr_inst_index], &intr_reason_in_q, sizeof(u32));
+			DPRINTK("%s interrupt_flag_in_q:%d, intr_inst_index:%d, intr_reason_in_q:%d, kfifo_count=%d\n", DEV_NAME, interrupt_flag_in_q, intr_inst_index, intr_reason_in_q, kfifo_len(&s_interrupt_pending_q_ve2[intr_inst_index]));
+			if (interrupt_flag_in_q > 0)
+			{
+				dev->interrupt_reason_ve2[intr_inst_index] = intr_reason_in_q;
+				DPRINTK("%s Interrupt Remain : intr_inst_index=%d, intr_reason_in_q=0x%x, interrupt_flag_in_q=%d\n", DEV_NAME, intr_inst_index, intr_reason_in_q, interrupt_flag_in_q);
+				goto INTERRUPT_REMAIN_IN_QUEUE;
+			}
+#ifdef SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+			else {
+				dev->interrupt_reason_ve2[intr_inst_index] = 0;
+			}
+#endif
+
+#ifdef USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+			ret = wait_event_interruptible_hrtimeout(s_interrupt_wait_q_ve2[intr_inst_index], atomic_read(&s_interrupt_flag_ve2[intr_inst_index]) != 0, ktime);
+#else /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve2[intr_inst_index], atomic_read(&s_interrupt_flag_ve2[intr_inst_index]) != 0, msecs_to_jiffies(info.timeout));
+#endif /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+
+#else /* SUPPORT_MULTI_INST_INTR */
+			smp_rmb();
+#ifdef USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+			ret = wait_event_interruptible_hrtimeout(s_interrupt_wait_q_ve2, atomic_read(&s_interrupt_flag_ve2) != 0, ktime);
+#else /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve2, atomic_read(&s_interrupt_flag_ve2) != 0, msecs_to_jiffies(info.timeout));
+#endif /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+#endif /* SUPPORT_MULTI_INST_INTR */
+
+#ifdef USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+			if (ret) {
+				ret = -ETIME;
+				break;
+			}
+#else /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+			if (!ret) {
+				ret = -ETIME;
+				break;
+			}
+#endif /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+
+			if (signal_pending(current)) {
+				ret = -ERESTARTSYS;
+				break;
+			}
+
+#ifdef SUPPORT_MULTI_INST_INTR
+			intr_reason_in_q = 0;
+			interrupt_flag_in_q = kfifo_out(&s_interrupt_pending_q_ve2[intr_inst_index], &intr_reason_in_q, sizeof(u32));
+			if (interrupt_flag_in_q > 0) {
+				dev->interrupt_reason_ve2[intr_inst_index] = intr_reason_in_q;
+			}
+#endif
+
+#ifdef SUPPORT_MULTI_INST_INTR
+			DPRINTK("%s inst_index(%d), s_interrupt_flag(%d), reason(0x%08lx), kfifo_count=%d\n", DEV_NAME, intr_inst_index, s_interrupt_flag_ve2[intr_inst_index], dev->interrupt_reason_ve2[intr_inst_index], kfifo_len(&s_interrupt_pending_q_ve2[intr_inst_index]));
+#else
+			//DPRINTK("%s	s_interrupt_flag(%d), reason(0x%08lx)\n", DEV_NAME, s_interrupt_flag_ve2, dev->interrupt_reason_ve2);
+#endif
+
+INTERRUPT_REMAIN_IN_QUEUE:
+
+			spin_lock_irqsave(&s_ve2_lock, flags);
+#ifdef SUPPORT_MULTI_INST_INTR
+			info.intr_reason = dev->interrupt_reason_ve2[intr_inst_index];
+			atomic_set(&s_interrupt_flag_ve2[intr_inst_index], 0);
+			dev->interrupt_reason_ve2[intr_inst_index] = 0;
+#else
+			atomic_set(&s_interrupt_flag_ve2, 0);
+			info.intr_reason = dev->interrupt_reason_ve2;
+			dev->interrupt_reason_ve2 = 0;
+#endif
+			spin_unlock_irqrestore(&s_ve2_lock, flags);
+		}
+
+		ret = copy_to_user((void __user *)arg, &info, sizeof(vpudrv_intr_info_t));
+		DPRINTK("[VPUDRV][-]VDI_IOCTL_WAIT_INTERRUPT, info.intr_reason[%d]:0x%x\n", intr_inst_index, info.intr_reason);
+		if (ret != 0)
+			return -EFAULT;
+	}
+	break;
+	case VDI_IOCTL_SET_CLOCK_GATE:
+	{
+		u32 clkgate;
+
+		//DPRINTK("[VPUDRV][+]VDI_IOCTL_SET_CLOCK_GATE\n");
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+#ifdef VPU_SUPPORT_CLOCK_CONTROL
+		if (clkgate)
+			vpu_clk_enable(s_vpu_clk);
+		else
+			vpu_clk_disable(s_vpu_clk);
+#endif /* VPU_SUPPORT_CLOCK_CONTROL */
+		//DPRINTK("[VPUDRV][-]VDI_IOCTL_SET_CLOCK_GATE\n");
+	}
+	break;
+	case VDI_IOCTL_GET_INSTANCE_POOL:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_INSTANCE_POOL\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			if (s_instance_pool.base != 0) {
+				ret = copy_to_user((void __user *)arg, &s_instance_pool, sizeof(vpudrv_buffer_t));
+				if (ret != 0)
+					ret = -EFAULT;
+			} else {
+				ret = copy_from_user(&s_instance_pool, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+				if (ret == 0) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+					s_instance_pool.size = PAGE_ALIGN(s_instance_pool.size);
+					s_instance_pool.base = (unsigned long)vmalloc(s_instance_pool.size);
+					s_instance_pool.phys_addr = s_instance_pool.base;
+
+					if (s_instance_pool.base != 0)
+#else
+					if (vpu_alloc_dma_buffer2(&s_instance_pool) != -1)
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+					{
+						memset((void *)s_instance_pool.base, 0x0, s_instance_pool.size); /*clearing memory*/
+						ret = copy_to_user((void __user *)arg, &s_instance_pool, sizeof(vpudrv_buffer_t));
+						if (ret == 0) {
+							/* success to get memory for instance pool */
+							up(&s_vpu_sem);
+							break;
+						}
+					}
+
+				}
+				ret = -EFAULT;
+			}
+
+			up(&s_vpu_sem);
+		}
+
+		DPRINTK("%s [-]VDI_IOCTL_GET_INSTANCE_POOL\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_GET_COMMON_MEMORY:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_COMMON_MEMORY\n", DEV_NAME);
+		if (s_common_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_common_memory, sizeof(vpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = copy_from_user(&s_common_memory, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret == 0) {
+				if (vpu_alloc_dma_buffer(&s_common_memory) != -1) {
+					ret = copy_to_user((void __user *)arg, &s_common_memory, sizeof(vpudrv_buffer_t));
+					if (ret == 0) {
+						/* success to get memory for common memory */
+						break;
+					}
+				}
+			}
+
+			ret = -EFAULT;
+		}
+		DPRINTK("%s [-]VDI_IOCTL_GET_COMMON_MEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_OPEN_INSTANCE:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+
+		vil = kzalloc(sizeof(*vil), GFP_KERNEL);
+		if (!vil)
+			return -ENOMEM;
+
+		if (copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t))) {
+			kfree(vil);
+			return -EFAULT;
+		}
+
+		vil->inst_idx = inst_info.inst_idx;
+		vil->core_idx = inst_info.core_idx;
+		vil->filp = filp;
+
+		spin_lock(&s_vpu_lock);
+		list_add(&vil->list, &s_inst_list_head);
+
+		inst_info.inst_open_count = 0; /* counting the current open instance number */
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		s_vpu_open_ref_count++; /* flag just for that vpu is in opened or closed */
+
+		if (copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t))) {
+			kfree(vil);
+			return -EFAULT;
+		}
+
+		DPRINTK("%s VDI_IOCTL_OPEN_INSTANCE core_idx=%d, inst_idx=%d, s_vpu_open_ref_count=%d, inst_open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, s_vpu_open_ref_count, inst_info.inst_open_count);
+	}
+	break;
+	case VDI_IOCTL_CLOSE_INSTANCE:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+
+		DPRINTK("%s [+]VDI_IOCTL_CLOSE_INSTANCE\n", DEV_NAME);
+		if (copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t)))
+			return -EFAULT;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->inst_idx == inst_info.inst_idx && vil->core_idx == inst_info.core_idx) {
+				list_del(&vil->list);
+				kfree(vil);
+				break;
+			}
+		}
+
+		inst_info.inst_open_count = 0; /* counting the current open instance number */
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+#ifdef SUPPORT_MULTI_INST_INTR
+		if(inst_info.core_idx == 1)
+			kfifo_reset(&s_interrupt_pending_q_ve2[inst_info.inst_idx]);
+#endif
+		spin_unlock(&s_vpu_lock);
+
+		s_vpu_open_ref_count--; /* flag just for that vpu is in opened or closed */
+
+		if (copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t)))
+			return -EFAULT;
+
+		DPRINTK("%s VDI_IOCTL_CLOSE_INSTANCE core_idx=%d, inst_idx=%d, s_vpu_open_ref_count=%d, inst_open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, s_vpu_open_ref_count, inst_info.inst_open_count);
+	}
+	break;
+	case VDI_IOCTL_GET_INSTANCE_NUM:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+		DPRINTK("%s [+]VDI_IOCTL_GET_INSTANCE_NUM\n", DEV_NAME);
+
+		ret = copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t));
+		if (ret != 0)
+			break;
+
+		inst_info.inst_open_count = 0;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		ret = copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t));
+
+		DPRINTK("%s VDI_IOCTL_GET_INSTANCE_NUM core_idx=%d, inst_idx=%d, open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, inst_info.inst_open_count);
+
+	}
+	break;
+	case VDI_IOCTL_RESET:
+	{
+		u32 coreIdx;
+		if (get_user(coreIdx, (u32 __user *) arg))
+			return -EFAULT;
+		vpu_hw_reset(coreIdx);
+	}
+	break;
+	case VDI_IOCTL_GET_REGISTER_INFO:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_REGISTER_INFO\n", DEV_NAME);
+		ret = copy_to_user((void __user *)arg, &s_vpu_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		DPRINTK("%s [-]VDI_IOCTL_GET_REGISTER_INFO s_vpu_register.phys_addr=0x%lx, s_vpu_register.virt_addr=0x%lx, s_vpu_register.size=%d\n", DEV_NAME, s_vpu_register.phys_addr, s_vpu_register.virt_addr, s_vpu_register.size);
+	}
+	break;
+	/* RTK ioctl */
+	case VDI_IOCTL_SET_RTK_CLK_GATING:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+#ifdef CONFIG_POWER_CONTROL
+		struct power_control *pctrl;
+#endif
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_GATING\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		/* VE1 */
+		if (clockInfo.core_idx == 0) {
+			s_vpu_clk = s_vpu_clk_ve1;
+#ifdef CONFIG_POWER_CONTROL
+			pctrl = s_pctrl_ve1;
+#endif
+		} else {/* VE2 */
+			s_vpu_clk = s_vpu_clk_ve2;
+#ifdef CONFIG_POWER_CONTROL
+			pctrl = s_pctrl_ve2;
+#endif
+		}
+
+		if (clockInfo.enable == 1) {
+#ifdef CONFIG_POWER_CONTROL
+			pr_info("%s before pctrl_on for laterncy watching!!\n", DEV_NAME);
+			vpu_pctrl_on(pctrl);
+			pr_info("%s after pctrl_on for laterncy watching!!\n", DEV_NAME);
+#endif
+			vpu_clk_enable(s_vpu_clk);
+#ifdef CONFIG_ARCH_RTD139x
+			if (s_vpu_clk == s_vpu_clk_ve2)
+				vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+			ve1_wrapper_setup((1 << clockInfo.core_idx));
+		} else {
+			vpu_clk_disable(s_vpu_clk);
+#ifdef CONFIG_POWER_CONTROL
+			vpu_pctrl_off(pctrl);
+#endif
+		}
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_GATING clockInfo.core_idx:%d, clockInfo.enable:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.enable);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_CLK_PLL:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_PLL\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		s_vpu_clk = clockInfo.core_idx == 0 ? s_vpu_clk_ve1 : s_vpu_clk_ve2;
+		if (vpu_clk_pll_set_rate(s_vpu_clk, clockInfo.value))
+			break;
+			ve1_wrapper_setup((1 << clockInfo.core_idx));
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_PLL clockInfo.core_idx:%d, clockInfo.value:0x%x\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_CLK_PLL:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+
+		DPRINTK("%s [+]VDI_IOCTL_GET_RTK_CLK_PLL\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		/* VE1 */
+		if (clockInfo.core_idx == 0) {
+			s_vpu_clk = s_vpu_clk_ve1;
+		} else { /* VE2 */
+			s_vpu_clk = s_vpu_clk_ve2;
+		}
+		clockInfo.value = (unsigned int)clk_get_rate(s_vpu_clk);
+		ret = copy_to_user((vpu_clock_info_t *)arg, &clockInfo, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_GET_RTK_CLK_PLL clockInfo.core_idx:%d, clockInfo.value:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_CLK_SELECT:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+		struct clk *s_pclk = NULL;
+
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_SELECT\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		s_vpu_clk = clockInfo.core_idx == 0 ? s_vpu_clk_ve1 : s_vpu_clk_ve2;
+		switch(clockInfo.value)
+		{
+			case VE_PLL_SYSH:
+				s_pclk = s_vpu_clk_sysh;
+				break;
+			case VE_PLL_VE1:
+				s_pclk = s_vpu_pll_ve1;
+				break;
+			case VE_PLL_VE2:
+				s_pclk = s_vpu_pll_ve2;
+				break;
+			default:
+				pr_warn("%s  %s %d, wrong value:0x%x\n", DEV_NAME, __func__, __LINE__, clockInfo.value);
+				break;
+		}
+		if (s_pclk != NULL)
+			clk_set_parent(s_vpu_clk, s_pclk);
+
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_SELECT clockInfo.core_idx:%d, clockInfo.value:0x%x\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_CLK_SELECT:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+		struct clk *s_pclk;
+		DPRINTK("%s [+]VDI_IOCTL_GET_RTK_CLK_SELECT\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		s_vpu_clk = clockInfo.core_idx == 0 ? s_vpu_clk_ve1 : s_vpu_clk_ve2;
+		s_pclk = clk_get_parent(s_vpu_clk);
+		if (clk_is_match(s_pclk, s_vpu_clk_sysh))
+		{
+			clockInfo.value = (unsigned int)VE_PLL_SYSH;
+		}
+		else if (clk_is_match(s_pclk, s_vpu_pll_ve1))
+		{
+			clockInfo.value = (unsigned int)VE_PLL_VE1;
+		}
+		else if (clk_is_match(s_pclk, s_vpu_pll_ve2))
+		{
+			clockInfo.value = (unsigned int)VE_PLL_VE2;
+		}
+
+		ret = copy_to_user((vpu_clock_info_t *)arg, &clockInfo, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_GET_RTK_CLK_SELECT clockInfo.core_idx:%d, clockInfo.value:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_SUPPORT_TYPE:
+	{
+		ret = copy_to_user((void __user *)arg, &s_bond_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_DCSYS_INFO:
+	{
+		ret = copy_to_user((void __user *)arg, &s_dc_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_ASIC_REVISION:
+	{
+		__put_user(get_rtd129x_cpu_revision()|get_rtd129x_cpu_id(), (unsigned int *) arg);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_DOVI_FLAG:
+	{
+		vpudrv_dovi_info_t doviInfo;
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_DOVI_FLAG\n", DEV_NAME);
+		ret = copy_from_user(&doviInfo, (vpudrv_dovi_info_t *)arg, sizeof(vpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+
+		doviInfo.enable = pu_set_dovi_flag(doviInfo.core_idx, doviInfo.inst_idx, doviInfo.enable);
+
+		ret = copy_to_user((vpudrv_dovi_info_t *)arg, &doviInfo, sizeof(vpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_DOVI_FLAG doviInfo.core_idx:%d, doviInfo.inst_idx:%d, doviInfo.value:%d\n", DEV_NAME, doviInfo.core_idx, doviInfo.inst_idx, doviInfo.enable);
+	}
+	break;
+	case VDI_IOCTL_GET_TOTAL_INSTANCE_NUM:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+		DPRINTK("%s [+]VDI_IOCTL_GET_TOTAL_INSTANCE_NUM\n", DEV_NAME);
+
+		ret = copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t));
+		if (ret != 0)
+			break;
+
+		inst_info.inst_open_count = 0;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		ret = copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t));
+
+		DPRINTK("%s VDI_IOCTL_GET_TOTAL_INSTANCE_NUM core_idx=%d, inst_idx=%d, open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, inst_info.inst_open_count);
+
+	}
+	break;
+	default:
+	{
+		pr_err("%s No such IOCTL, cmd is %d\n", DEV_NAME, cmd);
+	}
+	break;
+	}
+
+	return ret;
+}
+
+static ssize_t vpu_read(struct file *filp, char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static int compat_get_vpu_bit_firmware_info_data(
+	compat_vpu_bit_firmware_info_t __user *data32,
+	vpu_bit_firmware_info_t __user *data)
+{
+#if defined(CONFIG_CPU_V7)
+	//u32 s;
+	u32 c;
+	u32 r;
+	u32 b[512];
+#else
+	//compat_uint_t s;
+	compat_uint_t c;
+	compat_ulong_t r;
+	compat_ushort_t b[512];
+#endif /* CONFIG_CPU_V7 */
+	int err;
+
+	//err = get_user(s, &data32->size);
+	//err |= put_user(s, &data->size);
+	data->size = sizeof(vpu_bit_firmware_info_t);
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(r, &data32->reg_base_offset);
+	err |= put_user(r, &data->reg_base_offset);
+	err |= copy_from_user(b, data32->bit_code, sizeof(b));
+	err |= copy_to_user(data->bit_code, b, sizeof(b));
+
+	return err;
+};
+
+static ssize_t vpu_write(struct file *filp, const char __user *buf, size_t len, loff_t *ppos)
+{
+
+	/* DPRINTK("[VPUDRV] vpu_write len=%d\n", (int)len); */
+	if (!buf) {
+		pr_err("%s vpu_write buf = NULL error \n", DEV_NAME);
+		return -EFAULT;
+	}
+
+	if (len == sizeof(vpu_bit_firmware_info_t) || len == sizeof(compat_vpu_bit_firmware_info_t))	{
+		vpu_bit_firmware_info_t *bit_firmware_info;
+
+		bit_firmware_info = kmalloc(sizeof(vpu_bit_firmware_info_t), GFP_KERNEL);
+		if (!bit_firmware_info) {
+			pr_err("%s vpu_write  bit_firmware_info allocation error\n", DEV_NAME);
+			return -EFAULT;
+		}
+
+		if (len == sizeof(vpu_bit_firmware_info_t)) {
+			if (copy_from_user(bit_firmware_info, buf, len)) {
+				pr_err("%s vpu_write copy_from_user error for bit_firmware_info\n", DEV_NAME);
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+		}
+#ifdef CONFIG_COMPAT
+		 else {
+			int err;
+			compat_vpu_bit_firmware_info_t __user *data32;
+			vpu_bit_firmware_info_t __user *data;
+
+			data32 = (compat_vpu_bit_firmware_info_t __user *) buf;
+			data = compat_alloc_user_space(sizeof(*data));
+			if (data == NULL) {
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+
+			err = compat_get_vpu_bit_firmware_info_data(data32, data);
+			if (err) {
+				kfree(bit_firmware_info);
+				return err;
+			}
+
+			if (copy_from_user(bit_firmware_info, data, sizeof(vpu_bit_firmware_info_t))) {
+				pr_err("%s vpu_write copy_from_user error for bit_firmware_info\n", DEV_NAME);
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+		}
+#endif /* CONFIG_COMPAT */
+
+		if (bit_firmware_info->size == sizeof(vpu_bit_firmware_info_t)) {
+			DPRINTK("%s vpu_write set bit_firmware_info coreIdx=0x%x, reg_base_offset=0x%x size=0x%x, bit_code[0]=0x%x\n",
+					DEV_NAME, bit_firmware_info->core_idx, (int)bit_firmware_info->reg_base_offset, bit_firmware_info->size, bit_firmware_info->bit_code[0]);
+
+			if (bit_firmware_info->core_idx > MAX_NUM_VPU_CORE) {
+				pr_err("%s vpu_write coreIdx[%d] is exceeded than MAX_NUM_VPU_CORE[%d]\n", DEV_NAME, bit_firmware_info->core_idx, MAX_NUM_VPU_CORE);
+				kfree(bit_firmware_info);
+				return -ENODEV;
+			}
+
+			memcpy((void *)&s_bit_firmware_info[bit_firmware_info->core_idx], bit_firmware_info, sizeof(vpu_bit_firmware_info_t));
+			kfree(bit_firmware_info);
+
+			return len;
+		}
+
+		kfree(bit_firmware_info);
+	}
+
+	return -1;
+}
+
+static int vpu_release(struct inode *inode, struct file *filp)
+{
+	int ret = 0;
+	DPRINTK("%s vpu_release\n", DEV_NAME);
+
+	ret = down_interruptible(&s_vpu_sem);
+	if (ret == 0) {
+		/* found and free the not handled buffer by user applications */
+		vpu_free_buffers(filp);
+		/* found and free the not closed instance by user applications */
+		vpu_free_instances(filp);
+		s_vpu_drv_context.open_count--;
+		if (s_vpu_drv_context.open_count == 0) {
+			if (s_instance_pool.base) {
+				DPRINTK("%s free instance pool\n", DEV_NAME);
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+				vfree((const void *)s_instance_pool.base);
+#else
+				pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+				vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+				s_instance_pool.base = 0;
+			}
+#if 0 /* Fuchun 20150909, we must not free instance pool and common memory */
+			if (s_common_memory.base) {
+				DPRINTK("%s free common memory\n", DEV_NAME);
+				vpu_free_dma_buffer(&s_common_memory);
+				s_common_memory.base = 0;
+			}
+#endif
+		}
+	}
+	up(&s_vpu_sem);
+
+	return 0;
+}
+
+static int vpu_fasync(int fd, struct file *filp, int mode)
+{
+	struct vpu_drv_context_t *dev = (struct vpu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+static int vpu_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	pfn = vm->vm_pgoff;
+
+	return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int vpu_map_to_physical_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+	return pu_mmap_dma_buffer(vm);
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif /* CONFIG_RTK_RESERVE_MEMORY */
+}
+
+static int vpu_map_to_instance_pool_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	int ret;
+	long length = vm->vm_end - vm->vm_start;
+	unsigned long start = vm->vm_start;
+	char *vmalloc_area_ptr = (char *)s_instance_pool.base;
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_RESERVED;
+
+	/* loop over all pages, map it page individually */
+	while (length > 0) {
+		pfn = vmalloc_to_pfn(vmalloc_area_ptr);
+		ret = remap_pfn_range(vm, start, pfn, PAGE_SIZE, PAGE_SHARED);
+		if (ret < 0) {
+			return ret;
+		}
+		start += PAGE_SIZE;
+		vmalloc_area_ptr += PAGE_SIZE;
+		length -= PAGE_SIZE;
+	}
+
+	return 0;
+#else
+	vm->vm_flags |= VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+}
+
+/*!
+ * @brief memory map interface for vpu file operation
+ * @return  0 on success or negative error code on error
+ */
+static int vpu_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	if (vm->vm_pgoff == 0)
+		return vpu_map_to_instance_pool_memory(fp, vm);
+
+	if ((vm->vm_pgoff == (s_vpu_register.phys_addr>>PAGE_SHIFT))
+	|| (vm->vm_pgoff == (s_bond_register.phys_addr>>PAGE_SHIFT))
+	|| (vm->vm_pgoff == (s_dc_register.phys_addr>>PAGE_SHIFT)))
+		return vpu_map_to_register(fp, vm);
+
+	return vpu_map_to_physical_memory(fp, vm);
+#else
+	if (vm->vm_pgoff) {
+		if (vm->vm_pgoff == (s_instance_pool.phys_addr>>PAGE_SHIFT))
+			return vpu_map_to_instance_pool_memory(fp, vm);
+
+		return vpu_map_to_physical_memory(fp, vm);
+	} else {
+		return vpu_map_to_register(fp, vm);
+	}
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+}
+
+struct file_operations vpu_fops = {
+	.owner = THIS_MODULE,
+	.open = vpu_open,
+	.read = vpu_read,
+	.write = vpu_write,
+	/*.ioctl = vpu_ioctl, // for kernel 2.6.9*/
+	.unlocked_ioctl = vpu_ioctl,
+	.compat_ioctl = compat_vpu_ioctl,
+	.release = vpu_release,
+	.fasync = vpu_fasync,
+	.mmap = vpu_mmap,
+};
+
+
+static int vpu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+	u32 bonding_value;
+	unsigned long virt_addr;
+	struct resource res;
+	void __iomem *iobase;
+	int irq;
+	struct device_node *node = pdev->dev.of_node;
+#if 0 //Fuchun disable 20160204, set clock gating by vdi.c
+	unsigned int val = 0;
+#endif
+
+	pr_info("%s vpu_probe\n", DEV_NAME);
+
+	of_address_to_resource(node, 0, &res);
+	iobase = of_iomap(node, 0);
+
+	s_vpu_register.phys_addr = res.start;
+	s_vpu_register.virt_addr = (unsigned long)iobase;
+	s_vpu_register.size = res.end - res.start + 1;
+
+	pr_info("%s vpu base address get from DTB physical base addr=0x%lx, virtual base=0x%lx, size=0x%x\n", DEV_NAME, s_vpu_register.phys_addr, s_vpu_register.virt_addr, s_vpu_register.size);
+
+	of_address_to_resource(node, 1, &res);
+	iobase = of_iomap(node, 1);
+
+	s_dc_register.phys_addr = res.start;
+	s_dc_register.virt_addr = (unsigned long)iobase;
+	s_dc_register.size = res.end - res.start + 1;
+
+	s_vpu_dev.minor = MISC_VE1_MINOR;
+	s_vpu_dev.name = VPU_DEV_NAME;
+	s_vpu_dev.fops = &vpu_fops;
+	s_vpu_dev.parent = NULL;
+	if (misc_register(&s_vpu_dev)) {
+		pr_err("%s failed to register misc device.", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	of_address_to_resource(node, 2, &res);
+	iobase = of_iomap(node, 2);
+
+	s_bond_register.phys_addr = res.start;
+	s_bond_register.virt_addr = (unsigned long)iobase;
+	s_bond_register.size = res.end - res.start + 1;
+
+	virt_addr = (unsigned long)iobase;
+	bonding_value = __raw_readl((volatile u8 *)virt_addr);
+
+	pr_info("%s res.start:0x%llx, bonding_value:0x%x\n", DEV_NAME, res.start, bonding_value);
+
+	s_vpu_clk_ve1 = vpu_clk_get(&pdev->dev, 0);
+	s_vpu_clk_ve2 = vpu_clk_get(&pdev->dev, 1);
+#ifdef CONFIG_ARCH_RTD139x
+	s_vpu_clk_ve2_bpu = clk_get(&pdev->dev, "clk_ve2_bpu");
+#endif /* CONFIG_ARCH_RTD139x */
+	s_vpu_clk_sysh = clk_get(&pdev->dev, "clk_sysh");
+	s_vpu_pll_ve1 = clk_get(&pdev->dev, "pll_ve1");
+	s_vpu_pll_ve2 = clk_get(&pdev->dev, "pll_ve2");
+
+#ifdef CONFIG_POWER_CONTROL
+	s_pctrl_ve1 = vpu_pctrl_get(0);
+	s_pctrl_ve2 = vpu_pctrl_get(1);
+#endif
+
+	p_vpu_dev = &pdev->dev;
+
+#ifdef VPU_SUPPORT_CLOCK_CONTROL
+	vpu_clk_enable(s_vpu_clk_ve1);
+	vpu_clk_enable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+#endif
+
+	irq = irq_of_parse_and_map(node, 0);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_ve1_irq = irq;
+	pr_info("%s s_ve1_irq:%d want to register ve1_irq_handler\n", DEV_NAME, s_ve1_irq);
+	err = request_irq(s_ve1_irq, ve1_irq_handler, 0, "VE1_CODEC_IRQ", (void *)(&s_vpu_drv_context));
+	err = 0;
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_ve1_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_ve1_irq <%d> busy, change your config\n", DEV_NAME, s_ve1_irq);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	irq = irq_of_parse_and_map(node, 1);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_ve2_irq = irq;
+	pr_info("%s s_ve2_irq:%d want to register ve2_irq_handler\n", DEV_NAME, s_ve2_irq);
+	err = request_irq(s_ve2_irq, ve2_irq_handler, 0, "VE2_CODEC_IRQ", (void *)(&s_vpu_drv_context));
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_ve2_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_ve2_irq <%d> busy, change your config\n", DEV_NAME, s_ve2_irq);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	s_video_memory.size = VPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+	s_video_memory.phys_addr = VPU_DRAM_PHYSICAL_BASE;
+	s_video_memory.base = (unsigned long)ioremap_nocache(s_video_memory.phys_addr, PAGE_ALIGN(s_video_memory.size));
+	if (!s_video_memory.base) {
+		pr_err("%s fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", DEV_NAME, (int)s_video_memory.phys_addr, (int)s_video_memory.base, (int)s_video_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (vmem_init(&s_vmem, s_video_memory.phys_addr, s_video_memory.size) < 0) {
+		pr_err("%s fail to init vmem system\n", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+	pr_info("%s success to probe vpu device with reserved video memory phys_addr=0x%x, base = 0x%x\n", DEV_NAME, (int) s_video_memory.phys_addr, (int)s_video_memory.base);
+#else
+	pr_info("%s success to probe vpu device with non reserved video memory\n", DEV_NAME);
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+#ifndef CONFIG_RTK_PLATFORM_FPGA
+	/* RESET disable */
+	rstc_ve1 = reset_control_get(&pdev->dev, "ve1");
+	rstc_ve2 = reset_control_get(&pdev->dev, "ve2");
+
+	reset_control_deassert(rstc_ve1);
+	reset_control_deassert(rstc_ve2);
+#endif /* CONFIG_RTK_PLATFORM_FPGA */
+
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_on(s_pctrl_ve1);
+	vpu_pctrl_on(s_pctrl_ve2);
+	vpu_pctrl_off(s_pctrl_ve1);
+	vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+
+#if 0 /* Fuchun disable 20160204, set clock gating by vdi.c */
+	val = ReadVpuRegister(VE_CTRL_REG, 0);
+	val |= (ve_cti_en << 1 | ve_idle_en << 6);
+	WriteVpuRegister(VE_CTRL_REG, val, 0);
+
+	pr_info("%s VE1_CTRL_REG = 0x%08x (0x%08x)\n", DEV_NAME, val, ReadVpuRegister(VE_CTRL_REG, 0));
+
+	val = ReadVpuRegister(W5_VE_CTRL_REG, 1);
+	val |= (ve_cti_en << 1 | ve_idle_en << 6);
+	WriteVpuRegister(W5_VE_CTRL_REG, val, 1);
+
+	pr_info("%s VE2_CTRL_REG = 0x%08x (0x%08x)\n", DEV_NAME, val, ReadVpuRegister(W5_VE_CTRL_REG, 1));
+#endif
+
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+	misc_deregister(&s_vpu_dev);
+
+	return err;
+}
+
+static int vpu_remove(struct platform_device *pdev)
+{
+	DPRINTK("%s vpu_remove\n", DEV_NAME);
+
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+		vpu_free_dma_buffer(&s_instance_pool);
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+		s_instance_pool.base = 0;
+	}
+
+	if (s_common_memory.base) {
+		vpu_free_dma_buffer(&s_common_memory);
+		s_common_memory.base = 0;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_video_memory.base) {
+		iounmap((void *)s_video_memory.base);
+		s_video_memory.base = 0;
+		vmem_exit(&s_vmem);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	misc_deregister(&s_vpu_dev);
+
+#ifdef VPU_SUPPORT_ISR
+	if (s_ve1_irq)
+		free_irq(s_ve1_irq, &s_vpu_drv_context);
+	if (s_ve2_irq)
+		free_irq(s_ve2_irq, &s_vpu_drv_context);
+#endif /* VPU_SUPPORT_ISR */
+
+
+	vpu_clk_put(s_vpu_clk_ve1);
+	vpu_clk_put(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_put(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+/* DO NOT CHANGE */
+#define WAVE5_STACK_SIZE (8*1024)
+#define W5_MAX_CODE_BUF_SIZE (512*1024)
+#define W5_CMD_INIT_VPU (0x0001)
+#define W5_CMD_SLEEP_VPU (0x0400)
+#define W5_CMD_WAKEUP_VPU (0x0800)
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+static void Wave5BitIssueCommand(u32 cmd)
+{
+	WriteVpuRegister(W5_VPU_BUSY_STATUS, 1, 1);
+	WriteVpuRegister(W5_CORE_INDEX,  0, 1);
+	/* coreIdx = ReadVpuRegister(W5_VPU_BUSY_STATUS, 1);*/
+	/* coreIdx = 0;*/
+	/* WriteVpuRegister(W5_INST_INDEX,  (instanceIndex&0xffff)|(codecMode<<16), 1);*/
+	WriteVpuRegister(W5_COMMAND, cmd, 1);
+	WriteVpuRegister(W5_VPU_HOST_INT_REQ, 1, 1);
+
+	return;
+}
+#endif /* DISABLE_ORIGIN_SUSPEND */
+
+static int vpu_suspend(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_on(s_pctrl_ve1);
+	vpu_pctrl_on(s_pctrl_ve2);
+#endif
+	vpu_clk_enable(s_vpu_clk_ve1);
+	vpu_clk_enable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+
+	/* RTK wrapper */
+	ve1_wrapper_setup((1 << 1) | 1);
+
+	if (s_vpu_open_ref_count > 0) {
+#ifdef DISABLE_ORIGIN_SUSPEND
+		vpudrv_instanace_list_t *vil, *n;
+		vpudrv_instance_pool_t *vip;
+		void *vip_base;
+		int instance_pool_size_per_core;
+		vpudrv_buffer_pool_t *pool, *nn;
+		vpudrv_buffer_t vb;
+		s_vpu_drv_context.open_count = 0;
+		s_vpu_open_ref_count = 0;
+
+		/* s_instance_pool.size  assigned to the size of all core once call VDI_IOCTL_GET_INSTANCE_POOL by user. */
+		instance_pool_size_per_core = (s_instance_pool.size/MAX_NUM_VPU_CORE);
+
+		wake_up_interruptible_all(&s_interrupt_wait_q_ve1);
+		atomic_set(&s_interrupt_flag_ve1, 0);
+
+#ifdef SUPPORT_MULTI_INST_INTR
+		{
+			int i;
+			for (i=0; i<MAX_NUM_INSTANCE; i++) {
+				wake_up_interruptible_all(&s_interrupt_wait_q_ve2[i]);
+				atomic_set(&s_interrupt_flag_ve2[i], 0);
+			}
+		}
+#else
+		atomic_set(&s_interrupt_flag_ve2, 0);
+#endif
+
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			vip_base = (void *)(s_instance_pool.base + (instance_pool_size_per_core*vil->core_idx));
+			vip = (vpudrv_instance_pool_t *)vip_base;
+			if (vip) {
+				/* only first 4 byte is key point(inUse of CodecInst in vpuapi) to free the corresponding instance. */
+				memset(&vip->codecInstPool[vil->inst_idx], 0x00, 4);
+			}
+			list_del(&vil->list);
+			kfree(vil);
+		}
+
+		list_for_each_entry_safe(pool, nn, &s_vbp_head, list) {
+			vb = pool->vb;
+			if (vb.base) {
+				vpu_free_dma_buffer(&vb);
+			}
+			list_del(&pool->list);
+			kfree(pool);
+		}
+
+		if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_instance_pool.base);
+#else
+			pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+			vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+			s_instance_pool.base = 0;
+		}
+#else /* else of DISABLE_ORIGIN_SUSPEND */
+		int i;
+		int core;
+		unsigned long timeout = jiffies + HZ; /* vpu wait timeout to 1sec */
+		int product_code = 0;
+
+		for (core = 0; core < MAX_NUM_VPU_CORE; core++) {
+			if (s_bit_firmware_info[core].size == 0)
+				continue;
+			product_code = ReadVpuRegister(VPU_PRODUCT_CODE_REGISTER, core);
+			if (PRODUCT_CODE_W_SERIES(product_code)) {
+				while (ReadVpuRegister(W5_VPU_BUSY_STATUS, core)) {
+					if (time_after(jiffies, timeout)) {
+						DPRINTK("%s SLEEP_VPU BUSY timeout", DEV_NAME);
+						goto DONE_SUSPEND;
+					}
+				}
+				Wave5BitIssueCommand(W5_CMD_SLEEP_VPU);
+
+				while (ReadVpuRegister(W5_VPU_BUSY_STATUS, core)) {
+					if (time_after(jiffies, timeout)) {
+						DPRINTK("%s SLEEP_VPU BUSY timeout", DEV_NAME);
+						goto DONE_SUSPEND;
+					}
+				}
+				if (ReadVpuRegister(W5_RET_SUCCESS, core) == 0) {
+					DPRINTK("%s SLEEP_VPU failed [0x%x]", DEV_NAME, ReadVpuRegister(W5_RET_FAIL_REASON, core));
+					goto DONE_SUSPEND;
+				}
+			} else {
+				while (ReadVpuRegister(BIT_BUSY_FLAG, core)) {
+					if (time_after(jiffies, timeout))
+						goto DONE_SUSPEND;
+				}
+
+				for (i = 0; i < 64; i++)
+					s_vpu_reg_store[core][i] = ReadVpuRegister(BIT_BASE+(0x100+(i * 4)), core);
+			}
+		}
+#endif /* end of DISABLE_ORIGIN_SUSPEND */
+	}
+
+	vpu_clk_disable(s_vpu_clk_ve1);
+	vpu_clk_disable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_disable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_off(s_pctrl_ve1);
+	vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+DONE_SUSPEND:
+#endif
+
+	vpu_clk_disable(s_vpu_clk_ve1);
+	vpu_clk_disable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_disable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_off(s_pctrl_ve1);
+	vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return -EAGAIN;
+}
+
+static int vpu_resume(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_on(s_pctrl_ve1);
+	vpu_pctrl_on(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+
+	vpu_clk_enable(s_vpu_clk_ve1);
+	vpu_clk_enable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+
+	//RTK wrapper
+	ve1_wrapper_setup((1 << 1) | 1);
+
+#ifdef DISABLE_ORIGIN_SUSPEND
+#else /* else of DISABLE_ORIGIN_SUSPEND */
+	int i;
+	int core;
+	int regVal;
+	int product_code = 0;
+	unsigned long timeout = jiffies + HZ; /* vpu wait timeout to 1sec */
+	unsigned long code_base;
+	unsigned long stack_base;
+	u32 val;
+	u32 code_size;
+	u32 stack_size;
+	u32 remap_size;
+	u32 hwOption  = 0;
+
+	for (core = 0; core < MAX_NUM_VPU_CORE; core++) {
+
+		if (s_bit_firmware_info[core].size == 0) {
+			continue;
+		}
+
+		product_code = ReadVpuRegister(VPU_PRODUCT_CODE_REGISTER, core);
+
+		if (PRODUCT_CODE_W_SERIES(product_code)) {
+
+			code_base = s_common_memory.phys_addr;
+			/* ALIGN TO 4KB */
+			code_size = (W5_MAX_CODE_BUF_SIZE&~0xfff);
+			if (code_size < s_bit_firmware_info[core].size*2) {
+				goto DONE_WAKEUP;
+			}
+			stack_base = code_base + code_size;
+			stack_size = WAVE5_STACK_SIZE;
+
+			/*---- LOAD BOOT CODE*/
+			//for (i = 0; i < 512; i++) {
+			//	val = s_bit_firmware_info[core].bit_code[i];
+			//	WriteVpu(code_base+(i*4), val);
+			//}
+
+			regVal = 0;
+			WriteVpuRegister(W5_PO_CONF, regVal, core);
+
+			/* Reset All blocks */
+			regVal = 0x7ffffff;
+			WriteVpuRegister(W5_RESET_REQ, regVal, core);	/*Reset All blocks*/
+
+			/* Waiting reset done */
+			while (ReadVpuRegister(W5_RESET_STATUS, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+			WriteVpuRegister(W5_RESET_REQ, 0, core);
+
+			/* remap page size */
+			remap_size = (code_size >> 12) & 0x1ff;
+			regVal = 0x80000000 | (W5_REMAP_CODE_INDEX<<12) | (0 << 16) | (1<<11) | remap_size;
+			WriteVpuRegister(W5_VPU_REMAP_CTRL,	 regVal, core);
+			WriteVpuRegister(W5_VPU_REMAP_VADDR,	0x00000000, core);	/* DO NOT CHANGE! */
+			WriteVpuRegister(W5_VPU_REMAP_PADDR,	code_base, core);
+			WriteVpuRegister(W5_ADDR_CODE_BASE,	 code_base, core);
+			WriteVpuRegister(W5_CODE_SIZE,		  code_size, core);
+			WriteVpuRegister(W5_CODE_PARAM,		 0, core);
+			WriteVpuRegister(W5_INIT_VPU_TIME_OUT_CNT,   timeout, core);
+
+			/* Stack */
+			WriteVpuRegister(W5_ADDR_STACK_BASE, stack_base, core);
+			WriteVpuRegister(W5_STACK_SIZE,	  stack_size, core);
+			WriteVpuRegister(W5_HW_OPTION, hwOption, core);
+
+			/* Interrupt */
+			regVal  = (1<<W5_INT_DEC_PIC_HDR);
+			regVal |= (1<<W5_INT_DEC_PIC);
+			regVal |= (1<<W5_INT_QUERY_DEC);
+			regVal |= (1<<W5_INT_SLEEP_VPU);
+			regVal |= (1<<W5_INT_BSBUF_EMPTY);
+
+			WriteVpuRegister(W5_VPU_INT_ENABLE,  regVal, core);
+
+			Wave5BitIssueCommand(W5_CMD_INIT_VPU);
+			WriteVpuRegister(W5_VPU_REMAP_PROC_START, 1, core);
+
+			while (ReadVpuRegister(W5_VPU_BUSY_STATUS, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+			if (ReadVpuRegister(W5_RET_SUCCESS, core) == 0) {
+				DPRINTK("%s WAKEUP_VPU failed [0x%x]", DEV_NAME, ReadVpuRegister(W5_RET_FAIL_REASON, core));
+				goto DONE_WAKEUP;
+			}
+		} else {
+
+			WriteVpuRegister(BIT_CODE_RUN, 0, core);
+
+			/*---- LOAD BOOT CODE*/
+			for (i = 0; i < 512; i++) {
+				val = s_bit_firmware_info[core].bit_code[i];
+				WriteVpuRegister(BIT_CODE_DOWN, ((i << 16) | val), core);
+			}
+
+			for (i = 0 ; i < 64 ; i++)
+				WriteVpuRegister(BIT_BASE+(0x100+(i * 4)), s_vpu_reg_store[core][i], core);
+
+			WriteVpuRegister(BIT_BUSY_FLAG, 1, core);
+			WriteVpuRegister(BIT_CODE_RESET, 1, core);
+			WriteVpuRegister(BIT_CODE_RUN, 1, core);
+
+			while (ReadVpuRegister(BIT_BUSY_FLAG, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+		}
+
+	}
+#endif /* end of DISABLE_ORIGIN_SUSPEND */
+
+	if (s_vpu_open_ref_count == 0) {
+		vpu_clk_disable(s_vpu_clk_ve1);
+		vpu_clk_disable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+		vpu_clk_disable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+#ifdef CONFIG_POWER_CONTROL
+		vpu_pctrl_off(s_pctrl_ve1);
+		vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+	}
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+DONE_WAKEUP:
+#endif /* DISABLE_ORIGIN_SUSPEND */
+
+	if (s_vpu_open_ref_count > 0) {
+		vpu_clk_enable(s_vpu_clk_ve1);
+		vpu_clk_enable(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+		vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+#ifdef CONFIG_POWER_CONTROL
+		vpu_pctrl_off(s_pctrl_ve1);
+		vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+	}
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+#else
+static int vpu_suspend(struct device *pdev);
+static int vpu_resume(struct device *pdev);
+#endif /* CONFIG_PM */
+
+static int __init vpu_init(void)
+{
+	int res = 0;
+
+#ifdef SUPPORT_MULTI_INST_INTR
+	int i;
+#endif
+	DPRINTK("%s begin vpu_init\n", DEV_NAME);
+#ifdef SUPPORT_MULTI_INST_INTR
+	for (i=0; i<MAX_NUM_INSTANCE; i++) {
+		init_waitqueue_head(&s_interrupt_wait_q_ve2[i]);
+	}
+
+	for (i=0; i<MAX_NUM_INSTANCE; i++) {
+#ifdef SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+#define MAX_INTERRUPT_QUEUE (16*MAX_NUM_INSTANCE)
+#else
+#define MAX_INTERRUPT_QUEUE 16
+#endif
+		res = kfifo_alloc(&s_interrupt_pending_q_ve2[i], MAX_INTERRUPT_QUEUE*sizeof(u32), GFP_KERNEL);
+		if (res) {
+			DPRINTK("%s kfifo_alloc failed 0x%x\n", DEV_NAME, res);
+		}
+	}
+#else
+	init_waitqueue_head(&s_interrupt_wait_q_ve2);
+#endif
+
+	init_waitqueue_head(&s_interrupt_wait_q_ve1);
+	s_common_memory.base = 0;
+	s_instance_pool.base = 0;
+
+	DPRINTK("%s end vpu_init result=0x%x\n", DEV_NAME, res);
+	return res;
+}
+
+static void __exit vpu_exit(void)
+{
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	DPRINTK("%s vpu_exit\n", DEV_NAME);
+#else
+
+	vpu_clk_put(s_vpu_clk_ve1);
+	vpu_clk_put(s_vpu_clk_ve2);
+#ifdef CONFIG_ARCH_RTD139x
+	vpu_clk_put(s_vpu_clk_ve2_bpu);
+#endif /* CONFIG_ARCH_RTD139x */
+
+	if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+		vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+		s_instance_pool.base = 0;
+	}
+
+	if (s_common_memory.base) {
+		vpu_free_dma_buffer(&s_common_memory);
+		s_common_memory.base = 0;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_video_memory.base) {
+		iounmap((void *)s_video_memory.base);
+		s_video_memory.base = 0;
+
+		vmem_exit(&s_vmem);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	misc_deregister(&s_vpu_dev);
+
+#ifdef VPU_SUPPORT_ISR
+	if (s_ve1_irq)
+		free_irq(s_ve1_irq, &s_vpu_drv_context);
+	if (s_ve2_irq)
+		free_irq(s_ve2_irq, &s_vpu_drv_context);
+#endif /* VPU_SUPPORT_ISR */
+
+#ifdef SUPPORT_MULTI_INST_INTR
+	{
+		int i;
+		for (i=0; i<MAX_NUM_INSTANCE; i++) {
+			kfifo_free(&s_interrupt_pending_q_ve2[i]);
+		}
+	}
+#endif
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+
+	return;
+}
+
+MODULE_AUTHOR("A customer using RTK VPU, Inc.");
+MODULE_DESCRIPTION("VPU linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(vpu_init);
+module_exit(vpu_exit);
+
+#ifdef CONFIG_POWER_CONTROL
+
+static int vpu_pcrtl_callback(struct notifier_block *nb,
+			      unsigned long action,
+			      void *p)
+{
+	struct power_control *pctrl = p;
+
+	if (action != POWER_CONTROL_ACTION_POST_POWER_ON)
+		return NOTIFY_DONE;
+
+	if (s_pctrl_ve1 == pctrl)
+		reset_control_reset(rstc_ve1);
+	if (s_pctrl_ve2 == pctrl)
+		reset_control_reset(rstc_ve2);
+	return NOTIFY_OK;
+}
+
+struct notifier_block vpu_pctrl_nb = {
+	.notifier_call = vpu_pcrtl_callback,
+};
+
+struct power_control *vpu_pctrl_get(u32 coreIdx)
+{
+	struct power_control *pctrl;
+
+	if (coreIdx == 0)
+		pctrl = power_control_get("pctrl_ve1");
+	else
+		pctrl = power_control_get("pctrl_ve2");
+
+	if (WARN_ON(IS_ERR_OR_NULL(pctrl)))
+		return NULL;
+	power_control_register_notifier(pctrl, &vpu_pctrl_nb);
+	return pctrl;
+}
+
+void vpu_pctrl_on(struct power_control *pctrl)
+{
+	if (!(pctrl == NULL || IS_ERR(pctrl))) {
+		DPRINTK("%s vpu_pctrl_on\n", DEV_NAME);
+		power_control_power_on(pctrl);
+		if (pctrl == s_pctrl_ve2)
+			power_control_power_on(s_pctrl_ve1);
+
+	}
+}
+
+void vpu_pctrl_off(struct power_control *pctrl)
+{
+	if (!(pctrl == NULL || IS_ERR(pctrl))) {
+		DPRINTK("%s vpu_pctrl_off\n", DEV_NAME);
+		power_control_power_off(pctrl);
+		if (pctrl == s_pctrl_ve2)
+			power_control_power_off(s_pctrl_ve1);
+	}
+}
+#endif /* CONFIG_POWER_CONTROL */
+
+static const struct of_device_id rtk_ve1_dt_match[] = {
+	{ .compatible = "Realtek,rtk1295-ve1" },
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtk_ve1_dt_match);
+
+const struct dev_pm_ops rtk_ve1_pmops = {
+	.suspend = vpu_suspend,
+	.resume = vpu_resume,
+};
+
+static struct platform_driver rtk_ve1_driver = {
+	.driver = {
+		.name = "rtk-ve1",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_ve1_dt_match,
+		.pm = &rtk_ve1_pmops,
+	},
+	.probe = vpu_probe,
+	.remove = vpu_remove,
+};
+
+module_platform_driver(rtk_ve1_driver);
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/ve1/ve1.h b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/ve1.h
new file mode 100755
index 00000000..f351f9d
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/ve1.h
@@ -0,0 +1,106 @@
+/**
+  ve1.c
+
+  linux device driver for VPU.
+
+ Copyright (C) 2006 - 2013  REALTEK INC.
+
+  This library is free software; you can redistribute it and/or modify it under
+  the terms of the GNU Lesser General Public License as published by the Free
+  Software Foundation; either version 2.1 of the License, or (at your option)
+  any later version.
+
+  This library is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+  details.
+
+  You should have received a copy of the GNU Lesser General Public License
+  along with this library; if not, write to the Free Software Foundation, Inc.,
+  51 Franklin St, Fifth Floor, Boston, MA
+  02110-1301  USA
+
+*/
+
+#ifndef __VPU_DRV_H__
+#define __VPU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+#define SUPPORT_MULTI_INST_INTR
+#define SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+#define USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+
+#define VDI_IOCTL_MAGIC 'V'
+#define VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(VDI_IOCTL_MAGIC, 0)
+#define VDI_IOCTL_FREE_PHYSICALMEMORY _IO(VDI_IOCTL_MAGIC, 1)
+#define VDI_IOCTL_WAIT_INTERRUPT _IO(VDI_IOCTL_MAGIC, 2)
+#define VDI_IOCTL_SET_CLOCK_GATE _IO(VDI_IOCTL_MAGIC, 3)
+#define VDI_IOCTL_RESET _IO(VDI_IOCTL_MAGIC, 4)
+#define VDI_IOCTL_GET_INSTANCE_POOL _IO(VDI_IOCTL_MAGIC, 5)
+#define VDI_IOCTL_GET_COMMON_MEMORY _IO(VDI_IOCTL_MAGIC, 6)
+#define VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(VDI_IOCTL_MAGIC, 8)
+#define VDI_IOCTL_OPEN_INSTANCE _IO(VDI_IOCTL_MAGIC, 9)
+#define VDI_IOCTL_CLOSE_INSTANCE _IO(VDI_IOCTL_MAGIC, 10)
+#define VDI_IOCTL_GET_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 11)
+#define VDI_IOCTL_GET_REGISTER_INFO _IO(VDI_IOCTL_MAGIC, 12)
+
+/* RTK ioctl */
+#define VDI_IOCTL_SET_RTK_CLK_GATING _IO(VDI_IOCTL_MAGIC, 16)
+#define VDI_IOCTL_SET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 17)
+#define VDI_IOCTL_GET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 18)
+#define VDI_IOCTL_GET_RTK_SUPPORT_TYPE _IO(VDI_IOCTL_MAGIC, 19)
+#define VDI_IOCTL_GET_RTK_ASIC_REVISION _IO(VDI_IOCTL_MAGIC, 20)
+#define VDI_IOCTL_SET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 21)
+#define VDI_IOCTL_GET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 22)
+#define VDI_IOCTL_SET_RTK_DOVI_FLAG _IO(VDI_IOCTL_MAGIC, 23)
+#define VDI_IOCTL_GET_TOTAL_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 24)
+#define VDI_IOCTL_GET_RTK_DCSYS_INFO _IO(VDI_IOCTL_MAGIC, 25)
+
+#define VE_PLL_SYSH	0x000
+#define VE_PLL_VE1	0x001
+#define VE_PLL_VE2	0x010
+
+typedef struct vpudrv_buffer_t {
+	unsigned int size;
+	unsigned long phys_addr;
+	unsigned long base; /* kernel logical address in use kernel */
+	unsigned long virt_addr; /* virtual user space address */
+	unsigned int mem_type; /* RTK, for protect memory */
+} vpudrv_buffer_t;
+
+typedef struct vpu_bit_firmware_info_t {
+	unsigned int size; /* size of this structure*/
+	unsigned int core_idx;
+	unsigned long reg_base_offset;
+	unsigned short bit_code[512];
+} vpu_bit_firmware_info_t;
+
+typedef struct vpu_clock_info_t{
+	unsigned int core_idx;
+	unsigned int enable;
+	unsigned int value;
+} vpu_clock_info_t;
+
+typedef struct vpudrv_inst_info_t {
+	unsigned int core_idx;
+	unsigned int inst_idx;
+	int inst_open_count; /* for output only*/
+} vpudrv_inst_info_t;
+
+typedef struct vpudrv_intr_info_t {
+	unsigned int core_idx;
+	unsigned int timeout;
+	int intr_reason;
+#ifdef SUPPORT_MULTI_INST_INTR
+	int intr_inst_index;
+#endif
+} vpudrv_intr_info_t;
+
+typedef struct vpudrv_dovi_info_t{
+	unsigned int core_idx;
+	unsigned int inst_idx;
+	unsigned int enable;
+} vpudrv_dovi_info_t;
+#endif
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/ve1/ve1config.h b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/ve1config.h
new file mode 100644
index 00000000..0ff610f
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/ve1config.h
@@ -0,0 +1,109 @@
+/* =========================================================================
+ *  This file is a part of VE1 Reference API project
+ * -----------------------------------------------------------------------------
+ *
+ * This confidential and proprietary software may be used only
+ * as authorized by a licensing agreement from Realtek Inc.
+ * In the event of publication, the following notice is applicable:
+ *
+ * (C) COPYRIGHT 2006 - 2011  REALTEK INC.
+ * ALL RIGHTS RESERVED
+ *
+ * The entire notice above must be reproduced on all authorized
+ * copies.
+ * This file should be modified by some customers according to their SOC configuration.
+ * =========================================================================
+ */
+
+#ifndef _VPU_CONFIG_H_
+#define _VPU_CONFIG_H_
+
+#define BODA7503_CODE 0x7503
+#define CODA7542_CODE 0x7542
+#define BODA950_CODE 0x9500
+#define CODA960_CODE 0x9600
+#define CODA980_CODE 0x9800
+#define WAVE320_CODE 0x3200
+#define WAVE410_CODE 0x4100 /* Wave410 version 1: Single vcore */
+#define WAVE4102_CODE 0x4102 /* Wave410 version 2: Multi vcore */
+#define WAVE420_CODE 0x4200 /* Wave420 */
+#define WAVE412_CODE 0x4120
+#define WAVE510_CODE                    0x5100
+#define WAVE512_CODE                    0x5120
+#define WAVE520_CODE                    0x5200
+
+#define PRODUCT_CODE_W_SERIES(x) (x == WAVE510_CODE || x == WAVE512_CODE || x == WAVE520_CODE)
+#define MAX_INST_HANDLE_SIZE (32*1024)
+#define MAX_NUM_INSTANCE 8
+#define MAX_NUM_VPU_CORE 2
+#define MAX_NUM_VCORE 1
+
+#define MAX_ENC_AVC_PIC_WIDTH 4096
+#define MAX_ENC_AVC_PIC_HEIGHT 2304
+#define MAX_ENC_PIC_WIDTH 4096
+#define MAX_ENC_PIC_HEIGHT 2304
+#define MIN_ENC_PIC_WIDTH 96
+#define MIN_ENC_PIC_HEIGHT 16
+
+/* for WAVE420 */
+#define W4_MIN_ENC_PIC_WIDTH 256
+#define W4_MIN_ENC_PIC_HEIGHT 128
+#define W4_MAX_ENC_PIC_WIDTH 8192
+#define W4_MAX_ENC_PIC_HEIGHT 8192
+
+#define MAX_DEC_PIC_WIDTH 4096
+#define MAX_DEC_PIC_HEIGHT 2304
+
+/* Application specific configuration */
+#define VPU_ENC_TIMEOUT 5000
+#define VPU_DEC_TIMEOUT 10000
+#define VPU_BUSY_CHECK_TIMEOUT 5000
+
+/* codec specific configuration */
+/* it can be set to 1 to handle reordering DPB in host side. */
+#define VPU_REORDER_ENABLE 1
+/*
+ * [default 1 for BW checking with RTKViedo Conformance] 0 (chroma separate mode), 1 (chroma interleave mode)
+ * if the type of tiledmap uses the kind of MB_RASTER_MAP. must set to enable CBCR_INTERLEAVE
+ */
+#define CBCR_INTERLEAVE 1
+#define VPU_ENABLE_BWB 1
+#define VPU_REPORT_USERDATA	 0
+
+#define HOST_ENDIAN  VDI_128BIT_LITTLE_ENDIAN
+#define VPU_FRAME_ENDIAN HOST_ENDIAN
+#define VPU_STREAM_ENDIAN HOST_ENDIAN
+#define VPU_USER_DATA_ENDIAN HOST_ENDIAN
+#define DRAM_BUS_WIDTH	 16
+
+/************************************************************************/
+/* VPU COMMON MEMORY */
+/************************************************************************/
+#define SIZE_COMMON (2*1024*1024)
+
+/*=====4. VPU REPORT MEMORY  ======================*/
+#define SIZE_REPORT_BUF (0x10000)
+
+#define STREAM_END_SIZE 0
+#define STREAM_END_SET_FLAG 0
+#define STREAM_END_CLEAR_FLAG -1
+
+#define USE_BIT_INTERNAL_BUF 1
+#define USE_IP_INTERNAL_BUF 1
+#define USE_DBKY_INTERNAL_BUF 1
+#define USE_DBKC_INTERNAL_BUF 1
+#define USE_OVL_INTERNAL_BUF 1
+#define USE_BTP_INTERNAL_BUF 1
+#define USE_ME_INTERNAL_BUF 1
+
+/* WAVE410 only */
+#define USE_BPU_INTERNAL_BUF 1
+#define USE_VCE_IP_INTERNAL_BUF 1
+#define USE_VCE_LF_ROW_INTERNAL_BUF 1
+
+/* WAVE420 only */
+#define USE_IMD_INTERNAL_BUF 1
+#define USE_RDO_INTERNAL_BUF 1
+#define USE_LF_INTERNAL_BUF 1
+
+#endif  /* _VPU_CONFIG_H_ */
diff --git a/drivers/soc/realtek/rtd139x/rtk_ve/ve1/vmm.h b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/vmm.h
new file mode 100644
index 00000000..5ad5792
--- /dev/null
+++ b/drivers/soc/realtek/rtd139x/rtk_ve/ve1/vmm.h
@@ -0,0 +1,634 @@
+/**
+  vmm.h
+
+  memory allocator for VE
+
+ Copyright (C) 2006 - 2013  REALTEK INC.
+
+  This library is free software; you can redistribute it and/or modify it under
+  the terms of the GNU Lesser General Public License as published by the Free
+  Software Foundation; either version 2.1 of the License, or (at your option)
+  any later version.
+
+  This library is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+  details.
+
+  You should have received a copy of the GNU Lesser General Public License
+  along with this library; if not, write to the Free Software Foundation, Inc.,
+  51 Franklin St, Fifth Floor, Boston, MA
+  02110-1301  USA
+
+*/
+
+#ifndef __RTK_VIDEO_MEMORY_MANAGEMENT_H__
+#define __RTK_VIDEO_MEMORY_MANAGEMENT_H__
+
+typedef struct _video_mm_info_struct {
+	unsigned long   total_pages;
+	unsigned long   alloc_pages;
+	unsigned long   free_pages;
+	unsigned long   page_size;
+} vmem_info_t;
+
+typedef unsigned long long  vmem_key_t;
+
+#define VMEM_PAGE_SIZE (16*1024)
+#define MAKE_KEY(_a, _b) (((vmem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key) (_key>>32)
+
+typedef struct page_struct {
+	int pageno;
+	unsigned long addr;
+	int used;
+	int alloc_pages;
+	int first_pageno;
+} page_t;
+
+typedef struct avl_node_struct {
+	vmem_key_t key;
+	int height;
+	page_t *page;
+	struct avl_node_struct *left;
+	struct avl_node_struct *right;
+} avl_node_t;
+
+typedef struct _video_mm_struct {
+	avl_node_t *free_tree;
+	avl_node_t *alloc_tree;
+	page_t *page_list;
+	int num_pages;
+	unsigned long base_addr;
+	unsigned long mem_size;
+	int free_page_count;
+	int  alloc_page_count;
+} video_mm_t;
+
+#define VMEM_P_ALLOC(_x) vmalloc(_x)
+#define VMEM_P_FREE(_x) vfree(_x)
+
+#define VMEM_ASSERT(_exp) if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/
+#define VMEM_HEIGHT(_tree) (_tree == NULL ? -1 : _tree->height)
+
+#define MAX(_a, _b) (_a >= _b ? _a : _b)
+
+typedef enum {
+	LEFT,
+	RIGHT
+} rotation_dir_t;
+
+typedef struct avl_node_data_struct {
+	int	 key;
+	page_t *page;
+} avl_node_data_t;
+
+static avl_node_t* make_avl_node( vmem_key_t key, page_t *page)
+{
+	avl_node_t *node = (avl_node_t *)VMEM_P_ALLOC(sizeof(avl_node_t));
+	node->key	 = key;
+	node->page	= page;
+	node->height  = 0;
+	node->left	= NULL;
+	node->right   = NULL;
+
+	return node;
+}
+
+static int get_balance_factor(avl_node_t *tree)
+{
+	int factor = 0;
+	if (tree) {
+		factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+	}
+
+	return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *	  A					  B
+ *	   \					/ \
+ *		B		 =>	   A   C
+ *	   /  \				 \
+ *	  D	C				 D
+ *
+ */
+static avl_node_t* rotation_left(avl_node_t *tree)
+{
+	avl_node_t *rchild;
+	avl_node_t *lchild;
+
+	if (tree == NULL)
+		return NULL;
+
+	rchild = tree->right;
+	if (rchild == NULL) {
+		return tree;
+	}
+
+	lchild = rchild->left;
+	rchild->left = tree;
+	tree->right = lchild;
+
+	tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+	rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+	return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *		 A				  B
+ *	   \				  /  \
+ *	  B		 =>	   D	A
+ *	/  \					 /
+ *   D	C				   C
+ *
+ */
+static avl_node_t *rotation_right(avl_node_t *tree)
+{
+	avl_node_t *rchild;
+	avl_node_t *lchild;
+
+	if (tree == NULL)
+		return NULL;
+
+	lchild = tree->left;
+	if (lchild == NULL)
+		return NULL;
+
+	rchild = lchild->right;
+	lchild->right = tree;
+	tree->left = rchild;
+
+	tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+	lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+	return lchild;
+}
+
+static avl_node_t *do_balance(avl_node_t *tree)
+{
+	int bfactor = 0, child_bfactor;	   /* balancing factor */
+
+	bfactor = get_balance_factor(tree);
+
+	if (bfactor >= 2) {
+		child_bfactor = get_balance_factor(tree->right);
+		if (child_bfactor == 1 || child_bfactor == 0) {
+			tree = rotation_left(tree);
+		} else if (child_bfactor == -1) {
+			tree->right = rotation_right(tree->right);
+			tree		= rotation_left(tree);
+		} else {
+			printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+			VMEM_ASSERT(0);
+			return NULL;
+		}
+	} else if (bfactor <= -2) {
+		child_bfactor = get_balance_factor(tree->left);
+		if (child_bfactor == -1 || child_bfactor == 0) {
+			tree = rotation_right(tree);
+		} else if (child_bfactor == 1) {
+			tree->left = rotation_left(tree->left);
+			tree	   = rotation_right(tree);
+		} else {
+			printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+			VMEM_ASSERT(0);
+			return NULL;
+		}
+	}
+
+	return tree;
+}
+
+static avl_node_t *unlink_end_node(avl_node_t *tree, int dir, avl_node_t **found_node)
+{
+	avl_node_t *node;
+	*found_node = NULL;
+
+	if (tree == NULL)
+		return NULL;
+
+	if (dir == LEFT) {
+		if (tree->left == NULL) {
+			*found_node = tree;
+			return NULL;
+		}
+	} else {
+		if (tree->right == NULL) {
+			*found_node = tree;
+			return NULL;
+		}
+	}
+
+	if (dir == LEFT) {
+		node = tree->left;
+		tree->left = unlink_end_node(tree->left, LEFT, found_node);
+		if (tree->left == NULL) {
+			tree->left = (*found_node)->right;
+			(*found_node)->left  = NULL;
+			(*found_node)->right = NULL;
+		}
+	} else {
+		node = tree->right;
+		tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+		if (tree->right == NULL) {
+			tree->right = (*found_node)->left;
+			(*found_node)->left  = NULL;
+			(*found_node)->right = NULL;
+		}
+	}
+
+	tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	return do_balance(tree);
+}
+
+
+static avl_node_t *avltree_insert(avl_node_t *tree, vmem_key_t key, page_t *page)
+{
+	if (tree == NULL) {
+		tree = make_avl_node(key, page);
+	} else {
+		if (key >= tree->key) {
+			tree->right = avltree_insert(tree->right, key, page);
+		} else {
+			tree->left  = avltree_insert(tree->left, key, page);
+		}
+	}
+
+	tree = do_balance(tree);
+
+	tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	return tree;
+}
+
+static avl_node_t *do_unlink(avl_node_t *tree)
+{
+	avl_node_t *node;
+	avl_node_t *end_node;
+
+	node = unlink_end_node(tree->right, LEFT, &end_node);
+	if (node) {
+		tree->right = node;
+	} else {
+		node = unlink_end_node(tree->left, RIGHT, &end_node);
+		if (node)
+			tree->left = node;
+	}
+
+	if (node == NULL) {
+		node = tree->right ? tree->right : tree->left;
+		end_node = node;
+	}
+
+	if (end_node) {
+		end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+		end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+		end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+	}
+
+	tree = end_node;
+
+	return tree;
+}
+
+static avl_node_t *avltree_remove(avl_node_t *tree, avl_node_t **found_node, vmem_key_t key)
+{
+	*found_node = NULL;
+	if (tree == NULL) {
+		printk(KERN_INFO "failed to find key %d\n", (int)key);
+		return NULL;
+	}
+
+	if (key == tree->key) {
+		*found_node = tree;
+		tree = do_unlink(tree);
+	} else if (key > tree->key) {
+		tree->right = avltree_remove(tree->right, found_node, key);
+	} else {
+		tree->left  = avltree_remove(tree->left, found_node, key);
+	}
+
+	if (tree)
+		tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	tree = do_balance(tree);
+
+	return tree;
+}
+
+void avltree_free(avl_node_t *tree)
+{
+	if (tree == NULL)
+		return;
+	if (tree->left == NULL && tree->right == NULL) {
+		VMEM_P_FREE(tree);
+		return;
+	}
+
+	avltree_free(tree->left);
+	tree->left = NULL;
+	avltree_free(tree->right);
+	tree->right = NULL;
+	VMEM_P_FREE(tree);
+}
+
+static avl_node_t *remove_approx_value(avl_node_t *tree, avl_node_t **found, vmem_key_t key)
+{
+	*found = NULL;
+	if (tree == NULL) {
+		return NULL;
+	}
+
+	if (key == tree->key) {
+		*found = tree;
+		tree = do_unlink(tree);
+	} else if (key > tree->key) {
+		tree->right = remove_approx_value(tree->right, found, key);
+	} else {
+		tree->left  = remove_approx_value(tree->left, found, key);
+		if (*found == NULL) {
+			*found = tree;
+			tree = do_unlink(tree);
+		}
+	}
+	if (tree)
+		tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	tree = do_balance(tree);
+
+	return tree;
+}
+
+static void set_blocks_free(video_mm_t *mm, int pageno, int npages)
+{
+	int last_pageno	 = pageno + npages - 1;
+	int i;
+	page_t *page;
+	page_t *last_page;
+
+	VMEM_ASSERT(npages);
+
+	if (last_pageno >= mm->num_pages) {
+		printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+		VMEM_ASSERT(0);
+		return;
+	}
+
+	for (i = pageno; i <= last_pageno; i++) {
+		mm->page_list[i].used		 = 0;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	page		= &mm->page_list[pageno];
+	page->alloc_pages = npages;
+	last_page   = &mm->page_list[last_pageno];
+	last_page->first_pageno = pageno;
+
+	mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void set_blocks_alloc(video_mm_t *mm, int pageno, int npages)
+{
+	int last_pageno	 = pageno + npages - 1;
+	int i;
+	page_t *page;
+	page_t *last_page;
+
+	if (last_pageno >= mm->num_pages) {
+		printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+		VMEM_ASSERT(0);
+		return;
+	}
+
+	for (i = pageno; i <= last_pageno; i++) {
+		mm->page_list[i].used		 = 1;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	page		= &mm->page_list[pageno];
+	page->alloc_pages = npages;
+
+	last_page   = &mm->page_list[last_pageno];
+	last_page->first_pageno = pageno;
+
+	mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int vmem_init(video_mm_t *mm, unsigned long addr, unsigned long size)
+{
+	int i;
+
+	if (NULL == mm)
+		return -1;
+
+	mm->base_addr  = (addr+(VMEM_PAGE_SIZE-1))&~(VMEM_PAGE_SIZE-1);
+	mm->mem_size   = size&~VMEM_PAGE_SIZE;
+	mm->num_pages  = mm->mem_size/VMEM_PAGE_SIZE;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = mm->num_pages;
+	mm->alloc_page_count = 0;
+	mm->page_list  = (page_t *)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+	if (mm->page_list == NULL) {
+		printk(KERN_ERR "%s:%d failed to kmalloc(%d)\n", __func__, __LINE__, mm->num_pages*sizeof(page_t));
+		return -1;
+	}
+
+	for (i = 0; i < mm->num_pages; i++) {
+		mm->page_list[i].pageno	   = i;
+		mm->page_list[i].addr		 = mm->base_addr + i * VMEM_PAGE_SIZE;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].used		 = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	set_blocks_free(mm, 0, mm->num_pages);
+
+	return 0;
+}
+
+int vmem_exit(video_mm_t *mm)
+{
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_exit: invalid handle\n");
+		return -1;
+	}
+
+	if (mm->free_tree) {
+		avltree_free(mm->free_tree);
+	}
+	if (mm->alloc_tree) {
+		avltree_free(mm->alloc_tree);
+	}
+
+	if (mm->page_list) {
+		VMEM_P_FREE(mm->page_list);
+		mm->page_list = NULL;
+	}
+
+	mm->base_addr  = 0;
+	mm->mem_size   = 0;
+	mm->num_pages  = 0;
+	mm->page_list  = NULL;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = 0;
+	mm->alloc_page_count = 0;
+	return 0;
+}
+
+unsigned long vmem_alloc(video_mm_t *mm, int size, unsigned long pid)
+{
+	avl_node_t *node;
+	page_t *free_page;
+	int		 npages, free_size;
+	int		 alloc_pageno;
+	unsigned long  ptr;
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_alloc: invalid handle\n");
+		return -1;
+	}
+
+	if (size <= 0)
+		return -1;
+
+	npages = (size + VMEM_PAGE_SIZE - 1)/VMEM_PAGE_SIZE;
+
+	mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+	if (node == NULL) {
+		return -1;
+	}
+	free_page = node->page;
+	free_size = KEY_TO_VALUE(node->key);
+
+	alloc_pageno = free_page->pageno;
+	set_blocks_alloc(mm, alloc_pageno, npages);
+	if (npages != free_size) {
+		int free_pageno = alloc_pageno + npages;
+		set_blocks_free(mm, free_pageno, (free_size-npages));
+	}
+
+	VMEM_P_FREE(node);
+
+	ptr = mm->page_list[alloc_pageno].addr;
+	mm->alloc_page_count += npages;
+	mm->free_page_count  -= npages;
+
+
+	return ptr;
+}
+
+int vmem_free(video_mm_t *mm, unsigned long ptr, unsigned long pid)
+{
+	unsigned long addr;
+	avl_node_t *found;
+	page_t *page;
+	int pageno, prev_free_pageno, next_free_pageno;
+	int prev_size, next_size;
+	int merge_page_no, merge_page_size, free_page_size;
+
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_free: invalid handle\n");
+		return -1;
+	}
+
+	addr = ptr;
+
+	mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+	if (found == NULL) {
+		printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+		VMEM_ASSERT(0);
+		return -1;
+	}
+
+	/* find previous free block */
+	page = found->page;
+	pageno = page->pageno;
+	free_page_size = page->alloc_pages;
+	prev_free_pageno = pageno-1;
+	prev_size = -1;
+	if (prev_free_pageno >= 0) {
+		if (mm->page_list[prev_free_pageno].used == 0) {
+			prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+			prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+		}
+	}
+
+	/* find next free block */
+	next_free_pageno = pageno + page->alloc_pages;
+	next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+	next_size = -1;
+	if (next_free_pageno >= 0) {
+		if (mm->page_list[next_free_pageno].used == 0) {
+			next_size = mm->page_list[next_free_pageno].alloc_pages;
+		}
+	}
+	VMEM_P_FREE(found);
+
+	/* merge */
+	merge_page_no = page->pageno;
+	merge_page_size = page->alloc_pages;
+	if (prev_size >= 0) {
+		mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+		if (found == NULL) {
+			VMEM_ASSERT(0);
+			return -1;
+		}
+		merge_page_no = found->page->pageno;
+		merge_page_size += found->page->alloc_pages;
+		VMEM_P_FREE(found);
+	}
+	if (next_size >= 0) {
+		mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+		if (found == NULL) {
+			VMEM_ASSERT(0);
+			return -1;
+		}
+		merge_page_size += found->page->alloc_pages;
+		VMEM_P_FREE(found);
+	}
+
+	page->alloc_pages  = 0;
+	page->first_pageno = -1;
+
+	set_blocks_free(mm, merge_page_no, merge_page_size);
+
+	mm->alloc_page_count -= free_page_size;
+	mm->free_page_count  += free_page_size;
+
+	return 0;
+}
+
+int vmem_get_info(video_mm_t *mm, vmem_info_t *info)
+{
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_get_info: invalid handle\n");
+		return -1;
+	}
+
+	if (info == NULL) {
+		return -1;
+	}
+
+	info->total_pages = mm->num_pages;
+	info->alloc_pages = mm->alloc_page_count;
+	info->free_pages  = mm->free_page_count;
+	info->page_size   = VMEM_PAGE_SIZE;
+
+	return 0;
+}
+
+#endif /* __RTK_VIDEO_MEMORY_MANAGEMENT_H__ */
diff --git a/drivers/soc/realtek/rtd13xx/Kconfig b/drivers/soc/realtek/rtd13xx/Kconfig
new file mode 100644
index 00000000..80192d3
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/Kconfig
@@ -0,0 +1,19 @@
+menu "RTD13xx General Setup"
+
+config RTK_PSCI_BOOT
+	bool "RTK PSCI boot method"
+	default n
+	help
+	  Using PSCI method to control slave CPU power.
+
+config RTK_MMIO_SECURE_RTD13XX_GENERIC_CRT
+	bool
+	select RTK_MMIO_SECURE
+
+endmenu #RTD13xx general setup
+
+menu "RTD13xx Device Drivers"
+
+source "drivers/soc/realtek/rtd13xx/rtk_ve/Kconfig"
+
+endmenu #RTD13xx Device Drivers
diff --git a/drivers/soc/realtek/rtd13xx/Makefile b/drivers/soc/realtek/rtd13xx/Makefile
new file mode 100644
index 00000000..2ed4c88
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/Makefile
@@ -0,0 +1,10 @@
+ifndef CONFIG_CPU_V7
+obj-$(CONFIG_ARCH_RTD13xx) += rtd13xx_spin_table.o rtd13xx_cpu_hotplug.o rtd13xx_cpu_wrapper.o
+endif
+
+obj-$(CONFIG_ARCH_RTD13xx) += rtk_chip.o
+obj-$(CONFIG_ARCH_RTD13xx) += rtk_usb.o
+obj-$(CONFIG_ARM_PSCI_FW) += rtd13xx_psci.o
+obj-$(CONFIG_SUSPEND) += rtd13xx_suspend.o rtd13xx_suspend_fs.o rtd13xx_suspend_mem.o
+obj-$(CONFIG_RTK_CODEC) += rtk_ve/
+obj-$(CONFIG_CPU_V7) += aarch32/
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd13xx/aarch32/Makefile b/drivers/soc/realtek/rtd13xx/aarch32/Makefile
new file mode 100644
index 00000000..79d9080
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/aarch32/Makefile
@@ -0,0 +1 @@
+obj-$(CONFIG_ARCH_RTD13xx) += rtd13xx_cpu_wrapper.o rtd13xx_cpu_hotplug.o
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd13xx/aarch32/rtd13xx_cpu_hotplug.S b/drivers/soc/realtek/rtd13xx/aarch32/rtd13xx_cpu_hotplug.S
new file mode 100644
index 00000000..6fc3b02
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/aarch32/rtd13xx_cpu_hotplug.S
@@ -0,0 +1,32 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/linkage.h>
+#include <asm/assembler.h>
+#include <asm/cp15.h>
+#include <asm/virt.h>
+
+ENTRY(__cpu_do_lowpower)
+	mov r1, #0
+	mcr p15, 0, r1, c12, c12, 7
+	//msr S3_0_C12_C12_7, r12
+	isb
+	mrc p15, 0, r1, c15, c2, 7
+	//mrs r12, S3_0_C15_C2_7
+	orr r1, r1, #0x1 /* send power down request*/
+	mcr p15, 0, r1, c15, c2, 7
+	//msr S3_0_C15_C2_7, r12
+	isb
+	dsb sy
+	wfi
+	ldr r3, [r0] //get entry address, if cpu do not power gating
+	mov pc, r3
+ENDPROC(__cpu_do_lowpower)
+
diff --git a/drivers/soc/realtek/rtd13xx/aarch32/rtd13xx_cpu_hotplug.h b/drivers/soc/realtek/rtd13xx/aarch32/rtd13xx_cpu_hotplug.h
new file mode 100644
index 00000000..79723aa
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/aarch32/rtd13xx_cpu_hotplug.h
@@ -0,0 +1,20 @@
+/*
+ * rtd13xx_cpu_hotplug.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef RTD13xx_CPU_HOTPLUG_H_
+#define RTD13xx_CPU_HOTPLUG_H_
+
+#include <asm/virt.h>
+
+void __cpu_do_lowpower(unsigned long secondary_entry_addr);
+
+#endif /* RTD13xx_CPU_HOTPLUG_H_ */
diff --git a/drivers/soc/realtek/rtd13xx/aarch32/rtd13xx_cpu_wrapper.c b/drivers/soc/realtek/rtd13xx/aarch32/rtd13xx_cpu_wrapper.c
new file mode 100644
index 00000000..b22cadd
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/aarch32/rtd13xx_cpu_wrapper.c
@@ -0,0 +1,339 @@
+/*
+ * rtd13xx_cpu_wrapper.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/delay.h>
+#include <linux/debugfs.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+
+#include <asm/io.h>
+#include <asm/cacheflush.h>
+#include <asm/cputype.h>
+#include <asm/io.h>
+#include <asm/smp_plat.h>
+
+#include <asm/system_misc.h>
+
+#include "../../common/include/debug.h"
+#include "rtd13xx_cpu_hotplug.h"
+
+#define DBG_INT 0x230
+#define DBG_ADDR 0x234
+#define DBG_ADDR_MODE 0x238
+
+static void __iomem *scpu_wrap_addr;
+
+void rtk_cpu_power_up(int cpu)
+{
+	u32 tmp = 0;
+	u32 flag1 = 0;
+	u32 flag2 = 0;
+	u32 cpu_offset = cpu * 4;
+
+	/* 1. Apply power to the PDCPU power domain.
+	 * Keep the state of the signals nCPUPORESET */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (0 + cpu);
+	tmp |= 1UL << (8 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	do {
+		tmp = readl(scpu_wrap_addr + 0x53C);
+		flag1 = !((tmp >> (0 + cpu)) & 0x1);
+		flag2 = !((tmp >> (8 + cpu)) & 0x1);
+		if (flag1 || flag2) {
+			pr_err("%s: CPU%d Power Mode Request is not ON\n",
+				__func__, cpu);
+			pr_err("%s: %x = %x\n", __func__,
+				(0x9801d000 + 0x53C), tmp);
+		}
+
+	} while( flag1 ||flag2 );
+
+	/* 2. Release the core output clamps. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (16 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* 3. SCP setup core P-Channel corresponding PSTATE Register
+	 * Request Power Mode to ON */
+	tmp = readl(scpu_wrap_addr + (0x540 + cpu_offset));
+	tmp &= 0x0000003F;
+	tmp |= 0x00000008;
+	writel(tmp, scpu_wrap_addr + (0x540 + cpu_offset));
+
+	/* 4. De-assert CPU cores resets. */
+	if (cpu < 4) {
+		tmp = readl(scpu_wrap_addr + 0x100);
+		tmp |= 1UL << (0 + cpu);
+		tmp |= 1UL << (4 + cpu);
+		writel(tmp, scpu_wrap_addr + 0x100);
+	} else {
+		tmp = readl(scpu_wrap_addr + 0x900);
+		tmp |= 1UL << (0 + (cpu - 4));
+		tmp |= 1UL << (4 + (cpu - 4));
+		writel(tmp, scpu_wrap_addr + 0x900);
+	}
+
+}
+EXPORT_SYMBOL(rtk_cpu_power_up);
+
+void rtk_cpu_power_down(int cpu)
+{
+	u32 tmp = 0;
+	u32 cpu_offset = cpu * 4;
+
+	/* SCP polling core corresponding P-Channel PACTIVE Register,
+	 * SC_CORE_PCHANNEL_STAT_ACK bit[10:0] is 0x0
+	 * (Power Mode Request is OFF)
+	 */
+	do {
+		tmp = readl(scpu_wrap_addr + (0x5C0 + cpu_offset));
+		tmp = tmp & 0x000007FF;
+		if (tmp != 0x00000000) {
+			pr_err("%s: CPU%d Power Mode Request is not OFF\n",
+				__func__, cpu);
+			pr_err("%s: %x = %d \n",
+				__func__, (0x9801d000 + 0x5C0 + cpu_offset),
+				tmp);
+		}
+	} while (tmp != 0x00000000);
+
+	/* SCP setup core P-Channel corresponding PSTATE Register,
+	 * Set SC_CORE_PCHANNEL_CTRL bit[5:0] as 0x0
+	 * (Request Power Mode to OFF)
+	 *
+	 * Set SC_CORE_PCHANNEL_CTRL bit[16] as 0x1
+	 * to assert P-Channel Request
+	 */
+	tmp = readl(scpu_wrap_addr + (0x540 + cpu_offset));
+	tmp &= 0xFFFFFFC0;
+	tmp |= 1UL << 16;
+	writel(tmp, scpu_wrap_addr + (0x540 + cpu_offset));
+
+	/* Wait P-Channel Request is Accepted:
+	 * Polling when SC_ CORE_PCHANNEL INT_STAT bit[8:0] is 0x1
+	 * (only paccept is asserted),
+	 * SC_CORE_PCHANNEL_STAT_ACK_TRIGGER bit[10:0] is 0x0
+	 * (Power Mode Request is OFF).
+	 */
+	do {
+		mdelay(1);
+		tmp = readl(scpu_wrap_addr + (0x930 + cpu_offset));
+		tmp &= 0x00000001;
+		if (!tmp) {
+			pr_err("%s: %x bit [8:0] is not 0x1, %x = %x\n",
+				__func__,
+				(0x9801d000 + 0x930 + cpu_offset),
+				(0x9801d000 + 0x930 + cpu_offset), tmp);
+		}
+	} while (!tmp);
+
+	do {
+		tmp = readl(scpu_wrap_addr + (0x580 + cpu_offset));
+		tmp &= 0x000007FF;
+		if (tmp) {
+			pr_err("%s: CPU%d Power Mode Request is not OFF\n",
+				__func__, cpu);
+			pr_err("%s: %x = %x\n", __func__,
+				(0x9801d000 + 0x580 + cpu_offset), tmp);
+		}
+	} while (tmp);
+
+	/*
+	 * SCP set SCPU Power_CTRL rbus register to reach the
+	 * requested power mode physical control.
+	 */
+
+	/* Activate the core output clamps. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (16 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* Assert nCPUPORESET LOW. */
+	if (cpu < 4) {
+		tmp = readl(scpu_wrap_addr + 0x100);
+		tmp &= ~(1UL << (0 + cpu));
+		tmp &= ~(1UL << (4 + cpu));
+		writel(tmp, scpu_wrap_addr + 0x100);
+	} else {
+		tmp = readl(scpu_wrap_addr + 0x900);
+		tmp &= ~(1UL << (0 + (cpu - 4)));
+		tmp &= ~(1UL << (4 + (cpu - 4)));
+		writel(tmp, scpu_wrap_addr + 0x900);
+	}
+
+	/* Remove power from the PDCPU power domain. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (0 + cpu));
+	tmp &= ~(1UL << (8 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+}
+EXPORT_SYMBOL(rtk_cpu_power_down);
+
+void cpu_do_lowpower(unsigned long secondary_entry_addr)
+{
+	__cpu_do_lowpower(secondary_entry_addr);
+}
+EXPORT_SYMBOL(cpu_do_lowpower);
+
+static int set_l4_icg(void *base)
+{
+	unsigned int val;
+
+	val = readl(scpu_wrap_addr + 0x000);
+	val |= 0xFF3C0000;
+	writel(val, scpu_wrap_addr + 0x000);
+
+	val = readl(scpu_wrap_addr + 0x030);
+	val |= 0x2000000;
+	writel(val, scpu_wrap_addr + 0x030);
+
+	val = readl(scpu_wrap_addr + 0x100);
+	val |= 0xC000000;
+	writel(val, scpu_wrap_addr + 0x100);
+
+	return 0;
+}
+
+irqreturn_t scpu_wrapper_isr(int irq, void *reg_base)
+{
+	struct pt_regs *regs;
+	u32 intr = readl(scpu_wrap_addr + DBG_INT);
+	u32 addr = readl(scpu_wrap_addr + DBG_ADDR);
+	u32 cause = readl(scpu_wrap_addr + DBG_ADDR_MODE);
+	char buf[128];
+
+	regs = get_irq_regs();
+
+	dbg_err("scpu wrapper get int 0x%08x", intr);
+	if(intr & (BIT(4) | BIT(2))){
+		writel((intr & ~(BIT(3)|BIT(1))), scpu_wrap_addr + DBG_INT);
+		dbg_err("scpu addr:0x%08x mode:%s", addr, (cause & 1) ? "W" : "R");
+
+		sprintf(buf, "[SCUP] Memory 0x%08x trashed with %s\n", addr,
+				(cause & 1) ? "W" : "R");
+		die(buf, regs, 0);
+
+		return IRQ_HANDLED;
+	}
+
+	return IRQ_NONE;
+}
+
+static const struct of_device_id rtk_scpu_wrapper_ids[] __initconst = {
+	{.compatible = "Realtek,rtk-scpu_wrapper"},
+	{},
+};
+
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w);
+
+static int __init scpu_wrapper_init(void)
+{
+	struct device_node *np;
+	int irq = 0;
+	int i = 0;
+
+	np = of_find_matching_node(NULL, rtk_scpu_wrapper_ids);
+	if(unlikely(np == NULL))
+		return -1;
+
+	irq = irq_of_parse_and_map(np, 0);
+
+	scpu_wrap_addr = of_iomap(np, 0);
+	dbg_info("scpu wrappee irq %d, scpu_wrap_addr 0x%08llx\n", irq, (u64)scpu_wrap_addr);
+
+	of_node_put(np);
+
+	if(request_irq(irq, scpu_wrapper_isr, IRQF_SHARED, "scpu_wrapper", scpu_wrap_addr) != 0){
+		dbg_err("Cannot get IRQ\n");
+		return -1;
+	}
+
+	/* clear dbg trap addr*/
+	for(i = 0 ; i < 8 ; i++ )
+		writel(0, scpu_wrap_addr + 0x200 + i * 4);
+	writel(0x98000000, scpu_wrap_addr + 0x200);	// 1st set start
+	writel(0x98000040, scpu_wrap_addr + 0x210);	// 1st set end
+
+	writel(0x98000040, scpu_wrap_addr + 0x204);	// 2nd set start
+	writel(0x98000080, scpu_wrap_addr + 0x214);	// 2nd set end
+
+	writel(0x98000080, scpu_wrap_addr + 0x208);	// 3th set start
+	writel(0x980000c0, scpu_wrap_addr + 0x218);	// 3th set end
+
+	writel(0x980000c0, scpu_wrap_addr + 0x20c);	// 4th set start
+	writel(0x98000100, scpu_wrap_addr + 0x21c);	// 4th set end
+
+	writel(0x9, scpu_wrap_addr + DBG_INT);	// enable interrupt
+
+	printk(KERN_INFO "[SCPU_WRAPPER] initialized\n");
+
+	printk(KERN_INFO "[SCPU_WRAPPER][%s] memory monitor 0x98013b00 - 0x98013c00\n",__FUNCTION__);
+	scpu_dbg_scpu_monitor(0, 0x98013b00, 0x98013c00, 0x0);
+
+	set_l4_icg(scpu_wrap_addr);
+
+	return 0;
+}
+late_initcall(scpu_wrapper_init);
+
+void scpu_dbg_disable_mem_monitor(int which)
+{
+	void __iomem  *reg_ctrl;
+
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220);
+	reg_ctrl += which;
+	writel((1 << 13) | (1 << 9) | (1 << 1), reg_ctrl);
+}
+EXPORT_SYMBOL(scpu_dbg_disable_mem_monitor);
+
+static void scpu_dbg_set_mem_monitor(int which, u32 start, u32 end, u32 flags)
+{
+	void __iomem  *reg_start;
+	void __iomem  *reg_end;
+	void __iomem  *reg_ctrl;
+
+	/* disable this set first */
+	scpu_dbg_disable_mem_monitor(which);
+
+	reg_start = (void __iomem  *)(scpu_wrap_addr + 0x200 + which);
+	reg_end = (void __iomem  *)(scpu_wrap_addr + 0x210 + which);
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220 + which);
+
+	writel(start, reg_start);
+	writel(end, reg_end);
+
+	writel(flags, reg_ctrl);
+}
+
+/*
+ * which: 0~7, which register set
+ * d_i: SB2_DBG_MONITOR_DATA|SB2_DBG_MONITOR_INST
+ * r_w: SB2_DBG_MONITOR_READ|SB2_DBG_MONITOR_WRITE
+ */
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w)
+{
+	scpu_dbg_set_mem_monitor(which * 4, start, end, (3 << 8) | r_w | 3);
+}
+EXPORT_SYMBOL(scpu_dbg_scpu_monitor);
diff --git a/drivers/soc/realtek/rtd13xx/rtd13xx_cpu_hotplug.S b/drivers/soc/realtek/rtd13xx/rtd13xx_cpu_hotplug.S
new file mode 100644
index 00000000..8ac268d
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtd13xx_cpu_hotplug.S
@@ -0,0 +1,33 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/linkage.h>
+#include <asm/assembler.h>
+#include <asm/sysreg.h>
+#include <asm/virt.h>
+
+.text
+.pushsection .idmap.text, "ax"
+
+ENTRY(__cpu_do_lowpower)
+	mov x12, 0
+	msr S3_0_C12_C12_7, x12
+	isb
+	mrs x12, S3_0_C15_C2_7
+	orr x12, x12, #0x1 /* send power down request*/
+	msr S3_0_C15_C2_7, x12
+	isb
+	dsb sy
+	wfi
+	ldr w3, [x0]//get entry address, if cpu do not power gating
+	br x3
+ENDPROC(__cpu_do_lowpower)
+
+.popsection
diff --git a/drivers/soc/realtek/rtd13xx/rtd13xx_cpu_hotplug.h b/drivers/soc/realtek/rtd13xx/rtd13xx_cpu_hotplug.h
new file mode 100644
index 00000000..96a7176
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtd13xx_cpu_hotplug.h
@@ -0,0 +1,26 @@
+/*
+ * rtd13xx_cpu_hotplug.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef RTD13xx_CPU_HOTPLUG_H_
+#define RTD13xx_CPU_HOTPLUG_H_
+
+#include <asm/virt.h>
+
+void __cpu_do_lowpower(unsigned long secondary_entry_addr);
+
+static inline void cpu_do_lowpower(unsigned long secondary_entry_addr)
+{
+	__cpu_do_lowpower(secondary_entry_addr);
+	unreachable();
+}
+
+#endif /* RTD13xx_CPU_HOTPLUG_H_ */
diff --git a/drivers/soc/realtek/rtd13xx/rtd13xx_cpu_wrapper.c b/drivers/soc/realtek/rtd13xx/rtd13xx_cpu_wrapper.c
new file mode 100644
index 00000000..10b2d71
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtd13xx_cpu_wrapper.c
@@ -0,0 +1,333 @@
+/*
+ * rtd13xx_cpu_wrapper.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/delay.h>
+#include <linux/debugfs.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+
+#include <asm/io.h>
+#include <asm/cacheflush.h>
+#include <asm/cpu_ops.h>
+#include <asm/cputype.h>
+#include <asm/io.h>
+#include <asm/smp_plat.h>
+
+#include <asm/system_misc.h>
+
+#include "../common/include/debug.h"
+
+#define DBG_INT 0x230
+#define DBG_ADDR 0x234
+#define DBG_ADDR_MODE 0x238
+
+static void __iomem *scpu_wrap_addr;
+
+void rtk_cpu_power_up(int cpu)
+{
+	u32 tmp = 0;
+	u32 flag1 = 0;
+	u32 flag2 = 0;
+	u32 cpu_offset = cpu * 4;
+
+	/* 1. Apply power to the PDCPU power domain.
+	 * Keep the state of the signals nCPUPORESET */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (0 + cpu);
+	tmp |= 1UL << (8 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	do {
+		tmp = readl(scpu_wrap_addr + 0x53C);
+		flag1 = !((tmp >> (0 + cpu)) & 0x1);
+		flag2 = !((tmp >> (8 + cpu)) & 0x1);
+		if (flag1 || flag2) {
+			pr_err("%s: CPU%d Power Mode Request is not ON\n",
+				__func__, cpu);
+			pr_err("%s: %x = %x\n", __func__,
+				(0x9801d000 + 0x53C), tmp);
+		}
+
+	} while( flag1 ||flag2 );
+
+	/* 2. Release the core output clamps. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (16 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* 3. SCP setup core P-Channel corresponding PSTATE Register
+	 * Request Power Mode to ON */
+	tmp = readl(scpu_wrap_addr + (0x540 + cpu_offset));
+	tmp &= 0x0000003F;
+	tmp |= 0x00000008;
+	writel(tmp, scpu_wrap_addr + (0x540 + cpu_offset));
+
+	/* 4. De-assert CPU cores resets. */
+	if (cpu < 4) {
+		tmp = readl(scpu_wrap_addr + 0x100);
+		tmp |= 1UL << (0 + cpu);
+		tmp |= 1UL << (4 + cpu);
+		writel(tmp, scpu_wrap_addr + 0x100);
+	} else {
+		tmp = readl(scpu_wrap_addr + 0x900);
+		tmp |= 1UL << (0 + (cpu - 4));
+		tmp |= 1UL << (4 + (cpu - 4));
+		writel(tmp, scpu_wrap_addr + 0x900);
+	}
+
+}
+EXPORT_SYMBOL(rtk_cpu_power_up);
+
+void rtk_cpu_power_down(int cpu)
+{
+	u32 tmp = 0;
+	u32 cpu_offset = cpu * 4;
+
+	/* SCP polling core corresponding P-Channel PACTIVE Register,
+	 * SC_CORE_PCHANNEL_STAT_ACK bit[10:0] is 0x0
+	 * (Power Mode Request is OFF)
+	 */
+	do {
+		tmp = readl(scpu_wrap_addr + (0x5C0 + cpu_offset));
+		tmp = tmp & 0x000007FF;
+		if (tmp != 0x00000000) {
+			pr_err("%s: CPU%d Power Mode Request is not OFF\n",
+				__func__, cpu);
+			pr_err("%s: %x = %d \n",
+				__func__, (0x9801d000 + 0x5C0 + cpu_offset),
+				tmp);
+		}
+	} while (tmp != 0x00000000);
+
+	/* SCP setup core P-Channel corresponding PSTATE Register,
+	 * Set SC_CORE_PCHANNEL_CTRL bit[5:0] as 0x0
+	 * (Request Power Mode to OFF)
+	 *
+	 * Set SC_CORE_PCHANNEL_CTRL bit[16] as 0x1
+	 * to assert P-Channel Request
+	 */
+	tmp = readl(scpu_wrap_addr + (0x540 + cpu_offset));
+	tmp &= 0xFFFFFFC0;
+	tmp |= 1UL << 16;
+	writel(tmp, scpu_wrap_addr + (0x540 + cpu_offset));
+
+	/* Wait P-Channel Request is Accepted:
+	 * Polling when SC_ CORE_PCHANNEL INT_STAT bit[8:0] is 0x1
+	 * (only paccept is asserted),
+	 * SC_CORE_PCHANNEL_STAT_ACK_TRIGGER bit[10:0] is 0x0
+	 * (Power Mode Request is OFF).
+	 */
+	do {
+		mdelay(1);
+		tmp = readl(scpu_wrap_addr + (0x930 + cpu_offset));
+		tmp &= 0x00000001;
+		if (!tmp) {
+			pr_err("%s: %x bit [8:0] is not 0x1, %x = %x\n",
+				__func__,
+				(0x9801d000 + 0x930 + cpu_offset),
+				(0x9801d000 + 0x930 + cpu_offset), tmp);
+		}
+	} while (!tmp);
+
+	do {
+		tmp = readl(scpu_wrap_addr + (0x580 + cpu_offset));
+		tmp &= 0x000007FF;
+		if (tmp) {
+			pr_err("%s: CPU%d Power Mode Request is not OFF\n",
+				__func__, cpu);
+			pr_err("%s: %x = %x\n", __func__,
+				(0x9801d000 + 0x580 + cpu_offset), tmp);
+		}
+	} while (tmp);
+
+	/*
+	 * SCP set SCPU Power_CTRL rbus register to reach the
+	 * requested power mode physical control.
+	 */
+
+	/* Activate the core output clamps. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (16 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* Assert nCPUPORESET LOW. */
+	if (cpu < 4) {
+		tmp = readl(scpu_wrap_addr + 0x100);
+		tmp &= ~(1UL << (0 + cpu));
+		tmp &= ~(1UL << (4 + cpu));
+		writel(tmp, scpu_wrap_addr + 0x100);
+	} else {
+		tmp = readl(scpu_wrap_addr + 0x900);
+		tmp &= ~(1UL << (0 + (cpu - 4)));
+		tmp &= ~(1UL << (4 + (cpu - 4)));
+		writel(tmp, scpu_wrap_addr + 0x900);
+	}
+
+	/* Remove power from the PDCPU power domain. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (0 + cpu));
+	tmp &= ~(1UL << (8 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+}
+EXPORT_SYMBOL(rtk_cpu_power_down);
+
+static int set_l4_icg(void *base)
+{
+	unsigned int val;
+
+	val = readl(scpu_wrap_addr + 0x000);
+	val |= 0xFF3C0000;
+	writel(val, scpu_wrap_addr + 0x000);
+
+	val = readl(scpu_wrap_addr + 0x030);
+	val |= 0x2000000;
+	writel(val, scpu_wrap_addr + 0x030);
+
+	val = readl(scpu_wrap_addr + 0x100);
+	val |= 0xC000000;
+	writel(val, scpu_wrap_addr + 0x100);
+
+	return 0;
+}
+
+irqreturn_t scpu_wrapper_isr(int irq, void *reg_base)
+{
+	struct pt_regs *regs;
+	u32 intr = readl(scpu_wrap_addr + DBG_INT);
+	u32 addr = readl(scpu_wrap_addr + DBG_ADDR);
+	u32 cause = readl(scpu_wrap_addr + DBG_ADDR_MODE);
+	char buf[128];
+
+	regs = get_irq_regs();
+
+	dbg_err("scpu wrapper get int 0x%08x", intr);
+	if(intr & (BIT(4) | BIT(2))){
+		writel((intr & ~(BIT(3)|BIT(1))), scpu_wrap_addr + DBG_INT);
+		dbg_err("scpu addr:0x%08x mode:%s", addr, (cause & 1) ? "W" : "R");
+
+		sprintf(buf, "[SCUP] Memory 0x%08x trashed with %s\n", addr,
+				(cause & 1) ? "W" : "R");
+		die(buf, regs, 0);
+
+		return IRQ_HANDLED;
+	}
+
+	return IRQ_NONE;
+}
+
+static const struct of_device_id rtk_scpu_wrapper_ids[] __initconst = {
+	{.compatible = "Realtek,rtk-scpu_wrapper"},
+	{},
+};
+
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w);
+
+static int __init scpu_wrapper_init(void)
+{
+	struct device_node *np;
+	int irq = 0;
+	int i = 0;
+
+	np = of_find_matching_node(NULL, rtk_scpu_wrapper_ids);
+	if(unlikely(np == NULL))
+		return -1;
+
+	irq = irq_of_parse_and_map(np, 0);
+
+	scpu_wrap_addr = of_iomap(np, 0);
+	dbg_info("scpu wrappee irq %d, scpu_wrap_addr 0x%08llx\n", irq, (u64)scpu_wrap_addr);
+
+	of_node_put(np);
+
+	if(request_irq(irq, scpu_wrapper_isr, IRQF_SHARED, "scpu_wrapper", scpu_wrap_addr) != 0){
+		dbg_err("Cannot get IRQ\n");
+		return -1;
+	}
+
+	/* clear dbg trap addr*/
+	for(i = 0 ; i < 8 ; i++ )
+		writel(0, scpu_wrap_addr + 0x200 + i * 4);
+	writel(0x98000000, scpu_wrap_addr + 0x200);	// 1st set start
+	writel(0x98000040, scpu_wrap_addr + 0x210);	// 1st set end
+
+	writel(0x98000040, scpu_wrap_addr + 0x204);	// 2nd set start
+	writel(0x98000080, scpu_wrap_addr + 0x214);	// 2nd set end
+
+	writel(0x98000080, scpu_wrap_addr + 0x208);	// 3th set start
+	writel(0x980000c0, scpu_wrap_addr + 0x218);	// 3th set end
+
+	writel(0x980000c0, scpu_wrap_addr + 0x20c);	// 4th set start
+	writel(0x98000100, scpu_wrap_addr + 0x21c);	// 4th set end
+
+	writel(0x9, scpu_wrap_addr + DBG_INT);	// enable interrupt
+
+	printk(KERN_INFO "[SCPU_WRAPPER] initialized\n");
+
+	printk(KERN_INFO "[SCPU_WRAPPER][%s] memory monitor 0x98013b00 - 0x98013c00\n",__FUNCTION__);
+	scpu_dbg_scpu_monitor(0, 0x98013b00, 0x98013c00, 0x0);
+
+	set_l4_icg(scpu_wrap_addr);
+
+	return 0;
+}
+late_initcall(scpu_wrapper_init);
+
+void scpu_dbg_disable_mem_monitor(int which)
+{
+	void __iomem  *reg_ctrl;
+
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220);
+	reg_ctrl += which;
+	writel((1 << 13) | (1 << 9) | (1 << 1), reg_ctrl);
+}
+EXPORT_SYMBOL(scpu_dbg_disable_mem_monitor);
+
+static void scpu_dbg_set_mem_monitor(int which, u32 start, u32 end, u32 flags)
+{
+	void __iomem  *reg_start;
+	void __iomem  *reg_end;
+	void __iomem  *reg_ctrl;
+
+	/* disable this set first */
+	scpu_dbg_disable_mem_monitor(which);
+
+	reg_start = (void __iomem  *)(scpu_wrap_addr + 0x200 + which);
+	reg_end = (void __iomem  *)(scpu_wrap_addr + 0x210 + which);
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220 + which);
+
+	writel(start, reg_start);
+	writel(end, reg_end);
+
+	writel(flags, reg_ctrl);
+}
+
+/*
+ * which: 0~7, which register set
+ * d_i: SB2_DBG_MONITOR_DATA|SB2_DBG_MONITOR_INST
+ * r_w: SB2_DBG_MONITOR_READ|SB2_DBG_MONITOR_WRITE
+ */
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w)
+{
+	scpu_dbg_set_mem_monitor(which * 4, start, end, (3 << 8) | r_w | 3);
+}
+EXPORT_SYMBOL(scpu_dbg_scpu_monitor);
diff --git a/drivers/soc/realtek/rtd13xx/rtd13xx_psci.c b/drivers/soc/realtek/rtd13xx/rtd13xx_psci.c
new file mode 100644
index 00000000..e30aed6
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtd13xx_psci.c
@@ -0,0 +1,703 @@
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * Copyright (C) 2015 ARM Limited
+ */
+
+#define pr_fmt(fmt) "psci: " fmt
+
+#include <linux/acpi.h>
+#include <linux/arm-smccc.h>
+#include <linux/cpuidle.h>
+#include <linux/errno.h>
+#include <linux/linkage.h>
+#include <linux/of.h>
+#include <linux/pm.h>
+#include <linux/printk.h>
+#include <linux/psci.h>
+#include <linux/reboot.h>
+#include <linux/slab.h>
+#include <linux/suspend.h>
+
+#include <uapi/linux/psci.h>
+
+#include <asm/cpuidle.h>
+#include <asm/cputype.h>
+#include <asm/system_misc.h>
+#include <asm/smp_plat.h>
+#include <asm/suspend.h>
+
+/*
+ * While a 64-bit OS can make calls with SMC32 calling conventions, for some
+ * calls it is necessary to use SMC64 to pass or return 64-bit values.
+ * For such calls PSCI_FN_NATIVE(version, name) will choose the appropriate
+ * (native-width) function ID.
+ */
+#ifdef CONFIG_64BIT
+#define PSCI_FN_NATIVE(version, name)	PSCI_##version##_FN64_##name
+#else
+#define PSCI_FN_NATIVE(version, name)	PSCI_##version##_FN_##name
+#endif
+
+/*
+ * The CPU any Trusted OS is resident on. The trusted OS may reject CPU_OFF
+ * calls to its resident CPU, so we must avoid issuing those. We never migrate
+ * a Trusted OS even if it claims to be capable of migration -- doing so will
+ * require cooperation with a Trusted OS driver.
+ */
+static int resident_cpu = -1;
+
+bool psci_tos_resident_on(int cpu)
+{
+	return cpu == resident_cpu;
+}
+
+struct psci_operations psci_ops = {
+	.conduit = PSCI_CONDUIT_NONE,
+	.smccc_version = SMCCC_VERSION_1_0,
+};
+
+typedef unsigned long (psci_fn)(unsigned long, unsigned long,
+				unsigned long, unsigned long);
+ psci_fn *invoke_psci_fn;
+
+enum psci_function {
+	PSCI_FN_CPU_SUSPEND,
+	PSCI_FN_CPU_ON,
+	PSCI_FN_CPU_OFF,
+	PSCI_FN_MIGRATE,
+	PSCI_FN_MAX,
+};
+
+static u32 psci_function_id[PSCI_FN_MAX];
+
+#define PSCI_0_2_POWER_STATE_MASK		\
+				(PSCI_0_2_POWER_STATE_ID_MASK | \
+				PSCI_0_2_POWER_STATE_TYPE_MASK | \
+				PSCI_0_2_POWER_STATE_AFFL_MASK)
+
+#define PSCI_1_0_EXT_POWER_STATE_MASK		\
+				(PSCI_1_0_EXT_POWER_STATE_ID_MASK | \
+				PSCI_1_0_EXT_POWER_STATE_TYPE_MASK)
+
+static u32 psci_cpu_suspend_feature;
+
+static inline bool psci_has_ext_power_state(void)
+{
+	return psci_cpu_suspend_feature &
+				PSCI_1_0_FEATURES_CPU_SUSPEND_PF_MASK;
+}
+
+static inline bool psci_power_state_loses_context(u32 state)
+{
+	const u32 mask = psci_has_ext_power_state() ?
+					PSCI_1_0_EXT_POWER_STATE_TYPE_MASK :
+					PSCI_0_2_POWER_STATE_TYPE_MASK;
+
+	return state & mask;
+}
+
+static inline bool psci_power_state_is_valid(u32 state)
+{
+	const u32 valid_mask = psci_has_ext_power_state() ?
+			       PSCI_1_0_EXT_POWER_STATE_MASK :
+			       PSCI_0_2_POWER_STATE_MASK;
+
+	return !(state & ~valid_mask);
+}
+
+static unsigned long __invoke_psci_fn_hvc(unsigned long function_id,
+			unsigned long arg0, unsigned long arg1,
+			unsigned long arg2)
+{
+	struct arm_smccc_res res;
+
+	arm_smccc_hvc(function_id, arg0, arg1, arg2, 0, 0, 0, 0, &res);
+	return res.a0;
+}
+
+static unsigned long __invoke_psci_fn_smc(unsigned long function_id,
+			unsigned long arg0, unsigned long arg1,
+			unsigned long arg2)
+{
+	struct arm_smccc_res res;
+
+	arm_smccc_smc(function_id, arg0, arg1, arg2, 0, 0, 0, 0, &res);
+	return res.a0;
+}
+
+static int psci_to_linux_errno(int errno)
+{
+	switch (errno) {
+	case PSCI_RET_SUCCESS:
+		return 0;
+	case PSCI_RET_NOT_SUPPORTED:
+		return -EOPNOTSUPP;
+	case PSCI_RET_INVALID_PARAMS:
+	case PSCI_RET_INVALID_ADDRESS:
+		return -EINVAL;
+	case PSCI_RET_DENIED:
+		return -EPERM;
+	};
+
+	return -EINVAL;
+}
+
+static u32 psci_get_version(void)
+{
+	return invoke_psci_fn(PSCI_0_2_FN_PSCI_VERSION, 0, 0, 0);
+}
+
+static int psci_cpu_suspend(u32 state, unsigned long entry_point)
+{
+	int err;
+	u32 fn;
+
+	fn = psci_function_id[PSCI_FN_CPU_SUSPEND];
+	err = invoke_psci_fn(fn, state, entry_point, 0);
+	return psci_to_linux_errno(err);
+}
+
+static int psci_cpu_off(u32 state)
+{
+	int err;
+	u32 fn;
+
+	fn = psci_function_id[PSCI_FN_CPU_OFF];
+	err = invoke_psci_fn(fn, state, 0, 0);
+	return psci_to_linux_errno(err);
+}
+
+static int psci_cpu_on(unsigned long cpuid, unsigned long entry_point)
+{
+	int err;
+	u32 fn;
+
+	fn = psci_function_id[PSCI_FN_CPU_ON];
+	err = invoke_psci_fn(fn, cpuid, entry_point, 0);
+	return psci_to_linux_errno(err);
+}
+
+static int psci_migrate(unsigned long cpuid)
+{
+	int err;
+	u32 fn;
+
+	fn = psci_function_id[PSCI_FN_MIGRATE];
+	err = invoke_psci_fn(fn, cpuid, 0, 0);
+	return psci_to_linux_errno(err);
+}
+
+static int psci_affinity_info(unsigned long target_affinity,
+		unsigned long lowest_affinity_level)
+{
+	return invoke_psci_fn(PSCI_FN_NATIVE(0_2, AFFINITY_INFO),
+			      target_affinity, lowest_affinity_level, 0);
+}
+
+static int psci_migrate_info_type(void)
+{
+	return invoke_psci_fn(PSCI_0_2_FN_MIGRATE_INFO_TYPE, 0, 0, 0);
+}
+
+static unsigned long psci_migrate_info_up_cpu(void)
+{
+	return invoke_psci_fn(PSCI_FN_NATIVE(0_2, MIGRATE_INFO_UP_CPU),
+			      0, 0, 0);
+}
+
+static void set_conduit(enum psci_conduit conduit)
+{
+	switch (conduit) {
+	case PSCI_CONDUIT_HVC:
+		invoke_psci_fn = __invoke_psci_fn_hvc;
+		break;
+	case PSCI_CONDUIT_SMC:
+		invoke_psci_fn = __invoke_psci_fn_smc;
+		break;
+	default:
+		WARN(1, "Unexpected PSCI conduit %d\n", conduit);
+	}
+
+	psci_ops.conduit = conduit;
+}
+
+static int get_set_conduit_method(struct device_node *np)
+{
+	const char *method;
+
+	pr_info("probing for conduit method from DT.\n");
+
+	if (of_property_read_string(np, "method", &method)) {
+		pr_warn("missing \"method\" property\n");
+		return -ENXIO;
+	}
+
+	if (!strcmp("hvc", method)) {
+		set_conduit(PSCI_CONDUIT_HVC);
+	} else if (!strcmp("smc", method)) {
+		set_conduit(PSCI_CONDUIT_SMC);
+	} else {
+		pr_warn("invalid \"method\" property: %s\n", method);
+		return -EINVAL;
+	}
+	return 0;
+}
+
+void psci_sys_reset(enum reboot_mode reboot_mode, const char *cmd)
+{
+	invoke_psci_fn(PSCI_0_2_FN_SYSTEM_RESET, 0, 0, 0);
+}
+EXPORT_SYMBOL(psci_sys_reset);
+
+void psci_sys_poweroff(void)
+{
+	invoke_psci_fn(PSCI_0_2_FN_SYSTEM_OFF, 0, 0, 0);
+}
+EXPORT_SYMBOL(psci_sys_poweroff);
+
+static int __init psci_features(u32 psci_func_id)
+{
+	return invoke_psci_fn(PSCI_1_0_FN_PSCI_FEATURES,
+			      psci_func_id, 0, 0);
+}
+
+#ifdef CONFIG_CPU_IDLE
+static DEFINE_PER_CPU_READ_MOSTLY(u32 *, psci_power_state);
+
+static int psci_dt_cpu_init_idle(struct device_node *cpu_node, int cpu)
+{
+	int i, ret, count = 0;
+	u32 *psci_states;
+	struct device_node *state_node;
+
+	/* Count idle states */
+	while ((state_node = of_parse_phandle(cpu_node, "cpu-idle-states",
+					      count))) {
+		count++;
+		of_node_put(state_node);
+	}
+
+	if (!count)
+		return -ENODEV;
+
+	psci_states = kcalloc(count, sizeof(*psci_states), GFP_KERNEL);
+	if (!psci_states)
+		return -ENOMEM;
+
+	for (i = 0; i < count; i++) {
+		u32 state;
+
+		state_node = of_parse_phandle(cpu_node, "cpu-idle-states", i);
+
+		ret = of_property_read_u32(state_node,
+					   "arm,psci-suspend-param",
+					   &state);
+		if (ret) {
+			pr_warn(" * %s missing arm,psci-suspend-param property\n",
+				state_node->full_name);
+			of_node_put(state_node);
+			goto free_mem;
+		}
+
+		of_node_put(state_node);
+		pr_debug("psci-power-state %#x index %d\n", state, i);
+		if (!psci_power_state_is_valid(state)) {
+			pr_warn("Invalid PSCI power state %#x\n", state);
+			ret = -EINVAL;
+			goto free_mem;
+		}
+		psci_states[i] = state;
+	}
+	/* Idle states parsed correctly, initialize per-cpu pointer */
+	per_cpu(psci_power_state, cpu) = psci_states;
+	return 0;
+
+free_mem:
+	kfree(psci_states);
+	return ret;
+}
+
+#ifdef CONFIG_ACPI
+#include <acpi/processor.h>
+
+static int __maybe_unused psci_acpi_cpu_init_idle(unsigned int cpu)
+{
+	int i, count;
+	u32 *psci_states;
+	struct acpi_lpi_state *lpi;
+	struct acpi_processor *pr = per_cpu(processors, cpu);
+
+	if (unlikely(!pr || !pr->flags.has_lpi))
+		return -EINVAL;
+
+	count = pr->power.count - 1;
+	if (count <= 0)
+		return -ENODEV;
+
+	psci_states = kcalloc(count, sizeof(*psci_states), GFP_KERNEL);
+	if (!psci_states)
+		return -ENOMEM;
+
+	for (i = 0; i < count; i++) {
+		u32 state;
+
+		lpi = &pr->power.lpi_states[i + 1];
+		/*
+		 * Only bits[31:0] represent a PSCI power_state while
+		 * bits[63:32] must be 0x0 as per ARM ACPI FFH Specification
+		 */
+		state = lpi->address;
+		if (!psci_power_state_is_valid(state)) {
+			pr_warn("Invalid PSCI power state %#x\n", state);
+			kfree(psci_states);
+			return -EINVAL;
+		}
+		psci_states[i] = state;
+	}
+	/* Idle states parsed correctly, initialize per-cpu pointer */
+	per_cpu(psci_power_state, cpu) = psci_states;
+	return 0;
+}
+#else
+static int __maybe_unused psci_acpi_cpu_init_idle(unsigned int cpu)
+{
+	return -EINVAL;
+}
+#endif
+
+int psci_cpu_init_idle(unsigned int cpu)
+{
+	struct device_node *cpu_node;
+	int ret;
+
+	/*
+	 * If the PSCI cpu_suspend function hook has not been initialized
+	 * idle states must not be enabled, so bail out
+	 */
+	if (!psci_ops.cpu_suspend)
+		return -EOPNOTSUPP;
+
+	if (!acpi_disabled)
+		return psci_acpi_cpu_init_idle(cpu);
+
+	cpu_node = of_get_cpu_node(cpu, NULL);
+	if (!cpu_node)
+		return -ENODEV;
+
+	ret = psci_dt_cpu_init_idle(cpu_node, cpu);
+
+	of_node_put(cpu_node);
+
+	return ret;
+}
+
+static int psci_suspend_finisher(unsigned long index)
+{
+	u32 *state = __this_cpu_read(psci_power_state);
+
+	return psci_ops.cpu_suspend(state[index - 1],
+				    virt_to_phys(cpu_resume));
+}
+
+int psci_cpu_suspend_enter(unsigned long index)
+{
+	int ret;
+	u32 *state = __this_cpu_read(psci_power_state);
+	/*
+	 * idle state index 0 corresponds to wfi, should never be called
+	 * from the cpu_suspend operations
+	 */
+	if (WARN_ON_ONCE(!index))
+		return -EINVAL;
+
+	if (!psci_power_state_loses_context(state[index - 1]))
+		ret = psci_ops.cpu_suspend(state[index - 1], 0);
+	else
+		ret = cpu_suspend(index, psci_suspend_finisher);
+
+	return ret;
+}
+
+/* ARM specific CPU idle operations */
+#ifdef CONFIG_ARM
+static const struct cpuidle_ops psci_cpuidle_ops __initconst = {
+	.suspend = psci_cpu_suspend_enter,
+	.init = psci_dt_cpu_init_idle,
+};
+
+CPUIDLE_METHOD_OF_DECLARE(psci, "psci", &psci_cpuidle_ops);
+#endif
+#endif
+
+int psci_system_suspend(unsigned long wakeup_source)
+{
+	return invoke_psci_fn(PSCI_FN_NATIVE(1_0, SYSTEM_SUSPEND),
+			      virt_to_phys(cpu_resume), wakeup_source, 0);
+}
+EXPORT_SYMBOL(psci_system_suspend);
+
+static int psci_system_suspend_enter(suspend_state_t state)
+{
+	return cpu_suspend(0, psci_system_suspend);
+}
+
+static void __init psci_init_system_suspend(void)
+{
+	int ret;
+
+	if (!IS_ENABLED(CONFIG_SUSPEND))
+		return;
+
+	ret = psci_features(PSCI_FN_NATIVE(1_0, SYSTEM_SUSPEND));
+}
+
+static void __init psci_init_cpu_suspend(void)
+{
+	int feature = psci_features(psci_function_id[PSCI_FN_CPU_SUSPEND]);
+
+	if (feature != PSCI_RET_NOT_SUPPORTED)
+		psci_cpu_suspend_feature = feature;
+}
+
+/*
+ * Detect the presence of a resident Trusted OS which may cause CPU_OFF to
+ * return DENIED (which would be fatal).
+ */
+static void __init psci_init_migrate(void)
+{
+	unsigned long cpuid;
+	int type, cpu = -1;
+
+	type = psci_ops.migrate_info_type();
+
+	if (type == PSCI_0_2_TOS_MP) {
+		pr_info("Trusted OS migration not required\n");
+		return;
+	}
+
+	if (type == PSCI_RET_NOT_SUPPORTED) {
+		pr_info("MIGRATE_INFO_TYPE not supported.\n");
+		return;
+	}
+
+	if (type != PSCI_0_2_TOS_UP_MIGRATE &&
+	    type != PSCI_0_2_TOS_UP_NO_MIGRATE) {
+		pr_err("MIGRATE_INFO_TYPE returned unknown type (%d)\n", type);
+		return;
+	}
+
+	cpuid = psci_migrate_info_up_cpu();
+	if (cpuid & ~MPIDR_HWID_BITMASK) {
+		pr_warn("MIGRATE_INFO_UP_CPU reported invalid physical ID (0x%lx)\n",
+			cpuid);
+		return;
+	}
+
+	cpu = get_logical_index(cpuid);
+	resident_cpu = cpu >= 0 ? cpu : -1;
+
+	pr_info("Trusted OS resident on physical CPU 0x%lx\n", cpuid);
+}
+
+static void __init psci_init_smccc(void)
+{
+	u32 ver = ARM_SMCCC_VERSION_1_0;
+	int feature;
+
+	feature = psci_features(ARM_SMCCC_VERSION_FUNC_ID);
+
+	if (feature != PSCI_RET_NOT_SUPPORTED) {
+		u32 ret;
+		ret = invoke_psci_fn(ARM_SMCCC_VERSION_FUNC_ID, 0, 0, 0);
+		if (ret == ARM_SMCCC_VERSION_1_1) {
+			psci_ops.smccc_version = SMCCC_VERSION_1_1;
+			ver = ret;
+		}
+	}
+
+	/*
+	 * Conveniently, the SMCCC and PSCI versions are encoded the
+	 * same way. No, this isn't accidental.
+	 */
+	pr_info("SMC Calling Convention v%d.%d\n",
+		PSCI_VERSION_MAJOR(ver), PSCI_VERSION_MINOR(ver));
+
+}
+
+static void __init psci_0_2_set_functions(void)
+{
+	pr_info("Using standard PSCI v0.2 function IDs\n");
+	psci_ops.get_version = psci_get_version;
+
+	psci_function_id[PSCI_FN_CPU_SUSPEND] =
+					PSCI_FN_NATIVE(0_2, CPU_SUSPEND);
+	psci_ops.cpu_suspend = psci_cpu_suspend;
+
+	psci_function_id[PSCI_FN_CPU_OFF] = PSCI_0_2_FN_CPU_OFF;
+	psci_ops.cpu_off = psci_cpu_off;
+
+	psci_function_id[PSCI_FN_CPU_ON] = PSCI_FN_NATIVE(0_2, CPU_ON);
+	psci_ops.cpu_on = psci_cpu_on;
+
+	psci_function_id[PSCI_FN_MIGRATE] = PSCI_FN_NATIVE(0_2, MIGRATE);
+	psci_ops.migrate = psci_migrate;
+
+	psci_ops.affinity_info = psci_affinity_info;
+
+	psci_ops.migrate_info_type = psci_migrate_info_type;
+
+	arm_pm_restart = psci_sys_reset;
+
+	pm_power_off = psci_sys_poweroff;
+}
+
+/*
+ * Probe function for PSCI firmware versions >= 0.2
+ */
+static int __init psci_probe(void)
+{
+	u32 ver = psci_get_version();
+
+	pr_info("PSCIv%d.%d detected in firmware.\n",
+			PSCI_VERSION_MAJOR(ver),
+			PSCI_VERSION_MINOR(ver));
+
+	if (PSCI_VERSION_MAJOR(ver) == 0 && PSCI_VERSION_MINOR(ver) < 2) {
+		pr_err("Conflicting PSCI version detected.\n");
+		return -EINVAL;
+	}
+
+	psci_0_2_set_functions();
+
+	psci_init_migrate();
+
+	if (PSCI_VERSION_MAJOR(ver) >= 1) {
+		psci_init_smccc();
+		psci_init_cpu_suspend();
+		psci_init_system_suspend();
+	}
+
+	return 0;
+}
+
+typedef int (*psci_initcall_t)(const struct device_node *);
+
+/*
+ * PSCI init function for PSCI versions >=0.2
+ *
+ * Probe based on PSCI PSCI_VERSION function
+ */
+static int __init psci_0_2_init(struct device_node *np)
+{
+	int err;
+
+	err = get_set_conduit_method(np);
+
+	if (err)
+		goto out_put_node;
+	/*
+	 * Starting with v0.2, the PSCI specification introduced a call
+	 * (PSCI_VERSION) that allows probing the firmware version, so
+	 * that PSCI function IDs and version specific initialization
+	 * can be carried out according to the specific version reported
+	 * by firmware
+	 */
+	err = psci_probe();
+
+out_put_node:
+	of_node_put(np);
+	return err;
+}
+
+/*
+ * PSCI < v0.2 get PSCI Function IDs via DT.
+ */
+static int __init psci_0_1_init(struct device_node *np)
+{
+	u32 id;
+	int err;
+
+	err = get_set_conduit_method(np);
+
+	if (err)
+		goto out_put_node;
+
+	pr_info("Using PSCI v0.1 Function IDs from DT\n");
+
+	if (!of_property_read_u32(np, "cpu_suspend", &id)) {
+		psci_function_id[PSCI_FN_CPU_SUSPEND] = id;
+		psci_ops.cpu_suspend = psci_cpu_suspend;
+	}
+
+	if (!of_property_read_u32(np, "cpu_off", &id)) {
+		psci_function_id[PSCI_FN_CPU_OFF] = id;
+		psci_ops.cpu_off = psci_cpu_off;
+	}
+
+	if (!of_property_read_u32(np, "cpu_on", &id)) {
+		psci_function_id[PSCI_FN_CPU_ON] = id;
+		psci_ops.cpu_on = psci_cpu_on;
+	}
+
+	if (!of_property_read_u32(np, "migrate", &id)) {
+		psci_function_id[PSCI_FN_MIGRATE] = id;
+		psci_ops.migrate = psci_migrate;
+	}
+
+out_put_node:
+	of_node_put(np);
+	return err;
+}
+
+static const struct of_device_id psci_of_match[] __initconst = {
+	{ .compatible = "arm,psci",	.data = psci_0_1_init},
+	{ .compatible = "arm,psci-0.2",	.data = psci_0_2_init},
+	{ .compatible = "arm,psci-1.0",	.data = psci_0_2_init},
+	{},
+};
+
+int __init psci_dt_init(void)
+{
+	struct device_node *np;
+	const struct of_device_id *matched_np;
+	psci_initcall_t init_fn;
+
+	np = of_find_matching_node_and_match(NULL, psci_of_match, &matched_np);
+
+	if (!np)
+		return -ENODEV;
+
+	init_fn = (psci_initcall_t)matched_np->data;
+	return init_fn(np);
+}
+
+#ifdef CONFIG_ACPI
+/*
+ * We use PSCI 0.2+ when ACPI is deployed on ARM64 and it's
+ * explicitly clarified in SBBR
+ */
+int __init psci_acpi_init(void)
+{
+	if (!acpi_psci_present()) {
+		pr_info("is not implemented in ACPI.\n");
+		return -EOPNOTSUPP;
+	}
+
+	pr_info("probing for conduit method from ACPI.\n");
+
+	if (acpi_psci_use_hvc())
+		set_conduit(PSCI_CONDUIT_HVC);
+	else
+		set_conduit(PSCI_CONDUIT_SMC);
+
+	return psci_probe();
+}
+#endif
diff --git a/drivers/soc/realtek/rtd13xx/rtd13xx_spin_table.c b/drivers/soc/realtek/rtd13xx/rtd13xx_spin_table.c
new file mode 100644
index 00000000..073a69d
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtd13xx_spin_table.c
@@ -0,0 +1,179 @@
+/*
+ * rtd13xx_spin_table.c - boot method
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/delay.h>
+#include <linux/init.h>
+#include <linux/of.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/delay.h>
+#include <linux/printk.h>
+#include <linux/arm-smccc.h>
+#include <asm/io.h>
+#include <asm/cacheflush.h>
+#include <asm/cpu_ops.h>
+#include <asm/cputype.h>
+#include <asm/io.h>
+#include <asm/smp_plat.h>
+
+#include "rtd13xx_cpu_hotplug.h"
+
+#define BL31_CMD 0x8400ff04
+#define BL31_DAT 0x00001319
+
+#ifdef CONFIG_SMP
+
+extern void _rtk_cpu_power_up(int cpu);
+extern void secondary_holding_pen(void);
+
+volatile unsigned long rtk_secondary_holding_pen_release = INVALID_HWID;
+
+static phys_addr_t cpu_release_addr[NR_CPUS];
+static int cpu_hotplug[NR_CPUS] = {0};
+/*
+ * Write rtk_secondary_holding_pen_release in a way that is guaranteed to be
+ * visible to all observers, irrespective of whether they're taking part
+ * in coherency or not.  This is necessary for the hotplug code to work
+ * reliably.
+ */
+static void write_pen_release(u64 val)
+{
+	void *start = (void *)&rtk_secondary_holding_pen_release;
+	unsigned long size = sizeof(rtk_secondary_holding_pen_release);
+
+	rtk_secondary_holding_pen_release = val;
+	__flush_dcache_area(start, size);
+}
+
+static int smp_spin_table_cpu_init(unsigned int cpu)
+{
+
+	struct device_node *dn;
+
+	dn = of_get_cpu_node(cpu, NULL);
+	if (!dn)
+		return -ENODEV;
+
+	/*
+	 * Determine the address from which the CPU is polling.
+	 */
+
+	if(of_property_read_u64(dn, "cpu-release-addr", &cpu_release_addr[cpu])){
+		pr_err("CPU %d: missing or invalid cpu-release-addr property\n", cpu);
+		return -1;
+	}
+
+	return 0;
+}
+
+static int smp_spin_table_cpu_prepare(unsigned int cpu)
+{
+	__le64 __iomem *release_addr;
+
+	/*
+	 * The cpu-release-addr may or may not be inside the linear mapping.
+	 * As ioremap_cache will either give us a new mapping or reuse the
+	 * existing linear mapping, we can use it to cover both cases. In
+	 * either case the memory will be MT_NORMAL.
+	 */
+
+	release_addr = ioremap(cpu_release_addr[cpu], sizeof(*release_addr));
+
+	if (!release_addr)
+		return -ENOMEM;
+
+	/*
+	 * We write the release address as LE regardless of the native
+	 * endianess of the kernel. Therefore, any boot-loaders that
+	 * read this address need to convert this address to the
+	 * boot-loader's endianess before jumping. This is mandated by
+	 * the boot protocol.
+	 */
+	writel_relaxed(__pa(secondary_holding_pen), release_addr);
+
+	__flush_dcache_area((__force void *)release_addr, sizeof(*release_addr));
+
+	/*
+	 * Send an event to wake up the secondary CPU.
+	 */
+	sev();
+
+	iounmap(release_addr);
+
+	return 0;
+}
+
+static int smp_spin_table_cpu_boot(unsigned int cpu)
+{
+	if(cpu_hotplug[cpu] == 1){
+		__le64 __iomem *release_addr;
+		release_addr = ioremap(cpu_release_addr[cpu], sizeof(*release_addr));
+		writel_relaxed(__pa(secondary_holding_pen), release_addr);
+
+		__flush_dcache_area((__force void *)release_addr, sizeof(*release_addr));
+
+		smp_send_reschedule(cpu);
+		iounmap(release_addr);
+	}
+
+	/*
+	 * Update the pen release flag.
+	 */
+	write_pen_release(cpu_logical_map(cpu));
+
+	/*
+	 * Send an event, causing the secondaries to read pen_release.
+	 */
+
+	sev();
+	return 0;
+}
+
+#ifdef CONFIG_HOTPLUG_CPU
+static int smp_spin_table_cpu_disable(unsigned int cpu)
+{
+	if (!cpu_release_addr[cpu])
+		return -EOPNOTSUPP;
+
+	return 0;
+}
+
+static void smp_spin_table_cpu_die(unsigned int cpu)
+{
+	struct arm_smccc_res res;
+
+	/* notify BL31 cpu hotplug */
+	arm_smccc_smc(BL31_CMD, BL31_DAT, 0, 0, 0, 0, 0, 0, &res);
+	cpu_hotplug[cpu] = 1;
+	cpu_do_lowpower(cpu_release_addr[cpu]);
+}
+#endif
+
+const struct cpu_operations rtk_smp_spin_table_ops = {
+	.name = "rtk-spin-table",
+	.cpu_init = smp_spin_table_cpu_init,
+	.cpu_prepare = smp_spin_table_cpu_prepare,
+	.cpu_boot = smp_spin_table_cpu_boot,
+#ifdef CONFIG_HOTPLUG_CPU
+	.cpu_disable = smp_spin_table_cpu_disable,
+	.cpu_die = smp_spin_table_cpu_die,
+#endif
+};
+
+#endif /* CONFIG_SMP */
diff --git a/drivers/soc/realtek/rtd13xx/rtd13xx_suspend.c b/drivers/soc/realtek/rtd13xx/rtd13xx_suspend.c
new file mode 100755
index 00000000..0b77e5f
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtd13xx_suspend.c
@@ -0,0 +1,484 @@
+/*
+ * rtd13xx_suspend.c - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/pm.h>
+#include <linux/suspend.h>
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/cpu.h>
+#include <linux/delay.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/reboot.h>
+#include <linux/clocksource.h>
+#include <linux/clockchips.h>
+#include <linux/cpu_pm.h>
+#include <linux/vmalloc.h>
+#include <linux/tick.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/irqchip/arm-gic.h>
+#include <linux/psci.h>
+#include <linux/cpumask.h>
+#include <asm/system_misc.h>
+#include <asm/cacheflush.h>
+#include <asm/suspend.h>
+#include <soc/realtek/memory.h>
+#include <uapi/linux/psci.h>
+#include <soc/realtek/rtk_rstctl.h>
+
+#include "rtd13xx_suspend.h"
+
+#define DEV "RTD13xx_PM"
+#define SUSPEND_VERSION_MASK(v) ((v&0xffff) << 16)
+#define RTK_PM_DEBUG 1
+#define RTK_DDR_CALIBRATION 0
+
+unsigned int wakeup_source = 0;
+
+static int suspend_version = 2;
+extern unsigned int suspend_context;
+
+void __iomem *RTK_CRT_BASE;
+void __iomem *RTK_ISO_BASE;
+void __iomem *RTK_SB2_BASE;
+void __iomem *RTK_RSTCTRL_BASE;
+
+extern void rtk_cpu_power_down(int cpu);
+extern void rtk_cpu_power_up(int cpu);
+extern void rtk_ddr_calibration_save(void); /* save ddr rx calibration */
+extern void rtk_ddr_calibration_restore(void); /* restore ddr rx calibration */
+extern void psci_sys_reset(enum reboot_mode reboot_mode, const char *cmd);
+extern void psci_sys_poweroff(void);
+extern int psci_system_suspend(unsigned long wakeup_source);
+extern void memory_check_begin(void);
+extern void memory_check_end(void);
+extern void hexdump(char *note, unsigned char *buf, unsigned int len);
+#ifdef CONFIG_RTK_WATCHDOG
+extern int set_wdt_oe(void);
+#else
+static inline int set_wdt_oe(void) { return 0; }
+#endif
+
+struct suspend_param *pcpu_data;
+struct ipc_shm_irda pcpu_data_irda;
+
+extern char wu_en[SUSPEND_ISO_GPIO_SIZE];
+extern char wu_act[SUSPEND_ISO_GPIO_SIZE];
+
+static unsigned int rtk_acpu_check_rpc_flag(void);
+
+static unsigned int rtk_acpu_check_rpc_flag(void)
+{
+	unsigned int i = 0;
+	unsigned int ret = 0;
+
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	for (i = 0 ; i < 1000; i++) {
+		if (readl(&(ipc->audio_rpc_flag)) == 0) {
+			ret = 1;
+			break;
+		}
+		mdelay(1);
+	}
+
+	return ret;
+}
+
+static void rtk_acpu_set_flag(uint32_t flag)
+{
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	writel(__cpu_to_be32(SUSPEND_VERSION_MASK(suspend_version)),
+		&(ipc->suspend_mask));
+
+	if (suspend_version == 1)
+		writel(__cpu_to_be32(flag), &(ipc->suspend_flag));
+	else
+		writel(__cpu_to_be32(flag | AUTHOR_MASK(AUTHOR_SCPU)),
+			&(ipc->suspend_flag));
+}
+
+static void rtk_notify_acpu(enum _notify_flag flag)
+{
+	pr_info("[%s] Notify ACPU, flag= %d\n", DEV, flag);
+
+	switch (flag) {
+	case NOTIFY_SUSPEND_TO_RAM:
+	case NOTIFY_SUSPEND_TO_COOLBOOT:
+	case NOTIFY_SUSPEND_TO_WFI:
+		if (suspend_version == 1) {
+			rtk_acpu_set_flag(0x000018ff);
+			return;
+		}
+		break;
+	case NOTIFY_RESUME_PLATFORM:
+		if (suspend_version == 1) {
+			rtk_acpu_set_flag(0x00000000);
+			return;
+		}
+		break;
+	default:
+		if (suspend_version == 1)
+			return;
+		break;
+	}
+
+	rtk_acpu_set_flag(NOTIFY_MASK(flag));
+}
+
+static int rtk_suspend_wakeup_acpu(void)
+{
+	pr_info("[%s] Wakeup ACPU\n", DEV);
+
+	writel(0x00000000, RTK_SB2_BASE + 0x138);
+	__delay(1000);
+	writel(0x00000008, RTK_CRT_BASE + 0x328);
+	writel(0x0000ace7, RTK_CRT_BASE + 0x320);
+	writel(0x0000000c, RTK_CRT_BASE + 0x328);
+	__delay(1000);
+
+	return 0;
+}
+
+#if defined(CONFIG_THOR_PM_WORKARURD)
+extern void __iomem *wdt_base_export;
+#endif /* CONFIG_THOR_PM_WORKARURD */
+
+static void setup_restart_action(RESET_ACTION action)
+{
+	unsigned int reset_action = RESET_MAGIC;
+
+	if (!RTK_RSTCTRL_BASE) {
+		pr_err("%s: Skip set reset action\n", __func__);
+		return;
+	}
+
+	reset_action |= action;
+	writel(reset_action, RTK_RSTCTRL_BASE);
+}
+
+static void rtk_sys_reset(enum reboot_mode reboot_mode, const char *cmd)
+{
+	if (cmd) {
+		set_wdt_oe();
+
+		if (!strncmp("bootloader", cmd, 11)) {
+			setup_restart_action(RESET_ACTION_FASTBOOT);
+		} else if (!strncmp("recovery", cmd, 9)) {
+			setup_restart_action(RESET_ACTION_RECOVERY);
+		} else {
+			setup_restart_action(RESET_ACTION_NO_ACTION);
+		}
+	} else {
+		setup_restart_action(RESET_ACTION_NO_ACTION);
+	}
+
+	pr_info("[%s] Power reset\n", DEV);
+#if defined(CONFIG_THOR_PM_WORKARURD)
+	writel(0xA5, wdt_base_export + 0x0);
+	writel(0x01, wdt_base_export + 0x4);
+	writel(0x0, wdt_base_export + 0xC);
+	writel(0xFF, wdt_base_export + 0x0);
+#else
+	rtk_notify_acpu(NOTIFY_SUSPEND_TO_COOLBOOT);
+	psci_sys_reset(reboot_mode, cmd);
+#endif /* CONFIG_THOR_PM_WORKARURD */
+};
+
+static void rtk_set_pm_param(unsigned long pcpu_data)
+{
+#if defined(CONFIG_CPU_V7)
+	asm volatile(".arch_extension sec" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("mov r1, %0" : : "r" (__pa(pcpu_data)) : "cc");
+	asm volatile("ldr r0, =0x8400ff04" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+#else
+	asm volatile("isb" : : : "cc");
+	asm volatile("mov x1, %0" : : "r" (__pa(pcpu_data)) : "cc");
+	asm volatile("ldr x0, =0x8400ff04" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+#endif /* CONFIG_CPU_V7 */
+}
+
+static void rtk_power_off(void)
+{
+	int i = 0;
+
+	pr_info("[%s] Power off\n", DEV);
+
+	rtk_notify_acpu(NOTIFY_SUSPEND_TO_COOLBOOT);
+
+	pcpu_data->wakeup_source = htonl(pcpu_data->wakeup_source);
+	pcpu_data->timerout_val = htonl(pcpu_data->timerout_val);
+	pcpu_data->irda_info.dev_count = pcpu_data_irda.dev_count;
+	pcpu_data->irda_info.ipc_shm_ir_magic = pcpu_data_irda.ipc_shm_ir_magic;
+
+	for (i = 0 ; i< 5; i++) {
+		pcpu_data->irda_info.key_tbl[i].protocol = pcpu_data_irda.key_tbl[i].protocol;
+		pcpu_data->irda_info.key_tbl[i].scancode_mask = pcpu_data_irda.key_tbl[i].scancode_mask;
+		pcpu_data->irda_info.key_tbl[i].wakeup_scancode = pcpu_data_irda.key_tbl[i].wakeup_scancode;
+		pcpu_data->irda_info.key_tbl[i].cus_mask = pcpu_data_irda.key_tbl[i].cus_mask;
+		pcpu_data->irda_info.key_tbl[i].cus_code = pcpu_data_irda.key_tbl[i].cus_code;
+	}
+
+	pr_info("[%s] wakeup flags = 0x%x\n", DEV, pcpu_data->wakeup_source);
+
+	flush_cache_all();
+
+	rtk_set_pm_param((unsigned long) pcpu_data);
+
+	psci_sys_poweroff();
+};
+
+static int rtk_suspend_standby(unsigned long unused)
+{
+	/*
+	 * Todo:
+	 * define PSCI command: S1 mode
+	 */
+	return 0;
+}
+
+static int rtk_suspend_mem(unsigned long pcpu_data)
+{
+#if RTK_PM_DEBUG
+
+	struct suspend_param *tmp = (struct suspend_param *) pcpu_data;
+
+	pr_info("wakeup flags = 0x%x\n", tmp->wakeup_source);
+
+	pr_info("[%s] pcpu_data vaddr: 0x%08lx paddr: 0x%08lx\n",
+		DEV, (unsigned long)pcpu_data,
+		(unsigned long)__pa(pcpu_data));
+
+	hexdump("pcpu_data Dump:",
+		(unsigned char *) pcpu_data, sizeof(struct suspend_param));
+
+	pr_info("[%s] CPU Resume vaddr: 0x%08lx paddr: 0x%08lx\n",
+		DEV, (unsigned long)cpu_resume,
+		(unsigned long)__pa(cpu_resume));
+
+	hexdump("CPU Resume Entry Dump:",
+		(unsigned char *) cpu_resume, 0x100);
+
+#endif /* RTK_PM_DEBUG */
+
+	flush_cache_all();
+
+	return psci_system_suspend(__pa(pcpu_data));
+}
+
+static void rtk_suspend_cpu_pwr_down(void) {
+	unsigned int cpu = 1;
+
+	for (cpu = 1 ; cpu < NR_CPUS ; cpu++) {
+		rtk_cpu_power_down(cpu);
+	}
+}
+
+static void rtk_suspend_cpu_pwr_up(void) {
+	unsigned int cpu = 1;
+
+	for (cpu = 1 ; cpu < NR_CPUS ; cpu++) {
+		rtk_cpu_power_up(cpu);
+	}
+}
+
+static int rtk_suspend_enter(suspend_state_t state)
+{
+	int ret = 0;
+	int i = 0;
+
+	rtk_suspend_cpu_pwr_down();
+
+	switch (state) {
+	case PM_SUSPEND_STANDBY:
+		rtk_notify_acpu(NOTIFY_SUSPEND_TO_WFI);
+		cpu_suspend(0, rtk_suspend_standby);
+		break;
+	case PM_SUSPEND_MEM:
+		rtk_notify_acpu(NOTIFY_SUSPEND_TO_RAM);
+
+		if (!rtk_acpu_check_rpc_flag()) {
+			pr_err("[%s] ACPU FW not ready to suspend !\n", DEV);
+			ret = -EINVAL;
+			break;
+		}
+
+		pcpu_data->wakeup_source = htonl(pcpu_data->wakeup_source);
+		pcpu_data->timerout_val = htonl(pcpu_data->timerout_val);
+		pcpu_data->irda_info.dev_count = pcpu_data_irda.dev_count;
+		pcpu_data->irda_info.ipc_shm_ir_magic = pcpu_data_irda.ipc_shm_ir_magic;
+
+		for (i = 0 ; i< 5; i++) {
+			pcpu_data->irda_info.key_tbl[i].protocol = pcpu_data_irda.key_tbl[i].protocol;
+			pcpu_data->irda_info.key_tbl[i].scancode_mask = pcpu_data_irda.key_tbl[i].scancode_mask;
+			pcpu_data->irda_info.key_tbl[i].wakeup_scancode = pcpu_data_irda.key_tbl[i].wakeup_scancode;
+			pcpu_data->irda_info.key_tbl[i].cus_mask = pcpu_data_irda.key_tbl[i].cus_mask;
+			pcpu_data->irda_info.key_tbl[i].cus_code = pcpu_data_irda.key_tbl[i].cus_code;
+		}
+
+		pr_info("[%s] wakeup flags = 0x%x\n", DEV, pcpu_data->wakeup_source);
+		cpu_suspend((unsigned long) pcpu_data, rtk_suspend_mem);
+		break;
+	default:
+		ret = -EINVAL;
+		break;
+	}
+
+	/* restore original value */
+	pcpu_data->wakeup_source = htonl(pcpu_data->wakeup_source);
+	pcpu_data->timerout_val = htonl(pcpu_data->timerout_val);
+
+#if RTK_PM_DEBUG
+	memory_check_end();
+#endif /* RTK_PM_DEBUG */
+
+#if RTK_DDR_CALIBRATION
+	rtk_ddr_calibration_restore();
+#endif /* RTK_DDR_CALIBRATION */
+
+	/* Enable ACPU clock*/
+	writel(readl(RTK_CRT_BASE + 0x58) | 0x000000C0, RTK_CRT_BASE + 0x58);
+
+	writel(readl(RTK_ISO_BASE + 0x0418) | BIT(0), RTK_ISO_BASE + 0x0418);
+	writel(readl(RTK_ISO_BASE + 0x0410) & ~BIT(10), RTK_ISO_BASE + 0x0410);
+
+	rtk_suspend_cpu_pwr_up();
+
+	return ret;
+}
+
+static int rtk_suspend_valid(suspend_state_t state)
+{
+	return state == PM_SUSPEND_MEM || state == PM_SUSPEND_STANDBY;
+}
+
+static int rtk_suspend_begin(suspend_state_t suspend_state)
+{
+	int ret = 0;
+	int i = 0;
+
+	pr_info("[%s] Suspend Begin\n", DEV);
+
+	for(i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++){
+		pcpu_data->wu_gpio_en[i] = wu_en[i];
+		pcpu_data->wu_gpio_act[i] = wu_act[i];
+	}
+
+#if RTK_PM_DEBUG
+	memory_check_begin();
+#endif /* RTK_PM_DEBUG */
+
+#if RTK_DDR_CALIBRATION
+	rtk_ddr_calibration_save();
+#endif /* RTK_DDR_CALIBRATION */
+
+	cpu_idle_poll_ctrl(true);
+
+	return ret;
+}
+
+static void rtk_suspend_wake(void)
+{
+	pr_info("[%s] Platform Wake\n", DEV);
+
+	rtk_suspend_wakeup_acpu();
+
+	suspend_context++;
+
+	rtk_notify_acpu(NOTIFY_RESUME_PLATFORM);
+}
+
+static void rtk_suspend_end(void)
+{
+	pr_info("[%s] Suspend End\n", DEV);
+
+	rtk_notify_acpu(NOTIFY_RESUME_END);
+
+	cpu_idle_poll_ctrl(false);
+}
+
+const struct platform_suspend_ops rtk_suspend_ops = {
+	.begin = rtk_suspend_begin,
+	.end = rtk_suspend_end,
+	.enter = rtk_suspend_enter,
+	.valid = rtk_suspend_valid,
+	.wake = rtk_suspend_wake,
+};
+
+int __init rtk_suspend_init(void)
+{
+	struct device_node *pm_nd = NULL;
+	 struct device_node *rstctl_nd = NULL;
+	const u32 *prop;
+	int size;
+	int i = 0;
+
+	pr_info("[%s] Initial Power Management\n", DEV);
+
+	pcpu_data = kzalloc(sizeof(struct suspend_param), GFP_KERNEL);
+
+	for(i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++){
+		pcpu_data->wu_gpio_en[i] = wu_en[i];
+		pcpu_data->wu_gpio_act[i] = wu_act[i];
+	}
+
+	pm_nd = of_find_compatible_node(NULL, NULL, "realtek,pm");
+
+	RTK_CRT_BASE = of_iomap(pm_nd, 0);
+	RTK_ISO_BASE = of_iomap(pm_nd, 1);
+	RTK_SB2_BASE = of_iomap(pm_nd, 2);
+
+	if (pm_nd && of_device_is_available(pm_nd)) {
+		/* Wakeup Flags */
+		prop = of_get_property(pm_nd, "wakeup-flags", &size);
+		wakeup_source = of_read_number(prop, 1);
+		if (wakeup_source < 0) {
+			pr_err("[%s] wakeup flags set default value!\n", DEV);
+			pcpu_data->wakeup_source = fWAKEUP_ON_IR |
+					fWAKEUP_ON_GPIO | fWAKEUP_ON_ALARM |
+					fWAKEUP_ON_CEC;
+		} else {
+			pcpu_data->wakeup_source = wakeup_source;
+		}
+
+		pr_info("[%s] wakeup flags = 0x%x\n", DEV, pcpu_data->wakeup_source);
+	}
+
+	rtk_acpu_set_flag(0x00000000);
+	suspend_set_ops(&rtk_suspend_ops);
+	pm_power_off = rtk_power_off;
+	arm_pm_restart = rtk_sys_reset;
+
+	/* setup Reset Control */
+	rstctl_nd = of_find_compatible_node(NULL, NULL, "Realtek,rtk-rstctrl");
+	if (rstctl_nd) {
+		RTK_RSTCTRL_BASE = of_iomap(rstctl_nd, 0);
+		pr_info("[rstctrl] addr 0x%p\n", RTK_RSTCTRL_BASE);
+		setup_restart_action(RESET_ACTION_ABNORMAL);
+	}
+
+	return 0;
+}
+
+subsys_initcall(rtk_suspend_init);
diff --git a/drivers/soc/realtek/rtd13xx/rtd13xx_suspend.h b/drivers/soc/realtek/rtd13xx/rtd13xx_suspend.h
new file mode 100644
index 00000000..2d4fafb
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtd13xx_suspend.h
@@ -0,0 +1,131 @@
+/*
+ * rtd13xx_suspend.h - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef RTD13XX_SUSPEND_H_
+#define RTD13XX_SUSPEND_H_
+
+#include <soc/realtek/rtk_ipc_shm.h>
+#include <soc/realtek/rtk_pm.h>
+#include <soc/realtek/rtk_ir.h>
+
+#define SETMASK(bits, pos) (((-1U) >> (32-bits)) << (pos))
+#define CLRMASK(bits, pos) (~(SETMASK(bits, pos)))
+#define SET_VAL(val,bits,pos) ((val << pos) & SETMASK(bits, pos))
+#define GET_VAL(reg,bits,pos) ((reg & SETMASK(bits, pos)) >> pos)
+
+#define AUTHOR_SHIFFT 30
+#define AUTHOR_BITS 2
+#define AUTHOR_MASK(val) SET_VAL(val,AUTHOR_BITS,AUTHOR_SHIFFT)
+#define AUTHOR_GET(reg) GET_VAL(reg,AUTHOR_BITS,AUTHOR_SHIFFT)
+#define AUTHOR_IS_SCPU(reg) (AUTHOR_GET(reg) == AUTHOR_SCPU)
+#define AUTHOR_IS_ACPU(reg) (AUTHOR_GET(reg) == AUTHOR_ACPU)
+
+#define NOTIFY_SHIFFT 0
+#define NOTIFY_BITS 8
+#define NOTIFY_MASK(val) SET_VAL(val,NOTIFY_BITS,NOTIFY_SHIFFT)
+#define NOTIFY_GET(reg) GET_VAL(reg,NOTIFY_BITS,NOTIFY_SHIFFT)
+
+#define SUSPEND_ISO_GPIO_BASE 0
+#define SUSPEND_ISO_GPIO_SIZE 82
+
+#define SUSPEND_MAGIC_KEY 0xEA
+#define SUSPEND_MAGIC_SHIFFT 24
+#define SUSPEND_MAGIC_BITS 8
+#define SUSPEND_MAGIC_MASK (SUSPEND_MAGIC_KEY << SUSPEND_MAGIC_SHIFFT)
+#define SUSPEND_MAGIC_GET(val) GET_VAL(val, 8, 24)
+
+#define WAKEUP_FLAGS_SHIFFT	 0
+#define WAKEUP_FLAGS_BITS (eWAKEUP_ON_MAX)
+#define WAKEUP_FLAGS_MASK(val) SET_VAL(val, WAKEUP_FLAGS_BITS, WAKEUP_FLAGS_SHIFFT)
+#define WAKEUP_FLAGS_GET(reg) GET_VAL(reg, WAKEUP_FLAGS_BITS, WAKEUP_FLAGS_SHIFFT)
+
+#define RESUME_STATE_SHIFFT 16
+#define RESUME_STATE_BITS 8
+#define RESUME_STATE_MASK(val) SET_VAL(val, RESUME_STATE_BITS, RESUME_STATE_SHIFFT)
+#define RESUME_STATE_GET(reg) GET_VAL(reg, RESUME_STATE_BITS, RESUME_STATE_SHIFFT)
+
+#define RESUME_DATA_SHIFFT 0
+#define RESUME_DATA_BITS 16
+#define RESUME_DATA_MASK(val) SET_VAL(val, RESUME_DATA_BITS, RESUME_DATA_SHIFFT)
+#define RESUME_DATA_GET(reg) GET_VAL(reg, RESUME_DATA_BITS, RESUME_DATA_SHIFFT)
+
+#define AUDIO_RECIPROCAL_TIMER_SHIFFT 0
+#define AUDIO_RECIPROCAL_TIMER_BITS 24
+#define AUDIO_RECIPROCAL_TIMER_MASK(val) SET_VAL(val, AUDIO_RECIPROCAL_TIMER_BITS, AUDIO_RECIPROCAL_TIMER_SHIFFT)
+#define AUDIO_RECIPROCAL_TIMER_GET(reg) GET_VAL(reg, AUDIO_RECIPROCAL_TIMER_BITS, AUDIO_RECIPROCAL_TIMER_SHIFFT)
+
+enum {
+	AUTHOR_SCPU = 0x1,
+	AUTHOR_ACPU,
+};
+
+enum _notify_flag{
+	NOTIFY_NONE,
+	NOTIFY_SUSPEND_TO_RAM = 0x01,
+	NOTIFY_SUSPEND_TO_COOLBOOT,
+	NOTIFY_SUSPEND_TO_WFI,
+
+	NOTIFY_RESUME_PLATFORM = 0x10,
+	NOTIFY_RESUME_END,
+	NOTIFY_SCPU_READY,
+	NOTIFY_ACPU_READY,
+};
+
+enum _suspend_mode {
+	SUSPEND_TO_RAM,
+	SUSPEND_TO_COOLBOOT,
+	SUSPEND_TO_WFI,
+	MAX_SUSPEND_MODE,
+};
+
+enum _suspend_wakeup {
+	eWAKEUP_ON_LAN,
+	eWAKEUP_ON_IR,
+	eWAKEUP_ON_GPIO,
+	eWAKEUP_ON_ALARM,
+	eWAKEUP_ON_TIMER,
+	eWAKEUP_ON_CEC,
+	eWAKEUP_ON_MAX,
+};
+
+enum _wakeup_flags {
+	fWAKEUP_ON_LAN = 0x1U << eWAKEUP_ON_LAN,
+	fWAKEUP_ON_IR = 0x1U << eWAKEUP_ON_IR,
+	fWAKEUP_ON_GPIO = 0x1U << eWAKEUP_ON_GPIO,
+	fWAKEUP_ON_ALARM = 0x1U << eWAKEUP_ON_ALARM,
+	fWAKEUP_ON_TIMER = 0x1U << eWAKEUP_ON_TIMER,
+	fWAKEUP_ON_CEC = 0x1U << eWAKEUP_ON_CEC,
+};
+
+enum _RESUME_STATE {
+	RESUME_NONE	 = 0,
+	RESUME_UNKNOW,
+	RESUME_IR,
+	RESUME_GPIO,
+	RESUME_LAN,
+	RESUME_ALARM,
+	RESUME_TIMER,
+	RESUME_CEC,
+	RESUME_MAX_STATE,
+};
+
+struct suspend_param {
+	unsigned int wakeup_source;
+	unsigned int timerout_val;
+	char wu_gpio_en[SUSPEND_ISO_GPIO_SIZE];
+	char wu_gpio_act[SUSPEND_ISO_GPIO_SIZE];
+	struct ipc_shm_irda irda_info;
+}__attribute__((packed));
+
+extern const char *const rtk_suspend_resume_states[RESUME_MAX_STATE];
+extern const char *const rtk_suspend_wakeup_states[eWAKEUP_ON_MAX];
+extern const char *const rtk_suspend_states[MAX_SUSPEND_MODE];
+
+#endif /* RTD13XX_SUSPEND_H_ */
diff --git a/drivers/soc/realtek/rtd13xx/rtd13xx_suspend_fs.c b/drivers/soc/realtek/rtd13xx/rtd13xx_suspend_fs.c
new file mode 100644
index 00000000..c833377
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtd13xx_suspend_fs.c
@@ -0,0 +1,339 @@
+/*
+ * rtd13xx_suspend_fs.c - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/device.h>
+#include <linux/pm.h>
+#include <linux/suspend.h>
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/cpu.h>
+#include <linux/delay.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/reboot.h>
+#include <linux/clocksource.h>
+#include <linux/clockchips.h>
+#include <linux/cpu_pm.h>
+#include <linux/vmalloc.h>
+#include <linux/tick.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/irqchip/arm-gic.h>
+#include <linux/psci.h>
+#include <asm/system_misc.h>
+#include <asm/cacheflush.h>
+#include <asm/suspend.h>
+#include <soc/realtek/memory.h>
+#include <uapi/linux/psci.h>
+
+#include "rtd13xx_suspend.h"
+
+unsigned int suspend_context;
+unsigned int pm_state;
+
+/*
+wakelock count mode:
+0: original mode
+1: deep sleep mode
+*/
+unsigned int pm_wakelock_mode;
+/**
+ * some sync mechanism between kernel suspend
+ * and android wakelock control
+ */
+unsigned int pm_block_wakelock;
+extern struct suspend_param *pcpu_data;
+extern struct kobj_attribute rtk_suspend_gpio_wakeup_en_attr;
+extern struct kobj_attribute rtk_suspend_gpio_wakeup_act_attr;
+extern struct kobj_attribute rtk_suspend_gpio_out_en_attr;
+extern struct kobj_attribute rtk_suspend_gpio_out_act_attr;
+
+const char *const rtk_suspend_wakeup_states[eWAKEUP_ON_MAX] = {
+	[eWAKEUP_ON_LAN] = "lan",
+	[eWAKEUP_ON_IR] = "ir",
+	[eWAKEUP_ON_GPIO] = "gpio",
+	[eWAKEUP_ON_ALARM] = "alarm",
+	[eWAKEUP_ON_TIMER] = "timer",
+	[eWAKEUP_ON_CEC] = "cec",
+};
+
+const char *const rtk_suspend_resume_states[RESUME_MAX_STATE] = {
+	[RESUME_NONE] = "none",
+	[RESUME_UNKNOW] = "unknow",
+	[RESUME_IR] = "ir",
+	[RESUME_GPIO] = "gpio",
+	[RESUME_LAN] = "lan",
+	[RESUME_ALARM] = "alarm",
+	[RESUME_TIMER] = "timer",
+	[RESUME_CEC] = "cec",
+};
+
+const char *const rtk_suspend_states[MAX_SUSPEND_MODE] = {
+	[SUSPEND_TO_RAM] = "ram",
+	[SUSPEND_TO_COOLBOOT] = "coolboot",
+	[SUSPEND_TO_WFI] = "wfi",
+};
+
+#define RTK_SUSPEND_ATTR(_name) \
+{ \
+	.attr = {.name = #_name, .mode = 0644}, \
+	.show =  rtk_suspend_##_name##_show, \
+	.store = rtk_suspend_##_name##_store, \
+}
+
+static enum _suspend_wakeup rtk_suspend_decode_wakeup(const char *buf,
+	size_t n)
+{
+	const char *const *s;
+	char *p;
+	int len;
+	int i;
+
+	p = memchr(buf, '\n', n);
+	len = p ? p - buf : n;
+
+	for (i = 0 ; i < eWAKEUP_ON_MAX ; i++) {
+		s = &rtk_suspend_wakeup_states[i];
+		if (*s && len == strlen(*s) && !strncmp(buf, *s, len))
+			return i;
+	}
+
+	return eWAKEUP_ON_MAX;
+}
+
+static ssize_t rtk_suspend_wakeup_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val = pcpu_data->wakeup_source;
+
+	for (i = 0 ; i < eWAKEUP_ON_MAX ; i++) {
+
+		if (val & (0x1U << i))
+			n += sprintf(buf + n, " * ");
+		else
+			n += sprintf(buf + n, "   ");
+		n += sprintf(buf + n, "%s\n", rtk_suspend_wakeup_states[i]);
+	}
+	n += sprintf(buf + n, "\n");
+	return n;
+}
+
+static ssize_t rtk_suspend_wakeup_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	enum _suspend_wakeup wakeup = rtk_suspend_decode_wakeup(buf, count);
+
+	if (wakeup < eWAKEUP_ON_MAX) {
+		pcpu_data->wakeup_source ^= (0x1U << wakeup);
+		return count;
+	}
+	return -ENOMEM;
+}
+
+static ssize_t rtk_suspend_timer_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	return sprintf(buf, " %d sec (reciprocal timer)\n",
+		pcpu_data->timerout_val);
+}
+
+static ssize_t rtk_suspend_timer_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val > (AUDIO_RECIPROCAL_TIMER_GET(-1UL)))
+		return -ENOMEM;
+
+	pcpu_data->timerout_val = val;
+	return count;
+}
+
+static ssize_t rtk_suspend_context_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	return sprintf(buf, "%d\n", suspend_context);
+}
+
+static ssize_t rtk_suspend_context_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	suspend_context = val;
+	return count;
+}
+
+static struct kobj_attribute rtk_suspend_wakeup_attr =
+	RTK_SUSPEND_ATTR(wakeup);
+static struct kobj_attribute rtk_suspend_timer_attr =
+	RTK_SUSPEND_ATTR(timer);
+static struct kobj_attribute rtk_suspend_context_attr =
+	RTK_SUSPEND_ATTR(context);
+
+static struct attribute *rtk_suspend_attrs[] = {
+	&rtk_suspend_wakeup_attr.attr,
+	&rtk_suspend_timer_attr.attr,
+	&rtk_suspend_context_attr.attr,
+	&rtk_suspend_gpio_wakeup_en_attr.attr,
+	&rtk_suspend_gpio_wakeup_act_attr.attr,
+	&rtk_suspend_gpio_out_en_attr.attr,
+	&rtk_suspend_gpio_out_act_attr.attr,
+	NULL,
+};
+
+static struct attribute_group rtk_suspend_attr_group = {
+	.attrs = rtk_suspend_attrs,
+};
+
+static struct kobject *rtk_suspend_kobj;
+
+static ssize_t pm_state_show(struct device *dev, struct device_attribute *attr,
+	char *buf)
+{
+	return sprintf(buf, "%d\n", pm_state);
+}
+
+static ssize_t pm_state_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_state = val;
+
+	return count;;
+}
+
+static ssize_t pm_wakelock_mode_show(struct device *dev, struct device_attribute *attr,
+	char *buf)
+{
+	return sprintf(buf, "%d\n", pm_wakelock_mode);
+}
+
+static ssize_t pm_wakelock_mode_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_wakelock_mode = val;
+
+	return count;;
+}
+
+static ssize_t pm_block_wakelock_show(
+    struct device *dev,
+    struct device_attribute *attr,
+    char *buf)
+{
+	return sprintf(buf, "%d\n", pm_block_wakelock);
+}
+
+static ssize_t pm_block_wakelock_store(
+    struct device *dev,
+    struct device_attribute *attr,
+    const char *buf,
+    size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_block_wakelock = val;
+
+	return count;;
+}
+
+static struct device_attribute pm_state_attr =
+	__ATTR(pm_state, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_state_show, pm_state_store);
+
+static struct device_attribute pm_wakelock_mode_attr =
+	__ATTR(pm_wakelock_mode, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_wakelock_mode_show, pm_wakelock_mode_store);
+
+static struct device_attribute pm_block_wakelock_attr =
+	__ATTR(pm_block_wakelock, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_block_wakelock_show, pm_block_wakelock_store);
+
+struct class *rtk_pm_class;
+struct device *rtk_pm_dev;
+
+static int __init suspend_sysfs_init(void)
+{
+	int ret;
+
+	pcpu_data->timerout_val = 0;
+	pm_state = 0;
+	pm_wakelock_mode = 0;
+    pm_block_wakelock = 0;
+
+	rtk_pm_class = class_create(THIS_MODULE, "rtk_pm");
+	if (IS_ERR(rtk_pm_class))
+		return PTR_ERR(rtk_pm_class);
+
+	rtk_pm_dev =  device_create(rtk_pm_class, NULL,
+		MKDEV(0, 1), NULL, "android_control");
+	if (IS_ERR(rtk_pm_dev))
+		return PTR_ERR(rtk_pm_dev);
+
+	ret = device_create_file(rtk_pm_dev, &pm_state_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	ret = device_create_file(rtk_pm_dev, &pm_wakelock_mode_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	ret = device_create_file(rtk_pm_dev, &pm_block_wakelock_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	rtk_suspend_kobj = kobject_create_and_add("suspend", kernel_kobj);
+	if (!rtk_suspend_kobj)
+		return -ENOMEM;
+	ret = sysfs_create_group(rtk_suspend_kobj, &rtk_suspend_attr_group);
+	if (ret)
+		kobject_put(rtk_suspend_kobj);
+	return ret;
+}
+
+module_init(suspend_sysfs_init);
diff --git a/drivers/soc/realtek/rtd13xx/rtd13xx_suspend_mem.c b/drivers/soc/realtek/rtd13xx/rtd13xx_suspend_mem.c
new file mode 100644
index 00000000..e4129aa
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtd13xx_suspend_mem.c
@@ -0,0 +1,270 @@
+/*
+ * rtd13xx_ddr_calibration.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/printk.h>
+#include <linux/delay.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/slab.h>
+#include <asm/cacheflush.h>
+
+#define MEM_VERIFIED_CNT 20
+
+void hexdump(char *note, unsigned char *buf, unsigned int len)
+{
+	pr_crit("%s\n", note);
+	print_hex_dump(KERN_CONT, "", DUMP_PREFIX_OFFSET, 16, 1, buf, len,
+		false);
+}
+EXPORT_SYMBOL(hexdump);
+
+struct _memory_verified_handle {
+	unsigned char *memAddress;
+	size_t memByte;
+};
+
+struct _memory_verified_handle phys_wb_area[] = {
+	{(unsigned char *)0x0a000000, 0x20},
+	{(unsigned char *)0x0a001000, 0x20}
+};
+
+struct _memory_verified_handle *mem_vhandle[20];
+struct _memory_verified_handle **mem_wbhandle;
+
+static unsigned char memory_verified_datagen(int i)
+{
+	return (unsigned char) (i & 0xff);
+}
+
+static struct _memory_verified_handle *memory_verified_handle_create(size_t byte)
+{
+	int i = 0;
+
+	struct _memory_verified_handle *handle =
+		(struct _memory_verified_handle *)
+		kmalloc(sizeof(struct _memory_verified_handle), GFP_KERNEL);
+
+	if (!handle)
+		return NULL;
+
+	/*
+	 * > 32KB : vmalloc
+	 * < 32KB : kmalloc
+	 */
+	if (byte > 0x8000)
+		handle->memAddress = vmalloc(byte);
+	else
+		handle->memAddress = kmalloc(byte, GFP_KERNEL);
+
+	if (!handle->memAddress) {
+		kfree(handle);
+		return NULL;
+	}
+
+	for (i = 0; i < byte ; i++)
+		handle->memAddress[i] = memory_verified_datagen(i);
+
+	handle->memByte = byte;
+
+	return handle;
+}
+
+static int memory_verified_release(struct _memory_verified_handle *handle)
+{
+	int ret = 0, i = 0;
+	unsigned char data;
+
+	if (!handle) {
+		pr_err("%s: handle is NULL !\n", __func__);
+		return -1;
+	}
+
+	if (!handle->memByte) {
+		ret = -2;
+		pr_info("%s: handle %p ", __func__, (void *) handle);
+		pr_info("(memByte = %ld, memAddress = 0x%08lx)\n",
+			(long int) handle->memByte,
+			(unsigned long) handle->memAddress);
+
+		if (handle->memAddress)
+			goto free1;
+		else
+			goto free0;
+	}
+
+	for (i = 0 ; i < handle->memByte ; i++) {
+		data = memory_verified_datagen(i);
+
+		if (handle->memAddress[i] != data) {
+			pr_info("%s: handle %p memAddress[0x%x]",
+				__func__, (void *) handle, i);
+			pr_info("=> 0x%x != 0x%x (%ld bytes at 0x%08lx)\n",
+				handle->memAddress[i], data,
+				(long int) handle->memByte,
+				(unsigned long) handle->memAddress);
+			ret = -4;
+		}
+	}
+
+	if (ret == -4) {
+		pr_err("%s: memory phyAddt 0x%08llx\n",
+			__func__, __pa(handle->memAddress));
+		hexdump("[%s] memory verified error\n",
+			handle->memAddress, handle->memByte);
+	}
+
+free1:
+	kfree(handle->memAddress);
+free0:
+	kfree(handle);
+
+	return ret;
+}
+
+static struct _memory_verified_handle *memory_writeback_handle_create(
+	struct _memory_verified_handle *phys_area)
+{
+	void *tmp_addr;
+
+	struct _memory_verified_handle *handle =
+		(struct _memory_verified_handle *)
+		kmalloc(sizeof(struct _memory_verified_handle), GFP_KERNEL);
+
+	if (!handle)
+		goto out;
+
+	handle->memAddress = kmalloc(phys_area->memByte, GFP_KERNEL);
+
+	if (!handle->memAddress) {
+		kfree(handle);
+		handle = NULL;
+		goto out;
+	}
+
+	handle->memByte = phys_area->memByte;
+	tmp_addr = phys_to_virt((phys_addr_t) phys_area->memAddress);
+	hexdump("[RTD13xx_PM] Before write back dump:",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+	memcpy(handle->memAddress, tmp_addr, phys_area->memByte);
+
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(handle->memAddress, phys_area->memByte);
+#else
+	__flush_dcache_area(handle->memAddress, phys_area->memByte);
+#endif /* CONFIG_CPU_V7 */
+
+out:
+	return handle;
+}
+
+static int memory_writeback_release(struct _memory_verified_handle *handle,
+	struct _memory_verified_handle *phys_area)
+{
+	int ret = 0;
+	void *tmp_addr;
+
+	if (!handle) {
+		ret = -1;
+		goto out;
+	}
+
+	if (!handle->memAddress) {
+		ret = -1;
+		goto free_out;
+	}
+
+	tmp_addr = phys_to_virt((phys_addr_t)phys_area->memAddress);
+	hexdump("[RTD13xx_PM] Resume back dump:**********************",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+	memcpy(tmp_addr, handle->memAddress, handle->memByte);
+
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(tmp_addr, phys_area->memByte);
+#else
+	__flush_dcache_area(tmp_addr, phys_area->memByte);
+#endif /* CONFIG_CPU_V7 */
+
+	hexdump("[RTD13xx_PM] After write back dump:",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+
+	kfree(handle->memAddress);
+
+free_out:
+	kfree(handle);
+out:
+	return ret;
+}
+
+void memory_check_begin(void)
+{
+	int i = 0;
+
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		mem_vhandle[i] = memory_verified_handle_create(0x4000);
+}
+EXPORT_SYMBOL(memory_check_begin);
+
+void memory_check_end(void)
+{
+	int i = 0;
+
+	pr_info("%s: Resume Memory Verifying ... State 0\n", __func__);
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		memory_verified_release(mem_vhandle[i]);
+
+	pr_info("%s: Resume Memory Verifying ... State 1\n", __func__);
+	for (i = 0 ; i < MEM_VERIFIED_CNT; i++)
+		mem_vhandle[i] = memory_verified_handle_create(0x4000);
+
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		memory_verified_release(mem_vhandle[i]);
+
+}
+EXPORT_SYMBOL(memory_check_end);
+
+void rtk_ddr_calibration_save(void)
+{
+	int i = 0;
+	int size_tmp1 = 0;
+	int size_tmp2 = 0;
+	int size_tmp3 = 0;
+
+	size_tmp1 = sizeof(phys_wb_area);
+	size_tmp2 = sizeof(struct _memory_verified_handle);
+	size_tmp3 = sizeof(struct _memory_verified_handle *);
+	mem_wbhandle = kmalloc(size_tmp1 / size_tmp2 * size_tmp3, GFP_KERNEL);
+	if (mem_wbhandle) {
+		for (i = 0 ; i < (size_tmp1 / size_tmp2) ; i++)
+			mem_wbhandle[i] = memory_writeback_handle_create(
+					&phys_wb_area[i]);
+	}
+}
+EXPORT_SYMBOL(rtk_ddr_calibration_save);
+
+void rtk_ddr_calibration_restore(void)
+{
+	int i = 0;
+	int size_tmp1 = 0;
+	int size_tmp2 = 0;
+
+	if (mem_wbhandle) {
+		for (i = 0 ; i < (size_tmp1 / size_tmp2) ; i++)
+			memory_writeback_release(
+				mem_wbhandle[i], &phys_wb_area[i]);
+		kfree(mem_wbhandle);
+	}
+}
+EXPORT_SYMBOL(rtk_ddr_calibration_restore);
diff --git a/drivers/soc/realtek/rtd13xx/rtk_chip.c b/drivers/soc/realtek/rtd13xx/rtk_chip.c
new file mode 100644
index 00000000..3e75b3a
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_chip.c
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2018 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <soc/realtek/rtk_chip.h>
+#include <linux/module.h>
+#include <linux/io.h>
+
+#define SB2_BASE_ADDR 0x9801A000
+#define CHIP_ID 0x00000200
+#define CHIP_REV 0x00000204
+
+#define OTP_ADDR 0x980174f4
+#define OTP_CHIP_MASK 0x000F0000
+#define RTD1319 0x00000000
+#define RTD1317 0x00010000
+#define RTD1315 0x00020000
+
+#define RTD13xx_CHIP_A00 (0x00000000)
+
+int get_rtd_chip_id(void) {
+	int chip_id = CHIP_ID_RTD1319;
+	void __iomem *chip_id_addr;
+	int val;
+
+	chip_id_addr = ioremap(OTP_ADDR, 0x4);
+	val = readl(chip_id_addr);
+	__iounmap(chip_id_addr);
+
+	switch (val & OTP_CHIP_MASK) {
+	case (RTD1319):
+		chip_id = CHIP_ID_RTD1319;
+		break;
+	case (RTD1317):
+		chip_id = CHIP_ID_RTD1317;
+		break;
+	case (RTD1315):
+		chip_id = CHIP_ID_RTD1315;
+		break;
+	default:
+		printk("%s: Not define chip id 0x%x\n", __func__, val);
+	}
+
+	return chip_id;
+}
+EXPORT_SYMBOL(get_rtd_chip_id);
+
+int get_rtd_chip_revision(void) {
+	int chip_revision = RTD_CHIP_A00;
+	void __iomem *chip_revision_addr = ioremap(SB2_BASE_ADDR + CHIP_REV, 0x4);
+
+	int val = readl(chip_revision_addr);
+
+	__iounmap(chip_revision_addr);
+
+	switch (val) {
+	case (RTD13xx_CHIP_A00):
+		return RTD_CHIP_A00;
+	default:
+		printk("%s: Not define chip revision 0x%x\n", __func__, val);
+	}
+	return chip_revision;
+}
+EXPORT_SYMBOL(get_rtd_chip_revision);
diff --git a/drivers/soc/realtek/rtd13xx/rtk_usb.c b/drivers/soc/realtek/rtd13xx/rtk_usb.c
new file mode 100644
index 00000000..ef854d7
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_usb.c
@@ -0,0 +1,245 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_gpio.h>
+#include <linux/usb/otg.h>
+#include <soc/realtek/rtk_usb.h>
+#include <soc/realtek/rtk_chip.h>
+
+struct rtk_usb {
+	struct power_ctrl_reg {
+		/* l4_icg */
+		u32 p0_l4_icg;
+		u32 p1_l4_icg;
+		u32 p2_l4_icg;
+	} power_ctrl_reg;
+
+	bool usb_power_cut;
+
+	struct type_c {
+		int connector_switch_gpio;
+		int plug_side_switch_gpio;
+	} type_c;
+
+	u32 pcie_usb3phy_sel;
+};
+
+#define disable_cc 0x0
+#define enable_cc1 0x1
+#define enable_cc2 0x2
+
+static struct rtk_usb *rtk_usb;
+
+/* set usb charger power */
+void rtk_usb_set_charger_power(struct rtk_usb *rtk_usb, unsigned int val)
+{
+	if (!rtk_usb)
+		return;
+
+	return;
+}
+
+int rtk_usb_set_hw_l4icg_on_off(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool on)
+{
+	void __iomem *reg;
+
+	if (!rtk_usb)
+		return 0;
+
+	switch (port_num) {
+	case USB_PORT_0:
+		if (rtk_usb->power_ctrl_reg.p0_l4_icg) {
+			pr_info("%s set l4_icg port %d\n", __func__, port_num);
+			reg = ioremap(rtk_usb->power_ctrl_reg.p0_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	case USB_PORT_1:
+		if (rtk_usb->power_ctrl_reg.p1_l4_icg) {
+			pr_info("%s set l4_icg port %d\n", __func__, port_num);
+			reg = ioremap(rtk_usb->power_ctrl_reg.p1_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	case USB_PORT_2:
+		if (rtk_usb->power_ctrl_reg.p2_l4_icg) {
+			pr_info("%s set l4_icg port %d\n", __func__, port_num);
+			reg = ioremap(rtk_usb->power_ctrl_reg.p2_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	default:
+		pr_err("%s Error Port num %d\n", __func__, port_num);
+		break;
+	}
+
+	return 0;
+}
+
+int rtk_usb_iso_power_ctrl(struct rtk_usb *rtk_usb,
+	    bool power_on)
+{
+	if (!rtk_usb)
+		return 0;
+
+	pr_debug("%s START\n", __func__);
+
+	pr_debug("%s END\n", __func__);
+	return 0;
+}
+
+int rtk_usb_port_suspend_resume(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool is_suspend)
+{
+	if (!rtk_usb)
+		return 0;
+
+	return 0;
+}
+
+int rtk_type_c_init(struct rtk_usb *rtk_usb)
+{
+	if (!rtk_usb)
+		return 0;
+
+	return 0;
+}
+
+int rtk_type_c_plug_config(struct rtk_usb *rtk_usb, int dr_mode, int cc)
+{
+	bool high;
+
+	/* host / device */
+	if (dr_mode == USB_DR_MODE_PERIPHERAL) {
+		high = true;
+	} else if (dr_mode == USB_DR_MODE_HOST) {
+		high = false;
+	} else {
+		goto cc_config;
+	}
+
+	if (rtk_usb->type_c.connector_switch_gpio != -1 &&
+		    gpio_is_valid(rtk_usb->type_c.connector_switch_gpio)) {
+		pr_info("%s Set connector to %s by gpio %d\n",
+			    __func__, high?"device":"host",
+			    rtk_usb->type_c.connector_switch_gpio);
+		if (gpio_direction_output(rtk_usb->type_c.connector_switch_gpio, high))
+			pr_err("%s ERROR connector_switch_ctrl_gpio fail\n",
+				    __func__);
+	}
+
+cc_config:
+	/* cc pin */
+	/* host / device */
+	if (cc == enable_cc1) {
+		high = true;
+	} else if (cc == enable_cc2) {
+		high = false;
+	} else {
+		goto out;
+	}
+
+	if (rtk_usb->type_c.plug_side_switch_gpio != -1 &&
+		    gpio_is_valid(rtk_usb->type_c.plug_side_switch_gpio)) {
+		pr_info("%s type plug to %s by gpio %d\n",
+			    __func__, high?"cc1":"cc2",
+			    rtk_usb->type_c.plug_side_switch_gpio);
+		if (gpio_direction_output(rtk_usb->type_c.plug_side_switch_gpio, high))
+			pr_err("%s set ERROR plug_side_switch_gpio fail\n",
+				    __func__);
+	}
+
+out:
+	return 0;
+}
+
+struct rtk_usb *rtk_usb_soc_init(struct device_node *node)
+{
+	struct device_node *sub_node;
+
+	if (!rtk_usb)
+		rtk_usb = kzalloc(sizeof(struct rtk_usb), GFP_KERNEL);
+
+	pr_info("%s START (%s)\n", __func__, __FILE__);
+
+	sub_node = of_get_child_by_name(node, "power_ctrl_reg");
+	if (sub_node) {
+		pr_debug("%s sub_node %s\n", __func__, sub_node->name);
+
+		of_property_read_u32(sub_node,
+			    "p0_l4_icg", &rtk_usb->power_ctrl_reg.p0_l4_icg);
+		of_property_read_u32(sub_node,
+			    "p1_l4_icg", &rtk_usb->power_ctrl_reg.p1_l4_icg);
+		of_property_read_u32(sub_node,
+			    "p2_l4_icg", &rtk_usb->power_ctrl_reg.p2_l4_icg);
+
+		if (of_property_read_bool(sub_node, "usb_power_cut"))
+			rtk_usb->usb_power_cut = true;
+		else
+			rtk_usb->usb_power_cut = false;
+	}
+
+	sub_node = of_get_child_by_name(node, "type_c");
+	if (sub_node) {
+		int gpio;
+		pr_debug("%s sub_node %s\n", __func__, sub_node->name);
+
+		gpio = of_get_named_gpio(sub_node, "realtek,connector_switch-gpio", 0);
+		if (gpio_is_valid(gpio)) {
+			rtk_usb->type_c.connector_switch_gpio = gpio;
+			pr_info("%s get connector_switch-gpio (id=%d) OK\n",
+				    __func__, gpio);
+		} else {
+			pr_info("connector_switch-gpio no found");
+			rtk_usb->type_c.connector_switch_gpio = -1;
+		}
+
+		gpio = of_get_named_gpio(sub_node, "realtek,plug_side_switch-gpio", 0);
+		if (gpio_is_valid(gpio)) {
+			rtk_usb->type_c.plug_side_switch_gpio = gpio;
+			pr_info("%s get plug_side_switch-gpio (id=%d) OK\n",
+				    __func__, gpio);
+		} else {
+			pr_info("plug_side_switch-gpio no found");
+			rtk_usb->type_c.plug_side_switch_gpio = -1;
+		}
+	}
+	if (of_property_read_u32(node,
+			    "pcie_usb3phy_sel", &rtk_usb->pcie_usb3phy_sel)) {
+		rtk_usb->pcie_usb3phy_sel = -1;
+	} else {
+		void __iomem *reg = ioremap(rtk_usb->pcie_usb3phy_sel, 0x4);
+		int val = readl(reg) | BIT(6);
+
+		writel(val, reg);
+
+		pr_info("%s: pcie_usb3phy_sel=%x to enable usb3phy (val=0x%x)\n",
+			    __func__, rtk_usb->pcie_usb3phy_sel, readl(reg));
+
+		iounmap(reg);
+	}
+
+	pr_info("%s END\n", __func__);
+	return rtk_usb;
+}
+
+int rtk_usb_soc_free(struct rtk_usb **rtk_usb)
+{
+	if (*rtk_usb) {
+		kfree(*rtk_usb);
+		*rtk_usb = NULL;
+	}
+	return 0;
+}
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/Kconfig b/drivers/soc/realtek/rtd13xx/rtk_ve/Kconfig
new file mode 100644
index 00000000..226e865
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/Kconfig
@@ -0,0 +1,25 @@
+#
+# Realtek codec configuration
+#
+
+menuconfig RTK_CODEC
+	bool "Realtek Codec"
+	default n
+
+if RTK_CODEC
+
+if ION
+config RTK_RESERVE_MEMORY
+	bool "RTK Reserve Memory for Video/Image Codec"
+	default n
+endif # ION
+
+config VE1_CODEC
+	bool "RTK Video Engine 1 Codec"
+	default n
+
+config IMAGE_CODEC
+	bool "RTK Image Codec"
+	default n
+
+endif # RTK_CODEC
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/Makefile b/drivers/soc/realtek/rtd13xx/rtk_ve/Makefile
new file mode 100644
index 00000000..bcb1bfb
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/Makefile
@@ -0,0 +1,7 @@
+#
+# Makefile for the Realtek codec drivers.
+#
+
+obj-$(CONFIG_RTK_CODEC)		+= puwrap.o
+obj-$(CONFIG_VE1_CODEC)		+= ve1/
+obj-$(CONFIG_IMAGE_CODEC)	+= jdi/
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/Makefile b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/Makefile
new file mode 100644
index 00000000..40bef4c
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/Makefile
@@ -0,0 +1,6 @@
+# rtk_jcodec
+
+obj-$(CONFIG_IMAGE_CODEC) += jpu.o
+ifdef CONFIG_COMPAT
+obj-$(CONFIG_IMAGE_CODEC) += compat_jpu.o
+endif
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/compat_jpu.c b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/compat_jpu.c
new file mode 100644
index 00000000..fb5d79f
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/compat_jpu.c
@@ -0,0 +1,324 @@
+/*
+ * drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/compat.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#include "jpu.h"
+#include "compat_jpu.h"
+
+/* See drivers/soc/realtek/rtd129x/rtk_ve/jdi/jpu.h for the definition of these structs */
+typedef struct compat_jpudrv_buffer_t {
+    compat_uint_t size;
+    compat_ulong_t phys_addr;
+    compat_ulong_t base;							/* kernel logical address in use kernel */
+    compat_ulong_t virt_addr;				/* virtual user space address */
+} compat_jpudrv_buffer_t;
+
+typedef struct compat_jpudrv_intr_info_t {
+    compat_uint_t timeout;
+    compat_int_t intr_reason;
+} compat_jpudrv_intr_info_t;
+
+typedef struct compat_jpudrv_dovi_info_t{
+	compat_uint_t inst_idx;
+	compat_uint_t enable;
+} compat_jpudrv_dovi_info_t;
+
+#define COMPAT_JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(JDI_IOCTL_MAGIC, 0)
+#define COMPAT_JDI_IOCTL_FREE_PHYSICALMEMORY _IO(JDI_IOCTL_MAGIC, 1)
+#define COMPAT_JDI_IOCTL_WAIT_INTERRUPT _IO(JDI_IOCTL_MAGIC, 2)
+#define COMPAT_JDI_IOCTL_GET_INSTANCE_POOL _IO(JDI_IOCTL_MAGIC, 5)
+#define COMPAT_JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(JDI_IOCTL_MAGIC, 6)
+#define COMPAT_JDI_IOCTL_GET_REGISTER_INFO _IO(JDI_IOCTL_MAGIC, 11)
+#define COMPAT_JDI_IOCTL_GET_BONDING_INFO _IO(JDI_IOCTL_MAGIC, 13)
+#define COMPAT_JDI_IOCTL_SET_RTK_DOVI_FLAG _IO(JDI_IOCTL_MAGIC, 14)
+
+static int compat_get_jpu_buffer_data(
+    compat_jpudrv_buffer_t __user *data32,
+    jpudrv_buffer_t __user *data)
+{
+    compat_uint_t s;
+    compat_ulong_t p;
+    compat_ulong_t b;
+    compat_ulong_t v;
+    int err;
+
+    err = get_user(s, &data32->size);
+    err |= put_user(s, &data->size);
+    err |= get_user(p, &data32->phys_addr);
+    err |= put_user(p, &data->phys_addr);
+    err |= get_user(b, &data32->base);
+    err |= put_user(b, &data->base);
+    err |= get_user(v, &data32->virt_addr);
+    err |= put_user(v, &data->virt_addr);
+
+    return err;
+}
+
+static int compat_get_jpu_intr_info_data(
+    compat_jpudrv_intr_info_t __user *data32,
+    jpudrv_intr_info_t __user *data)
+{
+    compat_uint_t t;
+    compat_int_t i;
+    int err;
+
+    err = get_user(t, &data32->timeout);
+    err |= put_user(t, &data->timeout);
+    err |= get_user(i, &data32->intr_reason);
+    err |= put_user(i, &data->intr_reason);
+
+    return err;
+}
+
+static int compat_get_jpu_dovi_info(
+	compat_jpudrv_dovi_info_t __user *data32,
+	jpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t e;
+	compat_uint_t i;
+	int err;
+
+	err |= get_user(i, &data32->inst_idx);
+	err |= put_user(i, &data->inst_idx);
+	err |= get_user(e, &data32->enable);
+	err |= put_user(e, &data->enable);
+
+	return err;
+}
+
+static int compat_put_jpu_buffer_data(
+    compat_jpudrv_buffer_t __user *data32,
+    jpudrv_buffer_t __user *data)
+{
+    compat_uint_t s;
+    compat_ulong_t p;
+    compat_ulong_t b;
+    compat_ulong_t v;
+    int err;
+
+    err = get_user(s, &data->size);
+    err |= put_user(s, &data32->size);
+    err |= get_user(p, &data->phys_addr);
+    err |= put_user(p, &data32->phys_addr);
+    err |= get_user(b, &data->base);
+    err |= put_user(b, &data32->base);
+    err |= get_user(v, &data->virt_addr);
+    err |= put_user(v, &data32->virt_addr);
+
+    return err;
+}
+
+static int compat_put_jpu_intr_info_data(
+    compat_jpudrv_intr_info_t __user *data32,
+    jpudrv_intr_info_t __user *data)
+{
+    compat_uint_t t;
+    compat_int_t i;
+    int err;
+
+    err = get_user(t, &data->timeout);
+    err |= put_user(t, &data32->timeout);
+    err |= get_user(i, &data->intr_reason);
+    err |= put_user(i, &data32->intr_reason);
+
+    return err;
+}
+
+static int compat_put_jpu_dovi_info(
+	compat_jpudrv_dovi_info_t __user *data32,
+	jpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t i;
+	compat_uint_t e;
+	int err;
+
+	err |= get_user(i, &data->inst_idx);
+	err |= put_user(i, &data32->inst_idx);
+	err |= get_user(e, &data->enable);
+	err |= put_user(e, &data32->enable);
+
+	return err;
+}
+
+long compat_jpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+    long ret = 0;
+
+    if (!filp->f_op->unlocked_ioctl)
+        return -ENOTTY;
+
+    switch (cmd)
+    {
+    case COMPAT_JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_FREE_PHYSICALMEMORY:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+
+        return filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_FREE_PHYSICALMEMORY, (unsigned long)data);
+    }
+
+    case COMPAT_JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_WAIT_INTERRUPT:
+    {
+        compat_jpudrv_intr_info_t __user *data32;
+        jpudrv_intr_info_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_intr_info_data(data32, data);
+        if (err)
+            return err;
+
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_WAIT_INTERRUPT, (unsigned long)data);
+        err = compat_put_jpu_intr_info_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case JDI_IOCTL_ENABLE_INTERRUPT:
+    case JDI_IOCTL_SET_CLOCK_GATE:
+    case JDI_IOCTL_OPEN_INSTANCE:
+    case JDI_IOCTL_CLOSE_INSTANCE:
+    case JDI_IOCTL_GET_INSTANCE_NUM:
+    case JDI_IOCTL_RESET:
+    case JDI_IOCTL_SET_CLOCK_ENABLE:
+    {
+        return filp->f_op->unlocked_ioctl(filp, cmd,
+                                          (unsigned long)compat_ptr(arg));
+    }
+
+    case COMPAT_JDI_IOCTL_GET_INSTANCE_POOL:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_INSTANCE_POOL, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_GET_REGISTER_INFO:
+    case COMPAT_JDI_IOCTL_GET_BONDING_INFO:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        if (cmd == COMPAT_JDI_IOCTL_GET_REGISTER_INFO)
+            ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_REGISTER_INFO, (unsigned long)data);
+        else
+            ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_BONDING_INFO, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+	case COMPAT_JDI_IOCTL_SET_RTK_DOVI_FLAG:
+	{
+		compat_jpudrv_dovi_info_t __user *data32;
+		jpudrv_dovi_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_jpu_dovi_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_SET_RTK_DOVI_FLAG, (unsigned long)data);
+		err = compat_put_jpu_dovi_info(data32, data);
+		return ret ? ret : err;
+	}
+
+    default:
+    {
+        printk(KERN_ERR "[COMPAT JPU]No such IOCTL, cmd is %d\n", cmd);
+        return -ENOIOCTLCMD;
+    }
+    }
+}
+
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/compat_jpu.h b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/compat_jpu.h
new file mode 100644
index 00000000..2d920c9
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/compat_jpu.h
@@ -0,0 +1,31 @@
+/*
+
+ * drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_COMPAT_JPU_H
+#define _LINUX_COMPAT_JPU_H
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+long compat_jpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+
+#else
+
+#define compat_jpu_ioctl  NULL
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_JPU_H */
+
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/jmm.h b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/jmm.h
new file mode 100644
index 00000000..e54a228
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/jmm.h
@@ -0,0 +1,647 @@
+#ifndef __JPU_MM_H__
+#define __JPU_MM_H__
+
+
+typedef unsigned long long  jmem_key_t;
+
+#define JMEM_PAGE_SIZE           (16*1024)
+#define MAKE_KEY(_a, _b)        (((jmem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key)      (_key>>32)
+
+typedef struct page_struct {
+    int             pageno;
+    unsigned long   addr;
+    int             used;
+    int             alloc_pages;
+    int             first_pageno;
+} page_t;
+
+
+typedef struct avl_node_struct {
+    jmem_key_t   key;
+    int     height;
+    page_t* page;
+    struct avl_node_struct* left;
+    struct avl_node_struct* right;
+} avl_node_t;
+
+
+typedef struct _jpu_mm_struct {
+    avl_node_t*     free_tree;
+    avl_node_t*     alloc_tree;
+    page_t*         page_list;
+    int             num_pages;
+    unsigned long   base_addr;
+    unsigned long   mem_size;
+    int             free_page_count;
+    int             alloc_page_count;
+} jpu_mm_t;
+
+
+
+#define VMEM_P_ALLOC(_x)         kmalloc(_x, GFP_KERNEL)
+#define VMEM_P_FREE(_x)          kfree(_x)
+
+#define VMEM_ASSERT(_exp)        if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/
+}
+#define VMEM_HEIGHT(_tree)       (_tree==NULL ? -1 : _tree->height)
+
+
+#define MAX(_a, _b)         (_a >= _b ? _a : _b)
+
+typedef enum {
+    LEFT,
+    RIGHT
+} rotation_dir_t;
+
+
+
+typedef struct avl_node_data_struct {
+    int     key;
+    page_t* page;
+} avl_node_data_t;
+
+static avl_node_t*
+make_avl_node(
+    jmem_key_t key,
+    page_t* page
+)
+{
+    avl_node_t* node = (avl_node_t*)VMEM_P_ALLOC(sizeof(avl_node_t));
+    node->key     = key;
+    node->page    = page;
+    node->height  = 0;
+    node->left    = NULL;
+    node->right   = NULL;
+
+    return node;
+}
+
+
+static int
+get_balance_factor(
+    avl_node_t* tree
+)
+{
+    int factor = 0;
+    if (tree) {
+        factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+    }
+
+    return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *      A                      B
+ *       \                    / \
+ *        B         =>       A   C
+ *       /  \                 \
+ *      D    C                 D
+ *
+ */
+static avl_node_t*
+rotation_left(
+    avl_node_t* tree
+)
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    rchild = tree->right;
+    if (rchild == NULL) {
+        return tree;
+    }
+
+    lchild = rchild->left;
+    rchild->left = tree;
+    tree->right = lchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+    return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *         A                  B
+ *       \                  /  \
+ *      B         =>       D    A
+ *    /  \                     /
+ *   D    C                   C
+ *
+ */
+static avl_node_t*
+rotation_right(
+    avl_node_t* tree
+)
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    lchild = tree->left;
+    if (lchild == NULL) return NULL;
+
+    rchild = lchild->right;
+    lchild->right = tree;
+    tree->left = rchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+    return lchild;
+}
+
+static avl_node_t*
+do_balance(
+    avl_node_t* tree
+)
+{
+    int bfactor = 0, child_bfactor;       /* balancing factor */
+
+    bfactor = get_balance_factor(tree);
+
+    if (bfactor >= 2) {
+        child_bfactor = get_balance_factor(tree->right);
+        if (child_bfactor == 1 || child_bfactor == 0) {
+            tree = rotation_left(tree);
+        } else if (child_bfactor == -1) {
+            tree->right = rotation_right(tree->right);
+            tree        = rotation_left(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    } else if (bfactor <= -2) {
+        child_bfactor = get_balance_factor(tree->left);
+        if (child_bfactor == -1 || child_bfactor == 0) {
+            tree = rotation_right(tree);
+        } else if (child_bfactor == 1) {
+            tree->left = rotation_left(tree->left);
+            tree       = rotation_right(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    }
+
+    return tree;
+}
+static avl_node_t*
+unlink_end_node(
+    avl_node_t* tree,
+    int dir,
+    avl_node_t** found_node
+)
+{
+    avl_node_t* node;
+    *found_node = NULL;
+
+    if (tree == NULL) return NULL;
+
+    if (dir == LEFT) {
+        if (tree->left == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    } else {
+        if (tree->right == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    }
+
+    if (dir == LEFT) {
+        node = tree->left;
+        tree->left = unlink_end_node(tree->left, LEFT, found_node);
+        if (tree->left == NULL) {
+            tree->left = (*found_node)->right;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    } else {
+        node = tree->right;
+        tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+        if (tree->right == NULL) {
+            tree->right = (*found_node)->left;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    }
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return do_balance(tree);
+}
+
+
+static avl_node_t*
+avltree_insert(
+    avl_node_t* tree,
+    jmem_key_t key,
+    page_t* page
+)
+{
+    if (tree == NULL) {
+        tree = make_avl_node(key, page);
+    } else {
+        if (key >= tree->key) {
+            tree->right = avltree_insert(tree->right, key, page);
+        } else {
+            tree->left  = avltree_insert(tree->left, key, page);
+        }
+    }
+
+    tree = do_balance(tree);
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return tree;
+}
+
+static avl_node_t*
+do_unlink(
+    avl_node_t* tree
+)
+{
+    avl_node_t* node;
+    avl_node_t* end_node;
+    node = unlink_end_node(tree->right, LEFT, &end_node);
+    if (node) {
+        tree->right = node;
+    } else {
+        node = unlink_end_node(tree->left, RIGHT, &end_node);
+        if (node) tree->left = node;
+    }
+
+    if (node == NULL) {
+        node = tree->right ? tree->right : tree->left;
+        end_node = node;
+    }
+
+    if (end_node) {
+        end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+        end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+        end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+    }
+
+    tree = end_node;
+
+    return tree;
+}
+
+static avl_node_t*
+avltree_remove(
+    avl_node_t* tree,
+    avl_node_t** found_node,
+    jmem_key_t key
+)
+{
+    *found_node = NULL;
+    if (tree == NULL) {
+        printk(KERN_INFO "failed to find key %d\n", (int)key);
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found_node = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = avltree_remove(tree->right, found_node, key);
+    } else {
+        tree->left  = avltree_remove(tree->left, found_node, key);
+    }
+
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+void
+jpu_avltree_free(
+    avl_node_t* tree
+)
+{
+    if (tree == NULL) return;
+    if (tree->left == NULL && tree->right == NULL) {
+        VMEM_P_FREE(tree);
+        return;
+    }
+
+    jpu_avltree_free(tree->left);
+    tree->left = NULL;
+    jpu_avltree_free(tree->right);
+    tree->right = NULL;
+}
+
+
+
+
+static avl_node_t*
+remove_approx_value(
+    avl_node_t* tree,
+    avl_node_t** found,
+    jmem_key_t key
+)
+{
+    *found = NULL;
+    if (tree == NULL) {
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = remove_approx_value(tree->right, found, key);
+    } else {
+        tree->left  = remove_approx_value(tree->left, found, key);
+        if (*found == NULL) {
+            *found = tree;
+            tree = do_unlink(tree);
+        }
+    }
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+static void
+set_blocks_free(
+    jpu_mm_t *mm,
+    int pageno,
+    int npages
+)
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    VMEM_ASSERT(npages);
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+    last_page   = &mm->page_list[last_pageno];
+    last_page->first_pageno = pageno;
+
+    mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void
+set_blocks_alloc(
+    jpu_mm_t *mm,
+    int pageno,
+    int npages
+)
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 1;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+
+    last_page   = &mm->page_list[last_pageno];
+    last_page->first_pageno = pageno;
+
+    mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int
+jmem_init(
+    jpu_mm_t* mm,
+    unsigned long addr,
+    unsigned long size
+)
+{
+    int i;
+
+
+    mm->base_addr  = (addr+(JMEM_PAGE_SIZE-1))&~(JMEM_PAGE_SIZE-1);
+    mm->mem_size   = size&~JMEM_PAGE_SIZE;
+    mm->num_pages  = mm->mem_size/JMEM_PAGE_SIZE;
+    mm->page_list  = (page_t*)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = mm->num_pages;
+    mm->alloc_page_count = 0;
+
+    for (i=0; i<mm->num_pages; i++) {
+        mm->page_list[i].pageno       = i;
+        mm->page_list[i].addr         = mm->base_addr + i*JMEM_PAGE_SIZE;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    set_blocks_free(mm, 0, mm->num_pages);
+
+    return 0;
+}
+
+int
+jmem_exit(
+    jpu_mm_t* mm
+)
+{
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_exit: invalid handle\n");
+        return -1;
+    }
+
+    if (mm->free_tree) {
+        jpu_avltree_free(mm->free_tree);
+    }
+    if (mm->alloc_tree) {
+        jpu_avltree_free(mm->alloc_tree);
+    }
+
+    VMEM_P_FREE(mm->page_list);
+
+    mm->base_addr  = 0;
+    mm->mem_size   = 0;
+    mm->num_pages  = 0;
+    mm->page_list  = NULL;
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = 0;
+    mm->alloc_page_count = 0;
+    return 0;
+}
+
+unsigned long
+jmem_alloc(
+    jpu_mm_t* mm,
+    int size,
+    unsigned long pid
+)
+{
+    avl_node_t* node;
+    page_t*     free_page;
+    int         npages, free_size;
+    int         alloc_pageno;
+    unsigned long  ptr;
+
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_alloc: invalid handle\n");
+        return -1;
+    }
+
+    if (size <= 0) return -1;
+
+    npages = (size + JMEM_PAGE_SIZE -1)/JMEM_PAGE_SIZE;
+
+    mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+    if (node == NULL) {
+        return -1;
+    }
+    free_page = node->page;
+    free_size = KEY_TO_VALUE(node->key);
+
+    alloc_pageno = free_page->pageno;
+    set_blocks_alloc(mm, alloc_pageno, npages);
+    if (npages != free_size) {
+        int free_pageno = alloc_pageno + npages;
+        set_blocks_free(mm, free_pageno, (free_size-npages));
+    }
+
+    VMEM_P_FREE(node);
+
+    ptr = mm->page_list[alloc_pageno].addr;
+    mm->alloc_page_count += npages;
+    mm->free_page_count  -= npages;
+
+
+    return ptr;
+}
+
+int
+jmem_free(
+    jpu_mm_t* mm,
+    unsigned long ptr,
+    unsigned long pid
+)
+{
+    unsigned long addr;
+    avl_node_t* found;
+    page_t* page;
+    int pageno, prev_free_pageno, next_free_pageno;
+    int prev_size, next_size;
+    int merge_page_no, merge_page_size, free_page_size;
+
+
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_free: invalid handle\n");
+        return -1;
+    }
+
+    addr = ptr;
+
+    mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+    if (found == NULL) {
+        printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+        VMEM_ASSERT(0);
+        return -1;
+    }
+
+    /* find previous free block */
+    page = found->page;
+    pageno = page->pageno;
+    free_page_size = page->alloc_pages;
+    prev_free_pageno = pageno-1;
+    prev_size = -1;
+    if (prev_free_pageno >= 0) {
+        if (mm->page_list[prev_free_pageno].used == 0) {
+            prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+            prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+        }
+    }
+
+    /* find next free block */
+    next_free_pageno = pageno + page->alloc_pages;
+    next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+    next_size = -1;
+    if (next_free_pageno >= 0) {
+        if (mm->page_list[next_free_pageno].used == 0) {
+            next_size = mm->page_list[next_free_pageno].alloc_pages;
+        }
+    }
+    VMEM_P_FREE(found);
+
+    /* merge */
+    merge_page_no = page->pageno;
+    merge_page_size = page->alloc_pages;
+    if (prev_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_no = found->page->pageno;
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+    if (next_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+
+    page->alloc_pages  = 0;
+    page->first_pageno = -1;
+
+    set_blocks_free(mm, merge_page_no, merge_page_size);
+
+    mm->alloc_page_count -= free_page_size;
+    mm->free_page_count  += free_page_size;
+
+    return 0;
+}
+
+
+
+#endif /* __JPU_MM_H__ */
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/jpu.c b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/jpu.c
new file mode 100644
index 00000000..580a30b
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/jpu.c
@@ -0,0 +1,1089 @@
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+
+#include "jpu.h"
+#include "compat_jpu.h"
+#include "../puwrap.h"
+
+//from jpuconfig.h
+#define MAX_NUM_INSTANCE 8
+#define MAX_INST_HANDLE_SIZE (12*1024)
+
+/* definitions to be changed as customer  configuration */
+//#define JPU_SUPPORT_CLOCK_CONTROL /if you want to have clock gating scheme frame by frame
+#define JPU_SUPPORT_ISR
+/* if the platform driver knows the name of this driver. JPU_PLATFORM_DEVICE_NAME */
+#define JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+#ifndef CONFIG_RTK_RESERVE_MEMORY
+/* if this driver knows the dedicated video memory address */
+//#define JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#endif
+//#define JPU_IRQ_CONTROL
+#define DEV_NAME "[RTK_JPU]"
+#define JPU_PLATFORM_DEVICE_NAME "jdec"
+#define JPU_CLK_NAME "jpeg"
+#define JPU_DEV_NAME "jpu"
+
+#define JPU_BASE_ADDR 0x9803e000
+#define JPU_REG_SIZE 0x1000
+
+#ifdef JPU_SUPPORT_ISR
+#define JPU_IRQ_NUM 84+32
+#endif
+
+#ifndef VM_RESERVED /* for kernel up to 3.7.0 version */
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+typedef struct jpu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long interrupt_reason;
+} jpu_drv_context_t;
+
+/* To track the allocated memory buffer */
+typedef struct jpudrv_buffer_pool_t {
+	struct list_head list;
+	struct jpudrv_buffer_t jb;
+	struct file *filp;
+} jpudrv_buffer_pool_t;
+
+/* To track the instance index and buffer in instance pool */
+typedef struct jpudrv_instanace_list_t {
+	struct list_head list;
+	unsigned long inst_idx;
+	struct file *filp;
+} jpudrv_instanace_list_t;
+
+typedef struct jpudrv_instance_pool_t {
+	unsigned char jpgInstPool[MAX_NUM_INSTANCE][MAX_INST_HANDLE_SIZE];
+} jpudrv_instance_pool_t;
+
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#define JPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)
+#define JPU_DRAM_PHYSICAL_BASE (0x8AA00000)
+#include "jmm.h"
+static jpu_mm_t s_jmem;
+static jpudrv_buffer_t s_image_memory = {0};
+#endif
+
+static int jpu_hw_reset(void);
+static void jpu_clk_disable(struct clk *clk);
+static int jpu_clk_enable(struct clk *clk);
+static struct clk *jpu_clk_get(struct device *dev);
+static void jpu_clk_put(struct clk *clk);
+// end customer definition
+
+static jpudrv_buffer_t s_jpu_instance_pool = {0};
+static jpu_drv_context_t s_jpu_drv_context;
+static struct miscdevice s_jpu_dev;
+static int s_jpu_open_count;
+static struct clk *s_jpu_clk;
+static struct reset_control *rstc_jpeg = NULL;
+#ifdef JPU_SUPPORT_ISR
+static int s_jpu_irq = JPU_IRQ_NUM;
+static atomic_t s_interrupt_flag;
+#endif
+static unsigned long s_jpu_reg_phy_base = JPU_BASE_ADDR;
+static void __iomem *s_jpu_reg_virt_base;
+static jpudrv_buffer_t s_jpu_register = {0};
+static jpudrv_buffer_t s_bonding_register = {0};
+
+static unsigned long s_jpu_pll_phy_base = 0;
+static void __iomem *s_jpu_pll_virt_base = NULL;
+static unsigned long s_jpu_pll_size = 0;
+
+static wait_queue_head_t s_interrupt_wait_q;
+static int dbus_en = 1;
+
+#define JPEG_DBUS_REG (0x0000 + 0xF00)
+
+static spinlock_t s_jpu_lock = __SPIN_LOCK_UNLOCKED(s_jpu_lock);
+static DEFINE_SEMAPHORE(s_jpu_sem);
+static struct list_head s_jbp_head = LIST_HEAD_INIT(s_jbp_head);
+static struct list_head s_jpu_inst_list_head = LIST_HEAD_INIT(s_jpu_inst_list_head);
+
+/* implement to power management functions */
+#define ReadJpuRegister(addr) *(volatile unsigned int *)(s_jpu_reg_virt_base + addr)
+#define WriteJpuRegister(addr, val) *(volatile unsigned int *)(s_jpu_reg_virt_base + addr) = (unsigned int)val;
+
+#if 0 /* Fuchun disable 20160204, set clock gating by jdi.c */
+static void jpu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable)
+{
+	if (s_jpu_pll_phy_base == 0 || s_jpu_pll_virt_base == 0 || s_jpu_pll_size == 0) {
+		pr_warn("%s In[%s][%d] didn't get pll register\n", DEV_NAME, __FUNCTION__, __LINE__);
+		return;
+	} else if (offset > s_jpu_pll_size) {
+		pr_warn("%s In[%s][%d] offset over than register size\n", DEV_NAME, __FUNCTION__, __LINE__);
+		return;
+	}
+
+	if (bOverwrite == 1) {
+		__raw_writel(value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+	} else {
+		if (bEnable)
+			__raw_writel(__raw_readl((volatile u8 *)(s_jpu_pll_virt_base+offset)) | value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+		else
+			__raw_writel(__raw_readl((volatile u8 *)(s_jpu_pll_virt_base+offset)) & value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+	}
+}
+#endif
+
+static int jpu_alloc_dma_buffer(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	jb->phys_addr = (unsigned long)jmem_alloc(&s_jmem, jb->size, 0);
+
+	if ((unsigned long)jb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+
+	jb->base = (unsigned long)(s_image_memory.base + (jb->phys_addr - s_image_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	unsigned int ret;
+	ret = pu_alloc_dma_buffer(jb->size, &jb->phys_addr, &jb->base, 0);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#else
+	jb->base = (unsigned long)dma_alloc_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (dma_addr_t *) (&jb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#endif
+//	pr_info("%s base:0x%08x, phy_addr:0x%08x, size:%d\n", DEV_NAME, (unsigned int)jb->base, (unsigned int)jb->phys_addr, jb->size);
+	return 0;
+}
+
+static int jpu_alloc_dma_buffer2(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	jb->phys_addr = (unsigned long)jmem_alloc(&s_jmem, jb->size, 0);
+
+	if ((unsigned long)jb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+
+	jb->base = (unsigned long)(s_image_memory.base + (jb->phys_addr - s_image_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	unsigned int ret;
+	ret = pu_alloc_dma_buffer(jb->size, &jb->phys_addr, &jb->base, 0);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+	jb->base = pu_mmap_kernel_buffer(jb->phys_addr, jb->size);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s pu_mmap_kernel_buffer error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#else
+	jb->base = (unsigned long)dma_alloc_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (dma_addr_t *) (&jb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#endif
+//	pr_info("%s base:0x%08x, phy_addr:0x%08x, size:%d\n", DEV_NAME, (unsigned int)jb->base, (unsigned int)jb->phys_addr, jb->size);
+	return 0;
+}
+
+static void jpu_free_dma_buffer(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (jb->base)
+		jmem_free(&s_jmem, jb->phys_addr, 0);
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	pu_free_dma_buffer(jb->base, jb->phys_addr);
+#else
+	if (jb->base)
+		dma_free_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (void *)jb->base, jb->phys_addr);
+#endif
+}
+
+static int jpu_free_instances(struct file *filp)
+{
+	u32 inst_idx;
+	jpudrv_instanace_list_t *jil, *n;
+	jpudrv_instance_pool_t *jip;
+	void *jip_base;
+	void* jdi_mutex_base;
+	const unsigned int PTHREAD_MUTEX_T_DESTROY_VALUE = 0xdead10cc;
+
+	list_for_each_entry_safe(jil, n, &s_jpu_inst_list_head, list) {
+		if (jil->filp == filp) {
+			int i;
+			for (i = 0; i < MAX_NUM_INSTANCE; i++) /* reset dovi flag */
+			{
+				pu_set_dovi_flag(2, i, 0);
+			}
+
+			inst_idx = jil->inst_idx;
+			jip_base = (void *)(s_jpu_instance_pool.base);
+			jip = (jpudrv_instance_pool_t *)jip_base;
+			if (jip) {
+				memset(&jip->jpgInstPool[inst_idx], 0x00, 4);	// only first 4 byte is key point to free the corresponding instance.
+#define PTHREAD_MUTEX_T_HANDLE_SIZE 40
+				jdi_mutex_base = (jip_base + (s_jpu_instance_pool.size - PTHREAD_MUTEX_T_HANDLE_SIZE));
+				if (jdi_mutex_base) {
+					memcpy(jdi_mutex_base, &PTHREAD_MUTEX_T_DESTROY_VALUE, PTHREAD_MUTEX_T_HANDLE_SIZE);
+				}
+			}
+			s_jpu_open_count--;
+			list_del(&jil->list);
+			kfree(jil);
+		}
+	}
+
+	return s_jpu_open_count;
+}
+
+static int jpu_free_buffers(struct file *filp)
+{
+	jpudrv_buffer_pool_t *pool, *n;
+	jpudrv_buffer_t jb;
+
+	list_for_each_entry_safe(pool, n, &s_jbp_head, list) {
+		if (pool->filp == filp) {
+			jb = pool->jb;
+			if (jb.base) {
+				jpu_free_dma_buffer(&jb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+
+	return 0;
+}
+
+#ifdef JPU_SUPPORT_ISR
+static irqreturn_t jpu_irq_handler(int irq, void *dev_id)
+{
+	jpu_drv_context_t *dev = (jpu_drv_context_t *)dev_id;
+#ifdef JPU_IRQ_CONTROL
+	disable_irq_nosync(s_jpu_irq);
+#endif
+
+	dev->interrupt_reason = ReadJpuRegister(0x004); /* MJPEG_PIC_STATUS_REG */
+	WriteJpuRegister(0x004, dev->interrupt_reason);
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN); /* notify the interrupt to userspace */
+
+	atomic_set(&s_interrupt_flag, 1);
+
+	//pr_info("%s jpu_irq_handler\n", DEV_NAME);
+	wake_up_interruptible(&s_interrupt_wait_q);
+
+	return IRQ_HANDLED;
+}
+#endif
+
+static int jpu_open(struct inode *inode, struct file *filp)
+{
+	spin_lock(&s_jpu_lock);
+
+	filp->private_data = (void *)(&s_jpu_drv_context);
+	spin_unlock(&s_jpu_lock);
+	return 0;
+}
+
+static long jpu_ioctl(struct file *filp, u_int cmd, u_long arg)
+{
+	int ret = 0;
+	struct jpu_drv_context_t *dev = (struct jpu_drv_context_t *)filp->private_data;
+	jpudrv_buffer_pool_t *jbp;
+	jpudrv_buffer_pool_t *n;
+	jpudrv_buffer_t jb;
+	jpudrv_intr_info_t info;
+	jpudrv_instanace_list_t *jil;
+	jpudrv_instanace_list_t *tmp;
+	jpudrv_dovi_info_t doviInfo;
+	u32 inst_idx;
+	u32 clkgate;
+	u32 val;
+
+	switch (cmd) {
+	case JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+		down(&s_jpu_sem);
+
+		jbp = kzalloc(sizeof(*jbp), GFP_KERNEL);
+		if (!jbp) {
+			up(&s_jpu_sem);
+			return -ENOMEM;
+		}
+
+		ret = copy_from_user(&(jbp->jb), (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+		if (ret) {
+			kfree(jbp);
+			up(&s_jpu_sem);
+			return -EFAULT;
+		}
+
+		ret = jpu_alloc_dma_buffer(&(jbp->jb));
+		if (ret == -1) {
+			ret = -ENOMEM;
+			kfree(jbp);
+			up(&s_jpu_sem);
+			break;
+		}
+
+		ret = copy_to_user((void __user *)arg, &(jbp->jb), sizeof(jpudrv_buffer_t));
+		if (ret) {
+			kfree(jbp);
+			ret = -EFAULT;
+			up(&s_jpu_sem);
+			break;
+		}
+
+		jbp->filp = filp;
+		spin_lock(&s_jpu_lock);
+		list_add(&jbp->list, &s_jbp_head);
+		spin_unlock(&s_jpu_lock);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_FREE_PHYSICALMEMORY:
+		down(&s_jpu_sem);
+
+		ret = copy_from_user(&jb, (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+		if (ret) {
+			up(&s_jpu_sem);
+			return -EACCES;
+		}
+
+		if (jb.base)
+			jpu_free_dma_buffer(&jb);
+
+		spin_lock(&s_jpu_lock);
+		list_for_each_entry_safe(jbp, n, &s_jbp_head, list) {
+			if (jbp->jb.phys_addr == jb.phys_addr) {
+				list_del(&jbp->list);
+				kfree(jbp);
+				break;
+			}
+		}
+		spin_unlock(&s_jpu_lock);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+		if (s_image_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_image_memory, sizeof(jpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = -EFAULT;
+		}
+#endif
+		break;
+#ifdef JPU_SUPPORT_ISR
+	case JDI_IOCTL_WAIT_INTERRUPT:
+		ret = copy_from_user(&info, (jpudrv_intr_info_t*)arg, sizeof(jpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		smp_rmb();
+		ret = wait_event_interruptible_timeout(s_interrupt_wait_q, atomic_read(&s_interrupt_flag) != 0, msecs_to_jiffies(info.timeout));
+		if (!ret) {
+			ret = -ETIME;
+			//pr_info("%s JDI_IOCTL_WAIT_INTERRUPT fail\n", DEV_NAME);
+			break;
+		}
+
+		if (signal_pending(current)) {
+			ret = -ERESTARTSYS;
+			break;
+		}
+
+		atomic_set(&s_interrupt_flag, 0);
+		info.intr_reason = dev->interrupt_reason;
+		ret = copy_to_user((void __user *)arg, &info, sizeof(jpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		//pr_info("%s JDI_IOCTL_WAIT_INTERRUPT done, info.intr_reason:0x%x\n", DEV_NAME, info.intr_reason);
+		break;
+#endif /* JPU_SUPPORT_ISR */
+	case JDI_IOCTL_ENABLE_INTERRUPT:
+#ifdef JPU_IRQ_CONTROL
+		enable_irq(s_jpu_irq);
+#endif
+		break;
+	case JDI_IOCTL_SET_CLOCK_GATE:
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+
+#ifdef JPU_SUPPORT_CLOCK_CONTROL
+		if (clkgate)
+			jpu_clk_enable(s_jpu_clk);
+		else
+			jpu_clk_disable(s_jpu_clk);
+#endif
+
+		break;
+	case JDI_IOCTL_GET_INSTANCE_POOL:
+		down(&s_jpu_sem);
+
+		if (s_jpu_instance_pool.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_jpu_instance_pool, sizeof(jpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = copy_from_user(&s_jpu_instance_pool, (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+			if (ret == 0) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+				s_jpu_instance_pool.size = PAGE_ALIGN(s_jpu_instance_pool.size);
+				s_jpu_instance_pool.base = (unsigned long)vmalloc(s_jpu_instance_pool.size);
+				s_jpu_instance_pool.phys_addr = s_jpu_instance_pool.base;
+
+				if (s_jpu_instance_pool.base != 0)
+#else
+				if (jpu_alloc_dma_buffer2(&s_jpu_instance_pool) != -1)
+#endif
+				{
+					memset((void *)s_jpu_instance_pool.base, 0x0, s_jpu_instance_pool.size);
+					ret = copy_to_user((void __user *)arg, &s_jpu_instance_pool, sizeof(jpudrv_buffer_t));
+					if (ret == 0) {
+						// success to get memory for instance pool
+						up(&s_jpu_sem);
+						break;
+					}
+				}
+			}
+			ret = -EFAULT;
+		}
+		up(&s_jpu_sem);
+
+		break;
+	case JDI_IOCTL_OPEN_INSTANCE:
+		jil = kzalloc(sizeof(*jil), GFP_KERNEL);
+		if (!jil)
+			return -ENOMEM;
+
+		if (get_user(inst_idx, (u32 __user *) arg))
+			return -EFAULT;
+
+		jil->inst_idx = inst_idx;
+		jil->filp = filp;
+		spin_lock(&s_jpu_lock);
+		list_add(&jil->list, &s_jpu_inst_list_head);
+		s_jpu_open_count++;
+		spin_unlock(&s_jpu_lock);
+		break;
+	case JDI_IOCTL_CLOSE_INSTANCE:
+		if (get_user(inst_idx, (u32 __user *) arg))
+			return -EFAULT;
+
+		spin_lock(&s_jpu_lock);
+
+		list_for_each_entry_safe(jil, tmp, &s_jpu_inst_list_head, list) {
+			if (jil->inst_idx == inst_idx) {
+				s_jpu_open_count--;
+				list_del(&jil->list);
+				kfree(jil);
+//				printk(KERN_INFO "[JPUDRV] JDI_IOCTL_CLOSE_INSTANCE inst_idx=%d, open_count=%d\n", (int)inst_idx, s_jpu_open_count);
+				break;
+			}
+		}
+		spin_unlock(&s_jpu_lock);
+		break;
+	case JDI_IOCTL_GET_INSTANCE_NUM:
+		down(&s_jpu_sem);
+
+		ret = copy_to_user((void __user *)arg, &s_jpu_open_count, sizeof(int));
+		if (ret != 0)
+			ret = -EFAULT;
+
+		//printk(KERN_INFO "[JPUDRV] VDI_IOCTL_GET_INSTANCE_NUM open_count=%d\n", s_jpu_open_count);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_RESET:
+		jpu_hw_reset();
+		break;
+	case JDI_IOCTL_GET_REGISTER_INFO:
+		ret = copy_to_user((void __user *)arg, &s_jpu_register, sizeof(jpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		break;
+	case JDI_IOCTL_GET_BONDING_INFO:
+		ret = copy_to_user((void __user *)arg, &s_bonding_register, sizeof(jpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		break;
+	case JDI_IOCTL_SET_CLOCK_ENABLE:
+
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+
+		if (clkgate) {
+			reset_control_deassert(rstc_jpeg);
+			jpu_clk_enable(s_jpu_clk);
+			val = ReadJpuRegister(JPEG_DBUS_REG);
+			val |= (dbus_en << 0);
+			val &= ~(1 << 1); //Disable idle gating, fix it later.
+			WriteJpuRegister(JPEG_DBUS_REG, val);
+		} else {
+			jpu_clk_disable(s_jpu_clk);
+			reset_control_assert(rstc_jpeg);
+		}
+		break;
+	case JDI_IOCTL_SET_RTK_DOVI_FLAG:
+		//pr_info("%s [+]JDI_IOCTL_SET_RTK_DOVI_FLAG\n", DEV_NAME);
+		ret = copy_from_user(&doviInfo, (jpudrv_dovi_info_t *)arg, sizeof(jpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+
+		doviInfo.enable = pu_set_dovi_flag(2, doviInfo.inst_idx, doviInfo.enable);
+
+		ret = copy_to_user((jpudrv_dovi_info_t *)arg, &doviInfo, sizeof(jpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+		//pr_info("%s [-]JDI_IOCTL_SET_RTK_DOVI_FLAG doviInfo.inst_idx:%d, doviInfo.value:%d\n", DEV_NAME, doviInfo.inst_idx, doviInfo.enable);
+		break;
+	default:
+		printk(KERN_ERR "No such IOCTL, cmd is %d\n", cmd);
+		break;
+	}
+
+	return ret;
+}
+
+static ssize_t jpu_read(struct file *filp, char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static ssize_t jpu_write(struct file *filp, const char __user *buf, size_t len, loff_t *ppos)
+{
+
+	return -1;
+}
+
+static int jpu_release(struct inode *inode, struct file *filp)
+{
+//	pr_info("%s jpu_release s_jpu_open_count=%d\n", DEV_NAME, s_jpu_open_count);
+
+	spin_lock(&s_jpu_lock);
+
+
+	if (s_jpu_open_count > 0) {
+		/* found and free the not handled buffer by user applications */
+		jpu_free_buffers(filp);
+
+		/* found and free the not closed instance by user applications */
+		jpu_free_instances(filp);
+	}
+
+#if 1 //Fuchun 20150909, we must not free instance pool and common memory
+	if (s_jpu_open_count == 0) {
+		if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_jpu_instance_pool.base);
+#else
+			pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+			jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+			s_jpu_instance_pool.base = 0;
+//			pr_info("%s jpu_release - free s_jpu_instance_pool\n", DEV_NAME);
+		}
+	}
+#endif
+
+	spin_unlock(&s_jpu_lock);
+
+	return 0;
+}
+
+static int jpu_fasync(int fd, struct file *filp, int mode)
+{
+	struct jpu_drv_context_t *dev = (struct jpu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+static int jpu_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	pfn = vm->vm_pgoff;
+
+	return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int jpu_map_to_physical_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+	return pu_mmap_dma_buffer(vm);
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif
+}
+
+static int jpu_map_to_instance_pool_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	int ret;
+	long length = vm->vm_end - vm->vm_start;
+	unsigned long start = vm->vm_start;
+	char *vmalloc_area_ptr = (char *)s_jpu_instance_pool.base;
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_RESERVED;
+
+	/* loop over all pages, map it page individually */
+	while (length > 0) {
+		pfn = vmalloc_to_pfn(vmalloc_area_ptr);
+		if ((ret = remap_pfn_range(vm, start, pfn, PAGE_SIZE, PAGE_SHARED)) < 0) {
+			return ret;
+		}
+		start += PAGE_SIZE;
+		vmalloc_area_ptr += PAGE_SIZE;
+		length -= PAGE_SIZE;
+	}
+
+	return 0;
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif
+}
+
+/*!
+ * @brief memory map interface for jpu file operation
+ * @return  0 on success or negative error code on error
+ */
+static int jpu_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	if (vm->vm_pgoff == 0)
+		return jpu_map_to_instance_pool_memory(fp, vm);
+
+	if ((vm->vm_pgoff == (s_jpu_register.phys_addr>>PAGE_SHIFT)) || (vm->vm_pgoff == (s_bonding_register.phys_addr>>PAGE_SHIFT)))
+		return jpu_map_to_register(fp, vm);
+
+	return jpu_map_to_physical_memory(fp, vm);
+#else
+	if (vm->vm_pgoff) {
+		if (vm->vm_pgoff == (s_jpu_instance_pool.phys_addr>>PAGE_SHIFT))
+			return  jpu_map_to_instance_pool_memory(fp, vm);
+
+		return jpu_map_to_physical_memory(fp, vm);
+	} else
+		return jpu_map_to_register(fp, vm);
+#endif
+}
+
+struct file_operations jpu_fops = {
+	.owner = THIS_MODULE,
+	.open = jpu_open,
+	.read = jpu_read,
+	.write = jpu_write,
+	.unlocked_ioctl = jpu_ioctl,
+	.compat_ioctl   = compat_jpu_ioctl,
+	.release = jpu_release,
+	.fasync = jpu_fasync,
+	.mmap = jpu_mmap,
+};
+
+static int jpu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+	struct resource res;
+	void __iomem *iobase;
+	int irq;
+	struct device_node *node = pdev->dev.of_node;
+
+	pr_info("%s jpu_probe\n", DEV_NAME);
+
+	of_address_to_resource(node, 0, &res);
+	iobase = of_iomap(node, 0);
+
+	s_jpu_reg_phy_base = res.start;
+	s_jpu_reg_virt_base = iobase;
+	s_jpu_register.phys_addr = res.start;
+	s_jpu_register.virt_addr = (unsigned long)iobase;
+	s_jpu_register.size = res.end - res.start + 1;
+
+	pr_info("%s jpu base address get from DTB physical base addr=0x%lx, virtual base=0x%lx, size=0x%x\n", DEV_NAME, (unsigned long)s_jpu_reg_phy_base, (unsigned long)s_jpu_reg_virt_base, (unsigned int)(res.end - res.start + 1));
+
+	of_address_to_resource(node, 1, &res);
+	iobase = of_iomap(node, 1);
+
+	s_jpu_pll_phy_base = res.start;
+	s_jpu_pll_virt_base = iobase;
+	s_jpu_pll_size = res.end - res.start + 1;
+
+	of_address_to_resource(node, 2, &res);
+	iobase = of_iomap(node, 2);
+
+	s_bonding_register.phys_addr = res.start;
+	s_bonding_register.virt_addr = (unsigned long)iobase;
+	s_bonding_register.size = res.end - res.start + 1;
+
+	s_jpu_dev.minor = MISC_JPU_MINOR;
+	s_jpu_dev.name = JPU_DEV_NAME;
+	s_jpu_dev.fops = &jpu_fops;
+	s_jpu_dev.parent = NULL;
+	if (misc_register(&s_jpu_dev)) {
+		pr_info("%s failed to register misc device.", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (pdev)
+		s_jpu_clk = jpu_clk_get(&pdev->dev);
+	else
+		s_jpu_clk = jpu_clk_get(NULL);
+
+	if (!s_jpu_clk)
+		pr_err("%s fail to get clock controller, but, do not treat as error, \n", DEV_NAME);
+	else
+		pr_info("%s get clock controller s_jpu_clk=0x%p\n", DEV_NAME, s_jpu_clk);
+
+#ifdef JPU_SUPPORT_CLOCK_CONTROL
+	jpu_clk_enable(s_jpu_clk);
+#endif
+
+	rstc_jpeg = reset_control_get(&pdev->dev, NULL);
+
+	/* RTK clock setting */
+	reset_control_deassert(rstc_jpeg); // RESET disable
+#if 0 //Fuchun disable 20160204, set clock gating by jdi.c
+	jpu_pll_setting(0x10, (1 << jpg_clk_enable_bit), 0, 1); // CLK enable
+
+	val = ReadJpuRegister(JPEG_DBUS_REG);
+	val |= (dbus_en << 0);
+	WriteJpuRegister(JPEG_DBUS_REG, val);
+#endif
+
+#ifdef JPU_SUPPORT_ISR
+	irq = irq_of_parse_and_map(node, 0);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_jpu_irq = irq;
+	pr_info("%s s_jpu_irq:%d want to register jpu_irq_handler\n", DEV_NAME, s_jpu_irq);
+	err = request_irq(s_jpu_irq, jpu_irq_handler, 0, "JPEG_CODEC_IRQ", (void *)(&s_jpu_drv_context));
+	err = 0;
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_jpu_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_jpu_irq <%d> busy, change your config\n", DEV_NAME, s_jpu_irq);
+
+		goto ERROR_PROVE_DEVICE;
+	}
+#endif
+
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	s_image_memory.size = JPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+	s_image_memory.phys_addr = JPU_DRAM_PHYSICAL_BASE;
+	s_image_memory.base = (unsigned long)ioremap(s_image_memory.phys_addr, PAGE_ALIGN(s_image_memory.size));
+
+	if (!s_image_memory.base) {
+		pr_err("%s fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", DEV_NAME, (int)s_image_memory.phys_addr, (int)s_image_memory.base, (int)s_image_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (jmem_init(&s_jmem, s_image_memory.phys_addr, s_image_memory.size) < 0) {
+		pr_err("%s fail to init vmem system\n", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	pr_info("%s success to probe jpu device with reserved video memory phys_addr=0x%x, base = 0x%x\n", DEV_NAME, (int) s_image_memory.phys_addr, (int)s_image_memory.base);
+#else
+	pr_info("%s success to probe jpu device with non reserved video memory\n", DEV_NAME);
+#endif
+
+	reset_control_assert(rstc_jpeg);
+
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+	misc_deregister(&s_jpu_dev);
+
+	if (s_jpu_reg_virt_base)
+		iounmap(s_jpu_reg_virt_base);
+
+	return err;
+}
+
+static int jpu_remove(struct platform_device *pdev)
+{
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	pr_info("%s jpu_remove\n", DEV_NAME);
+
+	if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_jpu_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+		jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+		s_jpu_instance_pool.base = 0;
+	}
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_image_memory.base) {
+		iounmap((void *)s_image_memory.base);
+		s_image_memory.base = 0;
+		jmem_exit(&s_jmem);
+	}
+#endif
+
+	misc_deregister(&s_jpu_dev);
+
+#ifdef JPU_SUPPORT_ISR
+	if (s_jpu_irq)
+		free_irq(s_jpu_irq, &s_jpu_drv_context);
+#endif
+
+	if (s_jpu_reg_virt_base)
+		iounmap(s_jpu_reg_virt_base);
+
+	if (rstc_jpeg != NULL)
+		reset_control_put(rstc_jpeg);
+
+	jpu_clk_put(s_jpu_clk);
+
+#endif //JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+static int jpu_suspend(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+	reset_control_deassert(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+#if 0
+	if (s_jpu_open_count > 0) {
+		u32 inst_idx;
+		jpudrv_instanace_list_t *jil, *n;
+		jpudrv_instance_pool_t *jip;
+		void *jip_base;
+		jpudrv_buffer_pool_t *pool, *n;
+		jpudrv_buffer_t jb;
+
+		s_jpu_open_count = 0;
+		atomic_set(&s_interrupt_flag, 0);
+		wake_up_interruptible_all(&s_interrupt_wait_q);
+
+		if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_jpu_instance_pool.base);
+#else
+			jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+			s_jpu_instance_pool.base = 0;
+			pr_info("%s jpu_release - free s_jpu_instance_pool\n", DEV_NAME);
+		}
+
+		list_for_each_entry_safe(jil, n, &s_jpu_inst_list_head, list) {
+			inst_idx = jil->inst_idx;
+			jip_base = (void *)(s_jpu_instance_pool.base);
+			jip = (jpudrv_instance_pool_t *)jip_base;
+			if (jip) {
+				memset(&jip->jpgInstPool[inst_idx], 0x00, 4);	// only first 4 byte is key point to free the corresponding instance.
+			}
+			list_del(&jil->list);
+			kfree(jil);
+		}
+
+		list_for_each_entry_safe(pool, n, &s_jbp_head, list) {
+			jb = pool->jb;
+			if (jb.base) {
+				jpu_free_dma_buffer(&jb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+#endif
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_assert(rstc_jpeg);
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+
+}
+
+static int jpu_resume(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+	reset_control_deassert(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_assert(rstc_jpeg);
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+#else
+#define jpu_suspend NULL
+#define jpu_resume NULL
+#endif /* !CONFIG_PM */
+
+static int __init jpu_init(void)
+{
+	int res;
+	res = 0;
+
+	pr_info("%s jpu_init\n", DEV_NAME);
+	init_waitqueue_head(&s_interrupt_wait_q);
+	s_jpu_instance_pool.base = 0;
+
+	pr_info("%s end jpu_init result=0x%x\n", DEV_NAME, res);
+	return res;
+}
+
+static void __exit jpu_exit(void)
+{
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	pr_info("%s jpu_exit\n", DEV_NAME);
+#else
+	if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_jpu_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+		jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+		s_jpu_instance_pool.base = 0;
+	}
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_image_memory.base) {
+		iounmap((void *)s_image_memory.base);
+		s_image_memory.base = 0;
+	}
+#endif
+
+	misc_deregister(&s_jpu_dev);
+
+#ifdef JPU_SUPPORT_ISR
+	if (s_jpu_irq)
+		free_irq(s_jpu_irq, &s_jpu_drv_context);
+#endif
+
+	if (rstc_jpeg != NULL)
+		reset_control_put(rstc_jpeg);
+
+	jpu_clk_put(s_jpu_clk);
+
+
+	if (s_jpu_reg_virt_base) {
+		iounmap(s_jpu_reg_virt_base);
+		s_jpu_reg_virt_base = (void *)0x00;
+	}
+
+#endif //JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	return;
+}
+
+MODULE_AUTHOR("A customer using RTK JPU, Inc.");
+MODULE_DESCRIPTION("JPU linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(jpu_init);
+module_exit(jpu_exit);
+
+int jpu_hw_reset(void)
+{
+	u32 val;
+
+	pr_info("%s request jpu reset from application\n", DEV_NAME);
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_reset(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+	val = ReadJpuRegister(JPEG_DBUS_REG);
+	val |= (dbus_en << 0);
+	val &= ~(1 << 1); //Disable idle gating, fix it later.
+	WriteJpuRegister(JPEG_DBUS_REG, val);
+	return 0;
+}
+
+struct clk *jpu_clk_get(struct device *dev)
+{
+	return clk_get(dev, JPU_CLK_NAME);
+}
+
+void jpu_clk_put(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk)))
+		clk_put(clk);
+}
+
+int jpu_clk_enable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+//		pr_info("%s jpu_clk_enable\n", DEV_NAME);
+		return clk_prepare_enable(clk);
+	}
+	return 0;
+}
+
+void jpu_clk_disable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+//		pr_info("%s jpu_clk_disable\n", DEV_NAME);
+		clk_disable_unprepare(clk);
+	}
+}
+
+static const struct of_device_id rtk_jpeg_dt_match[] = {
+	{ .compatible = "Realtek,rtk16xx-jpeg" },
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtk_jpeg_dt_match);
+
+const struct dev_pm_ops rtk_jpeg_pmops = {
+	.suspend = jpu_suspend,
+	.resume = jpu_resume,
+};
+
+static struct platform_driver rtk_jpeg_driver = {
+	.driver = {
+		.name = "rtk-jpeg",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_jpeg_dt_match,
+		.pm = &rtk_jpeg_pmops,
+	},
+	.probe = jpu_probe,
+	.remove = jpu_remove,
+};
+
+module_platform_driver(rtk_jpeg_driver);
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/jpu.h b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/jpu.h
new file mode 100644
index 00000000..fce5113
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/jdi/jpu.h
@@ -0,0 +1,47 @@
+
+
+#ifndef __JPU_DRV_H__
+#define __JPU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+#define J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+
+#define JDI_IOCTL_MAGIC  'J'
+#define JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY			_IO(JDI_IOCTL_MAGIC, 0)
+#define JDI_IOCTL_FREE_PHYSICALMEMORY			_IO(JDI_IOCTL_MAGIC, 1)
+#define JDI_IOCTL_WAIT_INTERRUPT			_IO(JDI_IOCTL_MAGIC, 2)
+#define JDI_IOCTL_SET_CLOCK_GATE			_IO(JDI_IOCTL_MAGIC, 3)
+#define JDI_IOCTL_RESET						_IO(JDI_IOCTL_MAGIC, 4)
+#define JDI_IOCTL_GET_INSTANCE_POOL			_IO(JDI_IOCTL_MAGIC, 5)
+#define JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO			_IO(JDI_IOCTL_MAGIC, 6)
+#define JDI_IOCTL_OPEN_INSTANCE				_IO(JDI_IOCTL_MAGIC, 7)
+#define JDI_IOCTL_CLOSE_INSTANCE			_IO(JDI_IOCTL_MAGIC, 8)
+#define JDI_IOCTL_GET_INSTANCE_NUM			_IO(JDI_IOCTL_MAGIC, 9)
+#define JDI_IOCTL_ENABLE_INTERRUPT			_IO(JDI_IOCTL_MAGIC, 10)
+#define JDI_IOCTL_GET_REGISTER_INFO			_IO(JDI_IOCTL_MAGIC, 11)
+
+/* RTK ioctl */
+#define JDI_IOCTL_SET_CLOCK_ENABLE			_IO(JDI_IOCTL_MAGIC, 12)
+#define JDI_IOCTL_GET_BONDING_INFO			_IO(JDI_IOCTL_MAGIC, 13)
+#define JDI_IOCTL_SET_RTK_DOVI_FLAG			_IO(JDI_IOCTL_MAGIC, 14)
+
+typedef struct jpudrv_buffer_t {
+    unsigned int size;
+    unsigned long phys_addr;
+    unsigned long base;							/* kernel logical address in use kernel */
+    unsigned long virt_addr;				/* virtual user space address */
+} jpudrv_buffer_t;
+
+typedef struct jpudrv_intr_info_t {
+    unsigned int timeout;
+    int intr_reason;
+} jpudrv_intr_info_t;
+
+typedef struct jpudrv_dovi_info_t{
+	unsigned int inst_idx;
+	unsigned int enable;
+} jpudrv_dovi_info_t;
+
+#endif
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/puwrap.c b/drivers/soc/realtek/rtd13xx/rtk_ve/puwrap.c
new file mode 100644
index 00000000..da6f032
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/puwrap.c
@@ -0,0 +1,577 @@
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/module.h>
+
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/dma-buf.h>
+#include <linux/reservation.h>
+
+#include "puwrap.h"
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#define USE_ION_ALLOCATOR
+#ifdef USE_ION_ALLOCATOR
+#define NUM_ION_STRUCT 256
+#include "../../../../staging/android/ion/ion.h"
+#include "../../../../staging/android/uapi/ion_rtk.h"
+struct rtkdrv_ion_buffer_t {
+    unsigned int size;
+    unsigned int inUse;
+    unsigned long phys_addr;
+    unsigned long dmabuf;
+    unsigned long pIonHandle;
+};
+extern struct ion_device *rtk_phoenix_ion_device;
+struct ion_client *pu_client = NULL;
+struct rtkdrv_ion_buffer_t pu_ion_buffer[NUM_ION_STRUCT];
+static DEFINE_MUTEX(s_pu_mutex);
+#else /* else USE_ION_ALLOCATOR */
+typedef struct rtkdrv_buffer_t {
+    unsigned int size;
+    unsigned long phys_addr;
+    unsigned long base;							/* kernel logical address in use kernel */
+    unsigned long virt_addr;				/* virtual user space address */
+} rtkdrv_buffer_t;
+
+#define RTK_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)
+#define RTK_DRAM_PHYSICAL_BASE 0x06000000
+#include "rtk_mm.h"
+static video_mm_t s_mem;
+static rtkdrv_buffer_t s_memory = {0};
+#endif /* endif USE_ION_ALLOCATOR */
+#define VE_SECURE_NORMAL 1
+#define VE_SECURE_PROTECTION 2
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+typedef struct rtkdrv_dovi_flag_t{
+	int nCoreIdx;
+	int nInstIdx;
+	unsigned int bEnable;
+} rtkdrv_dovi_flag_t;
+
+unsigned long pll_phy_register = 0;
+unsigned long pll_virt_register = 0;
+unsigned long pll_size_register = 0;
+rtkdrv_dovi_flag_t dovi_flag = {-1, -1, 0};
+static DEFINE_MUTEX(s_dovi_mutex);
+
+
+#define PU_PLATFORM_DEVICE_NAME "rtk_puwrap"
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+int pu_alloc_dma_buffer(unsigned int size, unsigned long *phys_addr, unsigned long *base, unsigned int mem_type)
+{
+#ifdef USE_ION_ALLOCATOR
+    int ret = -1;
+
+    if (!size)
+        return -1;
+
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct ion_handle *handle;
+        struct dma_buf *dmabuf;
+        ion_phys_addr_t dat;
+        size_t len;
+        int heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+        int flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].inUse == 0)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] NUM_ION_STRUCT is too small!!!");
+            break;
+        }
+
+        switch(mem_type)
+        {
+            case VE_SECURE_NORMAL:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+                    flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED | ION_FLAG_VE_SPEC);
+                    break;
+                }
+            case VE_SECURE_PROTECTION:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_SECURE_MASK;
+                    flags = (ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+                    break;
+                }
+            default:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+                    flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+                    break;
+                }
+        }
+
+        handle = ion_alloc(pu_client, size, 1024, heap, flags);
+        if (IS_ERR(handle))
+        {
+            printk(KERN_ERR "[PUWRAP] ion_alloc allocation error size=%d\n", size);
+            break;
+        }
+
+        if(ion_phys(pu_client, handle, &dat, &len) != 0)
+        {
+            ion_free(pu_client, handle);
+            printk(KERN_ERR "[PUWRAP] ion_alloc allocation error size=%d\n", size);
+            break;
+        }
+
+        dmabuf = ion_share_dma_buf(pu_client, handle);
+        if (IS_ERR(dmabuf)) {
+            ion_unmap_kernel(pu_client, handle);
+            ion_free(pu_client, handle);
+            printk(KERN_ERR "[PUWRAP] ion_share_dma_buf error %p (size=%d)\n", dmabuf, size);
+            break;
+        }
+
+        *base = (unsigned long) dmabuf; // we didn't need base address on user space, but we also need it has value to do detection
+        *phys_addr = (unsigned long)dat;
+
+        pu_ion_buffer[i].size = size;
+        pu_ion_buffer[i].inUse = 1;
+        pu_ion_buffer[i].phys_addr = (unsigned long)*phys_addr;
+        pu_ion_buffer[i].dmabuf = (unsigned long)dmabuf;
+        pu_ion_buffer[i].pIonHandle = (unsigned long)handle;
+
+        ret = 0;
+        break;
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+    return ret;
+
+#else /* else USE_ION_ALLOCATOR */
+    if (!size)
+        return -1;
+
+    *phys_addr = (unsigned long)vmem_alloc(&s_mem, size, 0);
+    if (*phys_addr  == (unsigned long)-1)
+    {
+        printk(KERN_ERR "[PUWRAP] Physical memory allocation error size=%d\n", size);
+        return -1;
+    }
+
+    *base = (unsigned long)(s_memory.base + (*phys_addr - s_memory.phys_addr));
+    //printk("[PUWARP] base:0x%lx, phy_addr:0x%lx, size:%d\n", *base, (unsigned long)*phys_addr, size);
+
+    return 0;
+#endif /* endif USE_ION_ALLOCATOR */
+}
+
+void pu_free_dma_buffer(unsigned long base, unsigned long phys_addr)
+{
+    if (!base)
+        return;
+
+#ifdef USE_ION_ALLOCATOR
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct ion_handle *handle;
+        struct dma_buf *dmabuf;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if (dmabuf != NULL)
+        {
+            dma_buf_put(dmabuf);
+            pu_ion_buffer[i].dmabuf = (unsigned long) NULL;
+        }
+
+        handle = (struct ion_handle *)pu_ion_buffer[i].pIonHandle;
+        if(handle != NULL)
+        {
+            ion_free(pu_client, handle);
+        }
+        memset(&pu_ion_buffer[i], 0, sizeof(struct rtkdrv_ion_buffer_t));
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+#else
+    vmem_free(&s_mem, (unsigned long)phys_addr, 0);
+#endif
+}
+
+int pu_mmap_dma_buffer(struct vm_area_struct *vm)
+{
+#ifdef USE_ION_ALLOCATOR
+    u32 i;
+    int ret = 0;
+    struct dma_buf *dmabuf;
+    unsigned long phys_addr = (unsigned long)(vm->vm_pgoff << PAGE_SHIFT);
+    mutex_lock(&s_pu_mutex);
+
+    for (i = 0; i < NUM_ION_STRUCT; i++)
+    {
+        if (pu_ion_buffer[i].phys_addr == phys_addr)
+            break;
+    }
+    if (i == NUM_ION_STRUCT)
+    {
+        printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+        mutex_unlock(&s_pu_mutex);
+        return -EINVAL;
+    }
+
+    dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+    ret = dma_buf_mmap(dmabuf, vm, 0);
+
+    mutex_unlock(&s_pu_mutex);
+
+    return ret;
+#else
+    return -EINVAL;
+#endif
+}
+
+unsigned long pu_mmap_kernel_buffer(unsigned long phys_addr, unsigned int size)
+{
+#ifdef USE_ION_ALLOCATOR
+    unsigned long ret = 0;
+
+    if (!size)
+        return 0;
+
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct dma_buf *dmabuf;
+        void * virt_addr;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if(dmabuf != NULL)
+        {
+            ret = dma_buf_begin_cpu_access(dmabuf, 0);
+            if (ret) {
+                printk(KERN_ERR "[PUWRAP] dma_buf_begin_cpu_access error ret=%d (size=%d) \n", ret, size);
+                break;
+            }
+            virt_addr = dma_buf_kmap(dmabuf, 0);
+            if (IS_ERR_OR_NULL(virt_addr)) {
+                printk(KERN_ERR "[PUWRAP] dma_buf_kmap error %p (size=%d) \n", virt_addr, size);
+                break;
+            }
+
+            ret = (unsigned long)virt_addr;
+        }
+    } while(0);
+    mutex_unlock(&s_pu_mutex);
+
+    return ret;
+#endif
+}
+
+void pu_unmap_kernel_buffer(unsigned long base, unsigned long phys_addr)
+{
+    if (!base)
+        return;
+
+#ifdef USE_ION_ALLOCATOR
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct dma_buf *dmabuf;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if(dmabuf != NULL)
+        {
+            dma_buf_kunmap(dmabuf, 0, (void *)base);
+            dma_buf_end_cpu_access(dmabuf, 0);
+        }
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+#endif
+}
+#endif //#ifdef CONFIG_RTK_RESERVE_MEMORY
+
+void pu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable)
+{
+    if (pll_phy_register == 0 || pll_virt_register == 0 || pll_size_register == 0)
+    {
+        printk(KERN_WARNING "In[%s][%d] didn't get pll register\n", __FUNCTION__, __LINE__);
+        return;
+    }
+    else if (offset > pll_size_register)
+    {
+        printk(KERN_WARNING "In[%s][%d] offset over than register size\n", __FUNCTION__, __LINE__);
+        return;
+    }
+
+    if (bOverwrite == 1)
+    {
+        __raw_writel(value, (volatile u8 *)(pll_virt_register+offset));
+    }
+    else
+    {
+        if (bEnable)
+        {
+            __raw_writel(__raw_readl((volatile u8 *)(pll_virt_register+offset)) | value, (volatile u8 *)(pll_virt_register+offset));
+        }
+        else
+        {
+            __raw_writel(__raw_readl((volatile u8 *)(pll_virt_register+offset)) & value, (volatile u8 *)(pll_virt_register+offset));
+        }
+    }
+}
+
+int pu_set_dovi_flag(int nCoreIdx, int nInstIdx, unsigned int bEnable)
+{
+	int ret = 0;
+	//pr_info("VE1: dovi_flag[%p, %d, %d, %d], input[%d, %d, %d]\n", &dovi_flag, dovi_flag.nCoreIdx, dovi_flag.nInstIdx, dovi_flag.bEnable, nCoreIdx, nInstIdx, bEnable);
+
+	mutex_lock(&s_dovi_mutex);
+	if (bEnable == 1)
+	{
+		if (dovi_flag.bEnable == 0)
+		{
+			dovi_flag.bEnable = 1;
+			dovi_flag.nCoreIdx = nCoreIdx;
+			dovi_flag.nInstIdx = nInstIdx;
+			ret = 1;
+		}
+	}
+	else
+	{
+		if (dovi_flag.bEnable == 1 && dovi_flag.nCoreIdx == nCoreIdx && dovi_flag.nInstIdx == nInstIdx)
+		{
+			dovi_flag.bEnable = 0;
+			dovi_flag.nCoreIdx = -1;
+			dovi_flag.nInstIdx = -1;
+		}
+	}
+	mutex_unlock(&s_dovi_mutex);
+
+	return ret;
+}
+
+static int pu_probe(struct platform_device *pdev)
+{
+    struct resource res;
+    void __iomem *iobase;
+    struct device_node *node;
+
+    printk(KERN_INFO "[PUWRAP] pu_probe\n");
+
+    node = pdev->dev.of_node;
+    of_address_to_resource(node, 0, &res);
+    iobase = of_iomap(node, 0);
+
+    pll_phy_register = res.start;
+    pll_virt_register = (unsigned long)iobase;
+    pll_size_register = res.end - res.start + 1;
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifdef USE_ION_ALLOCATOR
+    pu_client = ion_client_create(rtk_phoenix_ion_device, "PUDriver");
+    memset(pu_ion_buffer, 0, sizeof(struct rtkdrv_ion_buffer_t)*NUM_ION_STRUCT);
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device with USE_ION_ALLOCATOR\n");
+#else /* else USE_ION_ALLOCATOR */
+    if(pdev)
+        res = platform_get_resource(pdev, IORESOURCE_MEM, 1);
+    if(res)
+    {
+        s_memory.size = res->end - res->start;
+        s_memory.phys_addr = res->start;
+    }
+    else
+    {
+        s_memory.size = RTK_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+        s_memory.phys_addr = RTK_DRAM_PHYSICAL_BASE;
+    }
+
+    s_memory.base = (unsigned long)ioremap(s_memory.phys_addr, PAGE_ALIGN(s_memory.size));
+    if (!s_memory.base)
+    {
+        printk(KERN_ERR "[PUWRAP] :  fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", (int)s_memory.phys_addr, (int)s_memory.base, (int)s_memory.size);
+        goto ERROR_PROVE_DEVICE;
+    }
+    if (vmem_init(&s_mem, s_memory.phys_addr, s_memory.size) < 0)
+    {
+        printk(KERN_ERR "[PUWRAP] :  fail to init vmem system\n");
+        goto ERROR_PROVE_DEVICE;
+    }
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device with reserved video memory phys_addr=0x%x, base = 0x%x\n", (int) s_memory.phys_addr, (int)s_memory.base);
+#endif /* endif USE_ION_ALLOCATOR */
+#else /* else CONFIG_RTK_RESERVE_MEMORY */
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device\n");
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+
+    return 0;
+
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifndef USE_ION_ALLOCATOR
+ERROR_PROVE_DEVICE:
+
+    return 0;
+#endif
+#endif
+}
+
+static int pu_remove(struct platform_device *pdev)
+{
+    printk(KERN_INFO "[PUWRAP] pu_remove\n");
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifdef USE_ION_ALLOCATOR
+    if(pu_client != NULL)
+    {
+        ion_client_destroy(pu_client);
+        pu_client = NULL;
+    }
+#else /* else USE_ION_ALLOCATOR */
+    if (s_memory.base)
+    {
+        iounmap((void *)s_memory.base);
+        s_memory.base = 0;
+        vmem_exit(&s_mem);
+    }
+#endif /* endif USE_ION_ALLOCATOR */
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+    return 0;
+}
+
+#if 0
+static struct platform_driver pu_driver = {
+    .driver = {
+        .name = PU_PLATFORM_DEVICE_NAME,
+    },
+    .probe = pu_probe,
+    .remove = pu_remove,
+};
+#endif
+
+static ssize_t pu_memsize_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    return sprintf(buf, "%d\n", (int)(get_num_physpages() << PAGE_SHIFT));
+}
+
+static struct kobj_attribute pu_memsize_attr =
+    __ATTR(pu_memsize, 0644, pu_memsize_show, NULL);
+
+static struct attribute *pu_attrs[] = {
+    &pu_memsize_attr.attr,
+    NULL,
+};
+
+static struct attribute_group rtk_pu_attr_group = {
+    .attrs = pu_attrs,
+};
+
+static struct kobject *pu_kobj;
+
+static int __init pu_init(void)
+{
+    int res = 0;
+
+    pu_kobj = kobject_create_and_add("rtk_pu", kernel_kobj);
+    if (pu_kobj)
+    {
+        res = sysfs_create_group(pu_kobj, &rtk_pu_attr_group);
+        if (res)
+            printk(KERN_WARNING "[PUWRAP] %d: unable to create sysfs entry\n", __LINE__);
+    }
+    else
+        printk(KERN_WARNING "[PUWRAP] %d: unable to create sysfs entry\n", __LINE__);
+
+    printk(KERN_INFO "[PUWRAP] begin pu_init\n");
+    //res = platform_driver_register(&pu_driver);
+    printk(KERN_INFO "[PUWRAP] end pu_init result=0x%x\n", res);
+    return res;
+}
+
+static void __exit pu_exit(void)
+{
+    printk(KERN_INFO "[PUWRAP] pu_exit\n");
+    //platform_driver_unregister(&pu_driver);
+    return;
+}
+
+
+static const struct of_device_id rtk_pu_dt_match[] = {
+    { .compatible = "Realtek,rtk16xx-pu_pll" },
+    {}
+};
+MODULE_DEVICE_TABLE(of, rtk_pu_dt_match);
+
+const struct dev_pm_ops rtk_pu_pmops = {
+    .suspend    = NULL,
+    .resume     = NULL,
+};
+
+static struct platform_driver rtk_pu_driver = {
+    .driver		= {
+        .name	= "rtk-pu",
+        .owner	= THIS_MODULE,
+        .of_match_table = rtk_pu_dt_match,
+        //.pm	= SDHCI_PLTFM_PMOPS,
+        .pm	= &rtk_pu_pmops,
+    },
+    .probe		= pu_probe,
+    .remove		= pu_remove,
+};
+
+module_platform_driver(rtk_pu_driver);
+
+MODULE_AUTHOR("RTK Wrapper for JPU & VPU, Inc.");
+MODULE_DESCRIPTION("PU WRAPPER linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(pu_init);
+module_exit(pu_exit);
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/puwrap.h b/drivers/soc/realtek/rtd13xx/rtk_ve/puwrap.h
new file mode 100644
index 00000000..f065d21
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/puwrap.h
@@ -0,0 +1,44 @@
+
+
+#ifndef __PU_DRV_H__
+#define __PU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+
+#define PDI_IOCTL_MAGIC  'V'
+
+#define PLL_CLK_715 (0x10D336)
+#define PLL_CLK_702 (0x10C186)
+#define PLL_CLK_675 (0x10C176)
+#define PLL_CLK_648 (0x10C166)
+#define PLL_CLK_594 (0x10C146)
+#define PLL_CLK_567 (0x10C136)
+#define PLL_CLK_337 (0x12C176)
+#define PLL_CLK_297 (0x12C146)
+
+#define UNUSED_PARAMETER(p) (void)(p)
+
+#define MISC_JPU_MINOR 107
+#define MISC_MEM_MINOR 108
+#define MISC_VE3_MINOR 109
+#define MISC_VE1_MINOR 110
+
+typedef struct pu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long jpu_interrupt_reason;
+	unsigned long vpu_interrupt_reason;
+} pu_drv_context_t;
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+int pu_alloc_dma_buffer(unsigned int size, unsigned long *phys_addr, unsigned long *base, unsigned int mem_type);
+void pu_free_dma_buffer(unsigned long base, unsigned long phys_addr);
+int pu_mmap_dma_buffer(struct vm_area_struct *vm);
+unsigned long pu_mmap_kernel_buffer(unsigned long phys_addr, unsigned int size);
+void pu_unmap_kernel_buffer(unsigned long base, unsigned long phys_addr);
+#endif
+void pu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable);
+int pu_set_dovi_flag(int nCoreIdx, int nInstIdx, unsigned int bEnable);
+
+#endif
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/Makefile b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/Makefile
new file mode 100644
index 00000000..45a2a98
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/Makefile
@@ -0,0 +1,7 @@
+# rtk_vcodec
+
+obj-$(CONFIG_VE1_CODEC) += ve1.o
+obj-$(CONFIG_VE1_CODEC) += ve1_pm.o
+ifdef CONFIG_COMPAT
+obj-$(CONFIG_VE1_CODEC) += compat_ve1.o
+endif
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/compat_ve1.c b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/compat_ve1.c
new file mode 100644
index 00000000..c9b4619
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/compat_ve1.c
@@ -0,0 +1,666 @@
+/*
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/compat.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#include "ve1.h"
+#include "compat_ve1.h"
+
+/* See drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1.h for the definition of these structs */
+typedef struct compat_vpudrv_buffer_t {
+	compat_uint_t size;
+	compat_ulong_t phys_addr;
+	compat_ulong_t base; /* kernel logical address in use kernel */
+	compat_ulong_t virt_addr; /* virtual user space address */
+	compat_uint_t mem_type;
+} compat_vpudrv_buffer_t;
+
+typedef struct compat_vpu_clock_info_t{
+	compat_uint_t core_idx;
+	compat_uint_t enable;
+	compat_uint_t value;
+} compat_vpu_clock_info_t;
+
+typedef struct compat_vpudrv_inst_info_t {
+	compat_uint_t core_idx;
+	compat_uint_t inst_idx;
+	compat_int_t inst_open_count;	/* for output only*/
+} compat_vpudrv_inst_info_t;
+
+typedef struct compat_vpudrv_intr_info_t {
+	compat_uint_t core_idx;
+	compat_uint_t timeout;
+	compat_int_t intr_reason;
+#ifdef SUPPORT_MULTI_INST_INTR
+	compat_int_t intr_inst_index;
+#endif
+} compat_vpudrv_intr_info_t;
+
+typedef struct compat_vpudrv_dovi_info_t{
+	compat_uint_t core_idx;
+	compat_uint_t inst_idx;
+	compat_uint_t enable;
+} compat_vpudrv_dovi_info_t;
+
+#define COMPAT_VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(VDI_IOCTL_MAGIC, 0)
+#define COMPAT_VDI_IOCTL_FREE_PHYSICALMEMORY _IO(VDI_IOCTL_MAGIC, 1)
+#define COMPAT_VDI_IOCTL_WAIT_INTERRUPT _IO(VDI_IOCTL_MAGIC, 2)
+#define COMPAT_VDI_IOCTL_GET_INSTANCE_POOL _IO(VDI_IOCTL_MAGIC, 5)
+#define COMPAT_VDI_IOCTL_GET_COMMON_MEMORY _IO(VDI_IOCTL_MAGIC, 6)
+#define COMPAT_VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(VDI_IOCTL_MAGIC, 8)
+#define COMPAT_VDI_IOCTL_OPEN_INSTANCE _IO(VDI_IOCTL_MAGIC, 9)
+#define COMPAT_VDI_IOCTL_CLOSE_INSTANCE _IO(VDI_IOCTL_MAGIC, 10)
+#define COMPAT_VDI_IOCTL_GET_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 11)
+#define COMPAT_VDI_IOCTL_GET_REGISTER_INFO _IO(VDI_IOCTL_MAGIC, 12)
+
+/* RTK ioctl */
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_GATING _IO(VDI_IOCTL_MAGIC, 16)
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 17)
+#define COMPAT_VDI_IOCTL_GET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 18)
+#define COMPAT_VDI_IOCTL_GET_RTK_SUPPORT_TYPE _IO(VDI_IOCTL_MAGIC, 19)
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 21)
+#define COMPAT_VDI_IOCTL_GET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 22)
+#define COMPAT_VDI_IOCTL_SET_RTK_DOVI_FLAG _IO(VDI_IOCTL_MAGIC, 23)
+#define COMPAT_VDI_IOCTL_GET_TOTAL_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 24)
+#define COMPAT_VDI_IOCTL_GET_RTK_DCSYS_INFO _IO(VDI_IOCTL_MAGIC, 25)
+
+static int compat_get_ve1_buffer_data(
+	compat_vpudrv_buffer_t __user *data32,
+	vpudrv_buffer_t __user *data)
+{
+	compat_uint_t s;
+	compat_ulong_t p;
+	compat_ulong_t b;
+	compat_ulong_t v;
+	compat_uint_t m;
+	int err;
+
+	err = get_user(s, &data32->size);
+	err |= put_user(s, &data->size);
+	err |= get_user(p, &data32->phys_addr);
+	err |= put_user(p, &data->phys_addr);
+	err |= get_user(b, &data32->base);
+	err |= put_user(b, &data->base);
+	err |= get_user(v, &data32->virt_addr);
+	err |= put_user(v, &data->virt_addr);
+	err |= get_user(m, &data32->mem_type);
+	err |= put_user(m, &data->mem_type);
+
+	return err;
+}
+
+static int compat_get_ve1_inst_info_data(
+	compat_vpudrv_inst_info_t __user *data32,
+	vpudrv_inst_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_int_t ioc;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(i, &data32->inst_idx);
+	err |= put_user(i, &data->inst_idx);
+	err |= get_user(ioc, &data32->inst_open_count);
+	err |= put_user(ioc, &data->inst_open_count);
+
+	return err;
+}
+
+static int compat_get_ve1_intr_info_data(
+	compat_vpudrv_intr_info_t __user *data32,
+	vpudrv_intr_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t t;
+	compat_int_t i;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(t, &data32->timeout);
+	err |= put_user(t, &data->timeout);
+	err |= get_user(i, &data32->intr_reason);
+	err |= put_user(i, &data->intr_reason);
+#ifdef SUPPORT_MULTI_INST_INTR
+	err |= get_user(i, &data32->intr_inst_index);
+	err |= put_user(i, &data->intr_inst_index);
+#endif
+
+	return err;
+}
+
+static int compat_get_ve1_clock_info(
+	compat_vpu_clock_info_t __user *data32,
+	vpu_clock_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_uint_t v;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(e, &data32->enable);
+	err |= put_user(e, &data->enable);
+	err |= get_user(v, &data32->value);
+	err |= put_user(v, &data->value);
+
+	return err;
+}
+
+static int compat_get_ve1_dovi_info(
+	compat_vpudrv_dovi_info_t __user *data32,
+	vpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_uint_t i;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(i, &data32->inst_idx);
+	err |= put_user(i, &data->inst_idx);
+	err |= get_user(e, &data32->enable);
+	err |= put_user(e, &data->enable);
+
+	return err;
+}
+
+static int compat_put_ve1_buffer_data(
+	compat_vpudrv_buffer_t __user *data32,
+	vpudrv_buffer_t __user *data)
+{
+	compat_uint_t s;
+	compat_ulong_t p;
+	compat_ulong_t b;
+	compat_ulong_t v;
+	compat_uint_t m;
+	int err;
+
+	err = get_user(s, &data->size);
+	err |= put_user(s, &data32->size);
+	err |= get_user(p, &data->phys_addr);
+	err |= put_user(p, &data32->phys_addr);
+	err |= get_user(b, &data->base);
+	err |= put_user(b, &data32->base);
+	err |= get_user(v, &data->virt_addr);
+	err |= put_user(v, &data32->virt_addr);
+	err |= get_user(m, &data->mem_type);
+	err |= put_user(m, &data32->mem_type);
+
+	return err;
+}
+
+static int compat_put_ve1_inst_info_data(
+	compat_vpudrv_inst_info_t __user *data32,
+	vpudrv_inst_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_int_t ioc;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(i, &data->inst_idx);
+	err |= put_user(i, &data32->inst_idx);
+	err |= get_user(ioc, &data->inst_open_count);
+	err |= put_user(ioc, &data32->inst_open_count);
+
+	return err;
+}
+
+static int compat_put_ve1_intr_info_data(
+	compat_vpudrv_intr_info_t __user *data32,
+	vpudrv_intr_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t t;
+	compat_int_t i;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(t, &data->timeout);
+	err |= put_user(t, &data32->timeout);
+	err |= get_user(i, &data->intr_reason);
+	err |= put_user(i, &data32->intr_reason);
+
+	return err;
+}
+
+static int compat_put_ve1_clock_info(
+	compat_vpu_clock_info_t __user *data32,
+	vpu_clock_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_uint_t v;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(e, &data->enable);
+	err |= put_user(e, &data32->enable);
+	err |= get_user(v, &data->value);
+	err |= put_user(v, &data32->value);
+
+	return err;
+}
+
+static int compat_put_ve1_dovi_info(
+	compat_vpudrv_dovi_info_t __user *data32,
+	vpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_uint_t e;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(i, &data->inst_idx);
+	err |= put_user(i, &data32->inst_idx);
+	err |= get_user(e, &data->enable);
+	err |= put_user(e, &data32->enable);
+
+	return err;
+}
+
+long compat_vpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	long ret = 0;
+
+	if (!filp->f_op->unlocked_ioctl)
+		return -ENOTTY;
+
+	switch (cmd) {
+	case COMPAT_VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_FREE_PHYSICALMEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_FREE_PHYSICALMEMORY, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_WAIT_INTERRUPT:
+	{
+		compat_vpudrv_intr_info_t __user *data32;
+		vpudrv_intr_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_intr_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_WAIT_INTERRUPT, (unsigned long)data);
+		err = compat_put_ve1_intr_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case VDI_IOCTL_SET_CLOCK_GATE:
+	case VDI_IOCTL_RESET:
+	case VDI_IOCTL_GET_RTK_ASIC_REVISION:
+	{
+		return filp->f_op->unlocked_ioctl(filp, cmd,
+										  (unsigned long)compat_ptr(arg));
+	}
+
+	case COMPAT_VDI_IOCTL_GET_INSTANCE_POOL:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_INSTANCE_POOL, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_COMMON_MEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_COMMON_MEMORY, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_OPEN_INSTANCE:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_OPEN_INSTANCE, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_CLOSE_INSTANCE:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_CLOSE_INSTANCE, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_INSTANCE_NUM:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_INSTANCE_NUM, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_REGISTER_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_REGISTER_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_GATING:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_GATING, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_PLL:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_PLL, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_CLK_PLL:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_CLK_PLL, (unsigned long)data);
+		err = compat_put_ve1_clock_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_SELECT:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_SELECT, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_CLK_SELECT:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_CLK_SELECT, (unsigned long)data);
+		err = compat_put_ve1_clock_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_DOVI_FLAG:
+	{
+		compat_vpudrv_dovi_info_t __user *data32;
+		vpudrv_dovi_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_dovi_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_DOVI_FLAG, (unsigned long)data);
+		err = compat_put_ve1_dovi_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_SUPPORT_TYPE:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_SUPPORT_TYPE, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_DCSYS_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_DCSYS_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_TOTAL_INSTANCE_NUM:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_TOTAL_INSTANCE_NUM, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	default:
+	{
+		printk(KERN_ERR "[COMPAT_VPUDRV] No such IOCTL, cmd is %d\n", cmd);
+		return -ENOIOCTLCMD;
+	}
+	}
+}
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/compat_ve1.h b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/compat_ve1.h
new file mode 100644
index 00000000..15c1161
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/compat_ve1.h
@@ -0,0 +1,42 @@
+/*
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_COMPAT_VE1_H
+#define _LINUX_COMPAT_VE1_H
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+typedef struct compat_vpu_bit_firmware_info_t {
+	compat_uint_t size; /* size of this structure*/
+	compat_uint_t core_idx;
+	compat_ulong_t reg_base_offset;
+	compat_ushort_t bit_code[512];
+} compat_vpu_bit_firmware_info_t;
+
+long compat_vpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+
+#else
+
+typedef struct compat_vpu_bit_firmware_info_t {
+	unsigned int size; /* size of this structure*/
+	unsigned int core_idx;
+	unsigned long reg_base_offset;
+	unsigned short bit_code[512];
+} compat_vpu_bit_firmware_info_t;
+
+#define compat_vpu_ioctl  NULL
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_VE1_H */
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1.c b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1.c
new file mode 100755
index 00000000..33e6e76
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1.c
@@ -0,0 +1,1965 @@
+/*
+ * ve1.c
+ *
+ * linux device driver for VE1.
+ *
+ * Copyright (C) 2006 - 2013  REALTEK INC.
+ *
+ * This library is free software; you can redistribute it and/or modify it under
+ * the terms of the GNU Lesser General Public License as published by the Free
+ * Software Foundation; either version 2.1 of the License, or (at your option)
+ * any later version.
+ *
+ * This library is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+ * details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this library; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301  USA
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/kfifo.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <soc/realtek/rtk_cpu.h>
+
+#ifdef CONFIG_COMPAT
+#include <linux/compat.h>
+#endif
+
+#include "ve1config.h"
+#include "ve1.h"
+#include "ve1_pm.h"
+#include "compat_ve1.h"
+#include "../puwrap.h"
+
+//#define ENABLE_DEBUG_MSG
+#ifdef ENABLE_DEBUG_MSG
+#define DPRINTK(args...) pr_info(args);
+#else
+#define DPRINTK(args...)
+#endif /* ENABLE_DEBUG_MSG */
+
+#define DEV_NAME "[RTK_VE1]"
+#define DISABLE_ORIGIN_SUSPEND
+#define USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+#define VE1_ALWAYS_ON
+
+/* definitions to be changed as customer  configuration */
+/* if you want to have clock gating scheme frame by frame */
+/* #define VPU_SUPPORT_CLOCK_CONTROL */
+
+/* if the driver want to use interrupt service from kernel ISR */
+#define VPU_SUPPORT_ISR
+
+/* if the platform driver knows the name of this driver */
+/* VPU_PLATFORM_DEVICE_NAME */
+#define VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+/* if this driver knows the dedicated video memory address */
+#ifndef CONFIG_RTK_RESERVE_MEMORY
+#ifdef CONFIG_RTK_PLATFORM_FPGA
+#define VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#endif
+#endif
+
+#define VPU_PLATFORM_DEVICE_NAME "vdec"
+#define VPU_CLK_NAME "vcodec"
+#define VPU_DEV_NAME "vpu"
+
+/* if the platform driver knows this driver */
+/* the definition of VPU_REG_BASE_ADDR and VPU_REG_SIZE are not meaningful */
+
+#define VPU_REG_BASE_ADDR 0x98040000
+#define VPU_REG_SIZE (0xC000)
+#define MS_TO_NS(x) (x * 1E6L)
+
+#ifdef VPU_SUPPORT_ISR
+#define VE1_IRQ_NUM (85)
+#define VE3_IRQ_NUM (87)
+#endif
+
+/* this definition is only for realtek FPGA board env */
+/* so for SOC env of customers can be ignored */
+
+#ifndef VM_RESERVED	/*for kernel up to 3.7.0 version*/
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+typedef struct vpu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long interrupt_reason_ve1;
+	unsigned long interrupt_reason_ve3;
+	/* !<< device reference count. Not instance count */
+	u32 open_count;
+} vpu_drv_context_t;
+
+/* To track the allocated memory buffer */
+typedef struct vpudrv_buffer_pool_t {
+	struct list_head list;
+	struct vpudrv_buffer_t vb;
+	struct file *filp;
+} vpudrv_buffer_pool_t;
+
+/* To track the instance index and buffer in instance pool */
+typedef struct vpudrv_instanace_list_t {
+	struct list_head list;
+	unsigned long inst_idx;
+	unsigned long core_idx;
+	struct file *filp;
+} vpudrv_instanace_list_t;
+
+typedef struct vpudrv_instance_pool_t {
+	unsigned char codecInstPool[MAX_NUM_INSTANCE][MAX_INST_HANDLE_SIZE];
+	long long pendingInstIdxPlus1;
+	void *pendingInst;
+} vpudrv_instance_pool_t;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#define VPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE 0x0b800000 //(62*1024*1024)
+#define VPU_DRAM_PHYSICAL_BASE 0x03200000 //0x86C00000
+#include "vmm.h"
+static video_mm_t s_vmem;
+static vpudrv_buffer_t s_video_memory = {0};
+#endif /*VPU_SUPPORT_RESERVED_VIDEO_MEMORY*/
+
+static int vpu_hw_reset(u32 coreIdx);
+
+/* end customer definition */
+static vpudrv_buffer_t s_instance_pool = {0};
+static vpudrv_buffer_t s_common_memory = {0};
+static vpu_drv_context_t s_vpu_drv_context;
+static struct miscdevice s_vpu_dev;
+
+static struct device *p_vpu_dev;
+static int s_vpu_open_ref_count;
+
+#ifdef VPU_SUPPORT_ISR
+static int s_ve1_irq = VE1_IRQ_NUM;
+static int s_ve3_irq = VE3_IRQ_NUM;
+#endif /* VPU_SUPPORT_ISR */
+
+static int ve_cti_en = 1;
+/* FIX ME after ver.B IC */
+static int ve_idle_en = 0;
+
+static vpudrv_buffer_t s_vpu_register = {0};
+static vpudrv_buffer_t s_dc_register = {0};
+static vpudrv_buffer_t s_bond_register = {0};
+static vpudrv_buffer_t s_dmc_register = {0};
+
+static atomic_t s_interrupt_flag_ve1;
+static wait_queue_head_t s_interrupt_wait_q_ve1;
+static atomic_t s_interrupt_flag_ve3;
+static wait_queue_head_t s_interrupt_wait_q_ve3;
+
+static spinlock_t s_vpu_lock = __SPIN_LOCK_UNLOCKED(s_vpu_lock);
+static spinlock_t s_ve1_lock = __SPIN_LOCK_UNLOCKED(s_ve1_lock);
+static spinlock_t s_ve3_lock = __SPIN_LOCK_UNLOCKED(s_ve3_lock);
+static DEFINE_SEMAPHORE(s_vpu_sem);
+static struct list_head s_vbp_head = LIST_HEAD_INIT(s_vbp_head);
+static struct list_head s_inst_list_head = LIST_HEAD_INIT(s_inst_list_head);
+
+static vpu_bit_firmware_info_t s_bit_firmware_info[MAX_NUM_VPU_CORE];
+
+#define BIT_BASE 0x0000
+#define BIT_INT_STS (BIT_BASE + 0x010)
+#define BIT_INT_REASON (BIT_BASE + 0x174)
+#define BIT_INT_CLEAR (BIT_BASE + 0x00C)
+#define VE_CTRL_REG (BIT_BASE + 0x3000)
+#define VE_CTI_GRP_REG (BIT_BASE + 0x3004)
+#define VE_INT_STS_REG (BIT_BASE + 0x3020)
+
+#define VE3_CTRL_REG (BIT_BASE + 0x3E00)
+
+#define W4_REG_BASE 0x0000
+#define W4_VPU_VINT_CLEAR (W4_REG_BASE + 0x003C)
+#define W4_VPU_VPU_INT_STS (W4_REG_BASE + 0x0044)
+#define W4_VPU_INT_REASON (W4_REG_BASE + 0x004c)
+#define W4_VPU_INT_REASON_CLEAR (W4_REG_BASE + 0x0034)
+#ifdef CONFIG_PM
+/* implement to power management functions */
+#define BIT_CODE_RUN (BIT_BASE + 0x000)
+#define BIT_CODE_DOWN (BIT_BASE + 0x004)
+#define BIT_INT_CLEAR (BIT_BASE + 0x00C)
+#define BIT_INT_STS (BIT_BASE + 0x010)
+#define BIT_CODE_RESET (BIT_BASE + 0x014)
+#define BIT_INT_REASON (BIT_BASE + 0x174)
+#define BIT_BUSY_FLAG (BIT_BASE + 0x160)
+#define BIT_RUN_COMMAND (BIT_BASE + 0x164)
+#define BIT_RUN_INDEX (BIT_BASE + 0x168)
+#define BIT_RUN_COD_STD (BIT_BASE + 0x16C)
+
+#define W4_VPU_BUSY_STATUS (W4_REG_BASE + 0x0070)
+#define W4_RET_SUCCESS (W4_REG_BASE + 0x0110)
+#define W4_RET_FAIL_REASON (W4_REG_BASE + 0x0114)
+#define W4_PO_CONF (W4_REG_BASE + 0x0000)
+#define W4_VCPU_CUR_PC (W4_REG_BASE + 0x0004)
+#define W4_VPU_INT_ENABLE (W4_REG_BASE + 0x0048)
+#define W4_VPU_RESET_REQ (W4_REG_BASE + 0x0050)
+#define W4_VPU_RESET_STATUS (W4_REG_BASE + 0x0054)
+#define W4_VPU_REMAP_CTRL (W4_REG_BASE + 0x0060)
+#define W4_VPU_REMAP_VADDR (W4_REG_BASE + 0x0064)
+#define W4_VPU_REMAP_PADDR (W4_REG_BASE + 0x0068)
+#define W4_VPU_REMAP_PROC_START (W4_REG_BASE + 0x006C)
+#define W4_VPU_BUSY_STATUS (W4_REG_BASE + 0x0070)
+#define W4_REMAP_CODE_INDEX 0
+enum {
+	W4_INT_INIT_VPU = 0,
+	W4_INT_DEC_PIC_HDR = 1,
+	W4_INT_FINI_SEQ = 2,
+	W4_INT_DEC_PIC = 3,
+	W4_INT_SET_FRAMEBUF = 4,
+	W4_INT_FLUSH_DEC = 5,
+	W4_INT_GET_FW_VERSION = 9,
+	W4_INT_QUERY_DEC = 10,
+	W4_INT_SLEEP_VPU = 11,
+	W4_INT_WAKEUP_VPU = 12,
+	W4_INT_CHANGE_INT = 13,
+	W4_INT_CREATE_INSTANCE = 14,
+	W4_INT_BSBUF_EMPTY = 15,   /*!<< Bitstream buffer empty */
+	W4_INT_ENC_SLICE_INT = 15,
+};
+
+#define W4_HW_OPTION (W4_REG_BASE + 0x0124)
+#define W4_CODE_SIZE (W4_REG_BASE + 0x011C)
+
+#define W4_ADDR_CODE_BASE (W4_REG_BASE + 0x0118)
+#define W4_CODE_PARAM (W4_REG_BASE + 0x0120)
+
+#define W4_ADDR_STACK_BASE (W4_REG_BASE + 0x012C)
+#define W4_STACK_SIZE (W4_REG_BASE + 0x0130)
+#define W4_INIT_VPU_TIME_OUT_CNT (W4_REG_BASE + 0x0134)
+
+#define W4_CORE_INDEX (W4_REG_BASE + 0x0104)
+#define W4_INST_INDEX (W4_REG_BASE + 0x0108)
+#define W4_COMMAND (W4_REG_BASE + 0x0100)
+#define W4_VPU_HOST_INT_REQ (W4_REG_BASE + 0x0038)
+/* Product register */
+#define VPU_PRODUCT_CODE_REGISTER   (BIT_BASE + 0x1044)
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+static u32 s_vpu_reg_store[MAX_NUM_VPU_CORE][64];
+#endif
+#endif /* CONFIG_PM */
+
+/*
+ * common struct and definition
+ */
+#define ReadVpuRegister(addr, core) *(volatile unsigned int *)(s_vpu_register.virt_addr + (0x8000 * core) + addr)
+#define WriteVpuRegister(addr, val, core) *(volatile unsigned int *)(s_vpu_register.virt_addr + (0x8000 * core) + addr) = (unsigned int)val
+#define WriteVpu(addr, val) *(volatile unsigned int *)(addr) = (unsigned int)val;
+
+static void ve1_wrapper_setup(unsigned int coreIdx)
+{
+	unsigned int ctrl_1;
+	unsigned int ctrl_2;
+
+	/* coreIdx == 0 */
+	if ((coreIdx & (1 << 0)) != 0) {
+		ctrl_1 = ReadVpuRegister(VE_CTRL_REG, 0);
+		ctrl_2 = ReadVpuRegister(VE_CTI_GRP_REG, 0);
+		ctrl_1 |= (ve_cti_en << 1 | ve_idle_en << 6);
+		/* ve1_cti_cmd_depth for 1296 timing issue */
+		ctrl_2 = (ctrl_2 & ~(0x3f << 24)) | (0x1a << 24);
+		WriteVpuRegister(VE_CTRL_REG, ctrl_1, 0);
+		WriteVpuRegister(VE_CTI_GRP_REG, ctrl_2, 0);
+	}
+
+	if ((coreIdx & (1 << 1)) != 0)
+	{
+		ctrl_1 = ReadVpuRegister(VE3_CTRL_REG, 1);
+		ctrl_1 |= ve_cti_en;
+		WriteVpuRegister(VE3_CTRL_REG, ctrl_1, 1);
+	}
+}
+
+int vpu_hw_reset(u32 coreIdx)
+{
+	ve_pd_reset_control_reset(coreIdx);
+	ve1_wrapper_setup((1 << coreIdx));
+	return 0;
+}
+
+static int vpu_alloc_dma_buffer(vpudrv_buffer_t *vb)
+{
+	unsigned int ret;
+
+	if (!vb)
+		return -1;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	UNUSED_PARAMETER(ret);
+	vb->phys_addr = (unsigned long)vmem_alloc(&s_vmem, vb->size, 0);
+	if ((unsigned long)vb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+
+	vb->base = (unsigned long)(s_video_memory.base + (vb->phys_addr - s_video_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	ret = pu_alloc_dma_buffer(vb->size, &vb->phys_addr, &vb->base, vb->mem_type);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#else
+	UNUSED_PARAMETER(ret);
+	vb->base = (unsigned long)dma_alloc_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (dma_addr_t *) (&vb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	DPRINTK("%s base:0x%lx, phy_addr:0x%lx, size:%d\n", DEV_NAME, vb->base, vb->phys_addr, vb->size);
+	return 0;
+}
+
+static int vpu_alloc_dma_buffer2(vpudrv_buffer_t *vb)
+{
+	unsigned int ret;
+
+	if (!vb)
+		return -1;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	UNUSED_PARAMETER(ret);
+	vb->phys_addr = (unsigned long)vmem_alloc(&s_vmem, vb->size, 0);
+	if ((unsigned long)vb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+
+	vb->base = (unsigned long)(s_video_memory.base + (vb->phys_addr - s_video_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	ret = pu_alloc_dma_buffer(vb->size, &vb->phys_addr, &vb->base, vb->mem_type);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+	vb->base = pu_mmap_kernel_buffer(vb->phys_addr, vb->size);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s pu_mmap_kernel_buffer error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#else
+	UNUSED_PARAMETER(ret);
+	vb->base = (unsigned long)dma_alloc_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (dma_addr_t *) (&vb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	DPRINTK("%s base:0x%lx, phy_addr:0x%lx, size:%d\n", DEV_NAME, vb->base, vb->phys_addr, vb->size);
+	return 0;
+}
+
+static void vpu_free_dma_buffer(vpudrv_buffer_t *vb)
+{
+	if (!vb)
+		return;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (vb->base)
+		vmem_free(&s_vmem, vb->phys_addr, 0);
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	pu_free_dma_buffer(vb->base, vb->phys_addr);
+#else
+	if (vb->base) {
+		dma_free_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (void *)vb->base, vb->phys_addr);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+}
+
+/* size=40 for Android M */
+#define PTHREAD_MUTEX_T_HANDLE_SIZE 40
+
+static int vpu_free_instances(struct file *filp)
+{
+	vpudrv_instanace_list_t *vil, *n;
+	vpudrv_instance_pool_t *vip;
+	void *vip_base;
+	int instance_pool_size_per_core;
+	void *vdi_mutexes_base;
+	const int PTHREAD_MUTEX_T_DESTROY_VALUE = 0xdead10cc;
+
+	DPRINTK("%s vpu_free_instances\n", DEV_NAME);
+
+	/* s_instance_pool.size  assigned to the size of all core once call VDI_IOCTL_GET_INSTANCE_POOL by user. */
+	instance_pool_size_per_core = (s_instance_pool.size/MAX_NUM_VPU_CORE);
+
+	list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+		if (vil->filp == filp) {
+			int i, j;
+			for (i = 0; i < MAX_NUM_INSTANCE; i++) /* reset dovi flag */
+			{
+				for (j = 0; j < MAX_NUM_VPU_CORE; j++)
+				{
+					pu_set_dovi_flag(j, i, 0);
+				}
+			}
+
+			vip_base = (void *)(s_instance_pool.base + (instance_pool_size_per_core*vil->core_idx));
+			DPRINTK("%s vpu_free_instances detect instance crash instIdx=%d, coreIdx=%d, vip_base=%p, instance_pool_size_per_core=%d\n", DEV_NAME, (int)vil->inst_idx, (int)vil->core_idx, vip_base, (int)instance_pool_size_per_core);
+			vip = (vpudrv_instance_pool_t *)vip_base;
+
+			if (vip) {
+				/* only first 4 byte is key point(inUse of CodecInst in vpuapi) to free the corresponding instance. */
+				memset(&vip->codecInstPool[vil->inst_idx], 0x00, 4);
+
+				if (vil->inst_idx == (vip->pendingInstIdxPlus1-1) && vip->pendingInst != 0) {
+					pr_warn("%s vil->inst_idx:%d, vil->core_idx:%d is pending, clear in here\n", DEV_NAME, (int)vil->inst_idx, (int)vil->core_idx);
+					vip->pendingInst = 0;
+					vip->pendingInstIdxPlus1 = 0;
+				}
+
+				vdi_mutexes_base = (vip_base + (instance_pool_size_per_core - PTHREAD_MUTEX_T_HANDLE_SIZE*4));
+				DPRINTK("%s vpu_free_instances : force to destroy vdi_mutexes_base=%p in userspace \n", DEV_NAME, vdi_mutexes_base);
+				if (vdi_mutexes_base) {
+					int i;
+					for (i = 0; i < 4; i++) {
+						memcpy(vdi_mutexes_base, &PTHREAD_MUTEX_T_DESTROY_VALUE, PTHREAD_MUTEX_T_HANDLE_SIZE);
+						vdi_mutexes_base += PTHREAD_MUTEX_T_HANDLE_SIZE;
+					}
+				}
+			}
+			s_vpu_open_ref_count--;
+			list_del(&vil->list);
+			kfree(vil);
+		}
+	}
+	return 1;
+}
+
+static int vpu_free_buffers(struct file *filp)
+{
+	vpudrv_buffer_pool_t *pool, *n;
+	vpudrv_buffer_t vb;
+
+	DPRINTK("%s vpu_free_buffers\n", DEV_NAME);
+
+	list_for_each_entry_safe(pool, n, &s_vbp_head, list) {
+		if (pool->filp == filp) {
+			vb = pool->vb;
+			if (vb.base) {
+				vpu_free_dma_buffer(&vb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+
+	return 0;
+}
+
+static irqreturn_t ve1_irq_handler(int irq, void *dev_id)
+{
+	vpu_drv_context_t *dev = (vpu_drv_context_t *)dev_id;
+
+	/* this can be removed. it also work in VPU_WaitInterrupt of API function */
+	int core = 0;
+	unsigned long interrupt_reason_ve1 = 0;
+	unsigned int vpu_int_sts_ve1 = 0;
+	unsigned long flags;
+
+	/* it means that we didn't get an information the current core from API layer. No core activated.*/
+	if (s_bit_firmware_info[core].size == 0) {
+		pr_err("[VPUDRV] :  s_bit_firmware_info[core].size is zero\n");
+		return IRQ_HANDLED;
+	}
+
+	vpu_int_sts_ve1 = ReadVpuRegister(BIT_INT_STS, core);
+	if (vpu_int_sts_ve1) {
+		interrupt_reason_ve1 = ReadVpuRegister(BIT_INT_REASON, core);
+		WriteVpuRegister(BIT_INT_REASON, 0, core);
+		WriteVpuRegister(BIT_INT_CLEAR, 0x1, core);
+	}
+
+	//DPRINTK("%s VE1 intr_reason: 0x%08lx\n", DEV_NAME, dev->interrupt_reason_ve1);
+
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN); /* notify the interrupt to user space */
+
+	if (vpu_int_sts_ve1) {
+		if (core == 0) {
+			dev->interrupt_reason_ve1 = interrupt_reason_ve1;
+			atomic_set(&s_interrupt_flag_ve1, 1);
+			wake_up_interruptible(&s_interrupt_wait_q_ve1);
+		}
+		//DPRINTK("%s [-]%s\n", DEV_NAME, __func__);
+	}
+
+	return IRQ_HANDLED;
+}
+
+#ifdef SUPPORT_MULTI_INST_INTR
+static inline u32 get_inst_idx(u32 reg_val)
+{
+	u32 inst_idx;
+	int i;
+	for (i=0; i < MAX_NUM_INSTANCE; i++)
+	{
+		if(((reg_val >> i)&0x01) == 1)
+			break;
+	}
+	inst_idx = i;
+	return inst_idx;
+}
+
+static u32 get_vpu_inst_idx(vpu_drv_context_t *dev, u32 *reason, u32 empty_inst, u32 done_inst, u32 other_inst)
+{
+	u32 inst_idx;
+	u32 reg_val;
+	u32 int_reason;
+
+	int_reason = *reason;
+	DPRINTK("%s [+]%s, int_reason=0x%x, empty_inst=0x%x, done_inst=0x%x\n", DEV_NAME, __func__, int_reason, empty_inst, done_inst);
+
+	if (int_reason & (1 << W4_INT_BSBUF_EMPTY))
+	{
+		reg_val = empty_inst;
+		inst_idx = get_inst_idx(reg_val);
+		*reason = (1 << W4_INT_BSBUF_EMPTY);
+		DPRINTK("%s	%s, W4_RET_BS_EMPTY_INST reg_val=0x%x, inst_idx=%d\n", DEV_NAME, __func__, reg_val, inst_idx);
+		goto GET_VPU_INST_IDX_HANDLED;
+	}
+
+	if (int_reason & (1 << W4_INT_DEC_PIC))
+	{
+		reg_val = done_inst;
+		inst_idx = get_inst_idx(reg_val);
+		*reason  = (1 << W4_INT_DEC_PIC);
+		DPRINTK("[VPUDRV]  %s, W4_RET_QUEUE_CMD_DONE_INST DEC_PIC reg_val=0x%x, inst_idx=%d\n", __func__, reg_val, inst_idx);
+		goto GET_VPU_INST_IDX_HANDLED;
+	}
+	// if  interrupt is not for empty and dec_pic and init_seq.
+	reg_val = (other_inst&0xFF);
+	inst_idx = reg_val;
+	*reason  = int_reason;
+	DPRINTK("%s	%s, W4_RET_DONE_INSTANCE_INFO reg_val=0x%x, inst_idx=%d\n", DEV_NAME, __func__, reg_val, inst_idx);
+GET_VPU_INST_IDX_HANDLED:
+
+	DPRINTK("%s [-]%s, inst_idx=%d. *reason=0x%x\n", DEV_NAME, __func__, inst_idx, *reason);
+
+	return inst_idx;
+}
+#endif
+static irqreturn_t ve3_irq_handler(int irq, void *dev_id)
+{
+	vpu_drv_context_t *dev = (vpu_drv_context_t *)dev_id;
+
+	/* this can be removed. it also work in VPU_WaitInterrupt of API function */
+	int core = 1;
+	unsigned int vpu_int_sts_ve3 = 0;
+	unsigned long flags;
+#ifdef SUPPORT_MULTI_INST_INTR
+	u32 intr_reason = 0;
+	u32 intr_inst_index = 0;
+#endif
+
+//	pr_err("[VPUDRV][+]%s\n", __func__);
+
+	if (s_bit_firmware_info[core].size == 0) {/* it means that we didn't get an information the current core from API layer. No core activated.*/
+		pr_err("[VPUDRV] :  s_bit_firmware_info[core].size is zero\n");
+		return IRQ_HANDLED;
+	}
+
+	int product_code = ReadVpuRegister(VPU_PRODUCT_CODE_REGISTER, core);
+
+	if (PRODUCT_CODE_W_SERIES(product_code)) {
+		if (ReadVpuRegister(W4_VPU_VPU_INT_STS, core)) {
+			dev->interrupt_reason_ve3 = ReadVpuRegister(W4_VPU_INT_REASON, core);
+			WriteVpuRegister(W4_VPU_INT_REASON_CLEAR, dev->interrupt_reason_ve3, core);
+			WriteVpuRegister(W4_VPU_VINT_CLEAR, 0x1, core);
+//			pr_err("[VPUDRV]have real interrupt!!!\n");
+		}
+	}
+	else {
+		pr_err("[VPUDRV] Unknown product id : %08x\n", product_code);
+	}
+//	pr_err("[VPUDRV] product: 0x%08x intr_reason: 0x%08lx\n", product_code, dev->interrupt_reason_ve3);
+
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN);	/* notify the interrupt to user space */
+
+	atomic_set(&s_interrupt_flag_ve3, 1);
+
+	wake_up_interruptible(&s_interrupt_wait_q_ve3);
+//	pr_err("[VPUDRV][-]%s\n", __func__);
+	return IRQ_HANDLED;
+}
+
+
+static int vpu_open(struct inode *inode, struct file *filp)
+{
+	DPRINTK("%s [+] %s\n", DEV_NAME, __func__);
+	spin_lock(&s_vpu_lock);
+
+	s_vpu_drv_context.open_count++;
+
+	filp->private_data = (void *)(&s_vpu_drv_context);
+	spin_unlock(&s_vpu_lock);
+
+	DPRINTK("%s [-] %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+
+/*static int vpu_ioctl(struct inode *inode, struct file *filp, u_int cmd, u_long arg) // for kernel 2.6.9*/
+static long vpu_ioctl(struct file *filp, u_int cmd, u_long arg)
+{
+	int ret = 0;
+	struct vpu_drv_context_t *dev = (struct vpu_drv_context_t *)filp->private_data;
+
+	switch (cmd) {
+	case VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+	{
+		vpudrv_buffer_pool_t *vbp;
+
+		DPRINTK("%s [+]VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			vbp = kzalloc(sizeof(*vbp), GFP_KERNEL);
+			if (!vbp) {
+				up(&s_vpu_sem);
+				return -ENOMEM;
+			}
+
+			ret = copy_from_user(&(vbp->vb), (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret) {
+				kfree(vbp);
+				up(&s_vpu_sem);
+				return -EFAULT;
+			}
+
+			ret = vpu_alloc_dma_buffer(&(vbp->vb));
+			if (ret == -1) {
+				ret = -ENOMEM;
+				kfree(vbp);
+				up(&s_vpu_sem);
+				break;
+			}
+
+			ret = copy_to_user((void __user *)arg, &(vbp->vb), sizeof(vpudrv_buffer_t));
+			if (ret) {
+				kfree(vbp);
+				ret = -EFAULT;
+				up(&s_vpu_sem);
+				break;
+			}
+
+			vbp->filp = filp;
+			spin_lock(&s_vpu_lock);
+			list_add(&vbp->list, &s_vbp_head);
+			spin_unlock(&s_vpu_lock);
+
+			up(&s_vpu_sem);
+		}
+		DPRINTK("%s [-]VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_FREE_PHYSICALMEMORY:
+	{
+		vpudrv_buffer_pool_t *vbp, *n;
+		vpudrv_buffer_t vb;
+
+		DPRINTK("%s [+]VDI_IOCTL_FREE_PHYSICALMEMORY\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			ret = copy_from_user(&vb, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret) {
+				up(&s_vpu_sem);
+				return -EACCES;
+			}
+
+			if (vb.base)
+				vpu_free_dma_buffer(&vb);
+
+			spin_lock(&s_vpu_lock);
+			list_for_each_entry_safe(vbp, n, &s_vbp_head, list) {
+				if (vbp->vb.phys_addr == vb.phys_addr/*vbp->vb.base == vb.base*/) {
+					list_del(&vbp->list);
+					kfree(vbp);
+					break;
+				}
+			}
+			spin_unlock(&s_vpu_lock);
+
+			up(&s_vpu_sem);
+		}
+		DPRINTK("%s [-]VDI_IOCTL_FREE_PHYSICALMEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+	{
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+		DPRINTK("%s [+]VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO\n", DEV_NAME);
+		if (s_video_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_video_memory, sizeof(vpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = -EFAULT;
+		}
+		DPRINTK("%s [-]VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO\n", DEV_NAME);
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+	}
+	break;
+
+	case VDI_IOCTL_WAIT_INTERRUPT:
+	{
+		vpudrv_intr_info_t info;
+		unsigned long flags;
+#ifdef SUPPORT_MULTI_INST_INTR
+		u32 intr_inst_index;
+		u32 intr_reason_in_q;
+		u32 interrupt_flag_in_q;
+#endif
+		DPRINTK("[VPUDRV][+]VDI_IOCTL_WAIT_INTERRUPT\n");
+		ret = copy_from_user(&info, (vpudrv_intr_info_t *)arg, sizeof(vpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		/* VE1 */
+		if (info.core_idx == 0) {
+			smp_rmb();
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve1, atomic_read(&s_interrupt_flag_ve1) != 0, msecs_to_jiffies(info.timeout));
+			if (!ret) {
+				ret = -ETIME;
+				break;
+			}
+
+			if (signal_pending(current)) {
+				ret = -ERESTARTSYS;
+				break;
+			}
+
+			//DPRINTK("[VPUDRV] s_interrupt_flag_ve1(%d), reason(0x%08lx)\n", atomic_read(&s_interrupt_flag_ve1), dev->interrupt_reason_ve1);
+			atomic_set(&s_interrupt_flag_ve1, 0);
+			info.intr_reason = dev->interrupt_reason_ve1;
+			dev->interrupt_reason_ve1 = 0;
+		} else { /* VE3 */
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve3, atomic_read(&s_interrupt_flag_ve3) != 0, msecs_to_jiffies(info.timeout));
+			if (!ret) {
+				ret = -ETIME;
+				break;
+			}
+
+			if (signal_pending(current)) {
+				ret = -ERESTARTSYS;
+				break;
+			}
+
+		//DPRINTK("[VPUDRV] s_interrupt_flag_ve1(%d), reason(0x%08lx)\n", atomic_read(&s_interrupt_flag_ve1), dev->interrupt_reason_ve1);
+			spin_lock_irqsave(&s_ve3_lock, flags);
+			atomic_set(&s_interrupt_flag_ve3, 0);
+
+			info.intr_reason = dev->interrupt_reason_ve3;
+			dev->interrupt_reason_ve3 = 0;
+			spin_unlock_irqrestore(&s_ve3_lock, flags);
+		}
+		ret = copy_to_user((void __user *)arg, &info, sizeof(vpudrv_intr_info_t));
+		DPRINTK("[VPUDRV][-]VDI_IOCTL_WAIT_INTERRUPT, info.intr_reason[%d]:0x%x\n", intr_inst_index, info.intr_reason);
+		if (ret != 0)
+			return -EFAULT;
+	}
+	break;
+	case VDI_IOCTL_SET_CLOCK_GATE:
+	{
+		u32 clkgate;
+
+		//DPRINTK("[VPUDRV][+]VDI_IOCTL_SET_CLOCK_GATE\n");
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+#ifdef VPU_SUPPORT_CLOCK_CONTROL
+		return -EFAULT;
+#endif /* VPU_SUPPORT_CLOCK_CONTROL */
+		//DPRINTK("[VPUDRV][-]VDI_IOCTL_SET_CLOCK_GATE\n");
+	}
+	break;
+	case VDI_IOCTL_GET_INSTANCE_POOL:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_INSTANCE_POOL\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			if (s_instance_pool.base != 0) {
+				ret = copy_to_user((void __user *)arg, &s_instance_pool, sizeof(vpudrv_buffer_t));
+				if (ret != 0)
+					ret = -EFAULT;
+			} else {
+				ret = copy_from_user(&s_instance_pool, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+				if (ret == 0) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+					s_instance_pool.size = PAGE_ALIGN(s_instance_pool.size);
+					s_instance_pool.base = (unsigned long)vmalloc(s_instance_pool.size);
+					s_instance_pool.phys_addr = s_instance_pool.base;
+
+					if (s_instance_pool.base != 0)
+#else
+					if (vpu_alloc_dma_buffer2(&s_instance_pool) != -1)
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+					{
+						memset((void *)s_instance_pool.base, 0x0, s_instance_pool.size); /*clearing memory*/
+						ret = copy_to_user((void __user *)arg, &s_instance_pool, sizeof(vpudrv_buffer_t));
+						if (ret == 0) {
+							/* success to get memory for instance pool */
+							up(&s_vpu_sem);
+							break;
+						}
+					}
+
+				}
+				ret = -EFAULT;
+			}
+
+			up(&s_vpu_sem);
+		}
+
+		DPRINTK("%s [-]VDI_IOCTL_GET_INSTANCE_POOL\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_GET_COMMON_MEMORY:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_COMMON_MEMORY\n", DEV_NAME);
+		if (s_common_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_common_memory, sizeof(vpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = copy_from_user(&s_common_memory, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret == 0) {
+				if (vpu_alloc_dma_buffer(&s_common_memory) != -1) {
+					ret = copy_to_user((void __user *)arg, &s_common_memory, sizeof(vpudrv_buffer_t));
+					if (ret == 0) {
+						/* success to get memory for common memory */
+						break;
+					}
+				}
+			}
+
+			ret = -EFAULT;
+		}
+		DPRINTK("%s [-]VDI_IOCTL_GET_COMMON_MEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_OPEN_INSTANCE:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+
+		vil = kzalloc(sizeof(*vil), GFP_KERNEL);
+		if (!vil)
+			return -ENOMEM;
+
+		if (copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t))) {
+			kfree(vil);
+			return -EFAULT;
+		}
+
+		vil->inst_idx = inst_info.inst_idx;
+		vil->core_idx = inst_info.core_idx;
+		vil->filp = filp;
+
+		spin_lock(&s_vpu_lock);
+		list_add(&vil->list, &s_inst_list_head);
+
+		inst_info.inst_open_count = 0; /* counting the current open instance number */
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		s_vpu_open_ref_count++; /* flag just for that vpu is in opened or closed */
+
+		if (copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t))) {
+			kfree(vil);
+			return -EFAULT;
+		}
+
+		DPRINTK("%s VDI_IOCTL_OPEN_INSTANCE core_idx=%d, inst_idx=%d, s_vpu_open_ref_count=%d, inst_open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, s_vpu_open_ref_count, inst_info.inst_open_count);
+	}
+	break;
+	case VDI_IOCTL_CLOSE_INSTANCE:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+
+		DPRINTK("%s [+]VDI_IOCTL_CLOSE_INSTANCE\n", DEV_NAME);
+		if (copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t)))
+			return -EFAULT;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->inst_idx == inst_info.inst_idx && vil->core_idx == inst_info.core_idx) {
+				list_del(&vil->list);
+				kfree(vil);
+				break;
+			}
+		}
+
+		inst_info.inst_open_count = 0; /* counting the current open instance number */
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		s_vpu_open_ref_count--; /* flag just for that vpu is in opened or closed */
+
+		if (copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t)))
+			return -EFAULT;
+
+		DPRINTK("%s VDI_IOCTL_CLOSE_INSTANCE core_idx=%d, inst_idx=%d, s_vpu_open_ref_count=%d, inst_open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, s_vpu_open_ref_count, inst_info.inst_open_count);
+	}
+	break;
+	case VDI_IOCTL_GET_INSTANCE_NUM:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+		DPRINTK("%s [+]VDI_IOCTL_GET_INSTANCE_NUM\n", DEV_NAME);
+
+		ret = copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t));
+		if (ret != 0)
+			break;
+
+		inst_info.inst_open_count = 0;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		ret = copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t));
+
+		DPRINTK("%s VDI_IOCTL_GET_INSTANCE_NUM core_idx=%d, inst_idx=%d, open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, inst_info.inst_open_count);
+
+	}
+	break;
+	case VDI_IOCTL_RESET:
+	{
+		u32 coreIdx;
+		if (get_user(coreIdx, (u32 __user *) arg))
+			return -EFAULT;
+		vpu_hw_reset(coreIdx);
+	}
+	break;
+	case VDI_IOCTL_GET_REGISTER_INFO:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_REGISTER_INFO\n", DEV_NAME);
+		ret = copy_to_user((void __user *)arg, &s_vpu_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		DPRINTK("%s [-]VDI_IOCTL_GET_REGISTER_INFO s_vpu_register.phys_addr=0x%lx, s_vpu_register.virt_addr=0x%lx, s_vpu_register.size=%d\n", DEV_NAME, s_vpu_register.phys_addr, s_vpu_register.virt_addr, s_vpu_register.size);
+	}
+	break;
+	/* RTK ioctl */
+	case VDI_IOCTL_SET_RTK_CLK_GATING:
+	{
+		vpu_clock_info_t clockInfo;
+
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_GATING\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		if (clockInfo.enable) {
+			ve_pd_power_on(clockInfo.core_idx);
+			ve1_wrapper_setup((1 << clockInfo.core_idx));
+		} else
+			ve_pd_power_off(clockInfo.core_idx);
+
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_GATING clockInfo.core_idx:%d, clockInfo.enable:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.enable);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_CLK_PLL:
+	{
+		vpu_clock_info_t clockInfo;
+
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_PLL\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		if (ve_pd_clk_set_rate(clockInfo.core_idx, clockInfo.value))
+			break;
+		ve1_wrapper_setup((1 << clockInfo.core_idx));
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_PLL clockInfo.core_idx:%d, clockInfo.value:0x%x\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_CLK_PLL:
+	{
+		vpu_clock_info_t clockInfo;
+
+		DPRINTK("%s [+]VDI_IOCTL_GET_RTK_CLK_PLL\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		clockInfo.value = (unsigned int)ve_pd_clk_get_rate(clockInfo.core_idx);
+		ret = copy_to_user((vpu_clock_info_t *)arg, &clockInfo, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_GET_RTK_CLK_PLL clockInfo.core_idx:%d, clockInfo.value:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_CLK_SELECT:
+	{
+		const char *parent_name;
+		vpu_clock_info_t clockInfo;
+
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_SELECT\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		switch(clockInfo.value)
+		{
+			case VE_PLL_SYSH:
+				parent_name = "clk_sysh";
+				break;
+			case VE_PLL_VE1:
+				parent_name = "pll_ve1";
+				break;
+			default:
+				parent_name = NULL;
+				pr_warn("%s  %s %d, wrong value:0x%x\n", DEV_NAME, __func__, __LINE__, clockInfo.value);
+				break;
+		}
+
+		ret = ve_pd_clk_set_parent(clockInfo.core_idx, parent_name);
+		if (ret)
+			pr_err("pd%d: failed to set clk parent %s: %s\n", clockInfo.core_idx, parent_name, ret);
+
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_SELECT clockInfo.core_idx:%d, clockInfo.value:0x%x\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_CLK_SELECT:
+	{
+		vpu_clock_info_t clockInfo;
+
+		DPRINTK("%s [+]VDI_IOCTL_GET_RTK_CLK_SELECT\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		if (ve_pd_clk_parent_match(clockInfo.core_idx, "clk_sysh") == 1)
+			clockInfo.value = (unsigned int)VE_PLL_SYSH;
+		else if (ve_pd_clk_parent_match(clockInfo.core_idx, "pll_ve1") == 1)
+			clockInfo.value = (unsigned int)VE_PLL_VE1;
+
+		ret = copy_to_user((vpu_clock_info_t *)arg, &clockInfo, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_GET_RTK_CLK_SELECT clockInfo.core_idx:%d, clockInfo.value:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_SUPPORT_TYPE:
+	{
+		ret = copy_to_user((void __user *)arg, &s_bond_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_DCSYS_INFO:
+	{
+		vpudrv_buffer_t vb;
+		ret = copy_from_user(&vb, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+		if (vb.mem_type == 0)
+			ret = copy_to_user((void __user *)arg, &s_dc_register, sizeof(vpudrv_buffer_t));
+		else
+			ret = copy_to_user((void __user *)arg, &s_dmc_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_ASIC_REVISION:
+	{
+		__put_user(get_rtd129x_cpu_revision()|get_rtd129x_cpu_id(), (unsigned int *) arg);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_DOVI_FLAG:
+	{
+		vpudrv_dovi_info_t doviInfo;
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_DOVI_FLAG\n", DEV_NAME);
+		ret = copy_from_user(&doviInfo, (vpudrv_dovi_info_t *)arg, sizeof(vpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+
+		doviInfo.enable = pu_set_dovi_flag(doviInfo.core_idx, doviInfo.inst_idx, doviInfo.enable);
+
+		ret = copy_to_user((vpudrv_dovi_info_t *)arg, &doviInfo, sizeof(vpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_DOVI_FLAG doviInfo.core_idx:%d, doviInfo.inst_idx:%d, doviInfo.value:%d\n", DEV_NAME, doviInfo.core_idx, doviInfo.inst_idx, doviInfo.enable);
+	}
+	break;
+	case VDI_IOCTL_GET_TOTAL_INSTANCE_NUM:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+		DPRINTK("%s [+]VDI_IOCTL_GET_TOTAL_INSTANCE_NUM\n", DEV_NAME);
+
+		ret = copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t));
+		if (ret != 0)
+			break;
+
+		inst_info.inst_open_count = 0;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		ret = copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t));
+
+		DPRINTK("%s VDI_IOCTL_GET_TOTAL_INSTANCE_NUM core_idx=%d, inst_idx=%d, open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, inst_info.inst_open_count);
+
+	}
+	break;
+	default:
+	{
+		pr_err("%s No such IOCTL, cmd is %d\n", DEV_NAME, cmd);
+	}
+	break;
+	}
+
+	return ret;
+}
+
+static ssize_t vpu_read(struct file *filp, char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static int compat_get_vpu_bit_firmware_info_data(
+	compat_vpu_bit_firmware_info_t __user *data32,
+	vpu_bit_firmware_info_t __user *data)
+{
+#if defined(CONFIG_CPU_V7)
+	//u32 s;
+	u32 c;
+	u32 r;
+	u32 b[512];
+#else
+	//compat_uint_t s;
+	compat_uint_t c;
+	compat_ulong_t r;
+	compat_ushort_t b[512];
+#endif /* CONFIG_CPU_V7 */
+
+	int err;
+
+	//err = get_user(s, &data32->size);
+	//err |= put_user(s, &data->size);
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(r, &data32->reg_base_offset);
+	err |= put_user(r, &data->reg_base_offset);
+	err |= copy_from_user(b, data32->bit_code, sizeof(b));
+	err |= copy_to_user(data->bit_code, b, sizeof(b));
+
+	return err;
+};
+
+static ssize_t vpu_write(struct file *filp, const char __user *buf, size_t len, loff_t *ppos)
+{
+
+	/* DPRINTK("[VPUDRV] vpu_write len=%d\n", (int)len); */
+	if (!buf) {
+		pr_err("%s vpu_write buf = NULL error \n", DEV_NAME);
+		return -EFAULT;
+	}
+
+	if (len == sizeof(vpu_bit_firmware_info_t) || len == sizeof(compat_vpu_bit_firmware_info_t))	{
+		vpu_bit_firmware_info_t *bit_firmware_info;
+
+		bit_firmware_info = kmalloc(sizeof(vpu_bit_firmware_info_t), GFP_KERNEL);
+		if (!bit_firmware_info) {
+			pr_err("%s vpu_write  bit_firmware_info allocation error\n", DEV_NAME);
+			return -EFAULT;
+		}
+
+		if (len == sizeof(vpu_bit_firmware_info_t)) {
+			if (copy_from_user(bit_firmware_info, buf, len)) {
+				pr_err("%s vpu_write copy_from_user error for bit_firmware_info\n", DEV_NAME);
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+		}
+#ifdef CONFIG_COMPAT
+		 else {
+			int err;
+			compat_vpu_bit_firmware_info_t __user *data32;
+			vpu_bit_firmware_info_t __user *data;
+
+			data32 = (compat_vpu_bit_firmware_info_t __user *) buf;
+			data = compat_alloc_user_space(sizeof(*data));
+			if (data == NULL) {
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+
+			err = compat_get_vpu_bit_firmware_info_data(data32, data);
+			if (err) {
+				kfree(bit_firmware_info);
+				return err;
+			}
+
+			if (copy_from_user(bit_firmware_info, data, sizeof(vpu_bit_firmware_info_t))) {
+				pr_err("%s vpu_write copy_from_user error for bit_firmware_info\n", DEV_NAME);
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+			bit_firmware_info->size = sizeof(vpu_bit_firmware_info_t);
+		}
+#endif /* CONFIG_COMPAT */
+
+		if (bit_firmware_info->size == sizeof(vpu_bit_firmware_info_t)) {
+			DPRINTK("%s vpu_write set bit_firmware_info coreIdx=0x%x, reg_base_offset=0x%x size=0x%x, bit_code[0]=0x%x\n",
+					DEV_NAME, bit_firmware_info->core_idx, (int)bit_firmware_info->reg_base_offset, bit_firmware_info->size, bit_firmware_info->bit_code[0]);
+
+			if (bit_firmware_info->core_idx > MAX_NUM_VPU_CORE) {
+				pr_err("%s vpu_write coreIdx[%d] is exceeded than MAX_NUM_VPU_CORE[%d]\n", DEV_NAME, bit_firmware_info->core_idx, MAX_NUM_VPU_CORE);
+				kfree(bit_firmware_info);
+				return -ENODEV;
+			}
+
+			memcpy((void *)&s_bit_firmware_info[bit_firmware_info->core_idx], bit_firmware_info, sizeof(vpu_bit_firmware_info_t));
+			kfree(bit_firmware_info);
+
+			return len;
+		}
+
+		kfree(bit_firmware_info);
+	}
+
+	return -1;
+}
+
+static int vpu_release(struct inode *inode, struct file *filp)
+{
+	int ret = 0;
+	DPRINTK("%s vpu_release\n", DEV_NAME);
+
+	ret = down_interruptible(&s_vpu_sem);
+	if (ret == 0) {
+		/* found and free the not handled buffer by user applications */
+		vpu_free_buffers(filp);
+		/* found and free the not closed instance by user applications */
+		vpu_free_instances(filp);
+		s_vpu_drv_context.open_count--;
+		if (s_vpu_drv_context.open_count == 0) {
+			if (s_instance_pool.base) {
+				DPRINTK("%s free instance pool\n", DEV_NAME);
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+				vfree((const void *)s_instance_pool.base);
+#else
+				pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+				vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+				s_instance_pool.base = 0;
+			}
+#if 0 /* Fuchun 20150909, we must not free instance pool and common memory */
+			if (s_common_memory.base) {
+				DPRINTK("%s free common memory\n", DEV_NAME);
+				vpu_free_dma_buffer(&s_common_memory);
+				s_common_memory.base = 0;
+			}
+#endif
+		}
+	}
+	up(&s_vpu_sem);
+
+	return 0;
+}
+
+static int vpu_fasync(int fd, struct file *filp, int mode)
+{
+	struct vpu_drv_context_t *dev = (struct vpu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+static int vpu_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	pfn = vm->vm_pgoff;
+
+	return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int vpu_map_to_physical_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+	return pu_mmap_dma_buffer(vm);
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif /* CONFIG_RTK_RESERVE_MEMORY */
+}
+
+static int vpu_map_to_instance_pool_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	int ret;
+	long length = vm->vm_end - vm->vm_start;
+	unsigned long start = vm->vm_start;
+	char *vmalloc_area_ptr = (char *)s_instance_pool.base;
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_RESERVED;
+
+	/* loop over all pages, map it page individually */
+	while (length > 0) {
+		pfn = vmalloc_to_pfn(vmalloc_area_ptr);
+		ret = remap_pfn_range(vm, start, pfn, PAGE_SIZE, PAGE_SHARED);
+		if (ret < 0) {
+			return ret;
+		}
+		start += PAGE_SIZE;
+		vmalloc_area_ptr += PAGE_SIZE;
+		length -= PAGE_SIZE;
+	}
+
+	return 0;
+#else
+	vm->vm_flags |= VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+}
+
+/*!
+ * @brief memory map interface for vpu file operation
+ * @return  0 on success or negative error code on error
+ */
+static int vpu_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	if (vm->vm_pgoff == 0)
+		return vpu_map_to_instance_pool_memory(fp, vm);
+
+	if ((vm->vm_pgoff == (s_vpu_register.phys_addr>>PAGE_SHIFT))
+	|| (vm->vm_pgoff == (s_bond_register.phys_addr>>PAGE_SHIFT))
+	|| (vm->vm_pgoff == (s_dc_register.phys_addr>>PAGE_SHIFT))
+	|| (vm->vm_pgoff == (s_dmc_register.phys_addr>>PAGE_SHIFT)))
+		return vpu_map_to_register(fp, vm);
+
+	return vpu_map_to_physical_memory(fp, vm);
+#else
+	if (vm->vm_pgoff) {
+		if (vm->vm_pgoff == (s_instance_pool.phys_addr>>PAGE_SHIFT))
+			return vpu_map_to_instance_pool_memory(fp, vm);
+
+		return vpu_map_to_physical_memory(fp, vm);
+	} else {
+		return vpu_map_to_register(fp, vm);
+	}
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+}
+
+struct file_operations vpu_fops = {
+	.owner = THIS_MODULE,
+	.open = vpu_open,
+	.read = vpu_read,
+	.write = vpu_write,
+	/*.ioctl = vpu_ioctl, // for kernel 2.6.9*/
+	.unlocked_ioctl = vpu_ioctl,
+	.compat_ioctl = compat_vpu_ioctl,
+	.release = vpu_release,
+	.fasync = vpu_fasync,
+	.mmap = vpu_mmap,
+};
+
+
+static int vpu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+	u32 bonding_value;
+	unsigned long virt_addr;
+	struct resource res;
+	void __iomem *iobase;
+	int irq;
+	struct device_node *node = pdev->dev.of_node;
+#if 0 //Fuchun disable 20160204, set clock gating by vdi.c
+	unsigned int val = 0;
+#endif
+
+	pr_info("%s vpu_probe\n", DEV_NAME);
+
+	of_address_to_resource(node, 0, &res);
+	iobase = of_iomap(node, 0);
+
+	s_vpu_register.phys_addr = res.start;
+	s_vpu_register.virt_addr = (unsigned long)iobase;
+	s_vpu_register.size = res.end - res.start + 1;
+
+	pr_info("%s vpu base address get from DTB physical base addr=0x%lx, virtual base=0x%lx, size=0x%x\n", DEV_NAME, s_vpu_register.phys_addr, s_vpu_register.virt_addr, s_vpu_register.size);
+
+	of_address_to_resource(node, 1, &res);
+	iobase = of_iomap(node, 1);
+
+	s_dc_register.phys_addr = res.start;
+	s_dc_register.virt_addr = (unsigned long)iobase;
+	s_dc_register.size = res.end - res.start + 1;
+
+	s_vpu_dev.minor = MISC_VE1_MINOR;
+	s_vpu_dev.name = VPU_DEV_NAME;
+	s_vpu_dev.fops = &vpu_fops;
+	s_vpu_dev.parent = NULL;
+	if (misc_register(&s_vpu_dev)) {
+		pr_err("%s failed to register misc device.", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	of_address_to_resource(node, 2, &res);
+	iobase = of_iomap(node, 2);
+
+	s_bond_register.phys_addr = res.start;
+	s_bond_register.virt_addr = (unsigned long)iobase;
+	s_bond_register.size = res.end - res.start + 1;
+
+	virt_addr = (unsigned long)iobase;
+	bonding_value = __raw_readl((volatile u8 *)virt_addr);
+
+	pr_info("%s res.start:0x%llx, bonding_value:0x%x\n", DEV_NAME, res.start, bonding_value);
+
+	of_address_to_resource(node, 3, &res);
+	iobase = of_iomap(node, 3);
+
+	s_dmc_register.phys_addr = res.start;
+	s_dmc_register.virt_addr = (unsigned long)iobase;
+	s_dmc_register.size = res.end - res.start + 1;
+
+	ve_pd_init(&pdev->dev, 0);
+	ve_pd_init(&pdev->dev, 1);
+
+	p_vpu_dev = &pdev->dev;
+
+	irq = irq_of_parse_and_map(node, 0);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_ve1_irq = irq;
+	pr_info("%s s_ve1_irq:%d want to register ve1_irq_handler\n", DEV_NAME, s_ve1_irq);
+	err = request_irq(s_ve1_irq, ve1_irq_handler, 0, "VE1_CODEC_IRQ", (void *)(&s_vpu_drv_context));
+	err = 0;
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_ve1_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_ve1_irq <%d> busy, change your config\n", DEV_NAME, s_ve1_irq);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	irq = irq_of_parse_and_map(node, 1);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_ve3_irq = irq;
+	pr_info("%s s_ve3_irq:%d want to register ve3_irq_handler\n", DEV_NAME, s_ve3_irq);
+	err = request_irq(s_ve3_irq, ve3_irq_handler, 0, "VE3_CODEC_IRQ", (void *)(&s_vpu_drv_context));
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_ve3_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_ve3_irq <%d> busy, change your config\n", DEV_NAME, s_ve3_irq);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	s_video_memory.size = VPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+	s_video_memory.phys_addr = VPU_DRAM_PHYSICAL_BASE;
+	s_video_memory.base = (unsigned long)ioremap_nocache(s_video_memory.phys_addr, PAGE_ALIGN(s_video_memory.size));
+	if (!s_video_memory.base) {
+		pr_err("%s fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", DEV_NAME, (int)s_video_memory.phys_addr, (int)s_video_memory.base, (int)s_video_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (vmem_init(&s_vmem, s_video_memory.phys_addr, s_video_memory.size) < 0) {
+		pr_err("%s fail to init vmem system\n", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+	pr_info("%s success to probe vpu device with reserved video memory phys_addr=0x%x, base = 0x%x\n", DEV_NAME, (int) s_video_memory.phys_addr, (int)s_video_memory.base);
+#else
+	pr_info("%s success to probe vpu device with non reserved video memory\n", DEV_NAME);
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+
+	ve_pd_power_on(0);
+	ve_pd_power_on(1);
+
+
+
+#ifndef VE1_ALWAYS_ON
+	/* since ve2 in not in kernel, the ve1 power domain can not be accessd,
+	 * keep it on
+	 */
+	ve_pd_power_off(0);
+#endif
+	ve_pd_power_off(1);
+
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+	ve_pd_exit(&pdev->dev, 1);
+	ve_pd_exit(&pdev->dev, 0);
+	misc_deregister(&s_vpu_dev);
+
+	return err;
+}
+
+static int vpu_remove(struct platform_device *pdev)
+{
+	DPRINTK("%s vpu_remove\n", DEV_NAME);
+
+	ve_pd_exit(&pdev->dev, 1);
+	ve_pd_exit(&pdev->dev, 0);
+
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+		vpu_free_dma_buffer(&s_instance_pool);
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+		s_instance_pool.base = 0;
+	}
+
+	if (s_common_memory.base) {
+		vpu_free_dma_buffer(&s_common_memory);
+		s_common_memory.base = 0;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_video_memory.base) {
+		iounmap((void *)s_video_memory.base);
+		s_video_memory.base = 0;
+		vmem_exit(&s_vmem);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	misc_deregister(&s_vpu_dev);
+
+#ifdef VPU_SUPPORT_ISR
+	if (s_ve1_irq)
+		free_irq(s_ve1_irq, &s_vpu_drv_context);
+	if (s_ve3_irq)
+		free_irq(s_ve3_irq, &s_vpu_drv_context);
+#endif /* VPU_SUPPORT_ISR */
+
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+/* DO NOT CHANGE */
+#define WAVE5_STACK_SIZE (8*1024)
+#define W4_MAX_CODE_BUF_SIZE (512*1024)
+#define W4_CMD_INIT_VPU (0x0001)
+#define W4_CMD_SLEEP_VPU (0x0400)
+#define W4_CMD_WAKEUP_VPU (0x0800)
+
+static int vpu_suspend(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+	ve_pd_power_on(0);
+	ve_pd_power_on(1);
+
+	/* RTK wrapper */
+	ve1_wrapper_setup((1 << 1) | 1);
+
+	if (s_vpu_open_ref_count > 0) {
+#ifdef DISABLE_ORIGIN_SUSPEND
+		vpudrv_instanace_list_t *vil, *n;
+		vpudrv_instance_pool_t *vip;
+		void *vip_base;
+		int instance_pool_size_per_core;
+		vpudrv_buffer_pool_t *pool, *nn;
+		vpudrv_buffer_t vb;
+		s_vpu_drv_context.open_count = 0;
+		s_vpu_open_ref_count = 0;
+
+		/* s_instance_pool.size  assigned to the size of all core once call VDI_IOCTL_GET_INSTANCE_POOL by user. */
+		instance_pool_size_per_core = (s_instance_pool.size/MAX_NUM_VPU_CORE);
+
+		wake_up_interruptible_all(&s_interrupt_wait_q_ve1);
+		atomic_set(&s_interrupt_flag_ve1, 0);
+		wake_up_interruptible_all(&s_interrupt_wait_q_ve3);
+		atomic_set(&s_interrupt_flag_ve3, 0);
+
+
+
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			vip_base = (void *)(s_instance_pool.base + (instance_pool_size_per_core*vil->core_idx));
+			vip = (vpudrv_instance_pool_t *)vip_base;
+			if (vip) {
+				/* only first 4 byte is key point(inUse of CodecInst in vpuapi) to free the corresponding instance. */
+				memset(&vip->codecInstPool[vil->inst_idx], 0x00, 4);
+			}
+			list_del(&vil->list);
+			kfree(vil);
+		}
+
+		list_for_each_entry_safe(pool, nn, &s_vbp_head, list) {
+			vb = pool->vb;
+			if (vb.base) {
+				vpu_free_dma_buffer(&vb);
+			}
+			list_del(&pool->list);
+			kfree(pool);
+		}
+
+		if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_instance_pool.base);
+#else
+			pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+			vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+			s_instance_pool.base = 0;
+		}
+#else /* else of DISABLE_ORIGIN_SUSPEND */
+		int i;
+		int core;
+		unsigned long timeout = jiffies + HZ; /* vpu wait timeout to 1sec */
+		int product_code = 0;
+
+		for (core = 0; core < MAX_NUM_VPU_CORE; core++) {
+			if (s_bit_firmware_info[core].size == 0)
+				continue;
+			product_code = ReadVpuRegister(VPU_PRODUCT_CODE_REGISTER, core);
+
+			if (PRODUCT_CODE_W_SERIES(product_code)) {
+				while (ReadVpuRegister(W4_VPU_BUSY_STATUS, core)) {
+					if (time_after(jiffies, timeout)) {
+						DPRINTK("%s SLEEP_VPU BUSY timeout", DEV_NAME);
+						goto DONE_SUSPEND;
+					}
+				}
+				Wave5BitIssueCommand(W4_CMD_SLEEP_VPU);
+
+				while (ReadVpuRegister(W4_VPU_BUSY_STATUS, core)) {
+					if (time_after(jiffies, timeout)) {
+						DPRINTK("%s SLEEP_VPU BUSY timeout", DEV_NAME);
+						goto DONE_SUSPEND;
+					}
+				}
+				if (ReadVpuRegister(W4_RET_SUCCESS, core) == 0) {
+					DPRINTK("%s SLEEP_VPU failed [0x%x]", DEV_NAME, ReadVpuRegister(W4_RET_FAIL_REASON, core));
+					goto DONE_SUSPEND;
+				}
+			} else {
+				while (ReadVpuRegister(BIT_BUSY_FLAG, core)) {
+					if (time_after(jiffies, timeout))
+						goto DONE_SUSPEND;
+				}
+
+			for (i = 0; i < 64; i++)
+				s_vpu_reg_store[core][i] = ReadVpuRegister(BIT_BASE+(0x100+(i * 4)), core);
+		}
+#endif /* end of DISABLE_ORIGIN_SUSPEND */
+	}
+
+	ve_pd_power_off(0);
+	ve_pd_power_off(1);
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+DONE_SUSPEND:
+#endif
+
+	ve_pd_power_off(0);
+	ve_pd_power_off(1);
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return -EAGAIN;
+}
+
+static int vpu_resume(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+	ve_pd_power_on(0);
+	ve_pd_power_on(1);
+
+	//RTK wrapper
+	ve1_wrapper_setup((1 << 1) | 1);
+
+#ifdef DISABLE_ORIGIN_SUSPEND
+#else /* else of DISABLE_ORIGIN_SUSPEND */
+	int i;
+	int core;
+	int regVal;
+	int product_code = 0;
+	unsigned long timeout = jiffies + HZ; /* vpu wait timeout to 1sec */
+	unsigned long code_base;
+	unsigned long stack_base;
+	u32 val;
+	u32 code_size;
+	u32 stack_size;
+	u32 remap_size;
+	u32 hwOption  = 0;
+
+	for (core = 0; core < MAX_NUM_VPU_CORE; core++) {
+
+		if (s_bit_firmware_info[core].size == 0) {
+			continue;
+		}
+
+		product_code = ReadVpuRegister(VPU_PRODUCT_CODE_REGISTER, core);
+
+		if (PRODUCT_CODE_W_SERIES(product_code)) {
+
+			code_base = s_common_memory.phys_addr;
+			/* ALIGN TO 4KB */
+			code_size = (W4_MAX_CODE_BUF_SIZE&~0xfff);
+			if (code_size < s_bit_firmware_info[core].size*2) {
+				goto DONE_WAKEUP;
+			}
+			stack_base = code_base + code_size;
+			stack_size = WAVE5_STACK_SIZE;
+
+			/*---- LOAD BOOT CODE*/
+			//for (i = 0; i < 512; i++) {
+			//	val = s_bit_firmware_info[core].bit_code[i];
+			//	WriteVpu(code_base+(i*4), val);
+			//}
+
+			regVal = 0;
+			WriteVpuRegister(W4_PO_CONF, regVal, core);
+
+			/* Reset All blocks */
+			regVal = 0x7ffffff;
+			WriteVpuRegister(W4_RESET_REQ, regVal, core);	/*Reset All blocks*/
+
+			/* Waiting reset done */
+			while (ReadVpuRegister(W4_RESET_STATUS, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+			WriteVpuRegister(W4_RESET_REQ, 0, core);
+
+			/* remap page size */
+			remap_size = (code_size >> 12) & 0x1ff;
+			regVal = 0x80000000 | (W4_REMAP_CODE_INDEX<<12) | (0 << 16) | (1<<11) | remap_size;
+			WriteVpuRegister(W4_VPU_REMAP_CTRL,	 regVal, core);
+			WriteVpuRegister(W4_VPU_REMAP_VADDR,	0x00000000, core);	/* DO NOT CHANGE! */
+			WriteVpuRegister(W4_VPU_REMAP_PADDR,	code_base, core);
+			WriteVpuRegister(W4_ADDR_CODE_BASE,	 code_base, core);
+			WriteVpuRegister(W4_CODE_SIZE,		  code_size, core);
+			WriteVpuRegister(W4_CODE_PARAM,		 0, core);
+			WriteVpuRegister(W4_INIT_VPU_TIME_OUT_CNT,   timeout, core);
+
+			/* Stack */
+			WriteVpuRegister(W4_ADDR_STACK_BASE, stack_base, core);
+			WriteVpuRegister(W4_STACK_SIZE,	  stack_size, core);
+			WriteVpuRegister(W4_HW_OPTION, hwOption, core);
+
+			/* Interrupt */
+			regVal  = (1<<W4_INT_DEC_PIC_HDR);
+			regVal |= (1<<W4_INT_DEC_PIC);
+			regVal |= (1<<W4_INT_QUERY_DEC);
+			regVal |= (1<<W4_INT_SLEEP_VPU);
+			regVal |= (1<<W4_INT_BSBUF_EMPTY);
+
+			WriteVpuRegister(W4_VPU_INT_ENABLE,  regVal, core);
+
+			Wave5BitIssueCommand(W4_CMD_INIT_VPU);
+			WriteVpuRegister(W4_VPU_REMAP_PROC_START, 1, core); // [r]where did we define it?
+
+			while (ReadVpuRegister(W4_VPU_BUSY_STATUS, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+			if (ReadVpuRegister(W4_RET_SUCCESS, core) == 0) {
+				DPRINTK("%s WAKEUP_VPU failed [0x%x]", DEV_NAME, ReadVpuRegister(W4_RET_FAIL_REASON, core));
+				goto DONE_WAKEUP;
+			}
+		} else {
+
+			WriteVpuRegister(BIT_CODE_RUN, 0, core);
+
+			/*---- LOAD BOOT CODE*/
+			for (i = 0; i < 512; i++) {
+				val = s_bit_firmware_info[core].bit_code[i];
+				WriteVpuRegister(BIT_CODE_DOWN, ((i << 16) | val), core);
+			}
+
+			for (i = 0 ; i < 64 ; i++)
+				WriteVpuRegister(BIT_BASE+(0x100+(i * 4)), s_vpu_reg_store[core][i], core);
+
+			WriteVpuRegister(BIT_BUSY_FLAG, 1, core);
+			WriteVpuRegister(BIT_CODE_RESET, 1, core);
+			WriteVpuRegister(BIT_CODE_RUN, 1, core);
+
+			while (ReadVpuRegister(BIT_BUSY_FLAG, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+		}
+
+	}
+#endif /* end of DISABLE_ORIGIN_SUSPEND */
+
+	if (s_vpu_open_ref_count == 0) {
+		ve_pd_power_off(0);
+		ve_pd_power_off(1);
+	}
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+DONE_WAKEUP:
+#endif /* DISABLE_ORIGIN_SUSPEND */
+
+	if (s_vpu_open_ref_count > 0) {
+		ve_pd_power_on(0);
+		ve_pd_power_on(1);
+	}
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+#else
+static int vpu_suspend(struct device *pdev);
+static int vpu_resume(struct device *pdev);
+#endif /* CONFIG_PM */
+
+static int __init vpu_init(void)
+{
+	int res = 0;
+
+#ifdef SUPPORT_MULTI_INST_INTR
+	int i;
+#endif
+	DPRINTK("%s begin vpu_init\n", DEV_NAME);
+
+	init_waitqueue_head(&s_interrupt_wait_q_ve1);
+	init_waitqueue_head(&s_interrupt_wait_q_ve3);
+	s_common_memory.base = 0;
+	s_instance_pool.base = 0;
+
+	DPRINTK("%s end vpu_init result=0x%x\n", DEV_NAME, res);
+	return res;
+}
+
+static void __exit vpu_exit(void)
+{
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	DPRINTK("%s vpu_exit\n", DEV_NAME);
+#else
+
+	if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+		vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+		s_instance_pool.base = 0;
+	}
+
+	if (s_common_memory.base) {
+		vpu_free_dma_buffer(&s_common_memory);
+		s_common_memory.base = 0;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_video_memory.base) {
+		iounmap((void *)s_video_memory.base);
+		s_video_memory.base = 0;
+
+		vmem_exit(&s_vmem);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	misc_deregister(&s_vpu_dev);
+
+#ifdef VPU_SUPPORT_ISR
+	if (s_ve1_irq)
+		free_irq(s_ve1_irq, &s_vpu_drv_context);
+	if (s_ve3_irq)
+		free_irq(s_ve3_irq, &s_vpu_drv_context);
+#endif /* VPU_SUPPORT_ISR */
+
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+
+	return;
+}
+
+MODULE_AUTHOR("A customer using RTK VPU, Inc.");
+MODULE_DESCRIPTION("VPU linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(vpu_init);
+module_exit(vpu_exit);
+
+static const struct of_device_id rtk_ve1_dt_match[] = {
+	{ .compatible = "Realtek,rtk13xx-ve1" },
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtk_ve1_dt_match);
+
+const struct dev_pm_ops rtk_ve1_pmops = {
+	.suspend = vpu_suspend,
+	.resume = vpu_resume,
+};
+
+static struct platform_driver rtk_ve1_driver = {
+	.driver = {
+		.name = "rtk-ve1",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_ve1_dt_match,
+		.pm = &rtk_ve1_pmops,
+	},
+	.probe = vpu_probe,
+	.remove = vpu_remove,
+};
+
+module_platform_driver(rtk_ve1_driver);
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1.h b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1.h
new file mode 100755
index 00000000..f351f9d
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1.h
@@ -0,0 +1,106 @@
+/**
+  ve1.c
+
+  linux device driver for VPU.
+
+ Copyright (C) 2006 - 2013  REALTEK INC.
+
+  This library is free software; you can redistribute it and/or modify it under
+  the terms of the GNU Lesser General Public License as published by the Free
+  Software Foundation; either version 2.1 of the License, or (at your option)
+  any later version.
+
+  This library is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+  details.
+
+  You should have received a copy of the GNU Lesser General Public License
+  along with this library; if not, write to the Free Software Foundation, Inc.,
+  51 Franklin St, Fifth Floor, Boston, MA
+  02110-1301  USA
+
+*/
+
+#ifndef __VPU_DRV_H__
+#define __VPU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+#define SUPPORT_MULTI_INST_INTR
+#define SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+#define USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+
+#define VDI_IOCTL_MAGIC 'V'
+#define VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(VDI_IOCTL_MAGIC, 0)
+#define VDI_IOCTL_FREE_PHYSICALMEMORY _IO(VDI_IOCTL_MAGIC, 1)
+#define VDI_IOCTL_WAIT_INTERRUPT _IO(VDI_IOCTL_MAGIC, 2)
+#define VDI_IOCTL_SET_CLOCK_GATE _IO(VDI_IOCTL_MAGIC, 3)
+#define VDI_IOCTL_RESET _IO(VDI_IOCTL_MAGIC, 4)
+#define VDI_IOCTL_GET_INSTANCE_POOL _IO(VDI_IOCTL_MAGIC, 5)
+#define VDI_IOCTL_GET_COMMON_MEMORY _IO(VDI_IOCTL_MAGIC, 6)
+#define VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(VDI_IOCTL_MAGIC, 8)
+#define VDI_IOCTL_OPEN_INSTANCE _IO(VDI_IOCTL_MAGIC, 9)
+#define VDI_IOCTL_CLOSE_INSTANCE _IO(VDI_IOCTL_MAGIC, 10)
+#define VDI_IOCTL_GET_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 11)
+#define VDI_IOCTL_GET_REGISTER_INFO _IO(VDI_IOCTL_MAGIC, 12)
+
+/* RTK ioctl */
+#define VDI_IOCTL_SET_RTK_CLK_GATING _IO(VDI_IOCTL_MAGIC, 16)
+#define VDI_IOCTL_SET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 17)
+#define VDI_IOCTL_GET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 18)
+#define VDI_IOCTL_GET_RTK_SUPPORT_TYPE _IO(VDI_IOCTL_MAGIC, 19)
+#define VDI_IOCTL_GET_RTK_ASIC_REVISION _IO(VDI_IOCTL_MAGIC, 20)
+#define VDI_IOCTL_SET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 21)
+#define VDI_IOCTL_GET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 22)
+#define VDI_IOCTL_SET_RTK_DOVI_FLAG _IO(VDI_IOCTL_MAGIC, 23)
+#define VDI_IOCTL_GET_TOTAL_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 24)
+#define VDI_IOCTL_GET_RTK_DCSYS_INFO _IO(VDI_IOCTL_MAGIC, 25)
+
+#define VE_PLL_SYSH	0x000
+#define VE_PLL_VE1	0x001
+#define VE_PLL_VE2	0x010
+
+typedef struct vpudrv_buffer_t {
+	unsigned int size;
+	unsigned long phys_addr;
+	unsigned long base; /* kernel logical address in use kernel */
+	unsigned long virt_addr; /* virtual user space address */
+	unsigned int mem_type; /* RTK, for protect memory */
+} vpudrv_buffer_t;
+
+typedef struct vpu_bit_firmware_info_t {
+	unsigned int size; /* size of this structure*/
+	unsigned int core_idx;
+	unsigned long reg_base_offset;
+	unsigned short bit_code[512];
+} vpu_bit_firmware_info_t;
+
+typedef struct vpu_clock_info_t{
+	unsigned int core_idx;
+	unsigned int enable;
+	unsigned int value;
+} vpu_clock_info_t;
+
+typedef struct vpudrv_inst_info_t {
+	unsigned int core_idx;
+	unsigned int inst_idx;
+	int inst_open_count; /* for output only*/
+} vpudrv_inst_info_t;
+
+typedef struct vpudrv_intr_info_t {
+	unsigned int core_idx;
+	unsigned int timeout;
+	int intr_reason;
+#ifdef SUPPORT_MULTI_INST_INTR
+	int intr_inst_index;
+#endif
+} vpudrv_intr_info_t;
+
+typedef struct vpudrv_dovi_info_t{
+	unsigned int core_idx;
+	unsigned int inst_idx;
+	unsigned int enable;
+} vpudrv_dovi_info_t;
+#endif
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1_pm.c b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1_pm.c
new file mode 100644
index 00000000..c4ebb1a
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1_pm.c
@@ -0,0 +1,278 @@
+/*
+ * ve1_pm.c - ve1 power management
+ *
+ * Copyright (c) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+#include <linux/atomic.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/device.h>
+#include <linux/reset.h>
+#include <soc/realtek/power-control.h>
+#include "ve1_pm.h"
+
+#define MAX_VE_PD_NUM 2
+
+static const struct ve_pd_desc desc[MAX_VE_PD_NUM] = {
+	{
+		.name = "ve1",
+		.has_rstc_bist = 1,
+		.has_rstc = 1,
+		.has_power = 1,
+	},
+	{
+		.name = "ve3",
+		.has_rstc_bist = 1,
+		.has_rstc = 1,
+		.has_power = 1,
+	},
+};
+
+static struct ve_pd_data data[MAX_VE_PD_NUM];
+
+static int ve_pd_power_callback(struct notifier_block *nb, unsigned long action,
+				void *p)
+{
+	struct ve_pd_data *vpd = container_of(nb, struct ve_pd_data, pc_nb);
+
+	if (action != POWER_CONTROL_ACTION_POST_POWER_ON)
+		return NOTIFY_DONE;
+
+	pr_debug("pd%d: %s: reset\n", vpd->idx, __func__);
+	if (vpd->rstc)
+		reset_control_reset(vpd->rstc);
+	return NOTIFY_OK;
+}
+
+int ve_pd_init(struct device *dev, int idx)
+{
+	char name[20];
+	const struct ve_pd_desc *d = &desc[idx];
+	struct ve_pd_data *vpd = &data[idx];
+	int ret;
+
+	vpd->idx = idx;
+
+	if (!d->has_power)
+		goto ignore_init_power;
+
+	snprintf(name, sizeof(name), "pctrl_%s", d->name);
+	vpd->pctrl = power_control_get(name);
+	if (IS_ERR(vpd->pctrl)) {
+		ret = PTR_ERR(vpd->pctrl);
+		dev_warn(dev, "pd%d: failed to get power_control %s: %d\n",
+			 idx, name, ret);
+		vpd->pctrl = NULL;
+	}
+
+	vpd->pc_nb.notifier_call = ve_pd_power_callback;
+	power_control_register_notifier(vpd->pctrl, &vpd->pc_nb);
+
+ignore_init_power:
+
+	snprintf(name, sizeof(name), "clk_%s", d->name);
+	vpd->clk = devm_clk_get(dev, name);
+	if (IS_ERR(vpd->clk)) {
+		ret = PTR_ERR(vpd->clk);
+		dev_warn(dev, "pd%d: failed to get clk %s: %d\n",
+			 idx, name, ret);
+		vpd->clk = NULL;
+	}
+
+	if (!d->has_rstc)
+		goto ignore_init_rstc;
+
+	snprintf(name, sizeof(name), "%s", d->name);
+	vpd->rstc = devm_reset_control_get(dev, name);
+	if (IS_ERR(vpd->rstc)) {
+		ret = PTR_ERR(vpd->rstc);
+		dev_warn(dev, "pd%d: failed to get reset control %s: %d\n",
+			 idx, name, ret);
+		vpd->rstc = NULL;
+	}
+
+ignore_init_rstc:
+
+	if (!d->has_rstc)
+		goto ignore_init_rstc_bist;
+
+	snprintf(name, sizeof(name), "%s_bist", d->name);
+	vpd->rstc_bist = devm_reset_control_get(dev, name);
+	if (IS_ERR(vpd->rstc_bist)) {
+		ret = PTR_ERR(vpd->rstc_bist);
+		dev_warn(dev, "pd%d: failed to get reset control %s: %d\n",
+			 idx, name, ret);
+		vpd->rstc_bist = NULL;
+	}
+
+ignore_init_rstc_bist:
+
+	atomic_set(&vpd->power_cnt, 0);
+
+	if (vpd->rstc)
+		reset_control_deassert(vpd->rstc);
+	if (vpd->rstc_bist)
+		reset_control_deassert(vpd->rstc_bist);
+
+	return 0;
+}
+
+void ve_pd_exit(struct device *dev, int idx)
+{
+	struct ve_pd_data *vpd = &data[idx];
+
+	WARN(atomic_read(&vpd->power_cnt) != 0, "not power off\n");
+
+	if (vpd->rstc)
+		reset_control_assert(vpd->rstc);
+	if (vpd->rstc_bist)
+		reset_control_assert(vpd->rstc_bist);
+
+	if (vpd->pctrl) {
+		power_control_unregister_notifier(vpd->pctrl, &vpd->pc_nb);
+		power_control_put(vpd->pctrl);
+	}
+}
+
+int ve_pd_power_on(int idx)
+{
+	struct ve_pd_data *vpd = &data[idx];
+
+	pr_debug("pd%d: %s\n", idx, __func__);
+
+	if (atomic_inc_return(&vpd->power_cnt) != 1)
+		return 0;
+
+	pr_debug("pd%d: %s: power_cnt=%d\n", idx, __func__,
+		atomic_read(&vpd->power_cnt));
+
+	power_control_power_on(vpd->pctrl);
+	clk_prepare_enable(vpd->clk);
+
+	return 0;
+}
+
+int ve_pd_power_off(int idx)
+{
+	struct ve_pd_data *vpd = &data[idx];
+
+	pr_debug("pd%d: %s\n", idx, __func__);
+
+	if (atomic_dec_return(&vpd->power_cnt) != 0)
+		return 0;
+
+	pr_debug("pd%d: %s: power_cnt=%d\n", idx, __func__,
+		atomic_read(&vpd->power_cnt));
+
+	clk_disable_unprepare(vpd->clk);
+	power_control_power_off(vpd->pctrl);
+	return 0;
+}
+
+
+int ve_pd_reset_control_reset(int idx)
+{
+	struct ve_pd_data *vpd = &data[idx];
+
+	if (WARN_ON(!vpd->rstc))
+		return -EINVAL;
+
+	return reset_control_reset(vpd->rstc);
+}
+
+int ve_pd_clk_set_parent(int idx, const char *parent_name)
+{
+	struct ve_pd_data *vpd = &data[idx];
+	struct clk *clk;
+	int ret;
+
+	if (!parent_name)
+		return -EINVAL;
+
+	if (atomic_read(&vpd->power_cnt) != 0)
+		return -EBUSY;
+
+	clk = clk_get(NULL, parent_name);
+	if (IS_ERR_OR_NULL(clk))
+		return -EINVAL;
+
+	pr_debug("pd%d: %s: parent=%s\n", idx, __func__, parent_name);
+
+	ret = clk_set_parent(vpd->clk, clk);
+	clk_put(clk);
+
+	return ret;
+}
+
+int ve_pd_clk_parent_match(int idx, const char *clk_name)
+{
+	struct ve_pd_data *vpd = &data[idx];
+	struct clk *clk;
+	struct clk *pclk;
+	bool is_match;
+
+	if (!clk_name)
+		return -EINVAL;
+
+	clk = clk_get(NULL, clk_name);
+	if (IS_ERR_OR_NULL(clk))
+		return -EINVAL;
+
+	pclk = clk_get_parent(vpd->clk);
+
+	is_match = clk_is_match(pclk, clk);
+	clk_put(clk);
+
+	return is_match ? 1 : 0;
+}
+
+
+int ve_pd_clk_set_rate(int idx, unsigned long rate)
+{
+	struct ve_pd_data *vpd = &data[idx];
+	struct clk *clk;
+	struct clk *pclk;
+	bool is_match;
+
+	/* should not set rate if parent is clk_sysh */
+	clk = clk_get(NULL, "clk_sysh");
+	if (IS_ERR_OR_NULL(clk))
+		return -EINVAL;
+
+	pclk = clk_get_parent(vpd->clk);
+
+	is_match = clk_is_match(pclk, clk);
+	clk_put(clk);
+
+	if (is_match)
+		return -EPERM;
+
+	pr_debug("pd%d: %s: rate=%ld\n", idx, __func__, rate);
+
+	return clk_set_rate(vpd->clk, rate);
+}
+
+unsigned long ve_pd_clk_get_rate(int idx)
+{
+	struct ve_pd_data *vpd = &data[idx];
+
+	return clk_get_rate(vpd->clk);
+}
+
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1_pm.h b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1_pm.h
new file mode 100644
index 00000000..12b58a8
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1_pm.h
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+#ifndef __VE1_PM_H
+#define __VE1_PM_H
+
+#include <linux/atomic.h>
+#include <linux/notifier.h>
+
+struct clk;
+struct reset_control;
+struct power_control;
+
+struct ve_pd_desc {
+	const char *name;
+	int has_rstc_bist:1;
+	int has_rstc:1;
+	int has_power:1;
+};
+
+struct ve_pd_data {
+	int idx;
+	struct clk *clk;
+	struct reset_control *rstc;
+	struct reset_control *rstc_bist;
+	struct power_control *pctrl;
+	struct notifier_block pc_nb;
+	atomic_t power_cnt;
+};
+
+int ve_pd_init(struct device *dev, int idx);
+void ve_pd_exit(struct device *dev, int idx);
+int ve_pd_power_on(int idx);
+int ve_pd_power_off(int idx);
+int ve_pd_reset_control_reset(int idx);
+int ve_pd_clk_parent_match(int idx, const char *clk_name);
+int ve_pd_clk_set_parent(int idx, const char *parent_name);
+int ve_pd_clk_set_rate(int idx, unsigned long rate);
+unsigned long ve_pd_clk_get_rate(int idx);
+
+#endif
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1config.h b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1config.h
new file mode 100755
index 00000000..44ff5e2
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/ve1config.h
@@ -0,0 +1,110 @@
+/* =========================================================================
+ *  This file is a part of VE1 Reference API project
+ * -----------------------------------------------------------------------------
+ *
+ * This confidential and proprietary software may be used only
+ * as authorized by a licensing agreement from Realtek Inc.
+ * In the event of publication, the following notice is applicable:
+ *
+ * (C) COPYRIGHT 2006 - 2011  REALTEK INC.
+ * ALL RIGHTS RESERVED
+ *
+ * The entire notice above must be reproduced on all authorized
+ * copies.
+ * This file should be modified by some customers according to their SOC configuration.
+ * =========================================================================
+ */
+
+#ifndef _VPU_CONFIG_H_
+#define _VPU_CONFIG_H_
+
+#define BODA7503_CODE 0x7503
+#define CODA7542_CODE 0x7542
+#define BODA950_CODE 0x9500
+#define CODA960_CODE 0x9600
+#define CODA980_CODE 0x9800
+#define WAVE320_CODE 0x3200
+#define WAVE410_CODE 0x4100 /* Wave410 version 1: Single vcore */
+#define WAVE4102_CODE 0x4102 /* Wave410 version 2: Multi vcore */
+#define WAVE420_CODE 0x4200 /* Wave420 */
+#define WAVE420L_CODE 0x4201 /* Wave420 */
+#define WAVE412_CODE 0x4120
+#define WAVE510_CODE                    0x5100
+#define WAVE512_CODE                    0x5120
+#define WAVE520_CODE                    0x5200
+
+#define PRODUCT_CODE_W_SERIES(x) (x == WAVE420L_CODE || x == WAVE510_CODE || x == WAVE512_CODE || x == WAVE520_CODE)
+#define MAX_INST_HANDLE_SIZE (32*1024)
+#define MAX_NUM_INSTANCE 4
+#define MAX_NUM_VPU_CORE 2
+#define MAX_NUM_VCORE 1
+
+#define MAX_ENC_AVC_PIC_WIDTH 4096
+#define MAX_ENC_AVC_PIC_HEIGHT 2304
+#define MAX_ENC_PIC_WIDTH 4096
+#define MAX_ENC_PIC_HEIGHT 2304
+#define MIN_ENC_PIC_WIDTH 96
+#define MIN_ENC_PIC_HEIGHT 16
+
+/* for WAVE420 */
+#define W4_MIN_ENC_PIC_WIDTH 256
+#define W4_MIN_ENC_PIC_HEIGHT 128
+#define W4_MAX_ENC_PIC_WIDTH 8192
+#define W4_MAX_ENC_PIC_HEIGHT 8192
+
+#define MAX_DEC_PIC_WIDTH 4096
+#define MAX_DEC_PIC_HEIGHT 2304
+
+/* Application specific configuration */
+#define VPU_ENC_TIMEOUT 5000
+#define VPU_DEC_TIMEOUT 10000
+#define VPU_BUSY_CHECK_TIMEOUT 5000
+
+/* codec specific configuration */
+/* it can be set to 1 to handle reordering DPB in host side. */
+#define VPU_REORDER_ENABLE 1
+/*
+ * [default 1 for BW checking with RTKViedo Conformance] 0 (chroma separate mode), 1 (chroma interleave mode)
+ * if the type of tiledmap uses the kind of MB_RASTER_MAP. must set to enable CBCR_INTERLEAVE
+ */
+#define CBCR_INTERLEAVE 1
+#define VPU_ENABLE_BWB 1
+#define VPU_REPORT_USERDATA	 0
+
+#define HOST_ENDIAN  VDI_128BIT_LITTLE_ENDIAN
+#define VPU_FRAME_ENDIAN HOST_ENDIAN
+#define VPU_STREAM_ENDIAN HOST_ENDIAN
+#define VPU_USER_DATA_ENDIAN HOST_ENDIAN
+#define DRAM_BUS_WIDTH	 16
+
+/************************************************************************/
+/* VPU COMMON MEMORY */
+/************************************************************************/
+#define SIZE_COMMON (2*1024*1024)
+
+/*=====4. VPU REPORT MEMORY  ======================*/
+#define SIZE_REPORT_BUF (0x10000)
+
+#define STREAM_END_SIZE 0
+#define STREAM_END_SET_FLAG 0
+#define STREAM_END_CLEAR_FLAG -1
+
+#define USE_BIT_INTERNAL_BUF 1
+#define USE_IP_INTERNAL_BUF 1
+#define USE_DBKY_INTERNAL_BUF 1
+#define USE_DBKC_INTERNAL_BUF 1
+#define USE_OVL_INTERNAL_BUF 1
+#define USE_BTP_INTERNAL_BUF 1
+#define USE_ME_INTERNAL_BUF 1
+
+/* WAVE410 only */
+#define USE_BPU_INTERNAL_BUF 1
+#define USE_VCE_IP_INTERNAL_BUF 1
+#define USE_VCE_LF_ROW_INTERNAL_BUF 1
+
+/* WAVE420 only */
+#define USE_IMD_INTERNAL_BUF 1
+#define USE_RDO_INTERNAL_BUF 1
+#define USE_LF_INTERNAL_BUF 1
+
+#endif  /* _VPU_CONFIG_H_ */
diff --git a/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/vmm.h b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/vmm.h
new file mode 100755
index 00000000..5ad5792
--- /dev/null
+++ b/drivers/soc/realtek/rtd13xx/rtk_ve/ve1/vmm.h
@@ -0,0 +1,634 @@
+/**
+  vmm.h
+
+  memory allocator for VE
+
+ Copyright (C) 2006 - 2013  REALTEK INC.
+
+  This library is free software; you can redistribute it and/or modify it under
+  the terms of the GNU Lesser General Public License as published by the Free
+  Software Foundation; either version 2.1 of the License, or (at your option)
+  any later version.
+
+  This library is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+  details.
+
+  You should have received a copy of the GNU Lesser General Public License
+  along with this library; if not, write to the Free Software Foundation, Inc.,
+  51 Franklin St, Fifth Floor, Boston, MA
+  02110-1301  USA
+
+*/
+
+#ifndef __RTK_VIDEO_MEMORY_MANAGEMENT_H__
+#define __RTK_VIDEO_MEMORY_MANAGEMENT_H__
+
+typedef struct _video_mm_info_struct {
+	unsigned long   total_pages;
+	unsigned long   alloc_pages;
+	unsigned long   free_pages;
+	unsigned long   page_size;
+} vmem_info_t;
+
+typedef unsigned long long  vmem_key_t;
+
+#define VMEM_PAGE_SIZE (16*1024)
+#define MAKE_KEY(_a, _b) (((vmem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key) (_key>>32)
+
+typedef struct page_struct {
+	int pageno;
+	unsigned long addr;
+	int used;
+	int alloc_pages;
+	int first_pageno;
+} page_t;
+
+typedef struct avl_node_struct {
+	vmem_key_t key;
+	int height;
+	page_t *page;
+	struct avl_node_struct *left;
+	struct avl_node_struct *right;
+} avl_node_t;
+
+typedef struct _video_mm_struct {
+	avl_node_t *free_tree;
+	avl_node_t *alloc_tree;
+	page_t *page_list;
+	int num_pages;
+	unsigned long base_addr;
+	unsigned long mem_size;
+	int free_page_count;
+	int  alloc_page_count;
+} video_mm_t;
+
+#define VMEM_P_ALLOC(_x) vmalloc(_x)
+#define VMEM_P_FREE(_x) vfree(_x)
+
+#define VMEM_ASSERT(_exp) if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/
+#define VMEM_HEIGHT(_tree) (_tree == NULL ? -1 : _tree->height)
+
+#define MAX(_a, _b) (_a >= _b ? _a : _b)
+
+typedef enum {
+	LEFT,
+	RIGHT
+} rotation_dir_t;
+
+typedef struct avl_node_data_struct {
+	int	 key;
+	page_t *page;
+} avl_node_data_t;
+
+static avl_node_t* make_avl_node( vmem_key_t key, page_t *page)
+{
+	avl_node_t *node = (avl_node_t *)VMEM_P_ALLOC(sizeof(avl_node_t));
+	node->key	 = key;
+	node->page	= page;
+	node->height  = 0;
+	node->left	= NULL;
+	node->right   = NULL;
+
+	return node;
+}
+
+static int get_balance_factor(avl_node_t *tree)
+{
+	int factor = 0;
+	if (tree) {
+		factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+	}
+
+	return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *	  A					  B
+ *	   \					/ \
+ *		B		 =>	   A   C
+ *	   /  \				 \
+ *	  D	C				 D
+ *
+ */
+static avl_node_t* rotation_left(avl_node_t *tree)
+{
+	avl_node_t *rchild;
+	avl_node_t *lchild;
+
+	if (tree == NULL)
+		return NULL;
+
+	rchild = tree->right;
+	if (rchild == NULL) {
+		return tree;
+	}
+
+	lchild = rchild->left;
+	rchild->left = tree;
+	tree->right = lchild;
+
+	tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+	rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+	return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *		 A				  B
+ *	   \				  /  \
+ *	  B		 =>	   D	A
+ *	/  \					 /
+ *   D	C				   C
+ *
+ */
+static avl_node_t *rotation_right(avl_node_t *tree)
+{
+	avl_node_t *rchild;
+	avl_node_t *lchild;
+
+	if (tree == NULL)
+		return NULL;
+
+	lchild = tree->left;
+	if (lchild == NULL)
+		return NULL;
+
+	rchild = lchild->right;
+	lchild->right = tree;
+	tree->left = rchild;
+
+	tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+	lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+	return lchild;
+}
+
+static avl_node_t *do_balance(avl_node_t *tree)
+{
+	int bfactor = 0, child_bfactor;	   /* balancing factor */
+
+	bfactor = get_balance_factor(tree);
+
+	if (bfactor >= 2) {
+		child_bfactor = get_balance_factor(tree->right);
+		if (child_bfactor == 1 || child_bfactor == 0) {
+			tree = rotation_left(tree);
+		} else if (child_bfactor == -1) {
+			tree->right = rotation_right(tree->right);
+			tree		= rotation_left(tree);
+		} else {
+			printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+			VMEM_ASSERT(0);
+			return NULL;
+		}
+	} else if (bfactor <= -2) {
+		child_bfactor = get_balance_factor(tree->left);
+		if (child_bfactor == -1 || child_bfactor == 0) {
+			tree = rotation_right(tree);
+		} else if (child_bfactor == 1) {
+			tree->left = rotation_left(tree->left);
+			tree	   = rotation_right(tree);
+		} else {
+			printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+			VMEM_ASSERT(0);
+			return NULL;
+		}
+	}
+
+	return tree;
+}
+
+static avl_node_t *unlink_end_node(avl_node_t *tree, int dir, avl_node_t **found_node)
+{
+	avl_node_t *node;
+	*found_node = NULL;
+
+	if (tree == NULL)
+		return NULL;
+
+	if (dir == LEFT) {
+		if (tree->left == NULL) {
+			*found_node = tree;
+			return NULL;
+		}
+	} else {
+		if (tree->right == NULL) {
+			*found_node = tree;
+			return NULL;
+		}
+	}
+
+	if (dir == LEFT) {
+		node = tree->left;
+		tree->left = unlink_end_node(tree->left, LEFT, found_node);
+		if (tree->left == NULL) {
+			tree->left = (*found_node)->right;
+			(*found_node)->left  = NULL;
+			(*found_node)->right = NULL;
+		}
+	} else {
+		node = tree->right;
+		tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+		if (tree->right == NULL) {
+			tree->right = (*found_node)->left;
+			(*found_node)->left  = NULL;
+			(*found_node)->right = NULL;
+		}
+	}
+
+	tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	return do_balance(tree);
+}
+
+
+static avl_node_t *avltree_insert(avl_node_t *tree, vmem_key_t key, page_t *page)
+{
+	if (tree == NULL) {
+		tree = make_avl_node(key, page);
+	} else {
+		if (key >= tree->key) {
+			tree->right = avltree_insert(tree->right, key, page);
+		} else {
+			tree->left  = avltree_insert(tree->left, key, page);
+		}
+	}
+
+	tree = do_balance(tree);
+
+	tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	return tree;
+}
+
+static avl_node_t *do_unlink(avl_node_t *tree)
+{
+	avl_node_t *node;
+	avl_node_t *end_node;
+
+	node = unlink_end_node(tree->right, LEFT, &end_node);
+	if (node) {
+		tree->right = node;
+	} else {
+		node = unlink_end_node(tree->left, RIGHT, &end_node);
+		if (node)
+			tree->left = node;
+	}
+
+	if (node == NULL) {
+		node = tree->right ? tree->right : tree->left;
+		end_node = node;
+	}
+
+	if (end_node) {
+		end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+		end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+		end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+	}
+
+	tree = end_node;
+
+	return tree;
+}
+
+static avl_node_t *avltree_remove(avl_node_t *tree, avl_node_t **found_node, vmem_key_t key)
+{
+	*found_node = NULL;
+	if (tree == NULL) {
+		printk(KERN_INFO "failed to find key %d\n", (int)key);
+		return NULL;
+	}
+
+	if (key == tree->key) {
+		*found_node = tree;
+		tree = do_unlink(tree);
+	} else if (key > tree->key) {
+		tree->right = avltree_remove(tree->right, found_node, key);
+	} else {
+		tree->left  = avltree_remove(tree->left, found_node, key);
+	}
+
+	if (tree)
+		tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	tree = do_balance(tree);
+
+	return tree;
+}
+
+void avltree_free(avl_node_t *tree)
+{
+	if (tree == NULL)
+		return;
+	if (tree->left == NULL && tree->right == NULL) {
+		VMEM_P_FREE(tree);
+		return;
+	}
+
+	avltree_free(tree->left);
+	tree->left = NULL;
+	avltree_free(tree->right);
+	tree->right = NULL;
+	VMEM_P_FREE(tree);
+}
+
+static avl_node_t *remove_approx_value(avl_node_t *tree, avl_node_t **found, vmem_key_t key)
+{
+	*found = NULL;
+	if (tree == NULL) {
+		return NULL;
+	}
+
+	if (key == tree->key) {
+		*found = tree;
+		tree = do_unlink(tree);
+	} else if (key > tree->key) {
+		tree->right = remove_approx_value(tree->right, found, key);
+	} else {
+		tree->left  = remove_approx_value(tree->left, found, key);
+		if (*found == NULL) {
+			*found = tree;
+			tree = do_unlink(tree);
+		}
+	}
+	if (tree)
+		tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	tree = do_balance(tree);
+
+	return tree;
+}
+
+static void set_blocks_free(video_mm_t *mm, int pageno, int npages)
+{
+	int last_pageno	 = pageno + npages - 1;
+	int i;
+	page_t *page;
+	page_t *last_page;
+
+	VMEM_ASSERT(npages);
+
+	if (last_pageno >= mm->num_pages) {
+		printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+		VMEM_ASSERT(0);
+		return;
+	}
+
+	for (i = pageno; i <= last_pageno; i++) {
+		mm->page_list[i].used		 = 0;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	page		= &mm->page_list[pageno];
+	page->alloc_pages = npages;
+	last_page   = &mm->page_list[last_pageno];
+	last_page->first_pageno = pageno;
+
+	mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void set_blocks_alloc(video_mm_t *mm, int pageno, int npages)
+{
+	int last_pageno	 = pageno + npages - 1;
+	int i;
+	page_t *page;
+	page_t *last_page;
+
+	if (last_pageno >= mm->num_pages) {
+		printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+		VMEM_ASSERT(0);
+		return;
+	}
+
+	for (i = pageno; i <= last_pageno; i++) {
+		mm->page_list[i].used		 = 1;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	page		= &mm->page_list[pageno];
+	page->alloc_pages = npages;
+
+	last_page   = &mm->page_list[last_pageno];
+	last_page->first_pageno = pageno;
+
+	mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int vmem_init(video_mm_t *mm, unsigned long addr, unsigned long size)
+{
+	int i;
+
+	if (NULL == mm)
+		return -1;
+
+	mm->base_addr  = (addr+(VMEM_PAGE_SIZE-1))&~(VMEM_PAGE_SIZE-1);
+	mm->mem_size   = size&~VMEM_PAGE_SIZE;
+	mm->num_pages  = mm->mem_size/VMEM_PAGE_SIZE;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = mm->num_pages;
+	mm->alloc_page_count = 0;
+	mm->page_list  = (page_t *)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+	if (mm->page_list == NULL) {
+		printk(KERN_ERR "%s:%d failed to kmalloc(%d)\n", __func__, __LINE__, mm->num_pages*sizeof(page_t));
+		return -1;
+	}
+
+	for (i = 0; i < mm->num_pages; i++) {
+		mm->page_list[i].pageno	   = i;
+		mm->page_list[i].addr		 = mm->base_addr + i * VMEM_PAGE_SIZE;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].used		 = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	set_blocks_free(mm, 0, mm->num_pages);
+
+	return 0;
+}
+
+int vmem_exit(video_mm_t *mm)
+{
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_exit: invalid handle\n");
+		return -1;
+	}
+
+	if (mm->free_tree) {
+		avltree_free(mm->free_tree);
+	}
+	if (mm->alloc_tree) {
+		avltree_free(mm->alloc_tree);
+	}
+
+	if (mm->page_list) {
+		VMEM_P_FREE(mm->page_list);
+		mm->page_list = NULL;
+	}
+
+	mm->base_addr  = 0;
+	mm->mem_size   = 0;
+	mm->num_pages  = 0;
+	mm->page_list  = NULL;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = 0;
+	mm->alloc_page_count = 0;
+	return 0;
+}
+
+unsigned long vmem_alloc(video_mm_t *mm, int size, unsigned long pid)
+{
+	avl_node_t *node;
+	page_t *free_page;
+	int		 npages, free_size;
+	int		 alloc_pageno;
+	unsigned long  ptr;
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_alloc: invalid handle\n");
+		return -1;
+	}
+
+	if (size <= 0)
+		return -1;
+
+	npages = (size + VMEM_PAGE_SIZE - 1)/VMEM_PAGE_SIZE;
+
+	mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+	if (node == NULL) {
+		return -1;
+	}
+	free_page = node->page;
+	free_size = KEY_TO_VALUE(node->key);
+
+	alloc_pageno = free_page->pageno;
+	set_blocks_alloc(mm, alloc_pageno, npages);
+	if (npages != free_size) {
+		int free_pageno = alloc_pageno + npages;
+		set_blocks_free(mm, free_pageno, (free_size-npages));
+	}
+
+	VMEM_P_FREE(node);
+
+	ptr = mm->page_list[alloc_pageno].addr;
+	mm->alloc_page_count += npages;
+	mm->free_page_count  -= npages;
+
+
+	return ptr;
+}
+
+int vmem_free(video_mm_t *mm, unsigned long ptr, unsigned long pid)
+{
+	unsigned long addr;
+	avl_node_t *found;
+	page_t *page;
+	int pageno, prev_free_pageno, next_free_pageno;
+	int prev_size, next_size;
+	int merge_page_no, merge_page_size, free_page_size;
+
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_free: invalid handle\n");
+		return -1;
+	}
+
+	addr = ptr;
+
+	mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+	if (found == NULL) {
+		printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+		VMEM_ASSERT(0);
+		return -1;
+	}
+
+	/* find previous free block */
+	page = found->page;
+	pageno = page->pageno;
+	free_page_size = page->alloc_pages;
+	prev_free_pageno = pageno-1;
+	prev_size = -1;
+	if (prev_free_pageno >= 0) {
+		if (mm->page_list[prev_free_pageno].used == 0) {
+			prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+			prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+		}
+	}
+
+	/* find next free block */
+	next_free_pageno = pageno + page->alloc_pages;
+	next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+	next_size = -1;
+	if (next_free_pageno >= 0) {
+		if (mm->page_list[next_free_pageno].used == 0) {
+			next_size = mm->page_list[next_free_pageno].alloc_pages;
+		}
+	}
+	VMEM_P_FREE(found);
+
+	/* merge */
+	merge_page_no = page->pageno;
+	merge_page_size = page->alloc_pages;
+	if (prev_size >= 0) {
+		mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+		if (found == NULL) {
+			VMEM_ASSERT(0);
+			return -1;
+		}
+		merge_page_no = found->page->pageno;
+		merge_page_size += found->page->alloc_pages;
+		VMEM_P_FREE(found);
+	}
+	if (next_size >= 0) {
+		mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+		if (found == NULL) {
+			VMEM_ASSERT(0);
+			return -1;
+		}
+		merge_page_size += found->page->alloc_pages;
+		VMEM_P_FREE(found);
+	}
+
+	page->alloc_pages  = 0;
+	page->first_pageno = -1;
+
+	set_blocks_free(mm, merge_page_no, merge_page_size);
+
+	mm->alloc_page_count -= free_page_size;
+	mm->free_page_count  += free_page_size;
+
+	return 0;
+}
+
+int vmem_get_info(video_mm_t *mm, vmem_info_t *info)
+{
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_get_info: invalid handle\n");
+		return -1;
+	}
+
+	if (info == NULL) {
+		return -1;
+	}
+
+	info->total_pages = mm->num_pages;
+	info->alloc_pages = mm->alloc_page_count;
+	info->free_pages  = mm->free_page_count;
+	info->page_size   = VMEM_PAGE_SIZE;
+
+	return 0;
+}
+
+#endif /* __RTK_VIDEO_MEMORY_MANAGEMENT_H__ */
diff --git a/drivers/soc/realtek/rtd16xx/Kconfig b/drivers/soc/realtek/rtd16xx/Kconfig
new file mode 100644
index 00000000..3ec9ed7
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/Kconfig
@@ -0,0 +1,25 @@
+menu "RTD16xx General Setup"
+
+config THOR_PM_WORKARURD
+	bool "System restart workarurd"
+	depends on RTK_WATCHDOG
+	help
+	  For SQA test.
+
+config RTK_PSCI_BOOT
+	bool "RTK PSCI boot method"
+	default n
+	help
+	  Using PSCI method to control slave CPU power.
+
+config RTK_MMIO_SECURE_RTD16XX_GENERIC_CRT
+	bool
+	select RTK_MMIO_SECURE
+
+endmenu #RTD16xx general setup
+
+menu "RTD16xx Device Drivers"
+
+source "drivers/soc/realtek/rtd16xx/rtk_ve/Kconfig"
+
+endmenu #RTD16xx Device Drivers
diff --git a/drivers/soc/realtek/rtd16xx/Makefile b/drivers/soc/realtek/rtd16xx/Makefile
new file mode 100644
index 00000000..c5f52fb
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/Makefile
@@ -0,0 +1,10 @@
+ifndef CONFIG_CPU_V7
+obj-$(CONFIG_ARCH_RTD16xx) += rtd16xx_spin_table.o rtd16xx_cpu_hotplug.o rtd16xx_cpu_wrapper.o
+endif
+
+obj-$(CONFIG_ARCH_RTD16xx) += rtk_chip.o
+obj-$(CONFIG_ARCH_RTD16xx) += rtk_usb.o
+obj-$(CONFIG_ARM_PSCI_FW) += rtd16xx_psci.o
+obj-$(CONFIG_SUSPEND) += rtd16xx_suspend.o rtd16xx_suspend_fs.o rtd16xx_suspend_mem.o
+obj-$(CONFIG_RTK_CODEC) += rtk_ve/
+obj-$(CONFIG_CPU_V7) += aarch32/
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd16xx/aarch32/Makefile b/drivers/soc/realtek/rtd16xx/aarch32/Makefile
new file mode 100644
index 00000000..2ae9f5b
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/aarch32/Makefile
@@ -0,0 +1 @@
+obj-$(CONFIG_ARCH_RTD16xx) += rtd16xx_cpu_wrapper.o rtd16xx_cpu_hotplug.o
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd16xx/aarch32/rtd16xx_cpu_hotplug.S b/drivers/soc/realtek/rtd16xx/aarch32/rtd16xx_cpu_hotplug.S
new file mode 100644
index 00000000..daae6b6
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/aarch32/rtd16xx_cpu_hotplug.S
@@ -0,0 +1,32 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/linkage.h>
+#include <asm/assembler.h>
+#include <asm/cp15.h>
+#include <asm/virt.h>
+
+ENTRY(__cpu_do_lowpower)
+	mov r1, #0
+	mcr p15, 0, r1, c12, c12, 7
+	//msr S3_0_C12_C12_7, r12
+	isb
+	mrc p15, 0, r1, c15, c2, 7
+	//mrs r12, S3_0_C15_C2_7
+	orr r1, r1, #0x1 /* send power down request*/
+	mcr p15, 0, r1, c15, c2, 7
+	//msr S3_0_C15_C2_7, r12
+	isb
+	dsb sy
+1:
+	wfi
+	b 1b
+ENDPROC(__cpu_do_lowpower)
+
diff --git a/drivers/soc/realtek/rtd16xx/aarch32/rtd16xx_cpu_hotplug.h b/drivers/soc/realtek/rtd16xx/aarch32/rtd16xx_cpu_hotplug.h
new file mode 100644
index 00000000..498b3a4
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/aarch32/rtd16xx_cpu_hotplug.h
@@ -0,0 +1,20 @@
+/*
+ * rtd16xx_cpu_hotplug.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef RTD16xx_CPU_HOTPLUG_H_
+#define RTD16xx_CPU_HOTPLUG_H_
+
+#include <asm/virt.h>
+
+void __cpu_do_lowpower(unsigned long secondary_entry_addr);
+
+#endif /* RTD16xx_CPU_HOTPLUG_H_ */
diff --git a/drivers/soc/realtek/rtd16xx/aarch32/rtd16xx_cpu_wrapper.c b/drivers/soc/realtek/rtd16xx/aarch32/rtd16xx_cpu_wrapper.c
new file mode 100644
index 00000000..e5c6a16
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/aarch32/rtd16xx_cpu_wrapper.c
@@ -0,0 +1,341 @@
+/*
+ * rtd16xx_cpu_wrapper.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/delay.h>
+#include <linux/debugfs.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+
+#include <asm/io.h>
+#include <asm/cacheflush.h>
+#include <asm/cputype.h>
+#include <asm/io.h>
+#include <asm/smp_plat.h>
+
+#include <asm/system_misc.h>
+
+#include "../../common/include/debug.h"
+#include "rtd16xx_cpu_hotplug.h"
+
+#define DBG_INT 0x230
+#define DBG_ADDR 0x234
+#define DBG_ADDR_MODE 0x238
+
+static void __iomem *scpu_wrap_addr;
+
+void rtk_cpu_power_up_all(void)
+{
+	writel(0x00003F3F, scpu_wrap_addr + 0x538);
+	writel(0x000000FF | readl(scpu_wrap_addr + 0x100), scpu_wrap_addr + 0x100);
+	writel(0x00003233, scpu_wrap_addr + 0x900);
+}
+
+void rtk_cpu_power_up(int cpu)
+{
+	u32 tmp = 0;
+	u32 flag1 = 0;
+	u32 flag2 = 0;
+	u32 cpu_offset = cpu * 4;
+
+	/* 1. Apply power to the PDCPU power domain.
+	 * Keep the state of the signals nCPUPORESET */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (0 + cpu);
+	tmp |= 1UL << (8 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	do {
+		tmp = readl(scpu_wrap_addr + 0x53C);
+		flag1 = !((tmp >> (0 + cpu)) & 0x1);
+		flag2 = !((tmp >> (8 + cpu)) & 0x1);
+		if (flag1 || flag2) {
+			pr_err("%s: CPU%d Power Mode Request is not ON\n",
+				__func__, cpu);
+			pr_err("%s: %x = %x\n", __func__,
+				(0x9801d000 + 0x53C), tmp);
+		}
+
+	} while( flag1 ||flag2 );
+
+	/* 2. Release the core output clamps. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (16 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* 3. SCP setup core P-Channel corresponding PSTATE Register
+	 * Request Power Mode to ON */
+	tmp = readl(scpu_wrap_addr + (0x540 + cpu_offset));
+	tmp &= 0x0000003F;
+	writel(tmp, scpu_wrap_addr + (0x540 + cpu_offset));
+	tmp |= 0x01000008;
+	writel(tmp, scpu_wrap_addr + (0x540 + cpu_offset));
+
+	/* 4. De-assert CPU cores resets. */
+	if (cpu < 4) {
+		tmp = readl(scpu_wrap_addr + 0x100);
+		tmp |= 1UL << (0 + cpu);
+		tmp |= 1UL << (4 + cpu);
+		writel(tmp, scpu_wrap_addr + 0x100);
+	} else {
+		tmp = readl(scpu_wrap_addr + 0x900);
+		tmp |= 1UL << (0 + (cpu - 4));
+		tmp |= 1UL << (4 + (cpu - 4));
+		writel(tmp, scpu_wrap_addr + 0x900);
+	}
+
+}
+EXPORT_SYMBOL(rtk_cpu_power_up);
+
+void rtk_cpu_power_down(int cpu)
+{
+	u32 tmp = 0;
+	u32 cpu_offset = cpu * 4;
+
+	/* SCP polling core corresponding P-Channel PACTIVE Register,
+	 * SC_CORE_PCHANNEL_STAT_ACK bit[10:0] is 0x0
+	 * (Power Mode Request is OFF)
+	 */
+	do {
+		tmp = readl(scpu_wrap_addr + (0x5C0 + cpu_offset));
+		tmp = tmp & 0x000007FF;
+		if (tmp != 0x00000000) {
+			pr_err("%s: CPU%d Power Mode Request is not OFF\n",
+				__func__, cpu);
+			pr_err("%s: %x = %d \n",
+				__func__, (0x9801d000 + 0x5C0 + cpu_offset),
+				tmp);
+		}
+	} while (tmp != 0x00000000);
+
+	/* SCP setup core P-Channel corresponding PSTATE Register,
+	 * Set SC_CORE_PCHANNEL_CTRL bit[5:0] as 0x0
+	 * (Request Power Mode to OFF)
+	 *
+	 * Set SC_CORE_PCHANNEL_CTRL bit[16] as 0x1
+	 * to assert P-Channel Request
+	 */
+	tmp = readl(scpu_wrap_addr + (0x540 + cpu_offset));
+	tmp &= 0xFFFFFFC0;
+	tmp |= 1UL << 16;
+	writel(tmp, scpu_wrap_addr + (0x540 + cpu_offset));
+
+	/* Wait P-Channel Request is Accepted:
+	 * Polling when SC_ CORE_PCHANNEL INT_STAT bit[8:0] is 0x1
+	 * (only paccept is asserted),
+	 * SC_CORE_PCHANNEL_STAT_ACK_TRIGGER bit[10:0] is 0x0
+	 * (Power Mode Request is OFF).
+	 */
+	do {
+		mdelay(1);
+		tmp = readl(scpu_wrap_addr + (0x930 + cpu_offset));
+		tmp &= 0x00000001;
+		if (!tmp) {
+			pr_err("%s: %x bit [8:0] is not 0x1, %x = %x\n",
+				__func__,
+				(0x9801d000 + 0x930 + cpu_offset),
+				(0x9801d000 + 0x930 + cpu_offset), tmp);
+		}
+	} while (!tmp);
+
+	do {
+		tmp = readl(scpu_wrap_addr + (0x580 + cpu_offset));
+		tmp &= 0x000007FF;
+		if (tmp) {
+			pr_err("%s: CPU%d Power Mode Request is not OFF\n",
+				__func__, cpu);
+			pr_err("%s: %x = %x\n", __func__,
+				(0x9801d000 + 0x580 + cpu_offset), tmp);
+		}
+	} while (tmp);
+
+	/*
+	 * SCP set SCPU Power_CTRL rbus register to reach the
+	 * requested power mode physical control.
+	 */
+
+	/* Activate the core output clamps. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (16 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* Assert nCPUPORESET LOW. */
+	if (cpu < 4) {
+		tmp = readl(scpu_wrap_addr + 0x100);
+		tmp &= ~(1UL << (0 + cpu));
+		tmp &= ~(1UL << (4 + cpu));
+		writel(tmp, scpu_wrap_addr + 0x100);
+	} else {
+		tmp = readl(scpu_wrap_addr + 0x900);
+		tmp &= ~(1UL << (0 + (cpu - 4)));
+		tmp &= ~(1UL << (4 + (cpu - 4)));
+		writel(tmp, scpu_wrap_addr + 0x900);
+	}
+
+	/* Remove power from the PDCPU power domain. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (0 + cpu));
+	tmp &= ~(1UL << (8 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+}
+EXPORT_SYMBOL(rtk_cpu_power_down);
+
+static int set_l4_icg(void *base)
+{
+	unsigned int val;
+
+	val = readl(scpu_wrap_addr + 0x000);
+	val |= 0xFF3C0000;
+	writel(val, scpu_wrap_addr + 0x000);
+
+	val = readl(scpu_wrap_addr + 0x030);
+	val |= 0x2000000;
+	writel(val, scpu_wrap_addr + 0x030);
+
+	val = readl(scpu_wrap_addr + 0x100);
+	val |= 0xC000000;
+	writel(val, scpu_wrap_addr + 0x100);
+
+	return 0;
+}
+
+irqreturn_t scpu_wrapper_isr(int irq, void *reg_base)
+{
+	struct pt_regs *regs;
+	u32 intr = readl(scpu_wrap_addr + DBG_INT);
+	u32 addr = readl(scpu_wrap_addr + DBG_ADDR);
+	u32 cause = readl(scpu_wrap_addr + DBG_ADDR_MODE);
+	char buf[128];
+
+	regs = get_irq_regs();
+
+	dbg_err("scpu wrapper get int 0x%08x", intr);
+	if(intr & (BIT(4) | BIT(2))){
+		writel((intr & ~(BIT(3)|BIT(1))), scpu_wrap_addr + DBG_INT);
+		dbg_err("scpu addr:0x%08x mode:%s", addr, (cause & 1) ? "W" : "R");
+
+		sprintf(buf, "[SCUP] Memory 0x%08x trashed with %s\n", addr,
+				(cause & 1) ? "W" : "R");
+		die(buf, regs, 0);
+
+		return IRQ_HANDLED;
+	}
+
+	return IRQ_NONE;
+}
+
+static const struct of_device_id rtk_scpu_wrapper_ids[] __initconst = {
+	{.compatible = "Realtek,rtk-scpu_wrapper"},
+	{},
+};
+
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w);
+
+static int __init scpu_wrapper_init(void)
+{
+	struct device_node *np;
+	int irq = 0;
+	int i = 0;
+
+	np = of_find_matching_node(NULL, rtk_scpu_wrapper_ids);
+	if(unlikely(np == NULL))
+		return -1;
+
+	irq = irq_of_parse_and_map(np, 0);
+
+	scpu_wrap_addr = of_iomap(np, 0);
+	dbg_info("scpu wrappee irq %d, scpu_wrap_addr 0x%08llx\n", irq, (u64)scpu_wrap_addr);
+
+	of_node_put(np);
+
+	if(request_irq(irq, scpu_wrapper_isr, IRQF_SHARED, "scpu_wrapper", scpu_wrap_addr) != 0){
+		dbg_err("Cannot get IRQ\n");
+		return -1;
+	}
+
+	/* clear dbg trap addr*/
+	for(i = 0 ; i < 8 ; i++ )
+		writel(0, scpu_wrap_addr + 0x200 + i * 4);
+	writel(0x98000000, scpu_wrap_addr + 0x200);	// 1st set start
+	writel(0x98000040, scpu_wrap_addr + 0x210);	// 1st set end
+
+	writel(0x98000040, scpu_wrap_addr + 0x204);	// 2nd set start
+	writel(0x98000080, scpu_wrap_addr + 0x214);	// 2nd set end
+
+	writel(0x98000080, scpu_wrap_addr + 0x208);	// 3th set start
+	writel(0x980000c0, scpu_wrap_addr + 0x218);	// 3th set end
+
+	writel(0x980000c0, scpu_wrap_addr + 0x20c);	// 4th set start
+	writel(0x98000100, scpu_wrap_addr + 0x21c);	// 4th set end
+
+	writel(0x9, scpu_wrap_addr + DBG_INT);	// enable interrupt
+
+	printk(KERN_INFO "[SCPU_WRAPPER] initialized\n");
+
+	printk(KERN_INFO "[SCPU_WRAPPER][%s] memory monitor 0x98013b00 - 0x98013c00\n",__FUNCTION__);
+	scpu_dbg_scpu_monitor(0, 0x98013b00, 0x98013c00, 0x0);
+
+	set_l4_icg(scpu_wrap_addr);
+
+	return 0;
+}
+late_initcall(scpu_wrapper_init);
+
+void scpu_dbg_disable_mem_monitor(int which)
+{
+	void __iomem  *reg_ctrl;
+
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220);
+	reg_ctrl += which;
+	writel((1 << 13) | (1 << 9) | (1 << 1), reg_ctrl);
+}
+EXPORT_SYMBOL(scpu_dbg_disable_mem_monitor);
+
+static void scpu_dbg_set_mem_monitor(int which, u32 start, u32 end, u32 flags)
+{
+	void __iomem  *reg_start;
+	void __iomem  *reg_end;
+	void __iomem  *reg_ctrl;
+
+	/* disable this set first */
+	scpu_dbg_disable_mem_monitor(which);
+
+	reg_start = (void __iomem  *)(scpu_wrap_addr + 0x200 + which);
+	reg_end = (void __iomem  *)(scpu_wrap_addr + 0x210 + which);
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220 + which);
+
+	writel(start, reg_start);
+	writel(end, reg_end);
+
+	writel(flags, reg_ctrl);
+}
+
+/*
+ * which: 0~7, which register set
+ * d_i: SB2_DBG_MONITOR_DATA|SB2_DBG_MONITOR_INST
+ * r_w: SB2_DBG_MONITOR_READ|SB2_DBG_MONITOR_WRITE
+ */
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w)
+{
+	scpu_dbg_set_mem_monitor(which * 4, start, end, (3 << 8) | r_w | 3);
+}
+EXPORT_SYMBOL(scpu_dbg_scpu_monitor);
diff --git a/drivers/soc/realtek/rtd16xx/rtd16xx_cpu_hotplug.S b/drivers/soc/realtek/rtd16xx/rtd16xx_cpu_hotplug.S
new file mode 100644
index 00000000..041409a
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtd16xx_cpu_hotplug.S
@@ -0,0 +1,33 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/linkage.h>
+#include <asm/assembler.h>
+#include <asm/sysreg.h>
+#include <asm/virt.h>
+
+.text
+.pushsection .idmap.text, "ax"
+
+ENTRY(__cpu_do_lowpower)
+	mov x12, 0
+	msr S3_0_C12_C12_7, x12
+	isb
+	mrs x12, S3_0_C15_C2_7
+	orr x12, x12, #0x1 /* send power down request*/
+	msr S3_0_C15_C2_7, x12
+	isb
+	dsb sy
+1:
+	wfi
+	b 1b
+ENDPROC(__cpu_do_lowpower)
+
+.popsection
diff --git a/drivers/soc/realtek/rtd16xx/rtd16xx_cpu_hotplug.h b/drivers/soc/realtek/rtd16xx/rtd16xx_cpu_hotplug.h
new file mode 100644
index 00000000..6f0b20f
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtd16xx_cpu_hotplug.h
@@ -0,0 +1,26 @@
+/*
+ * rtd16xx_cpu_hotplug.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef RTD16xx_CPU_HOTPLUG_H_
+#define RTD16xx_CPU_HOTPLUG_H_
+
+#include <asm/virt.h>
+
+void __cpu_do_lowpower(unsigned long secondary_entry_addr);
+
+static inline void cpu_do_lowpower(unsigned long secondary_entry_addr)
+{
+	__cpu_do_lowpower(secondary_entry_addr);
+	unreachable();
+}
+
+#endif /* RTD16xx_CPU_HOTPLUG_H_ */
diff --git a/drivers/soc/realtek/rtd16xx/rtd16xx_cpu_wrapper.c b/drivers/soc/realtek/rtd16xx/rtd16xx_cpu_wrapper.c
new file mode 100755
index 00000000..100490b
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtd16xx_cpu_wrapper.c
@@ -0,0 +1,341 @@
+/*
+ * rtd16xx_cpu_wrapper.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/printk.h>
+#include <linux/delay.h>
+#include <linux/debugfs.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+
+#include <asm/io.h>
+#include <asm/cacheflush.h>
+#include <asm/cpu_ops.h>
+#include <asm/cputype.h>
+#include <asm/io.h>
+#include <asm/smp_plat.h>
+
+#include <asm/system_misc.h>
+
+#include "../common/include/debug.h"
+
+#define DBG_INT 0x230
+#define DBG_ADDR 0x234
+#define DBG_ADDR_MODE 0x238
+
+static void __iomem *scpu_wrap_addr;
+
+void rtk_cpu_power_up_all(void)
+{
+	writel(0x00003F3F, scpu_wrap_addr + 0x538);
+	writel(0x000000FF | readl(scpu_wrap_addr + 0x100), scpu_wrap_addr + 0x100);
+	writel(0x00003233, scpu_wrap_addr + 0x900);
+}
+
+void rtk_cpu_power_up(int cpu)
+{
+	u32 tmp = 0;
+	u32 flag1 = 0;
+	u32 flag2 = 0;
+	u32 cpu_offset = cpu * 4;
+
+	/* 1. Apply power to the PDCPU power domain.
+	 * Keep the state of the signals nCPUPORESET */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (0 + cpu);
+	tmp |= 1UL << (8 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	do {
+		tmp = readl(scpu_wrap_addr + 0x53C);
+		flag1 = !((tmp >> (0 + cpu)) & 0x1);
+		flag2 = !((tmp >> (8 + cpu)) & 0x1);
+		if (flag1 || flag2) {
+			pr_err("%s: CPU%d Power Mode Request is not ON\n",
+				__func__, cpu);
+			pr_err("%s: %x = %x\n", __func__,
+				(0x9801d000 + 0x53C), tmp);
+		}
+
+	} while( flag1 ||flag2 );
+
+	/* 2. Release the core output clamps. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (16 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* 3. SCP setup core P-Channel corresponding PSTATE Register
+	 * Request Power Mode to ON */
+	tmp = readl(scpu_wrap_addr + (0x540 + cpu_offset));
+	tmp &= 0x0000003F;
+	writel(tmp, scpu_wrap_addr + (0x540 + cpu_offset));
+	tmp |= 0x01000008;
+	writel(tmp, scpu_wrap_addr + (0x540 + cpu_offset));
+
+	/* 4. De-assert CPU cores resets. */
+	if (cpu < 4) {
+		tmp = readl(scpu_wrap_addr + 0x100);
+		tmp |= 1UL << (0 + cpu);
+		tmp |= 1UL << (4 + cpu);
+		writel(tmp, scpu_wrap_addr + 0x100);
+	} else {
+		tmp = readl(scpu_wrap_addr + 0x900);
+		tmp |= 1UL << (0 + (cpu - 4));
+		tmp |= 1UL << (4 + (cpu - 4));
+		writel(tmp, scpu_wrap_addr + 0x900);
+	}
+
+}
+EXPORT_SYMBOL(rtk_cpu_power_up);
+
+void rtk_cpu_power_down(int cpu)
+{
+	u32 tmp = 0;
+	u32 cpu_offset = cpu * 4;
+
+	/* SCP polling core corresponding P-Channel PACTIVE Register,
+	 * SC_CORE_PCHANNEL_STAT_ACK bit[10:0] is 0x0
+	 * (Power Mode Request is OFF)
+	 */
+	do {
+		tmp = readl(scpu_wrap_addr + (0x5C0 + cpu_offset));
+		tmp = tmp & 0x000007FF;
+		if (tmp != 0x00000000) {
+			pr_err("%s: CPU%d Power Mode Request is not OFF\n",
+				__func__, cpu);
+			pr_err("%s: %x = %d \n",
+				__func__, (0x9801d000 + 0x5C0 + cpu_offset),
+				tmp);
+		}
+	} while (tmp != 0x00000000);
+
+	/* SCP setup core P-Channel corresponding PSTATE Register,
+	 * Set SC_CORE_PCHANNEL_CTRL bit[5:0] as 0x0
+	 * (Request Power Mode to OFF)
+	 *
+	 * Set SC_CORE_PCHANNEL_CTRL bit[16] as 0x1
+	 * to assert P-Channel Request
+	 */
+	tmp = readl(scpu_wrap_addr + (0x540 + cpu_offset));
+	tmp &= 0xFFFFFFC0;
+	tmp |= 1UL << 16;
+	writel(tmp, scpu_wrap_addr + (0x540 + cpu_offset));
+
+	/* Wait P-Channel Request is Accepted:
+	 * Polling when SC_ CORE_PCHANNEL INT_STAT bit[8:0] is 0x1
+	 * (only paccept is asserted),
+	 * SC_CORE_PCHANNEL_STAT_ACK_TRIGGER bit[10:0] is 0x0
+	 * (Power Mode Request is OFF).
+	 */
+	do {
+		mdelay(1);
+		tmp = readl(scpu_wrap_addr + (0x930 + cpu_offset));
+		tmp &= 0x00000001;
+		if (!tmp) {
+			pr_err("%s: %x bit [8:0] is not 0x1, %x = %x\n",
+				__func__,
+				(0x9801d000 + 0x930 + cpu_offset),
+				(0x9801d000 + 0x930 + cpu_offset), tmp);
+		}
+	} while (!tmp);
+
+	do {
+		tmp = readl(scpu_wrap_addr + (0x580 + cpu_offset));
+		tmp &= 0x000007FF;
+		if (tmp) {
+			pr_err("%s: CPU%d Power Mode Request is not OFF\n",
+				__func__, cpu);
+			pr_err("%s: %x = %x\n", __func__,
+				(0x9801d000 + 0x580 + cpu_offset), tmp);
+		}
+	} while (tmp);
+
+	/*
+	 * SCP set SCPU Power_CTRL rbus register to reach the
+	 * requested power mode physical control.
+	 */
+
+	/* Activate the core output clamps. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp |= 1UL << (16 + cpu);
+	writel(tmp, scpu_wrap_addr + 0x538);
+
+	/* Assert nCPUPORESET LOW. */
+	if (cpu < 4) {
+		tmp = readl(scpu_wrap_addr + 0x100);
+		tmp &= ~(1UL << (0 + cpu));
+		tmp &= ~(1UL << (4 + cpu));
+		writel(tmp, scpu_wrap_addr + 0x100);
+	} else {
+		tmp = readl(scpu_wrap_addr + 0x900);
+		tmp &= ~(1UL << (0 + (cpu - 4)));
+		tmp &= ~(1UL << (4 + (cpu - 4)));
+		writel(tmp, scpu_wrap_addr + 0x900);
+	}
+
+	/* Remove power from the PDCPU power domain. */
+	tmp = readl(scpu_wrap_addr + 0x538);
+	tmp &= ~(1UL << (0 + cpu));
+	tmp &= ~(1UL << (8 + cpu));
+	writel(tmp, scpu_wrap_addr + 0x538);
+}
+EXPORT_SYMBOL(rtk_cpu_power_down);
+
+static int set_l4_icg(void *base)
+{
+	unsigned int val;
+
+	val = readl(scpu_wrap_addr + 0x000);
+	val |= 0xFF3C0000;
+	writel(val, scpu_wrap_addr + 0x000);
+
+	val = readl(scpu_wrap_addr + 0x030);
+	val |= 0x02000000;
+	writel(val, scpu_wrap_addr + 0x030);
+
+	val = readl(scpu_wrap_addr + 0x100);
+	val |= 0xC0000000;
+	writel(val, scpu_wrap_addr + 0x100);
+
+	return 0;
+}
+
+irqreturn_t scpu_wrapper_isr(int irq, void *reg_base)
+{
+	struct pt_regs *regs;
+	u32 intr = readl(scpu_wrap_addr + DBG_INT);
+	u32 addr = readl(scpu_wrap_addr + DBG_ADDR);
+	u32 cause = readl(scpu_wrap_addr + DBG_ADDR_MODE);
+	char buf[128];
+
+	regs = get_irq_regs();
+
+	dbg_err("scpu wrapper get int 0x%08x", intr);
+	if(intr & (BIT(4) | BIT(2))){
+		writel((intr & ~(BIT(3)|BIT(1))), scpu_wrap_addr + DBG_INT);
+		dbg_err("scpu addr:0x%08x mode:%s", addr, (cause & 1) ? "W" : "R");
+
+		sprintf(buf, "[SCUP] Memory 0x%08x trashed with %s\n", addr,
+				(cause & 1) ? "W" : "R");
+		die(buf, regs, 0);
+
+		return IRQ_HANDLED;
+	}
+
+	return IRQ_NONE;
+}
+
+static const struct of_device_id rtk_scpu_wrapper_ids[] __initconst = {
+	{.compatible = "Realtek,rtk-scpu_wrapper"},
+	{},
+};
+
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w);
+
+static int __init scpu_wrapper_init(void)
+{
+	struct device_node *np;
+	int irq = 0;
+	int i = 0;
+
+	np = of_find_matching_node(NULL, rtk_scpu_wrapper_ids);
+	if(unlikely(np == NULL))
+		return -1;
+
+	irq = irq_of_parse_and_map(np, 0);
+
+	scpu_wrap_addr = of_iomap(np, 0);
+	dbg_info("scpu wrappee irq %d, scpu_wrap_addr 0x%08llx\n", irq, (u64)scpu_wrap_addr);
+
+	of_node_put(np);
+
+	if(request_irq(irq, scpu_wrapper_isr, IRQF_SHARED, "scpu_wrapper", scpu_wrap_addr) != 0){
+		dbg_err("Cannot get IRQ\n");
+		return -1;
+	}
+
+	/* clear dbg trap addr*/
+	for(i = 0 ; i < 8 ; i++ )
+		writel(0, scpu_wrap_addr + 0x200 + i * 4);
+	writel(0x98000000, scpu_wrap_addr + 0x200);	// 1st set start
+	writel(0x98000040, scpu_wrap_addr + 0x210);	// 1st set end
+
+	writel(0x98000040, scpu_wrap_addr + 0x204);	// 2nd set start
+	writel(0x98000080, scpu_wrap_addr + 0x214);	// 2nd set end
+
+	writel(0x98000080, scpu_wrap_addr + 0x208);	// 3th set start
+	writel(0x980000c0, scpu_wrap_addr + 0x218);	// 3th set end
+
+	writel(0x980000c0, scpu_wrap_addr + 0x20c);	// 4th set start
+	writel(0x98000100, scpu_wrap_addr + 0x21c);	// 4th set end
+
+	writel(0x9, scpu_wrap_addr + DBG_INT);	// enable interrupt
+
+	printk(KERN_INFO "[SCPU_WRAPPER] initialized\n");
+
+	printk(KERN_INFO "[SCPU_WRAPPER][%s] memory monitor 0x98013b00 - 0x98013c00\n",__FUNCTION__);
+	scpu_dbg_scpu_monitor(0, 0x98013b00, 0x98013c00, 0x0);
+
+	set_l4_icg(scpu_wrap_addr);
+
+	return 0;
+}
+late_initcall(scpu_wrapper_init);
+
+void scpu_dbg_disable_mem_monitor(int which)
+{
+	void __iomem  *reg_ctrl;
+
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220);
+	reg_ctrl += which;
+	writel((1 << 13) | (1 << 9) | (1 << 1), reg_ctrl);
+}
+EXPORT_SYMBOL(scpu_dbg_disable_mem_monitor);
+
+static void scpu_dbg_set_mem_monitor(int which, u32 start, u32 end, u32 flags)
+{
+	void __iomem  *reg_start;
+	void __iomem  *reg_end;
+	void __iomem  *reg_ctrl;
+
+	/* disable this set first */
+	scpu_dbg_disable_mem_monitor(which);
+
+	reg_start = (void __iomem  *)(scpu_wrap_addr + 0x200 + which);
+	reg_end = (void __iomem  *)(scpu_wrap_addr + 0x210 + which);
+	reg_ctrl = (void __iomem  *)(scpu_wrap_addr + 0x220 + which);
+
+	writel(start, reg_start);
+	writel(end, reg_end);
+
+	writel(flags, reg_ctrl);
+}
+
+/*
+ * which: 0~7, which register set
+ * d_i: SB2_DBG_MONITOR_DATA|SB2_DBG_MONITOR_INST
+ * r_w: SB2_DBG_MONITOR_READ|SB2_DBG_MONITOR_WRITE
+ */
+void scpu_dbg_scpu_monitor(int which, u32 start, u32 end, u32 r_w)
+{
+	scpu_dbg_set_mem_monitor(which * 4, start, end, (3 << 8) | r_w | 3);
+}
+EXPORT_SYMBOL(scpu_dbg_scpu_monitor);
diff --git a/drivers/soc/realtek/rtd16xx/rtd16xx_psci.c b/drivers/soc/realtek/rtd16xx/rtd16xx_psci.c
new file mode 100644
index 00000000..e30aed6
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtd16xx_psci.c
@@ -0,0 +1,703 @@
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * Copyright (C) 2015 ARM Limited
+ */
+
+#define pr_fmt(fmt) "psci: " fmt
+
+#include <linux/acpi.h>
+#include <linux/arm-smccc.h>
+#include <linux/cpuidle.h>
+#include <linux/errno.h>
+#include <linux/linkage.h>
+#include <linux/of.h>
+#include <linux/pm.h>
+#include <linux/printk.h>
+#include <linux/psci.h>
+#include <linux/reboot.h>
+#include <linux/slab.h>
+#include <linux/suspend.h>
+
+#include <uapi/linux/psci.h>
+
+#include <asm/cpuidle.h>
+#include <asm/cputype.h>
+#include <asm/system_misc.h>
+#include <asm/smp_plat.h>
+#include <asm/suspend.h>
+
+/*
+ * While a 64-bit OS can make calls with SMC32 calling conventions, for some
+ * calls it is necessary to use SMC64 to pass or return 64-bit values.
+ * For such calls PSCI_FN_NATIVE(version, name) will choose the appropriate
+ * (native-width) function ID.
+ */
+#ifdef CONFIG_64BIT
+#define PSCI_FN_NATIVE(version, name)	PSCI_##version##_FN64_##name
+#else
+#define PSCI_FN_NATIVE(version, name)	PSCI_##version##_FN_##name
+#endif
+
+/*
+ * The CPU any Trusted OS is resident on. The trusted OS may reject CPU_OFF
+ * calls to its resident CPU, so we must avoid issuing those. We never migrate
+ * a Trusted OS even if it claims to be capable of migration -- doing so will
+ * require cooperation with a Trusted OS driver.
+ */
+static int resident_cpu = -1;
+
+bool psci_tos_resident_on(int cpu)
+{
+	return cpu == resident_cpu;
+}
+
+struct psci_operations psci_ops = {
+	.conduit = PSCI_CONDUIT_NONE,
+	.smccc_version = SMCCC_VERSION_1_0,
+};
+
+typedef unsigned long (psci_fn)(unsigned long, unsigned long,
+				unsigned long, unsigned long);
+ psci_fn *invoke_psci_fn;
+
+enum psci_function {
+	PSCI_FN_CPU_SUSPEND,
+	PSCI_FN_CPU_ON,
+	PSCI_FN_CPU_OFF,
+	PSCI_FN_MIGRATE,
+	PSCI_FN_MAX,
+};
+
+static u32 psci_function_id[PSCI_FN_MAX];
+
+#define PSCI_0_2_POWER_STATE_MASK		\
+				(PSCI_0_2_POWER_STATE_ID_MASK | \
+				PSCI_0_2_POWER_STATE_TYPE_MASK | \
+				PSCI_0_2_POWER_STATE_AFFL_MASK)
+
+#define PSCI_1_0_EXT_POWER_STATE_MASK		\
+				(PSCI_1_0_EXT_POWER_STATE_ID_MASK | \
+				PSCI_1_0_EXT_POWER_STATE_TYPE_MASK)
+
+static u32 psci_cpu_suspend_feature;
+
+static inline bool psci_has_ext_power_state(void)
+{
+	return psci_cpu_suspend_feature &
+				PSCI_1_0_FEATURES_CPU_SUSPEND_PF_MASK;
+}
+
+static inline bool psci_power_state_loses_context(u32 state)
+{
+	const u32 mask = psci_has_ext_power_state() ?
+					PSCI_1_0_EXT_POWER_STATE_TYPE_MASK :
+					PSCI_0_2_POWER_STATE_TYPE_MASK;
+
+	return state & mask;
+}
+
+static inline bool psci_power_state_is_valid(u32 state)
+{
+	const u32 valid_mask = psci_has_ext_power_state() ?
+			       PSCI_1_0_EXT_POWER_STATE_MASK :
+			       PSCI_0_2_POWER_STATE_MASK;
+
+	return !(state & ~valid_mask);
+}
+
+static unsigned long __invoke_psci_fn_hvc(unsigned long function_id,
+			unsigned long arg0, unsigned long arg1,
+			unsigned long arg2)
+{
+	struct arm_smccc_res res;
+
+	arm_smccc_hvc(function_id, arg0, arg1, arg2, 0, 0, 0, 0, &res);
+	return res.a0;
+}
+
+static unsigned long __invoke_psci_fn_smc(unsigned long function_id,
+			unsigned long arg0, unsigned long arg1,
+			unsigned long arg2)
+{
+	struct arm_smccc_res res;
+
+	arm_smccc_smc(function_id, arg0, arg1, arg2, 0, 0, 0, 0, &res);
+	return res.a0;
+}
+
+static int psci_to_linux_errno(int errno)
+{
+	switch (errno) {
+	case PSCI_RET_SUCCESS:
+		return 0;
+	case PSCI_RET_NOT_SUPPORTED:
+		return -EOPNOTSUPP;
+	case PSCI_RET_INVALID_PARAMS:
+	case PSCI_RET_INVALID_ADDRESS:
+		return -EINVAL;
+	case PSCI_RET_DENIED:
+		return -EPERM;
+	};
+
+	return -EINVAL;
+}
+
+static u32 psci_get_version(void)
+{
+	return invoke_psci_fn(PSCI_0_2_FN_PSCI_VERSION, 0, 0, 0);
+}
+
+static int psci_cpu_suspend(u32 state, unsigned long entry_point)
+{
+	int err;
+	u32 fn;
+
+	fn = psci_function_id[PSCI_FN_CPU_SUSPEND];
+	err = invoke_psci_fn(fn, state, entry_point, 0);
+	return psci_to_linux_errno(err);
+}
+
+static int psci_cpu_off(u32 state)
+{
+	int err;
+	u32 fn;
+
+	fn = psci_function_id[PSCI_FN_CPU_OFF];
+	err = invoke_psci_fn(fn, state, 0, 0);
+	return psci_to_linux_errno(err);
+}
+
+static int psci_cpu_on(unsigned long cpuid, unsigned long entry_point)
+{
+	int err;
+	u32 fn;
+
+	fn = psci_function_id[PSCI_FN_CPU_ON];
+	err = invoke_psci_fn(fn, cpuid, entry_point, 0);
+	return psci_to_linux_errno(err);
+}
+
+static int psci_migrate(unsigned long cpuid)
+{
+	int err;
+	u32 fn;
+
+	fn = psci_function_id[PSCI_FN_MIGRATE];
+	err = invoke_psci_fn(fn, cpuid, 0, 0);
+	return psci_to_linux_errno(err);
+}
+
+static int psci_affinity_info(unsigned long target_affinity,
+		unsigned long lowest_affinity_level)
+{
+	return invoke_psci_fn(PSCI_FN_NATIVE(0_2, AFFINITY_INFO),
+			      target_affinity, lowest_affinity_level, 0);
+}
+
+static int psci_migrate_info_type(void)
+{
+	return invoke_psci_fn(PSCI_0_2_FN_MIGRATE_INFO_TYPE, 0, 0, 0);
+}
+
+static unsigned long psci_migrate_info_up_cpu(void)
+{
+	return invoke_psci_fn(PSCI_FN_NATIVE(0_2, MIGRATE_INFO_UP_CPU),
+			      0, 0, 0);
+}
+
+static void set_conduit(enum psci_conduit conduit)
+{
+	switch (conduit) {
+	case PSCI_CONDUIT_HVC:
+		invoke_psci_fn = __invoke_psci_fn_hvc;
+		break;
+	case PSCI_CONDUIT_SMC:
+		invoke_psci_fn = __invoke_psci_fn_smc;
+		break;
+	default:
+		WARN(1, "Unexpected PSCI conduit %d\n", conduit);
+	}
+
+	psci_ops.conduit = conduit;
+}
+
+static int get_set_conduit_method(struct device_node *np)
+{
+	const char *method;
+
+	pr_info("probing for conduit method from DT.\n");
+
+	if (of_property_read_string(np, "method", &method)) {
+		pr_warn("missing \"method\" property\n");
+		return -ENXIO;
+	}
+
+	if (!strcmp("hvc", method)) {
+		set_conduit(PSCI_CONDUIT_HVC);
+	} else if (!strcmp("smc", method)) {
+		set_conduit(PSCI_CONDUIT_SMC);
+	} else {
+		pr_warn("invalid \"method\" property: %s\n", method);
+		return -EINVAL;
+	}
+	return 0;
+}
+
+void psci_sys_reset(enum reboot_mode reboot_mode, const char *cmd)
+{
+	invoke_psci_fn(PSCI_0_2_FN_SYSTEM_RESET, 0, 0, 0);
+}
+EXPORT_SYMBOL(psci_sys_reset);
+
+void psci_sys_poweroff(void)
+{
+	invoke_psci_fn(PSCI_0_2_FN_SYSTEM_OFF, 0, 0, 0);
+}
+EXPORT_SYMBOL(psci_sys_poweroff);
+
+static int __init psci_features(u32 psci_func_id)
+{
+	return invoke_psci_fn(PSCI_1_0_FN_PSCI_FEATURES,
+			      psci_func_id, 0, 0);
+}
+
+#ifdef CONFIG_CPU_IDLE
+static DEFINE_PER_CPU_READ_MOSTLY(u32 *, psci_power_state);
+
+static int psci_dt_cpu_init_idle(struct device_node *cpu_node, int cpu)
+{
+	int i, ret, count = 0;
+	u32 *psci_states;
+	struct device_node *state_node;
+
+	/* Count idle states */
+	while ((state_node = of_parse_phandle(cpu_node, "cpu-idle-states",
+					      count))) {
+		count++;
+		of_node_put(state_node);
+	}
+
+	if (!count)
+		return -ENODEV;
+
+	psci_states = kcalloc(count, sizeof(*psci_states), GFP_KERNEL);
+	if (!psci_states)
+		return -ENOMEM;
+
+	for (i = 0; i < count; i++) {
+		u32 state;
+
+		state_node = of_parse_phandle(cpu_node, "cpu-idle-states", i);
+
+		ret = of_property_read_u32(state_node,
+					   "arm,psci-suspend-param",
+					   &state);
+		if (ret) {
+			pr_warn(" * %s missing arm,psci-suspend-param property\n",
+				state_node->full_name);
+			of_node_put(state_node);
+			goto free_mem;
+		}
+
+		of_node_put(state_node);
+		pr_debug("psci-power-state %#x index %d\n", state, i);
+		if (!psci_power_state_is_valid(state)) {
+			pr_warn("Invalid PSCI power state %#x\n", state);
+			ret = -EINVAL;
+			goto free_mem;
+		}
+		psci_states[i] = state;
+	}
+	/* Idle states parsed correctly, initialize per-cpu pointer */
+	per_cpu(psci_power_state, cpu) = psci_states;
+	return 0;
+
+free_mem:
+	kfree(psci_states);
+	return ret;
+}
+
+#ifdef CONFIG_ACPI
+#include <acpi/processor.h>
+
+static int __maybe_unused psci_acpi_cpu_init_idle(unsigned int cpu)
+{
+	int i, count;
+	u32 *psci_states;
+	struct acpi_lpi_state *lpi;
+	struct acpi_processor *pr = per_cpu(processors, cpu);
+
+	if (unlikely(!pr || !pr->flags.has_lpi))
+		return -EINVAL;
+
+	count = pr->power.count - 1;
+	if (count <= 0)
+		return -ENODEV;
+
+	psci_states = kcalloc(count, sizeof(*psci_states), GFP_KERNEL);
+	if (!psci_states)
+		return -ENOMEM;
+
+	for (i = 0; i < count; i++) {
+		u32 state;
+
+		lpi = &pr->power.lpi_states[i + 1];
+		/*
+		 * Only bits[31:0] represent a PSCI power_state while
+		 * bits[63:32] must be 0x0 as per ARM ACPI FFH Specification
+		 */
+		state = lpi->address;
+		if (!psci_power_state_is_valid(state)) {
+			pr_warn("Invalid PSCI power state %#x\n", state);
+			kfree(psci_states);
+			return -EINVAL;
+		}
+		psci_states[i] = state;
+	}
+	/* Idle states parsed correctly, initialize per-cpu pointer */
+	per_cpu(psci_power_state, cpu) = psci_states;
+	return 0;
+}
+#else
+static int __maybe_unused psci_acpi_cpu_init_idle(unsigned int cpu)
+{
+	return -EINVAL;
+}
+#endif
+
+int psci_cpu_init_idle(unsigned int cpu)
+{
+	struct device_node *cpu_node;
+	int ret;
+
+	/*
+	 * If the PSCI cpu_suspend function hook has not been initialized
+	 * idle states must not be enabled, so bail out
+	 */
+	if (!psci_ops.cpu_suspend)
+		return -EOPNOTSUPP;
+
+	if (!acpi_disabled)
+		return psci_acpi_cpu_init_idle(cpu);
+
+	cpu_node = of_get_cpu_node(cpu, NULL);
+	if (!cpu_node)
+		return -ENODEV;
+
+	ret = psci_dt_cpu_init_idle(cpu_node, cpu);
+
+	of_node_put(cpu_node);
+
+	return ret;
+}
+
+static int psci_suspend_finisher(unsigned long index)
+{
+	u32 *state = __this_cpu_read(psci_power_state);
+
+	return psci_ops.cpu_suspend(state[index - 1],
+				    virt_to_phys(cpu_resume));
+}
+
+int psci_cpu_suspend_enter(unsigned long index)
+{
+	int ret;
+	u32 *state = __this_cpu_read(psci_power_state);
+	/*
+	 * idle state index 0 corresponds to wfi, should never be called
+	 * from the cpu_suspend operations
+	 */
+	if (WARN_ON_ONCE(!index))
+		return -EINVAL;
+
+	if (!psci_power_state_loses_context(state[index - 1]))
+		ret = psci_ops.cpu_suspend(state[index - 1], 0);
+	else
+		ret = cpu_suspend(index, psci_suspend_finisher);
+
+	return ret;
+}
+
+/* ARM specific CPU idle operations */
+#ifdef CONFIG_ARM
+static const struct cpuidle_ops psci_cpuidle_ops __initconst = {
+	.suspend = psci_cpu_suspend_enter,
+	.init = psci_dt_cpu_init_idle,
+};
+
+CPUIDLE_METHOD_OF_DECLARE(psci, "psci", &psci_cpuidle_ops);
+#endif
+#endif
+
+int psci_system_suspend(unsigned long wakeup_source)
+{
+	return invoke_psci_fn(PSCI_FN_NATIVE(1_0, SYSTEM_SUSPEND),
+			      virt_to_phys(cpu_resume), wakeup_source, 0);
+}
+EXPORT_SYMBOL(psci_system_suspend);
+
+static int psci_system_suspend_enter(suspend_state_t state)
+{
+	return cpu_suspend(0, psci_system_suspend);
+}
+
+static void __init psci_init_system_suspend(void)
+{
+	int ret;
+
+	if (!IS_ENABLED(CONFIG_SUSPEND))
+		return;
+
+	ret = psci_features(PSCI_FN_NATIVE(1_0, SYSTEM_SUSPEND));
+}
+
+static void __init psci_init_cpu_suspend(void)
+{
+	int feature = psci_features(psci_function_id[PSCI_FN_CPU_SUSPEND]);
+
+	if (feature != PSCI_RET_NOT_SUPPORTED)
+		psci_cpu_suspend_feature = feature;
+}
+
+/*
+ * Detect the presence of a resident Trusted OS which may cause CPU_OFF to
+ * return DENIED (which would be fatal).
+ */
+static void __init psci_init_migrate(void)
+{
+	unsigned long cpuid;
+	int type, cpu = -1;
+
+	type = psci_ops.migrate_info_type();
+
+	if (type == PSCI_0_2_TOS_MP) {
+		pr_info("Trusted OS migration not required\n");
+		return;
+	}
+
+	if (type == PSCI_RET_NOT_SUPPORTED) {
+		pr_info("MIGRATE_INFO_TYPE not supported.\n");
+		return;
+	}
+
+	if (type != PSCI_0_2_TOS_UP_MIGRATE &&
+	    type != PSCI_0_2_TOS_UP_NO_MIGRATE) {
+		pr_err("MIGRATE_INFO_TYPE returned unknown type (%d)\n", type);
+		return;
+	}
+
+	cpuid = psci_migrate_info_up_cpu();
+	if (cpuid & ~MPIDR_HWID_BITMASK) {
+		pr_warn("MIGRATE_INFO_UP_CPU reported invalid physical ID (0x%lx)\n",
+			cpuid);
+		return;
+	}
+
+	cpu = get_logical_index(cpuid);
+	resident_cpu = cpu >= 0 ? cpu : -1;
+
+	pr_info("Trusted OS resident on physical CPU 0x%lx\n", cpuid);
+}
+
+static void __init psci_init_smccc(void)
+{
+	u32 ver = ARM_SMCCC_VERSION_1_0;
+	int feature;
+
+	feature = psci_features(ARM_SMCCC_VERSION_FUNC_ID);
+
+	if (feature != PSCI_RET_NOT_SUPPORTED) {
+		u32 ret;
+		ret = invoke_psci_fn(ARM_SMCCC_VERSION_FUNC_ID, 0, 0, 0);
+		if (ret == ARM_SMCCC_VERSION_1_1) {
+			psci_ops.smccc_version = SMCCC_VERSION_1_1;
+			ver = ret;
+		}
+	}
+
+	/*
+	 * Conveniently, the SMCCC and PSCI versions are encoded the
+	 * same way. No, this isn't accidental.
+	 */
+	pr_info("SMC Calling Convention v%d.%d\n",
+		PSCI_VERSION_MAJOR(ver), PSCI_VERSION_MINOR(ver));
+
+}
+
+static void __init psci_0_2_set_functions(void)
+{
+	pr_info("Using standard PSCI v0.2 function IDs\n");
+	psci_ops.get_version = psci_get_version;
+
+	psci_function_id[PSCI_FN_CPU_SUSPEND] =
+					PSCI_FN_NATIVE(0_2, CPU_SUSPEND);
+	psci_ops.cpu_suspend = psci_cpu_suspend;
+
+	psci_function_id[PSCI_FN_CPU_OFF] = PSCI_0_2_FN_CPU_OFF;
+	psci_ops.cpu_off = psci_cpu_off;
+
+	psci_function_id[PSCI_FN_CPU_ON] = PSCI_FN_NATIVE(0_2, CPU_ON);
+	psci_ops.cpu_on = psci_cpu_on;
+
+	psci_function_id[PSCI_FN_MIGRATE] = PSCI_FN_NATIVE(0_2, MIGRATE);
+	psci_ops.migrate = psci_migrate;
+
+	psci_ops.affinity_info = psci_affinity_info;
+
+	psci_ops.migrate_info_type = psci_migrate_info_type;
+
+	arm_pm_restart = psci_sys_reset;
+
+	pm_power_off = psci_sys_poweroff;
+}
+
+/*
+ * Probe function for PSCI firmware versions >= 0.2
+ */
+static int __init psci_probe(void)
+{
+	u32 ver = psci_get_version();
+
+	pr_info("PSCIv%d.%d detected in firmware.\n",
+			PSCI_VERSION_MAJOR(ver),
+			PSCI_VERSION_MINOR(ver));
+
+	if (PSCI_VERSION_MAJOR(ver) == 0 && PSCI_VERSION_MINOR(ver) < 2) {
+		pr_err("Conflicting PSCI version detected.\n");
+		return -EINVAL;
+	}
+
+	psci_0_2_set_functions();
+
+	psci_init_migrate();
+
+	if (PSCI_VERSION_MAJOR(ver) >= 1) {
+		psci_init_smccc();
+		psci_init_cpu_suspend();
+		psci_init_system_suspend();
+	}
+
+	return 0;
+}
+
+typedef int (*psci_initcall_t)(const struct device_node *);
+
+/*
+ * PSCI init function for PSCI versions >=0.2
+ *
+ * Probe based on PSCI PSCI_VERSION function
+ */
+static int __init psci_0_2_init(struct device_node *np)
+{
+	int err;
+
+	err = get_set_conduit_method(np);
+
+	if (err)
+		goto out_put_node;
+	/*
+	 * Starting with v0.2, the PSCI specification introduced a call
+	 * (PSCI_VERSION) that allows probing the firmware version, so
+	 * that PSCI function IDs and version specific initialization
+	 * can be carried out according to the specific version reported
+	 * by firmware
+	 */
+	err = psci_probe();
+
+out_put_node:
+	of_node_put(np);
+	return err;
+}
+
+/*
+ * PSCI < v0.2 get PSCI Function IDs via DT.
+ */
+static int __init psci_0_1_init(struct device_node *np)
+{
+	u32 id;
+	int err;
+
+	err = get_set_conduit_method(np);
+
+	if (err)
+		goto out_put_node;
+
+	pr_info("Using PSCI v0.1 Function IDs from DT\n");
+
+	if (!of_property_read_u32(np, "cpu_suspend", &id)) {
+		psci_function_id[PSCI_FN_CPU_SUSPEND] = id;
+		psci_ops.cpu_suspend = psci_cpu_suspend;
+	}
+
+	if (!of_property_read_u32(np, "cpu_off", &id)) {
+		psci_function_id[PSCI_FN_CPU_OFF] = id;
+		psci_ops.cpu_off = psci_cpu_off;
+	}
+
+	if (!of_property_read_u32(np, "cpu_on", &id)) {
+		psci_function_id[PSCI_FN_CPU_ON] = id;
+		psci_ops.cpu_on = psci_cpu_on;
+	}
+
+	if (!of_property_read_u32(np, "migrate", &id)) {
+		psci_function_id[PSCI_FN_MIGRATE] = id;
+		psci_ops.migrate = psci_migrate;
+	}
+
+out_put_node:
+	of_node_put(np);
+	return err;
+}
+
+static const struct of_device_id psci_of_match[] __initconst = {
+	{ .compatible = "arm,psci",	.data = psci_0_1_init},
+	{ .compatible = "arm,psci-0.2",	.data = psci_0_2_init},
+	{ .compatible = "arm,psci-1.0",	.data = psci_0_2_init},
+	{},
+};
+
+int __init psci_dt_init(void)
+{
+	struct device_node *np;
+	const struct of_device_id *matched_np;
+	psci_initcall_t init_fn;
+
+	np = of_find_matching_node_and_match(NULL, psci_of_match, &matched_np);
+
+	if (!np)
+		return -ENODEV;
+
+	init_fn = (psci_initcall_t)matched_np->data;
+	return init_fn(np);
+}
+
+#ifdef CONFIG_ACPI
+/*
+ * We use PSCI 0.2+ when ACPI is deployed on ARM64 and it's
+ * explicitly clarified in SBBR
+ */
+int __init psci_acpi_init(void)
+{
+	if (!acpi_psci_present()) {
+		pr_info("is not implemented in ACPI.\n");
+		return -EOPNOTSUPP;
+	}
+
+	pr_info("probing for conduit method from ACPI.\n");
+
+	if (acpi_psci_use_hvc())
+		set_conduit(PSCI_CONDUIT_HVC);
+	else
+		set_conduit(PSCI_CONDUIT_SMC);
+
+	return psci_probe();
+}
+#endif
diff --git a/drivers/soc/realtek/rtd16xx/rtd16xx_spin_table.c b/drivers/soc/realtek/rtd16xx/rtd16xx_spin_table.c
new file mode 100755
index 00000000..8503f26
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtd16xx_spin_table.c
@@ -0,0 +1,180 @@
+/*
+ * rtd16xx_spin_table.c - boot method
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * Author: Chih-Feng Tai <james.tai@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/delay.h>
+#include <linux/init.h>
+#include <linux/of.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/of_address.h>
+#include <linux/of_platform.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/delay.h>
+#include <linux/printk.h>
+#include <linux/arm-smccc.h>
+#include <asm/io.h>
+#include <asm/cacheflush.h>
+#include <asm/cpu_ops.h>
+#include <asm/cputype.h>
+#include <asm/io.h>
+#include <asm/smp_plat.h>
+
+#include "rtd16xx_cpu_hotplug.h"
+
+#define BL31_CMD 0x8400ff04
+#define BL31_DAT 0x00001619
+#define CPUID 28
+
+#ifdef CONFIG_SMP
+
+extern void _rtk_cpu_power_up(int cpu);
+extern void secondary_holding_pen(void);
+
+volatile unsigned long rtk_secondary_holding_pen_release = INVALID_HWID;
+
+static phys_addr_t cpu_release_addr[NR_CPUS];
+static int cpu_hotplug[NR_CPUS] = {0};
+/*
+ * Write rtk_secondary_holding_pen_release in a way that is guaranteed to be
+ * visible to all observers, irrespective of whether they're taking part
+ * in coherency or not.  This is necessary for the hotplug code to work
+ * reliably.
+ */
+static void write_pen_release(u64 val)
+{
+	void *start = (void *)&rtk_secondary_holding_pen_release;
+	unsigned long size = sizeof(rtk_secondary_holding_pen_release);
+
+	rtk_secondary_holding_pen_release = val;
+	__flush_dcache_area(start, size);
+}
+
+static int smp_spin_table_cpu_init(unsigned int cpu)
+{
+
+	struct device_node *dn;
+
+	dn = of_get_cpu_node(cpu, NULL);
+	if (!dn)
+		return -ENODEV;
+
+	/*
+	 * Determine the address from which the CPU is polling.
+	 */
+
+	if(of_property_read_u64(dn, "cpu-release-addr", &cpu_release_addr[cpu])){
+		pr_err("CPU %d: missing or invalid cpu-release-addr property\n", cpu);
+		return -1;
+	}
+
+	return 0;
+}
+
+static int smp_spin_table_cpu_prepare(unsigned int cpu)
+{
+	__le64 __iomem *release_addr;
+
+	/*
+	 * The cpu-release-addr may or may not be inside the linear mapping.
+	 * As ioremap_cache will either give us a new mapping or reuse the
+	 * existing linear mapping, we can use it to cover both cases. In
+	 * either case the memory will be MT_NORMAL.
+	 */
+
+	release_addr = ioremap(cpu_release_addr[cpu], sizeof(*release_addr));
+
+	if (!release_addr)
+		return -ENOMEM;
+
+	/*
+	 * We write the release address as LE regardless of the native
+	 * endianess of the kernel. Therefore, any boot-loaders that
+	 * read this address need to convert this address to the
+	 * boot-loader's endianess before jumping. This is mandated by
+	 * the boot protocol.
+	 */
+	writel_relaxed(__pa(secondary_holding_pen)|(cpu << CPUID), release_addr);
+
+	__flush_dcache_area((__force void *)release_addr, sizeof(*release_addr));
+
+	/*
+	 * Send an event to wake up the secondary CPU.
+	 */
+	sev();
+
+	iounmap(release_addr);
+
+	return 0;
+}
+
+static int smp_spin_table_cpu_boot(unsigned int cpu)
+{
+	if(cpu_hotplug[cpu] == 1){
+		__le64 __iomem *release_addr;
+		release_addr = ioremap(cpu_release_addr[cpu], sizeof(*release_addr));
+		writel_relaxed(__pa(secondary_holding_pen)|(cpu << CPUID), release_addr);
+
+		__flush_dcache_area((__force void *)release_addr, sizeof(*release_addr));
+
+		smp_send_reschedule(cpu);
+		iounmap(release_addr);
+	}
+
+	/*
+	 * Update the pen release flag.
+	 */
+	write_pen_release(cpu_logical_map(cpu));
+
+	/*
+	 * Send an event, causing the secondaries to read pen_release.
+	 */
+
+	sev();
+	return 0;
+}
+
+#ifdef CONFIG_HOTPLUG_CPU
+static int smp_spin_table_cpu_disable(unsigned int cpu)
+{
+	if (!cpu_release_addr[cpu])
+		return -EOPNOTSUPP;
+
+	return 0;
+}
+
+static void smp_spin_table_cpu_die(unsigned int cpu)
+{
+	struct arm_smccc_res res;
+
+	/* notify BL31 cpu hotplug */
+	arm_smccc_smc(BL31_CMD, BL31_DAT, 0, 0, 0, 0, 0, 0, &res);
+	cpu_hotplug[cpu] = 1;
+	cpu_do_lowpower(cpu_release_addr[cpu]);
+}
+#endif
+
+const struct cpu_operations rtk_smp_spin_table_ops = {
+	.name = "rtk-spin-table",
+	.cpu_init = smp_spin_table_cpu_init,
+	.cpu_prepare = smp_spin_table_cpu_prepare,
+	.cpu_boot = smp_spin_table_cpu_boot,
+#ifdef CONFIG_HOTPLUG_CPU
+	.cpu_disable = smp_spin_table_cpu_disable,
+	.cpu_die = smp_spin_table_cpu_die,
+#endif
+};
+
+#endif /* CONFIG_SMP */
diff --git a/drivers/soc/realtek/rtd16xx/rtd16xx_suspend.c b/drivers/soc/realtek/rtd16xx/rtd16xx_suspend.c
new file mode 100644
index 00000000..cc8f448
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtd16xx_suspend.c
@@ -0,0 +1,488 @@
+/*
+ * rtd16xx_suspend.c - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/pm.h>
+#include <linux/suspend.h>
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/cpu.h>
+#include <linux/delay.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/reboot.h>
+#include <linux/clocksource.h>
+#include <linux/clockchips.h>
+#include <linux/cpu_pm.h>
+#include <linux/vmalloc.h>
+#include <linux/tick.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/irqchip/arm-gic.h>
+#include <linux/psci.h>
+#include <linux/cpumask.h>
+#include <asm/system_misc.h>
+#include <asm/cacheflush.h>
+#include <asm/suspend.h>
+#include <soc/realtek/memory.h>
+#include <uapi/linux/psci.h>
+#include <soc/realtek/rtk_rstctl.h>
+
+#include "rtd16xx_suspend.h"
+
+#define DEV "RTD16xx_PM"
+#define SUSPEND_VERSION_MASK(v) ((v&0xffff) << 16)
+#define RTK_PM_DEBUG 1
+#define RTK_DDR_CALIBRATION 0
+
+unsigned int wakeup_source = 0;
+
+static int suspend_version = 2;
+extern unsigned int suspend_context;
+
+void __iomem *RTK_CRT_BASE;
+void __iomem *RTK_ISO_BASE;
+void __iomem *RTK_SB2_BASE;
+void __iomem *RTK_RSTCTRL_BASE;
+
+extern void rtk_cpu_power_up_all(void);
+extern void rtk_cpu_power_down(int cpu);
+extern void rtk_cpu_power_up(int cpu);
+extern void rtk_ddr_calibration_save(void); /* save ddr rx calibration */
+extern void rtk_ddr_calibration_restore(void); /* restore ddr rx calibration */
+extern void psci_sys_reset(enum reboot_mode reboot_mode, const char *cmd);
+extern void psci_sys_poweroff(void);
+extern int psci_system_suspend(unsigned long wakeup_source);
+extern void memory_check_begin(void);
+extern void memory_check_end(void);
+extern void hexdump(char *note, unsigned char *buf, unsigned int len);
+#ifdef CONFIG_RTK_WATCHDOG
+extern int set_wdt_oe(void);
+#else
+static inline int set_wdt_oe(void) { return 0; }
+#endif
+
+struct suspend_param *pcpu_data;
+struct ipc_shm_irda pcpu_data_irda;
+
+extern char wu_en[SUSPEND_ISO_GPIO_SIZE];
+extern char wu_act[SUSPEND_ISO_GPIO_SIZE];
+#ifdef CONFIG_RTK_RPC
+static unsigned int rtk_acpu_check_rpc_flag(void);
+
+static unsigned int rtk_acpu_check_rpc_flag(void)
+{
+	unsigned int i = 0;
+	unsigned int ret = 0;
+
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	for (i = 0 ; i < 1000; i++) {
+		if (readl(&(ipc->audio_rpc_flag)) == 0) {
+			ret = 1;
+			break;
+		}
+		mdelay(1);
+	}
+
+	return ret;
+}
+#endif
+
+static void rtk_acpu_set_flag(uint32_t flag)
+{
+#ifdef CONFIG_RTK_RPC
+	struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+
+	writel(__cpu_to_be32(SUSPEND_VERSION_MASK(suspend_version)),
+		&(ipc->suspend_mask));
+
+	if (suspend_version == 1)
+		writel(__cpu_to_be32(flag), &(ipc->suspend_flag));
+	else
+		writel(__cpu_to_be32(flag | AUTHOR_MASK(AUTHOR_SCPU)),
+			&(ipc->suspend_flag));
+#endif
+}
+
+static void rtk_notify_acpu(enum _notify_flag flag)
+{
+#ifdef CONFIG_RTK_RPC
+	pr_info("[%s] Notify ACPU, flag= %d\n", DEV, flag);
+
+	switch (flag) {
+	case NOTIFY_SUSPEND_TO_RAM:
+	case NOTIFY_SUSPEND_TO_COOLBOOT:
+	case NOTIFY_SUSPEND_TO_WFI:
+		if (suspend_version == 1) {
+			rtk_acpu_set_flag(0x000018ff);
+			return;
+		}
+		break;
+	case NOTIFY_RESUME_PLATFORM:
+		if (suspend_version == 1) {
+			rtk_acpu_set_flag(0x00000000);
+			return;
+		}
+		break;
+	default:
+		if (suspend_version == 1)
+			return;
+		break;
+	}
+
+	rtk_acpu_set_flag(NOTIFY_MASK(flag));
+#endif
+}
+
+static int rtk_suspend_wakeup_acpu(void)
+{
+	pr_info("[%s] Wakeup ACPU\n", DEV);
+
+	writel(0x00000000, RTK_SB2_BASE + 0x138);
+	__delay(1000);
+	writel(0x00000008, RTK_CRT_BASE + 0x328);
+	writel(0x0000ace7, RTK_CRT_BASE + 0x320);
+	writel(0x0000000c, RTK_CRT_BASE + 0x328);
+	__delay(1000);
+
+	return 0;
+}
+
+static void setup_restart_action(RESET_ACTION action)
+{
+	unsigned int reset_action = RESET_MAGIC;
+
+	if (!RTK_RSTCTRL_BASE) {
+		pr_err("%s: Skip set reset action\n", __func__);
+		return;
+	}
+
+	reset_action |= action;
+	writel(reset_action, RTK_RSTCTRL_BASE);
+}
+
+static void rtk_sys_reset(enum reboot_mode reboot_mode, const char *cmd)
+{
+	if (cmd) {
+		if (!strncmp("bootloader", cmd, 11)) {
+			set_wdt_oe();
+			setup_restart_action(RESET_ACTION_FASTBOOT);
+		} else if (!strncmp("recovery", cmd, 9)) {
+			set_wdt_oe();
+			setup_restart_action(RESET_ACTION_RECOVERY);
+		} else {
+			setup_restart_action(RESET_ACTION_NO_ACTION);
+		}
+	} else {
+		setup_restart_action(RESET_ACTION_NO_ACTION);
+	}
+
+	pr_info("[%s] Power reset\n", DEV);
+#if defined(CONFIG_THOR_PM_WORKARURD)
+	writel(0xA5, RTK_ISO_BASE + 0x680);
+	writel(0x01, RTK_ISO_BASE + 0x684);
+	writel(0x100, RTK_ISO_BASE + 0x68C);
+	writel(0xFF, RTK_ISO_BASE + 0x680);
+#else
+	rtk_notify_acpu(NOTIFY_SUSPEND_TO_COOLBOOT);
+	psci_sys_reset(reboot_mode, cmd);
+#endif /* CONFIG_THOR_PM_WORKARURD */
+};
+
+static void rtk_set_pm_param(unsigned long pcpu_data)
+{
+#if defined(CONFIG_CPU_V7)
+	asm volatile(".arch_extension sec" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("mov r1, %0" : : "r" (__pa(pcpu_data)) : "cc");
+	asm volatile("ldr r0, =0x8400ff04" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+#else
+	asm volatile("isb" : : : "cc");
+	asm volatile("mov x1, %0" : : "r" (__pa(pcpu_data)) : "cc");
+	asm volatile("ldr x0, =0x8400ff04" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+#endif /* CONFIG_CPU_V7 */
+}
+
+static void rtk_power_off(void)
+{
+	int i = 0;
+
+	pr_info("[%s] Power off\n", DEV);
+
+	rtk_notify_acpu(NOTIFY_SUSPEND_TO_COOLBOOT);
+
+	pcpu_data->wakeup_source = htonl(pcpu_data->wakeup_source);
+	pcpu_data->timerout_val = htonl(pcpu_data->timerout_val);
+	pcpu_data->irda_info.dev_count = pcpu_data_irda.dev_count;
+	pcpu_data->irda_info.ipc_shm_ir_magic = pcpu_data_irda.ipc_shm_ir_magic;
+
+	for (i = 0 ; i< 5; i++) {
+		pcpu_data->irda_info.key_tbl[i].protocol = pcpu_data_irda.key_tbl[i].protocol;
+		pcpu_data->irda_info.key_tbl[i].scancode_mask = pcpu_data_irda.key_tbl[i].scancode_mask;
+		pcpu_data->irda_info.key_tbl[i].wakeup_scancode = pcpu_data_irda.key_tbl[i].wakeup_scancode;
+		pcpu_data->irda_info.key_tbl[i].cus_mask = pcpu_data_irda.key_tbl[i].cus_mask;
+		pcpu_data->irda_info.key_tbl[i].cus_code = pcpu_data_irda.key_tbl[i].cus_code;
+	}
+
+	pr_info("[%s] wakeup flags = 0x%x\n", DEV, pcpu_data->wakeup_source);
+
+	flush_cache_all();
+
+	rtk_set_pm_param((unsigned long) pcpu_data);
+
+	psci_sys_poweroff();
+};
+
+static int rtk_suspend_standby(unsigned long unused)
+{
+	/*
+	 * Todo:
+	 * define PSCI command: S1 mode
+	 */
+	return 0;
+}
+
+static int rtk_suspend_mem(unsigned long pcpu_data)
+{
+
+#if RTK_PM_DEBUG
+
+	struct suspend_param *tmp = (struct suspend_param *) pcpu_data;
+
+	pr_info("wakeup flags = 0x%x\n", tmp->wakeup_source);
+
+	pr_info("[%s] pcpu_data vaddr: 0x%08lx paddr: 0x%08lx\n",
+		DEV, (unsigned long)pcpu_data,
+		(unsigned long)__pa(pcpu_data));
+
+	hexdump("pcpu_data Dump:",
+		(unsigned char *) pcpu_data, sizeof(struct suspend_param));
+
+	pr_info("[%s] CPU Resume vaddr: 0x%08lx paddr: 0x%08lx\n",
+		DEV, (unsigned long)cpu_resume,
+		(unsigned long)__pa(cpu_resume));
+
+	hexdump("CPU Resume Entry Dump:",
+		(unsigned char *) cpu_resume, 0x100);
+
+#endif /* RTK_PM_DEBUG */
+
+	flush_cache_all();
+
+	return psci_system_suspend(__pa(pcpu_data));
+}
+
+static void rtk_suspend_cpu_pwr_down(void) {
+	unsigned int cpu = 1;
+
+	for (cpu = 1 ; cpu < NR_CPUS ; cpu++) {
+		rtk_cpu_power_down(cpu);
+	}
+}
+
+static void rtk_suspend_cpu_pwr_up(void) {
+	unsigned int cpu = 1;
+
+	for (cpu = 1 ; cpu < NR_CPUS ; cpu++)
+		rtk_cpu_power_up(cpu);
+}
+
+static int rtk_suspend_enter(suspend_state_t state)
+{
+	int ret = 0;
+	int i = 0;
+
+	rtk_suspend_cpu_pwr_down();
+
+	switch (state) {
+	case PM_SUSPEND_STANDBY:
+		rtk_notify_acpu(NOTIFY_SUSPEND_TO_WFI);
+		cpu_suspend(0, rtk_suspend_standby);
+		break;
+	case PM_SUSPEND_MEM:
+		rtk_notify_acpu(NOTIFY_SUSPEND_TO_RAM);
+#ifdef CONFIG_RTK_RPC
+		if (!rtk_acpu_check_rpc_flag()) {
+			pr_err("[%s] ACPU FW not ready to suspend !\n", DEV);
+			ret = -EINVAL;
+			break;
+		}
+#endif
+		pcpu_data->wakeup_source = htonl(pcpu_data->wakeup_source);
+		pcpu_data->timerout_val = htonl(pcpu_data->timerout_val);
+		pcpu_data->irda_info.dev_count = pcpu_data_irda.dev_count;
+		pcpu_data->irda_info.ipc_shm_ir_magic = pcpu_data_irda.ipc_shm_ir_magic;
+
+		for (i = 0 ; i< 5; i++) {
+			pcpu_data->irda_info.key_tbl[i].protocol = pcpu_data_irda.key_tbl[i].protocol;
+			pcpu_data->irda_info.key_tbl[i].scancode_mask = pcpu_data_irda.key_tbl[i].scancode_mask;
+			pcpu_data->irda_info.key_tbl[i].wakeup_scancode = pcpu_data_irda.key_tbl[i].wakeup_scancode;
+			pcpu_data->irda_info.key_tbl[i].cus_mask = pcpu_data_irda.key_tbl[i].cus_mask;
+			pcpu_data->irda_info.key_tbl[i].cus_code = pcpu_data_irda.key_tbl[i].cus_code;
+		}
+
+		pr_info("[%s] wakeup flags = 0x%x\n", DEV, pcpu_data->wakeup_source);
+		cpu_suspend((unsigned long) pcpu_data, rtk_suspend_mem);
+		break;
+	default:
+		ret = -EINVAL;
+		break;
+	}
+
+	rtk_cpu_power_up_all();
+
+	/* restore original value */
+	pcpu_data->wakeup_source = htonl(pcpu_data->wakeup_source);
+	pcpu_data->timerout_val = htonl(pcpu_data->timerout_val);
+
+#if RTK_PM_DEBUG
+	memory_check_end();
+#endif /* RTK_PM_DEBUG */
+
+#if RTK_DDR_CALIBRATION
+	rtk_ddr_calibration_restore();
+#endif /* RTK_DDR_CALIBRATION */
+#ifdef CONFIG_RTK_RPC
+	/* Enable ACPU clock*/
+	writel_relaxed(readl(RTK_CRT_BASE + 0x58) | 0x000000C0, RTK_CRT_BASE + 0x58);
+#endif
+	writel_relaxed(readl(RTK_ISO_BASE + 0x0418) | BIT(0), RTK_ISO_BASE + 0x0418);
+	writel_relaxed(readl(RTK_ISO_BASE + 0x0410) & ~BIT(10), RTK_ISO_BASE + 0x0410);
+
+	writel_relaxed(0x0000aaaa, RTK_CRT_BASE + 0xc);
+
+	return ret;
+}
+
+static int rtk_suspend_valid(suspend_state_t state)
+{
+	return state == PM_SUSPEND_MEM || state == PM_SUSPEND_STANDBY;
+}
+
+static int rtk_suspend_begin(suspend_state_t suspend_state)
+{
+	int ret = 0;
+	int i = 0;
+
+	pr_info("[%s] Suspend Begin\n", DEV);
+
+	for(i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++){
+		pcpu_data->wu_gpio_en[i] = wu_en[i];
+		pcpu_data->wu_gpio_act[i] = wu_act[i];
+	}
+
+#if RTK_PM_DEBUG
+	memory_check_begin();
+#endif /* RTK_PM_DEBUG */
+
+#if RTK_DDR_CALIBRATION
+	rtk_ddr_calibration_save();
+#endif /* RTK_DDR_CALIBRATION */
+
+	cpu_idle_poll_ctrl(true);
+
+	return ret;
+}
+
+static void rtk_suspend_wake(void)
+{
+	pr_info("[%s] Platform Wake\n", DEV);
+
+	rtk_suspend_wakeup_acpu();
+
+	suspend_context++;
+
+	rtk_notify_acpu(NOTIFY_RESUME_PLATFORM);
+}
+
+static void rtk_suspend_end(void)
+{
+	pr_info("[%s] Suspend End\n", DEV);
+
+	rtk_notify_acpu(NOTIFY_RESUME_END);
+
+	cpu_idle_poll_ctrl(false);
+}
+
+const struct platform_suspend_ops rtk_suspend_ops = {
+	.begin = rtk_suspend_begin,
+	.end = rtk_suspend_end,
+	.enter = rtk_suspend_enter,
+	.valid = rtk_suspend_valid,
+	.wake = rtk_suspend_wake,
+};
+
+int __init rtk_suspend_init(void)
+{
+	struct device_node *pm_nd = NULL;
+	struct device_node *rstctl_nd = NULL;
+	const u32 *prop;
+	int size;
+	int i = 0;
+
+	pr_info("[%s] Initial Power Management\n", DEV);
+
+	pcpu_data = kzalloc(sizeof(struct suspend_param), GFP_KERNEL);
+
+	for(i = 0 ; i < SUSPEND_ISO_GPIO_SIZE ; i++){
+		pcpu_data->wu_gpio_en[i] = wu_en[i];
+		pcpu_data->wu_gpio_act[i] = wu_act[i];
+	}
+
+	pm_nd = of_find_compatible_node(NULL, NULL, "realtek,pm");
+
+	RTK_CRT_BASE = of_iomap(pm_nd, 0);
+	RTK_ISO_BASE = of_iomap(pm_nd, 1);
+	RTK_SB2_BASE = of_iomap(pm_nd, 2);
+
+	if (pm_nd && of_device_is_available(pm_nd)) {
+		/* Wakeup Flags */
+		prop = of_get_property(pm_nd, "wakeup-flags", &size);
+		wakeup_source = of_read_number(prop, 1);
+		if (wakeup_source < 0) {
+			pr_err("[%s] wakeup flags set default value!\n", DEV);
+			pcpu_data->wakeup_source = fWAKEUP_ON_IR |
+					fWAKEUP_ON_GPIO | fWAKEUP_ON_ALARM |
+					fWAKEUP_ON_CEC;
+		} else {
+			pcpu_data->wakeup_source = wakeup_source;
+		}
+
+		pr_info("[%s] wakeup flags = 0x%x\n", DEV, pcpu_data->wakeup_source);
+	}
+
+	rtk_acpu_set_flag(0x00000000);
+	suspend_set_ops(&rtk_suspend_ops);
+	pm_power_off = rtk_power_off;
+	arm_pm_restart = rtk_sys_reset;
+
+	/* setup Reset Control */
+	rstctl_nd = of_find_compatible_node(NULL, NULL, "Realtek,rtk-rstctrl");
+	if (rstctl_nd) {
+		RTK_RSTCTRL_BASE = of_iomap(rstctl_nd, 0);
+		pr_info("[rstctrl] addr 0x%p\n", RTK_RSTCTRL_BASE);
+		setup_restart_action(RESET_ACTION_ABNORMAL);
+	}
+
+	return 0;
+}
+
+subsys_initcall(rtk_suspend_init);
diff --git a/drivers/soc/realtek/rtd16xx/rtd16xx_suspend.h b/drivers/soc/realtek/rtd16xx/rtd16xx_suspend.h
new file mode 100644
index 00000000..ded1955
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtd16xx_suspend.h
@@ -0,0 +1,134 @@
+/*
+ * rtd16xx_suspend.h - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef RTD16XX_SUSPEND_H_
+#define RTD16XX_SUSPEND_H_
+
+#include <soc/realtek/rtk_ipc_shm.h>
+#include <soc/realtek/rtk_pm.h>
+#include <soc/realtek/rtk_ir.h>
+
+#define SETMASK(bits, pos) (((-1U) >> (32-bits)) << (pos))
+#define CLRMASK(bits, pos) (~(SETMASK(bits, pos)))
+#define SET_VAL(val,bits,pos) ((val << pos) & SETMASK(bits, pos))
+#define GET_VAL(reg,bits,pos) ((reg & SETMASK(bits, pos)) >> pos)
+
+#define AUTHOR_SHIFFT 30
+#define AUTHOR_BITS 2
+#define AUTHOR_MASK(val) SET_VAL(val,AUTHOR_BITS,AUTHOR_SHIFFT)
+#define AUTHOR_GET(reg) GET_VAL(reg,AUTHOR_BITS,AUTHOR_SHIFFT)
+#define AUTHOR_IS_SCPU(reg) (AUTHOR_GET(reg) == AUTHOR_SCPU)
+#define AUTHOR_IS_ACPU(reg) (AUTHOR_GET(reg) == AUTHOR_ACPU)
+
+#define NOTIFY_SHIFFT 0
+#define NOTIFY_BITS 8
+#define NOTIFY_MASK(val) SET_VAL(val,NOTIFY_BITS,NOTIFY_SHIFFT)
+#define NOTIFY_GET(reg) GET_VAL(reg,NOTIFY_BITS,NOTIFY_SHIFFT)
+
+#define SUSPEND_ISO_GPIO_BASE 0
+#define SUSPEND_ISO_GPIO_SIZE 86
+
+#define SUSPEND_MAGIC_KEY 0xEA
+#define SUSPEND_MAGIC_SHIFFT 24
+#define SUSPEND_MAGIC_BITS 8
+#define SUSPEND_MAGIC_MASK (SUSPEND_MAGIC_KEY << SUSPEND_MAGIC_SHIFFT)
+#define SUSPEND_MAGIC_GET(val) GET_VAL(val, 8, 24)
+
+#define WAKEUP_FLAGS_SHIFFT	 0
+#define WAKEUP_FLAGS_BITS (eWAKEUP_ON_MAX)
+#define WAKEUP_FLAGS_MASK(val) SET_VAL(val, WAKEUP_FLAGS_BITS, WAKEUP_FLAGS_SHIFFT)
+#define WAKEUP_FLAGS_GET(reg) GET_VAL(reg, WAKEUP_FLAGS_BITS, WAKEUP_FLAGS_SHIFFT)
+
+#define RESUME_STATE_SHIFFT 16
+#define RESUME_STATE_BITS 8
+#define RESUME_STATE_MASK(val) SET_VAL(val, RESUME_STATE_BITS, RESUME_STATE_SHIFFT)
+#define RESUME_STATE_GET(reg) GET_VAL(reg, RESUME_STATE_BITS, RESUME_STATE_SHIFFT)
+
+#define RESUME_DATA_SHIFFT 0
+#define RESUME_DATA_BITS 16
+#define RESUME_DATA_MASK(val) SET_VAL(val, RESUME_DATA_BITS, RESUME_DATA_SHIFFT)
+#define RESUME_DATA_GET(reg) GET_VAL(reg, RESUME_DATA_BITS, RESUME_DATA_SHIFFT)
+
+#define AUDIO_RECIPROCAL_TIMER_SHIFFT 0
+#define AUDIO_RECIPROCAL_TIMER_BITS 24
+#define AUDIO_RECIPROCAL_TIMER_MASK(val) SET_VAL(val, AUDIO_RECIPROCAL_TIMER_BITS, AUDIO_RECIPROCAL_TIMER_SHIFFT)
+#define AUDIO_RECIPROCAL_TIMER_GET(reg) GET_VAL(reg, AUDIO_RECIPROCAL_TIMER_BITS, AUDIO_RECIPROCAL_TIMER_SHIFFT)
+
+enum {
+	AUTHOR_SCPU = 0x1,
+	AUTHOR_ACPU,
+};
+
+enum _notify_flag{
+	NOTIFY_NONE,
+	NOTIFY_SUSPEND_TO_RAM = 0x01,
+	NOTIFY_SUSPEND_TO_COOLBOOT,
+	NOTIFY_SUSPEND_TO_WFI,
+
+	NOTIFY_RESUME_PLATFORM = 0x10,
+	NOTIFY_RESUME_END,
+	NOTIFY_SCPU_READY,
+	NOTIFY_ACPU_READY,
+};
+
+enum _suspend_mode {
+	SUSPEND_TO_RAM,
+	SUSPEND_TO_COOLBOOT,
+	SUSPEND_TO_WFI,
+	MAX_SUSPEND_MODE,
+};
+
+enum _suspend_wakeup {
+	eWAKEUP_ON_LAN,
+	eWAKEUP_ON_IR,
+	eWAKEUP_ON_GPIO,
+	eWAKEUP_ON_ALARM,
+	eWAKEUP_ON_TIMER,
+	eWAKEUP_ON_CEC,
+	eWAKEUP_ON_USB,
+	eWAKEUP_ON_MAX,
+};
+
+enum _wakeup_flags {
+	fWAKEUP_ON_LAN = 0x1U << eWAKEUP_ON_LAN,
+	fWAKEUP_ON_IR = 0x1U << eWAKEUP_ON_IR,
+	fWAKEUP_ON_GPIO = 0x1U << eWAKEUP_ON_GPIO,
+	fWAKEUP_ON_ALARM = 0x1U << eWAKEUP_ON_ALARM,
+	fWAKEUP_ON_TIMER = 0x1U << eWAKEUP_ON_TIMER,
+	fWAKEUP_ON_CEC = 0x1U << eWAKEUP_ON_CEC,
+	fWAKEUP_ON_USB = 0x1U << eWAKEUP_ON_USB,
+};
+
+enum _RESUME_STATE {
+	RESUME_NONE	 = 0,
+	RESUME_UNKNOW,
+	RESUME_IR,
+	RESUME_GPIO,
+	RESUME_LAN,
+	RESUME_ALARM,
+	RESUME_TIMER,
+	RESUME_CEC,
+	RESUME_USB,
+	RESUME_MAX_STATE,
+};
+
+struct suspend_param {
+	unsigned int wakeup_source;
+	unsigned int timerout_val;
+	char wu_gpio_en[SUSPEND_ISO_GPIO_SIZE];
+	char wu_gpio_act[SUSPEND_ISO_GPIO_SIZE];
+	struct ipc_shm_irda irda_info;
+}__attribute__((packed));
+
+extern const char *const rtk_suspend_resume_states[RESUME_MAX_STATE];
+extern const char *const rtk_suspend_wakeup_states[eWAKEUP_ON_MAX];
+extern const char *const rtk_suspend_states[MAX_SUSPEND_MODE];
+
+#endif /* RTD16XX_SUSPEND_H_ */
diff --git a/drivers/soc/realtek/rtd16xx/rtd16xx_suspend_fs.c b/drivers/soc/realtek/rtd16xx/rtd16xx_suspend_fs.c
new file mode 100755
index 00000000..cdeccf7
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtd16xx_suspend_fs.c
@@ -0,0 +1,342 @@
+/*
+ * rtd16xx_suspend_fs.c - power management driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/device.h>
+#include <linux/pm.h>
+#include <linux/suspend.h>
+#include <linux/module.h>
+#include <linux/err.h>
+#include <linux/cpu.h>
+#include <linux/delay.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_gpio.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/reboot.h>
+#include <linux/clocksource.h>
+#include <linux/clockchips.h>
+#include <linux/cpu_pm.h>
+#include <linux/vmalloc.h>
+#include <linux/tick.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/irqchip/arm-gic.h>
+#include <linux/psci.h>
+#include <asm/system_misc.h>
+#include <asm/cacheflush.h>
+#include <asm/suspend.h>
+#include <soc/realtek/memory.h>
+#include <uapi/linux/psci.h>
+
+#include "rtd16xx_suspend.h"
+
+unsigned int suspend_context;
+unsigned int pm_state;
+
+/*
+wakelock count mode:
+0: original mode
+1: deep sleep mode
+*/
+unsigned int pm_wakelock_mode;
+/**
+ * some sync mechanism between kernel suspend
+ * and android wakelock control
+ */
+unsigned int pm_block_wakelock;
+extern struct suspend_param *pcpu_data;
+extern struct kobj_attribute rtk_suspend_gpio_wakeup_en_attr;
+extern struct kobj_attribute rtk_suspend_gpio_wakeup_act_attr;
+extern struct kobj_attribute rtk_suspend_gpio_out_en_attr;
+extern struct kobj_attribute rtk_suspend_gpio_out_act_attr;
+
+const char *const rtk_suspend_wakeup_states[eWAKEUP_ON_MAX] = {
+	[eWAKEUP_ON_LAN] = "lan",
+	[eWAKEUP_ON_IR] = "ir",
+	[eWAKEUP_ON_GPIO] = "gpio",
+	[eWAKEUP_ON_ALARM] = "alarm",
+	[eWAKEUP_ON_TIMER] = "timer",
+	[eWAKEUP_ON_CEC] = "cec",
+};
+
+const char *const rtk_suspend_resume_states[RESUME_MAX_STATE] = {
+	[RESUME_NONE] = "none",
+	[RESUME_UNKNOW] = "unknow",
+	[RESUME_IR] = "ir",
+	[RESUME_GPIO] = "gpio",
+	[RESUME_LAN] = "lan",
+	[RESUME_ALARM] = "alarm",
+	[RESUME_TIMER] = "timer",
+	[RESUME_CEC] = "cec",
+};
+
+const char *const rtk_suspend_states[MAX_SUSPEND_MODE] = {
+	[SUSPEND_TO_RAM] = "ram",
+	[SUSPEND_TO_COOLBOOT] = "coolboot",
+	[SUSPEND_TO_WFI] = "wfi",
+};
+
+#define RTK_SUSPEND_ATTR(_name) \
+{ \
+	.attr = {.name = #_name, .mode = 0644}, \
+	.show =  rtk_suspend_##_name##_show, \
+	.store = rtk_suspend_##_name##_store, \
+}
+
+static enum _suspend_wakeup rtk_suspend_decode_wakeup(const char *buf,
+	size_t n)
+{
+	const char *const *s;
+	char *p;
+	int len;
+	int i;
+
+	p = memchr(buf, '\n', n);
+	len = p ? p - buf : n;
+
+	for (i = 0 ; i < eWAKEUP_ON_MAX ; i++) {
+		s = &rtk_suspend_wakeup_states[i];
+		if (*s && len == strlen(*s) && !strncmp(buf, *s, len))
+			return i;
+	}
+
+	return eWAKEUP_ON_MAX;
+}
+
+static ssize_t rtk_suspend_wakeup_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	int i;
+	int n = 0;
+	unsigned int val = pcpu_data->wakeup_source;
+
+	for (i = 0 ; i < eWAKEUP_ON_MAX ; i++) {
+
+		if (val & (0x1U << i))
+			n += sprintf(buf + n, " * ");
+		else
+			n += sprintf(buf + n, "   ");
+		n += sprintf(buf + n, "%s\n", rtk_suspend_wakeup_states[i]);
+	}
+	n += sprintf(buf + n, "\n");
+	return n;
+}
+
+static ssize_t rtk_suspend_wakeup_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	enum _suspend_wakeup wakeup = rtk_suspend_decode_wakeup(buf, count);
+
+	if (wakeup < eWAKEUP_ON_MAX) {
+		pcpu_data->wakeup_source ^= (0x1U << wakeup);
+		return count;
+	}
+
+	return -ENOMEM;
+}
+
+static ssize_t rtk_suspend_timer_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	return sprintf(buf, " %d sec (reciprocal timer)\n",
+		pcpu_data->timerout_val);
+}
+
+static ssize_t rtk_suspend_timer_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	if (val > (AUDIO_RECIPROCAL_TIMER_GET(-1UL)))
+		return -ENOMEM;
+
+	pcpu_data->timerout_val = val;
+	return count;
+}
+
+static ssize_t rtk_suspend_context_show(struct kobject *kobj,
+	struct kobj_attribute *attr, char *buf)
+{
+	return sprintf(buf, "%d\n", suspend_context);
+}
+
+static ssize_t rtk_suspend_context_store(struct kobject *kobj,
+	struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	suspend_context = val;
+	return count;
+}
+
+static struct kobj_attribute rtk_suspend_wakeup_attr =
+	RTK_SUSPEND_ATTR(wakeup);
+static struct kobj_attribute rtk_suspend_timer_attr =
+	RTK_SUSPEND_ATTR(timer);
+static struct kobj_attribute rtk_suspend_context_attr =
+	RTK_SUSPEND_ATTR(context);
+
+static struct attribute *rtk_suspend_attrs[] = {
+	&rtk_suspend_wakeup_attr.attr,
+	&rtk_suspend_timer_attr.attr,
+	&rtk_suspend_context_attr.attr,
+	&rtk_suspend_gpio_wakeup_en_attr.attr,
+	&rtk_suspend_gpio_wakeup_act_attr.attr,
+	&rtk_suspend_gpio_out_en_attr.attr,
+	&rtk_suspend_gpio_out_act_attr.attr,
+	NULL,
+};
+
+static struct attribute_group rtk_suspend_attr_group = {
+	.attrs = rtk_suspend_attrs,
+};
+
+static struct kobject *rtk_suspend_kobj;
+
+static ssize_t pm_state_show(struct device *dev, struct device_attribute *attr,
+	char *buf)
+{
+	return sprintf(buf, "%d\n", pm_state);
+}
+
+static ssize_t pm_state_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_state = val;
+
+	return count;;
+}
+
+static ssize_t pm_wakelock_mode_show(struct device *dev, struct device_attribute *attr,
+	char *buf)
+{
+	return sprintf(buf, "%d\n", pm_wakelock_mode);
+}
+
+static ssize_t pm_wakelock_mode_store(struct device *dev,
+	struct device_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_wakelock_mode = val;
+
+	return count;;
+}
+
+static ssize_t pm_block_wakelock_show(
+    struct device *dev,
+    struct device_attribute *attr,
+    char *buf)
+{
+	return sprintf(buf, "%d\n", pm_block_wakelock);
+}
+
+static ssize_t pm_block_wakelock_store(
+    struct device *dev,
+    struct device_attribute *attr,
+    const char *buf,
+    size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+
+	if (ret < 0)
+		return -ENOMEM;
+
+	pm_block_wakelock = val;
+
+	return count;;
+}
+
+static struct device_attribute pm_state_attr =
+	__ATTR(pm_state, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_state_show, pm_state_store);
+
+static struct device_attribute pm_wakelock_mode_attr =
+	__ATTR(pm_wakelock_mode, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_wakelock_mode_show, pm_wakelock_mode_store);
+
+static struct device_attribute pm_block_wakelock_attr =
+	__ATTR(pm_block_wakelock, (S_IRUGO|S_IWUSR|S_IWGRP),
+	pm_block_wakelock_show, pm_block_wakelock_store);
+
+struct class *rtk_pm_class;
+struct device *rtk_pm_dev;
+
+static int __init suspend_sysfs_init(void)
+{
+	int ret;
+
+	pcpu_data->timerout_val = 0;
+	pm_state = 0;
+	pm_wakelock_mode = 0;
+    pm_block_wakelock = 0;
+
+	rtk_pm_class = class_create(THIS_MODULE, "rtk_pm");
+	if (IS_ERR(rtk_pm_class))
+		return PTR_ERR(rtk_pm_class);
+
+	rtk_pm_dev =  device_create(rtk_pm_class, NULL,
+		MKDEV(0, 1), NULL, "android_control");
+	if (IS_ERR(rtk_pm_dev))
+		return PTR_ERR(rtk_pm_dev);
+
+	ret = device_create_file(rtk_pm_dev, &pm_state_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	ret = device_create_file(rtk_pm_dev, &pm_wakelock_mode_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	ret = device_create_file(rtk_pm_dev, &pm_block_wakelock_attr);
+	if (ret < 0) {
+		device_destroy(rtk_pm_class, MKDEV(0, 1));
+		return -1;
+	}
+
+	rtk_suspend_kobj = kobject_create_and_add("suspend", kernel_kobj);
+	if (!rtk_suspend_kobj)
+		return -ENOMEM;
+
+	ret = sysfs_create_group(rtk_suspend_kobj, &rtk_suspend_attr_group);
+	if (ret)
+		kobject_put(rtk_suspend_kobj);
+
+	return ret;
+}
+
+module_init(suspend_sysfs_init);
diff --git a/drivers/soc/realtek/rtd16xx/rtd16xx_suspend_mem.c b/drivers/soc/realtek/rtd16xx/rtd16xx_suspend_mem.c
new file mode 100644
index 00000000..348b428
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtd16xx_suspend_mem.c
@@ -0,0 +1,270 @@
+/*
+ * rtd16xx_ddr_calibration.c
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/printk.h>
+#include <linux/delay.h>
+#include <linux/smp.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/memblock.h>
+#include <linux/slab.h>
+#include <asm/cacheflush.h>
+
+#define MEM_VERIFIED_CNT 20
+
+void hexdump(char *note, unsigned char *buf, unsigned int len)
+{
+	pr_crit("%s\n", note);
+	print_hex_dump(KERN_CONT, "", DUMP_PREFIX_OFFSET, 16, 1, buf, len,
+		false);
+}
+EXPORT_SYMBOL(hexdump);
+
+struct _memory_verified_handle {
+	unsigned char *memAddress;
+	size_t memByte;
+};
+
+struct _memory_verified_handle phys_wb_area[] = {
+	{(unsigned char *)0x0a000000, 0x20},
+	{(unsigned char *)0x0a001000, 0x20}
+};
+
+struct _memory_verified_handle *mem_vhandle[20];
+struct _memory_verified_handle **mem_wbhandle;
+
+static unsigned char memory_verified_datagen(int i)
+{
+	return (unsigned char) (i & 0xff);
+}
+
+static struct _memory_verified_handle *memory_verified_handle_create(size_t byte)
+{
+	int i = 0;
+
+	struct _memory_verified_handle *handle =
+		(struct _memory_verified_handle *)
+		kmalloc(sizeof(struct _memory_verified_handle), GFP_KERNEL);
+
+	if (!handle)
+		return NULL;
+
+	/*
+	 * > 32KB : vmalloc
+	 * < 32KB : kmalloc
+	 */
+	if (byte > 0x8000)
+		handle->memAddress = vmalloc(byte);
+	else
+		handle->memAddress = kmalloc(byte, GFP_KERNEL);
+
+	if (!handle->memAddress) {
+		kfree(handle);
+		return NULL;
+	}
+
+	for (i = 0; i < byte ; i++)
+		handle->memAddress[i] = memory_verified_datagen(i);
+
+	handle->memByte = byte;
+
+	return handle;
+}
+
+static int memory_verified_release(struct _memory_verified_handle *handle)
+{
+	int ret = 0, i = 0;
+	unsigned char data;
+
+	if (!handle) {
+		pr_err("%s: handle is NULL !\n", __func__);
+		return -1;
+	}
+
+	if (!handle->memByte) {
+		ret = -2;
+		pr_info("%s: handle %p ", __func__, (void *) handle);
+		pr_info("(memByte = %ld, memAddress = 0x%08lx)\n",
+			(long int) handle->memByte,
+			(unsigned long) handle->memAddress);
+
+		if (handle->memAddress)
+			goto free1;
+		else
+			goto free0;
+	}
+
+	for (i = 0 ; i < handle->memByte ; i++) {
+		data = memory_verified_datagen(i);
+
+		if (handle->memAddress[i] != data) {
+			pr_info("%s: handle %p memAddress[0x%x]",
+				__func__, (void *) handle, i);
+			pr_info("=> 0x%x != 0x%x (%ld bytes at 0x%08lx)\n",
+				handle->memAddress[i], data,
+				(long int) handle->memByte,
+				(unsigned long) handle->memAddress);
+			ret = -4;
+		}
+	}
+
+	if (ret == -4) {
+		pr_err("%s: memory phyAddt 0x%08llx\n",
+			__func__, __pa(handle->memAddress));
+		hexdump("[%s] memory verified error\n",
+			handle->memAddress, handle->memByte);
+	}
+
+free1:
+	kfree(handle->memAddress);
+free0:
+	kfree(handle);
+
+	return ret;
+}
+
+static struct _memory_verified_handle *memory_writeback_handle_create(
+	struct _memory_verified_handle *phys_area)
+{
+	void *tmp_addr;
+
+	struct _memory_verified_handle *handle =
+		(struct _memory_verified_handle *)
+		kmalloc(sizeof(struct _memory_verified_handle), GFP_KERNEL);
+
+	if (!handle)
+		goto out;
+
+	handle->memAddress = kmalloc(phys_area->memByte, GFP_KERNEL);
+
+	if (!handle->memAddress) {
+		kfree(handle);
+		handle = NULL;
+		goto out;
+	}
+
+	handle->memByte = phys_area->memByte;
+	tmp_addr = phys_to_virt((phys_addr_t) phys_area->memAddress);
+	hexdump("[RTD16xx_PM] Before write back dump:",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+	memcpy(handle->memAddress, tmp_addr, phys_area->memByte);
+
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(handle->memAddress, phys_area->memByte);
+#else
+	__flush_dcache_area(handle->memAddress, phys_area->memByte);
+#endif /* CONFIG_CPU_V7 */
+
+out:
+	return handle;
+}
+
+static int memory_writeback_release(struct _memory_verified_handle *handle,
+	struct _memory_verified_handle *phys_area)
+{
+	int ret = 0;
+	void *tmp_addr;
+
+	if (!handle) {
+		ret = -1;
+		goto out;
+	}
+
+	if (!handle->memAddress) {
+		ret = -1;
+		goto free_out;
+	}
+
+	tmp_addr = phys_to_virt((phys_addr_t)phys_area->memAddress);
+	hexdump("[RTD16xx_PM] Resume back dump:**********************",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+	memcpy(tmp_addr, handle->memAddress, handle->memByte);
+
+#if defined(CONFIG_CPU_V7)
+	v7_flush_kern_dcache_area(tmp_addr, phys_area->memByte);
+#else
+	__flush_dcache_area(tmp_addr, phys_area->memByte);
+#endif /* CONFIG_CPU_V7 */
+
+	hexdump("[RTD16xx_PM] After write back dump:",
+		(unsigned char *) tmp_addr, phys_area->memByte);
+
+	kfree(handle->memAddress);
+
+free_out:
+	kfree(handle);
+out:
+	return ret;
+}
+
+void memory_check_begin(void)
+{
+	int i = 0;
+
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		mem_vhandle[i] = memory_verified_handle_create(0x4000);
+}
+EXPORT_SYMBOL(memory_check_begin);
+
+void memory_check_end(void)
+{
+	int i = 0;
+
+	pr_info("%s: Resume Memory Verifying ... State 0\n", __func__);
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		memory_verified_release(mem_vhandle[i]);
+
+	pr_info("%s: Resume Memory Verifying ... State 1\n", __func__);
+	for (i = 0 ; i < MEM_VERIFIED_CNT; i++)
+		mem_vhandle[i] = memory_verified_handle_create(0x4000);
+
+	for (i = 0 ; i < MEM_VERIFIED_CNT ; i++)
+		memory_verified_release(mem_vhandle[i]);
+
+}
+EXPORT_SYMBOL(memory_check_end);
+
+void rtk_ddr_calibration_save(void)
+{
+	int i = 0;
+	int size_tmp1 = 0;
+	int size_tmp2 = 0;
+	int size_tmp3 = 0;
+
+	size_tmp1 = sizeof(phys_wb_area);
+	size_tmp2 = sizeof(struct _memory_verified_handle);
+	size_tmp3 = sizeof(struct _memory_verified_handle *);
+	mem_wbhandle = kmalloc(size_tmp1 / size_tmp2 * size_tmp3, GFP_KERNEL);
+	if (mem_wbhandle) {
+		for (i = 0 ; i < (size_tmp1 / size_tmp2) ; i++)
+			mem_wbhandle[i] = memory_writeback_handle_create(
+					&phys_wb_area[i]);
+	}
+}
+EXPORT_SYMBOL(rtk_ddr_calibration_save);
+
+void rtk_ddr_calibration_restore(void)
+{
+	int i = 0;
+	int size_tmp1 = 0;
+	int size_tmp2 = 0;
+
+	if (mem_wbhandle) {
+		for (i = 0 ; i < (size_tmp1 / size_tmp2) ; i++)
+			memory_writeback_release(
+				mem_wbhandle[i], &phys_wb_area[i]);
+		kfree(mem_wbhandle);
+	}
+}
+EXPORT_SYMBOL(rtk_ddr_calibration_restore);
diff --git a/drivers/soc/realtek/rtd16xx/rtk_chip.c b/drivers/soc/realtek/rtd16xx/rtk_chip.c
new file mode 100644
index 00000000..063d344
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_chip.c
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2018 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <soc/realtek/rtk_chip.h>
+#include <linux/module.h>
+#include <linux/io.h>
+
+#define SB2_BASE_ADDR 0x9801A000
+#define CHIP_ID 0x00000200
+#define CHIP_REV 0x00000204
+
+#define RTD16xx_CHIP_A00 (0x00000000)
+#define RTD16xx_CHIP_A01 (0x00010000)
+
+int get_rtd_chip_id(void) {
+	int chip_id = CHIP_ID_RTD1619;
+	return chip_id;
+}
+EXPORT_SYMBOL(get_rtd_chip_id);
+
+int get_rtd_chip_revision(void) {
+	int chip_revision = RTD_CHIP_A00;
+	void __iomem *chip_revision_addr = ioremap(SB2_BASE_ADDR + CHIP_REV, 0x4);
+
+	int val = readl(chip_revision_addr);
+
+	__iounmap(chip_revision_addr);
+
+	switch (val) {
+	case (RTD16xx_CHIP_A00):
+		return RTD_CHIP_A00;
+	case (RTD16xx_CHIP_A01):
+		return RTD_CHIP_A01;
+	default:
+		printk("%s: Not define chip revision 0x%x\n", __func__, val);
+	}
+	return chip_revision;
+}
+EXPORT_SYMBOL(get_rtd_chip_revision);
diff --git a/drivers/soc/realtek/rtd16xx/rtk_usb.c b/drivers/soc/realtek/rtd16xx/rtk_usb.c
new file mode 100644
index 00000000..35fa511
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_usb.c
@@ -0,0 +1,395 @@
+/*
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/slab.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_platform.h>
+#include <linux/reset.h>
+#include <linux/usb/otg.h>
+#include <soc/realtek/rtk_usb.h>
+#include <soc/realtek/rtk_chip.h>
+
+struct rtk_usb {
+	struct power_ctrl_reg {
+		/* l4_icg */
+		u32 p0_l4_icg;
+		u32 p1_l4_icg;
+		u32 p2_l4_icg;
+	} power_ctrl_reg;
+
+	bool usb_power_cut;
+
+	struct type_c {
+		u32 drd_wrap_base; /* 0x98013200 */
+		u32 u3host_wrap_base; /* 0x98013e00 */
+		u32 drd_u3_portsc; /* 0x98020430 */
+		u32 drd_u3_sus_en; /* 0x980282c0 */
+		u32 u3host_u3_sus_en; /*0x980582c0 */
+	} type_c;
+};
+
+static struct rtk_usb *rtk_usb;
+
+#define disable_cc 0x0
+#define enable_cc1 0x1
+#define enable_cc2 0x2
+
+/* set usb charger power */
+void rtk_usb_set_charger_power(struct rtk_usb *rtk_usb, unsigned int val)
+{
+	if (!rtk_usb)
+		return;
+
+	return;
+}
+
+int rtk_usb_set_hw_l4icg_on_off(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool on)
+{
+	void __iomem *reg;
+
+	if (!rtk_usb)
+		return 0;
+
+	switch (port_num) {
+	case USB_PORT_0:
+		if (rtk_usb->power_ctrl_reg.p0_l4_icg) {
+			pr_info("%s set l4_icg port %d\n", __func__, port_num);
+			reg = ioremap(rtk_usb->power_ctrl_reg.p0_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	case USB_PORT_1:
+		if (rtk_usb->power_ctrl_reg.p1_l4_icg) {
+			pr_info("%s set l4_icg port %d\n", __func__, port_num);
+			reg = ioremap(rtk_usb->power_ctrl_reg.p1_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	case USB_PORT_2:
+		if (rtk_usb->power_ctrl_reg.p2_l4_icg) {
+			pr_info("%s set l4_icg port %d\n", __func__, port_num);
+			reg = ioremap(rtk_usb->power_ctrl_reg.p2_l4_icg, 0x4);
+			writel((on&BIT(0)) | readl(reg), reg);
+			iounmap(reg);
+		}
+		break;
+	default:
+		pr_err("%s Error Port num %d\n", __func__, port_num);
+		break;
+	}
+
+	return 0;
+}
+
+static inline struct reset_control *USB_reset_get(struct device *dev,
+	    const char *str)
+{
+	struct reset_control *reset;
+
+	reset = reset_control_get(dev, str);
+	if (IS_ERR(reset)) {
+		dev_dbg(dev, "No controller reset %s\n", str);
+		reset = NULL;
+	}
+	return reset;
+}
+
+static inline void USB_reset_put(struct reset_control *reset)
+{
+	if (reset) {
+		reset_control_put(reset);
+	}
+}
+
+static inline int USB_reset_deassert(struct reset_control *reset)
+{
+	if (!reset) return 0;
+
+	return reset_control_deassert(reset);
+}
+
+static inline int USB_reset_assert(struct reset_control *reset)
+{
+	if (!reset) return 0;
+
+	return reset_control_assert(reset);
+}
+
+int rtk_usb_iso_power_ctrl(struct rtk_usb *rtk_usb,
+	    bool power_on)
+{
+	struct platform_device *pdev;
+	struct device_node *node;
+	struct device *dev;
+	struct reset_control *reset_u2phy0;
+	struct reset_control *reset_u2phy1;
+	struct reset_control *reset_u2phy2;
+	struct reset_control *reset_u2phy3;
+	struct reset_control *reset_u3phy0;
+	struct reset_control *reset_u3phy1;
+	struct reset_control *reset_usb_apply;
+
+	if (!rtk_usb)
+		return 0;
+
+	pr_debug("%s START power %s\n", __func__, power_on?"on":"off");
+
+	node = of_find_compatible_node(NULL, NULL,
+		    "Realtek,usb-manager");
+	if (node != NULL)
+		pdev = of_find_device_by_node(node);
+	if (pdev != NULL) {
+		dev = &pdev->dev;
+	} else {
+		pr_err("%s ERROR no usb-manager", __func__);
+		return -ENODEV;
+	}
+
+	/* GET reset controller */
+	reset_u2phy0 = USB_reset_get(dev, "u2phy0");
+	reset_u2phy1 = USB_reset_get(dev, "u2phy1");
+	reset_u2phy2 = USB_reset_get(dev, "u2phy2");
+	reset_u2phy3 = USB_reset_get(dev, "u2phy3");
+
+	reset_u3phy0 = USB_reset_get(dev, "u3phy0");
+	reset_u3phy1 = USB_reset_get(dev, "u3phy1");
+
+	reset_usb_apply = USB_reset_get(dev, "apply");
+
+	if (rtk_usb->usb_power_cut) {
+		if (power_on) {
+			// Enable usb phy reset
+			/* DEASSERT: set rstn bit to 1 */
+			pr_debug("usb power cut No set phy reset by rtk_usb\n");
+		} else {
+			pr_debug("usb power cut set phy reset to 0\n");
+			USB_reset_assert(reset_u2phy0);
+			USB_reset_assert(reset_u2phy1);
+			USB_reset_assert(reset_u2phy2);
+			USB_reset_assert(reset_u2phy3);
+			USB_reset_assert(reset_u3phy0);
+			USB_reset_assert(reset_u3phy1);
+
+			USB_reset_assert(reset_usb_apply);
+		}
+	}
+	pr_debug("Realtek RTD16xx USB power %s OK\n", power_on?"on":"off");
+
+	USB_reset_put(reset_u2phy0);
+	USB_reset_put(reset_u2phy1);
+	USB_reset_put(reset_u2phy2);
+	USB_reset_put(reset_u2phy3);
+
+	USB_reset_put(reset_u3phy0);
+	USB_reset_put(reset_u3phy1);
+
+	USB_reset_put(reset_usb_apply);
+
+	return 0;
+}
+
+int rtk_usb_port_suspend_resume(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool is_suspend)
+{
+	if (!rtk_usb)
+		return 0;
+
+	return 0;
+}
+
+int rtk_type_c_init(struct rtk_usb *rtk_usb)
+{
+	void __iomem *drd_wrap_base, *drd_cc_setting;
+	void __iomem *u3host_wrap_base, *u3host_mac_ctrl;
+	int val_u3_tc_mode, val_u3host_mac_ctrl;
+
+	if (!rtk_usb->type_c.drd_wrap_base ||
+		    !rtk_usb->type_c.u3host_wrap_base ||
+		    !rtk_usb->type_c.drd_u3_portsc ||
+		    !rtk_usb->type_c.drd_u3_sus_en ||
+		    !rtk_usb->type_c.u3host_u3_sus_en) {
+		pr_err("%s: Error! No RTD1619 type_c reg\n", __func__);
+		return -1;
+	}
+
+	drd_wrap_base = ioremap(rtk_usb->type_c.drd_wrap_base, 0x200);
+	drd_cc_setting = drd_wrap_base + 0x194;
+	u3host_wrap_base = ioremap(rtk_usb->type_c.u3host_wrap_base, 0x200);
+	u3host_mac_ctrl = u3host_wrap_base + 0x60;
+	val_u3_tc_mode = BIT(0) | readl(drd_cc_setting);
+	val_u3host_mac_ctrl = BIT(8) | readl(u3host_mac_ctrl);
+
+	writel(val_u3_tc_mode, drd_cc_setting);
+	writel(val_u3host_mac_ctrl, u3host_mac_ctrl);
+
+	pr_info("%s: set type_c mode (0x%x) and disable u3host u3 port (0x%x) "
+		    "for RTD1619\n",
+		    __func__, readl(drd_cc_setting), readl(u3host_mac_ctrl));
+
+	iounmap(drd_wrap_base);
+	iounmap(u3host_mac_ctrl);
+}
+
+int rtk_type_c_plug_config(struct rtk_usb *rtk_usb, int dr_mode, int cc)
+{
+	void __iomem *drd_wrap_base, *u3host_wrap_base;
+	void __iomem *drd_u3phy_pipe_clock, *u3host_u3phy_pipe_clock;
+	void __iomem *drd_pclk_u3phy, *u3host_pclk_u3phy;
+	void __iomem *drd_tc_mux_ctrl;
+	void __iomem *drd_u3_portsc;
+	void __iomem *drd_u3_sus_en, *u3host_u3_sus_en;
+	int wait_count = 1000;
+	int drd_u3_sus_en_status_save, u3host_u3_sus_en_status_save;
+
+	if (!rtk_usb->type_c.drd_wrap_base ||
+		    !rtk_usb->type_c.u3host_wrap_base ||
+		    !rtk_usb->type_c.drd_u3_portsc ||
+		    !rtk_usb->type_c.drd_u3_sus_en ||
+		    !rtk_usb->type_c.u3host_u3_sus_en) {
+		pr_err("%s: Error! No RTD1619 type_c reg\n", __func__);
+		return -1;
+	}
+
+	drd_wrap_base = ioremap(rtk_usb->type_c.drd_wrap_base, 0x200);
+	u3host_wrap_base = ioremap(rtk_usb->type_c.u3host_wrap_base, 0x100);
+	drd_u3phy_pipe_clock = drd_wrap_base + 0xc;
+	u3host_u3phy_pipe_clock = u3host_wrap_base + 0xc;
+	drd_pclk_u3phy = drd_wrap_base + 0x84;
+	u3host_pclk_u3phy = u3host_wrap_base + 0x84;
+	drd_tc_mux_ctrl =  drd_wrap_base + 0x194;
+	drd_u3_portsc = ioremap(rtk_usb->type_c.drd_u3_portsc, 0x4);
+	drd_u3_sus_en = ioremap(rtk_usb->type_c.drd_u3_sus_en, 0x4);
+	u3host_u3_sus_en = ioremap(rtk_usb->type_c.u3host_u3_sus_en, 0x4);
+	drd_u3_sus_en_status_save = readl(drd_u3_sus_en) & BIT(17);
+	u3host_u3_sus_en_status_save = readl(u3host_u3_sus_en) & BIT(17);
+
+	pr_info("%s: dr_mode=%d cc=0x%x\n", __func__, dr_mode, cc);
+	/* disable u3phy suspend */
+	writel(~BIT(17) & readl(drd_u3_sus_en), drd_u3_sus_en);
+	writel(~BIT(17) & readl(u3host_u3_sus_en), u3host_u3_sus_en);
+
+	/* check u3phy clock if resume */
+	while (wait_count-- > 0 && (!(readl(drd_pclk_u3phy) & BIT(19)) ||
+		!(readl(u3host_pclk_u3phy) & BIT(19)))) {
+		pr_info("wait drd/u3host u3phy clock\n");
+		mdelay(1);
+	};
+
+	if (wait_count < 0) {
+		pr_err("wait u3phy clock fail. "
+			    "drd=0x%x u3host=0x%x\n",
+			    readl(drd_pclk_u3phy), readl(u3host_pclk_u3phy));
+	}
+
+	if (cc == disable_cc) {
+		pr_info("%s: disable drd u3phy for CHIP_ID_RTD1619\n",
+			__func__);
+	} else {
+		/* push drd u3 port status to disable */
+		writel(BIT(1) | readl(drd_u3_portsc), drd_u3_portsc);
+		pr_info("%s: disable drd_u3_portsc=0x%x\n",
+			    __func__, readl(drd_u3_portsc));
+
+		/* disable u3phy clock */
+		writel(~BIT(1) & readl(drd_u3phy_pipe_clock), drd_u3phy_pipe_clock);
+		writel(~BIT(1) & readl(u3host_u3phy_pipe_clock),
+			    u3host_u3phy_pipe_clock);
+
+		if (cc == enable_cc1) {
+			writel(~BIT(1) & readl(drd_tc_mux_ctrl), drd_tc_mux_ctrl);
+			pr_info("%s: enable_cc1 drd u3phy for "
+				    "CHIP_ID_RTD1619\n", __func__);
+		} else if (cc == enable_cc2) {
+			writel(BIT(1) | readl(drd_tc_mux_ctrl), drd_tc_mux_ctrl);
+			pr_info("%s: enable_cc2 drd u3phy for "
+				    "CHIP_ID_RTD1619\n", __func__);
+		}
+		/* enable u3phy clock */
+		writel(BIT(1) | readl(drd_u3phy_pipe_clock), drd_u3phy_pipe_clock);
+		writel(BIT(1) | readl(u3host_u3phy_pipe_clock),
+			    u3host_u3phy_pipe_clock);
+
+		/* push drd u3 port status to rxDetect */
+		writel(BIT(16) | 0xA0 |
+			    (readl(drd_u3_portsc) & (~0x1E0)),
+			    drd_u3_portsc);
+		pr_info("%s: drd_u3_portsc=0x%x\n",
+			    __func__, readl(drd_u3_portsc));
+	}
+
+		/* enable u3phy suspend */
+	pr_info("u3_sus_en_status_save drd=0x%x u3host=0x%x\n",
+		    drd_u3_sus_en_status_save, u3host_u3_sus_en_status_save);
+	writel(drd_u3_sus_en_status_save | readl(drd_u3_sus_en), drd_u3_sus_en);
+	writel(u3host_u3_sus_en_status_save | readl(u3host_u3_sus_en),
+		    u3host_u3_sus_en);
+
+	iounmap(drd_u3_portsc);
+	iounmap(drd_u3_sus_en);
+	iounmap(u3host_u3_sus_en);
+	iounmap(u3host_wrap_base);
+}
+
+struct rtk_usb *rtk_usb_soc_init(struct device_node *node)
+{
+	struct device_node *sub_node;
+
+	if (!rtk_usb)
+		rtk_usb = kzalloc(sizeof(struct rtk_usb), GFP_KERNEL);
+
+	pr_info("%s START (%s)\n", __func__, __FILE__);
+
+	sub_node = of_get_child_by_name(node, "power_ctrl_reg");
+	if (sub_node) {
+		pr_debug("%s sub_node %s\n", __func__, sub_node->name);
+
+		of_property_read_u32(sub_node,
+			    "p0_l4_icg", &rtk_usb->power_ctrl_reg.p0_l4_icg);
+		of_property_read_u32(sub_node,
+			    "p1_l4_icg", &rtk_usb->power_ctrl_reg.p1_l4_icg);
+		of_property_read_u32(sub_node,
+			    "p2_l4_icg", &rtk_usb->power_ctrl_reg.p2_l4_icg);
+
+		if (of_property_read_bool(sub_node, "usb_power_cut"))
+			rtk_usb->usb_power_cut = true;
+		else
+			rtk_usb->usb_power_cut = false;
+	}
+
+	sub_node = of_get_child_by_name(node, "type_c");
+	if (sub_node) {
+		pr_debug("%s sub_node %s\n", __func__, sub_node->name);
+
+		of_property_read_u32(sub_node,
+			    "drd_wrap_base", &rtk_usb->type_c.drd_wrap_base);
+		of_property_read_u32(sub_node,
+			    "u3host_wrap_base", &rtk_usb->type_c.u3host_wrap_base);
+		of_property_read_u32(sub_node,
+			    "drd_u3_portsc", &rtk_usb->type_c.drd_u3_portsc);
+		of_property_read_u32(sub_node,
+			    "drd_u3_sus_en", &rtk_usb->type_c.drd_u3_sus_en);
+		of_property_read_u32(sub_node,
+			    "u3host_u3_sus_en", &rtk_usb->type_c.u3host_u3_sus_en);
+	}
+
+	pr_info("%s END\n", __func__);
+	return rtk_usb;
+}
+
+int rtk_usb_soc_free(struct rtk_usb **rtk_usb)
+{
+	if (*rtk_usb) {
+		kfree(*rtk_usb);
+		*rtk_usb = NULL;
+	}
+	return 0;
+}
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/Kconfig b/drivers/soc/realtek/rtd16xx/rtk_ve/Kconfig
new file mode 100644
index 00000000..226e865
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/Kconfig
@@ -0,0 +1,25 @@
+#
+# Realtek codec configuration
+#
+
+menuconfig RTK_CODEC
+	bool "Realtek Codec"
+	default n
+
+if RTK_CODEC
+
+if ION
+config RTK_RESERVE_MEMORY
+	bool "RTK Reserve Memory for Video/Image Codec"
+	default n
+endif # ION
+
+config VE1_CODEC
+	bool "RTK Video Engine 1 Codec"
+	default n
+
+config IMAGE_CODEC
+	bool "RTK Image Codec"
+	default n
+
+endif # RTK_CODEC
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/Makefile b/drivers/soc/realtek/rtd16xx/rtk_ve/Makefile
new file mode 100644
index 00000000..bcb1bfb
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/Makefile
@@ -0,0 +1,7 @@
+#
+# Makefile for the Realtek codec drivers.
+#
+
+obj-$(CONFIG_RTK_CODEC)		+= puwrap.o
+obj-$(CONFIG_VE1_CODEC)		+= ve1/
+obj-$(CONFIG_IMAGE_CODEC)	+= jdi/
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/Makefile b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/Makefile
new file mode 100644
index 00000000..40bef4c
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/Makefile
@@ -0,0 +1,6 @@
+# rtk_jcodec
+
+obj-$(CONFIG_IMAGE_CODEC) += jpu.o
+ifdef CONFIG_COMPAT
+obj-$(CONFIG_IMAGE_CODEC) += compat_jpu.o
+endif
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/compat_jpu.c b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/compat_jpu.c
new file mode 100644
index 00000000..fb5d79f
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/compat_jpu.c
@@ -0,0 +1,324 @@
+/*
+ * drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/compat.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#include "jpu.h"
+#include "compat_jpu.h"
+
+/* See drivers/soc/realtek/rtd129x/rtk_ve/jdi/jpu.h for the definition of these structs */
+typedef struct compat_jpudrv_buffer_t {
+    compat_uint_t size;
+    compat_ulong_t phys_addr;
+    compat_ulong_t base;							/* kernel logical address in use kernel */
+    compat_ulong_t virt_addr;				/* virtual user space address */
+} compat_jpudrv_buffer_t;
+
+typedef struct compat_jpudrv_intr_info_t {
+    compat_uint_t timeout;
+    compat_int_t intr_reason;
+} compat_jpudrv_intr_info_t;
+
+typedef struct compat_jpudrv_dovi_info_t{
+	compat_uint_t inst_idx;
+	compat_uint_t enable;
+} compat_jpudrv_dovi_info_t;
+
+#define COMPAT_JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(JDI_IOCTL_MAGIC, 0)
+#define COMPAT_JDI_IOCTL_FREE_PHYSICALMEMORY _IO(JDI_IOCTL_MAGIC, 1)
+#define COMPAT_JDI_IOCTL_WAIT_INTERRUPT _IO(JDI_IOCTL_MAGIC, 2)
+#define COMPAT_JDI_IOCTL_GET_INSTANCE_POOL _IO(JDI_IOCTL_MAGIC, 5)
+#define COMPAT_JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(JDI_IOCTL_MAGIC, 6)
+#define COMPAT_JDI_IOCTL_GET_REGISTER_INFO _IO(JDI_IOCTL_MAGIC, 11)
+#define COMPAT_JDI_IOCTL_GET_BONDING_INFO _IO(JDI_IOCTL_MAGIC, 13)
+#define COMPAT_JDI_IOCTL_SET_RTK_DOVI_FLAG _IO(JDI_IOCTL_MAGIC, 14)
+
+static int compat_get_jpu_buffer_data(
+    compat_jpudrv_buffer_t __user *data32,
+    jpudrv_buffer_t __user *data)
+{
+    compat_uint_t s;
+    compat_ulong_t p;
+    compat_ulong_t b;
+    compat_ulong_t v;
+    int err;
+
+    err = get_user(s, &data32->size);
+    err |= put_user(s, &data->size);
+    err |= get_user(p, &data32->phys_addr);
+    err |= put_user(p, &data->phys_addr);
+    err |= get_user(b, &data32->base);
+    err |= put_user(b, &data->base);
+    err |= get_user(v, &data32->virt_addr);
+    err |= put_user(v, &data->virt_addr);
+
+    return err;
+}
+
+static int compat_get_jpu_intr_info_data(
+    compat_jpudrv_intr_info_t __user *data32,
+    jpudrv_intr_info_t __user *data)
+{
+    compat_uint_t t;
+    compat_int_t i;
+    int err;
+
+    err = get_user(t, &data32->timeout);
+    err |= put_user(t, &data->timeout);
+    err |= get_user(i, &data32->intr_reason);
+    err |= put_user(i, &data->intr_reason);
+
+    return err;
+}
+
+static int compat_get_jpu_dovi_info(
+	compat_jpudrv_dovi_info_t __user *data32,
+	jpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t e;
+	compat_uint_t i;
+	int err;
+
+	err |= get_user(i, &data32->inst_idx);
+	err |= put_user(i, &data->inst_idx);
+	err |= get_user(e, &data32->enable);
+	err |= put_user(e, &data->enable);
+
+	return err;
+}
+
+static int compat_put_jpu_buffer_data(
+    compat_jpudrv_buffer_t __user *data32,
+    jpudrv_buffer_t __user *data)
+{
+    compat_uint_t s;
+    compat_ulong_t p;
+    compat_ulong_t b;
+    compat_ulong_t v;
+    int err;
+
+    err = get_user(s, &data->size);
+    err |= put_user(s, &data32->size);
+    err |= get_user(p, &data->phys_addr);
+    err |= put_user(p, &data32->phys_addr);
+    err |= get_user(b, &data->base);
+    err |= put_user(b, &data32->base);
+    err |= get_user(v, &data->virt_addr);
+    err |= put_user(v, &data32->virt_addr);
+
+    return err;
+}
+
+static int compat_put_jpu_intr_info_data(
+    compat_jpudrv_intr_info_t __user *data32,
+    jpudrv_intr_info_t __user *data)
+{
+    compat_uint_t t;
+    compat_int_t i;
+    int err;
+
+    err = get_user(t, &data->timeout);
+    err |= put_user(t, &data32->timeout);
+    err |= get_user(i, &data->intr_reason);
+    err |= put_user(i, &data32->intr_reason);
+
+    return err;
+}
+
+static int compat_put_jpu_dovi_info(
+	compat_jpudrv_dovi_info_t __user *data32,
+	jpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t i;
+	compat_uint_t e;
+	int err;
+
+	err |= get_user(i, &data->inst_idx);
+	err |= put_user(i, &data32->inst_idx);
+	err |= get_user(e, &data->enable);
+	err |= put_user(e, &data32->enable);
+
+	return err;
+}
+
+long compat_jpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+    long ret = 0;
+
+    if (!filp->f_op->unlocked_ioctl)
+        return -ENOTTY;
+
+    switch (cmd)
+    {
+    case COMPAT_JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_FREE_PHYSICALMEMORY:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+
+        return filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_FREE_PHYSICALMEMORY, (unsigned long)data);
+    }
+
+    case COMPAT_JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_WAIT_INTERRUPT:
+    {
+        compat_jpudrv_intr_info_t __user *data32;
+        jpudrv_intr_info_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_intr_info_data(data32, data);
+        if (err)
+            return err;
+
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_WAIT_INTERRUPT, (unsigned long)data);
+        err = compat_put_jpu_intr_info_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case JDI_IOCTL_ENABLE_INTERRUPT:
+    case JDI_IOCTL_SET_CLOCK_GATE:
+    case JDI_IOCTL_OPEN_INSTANCE:
+    case JDI_IOCTL_CLOSE_INSTANCE:
+    case JDI_IOCTL_GET_INSTANCE_NUM:
+    case JDI_IOCTL_RESET:
+    case JDI_IOCTL_SET_CLOCK_ENABLE:
+    {
+        return filp->f_op->unlocked_ioctl(filp, cmd,
+                                          (unsigned long)compat_ptr(arg));
+    }
+
+    case COMPAT_JDI_IOCTL_GET_INSTANCE_POOL:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_INSTANCE_POOL, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+    case COMPAT_JDI_IOCTL_GET_REGISTER_INFO:
+    case COMPAT_JDI_IOCTL_GET_BONDING_INFO:
+    {
+        compat_jpudrv_buffer_t __user *data32;
+        jpudrv_buffer_t __user *data;
+        int err;
+
+        data32 = compat_ptr(arg);
+        data = compat_alloc_user_space(sizeof(*data));
+        if (data == NULL)
+            return -EFAULT;
+
+        err = compat_get_jpu_buffer_data(data32, data);
+        if (err)
+            return err;
+        if (cmd == COMPAT_JDI_IOCTL_GET_REGISTER_INFO)
+            ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_REGISTER_INFO, (unsigned long)data);
+        else
+            ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_GET_BONDING_INFO, (unsigned long)data);
+        err = compat_put_jpu_buffer_data(data32, data);
+        return ret ? ret : err;
+    }
+
+	case COMPAT_JDI_IOCTL_SET_RTK_DOVI_FLAG:
+	{
+		compat_jpudrv_dovi_info_t __user *data32;
+		jpudrv_dovi_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_jpu_dovi_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, JDI_IOCTL_SET_RTK_DOVI_FLAG, (unsigned long)data);
+		err = compat_put_jpu_dovi_info(data32, data);
+		return ret ? ret : err;
+	}
+
+    default:
+    {
+        printk(KERN_ERR "[COMPAT JPU]No such IOCTL, cmd is %d\n", cmd);
+        return -ENOIOCTLCMD;
+    }
+    }
+}
+
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/compat_jpu.h b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/compat_jpu.h
new file mode 100644
index 00000000..2d920c9
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/compat_jpu.h
@@ -0,0 +1,31 @@
+/*
+
+ * drivers/soc/realtek/rtd129x/rtk_ve/jdi/compat_jpu.h
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_COMPAT_JPU_H
+#define _LINUX_COMPAT_JPU_H
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+long compat_jpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+
+#else
+
+#define compat_jpu_ioctl  NULL
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_JPU_H */
+
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/jmm.h b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/jmm.h
new file mode 100644
index 00000000..e54a228
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/jmm.h
@@ -0,0 +1,647 @@
+#ifndef __JPU_MM_H__
+#define __JPU_MM_H__
+
+
+typedef unsigned long long  jmem_key_t;
+
+#define JMEM_PAGE_SIZE           (16*1024)
+#define MAKE_KEY(_a, _b)        (((jmem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key)      (_key>>32)
+
+typedef struct page_struct {
+    int             pageno;
+    unsigned long   addr;
+    int             used;
+    int             alloc_pages;
+    int             first_pageno;
+} page_t;
+
+
+typedef struct avl_node_struct {
+    jmem_key_t   key;
+    int     height;
+    page_t* page;
+    struct avl_node_struct* left;
+    struct avl_node_struct* right;
+} avl_node_t;
+
+
+typedef struct _jpu_mm_struct {
+    avl_node_t*     free_tree;
+    avl_node_t*     alloc_tree;
+    page_t*         page_list;
+    int             num_pages;
+    unsigned long   base_addr;
+    unsigned long   mem_size;
+    int             free_page_count;
+    int             alloc_page_count;
+} jpu_mm_t;
+
+
+
+#define VMEM_P_ALLOC(_x)         kmalloc(_x, GFP_KERNEL)
+#define VMEM_P_FREE(_x)          kfree(_x)
+
+#define VMEM_ASSERT(_exp)        if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/
+}
+#define VMEM_HEIGHT(_tree)       (_tree==NULL ? -1 : _tree->height)
+
+
+#define MAX(_a, _b)         (_a >= _b ? _a : _b)
+
+typedef enum {
+    LEFT,
+    RIGHT
+} rotation_dir_t;
+
+
+
+typedef struct avl_node_data_struct {
+    int     key;
+    page_t* page;
+} avl_node_data_t;
+
+static avl_node_t*
+make_avl_node(
+    jmem_key_t key,
+    page_t* page
+)
+{
+    avl_node_t* node = (avl_node_t*)VMEM_P_ALLOC(sizeof(avl_node_t));
+    node->key     = key;
+    node->page    = page;
+    node->height  = 0;
+    node->left    = NULL;
+    node->right   = NULL;
+
+    return node;
+}
+
+
+static int
+get_balance_factor(
+    avl_node_t* tree
+)
+{
+    int factor = 0;
+    if (tree) {
+        factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+    }
+
+    return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *      A                      B
+ *       \                    / \
+ *        B         =>       A   C
+ *       /  \                 \
+ *      D    C                 D
+ *
+ */
+static avl_node_t*
+rotation_left(
+    avl_node_t* tree
+)
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    rchild = tree->right;
+    if (rchild == NULL) {
+        return tree;
+    }
+
+    lchild = rchild->left;
+    rchild->left = tree;
+    tree->right = lchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+    return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *         A                  B
+ *       \                  /  \
+ *      B         =>       D    A
+ *    /  \                     /
+ *   D    C                   C
+ *
+ */
+static avl_node_t*
+rotation_right(
+    avl_node_t* tree
+)
+{
+    avl_node_t* rchild;
+    avl_node_t* lchild;
+
+    if (tree == NULL) return NULL;
+
+    lchild = tree->left;
+    if (lchild == NULL) return NULL;
+
+    rchild = lchild->right;
+    lchild->right = tree;
+    tree->left = rchild;
+
+    tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+    return lchild;
+}
+
+static avl_node_t*
+do_balance(
+    avl_node_t* tree
+)
+{
+    int bfactor = 0, child_bfactor;       /* balancing factor */
+
+    bfactor = get_balance_factor(tree);
+
+    if (bfactor >= 2) {
+        child_bfactor = get_balance_factor(tree->right);
+        if (child_bfactor == 1 || child_bfactor == 0) {
+            tree = rotation_left(tree);
+        } else if (child_bfactor == -1) {
+            tree->right = rotation_right(tree->right);
+            tree        = rotation_left(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    } else if (bfactor <= -2) {
+        child_bfactor = get_balance_factor(tree->left);
+        if (child_bfactor == -1 || child_bfactor == 0) {
+            tree = rotation_right(tree);
+        } else if (child_bfactor == 1) {
+            tree->left = rotation_left(tree->left);
+            tree       = rotation_right(tree);
+        } else {
+            printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+            VMEM_ASSERT(0);
+            return NULL;
+        }
+    }
+
+    return tree;
+}
+static avl_node_t*
+unlink_end_node(
+    avl_node_t* tree,
+    int dir,
+    avl_node_t** found_node
+)
+{
+    avl_node_t* node;
+    *found_node = NULL;
+
+    if (tree == NULL) return NULL;
+
+    if (dir == LEFT) {
+        if (tree->left == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    } else {
+        if (tree->right == NULL) {
+            *found_node = tree;
+            return NULL;
+        }
+    }
+
+    if (dir == LEFT) {
+        node = tree->left;
+        tree->left = unlink_end_node(tree->left, LEFT, found_node);
+        if (tree->left == NULL) {
+            tree->left = (*found_node)->right;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    } else {
+        node = tree->right;
+        tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+        if (tree->right == NULL) {
+            tree->right = (*found_node)->left;
+            (*found_node)->left  = NULL;
+            (*found_node)->right = NULL;
+        }
+    }
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return do_balance(tree);
+}
+
+
+static avl_node_t*
+avltree_insert(
+    avl_node_t* tree,
+    jmem_key_t key,
+    page_t* page
+)
+{
+    if (tree == NULL) {
+        tree = make_avl_node(key, page);
+    } else {
+        if (key >= tree->key) {
+            tree->right = avltree_insert(tree->right, key, page);
+        } else {
+            tree->left  = avltree_insert(tree->left, key, page);
+        }
+    }
+
+    tree = do_balance(tree);
+
+    tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    return tree;
+}
+
+static avl_node_t*
+do_unlink(
+    avl_node_t* tree
+)
+{
+    avl_node_t* node;
+    avl_node_t* end_node;
+    node = unlink_end_node(tree->right, LEFT, &end_node);
+    if (node) {
+        tree->right = node;
+    } else {
+        node = unlink_end_node(tree->left, RIGHT, &end_node);
+        if (node) tree->left = node;
+    }
+
+    if (node == NULL) {
+        node = tree->right ? tree->right : tree->left;
+        end_node = node;
+    }
+
+    if (end_node) {
+        end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+        end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+        end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+    }
+
+    tree = end_node;
+
+    return tree;
+}
+
+static avl_node_t*
+avltree_remove(
+    avl_node_t* tree,
+    avl_node_t** found_node,
+    jmem_key_t key
+)
+{
+    *found_node = NULL;
+    if (tree == NULL) {
+        printk(KERN_INFO "failed to find key %d\n", (int)key);
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found_node = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = avltree_remove(tree->right, found_node, key);
+    } else {
+        tree->left  = avltree_remove(tree->left, found_node, key);
+    }
+
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+void
+jpu_avltree_free(
+    avl_node_t* tree
+)
+{
+    if (tree == NULL) return;
+    if (tree->left == NULL && tree->right == NULL) {
+        VMEM_P_FREE(tree);
+        return;
+    }
+
+    jpu_avltree_free(tree->left);
+    tree->left = NULL;
+    jpu_avltree_free(tree->right);
+    tree->right = NULL;
+}
+
+
+
+
+static avl_node_t*
+remove_approx_value(
+    avl_node_t* tree,
+    avl_node_t** found,
+    jmem_key_t key
+)
+{
+    *found = NULL;
+    if (tree == NULL) {
+        return NULL;
+    }
+
+    if (key == tree->key) {
+        *found = tree;
+        tree = do_unlink(tree);
+    } else if (key > tree->key) {
+        tree->right = remove_approx_value(tree->right, found, key);
+    } else {
+        tree->left  = remove_approx_value(tree->left, found, key);
+        if (*found == NULL) {
+            *found = tree;
+            tree = do_unlink(tree);
+        }
+    }
+    if (tree) tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+    tree = do_balance(tree);
+
+    return tree;
+}
+
+static void
+set_blocks_free(
+    jpu_mm_t *mm,
+    int pageno,
+    int npages
+)
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    VMEM_ASSERT(npages);
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+    last_page   = &mm->page_list[last_pageno];
+    last_page->first_pageno = pageno;
+
+    mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void
+set_blocks_alloc(
+    jpu_mm_t *mm,
+    int pageno,
+    int npages
+)
+{
+    int last_pageno     = pageno + npages - 1;
+    int i;
+    page_t* page;
+    page_t* last_page;
+
+    if (last_pageno >= mm->num_pages) {
+        printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+        VMEM_ASSERT(0);
+        return;
+    }
+
+    for (i=pageno; i<=last_pageno; i++) {
+        mm->page_list[i].used         = 1;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    page        = &mm->page_list[pageno];
+    page->alloc_pages = npages;
+
+    last_page   = &mm->page_list[last_pageno];
+    last_page->first_pageno = pageno;
+
+    mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int
+jmem_init(
+    jpu_mm_t* mm,
+    unsigned long addr,
+    unsigned long size
+)
+{
+    int i;
+
+
+    mm->base_addr  = (addr+(JMEM_PAGE_SIZE-1))&~(JMEM_PAGE_SIZE-1);
+    mm->mem_size   = size&~JMEM_PAGE_SIZE;
+    mm->num_pages  = mm->mem_size/JMEM_PAGE_SIZE;
+    mm->page_list  = (page_t*)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = mm->num_pages;
+    mm->alloc_page_count = 0;
+
+    for (i=0; i<mm->num_pages; i++) {
+        mm->page_list[i].pageno       = i;
+        mm->page_list[i].addr         = mm->base_addr + i*JMEM_PAGE_SIZE;
+        mm->page_list[i].alloc_pages  = 0;
+        mm->page_list[i].used         = 0;
+        mm->page_list[i].first_pageno = -1;
+    }
+
+    set_blocks_free(mm, 0, mm->num_pages);
+
+    return 0;
+}
+
+int
+jmem_exit(
+    jpu_mm_t* mm
+)
+{
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_exit: invalid handle\n");
+        return -1;
+    }
+
+    if (mm->free_tree) {
+        jpu_avltree_free(mm->free_tree);
+    }
+    if (mm->alloc_tree) {
+        jpu_avltree_free(mm->alloc_tree);
+    }
+
+    VMEM_P_FREE(mm->page_list);
+
+    mm->base_addr  = 0;
+    mm->mem_size   = 0;
+    mm->num_pages  = 0;
+    mm->page_list  = NULL;
+    mm->free_tree  = NULL;
+    mm->alloc_tree = NULL;
+    mm->free_page_count = 0;
+    mm->alloc_page_count = 0;
+    return 0;
+}
+
+unsigned long
+jmem_alloc(
+    jpu_mm_t* mm,
+    int size,
+    unsigned long pid
+)
+{
+    avl_node_t* node;
+    page_t*     free_page;
+    int         npages, free_size;
+    int         alloc_pageno;
+    unsigned long  ptr;
+
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_alloc: invalid handle\n");
+        return -1;
+    }
+
+    if (size <= 0) return -1;
+
+    npages = (size + JMEM_PAGE_SIZE -1)/JMEM_PAGE_SIZE;
+
+    mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+    if (node == NULL) {
+        return -1;
+    }
+    free_page = node->page;
+    free_size = KEY_TO_VALUE(node->key);
+
+    alloc_pageno = free_page->pageno;
+    set_blocks_alloc(mm, alloc_pageno, npages);
+    if (npages != free_size) {
+        int free_pageno = alloc_pageno + npages;
+        set_blocks_free(mm, free_pageno, (free_size-npages));
+    }
+
+    VMEM_P_FREE(node);
+
+    ptr = mm->page_list[alloc_pageno].addr;
+    mm->alloc_page_count += npages;
+    mm->free_page_count  -= npages;
+
+
+    return ptr;
+}
+
+int
+jmem_free(
+    jpu_mm_t* mm,
+    unsigned long ptr,
+    unsigned long pid
+)
+{
+    unsigned long addr;
+    avl_node_t* found;
+    page_t* page;
+    int pageno, prev_free_pageno, next_free_pageno;
+    int prev_size, next_size;
+    int merge_page_no, merge_page_size, free_page_size;
+
+
+    if (mm == NULL) {
+        printk(KERN_INFO "vmem_free: invalid handle\n");
+        return -1;
+    }
+
+    addr = ptr;
+
+    mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+    if (found == NULL) {
+        printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+        VMEM_ASSERT(0);
+        return -1;
+    }
+
+    /* find previous free block */
+    page = found->page;
+    pageno = page->pageno;
+    free_page_size = page->alloc_pages;
+    prev_free_pageno = pageno-1;
+    prev_size = -1;
+    if (prev_free_pageno >= 0) {
+        if (mm->page_list[prev_free_pageno].used == 0) {
+            prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+            prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+        }
+    }
+
+    /* find next free block */
+    next_free_pageno = pageno + page->alloc_pages;
+    next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+    next_size = -1;
+    if (next_free_pageno >= 0) {
+        if (mm->page_list[next_free_pageno].used == 0) {
+            next_size = mm->page_list[next_free_pageno].alloc_pages;
+        }
+    }
+    VMEM_P_FREE(found);
+
+    /* merge */
+    merge_page_no = page->pageno;
+    merge_page_size = page->alloc_pages;
+    if (prev_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_no = found->page->pageno;
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+    if (next_size >= 0) {
+        mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+        if (found == NULL) {
+            VMEM_ASSERT(0);
+            return -1;
+        }
+        merge_page_size += found->page->alloc_pages;
+        VMEM_P_FREE(found);
+    }
+
+    page->alloc_pages  = 0;
+    page->first_pageno = -1;
+
+    set_blocks_free(mm, merge_page_no, merge_page_size);
+
+    mm->alloc_page_count -= free_page_size;
+    mm->free_page_count  += free_page_size;
+
+    return 0;
+}
+
+
+
+#endif /* __JPU_MM_H__ */
\ No newline at end of file
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/jpu.c b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/jpu.c
new file mode 100644
index 00000000..a04d839
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/jpu.c
@@ -0,0 +1,1104 @@
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+
+#include "jpu.h"
+#include "compat_jpu.h"
+#include "../puwrap.h"
+
+//from jpuconfig.h
+#define MAX_NUM_INSTANCE 8
+#define MAX_INST_HANDLE_SIZE (12*1024)
+
+/* definitions to be changed as customer  configuration */
+//#define JPU_SUPPORT_CLOCK_CONTROL /if you want to have clock gating scheme frame by frame
+#define JPU_SUPPORT_ISR
+/* if the platform driver knows the name of this driver. JPU_PLATFORM_DEVICE_NAME */
+#define JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+#ifndef CONFIG_RTK_RESERVE_MEMORY
+/* if this driver knows the dedicated video memory address */
+//#define JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#endif
+//#define JPU_IRQ_CONTROL
+#ifdef JPU_FRAGMENT_FRAME_BITSTREAM
+#define JPU_IRQ_CONTROL
+#endif
+#define DEV_NAME "[RTK_JPU]"
+#define JPU_PLATFORM_DEVICE_NAME "jdec"
+#define JPU_CLK_NAME "jpeg"
+#define JPU_DEV_NAME "jpu"
+
+#define JPU_BASE_ADDR 0x9803e000
+#define JPU_REG_SIZE 0x1000
+
+#ifdef JPU_SUPPORT_ISR
+#define JPU_IRQ_NUM 84+32
+#endif
+
+#ifndef VM_RESERVED /* for kernel up to 3.7.0 version */
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+typedef struct jpu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long interrupt_reason;
+} jpu_drv_context_t;
+
+/* To track the allocated memory buffer */
+typedef struct jpudrv_buffer_pool_t {
+	struct list_head list;
+	struct jpudrv_buffer_t jb;
+	struct file *filp;
+} jpudrv_buffer_pool_t;
+
+/* To track the instance index and buffer in instance pool */
+typedef struct jpudrv_instanace_list_t {
+	struct list_head list;
+	unsigned long inst_idx;
+	struct file *filp;
+} jpudrv_instanace_list_t;
+
+typedef struct jpudrv_instance_pool_t {
+	unsigned char jpgInstPool[MAX_NUM_INSTANCE][MAX_INST_HANDLE_SIZE];
+} jpudrv_instance_pool_t;
+
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#define JPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)
+#define JPU_DRAM_PHYSICAL_BASE (0x8AA00000)
+#include "jmm.h"
+static jpu_mm_t s_jmem;
+static jpudrv_buffer_t s_image_memory = {0};
+#endif
+
+static int jpu_hw_reset(void);
+static void jpu_clk_disable(struct clk *clk);
+static int jpu_clk_enable(struct clk *clk);
+static struct clk *jpu_clk_get(struct device *dev);
+static void jpu_clk_put(struct clk *clk);
+// end customer definition
+
+static jpudrv_buffer_t s_jpu_instance_pool = {0};
+static jpu_drv_context_t s_jpu_drv_context;
+static struct miscdevice s_jpu_dev;
+static int s_jpu_open_count;
+static struct clk *s_jpu_clk;
+static struct reset_control *rstc_jpeg = NULL;
+#ifdef JPU_SUPPORT_ISR
+static int s_jpu_irq = JPU_IRQ_NUM;
+static atomic_t s_interrupt_flag;
+#endif
+static unsigned long s_jpu_reg_phy_base = JPU_BASE_ADDR;
+static void __iomem *s_jpu_reg_virt_base;
+static jpudrv_buffer_t s_jpu_register = {0};
+static jpudrv_buffer_t s_bonding_register = {0};
+
+static unsigned long s_jpu_pll_phy_base = 0;
+static void __iomem *s_jpu_pll_virt_base = NULL;
+static unsigned long s_jpu_pll_size = 0;
+
+static wait_queue_head_t s_interrupt_wait_q;
+static int dbus_en = 1;
+
+#define JPEG_DBUS_REG (0x0000 + 0xF00)
+
+static spinlock_t s_jpu_lock = __SPIN_LOCK_UNLOCKED(s_jpu_lock);
+static DEFINE_SEMAPHORE(s_jpu_sem);
+static struct list_head s_jbp_head = LIST_HEAD_INIT(s_jbp_head);
+static struct list_head s_jpu_inst_list_head = LIST_HEAD_INIT(s_jpu_inst_list_head);
+
+/* implement to power management functions */
+#define ReadJpuRegister(addr) *(volatile unsigned int *)(s_jpu_reg_virt_base + addr)
+#define WriteJpuRegister(addr, val) *(volatile unsigned int *)(s_jpu_reg_virt_base + addr) = (unsigned int)val;
+
+#if 0 /* Fuchun disable 20160204, set clock gating by jdi.c */
+static void jpu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable)
+{
+	if (s_jpu_pll_phy_base == 0 || s_jpu_pll_virt_base == 0 || s_jpu_pll_size == 0) {
+		pr_warn("%s In[%s][%d] didn't get pll register\n", DEV_NAME, __FUNCTION__, __LINE__);
+		return;
+	} else if (offset > s_jpu_pll_size) {
+		pr_warn("%s In[%s][%d] offset over than register size\n", DEV_NAME, __FUNCTION__, __LINE__);
+		return;
+	}
+
+	if (bOverwrite == 1) {
+		__raw_writel(value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+	} else {
+		if (bEnable)
+			__raw_writel(__raw_readl((volatile u8 *)(s_jpu_pll_virt_base+offset)) | value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+		else
+			__raw_writel(__raw_readl((volatile u8 *)(s_jpu_pll_virt_base+offset)) & value, (volatile u8 *)(s_jpu_pll_virt_base+offset));
+	}
+}
+#endif
+
+static int jpu_alloc_dma_buffer(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	jb->phys_addr = (unsigned long)jmem_alloc(&s_jmem, jb->size, 0);
+
+	if ((unsigned long)jb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+
+	jb->base = (unsigned long)(s_image_memory.base + (jb->phys_addr - s_image_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	unsigned int ret;
+	ret = pu_alloc_dma_buffer(jb->size, &jb->phys_addr, &jb->base, 0);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#else
+	jb->base = (unsigned long)dma_alloc_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (dma_addr_t *) (&jb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#endif
+//	pr_info("%s base:0x%08x, phy_addr:0x%08x, size:%d\n", DEV_NAME, (unsigned int)jb->base, (unsigned int)jb->phys_addr, jb->size);
+	return 0;
+}
+
+static int jpu_alloc_dma_buffer2(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	jb->phys_addr = (unsigned long)jmem_alloc(&s_jmem, jb->size, 0);
+
+	if ((unsigned long)jb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+
+	jb->base = (unsigned long)(s_image_memory.base + (jb->phys_addr - s_image_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	unsigned int ret;
+	ret = pu_alloc_dma_buffer(jb->size, &jb->phys_addr, &jb->base, 0);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+	jb->base = pu_mmap_kernel_buffer(jb->phys_addr, jb->size);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s pu_mmap_kernel_buffer error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#else
+	jb->base = (unsigned long)dma_alloc_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (dma_addr_t *) (&jb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(jb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, jb->size);
+		return -1;
+	}
+#endif
+//	pr_info("%s base:0x%08x, phy_addr:0x%08x, size:%d\n", DEV_NAME, (unsigned int)jb->base, (unsigned int)jb->phys_addr, jb->size);
+	return 0;
+}
+
+static void jpu_free_dma_buffer(jpudrv_buffer_t *jb)
+{
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (jb->base)
+		jmem_free(&s_jmem, jb->phys_addr, 0);
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	pu_free_dma_buffer(jb->base, jb->phys_addr);
+#else
+	if (jb->base)
+		dma_free_coherent(s_jpu_dev.this_device, PAGE_ALIGN(jb->size), (void *)jb->base, jb->phys_addr);
+#endif
+}
+
+static int jpu_free_instances(struct file *filp)
+{
+	u32 inst_idx;
+	jpudrv_instanace_list_t *jil, *n;
+	jpudrv_instance_pool_t *jip;
+	void *jip_base;
+	void* jdi_mutex_base;
+	const unsigned int PTHREAD_MUTEX_T_DESTROY_VALUE = 0xdead10cc;
+
+	list_for_each_entry_safe(jil, n, &s_jpu_inst_list_head, list) {
+		if (jil->filp == filp) {
+			int i;
+			for (i = 0; i < MAX_NUM_INSTANCE; i++) /* reset dovi flag */
+			{
+				pu_set_dovi_flag(2, i, 0);
+			}
+
+			inst_idx = jil->inst_idx;
+			jip_base = (void *)(s_jpu_instance_pool.base);
+			jip = (jpudrv_instance_pool_t *)jip_base;
+			if (jip) {
+				memset(&jip->jpgInstPool[inst_idx], 0x00, 4);	// only first 4 byte is key point to free the corresponding instance.
+#define PTHREAD_MUTEX_T_HANDLE_SIZE 40
+				jdi_mutex_base = (jip_base + (s_jpu_instance_pool.size - PTHREAD_MUTEX_T_HANDLE_SIZE));
+				if (jdi_mutex_base) {
+					memcpy(jdi_mutex_base, &PTHREAD_MUTEX_T_DESTROY_VALUE, PTHREAD_MUTEX_T_HANDLE_SIZE);
+				}
+			}
+			s_jpu_open_count--;
+			list_del(&jil->list);
+			kfree(jil);
+		}
+	}
+
+	return s_jpu_open_count;
+}
+
+static int jpu_free_buffers(struct file *filp)
+{
+	jpudrv_buffer_pool_t *pool, *n;
+	jpudrv_buffer_t jb;
+
+	list_for_each_entry_safe(pool, n, &s_jbp_head, list) {
+		if (pool->filp == filp) {
+			jb = pool->jb;
+			if (jb.base) {
+				jpu_free_dma_buffer(&jb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+
+	return 0;
+}
+
+#ifdef JPU_SUPPORT_ISR
+static irqreturn_t jpu_irq_handler(int irq, void *dev_id)
+{
+	jpu_drv_context_t *dev = (jpu_drv_context_t *)dev_id;
+#ifdef JPU_FRAGMENT_FRAME_BITSTREAM
+	unsigned long value = 0;
+
+	value = ReadJpuRegister(0x004); /* MJPEG_PIC_STATUS_REG */
+	if(value == 0)
+		return IRQ_HANDLED;
+#endif
+
+#ifdef JPU_IRQ_CONTROL
+	disable_irq_nosync(s_jpu_irq);
+#endif
+
+#ifdef JPU_FRAGMENT_FRAME_BITSTREAM
+	dev->interrupt_reason = value;
+#else
+	dev->interrupt_reason = ReadJpuRegister(0x004); /* MJPEG_PIC_STATUS_REG */
+	WriteJpuRegister(0x004, dev->interrupt_reason);
+#endif
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN); /* notify the interrupt to userspace */
+
+	atomic_set(&s_interrupt_flag, 1);
+
+	//pr_info("%s jpu_irq_handler\n", DEV_NAME);
+	wake_up_interruptible(&s_interrupt_wait_q);
+
+	return IRQ_HANDLED;
+}
+#endif
+
+static int jpu_open(struct inode *inode, struct file *filp)
+{
+	spin_lock(&s_jpu_lock);
+
+	filp->private_data = (void *)(&s_jpu_drv_context);
+	spin_unlock(&s_jpu_lock);
+	return 0;
+}
+
+static long jpu_ioctl(struct file *filp, u_int cmd, u_long arg)
+{
+	int ret = 0;
+	struct jpu_drv_context_t *dev = (struct jpu_drv_context_t *)filp->private_data;
+	jpudrv_buffer_pool_t *jbp;
+	jpudrv_buffer_pool_t *n;
+	jpudrv_buffer_t jb;
+	jpudrv_intr_info_t info;
+	jpudrv_instanace_list_t *jil;
+	jpudrv_instanace_list_t *tmp;
+	jpudrv_dovi_info_t doviInfo;
+	u32 inst_idx;
+	u32 clkgate;
+	u32 val;
+
+	switch (cmd) {
+	case JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+		down(&s_jpu_sem);
+
+		jbp = kzalloc(sizeof(*jbp), GFP_KERNEL);
+		if (!jbp) {
+			up(&s_jpu_sem);
+			return -ENOMEM;
+		}
+
+		ret = copy_from_user(&(jbp->jb), (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+		if (ret) {
+			kfree(jbp);
+			up(&s_jpu_sem);
+			return -EFAULT;
+		}
+
+		ret = jpu_alloc_dma_buffer(&(jbp->jb));
+		if (ret == -1) {
+			ret = -ENOMEM;
+			kfree(jbp);
+			up(&s_jpu_sem);
+			break;
+		}
+
+		ret = copy_to_user((void __user *)arg, &(jbp->jb), sizeof(jpudrv_buffer_t));
+		if (ret) {
+			kfree(jbp);
+			ret = -EFAULT;
+			up(&s_jpu_sem);
+			break;
+		}
+
+		jbp->filp = filp;
+		spin_lock(&s_jpu_lock);
+		list_add(&jbp->list, &s_jbp_head);
+		spin_unlock(&s_jpu_lock);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_FREE_PHYSICALMEMORY:
+		down(&s_jpu_sem);
+
+		ret = copy_from_user(&jb, (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+		if (ret) {
+			up(&s_jpu_sem);
+			return -EACCES;
+		}
+
+		if (jb.base)
+			jpu_free_dma_buffer(&jb);
+
+		spin_lock(&s_jpu_lock);
+		list_for_each_entry_safe(jbp, n, &s_jbp_head, list) {
+			if (jbp->jb.phys_addr == jb.phys_addr) {
+				list_del(&jbp->list);
+				kfree(jbp);
+				break;
+			}
+		}
+		spin_unlock(&s_jpu_lock);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+		if (s_image_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_image_memory, sizeof(jpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = -EFAULT;
+		}
+#endif
+		break;
+#ifdef JPU_SUPPORT_ISR
+	case JDI_IOCTL_WAIT_INTERRUPT:
+		ret = copy_from_user(&info, (jpudrv_intr_info_t*)arg, sizeof(jpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		smp_rmb();
+		ret = wait_event_interruptible_timeout(s_interrupt_wait_q, atomic_read(&s_interrupt_flag) != 0, msecs_to_jiffies(info.timeout));
+		if (!ret) {
+			ret = -ETIME;
+			//pr_info("%s JDI_IOCTL_WAIT_INTERRUPT fail\n", DEV_NAME);
+			break;
+		}
+
+		if (signal_pending(current)) {
+			ret = -ERESTARTSYS;
+			break;
+		}
+
+		atomic_set(&s_interrupt_flag, 0);
+		info.intr_reason = dev->interrupt_reason;
+		ret = copy_to_user((void __user *)arg, &info, sizeof(jpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		//pr_info("%s JDI_IOCTL_WAIT_INTERRUPT done, info.intr_reason:0x%x\n", DEV_NAME, info.intr_reason);
+		break;
+#endif /* JPU_SUPPORT_ISR */
+	case JDI_IOCTL_ENABLE_INTERRUPT:
+#ifdef JPU_IRQ_CONTROL
+		enable_irq(s_jpu_irq);
+#endif
+		break;
+	case JDI_IOCTL_SET_CLOCK_GATE:
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+
+#ifdef JPU_SUPPORT_CLOCK_CONTROL
+		if (clkgate)
+			jpu_clk_enable(s_jpu_clk);
+		else
+			jpu_clk_disable(s_jpu_clk);
+#endif
+
+		break;
+	case JDI_IOCTL_GET_INSTANCE_POOL:
+		down(&s_jpu_sem);
+
+		if (s_jpu_instance_pool.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_jpu_instance_pool, sizeof(jpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = copy_from_user(&s_jpu_instance_pool, (jpudrv_buffer_t *)arg, sizeof(jpudrv_buffer_t));
+			if (ret == 0) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+				s_jpu_instance_pool.size = PAGE_ALIGN(s_jpu_instance_pool.size);
+				s_jpu_instance_pool.base = (unsigned long)vmalloc(s_jpu_instance_pool.size);
+				s_jpu_instance_pool.phys_addr = s_jpu_instance_pool.base;
+
+				if (s_jpu_instance_pool.base != 0)
+#else
+				if (jpu_alloc_dma_buffer2(&s_jpu_instance_pool) != -1)
+#endif
+				{
+					memset((void *)s_jpu_instance_pool.base, 0x0, s_jpu_instance_pool.size);
+					ret = copy_to_user((void __user *)arg, &s_jpu_instance_pool, sizeof(jpudrv_buffer_t));
+					if (ret == 0) {
+						// success to get memory for instance pool
+						up(&s_jpu_sem);
+						break;
+					}
+				}
+			}
+			ret = -EFAULT;
+		}
+		up(&s_jpu_sem);
+
+		break;
+	case JDI_IOCTL_OPEN_INSTANCE:
+		jil = kzalloc(sizeof(*jil), GFP_KERNEL);
+		if (!jil)
+			return -ENOMEM;
+
+		if (get_user(inst_idx, (u32 __user *) arg))
+			return -EFAULT;
+
+		jil->inst_idx = inst_idx;
+		jil->filp = filp;
+		spin_lock(&s_jpu_lock);
+		list_add(&jil->list, &s_jpu_inst_list_head);
+		s_jpu_open_count++;
+		spin_unlock(&s_jpu_lock);
+		break;
+	case JDI_IOCTL_CLOSE_INSTANCE:
+		if (get_user(inst_idx, (u32 __user *) arg))
+			return -EFAULT;
+
+		spin_lock(&s_jpu_lock);
+
+		list_for_each_entry_safe(jil, tmp, &s_jpu_inst_list_head, list) {
+			if (jil->inst_idx == inst_idx) {
+				s_jpu_open_count--;
+				list_del(&jil->list);
+				kfree(jil);
+//				printk(KERN_INFO "[JPUDRV] JDI_IOCTL_CLOSE_INSTANCE inst_idx=%d, open_count=%d\n", (int)inst_idx, s_jpu_open_count);
+				break;
+			}
+		}
+		spin_unlock(&s_jpu_lock);
+		break;
+	case JDI_IOCTL_GET_INSTANCE_NUM:
+		down(&s_jpu_sem);
+
+		ret = copy_to_user((void __user *)arg, &s_jpu_open_count, sizeof(int));
+		if (ret != 0)
+			ret = -EFAULT;
+
+		//printk(KERN_INFO "[JPUDRV] VDI_IOCTL_GET_INSTANCE_NUM open_count=%d\n", s_jpu_open_count);
+
+		up(&s_jpu_sem);
+		break;
+	case JDI_IOCTL_RESET:
+		jpu_hw_reset();
+		break;
+	case JDI_IOCTL_GET_REGISTER_INFO:
+		ret = copy_to_user((void __user *)arg, &s_jpu_register, sizeof(jpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		break;
+	case JDI_IOCTL_GET_BONDING_INFO:
+		ret = copy_to_user((void __user *)arg, &s_bonding_register, sizeof(jpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		break;
+	case JDI_IOCTL_SET_CLOCK_ENABLE:
+
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+
+		if (clkgate) {
+			reset_control_deassert(rstc_jpeg);
+			jpu_clk_enable(s_jpu_clk);
+			val = ReadJpuRegister(JPEG_DBUS_REG);
+			val |= (dbus_en << 0);
+			val &= ~(1 << 1); //Disable idle gating, fix it later.
+			WriteJpuRegister(JPEG_DBUS_REG, val);
+		} else {
+			jpu_clk_disable(s_jpu_clk);
+			reset_control_assert(rstc_jpeg);
+		}
+		break;
+	case JDI_IOCTL_SET_RTK_DOVI_FLAG:
+		//pr_info("%s [+]JDI_IOCTL_SET_RTK_DOVI_FLAG\n", DEV_NAME);
+		ret = copy_from_user(&doviInfo, (jpudrv_dovi_info_t *)arg, sizeof(jpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+
+		doviInfo.enable = pu_set_dovi_flag(2, doviInfo.inst_idx, doviInfo.enable);
+
+		ret = copy_to_user((jpudrv_dovi_info_t *)arg, &doviInfo, sizeof(jpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+		//pr_info("%s [-]JDI_IOCTL_SET_RTK_DOVI_FLAG doviInfo.inst_idx:%d, doviInfo.value:%d\n", DEV_NAME, doviInfo.inst_idx, doviInfo.enable);
+		break;
+	default:
+		printk(KERN_ERR "No such IOCTL, cmd is %d\n", cmd);
+		break;
+	}
+
+	return ret;
+}
+
+static ssize_t jpu_read(struct file *filp, char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static ssize_t jpu_write(struct file *filp, const char __user *buf, size_t len, loff_t *ppos)
+{
+
+	return -1;
+}
+
+static int jpu_release(struct inode *inode, struct file *filp)
+{
+//	pr_info("%s jpu_release s_jpu_open_count=%d\n", DEV_NAME, s_jpu_open_count);
+
+	spin_lock(&s_jpu_lock);
+
+
+	if (s_jpu_open_count > 0) {
+		/* found and free the not handled buffer by user applications */
+		jpu_free_buffers(filp);
+
+		/* found and free the not closed instance by user applications */
+		jpu_free_instances(filp);
+	}
+
+#if 1 //Fuchun 20150909, we must not free instance pool and common memory
+	if (s_jpu_open_count == 0) {
+		if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_jpu_instance_pool.base);
+#else
+			pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+			jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+			s_jpu_instance_pool.base = 0;
+//			pr_info("%s jpu_release - free s_jpu_instance_pool\n", DEV_NAME);
+		}
+	}
+#endif
+
+	spin_unlock(&s_jpu_lock);
+
+	return 0;
+}
+
+static int jpu_fasync(int fd, struct file *filp, int mode)
+{
+	struct jpu_drv_context_t *dev = (struct jpu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+static int jpu_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	pfn = vm->vm_pgoff;
+
+	return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int jpu_map_to_physical_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+	return pu_mmap_dma_buffer(vm);
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif
+}
+
+static int jpu_map_to_instance_pool_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	int ret;
+	long length = vm->vm_end - vm->vm_start;
+	unsigned long start = vm->vm_start;
+	char *vmalloc_area_ptr = (char *)s_jpu_instance_pool.base;
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_RESERVED;
+
+	/* loop over all pages, map it page individually */
+	while (length > 0) {
+		pfn = vmalloc_to_pfn(vmalloc_area_ptr);
+		if ((ret = remap_pfn_range(vm, start, pfn, PAGE_SIZE, PAGE_SHARED)) < 0) {
+			return ret;
+		}
+		start += PAGE_SIZE;
+		vmalloc_area_ptr += PAGE_SIZE;
+		length -= PAGE_SIZE;
+	}
+
+	return 0;
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif
+}
+
+/*!
+ * @brief memory map interface for jpu file operation
+ * @return  0 on success or negative error code on error
+ */
+static int jpu_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	if (vm->vm_pgoff == 0)
+		return jpu_map_to_instance_pool_memory(fp, vm);
+
+	if ((vm->vm_pgoff == (s_jpu_register.phys_addr>>PAGE_SHIFT)) || (vm->vm_pgoff == (s_bonding_register.phys_addr>>PAGE_SHIFT)))
+		return jpu_map_to_register(fp, vm);
+
+	return jpu_map_to_physical_memory(fp, vm);
+#else
+	if (vm->vm_pgoff) {
+		if (vm->vm_pgoff == (s_jpu_instance_pool.phys_addr>>PAGE_SHIFT))
+			return  jpu_map_to_instance_pool_memory(fp, vm);
+
+		return jpu_map_to_physical_memory(fp, vm);
+	} else
+		return jpu_map_to_register(fp, vm);
+#endif
+}
+
+struct file_operations jpu_fops = {
+	.owner = THIS_MODULE,
+	.open = jpu_open,
+	.read = jpu_read,
+	.write = jpu_write,
+	.unlocked_ioctl = jpu_ioctl,
+	.compat_ioctl   = compat_jpu_ioctl,
+	.release = jpu_release,
+	.fasync = jpu_fasync,
+	.mmap = jpu_mmap,
+};
+
+static int jpu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+	struct resource res;
+	void __iomem *iobase;
+	int irq;
+	struct device_node *node = pdev->dev.of_node;
+
+	pr_info("%s jpu_probe\n", DEV_NAME);
+
+	of_address_to_resource(node, 0, &res);
+	iobase = of_iomap(node, 0);
+
+	s_jpu_reg_phy_base = res.start;
+	s_jpu_reg_virt_base = iobase;
+	s_jpu_register.phys_addr = res.start;
+	s_jpu_register.virt_addr = (unsigned long)iobase;
+	s_jpu_register.size = res.end - res.start + 1;
+
+	pr_info("%s jpu base address get from DTB physical base addr=0x%lx, virtual base=0x%lx, size=0x%x\n", DEV_NAME, (unsigned long)s_jpu_reg_phy_base, (unsigned long)s_jpu_reg_virt_base, (unsigned int)(res.end - res.start + 1));
+
+	of_address_to_resource(node, 1, &res);
+	iobase = of_iomap(node, 1);
+
+	s_jpu_pll_phy_base = res.start;
+	s_jpu_pll_virt_base = iobase;
+	s_jpu_pll_size = res.end - res.start + 1;
+
+	of_address_to_resource(node, 2, &res);
+	iobase = of_iomap(node, 2);
+
+	s_bonding_register.phys_addr = res.start;
+	s_bonding_register.virt_addr = (unsigned long)iobase;
+	s_bonding_register.size = res.end - res.start + 1;
+
+	s_jpu_dev.minor = MISC_JPU_MINOR;
+	s_jpu_dev.name = JPU_DEV_NAME;
+	s_jpu_dev.fops = &jpu_fops;
+	s_jpu_dev.parent = NULL;
+	if (misc_register(&s_jpu_dev)) {
+		pr_info("%s failed to register misc device.", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (pdev)
+		s_jpu_clk = jpu_clk_get(&pdev->dev);
+	else
+		s_jpu_clk = jpu_clk_get(NULL);
+
+	if (!s_jpu_clk)
+		pr_err("%s fail to get clock controller, but, do not treat as error, \n", DEV_NAME);
+	else
+		pr_info("%s get clock controller s_jpu_clk=0x%p\n", DEV_NAME, s_jpu_clk);
+
+#ifdef JPU_SUPPORT_CLOCK_CONTROL
+	jpu_clk_enable(s_jpu_clk);
+#endif
+
+	rstc_jpeg = reset_control_get(&pdev->dev, NULL);
+
+	/* RTK clock setting */
+	reset_control_deassert(rstc_jpeg); // RESET disable
+#if 0 //Fuchun disable 20160204, set clock gating by jdi.c
+	jpu_pll_setting(0x10, (1 << jpg_clk_enable_bit), 0, 1); // CLK enable
+
+	val = ReadJpuRegister(JPEG_DBUS_REG);
+	val |= (dbus_en << 0);
+	WriteJpuRegister(JPEG_DBUS_REG, val);
+#endif
+
+#ifdef JPU_SUPPORT_ISR
+	irq = irq_of_parse_and_map(node, 0);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_jpu_irq = irq;
+	pr_info("%s s_jpu_irq:%d want to register jpu_irq_handler\n", DEV_NAME, s_jpu_irq);
+	err = request_irq(s_jpu_irq, jpu_irq_handler, 0, "JPEG_CODEC_IRQ", (void *)(&s_jpu_drv_context));
+	err = 0;
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_jpu_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_jpu_irq <%d> busy, change your config\n", DEV_NAME, s_jpu_irq);
+
+		goto ERROR_PROVE_DEVICE;
+	}
+#endif
+
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	s_image_memory.size = JPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+	s_image_memory.phys_addr = JPU_DRAM_PHYSICAL_BASE;
+	s_image_memory.base = (unsigned long)ioremap(s_image_memory.phys_addr, PAGE_ALIGN(s_image_memory.size));
+
+	if (!s_image_memory.base) {
+		pr_err("%s fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", DEV_NAME, (int)s_image_memory.phys_addr, (int)s_image_memory.base, (int)s_image_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (jmem_init(&s_jmem, s_image_memory.phys_addr, s_image_memory.size) < 0) {
+		pr_err("%s fail to init vmem system\n", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	pr_info("%s success to probe jpu device with reserved video memory phys_addr=0x%x, base = 0x%x\n", DEV_NAME, (int) s_image_memory.phys_addr, (int)s_image_memory.base);
+#else
+	pr_info("%s success to probe jpu device with non reserved video memory\n", DEV_NAME);
+#endif
+
+	reset_control_assert(rstc_jpeg);
+
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+	misc_deregister(&s_jpu_dev);
+
+	if (s_jpu_reg_virt_base)
+		iounmap(s_jpu_reg_virt_base);
+
+	return err;
+}
+
+static int jpu_remove(struct platform_device *pdev)
+{
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	pr_info("%s jpu_remove\n", DEV_NAME);
+
+	if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_jpu_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+		jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+		s_jpu_instance_pool.base = 0;
+	}
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_image_memory.base) {
+		iounmap((void *)s_image_memory.base);
+		s_image_memory.base = 0;
+		jmem_exit(&s_jmem);
+	}
+#endif
+
+	misc_deregister(&s_jpu_dev);
+
+#ifdef JPU_SUPPORT_ISR
+	if (s_jpu_irq)
+		free_irq(s_jpu_irq, &s_jpu_drv_context);
+#endif
+
+	if (s_jpu_reg_virt_base)
+		iounmap(s_jpu_reg_virt_base);
+
+	if (rstc_jpeg != NULL)
+		reset_control_put(rstc_jpeg);
+
+	jpu_clk_put(s_jpu_clk);
+
+#endif //JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+static int jpu_suspend(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+	reset_control_deassert(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+#if 0
+	if (s_jpu_open_count > 0) {
+		u32 inst_idx;
+		jpudrv_instanace_list_t *jil, *n;
+		jpudrv_instance_pool_t *jip;
+		void *jip_base;
+		jpudrv_buffer_pool_t *pool, *n;
+		jpudrv_buffer_t jb;
+
+		s_jpu_open_count = 0;
+		atomic_set(&s_interrupt_flag, 0);
+		wake_up_interruptible_all(&s_interrupt_wait_q);
+
+		if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_jpu_instance_pool.base);
+#else
+			jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+			s_jpu_instance_pool.base = 0;
+			pr_info("%s jpu_release - free s_jpu_instance_pool\n", DEV_NAME);
+		}
+
+		list_for_each_entry_safe(jil, n, &s_jpu_inst_list_head, list) {
+			inst_idx = jil->inst_idx;
+			jip_base = (void *)(s_jpu_instance_pool.base);
+			jip = (jpudrv_instance_pool_t *)jip_base;
+			if (jip) {
+				memset(&jip->jpgInstPool[inst_idx], 0x00, 4);	// only first 4 byte is key point to free the corresponding instance.
+			}
+			list_del(&jil->list);
+			kfree(jil);
+		}
+
+		list_for_each_entry_safe(pool, n, &s_jbp_head, list) {
+			jb = pool->jb;
+			if (jb.base) {
+				jpu_free_dma_buffer(&jb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+#endif
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_assert(rstc_jpeg);
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+
+}
+
+static int jpu_resume(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+	reset_control_deassert(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_assert(rstc_jpeg);
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+#else
+#define jpu_suspend NULL
+#define jpu_resume NULL
+#endif /* !CONFIG_PM */
+
+static int __init jpu_init(void)
+{
+	int res;
+	res = 0;
+
+	pr_info("%s jpu_init\n", DEV_NAME);
+	init_waitqueue_head(&s_interrupt_wait_q);
+	s_jpu_instance_pool.base = 0;
+
+	pr_info("%s end jpu_init result=0x%x\n", DEV_NAME, res);
+	return res;
+}
+
+static void __exit jpu_exit(void)
+{
+#ifdef JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	pr_info("%s jpu_exit\n", DEV_NAME);
+#else
+	if (s_jpu_instance_pool.base) {
+#ifdef J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_jpu_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_jpu_instance_pool.base, s_jpu_instance_pool.phys_addr);
+		jpu_free_dma_buffer(&s_jpu_instance_pool);
+#endif
+		s_jpu_instance_pool.base = 0;
+	}
+#ifdef JPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_image_memory.base) {
+		iounmap((void *)s_image_memory.base);
+		s_image_memory.base = 0;
+	}
+#endif
+
+	misc_deregister(&s_jpu_dev);
+
+#ifdef JPU_SUPPORT_ISR
+	if (s_jpu_irq)
+		free_irq(s_jpu_irq, &s_jpu_drv_context);
+#endif
+
+	if (rstc_jpeg != NULL)
+		reset_control_put(rstc_jpeg);
+
+	jpu_clk_put(s_jpu_clk);
+
+
+	if (s_jpu_reg_virt_base) {
+		iounmap(s_jpu_reg_virt_base);
+		s_jpu_reg_virt_base = (void *)0x00;
+	}
+
+#endif //JPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+	return;
+}
+
+MODULE_AUTHOR("A customer using RTK JPU, Inc.");
+MODULE_DESCRIPTION("JPU linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(jpu_init);
+module_exit(jpu_exit);
+
+int jpu_hw_reset(void)
+{
+	u32 val;
+
+	pr_info("%s request jpu reset from application\n", DEV_NAME);
+	jpu_clk_disable(s_jpu_clk);
+	reset_control_reset(rstc_jpeg);
+	jpu_clk_enable(s_jpu_clk);
+	val = ReadJpuRegister(JPEG_DBUS_REG);
+	val |= (dbus_en << 0);
+	val &= ~(1 << 1); //Disable idle gating, fix it later.
+	WriteJpuRegister(JPEG_DBUS_REG, val);
+	return 0;
+}
+
+struct clk *jpu_clk_get(struct device *dev)
+{
+	return clk_get(dev, JPU_CLK_NAME);
+}
+
+void jpu_clk_put(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk)))
+		clk_put(clk);
+}
+
+int jpu_clk_enable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+//		pr_info("%s jpu_clk_enable\n", DEV_NAME);
+		return clk_prepare_enable(clk);
+	}
+	return 0;
+}
+
+void jpu_clk_disable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+//		pr_info("%s jpu_clk_disable\n", DEV_NAME);
+		clk_disable_unprepare(clk);
+	}
+}
+
+static const struct of_device_id rtk_jpeg_dt_match[] = {
+	{ .compatible = "Realtek,rtk16xx-jpeg" },
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtk_jpeg_dt_match);
+
+const struct dev_pm_ops rtk_jpeg_pmops = {
+	.suspend = jpu_suspend,
+	.resume = jpu_resume,
+};
+
+static struct platform_driver rtk_jpeg_driver = {
+	.driver = {
+		.name = "rtk-jpeg",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_jpeg_dt_match,
+		.pm = &rtk_jpeg_pmops,
+	},
+	.probe = jpu_probe,
+	.remove = jpu_remove,
+};
+
+module_platform_driver(rtk_jpeg_driver);
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/jpu.h b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/jpu.h
new file mode 100644
index 00000000..fce5113
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/jdi/jpu.h
@@ -0,0 +1,47 @@
+
+
+#ifndef __JPU_DRV_H__
+#define __JPU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+#define J_USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+
+#define JDI_IOCTL_MAGIC  'J'
+#define JDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY			_IO(JDI_IOCTL_MAGIC, 0)
+#define JDI_IOCTL_FREE_PHYSICALMEMORY			_IO(JDI_IOCTL_MAGIC, 1)
+#define JDI_IOCTL_WAIT_INTERRUPT			_IO(JDI_IOCTL_MAGIC, 2)
+#define JDI_IOCTL_SET_CLOCK_GATE			_IO(JDI_IOCTL_MAGIC, 3)
+#define JDI_IOCTL_RESET						_IO(JDI_IOCTL_MAGIC, 4)
+#define JDI_IOCTL_GET_INSTANCE_POOL			_IO(JDI_IOCTL_MAGIC, 5)
+#define JDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO			_IO(JDI_IOCTL_MAGIC, 6)
+#define JDI_IOCTL_OPEN_INSTANCE				_IO(JDI_IOCTL_MAGIC, 7)
+#define JDI_IOCTL_CLOSE_INSTANCE			_IO(JDI_IOCTL_MAGIC, 8)
+#define JDI_IOCTL_GET_INSTANCE_NUM			_IO(JDI_IOCTL_MAGIC, 9)
+#define JDI_IOCTL_ENABLE_INTERRUPT			_IO(JDI_IOCTL_MAGIC, 10)
+#define JDI_IOCTL_GET_REGISTER_INFO			_IO(JDI_IOCTL_MAGIC, 11)
+
+/* RTK ioctl */
+#define JDI_IOCTL_SET_CLOCK_ENABLE			_IO(JDI_IOCTL_MAGIC, 12)
+#define JDI_IOCTL_GET_BONDING_INFO			_IO(JDI_IOCTL_MAGIC, 13)
+#define JDI_IOCTL_SET_RTK_DOVI_FLAG			_IO(JDI_IOCTL_MAGIC, 14)
+
+typedef struct jpudrv_buffer_t {
+    unsigned int size;
+    unsigned long phys_addr;
+    unsigned long base;							/* kernel logical address in use kernel */
+    unsigned long virt_addr;				/* virtual user space address */
+} jpudrv_buffer_t;
+
+typedef struct jpudrv_intr_info_t {
+    unsigned int timeout;
+    int intr_reason;
+} jpudrv_intr_info_t;
+
+typedef struct jpudrv_dovi_info_t{
+	unsigned int inst_idx;
+	unsigned int enable;
+} jpudrv_dovi_info_t;
+
+#endif
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/puwrap.c b/drivers/soc/realtek/rtd16xx/rtk_ve/puwrap.c
new file mode 100644
index 00000000..9ac1e38
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/puwrap.c
@@ -0,0 +1,577 @@
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/module.h>
+
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/dma-buf.h>
+#include <linux/reservation.h>
+
+#include "puwrap.h"
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#define USE_ION_ALLOCATOR
+#ifdef USE_ION_ALLOCATOR
+#define NUM_ION_STRUCT 512 //__LINUX_MEDIA_NAS__
+#include "../../../../staging/android/ion/ion.h"
+#include "../../../../staging/android/uapi/ion_rtk.h"
+struct rtkdrv_ion_buffer_t {
+    unsigned int size;
+    unsigned int inUse;
+    unsigned long phys_addr;
+    unsigned long dmabuf;
+    unsigned long pIonHandle;
+};
+extern struct ion_device *rtk_phoenix_ion_device;
+struct ion_client *pu_client = NULL;
+struct rtkdrv_ion_buffer_t pu_ion_buffer[NUM_ION_STRUCT];
+static DEFINE_MUTEX(s_pu_mutex);
+#else /* else USE_ION_ALLOCATOR */
+typedef struct rtkdrv_buffer_t {
+    unsigned int size;
+    unsigned long phys_addr;
+    unsigned long base;							/* kernel logical address in use kernel */
+    unsigned long virt_addr;				/* virtual user space address */
+} rtkdrv_buffer_t;
+
+#define RTK_INIT_VIDEO_MEMORY_SIZE_IN_BYTE (16*1024*1024)
+#define RTK_DRAM_PHYSICAL_BASE 0x06000000
+#include "rtk_mm.h"
+static video_mm_t s_mem;
+static rtkdrv_buffer_t s_memory = {0};
+#endif /* endif USE_ION_ALLOCATOR */
+#define VE_SECURE_NORMAL 1
+#define VE_SECURE_PROTECTION 2
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+typedef struct rtkdrv_dovi_flag_t{
+	int nCoreIdx;
+	int nInstIdx;
+	unsigned int bEnable;
+} rtkdrv_dovi_flag_t;
+
+unsigned long pll_phy_register = 0;
+unsigned long pll_virt_register = 0;
+unsigned long pll_size_register = 0;
+rtkdrv_dovi_flag_t dovi_flag = {-1, -1, 0};
+static DEFINE_MUTEX(s_dovi_mutex);
+
+
+#define PU_PLATFORM_DEVICE_NAME "rtk_puwrap"
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+int pu_alloc_dma_buffer(unsigned int size, unsigned long *phys_addr, unsigned long *base, unsigned int mem_type)
+{
+#ifdef USE_ION_ALLOCATOR
+    int ret = -1;
+
+    if (!size)
+        return -1;
+
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct ion_handle *handle;
+        struct dma_buf *dmabuf;
+        ion_phys_addr_t dat;
+        size_t len;
+        int heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+        int flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].inUse == 0)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] NUM_ION_STRUCT is too small!!!");
+            break;
+        }
+
+        switch(mem_type)
+        {
+            case VE_SECURE_NORMAL:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+                    flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED | ION_FLAG_VE_SPEC);
+                    break;
+                }
+            case VE_SECURE_PROTECTION:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_SECURE_MASK;
+                    flags = (ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+                    break;
+                }
+            default:
+                {
+                    heap = RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+                    flags = (ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_FLAG_NONCACHED);
+                    break;
+                }
+        }
+
+        handle = ion_alloc(pu_client, size, 1024, heap, flags);
+        if (IS_ERR(handle))
+        {
+            printk(KERN_ERR "[PUWRAP] ion_alloc allocation error size=%d\n", size);
+            break;
+        }
+
+        if(ion_phys(pu_client, handle, &dat, &len) != 0)
+        {
+            ion_free(pu_client, handle);
+            printk(KERN_ERR "[PUWRAP] ion_alloc allocation error size=%d\n", size);
+            break;
+        }
+
+        dmabuf = ion_share_dma_buf(pu_client, handle);
+        if (IS_ERR(dmabuf)) {
+            ion_unmap_kernel(pu_client, handle);
+            ion_free(pu_client, handle);
+            printk(KERN_ERR "[PUWRAP] ion_share_dma_buf error %p (size=%d)\n", dmabuf, size);
+            break;
+        }
+
+        *base = (unsigned long) dmabuf; // we didn't need base address on user space, but we also need it has value to do detection
+        *phys_addr = (unsigned long)dat;
+
+        pu_ion_buffer[i].size = size;
+        pu_ion_buffer[i].inUse = 1;
+        pu_ion_buffer[i].phys_addr = (unsigned long)*phys_addr;
+        pu_ion_buffer[i].dmabuf = (unsigned long)dmabuf;
+        pu_ion_buffer[i].pIonHandle = (unsigned long)handle;
+
+        ret = 0;
+        break;
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+    return ret;
+
+#else /* else USE_ION_ALLOCATOR */
+    if (!size)
+        return -1;
+
+    *phys_addr = (unsigned long)vmem_alloc(&s_mem, size, 0);
+    if (*phys_addr  == (unsigned long)-1)
+    {
+        printk(KERN_ERR "[PUWRAP] Physical memory allocation error size=%d\n", size);
+        return -1;
+    }
+
+    *base = (unsigned long)(s_memory.base + (*phys_addr - s_memory.phys_addr));
+    //printk("[PUWARP] base:0x%lx, phy_addr:0x%lx, size:%d\n", *base, (unsigned long)*phys_addr, size);
+
+    return 0;
+#endif /* endif USE_ION_ALLOCATOR */
+}
+
+void pu_free_dma_buffer(unsigned long base, unsigned long phys_addr)
+{
+    if (!base)
+        return;
+
+#ifdef USE_ION_ALLOCATOR
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct ion_handle *handle;
+        struct dma_buf *dmabuf;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if (dmabuf != NULL)
+        {
+            dma_buf_put(dmabuf);
+            pu_ion_buffer[i].dmabuf = (unsigned long) NULL;
+        }
+
+        handle = (struct ion_handle *)pu_ion_buffer[i].pIonHandle;
+        if(handle != NULL)
+        {
+            ion_free(pu_client, handle);
+        }
+        memset(&pu_ion_buffer[i], 0, sizeof(struct rtkdrv_ion_buffer_t));
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+#else
+    vmem_free(&s_mem, (unsigned long)phys_addr, 0);
+#endif
+}
+
+int pu_mmap_dma_buffer(struct vm_area_struct *vm)
+{
+#ifdef USE_ION_ALLOCATOR
+    u32 i;
+    int ret = 0;
+    struct dma_buf *dmabuf;
+    unsigned long phys_addr = (unsigned long)(vm->vm_pgoff << PAGE_SHIFT);
+    mutex_lock(&s_pu_mutex);
+
+    for (i = 0; i < NUM_ION_STRUCT; i++)
+    {
+        if (pu_ion_buffer[i].phys_addr == phys_addr)
+            break;
+    }
+    if (i == NUM_ION_STRUCT)
+    {
+        printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+        mutex_unlock(&s_pu_mutex);
+        return -EINVAL;
+    }
+
+    dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+    ret = dma_buf_mmap(dmabuf, vm, 0);
+
+    mutex_unlock(&s_pu_mutex);
+
+    return ret;
+#else
+    return -EINVAL;
+#endif
+}
+
+unsigned long pu_mmap_kernel_buffer(unsigned long phys_addr, unsigned int size)
+{
+#ifdef USE_ION_ALLOCATOR
+    unsigned long ret = 0;
+
+    if (!size)
+        return 0;
+
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct dma_buf *dmabuf;
+        void * virt_addr;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if(dmabuf != NULL)
+        {
+            ret = dma_buf_begin_cpu_access(dmabuf, 0);
+            if (ret) {
+                printk(KERN_ERR "[PUWRAP] dma_buf_begin_cpu_access error ret=%d (size=%d) \n", ret, size);
+                break;
+            }
+            virt_addr = dma_buf_kmap(dmabuf, 0);
+            if (IS_ERR_OR_NULL(virt_addr)) {
+                printk(KERN_ERR "[PUWRAP] dma_buf_kmap error %p (size=%d) \n", virt_addr, size);
+                break;
+            }
+
+            ret = (unsigned long)virt_addr;
+        }
+    } while(0);
+    mutex_unlock(&s_pu_mutex);
+
+    return ret;
+#endif
+}
+
+void pu_unmap_kernel_buffer(unsigned long base, unsigned long phys_addr)
+{
+    if (!base)
+        return;
+
+#ifdef USE_ION_ALLOCATOR
+    mutex_lock(&s_pu_mutex);
+    do {
+        int i;
+        struct dma_buf *dmabuf;
+
+        for (i = 0; i < NUM_ION_STRUCT; i++)
+        {
+            if (pu_ion_buffer[i].phys_addr == phys_addr)
+                break;
+        }
+        if (i == NUM_ION_STRUCT)
+        {
+            printk(KERN_ERR "[PUWRAP] can't find phys_addr:0x%lx !!!\n", (unsigned long)phys_addr);
+            break;
+        }
+
+        dmabuf = (struct dma_buf *)pu_ion_buffer[i].dmabuf;
+        if(dmabuf != NULL)
+        {
+            dma_buf_kunmap(dmabuf, 0, (void *)base);
+            dma_buf_end_cpu_access(dmabuf, 0);
+        }
+    } while (0);
+    mutex_unlock(&s_pu_mutex);
+#endif
+}
+#endif //#ifdef CONFIG_RTK_RESERVE_MEMORY
+
+void pu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable)
+{
+    if (pll_phy_register == 0 || pll_virt_register == 0 || pll_size_register == 0)
+    {
+        printk(KERN_WARNING "In[%s][%d] didn't get pll register\n", __FUNCTION__, __LINE__);
+        return;
+    }
+    else if (offset > pll_size_register)
+    {
+        printk(KERN_WARNING "In[%s][%d] offset over than register size\n", __FUNCTION__, __LINE__);
+        return;
+    }
+
+    if (bOverwrite == 1)
+    {
+        __raw_writel(value, (volatile u8 *)(pll_virt_register+offset));
+    }
+    else
+    {
+        if (bEnable)
+        {
+            __raw_writel(__raw_readl((volatile u8 *)(pll_virt_register+offset)) | value, (volatile u8 *)(pll_virt_register+offset));
+        }
+        else
+        {
+            __raw_writel(__raw_readl((volatile u8 *)(pll_virt_register+offset)) & value, (volatile u8 *)(pll_virt_register+offset));
+        }
+    }
+}
+
+int pu_set_dovi_flag(int nCoreIdx, int nInstIdx, unsigned int bEnable)
+{
+	int ret = 0;
+	//pr_info("VE1: dovi_flag[%p, %d, %d, %d], input[%d, %d, %d]\n", &dovi_flag, dovi_flag.nCoreIdx, dovi_flag.nInstIdx, dovi_flag.bEnable, nCoreIdx, nInstIdx, bEnable);
+
+	mutex_lock(&s_dovi_mutex);
+	if (bEnable == 1)
+	{
+		if (dovi_flag.bEnable == 0)
+		{
+			dovi_flag.bEnable = 1;
+			dovi_flag.nCoreIdx = nCoreIdx;
+			dovi_flag.nInstIdx = nInstIdx;
+			ret = 1;
+		}
+	}
+	else
+	{
+		if (dovi_flag.bEnable == 1 && dovi_flag.nCoreIdx == nCoreIdx && dovi_flag.nInstIdx == nInstIdx)
+		{
+			dovi_flag.bEnable = 0;
+			dovi_flag.nCoreIdx = -1;
+			dovi_flag.nInstIdx = -1;
+		}
+	}
+	mutex_unlock(&s_dovi_mutex);
+
+	return ret;
+}
+
+static int pu_probe(struct platform_device *pdev)
+{
+    struct resource res;
+    void __iomem *iobase;
+    struct device_node *node;
+
+    printk(KERN_INFO "[PUWRAP] pu_probe\n");
+
+    node = pdev->dev.of_node;
+    of_address_to_resource(node, 0, &res);
+    iobase = of_iomap(node, 0);
+
+    pll_phy_register = res.start;
+    pll_virt_register = (unsigned long)iobase;
+    pll_size_register = res.end - res.start + 1;
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifdef USE_ION_ALLOCATOR
+    pu_client = ion_client_create(rtk_phoenix_ion_device, "PUDriver");
+    memset(pu_ion_buffer, 0, sizeof(struct rtkdrv_ion_buffer_t)*NUM_ION_STRUCT);
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device with USE_ION_ALLOCATOR\n");
+#else /* else USE_ION_ALLOCATOR */
+    if(pdev)
+        res = platform_get_resource(pdev, IORESOURCE_MEM, 1);
+    if(res)
+    {
+        s_memory.size = res->end - res->start;
+        s_memory.phys_addr = res->start;
+    }
+    else
+    {
+        s_memory.size = RTK_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+        s_memory.phys_addr = RTK_DRAM_PHYSICAL_BASE;
+    }
+
+    s_memory.base = (unsigned long)ioremap(s_memory.phys_addr, PAGE_ALIGN(s_memory.size));
+    if (!s_memory.base)
+    {
+        printk(KERN_ERR "[PUWRAP] :  fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", (int)s_memory.phys_addr, (int)s_memory.base, (int)s_memory.size);
+        goto ERROR_PROVE_DEVICE;
+    }
+    if (vmem_init(&s_mem, s_memory.phys_addr, s_memory.size) < 0)
+    {
+        printk(KERN_ERR "[PUWRAP] :  fail to init vmem system\n");
+        goto ERROR_PROVE_DEVICE;
+    }
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device with reserved video memory phys_addr=0x%x, base = 0x%x\n", (int) s_memory.phys_addr, (int)s_memory.base);
+#endif /* endif USE_ION_ALLOCATOR */
+#else /* else CONFIG_RTK_RESERVE_MEMORY */
+    printk(KERN_INFO "[PUWRAP] success to probe pu wrapper device\n");
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+
+    return 0;
+
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifndef USE_ION_ALLOCATOR
+ERROR_PROVE_DEVICE:
+
+    return 0;
+#endif
+#endif
+}
+
+static int pu_remove(struct platform_device *pdev)
+{
+    printk(KERN_INFO "[PUWRAP] pu_remove\n");
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+#ifdef USE_ION_ALLOCATOR
+    if(pu_client != NULL)
+    {
+        ion_client_destroy(pu_client);
+        pu_client = NULL;
+    }
+#else /* else USE_ION_ALLOCATOR */
+    if (s_memory.base)
+    {
+        iounmap((void *)s_memory.base);
+        s_memory.base = 0;
+        vmem_exit(&s_mem);
+    }
+#endif /* endif USE_ION_ALLOCATOR */
+#endif /* endif CONFIG_RTK_RESERVE_MEMORY */
+
+    return 0;
+}
+
+#if 0
+static struct platform_driver pu_driver = {
+    .driver = {
+        .name = PU_PLATFORM_DEVICE_NAME,
+    },
+    .probe = pu_probe,
+    .remove = pu_remove,
+};
+#endif
+
+static ssize_t pu_memsize_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    return sprintf(buf, "%d\n", (int)(get_num_physpages() << PAGE_SHIFT));
+}
+
+static struct kobj_attribute pu_memsize_attr =
+    __ATTR(pu_memsize, 0644, pu_memsize_show, NULL);
+
+static struct attribute *pu_attrs[] = {
+    &pu_memsize_attr.attr,
+    NULL,
+};
+
+static struct attribute_group rtk_pu_attr_group = {
+    .attrs = pu_attrs,
+};
+
+static struct kobject *pu_kobj;
+
+static int __init pu_init(void)
+{
+    int res = 0;
+
+    pu_kobj = kobject_create_and_add("rtk_pu", kernel_kobj);
+    if (pu_kobj)
+    {
+        res = sysfs_create_group(pu_kobj, &rtk_pu_attr_group);
+        if (res)
+            printk(KERN_WARNING "[PUWRAP] %d: unable to create sysfs entry\n", __LINE__);
+    }
+    else
+        printk(KERN_WARNING "[PUWRAP] %d: unable to create sysfs entry\n", __LINE__);
+
+    printk(KERN_INFO "[PUWRAP] begin pu_init\n");
+    //res = platform_driver_register(&pu_driver);
+    printk(KERN_INFO "[PUWRAP] end pu_init result=0x%x\n", res);
+    return res;
+}
+
+static void __exit pu_exit(void)
+{
+    printk(KERN_INFO "[PUWRAP] pu_exit\n");
+    //platform_driver_unregister(&pu_driver);
+    return;
+}
+
+
+static const struct of_device_id rtk_pu_dt_match[] = {
+    { .compatible = "Realtek,rtk16xx-pu_pll" },
+    {}
+};
+MODULE_DEVICE_TABLE(of, rtk_pu_dt_match);
+
+const struct dev_pm_ops rtk_pu_pmops = {
+    .suspend    = NULL,
+    .resume     = NULL,
+};
+
+static struct platform_driver rtk_pu_driver = {
+    .driver		= {
+        .name	= "rtk-pu",
+        .owner	= THIS_MODULE,
+        .of_match_table = rtk_pu_dt_match,
+        //.pm	= SDHCI_PLTFM_PMOPS,
+        .pm	= &rtk_pu_pmops,
+    },
+    .probe		= pu_probe,
+    .remove		= pu_remove,
+};
+
+module_platform_driver(rtk_pu_driver);
+
+MODULE_AUTHOR("RTK Wrapper for JPU & VPU, Inc.");
+MODULE_DESCRIPTION("PU WRAPPER linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(pu_init);
+module_exit(pu_exit);
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/puwrap.h b/drivers/soc/realtek/rtd16xx/rtk_ve/puwrap.h
new file mode 100644
index 00000000..f065d21
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/puwrap.h
@@ -0,0 +1,44 @@
+
+
+#ifndef __PU_DRV_H__
+#define __PU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+#include <linux/reset.h>
+
+#define PDI_IOCTL_MAGIC  'V'
+
+#define PLL_CLK_715 (0x10D336)
+#define PLL_CLK_702 (0x10C186)
+#define PLL_CLK_675 (0x10C176)
+#define PLL_CLK_648 (0x10C166)
+#define PLL_CLK_594 (0x10C146)
+#define PLL_CLK_567 (0x10C136)
+#define PLL_CLK_337 (0x12C176)
+#define PLL_CLK_297 (0x12C146)
+
+#define UNUSED_PARAMETER(p) (void)(p)
+
+#define MISC_JPU_MINOR 107
+#define MISC_MEM_MINOR 108
+#define MISC_VE3_MINOR 109
+#define MISC_VE1_MINOR 110
+
+typedef struct pu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long jpu_interrupt_reason;
+	unsigned long vpu_interrupt_reason;
+} pu_drv_context_t;
+
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+int pu_alloc_dma_buffer(unsigned int size, unsigned long *phys_addr, unsigned long *base, unsigned int mem_type);
+void pu_free_dma_buffer(unsigned long base, unsigned long phys_addr);
+int pu_mmap_dma_buffer(struct vm_area_struct *vm);
+unsigned long pu_mmap_kernel_buffer(unsigned long phys_addr, unsigned int size);
+void pu_unmap_kernel_buffer(unsigned long base, unsigned long phys_addr);
+#endif
+void pu_pll_setting(unsigned long offset, unsigned int value, unsigned int bOverwrite, unsigned int bEnable);
+int pu_set_dovi_flag(int nCoreIdx, int nInstIdx, unsigned int bEnable);
+
+#endif
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/Makefile b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/Makefile
new file mode 100644
index 00000000..7217604
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/Makefile
@@ -0,0 +1,6 @@
+# rtk_vcodec
+
+obj-$(CONFIG_VE1_CODEC) += ve1.o
+ifdef CONFIG_COMPAT
+obj-$(CONFIG_VE1_CODEC) += compat_ve1.o
+endif
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/compat_ve1.c b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/compat_ve1.c
new file mode 100755
index 00000000..c9b4619
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/compat_ve1.c
@@ -0,0 +1,666 @@
+/*
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/compat.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#include "ve1.h"
+#include "compat_ve1.h"
+
+/* See drivers/soc/realtek/rtd129x/rtk_ve/ve1/ve1.h for the definition of these structs */
+typedef struct compat_vpudrv_buffer_t {
+	compat_uint_t size;
+	compat_ulong_t phys_addr;
+	compat_ulong_t base; /* kernel logical address in use kernel */
+	compat_ulong_t virt_addr; /* virtual user space address */
+	compat_uint_t mem_type;
+} compat_vpudrv_buffer_t;
+
+typedef struct compat_vpu_clock_info_t{
+	compat_uint_t core_idx;
+	compat_uint_t enable;
+	compat_uint_t value;
+} compat_vpu_clock_info_t;
+
+typedef struct compat_vpudrv_inst_info_t {
+	compat_uint_t core_idx;
+	compat_uint_t inst_idx;
+	compat_int_t inst_open_count;	/* for output only*/
+} compat_vpudrv_inst_info_t;
+
+typedef struct compat_vpudrv_intr_info_t {
+	compat_uint_t core_idx;
+	compat_uint_t timeout;
+	compat_int_t intr_reason;
+#ifdef SUPPORT_MULTI_INST_INTR
+	compat_int_t intr_inst_index;
+#endif
+} compat_vpudrv_intr_info_t;
+
+typedef struct compat_vpudrv_dovi_info_t{
+	compat_uint_t core_idx;
+	compat_uint_t inst_idx;
+	compat_uint_t enable;
+} compat_vpudrv_dovi_info_t;
+
+#define COMPAT_VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(VDI_IOCTL_MAGIC, 0)
+#define COMPAT_VDI_IOCTL_FREE_PHYSICALMEMORY _IO(VDI_IOCTL_MAGIC, 1)
+#define COMPAT_VDI_IOCTL_WAIT_INTERRUPT _IO(VDI_IOCTL_MAGIC, 2)
+#define COMPAT_VDI_IOCTL_GET_INSTANCE_POOL _IO(VDI_IOCTL_MAGIC, 5)
+#define COMPAT_VDI_IOCTL_GET_COMMON_MEMORY _IO(VDI_IOCTL_MAGIC, 6)
+#define COMPAT_VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(VDI_IOCTL_MAGIC, 8)
+#define COMPAT_VDI_IOCTL_OPEN_INSTANCE _IO(VDI_IOCTL_MAGIC, 9)
+#define COMPAT_VDI_IOCTL_CLOSE_INSTANCE _IO(VDI_IOCTL_MAGIC, 10)
+#define COMPAT_VDI_IOCTL_GET_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 11)
+#define COMPAT_VDI_IOCTL_GET_REGISTER_INFO _IO(VDI_IOCTL_MAGIC, 12)
+
+/* RTK ioctl */
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_GATING _IO(VDI_IOCTL_MAGIC, 16)
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 17)
+#define COMPAT_VDI_IOCTL_GET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 18)
+#define COMPAT_VDI_IOCTL_GET_RTK_SUPPORT_TYPE _IO(VDI_IOCTL_MAGIC, 19)
+#define COMPAT_VDI_IOCTL_SET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 21)
+#define COMPAT_VDI_IOCTL_GET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 22)
+#define COMPAT_VDI_IOCTL_SET_RTK_DOVI_FLAG _IO(VDI_IOCTL_MAGIC, 23)
+#define COMPAT_VDI_IOCTL_GET_TOTAL_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 24)
+#define COMPAT_VDI_IOCTL_GET_RTK_DCSYS_INFO _IO(VDI_IOCTL_MAGIC, 25)
+
+static int compat_get_ve1_buffer_data(
+	compat_vpudrv_buffer_t __user *data32,
+	vpudrv_buffer_t __user *data)
+{
+	compat_uint_t s;
+	compat_ulong_t p;
+	compat_ulong_t b;
+	compat_ulong_t v;
+	compat_uint_t m;
+	int err;
+
+	err = get_user(s, &data32->size);
+	err |= put_user(s, &data->size);
+	err |= get_user(p, &data32->phys_addr);
+	err |= put_user(p, &data->phys_addr);
+	err |= get_user(b, &data32->base);
+	err |= put_user(b, &data->base);
+	err |= get_user(v, &data32->virt_addr);
+	err |= put_user(v, &data->virt_addr);
+	err |= get_user(m, &data32->mem_type);
+	err |= put_user(m, &data->mem_type);
+
+	return err;
+}
+
+static int compat_get_ve1_inst_info_data(
+	compat_vpudrv_inst_info_t __user *data32,
+	vpudrv_inst_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_int_t ioc;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(i, &data32->inst_idx);
+	err |= put_user(i, &data->inst_idx);
+	err |= get_user(ioc, &data32->inst_open_count);
+	err |= put_user(ioc, &data->inst_open_count);
+
+	return err;
+}
+
+static int compat_get_ve1_intr_info_data(
+	compat_vpudrv_intr_info_t __user *data32,
+	vpudrv_intr_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t t;
+	compat_int_t i;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(t, &data32->timeout);
+	err |= put_user(t, &data->timeout);
+	err |= get_user(i, &data32->intr_reason);
+	err |= put_user(i, &data->intr_reason);
+#ifdef SUPPORT_MULTI_INST_INTR
+	err |= get_user(i, &data32->intr_inst_index);
+	err |= put_user(i, &data->intr_inst_index);
+#endif
+
+	return err;
+}
+
+static int compat_get_ve1_clock_info(
+	compat_vpu_clock_info_t __user *data32,
+	vpu_clock_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_uint_t v;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(e, &data32->enable);
+	err |= put_user(e, &data->enable);
+	err |= get_user(v, &data32->value);
+	err |= put_user(v, &data->value);
+
+	return err;
+}
+
+static int compat_get_ve1_dovi_info(
+	compat_vpudrv_dovi_info_t __user *data32,
+	vpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_uint_t i;
+	int err;
+
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(i, &data32->inst_idx);
+	err |= put_user(i, &data->inst_idx);
+	err |= get_user(e, &data32->enable);
+	err |= put_user(e, &data->enable);
+
+	return err;
+}
+
+static int compat_put_ve1_buffer_data(
+	compat_vpudrv_buffer_t __user *data32,
+	vpudrv_buffer_t __user *data)
+{
+	compat_uint_t s;
+	compat_ulong_t p;
+	compat_ulong_t b;
+	compat_ulong_t v;
+	compat_uint_t m;
+	int err;
+
+	err = get_user(s, &data->size);
+	err |= put_user(s, &data32->size);
+	err |= get_user(p, &data->phys_addr);
+	err |= put_user(p, &data32->phys_addr);
+	err |= get_user(b, &data->base);
+	err |= put_user(b, &data32->base);
+	err |= get_user(v, &data->virt_addr);
+	err |= put_user(v, &data32->virt_addr);
+	err |= get_user(m, &data->mem_type);
+	err |= put_user(m, &data32->mem_type);
+
+	return err;
+}
+
+static int compat_put_ve1_inst_info_data(
+	compat_vpudrv_inst_info_t __user *data32,
+	vpudrv_inst_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_int_t ioc;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(i, &data->inst_idx);
+	err |= put_user(i, &data32->inst_idx);
+	err |= get_user(ioc, &data->inst_open_count);
+	err |= put_user(ioc, &data32->inst_open_count);
+
+	return err;
+}
+
+static int compat_put_ve1_intr_info_data(
+	compat_vpudrv_intr_info_t __user *data32,
+	vpudrv_intr_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t t;
+	compat_int_t i;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(t, &data->timeout);
+	err |= put_user(t, &data32->timeout);
+	err |= get_user(i, &data->intr_reason);
+	err |= put_user(i, &data32->intr_reason);
+
+	return err;
+}
+
+static int compat_put_ve1_clock_info(
+	compat_vpu_clock_info_t __user *data32,
+	vpu_clock_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t e;
+	compat_uint_t v;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(e, &data->enable);
+	err |= put_user(e, &data32->enable);
+	err |= get_user(v, &data->value);
+	err |= put_user(v, &data32->value);
+
+	return err;
+}
+
+static int compat_put_ve1_dovi_info(
+	compat_vpudrv_dovi_info_t __user *data32,
+	vpudrv_dovi_info_t __user *data)
+{
+	compat_uint_t c;
+	compat_uint_t i;
+	compat_uint_t e;
+	int err;
+
+	err = get_user(c, &data->core_idx);
+	err |= put_user(c, &data32->core_idx);
+	err |= get_user(i, &data->inst_idx);
+	err |= put_user(i, &data32->inst_idx);
+	err |= get_user(e, &data->enable);
+	err |= put_user(e, &data32->enable);
+
+	return err;
+}
+
+long compat_vpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	long ret = 0;
+
+	if (!filp->f_op->unlocked_ioctl)
+		return -ENOTTY;
+
+	switch (cmd) {
+	case COMPAT_VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_FREE_PHYSICALMEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_FREE_PHYSICALMEMORY, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_WAIT_INTERRUPT:
+	{
+		compat_vpudrv_intr_info_t __user *data32;
+		vpudrv_intr_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_intr_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_WAIT_INTERRUPT, (unsigned long)data);
+		err = compat_put_ve1_intr_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case VDI_IOCTL_SET_CLOCK_GATE:
+	case VDI_IOCTL_RESET:
+	case VDI_IOCTL_GET_RTK_ASIC_REVISION:
+	{
+		return filp->f_op->unlocked_ioctl(filp, cmd,
+										  (unsigned long)compat_ptr(arg));
+	}
+
+	case COMPAT_VDI_IOCTL_GET_INSTANCE_POOL:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_INSTANCE_POOL, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_COMMON_MEMORY:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_COMMON_MEMORY, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_OPEN_INSTANCE:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_OPEN_INSTANCE, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_CLOSE_INSTANCE:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_CLOSE_INSTANCE, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_INSTANCE_NUM:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_INSTANCE_NUM, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_REGISTER_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_REGISTER_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_GATING:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_GATING, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_PLL:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_PLL, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_CLK_PLL:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_CLK_PLL, (unsigned long)data);
+		err = compat_put_ve1_clock_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_CLK_SELECT:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+
+		return filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_CLK_SELECT, (unsigned long)data);
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_CLK_SELECT:
+	{
+		compat_vpu_clock_info_t __user *data32;
+		vpu_clock_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_clock_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_CLK_SELECT, (unsigned long)data);
+		err = compat_put_ve1_clock_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_SET_RTK_DOVI_FLAG:
+	{
+		compat_vpudrv_dovi_info_t __user *data32;
+		vpudrv_dovi_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_dovi_info(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_SET_RTK_DOVI_FLAG, (unsigned long)data);
+		err = compat_put_ve1_dovi_info(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_SUPPORT_TYPE:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_SUPPORT_TYPE, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_RTK_DCSYS_INFO:
+	{
+		compat_vpudrv_buffer_t __user *data32;
+		vpudrv_buffer_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_buffer_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_RTK_DCSYS_INFO, (unsigned long)data);
+		err = compat_put_ve1_buffer_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	case COMPAT_VDI_IOCTL_GET_TOTAL_INSTANCE_NUM:
+	{
+		compat_vpudrv_inst_info_t __user *data32;
+		vpudrv_inst_info_t __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ve1_inst_info_data(data32, data);
+		if (err)
+			return err;
+		ret = filp->f_op->unlocked_ioctl(filp, VDI_IOCTL_GET_TOTAL_INSTANCE_NUM, (unsigned long)data);
+		err = compat_put_ve1_inst_info_data(data32, data);
+		return ret ? ret : err;
+	}
+
+	default:
+	{
+		printk(KERN_ERR "[COMPAT_VPUDRV] No such IOCTL, cmd is %d\n", cmd);
+		return -ENOIOCTLCMD;
+	}
+	}
+}
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/compat_ve1.h b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/compat_ve1.h
new file mode 100644
index 00000000..15c1161
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/compat_ve1.h
@@ -0,0 +1,42 @@
+/*
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_COMPAT_VE1_H
+#define _LINUX_COMPAT_VE1_H
+
+#if IS_ENABLED(CONFIG_COMPAT)
+
+typedef struct compat_vpu_bit_firmware_info_t {
+	compat_uint_t size; /* size of this structure*/
+	compat_uint_t core_idx;
+	compat_ulong_t reg_base_offset;
+	compat_ushort_t bit_code[512];
+} compat_vpu_bit_firmware_info_t;
+
+long compat_vpu_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+
+#else
+
+typedef struct compat_vpu_bit_firmware_info_t {
+	unsigned int size; /* size of this structure*/
+	unsigned int core_idx;
+	unsigned long reg_base_offset;
+	unsigned short bit_code[512];
+} compat_vpu_bit_firmware_info_t;
+
+#define compat_vpu_ioctl  NULL
+
+#endif /* CONFIG_COMPAT */
+#endif /* _LINUX_COMPAT_VE1_H */
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/ve1.c b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/ve1.c
new file mode 100644
index 00000000..7b8fb23
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/ve1.c
@@ -0,0 +1,2602 @@
+/*
+ * ve1.c
+ *
+ * linux device driver for VE1.
+ *
+ * Copyright (C) 2006 - 2013  REALTEK INC.
+ *
+ * This library is free software; you can redistribute it and/or modify it under
+ * the terms of the GNU Lesser General Public License as published by the Free
+ * Software Foundation; either version 2.1 of the License, or (at your option)
+ * any later version.
+ *
+ * This library is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+ * details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this library; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301  USA
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/clk-provider.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/kfifo.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <soc/realtek/rtk_chip.h>
+
+#ifdef CONFIG_COMPAT
+#include <linux/compat.h>
+#endif
+
+#ifdef CONFIG_POWER_CONTROL
+#include <soc/realtek/power-control.h>
+#endif
+
+#include "ve1config.h"
+#include "ve1.h"
+#include "compat_ve1.h"
+#include "../puwrap.h"
+
+//#define ENABLE_DEBUG_MSG
+#ifdef ENABLE_DEBUG_MSG
+#define DPRINTK(args...) pr_info(args);
+#else
+#define DPRINTK(args...)
+#endif /* ENABLE_DEBUG_MSG */
+
+#define DEV_NAME "[RTK_VE1]"
+#define DISABLE_ORIGIN_SUSPEND
+#define USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+
+/* definitions to be changed as customer  configuration */
+/* if you want to have clock gating scheme frame by frame */
+/* #define VPU_SUPPORT_CLOCK_CONTROL */
+
+/* if the driver want to use interrupt service from kernel ISR */
+#define VPU_SUPPORT_ISR
+
+/* if the platform driver knows the name of this driver */
+/* VPU_PLATFORM_DEVICE_NAME */
+#define VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+
+/* if this driver knows the dedicated video memory address */
+#ifndef CONFIG_RTK_RESERVE_MEMORY
+#ifdef CONFIG_RTK_PLATFORM_FPGA
+#define VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#endif
+#endif
+
+#define VPU_PLATFORM_DEVICE_NAME "vdec"
+#define VPU_CLK_NAME "vcodec"
+#define VPU_DEV_NAME "vpu"
+
+/* if the platform driver knows this driver */
+/* the definition of VPU_REG_BASE_ADDR and VPU_REG_SIZE are not meaningful */
+
+#define VPU_REG_BASE_ADDR 0x98040000
+#define VPU_REG_SIZE (0x4000*MAX_NUM_VPU_CORE)
+#define MS_TO_NS(x) (x * 1E6L)
+
+#ifdef VPU_SUPPORT_ISR
+#define VE1_IRQ_NUM (85)
+#define VE2_IRQ_NUM (86)
+#endif
+
+/* this definition is only for realtek FPGA board env */
+/* so for SOC env of customers can be ignored */
+
+#ifndef VM_RESERVED	/*for kernel up to 3.7.0 version*/
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+typedef struct vpu_drv_context_t {
+	struct fasync_struct *async_queue;
+	unsigned long interrupt_reason_ve1;
+#ifdef SUPPORT_MULTI_INST_INTR
+	unsigned long interrupt_reason_ve2[MAX_NUM_INSTANCE];
+#else
+	unsigned long interrupt_reason_ve2;
+#endif
+	unsigned long interrupt_reason_ve3;
+	/* !<< device reference count. Not instance count */
+	u32 open_count;
+} vpu_drv_context_t;
+
+/* To track the allocated memory buffer */
+typedef struct vpudrv_buffer_pool_t {
+	struct list_head list;
+	struct vpudrv_buffer_t vb;
+	struct file *filp;
+} vpudrv_buffer_pool_t;
+
+/* To track the instance index and buffer in instance pool */
+typedef struct vpudrv_instanace_list_t {
+	struct list_head list;
+	unsigned long inst_idx;
+	unsigned long core_idx;
+	struct file *filp;
+} vpudrv_instanace_list_t;
+
+typedef struct vpudrv_instance_pool_t {
+	unsigned char codecInstPool[MAX_NUM_INSTANCE][MAX_INST_HANDLE_SIZE];
+	long long pendingInstIdxPlus1;
+	void *pendingInst;
+} vpudrv_instance_pool_t;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+#define VPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE 0x0b800000 //(62*1024*1024)
+#define VPU_DRAM_PHYSICAL_BASE 0x03200000 //0x86C00000
+#include "vmm.h"
+static video_mm_t s_vmem;
+static vpudrv_buffer_t s_video_memory = {0};
+#endif /*VPU_SUPPORT_RESERVED_VIDEO_MEMORY*/
+
+static int vpu_hw_reset(u32 coreIdx);
+#ifdef CONFIG_POWER_CONTROL
+static void vpu_pctrl_off(struct power_control *pctrl);
+static void vpu_pctrl_on(struct power_control *pctrl);
+static struct power_control *vpu_pctrl_get(u32 coreIdx);
+#endif /* CONFIG_POWER_CONTROL */
+
+/* end customer definition */
+static vpudrv_buffer_t s_instance_pool = {0};
+static vpudrv_buffer_t s_common_memory = {0};
+static vpu_drv_context_t s_vpu_drv_context;
+static struct miscdevice s_vpu_dev;
+
+static struct clk *s_vpu_clk_ve1;
+static struct clk *s_vpu_clk_ve2;
+static struct clk *s_vpu_clk_ve2_bpu;
+static struct clk *s_vpu_clk_ve3;
+static struct clk *s_vpu_clk_sysh;
+static struct clk *s_vpu_pll_ve1;
+static struct clk *s_vpu_pll_ve2;
+static struct device *p_vpu_dev;
+static int s_vpu_open_ref_count;
+static struct reset_control *rstc_ve1;
+static struct reset_control *rstc_ve2;
+static struct reset_control *rstc_ve3;
+
+#ifdef VPU_SUPPORT_ISR
+static int s_ve1_irq = VE1_IRQ_NUM;
+static int s_ve2_irq = VE2_IRQ_NUM;
+#endif /* VPU_SUPPORT_ISR */
+
+#ifdef CONFIG_POWER_CONTROL
+static struct power_control *s_pctrl_ve1;
+static struct power_control *s_pctrl_ve2;
+static struct power_control *s_pctrl_ve3;
+#endif /* CONFIG_POWER_CONTROL */
+
+static int ve_cti_en = 1;
+/* FIX ME after ver.B IC */
+static int ve_idle_en = 0;
+
+static vpudrv_buffer_t s_vpu_register = {0};
+static vpudrv_buffer_t s_dc_register = {0};
+static vpudrv_buffer_t s_bond_register = {0};
+static vpudrv_buffer_t s_dmc_register = {0};
+
+static atomic_t s_interrupt_flag_ve1;
+static wait_queue_head_t s_interrupt_wait_q_ve1;
+#ifdef SUPPORT_MULTI_INST_INTR
+static atomic_t s_interrupt_flag_ve2[MAX_NUM_INSTANCE];
+static wait_queue_head_t s_interrupt_wait_q_ve2[MAX_NUM_INSTANCE];
+typedef struct kfifo kfifo_t;
+static kfifo_t s_interrupt_pending_q_ve2[MAX_NUM_INSTANCE];
+#else
+static atomic_t s_interrupt_flag_ve2;
+static wait_queue_head_t s_interrupt_wait_q_ve2;
+#endif
+static atomic_t s_interrupt_flag_ve3;
+static wait_queue_head_t s_interrupt_wait_q_ve3;
+
+static spinlock_t s_vpu_lock = __SPIN_LOCK_UNLOCKED(s_vpu_lock);
+static spinlock_t s_ve1_lock = __SPIN_LOCK_UNLOCKED(s_ve1_lock);
+static spinlock_t s_ve2_lock = __SPIN_LOCK_UNLOCKED(s_ve2_lock);
+static spinlock_t s_ve3_lock = __SPIN_LOCK_UNLOCKED(s_ve3_lock);
+static DEFINE_SEMAPHORE(s_vpu_sem);
+static struct list_head s_vbp_head = LIST_HEAD_INIT(s_vbp_head);
+static struct list_head s_inst_list_head = LIST_HEAD_INIT(s_inst_list_head);
+
+static vpu_bit_firmware_info_t s_bit_firmware_info[MAX_NUM_VPU_CORE];
+
+#define BIT_BASE 0x0000
+#define BIT_INT_STS (BIT_BASE + 0x010)
+#define BIT_INT_REASON (BIT_BASE + 0x174)
+#define BIT_INT_CLEAR (BIT_BASE + 0x00C)
+#define VE_CTRL_REG (BIT_BASE + 0x3000)
+#define VE_CTI_GRP_REG (BIT_BASE + 0x3004)
+#define VE_INT_STS_REG (BIT_BASE + 0x3020)
+
+#define W5_REG_BASE 0x0000
+#define W5_VPU_INT_CLEAR (W5_REG_BASE + 0x003C)
+#define W5_VPU_INT_STS (W5_REG_BASE + 0x0044)
+#define W5_VPU_INT_REASON (W5_REG_BASE + 0x004c)
+#define W5_VPU_INT_REASON_CLEAR (W5_REG_BASE + 0x0034)
+#ifdef SUPPORT_MULTI_INST_INTR
+#define W5_RET_BS_EMPTY_INST        (W5_REG_BASE + 0x01E4)
+#define W5_RET_QUEUE_CMD_DONE_INST  (W5_REG_BASE + 0x01E8)
+#define W5_RET_DONE_INSTANCE_INFO   (W5_REG_BASE + 0x01FC)
+typedef enum {
+    INT_WAVE5_INIT_VPU          = 0,
+    INT_WAVE5_WAKEUP_VPU        = 1,
+    INT_WAVE5_SLEEP_VPU         = 2,
+    INT_WAVE5_CREATE_INSTANCE   = 3,
+    INT_WAVE5_FLUSH_INSTANCE    = 4,
+    INT_WAVE5_DESTORY_INSTANCE  = 5,
+    INT_WAVE5_INIT_SEQ          = 6,
+    INT_WAVE5_SET_FRAMEBUF      = 7,
+    INT_WAVE5_DEC_PIC           = 8,
+    INT_WAVE5_ENC_PIC           = 8,
+    INT_WAVE5_ENC_SET_PARAM     = 9,
+    INT_WAVE5_DEC_QUERY         = 14,
+    INT_WAVE5_BSBUF_EMPTY       = 15,
+    INT_WAVE5_BSBUF_FULL        = 15,
+} Wave5InterruptBit;
+#endif
+
+#define W5_VE_CTRL_REG (W5_REG_BASE + 0x3E00)
+#define W5_VE_CTI_GRP_REG (W5_REG_BASE + 0x3E04)
+
+#ifdef CONFIG_PM
+/* implement to power management functions */
+#define BIT_CODE_RUN (BIT_BASE + 0x000)
+#define BIT_CODE_DOWN (BIT_BASE + 0x004)
+#define BIT_CODE_RESET (BIT_BASE + 0x014)
+#define BIT_BUSY_FLAG (BIT_BASE + 0x160)
+#define BIT_RUN_COMMAND (BIT_BASE + 0x164)
+#define BIT_RUN_INDEX (BIT_BASE + 0x168)
+#define BIT_RUN_COD_STD (BIT_BASE + 0x16C)
+
+/* WAVE5 registers */
+#define W5_VPU_BUSY_STATUS (W5_REG_BASE + 0x0070)
+
+#define W5_RET_SUCCESS (W5_REG_BASE + 0x0110)
+#define W5_RET_FAIL_REASON (W5_REG_BASE + 0x0114)
+
+/* WAVE5 INIT, WAKEUP */
+#define W5_PO_CONF (W5_REG_BASE + 0x0000)
+#define W5_VCPU_CUR_PC	 (W5_REG_BASE + 0x0004)
+
+#define W5_VPU_INT_ENABLE (W5_REG_BASE + 0x0048)
+
+#define W5_RESET_REQ (W5_REG_BASE + 0x0050)
+#define W5_RESET_STATUS (W5_REG_BASE + 0x0054)
+
+#define W5_VPU_REMAP_CTRL (W5_REG_BASE + 0x0060)
+#define W5_VPU_REMAP_VADDR	(W5_REG_BASE + 0x0064)
+#define W5_VPU_REMAP_PADDR (W5_REG_BASE + 0x0068)
+#define W5_VPU_REMAP_PROC_START (W5_REG_BASE + 0x006C)
+#define W5_VPU_BUSY_STATUS (W5_REG_BASE + 0x0070)
+
+#define W5_REMAP_CODE_INDEX 0
+
+enum {
+	W5_INT_INIT_VPU = 0,
+	W5_INT_DEC_PIC_HDR = 1,
+	W5_INT_FINI_SEQ = 2,
+	W5_INT_DEC_PIC = 3,
+	W5_INT_SET_FRAMEBUF = 4,
+	W5_INT_FLUSH_DEC = 5,
+	W5_INT_GET_FW_VERSION = 9,
+	W5_INT_QUERY_DEC = 10,
+	W5_INT_SLEEP_VPU = 11,
+	W5_INT_WAKEUP_VPU = 12,
+	W5_INT_CHANGE_INT = 13,
+	W5_INT_CREATE_INSTANCE = 14,
+	/*!<< Bitstream buffer empty */
+	W5_INT_BSBUF_EMPTY = 15,
+	W5_INT_ENC_SLICE_INT = 15,
+};
+
+#define W5_HW_OPTION (W5_REG_BASE + 0x0124)
+#define W5_CODE_SIZE (W5_REG_BASE + 0x011C)
+/* Note: W5_INIT_CODE_BASE_ADDR should be aligned to 4KB */
+#define W5_ADDR_CODE_BASE (W5_REG_BASE + 0x0118)
+#define W5_CODE_PARAM (W5_REG_BASE + 0x0120)
+/* Note: W5_INIT_STACK_BASE_ADDR should be aligned to 4KB */
+#define W5_ADDR_STACK_BASE (W5_REG_BASE + 0x012C)
+#define W5_STACK_SIZE (W5_REG_BASE + 0x0130)
+#define W5_INIT_VPU_TIME_OUT_CNT (W5_REG_BASE + 0x0134)
+
+/* WAVE5 Wave5BitIssueCommand */
+#define W5_CORE_INDEX (W5_REG_BASE + 0x0104)
+#define W5_INST_INDEX (W5_REG_BASE + 0x0108)
+#define W5_COMMAND (W5_REG_BASE + 0x0100)
+#define W5_VPU_HOST_INT_REQ (W5_REG_BASE + 0x0038)
+
+/* Product register */
+#define VPU_PRODUCT_CODE_REGISTER   (BIT_BASE + 0x1044)
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+static u32 s_vpu_reg_store[MAX_NUM_VPU_CORE][64];
+#endif
+#endif /* CONFIG_PM */
+
+/*
+ * common struct and definition
+ */
+#define ReadVpuRegister(addr, core) *(volatile unsigned int *)(s_vpu_register.virt_addr + (0x4000 * core) + addr)
+#define WriteVpuRegister(addr, val, core) *(volatile unsigned int *)(s_vpu_register.virt_addr + (0x4000 * core) + addr) = (unsigned int)val
+#define WriteVpu(addr, val) *(volatile unsigned int *)(addr) = (unsigned int)val;
+
+struct clk *vpu_clk_get(struct device *dev, u32 coreIdx)
+{
+	if (coreIdx == 0)
+		return clk_get(dev, "clk_ve1");
+	else if (coreIdx == 1)
+		return clk_get(dev, "clk_ve2");
+	else
+		return clk_get(dev, "clk_ve3");
+	//return clk_get(dev, VPU_CLK_NAME);
+}
+
+void vpu_clk_put(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk)))
+		clk_put(clk);
+}
+
+unsigned long vpu_clk_get_rate(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+		DPRINTK("%s vpu_clk_get_rate\n", DEV_NAME);
+		return clk_get_rate(clk);
+	}
+
+	return 0;
+}
+
+int vpu_clk_enable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+#if 0 /* the bellow is for EVB.*/
+		{
+			struct clk *s_vpuext_clk = NULL;
+			s_vpuext_clk = clk_get(NULL, "vcore");
+			if (s_vpuext_clk) {
+				DPRINTK("%s vcore clk=%p\n", DEV_NAME, s_vpuext_clk);
+				clk_enable(s_vpuext_clk);
+			}
+
+			DPRINTK("%s vbus clk=%p\n", DEV_NAME, s_vpuext_clk);
+			if (s_vpuext_clk) {
+				s_vpuext_clk = clk_get(NULL, "vbus");
+				clk_enable(s_vpuext_clk);
+			}
+		}
+#endif /* for EVB. */
+
+		DPRINTK("%s vpu_clk_enable\n", DEV_NAME);
+		return clk_prepare_enable(clk)/*clk_enable(clk)*/;
+	}
+
+	return 0;
+}
+
+void vpu_clk_disable(struct clk *clk)
+{
+	if (!(clk == NULL || IS_ERR(clk))) {
+		DPRINTK("%s vpu_clk_disable\n", DEV_NAME);
+		//clk_disable(clk);
+		//while (__clk_is_enabled(clk))
+			clk_disable_unprepare(clk);
+	}
+}
+
+static int vpu_clk_pll_set_rate(struct clk *clk, unsigned int rate)
+{
+	struct clk *pclk;
+
+	/* check if the parent clk is clk_sysh */
+	pclk = clk_get_parent(clk);
+	if (clk_is_match(pclk, s_vpu_clk_sysh)) {
+	        pr_warn("[VPUDRV] %s: set clk_sysh is not allowed\n", __func__);
+		return -EPERM;
+	}
+
+	/* set rate */
+	clk_set_rate(clk, rate);
+
+	return 0;
+}
+
+static void ve1_wrapper_setup(unsigned int coreIdx)
+{
+	unsigned int ctrl_1;
+	unsigned int ctrl_2;
+
+	/* coreIdx == 0 or coreIdx == 2 */
+	if ((coreIdx & (1 << 0)) != 0 || (coreIdx & (1 << 2)) != 0) {
+		ctrl_1 = ReadVpuRegister(VE_CTRL_REG, 0);
+		ctrl_2 = ReadVpuRegister(VE_CTI_GRP_REG, 0);
+		ctrl_1 |= (ve_cti_en << 1 | ve_idle_en << 6);
+		/* ve1_cti_cmd_depth for 1296 timing issue */
+		ctrl_2 = (ctrl_2 & ~(0x3f << 24)) | (0x1a << 24);
+		WriteVpuRegister(VE_CTRL_REG, ctrl_1, 0);
+		WriteVpuRegister(VE_CTI_GRP_REG, ctrl_2, 0);
+		if ((coreIdx & (1 << 2)) != 0) {
+			WriteVpuRegister(VE_CTRL_REG, 0x82, 2); /* DHCTHOR-28 */
+		}
+	}
+
+	/* coreIdx == 1 */
+	if ((coreIdx & (1 << 1)) != 0) {
+		ctrl_1 = ReadVpuRegister(W5_VE_CTRL_REG, 1);
+		ctrl_2 = ReadVpuRegister(W5_VE_CTI_GRP_REG, 1);
+		ctrl_1 |= (ve_cti_en << 1 | ve_idle_en << 6);
+		/* ve2_cti_cmd_depth for 1296 timing issue */
+		ctrl_2 = (ctrl_2 & ~(0x3f << 24)) | (0x1a << 24);
+		WriteVpuRegister(W5_VE_CTRL_REG, ctrl_1, 1);
+		WriteVpuRegister(W5_VE_CTI_GRP_REG, ctrl_2, 1);
+	}
+}
+
+int vpu_hw_reset(u32 coreIdx)
+{
+	struct reset_control *rstc;
+
+#if 1 /* RTK, workaround for demo */
+	DPRINTK("%s request vpu reset from application\n", DEV_NAME);
+
+	if (coreIdx == 0)
+		rstc = rstc_ve1;
+	else if (coreIdx == 1)
+		rstc = rstc_ve2;
+	else
+		rstc = rstc_ve3;
+
+	reset_control_reset(rstc);
+
+	ve1_wrapper_setup((1 << coreIdx));
+#endif
+	return 0;
+}
+
+static int vpu_alloc_dma_buffer(vpudrv_buffer_t *vb)
+{
+	unsigned int ret;
+
+	if (!vb)
+		return -1;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	UNUSED_PARAMETER(ret);
+	vb->phys_addr = (unsigned long)vmem_alloc(&s_vmem, vb->size, 0);
+	if ((unsigned long)vb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+
+	vb->base = (unsigned long)(s_video_memory.base + (vb->phys_addr - s_video_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	ret = pu_alloc_dma_buffer(vb->size, &vb->phys_addr, &vb->base, vb->mem_type);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#else
+	UNUSED_PARAMETER(ret);
+	vb->base = (unsigned long)dma_alloc_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (dma_addr_t *) (&vb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	DPRINTK("%s base:0x%lx, phy_addr:0x%lx, size:%d\n", DEV_NAME, vb->base, vb->phys_addr, vb->size);
+	return 0;
+}
+
+static int vpu_alloc_dma_buffer2(vpudrv_buffer_t *vb)
+{
+	unsigned int ret;
+
+	if (!vb)
+		return -1;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	UNUSED_PARAMETER(ret);
+	vb->phys_addr = (unsigned long)vmem_alloc(&s_vmem, vb->size, 0);
+	if ((unsigned long)vb->phys_addr  == (unsigned long)-1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+
+	vb->base = (unsigned long)(s_video_memory.base + (vb->phys_addr - s_video_memory.phys_addr));
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	ret = pu_alloc_dma_buffer(vb->size, &vb->phys_addr, &vb->base, vb->mem_type);
+	if (ret == -1) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+	vb->base = pu_mmap_kernel_buffer(vb->phys_addr, vb->size);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s pu_mmap_kernel_buffer error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#else
+	UNUSED_PARAMETER(ret);
+	vb->base = (unsigned long)dma_alloc_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (dma_addr_t *) (&vb->phys_addr), GFP_DMA | GFP_KERNEL);
+	if ((void *)(vb->base) == NULL) {
+		pr_err("%s Physical memory allocation error size=%d\n", DEV_NAME, vb->size);
+		return -1;
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	DPRINTK("%s base:0x%lx, phy_addr:0x%lx, size:%d\n", DEV_NAME, vb->base, vb->phys_addr, vb->size);
+	return 0;
+}
+
+static void vpu_free_dma_buffer(vpudrv_buffer_t *vb)
+{
+	if (!vb)
+		return;
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (vb->base)
+		vmem_free(&s_vmem, vb->phys_addr, 0);
+#elif defined(CONFIG_RTK_RESERVE_MEMORY)
+	pu_free_dma_buffer(vb->base, vb->phys_addr);
+#else
+	if (vb->base) {
+		dma_free_coherent(s_vpu_dev.this_device, PAGE_ALIGN(vb->size), (void *)vb->base, vb->phys_addr);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+}
+
+/* size=40 for Android M */
+#define PTHREAD_MUTEX_T_HANDLE_SIZE 40
+
+static int vpu_free_instances(struct file *filp)
+{
+	vpudrv_instanace_list_t *vil, *n;
+	vpudrv_instance_pool_t *vip;
+	void *vip_base;
+	int instance_pool_size_per_core;
+	void *vdi_mutexes_base;
+	const int PTHREAD_MUTEX_T_DESTROY_VALUE = 0xdead10cc;
+
+	DPRINTK("%s vpu_free_instances\n", DEV_NAME);
+
+	/* s_instance_pool.size  assigned to the size of all core once call VDI_IOCTL_GET_INSTANCE_POOL by user. */
+	instance_pool_size_per_core = (s_instance_pool.size/MAX_NUM_VPU_CORE);
+
+	list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+		if (vil->filp == filp) {
+			int i, j;
+			for (i = 0; i < MAX_NUM_INSTANCE; i++) /* reset dovi flag */
+			{
+				for (j = 0; j < MAX_NUM_VPU_CORE; j++)
+				{
+					pu_set_dovi_flag(j, i, 0);
+				}
+			}
+
+			vip_base = (void *)(s_instance_pool.base + (instance_pool_size_per_core*vil->core_idx));
+			DPRINTK("%s vpu_free_instances detect instance crash instIdx=%d, coreIdx=%d, vip_base=%p, instance_pool_size_per_core=%d\n", DEV_NAME, (int)vil->inst_idx, (int)vil->core_idx, vip_base, (int)instance_pool_size_per_core);
+			vip = (vpudrv_instance_pool_t *)vip_base;
+
+			if (vip) {
+				/* only first 4 byte is key point(inUse of CodecInst in vpuapi) to free the corresponding instance. */
+				memset(&vip->codecInstPool[vil->inst_idx], 0x00, 4);
+
+				if (vil->inst_idx == (vip->pendingInstIdxPlus1-1) && vip->pendingInst != 0) {
+					pr_warn("%s vil->inst_idx:%d, vil->core_idx:%d is pending, clear in here\n", DEV_NAME, (int)vil->inst_idx, (int)vil->core_idx);
+					vip->pendingInst = 0;
+					vip->pendingInstIdxPlus1 = 0;
+				}
+
+				vdi_mutexes_base = (vip_base + (instance_pool_size_per_core - PTHREAD_MUTEX_T_HANDLE_SIZE*4));
+				DPRINTK("%s vpu_free_instances : force to destroy vdi_mutexes_base=%p in userspace \n", DEV_NAME, vdi_mutexes_base);
+				if (vdi_mutexes_base) {
+					int i;
+					for (i = 0; i < 4; i++) {
+						memcpy(vdi_mutexes_base, &PTHREAD_MUTEX_T_DESTROY_VALUE, PTHREAD_MUTEX_T_HANDLE_SIZE);
+						vdi_mutexes_base += PTHREAD_MUTEX_T_HANDLE_SIZE;
+					}
+				}
+			}
+			s_vpu_open_ref_count--;
+			list_del(&vil->list);
+			kfree(vil);
+		}
+	}
+	return 1;
+}
+
+static int vpu_free_buffers(struct file *filp)
+{
+	vpudrv_buffer_pool_t *pool, *n;
+	vpudrv_buffer_t vb;
+
+	DPRINTK("%s vpu_free_buffers\n", DEV_NAME);
+
+	list_for_each_entry_safe(pool, n, &s_vbp_head, list) {
+		if (pool->filp == filp) {
+			vb = pool->vb;
+			if (vb.base) {
+				vpu_free_dma_buffer(&vb);
+				list_del(&pool->list);
+				kfree(pool);
+			}
+		}
+	}
+
+	return 0;
+}
+
+static irqreturn_t ve1_irq_handler(int irq, void *dev_id)
+{
+	vpu_drv_context_t *dev = (vpu_drv_context_t *)dev_id;
+
+	/* this can be removed. it also work in VPU_WaitInterrupt of API function */
+	int core = 0;
+	unsigned long interrupt_reason_ve1 = 0;
+	unsigned int vpu_int_sts_ve1 = 0;
+	unsigned long flags;
+	int int_sts = ReadVpuRegister(VE_INT_STS_REG, 0);
+
+	core = (int_sts & (1 << 0) ? 0 : 2);
+	//DPRINTK("%s [+]%s\n", DEV_NAME, __func__);
+
+	/* it means that we didn't get an information the current core from API layer. No core activated.*/
+	if (s_bit_firmware_info[core].size == 0) {
+		pr_err("[VPUDRV] :  s_bit_firmware_info[core].size is zero\n");
+		return IRQ_HANDLED;
+	}
+
+	vpu_int_sts_ve1 = ReadVpuRegister(BIT_INT_STS, core);
+	if (vpu_int_sts_ve1) {
+		interrupt_reason_ve1 = ReadVpuRegister(BIT_INT_REASON, core);
+		WriteVpuRegister(BIT_INT_REASON, 0, core);
+		WriteVpuRegister(BIT_INT_CLEAR, 0x1, core);
+	}
+
+	//DPRINTK("%s VE1 intr_reason: 0x%08lx\n", DEV_NAME, dev->interrupt_reason_ve1);
+
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN); /* notify the interrupt to user space */
+
+	if (vpu_int_sts_ve1) {
+		if (core == 0) {
+			spin_lock_irqsave(&s_ve1_lock, flags);
+			dev->interrupt_reason_ve1 = interrupt_reason_ve1;
+			atomic_set(&s_interrupt_flag_ve1, 1);
+			spin_unlock_irqrestore(&s_ve1_lock, flags);
+			wake_up_interruptible(&s_interrupt_wait_q_ve1);
+		} else {
+			spin_lock_irqsave(&s_ve3_lock, flags);
+			dev->interrupt_reason_ve3 = interrupt_reason_ve1;
+			atomic_set(&s_interrupt_flag_ve3, 1);
+			spin_unlock_irqrestore(&s_ve3_lock, flags);
+			wake_up_interruptible(&s_interrupt_wait_q_ve3);
+		}
+		//DPRINTK("%s [-]%s\n", DEV_NAME, __func__);
+	}
+
+	return IRQ_HANDLED;
+}
+
+#ifdef SUPPORT_MULTI_INST_INTR
+static inline u32 get_inst_idx(u32 reg_val)
+{
+	u32 inst_idx;
+	int i;
+	for (i=0; i < MAX_NUM_INSTANCE; i++)
+	{
+		if(((reg_val >> i)&0x01) == 1)
+			break;
+	}
+	inst_idx = i;
+	return inst_idx;
+}
+
+static u32 get_vpu_inst_idx(vpu_drv_context_t *dev, u32 *reason, u32 empty_inst, u32 done_inst, u32 other_inst)
+{
+	u32 inst_idx;
+	u32 reg_val;
+	u32 int_reason;
+
+	int_reason = *reason;
+	DPRINTK("%s [+]%s, int_reason=0x%x, empty_inst=0x%x, done_inst=0x%x\n", DEV_NAME, __func__, int_reason, empty_inst, done_inst);
+
+	if (int_reason & (1 << INT_WAVE5_BSBUF_EMPTY))
+	{
+		reg_val = empty_inst;
+		inst_idx = get_inst_idx(reg_val);
+		*reason = (1 << INT_WAVE5_BSBUF_EMPTY);
+		DPRINTK("%s	%s, W5_RET_BS_EMPTY_INST reg_val=0x%x, inst_idx=%d\n", DEV_NAME, __func__, reg_val, inst_idx);
+		goto GET_VPU_INST_IDX_HANDLED;
+	}
+
+	if (int_reason & (1 << INT_WAVE5_DEC_PIC))
+	{
+		reg_val = done_inst;
+		inst_idx = get_inst_idx(reg_val);
+		*reason  = (1 << INT_WAVE5_DEC_PIC);
+		DPRINTK("[VPUDRV]  %s, W5_RET_QUEUE_CMD_DONE_INST DEC_PIC reg_val=0x%x, inst_idx=%d\n", __func__, reg_val, inst_idx);
+		goto GET_VPU_INST_IDX_HANDLED;
+	}
+
+	if (int_reason & (1 << INT_WAVE5_INIT_SEQ))
+	{
+		reg_val = done_inst;
+		inst_idx = get_inst_idx(reg_val);
+		*reason  = (1 << INT_WAVE5_INIT_SEQ);
+		DPRINTK("[VPUDRV]  %s, W5_RET_QUEUE_CMD_DONE_INST INIT_SEQ reg_val=0x%x, inst_idx=%d\n", __func__, reg_val, inst_idx);
+		goto GET_VPU_INST_IDX_HANDLED;
+	}
+
+	// if  interrupt is not for empty and dec_pic and init_seq.
+	reg_val = (other_inst&0xFF);
+	inst_idx = reg_val;
+	*reason  = int_reason;
+	DPRINTK("%s	%s, W5_RET_DONE_INSTANCE_INFO reg_val=0x%x, inst_idx=%d\n", DEV_NAME, __func__, reg_val, inst_idx);
+GET_VPU_INST_IDX_HANDLED:
+
+	DPRINTK("%s [-]%s, inst_idx=%d. *reason=0x%x\n", DEV_NAME, __func__, inst_idx, *reason);
+
+	return inst_idx;
+}
+#endif
+static irqreturn_t ve2_irq_handler(int irq, void *dev_id)
+{
+	vpu_drv_context_t *dev = (vpu_drv_context_t *)dev_id;
+
+	/* this can be removed. it also work in VPU_WaitInterrupt of API function */
+	int core = 1;
+	unsigned int vpu_int_sts_ve2 = 0;
+	unsigned long flags;
+#ifdef SUPPORT_MULTI_INST_INTR
+	u32 intr_reason = 0;
+	u32 intr_inst_index = 0;
+#endif
+
+	//DPRINTK("%s [+]%s\n", DEV_NAME, __func__);
+
+	if (s_bit_firmware_info[core].size == 0) {/* it means that we didn't get an information the current core from API layer. No core activated.*/
+		pr_err("[VPUDRV] :  s_bit_firmware_info[core].size is zero\n");
+		return IRQ_HANDLED;
+	}
+
+	vpu_int_sts_ve2 = ReadVpuRegister(W5_VPU_INT_STS, core);
+	if (vpu_int_sts_ve2) {
+#ifdef SUPPORT_MULTI_INST_INTR
+		u32 intr_reason_reg;
+		u32 empty_inst;
+		u32 done_inst;
+		u32 other_inst;
+
+		intr_reason_reg = ReadVpuRegister(W5_VPU_INT_REASON, core);
+		empty_inst = ReadVpuRegister(W5_RET_BS_EMPTY_INST, core);
+		done_inst = ReadVpuRegister(W5_RET_QUEUE_CMD_DONE_INST, core);
+		other_inst = ReadVpuRegister(W5_RET_DONE_INSTANCE_INFO, core);
+
+		DPRINTK("%s %s reason=0x%x, empty_inst=0x%x, done_inst=0x%x, other_inst=0x%x \n", DEV_NAME,  __func__, intr_reason_reg, empty_inst, done_inst, other_inst);
+
+		intr_reason = intr_reason_reg;
+
+		intr_inst_index = get_vpu_inst_idx(dev, &intr_reason, empty_inst, done_inst, other_inst);
+#ifdef SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+		if (intr_inst_index >= 0 && intr_inst_index < MAX_NUM_INSTANCE)
+		{
+#define FIX_MULTI_INSTANCE_CLEAR_BS_EMPTY_AT_HOST
+#ifdef FIX_MULTI_INSTANCE_CLEAR_BS_EMPTY_AT_HOST
+			if (intr_reason == (1 << INT_WAVE5_BSBUF_EMPTY))
+			{
+				empty_inst = empty_inst & ~(1 << intr_inst_index);
+				WriteVpuRegister(W5_RET_BS_EMPTY_INST, empty_inst, core);
+				DPRINTK("[VPUDRV]   %s, W5_RET_BS_EMPTY_INST Clear empty_inst=0x%x, intr_inst_index=%d\n", __func__, empty_inst, intr_inst_index);
+			}
+
+			if ((intr_reason == (1 << INT_WAVE5_DEC_PIC)) || (intr_reason == (1 << INT_WAVE5_INIT_SEQ)))
+			{
+				done_inst = done_inst & ~(1 << intr_inst_index);
+				WriteVpuRegister(W5_RET_QUEUE_CMD_DONE_INST, done_inst, core);
+				DPRINTK("[VPUDRV]  %s, W5_RET_QUEUE_CMD_DONE_INST Clear done_inst=0x%x, intr_inst_index=%d\n", __func__, done_inst, intr_inst_index);
+			}
+#endif
+		}
+		if (intr_inst_index >= 0 && intr_inst_index < MAX_NUM_INSTANCE) {
+			if (!kfifo_is_full(&s_interrupt_pending_q_ve2[intr_inst_index])) {
+				kfifo_in(&s_interrupt_pending_q_ve2[intr_inst_index], &intr_reason, sizeof(u32));
+			}
+			else {
+				pr_err("%s :  kfifo_is_full kfifo_count=%d \n", DEV_NAME, kfifo_len(&s_interrupt_pending_q_ve2[intr_inst_index]));
+			}
+		}
+		else {
+			pr_err("%s :  intr_inst_index is wrong intr_inst_index=%d \n", DEV_NAME, intr_inst_index);
+		}
+
+#else
+		kfifo_in(&s_interrupt_pending_q_ve2[intr_inst_index], &intr_reason, sizeof(u32));
+#endif
+		WriteVpuRegister(W5_VPU_INT_REASON_CLEAR, intr_reason, core);
+#else
+		unsigned long interrupt_reason_ve2 = 0;
+		interrupt_reason_ve2 = ReadVpuRegister(W5_VPU_INT_REASON, core);
+		WriteVpuRegister(W5_VPU_INT_REASON_CLEAR, interrupt_reason_ve2, core);
+#endif
+		WriteVpuRegister(W5_VPU_INT_CLEAR, 0x1, core);
+	}
+	DPRINTK("%s VE2 intr_reason: 0x%08lx, intr_inst_index:%d\n", DEV_NAME, intr_reason, intr_inst_index);
+
+	if (dev->async_queue)
+		kill_fasync(&dev->async_queue, SIGIO, POLL_IN);	/* notify the interrupt to user space */
+
+	if (vpu_int_sts_ve2) {
+#ifdef SUPPORT_MULTI_INST_INTR
+#ifdef SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+		if (intr_inst_index >= 0 && intr_inst_index < MAX_NUM_INSTANCE) {
+			spin_lock_irqsave(&s_ve2_lock, flags);
+			atomic_set(&s_interrupt_flag_ve2[intr_inst_index], 1);
+			spin_unlock_irqrestore(&s_ve2_lock, flags);
+			wake_up_interruptible(&s_interrupt_wait_q_ve2[intr_inst_index]);
+		}
+#else
+		spin_lock_irqsave(&s_ve2_lock, flags);
+		atomic_set(&s_interrupt_flag_ve2[intr_inst_index], 1);
+		spin_unlock_irqrestore(&s_ve2_lock, flags);
+		wake_up_interruptible(&s_interrupt_wait_q_ve2[intr_inst_index]);
+#endif
+#else
+		spin_lock_irqsave(&s_ve2_lock, flags);
+		dev->interrupt_reason_ve2 = interrupt_reason_ve2;
+		atomic_set(&s_interrupt_flag_ve2, 1);
+		spin_unlock_irqrestore(&s_ve2_lock, flags);
+		wake_up_interruptible(&s_interrupt_wait_q_ve2);
+#endif
+		DPRINTK("%s [-]%s\n", DEV_NAME, __func__);
+	}
+
+	return IRQ_HANDLED;
+}
+
+static int vpu_open(struct inode *inode, struct file *filp)
+{
+	DPRINTK("%s [+] %s\n", DEV_NAME, __func__);
+	spin_lock(&s_vpu_lock);
+
+	s_vpu_drv_context.open_count++;
+
+	filp->private_data = (void *)(&s_vpu_drv_context);
+	spin_unlock(&s_vpu_lock);
+
+	DPRINTK("%s [-] %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+
+/*static int vpu_ioctl(struct inode *inode, struct file *filp, u_int cmd, u_long arg) // for kernel 2.6.9*/
+static long vpu_ioctl(struct file *filp, u_int cmd, u_long arg)
+{
+	int ret = 0;
+	struct vpu_drv_context_t *dev = (struct vpu_drv_context_t *)filp->private_data;
+
+	switch (cmd) {
+	case VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY:
+	{
+		vpudrv_buffer_pool_t *vbp;
+
+		DPRINTK("%s [+]VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			vbp = kzalloc(sizeof(*vbp), GFP_KERNEL);
+			if (!vbp) {
+				up(&s_vpu_sem);
+				return -ENOMEM;
+			}
+
+			ret = copy_from_user(&(vbp->vb), (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret) {
+				kfree(vbp);
+				up(&s_vpu_sem);
+				return -EFAULT;
+			}
+
+			ret = vpu_alloc_dma_buffer(&(vbp->vb));
+			if (ret == -1) {
+				ret = -ENOMEM;
+				kfree(vbp);
+				up(&s_vpu_sem);
+				break;
+			}
+
+			ret = copy_to_user((void __user *)arg, &(vbp->vb), sizeof(vpudrv_buffer_t));
+			if (ret) {
+				kfree(vbp);
+				ret = -EFAULT;
+				up(&s_vpu_sem);
+				break;
+			}
+
+			vbp->filp = filp;
+			spin_lock(&s_vpu_lock);
+			list_add(&vbp->list, &s_vbp_head);
+			spin_unlock(&s_vpu_lock);
+
+			up(&s_vpu_sem);
+		}
+		DPRINTK("%s [-]VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_FREE_PHYSICALMEMORY:
+	{
+		vpudrv_buffer_pool_t *vbp, *n;
+		vpudrv_buffer_t vb;
+
+		DPRINTK("%s [+]VDI_IOCTL_FREE_PHYSICALMEMORY\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			ret = copy_from_user(&vb, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret) {
+				up(&s_vpu_sem);
+				return -EACCES;
+			}
+
+			if (vb.base)
+				vpu_free_dma_buffer(&vb);
+
+			spin_lock(&s_vpu_lock);
+			list_for_each_entry_safe(vbp, n, &s_vbp_head, list) {
+				if (vbp->vb.phys_addr == vb.phys_addr/*vbp->vb.base == vb.base*/) {
+					list_del(&vbp->list);
+					kfree(vbp);
+					break;
+				}
+			}
+			spin_unlock(&s_vpu_lock);
+
+			up(&s_vpu_sem);
+		}
+		DPRINTK("%s [-]VDI_IOCTL_FREE_PHYSICALMEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO:
+	{
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+		DPRINTK("%s [+]VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO\n", DEV_NAME);
+		if (s_video_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_video_memory, sizeof(vpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = -EFAULT;
+		}
+		DPRINTK("%s [-]VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO\n", DEV_NAME);
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+	}
+	break;
+
+	case VDI_IOCTL_WAIT_INTERRUPT:
+	{
+		vpudrv_intr_info_t info;
+		unsigned long flags;
+#ifdef SUPPORT_MULTI_INST_INTR
+		u32 intr_inst_index;
+		u32 intr_reason_in_q;
+		u32 interrupt_flag_in_q;
+#endif
+		DPRINTK("[VPUDRV][+]VDI_IOCTL_WAIT_INTERRUPT\n");
+		ret = copy_from_user(&info, (vpudrv_intr_info_t *)arg, sizeof(vpudrv_intr_info_t));
+		if (ret != 0)
+			return -EFAULT;
+
+		/* VE1 */
+		if (info.core_idx == 0) {
+			smp_rmb();
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve1, atomic_read(&s_interrupt_flag_ve1) != 0, msecs_to_jiffies(info.timeout));
+			if (!ret) {
+				ret = -ETIME;
+				break;
+			}
+
+			if (signal_pending(current)) {
+				ret = -ERESTARTSYS;
+				break;
+			}
+
+			//DPRINTK("[VPUDRV] s_interrupt_flag_ve1(%d), reason(0x%08lx)\n", atomic_read(&s_interrupt_flag_ve1), dev->interrupt_reason_ve1);
+			spin_lock_irqsave(&s_ve1_lock, flags);
+			atomic_set(&s_interrupt_flag_ve1, 0);
+			info.intr_reason = dev->interrupt_reason_ve1;
+			dev->interrupt_reason_ve1 = 0;
+			spin_unlock_irqrestore(&s_ve1_lock, flags);
+		} else if (info.core_idx == 1) { /* VE2 */
+#ifdef USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+			ktime_t ktime;
+			unsigned long delay_in_ms = 1L;
+			ktime = ktime_set(0, MS_TO_NS(delay_in_ms));
+			//ktime = ktime_set(0, MS_TO_NS((u64)info.timeout));
+#endif /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+
+#ifdef SUPPORT_MULTI_INST_INTR
+			intr_inst_index = info.intr_inst_index;
+
+			intr_reason_in_q = 0;
+			interrupt_flag_in_q = kfifo_out(&s_interrupt_pending_q_ve2[intr_inst_index], &intr_reason_in_q, sizeof(u32));
+			DPRINTK("%s interrupt_flag_in_q:%d, intr_inst_index:%d, intr_reason_in_q:%d, kfifo_count=%d\n", DEV_NAME, interrupt_flag_in_q, intr_inst_index, intr_reason_in_q, kfifo_len(&s_interrupt_pending_q_ve2[intr_inst_index]));
+			if (interrupt_flag_in_q > 0)
+			{
+				dev->interrupt_reason_ve2[intr_inst_index] = intr_reason_in_q;
+				DPRINTK("%s Interrupt Remain : intr_inst_index=%d, intr_reason_in_q=0x%x, interrupt_flag_in_q=%d\n", DEV_NAME, intr_inst_index, intr_reason_in_q, interrupt_flag_in_q);
+				goto INTERRUPT_REMAIN_IN_QUEUE;
+			}
+#ifdef SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+			else {
+				dev->interrupt_reason_ve2[intr_inst_index] = 0;
+			}
+#endif
+
+#ifdef USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+			ret = wait_event_interruptible_hrtimeout(s_interrupt_wait_q_ve2[intr_inst_index], atomic_read(&s_interrupt_flag_ve2[intr_inst_index]) != 0, ktime);
+#else /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve2[intr_inst_index], atomic_read(&s_interrupt_flag_ve2[intr_inst_index]) != 0, msecs_to_jiffies(info.timeout));
+#endif /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+
+#else /* SUPPORT_MULTI_INST_INTR */
+			smp_rmb();
+#ifdef USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+			ret = wait_event_interruptible_hrtimeout(s_interrupt_wait_q_ve2, atomic_read(&s_interrupt_flag_ve2) != 0, ktime);
+#else /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve2, atomic_read(&s_interrupt_flag_ve2) != 0, msecs_to_jiffies(info.timeout));
+#endif /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+#endif /* SUPPORT_MULTI_INST_INTR */
+
+#ifdef USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT
+			if (ret) {
+				ret = -ETIME;
+				break;
+			}
+#else /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+			if (!ret) {
+				ret = -ETIME;
+				break;
+			}
+#endif /* USE_HRTIMEOUT_INSTEAD_OF_TIMEOUT */
+
+			if (signal_pending(current)) {
+				ret = -ERESTARTSYS;
+				break;
+			}
+
+#ifdef SUPPORT_MULTI_INST_INTR
+			intr_reason_in_q = 0;
+			interrupt_flag_in_q = kfifo_out(&s_interrupt_pending_q_ve2[intr_inst_index], &intr_reason_in_q, sizeof(u32));
+			if (interrupt_flag_in_q > 0) {
+				dev->interrupt_reason_ve2[intr_inst_index] = intr_reason_in_q;
+			}
+#endif
+
+#ifdef SUPPORT_MULTI_INST_INTR
+			DPRINTK("%s inst_index(%d), s_interrupt_flag(%d), reason(0x%08lx), kfifo_count=%d\n", DEV_NAME, intr_inst_index, s_interrupt_flag_ve2[intr_inst_index], dev->interrupt_reason_ve2[intr_inst_index], kfifo_len(&s_interrupt_pending_q_ve2[intr_inst_index]));
+#else
+			//DPRINTK("%s	s_interrupt_flag(%d), reason(0x%08lx)\n", DEV_NAME, s_interrupt_flag_ve2, dev->interrupt_reason_ve2);
+#endif
+
+INTERRUPT_REMAIN_IN_QUEUE:
+
+			spin_lock_irqsave(&s_ve2_lock, flags);
+#ifdef SUPPORT_MULTI_INST_INTR
+			info.intr_reason = dev->interrupt_reason_ve2[intr_inst_index];
+			atomic_set(&s_interrupt_flag_ve2[intr_inst_index], 0);
+			dev->interrupt_reason_ve2[intr_inst_index] = 0;
+#else
+			atomic_set(&s_interrupt_flag_ve2, 0);
+			info.intr_reason = dev->interrupt_reason_ve2;
+			dev->interrupt_reason_ve2 = 0;
+#endif
+			spin_unlock_irqrestore(&s_ve2_lock, flags);
+		} else { /* VE3 */
+			smp_rmb();
+			ret = wait_event_interruptible_timeout(s_interrupt_wait_q_ve3, atomic_read(&s_interrupt_flag_ve3) != 0, msecs_to_jiffies(info.timeout));
+			if (!ret) {
+				ret = -ETIME;
+				break;
+			}
+
+			if (signal_pending(current)) {
+				ret = -ERESTARTSYS;
+				break;
+			}
+
+			//DPRINTK("[VPUDRV] s_interrupt_flag_ve3(%d), reason(0x%08lx)\n", atomic_read(&s_interrupt_flag_ve3), dev->interrupt_reason_ve3);
+			spin_lock_irqsave(&s_ve3_lock, flags);
+			atomic_set(&s_interrupt_flag_ve3, 0);
+			info.intr_reason = dev->interrupt_reason_ve3;
+			dev->interrupt_reason_ve3 = 0;
+			spin_unlock_irqrestore(&s_ve3_lock, flags);
+		}
+
+		ret = copy_to_user((void __user *)arg, &info, sizeof(vpudrv_intr_info_t));
+		DPRINTK("[VPUDRV][-]VDI_IOCTL_WAIT_INTERRUPT, info.intr_reason[%d]:0x%x\n", intr_inst_index, info.intr_reason);
+		if (ret != 0)
+			return -EFAULT;
+	}
+	break;
+	case VDI_IOCTL_SET_CLOCK_GATE:
+	{
+		u32 clkgate;
+
+		//DPRINTK("[VPUDRV][+]VDI_IOCTL_SET_CLOCK_GATE\n");
+		if (get_user(clkgate, (u32 __user *) arg))
+			return -EFAULT;
+#ifdef VPU_SUPPORT_CLOCK_CONTROL
+		if (clkgate)
+			vpu_clk_enable(s_vpu_clk);
+		else
+			vpu_clk_disable(s_vpu_clk);
+#endif /* VPU_SUPPORT_CLOCK_CONTROL */
+		//DPRINTK("[VPUDRV][-]VDI_IOCTL_SET_CLOCK_GATE\n");
+	}
+	break;
+	case VDI_IOCTL_GET_INSTANCE_POOL:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_INSTANCE_POOL\n", DEV_NAME);
+
+		ret = down_interruptible(&s_vpu_sem);
+		if (ret == 0) {
+			if (s_instance_pool.base != 0) {
+				ret = copy_to_user((void __user *)arg, &s_instance_pool, sizeof(vpudrv_buffer_t));
+				if (ret != 0)
+					ret = -EFAULT;
+			} else {
+				ret = copy_from_user(&s_instance_pool, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+				if (ret == 0) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+					s_instance_pool.size = PAGE_ALIGN(s_instance_pool.size);
+					s_instance_pool.base = (unsigned long)vmalloc(s_instance_pool.size);
+					s_instance_pool.phys_addr = s_instance_pool.base;
+
+					if (s_instance_pool.base != 0)
+#else
+					if (vpu_alloc_dma_buffer2(&s_instance_pool) != -1)
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+					{
+						memset((void *)s_instance_pool.base, 0x0, s_instance_pool.size); /*clearing memory*/
+						ret = copy_to_user((void __user *)arg, &s_instance_pool, sizeof(vpudrv_buffer_t));
+						if (ret == 0) {
+							/* success to get memory for instance pool */
+							up(&s_vpu_sem);
+							break;
+						}
+					}
+
+				}
+				ret = -EFAULT;
+			}
+
+			up(&s_vpu_sem);
+		}
+
+		DPRINTK("%s [-]VDI_IOCTL_GET_INSTANCE_POOL\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_GET_COMMON_MEMORY:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_COMMON_MEMORY\n", DEV_NAME);
+		if (s_common_memory.base != 0) {
+			ret = copy_to_user((void __user *)arg, &s_common_memory, sizeof(vpudrv_buffer_t));
+			if (ret != 0)
+				ret = -EFAULT;
+		} else {
+			ret = copy_from_user(&s_common_memory, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+			if (ret == 0) {
+				if (vpu_alloc_dma_buffer(&s_common_memory) != -1) {
+					ret = copy_to_user((void __user *)arg, &s_common_memory, sizeof(vpudrv_buffer_t));
+					if (ret == 0) {
+						/* success to get memory for common memory */
+						break;
+					}
+				}
+			}
+
+			ret = -EFAULT;
+		}
+		DPRINTK("%s [-]VDI_IOCTL_GET_COMMON_MEMORY\n", DEV_NAME);
+	}
+	break;
+	case VDI_IOCTL_OPEN_INSTANCE:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+
+		vil = kzalloc(sizeof(*vil), GFP_KERNEL);
+		if (!vil)
+			return -ENOMEM;
+
+		if (copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t))) {
+			kfree(vil);
+			return -EFAULT;
+		}
+
+		vil->inst_idx = inst_info.inst_idx;
+		vil->core_idx = inst_info.core_idx;
+		vil->filp = filp;
+
+		spin_lock(&s_vpu_lock);
+		list_add(&vil->list, &s_inst_list_head);
+
+		inst_info.inst_open_count = 0; /* counting the current open instance number */
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		s_vpu_open_ref_count++; /* flag just for that vpu is in opened or closed */
+
+		if (copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t))) {
+			kfree(vil);
+			return -EFAULT;
+		}
+
+		DPRINTK("%s VDI_IOCTL_OPEN_INSTANCE core_idx=%d, inst_idx=%d, s_vpu_open_ref_count=%d, inst_open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, s_vpu_open_ref_count, inst_info.inst_open_count);
+	}
+	break;
+	case VDI_IOCTL_CLOSE_INSTANCE:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+
+		DPRINTK("%s [+]VDI_IOCTL_CLOSE_INSTANCE\n", DEV_NAME);
+		if (copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t)))
+			return -EFAULT;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->inst_idx == inst_info.inst_idx && vil->core_idx == inst_info.core_idx) {
+				list_del(&vil->list);
+				kfree(vil);
+				break;
+			}
+		}
+
+		inst_info.inst_open_count = 0; /* counting the current open instance number */
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+#ifdef SUPPORT_MULTI_INST_INTR
+		if(inst_info.core_idx == 1)
+			kfifo_reset(&s_interrupt_pending_q_ve2[inst_info.inst_idx]);
+#endif
+		spin_unlock(&s_vpu_lock);
+
+		s_vpu_open_ref_count--; /* flag just for that vpu is in opened or closed */
+
+		if (copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t)))
+			return -EFAULT;
+
+		DPRINTK("%s VDI_IOCTL_CLOSE_INSTANCE core_idx=%d, inst_idx=%d, s_vpu_open_ref_count=%d, inst_open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, s_vpu_open_ref_count, inst_info.inst_open_count);
+	}
+	break;
+	case VDI_IOCTL_GET_INSTANCE_NUM:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+		DPRINTK("%s [+]VDI_IOCTL_GET_INSTANCE_NUM\n", DEV_NAME);
+
+		ret = copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t));
+		if (ret != 0)
+			break;
+
+		inst_info.inst_open_count = 0;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			if (vil->core_idx == inst_info.core_idx)
+				inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		ret = copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t));
+
+		DPRINTK("%s VDI_IOCTL_GET_INSTANCE_NUM core_idx=%d, inst_idx=%d, open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, inst_info.inst_open_count);
+
+	}
+	break;
+	case VDI_IOCTL_RESET:
+	{
+		u32 coreIdx;
+		if (get_user(coreIdx, (u32 __user *) arg))
+			return -EFAULT;
+		vpu_hw_reset(coreIdx);
+	}
+	break;
+	case VDI_IOCTL_GET_REGISTER_INFO:
+	{
+		DPRINTK("%s [+]VDI_IOCTL_GET_REGISTER_INFO\n", DEV_NAME);
+		ret = copy_to_user((void __user *)arg, &s_vpu_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+		DPRINTK("%s [-]VDI_IOCTL_GET_REGISTER_INFO s_vpu_register.phys_addr=0x%lx, s_vpu_register.virt_addr=0x%lx, s_vpu_register.size=%d\n", DEV_NAME, s_vpu_register.phys_addr, s_vpu_register.virt_addr, s_vpu_register.size);
+	}
+	break;
+	/* RTK ioctl */
+	case VDI_IOCTL_SET_RTK_CLK_GATING:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+#ifdef CONFIG_POWER_CONTROL
+		struct power_control *pctrl;
+#endif
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_GATING\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		/* VE1 */
+		if (clockInfo.core_idx == 0) {
+			s_vpu_clk = s_vpu_clk_ve1;
+#ifdef CONFIG_POWER_CONTROL
+			pctrl = s_pctrl_ve1;
+#endif
+		} else if (clockInfo.core_idx == 1) {/* VE2 */
+			s_vpu_clk = s_vpu_clk_ve2;
+#ifdef CONFIG_POWER_CONTROL
+			pctrl = s_pctrl_ve2;
+#endif
+		} else {
+			s_vpu_clk = s_vpu_clk_ve3;
+#ifdef CONFIG_POWER_CONTROL
+			pctrl = s_pctrl_ve3;
+#endif
+		}
+
+		if (clockInfo.enable == 1) {
+			if (s_vpu_clk == s_vpu_clk_ve1 || s_vpu_clk == s_vpu_clk_ve3)
+			{
+#ifdef CONFIG_POWER_CONTROL
+				if (__clk_get_enable_count(s_vpu_clk_ve1) == 0 && __clk_get_enable_count(s_vpu_clk_ve3) == 0)
+				{
+					vpu_pctrl_on(s_pctrl_ve1);
+					vpu_pctrl_on(s_pctrl_ve3);
+				}
+#endif
+				vpu_clk_enable(s_vpu_clk_ve1);
+				vpu_clk_enable(s_vpu_clk_ve3);
+			}
+			else /* ve2 */
+			{
+#ifdef CONFIG_POWER_CONTROL
+				vpu_pctrl_on(pctrl);
+#endif
+				vpu_clk_enable(s_vpu_clk);
+				vpu_clk_enable(s_vpu_clk_ve2_bpu);
+			}
+			ve1_wrapper_setup((1 << clockInfo.core_idx));
+		} else {
+			if (s_vpu_clk == s_vpu_clk_ve1 || s_vpu_clk == s_vpu_clk_ve3)
+			{
+				vpu_clk_disable(s_vpu_clk_ve3);
+				vpu_clk_disable(s_vpu_clk_ve1);
+#ifdef CONFIG_POWER_CONTROL
+				if (__clk_get_enable_count(s_vpu_clk_ve1) == 0 && __clk_get_enable_count(s_vpu_clk_ve3) == 0)
+				{
+					vpu_pctrl_off(s_pctrl_ve3);
+					vpu_pctrl_off(s_pctrl_ve1);
+				}
+#endif
+			}
+			else /* ve2 */
+			{
+				vpu_clk_disable(s_vpu_clk_ve2_bpu);
+				vpu_clk_disable(s_vpu_clk);
+#ifdef CONFIG_POWER_CONTROL
+				vpu_pctrl_off(pctrl);
+#endif
+			}
+		}
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_GATING clockInfo.core_idx:%d, clockInfo.enable:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.enable);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_CLK_PLL:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_PLL\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		s_vpu_clk = clockInfo.core_idx == 1 ? s_vpu_clk_ve2 : s_vpu_clk_ve1;
+		if (vpu_clk_pll_set_rate(s_vpu_clk, clockInfo.value))
+			break;
+		ve1_wrapper_setup((1 << clockInfo.core_idx));
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_PLL clockInfo.core_idx:%d, clockInfo.value:0x%x\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_CLK_PLL:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+
+		DPRINTK("%s [+]VDI_IOCTL_GET_RTK_CLK_PLL\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		s_vpu_clk = clockInfo.core_idx == 1 ? s_vpu_clk_ve2 : s_vpu_clk_ve1;
+		clockInfo.value = (unsigned int)clk_get_rate(s_vpu_clk);
+		ret = copy_to_user((vpu_clock_info_t *)arg, &clockInfo, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_GET_RTK_CLK_PLL clockInfo.core_idx:%d, clockInfo.value:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_CLK_SELECT:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+		struct clk *s_pclk = NULL;
+
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_CLK_SELECT\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		s_vpu_clk = clockInfo.core_idx == 1 ? s_vpu_clk_ve2 : s_vpu_clk_ve1;
+		switch(clockInfo.value)
+		{
+			case VE_PLL_SYSH:
+				s_pclk = s_vpu_clk_sysh;
+				break;
+			case VE_PLL_VE1:
+				s_pclk = s_vpu_pll_ve1;
+				break;
+			case VE_PLL_VE2:
+				s_pclk = s_vpu_pll_ve2;
+				break;
+			default:
+				pr_warn("%s  %s %d, wrong value:0x%x\n", DEV_NAME, __func__, __LINE__, clockInfo.value);
+				break;
+		}
+		if (s_pclk != NULL)
+			clk_set_parent(s_vpu_clk, s_pclk);
+
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_CLK_SELECT clockInfo.core_idx:%d, clockInfo.value:0x%x\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_CLK_SELECT:
+	{
+		vpu_clock_info_t clockInfo;
+		struct clk *s_vpu_clk;
+		struct clk *s_pclk;
+		DPRINTK("%s [+]VDI_IOCTL_GET_RTK_CLK_SELECT\n", DEV_NAME);
+		ret = copy_from_user(&clockInfo, (vpu_clock_info_t *)arg, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+
+		s_vpu_clk = clockInfo.core_idx == 1 ? s_vpu_clk_ve2 : s_vpu_clk_ve1;
+		s_pclk = clk_get_parent(s_vpu_clk);
+		if (clk_is_match(s_pclk, s_vpu_clk_sysh))
+		{
+			clockInfo.value = (unsigned int)VE_PLL_SYSH;
+		}
+		else if (clk_is_match(s_pclk, s_vpu_pll_ve1))
+		{
+			clockInfo.value = (unsigned int)VE_PLL_VE1;
+		}
+		else if (clk_is_match(s_pclk, s_vpu_pll_ve2))
+		{
+			clockInfo.value = (unsigned int)VE_PLL_VE2;
+		}
+
+		ret = copy_to_user((vpu_clock_info_t *)arg, &clockInfo, sizeof(vpu_clock_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_GET_RTK_CLK_SELECT clockInfo.core_idx:%d, clockInfo.value:%d\n", DEV_NAME, clockInfo.core_idx, clockInfo.value);
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_SUPPORT_TYPE:
+	{
+		ret = copy_to_user((void __user *)arg, &s_bond_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_DCSYS_INFO:
+	{
+		vpudrv_buffer_t vb;
+		ret = copy_from_user(&vb, (vpudrv_buffer_t *)arg, sizeof(vpudrv_buffer_t));
+		if (vb.mem_type == 0)
+			ret = copy_to_user((void __user *)arg, &s_dc_register, sizeof(vpudrv_buffer_t));
+		else
+			ret = copy_to_user((void __user *)arg, &s_dmc_register, sizeof(vpudrv_buffer_t));
+		if (ret != 0)
+			ret = -EFAULT;
+	}
+	break;
+	case VDI_IOCTL_GET_RTK_ASIC_REVISION:
+	{
+		__put_user(get_rtd_chip_revision()|get_rtd_chip_id(), (unsigned int *) arg);
+	}
+	break;
+	case VDI_IOCTL_SET_RTK_DOVI_FLAG:
+	{
+		vpudrv_dovi_info_t doviInfo;
+		DPRINTK("%s [+]VDI_IOCTL_SET_RTK_DOVI_FLAG\n", DEV_NAME);
+		ret = copy_from_user(&doviInfo, (vpudrv_dovi_info_t *)arg, sizeof(vpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+
+		doviInfo.enable = pu_set_dovi_flag(doviInfo.core_idx, doviInfo.inst_idx, doviInfo.enable);
+
+		ret = copy_to_user((vpudrv_dovi_info_t *)arg, &doviInfo, sizeof(vpudrv_dovi_info_t));
+		if (ret != 0)
+			break;
+		DPRINTK("%s [-]VDI_IOCTL_SET_RTK_DOVI_FLAG doviInfo.core_idx:%d, doviInfo.inst_idx:%d, doviInfo.value:%d\n", DEV_NAME, doviInfo.core_idx, doviInfo.inst_idx, doviInfo.enable);
+	}
+	break;
+	case VDI_IOCTL_GET_TOTAL_INSTANCE_NUM:
+	{
+		vpudrv_inst_info_t inst_info;
+		vpudrv_instanace_list_t *vil, *n;
+		DPRINTK("%s [+]VDI_IOCTL_GET_TOTAL_INSTANCE_NUM\n", DEV_NAME);
+
+		ret = copy_from_user(&inst_info, (vpudrv_inst_info_t *)arg, sizeof(vpudrv_inst_info_t));
+		if (ret != 0)
+			break;
+
+		inst_info.inst_open_count = 0;
+
+		spin_lock(&s_vpu_lock);
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			inst_info.inst_open_count++;
+		}
+		spin_unlock(&s_vpu_lock);
+
+		ret = copy_to_user((void __user *)arg, &inst_info, sizeof(vpudrv_inst_info_t));
+
+		DPRINTK("%s VDI_IOCTL_GET_TOTAL_INSTANCE_NUM core_idx=%d, inst_idx=%d, open_count=%d\n", DEV_NAME, (int)inst_info.core_idx, (int)inst_info.inst_idx, inst_info.inst_open_count);
+
+	}
+	break;
+	default:
+	{
+		pr_err("%s No such IOCTL, cmd is %d\n", DEV_NAME, cmd);
+	}
+	break;
+	}
+
+	return ret;
+}
+
+static ssize_t vpu_read(struct file *filp, char __user *buf, size_t len, loff_t *ppos)
+{
+	return -1;
+}
+
+static int compat_get_vpu_bit_firmware_info_data(
+	compat_vpu_bit_firmware_info_t __user *data32,
+	vpu_bit_firmware_info_t __user *data)
+{
+#if defined(CONFIG_CPU_V7)
+	//u32 s;
+	u32 c;
+	u32 r;
+	u32 b[512];
+#else
+	//compat_uint_t s;
+	compat_uint_t c;
+	compat_ulong_t r;
+	compat_ushort_t b[512];
+#endif /* CONFIG_CPU_V7 */
+
+	int err;
+
+	//err = get_user(s, &data32->size);
+	//err |= put_user(s, &data->size);
+	err = get_user(c, &data32->core_idx);
+	err |= put_user(c, &data->core_idx);
+	err |= get_user(r, &data32->reg_base_offset);
+	err |= put_user(r, &data->reg_base_offset);
+	err |= copy_from_user(b, data32->bit_code, sizeof(b));
+	err |= copy_to_user(data->bit_code, b, sizeof(b));
+
+	return err;
+};
+
+static ssize_t vpu_write(struct file *filp, const char __user *buf, size_t len, loff_t *ppos)
+{
+
+	/* DPRINTK("[VPUDRV] vpu_write len=%d\n", (int)len); */
+	if (!buf) {
+		pr_err("%s vpu_write buf = NULL error \n", DEV_NAME);
+		return -EFAULT;
+	}
+
+	if (len == sizeof(vpu_bit_firmware_info_t) || len == sizeof(compat_vpu_bit_firmware_info_t))	{
+		vpu_bit_firmware_info_t *bit_firmware_info;
+
+		bit_firmware_info = kmalloc(sizeof(vpu_bit_firmware_info_t), GFP_KERNEL);
+		if (!bit_firmware_info) {
+			pr_err("%s vpu_write  bit_firmware_info allocation error\n", DEV_NAME);
+			return -EFAULT;
+		}
+
+		if (len == sizeof(vpu_bit_firmware_info_t)) {
+			if (copy_from_user(bit_firmware_info, buf, len)) {
+				pr_err("%s vpu_write copy_from_user error for bit_firmware_info\n", DEV_NAME);
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+		}
+#ifdef CONFIG_COMPAT
+		 else {
+			int err;
+			compat_vpu_bit_firmware_info_t __user *data32;
+			vpu_bit_firmware_info_t __user *data;
+
+			data32 = (compat_vpu_bit_firmware_info_t __user *) buf;
+			data = compat_alloc_user_space(sizeof(*data));
+			if (data == NULL) {
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+
+			err = compat_get_vpu_bit_firmware_info_data(data32, data);
+			if (err) {
+				kfree(bit_firmware_info);
+				return err;
+			}
+
+			if (copy_from_user(bit_firmware_info, data, sizeof(vpu_bit_firmware_info_t))) {
+				pr_err("%s vpu_write copy_from_user error for bit_firmware_info\n", DEV_NAME);
+				kfree(bit_firmware_info);
+				return -EFAULT;
+			}
+			bit_firmware_info->size = sizeof(vpu_bit_firmware_info_t);
+		}
+#endif /* CONFIG_COMPAT */
+
+		if (bit_firmware_info->size == sizeof(vpu_bit_firmware_info_t)) {
+			DPRINTK("%s vpu_write set bit_firmware_info coreIdx=0x%x, reg_base_offset=0x%x size=0x%x, bit_code[0]=0x%x\n",
+					DEV_NAME, bit_firmware_info->core_idx, (int)bit_firmware_info->reg_base_offset, bit_firmware_info->size, bit_firmware_info->bit_code[0]);
+
+			if (bit_firmware_info->core_idx > MAX_NUM_VPU_CORE) {
+				pr_err("%s vpu_write coreIdx[%d] is exceeded than MAX_NUM_VPU_CORE[%d]\n", DEV_NAME, bit_firmware_info->core_idx, MAX_NUM_VPU_CORE);
+				kfree(bit_firmware_info);
+				return -ENODEV;
+			}
+
+			memcpy((void *)&s_bit_firmware_info[bit_firmware_info->core_idx], bit_firmware_info, sizeof(vpu_bit_firmware_info_t));
+			kfree(bit_firmware_info);
+
+			return len;
+		}
+
+		kfree(bit_firmware_info);
+	}
+
+	return -1;
+}
+
+static int vpu_release(struct inode *inode, struct file *filp)
+{
+	int ret = 0;
+	DPRINTK("%s vpu_release\n", DEV_NAME);
+
+	ret = down_interruptible(&s_vpu_sem);
+	if (ret == 0) {
+		/* found and free the not handled buffer by user applications */
+		vpu_free_buffers(filp);
+		/* found and free the not closed instance by user applications */
+		vpu_free_instances(filp);
+		s_vpu_drv_context.open_count--;
+		if (s_vpu_drv_context.open_count == 0) {
+			if (s_instance_pool.base) {
+				DPRINTK("%s free instance pool\n", DEV_NAME);
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+				vfree((const void *)s_instance_pool.base);
+#else
+				pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+				vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+				s_instance_pool.base = 0;
+			}
+#if 0 /* Fuchun 20150909, we must not free instance pool and common memory */
+			if (s_common_memory.base) {
+				DPRINTK("%s free common memory\n", DEV_NAME);
+				vpu_free_dma_buffer(&s_common_memory);
+				s_common_memory.base = 0;
+			}
+#endif
+		}
+	}
+	up(&s_vpu_sem);
+
+	return 0;
+}
+
+static int vpu_fasync(int fd, struct file *filp, int mode)
+{
+	struct vpu_drv_context_t *dev = (struct vpu_drv_context_t *)filp->private_data;
+	return fasync_helper(fd, filp, mode, &dev->async_queue);
+}
+
+static int vpu_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	pfn = vm->vm_pgoff;
+
+	return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int vpu_map_to_physical_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef CONFIG_RTK_RESERVE_MEMORY
+	return pu_mmap_dma_buffer(vm);
+#else
+	vm->vm_flags |= VM_IO | VM_RESERVED;
+	vm->vm_page_prot = pgprot_writecombine(vm->vm_page_prot);
+
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif /* CONFIG_RTK_RESERVE_MEMORY */
+}
+
+static int vpu_map_to_instance_pool_memory(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	int ret;
+	long length = vm->vm_end - vm->vm_start;
+	unsigned long start = vm->vm_start;
+	char *vmalloc_area_ptr = (char *)s_instance_pool.base;
+	unsigned long pfn;
+
+	vm->vm_flags |= VM_RESERVED;
+
+	/* loop over all pages, map it page individually */
+	while (length > 0) {
+		pfn = vmalloc_to_pfn(vmalloc_area_ptr);
+		ret = remap_pfn_range(vm, start, pfn, PAGE_SIZE, PAGE_SHARED);
+		if (ret < 0) {
+			return ret;
+		}
+		start += PAGE_SIZE;
+		vmalloc_area_ptr += PAGE_SIZE;
+		length -= PAGE_SIZE;
+	}
+
+	return 0;
+#else
+	vm->vm_flags |= VM_RESERVED;
+	vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+	return remap_pfn_range(vm, vm->vm_start, vm->vm_pgoff, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+}
+
+/*!
+ * @brief memory map interface for vpu file operation
+ * @return  0 on success or negative error code on error
+ */
+static int vpu_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+	if (vm->vm_pgoff == 0)
+		return vpu_map_to_instance_pool_memory(fp, vm);
+
+	if ((vm->vm_pgoff == (s_vpu_register.phys_addr>>PAGE_SHIFT))
+	|| (vm->vm_pgoff == (s_bond_register.phys_addr>>PAGE_SHIFT))
+	|| (vm->vm_pgoff == (s_dc_register.phys_addr>>PAGE_SHIFT))
+	|| (vm->vm_pgoff == (s_dmc_register.phys_addr>>PAGE_SHIFT)))
+		return vpu_map_to_register(fp, vm);
+
+	return vpu_map_to_physical_memory(fp, vm);
+#else
+	if (vm->vm_pgoff) {
+		if (vm->vm_pgoff == (s_instance_pool.phys_addr>>PAGE_SHIFT))
+			return vpu_map_to_instance_pool_memory(fp, vm);
+
+		return vpu_map_to_physical_memory(fp, vm);
+	} else {
+		return vpu_map_to_register(fp, vm);
+	}
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+}
+
+struct file_operations vpu_fops = {
+	.owner = THIS_MODULE,
+	.open = vpu_open,
+	.read = vpu_read,
+	.write = vpu_write,
+	/*.ioctl = vpu_ioctl, // for kernel 2.6.9*/
+	.unlocked_ioctl = vpu_ioctl,
+	.compat_ioctl = compat_vpu_ioctl,
+	.release = vpu_release,
+	.fasync = vpu_fasync,
+	.mmap = vpu_mmap,
+};
+
+
+static int vpu_probe(struct platform_device *pdev)
+{
+	int err = 0;
+	u32 bonding_value;
+	unsigned long virt_addr;
+	struct resource res;
+	void __iomem *iobase;
+	int irq;
+	struct device_node *node = pdev->dev.of_node;
+#if 0 //Fuchun disable 20160204, set clock gating by vdi.c
+	unsigned int val = 0;
+#endif
+
+	pr_info("%s vpu_probe\n", DEV_NAME);
+
+	of_address_to_resource(node, 0, &res);
+	iobase = of_iomap(node, 0);
+
+	s_vpu_register.phys_addr = res.start;
+	s_vpu_register.virt_addr = (unsigned long)iobase;
+	s_vpu_register.size = res.end - res.start + 1;
+
+	pr_info("%s vpu base address get from DTB physical base addr=0x%lx, virtual base=0x%lx, size=0x%x\n", DEV_NAME, s_vpu_register.phys_addr, s_vpu_register.virt_addr, s_vpu_register.size);
+
+	of_address_to_resource(node, 1, &res);
+	iobase = of_iomap(node, 1);
+
+	s_dc_register.phys_addr = res.start;
+	s_dc_register.virt_addr = (unsigned long)iobase;
+	s_dc_register.size = res.end - res.start + 1;
+
+	s_vpu_dev.minor = MISC_VE1_MINOR;
+	s_vpu_dev.name = VPU_DEV_NAME;
+	s_vpu_dev.fops = &vpu_fops;
+	s_vpu_dev.parent = NULL;
+	if (misc_register(&s_vpu_dev)) {
+		pr_err("%s failed to register misc device.", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	of_address_to_resource(node, 2, &res);
+	iobase = of_iomap(node, 2);
+
+	s_bond_register.phys_addr = res.start;
+	s_bond_register.virt_addr = (unsigned long)iobase;
+	s_bond_register.size = res.end - res.start + 1;
+
+	virt_addr = (unsigned long)iobase;
+	bonding_value = __raw_readl((volatile u8 *)virt_addr);
+
+	pr_info("%s res.start:0x%llx, bonding_value:0x%x\n", DEV_NAME, res.start, bonding_value);
+
+	of_address_to_resource(node, 3, &res);
+	iobase = of_iomap(node, 3);
+
+	s_dmc_register.phys_addr = res.start;
+	s_dmc_register.virt_addr = (unsigned long)iobase;
+	s_dmc_register.size = res.end - res.start + 1;
+
+	s_vpu_clk_ve1 = vpu_clk_get(&pdev->dev, 0);
+	s_vpu_clk_ve2 = vpu_clk_get(&pdev->dev, 1);
+	s_vpu_clk_ve3 = vpu_clk_get(&pdev->dev, 2);
+	s_vpu_clk_ve2_bpu = clk_get(&pdev->dev, "clk_ve2_bpu");
+	s_vpu_clk_sysh = clk_get(&pdev->dev, "clk_sysh");
+	s_vpu_pll_ve1 = clk_get(&pdev->dev, "pll_ve1");
+	s_vpu_pll_ve2 = clk_get(&pdev->dev, "pll_ve2");
+
+#ifdef CONFIG_POWER_CONTROL
+	s_pctrl_ve1 = vpu_pctrl_get(0);
+	s_pctrl_ve2 = vpu_pctrl_get(1);
+	s_pctrl_ve3 = vpu_pctrl_get(2);
+#endif
+
+	p_vpu_dev = &pdev->dev;
+
+#ifdef VPU_SUPPORT_CLOCK_CONTROL
+	vpu_clk_enable(s_vpu_clk_ve1);
+	vpu_clk_enable(s_vpu_clk_ve2);
+	vpu_clk_enable(s_vpu_clk_ve2_bpu);
+	vpu_clk_enable(s_vpu_clk_ve3);
+#endif
+
+	irq = irq_of_parse_and_map(node, 0);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_ve1_irq = irq;
+	pr_info("%s s_ve1_irq:%d want to register ve1_irq_handler\n", DEV_NAME, s_ve1_irq);
+	err = request_irq(s_ve1_irq, ve1_irq_handler, 0, "VE1_CODEC_IRQ", (void *)(&s_vpu_drv_context));
+	err = 0;
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_ve1_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_ve1_irq <%d> busy, change your config\n", DEV_NAME, s_ve1_irq);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	irq = irq_of_parse_and_map(node, 1);
+	if (irq <= 0)
+		panic("Can't parse IRQ");
+
+	s_ve2_irq = irq;
+	pr_info("%s s_ve2_irq:%d want to register ve2_irq_handler\n", DEV_NAME, s_ve2_irq);
+	err = request_irq(s_ve2_irq, ve2_irq_handler, 0, "VE2_CODEC_IRQ", (void *)(&s_vpu_drv_context));
+	if (err != 0) {
+		if (err == -EINVAL)
+			pr_err("%s Bad s_ve2_irq number or handler\n", DEV_NAME);
+		else if (err == -EBUSY)
+			pr_err("%s s_ve2_irq <%d> busy, change your config\n", DEV_NAME, s_ve2_irq);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	s_video_memory.size = VPU_INIT_VIDEO_MEMORY_SIZE_IN_BYTE;
+	s_video_memory.phys_addr = VPU_DRAM_PHYSICAL_BASE;
+	s_video_memory.base = (unsigned long)ioremap_nocache(s_video_memory.phys_addr, PAGE_ALIGN(s_video_memory.size));
+	if (!s_video_memory.base) {
+		pr_err("%s fail to remap video memory physical phys_addr=0x%x, base=0x%x, size=%d\n", DEV_NAME, (int)s_video_memory.phys_addr, (int)s_video_memory.base, (int)s_video_memory.size);
+		goto ERROR_PROVE_DEVICE;
+	}
+
+	if (vmem_init(&s_vmem, s_video_memory.phys_addr, s_video_memory.size) < 0) {
+		pr_err("%s fail to init vmem system\n", DEV_NAME);
+		goto ERROR_PROVE_DEVICE;
+	}
+	pr_info("%s success to probe vpu device with reserved video memory phys_addr=0x%x, base = 0x%x\n", DEV_NAME, (int) s_video_memory.phys_addr, (int)s_video_memory.base);
+#else
+	pr_info("%s success to probe vpu device with non reserved video memory\n", DEV_NAME);
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+#ifndef CONFIG_RTK_PLATFORM_FPGA
+	/* RESET disable */
+	rstc_ve1 = reset_control_get(&pdev->dev, "ve1");
+	rstc_ve2 = reset_control_get(&pdev->dev, "ve2");
+	rstc_ve3 = reset_control_get(&pdev->dev, "ve3");
+
+	reset_control_deassert(rstc_ve1);
+	reset_control_deassert(rstc_ve2);
+	reset_control_deassert(rstc_ve3);
+
+
+#endif /* CONFIG_RTK_PLATFORM_FPGA */
+
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_on(s_pctrl_ve1);
+	vpu_pctrl_on(s_pctrl_ve2);
+	vpu_pctrl_on(s_pctrl_ve3);
+	vpu_pctrl_off(s_pctrl_ve1);
+	//vpu_pctrl_off(s_pctrl_ve2);
+	vpu_pctrl_off(s_pctrl_ve3);
+#endif /* CONFIG_POWER_CONTROL */
+
+#if 0 /* Fuchun disable 20160204, set clock gating by vdi.c */
+	val = ReadVpuRegister(VE_CTRL_REG, 0);
+	val |= (ve_cti_en << 1 | ve_idle_en << 6);
+	WriteVpuRegister(VE_CTRL_REG, val, 0);
+
+	pr_info("%s VE1_CTRL_REG = 0x%08x (0x%08x)\n", DEV_NAME, val, ReadVpuRegister(VE_CTRL_REG, 0));
+
+	val = ReadVpuRegister(W5_VE_CTRL_REG, 1);
+	val |= (ve_cti_en << 1 | ve_idle_en << 6);
+	WriteVpuRegister(W5_VE_CTRL_REG, val, 1);
+
+	pr_info("%s VE2_CTRL_REG = 0x%08x (0x%08x)\n", DEV_NAME, val, ReadVpuRegister(W5_VE_CTRL_REG, 1));
+#endif
+
+	return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+	misc_deregister(&s_vpu_dev);
+
+	return err;
+}
+
+static int vpu_remove(struct platform_device *pdev)
+{
+	DPRINTK("%s vpu_remove\n", DEV_NAME);
+
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+		vpu_free_dma_buffer(&s_instance_pool);
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+		s_instance_pool.base = 0;
+	}
+
+	if (s_common_memory.base) {
+		vpu_free_dma_buffer(&s_common_memory);
+		s_common_memory.base = 0;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_video_memory.base) {
+		iounmap((void *)s_video_memory.base);
+		s_video_memory.base = 0;
+		vmem_exit(&s_vmem);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	misc_deregister(&s_vpu_dev);
+
+#ifdef VPU_SUPPORT_ISR
+	if (s_ve1_irq)
+		free_irq(s_ve1_irq, &s_vpu_drv_context);
+	if (s_ve2_irq)
+		free_irq(s_ve2_irq, &s_vpu_drv_context);
+#endif /* VPU_SUPPORT_ISR */
+
+
+	vpu_clk_put(s_vpu_clk_ve3);
+	vpu_clk_put(s_vpu_clk_ve1);
+	vpu_clk_put(s_vpu_clk_ve2);
+	vpu_clk_put(s_vpu_clk_ve2_bpu);
+
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+
+	return 0;
+}
+
+#ifdef CONFIG_PM
+/* DO NOT CHANGE */
+#define WAVE5_STACK_SIZE (8*1024)
+#define W5_MAX_CODE_BUF_SIZE (512*1024)
+#define W5_CMD_INIT_VPU (0x0001)
+#define W5_CMD_SLEEP_VPU (0x0400)
+#define W5_CMD_WAKEUP_VPU (0x0800)
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+static void Wave5BitIssueCommand(u32 cmd)
+{
+	WriteVpuRegister(W5_VPU_BUSY_STATUS, 1, 1);
+	WriteVpuRegister(W5_CORE_INDEX,  0, 1);
+	/* coreIdx = ReadVpuRegister(W5_VPU_BUSY_STATUS, 1);*/
+	/* coreIdx = 0;*/
+	/* WriteVpuRegister(W5_INST_INDEX,  (instanceIndex&0xffff)|(codecMode<<16), 1);*/
+	WriteVpuRegister(W5_COMMAND, cmd, 1);
+	WriteVpuRegister(W5_VPU_HOST_INT_REQ, 1, 1);
+
+	return;
+}
+#endif /* DISABLE_ORIGIN_SUSPEND */
+
+static int vpu_suspend(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_on(s_pctrl_ve1);
+	vpu_pctrl_on(s_pctrl_ve2);
+	vpu_pctrl_on(s_pctrl_ve3);
+#endif
+	vpu_clk_enable(s_vpu_clk_ve1);
+	vpu_clk_enable(s_vpu_clk_ve2);
+	vpu_clk_enable(s_vpu_clk_ve2_bpu);
+	vpu_clk_enable(s_vpu_clk_ve3);
+
+	/* RTK wrapper */
+	ve1_wrapper_setup((1 << 2) | (1 << 1) | 1);
+
+	if (s_vpu_open_ref_count > 0) {
+#ifdef DISABLE_ORIGIN_SUSPEND
+		vpudrv_instanace_list_t *vil, *n;
+		vpudrv_instance_pool_t *vip;
+		void *vip_base;
+		int instance_pool_size_per_core;
+		vpudrv_buffer_pool_t *pool, *nn;
+		vpudrv_buffer_t vb;
+		s_vpu_drv_context.open_count = 0;
+		s_vpu_open_ref_count = 0;
+
+		/* s_instance_pool.size  assigned to the size of all core once call VDI_IOCTL_GET_INSTANCE_POOL by user. */
+		instance_pool_size_per_core = (s_instance_pool.size/MAX_NUM_VPU_CORE);
+
+		wake_up_interruptible_all(&s_interrupt_wait_q_ve1);
+		atomic_set(&s_interrupt_flag_ve1, 0);
+		wake_up_interruptible_all(&s_interrupt_wait_q_ve3);
+		atomic_set(&s_interrupt_flag_ve3, 0);
+
+#ifdef SUPPORT_MULTI_INST_INTR
+		{
+			int i;
+			for (i=0; i<MAX_NUM_INSTANCE; i++) {
+				wake_up_interruptible_all(&s_interrupt_wait_q_ve2[i]);
+				atomic_set(&s_interrupt_flag_ve2[i], 0);
+			}
+		}
+#else
+		atomic_set(&s_interrupt_flag_ve2, 0);
+#endif
+
+		list_for_each_entry_safe(vil, n, &s_inst_list_head, list) {
+			vip_base = (void *)(s_instance_pool.base + (instance_pool_size_per_core*vil->core_idx));
+			vip = (vpudrv_instance_pool_t *)vip_base;
+			if (vip) {
+				/* only first 4 byte is key point(inUse of CodecInst in vpuapi) to free the corresponding instance. */
+				memset(&vip->codecInstPool[vil->inst_idx], 0x00, 4);
+			}
+			list_del(&vil->list);
+			kfree(vil);
+		}
+
+		list_for_each_entry_safe(pool, nn, &s_vbp_head, list) {
+			vb = pool->vb;
+			if (vb.base) {
+				vpu_free_dma_buffer(&vb);
+			}
+			list_del(&pool->list);
+			kfree(pool);
+		}
+
+		if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+			vfree((const void *)s_instance_pool.base);
+#else
+			pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+			vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+			s_instance_pool.base = 0;
+		}
+#else /* else of DISABLE_ORIGIN_SUSPEND */
+		int i;
+		int core;
+		unsigned long timeout = jiffies + HZ; /* vpu wait timeout to 1sec */
+		int product_code = 0;
+
+		for (core = 0; core < MAX_NUM_VPU_CORE; core++) {
+			if (s_bit_firmware_info[core].size == 0)
+				continue;
+			product_code = ReadVpuRegister(VPU_PRODUCT_CODE_REGISTER, core);
+			if (PRODUCT_CODE_W_SERIES(product_code)) {
+				while (ReadVpuRegister(W5_VPU_BUSY_STATUS, core)) {
+					if (time_after(jiffies, timeout)) {
+						DPRINTK("%s SLEEP_VPU BUSY timeout", DEV_NAME);
+						goto DONE_SUSPEND;
+					}
+				}
+				Wave5BitIssueCommand(W5_CMD_SLEEP_VPU);
+
+				while (ReadVpuRegister(W5_VPU_BUSY_STATUS, core)) {
+					if (time_after(jiffies, timeout)) {
+						DPRINTK("%s SLEEP_VPU BUSY timeout", DEV_NAME);
+						goto DONE_SUSPEND;
+					}
+				}
+				if (ReadVpuRegister(W5_RET_SUCCESS, core) == 0) {
+					DPRINTK("%s SLEEP_VPU failed [0x%x]", DEV_NAME, ReadVpuRegister(W5_RET_FAIL_REASON, core));
+					goto DONE_SUSPEND;
+				}
+			} else {
+				while (ReadVpuRegister(BIT_BUSY_FLAG, core)) {
+					if (time_after(jiffies, timeout))
+						goto DONE_SUSPEND;
+				}
+
+				for (i = 0; i < 64; i++)
+					s_vpu_reg_store[core][i] = ReadVpuRegister(BIT_BASE+(0x100+(i * 4)), core);
+			}
+		}
+#endif /* end of DISABLE_ORIGIN_SUSPEND */
+	}
+
+	vpu_clk_disable(s_vpu_clk_ve3);
+	vpu_clk_disable(s_vpu_clk_ve1);
+	vpu_clk_disable(s_vpu_clk_ve2);
+	vpu_clk_disable(s_vpu_clk_ve2_bpu);
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_off(s_pctrl_ve3);
+	vpu_pctrl_off(s_pctrl_ve1);
+	vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+DONE_SUSPEND:
+#endif
+
+	vpu_clk_disable(s_vpu_clk_ve3);
+	vpu_clk_disable(s_vpu_clk_ve1);
+	vpu_clk_disable(s_vpu_clk_ve2);
+	vpu_clk_disable(s_vpu_clk_ve2_bpu);
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_off(s_pctrl_ve3);
+	vpu_pctrl_off(s_pctrl_ve1);
+	vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return -EAGAIN;
+}
+
+static int vpu_resume(struct device *pdev)
+{
+	pr_info("%s Enter %s\n", DEV_NAME, __func__);
+
+#ifdef CONFIG_POWER_CONTROL
+	vpu_pctrl_on(s_pctrl_ve1);
+	vpu_pctrl_on(s_pctrl_ve2);
+	vpu_pctrl_on(s_pctrl_ve3);
+#endif /* CONFIG_POWER_CONTROL */
+
+	vpu_clk_enable(s_vpu_clk_ve1);
+	vpu_clk_enable(s_vpu_clk_ve2);
+	vpu_clk_enable(s_vpu_clk_ve2_bpu);
+	vpu_clk_enable(s_vpu_clk_ve3);
+
+	//RTK wrapper
+	ve1_wrapper_setup((1 << 2) | (1 << 1) | 1);
+
+#ifdef DISABLE_ORIGIN_SUSPEND
+#else /* else of DISABLE_ORIGIN_SUSPEND */
+	int i;
+	int core;
+	int regVal;
+	int product_code = 0;
+	unsigned long timeout = jiffies + HZ; /* vpu wait timeout to 1sec */
+	unsigned long code_base;
+	unsigned long stack_base;
+	u32 val;
+	u32 code_size;
+	u32 stack_size;
+	u32 remap_size;
+	u32 hwOption  = 0;
+
+	for (core = 0; core < MAX_NUM_VPU_CORE; core++) {
+
+		if (s_bit_firmware_info[core].size == 0) {
+			continue;
+		}
+
+		product_code = ReadVpuRegister(VPU_PRODUCT_CODE_REGISTER, core);
+
+		if (PRODUCT_CODE_W_SERIES(product_code)) {
+
+			code_base = s_common_memory.phys_addr;
+			/* ALIGN TO 4KB */
+			code_size = (W5_MAX_CODE_BUF_SIZE&~0xfff);
+			if (code_size < s_bit_firmware_info[core].size*2) {
+				goto DONE_WAKEUP;
+			}
+			stack_base = code_base + code_size;
+			stack_size = WAVE5_STACK_SIZE;
+
+			/*---- LOAD BOOT CODE*/
+			//for (i = 0; i < 512; i++) {
+			//	val = s_bit_firmware_info[core].bit_code[i];
+			//	WriteVpu(code_base+(i*4), val);
+			//}
+
+			regVal = 0;
+			WriteVpuRegister(W5_PO_CONF, regVal, core);
+
+			/* Reset All blocks */
+			regVal = 0x7ffffff;
+			WriteVpuRegister(W5_RESET_REQ, regVal, core);	/*Reset All blocks*/
+
+			/* Waiting reset done */
+			while (ReadVpuRegister(W5_RESET_STATUS, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+			WriteVpuRegister(W5_RESET_REQ, 0, core);
+
+			/* remap page size */
+			remap_size = (code_size >> 12) & 0x1ff;
+			regVal = 0x80000000 | (W5_REMAP_CODE_INDEX<<12) | (0 << 16) | (1<<11) | remap_size;
+			WriteVpuRegister(W5_VPU_REMAP_CTRL,	 regVal, core);
+			WriteVpuRegister(W5_VPU_REMAP_VADDR,	0x00000000, core);	/* DO NOT CHANGE! */
+			WriteVpuRegister(W5_VPU_REMAP_PADDR,	code_base, core);
+			WriteVpuRegister(W5_ADDR_CODE_BASE,	 code_base, core);
+			WriteVpuRegister(W5_CODE_SIZE,		  code_size, core);
+			WriteVpuRegister(W5_CODE_PARAM,		 0, core);
+			WriteVpuRegister(W5_INIT_VPU_TIME_OUT_CNT,   timeout, core);
+
+			/* Stack */
+			WriteVpuRegister(W5_ADDR_STACK_BASE, stack_base, core);
+			WriteVpuRegister(W5_STACK_SIZE,	  stack_size, core);
+			WriteVpuRegister(W5_HW_OPTION, hwOption, core);
+
+			/* Interrupt */
+			regVal  = (1<<W5_INT_DEC_PIC_HDR);
+			regVal |= (1<<W5_INT_DEC_PIC);
+			regVal |= (1<<W5_INT_QUERY_DEC);
+			regVal |= (1<<W5_INT_SLEEP_VPU);
+			regVal |= (1<<W5_INT_BSBUF_EMPTY);
+
+			WriteVpuRegister(W5_VPU_INT_ENABLE,  regVal, core);
+
+			Wave5BitIssueCommand(W5_CMD_INIT_VPU);
+			WriteVpuRegister(W5_VPU_REMAP_PROC_START, 1, core);
+
+			while (ReadVpuRegister(W5_VPU_BUSY_STATUS, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+			if (ReadVpuRegister(W5_RET_SUCCESS, core) == 0) {
+				DPRINTK("%s WAKEUP_VPU failed [0x%x]", DEV_NAME, ReadVpuRegister(W5_RET_FAIL_REASON, core));
+				goto DONE_WAKEUP;
+			}
+		} else {
+
+			WriteVpuRegister(BIT_CODE_RUN, 0, core);
+
+			/*---- LOAD BOOT CODE*/
+			for (i = 0; i < 512; i++) {
+				val = s_bit_firmware_info[core].bit_code[i];
+				WriteVpuRegister(BIT_CODE_DOWN, ((i << 16) | val), core);
+			}
+
+			for (i = 0 ; i < 64 ; i++)
+				WriteVpuRegister(BIT_BASE+(0x100+(i * 4)), s_vpu_reg_store[core][i], core);
+
+			WriteVpuRegister(BIT_BUSY_FLAG, 1, core);
+			WriteVpuRegister(BIT_CODE_RESET, 1, core);
+			WriteVpuRegister(BIT_CODE_RUN, 1, core);
+
+			while (ReadVpuRegister(BIT_BUSY_FLAG, core)) {
+				if (time_after(jiffies, timeout))
+					goto DONE_WAKEUP;
+			}
+
+		}
+
+	}
+#endif /* end of DISABLE_ORIGIN_SUSPEND */
+
+	if (s_vpu_open_ref_count == 0) {
+		vpu_clk_disable(s_vpu_clk_ve3);
+		vpu_clk_disable(s_vpu_clk_ve1);
+		vpu_clk_disable(s_vpu_clk_ve2);
+		vpu_clk_disable(s_vpu_clk_ve2_bpu);
+#ifdef CONFIG_POWER_CONTROL
+		vpu_pctrl_off(s_pctrl_ve3);
+		vpu_pctrl_off(s_pctrl_ve1);
+		vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+	}
+
+#ifndef DISABLE_ORIGIN_SUSPEND
+DONE_WAKEUP:
+#endif /* DISABLE_ORIGIN_SUSPEND */
+
+	if (s_vpu_open_ref_count > 0) {
+		vpu_clk_enable(s_vpu_clk_ve3);
+		vpu_clk_enable(s_vpu_clk_ve1);
+		vpu_clk_enable(s_vpu_clk_ve2);
+		vpu_clk_enable(s_vpu_clk_ve2_bpu);
+#ifdef CONFIG_POWER_CONTROL
+		vpu_pctrl_off(s_pctrl_ve3);
+		vpu_pctrl_off(s_pctrl_ve1);
+		vpu_pctrl_off(s_pctrl_ve2);
+#endif /* CONFIG_POWER_CONTROL */
+	}
+
+	pr_info("%s Exit %s\n", DEV_NAME, __func__);
+
+	return 0;
+}
+#else
+static int vpu_suspend(struct device *pdev);
+static int vpu_resume(struct device *pdev);
+#endif /* CONFIG_PM */
+
+static int __init vpu_init(void)
+{
+	int res = 0;
+
+#ifdef SUPPORT_MULTI_INST_INTR
+	int i;
+#endif
+	DPRINTK("%s begin vpu_init\n", DEV_NAME);
+#ifdef SUPPORT_MULTI_INST_INTR
+	for (i=0; i<MAX_NUM_INSTANCE; i++) {
+		init_waitqueue_head(&s_interrupt_wait_q_ve2[i]);
+	}
+
+	for (i=0; i<MAX_NUM_INSTANCE; i++) {
+#ifdef SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+#define MAX_INTERRUPT_QUEUE (16*MAX_NUM_INSTANCE)
+#else
+#define MAX_INTERRUPT_QUEUE 16
+#endif
+		res = kfifo_alloc(&s_interrupt_pending_q_ve2[i], MAX_INTERRUPT_QUEUE*sizeof(u32), GFP_KERNEL);
+		if (res) {
+			DPRINTK("%s kfifo_alloc failed 0x%x\n", DEV_NAME, res);
+		}
+	}
+#else
+	init_waitqueue_head(&s_interrupt_wait_q_ve2);
+#endif
+
+	init_waitqueue_head(&s_interrupt_wait_q_ve1);
+	init_waitqueue_head(&s_interrupt_wait_q_ve3);
+	s_common_memory.base = 0;
+	s_instance_pool.base = 0;
+
+	DPRINTK("%s end vpu_init result=0x%x\n", DEV_NAME, res);
+	return res;
+}
+
+static void __exit vpu_exit(void)
+{
+#ifdef VPU_SUPPORT_PLATFORM_DRIVER_REGISTER
+	DPRINTK("%s vpu_exit\n", DEV_NAME);
+#else
+
+	vpu_clk_put(s_vpu_clk_ve3);
+	vpu_clk_put(s_vpu_clk_ve1);
+	vpu_clk_put(s_vpu_clk_ve2);
+	vpu_clk_put(s_vpu_clk_ve2_bpu);
+
+	if (s_instance_pool.base) {
+#ifdef USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+		vfree((const void *)s_instance_pool.base);
+#else
+		pu_unmap_kernel_buffer(s_instance_pool.base, s_instance_pool.phys_addr);
+		vpu_free_dma_buffer(&s_instance_pool);
+#endif /* USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY */
+		s_instance_pool.base = 0;
+	}
+
+	if (s_common_memory.base) {
+		vpu_free_dma_buffer(&s_common_memory);
+		s_common_memory.base = 0;
+	}
+
+#ifdef VPU_SUPPORT_RESERVED_VIDEO_MEMORY
+	if (s_video_memory.base) {
+		iounmap((void *)s_video_memory.base);
+		s_video_memory.base = 0;
+
+		vmem_exit(&s_vmem);
+	}
+#endif /* VPU_SUPPORT_RESERVED_VIDEO_MEMORY */
+
+	misc_deregister(&s_vpu_dev);
+
+#ifdef VPU_SUPPORT_ISR
+	if (s_ve1_irq)
+		free_irq(s_ve1_irq, &s_vpu_drv_context);
+	if (s_ve2_irq)
+		free_irq(s_ve2_irq, &s_vpu_drv_context);
+#endif /* VPU_SUPPORT_ISR */
+
+#ifdef SUPPORT_MULTI_INST_INTR
+	{
+		int i;
+		for (i=0; i<MAX_NUM_INSTANCE; i++) {
+			kfifo_free(&s_interrupt_pending_q_ve2[i]);
+		}
+	}
+#endif
+#endif /* VPU_SUPPORT_PLATFORM_DRIVER_REGISTER */
+
+	return;
+}
+
+MODULE_AUTHOR("A customer using RTK VPU, Inc.");
+MODULE_DESCRIPTION("VPU linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(vpu_init);
+module_exit(vpu_exit);
+
+#ifdef CONFIG_POWER_CONTROL
+
+static int vpu_pcrtl_callback(struct notifier_block *nb,
+			      unsigned long action,
+			      void *p)
+{
+	struct power_control *pctrl = p;
+
+	if (action != POWER_CONTROL_ACTION_POST_POWER_ON)
+		return NOTIFY_DONE;
+
+	if (s_pctrl_ve1 == pctrl)
+		reset_control_reset(rstc_ve1);
+	if (s_pctrl_ve2 == pctrl)
+		reset_control_reset(rstc_ve2);
+	if (s_pctrl_ve3 == pctrl)
+		reset_control_reset(rstc_ve3);
+	return NOTIFY_OK;
+}
+
+struct notifier_block vpu_pctrl_nb = {
+	.notifier_call = vpu_pcrtl_callback,
+};
+
+struct power_control *vpu_pctrl_get(u32 coreIdx)
+{
+	struct power_control *pctrl;
+
+	if (coreIdx == 0)
+		pctrl = power_control_get("pctrl_ve1");
+	else if (coreIdx == 1)
+		pctrl = power_control_get("pctrl_ve2");
+	else
+		pctrl = power_control_get("pctrl_ve3");
+
+	if (WARN_ON(IS_ERR_OR_NULL(pctrl)))
+		return NULL;
+	power_control_register_notifier(pctrl, &vpu_pctrl_nb);
+	return pctrl;
+}
+
+void vpu_pctrl_on(struct power_control *pctrl)
+{
+	if (!(pctrl == NULL || IS_ERR(pctrl))) {
+		DPRINTK("%s vpu_pctrl_on\n", DEV_NAME);
+		power_control_power_on(pctrl);
+		if (pctrl == s_pctrl_ve2)
+			 power_control_power_on(s_pctrl_ve1);
+	}
+}
+
+void vpu_pctrl_off(struct power_control *pctrl)
+{
+	if (!(pctrl == NULL || IS_ERR(pctrl))) {
+		DPRINTK("%s vpu_pctrl_off\n", DEV_NAME);
+		power_control_power_off(pctrl);
+		if (pctrl == s_pctrl_ve2)
+			power_control_power_off(s_pctrl_ve1);
+	}
+}
+#endif /* CONFIG_POWER_CONTROL */
+
+static const struct of_device_id rtk_ve1_dt_match[] = {
+	{ .compatible = "Realtek,rtk16xx-ve1" },
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtk_ve1_dt_match);
+
+const struct dev_pm_ops rtk_ve1_pmops = {
+	.suspend = vpu_suspend,
+	.resume = vpu_resume,
+};
+
+static struct platform_driver rtk_ve1_driver = {
+	.driver = {
+		.name = "rtk-ve1",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_ve1_dt_match,
+		.pm = &rtk_ve1_pmops,
+	},
+	.probe = vpu_probe,
+	.remove = vpu_remove,
+};
+
+module_platform_driver(rtk_ve1_driver);
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/ve1.h b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/ve1.h
new file mode 100755
index 00000000..f351f9d
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/ve1.h
@@ -0,0 +1,106 @@
+/**
+  ve1.c
+
+  linux device driver for VPU.
+
+ Copyright (C) 2006 - 2013  REALTEK INC.
+
+  This library is free software; you can redistribute it and/or modify it under
+  the terms of the GNU Lesser General Public License as published by the Free
+  Software Foundation; either version 2.1 of the License, or (at your option)
+  any later version.
+
+  This library is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+  details.
+
+  You should have received a copy of the GNU Lesser General Public License
+  along with this library; if not, write to the Free Software Foundation, Inc.,
+  51 Franklin St, Fifth Floor, Boston, MA
+  02110-1301  USA
+
+*/
+
+#ifndef __VPU_DRV_H__
+#define __VPU_DRV_H__
+
+#include <linux/fs.h>
+#include <linux/types.h>
+
+#define SUPPORT_MULTI_INST_INTR
+#define SUPPORT_MULTI_INST_INTR_ERROR_CHECK
+#define USE_VMALLOC_FOR_INSTANCE_POOL_MEMORY
+
+#define VDI_IOCTL_MAGIC 'V'
+#define VDI_IOCTL_ALLOCATE_PHYSICAL_MEMORY _IO(VDI_IOCTL_MAGIC, 0)
+#define VDI_IOCTL_FREE_PHYSICALMEMORY _IO(VDI_IOCTL_MAGIC, 1)
+#define VDI_IOCTL_WAIT_INTERRUPT _IO(VDI_IOCTL_MAGIC, 2)
+#define VDI_IOCTL_SET_CLOCK_GATE _IO(VDI_IOCTL_MAGIC, 3)
+#define VDI_IOCTL_RESET _IO(VDI_IOCTL_MAGIC, 4)
+#define VDI_IOCTL_GET_INSTANCE_POOL _IO(VDI_IOCTL_MAGIC, 5)
+#define VDI_IOCTL_GET_COMMON_MEMORY _IO(VDI_IOCTL_MAGIC, 6)
+#define VDI_IOCTL_GET_RESERVED_VIDEO_MEMORY_INFO _IO(VDI_IOCTL_MAGIC, 8)
+#define VDI_IOCTL_OPEN_INSTANCE _IO(VDI_IOCTL_MAGIC, 9)
+#define VDI_IOCTL_CLOSE_INSTANCE _IO(VDI_IOCTL_MAGIC, 10)
+#define VDI_IOCTL_GET_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 11)
+#define VDI_IOCTL_GET_REGISTER_INFO _IO(VDI_IOCTL_MAGIC, 12)
+
+/* RTK ioctl */
+#define VDI_IOCTL_SET_RTK_CLK_GATING _IO(VDI_IOCTL_MAGIC, 16)
+#define VDI_IOCTL_SET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 17)
+#define VDI_IOCTL_GET_RTK_CLK_PLL _IO(VDI_IOCTL_MAGIC, 18)
+#define VDI_IOCTL_GET_RTK_SUPPORT_TYPE _IO(VDI_IOCTL_MAGIC, 19)
+#define VDI_IOCTL_GET_RTK_ASIC_REVISION _IO(VDI_IOCTL_MAGIC, 20)
+#define VDI_IOCTL_SET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 21)
+#define VDI_IOCTL_GET_RTK_CLK_SELECT _IO(VDI_IOCTL_MAGIC, 22)
+#define VDI_IOCTL_SET_RTK_DOVI_FLAG _IO(VDI_IOCTL_MAGIC, 23)
+#define VDI_IOCTL_GET_TOTAL_INSTANCE_NUM _IO(VDI_IOCTL_MAGIC, 24)
+#define VDI_IOCTL_GET_RTK_DCSYS_INFO _IO(VDI_IOCTL_MAGIC, 25)
+
+#define VE_PLL_SYSH	0x000
+#define VE_PLL_VE1	0x001
+#define VE_PLL_VE2	0x010
+
+typedef struct vpudrv_buffer_t {
+	unsigned int size;
+	unsigned long phys_addr;
+	unsigned long base; /* kernel logical address in use kernel */
+	unsigned long virt_addr; /* virtual user space address */
+	unsigned int mem_type; /* RTK, for protect memory */
+} vpudrv_buffer_t;
+
+typedef struct vpu_bit_firmware_info_t {
+	unsigned int size; /* size of this structure*/
+	unsigned int core_idx;
+	unsigned long reg_base_offset;
+	unsigned short bit_code[512];
+} vpu_bit_firmware_info_t;
+
+typedef struct vpu_clock_info_t{
+	unsigned int core_idx;
+	unsigned int enable;
+	unsigned int value;
+} vpu_clock_info_t;
+
+typedef struct vpudrv_inst_info_t {
+	unsigned int core_idx;
+	unsigned int inst_idx;
+	int inst_open_count; /* for output only*/
+} vpudrv_inst_info_t;
+
+typedef struct vpudrv_intr_info_t {
+	unsigned int core_idx;
+	unsigned int timeout;
+	int intr_reason;
+#ifdef SUPPORT_MULTI_INST_INTR
+	int intr_inst_index;
+#endif
+} vpudrv_intr_info_t;
+
+typedef struct vpudrv_dovi_info_t{
+	unsigned int core_idx;
+	unsigned int inst_idx;
+	unsigned int enable;
+} vpudrv_dovi_info_t;
+#endif
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/ve1config.h b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/ve1config.h
new file mode 100644
index 00000000..271a5c1
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/ve1config.h
@@ -0,0 +1,109 @@
+/* =========================================================================
+ *  This file is a part of VE1 Reference API project
+ * -----------------------------------------------------------------------------
+ *
+ * This confidential and proprietary software may be used only
+ * as authorized by a licensing agreement from Realtek Inc.
+ * In the event of publication, the following notice is applicable:
+ *
+ * (C) COPYRIGHT 2006 - 2011  REALTEK INC.
+ * ALL RIGHTS RESERVED
+ *
+ * The entire notice above must be reproduced on all authorized
+ * copies.
+ * This file should be modified by some customers according to their SOC configuration.
+ * =========================================================================
+ */
+
+#ifndef _VPU_CONFIG_H_
+#define _VPU_CONFIG_H_
+
+#define BODA7503_CODE 0x7503
+#define CODA7542_CODE 0x7542
+#define BODA950_CODE 0x9500
+#define CODA960_CODE 0x9600
+#define CODA980_CODE 0x9800
+#define WAVE320_CODE 0x3200
+#define WAVE410_CODE 0x4100 /* Wave410 version 1: Single vcore */
+#define WAVE4102_CODE 0x4102 /* Wave410 version 2: Multi vcore */
+#define WAVE420_CODE 0x4200 /* Wave420 */
+#define WAVE412_CODE 0x4120
+#define WAVE510_CODE                    0x5100
+#define WAVE512_CODE                    0x5120
+#define WAVE520_CODE                    0x5200
+
+#define PRODUCT_CODE_W_SERIES(x) (x == WAVE510_CODE || x == WAVE512_CODE || x == WAVE520_CODE)
+#define MAX_INST_HANDLE_SIZE (32*1024)
+#define MAX_NUM_INSTANCE 48 //__LINUX_MEDIA_NAS__
+#define MAX_NUM_VPU_CORE 3
+#define MAX_NUM_VCORE 1
+
+#define MAX_ENC_AVC_PIC_WIDTH 4096
+#define MAX_ENC_AVC_PIC_HEIGHT 2304
+#define MAX_ENC_PIC_WIDTH 4096
+#define MAX_ENC_PIC_HEIGHT 2304
+#define MIN_ENC_PIC_WIDTH 96
+#define MIN_ENC_PIC_HEIGHT 16
+
+/* for WAVE420 */
+#define W4_MIN_ENC_PIC_WIDTH 256
+#define W4_MIN_ENC_PIC_HEIGHT 128
+#define W4_MAX_ENC_PIC_WIDTH 8192
+#define W4_MAX_ENC_PIC_HEIGHT 8192
+
+#define MAX_DEC_PIC_WIDTH 4096
+#define MAX_DEC_PIC_HEIGHT 2304
+
+/* Application specific configuration */
+#define VPU_ENC_TIMEOUT 5000
+#define VPU_DEC_TIMEOUT 10000
+#define VPU_BUSY_CHECK_TIMEOUT 5000
+
+/* codec specific configuration */
+/* it can be set to 1 to handle reordering DPB in host side. */
+#define VPU_REORDER_ENABLE 1
+/*
+ * [default 1 for BW checking with RTKViedo Conformance] 0 (chroma separate mode), 1 (chroma interleave mode)
+ * if the type of tiledmap uses the kind of MB_RASTER_MAP. must set to enable CBCR_INTERLEAVE
+ */
+#define CBCR_INTERLEAVE 1
+#define VPU_ENABLE_BWB 1
+#define VPU_REPORT_USERDATA	 0
+
+#define HOST_ENDIAN  VDI_128BIT_LITTLE_ENDIAN
+#define VPU_FRAME_ENDIAN HOST_ENDIAN
+#define VPU_STREAM_ENDIAN HOST_ENDIAN
+#define VPU_USER_DATA_ENDIAN HOST_ENDIAN
+#define DRAM_BUS_WIDTH	 16
+
+/************************************************************************/
+/* VPU COMMON MEMORY */
+/************************************************************************/
+#define SIZE_COMMON (2*1024*1024)
+
+/*=====4. VPU REPORT MEMORY  ======================*/
+#define SIZE_REPORT_BUF (0x10000)
+
+#define STREAM_END_SIZE 0
+#define STREAM_END_SET_FLAG 0
+#define STREAM_END_CLEAR_FLAG -1
+
+#define USE_BIT_INTERNAL_BUF 1
+#define USE_IP_INTERNAL_BUF 1
+#define USE_DBKY_INTERNAL_BUF 1
+#define USE_DBKC_INTERNAL_BUF 1
+#define USE_OVL_INTERNAL_BUF 1
+#define USE_BTP_INTERNAL_BUF 1
+#define USE_ME_INTERNAL_BUF 1
+
+/* WAVE410 only */
+#define USE_BPU_INTERNAL_BUF 1
+#define USE_VCE_IP_INTERNAL_BUF 1
+#define USE_VCE_LF_ROW_INTERNAL_BUF 1
+
+/* WAVE420 only */
+#define USE_IMD_INTERNAL_BUF 1
+#define USE_RDO_INTERNAL_BUF 1
+#define USE_LF_INTERNAL_BUF 1
+
+#endif  /* _VPU_CONFIG_H_ */
diff --git a/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/vmm.h b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/vmm.h
new file mode 100644
index 00000000..5ad5792
--- /dev/null
+++ b/drivers/soc/realtek/rtd16xx/rtk_ve/ve1/vmm.h
@@ -0,0 +1,634 @@
+/**
+  vmm.h
+
+  memory allocator for VE
+
+ Copyright (C) 2006 - 2013  REALTEK INC.
+
+  This library is free software; you can redistribute it and/or modify it under
+  the terms of the GNU Lesser General Public License as published by the Free
+  Software Foundation; either version 2.1 of the License, or (at your option)
+  any later version.
+
+  This library is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+  details.
+
+  You should have received a copy of the GNU Lesser General Public License
+  along with this library; if not, write to the Free Software Foundation, Inc.,
+  51 Franklin St, Fifth Floor, Boston, MA
+  02110-1301  USA
+
+*/
+
+#ifndef __RTK_VIDEO_MEMORY_MANAGEMENT_H__
+#define __RTK_VIDEO_MEMORY_MANAGEMENT_H__
+
+typedef struct _video_mm_info_struct {
+	unsigned long   total_pages;
+	unsigned long   alloc_pages;
+	unsigned long   free_pages;
+	unsigned long   page_size;
+} vmem_info_t;
+
+typedef unsigned long long  vmem_key_t;
+
+#define VMEM_PAGE_SIZE (16*1024)
+#define MAKE_KEY(_a, _b) (((vmem_key_t)_a)<<32 | _b)
+#define KEY_TO_VALUE(_key) (_key>>32)
+
+typedef struct page_struct {
+	int pageno;
+	unsigned long addr;
+	int used;
+	int alloc_pages;
+	int first_pageno;
+} page_t;
+
+typedef struct avl_node_struct {
+	vmem_key_t key;
+	int height;
+	page_t *page;
+	struct avl_node_struct *left;
+	struct avl_node_struct *right;
+} avl_node_t;
+
+typedef struct _video_mm_struct {
+	avl_node_t *free_tree;
+	avl_node_t *alloc_tree;
+	page_t *page_list;
+	int num_pages;
+	unsigned long base_addr;
+	unsigned long mem_size;
+	int free_page_count;
+	int  alloc_page_count;
+} video_mm_t;
+
+#define VMEM_P_ALLOC(_x) vmalloc(_x)
+#define VMEM_P_FREE(_x) vfree(_x)
+
+#define VMEM_ASSERT(_exp) if (!(_exp)) { printk(KERN_INFO "VMEM_ASSERT at %s:%d\n", __FILE__, __LINE__); /*while(1);*/
+#define VMEM_HEIGHT(_tree) (_tree == NULL ? -1 : _tree->height)
+
+#define MAX(_a, _b) (_a >= _b ? _a : _b)
+
+typedef enum {
+	LEFT,
+	RIGHT
+} rotation_dir_t;
+
+typedef struct avl_node_data_struct {
+	int	 key;
+	page_t *page;
+} avl_node_data_t;
+
+static avl_node_t* make_avl_node( vmem_key_t key, page_t *page)
+{
+	avl_node_t *node = (avl_node_t *)VMEM_P_ALLOC(sizeof(avl_node_t));
+	node->key	 = key;
+	node->page	= page;
+	node->height  = 0;
+	node->left	= NULL;
+	node->right   = NULL;
+
+	return node;
+}
+
+static int get_balance_factor(avl_node_t *tree)
+{
+	int factor = 0;
+	if (tree) {
+		factor = VMEM_HEIGHT(tree->right) - VMEM_HEIGHT(tree->left);
+	}
+
+	return factor;
+}
+
+/*
+ * Left Rotation
+ *
+ *	  A					  B
+ *	   \					/ \
+ *		B		 =>	   A   C
+ *	   /  \				 \
+ *	  D	C				 D
+ *
+ */
+static avl_node_t* rotation_left(avl_node_t *tree)
+{
+	avl_node_t *rchild;
+	avl_node_t *lchild;
+
+	if (tree == NULL)
+		return NULL;
+
+	rchild = tree->right;
+	if (rchild == NULL) {
+		return tree;
+	}
+
+	lchild = rchild->left;
+	rchild->left = tree;
+	tree->right = lchild;
+
+	tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+	rchild->height = MAX(VMEM_HEIGHT(rchild->left), VMEM_HEIGHT(rchild->right)) + 1;
+
+	return rchild;
+}
+
+
+/*
+ * Reft Rotation
+ *
+ *		 A				  B
+ *	   \				  /  \
+ *	  B		 =>	   D	A
+ *	/  \					 /
+ *   D	C				   C
+ *
+ */
+static avl_node_t *rotation_right(avl_node_t *tree)
+{
+	avl_node_t *rchild;
+	avl_node_t *lchild;
+
+	if (tree == NULL)
+		return NULL;
+
+	lchild = tree->left;
+	if (lchild == NULL)
+		return NULL;
+
+	rchild = lchild->right;
+	lchild->right = tree;
+	tree->left = rchild;
+
+	tree->height   = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+	lchild->height = MAX(VMEM_HEIGHT(lchild->left), VMEM_HEIGHT(lchild->right)) + 1;
+
+	return lchild;
+}
+
+static avl_node_t *do_balance(avl_node_t *tree)
+{
+	int bfactor = 0, child_bfactor;	   /* balancing factor */
+
+	bfactor = get_balance_factor(tree);
+
+	if (bfactor >= 2) {
+		child_bfactor = get_balance_factor(tree->right);
+		if (child_bfactor == 1 || child_bfactor == 0) {
+			tree = rotation_left(tree);
+		} else if (child_bfactor == -1) {
+			tree->right = rotation_right(tree->right);
+			tree		= rotation_left(tree);
+		} else {
+			printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+			VMEM_ASSERT(0);
+			return NULL;
+		}
+	} else if (bfactor <= -2) {
+		child_bfactor = get_balance_factor(tree->left);
+		if (child_bfactor == -1 || child_bfactor == 0) {
+			tree = rotation_right(tree);
+		} else if (child_bfactor == 1) {
+			tree->left = rotation_left(tree->left);
+			tree	   = rotation_right(tree);
+		} else {
+			printk(KERN_INFO "invalid balancing factor: %d\n", child_bfactor);
+			VMEM_ASSERT(0);
+			return NULL;
+		}
+	}
+
+	return tree;
+}
+
+static avl_node_t *unlink_end_node(avl_node_t *tree, int dir, avl_node_t **found_node)
+{
+	avl_node_t *node;
+	*found_node = NULL;
+
+	if (tree == NULL)
+		return NULL;
+
+	if (dir == LEFT) {
+		if (tree->left == NULL) {
+			*found_node = tree;
+			return NULL;
+		}
+	} else {
+		if (tree->right == NULL) {
+			*found_node = tree;
+			return NULL;
+		}
+	}
+
+	if (dir == LEFT) {
+		node = tree->left;
+		tree->left = unlink_end_node(tree->left, LEFT, found_node);
+		if (tree->left == NULL) {
+			tree->left = (*found_node)->right;
+			(*found_node)->left  = NULL;
+			(*found_node)->right = NULL;
+		}
+	} else {
+		node = tree->right;
+		tree->right = unlink_end_node(tree->right, RIGHT, found_node);
+		if (tree->right == NULL) {
+			tree->right = (*found_node)->left;
+			(*found_node)->left  = NULL;
+			(*found_node)->right = NULL;
+		}
+	}
+
+	tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	return do_balance(tree);
+}
+
+
+static avl_node_t *avltree_insert(avl_node_t *tree, vmem_key_t key, page_t *page)
+{
+	if (tree == NULL) {
+		tree = make_avl_node(key, page);
+	} else {
+		if (key >= tree->key) {
+			tree->right = avltree_insert(tree->right, key, page);
+		} else {
+			tree->left  = avltree_insert(tree->left, key, page);
+		}
+	}
+
+	tree = do_balance(tree);
+
+	tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	return tree;
+}
+
+static avl_node_t *do_unlink(avl_node_t *tree)
+{
+	avl_node_t *node;
+	avl_node_t *end_node;
+
+	node = unlink_end_node(tree->right, LEFT, &end_node);
+	if (node) {
+		tree->right = node;
+	} else {
+		node = unlink_end_node(tree->left, RIGHT, &end_node);
+		if (node)
+			tree->left = node;
+	}
+
+	if (node == NULL) {
+		node = tree->right ? tree->right : tree->left;
+		end_node = node;
+	}
+
+	if (end_node) {
+		end_node->left  = (tree->left != end_node) ? tree->left : end_node->left;
+		end_node->right = (tree->right != end_node) ? tree->right : end_node->right;
+		end_node->height = MAX(VMEM_HEIGHT(end_node->left), VMEM_HEIGHT(end_node->right)) + 1;
+	}
+
+	tree = end_node;
+
+	return tree;
+}
+
+static avl_node_t *avltree_remove(avl_node_t *tree, avl_node_t **found_node, vmem_key_t key)
+{
+	*found_node = NULL;
+	if (tree == NULL) {
+		printk(KERN_INFO "failed to find key %d\n", (int)key);
+		return NULL;
+	}
+
+	if (key == tree->key) {
+		*found_node = tree;
+		tree = do_unlink(tree);
+	} else if (key > tree->key) {
+		tree->right = avltree_remove(tree->right, found_node, key);
+	} else {
+		tree->left  = avltree_remove(tree->left, found_node, key);
+	}
+
+	if (tree)
+		tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	tree = do_balance(tree);
+
+	return tree;
+}
+
+void avltree_free(avl_node_t *tree)
+{
+	if (tree == NULL)
+		return;
+	if (tree->left == NULL && tree->right == NULL) {
+		VMEM_P_FREE(tree);
+		return;
+	}
+
+	avltree_free(tree->left);
+	tree->left = NULL;
+	avltree_free(tree->right);
+	tree->right = NULL;
+	VMEM_P_FREE(tree);
+}
+
+static avl_node_t *remove_approx_value(avl_node_t *tree, avl_node_t **found, vmem_key_t key)
+{
+	*found = NULL;
+	if (tree == NULL) {
+		return NULL;
+	}
+
+	if (key == tree->key) {
+		*found = tree;
+		tree = do_unlink(tree);
+	} else if (key > tree->key) {
+		tree->right = remove_approx_value(tree->right, found, key);
+	} else {
+		tree->left  = remove_approx_value(tree->left, found, key);
+		if (*found == NULL) {
+			*found = tree;
+			tree = do_unlink(tree);
+		}
+	}
+	if (tree)
+		tree->height = MAX(VMEM_HEIGHT(tree->left), VMEM_HEIGHT(tree->right)) + 1;
+
+	tree = do_balance(tree);
+
+	return tree;
+}
+
+static void set_blocks_free(video_mm_t *mm, int pageno, int npages)
+{
+	int last_pageno	 = pageno + npages - 1;
+	int i;
+	page_t *page;
+	page_t *last_page;
+
+	VMEM_ASSERT(npages);
+
+	if (last_pageno >= mm->num_pages) {
+		printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+		VMEM_ASSERT(0);
+		return;
+	}
+
+	for (i = pageno; i <= last_pageno; i++) {
+		mm->page_list[i].used		 = 0;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	page		= &mm->page_list[pageno];
+	page->alloc_pages = npages;
+	last_page   = &mm->page_list[last_pageno];
+	last_page->first_pageno = pageno;
+
+	mm->free_tree = avltree_insert(mm->free_tree, MAKE_KEY(npages, pageno), page);
+}
+
+static void set_blocks_alloc(video_mm_t *mm, int pageno, int npages)
+{
+	int last_pageno	 = pageno + npages - 1;
+	int i;
+	page_t *page;
+	page_t *last_page;
+
+	if (last_pageno >= mm->num_pages) {
+		printk(KERN_INFO "set_blocks_free: invalid last page number: %d\n", last_pageno);
+		VMEM_ASSERT(0);
+		return;
+	}
+
+	for (i = pageno; i <= last_pageno; i++) {
+		mm->page_list[i].used		 = 1;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	page		= &mm->page_list[pageno];
+	page->alloc_pages = npages;
+
+	last_page   = &mm->page_list[last_pageno];
+	last_page->first_pageno = pageno;
+
+	mm->alloc_tree = avltree_insert(mm->alloc_tree, MAKE_KEY(page->addr, 0), page);
+}
+
+
+int vmem_init(video_mm_t *mm, unsigned long addr, unsigned long size)
+{
+	int i;
+
+	if (NULL == mm)
+		return -1;
+
+	mm->base_addr  = (addr+(VMEM_PAGE_SIZE-1))&~(VMEM_PAGE_SIZE-1);
+	mm->mem_size   = size&~VMEM_PAGE_SIZE;
+	mm->num_pages  = mm->mem_size/VMEM_PAGE_SIZE;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = mm->num_pages;
+	mm->alloc_page_count = 0;
+	mm->page_list  = (page_t *)VMEM_P_ALLOC(mm->num_pages*sizeof(page_t));
+	if (mm->page_list == NULL) {
+		printk(KERN_ERR "%s:%d failed to kmalloc(%d)\n", __func__, __LINE__, mm->num_pages*sizeof(page_t));
+		return -1;
+	}
+
+	for (i = 0; i < mm->num_pages; i++) {
+		mm->page_list[i].pageno	   = i;
+		mm->page_list[i].addr		 = mm->base_addr + i * VMEM_PAGE_SIZE;
+		mm->page_list[i].alloc_pages  = 0;
+		mm->page_list[i].used		 = 0;
+		mm->page_list[i].first_pageno = -1;
+	}
+
+	set_blocks_free(mm, 0, mm->num_pages);
+
+	return 0;
+}
+
+int vmem_exit(video_mm_t *mm)
+{
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_exit: invalid handle\n");
+		return -1;
+	}
+
+	if (mm->free_tree) {
+		avltree_free(mm->free_tree);
+	}
+	if (mm->alloc_tree) {
+		avltree_free(mm->alloc_tree);
+	}
+
+	if (mm->page_list) {
+		VMEM_P_FREE(mm->page_list);
+		mm->page_list = NULL;
+	}
+
+	mm->base_addr  = 0;
+	mm->mem_size   = 0;
+	mm->num_pages  = 0;
+	mm->page_list  = NULL;
+	mm->free_tree  = NULL;
+	mm->alloc_tree = NULL;
+	mm->free_page_count = 0;
+	mm->alloc_page_count = 0;
+	return 0;
+}
+
+unsigned long vmem_alloc(video_mm_t *mm, int size, unsigned long pid)
+{
+	avl_node_t *node;
+	page_t *free_page;
+	int		 npages, free_size;
+	int		 alloc_pageno;
+	unsigned long  ptr;
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_alloc: invalid handle\n");
+		return -1;
+	}
+
+	if (size <= 0)
+		return -1;
+
+	npages = (size + VMEM_PAGE_SIZE - 1)/VMEM_PAGE_SIZE;
+
+	mm->free_tree = remove_approx_value(mm->free_tree, &node, MAKE_KEY(npages, 0));
+	if (node == NULL) {
+		return -1;
+	}
+	free_page = node->page;
+	free_size = KEY_TO_VALUE(node->key);
+
+	alloc_pageno = free_page->pageno;
+	set_blocks_alloc(mm, alloc_pageno, npages);
+	if (npages != free_size) {
+		int free_pageno = alloc_pageno + npages;
+		set_blocks_free(mm, free_pageno, (free_size-npages));
+	}
+
+	VMEM_P_FREE(node);
+
+	ptr = mm->page_list[alloc_pageno].addr;
+	mm->alloc_page_count += npages;
+	mm->free_page_count  -= npages;
+
+
+	return ptr;
+}
+
+int vmem_free(video_mm_t *mm, unsigned long ptr, unsigned long pid)
+{
+	unsigned long addr;
+	avl_node_t *found;
+	page_t *page;
+	int pageno, prev_free_pageno, next_free_pageno;
+	int prev_size, next_size;
+	int merge_page_no, merge_page_size, free_page_size;
+
+
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_free: invalid handle\n");
+		return -1;
+	}
+
+	addr = ptr;
+
+	mm->alloc_tree = avltree_remove(mm->alloc_tree, &found, MAKE_KEY(addr, 0));
+	if (found == NULL) {
+		printk(KERN_INFO "vmem_free: 0x%08x not found\n", (int)addr);
+		VMEM_ASSERT(0);
+		return -1;
+	}
+
+	/* find previous free block */
+	page = found->page;
+	pageno = page->pageno;
+	free_page_size = page->alloc_pages;
+	prev_free_pageno = pageno-1;
+	prev_size = -1;
+	if (prev_free_pageno >= 0) {
+		if (mm->page_list[prev_free_pageno].used == 0) {
+			prev_free_pageno = mm->page_list[prev_free_pageno].first_pageno;
+			prev_size = mm->page_list[prev_free_pageno].alloc_pages;
+		}
+	}
+
+	/* find next free block */
+	next_free_pageno = pageno + page->alloc_pages;
+	next_free_pageno = (next_free_pageno == mm->num_pages) ? -1 : next_free_pageno;
+	next_size = -1;
+	if (next_free_pageno >= 0) {
+		if (mm->page_list[next_free_pageno].used == 0) {
+			next_size = mm->page_list[next_free_pageno].alloc_pages;
+		}
+	}
+	VMEM_P_FREE(found);
+
+	/* merge */
+	merge_page_no = page->pageno;
+	merge_page_size = page->alloc_pages;
+	if (prev_size >= 0) {
+		mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(prev_size, prev_free_pageno));
+		if (found == NULL) {
+			VMEM_ASSERT(0);
+			return -1;
+		}
+		merge_page_no = found->page->pageno;
+		merge_page_size += found->page->alloc_pages;
+		VMEM_P_FREE(found);
+	}
+	if (next_size >= 0) {
+		mm->free_tree = avltree_remove(mm->free_tree, &found, MAKE_KEY(next_size, next_free_pageno));
+		if (found == NULL) {
+			VMEM_ASSERT(0);
+			return -1;
+		}
+		merge_page_size += found->page->alloc_pages;
+		VMEM_P_FREE(found);
+	}
+
+	page->alloc_pages  = 0;
+	page->first_pageno = -1;
+
+	set_blocks_free(mm, merge_page_no, merge_page_size);
+
+	mm->alloc_page_count -= free_page_size;
+	mm->free_page_count  += free_page_size;
+
+	return 0;
+}
+
+int vmem_get_info(video_mm_t *mm, vmem_info_t *info)
+{
+	if (mm == NULL) {
+		printk(KERN_INFO "vmem_get_info: invalid handle\n");
+		return -1;
+	}
+
+	if (info == NULL) {
+		return -1;
+	}
+
+	info->total_pages = mm->num_pages;
+	info->alloc_pages = mm->alloc_page_count;
+	info->free_pages  = mm->free_page_count;
+	info->page_size   = VMEM_PAGE_SIZE;
+
+	return 0;
+}
+
+#endif /* __RTK_VIDEO_MEMORY_MANAGEMENT_H__ */
diff --git a/drivers/soc/realtek/xen/Kconfig b/drivers/soc/realtek/xen/Kconfig
new file mode 100644
index 00000000..17a0730
--- /dev/null
+++ b/drivers/soc/realtek/xen/Kconfig
@@ -0,0 +1,20 @@
+
+comment "RealTek XEN support features"
+
+menu "Realtek XEN Features"
+
+config RTK_XEN_HYPERCALL
+	bool "Realtek XEN hypercall interface"
+	depends on RTK_XEN_SUPPORT
+	default y
+	help
+	  Interface for RTK xen hypercall
+
+config RTK_XEN_SK_RMEM_BASE
+	hex "Socket rbuff-memory base"
+	depends on RTK_XEN_SUPPORT
+	default 0x00100000
+	help
+	  Base size used for socket receive-buffer.
+
+endmenu #RTD1295 Device Drivers
diff --git a/drivers/soc/realtek/xen/Makefile b/drivers/soc/realtek/xen/Makefile
new file mode 100644
index 00000000..41ad346
--- /dev/null
+++ b/drivers/soc/realtek/xen/Makefile
@@ -0,0 +1,3 @@
+obj-y += dummy.o
+obj-y += gpio-wakeup.o
+obj-$(CONFIG_RTK_XEN_HYPERCALL) += hypercall-rtk.o
diff --git a/drivers/soc/realtek/xen/dummy.c b/drivers/soc/realtek/xen/dummy.c
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/soc/realtek/xen/gpio-wakeup.c b/drivers/soc/realtek/xen/gpio-wakeup.c
new file mode 100644
index 00000000..07b07b8
--- /dev/null
+++ b/drivers/soc/realtek/xen/gpio-wakeup.c
@@ -0,0 +1,197 @@
+#include <linux/platform_device.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/device.h>
+#include <linux/kernel.h>
+#include <linux/types.h>
+#include <linux/switch.h>
+#include <linux/of.h>
+
+#include <linux/gpio.h>
+#include <linux/of_gpio.h>
+#include <linux/interrupt.h>
+
+#include <linux/sysfs.h>
+#include <linux/completion.h>
+
+#define DEV_NAME "GPIO_WAKEUP"
+
+struct completion wu_completion;
+
+bool gpio_wakeup_en[136];
+bool gpio_wakeup_act[136];
+
+struct class *wakeup_class;
+int wu_gpio_num;
+int gpio_irq_base;
+
+static ssize_t gpio_wakeup_show(struct class *class,
+		struct class_attribute *attr, char *buf)
+{
+	if (completion_done(&wu_completion))
+		reinit_completion(&wu_completion);
+
+	wait_for_completion_interruptible(&wu_completion);
+	return sprintf(buf, "%d\n", wu_gpio_num);
+}
+
+static CLASS_ATTR(gpio_wakeup, 0444, gpio_wakeup_show, NULL);
+
+
+static irqreturn_t gpio_wakeup_isr(int irq, void *data)
+{
+	int wakeup_value;
+	int gpio_num = irq - gpio_irq_base;
+
+	if(!gpio_wakeup_en[gpio_num])
+		return IRQ_HANDLED;
+	if (gpio_wakeup_act[gpio_num])
+		wakeup_value = gpio_get_value(gpio_num) ? 0:1;
+	else
+		wakeup_value = gpio_get_value(gpio_num) ? 1:0;
+
+	if(wakeup_value) {
+		wu_gpio_num = gpio_num;
+		complete_all(&wu_completion);
+	}
+	return IRQ_HANDLED;
+}
+
+static int rtk_gpio_wakeup_probe(struct platform_device *pdev)
+{
+	struct device_node *nd = NULL;
+	struct device *gpio_dev;
+	const u32 *prop_en;
+	const u32 *prop_act;
+	int ret = 0;
+	int wu_gpio_en = 0;
+	int wu_gpio_act = 0;
+	int wu_gpio_list = 0;
+	int en;
+	int act;
+	int i = 0;
+	int wu_gpio;
+	int wu_irq;
+
+	gpio_dev = &pdev->dev;
+	nd = pdev->dev.of_node;
+
+	wakeup_class = class_create(THIS_MODULE, "wakeup");
+	if (wakeup_class == NULL)
+		pr_err("failed to create wakeup attribute!\n");
+	ret = class_create_file(wakeup_class, &class_attr_gpio_wakeup);
+
+	wu_gpio_list = of_gpio_named_count(nd, "wakeup-gpio-list");
+	prop_en = of_get_property(nd, "wakeup-gpio-enable", &wu_gpio_en);
+	prop_act = of_get_property(nd, "wakeup-gpio-activity", &wu_gpio_act);
+	wu_gpio_en  /= sizeof(u32);
+	wu_gpio_act /= sizeof(u32);
+
+	pr_info("[%s] wakeup-gpio Cnt: en(%d) act(%d) list(%d)\n",
+		DEV_NAME, wu_gpio_en, wu_gpio_act, wu_gpio_list);
+
+	if (wu_gpio_en != 0 && (wu_gpio_en == wu_gpio_act)
+		&& (wu_gpio_act == wu_gpio_list)) {
+
+		for (i = 0 ; i < wu_gpio_list ; i++) {
+			en  = of_read_number(prop_en, 1 + i);
+			act = of_read_number(prop_act, 1 + i);
+			wu_gpio = of_get_named_gpio(nd, "wakeup-gpio-list", i);
+
+			if (!en) {
+				pr_err("[%s] wakeup-gpio[%d] States is disable!",
+					DEV_NAME, i);
+				pr_err(" (en:%d act:%d gpio:%d)\n",
+					en, act, wu_gpio);
+				continue;
+			}
+
+			if (gpio_request(wu_gpio, nd->name)) {
+				pr_err("[%s] wakeup-gpio[%d] Request failed!",
+					DEV_NAME, i);
+				pr_err(" (en:%d act:%d gpio:%d)\n",
+					en, act, wu_gpio);
+			} else {
+				gpio_free(wu_gpio);
+			}
+
+			gpio_direction_input(wu_gpio);
+
+			pr_info("[%s] wakeup-gpio[%d] Successful registration!",
+				DEV_NAME, i);
+			pr_info(" (en:%d act:%d gpio:%d)\n",
+				en, act, wu_gpio);
+
+			gpio_wakeup_en[wu_gpio] = en ? 1:0;
+			gpio_wakeup_act[wu_gpio] = act ? 1:0;
+
+			gpio_set_debounce(wu_gpio, 1000);
+			wu_irq = gpio_to_irq(wu_gpio);
+
+			if (!wu_irq)
+				pr_err("Fail to get cvbs irq");
+			else
+				pr_debug("irq_num(%u)\n", wu_irq);
+
+			irq_set_irq_type(wu_irq, IRQ_TYPE_EDGE_BOTH);
+			ret = request_irq(wu_irq, gpio_wakeup_isr,
+					IRQF_SHARED, "wakeup_gpio", gpio_dev);
+			if (ret)
+				pr_err("Cannot register IRQ %d", wu_irq);
+		}
+	}
+
+	gpio_irq_base = gpio_to_irq(0);
+
+	init_completion(&wu_completion);
+
+	return ret;
+}
+
+static const struct of_device_id rtk_gpio_wakeup_table[] = {
+	{.compatible = "realtek,gpio_wakeup",},
+	{},
+};
+
+
+static struct platform_driver rtk_gpio_wakeup_driver = {
+	.probe		= rtk_gpio_wakeup_probe,
+	.driver		= {
+		.name	= "gpio_wakeup",
+		.of_match_table = of_match_ptr(rtk_gpio_wakeup_table),
+		.owner	= THIS_MODULE,
+	},
+};
+
+
+static int __init rtk_gpio_wakeup_init(void)
+{
+	int ret = 0;
+
+	ret = platform_driver_register(&rtk_gpio_wakeup_driver);
+	if (ret != 0)
+		goto err_register;
+
+	return 0;
+err_register:
+	platform_driver_unregister(&rtk_gpio_wakeup_driver);
+
+	return -EFAULT;
+}
+
+static void __exit rtk_gpio_wakeup_exit(void)
+{
+
+	class_remove_file(wakeup_class, &class_attr_gpio_wakeup);
+	class_destroy(wakeup_class);
+	platform_driver_unregister(&rtk_gpio_wakeup_driver);
+}
+
+
+module_init(rtk_gpio_wakeup_init);
+module_exit(rtk_gpio_wakeup_exit);
+MODULE_DESCRIPTION("Realtek GPIO wakeup driver");
+MODULE_LICENSE("GPL v2");
+
+
+
diff --git a/drivers/soc/realtek/xen/hypercall-rtk.c b/drivers/soc/realtek/xen/hypercall-rtk.c
new file mode 100644
index 00000000..74d5966
--- /dev/null
+++ b/drivers/soc/realtek/xen/hypercall-rtk.c
@@ -0,0 +1,81 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/device.h>
+#include <linux/miscdevice.h>
+#include <linux/fs.h>
+#include <linux/module.h>
+#include <linux/cpu.h>
+#include <xen/xen.h>
+#include <xen/interface/rtk-hypercall.h>
+#include <asm/xen/hypercall.h>
+#include <asm/xen/interface.h>
+
+#define DUMMY_TICKET	(~0)	// ticket wouldn't reach this value since it's u16
+
+unsigned int rtk_xen_domain_lock(unsigned long timeout, RTK_DOMAIN_LOCK lock_type) {
+	struct xen_rtk_domain_lock lock_param;
+	unsigned int ticket;
+	unsigned long base_time = sched_clock() / NSEC_PER_MSEC;
+	unsigned long current_time;
+	int rc = 0;
+
+	if (!xen_domain())
+		return DUMMY_TICKET;
+
+	lock_param.lock_type = lock_type;
+
+	rc = HYPERVISOR_rtk_hypercall_op(XENRTK_domain_lock, &lock_param);
+	if(rc) {
+		pr_err("%s, get ticket FAIL!!\n", __func__);
+		goto err;
+	}
+
+	ticket = lock_param.lock;
+
+	while (1) {
+		lock_param.lock_type = lock_type;
+		lock_param.lock = ticket;
+		rc = HYPERVISOR_rtk_hypercall_op(XENRTK_domain_lock_check, &lock_param);
+
+		/* LOCK HOLD */
+		if (!rc)
+			return ticket;
+
+		current_time = sched_clock() / NSEC_PER_MSEC;
+		if (current_time - base_time > timeout) {
+			pr_err("%s, timeout with ticket:%x, lock:%x held by dom:%u\n",
+				__func__, ticket, lock_param.lock, lock_param.domid);
+			goto err;
+		}
+	}
+err:
+	BUG();
+	return rc;
+}
+
+int rtk_xen_domain_unlock(unsigned int ticket, RTK_DOMAIN_LOCK lock_type) {
+	struct xen_rtk_domain_lock lock_param;
+	int rc = 0;
+
+	if (ticket == DUMMY_TICKET)
+		return 0;
+
+	lock_param.lock = ticket;
+	lock_param.lock_type = lock_type;
+	rc =  HYPERVISOR_rtk_hypercall_op(XENRTK_domain_unlock, &lock_param);
+
+	if (rc != 0) {
+		pr_warn("DEBUG UNLOCK FAIL!!\n");
+		BUG();
+	}
+
+	return rc;
+}
+
diff --git a/drivers/spi/Kconfig b/drivers/spi/Kconfig
index b799547..a3d1043 100644
--- a/drivers/spi/Kconfig
+++ b/drivers/spi/Kconfig
@@ -230,6 +230,15 @@ config SPI_DW_MMIO
 	tristate "Memory-mapped io interface driver for DW SPI core"
 	depends on SPI_DESIGNWARE
 
+config SPI_RTD139x
+	tristate "SPI driver for DW SPI core on RTK RTD139x, RTD16xx, or RTD13xx platform"
+	select SPI_DESIGNWARE
+	depends on ARCH_RTD139x || ARCH_RTD16xx || ARCH_RTD13xx
+	default n
+	help
+	  Driver for the SPI controller core from DesignWare on
+	  Realtek RTD139x, RTD16xx, or RTD13xx platform.
+
 config SPI_DLN2
        tristate "Diolan DLN-2 USB SPI adapter"
        depends on MFD_DLN2
@@ -759,6 +768,12 @@ config SPI_TLE62X0
 # Add new SPI protocol masters in alphabetical order above this line
 #
 
+config SPI_RTK129X
+    tristate "Realtek SPI"
+    select SPI_BITBANG
+    help
+        This driver supports GSPI on Realtek SoC
+
 endif # SPI_MASTER
 
 # (slave support would go here)
diff --git a/drivers/spi/Makefile b/drivers/spi/Makefile
index aa939d9..4d245ea 100644
--- a/drivers/spi/Makefile
+++ b/drivers/spi/Makefile
@@ -36,6 +36,7 @@ obj-$(CONFIG_SPI_DESIGNWARE)		+= spi-dw.o
 obj-$(CONFIG_SPI_DW_MMIO)		+= spi-dw-mmio.o
 obj-$(CONFIG_SPI_DW_PCI)		+= spi-dw-midpci.o
 spi-dw-midpci-objs			:= spi-dw-pci.o spi-dw-mid.o
+obj-$(CONFIG_SPI_RTD139x)		+= spi-dw-rtd139x.o
 obj-$(CONFIG_SPI_EFM32)			+= spi-efm32.o
 obj-$(CONFIG_SPI_EP93XX)		+= spi-ep93xx.o
 obj-$(CONFIG_SPI_FALCON)		+= spi-falcon.o
@@ -102,3 +103,4 @@ obj-$(CONFIG_SPI_XILINX)		+= spi-xilinx.o
 obj-$(CONFIG_SPI_XLP)			+= spi-xlp.o
 obj-$(CONFIG_SPI_XTENSA_XTFPGA)		+= spi-xtensa-xtfpga.o
 obj-$(CONFIG_SPI_ZYNQMP_GQSPI)		+= spi-zynqmp-gqspi.o
+obj-$(CONFIG_SPI_RTK129X)       += spi-rtk129x.o
diff --git a/drivers/spi/spi-dw-rtd139x.c b/drivers/spi/spi-dw-rtd139x.c
new file mode 100644
index 00000000..8de0655
--- /dev/null
+++ b/drivers/spi/spi-dw-rtd139x.c
@@ -0,0 +1,233 @@
+/*
+ * SPI driver for DW SPI Core on Realtek RTD139x platform
+ *
+ * Copyright (c) 2017 Realtek Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms and conditions of the GNU General Public License,
+ * version 2, as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+ * more details.
+ */
+
+#include <linux/interrupt.h>
+#include <linux/pci.h>
+#include <linux/slab.h>
+#include <linux/spi/spi.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/init.h>
+#include <linux/err.h>
+#include <linux/of.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/interrupt.h>
+#include <linux/suspend.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+#include <linux/io.h>
+
+#include "spi-dw.h"
+
+#define DRIVER_NAME "dw_spi_rtd139x"
+#define SPI_Wra_CTRL 0
+
+struct rtk_spi {
+	struct dw_spi dws;
+
+	void __iomem *spi_wrapper;
+	struct clk *clk;
+	struct reset_control *rstc;
+	struct device *dev;
+};
+
+static inline struct rtk_spi *rtk_spi_to_hw(struct spi_device *spi)
+{
+	struct dw_spi *dws = spi_master_get_devdata(spi->master); 
+	struct rtk_spi *hw = container_of(dws, struct rtk_spi, dws);
+
+	return hw;
+	//return spi_master_get_devdata(sdev->master);
+}
+
+void rtk_spi_wrap_ctrl(struct spi_device *spi,  int val)
+{
+	struct rtk_spi *hw = rtk_spi_to_hw(spi);
+	__raw_writel(val, hw->spi_wrapper + SPI_Wra_CTRL);
+}
+EXPORT_SYMBOL_GPL(rtk_spi_wrap_ctrl);
+
+
+static int rtk_spi_probe(struct platform_device *pdev)
+{
+	struct rtk_spi *hw;
+	struct dw_spi *dws;
+	struct clk *clk = clk_get(&pdev->dev, NULL);
+	struct reset_control *rstc = reset_control_get(&pdev->dev, NULL);
+	u32 val;
+	int err = -ENODEV;
+
+	if (WARN_ON(!(pdev->dev.of_node)))
+	{
+		pr_err("[SPI] Error: No node\n");
+		return err;
+	}
+
+	hw = devm_kzalloc(&pdev->dev, sizeof(*hw), GFP_KERNEL);
+	if (!hw)
+		return -ENOMEM;
+
+	dws = &hw->dws;
+	/* Enable clk and release reset module */
+	reset_control_deassert(rstc);	/* release reset */
+	clk_prepare_enable(clk);	/* enable clk */
+
+	dev_set_drvdata(&pdev->dev, hw);
+
+	/* Find and map resources */
+	dws->regs = of_iomap(pdev->dev.of_node, 0);
+	if (IS_ERR(dws->regs)) {
+		dev_err(&pdev->dev, "[SPI] DW SPI region map failed, addr 0x%p\n", dws->regs);
+		goto exit;
+	}
+	hw->spi_wrapper = of_iomap(pdev->dev.of_node, 1);
+
+	if (IS_ERR(dws->regs)) {
+		dev_err(&pdev->dev, "[SPI] SPI wrapper region map failed, addr 0x%p\n", hw->spi_wrapper);
+		goto exit;
+	}
+
+	dws->irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (dws->irq < 0) {
+		dev_err(&pdev->dev, "[SPI] no irq resource?\n");
+		err = -ENXIO;
+		goto exit;
+	}
+
+	if (!of_property_read_u32(pdev->dev.of_node, "num-chipselect", &val))
+		dws->num_cs = val;
+	if (!of_property_read_u32(pdev->dev.of_node, "bus-num", &val))
+		dws->bus_num = val;
+	if (!of_property_read_u32(pdev->dev.of_node, "clock-frequency", &val))
+		dws->max_freq = val;
+
+	hw->clk = clk;
+	hw->rstc = rstc;
+	hw->dev = &pdev->dev;
+	/* call setup function */
+	err = dw_spi_add_host(&pdev->dev, &hw->dws);
+	if (err) {
+		pr_err("[SPI] Init failed, ret = %d\n", err);
+		goto exit;
+	}
+	dev_info(&pdev->dev, "[SPI] base 0x%p, irq %d\n", hw->dws.regs, hw->dws.irq);
+
+	return 0;
+
+exit:
+	/* Disable clk and reset module */
+	reset_control_assert(hw->rstc);	/* reset */
+	clk_disable_unprepare(hw->clk);	/* disable clk */
+	reset_control_put(rstc);
+	dev_set_drvdata(&pdev->dev, NULL);
+	return err;
+}
+
+static int rtk_spi_remove(struct platform_device *dev)
+{
+	struct rtk_spi *hw = platform_get_drvdata(dev);
+	struct dw_spi *dws = &hw->dws;
+
+	dw_spi_remove_host(dws);
+
+	/* Disable clk and reset module */
+	reset_control_assert(hw->rstc);	/* reset */
+	clk_disable_unprepare(hw->clk);	/* disable clk */
+	reset_control_put(hw->rstc);
+
+	dev_set_drvdata(&dev->dev, NULL);
+	return 0;
+}
+
+
+#ifdef CONFIG_PM_SLEEP
+
+static int rtk_spi_suspend(struct device *dev)
+{
+	struct rtk_spi *hw = dev_get_drvdata(dev);
+	struct dw_spi *dws = &hw->dws;
+	int ret;
+
+	printk(KERN_ERR "[SPI] Enter %s\n", __func__);
+
+	if(RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		printk(KERN_ERR "[SPI] %s Idle mode\n", __func__);
+	}else{
+		//For suspend mode
+		printk(KERN_ERR "[SPI] %s Suspend mode\n", __func__);
+	}
+
+	ret = dw_spi_suspend_host(dws);
+
+	printk(KERN_ERR "[SPI] Exit %s\n", __func__);
+
+	return ret;
+}
+
+static int rtk_spi_resume(struct device *dev)
+{
+	struct rtk_spi *hw = dev_get_drvdata(dev);
+	struct dw_spi *dws = &hw->dws;
+	int ret;
+
+	printk(KERN_ERR "[SPI] Enter %s\n", __func__);
+
+	if(RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		printk(KERN_ERR "[SPI] %s Idle mode\n", __func__);
+	}else{
+		//For suspend mode
+		printk(KERN_ERR "[SPI] %s Suspend mode\n", __func__);
+	}
+
+	ret = dw_spi_resume_host(dws);
+
+	printk(KERN_ERR "[SPI] Exit %s\n", __func__);
+
+	return ret;
+}
+
+static SIMPLE_DEV_PM_OPS(rtk_spi_pm_ops, rtk_spi_suspend, rtk_spi_resume);
+
+#define RTK_SPI_PM_OPS	(&rtk_spi_pm_ops)
+
+#else /* CONFIG_PM_SLEEP */
+#define RTK_SPI_PM_OPS	NULL
+#endif /* CONFIG_PM_SLEEP */
+
+
+static const struct of_device_id rtk_spi_match[] = {
+	{ .compatible = "Realtek,rtk-dw-apb-ssi", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_spi_match);
+
+static struct platform_driver rtk_spi_driver = {
+	.probe = rtk_spi_probe,
+	.remove = rtk_spi_remove,
+	.driver = {
+		.name = DRIVER_NAME,
+		.owner = THIS_MODULE,
+		.pm = RTK_SPI_PM_OPS,
+		.of_match_table = of_match_ptr(rtk_spi_match),
+	},
+};
+module_platform_driver(rtk_spi_driver);
+
+MODULE_AUTHOR("Eric Wang <ericwang@realtek.com>");
+MODULE_DESCRIPTION("SPI driver for DW SPI Core on RTK RTD139x platform");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/spi/spi-dw.c b/drivers/spi/spi-dw.c
index c4226c0..4d5220e 100644
--- a/drivers/spi/spi-dw.c
+++ b/drivers/spi/spi-dw.c
@@ -67,6 +67,8 @@ static ssize_t dw_spi_show_regs(struct file *file, char __user *user_buf,
 	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
 			"SSIENR: \t0x%08x\n", dw_readl(dws, DW_SPI_SSIENR));
 	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
+			"MWCR: \t\t0x%08x\n", dw_readl(dws, DW_SPI_MWCR));
+	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
 			"SER: \t\t0x%08x\n", dw_readl(dws, DW_SPI_SER));
 	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
 			"BAUDR: \t\t0x%08x\n", dw_readl(dws, DW_SPI_BAUDR));
@@ -85,12 +87,31 @@ static ssize_t dw_spi_show_regs(struct file *file, char __user *user_buf,
 	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
 			"ISR: \t\t0x%08x\n", dw_readl(dws, DW_SPI_ISR));
 	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
+			"RISR: \t\t0x%08x\n", dw_readl(dws, DW_SPI_RISR));
+	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
+			"TXOICR: \t0x%08x\n", dw_readl(dws, DW_SPI_TXOICR));
+	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
+			"RXOICR: \t0x%08x\n", dw_readl(dws, DW_SPI_RXOICR));
+	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
+			"RXUICR: \t0x%08x\n", dw_readl(dws, DW_SPI_RXUICR));
+	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
+			"MSTICR: \t0x%08x\n", dw_readl(dws, DW_SPI_MSTICR));
+	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
+			"ICR: \t\t0x%08x\n", dw_readl(dws, DW_SPI_ICR));
+	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
 			"DMACR: \t\t0x%08x\n", dw_readl(dws, DW_SPI_DMACR));
 	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
 			"DMATDLR: \t0x%08x\n", dw_readl(dws, DW_SPI_DMATDLR));
 	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
 			"DMARDLR: \t0x%08x\n", dw_readl(dws, DW_SPI_DMARDLR));
 	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
+			"IDR: \t\t0x%08x\n", dw_readl(dws, DW_SPI_IDR));
+	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
+			"VERSION: \t0x%08x\n", dw_readl(dws, DW_SPI_VERSION));
+	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
+			"RX_SAMPLE_DLY: \t0x%08x\n", dw_readl(dws, DW_SPI_RX_SAMPLE_DLY));
+
+	len += snprintf(buf + len, SPI_REGS_BUFSIZE - len,
 			"=================================\n");
 
 	ret = simple_read_from_buffer(user_buf, count, ppos, buf, len);
@@ -139,13 +160,12 @@ static void dw_spi_set_cs(struct spi_device *spi, bool enable)
 {
 	struct dw_spi *dws = spi_master_get_devdata(spi->master);
 	struct chip_data *chip = spi_get_ctldata(spi);
-
 	/* Chip select logic is inverted from spi_set_cs() */
 	if (chip && chip->cs_control)
 		chip->cs_control(!enable);
-
-	if (!enable)
+	if (!enable) 
 		dw_writel(dws, DW_SPI_SER, BIT(spi->chip_select));
+	
 }
 
 /* Return the max entries we can fill into tx fifo */
@@ -182,7 +202,6 @@ static void dw_writer(struct dw_spi *dws)
 {
 	u32 max = tx_max(dws);
 	u16 txw = 0;
-
 	while (max--) {
 		/* Set the tx word if the transfer's original "tx" is not null */
 		if (dws->tx_end - dws->len) {
@@ -203,9 +222,10 @@ static void dw_reader(struct dw_spi *dws)
 
 	while (max--) {
 		rxw = dw_read_io_reg(dws, DW_SPI_DR);
+
 		/* Care rx only if the transfer's original "rx" is not null */
 		if (dws->rx_end - dws->len) {
-			if (dws->n_bytes == 1)
+			if (dws->n_bytes == 1) 
 				*(u8 *)(dws->rx) = rxw;
 			else
 				*(u16 *)(dws->rx) = rxw;
@@ -240,8 +260,10 @@ static irqreturn_t interrupt_transfer(struct dw_spi *dws)
 		spi_finalize_current_transfer(dws->master);
 		return IRQ_HANDLED;
 	}
+
 	if (irq_status & SPI_INT_TXEI) {
 		spi_mask_intr(dws, SPI_INT_TXEI);
+
 		dw_writer(dws);
 		/* Enable TX irq always, it will be disabled when RX finished */
 		spi_umask_intr(dws, SPI_INT_TXEI);
@@ -297,6 +319,8 @@ static int dw_spi_transfer_one(struct spi_master *master,
 	dws->rx_end = dws->rx + transfer->len;
 	dws->len = transfer->len;
 
+	
+
 	spi_enable_chip(dws, 0);
 
 	/* Handle per transfer options for bpw and speed */
@@ -307,8 +331,10 @@ static int dw_spi_transfer_one(struct spi_master *master,
 			chip->speed_hz = transfer->speed_hz;
 		}
 		dws->current_freq = transfer->speed_hz;
+
 		spi_set_clk(dws, chip->clk_div);
 	}
+
 	if (transfer->bits_per_word == 8) {
 		dws->n_bytes = 1;
 		dws->dma_width = 1;
@@ -318,6 +344,7 @@ static int dw_spi_transfer_one(struct spi_master *master,
 	} else {
 		return -EINVAL;
 	}
+
 	/* Default SPI mode is SCPOL = 0, SCPH = 0 */
 	cr0 = (transfer->bits_per_word - 1)
 		| (chip->type << SPI_FRF_OFFSET)
@@ -354,11 +381,13 @@ static int dw_spi_transfer_one(struct spi_master *master,
 	 * we only need set the TXEI IRQ, as TX/RX always happen syncronizely
 	 */
 	if (dws->dma_mapped) {
+
 		ret = dws->dma_ops->dma_setup(dws, transfer);
 		if (ret < 0) {
 			spi_enable_chip(dws, 1);
 			return ret;
 		}
+
 	} else if (!chip->poll_mode) {
 		txlevel = min_t(u16, dws->fifo_len / 2, dws->len / dws->n_bytes);
 		dw_writel(dws, DW_SPI_TXFLTR, txlevel);
@@ -369,17 +398,18 @@ static int dw_spi_transfer_one(struct spi_master *master,
 		spi_umask_intr(dws, imask);
 
 		dws->transfer_handler = interrupt_transfer;
-	}
 
+	}
 	spi_enable_chip(dws, 1);
 
 	if (dws->dma_mapped) {
+
 		ret = dws->dma_ops->dma_transfer(dws, transfer);
 		if (ret < 0)
 			return ret;
 	}
 
-	if (chip->poll_mode)
+	if (chip->poll_mode) 
 		return poll_transfer(dws);
 
 	return 1;
@@ -477,7 +507,6 @@ int dw_spi_add_host(struct device *dev, struct dw_spi *dws)
 	int ret;
 
 	BUG_ON(dws == NULL);
-
 	master = spi_alloc_master(dev, 0);
 	if (!master)
 		return -ENOMEM;
@@ -527,6 +556,7 @@ int dw_spi_add_host(struct device *dev, struct dw_spi *dws)
 	}
 
 	dw_spi_debugfs_init(dws);
+
 	return 0;
 
 err_dma_exit:
diff --git a/drivers/spi/spi-dw.h b/drivers/spi/spi-dw.h
index c21ca02..2a7a9e7 100644
--- a/drivers/spi/spi-dw.h
+++ b/drivers/spi/spi-dw.h
@@ -31,7 +31,7 @@
 #define DW_SPI_IDR			0x58
 #define DW_SPI_VERSION			0x5c
 #define DW_SPI_DR			0x60
-
+#define DW_SPI_RX_SAMPLE_DLY		0xf0
 /* Bit fields in CTRLR0 */
 #define SPI_DFS_OFFSET			0
 
@@ -223,6 +223,8 @@ static inline void spi_reset_chip(struct dw_spi *dws)
 {
 	spi_enable_chip(dws, 0);
 	spi_mask_intr(dws, 0xff);
+	/* Set Rx Sample Delay for greenpeak 0xf*/
+        dw_writel(dws, DW_SPI_RX_SAMPLE_DLY, 0xf);	
 	spi_enable_chip(dws, 1);
 }
 
diff --git a/drivers/spi/spi-rtk129x.c b/drivers/spi/spi-rtk129x.c
new file mode 100644
index 00000000..a4100c5
--- /dev/null
+++ b/drivers/spi/spi-rtk129x.c
@@ -0,0 +1,588 @@
+/*
+ * Realtek SPI driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/errno.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/delay.h>
+#include <linux/spi/spi.h>
+#include <linux/spi/spi_bitbang.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_gpio.h>
+#include <linux/suspend.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+#define SPI_CONTROL		0x0
+	#define SPI_CLK_DIV(n)		((n)<<16)
+
+#define SPI_CS_TIMING	0x4
+	#define TCS_high(n)		(n<<16)
+	#define TCS_end(n)		(n<<8)
+	#define TCS_start(n)	(n<<0)
+	#define DEFAULT_TIMING	(TCS_high(0)|TCS_end(0x10)|TCS_start(0))
+
+#define SPI_AUX_CTRL	0x8
+	#define CS0_EN			(1<<0)
+	#define CS1_EN			(1<<1)
+	#define MASTER_MODE_EN	(0<<8)
+	#define SLAVE_MODE_EN	(1<<8)
+	#define DEFAULT_AUX		(CS0_EN | MASTER_MODE_EN)
+
+#define SPI_CMD_DUMMY	0xC
+	#define INST_BIT_LEN(n)	(n<<16)
+
+#define SPI_SO_CTRL		0x10
+	#define READ_CMD		(0<<31)
+	#define WRITE_CMD		(1<<31)
+	#define ADDR_BIT_LEN(n)	(n<<22)
+	#define DATA_BIT_LEN(n)	(n<<0)
+
+#define SPI_SI_CTRL		0x14
+	#define RD_BIT_LEN(n)	(n<<0)
+
+#define SPI_W_FIFO		0x18
+#define SPI_R_FIFO		0x1C
+#define SPI_INST		0x20
+#define SPI_ADDR		0X24
+
+#define SPI_CTRL		0x28
+	#define CMD_ENABLE		(1<<0)
+
+#define SPI_INT			0x30
+	#define CMD_DONE		(1<<0)
+
+
+#define RTK_SPI_RXDATA	0
+#define RTK_SPI_TXDATA	4
+#define RTK_SPI_STATUS	8
+#define RTK_SPI_CONTROL	12
+#define RTK_SPI_SLAVE_SEL	20
+
+#define RTK_SPI_STATUS_ROE_MSK	0x8
+#define RTK_SPI_STATUS_TOE_MSK	0x10
+#define RTK_SPI_STATUS_TMT_MSK	0x20
+#define RTK_SPI_STATUS_TRDY_MSK	0x40
+#define RTK_SPI_STATUS_RRDY_MSK	0x80
+#define RTK_SPI_STATUS_E_MSK		0x100
+
+#define RTK_SPI_CONTROL_IROE_MSK	0x8
+#define RTK_SPI_CONTROL_ITOE_MSK	0x10
+#define RTK_SPI_CONTROL_ITRDY_MSK	0x40
+#define RTK_SPI_CONTROL_IRRDY_MSK	0x80
+#define RTK_SPI_CONTROL_IE_MSK	0x100
+#define RTK_SPI_CONTROL_SSO_MSK	0x400
+
+#define RTK_SPI_DUMMY_LEN 0
+#define RTK_SPI_MAX_WRITE_LEN 17
+#define RTK_SPI_MAX_READ_LEN 16
+
+#define RTK_SPI_BASE_CLK		256000000
+#define RTK_SPI_MAX_CLK			 25600000	/* for RF4CE device */
+
+static int cs_ctrl_gpio = -1;
+
+#if 0
+	#define RTK_SPI_DBG(args...) printk(args)
+#else
+	#define RTK_SPI_DBG(args...)
+#endif
+
+struct rtk_gspi_devstate {
+	unsigned int	hz;
+	u8		sck_div;
+};
+
+struct rtk_gspi {
+	/* bitbang has to be first */
+	struct spi_bitbang bitbang;
+	struct completion done;
+
+	void __iomem *base;
+	int irq;
+	int len;
+	int count;
+	int bytes_per_word;
+	unsigned long imr;
+
+	/* data buffers */
+	const unsigned char *tx;
+	unsigned char *rx;
+
+	struct clk		*clk;
+	struct spi_master	*master;
+	struct spi_device	*curdev;
+	struct device		*dev;
+};
+
+static inline struct rtk_gspi *rtk_gspi_to_hw(struct spi_device *sdev)
+{
+	return spi_master_get_devdata(sdev->master);
+}
+
+
+static void rtk_gspi_chipsel(struct spi_device *spi, int value)
+{
+	unsigned int cspol;
+	cspol = spi->mode & SPI_CS_HIGH ? 1 : 0;
+	if (value == BITBANG_CS_INACTIVE)
+		cspol = !cspol;
+
+	RTK_SPI_DBG("chipsel(%d), set GPIO%d value(%u)\n", value, cs_ctrl_gpio, cspol);
+	gpio_set_value(cs_ctrl_gpio, cspol);
+
+}
+
+static int rtk_gspi_update_state(struct spi_device *spi,
+				    struct spi_transfer *t)
+{
+	struct rtk_gspi *hw = rtk_gspi_to_hw(spi);
+	struct rtk_gspi_devstate *cs = spi->controller_state;
+	unsigned int hz;
+	unsigned int div;
+	unsigned long clk;
+
+	hz  = t ? t->speed_hz : spi->max_speed_hz;
+
+	if (!hz)
+		hz = spi->max_speed_hz;
+
+	if (hz > RTK_SPI_MAX_CLK)
+		hz = RTK_SPI_MAX_CLK;
+
+	if (cs->hz != hz) {
+		clk = RTK_SPI_BASE_CLK;
+		div = DIV_ROUND_UP(clk, hz);
+
+		RTK_SPI_DBG("temporary div = %d\n", div);
+		if (div <= 4) {
+			div = 4;
+			cs->sck_div = 2;
+		} else if (div == 5) {
+			cs->sck_div = 0x11;
+		} else if (div == 7) {
+			cs->sck_div = 0x12;
+		} else if (div <= 16) {
+			div = ((div + 1) / 2) * 2;
+			cs->sck_div = div / 2;
+		} else if (div <= 20) {
+			div = 20;
+			cs->sck_div = 9;
+		} else if (div <= 24) {
+			div = 24;
+			cs->sck_div = 0xa;
+		} else if (div <= 48) {
+			div = 48;
+			cs->sck_div = 0xb;
+		} else if (div <= 256) {
+			div = 256;
+			cs->sck_div = 0xc;
+		} else if (div <= 512) {
+			div = 512;
+			cs->sck_div = 0xd;
+		} else if (div <= 2048) {
+			div = 2048;
+			cs->sck_div = 0xe;
+		} else {
+			div = 2560;
+			cs->sck_div = 0xf;
+		}
+
+		dev_dbg(&spi->dev, "pre-scaler=%d (wanted %d, got %ld)\n",
+			div, hz, clk / div );
+
+		RTK_SPI_DBG("old hz = %d, new hz = %d, clk = %d, div = %d, sck_div = %d\n", cs->hz, hz, clk, div, cs->sck_div);
+		cs->hz = hz;
+	}
+	else
+		return 1;
+
+	return 0;
+}
+
+static int rtk_gspi_setupxfer(struct spi_device *spi, struct spi_transfer *t)
+{
+	struct rtk_gspi *hw = rtk_gspi_to_hw(spi);
+	struct rtk_gspi_devstate *cs = spi->controller_state;
+
+	if(!rtk_gspi_update_state(spi, t)) {
+		writel(SPI_CLK_DIV(cs->sck_div) | BIT(8), hw->base + SPI_CONTROL);
+
+		RTK_SPI_DBG("%s:%d: cs->sck_div = %d, SPI_CONTROL = 0x%x\n", __func__, __LINE__, cs->sck_div, readl(hw->base + SPI_CONTROL));
+	}
+
+	return 0;
+}
+
+static int rtk_gspi_setup(struct spi_device *spi)
+{
+	struct rtk_gspi *hw = rtk_gspi_to_hw(spi);
+	struct rtk_gspi_devstate *cs = spi->controller_state;
+
+	/* allocate settings on the first call */
+	if (!cs) {
+		cs = kzalloc(sizeof(struct rtk_gspi_devstate), GFP_KERNEL);
+		if (!cs)
+			return -ENOMEM;
+
+		cs->hz = -1;
+		spi->controller_state = cs;
+	}
+
+	/* initialise the state from the device */
+	rtk_gspi_setupxfer(spi, NULL);
+
+	//spin_lock(&hw->bitbang.lock);
+	if (!hw->bitbang.busy) {
+		hw->bitbang.chipselect(spi, BITBANG_CS_INACTIVE);
+	}
+	//spin_unlock(&hw->bitbang.lock);
+
+
+	return 0;
+}
+
+static void rtk_gspi_cleanup(struct spi_device *spi)
+{
+	struct rtk_gspi_devstate *cs = spi->controller_state;
+	if (cs) {
+		kfree(cs);
+	}
+}
+
+static void rtk_gspi_write(struct rtk_gspi *hw)
+{
+	unsigned int txd,temp,i,j;
+	unsigned int write_len,data_byte_len,fifo_data_byte_len,offset=0;
+
+	RTK_SPI_DBG("%s len(%u)\n", __func__,hw->len);
+
+	write_len = hw->len;
+
+	if((write_len<1) || (hw->tx==NULL))
+		return;
+
+	while(write_len)
+	{
+		if(write_len>=RTK_SPI_MAX_WRITE_LEN)
+			data_byte_len = RTK_SPI_MAX_WRITE_LEN;
+		else
+			data_byte_len = write_len;
+
+		fifo_data_byte_len = data_byte_len-1;
+
+		if(data_byte_len==1)//Write FIFO can't be empty
+		{
+			writel((INST_BIT_LEN(0x4) | RTK_SPI_DUMMY_LEN), hw->base + SPI_CMD_DUMMY);//tr
+			writel((ADDR_BIT_LEN(0x0) | WRITE_CMD | DATA_BIT_LEN(0x4)), hw->base + SPI_SO_CTRL);
+			RTK_SPI_DBG("%s tx[%u] 0x%02x\n", __func__,offset,hw->tx[offset]);
+			RTK_SPI_DBG("%s write 0x%08x to INST\n", __func__,hw->tx[offset]>>4);
+			RTK_SPI_DBG("%s write 0x%08x to FIFO\n", __func__,hw->tx[offset]&0xF);
+			writel((hw->tx[offset]>>4), hw->base + SPI_INST);//4  //4bit
+			writel((hw->tx[offset]&0xF), hw->base + SPI_W_FIFO);//
+		}
+		else
+		{
+			writel((INST_BIT_LEN(0x8) | RTK_SPI_DUMMY_LEN), hw->base + SPI_CMD_DUMMY);//tr
+			writel((ADDR_BIT_LEN(0x0) | WRITE_CMD | DATA_BIT_LEN(fifo_data_byte_len<<3)), hw->base + SPI_SO_CTRL);
+			RTK_SPI_DBG("%s tx[%u] 0x%02x\n", __func__,offset,hw->tx[offset]);
+			RTK_SPI_DBG("%s write 0x%08x to INST\n", __func__,hw->tx[offset]);
+			writel(hw->tx[offset], hw->base + SPI_INST);//First byte
+		}
+		writel(RD_BIT_LEN(0x0), hw->base + SPI_SI_CTRL);//Note:read bit len cat't be 0x20
+
+		//Write FIFO
+		txd = 0;
+		j=1;
+		for(i=fifo_data_byte_len+offset; i>=offset+1; i--)
+		{
+			temp = hw->tx[i]<<(8*(j-1));
+			txd = txd + temp;
+			RTK_SPI_DBG("%s tx[%u] 0x%02x\n", __func__,i,hw->tx[i]);
+			if(j==4)
+			{
+				RTK_SPI_DBG("%s write 0x%08x to FIFO\n", __func__,txd);
+				writel(txd, hw->base + SPI_W_FIFO);
+				txd = 0;
+				j=1;
+				continue;
+			}
+			else if(i==(offset+1))
+			{
+				RTK_SPI_DBG("%s write 0x%08x to FIFO\n", __func__,txd);
+				writel(txd, hw->base + SPI_W_FIFO);
+			}
+			j++;
+		}
+
+		writel(0x100, hw->base + SPI_CTRL); // reset r/w fifo
+		writel(CMD_ENABLE, hw->base + SPI_CTRL);
+
+		while (!(readl(hw->base + SPI_INT) & CMD_DONE))
+			cpu_relax();
+
+		writel(CMD_DONE, hw->base + SPI_INT);// clear
+		offset += RTK_SPI_MAX_WRITE_LEN;
+		write_len = write_len - data_byte_len;
+	}
+
+	return;
+
+}
+
+static void rtk_gspi_read(struct rtk_gspi *hw)
+{
+	unsigned int rxd,i;
+	unsigned int read_len,data_byte_len,offset=0;
+
+	RTK_SPI_DBG("%s len(%u)\n", __func__,hw->len);
+
+	read_len = hw->len;
+
+	while(read_len)
+	{
+		if(read_len>=RTK_SPI_MAX_READ_LEN)
+			data_byte_len = RTK_SPI_MAX_READ_LEN;
+		else
+			data_byte_len = read_len;
+
+		writel((INST_BIT_LEN(0x0) | RTK_SPI_DUMMY_LEN), hw->base + SPI_CMD_DUMMY);//tr
+		writel((ADDR_BIT_LEN(0x0) | READ_CMD), hw->base + SPI_SO_CTRL);
+		writel(0x100, hw->base + SPI_CTRL); // reset r/w fifo
+		writel(RD_BIT_LEN(data_byte_len<<3), hw->base + SPI_SI_CTRL);//Note:read bit len cat't be 0x20
+		writel(CMD_ENABLE, hw->base + SPI_CTRL);
+		RTK_SPI_DBG("%s READ CMD, read len(%u)\n", __func__,data_byte_len);
+		while (!(readl(hw->base + SPI_INT) & CMD_DONE))
+			cpu_relax();
+		writel(CMD_DONE, hw->base + SPI_INT);
+
+		//Read FIFO
+		rxd = readl(hw->base + SPI_R_FIFO);
+		RTK_SPI_DBG("%s read 0x%08x from FIFO\n", __func__,rxd);
+		for(i=1; i<=data_byte_len; i++)
+		{
+			hw->rx[offset+data_byte_len-i] = rxd&0xff;
+			RTK_SPI_DBG("%s rx[%u] 0x%02x\n", __func__,offset+data_byte_len-i,hw->rx[offset+data_byte_len-i]);
+			rxd = rxd >>8;
+			if(i%4==0&&(i<data_byte_len))
+			{
+				rxd = readl(hw->base + SPI_R_FIFO);
+				RTK_SPI_DBG("%s read 0x%08x from FIFO\n", __func__,rxd);
+			}
+		}
+		offset += RTK_SPI_MAX_READ_LEN;
+
+		read_len = read_len - data_byte_len;
+	}
+
+	return;
+
+}
+
+static int rtk_gspi_txrx(struct spi_device *spi, struct spi_transfer *t)
+{
+	struct rtk_gspi *hw = rtk_gspi_to_hw(spi);
+	struct spi_transfer *transfer;
+
+	transfer = t;
+
+	hw->tx = transfer->tx_buf;
+	hw->rx = transfer->rx_buf;
+	hw->len = transfer->len;
+
+	if(hw->tx!=NULL)
+		rtk_gspi_write(hw);
+	else if(hw->rx!=NULL)
+		rtk_gspi_read(hw);
+
+	return hw->len;
+
+}
+
+
+static int rtk_gspi_probe(struct platform_device *pdev)
+{
+	struct rtk_gspi_platform_data *platp = pdev->dev.platform_data;
+	struct rtk_gspi *hw;
+	struct spi_master *master;
+	struct clk *clk = clk_get(&pdev->dev, NULL);
+	struct reset_control *rstc = reset_control_get(&pdev->dev, NULL);
+
+	int err = -ENODEV;
+
+	if (WARN_ON(!(pdev->dev.of_node)))
+	{
+		pr_err("[GSPI] Error: No node\n");
+		return -err;
+	}
+
+	master = spi_alloc_master(&pdev->dev, sizeof(struct rtk_gspi));
+	if (!master)
+		return err;
+
+	/* Enable clk and release reset module */
+	reset_control_deassert(rstc);	// release reset
+	clk_prepare_enable(clk);		// enable clk
+
+	/* Setup the master default state. */
+	//master->bus_num = pdev->id;
+	master->bus_num = 0;
+	master->num_chipselect = 16;
+	master->mode_bits = SPI_MODE_0;
+	master->setup = rtk_gspi_setup;
+	master->cleanup = rtk_gspi_cleanup;
+	//RTK_SPI_DBG("%s bus_num %d, #cs %d, mode 0x%x, pdev->id %d\n", __func__, master->bus_num, master->num_chipselect, master->mode_bits, pdev->id);
+
+	hw = spi_master_get_devdata(master);
+	platform_set_drvdata(pdev, hw);
+	dev_set_drvdata(&pdev->dev, hw);
+
+	/* Setup the state for the bitbang driver */
+	hw->bitbang.master = spi_master_get(master);
+	if (!hw->bitbang.master)
+		return err;
+	hw->bitbang.setup_transfer = rtk_gspi_setupxfer;
+	hw->bitbang.chipselect = rtk_gspi_chipsel;
+	hw->bitbang.txrx_bufs = rtk_gspi_txrx;
+
+	/* Find and map resources */
+	hw->base = of_iomap(pdev->dev.of_node, 0);
+	if (!hw->base)
+		goto exit_busy;
+	writel(SPI_CLK_DIV(8) | BIT(8), hw->base + SPI_CONTROL);//Clock 15.43MHz, clk_div:16, phase adj
+	writel(DEFAULT_TIMING,  hw->base + SPI_CS_TIMING);
+	writel(DEFAULT_AUX,     hw->base + SPI_AUX_CTRL);
+
+	/* store hw info */
+	hw->clk = clk;
+
+	/* Request gpio */
+	cs_ctrl_gpio = of_get_named_gpio(pdev->dev.of_node, "spi-cs-gpio", 0);
+	if (cs_ctrl_gpio < 0)
+		pr_err("[GSPI][%s] could not get gpio from of ",__FUNCTION__);
+	else
+		pr_err("[GSPI] spi-cs-gpio(%d)\n",cs_ctrl_gpio);
+
+	/* Find platform data */
+	if (!platp)
+		hw->bitbang.master->dev.of_node = pdev->dev.of_node;
+
+	/* Register spi controller */
+	err = spi_bitbang_start(&hw->bitbang);
+	if (err)
+		goto exit;
+	dev_info(&pdev->dev, "base %p, irq %d\n", hw->base, hw->irq);
+
+	return 0;
+
+exit_busy:
+	err = -EBUSY;
+exit:
+	dev_set_drvdata(&pdev->dev, NULL);
+	platform_set_drvdata(pdev, NULL);
+	spi_master_put(master);
+	return err;
+}
+
+static int rtk_gspi_remove(struct platform_device *dev)
+{
+	struct rtk_gspi *hw = platform_get_drvdata(dev);
+	struct spi_master *master = hw->bitbang.master;
+
+	spi_bitbang_stop(&hw->bitbang);
+	platform_set_drvdata(dev, NULL);
+	dev_set_drvdata(&dev->dev, NULL);
+	spi_master_put(master);
+	return 0;
+}
+
+#ifdef CONFIG_PM
+
+static int rtk_gspi_suspend(struct device *dev)
+{
+	//struct rtk_gspi *hw = dev_get_drvdata(dev);
+	printk(KERN_ERR "[RTK_SPI] Enter %s\n", __func__);
+
+	if(RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		printk(KERN_ERR "[RTK_SPI] %s Idle mode\n", __func__);
+	}else{
+		//For suspend mode
+		printk(KERN_ERR "[RTK_SPI] %s Suspend mode\n", __func__);
+	}
+
+	printk(KERN_ERR "[RTK_SPI] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static int rtk_gspi_resume(struct device *dev)
+{
+	struct rtk_gspi *hw = dev_get_drvdata(dev);
+
+	printk(KERN_ERR "[RTK_SPI] Enter %s\n", __func__);
+
+	if(RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		printk(KERN_ERR "[RTK_SPI] %s Idle mode\n", __func__);
+	}else{
+		//For suspend mode
+		printk(KERN_ERR "[RTK_SPI] %s Suspend mode\n", __func__);
+	}
+
+
+	writel(SPI_CLK_DIV(8) | BIT(8), hw->base + SPI_CONTROL);//Clock 15.43MHz, clk_div:16, phase adj
+	writel(DEFAULT_TIMING,  hw->base + SPI_CS_TIMING);
+	writel(DEFAULT_AUX,     hw->base + SPI_AUX_CTRL);
+
+	printk(KERN_ERR "[RTK_SPI] Exit %s\n", __func__);
+
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_gspi_pm_ops = {
+	.suspend		= rtk_gspi_suspend,
+	.resume			= rtk_gspi_resume,
+};
+
+#define RTK_GSPI_PM_OPS	(&rtk_gspi_pm_ops)
+
+#else /* !CONFIG_PM */
+#define RTK_GSPI_PM_OPS	NULL
+#endif /* !CONFIG_PM */
+
+static const struct of_device_id rtk_gspi_match[] = {
+	{ .compatible = "Realtek,rtk129x-spi", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_gspi_match);
+
+
+static struct platform_driver rtk_gspi_driver = {
+	.probe = rtk_gspi_probe,
+	.remove = rtk_gspi_remove,
+	.driver = {
+		.name = "rtk-gspi",
+		.owner = THIS_MODULE,
+		.pm = RTK_GSPI_PM_OPS,
+		.of_match_table = of_match_ptr(rtk_gspi_match),
+	},
+};
+module_platform_driver(rtk_gspi_driver);
+
+MODULE_DESCRIPTION("Realtek GSPI driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtk129x-gspi");
+
diff --git a/drivers/staging/android/Kconfig b/drivers/staging/android/Kconfig
index 6c00d6f..5255dce 100644
--- a/drivers/staging/android/Kconfig
+++ b/drivers/staging/android/Kconfig
@@ -24,8 +24,45 @@ config ANDROID_LOW_MEMORY_KILLER
 	  scripts (/init.rc), and it defines priority values with minimum free memory size
 	  for each priority.
 
+config ANDROID_LOW_MEMORY_KILLER_AUTODETECT_OOM_ADJ_VALUES
+	bool "Android Low Memory Killer: detect oom_adj values"
+	depends on ANDROID_LOW_MEMORY_KILLER
+	default y
+	---help---
+	  Detect oom_adj values written to
+	  /sys/module/lowmemorykiller/parameters/adj and convert them
+	  to oom_score_adj values.
+
+config ANDROID_LOGGER
+	tristate "Android log driver"
+	default n
+	---help---
+	  This adds support for system-wide logging using four log buffers.
+
+	  These are:
+
+	      1: main
+	      2: events
+	      3: radio
+	      4: system
+
+	  Log reading and writing is performed via normal Linux reads and
+	  optimized writes. This optimization avoids logging having too
+	  much overhead in the system.
+
+config ANDROID_VSOC
+	tristate "Android Virtual SoC support"
+	default n
+	depends on PCI_MSI
+	---help---
+	  This option adds support for the Virtual SoC driver needed to boot
+	  a 'cuttlefish' Android image inside QEmu. The driver interacts with
+	  a QEmu ivshmem device. If built as a module, it will be called vsoc.
+
 source "drivers/staging/android/ion/Kconfig"
 
+source "drivers/staging/android/fiq_debugger/Kconfig"
+
 endif # if ANDROID
 
 endmenu
diff --git a/drivers/staging/android/Makefile b/drivers/staging/android/Makefile
index 7ed1be7..7396c5d 100644
--- a/drivers/staging/android/Makefile
+++ b/drivers/staging/android/Makefile
@@ -1,6 +1,9 @@
 ccflags-y += -I$(src)			# needed for trace events
 
 obj-y					+= ion/
+obj-$(CONFIG_FIQ_DEBUGGER)		+= fiq_debugger/
 
 obj-$(CONFIG_ASHMEM)			+= ashmem.o
 obj-$(CONFIG_ANDROID_LOW_MEMORY_KILLER)	+= lowmemorykiller.o
+obj-$(CONFIG_ANDROID_LOGGER)		+= logger.o
+obj-$(CONFIG_ANDROID_VSOC)		+= vsoc.o
diff --git a/drivers/staging/android/TODO b/drivers/staging/android/TODO
index 64d8c87..edfb680 100644
--- a/drivers/staging/android/TODO
+++ b/drivers/staging/android/TODO
@@ -33,5 +33,14 @@ sync framework:
  - clean up and ABI check for security issues
  - move it to drivers/base/dma-buf
 
+vsoc.c, uapi/vsoc_shm.h
+ - The current driver uses the same wait queue for all of the futexes in a
+   region. This will cause false wakeups in regions with a large number of
+   waiting threads. We should eventually use multiple queues and select the
+   queue based on the region.
+ - Add debugfs support for examining the permissions of regions.
+ - Remove VSOC_WAIT_FOR_INCOMING_INTERRUPT ioctl. This functionality has been
+   superseded by the futex and is there for legacy reasons.
+
 Please send patches to Greg Kroah-Hartman <greg@kroah.com> and Cc:
 Arve Hjønnevåg <arve@android.com> and Riley Andrews <riandrews@android.com>
diff --git a/drivers/staging/android/ashmem.c b/drivers/staging/android/ashmem.c
index 6d690e5..f4ffac4 100644
--- a/drivers/staging/android/ashmem.c
+++ b/drivers/staging/android/ashmem.c
@@ -409,22 +409,14 @@ static int ashmem_mmap(struct file *file, struct vm_area_struct *vma)
 	}
 	get_file(asma->file);
 
-	/*
-	 * XXX - Reworked to use shmem_zero_setup() instead of
-	 * shmem_set_file while we're in staging. -jstultz
-	 */
-	if (vma->vm_flags & VM_SHARED) {
-		ret = shmem_zero_setup(vma);
-		if (ret) {
-			fput(asma->file);
-			goto out;
-		}
+	if (vma->vm_flags & VM_SHARED)
+		shmem_set_file(vma, asma->file);
+	else {
+		if (vma->vm_file)
+			fput(vma->vm_file);
+		vma->vm_file = asma->file;
 	}
 
-	if (vma->vm_file)
-		fput(vma->vm_file);
-	vma->vm_file = asma->file;
-
 out:
 	mutex_unlock(&ashmem_mutex);
 	return ret;
@@ -461,9 +453,9 @@ static int ashmem_mmap(struct file *file, struct vm_area_struct *vma)
 		loff_t start = range->pgstart * PAGE_SIZE;
 		loff_t end = (range->pgend + 1) * PAGE_SIZE;
 
-		vfs_fallocate(range->asma->file,
-			      FALLOC_FL_PUNCH_HOLE | FALLOC_FL_KEEP_SIZE,
-			      start, end - start);
+		range->asma->file->f_op->fallocate(range->asma->file,
+				FALLOC_FL_PUNCH_HOLE | FALLOC_FL_KEEP_SIZE,
+				start, end - start);
 		range->purged = ASHMEM_WAS_PURGED;
 		lru_del(range);
 
diff --git a/drivers/staging/android/fiq_debugger/Kconfig b/drivers/staging/android/fiq_debugger/Kconfig
new file mode 100644
index 00000000..60fc224
--- /dev/null
+++ b/drivers/staging/android/fiq_debugger/Kconfig
@@ -0,0 +1,58 @@
+config FIQ_DEBUGGER
+	bool "FIQ Mode Serial Debugger"
+	default n
+	depends on ARM || ARM64
+	help
+	  The FIQ serial debugger can accept commands even when the
+	  kernel is unresponsive due to being stuck with interrupts
+	  disabled.
+
+config FIQ_DEBUGGER_NO_SLEEP
+	bool "Keep serial debugger active"
+	depends on FIQ_DEBUGGER
+	default n
+	help
+	  Enables the serial debugger at boot. Passing
+	  fiq_debugger.no_sleep on the kernel commandline will
+	  override this config option.
+
+config FIQ_DEBUGGER_WAKEUP_IRQ_ALWAYS_ON
+	bool "Don't disable wakeup IRQ when debugger is active"
+	depends on FIQ_DEBUGGER
+	default n
+	help
+	  Don't disable the wakeup irq when enabling the uart clock.  This will
+	  cause extra interrupts, but it makes the serial debugger usable with
+	  on some MSM radio builds that ignore the uart clock request in power
+	  collapse.
+
+config FIQ_DEBUGGER_CONSOLE
+	bool "Console on FIQ Serial Debugger port"
+	depends on FIQ_DEBUGGER
+	default n
+	help
+	  Enables a console so that printk messages are displayed on
+	  the debugger serial port as the occur.
+
+config FIQ_DEBUGGER_CONSOLE_DEFAULT_ENABLE
+	bool "Put the FIQ debugger into console mode by default"
+	depends on FIQ_DEBUGGER_CONSOLE
+	default n
+	help
+	  If enabled, this puts the fiq debugger into console mode by default.
+	  Otherwise, the fiq debugger will start out in debug mode.
+
+config FIQ_DEBUGGER_UART_OVERLAY
+	bool "Install uart DT overlay"
+	depends on FIQ_DEBUGGER
+	select OF_OVERLAY
+	default n
+	help
+	  If enabled, fiq debugger is calling fiq_debugger_uart_overlay()
+	  that will apply overlay uart_overlay@0 to disable proper uart.
+
+config FIQ_WATCHDOG
+	bool
+	select FIQ_DEBUGGER
+	select PSTORE_RAM
+	default n
diff --git a/drivers/staging/android/fiq_debugger/Makefile b/drivers/staging/android/fiq_debugger/Makefile
new file mode 100644
index 00000000..a7ca487
--- /dev/null
+++ b/drivers/staging/android/fiq_debugger/Makefile
@@ -0,0 +1,4 @@
+obj-y			+= fiq_debugger.o
+obj-$(CONFIG_ARM)	+= fiq_debugger_arm.o
+obj-$(CONFIG_ARM64)	+= fiq_debugger_arm64.o
+obj-$(CONFIG_FIQ_WATCHDOG)	+= fiq_watchdog.o
diff --git a/drivers/staging/android/fiq_debugger/fiq_debugger.c b/drivers/staging/android/fiq_debugger/fiq_debugger.c
new file mode 100644
index 00000000..d9bc1253
--- /dev/null
+++ b/drivers/staging/android/fiq_debugger/fiq_debugger.c
@@ -0,0 +1,1246 @@
+/*
+ * drivers/staging/android/fiq_debugger.c
+ *
+ * Serial Debugger Interface accessed through an FIQ interrupt.
+ *
+ * Copyright (C) 2008 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include <stdarg.h>
+#include <linux/module.h>
+#include <linux/io.h>
+#include <linux/console.h>
+#include <linux/interrupt.h>
+#include <linux/clk.h>
+#include <linux/platform_device.h>
+#include <linux/kernel_stat.h>
+#include <linux/kmsg_dump.h>
+#include <linux/irq.h>
+#include <linux/delay.h>
+#include <linux/reboot.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/smp.h>
+#include <linux/timer.h>
+#include <linux/tty.h>
+#include <linux/tty_flip.h>
+
+#ifdef CONFIG_FIQ_GLUE
+#include <asm/fiq_glue.h>
+#endif
+
+#ifdef CONFIG_FIQ_DEBUGGER_UART_OVERLAY
+#include <linux/of.h>
+#endif
+
+#include <linux/uaccess.h>
+
+#include "fiq_debugger.h"
+#include "fiq_debugger_priv.h"
+#include "fiq_debugger_ringbuf.h"
+
+#define DEBUG_MAX 64
+#define MAX_UNHANDLED_FIQ_COUNT 1000000
+
+#define MAX_FIQ_DEBUGGER_PORTS 4
+
+struct fiq_debugger_state {
+#ifdef CONFIG_FIQ_GLUE
+	struct fiq_glue_handler handler;
+#endif
+	struct fiq_debugger_output output;
+
+	int fiq;
+	int uart_irq;
+	int signal_irq;
+	int wakeup_irq;
+	bool wakeup_irq_no_set_wake;
+	struct clk *clk;
+	struct fiq_debugger_pdata *pdata;
+	struct platform_device *pdev;
+
+	char debug_cmd[DEBUG_MAX];
+	int debug_busy;
+	int debug_abort;
+
+	char debug_buf[DEBUG_MAX];
+	int debug_count;
+
+	bool no_sleep;
+	bool debug_enable;
+	bool ignore_next_wakeup_irq;
+	struct timer_list sleep_timer;
+	spinlock_t sleep_timer_lock;
+	bool uart_enabled;
+	struct wakeup_source debugger_wake_src;
+	bool console_enable;
+	int current_cpu;
+	atomic_t unhandled_fiq_count;
+	bool in_fiq;
+
+	struct work_struct work;
+	spinlock_t work_lock;
+	char work_cmd[DEBUG_MAX];
+
+#ifdef CONFIG_FIQ_DEBUGGER_CONSOLE
+	spinlock_t console_lock;
+	struct console console;
+	struct tty_port tty_port;
+	struct fiq_debugger_ringbuf *tty_rbuf;
+	bool syslog_dumping;
+#endif
+
+	unsigned int last_irqs[NR_IRQS];
+	unsigned int last_local_timer_irqs[NR_CPUS];
+};
+
+#ifdef CONFIG_FIQ_DEBUGGER_CONSOLE
+struct tty_driver *fiq_tty_driver;
+#endif
+
+#ifdef CONFIG_FIQ_DEBUGGER_NO_SLEEP
+static bool initial_no_sleep = true;
+#else
+static bool initial_no_sleep;
+#endif
+
+#ifdef CONFIG_FIQ_DEBUGGER_CONSOLE_DEFAULT_ENABLE
+static bool initial_debug_enable = true;
+static bool initial_console_enable = true;
+#else
+static bool initial_debug_enable;
+static bool initial_console_enable;
+#endif
+
+static bool fiq_kgdb_enable;
+static bool fiq_debugger_disable;
+
+module_param_named(no_sleep, initial_no_sleep, bool, 0644);
+module_param_named(debug_enable, initial_debug_enable, bool, 0644);
+module_param_named(console_enable, initial_console_enable, bool, 0644);
+module_param_named(kgdb_enable, fiq_kgdb_enable, bool, 0644);
+module_param_named(disable, fiq_debugger_disable, bool, 0644);
+
+#ifdef CONFIG_FIQ_DEBUGGER_WAKEUP_IRQ_ALWAYS_ON
+static inline
+void fiq_debugger_enable_wakeup_irq(struct fiq_debugger_state *state) {}
+static inline
+void fiq_debugger_disable_wakeup_irq(struct fiq_debugger_state *state) {}
+#else
+static inline
+void fiq_debugger_enable_wakeup_irq(struct fiq_debugger_state *state)
+{
+	if (state->wakeup_irq < 0)
+		return;
+	enable_irq(state->wakeup_irq);
+	if (!state->wakeup_irq_no_set_wake)
+		enable_irq_wake(state->wakeup_irq);
+}
+static inline
+void fiq_debugger_disable_wakeup_irq(struct fiq_debugger_state *state)
+{
+	if (state->wakeup_irq < 0)
+		return;
+	disable_irq_nosync(state->wakeup_irq);
+	if (!state->wakeup_irq_no_set_wake)
+		disable_irq_wake(state->wakeup_irq);
+}
+#endif
+
+static inline bool fiq_debugger_have_fiq(struct fiq_debugger_state *state)
+{
+	return (state->fiq >= 0);
+}
+
+#ifdef CONFIG_FIQ_GLUE
+static void fiq_debugger_force_irq(struct fiq_debugger_state *state)
+{
+	unsigned int irq = state->signal_irq;
+
+	if (WARN_ON(!fiq_debugger_have_fiq(state)))
+		return;
+	if (state->pdata->force_irq) {
+		state->pdata->force_irq(state->pdev, irq);
+	} else {
+		struct irq_chip *chip = irq_get_chip(irq);
+		if (chip && chip->irq_retrigger)
+			chip->irq_retrigger(irq_get_irq_data(irq));
+	}
+}
+#endif
+
+static void fiq_debugger_uart_enable(struct fiq_debugger_state *state)
+{
+	if (state->clk)
+		clk_enable(state->clk);
+	if (state->pdata->uart_enable)
+		state->pdata->uart_enable(state->pdev);
+}
+
+static void fiq_debugger_uart_disable(struct fiq_debugger_state *state)
+{
+	if (state->pdata->uart_disable)
+		state->pdata->uart_disable(state->pdev);
+	if (state->clk)
+		clk_disable(state->clk);
+}
+
+static void fiq_debugger_uart_flush(struct fiq_debugger_state *state)
+{
+	if (state->pdata->uart_flush)
+		state->pdata->uart_flush(state->pdev);
+}
+
+static void fiq_debugger_putc(struct fiq_debugger_state *state, char c)
+{
+	state->pdata->uart_putc(state->pdev, c);
+}
+
+static void fiq_debugger_puts(struct fiq_debugger_state *state, char *s)
+{
+	unsigned c;
+	while ((c = *s++)) {
+		if (c == '\n')
+			fiq_debugger_putc(state, '\r');
+		fiq_debugger_putc(state, c);
+	}
+}
+
+static void fiq_debugger_prompt(struct fiq_debugger_state *state)
+{
+	fiq_debugger_puts(state, "debug> ");
+}
+
+static void fiq_debugger_dump_kernel_log(struct fiq_debugger_state *state)
+{
+	char buf[512];
+	size_t len;
+	struct kmsg_dumper dumper = { .active = true };
+
+
+	kmsg_dump_rewind_nolock(&dumper);
+	while (kmsg_dump_get_line_nolock(&dumper, true, buf,
+					 sizeof(buf) - 1, &len)) {
+		buf[len] = 0;
+		fiq_debugger_puts(state, buf);
+	}
+}
+
+static void fiq_debugger_printf(struct fiq_debugger_output *output,
+			       const char *fmt, ...)
+{
+	struct fiq_debugger_state *state;
+	char buf[256];
+	va_list ap;
+
+	state = container_of(output, struct fiq_debugger_state, output);
+	va_start(ap, fmt);
+	vsnprintf(buf, sizeof(buf), fmt, ap);
+	va_end(ap);
+
+	fiq_debugger_puts(state, buf);
+}
+
+/* Safe outside fiq context */
+static int fiq_debugger_printf_nfiq(void *cookie, const char *fmt, ...)
+{
+	struct fiq_debugger_state *state = cookie;
+	char buf[256];
+	va_list ap;
+	unsigned long irq_flags;
+
+	va_start(ap, fmt);
+	vsnprintf(buf, 128, fmt, ap);
+	va_end(ap);
+
+	local_irq_save(irq_flags);
+	fiq_debugger_puts(state, buf);
+	fiq_debugger_uart_flush(state);
+	local_irq_restore(irq_flags);
+	return state->debug_abort;
+}
+
+static void fiq_debugger_dump_irqs(struct fiq_debugger_state *state)
+{
+	int n;
+	struct irq_desc *desc;
+
+	fiq_debugger_printf(&state->output,
+			"irqnr       total  since-last   status  name\n");
+	for_each_irq_desc(n, desc) {
+		struct irqaction *act = desc->action;
+		if (!act && !kstat_irqs(n))
+			continue;
+		fiq_debugger_printf(&state->output, "%5d: %10u %11u %8x  %s\n", n,
+			kstat_irqs(n),
+			kstat_irqs(n) - state->last_irqs[n],
+			desc->status_use_accessors,
+			(act && act->name) ? act->name : "???");
+		state->last_irqs[n] = kstat_irqs(n);
+	}
+}
+
+static void fiq_debugger_do_ps(struct fiq_debugger_state *state)
+{
+	struct task_struct *g;
+	struct task_struct *p;
+	unsigned task_state;
+	static const char stat_nam[] = "RSDTtZX";
+
+	fiq_debugger_printf(&state->output, "pid   ppid  prio task            pc\n");
+	read_lock(&tasklist_lock);
+	do_each_thread(g, p) {
+		task_state = p->state ? __ffs(p->state) + 1 : 0;
+		fiq_debugger_printf(&state->output,
+			     "%5d %5d %4d ", p->pid, p->parent->pid, p->prio);
+		fiq_debugger_printf(&state->output, "%-13.13s %c", p->comm,
+			     task_state >= sizeof(stat_nam) ? '?' : stat_nam[task_state]);
+		if (task_state == TASK_RUNNING)
+			fiq_debugger_printf(&state->output, " running\n");
+		else
+			fiq_debugger_printf(&state->output, " %08lx\n",
+					thread_saved_pc(p));
+	} while_each_thread(g, p);
+	read_unlock(&tasklist_lock);
+}
+
+#ifdef CONFIG_FIQ_DEBUGGER_CONSOLE
+static void fiq_debugger_begin_syslog_dump(struct fiq_debugger_state *state)
+{
+	state->syslog_dumping = true;
+}
+
+static void fiq_debugger_end_syslog_dump(struct fiq_debugger_state *state)
+{
+	state->syslog_dumping = false;
+}
+#else
+extern int do_syslog(int type, char __user *bug, int count);
+static void fiq_debugger_begin_syslog_dump(struct fiq_debugger_state *state)
+{
+	do_syslog(5 /* clear */, NULL, 0);
+}
+
+static void fiq_debugger_end_syslog_dump(struct fiq_debugger_state *state)
+{
+	fiq_debugger_dump_kernel_log(state);
+}
+#endif
+
+static void fiq_debugger_do_sysrq(struct fiq_debugger_state *state, char rq)
+{
+	if ((rq == 'g' || rq == 'G') && !fiq_kgdb_enable) {
+		fiq_debugger_printf(&state->output, "sysrq-g blocked\n");
+		return;
+	}
+	fiq_debugger_begin_syslog_dump(state);
+	handle_sysrq(rq);
+	fiq_debugger_end_syslog_dump(state);
+}
+
+#ifdef CONFIG_KGDB
+static void fiq_debugger_do_kgdb(struct fiq_debugger_state *state)
+{
+	if (!fiq_kgdb_enable) {
+		fiq_debugger_printf(&state->output, "kgdb through fiq debugger not enabled\n");
+		return;
+	}
+
+	fiq_debugger_printf(&state->output, "enabling console and triggering kgdb\n");
+	state->console_enable = true;
+	handle_sysrq('g');
+}
+#endif
+
+static void fiq_debugger_schedule_work(struct fiq_debugger_state *state,
+		char *cmd)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&state->work_lock, flags);
+	if (state->work_cmd[0] != '\0') {
+		fiq_debugger_printf(&state->output, "work command processor busy\n");
+		spin_unlock_irqrestore(&state->work_lock, flags);
+		return;
+	}
+
+	strlcpy(state->work_cmd, cmd, sizeof(state->work_cmd));
+	spin_unlock_irqrestore(&state->work_lock, flags);
+
+	schedule_work(&state->work);
+}
+
+static void fiq_debugger_work(struct work_struct *work)
+{
+	struct fiq_debugger_state *state;
+	char work_cmd[DEBUG_MAX];
+	char *cmd;
+	unsigned long flags;
+
+	state = container_of(work, struct fiq_debugger_state, work);
+
+	spin_lock_irqsave(&state->work_lock, flags);
+
+	strlcpy(work_cmd, state->work_cmd, sizeof(work_cmd));
+	state->work_cmd[0] = '\0';
+
+	spin_unlock_irqrestore(&state->work_lock, flags);
+
+	cmd = work_cmd;
+	if (!strncmp(cmd, "reboot", 6)) {
+		cmd += 6;
+		while (*cmd == ' ')
+			cmd++;
+		if (*cmd != '\0')
+			kernel_restart(cmd);
+		else
+			kernel_restart(NULL);
+	} else {
+		fiq_debugger_printf(&state->output, "unknown work command '%s'\n",
+				work_cmd);
+	}
+}
+
+/* This function CANNOT be called in FIQ context */
+static void fiq_debugger_irq_exec(struct fiq_debugger_state *state, char *cmd)
+{
+	if (!strcmp(cmd, "ps"))
+		fiq_debugger_do_ps(state);
+	if (!strcmp(cmd, "sysrq"))
+		fiq_debugger_do_sysrq(state, 'h');
+	if (!strncmp(cmd, "sysrq ", 6))
+		fiq_debugger_do_sysrq(state, cmd[6]);
+#ifdef CONFIG_KGDB
+	if (!strcmp(cmd, "kgdb"))
+		fiq_debugger_do_kgdb(state);
+#endif
+	if (!strncmp(cmd, "reboot", 6))
+		fiq_debugger_schedule_work(state, cmd);
+}
+
+static void fiq_debugger_help(struct fiq_debugger_state *state)
+{
+	fiq_debugger_printf(&state->output,
+				"FIQ Debugger commands:\n"
+				" pc            PC status\n"
+				" regs          Register dump\n"
+				" allregs       Extended Register dump\n"
+				" bt            Stack trace\n"
+				" reboot [<c>]  Reboot with command <c>\n"
+				" reset [<c>]   Hard reset with command <c>\n"
+				" irqs          Interupt status\n"
+				" kmsg          Kernel log\n"
+				" version       Kernel version\n");
+	fiq_debugger_printf(&state->output,
+				" sleep         Allow sleep while in FIQ\n"
+				" nosleep       Disable sleep while in FIQ\n"
+				" console       Switch terminal to console\n"
+				" cpu           Current CPU\n"
+				" cpu <number>  Switch to CPU<number>\n");
+	fiq_debugger_printf(&state->output,
+				" ps            Process list\n"
+				" sysrq         sysrq options\n"
+				" sysrq <param> Execute sysrq with <param>\n");
+#ifdef CONFIG_KGDB
+	fiq_debugger_printf(&state->output,
+				" kgdb          Enter kernel debugger\n");
+#endif
+}
+
+static void fiq_debugger_take_affinity(void *info)
+{
+	struct fiq_debugger_state *state = info;
+	struct cpumask cpumask;
+
+	cpumask_clear(&cpumask);
+	cpumask_set_cpu(get_cpu(), &cpumask);
+
+	irq_set_affinity(state->uart_irq, &cpumask);
+}
+
+static void fiq_debugger_switch_cpu(struct fiq_debugger_state *state, int cpu)
+{
+	if (!fiq_debugger_have_fiq(state))
+		smp_call_function_single(cpu, fiq_debugger_take_affinity, state,
+				false);
+	state->current_cpu = cpu;
+}
+
+static bool fiq_debugger_fiq_exec(struct fiq_debugger_state *state,
+			const char *cmd, const struct pt_regs *regs,
+			void *svc_sp)
+{
+	bool signal_helper = false;
+
+	if (!strcmp(cmd, "help") || !strcmp(cmd, "?")) {
+		fiq_debugger_help(state);
+	} else if (!strcmp(cmd, "pc")) {
+		fiq_debugger_dump_pc(&state->output, regs);
+	} else if (!strcmp(cmd, "regs")) {
+		fiq_debugger_dump_regs(&state->output, regs);
+	} else if (!strcmp(cmd, "allregs")) {
+		fiq_debugger_dump_allregs(&state->output, regs);
+	} else if (!strcmp(cmd, "bt")) {
+		fiq_debugger_dump_stacktrace(&state->output, regs, 100, svc_sp);
+	} else if (!strncmp(cmd, "reset", 5)) {
+		cmd += 5;
+		while (*cmd == ' ')
+			cmd++;
+		if (*cmd) {
+			char tmp_cmd[32];
+			strlcpy(tmp_cmd, cmd, sizeof(tmp_cmd));
+			machine_restart(tmp_cmd);
+		} else {
+			machine_restart(NULL);
+		}
+	} else if (!strcmp(cmd, "irqs")) {
+		fiq_debugger_dump_irqs(state);
+	} else if (!strcmp(cmd, "kmsg")) {
+		fiq_debugger_dump_kernel_log(state);
+	} else if (!strcmp(cmd, "version")) {
+		fiq_debugger_printf(&state->output, "%s\n", linux_banner);
+	} else if (!strcmp(cmd, "sleep")) {
+		state->no_sleep = false;
+		fiq_debugger_printf(&state->output, "enabling sleep\n");
+	} else if (!strcmp(cmd, "nosleep")) {
+		state->no_sleep = true;
+		fiq_debugger_printf(&state->output, "disabling sleep\n");
+	} else if (!strcmp(cmd, "console")) {
+		fiq_debugger_printf(&state->output, "console mode\n");
+		fiq_debugger_uart_flush(state);
+		state->console_enable = true;
+	} else if (!strcmp(cmd, "cpu")) {
+		fiq_debugger_printf(&state->output, "cpu %d\n", state->current_cpu);
+	} else if (!strncmp(cmd, "cpu ", 4)) {
+		unsigned long cpu = 0;
+		if (kstrtoul(cmd + 4, 10, &cpu) == 0)
+			fiq_debugger_switch_cpu(state, cpu);
+		else
+			fiq_debugger_printf(&state->output, "invalid cpu\n");
+		fiq_debugger_printf(&state->output, "cpu %d\n", state->current_cpu);
+	} else {
+		if (state->debug_busy) {
+			fiq_debugger_printf(&state->output,
+				"command processor busy. trying to abort.\n");
+			state->debug_abort = -1;
+		} else {
+			strcpy(state->debug_cmd, cmd);
+			state->debug_busy = 1;
+		}
+
+		return true;
+	}
+	if (!state->console_enable)
+		fiq_debugger_prompt(state);
+
+	return signal_helper;
+}
+
+static void fiq_debugger_sleep_timer_expired(unsigned long data)
+{
+	struct fiq_debugger_state *state = (struct fiq_debugger_state *)data;
+	unsigned long flags;
+
+	spin_lock_irqsave(&state->sleep_timer_lock, flags);
+	if (state->uart_enabled && !state->no_sleep) {
+		if (state->debug_enable && !state->console_enable) {
+			state->debug_enable = false;
+			fiq_debugger_printf_nfiq(state,
+					"suspending fiq debugger\n");
+		}
+		state->ignore_next_wakeup_irq = true;
+		fiq_debugger_uart_disable(state);
+		state->uart_enabled = false;
+		fiq_debugger_enable_wakeup_irq(state);
+	}
+	__pm_relax(&state->debugger_wake_src);
+	spin_unlock_irqrestore(&state->sleep_timer_lock, flags);
+}
+
+static void fiq_debugger_handle_wakeup(struct fiq_debugger_state *state)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&state->sleep_timer_lock, flags);
+	if (state->wakeup_irq >= 0 && state->ignore_next_wakeup_irq) {
+		state->ignore_next_wakeup_irq = false;
+	} else if (!state->uart_enabled) {
+		__pm_stay_awake(&state->debugger_wake_src);
+		fiq_debugger_uart_enable(state);
+		state->uart_enabled = true;
+		fiq_debugger_disable_wakeup_irq(state);
+		mod_timer(&state->sleep_timer, jiffies + HZ / 2);
+	}
+	spin_unlock_irqrestore(&state->sleep_timer_lock, flags);
+}
+
+static irqreturn_t fiq_debugger_wakeup_irq_handler(int irq, void *dev)
+{
+	struct fiq_debugger_state *state = dev;
+
+	if (!state->no_sleep)
+		fiq_debugger_puts(state, "WAKEUP\n");
+	fiq_debugger_handle_wakeup(state);
+
+	return IRQ_HANDLED;
+}
+
+static
+void fiq_debugger_handle_console_irq_context(struct fiq_debugger_state *state)
+{
+#if defined(CONFIG_FIQ_DEBUGGER_CONSOLE)
+	if (state->tty_port.ops) {
+		int i;
+		int count = fiq_debugger_ringbuf_level(state->tty_rbuf);
+		for (i = 0; i < count; i++) {
+			int c = fiq_debugger_ringbuf_peek(state->tty_rbuf, 0);
+			tty_insert_flip_char(&state->tty_port, c, TTY_NORMAL);
+			if (!fiq_debugger_ringbuf_consume(state->tty_rbuf, 1))
+				pr_warn("fiq tty failed to consume byte\n");
+		}
+		tty_flip_buffer_push(&state->tty_port);
+	}
+#endif
+}
+
+static void fiq_debugger_handle_irq_context(struct fiq_debugger_state *state)
+{
+	if (!state->no_sleep) {
+		unsigned long flags;
+
+		spin_lock_irqsave(&state->sleep_timer_lock, flags);
+		__pm_stay_awake(&state->debugger_wake_src);
+		mod_timer(&state->sleep_timer, jiffies + HZ * 5);
+		spin_unlock_irqrestore(&state->sleep_timer_lock, flags);
+	}
+	fiq_debugger_handle_console_irq_context(state);
+	if (state->debug_busy) {
+		fiq_debugger_irq_exec(state, state->debug_cmd);
+		if (!state->console_enable)
+			fiq_debugger_prompt(state);
+		state->debug_busy = 0;
+	}
+}
+
+static int fiq_debugger_getc(struct fiq_debugger_state *state)
+{
+	return state->pdata->uart_getc(state->pdev);
+}
+
+static bool fiq_debugger_handle_uart_interrupt(struct fiq_debugger_state *state,
+			int this_cpu, const struct pt_regs *regs, void *svc_sp)
+{
+	int c;
+	static int last_c;
+	int count = 0;
+	bool signal_helper = false;
+
+	if (this_cpu != state->current_cpu) {
+		if (state->in_fiq)
+			return false;
+
+		if (atomic_inc_return(&state->unhandled_fiq_count) !=
+					MAX_UNHANDLED_FIQ_COUNT)
+			return false;
+
+		fiq_debugger_printf(&state->output,
+			"fiq_debugger: cpu %d not responding, "
+			"reverting to cpu %d\n", state->current_cpu,
+			this_cpu);
+
+		atomic_set(&state->unhandled_fiq_count, 0);
+		fiq_debugger_switch_cpu(state, this_cpu);
+		return false;
+	}
+
+	state->in_fiq = true;
+
+	while ((c = fiq_debugger_getc(state)) != FIQ_DEBUGGER_NO_CHAR) {
+		count++;
+		if (!state->debug_enable) {
+			if ((c == 13) || (c == 10)) {
+				state->debug_enable = true;
+				state->debug_count = 0;
+				fiq_debugger_prompt(state);
+			}
+		} else if (c == FIQ_DEBUGGER_BREAK) {
+			state->console_enable = false;
+			fiq_debugger_puts(state, "fiq debugger mode\n");
+			state->debug_count = 0;
+			fiq_debugger_prompt(state);
+#ifdef CONFIG_FIQ_DEBUGGER_CONSOLE
+		} else if (state->console_enable && state->tty_rbuf) {
+			fiq_debugger_ringbuf_push(state->tty_rbuf, c);
+			signal_helper = true;
+#endif
+		} else if ((c >= ' ') && (c < 127)) {
+			if (state->debug_count < (DEBUG_MAX - 1)) {
+				state->debug_buf[state->debug_count++] = c;
+				fiq_debugger_putc(state, c);
+			}
+		} else if ((c == 8) || (c == 127)) {
+			if (state->debug_count > 0) {
+				state->debug_count--;
+				fiq_debugger_putc(state, 8);
+				fiq_debugger_putc(state, ' ');
+				fiq_debugger_putc(state, 8);
+			}
+		} else if ((c == 13) || (c == 10)) {
+			if (c == '\r' || (c == '\n' && last_c != '\r')) {
+				fiq_debugger_putc(state, '\r');
+				fiq_debugger_putc(state, '\n');
+			}
+			if (state->debug_count) {
+				state->debug_buf[state->debug_count] = 0;
+				state->debug_count = 0;
+				signal_helper |=
+					fiq_debugger_fiq_exec(state,
+							state->debug_buf,
+							regs, svc_sp);
+			} else {
+				fiq_debugger_prompt(state);
+			}
+		}
+		last_c = c;
+	}
+	if (!state->console_enable)
+		fiq_debugger_uart_flush(state);
+	if (state->pdata->fiq_ack)
+		state->pdata->fiq_ack(state->pdev, state->fiq);
+
+	/* poke sleep timer if necessary */
+	if (state->debug_enable && !state->no_sleep)
+		signal_helper = true;
+
+	atomic_set(&state->unhandled_fiq_count, 0);
+	state->in_fiq = false;
+
+	return signal_helper;
+}
+
+#ifdef CONFIG_FIQ_GLUE
+static void fiq_debugger_fiq(struct fiq_glue_handler *h,
+		const struct pt_regs *regs, void *svc_sp)
+{
+	struct fiq_debugger_state *state =
+		container_of(h, struct fiq_debugger_state, handler);
+	unsigned int this_cpu = THREAD_INFO(svc_sp)->cpu;
+	bool need_irq;
+
+	need_irq = fiq_debugger_handle_uart_interrupt(state, this_cpu, regs,
+			svc_sp);
+	if (need_irq)
+		fiq_debugger_force_irq(state);
+}
+#endif
+
+/*
+ * When not using FIQs, we only use this single interrupt as an entry point.
+ * This just effectively takes over the UART interrupt and does all the work
+ * in this context.
+ */
+static irqreturn_t fiq_debugger_uart_irq(int irq, void *dev)
+{
+	struct fiq_debugger_state *state = dev;
+	bool not_done;
+
+	fiq_debugger_handle_wakeup(state);
+
+	/* handle the debugger irq in regular context */
+	not_done = fiq_debugger_handle_uart_interrupt(state, smp_processor_id(),
+					      get_irq_regs(),
+					      current_thread_info());
+	if (not_done)
+		fiq_debugger_handle_irq_context(state);
+
+	return IRQ_HANDLED;
+}
+
+/*
+ * If FIQs are used, not everything can happen in fiq context.
+ * FIQ handler does what it can and then signals this interrupt to finish the
+ * job in irq context.
+ */
+static irqreturn_t fiq_debugger_signal_irq(int irq, void *dev)
+{
+	struct fiq_debugger_state *state = dev;
+
+	if (state->pdata->force_irq_ack)
+		state->pdata->force_irq_ack(state->pdev, state->signal_irq);
+
+	fiq_debugger_handle_irq_context(state);
+
+	return IRQ_HANDLED;
+}
+
+#ifdef CONFIG_FIQ_GLUE
+static void fiq_debugger_resume(struct fiq_glue_handler *h)
+{
+	struct fiq_debugger_state *state =
+		container_of(h, struct fiq_debugger_state, handler);
+	if (state->pdata->uart_resume)
+		state->pdata->uart_resume(state->pdev);
+}
+#endif
+
+#if defined(CONFIG_FIQ_DEBUGGER_CONSOLE)
+struct tty_driver *fiq_debugger_console_device(struct console *co, int *index)
+{
+	*index = co->index;
+	return fiq_tty_driver;
+}
+
+static void fiq_debugger_console_write(struct console *co,
+				const char *s, unsigned int count)
+{
+	struct fiq_debugger_state *state;
+	unsigned long flags;
+
+	state = container_of(co, struct fiq_debugger_state, console);
+
+	if (!state->console_enable && !state->syslog_dumping)
+		return;
+
+	fiq_debugger_uart_enable(state);
+	spin_lock_irqsave(&state->console_lock, flags);
+	while (count--) {
+		if (*s == '\n')
+			fiq_debugger_putc(state, '\r');
+		fiq_debugger_putc(state, *s++);
+	}
+	fiq_debugger_uart_flush(state);
+	spin_unlock_irqrestore(&state->console_lock, flags);
+	fiq_debugger_uart_disable(state);
+}
+
+static struct console fiq_debugger_console = {
+	.name = "ttyFIQ",
+	.device = fiq_debugger_console_device,
+	.write = fiq_debugger_console_write,
+	.flags = CON_PRINTBUFFER | CON_ANYTIME | CON_ENABLED,
+};
+
+int fiq_tty_open(struct tty_struct *tty, struct file *filp)
+{
+	int line = tty->index;
+	struct fiq_debugger_state **states = tty->driver->driver_state;
+	struct fiq_debugger_state *state = states[line];
+
+	return tty_port_open(&state->tty_port, tty, filp);
+}
+
+void fiq_tty_close(struct tty_struct *tty, struct file *filp)
+{
+	tty_port_close(tty->port, tty, filp);
+}
+
+int  fiq_tty_write(struct tty_struct *tty, const unsigned char *buf, int count)
+{
+	int i;
+	int line = tty->index;
+	struct fiq_debugger_state **states = tty->driver->driver_state;
+	struct fiq_debugger_state *state = states[line];
+
+	if (!state->console_enable)
+		return count;
+
+	fiq_debugger_uart_enable(state);
+	spin_lock_irq(&state->console_lock);
+	for (i = 0; i < count; i++)
+		fiq_debugger_putc(state, *buf++);
+	spin_unlock_irq(&state->console_lock);
+	fiq_debugger_uart_disable(state);
+
+	return count;
+}
+
+int  fiq_tty_write_room(struct tty_struct *tty)
+{
+	return 16;
+}
+
+#ifdef CONFIG_CONSOLE_POLL
+static int fiq_tty_poll_init(struct tty_driver *driver, int line, char *options)
+{
+	return 0;
+}
+
+static int fiq_tty_poll_get_char(struct tty_driver *driver, int line)
+{
+	struct fiq_debugger_state **states = driver->driver_state;
+	struct fiq_debugger_state *state = states[line];
+	int c = NO_POLL_CHAR;
+
+	fiq_debugger_uart_enable(state);
+	if (fiq_debugger_have_fiq(state)) {
+		int count = fiq_debugger_ringbuf_level(state->tty_rbuf);
+		if (count > 0) {
+			c = fiq_debugger_ringbuf_peek(state->tty_rbuf, 0);
+			fiq_debugger_ringbuf_consume(state->tty_rbuf, 1);
+		}
+	} else {
+		c = fiq_debugger_getc(state);
+		if (c == FIQ_DEBUGGER_NO_CHAR)
+			c = NO_POLL_CHAR;
+	}
+	fiq_debugger_uart_disable(state);
+
+	return c;
+}
+
+static void fiq_tty_poll_put_char(struct tty_driver *driver, int line, char ch)
+{
+	struct fiq_debugger_state **states = driver->driver_state;
+	struct fiq_debugger_state *state = states[line];
+	fiq_debugger_uart_enable(state);
+	fiq_debugger_putc(state, ch);
+	fiq_debugger_uart_disable(state);
+}
+#endif
+
+static const struct tty_port_operations fiq_tty_port_ops;
+
+static const struct tty_operations fiq_tty_driver_ops = {
+	.write = fiq_tty_write,
+	.write_room = fiq_tty_write_room,
+	.open = fiq_tty_open,
+	.close = fiq_tty_close,
+#ifdef CONFIG_CONSOLE_POLL
+	.poll_init = fiq_tty_poll_init,
+	.poll_get_char = fiq_tty_poll_get_char,
+	.poll_put_char = fiq_tty_poll_put_char,
+#endif
+};
+
+static int fiq_debugger_tty_init(void)
+{
+	int ret;
+	struct fiq_debugger_state **states = NULL;
+
+	states = kzalloc(sizeof(*states) * MAX_FIQ_DEBUGGER_PORTS, GFP_KERNEL);
+	if (!states) {
+		pr_err("Failed to allocate fiq debugger state structres\n");
+		return -ENOMEM;
+	}
+
+	fiq_tty_driver = alloc_tty_driver(MAX_FIQ_DEBUGGER_PORTS);
+	if (!fiq_tty_driver) {
+		pr_err("Failed to allocate fiq debugger tty\n");
+		ret = -ENOMEM;
+		goto err_free_state;
+	}
+
+	fiq_tty_driver->owner		= THIS_MODULE;
+	fiq_tty_driver->driver_name	= "fiq-debugger";
+	fiq_tty_driver->name		= "ttyFIQ";
+	fiq_tty_driver->type		= TTY_DRIVER_TYPE_SERIAL;
+	fiq_tty_driver->subtype		= SERIAL_TYPE_NORMAL;
+	fiq_tty_driver->init_termios	= tty_std_termios;
+	fiq_tty_driver->flags		= TTY_DRIVER_REAL_RAW |
+					  TTY_DRIVER_DYNAMIC_DEV;
+	fiq_tty_driver->driver_state	= states;
+
+	fiq_tty_driver->init_termios.c_cflag =
+					B115200 | CS8 | CREAD | HUPCL | CLOCAL;
+	fiq_tty_driver->init_termios.c_ispeed = 115200;
+	fiq_tty_driver->init_termios.c_ospeed = 115200;
+
+	tty_set_operations(fiq_tty_driver, &fiq_tty_driver_ops);
+
+	ret = tty_register_driver(fiq_tty_driver);
+	if (ret) {
+		pr_err("Failed to register fiq tty: %d\n", ret);
+		goto err_free_tty;
+	}
+
+	pr_info("Registered FIQ tty driver\n");
+	return 0;
+
+err_free_tty:
+	put_tty_driver(fiq_tty_driver);
+	fiq_tty_driver = NULL;
+err_free_state:
+	kfree(states);
+	return ret;
+}
+
+static int fiq_debugger_tty_init_one(struct fiq_debugger_state *state)
+{
+	int ret;
+	struct device *tty_dev;
+	struct fiq_debugger_state **states = fiq_tty_driver->driver_state;
+
+	states[state->pdev->id] = state;
+
+	state->tty_rbuf = fiq_debugger_ringbuf_alloc(1024);
+	if (!state->tty_rbuf) {
+		pr_err("Failed to allocate fiq debugger ringbuf\n");
+		ret = -ENOMEM;
+		goto err;
+	}
+
+	tty_port_init(&state->tty_port);
+	state->tty_port.ops = &fiq_tty_port_ops;
+
+	tty_dev = tty_port_register_device(&state->tty_port, fiq_tty_driver,
+					   state->pdev->id, &state->pdev->dev);
+	if (IS_ERR(tty_dev)) {
+		pr_err("Failed to register fiq debugger tty device\n");
+		ret = PTR_ERR(tty_dev);
+		goto err;
+	}
+
+	device_set_wakeup_capable(tty_dev, 1);
+
+	pr_info("Registered fiq debugger ttyFIQ%d\n", state->pdev->id);
+
+	return 0;
+
+err:
+	fiq_debugger_ringbuf_free(state->tty_rbuf);
+	state->tty_rbuf = NULL;
+	return ret;
+}
+#endif
+
+static int fiq_debugger_dev_suspend(struct device *dev)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct fiq_debugger_state *state = platform_get_drvdata(pdev);
+
+	if (state->pdata->uart_dev_suspend)
+		return state->pdata->uart_dev_suspend(pdev);
+	return 0;
+}
+
+static int fiq_debugger_dev_resume(struct device *dev)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct fiq_debugger_state *state = platform_get_drvdata(pdev);
+
+	if (state->pdata->uart_dev_resume)
+		return state->pdata->uart_dev_resume(pdev);
+	return 0;
+}
+
+static int fiq_debugger_probe(struct platform_device *pdev)
+{
+	int ret;
+	struct fiq_debugger_pdata *pdata = dev_get_platdata(&pdev->dev);
+	struct fiq_debugger_state *state;
+	int fiq;
+	int uart_irq;
+
+	if (pdev->id >= MAX_FIQ_DEBUGGER_PORTS)
+		return -EINVAL;
+
+	if (!pdata->uart_getc || !pdata->uart_putc)
+		return -EINVAL;
+	if ((pdata->uart_enable && !pdata->uart_disable) ||
+	    (!pdata->uart_enable && pdata->uart_disable))
+		return -EINVAL;
+
+	fiq = platform_get_irq_byname(pdev, "fiq");
+	uart_irq = platform_get_irq_byname(pdev, "uart_irq");
+
+	/* uart_irq mode and fiq mode are mutually exclusive, but one of them
+	 * is required */
+	if ((uart_irq < 0 && fiq < 0) || (uart_irq >= 0 && fiq >= 0))
+		return -EINVAL;
+	if (fiq >= 0 && !pdata->fiq_enable)
+		return -EINVAL;
+
+	state = kzalloc(sizeof(*state), GFP_KERNEL);
+	state->output.printf = fiq_debugger_printf;
+	setup_timer(&state->sleep_timer, fiq_debugger_sleep_timer_expired,
+		    (unsigned long)state);
+	state->pdata = pdata;
+	state->pdev = pdev;
+	state->no_sleep = initial_no_sleep;
+	state->debug_enable = initial_debug_enable;
+	state->console_enable = initial_console_enable;
+
+	state->fiq = fiq;
+	state->uart_irq = uart_irq;
+	state->signal_irq = platform_get_irq_byname(pdev, "signal");
+	state->wakeup_irq = platform_get_irq_byname(pdev, "wakeup");
+
+	INIT_WORK(&state->work, fiq_debugger_work);
+	spin_lock_init(&state->work_lock);
+
+	platform_set_drvdata(pdev, state);
+
+	spin_lock_init(&state->sleep_timer_lock);
+
+	if (state->wakeup_irq < 0 && fiq_debugger_have_fiq(state))
+		state->no_sleep = true;
+	state->ignore_next_wakeup_irq = !state->no_sleep;
+
+	wakeup_source_init(&state->debugger_wake_src, "serial-debug");
+
+	state->clk = clk_get(&pdev->dev, NULL);
+	if (IS_ERR(state->clk))
+		state->clk = NULL;
+
+	/* do not call pdata->uart_enable here since uart_init may still
+	 * need to do some initialization before uart_enable can work.
+	 * So, only try to manage the clock during init.
+	 */
+	if (state->clk)
+		clk_enable(state->clk);
+
+	if (pdata->uart_init) {
+		ret = pdata->uart_init(pdev);
+		if (ret)
+			goto err_uart_init;
+	}
+
+	fiq_debugger_printf_nfiq(state,
+				"<hit enter %sto activate fiq debugger>\n",
+				state->no_sleep ? "" : "twice ");
+
+#ifdef CONFIG_FIQ_GLUE
+	if (fiq_debugger_have_fiq(state)) {
+		state->handler.fiq = fiq_debugger_fiq;
+		state->handler.resume = fiq_debugger_resume;
+		ret = fiq_glue_register_handler(&state->handler);
+		if (ret) {
+			pr_err("%s: could not install fiq handler\n", __func__);
+			goto err_register_irq;
+		}
+
+		pdata->fiq_enable(pdev, state->fiq, 1);
+	} else
+#endif
+	{
+		ret = request_irq(state->uart_irq, fiq_debugger_uart_irq,
+				  IRQF_NO_SUSPEND, "debug", state);
+		if (ret) {
+			pr_err("%s: could not install irq handler\n", __func__);
+			goto err_register_irq;
+		}
+
+		/* for irq-only mode, we want this irq to wake us up, if it
+		 * can.
+		 */
+		enable_irq_wake(state->uart_irq);
+	}
+
+	if (state->clk)
+		clk_disable(state->clk);
+
+	if (state->signal_irq >= 0) {
+		ret = request_irq(state->signal_irq, fiq_debugger_signal_irq,
+			  IRQF_TRIGGER_RISING, "debug-signal", state);
+		if (ret)
+			pr_err("serial_debugger: could not install signal_irq");
+	}
+
+	if (state->wakeup_irq >= 0) {
+		ret = request_irq(state->wakeup_irq,
+				  fiq_debugger_wakeup_irq_handler,
+				  IRQF_TRIGGER_FALLING,
+				  "debug-wakeup", state);
+		if (ret) {
+			pr_err("serial_debugger: "
+				"could not install wakeup irq\n");
+			state->wakeup_irq = -1;
+		} else {
+			ret = enable_irq_wake(state->wakeup_irq);
+			if (ret) {
+				pr_err("serial_debugger: "
+					"could not enable wakeup\n");
+				state->wakeup_irq_no_set_wake = true;
+			}
+		}
+	}
+	if (state->no_sleep)
+		fiq_debugger_handle_wakeup(state);
+
+#if defined(CONFIG_FIQ_DEBUGGER_CONSOLE)
+	spin_lock_init(&state->console_lock);
+	state->console = fiq_debugger_console;
+	state->console.index = pdev->id;
+	if (!console_set_on_cmdline)
+		add_preferred_console(state->console.name,
+			state->console.index, NULL);
+	register_console(&state->console);
+	fiq_debugger_tty_init_one(state);
+#endif
+	return 0;
+
+err_register_irq:
+	if (pdata->uart_free)
+		pdata->uart_free(pdev);
+err_uart_init:
+	if (state->clk)
+		clk_disable(state->clk);
+	if (state->clk)
+		clk_put(state->clk);
+	wakeup_source_trash(&state->debugger_wake_src);
+	platform_set_drvdata(pdev, NULL);
+	kfree(state);
+	return ret;
+}
+
+static const struct dev_pm_ops fiq_debugger_dev_pm_ops = {
+	.suspend	= fiq_debugger_dev_suspend,
+	.resume		= fiq_debugger_dev_resume,
+};
+
+static struct platform_driver fiq_debugger_driver = {
+	.probe	= fiq_debugger_probe,
+	.driver	= {
+		.name	= "fiq_debugger",
+		.pm	= &fiq_debugger_dev_pm_ops,
+	},
+};
+
+#if defined(CONFIG_FIQ_DEBUGGER_UART_OVERLAY)
+int fiq_debugger_uart_overlay(void)
+{
+	struct device_node *onp = of_find_node_by_path("/uart_overlay@0");
+	int ret;
+
+	if (!onp) {
+		pr_err("serial_debugger: uart overlay not found\n");
+		return -ENODEV;
+	}
+
+	ret = of_overlay_create(onp);
+	if (ret < 0) {
+		pr_err("serial_debugger: fail to create overlay: %d\n", ret);
+		of_node_put(onp);
+		return ret;
+	}
+
+	pr_info("serial_debugger: uart overlay applied\n");
+	return 0;
+}
+#endif
+
+static int __init fiq_debugger_init(void)
+{
+	if (fiq_debugger_disable) {
+		pr_err("serial_debugger: disabled\n");
+		return -ENODEV;
+	}
+#if defined(CONFIG_FIQ_DEBUGGER_CONSOLE)
+	fiq_debugger_tty_init();
+#endif
+#if defined(CONFIG_FIQ_DEBUGGER_UART_OVERLAY)
+	fiq_debugger_uart_overlay();
+#endif
+	return platform_driver_register(&fiq_debugger_driver);
+}
+
+postcore_initcall(fiq_debugger_init);
diff --git a/drivers/staging/android/fiq_debugger/fiq_debugger.h b/drivers/staging/android/fiq_debugger/fiq_debugger.h
new file mode 100644
index 00000000..c9ec4f8
--- /dev/null
+++ b/drivers/staging/android/fiq_debugger/fiq_debugger.h
@@ -0,0 +1,64 @@
+/*
+ * drivers/staging/android/fiq_debugger/fiq_debugger.h
+ *
+ * Copyright (C) 2010 Google, Inc.
+ * Author: Colin Cross <ccross@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _ARCH_ARM_MACH_TEGRA_FIQ_DEBUGGER_H_
+#define _ARCH_ARM_MACH_TEGRA_FIQ_DEBUGGER_H_
+
+#include <linux/serial_core.h>
+
+#define FIQ_DEBUGGER_NO_CHAR NO_POLL_CHAR
+#define FIQ_DEBUGGER_BREAK 0x00ff0100
+
+#define FIQ_DEBUGGER_FIQ_IRQ_NAME	"fiq"
+#define FIQ_DEBUGGER_SIGNAL_IRQ_NAME	"signal"
+#define FIQ_DEBUGGER_WAKEUP_IRQ_NAME	"wakeup"
+
+/**
+ * struct fiq_debugger_pdata - fiq debugger platform data
+ * @uart_resume:	used to restore uart state right before enabling
+ *			the fiq.
+ * @uart_enable:	Do the work necessary to communicate with the uart
+ *			hw (enable clocks, etc.). This must be ref-counted.
+ * @uart_disable:	Do the work necessary to disable the uart hw
+ *			(disable clocks, etc.). This must be ref-counted.
+ * @uart_dev_suspend:	called during PM suspend, generally not needed
+ *			for real fiq mode debugger.
+ * @uart_dev_resume:	called during PM resume, generally not needed
+ *			for real fiq mode debugger.
+ */
+struct fiq_debugger_pdata {
+	int (*uart_init)(struct platform_device *pdev);
+	void (*uart_free)(struct platform_device *pdev);
+	int (*uart_resume)(struct platform_device *pdev);
+	int (*uart_getc)(struct platform_device *pdev);
+	void (*uart_putc)(struct platform_device *pdev, unsigned int c);
+	void (*uart_flush)(struct platform_device *pdev);
+	void (*uart_enable)(struct platform_device *pdev);
+	void (*uart_disable)(struct platform_device *pdev);
+
+	int (*uart_dev_suspend)(struct platform_device *pdev);
+	int (*uart_dev_resume)(struct platform_device *pdev);
+
+	void (*fiq_enable)(struct platform_device *pdev, unsigned int fiq,
+								bool enable);
+	void (*fiq_ack)(struct platform_device *pdev, unsigned int fiq);
+
+	void (*force_irq)(struct platform_device *pdev, unsigned int irq);
+	void (*force_irq_ack)(struct platform_device *pdev, unsigned int irq);
+};
+
+#endif
diff --git a/drivers/staging/android/fiq_debugger/fiq_debugger_arm.c b/drivers/staging/android/fiq_debugger/fiq_debugger_arm.c
new file mode 100644
index 00000000..8b3e013
--- /dev/null
+++ b/drivers/staging/android/fiq_debugger/fiq_debugger_arm.c
@@ -0,0 +1,240 @@
+/*
+ * Copyright (C) 2014 Google, Inc.
+ * Author: Colin Cross <ccross@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/ptrace.h>
+#include <linux/uaccess.h>
+
+#include <asm/stacktrace.h>
+
+#include "fiq_debugger_priv.h"
+
+static char *mode_name(unsigned cpsr)
+{
+	switch (cpsr & MODE_MASK) {
+	case USR_MODE: return "USR";
+	case FIQ_MODE: return "FIQ";
+	case IRQ_MODE: return "IRQ";
+	case SVC_MODE: return "SVC";
+	case ABT_MODE: return "ABT";
+	case UND_MODE: return "UND";
+	case SYSTEM_MODE: return "SYS";
+	default: return "???";
+	}
+}
+
+void fiq_debugger_dump_pc(struct fiq_debugger_output *output,
+		const struct pt_regs *regs)
+{
+	output->printf(output, " pc %08x cpsr %08x mode %s\n",
+		regs->ARM_pc, regs->ARM_cpsr, mode_name(regs->ARM_cpsr));
+}
+
+void fiq_debugger_dump_regs(struct fiq_debugger_output *output,
+		const struct pt_regs *regs)
+{
+	output->printf(output,
+			" r0 %08x  r1 %08x  r2 %08x  r3 %08x\n",
+			regs->ARM_r0, regs->ARM_r1, regs->ARM_r2, regs->ARM_r3);
+	output->printf(output,
+			" r4 %08x  r5 %08x  r6 %08x  r7 %08x\n",
+			regs->ARM_r4, regs->ARM_r5, regs->ARM_r6, regs->ARM_r7);
+	output->printf(output,
+			" r8 %08x  r9 %08x r10 %08x r11 %08x  mode %s\n",
+			regs->ARM_r8, regs->ARM_r9, regs->ARM_r10, regs->ARM_fp,
+			mode_name(regs->ARM_cpsr));
+	output->printf(output,
+			" ip %08x  sp %08x  lr %08x  pc %08x cpsr %08x\n",
+			regs->ARM_ip, regs->ARM_sp, regs->ARM_lr, regs->ARM_pc,
+			regs->ARM_cpsr);
+}
+
+struct mode_regs {
+	unsigned long sp_svc;
+	unsigned long lr_svc;
+	unsigned long spsr_svc;
+
+	unsigned long sp_abt;
+	unsigned long lr_abt;
+	unsigned long spsr_abt;
+
+	unsigned long sp_und;
+	unsigned long lr_und;
+	unsigned long spsr_und;
+
+	unsigned long sp_irq;
+	unsigned long lr_irq;
+	unsigned long spsr_irq;
+
+	unsigned long r8_fiq;
+	unsigned long r9_fiq;
+	unsigned long r10_fiq;
+	unsigned long r11_fiq;
+	unsigned long r12_fiq;
+	unsigned long sp_fiq;
+	unsigned long lr_fiq;
+	unsigned long spsr_fiq;
+};
+
+static void __naked get_mode_regs(struct mode_regs *regs)
+{
+	asm volatile (
+	"mrs	r1, cpsr\n"
+	"msr	cpsr_c, #0xd3 @(SVC_MODE | PSR_I_BIT | PSR_F_BIT)\n"
+	"stmia	r0!, {r13 - r14}\n"
+	"mrs	r2, spsr\n"
+	"msr	cpsr_c, #0xd7 @(ABT_MODE | PSR_I_BIT | PSR_F_BIT)\n"
+	"stmia	r0!, {r2, r13 - r14}\n"
+	"mrs	r2, spsr\n"
+	"msr	cpsr_c, #0xdb @(UND_MODE | PSR_I_BIT | PSR_F_BIT)\n"
+	"stmia	r0!, {r2, r13 - r14}\n"
+	"mrs	r2, spsr\n"
+	"msr	cpsr_c, #0xd2 @(IRQ_MODE | PSR_I_BIT | PSR_F_BIT)\n"
+	"stmia	r0!, {r2, r13 - r14}\n"
+	"mrs	r2, spsr\n"
+	"msr	cpsr_c, #0xd1 @(FIQ_MODE | PSR_I_BIT | PSR_F_BIT)\n"
+	"stmia	r0!, {r2, r8 - r14}\n"
+	"mrs	r2, spsr\n"
+	"stmia	r0!, {r2}\n"
+	"msr	cpsr_c, r1\n"
+	"bx	lr\n");
+}
+
+
+void fiq_debugger_dump_allregs(struct fiq_debugger_output *output,
+		const struct pt_regs *regs)
+{
+	struct mode_regs mode_regs;
+	unsigned long mode = regs->ARM_cpsr & MODE_MASK;
+
+	fiq_debugger_dump_regs(output, regs);
+	get_mode_regs(&mode_regs);
+
+	output->printf(output,
+			"%csvc: sp %08x  lr %08x  spsr %08x\n",
+			mode == SVC_MODE ? '*' : ' ',
+			mode_regs.sp_svc, mode_regs.lr_svc, mode_regs.spsr_svc);
+	output->printf(output,
+			"%cabt: sp %08x  lr %08x  spsr %08x\n",
+			mode == ABT_MODE ? '*' : ' ',
+			mode_regs.sp_abt, mode_regs.lr_abt, mode_regs.spsr_abt);
+	output->printf(output,
+			"%cund: sp %08x  lr %08x  spsr %08x\n",
+			mode == UND_MODE ? '*' : ' ',
+			mode_regs.sp_und, mode_regs.lr_und, mode_regs.spsr_und);
+	output->printf(output,
+			"%cirq: sp %08x  lr %08x  spsr %08x\n",
+			mode == IRQ_MODE ? '*' : ' ',
+			mode_regs.sp_irq, mode_regs.lr_irq, mode_regs.spsr_irq);
+	output->printf(output,
+			"%cfiq: r8 %08x  r9 %08x  r10 %08x  r11 %08x  r12 %08x\n",
+			mode == FIQ_MODE ? '*' : ' ',
+			mode_regs.r8_fiq, mode_regs.r9_fiq, mode_regs.r10_fiq,
+			mode_regs.r11_fiq, mode_regs.r12_fiq);
+	output->printf(output,
+			" fiq: sp %08x  lr %08x  spsr %08x\n",
+			mode_regs.sp_fiq, mode_regs.lr_fiq, mode_regs.spsr_fiq);
+}
+
+struct stacktrace_state {
+	struct fiq_debugger_output *output;
+	unsigned int depth;
+};
+
+static int report_trace(struct stackframe *frame, void *d)
+{
+	struct stacktrace_state *sts = d;
+
+	if (sts->depth) {
+		sts->output->printf(sts->output,
+			"  pc: %p (%pF), lr %p (%pF), sp %p, fp %p\n",
+			frame->pc, frame->pc, frame->lr, frame->lr,
+			frame->sp, frame->fp);
+		sts->depth--;
+		return 0;
+	}
+	sts->output->printf(sts->output, "  ...\n");
+
+	return sts->depth == 0;
+}
+
+struct frame_tail {
+	struct frame_tail *fp;
+	unsigned long sp;
+	unsigned long lr;
+} __attribute__((packed));
+
+static struct frame_tail *user_backtrace(struct fiq_debugger_output *output,
+					struct frame_tail *tail)
+{
+	struct frame_tail buftail[2];
+
+	/* Also check accessibility of one struct frame_tail beyond */
+	if (!access_ok(VERIFY_READ, tail, sizeof(buftail))) {
+		output->printf(output, "  invalid frame pointer %p\n",
+				tail);
+		return NULL;
+	}
+	if (__copy_from_user_inatomic(buftail, tail, sizeof(buftail))) {
+		output->printf(output,
+			"  failed to copy frame pointer %p\n", tail);
+		return NULL;
+	}
+
+	output->printf(output, "  %p\n", buftail[0].lr);
+
+	/* frame pointers should strictly progress back up the stack
+	 * (towards higher addresses) */
+	if (tail >= buftail[0].fp)
+		return NULL;
+
+	return buftail[0].fp-1;
+}
+
+void fiq_debugger_dump_stacktrace(struct fiq_debugger_output *output,
+		const struct pt_regs *regs, unsigned int depth, void *ssp)
+{
+	struct frame_tail *tail;
+	struct thread_info *real_thread_info = THREAD_INFO(ssp);
+	struct stacktrace_state sts;
+
+	sts.depth = depth;
+	sts.output = output;
+	*current_thread_info() = *real_thread_info;
+
+	if (!current)
+		output->printf(output, "current NULL\n");
+	else
+		output->printf(output, "pid: %d  comm: %s\n",
+			current->pid, current->comm);
+	fiq_debugger_dump_regs(output, regs);
+
+	if (!user_mode(regs)) {
+		struct stackframe frame;
+		frame.fp = regs->ARM_fp;
+		frame.sp = regs->ARM_sp;
+		frame.lr = regs->ARM_lr;
+		frame.pc = regs->ARM_pc;
+		output->printf(output,
+			"  pc: %p (%pF), lr %p (%pF), sp %p, fp %p\n",
+			regs->ARM_pc, regs->ARM_pc, regs->ARM_lr, regs->ARM_lr,
+			regs->ARM_sp, regs->ARM_fp);
+		walk_stackframe(&frame, report_trace, &sts);
+		return;
+	}
+
+	tail = ((struct frame_tail *) regs->ARM_fp) - 1;
+	while (depth-- && tail && !((unsigned long) tail & 3))
+		tail = user_backtrace(output, tail);
+}
diff --git a/drivers/staging/android/fiq_debugger/fiq_debugger_arm64.c b/drivers/staging/android/fiq_debugger/fiq_debugger_arm64.c
new file mode 100644
index 00000000..97246bc
--- /dev/null
+++ b/drivers/staging/android/fiq_debugger/fiq_debugger_arm64.c
@@ -0,0 +1,202 @@
+/*
+ * Copyright (C) 2014 Google, Inc.
+ * Author: Colin Cross <ccross@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/ptrace.h>
+#include <asm/stacktrace.h>
+
+#include "fiq_debugger_priv.h"
+
+static char *mode_name(const struct pt_regs *regs)
+{
+	if (compat_user_mode(regs)) {
+		return "USR";
+	} else {
+		switch (processor_mode(regs)) {
+		case PSR_MODE_EL0t: return "EL0t";
+		case PSR_MODE_EL1t: return "EL1t";
+		case PSR_MODE_EL1h: return "EL1h";
+		case PSR_MODE_EL2t: return "EL2t";
+		case PSR_MODE_EL2h: return "EL2h";
+		default: return "???";
+		}
+	}
+}
+
+void fiq_debugger_dump_pc(struct fiq_debugger_output *output,
+		const struct pt_regs *regs)
+{
+	output->printf(output, " pc %016lx cpsr %08lx mode %s\n",
+		regs->pc, regs->pstate, mode_name(regs));
+}
+
+void fiq_debugger_dump_regs_aarch32(struct fiq_debugger_output *output,
+		const struct pt_regs *regs)
+{
+	output->printf(output, " r0 %08x  r1 %08x  r2 %08x  r3 %08x\n",
+			regs->compat_usr(0), regs->compat_usr(1),
+			regs->compat_usr(2), regs->compat_usr(3));
+	output->printf(output, " r4 %08x  r5 %08x  r6 %08x  r7 %08x\n",
+			regs->compat_usr(4), regs->compat_usr(5),
+			regs->compat_usr(6), regs->compat_usr(7));
+	output->printf(output, " r8 %08x  r9 %08x r10 %08x r11 %08x\n",
+			regs->compat_usr(8), regs->compat_usr(9),
+			regs->compat_usr(10), regs->compat_usr(11));
+	output->printf(output, " ip %08x  sp %08x  lr %08x  pc %08x\n",
+			regs->compat_usr(12), regs->compat_sp,
+			regs->compat_lr, regs->pc);
+	output->printf(output, " cpsr %08x (%s)\n",
+			regs->pstate, mode_name(regs));
+}
+
+void fiq_debugger_dump_regs_aarch64(struct fiq_debugger_output *output,
+		const struct pt_regs *regs)
+{
+
+	output->printf(output, "  x0 %016lx   x1 %016lx\n",
+			regs->regs[0], regs->regs[1]);
+	output->printf(output, "  x2 %016lx   x3 %016lx\n",
+			regs->regs[2], regs->regs[3]);
+	output->printf(output, "  x4 %016lx   x5 %016lx\n",
+			regs->regs[4], regs->regs[5]);
+	output->printf(output, "  x6 %016lx   x7 %016lx\n",
+			regs->regs[6], regs->regs[7]);
+	output->printf(output, "  x8 %016lx   x9 %016lx\n",
+			regs->regs[8], regs->regs[9]);
+	output->printf(output, " x10 %016lx  x11 %016lx\n",
+			regs->regs[10], regs->regs[11]);
+	output->printf(output, " x12 %016lx  x13 %016lx\n",
+			regs->regs[12], regs->regs[13]);
+	output->printf(output, " x14 %016lx  x15 %016lx\n",
+			regs->regs[14], regs->regs[15]);
+	output->printf(output, " x16 %016lx  x17 %016lx\n",
+			regs->regs[16], regs->regs[17]);
+	output->printf(output, " x18 %016lx  x19 %016lx\n",
+			regs->regs[18], regs->regs[19]);
+	output->printf(output, " x20 %016lx  x21 %016lx\n",
+			regs->regs[20], regs->regs[21]);
+	output->printf(output, " x22 %016lx  x23 %016lx\n",
+			regs->regs[22], regs->regs[23]);
+	output->printf(output, " x24 %016lx  x25 %016lx\n",
+			regs->regs[24], regs->regs[25]);
+	output->printf(output, " x26 %016lx  x27 %016lx\n",
+			regs->regs[26], regs->regs[27]);
+	output->printf(output, " x28 %016lx  x29 %016lx\n",
+			regs->regs[28], regs->regs[29]);
+	output->printf(output, " x30 %016lx   sp %016lx\n",
+			regs->regs[30], regs->sp);
+	output->printf(output, "  pc %016lx cpsr %08x (%s)\n",
+			regs->pc, regs->pstate, mode_name(regs));
+}
+
+void fiq_debugger_dump_regs(struct fiq_debugger_output *output,
+		const struct pt_regs *regs)
+{
+	if (compat_user_mode(regs))
+		fiq_debugger_dump_regs_aarch32(output, regs);
+	else
+		fiq_debugger_dump_regs_aarch64(output, regs);
+}
+
+#define READ_SPECIAL_REG(x) ({ \
+	u64 val; \
+	asm volatile ("mrs %0, " # x : "=r"(val)); \
+	val; \
+})
+
+void fiq_debugger_dump_allregs(struct fiq_debugger_output *output,
+		const struct pt_regs *regs)
+{
+	u32 pstate = READ_SPECIAL_REG(CurrentEl);
+	bool in_el2 = (pstate & PSR_MODE_MASK) >= PSR_MODE_EL2t;
+
+	fiq_debugger_dump_regs(output, regs);
+
+	output->printf(output, " sp_el0   %016lx\n",
+			READ_SPECIAL_REG(sp_el0));
+
+	if (in_el2)
+		output->printf(output, " sp_el1   %016lx\n",
+				READ_SPECIAL_REG(sp_el1));
+
+	output->printf(output, " elr_el1  %016lx\n",
+			READ_SPECIAL_REG(elr_el1));
+
+	output->printf(output, " spsr_el1 %08lx\n",
+			READ_SPECIAL_REG(spsr_el1));
+
+	if (in_el2) {
+		output->printf(output, " spsr_irq %08lx\n",
+				READ_SPECIAL_REG(spsr_irq));
+		output->printf(output, " spsr_abt %08lx\n",
+				READ_SPECIAL_REG(spsr_abt));
+		output->printf(output, " spsr_und %08lx\n",
+				READ_SPECIAL_REG(spsr_und));
+		output->printf(output, " spsr_fiq %08lx\n",
+				READ_SPECIAL_REG(spsr_fiq));
+		output->printf(output, " spsr_el2 %08lx\n",
+				READ_SPECIAL_REG(elr_el2));
+		output->printf(output, " spsr_el2 %08lx\n",
+				READ_SPECIAL_REG(spsr_el2));
+	}
+}
+
+struct stacktrace_state {
+	struct fiq_debugger_output *output;
+	unsigned int depth;
+};
+
+static int report_trace(struct stackframe *frame, void *d)
+{
+	struct stacktrace_state *sts = d;
+
+	if (sts->depth) {
+		sts->output->printf(sts->output, "%pF:\n", frame->pc);
+		sts->output->printf(sts->output,
+				"  pc %016lx   sp %016lx   fp %016lx\n",
+				frame->pc, frame->sp, frame->fp);
+		sts->depth--;
+		return 0;
+	}
+	sts->output->printf(sts->output, "  ...\n");
+
+	return sts->depth == 0;
+}
+
+void fiq_debugger_dump_stacktrace(struct fiq_debugger_output *output,
+		const struct pt_regs *regs, unsigned int depth, void *ssp)
+{
+	struct thread_info *real_thread_info = THREAD_INFO(ssp);
+	struct stacktrace_state sts;
+
+	sts.depth = depth;
+	sts.output = output;
+	*current_thread_info() = *real_thread_info;
+
+	if (!current)
+		output->printf(output, "current NULL\n");
+	else
+		output->printf(output, "pid: %d  comm: %s\n",
+			current->pid, current->comm);
+	fiq_debugger_dump_regs(output, regs);
+
+	if (!user_mode(regs)) {
+		struct stackframe frame;
+		frame.fp = regs->regs[29];
+		frame.sp = regs->sp;
+		frame.pc = regs->pc;
+		output->printf(output, "\n");
+		walk_stackframe(current, &frame, report_trace, &sts);
+	}
+}
diff --git a/drivers/staging/android/fiq_debugger/fiq_debugger_priv.h b/drivers/staging/android/fiq_debugger/fiq_debugger_priv.h
new file mode 100644
index 00000000..d5d051f
--- /dev/null
+++ b/drivers/staging/android/fiq_debugger/fiq_debugger_priv.h
@@ -0,0 +1,37 @@
+/*
+ * Copyright (C) 2014 Google, Inc.
+ * Author: Colin Cross <ccross@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _FIQ_DEBUGGER_PRIV_H_
+#define _FIQ_DEBUGGER_PRIV_H_
+
+#define THREAD_INFO(sp) ((struct thread_info *) \
+		((unsigned long)(sp) & ~(THREAD_SIZE - 1)))
+
+struct fiq_debugger_output {
+	void (*printf)(struct fiq_debugger_output *output, const char *fmt, ...);
+};
+
+struct pt_regs;
+
+void fiq_debugger_dump_pc(struct fiq_debugger_output *output,
+		const struct pt_regs *regs);
+void fiq_debugger_dump_regs(struct fiq_debugger_output *output,
+		const struct pt_regs *regs);
+void fiq_debugger_dump_allregs(struct fiq_debugger_output *output,
+		const struct pt_regs *regs);
+void fiq_debugger_dump_stacktrace(struct fiq_debugger_output *output,
+		const struct pt_regs *regs, unsigned int depth, void *ssp);
+
+#endif
diff --git a/drivers/staging/android/fiq_debugger/fiq_debugger_ringbuf.h b/drivers/staging/android/fiq_debugger/fiq_debugger_ringbuf.h
new file mode 100644
index 00000000..10c3c5d
--- /dev/null
+++ b/drivers/staging/android/fiq_debugger/fiq_debugger_ringbuf.h
@@ -0,0 +1,94 @@
+/*
+ * drivers/staging/android/fiq_debugger/fiq_debugger_ringbuf.h
+ *
+ * simple lockless ringbuffer
+ *
+ * Copyright (C) 2010 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include <linux/kernel.h>
+#include <linux/slab.h>
+
+struct fiq_debugger_ringbuf {
+	int len;
+	int head;
+	int tail;
+	u8 buf[];
+};
+
+
+static inline struct fiq_debugger_ringbuf *fiq_debugger_ringbuf_alloc(int len)
+{
+	struct fiq_debugger_ringbuf *rbuf;
+
+	rbuf = kzalloc(sizeof(*rbuf) + len, GFP_KERNEL);
+	if (rbuf == NULL)
+		return NULL;
+
+	rbuf->len = len;
+	rbuf->head = 0;
+	rbuf->tail = 0;
+	smp_mb();
+
+	return rbuf;
+}
+
+static inline void fiq_debugger_ringbuf_free(struct fiq_debugger_ringbuf *rbuf)
+{
+	kfree(rbuf);
+}
+
+static inline int fiq_debugger_ringbuf_level(struct fiq_debugger_ringbuf *rbuf)
+{
+	int level = rbuf->head - rbuf->tail;
+
+	if (level < 0)
+		level = rbuf->len + level;
+
+	return level;
+}
+
+static inline int fiq_debugger_ringbuf_room(struct fiq_debugger_ringbuf *rbuf)
+{
+	return rbuf->len - fiq_debugger_ringbuf_level(rbuf) - 1;
+}
+
+static inline u8
+fiq_debugger_ringbuf_peek(struct fiq_debugger_ringbuf *rbuf, int i)
+{
+	return rbuf->buf[(rbuf->tail + i) % rbuf->len];
+}
+
+static inline int
+fiq_debugger_ringbuf_consume(struct fiq_debugger_ringbuf *rbuf, int count)
+{
+	count = min(count, fiq_debugger_ringbuf_level(rbuf));
+
+	rbuf->tail = (rbuf->tail + count) % rbuf->len;
+	smp_mb();
+
+	return count;
+}
+
+static inline int
+fiq_debugger_ringbuf_push(struct fiq_debugger_ringbuf *rbuf, u8 datum)
+{
+	if (fiq_debugger_ringbuf_room(rbuf) == 0)
+		return 0;
+
+	rbuf->buf[rbuf->head] = datum;
+	smp_mb();
+	rbuf->head = (rbuf->head + 1) % rbuf->len;
+	smp_mb();
+
+	return 1;
+}
diff --git a/drivers/staging/android/fiq_debugger/fiq_watchdog.c b/drivers/staging/android/fiq_debugger/fiq_watchdog.c
new file mode 100644
index 00000000..194b541
--- /dev/null
+++ b/drivers/staging/android/fiq_debugger/fiq_watchdog.c
@@ -0,0 +1,56 @@
+/*
+ * Copyright (C) 2014 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/spinlock.h>
+#include <linux/pstore_ram.h>
+
+#include "fiq_watchdog.h"
+#include "fiq_debugger_priv.h"
+
+static DEFINE_RAW_SPINLOCK(fiq_watchdog_lock);
+
+static void fiq_watchdog_printf(struct fiq_debugger_output *output,
+				const char *fmt, ...)
+{
+	char buf[256];
+	va_list ap;
+	int len;
+
+	va_start(ap, fmt);
+	len = vscnprintf(buf, sizeof(buf), fmt, ap);
+	va_end(ap);
+
+	ramoops_console_write_buf(buf, len);
+}
+
+struct fiq_debugger_output fiq_watchdog_output = {
+	.printf = fiq_watchdog_printf,
+};
+
+void fiq_watchdog_triggered(const struct pt_regs *regs, void *svc_sp)
+{
+	char msg[24];
+	int len;
+
+	raw_spin_lock(&fiq_watchdog_lock);
+
+	len = scnprintf(msg, sizeof(msg), "watchdog fiq cpu %d\n",
+			THREAD_INFO(svc_sp)->cpu);
+	ramoops_console_write_buf(msg, len);
+
+	fiq_debugger_dump_stacktrace(&fiq_watchdog_output, regs, 100, svc_sp);
+
+	raw_spin_unlock(&fiq_watchdog_lock);
+}
diff --git a/drivers/staging/android/fiq_debugger/fiq_watchdog.h b/drivers/staging/android/fiq_debugger/fiq_watchdog.h
new file mode 100644
index 00000000..c6b507f
--- /dev/null
+++ b/drivers/staging/android/fiq_debugger/fiq_watchdog.h
@@ -0,0 +1,20 @@
+/*
+ * Copyright (C) 2014 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _FIQ_WATCHDOG_H_
+#define _FIQ_WATCHDOG_H_
+
+void fiq_watchdog_triggered(const struct pt_regs *regs, void *svc_sp);
+
+#endif
diff --git a/drivers/staging/android/ion/Kconfig b/drivers/staging/android/ion/Kconfig
index c8fb413..5536efe 100644
--- a/drivers/staging/android/ion/Kconfig
+++ b/drivers/staging/android/ion/Kconfig
@@ -52,3 +52,10 @@ config ION_OF
 	  extensions
 
 	  If using Ion and devicetree, you should say Y here
+
+config ION_RTK
+	tristate "Ion for Realtek"
+	depends on ION
+	help
+	  Choose this option if you wish to use ion on Realtek platform.
+
diff --git a/drivers/staging/android/ion/Makefile b/drivers/staging/android/ion/Makefile
index 5d630a0..67f7b8b 100644
--- a/drivers/staging/android/ion/Makefile
+++ b/drivers/staging/android/ion/Makefile
@@ -9,5 +9,5 @@ endif
 obj-$(CONFIG_ION_DUMMY) += ion_dummy_driver.o
 obj-$(CONFIG_ION_TEGRA) += tegra/
 obj-$(CONFIG_ION_HISI) += hisilicon/
-obj-$(CONFIG_ION_OF) += ion_of.o
-
+obj-$(CONFIG_ION_RTK) += realtek/
+obj-$(CONFIG_ION_OF) += ion_of.o
\ No newline at end of file
diff --git a/drivers/staging/android/ion/compat_ion.c b/drivers/staging/android/ion/compat_ion.c
index 9a978d2..8e772ca 100644
--- a/drivers/staging/android/ion/compat_ion.c
+++ b/drivers/staging/android/ion/compat_ion.c
@@ -39,12 +39,24 @@ struct compat_ion_handle_data {
 	compat_int_t handle;
 };
 
+#if defined(CONFIG_ION_RTK)
+struct compat_ion_phys_data {
+	compat_int_t handle;
+	compat_ulong_t addr;
+	compat_size_t len;
+};
+#endif /* CONFIG_ION_RTK */
+
 #define COMPAT_ION_IOC_ALLOC	_IOWR(ION_IOC_MAGIC, 0, \
 				      struct compat_ion_allocation_data)
 #define COMPAT_ION_IOC_FREE	_IOWR(ION_IOC_MAGIC, 1, \
 				      struct compat_ion_handle_data)
 #define COMPAT_ION_IOC_CUSTOM	_IOWR(ION_IOC_MAGIC, 6, \
 				      struct compat_ion_custom_data)
+#if defined(CONFIG_ION_RTK)
+#define COMPAT_ION_IOC_PHYS	_IOWR(ION_IOC_MAGIC, 8, \
+				      struct compat_ion_phys_data)
+#endif /* CONFIG_ION_RTK */
 
 static int compat_get_ion_allocation_data(
 			struct compat_ion_allocation_data __user *data32,
@@ -82,6 +94,46 @@ static int compat_get_ion_handle_data(
 	return err;
 }
 
+#if defined(CONFIG_ION_RTK)
+static int compat_get_ion_phys_data(
+			struct compat_ion_phys_data __user *data32,
+			struct ion_phys_data __user *data)
+{
+	compat_size_t s;
+	compat_int_t i;
+	compat_ulong_t u;
+	int err;
+
+	err = get_user(i, &data32->handle);
+	err |= put_user(i, &data->handle);
+	err |= get_user(u, &data32->addr);
+	err |= put_user(u, &data->addr);
+	err |= get_user(s, &data32->len);
+	err |= put_user(s, &data->len);
+
+	return err;
+}
+
+static int compat_put_ion_phys_data(
+			struct compat_ion_phys_data __user *data32,
+			struct ion_phys_data __user *data)
+{
+	compat_size_t s;
+	compat_int_t i;
+	compat_ulong_t u;
+	int err;
+
+	err = get_user(i, &data->handle);
+	err |= put_user(i, &data32->handle);
+	err |= get_user(u, &data->addr);
+	err |= put_user(u, &data32->addr);
+	err |= get_user(s, &data->len);
+	err |= put_user(s, &data32->len);
+
+	return err;
+}
+#endif /* CONFIG_ION_RTK */
+
 static int compat_put_ion_allocation_data(
 			struct compat_ion_allocation_data __user *data32,
 			struct ion_allocation_data __user *data)
@@ -189,6 +241,30 @@ long compat_ion_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 	case ION_IOC_SYNC:
 		return filp->f_op->unlocked_ioctl(filp, cmd,
 						(unsigned long)compat_ptr(arg));
+#if defined(CONFIG_ION_RTK)
+	case COMPAT_ION_IOC_PHYS:
+	{
+		struct compat_ion_phys_data __user *data32;
+		struct ion_phys_data __user *data;
+		int err;
+
+		data32 = compat_ptr(arg);
+		data = compat_alloc_user_space(sizeof(*data));
+		if (data == NULL)
+			return -EFAULT;
+
+		err = compat_get_ion_phys_data(data32, data);
+		if (err)
+			return err;
+
+		err = filp->f_op->unlocked_ioctl(filp, ION_IOC_PHYS,
+							(unsigned long)data);
+
+		compat_put_ion_phys_data(data32, data);
+		return err;
+
+	}
+#endif /* CONFIG_ION_RTK */
 	default:
 		return -ENOIOCTLCMD;
 	}
diff --git a/drivers/staging/android/ion/ion-ioctl.c b/drivers/staging/android/ion/ion-ioctl.c
index 2b700e8..d03fef2 100644
--- a/drivers/staging/android/ion/ion-ioctl.c
+++ b/drivers/staging/android/ion/ion-ioctl.c
@@ -22,12 +22,24 @@
 #include "ion_priv.h"
 #include "compat_ion.h"
 
+#if defined(CONFIG_ION_RTK)
+extern int ion_phys(struct ion_client *client, struct ion_handle *handle,
+	ion_phys_addr_t *addr, size_t *len);
+#if defined(CONFIG_ARM)
+#define COMPAT_ION_IOC_PHYS _IOWR(ION_IOC_MAGIC, 8, struct ion_phys_data)
+#endif /* CONFIG_ARM 32bit */
+
+#endif /* CONFIG_ION_RTK */
+
 union ion_ioctl_arg {
 	struct ion_fd_data fd;
 	struct ion_allocation_data allocation;
 	struct ion_handle_data handle;
 	struct ion_custom_data custom;
 	struct ion_heap_query query;
+#if defined(CONFIG_ION_RTK)
+	struct ion_phys_data phys;
+#endif /* CONFIG_ION_RTK */
 };
 
 static int validate_ioctl_arg(unsigned int cmd, union ion_ioctl_arg *arg)
@@ -123,6 +135,37 @@ long ion_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 		mutex_unlock(&client->lock);
 		break;
 	}
+	/* 20130208 charleslin: add ioctl to get physical address */
+#if defined(CONFIG_ION_RTK)
+#if defined(CONFIG_ARM)
+    case COMPAT_ION_IOC_PHYS:
+#endif /* CONFIG_ARM 32bit */
+	case ION_IOC_PHYS:
+	{
+		int ret;
+		ion_phys_addr_t addr;
+		size_t len;
+		struct ion_handle *handle;
+
+		if (copy_from_user(&data, (void __user *)arg, sizeof(data)))
+			return -EFAULT;
+
+		handle = ion_handle_get_by_id(client, data.phys.handle);
+		if (IS_ERR(handle))
+			return PTR_ERR(handle);
+		ret = ion_phys(client, handle, &addr, &len);
+
+		ion_handle_put(handle);
+		pr_debug("%s: addr:%lx len:%lx\n", __func__, addr, len);
+		data.phys.addr = addr;
+		data.phys.len = len;
+		if(ret != 0)
+			return ret;
+		if (copy_to_user((void __user *)arg, &data.phys, sizeof(data.phys)))
+			return -EFAULT;
+		break;
+	}
+#endif /* CONFIG_ION_RTK */
 	case ION_IOC_SHARE:
 	case ION_IOC_MAP:
 	{
diff --git a/drivers/staging/android/ion/ion.c b/drivers/staging/android/ion/ion.c
index 6f9974c..ff2b491 100644
--- a/drivers/staging/android/ion/ion.c
+++ b/drivers/staging/android/ion/ion.c
@@ -41,6 +41,10 @@
 #include "ion_priv.h"
 #include "compat_ion.h"
 
+#if defined(CONFIG_ION_RTK)
+#include "../uapi/ion_rtk.h"
+#endif
+
 bool ion_buffer_fault_user_mappings(struct ion_buffer *buffer)
 {
 	return (buffer->flags & ION_FLAG_CACHED) &&
@@ -402,6 +406,25 @@ static int ion_handle_add(struct ion_client *client, struct ion_handle *handle)
 	return 0;
 }
 
+#if defined(CONFIG_ION_RTK)
+struct ion_heap * ion_get_client_heap_by_mask(struct ion_client *client,  unsigned int heap_id_mask)
+{
+	struct ion_device *dev = client->dev;
+	struct ion_heap *heap = NULL;
+
+	down_read(&dev->lock);
+	plist_for_each_entry(heap, &dev->heaps, node) {
+		/* if the caller didn't specify this heap id */
+		if (!((1 << heap->id) & heap_id_mask))
+			continue;
+		break;
+	}
+	up_read(&dev->lock);
+	return heap;
+}
+EXPORT_SYMBOL(ion_get_client_heap_by_mask);
+#endif /* CONFIG_ION_RTK */
+
 struct ion_handle *ion_alloc(struct ion_client *client, size_t len,
 			     size_t align, unsigned int heap_id_mask,
 			     unsigned int flags)
@@ -485,6 +508,34 @@ void ion_free(struct ion_client *client, struct ion_handle *handle)
 }
 EXPORT_SYMBOL(ion_free);
 
+#if defined(CONFIG_ION_RTK)
+int ion_phys(struct ion_client *client, struct ion_handle *handle,
+	     ion_phys_addr_t *addr, size_t *len)
+{
+	struct ion_buffer *buffer;
+	int ret;
+
+	mutex_lock(&client->lock);
+	if (!ion_handle_validate(client, handle)) {
+		mutex_unlock(&client->lock);
+		return -EINVAL;
+	}
+
+	buffer = handle->buffer;
+
+	if (!buffer->heap->ops->phys) {
+		pr_err("%s: ion_phys is not implemented by this heap (name=%s, type=%d).\n",
+			__func__, buffer->heap->name, buffer->heap->type);
+		mutex_unlock(&client->lock);
+		return -ENODEV;
+	}
+	mutex_unlock(&client->lock);
+	ret = buffer->heap->ops->phys(buffer->heap, buffer, addr, len);
+	return ret;
+}
+EXPORT_SYMBOL(ion_phys);
+#endif /* CONFIG_ION_RTK */
+
 static void *ion_buffer_kmap_get(struct ion_buffer *buffer)
 {
 	void *vaddr;
@@ -623,7 +674,7 @@ static int ion_debug_client_show(struct seq_file *s, void *unused)
 
 	mutex_lock(&debugfs_mutex);
 	if (!is_client_alive(client)) {
-		seq_printf(s, "ion_client 0x%p dead, can't dump its buffers\n",
+		seq_printf(s, "ion_client 0x%pK dead, can't dump its buffers\n",
 			   client);
 		mutex_unlock(&debugfs_mutex);
 		return 0;
@@ -776,7 +827,6 @@ void ion_client_destroy(struct ion_client *client)
 	struct ion_device *dev = client->dev;
 	struct rb_node *n;
 
-	pr_debug("%s: %d\n", __func__, __LINE__);
 	mutex_lock(&debugfs_mutex);
 	while ((n = rb_first(&client->handles))) {
 		struct ion_handle *handle = rb_entry(n, struct ion_handle,
@@ -790,16 +840,42 @@ void ion_client_destroy(struct ion_client *client)
 	if (client->task)
 		put_task_struct(client->task);
 	rb_erase(&client->node, &dev->clients);
+#if 1 /* ATM-1809 : Fix deadlock at operate debugfs */
+	mutex_unlock(&debugfs_mutex);
+#endif
 	debugfs_remove_recursive(client->debug_root);
 	up_write(&dev->lock);
 
 	kfree(client->display_name);
 	kfree(client->name);
 	kfree(client);
+#if 0 /* ATM-1809 : Fix deadlock at operate debugfs */
 	mutex_unlock(&debugfs_mutex);
+#endif
 }
 EXPORT_SYMBOL(ion_client_destroy);
 
+#if defined(CONFIG_ION_RTK)
+struct sg_table *ion_sg_table(struct ion_client *client,
+	struct ion_handle *handle)
+{
+	struct ion_buffer *buffer;
+	struct sg_table *table;
+
+	mutex_lock(&client->lock);
+	if (!ion_handle_validate(client, handle)) {
+		pr_err("%s: invalid handle passed to map_dma.\n", __func__);
+		mutex_unlock(&client->lock);
+		return ERR_PTR(-EINVAL);
+	}
+	buffer = handle->buffer;
+	table = buffer->sg_table;
+	mutex_unlock(&client->lock);
+	return table;
+}
+EXPORT_SYMBOL(ion_sg_table);
+#endif /* CONFIG_ION_RTK */
+
 static void ion_buffer_sync_for_device(struct ion_buffer *buffer,
 				       struct device *dev,
 				       enum dma_data_direction direction);
@@ -849,9 +925,6 @@ static void ion_buffer_sync_for_device(struct ion_buffer *buffer,
 	int pages = PAGE_ALIGN(buffer->size) / PAGE_SIZE;
 	int i;
 
-	pr_debug("%s: syncing for device %s\n", __func__,
-		 dev ? dev_name(dev) : "null");
-
 	if (!ion_buffer_fault_user_mappings(buffer))
 		return;
 
@@ -887,6 +960,22 @@ static int ion_vm_fault(struct vm_area_struct *vma, struct vm_fault *vmf)
 	pfn = page_to_pfn(ion_buffer_page(buffer->pages[vmf->pgoff]));
 	ret = vm_insert_pfn(vma, (unsigned long)vmf->virtual_address, pfn);
 	mutex_unlock(&buffer->lock);
+#if 1
+	/*
+	 * Android CTS causes OOM if ion_vm_fault return "-EBUSY".
+	 * vm_insert_pfn >> insert_pfn >> -EBUSY
+	 */
+#ifdef CONFIG_ARCH_RTD139x
+	/*
+	 * low-end GPU not support GPU render script.
+	 * if using CPU to do that will cause OOM.
+	 */
+	if (ret == -EBUSY) {
+		printk(KERN_INFO "%s: -EBUSY\n", __func__);
+		return VM_FAULT_NOPAGE; // "VM_FAULT_RETRY" not work
+	}
+#endif /* CONFIG_ARCH_RTD139x */
+#endif
 	if (ret)
 		return VM_FAULT_ERROR;
 
@@ -905,7 +994,6 @@ static void ion_vm_open(struct vm_area_struct *vma)
 	mutex_lock(&buffer->lock);
 	list_add(&vma_list->list, &buffer->vmas);
 	mutex_unlock(&buffer->lock);
-	pr_debug("%s: adding %p\n", __func__, vma);
 }
 
 static void ion_vm_close(struct vm_area_struct *vma)
@@ -913,24 +1001,30 @@ static void ion_vm_close(struct vm_area_struct *vma)
 	struct ion_buffer *buffer = vma->vm_private_data;
 	struct ion_vma_list *vma_list, *tmp;
 
-	pr_debug("%s\n", __func__);
 	mutex_lock(&buffer->lock);
 	list_for_each_entry_safe(vma_list, tmp, &buffer->vmas, list) {
 		if (vma_list->vma != vma)
 			continue;
 		list_del(&vma_list->list);
 		kfree(vma_list);
-		pr_debug("%s: deleting %p\n", __func__, vma);
 		break;
 	}
 	mutex_unlock(&buffer->lock);
 }
-
+#if defined(CONFIG_ION_RTK)
+const struct vm_operations_struct ion_vma_ops = {
+	.open = ion_vm_open,
+	.close = ion_vm_close,
+	.fault = ion_vm_fault,
+};
+EXPORT_SYMBOL(ion_vma_ops);
+#else
 static const struct vm_operations_struct ion_vma_ops = {
 	.open = ion_vm_open,
 	.close = ion_vm_close,
 	.fault = ion_vm_fault,
 };
+#endif /* CONFIG_ION_RTK */
 
 static int ion_mmap(struct dma_buf *dmabuf, struct vm_area_struct *vma)
 {
@@ -952,6 +1046,18 @@ static int ion_mmap(struct dma_buf *dmabuf, struct vm_area_struct *vma)
 		return 0;
 	}
 
+#if defined(CONFIG_ION_RTK)
+#if 0
+	if (buffer->heap->type == RTK_PHOENIX_ION_HEAP_TYPE_MEDIA ||
+		buffer->heap->type == RTK_PHOENIX_ION_HEAP_TYPE_AUDIO ||
+		buffer->heap->type == RTK_PHOENIX_ION_HEAP_TYPE_TILER)
+#else
+	if (buffer->flags & ION_FLAG_NONCACHED)
+#endif
+		vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+	else
+#endif /* CONFIG_ION_RTK */
+
 	if (!(buffer->flags & ION_FLAG_CACHED))
 		vma->vm_page_prot = pgprot_writecombine(vma->vm_page_prot);
 
@@ -967,6 +1073,19 @@ static int ion_mmap(struct dma_buf *dmabuf, struct vm_area_struct *vma)
 	return ret;
 }
 
+#if defined(CONFIG_ION_RTK)
+int ion_mmap_by_handle(struct ion_handle *handle, struct vm_area_struct *vma)
+{
+	struct dma_buf dmabuf;
+	
+	if (handle == NULL)
+		return -1;
+	dmabuf.priv = handle->buffer;
+	return ion_mmap(&dmabuf, vma);
+}
+EXPORT_SYMBOL(ion_mmap_by_handle);
+#endif /* CONFIG_ION_RTK */
+
 static void ion_dma_buf_release(struct dma_buf *dmabuf)
 {
 	struct ion_buffer *buffer = dmabuf->priv;
@@ -1138,6 +1257,54 @@ struct ion_handle *ion_import_dma_buf_fd(struct ion_client *client, int fd)
 }
 EXPORT_SYMBOL(ion_import_dma_buf_fd);
 
+#if defined(CONFIG_ION_RTK)
+struct ion_handle *ion_import_dma_buf_point(struct ion_client *client, struct dma_buf *dmabuf)
+{
+	struct ion_buffer *buffer;
+	struct ion_handle *handle;
+	int ret;
+
+	if (IS_ERR(dmabuf))
+		return ERR_CAST(dmabuf);
+	/* if this memory came from ion */
+
+	if (dmabuf->ops != &dma_buf_ops) {
+		pr_err("%s: can not import dmabuf from another exporter\n",
+		       __func__);
+		dma_buf_put(dmabuf);
+		return ERR_PTR(-EINVAL);
+	}
+	buffer = dmabuf->priv;
+
+	mutex_lock(&client->lock);
+	/* if a handle exists for this buffer just take a reference to it */
+	handle = ion_handle_lookup(client, buffer);
+	if (!IS_ERR(handle)) {
+		ion_handle_get(handle);
+		mutex_unlock(&client->lock);
+		goto end;
+	}
+
+	handle = ion_handle_create(client, buffer);
+	if (IS_ERR(handle)) {
+		mutex_unlock(&client->lock);
+		goto end;
+	}
+
+	ret = ion_handle_add(client, handle);
+	mutex_unlock(&client->lock);
+	if (ret) {
+		ion_handle_put(handle);
+		handle = ERR_PTR(ret);
+	}
+
+end:
+	dma_buf_put(dmabuf);
+	return handle;
+}
+EXPORT_SYMBOL(ion_import_dma_buf_point);
+#endif /* CONFIG_ION_RTK */
+
 int ion_sync_for_device(struct ion_client *client, int fd)
 {
 	struct dma_buf *dmabuf;
@@ -1210,7 +1377,6 @@ static int ion_release(struct inode *inode, struct file *file)
 {
 	struct ion_client *client = file->private_data;
 
-	pr_debug("%s: %d\n", __func__, __LINE__);
 	ion_client_destroy(client);
 	return 0;
 }
@@ -1222,7 +1388,6 @@ static int ion_open(struct inode *inode, struct file *file)
 	struct ion_client *client;
 	char debug_name[64];
 
-	pr_debug("%s: %d\n", __func__, __LINE__);
 	snprintf(debug_name, 64, "%u", task_pid_nr(current->group_leader));
 	client = ion_client_create(dev, debug_name);
 	if (IS_ERR(client))
diff --git a/drivers/staging/android/ion/ion.h b/drivers/staging/android/ion/ion.h
index 93dafb4..dfb38fa 100644
--- a/drivers/staging/android/ion/ion.h
+++ b/drivers/staging/android/ion/ion.h
@@ -118,6 +118,40 @@ struct ion_handle *ion_alloc(struct ion_client *client, size_t len,
  */
 void ion_free(struct ion_client *client, struct ion_handle *handle);
 
+#if defined(CONFIG_ION_RTK)
+
+/**
+ * ion_phys - returns the physical address and len of a handle
+ * @client:     the client
+ * @handle:     the handle
+ * @addr:       a pointer to put the address in
+ * @len:        a pointer to put the length in
+ *
+ * This function queries the heap for a particular handle to get the
+ * handle's physical address.  It't output is only correct if
+ * a heap returns physically contiguous memory -- in other cases
+ * this api should not be implemented -- ion_sg_table should be used
+ * instead.  Returns -EINVAL if the handle is invalid.  This has
+ * no implications on the reference counting of the handle --
+ * the returned value may not be valid if the caller is not
+ * holding a reference.
+ */
+
+int ion_phys(struct ion_client *client, struct ion_handle *handle,
+	ion_phys_addr_t *addr, size_t *len);
+
+/**
+ * ion_map_dma - return an sg_table describing a handle
+ * @client:    the client
+ * @handle:    the handle
+ *
+ * This function returns the sg_table describing
+ * a particular ion handle.
+ */
+struct sg_table *ion_sg_table(struct ion_client *client,
+	struct ion_handle *handle);
+#endif /* CONFIG_ION_RTK */
+
 /**
  * ion_map_kernel - create mapping for the given handle
  * @client:	the client
@@ -173,4 +207,10 @@ struct ion_handle *ion_import_dma_buf(struct ion_client *client,
  */
 struct ion_handle *ion_import_dma_buf_fd(struct ion_client *client, int fd);
 
+#if defined(CONFIG_ION_RTK)
+struct ion_handle *ion_import_dma_buf_point(struct ion_client *client, struct dma_buf *dmabuf);
+int ion_mmap_by_handle(struct ion_handle *handle, struct vm_area_struct *vma);
+extern const struct vm_operations_struct ion_vma_ops;
+#endif /* CONFIG_ION_RTK */
+
 #endif /* _LINUX_ION_H */
diff --git a/drivers/staging/android/ion/ion_carveout_heap.c b/drivers/staging/android/ion/ion_carveout_heap.c
index a8ea973..7869d21 100644
--- a/drivers/staging/android/ion/ion_carveout_heap.c
+++ b/drivers/staging/android/ion/ion_carveout_heap.c
@@ -25,6 +25,10 @@
 #include "ion.h"
 #include "ion_priv.h"
 
+#if defined(CONFIG_ION_RTK)
+#include "../uapi/ion_rtk.h"
+#endif
+
 #define ION_CARVEOUT_ALLOCATE_FAIL	-1
 
 struct ion_carveout_heap {
@@ -58,6 +62,21 @@ static void ion_carveout_free(struct ion_heap *heap, ion_phys_addr_t addr,
 	gen_pool_free(carveout_heap->pool, addr, size);
 }
 
+#if defined(CONFIG_ION_RTK)
+static int ion_carveout_heap_phys(struct ion_heap *heap,
+	struct ion_buffer *buffer, ion_phys_addr_t *addr, size_t *len)
+{
+	struct sg_table *table = buffer->priv_virt;
+	struct page *page = sg_page(table->sgl);
+	ion_phys_addr_t paddr = PFN_PHYS(page_to_pfn(page));
+
+	*addr = paddr;
+	*len = buffer->size;
+
+	return 0;
+}
+#endif /* CONFIG_ION_RTK */
+
 static int ion_carveout_heap_allocate(struct ion_heap *heap,
 				      struct ion_buffer *buffer,
 				      unsigned long size, unsigned long align,
@@ -116,6 +135,9 @@ static void ion_carveout_heap_free(struct ion_buffer *buffer)
 static struct ion_heap_ops carveout_heap_ops = {
 	.allocate = ion_carveout_heap_allocate,
 	.free = ion_carveout_heap_free,
+#if defined(CONFIG_ION_RTK)
+	.phys = ion_carveout_heap_phys,
+#endif /* CONFIG_ION_RTK */
 	.map_user = ion_heap_map_user,
 	.map_kernel = ion_heap_map_kernel,
 	.unmap_kernel = ion_heap_unmap_kernel,
diff --git a/drivers/staging/android/ion/ion_cma_heap.c b/drivers/staging/android/ion/ion_cma_heap.c
index 6c7de74..37b2c02 100644
--- a/drivers/staging/android/ion/ion_cma_heap.c
+++ b/drivers/staging/android/ion/ion_cma_heap.c
@@ -51,8 +51,12 @@ static int ion_cma_allocate(struct ion_heap *heap, struct ion_buffer *buffer,
 
 	dev_dbg(dev, "Request buffer allocation len %ld\n", len);
 
-	if (buffer->flags & ION_FLAG_CACHED)
+	if (buffer->flags & ION_FLAG_CACHED){
+#if defined(CONFIG_ION_RTK)
+		dev_err(dev, "Can't allocate buffer cause buffer->flags(0x%.8lx) & ION_FLAG_CACHED\n", buffer->flags);
+#endif /* CONFIG_ION_RTK */
 		return -EINVAL;
+	}
 
 	if (align > PAGE_SIZE)
 		return -EINVAL;
@@ -79,7 +83,6 @@ static int ion_cma_allocate(struct ion_heap *heap, struct ion_buffer *buffer,
 	/* keep this for memory release */
 	buffer->priv_virt = info;
 	buffer->sg_table = info->table;
-	dev_dbg(dev, "Allocate buffer %p\n", buffer);
 	return 0;
 
 free_table:
@@ -97,7 +100,6 @@ static void ion_cma_free(struct ion_buffer *buffer)
 	struct device *dev = cma_heap->dev;
 	struct ion_cma_buffer_info *info = buffer->priv_virt;
 
-	dev_dbg(dev, "Release buffer %p\n", buffer);
 	/* release memory */
 	dma_free_coherent(dev, buffer->size, info->cpu_addr, info->handle);
 	/* release sg table */
@@ -106,6 +108,24 @@ static void ion_cma_free(struct ion_buffer *buffer)
 	kfree(info);
 }
 
+#if defined(CONFIG_ION_RTK)
+/* return physical address in addr */
+static int ion_cma_phys(struct ion_heap *heap, struct ion_buffer *buffer,
+	ion_phys_addr_t *addr, size_t *len)
+{
+	struct ion_cma_heap *cma_heap = to_cma_heap(buffer->heap);
+	struct device *dev = cma_heap->dev;
+	struct ion_cma_buffer_info *info = buffer->priv_virt;
+
+	dev_dbg(dev, "Return buffer %p physical address %pa\n", buffer,
+		&info->handle);
+	*addr = info->handle;
+	*len = buffer->size;
+
+	return 0;
+}
+#endif /* CONFIG_ION_RTK */
+
 static int ion_cma_mmap(struct ion_heap *mapper, struct ion_buffer *buffer,
 			struct vm_area_struct *vma)
 {
@@ -133,6 +153,9 @@ static void ion_cma_unmap_kernel(struct ion_heap *heap,
 static struct ion_heap_ops ion_cma_ops = {
 	.allocate = ion_cma_allocate,
 	.free = ion_cma_free,
+#if defined(CONFIG_ION_RTK)
+	.phys = ion_cma_phys,
+#endif /* CONFIG_ION_RTK */
 	.map_user = ion_cma_mmap,
 	.map_kernel = ion_cma_map_kernel,
 	.unmap_kernel = ion_cma_unmap_kernel,
diff --git a/drivers/staging/android/ion/ion_heap.c b/drivers/staging/android/ion/ion_heap.c
index c2a7cb9..5fcd54c 100644
--- a/drivers/staging/android/ion/ion_heap.c
+++ b/drivers/staging/android/ion/ion_heap.c
@@ -25,6 +25,11 @@
 #include "ion.h"
 #include "ion_priv.h"
 
+#if defined(CONFIG_ION_RTK)
+#include "../uapi/ion_rtk.h"
+#include "realtek/ion_rtk_carveout_heap.h"
+#endif
+
 void *ion_heap_map_kernel(struct ion_heap *heap,
 			  struct ion_buffer *buffer)
 {
@@ -92,6 +97,23 @@ int ion_heap_map_user(struct ion_heap *heap, struct ion_buffer *buffer,
 			offset = 0;
 		}
 		len = min(len, remainder);
+
+		/* 20130208 charleslin: supports noncached mmap for user space */
+#if defined(CONFIG_ION_RTK)
+#if 0
+		if (heap->type == RTK_PHOENIX_ION_HEAP_TYPE_MEDIA ||
+			heap->type == RTK_PHOENIX_ION_HEAP_TYPE_AUDIO ||
+			heap->type == RTK_PHOENIX_ION_HEAP_TYPE_TILER)
+#else
+			if (buffer->flags & ION_FLAG_NONCACHED)
+#endif
+				vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+			else
+				if (!(buffer->flags & ION_FLAG_CACHED))
+					vma->vm_page_prot = pgprot_writecombine(vma->vm_page_prot);
+#endif
+		/* NAS transcode: force to use "write combine" instead of "noncache" */
+		vma->vm_page_prot = pgprot_writecombine(vma->vm_page_prot);
 		ret = remap_pfn_range(vma, addr, page_to_pfn(page), len,
 				      vma->vm_page_prot);
 		if (ret)
@@ -319,7 +341,11 @@ struct ion_heap *ion_heap_create(struct ion_platform_heap *heap_data)
 {
 	struct ion_heap *heap = NULL;
 
+#if defined(CONFIG_ION_RTK)
+	switch ((int)heap_data->type) {
+#else
 	switch (heap_data->type) {
+#endif
 	case ION_HEAP_TYPE_SYSTEM_CONTIG:
 		heap = ion_system_contig_heap_create(heap_data);
 		break;
@@ -335,6 +361,16 @@ struct ion_heap *ion_heap_create(struct ion_platform_heap *heap_data)
 	case ION_HEAP_TYPE_DMA:
 		heap = ion_cma_heap_create(heap_data);
 		break;
+#if defined(CONFIG_ION_RTK)
+	case RTK_PHOENIX_ION_HEAP_TYPE_TILER:
+	case RTK_PHOENIX_ION_HEAP_TYPE_MEDIA:
+	case RTK_PHOENIX_ION_HEAP_TYPE_AUDIO:
+	case RTK_PHOENIX_ION_HEAP_TYPE_SECURE:
+		heap = ion_rtk_carveout_heap_create(heap_data);
+		if (!IS_ERR_OR_NULL(heap))
+			heap->type = heap_data->type;
+		break;
+#endif
 	default:
 		pr_err("%s: Invalid heap type %d\n", __func__,
 		       heap_data->type);
@@ -359,7 +395,11 @@ void ion_heap_destroy(struct ion_heap *heap)
 	if (!heap)
 		return;
 
+#if defined(CONFIG_ION_RTK)
+	switch ((int)heap->type) {
+#else
 	switch (heap->type) {
+#endif
 	case ION_HEAP_TYPE_SYSTEM_CONTIG:
 		ion_system_contig_heap_destroy(heap);
 		break;
@@ -375,6 +415,14 @@ void ion_heap_destroy(struct ion_heap *heap)
 	case ION_HEAP_TYPE_DMA:
 		ion_cma_heap_destroy(heap);
 		break;
+#if defined(CONFIG_ION_RTK)
+	case RTK_PHOENIX_ION_HEAP_TYPE_TILER:
+	case RTK_PHOENIX_ION_HEAP_TYPE_MEDIA:
+	case RTK_PHOENIX_ION_HEAP_TYPE_AUDIO:
+	case RTK_PHOENIX_ION_HEAP_TYPE_SECURE:
+		ion_rtk_carveout_heap_destroy(heap);
+		break;
+#endif
 	default:
 		pr_err("%s: Invalid heap type %d\n", __func__,
 		       heap->type);
diff --git a/drivers/staging/android/ion/ion_priv.h b/drivers/staging/android/ion/ion_priv.h
index 3c3b324..5550c38 100644
--- a/drivers/staging/android/ion/ion_priv.h
+++ b/drivers/staging/android/ion/ion_priv.h
@@ -66,6 +66,9 @@ struct ion_buffer {
 	unsigned long flags;
 	unsigned long private_flags;
 	size_t size;
+#if defined(CONFIG_ION_RTK)
+	ion_phys_addr_t priv_phys;
+#endif
 	void *priv_virt;
 	struct mutex lock;
 	int kmap_cnt;
@@ -176,6 +179,13 @@ struct ion_heap_ops {
 			struct ion_buffer *buffer, unsigned long len,
 			unsigned long align, unsigned long flags);
 	void (*free)(struct ion_buffer *buffer);
+#if defined(CONFIG_ION_RTK)
+	int (*phys)(struct ion_heap *heap, struct ion_buffer *buffer,
+		ion_phys_addr_t *addr, size_t *len);
+#endif
+	struct sg_table * (*map_dma)(struct ion_heap *heap,
+		struct ion_buffer *buffer);
+	void (*unmap_dma)(struct ion_heap *heap, struct ion_buffer *buffer);
 	void * (*map_kernel)(struct ion_heap *heap, struct ion_buffer *buffer);
 	void (*unmap_kernel)(struct ion_heap *heap, struct ion_buffer *buffer);
 	int (*map_user)(struct ion_heap *mapper, struct ion_buffer *buffer,
diff --git a/drivers/staging/android/ion/ion_system_heap.c b/drivers/staging/android/ion/ion_system_heap.c
index d270a42..249e0d8 100644
--- a/drivers/staging/android/ion/ion_system_heap.c
+++ b/drivers/staging/android/ion/ion_system_heap.c
@@ -75,7 +75,7 @@ static struct page *alloc_buffer_page(struct ion_system_heap *heap,
 
 	page = ion_page_pool_alloc(pool);
 
-	if (cached)
+	if (cached && page)
 		ion_pages_sync_for_device(NULL, page, PAGE_SIZE << order,
 					  DMA_BIDIRECTIONAL);
 	return page;
@@ -434,9 +434,26 @@ static void ion_system_contig_heap_free(struct ion_buffer *buffer)
 	kfree(table);
 }
 
+#if defined(CONFIG_ION_RTK)
+static int ion_system_contig_heap_phys(struct ion_heap *heap,
+	struct ion_buffer *buffer, ion_phys_addr_t *addr, size_t *len)
+{
+	struct sg_table *table = buffer->sg_table;
+	struct page *page = sg_page(table->sgl);
+
+	*addr = page_to_phys(page);
+	*len = buffer->size;
+
+	return 0;
+}
+#endif /* CONFIG_ION_RTK */
+
 static struct ion_heap_ops kmalloc_ops = {
 	.allocate = ion_system_contig_heap_allocate,
 	.free = ion_system_contig_heap_free,
+#if defined(CONFIG_ION_RTK)
+	.phys = ion_system_contig_heap_phys,
+#endif /* CONFIG_ION_RTK */
 	.map_kernel = ion_heap_map_kernel,
 	.unmap_kernel = ion_heap_unmap_kernel,
 	.map_user = ion_heap_map_user,
diff --git a/drivers/staging/android/ion/realtek/Kconfig b/drivers/staging/android/ion/realtek/Kconfig
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/staging/android/ion/realtek/Makefile b/drivers/staging/android/ion/realtek/Makefile
new file mode 100644
index 00000000..d75452b
--- /dev/null
+++ b/drivers/staging/android/ion/realtek/Makefile
@@ -0,0 +1 @@
+obj-y += ion_rtk.o ion_rtk_carveout_heap.o
diff --git a/drivers/staging/android/ion/realtek/ion_rtk.c b/drivers/staging/android/ion/realtek/ion_rtk.c
new file mode 100644
index 00000000..485d7ab
--- /dev/null
+++ b/drivers/staging/android/ion/realtek/ion_rtk.c
@@ -0,0 +1,242 @@
+/*
+ *
+ * Copyright (C) 2011 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/err.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/uaccess.h>
+#include <linux/dma-buf.h>
+
+#include "../ion.h"
+#include "../ion_priv.h"
+#include "../../uapi/ion_rtk.h"
+#include "ion_rtk_carveout_heap.h"
+
+#define ALIGNTO   32U
+#define ION_ALIGN(len) ( ((len)+ALIGNTO-1) & ~(ALIGNTO-1) )
+
+static int rtk_ion_sync_for_device(struct ion_client *client, int fd, int cmd)
+{
+	struct dma_buf *dmabuf;
+	struct ion_buffer *buffer;
+	enum dma_data_direction dir = (cmd == RTK_ION_IOC_INVALIDATE) ? DMA_FROM_DEVICE : DMA_TO_DEVICE;
+
+	switch (cmd) {
+	case RTK_ION_IOC_INVALIDATE:
+	case RTK_ION_IOC_FLUSH:
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	dmabuf = dma_buf_get(fd);
+	if (IS_ERR(dmabuf))
+		return PTR_ERR(dmabuf);
+
+	buffer = dmabuf->priv;
+
+    if ((buffer->flags & (ION_FLAG_SECURE_AUDIO | ION_FLAG_SECURE_TPACC)) == 0)
+        dma_sync_sg_for_device(NULL, buffer->sg_table->sgl,
+                buffer->sg_table->nents, dir);
+
+	dma_buf_put(dmabuf);
+	return 0;
+}
+
+static int rtk_ion_sync_range_for_device(struct ion_client *client, int cmd, struct RTK_ION_IOC_SYNC_RANE *range_data)
+{
+	struct dma_buf *dmabuf;
+	struct ion_buffer *buffer;
+	enum dma_data_direction dir = (cmd == RTK_ION_IOC_INVALIDATE_RANGE) ? DMA_FROM_DEVICE : DMA_TO_DEVICE;
+	int fd;
+
+	switch (cmd) {
+	case RTK_ION_IOC_INVALIDATE_RANGE:
+	case RTK_ION_IOC_FLUSH_RANGE:
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	fd = (int) range_data->handle & -1U;
+
+	dmabuf = dma_buf_get(fd);
+	if (IS_ERR(dmabuf))
+		return PTR_ERR(dmabuf);
+
+	buffer = dmabuf->priv;
+
+    if ((buffer->flags & (ION_FLAG_SECURE_AUDIO | ION_FLAG_SECURE_TPACC)) == 0)
+        dma_sync_single_for_device(NULL, range_data->phyAddr, range_data->len, dir);
+
+	dma_buf_put(dmabuf);
+	return 0;
+}
+
+static int rtk_ion_get_memory_info(struct ion_client *client, unsigned int heapMask, unsigned int flags, struct ion_rtk_carveout_meminfo * info)
+{
+	int i;
+
+	if (client == NULL || info == NULL)
+		goto err;
+
+	info->usedSize = 0;
+	info->freeSize = 0;
+
+	for (i = 0; i < 32; i++) {
+		struct ion_heap *			   heap;
+		struct ion_rtk_carveout_ops *   ops;
+		struct ion_rtk_carveout_meminfo tmp_info;
+		unsigned int					target_heap_id_mask = 0x1U << i;
+
+		if ((target_heap_id_mask & heapMask) == 0)
+			continue;
+
+		heap = ion_get_client_heap_by_mask(client, target_heap_id_mask);
+		if (heap == NULL)
+			continue;
+
+		ops = get_rtk_carveout_ops(heap);
+		if (ops == NULL)
+			continue;
+
+		if (ops->getMemInfo(heap, flags, &tmp_info) == 0) {
+			info->usedSize += tmp_info.usedSize;
+			info->freeSize += tmp_info.freeSize;
+		}
+	}
+
+	return 0;
+err:
+	return -1;
+}
+
+static int rtk_ion_get_phy_info(struct ion_client *client, struct RTK_ION_IOC_PHY_INFO * phyInfo)
+{
+    int ret = -1;
+    do {
+        struct ion_handle * handle;
+        ion_phys_addr_t addr;
+        size_t len;
+
+        handle = ion_handle_get_by_id(client, phyInfo->handle);
+        if (IS_ERR(handle)) {
+            ret = (int) PTR_ERR(handle);
+            break;
+        }
+        ret = ion_phys(client, handle, &addr, &len);
+        ion_handle_put(handle);
+
+        if (ret != 0)
+            break;
+
+        phyInfo->addr = addr;
+        phyInfo->len = len;
+        break;
+    } while (0);
+    return ret;
+}
+
+long rtk_phoenix_ion_ioctl(struct ion_client *client, unsigned int cmd,
+						   unsigned long arg)
+{
+	switch (cmd) {
+
+	case RTK_PHOENIX_ION_GET_LAST_ALLOC_ADDR:
+	{
+		pr_err("%s: Outdated ioctl : RTK_PHOENIX_ION_GET_LAST_ALLOC_ADDR\n", __func__);
+		return -EFAULT;
+	}
+	case RTK_ION_IOC_INVALIDATE:
+	case RTK_ION_IOC_FLUSH:
+	{
+		int fd = (int) arg& -1U;
+		if (rtk_ion_sync_for_device(client, fd, cmd) != 0) {
+			pr_err("%s: rtk_ion_sync_for_device failed! (cmd:%d fd:%d)\n", __func__, cmd, fd);
+			return -EFAULT;
+		}
+		break;
+	}
+	case RTK_ION_IOC_FLUSH_RANGE:
+	case RTK_ION_IOC_INVALIDATE_RANGE:
+	{
+		struct RTK_ION_IOC_SYNC_RANE range_data;
+		int ret = copy_from_user(&range_data, (void __user *)arg, sizeof (range_data));
+		if (ret) {
+			pr_err("%s:%d copy_from_user failed! (ret = %d)\n", __func__, __LINE__, ret);
+			return -EFAULT;
+		}
+		if (rtk_ion_sync_range_for_device(client, cmd, &range_data) != 0) {
+			pr_err("%s: rtk_ion_sync_range_for_device failed! (cmd:%d handle:%d)\n", __func__, cmd, (int) range_data.handle);
+			return -EFAULT;
+		}
+		break;
+	}
+
+    case RTK_ION_IOC_GET_PHYINFO:
+    {
+        struct RTK_ION_IOC_PHY_INFO phyInfo;
+        int ret = copy_from_user(&phyInfo, (void __user *) arg, sizeof (phyInfo));
+        if (ret != 0) {
+			pr_err("%s:%d copy_from_user failed! (ret = %d)\n", __func__, __LINE__, ret);
+			return -EFAULT;
+        }
+
+        ret = rtk_ion_get_phy_info(client, &phyInfo);
+        if (ret != 0) {
+			pr_err("%s:%d rtk_ion_get_phy_info failed! (ret = %d)\n", __func__, __LINE__, ret);
+			return -EFAULT;
+        }
+
+        ret = copy_to_user((void __user *) arg, &phyInfo, sizeof (phyInfo));
+        if (ret != 0) {
+			pr_err("%s:%d copy_to_user failed! (ret = %d)\n", __func__, __LINE__, ret);
+			return -EFAULT;
+        }
+        break;
+    }
+
+	case RTK_ION_IOC_GET_MEMORY_INFO:
+	{
+		struct RTK_ION_IOC_GET_MEMORY_INFO_S user_info;
+		struct ion_rtk_carveout_meminfo ion_info;
+		int ret;
+		ret = copy_from_user(&user_info, (void __user *)arg, sizeof (user_info));
+		if (ret) {
+			pr_err("%s:%d copy_from_user failed! (ret = %d)\n", __func__, __LINE__, ret);
+			return -EFAULT;
+		}
+		ret = rtk_ion_get_memory_info(client, user_info.heapMask, user_info.flags, &ion_info);
+		if (ret) {
+			pr_err("%s:%d rtk_ion_get_memory_info failed! (ret = %d)\n", __func__, __LINE__, ret);
+			return -EFAULT;
+		}
+		user_info.usedSize = (unsigned int) ion_info.usedSize & -1U;
+		user_info.freeSize = (unsigned int) ion_info.freeSize & -1U;
+		ret = copy_to_user((void __user *)arg, &user_info, sizeof (user_info));
+		if (ret) {
+			pr_err("%s:%d copy_to_user failed! (ret = %d)\n", __func__, __LINE__, ret);
+			return -EFAULT;
+		}
+		break;
+	}
+
+	default:
+		pr_err("%s: Unknown custom ioctl\n", __func__);
+		return -ENOTTY;
+	}
+	return 0;
+}
+
diff --git a/drivers/staging/android/ion/realtek/ion_rtk_carveout_heap.c b/drivers/staging/android/ion/realtek/ion_rtk_carveout_heap.c
new file mode 100644
index 00000000..f89396b
--- /dev/null
+++ b/drivers/staging/android/ion/realtek/ion_rtk_carveout_heap.c
@@ -0,0 +1,929 @@
+/*
+ *
+ * Copyright (C) 2011 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+#include <linux/spinlock.h>
+#include <linux/dma-mapping.h>
+#include <linux/err.h>
+#include <linux/genalloc.h>
+#include <linux/io.h>
+#include <linux/mm.h>
+#include <linux/scatterlist.h>
+#include <linux/slab.h>
+#include <linux/vmalloc.h>
+#include <linux/bitops.h>
+#include <linux/sched.h>
+#include <linux/dma-contiguous.h>
+#include <linux/cma.h>
+#include <linux/module.h>
+
+#include "ion_rtk_carveout_heap.h"
+
+#define ION_CARVEOUT_ALLOCATE_FAIL -1
+
+#define POOL_FLAG_MISMATCH(flags,poolflag) ((flags & poolflag) != flags)
+
+enum ion_rtk_carveout_heap_gen_pool_algo_mode {
+	ALGO_FIRST_FIT  = 0,
+	ALGO_LAST_FIT,
+};
+
+struct ion_rtk_carveout_heap {
+	struct ion_heap heap;
+	unsigned long version;
+	struct ion_rtk_carveout_ops * priv_ops;
+	struct mutex poollock;
+	struct mutex pagelock;
+	struct list_head pool_handlers;
+	struct list_head page_handlers;
+	enum ion_rtk_carveout_heap_gen_pool_algo_mode algo_mode;
+};
+
+struct ION_RTK_CARVEOUT_POOL_INFO {
+	enum ion_rtk_carveout_pool_type type;
+	struct gen_pool *gpool;
+	struct cma * cpool;
+	ion_phys_addr_t base;
+	size_t size;
+	unsigned long flags;
+	struct list_head list;
+};
+
+struct ION_RTK_CARVEOUT_PAGE_INFO {
+	struct ION_RTK_CARVEOUT_POOL_INFO * pool_info;
+	ion_phys_addr_t base;
+	size_t size;
+	unsigned long flags;
+	char task_comm[TASK_COMM_LEN];
+	pid_t pid;
+	pid_t tgid;
+	struct page * page;
+	struct list_head list;
+};
+
+static bool cached_turbo = true;
+
+inline unsigned long poolFlag2ION (unsigned long flags)
+{
+	unsigned long out = 0;
+
+	out |= (flags & RTK_FLAG_NONCACHED) ? ION_FLAG_NONCACHED	: 0;
+	out |= (flags & RTK_FLAG_SCPUACC) ? ION_FLAG_SCPUACC	 : 0;
+	out |= (flags & RTK_FLAG_ACPUACC) ? ION_FLAG_ACPUACC	 : 0;
+	out |= (flags & RTK_FLAG_HWIPACC) ? ION_FLAG_HWIPACC	 : 0;
+	out |= (flags & RTK_FLAG_VE_SPEC) ? ION_FLAG_VE_SPEC : 0;
+	out |= (flags & RTK_FLAG_SECURE_AUDIO) ? ION_FLAG_SECURE_AUDIO : 0;
+	out |= (flags & RTK_FLAG_SECURE_TPACC) ? ION_FLAG_SECURE_TPACC : 0;
+	out |= (flags & RTK_FLAG_VCPU_FWACC) ? ION_FLAG_VCPU_FWACC : 0;
+	out |= (flags & RTK_FLAG_CMA) ? ION_FLAG_CMA : 0;
+	return out;
+}
+
+static unsigned int ion_rtk_carveout_get_version (struct ion_heap * heap)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap =
+		container_of(heap, struct ion_rtk_carveout_heap, heap);
+
+	if (rtk_carveout_heap->version != sizeof(struct ion_rtk_carveout_heap))
+		goto err;
+
+	return (unsigned int) rtk_carveout_heap->version & -1U;
+
+err:
+	return 0;
+}
+
+static int ion_rtk_carveout_get_meminfo (struct ion_heap * heap, unsigned int flags, struct ion_rtk_carveout_meminfo * info)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap =
+		container_of(heap, struct ion_rtk_carveout_heap, heap);
+
+	struct ION_RTK_CARVEOUT_PAGE_INFO * page_info = NULL;
+	struct ION_RTK_CARVEOUT_POOL_INFO * phandler = NULL;
+
+	unsigned long usedSize = 0, freeSize = 0;
+
+	if (heap == NULL || info == NULL)
+		return -1;
+
+	mutex_lock(&rtk_carveout_heap->poollock);
+	list_for_each_entry(phandler, &rtk_carveout_heap->pool_handlers, list) {
+		if (!POOL_FLAG_MISMATCH(flags, poolFlag2ION(phandler->flags))) {
+			unsigned long allocSize = 0;
+			mutex_lock(&rtk_carveout_heap->pagelock);
+			list_for_each_entry(page_info, &rtk_carveout_heap->page_handlers, list) {
+				if (page_info->pool_info == phandler) {
+					if (!POOL_FLAG_MISMATCH(flags, page_info->flags))
+						allocSize += page_info->size;
+				}
+			}
+			mutex_unlock(&rtk_carveout_heap->pagelock);
+
+			usedSize += allocSize;
+			freeSize += phandler->size - allocSize;
+		}
+	}
+	mutex_unlock(&rtk_carveout_heap->poollock);
+
+	info->usedSize = usedSize;
+	info->freeSize = freeSize;
+
+	return 0;
+}
+
+static struct ion_rtk_carveout_ops rtk_carveout_heap_priv_ops = {
+	.getVersion = ion_rtk_carveout_get_version,
+	.getMemInfo = ion_rtk_carveout_get_meminfo,
+};
+
+struct ion_rtk_carveout_ops * get_rtk_carveout_ops(struct ion_heap * heap)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap =
+		container_of(heap, struct ion_rtk_carveout_heap, heap);
+
+	if (rtk_carveout_heap->version != sizeof(struct ion_rtk_carveout_heap))
+		goto err;
+
+	return rtk_carveout_heap->priv_ops;
+
+err:
+	return NULL;
+}
+
+void ion_rtk_carveout_show_list(struct ion_heap *heap)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap =
+		container_of(heap, struct ion_rtk_carveout_heap, heap);
+
+	struct ION_RTK_CARVEOUT_PAGE_INFO * page_info;
+	struct ION_RTK_CARVEOUT_POOL_INFO * phandler;
+
+	__WARN();
+	mutex_lock(&rtk_carveout_heap->poollock);
+	list_for_each_entry(phandler, &rtk_carveout_heap->pool_handlers, list) {
+		pr_debug("[POOL] base=0x%08X size=0x%08X flags=0x%x\n",
+				(unsigned int) phandler->base,
+				(unsigned int) phandler->size,
+				(unsigned int) phandler->flags);
+		mutex_lock(&rtk_carveout_heap->pagelock);
+		list_for_each_entry(page_info, &rtk_carveout_heap->page_handlers, list) {
+			if (page_info->pool_info == phandler) {
+				pr_debug("  +--- [PAGE] base=0x%08X size=0x%08X flags=0x%x [%16.s] pids:%-5d tgid:%-5d\n",
+						(unsigned int) page_info->base,
+						(unsigned int) page_info->size,
+						(unsigned int) page_info->flags,
+						page_info->task_comm,
+						(unsigned int) page_info->pid,
+						(unsigned int) page_info->tgid);
+			}
+		}
+		mutex_unlock(&rtk_carveout_heap->pagelock);
+	}
+	mutex_unlock(&rtk_carveout_heap->poollock);
+}
+
+__maybe_unused static int ion_carveout_heap_debug_show_list(
+	struct ion_heap *heap, struct seq_file *s, void *unused)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap =
+		container_of(heap, struct ion_rtk_carveout_heap, heap);
+
+	struct ION_RTK_CARVEOUT_PAGE_INFO * page_info;
+	struct ION_RTK_CARVEOUT_POOL_INFO * phandler;
+
+	seq_printf(s,"[%s]\n", __func__);
+
+	mutex_lock(&rtk_carveout_heap->poollock);
+	list_for_each_entry(phandler, &rtk_carveout_heap->pool_handlers, list) {
+		seq_printf(s,"\n[POOL] base=0x%08X size=0x%08X flags=0x%x\n",
+				(unsigned int) phandler->base,
+				(unsigned int) phandler->size,
+				(unsigned int) phandler->flags);
+		mutex_lock(&rtk_carveout_heap->pagelock);
+		list_for_each_entry(page_info, &rtk_carveout_heap->page_handlers, list) {
+			if (page_info->pool_info == phandler) {
+				seq_printf(s,"  +--- [PAGE] base=0x%08X size=0x%08X flags=0x%x [%16.s] pids:%-5d tgid:%-5d\n",
+						(unsigned int) page_info->base,
+						(unsigned int) page_info->size,
+						(unsigned int) page_info->flags,
+						page_info->task_comm,
+						(unsigned int) page_info->pid,
+						(unsigned int) page_info->tgid);
+			}
+		}
+		mutex_unlock(&rtk_carveout_heap->pagelock);
+	}
+	mutex_unlock(&rtk_carveout_heap->poollock);
+	seq_printf(s,"\n");
+	return 0;
+}
+
+struct ION_RTK_CARVEOUT_PAGE_INFO * ion_rtk_carveout_allocate(struct ion_heap *heap,
+	unsigned long size, unsigned long align, unsigned long flags)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap =
+		container_of(heap, struct ion_rtk_carveout_heap, heap);
+
+	struct ION_RTK_CARVEOUT_PAGE_INFO * page_info;
+	struct ION_RTK_CARVEOUT_POOL_INFO * phandler;
+	unsigned int matchCmp = 0;
+	unsigned int compare;
+	unsigned long tmp_flag = flags & RTK_ION_FLAG_POOL_CONDITION;
+	unsigned int algo_mode = (flags & ION_USAGE_ALGO_LAST_FIT) ? ALGO_LAST_FIT : ALGO_FIRST_FIT;
+	unsigned long pool_flag;
+
+	ion_phys_addr_t offset = 0;
+
+	struct task_struct *task;
+	pid_t pid, tgid;
+	char task_comm[TASK_COMM_LEN];
+
+	get_task_struct(current->group_leader);
+	task_lock(current->group_leader);
+	pid = task_pid_nr(current->group_leader);
+	tgid = task_tgid_nr(current->group_leader);
+	if (current->group_leader->flags & PF_KTHREAD)
+		task = NULL;
+	else
+		task = current->group_leader;
+	task_unlock(current->group_leader);
+
+	if (task)
+		get_task_comm(task_comm, task);
+	else
+		strncpy(task_comm, "KTHREAD", sizeof(task_comm));
+
+    /* decrease usage count */
+    put_task_struct(current->group_leader);
+
+#if 0
+	if (tmp_flag == 0) {
+		pr_err(" Warning: flags is zero!! The default value is set "
+			"RTK_ION_FLAG_POOL_CONDITION [%16.s]"
+			"pids:%-5d tgid:%-5d\n", task_comm, pid, tgid);
+		tmp_flag = RTK_ION_FLAG_POOL_CONDITION;
+	}
+#endif
+
+	switch (algo_mode) {
+		case ALGO_LAST_FIT:
+			rtk_carveout_heap->algo_mode = ALGO_LAST_FIT;
+			break;
+		case ALGO_FIRST_FIT:
+		default:
+			rtk_carveout_heap->algo_mode = ALGO_FIRST_FIT;
+			break;
+	}
+
+	pr_debug("%s try to alloc %lu align:%lx flags:%lx from heap:%s\n", task_comm, size, align, flags, rtk_carveout_heap->heap.name);
+
+REALLOC:
+	mutex_lock(&rtk_carveout_heap->poollock);
+	list_for_each_entry(phandler, &rtk_carveout_heap->pool_handlers, list) {
+		if (phandler->type != RTK_CARVEOUT_GEN_POOL_TYPE)
+			continue;
+
+		if (phandler->size == 0)
+			continue;
+
+		pool_flag = poolFlag2ION(phandler->flags);
+
+#if 0
+		pr_info("tmp_flag=0x%x pool_flag=0x%x compare=0x%x matchCmp=0x%x\n",
+				tmp_flag, pool_flag, (hweight32(pool_flag) - hweight32(tmp_flag)), matchCmp);
+#endif
+
+		if (POOL_FLAG_MISMATCH(tmp_flag, pool_flag))
+			continue;
+
+		compare = hweight32(pool_flag) - hweight32(tmp_flag);
+
+		if (compare != matchCmp)
+			continue;
+
+		offset = gen_pool_alloc(phandler->gpool, size);
+
+		if (offset != 0) {
+			page_info = kzalloc(sizeof(struct ION_RTK_CARVEOUT_PAGE_INFO), GFP_KERNEL);
+			if (!page_info) {
+				gen_pool_free(phandler->gpool, offset, size);
+				mutex_unlock(&rtk_carveout_heap->poollock);
+				goto ERR;
+			}
+			page_info->pool_info = phandler;
+			page_info->base = offset;
+			page_info->size = size;
+			page_info->flags = flags;
+			page_info->pid = pid;
+			page_info->tgid = tgid;
+			page_info->page = NULL;
+			strncpy(page_info->task_comm, task_comm, sizeof(page_info->task_comm));
+			mutex_unlock(&rtk_carveout_heap->poollock);
+			pr_debug("allocate %zu from %s heap\n", size, rtk_carveout_heap->heap.name);
+			return page_info;
+		}
+	}
+	mutex_unlock(&rtk_carveout_heap->poollock);
+
+	if (matchCmp < (hweight32(RTK_ION_FLAG_POOL_CONDITION) - hweight32(tmp_flag))) {
+		matchCmp++;
+		goto REALLOC;
+	}
+
+	matchCmp = 0;
+
+CMA_REALLOC:
+	mutex_lock(&rtk_carveout_heap->poollock);
+	list_for_each_entry(phandler, &rtk_carveout_heap->pool_handlers, list) {
+		struct page * page = NULL;
+		unsigned int cma_align = get_order(size);
+
+		if (phandler->type != RTK_CARVEOUT_CMA_POOL_TYPE)
+			continue;
+
+		pool_flag = poolFlag2ION(phandler->flags);
+
+		if (POOL_FLAG_MISMATCH(tmp_flag, pool_flag))
+			continue;
+
+		compare = hweight32(pool_flag) - hweight32(tmp_flag);
+
+		if (compare != matchCmp)
+			continue;
+
+		if (cma_align > CONFIG_CMA_ALIGNMENT)
+			cma_align = CONFIG_CMA_ALIGNMENT;
+
+		page = cma_alloc(phandler->cpool, size>>PAGE_SHIFT, cma_align);
+
+		if (page) {
+			page_info = kzalloc(sizeof(struct ION_RTK_CARVEOUT_PAGE_INFO), GFP_KERNEL);
+			if (!page_info) {
+				cma_release(phandler->cpool, page, size>>PAGE_SHIFT);
+				mutex_unlock(&rtk_carveout_heap->poollock);
+				goto ERR;
+			}
+			page_info->pool_info = phandler;
+			page_info->base = page_to_phys(page);
+			page_info->size = size;
+			page_info->flags = flags;
+			page_info->pid = pid;
+			page_info->tgid = tgid;
+			page_info->page = page;
+			strncpy(page_info->task_comm, task_comm, sizeof(page_info->task_comm));
+			mutex_unlock(&rtk_carveout_heap->poollock);
+			pr_debug("allocate %zu from cma\n", size);
+			return page_info;
+		} else
+			pr_err("[%s] cma_alloc failed! %p size:%ld cma_align:%d\n", __func__,
+					phandler->cpool, size, cma_align);
+	}
+	mutex_unlock(&rtk_carveout_heap->poollock);
+	if (matchCmp < (hweight32(RTK_ION_FLAG_POOL_CONDITION) - hweight32(tmp_flag))) {
+		matchCmp++;
+		goto CMA_REALLOC;
+	}
+
+
+ERR:
+	pr_err("[%s] alloc failed! request heap=%s size=0x%x align=0x%x flags=0x%x [%16.s] pids:%-5d tgid:%-5d\n",
+			__func__,
+			rtk_carveout_heap->heap.name,
+			(unsigned int) size,
+			(unsigned int) align,
+			(unsigned int) flags,
+			task_comm,
+			(unsigned int) pid,
+			(unsigned int) tgid);
+	ion_rtk_carveout_show_list(heap);
+	return NULL;
+}
+
+void ion_rtk_carveout_free(struct ion_heap *heap, ion_phys_addr_t addr,
+	unsigned long size)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap =
+		container_of(heap, struct ion_rtk_carveout_heap, heap);
+
+	struct ION_RTK_CARVEOUT_PAGE_INFO * page_info, * tmp_page_info;
+
+	if (addr == ION_CARVEOUT_ALLOCATE_FAIL)
+		return;
+
+	mutex_lock(&rtk_carveout_heap->pagelock);
+	list_for_each_entry_safe(page_info,  tmp_page_info, &rtk_carveout_heap->page_handlers, list) {
+		if (page_info->base == addr) {
+			if (page_info->size != size)
+				pr_err("[%s] free size is mismatch! (alloc:%ld free:%lu)\n", __func__, page_info->size, size);
+
+			if (page_info->pool_info->type == RTK_CARVEOUT_GEN_POOL_TYPE)
+				gen_pool_free(page_info->pool_info->gpool, page_info->base, page_info->size);
+			else if (page_info->pool_info->type == RTK_CARVEOUT_CMA_POOL_TYPE)
+				cma_release(page_info->pool_info->cpool, page_info->page, page_info->size>>PAGE_SHIFT);
+
+			list_del(&page_info->list);
+			kfree(page_info);
+			mutex_unlock(&rtk_carveout_heap->pagelock);
+			return;
+		}
+	}
+	mutex_unlock(&rtk_carveout_heap->pagelock);
+
+	pr_err("[%s] free faile!\n",__func__);
+}
+
+static int ion_rtk_carveout_heap_phys(struct ion_heap *heap,
+	struct ion_buffer *buffer, ion_phys_addr_t *addr, size_t *len)
+{
+	struct sg_table *table = buffer->priv_virt;
+	struct page *page = sg_page(table->sgl);
+	ion_phys_addr_t paddr = PFN_PHYS(page_to_pfn(page));
+
+	*addr = paddr;
+	*len = buffer->size;
+	return 0;
+}
+
+static int ion_rtk_carveout_heap_allocate(struct ion_heap *heap,
+	struct ion_buffer *buffer, unsigned long size, unsigned long align,
+	unsigned long flags)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap =
+		container_of(heap, struct ion_rtk_carveout_heap, heap);
+	struct sg_table *table;
+	struct ION_RTK_CARVEOUT_PAGE_INFO * page_info;
+	int ret;
+
+	if (align > PAGE_SIZE)
+		return -EINVAL;
+
+	table = kzalloc(sizeof(struct sg_table), GFP_KERNEL);
+	if (!table)
+		return -ENOMEM;
+
+	ret = sg_alloc_table(table, 1, GFP_KERNEL);
+	if (ret)
+		goto err_free;
+
+	if ((flags & RTK_ION_FLAG_POOL_CONDITION) == 0) {
+		pr_err(" Warning: flags is 0x%lx!! The default value is set (ION_FLAG_ACPUACC | ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_USAGE_MMAP_NONCACHED) \n", flags);
+		flags = ION_FLAG_ACPUACC | ION_FLAG_SCPUACC | ION_FLAG_HWIPACC | ION_USAGE_MMAP_NONCACHED;
+	}
+
+	page_info = ion_rtk_carveout_allocate(heap, size, align, flags);
+
+	if (page_info == NULL) {
+		ret = -ENOMEM;
+		goto err_free_table;
+	}
+
+	buffer->flags |= poolFlag2ION(page_info->pool_info->flags);
+
+	buffer->flags |= (flags & ION_FLAG_NONCACHED);
+
+	buffer->flags |= (flags & ION_USAGE_MASK);
+
+	if (buffer->flags & ION_USAGE_MMAP_NONCACHED) {
+		/* NONCACHED */
+		buffer->flags |= ION_FLAG_CACHED;
+		buffer->flags |= ION_FLAG_NONCACHED;
+		buffer->flags &= ~ION_FLAG_CACHED_NEEDS_SYNC;
+	} else if (buffer->flags & ION_USAGE_MMAP_WRITECOMBINE) {
+		/* WRITECOMBINE */
+		buffer->flags &= ~ION_FLAG_CACHED;
+		buffer->flags &= ~ION_FLAG_NONCACHED;
+		buffer->flags &= ~ION_FLAG_CACHED_NEEDS_SYNC;
+	} else if ( (buffer->flags & ION_USAGE_MMAP_CACHED) ||
+				(cached_turbo && !(buffer->flags & ION_FLAG_NONCACHED))){
+		/* CACHED */
+		buffer->flags |= ION_FLAG_CACHED;
+		buffer->flags &= ~ION_FLAG_NONCACHED;
+		buffer->flags |= ION_FLAG_CACHED_NEEDS_SYNC;
+	}
+
+	if (	!(buffer->flags & ION_FLAG_SCPUACC) ||
+			(buffer->flags & ION_USAGE_PROTECTED)) {
+		buffer->flags |= ION_FLAG_CACHED;
+		buffer->flags |= ION_FLAG_NONCACHED;
+		buffer->flags &= ~ION_FLAG_CACHED_NEEDS_SYNC;
+	}
+
+	mutex_lock(&rtk_carveout_heap->pagelock);
+	list_add(&page_info->list, &rtk_carveout_heap->page_handlers);
+	mutex_unlock(&rtk_carveout_heap->pagelock);
+
+	sg_set_page(table->sgl, pfn_to_page(PFN_DOWN(page_info->base)), page_info->size, 0);
+
+	buffer->sg_table = table;
+	buffer->priv_virt = table;
+
+	return 0;
+
+err_free_table:
+	sg_free_table(table);
+err_free:
+	kfree(table);
+	ion_rtk_carveout_show_list(heap);
+	return ret;
+}
+
+static void ion_rtk_carveout_heap_free(struct ion_buffer *buffer)
+{
+	struct ion_heap *heap = buffer->heap;
+	struct sg_table *table = buffer->priv_virt;
+	struct page *page = sg_page(table->sgl);
+	ion_phys_addr_t paddr = PFN_PHYS(page_to_pfn(page));
+
+	if (	(buffer->flags & ION_FLAG_SCPUACC) &&
+			!(buffer->flags & ION_USAGE_PROTECTED)) {
+		ion_heap_buffer_zero(buffer);
+
+		if (ion_buffer_cached(buffer))
+			dma_sync_sg_for_device(NULL, table->sgl, table->nents,
+					DMA_BIDIRECTIONAL);
+	}
+
+	ion_rtk_carveout_free(heap, paddr, buffer->size);
+	sg_free_table(table);
+	kfree(table);
+}
+
+static int ion_carveout_heap_debug_show(struct ion_heap *heap, struct seq_file *s,
+	void *unused)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap =
+		container_of(heap, struct ion_rtk_carveout_heap, heap);
+	struct ION_RTK_CARVEOUT_PAGE_INFO * page_info;
+	struct ION_RTK_CARVEOUT_POOL_INFO * phandler;
+	unsigned long offset, allocSize, MemSize;
+
+	enum __mem_state {
+		NONE,
+		FREE,
+		USED,
+	};
+
+
+	seq_printf(s,"\n");
+	mutex_lock(&rtk_carveout_heap->poollock);
+	list_for_each_entry(phandler, &rtk_carveout_heap->pool_handlers, list) {
+		enum __mem_state mem_state = NONE;
+
+		offset = phandler->base;
+		allocSize = 0;
+
+		mutex_lock(&rtk_carveout_heap->pagelock);
+
+		list_for_each_entry(page_info, &rtk_carveout_heap->page_handlers, list) {
+			if (page_info->pool_info == phandler)
+				allocSize += page_info->size;
+		}
+
+
+		seq_printf(s,"   [POOL] type=%s base=0x%08X size=0x%08X flags=0x%-2x Free: %lu kB  Alloc: %lu kB Usage:%lu%%\n",
+				(phandler->type == RTK_CARVEOUT_GEN_POOL_TYPE)?"GEN":
+				(phandler->type == RTK_CARVEOUT_CMA_POOL_TYPE)?"CMA":"Unknown",
+				(unsigned int) phandler->base,
+				(unsigned int) phandler->size,
+				(unsigned int) phandler->flags,
+				(phandler->size - allocSize) / SZ_1K,
+				allocSize/SZ_1K,
+				(allocSize * 100)/phandler->size);
+
+		MemSize = 0;
+
+		seq_printf(s,"       +-------------------+ (0x%08x)\n", (unsigned int) phandler->base);
+		while (offset <= (phandler->base + phandler->size)) {
+			enum __mem_state new_mem_state = NONE;
+			struct ION_RTK_CARVEOUT_PAGE_INFO * find_page_info = NULL;
+			list_for_each_entry(page_info, &rtk_carveout_heap->page_handlers, list) {
+				if (page_info->pool_info == phandler && offset <= page_info->base) {
+					if (find_page_info == NULL)
+						find_page_info = page_info;
+					else if (find_page_info->base > page_info->base)
+						find_page_info = page_info;
+				}
+			}
+
+			if (find_page_info == NULL) {
+				if (offset == phandler->base) {
+					MemSize = phandler->size;
+					offset = phandler->base + phandler->size;
+				}
+
+				seq_printf(s,"       | %s : %10lu |\n",
+						(mem_state == USED) ? "used" :
+						(mem_state == FREE) ? "free" : "none",
+						MemSize);
+
+				if (offset != (phandler->base + phandler->size))
+					seq_printf(s,"       | %s : %10lu |\n",
+							(phandler->type == RTK_CARVEOUT_CMA_POOL_TYPE) ? "none" : "free",
+							(phandler->base + phandler->size) - offset);
+
+				break;
+			}
+
+			new_mem_state   = (offset == find_page_info->base) ? USED :
+				(phandler->type == RTK_CARVEOUT_CMA_POOL_TYPE) ? NONE :
+				(phandler->type == RTK_CARVEOUT_GEN_POOL_TYPE) ? FREE : NONE;
+
+			if (mem_state == NONE) {
+				mem_state   = new_mem_state;
+				MemSize	 = 0;
+			}
+
+			if (new_mem_state != mem_state) {
+				seq_printf(s,"       | %s : %10lu |\n",
+						(mem_state == USED) ? "used" :
+						(mem_state == FREE) ? "free" : "none",
+						MemSize);
+				mem_state   = new_mem_state;
+				MemSize = 0;
+			}
+
+			if (new_mem_state == USED) {
+				MemSize += find_page_info->size;
+				offset = find_page_info->base + find_page_info->size;
+			} else {
+				MemSize += find_page_info->base - offset;
+				offset = find_page_info->base;
+			}
+		}
+		seq_printf(s,"       +-------------------+ (0x%08lx)\n\n",
+				(unsigned long) phandler->base + phandler->size - 1);
+
+		mutex_unlock(&rtk_carveout_heap->pagelock);
+	}
+	mutex_unlock(&rtk_carveout_heap->poollock);
+	seq_printf(s,"\n");
+	//return ion_carveout_heap_debug_show_list(heap, s, unused);
+	return 0;
+}
+
+static struct sg_table *ion_rtk_carveout_heap_map_dma(struct ion_heap *heap,
+	struct ion_buffer *buffer)
+{
+	return buffer->priv_virt;
+}
+
+static void ion_rtk_carveout_heap_unmap_dma(struct ion_heap *heap,
+	struct ion_buffer *buffer)
+{
+	return;
+}
+
+static unsigned long ion_rtk_carveout_heap_gen_pool_algo_last_fit(unsigned long *map, unsigned long size,
+	unsigned long start, unsigned int nr, void *data)
+{
+	unsigned long start_bit	 = size;
+	unsigned long index		 = size;
+
+	if (start_bit <= nr)
+		return index;
+
+	do {
+		if (start_bit > nr) {
+			unsigned long start_bit_next = start_bit;
+			start_bit_next -= nr;
+			start_bit_next = find_next_bit(map, size, start_bit_next) - nr;
+			if (start_bit_next >= start_bit)
+				pr_err("[%s:%d] Warning! start_bit=%ld start_bit_next=%ld size=%ld nr=%d\n", __func__, __LINE__,
+						start_bit, start_bit_next, size, nr);
+			start_bit = start_bit_next;
+		} else
+			start_bit -= 1;
+
+		index = bitmap_find_next_zero_area(map, size, start_bit, nr, 0);
+
+		if (start_bit <= 0)
+			break;
+
+	}while(index >= size);
+
+	return index;
+}
+
+static unsigned long ion_rtk_carveout_heap_gen_pool_algo(unsigned long *map, unsigned long size,
+	unsigned long start, unsigned int nr, void *data)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap = (struct ion_rtk_carveout_heap *) data;
+
+	if (rtk_carveout_heap != NULL) {
+		switch (rtk_carveout_heap->algo_mode) {
+			case ALGO_FIRST_FIT:
+				return gen_pool_first_fit(map, size, start, nr, data, NULL);
+			case ALGO_LAST_FIT:
+				return ion_rtk_carveout_heap_gen_pool_algo_last_fit(map, size, start, nr, data);
+			default:
+				break;
+		}
+	}
+
+	pr_err(	 "[%s] Warning: rtk_carveout_heap=%p", __func__, rtk_carveout_heap);
+	if (rtk_carveout_heap != NULL)
+		pr_err( " algo_mode=0x%x", rtk_carveout_heap->algo_mode);
+	pr_err(	 " size=%ld start=%ld, nr=%d\n", size, start, nr);
+	return gen_pool_first_fit(map, size, start, nr, data, NULL);
+
+}
+
+static struct ion_heap_ops rtk_carveout_heap_ops = {
+	.allocate = ion_rtk_carveout_heap_allocate,
+	.free = ion_rtk_carveout_heap_free,
+	.phys = ion_rtk_carveout_heap_phys,
+	.map_dma = ion_rtk_carveout_heap_map_dma,
+	.unmap_dma = ion_rtk_carveout_heap_unmap_dma,
+	.map_user = ion_heap_map_user,
+	.map_kernel = ion_heap_map_kernel,
+	.unmap_kernel = ion_heap_unmap_kernel,
+};
+
+struct ion_heap *ion_rtk_carveout_heap_create(struct ion_platform_heap *heap_data)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap;
+	struct list_head * pool_list = (struct list_head *) heap_data->priv;
+	struct ion_rtk_priv_pool * pool;
+	struct ION_RTK_CARVEOUT_POOL_INFO * phandler = NULL;
+	struct gen_pool *gpool;
+	struct page * page;
+	int ret = 0;
+
+	if (!pool_list) {
+		printk("[%s] pool_list is NULL!!!!\n",__func__);
+		return ERR_PTR(-ENOMEM);
+	}
+
+	rtk_carveout_heap = kzalloc(sizeof(struct ion_rtk_carveout_heap), GFP_KERNEL);
+
+	if (!rtk_carveout_heap)
+		return ERR_PTR(-ENOMEM);
+
+	mutex_init(&rtk_carveout_heap->poollock);
+	mutex_init(&rtk_carveout_heap->pagelock);
+
+	INIT_LIST_HEAD(&rtk_carveout_heap->pool_handlers);
+	INIT_LIST_HEAD(&rtk_carveout_heap->page_handlers);
+
+	list_for_each_entry(pool, pool_list, list) {
+		phandler = kzalloc(sizeof(struct ION_RTK_CARVEOUT_POOL_INFO), GFP_KERNEL);
+
+		if (pool->type == RTK_CARVEOUT_GEN_POOL_TYPE) {
+			page = pfn_to_page(PFN_DOWN(pool->base));
+			if (pool->flags & RTK_FLAG_SCPUACC) {
+				ion_pages_sync_for_device(NULL, page, pool->size, DMA_BIDIRECTIONAL);
+				ret = ion_heap_pages_zero(page, pool->size, pgprot_writecombine(PAGE_KERNEL));
+			}
+			if (ret)
+				goto ERROR;
+			gpool = gen_pool_create(PAGE_SHIFT, -1);
+			if (!gpool) {
+				printk("[%s] gen_pool_create failed! \n",__func__);
+				ret = -ENOMEM;
+				goto ERROR;
+			}
+
+			gen_pool_set_algo(gpool, (genpool_algo_t ) ion_rtk_carveout_heap_gen_pool_algo, (void *)rtk_carveout_heap);
+
+			gen_pool_add(gpool, pool->base, pool->size, -1);
+			phandler->gpool = gpool;
+		} else if (pool->type == RTK_CARVEOUT_CMA_POOL_TYPE) {
+			phandler->cpool = pool->cma_pool;
+			if (!phandler->cpool) {
+				kfree(phandler);
+				phandler = NULL;
+				continue;
+			}
+		}
+
+		phandler->type = pool->type;
+		phandler->base = pool->base;
+		phandler->size = pool->size;
+		phandler->flags = pool->flags;
+
+		mutex_lock(&rtk_carveout_heap->poollock);
+		list_add(&phandler->list, &rtk_carveout_heap->pool_handlers);
+		mutex_unlock(&rtk_carveout_heap->poollock);
+	}
+
+	rtk_carveout_heap->heap.ops = &rtk_carveout_heap_ops;
+	rtk_carveout_heap->heap.type = ION_HEAP_TYPE_CARVEOUT;
+	rtk_carveout_heap->heap.flags = 0;//ION_HEAP_FLAG_DEFER_FREE;
+	rtk_carveout_heap->heap.debug_show = ion_carveout_heap_debug_show;
+	rtk_carveout_heap->priv_ops = &rtk_carveout_heap_priv_ops;
+	rtk_carveout_heap->version  = sizeof(*rtk_carveout_heap);
+
+	//ion_rtk_carveout_show_list(&rtk_carveout_heap->heap);
+	return &rtk_carveout_heap->heap;
+
+ERROR:
+	if (phandler)
+		kfree(phandler);
+	kfree(rtk_carveout_heap);
+	return ERR_PTR(ret);
+}
+
+void ion_rtk_carveout_heap_destroy(struct ion_heap *heap)
+{
+	struct ion_rtk_carveout_heap *rtk_carveout_heap =
+		 container_of(heap, struct  ion_rtk_carveout_heap, heap);
+
+	struct ION_RTK_CARVEOUT_PAGE_INFO * page_info, * tmp_page_info;
+
+	struct ION_RTK_CARVEOUT_POOL_INFO * phandler, * tmp_phandler;
+
+	ion_rtk_carveout_show_list(heap);
+
+	mutex_lock(&rtk_carveout_heap->pagelock);
+	list_for_each_entry_safe(page_info,  tmp_page_info, &rtk_carveout_heap->page_handlers, list) {
+		if (page_info->pool_info->type == RTK_CARVEOUT_GEN_POOL_TYPE)
+			gen_pool_free(page_info->pool_info->gpool, page_info->base, page_info->size);
+		else if (page_info->pool_info->type == RTK_CARVEOUT_CMA_POOL_TYPE)
+			cma_release(page_info->pool_info->cpool, page_info->page, page_info->size>>PAGE_SHIFT);
+		list_del(&page_info->list);
+		kfree(page_info);
+	}
+	mutex_unlock(&rtk_carveout_heap->pagelock);
+
+	mutex_lock(&rtk_carveout_heap->poollock);
+	list_for_each_entry_safe(phandler, tmp_phandler, &rtk_carveout_heap->pool_handlers, list) {
+		if (phandler->type == RTK_CARVEOUT_GEN_POOL_TYPE)
+			gen_pool_destroy(phandler->gpool);
+		else if (phandler->type == RTK_CARVEOUT_CMA_POOL_TYPE) {
+			// nothing to do
+		}
+		list_del(&phandler->list);
+		kfree(phandler);
+	}
+	mutex_unlock(&rtk_carveout_heap->poollock);
+
+	kfree(rtk_carveout_heap);
+	rtk_carveout_heap = NULL;
+}
+
+
+#ifdef CONFIG_SYSFS
+
+#define ION_RTK_CARVEOUT_ATTR(_name) \
+{ \
+	.attr = {.name = #_name, .mode = 0644}, \
+	.show =  ion_rtk_##_name##_show, \
+	.store = ion_rtk_##_name##_store, \
+}
+
+static ssize_t ion_rtk_cached_turbo_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+	int n = 0;
+	n += sprintf(buf+n,"Cached Turbo  : %d\n", cached_turbo);
+	return n;
+}
+
+static ssize_t ion_rtk_cached_turbo_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+	if (ret < 0)
+		return -ENOMEM;
+	cached_turbo = (val == 0)?false:true;
+	return count;
+}
+
+static struct kobj_attribute ion_rtk_cached_turbo_attr = ION_RTK_CARVEOUT_ATTR(cached_turbo);
+
+
+static struct attribute *ion_rtk_attrs[] = {
+	&ion_rtk_cached_turbo_attr.attr,
+	NULL,
+};
+
+static struct attribute_group ion_rtk_attr_group = {
+	.attrs = ion_rtk_attrs,
+};
+
+static struct kobject *ion_rtk_kobj;
+
+static int __init ion_rtk_sysfs_init(void)
+{
+	int ret;
+
+	ion_rtk_kobj = kobject_create_and_add("ion", kernel_kobj);
+	if (!ion_rtk_kobj)
+		return -ENOMEM;
+	ret = sysfs_create_group(ion_rtk_kobj, &ion_rtk_attr_group);
+	if (ret)
+		kobject_put(ion_rtk_kobj);
+	return ret;
+}
+
+module_init(ion_rtk_sysfs_init)
+#endif /* End of CONFIG_SYSFS */
diff --git a/drivers/staging/android/ion/realtek/ion_rtk_carveout_heap.h b/drivers/staging/android/ion/realtek/ion_rtk_carveout_heap.h
new file mode 100644
index 00000000..3b6456e
--- /dev/null
+++ b/drivers/staging/android/ion/realtek/ion_rtk_carveout_heap.h
@@ -0,0 +1,38 @@
+#ifndef _LINUX_ION_RTK_CARVEOUT_HEAP_H
+#define _LINUX_ION_RTK_CARVEOUT_HEAP_H
+
+#include "../ion.h"
+#include "../ion_priv.h"
+#include "../../uapi/ion_rtk.h"
+#include "soc/realtek/memory.h"
+
+enum ion_rtk_carveout_pool_type {
+    RTK_CARVEOUT_GEN_POOL_TYPE = 0,
+    RTK_CARVEOUT_CMA_POOL_TYPE,
+};
+
+struct ion_rtk_priv_pool {
+    enum ion_rtk_carveout_pool_type type;
+    ion_phys_addr_t base;
+    struct cma * cma_pool;
+    size_t size;
+    unsigned long flags;
+    struct list_head list;
+};
+
+struct ion_rtk_carveout_meminfo {
+    unsigned long usedSize;
+    unsigned long freeSize;
+};
+
+struct ion_rtk_carveout_ops {
+    unsigned int (*getVersion) (struct ion_heap * heap);
+    int          (*getMemInfo) (struct ion_heap * heap, unsigned int flags, struct ion_rtk_carveout_meminfo * info);
+};
+
+struct ion_heap *   ion_rtk_carveout_heap_create    (struct ion_platform_heap *);
+void                ion_rtk_carveout_heap_destroy   (struct ion_heap *);
+
+struct ion_rtk_carveout_ops * get_rtk_carveout_ops  (struct ion_heap * heap);
+
+#endif /* End of _LINUX_ION_RTK_CARVEOUT_HEAP_H */
diff --git a/drivers/staging/android/logger.c b/drivers/staging/android/logger.c
new file mode 100644
index 00000000..90517cf
--- /dev/null
+++ b/drivers/staging/android/logger.c
@@ -0,0 +1,809 @@
+/*
+ * drivers/misc/logger.c
+ *
+ * A Logging Subsystem
+ *
+ * Copyright (C) 2007-2008 Google, Inc.
+ *
+ * Robert Love <rlove@google.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#define pr_fmt(fmt) "logger: " fmt
+
+#include <linux/sched.h>
+#include <linux/module.h>
+#include <linux/fs.h>
+#include <linux/miscdevice.h>
+#include <linux/uaccess.h>
+#include <linux/poll.h>
+#include <linux/slab.h>
+#include <linux/time.h>
+#include <linux/vmalloc.h>
+#include <linux/aio.h>
+#include <linux/uio.h>
+#include "logger.h"
+
+#include <asm/ioctls.h>
+
+/**
+ * struct logger_log - represents a specific log, such as 'main' or 'radio'
+ * @buffer:	The actual ring buffer
+ * @misc:	The "misc" device representing the log
+ * @wq:		The wait queue for @readers
+ * @readers:	This log's readers
+ * @mutex:	The mutex that protects the @buffer
+ * @w_off:	The current write head offset
+ * @head:	The head, or location that readers start reading at.
+ * @size:	The size of the log
+ * @logs:	The list of log channels
+ *
+ * This structure lives from module insertion until module removal, so it does
+ * not need additional reference counting. The structure is protected by the
+ * mutex 'mutex'.
+ */
+struct logger_log {
+	unsigned char		*buffer;
+	struct miscdevice	misc;
+	wait_queue_head_t	wq;
+	struct list_head	readers;
+	struct mutex		mutex;
+	size_t			w_off;
+	size_t			head;
+	size_t			size;
+	struct list_head	logs;
+};
+
+static LIST_HEAD(log_list);
+
+
+/**
+ * struct logger_reader - a logging device open for reading
+ * @log:	The associated log
+ * @list:	The associated entry in @logger_log's list
+ * @r_off:	The current read head offset.
+ * @r_all:	Reader can read all entries
+ * @r_ver:	Reader ABI version
+ *
+ * This object lives from open to release, so we don't need additional
+ * reference counting. The structure is protected by log->mutex.
+ */
+struct logger_reader {
+	struct logger_log	*log;
+	struct list_head	list;
+	size_t			r_off;
+	bool			r_all;
+	int			r_ver;
+};
+
+/* logger_offset - returns index 'n' into the log via (optimized) modulus */
+static size_t logger_offset(struct logger_log *log, size_t n)
+{
+	return n & (log->size - 1);
+}
+
+
+/*
+ * file_get_log - Given a file structure, return the associated log
+ *
+ * This isn't aesthetic. We have several goals:
+ *
+ *	1) Need to quickly obtain the associated log during an I/O operation
+ *	2) Readers need to maintain state (logger_reader)
+ *	3) Writers need to be very fast (open() should be a near no-op)
+ *
+ * In the reader case, we can trivially go file->logger_reader->logger_log.
+ * For a writer, we don't want to maintain a logger_reader, so we just go
+ * file->logger_log. Thus what file->private_data points at depends on whether
+ * or not the file was opened for reading. This function hides that dirtiness.
+ */
+static inline struct logger_log *file_get_log(struct file *file)
+{
+	if (file->f_mode & FMODE_READ) {
+		struct logger_reader *reader = file->private_data;
+
+		return reader->log;
+	}
+	return file->private_data;
+}
+
+/*
+ * get_entry_header - returns a pointer to the logger_entry header within
+ * 'log' starting at offset 'off'. A temporary logger_entry 'scratch' must
+ * be provided. Typically the return value will be a pointer within
+ * 'logger->buf'.  However, a pointer to 'scratch' may be returned if
+ * the log entry spans the end and beginning of the circular buffer.
+ */
+static struct logger_entry *get_entry_header(struct logger_log *log,
+		size_t off, struct logger_entry *scratch)
+{
+	size_t len = min(sizeof(struct logger_entry), log->size - off);
+
+	if (len != sizeof(struct logger_entry)) {
+		memcpy(((void *) scratch), log->buffer + off, len);
+		memcpy(((void *) scratch) + len, log->buffer,
+			sizeof(struct logger_entry) - len);
+		return scratch;
+	}
+
+	return (struct logger_entry *) (log->buffer + off);
+}
+
+/*
+ * get_entry_msg_len - Grabs the length of the message of the entry
+ * starting from from 'off'.
+ *
+ * An entry length is 2 bytes (16 bits) in host endian order.
+ * In the log, the length does not include the size of the log entry structure.
+ * This function returns the size including the log entry structure.
+ *
+ * Caller needs to hold log->mutex.
+ */
+static __u32 get_entry_msg_len(struct logger_log *log, size_t off)
+{
+	struct logger_entry scratch;
+	struct logger_entry *entry;
+
+	entry = get_entry_header(log, off, &scratch);
+	return entry->len;
+}
+
+static size_t get_user_hdr_len(int ver)
+{
+	if (ver < 2)
+		return sizeof(struct user_logger_entry_compat);
+	return sizeof(struct logger_entry);
+}
+
+static ssize_t copy_header_to_user(int ver, struct logger_entry *entry,
+					 char __user *buf)
+{
+	void *hdr;
+	size_t hdr_len;
+	struct user_logger_entry_compat v1;
+
+	if (ver < 2) {
+		v1.len      = entry->len;
+		v1.__pad    = 0;
+		v1.pid      = entry->pid;
+		v1.tid      = entry->tid;
+		v1.sec      = entry->sec;
+		v1.nsec     = entry->nsec;
+		hdr         = &v1;
+		hdr_len     = sizeof(struct user_logger_entry_compat);
+	} else {
+		hdr         = entry;
+		hdr_len     = sizeof(struct logger_entry);
+	}
+
+	return copy_to_user(buf, hdr, hdr_len);
+}
+
+/*
+ * do_read_log_to_user - reads exactly 'count' bytes from 'log' into the
+ * user-space buffer 'buf'. Returns 'count' on success.
+ *
+ * Caller must hold log->mutex.
+ */
+static ssize_t do_read_log_to_user(struct logger_log *log,
+				   struct logger_reader *reader,
+				   char __user *buf,
+				   size_t count)
+{
+	struct logger_entry scratch;
+	struct logger_entry *entry;
+	size_t len;
+	size_t msg_start;
+
+	/*
+	 * First, copy the header to userspace, using the version of
+	 * the header requested
+	 */
+	entry = get_entry_header(log, reader->r_off, &scratch);
+	if (copy_header_to_user(reader->r_ver, entry, buf))
+		return -EFAULT;
+
+	count -= get_user_hdr_len(reader->r_ver);
+	buf += get_user_hdr_len(reader->r_ver);
+	msg_start = logger_offset(log,
+		reader->r_off + sizeof(struct logger_entry));
+
+	/*
+	 * We read from the msg in two disjoint operations. First, we read from
+	 * the current msg head offset up to 'count' bytes or to the end of
+	 * the log, whichever comes first.
+	 */
+	len = min(count, log->size - msg_start);
+	if (copy_to_user(buf, log->buffer + msg_start, len))
+		return -EFAULT;
+
+	/*
+	 * Second, we read any remaining bytes, starting back at the head of
+	 * the log.
+	 */
+	if (count != len)
+		if (copy_to_user(buf + len, log->buffer, count - len))
+			return -EFAULT;
+
+	reader->r_off = logger_offset(log, reader->r_off +
+		sizeof(struct logger_entry) + count);
+
+	return count + get_user_hdr_len(reader->r_ver);
+}
+
+/*
+ * get_next_entry_by_uid - Starting at 'off', returns an offset into
+ * 'log->buffer' which contains the first entry readable by 'euid'
+ */
+static size_t get_next_entry_by_uid(struct logger_log *log,
+		size_t off, kuid_t euid)
+{
+	while (off != log->w_off) {
+		struct logger_entry *entry;
+		struct logger_entry scratch;
+		size_t next_len;
+
+		entry = get_entry_header(log, off, &scratch);
+
+		if (uid_eq(entry->euid, euid))
+			return off;
+
+		next_len = sizeof(struct logger_entry) + entry->len;
+		off = logger_offset(log, off + next_len);
+	}
+
+	return off;
+}
+
+/*
+ * logger_read - our log's read() method
+ *
+ * Behavior:
+ *
+ *	- O_NONBLOCK works
+ *	- If there are no log entries to read, blocks until log is written to
+ *	- Atomically reads exactly one log entry
+ *
+ * Will set errno to EINVAL if read
+ * buffer is insufficient to hold next entry.
+ */
+static ssize_t logger_read(struct file *file, char __user *buf,
+			   size_t count, loff_t *pos)
+{
+	struct logger_reader *reader = file->private_data;
+	struct logger_log *log = reader->log;
+	ssize_t ret;
+	DEFINE_WAIT(wait);
+
+start:
+	while (1) {
+		mutex_lock(&log->mutex);
+
+		prepare_to_wait(&log->wq, &wait, TASK_INTERRUPTIBLE);
+
+		ret = (log->w_off == reader->r_off);
+		mutex_unlock(&log->mutex);
+		if (!ret)
+			break;
+
+		if (file->f_flags & O_NONBLOCK) {
+			ret = -EAGAIN;
+			break;
+		}
+
+		if (signal_pending(current)) {
+			ret = -EINTR;
+			break;
+		}
+
+		schedule();
+	}
+
+	finish_wait(&log->wq, &wait);
+	if (ret)
+		return ret;
+
+	mutex_lock(&log->mutex);
+
+	if (!reader->r_all)
+		reader->r_off = get_next_entry_by_uid(log,
+			reader->r_off, current_euid());
+
+	/* is there still something to read or did we race? */
+	if (unlikely(log->w_off == reader->r_off)) {
+		mutex_unlock(&log->mutex);
+		goto start;
+	}
+
+	/* get the size of the next entry */
+	ret = get_user_hdr_len(reader->r_ver) +
+		get_entry_msg_len(log, reader->r_off);
+	if (count < ret) {
+		ret = -EINVAL;
+		goto out;
+	}
+
+	/* get exactly one entry from the log */
+	ret = do_read_log_to_user(log, reader, buf, ret);
+
+out:
+	mutex_unlock(&log->mutex);
+
+	return ret;
+}
+
+/*
+ * get_next_entry - return the offset of the first valid entry at least 'len'
+ * bytes after 'off'.
+ *
+ * Caller must hold log->mutex.
+ */
+static size_t get_next_entry(struct logger_log *log, size_t off, size_t len)
+{
+	size_t count = 0;
+
+	do {
+		size_t nr = sizeof(struct logger_entry) +
+			get_entry_msg_len(log, off);
+		off = logger_offset(log, off + nr);
+		count += nr;
+	} while (count < len);
+
+	return off;
+}
+
+/*
+ * is_between - is a < c < b, accounting for wrapping of a, b, and c
+ *    positions in the buffer
+ *
+ * That is, if a<b, check for c between a and b
+ * and if a>b, check for c outside (not between) a and b
+ *
+ * |------- a xxxxxxxx b --------|
+ *               c^
+ *
+ * |xxxxx b --------- a xxxxxxxxx|
+ *    c^
+ *  or                    c^
+ */
+static inline int is_between(size_t a, size_t b, size_t c)
+{
+	if (a < b) {
+		/* is c between a and b? */
+		if (a < c && c <= b)
+			return 1;
+	} else {
+		/* is c outside of b through a? */
+		if (c <= b || a < c)
+			return 1;
+	}
+
+	return 0;
+}
+
+/*
+ * fix_up_readers - walk the list of all readers and "fix up" any who were
+ * lapped by the writer; also do the same for the default "start head".
+ * We do this by "pulling forward" the readers and start head to the first
+ * entry after the new write head.
+ *
+ * The caller needs to hold log->mutex.
+ */
+static void fix_up_readers(struct logger_log *log, size_t len)
+{
+	size_t old = log->w_off;
+	size_t new = logger_offset(log, old + len);
+	struct logger_reader *reader;
+
+	if (is_between(old, new, log->head))
+		log->head = get_next_entry(log, log->head, len);
+
+	list_for_each_entry(reader, &log->readers, list)
+		if (is_between(old, new, reader->r_off))
+			reader->r_off = get_next_entry(log, reader->r_off, len);
+}
+
+/*
+ * logger_write_iter - our write method, implementing support for write(),
+ * writev(), and aio_write(). Writes are our fast path, and we try to optimize
+ * them above all else.
+ */
+static ssize_t logger_write_iter(struct kiocb *iocb, struct iov_iter *from)
+{
+	struct logger_log *log = file_get_log(iocb->ki_filp);
+	struct logger_entry header;
+	struct timespec now;
+	size_t len, count, w_off;
+
+	count = min_t(size_t, iov_iter_count(from), LOGGER_ENTRY_MAX_PAYLOAD);
+
+	now = current_kernel_time();
+
+	header.pid = current->tgid;
+	header.tid = current->pid;
+	header.sec = now.tv_sec;
+	header.nsec = now.tv_nsec;
+	header.euid = current_euid();
+	header.len = count;
+	header.hdr_size = sizeof(struct logger_entry);
+
+	/* null writes succeed, return zero */
+	if (unlikely(!header.len))
+		return 0;
+
+	mutex_lock(&log->mutex);
+
+	/*
+	 * Fix up any readers, pulling them forward to the first readable
+	 * entry after (what will be) the new write offset. We do this now
+	 * because if we partially fail, we can end up with clobbered log
+	 * entries that encroach on readable buffer.
+	 */
+	fix_up_readers(log, sizeof(struct logger_entry) + header.len);
+
+	len = min(sizeof(header), log->size - log->w_off);
+	memcpy(log->buffer + log->w_off, &header, len);
+	memcpy(log->buffer, (char *)&header + len, sizeof(header) - len);
+
+	/* Work with a copy until we are ready to commit the whole entry */
+	w_off =  logger_offset(log, log->w_off + sizeof(struct logger_entry));
+
+	len = min(count, log->size - w_off);
+
+	if (copy_from_iter(log->buffer + w_off, len, from) != len) {
+		/*
+		 * Note that by not updating log->w_off, this abandons the
+		 * portion of the new entry that *was* successfully
+		 * copied, just above.  This is intentional to avoid
+		 * message corruption from missing fragments.
+		 */
+		mutex_unlock(&log->mutex);
+		return -EFAULT;
+	}
+
+	if (copy_from_iter(log->buffer, count - len, from) != count - len) {
+		mutex_unlock(&log->mutex);
+		return -EFAULT;
+	}
+
+	log->w_off = logger_offset(log, w_off + count);
+	mutex_unlock(&log->mutex);
+
+	/* wake up any blocked readers */
+	wake_up_interruptible(&log->wq);
+
+	return len;
+}
+
+static struct logger_log *get_log_from_minor(int minor)
+{
+	struct logger_log *log;
+
+	list_for_each_entry(log, &log_list, logs)
+		if (log->misc.minor == minor)
+			return log;
+	return NULL;
+}
+
+/*
+ * logger_open - the log's open() file operation
+ *
+ * Note how near a no-op this is in the write-only case. Keep it that way!
+ */
+static int logger_open(struct inode *inode, struct file *file)
+{
+	struct logger_log *log;
+	int ret;
+
+	ret = nonseekable_open(inode, file);
+	if (ret)
+		return ret;
+
+	log = get_log_from_minor(MINOR(inode->i_rdev));
+	if (!log)
+		return -ENODEV;
+
+	if (file->f_mode & FMODE_READ) {
+		struct logger_reader *reader;
+
+		reader = kmalloc(sizeof(struct logger_reader), GFP_KERNEL);
+		if (!reader)
+			return -ENOMEM;
+
+		reader->log = log;
+		reader->r_ver = 1;
+		reader->r_all = in_egroup_p(inode->i_gid) ||
+			capable(CAP_SYSLOG);
+
+		INIT_LIST_HEAD(&reader->list);
+
+		mutex_lock(&log->mutex);
+		reader->r_off = log->head;
+		list_add_tail(&reader->list, &log->readers);
+		mutex_unlock(&log->mutex);
+
+		file->private_data = reader;
+	} else
+		file->private_data = log;
+
+	return 0;
+}
+
+/*
+ * logger_release - the log's release file operation
+ *
+ * Note this is a total no-op in the write-only case. Keep it that way!
+ */
+static int logger_release(struct inode *ignored, struct file *file)
+{
+	if (file->f_mode & FMODE_READ) {
+		struct logger_reader *reader = file->private_data;
+		struct logger_log *log = reader->log;
+
+		mutex_lock(&log->mutex);
+		list_del(&reader->list);
+		mutex_unlock(&log->mutex);
+
+		kfree(reader);
+	}
+
+	return 0;
+}
+
+/*
+ * logger_poll - the log's poll file operation, for poll/select/epoll
+ *
+ * Note we always return POLLOUT, because you can always write() to the log.
+ * Note also that, strictly speaking, a return value of POLLIN does not
+ * guarantee that the log is readable without blocking, as there is a small
+ * chance that the writer can lap the reader in the interim between poll()
+ * returning and the read() request.
+ */
+static unsigned int logger_poll(struct file *file, poll_table *wait)
+{
+	struct logger_reader *reader;
+	struct logger_log *log;
+	unsigned int ret = POLLOUT | POLLWRNORM;
+
+	if (!(file->f_mode & FMODE_READ))
+		return ret;
+
+	reader = file->private_data;
+	log = reader->log;
+
+	poll_wait(file, &log->wq, wait);
+
+	mutex_lock(&log->mutex);
+	if (!reader->r_all)
+		reader->r_off = get_next_entry_by_uid(log,
+			reader->r_off, current_euid());
+
+	if (log->w_off != reader->r_off)
+		ret |= POLLIN | POLLRDNORM;
+	mutex_unlock(&log->mutex);
+
+	return ret;
+}
+
+static long logger_set_version(struct logger_reader *reader, void __user *arg)
+{
+	int version;
+
+	if (copy_from_user(&version, arg, sizeof(int)))
+		return -EFAULT;
+
+	if ((version < 1) || (version > 2))
+		return -EINVAL;
+
+	reader->r_ver = version;
+	return 0;
+}
+
+static long logger_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+{
+	struct logger_log *log = file_get_log(file);
+	struct logger_reader *reader;
+	long ret = -EINVAL;
+	void __user *argp = (void __user *) arg;
+
+	mutex_lock(&log->mutex);
+
+	switch (cmd) {
+	case LOGGER_GET_LOG_BUF_SIZE:
+		ret = log->size;
+		break;
+	case LOGGER_GET_LOG_LEN:
+		if (!(file->f_mode & FMODE_READ)) {
+			ret = -EBADF;
+			break;
+		}
+		reader = file->private_data;
+		if (log->w_off >= reader->r_off)
+			ret = log->w_off - reader->r_off;
+		else
+			ret = (log->size - reader->r_off) + log->w_off;
+		break;
+	case LOGGER_GET_NEXT_ENTRY_LEN:
+		if (!(file->f_mode & FMODE_READ)) {
+			ret = -EBADF;
+			break;
+		}
+		reader = file->private_data;
+
+		if (!reader->r_all)
+			reader->r_off = get_next_entry_by_uid(log,
+				reader->r_off, current_euid());
+
+		if (log->w_off != reader->r_off)
+			ret = get_user_hdr_len(reader->r_ver) +
+				get_entry_msg_len(log, reader->r_off);
+		else
+			ret = 0;
+		break;
+	case LOGGER_FLUSH_LOG:
+		if (!(file->f_mode & FMODE_WRITE)) {
+			ret = -EBADF;
+			break;
+		}
+		if (!(in_egroup_p(file_inode(file)->i_gid) ||
+				capable(CAP_SYSLOG))) {
+			ret = -EPERM;
+			break;
+		}
+		list_for_each_entry(reader, &log->readers, list)
+			reader->r_off = log->w_off;
+		log->head = log->w_off;
+		ret = 0;
+		break;
+	case LOGGER_GET_VERSION:
+		if (!(file->f_mode & FMODE_READ)) {
+			ret = -EBADF;
+			break;
+		}
+		reader = file->private_data;
+		ret = reader->r_ver;
+		break;
+	case LOGGER_SET_VERSION:
+		if (!(file->f_mode & FMODE_READ)) {
+			ret = -EBADF;
+			break;
+		}
+		reader = file->private_data;
+		ret = logger_set_version(reader, argp);
+		break;
+	}
+
+	mutex_unlock(&log->mutex);
+
+	return ret;
+}
+
+static const struct file_operations logger_fops = {
+	.owner = THIS_MODULE,
+	.read = logger_read,
+	.write_iter = logger_write_iter,
+	.poll = logger_poll,
+	.unlocked_ioctl = logger_ioctl,
+	.compat_ioctl = logger_ioctl,
+	.open = logger_open,
+	.release = logger_release,
+};
+
+/*
+ * Log size must must be a power of two, and greater than
+ * (LOGGER_ENTRY_MAX_PAYLOAD + sizeof(struct logger_entry)).
+ */
+static int __init create_log(char *log_name, int size)
+{
+	int ret = 0;
+	struct logger_log *log;
+	unsigned char *buffer;
+
+	buffer = vmalloc(size);
+	if (buffer == NULL)
+		return -ENOMEM;
+
+	log = kzalloc(sizeof(struct logger_log), GFP_KERNEL);
+	if (log == NULL) {
+		ret = -ENOMEM;
+		goto out_free_buffer;
+	}
+	log->buffer = buffer;
+
+	log->misc.minor = MISC_DYNAMIC_MINOR;
+	log->misc.name = kstrdup(log_name, GFP_KERNEL);
+	if (log->misc.name == NULL) {
+		ret = -ENOMEM;
+		goto out_free_log;
+	}
+
+	log->misc.fops = &logger_fops;
+	log->misc.parent = NULL;
+
+	init_waitqueue_head(&log->wq);
+	INIT_LIST_HEAD(&log->readers);
+	mutex_init(&log->mutex);
+	log->w_off = 0;
+	log->head = 0;
+	log->size = size;
+
+	INIT_LIST_HEAD(&log->logs);
+	list_add_tail(&log->logs, &log_list);
+
+	/* finally, initialize the misc device for this log */
+	ret = misc_register(&log->misc);
+	if (unlikely(ret)) {
+		pr_err("failed to register misc device for log '%s'!\n",
+				log->misc.name);
+		goto out_free_misc_name;
+	}
+
+	pr_info("created %luK log '%s'\n",
+		(unsigned long) log->size >> 10, log->misc.name);
+
+	return 0;
+
+out_free_misc_name:
+	kfree(log->misc.name);
+
+out_free_log:
+	kfree(log);
+
+out_free_buffer:
+	vfree(buffer);
+	return ret;
+}
+
+static int __init logger_init(void)
+{
+	int ret;
+
+	ret = create_log(LOGGER_LOG_MAIN, 256*1024);
+	if (unlikely(ret))
+		goto out;
+
+	ret = create_log(LOGGER_LOG_EVENTS, 256*1024);
+	if (unlikely(ret))
+		goto out;
+
+	ret = create_log(LOGGER_LOG_RADIO, 256*1024);
+	if (unlikely(ret))
+		goto out;
+
+	ret = create_log(LOGGER_LOG_SYSTEM, 256*1024);
+	if (unlikely(ret))
+		goto out;
+
+out:
+	return ret;
+}
+
+static void __exit logger_exit(void)
+{
+	struct logger_log *current_log, *next_log;
+
+	list_for_each_entry_safe(current_log, next_log, &log_list, logs) {
+		/* we have to delete all the entry inside log_list */
+		misc_deregister(&current_log->misc);
+		vfree(current_log->buffer);
+		kfree(current_log->misc.name);
+		list_del(&current_log->logs);
+		kfree(current_log);
+	}
+}
+
+
+device_initcall(logger_init);
+module_exit(logger_exit);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Robert Love, <rlove@google.com>");
+MODULE_DESCRIPTION("Android Logger");
diff --git a/drivers/staging/android/logger.h b/drivers/staging/android/logger.h
new file mode 100644
index 00000000..70af7d8
--- /dev/null
+++ b/drivers/staging/android/logger.h
@@ -0,0 +1,89 @@
+/* include/linux/logger.h
+ *
+ * Copyright (C) 2007-2008 Google, Inc.
+ * Author: Robert Love <rlove@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_LOGGER_H
+#define _LINUX_LOGGER_H
+
+#include <linux/types.h>
+#include <linux/ioctl.h>
+
+/**
+ * struct user_logger_entry_compat - defines a single entry that is given to a logger
+ * @len:	The length of the payload
+ * @__pad:	Two bytes of padding that appear to be required
+ * @pid:	The generating process' process ID
+ * @tid:	The generating process' thread ID
+ * @sec:	The number of seconds that have elapsed since the Epoch
+ * @nsec:	The number of nanoseconds that have elapsed since @sec
+ * @msg:	The message that is to be logged
+ *
+ * The userspace structure for version 1 of the logger_entry ABI.
+ * This structure is returned to userspace unless the caller requests
+ * an upgrade to a newer ABI version.
+ */
+struct user_logger_entry_compat {
+	__u16		len;
+	__u16		__pad;
+	__s32		pid;
+	__s32		tid;
+	__s32		sec;
+	__s32		nsec;
+	char		msg[0];
+};
+
+/**
+ * struct logger_entry - defines a single entry that is given to a logger
+ * @len:	The length of the payload
+ * @hdr_size:	sizeof(struct logger_entry_v2)
+ * @pid:	The generating process' process ID
+ * @tid:	The generating process' thread ID
+ * @sec:	The number of seconds that have elapsed since the Epoch
+ * @nsec:	The number of nanoseconds that have elapsed since @sec
+ * @euid:	Effective UID of logger
+ * @msg:	The message that is to be logged
+ *
+ * The structure for version 2 of the logger_entry ABI.
+ * This structure is returned to userspace if ioctl(LOGGER_SET_VERSION)
+ * is called with version >= 2
+ */
+struct logger_entry {
+	__u16		len;
+	__u16		hdr_size;
+	__s32		pid;
+	__s32		tid;
+	__s32		sec;
+	__s32		nsec;
+	kuid_t		euid;
+	char		msg[0];
+};
+
+#define LOGGER_LOG_RADIO	"log_radio"	/* radio-related messages */
+#define LOGGER_LOG_EVENTS	"log_events"	/* system/hardware events */
+#define LOGGER_LOG_SYSTEM	"log_system"	/* system/framework messages */
+#define LOGGER_LOG_MAIN		"log_main"	/* everything else */
+
+#define LOGGER_ENTRY_MAX_PAYLOAD	4076
+
+#define __LOGGERIO	0xAE
+
+#define LOGGER_GET_LOG_BUF_SIZE		_IO(__LOGGERIO, 1) /* size of log */
+#define LOGGER_GET_LOG_LEN		_IO(__LOGGERIO, 2) /* used log len */
+#define LOGGER_GET_NEXT_ENTRY_LEN	_IO(__LOGGERIO, 3) /* next entry len */
+#define LOGGER_FLUSH_LOG		_IO(__LOGGERIO, 4) /* flush log */
+#define LOGGER_GET_VERSION		_IO(__LOGGERIO, 5) /* abi version */
+#define LOGGER_SET_VERSION		_IO(__LOGGERIO, 6) /* abi version */
+
+#endif /* _LINUX_LOGGER_H */
diff --git a/drivers/staging/android/lowmemorykiller.c b/drivers/staging/android/lowmemorykiller.c
index ec3b665..687be36 100644
--- a/drivers/staging/android/lowmemorykiller.c
+++ b/drivers/staging/android/lowmemorykiller.c
@@ -43,6 +43,9 @@
 #include <linux/profile.h>
 #include <linux/notifier.h>
 
+#define CREATE_TRACE_POINTS
+#include "trace/lowmemorykiller.h"
+
 static u32 lowmem_debug_level = 1;
 static short lowmem_adj[6] = {
 	0,
@@ -93,6 +96,7 @@ static unsigned long lowmem_scan(struct shrinker *s, struct shrink_control *sc)
 	int other_free = global_page_state(NR_FREE_PAGES) - totalreserve_pages;
 	int other_file = global_node_page_state(NR_FILE_PAGES) -
 				global_node_page_state(NR_SHMEM) -
+				global_node_page_state(NR_UNEVICTABLE) -
 				total_swapcache_pages();
 
 	if (lowmem_adj_size < array_size)
@@ -160,23 +164,27 @@ static unsigned long lowmem_scan(struct shrinker *s, struct shrink_control *sc)
 			     p->comm, p->pid, oom_score_adj, tasksize);
 	}
 	if (selected) {
+		long cache_size = other_file * (long)(PAGE_SIZE / 1024);
+		long cache_limit = minfree * (long)(PAGE_SIZE / 1024);
+		long free = other_free * (long)(PAGE_SIZE / 1024);
+
 		task_lock(selected);
 		send_sig(SIGKILL, selected, 0);
 		if (selected->mm)
 			task_set_lmk_waiting(selected);
 		task_unlock(selected);
-		lowmem_print(1, "Killing '%s' (%d), adj %hd,\n"
+		trace_lowmemory_kill(selected, cache_size, cache_limit, free);
+		lowmem_print(1, "Killing '%s' (%d) (tgid %d), adj %hd,\n"
 				 "   to free %ldkB on behalf of '%s' (%d) because\n"
 				 "   cache %ldkB is below limit %ldkB for oom_score_adj %hd\n"
 				 "   Free memory is %ldkB above reserved\n",
-			     selected->comm, selected->pid,
+			     selected->comm, selected->pid, selected->tgid,
 			     selected_oom_score_adj,
 			     selected_tasksize * (long)(PAGE_SIZE / 1024),
 			     current->comm, current->pid,
-			     other_file * (long)(PAGE_SIZE / 1024),
-			     minfree * (long)(PAGE_SIZE / 1024),
+			     cache_size, cache_limit,
 			     min_score_adj,
-			     other_free * (long)(PAGE_SIZE / 1024));
+			     free);
 		lowmem_deathpending_timeout = jiffies + HZ;
 		rem += selected_tasksize;
 	}
@@ -200,12 +208,96 @@ static int __init lowmem_init(void)
 }
 device_initcall(lowmem_init);
 
+#ifdef CONFIG_ANDROID_LOW_MEMORY_KILLER_AUTODETECT_OOM_ADJ_VALUES
+static short lowmem_oom_adj_to_oom_score_adj(short oom_adj)
+{
+	if (oom_adj == OOM_ADJUST_MAX)
+		return OOM_SCORE_ADJ_MAX;
+	else
+		return (oom_adj * OOM_SCORE_ADJ_MAX) / -OOM_DISABLE;
+}
+
+static void lowmem_autodetect_oom_adj_values(void)
+{
+	int i;
+	short oom_adj;
+	short oom_score_adj;
+	int array_size = ARRAY_SIZE(lowmem_adj);
+
+	if (lowmem_adj_size < array_size)
+		array_size = lowmem_adj_size;
+
+	if (array_size <= 0)
+		return;
+
+	oom_adj = lowmem_adj[array_size - 1];
+	if (oom_adj > OOM_ADJUST_MAX)
+		return;
+
+	oom_score_adj = lowmem_oom_adj_to_oom_score_adj(oom_adj);
+	if (oom_score_adj <= OOM_ADJUST_MAX)
+		return;
+
+	lowmem_print(1, "lowmem_shrink: convert oom_adj to oom_score_adj:\n");
+	for (i = 0; i < array_size; i++) {
+		oom_adj = lowmem_adj[i];
+		oom_score_adj = lowmem_oom_adj_to_oom_score_adj(oom_adj);
+		lowmem_adj[i] = oom_score_adj;
+		lowmem_print(1, "oom_adj %d => oom_score_adj %d\n",
+			     oom_adj, oom_score_adj);
+	}
+}
+
+static int lowmem_adj_array_set(const char *val, const struct kernel_param *kp)
+{
+	int ret;
+
+	ret = param_array_ops.set(val, kp);
+
+	/* HACK: Autodetect oom_adj values in lowmem_adj array */
+	lowmem_autodetect_oom_adj_values();
+
+	return ret;
+}
+
+static int lowmem_adj_array_get(char *buffer, const struct kernel_param *kp)
+{
+	return param_array_ops.get(buffer, kp);
+}
+
+static void lowmem_adj_array_free(void *arg)
+{
+	param_array_ops.free(arg);
+}
+
+static struct kernel_param_ops lowmem_adj_array_ops = {
+	.set = lowmem_adj_array_set,
+	.get = lowmem_adj_array_get,
+	.free = lowmem_adj_array_free,
+};
+
+static const struct kparam_array __param_arr_adj = {
+	.max = ARRAY_SIZE(lowmem_adj),
+	.num = &lowmem_adj_size,
+	.ops = &param_ops_short,
+	.elemsize = sizeof(lowmem_adj[0]),
+	.elem = lowmem_adj,
+};
+#endif
+
 /*
  * not really modular, but the easiest way to keep compat with existing
  * bootargs behaviour is to continue using module_param here.
  */
 module_param_named(cost, lowmem_shrinker.seeks, int, 0644);
+#ifdef CONFIG_ANDROID_LOW_MEMORY_KILLER_AUTODETECT_OOM_ADJ_VALUES
+module_param_cb(adj, &lowmem_adj_array_ops,
+		.arr = &__param_arr_adj,
+		0644);
+__MODULE_PARM_TYPE(adj, "array of short");
+#else
 module_param_array_named(adj, lowmem_adj, short, &lowmem_adj_size, 0644);
+#endif
 module_param_array_named(minfree, lowmem_minfree, uint, &lowmem_minfree_size,
 			 0644);
 module_param_named(debug_level, lowmem_debug_level, uint, 0644);
diff --git a/drivers/staging/android/trace/lowmemorykiller.h b/drivers/staging/android/trace/lowmemorykiller.h
new file mode 100644
index 00000000..f43d3fa
--- /dev/null
+++ b/drivers/staging/android/trace/lowmemorykiller.h
@@ -0,0 +1,41 @@
+#undef TRACE_SYSTEM
+#define TRACE_INCLUDE_PATH ../../drivers/staging/android/trace
+#define TRACE_SYSTEM lowmemorykiller
+
+#if !defined(_TRACE_LOWMEMORYKILLER_H) || defined(TRACE_HEADER_MULTI_READ)
+#define _TRACE_LOWMEMORYKILLER_H
+
+#include <linux/tracepoint.h>
+
+TRACE_EVENT(lowmemory_kill,
+	TP_PROTO(struct task_struct *killed_task, long cache_size, \
+		 long cache_limit, long free),
+
+	TP_ARGS(killed_task, cache_size, cache_limit, free),
+
+	TP_STRUCT__entry(
+			__array(char, comm, TASK_COMM_LEN)
+			__field(pid_t, pid)
+			__field(long, pagecache_size)
+			__field(long, pagecache_limit)
+			__field(long, free)
+	),
+
+	TP_fast_assign(
+			memcpy(__entry->comm, killed_task->comm, TASK_COMM_LEN);
+			__entry->pid = killed_task->pid;
+			__entry->pagecache_size = cache_size;
+			__entry->pagecache_limit = cache_limit;
+			__entry->free = free;
+	),
+
+	TP_printk("%s (%d), page cache %ldkB (limit %ldkB), free %ldKb",
+		__entry->comm, __entry->pid, __entry->pagecache_size,
+		__entry->pagecache_limit, __entry->free)
+);
+
+
+#endif /* if !defined(_TRACE_LOWMEMORYKILLER_H) || defined(TRACE_HEADER_MULTI_READ) */
+
+/* This part must be outside protection */
+#include <trace/define_trace.h>
diff --git a/drivers/staging/android/uapi/ion.h b/drivers/staging/android/uapi/ion.h
index 14cd873..479eb2b 100644
--- a/drivers/staging/android/uapi/ion.h
+++ b/drivers/staging/android/uapi/ion.h
@@ -46,6 +46,13 @@ enum ion_heap_type {
 			       */
 };
 
+#if defined(CONFIG_ION_RTK)
+#define ION_HEAP_SYSTEM_MASK		(1 << ION_HEAP_TYPE_SYSTEM)
+#define ION_HEAP_SYSTEM_CONTIG_MASK	(1 << ION_HEAP_TYPE_SYSTEM_CONTIG)
+#define ION_HEAP_CARVEOUT_MASK		(1 << ION_HEAP_TYPE_CARVEOUT)
+#define ION_HEAP_TYPE_DMA_MASK		(1 << ION_HEAP_TYPE_DMA)
+#endif /* CONFIG_ION_RTK */
+
 #define ION_NUM_HEAP_IDS		(sizeof(unsigned int) * 8)
 
 /**
@@ -65,6 +72,35 @@ enum ion_heap_type {
  */
 #define ION_FLAG_CACHED_NEEDS_SYNC 2
 
+#if defined(CONFIG_ION_RTK)
+#define ION_FLAG_NONCACHED		(1 << 31)
+#define ION_FLAG_SCPUACC		(1 << 30)
+#define ION_FLAG_ACPUACC		(1 << 29)
+#define ION_FLAG_HWIPACC		(1 << 28)
+#define ION_FLAG_VE_SPEC		(1 << 27)
+#define ION_FLAG_SECURE_AUDIO		(1 << 26)
+#define ION_FLAG_SECURE_TPACC	        (1 << 25)
+#define ION_FLAG_VCPU_FWACC		(1 << 18)
+#define ION_FLAG_CMA		    (1 << 17)
+#define RTK_ION_FLAG_POOL_CONDITION		(\
+        ION_FLAG_ACPUACC | \
+        ION_FLAG_SCPUACC | \
+        ION_FLAG_HWIPACC | \
+        ION_FLAG_VE_SPEC | \
+        ION_FLAG_SECURE_AUDIO | \
+        ION_FLAG_SECURE_TPACC | \
+        ION_FLAG_VCPU_FWACC | \
+        ION_FLAG_CMA)
+#define RTK_ION_FLAG_MASK		(RTK_ION_FLAG_POOL_CONDITION) /* legacy */
+
+#define ION_USAGE_PROTECTED		(1 << 23)
+#define ION_USAGE_MMAP_NONCACHED		(1 << 22)
+#define ION_USAGE_MMAP_CACHED		(1 << 21)
+#define ION_USAGE_MMAP_WRITECOMBINE		(1 << 20)
+#define ION_USAGE_ALGO_LAST_FIT		(1 << 19) /* 0:first fit(default), 1:last fit */
+#define ION_USAGE_MASK		(ION_USAGE_PROTECTED | ION_USAGE_MMAP_NONCACHED | ION_USAGE_MMAP_CACHED | ION_USAGE_MMAP_WRITECOMBINE | ION_USAGE_ALGO_LAST_FIT)
+#endif /* CONFIG_ION_RTK */
+
 /**
  * DOC: Ion Userspace API
  *
@@ -128,6 +164,15 @@ struct ion_custom_data {
 	unsigned long arg;
 };
 
+/* 20130208 charleslin: support getting physical address */
+#if defined(CONFIG_ION_RTK)
+struct ion_phys_data {
+	ion_user_handle_t handle;
+	unsigned long addr;
+	unsigned int len;
+};
+#endif /* CONFIG_ION_RTK */
+
 #define MAX_HEAP_NAME			32
 
 /**
@@ -233,4 +278,10 @@ struct ion_heap_query {
 #define ION_IOC_HEAP_QUERY     _IOWR(ION_IOC_MAGIC, 8, \
 					struct ion_heap_query)
 
+#if defined(CONFIG_ION_RTK)
+/* 20130208 charleslin: support getting physical address */
+#define ION_IOC_PHYS _IOWR(ION_IOC_MAGIC, 9, struct ion_phys_data)
+#endif /* CONFIG_ION_RTK */
+
+
 #endif /* _UAPI_LINUX_ION_H */
diff --git a/drivers/staging/android/uapi/ion_rtk.h b/drivers/staging/android/uapi/ion_rtk.h
new file mode 100644
index 00000000..cba9f22
--- /dev/null
+++ b/drivers/staging/android/uapi/ion_rtk.h
@@ -0,0 +1,106 @@
+/*
+ *
+ * Copyright (C) 2011 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_RTK_PHOENIX_ION_H
+#define _LINUX_RTK_PHOENIX_ION_H
+
+#include <linux/types.h>
+#include <linux/cma.h>
+
+//#include "ion.h"
+//#include "../ion/ion.h"
+/**
+ * struct rtk_phoenix_ion_tiler_alloc_data - metadata passed from userspace for allocations
+ * @w:		width of the allocation
+ * @h:		height of the allocation
+ * @fmt:	format of the data (8, 16, 32bit or page)
+ * @flags:	flags passed to heap
+ * @stride:	stride of the allocation, returned to caller from kernel
+ * @handle:	pointer that will be populated with a cookie to use to refer
+ *		to this allocation
+ *
+ * Provided by userspace as an argument to the ioctl
+ */
+
+#ifdef __KERNEL__
+struct ion_heap *   ion_get_client_heap_by_mask(struct ion_client *client, unsigned int heap_id_mask);
+long                rtk_phoenix_ion_ioctl(struct ion_client *client, unsigned int cmd, unsigned long arg);
+#endif /* __KERNEL__ */
+
+/* additional heaps used only on rtk_phoenix */
+enum {
+	RTK_PHOENIX_ION_HEAP_TYPE_TILER = ION_HEAP_TYPE_CUSTOM + 1,
+	RTK_PHOENIX_ION_HEAP_TYPE_MEDIA,
+	RTK_PHOENIX_ION_HEAP_TYPE_AUDIO,
+	RTK_PHOENIX_ION_HEAP_TYPE_SECURE,
+};
+
+#define RTK_PHOENIX_ION_HEAP_TILER_MASK (1 << RTK_PHOENIX_ION_HEAP_TYPE_TILER)
+#define RTK_PHOENIX_ION_HEAP_MEDIA_MASK (1 << RTK_PHOENIX_ION_HEAP_TYPE_MEDIA)
+#define RTK_PHOENIX_ION_HEAP_AUDIO_MASK (1 << RTK_PHOENIX_ION_HEAP_TYPE_AUDIO)
+#define RTK_PHOENIX_ION_HEAP_SECURE_MASK (1 << RTK_PHOENIX_ION_HEAP_TYPE_SECURE)
+
+struct RTK_ION_IOC_GET_MEMORY_INFO_S {
+	unsigned int heapMask; /* request  : Select the heap to be queried */
+	unsigned int flags; /* request  : Set the conditions to query, 0 is to query all the conditions */
+	unsigned int usedSize; /* response */
+	unsigned int freeSize; /* response */
+};
+
+struct RTK_ION_IOC_SYNC_RANE {
+	ion_user_handle_t handle;
+	unsigned long long phyAddr;
+	unsigned int len;
+};
+
+struct RTK_ION_IOC_PHY_INFO {
+	ion_user_handle_t handle;
+	unsigned long long addr;
+	unsigned long long len;
+};
+
+#define RTK_ION_IOC_MAGIC 'R'
+#define RTK_PHOENIX_ION_TILER_ALLOC (0x0)
+#define RTK_PHOENIX_ION_GET_LAST_ALLOC_ADDR (0x1)
+#define RTK_ION_IOC_INVALIDATE (0x10)
+#define RTK_ION_IOC_FLUSH (0x11)
+#define RTK_ION_IOC_GET_MEMORY_INFO _IOWR(RTK_ION_IOC_MAGIC, 0x12, struct RTK_ION_IOC_GET_MEMORY_INFO_S)
+#define RTK_ION_IOC_INVALIDATE_RANGE (0x13)
+#define RTK_ION_IOC_FLUSH_RANGE (0x14)
+#define RTK_ION_IOC_GET_PHYINFO (0x15)
+
+/**
+ * These should match the defines in the tiler driver
+ */
+enum {
+	TILER_PIXEL_FMT_MIN = 0,
+	TILER_PIXEL_FMT_8BIT = 0,
+	TILER_PIXEL_FMT_16BIT = 1,
+	TILER_PIXEL_FMT_32BIT = 2,
+	TILER_PIXEL_FMT_PAGE = 3,
+	TILER_PIXEL_FMT_MAX = 3
+};
+
+/**
+ * List of heaps in the system
+ */
+enum {
+	RTK_PHOENIX_ION_HEAP_LARGE_SURFACES,
+	RTK_PHOENIX_ION_HEAP_TILER,
+	RTK_PHOENIX_ION_HEAP_SECURE_INPUT,
+	RTK_PHOENIX_ION_HEAP_NONSECURE_TILER,
+};
+
+#endif /* _LINUX_RTK_PHOENIX_ION_H */
diff --git a/drivers/staging/android/uapi/vsoc_shm.h b/drivers/staging/android/uapi/vsoc_shm.h
new file mode 100644
index 00000000..741b138
--- /dev/null
+++ b/drivers/staging/android/uapi/vsoc_shm.h
@@ -0,0 +1,303 @@
+/*
+ * Copyright (C) 2017 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _UAPI_LINUX_VSOC_SHM_H
+#define _UAPI_LINUX_VSOC_SHM_H
+
+#include <linux/types.h>
+
+/**
+ * A permission is a token that permits a receiver to read and/or write an area
+ * of memory within a Vsoc region.
+ *
+ * An fd_scoped permission grants both read and write access, and can be
+ * attached to a file description (see open(2)).
+ * Ownership of the area can then be shared by passing a file descriptor
+ * among processes.
+ *
+ * begin_offset and end_offset define the area of memory that is controlled by
+ * the permission. owner_offset points to a word, also in shared memory, that
+ * controls ownership of the area.
+ *
+ * ownership of the region expires when the associated file description is
+ * released.
+ *
+ * At most one permission can be attached to each file description.
+ *
+ * This is useful when implementing HALs like gralloc that scope and pass
+ * ownership of shared resources via file descriptors.
+ *
+ * The caller is responsibe for doing any fencing.
+ *
+ * The calling process will normally identify a currently free area of
+ * memory. It will construct a proposed fd_scoped_permission_arg structure:
+ *
+ *   begin_offset and end_offset describe the area being claimed
+ *
+ *   owner_offset points to the location in shared memory that indicates the
+ *   owner of the area.
+ *
+ *   owned_value is the value that will be stored in owner_offset iff the
+ *   permission can be granted. It must be different than VSOC_REGION_FREE.
+ *
+ * Two fd_scoped_permission structures are compatible if they vary only by
+ * their owned_value fields.
+ *
+ * The driver ensures that, for any group of simultaneous callers proposing
+ * compatible fd_scoped_permissions, it will accept exactly one of the
+ * propopsals. The other callers will get a failure with errno of EAGAIN.
+ *
+ * A process receiving a file descriptor can identify the region being
+ * granted using the VSOC_GET_FD_SCOPED_PERMISSION ioctl.
+ */
+struct fd_scoped_permission {
+	__u32 begin_offset;
+	__u32 end_offset;
+	__u32 owner_offset;
+	__u32 owned_value;
+};
+
+/*
+ * This value represents a free area of memory. The driver expects to see this
+ * value at owner_offset when creating a permission otherwise it will not do it,
+ * and will write this value back once the permission is no longer needed.
+ */
+#define VSOC_REGION_FREE ((__u32)0)
+
+/**
+ * ioctl argument for VSOC_CREATE_FD_SCOPE_PERMISSION
+ */
+struct fd_scoped_permission_arg {
+	struct fd_scoped_permission perm;
+	__s32 managed_region_fd;
+};
+
+#define VSOC_NODE_FREE ((__u32)0)
+
+/*
+ * Describes a signal table in shared memory. Each non-zero entry in the
+ * table indicates that the receiver should signal the futex at the given
+ * offset. Offsets are relative to the region, not the shared memory window.
+ *
+ * interrupt_signalled_offset is used to reliably signal interrupts across the
+ * vmm boundary. There are two roles: transmitter and receiver. For example,
+ * in the host_to_guest_signal_table the host is the transmitter and the
+ * guest is the receiver. The protocol is as follows:
+ *
+ * 1. The transmitter should convert the offset of the futex to an offset
+ *    in the signal table [0, (1 << num_nodes_lg2))
+ *    The transmitter can choose any appropriate hashing algorithm, including
+ *    hash = futex_offset & ((1 << num_nodes_lg2) - 1)
+ *
+ * 3. The transmitter should atomically compare and swap futex_offset with 0
+ *    at hash. There are 3 possible outcomes
+ *      a. The swap fails because the futex_offset is already in the table.
+ *         The transmitter should stop.
+ *      b. Some other offset is in the table. This is a hash collision. The
+ *         transmitter should move to another table slot and try again. One
+ *         possible algorithm:
+ *         hash = (hash + 1) & ((1 << num_nodes_lg2) - 1)
+ *      c. The swap worked. Continue below.
+ *
+ * 3. The transmitter atomically swaps 1 with the value at the
+ *    interrupt_signalled_offset. There are two outcomes:
+ *      a. The prior value was 1. In this case an interrupt has already been
+ *         posted. The transmitter is done.
+ *      b. The prior value was 0, indicating that the receiver may be sleeping.
+ *         The transmitter will issue an interrupt.
+ *
+ * 4. On waking the receiver immediately exchanges a 0 with the
+ *    interrupt_signalled_offset. If it receives a 0 then this a spurious
+ *    interrupt. That may occasionally happen in the current protocol, but
+ *    should be rare.
+ *
+ * 5. The receiver scans the signal table by atomicaly exchanging 0 at each
+ *    location. If a non-zero offset is returned from the exchange the
+ *    receiver wakes all sleepers at the given offset:
+ *      futex((int*)(region_base + old_value), FUTEX_WAKE, MAX_INT);
+ *
+ * 6. The receiver thread then does a conditional wait, waking immediately
+ *    if the value at interrupt_signalled_offset is non-zero. This catches cases
+ *    here additional  signals were posted while the table was being scanned.
+ *    On the guest the wait is handled via the VSOC_WAIT_FOR_INCOMING_INTERRUPT
+ *    ioctl.
+ */
+struct vsoc_signal_table_layout {
+	/* log_2(Number of signal table entries) */
+	__u32 num_nodes_lg2;
+	/*
+	 * Offset to the first signal table entry relative to the start of the
+	 * region
+	 */
+	__u32 futex_uaddr_table_offset;
+	/*
+	 * Offset to an atomic_t / atomic uint32_t. A non-zero value indicates
+	 * that one or more offsets are currently posted in the table.
+	 * semi-unique access to an entry in the table
+	 */
+	__u32 interrupt_signalled_offset;
+};
+
+#define VSOC_REGION_WHOLE ((__s32)0)
+#define VSOC_DEVICE_NAME_SZ 16
+
+/**
+ * Each HAL would (usually) talk to a single device region
+ * Mulitple entities care about these regions:
+ * - The ivshmem_server will populate the regions in shared memory
+ * - The guest kernel will read the region, create minor device nodes, and
+ *   allow interested parties to register for FUTEX_WAKE events in the region
+ * - HALs will access via the minor device nodes published by the guest kernel
+ * - Host side processes will access the region via the ivshmem_server:
+ *   1. Pass name to ivshmem_server at a UNIX socket
+ *   2. ivshmemserver will reply with 2 fds:
+ *     - host->guest doorbell fd
+ *     - guest->host doorbell fd
+ *     - fd for the shared memory region
+ *     - region offset
+ *   3. Start a futex receiver thread on the doorbell fd pointed at the
+ *      signal_nodes
+ */
+struct vsoc_device_region {
+	__u16 current_version;
+	__u16 min_compatible_version;
+	__u32 region_begin_offset;
+	__u32 region_end_offset;
+	__u32 offset_of_region_data;
+	struct vsoc_signal_table_layout guest_to_host_signal_table;
+	struct vsoc_signal_table_layout host_to_guest_signal_table;
+	/* Name of the device. Must always be terminated with a '\0', so
+	 * the longest supported device name is 15 characters.
+	 */
+	char device_name[VSOC_DEVICE_NAME_SZ];
+	/* There are two ways that permissions to access regions are handled:
+	 *   - When subdivided_by is VSOC_REGION_WHOLE, any process that can
+	 *     open the device node for the region gains complete access to it.
+	 *   - When subdivided is set processes that open the region cannot
+	 *     access it. Access to a sub-region must be established by invoking
+	 *     the VSOC_CREATE_FD_SCOPE_PERMISSION ioctl on the region
+	 *     referenced in subdivided_by, providing a fileinstance
+	 *     (represented by a fd) opened on this region.
+	 */
+	__u32 managed_by;
+};
+
+/*
+ * The vsoc layout descriptor.
+ * The first 4K should be reserved for the shm header and region descriptors.
+ * The regions should be page aligned.
+ */
+
+struct vsoc_shm_layout_descriptor {
+	__u16 major_version;
+	__u16 minor_version;
+
+	/* size of the shm. This may be redundant but nice to have */
+	__u32 size;
+
+	/* number of shared memory regions */
+	__u32 region_count;
+
+	/* The offset to the start of region descriptors */
+	__u32 vsoc_region_desc_offset;
+};
+
+/*
+ * This specifies the current version that should be stored in
+ * vsoc_shm_layout_descriptor.major_version and
+ * vsoc_shm_layout_descriptor.minor_version.
+ * It should be updated only if the vsoc_device_region and
+ * vsoc_shm_layout_descriptor structures have changed.
+ * Versioning within each region is transferred
+ * via the min_compatible_version and current_version fields in
+ * vsoc_device_region. The driver does not consult these fields: they are left
+ * for the HALs and host processes and will change independently of the layout
+ * version.
+ */
+#define CURRENT_VSOC_LAYOUT_MAJOR_VERSION 2
+#define CURRENT_VSOC_LAYOUT_MINOR_VERSION 0
+
+#define VSOC_CREATE_FD_SCOPED_PERMISSION \
+	_IOW(0xF5, 0, struct fd_scoped_permission)
+#define VSOC_GET_FD_SCOPED_PERMISSION _IOR(0xF5, 1, struct fd_scoped_permission)
+
+/*
+ * This is used to signal the host to scan the guest_to_host_signal_table
+ * for new futexes to wake. This sends an interrupt if one is not already
+ * in flight.
+ */
+#define VSOC_MAYBE_SEND_INTERRUPT_TO_HOST _IO(0xF5, 2)
+
+/*
+ * When this returns the guest will scan host_to_guest_signal_table to
+ * check for new futexes to wake.
+ */
+/* TODO(ghartman): Consider moving this to the bottom half */
+#define VSOC_WAIT_FOR_INCOMING_INTERRUPT _IO(0xF5, 3)
+
+/*
+ * Guest HALs will use this to retrieve the region description after
+ * opening their device node.
+ */
+#define VSOC_DESCRIBE_REGION _IOR(0xF5, 4, struct vsoc_device_region)
+
+/*
+ * Wake any threads that may be waiting for a host interrupt on this region.
+ * This is mostly used during shutdown.
+ */
+#define VSOC_SELF_INTERRUPT _IO(0xF5, 5)
+
+/*
+ * This is used to signal the host to scan the guest_to_host_signal_table
+ * for new futexes to wake. This sends an interrupt unconditionally.
+ */
+#define VSOC_SEND_INTERRUPT_TO_HOST _IO(0xF5, 6)
+
+enum wait_types {
+	VSOC_WAIT_UNDEFINED = 0,
+	VSOC_WAIT_IF_EQUAL = 1,
+	VSOC_WAIT_IF_EQUAL_TIMEOUT = 2
+};
+
+/*
+ * Wait for a condition to be true
+ *
+ * Note, this is sized and aligned so the 32 bit and 64 bit layouts are
+ * identical.
+ */
+struct vsoc_cond_wait {
+	/* Input: Offset of the 32 bit word to check */
+	__u32 offset;
+	/* Input: Value that will be compared with the offset */
+	__u32 value;
+	/* Monotonic time to wake at in seconds */
+	__u64 wake_time_sec;
+	/* Input: Monotonic time to wait in nanoseconds */
+	__u32 wake_time_nsec;
+	/* Input: Type of wait */
+	__u32 wait_type;
+	/* Output: Number of times the thread woke before returning. */
+	__u32 wakes;
+	/* Ensure that we're 8-byte aligned and 8 byte length for 32/64 bit
+	 * compatibility.
+	 */
+	__u32 reserved_1;
+};
+
+#define VSOC_COND_WAIT _IOWR(0xF5, 7, struct vsoc_cond_wait)
+
+/* Wake any local threads waiting at the offset given in arg */
+#define VSOC_COND_WAKE _IO(0xF5, 8)
+
+#endif /* _UAPI_LINUX_VSOC_SHM_H */
diff --git a/drivers/staging/android/vsoc.c b/drivers/staging/android/vsoc.c
new file mode 100644
index 00000000..954ed2c
--- /dev/null
+++ b/drivers/staging/android/vsoc.c
@@ -0,0 +1,1165 @@
+/*
+ * drivers/android/staging/vsoc.c
+ *
+ * Android Virtual System on a Chip (VSoC) driver
+ *
+ * Copyright (C) 2017 Google, Inc.
+ *
+ * Author: ghartman@google.com
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ *
+ * Based on drivers/char/kvm_ivshmem.c - driver for KVM Inter-VM shared memory
+ *         Copyright 2009 Cam Macdonell <cam@cs.ualberta.ca>
+ *
+ * Based on cirrusfb.c and 8139cp.c:
+ *   Copyright 1999-2001 Jeff Garzik
+ *   Copyright 2001-2004 Jeff Garzik
+ */
+
+#include <linux/dma-mapping.h>
+#include <linux/freezer.h>
+#include <linux/futex.h>
+#include <linux/init.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/mutex.h>
+#include <linux/pci.h>
+#include <linux/proc_fs.h>
+#include <linux/sched.h>
+#include <linux/syscalls.h>
+#include <linux/uaccess.h>
+#include <linux/interrupt.h>
+#include <linux/mutex.h>
+#include <linux/cdev.h>
+#include <linux/file.h>
+#include "uapi/vsoc_shm.h"
+
+#define VSOC_DEV_NAME "vsoc"
+
+/*
+ * Description of the ivshmem-doorbell PCI device used by QEmu. These
+ * constants follow docs/specs/ivshmem-spec.txt, which can be found in
+ * the QEmu repository. This was last reconciled with the version that
+ * came out with 2.8
+ */
+
+/*
+ * These constants are determined KVM Inter-VM shared memory device
+ * register offsets
+ */
+enum {
+	INTR_MASK = 0x00,	/* Interrupt Mask */
+	INTR_STATUS = 0x04,	/* Interrupt Status */
+	IV_POSITION = 0x08,	/* VM ID */
+	DOORBELL = 0x0c,	/* Doorbell */
+};
+
+static const int REGISTER_BAR;  /* Equal to 0 */
+static const int MAX_REGISTER_BAR_LEN = 0x100;
+/*
+ * The MSI-x BAR is not used directly.
+ *
+ * static const int MSI_X_BAR = 1;
+ */
+static const int SHARED_MEMORY_BAR = 2;
+
+struct vsoc_region_data {
+	char name[VSOC_DEVICE_NAME_SZ + 1];
+	wait_queue_head_t interrupt_wait_queue;
+	/* TODO(b/73664181): Use multiple futex wait queues */
+	wait_queue_head_t futex_wait_queue;
+	/* Flag indicating that an interrupt has been signalled by the host. */
+	atomic_t *incoming_signalled;
+	/* Flag indicating the guest has signalled the host. */
+	atomic_t *outgoing_signalled;
+	bool irq_requested;
+	bool device_created;
+};
+
+struct vsoc_device {
+	/* Kernel virtual address of REGISTER_BAR. */
+	void __iomem *regs;
+	/* Physical address of SHARED_MEMORY_BAR. */
+	phys_addr_t shm_phys_start;
+	/* Kernel virtual address of SHARED_MEMORY_BAR. */
+	void __iomem *kernel_mapped_shm;
+	/* Size of the entire shared memory window in bytes. */
+	size_t shm_size;
+	/*
+	 * Pointer to the virtual address of the shared memory layout structure.
+	 * This is probably identical to kernel_mapped_shm, but saving this
+	 * here saves a lot of annoying casts.
+	 */
+	struct vsoc_shm_layout_descriptor *layout;
+	/*
+	 * Points to a table of region descriptors in the kernel's virtual
+	 * address space. Calculated from
+	 * vsoc_shm_layout_descriptor.vsoc_region_desc_offset
+	 */
+	struct vsoc_device_region *regions;
+	/* Head of a list of permissions that have been granted. */
+	struct list_head permissions;
+	struct pci_dev *dev;
+	/* Per-region (and therefore per-interrupt) information. */
+	struct vsoc_region_data *regions_data;
+	/*
+	 * Table of msi-x entries. This has to be separated from struct
+	 * vsoc_region_data because the kernel deals with them as an array.
+	 */
+	struct msix_entry *msix_entries;
+	/* Mutex that protectes the permission list */
+	struct mutex mtx;
+	/* Major number assigned by the kernel */
+	int major;
+	/* Character device assigned by the kernel */
+	struct cdev cdev;
+	/* Device class assigned by the kernel */
+	struct class *class;
+	/*
+	 * Flags that indicate what we've initialized. These are used to do an
+	 * orderly cleanup of the device.
+	 */
+	bool enabled_device;
+	bool requested_regions;
+	bool cdev_added;
+	bool class_added;
+	bool msix_enabled;
+};
+
+static struct vsoc_device vsoc_dev;
+
+/*
+ * TODO(ghartman): Add a /sys filesystem entry that summarizes the permissions.
+ */
+
+struct fd_scoped_permission_node {
+	struct fd_scoped_permission permission;
+	struct list_head list;
+};
+
+struct vsoc_private_data {
+	struct fd_scoped_permission_node *fd_scoped_permission_node;
+};
+
+static long vsoc_ioctl(struct file *, unsigned int, unsigned long);
+static int vsoc_mmap(struct file *, struct vm_area_struct *);
+static int vsoc_open(struct inode *, struct file *);
+static int vsoc_release(struct inode *, struct file *);
+static ssize_t vsoc_read(struct file *, char __user *, size_t, loff_t *);
+static ssize_t vsoc_write(struct file *, const char __user *, size_t, loff_t *);
+static loff_t vsoc_lseek(struct file *filp, loff_t offset, int origin);
+static int do_create_fd_scoped_permission(
+	struct vsoc_device_region *region_p,
+	struct fd_scoped_permission_node *np,
+	struct fd_scoped_permission_arg __user *arg);
+static void do_destroy_fd_scoped_permission(
+	struct vsoc_device_region *owner_region_p,
+	struct fd_scoped_permission *perm);
+static long do_vsoc_describe_region(struct file *,
+				    struct vsoc_device_region __user *);
+static ssize_t vsoc_get_area(struct file *filp, __u32 *perm_off);
+
+/**
+ * Validate arguments on entry points to the driver.
+ */
+inline int vsoc_validate_inode(struct inode *inode)
+{
+	if (iminor(inode) >= vsoc_dev.layout->region_count) {
+		dev_err(&vsoc_dev.dev->dev,
+			"describe_region: invalid region %d\n", iminor(inode));
+		return -ENODEV;
+	}
+	return 0;
+}
+
+inline int vsoc_validate_filep(struct file *filp)
+{
+	int ret = vsoc_validate_inode(file_inode(filp));
+
+	if (ret)
+		return ret;
+	if (!filp->private_data) {
+		dev_err(&vsoc_dev.dev->dev,
+			"No private data on fd, region %d\n",
+			iminor(file_inode(filp)));
+		return -EBADFD;
+	}
+	return 0;
+}
+
+/* Converts from shared memory offset to virtual address */
+static inline void *shm_off_to_virtual_addr(__u32 offset)
+{
+	return (void __force *)vsoc_dev.kernel_mapped_shm + offset;
+}
+
+/* Converts from shared memory offset to physical address */
+static inline phys_addr_t shm_off_to_phys_addr(__u32 offset)
+{
+	return vsoc_dev.shm_phys_start + offset;
+}
+
+/**
+ * Convenience functions to obtain the region from the inode or file.
+ * Dangerous to call before validating the inode/file.
+ */
+static inline struct vsoc_device_region *vsoc_region_from_inode(
+	struct inode *inode)
+{
+	return &vsoc_dev.regions[iminor(inode)];
+}
+
+static inline struct vsoc_device_region *vsoc_region_from_filep(
+	struct file *inode)
+{
+	return vsoc_region_from_inode(file_inode(inode));
+}
+
+static inline uint32_t vsoc_device_region_size(struct vsoc_device_region *r)
+{
+	return r->region_end_offset - r->region_begin_offset;
+}
+
+static const struct file_operations vsoc_ops = {
+	.owner = THIS_MODULE,
+	.open = vsoc_open,
+	.mmap = vsoc_mmap,
+	.read = vsoc_read,
+	.unlocked_ioctl = vsoc_ioctl,
+	.compat_ioctl = vsoc_ioctl,
+	.write = vsoc_write,
+	.llseek = vsoc_lseek,
+	.release = vsoc_release,
+};
+
+static struct pci_device_id vsoc_id_table[] = {
+	{0x1af4, 0x1110, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0},
+	{0},
+};
+
+MODULE_DEVICE_TABLE(pci, vsoc_id_table);
+
+static void vsoc_remove_device(struct pci_dev *pdev);
+static int vsoc_probe_device(struct pci_dev *pdev,
+			     const struct pci_device_id *ent);
+
+static struct pci_driver vsoc_pci_driver = {
+	.name = "vsoc",
+	.id_table = vsoc_id_table,
+	.probe = vsoc_probe_device,
+	.remove = vsoc_remove_device,
+};
+
+static int do_create_fd_scoped_permission(
+	struct vsoc_device_region *region_p,
+	struct fd_scoped_permission_node *np,
+	struct fd_scoped_permission_arg __user *arg)
+{
+	struct file *managed_filp;
+	s32 managed_fd;
+	atomic_t *owner_ptr = NULL;
+	struct vsoc_device_region *managed_region_p;
+
+	if (copy_from_user(&np->permission, &arg->perm, sizeof(*np)) ||
+	    copy_from_user(&managed_fd,
+			   &arg->managed_region_fd, sizeof(managed_fd))) {
+		return -EFAULT;
+	}
+	managed_filp = fdget(managed_fd).file;
+	/* Check that it's a valid fd, */
+	if (!managed_filp || vsoc_validate_filep(managed_filp))
+		return -EPERM;
+	/* EEXIST if the given fd already has a permission. */
+	if (((struct vsoc_private_data *)managed_filp->private_data)->
+	    fd_scoped_permission_node)
+		return -EEXIST;
+	managed_region_p = vsoc_region_from_filep(managed_filp);
+	/* Check that the provided region is managed by this one */
+	if (&vsoc_dev.regions[managed_region_p->managed_by] != region_p)
+		return -EPERM;
+	/* The area must be well formed and have non-zero size */
+	if (np->permission.begin_offset >= np->permission.end_offset)
+		return -EINVAL;
+	/* The area must fit in the memory window */
+	if (np->permission.end_offset >
+	    vsoc_device_region_size(managed_region_p))
+		return -ERANGE;
+	/* The area must be in the region data section */
+	if (np->permission.begin_offset <
+	    managed_region_p->offset_of_region_data)
+		return -ERANGE;
+	/* The area must be page aligned */
+	if (!PAGE_ALIGNED(np->permission.begin_offset) ||
+	    !PAGE_ALIGNED(np->permission.end_offset))
+		return -EINVAL;
+	/* Owner offset must be naturally aligned in the window */
+	if (np->permission.owner_offset &
+	    (sizeof(np->permission.owner_offset) - 1))
+		return -EINVAL;
+	/* The owner flag must reside in the owner memory */
+	if (np->permission.owner_offset + sizeof(np->permission.owner_offset) >
+	    vsoc_device_region_size(region_p))
+		return -ERANGE;
+	/* The owner flag must reside in the data section */
+	if (np->permission.owner_offset < region_p->offset_of_region_data)
+		return -EINVAL;
+	/* The owner value must change to claim the memory */
+	if (np->permission.owned_value == VSOC_REGION_FREE)
+		return -EINVAL;
+	owner_ptr =
+	    (atomic_t *)shm_off_to_virtual_addr(region_p->region_begin_offset +
+						np->permission.owner_offset);
+	/* We've already verified that this is in the shared memory window, so
+	 * it should be safe to write to this address.
+	 */
+	if (atomic_cmpxchg(owner_ptr,
+			   VSOC_REGION_FREE,
+			   np->permission.owned_value) != VSOC_REGION_FREE) {
+		return -EBUSY;
+	}
+	((struct vsoc_private_data *)managed_filp->private_data)->
+	    fd_scoped_permission_node = np;
+	/* The file offset needs to be adjusted if the calling
+	 * process did any read/write operations on the fd
+	 * before creating the permission.
+	 */
+	if (managed_filp->f_pos) {
+		if (managed_filp->f_pos > np->permission.end_offset) {
+			/* If the offset is beyond the permission end, set it
+			 * to the end.
+			 */
+			managed_filp->f_pos = np->permission.end_offset;
+		} else {
+			/* If the offset is within the permission interval
+			 * keep it there otherwise reset it to zero.
+			 */
+			if (managed_filp->f_pos < np->permission.begin_offset) {
+				managed_filp->f_pos = 0;
+			} else {
+				managed_filp->f_pos -=
+				    np->permission.begin_offset;
+			}
+		}
+	}
+	return 0;
+}
+
+static void do_destroy_fd_scoped_permission_node(
+	struct vsoc_device_region *owner_region_p,
+	struct fd_scoped_permission_node *node)
+{
+	if (node) {
+		do_destroy_fd_scoped_permission(owner_region_p,
+						&node->permission);
+		mutex_lock(&vsoc_dev.mtx);
+		list_del(&node->list);
+		mutex_unlock(&vsoc_dev.mtx);
+		kfree(node);
+	}
+}
+
+static void do_destroy_fd_scoped_permission(
+		struct vsoc_device_region *owner_region_p,
+		struct fd_scoped_permission *perm)
+{
+	atomic_t *owner_ptr = NULL;
+	int prev = 0;
+
+	if (!perm)
+		return;
+	owner_ptr = (atomic_t *)shm_off_to_virtual_addr(
+		owner_region_p->region_begin_offset + perm->owner_offset);
+	prev = atomic_xchg(owner_ptr, VSOC_REGION_FREE);
+	if (prev != perm->owned_value)
+		dev_err(&vsoc_dev.dev->dev,
+			"%x-%x: owner (%s) %x: expected to be %x was %x",
+			perm->begin_offset, perm->end_offset,
+			owner_region_p->device_name, perm->owner_offset,
+			perm->owned_value, prev);
+}
+
+static long do_vsoc_describe_region(struct file *filp,
+				    struct vsoc_device_region __user *dest)
+{
+	struct vsoc_device_region *region_p;
+	int retval = vsoc_validate_filep(filp);
+
+	if (retval)
+		return retval;
+	region_p = vsoc_region_from_filep(filp);
+	if (copy_to_user(dest, region_p, sizeof(*region_p)))
+		return -EFAULT;
+	return 0;
+}
+
+/**
+ * Implements the inner logic of cond_wait. Copies to and from userspace are
+ * done in the helper function below.
+ */
+static int handle_vsoc_cond_wait(struct file *filp, struct vsoc_cond_wait *arg)
+{
+	DEFINE_WAIT(wait);
+	u32 region_number = iminor(file_inode(filp));
+	struct vsoc_region_data *data = vsoc_dev.regions_data + region_number;
+	struct hrtimer_sleeper timeout, *to = NULL;
+	int ret = 0;
+	struct vsoc_device_region *region_p = vsoc_region_from_filep(filp);
+	atomic_t *address = NULL;
+	struct timespec ts;
+
+	/* Ensure that the offset is aligned */
+	if (arg->offset & (sizeof(uint32_t) - 1))
+		return -EADDRNOTAVAIL;
+	/* Ensure that the offset is within shared memory */
+	if (((uint64_t)arg->offset) + region_p->region_begin_offset +
+	    sizeof(uint32_t) > region_p->region_end_offset)
+		return -E2BIG;
+	address = shm_off_to_virtual_addr(region_p->region_begin_offset +
+					  arg->offset);
+
+	/* Ensure that the type of wait is valid */
+	switch (arg->wait_type) {
+	case VSOC_WAIT_IF_EQUAL:
+		break;
+	case VSOC_WAIT_IF_EQUAL_TIMEOUT:
+		to = &timeout;
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	if (to) {
+		/* Copy the user-supplied timesec into the kernel structure.
+		 * We do things this way to flatten differences between 32 bit
+		 * and 64 bit timespecs.
+		 */
+		ts.tv_sec = arg->wake_time_sec;
+		ts.tv_nsec = arg->wake_time_nsec;
+
+		if (!timespec_valid(&ts))
+			return -EINVAL;
+		hrtimer_init_on_stack(&to->timer, CLOCK_MONOTONIC,
+				      HRTIMER_MODE_ABS);
+		hrtimer_set_expires_range_ns(&to->timer, timespec_to_ktime(ts),
+					     current->timer_slack_ns);
+
+		hrtimer_init_sleeper(to, current);
+	}
+
+	while (1) {
+		prepare_to_wait(&data->futex_wait_queue, &wait,
+				TASK_INTERRUPTIBLE);
+		/*
+		 * Check the sentinel value after prepare_to_wait. If the value
+		 * changes after this check the writer will call signal,
+		 * changing the task state from INTERRUPTIBLE to RUNNING. That
+		 * will ensure that schedule() will eventually schedule this
+		 * task.
+		 */
+		if (atomic_read(address) != arg->value) {
+			ret = 0;
+			break;
+		}
+		if (to) {
+			hrtimer_start_expires(&to->timer, HRTIMER_MODE_ABS);
+			if (likely(to->task))
+				freezable_schedule();
+			hrtimer_cancel(&to->timer);
+			if (!to->task) {
+				ret = -ETIMEDOUT;
+				break;
+			}
+		} else {
+			freezable_schedule();
+		}
+		/* Count the number of times that we woke up. This is useful
+		 * for unit testing.
+		 */
+		++arg->wakes;
+		if (signal_pending(current)) {
+			ret = -EINTR;
+			break;
+		}
+	}
+	finish_wait(&data->futex_wait_queue, &wait);
+	if (to)
+		destroy_hrtimer_on_stack(&to->timer);
+	return ret;
+}
+
+/**
+ * Handles the details of copying from/to userspace to ensure that the copies
+ * happen on all of the return paths of cond_wait.
+ */
+static int do_vsoc_cond_wait(struct file *filp,
+			     struct vsoc_cond_wait __user *untrusted_in)
+{
+	struct vsoc_cond_wait arg;
+	int rval = 0;
+
+	if (copy_from_user(&arg, untrusted_in, sizeof(arg)))
+		return -EFAULT;
+	/* wakes is an out parameter. Initialize it to something sensible. */
+	arg.wakes = 0;
+	rval = handle_vsoc_cond_wait(filp, &arg);
+	if (copy_to_user(untrusted_in, &arg, sizeof(arg)))
+		return -EFAULT;
+	return rval;
+}
+
+static int do_vsoc_cond_wake(struct file *filp, uint32_t offset)
+{
+	struct vsoc_device_region *region_p = vsoc_region_from_filep(filp);
+	u32 region_number = iminor(file_inode(filp));
+	struct vsoc_region_data *data = vsoc_dev.regions_data + region_number;
+	/* Ensure that the offset is aligned */
+	if (offset & (sizeof(uint32_t) - 1))
+		return -EADDRNOTAVAIL;
+	/* Ensure that the offset is within shared memory */
+	if (((uint64_t)offset) + region_p->region_begin_offset +
+	    sizeof(uint32_t) > region_p->region_end_offset)
+		return -E2BIG;
+	/*
+	 * TODO(b/73664181): Use multiple futex wait queues.
+	 * We need to wake every sleeper when the condition changes. Typically
+	 * only a single thread will be waiting on the condition, but there
+	 * are exceptions. The worst case is about 10 threads.
+	 */
+	wake_up_interruptible_all(&data->futex_wait_queue);
+	return 0;
+}
+
+static long vsoc_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	int rv = 0;
+	struct vsoc_device_region *region_p;
+	u32 reg_num;
+	struct vsoc_region_data *reg_data;
+	int retval = vsoc_validate_filep(filp);
+
+	if (retval)
+		return retval;
+	region_p = vsoc_region_from_filep(filp);
+	reg_num = iminor(file_inode(filp));
+	reg_data = vsoc_dev.regions_data + reg_num;
+	switch (cmd) {
+	case VSOC_CREATE_FD_SCOPED_PERMISSION:
+		{
+			struct fd_scoped_permission_node *node = NULL;
+
+			node = kzalloc(sizeof(*node), GFP_KERNEL);
+			/* We can't allocate memory for the permission */
+			if (!node)
+				return -ENOMEM;
+			INIT_LIST_HEAD(&node->list);
+			rv = do_create_fd_scoped_permission(
+				region_p,
+				node,
+				(struct fd_scoped_permission_arg __user *)arg);
+			if (!rv) {
+				mutex_lock(&vsoc_dev.mtx);
+				list_add(&node->list, &vsoc_dev.permissions);
+				mutex_unlock(&vsoc_dev.mtx);
+			} else {
+				kfree(node);
+				return rv;
+			}
+		}
+		break;
+
+	case VSOC_GET_FD_SCOPED_PERMISSION:
+		{
+			struct fd_scoped_permission_node *node =
+			    ((struct vsoc_private_data *)filp->private_data)->
+			    fd_scoped_permission_node;
+			if (!node)
+				return -ENOENT;
+			if (copy_to_user
+			    ((struct fd_scoped_permission __user *)arg,
+			     &node->permission, sizeof(node->permission)))
+				return -EFAULT;
+		}
+		break;
+
+	case VSOC_MAYBE_SEND_INTERRUPT_TO_HOST:
+		if (!atomic_xchg(
+			    reg_data->outgoing_signalled,
+			    1)) {
+			writel(reg_num, vsoc_dev.regs + DOORBELL);
+			return 0;
+		} else {
+			return -EBUSY;
+		}
+		break;
+
+	case VSOC_SEND_INTERRUPT_TO_HOST:
+		writel(reg_num, vsoc_dev.regs + DOORBELL);
+		return 0;
+
+	case VSOC_WAIT_FOR_INCOMING_INTERRUPT:
+		wait_event_interruptible(
+			reg_data->interrupt_wait_queue,
+			(atomic_read(reg_data->incoming_signalled) != 0));
+		break;
+
+	case VSOC_DESCRIBE_REGION:
+		return do_vsoc_describe_region(
+			filp,
+			(struct vsoc_device_region __user *)arg);
+
+	case VSOC_SELF_INTERRUPT:
+		atomic_set(reg_data->incoming_signalled, 1);
+		wake_up_interruptible(&reg_data->interrupt_wait_queue);
+		break;
+
+	case VSOC_COND_WAIT:
+		return do_vsoc_cond_wait(filp,
+					 (struct vsoc_cond_wait __user *)arg);
+	case VSOC_COND_WAKE:
+		return do_vsoc_cond_wake(filp, arg);
+
+	default:
+		return -EINVAL;
+	}
+	return 0;
+}
+
+static ssize_t vsoc_read(struct file *filp, char __user *buffer, size_t len,
+			 loff_t *poffset)
+{
+	__u32 area_off;
+	const void *area_p;
+	ssize_t area_len;
+	int retval = vsoc_validate_filep(filp);
+
+	if (retval)
+		return retval;
+	area_len = vsoc_get_area(filp, &area_off);
+	area_p = shm_off_to_virtual_addr(area_off);
+	area_p += *poffset;
+	area_len -= *poffset;
+	if (area_len <= 0)
+		return 0;
+	if (area_len < len)
+		len = area_len;
+	if (copy_to_user(buffer, area_p, len))
+		return -EFAULT;
+	*poffset += len;
+	return len;
+}
+
+static loff_t vsoc_lseek(struct file *filp, loff_t offset, int origin)
+{
+	ssize_t area_len = 0;
+	int retval = vsoc_validate_filep(filp);
+
+	if (retval)
+		return retval;
+	area_len = vsoc_get_area(filp, NULL);
+	switch (origin) {
+	case SEEK_SET:
+		break;
+
+	case SEEK_CUR:
+		if (offset > 0 && offset + filp->f_pos < 0)
+			return -EOVERFLOW;
+		offset += filp->f_pos;
+		break;
+
+	case SEEK_END:
+		if (offset > 0 && offset + area_len < 0)
+			return -EOVERFLOW;
+		offset += area_len;
+		break;
+
+	case SEEK_DATA:
+		if (offset >= area_len)
+			return -EINVAL;
+		if (offset < 0)
+			offset = 0;
+		break;
+
+	case SEEK_HOLE:
+		/* Next hole is always the end of the region, unless offset is
+		 * beyond that
+		 */
+		if (offset < area_len)
+			offset = area_len;
+		break;
+
+	default:
+		return -EINVAL;
+	}
+
+	if (offset < 0 || offset > area_len)
+		return -EINVAL;
+	filp->f_pos = offset;
+
+	return offset;
+}
+
+static ssize_t vsoc_write(struct file *filp, const char __user *buffer,
+			  size_t len, loff_t *poffset)
+{
+	__u32 area_off;
+	void *area_p;
+	ssize_t area_len;
+	int retval = vsoc_validate_filep(filp);
+
+	if (retval)
+		return retval;
+	area_len = vsoc_get_area(filp, &area_off);
+	area_p = shm_off_to_virtual_addr(area_off);
+	area_p += *poffset;
+	area_len -= *poffset;
+	if (area_len <= 0)
+		return 0;
+	if (area_len < len)
+		len = area_len;
+	if (copy_from_user(area_p, buffer, len))
+		return -EFAULT;
+	*poffset += len;
+	return len;
+}
+
+static irqreturn_t vsoc_interrupt(int irq, void *region_data_v)
+{
+	struct vsoc_region_data *region_data =
+	    (struct vsoc_region_data *)region_data_v;
+	int reg_num = region_data - vsoc_dev.regions_data;
+
+	if (unlikely(!region_data))
+		return IRQ_NONE;
+
+	if (unlikely(reg_num < 0 ||
+		     reg_num >= vsoc_dev.layout->region_count)) {
+		dev_err(&vsoc_dev.dev->dev,
+			"invalid irq @%p reg_num=0x%04x\n",
+			region_data, reg_num);
+		return IRQ_NONE;
+	}
+	if (unlikely(vsoc_dev.regions_data + reg_num != region_data)) {
+		dev_err(&vsoc_dev.dev->dev,
+			"irq not aligned @%p reg_num=0x%04x\n",
+			region_data, reg_num);
+		return IRQ_NONE;
+	}
+	wake_up_interruptible(&region_data->interrupt_wait_queue);
+	return IRQ_HANDLED;
+}
+
+static int vsoc_probe_device(struct pci_dev *pdev,
+			     const struct pci_device_id *ent)
+{
+	int result;
+	int i;
+	resource_size_t reg_size;
+	dev_t devt;
+
+	vsoc_dev.dev = pdev;
+	result = pci_enable_device(pdev);
+	if (result) {
+		dev_err(&pdev->dev,
+			"pci_enable_device failed %s: error %d\n",
+			pci_name(pdev), result);
+		return result;
+	}
+	vsoc_dev.enabled_device = true;
+	result = pci_request_regions(pdev, "vsoc");
+	if (result < 0) {
+		dev_err(&pdev->dev, "pci_request_regions failed\n");
+		vsoc_remove_device(pdev);
+		return -EBUSY;
+	}
+	vsoc_dev.requested_regions = true;
+	/* Set up the control registers in BAR 0 */
+	reg_size = pci_resource_len(pdev, REGISTER_BAR);
+	if (reg_size > MAX_REGISTER_BAR_LEN)
+		vsoc_dev.regs =
+		    pci_iomap(pdev, REGISTER_BAR, MAX_REGISTER_BAR_LEN);
+	else
+		vsoc_dev.regs = pci_iomap(pdev, REGISTER_BAR, reg_size);
+
+	if (!vsoc_dev.regs) {
+		dev_err(&pdev->dev,
+			"cannot map registers of size %zu\n",
+		       (size_t)reg_size);
+		vsoc_remove_device(pdev);
+		return -EBUSY;
+	}
+
+	/* Map the shared memory in BAR 2 */
+	vsoc_dev.shm_phys_start = pci_resource_start(pdev, SHARED_MEMORY_BAR);
+	vsoc_dev.shm_size = pci_resource_len(pdev, SHARED_MEMORY_BAR);
+
+	dev_info(&pdev->dev, "shared memory @ DMA %pa size=0x%zx\n",
+		 &vsoc_dev.shm_phys_start, vsoc_dev.shm_size);
+	vsoc_dev.kernel_mapped_shm = pci_iomap_wc(pdev, SHARED_MEMORY_BAR, 0);
+	if (!vsoc_dev.kernel_mapped_shm) {
+		dev_err(&vsoc_dev.dev->dev, "cannot iomap region\n");
+		vsoc_remove_device(pdev);
+		return -EBUSY;
+	}
+
+	vsoc_dev.layout = (struct vsoc_shm_layout_descriptor __force *)
+				vsoc_dev.kernel_mapped_shm;
+	dev_info(&pdev->dev, "major_version: %d\n",
+		 vsoc_dev.layout->major_version);
+	dev_info(&pdev->dev, "minor_version: %d\n",
+		 vsoc_dev.layout->minor_version);
+	dev_info(&pdev->dev, "size: 0x%x\n", vsoc_dev.layout->size);
+	dev_info(&pdev->dev, "regions: %d\n", vsoc_dev.layout->region_count);
+	if (vsoc_dev.layout->major_version !=
+	    CURRENT_VSOC_LAYOUT_MAJOR_VERSION) {
+		dev_err(&vsoc_dev.dev->dev,
+			"driver supports only major_version %d\n",
+			CURRENT_VSOC_LAYOUT_MAJOR_VERSION);
+		vsoc_remove_device(pdev);
+		return -EBUSY;
+	}
+	result = alloc_chrdev_region(&devt, 0, vsoc_dev.layout->region_count,
+				     VSOC_DEV_NAME);
+	if (result) {
+		dev_err(&vsoc_dev.dev->dev, "alloc_chrdev_region failed\n");
+		vsoc_remove_device(pdev);
+		return -EBUSY;
+	}
+	vsoc_dev.major = MAJOR(devt);
+	cdev_init(&vsoc_dev.cdev, &vsoc_ops);
+	vsoc_dev.cdev.owner = THIS_MODULE;
+	result = cdev_add(&vsoc_dev.cdev, devt, vsoc_dev.layout->region_count);
+	if (result) {
+		dev_err(&vsoc_dev.dev->dev, "cdev_add error\n");
+		vsoc_remove_device(pdev);
+		return -EBUSY;
+	}
+	vsoc_dev.cdev_added = true;
+	vsoc_dev.class = class_create(THIS_MODULE, VSOC_DEV_NAME);
+	if (IS_ERR(vsoc_dev.class)) {
+		dev_err(&vsoc_dev.dev->dev, "class_create failed\n");
+		vsoc_remove_device(pdev);
+		return PTR_ERR(vsoc_dev.class);
+	}
+	vsoc_dev.class_added = true;
+	vsoc_dev.regions = (struct vsoc_device_region __force *)
+		((void *)vsoc_dev.layout +
+		 vsoc_dev.layout->vsoc_region_desc_offset);
+	vsoc_dev.msix_entries = kcalloc(
+			vsoc_dev.layout->region_count,
+			sizeof(vsoc_dev.msix_entries[0]), GFP_KERNEL);
+	if (!vsoc_dev.msix_entries) {
+		dev_err(&vsoc_dev.dev->dev,
+			"unable to allocate msix_entries\n");
+		vsoc_remove_device(pdev);
+		return -ENOSPC;
+	}
+	vsoc_dev.regions_data = kcalloc(
+			vsoc_dev.layout->region_count,
+			sizeof(vsoc_dev.regions_data[0]), GFP_KERNEL);
+	if (!vsoc_dev.regions_data) {
+		dev_err(&vsoc_dev.dev->dev,
+			"unable to allocate regions' data\n");
+		vsoc_remove_device(pdev);
+		return -ENOSPC;
+	}
+	for (i = 0; i < vsoc_dev.layout->region_count; ++i)
+		vsoc_dev.msix_entries[i].entry = i;
+
+	result = pci_enable_msix_exact(vsoc_dev.dev, vsoc_dev.msix_entries,
+				       vsoc_dev.layout->region_count);
+	if (result) {
+		dev_info(&pdev->dev, "pci_enable_msix failed: %d\n", result);
+		vsoc_remove_device(pdev);
+		return -ENOSPC;
+	}
+	/* Check that all regions are well formed */
+	for (i = 0; i < vsoc_dev.layout->region_count; ++i) {
+		const struct vsoc_device_region *region = vsoc_dev.regions + i;
+
+		if (!PAGE_ALIGNED(region->region_begin_offset) ||
+		    !PAGE_ALIGNED(region->region_end_offset)) {
+			dev_err(&vsoc_dev.dev->dev,
+				"region %d not aligned (%x:%x)", i,
+				region->region_begin_offset,
+				region->region_end_offset);
+			vsoc_remove_device(pdev);
+			return -EFAULT;
+		}
+		if (region->region_begin_offset >= region->region_end_offset ||
+		    region->region_end_offset > vsoc_dev.shm_size) {
+			dev_err(&vsoc_dev.dev->dev,
+				"region %d offsets are wrong: %x %x %zx",
+				i, region->region_begin_offset,
+				region->region_end_offset, vsoc_dev.shm_size);
+			vsoc_remove_device(pdev);
+			return -EFAULT;
+		}
+		if (region->managed_by >= vsoc_dev.layout->region_count) {
+			dev_err(&vsoc_dev.dev->dev,
+				"region %d has invalid owner: %u",
+				i, region->managed_by);
+			vsoc_remove_device(pdev);
+			return -EFAULT;
+		}
+	}
+	vsoc_dev.msix_enabled = true;
+	for (i = 0; i < vsoc_dev.layout->region_count; ++i) {
+		const struct vsoc_device_region *region = vsoc_dev.regions + i;
+		size_t name_sz = sizeof(vsoc_dev.regions_data[i].name) - 1;
+		const struct vsoc_signal_table_layout *h_to_g_signal_table =
+			&region->host_to_guest_signal_table;
+		const struct vsoc_signal_table_layout *g_to_h_signal_table =
+			&region->guest_to_host_signal_table;
+
+		vsoc_dev.regions_data[i].name[name_sz] = '\0';
+		memcpy(vsoc_dev.regions_data[i].name, region->device_name,
+		       name_sz);
+		dev_info(&pdev->dev, "region %d name=%s\n",
+			 i, vsoc_dev.regions_data[i].name);
+		init_waitqueue_head(
+				&vsoc_dev.regions_data[i].interrupt_wait_queue);
+		init_waitqueue_head(&vsoc_dev.regions_data[i].futex_wait_queue);
+		vsoc_dev.regions_data[i].incoming_signalled =
+			shm_off_to_virtual_addr(region->region_begin_offset) +
+			h_to_g_signal_table->interrupt_signalled_offset;
+		vsoc_dev.regions_data[i].outgoing_signalled =
+			shm_off_to_virtual_addr(region->region_begin_offset) +
+			g_to_h_signal_table->interrupt_signalled_offset;
+		result = request_irq(
+				vsoc_dev.msix_entries[i].vector,
+				vsoc_interrupt, 0,
+				vsoc_dev.regions_data[i].name,
+				vsoc_dev.regions_data + i);
+		if (result) {
+			dev_info(&pdev->dev,
+				 "request_irq failed irq=%d vector=%d\n",
+				i, vsoc_dev.msix_entries[i].vector);
+			vsoc_remove_device(pdev);
+			return -ENOSPC;
+		}
+		vsoc_dev.regions_data[i].irq_requested = true;
+		if (!device_create(vsoc_dev.class, NULL,
+				   MKDEV(vsoc_dev.major, i),
+				   NULL, vsoc_dev.regions_data[i].name)) {
+			dev_err(&vsoc_dev.dev->dev, "device_create failed\n");
+			vsoc_remove_device(pdev);
+			return -EBUSY;
+		}
+		vsoc_dev.regions_data[i].device_created = true;
+	}
+	return 0;
+}
+
+/*
+ * This should undo all of the allocations in the probe function in reverse
+ * order.
+ *
+ * Notes:
+ *
+ *   The device may have been partially initialized, so double check
+ *   that the allocations happened.
+ *
+ *   This function may be called multiple times, so mark resources as freed
+ *   as they are deallocated.
+ */
+static void vsoc_remove_device(struct pci_dev *pdev)
+{
+	int i;
+	/*
+	 * pdev is the first thing to be set on probe and the last thing
+	 * to be cleared here. If it's NULL then there is no cleanup.
+	 */
+	if (!pdev || !vsoc_dev.dev)
+		return;
+	dev_info(&pdev->dev, "remove_device\n");
+	if (vsoc_dev.regions_data) {
+		for (i = 0; i < vsoc_dev.layout->region_count; ++i) {
+			if (vsoc_dev.regions_data[i].device_created) {
+				device_destroy(vsoc_dev.class,
+					       MKDEV(vsoc_dev.major, i));
+				vsoc_dev.regions_data[i].device_created = false;
+			}
+			if (vsoc_dev.regions_data[i].irq_requested)
+				free_irq(vsoc_dev.msix_entries[i].vector, NULL);
+			vsoc_dev.regions_data[i].irq_requested = false;
+		}
+		kfree(vsoc_dev.regions_data);
+		vsoc_dev.regions_data = NULL;
+	}
+	if (vsoc_dev.msix_enabled) {
+		pci_disable_msix(pdev);
+		vsoc_dev.msix_enabled = false;
+	}
+	kfree(vsoc_dev.msix_entries);
+	vsoc_dev.msix_entries = NULL;
+	vsoc_dev.regions = NULL;
+	if (vsoc_dev.class_added) {
+		class_destroy(vsoc_dev.class);
+		vsoc_dev.class_added = false;
+	}
+	if (vsoc_dev.cdev_added) {
+		cdev_del(&vsoc_dev.cdev);
+		vsoc_dev.cdev_added = false;
+	}
+	if (vsoc_dev.major && vsoc_dev.layout) {
+		unregister_chrdev_region(MKDEV(vsoc_dev.major, 0),
+					 vsoc_dev.layout->region_count);
+		vsoc_dev.major = 0;
+	}
+	vsoc_dev.layout = NULL;
+	if (vsoc_dev.kernel_mapped_shm) {
+		pci_iounmap(pdev, vsoc_dev.kernel_mapped_shm);
+		vsoc_dev.kernel_mapped_shm = NULL;
+	}
+	if (vsoc_dev.regs) {
+		pci_iounmap(pdev, vsoc_dev.regs);
+		vsoc_dev.regs = NULL;
+	}
+	if (vsoc_dev.requested_regions) {
+		pci_release_regions(pdev);
+		vsoc_dev.requested_regions = false;
+	}
+	if (vsoc_dev.enabled_device) {
+		pci_disable_device(pdev);
+		vsoc_dev.enabled_device = false;
+	}
+	/* Do this last: it indicates that the device is not initialized. */
+	vsoc_dev.dev = NULL;
+}
+
+static void __exit vsoc_cleanup_module(void)
+{
+	vsoc_remove_device(vsoc_dev.dev);
+	pci_unregister_driver(&vsoc_pci_driver);
+}
+
+static int __init vsoc_init_module(void)
+{
+	int err = -ENOMEM;
+
+	INIT_LIST_HEAD(&vsoc_dev.permissions);
+	mutex_init(&vsoc_dev.mtx);
+
+	err = pci_register_driver(&vsoc_pci_driver);
+	if (err < 0)
+		return err;
+	return 0;
+}
+
+static int vsoc_open(struct inode *inode, struct file *filp)
+{
+	/* Can't use vsoc_validate_filep because filp is still incomplete */
+	int ret = vsoc_validate_inode(inode);
+
+	if (ret)
+		return ret;
+	filp->private_data =
+		kzalloc(sizeof(struct vsoc_private_data), GFP_KERNEL);
+	if (!filp->private_data)
+		return -ENOMEM;
+	return 0;
+}
+
+static int vsoc_release(struct inode *inode, struct file *filp)
+{
+	struct vsoc_private_data *private_data = NULL;
+	struct fd_scoped_permission_node *node = NULL;
+	struct vsoc_device_region *owner_region_p = NULL;
+	int retval = vsoc_validate_filep(filp);
+
+	if (retval)
+		return retval;
+	private_data = (struct vsoc_private_data *)filp->private_data;
+	if (!private_data)
+		return 0;
+
+	node = private_data->fd_scoped_permission_node;
+	if (node) {
+		owner_region_p = vsoc_region_from_inode(inode);
+		if (owner_region_p->managed_by != VSOC_REGION_WHOLE) {
+			owner_region_p =
+			    &vsoc_dev.regions[owner_region_p->managed_by];
+		}
+		do_destroy_fd_scoped_permission_node(owner_region_p, node);
+		private_data->fd_scoped_permission_node = NULL;
+	}
+	kfree(private_data);
+	filp->private_data = NULL;
+
+	return 0;
+}
+
+/*
+ * Returns the device relative offset and length of the area specified by the
+ * fd scoped permission. If there is no fd scoped permission set, a default
+ * permission covering the entire region is assumed, unless the region is owned
+ * by another one, in which case the default is a permission with zero size.
+ */
+static ssize_t vsoc_get_area(struct file *filp, __u32 *area_offset)
+{
+	__u32 off = 0;
+	ssize_t length = 0;
+	struct vsoc_device_region *region_p;
+	struct fd_scoped_permission *perm;
+
+	region_p = vsoc_region_from_filep(filp);
+	off = region_p->region_begin_offset;
+	perm = &((struct vsoc_private_data *)filp->private_data)->
+		fd_scoped_permission_node->permission;
+	if (perm) {
+		off += perm->begin_offset;
+		length = perm->end_offset - perm->begin_offset;
+	} else if (region_p->managed_by == VSOC_REGION_WHOLE) {
+		/* No permission set and the regions is not owned by another,
+		 * default to full region access.
+		 */
+		length = vsoc_device_region_size(region_p);
+	} else {
+		/* return zero length, access is denied. */
+		length = 0;
+	}
+	if (area_offset)
+		*area_offset = off;
+	return length;
+}
+
+static int vsoc_mmap(struct file *filp, struct vm_area_struct *vma)
+{
+	unsigned long len = vma->vm_end - vma->vm_start;
+	__u32 area_off;
+	phys_addr_t mem_off;
+	ssize_t area_len;
+	int retval = vsoc_validate_filep(filp);
+
+	if (retval)
+		return retval;
+	area_len = vsoc_get_area(filp, &area_off);
+	/* Add the requested offset */
+	area_off += (vma->vm_pgoff << PAGE_SHIFT);
+	area_len -= (vma->vm_pgoff << PAGE_SHIFT);
+	if (area_len < len)
+		return -EINVAL;
+	vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+	mem_off = shm_off_to_phys_addr(area_off);
+	if (io_remap_pfn_range(vma, vma->vm_start, mem_off >> PAGE_SHIFT,
+			       len, vma->vm_page_prot))
+		return -EAGAIN;
+	return 0;
+}
+
+module_init(vsoc_init_module);
+module_exit(vsoc_cleanup_module);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Greg Hartman <ghartman@google.com>");
+MODULE_DESCRIPTION("VSoC interpretation of QEmu's ivshmem device");
+MODULE_VERSION("1.0");
diff --git a/drivers/staging/goldfish/Kconfig b/drivers/staging/goldfish/Kconfig
index 4e09460..d293bbc 100644
--- a/drivers/staging/goldfish/Kconfig
+++ b/drivers/staging/goldfish/Kconfig
@@ -4,6 +4,14 @@ config GOLDFISH_AUDIO
 	---help---
 	  Emulated audio channel for the Goldfish Android Virtual Device
 
+config GOLDFISH_SYNC
+    tristate "Goldfish AVD Sync Driver"
+    depends on GOLDFISH
+    depends on SW_SYNC
+    depends on SYNC_FILE
+	---help---
+	  Emulated sync fences for the Goldfish Android Virtual Device
+
 config MTD_GOLDFISH_NAND
 	tristate "Goldfish NAND device"
 	depends on GOLDFISH
diff --git a/drivers/staging/goldfish/Makefile b/drivers/staging/goldfish/Makefile
index dec34ad..3313fce 100644
--- a/drivers/staging/goldfish/Makefile
+++ b/drivers/staging/goldfish/Makefile
@@ -4,3 +4,9 @@
 
 obj-$(CONFIG_GOLDFISH_AUDIO) += goldfish_audio.o
 obj-$(CONFIG_MTD_GOLDFISH_NAND)	+= goldfish_nand.o
+
+# and sync
+
+ccflags-y := -Idrivers/staging/android
+goldfish_sync-objs := goldfish_sync_timeline_fence.o goldfish_sync_timeline.o
+obj-$(CONFIG_GOLDFISH_SYNC) += goldfish_sync.o
diff --git a/drivers/staging/goldfish/goldfish_audio.c b/drivers/staging/goldfish/goldfish_audio.c
index bd55995..0bb0ee2 100644
--- a/drivers/staging/goldfish/goldfish_audio.c
+++ b/drivers/staging/goldfish/goldfish_audio.c
@@ -28,6 +28,7 @@
 #include <linux/uaccess.h>
 #include <linux/slab.h>
 #include <linux/goldfish.h>
+#include <linux/acpi.h>
 
 MODULE_AUTHOR("Google, Inc.");
 MODULE_DESCRIPTION("Android QEMU Audio Driver");
@@ -116,6 +117,7 @@ static ssize_t goldfish_audio_read(struct file *fp, char __user *buf,
 				   size_t count, loff_t *pos)
 {
 	struct goldfish_audio *data = fp->private_data;
+	unsigned long irq_flags;
 	int length;
 	int result = 0;
 
@@ -129,6 +131,10 @@ static ssize_t goldfish_audio_read(struct file *fp, char __user *buf,
 		wait_event_interruptible(data->wait, data->buffer_status &
 					 AUDIO_INT_READ_BUFFER_FULL);
 
+		spin_lock_irqsave(&data->lock, irq_flags);
+		data->buffer_status &= ~AUDIO_INT_READ_BUFFER_FULL;
+		spin_unlock_irqrestore(&data->lock, irq_flags);
+
 		length = AUDIO_READ(data, AUDIO_READ_BUFFER_AVAILABLE);
 
 		/* copy data to user space */
@@ -351,12 +357,19 @@ static int goldfish_audio_remove(struct platform_device *pdev)
 };
 MODULE_DEVICE_TABLE(of, goldfish_audio_of_match);
 
+static const struct acpi_device_id goldfish_audio_acpi_match[] = {
+	{ "GFSH0005", 0 },
+	{ },
+};
+MODULE_DEVICE_TABLE(acpi, goldfish_audio_acpi_match);
+
 static struct platform_driver goldfish_audio_driver = {
 	.probe		= goldfish_audio_probe,
 	.remove		= goldfish_audio_remove,
 	.driver = {
 		.name = "goldfish_audio",
 		.of_match_table = goldfish_audio_of_match,
+		.acpi_match_table = ACPI_PTR(goldfish_audio_acpi_match),
 	}
 };
 
diff --git a/drivers/staging/goldfish/goldfish_sync_timeline.c b/drivers/staging/goldfish/goldfish_sync_timeline.c
new file mode 100644
index 00000000..5bef4c6
--- /dev/null
+++ b/drivers/staging/goldfish/goldfish_sync_timeline.c
@@ -0,0 +1,962 @@
+/*
+ * Copyright (C) 2016 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/fdtable.h>
+#include <linux/file.h>
+#include <linux/init.h>
+#include <linux/miscdevice.h>
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/platform_device.h>
+
+#include <linux/interrupt.h>
+#include <linux/kref.h>
+#include <linux/spinlock.h>
+#include <linux/types.h>
+
+#include <linux/io.h>
+#include <linux/mm.h>
+#include <linux/acpi.h>
+
+#include <linux/string.h>
+
+#include <linux/fs.h>
+#include <linux/syscalls.h>
+#include <linux/sync_file.h>
+#include <linux/fence.h>
+
+#include "goldfish_sync_timeline_fence.h"
+
+#define ERR(...) printk(KERN_ERR __VA_ARGS__);
+
+#define INFO(...) printk(KERN_INFO __VA_ARGS__);
+
+#define DPRINT(...) pr_debug(__VA_ARGS__);
+
+#define DTRACE() DPRINT("%s: enter", __func__)
+
+/* The Goldfish sync driver is designed to provide a interface
+ * between the underlying host's sync device and the kernel's
+ * fence sync framework..
+ * The purpose of the device/driver is to enable lightweight
+ * creation and signaling of timelines and fences
+ * in order to synchronize the guest with host-side graphics events.
+ *
+ * Each time the interrupt trips, the driver
+ * may perform a sync operation.
+ */
+
+/* The operations are: */
+
+/* Ready signal - used to mark when irq should lower */
+#define CMD_SYNC_READY            0
+
+/* Create a new timeline. writes timeline handle */
+#define CMD_CREATE_SYNC_TIMELINE  1
+
+/* Create a fence object. reads timeline handle and time argument.
+ * Writes fence fd to the SYNC_REG_HANDLE register. */
+#define CMD_CREATE_SYNC_FENCE     2
+
+/* Increments timeline. reads timeline handle and time argument */
+#define CMD_SYNC_TIMELINE_INC     3
+
+/* Destroys a timeline. reads timeline handle */
+#define CMD_DESTROY_SYNC_TIMELINE 4
+
+/* Starts a wait on the host with
+ * the given glsync object and sync thread handle. */
+#define CMD_TRIGGER_HOST_WAIT     5
+
+/* The register layout is: */
+
+#define SYNC_REG_BATCH_COMMAND                0x00 /* host->guest batch commands */
+#define SYNC_REG_BATCH_GUESTCOMMAND           0x04 /* guest->host batch commands */
+#define SYNC_REG_BATCH_COMMAND_ADDR           0x08 /* communicate physical address of host->guest batch commands */
+#define SYNC_REG_BATCH_COMMAND_ADDR_HIGH      0x0c /* 64-bit part */
+#define SYNC_REG_BATCH_GUESTCOMMAND_ADDR      0x10 /* communicate physical address of guest->host commands */
+#define SYNC_REG_BATCH_GUESTCOMMAND_ADDR_HIGH 0x14 /* 64-bit part */
+#define SYNC_REG_INIT                         0x18 /* signals that the device has been probed */
+
+/* There is an ioctl associated with goldfish sync driver.
+ * Make it conflict with ioctls that are not likely to be used
+ * in the emulator.
+ *
+ * '@'	00-0F	linux/radeonfb.h	conflict!
+ * '@'	00-0F	drivers/video/aty/aty128fb.c	conflict!
+ */
+#define GOLDFISH_SYNC_IOC_MAGIC	'@'
+
+#define GOLDFISH_SYNC_IOC_QUEUE_WORK	_IOWR(GOLDFISH_SYNC_IOC_MAGIC, 0, struct goldfish_sync_ioctl_info)
+
+/* The above definitions (command codes, register layout, ioctl definitions)
+ * need to be in sync with the following files:
+ *
+ * Host-side (emulator):
+ * external/qemu/android/emulation/goldfish_sync.h
+ * external/qemu-android/hw/misc/goldfish_sync.c
+ *
+ * Guest-side (system image):
+ * device/generic/goldfish-opengl/system/egl/goldfish_sync.h
+ * device/generic/goldfish/ueventd.ranchu.rc
+ * platform/build/target/board/generic/sepolicy/file_contexts
+ */
+struct goldfish_sync_hostcmd {
+	/* sorted for alignment */
+	uint64_t handle;
+	uint64_t hostcmd_handle;
+	uint32_t cmd;
+	uint32_t time_arg;
+};
+
+struct goldfish_sync_guestcmd {
+	uint64_t host_command; /* uint64_t for alignment */
+	uint64_t glsync_handle;
+	uint64_t thread_handle;
+	uint64_t guest_timeline_handle;
+};
+
+#define GOLDFISH_SYNC_MAX_CMDS 32
+
+struct goldfish_sync_state {
+	char __iomem *reg_base;
+	int irq;
+
+	/* Spinlock protects |to_do| / |to_do_end|. */
+	spinlock_t lock;
+	/* |mutex_lock| protects all concurrent access
+	 * to timelines for both kernel and user space. */
+	struct mutex mutex_lock;
+
+	/* Buffer holding commands issued from host. */
+	struct goldfish_sync_hostcmd to_do[GOLDFISH_SYNC_MAX_CMDS];
+	uint32_t to_do_end;
+
+	/* Addresses for the reading or writing
+	 * of individual commands. The host can directly write
+	 * to |batch_hostcmd| (and then this driver immediately
+	 * copies contents to |to_do|). This driver either replies
+	 * through |batch_hostcmd| or simply issues a
+	 * guest->host command through |batch_guestcmd|.
+	 */
+	struct goldfish_sync_hostcmd *batch_hostcmd;
+	struct goldfish_sync_guestcmd *batch_guestcmd;
+
+	/* Used to give this struct itself to a work queue
+	 * function for executing actual sync commands. */
+	struct work_struct work_item;
+};
+
+static struct goldfish_sync_state global_sync_state[1];
+
+struct goldfish_sync_timeline_obj {
+	struct goldfish_sync_timeline *sync_tl;
+	uint32_t current_time;
+	/* We need to be careful about when we deallocate
+	 * this |goldfish_sync_timeline_obj| struct.
+	 * In order to ensure proper cleanup, we need to
+	 * consider the triggered host-side wait that may
+	 * still be in flight when the guest close()'s a
+	 * goldfish_sync device's sync context fd (and
+	 * destroys the |sync_tl| field above).
+	 * The host-side wait may raise IRQ
+	 * and tell the kernel to increment the timeline _after_
+	 * the |sync_tl| has already been set to null.
+	 *
+	 * From observations on OpenGL apps and CTS tests, this
+	 * happens at some very low probability upon context
+	 * destruction or process close, but it does happen
+	 * and it needs to be handled properly. Otherwise,
+	 * if we clean up the surrounding |goldfish_sync_timeline_obj|
+	 * too early, any |handle| field of any host->guest command
+	 * might not even point to a null |sync_tl| field,
+	 * but to garbage memory or even a reclaimed |sync_tl|.
+	 * If we do not count such "pending waits" and kfree the object
+	 * immediately upon |goldfish_sync_timeline_destroy|,
+	 * we might get mysterous RCU stalls after running a long
+	 * time because the garbage memory that is being read
+	 * happens to be interpretable as a |spinlock_t| struct
+	 * that is currently in the locked state.
+	 *
+	 * To track when to free the |goldfish_sync_timeline_obj|
+	 * itself, we maintain a kref.
+	 * The kref essentially counts the timeline itself plus
+	 * the number of waits in flight. kref_init/kref_put
+	 * are issued on
+	 * |goldfish_sync_timeline_create|/|goldfish_sync_timeline_destroy|
+	 * and kref_get/kref_put are issued on
+	 * |goldfish_sync_fence_create|/|goldfish_sync_timeline_inc|.
+	 *
+	 * The timeline is destroyed after reference count
+	 * reaches zero, which would happen after
+	 * |goldfish_sync_timeline_destroy| and all pending
+	 * |goldfish_sync_timeline_inc|'s are fulfilled.
+	 *
+	 * NOTE (1): We assume that |fence_create| and
+	 * |timeline_inc| calls are 1:1, otherwise the kref scheme
+	 * will not work. This is a valid assumption as long
+	 * as the host-side virtual device implementation
+	 * does not insert any timeline increments
+	 * that we did not trigger from here.
+	 *
+	 * NOTE (2): The use of kref by itself requires no locks,
+	 * but this does not mean everything works without locks.
+	 * Related timeline operations do require a lock of some sort,
+	 * or at least are not proven to work without it.
+	 * In particualr, we assume that all the operations
+	 * done on the |kref| field above are done in contexts where
+	 * |global_sync_state->mutex_lock| is held. Do not
+	 * remove that lock until everything is proven to work
+	 * without it!!! */
+	struct kref kref;
+};
+
+/* We will call |delete_timeline_obj| when the last reference count
+ * of the kref is decremented. This deletes the sync
+ * timeline object along with the wrapper itself. */
+static void delete_timeline_obj(struct kref* kref) {
+	struct goldfish_sync_timeline_obj* obj =
+		container_of(kref, struct goldfish_sync_timeline_obj, kref);
+
+	goldfish_sync_timeline_put_internal(obj->sync_tl);
+	obj->sync_tl = NULL;
+	kfree(obj);
+}
+
+static uint64_t gensym_ctr;
+static void gensym(char *dst)
+{
+	sprintf(dst, "goldfish_sync:gensym:%llu", gensym_ctr);
+	gensym_ctr++;
+}
+
+/* |goldfish_sync_timeline_create| assumes that |global_sync_state->mutex_lock|
+ * is held. */
+static struct goldfish_sync_timeline_obj*
+goldfish_sync_timeline_create(void)
+{
+
+	char timeline_name[256];
+	struct goldfish_sync_timeline *res_sync_tl = NULL;
+	struct goldfish_sync_timeline_obj *res;
+
+	DTRACE();
+
+	gensym(timeline_name);
+
+	res_sync_tl = goldfish_sync_timeline_create_internal(timeline_name);
+	if (!res_sync_tl) {
+		ERR("Failed to create goldfish_sw_sync timeline.");
+		return NULL;
+	}
+
+	res = kzalloc(sizeof(struct goldfish_sync_timeline_obj), GFP_KERNEL);
+	res->sync_tl = res_sync_tl;
+	res->current_time = 0;
+	kref_init(&res->kref);
+
+	DPRINT("new timeline_obj=0x%p", res);
+	return res;
+}
+
+/* |goldfish_sync_fence_create| assumes that |global_sync_state->mutex_lock|
+ * is held. */
+static int
+goldfish_sync_fence_create(struct goldfish_sync_timeline_obj *obj,
+							uint32_t val)
+{
+
+	int fd;
+	char fence_name[256];
+	struct sync_pt *syncpt = NULL;
+	struct sync_file *sync_file_obj = NULL;
+	struct goldfish_sync_timeline *tl;
+
+	DTRACE();
+
+	if (!obj) return -1;
+
+	tl = obj->sync_tl;
+
+	syncpt = goldfish_sync_pt_create_internal(
+				tl, sizeof(struct sync_pt) + 4, val);
+	if (!syncpt) {
+		ERR("could not create sync point! "
+			"goldfish_sync_timeline=0x%p val=%d",
+			   tl, val);
+		return -1;
+	}
+
+	fd = get_unused_fd_flags(O_CLOEXEC);
+	if (fd < 0) {
+		ERR("could not get unused fd for sync fence. "
+			"errno=%d", fd);
+		goto err_cleanup_pt;
+	}
+
+	gensym(fence_name);
+
+	sync_file_obj = sync_file_create(&syncpt->base);
+	if (!sync_file_obj) {
+		ERR("could not create sync fence! "
+			"goldfish_sync_timeline=0x%p val=%d sync_pt=0x%p",
+			   tl, val, syncpt);
+		goto err_cleanup_fd_pt;
+	}
+
+	DPRINT("installing sync fence into fd %d sync_file_obj=0x%p",
+			fd, sync_file_obj);
+	fd_install(fd, sync_file_obj->file);
+	kref_get(&obj->kref);
+
+	return fd;
+
+err_cleanup_fd_pt:
+	put_unused_fd(fd);
+err_cleanup_pt:
+	fence_put(&syncpt->base);
+	return -1;
+}
+
+/* |goldfish_sync_timeline_inc| assumes that |global_sync_state->mutex_lock|
+ * is held. */
+static void
+goldfish_sync_timeline_inc(struct goldfish_sync_timeline_obj *obj, uint32_t inc)
+{
+	DTRACE();
+	/* Just give up if someone else nuked the timeline.
+	 * Whoever it was won't care that it doesn't get signaled. */
+	if (!obj) return;
+
+	DPRINT("timeline_obj=0x%p", obj);
+	goldfish_sync_timeline_signal_internal(obj->sync_tl, inc);
+	DPRINT("incremented timeline. increment max_time");
+	obj->current_time += inc;
+
+	/* Here, we will end up deleting the timeline object if it
+	 * turns out that this call was a pending increment after
+	 * |goldfish_sync_timeline_destroy| was called. */
+	kref_put(&obj->kref, delete_timeline_obj);
+	DPRINT("done");
+}
+
+/* |goldfish_sync_timeline_destroy| assumes
+ * that |global_sync_state->mutex_lock| is held. */
+static void
+goldfish_sync_timeline_destroy(struct goldfish_sync_timeline_obj *obj)
+{
+	DTRACE();
+	/* See description of |goldfish_sync_timeline_obj| for why we
+	 * should not immediately destroy |obj| */
+	kref_put(&obj->kref, delete_timeline_obj);
+}
+
+static inline void
+goldfish_sync_cmd_queue(struct goldfish_sync_state *sync_state,
+						uint32_t cmd,
+						uint64_t handle,
+						uint32_t time_arg,
+						uint64_t hostcmd_handle)
+{
+	struct goldfish_sync_hostcmd *to_add;
+
+	DTRACE();
+
+	BUG_ON(sync_state->to_do_end == GOLDFISH_SYNC_MAX_CMDS);
+
+	to_add = &sync_state->to_do[sync_state->to_do_end];
+
+	to_add->cmd = cmd;
+	to_add->handle = handle;
+	to_add->time_arg = time_arg;
+	to_add->hostcmd_handle = hostcmd_handle;
+
+	sync_state->to_do_end += 1;
+}
+
+static inline void
+goldfish_sync_hostcmd_reply(struct goldfish_sync_state *sync_state,
+							uint32_t cmd,
+							uint64_t handle,
+							uint32_t time_arg,
+							uint64_t hostcmd_handle)
+{
+	unsigned long irq_flags;
+	struct goldfish_sync_hostcmd *batch_hostcmd =
+		sync_state->batch_hostcmd;
+
+	DTRACE();
+
+	spin_lock_irqsave(&sync_state->lock, irq_flags);
+
+	batch_hostcmd->cmd = cmd;
+	batch_hostcmd->handle = handle;
+	batch_hostcmd->time_arg = time_arg;
+	batch_hostcmd->hostcmd_handle = hostcmd_handle;
+	writel(0, sync_state->reg_base + SYNC_REG_BATCH_COMMAND);
+
+	spin_unlock_irqrestore(&sync_state->lock, irq_flags);
+}
+
+static inline void
+goldfish_sync_send_guestcmd(struct goldfish_sync_state *sync_state,
+							uint32_t cmd,
+							uint64_t glsync_handle,
+							uint64_t thread_handle,
+							uint64_t timeline_handle)
+{
+	unsigned long irq_flags;
+	struct goldfish_sync_guestcmd *batch_guestcmd =
+		sync_state->batch_guestcmd;
+
+	DTRACE();
+
+	spin_lock_irqsave(&sync_state->lock, irq_flags);
+
+	batch_guestcmd->host_command = (uint64_t)cmd;
+	batch_guestcmd->glsync_handle = (uint64_t)glsync_handle;
+	batch_guestcmd->thread_handle = (uint64_t)thread_handle;
+	batch_guestcmd->guest_timeline_handle = (uint64_t)timeline_handle;
+	writel(0, sync_state->reg_base + SYNC_REG_BATCH_GUESTCOMMAND);
+
+	spin_unlock_irqrestore(&sync_state->lock, irq_flags);
+}
+
+/* |goldfish_sync_interrupt| handles IRQ raises from the virtual device.
+ * In the context of OpenGL, this interrupt will fire whenever we need
+ * to signal a fence fd in the guest, with the command
+ * |CMD_SYNC_TIMELINE_INC|.
+ * However, because this function will be called in an interrupt context,
+ * it is necessary to do the actual work of signaling off of interrupt context.
+ * The shared work queue is used for this purpose. At the end when
+ * all pending commands are intercepted by the interrupt handler,
+ * we call |schedule_work|, which will later run the actual
+ * desired sync command in |goldfish_sync_work_item_fn|.
+ */
+static irqreturn_t goldfish_sync_interrupt(int irq, void *dev_id)
+{
+
+	struct goldfish_sync_state *sync_state = dev_id;
+
+	uint32_t nextcmd;
+	uint32_t command_r;
+	uint64_t handle_rw;
+	uint32_t time_r;
+	uint64_t hostcmd_handle_rw;
+
+	int count = 0;
+
+	DTRACE();
+
+	sync_state = dev_id;
+
+	spin_lock(&sync_state->lock);
+
+	for (;;) {
+
+		readl(sync_state->reg_base + SYNC_REG_BATCH_COMMAND);
+		nextcmd = sync_state->batch_hostcmd->cmd;
+
+		if (nextcmd == 0)
+			break;
+
+		command_r = nextcmd;
+		handle_rw = sync_state->batch_hostcmd->handle;
+		time_r = sync_state->batch_hostcmd->time_arg;
+		hostcmd_handle_rw = sync_state->batch_hostcmd->hostcmd_handle;
+
+		goldfish_sync_cmd_queue(
+				sync_state,
+				command_r,
+				handle_rw,
+				time_r,
+				hostcmd_handle_rw);
+
+		count++;
+	}
+
+	spin_unlock(&sync_state->lock);
+
+	schedule_work(&sync_state->work_item);
+
+	return (count == 0) ? IRQ_NONE : IRQ_HANDLED;
+}
+
+/* |goldfish_sync_work_item_fn| does the actual work of servicing
+ * host->guest sync commands. This function is triggered whenever
+ * the IRQ for the goldfish sync device is raised. Once it starts
+ * running, it grabs the contents of the buffer containing the
+ * commands it needs to execute (there may be multiple, because
+ * our IRQ is active high and not edge triggered), and then
+ * runs all of them one after the other.
+ */
+static void goldfish_sync_work_item_fn(struct work_struct *input)
+{
+
+	struct goldfish_sync_state *sync_state;
+	int sync_fence_fd;
+
+	struct goldfish_sync_timeline_obj *timeline;
+	uint64_t timeline_ptr;
+
+	uint64_t hostcmd_handle;
+
+	uint32_t cmd;
+	uint64_t handle;
+	uint32_t time_arg;
+
+	struct goldfish_sync_hostcmd *todo;
+	uint32_t todo_end;
+
+	unsigned long irq_flags;
+
+	struct goldfish_sync_hostcmd to_run[GOLDFISH_SYNC_MAX_CMDS];
+	uint32_t i = 0;
+
+	sync_state = container_of(input, struct goldfish_sync_state, work_item);
+
+	mutex_lock(&sync_state->mutex_lock);
+
+	spin_lock_irqsave(&sync_state->lock, irq_flags); {
+
+		todo_end = sync_state->to_do_end;
+
+		DPRINT("num sync todos: %u", sync_state->to_do_end);
+
+		for (i = 0; i < todo_end; i++)
+			to_run[i] = sync_state->to_do[i];
+
+		/* We expect that commands will come in at a slow enough rate
+		 * so that incoming items will not be more than
+		 * GOLDFISH_SYNC_MAX_CMDS.
+		 *
+		 * This is because the way the sync device is used,
+		 * it's only for managing buffer data transfers per frame,
+		 * with a sequential dependency between putting things in
+		 * to_do and taking them out. Once a set of commands is
+		 * queued up in to_do, the user of the device waits for
+		 * them to be processed before queuing additional commands,
+		 * which limits the rate at which commands come in
+		 * to the rate at which we take them out here.
+		 *
+		 * We also don't expect more than MAX_CMDS to be issued
+		 * at once; there is a correspondence between
+		 * which buffers need swapping to the (display / buffer queue)
+		 * to particular commands, and we don't expect there to be
+		 * enough display or buffer queues in operation at once
+		 * to overrun GOLDFISH_SYNC_MAX_CMDS.
+		 */
+		sync_state->to_do_end = 0;
+
+	} spin_unlock_irqrestore(&sync_state->lock, irq_flags);
+
+	for (i = 0; i < todo_end; i++) {
+		DPRINT("todo index: %u", i);
+
+		todo = &to_run[i];
+
+		cmd = todo->cmd;
+
+		handle = (uint64_t)todo->handle;
+		time_arg = todo->time_arg;
+		hostcmd_handle = (uint64_t)todo->hostcmd_handle;
+
+		DTRACE();
+
+		timeline = (struct goldfish_sync_timeline_obj *)(uintptr_t)handle;
+
+		switch (cmd) {
+		case CMD_SYNC_READY:
+			break;
+		case CMD_CREATE_SYNC_TIMELINE:
+			DPRINT("exec CMD_CREATE_SYNC_TIMELINE: "
+					"handle=0x%llx time_arg=%d",
+					handle, time_arg);
+			timeline = goldfish_sync_timeline_create();
+			timeline_ptr = (uintptr_t)timeline;
+			goldfish_sync_hostcmd_reply(sync_state, CMD_CREATE_SYNC_TIMELINE,
+										timeline_ptr,
+										0,
+										hostcmd_handle);
+			DPRINT("sync timeline created: %p", timeline);
+			break;
+		case CMD_CREATE_SYNC_FENCE:
+			DPRINT("exec CMD_CREATE_SYNC_FENCE: "
+					"handle=0x%llx time_arg=%d",
+					handle, time_arg);
+			sync_fence_fd = goldfish_sync_fence_create(timeline, time_arg);
+			goldfish_sync_hostcmd_reply(sync_state, CMD_CREATE_SYNC_FENCE,
+										sync_fence_fd,
+										0,
+										hostcmd_handle);
+			break;
+		case CMD_SYNC_TIMELINE_INC:
+			DPRINT("exec CMD_SYNC_TIMELINE_INC: "
+					"handle=0x%llx time_arg=%d",
+					handle, time_arg);
+			goldfish_sync_timeline_inc(timeline, time_arg);
+			break;
+		case CMD_DESTROY_SYNC_TIMELINE:
+			DPRINT("exec CMD_DESTROY_SYNC_TIMELINE: "
+					"handle=0x%llx time_arg=%d",
+					handle, time_arg);
+			goldfish_sync_timeline_destroy(timeline);
+			break;
+		}
+		DPRINT("Done executing sync command");
+	}
+	mutex_unlock(&sync_state->mutex_lock);
+}
+
+/* Guest-side interface: file operations */
+
+/* Goldfish sync context and ioctl info.
+ *
+ * When a sync context is created by open()-ing the goldfish sync device, we
+ * create a sync context (|goldfish_sync_context|).
+ *
+ * Currently, the only data required to track is the sync timeline itself
+ * along with the current time, which are all packed up in the
+ * |goldfish_sync_timeline_obj| field. We use a |goldfish_sync_context|
+ * as the filp->private_data.
+ *
+ * Next, when a sync context user requests that work be queued and a fence
+ * fd provided, we use the |goldfish_sync_ioctl_info| struct, which holds
+ * information about which host handles to touch for this particular
+ * queue-work operation. We need to know about the host-side sync thread
+ * and the particular host-side GLsync object. We also possibly write out
+ * a file descriptor.
+ */
+struct goldfish_sync_context {
+	struct goldfish_sync_timeline_obj *timeline;
+};
+
+struct goldfish_sync_ioctl_info {
+	uint64_t host_glsync_handle_in;
+	uint64_t host_syncthread_handle_in;
+	int fence_fd_out;
+};
+
+static int goldfish_sync_open(struct inode *inode, struct file *file)
+{
+
+	struct goldfish_sync_context *sync_context;
+
+	DTRACE();
+
+	mutex_lock(&global_sync_state->mutex_lock);
+
+	sync_context = kzalloc(sizeof(struct goldfish_sync_context), GFP_KERNEL);
+
+	if (sync_context == NULL) {
+		ERR("Creation of goldfish sync context failed!");
+		mutex_unlock(&global_sync_state->mutex_lock);
+		return -ENOMEM;
+	}
+
+	sync_context->timeline = NULL;
+
+	file->private_data = sync_context;
+
+	DPRINT("successfully create a sync context @0x%p", sync_context);
+
+	mutex_unlock(&global_sync_state->mutex_lock);
+
+	return 0;
+}
+
+static int goldfish_sync_release(struct inode *inode, struct file *file)
+{
+
+	struct goldfish_sync_context *sync_context;
+
+	DTRACE();
+
+	mutex_lock(&global_sync_state->mutex_lock);
+
+	sync_context = file->private_data;
+
+	if (sync_context->timeline)
+		goldfish_sync_timeline_destroy(sync_context->timeline);
+
+	sync_context->timeline = NULL;
+
+	kfree(sync_context);
+
+	mutex_unlock(&global_sync_state->mutex_lock);
+
+	return 0;
+}
+
+/* |goldfish_sync_ioctl| is the guest-facing interface of goldfish sync
+ * and is used in conjunction with eglCreateSyncKHR to queue up the
+ * actual work of waiting for the EGL sync command to complete,
+ * possibly returning a fence fd to the guest.
+ */
+static long goldfish_sync_ioctl(struct file *file,
+								unsigned int cmd,
+								unsigned long arg)
+{
+	struct goldfish_sync_context *sync_context_data;
+	struct goldfish_sync_timeline_obj *timeline;
+	int fd_out;
+	struct goldfish_sync_ioctl_info ioctl_data;
+
+	DTRACE();
+
+	sync_context_data = file->private_data;
+	fd_out = -1;
+
+	switch (cmd) {
+	case GOLDFISH_SYNC_IOC_QUEUE_WORK:
+
+		DPRINT("exec GOLDFISH_SYNC_IOC_QUEUE_WORK");
+
+		mutex_lock(&global_sync_state->mutex_lock);
+
+		if (copy_from_user(&ioctl_data,
+						(void __user *)arg,
+						sizeof(ioctl_data))) {
+			ERR("Failed to copy memory for ioctl_data from user.");
+			mutex_unlock(&global_sync_state->mutex_lock);
+			return -EFAULT;
+		}
+
+		if (ioctl_data.host_syncthread_handle_in == 0) {
+			DPRINT("Error: zero host syncthread handle!!!");
+			mutex_unlock(&global_sync_state->mutex_lock);
+			return -EFAULT;
+		}
+
+		if (!sync_context_data->timeline) {
+			DPRINT("no timeline yet, create one.");
+			sync_context_data->timeline = goldfish_sync_timeline_create();
+			DPRINT("timeline: 0x%p", &sync_context_data->timeline);
+		}
+
+		timeline = sync_context_data->timeline;
+		fd_out = goldfish_sync_fence_create(timeline,
+											timeline->current_time + 1);
+		DPRINT("Created fence with fd %d and current time %u (timeline: 0x%p)",
+			   fd_out,
+			   sync_context_data->timeline->current_time + 1,
+			   sync_context_data->timeline);
+
+		ioctl_data.fence_fd_out = fd_out;
+
+		if (copy_to_user((void __user *)arg,
+						&ioctl_data,
+						sizeof(ioctl_data))) {
+			DPRINT("Error, could not copy to user!!!");
+
+			sys_close(fd_out);
+			/* We won't be doing an increment, kref_put immediately. */
+			kref_put(&timeline->kref, delete_timeline_obj);
+			mutex_unlock(&global_sync_state->mutex_lock);
+			return -EFAULT;
+		}
+
+		/* We are now about to trigger a host-side wait;
+		 * accumulate on |pending_waits|. */
+		goldfish_sync_send_guestcmd(global_sync_state,
+				CMD_TRIGGER_HOST_WAIT,
+				ioctl_data.host_glsync_handle_in,
+				ioctl_data.host_syncthread_handle_in,
+				(uint64_t)(uintptr_t)(sync_context_data->timeline));
+
+		mutex_unlock(&global_sync_state->mutex_lock);
+		return 0;
+	default:
+		return -ENOTTY;
+	}
+}
+
+static const struct file_operations goldfish_sync_fops = {
+	.owner = THIS_MODULE,
+	.open = goldfish_sync_open,
+	.release = goldfish_sync_release,
+	.unlocked_ioctl = goldfish_sync_ioctl,
+	.compat_ioctl = goldfish_sync_ioctl,
+};
+
+static struct miscdevice goldfish_sync_device = {
+	.name = "goldfish_sync",
+	.fops = &goldfish_sync_fops,
+};
+
+
+static bool setup_verify_batch_cmd_addr(struct goldfish_sync_state *sync_state,
+										void *batch_addr,
+										uint32_t addr_offset,
+										uint32_t addr_offset_high)
+{
+	uint64_t batch_addr_phys;
+	uint32_t batch_addr_phys_test_lo;
+	uint32_t batch_addr_phys_test_hi;
+
+	if (!batch_addr) {
+		ERR("Could not use batch command address!");
+		return false;
+	}
+
+	batch_addr_phys = virt_to_phys(batch_addr);
+	writel((uint32_t)(batch_addr_phys),
+			sync_state->reg_base + addr_offset);
+	writel((uint32_t)(batch_addr_phys >> 32),
+			sync_state->reg_base + addr_offset_high);
+
+	batch_addr_phys_test_lo =
+		readl(sync_state->reg_base + addr_offset);
+	batch_addr_phys_test_hi =
+		readl(sync_state->reg_base + addr_offset_high);
+
+	if (virt_to_phys(batch_addr) !=
+			(((uint64_t)batch_addr_phys_test_hi << 32) |
+			 batch_addr_phys_test_lo)) {
+		ERR("Invalid batch command address!");
+		return false;
+	}
+
+	return true;
+}
+
+int goldfish_sync_probe(struct platform_device *pdev)
+{
+	struct resource *ioresource;
+	struct goldfish_sync_state *sync_state = global_sync_state;
+	int status;
+
+	DTRACE();
+
+	sync_state->to_do_end = 0;
+
+	spin_lock_init(&sync_state->lock);
+	mutex_init(&sync_state->mutex_lock);
+
+	platform_set_drvdata(pdev, sync_state);
+
+	ioresource = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (ioresource == NULL) {
+		ERR("platform_get_resource failed");
+		return -ENODEV;
+	}
+
+	sync_state->reg_base =
+		devm_ioremap(&pdev->dev, ioresource->start, PAGE_SIZE);
+	if (sync_state->reg_base == NULL) {
+		ERR("Could not ioremap");
+		return -ENOMEM;
+	}
+
+	sync_state->irq = platform_get_irq(pdev, 0);
+	if (sync_state->irq < 0) {
+		ERR("Could not platform_get_irq");
+		return -ENODEV;
+	}
+
+	status = devm_request_irq(&pdev->dev,
+							sync_state->irq,
+							goldfish_sync_interrupt,
+							IRQF_SHARED,
+							pdev->name,
+							sync_state);
+	if (status) {
+		ERR("request_irq failed");
+		return -ENODEV;
+	}
+
+	INIT_WORK(&sync_state->work_item,
+			  goldfish_sync_work_item_fn);
+
+	misc_register(&goldfish_sync_device);
+
+	/* Obtain addresses for batch send/recv of commands. */
+	{
+		struct goldfish_sync_hostcmd *batch_addr_hostcmd;
+		struct goldfish_sync_guestcmd *batch_addr_guestcmd;
+
+		batch_addr_hostcmd =
+			devm_kzalloc(&pdev->dev, sizeof(struct goldfish_sync_hostcmd),
+				GFP_KERNEL);
+		batch_addr_guestcmd =
+			devm_kzalloc(&pdev->dev, sizeof(struct goldfish_sync_guestcmd),
+				GFP_KERNEL);
+
+		if (!setup_verify_batch_cmd_addr(sync_state,
+					batch_addr_hostcmd,
+					SYNC_REG_BATCH_COMMAND_ADDR,
+					SYNC_REG_BATCH_COMMAND_ADDR_HIGH)) {
+			ERR("goldfish_sync: Could not setup batch command address");
+			return -ENODEV;
+		}
+
+		if (!setup_verify_batch_cmd_addr(sync_state,
+					batch_addr_guestcmd,
+					SYNC_REG_BATCH_GUESTCOMMAND_ADDR,
+					SYNC_REG_BATCH_GUESTCOMMAND_ADDR_HIGH)) {
+			ERR("goldfish_sync: Could not setup batch guest command address");
+			return -ENODEV;
+		}
+
+		sync_state->batch_hostcmd = batch_addr_hostcmd;
+		sync_state->batch_guestcmd = batch_addr_guestcmd;
+	}
+
+	INFO("goldfish_sync: Initialized goldfish sync device");
+
+	writel(0, sync_state->reg_base + SYNC_REG_INIT);
+
+	return 0;
+}
+
+static int goldfish_sync_remove(struct platform_device *pdev)
+{
+	struct goldfish_sync_state *sync_state = global_sync_state;
+
+	DTRACE();
+
+	misc_deregister(&goldfish_sync_device);
+	memset(sync_state, 0, sizeof(struct goldfish_sync_state));
+	return 0;
+}
+
+static const struct of_device_id goldfish_sync_of_match[] = {
+	{ .compatible = "google,goldfish-sync", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, goldfish_sync_of_match);
+
+static const struct acpi_device_id goldfish_sync_acpi_match[] = {
+	{ "GFSH0006", 0 },
+	{ },
+};
+
+MODULE_DEVICE_TABLE(acpi, goldfish_sync_acpi_match);
+
+static struct platform_driver goldfish_sync = {
+	.probe = goldfish_sync_probe,
+	.remove = goldfish_sync_remove,
+	.driver = {
+		.name = "goldfish_sync",
+		.of_match_table = goldfish_sync_of_match,
+		.acpi_match_table = ACPI_PTR(goldfish_sync_acpi_match),
+	}
+};
+
+module_platform_driver(goldfish_sync);
+
+MODULE_AUTHOR("Google, Inc.");
+MODULE_DESCRIPTION("Android QEMU Sync Driver");
+MODULE_LICENSE("GPL");
+MODULE_VERSION("1.0");
diff --git a/drivers/staging/goldfish/goldfish_sync_timeline_fence.c b/drivers/staging/goldfish/goldfish_sync_timeline_fence.c
new file mode 100644
index 00000000..e671618
--- /dev/null
+++ b/drivers/staging/goldfish/goldfish_sync_timeline_fence.c
@@ -0,0 +1,254 @@
+#include <linux/slab.h>
+#include <linux/fs.h>
+#include <linux/syscalls.h>
+#include <linux/sync_file.h>
+#include <linux/fence.h>
+
+#include "goldfish_sync_timeline_fence.h"
+
+/*
+ * Timeline-based sync for Goldfish Sync
+ * Based on "Sync File validation framework"
+ * (drivers/dma-buf/sw_sync.c)
+ *
+ * Copyright (C) 2017 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+/**
+ * struct goldfish_sync_timeline - sync object
+ * @kref:		reference count on fence.
+ * @name:		name of the goldfish_sync_timeline. Useful for debugging
+ * @child_list_head:	list of children sync_pts for this goldfish_sync_timeline
+ * @child_list_lock:	lock protecting @child_list_head and fence.status
+ * @active_list_head:	list of active (unsignaled/errored) sync_pts
+ */
+struct goldfish_sync_timeline {
+	struct kref		kref;
+	char			name[32];
+
+	/* protected by child_list_lock */
+	u64			context;
+	int			value;
+
+	struct list_head	child_list_head;
+	spinlock_t		child_list_lock;
+
+	struct list_head	active_list_head;
+};
+
+static inline struct goldfish_sync_timeline *fence_parent(struct fence *fence)
+{
+	return container_of(fence->lock, struct goldfish_sync_timeline,
+				child_list_lock);
+}
+
+static const struct fence_ops goldfish_sync_timeline_fence_ops;
+
+static inline struct sync_pt *goldfish_sync_fence_to_sync_pt(struct fence *fence)
+{
+	if (fence->ops != &goldfish_sync_timeline_fence_ops)
+		return NULL;
+	return container_of(fence, struct sync_pt, base);
+}
+
+/**
+ * goldfish_sync_timeline_create_internal() - creates a sync object
+ * @name:	sync_timeline name
+ *
+ * Creates a new sync_timeline. Returns the sync_timeline object or NULL in
+ * case of error.
+ */
+struct goldfish_sync_timeline
+*goldfish_sync_timeline_create_internal(const char *name)
+{
+	struct goldfish_sync_timeline *obj;
+
+	obj = kzalloc(sizeof(*obj), GFP_KERNEL);
+	if (!obj)
+		return NULL;
+
+	kref_init(&obj->kref);
+	obj->context = fence_context_alloc(1);
+	strlcpy(obj->name, name, sizeof(obj->name));
+
+	INIT_LIST_HEAD(&obj->child_list_head);
+	INIT_LIST_HEAD(&obj->active_list_head);
+	spin_lock_init(&obj->child_list_lock);
+
+	return obj;
+}
+
+static void goldfish_sync_timeline_free_internal(struct kref *kref)
+{
+	struct goldfish_sync_timeline *obj =
+		container_of(kref, struct goldfish_sync_timeline, kref);
+
+	kfree(obj);
+}
+
+static void goldfish_sync_timeline_get_internal(
+					struct goldfish_sync_timeline *obj)
+{
+	kref_get(&obj->kref);
+}
+
+void goldfish_sync_timeline_put_internal(struct goldfish_sync_timeline *obj)
+{
+	kref_put(&obj->kref, goldfish_sync_timeline_free_internal);
+}
+
+/**
+ * goldfish_sync_timeline_signal() -
+ * signal a status change on a goldfish_sync_timeline
+ * @obj:	sync_timeline to signal
+ * @inc:	num to increment on timeline->value
+ *
+ * A sync implementation should call this any time one of it's fences
+ * has signaled or has an error condition.
+ */
+void goldfish_sync_timeline_signal_internal(struct goldfish_sync_timeline *obj,
+											unsigned int inc)
+{
+	unsigned long flags;
+	struct sync_pt *pt, *next;
+
+	spin_lock_irqsave(&obj->child_list_lock, flags);
+
+	obj->value += inc;
+
+	list_for_each_entry_safe(pt, next, &obj->active_list_head,
+				 active_list) {
+		if (fence_is_signaled_locked(&pt->base))
+			list_del_init(&pt->active_list);
+	}
+
+	spin_unlock_irqrestore(&obj->child_list_lock, flags);
+}
+
+/**
+ * goldfish_sync_pt_create_internal() - creates a sync pt
+ * @parent:	fence's parent sync_timeline
+ * @size:	size to allocate for this pt
+ * @inc:	value of the fence
+ *
+ * Creates a new sync_pt as a child of @parent.  @size bytes will be
+ * allocated allowing for implementation specific data to be kept after
+ * the generic sync_timeline struct. Returns the sync_pt object or
+ * NULL in case of error.
+ */
+struct sync_pt *goldfish_sync_pt_create_internal(
+					struct goldfish_sync_timeline *obj, int size,
+				 	unsigned int value)
+{
+	unsigned long flags;
+	struct sync_pt *pt;
+
+	if (size < sizeof(*pt))
+		return NULL;
+
+	pt = kzalloc(size, GFP_KERNEL);
+	if (!pt)
+		return NULL;
+
+	spin_lock_irqsave(&obj->child_list_lock, flags);
+	goldfish_sync_timeline_get_internal(obj);
+	fence_init(&pt->base, &goldfish_sync_timeline_fence_ops, &obj->child_list_lock,
+		   obj->context, value);
+	list_add_tail(&pt->child_list, &obj->child_list_head);
+	INIT_LIST_HEAD(&pt->active_list);
+	spin_unlock_irqrestore(&obj->child_list_lock, flags);
+	return pt;
+}
+
+static const char *goldfish_sync_timeline_fence_get_driver_name(
+						struct fence *fence)
+{
+	return "sw_sync";
+}
+
+static const char *goldfish_sync_timeline_fence_get_timeline_name(
+						struct fence *fence)
+{
+	struct goldfish_sync_timeline *parent = fence_parent(fence);
+
+	return parent->name;
+}
+
+static void goldfish_sync_timeline_fence_release(struct fence *fence)
+{
+	struct sync_pt *pt = goldfish_sync_fence_to_sync_pt(fence);
+	struct goldfish_sync_timeline *parent = fence_parent(fence);
+	unsigned long flags;
+
+	spin_lock_irqsave(fence->lock, flags);
+	list_del(&pt->child_list);
+	if (!list_empty(&pt->active_list))
+		list_del(&pt->active_list);
+	spin_unlock_irqrestore(fence->lock, flags);
+
+	goldfish_sync_timeline_put_internal(parent);
+	fence_free(fence);
+}
+
+static bool goldfish_sync_timeline_fence_signaled(struct fence *fence)
+{
+	struct goldfish_sync_timeline *parent = fence_parent(fence);
+
+	return (fence->seqno > parent->value) ? false : true;
+}
+
+static bool goldfish_sync_timeline_fence_enable_signaling(struct fence *fence)
+{
+	struct sync_pt *pt = goldfish_sync_fence_to_sync_pt(fence);
+	struct goldfish_sync_timeline *parent = fence_parent(fence);
+
+	if (goldfish_sync_timeline_fence_signaled(fence))
+		return false;
+
+	list_add_tail(&pt->active_list, &parent->active_list_head);
+	return true;
+}
+
+static void goldfish_sync_timeline_fence_disable_signaling(struct fence *fence)
+{
+	struct sync_pt *pt = container_of(fence, struct sync_pt, base);
+
+	list_del_init(&pt->active_list);
+}
+
+static void goldfish_sync_timeline_fence_value_str(struct fence *fence,
+					char *str, int size)
+{
+	snprintf(str, size, "%d", fence->seqno);
+}
+
+static void goldfish_sync_timeline_fence_timeline_value_str(
+				struct fence *fence,
+				char *str, int size)
+{
+	struct goldfish_sync_timeline *parent = fence_parent(fence);
+
+	snprintf(str, size, "%d", parent->value);
+}
+
+static const struct fence_ops goldfish_sync_timeline_fence_ops = {
+	.get_driver_name = goldfish_sync_timeline_fence_get_driver_name,
+	.get_timeline_name = goldfish_sync_timeline_fence_get_timeline_name,
+	.enable_signaling = goldfish_sync_timeline_fence_enable_signaling,
+	.disable_signaling = goldfish_sync_timeline_fence_disable_signaling,
+	.signaled = goldfish_sync_timeline_fence_signaled,
+	.wait = fence_default_wait,
+	.release = goldfish_sync_timeline_fence_release,
+	.fence_value_str = goldfish_sync_timeline_fence_value_str,
+	.timeline_value_str = goldfish_sync_timeline_fence_timeline_value_str,
+};
diff --git a/drivers/staging/goldfish/goldfish_sync_timeline_fence.h b/drivers/staging/goldfish/goldfish_sync_timeline_fence.h
new file mode 100644
index 00000000..fc25924
--- /dev/null
+++ b/drivers/staging/goldfish/goldfish_sync_timeline_fence.h
@@ -0,0 +1,58 @@
+#include <linux/sync_file.h>
+#include <linux/fence.h>
+
+/**
+ * struct sync_pt - sync_pt object
+ * @base: base fence object
+ * @child_list: sync timeline child's list
+ * @active_list: sync timeline active child's list
+ */
+struct sync_pt {
+	struct fence base;
+	struct list_head child_list;
+	struct list_head active_list;
+};
+
+/**
+ * goldfish_sync_timeline_create_internal() - creates a sync object
+ * @name:	goldfish_sync_timeline name
+ *
+ * Creates a new goldfish_sync_timeline.
+ * Returns the goldfish_sync_timeline object or NULL in case of error.
+ */
+struct goldfish_sync_timeline
+*goldfish_sync_timeline_create_internal(const char *name);
+
+/**
+ * goldfish_sync_pt_create_internal() - creates a sync pt
+ * @parent:	fence's parent goldfish_sync_timeline
+ * @size:	size to allocate for this pt
+ * @inc:	value of the fence
+ *
+ * Creates a new sync_pt as a child of @parent.  @size bytes will be
+ * allocated allowing for implementation specific data to be kept after
+ * the generic sync_timeline struct. Returns the sync_pt object or
+ * NULL in case of error.
+ */
+struct sync_pt
+*goldfish_sync_pt_create_internal(struct goldfish_sync_timeline *obj,
+									int size, unsigned int value);
+
+/**
+ * goldfish_sync_timeline_signal_internal() -
+ * signal a status change on a sync_timeline
+ * @obj:	goldfish_sync_timeline to signal
+ * @inc:	num to increment on timeline->value
+ *
+ * A sync implementation should call this any time one of it's fences
+ * has signaled or has an error condition.
+ */
+void goldfish_sync_timeline_signal_internal(struct goldfish_sync_timeline *obj,
+											unsigned int inc);
+
+/**
+ * goldfish_sync_timeline_put_internal() - dec refcount of a sync_timeline
+ * and clean up memory if it was the last ref.
+ * @obj:	goldfish_sync_timeline to decref
+ */
+void goldfish_sync_timeline_put_internal(struct goldfish_sync_timeline *obj);
diff --git a/drivers/staging/lustre/lustre/mdc/mdc_request.c b/drivers/staging/lustre/lustre/mdc/mdc_request.c
index f56ea64..6a146f4 100644
--- a/drivers/staging/lustre/lustre/mdc/mdc_request.c
+++ b/drivers/staging/lustre/lustre/mdc/mdc_request.c
@@ -1219,9 +1219,9 @@ struct readpage_param {
  * in PAGE_SIZE (if PAGE_SIZE greater than LU_PAGE_SIZE), and the
  * lu_dirpage for this integrated page will be adjusted.
  **/
-static int mdc_read_page_remote(void *data, struct page *page0)
+static int mdc_read_page_remote(struct file *data, struct page *page0)
 {
-	struct readpage_param *rp = data;
+	struct readpage_param *rp = (struct readpage_param *)data;
 	struct page **page_pool;
 	struct page *page;
 	struct lu_dirpage *dp;
diff --git a/drivers/staging/media/Kconfig b/drivers/staging/media/Kconfig
index 6620d96..4c3fcd9 100644
--- a/drivers/staging/media/Kconfig
+++ b/drivers/staging/media/Kconfig
@@ -38,4 +38,5 @@ source "drivers/staging/media/lirc/Kconfig"
 
 source "drivers/staging/media/st-cec/Kconfig"
 
+source "drivers/staging/media/rtk-cec/Kconfig"
 endif
diff --git a/drivers/staging/media/Makefile b/drivers/staging/media/Makefile
index 906257e..a4b2f44 100644
--- a/drivers/staging/media/Makefile
+++ b/drivers/staging/media/Makefile
@@ -7,3 +7,4 @@ obj-$(CONFIG_VIDEO_DM365_VPFE)	+= davinci_vpfe/
 obj-$(CONFIG_VIDEO_OMAP4)	+= omap4iss/
 obj-$(CONFIG_USB_PULSE8_CEC)    += pulse8-cec/
 obj-$(CONFIG_VIDEO_STI_HDMI_CEC) += st-cec/
+obj-$(CONFIG_RTK_HDMI_CEC) 	+= rtk-cec/
diff --git a/drivers/staging/media/rtk-cec/Kconfig b/drivers/staging/media/rtk-cec/Kconfig
new file mode 100644
index 00000000..aab3cae
--- /dev/null
+++ b/drivers/staging/media/rtk-cec/Kconfig
@@ -0,0 +1,9 @@
+config RTK_HDMI_CEC
+       tristate "Realtek HDMI CEC driver"
+       depends on MEDIA_CEC
+       ---help---
+         This is a driver for Realtek HDMI CEC interface. It uses the
+         generic CEC framework interface.
+         CEC bus is present in the HDMI connector and enables communication
+         between compatible devices.
+
diff --git a/drivers/staging/media/rtk-cec/Makefile b/drivers/staging/media/rtk-cec/Makefile
new file mode 100644
index 00000000..f1397ee
--- /dev/null
+++ b/drivers/staging/media/rtk-cec/Makefile
@@ -0,0 +1 @@
+obj-$(CONFIG_RTK_HDMI_CEC) += rtk_cec.o
diff --git a/drivers/staging/media/rtk-cec/rtk_cec.c b/drivers/staging/media/rtk-cec/rtk_cec.c
new file mode 100644
index 00000000..76f945b
--- /dev/null
+++ b/drivers/staging/media/rtk-cec/rtk_cec.c
@@ -0,0 +1,414 @@
+/* drivers/media/platform/rtk-cec/rtk_cec.c
+ *
+ * Realtek HDMI CEC driver
+ *
+ * Copyright (c) 2019 Realtek Co., Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/interrupt.h>
+#include <linux/clk.h>
+#include <linux/pm_runtime.h>
+#include <media/cec.h>
+
+#include "rtk_cec.h"
+
+#define CEC_NAME	"rtk-cec"
+
+#define XTAL_CLK		27000000
+#define PRE_DIV_TARGET		800000
+#define TIMER_DIV_TARGET	40000
+#define RPU_SELECT		0x17
+
+#define TX_FIFO_NUM		4
+
+#define BROADCAST_ADDR (0x1 << 31)
+#define IS_BROADCAST(x) (((x) & BROADCAST_ADDR) >> 31)
+#define ININ_ADDR_MASK (0xF << 8)
+#define GET_INIT_ADDR(x) (((x) & ININ_ADDR_MASK) >> 8)
+
+#define GET_LOGICAL_ADDR(x) (((x) & LOG_ADDR_MASK) >> LOG_ADDR_SHIFT)
+
+static void rtk_cec_rx_reset(struct rtk_cec_dev *cec)
+{
+	writel(RX_INT_CLEAR | RX_RESET, cec->reg + CEC_RXCR0);
+	writel(0, cec->reg + CEC_RXCR0);
+}
+
+static void rtk_cec_tx_reset(struct rtk_cec_dev *cec)
+{
+	writel(TX_INT_CLEAR | TX_RESET, cec->reg + CEC_TXCR0);
+	writel(0, cec->reg + CEC_TXCR0);
+}
+
+static void rtk_cec_set_divider(struct rtk_cec_dev *cec)
+{
+	unsigned int reg;
+	unsigned short pre_div, timer_div;
+
+	reg = readl(cec->wrapper + WRAPPER_CTRL);
+	reg &= ~(1 << CLOCK_SEL_SHIFT);
+	writel(reg, cec->wrapper + WRAPPER_CTRL);
+
+	pre_div = XTAL_CLK / PRE_DIV_TARGET;
+	timer_div = PRE_DIV_TARGET / TIMER_DIV_TARGET;
+
+	reg = readl(cec->reg + CEC_CR0);
+	reg &= ~(PRE_DIV_MASK | TIMER_DIV_MASK);
+	reg |= (pre_div << PRE_DIV_SHIFT) | (timer_div << TIMER_DIV_SHIFT);
+	writel(reg, cec->reg + CEC_CR0);
+}
+
+static void rtk_cec_set_retries(struct rtk_cec_dev *cec, unsigned char retries)
+{
+	unsigned int reg;
+
+	reg = readl(cec->reg + CEC_RTCR0);
+	reg &= ~RETRY_NUM_MASK;
+	reg |= retries;
+	writel(reg, cec->reg + CEC_RTCR0);
+}
+
+static void rtk_cec_enable(struct rtk_cec_dev *cec)
+{
+	unsigned int reg;
+
+	reg = (1 << PAD_EN_SHIFT) | (1 << PAD_EN_MODE_SHIFT);
+	writel(reg, cec->reg + CEC_RTCR0);
+
+	rtk_cec_set_retries(cec, 2);
+
+	reg = (0x1A << TXDATA_LOW_SHIFT) | (0x23 << TXDATA_01_SHIFT) | 0x22;
+	writel(reg, cec->reg + CEC_TXTCR1);
+
+	reg = (0x93 << TXSTART_LOW_SHIFT) | 0x20;
+	writel(reg, cec->reg + CEC_TXTCR0);
+
+	reg = (0x8c << RXSTART_LOW_SHIFT) | (0xc1 << RXSTART_PERIOD_SHIFT) |
+				(0x2a << RXDATA_SAMPLE_SHIFT) | 0x52;
+	writel(reg, cec->reg + CEC_RXTCR0);
+
+	reg = readl(cec->reg + CEC_CR0);
+	reg |= (1 << CEC_MODE_SHIFT) | UNREG_ACK_EN;
+	reg &= ~(PAD_DATA_MASK);
+	writel(reg, cec->reg + CEC_CR0);
+
+	reg = SPECIAL_CMD_IRQ_EN | RPU_EN | RPU_SELECT;
+	writel(reg, cec->reg + CEC_PWR_SAVE);
+
+	reg = readl(cec->wrapper + WRAPPER_CTRL);
+	reg |= (1 << INT_ACPU_SHIFT) | (1 << INT_SCPU_SHIFT);
+	writel(reg, cec->wrapper + WRAPPER_CTRL);
+}
+
+static void rtk_cec_disable(struct rtk_cec_dev *cec)
+{
+	unsigned int reg;
+
+	reg = readl(cec->reg + CEC_CR0);
+	reg &= ~(1 << CEC_MODE_SHIFT);
+	writel(reg, cec->reg + CEC_CR0);
+}
+
+static void rtk_cec_rx_enable(struct rtk_cec_dev *cec)
+{
+	writel(RX_EN | RX_INT_EN, cec->reg + CEC_RXCR0);
+}
+
+static void rtk_cec_get_rx_buf(struct rtk_cec_dev *cec,
+			       unsigned int size, unsigned char *buf)
+{
+	unsigned int rxfifo[4];
+	int i;
+
+	memset(rxfifo, 0, sizeof(rxfifo));
+	for (i = 0; i < size; i += 4)
+		rxfifo[i >> 2] = __cpu_to_be32(readl(cec->reg + CEC_RXDR1 + i));
+
+       /* rxbuf left-shifted by 1 byte */
+       for (i = 3 ; i > 0 ; i--) {
+               rxfifo[i] = (rxfifo[i] & (0xFFFFFF)) << 8;
+               rxfifo[i] &= rxfifo[i-1] & (0xFF);
+       }
+       rxfifo[0] = (rxfifo[0] & 0xFFFFFF) << 8;
+
+       if (IS_BROADCAST(readl(cec->reg + CEC_RXCR0)))
+               rxfifo[0] |= GET_INIT_ADDR(readl(cec->reg + CEC_RXCR0)) << 4 |
+                                0xF;
+       else{
+               rxfifo[0] |= GET_INIT_ADDR(readl(cec->reg + CEC_RXCR0)) << 4 |
+                            GET_LOGICAL_ADDR(readl(cec->reg + CEC_CR0));
+       }
+
+
+	memcpy(buf, (unsigned char *)rxfifo, size);
+
+	writel(SUB_CNT | size, cec->reg + CEC_TXDR0);
+}
+
+static int rtk_cec_adap_enable(struct cec_adapter *adap, bool enable)
+{
+	struct rtk_cec_dev *cec = adap->priv;
+
+	dev_dbg(cec->dev, "%s start, %d\n", __func__, enable);
+	if (enable) {
+		rtk_cec_rx_reset(cec);
+		rtk_cec_tx_reset(cec);
+
+		rtk_cec_set_divider(cec);
+		rtk_cec_enable(cec);
+		rtk_cec_rx_enable(cec);
+	} else {
+		rtk_cec_rx_reset(cec);
+		rtk_cec_tx_reset(cec);
+
+		rtk_cec_disable(cec);
+	}
+	return 0;
+}
+
+static int rtk_cec_adap_log_addr(struct cec_adapter *adap, u8 addr)
+{
+	struct rtk_cec_dev *cec = adap->priv;
+	unsigned int reg;
+
+	dev_dbg(cec->dev, "%s addr = 0x%x\n", __func__, addr);
+	reg = readl(cec->reg + CEC_CR0);
+	reg &= ~(LOG_ADDR_MASK);
+	reg |= (addr & 0xf) << LOG_ADDR_SHIFT;
+	writel(reg, cec->reg + CEC_CR0);
+
+	cec->log_addr = addr;
+
+	return 0;
+}
+
+static int rtk_cec_adap_transmit(struct cec_adapter *adap, u8 attempts,
+				 u32 signal_free_time, struct cec_msg *msg)
+{
+	struct rtk_cec_dev *cec = adap->priv;
+	unsigned int txfifo[TX_FIFO_NUM];
+	unsigned int reg;
+	int remain;
+	int i;
+	int len;
+
+	len = msg->len - 1;
+
+	remain = TX_FIFO_CNT - (readl(cec->reg + CEC_TXCR0) & TX_FIFO_CNT);
+
+	if (msg->len > remain) {
+		dev_err(cec->dev, "tx fifo not enougth");
+		return -1;
+	}
+
+	rtk_cec_set_retries(cec, attempts);
+
+	rtk_cec_tx_reset(cec);
+
+	memcpy(txfifo, (msg->msg + 1), len);
+	for (i = 0; i < len; i += 4)
+		writel(__cpu_to_be32(txfifo[i >> 2]), cec->reg + CEC_TXDR1 + i);
+
+	writel(ADD_CNT | len, cec->reg + CEC_TXDR0);
+
+	reg = TX_ADDR_EN | (cec->log_addr << TX_LOG_ADDR_SHIFT)
+		| ((msg->msg[0] & 0xf) << TX_DEST_ADDR_SHIFT)
+		| TX_EN | TX_INT_EN;
+	writel(reg, cec->reg + CEC_TXCR0);
+
+	return 0;
+}
+
+static irqreturn_t rtk_cec_irq_handler(int irq, void *priv)
+{
+	struct rtk_cec_dev *cec = priv;
+	unsigned int reg;
+
+	dev_dbg(cec->dev, "irq received\n");
+
+	reg = readl(cec->reg + CEC_TXCR0);
+	if (reg & TX_INT) {
+		if (reg & TX_EOM) {
+			cec->tx = STATE_DONE;
+		} else {
+			dev_dbg(cec->dev, "tx transfer error\n");
+			cec->tx = STATE_ERROR;
+		}
+		writel(reg, cec->reg + CEC_TXCR0);
+	}
+
+	reg = readl(cec->reg + CEC_RXCR0);
+	if (reg & RX_INT) {
+		if (reg & RX_EN) {
+			dev_dbg(cec->dev, "over rx msg fifo\n");
+			cec->rx = STATE_ERROR;
+		} else if (reg & RX_EOM) {
+			reg = readl(cec->reg + CEC_RXCR0);
+			cec->msg.len = (reg & 0x1F) + 1;
+			cec->msg.rx_status = CEC_RX_STATUS_OK;
+			rtk_cec_get_rx_buf(cec, cec->msg.len, cec->msg.msg);
+			cec->rx = STATE_DONE;
+		}
+		rtk_cec_rx_reset(cec);
+		rtk_cec_rx_enable(cec);
+	}
+	return IRQ_WAKE_THREAD;
+}
+
+static irqreturn_t rtk_cec_irq_handler_thread(int irq, void *priv)
+{
+	struct rtk_cec_dev *cec = priv;
+
+	switch (cec->tx) {
+	case STATE_DONE:
+		cec_transmit_done(cec->adap, CEC_TX_STATUS_OK, 0, 0, 0, 0);
+		cec->tx = STATE_IDLE;
+		break;
+	case STATE_ERROR:
+		cec_transmit_done(cec->adap, CEC_TX_STATUS_MAX_RETRIES |
+				CEC_TX_STATUS_ERROR, 0, 0, 0, 1);
+		cec->tx = STATE_IDLE;
+		break;
+	case STATE_IDLE:
+		break;
+	default:
+		dev_err(cec->dev, "can't handle this tx state\n");
+		break;
+	}
+
+	switch (cec->rx) {
+	case STATE_DONE:
+		cec_received_msg(cec->adap, &cec->msg);
+		cec->rx = STATE_IDLE;
+		break;
+	default:
+		break;
+	}
+
+	return IRQ_HANDLED;
+}
+
+static const struct cec_adap_ops rtk_cec_adap_ops = {
+	.adap_enable = rtk_cec_adap_enable,
+	.adap_log_addr = rtk_cec_adap_log_addr,
+	.adap_transmit = rtk_cec_adap_transmit,
+};
+
+static int rtk_cec_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct resource *res;
+	struct rtk_cec_dev *cec;
+	int ret;
+
+	cec = devm_kzalloc(&pdev->dev, sizeof(*cec), GFP_KERNEL);
+	if (!cec)
+		return -ENOMEM;
+
+	cec->dev = dev;
+
+	cec->irq = platform_get_irq(pdev, 0);
+	if (cec->irq < 0)
+		return cec->irq;
+
+	ret = devm_request_threaded_irq(dev, cec->irq, rtk_cec_irq_handler,
+					rtk_cec_irq_handler_thread, 0,
+					pdev->name, cec);
+	if (ret)
+		return ret;
+
+	cec->clk_cbus_osc = devm_clk_get(dev, "cbus_osc");
+	if (IS_ERR(cec->clk_cbus_osc))
+		return PTR_ERR(cec->clk_cbus_osc);
+
+	cec->clk_cbus_sys = devm_clk_get(dev, "cbus_sys");
+	if (IS_ERR(cec->clk_cbus_sys))
+		return PTR_ERR(cec->clk_cbus_sys);
+
+	cec->clk_cbus_tx = devm_clk_get(dev, "cbustx_sys");
+	if (IS_ERR(cec->clk_cbus_tx))
+		return PTR_ERR(cec->clk_cbus_tx);
+
+	cec->rstc_cbus = devm_reset_control_get_shared(dev, "cbus");
+	if (IS_ERR(cec->rstc_cbus))
+		return PTR_ERR(cec->rstc_cbus);
+
+	cec->rstc_cbus_tx = devm_reset_control_get_shared(dev, "cbustx");
+	if (IS_ERR(cec->rstc_cbus_tx))
+		return PTR_ERR(cec->rstc_cbus_tx);
+
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	cec->reg = devm_ioremap_resource(dev, res);
+	if (IS_ERR(cec->reg))
+		return PTR_ERR(cec->reg);
+
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 1);
+	cec->wrapper = devm_ioremap_resource(dev, res);
+	if (IS_ERR(cec->wrapper))
+		return PTR_ERR(cec->wrapper);
+
+	cec->adap = cec_allocate_adapter(&rtk_cec_adap_ops, cec, CEC_NAME,
+		CEC_CAP_PHYS_ADDR | CEC_CAP_LOG_ADDRS | CEC_CAP_TRANSMIT |
+		CEC_CAP_PASSTHROUGH | CEC_CAP_RC,
+		1, &pdev->dev);
+	ret = PTR_ERR_OR_ZERO(cec->adap);
+	if (ret)
+		return ret;
+
+	ret = cec_register_adapter(cec->adap);
+	if (ret)
+		goto err_delete_adapter;
+
+	platform_set_drvdata(pdev, cec);
+
+	clk_prepare_enable(cec->clk_cbus_osc);
+	clk_prepare_enable(cec->clk_cbus_sys);
+	clk_prepare_enable(cec->clk_cbus_tx);
+
+	reset_control_deassert(cec->rstc_cbus);
+	reset_control_deassert(cec->rstc_cbus_tx);
+
+	return 0;
+
+err_delete_adapter:
+	cec_delete_adapter(cec->adap);
+	return ret;
+}
+
+static int rtk_cec_remove(struct platform_device *pdev)
+{
+	struct rtk_cec_dev *cec = platform_get_drvdata(pdev);
+
+	cec_unregister_adapter(cec->adap);
+	pm_runtime_disable(&pdev->dev);
+	return 0;
+}
+
+static const struct of_device_id rtk_cec_match[] = {
+	{
+		.compatible	= "Realtek,rtk-cec",
+	},
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_cec_match);
+
+static struct platform_driver rtk_cec_pdrv = {
+	.probe	= rtk_cec_probe,
+	.remove	= rtk_cec_remove,
+	.driver	= {
+		.name		= CEC_NAME,
+		.of_match_table	= rtk_cec_match,
+	},
+};
+module_platform_driver(rtk_cec_pdrv);
+
+MODULE_AUTHOR("Simon HSU <simon_hsu@realtek.com>");
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Realtek HDMI CEC driver");
diff --git a/drivers/staging/media/rtk-cec/rtk_cec.h b/drivers/staging/media/rtk-cec/rtk_cec.h
new file mode 100644
index 00000000..d0a0e35
--- /dev/null
+++ b/drivers/staging/media/rtk-cec/rtk_cec.h
@@ -0,0 +1,130 @@
+/* drivers/media/platform/rtk-cec/rtk_cec.h
+ *
+ * Realtek HDMI CEC driver
+ *
+ * Copyright (c) 2019 Realtek Co., Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _RTK_CEC_H_
+#define _RTK_CEC_H_ __FILE__
+
+#include <linux/clk.h>
+#include <linux/reset.h>
+
+/* CEC register define */
+#define CEC_CR0		(0x00)
+#define CEC_RTCR0	(0x04)
+#define CEC_RXCR0	(0x08)
+#define CEC_TXCR0	(0x0C)
+#define CEC_TXDR0	(0x10)
+#define CEC_TXDR1	(0x14)
+#define CEC_TXDR2	(0x18)
+#define CEC_TXDR3	(0x1C)
+#define CEC_TXDR4	(0x20)
+#define CEC_RXDR1	(0x24)
+#define CEC_RXDR2	(0x28)
+#define CEC_RXDR3	(0x2C)
+#define CEC_RXDR4	(0x30)
+#define CEC_RXTCR0	(0x34)
+#define CEC_TXTCR0	(0x38)
+#define CEC_TXTCR1	(0x3C)
+#define CEC_PWR_SAVE	(0xD0)
+
+/* For CEC_CR0 */
+#define CEC_MODE_SHIFT		(30)
+#define PRE_DIV_SHIFT		(8)
+#define TIMER_DIV_SHIFT		(16)
+#define LOG_ADDR_SHIFT		(24)
+#define PRE_DIV_MASK		(0xFF << PRE_DIV_SHIFT)
+#define TIMER_DIV_MASK		(0xFF << TIMER_DIV_SHIFT)
+#define LOG_ADDR_MASK		(0xF << LOG_ADDR_SHIFT)
+#define PAD_DATA_MASK		(0x1F)
+#define UNREG_ACK_EN		BIT(7)
+
+/* For CEC_RTCR0 */
+#define PAD_EN_SHIFT		(17)
+#define PAD_EN_MODE_SHIFT	(16)
+#define RETRY_NUM_MASK		(0xF)
+
+/* For CEC_RXCR0 */
+#define RX_INT_CLEAR		BIT(6)
+#define RX_INT			BIT(6)
+#define RX_EOM			BIT(7)
+#define RX_INT_EN		BIT(12)
+#define RX_RESET		BIT(14)
+#define RX_EN			BIT(15)
+
+/* For CEC_TXCR0 */
+#define TX_INT_CLEAR		BIT(6)
+#define TX_INT			BIT(6)
+#define TX_EOM			BIT(7)
+#define TX_INT_EN		BIT(12)
+#define TX_RESET		BIT(14)
+#define TX_EN			BIT(15)
+#define TX_ADDR_EN		BIT(20)
+#define TX_DEST_ADDR_SHIFT	(8)
+#define TX_LOG_ADDR_SHIFT	(16)
+#define TX_FIFO_CNT		(0x1F)
+
+/* For CEC_TXDR0 */
+#define SUB_CNT			BIT(5)
+#define ADD_CNT			BIT(6)
+
+/* For CEC_RXTCR0 */
+#define RXSTART_LOW_SHIFT	(24)
+#define RXSTART_PERIOD_SHIFT	(16)
+#define RXDATA_SAMPLE_SHIFT	(8)
+
+/* For CEC_TXTCR0 */
+#define TXSTART_LOW_SHIFT	(8)
+
+/* For CEC_TXTCR1 */
+#define TXDATA_LOW_SHIFT	(16)
+#define TXDATA_01_SHIFT		(8)
+
+/* For CEC_PWR_SAVE */
+#define RPU_MASK		(0x1F)
+#define RPU_EN			BIT(5)
+#define SPECIAL_CMD_IRQ_EN	BIT(8)
+
+/* CEC wrapper register define */
+#define WRAPPER_CTRL		(0x00)
+
+#define INT_ACPU_SHIFT		(16)
+#define INT_SCPU_SHIFT		(17)
+#define CLOCK_SEL_SHIFT		(26)
+
+enum cec_state {
+	STATE_IDLE,
+	STATE_BUSY,
+	STATE_DONE,
+	STATE_NACK,
+	STATE_ERROR
+};
+
+struct rtk_cec_dev {
+	struct cec_adapter	*adap;
+	struct cec_msg		msg;
+	struct device		*dev;
+
+	struct clk		*clk_cbus_osc;
+	struct clk		*clk_cbus_sys;
+	struct clk		*clk_cbus_tx;
+	struct reset_control	*rstc_cbus;
+	struct reset_control	*rstc_cbus_tx;
+
+	void __iomem		*reg;
+	void __iomem		*wrapper;
+	int			irq;
+
+	enum cec_state		rx;
+	enum cec_state		tx;
+	unsigned char		log_addr;
+};
+
+#endif /* _RTK_CEC_H_ */
diff --git a/drivers/switch/Kconfig b/drivers/switch/Kconfig
new file mode 100644
index 00000000..19404b6
--- /dev/null
+++ b/drivers/switch/Kconfig
@@ -0,0 +1,15 @@
+menuconfig SWITCH
+	tristate "Switch class support"
+	help
+	  Say Y here to enable switch class support. This allows
+	  monitoring switches by userspace via sysfs and uevent.
+
+if SWITCH
+
+config SWITCH_GPIO
+	tristate "GPIO Swith support"
+	depends on GPIOLIB
+	help
+	  Say Y here to enable GPIO based switch support.
+
+endif # SWITCH
diff --git a/drivers/switch/Makefile b/drivers/switch/Makefile
new file mode 100644
index 00000000..f7606ed
--- /dev/null
+++ b/drivers/switch/Makefile
@@ -0,0 +1,4 @@
+# Switch Class Driver
+obj-$(CONFIG_SWITCH)		+= switch_class.o
+obj-$(CONFIG_SWITCH_GPIO)	+= switch_gpio.o
+
diff --git a/drivers/switch/switch_class.c b/drivers/switch/switch_class.c
new file mode 100644
index 00000000..e373b62
--- /dev/null
+++ b/drivers/switch/switch_class.c
@@ -0,0 +1,174 @@
+/*
+ *  drivers/switch/switch_class.c
+ *
+ * Copyright (C) 2008 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+*/
+
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/init.h>
+#include <linux/device.h>
+#include <linux/fs.h>
+#include <linux/err.h>
+#include <linux/switch.h>
+
+struct class *switch_class;
+static atomic_t device_count;
+
+static ssize_t state_show(struct device *dev, struct device_attribute *attr,
+		char *buf)
+{
+	struct switch_dev *sdev = (struct switch_dev *)
+		dev_get_drvdata(dev);
+
+	if (sdev->print_state) {
+		int ret = sdev->print_state(sdev, buf);
+		if (ret >= 0)
+			return ret;
+	}
+	return sprintf(buf, "%d\n", sdev->state);
+}
+
+static ssize_t name_show(struct device *dev, struct device_attribute *attr,
+		char *buf)
+{
+	struct switch_dev *sdev = (struct switch_dev *)
+		dev_get_drvdata(dev);
+
+	if (sdev->print_name) {
+		int ret = sdev->print_name(sdev, buf);
+		if (ret >= 0)
+			return ret;
+	}
+	return sprintf(buf, "%s\n", sdev->name);
+}
+
+static DEVICE_ATTR(state, S_IRUGO, state_show, NULL);
+static DEVICE_ATTR(name, S_IRUGO, name_show, NULL);
+
+void switch_set_state(struct switch_dev *sdev, int state)
+{
+	char name_buf[120];
+	char state_buf[120];
+	char *prop_buf;
+	char *envp[3];
+	int env_offset = 0;
+	int length;
+
+	if (sdev->state != state) {
+		sdev->state = state;
+
+		prop_buf = (char *)get_zeroed_page(GFP_KERNEL);
+		if (prop_buf) {
+			length = name_show(sdev->dev, NULL, prop_buf);
+			if (length > 0) {
+				if (prop_buf[length - 1] == '\n')
+					prop_buf[length - 1] = 0;
+				snprintf(name_buf, sizeof(name_buf),
+					"SWITCH_NAME=%s", prop_buf);
+				envp[env_offset++] = name_buf;
+			}
+			length = state_show(sdev->dev, NULL, prop_buf);
+			if (length > 0) {
+				if (prop_buf[length - 1] == '\n')
+					prop_buf[length - 1] = 0;
+				snprintf(state_buf, sizeof(state_buf),
+					"SWITCH_STATE=%s", prop_buf);
+				envp[env_offset++] = state_buf;
+			}
+			envp[env_offset] = NULL;
+			kobject_uevent_env(&sdev->dev->kobj, KOBJ_CHANGE, envp);
+			free_page((unsigned long)prop_buf);
+		} else {
+			printk(KERN_ERR "out of memory in switch_set_state\n");
+			kobject_uevent(&sdev->dev->kobj, KOBJ_CHANGE);
+		}
+	}
+}
+EXPORT_SYMBOL_GPL(switch_set_state);
+
+static int create_switch_class(void)
+{
+	if (!switch_class) {
+		switch_class = class_create(THIS_MODULE, "switch");
+		if (IS_ERR(switch_class))
+			return PTR_ERR(switch_class);
+		atomic_set(&device_count, 0);
+	}
+
+	return 0;
+}
+
+int switch_dev_register(struct switch_dev *sdev)
+{
+	int ret;
+
+	if (!switch_class) {
+		ret = create_switch_class();
+		if (ret < 0)
+			return ret;
+	}
+
+	sdev->index = atomic_inc_return(&device_count);
+	sdev->dev = device_create(switch_class, NULL,
+		MKDEV(0, sdev->index), NULL, sdev->name);
+	if (IS_ERR(sdev->dev))
+		return PTR_ERR(sdev->dev);
+
+	ret = device_create_file(sdev->dev, &dev_attr_state);
+	if (ret < 0)
+		goto err_create_file_1;
+	ret = device_create_file(sdev->dev, &dev_attr_name);
+	if (ret < 0)
+		goto err_create_file_2;
+
+	dev_set_drvdata(sdev->dev, sdev);
+	sdev->state = 0;
+	return 0;
+
+err_create_file_2:
+	device_remove_file(sdev->dev, &dev_attr_state);
+err_create_file_1:
+	device_destroy(switch_class, MKDEV(0, sdev->index));
+	printk(KERN_ERR "switch: Failed to register driver %s\n", sdev->name);
+
+	return ret;
+}
+EXPORT_SYMBOL_GPL(switch_dev_register);
+
+void switch_dev_unregister(struct switch_dev *sdev)
+{
+	device_remove_file(sdev->dev, &dev_attr_name);
+	device_remove_file(sdev->dev, &dev_attr_state);
+	device_destroy(switch_class, MKDEV(0, sdev->index));
+	dev_set_drvdata(sdev->dev, NULL);
+}
+EXPORT_SYMBOL_GPL(switch_dev_unregister);
+
+static int __init switch_class_init(void)
+{
+	return create_switch_class();
+}
+
+static void __exit switch_class_exit(void)
+{
+	class_destroy(switch_class);
+}
+
+module_init(switch_class_init);
+module_exit(switch_class_exit);
+
+MODULE_AUTHOR("Mike Lockwood <lockwood@android.com>");
+MODULE_DESCRIPTION("Switch class driver");
+MODULE_LICENSE("GPL");
diff --git a/drivers/switch/switch_gpio.c b/drivers/switch/switch_gpio.c
new file mode 100644
index 00000000..621d62d
--- /dev/null
+++ b/drivers/switch/switch_gpio.c
@@ -0,0 +1,172 @@
+/*
+ *  drivers/switch/switch_gpio.c
+ *
+ * Copyright (C) 2008 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+*/
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/switch.h>
+#include <linux/workqueue.h>
+#include <linux/gpio.h>
+
+struct gpio_switch_data {
+	struct switch_dev sdev;
+	unsigned gpio;
+	const char *name_on;
+	const char *name_off;
+	const char *state_on;
+	const char *state_off;
+	int irq;
+	struct work_struct work;
+};
+
+static void gpio_switch_work(struct work_struct *work)
+{
+	int state;
+	struct gpio_switch_data	*data =
+		container_of(work, struct gpio_switch_data, work);
+
+	state = gpio_get_value(data->gpio);
+	switch_set_state(&data->sdev, state);
+}
+
+static irqreturn_t gpio_irq_handler(int irq, void *dev_id)
+{
+	struct gpio_switch_data *switch_data =
+	    (struct gpio_switch_data *)dev_id;
+
+	schedule_work(&switch_data->work);
+	return IRQ_HANDLED;
+}
+
+static ssize_t switch_gpio_print_state(struct switch_dev *sdev, char *buf)
+{
+	struct gpio_switch_data	*switch_data =
+		container_of(sdev, struct gpio_switch_data, sdev);
+	const char *state;
+	if (switch_get_state(sdev))
+		state = switch_data->state_on;
+	else
+		state = switch_data->state_off;
+
+	if (state)
+		return sprintf(buf, "%s\n", state);
+	return -1;
+}
+
+static int gpio_switch_probe(struct platform_device *pdev)
+{
+	struct gpio_switch_platform_data *pdata = pdev->dev.platform_data;
+	struct gpio_switch_data *switch_data;
+	int ret = 0;
+
+	if (!pdata)
+		return -EBUSY;
+
+	switch_data = kzalloc(sizeof(struct gpio_switch_data), GFP_KERNEL);
+	if (!switch_data)
+		return -ENOMEM;
+
+	switch_data->sdev.name = pdata->name;
+	switch_data->gpio = pdata->gpio;
+	switch_data->name_on = pdata->name_on;
+	switch_data->name_off = pdata->name_off;
+	switch_data->state_on = pdata->state_on;
+	switch_data->state_off = pdata->state_off;
+	switch_data->sdev.print_state = switch_gpio_print_state;
+
+	ret = switch_dev_register(&switch_data->sdev);
+	if (ret < 0)
+		goto err_switch_dev_register;
+
+	ret = gpio_request(switch_data->gpio, pdev->name);
+	if (ret < 0)
+		goto err_request_gpio;
+
+	ret = gpio_direction_input(switch_data->gpio);
+	if (ret < 0)
+		goto err_set_gpio_input;
+
+	INIT_WORK(&switch_data->work, gpio_switch_work);
+
+	switch_data->irq = gpio_to_irq(switch_data->gpio);
+	if (switch_data->irq < 0) {
+		ret = switch_data->irq;
+		goto err_detect_irq_num_failed;
+	}
+
+	ret = request_irq(switch_data->irq, gpio_irq_handler,
+			  IRQF_TRIGGER_LOW, pdev->name, switch_data);
+	if (ret < 0)
+		goto err_request_irq;
+
+	/* Perform initial detection */
+	gpio_switch_work(&switch_data->work);
+
+	return 0;
+
+err_request_irq:
+err_detect_irq_num_failed:
+err_set_gpio_input:
+	gpio_free(switch_data->gpio);
+err_request_gpio:
+	switch_dev_unregister(&switch_data->sdev);
+err_switch_dev_register:
+	kfree(switch_data);
+
+	return ret;
+}
+
+static int gpio_switch_remove(struct platform_device *pdev)
+{
+	struct gpio_switch_data *switch_data = platform_get_drvdata(pdev);
+
+	cancel_work_sync(&switch_data->work);
+	gpio_free(switch_data->gpio);
+	switch_dev_unregister(&switch_data->sdev);
+	kfree(switch_data);
+
+	return 0;
+}
+
+static struct platform_driver gpio_switch_driver = {
+	.probe		= gpio_switch_probe,
+	.remove		= gpio_switch_remove,
+	.driver		= {
+		.name	= "switch-gpio",
+		.owner	= THIS_MODULE,
+	},
+};
+
+static int __init gpio_switch_init(void)
+{
+	return platform_driver_register(&gpio_switch_driver);
+}
+
+static void __exit gpio_switch_exit(void)
+{
+	platform_driver_unregister(&gpio_switch_driver);
+}
+
+module_init(gpio_switch_init);
+module_exit(gpio_switch_exit);
+
+MODULE_AUTHOR("Mike Lockwood <lockwood@android.com>");
+MODULE_DESCRIPTION("GPIO Switch driver");
+MODULE_LICENSE("GPL");
diff --git a/drivers/tee/Kconfig b/drivers/tee/Kconfig
new file mode 100644
index 00000000..a6df12d
--- /dev/null
+++ b/drivers/tee/Kconfig
@@ -0,0 +1,19 @@
+# Generic Trusted Execution Environment Configuration
+config TEE
+	tristate "Trusted Execution Environment support"
+	depends on HAVE_ARM_SMCCC || COMPILE_TEST
+	select DMA_SHARED_BUFFER
+	select GENERIC_ALLOCATOR
+	help
+	  This implements a generic interface towards a Trusted Execution
+	  Environment (TEE).
+
+if TEE
+
+menu "TEE drivers"
+
+source "drivers/tee/optee/Kconfig"
+
+endmenu
+
+endif
diff --git a/drivers/tee/Makefile b/drivers/tee/Makefile
new file mode 100644
index 00000000..48c69e4
--- /dev/null
+++ b/drivers/tee/Makefile
@@ -0,0 +1,7 @@
+obj-$(CONFIG_TEE) += tee.o
+tee-objs += tee_core.o
+tee-objs += tee_shm.o
+tee-objs += tee_shm_pool.o
+tee-objs += tee_hdcp14_api.o
+tee-objs += tee_i2c_api.o
+obj-$(CONFIG_OPTEE) += optee/
diff --git a/drivers/tee/optee/Kconfig b/drivers/tee/optee/Kconfig
new file mode 100644
index 00000000..0126de8
--- /dev/null
+++ b/drivers/tee/optee/Kconfig
@@ -0,0 +1,7 @@
+# OP-TEE Trusted Execution Environment Configuration
+config OPTEE
+	tristate "OP-TEE"
+	depends on HAVE_ARM_SMCCC
+	help
+	  This implements the OP-TEE Trusted Execution Environment (TEE)
+	  driver.
diff --git a/drivers/tee/optee/Makefile b/drivers/tee/optee/Makefile
new file mode 100644
index 00000000..220cf42
--- /dev/null
+++ b/drivers/tee/optee/Makefile
@@ -0,0 +1,6 @@
+obj-$(CONFIG_OPTEE) += optee.o
+optee-objs += core.o
+optee-objs += call.o
+optee-objs += rpc.o
+optee-objs += supp.o
+optee-objs += shm_pool.o
diff --git a/drivers/tee/optee/call.c b/drivers/tee/optee/call.c
new file mode 100755
index 00000000..359053c
--- /dev/null
+++ b/drivers/tee/optee/call.c
@@ -0,0 +1,660 @@
+/*
+ * Copyright (c) 2015, Linaro Limited
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+#include <linux/arm-smccc.h>
+#include <linux/device.h>
+#include <linux/err.h>
+#include <linux/errno.h>
+#include <linux/mm.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include <linux/types.h>
+#include <linux/uaccess.h>
+#include "optee_private.h"
+#include "optee_smc.h"
+
+struct optee_call_waiter {
+	struct list_head list_node;
+	struct completion c;
+};
+
+static void optee_cq_wait_init(struct optee_call_queue *cq,
+			       struct optee_call_waiter *w)
+{
+	/*
+	 * We're preparing to make a call to secure world. In case we can't
+	 * allocate a thread in secure world we'll end up waiting in
+	 * optee_cq_wait_for_completion().
+	 *
+	 * Normally if there's no contention in secure world the call will
+	 * complete and we can cleanup directly with optee_cq_wait_final().
+	 */
+	mutex_lock(&cq->mutex);
+
+	/*
+	 * We add ourselves to the queue, but we don't wait. This
+	 * guarantees that we don't lose a completion if secure world
+	 * returns busy and another thread just exited and try to complete
+	 * someone.
+	 */
+	init_completion(&w->c);
+	list_add_tail(&w->list_node, &cq->waiters);
+
+	mutex_unlock(&cq->mutex);
+}
+
+static void optee_cq_wait_for_completion(struct optee_call_queue *cq,
+					 struct optee_call_waiter *w)
+{
+	wait_for_completion(&w->c);
+
+	mutex_lock(&cq->mutex);
+
+	/* Move to end of list to get out of the way for other waiters */
+	list_del(&w->list_node);
+	reinit_completion(&w->c);
+	list_add_tail(&w->list_node, &cq->waiters);
+
+	mutex_unlock(&cq->mutex);
+}
+
+static void optee_cq_complete_one(struct optee_call_queue *cq)
+{
+	struct optee_call_waiter *w;
+
+	list_for_each_entry(w, &cq->waiters, list_node) {
+		if (!completion_done(&w->c)) {
+			complete(&w->c);
+			break;
+		}
+	}
+}
+
+static void optee_cq_wait_final(struct optee_call_queue *cq,
+				struct optee_call_waiter *w)
+{
+	/*
+	 * We're done with the call to secure world. The thread in secure
+	 * world that was used for this call is now available for some
+	 * other task to use.
+	 */
+	mutex_lock(&cq->mutex);
+
+	/* Get out of the list */
+	list_del(&w->list_node);
+
+	/* Wake up one eventual waiting task */
+	optee_cq_complete_one(cq);
+
+	/*
+	 * If we're completed we've got a completion from another task that
+	 * was just done with its call to secure world. Since yet another
+	 * thread now is available in secure world wake up another eventual
+	 * waiting task.
+	 */
+	if (completion_done(&w->c))
+		optee_cq_complete_one(cq);
+
+	mutex_unlock(&cq->mutex);
+}
+
+/* Requires the filpstate mutex to be held */
+static struct optee_session *find_session(struct optee_context_data *ctxdata,
+					  u32 session_id)
+{
+	struct optee_session *sess;
+
+	list_for_each_entry(sess, &ctxdata->sess_list, list_node)
+		if (sess->session_id == session_id)
+			return sess;
+	return NULL;
+}
+
+/**
+ * optee_do_call_with_arg() - Do an SMC to OP-TEE in secure world
+ * @ctx:	calling context
+ * @parg:	physical address of message to pass to secure world
+ *
+ * Does and SMC to OP-TEE in secure world and handles eventual resulting
+ * Remote Procedure Calls (RPC) from OP-TEE.
+ *
+ * Returns return code from secure world, 0 is OK
+ */
+u32 optee_do_call_with_arg(struct tee_context *ctx, phys_addr_t parg)
+{
+	struct optee *optee = tee_get_drvdata(ctx->teedev);
+	struct optee_call_waiter w;
+	struct optee_rpc_param param = { };
+	struct optee_call_ctx call_ctx = { };
+	u32 ret;
+
+	param.a0 = OPTEE_SMC_CALL_WITH_ARG;
+	reg_pair_from_64(&param.a1, &param.a2, parg);
+	/* Initialize waiter */
+	optee_cq_wait_init(&optee->call_queue, &w);
+	while (true) {
+		struct arm_smccc_res res;
+
+		optee->invoke_fn(param.a0, param.a1, param.a2, param.a3,
+				 param.a4, param.a5, param.a6, param.a7,
+				 &res);
+
+		if (res.a0 == OPTEE_SMC_RETURN_ETHREAD_LIMIT) {
+			/*
+			 * Out of threads in secure world, wait for a thread
+			 * become available.
+			 */
+			optee_cq_wait_for_completion(&optee->call_queue, &w);
+		} else if (OPTEE_SMC_RETURN_IS_RPC(res.a0)) {
+			param.a0 = res.a0;
+			param.a1 = res.a1;
+			param.a2 = res.a2;
+			param.a3 = res.a3;
+			optee_handle_rpc(ctx, &param, &call_ctx);
+		} else {
+			ret = res.a0;
+			break;
+		}
+	}
+
+	optee_rpc_finalize_call(&call_ctx);
+	/*
+	 * We're done with our thread in secure world, if there's any
+	 * thread waiters wake up one.
+	 */
+	optee_cq_wait_final(&optee->call_queue, &w);
+	return ret;
+}
+
+static struct tee_shm *get_msg_arg(struct tee_context *ctx, size_t num_params,
+				   struct optee_msg_arg **msg_arg,
+				   phys_addr_t *msg_parg)
+{
+	int rc;
+	struct tee_shm *shm;
+	struct optee_msg_arg *ma;
+
+	shm = tee_shm_alloc(ctx, OPTEE_MSG_GET_ARG_SIZE(num_params),
+			    TEE_SHM_MAPPED);
+	if (IS_ERR(shm))
+		return shm;
+	ma = tee_shm_get_va(shm, 0);
+	if (IS_ERR(ma)) {
+		rc = PTR_ERR(ma);
+		goto out;
+	}
+	rc = tee_shm_get_pa(shm, 0, msg_parg);
+	if (rc)
+		goto out;
+
+	memset(ma, 0, OPTEE_MSG_GET_ARG_SIZE(num_params));
+	ma->num_params = num_params;
+	*msg_arg = ma;
+out:
+	if (rc) {
+		tee_shm_free(shm);
+		return ERR_PTR(rc);
+	}
+	return shm;
+}
+
+int optee_open_session(struct tee_context *ctx,
+		       struct tee_ioctl_open_session_arg *arg,
+		       struct tee_param *param)
+{
+	struct optee_context_data *ctxdata = ctx->data;
+	int rc;
+	struct tee_shm *shm;
+	struct optee_msg_arg *msg_arg;
+	phys_addr_t msg_parg;
+	struct optee_session *sess = NULL;
+
+	/* +2 for the meta parameters added below */
+	shm = get_msg_arg(ctx, arg->num_params + 2, &msg_arg, &msg_parg);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+	msg_arg->cmd = OPTEE_MSG_CMD_OPEN_SESSION;
+	msg_arg->cancel_id = arg->cancel_id;
+
+	/*
+	 * Initialize and add the meta parameters needed when opening a
+	 * session.
+	 */
+	msg_arg->params[0].attr = OPTEE_MSG_ATTR_TYPE_VALUE_INPUT |
+				  OPTEE_MSG_ATTR_META;
+	msg_arg->params[1].attr = OPTEE_MSG_ATTR_TYPE_VALUE_INPUT |
+				  OPTEE_MSG_ATTR_META;
+	memcpy(&msg_arg->params[0].u.value, arg->uuid, sizeof(arg->uuid));
+	memcpy(&msg_arg->params[1].u.value, arg->uuid, sizeof(arg->clnt_uuid));
+	msg_arg->params[1].u.value.c = arg->clnt_login;
+
+	rc = optee_to_msg_param(msg_arg->params + 2, arg->num_params, param);
+	if (rc)
+		goto out;
+
+	sess = kzalloc(sizeof(*sess), GFP_KERNEL);
+	if (!sess) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	if (optee_do_call_with_arg(ctx, msg_parg)) {
+		msg_arg->ret = TEEC_ERROR_COMMUNICATION;
+		msg_arg->ret_origin = TEEC_ORIGIN_COMMS;
+	}
+
+	if (msg_arg->ret == TEEC_SUCCESS) {
+		/* A new session has been created, add it to the list. */
+		sess->session_id = msg_arg->session;
+		mutex_lock(&ctxdata->mutex);
+		list_add(&sess->list_node, &ctxdata->sess_list);
+		mutex_unlock(&ctxdata->mutex);
+	} else {
+		kfree(sess);
+	}
+
+	if (optee_from_msg_param(param, arg->num_params, msg_arg->params + 2)) {
+		arg->ret = TEEC_ERROR_COMMUNICATION;
+		arg->ret_origin = TEEC_ORIGIN_COMMS;
+		/* Close session again to avoid leakage */
+		optee_close_session(ctx, msg_arg->session);
+	} else {
+		arg->session = msg_arg->session;
+		arg->ret = msg_arg->ret;
+		arg->ret_origin = msg_arg->ret_origin;
+	}
+out:
+	tee_shm_free(shm);
+
+	return rc;
+}
+
+int optee_close_session(struct tee_context *ctx, u32 session)
+{
+	struct optee_context_data *ctxdata = ctx->data;
+	struct tee_shm *shm;
+	struct optee_msg_arg *msg_arg;
+	phys_addr_t msg_parg;
+	struct optee_session *sess;
+
+	/* Check that the session is valid and remove it from the list */
+	mutex_lock(&ctxdata->mutex);
+	sess = find_session(ctxdata, session);
+	if (sess)
+		list_del(&sess->list_node);
+	mutex_unlock(&ctxdata->mutex);
+	if (!sess)
+		return -EINVAL;
+	kfree(sess);
+
+	shm = get_msg_arg(ctx, 0, &msg_arg, &msg_parg);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+	msg_arg->cmd = OPTEE_MSG_CMD_CLOSE_SESSION;
+	msg_arg->session = session;
+	optee_do_call_with_arg(ctx, msg_parg);
+
+	tee_shm_free(shm);
+	return 0;
+}
+
+int optee_invoke_func(struct tee_context *ctx, struct tee_ioctl_invoke_arg *arg,
+		      struct tee_param *param)
+{
+	struct optee_context_data *ctxdata = ctx->data;
+	struct tee_shm *shm;
+	struct optee_msg_arg *msg_arg;
+	phys_addr_t msg_parg;
+	struct optee_session *sess;
+	int rc;
+
+	/* Check that the session is valid */
+	mutex_lock(&ctxdata->mutex);
+	sess = find_session(ctxdata, arg->session);
+	mutex_unlock(&ctxdata->mutex);
+	if (!sess)
+		return -EINVAL;
+
+
+	shm = get_msg_arg(ctx, arg->num_params, &msg_arg, &msg_parg);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+	msg_arg->cmd = OPTEE_MSG_CMD_INVOKE_COMMAND;
+	msg_arg->func = arg->func;
+	msg_arg->session = arg->session;
+	msg_arg->cancel_id = arg->cancel_id;
+
+	rc = optee_to_msg_param(msg_arg->params, arg->num_params, param);
+	if (rc)
+		goto out;
+
+	if (optee_do_call_with_arg(ctx, msg_parg)) {
+		msg_arg->ret = TEEC_ERROR_COMMUNICATION;
+		msg_arg->ret_origin = TEEC_ORIGIN_COMMS;
+	}
+
+	if (optee_from_msg_param(param, arg->num_params, msg_arg->params)) {
+		msg_arg->ret = TEEC_ERROR_COMMUNICATION;
+		msg_arg->ret_origin = TEEC_ORIGIN_COMMS;
+	}
+
+	arg->ret = msg_arg->ret;
+	arg->ret_origin = msg_arg->ret_origin;
+
+out:
+	tee_shm_free(shm);
+
+	return rc;
+}
+
+int optee_cancel_req(struct tee_context *ctx, u32 cancel_id, u32 session)
+{
+	struct optee_context_data *ctxdata = ctx->data;
+	struct tee_shm *shm;
+	struct optee_msg_arg *msg_arg;
+	phys_addr_t msg_parg;
+	struct optee_session *sess;
+
+	/* Check that the session is valid */
+	mutex_lock(&ctxdata->mutex);
+	sess = find_session(ctxdata, session);
+	mutex_unlock(&ctxdata->mutex);
+	if (!sess)
+		return -EINVAL;
+
+	shm = get_msg_arg(ctx, 0, &msg_arg, &msg_parg);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+	msg_arg->cmd = OPTEE_MSG_CMD_CANCEL;
+	msg_arg->session = session;
+	msg_arg->cancel_id = cancel_id;
+	optee_do_call_with_arg(ctx, msg_parg);
+
+	tee_shm_free(shm);
+	return 0;
+}
+
+/**
+ * optee_enable_shm_cache() - Enables caching of some shared memory allocation
+ *			      in OP-TEE
+ * @optee:	main service struct
+ */
+void optee_enable_shm_cache(struct optee *optee)
+{
+	struct optee_call_waiter w;
+
+	/* We need to retry until secure world isn't busy. */
+	optee_cq_wait_init(&optee->call_queue, &w);
+	while (true) {
+		struct arm_smccc_res res;
+
+		optee->invoke_fn(OPTEE_SMC_ENABLE_SHM_CACHE, 0, 0, 0, 0, 0, 0,
+				 0, &res);
+		if (res.a0 == OPTEE_SMC_RETURN_OK)
+			break;
+		optee_cq_wait_for_completion(&optee->call_queue, &w);
+	}
+	optee_cq_wait_final(&optee->call_queue, &w);
+}
+
+/**
+ * optee_disable_shm_cache() - Disables caching of some shared memory allocation
+ *			      in OP-TEE
+ * @optee:	main service struct
+ */
+void optee_disable_shm_cache(struct optee *optee)
+{
+	struct optee_call_waiter w;
+
+	/* We need to retry until secure world isn't busy. */
+	optee_cq_wait_init(&optee->call_queue, &w);
+	while (true) {
+		union {
+			struct arm_smccc_res smccc;
+			struct optee_smc_disable_shm_cache_result result;
+		} res;
+
+		optee->invoke_fn(OPTEE_SMC_DISABLE_SHM_CACHE, 0, 0, 0, 0, 0, 0,
+				 0, &res.smccc);
+		if (res.result.status == OPTEE_SMC_RETURN_ENOTAVAIL)
+			break; /* All shm's freed */
+		if (res.result.status == OPTEE_SMC_RETURN_OK) {
+			struct tee_shm *shm;
+
+			shm = reg_pair_to_ptr(res.result.shm_upper32,
+					      res.result.shm_lower32);
+			tee_shm_free(shm);
+		} else {
+			optee_cq_wait_for_completion(&optee->call_queue, &w);
+		}
+	}
+	optee_cq_wait_final(&optee->call_queue, &w);
+}
+
+#define PAGELIST_ENTRIES_PER_PAGE				\
+	((OPTEE_MSG_NONCONTIG_PAGE_SIZE / sizeof(u64)) - 1)
+
+/**
+ * optee_fill_pages_list() - write list of user pages to given shared
+ * buffer.
+ *
+ * @dst: page-aligned buffer where list of pages will be stored
+ * @pages: array of pages that represents shared buffer
+ * @num_pages: number of entries in @pages
+ * @page_offset: offset of user buffer from page start
+ *
+ * @dst should be big enough to hold list of user page addresses and
+ *	links to the next pages of buffer
+ */
+void optee_fill_pages_list(u64 *dst, struct page **pages, int num_pages,
+			   size_t page_offset)
+{
+	int n = 0;
+	phys_addr_t optee_page;
+	/*
+	 * Refer to OPTEE_MSG_ATTR_NONCONTIG description in optee_msg.h
+	 * for details.
+	 */
+	struct {
+		u64 pages_list[PAGELIST_ENTRIES_PER_PAGE];
+		u64 next_page_data;
+	} *pages_data;
+
+	/*
+	 * Currently OP-TEE uses 4k page size and it does not looks
+	 * like this will change in the future.  On other hand, there are
+	 * no know ARM architectures with page size < 4k.
+	 * Thus the next built assert looks redundant. But the following
+	 * code heavily relies on this assumption, so it is better be
+	 * safe than sorry.
+	 */
+	BUILD_BUG_ON(PAGE_SIZE < OPTEE_MSG_NONCONTIG_PAGE_SIZE);
+
+	pages_data = (void *)dst;
+	/*
+	 * If linux page is bigger than 4k, and user buffer offset is
+	 * larger than 4k/8k/12k/etc this will skip first 4k pages,
+	 * because they bear no value data for OP-TEE.
+	 */
+	optee_page = page_to_phys(*pages) +
+		round_down(page_offset, OPTEE_MSG_NONCONTIG_PAGE_SIZE);
+
+	while (true) {
+		pages_data->pages_list[n++] = optee_page;
+
+		if (n == PAGELIST_ENTRIES_PER_PAGE) {
+			pages_data->next_page_data =
+				virt_to_phys(pages_data + 1);
+			pages_data++;
+			n = 0;
+		}
+
+		optee_page += OPTEE_MSG_NONCONTIG_PAGE_SIZE;
+		if (!(optee_page & ~PAGE_MASK)) {
+			if (!--num_pages)
+				break;
+			pages++;
+			optee_page = page_to_phys(*pages);
+		}
+	}
+}
+
+/*
+ * The final entry in each pagelist page is a pointer to the next
+ * pagelist page.
+ */
+static size_t get_pages_list_size(size_t num_entries)
+{
+	int pages = DIV_ROUND_UP(num_entries, PAGELIST_ENTRIES_PER_PAGE);
+
+	return pages * OPTEE_MSG_NONCONTIG_PAGE_SIZE;
+}
+
+u64 *optee_allocate_pages_list(size_t num_entries)
+{
+	return alloc_pages_exact(get_pages_list_size(num_entries), GFP_KERNEL);
+}
+
+void optee_free_pages_list(void *list, size_t num_entries)
+{
+	free_pages_exact(list, get_pages_list_size(num_entries));
+}
+
+static bool is_normal_memory(pgprot_t p)
+{
+#if defined(CONFIG_ARM)
+	return (pgprot_val(p) & L_PTE_MT_MASK) == L_PTE_MT_WRITEALLOC;
+#elif defined(CONFIG_ARM64)
+	return (pgprot_val(p) & PTE_ATTRINDX_MASK) == PTE_ATTRINDX(MT_NORMAL);
+#else
+#error "Unuspported architecture"
+#endif
+}
+
+static int __check_mem_type(struct vm_area_struct *vma, unsigned long end)
+{
+	while (vma && is_normal_memory(vma->vm_page_prot)) {
+		if (vma->vm_end >= end)
+			return 0;
+		vma = vma->vm_next;
+	}
+
+	return -EINVAL;
+}
+
+static int check_mem_type(unsigned long start, size_t num_pages)
+{
+	struct mm_struct *mm = current->mm;
+	int rc;
+
+	down_read(&mm->mmap_sem);
+	rc = __check_mem_type(find_vma(mm, start),
+			      start + num_pages * PAGE_SIZE);
+	up_read(&mm->mmap_sem);
+
+	return rc;
+}
+
+int optee_shm_register(struct tee_context *ctx, struct tee_shm *shm,
+		       struct page **pages, size_t num_pages,
+		       unsigned long start)
+{
+	struct tee_shm *shm_arg = NULL;
+	struct optee_msg_arg *msg_arg;
+	u64 *pages_list;
+	phys_addr_t msg_parg;
+	int rc;
+
+	if (!num_pages)
+		return -EINVAL;
+
+	rc = check_mem_type(start, num_pages);
+	if (rc)
+		return rc;
+
+	pages_list = optee_allocate_pages_list(num_pages);
+	if (!pages_list)
+		return -ENOMEM;
+
+	shm_arg = get_msg_arg(ctx, 1, &msg_arg, &msg_parg);
+	if (IS_ERR(shm_arg)) {
+		rc = PTR_ERR(shm_arg);
+		goto out;
+	}
+
+	optee_fill_pages_list(pages_list, pages, num_pages,
+			      tee_shm_get_page_offset(shm));
+
+	msg_arg->cmd = OPTEE_MSG_CMD_REGISTER_SHM;
+	msg_arg->params->attr = OPTEE_MSG_ATTR_TYPE_TMEM_OUTPUT |
+				OPTEE_MSG_ATTR_NONCONTIG;
+	msg_arg->params->u.tmem.shm_ref = (unsigned long)shm;
+	msg_arg->params->u.tmem.size = tee_shm_get_size(shm);
+	/*
+	 * In the least bits of msg_arg->params->u.tmem.buf_ptr we
+	 * store buffer offset from 4k page, as described in OP-TEE ABI.
+	 */
+	msg_arg->params->u.tmem.buf_ptr = virt_to_phys(pages_list) |
+	  (tee_shm_get_page_offset(shm) & (OPTEE_MSG_NONCONTIG_PAGE_SIZE - 1));
+
+	if (optee_do_call_with_arg(ctx, msg_parg) ||
+	    msg_arg->ret != TEEC_SUCCESS)
+		rc = -EINVAL;
+
+	tee_shm_free(shm_arg);
+out:
+	optee_free_pages_list(pages_list, num_pages);
+	return rc;
+}
+
+int optee_shm_unregister(struct tee_context *ctx, struct tee_shm *shm)
+{
+	struct tee_shm *shm_arg;
+	struct optee_msg_arg *msg_arg;
+	phys_addr_t msg_parg;
+	int rc = 0;
+
+	shm_arg = get_msg_arg(ctx, 1, &msg_arg, &msg_parg);
+	if (IS_ERR(shm_arg))
+		return PTR_ERR(shm_arg);
+
+	msg_arg->cmd = OPTEE_MSG_CMD_UNREGISTER_SHM;
+
+	msg_arg->params[0].attr = OPTEE_MSG_ATTR_TYPE_RMEM_INPUT;
+	msg_arg->params[0].u.rmem.shm_ref = (unsigned long)shm;
+
+	if (optee_do_call_with_arg(ctx, msg_parg) ||
+	    msg_arg->ret != TEEC_SUCCESS)
+		rc = -EINVAL;
+	tee_shm_free(shm_arg);
+	return rc;
+}
+
+int optee_shm_register_supp(struct tee_context *ctx, struct tee_shm *shm,
+			    struct page **pages, size_t num_pages,
+			    unsigned long start)
+{
+	/*
+	 * We don't want to register supplicant memory in OP-TEE.
+	 * Instead information about it will be passed in RPC code.
+	 */
+	return check_mem_type(start, num_pages);
+}
+
+int optee_shm_unregister_supp(struct tee_context *ctx, struct tee_shm *shm)
+{
+	return 0;
+}
diff --git a/drivers/tee/optee/core.c b/drivers/tee/optee/core.c
new file mode 100644
index 00000000..0d00098
--- /dev/null
+++ b/drivers/tee/optee/core.c
@@ -0,0 +1,766 @@
+/*
+ * Copyright (c) 2015, Linaro Limited
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#define pr_fmt(fmt) KBUILD_MODNAME ": " fmt
+
+#include <linux/arm-smccc.h>
+#include <linux/errno.h>
+#include <linux/io.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/of_platform.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/string.h>
+#include <linux/tee_drv.h>
+#include <linux/types.h>
+#include <linux/uaccess.h>
+#include "optee_private.h"
+#include "optee_smc.h"
+#include <linux/proc_fs.h>
+#include "shm_pool.h"
+
+
+#if defined(CONFIG_RTD139x) || defined(CONFIG_RTD16xx)
+#include <linux/semaphore.h>
+#endif
+#define DRIVER_NAME "optee"
+
+#define OPTEE_SHM_NUM_PRIV_PAGES	1
+
+//#define BL31_TSP_TEST
+
+#if defined(CONFIG_RTD139x) || defined(CONFIG_RTD16xx)
+static struct semaphore sem_tee;
+#endif
+
+#ifdef BL31_TSP_TEST
+ssize_t tsp_trigger(struct file *filp, const char __user *buff, unsigned long len, void *data);
+static struct proc_dir_entry *proc_file = NULL;
+static struct file_operations proc_fops = 
+{
+.owner = THIS_MODULE,
+.write = tsp_trigger
+};
+
+ssize_t tsp_trigger(struct file *filp, const char __user *buff, unsigned long len, void *data) 
+{ 	
+	printk(KERN_ERR "tsp_trigger !!! \n");
+	unsigned int arg1 = 3, arg2 = 5;
+	printk(KERN_ERR "TSP_ADD: x1 = 3, x2 = 5 \n");
+	asm volatile("mov x1, %0" : : "r"(arg1): "cc");
+	asm volatile("mov x2, %0" : : "r"(arg2): "cc");
+	asm volatile("ldr x0, =0xf2002000" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("smc #0" : : : "cc");
+	asm volatile("isb" : : : "cc");
+	asm volatile("mov %0, x1" : "=r"(arg1): : "cc");
+	asm volatile("mov %0, x2" : "=r"(arg2): : "cc");
+	asm volatile("isb" : : : "cc");
+	printk(KERN_ERR "Result: x1 = %u, x2 = %u \n",arg1, arg2);	
+	return len; 
+}
+
+#endif
+
+/**
+ * optee_from_msg_param() - convert from OPTEE_MSG parameters to
+ *			    struct tee_param
+ * @params:	subsystem internal parameter representation
+ * @num_params:	number of elements in the parameter arrays
+ * @msg_params:	OPTEE_MSG parameters
+ * Returns 0 on success or <0 on failure
+ */
+int optee_from_msg_param(struct tee_param *params, size_t num_params,
+			 const struct optee_msg_param *msg_params)
+{
+	int rc;
+	size_t n;
+	struct tee_shm *shm;
+	phys_addr_t pa;
+
+	for (n = 0; n < num_params; n++) {
+		struct tee_param *p = params + n;
+		const struct optee_msg_param *mp = msg_params + n;
+		u32 attr = mp->attr & OPTEE_MSG_ATTR_TYPE_MASK;
+
+		switch (attr) {
+		case OPTEE_MSG_ATTR_TYPE_NONE:
+			p->attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+			memset(&p->u, 0, sizeof(p->u));
+			break;
+		case OPTEE_MSG_ATTR_TYPE_VALUE_INPUT:
+		case OPTEE_MSG_ATTR_TYPE_VALUE_OUTPUT:
+		case OPTEE_MSG_ATTR_TYPE_VALUE_INOUT:
+			p->attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INPUT +
+				  attr - OPTEE_MSG_ATTR_TYPE_VALUE_INPUT;
+			p->u.value.a = mp->u.value.a;
+			p->u.value.b = mp->u.value.b;
+			p->u.value.c = mp->u.value.c;
+			break;
+		case OPTEE_MSG_ATTR_TYPE_TMEM_INPUT:
+		case OPTEE_MSG_ATTR_TYPE_TMEM_OUTPUT:
+		case OPTEE_MSG_ATTR_TYPE_TMEM_INOUT:
+			p->attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT +
+				  attr - OPTEE_MSG_ATTR_TYPE_TMEM_INPUT;
+			p->u.memref.size = mp->u.tmem.size;
+			shm = (struct tee_shm *)(unsigned long)
+				mp->u.tmem.shm_ref;
+			if (!shm) {
+				p->u.memref.shm_offs = 0;
+				p->u.memref.shm = NULL;
+				break;
+			}
+			rc = tee_shm_get_pa(shm, 0, &pa);
+			if (rc)
+				return rc;
+			p->u.memref.shm_offs = mp->u.tmem.buf_ptr - pa;
+			p->u.memref.shm = shm;
+
+			/* Check that the memref is covered by the shm object */
+			if (p->u.memref.size) {
+				size_t o = p->u.memref.shm_offs +
+					   p->u.memref.size - 1;
+
+				rc = tee_shm_get_pa(shm, o, NULL);
+				if (rc)
+					return rc;
+			}
+			break;
+		case OPTEE_MSG_ATTR_TYPE_RMEM_INPUT:
+		case OPTEE_MSG_ATTR_TYPE_RMEM_OUTPUT:
+		case OPTEE_MSG_ATTR_TYPE_RMEM_INOUT:
+			p->attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT +
+				  attr - OPTEE_MSG_ATTR_TYPE_RMEM_INPUT;
+			p->u.memref.size = mp->u.rmem.size;
+			shm = (struct tee_shm *)(unsigned long)
+				mp->u.rmem.shm_ref;
+
+			if (!shm) {
+				p->u.memref.shm_offs = 0;
+				p->u.memref.shm = NULL;
+				break;
+			}
+			p->u.memref.shm_offs = mp->u.rmem.offs;
+			p->u.memref.shm = shm;
+
+			break;
+
+		default:
+			return -EINVAL;
+		}
+	}
+	return 0;
+}
+
+static int to_msg_param_tmp_mem(struct optee_msg_param *mp,
+				const struct tee_param *p)
+{
+	int rc;
+	phys_addr_t pa;
+
+	mp->attr = OPTEE_MSG_ATTR_TYPE_TMEM_INPUT + p->attr -
+		   TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT;
+
+	mp->u.tmem.shm_ref = (unsigned long)p->u.memref.shm;
+	mp->u.tmem.size = p->u.memref.size;
+
+	if (!p->u.memref.shm) {
+		mp->u.tmem.buf_ptr = 0;
+		return 0;
+	}
+
+	rc = tee_shm_get_pa(p->u.memref.shm, p->u.memref.shm_offs, &pa);
+	if (rc)
+		return rc;
+
+	mp->u.tmem.buf_ptr = pa;
+	mp->attr |= OPTEE_MSG_ATTR_CACHE_PREDEFINED <<
+		    OPTEE_MSG_ATTR_CACHE_SHIFT;
+
+	return 0;
+}
+
+static int to_msg_param_reg_mem(struct optee_msg_param *mp,
+				const struct tee_param *p)
+{
+	mp->attr = OPTEE_MSG_ATTR_TYPE_RMEM_INPUT + p->attr -
+		   TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT;
+
+	mp->u.rmem.shm_ref = (unsigned long)p->u.memref.shm;
+	mp->u.rmem.size = p->u.memref.size;
+	mp->u.rmem.offs = p->u.memref.shm_offs;
+	return 0;
+}
+
+/**
+ * optee_to_msg_param() - convert from struct tee_params to OPTEE_MSG parameters
+ * @msg_params:	OPTEE_MSG parameters
+ * @num_params:	number of elements in the parameter arrays
+ * @params:	subsystem itnernal parameter representation
+ * Returns 0 on success or <0 on failure
+ */
+int optee_to_msg_param(struct optee_msg_param *msg_params, size_t num_params,
+		       const struct tee_param *params)
+{
+	int rc;
+	size_t n;
+
+	for (n = 0; n < num_params; n++) {
+		const struct tee_param *p = params + n;
+		struct optee_msg_param *mp = msg_params + n;
+
+		switch (p->attr) {
+		case TEE_IOCTL_PARAM_ATTR_TYPE_NONE:
+			mp->attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+			memset(&mp->u, 0, sizeof(mp->u));
+			break;
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_OUTPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT:
+			mp->attr = OPTEE_MSG_ATTR_TYPE_VALUE_INPUT + p->attr -
+				   TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INPUT;
+			mp->u.value.a = p->u.value.a;
+			mp->u.value.b = p->u.value.b;
+			mp->u.value.c = p->u.value.c;
+			break;
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_OUTPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT:
+			if (tee_shm_is_registered(p->u.memref.shm))
+				rc = to_msg_param_reg_mem(mp, p);
+			else
+				rc = to_msg_param_tmp_mem(mp, p);
+			if (rc)
+				return rc;
+			break;
+		default:
+			return -EINVAL;
+		}
+	}
+	return 0;
+}
+
+static void optee_get_version(struct tee_device *teedev,
+			      struct tee_ioctl_version_data *vers)
+{
+	struct tee_ioctl_version_data v = {
+		.impl_id = TEE_IMPL_ID_OPTEE,
+		.impl_caps = TEE_OPTEE_CAP_TZ,
+		.gen_caps = TEE_GEN_CAP_GP,
+	};
+	struct optee *optee = tee_get_drvdata(teedev);
+
+	if (optee->sec_caps & OPTEE_SMC_SEC_CAP_DYNAMIC_SHM)
+		v.gen_caps |= TEE_GEN_CAP_REG_MEM;
+	*vers = v;
+}
+
+static int optee_open(struct tee_context *ctx)
+{
+	struct optee_context_data *ctxdata;
+	struct tee_device *teedev = ctx->teedev;
+	struct optee *optee = tee_get_drvdata(teedev);
+
+	ctxdata = kzalloc(sizeof(*ctxdata), GFP_KERNEL);
+	if (!ctxdata)
+		return -ENOMEM;
+
+	if (teedev == optee->supp_teedev) {
+		bool busy = true;
+
+		mutex_lock(&optee->supp.mutex);
+		if (!optee->supp.ctx) {
+			busy = false;
+			optee->supp.ctx = ctx;
+		}
+		mutex_unlock(&optee->supp.mutex);
+		if (busy) {
+			kfree(ctxdata);
+			return -EBUSY;
+		}
+	}
+
+	mutex_init(&ctxdata->mutex);
+	INIT_LIST_HEAD(&ctxdata->sess_list);
+
+	ctx->data = ctxdata;
+	return 0;
+}
+
+static void optee_release(struct tee_context *ctx)
+{
+	struct optee_context_data *ctxdata = ctx->data;
+	struct tee_device *teedev = ctx->teedev;
+	struct optee *optee = tee_get_drvdata(teedev);
+	struct tee_shm *shm;
+	struct optee_msg_arg *arg = NULL;
+	phys_addr_t parg;
+	struct optee_session *sess;
+	struct optee_session *sess_tmp;
+
+	if (!ctxdata)
+		return;
+
+	shm = tee_shm_alloc(ctx, sizeof(struct optee_msg_arg), TEE_SHM_MAPPED);
+	if (!IS_ERR(shm)) {
+		arg = tee_shm_get_va(shm, 0);
+		/*
+		 * If va2pa fails for some reason, we can't call into
+		 * secure world, only free the memory. Secure OS will leak
+		 * sessions and finally refuse more sessions, but we will
+		 * at least let normal world reclaim its memory.
+		 */
+		if (!IS_ERR(arg))
+			if (tee_shm_va2pa(shm, arg, &parg))
+				arg = NULL; /* prevent usage of parg below */
+	}
+
+	list_for_each_entry_safe(sess, sess_tmp, &ctxdata->sess_list,
+				 list_node) {
+		list_del(&sess->list_node);
+		if (!IS_ERR_OR_NULL(arg)) {
+			memset(arg, 0, sizeof(*arg));
+			arg->cmd = OPTEE_MSG_CMD_CLOSE_SESSION;
+			arg->session = sess->session_id;
+			optee_do_call_with_arg(ctx, parg);
+		}
+		kfree(sess);
+	}
+	kfree(ctxdata);
+
+	if (!IS_ERR(shm))
+		tee_shm_free(shm);
+
+	ctx->data = NULL;
+
+	if (teedev == optee->supp_teedev)
+		optee_supp_release(&optee->supp);
+}
+
+static const struct tee_driver_ops optee_ops = {
+	.get_version = optee_get_version,
+	.open = optee_open,
+	.release = optee_release,
+	.open_session = optee_open_session,
+	.close_session = optee_close_session,
+	.invoke_func = optee_invoke_func,
+	.cancel_req = optee_cancel_req,
+	.shm_register = optee_shm_register,
+	.shm_unregister = optee_shm_unregister,
+};
+
+static const struct tee_desc optee_desc = {
+	.name = DRIVER_NAME "-clnt",
+	.ops = &optee_ops,
+	.owner = THIS_MODULE,
+};
+
+static const struct tee_driver_ops optee_supp_ops = {
+	.get_version = optee_get_version,
+	.open = optee_open,
+	.release = optee_release,
+	.supp_recv = optee_supp_recv,
+	.supp_send = optee_supp_send,
+	.shm_register = optee_shm_register_supp,
+	.shm_unregister = optee_shm_unregister_supp,
+};
+
+static const struct tee_desc optee_supp_desc = {
+	.name = DRIVER_NAME "-supp",
+	.ops = &optee_supp_ops,
+	.owner = THIS_MODULE,
+	.flags = TEE_DESC_PRIVILEGED,
+};
+
+static bool optee_msg_api_uid_is_optee_api(optee_invoke_fn *invoke_fn)
+{
+	struct arm_smccc_res res;
+
+	invoke_fn(OPTEE_SMC_CALLS_UID, 0, 0, 0, 0, 0, 0, 0, &res);
+
+	if (res.a0 == OPTEE_MSG_UID_0 && res.a1 == OPTEE_MSG_UID_1 &&
+	    res.a2 == OPTEE_MSG_UID_2 && res.a3 == OPTEE_MSG_UID_3)
+		return true;
+	return false;
+}
+
+static bool optee_msg_api_revision_is_compatible(optee_invoke_fn *invoke_fn)
+{
+	union {
+		struct arm_smccc_res smccc;
+		struct optee_smc_calls_revision_result result;
+	} res;
+
+	invoke_fn(OPTEE_SMC_CALLS_REVISION, 0, 0, 0, 0, 0, 0, 0, &res.smccc);
+
+	if (res.result.major == OPTEE_MSG_REVISION_MAJOR &&
+	    (int)res.result.minor >= OPTEE_MSG_REVISION_MINOR)
+		return true;
+	return false;
+}
+
+static bool optee_msg_exchange_capabilities(optee_invoke_fn *invoke_fn,
+					    u32 *sec_caps)
+{
+	union {
+		struct arm_smccc_res smccc;
+		struct optee_smc_exchange_capabilities_result result;
+	} res;
+	u32 a1 = 0;
+
+	/*
+	 * TODO This isn't enough to tell if it's UP system (from kernel
+	 * point of view) or not, is_smp() returns the the information
+	 * needed, but can't be called directly from here.
+	 */
+	if (!IS_ENABLED(CONFIG_SMP) || nr_cpu_ids == 1)
+		a1 |= OPTEE_SMC_NSEC_CAP_UNIPROCESSOR;
+
+	invoke_fn(OPTEE_SMC_EXCHANGE_CAPABILITIES, a1, 0, 0, 0, 0, 0, 0,
+		  &res.smccc);
+
+	if (res.result.status != OPTEE_SMC_RETURN_OK)
+		return false;
+
+	*sec_caps = res.result.capabilities;
+	return true;
+}
+
+static struct tee_shm_pool *
+optee_config_shm_memremap(optee_invoke_fn *invoke_fn, void **memremaped_shm,
+			  u32 sec_caps)
+{
+	union {
+		struct arm_smccc_res smccc;
+		struct optee_smc_get_shm_config_result result;
+	} res;
+	unsigned long vaddr;
+	phys_addr_t paddr;
+	size_t size;
+	phys_addr_t begin;
+	phys_addr_t end;
+	void *va;
+	struct tee_shm_pool_mgr *priv_mgr;
+	struct tee_shm_pool_mgr *dmabuf_mgr;
+	void *rc;
+
+	invoke_fn(OPTEE_SMC_GET_SHM_CONFIG, 0, 0, 0, 0, 0, 0, 0, &res.smccc);
+	if (res.result.status != OPTEE_SMC_RETURN_OK) {
+		pr_info("shm service not available\n");
+		return ERR_PTR(-ENOENT);
+	}
+
+	if (res.result.settings != OPTEE_SMC_SHM_CACHED) {
+		pr_err("only normal cached shared memory supported\n");
+		return ERR_PTR(-EINVAL);
+	}
+
+	begin = roundup(res.result.start, PAGE_SIZE);
+	end = rounddown(res.result.start + res.result.size, PAGE_SIZE);
+	paddr = begin;
+	size = end - begin;
+
+	if (size < 2 * OPTEE_SHM_NUM_PRIV_PAGES * PAGE_SIZE) {
+		pr_err("too small shared memory area\n");
+		return ERR_PTR(-EINVAL);
+	}
+
+	va = memremap(paddr, size, MEMREMAP_WB);
+	if (!va) {
+		pr_err("shared memory ioremap failed\n");
+		return ERR_PTR(-EINVAL);
+	}
+	vaddr = (unsigned long)va;
+
+	/*
+	 * If OP-TEE can work with unregistered SHM, we will use own pool
+	 * for private shm
+	 */
+	if (sec_caps & OPTEE_SMC_SEC_CAP_DYNAMIC_SHM) {
+		rc = optee_shm_pool_alloc_pages();
+		if (IS_ERR(rc))
+			goto err_memunmap;
+		priv_mgr = rc;
+	} else {
+		const size_t sz = OPTEE_SHM_NUM_PRIV_PAGES * PAGE_SIZE;
+
+		rc = tee_shm_pool_mgr_alloc_res_mem(vaddr, paddr, sz,
+						    3 /* 8 bytes aligned */);
+		if (IS_ERR(rc))
+			goto err_memunmap;
+		priv_mgr = rc;
+
+		vaddr += sz;
+		paddr += sz;
+		size -= sz;
+	}
+
+	rc = tee_shm_pool_mgr_alloc_res_mem(vaddr, paddr, size, PAGE_SHIFT);
+	if (IS_ERR(rc))
+		goto err_free_priv_mgr;
+	dmabuf_mgr = rc;
+
+	rc = tee_shm_pool_alloc(priv_mgr, dmabuf_mgr);
+	if (IS_ERR(rc))
+		goto err_free_dmabuf_mgr;
+
+	*memremaped_shm = va;
+
+	return rc;
+
+err_free_dmabuf_mgr:
+	tee_shm_pool_mgr_destroy(dmabuf_mgr);
+err_free_priv_mgr:
+	tee_shm_pool_mgr_destroy(priv_mgr);
+err_memunmap:
+	memunmap(va);
+	return rc;
+}
+
+/* Simple wrapper functions to be able to use a function pointer */
+static void optee_smccc_smc(unsigned long a0, unsigned long a1,
+			    unsigned long a2, unsigned long a3,
+			    unsigned long a4, unsigned long a5,
+			    unsigned long a6, unsigned long a7,
+			    struct arm_smccc_res *res)
+{
+#if defined(CONFIG_RTD139x) || defined(CONFIG_RTD16xx)
+	down(&sem_tee);
+#endif
+	arm_smccc_smc(a0, a1, a2, a3, a4, a5, a6, a7, res);
+#if defined(CONFIG_RTD139x) || defined(CONFIG_RTD16xx)
+	up(&sem_tee);
+#endif
+}
+
+static void optee_smccc_hvc(unsigned long a0, unsigned long a1,
+			    unsigned long a2, unsigned long a3,
+			    unsigned long a4, unsigned long a5,
+			    unsigned long a6, unsigned long a7,
+			    struct arm_smccc_res *res)
+{
+	arm_smccc_hvc(a0, a1, a2, a3, a4, a5, a6, a7, res);
+}
+
+static optee_invoke_fn *get_invoke_func(struct device_node *np)
+{
+	const char *method;
+
+	pr_info("probing for conduit method from DT.\n");
+
+	if (of_property_read_string(np, "method", &method)) {
+		pr_warn("missing \"method\" property\n");
+		return ERR_PTR(-ENXIO);
+	}
+
+	if (!strcmp("hvc", method))
+		return optee_smccc_hvc;
+	else if (!strcmp("smc", method))
+		return optee_smccc_smc;
+
+	pr_warn("invalid \"method\" property: %s\n", method);
+	return ERR_PTR(-EINVAL);
+}
+
+static struct optee *optee_probe(struct device_node *np)
+{
+	optee_invoke_fn *invoke_fn;
+	struct tee_shm_pool *pool;
+	struct optee *optee = NULL;
+	void *memremaped_shm = NULL;
+	struct tee_device *teedev;
+	u32 sec_caps;
+	int rc;
+	
+#ifdef BL31_TSP_TEST
+	proc_file = proc_create("tsp_trigger", 0x0644, NULL, &proc_fops);
+	
+	if(!proc_file){
+		printk(KERN_ERR "/proc/tsp_trigger can't be created! \n");
+	}
+	else{
+		printk(KERN_ERR "/proc/tsp_trigger is created. \n");
+	}	
+#endif
+
+	invoke_fn = get_invoke_func(np);
+	if (IS_ERR(invoke_fn))
+		return (void *)invoke_fn;
+
+	if (!optee_msg_api_uid_is_optee_api(invoke_fn)) {
+		pr_warn("api uid mismatch\n");
+		return ERR_PTR(-EINVAL);
+	}
+
+	if (!optee_msg_api_revision_is_compatible(invoke_fn)) {
+		pr_warn("api revision mismatch\n");
+		return ERR_PTR(-EINVAL);
+	}
+
+	if (!optee_msg_exchange_capabilities(invoke_fn, &sec_caps)) {
+		pr_warn("capabilities mismatch\n");
+		return ERR_PTR(-EINVAL);
+	}
+
+	/*
+	 * We have no other option for shared memory, if secure world
+	 * doesn't have any reserved memory we can use we can't continue.
+	 */
+	if (!(sec_caps & OPTEE_SMC_SEC_CAP_HAVE_RESERVED_SHM))
+		return ERR_PTR(-EINVAL);
+
+	pool = optee_config_shm_memremap(invoke_fn, &memremaped_shm, sec_caps);
+	if (IS_ERR(pool))
+		return (void *)pool;
+
+	optee = kzalloc(sizeof(*optee), GFP_KERNEL);
+	if (!optee) {
+		rc = -ENOMEM;
+		goto err;
+	}
+
+	optee->invoke_fn = invoke_fn;
+	optee->sec_caps = sec_caps;
+
+	teedev = tee_device_alloc(&optee_desc, NULL, pool, optee);
+	if (IS_ERR(teedev)) {
+		rc = PTR_ERR(teedev);
+		goto err;
+	}
+	optee->teedev = teedev;
+
+	teedev = tee_device_alloc(&optee_supp_desc, NULL, pool, optee);
+	if (IS_ERR(teedev)) {
+		rc = PTR_ERR(teedev);
+		goto err;
+	}
+	optee->supp_teedev = teedev;
+
+	rc = tee_device_register(optee->teedev);
+	if (rc)
+		goto err;
+
+	rc = tee_device_register(optee->supp_teedev);
+	if (rc)
+		goto err;
+
+	mutex_init(&optee->call_queue.mutex);
+	INIT_LIST_HEAD(&optee->call_queue.waiters);
+	optee_wait_queue_init(&optee->wait_queue);
+	optee_supp_init(&optee->supp);
+	optee->memremaped_shm = memremaped_shm;
+	optee->pool = pool;
+
+	optee_enable_shm_cache(optee);
+
+	pr_info("initialized driver\n");
+	return optee;
+err:
+	if (optee) {
+		/*
+		 * tee_device_unregister() is safe to call even if the
+		 * devices hasn't been registered with
+		 * tee_device_register() yet.
+		 */
+		tee_device_unregister(optee->supp_teedev);
+		tee_device_unregister(optee->teedev);
+		kfree(optee);
+	}
+	if (pool)
+		tee_shm_pool_free(pool);
+	if (memremaped_shm)
+		memunmap(memremaped_shm);
+	return ERR_PTR(rc);
+}
+
+static void optee_remove(struct optee *optee)
+{
+	/*
+	 * Ask OP-TEE to free all cached shared memory objects to decrease
+	 * reference counters and also avoid wild pointers in secure world
+	 * into the old shared memory range.
+	 */
+	optee_disable_shm_cache(optee);
+
+	/*
+	 * The two devices has to be unregistered before we can free the
+	 * other resources.
+	 */
+	tee_device_unregister(optee->supp_teedev);
+	tee_device_unregister(optee->teedev);
+
+	tee_shm_pool_free(optee->pool);
+	if (optee->memremaped_shm)
+		memunmap(optee->memremaped_shm);
+	optee_wait_queue_exit(&optee->wait_queue);
+	optee_supp_uninit(&optee->supp);
+	mutex_destroy(&optee->call_queue.mutex);
+
+	kfree(optee);
+}
+
+static const struct of_device_id optee_match[] = {
+	{ .compatible = "linaro,optee-tz" },
+	{},
+};
+
+static struct optee *optee_svc;
+
+static int __init optee_driver_init(void)
+{
+	struct device_node *fw_np;
+	struct device_node *np;
+	struct optee *optee;
+#if defined(CONFIG_RTD139x) || defined(CONFIG_RTD16xx)
+	printk(KERN_INFO "TEE SEM INIT\n");
+	sema_init( &sem_tee, 3);
+#endif
+
+	/* Node is supposed to be below /firmware */
+	fw_np = of_find_node_by_name(NULL, "firmware");
+	if (!fw_np)
+		return -ENODEV;
+
+	np = of_find_matching_node(fw_np, optee_match);
+	if (!np)
+		return -ENODEV;
+
+	optee = optee_probe(np);
+	of_node_put(np);
+
+	if (IS_ERR(optee))
+		return PTR_ERR(optee);
+
+	optee_svc = optee;
+
+	return 0;
+}
+fs_initcall(optee_driver_init);
+
+static void __exit optee_driver_exit(void)
+{
+	struct optee *optee = optee_svc;
+
+	optee_svc = NULL;
+	if (optee)
+		optee_remove(optee);
+}
+module_exit(optee_driver_exit);
+
+MODULE_AUTHOR("Linaro");
+MODULE_DESCRIPTION("OP-TEE driver");
+MODULE_SUPPORTED_DEVICE("");
+MODULE_VERSION("1.0");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/tee/optee/optee_msg.h b/drivers/tee/optee/optee_msg.h
new file mode 100644
index 00000000..3050490
--- /dev/null
+++ b/drivers/tee/optee/optee_msg.h
@@ -0,0 +1,444 @@
+/*
+ * Copyright (c) 2015-2016, Linaro Limited
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright notice,
+ * this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+#ifndef _OPTEE_MSG_H
+#define _OPTEE_MSG_H
+
+#include <linux/bitops.h>
+#include <linux/types.h>
+
+/*
+ * This file defines the OP-TEE message protocol used to communicate
+ * with an instance of OP-TEE running in secure world.
+ *
+ * This file is divided into three sections.
+ * 1. Formatting of messages.
+ * 2. Requests from normal world
+ * 3. Requests from secure world, Remote Procedure Call (RPC), handled by
+ *    tee-supplicant.
+ */
+
+/*****************************************************************************
+ * Part 1 - formatting of messages
+ *****************************************************************************/
+
+#define OPTEE_MSG_ATTR_TYPE_NONE		0x0
+#define OPTEE_MSG_ATTR_TYPE_VALUE_INPUT		0x1
+#define OPTEE_MSG_ATTR_TYPE_VALUE_OUTPUT	0x2
+#define OPTEE_MSG_ATTR_TYPE_VALUE_INOUT		0x3
+#define OPTEE_MSG_ATTR_TYPE_RMEM_INPUT		0x5
+#define OPTEE_MSG_ATTR_TYPE_RMEM_OUTPUT		0x6
+#define OPTEE_MSG_ATTR_TYPE_RMEM_INOUT		0x7
+#define OPTEE_MSG_ATTR_TYPE_TMEM_INPUT		0x9
+#define OPTEE_MSG_ATTR_TYPE_TMEM_OUTPUT		0xa
+#define OPTEE_MSG_ATTR_TYPE_TMEM_INOUT		0xb
+
+#define OPTEE_MSG_ATTR_TYPE_MASK		GENMASK(7, 0)
+
+/*
+ * Meta parameter to be absorbed by the Secure OS and not passed
+ * to the Trusted Application.
+ *
+ * Currently only used with OPTEE_MSG_CMD_OPEN_SESSION.
+ */
+#define OPTEE_MSG_ATTR_META			BIT(8)
+
+/*
+ * Pointer to a list of pages used to register user-defined SHM buffer.
+ * Used with OPTEE_MSG_ATTR_TYPE_TMEM_*.
+ * buf_ptr should point to the beginning of the buffer. Buffer will contain
+ * list of page addresses. OP-TEE core can reconstruct contiguous buffer from
+ * that page addresses list. Page addresses are stored as 64 bit values.
+ * Last entry on a page should point to the next page of buffer.
+ * Every entry in buffer should point to a 4k page beginning (12 least
+ * significant bits must be equal to zero).
+ *
+ * 12 least significant bints of optee_msg_param.u.tmem.buf_ptr should hold page
+ * offset of the user buffer.
+ *
+ * So, entries should be placed like members of this structure:
+ *
+ * struct page_data {
+ *   uint64_t pages_array[OPTEE_MSG_NONCONTIG_PAGE_SIZE/sizeof(uint64_t) - 1];
+ *   uint64_t next_page_data;
+ * };
+ *
+ * Structure is designed to exactly fit into the page size
+ * OPTEE_MSG_NONCONTIG_PAGE_SIZE which is a standard 4KB page.
+ *
+ * The size of 4KB is chosen because this is the smallest page size for ARM
+ * architectures. If REE uses larger pages, it should divide them to 4KB ones.
+ */
+#define OPTEE_MSG_ATTR_NONCONTIG		BIT(9)
+
+/*
+ * Memory attributes for caching passed with temp memrefs. The actual value
+ * used is defined outside the message protocol with the exception of
+ * OPTEE_MSG_ATTR_CACHE_PREDEFINED which means the attributes already
+ * defined for the memory range should be used. If optee_smc.h is used as
+ * bearer of this protocol OPTEE_SMC_SHM_* is used for values.
+ */
+#define OPTEE_MSG_ATTR_CACHE_SHIFT		16
+#define OPTEE_MSG_ATTR_CACHE_MASK		GENMASK(2, 0)
+#define OPTEE_MSG_ATTR_CACHE_PREDEFINED		0
+
+/*
+ * Same values as TEE_LOGIN_* from TEE Internal API
+ */
+#define OPTEE_MSG_LOGIN_PUBLIC			0x00000000
+#define OPTEE_MSG_LOGIN_USER			0x00000001
+#define OPTEE_MSG_LOGIN_GROUP			0x00000002
+#define OPTEE_MSG_LOGIN_APPLICATION		0x00000004
+#define OPTEE_MSG_LOGIN_APPLICATION_USER	0x00000005
+#define OPTEE_MSG_LOGIN_APPLICATION_GROUP	0x00000006
+
+/*
+ * Page size used in non-contiguous buffer entries
+ */
+#define OPTEE_MSG_NONCONTIG_PAGE_SIZE		4096
+
+/**
+ * struct optee_msg_param_tmem - temporary memory reference parameter
+ * @buf_ptr:	Address of the buffer
+ * @size:	Size of the buffer
+ * @shm_ref:	Temporary shared memory reference, pointer to a struct tee_shm
+ *
+ * Secure and normal world communicates pointers as physical address
+ * instead of the virtual address. This is because secure and normal world
+ * have completely independent memory mapping. Normal world can even have a
+ * hypervisor which need to translate the guest physical address (AKA IPA
+ * in ARM documentation) to a real physical address before passing the
+ * structure to secure world.
+ */
+struct optee_msg_param_tmem {
+	u64 buf_ptr;
+	u64 size;
+	u64 shm_ref;
+};
+
+/**
+ * struct optee_msg_param_rmem - registered memory reference parameter
+ * @offs:	Offset into shared memory reference
+ * @size:	Size of the buffer
+ * @shm_ref:	Shared memory reference, pointer to a struct tee_shm
+ */
+struct optee_msg_param_rmem {
+	u64 offs;
+	u64 size;
+	u64 shm_ref;
+};
+
+/**
+ * struct optee_msg_param_value - opaque value parameter
+ *
+ * Value parameters are passed unchecked between normal and secure world.
+ */
+struct optee_msg_param_value {
+	u64 a;
+	u64 b;
+	u64 c;
+};
+
+/**
+ * struct optee_msg_param - parameter used together with struct optee_msg_arg
+ * @attr:	attributes
+ * @tmem:	parameter by temporary memory reference
+ * @rmem:	parameter by registered memory reference
+ * @value:	parameter by opaque value
+ *
+ * @attr & OPTEE_MSG_ATTR_TYPE_MASK indicates if tmem, rmem or value is used in
+ * the union. OPTEE_MSG_ATTR_TYPE_VALUE_* indicates value,
+ * OPTEE_MSG_ATTR_TYPE_TMEM_* indicates @tmem and
+ * OPTEE_MSG_ATTR_TYPE_RMEM_* indicates @rmem,
+ * OPTEE_MSG_ATTR_TYPE_NONE indicates that none of the members are used.
+ */
+struct optee_msg_param {
+	u64 attr;
+	union {
+		struct optee_msg_param_tmem tmem;
+		struct optee_msg_param_rmem rmem;
+		struct optee_msg_param_value value;
+	} u;
+};
+
+/**
+ * struct optee_msg_arg - call argument
+ * @cmd: Command, one of OPTEE_MSG_CMD_* or OPTEE_MSG_RPC_CMD_*
+ * @func: Trusted Application function, specific to the Trusted Application,
+ *	     used if cmd == OPTEE_MSG_CMD_INVOKE_COMMAND
+ * @session: In parameter for all OPTEE_MSG_CMD_* except
+ *	     OPTEE_MSG_CMD_OPEN_SESSION where it's an output parameter instead
+ * @cancel_id: Cancellation id, a unique value to identify this request
+ * @ret: return value
+ * @ret_origin: origin of the return value
+ * @num_params: number of parameters supplied to the OS Command
+ * @params: the parameters supplied to the OS Command
+ *
+ * All normal calls to Trusted OS uses this struct. If cmd requires further
+ * information than what these field holds it can be passed as a parameter
+ * tagged as meta (setting the OPTEE_MSG_ATTR_META bit in corresponding
+ * attrs field). All parameters tagged as meta has to come first.
+ *
+ * Temp memref parameters can be fragmented if supported by the Trusted OS
+ * (when optee_smc.h is bearer of this protocol this is indicated with
+ * OPTEE_SMC_SEC_CAP_UNREGISTERED_SHM). If a logical memref parameter is
+ * fragmented then has all but the last fragment the
+ * OPTEE_MSG_ATTR_FRAGMENT bit set in attrs. Even if a memref is fragmented
+ * it will still be presented as a single logical memref to the Trusted
+ * Application.
+ */
+struct optee_msg_arg {
+	u32 cmd;
+	u32 func;
+	u32 session;
+	u32 cancel_id;
+	u32 pad;
+	u32 ret;
+	u32 ret_origin;
+	u32 num_params;
+
+	/* num_params tells the actual number of element in params */
+	struct optee_msg_param params[0];
+};
+
+/**
+ * OPTEE_MSG_GET_ARG_SIZE - return size of struct optee_msg_arg
+ *
+ * @num_params: Number of parameters embedded in the struct optee_msg_arg
+ *
+ * Returns the size of the struct optee_msg_arg together with the number
+ * of embedded parameters.
+ */
+#define OPTEE_MSG_GET_ARG_SIZE(num_params) \
+	(sizeof(struct optee_msg_arg) + \
+	 sizeof(struct optee_msg_param) * (num_params))
+
+/*****************************************************************************
+ * Part 2 - requests from normal world
+ *****************************************************************************/
+
+/*
+ * Return the following UID if using API specified in this file without
+ * further extensions:
+ * 384fb3e0-e7f8-11e3-af63-0002a5d5c51b.
+ * Represented in 4 32-bit words in OPTEE_MSG_UID_0, OPTEE_MSG_UID_1,
+ * OPTEE_MSG_UID_2, OPTEE_MSG_UID_3.
+ */
+#define OPTEE_MSG_UID_0			0x384fb3e0
+#define OPTEE_MSG_UID_1			0xe7f811e3
+#define OPTEE_MSG_UID_2			0xaf630002
+#define OPTEE_MSG_UID_3			0xa5d5c51b
+#define OPTEE_MSG_FUNCID_CALLS_UID	0xFF01
+
+/*
+ * Returns 2.0 if using API specified in this file without further
+ * extensions. Represented in 2 32-bit words in OPTEE_MSG_REVISION_MAJOR
+ * and OPTEE_MSG_REVISION_MINOR
+ */
+#define OPTEE_MSG_REVISION_MAJOR	2
+#define OPTEE_MSG_REVISION_MINOR	0
+#define OPTEE_MSG_FUNCID_CALLS_REVISION	0xFF03
+
+/*
+ * Get UUID of Trusted OS.
+ *
+ * Used by non-secure world to figure out which Trusted OS is installed.
+ * Note that returned UUID is the UUID of the Trusted OS, not of the API.
+ *
+ * Returns UUID in 4 32-bit words in the same way as
+ * OPTEE_MSG_FUNCID_CALLS_UID described above.
+ */
+#define OPTEE_MSG_OS_OPTEE_UUID_0	0x486178e0
+#define OPTEE_MSG_OS_OPTEE_UUID_1	0xe7f811e3
+#define OPTEE_MSG_OS_OPTEE_UUID_2	0xbc5e0002
+#define OPTEE_MSG_OS_OPTEE_UUID_3	0xa5d5c51b
+#define OPTEE_MSG_FUNCID_GET_OS_UUID	0x0000
+
+/*
+ * Get revision of Trusted OS.
+ *
+ * Used by non-secure world to figure out which version of the Trusted OS
+ * is installed. Note that the returned revision is the revision of the
+ * Trusted OS, not of the API.
+ *
+ * Returns revision in 2 32-bit words in the same way as
+ * OPTEE_MSG_CALLS_REVISION described above.
+ */
+#define OPTEE_MSG_FUNCID_GET_OS_REVISION	0x0001
+
+/*
+ * Do a secure call with struct optee_msg_arg as argument
+ * The OPTEE_MSG_CMD_* below defines what goes in struct optee_msg_arg::cmd
+ *
+ * OPTEE_MSG_CMD_OPEN_SESSION opens a session to a Trusted Application.
+ * The first two parameters are tagged as meta, holding two value
+ * parameters to pass the following information:
+ * param[0].u.value.a-b uuid of Trusted Application
+ * param[1].u.value.a-b uuid of Client
+ * param[1].u.value.c Login class of client OPTEE_MSG_LOGIN_*
+ *
+ * OPTEE_MSG_CMD_INVOKE_COMMAND invokes a command a previously opened
+ * session to a Trusted Application.  struct optee_msg_arg::func is Trusted
+ * Application function, specific to the Trusted Application.
+ *
+ * OPTEE_MSG_CMD_CLOSE_SESSION closes a previously opened session to
+ * Trusted Application.
+ *
+ * OPTEE_MSG_CMD_CANCEL cancels a currently invoked command.
+ *
+ * OPTEE_MSG_CMD_REGISTER_SHM registers a shared memory reference. The
+ * information is passed as:
+ * [in] param[0].attr			OPTEE_MSG_ATTR_TYPE_TMEM_INPUT
+ *					[| OPTEE_MSG_ATTR_FRAGMENT]
+ * [in] param[0].u.tmem.buf_ptr		physical address (of first fragment)
+ * [in] param[0].u.tmem.size		size (of first fragment)
+ * [in] param[0].u.tmem.shm_ref		holds shared memory reference
+ * ...
+ * The shared memory can optionally be fragmented, temp memrefs can follow
+ * each other with all but the last with the OPTEE_MSG_ATTR_FRAGMENT bit set.
+ *
+ * OPTEE_MSG_CMD_UNREGISTER_SHM unregisteres a previously registered shared
+ * memory reference. The information is passed as:
+ * [in] param[0].attr			OPTEE_MSG_ATTR_TYPE_RMEM_INPUT
+ * [in] param[0].u.rmem.shm_ref		holds shared memory reference
+ * [in] param[0].u.rmem.offs		0
+ * [in] param[0].u.rmem.size		0
+ */
+#define OPTEE_MSG_CMD_OPEN_SESSION	0
+#define OPTEE_MSG_CMD_INVOKE_COMMAND	1
+#define OPTEE_MSG_CMD_CLOSE_SESSION	2
+#define OPTEE_MSG_CMD_CANCEL		3
+#define OPTEE_MSG_CMD_REGISTER_SHM	4
+#define OPTEE_MSG_CMD_UNREGISTER_SHM	5
+#define OPTEE_MSG_FUNCID_CALL_WITH_ARG	0x0004
+
+/*****************************************************************************
+ * Part 3 - Requests from secure world, RPC
+ *****************************************************************************/
+
+/*
+ * All RPC is done with a struct optee_msg_arg as bearer of information,
+ * struct optee_msg_arg::arg holds values defined by OPTEE_MSG_RPC_CMD_* below
+ *
+ * RPC communication with tee-supplicant is reversed compared to normal
+ * client communication desribed above. The supplicant receives requests
+ * and sends responses.
+ */
+
+/*
+ * Load a TA into memory, defined in tee-supplicant
+ */
+#define OPTEE_MSG_RPC_CMD_LOAD_TA	0
+
+/*
+ * Reserved
+ */
+#define OPTEE_MSG_RPC_CMD_RPMB		1
+
+/*
+ * File system access, defined in tee-supplicant
+ */
+#define OPTEE_MSG_RPC_CMD_FS		2
+
+/*
+ * Get time
+ *
+ * Returns number of seconds and nano seconds since the Epoch,
+ * 1970-01-01 00:00:00 +0000 (UTC).
+ *
+ * [out] param[0].u.value.a	Number of seconds
+ * [out] param[0].u.value.b	Number of nano seconds.
+ */
+#define OPTEE_MSG_RPC_CMD_GET_TIME	3
+
+/*
+ * Wait queue primitive, helper for secure world to implement a wait queue.
+ *
+ * If secure world need to wait for a secure world mutex it issues a sleep
+ * request instead of spinning in secure world. Conversely is a wakeup
+ * request issued when a secure world mutex with a thread waiting thread is
+ * unlocked.
+ *
+ * Waiting on a key
+ * [in] param[0].u.value.a OPTEE_MSG_RPC_WAIT_QUEUE_SLEEP
+ * [in] param[0].u.value.b wait key
+ *
+ * Waking up a key
+ * [in] param[0].u.value.a OPTEE_MSG_RPC_WAIT_QUEUE_WAKEUP
+ * [in] param[0].u.value.b wakeup key
+ */
+#define OPTEE_MSG_RPC_CMD_WAIT_QUEUE	4
+#define OPTEE_MSG_RPC_WAIT_QUEUE_SLEEP	0
+#define OPTEE_MSG_RPC_WAIT_QUEUE_WAKEUP	1
+
+/*
+ * Suspend execution
+ *
+ * [in] param[0].value	.a number of milliseconds to suspend
+ */
+#define OPTEE_MSG_RPC_CMD_SUSPEND	5
+
+/*
+ * Allocate a piece of shared memory
+ *
+ * Shared memory can optionally be fragmented, to support that additional
+ * spare param entries are allocated to make room for eventual fragments.
+ * The spare param entries has .attr = OPTEE_MSG_ATTR_TYPE_NONE when
+ * unused. All returned temp memrefs except the last should have the
+ * OPTEE_MSG_ATTR_FRAGMENT bit set in the attr field.
+ *
+ * [in]  param[0].u.value.a		type of memory one of
+ *					OPTEE_MSG_RPC_SHM_TYPE_* below
+ * [in]  param[0].u.value.b		requested size
+ * [in]  param[0].u.value.c		required alignment
+ *
+ * [out] param[0].u.tmem.buf_ptr	physical address (of first fragment)
+ * [out] param[0].u.tmem.size		size (of first fragment)
+ * [out] param[0].u.tmem.shm_ref	shared memory reference
+ * ...
+ * [out] param[n].u.tmem.buf_ptr	physical address
+ * [out] param[n].u.tmem.size		size
+ * [out] param[n].u.tmem.shm_ref	shared memory reference (same value
+ *					as in param[n-1].u.tmem.shm_ref)
+ */
+#define OPTEE_MSG_RPC_CMD_SHM_ALLOC	6
+/* Memory that can be shared with a non-secure user space application */
+#define OPTEE_MSG_RPC_SHM_TYPE_APPL	0
+/* Memory only shared with non-secure kernel */
+#define OPTEE_MSG_RPC_SHM_TYPE_KERNEL	1
+
+/*
+ * Free shared memory previously allocated with OPTEE_MSG_RPC_CMD_SHM_ALLOC
+ *
+ * [in]  param[0].u.value.a		type of memory one of
+ *					OPTEE_MSG_RPC_SHM_TYPE_* above
+ * [in]  param[0].u.value.b		value of shared memory reference
+ *					returned in param[0].u.tmem.shm_ref
+ *					above
+ */
+#define OPTEE_MSG_RPC_CMD_SHM_FREE	7
+
+#endif /* _OPTEE_MSG_H */
diff --git a/drivers/tee/optee/optee_private.h b/drivers/tee/optee/optee_private.h
new file mode 100755
index 00000000..35e7938
--- /dev/null
+++ b/drivers/tee/optee/optee_private.h
@@ -0,0 +1,199 @@
+/*
+ * Copyright (c) 2015, Linaro Limited
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef OPTEE_PRIVATE_H
+#define OPTEE_PRIVATE_H
+
+#include <linux/arm-smccc.h>
+#include <linux/semaphore.h>
+#include <linux/tee_drv.h>
+#include <linux/types.h>
+#include "optee_msg.h"
+
+#define OPTEE_MAX_ARG_SIZE	1024
+
+/* Some Global Platform error codes used in this driver */
+#define TEEC_SUCCESS			0x00000000
+#define TEEC_ERROR_BAD_PARAMETERS	0xFFFF0006
+#define TEEC_ERROR_COMMUNICATION	0xFFFF000E
+#define TEEC_ERROR_OUT_OF_MEMORY	0xFFFF000C
+
+#define TEEC_ORIGIN_COMMS		0x00000002
+
+typedef void (optee_invoke_fn)(unsigned long, unsigned long, unsigned long,
+				unsigned long, unsigned long, unsigned long,
+				unsigned long, unsigned long,
+				struct arm_smccc_res *);
+
+struct optee_call_queue {
+	/* Serializes access to this struct */
+	struct mutex mutex;
+	struct list_head waiters;
+};
+
+struct optee_wait_queue {
+	/* Serializes access to this struct */
+	struct mutex mu;
+	struct list_head db;
+};
+
+/**
+ * struct optee_supp - supplicant synchronization struct
+ * @ctx			the context of current connected supplicant.
+ *			if !NULL the supplicant device is available for use,
+ *			else busy
+ * @mutex:		held while accessing content of this struct
+ * @req_id:		current request id if supplicant is doing synchronous
+ *			communication, else -1
+ * @reqs:		queued request not yet retrieved by supplicant
+ * @idr:		IDR holding all requests currently being processed
+ *			by supplicant
+ * @reqs_c:		completion used by supplicant when waiting for a
+ *			request to be queued.
+ */
+struct optee_supp {
+	/* Serializes access to this struct */
+	struct mutex mutex;
+	struct tee_context *ctx;
+
+	int req_id;
+	struct list_head reqs;
+	struct idr idr;
+	struct completion reqs_c;
+};
+
+/**
+ * struct optee - main service struct
+ * @supp_teedev:	supplicant device
+ * @teedev:		client device
+ * @invoke_fn:		function to issue smc or hvc
+ * @call_queue:		queue of threads waiting to call @invoke_fn
+ * @wait_queue:		queue of threads from secure world waiting for a
+ *			secure world sync object
+ * @supp:		supplicant synchronization struct for RPC to supplicant
+ * @pool:		shared memory pool
+ * @memremaped_shm	virtual address of memory in shared memory pool
+ * @sec_caps:		secure world capabilities defined by
+ *			OPTEE_SMC_SEC_CAP_* in optee_smc.h
+ */
+struct optee {
+	struct tee_device *supp_teedev;
+	struct tee_device *teedev;
+	optee_invoke_fn *invoke_fn;
+	struct optee_call_queue call_queue;
+	struct optee_wait_queue wait_queue;
+	struct optee_supp supp;
+	struct tee_shm_pool *pool;
+	void *memremaped_shm;
+	u32 sec_caps;
+};
+
+struct optee_session {
+	struct list_head list_node;
+	u32 session_id;
+};
+
+struct optee_context_data {
+	/* Serializes access to this struct */
+	struct mutex mutex;
+	struct list_head sess_list;
+};
+
+struct optee_rpc_param {
+	u32	a0;
+	u32	a1;
+	u32	a2;
+	u32	a3;
+	u32	a4;
+	u32	a5;
+	u32	a6;
+	u32	a7;
+};
+
+/* Holds context that is preserved during one STD call */
+struct optee_call_ctx {
+	/* information about pages list used in last allocation */
+	void *pages_list;
+	size_t num_entries;
+};
+
+void optee_handle_rpc(struct tee_context *ctx, struct optee_rpc_param *param,
+		      struct optee_call_ctx *call_ctx);
+void optee_rpc_finalize_call(struct optee_call_ctx *call_ctx);
+
+void optee_wait_queue_init(struct optee_wait_queue *wq);
+void optee_wait_queue_exit(struct optee_wait_queue *wq);
+
+u32 optee_supp_thrd_req(struct tee_context *ctx, u32 func, size_t num_params,
+			struct tee_param *param);
+
+int optee_supp_read(struct tee_context *ctx, void __user *buf, size_t len);
+int optee_supp_write(struct tee_context *ctx, void __user *buf, size_t len);
+void optee_supp_init(struct optee_supp *supp);
+void optee_supp_uninit(struct optee_supp *supp);
+void optee_supp_release(struct optee_supp *supp);
+
+int optee_supp_recv(struct tee_context *ctx, u32 *func, u32 *num_params,
+		    struct tee_param *param);
+int optee_supp_send(struct tee_context *ctx, u32 ret, u32 num_params,
+		    struct tee_param *param);
+
+u32 optee_do_call_with_arg(struct tee_context *ctx, phys_addr_t parg);
+int optee_open_session(struct tee_context *ctx,
+		       struct tee_ioctl_open_session_arg *arg,
+		       struct tee_param *param);
+int optee_close_session(struct tee_context *ctx, u32 session);
+int optee_invoke_func(struct tee_context *ctx, struct tee_ioctl_invoke_arg *arg,
+		      struct tee_param *param);
+int optee_cancel_req(struct tee_context *ctx, u32 cancel_id, u32 session);
+
+void optee_enable_shm_cache(struct optee *optee);
+void optee_disable_shm_cache(struct optee *optee);
+
+int optee_shm_register(struct tee_context *ctx, struct tee_shm *shm,
+		       struct page **pages, size_t num_pages,
+		       unsigned long start);
+int optee_shm_unregister(struct tee_context *ctx, struct tee_shm *shm);
+
+int optee_shm_register_supp(struct tee_context *ctx, struct tee_shm *shm,
+			    struct page **pages, size_t num_pages,
+			    unsigned long start);
+int optee_shm_unregister_supp(struct tee_context *ctx, struct tee_shm *shm);
+
+int optee_from_msg_param(struct tee_param *params, size_t num_params,
+			 const struct optee_msg_param *msg_params);
+int optee_to_msg_param(struct optee_msg_param *msg_params, size_t num_params,
+		       const struct tee_param *params);
+
+u64 *optee_allocate_pages_list(size_t num_entries);
+void optee_free_pages_list(void *array, size_t num_entries);
+void optee_fill_pages_list(u64 *dst, struct page **pages, int num_pages,
+			   size_t page_offset);
+
+/*
+ * Small helpers
+ */
+
+static inline void *reg_pair_to_ptr(u32 reg0, u32 reg1)
+{
+	return (void *)(unsigned long)(((u64)reg0 << 32) | reg1);
+}
+
+static inline void reg_pair_from_64(u32 *reg0, u32 *reg1, u64 val)
+{
+	*reg0 = val >> 32;
+	*reg1 = val;
+}
+
+#endif /*OPTEE_PRIVATE_H*/
diff --git a/drivers/tee/optee/optee_smc.h b/drivers/tee/optee/optee_smc.h
new file mode 100644
index 00000000..1af7a03
--- /dev/null
+++ b/drivers/tee/optee/optee_smc.h
@@ -0,0 +1,456 @@
+/*
+ * Copyright (c) 2015-2016, Linaro Limited
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright notice,
+ * this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+#ifndef OPTEE_SMC_H
+#define OPTEE_SMC_H
+
+#include <linux/arm-smccc.h>
+#include <linux/bitops.h>
+
+#define OPTEE_SMC_STD_CALL_VAL(func_num) \
+	ARM_SMCCC_CALL_VAL(ARM_SMCCC_STD_CALL, ARM_SMCCC_SMC_32, \
+			   ARM_SMCCC_OWNER_TRUSTED_OS, (func_num))
+#define OPTEE_SMC_FAST_CALL_VAL(func_num) \
+	ARM_SMCCC_CALL_VAL(ARM_SMCCC_FAST_CALL, ARM_SMCCC_SMC_32, \
+			   ARM_SMCCC_OWNER_TRUSTED_OS, (func_num))
+
+/*
+ * Function specified by SMC Calling convention.
+ */
+#define OPTEE_SMC_FUNCID_CALLS_COUNT	0xFF00
+#define OPTEE_SMC_CALLS_COUNT \
+	ARM_SMCCC_CALL_VAL(OPTEE_SMC_FAST_CALL, SMCCC_SMC_32, \
+			   SMCCC_OWNER_TRUSTED_OS_END, \
+			   OPTEE_SMC_FUNCID_CALLS_COUNT)
+
+/*
+ * Normal cached memory (write-back), shareable for SMP systems and not
+ * shareable for UP systems.
+ */
+#define OPTEE_SMC_SHM_CACHED		1
+
+/*
+ * a0..a7 is used as register names in the descriptions below, on arm32
+ * that translates to r0..r7 and on arm64 to w0..w7. In both cases it's
+ * 32-bit registers.
+ */
+
+/*
+ * Function specified by SMC Calling convention
+ *
+ * Return one of the following UIDs if using API specified in this file
+ * without further extentions:
+ * 65cb6b93-af0c-4617-8ed6-644a8d1140f8
+ * see also OPTEE_SMC_UID_* in optee_msg.h
+ */
+#define OPTEE_SMC_FUNCID_CALLS_UID OPTEE_MSG_FUNCID_CALLS_UID
+#define OPTEE_SMC_CALLS_UID \
+	ARM_SMCCC_CALL_VAL(ARM_SMCCC_FAST_CALL, ARM_SMCCC_SMC_32, \
+			   ARM_SMCCC_OWNER_TRUSTED_OS_END, \
+			   OPTEE_SMC_FUNCID_CALLS_UID)
+
+/*
+ * Function specified by SMC Calling convention
+ *
+ * Returns 2.0 if using API specified in this file without further extentions.
+ * see also OPTEE_MSG_REVISION_* in optee_msg.h
+ */
+#define OPTEE_SMC_FUNCID_CALLS_REVISION OPTEE_MSG_FUNCID_CALLS_REVISION
+#define OPTEE_SMC_CALLS_REVISION \
+	ARM_SMCCC_CALL_VAL(ARM_SMCCC_FAST_CALL, ARM_SMCCC_SMC_32, \
+			   ARM_SMCCC_OWNER_TRUSTED_OS_END, \
+			   OPTEE_SMC_FUNCID_CALLS_REVISION)
+struct optee_smc_calls_revision_result {
+	unsigned long major;
+	unsigned long minor;
+	unsigned long reserved0;
+	unsigned long reserved1;
+};
+
+/*
+ * Get UUID of Trusted OS.
+ *
+ * Used by non-secure world to figure out which Trusted OS is installed.
+ * Note that returned UUID is the UUID of the Trusted OS, not of the API.
+ *
+ * Returns UUID in a0-4 in the same way as OPTEE_SMC_CALLS_UID
+ * described above.
+ */
+#define OPTEE_SMC_FUNCID_GET_OS_UUID OPTEE_MSG_FUNCID_GET_OS_UUID
+#define OPTEE_SMC_CALL_GET_OS_UUID \
+	OPTEE_SMC_FAST_CALL_VAL(OPTEE_SMC_FUNCID_GET_OS_UUID)
+
+/*
+ * Get revision of Trusted OS.
+ *
+ * Used by non-secure world to figure out which version of the Trusted OS
+ * is installed. Note that the returned revision is the revision of the
+ * Trusted OS, not of the API.
+ *
+ * Returns revision in a0-1 in the same way as OPTEE_SMC_CALLS_REVISION
+ * described above.
+ */
+#define OPTEE_SMC_FUNCID_GET_OS_REVISION OPTEE_MSG_FUNCID_GET_OS_REVISION
+#define OPTEE_SMC_CALL_GET_OS_REVISION \
+	OPTEE_SMC_FAST_CALL_VAL(OPTEE_SMC_FUNCID_GET_OS_REVISION)
+
+/*
+ * Call with struct optee_msg_arg as argument
+ *
+ * Call register usage:
+ * a0	SMC Function ID, OPTEE_SMC*CALL_WITH_ARG
+ * a1	Upper 32bit of a 64bit physical pointer to a struct optee_msg_arg
+ * a2	Lower 32bit of a 64bit physical pointer to a struct optee_msg_arg
+ * a3	Cache settings, not used if physical pointer is in a predefined shared
+ *	memory area else per OPTEE_SMC_SHM_*
+ * a4-6	Not used
+ * a7	Hypervisor Client ID register
+ *
+ * Normal return register usage:
+ * a0	Return value, OPTEE_SMC_RETURN_*
+ * a1-3	Not used
+ * a4-7	Preserved
+ *
+ * OPTEE_SMC_RETURN_ETHREAD_LIMIT return register usage:
+ * a0	Return value, OPTEE_SMC_RETURN_ETHREAD_LIMIT
+ * a1-3	Preserved
+ * a4-7	Preserved
+ *
+ * RPC return register usage:
+ * a0	Return value, OPTEE_SMC_RETURN_IS_RPC(val)
+ * a1-2	RPC parameters
+ * a3-7	Resume information, must be preserved
+ *
+ * Possible return values:
+ * OPTEE_SMC_RETURN_UNKNOWN_FUNCTION	Trusted OS does not recognize this
+ *					function.
+ * OPTEE_SMC_RETURN_OK			Call completed, result updated in
+ *					the previously supplied struct
+ *					optee_msg_arg.
+ * OPTEE_SMC_RETURN_ETHREAD_LIMIT	Number of Trusted OS threads exceeded,
+ *					try again later.
+ * OPTEE_SMC_RETURN_EBADADDR		Bad physcial pointer to struct
+ *					optee_msg_arg.
+ * OPTEE_SMC_RETURN_EBADCMD		Bad/unknown cmd in struct optee_msg_arg
+ * OPTEE_SMC_RETURN_IS_RPC()		Call suspended by RPC call to normal
+ *					world.
+ */
+#define OPTEE_SMC_FUNCID_CALL_WITH_ARG OPTEE_MSG_FUNCID_CALL_WITH_ARG
+#define OPTEE_SMC_CALL_WITH_ARG \
+	OPTEE_SMC_STD_CALL_VAL(OPTEE_SMC_FUNCID_CALL_WITH_ARG)
+
+/*
+ * Get Shared Memory Config
+ *
+ * Returns the Secure/Non-secure shared memory config.
+ *
+ * Call register usage:
+ * a0	SMC Function ID, OPTEE_SMC_GET_SHM_CONFIG
+ * a1-6	Not used
+ * a7	Hypervisor Client ID register
+ *
+ * Have config return register usage:
+ * a0	OPTEE_SMC_RETURN_OK
+ * a1	Physical address of start of SHM
+ * a2	Size of of SHM
+ * a3	Cache settings of memory, as defined by the
+ *	OPTEE_SMC_SHM_* values above
+ * a4-7	Preserved
+ *
+ * Not available register usage:
+ * a0	OPTEE_SMC_RETURN_ENOTAVAIL
+ * a1-3 Not used
+ * a4-7	Preserved
+ */
+#define OPTEE_SMC_FUNCID_GET_SHM_CONFIG	7
+#define OPTEE_SMC_GET_SHM_CONFIG \
+	OPTEE_SMC_FAST_CALL_VAL(OPTEE_SMC_FUNCID_GET_SHM_CONFIG)
+
+struct optee_smc_get_shm_config_result {
+	unsigned long status;
+	unsigned long start;
+	unsigned long size;
+	unsigned long settings;
+};
+
+/*
+ * Exchanges capabilities between normal world and secure world
+ *
+ * Call register usage:
+ * a0	SMC Function ID, OPTEE_SMC_EXCHANGE_CAPABILITIES
+ * a1	bitfield of normal world capabilities OPTEE_SMC_NSEC_CAP_*
+ * a2-6	Not used
+ * a7	Hypervisor Client ID register
+ *
+ * Normal return register usage:
+ * a0	OPTEE_SMC_RETURN_OK
+ * a1	bitfield of secure world capabilities OPTEE_SMC_SEC_CAP_*
+ * a2-7	Preserved
+ *
+ * Error return register usage:
+ * a0	OPTEE_SMC_RETURN_ENOTAVAIL, can't use the capabilities from normal world
+ * a1	bitfield of secure world capabilities OPTEE_SMC_SEC_CAP_*
+ * a2-7 Preserved
+ */
+/* Normal world works as a uniprocessor system */
+#define OPTEE_SMC_NSEC_CAP_UNIPROCESSOR		BIT(0)
+/* Secure world has reserved shared memory for normal world to use */
+#define OPTEE_SMC_SEC_CAP_HAVE_RESERVED_SHM	BIT(0)
+/* Secure world can communicate via previously unregistered shared memory */
+#define OPTEE_SMC_SEC_CAP_UNREGISTERED_SHM	BIT(1)
+
+/*
+ * Secure world supports commands "register/unregister shared memory",
+ * secure world accepts command buffers located in any parts of non-secure RAM
+ */
+#define OPTEE_SMC_SEC_CAP_DYNAMIC_SHM		BIT(2)
+
+#define OPTEE_SMC_FUNCID_EXCHANGE_CAPABILITIES	9
+#define OPTEE_SMC_EXCHANGE_CAPABILITIES \
+	OPTEE_SMC_FAST_CALL_VAL(OPTEE_SMC_FUNCID_EXCHANGE_CAPABILITIES)
+
+struct optee_smc_exchange_capabilities_result {
+	unsigned long status;
+	unsigned long capabilities;
+	unsigned long reserved0;
+	unsigned long reserved1;
+};
+
+/*
+ * Disable and empties cache of shared memory objects
+ *
+ * Secure world can cache frequently used shared memory objects, for
+ * example objects used as RPC arguments. When secure world is idle this
+ * function returns one shared memory reference to free. To disable the
+ * cache and free all cached objects this function has to be called until
+ * it returns OPTEE_SMC_RETURN_ENOTAVAIL.
+ *
+ * Call register usage:
+ * a0	SMC Function ID, OPTEE_SMC_DISABLE_SHM_CACHE
+ * a1-6	Not used
+ * a7	Hypervisor Client ID register
+ *
+ * Normal return register usage:
+ * a0	OPTEE_SMC_RETURN_OK
+ * a1	Upper 32bit of a 64bit Shared memory cookie
+ * a2	Lower 32bit of a 64bit Shared memory cookie
+ * a3-7	Preserved
+ *
+ * Cache empty return register usage:
+ * a0	OPTEE_SMC_RETURN_ENOTAVAIL
+ * a1-7	Preserved
+ *
+ * Not idle return register usage:
+ * a0	OPTEE_SMC_RETURN_EBUSY
+ * a1-7	Preserved
+ */
+#define OPTEE_SMC_FUNCID_DISABLE_SHM_CACHE	10
+#define OPTEE_SMC_DISABLE_SHM_CACHE \
+	OPTEE_SMC_FAST_CALL_VAL(OPTEE_SMC_FUNCID_DISABLE_SHM_CACHE)
+
+struct optee_smc_disable_shm_cache_result {
+	unsigned long status;
+	unsigned long shm_upper32;
+	unsigned long shm_lower32;
+	unsigned long reserved0;
+};
+
+/*
+ * Enable cache of shared memory objects
+ *
+ * Secure world can cache frequently used shared memory objects, for
+ * example objects used as RPC arguments. When secure world is idle this
+ * function returns OPTEE_SMC_RETURN_OK and the cache is enabled. If
+ * secure world isn't idle OPTEE_SMC_RETURN_EBUSY is returned.
+ *
+ * Call register usage:
+ * a0	SMC Function ID, OPTEE_SMC_ENABLE_SHM_CACHE
+ * a1-6	Not used
+ * a7	Hypervisor Client ID register
+ *
+ * Normal return register usage:
+ * a0	OPTEE_SMC_RETURN_OK
+ * a1-7	Preserved
+ *
+ * Not idle return register usage:
+ * a0	OPTEE_SMC_RETURN_EBUSY
+ * a1-7	Preserved
+ */
+#define OPTEE_SMC_FUNCID_ENABLE_SHM_CACHE	11
+#define OPTEE_SMC_ENABLE_SHM_CACHE \
+	OPTEE_SMC_FAST_CALL_VAL(OPTEE_SMC_FUNCID_ENABLE_SHM_CACHE)
+
+/*
+ * Resume from RPC (for example after processing a foreign interrupt)
+ *
+ * Call register usage:
+ * a0	SMC Function ID, OPTEE_SMC_CALL_RETURN_FROM_RPC
+ * a1-3	Value of a1-3 when OPTEE_SMC_CALL_WITH_ARG returned
+ *	OPTEE_SMC_RETURN_RPC in a0
+ *
+ * Return register usage is the same as for OPTEE_SMC_*CALL_WITH_ARG above.
+ *
+ * Possible return values
+ * OPTEE_SMC_RETURN_UNKNOWN_FUNCTION	Trusted OS does not recognize this
+ *					function.
+ * OPTEE_SMC_RETURN_OK			Original call completed, result
+ *					updated in the previously supplied.
+ *					struct optee_msg_arg
+ * OPTEE_SMC_RETURN_RPC			Call suspended by RPC call to normal
+ *					world.
+ * OPTEE_SMC_RETURN_ERESUME		Resume failed, the opaque resume
+ *					information was corrupt.
+ */
+#define OPTEE_SMC_FUNCID_RETURN_FROM_RPC	3
+#define OPTEE_SMC_CALL_RETURN_FROM_RPC \
+	OPTEE_SMC_STD_CALL_VAL(OPTEE_SMC_FUNCID_RETURN_FROM_RPC)
+
+#define OPTEE_SMC_RETURN_RPC_PREFIX_MASK	0xFFFF0000
+#define OPTEE_SMC_RETURN_RPC_PREFIX		0xFFFF0000
+#define OPTEE_SMC_RETURN_RPC_FUNC_MASK		0x0000FFFF
+
+#define OPTEE_SMC_RETURN_GET_RPC_FUNC(ret) \
+	((ret) & OPTEE_SMC_RETURN_RPC_FUNC_MASK)
+
+#define OPTEE_SMC_RPC_VAL(func)		((func) | OPTEE_SMC_RETURN_RPC_PREFIX)
+
+/*
+ * Allocate memory for RPC parameter passing. The memory is used to hold a
+ * struct optee_msg_arg.
+ *
+ * "Call" register usage:
+ * a0	This value, OPTEE_SMC_RETURN_RPC_ALLOC
+ * a1	Size in bytes of required argument memory
+ * a2	Not used
+ * a3	Resume information, must be preserved
+ * a4-5	Not used
+ * a6-7	Resume information, must be preserved
+ *
+ * "Return" register usage:
+ * a0	SMC Function ID, OPTEE_SMC_CALL_RETURN_FROM_RPC.
+ * a1	Upper 32bits of 64bit physical pointer to allocated
+ *	memory, (a1 == 0 && a2 == 0) if size was 0 or if memory can't
+ *	be allocated.
+ * a2	Lower 32bits of 64bit physical pointer to allocated
+ *	memory, (a1 == 0 && a2 == 0) if size was 0 or if memory can't
+ *	be allocated
+ * a3	Preserved
+ * a4	Upper 32bits of 64bit Shared memory cookie used when freeing
+ *	the memory or doing an RPC
+ * a5	Lower 32bits of 64bit Shared memory cookie used when freeing
+ *	the memory or doing an RPC
+ * a6-7	Preserved
+ */
+#define OPTEE_SMC_RPC_FUNC_ALLOC	0
+#define OPTEE_SMC_RETURN_RPC_ALLOC \
+	OPTEE_SMC_RPC_VAL(OPTEE_SMC_RPC_FUNC_ALLOC)
+
+/*
+ * Free memory previously allocated by OPTEE_SMC_RETURN_RPC_ALLOC
+ *
+ * "Call" register usage:
+ * a0	This value, OPTEE_SMC_RETURN_RPC_FREE
+ * a1	Upper 32bits of 64bit shared memory cookie belonging to this
+ *	argument memory
+ * a2	Lower 32bits of 64bit shared memory cookie belonging to this
+ *	argument memory
+ * a3-7	Resume information, must be preserved
+ *
+ * "Return" register usage:
+ * a0	SMC Function ID, OPTEE_SMC_CALL_RETURN_FROM_RPC.
+ * a1-2	Not used
+ * a3-7	Preserved
+ */
+#define OPTEE_SMC_RPC_FUNC_FREE		2
+#define OPTEE_SMC_RETURN_RPC_FREE \
+	OPTEE_SMC_RPC_VAL(OPTEE_SMC_RPC_FUNC_FREE)
+
+/*
+ * Deliver foreign interrupt to normal world.
+ *
+ * "Call" register usage:
+ * a0	OPTEE_SMC_RETURN_RPC_FOREIGN_INTR
+ * a1-7	Resume information, must be preserved
+ *
+ * "Return" register usage:
+ * a0	SMC Function ID, OPTEE_SMC_CALL_RETURN_FROM_RPC.
+ * a1-7	Preserved
+ */
+#define OPTEE_SMC_RPC_FUNC_FOREIGN_INTR		4
+#define OPTEE_SMC_RETURN_RPC_FOREIGN_INTR \
+	OPTEE_SMC_RPC_VAL(OPTEE_SMC_RPC_FUNC_FOREIGN_INTR)
+
+/*
+ * Do an RPC request. The supplied struct optee_msg_arg tells which
+ * request to do and the parameters for the request. The following fields
+ * are used (the rest are unused):
+ * - cmd		the Request ID
+ * - ret		return value of the request, filled in by normal world
+ * - num_params		number of parameters for the request
+ * - params		the parameters
+ * - param_attrs	attributes of the parameters
+ *
+ * "Call" register usage:
+ * a0	OPTEE_SMC_RETURN_RPC_CMD
+ * a1	Upper 32bit of a 64bit Shared memory cookie holding a
+ *	struct optee_msg_arg, must be preserved, only the data should
+ *	be updated
+ * a2	Lower 32bit of a 64bit Shared memory cookie holding a
+ *	struct optee_msg_arg, must be preserved, only the data should
+ *	be updated
+ * a3-7	Resume information, must be preserved
+ *
+ * "Return" register usage:
+ * a0	SMC Function ID, OPTEE_SMC_CALL_RETURN_FROM_RPC.
+ * a1-2	Not used
+ * a3-7	Preserved
+ */
+#define OPTEE_SMC_RPC_FUNC_CMD		5
+#define OPTEE_SMC_RETURN_RPC_CMD \
+	OPTEE_SMC_RPC_VAL(OPTEE_SMC_RPC_FUNC_CMD)
+
+/* Returned in a0 */
+#define OPTEE_SMC_RETURN_UNKNOWN_FUNCTION 0xFFFFFFFF
+
+/* Returned in a0 only from Trusted OS functions */
+#define OPTEE_SMC_RETURN_OK		0x0
+#define OPTEE_SMC_RETURN_ETHREAD_LIMIT	0x1
+#define OPTEE_SMC_RETURN_EBUSY		0x2
+#define OPTEE_SMC_RETURN_ERESUME	0x3
+#define OPTEE_SMC_RETURN_EBADADDR	0x4
+#define OPTEE_SMC_RETURN_EBADCMD	0x5
+#define OPTEE_SMC_RETURN_ENOMEM		0x6
+#define OPTEE_SMC_RETURN_ENOTAVAIL	0x7
+#define OPTEE_SMC_RETURN_IS_RPC(ret)	__optee_smc_return_is_rpc((ret))
+
+static inline bool __optee_smc_return_is_rpc(u32 ret)
+{
+	return ret != OPTEE_SMC_RETURN_UNKNOWN_FUNCTION &&
+	       (ret & OPTEE_SMC_RETURN_RPC_PREFIX_MASK) ==
+			OPTEE_SMC_RETURN_RPC_PREFIX;
+}
+
+#endif /* OPTEE_SMC_H */
diff --git a/drivers/tee/optee/rpc.c b/drivers/tee/optee/rpc.c
new file mode 100644
index 00000000..41aea12
--- /dev/null
+++ b/drivers/tee/optee/rpc.c
@@ -0,0 +1,452 @@
+/*
+ * Copyright (c) 2015-2016, Linaro Limited
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#define pr_fmt(fmt) KBUILD_MODNAME ": " fmt
+
+#include <linux/delay.h>
+#include <linux/device.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include "optee_private.h"
+#include "optee_smc.h"
+
+struct wq_entry {
+	struct list_head link;
+	struct completion c;
+	u32 key;
+};
+
+void optee_wait_queue_init(struct optee_wait_queue *priv)
+{
+	mutex_init(&priv->mu);
+	INIT_LIST_HEAD(&priv->db);
+}
+
+void optee_wait_queue_exit(struct optee_wait_queue *priv)
+{
+	mutex_destroy(&priv->mu);
+}
+
+static void handle_rpc_func_cmd_get_time(struct optee_msg_arg *arg)
+{
+	struct timespec64 ts;
+
+	if (arg->num_params != 1)
+		goto bad;
+	if ((arg->params[0].attr & OPTEE_MSG_ATTR_TYPE_MASK) !=
+			OPTEE_MSG_ATTR_TYPE_VALUE_OUTPUT)
+		goto bad;
+
+	getnstimeofday64(&ts);
+	arg->params[0].u.value.a = ts.tv_sec;
+	arg->params[0].u.value.b = ts.tv_nsec;
+
+	arg->ret = TEEC_SUCCESS;
+	return;
+bad:
+	arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+}
+
+static struct wq_entry *wq_entry_get(struct optee_wait_queue *wq, u32 key)
+{
+	struct wq_entry *w;
+
+	mutex_lock(&wq->mu);
+
+	list_for_each_entry(w, &wq->db, link)
+		if (w->key == key)
+			goto out;
+
+	w = kmalloc(sizeof(*w), GFP_KERNEL);
+	if (w) {
+		init_completion(&w->c);
+		w->key = key;
+		list_add_tail(&w->link, &wq->db);
+	}
+out:
+	mutex_unlock(&wq->mu);
+	return w;
+}
+
+static void wq_sleep(struct optee_wait_queue *wq, u32 key)
+{
+	struct wq_entry *w = wq_entry_get(wq, key);
+
+	if (w) {
+		wait_for_completion(&w->c);
+		mutex_lock(&wq->mu);
+		list_del(&w->link);
+		mutex_unlock(&wq->mu);
+		kfree(w);
+	}
+}
+
+static void wq_wakeup(struct optee_wait_queue *wq, u32 key)
+{
+	struct wq_entry *w = wq_entry_get(wq, key);
+
+	if (w)
+		complete(&w->c);
+}
+
+static void handle_rpc_func_cmd_wq(struct optee *optee,
+				   struct optee_msg_arg *arg)
+{
+	if (arg->num_params != 1)
+		goto bad;
+
+	if ((arg->params[0].attr & OPTEE_MSG_ATTR_TYPE_MASK) !=
+			OPTEE_MSG_ATTR_TYPE_VALUE_INPUT)
+		goto bad;
+
+	switch (arg->params[0].u.value.a) {
+	case OPTEE_MSG_RPC_WAIT_QUEUE_SLEEP:
+		wq_sleep(&optee->wait_queue, arg->params[0].u.value.b);
+		break;
+	case OPTEE_MSG_RPC_WAIT_QUEUE_WAKEUP:
+		wq_wakeup(&optee->wait_queue, arg->params[0].u.value.b);
+		break;
+	default:
+		goto bad;
+	}
+
+	arg->ret = TEEC_SUCCESS;
+	return;
+bad:
+	arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+}
+
+static void handle_rpc_func_cmd_wait(struct optee_msg_arg *arg)
+{
+	u32 msec_to_wait;
+
+	if (arg->num_params != 1)
+		goto bad;
+
+	if ((arg->params[0].attr & OPTEE_MSG_ATTR_TYPE_MASK) !=
+			OPTEE_MSG_ATTR_TYPE_VALUE_INPUT)
+		goto bad;
+
+	msec_to_wait = arg->params[0].u.value.a;
+
+	/* Go to interruptible sleep */
+	msleep_interruptible(msec_to_wait);
+
+	arg->ret = TEEC_SUCCESS;
+	return;
+bad:
+	arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+}
+
+static void handle_rpc_supp_cmd(struct tee_context *ctx,
+				struct optee_msg_arg *arg)
+{
+	struct tee_param *params;
+
+	arg->ret_origin = TEEC_ORIGIN_COMMS;
+
+	params = kmalloc_array(arg->num_params, sizeof(struct tee_param),
+			       GFP_KERNEL);
+	if (!params) {
+		arg->ret = TEEC_ERROR_OUT_OF_MEMORY;
+		return;
+	}
+
+	if (optee_from_msg_param(params, arg->num_params, arg->params)) {
+		arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+		goto out;
+	}
+
+	arg->ret = optee_supp_thrd_req(ctx, arg->cmd, arg->num_params, params);
+
+	if (optee_to_msg_param(arg->params, arg->num_params, params))
+		arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+out:
+	kfree(params);
+}
+
+static struct tee_shm *cmd_alloc_suppl(struct tee_context *ctx, size_t sz)
+{
+	u32 ret;
+	struct tee_param param;
+	struct optee *optee = tee_get_drvdata(ctx->teedev);
+	struct tee_shm *shm;
+
+	param.attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	param.u.value.a = OPTEE_MSG_RPC_SHM_TYPE_APPL;
+	param.u.value.b = sz;
+	param.u.value.c = 0;
+
+	ret = optee_supp_thrd_req(ctx, OPTEE_MSG_RPC_CMD_SHM_ALLOC, 1, &param);
+	if (ret)
+		return ERR_PTR(-ENOMEM);
+
+	mutex_lock(&optee->supp.mutex);
+	/* Increases count as secure world doesn't have a reference */
+	shm = tee_shm_get_from_id(optee->supp.ctx, param.u.value.c);
+	mutex_unlock(&optee->supp.mutex);
+	return shm;
+}
+
+static void handle_rpc_func_cmd_shm_alloc(struct tee_context *ctx,
+					  struct optee_msg_arg *arg,
+					  struct optee_call_ctx *call_ctx)
+{
+	phys_addr_t pa;
+	struct tee_shm *shm;
+	size_t sz;
+	size_t n;
+
+	arg->ret_origin = TEEC_ORIGIN_COMMS;
+
+	if (!arg->num_params ||
+	    arg->params[0].attr != OPTEE_MSG_ATTR_TYPE_VALUE_INPUT) {
+		arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+		return;
+	}
+
+	for (n = 1; n < arg->num_params; n++) {
+		if (arg->params[n].attr != OPTEE_MSG_ATTR_TYPE_NONE) {
+			arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+			return;
+		}
+	}
+
+	sz = arg->params[0].u.value.b;
+	switch (arg->params[0].u.value.a) {
+	case OPTEE_MSG_RPC_SHM_TYPE_APPL:
+		shm = cmd_alloc_suppl(ctx, sz);
+		break;
+	case OPTEE_MSG_RPC_SHM_TYPE_KERNEL:
+		shm = tee_shm_alloc(ctx, sz, TEE_SHM_MAPPED);
+		break;
+	default:
+		arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+		return;
+	}
+
+	if (IS_ERR(shm)) {
+		arg->ret = TEEC_ERROR_OUT_OF_MEMORY;
+		return;
+	}
+
+	if (tee_shm_get_pa(shm, 0, &pa)) {
+		arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+		goto bad;
+	}
+
+	sz = tee_shm_get_size(shm);
+
+	if (tee_shm_is_registered(shm)) {
+		struct page **pages;
+		u64 *pages_list;
+		size_t page_num;
+
+		pages = tee_shm_get_pages(shm, &page_num);
+		if (!pages || !page_num) {
+			arg->ret = TEEC_ERROR_OUT_OF_MEMORY;
+			goto bad;
+		}
+
+		pages_list = optee_allocate_pages_list(page_num);
+		if (!pages_list) {
+			arg->ret = TEEC_ERROR_OUT_OF_MEMORY;
+			goto bad;
+		}
+
+		call_ctx->pages_list = pages_list;
+		call_ctx->num_entries = page_num;
+
+		arg->params[0].attr = OPTEE_MSG_ATTR_TYPE_TMEM_OUTPUT |
+				      OPTEE_MSG_ATTR_NONCONTIG;
+		/*
+		 * In the least bits of u.tmem.buf_ptr we store buffer offset
+		 * from 4k page, as described in OP-TEE ABI.
+		 */
+		arg->params[0].u.tmem.buf_ptr = virt_to_phys(pages_list) |
+			(tee_shm_get_page_offset(shm) &
+			 (OPTEE_MSG_NONCONTIG_PAGE_SIZE - 1));
+		arg->params[0].u.tmem.size = tee_shm_get_size(shm);
+		arg->params[0].u.tmem.shm_ref = (unsigned long)shm;
+
+		optee_fill_pages_list(pages_list, pages, page_num,
+				      tee_shm_get_page_offset(shm));
+	} else {
+		arg->params[0].attr = OPTEE_MSG_ATTR_TYPE_TMEM_OUTPUT;
+		arg->params[0].u.tmem.buf_ptr = pa;
+		arg->params[0].u.tmem.size = sz;
+		arg->params[0].u.tmem.shm_ref = (unsigned long)shm;
+	}
+
+	arg->ret = TEEC_SUCCESS;
+	return;
+bad:
+	tee_shm_free(shm);
+}
+
+static void cmd_free_suppl(struct tee_context *ctx, struct tee_shm *shm)
+{
+	struct tee_param param;
+
+	param.attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	param.u.value.a = OPTEE_MSG_RPC_SHM_TYPE_APPL;
+	param.u.value.b = tee_shm_get_id(shm);
+	param.u.value.c = 0;
+
+	/*
+	 * Match the tee_shm_get_from_id() in cmd_alloc_suppl() as secure
+	 * world has released its reference.
+	 *
+	 * It's better to do this before sending the request to supplicant
+	 * as we'd like to let the process doing the initial allocation to
+	 * do release the last reference too in order to avoid stacking
+	 * many pending fput() on the client process. This could otherwise
+	 * happen if secure world does many allocate and free in a single
+	 * invoke.
+	 */
+	tee_shm_put(shm);
+
+	optee_supp_thrd_req(ctx, OPTEE_MSG_RPC_CMD_SHM_FREE, 1, &param);
+}
+
+static void handle_rpc_func_cmd_shm_free(struct tee_context *ctx,
+					 struct optee_msg_arg *arg)
+{
+	struct tee_shm *shm;
+
+	arg->ret_origin = TEEC_ORIGIN_COMMS;
+
+	if (arg->num_params != 1 ||
+	    arg->params[0].attr != OPTEE_MSG_ATTR_TYPE_VALUE_INPUT) {
+		arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+		return;
+	}
+
+	shm = (struct tee_shm *)(unsigned long)arg->params[0].u.value.b;
+	switch (arg->params[0].u.value.a) {
+	case OPTEE_MSG_RPC_SHM_TYPE_APPL:
+		cmd_free_suppl(ctx, shm);
+		break;
+	case OPTEE_MSG_RPC_SHM_TYPE_KERNEL:
+		tee_shm_free(shm);
+		break;
+	default:
+		arg->ret = TEEC_ERROR_BAD_PARAMETERS;
+	}
+	arg->ret = TEEC_SUCCESS;
+}
+
+static void free_pages_list(struct optee_call_ctx *call_ctx)
+{
+	if (call_ctx->pages_list) {
+		optee_free_pages_list(call_ctx->pages_list,
+				      call_ctx->num_entries);
+		call_ctx->pages_list = NULL;
+		call_ctx->num_entries = 0;
+	}
+}
+
+void optee_rpc_finalize_call(struct optee_call_ctx *call_ctx)
+{
+	free_pages_list(call_ctx);
+}
+
+static void handle_rpc_func_cmd(struct tee_context *ctx, struct optee *optee,
+				struct tee_shm *shm,
+				struct optee_call_ctx *call_ctx)
+{
+	struct optee_msg_arg *arg;
+
+	arg = tee_shm_get_va(shm, 0);
+	if (IS_ERR(arg)) {
+		pr_err("%s: tee_shm_get_va %p failed\n", __func__, shm);
+		return;
+	}
+
+	switch (arg->cmd) {
+	case OPTEE_MSG_RPC_CMD_GET_TIME:
+		handle_rpc_func_cmd_get_time(arg);
+		break;
+	case OPTEE_MSG_RPC_CMD_WAIT_QUEUE:
+		handle_rpc_func_cmd_wq(optee, arg);
+		break;
+	case OPTEE_MSG_RPC_CMD_SUSPEND:
+		handle_rpc_func_cmd_wait(arg);
+		break;
+	case OPTEE_MSG_RPC_CMD_SHM_ALLOC:
+		free_pages_list(call_ctx);
+		handle_rpc_func_cmd_shm_alloc(ctx, arg, call_ctx);
+		break;
+	case OPTEE_MSG_RPC_CMD_SHM_FREE:
+		handle_rpc_func_cmd_shm_free(ctx, arg);
+		break;
+	default:
+		handle_rpc_supp_cmd(ctx, arg);
+	}
+}
+
+/**
+ * optee_handle_rpc() - handle RPC from secure world
+ * @ctx:	context doing the RPC
+ * @param:	value of registers for the RPC
+ * @call_ctx:	call context. Preserved during one OP-TEE invocation
+ *
+ * Result of RPC is written back into @param.
+ */
+void optee_handle_rpc(struct tee_context *ctx, struct optee_rpc_param *param,
+		      struct optee_call_ctx *call_ctx)
+{
+	struct tee_device *teedev = ctx->teedev;
+	struct optee *optee = tee_get_drvdata(teedev);
+	struct tee_shm *shm;
+	phys_addr_t pa;
+
+	switch (OPTEE_SMC_RETURN_GET_RPC_FUNC(param->a0)) {
+	case OPTEE_SMC_RPC_FUNC_ALLOC:
+		shm = tee_shm_alloc(ctx, param->a1, TEE_SHM_MAPPED);
+		if (!IS_ERR(shm) && !tee_shm_get_pa(shm, 0, &pa)) {
+			reg_pair_from_64(&param->a1, &param->a2, pa);
+			reg_pair_from_64(&param->a4, &param->a5,
+					 (unsigned long)shm);
+		} else {
+			param->a1 = 0;
+			param->a2 = 0;
+			param->a4 = 0;
+			param->a5 = 0;
+		}
+		break;
+	case OPTEE_SMC_RPC_FUNC_FREE:
+		shm = reg_pair_to_ptr(param->a1, param->a2);
+		tee_shm_free(shm);
+		break;
+	case OPTEE_SMC_RPC_FUNC_FOREIGN_INTR:
+		/*
+		 * A foreign interrupt was raised while secure world was
+		 * executing, since they are handled in Linux a dummy RPC is
+		 * performed to let Linux take the interrupt through the normal
+		 * vector.
+		 */
+		break;
+	case OPTEE_SMC_RPC_FUNC_CMD:
+		shm = reg_pair_to_ptr(param->a1, param->a2);
+		handle_rpc_func_cmd(ctx, optee, shm, call_ctx);
+		break;
+	default:
+		pr_warn("Unknown RPC func 0x%x\n",
+			(u32)OPTEE_SMC_RETURN_GET_RPC_FUNC(param->a0));
+		break;
+	}
+
+	param->a0 = OPTEE_SMC_CALL_RETURN_FROM_RPC;
+}
diff --git a/drivers/tee/optee/shm_pool.c b/drivers/tee/optee/shm_pool.c
new file mode 100644
index 00000000..4939781
--- /dev/null
+++ b/drivers/tee/optee/shm_pool.c
@@ -0,0 +1,75 @@
+/*
+ * Copyright (c) 2015, Linaro Limited
+ * Copyright (c) 2017, EPAM Systems
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+#include <linux/device.h>
+#include <linux/dma-buf.h>
+#include <linux/genalloc.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include "optee_private.h"
+#include "optee_smc.h"
+#include "shm_pool.h"
+
+static int pool_op_alloc(struct tee_shm_pool_mgr *poolm,
+			 struct tee_shm *shm, size_t size)
+{
+	unsigned int order = get_order(size);
+	struct page *page;
+
+	page = alloc_pages(GFP_KERNEL | __GFP_ZERO, order);
+	if (!page)
+		return -ENOMEM;
+
+	shm->kaddr = page_address(page);
+	shm->paddr = page_to_phys(page);
+	shm->size = PAGE_SIZE << order;
+
+	return 0;
+}
+
+static void pool_op_free(struct tee_shm_pool_mgr *poolm,
+			 struct tee_shm *shm)
+{
+	free_pages((unsigned long)shm->kaddr, get_order(shm->size));
+	shm->kaddr = NULL;
+}
+
+static void pool_op_destroy_poolmgr(struct tee_shm_pool_mgr *poolm)
+{
+	kfree(poolm);
+}
+
+static const struct tee_shm_pool_mgr_ops pool_ops = {
+	.alloc = pool_op_alloc,
+	.free = pool_op_free,
+	.destroy_poolmgr = pool_op_destroy_poolmgr,
+};
+
+/**
+ * optee_shm_pool_alloc_pages() - create page-based allocator pool
+ *
+ * This pool is used when OP-TEE supports dymanic SHM. In this case
+ * command buffers and such are allocated from kernel's own memory.
+ */
+struct tee_shm_pool_mgr *optee_shm_pool_alloc_pages(void)
+{
+	struct tee_shm_pool_mgr *mgr = kzalloc(sizeof(*mgr), GFP_KERNEL);
+
+	if (!mgr)
+		return ERR_PTR(-ENOMEM);
+
+	mgr->ops = &pool_ops;
+
+	return mgr;
+}
diff --git a/drivers/tee/optee/shm_pool.h b/drivers/tee/optee/shm_pool.h
new file mode 100644
index 00000000..4e753c3
--- /dev/null
+++ b/drivers/tee/optee/shm_pool.h
@@ -0,0 +1,23 @@
+/*
+ * Copyright (c) 2015, Linaro Limited
+ * Copyright (c) 2016, EPAM Systems
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef SHM_POOL_H
+#define SHM_POOL_H
+
+#include <linux/tee_drv.h>
+
+struct tee_shm_pool_mgr *optee_shm_pool_alloc_pages(void);
+
+#endif
diff --git a/drivers/tee/optee/supp.c b/drivers/tee/optee/supp.c
new file mode 100644
index 00000000..df35fc0
--- /dev/null
+++ b/drivers/tee/optee/supp.c
@@ -0,0 +1,382 @@
+/*
+ * Copyright (c) 2015, Linaro Limited
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+#include <linux/device.h>
+#include <linux/slab.h>
+#include <linux/uaccess.h>
+#include "optee_private.h"
+
+struct optee_supp_req {
+	struct list_head link;
+
+	bool busy;
+	u32 func;
+	u32 ret;
+	size_t num_params;
+	struct tee_param *param;
+
+	struct completion c;
+};
+
+void optee_supp_init(struct optee_supp *supp)
+{
+	memset(supp, 0, sizeof(*supp));
+	mutex_init(&supp->mutex);
+	init_completion(&supp->reqs_c);
+	idr_init(&supp->idr);
+	INIT_LIST_HEAD(&supp->reqs);
+	supp->req_id = -1;
+}
+
+void optee_supp_uninit(struct optee_supp *supp)
+{
+	mutex_destroy(&supp->mutex);
+	idr_destroy(&supp->idr);
+}
+
+void optee_supp_release(struct optee_supp *supp)
+{
+	int id;
+	struct optee_supp_req *req;
+	struct optee_supp_req *req_tmp;
+
+	mutex_lock(&supp->mutex);
+
+	/* Abort all request retrieved by supplicant */
+	idr_for_each_entry(&supp->idr, req, id) {
+		req->busy = false;
+		idr_remove(&supp->idr, id);
+		req->ret = TEEC_ERROR_COMMUNICATION;
+		complete(&req->c);
+	}
+
+	/* Abort all queued requests */
+	list_for_each_entry_safe(req, req_tmp, &supp->reqs, link) {
+		list_del(&req->link);
+		req->ret = TEEC_ERROR_COMMUNICATION;
+		complete(&req->c);
+	}
+
+	supp->ctx = NULL;
+	supp->req_id = -1;
+
+	mutex_unlock(&supp->mutex);
+}
+
+/**
+ * optee_supp_thrd_req() - request service from supplicant
+ * @ctx:	context doing the request
+ * @func:	function requested
+ * @num_params:	number of elements in @param array
+ * @param:	parameters for function
+ *
+ * Returns result of operation to be passed to secure world
+ */
+u32 optee_supp_thrd_req(struct tee_context *ctx, u32 func, size_t num_params,
+			struct tee_param *param)
+
+{
+	struct optee *optee = tee_get_drvdata(ctx->teedev);
+	struct optee_supp *supp = &optee->supp;
+	struct optee_supp_req *req = kzalloc(sizeof(*req), GFP_KERNEL);
+	bool interruptable;
+	u32 ret;
+
+	if (!req)
+		return TEEC_ERROR_OUT_OF_MEMORY;
+
+	init_completion(&req->c);
+	req->func = func;
+	req->num_params = num_params;
+	req->param = param;
+
+	/* Insert the request in the request list */
+	mutex_lock(&supp->mutex);
+	list_add_tail(&req->link, &supp->reqs);
+	mutex_unlock(&supp->mutex);
+
+	/* Tell an eventual waiter there's a new request */
+	complete(&supp->reqs_c);
+
+	/*
+	 * Wait for supplicant to process and return result, once we've
+	 * returned from wait_for_completion(&req->c) successfully we have
+	 * exclusive access again.
+	 */
+	while (wait_for_completion_interruptible(&req->c)) {
+		mutex_lock(&supp->mutex);
+		interruptable = !supp->ctx;
+		if (interruptable) {
+			/*
+			 * There's no supplicant available and since the
+			 * supp->mutex currently is held none can
+			 * become available until the mutex released
+			 * again.
+			 *
+			 * Interrupting an RPC to supplicant is only
+			 * allowed as a way of slightly improving the user
+			 * experience in case the supplicant hasn't been
+			 * started yet. During normal operation the supplicant
+			 * will serve all requests in a timely manner and
+			 * interrupting then wouldn't make sense.
+			 */
+			interruptable = !req->busy;
+			if (!req->busy)
+				list_del(&req->link);
+		}
+		mutex_unlock(&supp->mutex);
+
+		if (interruptable) {
+			req->ret = TEEC_ERROR_COMMUNICATION;
+			break;
+		}
+	}
+
+	ret = req->ret;
+	kfree(req);
+
+	return ret;
+}
+
+static struct optee_supp_req  *supp_pop_entry(struct optee_supp *supp,
+					      int num_params, int *id)
+{
+	struct optee_supp_req *req;
+
+	if (supp->req_id != -1) {
+		/*
+		 * Supplicant should not mix synchronous and asnynchronous
+		 * requests.
+		 */
+		return ERR_PTR(-EINVAL);
+	}
+
+	if (list_empty(&supp->reqs))
+		return NULL;
+
+	req = list_first_entry(&supp->reqs, struct optee_supp_req, link);
+
+	if (num_params < req->num_params) {
+		/* Not enough room for parameters */
+		return ERR_PTR(-EINVAL);
+	}
+
+	*id = idr_alloc(&supp->idr, req, 1, 0, GFP_KERNEL);
+	if (*id < 0)
+		return ERR_PTR(-ENOMEM);
+
+	list_del(&req->link);
+	req->busy = true;
+
+	return req;
+}
+
+static int supp_check_recv_params(size_t num_params, struct tee_param *params,
+				  size_t *num_meta)
+{
+	size_t n;
+
+	if (!num_params)
+		return -EINVAL;
+
+	/*
+	 * If there's memrefs we need to decrease those as they where
+	 * increased earlier and we'll even refuse to accept any below.
+	 */
+	for (n = 0; n < num_params; n++)
+		if (tee_param_is_memref(params + n) && params[n].u.memref.shm)
+			tee_shm_put(params[n].u.memref.shm);
+
+	/*
+	 * We only expect parameters as TEE_IOCTL_PARAM_ATTR_TYPE_NONE with
+	 * or without the TEE_IOCTL_PARAM_ATTR_META bit set.
+	 */
+	for (n = 0; n < num_params; n++)
+		if (params[n].attr &&
+		    params[n].attr != TEE_IOCTL_PARAM_ATTR_META)
+			return -EINVAL;
+
+	/* At most we'll need one meta parameter so no need to check for more */
+	if (params->attr == TEE_IOCTL_PARAM_ATTR_META)
+		*num_meta = 1;
+	else
+		*num_meta = 0;
+
+	return 0;
+}
+
+/**
+ * optee_supp_recv() - receive request for supplicant
+ * @ctx:	context receiving the request
+ * @func:	requested function in supplicant
+ * @num_params:	number of elements allocated in @param, updated with number
+ *		used elements
+ * @param:	space for parameters for @func
+ *
+ * Returns 0 on success or <0 on failure
+ */
+int optee_supp_recv(struct tee_context *ctx, u32 *func, u32 *num_params,
+		    struct tee_param *param)
+{
+	struct tee_device *teedev = ctx->teedev;
+	struct optee *optee = tee_get_drvdata(teedev);
+	struct optee_supp *supp = &optee->supp;
+	struct optee_supp_req *req = NULL;
+	int id;
+	size_t num_meta;
+	int rc;
+
+	rc = supp_check_recv_params(*num_params, param, &num_meta);
+	if (rc)
+		return rc;
+
+	while (true) {
+		mutex_lock(&supp->mutex);
+		req = supp_pop_entry(supp, *num_params - num_meta, &id);
+		mutex_unlock(&supp->mutex);
+
+		if (req) {
+			if (IS_ERR(req))
+				return PTR_ERR(req);
+			break;
+		}
+
+		/*
+		 * If we didn't get a request we'll block in
+		 * wait_for_completion() to avoid needless spinning.
+		 *
+		 * This is where supplicant will be hanging most of
+		 * the time, let's make this interruptable so we
+		 * can easily restart supplicant if needed.
+		 */
+		if (wait_for_completion_interruptible(&supp->reqs_c))
+			return -ERESTARTSYS;
+	}
+
+	if (num_meta) {
+		/*
+		 * tee-supplicant support meta parameters -> requsts can be
+		 * processed asynchronously.
+		 */
+		param->attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT |
+			      TEE_IOCTL_PARAM_ATTR_META;
+		param->u.value.a = id;
+		param->u.value.b = 0;
+		param->u.value.c = 0;
+	} else {
+		mutex_lock(&supp->mutex);
+		supp->req_id = id;
+		mutex_unlock(&supp->mutex);
+	}
+
+	*func = req->func;
+	*num_params = req->num_params + num_meta;
+	memcpy(param + num_meta, req->param,
+	       sizeof(struct tee_param) * req->num_params);
+
+	return 0;
+}
+
+static struct optee_supp_req *supp_pop_req(struct optee_supp *supp,
+					   size_t num_params,
+					   struct tee_param *param,
+					   size_t *num_meta)
+{
+	struct optee_supp_req *req;
+	int id;
+	size_t nm;
+	const u32 attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT |
+			 TEE_IOCTL_PARAM_ATTR_META;
+
+	if (!num_params)
+		return ERR_PTR(-EINVAL);
+
+	if (supp->req_id == -1) {
+		if (param->attr != attr)
+			return ERR_PTR(-EINVAL);
+		id = param->u.value.a;
+		nm = 1;
+	} else {
+		id = supp->req_id;
+		nm = 0;
+	}
+
+	req = idr_find(&supp->idr, id);
+	if (!req)
+		return ERR_PTR(-ENOENT);
+
+	if ((num_params - nm) != req->num_params)
+		return ERR_PTR(-EINVAL);
+
+	req->busy = false;
+	idr_remove(&supp->idr, id);
+	supp->req_id = -1;
+	*num_meta = nm;
+
+	return req;
+}
+
+/**
+ * optee_supp_send() - send result of request from supplicant
+ * @ctx:	context sending result
+ * @ret:	return value of request
+ * @num_params:	number of parameters returned
+ * @param:	returned parameters
+ *
+ * Returns 0 on success or <0 on failure.
+ */
+int optee_supp_send(struct tee_context *ctx, u32 ret, u32 num_params,
+		    struct tee_param *param)
+{
+	struct tee_device *teedev = ctx->teedev;
+	struct optee *optee = tee_get_drvdata(teedev);
+	struct optee_supp *supp = &optee->supp;
+	struct optee_supp_req *req;
+	size_t n;
+	size_t num_meta;
+
+	mutex_lock(&supp->mutex);
+	req = supp_pop_req(supp, num_params, param, &num_meta);
+	mutex_unlock(&supp->mutex);
+
+	if (IS_ERR(req)) {
+		/* Something is wrong, let supplicant restart. */
+		return PTR_ERR(req);
+	}
+
+	/* Update out and in/out parameters */
+	for (n = 0; n < req->num_params; n++) {
+		struct tee_param *p = req->param + n;
+
+		switch (p->attr & TEE_IOCTL_PARAM_ATTR_TYPE_MASK) {
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_OUTPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT:
+			p->u.value.a = param[n + num_meta].u.value.a;
+			p->u.value.b = param[n + num_meta].u.value.b;
+			p->u.value.c = param[n + num_meta].u.value.c;
+			break;
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_OUTPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT:
+			p->u.memref.size = param[n + num_meta].u.memref.size;
+			break;
+		default:
+			break;
+		}
+	}
+	req->ret = ret;
+
+	/* Let the requesting thread continue */
+	complete(&req->c);
+
+	return 0;
+}
diff --git a/drivers/tee/tee_client_api.h b/drivers/tee/tee_client_api.h
new file mode 100644
index 00000000..591bf26
--- /dev/null
+++ b/drivers/tee/tee_client_api.h
@@ -0,0 +1,530 @@
+/*
+ * Copyright (c) 2014, STMicroelectronics International N.V.
+ * All rights reserved.
+ * Copyright (c) 2015, Linaro Limited
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright notice,
+ * this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+#ifndef TEE_CLIENT_API_H
+#define TEE_CLIENT_API_H
+
+//#include <stdint.h>
+//#include <stddef.h>
+
+/*
+ * Defines the number of available memory references in an open session or
+ * invoke command operation payload.
+ */
+#define TEEC_CONFIG_PAYLOAD_REF_COUNT 4
+
+
+/**
+ * Defines the maximum size of a single shared memory block, in bytes, of both
+ * API allocated and API registered memory. The size is currently set to
+ * 512 * kB (512 * 1024).
+ */
+#define TEEC_CONFIG_SHAREDMEM_MAX_SIZE 0x8000
+
+/**
+ * Flag constants indicating the type of parameters encoded inside the
+ * operation payload (TEEC_Operation), Type is uint32_t.
+ *
+ * TEEC_NONE                   The Parameter is not used
+ *
+ * TEEC_VALUE_INPUT            The Parameter is a TEEC_Value tagged as input.
+ *
+ * TEEC_VALUE_OUTPUT           The Parameter is a TEEC_Value tagged as output.
+ *
+ * TEEC_VALUE_INOUT            The Parameter is a TEEC_Value tagged as both as
+ *                             input and output, i.e., for which both the
+ *                             behaviors of TEEC_VALUE_INPUT and
+ *                             TEEC_VALUE_OUTPUT apply.
+ *
+ * TEEC_MEMREF_TEMP_INPUT      The Parameter is a TEEC_TempMemoryReference
+ *                             describing a region of memory which needs to be
+ *                             temporarily registered for the duration of the
+ *                             Operation and is tagged as input.
+ *
+ * TEEC_MEMREF_TEMP_OUTPUT     Same as TEEC_MEMREF_TEMP_INPUT, but the Memory
+ *                             Reference is tagged as output. The
+ *                             Implementation may update the size field to
+ *                             reflect the required output size in some use
+ *                             cases.
+ *
+ * TEEC_MEMREF_TEMP_INOUT      A Temporary Memory Reference tagged as both
+ *                             input and output, i.e., for which both the
+ *                             behaviors of TEEC_MEMREF_TEMP_INPUT and
+ *                             TEEC_MEMREF_TEMP_OUTPUT apply.
+ *
+ * TEEC_MEMREF_WHOLE           The Parameter is a Registered Memory Reference
+ *                             that refers to the entirety of its parent Shared
+ *                             Memory block. The parameter structure is a
+ *                             TEEC_MemoryReference. In this structure, the
+ *                             Implementation MUST read only the parent field
+ *                             and MAY update the size field when the operation
+ *                             completes.
+ *
+ * TEEC_MEMREF_PARTIAL_INPUT   A Registered Memory Reference structure that
+ *                             refers to a partial region of its parent Shared
+ *                             Memory block and is tagged as input.
+ *
+ * TEEC_MEMREF_PARTIAL_OUTPUT  Registered Memory Reference structure that
+ *                             refers to a partial region of its parent Shared
+ *                             Memory block and is tagged as output.
+ *
+ * TEEC_MEMREF_PARTIAL_INOUT   The Registered Memory Reference structure that
+ *                             refers to a partial region of its parent Shared
+ *                             Memory block and is tagged as both input and
+ *                             output, i.e., for which both the behaviors of
+ *                             TEEC_MEMREF_PARTIAL_INPUT and
+ *                             TEEC_MEMREF_PARTIAL_OUTPUT apply.
+ */
+#define TEEC_NONE                   0x00000000
+#define TEEC_VALUE_INPUT            0x00000001
+#define TEEC_VALUE_OUTPUT           0x00000002
+#define TEEC_VALUE_INOUT            0x00000003
+#define TEEC_MEMREF_TEMP_INPUT      0x00000005
+#define TEEC_MEMREF_TEMP_OUTPUT     0x00000006
+#define TEEC_MEMREF_TEMP_INOUT      0x00000007
+#define TEEC_MEMREF_WHOLE           0x0000000C
+#define TEEC_MEMREF_PARTIAL_INPUT   0x0000000D
+#define TEEC_MEMREF_PARTIAL_OUTPUT  0x0000000E
+#define TEEC_MEMREF_PARTIAL_INOUT   0x0000000F
+
+/**
+ * Flag constants indicating the data transfer direction of memory in
+ * TEEC_Parameter. TEEC_MEM_INPUT signifies data transfer direction from the
+ * client application to the TEE. TEEC_MEM_OUTPUT signifies data transfer
+ * direction from the TEE to the client application. Type is uint32_t.
+ *
+ * TEEC_MEM_INPUT   The Shared Memory can carry data from the client
+ *                  application to the Trusted Application.
+ * TEEC_MEM_OUTPUT  The Shared Memory can carry data from the Trusted
+ *                  Application to the client application.
+ */
+#define TEEC_MEM_INPUT   0x00000001
+#define TEEC_MEM_OUTPUT  0x00000002
+
+/**
+ * Return values. Type is TEEC_Result
+ *
+ * TEEC_SUCCESS                 The operation was successful.
+ * TEEC_ERROR_GENERIC           Non-specific cause.
+ * TEEC_ERROR_ACCESS_DENIED     Access privileges are not sufficient.
+ * TEEC_ERROR_CANCEL            The operation was canceled.
+ * TEEC_ERROR_ACCESS_CONFLICT   Concurrent accesses caused conflict.
+ * TEEC_ERROR_EXCESS_DATA       Too much data for the requested operation was
+ *                              passed.
+ * TEEC_ERROR_BAD_FORMAT        Input data was of invalid format.
+ * TEEC_ERROR_BAD_PARAMETERS    Input parameters were invalid.
+ * TEEC_ERROR_BAD_STATE         Operation is not valid in the current state.
+ * TEEC_ERROR_ITEM_NOT_FOUND    The requested data item is not found.
+ * TEEC_ERROR_NOT_IMPLEMENTED   The requested operation should exist but is not
+ *                              yet implemented.
+ * TEEC_ERROR_NOT_SUPPORTED     The requested operation is valid but is not
+ *                              supported in this implementation.
+ * TEEC_ERROR_NO_DATA           Expected data was missing.
+ * TEEC_ERROR_OUT_OF_MEMORY     System ran out of resources.
+ * TEEC_ERROR_BUSY              The system is busy working on something else.
+ * TEEC_ERROR_COMMUNICATION     Communication with a remote party failed.
+ * TEEC_ERROR_SECURITY          A security fault was detected.
+ * TEEC_ERROR_SHORT_BUFFER      The supplied buffer is too short for the
+ *                              generated output.
+ * TEEC_ERROR_TARGET_DEAD       Trusted Application has panicked
+ *                              during the operation.
+ */
+
+/**
+ *  Standard defined error codes.
+ */
+#define TEEC_SUCCESS                0x00000000
+#define TEEC_ERROR_GENERIC          0xFFFF0000
+#define TEEC_ERROR_ACCESS_DENIED    0xFFFF0001
+#define TEEC_ERROR_CANCEL           0xFFFF0002
+#define TEEC_ERROR_ACCESS_CONFLICT  0xFFFF0003
+#define TEEC_ERROR_EXCESS_DATA      0xFFFF0004
+#define TEEC_ERROR_BAD_FORMAT       0xFFFF0005
+#define TEEC_ERROR_BAD_PARAMETERS   0xFFFF0006
+#define TEEC_ERROR_BAD_STATE        0xFFFF0007
+#define TEEC_ERROR_ITEM_NOT_FOUND   0xFFFF0008
+#define TEEC_ERROR_NOT_IMPLEMENTED  0xFFFF0009
+#define TEEC_ERROR_NOT_SUPPORTED    0xFFFF000A
+#define TEEC_ERROR_NO_DATA          0xFFFF000B
+#define TEEC_ERROR_OUT_OF_MEMORY    0xFFFF000C
+#define TEEC_ERROR_BUSY             0xFFFF000D
+#define TEEC_ERROR_COMMUNICATION    0xFFFF000E
+#define TEEC_ERROR_SECURITY         0xFFFF000F
+#define TEEC_ERROR_SHORT_BUFFER     0xFFFF0010
+#define TEEC_ERROR_EXTERNAL_CANCEL  0xFFFF0011
+#define TEEC_ERROR_TARGET_DEAD      0xFFFF3024
+
+/**
+ * Function error origins, of type TEEC_ErrorOrigin. These indicate where in
+ * the software stack a particular return value originates from.
+ *
+ * TEEC_ORIGIN_API          The error originated within the TEE Client API
+ *                          implementation.
+ * TEEC_ORIGIN_COMMS        The error originated within the underlying
+ *                          communications stack linking the rich OS with
+ *                          the TEE.
+ * TEEC_ORIGIN_TEE          The error originated within the common TEE code.
+ * TEEC_ORIGIN_TRUSTED_APP  The error originated within the Trusted Application
+ *                          code.
+ */
+#define TEEC_ORIGIN_API          0x00000001
+#define TEEC_ORIGIN_COMMS        0x00000002
+#define TEEC_ORIGIN_TEE          0x00000003
+#define TEEC_ORIGIN_TRUSTED_APP  0x00000004
+
+/**
+ * Session login methods, for use in TEEC_OpenSession() as parameter
+ * connectionMethod. Type is uint32_t.
+ *
+ * TEEC_LOGIN_PUBLIC       No login data is provided.
+ * TEEC_LOGIN_USER         Login data about the user running the Client
+ *                         Application process is provided.
+ * TEEC_LOGIN_GROUP        Login data about the group running the Client
+ *                         Application process is provided.
+ * TEEC_LOGIN_APPLICATION  Login data about the running Client Application
+ *                         itself is provided.
+ */
+#define TEEC_LOGIN_PUBLIC       0x00000000
+#define TEEC_LOGIN_USER         0x00000001
+#define TEEC_LOGIN_GROUP        0x00000002
+#define TEEC_LOGIN_APPLICATION  0x00000004
+
+/**
+ * Encode the paramTypes according to the supplied types.
+ *
+ * @param p0 The first param type.
+ * @param p1 The second param type.
+ * @param p2 The third param type.
+ * @param p3 The fourth param type.
+ */
+#define TEEC_PARAM_TYPES(p0, p1, p2, p3) \
+	((p0) | ((p1) << 4) | ((p2) << 8) | ((p3) << 12))
+
+/**
+ * Get the i_th param type from the paramType.
+ *
+ * @param p The paramType.
+ * @param i The i-th parameter to get the type for.
+ */
+#define TEEC_PARAM_TYPE_GET(p, i) (((p) >> (i * 4)) & 0xF)
+
+typedef uint32_t TEEC_Result;
+
+/**
+ * struct TEEC_Context - Represents a connection between a client application
+ * and a TEE.
+ */
+typedef struct {
+	/* Implementation defined */
+	int fd;
+} TEEC_Context;
+
+/**
+ * This type contains a Universally Unique Resource Identifier (UUID) type as
+ * defined in RFC4122. These UUID values are used to identify Trusted
+ * Applications.
+ */
+typedef struct {
+	uint32_t timeLow;
+	uint16_t timeMid;
+	uint16_t timeHiAndVersion;
+	uint8_t clockSeqAndNode[8];
+} TEEC_UUID;
+
+/**
+ * struct TEEC_SharedMemory - Memory to transfer data between a client
+ * application and trusted code.
+ *
+ * @param buffer      The memory buffer which is to be, or has been, shared
+ *                    with the TEE.
+ * @param size        The size, in bytes, of the memory buffer.
+ * @param flags       Bit-vector which holds properties of buffer.
+ *                    The bit-vector can contain either or both of the
+ *                    TEEC_MEM_INPUT and TEEC_MEM_OUTPUT flags.
+ *
+ * A shared memory block is a region of memory allocated in the context of the
+ * client application memory space that can be used to transfer data between
+ * that client application and a trusted application. The user of this struct
+ * is responsible to populate the buffer pointer.
+ */
+typedef struct {
+	void *buffer;
+	size_t size;
+	uint32_t flags;
+	/*
+	 * Implementation-Defined
+	 */
+	int id;
+	size_t alloced_size;
+	void *shadow_buffer;
+} TEEC_SharedMemory;
+
+/**
+ * struct TEEC_TempMemoryReference - Temporary memory to transfer data between
+ * a client application and trusted code, only used for the duration of the
+ * operation.
+ *
+ * @param buffer  The memory buffer which is to be, or has been shared with
+ *                the TEE.
+ * @param size    The size, in bytes, of the memory buffer.
+ *
+ * A memory buffer that is registered temporarily for the duration of the
+ * operation to be called.
+ */
+typedef struct {
+	void *buffer;
+	size_t size;
+} TEEC_TempMemoryReference;
+
+/**
+ * struct TEEC_RegisteredMemoryReference - use a pre-registered or
+ * pre-allocated shared memory block of memory to transfer data between
+ * a client application and trusted code.
+ *
+ * @param parent  Points to a shared memory structure. The memory reference
+ *                may utilize the whole shared memory or only a part of it.
+ *                Must not be NULL
+ *
+ * @param size    The size, in bytes, of the memory buffer.
+ *
+ * @param offset  The offset, in bytes, of the referenced memory region from
+ *                the start of the shared memory block.
+ *
+ */
+typedef struct {
+	TEEC_SharedMemory *parent;
+	size_t size;
+	size_t offset;
+} TEEC_RegisteredMemoryReference;
+
+/**
+ * struct TEEC_Value - Small raw data container
+ *
+ * Instead of allocating a shared memory buffer this structure can be used
+ * to pass small raw data between a client application and trusted code.
+ *
+ * @param a  The first integer value.
+ *
+ * @param b  The second second value.
+ */
+typedef struct {
+	uint32_t a;
+	uint32_t b;
+} TEEC_Value;
+
+/**
+ * union TEEC_Parameter - Memory container to be used when passing data between
+ *                        client application and trusted code.
+ *
+ * Either the client uses a shared memory reference, parts of it or a small raw
+ * data container.
+ *
+ * @param tmpref  A temporary memory reference only valid for the duration
+ *                of the operation.
+ *
+ * @param memref  The entire shared memory or parts of it.
+ *
+ * @param value   The small raw data container to use
+ */
+typedef union {
+	TEEC_TempMemoryReference tmpref;
+	TEEC_RegisteredMemoryReference memref;
+	TEEC_Value value;
+} TEEC_Parameter;
+
+/**
+ * struct TEEC_Session - Represents a connection between a client application
+ * and a trusted application.
+ */
+typedef struct {
+	/* Implementation defined */
+	TEEC_Context *ctx;
+	uint32_t session_id;
+} TEEC_Session;
+
+/**
+ * struct TEEC_Operation - Holds information and memory references used in
+ * TEEC_InvokeCommand().
+ *
+ * @param   started     Client must initialize to zero if it needs to cancel
+ *                      an operation about to be performed.
+ * @param   paramTypes  Type of data passed. Use TEEC_PARAMS_TYPE macro to
+ *                      create the correct flags.
+ *                      0 means TEEC_NONE is passed for all params.
+ * @param   params      Array of parameters of type TEEC_Parameter.
+ * @param   session     Internal pointer to the last session used by
+ *                      TEEC_InvokeCommand with this operation.
+ *
+ */
+typedef struct {
+	uint32_t started;
+	uint32_t paramTypes;
+	TEEC_Parameter params[TEEC_CONFIG_PAYLOAD_REF_COUNT];
+	/* Implementation-Defined */
+	TEEC_Session *session;
+} TEEC_Operation;
+
+/**
+ * TEEC_InitializeContext() - Initializes a context holding connection
+ * information on the specific TEE, designated by the name string.
+
+ * @param name    A zero-terminated string identifying the TEE to connect to.
+ *                If name is set to NULL, the default TEE is connected to. NULL
+ *                is the only supported value in this version of the API
+ *                implementation.
+ *
+ * @param context The context structure which is to be initialized.
+ *
+ * @return TEEC_SUCCESS  The initialization was successful.
+ * @return TEEC_Result   Something failed.
+ */
+TEEC_Result TEEC_InitializeContext(const char *name, TEEC_Context *context);
+
+/**
+ * TEEC_FinalizeContext() - Destroys a context holding connection information
+ * on the specific TEE.
+ *
+ * This function destroys an initialized TEE context, closing the connection
+ * between the client application and the TEE. This function must only be
+ * called when all sessions related to this TEE context have been closed and
+ * all shared memory blocks have been released.
+ *
+ * @param context       The context to be destroyed.
+ */
+void TEEC_FinalizeContext(TEEC_Context *context);
+
+/**
+ * TEEC_OpenSession() - Opens a new session with the specified trusted
+ *                      application.
+ *
+ * @param context            The initialized TEE context structure in which
+ *                           scope to open the session.
+ * @param session            The session to initialize.
+ * @param destination        A structure identifying the trusted application
+ *                           with which to open a session.
+ *
+ * @param connectionMethod   The connection method to use.
+ * @param connectionData     Any data necessary to connect with the chosen
+ *                           connection method. Not supported, should be set to
+ *                           NULL.
+ * @param operation          An operation structure to use in the session. May
+ *                           be set to NULL to signify no operation structure
+ *                           needed.
+ *
+ * @param returnOrigin       A parameter which will hold the error origin if
+ *                           this function returns any value other than
+ *                           TEEC_SUCCESS.
+ *
+ * @return TEEC_SUCCESS      OpenSession successfully opened a new session.
+ * @return TEEC_Result       Something failed.
+ *
+ */
+TEEC_Result TEEC_OpenSession(TEEC_Context *context,
+			     TEEC_Session *session,
+			     const TEEC_UUID *destination,
+			     uint32_t connectionMethod,
+			     const void *connectionData,
+			     TEEC_Operation *operation,
+			     uint32_t *returnOrigin);
+
+/**
+ * TEEC_CloseSession() - Closes the session which has been opened with the
+ * specific trusted application.
+ *
+ * @param session The opened session to close.
+ */
+void TEEC_CloseSession(TEEC_Session *session);
+
+/**
+ * TEEC_InvokeCommand() - Executes a command in the specified trusted
+ * application.
+ *
+ * @param session        A handle to an open connection to the trusted
+ *                       application.
+ * @param commandID      Identifier of the command in the trusted application
+ *                       to invoke.
+ * @param operation      An operation structure to use in the invoke command.
+ *                       May be set to NULL to signify no operation structure
+ *                       needed.
+ * @param returnOrigin   A parameter which will hold the error origin if this
+ *                       function returns any value other than TEEC_SUCCESS.
+ *
+ * @return TEEC_SUCCESS  OpenSession successfully opened a new session.
+ * @return TEEC_Result   Something failed.
+ */
+TEEC_Result TEEC_InvokeCommand(TEEC_Session *session,
+			       uint32_t commandID,
+			       TEEC_Operation *operation,
+			       uint32_t *returnOrigin);
+
+/**
+ * TEEC_RegisterSharedMemory() - Register a block of existing memory as a
+ * shared block within the scope of the specified context.
+ *
+ * @param context    The initialized TEE context structure in which scope to
+ *                   open the session.
+ * @param sharedMem  pointer to the shared memory structure to register.
+ *
+ * @return TEEC_SUCCESS              The registration was successful.
+ * @return TEEC_ERROR_OUT_OF_MEMORY  Memory exhaustion.
+ * @return TEEC_Result               Something failed.
+ */
+TEEC_Result TEEC_RegisterSharedMemory(TEEC_Context *context,
+				      TEEC_SharedMemory *sharedMem);
+
+/**
+ * TEEC_AllocateSharedMemory() - Allocate shared memory for TEE.
+ *
+ * @param context     The initialized TEE context structure in which scope to
+ *                    open the session.
+ * @param sharedMem   Pointer to the allocated shared memory.
+ *
+ * @return TEEC_SUCCESS              The registration was successful.
+ * @return TEEC_ERROR_OUT_OF_MEMORY  Memory exhaustion.
+ * @return TEEC_Result               Something failed.
+ */
+TEEC_Result TEEC_AllocateSharedMemory(TEEC_Context *context,
+				      TEEC_SharedMemory *sharedMem);
+
+/**
+ * TEEC_ReleaseSharedMemory() - Free or deregister the shared memory.
+ *
+ * @param sharedMem  Pointer to the shared memory to be freed.
+ */
+void TEEC_ReleaseSharedMemory(TEEC_SharedMemory *sharedMemory);
+
+/**
+ * TEEC_RequestCancellation() - Request the cancellation of a pending open
+ *                              session or command invocation.
+ *
+ * @param operation Pointer to an operation previously passed to open session
+ *                  or invoke.
+ */
+void TEEC_RequestCancellation(TEEC_Operation *operation);
+
+#endif
diff --git a/drivers/tee/tee_core.c b/drivers/tee/tee_core.c
new file mode 100644
index 00000000..0deeb96
--- /dev/null
+++ b/drivers/tee/tee_core.c
@@ -0,0 +1,1137 @@
+/*
+ * Copyright (c) 2015-2016, Linaro Limited
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#define pr_fmt(fmt) "%s: " fmt, __func__
+
+#include <linux/cdev.h>
+#include <linux/device.h>
+#include <linux/fs.h>
+#include <linux/idr.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include <linux/uaccess.h>
+#include "tee_private.h"
+
+#define TEE_NUM_DEVICES	32
+
+#define TEE_IOCTL_PARAM_SIZE(x) (sizeof(struct tee_param) * (x))
+
+/*
+ * Unprivileged devices in the lower half range and privileged devices in
+ * the upper half range.
+ */
+static DECLARE_BITMAP(dev_mask, TEE_NUM_DEVICES);
+static DEFINE_SPINLOCK(driver_lock);
+
+static struct class *tee_class;
+static dev_t tee_devt;
+
+#if defined(CONFIG_RTK_HDCPRX_2P2_TEE) || defined(CONFIG_RTK_HDCPRX_1P4_TEE)
+int TEE2p1_Flag = 0 ; 
+#endif
+
+#ifdef CONFIG_RTK_PLATFORM
+static struct tee_context *teedev_open(struct tee_device *teedev)
+{
+	int rc;
+	struct tee_context *ctx;
+
+	if (!tee_device_get(teedev))
+		return ERR_PTR(-EINVAL);
+
+	ctx = kzalloc(sizeof(*ctx), GFP_KERNEL);
+	if (!ctx) {
+		rc = -ENOMEM;
+		goto err;
+	}
+
+	kref_init(&ctx->refcount);
+	ctx->teedev = teedev;
+	INIT_LIST_HEAD(&ctx->list_shm);
+	rc = teedev->desc->ops->open(ctx);
+	if (rc)
+		goto err;
+
+	return ctx;
+err:
+	kfree(ctx);
+	tee_device_put(teedev);
+	return ERR_PTR(rc);
+
+}
+
+static void teedev_close_context(struct tee_context *ctx)
+{
+	struct tee_shm *shm;
+
+	ctx->teedev->desc->ops->release(ctx);
+	mutex_lock(&ctx->teedev->mutex);
+	list_for_each_entry(shm, &ctx->list_shm, link)
+		shm->ctx = NULL;
+	mutex_unlock(&ctx->teedev->mutex);
+	tee_device_put(ctx->teedev);
+	kfree(ctx);
+}
+#endif /* CONFIG_RTK_PLATFORM */
+
+static int tee_open(struct inode *inode, struct file *filp)
+{
+	int rc;
+	struct tee_device *teedev;
+	struct tee_context *ctx;
+
+	teedev = container_of(inode->i_cdev, struct tee_device, cdev);
+	if (!tee_device_get(teedev))
+		return -EINVAL;
+
+	ctx = kzalloc(sizeof(*ctx), GFP_KERNEL);
+	if (!ctx) {
+		rc = -ENOMEM;
+		goto err;
+	}
+
+	kref_init(&ctx->refcount);
+	ctx->teedev = teedev;
+	INIT_LIST_HEAD(&ctx->list_shm);
+	filp->private_data = ctx;
+	rc = teedev->desc->ops->open(ctx);
+	if (rc)
+		goto err;
+
+	return 0;
+err:
+	kfree(ctx);
+	tee_device_put(teedev);
+	return rc;
+}
+
+void teedev_ctx_get(struct tee_context *ctx)
+{
+	if (ctx->releasing)
+		return;
+
+	kref_get(&ctx->refcount);
+}
+
+static void teedev_ctx_release(struct kref *ref)
+{
+	struct tee_context *ctx = container_of(ref, struct tee_context,
+					       refcount);
+	ctx->releasing = true;
+	ctx->teedev->desc->ops->release(ctx);
+	kfree(ctx);
+}
+
+void teedev_ctx_put(struct tee_context *ctx)
+{
+	if (ctx->releasing)
+		return;
+
+	kref_put(&ctx->refcount, teedev_ctx_release);
+}
+
+#ifdef CONFIG_RTK_PLATFORM
+#else
+static void teedev_close_context(struct tee_context *ctx)
+{
+	tee_device_put(ctx->teedev);
+	teedev_ctx_put(ctx);
+}
+#endif
+
+static int tee_release(struct inode *inode, struct file *filp)
+{
+	teedev_close_context(filp->private_data);
+	return 0;
+}
+
+static int tee_ioctl_version(struct tee_context *ctx,
+			     struct tee_ioctl_version_data __user *uvers)
+{
+	struct tee_ioctl_version_data vers;
+
+	ctx->teedev->desc->ops->get_version(ctx->teedev, &vers);
+
+	if (ctx->teedev->desc->flags & TEE_DESC_PRIVILEGED)
+		vers.gen_caps |= TEE_GEN_CAP_PRIVILEGED;
+
+	if (copy_to_user(uvers, &vers, sizeof(vers)))
+		return -EFAULT;
+
+	return 0;
+}
+
+static int tee_ioctl_shm_alloc(struct tee_context *ctx,
+			       struct tee_ioctl_shm_alloc_data __user *udata)
+{
+	long ret;
+	struct tee_ioctl_shm_alloc_data data;
+	struct tee_shm *shm;
+
+	if (copy_from_user(&data, udata, sizeof(data)))
+		return -EFAULT;
+
+	/* Currently no input flags are supported */
+	if (data.flags)
+		return -EINVAL;
+
+	shm = tee_shm_alloc(ctx, data.size, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+	data.id = shm->id;
+	data.flags = shm->flags;
+	data.size = shm->size;
+
+	if (copy_to_user(udata, &data, sizeof(data)))
+		ret = -EFAULT;
+	else
+		ret = tee_shm_get_fd(shm);
+
+	/*
+	 * When user space closes the file descriptor the shared memory
+	 * should be freed or if tee_shm_get_fd() failed then it will
+	 * be freed immediately.
+	 */
+	tee_shm_put(shm);
+	return ret;
+}
+
+static int
+tee_ioctl_shm_register(struct tee_context *ctx,
+		       struct tee_ioctl_shm_register_data __user *udata)
+{
+	long ret;
+	struct tee_ioctl_shm_register_data data;
+	struct tee_shm *shm;
+
+	if (copy_from_user(&data, udata, sizeof(data)))
+		return -EFAULT;
+
+	/* Currently no input flags are supported */
+	if (data.flags)
+		return -EINVAL;
+
+	shm = tee_shm_register(ctx, data.addr, data.length,
+			       TEE_SHM_DMA_BUF | TEE_SHM_USER_MAPPED);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+	data.id = shm->id;
+	data.flags = shm->flags;
+	data.length = shm->size;
+
+	if (copy_to_user(udata, &data, sizeof(data)))
+		ret = -EFAULT;
+	else
+		ret = tee_shm_get_fd(shm);
+	/*
+	 * When user space closes the file descriptor the shared memory
+	 * should be freed or if tee_shm_get_fd() failed then it will
+	 * be freed immediately.
+	 */
+	tee_shm_put(shm);
+	return ret;
+}
+
+static int tee_ioctl_shm_register_fd(struct tee_context *ctx,
+			struct tee_ioctl_shm_register_fd_data __user *udata)
+{
+	struct tee_ioctl_shm_register_fd_data data;
+	struct tee_shm *shm;
+	long ret;
+
+	if (copy_from_user(&data, udata, sizeof(data)))
+		return -EFAULT;
+
+	/* Currently no input flags are supported */
+	if (data.flags)
+		return -EINVAL;
+
+	shm = tee_shm_register_fd(ctx, data.fd);
+	if (IS_ERR_OR_NULL(shm))
+		return -EINVAL;
+
+	data.id = shm->id;
+	data.flags = shm->flags;
+	data.size = shm->size;
+
+	if (copy_to_user(udata, &data, sizeof(data)))
+		ret = -EFAULT;
+	else
+		ret = tee_shm_get_fd(shm);
+
+	/*
+	 * When user space closes the file descriptor the shared memory
+	 * should be freed or if tee_shm_get_fd() failed then it will
+	 * be freed immediately.
+	 */
+	tee_shm_put(shm);
+	return ret;
+}
+
+static int params_from_user(struct tee_context *ctx, struct tee_param *params,
+			    size_t num_params,
+			    struct tee_ioctl_param __user *uparams)
+{
+	size_t n;
+
+	for (n = 0; n < num_params; n++) {
+		struct tee_shm *shm;
+		struct tee_ioctl_param ip;
+
+		if (copy_from_user(&ip, uparams + n, sizeof(ip)))
+			return -EFAULT;
+
+		/* All unused attribute bits has to be zero */
+		if (ip.attr & ~TEE_IOCTL_PARAM_ATTR_MASK)
+			return -EINVAL;
+
+		params[n].attr = ip.attr;
+		switch (ip.attr & TEE_IOCTL_PARAM_ATTR_TYPE_MASK) {
+		case TEE_IOCTL_PARAM_ATTR_TYPE_NONE:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_OUTPUT:
+			break;
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT:
+			params[n].u.value.a = ip.a;
+			params[n].u.value.b = ip.b;
+			params[n].u.value.c = ip.c;
+			break;
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_OUTPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT:
+			/*
+			 * If we fail to get a pointer to a shared memory
+			 * object (and increase the ref count) from an
+			 * identifier we return an error. All pointers that
+			 * has been added in params have an increased ref
+			 * count. It's the callers responibility to do
+			 * tee_shm_put() on all resolved pointers.
+			 */
+			shm = tee_shm_get_from_id(ctx, ip.c);
+			if (IS_ERR(shm))
+				return PTR_ERR(shm);
+
+			params[n].u.memref.shm_offs = ip.a;
+			params[n].u.memref.size = ip.b;
+			params[n].u.memref.shm = shm;
+			break;
+		default:
+			/* Unknown attribute */
+			return -EINVAL;
+		}
+	}
+	return 0;
+}
+
+static int params_to_user(struct tee_ioctl_param __user *uparams,
+			  size_t num_params, struct tee_param *params)
+{
+	size_t n;
+
+	for (n = 0; n < num_params; n++) {
+		struct tee_ioctl_param __user *up = uparams + n;
+		struct tee_param *p = params + n;
+
+		switch (p->attr) {
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_OUTPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT:
+			if (put_user(p->u.value.a, &up->a) ||
+			    put_user(p->u.value.b, &up->b) ||
+			    put_user(p->u.value.c, &up->c))
+				return -EFAULT;
+			break;
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_OUTPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT:
+			if (put_user((u64)p->u.memref.size, &up->b))
+				return -EFAULT;
+		default:
+			break;
+		}
+	}
+	return 0;
+}
+
+static int tee_ioctl_open_session(struct tee_context *ctx,
+				  struct tee_ioctl_buf_data __user *ubuf)
+{
+	int rc;
+	size_t n;
+	struct tee_ioctl_buf_data buf;
+	struct tee_ioctl_open_session_arg __user *uarg;
+	struct tee_ioctl_open_session_arg arg;
+	struct tee_ioctl_param __user *uparams = NULL;
+	struct tee_param *params = NULL;
+	bool have_session = false;
+
+	if (!ctx->teedev->desc->ops->open_session)
+		return -EINVAL;
+
+	if (copy_from_user(&buf, ubuf, sizeof(buf)))
+		return -EFAULT;
+
+	if (buf.buf_len > TEE_MAX_ARG_SIZE ||
+	    buf.buf_len < sizeof(struct tee_ioctl_open_session_arg))
+		return -EINVAL;
+
+	uarg = u64_to_user_ptr(buf.buf_ptr);
+	if (copy_from_user(&arg, uarg, sizeof(arg)))
+		return -EFAULT;
+
+	if (sizeof(arg) + TEE_IOCTL_PARAM_SIZE(arg.num_params) != buf.buf_len)
+		return -EINVAL;
+
+	if (arg.num_params) {
+		params = kcalloc(arg.num_params, sizeof(struct tee_param),
+				 GFP_KERNEL);
+		if (!params)
+			return -ENOMEM;
+		uparams = uarg->params;
+		rc = params_from_user(ctx, params, arg.num_params, uparams);
+		if (rc)
+			goto out;
+	}
+
+	rc = ctx->teedev->desc->ops->open_session(ctx, &arg, params);
+	if (rc)
+		goto out;
+	have_session = true;
+
+	if (put_user(arg.session, &uarg->session) ||
+	    put_user(arg.ret, &uarg->ret) ||
+	    put_user(arg.ret_origin, &uarg->ret_origin)) {
+		rc = -EFAULT;
+		goto out;
+	}
+	rc = params_to_user(uparams, arg.num_params, params);
+out:
+	/*
+	 * If we've succeeded to open the session but failed to communicate
+	 * it back to user space, close the session again to avoid leakage.
+	 */
+	if (rc && have_session && ctx->teedev->desc->ops->close_session)
+		ctx->teedev->desc->ops->close_session(ctx, arg.session);
+
+	if (params) {
+		/* Decrease ref count for all valid shared memory pointers */
+		for (n = 0; n < arg.num_params; n++)
+			if (tee_param_is_memref(params + n) &&
+			    params[n].u.memref.shm)
+				tee_shm_put(params[n].u.memref.shm);
+		kfree(params);
+	}
+
+	return rc;
+}
+
+static int tee_ioctl_invoke(struct tee_context *ctx,
+			    struct tee_ioctl_buf_data __user *ubuf)
+{
+	int rc;
+	size_t n;
+	struct tee_ioctl_buf_data buf;
+	struct tee_ioctl_invoke_arg __user *uarg;
+	struct tee_ioctl_invoke_arg arg;
+	struct tee_ioctl_param __user *uparams = NULL;
+	struct tee_param *params = NULL;
+
+	if (!ctx->teedev->desc->ops->invoke_func)
+		return -EINVAL;
+
+	if (copy_from_user(&buf, ubuf, sizeof(buf)))
+		return -EFAULT;
+
+	if (buf.buf_len > TEE_MAX_ARG_SIZE ||
+	    buf.buf_len < sizeof(struct tee_ioctl_invoke_arg))
+		return -EINVAL;
+
+	uarg = u64_to_user_ptr(buf.buf_ptr);
+	if (copy_from_user(&arg, uarg, sizeof(arg)))
+		return -EFAULT;
+
+	if (sizeof(arg) + TEE_IOCTL_PARAM_SIZE(arg.num_params) != buf.buf_len)
+		return -EINVAL;
+
+	if (arg.num_params) {
+		params = kcalloc(arg.num_params, sizeof(struct tee_param),
+				 GFP_KERNEL);
+		if (!params)
+			return -ENOMEM;
+		uparams = uarg->params;
+		rc = params_from_user(ctx, params, arg.num_params, uparams);
+		if (rc)
+			goto out;
+	}
+
+	rc = ctx->teedev->desc->ops->invoke_func(ctx, &arg, params);
+	if (rc)
+		goto out;
+
+	if (put_user(arg.ret, &uarg->ret) ||
+	    put_user(arg.ret_origin, &uarg->ret_origin)) {
+		rc = -EFAULT;
+		goto out;
+	}
+	rc = params_to_user(uparams, arg.num_params, params);
+out:
+	if (params) {
+		/* Decrease ref count for all valid shared memory pointers */
+		for (n = 0; n < arg.num_params; n++)
+			if (tee_param_is_memref(params + n) &&
+			    params[n].u.memref.shm)
+				tee_shm_put(params[n].u.memref.shm);
+		kfree(params);
+	}
+	return rc;
+}
+
+static int tee_ioctl_cancel(struct tee_context *ctx,
+			    struct tee_ioctl_cancel_arg __user *uarg)
+{
+	struct tee_ioctl_cancel_arg arg;
+
+	if (!ctx->teedev->desc->ops->cancel_req)
+		return -EINVAL;
+
+	if (copy_from_user(&arg, uarg, sizeof(arg)))
+		return -EFAULT;
+
+	return ctx->teedev->desc->ops->cancel_req(ctx, arg.cancel_id,
+						  arg.session);
+}
+
+static int
+tee_ioctl_close_session(struct tee_context *ctx,
+			struct tee_ioctl_close_session_arg __user *uarg)
+{
+	struct tee_ioctl_close_session_arg arg;
+
+	if (!ctx->teedev->desc->ops->close_session)
+		return -EINVAL;
+
+	if (copy_from_user(&arg, uarg, sizeof(arg)))
+		return -EFAULT;
+
+	return ctx->teedev->desc->ops->close_session(ctx, arg.session);
+}
+
+static int params_to_supp(struct tee_context *ctx,
+			  struct tee_ioctl_param __user *uparams,
+			  size_t num_params, struct tee_param *params)
+{
+	size_t n;
+
+	for (n = 0; n < num_params; n++) {
+		struct tee_ioctl_param ip;
+		struct tee_param *p = params + n;
+
+		ip.attr = p->attr;
+		switch (p->attr & TEE_IOCTL_PARAM_ATTR_TYPE_MASK) {
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT:
+			ip.a = p->u.value.a;
+			ip.b = p->u.value.b;
+			ip.c = p->u.value.c;
+			break;
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_OUTPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT:
+			ip.b = p->u.memref.size;
+			if (!p->u.memref.shm) {
+				ip.a = 0;
+				ip.c = (u64)-1; /* invalid shm id */
+				break;
+			}
+			ip.a = p->u.memref.shm_offs;
+			ip.c = p->u.memref.shm->id;
+			break;
+		default:
+			ip.a = 0;
+			ip.b = 0;
+			ip.c = 0;
+			break;
+		}
+
+		if (copy_to_user(uparams + n, &ip, sizeof(ip)))
+			return -EFAULT;
+	}
+
+	return 0;
+}
+
+static int tee_ioctl_supp_recv(struct tee_context *ctx,
+			       struct tee_ioctl_buf_data __user *ubuf)
+{
+	int rc;
+	struct tee_ioctl_buf_data buf;
+	struct tee_iocl_supp_recv_arg __user *uarg;
+	struct tee_param *params;
+	u32 num_params;
+	u32 func;
+
+	if (!ctx->teedev->desc->ops->supp_recv)
+		return -EINVAL;
+
+	if (copy_from_user(&buf, ubuf, sizeof(buf)))
+		return -EFAULT;
+
+	if (buf.buf_len > TEE_MAX_ARG_SIZE ||
+	    buf.buf_len < sizeof(struct tee_iocl_supp_recv_arg))
+		return -EINVAL;
+
+	uarg = u64_to_user_ptr(buf.buf_ptr);
+	if (get_user(num_params, &uarg->num_params))
+		return -EFAULT;
+
+	if (sizeof(*uarg) + TEE_IOCTL_PARAM_SIZE(num_params) != buf.buf_len)
+		return -EINVAL;
+
+	params = kcalloc(num_params, sizeof(struct tee_param), GFP_KERNEL);
+	if (!params)
+		return -ENOMEM;
+
+	rc = params_from_user(ctx, params, num_params, uarg->params);
+	if (rc)
+		goto out;
+
+	rc = ctx->teedev->desc->ops->supp_recv(ctx, &func, &num_params, params);
+	if (rc)
+		goto out;
+
+	if (put_user(func, &uarg->func) ||
+	    put_user(num_params, &uarg->num_params)) {
+		rc = -EFAULT;
+		goto out;
+	}
+
+	rc = params_to_supp(ctx, uarg->params, num_params, params);
+out:
+	kfree(params);
+	return rc;
+}
+
+static int params_from_supp(struct tee_param *params, size_t num_params,
+			    struct tee_ioctl_param __user *uparams)
+{
+	size_t n;
+
+	for (n = 0; n < num_params; n++) {
+		struct tee_param *p = params + n;
+		struct tee_ioctl_param ip;
+
+		if (copy_from_user(&ip, uparams + n, sizeof(ip)))
+			return -EFAULT;
+
+		/* All unused attribute bits has to be zero */
+		if (ip.attr & ~TEE_IOCTL_PARAM_ATTR_MASK)
+			return -EINVAL;
+
+		p->attr = ip.attr;
+		switch (ip.attr & TEE_IOCTL_PARAM_ATTR_TYPE_MASK) {
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_OUTPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT:
+			/* Only out and in/out values can be updated */
+			p->u.value.a = ip.a;
+			p->u.value.b = ip.b;
+			p->u.value.c = ip.c;
+			break;
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_OUTPUT:
+		case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT:
+			/*
+			 * Only the size of the memref can be updated.
+			 * Since we don't have access to the original
+			 * parameters here, only store the supplied size.
+			 * The driver will copy the updated size into the
+			 * original parameters.
+			 */
+			p->u.memref.shm = NULL;
+			p->u.memref.shm_offs = 0;
+			p->u.memref.size = ip.b;
+			break;
+		default:
+			memset(&p->u, 0, sizeof(p->u));
+			break;
+		}
+	}
+	return 0;
+}
+
+static int tee_ioctl_supp_send(struct tee_context *ctx,
+			       struct tee_ioctl_buf_data __user *ubuf)
+{
+	long rc;
+	struct tee_ioctl_buf_data buf;
+	struct tee_iocl_supp_send_arg __user *uarg;
+	struct tee_param *params;
+	u32 num_params;
+	u32 ret;
+
+	/* Not valid for this driver */
+	if (!ctx->teedev->desc->ops->supp_send)
+		return -EINVAL;
+
+	if (copy_from_user(&buf, ubuf, sizeof(buf)))
+		return -EFAULT;
+
+	if (buf.buf_len > TEE_MAX_ARG_SIZE ||
+	    buf.buf_len < sizeof(struct tee_iocl_supp_send_arg))
+		return -EINVAL;
+
+	uarg = u64_to_user_ptr(buf.buf_ptr);
+	if (get_user(ret, &uarg->ret) ||
+	    get_user(num_params, &uarg->num_params))
+		return -EFAULT;
+
+	if (sizeof(*uarg) + TEE_IOCTL_PARAM_SIZE(num_params) > buf.buf_len)
+		return -EINVAL;
+
+	params = kcalloc(num_params, sizeof(struct tee_param), GFP_KERNEL);
+	if (!params)
+		return -ENOMEM;
+
+	rc = params_from_supp(params, num_params, uarg->params);
+	if (rc)
+		goto out;
+
+	rc = ctx->teedev->desc->ops->supp_send(ctx, ret, num_params, params);
+out:
+	kfree(params);
+	return rc;
+}
+
+static long tee_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
+{
+	struct tee_context *ctx = filp->private_data;
+	void __user *uarg = (void __user *)arg;
+
+	switch (cmd) {
+	case TEE_IOC_VERSION:
+		return tee_ioctl_version(ctx, uarg);
+	case TEE_IOC_SHM_ALLOC:
+		return tee_ioctl_shm_alloc(ctx, uarg);
+	case TEE_IOC_SHM_REGISTER:
+		return tee_ioctl_shm_register(ctx, uarg);
+	case TEE_IOC_SHM_REGISTER_FD:
+		return tee_ioctl_shm_register_fd(ctx, uarg);
+	case TEE_IOC_OPEN_SESSION:
+		return tee_ioctl_open_session(ctx, uarg);
+	case TEE_IOC_INVOKE:
+		return tee_ioctl_invoke(ctx, uarg);
+	case TEE_IOC_CANCEL:
+		return tee_ioctl_cancel(ctx, uarg);
+	case TEE_IOC_CLOSE_SESSION:
+		return tee_ioctl_close_session(ctx, uarg);
+	case TEE_IOC_SUPPL_RECV:
+		return tee_ioctl_supp_recv(ctx, uarg);
+	case TEE_IOC_SUPPL_SEND:
+		return tee_ioctl_supp_send(ctx, uarg);
+	default:
+		return -EINVAL;
+	}
+}
+
+static const struct file_operations tee_fops = {
+	.owner = THIS_MODULE,
+	.open = tee_open,
+	.release = tee_release,
+	.unlocked_ioctl = tee_ioctl,
+	.compat_ioctl = tee_ioctl,
+};
+
+static void tee_release_device(struct device *dev)
+{
+	struct tee_device *teedev = container_of(dev, struct tee_device, dev);
+
+	spin_lock(&driver_lock);
+	clear_bit(teedev->id, dev_mask);
+	spin_unlock(&driver_lock);
+	mutex_destroy(&teedev->mutex);
+	idr_destroy(&teedev->idr);
+	kfree(teedev);
+}
+
+/**
+ * tee_device_alloc() - Allocate a new struct tee_device instance
+ * @teedesc:	Descriptor for this driver
+ * @dev:	Parent device for this device
+ * @pool:	Shared memory pool, NULL if not used
+ * @driver_data: Private driver data for this device
+ *
+ * Allocates a new struct tee_device instance. The device is
+ * removed by tee_device_unregister().
+ *
+ * @returns a pointer to a 'struct tee_device' or an ERR_PTR on failure
+ */
+struct tee_device *tee_device_alloc(const struct tee_desc *teedesc,
+				    struct device *dev,
+				    struct tee_shm_pool *pool,
+				    void *driver_data)
+{
+	struct tee_device *teedev;
+	void *ret;
+	int rc;
+	int offs = 0;
+
+	if (!teedesc || !teedesc->name || !teedesc->ops ||
+	    !teedesc->ops->get_version || !teedesc->ops->open ||
+	    !teedesc->ops->release || !pool)
+		return ERR_PTR(-EINVAL);
+
+	teedev = kzalloc(sizeof(*teedev), GFP_KERNEL);
+	if (!teedev) {
+		ret = ERR_PTR(-ENOMEM);
+		goto err;
+	}
+
+	if (teedesc->flags & TEE_DESC_PRIVILEGED)
+		offs = TEE_NUM_DEVICES / 2;
+
+	spin_lock(&driver_lock);
+	teedev->id = find_next_zero_bit(dev_mask, TEE_NUM_DEVICES, offs);
+	if (teedev->id < TEE_NUM_DEVICES)
+		set_bit(teedev->id, dev_mask);
+	spin_unlock(&driver_lock);
+
+	if (teedev->id >= TEE_NUM_DEVICES) {
+		ret = ERR_PTR(-ENOMEM);
+		goto err;
+	}
+
+	snprintf(teedev->name, sizeof(teedev->name), "tee%s%d",
+		 teedesc->flags & TEE_DESC_PRIVILEGED ? "priv" : "",
+		 teedev->id - offs);
+
+	teedev->dev.class = tee_class;
+	teedev->dev.release = tee_release_device;
+	teedev->dev.parent = dev;
+
+	teedev->dev.devt = MKDEV(MAJOR(tee_devt), teedev->id);
+
+	rc = dev_set_name(&teedev->dev, "%s", teedev->name);
+	if (rc) {
+		ret = ERR_PTR(rc);
+		goto err_devt;
+	}
+
+	cdev_init(&teedev->cdev, &tee_fops);
+	teedev->cdev.owner = teedesc->owner;
+	teedev->cdev.kobj.parent = &teedev->dev.kobj;
+
+	dev_set_drvdata(&teedev->dev, driver_data);
+	device_initialize(&teedev->dev);
+
+	/* 1 as tee_device_unregister() does one final tee_device_put() */
+	teedev->num_users = 1;
+	init_completion(&teedev->c_no_users);
+	mutex_init(&teedev->mutex);
+	idr_init(&teedev->idr);
+
+	teedev->desc = teedesc;
+	teedev->pool = pool;
+
+	return teedev;
+err_devt:
+	unregister_chrdev_region(teedev->dev.devt, 1);
+err:
+	pr_err("could not register %s driver\n",
+	       teedesc->flags & TEE_DESC_PRIVILEGED ? "privileged" : "client");
+	if (teedev && teedev->id < TEE_NUM_DEVICES) {
+		spin_lock(&driver_lock);
+		clear_bit(teedev->id, dev_mask);
+		spin_unlock(&driver_lock);
+	}
+	kfree(teedev);
+	return ret;
+}
+EXPORT_SYMBOL_GPL(tee_device_alloc);
+
+static ssize_t implementation_id_show(struct device *dev,
+				      struct device_attribute *attr, char *buf)
+{
+	struct tee_device *teedev = container_of(dev, struct tee_device, dev);
+	struct tee_ioctl_version_data vers;
+
+	teedev->desc->ops->get_version(teedev, &vers);
+	return scnprintf(buf, PAGE_SIZE, "%d\n", vers.impl_id);
+}
+static DEVICE_ATTR_RO(implementation_id);
+
+static struct attribute *tee_dev_attrs[] = {
+	&dev_attr_implementation_id.attr,
+	NULL
+};
+
+static const struct attribute_group tee_dev_group = {
+	.attrs = tee_dev_attrs,
+};
+
+/**
+ * tee_device_register() - Registers a TEE device
+ * @teedev:	Device to register
+ *
+ * tee_device_unregister() need to be called to remove the @teedev if
+ * this function fails.
+ *
+ * @returns < 0 on failure
+ */
+int tee_device_register(struct tee_device *teedev)
+{
+	int rc;
+
+	if (teedev->flags & TEE_DEVICE_FLAG_REGISTERED) {
+		dev_err(&teedev->dev, "attempt to register twice\n");
+		return -EINVAL;
+	}
+
+	rc = cdev_add(&teedev->cdev, teedev->dev.devt, 1);
+	if (rc) {
+		dev_err(&teedev->dev,
+			"unable to cdev_add() %s, major %d, minor %d, err=%d\n",
+			teedev->name, MAJOR(teedev->dev.devt),
+			MINOR(teedev->dev.devt), rc);
+		return rc;
+	}
+
+	rc = device_add(&teedev->dev);
+	if (rc) {
+		dev_err(&teedev->dev,
+			"unable to device_add() %s, major %d, minor %d, err=%d\n",
+			teedev->name, MAJOR(teedev->dev.devt),
+			MINOR(teedev->dev.devt), rc);
+		goto err_device_add;
+	}
+
+	rc = sysfs_create_group(&teedev->dev.kobj, &tee_dev_group);
+	if (rc) {
+		dev_err(&teedev->dev,
+			"failed to create sysfs attributes, err=%d\n", rc);
+		goto err_sysfs_create_group;
+	}
+
+	teedev->flags |= TEE_DEVICE_FLAG_REGISTERED;
+	//cloud test 
+#if defined(CONFIG_RTK_HDCPRX_2P2_TEE) || defined(CONFIG_RTK_HDCPRX_1P4_TEE)
+	pr_err("tee_device_register sucess!!!!!!!");
+	TEE2p1_Flag = 1;
+#endif
+	return 0;
+
+err_sysfs_create_group:
+	device_del(&teedev->dev);
+err_device_add:
+	cdev_del(&teedev->cdev);
+	return rc;
+}
+EXPORT_SYMBOL_GPL(tee_device_register);
+
+void tee_device_put(struct tee_device *teedev)
+{
+	mutex_lock(&teedev->mutex);
+	/* Shouldn't put in this state */
+	if (!WARN_ON(!teedev->desc)) {
+		teedev->num_users--;
+		if (!teedev->num_users) {
+			teedev->desc = NULL;
+			complete(&teedev->c_no_users);
+		}
+	}
+	mutex_unlock(&teedev->mutex);
+}
+
+bool tee_device_get(struct tee_device *teedev)
+{
+	mutex_lock(&teedev->mutex);
+	if (!teedev->desc) {
+		mutex_unlock(&teedev->mutex);
+		return false;
+	}
+	teedev->num_users++;
+	mutex_unlock(&teedev->mutex);
+	return true;
+}
+
+/**
+ * tee_device_unregister() - Removes a TEE device
+ * @teedev:	Device to unregister
+ *
+ * This function should be called to remove the @teedev even if
+ * tee_device_register() hasn't been called yet. Does nothing if
+ * @teedev is NULL.
+ */
+void tee_device_unregister(struct tee_device *teedev)
+{
+	if (!teedev)
+		return;
+
+	if (teedev->flags & TEE_DEVICE_FLAG_REGISTERED) {
+		sysfs_remove_group(&teedev->dev.kobj, &tee_dev_group);
+		cdev_del(&teedev->cdev);
+		device_del(&teedev->dev);
+	}
+
+	tee_device_put(teedev);
+	wait_for_completion(&teedev->c_no_users);
+
+	/*
+	 * No need to take a mutex any longer now since teedev->desc was
+	 * set to NULL before teedev->c_no_users was completed.
+	 */
+
+	teedev->pool = NULL;
+
+	put_device(&teedev->dev);
+}
+EXPORT_SYMBOL_GPL(tee_device_unregister);
+
+/**
+ * tee_get_drvdata() - Return driver_data pointer
+ * @teedev:	Device containing the driver_data pointer
+ * @returns the driver_data pointer supplied to tee_register().
+ */
+void *tee_get_drvdata(struct tee_device *teedev)
+{
+	return dev_get_drvdata(&teedev->dev);
+}
+EXPORT_SYMBOL_GPL(tee_get_drvdata);
+
+#ifdef CONFIG_RTK_PLATFORM
+
+struct match_dev_data {
+	struct tee_ioctl_version_data *vers;
+	const void *data;
+	int (*match)(struct tee_ioctl_version_data *, const void *);
+};
+
+static int match_dev(struct device *dev, const void *data)
+{
+	const struct match_dev_data *match_data = data;
+	struct tee_device *teedev = container_of(dev, struct tee_device, dev);
+
+	teedev->desc->ops->get_version(teedev, match_data->vers);
+	return match_data->match(match_data->vers, match_data->data);
+}
+
+struct tee_context *tee_client_open_context(struct tee_context *start,
+	int (*match)(struct tee_ioctl_version_data *,
+	const void *),
+	const void *data, struct tee_ioctl_version_data *vers)
+{
+	struct device *dev = NULL;
+	struct device *put_dev = NULL;
+	struct tee_context *ctx = NULL;
+	struct tee_ioctl_version_data v;
+	struct match_dev_data match_data = { vers ? vers : &v, data, match };
+
+	if (start)
+		dev = &start->teedev->dev;
+
+	do {
+		dev = class_find_device(tee_class, dev, &match_data, match_dev);
+		if (!dev) {
+			ctx = ERR_PTR(-ENOENT);
+			break;
+		}
+
+		put_device(put_dev);
+		put_dev = dev;
+
+		ctx = teedev_open(container_of(dev, struct tee_device, dev));
+	} while (IS_ERR(ctx) && PTR_ERR(ctx) != -ENOMEM);
+
+	put_device(put_dev);
+	return ctx;
+}
+EXPORT_SYMBOL_GPL(tee_client_open_context);
+
+void tee_client_close_context(struct tee_context *ctx)
+{
+	teedev_close_context(ctx);
+}
+
+EXPORT_SYMBOL_GPL(tee_client_close_context);
+
+void tee_client_get_version(struct tee_context *ctx,
+	struct tee_ioctl_version_data *vers)
+{
+	ctx->teedev->desc->ops->get_version(ctx->teedev, vers);
+}
+EXPORT_SYMBOL_GPL(tee_client_get_version);
+
+
+int tee_client_open_session(struct tee_context *ctx,
+	struct tee_ioctl_open_session_arg *arg,
+	struct tee_param *param)
+{
+	if (!ctx->teedev->desc->ops->open_session)
+		return -EINVAL;
+	return ctx->teedev->desc->ops->open_session(ctx, arg, param);
+}
+EXPORT_SYMBOL_GPL(tee_client_open_session);
+
+int tee_client_close_session(struct tee_context *ctx, u32 session)
+{
+	if (!ctx->teedev->desc->ops->close_session)
+		return -EINVAL;
+	return ctx->teedev->desc->ops->close_session(ctx, session);
+}
+EXPORT_SYMBOL_GPL(tee_client_close_session);
+
+int tee_client_invoke_func(struct tee_context *ctx,
+	struct tee_ioctl_invoke_arg *arg,
+	struct tee_param *param)
+{
+	if (!ctx->teedev->desc->ops->invoke_func)
+		return -EINVAL;
+	return ctx->teedev->desc->ops->invoke_func(ctx, arg, param);
+}
+EXPORT_SYMBOL_GPL(tee_client_invoke_func);
+
+#endif /* CONFIG_RTK_PLATFORM */
+
+static int __init tee_init(void)
+{
+	int rc;
+
+	tee_class = class_create(THIS_MODULE, "tee");
+	if (IS_ERR(tee_class)) {
+		pr_err("couldn't create class\n");
+		return PTR_ERR(tee_class);
+	}
+
+	rc = alloc_chrdev_region(&tee_devt, 0, TEE_NUM_DEVICES, "tee");
+	if (rc) {
+		pr_err("failed to allocate char dev region\n");
+		class_destroy(tee_class);
+		tee_class = NULL;
+	}
+
+	return rc;
+}
+
+static void __exit tee_exit(void)
+{
+	class_destroy(tee_class);
+	tee_class = NULL;
+	unregister_chrdev_region(tee_devt, TEE_NUM_DEVICES);
+}
+
+subsys_initcall(tee_init);
+module_exit(tee_exit);
+
+MODULE_AUTHOR("Linaro");
+MODULE_DESCRIPTION("TEE Driver");
+MODULE_VERSION("1.0");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/tee/tee_hdcp14_api.c b/drivers/tee/tee_hdcp14_api.c
new file mode 100644
index 00000000..f55e600
--- /dev/null
+++ b/drivers/tee/tee_hdcp14_api.c
@@ -0,0 +1,798 @@
+#include <linux/cdev.h>
+#include <linux/device.h>
+#include <linux/fs.h>
+#include <linux/idr.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include <linux/uaccess.h>
+#include "tee_private.h"
+#include "tee_client_api.h"
+
+#define TA_HDCPTX14_UUID { 0x87ef28e8, 0xf581, 0x4e3d, \
+		{ 0xb2, 0xb2, 0xd7, 0xe3, 0xd4, 0x8b, 0x23, 0x21} }
+
+#define HDCP14_AN_CMD_LEN		8
+#define HDCP14_BKSV_CMD_LEN		5
+#define HDCP_AKSV_SIZE			5
+
+#define HDCP14_PK_SIZE	280
+
+#define MAX_SHA_DATA_SIZE       645
+#define MAX_SHA_VPRIME_SIZE     20
+
+#define HDCP14_PARAM_KEY_SIZE   288
+
+#define TEE_IOCTL_UUID_LEN		16
+
+enum HDCP14_CMD_FOR_TA {
+	TA_TEE_HDCP14_GenAn			= 0x1,
+	TA_TEE_HDCP14_WriteBKSV		= 0x2,
+	TA_TEE_HDCP14_SetRepeaterBitInTx	= 0x3,
+	TA_TEE_HDCP14_CheckRepeaterBitInTx	= 0x4,
+	TA_TEE_HDCP14_SetEnc		= 0x5,
+	TA_TEE_HDCP14_SetWinderWin	= 0x6,
+	TA_TEE_HDCP14_EnRi			= 0x7,
+	TA_TEE_HDCP14_SetAVMute		= 0x8,
+	TA_TEE_HDCP14_SHAAppend		= 0x9,
+	TA_TEE_HDCP14_ComputeV		= 0xa,
+	TA_TEE_HDCP14_VerifyV		= 0xb,
+	TA_TEE_HDCP14_CheckR0		= 0xc,
+	TA_TEE_HDCP14_GetAKSV		= 0xd,
+	TA_TEE_HDCP14_GetCtrlState	= 0xe,
+	TA_TEE_HDCP14_SetParamKey	= 0xf,
+	TA_TEE_HDCP14_Fix480P       = 0x10,
+};
+
+enum hdcp_repeater {
+	HDCP_RECEIVER = 0,
+	HDCP_REPEATER = 1
+};
+
+enum encryption_state {
+	HDCP_ENC_OFF = 0x0,
+	HDCP_ENC_ON  = 0x1
+};
+
+enum ri_state {
+	HDCP_RI_OFF = 0x0,
+	HDCP_RI_ON  = 0x1
+};
+
+enum av_mute {
+	AV_MUTE_SET = 0x01,
+	AV_MUTE_CLEAR = 0x10
+};
+
+struct hdcp_sha_in {
+	uint8_t data[MAX_SHA_DATA_SIZE];
+	uint32_t byte_counter;
+	uint8_t vprime[MAX_SHA_VPRIME_SIZE];
+};
+
+static int init_ta_flag = 0;
+struct tee_ioctl_open_session_arg arg;
+struct tee_param  param[4];
+struct tee_context *ctx;
+
+int ta_hdcp_lib_get_aksv(uint8_t *aksv);
+
+static void uuid_to_octets(uint8_t d[TEE_IOCTL_UUID_LEN], const TEEC_UUID *s)
+{
+	d[0] = s->timeLow >> 24;
+	d[1] = s->timeLow >> 16;
+	d[2] = s->timeLow >> 8;
+	d[3] = s->timeLow;
+	d[4] = s->timeMid >> 8;
+	d[5] = s->timeMid;
+	d[6] = s->timeHiAndVersion >> 8;
+	d[7] = s->timeHiAndVersion;
+	memcpy(d + 8, s->clockSeqAndNode, sizeof(s->clockSeqAndNode));
+}
+
+static int hdcp_optee_match(struct tee_ioctl_version_data *data,
+	const void *vers)
+{
+	return 1;
+}
+
+void ta_hdcp14_init(void)
+{
+	int ret;
+	struct tee_ioctl_version_data vers = {
+		.impl_id = TEE_OPTEE_CAP_TZ,
+		.impl_caps = TEE_IMPL_ID_OPTEE,
+		.gen_caps = TEE_GEN_CAP_GP,
+	};
+
+	if (init_ta_flag == 1)
+		return;
+	else
+		init_ta_flag = 1;
+
+	pr_err("[TEE_HDCPTX] %s\n", __func__);
+
+	const TEEC_UUID test_id = TA_HDCPTX14_UUID;
+
+	ctx = tee_client_open_context(NULL, hdcp_optee_match, NULL, &vers);
+
+	if (IS_ERR(ctx))
+		pr_err("%s fail\n", __func__);
+
+	uuid_to_octets((uint8_t *)&arg.uuid, &test_id);
+
+	arg.clnt_login = TEEC_LOGIN_PUBLIC;
+	arg.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("UUID = %x ,%x ,%x\n", arg.uuid[0], arg.uuid[1], arg.uuid[2]);
+	pr_err("Before session = %x\n", arg.session);
+#endif
+	ret = tee_client_open_session(ctx, &arg, param);
+	if (ret)
+		pr_err("%s open session fail\n", __func__);
+	/* pr_err("After  session  = %x\n", arg.session); */
+}
+
+void ta_hdcp14_deinit(void)
+{
+	if (init_ta_flag == 0)
+		return;
+	else
+		init_ta_flag = 0;
+
+	pr_err("[TEE_HDCPTX] %s\n", __func__);
+
+	if (ctx == NULL)
+		return;
+
+	tee_client_close_session(ctx, arg.session);
+	tee_client_close_context(ctx);
+	ctx = NULL;
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_generate_an (Generate An using HDCP HW)
+ *-----------------------------------------------------------------------------
+ */
+int ta_hdcp_lib_generate_an(uint8_t *an)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	struct tee_shm *shm;
+
+	arg_I.func = TA_TEE_HDCP14_GenAn;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+	shm = tee_shm_alloc(ctx, HDCP14_AN_CMD_LEN, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_generate_an.\n");
+#endif
+	invoke_param[0].u.memref.size = HDCP14_AN_CMD_LEN;
+	invoke_param[0].u.memref.shm = shm;
+
+	memcpy(invoke_param[0].u.memref.shm->kaddr, an, HDCP14_AN_CMD_LEN);
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	memcpy(an, invoke_param[0].u.memref.shm->kaddr, HDCP14_AN_CMD_LEN);
+
+	tee_shm_free(shm);
+	kfree(invoke_param);
+
+	return 0;/* HDCP_OK */
+}
+
+/*-----------------------------------------------------------------------------
+ * Function: hdcp_lib_get_aksv from RPMB
+ *-----------------------------------------------------------------------------
+ */
+int ta_hdcp_lib_get_aksv(uint8_t *aksv)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+	unsigned int check_val = 0;
+	struct tee_shm *shm;
+
+	arg_I.func = TA_TEE_HDCP14_GetAKSV;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+	shm = tee_shm_alloc(ctx, HDCP_AKSV_SIZE, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_get_aksv.\n");
+#endif
+	invoke_param[0].u.memref.size = HDCP_AKSV_SIZE;
+	invoke_param[0].u.memref.shm = shm;
+
+	memcpy(invoke_param[0].u.memref.shm->kaddr, aksv, HDCP_AKSV_SIZE);
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	check_val = invoke_param[1].u.value.a;
+	memcpy(aksv, invoke_param[0].u.memref.shm->kaddr, HDCP_AKSV_SIZE);
+
+	tee_shm_free(shm);
+	kfree(invoke_param);
+	/* pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_get_aksv: %d\n", check_val); */
+	return check_val;
+}
+
+int ta_hdcp_lib_write_bksv(uint8_t *ksv_data)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	struct tee_shm *shm;
+	struct tee_shm *shm1;
+
+	arg_I.func = TA_TEE_HDCP14_WriteBKSV;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+	shm = tee_shm_alloc(ctx, HDCP14_BKSV_CMD_LEN, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_write_bksv.\n");
+#endif
+	invoke_param[0].u.memref.size = HDCP14_BKSV_CMD_LEN;
+	invoke_param[0].u.memref.shm = shm;
+
+	memcpy(invoke_param[0].u.memref.shm->kaddr, ksv_data, HDCP14_BKSV_CMD_LEN);
+
+	shm1 = tee_shm_alloc(ctx, HDCP14_PK_SIZE, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm1))
+		return PTR_ERR(shm1);
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_write_bksv pk.\n");
+#endif
+	invoke_param[1].u.memref.size = HDCP14_PK_SIZE;
+	invoke_param[1].u.memref.shm = shm1;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	memcpy(ksv_data, invoke_param[0].u.memref.shm->kaddr, HDCP14_BKSV_CMD_LEN);
+
+	tee_shm_free(shm);
+	tee_shm_free(shm1);
+	kfree(invoke_param);
+
+	return 0;/* HDCP_OK */
+}
+
+void ta_hdcp_lib_set_repeater_bit_in_tx(enum hdcp_repeater rx_mode)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	arg_I.func = TA_TEE_HDCP14_SetRepeaterBitInTx;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_set_repeater_bit_in_tx.\n");
+#endif
+	invoke_param[0].u.value.a = rx_mode;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	kfree(invoke_param);
+}
+
+int ta_hdcp_lib_check_repeater_bit_in_tx(void)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+	unsigned int check_val = 0;
+
+	arg_I.func = TA_TEE_HDCP14_CheckRepeaterBitInTx;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_check_repeater_bit_in_tx.\n");
+#endif
+	invoke_param[0].u.value.a = 0;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+	check_val = invoke_param[0].u.value.a;
+
+	kfree(invoke_param);
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_check_repeater_bit_in_tx: %d\n",
+		check_val);
+#endif
+
+	return check_val;
+}
+
+void ta_hdcp_lib_set_encryption(enum encryption_state enc_state)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	arg_I.func = TA_TEE_HDCP14_SetEnc;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_set_encryption.\n");
+#endif
+	invoke_param[0].u.value.a = enc_state;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	kfree(invoke_param);
+}
+
+void ta_hdcp_lib_set_wider_window(void)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	arg_I.func = TA_TEE_HDCP14_SetWinderWin;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return;
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_set_wider_window.\n");
+#endif
+	invoke_param[0].u.value.a = 1;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	kfree(invoke_param);
+}
+
+void ta_hdcp_lib_set_ri(enum ri_state ri_state)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	arg_I.func = TA_TEE_HDCP14_EnRi;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_set_ri.\n");
+#endif
+	invoke_param[0].u.value.a = ri_state;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	kfree(invoke_param);
+}
+
+void ta_hdcp_lib_set_av_mute(enum av_mute av_mute_state)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	arg_I.func = TA_TEE_HDCP14_SetAVMute;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_set_av_mute.\n");
+#endif
+	invoke_param[0].u.value.a = av_mute_state;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	kfree(invoke_param);
+}
+
+int ta_hdcp_lib_SHA_append_bstatus_M0(struct hdcp_sha_in *sha, uint8_t *bstatus)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	struct tee_shm *shm;
+	struct tee_shm *shm1;
+
+	arg_I.func = TA_TEE_HDCP14_SHAAppend;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+	shm = tee_shm_alloc(ctx, MAX_SHA_DATA_SIZE, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_SHA_append.\n");
+#endif
+	invoke_param[0].u.memref.size = MAX_SHA_DATA_SIZE;
+	invoke_param[0].u.memref.shm = shm;
+
+	memcpy(invoke_param[0].u.memref.shm->kaddr, sha->data, MAX_SHA_DATA_SIZE);
+
+	shm1 = tee_shm_alloc(ctx, 2, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm1))
+		return PTR_ERR(shm1);
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_SHA_append bstaus.\n");
+#endif
+
+	invoke_param[1].u.memref.size = 2;
+	invoke_param[1].u.memref.shm = shm1;
+
+	memcpy(invoke_param[1].u.memref.shm->kaddr, bstatus, 2);
+
+	invoke_param[2].u.value.a = sha->byte_counter;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   sha->byte_counter bef: %d\n",
+		invoke_param[2].u.value.a);
+#endif
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	sha->byte_counter = invoke_param[2].u.value.a;
+	memcpy(sha->data, invoke_param[0].u.memref.shm->kaddr, MAX_SHA_DATA_SIZE);
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   sha->byte_counter aft: %d\n",
+		invoke_param[2].u.value.a);
+#endif
+
+	tee_shm_free(shm);
+	tee_shm_free(shm1);
+	kfree(invoke_param);
+
+	return 0;/* HDCP_OK */
+}
+
+int ta_hdcp_lib_compute_V(struct hdcp_sha_in *sha)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	struct tee_shm *shm;
+
+	int ret = 0;
+
+	arg_I.func = TA_TEE_HDCP14_ComputeV;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+	shm = tee_shm_alloc(ctx, MAX_SHA_DATA_SIZE, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_compute_V.\n");
+#endif
+	invoke_param[0].u.memref.size = MAX_SHA_DATA_SIZE;
+	invoke_param[0].u.memref.shm = shm;
+
+	memcpy(invoke_param[0].u.memref.shm->kaddr, sha->data, MAX_SHA_DATA_SIZE);
+
+	invoke_param[1].u.value.a = sha->byte_counter;
+	invoke_param[1].u.value.b = 0;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   return invoke_param[1].u.value.b: %d\n",
+		invoke_param[1].u.value.b);
+#endif
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	sha->byte_counter = invoke_param[1].u.value.a;
+	memcpy(sha->data, invoke_param[0].u.memref.shm->kaddr, MAX_SHA_DATA_SIZE);
+
+	ret = invoke_param[1].u.value.b;
+
+	tee_shm_free(shm);
+	kfree(invoke_param);
+
+	return ret;
+}
+
+int ta_hdcp_lib_verify_V(struct hdcp_sha_in *sha)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	struct tee_shm *shm;
+	int ret = 0;
+
+	arg_I.func = TA_TEE_HDCP14_VerifyV;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+	shm = tee_shm_alloc(ctx, MAX_SHA_VPRIME_SIZE, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_verify_V.\n");
+#endif
+	invoke_param[0].u.memref.size = MAX_SHA_DATA_SIZE;
+	invoke_param[0].u.memref.shm = shm;
+
+	memcpy(invoke_param[0].u.memref.shm->kaddr, sha->vprime, MAX_SHA_VPRIME_SIZE);
+
+	invoke_param[1].u.value.a = 0;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	memcpy(sha->vprime, invoke_param[0].u.memref.shm->kaddr, MAX_SHA_VPRIME_SIZE);
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   return invoke_param[1].u.value.a: %d\n",
+		invoke_param[1].u.value.a);
+#endif
+	ret = invoke_param[1].u.value.a;
+
+	tee_shm_free(shm);
+	kfree(invoke_param);
+
+	return ret;
+}
+
+int ta_hdcp_get_ctrl_state(unsigned char select)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+	int ret_val;
+
+	arg_I.func = TA_TEE_HDCP14_GetCtrlState;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_get_ctrl_state.\n");
+#endif
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	if (select == 0)
+		ret_val = invoke_param[0].u.value.a;
+	else
+		ret_val = invoke_param[1].u.value.a;
+
+	kfree(invoke_param);
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_get_ctrl_state: hdcp_en=%u hdcp22=%u\n",
+			(unsigned int)invoke_param[0].u.value.a, (unsigned int)invoke_param[1].u.value.a);
+#endif
+
+	return ret_val;
+}
+
+int ta_hdcp_set_param_key(unsigned char *param_key)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+	int ret_val;
+	struct tee_shm *shm;
+
+	arg_I.func = TA_TEE_HDCP14_SetParamKey;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+	shm = tee_shm_alloc(ctx, HDCP14_PARAM_KEY_SIZE, TEE_SHM_MAPPED | TEE_SHM_DMA_BUF);
+	if (IS_ERR(shm))
+		return PTR_ERR(shm);
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_set_param_key.\n");
+#endif
+
+	invoke_param[0].u.memref.size = HDCP14_PARAM_KEY_SIZE;
+	invoke_param[0].u.memref.shm = shm;
+
+	memcpy(invoke_param[0].u.memref.shm->kaddr, param_key, HDCP14_PARAM_KEY_SIZE);
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_OUTPUT;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	ret_val = invoke_param[1].u.value.a;
+
+	kfree(invoke_param);
+
+	return ret_val;
+}
+
+int ta_hdcp_fix480p(void)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+	int ret_val;
+
+	arg_I.func = TA_TEE_HDCP14_Fix480P;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return -ENOMEM;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_fix480p.\n");
+#endif
+
+	invoke_param[0].u.value.a = 0;/* Reserved */
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	ret_val = invoke_param[0].u.value.a;
+
+	kfree(invoke_param);
+
+	return ret_val;
+}
diff --git a/drivers/tee/tee_i2c_api.c b/drivers/tee/tee_i2c_api.c
new file mode 100644
index 00000000..e2309bd
--- /dev/null
+++ b/drivers/tee/tee_i2c_api.c
@@ -0,0 +1,113 @@
+#include <linux/cdev.h>
+#include <linux/device.h>
+#include <linux/fs.h>
+#include <linux/idr.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include <linux/uaccess.h>
+#include "tee_private.h"
+#include "tee_client_api.h"
+
+//#define TA_I2C_UUID { 0x7e67f57e, 0xab68, 0x4caf, \
+//		{ 0xb1, 0x5e, 0xd1, 0xc9, 0xa4, 0xb3, 0x10, 0xc1} }
+
+//#define TA_I2C_ENABLE_VALUE 0xff
+
+#define TA_I2C_UUID \
+{ 0x650b79a1, 0xa79a, 0x43ea, \
+{ 0x91, 0x85, 0xf6, 0x67, 0x55, 0x65, 0x64, 0xa7 } }
+
+#define TA_I2C_ENABLE_VALUE 0
+
+static struct tee_ioctl_open_session_arg arg;
+static struct tee_param  param[4];
+static struct tee_context *ctx;
+
+static void uuid_to_octets(uint8_t d[TEE_IOCTL_UUID_LEN], const TEEC_UUID *s)
+{
+	d[0] = s->timeLow >> 24;
+	d[1] = s->timeLow >> 16;
+	d[2] = s->timeLow >> 8;
+	d[3] = s->timeLow;
+	d[4] = s->timeMid >> 8;
+	d[5] = s->timeMid;
+	d[6] = s->timeHiAndVersion >> 8;
+	d[7] = s->timeHiAndVersion;
+	memcpy(d + 8, s->clockSeqAndNode, sizeof(s->clockSeqAndNode));
+}
+
+static int hdcp_optee_match(struct tee_ioctl_version_data *data,
+	const void *vers)
+{
+	return 1;
+}
+
+void ta_i2c_init(void)
+{
+	int ret;
+	struct tee_ioctl_version_data vers = {
+		.impl_id = TEE_OPTEE_CAP_TZ,
+		.impl_caps = TEE_IMPL_ID_OPTEE,
+		.gen_caps = TEE_GEN_CAP_GP,
+	};
+
+	pr_err("[TEE_KERNEL_DBG]   ta_i2c_init. teeos v2.5\n");
+
+	const TEEC_UUID test_id = TA_I2C_UUID;
+
+	ctx = tee_client_open_context(NULL, hdcp_optee_match, NULL, &vers);
+
+	if (IS_ERR(ctx))
+		pr_err("%s fail\n", __func__);
+
+	uuid_to_octets((uint8_t *)&arg.uuid, &test_id);
+
+	arg.clnt_login = TEEC_LOGIN_PUBLIC;
+	arg.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("UUID = %x ,%x ,%x\n", arg.uuid[0], arg.uuid[1], arg.uuid[2]);
+	pr_err("Before session = %x\n", arg.session);
+#endif
+	ret = tee_client_open_session(ctx, &arg, param);
+	if (ret)
+		pr_err("%s open session fail\n", __func__);
+	/* pr_err("After  session  = %x\n", arg.session); */
+}
+
+void ta_hdcp_lib_set_i2c_enable(unsigned int  i2c_enable_value)
+{
+	struct tee_param *invoke_param = NULL;
+	struct tee_ioctl_invoke_arg arg_I;
+
+	arg_I.func = TA_I2C_ENABLE_VALUE;
+	arg_I.session = arg.session;
+	arg_I.num_params = TEEC_CONFIG_PAYLOAD_REF_COUNT;
+
+	invoke_param = kcalloc(TEEC_CONFIG_PAYLOAD_REF_COUNT,
+		sizeof(struct tee_param), GFP_KERNEL);
+
+	if (!invoke_param)
+		return;
+
+#ifdef KERNEL_TA_DBG
+	pr_err("[TEE_KERNEL_DBG]   ta_hdcp_lib_set_i2c_enable.\n");
+#endif
+	invoke_param[0].u.value.a = i2c_enable_value;
+
+	invoke_param[0].attr = TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT;
+	invoke_param[1].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[2].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+	invoke_param[3].attr = TEE_IOCTL_PARAM_ATTR_TYPE_NONE;
+
+	tee_client_invoke_func(ctx, &arg_I, invoke_param);
+
+	kfree(invoke_param);
+}
+
diff --git a/drivers/tee/tee_private.h b/drivers/tee/tee_private.h
new file mode 100644
index 00000000..85d99d6
--- /dev/null
+++ b/drivers/tee/tee_private.h
@@ -0,0 +1,79 @@
+/*
+ * Copyright (c) 2015-2016, Linaro Limited
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+#ifndef TEE_PRIVATE_H
+#define TEE_PRIVATE_H
+
+#include <linux/cdev.h>
+#include <linux/completion.h>
+#include <linux/device.h>
+#include <linux/kref.h>
+#include <linux/mutex.h>
+#include <linux/types.h>
+
+/**
+ * struct tee_shm_pool - shared memory pool
+ * @private_mgr:	pool manager for shared memory only between kernel
+ *			and secure world
+ * @dma_buf_mgr:	pool manager for shared memory exported to user space
+ */
+struct tee_shm_pool {
+	struct tee_shm_pool_mgr *private_mgr;
+	struct tee_shm_pool_mgr *dma_buf_mgr;
+};
+
+#define TEE_DEVICE_FLAG_REGISTERED	0x1
+#define TEE_MAX_DEV_NAME_LEN		32
+
+/**
+ * struct tee_device - TEE Device representation
+ * @name:	name of device
+ * @desc:	description of device
+ * @id:		unique id of device
+ * @flags:	represented by TEE_DEVICE_FLAG_REGISTERED above
+ * @dev:	embedded basic device structure
+ * @cdev:	embedded cdev
+ * @num_users:	number of active users of this device
+ * @c_no_user:	completion used when unregistering the device
+ * @mutex:	mutex protecting @num_users and @idr
+ * @idr:	register of shared memory object allocated on this device
+ * @pool:	shared memory pool
+ */
+struct tee_device {
+	char name[TEE_MAX_DEV_NAME_LEN];
+	const struct tee_desc *desc;
+	int id;
+	unsigned int flags;
+
+	struct device dev;
+	struct cdev cdev;
+
+	size_t num_users;
+	struct completion c_no_users;
+	struct mutex mutex;	/* protects num_users and idr */
+
+	struct idr idr;
+	struct tee_shm_pool *pool;
+};
+
+int tee_shm_init(void);
+
+int tee_shm_get_fd(struct tee_shm *shm);
+
+bool tee_device_get(struct tee_device *teedev);
+void tee_device_put(struct tee_device *teedev);
+
+void teedev_ctx_get(struct tee_context *ctx);
+void teedev_ctx_put(struct tee_context *ctx);
+
+#endif /*TEE_PRIVATE_H*/
diff --git a/drivers/tee/tee_shm.c b/drivers/tee/tee_shm.c
new file mode 100644
index 00000000..75473db3
--- /dev/null
+++ b/drivers/tee/tee_shm.c
@@ -0,0 +1,623 @@
+/*
+ * Copyright (c) 2015-2016, Linaro Limited
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+#include <linux/device.h>
+#include <linux/dma-buf.h>
+#include <linux/fdtable.h>
+#include <linux/idr.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include "tee_private.h"
+
+/* extra references appended to shm object for registered shared memory */
+struct tee_shm_dmabuf_ref {
+     struct tee_shm shm;
+     struct dma_buf *dmabuf;
+     struct dma_buf_attachment *attach;
+     struct sg_table *sgt;
+};
+
+static void tee_shm_release(struct tee_shm *shm)
+{
+	struct tee_device *teedev = shm->teedev;
+
+	mutex_lock(&teedev->mutex);
+	idr_remove(&teedev->idr, shm->id);
+	if (shm->ctx)
+		list_del(&shm->link);
+	mutex_unlock(&teedev->mutex);
+
+	if (shm->flags & TEE_SHM_EXT_DMA_BUF) {
+		struct tee_shm_dmabuf_ref *ref;
+
+		ref = container_of(shm, struct tee_shm_dmabuf_ref, shm);
+		dma_buf_unmap_attachment(ref->attach, ref->sgt,
+					 DMA_BIDIRECTIONAL);
+		dma_buf_detach(shm->dmabuf, ref->attach);
+		dma_buf_put(ref->dmabuf);
+	} else if (shm->flags & TEE_SHM_POOL) {
+		struct tee_shm_pool_mgr *poolm;
+
+		if (shm->flags & TEE_SHM_DMA_BUF)
+			poolm = teedev->pool->dma_buf_mgr;
+		else
+			poolm = teedev->pool->private_mgr;
+
+		poolm->ops->free(poolm, shm);
+	} else if (shm->flags & TEE_SHM_REGISTER) {
+		size_t n;
+		int rc = teedev->desc->ops->shm_unregister(shm->ctx, shm);
+
+		if (rc)
+			dev_err(teedev->dev.parent,
+				"unregister shm %p failed: %d", shm, rc);
+
+		for (n = 0; n < shm->num_pages; n++)
+			put_page(shm->pages[n]);
+
+		kfree(shm->pages);
+	}
+
+	if (shm->ctx)
+		teedev_ctx_put(shm->ctx);
+
+	kfree(shm);
+
+	tee_device_put(teedev);
+}
+
+static struct sg_table *tee_shm_op_map_dma_buf(struct dma_buf_attachment
+			*attach, enum dma_data_direction dir)
+{
+	return NULL;
+}
+
+static void tee_shm_op_unmap_dma_buf(struct dma_buf_attachment *attach,
+				     struct sg_table *table,
+				     enum dma_data_direction dir)
+{
+}
+
+static void tee_shm_op_release(struct dma_buf *dmabuf)
+{
+	struct tee_shm *shm = dmabuf->priv;
+
+	tee_shm_release(shm);
+}
+
+static void *tee_shm_op_kmap_atomic(struct dma_buf *dmabuf, unsigned long pgnum)
+{
+	return NULL;
+}
+
+static void *tee_shm_op_kmap(struct dma_buf *dmabuf, unsigned long pgnum)
+{
+	return NULL;
+}
+
+static int tee_shm_op_mmap(struct dma_buf *dmabuf, struct vm_area_struct *vma)
+{
+	struct tee_shm *shm = dmabuf->priv;
+	size_t size = vma->vm_end - vma->vm_start;
+
+	/* Refuse sharing shared memory provided by application */
+	if (shm->flags & TEE_SHM_REGISTER)
+		return -EINVAL;
+
+	return remap_pfn_range(vma, vma->vm_start, shm->paddr >> PAGE_SHIFT,
+			       size, vma->vm_page_prot);
+}
+
+static const struct dma_buf_ops tee_shm_dma_buf_ops = {
+	.map_dma_buf = tee_shm_op_map_dma_buf,
+	.unmap_dma_buf = tee_shm_op_unmap_dma_buf,
+	.release = tee_shm_op_release,
+	.kmap_atomic = tee_shm_op_kmap_atomic,
+	.kmap = tee_shm_op_kmap,
+	.mmap = tee_shm_op_mmap,
+};
+
+static struct tee_shm *__tee_shm_alloc(struct tee_context *ctx,
+				       struct tee_device *teedev,
+				       size_t size, u32 flags)
+{
+	struct tee_shm_pool_mgr *poolm = NULL;
+	struct tee_shm *shm;
+	void *ret;
+	int rc;
+
+	if (ctx && ctx->teedev != teedev) {
+		dev_err(teedev->dev.parent, "ctx and teedev mismatch\n");
+		return ERR_PTR(-EINVAL);
+	}
+
+	if (!(flags & TEE_SHM_MAPPED)) {
+		dev_err(teedev->dev.parent,
+			"only mapped allocations supported\n");
+		return ERR_PTR(-EINVAL);
+	}
+
+	if ((flags & ~(TEE_SHM_MAPPED | TEE_SHM_DMA_BUF))) {
+		dev_err(teedev->dev.parent, "invalid shm flags 0x%x", flags);
+		return ERR_PTR(-EINVAL);
+	}
+
+	if (!tee_device_get(teedev))
+		return ERR_PTR(-EINVAL);
+
+	if (!teedev->pool) {
+		/* teedev has been detached from driver */
+		ret = ERR_PTR(-EINVAL);
+		goto err_dev_put;
+	}
+
+	shm = kzalloc(sizeof(*shm), GFP_KERNEL);
+	if (!shm) {
+		ret = ERR_PTR(-ENOMEM);
+		goto err_dev_put;
+	}
+
+	shm->flags = flags | TEE_SHM_POOL;
+	shm->teedev = teedev;
+	shm->ctx = ctx;
+	if (flags & TEE_SHM_DMA_BUF)
+		poolm = teedev->pool->dma_buf_mgr;
+	else
+		poolm = teedev->pool->private_mgr;
+
+	rc = poolm->ops->alloc(poolm, shm, size);
+	if (rc) {
+		ret = ERR_PTR(rc);
+		goto err_kfree;
+	}
+
+	mutex_lock(&teedev->mutex);
+	shm->id = idr_alloc(&teedev->idr, shm, 1, 0, GFP_KERNEL);
+	mutex_unlock(&teedev->mutex);
+	if (shm->id < 0) {
+		ret = ERR_PTR(shm->id);
+		goto err_pool_free;
+	}
+
+	if (flags & TEE_SHM_DMA_BUF) {
+		DEFINE_DMA_BUF_EXPORT_INFO(exp_info);
+
+		exp_info.ops = &tee_shm_dma_buf_ops;
+		exp_info.size = shm->size;
+		exp_info.flags = O_RDWR;
+		exp_info.priv = shm;
+
+		shm->dmabuf = dma_buf_export(&exp_info);
+		if (IS_ERR(shm->dmabuf)) {
+			ret = ERR_CAST(shm->dmabuf);
+			goto err_rem;
+		}
+	}
+
+	if (ctx) {
+		teedev_ctx_get(ctx);
+		mutex_lock(&teedev->mutex);
+		list_add_tail(&shm->link, &ctx->list_shm);
+		mutex_unlock(&teedev->mutex);
+	}
+
+	return shm;
+err_rem:
+	mutex_lock(&teedev->mutex);
+	idr_remove(&teedev->idr, shm->id);
+	mutex_unlock(&teedev->mutex);
+err_pool_free:
+	poolm->ops->free(poolm, shm);
+err_kfree:
+	kfree(shm);
+err_dev_put:
+	tee_device_put(teedev);
+	return ret;
+}
+
+/**
+ * tee_shm_alloc() - Allocate shared memory
+ * @ctx:	Context that allocates the shared memory
+ * @size:	Requested size of shared memory
+ * @flags:	Flags setting properties for the requested shared memory.
+ *
+ * Memory allocated as global shared memory is automatically freed when the
+ * TEE file pointer is closed. The @flags field uses the bits defined by
+ * TEE_SHM_* in <linux/tee_drv.h>. TEE_SHM_MAPPED must currently always be
+ * set. If TEE_SHM_DMA_BUF global shared memory will be allocated and
+ * associated with a dma-buf handle, else driver private memory.
+ */
+struct tee_shm *tee_shm_alloc(struct tee_context *ctx, size_t size, u32 flags)
+{
+	return __tee_shm_alloc(ctx, ctx->teedev, size, flags);
+}
+EXPORT_SYMBOL_GPL(tee_shm_alloc);
+
+struct tee_shm *tee_shm_priv_alloc(struct tee_device *teedev, size_t size)
+{
+	return __tee_shm_alloc(NULL, teedev, size, TEE_SHM_MAPPED);
+}
+EXPORT_SYMBOL_GPL(tee_shm_priv_alloc);
+
+struct tee_shm *tee_shm_register(struct tee_context *ctx, unsigned long addr,
+				 size_t length, u32 flags)
+{
+	struct tee_device *teedev = ctx->teedev;
+	const u32 req_flags = TEE_SHM_DMA_BUF | TEE_SHM_USER_MAPPED;
+	struct tee_shm *shm;
+	void *ret;
+	int rc;
+	int num_pages;
+	unsigned long start;
+
+	if (flags != req_flags)
+		return ERR_PTR(-ENOTSUPP);
+
+	if (!tee_device_get(teedev))
+		return ERR_PTR(-EINVAL);
+
+	if (!teedev->desc->ops->shm_register ||
+	    !teedev->desc->ops->shm_unregister) {
+		tee_device_put(teedev);
+		return ERR_PTR(-ENOTSUPP);
+	}
+
+	teedev_ctx_get(ctx);
+
+	shm = kzalloc(sizeof(*shm), GFP_KERNEL);
+	if (!shm) {
+		ret = ERR_PTR(-ENOMEM);
+		goto err;
+	}
+
+	shm->flags = flags | TEE_SHM_REGISTER;
+	shm->teedev = teedev;
+	shm->ctx = ctx;
+	shm->id = -1;
+	start = rounddown(addr, PAGE_SIZE);
+	shm->offset = addr - start;
+	shm->size = length;
+	num_pages = (roundup(addr + length, PAGE_SIZE) - start) / PAGE_SIZE;
+	shm->pages = kcalloc(num_pages, sizeof(*shm->pages), GFP_KERNEL);
+	if (!shm->pages) {
+		ret = ERR_PTR(-ENOMEM);
+		goto err;
+	}
+
+	rc = get_user_pages_fast(start, num_pages, 1, shm->pages);
+	if (rc > 0)
+		shm->num_pages = rc;
+	if (rc != num_pages) {
+		if (rc >= 0)
+			rc = -ENOMEM;
+		ret = ERR_PTR(rc);
+		goto err;
+	}
+
+	mutex_lock(&teedev->mutex);
+	shm->id = idr_alloc(&teedev->idr, shm, 1, 0, GFP_KERNEL);
+	mutex_unlock(&teedev->mutex);
+
+	if (shm->id < 0) {
+		ret = ERR_PTR(shm->id);
+		goto err;
+	}
+
+	rc = teedev->desc->ops->shm_register(ctx, shm, shm->pages,
+					     shm->num_pages, start);
+	if (rc) {
+		ret = ERR_PTR(rc);
+		goto err;
+	}
+
+	if (flags & TEE_SHM_DMA_BUF) {
+		DEFINE_DMA_BUF_EXPORT_INFO(exp_info);
+
+		exp_info.ops = &tee_shm_dma_buf_ops;
+		exp_info.size = shm->size;
+		exp_info.flags = O_RDWR;
+		exp_info.priv = shm;
+
+		shm->dmabuf = dma_buf_export(&exp_info);
+		if (IS_ERR(shm->dmabuf)) {
+			ret = ERR_CAST(shm->dmabuf);
+			teedev->desc->ops->shm_unregister(ctx, shm);
+			goto err;
+		}
+	}
+
+	mutex_lock(&teedev->mutex);
+	list_add_tail(&shm->link, &ctx->list_shm);
+	mutex_unlock(&teedev->mutex);
+
+	return shm;
+err:
+	if (shm) {
+		size_t n;
+
+		if (shm->id >= 0) {
+			mutex_lock(&teedev->mutex);
+			idr_remove(&teedev->idr, shm->id);
+			mutex_unlock(&teedev->mutex);
+		}
+		if (shm->pages) {
+			for (n = 0; n < shm->num_pages; n++)
+				put_page(shm->pages[n]);
+			kfree(shm->pages);
+		}
+	}
+	kfree(shm);
+	teedev_ctx_put(ctx);
+	tee_device_put(teedev);
+	return ret;
+}
+EXPORT_SYMBOL_GPL(tee_shm_register);
+
+struct tee_shm *tee_shm_register_fd(struct tee_context *ctx, int fd)
+{
+	struct tee_shm_dmabuf_ref *ref;
+	void *rc;
+	DEFINE_DMA_BUF_EXPORT_INFO(exp_info);
+
+	if (!tee_device_get(ctx->teedev))
+		return ERR_PTR(-EINVAL);
+
+	teedev_ctx_get(ctx);
+
+	ref = kzalloc(sizeof(*ref), GFP_KERNEL);
+	if (!ref) {
+		rc = ERR_PTR(-ENOMEM);
+		goto err;
+	}
+
+	ref->shm.ctx = ctx;
+	ref->shm.teedev = ctx->teedev;
+	ref->shm.id = -1;
+
+	ref->dmabuf = dma_buf_get(fd);
+	if (!ref->dmabuf) {
+		rc = ERR_PTR(-EINVAL);
+		goto err;
+	}
+
+	ref->attach = dma_buf_attach(ref->dmabuf, &ref->shm.teedev->dev);
+	if (IS_ERR_OR_NULL(ref->attach)) {
+		rc = ERR_PTR(-EINVAL);
+		goto err;
+	}
+
+	ref->sgt = dma_buf_map_attachment(ref->attach, DMA_BIDIRECTIONAL);
+	if (IS_ERR_OR_NULL(ref->sgt)) {
+		rc = ERR_PTR(-EINVAL);
+		goto err;
+	}
+
+	if (sg_nents(ref->sgt->sgl) != 1) {
+		rc = ERR_PTR(-EINVAL);
+		goto err;
+	}
+
+	ref->shm.paddr = sg_dma_address(ref->sgt->sgl);
+	ref->shm.size = sg_dma_len(ref->sgt->sgl);
+	ref->shm.flags = TEE_SHM_DMA_BUF | TEE_SHM_EXT_DMA_BUF;
+
+	mutex_lock(&ref->shm.teedev->mutex);
+	ref->shm.id = idr_alloc(&ref->shm.teedev->idr, &ref->shm,
+				1, 0, GFP_KERNEL);
+	mutex_unlock(&ref->shm.teedev->mutex);
+	if (ref->shm.id < 0) {
+		rc = ERR_PTR(ref->shm.id);
+		goto err;
+	}
+
+	/* export a dmabuf to later get a userland ref */
+	exp_info.ops = &tee_shm_dma_buf_ops;
+	exp_info.size = ref->shm.size;
+	exp_info.flags = O_RDWR;
+	exp_info.priv = &ref->shm;
+
+	ref->shm.dmabuf = dma_buf_export(&exp_info);
+	if (IS_ERR(ref->shm.dmabuf)) {
+		rc = ERR_PTR(-EINVAL);
+		goto err;
+	}
+
+	mutex_lock(&ref->shm.teedev->mutex);
+	list_add_tail(&ref->shm.link, &ctx->list_shm);
+	mutex_unlock(&ref->shm.teedev->mutex);
+
+	return &ref->shm;
+
+err:
+	if (ref) {
+		if (ref->shm.id >= 0) {
+			mutex_lock(&ctx->teedev->mutex);
+			idr_remove(&ctx->teedev->idr, ref->shm.id);
+			mutex_unlock(&ctx->teedev->mutex);
+		}
+		if (ref->sgt)
+			dma_buf_unmap_attachment(ref->attach, ref->sgt,
+						 DMA_BIDIRECTIONAL);
+		if (ref->attach)
+			dma_buf_detach(ref->dmabuf, ref->attach);
+		if (ref->dmabuf)
+			dma_buf_put(ref->dmabuf);
+	}
+	kfree(ref);
+	teedev_ctx_put(ctx);
+	tee_device_put(ctx->teedev);
+	return rc;
+}
+EXPORT_SYMBOL_GPL(tee_shm_register_fd);
+
+/**
+ * tee_shm_get_fd() - Increase reference count and return file descriptor
+ * @shm:	Shared memory handle
+ * @returns user space file descriptor to shared memory
+ */
+int tee_shm_get_fd(struct tee_shm *shm)
+{
+	int fd;
+
+	if (!(shm->flags & TEE_SHM_DMA_BUF))
+		return -EINVAL;
+
+	fd = dma_buf_fd(shm->dmabuf, O_CLOEXEC);
+	if (fd >= 0)
+		get_dma_buf(shm->dmabuf);
+	return fd;
+}
+
+/**
+ * tee_shm_free() - Free shared memory
+ * @shm:	Handle to shared memory to free
+ */
+void tee_shm_free(struct tee_shm *shm)
+{
+	/*
+	 * dma_buf_put() decreases the dmabuf reference counter and will
+	 * call tee_shm_release() when the last reference is gone.
+	 *
+	 * In the case of driver private memory we call tee_shm_release
+	 * directly instead as it doesn't have a reference counter.
+	 */
+	if (shm->flags & TEE_SHM_DMA_BUF)
+		dma_buf_put(shm->dmabuf);
+	else
+		tee_shm_release(shm);
+}
+EXPORT_SYMBOL_GPL(tee_shm_free);
+
+/**
+ * tee_shm_va2pa() - Get physical address of a virtual address
+ * @shm:	Shared memory handle
+ * @va:		Virtual address to tranlsate
+ * @pa:		Returned physical address
+ * @returns 0 on success and < 0 on failure
+ */
+int tee_shm_va2pa(struct tee_shm *shm, void *va, phys_addr_t *pa)
+{
+	if (!(shm->flags & TEE_SHM_MAPPED))
+		return -EINVAL;
+	/* Check that we're in the range of the shm */
+	if ((char *)va < (char *)shm->kaddr)
+		return -EINVAL;
+	if ((char *)va >= ((char *)shm->kaddr + shm->size))
+		return -EINVAL;
+
+	return tee_shm_get_pa(
+			shm, (unsigned long)va - (unsigned long)shm->kaddr, pa);
+}
+EXPORT_SYMBOL_GPL(tee_shm_va2pa);
+
+/**
+ * tee_shm_pa2va() - Get virtual address of a physical address
+ * @shm:	Shared memory handle
+ * @pa:		Physical address to tranlsate
+ * @va:		Returned virtual address
+ * @returns 0 on success and < 0 on failure
+ */
+int tee_shm_pa2va(struct tee_shm *shm, phys_addr_t pa, void **va)
+{
+	if (!(shm->flags & TEE_SHM_MAPPED))
+		return -EINVAL;
+	/* Check that we're in the range of the shm */
+	if (pa < shm->paddr)
+		return -EINVAL;
+	if (pa >= (shm->paddr + shm->size))
+		return -EINVAL;
+
+	if (va) {
+		void *v = tee_shm_get_va(shm, pa - shm->paddr);
+
+		if (IS_ERR(v))
+			return PTR_ERR(v);
+		*va = v;
+	}
+	return 0;
+}
+EXPORT_SYMBOL_GPL(tee_shm_pa2va);
+
+/**
+ * tee_shm_get_va() - Get virtual address of a shared memory plus an offset
+ * @shm:	Shared memory handle
+ * @offs:	Offset from start of this shared memory
+ * @returns virtual address of the shared memory + offs if offs is within
+ *	the bounds of this shared memory, else an ERR_PTR
+ */
+void *tee_shm_get_va(struct tee_shm *shm, size_t offs)
+{
+	if (!(shm->flags & TEE_SHM_MAPPED))
+		return ERR_PTR(-EINVAL);
+	if (offs >= shm->size)
+		return ERR_PTR(-EINVAL);
+	return (char *)shm->kaddr + offs;
+}
+EXPORT_SYMBOL_GPL(tee_shm_get_va);
+
+/**
+ * tee_shm_get_pa() - Get physical address of a shared memory plus an offset
+ * @shm:	Shared memory handle
+ * @offs:	Offset from start of this shared memory
+ * @pa:		Physical address to return
+ * @returns 0 if offs is within the bounds of this shared memory, else an
+ *	error code.
+ */
+int tee_shm_get_pa(struct tee_shm *shm, size_t offs, phys_addr_t *pa)
+{
+	if (offs >= shm->size)
+		return -EINVAL;
+	if (pa)
+		*pa = shm->paddr + offs;
+	return 0;
+}
+EXPORT_SYMBOL_GPL(tee_shm_get_pa);
+
+/**
+ * tee_shm_get_from_id() - Find shared memory object and increase reference
+ * count
+ * @ctx:	Context owning the shared memory
+ * @id:		Id of shared memory object
+ * @returns a pointer to 'struct tee_shm' on success or an ERR_PTR on failure
+ */
+struct tee_shm *tee_shm_get_from_id(struct tee_context *ctx, int id)
+{
+	struct tee_device *teedev;
+	struct tee_shm *shm;
+
+	if (!ctx)
+		return ERR_PTR(-EINVAL);
+
+	teedev = ctx->teedev;
+	mutex_lock(&teedev->mutex);
+	shm = idr_find(&teedev->idr, id);
+	if (!shm || shm->ctx != ctx)
+		shm = ERR_PTR(-EINVAL);
+	else if (shm->flags & TEE_SHM_DMA_BUF)
+		get_dma_buf(shm->dmabuf);
+	mutex_unlock(&teedev->mutex);
+	return shm;
+}
+EXPORT_SYMBOL_GPL(tee_shm_get_from_id);
+
+/**
+ * tee_shm_put() - Decrease reference count on a shared memory handle
+ * @shm:	Shared memory handle
+ */
+void tee_shm_put(struct tee_shm *shm)
+{
+	if (shm->flags & TEE_SHM_DMA_BUF)
+		dma_buf_put(shm->dmabuf);
+}
+EXPORT_SYMBOL_GPL(tee_shm_put);
diff --git a/drivers/tee/tee_shm_pool.c b/drivers/tee/tee_shm_pool.c
new file mode 100644
index 00000000..e6d4b9e
--- /dev/null
+++ b/drivers/tee/tee_shm_pool.c
@@ -0,0 +1,195 @@
+/*
+ * Copyright (c) 2015, Linaro Limited
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+#include <linux/device.h>
+#include <linux/dma-buf.h>
+#include <linux/genalloc.h>
+#include <linux/slab.h>
+#include <linux/tee_drv.h>
+#include "tee_private.h"
+
+static int pool_op_gen_alloc(struct tee_shm_pool_mgr *poolm,
+			     struct tee_shm *shm, size_t size)
+{
+	unsigned long va;
+	struct gen_pool *genpool = poolm->private_data;
+	size_t s = roundup(size, 1 << genpool->min_alloc_order);
+
+	va = gen_pool_alloc(genpool, s);
+	if (!va)
+		return -ENOMEM;
+
+	memset((void *)va, 0, s);
+	shm->kaddr = (void *)va;
+	shm->paddr = gen_pool_virt_to_phys(genpool, va);
+	shm->size = s;
+	return 0;
+}
+
+static void pool_op_gen_free(struct tee_shm_pool_mgr *poolm,
+			     struct tee_shm *shm)
+{
+	gen_pool_free(poolm->private_data, (unsigned long)shm->kaddr,
+		      shm->size);
+	shm->kaddr = NULL;
+}
+
+static void pool_op_gen_destroy_poolmgr(struct tee_shm_pool_mgr *poolm)
+{
+	gen_pool_destroy(poolm->private_data);
+	kfree(poolm);
+}
+
+static const struct tee_shm_pool_mgr_ops pool_ops_generic = {
+	.alloc = pool_op_gen_alloc,
+	.free = pool_op_gen_free,
+	.destroy_poolmgr = pool_op_gen_destroy_poolmgr,
+};
+
+/**
+ * tee_shm_pool_alloc_res_mem() - Create a shared memory pool from reserved
+ * memory range
+ * @priv_info:	Information for driver private shared memory pool
+ * @dmabuf_info: Information for dma-buf shared memory pool
+ *
+ * Start and end of pools will must be page aligned.
+ *
+ * Allocation with the flag TEE_SHM_DMA_BUF set will use the range supplied
+ * in @dmabuf, others will use the range provided by @priv.
+ *
+ * @returns pointer to a 'struct tee_shm_pool' or an ERR_PTR on failure.
+ */
+struct tee_shm_pool *
+tee_shm_pool_alloc_res_mem(struct tee_shm_pool_mem_info *priv_info,
+			   struct tee_shm_pool_mem_info *dmabuf_info)
+{
+	struct tee_shm_pool_mgr *priv_mgr;
+	struct tee_shm_pool_mgr *dmabuf_mgr;
+	void *rc;
+
+	/*
+	 * Create the pool for driver private shared memory
+	 */
+	rc = tee_shm_pool_mgr_alloc_res_mem(priv_info->vaddr, priv_info->paddr,
+					    priv_info->size,
+					    3 /* 8 byte aligned */);
+	if (IS_ERR(rc))
+		return rc;
+	priv_mgr = rc;
+
+	/*
+	 * Create the pool for dma_buf shared memory
+	 */
+	rc = tee_shm_pool_mgr_alloc_res_mem(dmabuf_info->vaddr,
+					    dmabuf_info->paddr,
+					    dmabuf_info->size, PAGE_SHIFT);
+	if (IS_ERR(rc))
+		goto err_free_priv_mgr;
+	dmabuf_mgr = rc;
+
+	rc = tee_shm_pool_alloc(priv_mgr, dmabuf_mgr);
+	if (IS_ERR(rc))
+		goto err_free_dmabuf_mgr;
+
+	return rc;
+
+err_free_dmabuf_mgr:
+	tee_shm_pool_mgr_destroy(dmabuf_mgr);
+err_free_priv_mgr:
+	tee_shm_pool_mgr_destroy(priv_mgr);
+
+	return rc;
+}
+EXPORT_SYMBOL_GPL(tee_shm_pool_alloc_res_mem);
+
+struct tee_shm_pool_mgr *tee_shm_pool_mgr_alloc_res_mem(unsigned long vaddr,
+							phys_addr_t paddr,
+							size_t size,
+							int min_alloc_order)
+{
+	const size_t page_mask = PAGE_SIZE - 1;
+	struct tee_shm_pool_mgr *mgr;
+	int rc;
+
+	/* Start and end must be page aligned */
+	if (vaddr & page_mask || paddr & page_mask || size & page_mask)
+		return ERR_PTR(-EINVAL);
+
+	mgr = kzalloc(sizeof(*mgr), GFP_KERNEL);
+	if (!mgr)
+		return ERR_PTR(-ENOMEM);
+
+	mgr->private_data = gen_pool_create(min_alloc_order, -1);
+	if (!mgr->private_data) {
+		rc = -ENOMEM;
+		goto err;
+	}
+
+	gen_pool_set_algo(mgr->private_data, gen_pool_best_fit, NULL);
+	rc = gen_pool_add_virt(mgr->private_data, vaddr, paddr, size, -1);
+	if (rc) {
+		gen_pool_destroy(mgr->private_data);
+		goto err;
+	}
+
+	mgr->ops = &pool_ops_generic;
+
+	return mgr;
+err:
+	kfree(mgr);
+
+	return ERR_PTR(rc);
+}
+EXPORT_SYMBOL_GPL(tee_shm_pool_mgr_alloc_res_mem);
+
+static bool check_mgr_ops(struct tee_shm_pool_mgr *mgr)
+{
+	return mgr && mgr->ops && mgr->ops->alloc && mgr->ops->free &&
+		mgr->ops->destroy_poolmgr;
+}
+
+struct tee_shm_pool *tee_shm_pool_alloc(struct tee_shm_pool_mgr *priv_mgr,
+					struct tee_shm_pool_mgr *dmabuf_mgr)
+{
+	struct tee_shm_pool *pool;
+
+	if (!check_mgr_ops(priv_mgr) || !check_mgr_ops(dmabuf_mgr))
+		return ERR_PTR(-EINVAL);
+
+	pool = kzalloc(sizeof(*pool), GFP_KERNEL);
+	if (!pool)
+		return ERR_PTR(-ENOMEM);
+
+	pool->private_mgr = priv_mgr;
+	pool->dma_buf_mgr = dmabuf_mgr;
+
+	return pool;
+}
+EXPORT_SYMBOL_GPL(tee_shm_pool_alloc);
+
+/**
+ * tee_shm_pool_free() - Free a shared memory pool
+ * @pool:	The shared memory pool to free
+ *
+ * There must be no remaining shared memory allocated from this pool when
+ * this function is called.
+ */
+void tee_shm_pool_free(struct tee_shm_pool *pool)
+{
+	if (pool->private_mgr)
+		tee_shm_pool_mgr_destroy(pool->private_mgr);
+	if (pool->dma_buf_mgr)
+		tee_shm_pool_mgr_destroy(pool->dma_buf_mgr);
+	kfree(pool);
+}
+EXPORT_SYMBOL_GPL(tee_shm_pool_free);
diff --git a/drivers/thermal/Kconfig b/drivers/thermal/Kconfig
index 6356295..e4b2628 100644
--- a/drivers/thermal/Kconfig
+++ b/drivers/thermal/Kconfig
@@ -434,4 +434,8 @@ depends on (ARCH_QCOM && OF) || COMPILE_TEST
 source "drivers/thermal/qcom/Kconfig"
 endmenu
 
+menu "Realtek thermal drivers"
+source "drivers/thermal/realtek/Kconfig"
+endmenu
+
 endif
diff --git a/drivers/thermal/Makefile b/drivers/thermal/Makefile
index c92eb22..a985ea6 100644
--- a/drivers/thermal/Makefile
+++ b/drivers/thermal/Makefile
@@ -55,3 +55,4 @@ obj-$(CONFIG_TEGRA_SOCTHERM)	+= tegra/
 obj-$(CONFIG_HISI_THERMAL)     += hisi_thermal.o
 obj-$(CONFIG_MTK_THERMAL)	+= mtk_thermal.o
 obj-$(CONFIG_GENERIC_ADC_THERMAL)	+= thermal-generic-adc.o
+obj-$(CONFIG_RTK_THERMAL)       += realtek/
diff --git a/drivers/thermal/hisi_thermal.c b/drivers/thermal/hisi_thermal.c
index c5285ed..2d855a9 100644
--- a/drivers/thermal/hisi_thermal.c
+++ b/drivers/thermal/hisi_thermal.c
@@ -23,243 +23,450 @@
 #include <linux/module.h>
 #include <linux/platform_device.h>
 #include <linux/io.h>
+#include <linux/of_device.h>
 
 #include "thermal_core.h"
 
-#define TEMP0_TH			(0x4)
-#define TEMP0_RST_TH			(0x8)
-#define TEMP0_CFG			(0xC)
-#define TEMP0_EN			(0x10)
-#define TEMP0_INT_EN			(0x14)
-#define TEMP0_INT_CLR			(0x18)
-#define TEMP0_RST_MSK			(0x1C)
-#define TEMP0_VALUE			(0x28)
-
-#define HISI_TEMP_BASE			(-60000)
-#define HISI_TEMP_RESET			(100000)
-#define HISI_TEMP_STEP			(784)
-
-#define HISI_MAX_SENSORS		4
+#define HI6220_TEMP0_LAG			(0x0)
+#define HI6220_TEMP0_TH				(0x4)
+#define HI6220_TEMP0_RST_TH			(0x8)
+#define HI6220_TEMP0_CFG			(0xC)
+#define HI6220_TEMP0_CFG_SS_MSK			(0xF000)
+#define HI6220_TEMP0_CFG_HDAK_MSK		(0x30)
+#define HI6220_TEMP0_EN				(0x10)
+#define HI6220_TEMP0_INT_EN			(0x14)
+#define HI6220_TEMP0_INT_CLR			(0x18)
+#define HI6220_TEMP0_RST_MSK			(0x1C)
+#define HI6220_TEMP0_VALUE			(0x28)
+
+#define HI3660_OFFSET(chan)		((chan) * 0x40)
+#define HI3660_TEMP(chan)		(HI3660_OFFSET(chan) + 0x1C)
+#define HI3660_TH(chan)			(HI3660_OFFSET(chan) + 0x20)
+#define HI3660_LAG(chan)		(HI3660_OFFSET(chan) + 0x28)
+#define HI3660_INT_EN(chan)		(HI3660_OFFSET(chan) + 0x2C)
+#define HI3660_INT_CLR(chan)		(HI3660_OFFSET(chan) + 0x30)
+
+#define HI6220_TEMP_BASE			(-60000)
+#define HI6220_TEMP_RESET			(100000)
+#define HI6220_TEMP_STEP			(785)
+#define HI6220_TEMP_LAG				(3500)
+
+#define HI3660_TEMP_BASE		(-63780)
+#define HI3660_TEMP_STEP		(205)
+#define HI3660_TEMP_LAG			(4000)
+
+#define HI6220_DEFAULT_SENSOR		2
+#define HI3660_DEFAULT_SENSOR		1
 
 struct hisi_thermal_sensor {
-	struct hisi_thermal_data *thermal;
 	struct thermal_zone_device *tzd;
-
-	long sensor_temp;
 	uint32_t id;
 	uint32_t thres_temp;
 };
 
 struct hisi_thermal_data {
-	struct mutex thermal_lock;    /* protects register data */
+	int (*get_temp)(struct hisi_thermal_data *data);
+	int (*enable_sensor)(struct hisi_thermal_data *data);
+	int (*disable_sensor)(struct hisi_thermal_data *data);
+	int (*irq_handler)(struct hisi_thermal_data *data);
 	struct platform_device *pdev;
 	struct clk *clk;
-	struct hisi_thermal_sensor sensors[HISI_MAX_SENSORS];
-
-	int irq, irq_bind_sensor;
-	bool irq_enabled;
-
+	struct hisi_thermal_sensor sensor;
 	void __iomem *regs;
+	int irq;
 };
 
 /*
  * The temperature computation on the tsensor is as follow:
  *	Unit: millidegree Celsius
- *	Step: 255/200 (0.7843)
+ *	Step: 200/255 (0.7843)
  *	Temperature base: -60°C
  *
- * The register is programmed in temperature steps, every step is 784
+ * The register is programmed in temperature steps, every step is 785
  * millidegree and begins at -60 000 m°C
  *
  * The temperature from the steps:
  *
- *	Temp = TempBase + (steps x 784)
+ *	Temp = TempBase + (steps x 785)
  *
  * and the steps from the temperature:
  *
- *	steps = (Temp - TempBase) / 784
+ *	steps = (Temp - TempBase) / 785
  *
  */
-static inline int hisi_thermal_step_to_temp(int step)
+static inline int hi6220_thermal_step_to_temp(int step)
 {
-	return HISI_TEMP_BASE + (step * HISI_TEMP_STEP);
+	return HI6220_TEMP_BASE + (step * HI6220_TEMP_STEP);
 }
 
-static inline long hisi_thermal_temp_to_step(long temp)
+static inline int hi6220_thermal_temp_to_step(int temp)
 {
-	return (temp - HISI_TEMP_BASE) / HISI_TEMP_STEP;
+	return DIV_ROUND_UP(temp - HI6220_TEMP_BASE, HI6220_TEMP_STEP);
 }
 
-static inline long hisi_thermal_round_temp(int temp)
+/*
+ * for Hi3660,
+ *	Step: 189/922 (0.205)
+ *	Temperature base: -63.780°C
+ *
+ * The register is programmed in temperature steps, every step is 205
+ * millidegree and begins at -63 780 m°C
+ */
+static inline int hi3660_thermal_step_to_temp(int step)
 {
-	return hisi_thermal_step_to_temp(
-		hisi_thermal_temp_to_step(temp));
+	return HI3660_TEMP_BASE + step * HI3660_TEMP_STEP;
 }
 
-static long hisi_thermal_get_sensor_temp(struct hisi_thermal_data *data,
-					 struct hisi_thermal_sensor *sensor)
+static inline int hi3660_thermal_temp_to_step(int temp)
 {
-	long val;
+	return DIV_ROUND_UP(temp - HI3660_TEMP_BASE, HI3660_TEMP_STEP);
+}
 
-	mutex_lock(&data->thermal_lock);
+/*
+ * The lag register contains 5 bits encoding the temperature in steps.
+ *
+ * Each time the temperature crosses the threshold boundary, an
+ * interrupt is raised. It could be when the temperature is going
+ * above the threshold or below. However, if the temperature is
+ * fluctuating around this value due to the load, we can receive
+ * several interrupts which may not desired.
+ *
+ * We can setup a temperature representing the delta between the
+ * threshold and the current temperature when the temperature is
+ * decreasing.
+ *
+ * For instance: the lag register is 5°C, the threshold is 65°C, when
+ * the temperature reaches 65°C an interrupt is raised and when the
+ * temperature decrease to 65°C - 5°C another interrupt is raised.
+ *
+ * A very short lag can lead to an interrupt storm, a long lag
+ * increase the latency to react to the temperature changes.  In our
+ * case, that is not really a problem as we are polling the
+ * temperature.
+ *
+ * [0:4] : lag register
+ *
+ * The temperature is coded in steps, cf. HI6220_TEMP_STEP.
+ *
+ * Min : 0x00 :  0.0 °C
+ * Max : 0x1F : 24.3 °C
+ *
+ * The 'value' parameter is in milliCelsius.
+ */
+static inline void hi6220_thermal_set_lag(void __iomem *addr, int value)
+{
+	writel(DIV_ROUND_UP(value, HI6220_TEMP_STEP) & 0x1F,
+			addr + HI6220_TEMP0_LAG);
+}
 
-	/* disable interrupt */
-	writel(0x0, data->regs + TEMP0_INT_EN);
-	writel(0x1, data->regs + TEMP0_INT_CLR);
+static inline void hi6220_thermal_alarm_clear(void __iomem *addr, int value)
+{
+	writel(value, addr + HI6220_TEMP0_INT_CLR);
+}
 
-	/* disable module firstly */
-	writel(0x0, data->regs + TEMP0_EN);
+static inline void hi6220_thermal_alarm_enable(void __iomem *addr, int value)
+{
+	writel(value, addr + HI6220_TEMP0_INT_EN);
+}
 
-	/* select sensor id */
-	writel((sensor->id << 12), data->regs + TEMP0_CFG);
+static inline void hi6220_thermal_alarm_set(void __iomem *addr, int temp)
+{
+	writel(hi6220_thermal_temp_to_step(temp) | 0x0FFFFFF00,
+	       addr + HI6220_TEMP0_TH);
+}
 
-	/* enable module */
-	writel(0x1, data->regs + TEMP0_EN);
+static inline void hi6220_thermal_reset_set(void __iomem *addr, int temp)
+{
+	writel(hi6220_thermal_temp_to_step(temp), addr + HI6220_TEMP0_RST_TH);
+}
 
-	usleep_range(3000, 5000);
+static inline void hi6220_thermal_reset_enable(void __iomem *addr, int value)
+{
+	writel(value, addr + HI6220_TEMP0_RST_MSK);
+}
 
-	val = readl(data->regs + TEMP0_VALUE);
-	val = hisi_thermal_step_to_temp(val);
+static inline void hi6220_thermal_enable(void __iomem *addr, int value)
+{
+	writel(value, addr + HI6220_TEMP0_EN);
+}
 
-	mutex_unlock(&data->thermal_lock);
+static inline int hi6220_thermal_get_temperature(void __iomem *addr)
+{
+	return hi6220_thermal_step_to_temp(readl(addr + HI6220_TEMP0_VALUE));
+}
 
-	return val;
+/*
+ * [0:6] lag register
+ *
+ * The temperature is coded in steps, cf. HI3660_TEMP_STEP.
+ *
+ * Min : 0x00 :  0.0 °C
+ * Max : 0x7F : 26.0 °C
+ *
+ */
+static inline void hi3660_thermal_set_lag(void __iomem *addr,
+					  int id, int value)
+{
+	writel(DIV_ROUND_UP(value, HI3660_TEMP_STEP) & 0x7F,
+			addr + HI3660_LAG(id));
 }
 
-static void hisi_thermal_enable_bind_irq_sensor
-			(struct hisi_thermal_data *data)
+static inline void hi3660_thermal_alarm_clear(void __iomem *addr,
+					      int id, int value)
 {
-	struct hisi_thermal_sensor *sensor;
+	writel(value, addr + HI3660_INT_CLR(id));
+}
 
-	mutex_lock(&data->thermal_lock);
+static inline void hi3660_thermal_alarm_enable(void __iomem *addr,
+					       int id, int value)
+{
+	writel(value, addr + HI3660_INT_EN(id));
+}
 
-	sensor = &data->sensors[data->irq_bind_sensor];
+static inline void hi3660_thermal_alarm_set(void __iomem *addr,
+					    int id, int value)
+{
+	writel(value, addr + HI3660_TH(id));
+}
 
-	/* setting the hdak time */
-	writel(0x0, data->regs + TEMP0_CFG);
+static inline int hi3660_thermal_get_temperature(void __iomem *addr, int id)
+{
+	return hi3660_thermal_step_to_temp(readl(addr + HI3660_TEMP(id)));
+}
+
+/*
+ * Temperature configuration register - Sensor selection
+ *
+ * Bits [19:12]
+ *
+ * 0x0: local sensor (default)
+ * 0x1: remote sensor 1 (ACPU cluster 1)
+ * 0x2: remote sensor 2 (ACPU cluster 0)
+ * 0x3: remote sensor 3 (G3D)
+ */
+static inline void hi6220_thermal_sensor_select(void __iomem *addr, int sensor)
+{
+	writel((readl(addr + HI6220_TEMP0_CFG) & ~HI6220_TEMP0_CFG_SS_MSK) |
+	       (sensor << 12), addr + HI6220_TEMP0_CFG);
+}
+
+/*
+ * Temperature configuration register - Hdak conversion polling interval
+ *
+ * Bits [5:4]
+ *
+ * 0x0 :   0.768 ms
+ * 0x1 :   6.144 ms
+ * 0x2 :  49.152 ms
+ * 0x3 : 393.216 ms
+ */
+static inline void hi6220_thermal_hdak_set(void __iomem *addr, int value)
+{
+	writel((readl(addr + HI6220_TEMP0_CFG) & ~HI6220_TEMP0_CFG_HDAK_MSK) |
+	       (value << 4), addr + HI6220_TEMP0_CFG);
+}
+
+static int hi6220_thermal_irq_handler(struct hisi_thermal_data *data)
+{
+	hi6220_thermal_alarm_clear(data->regs, 1);
+	return 0;
+}
+
+static int hi3660_thermal_irq_handler(struct hisi_thermal_data *data)
+{
+	hi3660_thermal_alarm_clear(data->regs, data->sensor.id, 1);
+	return 0;
+}
+
+static int hi6220_thermal_get_temp(struct hisi_thermal_data *data)
+{
+	return hi6220_thermal_get_temperature(data->regs);
+}
+
+static int hi3660_thermal_get_temp(struct hisi_thermal_data *data)
+{
+	return hi3660_thermal_get_temperature(data->regs, data->sensor.id);
+}
+
+static int hi6220_thermal_disable_sensor(struct hisi_thermal_data *data)
+{
+	/* disable sensor module */
+	hi6220_thermal_enable(data->regs, 0);
+	hi6220_thermal_alarm_enable(data->regs, 0);
+	hi6220_thermal_reset_enable(data->regs, 0);
+
+	clk_disable_unprepare(data->clk);
+
+	return 0;
+}
+
+static int hi3660_thermal_disable_sensor(struct hisi_thermal_data *data)
+{
+	/* disable sensor module */
+	hi3660_thermal_alarm_enable(data->regs, data->sensor.id, 0);
+	return 0;
+}
+
+static int hi6220_thermal_enable_sensor(struct hisi_thermal_data *data)
+{
+	struct hisi_thermal_sensor *sensor = &data->sensor;
+	int ret;
+
+	/* enable clock for tsensor */
+	ret = clk_prepare_enable(data->clk);
+	if (ret)
+		return ret;
 
 	/* disable module firstly */
-	writel(0x0, data->regs + TEMP0_RST_MSK);
-	writel(0x0, data->regs + TEMP0_EN);
+	hi6220_thermal_reset_enable(data->regs, 0);
+	hi6220_thermal_enable(data->regs, 0);
 
 	/* select sensor id */
-	writel((sensor->id << 12), data->regs + TEMP0_CFG);
+	hi6220_thermal_sensor_select(data->regs, sensor->id);
+
+	/* setting the hdak time */
+	hi6220_thermal_hdak_set(data->regs, 0);
+
+	/* setting lag value between current temp and the threshold */
+	hi6220_thermal_set_lag(data->regs, HI6220_TEMP_LAG);
 
 	/* enable for interrupt */
-	writel(hisi_thermal_temp_to_step(sensor->thres_temp) | 0x0FFFFFF00,
-	       data->regs + TEMP0_TH);
+	hi6220_thermal_alarm_set(data->regs, sensor->thres_temp);
 
-	writel(hisi_thermal_temp_to_step(HISI_TEMP_RESET),
-	       data->regs + TEMP0_RST_TH);
+	hi6220_thermal_reset_set(data->regs, HI6220_TEMP_RESET);
 
 	/* enable module */
-	writel(0x1, data->regs + TEMP0_RST_MSK);
-	writel(0x1, data->regs + TEMP0_EN);
+	hi6220_thermal_reset_enable(data->regs, 1);
+	hi6220_thermal_enable(data->regs, 1);
 
-	writel(0x0, data->regs + TEMP0_INT_CLR);
-	writel(0x1, data->regs + TEMP0_INT_EN);
+	hi6220_thermal_alarm_clear(data->regs, 0);
+	hi6220_thermal_alarm_enable(data->regs, 1);
 
-	usleep_range(3000, 5000);
-
-	mutex_unlock(&data->thermal_lock);
+	return 0;
 }
 
-static void hisi_thermal_disable_sensor(struct hisi_thermal_data *data)
+static int hi3660_thermal_enable_sensor(struct hisi_thermal_data *data)
 {
-	mutex_lock(&data->thermal_lock);
+	unsigned int value;
+	struct hisi_thermal_sensor *sensor = &data->sensor;
 
-	/* disable sensor module */
-	writel(0x0, data->regs + TEMP0_INT_EN);
-	writel(0x0, data->regs + TEMP0_RST_MSK);
-	writel(0x0, data->regs + TEMP0_EN);
+	/* disable interrupt */
+	hi3660_thermal_alarm_enable(data->regs, sensor->id, 0);
 
-	mutex_unlock(&data->thermal_lock);
-}
+	/* setting lag value between current temp and the threshold */
+	hi3660_thermal_set_lag(data->regs, sensor->id, HI3660_TEMP_LAG);
 
-static int hisi_thermal_get_temp(void *_sensor, int *temp)
-{
-	struct hisi_thermal_sensor *sensor = _sensor;
-	struct hisi_thermal_data *data = sensor->thermal;
+	/* set interrupt threshold */
+	value = hi3660_thermal_temp_to_step(sensor->thres_temp);
+	hi3660_thermal_alarm_set(data->regs, sensor->id, value);
 
-	int sensor_id = -1, i;
-	long max_temp = 0;
+	/* enable interrupt */
+	hi3660_thermal_alarm_clear(data->regs, sensor->id, 1);
+	hi3660_thermal_alarm_enable(data->regs, sensor->id, 1);
 
-	*temp = hisi_thermal_get_sensor_temp(data, sensor);
+	return 0;
+}
 
-	sensor->sensor_temp = *temp;
+static int hi6220_thermal_probe(struct hisi_thermal_data *data)
+{
+	struct platform_device *pdev = data->pdev;
+	struct device *dev = &pdev->dev;
+	struct resource *res;
+	int ret;
 
-	for (i = 0; i < HISI_MAX_SENSORS; i++) {
-		if (!data->sensors[i].tzd)
-			continue;
+	data->get_temp = hi6220_thermal_get_temp;
+	data->enable_sensor = hi6220_thermal_enable_sensor;
+	data->disable_sensor = hi6220_thermal_disable_sensor;
+	data->irq_handler = hi6220_thermal_irq_handler;
 
-		if (data->sensors[i].sensor_temp >= max_temp) {
-			max_temp = data->sensors[i].sensor_temp;
-			sensor_id = i;
-		}
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	data->regs = devm_ioremap_resource(dev, res);
+	if (IS_ERR(data->regs)) {
+		dev_err(dev, "failed to get io address\n");
+		return PTR_ERR(data->regs);
 	}
 
-	/* If no sensor has been enabled, then skip to enable irq */
-	if (sensor_id == -1)
-		return 0;
-
-	mutex_lock(&data->thermal_lock);
-	data->irq_bind_sensor = sensor_id;
-	mutex_unlock(&data->thermal_lock);
-
-	dev_dbg(&data->pdev->dev, "id=%d, irq=%d, temp=%d, thres=%d\n",
-		sensor->id, data->irq_enabled, *temp, sensor->thres_temp);
-	/*
-	 * Bind irq to sensor for two cases:
-	 *   Reenable alarm IRQ if temperature below threshold;
-	 *   if irq has been enabled, always set it;
-	 */
-	if (data->irq_enabled) {
-		hisi_thermal_enable_bind_irq_sensor(data);
-		return 0;
+	data->clk = devm_clk_get(dev, "thermal_clk");
+	if (IS_ERR(data->clk)) {
+		ret = PTR_ERR(data->clk);
+		if (ret != -EPROBE_DEFER)
+			dev_err(dev, "failed to get thermal clk: %d\n", ret);
+		return ret;
 	}
 
-	if (max_temp < sensor->thres_temp) {
-		data->irq_enabled = true;
-		hisi_thermal_enable_bind_irq_sensor(data);
-		enable_irq(data->irq);
-	}
+	data->irq = platform_get_irq(pdev, 0);
+	if (data->irq < 0)
+		return data->irq;
+
+	data->sensor.id = HI6220_DEFAULT_SENSOR;
 
 	return 0;
 }
 
-static struct thermal_zone_of_device_ops hisi_of_thermal_ops = {
-	.get_temp = hisi_thermal_get_temp,
-};
+static int hi3660_thermal_probe(struct hisi_thermal_data *data)
+{
+	struct platform_device *pdev = data->pdev;
+	struct device *dev = &pdev->dev;
+	struct resource *res;
+
+	data->get_temp = hi3660_thermal_get_temp;
+	data->enable_sensor = hi3660_thermal_enable_sensor;
+	data->disable_sensor = hi3660_thermal_disable_sensor;
+	data->irq_handler = hi3660_thermal_irq_handler;
+
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	data->regs = devm_ioremap_resource(dev, res);
+	if (IS_ERR(data->regs)) {
+		dev_err(dev, "failed to get io address\n");
+		return PTR_ERR(data->regs);
+	}
+
+	data->irq = platform_get_irq(pdev, 0);
+	if (data->irq < 0)
+		return data->irq;
+
+	data->sensor.id = HI3660_DEFAULT_SENSOR;
 
-static irqreturn_t hisi_thermal_alarm_irq(int irq, void *dev)
+	return 0;
+}
+
+static int hisi_thermal_get_temp(void *__data, int *temp)
 {
-	struct hisi_thermal_data *data = dev;
+	struct hisi_thermal_data *data = __data;
+	struct hisi_thermal_sensor *sensor = &data->sensor;
+
+	*temp = data->get_temp(data);
 
-	disable_irq_nosync(irq);
-	data->irq_enabled = false;
+	dev_dbg(&data->pdev->dev, "id=%d, temp=%d, thres=%d\n",
+		sensor->id, *temp, sensor->thres_temp);
 
-	return IRQ_WAKE_THREAD;
+	return 0;
 }
 
+static const struct thermal_zone_of_device_ops hisi_of_thermal_ops = {
+	.get_temp = hisi_thermal_get_temp,
+};
+
 static irqreturn_t hisi_thermal_alarm_irq_thread(int irq, void *dev)
 {
 	struct hisi_thermal_data *data = dev;
-	struct hisi_thermal_sensor *sensor;
-	int i;
+	struct hisi_thermal_sensor *sensor = &data->sensor;
+	int temp = 0;
 
-	mutex_lock(&data->thermal_lock);
-	sensor = &data->sensors[data->irq_bind_sensor];
+	data->irq_handler(data);
 
-	dev_crit(&data->pdev->dev, "THERMAL ALARM: T > %d\n",
-		 sensor->thres_temp);
-	mutex_unlock(&data->thermal_lock);
+	hisi_thermal_get_temp(data, &temp);
 
-	for (i = 0; i < HISI_MAX_SENSORS; i++) {
-		if (!data->sensors[i].tzd)
-			continue;
+	if (temp >= sensor->thres_temp) {
+		dev_crit(&data->pdev->dev, "THERMAL ALARM: %d > %d\n",
+			 temp, sensor->thres_temp);
 
-		thermal_zone_device_update(data->sensors[i].tzd,
+		thermal_zone_device_update(data->sensor.tzd,
 					   THERMAL_EVENT_UNSPECIFIED);
+
+	} else {
+		dev_crit(&data->pdev->dev, "THERMAL ALARM stopped: %d < %d\n",
+			 temp, sensor->thres_temp);
 	}
 
 	return IRQ_HANDLED;
@@ -267,17 +474,14 @@ static irqreturn_t hisi_thermal_alarm_irq_thread(int irq, void *dev)
 
 static int hisi_thermal_register_sensor(struct platform_device *pdev,
 					struct hisi_thermal_data *data,
-					struct hisi_thermal_sensor *sensor,
-					int index)
+					struct hisi_thermal_sensor *sensor)
 {
 	int ret, i;
 	const struct thermal_trip *trip;
 
-	sensor->id = index;
-	sensor->thermal = data;
-
 	sensor->tzd = devm_thermal_zone_of_sensor_register(&pdev->dev,
-				sensor->id, sensor, &hisi_of_thermal_ops);
+							   sensor->id, data,
+							   &hisi_of_thermal_ops);
 	if (IS_ERR(sensor->tzd)) {
 		ret = PTR_ERR(sensor->tzd);
 		sensor->tzd = NULL;
@@ -290,7 +494,7 @@ static int hisi_thermal_register_sensor(struct platform_device *pdev,
 
 	for (i = 0; i < of_thermal_get_ntrips(sensor->tzd); i++) {
 		if (trip[i].type == THERMAL_TRIP_PASSIVE) {
-			sensor->thres_temp = hisi_thermal_round_temp(trip[i].temperature);
+			sensor->thres_temp = trip[i].temperature;
 			break;
 		}
 	}
@@ -299,7 +503,14 @@ static int hisi_thermal_register_sensor(struct platform_device *pdev,
 }
 
 static const struct of_device_id of_hisi_thermal_match[] = {
-	{ .compatible = "hisilicon,tsensor" },
+	{
+		.compatible = "hisilicon,tsensor",
+		.data = hi6220_thermal_probe
+	},
+	{
+		.compatible = "hisilicon,hi3660-tsensor",
+		.data = hi3660_thermal_probe
+	},
 	{ /* end */ }
 };
 MODULE_DEVICE_TABLE(of, of_hisi_thermal_match);
@@ -316,69 +527,51 @@ static void hisi_thermal_toggle_sensor(struct hisi_thermal_sensor *sensor,
 static int hisi_thermal_probe(struct platform_device *pdev)
 {
 	struct hisi_thermal_data *data;
-	struct resource *res;
-	int i;
+	int const (*platform_probe)(struct hisi_thermal_data *);
+	struct device *dev = &pdev->dev;
 	int ret;
 
-	data = devm_kzalloc(&pdev->dev, sizeof(*data), GFP_KERNEL);
+	data = devm_kzalloc(dev, sizeof(*data), GFP_KERNEL);
 	if (!data)
 		return -ENOMEM;
 
-	mutex_init(&data->thermal_lock);
 	data->pdev = pdev;
+	platform_set_drvdata(pdev, data);
 
-	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
-	data->regs = devm_ioremap_resource(&pdev->dev, res);
-	if (IS_ERR(data->regs)) {
-		dev_err(&pdev->dev, "failed to get io address\n");
-		return PTR_ERR(data->regs);
+	platform_probe = of_device_get_match_data(dev);
+	if (!platform_probe) {
+		dev_err(dev, "failed to get probe func\n");
+		return -EINVAL;
 	}
 
-	data->irq = platform_get_irq(pdev, 0);
-	if (data->irq < 0)
-		return data->irq;
-
-	platform_set_drvdata(pdev, data);
-
-	data->clk = devm_clk_get(&pdev->dev, "thermal_clk");
-	if (IS_ERR(data->clk)) {
-		ret = PTR_ERR(data->clk);
-		if (ret != -EPROBE_DEFER)
-			dev_err(&pdev->dev,
-				"failed to get thermal clk: %d\n", ret);
+	ret = platform_probe(data);
+	if (ret)
 		return ret;
-	}
 
-	/* enable clock for thermal */
-	ret = clk_prepare_enable(data->clk);
+	ret = hisi_thermal_register_sensor(pdev, data,
+					   &data->sensor);
 	if (ret) {
-		dev_err(&pdev->dev, "failed to enable thermal clk: %d\n", ret);
+		dev_err(dev, "failed to register thermal sensor: %d\n", ret);
 		return ret;
 	}
 
-	hisi_thermal_enable_bind_irq_sensor(data);
-	data->irq_enabled = true;
-
-	for (i = 0; i < HISI_MAX_SENSORS; ++i) {
-		ret = hisi_thermal_register_sensor(pdev, data,
-						   &data->sensors[i], i);
-		if (ret)
-			dev_err(&pdev->dev,
-				"failed to register thermal sensor: %d\n", ret);
-		else
-			hisi_thermal_toggle_sensor(&data->sensors[i], true);
+	ret = data->enable_sensor(data);
+	if (ret) {
+		dev_err(dev, "Failed to setup the sensor: %d\n", ret);
+		return ret;
 	}
 
-	ret = devm_request_threaded_irq(&pdev->dev, data->irq,
-					hisi_thermal_alarm_irq,
-					hisi_thermal_alarm_irq_thread,
-					0, "hisi_thermal", data);
-	if (ret < 0) {
-		dev_err(&pdev->dev, "failed to request alarm irq: %d\n", ret);
-		return ret;
+	if (data->irq) {
+		ret = devm_request_threaded_irq(dev, data->irq, NULL,
+				hisi_thermal_alarm_irq_thread,
+				IRQF_ONESHOT, "hisi_thermal", data);
+		if (ret < 0) {
+			dev_err(dev, "failed to request alarm irq: %d\n", ret);
+			return ret;
+		}
 	}
 
-	enable_irq(data->irq);
+	hisi_thermal_toggle_sensor(&data->sensor, true);
 
 	return 0;
 }
@@ -386,19 +579,11 @@ static int hisi_thermal_probe(struct platform_device *pdev)
 static int hisi_thermal_remove(struct platform_device *pdev)
 {
 	struct hisi_thermal_data *data = platform_get_drvdata(pdev);
-	int i;
-
-	for (i = 0; i < HISI_MAX_SENSORS; i++) {
-		struct hisi_thermal_sensor *sensor = &data->sensors[i];
+	struct hisi_thermal_sensor *sensor = &data->sensor;
 
-		if (!sensor->tzd)
-			continue;
+	hisi_thermal_toggle_sensor(sensor, false);
 
-		hisi_thermal_toggle_sensor(sensor, false);
-	}
-
-	hisi_thermal_disable_sensor(data);
-	clk_disable_unprepare(data->clk);
+	data->disable_sensor(data);
 
 	return 0;
 }
@@ -408,10 +593,7 @@ static int hisi_thermal_suspend(struct device *dev)
 {
 	struct hisi_thermal_data *data = dev_get_drvdata(dev);
 
-	hisi_thermal_disable_sensor(data);
-	data->irq_enabled = false;
-
-	clk_disable_unprepare(data->clk);
+	data->disable_sensor(data);
 
 	return 0;
 }
@@ -419,16 +601,8 @@ static int hisi_thermal_suspend(struct device *dev)
 static int hisi_thermal_resume(struct device *dev)
 {
 	struct hisi_thermal_data *data = dev_get_drvdata(dev);
-	int ret;
 
-	ret = clk_prepare_enable(data->clk);
-	if (ret)
-		return ret;
-
-	data->irq_enabled = true;
-	hisi_thermal_enable_bind_irq_sensor(data);
-
-	return 0;
+	return data->enable_sensor(data);
 }
 #endif
 
diff --git a/drivers/thermal/realtek/Kconfig b/drivers/thermal/realtek/Kconfig
new file mode 100644
index 00000000..96f7892
--- /dev/null
+++ b/drivers/thermal/realtek/Kconfig
@@ -0,0 +1,42 @@
+config RTK_THERMAL
+	bool "Realtek thermal management"
+	depends on OF && THERMAL_OF
+	help
+	  Enable thermal management with a generic thermal
+	  sensor driver on Realtek SoCs.
+
+	  If you want this support, you should say Y here.
+
+config RTK_THERMAL_EOH
+	bool "Realtek thermal sensor EOH"
+	depends on RTK_THERMAL
+
+config RTK_THERMAL_RTD119X
+	bool "RTD-119X thermal sensor support"
+	depends on ARCH_RTD119X
+	default y
+	select RTK_THERMAL
+
+config RTK_THERMAL_RTD129X
+	bool "RTD-129x thermal sensor support"
+	depends on ARCH_RTD129x
+	default y
+	select RTK_THERMAL
+
+config RTK_THERMAL_RTD139X
+	bool "RTD-139x thermal sensor support"
+	depends on ARCH_RTD139x
+	default y
+	select RTK_THERMAL
+
+config RTK_THERMAL_RTD16XX
+	bool "RTD-16XX thermal sensor support"
+	depends on ARCH_RTD16xx
+	default y
+	select RTK_THERMAL
+
+config RTK_THERMAL_RTD13XX
+	bool "RTD-13XX thermal sensor support"
+	depends on ARCH_RTD13xx
+	default y
+	select RTK_THERMAL
diff --git a/drivers/thermal/realtek/Makefile b/drivers/thermal/realtek/Makefile
new file mode 100644
index 00000000..6c61dc0
--- /dev/null
+++ b/drivers/thermal/realtek/Makefile
@@ -0,0 +1,10 @@
+obj-$(CONFIG_RTK_THERMAL) += rtk-thermal.o
+
+rtk-thermal-y += sensor.o
+rtk-thermal-$(CONFIG_RTK_THERMAL_RTD119X) += sensor-rtd119x.o
+rtk-thermal-$(CONFIG_RTK_THERMAL_RTD129X) += sensor-rtd129x.o
+rtk-thermal-$(CONFIG_RTK_THERMAL_RTD139X) += sensor-rtd139x.o
+rtk-thermal-$(CONFIG_RTK_THERMAL_RTD16XX) += sensor-rtd16xx.o
+rtk-thermal-$(CONFIG_RTK_THERMAL_RTD13XX) += sensor-rtd13xx.o
+rtk-thermal-$(CONFIG_RTK_THERMAL_EOH) += sensor-eoh.o
+
diff --git a/drivers/thermal/realtek/sensor-eoh.c b/drivers/thermal/realtek/sensor-eoh.c
new file mode 100644
index 00000000..a58abd65
--- /dev/null
+++ b/drivers/thermal/realtek/sensor-eoh.c
@@ -0,0 +1,121 @@
+/*
+ * sensor-eoh.c - External Overheat Handler
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/slab.h>
+#include <linux/thermal.h>
+#include <linux/cpufreq.h>
+#include <linux/of.h>
+#include "../thermal_core.h"
+#include "sensor.h"
+
+void thermal_sensor_eoh_handle_restore(struct thermal_sensor_device *tdev)
+{
+	unsigned int cpu = cpumask_any(cpu_online_mask);
+	ktime_t delta;
+
+	if (!tdev->eoh_freq)
+		return;
+
+	delta = ktime_sub(ktime_get(), tdev->eoh_time);
+	if (ktime_to_ms(delta) < (s64)tdev->eoh_restore_ms)
+		return;
+
+	tdev->eoh_freq = 0;
+	tdev->eoh_state = THERMAL_SENSOR_EOH_NONE;
+	dev_dbg(tdev->dev, "eoh: restore policy\n");
+	cpufreq_update_policy(cpu);
+}
+
+void thermal_sensor_eoh_handle_overheat(struct thermal_sensor_device *tdev,
+					int i, enum thermal_trend trend)
+{
+	struct thermal_zone_device *tz = tdev->tz;
+	struct thermal_instance *pos;
+
+	if (trend != THERMAL_TREND_RAISE_FULL &&
+	    trend != THERMAL_TREND_RAISING)
+		return;
+
+	list_for_each_entry(pos, &tz->thermal_instances, tz_node) {
+		if (pos->trip != i)
+			continue;
+		if (!cdev_is_cpufreq(pos->cdev))
+			continue;
+
+		dev_dbg(tdev->dev, "eoh: overheat\n");
+		tdev->eoh_state = THERMAL_SENSOR_EOH_START;
+		tdev->eoh_time = ktime_get();
+		break;
+	}
+}
+
+
+static int thermal_sensor_eoh_cpufreq_cb(struct notifier_block *nb,
+					 unsigned long event, void *data)
+{
+	struct cpufreq_policy *policy = data;
+	struct thermal_sensor_device *tdev = container_of(nb,
+		struct thermal_sensor_device, eoh_cpufreq_nb);
+
+	if (event != CPUFREQ_ADJUST)
+		return NOTIFY_DONE;
+
+	if (tdev->eoh_state == THERMAL_SENSOR_EOH_START) {
+		if (tdev->eoh_freq != 0 && tdev->eoh_freq < policy->max)
+			return NOTIFY_DONE;
+
+		tdev->eoh_freq = policy->max;
+		tdev->eoh_state = THERMAL_SENSOR_EOH_POLL;
+		dev_dbg(tdev->dev, "eoh: save freq=%u\n", tdev->eoh_freq);
+		return NOTIFY_OK;
+	} else if (tdev->eoh_state == THERMAL_SENSOR_EOH_POLL) {
+		if (!tdev->eoh_freq)
+			return NOTIFY_DONE;
+		cpufreq_verify_within_limits(policy, 0, tdev->eoh_freq);
+		dev_dbg(tdev->dev, "eoh: apply freq=%u\n", policy->max);
+		return NOTIFY_OK;
+	}
+	return NOTIFY_DONE;
+}
+
+int thermal_sensor_add_eoh(struct thermal_sensor_device *tdev)
+{
+	struct device *dev = tdev->dev;
+	struct device_node *np = dev->of_node;
+
+	if (of_property_read_u32(np, "eoh-restore-ms", &tdev->eoh_restore_ms))
+		tdev->eoh_restore_ms = 2000;
+
+	tdev->eoh_cpufreq_nb.notifier_call = thermal_sensor_eoh_cpufreq_cb;
+	tdev->eoh_cpufreq_nb.priority = -1;
+	cpufreq_register_notifier(&tdev->eoh_cpufreq_nb,
+		CPUFREQ_POLICY_NOTIFIER);
+	return 0;
+}
+
+void thermal_sensor_remove_eoh(struct thermal_sensor_device *tdev)
+{
+	cpufreq_unregister_notifier(&tdev->eoh_cpufreq_nb,
+		CPUFREQ_POLICY_NOTIFIER);
+}
+
diff --git a/drivers/thermal/realtek/sensor-rtd119x.c b/drivers/thermal/realtek/sensor-rtd119x.c
new file mode 100644
index 00000000..6e32ea4
--- /dev/null
+++ b/drivers/thermal/realtek/sensor-rtd119x.c
@@ -0,0 +1,129 @@
+/*
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/bitops.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/nvmem-consumer.h>
+#include <linux/of_address.h>
+#include <linux/slab.h>
+#include "sensor.h"
+
+static void rtd119x_sensor_reset(struct thermal_sensor_device *tdev, int index)
+{
+}
+
+static int rtd119x_sensor_init(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+	struct device_node *np = tdev->dev->of_node;
+	char cell_name[20];
+	struct nvmem_cell *cell;
+	unsigned char *buf;
+	size_t buf_size;
+
+	sen->reg = of_iomap(np, index);
+	if (!sen->reg)
+		return -ENOMEM;
+	sen->available = true;
+
+	sprintf(cell_name, "calibration%d", index);
+	cell = nvmem_cell_get(tdev->dev, cell_name);
+	if (IS_ERR(cell)) {
+		dev_warn(tdev->dev, "nvmem_cell_get() returns %ld\n",
+			PTR_ERR(cell));
+		goto done;
+	}
+	buf = nvmem_cell_read(cell, &buf_size);
+	nvmem_cell_put(cell);
+	dev_info(tdev->dev, "sensor%d: calibration=%d\n", index, (int)buf[0]);
+	sen->calibration_data = (int)buf[0] * 1000;
+	kfree(buf);
+done:
+	return 0;
+}
+
+static void rtd119x_sensor_exit(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	if (!sen->available)
+		return;
+	sen->available = false;
+	iounmap(sen->reg);
+}
+
+static inline int rtd119x_sensor_get_temp(struct thermal_sensor_device *tdev,
+	int index, int *temp)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+	int i;
+	u64 t;
+	u32 val, cmp_data;
+
+	if (!sen->available)
+		return -EINVAL;
+
+	/* enable */
+	writel(0x0000c80c, sen->reg);
+	usleep_range(15, 25);
+
+	/* thermal detect */
+	for (i = 6; i >= 0; i--) {
+		val = readl(sen->reg);
+		cmp_data = BIT(i + 5);
+		writel(cmp_data | val, sen->reg);
+		usleep_range(15, 25);
+
+		val = readl(sen->reg);
+		if ((val & BIT(16)) == 0)
+			writel(~cmp_data & val, sen->reg);
+	}
+
+	/* get temperture */
+	val = readl(sen->reg);
+	t = (val >> 5) & 0x7f;
+	t *= 1000;
+	t -= sen->calibration_data;
+	t = (t * 165) / 128;
+	if (sen->calibration_data)
+		t += 25 * 1000;
+	else
+		t -= 47 * 1000;
+
+	dev_dbg(tdev->dev, "sensor%d: reg=%05x, t=%lld, calibration_data=%d\n",
+		index, val, t, sen->calibration_data);
+	*temp = (int)t;
+	return 0;
+}
+
+static const struct thermal_sensor_hw_ops rtd119x_hw_ops = {
+	.get_temp = rtd119x_sensor_get_temp,
+	.reset    = rtd119x_sensor_reset,
+	.init     = rtd119x_sensor_init,
+	.exit     = rtd119x_sensor_exit,
+};
+
+const struct thermal_sensor_desc rtd119x_sensor_desc = {
+	.hw_ops = &rtd119x_hw_ops,
+	.num_sensors = 2,
+};
+
diff --git a/drivers/thermal/realtek/sensor-rtd129x.c b/drivers/thermal/realtek/sensor-rtd129x.c
new file mode 100644
index 00000000..20f362b
--- /dev/null
+++ b/drivers/thermal/realtek/sensor-rtd129x.c
@@ -0,0 +1,115 @@
+/*
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/bitops.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/of_address.h>
+#include "sensor.h"
+
+/* Thermal sensor offset
+ */
+#define TM_SENSOR_CTRL0    0x00
+#define TM_SENSOR_CTRL1    0x04
+#define TM_SENSOR_CTRL2    0x08
+#define TM_SENSOR_CTRL3    0x0C
+#define TM_SENSOR_CTRL4    0x10
+#define TM_SENSOR_CTRL5    0x14
+#define TM_SENSOR_STATUS1  0x18
+#define TM_SENSOR_STATUS2  0x1C
+
+static void rtd129x_sensor_reset(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	writel(0x01904001, sen->reg + TM_SENSOR_CTRL2);
+	writel(0x01924001, sen->reg + TM_SENSOR_CTRL2);
+	usleep_range(25000, 26000);
+}
+
+static int rtd129x_sensor_init(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	sen->reg = of_iomap(tdev->dev->of_node, index);
+	if (!sen->reg)
+		return -ENOMEM;
+	sen->available = true;
+	return 0;
+}
+
+static void rtd129x_sensor_exit(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	if (!sen->available)
+		return;
+	sen->available = false;
+	iounmap(sen->reg);
+}
+
+static inline int __hw_get_temp(void *reg)
+{
+	unsigned int val = readl(reg + TM_SENSOR_STATUS1);
+
+	return __signext(18, val) * 1000 / 1024;
+}
+
+static inline int __hw_check_status_error(void *reg)
+{
+	unsigned int val = readl(reg + TM_SENSOR_STATUS2);
+
+	return val == 0 || val == 0x3FFFFF;
+}
+
+static inline int rtd129x_sensor_get_temp(struct thermal_sensor_device *tdev,
+	int index, int *temp)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+	int t = 0;
+
+	t = __hw_get_temp(sen->reg);
+
+	if (t < -3000 || t > 150000 || __hw_check_status_error(sen->reg)) {
+		dev_info(tdev->dev, "reset: temp=%d, status={%08x, %08x}\n",
+			t, readl(sen->reg + TM_SENSOR_STATUS1),
+			readl(sen->reg + TM_SENSOR_STATUS2));
+
+		rtd129x_sensor_reset(tdev, index);
+		t = __hw_get_temp(sen->reg);
+	}
+	*temp = t;
+
+	return 0;
+}
+
+static const struct thermal_sensor_hw_ops rtd129x_hw_ops = {
+	.get_temp = rtd129x_sensor_get_temp,
+	.reset    = rtd129x_sensor_reset,
+	.init     = rtd129x_sensor_init,
+	.exit     = rtd129x_sensor_exit,
+};
+
+const struct thermal_sensor_desc rtd129x_sensor_desc = {
+	.hw_ops = &rtd129x_hw_ops,
+	.num_sensors = 1,
+};
+
diff --git a/drivers/thermal/realtek/sensor-rtd139x.c b/drivers/thermal/realtek/sensor-rtd139x.c
new file mode 100644
index 00000000..ef97e3f
--- /dev/null
+++ b/drivers/thermal/realtek/sensor-rtd139x.c
@@ -0,0 +1,117 @@
+/*
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/bitops.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/of_address.h>
+#include "sensor.h"
+
+/*
+ * thermal sensor offset
+ */
+#define TM_SENSOR_CTRL0    0x00
+#define TM_SENSOR_CTRL1    0x04
+#define TM_SENSOR_CTRL2    0x08
+#define TM_SENSOR_CTRL3    0x0C
+#define TM_SENSOR_CTRL4    0x10
+#define TM_SENSOR_CTRL5    0x14
+#define TM_SENSOR_STATUS1  0x18
+#define TM_SENSOR_STATUS2  0x1C
+
+static void rtd139x_sensor_reset(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	writel(0x11904000, sen->reg + TM_SENSOR_CTRL2);
+	writel(0x11924000, sen->reg + TM_SENSOR_CTRL2);
+	usleep_range(25000, 26000);
+
+}
+
+static int rtd139x_sensor_init(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	sen->reg = of_iomap(tdev->dev->of_node, index);
+	if (!sen->reg)
+		return -ENOMEM;
+	sen->available = true;
+
+	writel(0x081fc000, sen->reg + TM_SENSOR_CTRL0);
+	writel(0x05772000, sen->reg + TM_SENSOR_CTRL1);
+	writel(0x11824000, sen->reg + TM_SENSOR_CTRL2);
+	writel(0x11924000, sen->reg + TM_SENSOR_CTRL2);
+	udelay(6);
+	return 0;
+}
+
+static void rtd139x_sensor_exit(struct thermal_sensor_device *tdev,
+	int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	if (!sen->available)
+		return;
+
+	sen->available = false;
+	iounmap(sen->reg);
+}
+
+static inline int __hw_get_temp(void *reg)
+{
+	unsigned int val = readl(reg + TM_SENSOR_STATUS1);
+
+	return __signext(18, val) * 1000 / 1024;
+}
+
+static inline int rtd139x_sensor_get_temp(struct thermal_sensor_device *tdev,
+	int index, int *temp)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+	int t = 0;
+
+	t = __hw_get_temp(sen->reg);
+
+	if (t < -3000 || t > 150000) {
+		dev_info(tdev->dev, "reset: temp=%d, status={%08x, %08x}\n",
+			t, readl(sen->reg + TM_SENSOR_STATUS1),
+			readl(sen->reg + TM_SENSOR_STATUS2));
+
+		rtd139x_sensor_reset(tdev, index);
+		t = __hw_get_temp(sen->reg);
+	}
+	*temp = t;
+
+	return 0;
+}
+
+static const struct thermal_sensor_hw_ops rtd139x_sensor_hw_ops = {
+	.get_temp = rtd139x_sensor_get_temp,
+	.reset    = rtd139x_sensor_reset,
+	.init     = rtd139x_sensor_init,
+	.exit     = rtd139x_sensor_exit,
+};
+
+const struct thermal_sensor_desc rtd139x_sensor_desc = {
+	.hw_ops = &rtd139x_sensor_hw_ops,
+	.num_sensors = 1,
+};
diff --git a/drivers/thermal/realtek/sensor-rtd13xx.c b/drivers/thermal/realtek/sensor-rtd13xx.c
new file mode 100644
index 00000000..695a3d2
--- /dev/null
+++ b/drivers/thermal/realtek/sensor-rtd13xx.c
@@ -0,0 +1,124 @@
+/*
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/bitops.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/of_address.h>
+#include "sensor.h"
+
+/*
+ * thermal sensor offset
+ */
+#define SC_DUMMY_1         0x604
+#define TM_SENSOR_CTRL0    0xb00
+#define TM_SENSOR_CTRL1    0xb04
+#define TM_SENSOR_CTRL2    0xb08
+#define TM_SENSOR_STATUS0  0xb40
+#define TM_SENSOR_STATUS1  0xb44
+
+
+static void rtd13xx_sensor_reset(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	writel(0x08130000, sen->reg + TM_SENSOR_CTRL0);
+	writel(0x003723ff, sen->reg + TM_SENSOR_CTRL1);
+	writel(0x00011114, sen->reg + TM_SENSOR_CTRL2);
+	writel(0x00031114, sen->reg + TM_SENSOR_CTRL2);
+	writel(0xfffffffe, sen->reg + SC_DUMMY_1);
+	sen->ts_reset = ktime_get();
+}
+
+static int rtd13xx_sensor_init(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	sen->reg = of_iomap(tdev->dev->of_node, index);
+	if (!sen->reg)
+		return -ENOMEM;
+	sen->available = true;
+
+	rtd13xx_sensor_reset(tdev, index);
+	return 0;
+}
+
+static void rtd13xx_sensor_exit(struct thermal_sensor_device *tdev,
+	int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	if (!sen->available)
+		return;
+
+	sen->available = false;
+	iounmap(sen->reg);
+}
+
+static inline int __hw_get_temp(void *reg)
+{
+	unsigned int val = readl(reg + TM_SENSOR_STATUS0);
+
+	return __signext(18, val) * 1000 / 1024;
+}
+
+static inline int rtd13xx_sensor_get_temp(struct thermal_sensor_device *tdev,
+	int index, int *temp)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+	int t = 0;
+	ktime_t delta;
+
+	delta = ktime_sub(ktime_get(), sen->ts_reset);
+	if (ktime_to_ms(delta) < 12) {
+		u32 wait_ms = 12 - ktime_to_ms(delta);
+
+		msleep(wait_ms);
+		dev_dbg(tdev->dev, "wait %ums\n", wait_ms);
+	}
+
+	t = __hw_get_temp(sen->reg);
+
+	if (t < -3000 || t > 150000) {
+		dev_info(tdev->dev, "reset: temp=%d, status={%08x, %08x}\n",
+			t, readl(sen->reg + TM_SENSOR_STATUS0),
+			readl(sen->reg + TM_SENSOR_STATUS1));
+
+		rtd13xx_sensor_reset(tdev, index);
+		usleep_range(10000, 12000);
+		t = __hw_get_temp(sen->reg);
+	}
+	*temp = t;
+
+	return 0;
+}
+
+static const struct thermal_sensor_hw_ops rtd13xx_sensor_hw_ops = {
+	.get_temp = rtd13xx_sensor_get_temp,
+	.reset    = rtd13xx_sensor_reset,
+	.init     = rtd13xx_sensor_init,
+	.exit     = rtd13xx_sensor_exit,
+};
+
+const struct thermal_sensor_desc rtd13xx_sensor_desc = {
+	.hw_ops = &rtd13xx_sensor_hw_ops,
+	.num_sensors = 1,
+};
diff --git a/drivers/thermal/realtek/sensor-rtd16xx.c b/drivers/thermal/realtek/sensor-rtd16xx.c
new file mode 100644
index 00000000..48e3bdc
--- /dev/null
+++ b/drivers/thermal/realtek/sensor-rtd16xx.c
@@ -0,0 +1,121 @@
+/*
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/bitops.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/of_address.h>
+#include "sensor.h"
+
+/*
+ * thermal sensor offset
+ */
+#define TM_SENSOR_CTRL0    0x00
+#define TM_SENSOR_CTRL1    0x04
+#define TM_SENSOR_CTRL2    0x08
+#define TM_SENSOR_STATUS0  0x40
+#define TM_SENSOR_STATUS1  0x44
+
+static void rtd16xx_sensor_reset(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	writel(0x07ce7ae1, sen->reg + TM_SENSOR_CTRL0);
+	writel(0x00378228, sen->reg + TM_SENSOR_CTRL1);
+	writel(0x00011114, sen->reg + TM_SENSOR_CTRL2);
+	writel(0x00031114, sen->reg + TM_SENSOR_CTRL2);
+	sen->ts_reset = ktime_get();
+}
+
+static int rtd16xx_sensor_init(struct thermal_sensor_device *tdev, int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	sen->reg = of_iomap(tdev->dev->of_node, index);
+	if (!sen->reg)
+		return -ENOMEM;
+	sen->available = true;
+
+	rtd16xx_sensor_reset(tdev, index);
+	return 0;
+}
+
+static void rtd16xx_sensor_exit(struct thermal_sensor_device *tdev,
+	int index)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+
+	if (!sen->available)
+		return;
+
+	sen->available = false;
+	iounmap(sen->reg);
+}
+
+static inline int __hw_get_temp(void *reg)
+{
+	unsigned int val = readl(reg + TM_SENSOR_STATUS0);
+
+	return __signext(18, val) * 1000 / 1024;
+}
+
+static inline int rtd16xx_sensor_get_temp(struct thermal_sensor_device *tdev,
+	int index, int *temp)
+{
+	struct thermal_sensor *sen = &tdev->sensors[index];
+	int t = 0;
+	ktime_t delta;
+
+	delta = ktime_sub(ktime_get(), sen->ts_reset);
+	if (ktime_to_ms(delta) < 12) {
+		u32 wait_ms = 12 - ktime_to_ms(delta);
+
+		msleep(wait_ms);
+		dev_dbg(tdev->dev, "wait %ums\n", wait_ms);
+	}
+
+	t = __hw_get_temp(sen->reg);
+
+	if (t < -3000 || t > 150000) {
+		dev_info(tdev->dev, "reset: temp=%d, status={%08x, %08x}\n",
+			t, readl(sen->reg + TM_SENSOR_STATUS0),
+			readl(sen->reg + TM_SENSOR_STATUS1));
+
+		rtd16xx_sensor_reset(tdev, index);
+		usleep_range(10000, 12000);
+		t = __hw_get_temp(sen->reg);
+	}
+	*temp = t;
+
+	return 0;
+}
+
+static const struct thermal_sensor_hw_ops rtd16xx_sensor_hw_ops = {
+	.get_temp = rtd16xx_sensor_get_temp,
+	.reset    = rtd16xx_sensor_reset,
+	.init     = rtd16xx_sensor_init,
+	.exit     = rtd16xx_sensor_exit,
+};
+
+const struct thermal_sensor_desc rtd16xx_sensor_desc = {
+	.hw_ops = &rtd16xx_sensor_hw_ops,
+	.num_sensors = 1,
+};
diff --git a/drivers/thermal/realtek/sensor.c b/drivers/thermal/realtek/sensor.c
new file mode 100644
index 00000000..13e0334
--- /dev/null
+++ b/drivers/thermal/realtek/sensor.c
@@ -0,0 +1,329 @@
+/*
+ * sensor.c - Realtek generic thermal sensor driver
+ *
+ * Copyright (C) 2017-2018 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/pm.h>
+#include <linux/slab.h>
+#include <linux/thermal.h>
+#include <linux/version.h>
+#include <linux/module.h>
+#include "../thermal_core.h"
+#include "sensor.h"
+
+static LIST_HEAD(sensor_device_list);
+static const struct thermal_zone_of_device_ops thermal_sensor_ops;
+static const struct of_device_id thermal_sensor_of_match[];
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 9, 0)
+static int __thermal_sensor_get_trend(struct thermal_zone_device *tz, int trip,
+				      enum thermal_trend *trend);
+#endif
+
+static struct thermal_sensor_device *tz_to_tdev(struct thermal_zone_device *tz)
+{
+	struct thermal_sensor_device *pos;
+
+	list_for_each_entry(pos, &sensor_device_list, list)
+		if (pos->tz == tz)
+			return pos;
+	return NULL;
+}
+
+static int thermal_sensor_set_mode(struct thermal_zone_device *tz,
+				   enum thermal_device_mode mode)
+{
+	struct thermal_instance *pos;
+	struct thermal_sensor_device *tdev = tz_to_tdev(tz);
+
+	if (mode  == THERMAL_DEVICE_DISABLED) {
+		/*
+		 * do original of_thermal_ops->set_mode to update its internal
+		 * status and clear polling_delay.
+		 */
+		tdev->old_ops->set_mode(tz, mode);
+
+		/* clear passive and passive_delay */
+		mutex_lock(&tz->lock);
+		tz->passive = 0;
+		tz->passive_delay = 0;
+		cancel_delayed_work(&tz->poll_queue);
+		mutex_unlock(&tz->lock);
+
+		/* reset cdev state */
+		list_for_each_entry(pos, &tz->thermal_instances, tz_node) {
+			if (pos->target == THERMAL_NO_TARGET)
+				continue;
+			pos->target = THERMAL_NO_TARGET;
+			pos->cdev->updated = false;
+		}
+
+		/* update cdev */
+		list_for_each_entry(pos, &tz->thermal_instances, tz_node)
+			thermal_cdev_update(pos->cdev);
+
+	} else {
+		mutex_lock(&tz->lock);
+		tz->passive_delay = tdev->passive_delay;
+		mutex_unlock(&tz->lock);
+		tdev->old_ops->set_mode(tz, mode);
+	}
+
+	return 0;
+}
+
+static int thermal_sensor_bind(struct thermal_zone_device *tz,
+			       struct thermal_cooling_device *cdev)
+{
+	struct thermal_sensor_device *tdev = tz_to_tdev(tz);
+	int ret;
+
+	ret = tdev->old_ops->bind(tz, cdev);
+	return ret;
+}
+
+static int thermal_sensor_device_add(struct device *dev,
+				     struct thermal_sensor_device *tdev,
+				     const struct thermal_sensor_desc *desc)
+{
+	tdev->dev = dev;
+	tdev->ops = &thermal_sensor_ops;
+	tdev->desc = desc;
+	tdev->sensors = devm_kcalloc(dev, desc->num_sensors,
+		sizeof(*tdev->sensors), GFP_KERNEL);
+	if (!tdev->sensors)
+		return -ENOMEM;
+
+	thermal_sensor_hw_init(tdev);
+	thermal_sensor_hw_reset(tdev);
+
+	tdev->tz = thermal_zone_of_sensor_register(dev, 0, tdev, tdev->ops);
+	if (IS_ERR(tdev->tz))
+		return PTR_ERR(tdev->tz);
+
+	/*
+	 * Copy the original thermal_zone_ops. Since the thermal_zone_ops
+	 * created by of-thermal is a copy of of_thermal_ops, we can assign
+	 * any callbacks directly.
+	 */
+	tdev->old_ops = devm_kmemdup(dev, tdev->tz->ops, sizeof(*tdev->old_ops),
+				     GFP_KERNEL);
+	if (!tdev->old_ops) {
+		dev_warn(dev, "thermal_zone_ops not override\n");
+		return 0;
+	}
+	tdev->tz->ops->set_mode = thermal_sensor_set_mode;
+	tdev->tz->ops->bind     = thermal_sensor_bind;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 9, 0)
+	tdev->tz->ops->get_trend = __thermal_sensor_get_trend;
+#endif
+
+	list_add(&tdev->list, &sensor_device_list);
+	tdev->passive_delay = tdev->tz->passive_delay;
+	tdev->polling_delay = tdev->tz->polling_delay;
+
+	thermal_sensor_add_eoh(tdev);
+	return 0;
+}
+
+static void thermal_sensor_device_remove(struct thermal_sensor_device *tdev)
+{
+	thermal_sensor_remove_eoh(tdev);
+	list_del(&tdev->list);
+	thermal_zone_of_sensor_unregister(tdev->dev, tdev->tz);
+	thermal_sensor_hw_exit(tdev);
+}
+
+static int thermal_sensor_get_temp(void *data, int *temp)
+{
+	struct thermal_sensor_device *tdev = data;
+	int ret;
+
+	ret = thermal_sensor_hw_get_temp(tdev, temp);
+	dev_dbg(tdev->dev, "temp=%d\n", *temp);
+	return ret;
+}
+
+static int thermal_sensor_get_trend(void *data,
+				    int i,
+				    enum thermal_trend *trend)
+{
+	struct thermal_sensor_device *tdev = data;
+	struct thermal_zone_device *tz = tdev->tz;
+	const struct thermal_trip *trip;
+	int delta;
+
+	/* .get_trend will be call at thermal_zone_register. */
+	if (!tz || !of_thermal_is_trip_valid(tz, i))
+		return -EINVAL;
+
+	trip = of_thermal_get_trip_points(tz) + i;
+	delta = tz->temperature - trip->temperature;
+
+	thermal_sensor_eoh_handle_restore(tdev);
+
+	if (-500 < delta && delta < 500)
+		*trend = THERMAL_TREND_STABLE;
+	else if (delta > 5000)
+		*trend = THERMAL_TREND_RAISE_FULL;
+	else if (delta > 0)
+		*trend = THERMAL_TREND_RAISING;
+	else
+		*trend = THERMAL_TREND_DROPPING;
+
+	dev_dbg(tdev->dev, "trip%d, delta=%d, trend=%d\n", i,
+		delta, *trend);
+
+	thermal_sensor_eoh_handle_overheat(tdev, i, *trend);
+	return 0;
+}
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 9, 0)
+
+static int __thermal_sensor_get_trend(struct thermal_zone_device *tz, int trip,
+				      enum thermal_trend *trend)
+{
+	struct thermal_sensor_device *tdev = tz_to_tdev(tz);
+
+	return thermal_sensor_get_trend(tdev, trip, trend);
+}
+
+#endif
+
+static const struct thermal_zone_of_device_ops thermal_sensor_ops = {
+	.get_temp  = thermal_sensor_get_temp,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 9, 0)
+	.get_trend = thermal_sensor_get_trend,
+#endif
+};
+
+static int thermal_sensor_resume(struct device *dev)
+{
+	struct thermal_sensor_device *tdev = dev_get_drvdata(dev);
+
+	dev_info(dev, "enter %s\n", __func__);
+	thermal_sensor_hw_reset(tdev);
+	dev_info(dev, "exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops thermal_sensor_pm_ops = {
+	.resume = thermal_sensor_resume,
+};
+
+static int thermal_sensor_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	struct thermal_sensor_device *tdev;
+	int ret = 0;
+	const struct of_device_id *id;
+	const struct thermal_sensor_desc *desc;
+
+	id = of_match_node(thermal_sensor_of_match, np);
+	if (id)
+		desc = id->data;
+
+	if (!id || !desc)
+		return -EINVAL;
+
+	tdev = devm_kzalloc(dev, sizeof(*tdev), GFP_KERNEL);
+	if (!tdev)
+		return -ENOMEM;
+
+	ret = thermal_sensor_device_add(dev, tdev, desc);
+	if (ret)
+		dev_err(dev, "failed to add thermal sensor: %d\n", ret);
+	platform_set_drvdata(pdev, tdev);
+	dev_info(dev, "initialized\n");
+	return 0;
+}
+
+static int thermal_sensor_remove(struct platform_device *pdev)
+{
+	struct thermal_sensor_device *tdev = platform_get_drvdata(pdev);
+
+	thermal_sensor_device_remove(tdev);
+	platform_set_drvdata(pdev, NULL);
+	dev_info(&pdev->dev, "removed\n");
+	return 0;
+}
+
+static void thermal_sensor_shutdown(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct thermal_sensor_device *tdev = platform_get_drvdata(pdev);
+
+	dev_info(dev, "%s: stop tz_dev\n", __func__);
+	tdev->tz->ops->set_mode(tdev->tz, THERMAL_DEVICE_DISABLED);
+};
+
+
+static const struct of_device_id thermal_sensor_of_match[] = {
+#ifdef CONFIG_RTK_THERMAL_RTD119X
+	{
+		.compatible = "realtek,rtd119x-thermal-sensor",
+		.data = &rtd119x_sensor_desc,
+	},
+#endif
+#ifdef CONFIG_RTK_THERMAL_RTD129X
+	{
+		.compatible = "realtek,rtd129x-thermal-sensor",
+		.data = &rtd129x_sensor_desc,
+	},
+#endif
+#ifdef CONFIG_RTK_THERMAL_RTD139X
+	{
+		.compatible = "realtek,rtd139x-thermal-sensor",
+		.data = &rtd139x_sensor_desc,
+	},
+#endif
+#ifdef CONFIG_RTK_THERMAL_RTD16XX
+	{
+		.compatible = "realtek,rtd16xx-thermal-sensor",
+		.data = &rtd16xx_sensor_desc,
+	},
+#endif
+#ifdef CONFIG_RTK_THERMAL_RTD13XX
+	{
+		.compatible = "realtek,rtd13xx-thermal-sensor",
+		.data = &rtd13xx_sensor_desc,
+	},
+#endif
+	{}
+};
+
+static struct platform_driver thermal_sensor_drv = {
+	.driver = {
+		.name           = "rtk-thermal-sensor",
+		.owner          = THIS_MODULE,
+		.of_match_table = of_match_ptr(thermal_sensor_of_match),
+		.pm             = &thermal_sensor_pm_ops,
+	},
+	.probe    = thermal_sensor_probe,
+	.remove   = thermal_sensor_remove,
+	.shutdown = thermal_sensor_shutdown,
+};
+module_platform_driver(thermal_sensor_drv);
diff --git a/drivers/thermal/realtek/sensor.h b/drivers/thermal/realtek/sensor.h
new file mode 100644
index 00000000..fa4d9b0
--- /dev/null
+++ b/drivers/thermal/realtek/sensor.h
@@ -0,0 +1,191 @@
+/*
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#ifndef __REALTEK_THERMAL_H
+#define __REALTEK_THERMAL_H
+
+#include <linux/device.h>
+#include <linux/list.h>
+#include <linux/thermal.h>
+#include <linux/notifier.h>
+#include <linux/ktime.h>
+
+struct thermal_sensor_device;
+struct thermal_cooling_device;
+
+struct thermal_sensor_hw_ops {
+	int (*init)(struct thermal_sensor_device *, int);
+	void (*exit)(struct thermal_sensor_device *, int);
+	void (*reset)(struct thermal_sensor_device *, int);
+	int (*get_temp)(struct thermal_sensor_device *, int, int *);
+};
+
+struct thermal_sensor_desc {
+	int num_sensors;
+	const struct thermal_sensor_hw_ops *hw_ops;
+};
+
+struct thermal_sensor {
+	void __iomem *reg;
+	bool available;
+	int calibration_data;
+	int weight;
+	ktime_t ts_reset;
+};
+
+struct thermal_sensor_device {
+	struct device *dev;
+	const struct thermal_zone_of_device_ops *ops;
+	struct thermal_zone_device *tz;
+	struct list_head list;
+	int passive_delay;
+	int polling_delay;
+
+	const struct thermal_sensor_desc *desc;
+	struct thermal_sensor *sensors;
+	struct thermal_zone_device_ops *old_ops;
+
+#ifdef CONFIG_RTK_THERMAL_EOH
+	unsigned int eoh_state;
+#define THERMAL_SENSOR_EOH_NONE    0
+#define THERMAL_SENSOR_EOH_START   1
+#define THERMAL_SENSOR_EOH_POLL    2
+	unsigned int eoh_freq;
+	unsigned int eoh_restore_ms;
+	ktime_t eoh_time;
+	struct notifier_block eoh_cpufreq_nb;
+#endif /* CONFIG_RTK_THERMAL_EOH */
+};
+
+static inline void thermal_sensor_hw_init(struct thermal_sensor_device *tdev)
+{
+	const struct thermal_sensor_desc *desc = tdev->desc;
+	int i;
+	int ret;
+
+	if (!desc->hw_ops->init)
+		return;
+
+	for (i = 0; i < desc->num_sensors; i++) {
+		ret = desc->hw_ops->init(tdev, i);
+		if (!ret)
+			continue;
+		dev_warn(tdev->dev, "failed to init sensor%d: %d\n", i, ret);
+	}
+}
+
+static inline void thermal_sensor_hw_exit(struct thermal_sensor_device *tdev)
+{
+	const struct thermal_sensor_desc *desc = tdev->desc;
+	int i;
+
+	if (!desc->hw_ops->exit)
+		return;
+
+	for (i = 0; i < desc->num_sensors; i++)
+		desc->hw_ops->exit(tdev, i);
+}
+
+static inline void thermal_sensor_hw_reset(struct thermal_sensor_device *tdev)
+{
+	const struct thermal_sensor_desc *desc = tdev->desc;
+	int i;
+
+	if (!desc->hw_ops->reset)
+		return;
+
+	for (i = 0; i < desc->num_sensors; i++)
+		desc->hw_ops->reset(tdev, i);
+}
+
+static inline int thermal_sensor_hw_get_temp(struct thermal_sensor_device *tdev,
+					     int *temp)
+{
+	const struct thermal_sensor_desc *desc = tdev->desc;
+	int ret;
+	int i;
+	int t, max_t = INT_MIN;
+
+	if (!desc->hw_ops->get_temp)
+		return -EINVAL;
+
+	for (i = 0; i < desc->num_sensors; i++) {
+		ret = desc->hw_ops->get_temp(tdev, i, &t);
+		if (ret == 0 && max_t < t)
+			max_t = t;
+	}
+	*temp = max_t;
+	return 0;
+}
+
+extern const struct thermal_sensor_desc rtd119x_sensor_desc;
+extern const struct thermal_sensor_desc rtd129x_sensor_desc;
+extern const struct thermal_sensor_desc rtd139x_sensor_desc;
+extern const struct thermal_sensor_desc rtd16xx_sensor_desc;
+extern const struct thermal_sensor_desc rtd13xx_sensor_desc;
+
+/* helper function */
+static inline int __signext(int signb, unsigned int v)
+{
+	int x = 31 - signb;
+
+	return ((int)(v << x)) >> x;
+}
+
+static inline bool cdev_is_cpufreq(struct thermal_cooling_device *cdev)
+{
+	return !strncmp("thermal-cpufreq-0", cdev->type, THERMAL_NAME_LENGTH);
+}
+
+
+#ifdef CONFIG_RTK_THERMAL_EOH
+void thermal_sensor_eoh_handle_restore(struct thermal_sensor_device *tdev);
+void thermal_sensor_eoh_handle_overheat(struct thermal_sensor_device *tdev,
+					int i, enum thermal_trend trend);
+int thermal_sensor_add_eoh(struct thermal_sensor_device *tdev);
+void thermal_sensor_remove_eoh(struct thermal_sensor_device *tdev);
+#else
+
+static inline
+void thermal_sensor_eoh_handle_restore(struct thermal_sensor_device *tdev)
+{
+}
+
+static inline
+void thermal_sensor_eoh_handle_overheat(struct thermal_sensor_device *tdev,
+					int i, enum thermal_trend trend)
+{
+}
+
+static inline
+int thermal_sensor_add_eoh(struct thermal_sensor_device *tdev)
+{
+	return 0;
+}
+
+static inline
+void thermal_sensor_remove_eoh(struct thermal_sensor_device *tdev)
+{
+}
+
+#endif /* CONFIG_RTK_THERMAL_EOH */
+
+#endif
diff --git a/drivers/tsio/Kconfig b/drivers/tsio/Kconfig
new file mode 100644
index 00000000..25ccb66
--- /dev/null
+++ b/drivers/tsio/Kconfig
@@ -0,0 +1,9 @@
+menu "TSIO Smart Card Support"
+
+config TSIO
+	bool "tsio function"
+	default n
+	help
+	    Support tsio smart card.
+
+endmenu
diff --git a/drivers/tsio/Makefile b/drivers/tsio/Makefile
new file mode 100755
index 00000000..a15d1ae
--- /dev/null
+++ b/drivers/tsio/Makefile
@@ -0,0 +1 @@
+obj-$(CONFIG_TSIO) += tsio.o
diff --git a/drivers/tsio/tsio.c b/drivers/tsio/tsio.c
new file mode 100755
index 00000000..d1cfdfd
--- /dev/null
+++ b/drivers/tsio/tsio.c
@@ -0,0 +1,541 @@
+#include <linux/init.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/fs.h>
+#include <linux/delay.h>
+#include <linux/major.h>
+#include <linux/device.h>
+#include <linux/uaccess.h>
+#include <linux/io.h>
+#include <linux/slab.h>
+#include <linux/dma-mapping.h>
+#include "tsio.h"
+#include "tsio_dev.h"
+#include "tsio_dbg.h"
+
+#define rtd_inl(offset)             readl(offset)
+#define rtd_outl(offset,val)        writel(val, offset)
+
+struct class * tsio_dev_class = NULL;
+static char * p_high_fifo = NULL;
+static char * p_middle_fifo = NULL;
+static char * p_low_fifo = NULL;
+static unsigned long hfifo_phy_addr = 0, mfifo_phy_addr = 0;
+static dma_addr_t phy_high_fifo;
+static dma_addr_t phy_middle_fifo;
+static struct device *tsio_dev;
+
+static unsigned long bytes_to_long(unsigned char* p_data)
+{
+    unsigned long l = 0;
+    
+    l = ((p_data[3]<<24) | (p_data[2]<<16) | (p_data[1]<<8) | p_data[0]);
+    return l;
+}
+
+static int tsio_send_cc(char * cc_arr, unsigned int data_len) 
+{
+    unsigned int data = 0, round = 0, i;
+    unsigned char * cc_ptr = (unsigned char *)cc_arr;
+    int rx_timeout = 0, rx_err = 0, ret = 0;
+    unsigned long cc_data;
+    void __iomem *tsio_reg_base = ioremap(TSIO_REG_BASE, 0x400);
+
+    rtd_outl(tsio_reg_base + TSIO_CCTX_IDX, 0x0);
+    
+    round = data_len/4;
+    if((data_len%4) != 0) {
+        round++;
+    }
+
+    for( i = 0; i < round; i++) {
+        data = bytes_to_long(cc_ptr);
+        rtd_outl(tsio_reg_base + TSIO_CCTX, data);
+	cc_ptr += 4;
+    }
+
+    data_len |= TSIO_START_TX;
+    rtd_outl(tsio_reg_base + TSIO_CCTX_CRTL, data_len);
+
+    i = 0;
+    while(!(rtd_inl(tsio_reg_base + TSIO_CCTX_CRTL)&TSIO_TX_DONE)) {
+        if(i > 20) {
+            break;
+        }
+
+        udelay(50);
+	i++;
+    }
+    rtd_outl(tsio_reg_base + TSIO_CCTX_CRTL, 0x0);
+
+    i = 0;
+    while(!(rtd_inl(tsio_reg_base + TSIO_CCRX_CRTL)&TSIO_RX_DONE)) {
+        if(rtd_inl(tsio_reg_base + TSIO_CCRX_CRTL) & TSIO_RX_ERR) {
+            rx_err = 1;
+            break;
+        }
+
+        if(i > 20) {
+            rx_timeout = 1;
+            break;
+        }
+        udelay(50);
+	i++;
+    }
+
+    rtd_outl(tsio_reg_base + TSIO_CCRX_IDX, 0x0);
+    rtd_outl(tsio_reg_base + TSIO_CCRX_CRTL, 0x0);
+    
+    if(rx_err == 1 || rx_timeout == 1) {
+        ret = 1;
+    } else {
+        ret = 0;
+
+        for( i = 0; i < round; i++) {
+            cc_data = rtd_inl(tsio_reg_base + TSIO_CCRX);
+            TSIO_TRACE("TSIO_CCRX(0x%x): 0x%x\n", tsio_reg_base + TSIO_CCRX, cc_data);
+        }
+    }
+
+    iounmap(tsio_reg_base);
+
+    return ret;
+}
+
+static int tsio_start_descriptor(unsigned char file_mode){
+    int i, ret = 1;
+    unsigned int wptr_fifo, wptr_reg = 0, rptr_reg = 0;
+    void __iomem *tsio_reg_base = ioremap(TSIO_REG_BASE, 0x400);
+
+    if(file_mode == TSIO_CCP_TS) {
+        wptr_reg = tsio_reg_base + TSIO_FIFO_M_WPTR;
+        rptr_reg = tsio_reg_base + TSIO_FIFO_M_RPTR;
+    } else {
+        wptr_reg = tsio_reg_base + TSIO_FIFO_H_WPTR;
+        rptr_reg = tsio_reg_base + TSIO_FIFO_H_RPTR;
+    }
+
+    //wptr_fifo = rtd_inl(wptr_reg);
+    //wptr_fifo += 0x10;
+    //rtd_outl(wptr_reg, wptr_fifo);
+
+    TSIO_TRACE("tsio start des!\n");
+    wptr_fifo = rtd_inl(tsio_reg_base + TSIO_FIFO_H_WPTR);
+    wptr_fifo += 0x10;
+    rtd_outl(tsio_reg_base + TSIO_FIFO_H_WPTR, wptr_fifo);
+
+    i = 0;
+    while(rtd_inl(tsio_reg_base + TSIO_FIFO_H_WPTR) != rtd_inl(tsio_reg_base + TSIO_FIFO_H_RPTR)) {
+        if(rtd_inl(tsio_reg_base + TSIO_EXE_INFO) & (1<<7)) {
+            ret = 0;
+            TSIO_TRACE("tsio lost sync! \n");
+            break;
+        }
+
+        if(i >= 4000) { //2000
+            ret = 0;
+            TSIO_TRACE("tsio time out! \n");
+            break;
+        }
+        
+        udelay(500);
+        i++;
+    }
+
+    if(1) {
+        TSIO_TRACE("TSIO_LINK_STATE: 0x%x\n", rtd_inl(tsio_reg_base + TSIO_LINK_STATE));
+        TSIO_TRACE("TSIO_FIFO_H_RPTR: 0x%x\n", rtd_inl(tsio_reg_base + TSIO_FIFO_H_RPTR));
+        TSIO_TRACE("TSIO_FIFO_H_WPTR: 0x%x\n", rtd_inl(tsio_reg_base + TSIO_FIFO_H_WPTR));
+        TSIO_TRACE("TSIO_FIFO_M_RPTR: 0x%x\n", rtd_inl(tsio_reg_base + TSIO_FIFO_M_RPTR));
+        TSIO_TRACE("TSIO_FIFO_M_WPTR: 0x%x\n", rtd_inl(tsio_reg_base + TSIO_FIFO_M_WPTR));
+        TSIO_TRACE("TSIO_EXE_INFO: 0x%x\n", rtd_inl(tsio_reg_base + TSIO_EXE_INFO));
+        TSIO_TRACE("DESP_EXE_INT: 0x%x\n", rtd_inl(tsio_reg_base + DESP_EXE_INT));
+    }
+
+    iounmap(tsio_reg_base);
+    return ret;
+}
+
+static void tsio_set_descriptor(unsigned char file_mode, unsigned char srv_id, unsigned long phy_src_addr, unsigned long phy_dst_addr, unsigned long data_len){
+    char * des_addr = NULL;
+    unsigned long wptr_fifo, rptr_fifo, des_data_len;
+    unsigned char setting[4];
+    void __iomem *tsio_reg_base = ioremap(TSIO_REG_BASE, 0x400);
+
+    memset(setting, 0, sizeof(setting));
+
+    if(file_mode == TSIO_CCP_TS) {
+        des_addr = p_middle_fifo;
+    } else {
+        des_addr = p_high_fifo;
+    }
+
+    if(des_addr == NULL) return;
+
+    wptr_fifo = rtd_inl(tsio_reg_base + TSIO_FIFO_H_WPTR);
+    rptr_fifo = rtd_inl(tsio_reg_base + TSIO_FIFO_H_RPTR);
+
+    if(wptr_fifo == rptr_fifo) {
+	if(file_mode == TSIO_TS || file_mode == TSIO_CCP_TS) {
+            des_data_len = data_len & 0x01FFFFFF;
+            setting[0] = (des_data_len & 0x000000FF);
+            setting[1] = ((des_data_len & 0x0000FF00)>>8);
+            setting[2] = ((des_data_len & 0x00FF0000)>>16);
+            setting[3] = ((srv_id & 0x3f)<<2) | (des_data_len>>24);
+            setting[3] |= 0x02;
+
+            memset(((char *)des_addr), 0, 4);
+            memcpy(((char *)des_addr)+4, &phy_src_addr, 4);
+            memcpy(((char *)des_addr)+8, setting, 4);
+            memset(((char *)des_addr)+12, 0, 4);
+	} else if(file_mode == TSIO_BLK){
+            des_data_len = data_len & 0x01FFFFFF;
+            setting[0] = (des_data_len & 0x000000FF);
+            setting[1] = ((des_data_len & 0x0000FF00)>>8);
+            setting[2] = ((des_data_len & 0x00FF0000)>>16);
+            setting[3] = ((srv_id & 0x3f)<<2) | (des_data_len>>24);
+
+            memcpy(((char *)des_addr), &phy_dst_addr, 4);
+            memcpy(((char *)des_addr)+4, &phy_src_addr, 4);
+            memcpy(((char *)des_addr)+8, setting, 4);
+            memset(((char *)des_addr)+12, 0, 4);
+	    TSIO_TRACE("tsio_set_descriptor TSIO_BLK\n");
+        }
+    }
+
+    TSIO_TRACE("Dump des_addr: 0x%08x\n", des_addr);
+    TSIO_TRACE("%02x %02x %02x %02x \n", des_addr[0], des_addr[1], des_addr[2], des_addr[3]);
+    TSIO_TRACE("%02x %02x %02x %02x \n", des_addr[4], des_addr[5], des_addr[6], des_addr[7]);
+    TSIO_TRACE("%02x %02x %02x %02x \n", des_addr[8], des_addr[9], des_addr[10], des_addr[11]);
+    TSIO_TRACE("%02x %02x %02x %02x \n", des_addr[12], des_addr[13], des_addr[14], des_addr[15]);
+    iounmap(tsio_reg_base);
+}
+
+static void tsio_set_ring_buff(unsigned long phy_addr, unsigned long buff_size, int level){
+    void __iomem *tsio_reg_base = ioremap(TSIO_REG_BASE, 0x400);
+    if(level == TSIO_H_QUEUE) {
+        rtd_outl(tsio_reg_base + TSIO_FIFO_H_BASE, phy_addr);
+        rtd_outl(tsio_reg_base + TSIO_FIFO_H_LIMIT, phy_addr+buff_size);
+        rtd_outl(tsio_reg_base + TSIO_FIFO_H_WPTR, phy_addr);
+    } else if(level == TSIO_M_QUEUE) {
+        rtd_outl(tsio_reg_base + TSIO_FIFO_M_BASE, phy_addr);
+        rtd_outl(tsio_reg_base + TSIO_FIFO_M_LIMIT, phy_addr+buff_size);
+        rtd_outl(tsio_reg_base + TSIO_FIFO_M_WPTR, phy_addr);
+    } else if(level == TSIO_L_QUEUE) {
+        rtd_outl(tsio_reg_base + TSIO_FIFO_L_BASE, phy_addr);
+        rtd_outl(tsio_reg_base + TSIO_FIFO_L_LIMIT, phy_addr+buff_size);
+        rtd_outl(tsio_reg_base + TSIO_FIFO_L_WPTR, phy_addr);
+    }
+    iounmap(tsio_reg_base);
+}
+
+static int tsio_link_up(void){
+    int delay_cnt = 0, ret = 0;
+    void __iomem *tsio_reg_base = ioremap(TSIO_REG_BASE, 0x400);
+
+    if((rtd_inl(tsio_reg_base + TSIO_LINK_STATE)&TSIO_LINK_UP) == 0) {
+        rtd_outl(tsio_reg_base + TSIO_CRTL, 0x11070008);
+        while((rtd_inl(tsio_reg_base + TSIO_LINK_STATE)&TSIO_LINK_UP) == 0){
+           udelay(50);
+           if(delay_cnt > 20) {
+               ret = -1;
+               break;
+           }
+           delay_cnt++;
+        }
+    }
+
+    TSIO_TRACE("TSIO_CRTL(0x%x): 0x%x\n", TSIO_CRTL, rtd_inl(tsio_reg_base + TSIO_CRTL));
+    TSIO_TRACE("TSIO_LINK_STATE(0x%x): 0x%x\n", TSIO_LINK_STATE, rtd_inl(tsio_reg_base + TSIO_LINK_STATE));
+    iounmap(tsio_reg_base);
+    return ret;
+}
+
+static void tsio_link_down(void)
+{
+    if(rtd_inl(TSIO_LINK_STATE)&TSIO_LINK_UP) {
+        rtd_outl(TSIO_CRTL, 0x10070008);
+    }
+}
+
+static void tsio_clk_init(int tsio_clk){
+    unsigned int clk_setting = 0;
+
+    void __iomem *tsio_reg_base = ioremap(TSIO_REG_BASE, 0x400);
+    void __iomem *clk_reg_base = ioremap(0x98000000, 0x800);
+    void __iomem *clk_reg_base2 = ioremap(0x9803DA00, 0x100);
+
+#ifdef TSIO_BGA
+    rtd_outl(0x98007100, 0x40000000);
+    rtd_outl(0x98007104, 0x00000000);
+#endif
+
+    rtd_outl(clk_reg_base + 0x270, 0x00000157);
+    rtd_outl(clk_reg_base + 0x608, 0x081e1f80);
+    rtd_outl(clk_reg_base + 0x248, 0x1a333007);
+    rtd_outl(clk_reg_base + 0x254, 0x00001e01);
+    rtd_outl(clk_reg_base + 0x05c, 0x30000000);
+    rtd_outl(clk_reg_base + 0x068, 0x00000c00);
+    rtd_outl(clk_reg_base2 + 0x80, 0x00000000);
+    rtd_outl(clk_reg_base + 0x05c, 0x20000000);
+    rtd_outl(clk_reg_base + 0x068, 0x00000800);
+    rtd_outl(clk_reg_base + 0x250, 0x93464980);
+
+    if(tsio_clk == TSIO_100MBPS) {
+        rtd_outl(clk_reg_base + 0x250, 0x93064180);
+    } else {
+        rtd_outl(clk_reg_base + 0x250, 0x93464180);
+    }
+
+    if(tsio_clk == TSIO_50MBPS) {
+        rtd_outl(clk_reg_base + 0x250, 0x97064780); //#25MHz, Icp=2u, Rs=32K, pll BW must lowerer than 3MHz
+    }
+    rtd_outl(clk_reg_base + 0x600, 0x0000000c);
+
+    if(tsio_clk == TSIO_100MBPS) {
+        rtd_outl(clk_reg_base + 0x604, 0x00004800); // 108 Mpbs
+    } else {
+        rtd_outl(clk_reg_base + 0x604, 0x00015000); // 50/200/400 Mbps
+    }
+
+    rtd_outl(clk_reg_base + 0x600, 0x0000000d);
+    rtd_outl(clk_reg_base + 0x05c, 0xC3000000);
+    rtd_outl(clk_reg_base + 0x75c, 0x41000050);
+    rtd_outl(clk_reg_base + 0x068, 0x000000c0);
+    rtd_outl(clk_reg_base + 0x768, 0x00000040);
+    rtd_outl(clk_reg_base + 0x274, 0x0005DE10);
+    rtd_outl(clk_reg_base + 0x278, 0x000741C0);
+
+    rtd_outl(tsio_reg_base + TSIO_PHY_CLK, 0xffff);
+
+    if(tsio_clk == TSIO_100MBPS) {
+        rtd_outl(tsio_reg_base + TSIO_TX_PKT, 0x2503018); //100 Mbps
+	rtd_outl(tsio_reg_base + TSIO_CRTL, 0x110700f8); //100 Mbps
+    } else {
+        rtd_outl(tsio_reg_base + TSIO_TX_PKT, 0x2583018); //50/200/400 Mbps
+    }
+
+    rtd_outl(tsio_reg_base + TSIO_PKT, 0x3f);
+
+    clk_setting = rtd_inl(clk_reg_base + 0x084);
+    if(tsio_clk == TSIO_400MBPS) {
+        clk_setting |= ((1<<27)|(1<<26) | (1<<25)|(1<<24)); //400Mbps
+    } else if(tsio_clk == TSIO_200MBPS) {
+        clk_setting |= ((1<<27)|(1<<26) | (1<<25)|(0<<24)); //200Mbps   
+    } else if(tsio_clk == TSIO_100MBPS) {
+        clk_setting |= ((1<<27)|(0<<26) | (1<<25)|(1<<24)); //100Mbps  
+    } else if(tsio_clk == TSIO_50MBPS) {
+        clk_setting |= ((1<<27)|(0<<26) | (1<<25)|(0<<24)); //50Mbps
+    }
+    rtd_outl(clk_reg_base + 0x084, clk_setting);
+
+    iounmap(tsio_reg_base);
+    iounmap(clk_reg_base);
+    iounmap(clk_reg_base2);
+}
+
+static int tsio_open(struct inode *inode, struct file *filp)
+{
+    int ret;
+    TSIO_TRACE("tsio device open\n");
+    tsio_clk_init(TSIO_200MBPS);
+
+    tsio_set_ring_buff(phy_high_fifo, 512, TSIO_H_QUEUE);
+    tsio_set_ring_buff(phy_middle_fifo, 512, TSIO_M_QUEUE);
+    ret = tsio_link_up();
+
+    return ret;
+}
+
+static ssize_t tsio_write(struct file *f, const char __user *buf, size_t count, loff_t *offp)
+{
+    char * p_dump = NULL;
+    unsigned char write_buf[512];
+    unsigned long data_len = 0, p_src_addr = 0, p_dst_addr = 0;
+    int ret = 0, i;
+    memset(write_buf, 0, sizeof(write_buf));
+
+    TSIO_TRACE("tsio device write\n");
+    TSIO_TRACE("count = %d\n", count);
+ 
+    if(count > 512)
+        return -EFAULT;
+ 
+    if (copy_from_user(write_buf, buf, count))
+        return -EFAULT;
+
+    TSIO_TRACE("Dump write buff:\n");
+    TSIO_TRACE("%02x %02x %02x %02x \n", write_buf[0], write_buf[1], write_buf[2], write_buf[3]);
+    TSIO_TRACE("%02x %02x %02x %02x \n", write_buf[4], write_buf[5], write_buf[6], write_buf[7]);
+    TSIO_TRACE("%02x %02x %02x %02x \n", write_buf[8], write_buf[9], write_buf[10], write_buf[11]);
+    TSIO_TRACE("%02x %02x %02x %02x \n", write_buf[12], write_buf[13], write_buf[14], write_buf[15]);
+
+    if(write_buf[0] == TSIO_TS || write_buf[0] == TSIO_CCP_TS) {
+        data_len = bytes_to_long(&write_buf[4]);
+        p_src_addr = bytes_to_long(&write_buf[8]);
+        p_dst_addr = 0;
+        tsio_set_descriptor(write_buf[0], write_buf[2], p_src_addr, p_dst_addr, data_len);
+        ret = tsio_start_descriptor(write_buf[0]);
+    } else if(write_buf[0] == TSIO_BLK) {
+        data_len = bytes_to_long(&write_buf[4]);
+        p_src_addr = bytes_to_long(&write_buf[8]);
+        p_dst_addr = bytes_to_long(&write_buf[12]);
+        TSIO_TRACE("data_len: %x\n", data_len);
+        TSIO_TRACE("p_src_addr: %x\n", p_src_addr);
+        TSIO_TRACE("p_dst_addr: %x\n", p_dst_addr);
+        p_dump = phys_to_virt(p_src_addr);
+
+        TSIO_TRACE("Dump p_dump buff:\n");
+        TSIO_TRACE("%02x %02x %02x %02x \n", p_dump[0], p_dump[1], p_dump[2], p_dump[3]);
+        TSIO_TRACE("%02x %02x %02x %02x \n", p_dump[4], p_dump[5], p_dump[6], p_dump[7]);
+        tsio_set_descriptor(write_buf[0], write_buf[2], p_src_addr, p_dst_addr, data_len);
+        ret = tsio_start_descriptor(write_buf[0]);
+	TSIO_TRACE("ret = %d\n", ret);
+    } else if(write_buf[0] == TSIO_CC) {
+	data_len = bytes_to_long(&write_buf[4]);
+	tsio_send_cc(&write_buf[8], data_len);
+    }
+
+    return count;
+}
+
+static long tsio_ioctl(struct file* file, unsigned int cmd, unsigned long arg)
+{
+    long ret = 0;
+    unsigned int tsio_value;
+    void __iomem *tsio_reg_base = ioremap(TSIO_REG_BASE, 0x400);
+    void __iomem *clk_reg_base = ioremap(0x98000000, 0x800);
+
+    TSIO_TRACE("tsio device compat ioctl\n");
+
+    switch (cmd) {
+        case TSIO_GET_LINK_STATUS:
+            if((rtd_inl(tsio_reg_base + TSIO_LINK_STATE)&TSIO_LINK_UP) == 0) {
+                tsio_value = 0;
+            } else {
+                tsio_value = 1;
+            }
+            ret = copy_to_user((unsigned int __user *)arg, &tsio_value, sizeof(tsio_value)); 
+        break;
+
+        case TSIO_GET_BW:
+            tsio_value = 0;
+            if(rtd_inl(clk_reg_base + 0x084)&(1<<26)){
+                tsio_value |= (1<<1);
+            }
+
+            if(rtd_inl(clk_reg_base + 0x084)&(1<<24)){
+                tsio_value |= (1<<0);
+            }
+            ret = copy_to_user((unsigned int __user *)arg, &tsio_value, sizeof(tsio_value)); 
+        break;
+
+        case TSIO_SET_BW:
+             if (copy_from_user(&tsio_value, (unsigned int __user *)arg, sizeof(unsigned int)))
+                return -EFAULT;
+
+             if(tsio_value >= TSIO_50MBPS && tsio_value <= TSIO_400MBPS) {
+                tsio_link_down();
+                tsio_clk_init(tsio_value);
+                tsio_link_up();
+             }
+        break;
+
+        case TSIO_GET_STFF_SID:
+            tsio_value = rtd_inl(tsio_reg_base + TSIO_PKT);
+            ret = copy_to_user((unsigned int __user *)arg, &tsio_value, sizeof(tsio_value)); 
+        break;
+
+        case TSIO_SET_STFF_SID:
+            if (copy_from_user(&tsio_value, (unsigned int __user *)arg, sizeof(unsigned int)))
+                return -EFAULT;
+
+            rtd_outl(tsio_reg_base + TSIO_PKT, tsio_value);
+        break;
+
+        case TSIO_GET_SYNC_THRES:
+        break;
+
+        case TSIO_SET_SYNC_THRES:
+        break;
+
+        case TSIO_SET_KEY_IDX:
+        break;
+
+        default:
+            ret = -EFAULT;
+    }
+
+    iounmap(tsio_reg_base);
+    iounmap(clk_reg_base);
+    return ret;
+}
+
+#ifdef CONFIG_COMPAT
+static long tsio_compat_ioctl(struct file* file,unsigned int cmd, unsigned long arg)
+{
+    TSIO_TRACE("tsio device compat ioctl\n");
+    return tsio_ioctl(file, cmd,(unsigned long)compat_ptr(arg));
+}
+#endif
+
+static int tsio_release(struct inode *inode, struct file *filp)
+{
+    TSIO_TRACE("tsio device close\n");
+    return 0;
+}
+
+static const struct file_operations tsio_dev_fops = 
+{
+    .owner          = THIS_MODULE,
+    .write          = tsio_write,
+    .unlocked_ioctl = tsio_ioctl,
+#ifdef CONFIG_COMPAT
+    .compat_ioctl   = tsio_compat_ioctl,
+#endif
+    .open           = tsio_open,
+//    .release        = tsio_release,
+};
+
+static int __init tsio_init(void)
+{
+    TSIO_TRACE("<1> TSIO initial !\n");
+    if (register_chrdev(TSIO_MAJOR, "tsio", &tsio_dev_fops) < 0) {
+        TSIO_WARNING("<1>%s: can't get major %d\n", "tsio", TSIO_MAJOR);
+        return (-EBUSY);
+    }
+
+    tsio_dev_class = class_create(THIS_MODULE, "tsiodev"); // create a new class for tsio
+    tsio_dev = device_create(tsio_dev_class, NULL, MKDEV(TSIO_MAJOR,0), NULL, "tsio_sc");
+
+    TSIO_TRACE("Before dma_alloc_coherent tsio_dev\n");
+    p_high_fifo  = dma_alloc_coherent(tsio_dev, 512, &phy_high_fifo, GFP_KERNEL);
+    p_middle_fifo = dma_alloc_coherent(tsio_dev, 512, &phy_middle_fifo, GFP_KERNEL);
+    
+    TSIO_TRACE("p_high_fifo: 0x%08x\n", p_high_fifo);
+    TSIO_TRACE("phy_high_fifo: 0x%08x\n", phy_high_fifo);
+    TSIO_TRACE("p_middle_fifo: 0x%08x\n", p_middle_fifo);
+    TSIO_TRACE("phy_middle_fifo: 0x%08x\n", phy_middle_fifo);
+
+    TSIO_TRACE("<1>%s: started\n", "tsio");
+    return 0;
+}
+
+static __exit void tsio_exit(void)
+{
+    if(p_high_fifo) {
+        dma_free_coherent(tsio_dev, 512, p_high_fifo, phy_high_fifo);
+    }
+
+    if(p_middle_fifo) {
+        dma_free_coherent(tsio_dev, 512, p_middle_fifo, phy_middle_fifo);
+    }
+    device_destroy(tsio_dev_class, MKDEV(TSIO_MAJOR,0));
+    unregister_chrdev(TSIO_MAJOR, "tsio");
+    TSIO_TRACE("<1> remove tsio!\n");
+}
+
+module_init(tsio_init);
+module_exit(tsio_exit);
+
+MODULE_LICENSE("GPL");
diff --git a/drivers/tsio/tsio.h b/drivers/tsio/tsio.h
new file mode 100755
index 00000000..6e5ab2d
--- /dev/null
+++ b/drivers/tsio/tsio.h
@@ -0,0 +1,65 @@
+#ifndef __TSIO_H__
+#define __TSIO_H__
+
+#define TSIO_400MBPS 3
+#define TSIO_200MBPS 2
+#define TSIO_100MBPS 1
+#define TSIO_50MBPS  0
+#define TSIO_LINK_UP    (1<<10)
+
+#define TSIO_H_QUEUE  0
+#define TSIO_M_QUEUE  1
+#define TSIO_L_QUEUE  2
+
+#define TSIO_TS       0
+#define TSIO_BLK      1
+#define TSIO_CCP_TS   2
+#define TSIO_CCP_BLK  3
+#define TSIO_CC       4
+
+#define TSIO_START_TX     (1<<9)
+#define TSIO_TX_DONE      (1<<10)
+#define TSIO_RX_DONE      (1<<10)
+#define TSIO_RX_ERR       (1<<11)
+
+#define TSIO_REG_BASE     0x98019000
+#define TSIO_CRTL         0x000
+#define TSIO_LINK_STATE   0x010
+
+#define TSIO_PKT          0x044
+#define TSIO_CCTX         0x048
+#define TSIO_CCTX_IDX     0x04C
+#define TSIO_CCTX_CRTL    0x050
+#define TSIO_CCRX         0x054
+#define TSIO_CCRX_IDX     0x058
+#define TSIO_CCRX_CRTL    0x05C
+
+#define TSIO_FIFO_H_BASE  0x014
+#define TSIO_FIFO_H_LIMIT 0x018
+#define TSIO_FIFO_M_BASE  0x01C
+#define TSIO_FIFO_M_LIMIT 0x020
+#define TSIO_FIFO_L_BASE  0x024
+#define TSIO_FIFO_L_LIMIT 0x028
+
+#define TSIO_FIFO_H_WPTR  0x02C
+#define TSIO_FIFO_H_RPTR  0x030
+#define TSIO_FIFO_M_WPTR  0x034
+#define TSIO_FIFO_M_RPTR  0x038
+#define TSIO_FIFO_L_WPTR  0x03C
+#define TSIO_FIFO_L_RPTR  0x040
+
+#define TSIO_EXE_INFO     0x084
+#define DESP_EXE_INT      0x23C
+
+#define TSIO_H_RX_CNT     0x230
+#define TSIO_H_TX_CNT     0x224
+
+#define TSIO_TX_PKT       0x068
+
+#define  TSIO_TX_H_PTL_WR    0x224
+#define  TSIO_RX_H_PTL_INFO  0x230
+
+#define  TSIO_PHY_CLK     0x004
+#define  TSIO_SID_KEY     0x120
+
+#endif //__TSIO_H
\ No newline at end of file
diff --git a/drivers/tsio/tsio_dbg.h b/drivers/tsio/tsio_dbg.h
new file mode 100644
index 00000000..50c1560b
--- /dev/null
+++ b/drivers/tsio/tsio_dbg.h
@@ -0,0 +1,14 @@
+#ifndef __TSIO_DBG_H__
+#define __TSIO_DBG_H__
+
+#define CONFIG_TSIO_DBG
+
+#ifdef  CONFIG_TSIO_DBG
+#define TSIO_TRACE(fmt, args...)          printk(KERN_INFO "[TSIO] TRACE, " fmt, ## args)
+#define TSIO_WARNING(fmt, args...)        printk(KERN_EMERG "[TSIO] Warning, " fmt, ## args)
+#else
+#define TSIO_TRACE(fmt, args...)
+#define TSIO_WARNING(fmt, args...)
+#endif
+
+#endif  //__TSIO_DBG_H__
diff --git a/drivers/tsio/tsio_dev.h b/drivers/tsio/tsio_dev.h
new file mode 100644
index 00000000..988a861
--- /dev/null
+++ b/drivers/tsio/tsio_dev.h
@@ -0,0 +1,13 @@
+#ifndef __TSIO_DEV_H__
+#define __TSIO_DEV_H__
+
+#define TSIO_GET_LINK_STATUS    0x4700
+#define TSIO_GET_BW             0x4701
+#define TSIO_SET_BW             0x4702
+#define TSIO_GET_STFF_SID       0x4703
+#define TSIO_SET_STFF_SID       0x4704
+#define TSIO_GET_SYNC_THRES     0x4705
+#define TSIO_SET_SYNC_THRES     0x4706
+#define TSIO_SET_KEY_IDX        0x4707
+
+#endif //__TSIO_DEV_H
diff --git a/drivers/tty/hvc/hvc_console.c b/drivers/tty/hvc/hvc_console.c
index ce86487..4f91e9d 100644
--- a/drivers/tty/hvc/hvc_console.c
+++ b/drivers/tty/hvc/hvc_console.c
@@ -46,6 +46,13 @@
 
 #include "hvc_console.h"
 
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#include <xen/hvc-console.h>
+static atomic_t crash_console_start = ATOMIC_INIT(-1);
+static void domu_crash_console_start(void);
+#endif
+
 #define HVC_MAJOR	229
 #define HVC_MINOR	0
 
@@ -261,6 +268,10 @@ static void hvc_check_console(int index)
 	 */
 	if (index == hvc_console.index)
 		register_console(&hvc_console);
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	if (atomic_inc_and_test(&crash_console_start))
+		domu_crash_console_start();
+#endif
 }
 
 /*
@@ -1005,3 +1016,29 @@ static int hvc_init(void)
 out:
 	return err;
 }
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+static void domu_crash_print(struct console *co, const char *b,
+				unsigned count)
+{
+	static char buf[512] = "";
+
+	if (oops_in_progress && !xen_initial_domain()) {
+		strncpy(buf, b, count);
+		buf[count] = '\0';
+		xen_raw_console_write(buf);
+	}
+}
+
+static struct console domu_crash_console = {
+	.name		= "domu_crash",
+	.write		= domu_crash_print,
+	.flags		= CON_PRINTBUFFER | CON_ANYTIME | CON_ENABLED,
+	.index		= -1,
+};
+
+static void domu_crash_console_start(void)
+{
+	register_console(&domu_crash_console);
+}
+#endif
diff --git a/drivers/tty/serial/8250/8250_dw.c b/drivers/tty/serial/8250/8250_dw.c
index 3eb01a71..99ea7c1 100644
--- a/drivers/tty/serial/8250/8250_dw.c
+++ b/drivers/tty/serial/8250/8250_dw.c
@@ -105,15 +105,15 @@ static void dw8250_check_lcr(struct uart_port *p, int value)
 
 #ifdef CONFIG_64BIT
 		if (p->type == PORT_OCTEON)
-			__raw_writeq(value & 0xff, offset);
+			__raw_writeq_no_log(value & 0xff, offset);
 		else
 #endif
 		if (p->iotype == UPIO_MEM32)
-			writel(value, offset);
+			writel_no_log(value, offset);
 		else if (p->iotype == UPIO_MEM32BE)
 			iowrite32be(value, offset);
 		else
-			writeb(value, offset);
+			writeb_no_log(value, offset);
 	}
 	/*
 	 * FIXME: this deadlocks if port->lock is already held
@@ -125,7 +125,7 @@ static void dw8250_serial_out(struct uart_port *p, int offset, int value)
 {
 	struct dw8250_data *d = p->private_data;
 
-	writeb(value, p->membase + (offset << p->regshift));
+	writeb_no_log(value, p->membase + (offset << p->regshift));
 
 	if (offset == UART_LCR && !d->uart_16550_compatible)
 		dw8250_check_lcr(p, value);
@@ -133,7 +133,7 @@ static void dw8250_serial_out(struct uart_port *p, int offset, int value)
 
 static unsigned int dw8250_serial_in(struct uart_port *p, int offset)
 {
-	unsigned int value = readb(p->membase + (offset << p->regshift));
+	unsigned int value = readb_no_log(p->membase + (offset << p->regshift));
 
 	return dw8250_modify_msr(p, offset, value);
 }
@@ -143,7 +143,7 @@ static unsigned int dw8250_serial_inq(struct uart_port *p, int offset)
 {
 	unsigned int value;
 
-	value = (u8)__raw_readq(p->membase + (offset << p->regshift));
+	value = (u8)__raw_readq_no_log(p->membase + (offset << p->regshift));
 
 	return dw8250_modify_msr(p, offset, value);
 }
@@ -153,9 +153,9 @@ static void dw8250_serial_outq(struct uart_port *p, int offset, int value)
 	struct dw8250_data *d = p->private_data;
 
 	value &= 0xff;
-	__raw_writeq(value, p->membase + (offset << p->regshift));
+	__raw_writeq_no_log(value, p->membase + (offset << p->regshift));
 	/* Read back to ensure register write ordering. */
-	__raw_readq(p->membase + (UART_LCR << p->regshift));
+	__raw_readq_no_log(p->membase + (UART_LCR << p->regshift));
 
 	if (offset == UART_LCR && !d->uart_16550_compatible)
 		dw8250_check_lcr(p, value);
@@ -166,7 +166,7 @@ static void dw8250_serial_out32(struct uart_port *p, int offset, int value)
 {
 	struct dw8250_data *d = p->private_data;
 
-	writel(value, p->membase + (offset << p->regshift));
+	writel_no_log(value, p->membase + (offset << p->regshift));
 
 	if (offset == UART_LCR && !d->uart_16550_compatible)
 		dw8250_check_lcr(p, value);
@@ -174,7 +174,7 @@ static void dw8250_serial_out32(struct uart_port *p, int offset, int value)
 
 static unsigned int dw8250_serial_in32(struct uart_port *p, int offset)
 {
-	unsigned int value = readl(p->membase + (offset << p->regshift));
+	unsigned int value = readl_no_log(p->membase + (offset << p->regshift));
 
 	return dw8250_modify_msr(p, offset, value);
 }
@@ -333,7 +333,7 @@ static void dw8250_setup_port(struct uart_port *p)
 	if (p->iotype == UPIO_MEM32BE)
 		reg = ioread32be(p->membase + DW_UART_UCV);
 	else
-		reg = readl(p->membase + DW_UART_UCV);
+		reg = readl_no_log(p->membase + DW_UART_UCV);
 	if (!reg)
 		return;
 
@@ -343,7 +343,7 @@ static void dw8250_setup_port(struct uart_port *p)
 	if (p->iotype == UPIO_MEM32BE)
 		reg = ioread32be(p->membase + DW_UART_CPR);
 	else
-		reg = readl(p->membase + DW_UART_CPR);
+		reg = readl_no_log(p->membase + DW_UART_CPR);
 	if (!reg)
 		return;
 
diff --git a/drivers/tty/serial/8250/8250_early.c b/drivers/tty/serial/8250/8250_early.c
index 85a12f0..8418e94 100644
--- a/drivers/tty/serial/8250/8250_early.c
+++ b/drivers/tty/serial/8250/8250_early.c
@@ -43,11 +43,11 @@ static unsigned int __init serial8250_early_in(struct uart_port *port, int offse
 
 	switch (port->iotype) {
 	case UPIO_MEM:
-		return readb(port->membase + offset);
+		return readb_no_log(port->membase + offset);
 	case UPIO_MEM16:
-		return readw(port->membase + offset);
+		return readw_no_log(port->membase + offset);
 	case UPIO_MEM32:
-		return readl(port->membase + offset);
+		return readl_no_log(port->membase + offset);
 	case UPIO_MEM32BE:
 		return ioread32be(port->membase + offset);
 	case UPIO_PORT:
@@ -63,13 +63,13 @@ static void __init serial8250_early_out(struct uart_port *port, int offset, int
 
 	switch (port->iotype) {
 	case UPIO_MEM:
-		writeb(value, port->membase + offset);
+		writeb_no_log(value, port->membase + offset);
 		break;
 	case UPIO_MEM16:
-		writew(value, port->membase + offset);
+		writew_no_log(value, port->membase + offset);
 		break;
 	case UPIO_MEM32:
-		writel(value, port->membase + offset);
+		writel_no_log(value, port->membase + offset);
 		break;
 	case UPIO_MEM32BE:
 		iowrite32be(value, port->membase + offset);
diff --git a/drivers/tty/serial/8250/8250_em.c b/drivers/tty/serial/8250/8250_em.c
index 0b63812..37e796d 100644
--- a/drivers/tty/serial/8250/8250_em.c
+++ b/drivers/tty/serial/8250/8250_em.c
@@ -40,20 +40,20 @@ static void serial8250_em_serial_out(struct uart_port *p, int offset, int value)
 {
 	switch (offset) {
 	case UART_TX: /* TX @ 0x00 */
-		writeb(value, p->membase);
+		writeb_no_log(value, p->membase);
 		break;
 	case UART_FCR: /* FCR @ 0x0c (+1) */
 	case UART_LCR: /* LCR @ 0x10 (+1) */
 	case UART_MCR: /* MCR @ 0x14 (+1) */
 	case UART_SCR: /* SCR @ 0x20 (+1) */
-		writel(value, p->membase + ((offset + 1) << 2));
+		writel_no_log(value, p->membase + ((offset + 1) << 2));
 		break;
 	case UART_IER: /* IER @ 0x04 */
 		value &= 0x0f; /* only 4 valid bits - not Xscale */
 		/* fall-through */
 	case UART_DLL_EM: /* DLL @ 0x24 (+9) */
 	case UART_DLM_EM: /* DLM @ 0x28 (+9) */
-		writel(value, p->membase + (offset << 2));
+		writel_no_log(value, p->membase + (offset << 2));
 	}
 }
 
@@ -61,17 +61,17 @@ static unsigned int serial8250_em_serial_in(struct uart_port *p, int offset)
 {
 	switch (offset) {
 	case UART_RX: /* RX @ 0x00 */
-		return readb(p->membase);
+		return readb_no_log(p->membase);
 	case UART_MCR: /* MCR @ 0x14 (+1) */
 	case UART_LSR: /* LSR @ 0x18 (+1) */
 	case UART_MSR: /* MSR @ 0x1c (+1) */
 	case UART_SCR: /* SCR @ 0x20 (+1) */
-		return readl(p->membase + ((offset + 1) << 2));
+		return readl_no_log(p->membase + ((offset + 1) << 2));
 	case UART_IER: /* IER @ 0x04 */
 	case UART_IIR: /* IIR @ 0x08 */
 	case UART_DLL_EM: /* DLL @ 0x24 (+9) */
 	case UART_DLM_EM: /* DLM @ 0x28 (+9) */
-		return readl(p->membase + (offset << 2));
+		return readl_no_log(p->membase + (offset << 2));
 	}
 	return 0;
 }
diff --git a/drivers/tty/serial/8250/8250_ingenic.c b/drivers/tty/serial/8250/8250_ingenic.c
index 4d9dc10..54049ba 100644
--- a/drivers/tty/serial/8250/8250_ingenic.c
+++ b/drivers/tty/serial/8250/8250_ingenic.c
@@ -52,12 +52,12 @@ struct ingenic_uart_data {
 
 static uint8_t __init early_in(struct uart_port *port, int offset)
 {
-	return readl(port->membase + (offset << 2));
+	return readl_no_log(port->membase + (offset << 2));
 }
 
 static void __init early_out(struct uart_port *port, int offset, uint8_t value)
 {
-	writel(value, port->membase + (offset << 2));
+	writel_no_log(value, port->membase + (offset << 2));
 }
 
 static void __init ingenic_early_console_putc(struct uart_port *port, int c)
@@ -176,14 +176,14 @@ static void ingenic_uart_serial_out(struct uart_port *p, int offset, int value)
 		break;
 	}
 
-	writeb(value, p->membase + (offset << p->regshift));
+	writeb_no_log(value, p->membase + (offset << p->regshift));
 }
 
 static unsigned int ingenic_uart_serial_in(struct uart_port *p, int offset)
 {
 	unsigned int value;
 
-	value = readb(p->membase + (offset << p->regshift));
+	value = readb_no_log(p->membase + (offset << p->regshift));
 
 	/* Hide non-16550 compliant bits from higher levels */
 	switch (offset) {
diff --git a/drivers/tty/serial/8250/8250_lpc18xx.c b/drivers/tty/serial/8250/8250_lpc18xx.c
index 99cd478..60ebcd5 100644
--- a/drivers/tty/serial/8250/8250_lpc18xx.c
+++ b/drivers/tty/serial/8250/8250_lpc18xx.c
@@ -99,7 +99,7 @@ static void lpc18xx_uart_serial_out(struct uart_port *p, int offset, int value)
 		value |= UART_FCR_DMA_SELECT;
 
 	offset = offset << p->regshift;
-	writel(value, p->membase + offset);
+	writel_no_log(value, p->membase + offset);
 }
 
 static int lpc18xx_serial_probe(struct platform_device *pdev)
diff --git a/drivers/tty/serial/8250/8250_lpss.c b/drivers/tty/serial/8250/8250_lpss.c
index b992346..3115b52 100644
--- a/drivers/tty/serial/8250/8250_lpss.c
+++ b/drivers/tty/serial/8250/8250_lpss.c
@@ -88,9 +88,9 @@ static void byt_set_termios(struct uart_port *p, struct ktermios *termios,
 
 	/* Reset the clock */
 	reg = (m << BYT_PRV_CLK_M_VAL_SHIFT) | (n << BYT_PRV_CLK_N_VAL_SHIFT);
-	writel(reg, p->membase + BYT_PRV_CLK);
+	writel_no_log(reg, p->membase + BYT_PRV_CLK);
 	reg |= BYT_PRV_CLK_EN | BYT_PRV_CLK_UPDATE;
-	writel(reg, p->membase + BYT_PRV_CLK);
+	writel_no_log(reg, p->membase + BYT_PRV_CLK);
 
 	p->status &= ~UPSTAT_AUTOCTS;
 	if (termios->c_cflag & CRTSCTS)
@@ -148,7 +148,7 @@ static int byt_serial_setup(struct lpss8250 *lpss, struct uart_port *port)
 	port->get_mctrl = byt_get_mctrl;
 
 	/* Disable TX counter interrupts */
-	writel(BYT_TX_OVF_INT_MASK, port->membase + BYT_TX_OVF_INT);
+	writel_no_log(BYT_TX_OVF_INT_MASK, port->membase + BYT_TX_OVF_INT);
 
 	return 0;
 }
diff --git a/drivers/tty/serial/8250/8250_mid.c b/drivers/tty/serial/8250/8250_mid.c
index 39c2324..f88d571 100644
--- a/drivers/tty/serial/8250/8250_mid.c
+++ b/drivers/tty/serial/8250/8250_mid.c
@@ -186,9 +186,9 @@ static void mid8250_set_termios(struct uart_port *p,
 	rational_best_approximation(fuart, mid->board->freq, w, w, &mul, &div);
 	p->uartclk = fuart * 16 / ps;		/* core uses ps = 16 always */
 
-	writel(ps, p->membase + INTEL_MID_UART_PS);		/* set PS */
-	writel(mul, p->membase + INTEL_MID_UART_MUL);		/* set MUL */
-	writel(div, p->membase + INTEL_MID_UART_DIV);
+	writel_no_log(ps, p->membase + INTEL_MID_UART_PS);		/* set PS */
+	writel_no_log(mul, p->membase + INTEL_MID_UART_MUL);		/* set MUL */
+	writel_no_log(div, p->membase + INTEL_MID_UART_DIV);
 
 	serial8250_do_set_termios(p, termios, old);
 }
diff --git a/drivers/tty/serial/8250/8250_mtk.c b/drivers/tty/serial/8250/8250_mtk.c
index ce0cc47..bef73fd 100644
--- a/drivers/tty/serial/8250/8250_mtk.c
+++ b/drivers/tty/serial/8250/8250_mtk.c
@@ -220,7 +220,7 @@ static int mtk8250_probe(struct platform_device *pdev)
 	uart.port.uartclk = clk_get_rate(data->uart_clk);
 
 	/* Disable Rate Fix function */
-	writel(0x0, uart.port.membase +
+	writel_no_log(0x0, uart.port.membase +
 			(MTK_UART_RATE_FIX << uart.port.regshift));
 
 	platform_set_drvdata(pdev, data);
diff --git a/drivers/tty/serial/8250/8250_omap.c b/drivers/tty/serial/8250/8250_omap.c
index a3adf21..bc6c28f 100644
--- a/drivers/tty/serial/8250/8250_omap.c
+++ b/drivers/tty/serial/8250/8250_omap.c
@@ -123,7 +123,7 @@ static inline void omap_8250_rx_dma_flush(struct uart_8250_port *p) { }
 
 static u32 uart_read(struct uart_8250_port *up, u32 reg)
 {
-	return readl(up->port.membase + (reg << up->port.regshift));
+	return readl_no_log(up->port.membase + (reg << up->port.regshift));
 }
 
 static void omap8250_set_mctrl(struct uart_port *port, unsigned int mctrl)
diff --git a/drivers/tty/serial/8250/8250_pci.c b/drivers/tty/serial/8250/8250_pci.c
index e82b347..089c6fa 100644
--- a/drivers/tty/serial/8250/8250_pci.c
+++ b/drivers/tty/serial/8250/8250_pci.c
@@ -268,12 +268,12 @@ static int pci_plx9050_init(struct pci_dev *dev)
 	p = ioremap_nocache(pci_resource_start(dev, 0), 0x80);
 	if (p == NULL)
 		return -ENOMEM;
-	writel(irq_config, p + 0x4c);
+	writel_no_log(irq_config, p + 0x4c);
 
 	/*
 	 * Read the register back to ensure that it took effect.
 	 */
-	readl(p + 0x4c);
+	readl_no_log(p + 0x4c);
 	iounmap(p);
 
 	return 0;
@@ -291,12 +291,12 @@ static void pci_plx9050_exit(struct pci_dev *dev)
 	 */
 	p = ioremap_nocache(pci_resource_start(dev, 0), 0x80);
 	if (p != NULL) {
-		writel(0, p + 0x4c);
+		writel_no_log(0, p + 0x4c);
 
 		/*
 		 * Read the register back to ensure that it took effect.
 		 */
-		readl(p + 0x4c);
+		readl_no_log(p + 0x4c);
 		iounmap(p);
 	}
 }
@@ -319,7 +319,7 @@ static void pci_ni8420_exit(struct pci_dev *dev)
 		return;
 
 	/* Disable the CPU Interrupt */
-	writel(readl(p + NI8420_INT_ENABLE_REG) & ~(NI8420_INT_ENABLE_BIT),
+	writel_no_log(readl_no_log(p + NI8420_INT_ENABLE_REG) & ~(NI8420_INT_ENABLE_BIT),
 	       p + NI8420_INT_ENABLE_REG);
 	iounmap(p);
 }
@@ -348,7 +348,7 @@ static void pci_ni8430_exit(struct pci_dev *dev)
 		return;
 
 	/* Disable the CPU Interrupt */
-	writel(MITE_LCIMR2_CLR_CPU_IE, p + MITE_LCIMR2);
+	writel_no_log(MITE_LCIMR2_CLR_CPU_IE, p + MITE_LCIMR2);
 	iounmap(p);
 }
 
@@ -392,12 +392,12 @@ static int sbs_init(struct pci_dev *dev)
 	if (p == NULL)
 		return -ENOMEM;
 	/* Set bit-4 Control Register (UART RESET) in to reset the uarts */
-	writeb(0x10, p + OCT_REG_CR_OFF);
+	writeb_no_log(0x10, p + OCT_REG_CR_OFF);
 	udelay(50);
-	writeb(0x0, p + OCT_REG_CR_OFF);
+	writeb_no_log(0x0, p + OCT_REG_CR_OFF);
 
 	/* Set bit-2 (INTENABLE) of Control Register */
-	writeb(0x4, p + OCT_REG_CR_OFF);
+	writeb_no_log(0x4, p + OCT_REG_CR_OFF);
 	iounmap(p);
 
 	return 0;
@@ -414,7 +414,7 @@ static void sbs_exit(struct pci_dev *dev)
 	p = pci_ioremap_bar(dev, 0);
 	/* FIXME: What if resource_len < OCT_REG_CR_OFF */
 	if (p != NULL)
-		writeb(0, p + OCT_REG_CR_OFF);
+		writeb_no_log(0, p + OCT_REG_CR_OFF);
 	iounmap(p);
 }
 
@@ -469,8 +469,8 @@ static int pci_siig10x_init(struct pci_dev *dev)
 	if (p == NULL)
 		return -ENOMEM;
 
-	writew(readw(p + 0x28) & data, p + 0x28);
-	readw(p + 0x28);
+	writew_no_log(readw_no_log(p + 0x28) & data, p + 0x28);
+	readw_no_log(p + 0x28);
 	iounmap(p);
 	return 0;
 }
@@ -678,7 +678,7 @@ static int pci_ni8420_init(struct pci_dev *dev)
 		return -ENOMEM;
 
 	/* Enable CPU Interrupt */
-	writel(readl(p + NI8420_INT_ENABLE_REG) | NI8420_INT_ENABLE_BIT,
+	writel_no_log(readl_no_log(p + NI8420_INT_ENABLE_REG) | NI8420_INT_ENABLE_BIT,
 	       p + NI8420_INT_ENABLE_REG);
 
 	iounmap(p);
@@ -716,17 +716,17 @@ static int pci_ni8430_init(struct pci_dev *dev)
 	pcibios_resource_to_bus(dev->bus, &region, &dev->resource[bar]);
 	device_window = ((region.start + MITE_IOWBSR1_WIN_OFFSET) & 0xffffff00)
 			| MITE_IOWBSR1_WENAB | MITE_IOWBSR1_WSIZE;
-	writel(device_window, p + MITE_IOWBSR1);
+	writel_no_log(device_window, p + MITE_IOWBSR1);
 
 	/* Set window access to go to RAMSEL IO address space */
-	writel((readl(p + MITE_IOWCR1) & MITE_IOWCR1_RAMSEL_MASK),
+	writel_no_log((readl_no_log(p + MITE_IOWCR1) & MITE_IOWCR1_RAMSEL_MASK),
 	       p + MITE_IOWCR1);
 
 	/* Enable IO Bus Interrupt 0 */
-	writel(MITE_LCIMR1_IO_IE_0, p + MITE_LCIMR1);
+	writel_no_log(MITE_LCIMR1_IO_IE_0, p + MITE_LCIMR1);
 
 	/* Enable CPU Interrupt */
-	writel(MITE_LCIMR2_SET_CPU_IE, p + MITE_LCIMR2);
+	writel_no_log(MITE_LCIMR2_SET_CPU_IE, p + MITE_LCIMR2);
 
 	iounmap(p);
 	return 0;
@@ -756,7 +756,7 @@ static int pci_ni8430_init(struct pci_dev *dev)
 		return -ENOMEM;
 
 	/* enable the transceiver */
-	writeb(readb(p + offset + NI8430_PORTCON) | NI8430_PORTCON_TXVR_ENABLE,
+	writeb_no_log(readb_no_log(p + offset + NI8430_PORTCON) | NI8430_PORTCON_TXVR_ENABLE,
 	       p + offset + NI8430_PORTCON);
 
 	iounmap(p);
@@ -1639,23 +1639,23 @@ static int pci_eg20t_init(struct pci_dev *dev)
 	 * Setup Multipurpose Input/Output pins.
 	 */
 	if (idx == 0) {
-		writeb(0x00, p + UART_EXAR_MPIOINT_7_0);
-		writeb(0x00, p + UART_EXAR_MPIOLVL_7_0);
-		writeb(0x00, p + UART_EXAR_MPIO3T_7_0);
-		writeb(0x00, p + UART_EXAR_MPIOINV_7_0);
-		writeb(0x00, p + UART_EXAR_MPIOSEL_7_0);
-		writeb(0x00, p + UART_EXAR_MPIOOD_7_0);
-		writeb(0x00, p + UART_EXAR_MPIOINT_15_8);
-		writeb(0x00, p + UART_EXAR_MPIOLVL_15_8);
-		writeb(0x00, p + UART_EXAR_MPIO3T_15_8);
-		writeb(0x00, p + UART_EXAR_MPIOINV_15_8);
-		writeb(0x00, p + UART_EXAR_MPIOSEL_15_8);
-		writeb(0x00, p + UART_EXAR_MPIOOD_15_8);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOINT_7_0);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOLVL_7_0);
+		writeb_no_log(0x00, p + UART_EXAR_MPIO3T_7_0);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOINV_7_0);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOSEL_7_0);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOOD_7_0);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOINT_15_8);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOLVL_15_8);
+		writeb_no_log(0x00, p + UART_EXAR_MPIO3T_15_8);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOINV_15_8);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOSEL_15_8);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOOD_15_8);
 	}
-	writeb(0x00, p + UART_EXAR_8XMODE);
-	writeb(UART_FCTR_EXAR_TRGD, p + UART_EXAR_FCTR);
-	writeb(128, p + UART_EXAR_TXTRG);
-	writeb(128, p + UART_EXAR_RXTRG);
+	writeb_no_log(0x00, p + UART_EXAR_8XMODE);
+	writeb_no_log(UART_FCTR_EXAR_TRGD, p + UART_EXAR_FCTR);
+	writeb_no_log(128, p + UART_EXAR_TXTRG);
+	writeb_no_log(128, p + UART_EXAR_RXTRG);
 	iounmap(p);
 
 	return pci_default_setup(priv, board, port, idx);
@@ -1686,25 +1686,25 @@ static int pci_eg20t_init(struct pci_dev *dev)
 		switch (priv->dev->device) {
 		case PCI_DEVICE_ID_COMMTECH_4222PCI335:
 		case PCI_DEVICE_ID_COMMTECH_4224PCI335:
-			writeb(0x78, p + UART_EXAR_MPIOLVL_7_0);
-			writeb(0x00, p + UART_EXAR_MPIOINV_7_0);
-			writeb(0x00, p + UART_EXAR_MPIOSEL_7_0);
+			writeb_no_log(0x78, p + UART_EXAR_MPIOLVL_7_0);
+			writeb_no_log(0x00, p + UART_EXAR_MPIOINV_7_0);
+			writeb_no_log(0x00, p + UART_EXAR_MPIOSEL_7_0);
 			break;
 		case PCI_DEVICE_ID_COMMTECH_2324PCI335:
 		case PCI_DEVICE_ID_COMMTECH_2328PCI335:
-			writeb(0x00, p + UART_EXAR_MPIOLVL_7_0);
-			writeb(0xc0, p + UART_EXAR_MPIOINV_7_0);
-			writeb(0xc0, p + UART_EXAR_MPIOSEL_7_0);
+			writeb_no_log(0x00, p + UART_EXAR_MPIOLVL_7_0);
+			writeb_no_log(0xc0, p + UART_EXAR_MPIOINV_7_0);
+			writeb_no_log(0xc0, p + UART_EXAR_MPIOSEL_7_0);
 			break;
 		}
-		writeb(0x00, p + UART_EXAR_MPIOINT_7_0);
-		writeb(0x00, p + UART_EXAR_MPIO3T_7_0);
-		writeb(0x00, p + UART_EXAR_MPIOOD_7_0);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOINT_7_0);
+		writeb_no_log(0x00, p + UART_EXAR_MPIO3T_7_0);
+		writeb_no_log(0x00, p + UART_EXAR_MPIOOD_7_0);
 	}
-	writeb(0x00, p + UART_EXAR_8XMODE);
-	writeb(UART_FCTR_EXAR_TRGD, p + UART_EXAR_FCTR);
-	writeb(32, p + UART_EXAR_TXTRG);
-	writeb(32, p + UART_EXAR_RXTRG);
+	writeb_no_log(0x00, p + UART_EXAR_8XMODE);
+	writeb_no_log(UART_FCTR_EXAR_TRGD, p + UART_EXAR_FCTR);
+	writeb_no_log(32, p + UART_EXAR_TXTRG);
+	writeb_no_log(32, p + UART_EXAR_RXTRG);
 	iounmap(p);
 
 	return pci_default_setup(priv, board, port, idx);
diff --git a/drivers/tty/serial/8250/8250_port.c b/drivers/tty/serial/8250/8250_port.c
index 5d9038a..7917f19 100644
--- a/drivers/tty/serial/8250/8250_port.c
+++ b/drivers/tty/serial/8250/8250_port.c
@@ -320,7 +320,7 @@ static unsigned int au_serial_in(struct uart_port *p, int offset)
 	offset = au_io_in_map[offset];
 	if (offset < 0)
 		return UINT_MAX;
-	return __raw_readl(p->membase + (offset << p->regshift));
+	return __raw_readl_no_log(p->membase + (offset << p->regshift));
 }
 
 static void au_serial_out(struct uart_port *p, int offset, int value)
@@ -330,18 +330,18 @@ static void au_serial_out(struct uart_port *p, int offset, int value)
 	offset = au_io_out_map[offset];
 	if (offset < 0)
 		return;
-	__raw_writel(value, p->membase + (offset << p->regshift));
+	__raw_writel_no_log(value, p->membase + (offset << p->regshift));
 }
 
 /* Au1x00 haven't got a standard divisor latch */
 static int au_serial_dl_read(struct uart_8250_port *up)
 {
-	return __raw_readl(up->port.membase + 0x28);
+	return __raw_readl_no_log(up->port.membase + 0x28);
 }
 
 static void au_serial_dl_write(struct uart_8250_port *up, int value)
 {
-	__raw_writel(value, up->port.membase + 0x28);
+	__raw_writel_no_log(value, up->port.membase + 0x28);
 }
 
 #endif
@@ -363,37 +363,37 @@ static void hub6_serial_out(struct uart_port *p, int offset, int value)
 static unsigned int mem_serial_in(struct uart_port *p, int offset)
 {
 	offset = offset << p->regshift;
-	return readb(p->membase + offset);
+	return readb_no_log(p->membase + offset);
 }
 
 static void mem_serial_out(struct uart_port *p, int offset, int value)
 {
 	offset = offset << p->regshift;
-	writeb(value, p->membase + offset);
+	writeb_no_log(value, p->membase + offset);
 }
 
 static void mem16_serial_out(struct uart_port *p, int offset, int value)
 {
 	offset = offset << p->regshift;
-	writew(value, p->membase + offset);
+	writew_no_log(value, p->membase + offset);
 }
 
 static unsigned int mem16_serial_in(struct uart_port *p, int offset)
 {
 	offset = offset << p->regshift;
-	return readw(p->membase + offset);
+	return readw_no_log(p->membase + offset);
 }
 
 static void mem32_serial_out(struct uart_port *p, int offset, int value)
 {
 	offset = offset << p->regshift;
-	writel(value, p->membase + offset);
+	writel_no_log(value, p->membase + offset);
 }
 
 static unsigned int mem32_serial_in(struct uart_port *p, int offset)
 {
 	offset = offset << p->regshift;
-	return readl(p->membase + offset);
+	return readl_no_log(p->membase + offset);
 }
 
 static void mem32be_serial_out(struct uart_port *p, int offset, int value)
diff --git a/drivers/tty/serial/8250/8250_rtk.c b/drivers/tty/serial/8250/8250_rtk.c
new file mode 100644
index 00000000..4347de4
--- /dev/null
+++ b/drivers/tty/serial/8250/8250_rtk.c
@@ -0,0 +1,651 @@
+/*
+ * Synopsys DesignWare 8250 driver.
+ *
+ * Copyright 2011 Picochip, Jamie Iles.
+ * Copyright 2013 Intel Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * The Synopsys DesignWare 8250 has an extra feature whereby it detects if the
+ * LCR is written whilst busy.  If it is, then a busy detect interrupt is
+ * raised, the LCR needs to be rewritten and the uart status register read.
+ */
+#include <linux/device.h>
+#include <linux/io.h>
+#include <linux/module.h>
+#include <linux/serial_8250.h>
+#include <linux/serial_reg.h>
+#include <linux/of.h>
+#include <linux/of_irq.h>
+#include <linux/of_platform.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/acpi.h>
+#include <linux/clk.h>
+#include <linux/reset.h>
+#include <linux/pm_runtime.h>
+#include <linux/delay.h>
+
+#include <asm/byteorder.h>
+
+#include "8250.h"
+
+/* Offsets for the DesignWare specific registers */
+#define DW_UART_USR	0x1f /* UART Status Register */
+#define DW_UART_CPR	0xf4 /* Component Parameter Register */
+#define DW_UART_UCV	0xf8 /* UART Component Version */
+
+/* Component Parameter Register bits */
+#define DW_UART_CPR_ABP_DATA_WIDTH	(3 << 0)
+#define DW_UART_CPR_AFCE_MODE		(1 << 4)
+#define DW_UART_CPR_THRE_MODE		(1 << 5)
+#define DW_UART_CPR_SIR_MODE		(1 << 6)
+#define DW_UART_CPR_SIR_LP_MODE		(1 << 7)
+#define DW_UART_CPR_ADDITIONAL_FEATURES	(1 << 8)
+#define DW_UART_CPR_FIFO_ACCESS		(1 << 9)
+#define DW_UART_CPR_FIFO_STAT		(1 << 10)
+#define DW_UART_CPR_SHADOW		(1 << 11)
+#define DW_UART_CPR_ENCODED_PARMS	(1 << 12)
+#define DW_UART_CPR_DMA_EXTRA		(1 << 13)
+#define DW_UART_CPR_FIFO_MODE		(0xff << 16)
+/* Helper for fifo size calculation */
+#define DW_UART_CPR_FIFO_SIZE(a)	(((a >> 16) & 0xff) * 16)
+
+
+struct dw8250_data {
+	u8			usr_reg;
+	int			line;
+	int			msr_mask_on;
+	int			msr_mask_off;
+	struct clk		*clk;
+	struct clk		*pclk;
+	struct reset_control	*rst;
+	struct uart_8250_dma	dma;
+	u32		isr_st_mask;
+	void __iomem		*isr_reg;
+
+	unsigned int		skip_autocfg:1;
+	unsigned int		uart_16550_compatible:1;
+};
+
+#define BYT_PRV_CLK			0x800
+#define BYT_PRV_CLK_EN			(1 << 0)
+#define BYT_PRV_CLK_M_VAL_SHIFT		1
+#define BYT_PRV_CLK_N_VAL_SHIFT		16
+#define BYT_PRV_CLK_UPDATE		(1 << 31)
+
+static inline int dw8250_modify_msr(struct uart_port *p, int offset, int value)
+{
+	struct dw8250_data *d = p->private_data;
+
+	/* Override any modem control signals if needed */
+	if (offset == UART_MSR) {
+		value |= d->msr_mask_on;
+		value &= ~d->msr_mask_off;
+	}
+
+	return value;
+}
+
+static void dw8250_force_idle(struct uart_port *p)
+{
+	struct uart_8250_port *up = up_to_u8250p(p);
+
+	serial8250_clear_and_reinit_fifos(up);
+	(void)p->serial_in(p, UART_RX);
+}
+
+static void dw8250_serial_out(struct uart_port *p, int offset, int value)
+{
+	writeb_no_log(value, p->membase + (offset << p->regshift));
+
+	/* Make sure LCR write wasn't ignored */
+	if (offset == UART_LCR) {
+		int tries = 1000;
+
+		while (tries--) {
+			unsigned int lcr = p->serial_in(p, UART_LCR);
+
+			if ((value & ~UART_LCR_SPAR) == (lcr & ~UART_LCR_SPAR))
+				return;
+			dw8250_force_idle(p);
+			writeb_no_log(value, p->membase + (UART_LCR << p->regshift));
+		}
+		/*
+		 * FIXME: this deadlocks if port->lock is already held
+		 * dev_err(p->dev, "Couldn't set LCR to %d\n", value);
+		 */
+	}
+}
+
+static unsigned int dw8250_serial_in(struct uart_port *p, int offset)
+{
+	unsigned int value = readb_no_log(p->membase + (offset << p->regshift));
+
+	return dw8250_modify_msr(p, offset, value);
+}
+
+#ifdef CONFIG_64BIT
+static unsigned int dw8250_serial_inq(struct uart_port *p, int offset)
+{
+	unsigned int value;
+
+	value = (u8)__raw_readq_no_log(p->membase + (offset << p->regshift));
+
+	return dw8250_modify_msr(p, offset, value);
+}
+
+static void dw8250_serial_outq(struct uart_port *p, int offset, int value)
+{
+	value &= 0xff;
+	__raw_writeq_no_log(value, p->membase + (offset << p->regshift));
+	/* Read back to ensure register write ordering. */
+	__raw_readq_no_log(p->membase + (UART_LCR << p->regshift));
+
+	/* Make sure LCR write wasn't ignored */
+	if (offset == UART_LCR) {
+		int tries = 1000;
+
+		while (tries--) {
+			unsigned int lcr = p->serial_in(p, UART_LCR);
+
+			if ((value & ~UART_LCR_SPAR) == (lcr & ~UART_LCR_SPAR))
+				return;
+			dw8250_force_idle(p);
+			__raw_writeq_no_log(value & 0xff,
+				     p->membase + (UART_LCR << p->regshift));
+		}
+		/*
+		 * FIXME: this deadlocks if port->lock is already held
+		 * dev_err(p->dev, "Couldn't set LCR to %d\n", value);
+		 */
+	}
+}
+#endif /* CONFIG_64BIT */
+
+static void dw8250_serial_out32(struct uart_port *p, int offset, int value)
+{
+	writel_no_log(value, p->membase + (offset << p->regshift));
+
+	/* Make sure LCR write wasn't ignored */
+	if (offset == UART_LCR) {
+		int tries = 1000;
+
+		while (tries--) {
+			unsigned int lcr = p->serial_in(p, UART_LCR);
+
+			if ((value & ~UART_LCR_SPAR) == (lcr & ~UART_LCR_SPAR))
+				return;
+			dw8250_force_idle(p);
+			writel_no_log(value, p->membase + (UART_LCR << p->regshift));
+		}
+		/*
+		 * FIXME: this deadlocks if port->lock is already held
+		 * dev_err(p->dev, "Couldn't set LCR to %d\n", value);
+		 */
+	}
+}
+
+static unsigned int dw8250_serial_in32(struct uart_port *p, int offset)
+{
+	unsigned int value = readl_no_log(p->membase + (offset << p->regshift));
+
+	return dw8250_modify_msr(p, offset, value);
+}
+
+static int dw8250_handle_irq(struct uart_port *p)
+{
+	struct dw8250_data *d = p->private_data;
+	unsigned int iir = p->serial_in(p, UART_IIR);
+
+	if (serial8250_handle_irq(p, iir)) {
+		if (d->isr_reg)
+			writel_no_log(d->isr_st_mask, d->isr_reg);
+		return 1;
+	} else if ((iir & UART_IIR_BUSY) == UART_IIR_BUSY) {
+		/* Clear the USR and write the LCR again. */
+		(void)p->serial_in(p, DW_UART_USR);
+		//p->serial_out(p, UART_LCR, d->last_lcr);
+
+		if (d->isr_reg)
+			writel_no_log(d->isr_st_mask, d->isr_reg);
+		return 1;
+	}
+
+	if (d->isr_reg)
+		writel_no_log(d->isr_st_mask, d->isr_reg);
+
+	return 0;
+}
+
+static void
+dw8250_do_pm(struct uart_port *port, unsigned int state, unsigned int old)
+{
+	if (!state)
+		pm_runtime_get_sync(port->dev);
+
+	serial8250_do_pm(port, state, old);
+
+	if (state)
+		pm_runtime_put_sync_suspend(port->dev);
+}
+
+static void dw8250_set_termios(struct uart_port *p, struct ktermios *termios,
+			       struct ktermios *old)
+{
+	unsigned int baud = tty_termios_baud_rate(termios);
+	struct dw8250_data *d = p->private_data;
+	unsigned int rate;
+	int ret;
+
+	if (IS_ERR(d->clk) || !old)
+		goto out;
+
+	clk_disable_unprepare(d->clk);
+	rate = clk_round_rate(d->clk, baud * 16);
+	ret = clk_set_rate(d->clk, rate);
+	clk_prepare_enable(d->clk);
+
+	if (!ret)
+		p->uartclk = rate;
+
+	p->status &= ~UPSTAT_AUTOCTS;
+	if (termios->c_cflag & CRTSCTS)
+		p->status |= UPSTAT_AUTOCTS;
+
+out:
+	serial8250_do_set_termios(p, termios, old);
+}
+
+/*
+ * dw8250_fallback_dma_filter will prevent the UART from getting just any free
+ * channel on platforms that have DMA engines, but don't have any channels
+ * assigned to the UART.
+ *
+ * REVISIT: This is a work around for limitation in the DMA Engine API. Once the
+ * core problem is fixed, this function is no longer needed.
+ */
+static bool dw8250_fallback_dma_filter(struct dma_chan *chan, void *param)
+{
+	return false;
+}
+
+static bool dw8250_idma_filter(struct dma_chan *chan, void *param)
+{
+	return param == chan->device->dev->parent;
+}
+
+static void dw8250_quirks(struct uart_port *p, struct dw8250_data *data)
+{
+	if (p->dev->of_node) {
+		struct device_node *np = p->dev->of_node;
+		int id;
+
+		/* get index of serial line, if found in DT aliases */
+		id = of_alias_get_id(np, "serial");
+		if (id >= 0)
+			p->line = id;
+#ifdef CONFIG_64BIT
+		if (of_device_is_compatible(np, "cavium,octeon-3860-uart")) {
+			p->serial_in = dw8250_serial_inq;
+			p->serial_out = dw8250_serial_outq;
+			p->flags = UPF_SKIP_TEST |
+				UPF_SHARE_IRQ | UPF_FIXED_TYPE;
+			p->type = PORT_OCTEON;
+			data->usr_reg = 0x27;
+			data->skip_autocfg = true;
+		}
+#endif
+	} else if (has_acpi_companion(p->dev)) {
+		p->iotype = UPIO_MEM32;
+		p->regshift = 2;
+		p->serial_in = dw8250_serial_in32;
+		p->set_termios = dw8250_set_termios;
+		/* So far none of there implement the Busy Functionality */
+		data->uart_16550_compatible = true;
+	}
+
+	/* Platforms with iDMA */
+	if (platform_get_resource_byname(to_platform_device(p->dev),
+					 IORESOURCE_MEM, "lpss_priv")) {
+		p->set_termios = dw8250_set_termios;
+		data->dma.rx_param = p->dev->parent;
+		data->dma.tx_param = p->dev->parent;
+		data->dma.fn = dw8250_idma_filter;
+	}
+}
+
+static void dw8250_setup_port(struct uart_port *p)
+{
+	struct uart_8250_port *up = up_to_u8250p(p);
+	u32 reg;
+
+	/*
+	 * If the Component Version Register returns zero, we know that
+	 * ADDITIONAL_FEATURES are not enabled. No need to go any further.
+	 */
+	reg = readl_no_log(p->membase + DW_UART_UCV);
+	if (!reg)
+		return;
+
+	dev_dbg(p->dev, "Designware UART version %c.%c%c\n",
+		(reg >> 24) & 0xff, (reg >> 16) & 0xff, (reg >> 8) & 0xff);
+
+	reg = readl_no_log(p->membase + DW_UART_CPR);
+	if (!reg)
+		return;
+
+	/* Select the type based on fifo */
+	if (reg & DW_UART_CPR_FIFO_MODE) {
+		p->type = PORT_16550A;
+		p->flags |= UPF_FIXED_TYPE;
+		p->fifosize = DW_UART_CPR_FIFO_SIZE(reg);
+		up->capabilities = UART_CAP_FIFO;
+	}
+
+	if (reg & DW_UART_CPR_AFCE_MODE)
+		up->capabilities |= UART_CAP_AFE;
+}
+
+static int dw8250_probe(struct platform_device *pdev)
+{
+	struct uart_8250_port uart = {};
+	struct resource *regs = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	struct resource *isr_regs =
+			platform_get_resource(pdev, IORESOURCE_MEM, 1);
+	int irq = platform_get_irq(pdev, 0);
+	struct uart_port *p = &uart.port;
+	struct dw8250_data *data;
+	struct device_node *node = pdev->dev.of_node;
+	int err;
+	u32 val;
+
+	if (!regs) {
+		dev_err(&pdev->dev, "no registers defined\n");
+		return -EINVAL;
+	}
+
+	if (irq < 0) {
+		if (irq != -EPROBE_DEFER)
+			dev_err(&pdev->dev, "cannot get irq\n");
+		return irq;
+	}
+
+	spin_lock_init(&p->lock);
+	p->mapbase	= regs->start;
+	p->irq		= irq;
+	p->handle_irq	= dw8250_handle_irq;
+	p->pm		= dw8250_do_pm;
+	p->type		= PORT_8250;
+	p->flags	= UPF_SHARE_IRQ | UPF_FIXED_PORT;
+	p->dev		= &pdev->dev;
+	p->iotype	= UPIO_MEM;
+	p->serial_in	= dw8250_serial_in;
+	p->serial_out	= dw8250_serial_out;
+
+	p->membase = devm_ioremap(&pdev->dev, regs->start, resource_size(regs));
+	if (!p->membase)
+		return -ENOMEM;
+
+	data = devm_kzalloc(&pdev->dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	data->dma.fn = dw8250_fallback_dma_filter;
+	data->usr_reg = DW_UART_USR;
+	p->private_data = data;
+
+	data->uart_16550_compatible = device_property_read_bool(p->dev,
+						"snps,uart-16550-compatible");
+
+	err = device_property_read_u32(p->dev, "reg-shift", &val);
+	if (!err)
+		p->regshift = val;
+
+	err = device_property_read_u32(p->dev, "reg-io-width", &val);
+	if (!err && val == 4) {
+		p->iotype = UPIO_MEM32;
+		p->serial_in = dw8250_serial_in32;
+		p->serial_out = dw8250_serial_out32;
+	}
+
+	if (device_property_read_bool(p->dev, "dcd-override")) {
+		/* Always report DCD as active */
+		data->msr_mask_on |= UART_MSR_DCD;
+		data->msr_mask_off |= UART_MSR_DDCD;
+	}
+
+	if (device_property_read_bool(p->dev, "dsr-override")) {
+		/* Always report DSR as active */
+		data->msr_mask_on |= UART_MSR_DSR;
+		data->msr_mask_off |= UART_MSR_DDSR;
+	}
+
+	if (device_property_read_bool(p->dev, "cts-override")) {
+		/* Always report CTS as active */
+		data->msr_mask_on |= UART_MSR_CTS;
+		data->msr_mask_off |= UART_MSR_DCTS;
+	}
+
+	if (device_property_read_bool(p->dev, "ri-override")) {
+		/* Always report Ring indicator as inactive */
+		data->msr_mask_off |= UART_MSR_RI;
+		data->msr_mask_off |= UART_MSR_TERI;
+	}
+
+	/* Always ask for fixed clock rate from a property. */
+	device_property_read_u32(p->dev, "clock-frequency", &p->uartclk);
+
+	/* If there is separate baudclk, get the rate from it. */
+	data->clk = devm_clk_get(&pdev->dev, "baudclk");
+	if (IS_ERR(data->clk) && PTR_ERR(data->clk) != -EPROBE_DEFER)
+		data->clk = devm_clk_get(&pdev->dev, NULL);
+	if (IS_ERR(data->clk) && PTR_ERR(data->clk) == -EPROBE_DEFER)
+		return -EPROBE_DEFER;
+	if (!IS_ERR_OR_NULL(data->clk)) {
+		err = clk_prepare_enable(data->clk);
+		if (err)
+			dev_warn(&pdev->dev, "could not enable optional baudclk: %d\n",
+				 err);
+		else if (!uart.port.uartclk) // only get uartclk if DTS doesn't set "clock-frequency"
+			p->uartclk = clk_get_rate(data->clk);
+	}
+
+	/* If no clock rate is defined, fail. */
+	if (!p->uartclk) {
+		dev_err(&pdev->dev, "clock rate not defined\n");
+		return -EINVAL;
+	}
+
+	data->pclk = devm_clk_get(&pdev->dev, "apb_pclk");
+	if (IS_ERR(data->pclk) && PTR_ERR(data->pclk) == -EPROBE_DEFER) {
+		err = -EPROBE_DEFER;
+		goto err_clk;
+	}
+	if (!IS_ERR(data->pclk)) {
+		err = clk_prepare_enable(data->pclk);
+		if (err) {
+			dev_err(&pdev->dev, "could not enable apb_pclk\n");
+			goto err_clk;
+		}
+	}
+
+	data->rst = devm_reset_control_get_optional(&pdev->dev, NULL);
+	if (IS_ERR(data->rst) && PTR_ERR(data->rst) == -EPROBE_DEFER) {
+		err = -EPROBE_DEFER;
+		goto err_pclk;
+	}
+	if (!IS_ERR(data->rst))
+		reset_control_deassert(data->rst);
+
+	if (!of_property_read_u32_index(node, "interrupts-st-mask", 0, &data->isr_st_mask))
+		data->isr_reg = devm_ioremap(&pdev->dev, isr_regs->start, resource_size(isr_regs));
+	else
+		data->isr_reg = 0;
+
+	dw8250_quirks(p, data);
+
+	/* If the Busy Functionality is not implemented, don't handle it */
+	if (data->uart_16550_compatible) {
+		p->serial_out = NULL;
+		p->handle_irq = NULL;
+	}
+
+	if (!data->skip_autocfg)
+		dw8250_setup_port(p);
+
+	/* If we have a valid fifosize, try hooking up DMA */
+	if (p->fifosize) {
+		data->dma.rxconf.src_maxburst = p->fifosize / 4;
+		data->dma.txconf.dst_maxburst = p->fifosize / 4;
+		uart.dma = &data->dma;
+	}
+
+	data->line = serial8250_register_8250_port(&uart);
+	if (data->line < 0) {
+		err = data->line;
+		goto err_reset;
+	}
+
+	platform_set_drvdata(pdev, data);
+
+	pm_runtime_set_active(&pdev->dev);
+	pm_runtime_enable(&pdev->dev);
+
+	return 0;
+
+err_reset:
+	if (!IS_ERR(data->rst))
+		reset_control_assert(data->rst);
+
+err_pclk:
+	if (!IS_ERR(data->pclk))
+		clk_disable_unprepare(data->pclk);
+
+err_clk:
+	if (!IS_ERR(data->clk))
+		clk_disable_unprepare(data->clk);
+
+	return err;
+}
+
+static int dw8250_remove(struct platform_device *pdev)
+{
+	struct dw8250_data *data = platform_get_drvdata(pdev);
+
+	pm_runtime_get_sync(&pdev->dev);
+
+	serial8250_unregister_port(data->line);
+
+	if (!IS_ERR(data->rst))
+		reset_control_assert(data->rst);
+
+	if (!IS_ERR(data->pclk))
+		clk_disable_unprepare(data->pclk);
+
+	if (!IS_ERR(data->clk))
+		clk_disable_unprepare(data->clk);
+
+	pm_runtime_disable(&pdev->dev);
+	pm_runtime_put_noidle(&pdev->dev);
+
+	return 0;
+}
+
+#ifdef CONFIG_PM_SLEEP
+static int dw8250_suspend(struct device *dev)
+{
+	struct dw8250_data *data = dev_get_drvdata(dev);
+
+	if (!IS_ERR(data->rst))
+		reset_control_deassert(data->rst);
+
+	serial8250_suspend_port(data->line);
+
+	return 0;
+}
+
+static int dw8250_resume(struct device *dev)
+{
+	struct dw8250_data *data = dev_get_drvdata(dev);
+
+	serial8250_resume_port(data->line);
+
+	return 0;
+}
+#endif /* CONFIG_PM_SLEEP */
+
+#ifdef CONFIG_PM
+static int dw8250_runtime_suspend(struct device *dev)
+{
+	struct dw8250_data *data = dev_get_drvdata(dev);
+
+	if (!IS_ERR(data->clk))
+		clk_disable_unprepare(data->clk);
+
+	if (!IS_ERR(data->pclk))
+		clk_disable_unprepare(data->pclk);
+
+	return 0;
+}
+
+static int dw8250_runtime_resume(struct device *dev)
+{
+	struct dw8250_data *data = dev_get_drvdata(dev);
+
+	if (!IS_ERR(data->pclk))
+		clk_prepare_enable(data->pclk);
+
+	if (!IS_ERR(data->clk))
+		clk_prepare_enable(data->clk);
+
+	return 0;
+}
+#endif
+
+static const struct dev_pm_ops dw8250_pm_ops = {
+	SET_SYSTEM_SLEEP_PM_OPS(dw8250_suspend, dw8250_resume)
+	SET_RUNTIME_PM_OPS(dw8250_runtime_suspend, dw8250_runtime_resume, NULL)
+};
+
+static const struct of_device_id dw8250_of_match[] = {
+	{ .compatible = "snps,dw-apb-uart" },
+	{ .compatible = "cavium,octeon-3860-uart" },
+	{ /* Sentinel */ }
+};
+MODULE_DEVICE_TABLE(of, dw8250_of_match);
+
+static const struct acpi_device_id dw8250_acpi_match[] = {
+	{ "INT33C4", 0 },
+	{ "INT33C5", 0 },
+	{ "INT3434", 0 },
+	{ "INT3435", 0 },
+	{ "80860F0A", 0 },
+	{ "8086228A", 0 },
+	{ "APMC0D08", 0},
+	{ "AMD0020", 0 },
+	{ },
+};
+MODULE_DEVICE_TABLE(acpi, dw8250_acpi_match);
+
+static struct platform_driver dw8250_platform_driver = {
+	.driver = {
+		.name = "dw-apb-uart",
+		.pm = &dw8250_pm_ops,
+		.of_match_table	= dw8250_of_match,
+		.acpi_match_table = ACPI_PTR(dw8250_acpi_match),
+	},
+	.probe = dw8250_probe,
+	.remove = dw8250_remove,
+};
+
+module_platform_driver(dw8250_platform_driver);
+
+MODULE_AUTHOR("Jamie Iles");
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Synopsys DesignWare 8250 serial port driver");
+MODULE_ALIAS("platform:dw-apb-uart");
diff --git a/drivers/tty/serial/8250/8250_uniphier.c b/drivers/tty/serial/8250/8250_uniphier.c
index 417d9e7..491e8c6b 100644
--- a/drivers/tty/serial/8250/8250_uniphier.c
+++ b/drivers/tty/serial/8250/8250_uniphier.c
@@ -84,7 +84,7 @@ static unsigned int uniphier_serial_in(struct uart_port *p, int offset)
 	 * in the same register that must be accessed by 32-bit write/read.
 	 * 8 or 16 bit access to this hardware result in unexpected behavior.
 	 */
-	return (readl(p->membase + offset) >> valshift) & 0xff;
+	return (readl_no_log(p->membase + offset) >> valshift) & 0xff;
 }
 
 static void uniphier_serial_out(struct uart_port *p, int offset, int value)
@@ -112,7 +112,7 @@ static void uniphier_serial_out(struct uart_port *p, int offset, int value)
 	offset <<= p->regshift;
 
 	if (normal) {
-		writel(value, p->membase + offset);
+		writel_no_log(value, p->membase + offset);
 	} else {
 		/*
 		 * Special case: two registers share the same address that
@@ -124,10 +124,10 @@ static void uniphier_serial_out(struct uart_port *p, int offset, int value)
 		u32 tmp;
 
 		spin_lock_irqsave(&priv->atomic_write_lock, flags);
-		tmp = readl(p->membase + offset);
+		tmp = readl_no_log(p->membase + offset);
 		tmp &= ~(0xff << valshift);
 		tmp |= value << valshift;
-		writel(tmp, p->membase + offset);
+		writel_no_log(tmp, p->membase + offset);
 		spin_unlock_irqrestore(&priv->atomic_write_lock, flags);
 	}
 }
@@ -141,14 +141,14 @@ static int uniphier_serial_dl_read(struct uart_8250_port *up)
 {
 	int offset = UNIPHIER_UART_DLR << up->port.regshift;
 
-	return readl(up->port.membase + offset);
+	return readl_no_log(up->port.membase + offset);
 }
 
 static void uniphier_serial_dl_write(struct uart_8250_port *up, int value)
 {
 	int offset = UNIPHIER_UART_DLR << up->port.regshift;
 
-	writel(value, up->port.membase + offset);
+	writel_no_log(value, up->port.membase + offset);
 }
 
 static int uniphier_of_serial_setup(struct device *dev, struct uart_port *port,
diff --git a/drivers/tty/serial/8250/Kconfig b/drivers/tty/serial/8250/Kconfig
index 8998347..2321421 100644
--- a/drivers/tty/serial/8250/Kconfig
+++ b/drivers/tty/serial/8250/Kconfig
@@ -447,3 +447,11 @@ config SERIAL_OF_PLATFORM
 	  are probed through devicetree, including Open Firmware based
 	  PowerPC systems and embedded systems on architectures using the
 	  flattened device tree format.
+
+config SERIAL_8250_RTK
+	tristate "Realtek  serial port support "
+	depends on SERIAL_8250 && RTK_PLATFORM
+	help
+	  If you have a system using an Realtek SoC and wish to make use of
+	  its UARTs, say Y to this option. If unsure, say N.
+
diff --git a/drivers/tty/serial/8250/Makefile b/drivers/tty/serial/8250/Makefile
index 276c6fb..6cf99b7 100644
--- a/drivers/tty/serial/8250/Makefile
+++ b/drivers/tty/serial/8250/Makefile
@@ -21,7 +21,7 @@ obj-$(CONFIG_SERIAL_8250_BOCA)		+= 8250_boca.o
 obj-$(CONFIG_SERIAL_8250_EXAR_ST16C554)	+= 8250_exar_st16c554.o
 obj-$(CONFIG_SERIAL_8250_HUB6)		+= 8250_hub6.o
 obj-$(CONFIG_SERIAL_8250_FSL)		+= 8250_fsl.o
-obj-$(CONFIG_SERIAL_8250_DW)		+= 8250_dw.o
+#obj-$(CONFIG_SERIAL_8250_DW)		+= 8250_dw.o
 obj-$(CONFIG_SERIAL_8250_EM)		+= 8250_em.o
 obj-$(CONFIG_SERIAL_8250_OMAP)		+= 8250_omap.o
 obj-$(CONFIG_SERIAL_8250_LPC18XX)	+= 8250_lpc18xx.o
@@ -31,6 +31,7 @@ obj-$(CONFIG_SERIAL_8250_INGENIC)	+= 8250_ingenic.o
 obj-$(CONFIG_SERIAL_8250_LPSS)		+= 8250_lpss.o
 obj-$(CONFIG_SERIAL_8250_MID)		+= 8250_mid.o
 obj-$(CONFIG_SERIAL_8250_MOXA)		+= 8250_moxa.o
-obj-$(CONFIG_SERIAL_OF_PLATFORM)	+= 8250_of.o
+#obj-$(CONFIG_SERIAL_OF_PLATFORM)	+= 8250_of.o
+obj-$(CONFIG_SERIAL_8250_RTK)			+= 8250_rtk.o
 
 CFLAGS_8250_ingenic.o += -I$(srctree)/scripts/dtc/libfdt
diff --git a/drivers/tty/serial/kgdboc.c b/drivers/tty/serial/kgdboc.c
index a260cde..5532c44 100644
--- a/drivers/tty/serial/kgdboc.c
+++ b/drivers/tty/serial/kgdboc.c
@@ -245,7 +245,8 @@ static void kgdboc_put_char(u8 chr)
 					kgdb_tty_line, chr);
 }
 
-static int param_set_kgdboc_var(const char *kmessage, struct kernel_param *kp)
+static int param_set_kgdboc_var(const char *kmessage,
+				const struct kernel_param *kp)
 {
 	int len = strlen(kmessage);
 
diff --git a/drivers/tty/serial/serial_core.c b/drivers/tty/serial/serial_core.c
index 6cbd46c..839cee4 100644
--- a/drivers/tty/serial/serial_core.c
+++ b/drivers/tty/serial/serial_core.c
@@ -131,6 +131,9 @@ static void __uart_start(struct tty_struct *tty)
 	struct uart_state *state = tty->driver_data;
 	struct uart_port *port = state->uart_port;
 
+	if (port && port->ops->wake_peer)
+		port->ops->wake_peer(port);
+
 	if (port && !uart_tx_stopped(port))
 		port->ops->start_tx(port);
 }
diff --git a/drivers/tty/sysrq.c b/drivers/tty/sysrq.c
index 53cbf4e..732a32d 100644
--- a/drivers/tty/sysrq.c
+++ b/drivers/tty/sysrq.c
@@ -53,7 +53,7 @@
 
 /* Whether we react on sysrq keys or just ignore them */
 static int __read_mostly sysrq_enabled = CONFIG_MAGIC_SYSRQ_DEFAULT_ENABLE;
-static bool __read_mostly sysrq_always_enabled;
+static bool __read_mostly sysrq_always_enabled = true;
 
 static bool sysrq_on(void)
 {
diff --git a/drivers/uio/Kconfig b/drivers/uio/Kconfig
index 52c98ce..e0c64128 100644
--- a/drivers/uio/Kconfig
+++ b/drivers/uio/Kconfig
@@ -12,6 +12,35 @@ menuconfig UIO
 
 if UIO
 
+config UIO_ASSIGN_MINOR
+	bool "UIO supports assigning minor number"
+
+config UIO_RTK
+	bool "Realtek Generic UIO Driver"
+	default y
+	help
+	  Realtek Generic UIO Driver
+
+	  If you don't know what to do here, say Y.
+
+config UIO_RTK_SE
+	bool "Streaming Engine driver use UIO mode"
+	default n
+	select UIO_ASSIGN_MINOR
+	select CONFIG_UIO_PDRV_GENIRQ
+	select CONFIG_UIO_DMEM_GENIRQ
+	help
+	  Realtek Streaming Engine driver using UIO mode
+
+config UIO_RTK_MD
+	bool "Moving Data Engine driver use UIO mode"
+	default n
+	select UIO_ASSIGN_MINOR
+	select CONFIG_UIO_PDRV_GENIRQ
+	select CONFIG_UIO_DMEM_GENIRQ
+	help
+	  Realtek Moving Data Engine driver using UIO mode
+
 config UIO_CIF
 	tristate "generic Hilscher CIF Card driver"
 	depends on PCI
diff --git a/drivers/uio/Makefile b/drivers/uio/Makefile
index 8560dad..b41f03e 100644
--- a/drivers/uio/Makefile
+++ b/drivers/uio/Makefile
@@ -9,3 +9,6 @@ obj-$(CONFIG_UIO_NETX)	+= uio_netx.o
 obj-$(CONFIG_UIO_PRUSS)         += uio_pruss.o
 obj-$(CONFIG_UIO_MF624)         += uio_mf624.o
 obj-$(CONFIG_UIO_FSL_ELBC_GPCM)	+= uio_fsl_elbc_gpcm.o
+obj-$(CONFIG_UIO_RTK)		+= uio_rtk.o
+obj-$(CONFIG_UIO_RTK_SE)		+= uio_rtk_se.o
+obj-$(CONFIG_UIO_RTK_MD)		+= uio_rtk_md.o
diff --git a/drivers/uio/reg_md.h b/drivers/uio/reg_md.h
new file mode 100644
index 00000000..97079f5
--- /dev/null
+++ b/drivers/uio/reg_md.h
@@ -0,0 +1,205 @@
+//=================================================================================================
+// Copyright (c) 2008 Realtek Mdmiconductor Corp. All Rights Reserved.
+//
+// Filename: MdReg.h
+// Abstract:
+//   Related Definitions of Register Mdt for Columbus Streaming Engine
+//
+// History:
+//   2008-02-14         cyyang          Initial Version
+//=================================================================================================
+
+#ifndef _MD_REG_H_
+#define _MD_REG_H_
+
+//=================================================================================================
+#define MDREG_BASE_ADDRESS              	0xB800B000
+
+//=================================================================================================
+typedef union _MDREG_CTRL
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CTRL (0x1800_B000)
+        uint32_t  write_data: 1;            //IO[0]: write_data
+        
+        uint32_t  go: 1;                    //IO[1]: MD operation of the command queue can only start when go = 1. 
+                                            //       Once it starts the command queue will only stop when this bit is 
+                                            //       set to 0 and when it completes the current instruction
+        
+        uint32_t  endiswap: 1;              //IO[2]: When this bit is == 1, the command endianness will be swapped. 
+                                            //       It will change the byte order to {cmd[7:0],cmd[15:8], cmd[23:16], cmd[31:24]}
+                                            	
+        uint32_t  idle: 1;
+
+        uint32_t  Reserved: 28;             //IO[31:4]: Reserved  
+
+    } Fields;
+    
+} MDREG_CTRL;
+
+//=================================================================================================
+typedef union _MDREG_INTS
+{
+    uint32_t  Value;
+    struct
+    {    
+        uint32_t  write_data: 1;
+        uint32_t  smq_inst_err: 1;
+        uint32_t  smq_length_err: 1;
+        uint32_t  smq_empty: 1;
+        uint32_t  fdma_done: 1;
+        uint32_t  smq_mode_2b4b_err: 1;
+        uint32_t  ur_tx_thd: 1;
+        uint32_t  ur_rx_thd: 1;
+        uint32_t  ur_rx_timeout: 1;
+        uint32_t  ur_length_err: 1;
+        uint32_t  smq_chksum_err: 1;
+        uint32_t  gsp_tx_thd_ints: 1;
+        uint32_t  gsp_txbasic_thd_ints: 1;
+        uint32_t  gsp_txdat_thd_ints: 1;
+        uint32_t  gsp_rx_thd_ints: 1;
+        uint32_t  gsp_length_err: 1;
+		uint32_t  Reserved: 16;             //IO[31:16]: Reserved  
+    } Fields;   
+                
+} MDREG_INTS;   
+
+//=================================================================================================
+typedef union _MDREG_INTE
+{
+    uint32_t  Value;
+    struct
+    {    
+		uint32_t  write_data: 1;
+		uint32_t  smq_inst_err_en: 1;
+		uint32_t  smq_length_err_en: 1;
+		uint32_t  smq_empty_en: 1;
+		uint32_t  fdma_done_en: 1;
+		uint32_t  smq_mode_2b4b_err_en: 1;
+		uint32_t  ur_tx_thd_en: 1;
+    uint32_t  ur_rx_thd_en: 1;
+    uint32_t  ur_rx_timeout_en: 1;
+    uint32_t  ur_length_err_en: 1;
+    uint32_t  smq_chksum_err_en: 1;
+    uint32_t  gsp_tx_thd_en: 1;
+    uint32_t  gsp_txbasic_thd_en: 1;
+    uint32_t  gsp_txdat_thd_en: 1;
+    uint32_t  gsp_rx_thd_en: 1;
+    uint32_t  gsp_length_err_en: 1;
+		uint32_t  scpu_int_en: 1;
+		uint32_t  Reserved: 15;
+                                             
+    } Fields;   
+                
+} MDREG_INTE; 
+ 
+//=================================================================================================
+typedef union _MDREG_CMDBASE
+{
+    uint32_t  Value;
+    struct
+    {    
+											//Register: CMDBASE (0x1800_B00C)
+		uint32_t  Reserved0: 4; 			//IO[3:0]: Reserved 
+        uint32_t  base: 25;                 //IO[27:4]: Command ring buffer SDRAM base address, 16B alignment
+        uint32_t  Reserved1: 3;             //IO[31:28]: Reserved    
+        
+    } Fields;
+    
+} MDREG_CMDBASE;
+
+//=================================================================================================
+typedef union _MDREG_CMDLMT
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CMDLMT (0x1800_B010)
+		uint32_t  Reserved0: 4;             //IO[3:0]: Reserved   
+        uint32_t  limit: 25;                //IO[27:4]: Command ring buffer limit SDRAM address, 16B alignment
+        uint32_t  Reserved1: 3;             //IO[31:28]: Reserved  
+        
+    } Fields;
+    
+} MDREG_CMDLMT;
+
+//=================================================================================================
+typedef union _MDREG_CMDRPTR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CMDRPTR (0x1800_B014)
+		uint32_t  Reserved0: 4;             //IO[3:0]: Reserved 
+        uint32_t  rptr: 25;                 //IO[27:4]: Command ring buffer read pointer, 16B alignment 
+        uint32_t  Reserved1: 3;             //IO[31:28]: Reserved    
+        
+    } Fields;
+    
+} MDREG_CMDRPTR;
+
+//=================================================================================================
+typedef union _MDREG_CMDWPTR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CMDWPTR (0x1800_B018)  
+		uint32_t  Reserved0: 4; 			//IO[3:0]: Reserved 
+        uint32_t  wptr: 25;                 //IO[27:4]: Command ring buffer write pointer, 16B alignment   
+        uint32_t  Reserved1: 3;             //IO[31:28]: Reserved  
+        
+    } Fields;
+    
+} MDREG_CMDWPTR;
+
+//=================================================================================================
+typedef union _MDREG_FIFOSTATE
+{
+    uint32_t  Value;
+    struct
+    {    
+        uint32_t  smq_inst_remain: 5;
+        uint32_t  Reserved: 27;
+    } Fields;
+    
+} MDREG_FIFOSTATE; 
+
+//=================================================================================================
+typedef union _MDREG_INSTCNT
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: INSTCNT (0x1800_B020)
+        uint32_t  instcnt: 16;              //IO[15:0]: number of commands encountered.  This field will increment by 1 
+                                            //          whenever an command is completed execution. It will wrap to 0 after 16hffff.
+        
+        uint32_t  Reserved: 16;             //IO[31:16]: Reserved  
+                                    
+    } Fields;
+    
+} MDREG_INSTCNT; 
+
+//=================================================================================================
+typedef struct _MDREG_INFO
+{               
+    MDREG_CTRL              MdCtrl[1];              //0x1800_B000: Register: CTRL
+    MDREG_INTS              MdInts[1];              //0x1800_B004: Register: INTS
+    MDREG_INTE              MdInte[1];              //0x1800_B008: Register: INTE
+    MDREG_CMDBASE           MdCmdBase[1];           //0x1800_B00C: Register: CMDBASE
+    MDREG_CMDLMT            MdCmdLimit[1];          //0x1800_B010: Register: MDREG_CMDLMT
+    MDREG_CMDRPTR           MdCmdReadPtr[1];        //0x1800_B014: Register: CMDRPTR
+    MDREG_CMDWPTR           MdCmdWritePtr[1];       //0x1800_B018: Register: CMDWPTR
+    MDREG_FIFOSTATE         MdFifoState[1];         //0x1800_B01C: Register: FIFOSTATE
+    MDREG_INSTCNT           MdInstCnt[1];           //0x1800_B020: Register: INSTCNT
+} MDREG_INFO;
+
+//=================================================================================================
+
+#endif
+
+//=================================================================================================
+// End of File
diff --git a/drivers/uio/reg_se.h b/drivers/uio/reg_se.h
new file mode 100644
index 00000000..fa3e8fe
--- /dev/null
+++ b/drivers/uio/reg_se.h
@@ -0,0 +1,1144 @@
+//=================================================================================================
+// Copyright (c) 2008 Realtek Semiconductor Corp. All Rights Reserved.
+//
+// Filename: SeReg.h
+// Abstract:
+//   Related Definitions of Register Set for Columbus Streaming Engine
+//
+// History:
+//   2008-02-14         cyyang          Initial Version
+//   2011-01-18         zack            Modify for Saturn
+//=================================================================================================
+
+#ifndef _SE_REG_H_
+#define _SE_REG_H_
+
+//=================================================================================================
+#define SEREG_BASE_ADDRESS              	0xB800C000
+
+//=================================================================================================
+typedef union _SEREG_CMDBASE
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CMDBASE (0x1800_C000)
+        uint32_t  Reserved0: 4;             //IO[3:0]: Reserved 
+        uint32_t  base: 27;                 //IO[30:4]: Command ring buffer SDRAM base address, 16B alignment
+        uint32_t  Reserved1: 1;             //IO[31:31]: Reserved    
+        
+    } Fields;
+    
+} SEREG_CMDBASE;
+
+//=================================================================================================
+typedef union _SEREG_CMDLMT
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CMDLMT (0x1800_C00C)
+        uint32_t  Reserved0: 4;             //IO[3:0]: Reserved   
+        uint32_t  limit: 27;                //IO[30:4]: Command ring buffer limit SDRAM address, 16B alignment
+        uint32_t  Reserved1: 1;             //IO[31:31]: Reserved  
+        
+    } Fields;
+    
+} SEREG_CMDLMT;
+
+//=================================================================================================
+typedef union _SEREG_CMDRPTR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CMDRPTR (0x1800_C018)
+        uint32_t  Reserved0: 4;             //IO[3:0]: Reserved 
+        uint32_t  rptr: 27;                 //IO[30:4]: Command ring buffer read pointer, 16B alignment 
+        uint32_t  Reserved1: 1;             //IO[31:31]: Reserved    
+        
+    } Fields;
+    
+} SEREG_CMDRPTR;
+
+//=================================================================================================
+typedef union _SEREG_CMDWPTR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CMDWPTR (0x1800_C024)  
+        uint32_t  Reserved0: 4; 			      //IO[3:0]: Reserved 
+        uint32_t  wptr: 27;                 //IO[30:4]: Command ring buffer write pointer, 16B alignment   
+        uint32_t  Reserved1: 1;             //IO[31:31]: Reserved  
+        
+    } Fields;
+    
+} SEREG_CMDWPTR;
+
+//=================================================================================================
+typedef union _SEREG_SRWORDCNT
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SRWORDCNT (0x1800_C030)
+        uint32_t  srwordcnt: 7;             //IO[6:0]: Number of 4B word inside SE command FIFO SRAM. 
+                                            //		   This is used for debugging only. 	
+
+        uint32_t  Reserved: 25;             //IO[31:7]: Reserved    
+        
+    } Fields;
+    
+} SEREG_SRWORDCNT;
+
+//=================================================================================================
+typedef union _SEREG_Q_PRIORITY
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: Q_PRIORITY (0x1800_C03C)
+        uint32_t  pri1: 2;                  //IO[1:0]: Priority number of command queue1.
+        uint32_t  pri2: 2;                  //IO[3:2]: Priority number of command queue2.
+        uint32_t  pri3: 2;                  //IO[5:4]: Priority number of command queue3.
+        uint32_t  Reserved: 26;             //IO[31:6]: Reserved    
+       
+    } Fields;
+    
+} SEREG_Q_PRIORITY;
+
+//=================================================================================================
+typedef union _SEREG_CLR_FMT
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CLR_FMT (0x1800_C040)
+        uint32_t  Format: 4;                //IO[3:0]: Format
+                                            //		   - 4¡¦b0010: Index8
+                                            //		   - 4¡¦b0100: RGB565
+                                            //		   - 4¡¦b0101: ARGB1555
+                                            //		   - 4¡¦b0110: ARGB4444
+                                            //		   - 4¡¦b0111: ARGB8888
+                                            //		   - 4¡¦b1000: Y (stretch and rotate command only)
+                                            //		   - 4¡¦b1001: CbCr (stretch and rotate command only)
+                                            //		   - 4¡¦b1010: YCbCr 420 (alpha only)
+                                            //		   - 4¡¦b1011: YCbCr 422 (alpha only)
+                                            //		   - 4¡¦b1111: RGB888
+                                            //		   - else: reserved
+                                   
+        uint32_t  write_enable1: 1;         //IO[4]: Write enable for IO[3:0]
+
+        uint32_t  alpha_loc: 1;             //IO[5]: Location of alpha pixel if the format is 8888, 4444, 1555 mode, this bit 
+                                            //		 specifies whether the alpha pixel location is the leftmost (=0) or rightmost 
+                                            //		 of a pixel
+
+        uint32_t  write_enable2: 1;         //IO[6]: Write enable for IO[5]
+
+        uint32_t  Reserved1: 6;             //IO[12:7]: Reserved
+
+        uint32_t  alpha_loc2: 1;            //IO[13]: Specify the output alpha location in format conversion ARGB to ARGB mode
+
+        uint32_t  write_enable5: 1;         //IO[14]: Write enable for IO[13]
+	
+        uint32_t  big_endian_i1: 1;         //IO[15]: SE works on big endian. If input color format is little endian, SE will swap data to big endian before operation
+	
+        uint32_t  write_enable6: 1;         //IO[16]: Write enable for IO[15]
+
+        uint32_t  big_endian_i2: 1;         //IO[17]: Specify input color format for bitblit/alpha destination data (source data is specified by big_endian_i1)
+
+        uint32_t  write_enable7: 1;         //IO[18]: Write enable for IO[17]
+
+        uint32_t  big_endian_o: 1;          //IO[19]: Specify endian type for output color format. If output color format is little endian, SE will swap data to little endian after operation
+
+        uint32_t  write_enable8: 1;         //IO[20]: Write enable for IO[19]
+
+        uint32_t  rounding_en: 1;           //IO[21]: Rounding option for color format truncation (i.e. RGB888 to RGB565)
+                                            //        - 0: disable rounding
+                                            //        - 1: enable rounding
+
+        uint32_t  write_enable10: 1;        //IO[22]: Write enable for IO[21]
+        uint32_t  Reserved2: 9;             //IO[31:23]: Reserved    
+
+    } Fields;
+    
+} SEREG_CLR_FMT;
+
+//=================================================================================================
+typedef union _SEREG_COLOR_KEY
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: COLOR_KEY (0x1800_C04C)
+        uint32_t  color_key: 24;            //IO[23:0]: color key in variable color formats. 
+                                            //          - Index2: use color_key[1:0] as color_key
+                                            //          - Index4: use color_key[3:0] as color_key
+                                            //          - Index8: use color_key[7:0] as color_key
+                                            //          - RGB332: use color_key[7:0] as color_key
+                                            //          - RGB565: use color_key[15:0] as color_key
+                                            //          - ARGB1555: use color_key[14:0] as color_key
+                                            //          - ARGB4444: use color_key[11:0] as color_key
+                                            //          - ARGB8888: use color_key[23:0] as color_key
+
+        uint32_t  Reserved: 8;              //IO[31:24]: Reserved    
+
+    } Fields;
+    
+} SEREG_COLOR_KEY;
+
+//=================================================================================================
+typedef union _SEREG_DST_COLOR_KEY
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: DST_COLOR_KEY (0x1800_C54C)
+        uint32_t  dst_color_key: 24;        //IO[23:0]: This destination color key is used for Bitblit with directFB only. 
+                                            //            The color key in variable color formats. 
+                                            //            RGB565: use color_key[15:0] as color_key
+                                            //            ARGB8888: use color_key[23:0] as color_key
+                                            //            
+                                            //            [Note] In directFB, SW can enable source and destination 
+                                            //                      color key simultaneously, so two color keys are needed 
+                                            //                      in Bitblit instruction.
+        uint32_t  Reserved: 8;              //IO[31:24]: Reserved    
+
+    } Fields;
+    
+} SEREG_DST_COLOR_KEY;
+
+//=================================================================================================
+typedef union _SEREG_SRC_COLOR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SRC_COLOR (0x1800_C058)
+        uint32_t  src_color: 24;            //IO[23:0]: constant source color in variable color formats.
+                                            //          - Index8: use src_color[7:0]
+                                            //          - RGB565: use src_color[15:0]
+                                            //          - RGB888: use src_color[23:0]
+                                            //          - ARGB1555: use src_color[14:0]
+                                            //          - ARGB4444: use src_color[11:0]
+                                            //          - ARGB8888: use src_color[23:0]
+                                            
+        uint32_t  Reserved: 8;              //IO[31:24]: Reserved    
+
+    } Fields;
+    
+} SEREG_SRC_COLOR;
+
+//=================================================================================================
+typedef union _SEREG_SRC_ALPHA
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SRC_ALPHA (0x1800_C070)
+        uint32_t  src_alpha: 8;             //IO[7:0]: constant source alpha; 
+                                            //         if 4444, use the LSB [3:0]; if 1555, use the LSB [0]
+                                            
+        uint32_t  Reserved: 24;             //IO[31:8]: Reserved    
+
+    } Fields;
+    
+} SEREG_SRC_ALPHA;
+
+//=================================================================================================
+typedef union _SEREG_DEST_ALPHA
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: DEST_ALPHA (0x1800_C07C)
+        uint32_t  dest_alpha: 8;           	//IO[7:0]: constant dest alpha; used for dest-alpha calculation by select_dest_alpha; 
+                                            //         if 4444, use the LSB [3:0]; if 1555, use the LSB [0]. 
+
+        uint32_t  Reserved: 24;             //IO[31:8]: Reserved	  
+
+    } Fields;
+    
+} SEREG_DEST_ALPHA;
+
+//=================================================================================================
+typedef union _SEREG_RSLT_ALPHA
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: RSLT_ALPHA (0x1800_C088)
+        uint32_t  rslt_alpha: 8;            //IO[7:0]: constant result alpha, to overwrite the alpha results after operation. 
+                                            //         if 4444, use the LSB [3:0]; if 1555, use the LSB [0].
+                                            
+        uint32_t  Reserved: 24;             //IO[31:8]: Reserved	  
+
+    } Fields;
+    
+} SEREG_RSLT_ALPHA;
+
+//=================================================================================================
+typedef union _SEREG_BADDR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: BADDR1 (0x1800_C094)
+        uint32_t  baddr: 31;                //IO[30:0]: Base address of a SE address set; 16B-align
+        uint32_t  Reserved: 1;              //IO[31]: Reserved    
+
+    } Fields;
+    
+} SEREG_BADDR;
+
+//=================================================================================================
+typedef union _SEREG_PITCH
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: PITCH1 (0x1800_C0A4)
+        uint32_t  pitch: 16;                //IO[15:0]: Pitch of a SE address set, unit in byte. 0 means 16384 bytes. 16B-align.
+        uint32_t  interleave: 1;            //IO[16]: interleaving mode for the picture index.
+        uint32_t  Reserved: 15;             //IO[31:17]: Reserved    
+
+    } Fields;
+    
+} SEREG_PITCH;
+
+typedef struct _SEREG_DMAINFO
+{
+		SEREG_BADDR		SeRegBaseAddress[4];
+		SEREG_PITCH		SeRegPitch[4];
+	
+} SEREG_DMAINFO;
+
+
+//=================================================================================================
+typedef union _SEREG_CLUT_LOCK_ST
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CLUT_LOCK_ST (0x1800_C4C8)
+        uint32_t clut_lock_st: 2;           //IO[1:0]: Indicate which command queue has locked the CLUT Table
+                                            //         - 00: lock by command queue0
+                                            //         - 01: lock by command queue1
+                                            //         - 10: lock by command queue2
+                                            //         - 11: unlock
+        uint32_t Reserved:30;               //IO[31:2]: Reserved
+    } Fields;
+} SEREG_CLUT_LOCK_ST;
+
+//=================================================================================================
+typedef union _SEREG_CLIP_XCOOR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CLIP_XCOOR1 (0x1800_C128)
+        uint32_t  xmax: 12;                 //IO[11:0]: Max X coordinate for clipping; When YC422/420, 
+                                            //          this value should be an odd number.
+
+        uint32_t  xmin: 12;                 //IO[23:12]: Min X coordinate for clipping; When YC422/420, 
+                                            //           this value should be an even number.
+                                            
+        uint32_t  clipen: 1;                //IO[24]: Enable clipping function
+        	
+        uint32_t  Reserved: 7;              //IO[31:25]: Reserved  
+
+    } Fields;
+    
+} SEREG_CLIP_XCOOR;
+
+//=================================================================================================
+typedef union _SEREG_CLIP_YCOOR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CLIP_YCOOR1 (0x1800_C138)
+        uint32_t  ymax: 12;                 //IO[11:0]: Max Y coordinate for clipping; When YC420, 
+                                            //          this value should be an odd number.
+
+        uint32_t  ymin: 12;                 //IO[23:12]: Min Y coordinate for clipping; When YC420, 
+                                            //           this value should be an even number.
+              	                                    
+        uint32_t  Reserved: 8;              //IO[31:24]: Reserved  
+
+    } Fields;
+    
+} SEREG_CLIP_YCOOR;
+
+//=================================================================================================
+typedef struct _SEREG_CLIP_INFO
+{
+    SEREG_CLIP_XCOOR	SeRegClipXCoor[4];
+    SEREG_CLIP_YCOOR	SeRegClipYCoor[4];
+
+} SEREG_CLIP_INFO;
+
+//=================================================================================================
+typedef union _SEREG_CONVSCALING
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CONVSCALING (0x1800_C188)
+        uint32_t  vup: 1;                   //IO[0]: Vertical interpolation when 420 to 444
+                                            //       - 0: repeat
+                                            //       - 1: [1 1]/2
+
+        uint32_t  hup: 1;                   //IO[1]: Horizontal interpolation when 422/420 to 444
+                                            //       - 0: repeat
+                                            //       - 1: [1 1]/2
+
+        uint32_t  vdown: 1;                 //IO[2]: Vertical decimation when 444 to 420
+                                            //       - 0: drop
+                                            //       - 1: [1 1]/2
+
+        uint32_t  hdown: 1;                 //IO[3]: Horizontal decimation when 444 to 422/420
+                                            //       - 0: drop
+                                            //       - 1: [1 1]/2
+
+        uint32_t  Reserved: 28;             //IO[31:4]: Reserved  
+     
+    } Fields;
+    
+} SEREG_CONVSCALING;
+
+//=================================================================================================
+typedef union _SEREG_CONVCOEF1
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CONVCOEF1 (0x1800_C194)
+        uint32_t  m00: 13;                  //IO[12:0]: Coefficient with format (sign,2,10)
+        uint32_t  m01: 13;                  //IO[25:13]: Coefficient with format (sign,2,10)
+        uint32_t  Reserved: 6;              //IO[31:26]: Reserved  
+
+    } Fields;
+    
+} SEREG_CONVCOEF1;
+
+//=================================================================================================
+typedef union _SEREG_CONVCOEF2
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CONVCOEF2 (0x1800_C1A0)
+        uint32_t  m02: 13;                  //IO[12:0]: Coefficient with format (sign,2,10)
+        uint32_t  m10: 13;                  //IO[25:13]: Coefficient with format (sign,2,10) 
+        uint32_t  Reserved: 6;              //IO[31:26]: Reserved  
+
+    } Fields;
+    
+} SEREG_CONVCOEF2;
+
+//=================================================================================================
+typedef union _SEREG_CONVCOEF3
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CONVCOEF3 (0x1800_C1AC)
+        uint32_t  m11: 13;                  //IO[11:0]: Coefficient with format (sign,2,10)
+        uint32_t  m12: 13;                  //IO[23:12]: Coefficient with format (sign,2,10)
+        uint32_t  Reserved: 6;              //IO[31:24]: Reserved  
+         
+        
+
+    } Fields;
+    
+} SEREG_CONVCOEF3;
+
+//=================================================================================================
+typedef union _SEREG_CONVCOEF4
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CONVCOEF4 (0x1800_C1B8)
+        uint32_t  m20: 13;                  //IO[11:0]: Coefficient with format (sign,2,10)
+        uint32_t  m21: 13;                  //IO[23:12]: Coefficient with format (sign,2,10)
+        uint32_t  Reserved: 6;              //IO[31:24]: Reserved  
+
+    } Fields;
+    
+} SEREG_CONVCOEF4;
+
+//=================================================================================================
+typedef union _SEREG_CONVCOEF5
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CONVCOEF5 (0x1800_C1C4)
+        uint32_t  m22: 13;                  //IO[12:0]: Coefficient with format (sign,2,10) 
+        uint32_t  Reserved: 19;             //IO[31:13]: Reserved  
+
+    } Fields;
+    
+} SEREG_CONVCOEF5;
+
+//=================================================================================================
+typedef union _SEREG_CONVCOEF6
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CONVCOEF1 (0x1800_C1D0)
+        uint32_t  a0: 10;                   //IO[9:0]: Coefficient with format of (sign,9)
+        uint32_t  a1: 10;                   //IO[10:19]: Coefficient with format of (sign,9)
+        uint32_t  a2: 10;                   //IO[20:29]: Coefficient with format of (sign,9)
+        uint32_t  Reserved: 2;              //IO[31:30]: Reserved  
+  
+    } Fields;
+    
+} SEREG_CONVCOEF6;
+
+//=================================================================================================
+typedef union _SEREG_FCV_BITBLIT_COLOR_KEY
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: FCV_BITBLIT_COLOR_KEY (0x1800_C4BC)
+        uint32_t color_key: 24;             //IO[23:0]: For Bitblit instruction when ¿Format conversion + Bitblit?filed is set in the command
+                                            //          - Index8: use src_color[7:0]
+                                            //          - RGB565: use src_color[15:0]
+                                            //          - RGB888: use src_color[23:0]
+                                            //          - ARGB1555: use src_color[14:0]
+                                            //          - ARGB4444: use src_color[11:0]
+                                            //          - ARGB8888: use src_color[23:0]
+        uint32_t Reserved: 8;               //IO[31:24]: Reserved
+
+    } Fields;
+} SEREG_FCV_BITBLIT_COLOR_KEY;
+
+//=================================================================================================
+typedef union _SEREG_SRC_CLR_RED
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SRC_CLR_RED (0x1800_C51C)
+        uint32_t  src_clr_mul_red: 9;       //IO[8:0]: Color multiplier coefficient of "R" component in format (0..256).
+        uint32_t  Reserved: 7;              //IO[15:9]: Reserved
+        uint32_t  src_clr_add_red: 9;       //IO[24:16]: Color offset coefficient of "R" component (-256 ~ 255)
+        uint32_t  Reserved1: 7;             //IO[31:25]: Reserved
+        
+    } Fields;
+    
+} SEREG_SRC_CLR_RED; 
+
+//=================================================================================================
+typedef union _SEREG_SRC_CLR_GREEN
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SRC_CLR_GREEN (0x1800_C528)
+        uint32_t  src_clr_mul_green: 9;     //IO[8:0]: Color multiplier coefficient of "G" component in format (0..256).
+        uint32_t  Reserved: 7;              //IO[15:9]: Reserved
+        uint32_t  src_clr_add_green: 9;     //IO[24:16]: Color offset coefficient of "G" component (-256 ~ 255)
+        uint32_t  Reserved1: 7;             //IO[31:25]: Reserved
+        
+    } Fields;
+    
+} SEREG_SRC_CLR_GREEN; 
+
+//=================================================================================================
+typedef union _SEREG_SRC_CLR_BLUE
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SRC_CLR_BLUE (0x1800_C534)
+        uint32_t  src_clr_mul_blue: 9;      //IO[8:0]: Color multiplier coefficient of "B" component in format (0..256).
+        uint32_t  Reserved: 7;              //IO[15:9]: Reserved
+        uint32_t  src_clr_add_blue: 9;      //IO[24:16]: Color offset coefficient of "B" component (-256 ~ 255)
+        uint32_t  Reserved1: 7;             //IO[31:25]: Reserved
+        
+    } Fields;
+    
+} SEREG_SRC_CLR_BLUE; 
+
+//=================================================================================================
+typedef union _SEREG_SRC_CLR_ALPHA
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SRC_CLR_ALPHA (0x1800_C540)
+        uint32_t  src_clr_mul_alpha: 9;     //IO[8:0]: Color multiplier coefficient of "A" component in format (0..256).
+        uint32_t  Reserved: 7;              //IO[15:9]: Reserved
+        uint32_t  src_clr_add_alpha: 9;     //IO[24:16]: Color offset coefficient of "A" component (-256 ~ 255)
+        uint32_t  Reserved1: 7;             //IO[31:25]: Reserved
+        
+    } Fields;
+    
+} SEREG_SRC_CLR_ALPHA; 
+
+//=================================================================================================
+typedef union _SEREG_SYNC_VO_MARGIN
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SYNC_VO_MARGIN (0x1800_C4E0)
+        uint32_t  margin_VOtoSE: 12;        //IO[11:0]: VO to SE margin.
+        uint32_t  Reserved: 14;             //IO[25:12]: Reserved
+        uint32_t  vo_osd_plane: 1;          //IO[26:26]: Which VO OSD plane to sync
+        uint32_t  vbi: 1;                   //IO[27:27]: When sync_vo_en=1, allow bitblit during VBI period. 
+        uint32_t  after_vo_cur: 1;          //IO[28:28]: Which VO OSD plane to sync
+        uint32_t  before_vo_cur: 1;         //IO[29:29]: When sync_vo_en == 1, allow bitblit when the bitblit region is before the current VO current scan line.
+        uint32_t  vo_plane: 1;              //IO[30:30]: Which VO plane to sync(0: OSD, 1: SUB)
+        uint32_t  auto_dir_en: 1;           //IO[31:31]: 
+                                            //    1: enable HW to calculate the bitblit direction automatically based on input X &Y and output X & Y.
+                                            //    0: SW needs to set the direction in bitblit command.
+        
+    } Fields;
+    
+} SEREG_SYNC_VO_MARGIN; 
+
+//=================================================================================================
+typedef union _SEREG_SYNC_VO_LOCATION
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SYNC_VO_LOCATION (0x1800_C4F8)
+        uint32_t  VO_current_y: 12;         //IO[11:0]: VO current y location.
+        uint32_t  Reserved: 20;             //IO[31:12]: Reserved
+        
+    } Fields;
+    
+} SEREG_SYNC_VO_LOCATION;
+
+//=================================================================================================
+typedef union _SEREG_STRETCH
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: STRETCH (0x1800_C1DC)
+        uint32_t  vodd: 1;                  //IO[0]: This bit is only used when apply FIR algorithm.
+                                            //       - 1: Using odd type FIR for V-scaling. 
+                                            //       - 0: Using even type FIR for V-scaling.
+        
+        uint32_t  hodd: 1;                  //IO[1]: This bit is only used when apply FIR algorithm.
+                                            //       - 1: Using odd type FIR for H-scaling. 
+                                            //       - 0: Using even type FIR for H-scaling. 
+
+        uint32_t  vtype: 1;                 //IO[2]: vtype
+                                            //       - 0: 2-tap FIR 
+                                            //       - 1: 4-tap FIR
+
+        uint32_t  htype: 2;                 //IO[4:3]: htype
+                                            //         - 00: 2-tap FIR 
+                                            //         - 01: 4-tap FIR
+                                            //         - 10: 8-tap FIR
+
+        uint32_t  ref_alpha: 1;             //IO[5]: Reference alpha option for transparency function
+
+        uint32_t  Reserved: 26;             //IO[31:6]: Reserved  
+
+    } Fields;
+    
+} SEREG_STRETCH;
+
+//=================================================================================================
+typedef union _SEREG_HDHS
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: HDHS (0x1800_C1E8)
+        uint32_t  H_scaling_dph_lsb: 14;    //IO[13:0]: LSB of the H-scaling delta-phase in (4,14) format
+        uint32_t  H_scaling_dph_msb: 4;     //IO[17:14]: MSB of the H-scaling delta-phase in (4,14) format
+        uint32_t  H_scaling_iniph: 4;       //IO[21:18]: Initial phase of Y coordinate for H-scaling
+        uint32_t  Reserved: 10;             //IO[31:22]: Reserved  
+
+    } Fields;
+    
+} SEREG_HDHS;
+
+//=================================================================================================
+typedef union _SEREG_VDHS
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: VDHS (0x1800_C1F4)
+        uint32_t  V_scaling_dph_lsb: 14;    //IO[13:0]: LSB of the V-scaling delta-phase in (4,14) format
+        uint32_t  V_scaling_dph_msb: 4;     //IO[17:14]: MSB of the V-scaling delta-phase in (4,14) format
+        uint32_t  V_scaling_iniph: 4;       //IO[21:18]: Initial phase of Y coordinate for V-scaling
+        uint32_t  Reserved: 10;             //IO[31:22]: Reserved  
+   
+    } Fields;
+    
+} SEREG_VDHS;
+
+//=================================================================================================
+typedef union _SEREG_HCOEF
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: HCOEF1 (0x1800_C200)
+        uint32_t  hcoef: 14;                //IO[13:0]: Coefficient in (sign, 1, 12) format (2¡¦s complement)
+        uint32_t  Reserved: 18;             //IO[31:14]: Reserved  
+
+    } Fields;
+    
+} SEREG_HCOEF;
+
+//=================================================================================================
+typedef union _SEREG_VCOEF
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: VCOEF1 (0x1800_C280)
+        uint32_t  vcoef: 14;                //IO[13:0]: Coefficient in (sign, 1, 12) format (2¡¦s complement)
+        uint32_t  Reserved: 18;             //IO[31:14]: Reserved  
+
+    } Fields;
+    
+} SEREG_VCOEF;
+
+typedef struct _SEREG_COEFINFO
+{
+    SEREG_HCOEF		SeRegHCoef[32];
+    SEREG_VCOEF		SeRegVCoef[16];
+	
+} SEREG_COEFINFO;
+
+//=================================================================================================
+typedef union _SEREG_HCOEF_32
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: HCOEF1_32 (0x1800_C558)
+        uint32_t  hcoef: 14;                //IO[13:0]: Coefficient in (sign, 1, 12) format (2¡¦s complement)
+        uint32_t  Reserved: 18;             //IO[31:14]: Reserved  
+
+    } Fields;
+    
+} SEREG_HCOEF_32;
+
+//=================================================================================================
+typedef union _SEREG_VCOEF_16
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: VCOEF1_16 (0x1800_C5D8)
+        uint32_t  vcoef: 14;                //IO[13:0]: Coefficient in (sign, 1, 12) format (2¡¦s complement)
+        uint32_t  Reserved: 18;             //IO[31:14]: Reserved  
+
+    } Fields;
+    
+} SEREG_VCOEF_16;
+
+typedef struct _SEREG_COEFINFO_2
+{
+    SEREG_HCOEF_32 SeRegHCoef[32];
+    SEREG_VCOEF_16 SeRegVCoef[16];
+	
+} SEREG_COEFINFO_2;
+
+//=================================================================================================
+typedef union _SEREG_SC_BITBLIT_COLOR_KEY
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SC_BITBLIT_COLOR_KEY (0x1800_C4EC)
+		uint32_t color_key: 24;                 //IO[23:0]: For Bitblit instruction when ¿Format conversion + Bitblit?filed is set in the command
+                                            //          - Index8: use src_color[7:0]
+                                            //          - RGB565: use src_color[15:0]
+                                            //          - RGB888: use src_color[23:0]
+                                            //          - ARGB1555: use src_color[14:0]
+                                            //          - ARGB4444: use src_color[11:0]
+                                            //          - ARGB8888: use src_color[23:0]
+		uint32_t Reserved: 8;                   //IO[31:24]: Reserved
+
+	} Fields;
+} SEREG_SC_BITBLIT_COLOR_KEY;
+
+//=================================================================================================
+typedef union _SEREG_CTRL
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CTRL (0x1800_C458)
+        uint32_t  write_data: 1;            //IO[0]: write_data
+        
+        uint32_t  go: 1;                    //IO[1]: SE operation of the command queue can only start when go = 1. 
+                                            //       Once it starts the command queue will only stop when this bit is 
+                                            //       set to 0 and when it completes the current instruction
+        
+        uint32_t  endiswap: 1;              //IO[2]: When this bit is == 1, the command endianness will be swapped. 
+                                            //       It will change the byte order to {cmd[7:0],cmd[15:8], cmd[23:16], cmd[31:24]}
+                                            	
+        uint32_t  Reserved: 29;             //IO[31:3]: Reserved  
+
+    } Fields;
+    
+} SEREG_CTRL;
+
+//=================================================================================================
+typedef union _SEREG_IDLE
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: IDLE (0x1800_C464)
+        uint32_t  idle: 1;                  //IO[0]: indicate the command queue of SE is idle (all instruction has been 
+                                            //       executed and in both the internal and external command list, or when 
+                                            //       go bit = 0 and the command queue of SE is stopped.
+
+        uint32_t  Reserved: 31;             //IO[31:1]: Reserved  
+                                      
+    } Fields;
+    
+} SEREG_IDLE;
+
+//=================================================================================================
+typedef union _SEREG_INTSEL
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: INTSEL (0x1800_C470)
+        uint32_t  Sel1: 1;                  //IO[0]: Select which CPU to interrupt for command queue 1: 
+                                            //       - 0: SCPU
+                                            //       - 1: VCPU 
+
+        uint32_t  Sel2: 1;                  //IO[1]: Select which CPU to interrupt for command queue 2: 
+                                            //       - 0: SCPU
+                                            //       - 1: VCPU
+
+        uint32_t  Sel3: 1;                  //IO[2]: Select which CPU to interrupt for command queue 3: 
+                                            //       - 0: SCPU
+                                            //       - 1: VCPU
+
+        uint32_t  Reserved: 29;             //IO[31:3]: Reserved  
+                                
+    } Fields;
+    
+} SEREG_INTSEL;
+
+//=================================================================================================
+typedef union _SEREG_INTS
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: INTS (0x1800_C474)
+        uint32_t  write_data: 1;            //IO[0]: write_data
+        uint32_t  sync: 1;                  //IO[1]: Interrupt enable of sync interrupt 	
+        uint32_t  com_err: 1;               //IO[2]: Interrupt enable of command decoding error. The command will be ignored.
+        uint32_t  com_empty: 1;             //IO[3]: Interrupt enable. SDRAM and internal command lists both empty, 
+                                            //       and the execution of all commands is done.
+                                            //       object is decompressed.
+        uint32_t  Reserved1: 12;          	//IO[15:4]: Reserved
+        uint32_t  fmt_err: 1;               //IO[16]: Interrupt for unsupported color format
+        uint32_t  vo_sync_err: 1;           //IO[17]: Interrupt for vo_sync_en error when none of the vo_sync mode is selected. The command will be ignored
+        uint32_t  Reserved2: 14;            //IO[31:18]: Reserved  
+	
+    } Fields;   
+                
+} SEREG_INTS;   
+
+//=================================================================================================
+typedef union _SEREG_INTE
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: INTE (0x1800_C480)
+        uint32_t  write_data: 1;            //IO[0]: write_data
+        uint32_t  sync: 1;                  //IO[1]: Interrupt enable of sync interrupt 
+        uint32_t  com_err: 1;               //IO[2]: Interrupt enable of command decoding error. The command will be ignored.
+        uint32_t  com_empty: 1;             //IO[3]: Interrupt enable. SDRAM and internal command lists both empty, 
+                                            //       and the execution of all commands is done.
+        uint32_t  Reserved1: 12;            //IO[15:4]: Reserved
+        uint32_t  fmt_err: 1;               //IO[16]: Interrupt for unsupported color format
+        uint32_t  vo_sync_err: 1;           //IO[17]: Interrupt for vo_sync_en error when none of the vo_sync mode is selected. The command will be ignored
+        uint32_t  Reserved: 14;             //IO[31:18]: Reserved  
+                                             
+    } Fields;   
+                
+} SEREG_INTE; 
+ 
+//=================================================================================================
+typedef union _SEREG_INSTCNT_L
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: INSTCNT_L (0x1800_C48C)
+        uint32_t instcnt_l;                 //IO[31:0]: number of commands encountered(lower 4 bytes).  This field will increment by 1 
+                                            //          whenever an command is completed execution. It will wrap to 0 after 32¡¦hffffffff.
+        
+                                    
+    } Fields;
+    
+} SEREG_INSTCNT_L; 
+
+//=================================================================================================
+typedef union _SEREG_INSTCNT_H
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: INSTCNT_H (0x1800_C510)
+        uint32_t instcnt_h;                 //IO[31:0]: number of commands encountered(lower 4 bytes).  This field will increment by 1 
+                                            //          whenever an command is completed execution. It will wrap to 0 after 32¡¦hffffffff.
+        
+                                    
+    } Fields;
+    
+} SEREG_INSTCNT_H; 
+
+//=================================================================================================
+typedef union _SEREG_CLUT_RADR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CLUT_RADR (0x1800_C498)
+        uint32_t  radr: 8;                  //IO[7:0]: CLUT SRAM read address. 
+        uint32_t  Reserved: 24;             //IO[31:8]: Reserved  
+                                  
+    } Fields;
+    
+} SEREG_CLUT_RADR; 
+ 
+//=================================================================================================
+typedef union _SEREG_CLUT_VALUE
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CLUT_VALUE (0x1800_C49C)
+        uint32_t  value;                    //IO[31:0]: The 32b content inside the CLUT SRAM addressed by SE_CLUT_RADR.
+        
+    } Fields;
+    
+} SEREG_CLUT_VALUE;  
+
+//=================================================================================================
+typedef union _SEREG_DBG
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: CLUT_RADR (0x1800_C4A0)
+        uint32_t  dbg_sel0: 5;              //IO[4:0]: Select debug signal sets to be probed via se_dbg_out0
+        uint32_t  Reserved1: 3;             //IO[7:5]: Reserved
+        uint32_t  dbg_sel1: 5;              //IO[12:8]: Select debug signal sets to be probed via se_dbg_out1
+        uint32_t  Reserved2: 3;             //IO[15:13]: Reserved
+        uint32_t  dbg_module_sel0:4;        //IO[19:16]: Select module to be probed via se_dbg_out0
+                                            //           - 4¿b0000: se_clut
+                                            //           - 4¿b0001: se_cmd_queue
+                                            //           - 4¿b0010: se_dbsctl
+                                            //           - 4¿b0011: se_dma
+                                            //           - 4¿b0100: se_globalctl
+                                            //           - 4¿b0101: se_op
+                                            //           - 4¿b0110: se_regif
+                                            //           - 4¿b0111: se_regwrap
+
+        uint32_t  dbg_module_sel1:4;        //IO[23:20]: Select module to be probed via se_dbg_out1
+                                            //           - 4¿b0000: se_clut
+                                            //           - 4¿b0001: se_cmd_queue
+                                            //           - 4¿b0010: se_dbsctl
+                                            //           - 4¿b0011: se_dma
+                                            //           - 4¿b0100: se_globalctl
+                                            //           - 4¿b0101: se_op
+                                            //           - 4¿b0110: se_regif
+                                            //           - 4¿b0111: se_regwrap
+
+        uint32_t  dbg_en: 1;                //IO[24]: Debug enable
+                                            //        When set, selected signals can be probed via debug ports. When clear, both se_dbg_out0 and se_dbg_out1 are static 16¿h0
+
+        uint32_t  Reserved3: 7;             //IO[31:25]: Reserved  
+                   
+    } Fields;
+    
+} SEREG_DBG; 
+
+//=================================================================================================
+typedef union _SEREG_SCTCH
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: SCTCH (0x1800_C4A4)
+        uint32_t  Reg0: 16;                 //IO[15:0]: Dummy registers with default value 0 
+        uint32_t  Reg1: 16;                 //IO[31:16]: Dummy registers with default value 1
+              
+    } Fields;
+    
+} SEREG_SCTCH; 
+
+//=================================================================================================
+typedef union _SEREG_GCRA_CTRL
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: GCRA_CTRL (0x1800_C4A8)
+        uint32_t  Gcra_en: 1;               //IO[0]: SE request GCRA algorithm enable
+        uint32_t  Reserved: 31;             //IO[31:1]: Reserved
+                    
+    } Fields;
+    
+} SEREG_GCRA_CTRL; 
+
+//=================================================================================================
+typedef union _SEREG_GCRA_REQ_CNT
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: GCRA_REQ_CNT (0x1800_C4AC)
+        uint32_t  Gcra_req_num: 24;         //IO[23:0]: Request number for current period.
+        uint32_t  Reserved: 8;              //IO[31:24]: Reserved
+                        
+    } Fields;
+    
+} SEREG_GCRA_REQ_CNT; 
+
+//=================================================================================================
+typedef union _SEREG_GCRA_TIM_CNT
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: GCRA_TIM_CNT (0x1800_C4B0)
+        uint32_t  Gcra_tim_cnt;             //IO[31:0]: Timer counter
+                        
+    } Fields;
+    
+} SEREG_GCRA_TIM_CNT; 
+
+//=================================================================================================
+typedef union _SEREG_GCRA_TIM_THR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: GCRA_TIM_THR (0x1800_C4B4)
+        uint32_t  Gcra_tim_thr;             //IO[31:0]: Timer counter threshold. When timer reach this threshold, 
+                                            //          HW will clear timer counter and request number
+                        
+    } Fields;
+    
+} SEREG_GCRA_TIM_THR; 
+
+//=================================================================================================
+typedef union _SEREG_GCRA_REQ_THR
+{
+    uint32_t  Value;
+    struct
+    {    
+                                            //Register: GCRA_REQ_THR (0x1800_C4B8)
+        uint32_t  Gcra_req_thr: 24;         //IO[23:0]: Request number threshold. When SE request number reach this 
+                                            //          threshold, HW will stop to access.
+        uint32_t  Reserved: 8;              //IO[31:24]: Reserved
+                       
+    } Fields;
+    
+} SEREG_GCRA_REQ_THR; 
+
+//=================================================================================================
+typedef struct _SEREG_INFO
+{               
+    SEREG_CMDBASE               SeCmdBase[3];            //0x1800_C000: Register: CMDBASE
+    SEREG_CMDLMT                SeCmdLimit[3];           //0x1800_C00C: Register: SEREG_CMDLMT
+    SEREG_CMDRPTR               SeCmdReadPtr[3];         //0x1800_C018: Register: CMDRPTR
+    SEREG_CMDWPTR               SeCmdWritePtr[3];        //0x1800_C024: Register: CMDWPTR
+    SEREG_SRWORDCNT             SeSramWordCount[3];      //0x1800_C030: Register: SRWORDCNT
+    SEREG_Q_PRIORITY            SeQueuePriority;         //0x1800_C03C: Register: Q_PRIORITY
+    
+    SEREG_CLR_FMT               SeColorFormat[3];        //0x1800_C040: Register: CLR_FMT
+    SEREG_COLOR_KEY             SeColorKey[3];           //0x1800_C04C: Register: COLOR_KEY
+    SEREG_SRC_COLOR             SeSrcColor[3];           //0x1800_C058: Register: SRC_COLOR
+    uint32_t                    Reserved00[3];           //0x1800_C064: Reserved on Saturn
+    SEREG_SRC_ALPHA             SeSrcAlpha[3];           //0x1800_C070: Register: SRC_ALPHA
+    SEREG_DEST_ALPHA            SeDestAlpha[3];          //0x1800_C07C: Register: DEST_ALPHA
+    SEREG_RSLT_ALPHA            SeResultAlpha[3];        //0x1800_C088: Register: RSLT_ALPHA
+    
+    SEREG_DMAINFO               SeDmaInfo[3];            //0x1800_C094
+    uint32_t                    Reserved01[13];          //0x1800_C0F4: Reserved on Saturn
+
+    SEREG_CLIP_INFO        	    SeClipInfo[3];           //0x1800_C128 - 0x1800_C184
+
+    SEREG_CONVSCALING           SeConvScaling[3];        //0x1800_C188: Register: CONVSCALING
+    SEREG_CONVCOEF1             SeConvCoef1[3];          //0x1800_C194: Register: CONVCOEF1
+    SEREG_CONVCOEF2             SeConvCoef2[3];          //0x1800_C1A0: Register: CONVCOEF2
+    SEREG_CONVCOEF3             SeConvCoef3[3];          //0x1800_C1AC: Register: CONVCOEF3
+    SEREG_CONVCOEF4             SeConvCoef4[3];          //0x1800_C1B8: Register: CONVCOEF4
+    SEREG_CONVCOEF5             SeConvCoef5[3];          //0x1800_C1C4: Register: CONVCOEF5
+    SEREG_CONVCOEF6             SeConvCoef6[3];          //0x1800_C1D0: Register: CONVCOEF6
+
+    SEREG_STRETCH               SeStretch[3];            //0x1800_C1DC: Register: STRETCH
+    SEREG_HDHS                  SeHdhs[3];               //0x1800_C1E8: Register: HDHS
+    SEREG_VDHS                  SeVdhs[3];               //0x1800_C1F4: Register: VDHS
+    SEREG_COEFINFO              SeCoefInfo[3];           //0x1800_C200 - 0x1800_C43C
+
+    uint32_t                    Reserved02[6];           //0x1800_C440: Reserved On Saturn
+    
+    SEREG_CTRL                  SeCtrl[3];               //0x1800_C458: Register: CTRL
+    SEREG_IDLE                  SeIdle[3];               //0x1800_C464: Register: IDLE
+
+    SEREG_INTSEL                SeIntSel;                //0x1800_C470: Register: INTSEL
+    SEREG_INTS                  SeInts[3];               //0x1800_C474: Register: INTS
+    SEREG_INTE                  SeInte[3];               //0x1800_C480: Register: INTE
+    SEREG_INSTCNT_L             SeInstCntL[3];           //0x1800_C48C: Register: INSTCNT
+
+    SEREG_CLUT_RADR             SeClutReadAddress;       //0x1800_C498: Register: CLUT_RADR
+    SEREG_CLUT_VALUE            SeClutValue;             //0x1800_C49C: Register: CLUT_VALUE
+    SEREG_DBG                   SeDebug;                 //0x1800_C4A0: Register: DBG
+    SEREG_SCTCH                 SeSctch;                 //0x1800_C4A4: Register: SCTCH  
+    
+    SEREG_GCRA_CTRL             SeGcraCtrl;              //0x1800_C4A8: Register: GCRA_CTRL
+    SEREG_GCRA_REQ_CNT          SeGcraReqCnt;            //0x1800_C4AC: Register: GCRA_REQ_CNT
+    SEREG_GCRA_TIM_CNT          SeGcraTimCnt;            //0x1800_C4B0: Register: GCRA_TIM_CNT
+    SEREG_GCRA_TIM_THR          SeGcraTimThr;            //0x1800_C4B4: Register: GCRA_TIM_THR
+    SEREG_GCRA_REQ_THR          SeGcraReqThr;            //0x1800_C4B8: Register: GCRA_REQ_THR
+
+    SEREG_FCV_BITBLIT_COLOR_KEY SeFcvBitblitColorKey[3]; //0x1800_C4BC: Register: FCV_BITBLIT_COLOR_KEY
+    SEREG_CLUT_LOCK_ST          SeClutLockSt;            //0x1800_C4C8: Register: CLUT_LOCK_ST
+    uint32_t                    Reserved03[5];           //0x1800_C4CC: Reserved on Saturn
+
+    SEREG_SYNC_VO_MARGIN        SeSyncVoMargin[3];       //0x1800_C4E0: Register: SYNC_VO_MARGIN
+    SEREG_SC_BITBLIT_COLOR_KEY  SeScBitblitColorKey[3];  //0x1800_C4EC: Register: SC_BITBLIT_COLOR_KEY
+    SEREG_SYNC_VO_LOCATION      SeSyncVoLocation[3];     //0x1800_C4F8: Register: SYNC_VO_LOCATION
+    uint32_t                    Reserved04[3];           //0x1800_C504: Reserved on Saturn
+
+    SEREG_INSTCNT_H             SeInstCntH[3];           //0x1800_C510: Register: INSTCNT_H    
+    SEREG_SRC_CLR_RED           SeSrcClrRed[3];          //0x1800_C51C: Register: SRC_CLR_RED
+    SEREG_SRC_CLR_GREEN         SeSrcClrGreen[3];        //0x1800_C528: Register: SRC_CLR_GREEN
+    SEREG_SRC_CLR_BLUE          SeSrcClrBlue[3];         //0x1800_C534: Register: SRC_CLR_BLUE
+    SEREG_SRC_CLR_ALPHA         SeSrcClrAlpha[3];        //0x1800_C540: Register: SRC_CLR_ALPHA
+    SEREG_DST_COLOR_KEY         SeDstColorKey[3];        //0x1800_C54C: Register: DST_COLOR_KEY
+
+    SEREG_COEFINFO_2            SeCoefInfo2[3];          //0x1800_C558
+} SEREG_INFO;
+
+//=================================================================================================
+
+#endif
+
+//=================================================================================================
+// End of File
diff --git a/drivers/uio/uio.c b/drivers/uio/uio.c
index 208bc52..47d8e85 100644
--- a/drivers/uio/uio.c
+++ b/drivers/uio/uio.c
@@ -386,6 +386,26 @@ static int uio_get_minor(struct uio_device *idev)
 	return retval;
 }
 
+#ifdef CONFIG_UIO_ASSIGN_MINOR
+static int uio_use_minor(struct uio_device *idev, int minor)
+{
+	int retval = -ENOMEM;
+
+	mutex_lock(&minor_lock);
+	retval = idr_alloc(&uio_idr, idev, minor, minor+1, GFP_KERNEL);
+	if (retval >= 0) {
+		idev->minor = retval;
+		retval = 0;
+	} else if (retval == -ENOSPC) {
+		dev_err(idev->dev, "too many uio devices\n");
+		retval = -EINVAL;
+	}
+	mutex_unlock(&minor_lock);
+	return retval;
+}
+#endif
+
+
 static void uio_free_minor(struct uio_device *idev)
 {
 	mutex_lock(&minor_lock);
@@ -824,7 +844,12 @@ int __uio_register_device(struct module *owner,
 	init_waitqueue_head(&idev->wait);
 	atomic_set(&idev->event, 0);
 
-	ret = uio_get_minor(idev);
+#ifdef CONFIG_UIO_ASSIGN_MINOR
+	if(info->minor > 0)
+		ret = uio_use_minor(idev, info->minor);
+	else
+#endif
+		ret = uio_get_minor(idev);
 	if (ret)
 		return ret;
 
diff --git a/drivers/uio/uio_helper.h b/drivers/uio/uio_helper.h
new file mode 100644
index 00000000..b68bb31
--- /dev/null
+++ b/drivers/uio/uio_helper.h
@@ -0,0 +1,133 @@
+/*
+ * Helper Macros for UIO
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ * Copyright (C) 2017 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __UIO_HELPER_H__
+#define __UIO_HELPER_H__
+
+#include <linux/clk.h>
+#include <linux/dma-mapping.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/reset.h>
+#include <linux/slab.h>
+#include <linux/uio_driver.h>
+
+static inline void *uio_get_mem(struct uio_info *info, int index)
+{
+	return info->mem[index].internal_addr;
+}
+
+static inline void uio_mem_print(struct device *dev, struct uio_mem *mem)
+{
+	dev_info(dev, "phys:%pa virt:0x%p size:%pa type:%d name:%s\n",
+		&mem->addr, mem->internal_addr, &mem->size,
+		mem->memtype, mem->name);
+}
+
+static inline int uio_mem_of_iomap(struct device *dev,
+	struct uio_mem *mem, int index)
+{
+	struct resource res;
+	struct device_node *np = dev->of_node;
+	int ret;
+
+	if (!np)
+		return -EINVAL;
+
+	ret = of_address_to_resource(np, index, &res);
+	if (ret)
+		return ret;
+
+	mem->addr          = res.start;
+	mem->size          = ALIGN(resource_size(&res), PAGE_SIZE);
+	mem->internal_addr = ioremap(res.start, resource_size(&res));
+	mem->memtype       = UIO_MEM_PHYS;
+	return 0;
+}
+
+static inline void uio_mem_iounmap(struct device *dev, struct uio_mem *mem)
+{
+	if (!mem->internal_addr)
+		return;
+
+	iounmap(mem->internal_addr);
+}
+
+static inline int uio_mem_dma_alloc(struct device *dev, struct uio_mem *mem,
+	size_t size, gfp_t flag)
+{
+	void *virt = NULL;
+	dma_addr_t phys = 0;
+
+	size = ALIGN(size, PAGE_SIZE);
+	virt = dma_alloc_coherent(dev, size, &phys, flag);
+	if (!virt)
+		return -ENOMEM;
+
+	mem->addr          = phys;
+	mem->size          = size;
+	mem->internal_addr = virt;
+	mem->memtype       = UIO_MEM_PHYS;
+	return 0;
+}
+
+static inline void uio_mem_dma_free(struct device *dev, struct uio_mem *mem)
+{
+	if (!mem->internal_addr)
+		return;
+
+	dma_free_coherent(dev, mem->size, mem->internal_addr, mem->addr);
+}
+
+static inline int uio_reset_control_deassert(struct device *dev,
+	const char *id)
+{
+	struct reset_control *rstc;
+	struct device_node *np = dev->of_node;
+
+	if (!np)
+		return -EINVAL;
+
+	if (!of_get_property(np, "resets", NULL))
+		return 0;
+
+	rstc = reset_control_get(dev, id);
+	if (IS_ERR(rstc))
+		return PTR_ERR(rstc);
+	reset_control_deassert(rstc);
+	reset_control_put(rstc);
+
+	return 0;
+}
+
+static inline int uio_reset_control_assert(struct device *dev,
+	const char *id)
+{
+	struct reset_control *rstc;
+	struct device_node *np = dev->of_node;
+
+	if (!np)
+		return -EINVAL;
+
+	if (!of_get_property(np, "resets", NULL))
+		return 0;
+
+	rstc = reset_control_get(dev, id);
+	if (IS_ERR(rstc))
+		return PTR_ERR(rstc);
+	reset_control_assert(rstc);
+	reset_control_put(rstc);
+
+	return 0;
+}
+
+#endif /* __UIO_HELPER_H__ */
diff --git a/drivers/uio/uio_rtk.c b/drivers/uio/uio_rtk.c
new file mode 100644
index 00000000..45cbbba
--- /dev/null
+++ b/drivers/uio/uio_rtk.c
@@ -0,0 +1,223 @@
+/*
+ * Realtek Generic UIO Driver
+ *
+ * Copyright (C) 2017,2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <linux/clk.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/pm.h>
+#include <linux/pm_clock.h>
+#include <linux/pm_runtime.h>
+#include <linux/reset.h>
+#include <linux/slab.h>
+#include <linux/uio_driver.h>
+
+#ifdef CONFIG_UIO_ASSIGN_MINOR
+
+struct minor_map {
+	const char *name;
+	int minor;
+};
+
+static const struct minor_map _map[] = {
+	{ .name = "refclk", .minor = 253, },
+	{ .name = "rbus",   .minor = 250, },
+	{ .name = "tp",     .minor = 249, },
+	{ .name = NULL,     .minor = 0,   }
+};
+
+static int rtk_uio_get_minor(const char *name)
+{
+	const struct minor_map *p;
+
+	for (p = _map; p->name != NULL; p++)
+		if (!strcmp(name, p->name))
+			return p->minor;
+	return 0;
+}
+
+#endif
+
+struct rtk_uio_data {
+	struct uio_info info;
+	struct device *dev;
+	struct reset_control *rstc;
+};
+
+#define to_data(_uio_info) ((_uio_info)->priv)
+
+static int rtk_uio_open(struct uio_info *info, struct inode *inode)
+{
+	struct rtk_uio_data *priv = to_data(info);
+
+	pm_runtime_get_sync(priv->dev);
+
+	return 0;
+}
+
+static int rtk_uio_release(struct uio_info *info, struct inode *inode)
+{
+	struct rtk_uio_data *priv = to_data(info);
+
+	pm_runtime_put_sync(priv->dev);
+
+	return 0;
+}
+
+static int rtk_uio_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np = dev->of_node;
+	int ret;
+	struct rtk_uio_data *priv;
+	struct uio_info *info;
+	struct resource res;
+
+	priv = devm_kzalloc(dev, sizeof(*priv), GFP_KERNEL);
+	if (!priv)
+		return -ENOMEM;
+	info = &priv->info;
+
+	ret = pm_clk_create(dev);
+	if (ret)
+		dev_warn(dev, "failed to create pm_clk: %d\n", ret);
+	else
+		pm_clk_add(dev, NULL);
+
+	if (of_get_property(np, "resets", NULL)) {
+		priv->rstc = devm_reset_control_get(dev, NULL);
+		if (IS_ERR(priv->rstc)) {
+			ret = PTR_ERR(priv->rstc);
+			dev_warn(dev, "failed to get reset control: %d\n", ret);
+			priv->rstc = NULL;
+		}
+	}
+
+	ret = of_address_to_resource(np, 0, &res);
+	if (ret) {
+		dev_err(dev, "failed to get resource: %d\n", ret);
+		goto destroy_pm_clk;
+	}
+	info->mem[0].addr    = res.start;
+	info->mem[0].size    = ALIGN(resource_size(&res), PAGE_SIZE);
+	info->mem[0].memtype = UIO_MEM_PHYS;
+
+	info->version = "0.0.2";
+	info->name    = np->name;
+	info->open    = rtk_uio_open;
+	info->release = rtk_uio_release;
+	info->priv    = priv;
+#ifdef CONFIG_UIO_ASSIGN_MINOR
+	info->minor = rtk_uio_get_minor(info->name);
+	dev_dbg(dev, "minor is %d\n", info->minor);
+#endif
+	priv->dev     = dev;
+
+	platform_set_drvdata(pdev, info);
+
+	ret = uio_register_device(dev, info);
+	if (ret) {
+		dev_err(dev, "failed to register uio_device: %d\n", ret);
+		goto destroy_pm_clk;
+	}
+
+	pm_runtime_set_suspended(dev);
+	pm_runtime_enable(dev);
+	if (priv->rstc)
+		reset_control_deassert(priv->rstc);
+	dev_info(dev, "initialized\n");
+	return 0;
+destroy_pm_clk:
+	pm_clk_destroy(dev);
+	return ret;
+
+}
+
+static int rtk_uio_remove(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct uio_info *info = platform_get_drvdata(pdev);
+	struct rtk_uio_data *priv = info->priv;
+
+	if (priv->rstc)
+		reset_control_assert(priv->rstc);
+	pm_runtime_disable(dev);
+	uio_unregister_device(info);
+	platform_set_drvdata(pdev, NULL);
+	pm_clk_destroy(dev);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+static int rtk_uio_runtime_suspend(struct device *dev)
+{
+	int ret = 0;
+
+	dev_dbg(dev, "enter %s\n", __func__);
+	ret = pm_clk_suspend(dev);
+	if (ret)
+		dev_err(dev, "failed to pm_clk_suspend: %d\n", ret);
+	dev_dbg(dev, "exit %s\n", __func__);
+	return ret;
+}
+
+static int rtk_uio_runtime_resume(struct device *dev)
+{
+	int ret = 0;
+
+	dev_dbg(dev, "enter %s\n", __func__);
+	ret = pm_clk_resume(dev);
+	if (ret)
+		dev_err(dev, "failed to pm_clk_resume: %d\n", ret);
+	dev_dbg(dev, "exit %s\n", __func__);
+	return ret;
+}
+
+static const struct dev_pm_ops rtk_uio_dev_pm_ops = {
+	.runtime_suspend = rtk_uio_runtime_suspend,
+	.runtime_resume = rtk_uio_runtime_resume,
+};
+
+static const struct of_device_id rtk_uio_ids[] = {
+	{ .compatible = "realtek,uio" },
+	{}
+};
+MODULE_DEVICE_TABLE(of, rtk_uio_ids);
+
+static struct platform_driver rtk_uio_driver = {
+	.probe = rtk_uio_probe,
+	.remove = rtk_uio_remove,
+	.driver = {
+		.name =  "rtk-uio",
+		.owner = THIS_MODULE,
+		.of_match_table = of_match_ptr(rtk_uio_ids),
+		.pm = &rtk_uio_dev_pm_ops,
+	},
+};
+module_platform_driver(rtk_uio_driver);
+
+MODULE_AUTHOR("Cheng-Yu Lee");
+MODULE_DESCRIPTION("Realtek Generic UIO driver");
+MODULE_LICENSE("GPL v2");
+MODULE_ALIAS("platform:"  "rtk-uio");
+
diff --git a/drivers/uio/uio_rtk_md.c b/drivers/uio/uio_rtk_md.c
new file mode 100644
index 00000000..a16b6c5
--- /dev/null
+++ b/drivers/uio/uio_rtk_md.c
@@ -0,0 +1,311 @@
+/*
+ * Copyright (C) 2015-2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/interrupt.h>
+#include <linux/io.h>
+#include <linux/module.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/uio_driver.h>
+#include <linux/pm_runtime.h>
+#include "reg_md.h"
+#include "uio_rtk_md.h"
+#include "uio_helper.h"
+
+struct md_uio_info {
+	struct uio_info info;
+	struct device *dev;
+	void __iomem *base;
+	struct clk *clk;
+	int irq;
+};
+
+enum {
+	MdClearWriteData = 0,
+	MdWriteData = BIT(0),
+	MdGo = BIT(1),
+	MdEndianSwap = BIT(2),
+};
+
+static inline void rtk_md_init_reg(struct device *dev)
+{
+	struct md_uio_info *priv = dev_get_drvdata(dev);
+	struct uio_info *info = &priv->info;
+	struct md_hw *md_hw = info->mem[1].internal_addr;
+	int i;
+
+	 MDREG_INFO *reg_info = (MDREG_INFO *)priv->base;
+
+	for (i = 0 ; i < MD_NUM_ENGINES ; i++) {
+		/* Stop Moving Data */
+		reg_info->MdCtrl[i].Value =
+			(MdGo | MdEndianSwap | MdClearWriteData);
+		reg_info->MdCtrl[i].Value = (MdEndianSwap | MdWriteData);
+		reg_info->MdCmdBase[i].Value = md_hw->engine[i].CmdBase;
+		reg_info->MdCmdReadPtr[i].Value = md_hw->engine[i].CmdBase;
+		reg_info->MdCmdWritePtr[i].Value = md_hw->engine[i].CmdBase;
+		reg_info->MdCmdLimit[i].Value = md_hw->engine[i].CmdLimit;
+		reg_info->MdInstCnt[i].Value = 0;
+
+		dev_info(dev, "[MD] Engine[%d] Ctrl:%08x Base:%08x ReadPtr:%08x WritePtr:%08x Limit:%08x\n",
+			i,
+			reg_info->MdCtrl[i].Value,
+			reg_info->MdCmdBase[i].Value,
+			reg_info->MdCmdReadPtr[i].Value,
+			reg_info->MdCmdWritePtr[i].Value,
+			reg_info->MdCmdLimit[i].Value);
+
+		md_hw->engine[i].CmdWritePtr = md_hw->engine[i].CmdBase;
+	}
+}
+
+static inline void rtk_md_enable_icg(struct device *dev)
+{
+	struct md_uio_info *priv = dev_get_drvdata(dev);
+	unsigned int val;
+
+	val = readl(priv->base + 0x180);
+	val |= 0x0000000f;
+	writel(val, priv->base + 0x180);
+}
+
+static void rtk_md_init_drv(struct device *dev)
+{
+	struct md_uio_info *priv = dev_get_drvdata(dev);
+	struct uio_info *info = &priv->info;
+	struct md_hw *md_hw = info->mem[1].internal_addr;
+	int i;
+	void *virt = info->mem[2].internal_addr;
+	dma_addr_t phys = info->mem[2].addr;
+
+	for (i = 0 ; i < MD_NUM_ENGINES ; i++) {
+		struct md_engine *eng = &md_hw->engine[i];
+
+		eng->CmdBuf   = (unsigned long)virt + MD_CMDBUF_SIZE * i;
+		eng->CmdBase  = phys + MD_CMDBUF_SIZE * i;
+		eng->CmdLimit = eng->CmdBase + MD_CMDBUF_SIZE;
+		eng->BufSize  = MD_CMDBUF_SIZE;
+	}
+
+	rtk_md_init_reg(dev);
+	rtk_md_enable_icg(dev);
+}
+
+static irqreturn_t md_irq_handler(int irq, struct uio_info *info)
+{
+	struct md_uio_info *priv = container_of(info, struct md_uio_info, info);
+	int i;
+	MDREG_INFO *reg_info = (MDREG_INFO *)priv->base;
+
+	pr_debug("[MD] interrupt...\n");
+
+	for (i = 0 ; i < MD_NUM_ENGINES ; i++) {
+		if (reg_info->MdInte[i].Fields.smq_empty_en &&
+			reg_info->MdInts[i].Fields.smq_empty) {
+
+			pr_debug("[MD] smq empty interrupt...\n");
+			reg_info->MdInte[i].Value = 0x8;
+		}
+	}
+
+	return IRQ_HANDLED;
+}
+
+
+static inline void print_uio_mem(struct device *dev, struct uio_info *info,
+	int index)
+{
+	struct uio_mem *umem = &info->mem[index];
+
+	dev_info(dev,
+		"mem[%d] phys:0x%pa virt:0x%p size:0x%pa type:%d name:%s\n",
+		index, &umem->addr, umem->internal_addr, &umem->size,
+		umem->memtype, umem->name);
+}
+
+static int rtk_md_runtime_suspend(struct device *dev)
+{
+	struct md_uio_info *priv = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "%s\n", __func__);
+	clk_disable_unprepare(priv->clk);
+	return 0;
+}
+
+static int rtk_md_runtime_resume(struct device *dev)
+{
+	struct md_uio_info *priv = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "%s\n", __func__);
+	clk_prepare_enable(priv->clk);
+	return 0;
+}
+
+static const struct dev_pm_ops rtk_md_pm_ops = {
+	SET_RUNTIME_PM_OPS(rtk_md_runtime_suspend, rtk_md_runtime_resume, NULL)
+};
+
+static int rtk_md_open(struct uio_info *info, struct inode *inode)
+{
+	struct md_uio_info *priv = info->priv;
+
+	pm_runtime_get_sync(priv->dev);
+	return 0;
+}
+
+static int rtk_md_release(struct uio_info *info, struct inode *inode)
+{
+	struct md_uio_info *priv = info->priv;
+
+	pm_runtime_put_sync(priv->dev);
+	return 0;
+}
+
+static int rtk_md_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct md_uio_info *priv;
+	struct uio_info *info;
+	int ret;
+
+	priv = devm_kzalloc(dev, sizeof(*priv), GFP_KERNEL);
+	if (!priv)
+		return -ENOMEM;
+
+	priv->clk = devm_clk_get(dev, NULL);
+	if (IS_ERR(priv->clk)) {
+		dev_warn(dev, "clk_get() returns %ld\n", PTR_ERR(priv->clk));
+		priv->clk = NULL;
+	}
+
+	ret = platform_get_irq(pdev, 0);
+	if (ret < 0) {
+		dev_err(dev, "platform_get_irq() returns %d\n", ret);
+		return ret;
+	}
+	priv->irq = ret;
+
+	priv->dev = dev;
+	info = &priv->info;
+
+	info->mem[0].name = "MD reg space";
+	ret = uio_mem_of_iomap(dev, &info->mem[0], 0);
+	if (ret) {
+		dev_err(dev, "mem0: uio_mem_of_iomap() returns %d\n", ret);
+		goto free_uio_mem;
+	}
+	priv->base = info->mem[0].internal_addr;
+
+	info->mem[1].name = "MD driver data";
+	ret = uio_mem_dma_alloc(dev, &info->mem[1], sizeof(struct md_hw),
+		GFP_KERNEL);
+	if (ret) {
+		dev_err(dev, "mem1: uio_mem_dma_alloc() returns %d\n", ret);
+		goto free_uio_mem;
+	}
+
+	info->mem[2].name = "MD command queue";
+	ret = uio_mem_dma_alloc(dev, &info->mem[2],
+		MD_CMDBUF_SIZE * MD_NUM_ENGINES, GFP_KERNEL | GFP_DMA);
+	if (ret) {
+		dev_err(dev, "mem2: uio_mem_dma_alloc() returns %d\n", ret);
+		goto free_uio_mem;
+	}
+
+	dev_info(dev, "irq=%d\n", priv->irq);
+	uio_mem_print(dev, &info->mem[0]);
+	uio_mem_print(dev, &info->mem[1]);
+	uio_mem_print(dev, &info->mem[2]);
+
+#ifdef CONFIG_UIO_ASSIGN_MINOR
+	info->minor = 252;
+#endif
+	info->version = "0.0.1";
+	info->name = "RTK-MD";
+	info->irq = priv->irq;
+	info->irq_flags = IRQF_SHARED;
+	info->handler = md_irq_handler;
+	info->open = rtk_md_open;
+	info->release = rtk_md_release;
+	info->priv = priv;
+
+	ret = uio_register_device(dev, info);
+	if (ret) {
+		dev_err(dev, "uio_register_device() returns %d\n", ret);
+		goto free_uio_mem;
+	}
+
+	ret = uio_reset_control_deassert(dev, NULL);
+	if (ret)
+		dev_warn(dev, "uio_reset_control_deassert() returns %d\n", ret);
+
+	platform_set_drvdata(pdev, priv);
+
+	/* enable runtime pm */
+	pm_runtime_set_suspended(dev);
+	pm_runtime_enable(dev);
+
+	/* init md */
+	pm_runtime_get_sync(dev);
+
+	rtk_md_init_drv(dev);
+
+	if (!of_property_read_bool(dev->of_node, "realtek,device-is-exclusive")) {
+		dev_info(dev, "shared mode\n");
+		pm_runtime_forbid(dev);
+	}
+	pm_runtime_put_sync(dev);
+
+	dev_info(dev, "initialized\n");
+	return 0;
+
+free_uio_mem:
+	uio_mem_dma_free(dev, &info->mem[2]);
+	uio_mem_dma_free(dev, &info->mem[1]);
+	uio_mem_iounmap(dev, &info->mem[0]);
+
+	return ret;
+}
+
+static int rtk_md_remove(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct md_uio_info *priv = platform_get_drvdata(pdev);
+	struct uio_info *info = &priv->info;
+
+	pm_runtime_disable(dev);
+	uio_reset_control_assert(dev, NULL);
+	platform_set_drvdata(pdev, NULL);
+	uio_unregister_device(info);
+	uio_mem_dma_free(dev, &info->mem[2]);
+	uio_mem_dma_free(dev, &info->mem[1]);
+	uio_mem_iounmap(dev, &info->mem[0]);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+static const struct of_device_id rtk_md_ids[] = {
+	{ .compatible = "realtek,md" },
+	{}
+};
+
+static struct platform_driver rtk_md_driver = {
+	.probe = rtk_md_probe,
+	.remove = rtk_md_remove,
+	.driver = {
+		.name = "rtk-md",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_md_ids,
+		.pm = &rtk_md_pm_ops,
+	},
+};
+module_platform_driver(rtk_md_driver);
diff --git a/drivers/uio/uio_rtk_md.h b/drivers/uio/uio_rtk_md.h
new file mode 100644
index 00000000..71b4211
--- /dev/null
+++ b/drivers/uio/uio_rtk_md.h
@@ -0,0 +1,36 @@
+#ifndef __MD_DRIVER_H__
+#define __MD_DRIVER_H__
+
+#include <linux/ioctl.h>
+#include <linux/cdev.h>
+#include <linux/dma-mapping.h>
+
+//#include "md_export.h"
+//#include "debug.h"
+
+#define MD_NUM_ENGINES			1 //3
+#define MD_COMMAND_ENTRIES		4096
+#define MD_CMDBUF_SIZE			(MD_COMMAND_ENTRIES * sizeof(uint32_t))
+
+#define MAX_QUEUE_ENTRIES		32
+#define BUF_OFFSET				12
+#define BUF_SIZE				(4096*32 - BUF_OFFSET)
+
+typedef struct md_engine {
+	volatile uint64_t CmdBuf;           //kernel virtual start address of command queue
+	volatile uint32_t CmdBase;          //physical start address of command queue
+	volatile uint32_t CmdLimit;         //physical end address of command queue
+	volatile uint32_t CmdWritePtr;      //physical address of write pointer
+	volatile uint32_t BufSize;          //total size of command queue
+} md_engine_t;
+
+typedef struct md_hw {
+	struct md_engine engine[MD_NUM_ENGINES];
+} md_hw_t;
+
+typedef struct md_resource {
+	void __iomem		*base;
+	int					irq;
+} md_resource_t;
+
+#endif // __MD_DRIVER_H__
diff --git a/drivers/uio/uio_rtk_se.c b/drivers/uio/uio_rtk_se.c
new file mode 100644
index 00000000..8048723
--- /dev/null
+++ b/drivers/uio/uio_rtk_se.c
@@ -0,0 +1,462 @@
+/*
+ * Copyright (C) 2015-2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/interrupt.h>
+#include <linux/io.h>
+#include <linux/module.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/uio_driver.h>
+#include <linux/pm_runtime.h>
+
+#include "reg_se.h"
+#include "uio_rtk_se.h"
+#include "uio_helper.h"
+
+struct se_uio_info {
+	struct uio_info info;
+	struct device *dev;
+	void __iomem *base;
+	struct clk *clk;
+	int irq;
+	int suspend;
+	int should_resume;
+};
+
+static SEREG_INFO se_reg;
+
+enum {
+	SeClearWriteData = 0,
+	SeWriteData = BIT(0),
+	SeGo = BIT(1),
+	SeEndianSwap = BIT(2),
+};
+
+static inline void rtk_se_init_reg(struct device *dev)
+{
+	struct se_uio_info *priv = dev_get_drvdata(dev);
+	struct uio_info *info = &priv->info;
+	struct se_hw *se_hw = info->mem[1].internal_addr;
+	int i;
+	SEREG_INFO *reg_info = (SEREG_INFO *)priv->base;
+
+	for (i = 0; i < SE_NUM_ENGINES; i++) {
+		/* Stop Streaming Engine */
+		reg_info->SeCtrl[i].Value = (SeGo | SeClearWriteData);
+		reg_info->SeCtrl[i].Value = (SeWriteData);
+		reg_info->SeCmdBase[i].Value = se_hw->engine[i].CmdBase;
+		reg_info->SeCmdReadPtr[i].Value = se_hw->engine[i].CmdBase;
+		reg_info->SeCmdWritePtr[i].Value = se_hw->engine[i].CmdBase;
+		reg_info->SeCmdLimit[i].Value = se_hw->engine[i].CmdLimit;
+		reg_info->SeInstCntL[i].Value = 0;
+		reg_info->SeInstCntH[i].Value = 0;
+
+		dev_info(dev,
+			"[SE] Engine[%d] Ctrl:%08x Base:%08x ReadPtr:%08x WritePtr:%08x Limit:%08x\n",
+			i,
+			reg_info->SeCtrl[i].Value,
+			reg_info->SeCmdBase[i].Value,
+			reg_info->SeCmdReadPtr[i].Value,
+			reg_info->SeCmdWritePtr[i].Value,
+			reg_info->SeCmdLimit[i].Value);
+
+		se_hw->engine[i].CmdWritePtr = se_hw->engine[i].CmdBase;
+	}
+}
+
+static inline void rtk_se_enable_icg(struct device *dev)
+{
+	struct se_uio_info *priv = dev_get_drvdata(dev);
+	unsigned int val;
+
+#ifndef CONFIG_ARCH_RTD119X
+	val = readl(priv->base + 0x80c);
+	val &= ~0xf8000000;
+	writel(val, priv->base + 0x80c);
+#endif
+}
+
+static void rtk_se_init_drv(struct device *dev)
+{
+	struct se_uio_info *priv = dev_get_drvdata(dev);
+	struct uio_info *info = &priv->info;
+	struct se_hw *se_hw = info->mem[1].internal_addr;
+	void *virt = info->mem[2].internal_addr;
+	dma_addr_t phys = info->mem[2].addr;
+	int i;
+
+	for (i = 0 ; i < SE_NUM_ENGINES ; i++) {
+		struct se_engine *eng = &se_hw->engine[i];
+
+		eng->CmdBuf   = (unsigned long)virt + SE_CMDBUF_SIZE * i;
+		eng->CmdBase  = phys + SE_CMDBUF_SIZE * i;
+		eng->CmdLimit = eng->CmdBase + SE_CMDBUF_SIZE;
+		eng->BufSize  = SE_CMDBUF_SIZE;
+	}
+
+	rtk_se_init_reg(dev);
+	rtk_se_enable_icg(dev);
+}
+
+static irqreturn_t rtk_se_irq_handler(int irq, struct uio_info *info)
+{
+	struct se_uio_info *priv = container_of(info, struct se_uio_info, info);
+	SEREG_INFO *reg_info = (SEREG_INFO *)priv->base;
+	int i;
+
+	pr_debug("[SE] interrupt...\n");
+
+	for (i = 0 ; i < SE_NUM_ENGINES ; i++) {
+		if (reg_info->SeInte[i].Fields.com_empty &&
+			reg_info->SeInts[i].Fields.com_empty) {
+
+			pr_debug("[SE] smq empty interrupt...\n");
+			reg_info->SeInte[i].Value = 0x8;
+#if 0
+			if ((reg_info->SeCtrl[i].Value & 0x2) &&
+				((reg_info->SeIdle[i].Value & 0x1) == 0)) {
+				//dbg_info("%s se is not idle", DEV_NAME);
+			}
+#endif
+		}
+	}
+
+	return IRQ_HANDLED;
+}
+
+static int rtk_se_save_reg(struct device *dev)
+{
+	struct se_uio_info *priv = dev_get_drvdata(dev);
+	int i;
+	uint8_t *regbak = (uint8_t *)&se_reg;
+	uint8_t *reghw = (uint8_t *)priv->base;
+
+	dev_info(dev, "[SE] Enter %s\n", __func__);
+
+	for (i = 0; i < sizeof(SEREG_INFO); i += 4) {
+		/* skip reserved registers to avoid sb2 timeout issue */
+		if (i >= 0x64 && i < 0x70)
+			continue; /* Reserved */
+		if (i >= 0xF4 && i < 0x128)
+			continue; /* Reserved */
+		if (i >= 0x440 && i < 0x458)
+			continue; /* Reserved */
+		if (i >= 0x4CC && i < 0x4E0)
+			continue; /* Reserved */
+		if (i >= 0x504 && i < 0x510)
+			continue; /* Reserved */
+
+		dev_dbg(dev, "offset=%03x val=%08x to mem", i, *(uint32_t *)(reghw + i));
+		*(uint32_t *)(regbak + i) = *(uint32_t *)(reghw + i);
+	}
+
+	dev_info(dev, "[SE] Exit %s\n", __func__);
+	priv->suspend = 1;
+
+	return 0;
+}
+
+static int rtk_se_restore_reg(struct device *dev)
+{
+	struct se_uio_info *priv = dev_get_drvdata(dev);
+	uint8_t *regbak = (uint8_t *)&se_reg;
+	uint8_t *reghw = (uint8_t *)priv->base;
+	int i;
+	SEREG_INFO *reg_info = (SEREG_INFO *)priv->base;
+
+	dev_info(dev, "[SE] Enter %s\n", __func__);
+
+	for (i = 0; i < sizeof(SEREG_INFO); i += 4) {
+		/* skip restoring reserved, read-only, special registers */
+		if (i >= 0x30 && i < 0x3C)
+			continue; /* SRWORDCNT */
+		if (i >= 0x40 && i < 0x4C)
+			continue; /* CLR_FMT */
+		if (i >= 0x64 && i < 0x70)
+			continue; /* Reserved */
+		if (i >= 0xF4 && i < 0x128)
+			continue; /* Reserved */
+		if (i >= 0x440 && i < 0x458)
+			continue; /* Reserved */
+		if (i >= 0x458 && i < 0x464)
+			continue; /* CTRL */
+		if (i >= 0x474 && i < 0x480)
+			continue; /* INTS */
+		if (i >= 0x48C && i < 0x498)
+			continue; /* INSTCNT */
+		if (i == 0x4C8)
+			continue; /* CLUT_LOCK_ST */
+		if (i >= 0x4CC && i < 0x4E0)
+			continue; /* Reserved */
+		if (i >= 0x4F8 && i < 0x504)
+			continue; /* SYNC_VO_LOCATION */
+		if (i >= 0x504 && i < 0x510)
+			continue; /* Reserved */
+		if (i >= 0x510 && i < 0x51C)
+			continue; /* INSTCNT_H */
+
+		dev_dbg(dev, "offset=%03x val=%08x to reg", i, *(uint32_t *)(regbak + i));
+		*(uint32_t *)(reghw + i) = *(uint32_t *)(regbak + i);
+	}
+
+	se_reg.SeColorFormat[0].Fields.write_enable1 = 1;
+	se_reg.SeColorFormat[0].Fields.write_enable2 = 1;
+	se_reg.SeColorFormat[0].Fields.write_enable5 = 1;
+	se_reg.SeColorFormat[0].Fields.write_enable6 = 1;
+	se_reg.SeColorFormat[0].Fields.write_enable7 = 1;
+	se_reg.SeColorFormat[0].Fields.write_enable8 = 1;
+	se_reg.SeColorFormat[0].Fields.write_enable10 = 1;
+	reg_info->SeColorFormat[0].Value = se_reg.SeColorFormat[0].Value;
+	se_reg.SeColorFormat[1].Fields.write_enable1 = 1;
+	se_reg.SeColorFormat[1].Fields.write_enable2 = 1;
+	se_reg.SeColorFormat[1].Fields.write_enable5 = 1;
+	se_reg.SeColorFormat[1].Fields.write_enable6 = 1;
+	se_reg.SeColorFormat[1].Fields.write_enable7 = 1;
+	se_reg.SeColorFormat[1].Fields.write_enable8 = 1;
+	se_reg.SeColorFormat[1].Fields.write_enable10 = 1;
+	reg_info->SeColorFormat[1].Value = se_reg.SeColorFormat[1].Value;
+	se_reg.SeColorFormat[2].Fields.write_enable1 = 1;
+	se_reg.SeColorFormat[2].Fields.write_enable2 = 1;
+	se_reg.SeColorFormat[2].Fields.write_enable5 = 1;
+	se_reg.SeColorFormat[2].Fields.write_enable6 = 1;
+	se_reg.SeColorFormat[2].Fields.write_enable7 = 1;
+	se_reg.SeColorFormat[2].Fields.write_enable8 = 1;
+	se_reg.SeColorFormat[2].Fields.write_enable10 = 1;
+	reg_info->SeColorFormat[2].Value = se_reg.SeColorFormat[2].Value;
+
+	/* clear interrupt status? */
+	reg_info->SeInts[0].Value = se_reg.SeInts[0].Value;
+	reg_info->SeInts[1].Value = se_reg.SeInts[1].Value;
+	reg_info->SeInts[2].Value = se_reg.SeInts[2].Value;
+
+	/* restore the go bit? */
+	reg_info->SeCtrl[0].Value = se_reg.SeCtrl[0].Value;
+	reg_info->SeCtrl[1].Value = se_reg.SeCtrl[1].Value;
+	reg_info->SeCtrl[2].Value = se_reg.SeCtrl[2].Value;
+
+	dev_info(dev, "[SE] Exit %s\n", __func__);
+	priv->suspend = 0;
+
+	return 0;
+}
+
+static int rtk_se_runtime_suspend(struct device *dev)
+{
+	struct se_uio_info *priv = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "%s\n", __func__);
+	rtk_se_save_reg(dev);
+	clk_disable_unprepare(priv->clk);
+	return 0;
+}
+
+static int rtk_se_runtime_resume(struct device *dev)
+{
+	struct se_uio_info *priv = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "%s\n", __func__);
+	clk_prepare_enable(priv->clk);
+	rtk_se_restore_reg(dev);
+	return 0;
+}
+
+static int rtk_se_suspend(struct device *dev)
+{
+	struct se_uio_info *priv = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "%s\n", __func__);
+	if (priv->suspend)
+		return 0;
+
+	rtk_se_runtime_suspend(dev);
+	priv->should_resume = 1;
+
+	return 0;
+}
+
+static int rtk_se_resume(struct device *dev)
+{
+	struct se_uio_info *priv = dev_get_drvdata(dev);
+
+	dev_dbg(dev, "%s\n", __func__);
+	if (priv->should_resume)
+		rtk_se_runtime_resume(dev);
+	priv->should_resume = 0;
+
+	return 0;
+}
+
+
+static const struct dev_pm_ops rtk_se_pm_ops = {
+	SET_RUNTIME_PM_OPS(rtk_se_runtime_suspend, rtk_se_runtime_resume, NULL)
+	SET_SYSTEM_SLEEP_PM_OPS(rtk_se_suspend, rtk_se_resume)
+};
+
+static int rtk_se_open(struct uio_info *info, struct inode *inode)
+{
+	struct se_uio_info *priv = info->priv;
+
+	pm_runtime_get_sync(priv->dev);
+	return 0;
+}
+
+static int rtk_se_release(struct uio_info *info, struct inode *inode)
+{
+	struct se_uio_info *priv = info->priv;
+
+	pm_runtime_put_sync(priv->dev);
+	return 0;
+}
+
+static int rtk_se_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct se_uio_info *priv;
+	struct uio_info *info;
+	int ret;
+
+	priv = devm_kzalloc(dev, sizeof(*priv), GFP_KERNEL);
+	if (!priv)
+		return -ENOMEM;
+
+	priv->clk = devm_clk_get(dev, NULL);
+	if (IS_ERR(priv->clk)) {
+		dev_warn(dev, "clk_get() returns %ld\n", PTR_ERR(priv->clk));
+		priv->clk = NULL;
+	}
+
+	ret = platform_get_irq(pdev, 0);
+	if (ret < 0) {
+		dev_err(dev, "platform_get_irq() returns %d\n", ret);
+		return ret;
+	}
+	priv->irq = ret;
+	priv->dev = dev;
+
+	info = &priv->info;
+	info->mem[0].name = "SE reg space";
+	ret = uio_mem_of_iomap(dev, &info->mem[0], 0);
+	if (ret) {
+		dev_err(dev, "mem0: uio_mem_of_iomap() returns %d\n", ret);
+		goto free_uio_mem;
+	}
+	priv->base = info->mem[0].internal_addr;
+
+	info->mem[1].name = "SE driver data";
+	ret = uio_mem_dma_alloc(dev, &info->mem[1], sizeof(struct se_hw),
+		GFP_KERNEL);
+	if (ret) {
+		dev_err(dev, "mem1: uio_mem_dma_alloc() returns %d\n", ret);
+		goto free_uio_mem;
+	}
+
+	info->mem[2].name = "SE command queue";
+	ret = uio_mem_dma_alloc(dev, &info->mem[2],
+		SE_CMDBUF_SIZE * SE_NUM_ENGINES, GFP_KERNEL | GFP_DMA);
+	if (ret) {
+		dev_err(dev, "mem2: uio_mem_dma_alloc() returns %d\n", ret);
+		goto free_uio_mem;
+	}
+
+	dev_info(dev, "irq=%d\n", priv->irq);
+	uio_mem_print(dev, &info->mem[0]);
+	uio_mem_print(dev, &info->mem[1]);
+	uio_mem_print(dev, &info->mem[2]);
+
+#ifdef CONFIG_UIO_ASSIGN_MINOR
+	info->minor = 251;
+#endif
+	info->version = "0.0.1";
+	info->name = "RTK-SE";
+	info->irq = priv->irq;
+	info->irq_flags = IRQF_SHARED;
+	info->handler = rtk_se_irq_handler;
+	info->open = rtk_se_open;
+	info->release = rtk_se_release;
+	info->priv = priv;
+
+	ret = uio_register_device(dev, info);
+	if (ret) {
+		dev_err(dev, "uio_register_device() returns %d\n", ret);
+		goto free_uio_mem;
+	}
+
+	ret = uio_reset_control_deassert(dev, NULL);
+	if (ret)
+		dev_warn(dev, "uio_reset_control_deassert() returns %d\n", ret);
+
+	platform_set_drvdata(pdev, priv);
+
+	/* enable runtime pm */
+	pm_runtime_set_active(dev);
+	pm_runtime_enable(dev);
+
+	/* do resume */
+	clk_prepare_enable(priv->clk);
+	priv->suspend = 0;
+	pm_runtime_get_noresume(dev);
+
+	/* init se */
+	rtk_se_init_drv(dev);
+
+	if (!of_property_read_bool(dev->of_node, "realtek,device-is-exclusive")) {
+		dev_info(dev, "shared mode\n");
+		pm_runtime_forbid(dev);
+	}
+
+	pm_runtime_put_sync(dev);
+
+	dev_info(dev, "initialized\n");
+	return 0;
+
+free_uio_mem:
+	uio_mem_dma_free(dev, &info->mem[2]);
+	uio_mem_dma_free(dev, &info->mem[1]);
+	uio_mem_iounmap(dev, &info->mem[0]);
+
+	return ret;
+}
+
+static int rtk_se_remove(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct se_uio_info *priv = platform_get_drvdata(pdev);
+	struct uio_info *info = &priv->info;
+
+	pm_runtime_disable(dev);
+	uio_reset_control_assert(dev, NULL);
+	platform_set_drvdata(pdev, NULL);
+	uio_unregister_device(info);
+	uio_mem_dma_free(dev, &info->mem[2]);
+	uio_mem_dma_free(dev, &info->mem[1]);
+	uio_mem_iounmap(dev, &info->mem[0]);
+	dev_info(dev, "removed\n");
+	return 0;
+}
+
+
+static const struct of_device_id rtk_se_ids[] = {
+	{ .compatible = "realtek,se" },
+	{}
+};
+
+static struct platform_driver rtk_se_driver = {
+	.probe = rtk_se_probe,
+	.remove = rtk_se_remove,
+	.driver = {
+		.name = "rtk-se",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_se_ids,
+		.pm = &rtk_se_pm_ops,
+	},
+};
+module_platform_driver(rtk_se_driver);
diff --git a/drivers/uio/uio_rtk_se.h b/drivers/uio/uio_rtk_se.h
new file mode 100644
index 00000000..5cf909c
--- /dev/null
+++ b/drivers/uio/uio_rtk_se.h
@@ -0,0 +1,49 @@
+#ifndef __SE_DRIVER_H__
+#define __SE_DRIVER_H__
+
+#include <linux/ioctl.h>
+#include <linux/cdev.h>
+#include <linux/dma-mapping.h>
+
+//#include "se_export.h"
+//#include "debug.h"
+
+#ifdef CONFIG_ARCH_RTD129x
+#  define SE_NUM_ENGINES       2
+#elif defined(CONFIG_ARCH_RTD139x)
+#  define SE_NUM_ENGINES       1
+#elif defined(CONFIG_ARCH_RTD16xx)
+#  define SE_NUM_ENGINES       1
+#elif defined(CONFIG_ARCH_RTD119X)
+#  define SE_NUM_ENGINES       2
+#elif defined(CONFIG_ARCH_RTD13xx)
+#  define SE_NUM_ENGINES       1
+#else
+#  error "unknown platform"
+#endif
+
+#define SE_COMMAND_ENTRIES		4096
+#define SE_CMDBUF_SIZE			(SE_COMMAND_ENTRIES * sizeof(uint32_t))
+
+#define MAX_QUEUE_ENTRIES		32
+#define BUF_OFFSET				12
+#define BUF_SIZE				(4096*32 - BUF_OFFSET)
+
+typedef struct se_engine {
+	volatile uint64_t CmdBuf;           //kernel virtual start address of command queue
+	volatile uint32_t CmdBase;          //physical start address of command queue
+	volatile uint32_t CmdLimit;         //physical end address of command queue
+	volatile uint32_t CmdWritePtr;      //physical address of write pointer
+	volatile uint32_t BufSize;          //total size of command queue
+} se_engine_t;
+
+typedef struct se_hw {
+	struct se_engine engine[SE_NUM_ENGINES];
+} se_hw_t;
+
+typedef struct se_resource {
+	void __iomem		*base;
+	int					irq;
+} se_resource_t;
+
+#endif // __SE_DRIVER_H__
diff --git a/drivers/usb/Kconfig b/drivers/usb/Kconfig
index 0103f77..bfa1756 100644
--- a/drivers/usb/Kconfig
+++ b/drivers/usb/Kconfig
@@ -152,6 +152,10 @@ source "drivers/usb/misc/Kconfig"
 
 source "drivers/usb/atm/Kconfig"
 
+config USB_PATCH_ON_RTK
+	boolean
+	default y if USB_OHCI_RTK || USB_EHCI_RTK || USB_DWC3_RTK
+
 endif # USB
 
 source "drivers/usb/phy/Kconfig"
diff --git a/drivers/usb/core/driver.c b/drivers/usb/core/driver.c
index 0bb380a..1cdb38e 100644
--- a/drivers/usb/core/driver.c
+++ b/drivers/usb/core/driver.c
@@ -264,6 +264,15 @@ static int usb_probe_device(struct device *dev)
 	return error;
 }
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+int RTK_usb_probe_device(struct device *dev)
+{
+	int ret = 0;
+	ret = usb_probe_device(dev);
+	return ret;
+}
+#endif
+
 /* called from driver core with dev locked */
 static int usb_unbind_device(struct device *dev)
 {
@@ -276,6 +285,15 @@ static int usb_unbind_device(struct device *dev)
 	return 0;
 }
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+int RTK_usb_unbind_device(struct device *dev)
+{
+	int ret = 0;
+	ret = usb_unbind_device(dev);
+	return ret;
+}
+#endif
+
 /* called from driver core with dev locked */
 static int usb_probe_interface(struct device *dev)
 {
diff --git a/drivers/usb/core/hub.c b/drivers/usb/core/hub.c
index 7aee552..ab8e3b3 100644
--- a/drivers/usb/core/hub.c
+++ b/drivers/usb/core/hub.c
@@ -26,6 +26,11 @@
 #include <linux/mutex.h>
 #include <linux/random.h>
 #include <linux/pm_qos.h>
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#include <linux/platform_device.h>
+#include <linux/timer.h>
+#include <linux/syscalls.h>
+#endif
 
 #include <asm/uaccess.h>
 #include <asm/byteorder.h>
@@ -36,6 +41,13 @@
 #define USB_VENDOR_GENESYS_LOGIC		0x05e3
 #define HUB_QUIRK_CHECK_PORT_AUTOSUSPEND	0x01
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_RTK_USB_CTRL_MANAGER
+extern int RTK_usb_reprobe_usb_storage(struct usb_device *udev);
+extern bool RTK_usb_disable_hub_autosuspend(void);
+#endif
+#endif
+
 /* Protect struct usb_device->state and ->children members
  * Note: Both are also protected by ->dev.sem, except that ->state can
  * change to USB_STATE_NOTATTACHED even when the semaphore isn't held. */
@@ -393,6 +405,26 @@ static int get_hub_descriptor(struct usb_device *hdev,
 	return -EINVAL;
 }
 
+#ifdef CONFIG_USB_RTK_HCD_TEST_MODE
+int get_hub_descriptor_port(struct usb_device *hdev, void *data, int size, int port1)
+{
+	struct usb_hub *hub = usb_hub_to_struct_hub(hdev);
+	struct usb_device *dev = hub->ports[port1 - 1]->child;
+
+	if (dev) {
+		memset(data, 0, size);
+
+		return usb_control_msg(dev, usb_rcvctrlpipe(dev, 0),
+				USB_REQ_GET_DESCRIPTOR, USB_DIR_IN,
+				(USB_DT_DEVICE << 8), 0, data, size,
+				USB_CTRL_GET_TIMEOUT);
+
+	} else
+		return 0;
+}
+EXPORT_SYMBOL_GPL(get_hub_descriptor_port);
+#endif //CONFIG_USB_RTK_HCD_TEST_MODE
+
 /*
  * USB 2.0 spec Section 11.24.2.1
  */
@@ -1726,6 +1758,14 @@ static int hub_probe(struct usb_interface *intf, const struct usb_device_id *id)
 	 */
 	if (hdev->parent) {		/* normal device */
 		usb_enable_autosuspend(hdev);
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_RTK_USB_CTRL_MANAGER
+		if (RTK_usb_disable_hub_autosuspend()) {
+			dev_warn(&intf->dev, "disable hub autosuspend\n");
+			usb_disable_autosuspend(hdev);
+		}
+#endif
+#endif
 	} else {			/* root hub */
 		const struct hc_driver *drv = bus_to_hcd(hdev->bus)->driver;
 
@@ -2809,7 +2849,9 @@ static int hub_port_reset(struct usb_hub *hub, int port1,
 					USB_PORT_FEAT_C_BH_PORT_RESET);
 			usb_clear_port_feature(hub->hdev, port1,
 					USB_PORT_FEAT_C_PORT_LINK_STATE);
-			usb_clear_port_feature(hub->hdev, port1,
+
+			if (udev)
+				usb_clear_port_feature(hub->hdev, port1,
 					USB_PORT_FEAT_C_CONNECTION);
 
 			/*
@@ -3480,6 +3522,39 @@ int usb_port_resume(struct usb_device *udev, pm_message_t msg)
 
 	status = check_port_resume_type(udev,
 			hub, port1, status, portchange, portstatus);
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* [DEV_FIX] Disconnect usb port at resume.
+	 * commit 1a50dacafca108bd258f28755e2f4ad9ba4bc8d4
+	 * [BUG_FIX]: ID 46792 [ROOT_CAUSE]: can't recognize usb hub
+	 * commit cd7a079f0a82876abcdbe3e6a0b9409441c94294
+	 * [DEV_FIX]check udev reset_resume flag to disconnect
+	 * the device while resume back .
+	 * commit 8185a91ad51e2fe115d8d7a60d8b1ed4b8eb6c9f
+	 * [DEV_FIX]cant recognize hub after unplug/plug & suspend/resume
+	 * commit 3bbc65af52a4b27ac41114a998ad942aa613c078
+	 * [DEV_FIX]2. force  CONFIG_USB_HUB_DISCONNECT_AT_RESUME
+	 * commit 3e6a470b06ea6e37edded163aa814c8c24f04ced
+	 */
+	if (udev->reset_resume) {
+		int i;
+		if (udev->descriptor.bDeviceClass == USB_CLASS_MASS_STORAGE)
+			status = -1;
+		else
+			for (i = 0; i < udev->actconfig->desc.bNumInterfaces; i++) {
+				struct usb_host_config *config = udev->actconfig;
+				struct usb_interface *intf = config->interface[i];
+				struct usb_interface_descriptor *desc;
+				desc = &intf->cur_altsetting->desc;
+
+				dev_notice(&udev->dev , "%s bInterfaceClass = %d \n", __func__, desc->bInterfaceClass);//hcy test
+				if (desc->bInterfaceClass == USB_CLASS_MASS_STORAGE){
+					status = -1;
+					break;
+				}
+			}
+	}
+#endif
 	if (status == 0)
 		status = finish_port_resume(udev);
 	if (status < 0) {
@@ -4431,11 +4506,31 @@ static int hub_enable_device(struct usb_device *udev)
 	else
 		speed = usb_speed_string(udev->speed);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (udev->speed < USB_SPEED_SUPER)
+		dev_notice(&udev->dev,
+				"%s %s USB device number %d using %s\n",
+				(udev->config) ? "reset" : "new", speed,
+				devnum, udev->bus->controller->driver->name);
+
+	/* add for debug reset*/
+	if (udev->speed < USB_SPEED_SUPER && udev->config) {
+		dev_dbg(&udev->dev,
+			    "Start print dump_stack for %s %s USB device number %d "
+			    "using %s (%s)\n",
+			    (udev->config) ? "reset" : "new", speed,
+			    devnum, udev->bus->controller->driver->name,
+			    dev_name(udev->bus->controller->parent));
+		dev_dbg(&udev->dev, "End print dump_stack for USB dev number %d",
+			    ({dump_stack(); devnum;}));
+	}
+#else
 	if (udev->speed < USB_SPEED_SUPER)
 		dev_info(&udev->dev,
 				"%s %s USB device number %d using %s\n",
 				(udev->config) ? "reset" : "new", speed,
 				devnum, udev->bus->controller->driver->name);
+#endif
 
 	/* Set up TT records, if needed  */
 	if (hdev->tt) {
@@ -4565,11 +4660,34 @@ static int hub_enable_device(struct usb_device *udev)
 			}
 			if (udev->speed >= USB_SPEED_SUPER) {
 				devnum = udev->devnum;
+#ifdef CONFIG_USB_PATCH_ON_RTK
+				dev_notice(&udev->dev,
+						"%s SuperSpeed%s USB device number %d using %s\n",
+						(udev->config) ? "reset" : "new",
+					 (udev->speed == USB_SPEED_SUPER_PLUS) ? "Plus" : "",
+						devnum, udev->bus->controller->driver->name);
+
+				/* add for debug reset*/
+				if (udev->config) {
+					dev_dbg(&udev->dev,
+					    "Start print dump_stack for %s SuperSpeed%s "
+					    "USB device number %d "
+					    "using %s (%s)\n",
+					    (udev->config) ? "reset" : "new",
+					    (udev->speed == USB_SPEED_SUPER_PLUS) ? "Plus" : "",
+					    devnum, udev->bus->controller->driver->name,
+					    dev_name(udev->bus->controller->parent));
+					dev_dbg(&udev->dev,
+					    "End print dump_stack for USB dev number %d",
+					    ({dump_stack(); devnum;}));
+				}
+#else
 				dev_info(&udev->dev,
 						"%s SuperSpeed%s USB device number %d using %s\n",
 						(udev->config) ? "reset" : "new",
 					 (udev->speed == USB_SPEED_SUPER_PLUS) ? "Plus" : "",
 						devnum, udev->bus->controller->driver->name);
+#endif
 			}
 
 			/* cope with hardware quirkiness:
@@ -4912,6 +5030,12 @@ static void hub_port_connect(struct usb_hub *hub, int port1, u16 portstatus,
 		/* Run it through the hoops (find a driver, etc) */
 		if (!status) {
 			status = usb_new_device(udev);
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_RTK_USB_CTRL_MANAGER
+			if (!status)
+				RTK_usb_reprobe_usb_storage(udev);
+#endif
+#endif
 			if (status) {
 				mutex_lock(&usb_port_peer_mutex);
 				spin_lock_irq(&device_state_lock);
@@ -4985,8 +5109,13 @@ static void hub_port_connect_change(struct usb_hub *hub, int port1,
 	struct usb_device *udev = port_dev->child;
 	int status = -ENODEV;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	dev_notice(&port_dev->dev, "port %d, status %04x, change %04x, %s\n",
+			port1, portstatus, portchange, portspeed(hub, portstatus));
+#else
 	dev_dbg(&port_dev->dev, "status %04x, change %04x, %s\n", portstatus,
 			portchange, portspeed(hub, portstatus));
+#endif
 
 	if (hub->has_indicators) {
 		set_port_led(hub, port1, HUB_LED_AUTO);
diff --git a/drivers/usb/core/quirks.c b/drivers/usb/core/quirks.c
index 99f6776..ed91665 100644
--- a/drivers/usb/core/quirks.c
+++ b/drivers/usb/core/quirks.c
@@ -60,6 +60,11 @@
 	/* Microsoft LifeCam-VX700 v2.0 */
 	{ USB_DEVICE(0x045e, 0x0770), .driver_info = USB_QUIRK_RESET_RESUME },
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Microsoft Wireless Mouse 5000 */
+	{ USB_DEVICE(0x045e, 0x0745), .driver_info = USB_QUIRK_RESET },
+#endif
+
 	/* Logitech HD Pro Webcams C920, C920-C, C925e and C930e */
 	{ USB_DEVICE(0x046d, 0x082d), .driver_info = USB_QUIRK_DELAY_INIT },
 	{ USB_DEVICE(0x046d, 0x0841), .driver_info = USB_QUIRK_DELAY_INIT },
@@ -94,6 +99,11 @@
 	/* Logitech Harmony 700-series */
 	{ USB_DEVICE(0x046d, 0xc122), .driver_info = USB_QUIRK_DELAY_INIT },
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Logitech Wireless Mouse M705 */
+	{ USB_DEVICE(0x046d, 0xc52b), .driver_info = USB_QUIRK_RESET },
+#endif
+
 	/* Philips PSC805 audio device */
 	{ USB_DEVICE(0x0471, 0x0155), .driver_info = USB_QUIRK_RESET_RESUME },
 
@@ -255,6 +265,16 @@
 	/* Blackmagic Design UltraStudio SDI */
 	{ USB_DEVICE(0x1edb, 0xbd4f), .driver_info = USB_QUIRK_NO_LPM },
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Kingston DataTraveler 3.0 G4 */
+	{ USB_DEVICE_VER(0x0951, 0x1666, 0, 0x1100), .driver_info = USB_QUIRK_RESET_RESUME },
+
+	/* Kingston DataTraveler 3.0 G4 no support lpm */
+	{ USB_DEVICE(0x0951, 0x1666), .driver_info = USB_QUIRK_NO_LPM },
+
+	/* Toshiba no support lpm */
+	{ USB_DEVICE(0x0930, 0x6545), .driver_info = USB_QUIRK_NO_LPM },
+#endif
 	/* Hauppauge HVR-950q */
 	{ USB_DEVICE(0x2040, 0x7200), .driver_info =
 			USB_QUIRK_CONFIG_INTF_STRINGS },
diff --git a/drivers/usb/core/sysfs.c b/drivers/usb/core/sysfs.c
index c953a0f..90a9003 100644
--- a/drivers/usb/core/sysfs.c
+++ b/drivers/usb/core/sysfs.c
@@ -756,6 +756,192 @@ static ssize_t remove_store(struct device *dev, struct device_attribute *attr,
 }
 static DEVICE_ATTR_IGNORE_LOCKDEP(remove, S_IWUSR, NULL, remove_store);
 
+#ifdef CONFIG_USB_RTK_HCD_TEST_MODE
+#include <linux/slab.h>
+#include <linux/usb/ch11.h>
+#include <linux/usb/hcd.h>
+
+extern int get_hub_descriptor_port(struct usb_device *hdev, void *data, int size, int port1);
+
+// copy from hub.c and rename
+/*
+ * USB 2.0 spec Section 11.24.2.2
+ */
+static int hub_clear_port_feature(struct usb_device *hdev, int port1, int feature)
+{
+	return usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+			ClearPortFeature, USB_RT_PORT, feature, port1,
+			NULL, 0, 1000);
+}
+
+/*
+ * USB 2.0 spec Section 11.24.2.13
+ */
+static int hub_set_port_feature(struct usb_device *hdev, int port1, int feature)
+{
+	return usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+			SetPortFeature, USB_RT_PORT, feature, port1,
+			NULL, 0, 1000);
+}
+
+/* use a short timeout for hub/port status fetches */
+#define	USB_STS_TIMEOUT		1000
+#define	USB_STS_RETRIES		5
+
+static int get_port_status(struct usb_device *hdev, int port1,
+		struct usb_port_status *data)
+{
+	int i, status = -ETIMEDOUT;
+
+	for (i = 0; i < USB_STS_RETRIES &&
+			(status == -ETIMEDOUT || status == -EPIPE); i++) {
+		printk("get_port_status at port %d ...\n", port1);
+		status = usb_control_msg(hdev, usb_rcvctrlpipe(hdev, 0),
+			USB_REQ_GET_STATUS, USB_DIR_IN | USB_RT_PORT, 0, port1,
+			data, sizeof(*data), USB_STS_TIMEOUT);
+	}
+	return status;
+}
+
+enum {
+	TEST_RESET = 0,
+	TEST_TEST_J,
+	TEST_TEST_K,
+	TEST_TEST_SE0_NAK,
+	TEST_TEST_PACKET,
+	TEST_TEST_FORCE_ENABLE,
+	TEST_SUSPEND_RESUME,
+	TEST_SINGLE_STEP_GET_DEVICE_DESCRIPTOR,
+	TEST_PORT_RESET,
+	MAX_CTS_TEST_CASE,
+};
+
+static ssize_t  show_runTestMode (struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct usb_device *udev = udev = to_usb_device (dev);
+	struct usb_host_config *actconfig;
+
+	if(udev->descriptor.bDeviceClass != USB_CLASS_HUB)
+		return sprintf (buf, "This node is not a HUB\n");
+
+	return sprintf (buf, "%s to runTestMode\n"
+		    "echo \"1 %d\" to run port1 HC_RESET command\n"
+		    "echo \"1 %d\" to run port1 TEST_J command\n"
+		    "echo \"1 %d\" ro run port1 TEST_K command\n"
+		    "echo \"1 %d\" to run port1 TEST_SE0_NAK command\n"
+		    "echo \"1 %d\" to run port1 TEST_PACKET command\n"
+		    "echo \"1 %d\" to run port1 TEST_FORCE_ENABLE command\n"
+		    "echo \"1 %d\" to run port1 SUSPEND/RESUME command\n"
+		    "echo \"1 %d\" to run port1 "
+		    "SINGLE_STEP_GET_DEVICE_DESCRIPTOR command\n"
+		    "echo \"1 %d\" to run port1 PORT_RESET command\n",
+		    dev_name(dev),
+		    TEST_RESET, TEST_TEST_J, TEST_TEST_K, TEST_TEST_SE0_NAK,
+		    TEST_TEST_PACKET,
+		    TEST_TEST_FORCE_ENABLE, TEST_SUSPEND_RESUME,
+		    TEST_SINGLE_STEP_GET_DEVICE_DESCRIPTOR,
+		    TEST_PORT_RESET);
+
+	return 0;
+}
+
+static ssize_t
+set_runTestMode (struct device *dev, struct device_attribute *attr, const char *buf, size_t count)
+{
+	struct usb_device	*udev = udev = to_usb_device (dev);
+	int value, test_case;
+	unsigned int		port1 = 1;
+
+	if ((value = sscanf (buf, "%u", &port1)) != 1)
+		return -EINVAL;
+
+	buf += 2;
+
+	if ((value = sscanf (buf, "%u", &test_case)) != 1)
+		return -EINVAL;
+
+	if(udev->descriptor.bDeviceClass != USB_CLASS_HUB)
+		return value;
+
+	switch (test_case) {
+	case TEST_RESET:
+		printk("run HC_RESET (%d) to port %d ...\n", test_case, port1);
+		if (udev->bus != NULL) {
+			struct usb_hcd *hcd = bus_to_hcd(udev->bus);
+			int ret;
+			if (hcd != NULL && hcd->driver != NULL && hcd->driver->reset)
+				ret = hcd->driver->reset(hcd);
+			if (ret)
+				printk("run HC_RESET fail ...\n");
+		}
+
+	break;
+	case TEST_TEST_J:
+	case TEST_TEST_K:
+	case TEST_TEST_SE0_NAK:
+	case TEST_TEST_PACKET:
+	case TEST_TEST_FORCE_ENABLE:
+		usb_autoresume_device(udev);
+		printk("run USB_PORT_FEAT_TEST mode %d to port %d ...\n", test_case, port1);
+		hub_set_port_feature(udev,(test_case << 8) | port1, USB_PORT_FEAT_TEST);
+
+	break;
+	case TEST_SUSPEND_RESUME:
+		printk("run TEST_SUSPEND_RESUME to the port %d of the hub ...\n", port1);
+		msleep(15000);
+		printk("set USB_PORT_FEAT_SUSPEND to the port %d of the hub ...\n", port1);
+		hub_set_port_feature(udev, port1, USB_PORT_FEAT_SUSPEND);
+		printk("set OK !!!\n");
+		msleep(15000);
+		printk("clear USB_PORT_FEAT_SUSPEND to the port %d of the hub ...\n", port1);
+		hub_clear_port_feature(udev, port1, USB_PORT_FEAT_SUSPEND);
+		printk("clear OK !!!\n");
+		{
+			printk("get_port_status port %d of the hub ...\n", port1);
+			struct usb_port_status data;
+			msleep(USB_RESUME_TIMEOUT);
+			get_port_status(udev, port1, &data);
+		}
+	break;
+	case TEST_SINGLE_STEP_GET_DEVICE_DESCRIPTOR:
+		printk("run SINGLE_STEP_GET_DEVICE_DESCRIPTOR to the port %d of the hub ...\n", port1);
+		int i, size = 0x12;
+		unsigned char		*data;
+		data = (unsigned char*)kmalloc(size, GFP_KERNEL);
+		if (!data)
+			return -ENOMEM;
+		memset (data, 0, size);
+		get_hub_descriptor_port(udev, data, size, port1);
+
+		printk(" get device descriptor\n");
+		for( i = 0; i < size; i++)
+		{
+			printk(" %.2x", data[i]);
+			if((i % 15) == 0 && (i != 0))
+				printk("\n<1>");
+		}
+		printk("\n");
+
+		kfree(data);
+
+	break;
+	case TEST_PORT_RESET:
+		printk("run PORT_RESET (%d) to port %d ...\n", test_case, port1);
+		hub_clear_port_feature(udev, port1, USB_PORT_FEAT_POWER);
+		msleep(1000);
+		hub_set_port_feature(udev, port1, USB_PORT_FEAT_POWER);
+
+	break;
+	default:
+		printk("error test_case %d !!!\n", test_case);
+	break;
+	}
+
+	return (value < 0) ? value : count;
+}
+static DEVICE_ATTR(runTestMode, S_IRUGO | S_IWUSR,
+		show_runTestMode, set_runTestMode);
+#endif /* CONFIG_USB_RTK_HCD_TEST_MODE */
 
 static struct attribute *dev_attrs[] = {
 	/* current configuration's attributes */
@@ -786,6 +972,9 @@ static ssize_t remove_store(struct device *dev, struct device_attribute *attr,
 	&dev_attr_remove.attr,
 	&dev_attr_removable.attr,
 	&dev_attr_ltm_capable.attr,
+#ifdef CONFIG_USB_RTK_HCD_TEST_MODE
+	&dev_attr_runTestMode.attr,
+#endif // CONFIG_USB_RTK_HCD_TEST_MODE
 	NULL,
 };
 static struct attribute_group dev_attr_grp = {
diff --git a/drivers/usb/dwc3/Kconfig b/drivers/usb/dwc3/Kconfig
index b97cde7..3252653 100644
--- a/drivers/usb/dwc3/Kconfig
+++ b/drivers/usb/dwc3/Kconfig
@@ -49,6 +49,28 @@ endchoice
 
 comment "Platform Glue Driver Support"
 
+config USB_DWC3_RTK
+	tristate "Realtek DWC3 Platform Driver"
+	default USB_DWC3
+	select RTK_USB2PHY
+	select RTK_USB3PHY
+	select USB_RTK_CTRL_MANAGER
+	help
+	  RTK SoCs with DesignWare Core USB3 IP inside,
+	  say 'Y' or 'M' if you have such device.
+
+config USB_RTK_DWC3_DRD_MODE
+	bool "RTK DWC3 DRD (dynamical host/device mode switch)"
+	depends on USB_DWC3_DUAL_ROLE
+	help
+		Support Realtek dwc3 drd type c dynamical host/device mode switch
+
+config USB_TYPE_C_RTK_RTS5400
+	bool "RTK Type C Controller RTS5400"
+	depends on USB_RTK_DWC3_DRD_MODE
+	help
+		Support Realtek type c controller via RTS5400
+
 config USB_DWC3_OMAP
 	tristate "Texas Instruments OMAP5 and similar Platforms"
 	depends on EXTCON && (ARCH_OMAP2PLUS || COMPILE_TEST)
diff --git a/drivers/usb/dwc3/Makefile b/drivers/usb/dwc3/Makefile
index 22420e1..b6afc4c 100644
--- a/drivers/usb/dwc3/Makefile
+++ b/drivers/usb/dwc3/Makefile
@@ -39,3 +39,7 @@ obj-$(CONFIG_USB_DWC3_PCI)		+= dwc3-pci.o
 obj-$(CONFIG_USB_DWC3_KEYSTONE)		+= dwc3-keystone.o
 obj-$(CONFIG_USB_DWC3_OF_SIMPLE)	+= dwc3-of-simple.o
 obj-$(CONFIG_USB_DWC3_ST)		+= dwc3-st.o
+obj-$(CONFIG_USB_DWC3_RTK)		+= dwc3-rtk.o
+obj-$(CONFIG_USB_DWC3_RTK)		+= dwc3-rtk-type_c.o
+obj-$(CONFIG_USB_RTK_DWC3_DRD_MODE)			+= dwc3-rtk-drd.o
+obj-$(CONFIG_USB_TYPE_C_RTK_RTS5400) += rtk-rts5400.o
diff --git a/drivers/usb/dwc3/core.c b/drivers/usb/dwc3/core.c
index 53b26e9..a1321f2 100644
--- a/drivers/usb/dwc3/core.c
+++ b/drivers/usb/dwc3/core.c
@@ -41,6 +41,14 @@
 #include <linux/usb/of.h>
 #include <linux/usb/otg.h>
 
+#ifdef CONFIG_USB_DWC3_RTK
+#include <linux/of_address.h>
+#endif
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#include <linux/suspend.h>
+#endif
+
 #include "core.h"
 #include "gadget.h"
 #include "io.h"
@@ -337,6 +345,28 @@ static int dwc3_event_buffers_setup(struct dwc3 *dwc)
 	return 0;
 }
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+int rtk_dwc3_drd_core_soft_reset(struct dwc3 *dwc)
+{
+	int ret;
+	u32 reg;
+
+	reg = dwc3_readl(dwc->regs, DWC3_GCTL);
+	dwc3_writel(dwc->regs, DWC3_GCTL, reg | DWC3_GCTL_DSBLCLKGTNG);
+
+	ret = dwc3_core_soft_reset(dwc);
+
+	dwc3_writel(dwc->regs, DWC3_GCTL, reg);
+
+	return ret;
+}
+
+int rtk_dwc3_drd_event_buffers_setup(struct dwc3 *dwc)
+{
+	return dwc3_event_buffers_setup(dwc);
+}
+#endif
+
 static void dwc3_event_buffers_cleanup(struct dwc3 *dwc)
 {
 	struct dwc3_event_buffer	*evt;
@@ -786,6 +816,53 @@ static int dwc3_core_init(struct dwc3 *dwc)
 		dwc3_writel(dwc->regs, DWC3_GUCTL2, reg);
 	}
 
+#ifdef CONFIG_USB_DWC3_RTK
+	/* workaround: to avoid transaction error and cause port reset
+	 * we enable threshold control for TX/RX
+	 * [Dev_Fix] Enable DWC3 threshold control for USB compatibility issue
+	 * commit 77f116ba77cc089ee2a6ceca1d2aa496b39c98ba
+	 * [Dev_Fix] change RX threshold packet count from 1 to 3, it will get better performance
+	 * commit fe8905c2112f899f9ec3ddbfd83e0f183d3fbf7d
+	 * [DEV_FIX] In case there may have transaction error once system bus busy
+	 * commit b36294740c5cf66932c0fec429f4c5399e26f591
+	 * */
+#define RX_THRESHOLD_EN			(1<<29)
+#define RX_PKT_CNT(n)			(n<<24)
+#define RX_MAX_BURST_SZ(n)		(n<<19)
+
+	dwc3_writel(dwc->regs, DWC3_GTXTHRCFG, 0x01010000);
+	dwc3_writel(dwc->regs, DWC3_GRXTHRCFG,  RX_THRESHOLD_EN  |
+											RX_PKT_CNT(3)    |
+											RX_MAX_BURST_SZ(3));
+	dwc3_writel(dwc->regs, DWC3_GUCTL,
+					dwc3_readl(dwc->regs, DWC3_GUCTL) | (1<<14));   // enable auto retry
+
+	/* disable SS park modde */
+	if (dwc->dis_ss_park_mode)
+		dwc3_writel(dwc->regs, DWC3_GUCTL1,
+				dwc3_readl(dwc->regs, DWC3_GUCTL1) | (1<<17));
+
+	if (dwc->dis_hs_park_mode)
+		dwc3_writel(dwc->regs, DWC3_GUCTL1,
+				dwc3_readl(dwc->regs, DWC3_GUCTL1) | (1<<16));
+
+	if (dwc->dev_force_20_clk_for30_clk)
+		dwc3_writel(dwc->regs, DWC3_GUCTL1,
+			    dwc3_readl(dwc->regs, DWC3_GUCTL1) | (1<<26));
+
+	if (dwc->usb3_ssic_enable)
+		dwc3_writel(dwc->regs, DWC3_GUSB3PIPECTL(0),
+			    dwc3_readl(dwc->regs, DWC3_GUSB3PIPECTL(0)) |
+			         DWC3_GUSB3PIPECTL_SSICEn);
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (dwc->revision >= DWC3_REVISION_300A)
+		dwc3_writel(dwc->regs, DWC3_DEV_IMOD,
+					dwc3_readl(dwc->regs, DWC3_DEV_IMOD) | DWC3_DEVICE_IMODI(0x1));
+#endif
+
+#endif
+
 	return 0;
 
 err4:
@@ -977,18 +1054,34 @@ static int dwc3_probe(struct platform_device *pdev)
 
 	res->start += DWC3_GLOBALS_REGS_START;
 
+#ifdef CONFIG_USB_DWC3_RTK
+	/* due to rtk dwc3 ip DWC3_GLOBALS_REGS_START is not standard (0xc100)
+	 * we need to fixed it
+	 */
+	regs = of_iomap(dev->of_node, 0);
+	regs += 0x8100;
+	dev_info(dev, "rtk dwc3 fixed dwc3 globals register start address 0x%p\n", regs);
+#else
 	/*
 	 * Request memory region but exclude xHCI regs,
 	 * since it will be requested by the xhci-plat driver.
 	 */
 	regs = devm_ioremap_resource(dev, res);
+#endif
 	if (IS_ERR(regs)) {
 		ret = PTR_ERR(regs);
 		goto err0;
 	}
 
 	dwc->regs	= regs;
+#ifdef CONFIG_USB_DWC3_RTK
+	/* due to rtk dwc3 ip DWC3_GLOBALS_REGS_START is not standard (0xc100)
+	 * we need to fixed it
+	 */
+	dwc->regs_size	= resource_size(res) - 0x8100;
+#else
 	dwc->regs_size	= resource_size(res);
+#endif
 
 	/* default to highest possible threshold */
 	lpm_nyet_threshold = 0xff;
@@ -1045,6 +1138,16 @@ static int dwc3_probe(struct platform_device *pdev)
 				"snps,dis-u2-freeclk-exists-quirk");
 	dwc->dis_del_phy_power_chg_quirk = device_property_read_bool(dev,
 				"snps,dis-del-phy-power-chg-quirk");
+#ifdef CONFIG_USB_DWC3_RTK
+		dwc->dis_ss_park_mode = device_property_read_bool(dev,
+				"snps,dis_ss_park_mode");
+		dwc->dis_hs_park_mode = device_property_read_bool(dev,
+				"snps,dis_hs_park_mode");
+		dwc->dev_force_20_clk_for30_clk = device_property_read_bool(dev,
+				"snps,dev_force_20_clk_for30_clk");
+		dwc->usb3_ssic_enable = device_property_read_bool(dev,
+				"snps,usb3_ssic_enable");
+#endif
 
 	dwc->tx_de_emphasis_quirk = device_property_read_bool(dev,
 				"snps,tx_de_emphasis_quirk");
@@ -1292,7 +1395,6 @@ static int dwc3_runtime_resume(struct device *dev)
 	ret = dwc3_resume_common(dwc);
 	if (ret)
 		return ret;
-
 	switch (dwc->dr_mode) {
 	case USB_DR_MODE_PERIPHERAL:
 	case USB_DR_MODE_OTG:
@@ -1334,25 +1436,107 @@ static int dwc3_runtime_idle(struct device *dev)
 #endif /* CONFIG_PM */
 
 #ifdef CONFIG_PM_SLEEP
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+/* [DEV_FIX]implement New USB reset mechanism with CRT reset to workaround any HW or IP issues
+ * commit 319ff9f5c298b94517a10d4ced59812b54994347
+ */
+static int dwc3_suspend(struct device *dev);
+int RTK_dwc3_suspend(struct device *dev)
+{
+	return dwc3_suspend(dev);
+}
+#endif
+
 static int dwc3_suspend(struct device *dev)
 {
 	struct dwc3	*dwc = dev_get_drvdata(dev);
 	int		ret;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	dev_info(dev, "[USB] Enter %s", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		return 0;
+	}
+	//For suspend mode
+	dev_info(dev,  "[USB] %s Suspend mode\n", __func__);
+
+#endif
+
 	ret = dwc3_suspend_common(dwc);
 	if (ret)
 		return ret;
 
 	pinctrl_pm_select_sleep_state(dev);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	dev_info(dev, "[USB] Exit %s", __func__);
+#endif
+
 	return 0;
 }
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+/* [DEV_FIX]implement New USB reset mechanism with CRT reset to workaround any HW or IP issues
+ * commit 319ff9f5c298b94517a10d4ced59812b54994347
+ */
+static int dwc3_resume(struct device *dev);
+int RTK_dwc3_resume(struct device *dev)
+{
+	return dwc3_resume(dev);
+}
+#endif
+
 static int dwc3_resume(struct device *dev)
 {
 	struct dwc3	*dwc = dev_get_drvdata(dev);
 	int		ret;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	dev_info(dev, "[USB] Enter %s", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		return 0;
+	}
+	//For suspend mode
+	dev_info(dev,  "[USB] %s Suspend mode\n", __func__);
+#endif
+
+#ifdef CONFIG_USB_DWC3_RTK
+	/* workaround: to avoid transaction error and cause port reset
+	 * we enable threshold control for TX/RX
+	 * [Dev_Fix] Enable DWC3 threshold control for USB compatibility issue
+	 * commit 77f116ba77cc089ee2a6ceca1d2aa496b39c98ba
+	 * [Dev_Fix] change RX threshold packet count from 1 to 3,
+	 * it will get better performance
+	 * commit fe8905c2112f899f9ec3ddbfd83e0f183d3fbf7d
+	 * [DEV_FIX] In case there may have transaction error once system bus busy
+	 * commit b36294740c5cf66932c0fec429f4c5399e26f591
+	 * */
+#define RX_THRESHOLD_EN			(1<<29)
+#define RX_PKT_CNT(n)			(n<<24)
+#define RX_MAX_BURST_SZ(n)		(n<<19)
+
+	dwc3_writel(dwc->regs, DWC3_GTXTHRCFG, 0x01010000);
+	dwc3_writel(dwc->regs, DWC3_GRXTHRCFG,  RX_THRESHOLD_EN  |
+											RX_PKT_CNT(3)    |
+											RX_MAX_BURST_SZ(3));
+	// enable auto retry
+	dwc3_writel(dwc->regs, DWC3_GUCTL,
+					dwc3_readl(dwc->regs, DWC3_GUCTL) | (1<<14));
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (dwc->revision >= DWC3_REVISION_300A)
+		dwc3_writel(dwc->regs, DWC3_DEV_IMOD,
+			    dwc3_readl(dwc->regs, DWC3_DEV_IMOD) |
+			        DWC3_DEVICE_IMODI(0x1));
+#endif
+
+#endif
+
 	pinctrl_pm_select_default_state(dev);
 
 	ret = dwc3_resume_common(dwc);
@@ -1363,6 +1547,10 @@ static int dwc3_resume(struct device *dev)
 	pm_runtime_set_active(dev);
 	pm_runtime_enable(dev);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+out:
+	dev_info(dev, "[USB] Exit %s", __func__);
+#endif
 	return 0;
 }
 #endif /* CONFIG_PM_SLEEP */
diff --git a/drivers/usb/dwc3/core.h b/drivers/usb/dwc3/core.h
index affb3d7..878b35c 100644
--- a/drivers/usb/dwc3/core.h
+++ b/drivers/usb/dwc3/core.h
@@ -145,6 +145,8 @@
 #define DWC3_DEPCMDPAR0		0x08
 #define DWC3_DEPCMD		0x0c
 
+#define DWC3_DEV_IMOD	0xca00
+
 /* OTG Registers */
 #define DWC3_OCFG		0xcc00
 #define DWC3_OCTL		0xcc04
@@ -234,6 +236,9 @@
 #define DWC3_GUSB3PIPECTL_SUSPHY	(1 << 17)
 #define DWC3_GUSB3PIPECTL_LFPSFILT	(1 << 9)
 #define DWC3_GUSB3PIPECTL_RX_DETOPOLL	(1 << 8)
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#define DWC3_GUSB3PIPECTL_SSICEn	(1 << 7)
+#endif
 #define DWC3_GUSB3PIPECTL_TX_DEEPH_MASK	DWC3_GUSB3PIPECTL_TX_DEEPH(3)
 #define DWC3_GUSB3PIPECTL_TX_DEEPH(n)	((n) << 1)
 
@@ -291,6 +296,9 @@
 #define DWC3_GHWPARAMS7_RAM1_DEPTH(n)	((n) & 0xffff)
 #define DWC3_GHWPARAMS7_RAM2_DEPTH(n)	(((n) >> 16) & 0xffff)
 
+/* Global GEVNTCOUNT EVNT_HANDLER_BUSY*/
+#define DWC3_EVNT_HANDLER_BUSY		(1 << 31)
+
 /* Global Frame Length Adjustment Register */
 #define DWC3_GFLADJ_30MHZ_SDBND_SEL		(1 << 7)
 #define DWC3_GFLADJ_30MHZ_MASK			0x3f
@@ -459,6 +467,9 @@
 #define DWC3_DEPCMD_TYPE_BULK		2
 #define DWC3_DEPCMD_TYPE_INTR		3
 
+#define DWC3_DEVICE_IMODC(n)		((0xffff & (n)) << 16)
+#define DWC3_DEVICE_IMODI(n)		((0xffff & (n)))
+
 /* Structures */
 
 struct dwc3_trb;
@@ -878,6 +889,14 @@ struct dwc3 {
 
 	u32			fladj;
 	u32			irq_gadget;
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	bool has_gadget;
+	bool has_xhci;
+#endif
+#endif
+
 	u32			nr_scratch;
 	u32			u1u2;
 	u32			maximum_speed;
@@ -976,7 +995,14 @@ struct dwc3 {
 	unsigned		dis_rxdet_inp3_quirk:1;
 	unsigned		dis_u2_freeclk_exists_quirk:1;
 	unsigned		dis_del_phy_power_chg_quirk:1;
-
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_USB_DWC3_RTK
+	unsigned		dis_ss_park_mode:1;
+	unsigned		dis_hs_park_mode:1;
+	unsigned		dev_force_20_clk_for30_clk:1;
+	unsigned		usb3_ssic_enable:1;
+#endif
+#endif
 	unsigned		tx_de_emphasis_quirk:1;
 	unsigned		tx_de_emphasis:2;
 };
diff --git a/drivers/usb/dwc3/debugfs.c b/drivers/usb/dwc3/debugfs.c
index 31926dd..8210f82 100644
--- a/drivers/usb/dwc3/debugfs.c
+++ b/drivers/usb/dwc3/debugfs.c
@@ -241,6 +241,9 @@
 	dump_register(DGCMDPAR),
 	dump_register(DGCMD),
 	dump_register(DALEPENA),
+#ifdef CONFIG_USB_DWC3_RTK
+	dump_register(DEV_IMOD),
+#endif
 
 	dump_ep_register_set(0),
 	dump_ep_register_set(1),
@@ -848,7 +851,13 @@ void dwc3_debugfs_init(struct dwc3 *dwc)
 	struct dentry		*root;
 	struct dentry           *file;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* move debugfs to /sys/kernel/debug/usb/ */
+	root = debugfs_create_dir(dev_name(dwc->dev), usb_debug_root);
+#else
 	root = debugfs_create_dir(dev_name(dwc->dev), NULL);
+#endif
+
 	if (IS_ERR_OR_NULL(root)) {
 		if (!root)
 			dev_err(dwc->dev, "Can't create debugfs root\n");
diff --git a/drivers/usb/dwc3/dwc3-rtk-drd.c b/drivers/usb/dwc3/dwc3-rtk-drd.c
new file mode 100644
index 00000000..f13f7d1
--- /dev/null
+++ b/drivers/usb/dwc3/dwc3-rtk-drd.c
@@ -0,0 +1,209 @@
+/**
+ * dwc3-rtk-drd.c - Realtek DWC3 Specific Glue layer
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/kernel.h>
+#include <linux/slab.h>
+#include <linux/spinlock.h>
+#include <linux/platform_device.h>
+#include <linux/pm_runtime.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/io.h>
+#include <linux/list.h>
+#include <linux/delay.h>
+#include <linux/dma-mapping.h>
+#include <linux/of.h>
+
+#include <linux/usb/ch9.h>
+#include <linux/usb/gadget.h>
+#include <linux/usb/composite.h>
+
+#include "core.h"
+#include "gadget.h"
+#include "io.h"
+#include "dwc3-rtk-drd.h"
+
+extern int rtk_dwc3_drd_core_soft_reset(struct dwc3 *dwc);
+extern int rtk_dwc3_drd_event_buffers_setup(struct dwc3 *dwc);
+extern int dwc3_gadget_restart(struct dwc3 *dwc);
+extern int dwc3_gadget_stop_on_switch(struct dwc3 *dwc);
+
+
+struct usb_gadget_driver *rtk_dwc3_set_and_get_usb_gadget_driver(
+	    struct usb_gadget_driver *driver)
+{
+	static struct usb_gadget_driver *gadget_driver = NULL;
+	struct usb_gadget_driver *local_driver = gadget_driver;
+
+	gadget_driver = driver;
+
+	return local_driver;
+}
+EXPORT_SYMBOL_GPL(rtk_dwc3_set_and_get_usb_gadget_driver);
+
+int dwc3_drd_to_host(struct dwc3 *dwc)
+{
+	int ret;
+	unsigned long timeout;
+	//unsigned long flags = 0;
+	u32 reg;
+
+	dev_info(dwc->dev, "%s START....", __func__);
+	if (dwc->has_gadget) {
+		if (dwc->gadget_driver != NULL) {
+			rtk_dwc3_set_and_get_usb_gadget_driver(dwc->gadget_driver);
+			usb_gadget_unregister_driver(dwc->gadget_driver);
+		}
+		dwc3_gadget_exit(dwc);
+	}
+	wmb();
+
+	if (dwc->has_xhci) {
+		dev_info(dwc->dev, "%s Now is host", __func__);
+		return 0;
+	}
+
+	/* issue device SoftReset too */
+	timeout = jiffies + msecs_to_jiffies(500);
+	dwc3_writel(dwc->regs, DWC3_DCTL, DWC3_DCTL_CSFTRST);
+	do {
+		reg = dwc3_readl(dwc->regs, DWC3_DCTL);
+		if (!(reg & DWC3_DCTL_CSFTRST))
+			break;
+
+		if (time_after(jiffies, timeout)) {
+			dev_err(dwc->dev, "Reset Timed Out\n");
+			ret = -ETIMEDOUT;
+			goto err0;
+		}
+
+		cpu_relax();
+	} while (true);
+
+	dev_info(dwc->dev, "%s: call dwc3_core_soft_reset\n", __func__);
+	ret = rtk_dwc3_drd_core_soft_reset(dwc);
+	if (ret) {
+		dev_err(dwc->dev, "soft reset failed\n");
+		goto err0;
+	}
+
+//	spin_lock_irqsave(&dwc->lock, flags);
+	ret = rtk_dwc3_drd_event_buffers_setup(dwc);
+	if (ret) {
+		dev_err(dwc->dev, "failed to setup event buffers\n");
+		goto err0;
+	}
+
+	dwc3_set_mode(dwc, DWC3_GCTL_PRTCAP_HOST);
+
+	ret = dwc3_host_init(dwc);
+	if (ret) {
+		dev_err(dwc->dev, "failed to init host\n");
+		goto err0;
+	}
+err0:
+//	spin_unlock_irqrestore(&dwc->lock, flags);
+	dev_info(dwc->dev, "%s END....", __func__);
+	return ret;
+}
+
+int dwc3_drd_to_device(struct dwc3 *dwc)
+{
+	int ret;
+	unsigned long timeout, flags = 0;
+	u32 reg;
+
+	dev_info(dwc->dev, "%s START....", __func__);
+
+	if (dwc->has_xhci) {
+		dev_info(dwc->dev, "%s dwc3_host_exit", __func__);
+		dwc3_host_exit(dwc);
+	}
+	wmb();
+
+	if (dwc->has_gadget) {
+		dev_info(dwc->dev, "%s Now is gadget", __func__);
+		return 0;
+	}
+
+	/* issue device SoftReset too */
+	timeout = jiffies + msecs_to_jiffies(500);
+	dwc3_writel(dwc->regs, DWC3_DCTL, DWC3_DCTL_CSFTRST);
+	do {
+		reg = dwc3_readl(dwc->regs, DWC3_DCTL);
+		if (!(reg & DWC3_DCTL_CSFTRST))
+			break;
+
+		if (time_after(jiffies, timeout)) {
+			dev_err(dwc->dev, "Reset Timed Out\n");
+			ret = -ETIMEDOUT;
+			goto err0;
+		}
+
+		cpu_relax();
+	} while (true);
+
+	ret = rtk_dwc3_drd_core_soft_reset(dwc);
+	if (ret) {
+		dev_err(dwc->dev, "soft reset failed\n");
+		goto err0;
+	}
+
+	spin_lock_irqsave(&dwc->lock, flags);
+
+	ret = rtk_dwc3_drd_event_buffers_setup(dwc);
+	if (ret) {
+		dev_err(dwc->dev, "failed to setup event buffers\n");
+		spin_unlock_irqrestore(&dwc->lock, flags);
+		goto err0;
+	}
+
+	dwc3_set_mode(dwc, DWC3_GCTL_PRTCAP_DEVICE);
+
+	spin_unlock_irqrestore(&dwc->lock, flags);
+
+	ret = dwc3_gadget_init(dwc);
+	if (ret) {
+		dev_err(dwc->dev, "failed to init gadget\n");
+		goto err0;
+	} else {
+		struct usb_gadget_driver *driver =
+			    rtk_dwc3_set_and_get_usb_gadget_driver(NULL);
+		if (driver)
+			ret = usb_gadget_probe_driver(driver);
+	}
+	if (ret) {
+		dev_err(dwc->dev, "failed to usb_gadget probe gadget_driver\n");
+		goto err0;
+	}
+err0:
+	dev_info(dwc->dev, "%s END....", __func__);
+	return ret;
+}
+
+int dwc3_drd_to_stop_all(struct dwc3 *dwc)
+{
+	int ret = 0;
+
+	dev_info(dwc->dev, "%s START....", __func__);
+	if (dwc->has_xhci)
+		dwc3_host_exit(dwc);
+	if (dwc->has_gadget) {
+		if (dwc->gadget_driver != NULL) {
+			rtk_dwc3_set_and_get_usb_gadget_driver(dwc->gadget_driver);
+			usb_gadget_unregister_driver(dwc->gadget_driver);
+		}
+		dwc3_gadget_exit(dwc);
+	}
+	wmb();
+	dev_info(dwc->dev, "%s END....", __func__);
+	return ret;
+}
diff --git a/drivers/usb/dwc3/dwc3-rtk-drd.h b/drivers/usb/dwc3/dwc3-rtk-drd.h
new file mode 100644
index 00000000..9a9bb3b
--- /dev/null
+++ b/drivers/usb/dwc3/dwc3-rtk-drd.h
@@ -0,0 +1,24 @@
+/**
+ * dwc3-rtk-drd.h - Realtek DWC3 Specific Glue layer
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __DRIVERS_USB_DWC3_RTK_DRD_H
+#define __DRIVERS_USB_DWC3_RTK_DRD_H
+
+#include "core.h"
+#include "gadget.h"
+#include "io.h"
+
+extern int dwc3_drd_to_host(struct dwc3 *dwc);
+extern int dwc3_drd_to_device(struct dwc3 *dwc);
+extern int dwc3_drd_to_stop_all(struct dwc3 *dwc);
+
+#endif /* __DRIVERS_USB_DWC3_RTK_CORE_H */
+
diff --git a/drivers/usb/dwc3/dwc3-rtk-type_c.c b/drivers/usb/dwc3/dwc3-rtk-type_c.c
new file mode 100644
index 00000000..5bf8c56
--- /dev/null
+++ b/drivers/usb/dwc3/dwc3-rtk-type_c.c
@@ -0,0 +1,2301 @@
+/**
+ *  * dwc3-rtk-type_c.c - Realtek DWC3 Type C driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#undef DEBUG
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/slab.h>
+#include <linux/platform_device.h>
+#include <linux/of.h>
+#include <linux/of_platform.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/of_gpio.h>
+#include <linux/io.h>
+#include <linux/interrupt.h>
+#include <linux/usb/otg.h>
+#include <linux/syscalls.h>
+#include <linux/suspend.h>
+#include <soc/realtek/rtk_chip.h>
+
+#include "core.h"
+#include "dwc3-rtk-drd.h"
+
+#ifdef CONFIG_DUAL_ROLE_USB_INTF
+#include <linux/usb/class-dual-role.h>
+#endif
+
+#ifdef CONFIG_USB_TYPE_C_RTK_RTS5400
+extern bool rtk_rts5400_is_UFP_attached(void);
+extern bool rtk_rts5400_is_enabled(void);
+extern int rtk_rts5400_set_type_c_soft_reset(void);
+#endif
+
+extern int rtk_usb_manager_is_iso_mode(struct device *usb_dev);
+extern int rtk_usb_manager_schedule_work(struct device *usb_dev,
+	    struct work_struct *work);
+extern int rtk_usb_type_c_init(struct device *type_c_dev);
+extern int rtk_usb_type_c_power_on_off(struct device *type_c_dev, bool on);
+extern int rtk_usb_type_c_plug_config(struct device *type_c_dev,
+	    int dr_mode, int cc);
+
+struct type_c_data {
+	void __iomem *wrap_base;
+	void __iomem *type_c_reg_base;
+	struct device *dev;
+
+	enum rtd_chip_id chip_id;
+	enum rtd_chip_revision chip_revision;
+
+	/* rd control GPIO only for rtd129x*/
+	unsigned int rd_ctrl_gpio;
+
+	/*Parameters*/
+	u32 cc1_rp;
+	u32 cc1_rp_code;
+	u32 cc1_rd_code;
+	u32 cc1_vref_ufp;
+	u32 cc1_vref_dfp_usb;
+	u32 cc1_vref_dfp_1_5;
+	u32 cc1_vref_dfp_3_0;
+	u32 cc2_rp;
+	u32 cc2_rp_code;
+	u32 cc2_rd_code;
+	u32 cc2_vref_ufp;
+	u32 cc2_vref_dfp_usb;
+	u32 cc2_vref_dfp_1_5;
+	u32 cc2_vref_dfp_3_0;
+	u32 debounce_val;// 1b,1us 7f,4.7us
+	int rd_config;
+#define INTERNAL_Rd 1
+#define EXTERNAL_Rd 0
+	int cc_dfp_mode;
+
+	/* Host/Device mode status */
+	struct dwc3 *dwc;
+	int dwc3_mode; /* define by dwc3 driver, and it is fixed */
+	bool support_drd_mode; /* if support Host/device switch */
+	int cur_mode; /* current mode in type c cc status */
+	bool is_role_swap; /* if in role swap */
+#define ROLE_SWAP 1
+#define NO_ROLE_SWAP 0
+#define TO_SWAP_ROLE 1
+#define TO_RESTORE_ROLE 0
+
+	// type_c state
+	int connect_change;
+#define CONNECT_CHANGE 1
+#define CONNECT_NO_CHANGE 0
+	int in_host_mode;
+#define IN_HOST_MODE 1
+#define IN_DEVICE_MODE 0
+	int is_attach;
+#define IN_ATTACH 1
+#define TO_ATTACH 1
+#define IN_DETACH 0
+#define TO_DETACH 0
+	int at_cc1;
+#define AT_CC1 1
+#define AT_CC2 0
+
+	u32 int_status;
+	u32 cc_status;
+	spinlock_t		lock;
+	struct delayed_work   delayed_work;
+
+	struct work_struct start_work;
+
+	/* boot time check device mode transfer to host mode*/
+	bool check_at_boot;
+	int boot_check_time;
+	struct delayed_work boot_check_work;
+
+	/* A sw debounce to filter cc signal */
+	bool filter_config_channel_signal;
+
+	bool debug;
+#ifdef CONFIG_DYNAMIC_DEBUG
+	struct dentry		*debug_dir;
+#endif
+#ifdef CONFIG_DUAL_ROLE_USB_INTF
+	struct dual_role_phy_instance *drp;
+#endif
+};
+
+// wrapper register offset for USB2 PHY
+#define USB2_PHY_reg  0x70
+#define USB2_PHY_SWITCH_MASK 0x707
+#define USB2_PHY_SWITCH_DEVICE 0x0
+#define USB2_PHY_SWITCH_HOST 0x606
+
+// Type C register offset
+#define USB_TYPEC_CTRL_CC1_0 0x0
+#define USB_TYPEC_CTRL_CC1_1 0x4
+#define USB_TYPEC_CTRL_CC2_0 0x8
+#define USB_TYPEC_CTRL_CC2_1 0xC
+#define USB_TYPEC_STS        0x10
+#define USB_TYPEC_CTRL       0x14
+#define USB_DBUS_PWR_CTRL    0x18
+
+// Bit mapping USB_TYPEC_CTRL_CC1_0 and USB_TYPEC_CTRL_CC2_0
+#define EN_EXTERNAL_RD BIT(29) /* only for rtd1395 */
+#define enable_cc1 0x1
+#define enable_cc2 0x2
+#define disable_cc 0x0
+
+#define rp4pk_code(val) ((0x1f & val) << 22)
+#define code_rp4pk(val) ((val >> 22) & 0x1f)
+#define rp36k_code(val) ((0x1f & val) << 17)
+#define code_rp36k(val) ((val >> 17) & 0x1f)
+#define rp12k_code(val) ((0x1f & val) << 12)
+#define code_rp12k(val) ((val >> 12) & 0x1f)
+#define rd_code(val) ((0x1f & val) << 7)
+#define code_rd(val) ((val >> 7) & 0x1f)
+#define cc_mode(val) ((0x3 & val) << 5)
+#define En_rp4p7k BIT(4)
+#define En_rp36k BIT(3)
+#define En_rp12k BIT(2)
+#define En_rd BIT(1)
+#define En_cc_det BIT(0)
+
+#define CC_MODE_UFP 0x0
+#define CC_MODE_DFP_USB 0x1
+#define CC_MODE_DFP_1_5 0x2
+#define CC_MODE_DFP_3_0 0x3
+
+// Bit mapping USB_TYPEC_CTRL_CC1_1 and USB_TYPEC_CTRL_CC2_1
+#define vref_2p6v(val) ((0x7 & val) << 26)
+#define vref_1p23v(val) ((0xf & val) << 22)
+#define vref_0p8v(val) ((0xf & val) << 18)
+#define vref_0p66v(val) ((0xf & val) << 14)
+#define vref_0p4v(val) ((0x7 & val) << 11)
+#define vref_0p2v(val) ((0x7 & val) << 8)
+#define vref_1_1p6v(val) ((0xf & val) << 4)
+#define vref_0_1p6v(val) ((0xf & val) << 0)
+
+#define decode_2p6v(val) ((val >> 26) & 0x7)
+#define decode_1p23v(val) ((val >> 22) & 0xf)
+#define decode_0p8v(val) ((val >> 18) & 0xf)
+#define decode_0p66v(val) ((val >> 14) & 0xf)
+#define decode_0p4v(val) ((val >> 11) & 0x7)
+#define decode_0p2v(val) ((val >> 8) & 0x7)
+#define decode_1_1p6v(val) ((val >> 4) & 0xf)
+#define decode_0_1p6v(val) ((val >> 0) & 0xf)
+// Bit mapping USB_TYPEC_STS
+#define det_sts 0x7
+#define cc1_det_sts (det_sts)
+#define cc2_det_sts (det_sts << 3)
+#define det_sts_ra 0x1
+#define det_sts_rd 0x3
+#define det_sts_rp 0x1
+#define cc1_det_sts_ra (det_sts_ra)
+#define cc1_det_sts_rd (det_sts_rd)
+#define cc1_det_sts_rp (det_sts_rp)
+#define cc2_det_sts_ra (det_sts_ra << 3)
+#define cc2_det_sts_rd (det_sts_rd << 3)
+#define cc2_det_sts_rp (det_sts_rp << 3)
+
+// Bit mapping USB_TYPEC_CTRL
+#define cc2_int_en BIT(11)
+#define cc1_int_en BIT(10)
+#define cc2_int_sts BIT(9)
+#define cc1_int_sts BIT(8)
+#define debounce_time_MASK 0xff
+#define ENABLE_TYPE_C_DETECT (cc1_int_en | cc2_int_en)
+#define all_cc_int_sts (cc1_int_sts | cc2_int_sts)
+
+// Parameter
+#define DETECT_TIME 50 //ms
+
+static void enable_writel(int value, void __iomem *addr)
+{
+	writel(value | readl(addr),  addr);
+}
+
+static void disable_writel(int value, void __iomem *addr)
+{
+	writel(~value & readl(addr),  addr);
+}
+
+static inline int rtk_type_c_init(struct type_c_data *type_c)
+{
+	dev_info(type_c->dev, "%s\n", __func__);
+
+	rtk_usb_type_c_init(type_c->dev);
+}
+
+static inline void switch_type_c_plug_config(struct type_c_data *type_c,
+	    int dr_mode, int cc)
+{
+	dev_info(type_c->dev, "%s dr_mode=%d cc=0x%x\n", __func__, dr_mode, cc);
+
+	rtk_usb_type_c_plug_config(type_c->dev, dr_mode, cc);
+}
+
+static void switch_dwc3_mode(struct type_c_data *type_c, int dr_mode)
+{
+	if (!type_c->support_drd_mode)
+		dr_mode = type_c->dwc3_mode;
+	dev_dbg(type_c->dev, "%s START....", __func__);
+
+	type_c->cur_mode = dr_mode;
+	type_c->dwc->dr_mode = dr_mode;
+
+	switch (dr_mode) {
+	case USB_DR_MODE_PERIPHERAL:
+		dev_info(type_c->dev, "%s dr_mode=USB_DR_MODE_PERIPHERAL\n",
+			    __func__);
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+		dwc3_drd_to_device(type_c->dwc);
+#else
+		dev_err(type_c->dev, "NO add config CONFIG_USB_RTK_DWC3_DRD_MODE");
+#endif
+		mdelay(10);
+		writel(USB2_PHY_SWITCH_DEVICE |
+			    (~USB2_PHY_SWITCH_MASK &
+			    readl(type_c->wrap_base + USB2_PHY_reg)),
+			    type_c->wrap_base + USB2_PHY_reg);
+
+		break;
+	case USB_DR_MODE_HOST:
+		dev_info(type_c->dev, "%s dr_mode=USB_DR_MODE_HOST\n", __func__);
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+		dwc3_drd_to_host(type_c->dwc);
+#else
+		dev_err(type_c->dev, "NO add config CONFIG_USB_RTK_DWC3_DRD_MODE");
+#endif
+		mdelay(10);
+		writel(USB2_PHY_SWITCH_HOST |
+			    (~USB2_PHY_SWITCH_MASK &
+			    readl(type_c->wrap_base + USB2_PHY_reg)),
+			    type_c->wrap_base + USB2_PHY_reg);
+		break;
+	default:
+		dev_info(type_c->dev, "%s dr_mode=%d\n", __func__, dr_mode);
+		//mdelay(10);
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+		dwc3_drd_to_stop_all(type_c->dwc);
+#else
+		dev_err(type_c->dev, "NO add config CONFIG_USB_RTK_DWC3_DRD_MODE");
+#endif
+	}
+	dev_dbg(type_c->dev, "%s END....", __func__);
+}
+
+/* device attached / detached */
+int device_attached(struct type_c_data *type_c, u32 enable_cc)
+{
+	struct device		*dev = type_c->dev;
+	void __iomem *type_c_reg_base = type_c->type_c_reg_base;
+
+	cancel_delayed_work(&type_c->delayed_work);
+
+	switch_type_c_plug_config(type_c, USB_DR_MODE_HOST, enable_cc);
+
+	switch_dwc3_mode(type_c, USB_DR_MODE_HOST);
+
+	dev_info(dev, "%s to enable power\n", __func__);
+	if (rtk_usb_type_c_power_on_off(dev, true))
+		dev_err(dev, "%s to enable type c power Fail\n", __func__);
+	else
+		dev_dbg(dev, "%s to enable type c power OK\n", __func__);
+
+	enable_writel(ENABLE_TYPE_C_DETECT, type_c_reg_base + USB_TYPEC_CTRL);
+	return 0;
+}
+
+int device_detached(struct type_c_data *type_c)
+{
+	struct device		*dev = type_c->dev;
+	void __iomem *type_c_reg_base = type_c->type_c_reg_base;
+
+	disable_writel(ENABLE_TYPE_C_DETECT, type_c_reg_base + USB_TYPEC_CTRL);
+
+	dev_info(dev, "%s to disable power\n", __func__);
+	if (rtk_usb_type_c_power_on_off(dev, false))
+		dev_err(dev, "%s to disable type c power Fail\n", __func__);
+	else
+		dev_dbg(dev, "%s to disable type c power OK\n", __func__);
+
+	switch_type_c_plug_config(type_c, 0, disable_cc);
+
+	msleep(1000);
+
+	switch_dwc3_mode(type_c, 0);
+
+	dev_dbg(dev, "%s start new schedule_delayed_work\n", __func__);
+	schedule_delayed_work(&type_c->delayed_work,
+			msecs_to_jiffies(DETECT_TIME));
+	dev_dbg(dev, "%s ok new schedule_delayed_work\n", __func__);
+
+	return 0;
+}
+
+/* host connect /disconnect*/
+int host_connected(struct type_c_data *type_c, u32 enable_cc)
+{
+	struct device		*dev = type_c->dev;
+	void __iomem *type_c_reg_base = type_c->type_c_reg_base;
+
+	dev_info(dev, "%s: a Host connect\n", __func__);
+
+	cancel_delayed_work(&type_c->delayed_work);
+
+	switch_type_c_plug_config(type_c, USB_DR_MODE_PERIPHERAL, enable_cc);
+
+	switch_dwc3_mode(type_c, USB_DR_MODE_PERIPHERAL);
+
+	enable_writel(ENABLE_TYPE_C_DETECT, type_c_reg_base + USB_TYPEC_CTRL);
+	return 0;
+}
+
+int host_disconnected(struct type_c_data *type_c)
+{
+	struct device		*dev = type_c->dev;
+	void __iomem *type_c_reg_base = type_c->type_c_reg_base;
+
+	dev_info(dev, "%s: a Host disconnect\n", __func__);
+
+	disable_writel(ENABLE_TYPE_C_DETECT, type_c_reg_base + USB_TYPEC_CTRL);
+
+	switch_type_c_plug_config(type_c, 0, disable_cc);
+
+	msleep(1000);
+
+	switch_dwc3_mode(type_c, 0);
+
+	schedule_delayed_work(&type_c->delayed_work, msecs_to_jiffies(DETECT_TIME));
+
+	return 0;
+}
+
+/* detect host device switch */
+static int detect_device(struct type_c_data *type_c)
+{
+	struct device		*dev = type_c->dev;
+	//struct device_node	*node = dev->of_node;
+	void __iomem *type_c_reg_base = type_c->type_c_reg_base;
+	unsigned int gpio = type_c->rd_ctrl_gpio;
+	u32 cc1_config, cc2_config, default_ctrl;
+	int cc_mode_sel = type_c->cc_dfp_mode;
+
+	default_ctrl = readl(type_c_reg_base + USB_TYPEC_CTRL) & debounce_time_MASK;
+	writel(default_ctrl, type_c_reg_base + USB_TYPEC_CTRL);
+
+	disable_writel(En_cc_det, type_c_reg_base + USB_TYPEC_CTRL_CC1_0);
+	disable_writel(En_cc_det, type_c_reg_base + USB_TYPEC_CTRL_CC2_0);
+
+	if (gpio != -1 && gpio_is_valid(gpio)) {
+		if (gpio_direction_output(gpio, 1))
+			dev_err(dev, "%s ERROR rd_ctrl_gpio=1 fail\n", __func__);
+	}
+
+	switch (cc_mode_sel) {
+	case CC_MODE_DFP_USB:
+		writel(type_c->cc1_vref_dfp_usb, type_c_reg_base + USB_TYPEC_CTRL_CC1_1);
+		writel(type_c->cc2_vref_dfp_usb, type_c_reg_base + USB_TYPEC_CTRL_CC2_1);
+		break;
+	case CC_MODE_DFP_1_5:
+		writel(type_c->cc1_vref_dfp_1_5, type_c_reg_base + USB_TYPEC_CTRL_CC1_1);
+		writel(type_c->cc2_vref_dfp_1_5, type_c_reg_base + USB_TYPEC_CTRL_CC2_1);
+		break;
+	case CC_MODE_DFP_3_0:
+		writel(type_c->cc1_vref_dfp_3_0, type_c_reg_base + USB_TYPEC_CTRL_CC1_1);
+		writel(type_c->cc2_vref_dfp_3_0, type_c_reg_base + USB_TYPEC_CTRL_CC2_1);
+		break;
+	default:
+		dev_err(dev, "%s ERROR cc_mode_sel=%d\n", __func__, cc_mode_sel);
+		break;
+	}
+	cc1_config = type_c->cc1_rp | type_c->cc1_rp_code | cc_mode(cc_mode_sel);
+	cc2_config = type_c->cc2_rp | type_c->cc2_rp_code | cc_mode(cc_mode_sel);
+
+	writel(cc1_config, type_c_reg_base + USB_TYPEC_CTRL_CC1_0);
+	writel(cc2_config, type_c_reg_base + USB_TYPEC_CTRL_CC2_0);
+
+	wmb();
+
+	enable_writel(En_cc_det, type_c_reg_base + USB_TYPEC_CTRL_CC1_0);
+	enable_writel(En_cc_det, type_c_reg_base + USB_TYPEC_CTRL_CC2_0);
+
+	return 0;
+}
+
+static int detect_host(struct type_c_data *type_c)
+{
+	struct device		*dev = type_c->dev;
+	//struct device_node	*node = dev->of_node;
+	void __iomem *type_c_reg_base = type_c->type_c_reg_base;
+	unsigned int gpio = type_c->rd_ctrl_gpio;
+	u32 cc1_config, cc2_config, default_ctrl;
+	u32 cc_rd = En_rd;
+
+	if (type_c->check_at_boot || (type_c->rd_config == EXTERNAL_Rd)) {
+		if ((type_c->chip_id & 0xFFF0) == CHIP_ID_RTD129X) {
+			cc_rd = 0;
+		} else if ((type_c->chip_id & 0xFFF0) == CHIP_ID_RTD139X) {
+			dev_info(dev, "%s external Rd is build on chip RTD%x, "
+				    "set EN_EXTERNAL_RD Bit 29\n", __func__, type_c->chip_id);
+			cc_rd = EN_EXTERNAL_RD;
+		}
+	}
+
+	default_ctrl = readl(type_c_reg_base + USB_TYPEC_CTRL) & debounce_time_MASK;
+	writel(default_ctrl, type_c_reg_base + USB_TYPEC_CTRL);
+
+	disable_writel(En_cc_det, type_c_reg_base + USB_TYPEC_CTRL_CC1_0);
+	disable_writel(En_cc_det, type_c_reg_base + USB_TYPEC_CTRL_CC2_0);
+
+	writel(type_c->cc1_vref_ufp, type_c_reg_base + USB_TYPEC_CTRL_CC1_1);
+	writel(type_c->cc2_vref_ufp, type_c_reg_base + USB_TYPEC_CTRL_CC2_1);
+
+	cc1_config = cc_rd | type_c->cc1_rd_code | cc_mode(CC_MODE_UFP);
+	cc2_config = cc_rd | type_c->cc2_rd_code | cc_mode(CC_MODE_UFP);
+
+	writel(cc1_config, type_c_reg_base + USB_TYPEC_CTRL_CC1_0);
+	writel(cc2_config, type_c_reg_base + USB_TYPEC_CTRL_CC2_0);
+
+	if (cc_rd && gpio != -1 && gpio_is_valid(gpio)) {
+		// use internal Rd
+		if (gpio_direction_output(gpio, 1))
+			dev_err(dev, "%s ERROR rd_ctrl_gpio=1 fail\n", __func__);
+	} else if (gpio != -1 && gpio_is_valid(gpio)) {
+		// use external Rd
+		if (gpio_direction_output(gpio, 0))
+			dev_err(dev, "%s ERROR rd_ctrl_gpio=0 fail\n", __func__);
+	}
+	wmb();
+
+	enable_writel(En_cc_det, type_c_reg_base + USB_TYPEC_CTRL_CC1_0);
+	enable_writel(En_cc_det, type_c_reg_base + USB_TYPEC_CTRL_CC2_0);
+
+	return 0;
+}
+
+int host_device_switch_detection(struct type_c_data *type_c)
+{
+	struct device		*dev = type_c->dev;
+	int ret = 0;
+	unsigned long		flags;
+
+	if (type_c->debug)
+		dev_dbg(dev, "ENTER %s", __func__);
+	if (type_c->in_host_mode) {
+		type_c->in_host_mode = IN_DEVICE_MODE;
+		detect_host(type_c);
+		if (type_c->debug)
+			dev_dbg(dev, "Now device mode $$$$");
+	} else {
+		type_c->in_host_mode = IN_HOST_MODE;
+		detect_device(type_c);
+		if (type_c->debug)
+			dev_dbg(dev, "Now host mode   ####");
+	}
+
+	return ret;
+}
+
+int detect_type_c_state(struct type_c_data *type_c)
+{
+	struct device *dev = type_c->dev;
+	u32 int_status, cc_status, cc_status_check;
+	unsigned long		flags;
+
+	spin_lock_irqsave(&type_c->lock, flags);
+
+	int_status = readl(type_c->type_c_reg_base + USB_TYPEC_CTRL);
+	cc_status = readl(type_c->type_c_reg_base + USB_TYPEC_STS);
+
+	type_c->connect_change = CONNECT_NO_CHANGE;
+
+	switch (type_c->in_host_mode) {
+	case IN_HOST_MODE:
+		switch (type_c->is_attach) {
+		case IN_ATTACH:
+			if (((cc_status & cc1_det_sts) == cc1_det_sts) &&
+				    (type_c->at_cc1 == AT_CC1)) {
+				dev_dbg(dev, "IN host mode and cc1 device detach "
+					    "(cc_status=0x%x)", cc_status);
+				type_c->is_attach = TO_DETACH;
+				type_c->connect_change = CONNECT_CHANGE;
+			} else if (((cc_status & cc2_det_sts) == cc2_det_sts) &&
+				    (type_c->at_cc1 == AT_CC2)) {
+				dev_dbg(dev, "IN host mode and cc2 device detach "
+				    "(cc_status=0x%x)", cc_status);
+				type_c->is_attach = TO_DETACH;
+				type_c->connect_change = CONNECT_CHANGE;
+			}
+		break;
+		case IN_DETACH:
+			cc_status_check = readl(type_c->type_c_reg_base + USB_TYPEC_STS);
+			if (cc_status_check != (cc1_det_sts | cc2_det_sts)) {
+				if (in_interrupt()) {
+					mdelay(300);
+				} else {
+					spin_unlock_irqrestore(&type_c->lock, flags);
+					msleep(300);
+					spin_lock_irqsave(&type_c->lock, flags);
+				}
+				cc_status_check = readl(type_c->type_c_reg_base + USB_TYPEC_STS);
+			}
+			if (cc_status != cc_status_check) {
+				dev_warn(dev, "IN_HOST_MODE: cc_status (0x%x) != "
+					    "cc_status_check (0x%x)\n",
+					    cc_status, cc_status_check);
+				cc_status = readl(type_c->type_c_reg_base + USB_TYPEC_STS);
+			}
+
+			if ((cc_status & cc1_det_sts) == cc1_det_sts_rd) {
+				dev_dbg(dev, "IN host mode and cc1 device attach "
+					    "(cc_status=0x%x)", cc_status);
+				type_c->is_attach = TO_ATTACH;
+				type_c->at_cc1 = AT_CC1;
+				type_c->connect_change = CONNECT_CHANGE;
+			} else if ((cc_status & cc2_det_sts) == cc2_det_sts_rd) {
+				dev_dbg(dev, "In host mode and cc2 device attach "
+					    "(cc_status=0x%x)", cc_status);
+				type_c->is_attach = TO_ATTACH;
+				type_c->at_cc1 = AT_CC2;
+				type_c->connect_change = CONNECT_CHANGE;
+			}
+		break;
+		default:
+			dev_err(dev, "IN host_mode and error attach state (is_attach=%d)",
+				    type_c->is_attach);
+		}
+	break;
+	case IN_DEVICE_MODE:
+		switch (type_c->is_attach) {
+		case IN_ATTACH:
+			if (type_c->filter_config_channel_signal &&
+				    ((cc_status & cc1_det_sts) < cc1_det_sts_rp ||
+				     (cc_status & cc2_det_sts) < cc2_det_sts_rp)) {
+				/* Add a sw debounce to filter cc signal sent
+				   from apple pd adapter */
+				if (in_interrupt()) {
+					mdelay(5);
+				} else {
+					spin_unlock_irqrestore(&type_c->lock, flags);
+					msleep(5);
+					spin_lock_irqsave(&type_c->lock, flags);
+				}
+				cc_status_check = readl(type_c->type_c_reg_base + USB_TYPEC_STS);
+
+				if (cc_status != cc_status_check) {
+					dev_dbg(dev, "IN_DEVICE_MODE: cc_status (0x%x) != "
+						    "cc_status_check (0x%x) maybe use a pd adapter\n",
+						    cc_status, cc_status_check);
+					cc_status = cc_status_check;
+				}
+			}
+
+			if ((cc_status & cc1_det_sts) < cc1_det_sts_rp &&
+				    type_c->at_cc1 == AT_CC1) {
+				dev_dbg(dev,"IN device mode and cc1 host disconnect "
+					    "(cc_status=0x%x)", cc_status);
+				type_c->is_attach = TO_DETACH;
+				type_c->connect_change = CONNECT_CHANGE;
+			} else if ((cc_status & cc2_det_sts) < cc2_det_sts_rp &&
+				    type_c->at_cc1 == AT_CC2) {
+				dev_dbg(dev,"IN device mode and cc2 host connect "
+					    "(cc_status=0x%x)", cc_status);
+				type_c->is_attach = TO_DETACH;
+				type_c->connect_change = CONNECT_CHANGE;
+			}
+		break;
+		case IN_DETACH:
+			cc_status_check = readl(type_c->type_c_reg_base + USB_TYPEC_STS);
+			if (cc_status_check != 0x0) {
+				if (in_interrupt()) {
+					mdelay(300);
+				} else {
+					spin_unlock_irqrestore(&type_c->lock, flags);
+					msleep(300);
+					spin_lock_irqsave(&type_c->lock, flags);
+				}
+				cc_status_check = readl(type_c->type_c_reg_base + USB_TYPEC_STS);
+			}
+			if (cc_status != cc_status_check) {
+				dev_warn(dev, "IN_DEVICE_MODE: cc_status (0x%x) != "
+					    "cc_status_check (0x%x)\n",
+					    cc_status, cc_status_check);
+				cc_status = readl(type_c->type_c_reg_base + USB_TYPEC_STS);
+			}
+
+			if ((cc_status & cc1_det_sts) >= cc1_det_sts_rp) {
+				dev_dbg(dev,"IN device mode and cc1 host connect "
+					    "(cc_status=0x%x)", cc_status);
+				type_c->at_cc1 = AT_CC1;
+				type_c->is_attach = TO_ATTACH;
+				type_c->connect_change = CONNECT_CHANGE;
+			} else if ((cc_status & cc2_det_sts) >= cc2_det_sts_rp) {
+				dev_dbg(dev,"IN device mode and cc2 host connect "
+					    "(cc_status=0x%x)", cc_status);
+				type_c->at_cc1 = AT_CC2;
+				type_c->is_attach = TO_ATTACH;
+				type_c->connect_change = CONNECT_CHANGE;
+			}
+		break;
+		default:
+			dev_err(dev, "IN device_mode and error attach state (is_attach=%d)",
+				    type_c->is_attach);
+		}
+	break;
+	default:
+		dev_err(dev, "error host or device mode (in_host_mode=%d)",
+			    type_c->in_host_mode);
+	}
+
+	type_c->int_status = int_status;
+	type_c->cc_status = cc_status;
+
+	spin_unlock_irqrestore(&type_c->lock, flags);
+	return 0;
+}
+
+void host_device_switch(struct work_struct *work)
+{
+	struct type_c_data *type_c = container_of(work,
+		    struct type_c_data, delayed_work.work);
+	struct device		*dev = type_c->dev;
+	unsigned long		flags;
+	int connect_change = 0;
+	int in_host_mode = 0;
+	int is_attach = 0;
+	int at_cc1 = 0;
+
+	if (type_c->debug) dev_dbg(type_c->dev, "ENTER %s", __func__);
+
+	spin_lock_irqsave(&type_c->lock, flags);
+	if (type_c->connect_change)
+		connect_change = type_c->connect_change;
+	spin_unlock_irqrestore(&type_c->lock, flags);
+
+	if (!connect_change)
+		detect_type_c_state(type_c);
+
+	spin_lock_irqsave(&type_c->lock, flags);
+	if (type_c->connect_change) {
+		connect_change = type_c->connect_change;
+		in_host_mode = type_c->in_host_mode;
+		is_attach = type_c->is_attach;
+		at_cc1 = type_c->at_cc1;
+		type_c->connect_change = CONNECT_NO_CHANGE;
+		type_c->is_role_swap = NO_ROLE_SWAP;
+	} else {
+		if (type_c->support_drd_mode)
+			host_device_switch_detection(type_c);
+
+		schedule_delayed_work(&type_c->delayed_work,
+			    msecs_to_jiffies(DETECT_TIME));
+	}
+	spin_unlock_irqrestore(&type_c->lock, flags);
+
+	if (connect_change) {
+		dev_info(dev, "%s: usb cable connection change\n", __func__);
+#ifdef CONFIG_USB_TYPE_C_RTK_RTS5400
+		if (type_c->check_at_boot
+				&& rtk_rts5400_is_enabled()
+				&& rtk_rts5400_is_UFP_attached()) {
+			u32 enable_cc = at_cc1?enable_cc1:enable_cc2;
+			dev_info(dev, "%s: In Device mode, role swap to Host mode\n",
+				    __func__);
+			switch_type_c_plug_config(type_c, USB_DR_MODE_HOST, enable_cc);
+			switch_dwc3_mode(type_c, USB_DR_MODE_HOST);
+
+			rtk_rts5400_set_type_c_soft_reset();
+
+			type_c->check_at_boot = false;
+		} else
+#endif //CONFIG_USB_TYPE_C_RTK_RTS5400
+		if (in_host_mode) {
+			if (is_attach && at_cc1)
+				device_attached(type_c, enable_cc1);
+			else if (is_attach && !at_cc1)
+				device_attached(type_c, enable_cc2);
+			else
+				device_detached(type_c);
+		} else {
+			if (is_attach && at_cc1)
+				host_connected(type_c, enable_cc1);
+			else if (is_attach && !at_cc1)
+				host_connected(type_c, enable_cc2);
+			else
+				host_disconnected(type_c);
+		}
+		dev_err(dev, "Connection change OK: IN %s mode to %s %s at %s "
+			    "(cc_status=0x%x)\n",
+			    in_host_mode?"host":"device",
+			    in_host_mode?
+			        (is_attach?"attach":"detach"):
+			        (is_attach?"connect":"disconnect"),
+			    in_host_mode?"device":"host",
+			    at_cc1?"cc1":"cc2", type_c->cc_status);
+
+	}
+
+	/* For special case, some boards use type c power and need use host mode.
+	 * After 30s, We switch to host mode if in device mode but no host connect.
+	 */
+	if (type_c->check_at_boot) {
+		if (type_c->support_drd_mode && connect_change &&
+			(in_host_mode == IN_DEVICE_MODE) && is_attach) {
+			dev_info(dev, "%s: In Device mode check connection at boot time\n",
+				    __func__);
+			schedule_delayed_work(&type_c->boot_check_work,
+				    msecs_to_jiffies(type_c->boot_check_time));
+		}
+		type_c->check_at_boot = false;
+	}
+}
+
+static int host_device_role_swap(struct type_c_data *type_c, bool swap_role)
+{
+	int ret = 0;
+	int swap_to_xx_mode = USB_DR_MODE_UNKNOWN;
+	int at_cc1, in_host_mode, is_attach;
+	unsigned long		flags;
+
+	spin_lock_irqsave(&type_c->lock, flags);
+
+	at_cc1 = type_c->at_cc1;
+	in_host_mode = type_c->in_host_mode;
+	is_attach = type_c->is_attach;
+
+	spin_unlock_irqrestore(&type_c->lock, flags);
+
+	if (!type_c->support_drd_mode) {
+		dev_warn(type_c->dev,
+			    "Can not swap role!! It is Not support drd mode\n");
+		return -1;
+	}
+	if (!is_attach) {
+		dev_warn(type_c->dev, "Can not swap role!! It is Not attach\n");
+		return -1;
+	}
+
+	dev_info(type_c->dev, "%s: In %s Mode and now is%s role swap ",
+		    __func__,
+		    in_host_mode == IN_HOST_MODE?"Host":"Device",
+		    type_c->is_role_swap == ROLE_SWAP?"":" Not");
+
+	if (swap_role == TO_RESTORE_ROLE &&
+		    type_c->is_role_swap == ROLE_SWAP)
+		/* Restore Role */
+		if (in_host_mode == IN_DEVICE_MODE)
+			swap_to_xx_mode = USB_DR_MODE_PERIPHERAL;
+		else
+			swap_to_xx_mode = USB_DR_MODE_HOST;
+	else if (swap_role == TO_SWAP_ROLE &&
+		    type_c->is_role_swap == NO_ROLE_SWAP)
+		/* Swap Role */
+		if (in_host_mode == IN_DEVICE_MODE)
+			swap_to_xx_mode = USB_DR_MODE_HOST;
+		else
+			swap_to_xx_mode = USB_DR_MODE_PERIPHERAL;
+
+	if (swap_to_xx_mode != USB_DR_MODE_UNKNOWN) {
+		u32 enable_cc = at_cc1?enable_cc1:enable_cc2;
+		dev_info(type_c->dev, "%s: now is%s role swap ==> to %s role "
+			    "(swap_to_xx_mode=%s\n",
+			    __func__,
+			    type_c->is_role_swap == ROLE_SWAP?"":" No",
+			    swap_role == TO_SWAP_ROLE?"swap":"restore",
+			    ({ char *tmp;
+			     switch (swap_to_xx_mode) {
+			     case USB_DR_MODE_PERIPHERAL:
+			        tmp = "USB_DR_MODE_PERIPHERAL"; break;
+			     case USB_DR_MODE_HOST:
+			        tmp = "USB_DR_MODE_HOST"; break;
+			     default: tmp = "USB_DR_MODE_UNKNOWN"; break;
+			    } tmp;}));
+
+		switch_type_c_plug_config(type_c, 0, disable_cc);
+		mdelay(100);
+		switch_type_c_plug_config(type_c, swap_to_xx_mode, enable_cc);
+		switch_dwc3_mode(type_c, swap_to_xx_mode);
+
+		if (swap_to_xx_mode == USB_DR_MODE_HOST) {
+			bool on = true;
+			rtk_usb_type_c_power_on_off(type_c->dev, on);
+		} else if (swap_to_xx_mode == USB_DR_MODE_PERIPHERAL) {
+			bool off = false;
+			rtk_usb_type_c_power_on_off(type_c->dev, off);
+		}
+		type_c->is_role_swap = (swap_role == TO_SWAP_ROLE?
+			    ROLE_SWAP: NO_ROLE_SWAP);
+	} else {
+		dev_info(type_c->dev, "%s: No swap and No restore\n", __func__);
+	}
+
+	return ret;
+}
+
+static void boot_time_check(struct work_struct *work)
+{
+	struct type_c_data *type_c = container_of(work,
+		    struct type_c_data, boot_check_work.work);
+	struct device		*dev = type_c->dev;
+	int at_cc1, in_host_mode, is_attach;
+	unsigned long		flags;
+
+	spin_lock_irqsave(&type_c->lock, flags);
+
+	at_cc1 = type_c->at_cc1;
+	in_host_mode = type_c->in_host_mode;
+	is_attach = type_c->is_attach;
+
+	spin_unlock_irqrestore(&type_c->lock, flags);
+
+	if (type_c->support_drd_mode &&
+			(in_host_mode == IN_DEVICE_MODE) && is_attach) {
+		int no_host_connect = 0;
+		int no_run_gadget = 0;
+		u32 enable_cc = at_cc1?enable_cc1:enable_cc2;
+		u32 dsts = dwc3_readl(type_c->dwc->regs, DWC3_DSTS);
+		u32 dctl = dwc3_readl(type_c->dwc->regs, DWC3_DCTL);
+
+		dev_info(dev, "%s: Device mode check DSTS=%x DCTL=%x\n", __func__,
+				dsts, dctl);
+		no_host_connect = (dsts & 0x0003FFF8) == BIT(17);
+		no_run_gadget = (dctl & BIT(31)) == 0x0;
+		if (no_host_connect || no_run_gadget) {
+			dev_info(dev, "%s: In Device mode, NO host connect at boot time "
+				    "(After %dms), switch to Host mode\n",
+				    __func__, type_c->boot_check_time);
+
+			host_device_role_swap(type_c, TO_SWAP_ROLE);
+		}
+	}
+}
+
+irqreturn_t type_c_detect_irq(int irq, void *__data)
+{
+	struct type_c_data 	*type_c = (struct type_c_data *) __data;
+	struct device 		*dev = type_c->dev;
+	unsigned long		flags;
+	//u32 int_status, cc_status;
+
+	detect_type_c_state(type_c);
+
+	spin_lock_irqsave(&type_c->lock, flags);
+
+	if (type_c->connect_change) {
+		dev_info(dev, "%s: IN %s mode to %s %s (at %s interrupt) "
+			    "int_status=0x%x, cc_status=0x%x",
+			    __func__,
+			    type_c->in_host_mode?"host":"device",
+			    type_c->in_host_mode?
+			        (type_c->is_attach?"attach":"detach"):
+			        (type_c->is_attach?"connect":"disconnect"),
+			    type_c->in_host_mode?"device":"host",
+			    type_c->at_cc1?"cc1":"cc2",
+			    type_c->int_status, type_c->cc_status);
+
+		//clear interrupt status
+		disable_writel(all_cc_int_sts,
+			    type_c->type_c_reg_base + USB_TYPEC_CTRL);
+
+		cancel_delayed_work(&type_c->delayed_work);
+		schedule_delayed_work(&type_c->delayed_work, msecs_to_jiffies(0));
+#ifdef CONFIG_DUAL_ROLE_USB_INTF
+		if (type_c->drp)
+			dual_role_instance_changed(type_c->drp);
+#endif
+	} else {
+		static int local_count = 0;
+		if (local_count++ > 10) {
+			//clear interrupt status
+			disable_writel(all_cc_int_sts,
+			    type_c->type_c_reg_base + USB_TYPEC_CTRL);
+			local_count = 0;
+		}
+		if (type_c->debug)
+			dev_dbg(dev, "%s: ###NO change### Status: IN %s mode %s %s "
+				    "(at %s interrupt) int_status=0x%x, cc_status=0x%x",
+				__func__,
+				type_c->in_host_mode?"host":"device",
+				type_c->in_host_mode?
+					(type_c->is_attach?"attach":"detach"):
+					(type_c->is_attach?"connect":"disconnect"),
+				type_c->in_host_mode?"device":"host",
+				type_c->at_cc1?"cc1":"cc2", type_c->int_status, type_c->cc_status);
+	}
+
+	spin_unlock_irqrestore(&type_c->lock, flags);
+
+	return IRQ_HANDLED;
+}
+
+static ssize_t type_c_role_swap_show(struct device *dev,
+			      struct device_attribute *attr,
+			      char *buf)
+{
+	struct type_c_data *type_c = dev_get_drvdata(dev);
+	char *ptr = buf;
+	int count = PAGE_SIZE;
+	int n;
+
+	n = scnprintf(ptr, count,
+		     "Now cur_mode is %s and is%s role swap\n",
+		    ({ char *tmp;
+		     switch (type_c->cur_mode) {
+		     case USB_DR_MODE_PERIPHERAL:
+		        tmp = "USB_DR_MODE_PERIPHERAL"; break;
+		     case USB_DR_MODE_HOST: tmp = "USB_DR_MODE_HOST"; break;
+		     default: tmp = "USB_DR_MODE_UNKNOWN"; break;
+		    } tmp;}), type_c->is_role_swap == ROLE_SWAP?"":" not");
+	ptr += n;
+	count -= n;
+
+	n = scnprintf(ptr, count,
+		     "write 1 to swap role, ex: echo 1 > role_swap\n");
+	ptr += n;
+	count -= n;
+
+	n = scnprintf(ptr, count,
+		     "write 0 to restore role, ex: echo 0 > role_swap\n");
+	ptr += n;
+	count -= n;
+
+	return ptr - buf;
+}
+
+static ssize_t type_c_role_swap_write(struct device *dev,
+			       struct device_attribute *attr,
+			       const char *buf, size_t count)
+{
+	struct type_c_data *type_c = dev_get_drvdata(dev);
+
+	if (!strncmp(buf, "1", 1))
+		host_device_role_swap(type_c, TO_SWAP_ROLE);
+	else if (!strncmp(buf, "0", 1))
+		host_device_role_swap(type_c, TO_RESTORE_ROLE);
+
+	return count;
+}
+static DEVICE_ATTR(role_swap, 0644, type_c_role_swap_show, type_c_role_swap_write);
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+static int type_c_parameter_show(struct seq_file *s, void *unused)
+{
+	struct type_c_data		*type_c = s->private;
+	unsigned long		flags;
+
+	spin_lock_irqsave(&type_c->lock, flags);
+
+	seq_printf(s, "Rd control gpio: %d\n", type_c->rd_ctrl_gpio);
+	seq_printf(s, "cc_dfp_mode %s\n",
+		    ({ char *tmp;
+		     switch (type_c->cc_dfp_mode) {
+		     case CC_MODE_DFP_USB: tmp = "CC_MODE_DFP_USB"; break;
+		     case CC_MODE_DFP_1_5: tmp = "CC_MODE_DFP_1_5"; break;
+		     case CC_MODE_DFP_3_0: tmp = "CC_MODE_DFP_3_0"; break;
+		     default: tmp = "?"; break;
+		     } tmp;}));
+	seq_printf(s, "cc1_rp 0x%x\n", type_c->cc1_rp);
+	seq_printf(s, "cc1_rp_code 0x%x\n",
+		    ({ int tmp;
+		     switch (type_c->cc_dfp_mode) {
+		     case CC_MODE_DFP_USB:
+		        tmp = code_rp12k(type_c->cc1_rp_code); break;
+		     case CC_MODE_DFP_1_5:
+		        tmp = code_rp36k(type_c->cc1_rp_code); break;
+		     case CC_MODE_DFP_3_0:
+		        tmp = code_rp4pk(type_c->cc1_rp_code); break;
+		     default: tmp = -1; break;
+		    } tmp;}));
+	seq_printf(s, "cc1_rd_code 0x%x (using %s Rd)\n",
+		    code_rd(type_c->cc1_rd_code),
+		    type_c->rd_config?"internal":"external");
+	seq_printf(s, "cc1_vref_ufp     vref_1p23v 0x%x vref_0p66v 0x%x "
+		    "vref_0p2v 0x%x\n",
+		    decode_1p23v(type_c->cc1_vref_ufp),
+		    decode_0p66v(type_c->cc1_vref_ufp),
+		    decode_0p2v(type_c->cc1_vref_ufp));
+	seq_printf(s, "cc1_vref_dfp_usb vref_0_1p6v 0x%x vref_0p2v 0x%x\n",
+		    decode_0_1p6v(type_c->cc1_vref_dfp_usb),
+		    decode_0p2v(type_c->cc1_vref_dfp_usb));
+	seq_printf(s, "cc1_vref_dfp_1_5 vref_1_1p6v 0x%x vref_0p4v 0x%x "
+		    "vref_0p2v 0x%x\n",
+		    decode_1_1p6v(type_c->cc1_vref_dfp_1_5),
+		    decode_0p4v(type_c->cc1_vref_dfp_1_5),
+		    decode_0p2v(type_c->cc1_vref_dfp_1_5));
+	seq_printf(s, "cc1_vref_dfp_3_0 vref_2p6v   0x%x vref_0p8v 0x%x "
+		    "vref_0p2v 0x%x\n",
+		    decode_2p6v(type_c->cc1_vref_dfp_3_0),
+		    decode_0p8v(type_c->cc1_vref_dfp_3_0),
+		    decode_0p2v(type_c->cc1_vref_dfp_3_0));
+	seq_printf(s, "cc2_rp 0x%x\n", type_c->cc2_rp);
+	seq_printf(s, "cc2_rp_code 0x%x\n",
+		    ({ int tmp;
+		     switch (type_c->cc_dfp_mode) {
+		     case CC_MODE_DFP_USB: tmp = code_rp12k(type_c->cc2_rp_code); break;
+		     case CC_MODE_DFP_1_5: tmp = code_rp36k(type_c->cc2_rp_code); break;
+		     case CC_MODE_DFP_3_0: tmp = code_rp4pk(type_c->cc2_rp_code); break;
+		     default: tmp = -1; break;
+		    } tmp;}));
+	seq_printf(s, "cc2_rd_code 0x%x (using %s Rd)\n",
+		    code_rd(type_c->cc2_rd_code),
+		    type_c->rd_config?"internal":"external");
+	seq_printf(s, "cc2_vref_ufp     vref_1p23v 0x%x vref_0p66v 0x%x "
+		    "vref_0p2v 0x%x\n",
+		    decode_1p23v(type_c->cc2_vref_ufp),
+		    decode_0p66v(type_c->cc2_vref_ufp),
+		    decode_0p2v(type_c->cc2_vref_ufp));
+	seq_printf(s, "cc2_vref_dfp_usb vref_0_1p6v 0x%x vref_0p2v 0x%x\n",
+		    decode_0_1p6v(type_c->cc2_vref_dfp_usb),
+		    decode_0p2v(type_c->cc2_vref_dfp_usb));
+	seq_printf(s, "cc2_vref_dfp_1_5 vref_1_1p6v 0x%x vref_0p4v 0x%x "
+		    "vref_0p2v 0x%x\n",
+		    decode_1_1p6v(type_c->cc2_vref_dfp_1_5),
+		    decode_0p4v(type_c->cc2_vref_dfp_1_5),
+		    decode_0p2v(type_c->cc2_vref_dfp_1_5));
+	seq_printf(s, "cc2_vref_dfp_3_0 vref_2p6v   0x%x vref_0p8v 0x%x "
+		    "vref_0p2v 0x%x\n",
+		    decode_2p6v(type_c->cc2_vref_dfp_3_0),
+		    decode_0p8v(type_c->cc2_vref_dfp_3_0),
+		    decode_0p2v(type_c->cc2_vref_dfp_3_0));
+	seq_printf(s, "debounce_val 0x%x\n", type_c->debounce_val);
+	seq_printf(s, "\n");
+
+	seq_printf(s, "dwc3_mode %s (%s)\n",
+		    ({ char *tmp;
+		     switch (type_c->dwc3_mode) {
+		     case USB_DR_MODE_PERIPHERAL: tmp = "USB_DR_MODE_PERIPHERAL"; break;
+		     case USB_DR_MODE_HOST: tmp = "USB_DR_MODE_HOST"; break;
+		     default: tmp = "USB_DR_MODE_UNKNOWN"; break;
+		    } tmp;}),
+		    type_c->support_drd_mode?"is DRD":"Not DRD");
+
+	spin_unlock_irqrestore(&type_c->lock, flags);
+
+	return 0;
+}
+
+static int type_c_parameter_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, type_c_parameter_show, inode->i_private);
+}
+
+static const struct file_operations type_c_parameter_fops = {
+	.open			= type_c_parameter_open,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int type_c_set_parameter_show(struct seq_file *s, void *unused)
+{
+	//struct type_c_data		*type_c = s->private;
+
+	seq_printf(s, "cc_dfp_mode [CC_MODE_DFP_USB|CC_MODE_DFP_1_5|"
+		    "CC_MODE_DFP_3_0]\n");
+	seq_printf(s, "rd_config [internal|external]");
+	seq_printf(s, "cc1_rp_code 0x_value\n");
+	seq_printf(s, "cc1_rd_code 0x_value\n");
+	seq_printf(s, "cc1_vref_ufp_vref_1p23v 0x_value\n");
+	seq_printf(s, "cc1_vref_ufp_vref_0p66v 0x_value\n");
+	seq_printf(s, "cc1_vref_ufp_vref_0p2v  0x_value\n");
+	seq_printf(s, "cc1_vref_dfp_usb_vref_1p6v 0x_value\n");
+	seq_printf(s, "cc1_vref_dfp_usb_vref_0p2v 0x_value\n");
+	seq_printf(s, "cc1_vref_dfp_1_5_vref_1p6v 0x_value\n");
+	seq_printf(s, "cc1_vref_dfp_1_5_vref_0p4v 0x_value\n");
+	seq_printf(s, "cc1_vref_dfp_1_5_vref_0p2v 0x_value\n");
+	seq_printf(s, "cc1_vref_dfp_3_0_vref_2p6v 0x_value\n");
+	seq_printf(s, "cc1_vref_dfp_3_0_vref_0p8v 0x_value\n");
+	seq_printf(s, "cc1_vref_dfp_3_0_vref_0p2v 0x_value\n");
+	seq_printf(s, "cc2_rp_code 0x_value\n");
+	seq_printf(s, "cc2_rd_code 0x_value\n");
+	seq_printf(s, "cc2_vref_ufp_vref_1p23v 0x_value\n");
+	seq_printf(s, "cc2_vref_ufp_vref_0p66v 0x_value\n");
+	seq_printf(s, "cc2_vref_ufp_vref_0p2v  0x_value\n");
+	seq_printf(s, "cc2_vref_dfp_usb_vref_1p6v 0x_value\n");
+	seq_printf(s, "cc2_vref_dfp_usb_vref_0p2v 0x_value\n");
+	seq_printf(s, "cc2_vref_dfp_1_5_vref_1p6v 0x_value\n");
+	seq_printf(s, "cc2_vref_dfp_1_5_vref_0p4v 0x_value\n");
+	seq_printf(s, "cc2_vref_dfp_1_5_vref_0p2v 0x_value\n");
+	seq_printf(s, "cc2_vref_dfp_3_0_vref_2p6v 0x_value\n");
+	seq_printf(s, "cc2_vref_dfp_3_0_vref_0p8v 0x_value\n");
+	seq_printf(s, "cc2_vref_dfp_3_0_vref_0p2v 0x_value\n");
+	seq_printf(s, "debounce_val value\n");
+
+	return 0;
+}
+
+static int type_c_set_parameter_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, type_c_set_parameter_show, inode->i_private);
+}
+
+static ssize_t type_c_set_parameter_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct type_c_data		*type_c = s->private;
+	unsigned long		flags;
+	char			buffer[40];
+	char *buf = buffer;
+	u32 value;
+
+	if (copy_from_user(&buffer, ubuf, min_t(size_t, sizeof(buffer) - 1, count)))
+		return -EFAULT;
+
+	spin_lock_irqsave(&type_c->lock, flags);
+	if (!strncmp(buf, "cc_dfp_mode", 11)) {
+		buf = buf + 11;
+		buf = skip_spaces(buf);
+		if (!strncmp(buf, "CC_MODE_DFP_USB", 15)) {
+			type_c->cc_dfp_mode = CC_MODE_DFP_USB;
+			type_c->cc1_rp = En_rp12k;
+			type_c->cc2_rp = En_rp12k;
+		} else if (!strncmp(buf, "CC_MODE_DFP_1_5", 15)) {
+			type_c->cc_dfp_mode = CC_MODE_DFP_1_5;
+			type_c->cc1_rp = En_rp36k;
+			type_c->cc2_rp = En_rp36k;
+		} else if (!strncmp(buf, "CC_MODE_DFP_3_0", 15)) {
+			type_c->cc_dfp_mode = CC_MODE_DFP_3_0;
+			type_c->cc1_rp = En_rp4p7k;
+			type_c->cc2_rp = En_rp4p7k;
+		} else {
+			dev_err(type_c->dev, "cc_dfp_mode UNKNOWN (%s)", buf);
+		}
+	} else if (!strncmp(buf, "rd_config", 9)) {
+		buf = buf + 9;
+		buf = skip_spaces(buf);
+		if (!strncmp(buf, "internal", 8))
+			type_c->rd_config = INTERNAL_Rd;
+		else if (!strncmp(buf, "external", 8))
+			type_c->rd_config = EXTERNAL_Rd;
+		else
+			dev_err(type_c->dev, "rd_config UNKNOWN (%s)", buf);
+
+	} else if (!strncmp(buf, "cc1_rp_code", 11)) {
+		buf = buf + 11;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		if (type_c->cc_dfp_mode == CC_MODE_DFP_USB)
+			type_c->cc1_rp_code = rp12k_code(value);
+		else if (type_c->cc_dfp_mode == CC_MODE_DFP_1_5)
+			type_c->cc1_rp_code = rp36k_code(value);
+		else if (type_c->cc_dfp_mode == CC_MODE_DFP_3_0)
+			type_c->cc1_rp_code = rp4pk_code(value);
+	} else if (!strncmp(buf, "cc1_rd_code", 11)) {
+		buf = buf + 11;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_rd_code = rd_code(value);
+	} else if (!strncmp(buf, "cc1_vref_ufp_vref_1p23v", 23)) {
+		buf = buf + 23;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_ufp = (type_c->cc1_vref_ufp & (~vref_1p23v(0xf))) |
+			    vref_1p23v(value);
+	} else if (!strncmp(buf, "cc1_vref_ufp_vref_0p66v", 23)) {
+		buf = buf + 23;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_ufp = (type_c->cc1_vref_ufp & (~vref_0p66v(0xf))) |
+			    vref_0p66v(value);
+	} else if (!strncmp(buf, "cc1_vref_ufp_vref_0p2v", 22)) {
+		buf = buf + 22;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_ufp = (type_c->cc1_vref_ufp & (~vref_0p2v(0x7))) |
+			    vref_0p2v(value);
+	} else if (!strncmp(buf, "cc1_vref_dfp_usb_vref_1p6v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_dfp_usb = (type_c->cc1_vref_dfp_usb &
+			    (~vref_0_1p6v(0xf))) | vref_0_1p6v(value);
+	} else if (!strncmp(buf, "cc1_vref_dfp_usb_vref_0p2v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_dfp_usb = (type_c->cc1_vref_dfp_usb &
+			    (~vref_0p2v(0x7))) | vref_0p2v(value);
+	} else if (!strncmp(buf, "cc1_vref_dfp_1_5_vref_1p6v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_dfp_1_5 = (type_c->cc1_vref_dfp_1_5 &
+			    (~vref_1_1p6v(0xf))) | vref_1_1p6v(value);
+	} else if (!strncmp(buf, "cc1_vref_dfp_1_5_vref_0p4v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_dfp_1_5 = (type_c->cc1_vref_dfp_1_5 &
+			    (~vref_0p4v(0x7))) | vref_0p4v(value);
+	} else if (!strncmp(buf, "cc1_vref_dfp_1_5_vref_0p2v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_dfp_1_5 = (type_c->cc1_vref_dfp_1_5 &
+			    (~vref_0p2v(0x7))) | vref_0p2v(value);
+	} else if (!strncmp(buf, "cc1_vref_dfp_3_0_vref_2p6v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_ufp = (type_c->cc1_vref_dfp_1_5 & (~vref_2p6v(0x7))) |
+			    vref_2p6v(value);
+	} else if (!strncmp(buf, "cc1_vref_dfp_3_0_vref_0p8v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_dfp_3_0 = (type_c->cc1_vref_dfp_3_0 &
+			    (~vref_0p8v(0xf))) | vref_0p8v(value);
+	} else if (!strncmp(buf, "cc1_vref_dfp_3_0_vref_0p2v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc1_vref_dfp_3_0 = (type_c->cc1_vref_dfp_3_0 &
+			    (~vref_0p2v(0x7))) | vref_0p2v(value);
+	} else if (!strncmp(buf, "cc2_rp_code", 11)) {
+		buf = buf + 11;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%d", &value);
+		if (type_c->cc_dfp_mode == CC_MODE_DFP_USB)
+			type_c->cc2_rp_code = rp12k_code(value);
+		else if (type_c->cc_dfp_mode == CC_MODE_DFP_1_5)
+			type_c->cc2_rp_code = rp36k_code(value);
+		else if (type_c->cc_dfp_mode == CC_MODE_DFP_3_0)
+			type_c->cc2_rp_code = rp4pk_code(value);
+	} else if (!strncmp(buf, "cc2_rd_code", 11)) {
+		buf = buf + 11;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%d", &value);
+		type_c->cc2_rd_code = rd_code(value);
+	} else if (!strncmp(buf, "cc2_vref_ufp_vref_1p23v", 23)) {
+		buf = buf + 23;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_ufp = (type_c->cc2_vref_ufp & (~vref_1p23v(0xf))) |
+			    vref_1p23v(value);
+	} else if (!strncmp(buf, "cc2_vref_ufp_vref_0p66v", 23)) {
+		buf = buf + 23;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_ufp = (type_c->cc2_vref_ufp & (~vref_0p66v(0xf))) |
+			    vref_0p66v(value);
+	} else if (!strncmp(buf, "cc2_vref_ufp_vref_0p2v", 22)) {
+		buf = buf + 22;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_ufp = (type_c->cc2_vref_ufp & (~vref_0p2v(0x7))) |
+			    vref_0p2v(value);
+	} else if (!strncmp(buf, "cc2_vref_dfp_usb_vref_1p6v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_dfp_usb = (type_c->cc2_vref_dfp_usb &
+			    (~vref_0_1p6v(0xf))) | vref_0_1p6v(value);
+	} else if (!strncmp(buf, "cc2_vref_dfp_usb_vref_0p2v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_dfp_usb = (type_c->cc2_vref_dfp_usb &
+			    (~vref_0p2v(0x7))) | vref_0p2v(value);
+	} else if (!strncmp(buf, "cc2_vref_dfp_1_5_vref_1p6v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_dfp_1_5 = (type_c->cc2_vref_dfp_1_5 &
+			    (~vref_1_1p6v(0xf))) | vref_1_1p6v(value);
+	} else if (!strncmp(buf, "cc2_vref_dfp_1_5_vref_0p4v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_dfp_1_5 = (type_c->cc2_vref_dfp_1_5 &
+			    (~vref_0p4v(0x7))) | vref_0p4v(value);
+	} else if (!strncmp(buf, "cc2_vref_dfp_1_5_vref_0p2v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_dfp_1_5 = (type_c->cc2_vref_dfp_1_5 &
+			    (~vref_0p2v(0x7))) | vref_0p2v(value);
+	} else if (!strncmp(buf, "cc2_vref_dfp_3_0_vref_2p6v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_dfp_3_0 = (type_c->cc2_vref_dfp_3_0 &
+			    (~vref_2p6v(0x7))) | vref_2p6v(value);
+	} else if (!strncmp(buf, "cc2_vref_dfp_3_0_vref_0p8v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_dfp_3_0 = (type_c->cc2_vref_dfp_3_0 &
+			    (~vref_0p8v(0xf))) | vref_0p8v(value);
+	} else if (!strncmp(buf, "cc2_vref_dfp_3_0_vref_0p2v", 26)) {
+		buf = buf + 26;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->cc2_vref_dfp_3_0 = (type_c->cc2_vref_dfp_3_0 &
+			    (~vref_0p2v(0x7))) | vref_0p2v(value);
+	} else if (!strncmp(buf, "debounce_val", 12)) {
+		buf = buf + 12;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x", &value);
+		type_c->debounce_val = value;
+	} else
+		dev_err(type_c->dev, "UNKNOWN input (%s)", buf);
+
+	spin_unlock_irqrestore(&type_c->lock, flags);
+	return count;
+}
+
+static const struct file_operations type_c_set_parameter_fops = {
+	.open			= type_c_set_parameter_open,
+	.write			= type_c_set_parameter_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int type_c_status_show(struct seq_file *s, void *unused)
+{
+	struct type_c_data		*type_c = s->private;
+	unsigned long		flags;
+
+	spin_lock_irqsave(&type_c->lock, flags);
+
+	seq_printf(s, "Set %s DRD mode and dwc3_mode is %s (set by dwc3 driver)\n",
+		    type_c->support_drd_mode?"support":"not support",
+		    ({ char *tmp;
+		     switch (type_c->dwc3_mode) {
+		     case USB_DR_MODE_PERIPHERAL:
+		        tmp = "USB_DR_MODE_PERIPHERAL"; break;
+		     case USB_DR_MODE_HOST: tmp = "USB_DR_MODE_HOST"; break;
+		     default: tmp = "USB_DR_MODE_UNKNOWN"; break;
+		    } tmp;}));
+
+	seq_printf(s, "Now cur_mode is %s (Is%s role swap)\n",
+		    ({ char *tmp;
+		     switch (type_c->cur_mode) {
+		     case USB_DR_MODE_PERIPHERAL:
+		        tmp = "USB_DR_MODE_PERIPHERAL"; break;
+		     case USB_DR_MODE_HOST: tmp = "USB_DR_MODE_HOST"; break;
+		     default: tmp = "USB_DR_MODE_UNKNOWN"; break;
+		    } tmp;}), type_c->is_role_swap == ROLE_SWAP?"":" not");
+
+	seq_printf(s, "In %s mode %s %s at %s (cc_status=0x%x)\n",
+		    type_c->in_host_mode?"host":"device",
+		    type_c->in_host_mode?
+		        (type_c->is_attach?"attach":"detach"):
+		        (type_c->is_attach?"connect":"disconnect"),
+		    type_c->in_host_mode?"device":"host",
+		    type_c->at_cc1?"cc1":"cc2", type_c->cc_status);
+
+	seq_printf(s, "Read Register (type_c_ctrl_cc1_0=0x%x)\n",
+		    readl(type_c->type_c_reg_base + 0x0));
+	seq_printf(s, "Read Register (type_c_ctrl_cc1_1=0x%x)\n",
+		    readl(type_c->type_c_reg_base + 0x4));
+	seq_printf(s, "Read Register (type_c_ctrl_cc2_0=0x%x)\n",
+		    readl(type_c->type_c_reg_base + 0x8));
+	seq_printf(s, "Read Register (type_c_ctrl_cc2_1=0x%x)\n",
+		    readl(type_c->type_c_reg_base + 0xc));
+	seq_printf(s, "Read Register (type_c_status=0x%x)\n",
+		    readl(type_c->type_c_reg_base + 0x10));
+	seq_printf(s, "Read Register (type_c_ctrl=0x%x)\n",
+		    readl(type_c->type_c_reg_base + 0x14));
+
+	spin_unlock_irqrestore(&type_c->lock, flags);
+
+	return 0;
+}
+
+static int type_c_status_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, type_c_status_show, inode->i_private);
+}
+
+static const struct file_operations type_c_status_fops = {
+	.open			= type_c_status_open,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int type_c_debug_show(struct seq_file *s, void *unused)
+{
+	struct type_c_data		*type_c = s->private;
+
+	seq_printf(s, "Debug: %s\n",
+				type_c->debug?"Enable":"disable");
+
+	return 0;
+}
+
+static int type_c_debug_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, type_c_debug_show, inode->i_private);
+}
+
+static ssize_t type_c_debug_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct type_c_data		*type_c = s->private;
+	char			buf[32];
+
+	if (copy_from_user(&buf, ubuf, min_t(size_t, sizeof(buf) - 1, count)))
+		return -EFAULT;
+
+	if (!strncmp(buf, "enable", 6))
+		type_c->debug = true;
+	else if (!strncmp(buf, "disable", 7))
+		type_c->debug = false;
+
+	return count;
+}
+
+static const struct file_operations type_c_debug_fops = {
+	.open			= type_c_debug_open,
+	.write			= type_c_debug_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static inline void create_debug_files(struct type_c_data *type_c)
+{
+	dev_err(type_c->dev, "%s", __func__);
+
+	type_c->debug_dir = debugfs_create_dir("type_c", usb_debug_root);
+	if (!type_c->debug_dir) {
+		dev_err(type_c->dev, "%s Error debug_dir is NULL", __func__);
+		return;
+	}
+
+	if (!debugfs_create_file("parameter", S_IRUGO, type_c->debug_dir, type_c,
+		    &type_c_parameter_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("set_parameter", S_IRUGO | S_IWUSR,
+		    type_c->debug_dir, type_c,
+		    &type_c_set_parameter_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("status", S_IRUGO, type_c->debug_dir, type_c,
+		    &type_c_status_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("debug", S_IRUGO | S_IWUSR,
+		    type_c->debug_dir, type_c,
+		    &type_c_debug_fops))
+		goto file_error;
+
+	return;
+
+file_error:
+	debugfs_remove_recursive(type_c->debug_dir);
+}
+#endif //CONFIG_DYNAMIC_DEBUG
+
+#ifdef CONFIG_DUAL_ROLE_USB_INTF
+static enum dual_role_property fusb_drp_properties[] = {
+	DUAL_ROLE_PROP_MODE,
+	DUAL_ROLE_PROP_PR,
+	DUAL_ROLE_PROP_DR,
+};
+
+static int dual_role_get_local_prop(struct dual_role_phy_instance *drp,
+				enum dual_role_property prop,
+				unsigned int *val)
+{
+	struct type_c_data *type_c = dual_role_get_drvdata(drp);
+
+	if (!type_c) {
+		pr_err("driver data not ready\n");
+		return -1;
+	}
+
+	if(type_c->cur_mode == USB_DR_MODE_PERIPHERAL) {
+		if (prop == DUAL_ROLE_PROP_MODE)
+			*val = DUAL_ROLE_PROP_MODE_UFP;
+		else if(prop == DUAL_ROLE_PROP_PR)
+			*val = DUAL_ROLE_PROP_PR_SNK;
+		else if(prop == DUAL_ROLE_PROP_DR)
+			*val = DUAL_ROLE_PROP_DR_DEVICE;
+		else
+			return -EINVAL;
+	} else if(type_c->cur_mode == USB_DR_MODE_HOST) {
+		if (prop == DUAL_ROLE_PROP_MODE)
+			*val = DUAL_ROLE_PROP_MODE_DFP;
+		else if (prop == DUAL_ROLE_PROP_PR)
+			*val = DUAL_ROLE_PROP_PR_SRC;
+		else if (prop == DUAL_ROLE_PROP_DR)
+			*val = DUAL_ROLE_PROP_DR_HOST;
+		else
+			return -EINVAL;
+	} else {
+		if (prop == DUAL_ROLE_PROP_MODE)
+			*val = DUAL_ROLE_PROP_MODE_NONE;
+		else if (prop == DUAL_ROLE_PROP_PR)
+			*val = DUAL_ROLE_PROP_PR_NONE;
+		else if (prop == DUAL_ROLE_PROP_DR)
+			*val = DUAL_ROLE_PROP_DR_NONE;
+		else
+			return -EINVAL;
+	}
+
+	return 0;
+}
+
+static int dual_role_is_writeable(struct dual_role_phy_instance *drp,
+				enum dual_role_property prop)
+{
+	if (prop == DUAL_ROLE_PROP_MODE)
+		return 1;
+	else
+		return 0;
+}
+#if 0
+static int dual_role_set_mode_prop(struct dual_role_phy_instance *drp,
+				enum dual_role_property prop,
+				const unsigned int *val)
+{
+	pr_err("%s\n", __func__);
+	return 0;
+}
+
+static int dual_role_set_prop(struct dual_role_phy_instance *drp,
+				enum dual_role_property prop,
+				const unsigned int *val)
+{
+	if (prop == DUAL_ROLE_PROP_MODE)
+		return dual_role_set_mode_prop(drp, prop, val);
+	else
+		return -EINVAL;
+}
+#endif
+#endif
+
+/* Init and probe */
+static int dwc3_rtk_type_c_init(struct type_c_data *type_c)
+{
+	struct device		*dev = type_c->dev;
+	u32 debounce_val = type_c->debounce_val;// 1b,1us 7f,4.7us
+#ifdef CONFIG_DUAL_ROLE_USB_INTF
+	struct dual_role_phy_desc *desc;
+	struct dual_role_phy_instance *dual_role;
+#endif
+
+	enable_writel(debounce_val<<1,
+		    type_c->type_c_reg_base + USB_TYPEC_CTRL);
+	dev_info(dev, "%s set debounce = 0x%x (check--> 0x%x)\n",
+		    __func__, debounce_val,
+		    readl(type_c->type_c_reg_base + USB_TYPEC_CTRL));
+
+	if ((type_c->rd_ctrl_gpio != -1) &&
+		    gpio_request(type_c->rd_ctrl_gpio, dev->of_node->name))
+		dev_err(dev, "%s ERROR Request rd_ctrl_gpio  (id=%d) fail\n",
+			   __func__, type_c->rd_ctrl_gpio);
+
+	rtk_type_c_init(type_c);
+
+	if (type_c->cur_mode == USB_DR_MODE_UNKNOWN)
+		switch_dwc3_mode(type_c, 0);
+
+	if (type_c->dwc3_mode == USB_DR_MODE_HOST) {
+		unsigned long		flags;
+
+		spin_lock_irqsave(&type_c->lock, flags);
+
+		dev_info(dev, "DWC3_DRD run in USB_DR_MODE_HOST");
+		type_c->in_host_mode = IN_HOST_MODE;
+		type_c->is_attach = IN_DETACH;
+		type_c->connect_change = CONNECT_NO_CHANGE;
+		type_c->cur_mode = USB_DR_MODE_HOST;
+
+		detect_device(type_c);
+
+		spin_unlock_irqrestore(&type_c->lock, flags);
+
+		schedule_delayed_work(&type_c->delayed_work,
+			    msecs_to_jiffies(0));
+	} else if (type_c->dwc3_mode == USB_DR_MODE_PERIPHERAL) {
+		unsigned long		flags;
+
+		spin_lock_irqsave(&type_c->lock, flags);
+
+		dev_info(dev, "DWC3_DRD run in USB_DR_MODE_PERIPHERAL%s",
+				type_c->support_drd_mode?" at DRD mode":"");
+		type_c->in_host_mode = IN_DEVICE_MODE;
+		type_c->is_attach = IN_DETACH;
+		type_c->connect_change = CONNECT_NO_CHANGE;
+		type_c->cur_mode = USB_DR_MODE_PERIPHERAL;
+		if (type_c->boot_check_time < 0)
+			type_c->check_at_boot = false;
+		else
+			type_c->check_at_boot= true;
+		dev_info(dev, "First time device mode check is %s",
+				type_c->check_at_boot?"Enable":"Diable");
+
+		detect_host(type_c);
+
+		spin_unlock_irqrestore(&type_c->lock, flags);
+
+		schedule_delayed_work(&type_c->delayed_work,
+			    msecs_to_jiffies(0));
+	} else {
+		dev_err(dev, "DWC3_DRD is USB_DR_MODE_UNKNOWN");
+	}
+
+#ifdef CONFIG_DUAL_ROLE_USB_INTF
+	if (type_c->drp == NULL) {
+		desc = devm_kzalloc(dev, sizeof(struct dual_role_phy_desc), GFP_KERNEL);
+		if (!desc) {
+			dev_err(dev, "%s, dual role descriptor malloc fail\n", __func__);
+			return 0;
+		}
+		desc->name = "dwc3_otg";
+		desc->supported_modes = DUAL_ROLE_SUPPORTED_MODES_DFP_AND_UFP;
+		desc->get_property = dual_role_get_local_prop;
+//		desc->set_property = dual_role_set_prop;
+		desc->properties = fusb_drp_properties;
+		desc->num_properties = ARRAY_SIZE(fusb_drp_properties);
+		desc->property_is_writeable = dual_role_is_writeable;
+		dual_role = devm_dual_role_instance_register(dev, desc);
+		dual_role->drv_data = type_c;
+		type_c->drp = dual_role;
+	}
+#endif
+
+	return 0;
+}
+
+static void dwc3_rtk_type_c_probe_work(struct work_struct *work)
+{
+	struct type_c_data *type_c = container_of(work,
+		    struct type_c_data, start_work);
+	struct device		*dev = type_c->dev;
+	int    ret = 0;
+
+	unsigned long probe_time = jiffies;
+
+	dev_info(dev, "%s Start ...\n", __func__);
+
+	ret = dwc3_rtk_type_c_init(type_c);
+
+	if (ret)
+		dev_err(dev, "%s failed to init type_c\n", __func__);
+
+	dev_info(dev, "%s End ... ok! (take %d ms)\n", __func__,
+		    jiffies_to_msecs(jiffies - probe_time));
+}
+
+static int dwc3_rtk_type_c_probe(struct platform_device *pdev)
+{
+	struct device		*dev = &pdev->dev;
+	struct device_node	*node = dev->of_node;
+	struct type_c_data 	*type_c;
+	unsigned int gpio;
+	int irq;
+	int ret = 0;
+	unsigned long probe_time = jiffies;
+
+	dev_info(dev, "ENTER %s", __func__);
+	type_c = devm_kzalloc(dev, sizeof(*type_c), GFP_KERNEL);
+	if (!type_c)
+		return -ENOMEM;
+
+	type_c->wrap_base = of_iomap(pdev->dev.of_node, 0);
+	if (type_c->wrap_base == NULL) {
+		dev_err(&pdev->dev, "error mapping memory for wrap_base\n");
+		ret = -EFAULT;
+		goto err1;
+	}
+
+	type_c->type_c_reg_base = of_iomap(pdev->dev.of_node, 1);
+	if (type_c->type_c_reg_base == NULL) {
+		type_c->type_c_reg_base = type_c->wrap_base + 0x14C; // for Kylin case
+		dev_warn(&pdev->dev, "No mapping memory for type_c_reg_base!\n");
+		dev_warn(&pdev->dev, "Let type_c_reg_base = %p\n",
+			    type_c->type_c_reg_base);
+	}
+
+	type_c->dev = dev;
+
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (irq <= 0) {
+		dev_err(&pdev->dev, "Type C driver with no IRQ. Check %s setup!\n",
+				dev_name(&pdev->dev));
+		ret = -ENODEV;
+		goto err1;
+	}
+
+	ret = request_irq(irq, type_c_detect_irq,
+			IRQF_SHARED, "type_c_detect", type_c);
+
+	spin_lock_init(&type_c->lock);
+	type_c->chip_id = get_rtd_chip_id();
+	type_c->chip_revision = get_rtd_chip_revision();
+
+	if (node && of_device_is_available(node)) {
+		gpio = of_get_named_gpio(node, "realtek,rd_ctrl-gpio", 0);
+
+		if (gpio_is_valid(gpio)) {
+			type_c->rd_ctrl_gpio = gpio;
+			dev_info(dev, "%s get rd_ctrl-gpio (id=%d) OK\n", __func__, gpio);
+		} else {
+			type_c->rd_ctrl_gpio = -1;
+			if ((type_c->chip_id & 0xFFF0) == CHIP_ID_RTD129X)
+				dev_err(dev, "Error rd_ctrl-gpio no found for RTD%x",
+					    type_c->chip_id);
+		}
+
+		ret = of_property_read_u32(node, "boot_check_time",
+			&type_c->boot_check_time);
+		if (ret) {
+			type_c->boot_check_time = -1; //ms
+		}
+		dev_info(dev, "Set device mode boot_check_time %d ms "
+			    "==> (%s to check)\n",
+			    type_c->boot_check_time,
+			    type_c->boot_check_time<0?"Disable":"Enable");
+
+		if (of_property_read_bool(node, "filter_config_channel_signal"))
+			type_c->filter_config_channel_signal = true;
+		else
+			type_c->filter_config_channel_signal = false;
+		dev_info(dev, "Set filter_config_channel_signal is %s\n",
+			    type_c->filter_config_channel_signal?"True":"False");
+
+	}
+
+	if (node && of_device_is_available(node)) {
+		const char *str;
+		u32 val;
+		struct device_node *sub_node;
+		u8 array_vals[3];
+		u32 u32_vals[3];
+		u32 default_revision;
+		char revision[4] = {0};
+
+		ret = of_property_read_u32(node, "default_revision",
+			    &default_revision);
+		if (ret) {
+			default_revision = 0xA00;
+			dev_info(dev, "%s: No set default_revision (use %x)\n",
+				    __func__, default_revision);
+		}
+
+		if (type_c->chip_revision > default_revision)
+			snprintf(revision, 4, "%X", default_revision);
+		else
+			snprintf(revision, 4, "%X", type_c->chip_revision);
+		dev_info(dev, "Chip %x revision is %x (support revision %x) "
+			    "to load %s parameter\n",
+			    type_c->chip_id, type_c->chip_revision,
+			    default_revision, revision);
+		sub_node = of_get_child_by_name(node, revision);
+
+		ret = of_property_read_string(sub_node, "cc_dfp_mode", &str);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc_dfp_mode error(%d)\n", __func__, ret);
+			goto err1;
+		}
+		if (!strcmp(str, "dfp_usb")) {
+			type_c->cc_dfp_mode = CC_MODE_DFP_USB;
+			type_c->cc1_rp = En_rp12k;
+			type_c->cc2_rp = En_rp12k;
+		} else if (!strcmp(str, "dfp_1_5")) {
+			type_c->cc_dfp_mode = CC_MODE_DFP_1_5;
+			type_c->cc1_rp = En_rp36k;
+			type_c->cc2_rp = En_rp36k;
+		} else if (!strcmp(str, "dfp_3_0")) {
+			type_c->cc_dfp_mode = CC_MODE_DFP_3_0;
+			type_c->cc1_rp = En_rp4p7k;
+			type_c->cc2_rp = En_rp4p7k;
+		} else {
+			dev_err(&pdev->dev, "%s: unknown cc_dfp_mode %s\n", __func__, str);
+		}
+
+		//cc1 parameters
+		ret = of_property_read_u32(sub_node, "cc1_rp_4p7k_code", &u32_vals[0]);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc1_rp_4p7k_code error(%d)\n",
+				    __func__, u32_vals[0]);
+			goto err1;
+		}
+		ret = of_property_read_u32(sub_node, "cc1_rp_36k_code", &u32_vals[1]);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc1_rp_36k_code error(%d)\n", __func__,
+				    u32_vals[1]);
+			goto err1;
+		}
+		ret = of_property_read_u32(sub_node, "cc1_rp_12k_code", &u32_vals[2]);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc1_rp_12k_code error(%d)\n",
+				    __func__, u32_vals[2]);
+			goto err1;
+		}
+		type_c->cc1_rp_code = rp4pk_code(u32_vals[0])
+				| rp36k_code(u32_vals[1])
+				| rp12k_code(u32_vals[2]);
+
+		ret = of_property_read_string(sub_node, "rd_config", &str);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: rd_config error(%d)\n", __func__, ret);
+			goto err1;
+		}
+		ret = of_property_read_u32(sub_node, "cc1_rd_code", &val);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc1_rd_code error(%d)\n", __func__, ret);
+			goto err1;
+		}
+		if (!strcmp(str, "internal")) {
+			type_c->rd_config = INTERNAL_Rd;
+			type_c->cc1_rd_code = rd_code(val);
+		} else if (!strcmp(str, "external")) {
+			type_c->rd_config = EXTERNAL_Rd;
+			type_c->cc1_rd_code = 0x0;
+		} else {
+			dev_err(&pdev->dev, "%s: unknown rd_config %s, cc1_rd_code=%d\n",
+				    __func__, str, val);
+		}
+		ret = of_property_read_u8_array(sub_node, "cc1_vref_ufp",
+			    array_vals, 3);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc1_vref_ufp error(%d)\n", __func__, ret);
+			goto err1;
+		}
+		type_c->cc1_vref_ufp = vref_1p23v(array_vals[0]) |
+			    vref_0p66v(array_vals[1]) | vref_0p2v(array_vals[2]);
+
+		ret = of_property_read_u8_array(sub_node, "cc1_vref_dfp_usb",
+			    array_vals, 3);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc1_vref_dfp_usb error(%d)\n",
+				    __func__, ret);
+			goto err1;
+		}
+		type_c->cc1_vref_dfp_usb = vref_0_1p6v(array_vals[0]) |
+			    vref_0p2v(array_vals[1]);
+
+		ret = of_property_read_u8_array(sub_node, "cc1_vref_dfp_1_5",
+			    array_vals, 3);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc1_vref_dfp_1_5 error(%d)\n",
+				    __func__, ret);
+			goto err1;
+		}
+		type_c->cc1_vref_dfp_1_5 = vref_1_1p6v(array_vals[0]) |
+			     vref_0p4v(array_vals[1]) | vref_0p2v(array_vals[2]);
+
+		ret = of_property_read_u8_array(sub_node, "cc1_vref_dfp_3_0",
+			    array_vals, 3);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc1_vref_dfp_3_0 error(%d)\n",
+				    __func__, ret);
+			goto err1;
+		}
+		type_c->cc1_vref_dfp_3_0 = vref_2p6v(array_vals[0]) |
+			    vref_0p8v(array_vals[1]) | vref_0p2v(array_vals[2]);
+
+		//cc2 parameters
+		ret = of_property_read_u32(sub_node, "cc2_rp_4p7k_code", &u32_vals[0]);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc2_rp_4p7k_code error(%d)\n",
+				    __func__, ret);
+			goto err1;
+		}
+		ret = of_property_read_u32(sub_node, "cc2_rp_36k_code", &u32_vals[1]);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc2_rp_36k_code error(%d)\n",
+				    __func__, ret);
+			goto err1;
+		}
+		ret = of_property_read_u32(sub_node, "cc2_rp_12k_code", &u32_vals[2]);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc2_rp_12k_code error(%d)\n",
+				    __func__, ret);
+			goto err1;
+		}
+		type_c->cc2_rp_code = rp4pk_code(array_vals[0])
+				| rp36k_code(array_vals[1])
+				| rp12k_code(array_vals[2]);
+
+		ret = of_property_read_string(sub_node, "rd_config", &str);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: rd_config error(%d)\n", __func__, ret);
+			goto err1;
+		}
+		ret = of_property_read_u32(sub_node, "cc2_rd_code", &val);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc2_rd_code error(%d)\n", __func__, ret);
+			goto err1;
+		}
+		if (!strcmp(str, "internal")) {
+			type_c->cc2_rd_code = rd_code(val);
+		} else if (!strcmp(str, "external")) {
+			type_c->cc2_rd_code = 0x0;
+		} else {
+			dev_err(&pdev->dev, "%s: unknown rd_code %s, cc2_rd_code=%d\n",
+				    __func__, str, val);
+		}
+
+		ret = of_property_read_u8_array(sub_node, "cc2_vref_ufp",
+			    array_vals, 3);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc2_vref_ufp error(%d)\n", __func__, ret);
+			goto err1;
+		}
+		type_c->cc2_vref_ufp = vref_1p23v(array_vals[0]) |
+			    vref_0p66v(array_vals[1]) | vref_0p2v(array_vals[2]);
+
+		ret = of_property_read_u8_array(sub_node, "cc2_vref_dfp_usb",
+			    array_vals, 3);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc2_vref_dfp_usb error(%d)\n",
+				    __func__, ret);
+			goto err1;
+		}
+		type_c->cc2_vref_dfp_usb = vref_0_1p6v(array_vals[0]) |
+			    vref_0p2v(array_vals[1]);
+
+		ret = of_property_read_u8_array(sub_node, "cc2_vref_dfp_1_5",
+			    array_vals, 3);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc2_vref_dfp_1_5 error(%d)\n",
+				    __func__, ret);
+			goto err1;
+		}
+		type_c->cc2_vref_dfp_1_5 = vref_1_1p6v(array_vals[0]) |
+			    vref_0p4v(array_vals[1]) | vref_0p2v(array_vals[2]);
+
+		ret = of_property_read_u8_array(sub_node, "cc2_vref_dfp_3_0",
+			    array_vals, 3);
+		if (ret) {
+			dev_err(&pdev->dev, "%s: cc2_vref_dfp_3_0 error(%d)\n",
+				    __func__, ret);
+			goto err1;
+		}
+		type_c->cc2_vref_dfp_3_0 = vref_2p6v(array_vals[0]) |
+			    vref_0p8v(array_vals[1]) | vref_0p2v(array_vals[2]);
+
+		type_c->debounce_val = 0x7f;// 1b,1us 7f,4.7us
+	}
+
+	if (true) {
+		struct device_node	*parent_node;
+		struct device_node	*next_node;
+
+		parent_node = of_get_parent(node);
+		next_node = of_get_next_child(parent_node, NULL);
+		if (next_node != NULL) {
+			type_c->dwc = platform_get_drvdata(
+				    of_find_device_by_node(next_node));
+		} else {
+			dev_err(dev, "%s No find dwc3_drd", __func__);
+			ret = -ENODEV;
+			goto err1;
+		}
+		if (type_c->dwc) {
+			type_c->dwc3_mode = type_c->dwc->dr_mode;
+		} else {
+			dev_err(dev, "%s dwc3_drd device dwc is NULL", __func__);
+			ret = -ENODEV;
+			goto err1;
+		}
+	}
+
+	type_c->cur_mode = USB_DR_MODE_UNKNOWN;
+	type_c->is_attach = IN_DETACH;
+	type_c->support_drd_mode = false;
+	type_c->is_role_swap = NO_ROLE_SWAP;
+	if (of_property_read_bool(node, "drd_mode")) {
+		if (type_c->dwc3_mode == USB_DR_MODE_PERIPHERAL) {
+			type_c->support_drd_mode = true;
+			dev_info(dev, "DWC3_DRD is DRD mode");
+		} else {
+			dev_info(dev, "DWC3_DRD is not DRD mode, "
+				   "due to dwc3_mode=USB_DR_MODE_HOST");
+		}
+	} else {
+		dev_dbg(dev, "DWC3_DRD is no drd_mode, and dwc3_mode=%d",
+			    type_c->dwc3_mode);
+	}
+
+	if (of_property_read_bool(node, "debug")) {
+		dev_info(&pdev->dev, "%s device tree set debug flag\n", __func__);
+		type_c->debug = true;
+	} else {
+		type_c->debug = false;
+	}
+
+	INIT_DELAYED_WORK(&type_c->delayed_work, host_device_switch);
+	INIT_DELAYED_WORK(&type_c->boot_check_work, boot_time_check);
+
+	if (node) {
+		if (of_property_read_bool(node, "delay_probe_work")) {
+			INIT_WORK(&type_c->start_work, dwc3_rtk_type_c_probe_work);
+
+			if (of_property_read_bool(node, "ordered_probe"))
+				rtk_usb_manager_schedule_work(dev, &type_c->start_work);
+			else
+				schedule_work(&type_c->start_work);
+		} else {
+			ret = dwc3_rtk_type_c_init(type_c);
+			if (ret) {
+				dev_err(dev, "%s failed to init type_c\n", __func__);
+				goto err1;
+			}
+		}
+	} else {
+		dev_err(dev, "no device node, failed to init type_c\n");
+		ret = -ENODEV;
+		goto err1;
+	}
+
+	platform_set_drvdata(pdev, type_c);
+
+	device_create_file(type_c->dev, &dev_attr_role_swap);
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	create_debug_files(type_c);
+#endif
+
+	dev_info(&pdev->dev, "Exit %s OK (take %d ms)\n", __func__,
+		    jiffies_to_msecs(jiffies - probe_time));
+	return 0;
+
+err1:
+	dev_err(&pdev->dev, "%s: Probe fail, %d\n", __func__, ret);
+
+	return ret;
+}
+
+static int dwc3_rtk_type_c_remove(struct platform_device *pdev)
+{
+	struct device		*dev = &pdev->dev;
+	struct type_c_data *type_c = dev_get_drvdata(dev);
+	u32 default_ctrl;
+	unsigned long		flags;
+
+	dev_info(dev, "[USB] Enter %s", __func__);
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	debugfs_remove_recursive(type_c->debug_dir);
+#endif
+
+	device_remove_file(type_c->dev, &dev_attr_role_swap);
+
+	cancel_delayed_work_sync(&type_c->delayed_work);
+	flush_delayed_work(&type_c->delayed_work);
+	BUG_ON(delayed_work_pending(&type_c->delayed_work));
+
+	cancel_delayed_work_sync(&type_c->boot_check_work);
+	flush_delayed_work(&type_c->boot_check_work);
+	BUG_ON(delayed_work_pending(&type_c->boot_check_work));
+
+	spin_lock_irqsave(&type_c->lock, flags);
+	//disable interrupt
+	default_ctrl = readl(type_c->type_c_reg_base + USB_TYPEC_CTRL) &
+		    debounce_time_MASK;
+	writel(default_ctrl, type_c->type_c_reg_base + USB_TYPEC_CTRL);
+
+	spin_unlock_irqrestore(&type_c->lock, flags);
+
+	dev_info(&pdev->dev, "[USB] Exit %s\n", __func__);
+	return 0;
+}
+
+#ifdef CONFIG_OF
+static const struct of_device_id rtk_dwc3_type_c_match[] = {
+	{ .compatible = "Realtek,dwc3-type_c" },
+	{ .compatible = "Realtek,rtd1295-dwc3-type_c" },
+	{ .compatible = "Realtek,rtd1296-dwc3-type_c" },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_dwc3_type_c_match);
+#endif
+
+#ifdef CONFIG_PM_SLEEP
+static int dwc3_rtk_type_c_prepare(struct device *dev) {
+	struct type_c_data *type_c = dev_get_drvdata(dev);
+	u32 default_ctrl;
+	unsigned long		flags;
+	int ret = 0;
+
+	dev_info(dev, "[USB] Enter %s\n", __func__);
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+	} else {
+		dev_info(dev,  "[USB] %s Suspend mode\n", __func__);
+	}
+
+	cancel_delayed_work_sync(&type_c->delayed_work);
+	flush_delayed_work(&type_c->delayed_work);
+	BUG_ON(delayed_work_pending(&type_c->delayed_work));
+
+	cancel_delayed_work_sync(&type_c->boot_check_work);
+	flush_delayed_work(&type_c->boot_check_work);
+	BUG_ON(delayed_work_pending(&type_c->boot_check_work));
+
+	spin_lock_irqsave(&type_c->lock, flags);
+	//disable interrupt
+	default_ctrl = readl(type_c->type_c_reg_base + USB_TYPEC_CTRL) &
+		    debounce_time_MASK;
+	writel(default_ctrl, type_c->type_c_reg_base + USB_TYPEC_CTRL);
+
+	spin_unlock_irqrestore(&type_c->lock, flags);
+
+	dev_info(dev, "[USB] Exit %s\n", __func__);
+	return ret;
+}
+
+static void dwc3_rtk_type_c_complete(struct device *dev) {
+	struct type_c_data *type_c = dev_get_drvdata(dev);
+	unsigned long		flags;
+
+	dev_info(dev, "[USB] Enter %s\n", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY){
+		//For idle mode
+		dev_info(dev, "[USB] %s S1 (Standby mode)\n", __func__);
+
+		spin_lock_irqsave(&type_c->lock, flags);
+		//enable interrupt
+		if (type_c->is_attach == IN_ATTACH)
+			enable_writel(ENABLE_TYPE_C_DETECT,
+				    type_c->type_c_reg_base + USB_TYPEC_CTRL);
+
+		schedule_delayed_work(&type_c->delayed_work, msecs_to_jiffies(1));
+		spin_unlock_irqrestore(&type_c->lock, flags);
+	} else {
+		dev_info(dev, "[USB] %s S3 (Suspend-to-RAM mode)\n", __func__);
+	}
+
+	dev_info(dev, "[USB] Exit %s\n", __func__);
+}
+
+static int dwc3_rtk_type_c_suspend(struct device *dev)
+{
+	struct type_c_data *type_c = dev_get_drvdata(dev);
+	unsigned long		flags;
+
+	dev_info(dev, "[USB] Enter %s", __func__);
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		goto out;
+	}
+	//For suspend mode
+	dev_info(dev,  "[USB] %s Suspend mode\n", __func__);
+
+	if (!rtk_usb_manager_is_iso_mode(type_c->dev)) {
+		rtk_usb_type_c_power_on_off(type_c->dev, false);
+	}
+
+	if (type_c->rd_ctrl_gpio != -1)
+		gpio_free(type_c->rd_ctrl_gpio);
+
+out:
+	dev_info(dev, "[USB] Exit %s\n", __func__);
+	return 0;
+}
+
+static int dwc3_rtk_type_c_resume(struct device *dev)
+{
+	struct type_c_data *type_c = dev_get_drvdata(dev);
+	unsigned long		flags;
+	bool reinit = false;
+
+
+	dev_info(dev, "[USB] Enter %s", __func__);
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		goto out;
+	}
+
+	//For suspend mode
+	dev_info(dev, "[USB] %s Suspend mode\n", __func__);
+
+	if (rtk_usb_manager_is_iso_mode(type_c->dev)) {
+		spin_lock_irqsave(&type_c->lock, flags);
+		//enable interrupt
+		if (type_c->is_attach == IN_ATTACH)
+			enable_writel(ENABLE_TYPE_C_DETECT,
+			    type_c->type_c_reg_base + USB_TYPEC_CTRL);
+		else
+			reinit = true;
+		spin_unlock_irqrestore(&type_c->lock, flags);
+	} else {
+		dev_info(dev, "[USB] %s reinit dwc3_rtk_type_c_init (Not iso mode\n)",
+			    __func__);
+
+		if (type_c->is_attach == IN_ATTACH) {
+			u32 enable_cc;
+
+			rtk_type_c_init(type_c);
+			enable_writel(ENABLE_TYPE_C_DETECT,
+			    type_c->type_c_reg_base + USB_TYPEC_CTRL);
+			enable_cc = type_c->at_cc1?enable_cc1:enable_cc2;
+			switch_type_c_plug_config(type_c, type_c->cur_mode, enable_cc);
+
+			if (type_c->cur_mode == USB_DR_MODE_HOST)
+				rtk_usb_type_c_power_on_off(type_c->dev, true);
+		} else {
+			reinit = true;
+		}
+	}
+
+	if (reinit)
+		dwc3_rtk_type_c_init(type_c);
+
+out:
+	dev_info(dev, "[USB] Exit %s\n", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops dwc3_rtk_type_c_pm_ops = {
+	SET_LATE_SYSTEM_SLEEP_PM_OPS(dwc3_rtk_type_c_suspend, dwc3_rtk_type_c_resume)
+	.prepare = dwc3_rtk_type_c_prepare,
+	.complete = dwc3_rtk_type_c_complete,
+};
+
+#define DEV_PM_OPS	(&dwc3_rtk_type_c_pm_ops)
+#else
+#define DEV_PM_OPS	NULL
+#endif /* CONFIG_PM_SLEEP */
+
+static struct platform_driver dwc3_rtk_type_c_driver = {
+	.probe		= dwc3_rtk_type_c_probe,
+	.remove		= dwc3_rtk_type_c_remove,
+	.driver		= {
+		.name	= "rtk-dwc3-type_c",
+		.of_match_table = of_match_ptr(rtk_dwc3_type_c_match),
+		.pm = DEV_PM_OPS,
+	},
+};
+
+static int __init dwc3_rtk_type_c_driver_init(void)
+{
+	return platform_driver_register(&(dwc3_rtk_type_c_driver));
+}
+module_init(dwc3_rtk_type_c_driver_init);
+
+static void __exit dwc3_rtk_type_c_driver_exit(void)
+{
+	platform_driver_unregister(&(dwc3_rtk_type_c_driver));
+}
+module_exit(dwc3_rtk_type_c_driver_exit);
+
+MODULE_ALIAS("platform:rtk-dwc3-type_c");
+MODULE_LICENSE("GPL");
+
diff --git a/drivers/usb/dwc3/dwc3-rtk.c b/drivers/usb/dwc3/dwc3-rtk.c
new file mode 100644
index 00000000..d3a7168
--- /dev/null
+++ b/drivers/usb/dwc3/dwc3-rtk.c
@@ -0,0 +1,476 @@
+/**
+ * dwc3-rtk.c - Realtek DWC3 Specific Glue layer
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/slab.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/clk.h>
+#include <linux/usb/otg.h>
+#include <linux/usb/usb_phy_generic.h>
+#include <linux/usb/of.h>
+#include <linux/of.h>
+#include <linux/of_platform.h>
+#include <linux/of_address.h>
+#include <linux/suspend.h>
+#include <soc/realtek/rtk_chip.h>
+
+#include "../host/xhci.h" //hcy test added
+#include "core.h" //hcy test added
+
+#define WRAP_CTR_reg  0x0
+#define USB2_PHY_reg  0x70
+
+#define EN_PHY_PLL_PORT0 BIT(12)
+#define EN_PHY_PLL_PORT1 BIT(13)
+#define DISABLE_MULTI_REQ BIT(1)
+#define USB2_PHY_SWITCH_MASK 0x707
+#define USB2_PHY_SWITCH_DEVICE 0x0
+#define USB2_PHY_SWITCH_HOST 0x606
+
+struct dwc3_rtk {
+	struct platform_device	*usb2_phy;
+	struct platform_device	*usb3_phy;
+	struct device		*dev;
+
+	void __iomem		*regs;
+	size_t		regs_size;
+
+	struct clk		*clk;
+	struct platform_device *dwc; //hjcy added
+
+	struct work_struct work;
+};
+
+#ifdef CONFIG_RTK_USB3PHY
+extern void rtk_usb3_phy_toggle(struct usb_phy *usb3_phy, bool isConnect,
+	    int port);
+#endif
+
+void RTK_dwc3_usb3_phy_toggle(struct device *hcd_dev, bool isConnect, int port)
+{
+	struct device *dwc3_dev = NULL;
+	struct dwc3 *dwc = NULL;
+	if (hcd_dev == NULL) return;
+
+	dwc3_dev = hcd_dev->parent;
+	if (dwc3_dev == NULL) return;
+
+	dwc = dev_get_drvdata(dwc3_dev);
+#ifdef CONFIG_RTK_USB3PHY
+	dev_dbg(dwc3_dev, "%s port=%d\n", __func__, port);
+	if (dwc != NULL)
+		rtk_usb3_phy_toggle(dwc->usb3_phy, isConnect, port);
+#endif
+}
+
+#ifdef CONFIG_RTK_USB2PHY
+extern void rtk_usb2_phy_toggle(struct usb_phy *usb3_phy, bool isConnect,
+	    int port);
+#endif
+
+int RTK_dwc3_usb2_phy_toggle(struct device *hcd_dev, bool isConnect, int port)
+{
+	struct device *dwc3_dev = NULL;
+	struct dwc3 *dwc = NULL;
+	if (hcd_dev == NULL) return -1;
+
+	dwc3_dev = hcd_dev->parent;
+	if (dwc3_dev == NULL) return -1;
+
+	dwc = dev_get_drvdata(dwc3_dev);
+	if (dwc == NULL) return -1;
+
+#ifdef CONFIG_RTK_USB2PHY
+	dev_dbg(dwc3_dev, "%s port=%d\n", __func__, port);
+	rtk_usb2_phy_toggle(dwc->usb2_phy, isConnect, port);
+#endif
+	return 0;
+}
+
+static int dwc3_rtk_register_phys(struct dwc3_rtk *rtk)
+{
+	struct usb_phy_generic_platform_data pdata;
+	struct platform_device	*pdev;
+	int			ret;
+
+	memset(&pdata, 0x00, sizeof(pdata));
+
+	pdev = platform_device_alloc("usb_phy_generic", PLATFORM_DEVID_AUTO);
+	if (!pdev)
+		return -ENOMEM;
+
+	rtk->usb2_phy = pdev;
+	pdata.type = USB_PHY_TYPE_USB2;
+
+	ret = platform_device_add_data(rtk->usb2_phy, &pdata, sizeof(pdata));
+	if (ret)
+		goto err1;
+
+	pdev = platform_device_alloc("usb_phy_generic", PLATFORM_DEVID_AUTO);
+	if (!pdev) {
+		ret = -ENOMEM;
+		goto err1;
+	}
+
+	rtk->usb3_phy = pdev;
+	pdata.type = USB_PHY_TYPE_USB3;
+
+	ret = platform_device_add_data(rtk->usb3_phy, &pdata, sizeof(pdata));
+	if (ret)
+		goto err2;
+
+	ret = platform_device_add(rtk->usb2_phy);
+	if (ret)
+		goto err2;
+
+	ret = platform_device_add(rtk->usb3_phy);
+	if (ret)
+		goto err3;
+
+	return 0;
+
+err3:
+	platform_device_del(rtk->usb2_phy);
+
+err2:
+	platform_device_put(rtk->usb3_phy);
+
+err1:
+	platform_device_put(rtk->usb2_phy);
+
+	return ret;
+}
+
+/*
+static int dwc3_rtk_remove_child(struct device *dev, void *unused)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+
+	platform_device_unregister(pdev);
+
+	return 0;
+}
+*/
+
+static void dwc3_rtk_int_dr_mode(struct dwc3_rtk *rtk, int dr_mode)
+{
+	switch (dr_mode) {
+	case USB_DR_MODE_PERIPHERAL:
+		writel(USB2_PHY_SWITCH_DEVICE |
+			    (~USB2_PHY_SWITCH_MASK & readl(rtk->regs + USB2_PHY_reg)),
+			    rtk->regs + USB2_PHY_reg);
+		break;
+	case USB_DR_MODE_HOST:
+		writel(USB2_PHY_SWITCH_HOST |
+			    (~USB2_PHY_SWITCH_MASK & readl(rtk->regs + USB2_PHY_reg)),
+			    rtk->regs + USB2_PHY_reg);
+		break;
+	case USB_DR_MODE_OTG:
+		//writel(BIT(11) , rtk->regs + USB2_PHY_reg);
+		dev_info(rtk->dev, "%s: USB_DR_MODE_OTG\n", __func__);
+		break;
+	}
+}
+
+static int dwc3_rtk_init(struct dwc3_rtk *rtk)
+{
+	struct device		*dev = rtk->dev;
+	//struct device_node	*node = dev->of_node;
+	void __iomem		*regs = rtk->regs;
+
+	if ((get_rtd_chip_id() == CHIP_ID_RTD1295 ||
+		    get_rtd_chip_id() == CHIP_ID_RTD1296) &&
+		    get_rtd_chip_revision() == RTD_CHIP_A00) {
+		writel(DISABLE_MULTI_REQ | readl(regs + WRAP_CTR_reg),
+				regs + WRAP_CTR_reg);
+		dev_info(dev, "[bug fixed] 1295/1296 A00: add workaround to "
+			    "disable multiple request for D-Bus");
+	}
+
+	if (get_rtd_chip_id() == CHIP_ID_RTD1395 ||
+		    get_rtd_chip_id() == CHIP_ID_RTD1392) {
+		writel(EN_PHY_PLL_PORT1 | readl(regs + USB2_PHY_reg),
+			    regs + USB2_PHY_reg);
+		dev_info(dev, "[bug fixed] 1395 add workaround to "
+			    "disable usb2 port 2 suspend!");
+
+	}
+	return 0;
+}
+
+extern void rtk_usb_init_port_power_on(struct device *dev);
+extern int rtk_usb_manager_schedule_work(struct device *usb_dev, struct work_struct *work);
+
+static int dwc3_rtk_probe_dwc3core(struct dwc3_rtk *rtk)
+{
+	struct device		*dev = rtk->dev;
+	struct device_node	*node = dev->of_node;
+	struct device_node	*next_node;
+	int    ret = 0;
+
+	dwc3_rtk_init(rtk);
+
+	if (node) {
+		ret = of_platform_populate(node, NULL, NULL, dev);
+		if (ret) {
+			dev_err(dev, "failed to add dwc3 core\n");
+			return ret;
+		}
+		/* hcy adde below */
+		//node =  of_find_compatible_node(NULL, NULL, "synopsys,dwc3");
+		next_node = of_get_next_child(node, NULL);
+		if (next_node != NULL) {
+			struct device *next_dev;
+			int dr_mode;
+
+			rtk->dwc = of_find_device_by_node(next_node);
+			next_dev = &(rtk->dwc)->dev;
+			dr_mode = usb_get_dr_mode(next_dev);
+			dwc3_rtk_int_dr_mode(rtk, dr_mode);
+
+			if (dr_mode == USB_DR_MODE_HOST)
+				rtk_usb_init_port_power_on(dev);
+		}
+	}
+
+	return ret;
+}
+
+static void dwc3_rtk_probe_work(struct work_struct *work)
+{
+	struct dwc3_rtk *rtk = container_of(work, struct dwc3_rtk, work);
+	struct device		*dev = rtk->dev;
+	int    ret = 0;
+
+	unsigned long probe_time = jiffies;
+
+	dev_info(dev, "%s Start ...\n", __func__);
+
+	ret = dwc3_rtk_probe_dwc3core(rtk);
+
+	if (ret)
+		dev_err(dev, "%s failed to add dwc3 core\n", __func__);
+
+	dev_info(dev, "%s End ... ok! (take %d ms)\n", __func__,
+		    jiffies_to_msecs(jiffies - probe_time));
+}
+
+static int dwc3_rtk_probe(struct platform_device *pdev)
+{
+	struct dwc3_rtk	*rtk;
+//	struct clk		*clk;
+	struct device		*dev = &pdev->dev;
+	struct device_node	*node = dev->of_node;
+
+	struct resource         *res;
+	void __iomem            *regs;
+
+	int			ret = -ENOMEM;
+	unsigned long probe_time = jiffies;
+
+	dev_info(&pdev->dev, "Probe Realtek-SoC USB DWC3 Host Controller\n");
+
+	rtk = devm_kzalloc(dev, sizeof(*rtk), GFP_KERNEL);
+	if (!rtk) {
+		dev_err(dev, "not enough memory\n");
+		goto err1;
+	}
+
+	/*
+	 * Right now device-tree probed devices don't get dma_mask set.
+	 * Since shared usb code relies on it, set it here for now.
+	 * Once we move to full device tree support this will vanish off.
+	 */
+	if (!dev->dma_mask)
+		dev->dma_mask = &dev->coherent_dma_mask;
+	if (!dev->coherent_dma_mask)
+		dev->coherent_dma_mask = DMA_BIT_MASK(32);
+
+	platform_set_drvdata(pdev, rtk);
+
+	ret = dwc3_rtk_register_phys(rtk);
+	if (ret) {
+		dev_err(dev, "couldn't register PHYs\n");
+		goto err1;
+	}
+
+	rtk->dev	= dev;
+
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (!res) {
+		dev_err(dev, "missing memory resource\n");
+		return -ENODEV;
+	}
+
+	regs = devm_ioremap_resource(dev, res);
+	if (IS_ERR(regs)) {
+		ret = PTR_ERR(regs);
+		goto err1;
+	}
+
+	rtk->regs = regs;
+	rtk->regs_size = resource_size(res);
+
+	if (node) {
+		if (of_property_read_bool(node, "dis_u3_port")) {
+			void __iomem *usb_hmac_ctr0 = rtk->regs + 0x60;
+			int val_u3port_dis = BIT(8) | readl(usb_hmac_ctr0);
+
+			writel(val_u3port_dis, usb_hmac_ctr0);
+
+			dev_info(rtk->dev, "%s: disable usb 3.0 port (usb_hmac_ctr0=%x)\n",
+				    __func__, readl(usb_hmac_ctr0));
+		}
+	}
+
+	if (node) {
+		if (of_property_read_bool(node, "delay_probe_work")) {
+			INIT_WORK(&rtk->work, dwc3_rtk_probe_work);
+			if (of_property_read_bool(node, "ordered_probe"))
+				rtk_usb_manager_schedule_work(dev, &rtk->work);
+			else
+				schedule_work(&rtk->work);
+		} else {
+			ret = dwc3_rtk_probe_dwc3core(rtk);
+			if (ret) {
+				dev_err(dev, "%s failed to add dwc3 core\n", __func__);
+				goto err2;
+			}
+		}
+	} else {
+		dev_err(dev, "no device node, failed to add dwc3 core\n");
+		ret = -ENODEV;
+		goto err2;
+	}
+	dev_info(dev, "dwc3_rtk_probe ok! (take %d ms)\n",
+		    jiffies_to_msecs(jiffies - probe_time));
+
+	return 0;
+
+err2:
+err1:
+	return ret;
+}
+
+static int dwc3_rtk_remove(struct platform_device *pdev)
+{
+	struct dwc3_rtk	*rtk = platform_get_drvdata(pdev);
+
+	of_platform_depopulate(rtk->dev);
+	//device_for_each_child(&pdev->dev, NULL, dwc3_rtk_remove_child);
+	platform_device_unregister(rtk->usb2_phy);
+	platform_device_unregister(rtk->usb3_phy);
+
+	clk_disable_unprepare(rtk->clk);
+
+	return 0;
+}
+
+static void dwc3_rtk_shutdown(struct platform_device *pdev)
+{
+	struct dwc3_rtk	*rtk = platform_get_drvdata(pdev);
+	struct device		*dev = &pdev->dev;
+
+	dev_info(dev, "dwc3_rtk_shutdown start ...\n");
+
+	of_platform_depopulate(rtk->dev);
+	//device_for_each_child(&pdev->dev, NULL, dwc3_rtk_remove_child);
+	platform_device_unregister(rtk->usb2_phy);
+	platform_device_unregister(rtk->usb3_phy);
+
+	clk_disable_unprepare(rtk->clk);
+	dev_info(dev, "dwc3_rtk_shutdown ok!\n");
+	return 0;
+}
+
+#ifdef CONFIG_OF
+static const struct of_device_id rtk_dwc3_match[] = {
+	{ .compatible = "Realtek,dwc3" },
+	{ .compatible = "Realtek,rtk119x-dwc3" },
+	{ .compatible = "Realtek,rtd129x-dwc3-drd" },
+	{ .compatible = "Realtek,rtd129x-dwc3-u2h" },
+	{ .compatible = "Realtek,rtd129x-dwc3-u3h" },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_dwc3_match);
+#endif
+
+#ifdef CONFIG_PM_SLEEP
+static int dwc3_rtk_suspend(struct device *dev)
+{
+	dev_info(dev, "[USB] Enter %s", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		goto out;
+	}
+	//For suspend mode
+	dev_info(dev,  "[USB] %s Suspend mode\n", __func__);
+
+out:
+	dev_info(dev, "[USB] Exit %s", __func__);
+	return 0;
+}
+
+static int dwc3_rtk_resume(struct device *dev)
+{
+	struct dwc3_rtk *rtk = dev_get_drvdata(dev);
+	struct dwc3 *dwc = platform_get_drvdata(rtk->dwc);
+
+	dev_info(dev, "[USB] Enter %s", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		goto out;
+	}
+	//For suspend mode
+	dev_info(dev,  "[USB] %s Suspend mode\n", __func__);
+
+	dwc3_rtk_init(rtk);
+
+	dwc3_rtk_int_dr_mode(rtk, dwc->dr_mode);
+
+	/* runtime set active to reflect active state. */
+	pm_runtime_disable(dev);
+	pm_runtime_set_active(dev);
+	pm_runtime_enable(dev);
+
+out:
+	dev_info(dev, "[USB] Exit %s", __func__);
+	return 0;
+}
+
+static const struct dev_pm_ops dwc3_rtk_dev_pm_ops = {
+	SET_SYSTEM_SLEEP_PM_OPS(dwc3_rtk_suspend, dwc3_rtk_resume)
+};
+
+#define DEV_PM_OPS	(&dwc3_rtk_dev_pm_ops)
+#else
+#define DEV_PM_OPS	NULL
+#endif /* CONFIG_PM_SLEEP */
+
+static struct platform_driver dwc3_rtk_driver = {
+	.probe		= dwc3_rtk_probe,
+	.remove		= dwc3_rtk_remove,
+	.driver		= {
+		.name	= "rtk-dwc3",
+		.of_match_table = of_match_ptr(rtk_dwc3_match),
+		.pm	= DEV_PM_OPS,
+	},
+	.shutdown 	= dwc3_rtk_shutdown,
+};
+
+module_platform_driver(dwc3_rtk_driver);
+
+MODULE_ALIAS("platform:rtk-dwc3");
+MODULE_LICENSE("GPL");
diff --git a/drivers/usb/dwc3/gadget.c b/drivers/usb/dwc3/gadget.c
index 26efe8c..3dc6719 100644
--- a/drivers/usb/dwc3/gadget.c
+++ b/drivers/usb/dwc3/gadget.c
@@ -27,6 +27,10 @@
 #include <linux/list.h>
 #include <linux/dma-mapping.h>
 
+#ifdef CONFIG_USB_DWC3_RTK
+#include <linux/of_device.h>
+#endif
+
 #include <linux/usb/ch9.h>
 #include <linux/usb/gadget.h>
 
@@ -1614,6 +1618,10 @@ static void dwc3_gadget_setup_nump(struct dwc3 *dwc)
 	u32 nump;
 	u32 reg;
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	dev_dbg(dwc->dev, "%s Enter \n", __func__);
+#endif
+
 	ram2_depth = DWC3_GHWPARAMS7_RAM2_DEPTH(dwc->hwparams.hwparams7);
 	mdwidth = DWC3_GHWPARAMS0_MDWIDTH(dwc->hwparams.hwparams0);
 
@@ -1714,6 +1722,10 @@ static int __dwc3_gadget_start(struct dwc3 *dwc)
 
 	dwc3_gadget_enable_irq(dwc);
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	dev_dbg(dwc->dev, "%s Exit\n", __func__);
+#endif
+
 	return 0;
 
 err1:
@@ -1751,6 +1763,10 @@ static int dwc3_gadget_start(struct usb_gadget *g,
 
 	dwc->gadget_driver	= driver;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	dwc->link_state = 0;
+#endif
+
 	if (pm_runtime_active(dwc->dev))
 		__dwc3_gadget_start(dwc);
 
@@ -1784,6 +1800,9 @@ static int dwc3_gadget_stop(struct usb_gadget *g)
 	spin_lock_irqsave(&dwc->lock, flags);
 	__dwc3_gadget_stop(dwc);
 	dwc->gadget_driver	= NULL;
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	dwc->link_state = 0;
+#endif
 	spin_unlock_irqrestore(&dwc->lock, flags);
 
 	free_irq(dwc->irq_gadget, dwc->ev_buf);
@@ -2849,7 +2868,12 @@ static irqreturn_t dwc3_process_event_buf(struct dwc3_event_buffer *evt)
 		evt->lpos = (evt->lpos + 4) % DWC3_EVENT_BUFFERS_SIZE;
 		left -= 4;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+		if (dwc->revision < DWC3_REVISION_300A)
+			dwc3_writel(dwc->regs, DWC3_GEVNTCOUNT(0), 4);
+#else
 		dwc3_writel(dwc->regs, DWC3_GEVNTCOUNT(0), 4);
+#endif
 	}
 
 	evt->count = 0;
@@ -2861,6 +2885,10 @@ static irqreturn_t dwc3_process_event_buf(struct dwc3_event_buffer *evt)
 	reg &= ~DWC3_GEVNTSIZ_INTMASK;
 	dwc3_writel(dwc->regs, DWC3_GEVNTSIZ(0), reg);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (dwc->revision >= DWC3_REVISION_300A)
+		dwc3_writel(dwc->regs, DWC3_GEVNTCOUNT(0), DWC3_EVNT_HANDLER_BUSY);
+#endif
 	return ret;
 }
 
@@ -2897,14 +2925,22 @@ static irqreturn_t dwc3_check_event_buf(struct dwc3_event_buffer *evt)
 	 * irq event handler completes before caching new event to prevent
 	 * losing events.
 	 */
+#ifndef CONFIG_USB_PATCH_ON_RTK
 	if (evt->flags & DWC3_EVENT_PENDING)
 		return IRQ_HANDLED;
+#endif
 
 	count = dwc3_readl(dwc->regs, DWC3_GEVNTCOUNT(0));
 	count &= DWC3_GEVNTCOUNT_MASK;
 	if (!count)
 		return IRQ_NONE;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (evt->flags & DWC3_EVENT_PENDING) {
+		return IRQ_NONE;
+	}
+#endif
+
 	evt->count = count;
 	evt->flags |= DWC3_EVENT_PENDING;
 
@@ -2913,6 +2949,11 @@ static irqreturn_t dwc3_check_event_buf(struct dwc3_event_buffer *evt)
 	reg |= DWC3_GEVNTSIZ_INTMASK;
 	dwc3_writel(dwc->regs, DWC3_GEVNTSIZ(0), reg);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (dwc->revision >= DWC3_REVISION_300A)
+		dwc3_writel(dwc->regs, DWC3_GEVNTCOUNT(0), count);
+#endif
+
 	return IRQ_WAKE_THREAD;
 }
 
@@ -2934,6 +2975,11 @@ int dwc3_gadget_init(struct dwc3 *dwc)
 	int ret, irq;
 	struct platform_device *dwc3_pdev = to_platform_device(dwc->dev);
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	if (dwc->has_gadget) return;
+	dev_info(dwc->dev, "%s Enter\n", __func__);
+#endif
+
 	irq = platform_get_irq_byname(dwc3_pdev, "peripheral");
 	if (irq == -EPROBE_DEFER)
 		return irq;
@@ -2996,6 +3042,10 @@ int dwc3_gadget_init(struct dwc3 *dwc)
 		goto err4;
 	}
 
+#ifdef CONFIG_USB_DWC3_RTK
+	of_dma_configure(&dwc->gadget.dev, NULL);
+#endif
+
 	dwc->gadget.ops			= &dwc3_gadget_ops;
 	dwc->gadget.speed		= USB_SPEED_UNKNOWN;
 	dwc->gadget.sg_supported	= true;
@@ -3046,6 +3096,10 @@ int dwc3_gadget_init(struct dwc3 *dwc)
 		goto err5;
 	}
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	dwc->has_gadget = true;
+	dev_info(dwc->dev, "%s Exit\n", __func__);
+#endif
 	return 0;
 
 err5:
@@ -3075,6 +3129,13 @@ int dwc3_gadget_init(struct dwc3 *dwc)
 
 void dwc3_gadget_exit(struct dwc3 *dwc)
 {
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	if (!dwc->has_gadget) return;
+
+	dev_info(dwc->dev, "%s Enter\n", __func__);
+	dwc->has_gadget = false;
+#endif
+
 	usb_del_gadget_udc(&dwc->gadget);
 
 	dwc3_gadget_free_endpoints(dwc);
@@ -3090,10 +3151,26 @@ void dwc3_gadget_exit(struct dwc3 *dwc)
 
 	dma_free_coherent(dwc->dev, sizeof(*dwc->ctrl_req),
 			dwc->ctrl_req, dwc->ctrl_req_addr);
+
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	memset(&dwc->gadget, 0x00, sizeof(dwc->gadget));
+
+	dev_info(dwc->dev, "%s Exit\n", __func__);
+#endif
 }
 
 int dwc3_gadget_suspend(struct dwc3 *dwc)
 {
+	int ret;
+
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	dev_info(dwc->dev, "[USB] Enter %s", __func__);
+	if (!dwc->has_gadget) {
+		dev_info(dwc->dev, "[USB] Exit %s (by no gadget)", __func__);
+		return 0;
+	}
+#endif
+
 	if (!dwc->gadget_driver)
 		return 0;
 
@@ -3101,6 +3178,9 @@ int dwc3_gadget_suspend(struct dwc3 *dwc)
 	dwc3_disconnect_gadget(dwc);
 	__dwc3_gadget_stop(dwc);
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	dev_info(dwc->dev, "[USB] Exit %s", __func__);
+#endif
 	return 0;
 }
 
@@ -3111,6 +3191,14 @@ int dwc3_gadget_resume(struct dwc3 *dwc)
 	if (!dwc->gadget_driver)
 		return 0;
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	dev_info(dwc->dev, "[USB] Enter %s", __func__);
+	if (!dwc->has_gadget) {
+		dev_info(dwc->dev, "[USB] Exit %s (by no gadget)", __func__);
+		return 0;
+	}
+#endif
+
 	ret = __dwc3_gadget_start(dwc);
 	if (ret < 0)
 		goto err0;
@@ -3119,6 +3207,10 @@ int dwc3_gadget_resume(struct dwc3 *dwc)
 	if (ret < 0)
 		goto err1;
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	dev_info(dwc->dev, "[USB] Exit %s", __func__);
+#endif
+
 	return 0;
 
 err1:
diff --git a/drivers/usb/dwc3/host.c b/drivers/usb/dwc3/host.c
index 626d87d..089de58 100644
--- a/drivers/usb/dwc3/host.c
+++ b/drivers/usb/dwc3/host.c
@@ -17,8 +17,15 @@
 
 #include <linux/platform_device.h>
 
+#ifdef CONFIG_USB_DWC3_RTK
+#include <linux/of_device.h>
+#endif
+
 #include "core.h"
 
+#ifdef CONFIG_XEN_USBHOST_FRONTEND
+extern int rtk_xen_usb_host_irq;
+#endif
 int dwc3_host_init(struct dwc3 *dwc)
 {
 	struct property_entry	props[3];
@@ -61,18 +68,28 @@ int dwc3_host_init(struct dwc3 *dwc)
 		res = platform_get_resource_byname(dwc3_pdev, IORESOURCE_IRQ,
 						   "host");
 	}
-
+#ifdef CONFIG_XEN_USBHOST_FRONTEND
+	irq = rtk_xen_usb_host_irq;
+#endif
 	dwc->xhci_resources[1].start = irq;
 	dwc->xhci_resources[1].end = irq;
 	dwc->xhci_resources[1].flags = res->flags;
 	dwc->xhci_resources[1].name = res->name;
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	dev_info(dwc->dev, "%s\n", __func__);
+#endif
+
 	xhci = platform_device_alloc("xhci-hcd", PLATFORM_DEVID_AUTO);
 	if (!xhci) {
 		dev_err(dwc->dev, "couldn't allocate xHCI device\n");
 		return -ENOMEM;
 	}
 
+#ifdef CONFIG_USB_DWC3_RTK
+	of_dma_configure(&xhci->dev, NULL);
+#endif
+
 	dma_set_coherent_mask(&xhci->dev, dwc->dev->coherent_dma_mask);
 
 	xhci->dev.parent	= dwc->dev;
@@ -80,6 +97,9 @@ int dwc3_host_init(struct dwc3 *dwc)
 	xhci->dev.dma_parms	= dwc->dev->dma_parms;
 
 	dwc->xhci = xhci;
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	dwc->has_xhci = true;
+#endif
 
 	ret = platform_device_add_resources(xhci, dwc->xhci_resources,
 						DWC3_XHCI_RESOURCES_NUM);
@@ -141,5 +161,8 @@ void dwc3_host_exit(struct dwc3 *dwc)
 			  dev_name(&dwc->xhci->dev));
 	phy_remove_lookup(dwc->usb3_generic_phy, "usb3-phy",
 			  dev_name(&dwc->xhci->dev));
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	dwc->has_xhci = false;
+#endif
 	platform_device_unregister(dwc->xhci);
 }
diff --git a/drivers/usb/dwc3/io.h b/drivers/usb/dwc3/io.h
index a06f9a8..43a71b1 100644
--- a/drivers/usb/dwc3/io.h
+++ b/drivers/usb/dwc3/io.h
@@ -24,10 +24,21 @@
 #include "debug.h"
 #include "core.h"
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+/* Add global lock for emmc issue*/
+#include <soc/realtek/rtd129x_lockapi.h>
+#endif
+
 static inline u32 dwc3_readl(void __iomem *base, u32 offset)
 {
 	u32 value;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Add global lock for emmc issue*/
+	unsigned long flags;
+	rtk_lockapi_lock(flags, __FUNCTION__);
+#endif
+
 	/*
 	 * We requested the mem region starting from the Globals address
 	 * space, see dwc3_probe in core.c.
@@ -35,6 +46,11 @@ static inline u32 dwc3_readl(void __iomem *base, u32 offset)
 	 */
 	value = readl(base + offset - DWC3_GLOBALS_REGS_START);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Add global lock for emmc issue*/
+	rtk_lockapi_unlock(flags,__FUNCTION__);
+#endif
+
 	/*
 	 * When tracing we want to make it easy to find the correct address on
 	 * documentation, so we revert it back to the proper addresses, the
@@ -48,6 +64,11 @@ static inline u32 dwc3_readl(void __iomem *base, u32 offset)
 
 static inline void dwc3_writel(void __iomem *base, u32 offset, u32 value)
 {
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	unsigned long flags;
+	rtk_lockapi_lock(flags, __FUNCTION__);
+#endif
+
 	/*
 	 * We requested the mem region starting from the Globals address
 	 * space, see dwc3_probe in core.c.
@@ -55,6 +76,10 @@ static inline void dwc3_writel(void __iomem *base, u32 offset, u32 value)
 	 */
 	writel(value, base + offset - DWC3_GLOBALS_REGS_START);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	rtk_lockapi_unlock(flags,__FUNCTION__);
+#endif
+
 	/*
 	 * When tracing we want to make it easy to find the correct address on
 	 * documentation, so we revert it back to the proper addresses, the
diff --git a/drivers/usb/dwc3/rtk-rts5400.c b/drivers/usb/dwc3/rtk-rts5400.c
new file mode 100644
index 00000000..6088508
--- /dev/null
+++ b/drivers/usb/dwc3/rtk-rts5400.c
@@ -0,0 +1,729 @@
+/**
+ * rtk-rts5400.c - Realtek RTS5400 Type C driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/device.h>
+#include <linux/kernel.h>
+#include <linux/slab.h>
+#include <linux/module.h>
+#include <linux/i2c.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_gpio.h>
+
+#include <linux/delay.h>
+
+#include <linux/io.h>
+#include <linux/suspend.h>
+
+#define RTS5400_MAX_WRITE_DATA_LEN 32
+
+static struct tcpm_command {
+	u8 cmd;
+	u8 wr_data_len;
+	u8 data[RTS5400_MAX_WRITE_DATA_LEN];
+} __packed;
+
+#define PING_STATUS_CMD_STATUS(n) (n & 0x3)
+#define PING_STATUS_DATA_LEN(n) ((n & 0xFC) >> 2)
+
+static struct tcpm_command_status {
+	u8 cmd_status:2;
+#define PING_STATUS_IN_PORCESS 	0x0
+#define PING_STATUS_COMPLETE 	0x1
+#define PING_STATUS_DEFERRED 	0x2
+#define PING_STATUS_ERROR 		0x3
+	u8 data_len:6;
+} __packed;
+
+static struct pd_ic_status {
+	u8 reservrd1;
+	u8 reservrd2;
+	u8 reservrd3;
+	u8 main_ver;
+	u8 sub_ver;
+	u8 sub_ver2;
+	u8 reservrd4;
+	u8 reservrd5;
+	u8 pd_tc;
+#define IC_STATUS_PD_READY(n) (n & 0x1)
+#define IC_STATUS_TC_CONNECT(n) ((n >> 3) & 0x1)
+	uint32_t reservrd6;
+	u8 sm_ready;
+#define IC_STATUS_SMB_READY(n) (n & 0x1)
+	u8 reservrd7;
+	u8 reservrd8;
+	uint32_t reservrd9;
+} __packed;
+
+static struct pd_status_change {//TODO
+	uint32_t reservrd;
+} __packed;
+
+static struct pd_status_info {
+	struct pd_status_change status_change; /* bit 0-31 */
+	u8 supply:1;
+#define PD_STATUS_INFO_NO_SUPPULY 	0x0
+#define PD_STATUS_INFO_SUPPULY 		0x1
+	u8 port_op_mode:3;
+#define PD_STATUS_INFO_NO_CONSUMER 	0x0
+#define PD_STATUS_INFO_USB_DEFAULT 	0x1
+#define PD_STATUS_INFO_BC 			0x2
+#define PD_STATUS_INFO_PD 			0x3
+#define PD_STATUS_INFO_USB_1_5A 	0x4
+#define PD_STATUS_INFO_USB_3_0A 	0x5
+	u8 insertion_detect:1;
+#define PD_STATUS_INFO_NO_CABLE 	0x0
+#define PD_STATUS_INFO_CABLE_DETECT 0x1
+	u8 pd_capable_cable:1;
+#define PD_STATUS_INFO_NO_PD_CABLE 	0x0
+#define PD_STATUS_INFO_PD_CABLE 	0x1
+	u8 power_direction:1;
+#define PD_STATUS_INFO_CONSUMER 	0x0
+#define PD_STATUS_INFO_PROVIDER 	0x1
+	u8 connect_status:1;
+#define PD_STATUS_INFO_UNATTACHED 	0x0
+#define PD_STATUS_INFO_ATTACHED 	0x1
+	u8 port_partner_flag; /* bit 40-47 */
+#define PD_STATUS_INFO_PARTNER_USB 	0x0
+#define PD_STATUS_INFO_PARTNER_ALT 	0x1
+	uint32_t request_data_obj; /* bit 48-79 */
+	u8 port_partner_type:3; /* bit 80-82 */
+#define PD_STATUS_INFO_PARTNER_DFP 	0x1
+#define PD_STATUS_INFO_PARTNER_UFP 	0x2
+#define PD_STATUS_INFO_PARTNER_PC 	0x3
+#define PD_STATUS_INFO_PARTNER_PC_UFP 0x4
+#define PD_STATUS_INFO_PARTNER_DA 	0x5
+#define PD_STATUS_INFO_PARTNER_AAA 	0x6
+	u8 battery_charging_status:2;
+	u8 pd_sourcing_Vconn:1;
+	u8 pd_responsible_for_Vconn:1;
+	u8 pd_ams:1;
+	u8 last_ams:4; /* bit 88-91 */
+	u8 port_partner_not_support_pd:1;
+	u8 plug_direction:1;
+	u8 dp_role:1;
+#define PD_STATUS_INFO_DP_SINK 		0x0
+#define PD_STATUS_INFO_DP_SOURCE 	0x1
+	u8 pd_connect:1;
+#define PD_STATUS_INFO_PD_NOT_EXCHANGE 0x0
+#define PD_STATUS_INFO_PD_EXCHANGE 	0x1
+	u8 reservrd1;
+	u8 alt_mode_status:3;
+	u8 reservrd2:5;
+} __packed;
+
+#define PDO_TYPE(n) (n&0x1)
+#define PDO_TYPE_SINK 0x0
+#define PDO_TYPE_SOURCE 0x1
+#define PDO_TCPM(n) ((n&0x1) << 1)
+#define PDO_TCPM_TCPM 0x0
+#define PDO_TCPM_PARTNER 0x1
+#define PDO_OFFEST(n) ((n&0x7) << 2)
+#define PDO_NUM(n) ((n&0x7) << 5)
+
+static struct source_fix_pdo {
+	u16 max_current:10;
+	u16 valtage:10;
+	u8 peak_current:2;
+	u8 reservrd:3;
+	u8 data_role_swap:1;
+	u8 usb_comm_capable:1;
+	u8 external_power:1;
+	u8 usb_suspend:1;
+	u8 dual_role_power:1;
+	u8 power_type:2;
+} __packed;
+
+static struct source_var_pdo {
+	u16 max_current:10;
+	u16 min_valtage:10;
+	u16 max_valtage:10;
+	u8 power_type:2;
+} __packed;
+
+static struct source_bat_pdo {
+	u16 max_current:10;
+	u16 min_valtage:10;
+	u16 max_valtage:10;
+	u8 power_type:2;
+} __packed;
+
+static struct sink_fix_pdo {
+	u16 op_current:10;
+	u16 valtage:10;
+	u8 peak_current:2;
+	u8 reservrd:3;
+	u8 data_role_swap:1;
+	u8 usb_comm_capable:1;
+	u8 external_power:1;
+	u8 higher_capability:1;
+	u8 dual_role_power:1;
+	u8 power_type:2;
+} __packed;
+
+static struct sink_var_pdo {
+	u16 op_current:10;
+	u16 min_valtage:10;
+	u16 max_valtage:10;
+	u8 power_type:2;
+} __packed;
+
+static struct sink_bat_pdo {
+	u16 op_current:10;
+	u16 min_valtage:10;
+	u16 max_valtage:10;
+	u8 power_type:2;
+} __packed;
+
+static struct common_pdo {
+	uint32_t reservrd:30;
+	u8 power_type:2;
+#define PDO_INFO_POWER_TYPE_FIX 0x0
+#define PDO_INFO_POWER_TYPE_BAT 0x1
+#define PDO_INFO_POWER_TYPE_VAR 0x2
+} __packed;
+
+union pdo_info {
+	struct source_fix_pdo so_f;
+	struct source_var_pdo so_v;
+	struct source_bat_pdo so_b;
+	struct sink_fix_pdo si_f;
+	struct sink_var_pdo si_v;
+	struct sink_bat_pdo si_b;
+	struct common_pdo com;
+};
+
+static struct rdo_info {
+	uint32_t reservrd_todo:28; //TODO
+	uint32_t obj_pos:3;
+	uint32_t reservrd:1;
+} __packed;
+
+#define PD_AMS_PR_SWAP 		0x01
+#define PD_AMS_DR_SWAP 		0x02
+#define PD_AMS_VCONN_SWAP 	0x03
+#define PD_AMS_SOURCE_CAP 	0x04
+#define PD_AMS_REQUEST 		0x05
+#define PD_AMS_SOFT_RESET 	0x06
+#define PD_AMS_HARD_RESET 	0x07
+#define PD_AMS_GOTO_MIN 	0x08
+#define PD_AMS_GET_SNK_CAP 	0x09
+#define PD_AMS_GET_SRC_CAP 	0x0A
+
+static struct rts5400_dev {
+	struct i2c_client *client;
+	struct device *dev;
+	bool no_device;
+
+	struct pd_ic_status ic_status;
+	struct pd_status_info status_info;
+
+	unsigned int pow_gpio;
+} g_rts5400;
+
+/* I2C transfer */
+static struct tcpm_command_status __rts5400_get_ping_status(
+		const struct i2c_client *client)
+{
+	int ret;
+	struct tcpm_command_status status;
+	status.cmd_status = 0;
+	status.data_len = 0;
+
+	ret = i2c_smbus_read_byte(client);
+	if (ret < 0) {
+		dev_err(&client->dev, "%s get error %d\n", __func__, ret);
+		return status;
+	}
+	status.cmd_status = PING_STATUS_CMD_STATUS(ret);
+	status.data_len = PING_STATUS_DATA_LEN(ret);
+	return status;
+}
+
+static int __rts5400_block_read(const struct i2c_client *client,
+		struct tcpm_command *command)
+{
+	int ret;
+	int data_len = command->wr_data_len + 1;
+	u8 *buffer;
+
+	buffer = kzalloc(data_len, GFP_KERNEL);
+
+	ret = i2c_smbus_read_i2c_block_data(client, command->cmd,
+			data_len, buffer);
+
+	if (ret < 0)
+		dev_err(&client->dev, "block read failed\n");
+	else {
+		memcpy(&command->data, buffer + 1, command->wr_data_len);
+		ret = buffer[0];
+	}
+
+	kfree(buffer);
+
+	return ret;
+}
+
+static int __rts5400_block_write(struct i2c_client *client,
+		struct tcpm_command *command)
+{
+	int ret;
+
+	ret = i2c_smbus_write_block_data(client, command->cmd,
+			command->wr_data_len, &command->data);
+	return ret;
+}
+
+static int __rts5400_transfer(const struct rts5400_dev *rts5400,
+		struct tcpm_command *w_cmd, struct tcpm_command *r_cmd)
+{
+	struct device *dev = rts5400->dev;
+	struct i2c_client *client = rts5400->client;
+	struct tcpm_command_status status;
+	int retry = 100;
+	int ret = -ENODEV;
+
+	if (rts5400->no_device) {
+		dev_dbg("%s Error! NO rts5400\n", __func__);
+		return ret;
+	}
+	dev_dbg(dev, "%s start write command 0x%x,wr_data_len %d, sub_command 0x%x\n",
+			__func__, w_cmd->cmd, w_cmd->wr_data_len, w_cmd->data[0]);
+
+	ret = __rts5400_block_write(client, w_cmd);
+
+	if (ret < 0) {
+		dev_err(dev, "%s block write error %d", __func__, ret);
+		return ret;
+	}
+
+	while (--retry) {
+		mdelay(1);
+		status = __rts5400_get_ping_status(client);
+		if (status.cmd_status == PING_STATUS_COMPLETE) {
+			break;
+		} else if (status.cmd_status == PING_STATUS_ERROR) {
+			dev_err(dev, "%s get ping status error %d\n", __func__, status.cmd_status);
+			break;
+		}
+	}
+	if (!retry) {
+		dev_err(dev, "%s get ping status TIMEOUT\n", __func__);
+		return -ETIMEDOUT;
+	} else
+		dev_dbg(dev, "%s get ping status 0x%x, data_len %d\n",
+				__func__, status.cmd_status, status.data_len);
+
+	if (r_cmd->wr_data_len == 0xff)
+		r_cmd->wr_data_len = status.data_len;
+
+	if (r_cmd->wr_data_len > 0) {
+		dev_dbg(dev, "%s start read command 0x%x,wr_data_len %d\n",
+			__func__, r_cmd->cmd, r_cmd->wr_data_len);
+
+		ret = __rts5400_block_read(client, r_cmd);
+		if (ret < 0)
+			dev_err(dev, "%s block read error %d\n", __func__, ret);
+	}
+	if (status.cmd_status == PING_STATUS_ERROR)
+		return -3;
+	else
+		return ret;
+}
+
+int rtk_rts5400_get_IC_status(void)
+{
+	struct rts5400_dev *rts5400 = &g_rts5400;
+	int ret, i;
+	struct tcpm_command w_cmd, r_cmd;
+	struct pd_ic_status *ic_status = &rts5400->ic_status;
+
+	w_cmd.cmd = 0x3A;
+	w_cmd.wr_data_len = 0x1;
+	w_cmd.data[0] = 0x14;
+	r_cmd.cmd = 0x80;
+	r_cmd.wr_data_len = 0x14;
+	memset(&r_cmd.data, 0, RTS5400_MAX_WRITE_DATA_LEN);
+
+	dev_dbg(rts5400->dev, "Enter %s\n", __func__);
+
+	ret = __rts5400_transfer(rts5400, &w_cmd, &r_cmd);
+
+	if (ret < 0) {
+		dev_err(rts5400->dev, "%s I2C transfer fails\n", __func__);
+		return ret;
+	}
+
+	//for (i = 0; i < r_cmd.wr_data_len; i++) {
+	//	dev_dbg(rts5400->dev, "Data#%d : 0x%x\n", i, r_cmd.data[i]);
+	//}
+	memcpy(ic_status, &r_cmd.data, r_cmd.wr_data_len);
+
+	dev_info(rts5400->dev, "RTS5400 Main_version %d Sub_version %d Sub_version_2 %d\n",
+			ic_status->main_ver, ic_status->sub_ver, ic_status->sub_ver2);
+
+	dev_info(rts5400->dev, "SMBus %sready, PD %sready, TypeC %sconnect\n",
+			IC_STATUS_SMB_READY(ic_status->sm_ready)?"":"NOT ",
+			IC_STATUS_PD_READY(ic_status->pd_tc)?"":"NOT ",
+			IC_STATUS_TC_CONNECT(ic_status->pd_tc)?"":"NOT ");
+
+	dev_dbg(rts5400->dev, "Exit %s return cmd %x, wr_data_len %d\n", __func__,
+			r_cmd.cmd, r_cmd.wr_data_len);
+
+	ret = IC_STATUS_SMB_READY(ic_status->sm_ready)
+			& IC_STATUS_PD_READY(ic_status->pd_tc)
+			& IC_STATUS_TC_CONNECT(ic_status->pd_tc);
+
+	return ret;
+}
+
+int rtk_rts5400_get_status(void)
+{
+	struct rts5400_dev *rts5400 = &g_rts5400;
+	int ret, i;
+	struct tcpm_command w_cmd, r_cmd;
+	struct pd_status_info *status_info = &rts5400->status_info;
+
+	w_cmd.cmd = 0x9;
+	w_cmd.wr_data_len = 0x3;
+	w_cmd.data[0] = 0x0;
+	w_cmd.data[1] = 0;
+	w_cmd.data[2] = 0x0D;
+	r_cmd.cmd = 0x80;
+	r_cmd.wr_data_len = 0xff;
+	memset(&r_cmd.data, 0, RTS5400_MAX_WRITE_DATA_LEN);
+
+	dev_dbg(rts5400->dev, "Enter %s\n", __func__);
+
+	ret = __rts5400_transfer(rts5400, &w_cmd, &r_cmd);
+
+	if (ret < 0) {
+		dev_err(rts5400->dev, "%s I2C transfer fails\n", __func__);
+		return ret;
+	}
+
+	//for (i = 0; i < r_cmd.wr_data_len; i++) {
+	//	dev_dbg(rts5400->dev, "Data#%d : 0x%x\n", i, r_cmd.data[i]);
+	//}
+
+	memcpy(status_info, &r_cmd.data, r_cmd.wr_data_len);
+
+	dev_info(rts5400->dev, "[Status Info] Externally Powered supply %d, Port OP mode %d, Insertion Detect %d\n",
+			status_info->supply, status_info->port_op_mode, status_info->insertion_detect);
+	dev_info(rts5400->dev, "[Status Info] PD Capable Cable %d, Power Direction %d\n",
+			status_info->pd_capable_cable, status_info->power_direction);
+	dev_info(rts5400->dev, "[Status Info] Connect Status %d, Port Partner Flags %d\n",
+			status_info->connect_status, status_info->port_partner_flag);
+	dev_info(rts5400->dev, "[Status Info] Request Data Object 0x%x\n", status_info->request_data_obj);
+	dev_info(rts5400->dev, "[Status Info] Port Partner Type %d\n", status_info->port_partner_type);
+	dev_info(rts5400->dev, "[Status Info] Battery Charging Status %d\n", status_info->battery_charging_status);
+	dev_info(rts5400->dev, "[Status Info] PD Sourcing Vconn %d\n", status_info->pd_sourcing_Vconn);
+	dev_info(rts5400->dev, "[Status Info] PD AMS is %s\n", status_info->pd_ams?"in progress":"ready");
+	dev_info(rts5400->dev, "[Status Info] DP Role: %s\n", status_info->dp_role?"Sink":"Source");
+	dev_info(rts5400->dev, "[Status Info] PD %sexchanged pd message and goodcrc\n", status_info->pd_connect?"":"NOT ");
+	dev_info(rts5400->dev, "[Status Info] Alt mode status 0x%x\n", status_info->alt_mode_status);
+
+	dev_dbg(rts5400->dev, "Exit %s return cmd %x, wr_data_len %d\n", __func__,
+			r_cmd.cmd, r_cmd.wr_data_len);
+
+	return ret;
+}
+
+int rtk_rts5400_get_PDO(int pdo_type, int pdo, int offset,
+		int num, u8 *value)
+{
+	struct rts5400_dev *rts5400 = &g_rts5400;
+	int ret, i;
+	struct tcpm_command w_cmd, r_cmd;
+	union pdo_info *pdo_inf;
+
+	w_cmd.cmd = 0x8;
+	w_cmd.wr_data_len = 0x3;
+	w_cmd.data[0] = 0x83;
+	w_cmd.data[1] = 0;
+	w_cmd.data[2] = PDO_TYPE(pdo_type) | PDO_TCPM(pdo) | PDO_OFFEST(offset) | PDO_NUM(num);
+	r_cmd.cmd = 0x80;
+	r_cmd.wr_data_len = 0xff;
+	memset(&r_cmd.data, 0, RTS5400_MAX_WRITE_DATA_LEN);
+
+	dev_dbg(rts5400->dev, "Enter %s\n", __func__);
+
+	ret = __rts5400_transfer(rts5400, &w_cmd, &r_cmd);
+
+	if (ret < 0) {
+		dev_err(rts5400->dev, "%s I2C transfer fails\n", __func__);
+		return ret;
+	}
+
+	dev_dbg(rts5400->dev, "[PDO status] %s %s PDO, offset %d, num %d\n",
+			pdo?"Partner":"TCPM", pdo_type?"Source":"Sink", offset, num);
+
+	//for (i = 0; i < r_cmd.wr_data_len; i++) {
+	//	dev_dbg(rts5400->dev, "Data#%d : 0x%x\n", i, r_cmd.data[i]);
+	//}
+
+	for (i = 0; i < r_cmd.wr_data_len; i = i + 4) {
+		pdo_inf = (union pdo_info *)&r_cmd.data[i];
+
+		if (pdo == PDO_TYPE_SOURCE && pdo_inf->com.power_type == PDO_INFO_POWER_TYPE_FIX) {
+			dev_info(rts5400->dev, "[PDO status] %s Fix PDO, valtage %d mV\n",
+				pdo_type?"Source":"Sink", (pdo_inf->so_f.valtage) * 50);
+		} else if (pdo == PDO_TYPE_SOURCE && pdo_inf->com.power_type == PDO_INFO_POWER_TYPE_VAR) {
+			dev_info(rts5400->dev, "[PDO status] %s Var PDO\n", pdo_type?"Source":"Sink");
+		} else if (pdo == PDO_TYPE_SOURCE && pdo_inf->com.power_type == PDO_INFO_POWER_TYPE_BAT) {
+			dev_info(rts5400->dev, "[PDO status] %s Bat PDO\n", pdo_type?"Source":"Sink");
+		} else if (pdo == PDO_TYPE_SINK && pdo_inf->com.power_type == PDO_INFO_POWER_TYPE_FIX) {
+			dev_info(rts5400->dev, "[PDO status] %s Fix PDO, valtage %d mV\n",
+				pdo_type?"Source":"Sink", (pdo_inf->si_f.valtage) * 50);
+		} else if (pdo == PDO_TYPE_SINK && pdo_inf->com.power_type == PDO_INFO_POWER_TYPE_VAR) {
+			dev_info(rts5400->dev, "[PDO status] %s Var PDO\n", pdo_type?"Source":"Sink");
+		} else if (pdo == PDO_TYPE_SINK && pdo_inf->com.power_type == PDO_INFO_POWER_TYPE_BAT) {
+			dev_info(rts5400->dev, "[PDO status] %s Var PDO\n", pdo_type?"Source":"Sink");
+		}
+	}
+	dev_dbg(rts5400->dev, "Exit %s return cmd %x, wr_data_len %d\n", __func__,
+			r_cmd.cmd, r_cmd.wr_data_len);
+
+	if (ret > 0) {
+		if (value != NULL) {
+			memcpy(value, &r_cmd.data, r_cmd.wr_data_len);
+		}
+		return r_cmd.wr_data_len;
+	}
+	return ret;
+}
+
+int rtk_rts5400_init_pd_ams(u8 pd_ams)
+{
+	struct rts5400_dev *rts5400 = &g_rts5400;
+	int ret, i;
+	struct tcpm_command w_cmd, r_cmd;
+
+	w_cmd.cmd = 0x8;
+	w_cmd.wr_data_len = 0x3;
+	w_cmd.data[0] = 0x20;
+	w_cmd.data[1] = 0;
+	w_cmd.data[2] = pd_ams;
+	r_cmd.cmd = 0x80;
+	r_cmd.wr_data_len = 0x0;
+	memset(&r_cmd.data, 0, RTS5400_MAX_WRITE_DATA_LEN);
+
+	dev_dbg(rts5400->dev, "Enter %s pd_ams=%x\n", __func__, pd_ams);
+
+	ret = __rts5400_transfer(rts5400, &w_cmd, &r_cmd);
+
+	if (ret < 0) {
+		dev_err(rts5400->dev, "%s I2C transfer fails\n", __func__);
+		return ret;
+	}
+
+	dev_dbg(rts5400->dev, "Exit %s\n", __func__);
+
+	return ret;
+}
+
+/* Type C */
+bool rtk_rts5400_is_enabled(void)
+{
+	struct rts5400_dev *rts5400 = &g_rts5400;
+	struct device *dev = rts5400->dev;
+
+	return !rts5400->no_device;
+}
+
+bool rtk_rts5400_is_UFP_attached(void)
+{
+	struct rts5400_dev *rts5400 = &g_rts5400;
+	struct device *dev = rts5400->dev;
+	struct pd_status_info *status_info = &rts5400->status_info;
+
+	return status_info->port_partner_type == PD_STATUS_INFO_PARTNER_UFP;
+}
+
+int rtk_rts5400_set_type_c_soft_reset(void)
+{
+	int ret = 0;
+
+	ret = rtk_rts5400_init_pd_ams(PD_AMS_SOFT_RESET);
+
+	return ret;
+}
+
+int rtk_rts5400_get_current_pdo_voltage(void)
+{
+	struct rts5400_dev *rts5400 = &g_rts5400;
+	struct device *dev = rts5400->dev;
+	struct pd_status_info *status_info = &rts5400->status_info;
+	struct rdo_info *rdo = NULL;
+	union pdo_info *pdo = NULL;
+	int offest;
+	int ret = -1;
+	u8 *buffer;
+
+	dev_dbg(dev, "Enter %s\n", __func__);
+	if (status_info->request_data_obj == 0x0) {
+		dev_err(dev, "%s NO request_data_obj", __func__);
+		return ret;
+	} else
+		rdo = &status_info->request_data_obj;
+
+	offest = (rdo->obj_pos - 1) * 4;
+
+	dev_dbg(dev, "%s rdo->obj_pos=%d, offest=%d", __func__,
+			rdo->obj_pos, offest);
+
+	if (offest < 0) {
+		dev_err(dev, "%s Error! rdo->obj_pos=%d, offest=%d",
+			__func__, rdo->obj_pos, offest);
+		return ret;
+	}
+
+	buffer = kzalloc(7*4, GFP_KERNEL);
+
+	ret = rtk_rts5400_get_PDO(PDO_TYPE_SOURCE, PDO_TCPM_PARTNER, 0, 7, buffer);
+
+	if (ret < 0) {
+		dev_err(dev, "%s rtk_rts5400_get_PDO fail(ret=%d)", __func__, ret);
+		kfree(buffer);
+		return ret;
+	}
+	pdo = buffer + offest;
+
+	if (pdo != NULL && pdo->com.power_type == PDO_INFO_POWER_TYPE_FIX) {
+		dev_info(rts5400->dev, "Current Partner Source Fix PDO, "
+				"valtage %d mV\n", (pdo->so_f.valtage) * 50);
+		ret = pdo->so_f.valtage * 50;
+	}
+
+	kfree(buffer);
+	dev_dbg(dev, "Exit %s\n", __func__);
+	return ret;
+}
+
+/* init and probe */
+static int rtk_rts5400_probe(struct i2c_client *client,
+		const struct i2c_device_id *id)
+{
+	struct rts5400_dev *rts5400 = &g_rts5400;
+	struct device *dev = &client->dev;
+	struct device_node	*node = dev->of_node;
+	unsigned int gpio, power_on_12v = 0;
+
+	int i, ret;
+	u8 val;
+	dev_dbg(dev, "Enter %s\n", __func__);
+
+	memset(rts5400, 0, sizeof(rts5400));
+
+	rts5400->client = client;
+	rts5400->dev = dev;
+
+	i2c_set_clientdata(client, rts5400);
+
+	ret = rtk_rts5400_get_IC_status();
+	if (ret < 0) {
+		dev_err(dev, "[RTS5400] rtk_rts5400_get_IC_status fail (ret=%d)\n", ret);
+		rts5400->no_device = true;
+	} else {
+		ret = rtk_rts5400_get_status();
+		if (ret < 0)
+			dev_err(dev, "[RTS5400] rtk_rts5400_get_status fail (ret=%d)\n", ret);
+		ret = rtk_rts5400_get_PDO(PDO_TYPE_SOURCE, PDO_TCPM_TCPM, 0, 7, NULL);
+		if (ret < 0)
+			dev_err(dev, "[RTS5400] rtk_rts5400_get_PDO "
+				"(PDO_TYPE_SOURCE, PDO_TCPM_TCPM) fail (ret=%d)\n", ret);
+		ret = rtk_rts5400_get_PDO(PDO_TYPE_SOURCE, PDO_TCPM_PARTNER, 0, 7, NULL);
+		if (ret < 0)
+			dev_err(dev, "[RTS5400] rtk_rts5400_get_PDO "
+				"PDO_TYPE_SOURCE, PDO_TCPM_PARTNER) fail (ret=%d)\n", ret);
+		ret = rtk_rts5400_get_PDO(PDO_TYPE_SINK, PDO_TCPM_TCPM, 0, 7, NULL);
+		if (ret < 0)
+			dev_err(dev, "[RTS5400] rtk_rts5400_get_PDO "
+				"(PDO_TYPE_SINK, PDO_TCPM_TCPM) fail (ret=%d)\n", ret);
+		ret = rtk_rts5400_get_PDO(PDO_TYPE_SINK, PDO_TCPM_PARTNER, 0, 7, NULL);
+		if (ret < 0)
+			 dev_err(dev, "[RTS5400] rtk_rts5400_get_PDO "
+				"(PDO_TYPE_SINK, PDO_TCPM_PARTNER) fail (ret=%d)\n", ret);
+
+		ret = rtk_rts5400_get_current_pdo_voltage();
+
+		if (ret >= 12000)
+			power_on_12v = 1;
+
+		gpio = of_get_named_gpio(node, "realtek,12v-power-gpio", 0);
+
+		if (gpio_is_valid(gpio)) {
+			rts5400->pow_gpio = gpio;
+			dev_info(dev, "%s get 12V power-gpio (id=%d) OK\n", __func__, gpio);
+			if (gpio_direction_output(gpio, power_on_12v))
+				dev_err(dev, "%s ERROR set 12v power (= 0) fail\n", __func__);
+			else
+				dev_info(dev, "%s Power %s 12v\n", __func__, power_on_12v?"on":"off");
+		 } else {
+			dev_err(dev, "Error 12V-power-gpio no found");
+			rts5400->pow_gpio = -1;
+		}
+	}
+
+	dev_dbg(dev, "Exit %s\n", __func__);
+
+	return 0;
+}
+
+#ifdef CONFIG_SUSPEND
+static int rtk_rts5400_suspend(struct device *dev)
+{
+	dev_dbg(dev, "Enter %s\n", __func__);
+
+	dev_dbg(dev, "Exit %s\n", __func__);
+	return 0;
+}
+
+static int rtk_rts5400_resume(struct device *dev)
+{
+	dev_dbg(dev, "Enter %s\n", __func__);
+
+	dev_dbg(dev, "Exit %s\n", __func__);
+	return 0;
+}
+#else
+
+#define rtk_rts5400_suspend NULL
+#define rtk_rts5400_resume NULL
+
+#endif
+
+static const struct dev_pm_ops rtk_rts5400_pm_ops = {
+	.suspend    = rtk_rts5400_suspend,
+	.resume     = rtk_rts5400_resume,
+};
+
+static const struct i2c_device_id rtk_rts5400_ids[] = {
+	{"rtk-rts5400", 0},
+	{ },
+};
+MODULE_DEVICE_TABLE(i2c, rtk_rts5400_ids);
+
+static struct i2c_driver rtk_rts5400_driver = {
+	.driver = {
+		.name = "rtk_rts5400",
+		.owner = THIS_MODULE,
+		.pm = &rtk_rts5400_pm_ops,
+	},
+	.probe = rtk_rts5400_probe,
+	.id_table = rtk_rts5400_ids,
+};
+
+module_i2c_driver(rtk_rts5400_driver);
+
+MODULE_DESCRIPTION("RTS5400 Type C Port Manager Driver");
+MODULE_AUTHOR("Stanley Chang");
+MODULE_LICENSE("GPL");
diff --git a/drivers/usb/gadget/Kconfig b/drivers/usb/gadget/Kconfig
index f3ee80e..f6cce5a 100644
--- a/drivers/usb/gadget/Kconfig
+++ b/drivers/usb/gadget/Kconfig
@@ -209,6 +209,18 @@ config USB_F_PRINTER
 config USB_F_TCM
 	tristate
 
+config USB_F_MTP
+	tristate
+
+config USB_F_PTP
+        tristate
+
+config USB_F_AUDIO_SRC
+	tristate
+
+config USB_F_ACC
+	tristate
+
 # this first set of drivers all depend on bulk-capable hardware.
 
 config USB_CONFIGFS
@@ -362,6 +374,44 @@ config USB_CONFIGFS_F_FS
 	  implemented in kernel space (for instance Ethernet, serial or
 	  mass storage) and other are implemented in user space.
 
+config USB_CONFIGFS_F_MTP
+	boolean "MTP gadget"
+	depends on USB_CONFIGFS
+	select USB_F_MTP
+	help
+	  USB gadget MTP support
+
+config USB_CONFIGFS_F_PTP
+	boolean "PTP gadget"
+	depends on USB_CONFIGFS && USB_CONFIGFS_F_MTP
+	select USB_F_PTP
+	help
+	  USB gadget PTP support
+
+config USB_CONFIGFS_F_ACC
+	boolean "Accessory gadget"
+	depends on USB_CONFIGFS
+	select USB_F_ACC
+	help
+	  USB gadget Accessory support
+
+config USB_CONFIGFS_F_AUDIO_SRC
+	boolean "Audio Source gadget"
+	depends on USB_CONFIGFS && USB_CONFIGFS_F_ACC
+	depends on SND
+	select SND_PCM
+	select USB_F_AUDIO_SRC
+	help
+	  USB gadget Audio Source support
+
+config USB_CONFIGFS_UEVENT
+	boolean "Uevent notification of Gadget state"
+	depends on USB_CONFIGFS
+	help
+	  Enable uevent notifications to userspace when the gadget
+	  state changes. The gadget can be in any of the following
+	  three states: "CONNECTED/DISCONNECTED/CONFIGURED"
+
 config USB_CONFIGFS_F_UAC1
 	bool "Audio Class 1.0"
 	depends on USB_CONFIGFS
diff --git a/drivers/usb/gadget/composite.c b/drivers/usb/gadget/composite.c
index ca97f5b..6350d90 100644
--- a/drivers/usb/gadget/composite.c
+++ b/drivers/usb/gadget/composite.c
@@ -305,6 +305,14 @@ int usb_add_function(struct usb_configuration *config,
 	if (value)
 		DBG(config->cdev, "adding '%s'/%p --> %d\n",
 				function->name, function, value);
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* add to print log*/
+	pr_err("adding '%s'/%p to config '%s'/%p --> %s (ret=%d)\n",
+			function->name, function,
+			config->label, config, value?"Fail":"Ok", value);
+#endif
+
 	return value;
 }
 EXPORT_SYMBOL_GPL(usb_add_function);
@@ -1993,6 +2001,12 @@ void composite_disconnect(struct usb_gadget *gadget)
 	struct usb_composite_dev	*cdev = get_gadget_data(gadget);
 	unsigned long			flags;
 
+	if (cdev == NULL) {
+		WARN(1, "%s: Calling disconnect on a Gadget that is \
+			 not connected\n", __func__);
+		return;
+	}
+
 	/* REVISIT:  should we have config and device level
 	 * disconnect callbacks?
 	 */
diff --git a/drivers/usb/gadget/configfs.c b/drivers/usb/gadget/configfs.c
index a5ca409..a241db6 100644
--- a/drivers/usb/gadget/configfs.c
+++ b/drivers/usb/gadget/configfs.c
@@ -9,6 +9,31 @@
 #include "u_f.h"
 #include "u_os_desc.h"
 
+#ifdef CONFIG_USB_CONFIGFS_UEVENT
+#include <linux/platform_device.h>
+#include <linux/kdev_t.h>
+#include <linux/usb/ch9.h>
+
+#ifdef CONFIG_USB_CONFIGFS_F_ACC
+extern int acc_ctrlrequest(struct usb_composite_dev *cdev,
+				const struct usb_ctrlrequest *ctrl);
+void acc_disconnect(void);
+#endif
+static struct class *android_class;
+static struct device *android_device;
+static int index;
+
+struct device *create_function_device(char *name)
+{
+	if (android_device && !IS_ERR(android_device))
+		return device_create(android_class, android_device,
+			MKDEV(0, index++), NULL, name);
+	else
+		return ERR_PTR(-EINVAL);
+}
+EXPORT_SYMBOL_GPL(create_function_device);
+#endif
+
 int check_user_usb_string(const char *name,
 		struct usb_gadget_strings *stringtab_dev)
 {
@@ -60,6 +85,12 @@ struct gadget_info {
 	bool use_os_desc;
 	char b_vendor_code;
 	char qw_sign[OS_STRING_QW_SIGN_LEN];
+#ifdef CONFIG_USB_CONFIGFS_UEVENT
+	bool connected;
+	bool sw_connected;
+	struct work_struct work;
+	struct device *dev;
+#endif
 };
 
 static inline struct gadget_info *to_gadget_info(struct config_item *item)
@@ -250,6 +281,12 @@ static int unregister_gadget(struct gadget_info *gi)
 	return 0;
 }
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+extern struct usb_gadget_driver *rtk_dwc3_set_and_get_usb_gadget_driver(
+			struct usb_gadget_driver* driver);
+extern int usb_gadget_find_udc(const char *name);
+#endif
+
 static ssize_t gadget_dev_desc_UDC_store(struct config_item *item,
 		const char *page, size_t len)
 {
@@ -265,8 +302,18 @@ static ssize_t gadget_dev_desc_UDC_store(struct config_item *item,
 
 	mutex_lock(&gi->lock);
 
-	if (!strlen(name)) {
+	if (!strlen(name) || strcmp(name, "none") == 0) {
 		ret = unregister_gadget(gi);
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+		if (ret == -ENODEV && gi->composite.gadget_driver.udc_name) {
+			pr_info("%s gadget device disconnected remove udc_name %s\n",
+					__func__, gi->composite.gadget_driver.udc_name);
+			rtk_dwc3_set_and_get_usb_gadget_driver(NULL);
+			kfree(gi->composite.gadget_driver.udc_name);
+			gi->composite.gadget_driver.udc_name = NULL;
+			ret = 0;
+		}
+#endif
 		if (ret)
 			goto err;
 		kfree(name);
@@ -281,6 +328,17 @@ static ssize_t gadget_dev_desc_UDC_store(struct config_item *item,
 			gi->composite.gadget_driver.udc_name = NULL;
 			goto err;
 		}
+
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+		/* We save usb_gadget_driver for DRD switch*/
+		if (usb_gadget_find_udc(name) == -ENODEV) {
+			pr_info("%s: udc_name=%s usb_udc_attach_driver --> "
+					"gadget device disconnected\n", __func__, name);
+			rtk_dwc3_set_and_get_usb_gadget_driver(
+					&gi->composite.gadget_driver);
+			ret = 0;
+		}
+#endif
 	}
 	mutex_unlock(&gi->lock);
 	return len;
@@ -431,7 +489,10 @@ static int config_usb_cfg_unlink(
 	mutex_lock(&gi->lock);
 	if (gi->composite.gadget_driver.udc_name)
 		unregister_gadget(gi);
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+#else
 	WARN_ON(gi->composite.gadget_driver.udc_name);
+#endif
 
 	list_for_each_entry(f, &cfg->func_list, list) {
 		if (f->fi == fi) {
@@ -1226,6 +1287,9 @@ static void purge_configs_funcs(struct gadget_info *gi)
 		c->highspeed = 0;
 		c->fullspeed = 0;
 	}
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+	wmb();
+#endif
 }
 
 static int configfs_composite_bind(struct usb_gadget *gadget,
@@ -1369,6 +1433,60 @@ static int configfs_composite_bind(struct usb_gadget *gadget,
 	return ret;
 }
 
+#ifdef CONFIG_USB_CONFIGFS_UEVENT
+static void android_work(struct work_struct *data)
+{
+	struct gadget_info *gi = container_of(data, struct gadget_info, work);
+	struct usb_composite_dev *cdev = &gi->cdev;
+	char *disconnected[2] = { "USB_STATE=DISCONNECTED", NULL };
+	char *connected[2]    = { "USB_STATE=CONNECTED", NULL };
+	char *configured[2]   = { "USB_STATE=CONFIGURED", NULL };
+	/* 0-connected 1-configured 2-disconnected*/
+	bool status[3] = { false, false, false };
+	unsigned long flags;
+	bool uevent_sent = false;
+
+	spin_lock_irqsave(&cdev->lock, flags);
+	if (cdev->config)
+		status[1] = true;
+
+	if (gi->connected != gi->sw_connected) {
+		if (gi->connected)
+			status[0] = true;
+		else
+			status[2] = true;
+		gi->sw_connected = gi->connected;
+	}
+	spin_unlock_irqrestore(&cdev->lock, flags);
+
+	if (status[0]) {
+		kobject_uevent_env(&android_device->kobj,
+					KOBJ_CHANGE, connected);
+		pr_info("%s: sent uevent %s\n", __func__, connected[0]);
+		uevent_sent = true;
+	}
+
+	if (status[1]) {
+		kobject_uevent_env(&android_device->kobj,
+					KOBJ_CHANGE, configured);
+		pr_info("%s: sent uevent %s\n", __func__, configured[0]);
+		uevent_sent = true;
+	}
+
+	if (status[2]) {
+		kobject_uevent_env(&android_device->kobj,
+					KOBJ_CHANGE, disconnected);
+		pr_info("%s: sent uevent %s\n", __func__, disconnected[0]);
+		uevent_sent = true;
+	}
+
+	if (!uevent_sent) {
+		pr_info("%s: did not send uevent (%d %d %p)\n", __func__,
+			gi->connected, gi->sw_connected, cdev->config);
+	}
+}
+#endif
+
 static void configfs_composite_unbind(struct usb_gadget *gadget)
 {
 	struct usb_composite_dev	*cdev;
@@ -1388,14 +1506,91 @@ static void configfs_composite_unbind(struct usb_gadget *gadget)
 	set_gadget_data(gadget, NULL);
 }
 
+#ifdef CONFIG_USB_CONFIGFS_UEVENT
+static int android_setup(struct usb_gadget *gadget,
+			const struct usb_ctrlrequest *c)
+{
+	struct usb_composite_dev *cdev = get_gadget_data(gadget);
+	unsigned long flags;
+	struct gadget_info *gi = container_of(cdev, struct gadget_info, cdev);
+	int value = -EOPNOTSUPP;
+	struct usb_function_instance *fi;
+
+	spin_lock_irqsave(&cdev->lock, flags);
+	if (!gi->connected) {
+		gi->connected = 1;
+		schedule_work(&gi->work);
+	}
+	spin_unlock_irqrestore(&cdev->lock, flags);
+	list_for_each_entry(fi, &gi->available_func, cfs_list) {
+		if (fi != NULL && fi->f != NULL && fi->f->setup != NULL) {
+			value = fi->f->setup(fi->f, c);
+			if (value >= 0)
+				break;
+		}
+	}
+
+#ifdef CONFIG_USB_CONFIGFS_F_ACC
+	if (value < 0)
+		value = acc_ctrlrequest(cdev, c);
+#endif
+
+	if (value < 0)
+		value = composite_setup(gadget, c);
+
+	spin_lock_irqsave(&cdev->lock, flags);
+	if (c->bRequest == USB_REQ_SET_CONFIGURATION &&
+						cdev->config) {
+		schedule_work(&gi->work);
+	}
+	spin_unlock_irqrestore(&cdev->lock, flags);
+
+	return value;
+}
+
+static void android_disconnect(struct usb_gadget *gadget)
+{
+	struct usb_composite_dev        *cdev = get_gadget_data(gadget);
+	struct gadget_info *gi = container_of(cdev, struct gadget_info, cdev);
+
+	/* FIXME: There's a race between usb_gadget_udc_stop() which is likely
+	 * to set the gadget driver to NULL in the udc driver and this drivers
+	 * gadget disconnect fn which likely checks for the gadget driver to
+	 * be a null ptr. It happens that unbind (doing set_gadget_data(NULL))
+	 * is called before the gadget driver is set to NULL and the udc driver
+	 * calls disconnect fn which results in cdev being a null ptr.
+	 */
+	if (cdev == NULL) {
+		WARN(1, "%s: gadget driver already disconnected\n", __func__);
+		return;
+	}
+
+	/* accessory HID support can be active while the
+		accessory function is not actually enabled,
+		so we need to inform it when we are disconnected.
+	*/
+
+#ifdef CONFIG_USB_CONFIGFS_F_ACC
+	acc_disconnect();
+#endif
+	gi->connected = 0;
+	schedule_work(&gi->work);
+	composite_disconnect(gadget);
+}
+#endif
+
 static const struct usb_gadget_driver configfs_driver_template = {
 	.bind           = configfs_composite_bind,
 	.unbind         = configfs_composite_unbind,
-
+#ifdef CONFIG_USB_CONFIGFS_UEVENT
+	.setup          = android_setup,
+	.reset          = android_disconnect,
+	.disconnect     = android_disconnect,
+#else
 	.setup          = composite_setup,
 	.reset          = composite_disconnect,
 	.disconnect     = composite_disconnect,
-
+#endif
 	.suspend	= composite_suspend,
 	.resume		= composite_resume,
 
@@ -1407,6 +1602,89 @@ static void configfs_composite_unbind(struct usb_gadget *gadget)
 	.match_existing_only = 1,
 };
 
+#ifdef CONFIG_USB_CONFIGFS_UEVENT
+static ssize_t state_show(struct device *pdev, struct device_attribute *attr,
+			char *buf)
+{
+	struct gadget_info *dev = dev_get_drvdata(pdev);
+	struct usb_composite_dev *cdev;
+	char *state = "DISCONNECTED";
+	unsigned long flags;
+
+	if (!dev)
+		goto out;
+
+	cdev = &dev->cdev;
+
+	if (!cdev)
+		goto out;
+
+	spin_lock_irqsave(&cdev->lock, flags);
+	if (cdev->config)
+		state = "CONFIGURED";
+	else if (dev->connected)
+		state = "CONNECTED";
+	spin_unlock_irqrestore(&cdev->lock, flags);
+out:
+	return sprintf(buf, "%s\n", state);
+}
+
+static DEVICE_ATTR(state, S_IRUGO, state_show, NULL);
+
+static struct device_attribute *android_usb_attributes[] = {
+	&dev_attr_state,
+	NULL
+};
+
+static int android_device_create(struct gadget_info *gi)
+{
+	struct device_attribute **attrs;
+	struct device_attribute *attr;
+
+	INIT_WORK(&gi->work, android_work);
+	android_device = device_create(android_class, NULL,
+				MKDEV(0, 0), NULL, "android0");
+	if (IS_ERR(android_device))
+		return PTR_ERR(android_device);
+
+	dev_set_drvdata(android_device, gi);
+
+	attrs = android_usb_attributes;
+	while ((attr = *attrs++)) {
+		int err;
+
+		err = device_create_file(android_device, attr);
+		if (err) {
+			device_destroy(android_device->class,
+				       android_device->devt);
+			return err;
+		}
+	}
+
+	return 0;
+}
+
+static void android_device_destroy(void)
+{
+	struct device_attribute **attrs;
+	struct device_attribute *attr;
+
+	attrs = android_usb_attributes;
+	while ((attr = *attrs++))
+		device_remove_file(android_device, attr);
+	device_destroy(android_device->class, android_device->devt);
+}
+#else
+static inline int android_device_create(struct gadget_info *gi)
+{
+	return 0;
+}
+
+static inline void android_device_destroy(void)
+{
+}
+#endif
+
 static struct config_group *gadgets_make(
 		struct config_group *group,
 		const char *name)
@@ -1452,13 +1730,21 @@ static struct config_group *gadgets_make(
 
 	gi->composite.gadget_driver = configfs_driver_template;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	INIT_LIST_HEAD(&(gi->composite.gadget_driver.pending));
+#endif
+
 	gi->composite.gadget_driver.function = kstrdup(name, GFP_KERNEL);
 	gi->composite.name = gi->composite.gadget_driver.function;
 
 	if (!gi->composite.gadget_driver.function)
 		goto err;
 
+	if (android_device_create(gi) < 0)
+		goto err;
+
 	return &gi->group;
+
 err:
 	kfree(gi);
 	return ERR_PTR(-ENOMEM);
@@ -1467,6 +1753,7 @@ static struct config_group *gadgets_make(
 static void gadgets_drop(struct config_group *group, struct config_item *item)
 {
 	config_item_put(item);
+	android_device_destroy();
 }
 
 static struct configfs_group_operations gadgets_ops = {
@@ -1506,6 +1793,13 @@ static int __init gadget_cfs_init(void)
 	config_group_init(&gadget_subsys.su_group);
 
 	ret = configfs_register_subsystem(&gadget_subsys);
+
+#ifdef CONFIG_USB_CONFIGFS_UEVENT
+	android_class = class_create(THIS_MODULE, "android_usb");
+	if (IS_ERR(android_class))
+		return PTR_ERR(android_class);
+#endif
+
 	return ret;
 }
 module_init(gadget_cfs_init);
@@ -1513,5 +1807,10 @@ static int __init gadget_cfs_init(void)
 static void __exit gadget_cfs_exit(void)
 {
 	configfs_unregister_subsystem(&gadget_subsys);
+#ifdef CONFIG_USB_CONFIGFS_UEVENT
+	if (!IS_ERR(android_class))
+		class_destroy(android_class);
+#endif
+
 }
 module_exit(gadget_cfs_exit);
diff --git a/drivers/usb/gadget/function/Makefile b/drivers/usb/gadget/function/Makefile
index cb8c225..78682d5 100644
--- a/drivers/usb/gadget/function/Makefile
+++ b/drivers/usb/gadget/function/Makefile
@@ -46,3 +46,11 @@ usb_f_printer-y			:= f_printer.o
 obj-$(CONFIG_USB_F_PRINTER)	+= usb_f_printer.o
 usb_f_tcm-y			:= f_tcm.o
 obj-$(CONFIG_USB_F_TCM)		+= usb_f_tcm.o
+usb_f_mtp-y                     := f_mtp.o
+obj-$(CONFIG_USB_F_MTP)         += usb_f_mtp.o
+usb_f_ptp-y                     := f_ptp.o
+obj-$(CONFIG_USB_F_PTP)         += usb_f_ptp.o
+usb_f_audio_source-y            := f_audio_source.o
+obj-$(CONFIG_USB_F_AUDIO_SRC)   += usb_f_audio_source.o
+usb_f_accessory-y               := f_accessory.o
+obj-$(CONFIG_USB_F_ACC)         += usb_f_accessory.o
diff --git a/drivers/usb/gadget/function/f_accessory.c b/drivers/usb/gadget/function/f_accessory.c
new file mode 100644
index 00000000..7aa2656
--- /dev/null
+++ b/drivers/usb/gadget/function/f_accessory.c
@@ -0,0 +1,1352 @@
+/*
+ * Gadget Function Driver for Android USB accessories
+ *
+ * Copyright (C) 2011 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+/* #define DEBUG */
+/* #define VERBOSE_DEBUG */
+
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/poll.h>
+#include <linux/delay.h>
+#include <linux/wait.h>
+#include <linux/err.h>
+#include <linux/interrupt.h>
+#include <linux/kthread.h>
+#include <linux/freezer.h>
+
+#include <linux/types.h>
+#include <linux/file.h>
+#include <linux/device.h>
+#include <linux/miscdevice.h>
+
+#include <linux/hid.h>
+#include <linux/hiddev.h>
+#include <linux/usb.h>
+#include <linux/usb/ch9.h>
+#include <linux/usb/f_accessory.h>
+
+#include <linux/configfs.h>
+#include <linux/usb/composite.h>
+
+#define MAX_INST_NAME_LEN        40
+#define BULK_BUFFER_SIZE    16384
+#define ACC_STRING_SIZE     256
+
+#define PROTOCOL_VERSION    2
+
+/* String IDs */
+#define INTERFACE_STRING_INDEX	0
+
+/* number of tx and rx requests to allocate */
+#define TX_REQ_MAX 4
+#define RX_REQ_MAX 2
+
+struct acc_hid_dev {
+	struct list_head	list;
+	struct hid_device *hid;
+	struct acc_dev *dev;
+	/* accessory defined ID */
+	int id;
+	/* HID report descriptor */
+	u8 *report_desc;
+	/* length of HID report descriptor */
+	int report_desc_len;
+	/* number of bytes of report_desc we have received so far */
+	int report_desc_offset;
+};
+
+struct acc_dev {
+	struct usb_function function;
+	struct usb_composite_dev *cdev;
+	spinlock_t lock;
+
+	struct usb_ep *ep_in;
+	struct usb_ep *ep_out;
+
+	/* online indicates state of function_set_alt & function_unbind
+	 * set to 1 when we connect
+	 */
+	int online:1;
+
+	/* disconnected indicates state of open & release
+	 * Set to 1 when we disconnect.
+	 * Not cleared until our file is closed.
+	 */
+	int disconnected:1;
+
+	/* strings sent by the host */
+	char manufacturer[ACC_STRING_SIZE];
+	char model[ACC_STRING_SIZE];
+	char description[ACC_STRING_SIZE];
+	char version[ACC_STRING_SIZE];
+	char uri[ACC_STRING_SIZE];
+	char serial[ACC_STRING_SIZE];
+
+	/* for acc_complete_set_string */
+	int string_index;
+
+	/* set to 1 if we have a pending start request */
+	int start_requested;
+
+	int audio_mode;
+
+	/* synchronize access to our device file */
+	atomic_t open_excl;
+
+	struct list_head tx_idle;
+
+	wait_queue_head_t read_wq;
+	wait_queue_head_t write_wq;
+	struct usb_request *rx_req[RX_REQ_MAX];
+	int rx_done;
+
+	/* delayed work for handling ACCESSORY_START */
+	struct delayed_work start_work;
+
+	/* worker for registering and unregistering hid devices */
+	struct work_struct hid_work;
+
+	/* list of active HID devices */
+	struct list_head	hid_list;
+
+	/* list of new HID devices to register */
+	struct list_head	new_hid_list;
+
+	/* list of dead HID devices to unregister */
+	struct list_head	dead_hid_list;
+};
+
+static struct usb_interface_descriptor acc_interface_desc = {
+	.bLength                = USB_DT_INTERFACE_SIZE,
+	.bDescriptorType        = USB_DT_INTERFACE,
+	.bInterfaceNumber       = 0,
+	.bNumEndpoints          = 2,
+	.bInterfaceClass        = USB_CLASS_VENDOR_SPEC,
+	.bInterfaceSubClass     = USB_SUBCLASS_VENDOR_SPEC,
+	.bInterfaceProtocol     = 0,
+};
+
+static struct usb_endpoint_descriptor acc_highspeed_in_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_IN,
+	.bmAttributes           = USB_ENDPOINT_XFER_BULK,
+	.wMaxPacketSize         = __constant_cpu_to_le16(512),
+};
+
+static struct usb_endpoint_descriptor acc_highspeed_out_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_OUT,
+	.bmAttributes           = USB_ENDPOINT_XFER_BULK,
+	.wMaxPacketSize         = __constant_cpu_to_le16(512),
+};
+
+static struct usb_endpoint_descriptor acc_fullspeed_in_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_IN,
+	.bmAttributes           = USB_ENDPOINT_XFER_BULK,
+};
+
+static struct usb_endpoint_descriptor acc_fullspeed_out_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_OUT,
+	.bmAttributes           = USB_ENDPOINT_XFER_BULK,
+};
+
+static struct usb_descriptor_header *fs_acc_descs[] = {
+	(struct usb_descriptor_header *) &acc_interface_desc,
+	(struct usb_descriptor_header *) &acc_fullspeed_in_desc,
+	(struct usb_descriptor_header *) &acc_fullspeed_out_desc,
+	NULL,
+};
+
+static struct usb_descriptor_header *hs_acc_descs[] = {
+	(struct usb_descriptor_header *) &acc_interface_desc,
+	(struct usb_descriptor_header *) &acc_highspeed_in_desc,
+	(struct usb_descriptor_header *) &acc_highspeed_out_desc,
+	NULL,
+};
+
+static struct usb_string acc_string_defs[] = {
+	[INTERFACE_STRING_INDEX].s	= "Android Accessory Interface",
+	{  },	/* end of list */
+};
+
+static struct usb_gadget_strings acc_string_table = {
+	.language		= 0x0409,	/* en-US */
+	.strings		= acc_string_defs,
+};
+
+static struct usb_gadget_strings *acc_strings[] = {
+	&acc_string_table,
+	NULL,
+};
+
+/* temporary variable used between acc_open() and acc_gadget_bind() */
+static struct acc_dev *_acc_dev;
+
+struct acc_instance {
+	struct usb_function_instance func_inst;
+	const char *name;
+};
+
+static inline struct acc_dev *func_to_dev(struct usb_function *f)
+{
+	return container_of(f, struct acc_dev, function);
+}
+
+static struct usb_request *acc_request_new(struct usb_ep *ep, int buffer_size)
+{
+	struct usb_request *req = usb_ep_alloc_request(ep, GFP_KERNEL);
+
+	if (!req)
+		return NULL;
+
+	/* now allocate buffers for the requests */
+	req->buf = kmalloc(buffer_size, GFP_KERNEL);
+	if (!req->buf) {
+		usb_ep_free_request(ep, req);
+		return NULL;
+	}
+
+	return req;
+}
+
+static void acc_request_free(struct usb_request *req, struct usb_ep *ep)
+{
+	if (req) {
+		kfree(req->buf);
+		usb_ep_free_request(ep, req);
+	}
+}
+
+/* add a request to the tail of a list */
+static void req_put(struct acc_dev *dev, struct list_head *head,
+		struct usb_request *req)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&dev->lock, flags);
+	list_add_tail(&req->list, head);
+	spin_unlock_irqrestore(&dev->lock, flags);
+}
+
+/* remove a request from the head of a list */
+static struct usb_request *req_get(struct acc_dev *dev, struct list_head *head)
+{
+	unsigned long flags;
+	struct usb_request *req;
+
+	spin_lock_irqsave(&dev->lock, flags);
+	if (list_empty(head)) {
+		req = 0;
+	} else {
+		req = list_first_entry(head, struct usb_request, list);
+		list_del(&req->list);
+	}
+	spin_unlock_irqrestore(&dev->lock, flags);
+	return req;
+}
+
+static void acc_set_disconnected(struct acc_dev *dev)
+{
+	dev->disconnected = 1;
+}
+
+static void acc_complete_in(struct usb_ep *ep, struct usb_request *req)
+{
+	struct acc_dev *dev = _acc_dev;
+
+	if (req->status == -ESHUTDOWN) {
+		pr_debug("acc_complete_in set disconnected");
+		acc_set_disconnected(dev);
+	}
+
+	req_put(dev, &dev->tx_idle, req);
+
+	wake_up(&dev->write_wq);
+}
+
+static void acc_complete_out(struct usb_ep *ep, struct usb_request *req)
+{
+	struct acc_dev *dev = _acc_dev;
+
+	dev->rx_done = 1;
+	if (req->status == -ESHUTDOWN) {
+		pr_debug("acc_complete_out set disconnected");
+		acc_set_disconnected(dev);
+	}
+
+	wake_up(&dev->read_wq);
+}
+
+static void acc_complete_set_string(struct usb_ep *ep, struct usb_request *req)
+{
+	struct acc_dev	*dev = ep->driver_data;
+	char *string_dest = NULL;
+	int length = req->actual;
+
+	if (req->status != 0) {
+		pr_err("acc_complete_set_string, err %d\n", req->status);
+		return;
+	}
+
+	switch (dev->string_index) {
+	case ACCESSORY_STRING_MANUFACTURER:
+		string_dest = dev->manufacturer;
+		break;
+	case ACCESSORY_STRING_MODEL:
+		string_dest = dev->model;
+		break;
+	case ACCESSORY_STRING_DESCRIPTION:
+		string_dest = dev->description;
+		break;
+	case ACCESSORY_STRING_VERSION:
+		string_dest = dev->version;
+		break;
+	case ACCESSORY_STRING_URI:
+		string_dest = dev->uri;
+		break;
+	case ACCESSORY_STRING_SERIAL:
+		string_dest = dev->serial;
+		break;
+	}
+	if (string_dest) {
+		unsigned long flags;
+
+		if (length >= ACC_STRING_SIZE)
+			length = ACC_STRING_SIZE - 1;
+
+		spin_lock_irqsave(&dev->lock, flags);
+		memcpy(string_dest, req->buf, length);
+		/* ensure zero termination */
+		string_dest[length] = 0;
+		spin_unlock_irqrestore(&dev->lock, flags);
+	} else {
+		pr_err("unknown accessory string index %d\n",
+			dev->string_index);
+	}
+}
+
+static void acc_complete_set_hid_report_desc(struct usb_ep *ep,
+		struct usb_request *req)
+{
+	struct acc_hid_dev *hid = req->context;
+	struct acc_dev *dev = hid->dev;
+	int length = req->actual;
+
+	if (req->status != 0) {
+		pr_err("acc_complete_set_hid_report_desc, err %d\n",
+			req->status);
+		return;
+	}
+
+	memcpy(hid->report_desc + hid->report_desc_offset, req->buf, length);
+	hid->report_desc_offset += length;
+	if (hid->report_desc_offset == hid->report_desc_len) {
+		/* After we have received the entire report descriptor
+		 * we schedule work to initialize the HID device
+		 */
+		schedule_work(&dev->hid_work);
+	}
+}
+
+static void acc_complete_send_hid_event(struct usb_ep *ep,
+		struct usb_request *req)
+{
+	struct acc_hid_dev *hid = req->context;
+	int length = req->actual;
+
+	if (req->status != 0) {
+		pr_err("acc_complete_send_hid_event, err %d\n", req->status);
+		return;
+	}
+
+	hid_report_raw_event(hid->hid, HID_INPUT_REPORT, req->buf, length, 1);
+}
+
+static int acc_hid_parse(struct hid_device *hid)
+{
+	struct acc_hid_dev *hdev = hid->driver_data;
+
+	hid_parse_report(hid, hdev->report_desc, hdev->report_desc_len);
+	return 0;
+}
+
+static int acc_hid_start(struct hid_device *hid)
+{
+	return 0;
+}
+
+static void acc_hid_stop(struct hid_device *hid)
+{
+}
+
+static int acc_hid_open(struct hid_device *hid)
+{
+	return 0;
+}
+
+static void acc_hid_close(struct hid_device *hid)
+{
+}
+
+static int acc_hid_raw_request(struct hid_device *hid, unsigned char reportnum,
+	__u8 *buf, size_t len, unsigned char rtype, int reqtype)
+{
+	return 0;
+}
+
+static struct hid_ll_driver acc_hid_ll_driver = {
+	.parse = acc_hid_parse,
+	.start = acc_hid_start,
+	.stop = acc_hid_stop,
+	.open = acc_hid_open,
+	.close = acc_hid_close,
+	.raw_request = acc_hid_raw_request,
+};
+
+static struct acc_hid_dev *acc_hid_new(struct acc_dev *dev,
+		int id, int desc_len)
+{
+	struct acc_hid_dev *hdev;
+
+	hdev = kzalloc(sizeof(*hdev), GFP_ATOMIC);
+	if (!hdev)
+		return NULL;
+	hdev->report_desc = kzalloc(desc_len, GFP_ATOMIC);
+	if (!hdev->report_desc) {
+		kfree(hdev);
+		return NULL;
+	}
+	hdev->dev = dev;
+	hdev->id = id;
+	hdev->report_desc_len = desc_len;
+
+	return hdev;
+}
+
+static struct acc_hid_dev *acc_hid_get(struct list_head *list, int id)
+{
+	struct acc_hid_dev *hid;
+
+	list_for_each_entry(hid, list, list) {
+		if (hid->id == id)
+			return hid;
+	}
+	return NULL;
+}
+
+static int acc_register_hid(struct acc_dev *dev, int id, int desc_length)
+{
+	struct acc_hid_dev *hid;
+	unsigned long flags;
+
+	/* report descriptor length must be > 0 */
+	if (desc_length <= 0)
+		return -EINVAL;
+
+	spin_lock_irqsave(&dev->lock, flags);
+	/* replace HID if one already exists with this ID */
+	hid = acc_hid_get(&dev->hid_list, id);
+	if (!hid)
+		hid = acc_hid_get(&dev->new_hid_list, id);
+	if (hid)
+		list_move(&hid->list, &dev->dead_hid_list);
+
+	hid = acc_hid_new(dev, id, desc_length);
+	if (!hid) {
+		spin_unlock_irqrestore(&dev->lock, flags);
+		return -ENOMEM;
+	}
+
+	list_add(&hid->list, &dev->new_hid_list);
+	spin_unlock_irqrestore(&dev->lock, flags);
+
+	/* schedule work to register the HID device */
+	schedule_work(&dev->hid_work);
+	return 0;
+}
+
+static int acc_unregister_hid(struct acc_dev *dev, int id)
+{
+	struct acc_hid_dev *hid;
+	unsigned long flags;
+
+	spin_lock_irqsave(&dev->lock, flags);
+	hid = acc_hid_get(&dev->hid_list, id);
+	if (!hid)
+		hid = acc_hid_get(&dev->new_hid_list, id);
+	if (!hid) {
+		spin_unlock_irqrestore(&dev->lock, flags);
+		return -EINVAL;
+	}
+
+	list_move(&hid->list, &dev->dead_hid_list);
+	spin_unlock_irqrestore(&dev->lock, flags);
+
+	schedule_work(&dev->hid_work);
+	return 0;
+}
+
+static int create_bulk_endpoints(struct acc_dev *dev,
+				struct usb_endpoint_descriptor *in_desc,
+				struct usb_endpoint_descriptor *out_desc)
+{
+	struct usb_composite_dev *cdev = dev->cdev;
+	struct usb_request *req;
+	struct usb_ep *ep;
+	int i;
+
+	DBG(cdev, "create_bulk_endpoints dev: %p\n", dev);
+
+	ep = usb_ep_autoconfig(cdev->gadget, in_desc);
+	if (!ep) {
+		DBG(cdev, "usb_ep_autoconfig for ep_in failed\n");
+		return -ENODEV;
+	}
+	DBG(cdev, "usb_ep_autoconfig for ep_in got %s\n", ep->name);
+	ep->driver_data = dev;		/* claim the endpoint */
+	dev->ep_in = ep;
+
+	ep = usb_ep_autoconfig(cdev->gadget, out_desc);
+	if (!ep) {
+		DBG(cdev, "usb_ep_autoconfig for ep_out failed\n");
+		return -ENODEV;
+	}
+	DBG(cdev, "usb_ep_autoconfig for ep_out got %s\n", ep->name);
+	ep->driver_data = dev;		/* claim the endpoint */
+	dev->ep_out = ep;
+
+	/* now allocate requests for our endpoints */
+	for (i = 0; i < TX_REQ_MAX; i++) {
+		req = acc_request_new(dev->ep_in, BULK_BUFFER_SIZE);
+		if (!req)
+			goto fail;
+		req->complete = acc_complete_in;
+		req_put(dev, &dev->tx_idle, req);
+	}
+	for (i = 0; i < RX_REQ_MAX; i++) {
+		req = acc_request_new(dev->ep_out, BULK_BUFFER_SIZE);
+		if (!req)
+			goto fail;
+		req->complete = acc_complete_out;
+		dev->rx_req[i] = req;
+	}
+
+	return 0;
+
+fail:
+	pr_err("acc_bind() could not allocate requests\n");
+	while ((req = req_get(dev, &dev->tx_idle)))
+		acc_request_free(req, dev->ep_in);
+	for (i = 0; i < RX_REQ_MAX; i++)
+		acc_request_free(dev->rx_req[i], dev->ep_out);
+	return -1;
+}
+
+static ssize_t acc_read(struct file *fp, char __user *buf,
+	size_t count, loff_t *pos)
+{
+	struct acc_dev *dev = fp->private_data;
+	struct usb_request *req;
+	ssize_t r = count;
+	unsigned xfer;
+	int ret = 0;
+
+	pr_debug("acc_read(%zu)\n", count);
+
+	if (dev->disconnected) {
+		pr_debug("acc_read disconnected");
+		return -ENODEV;
+	}
+
+	if (count > BULK_BUFFER_SIZE)
+		count = BULK_BUFFER_SIZE;
+
+	/* we will block until we're online */
+	pr_debug("acc_read: waiting for online\n");
+	ret = wait_event_interruptible(dev->read_wq, dev->online);
+	if (ret < 0) {
+		r = ret;
+		goto done;
+	}
+
+	if (dev->rx_done) {
+		// last req cancelled. try to get it.
+		req = dev->rx_req[0];
+		goto copy_data;
+	}
+
+requeue_req:
+	/* queue a request */
+	req = dev->rx_req[0];
+	req->length = count;
+	dev->rx_done = 0;
+	ret = usb_ep_queue(dev->ep_out, req, GFP_KERNEL);
+	if (ret < 0) {
+		r = -EIO;
+		goto done;
+	} else {
+		pr_debug("rx %p queue\n", req);
+	}
+
+	/* wait for a request to complete */
+	ret = wait_event_interruptible(dev->read_wq, dev->rx_done);
+	if (ret < 0) {
+		r = ret;
+		ret = usb_ep_dequeue(dev->ep_out, req);
+		if (ret != 0) {
+			// cancel failed. There can be a data already received.
+			// it will be retrieved in the next read.
+			pr_debug("acc_read: cancelling failed %d", ret);
+		}
+		goto done;
+	}
+
+copy_data:
+	dev->rx_done = 0;
+	if (dev->online) {
+		/* If we got a 0-len packet, throw it back and try again. */
+		if (req->actual == 0)
+			goto requeue_req;
+
+		pr_debug("rx %p %u\n", req, req->actual);
+		xfer = (req->actual < count) ? req->actual : count;
+		r = xfer;
+		if (copy_to_user(buf, req->buf, xfer))
+			r = -EFAULT;
+	} else
+		r = -EIO;
+
+done:
+	pr_debug("acc_read returning %zd\n", r);
+	return r;
+}
+
+static ssize_t acc_write(struct file *fp, const char __user *buf,
+	size_t count, loff_t *pos)
+{
+	struct acc_dev *dev = fp->private_data;
+	struct usb_request *req = 0;
+	ssize_t r = count;
+	unsigned xfer;
+	int ret;
+
+	pr_debug("acc_write(%zu)\n", count);
+
+	if (!dev->online || dev->disconnected) {
+		pr_debug("acc_write disconnected or not online");
+		return -ENODEV;
+	}
+
+	while (count > 0) {
+		if (!dev->online) {
+			pr_debug("acc_write dev->error\n");
+			r = -EIO;
+			break;
+		}
+
+		/* get an idle tx request to use */
+		req = 0;
+		ret = wait_event_interruptible(dev->write_wq,
+			((req = req_get(dev, &dev->tx_idle)) || !dev->online));
+		if (!req) {
+			r = ret;
+			break;
+		}
+
+		if (count > BULK_BUFFER_SIZE) {
+			xfer = BULK_BUFFER_SIZE;
+			/* ZLP, They will be more TX requests so not yet. */
+			req->zero = 0;
+		} else {
+			xfer = count;
+			/* If the data length is a multple of the
+			 * maxpacket size then send a zero length packet(ZLP).
+			*/
+			req->zero = ((xfer % dev->ep_in->maxpacket) == 0);
+		}
+		if (copy_from_user(req->buf, buf, xfer)) {
+			r = -EFAULT;
+			break;
+		}
+
+		req->length = xfer;
+		ret = usb_ep_queue(dev->ep_in, req, GFP_KERNEL);
+		if (ret < 0) {
+			pr_debug("acc_write: xfer error %d\n", ret);
+			r = -EIO;
+			break;
+		}
+
+		buf += xfer;
+		count -= xfer;
+
+		/* zero this so we don't try to free it on error exit */
+		req = 0;
+	}
+
+	if (req)
+		req_put(dev, &dev->tx_idle, req);
+
+	pr_debug("acc_write returning %zd\n", r);
+	return r;
+}
+
+static long acc_ioctl(struct file *fp, unsigned code, unsigned long value)
+{
+	struct acc_dev *dev = fp->private_data;
+	char *src = NULL;
+	int ret;
+
+	switch (code) {
+	case ACCESSORY_GET_STRING_MANUFACTURER:
+		src = dev->manufacturer;
+		break;
+	case ACCESSORY_GET_STRING_MODEL:
+		src = dev->model;
+		break;
+	case ACCESSORY_GET_STRING_DESCRIPTION:
+		src = dev->description;
+		break;
+	case ACCESSORY_GET_STRING_VERSION:
+		src = dev->version;
+		break;
+	case ACCESSORY_GET_STRING_URI:
+		src = dev->uri;
+		break;
+	case ACCESSORY_GET_STRING_SERIAL:
+		src = dev->serial;
+		break;
+	case ACCESSORY_IS_START_REQUESTED:
+		return dev->start_requested;
+	case ACCESSORY_GET_AUDIO_MODE:
+		return dev->audio_mode;
+	}
+	if (!src)
+		return -EINVAL;
+
+	ret = strlen(src) + 1;
+	if (copy_to_user((void __user *)value, src, ret))
+		ret = -EFAULT;
+	return ret;
+}
+
+static int acc_open(struct inode *ip, struct file *fp)
+{
+	printk(KERN_INFO "acc_open\n");
+	if (atomic_xchg(&_acc_dev->open_excl, 1))
+		return -EBUSY;
+
+	_acc_dev->disconnected = 0;
+	fp->private_data = _acc_dev;
+	return 0;
+}
+
+static int acc_release(struct inode *ip, struct file *fp)
+{
+	printk(KERN_INFO "acc_release\n");
+
+	WARN_ON(!atomic_xchg(&_acc_dev->open_excl, 0));
+	/* indicate that we are disconnected
+	 * still could be online so don't touch online flag
+	 */
+	_acc_dev->disconnected = 1;
+	return 0;
+}
+
+/* file operations for /dev/usb_accessory */
+static const struct file_operations acc_fops = {
+	.owner = THIS_MODULE,
+	.read = acc_read,
+	.write = acc_write,
+	.unlocked_ioctl = acc_ioctl,
+	.open = acc_open,
+	.release = acc_release,
+};
+
+static int acc_hid_probe(struct hid_device *hdev,
+		const struct hid_device_id *id)
+{
+	int ret;
+
+	ret = hid_parse(hdev);
+	if (ret)
+		return ret;
+	return hid_hw_start(hdev, HID_CONNECT_DEFAULT);
+}
+
+static struct miscdevice acc_device = {
+	.minor = MISC_DYNAMIC_MINOR,
+	.name = "usb_accessory",
+	.fops = &acc_fops,
+};
+
+static const struct hid_device_id acc_hid_table[] = {
+	{ HID_USB_DEVICE(HID_ANY_ID, HID_ANY_ID) },
+	{ }
+};
+
+static struct hid_driver acc_hid_driver = {
+	.name = "USB accessory",
+	.id_table = acc_hid_table,
+	.probe = acc_hid_probe,
+};
+
+static void acc_complete_setup_noop(struct usb_ep *ep, struct usb_request *req)
+{
+	/*
+	 * Default no-op function when nothing needs to be done for the
+	 * setup request
+	 */
+}
+
+int acc_ctrlrequest(struct usb_composite_dev *cdev,
+				const struct usb_ctrlrequest *ctrl)
+{
+	struct acc_dev	*dev = _acc_dev;
+	int	value = -EOPNOTSUPP;
+	struct acc_hid_dev *hid;
+	int offset;
+	u8 b_requestType = ctrl->bRequestType;
+	u8 b_request = ctrl->bRequest;
+	u16	w_index = le16_to_cpu(ctrl->wIndex);
+	u16	w_value = le16_to_cpu(ctrl->wValue);
+	u16	w_length = le16_to_cpu(ctrl->wLength);
+	unsigned long flags;
+
+/*
+	printk(KERN_INFO "acc_ctrlrequest "
+			"%02x.%02x v%04x i%04x l%u\n",
+			b_requestType, b_request,
+			w_value, w_index, w_length);
+*/
+
+	if (b_requestType == (USB_DIR_OUT | USB_TYPE_VENDOR)) {
+		if (b_request == ACCESSORY_START) {
+			dev->start_requested = 1;
+			schedule_delayed_work(
+				&dev->start_work, msecs_to_jiffies(10));
+			value = 0;
+			cdev->req->complete = acc_complete_setup_noop;
+		} else if (b_request == ACCESSORY_SEND_STRING) {
+			dev->string_index = w_index;
+			cdev->gadget->ep0->driver_data = dev;
+			cdev->req->complete = acc_complete_set_string;
+			value = w_length;
+		} else if (b_request == ACCESSORY_SET_AUDIO_MODE &&
+				w_index == 0 && w_length == 0) {
+			dev->audio_mode = w_value;
+			cdev->req->complete = acc_complete_setup_noop;
+			value = 0;
+		} else if (b_request == ACCESSORY_REGISTER_HID) {
+			cdev->req->complete = acc_complete_setup_noop;
+			value = acc_register_hid(dev, w_value, w_index);
+		} else if (b_request == ACCESSORY_UNREGISTER_HID) {
+			cdev->req->complete = acc_complete_setup_noop;
+			value = acc_unregister_hid(dev, w_value);
+		} else if (b_request == ACCESSORY_SET_HID_REPORT_DESC) {
+			spin_lock_irqsave(&dev->lock, flags);
+			hid = acc_hid_get(&dev->new_hid_list, w_value);
+			spin_unlock_irqrestore(&dev->lock, flags);
+			if (!hid) {
+				value = -EINVAL;
+				goto err;
+			}
+			offset = w_index;
+			if (offset != hid->report_desc_offset
+				|| offset + w_length > hid->report_desc_len) {
+				value = -EINVAL;
+				goto err;
+			}
+			cdev->req->context = hid;
+			cdev->req->complete = acc_complete_set_hid_report_desc;
+			value = w_length;
+		} else if (b_request == ACCESSORY_SEND_HID_EVENT) {
+			spin_lock_irqsave(&dev->lock, flags);
+			hid = acc_hid_get(&dev->hid_list, w_value);
+			spin_unlock_irqrestore(&dev->lock, flags);
+			if (!hid) {
+				value = -EINVAL;
+				goto err;
+			}
+			cdev->req->context = hid;
+			cdev->req->complete = acc_complete_send_hid_event;
+			value = w_length;
+		}
+	} else if (b_requestType == (USB_DIR_IN | USB_TYPE_VENDOR)) {
+		if (b_request == ACCESSORY_GET_PROTOCOL) {
+			*((u16 *)cdev->req->buf) = PROTOCOL_VERSION;
+			value = sizeof(u16);
+			cdev->req->complete = acc_complete_setup_noop;
+			/* clear any string left over from a previous session */
+			memset(dev->manufacturer, 0, sizeof(dev->manufacturer));
+			memset(dev->model, 0, sizeof(dev->model));
+			memset(dev->description, 0, sizeof(dev->description));
+			memset(dev->version, 0, sizeof(dev->version));
+			memset(dev->uri, 0, sizeof(dev->uri));
+			memset(dev->serial, 0, sizeof(dev->serial));
+			dev->start_requested = 0;
+			dev->audio_mode = 0;
+		}
+	}
+
+	if (value >= 0) {
+		cdev->req->zero = 0;
+		cdev->req->length = value;
+		value = usb_ep_queue(cdev->gadget->ep0, cdev->req, GFP_ATOMIC);
+		if (value < 0)
+			ERROR(cdev, "%s setup response queue error\n",
+				__func__);
+	}
+
+err:
+	if (value == -EOPNOTSUPP)
+		VDBG(cdev,
+			"unknown class-specific control req "
+			"%02x.%02x v%04x i%04x l%u\n",
+			ctrl->bRequestType, ctrl->bRequest,
+			w_value, w_index, w_length);
+	return value;
+}
+EXPORT_SYMBOL_GPL(acc_ctrlrequest);
+
+static int
+__acc_function_bind(struct usb_configuration *c,
+			struct usb_function *f, bool configfs)
+{
+	struct usb_composite_dev *cdev = c->cdev;
+	struct acc_dev	*dev = func_to_dev(f);
+	int			id;
+	int			ret;
+
+	DBG(cdev, "acc_function_bind dev: %p\n", dev);
+
+	if (configfs) {
+		if (acc_string_defs[INTERFACE_STRING_INDEX].id == 0) {
+			ret = usb_string_id(c->cdev);
+			if (ret < 0)
+				return ret;
+			acc_string_defs[INTERFACE_STRING_INDEX].id = ret;
+			acc_interface_desc.iInterface = ret;
+		}
+		dev->cdev = c->cdev;
+	}
+	ret = hid_register_driver(&acc_hid_driver);
+	if (ret)
+		return ret;
+
+	dev->start_requested = 0;
+
+	/* allocate interface ID(s) */
+	id = usb_interface_id(c, f);
+	if (id < 0)
+		return id;
+	acc_interface_desc.bInterfaceNumber = id;
+
+	/* allocate endpoints */
+	ret = create_bulk_endpoints(dev, &acc_fullspeed_in_desc,
+			&acc_fullspeed_out_desc);
+	if (ret)
+		return ret;
+
+	/* support high speed hardware */
+	if (gadget_is_dualspeed(c->cdev->gadget)) {
+		acc_highspeed_in_desc.bEndpointAddress =
+			acc_fullspeed_in_desc.bEndpointAddress;
+		acc_highspeed_out_desc.bEndpointAddress =
+			acc_fullspeed_out_desc.bEndpointAddress;
+	}
+
+	DBG(cdev, "%s speed %s: IN/%s, OUT/%s\n",
+			gadget_is_dualspeed(c->cdev->gadget) ? "dual" : "full",
+			f->name, dev->ep_in->name, dev->ep_out->name);
+	return 0;
+}
+
+static int
+acc_function_bind_configfs(struct usb_configuration *c,
+			struct usb_function *f) {
+	return __acc_function_bind(c, f, true);
+}
+
+static void
+kill_all_hid_devices(struct acc_dev *dev)
+{
+	struct acc_hid_dev *hid;
+	struct list_head *entry, *temp;
+	unsigned long flags;
+
+	/* do nothing if usb accessory device doesn't exist */
+	if (!dev)
+		return;
+
+	spin_lock_irqsave(&dev->lock, flags);
+	list_for_each_safe(entry, temp, &dev->hid_list) {
+		hid = list_entry(entry, struct acc_hid_dev, list);
+		list_del(&hid->list);
+		list_add(&hid->list, &dev->dead_hid_list);
+	}
+	list_for_each_safe(entry, temp, &dev->new_hid_list) {
+		hid = list_entry(entry, struct acc_hid_dev, list);
+		list_del(&hid->list);
+		list_add(&hid->list, &dev->dead_hid_list);
+	}
+	spin_unlock_irqrestore(&dev->lock, flags);
+
+	schedule_work(&dev->hid_work);
+}
+
+static void
+acc_hid_unbind(struct acc_dev *dev)
+{
+	hid_unregister_driver(&acc_hid_driver);
+	kill_all_hid_devices(dev);
+}
+
+static void
+acc_function_unbind(struct usb_configuration *c, struct usb_function *f)
+{
+	struct acc_dev	*dev = func_to_dev(f);
+	struct usb_request *req;
+	int i;
+
+	dev->online = 0;		/* clear online flag */
+	wake_up(&dev->read_wq);		/* unblock reads on closure */
+	wake_up(&dev->write_wq);	/* likewise for writes */
+
+	while ((req = req_get(dev, &dev->tx_idle)))
+		acc_request_free(req, dev->ep_in);
+	for (i = 0; i < RX_REQ_MAX; i++)
+		acc_request_free(dev->rx_req[i], dev->ep_out);
+
+	acc_hid_unbind(dev);
+}
+
+static void acc_start_work(struct work_struct *data)
+{
+	char *envp[2] = { "ACCESSORY=START", NULL };
+
+	kobject_uevent_env(&acc_device.this_device->kobj, KOBJ_CHANGE, envp);
+}
+
+static int acc_hid_init(struct acc_hid_dev *hdev)
+{
+	struct hid_device *hid;
+	int ret;
+
+	hid = hid_allocate_device();
+	if (IS_ERR(hid))
+		return PTR_ERR(hid);
+
+	hid->ll_driver = &acc_hid_ll_driver;
+	hid->dev.parent = acc_device.this_device;
+
+	hid->bus = BUS_USB;
+	hid->vendor = HID_ANY_ID;
+	hid->product = HID_ANY_ID;
+	hid->driver_data = hdev;
+	ret = hid_add_device(hid);
+	if (ret) {
+		pr_err("can't add hid device: %d\n", ret);
+		hid_destroy_device(hid);
+		return ret;
+	}
+
+	hdev->hid = hid;
+	return 0;
+}
+
+static void acc_hid_delete(struct acc_hid_dev *hid)
+{
+	kfree(hid->report_desc);
+	kfree(hid);
+}
+
+static void acc_hid_work(struct work_struct *data)
+{
+	struct acc_dev *dev = _acc_dev;
+	struct list_head	*entry, *temp;
+	struct acc_hid_dev *hid;
+	struct list_head	new_list, dead_list;
+	unsigned long flags;
+
+	INIT_LIST_HEAD(&new_list);
+
+	spin_lock_irqsave(&dev->lock, flags);
+
+	/* copy hids that are ready for initialization to new_list */
+	list_for_each_safe(entry, temp, &dev->new_hid_list) {
+		hid = list_entry(entry, struct acc_hid_dev, list);
+		if (hid->report_desc_offset == hid->report_desc_len)
+			list_move(&hid->list, &new_list);
+	}
+
+	if (list_empty(&dev->dead_hid_list)) {
+		INIT_LIST_HEAD(&dead_list);
+	} else {
+		/* move all of dev->dead_hid_list to dead_list */
+		dead_list.prev = dev->dead_hid_list.prev;
+		dead_list.next = dev->dead_hid_list.next;
+		dead_list.next->prev = &dead_list;
+		dead_list.prev->next = &dead_list;
+		INIT_LIST_HEAD(&dev->dead_hid_list);
+	}
+
+	spin_unlock_irqrestore(&dev->lock, flags);
+
+	/* register new HID devices */
+	list_for_each_safe(entry, temp, &new_list) {
+		hid = list_entry(entry, struct acc_hid_dev, list);
+		if (acc_hid_init(hid)) {
+			pr_err("can't add HID device %p\n", hid);
+			acc_hid_delete(hid);
+		} else {
+			spin_lock_irqsave(&dev->lock, flags);
+			list_move(&hid->list, &dev->hid_list);
+			spin_unlock_irqrestore(&dev->lock, flags);
+		}
+	}
+
+	/* remove dead HID devices */
+	list_for_each_safe(entry, temp, &dead_list) {
+		hid = list_entry(entry, struct acc_hid_dev, list);
+		list_del(&hid->list);
+		if (hid->hid)
+			hid_destroy_device(hid->hid);
+		acc_hid_delete(hid);
+	}
+}
+
+static int acc_function_set_alt(struct usb_function *f,
+		unsigned intf, unsigned alt)
+{
+	struct acc_dev	*dev = func_to_dev(f);
+	struct usb_composite_dev *cdev = f->config->cdev;
+	int ret;
+
+	DBG(cdev, "acc_function_set_alt intf: %d alt: %d\n", intf, alt);
+
+	ret = config_ep_by_speed(cdev->gadget, f, dev->ep_in);
+	if (ret)
+		return ret;
+
+	ret = usb_ep_enable(dev->ep_in);
+	if (ret)
+		return ret;
+
+	ret = config_ep_by_speed(cdev->gadget, f, dev->ep_out);
+	if (ret)
+		return ret;
+
+	ret = usb_ep_enable(dev->ep_out);
+	if (ret) {
+		usb_ep_disable(dev->ep_in);
+		return ret;
+	}
+
+	dev->online = 1;
+	dev->disconnected = 0; /* if online then not disconnected */
+
+	/* readers may be blocked waiting for us to go online */
+	wake_up(&dev->read_wq);
+	return 0;
+}
+
+static void acc_function_disable(struct usb_function *f)
+{
+	struct acc_dev	*dev = func_to_dev(f);
+	struct usb_composite_dev	*cdev = dev->cdev;
+
+	DBG(cdev, "acc_function_disable\n");
+	acc_set_disconnected(dev); /* this now only sets disconnected */
+	dev->online = 0; /* so now need to clear online flag here too */
+	usb_ep_disable(dev->ep_in);
+	usb_ep_disable(dev->ep_out);
+
+	/* readers may be blocked waiting for us to go online */
+	wake_up(&dev->read_wq);
+
+	VDBG(cdev, "%s disabled\n", dev->function.name);
+}
+
+static int acc_setup(void)
+{
+	struct acc_dev *dev;
+	int ret;
+
+	dev = kzalloc(sizeof(*dev), GFP_KERNEL);
+	if (!dev)
+		return -ENOMEM;
+
+	spin_lock_init(&dev->lock);
+	init_waitqueue_head(&dev->read_wq);
+	init_waitqueue_head(&dev->write_wq);
+	atomic_set(&dev->open_excl, 0);
+	INIT_LIST_HEAD(&dev->tx_idle);
+	INIT_LIST_HEAD(&dev->hid_list);
+	INIT_LIST_HEAD(&dev->new_hid_list);
+	INIT_LIST_HEAD(&dev->dead_hid_list);
+	INIT_DELAYED_WORK(&dev->start_work, acc_start_work);
+	INIT_WORK(&dev->hid_work, acc_hid_work);
+
+	/* _acc_dev must be set before calling usb_gadget_register_driver */
+	_acc_dev = dev;
+
+	ret = misc_register(&acc_device);
+	if (ret)
+		goto err;
+
+	return 0;
+
+err:
+	kfree(dev);
+	pr_err("USB accessory gadget driver failed to initialize\n");
+	return ret;
+}
+
+void acc_disconnect(void)
+{
+	/* unregister all HID devices if USB is disconnected */
+	kill_all_hid_devices(_acc_dev);
+}
+EXPORT_SYMBOL_GPL(acc_disconnect);
+
+static void acc_cleanup(void)
+{
+	misc_deregister(&acc_device);
+	kfree(_acc_dev);
+	_acc_dev = NULL;
+}
+static struct acc_instance *to_acc_instance(struct config_item *item)
+{
+	return container_of(to_config_group(item), struct acc_instance,
+		func_inst.group);
+}
+
+static void acc_attr_release(struct config_item *item)
+{
+	struct acc_instance *fi_acc = to_acc_instance(item);
+
+	usb_put_function_instance(&fi_acc->func_inst);
+}
+
+static struct configfs_item_operations acc_item_ops = {
+	.release        = acc_attr_release,
+};
+
+static struct config_item_type acc_func_type = {
+	.ct_item_ops    = &acc_item_ops,
+	.ct_owner       = THIS_MODULE,
+};
+
+static struct acc_instance *to_fi_acc(struct usb_function_instance *fi)
+{
+	return container_of(fi, struct acc_instance, func_inst);
+}
+
+static int acc_set_inst_name(struct usb_function_instance *fi, const char *name)
+{
+	struct acc_instance *fi_acc;
+	char *ptr;
+	int name_len;
+
+	name_len = strlen(name) + 1;
+	if (name_len > MAX_INST_NAME_LEN)
+		return -ENAMETOOLONG;
+
+	ptr = kstrndup(name, name_len, GFP_KERNEL);
+	if (!ptr)
+		return -ENOMEM;
+
+	fi_acc = to_fi_acc(fi);
+	fi_acc->name = ptr;
+	return 0;
+}
+
+static void acc_free_inst(struct usb_function_instance *fi)
+{
+	struct acc_instance *fi_acc;
+
+	fi_acc = to_fi_acc(fi);
+	kfree(fi_acc->name);
+	acc_cleanup();
+}
+
+static struct usb_function_instance *acc_alloc_inst(void)
+{
+	struct acc_instance *fi_acc;
+	struct acc_dev *dev;
+	int err;
+
+	fi_acc = kzalloc(sizeof(*fi_acc), GFP_KERNEL);
+	if (!fi_acc)
+		return ERR_PTR(-ENOMEM);
+	fi_acc->func_inst.set_inst_name = acc_set_inst_name;
+	fi_acc->func_inst.free_func_inst = acc_free_inst;
+
+	err = acc_setup();
+	if (err) {
+		kfree(fi_acc);
+		pr_err("Error setting ACCESSORY\n");
+		return ERR_PTR(err);
+	}
+
+	config_group_init_type_name(&fi_acc->func_inst.group,
+					"", &acc_func_type);
+	dev = _acc_dev;
+	return  &fi_acc->func_inst;
+}
+
+static void acc_free(struct usb_function *f)
+{
+/*NO-OP: no function specific resource allocation in mtp_alloc*/
+}
+
+int acc_ctrlrequest_configfs(struct usb_function *f,
+			const struct usb_ctrlrequest *ctrl) {
+	if (f->config != NULL && f->config->cdev != NULL)
+		return acc_ctrlrequest(f->config->cdev, ctrl);
+	else
+		return -1;
+}
+
+static struct usb_function *acc_alloc(struct usb_function_instance *fi)
+{
+	struct acc_dev *dev = _acc_dev;
+
+	pr_info("acc_alloc\n");
+
+	dev->function.name = "accessory";
+	dev->function.strings = acc_strings,
+	dev->function.fs_descriptors = fs_acc_descs;
+	dev->function.hs_descriptors = hs_acc_descs;
+	dev->function.bind = acc_function_bind_configfs;
+	dev->function.unbind = acc_function_unbind;
+	dev->function.set_alt = acc_function_set_alt;
+	dev->function.disable = acc_function_disable;
+	dev->function.free_func = acc_free;
+	dev->function.setup = acc_ctrlrequest_configfs;
+
+	return &dev->function;
+}
+DECLARE_USB_FUNCTION_INIT(accessory, acc_alloc_inst, acc_alloc);
+MODULE_LICENSE("GPL");
diff --git a/drivers/usb/gadget/function/f_audio_source.c b/drivers/usb/gadget/function/f_audio_source.c
new file mode 100644
index 00000000..8124af3
--- /dev/null
+++ b/drivers/usb/gadget/function/f_audio_source.c
@@ -0,0 +1,1071 @@
+/*
+ * Gadget Function Driver for USB audio source device
+ *
+ * Copyright (C) 2012 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/device.h>
+#include <linux/usb/audio.h>
+#include <linux/wait.h>
+#include <linux/pm_qos.h>
+#include <sound/core.h>
+#include <sound/initval.h>
+#include <sound/pcm.h>
+
+#include <linux/usb.h>
+#include <linux/usb_usual.h>
+#include <linux/usb/ch9.h>
+#include <linux/configfs.h>
+#include <linux/usb/composite.h>
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#define SAMPLE_RATE 44100
+#define FRAMES_PER_MSEC (SAMPLE_RATE / 1000)
+
+#define IN_EP_MAX_PACKET_SIZE 256
+
+/* Number of requests to allocate */
+#define IN_EP_REQ_COUNT 4
+
+#define AUDIO_AC_INTERFACE	0
+#define AUDIO_AS_INTERFACE	1
+#define AUDIO_NUM_INTERFACES	2
+#define MAX_INST_NAME_LEN     40
+
+/* B.3.1  Standard AC Interface Descriptor */
+static struct usb_interface_descriptor ac_interface_desc = {
+	.bLength =		USB_DT_INTERFACE_SIZE,
+	.bDescriptorType =	USB_DT_INTERFACE,
+	.bNumEndpoints =	0,
+	.bInterfaceClass =	USB_CLASS_AUDIO,
+	.bInterfaceSubClass =	USB_SUBCLASS_AUDIOCONTROL,
+};
+
+DECLARE_UAC_AC_HEADER_DESCRIPTOR(2);
+
+#define UAC_DT_AC_HEADER_LENGTH	UAC_DT_AC_HEADER_SIZE(AUDIO_NUM_INTERFACES)
+/* 1 input terminal, 1 output terminal and 1 feature unit */
+#define UAC_DT_TOTAL_LENGTH (UAC_DT_AC_HEADER_LENGTH \
+	+ UAC_DT_INPUT_TERMINAL_SIZE + UAC_DT_OUTPUT_TERMINAL_SIZE \
+	+ UAC_DT_FEATURE_UNIT_SIZE(0))
+/* B.3.2  Class-Specific AC Interface Descriptor */
+static struct uac1_ac_header_descriptor_2 ac_header_desc = {
+	.bLength =		UAC_DT_AC_HEADER_LENGTH,
+	.bDescriptorType =	USB_DT_CS_INTERFACE,
+	.bDescriptorSubtype =	UAC_HEADER,
+	.bcdADC =		__constant_cpu_to_le16(0x0100),
+	.wTotalLength =		__constant_cpu_to_le16(UAC_DT_TOTAL_LENGTH),
+	.bInCollection =	AUDIO_NUM_INTERFACES,
+	.baInterfaceNr = {
+		[0] =		AUDIO_AC_INTERFACE,
+		[1] =		AUDIO_AS_INTERFACE,
+	}
+};
+
+#define INPUT_TERMINAL_ID	1
+static struct uac_input_terminal_descriptor input_terminal_desc = {
+	.bLength =		UAC_DT_INPUT_TERMINAL_SIZE,
+	.bDescriptorType =	USB_DT_CS_INTERFACE,
+	.bDescriptorSubtype =	UAC_INPUT_TERMINAL,
+	.bTerminalID =		INPUT_TERMINAL_ID,
+	.wTerminalType =	UAC_INPUT_TERMINAL_MICROPHONE,
+	.bAssocTerminal =	0,
+	.wChannelConfig =	0x3,
+};
+
+DECLARE_UAC_FEATURE_UNIT_DESCRIPTOR(0);
+
+#define FEATURE_UNIT_ID		2
+static struct uac_feature_unit_descriptor_0 feature_unit_desc = {
+	.bLength		= UAC_DT_FEATURE_UNIT_SIZE(0),
+	.bDescriptorType	= USB_DT_CS_INTERFACE,
+	.bDescriptorSubtype	= UAC_FEATURE_UNIT,
+	.bUnitID		= FEATURE_UNIT_ID,
+	.bSourceID		= INPUT_TERMINAL_ID,
+	.bControlSize		= 2,
+};
+
+#define OUTPUT_TERMINAL_ID	3
+static struct uac1_output_terminal_descriptor output_terminal_desc = {
+	.bLength		= UAC_DT_OUTPUT_TERMINAL_SIZE,
+	.bDescriptorType	= USB_DT_CS_INTERFACE,
+	.bDescriptorSubtype	= UAC_OUTPUT_TERMINAL,
+	.bTerminalID		= OUTPUT_TERMINAL_ID,
+	.wTerminalType		= UAC_TERMINAL_STREAMING,
+	.bAssocTerminal		= FEATURE_UNIT_ID,
+	.bSourceID		= FEATURE_UNIT_ID,
+};
+
+/* B.4.1  Standard AS Interface Descriptor */
+static struct usb_interface_descriptor as_interface_alt_0_desc = {
+	.bLength =		USB_DT_INTERFACE_SIZE,
+	.bDescriptorType =	USB_DT_INTERFACE,
+	.bAlternateSetting =	0,
+	.bNumEndpoints =	0,
+	.bInterfaceClass =	USB_CLASS_AUDIO,
+	.bInterfaceSubClass =	USB_SUBCLASS_AUDIOSTREAMING,
+};
+
+static struct usb_interface_descriptor as_interface_alt_1_desc = {
+	.bLength =		USB_DT_INTERFACE_SIZE,
+	.bDescriptorType =	USB_DT_INTERFACE,
+	.bAlternateSetting =	1,
+	.bNumEndpoints =	1,
+	.bInterfaceClass =	USB_CLASS_AUDIO,
+	.bInterfaceSubClass =	USB_SUBCLASS_AUDIOSTREAMING,
+};
+
+/* B.4.2  Class-Specific AS Interface Descriptor */
+static struct uac1_as_header_descriptor as_header_desc = {
+	.bLength =		UAC_DT_AS_HEADER_SIZE,
+	.bDescriptorType =	USB_DT_CS_INTERFACE,
+	.bDescriptorSubtype =	UAC_AS_GENERAL,
+	.bTerminalLink =	INPUT_TERMINAL_ID,
+	.bDelay =		1,
+	.wFormatTag =		UAC_FORMAT_TYPE_I_PCM,
+};
+
+DECLARE_UAC_FORMAT_TYPE_I_DISCRETE_DESC(1);
+
+static struct uac_format_type_i_discrete_descriptor_1 as_type_i_desc = {
+	.bLength =		UAC_FORMAT_TYPE_I_DISCRETE_DESC_SIZE(1),
+	.bDescriptorType =	USB_DT_CS_INTERFACE,
+	.bDescriptorSubtype =	UAC_FORMAT_TYPE,
+	.bFormatType =		UAC_FORMAT_TYPE_I,
+	.bSubframeSize =	2,
+	.bBitResolution =	16,
+	.bSamFreqType =		1,
+};
+
+/* Standard ISO IN Endpoint Descriptor for highspeed */
+static struct usb_endpoint_descriptor hs_as_in_ep_desc  = {
+	.bLength =		USB_DT_ENDPOINT_AUDIO_SIZE,
+	.bDescriptorType =	USB_DT_ENDPOINT,
+	.bEndpointAddress =	USB_DIR_IN,
+	.bmAttributes =		USB_ENDPOINT_SYNC_SYNC
+				| USB_ENDPOINT_XFER_ISOC,
+	.wMaxPacketSize =	__constant_cpu_to_le16(IN_EP_MAX_PACKET_SIZE),
+	.bInterval =		4, /* poll 1 per millisecond */
+};
+
+/* Standard ISO IN Endpoint Descriptor for highspeed */
+static struct usb_endpoint_descriptor fs_as_in_ep_desc  = {
+	.bLength =		USB_DT_ENDPOINT_AUDIO_SIZE,
+	.bDescriptorType =	USB_DT_ENDPOINT,
+	.bEndpointAddress =	USB_DIR_IN,
+	.bmAttributes =		USB_ENDPOINT_SYNC_SYNC
+				| USB_ENDPOINT_XFER_ISOC,
+	.wMaxPacketSize =	__constant_cpu_to_le16(IN_EP_MAX_PACKET_SIZE),
+	.bInterval =		1, /* poll 1 per millisecond */
+};
+
+/* Class-specific AS ISO OUT Endpoint Descriptor */
+static struct uac_iso_endpoint_descriptor as_iso_in_desc = {
+	.bLength =		UAC_ISO_ENDPOINT_DESC_SIZE,
+	.bDescriptorType =	USB_DT_CS_ENDPOINT,
+	.bDescriptorSubtype =	UAC_EP_GENERAL,
+	.bmAttributes =		1,
+	.bLockDelayUnits =	1,
+	.wLockDelay =		__constant_cpu_to_le16(1),
+};
+
+static struct usb_descriptor_header *hs_audio_desc[] = {
+	(struct usb_descriptor_header *)&ac_interface_desc,
+	(struct usb_descriptor_header *)&ac_header_desc,
+
+	(struct usb_descriptor_header *)&input_terminal_desc,
+	(struct usb_descriptor_header *)&output_terminal_desc,
+	(struct usb_descriptor_header *)&feature_unit_desc,
+
+	(struct usb_descriptor_header *)&as_interface_alt_0_desc,
+	(struct usb_descriptor_header *)&as_interface_alt_1_desc,
+	(struct usb_descriptor_header *)&as_header_desc,
+
+	(struct usb_descriptor_header *)&as_type_i_desc,
+
+	(struct usb_descriptor_header *)&hs_as_in_ep_desc,
+	(struct usb_descriptor_header *)&as_iso_in_desc,
+	NULL,
+};
+
+static struct usb_descriptor_header *fs_audio_desc[] = {
+	(struct usb_descriptor_header *)&ac_interface_desc,
+	(struct usb_descriptor_header *)&ac_header_desc,
+
+	(struct usb_descriptor_header *)&input_terminal_desc,
+	(struct usb_descriptor_header *)&output_terminal_desc,
+	(struct usb_descriptor_header *)&feature_unit_desc,
+
+	(struct usb_descriptor_header *)&as_interface_alt_0_desc,
+	(struct usb_descriptor_header *)&as_interface_alt_1_desc,
+	(struct usb_descriptor_header *)&as_header_desc,
+
+	(struct usb_descriptor_header *)&as_type_i_desc,
+
+	(struct usb_descriptor_header *)&fs_as_in_ep_desc,
+	(struct usb_descriptor_header *)&as_iso_in_desc,
+	NULL,
+};
+
+static struct snd_pcm_hardware audio_hw_info = {
+	.info =			SNDRV_PCM_INFO_MMAP |
+				SNDRV_PCM_INFO_MMAP_VALID |
+				SNDRV_PCM_INFO_BATCH |
+				SNDRV_PCM_INFO_INTERLEAVED |
+				SNDRV_PCM_INFO_BLOCK_TRANSFER,
+
+	.formats		= SNDRV_PCM_FMTBIT_S16_LE,
+	.channels_min		= 2,
+	.channels_max		= 2,
+	.rate_min		= SAMPLE_RATE,
+	.rate_max		= SAMPLE_RATE,
+
+	.buffer_bytes_max =	1024 * 1024,
+	.period_bytes_min =	64,
+	.period_bytes_max =	512 * 1024,
+	.periods_min =		2,
+	.periods_max =		1024,
+};
+
+/*-------------------------------------------------------------------------*/
+
+struct audio_source_config {
+	int	card;
+	int	device;
+};
+
+struct audio_dev {
+	struct usb_function		func;
+	struct snd_card			*card;
+	struct snd_pcm			*pcm;
+	struct snd_pcm_substream *substream;
+
+	struct list_head		idle_reqs;
+	struct usb_ep			*in_ep;
+
+	spinlock_t			lock;
+
+	/* beginning, end and current position in our buffer */
+	void				*buffer_start;
+	void				*buffer_end;
+	void				*buffer_pos;
+
+	/* byte size of a "period" */
+	unsigned int			period;
+	/* bytes sent since last call to snd_pcm_period_elapsed */
+	unsigned int			period_offset;
+	/* time we started playing */
+	ktime_t				start_time;
+	/* number of frames sent since start_time */
+	s64				frames_sent;
+	struct audio_source_config	*config;
+	/* for creating and issuing QoS requests */
+	struct pm_qos_request pm_qos;
+};
+
+static inline struct audio_dev *func_to_audio(struct usb_function *f)
+{
+	return container_of(f, struct audio_dev, func);
+}
+
+/*-------------------------------------------------------------------------*/
+
+struct audio_source_instance {
+	struct usb_function_instance func_inst;
+	const char *name;
+	struct audio_source_config *config;
+	struct device *audio_device;
+};
+
+static void audio_source_attr_release(struct config_item *item);
+
+static struct configfs_item_operations audio_source_item_ops = {
+	.release        = audio_source_attr_release,
+};
+
+static struct config_item_type audio_source_func_type = {
+	.ct_item_ops    = &audio_source_item_ops,
+	.ct_owner       = THIS_MODULE,
+};
+
+static ssize_t audio_source_pcm_show(struct device *dev,
+		struct device_attribute *attr, char *buf);
+
+static DEVICE_ATTR(pcm, S_IRUGO, audio_source_pcm_show, NULL);
+
+static struct device_attribute *audio_source_function_attributes[] = {
+	&dev_attr_pcm,
+	NULL
+};
+
+/*--------------------------------------------------------------------------*/
+
+static struct usb_request *audio_request_new(struct usb_ep *ep, int buffer_size)
+{
+	struct usb_request *req = usb_ep_alloc_request(ep, GFP_KERNEL);
+
+	if (!req)
+		return NULL;
+
+	req->buf = kmalloc(buffer_size, GFP_KERNEL);
+	if (!req->buf) {
+		usb_ep_free_request(ep, req);
+		return NULL;
+	}
+	req->length = buffer_size;
+	return req;
+}
+
+static void audio_request_free(struct usb_request *req, struct usb_ep *ep)
+{
+	if (req) {
+		kfree(req->buf);
+		usb_ep_free_request(ep, req);
+	}
+}
+
+static void audio_req_put(struct audio_dev *audio, struct usb_request *req)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&audio->lock, flags);
+	list_add_tail(&req->list, &audio->idle_reqs);
+	spin_unlock_irqrestore(&audio->lock, flags);
+}
+
+static struct usb_request *audio_req_get(struct audio_dev *audio)
+{
+	unsigned long flags;
+	struct usb_request *req;
+
+	spin_lock_irqsave(&audio->lock, flags);
+	if (list_empty(&audio->idle_reqs)) {
+		req = 0;
+	} else {
+		req = list_first_entry(&audio->idle_reqs, struct usb_request,
+				list);
+		list_del(&req->list);
+	}
+	spin_unlock_irqrestore(&audio->lock, flags);
+	return req;
+}
+
+/* send the appropriate number of packets to match our bitrate */
+static void audio_send(struct audio_dev *audio)
+{
+	struct snd_pcm_runtime *runtime;
+	struct usb_request *req;
+	int length, length1, length2, ret;
+	s64 msecs;
+	s64 frames;
+	ktime_t now;
+
+	/* audio->substream will be null if we have been closed */
+	if (!audio->substream)
+		return;
+	/* audio->buffer_pos will be null if we have been stopped */
+	if (!audio->buffer_pos)
+		return;
+
+	runtime = audio->substream->runtime;
+
+	/* compute number of frames to send */
+	now = ktime_get();
+	msecs = div_s64((ktime_to_ns(now) - ktime_to_ns(audio->start_time)),
+			1000000);
+	frames = div_s64((msecs * SAMPLE_RATE), 1000);
+
+	/* Readjust our frames_sent if we fall too far behind.
+	 * If we get too far behind it is better to drop some frames than
+	 * to keep sending data too fast in an attempt to catch up.
+	 */
+	if (frames - audio->frames_sent > 10 * FRAMES_PER_MSEC)
+		audio->frames_sent = frames - FRAMES_PER_MSEC;
+
+	frames -= audio->frames_sent;
+
+	/* We need to send something to keep the pipeline going */
+	if (frames <= 0)
+		frames = FRAMES_PER_MSEC;
+
+	while (frames > 0) {
+		req = audio_req_get(audio);
+		if (!req)
+			break;
+
+		length = frames_to_bytes(runtime, frames);
+		if (length > IN_EP_MAX_PACKET_SIZE)
+			length = IN_EP_MAX_PACKET_SIZE;
+
+		if (audio->buffer_pos + length > audio->buffer_end)
+			length1 = audio->buffer_end - audio->buffer_pos;
+		else
+			length1 = length;
+		memcpy(req->buf, audio->buffer_pos, length1);
+		if (length1 < length) {
+			/* Wrap around and copy remaining length
+			 * at beginning of buffer.
+			 */
+			length2 = length - length1;
+			memcpy(req->buf + length1, audio->buffer_start,
+					length2);
+			audio->buffer_pos = audio->buffer_start + length2;
+		} else {
+			audio->buffer_pos += length1;
+			if (audio->buffer_pos >= audio->buffer_end)
+				audio->buffer_pos = audio->buffer_start;
+		}
+
+		req->length = length;
+		ret = usb_ep_queue(audio->in_ep, req, GFP_ATOMIC);
+		if (ret < 0) {
+			pr_err("usb_ep_queue failed ret: %d\n", ret);
+			audio_req_put(audio, req);
+			break;
+		}
+
+		frames -= bytes_to_frames(runtime, length);
+		audio->frames_sent += bytes_to_frames(runtime, length);
+	}
+}
+
+static void audio_control_complete(struct usb_ep *ep, struct usb_request *req)
+{
+	/* nothing to do here */
+}
+
+static void audio_data_complete(struct usb_ep *ep, struct usb_request *req)
+{
+	struct audio_dev *audio = req->context;
+
+	pr_debug("audio_data_complete req->status %d req->actual %d\n",
+		req->status, req->actual);
+
+	audio_req_put(audio, req);
+
+	if (!audio->buffer_start || req->status)
+		return;
+
+	audio->period_offset += req->actual;
+	if (audio->period_offset >= audio->period) {
+		snd_pcm_period_elapsed(audio->substream);
+		audio->period_offset = 0;
+	}
+	audio_send(audio);
+}
+
+static int audio_set_endpoint_req(struct usb_function *f,
+		const struct usb_ctrlrequest *ctrl)
+{
+	int value = -EOPNOTSUPP;
+	u16 ep = le16_to_cpu(ctrl->wIndex);
+	u16 len = le16_to_cpu(ctrl->wLength);
+	u16 w_value = le16_to_cpu(ctrl->wValue);
+
+	pr_debug("bRequest 0x%x, w_value 0x%04x, len %d, endpoint %d\n",
+			ctrl->bRequest, w_value, len, ep);
+
+	switch (ctrl->bRequest) {
+	case UAC_SET_CUR:
+	case UAC_SET_MIN:
+	case UAC_SET_MAX:
+	case UAC_SET_RES:
+		value = len;
+		break;
+	default:
+		break;
+	}
+
+	return value;
+}
+
+static int audio_get_endpoint_req(struct usb_function *f,
+		const struct usb_ctrlrequest *ctrl)
+{
+	struct usb_composite_dev *cdev = f->config->cdev;
+	int value = -EOPNOTSUPP;
+	u8 ep = ((le16_to_cpu(ctrl->wIndex) >> 8) & 0xFF);
+	u16 len = le16_to_cpu(ctrl->wLength);
+	u16 w_value = le16_to_cpu(ctrl->wValue);
+	u8 *buf = cdev->req->buf;
+
+	pr_debug("bRequest 0x%x, w_value 0x%04x, len %d, endpoint %d\n",
+			ctrl->bRequest, w_value, len, ep);
+
+	if (w_value == UAC_EP_CS_ATTR_SAMPLE_RATE << 8) {
+		switch (ctrl->bRequest) {
+		case UAC_GET_CUR:
+		case UAC_GET_MIN:
+		case UAC_GET_MAX:
+		case UAC_GET_RES:
+			/* return our sample rate */
+			buf[0] = (u8)SAMPLE_RATE;
+			buf[1] = (u8)(SAMPLE_RATE >> 8);
+			buf[2] = (u8)(SAMPLE_RATE >> 16);
+			value = 3;
+			break;
+		default:
+			break;
+		}
+	}
+
+	return value;
+}
+
+static int
+audio_setup(struct usb_function *f, const struct usb_ctrlrequest *ctrl)
+{
+	struct usb_composite_dev *cdev = f->config->cdev;
+	struct usb_request *req = cdev->req;
+	int value = -EOPNOTSUPP;
+	u16 w_index = le16_to_cpu(ctrl->wIndex);
+	u16 w_value = le16_to_cpu(ctrl->wValue);
+	u16 w_length = le16_to_cpu(ctrl->wLength);
+
+	/* composite driver infrastructure handles everything; interface
+	 * activation uses set_alt().
+	 */
+	switch (ctrl->bRequestType) {
+	case USB_DIR_OUT | USB_TYPE_CLASS | USB_RECIP_ENDPOINT:
+		value = audio_set_endpoint_req(f, ctrl);
+		break;
+
+	case USB_DIR_IN | USB_TYPE_CLASS | USB_RECIP_ENDPOINT:
+		value = audio_get_endpoint_req(f, ctrl);
+		break;
+	}
+
+	/* respond with data transfer or status phase? */
+	if (value >= 0) {
+		pr_debug("audio req%02x.%02x v%04x i%04x l%d\n",
+			ctrl->bRequestType, ctrl->bRequest,
+			w_value, w_index, w_length);
+		req->zero = 0;
+		req->length = value;
+		req->complete = audio_control_complete;
+		value = usb_ep_queue(cdev->gadget->ep0, req, GFP_ATOMIC);
+		if (value < 0)
+			pr_err("audio response on err %d\n", value);
+	}
+
+	/* device either stalls (value < 0) or reports success */
+	return value;
+}
+
+static int audio_set_alt(struct usb_function *f, unsigned intf, unsigned alt)
+{
+	struct audio_dev *audio = func_to_audio(f);
+	struct usb_composite_dev *cdev = f->config->cdev;
+	int ret;
+
+	pr_debug("audio_set_alt intf %d, alt %d\n", intf, alt);
+
+	ret = config_ep_by_speed(cdev->gadget, f, audio->in_ep);
+	if (ret)
+		return ret;
+
+	usb_ep_enable(audio->in_ep);
+	return 0;
+}
+
+static void audio_disable(struct usb_function *f)
+{
+	struct audio_dev	*audio = func_to_audio(f);
+
+	pr_debug("audio_disable\n");
+	usb_ep_disable(audio->in_ep);
+}
+
+static void audio_free_func(struct usb_function *f)
+{
+	/* no-op */
+}
+
+/*-------------------------------------------------------------------------*/
+
+static void audio_build_desc(struct audio_dev *audio)
+{
+	u8 *sam_freq;
+	int rate;
+
+	/* Set channel numbers */
+	input_terminal_desc.bNrChannels = 2;
+	as_type_i_desc.bNrChannels = 2;
+
+	/* Set sample rates */
+	rate = SAMPLE_RATE;
+	sam_freq = as_type_i_desc.tSamFreq[0];
+	memcpy(sam_freq, &rate, 3);
+}
+
+
+static int snd_card_setup(struct usb_configuration *c,
+	struct audio_source_config *config);
+static struct audio_source_instance *to_fi_audio_source(
+	const struct usb_function_instance *fi);
+
+
+/* audio function driver setup/binding */
+static int
+audio_bind(struct usb_configuration *c, struct usb_function *f)
+{
+	struct usb_composite_dev *cdev = c->cdev;
+	struct audio_dev *audio = func_to_audio(f);
+	int status;
+	struct usb_ep *ep;
+	struct usb_request *req;
+	int i;
+	int err;
+
+	if (IS_ENABLED(CONFIG_USB_CONFIGFS)) {
+		struct audio_source_instance *fi_audio =
+				to_fi_audio_source(f->fi);
+		struct audio_source_config *config =
+				fi_audio->config;
+
+		err = snd_card_setup(c, config);
+		if (err)
+			return err;
+	}
+
+	audio_build_desc(audio);
+
+	/* allocate instance-specific interface IDs, and patch descriptors */
+	status = usb_interface_id(c, f);
+	if (status < 0)
+		goto fail;
+	ac_interface_desc.bInterfaceNumber = status;
+
+	/* AUDIO_AC_INTERFACE */
+	ac_header_desc.baInterfaceNr[0] = status;
+
+	status = usb_interface_id(c, f);
+	if (status < 0)
+		goto fail;
+	as_interface_alt_0_desc.bInterfaceNumber = status;
+	as_interface_alt_1_desc.bInterfaceNumber = status;
+
+	/* AUDIO_AS_INTERFACE */
+	ac_header_desc.baInterfaceNr[1] = status;
+
+	status = -ENODEV;
+
+	/* allocate our endpoint */
+	ep = usb_ep_autoconfig(cdev->gadget, &fs_as_in_ep_desc);
+	if (!ep)
+		goto fail;
+	audio->in_ep = ep;
+	ep->driver_data = audio; /* claim */
+
+	if (gadget_is_dualspeed(c->cdev->gadget))
+		hs_as_in_ep_desc.bEndpointAddress =
+			fs_as_in_ep_desc.bEndpointAddress;
+
+	f->fs_descriptors = fs_audio_desc;
+	f->hs_descriptors = hs_audio_desc;
+
+	for (i = 0, status = 0; i < IN_EP_REQ_COUNT && status == 0; i++) {
+		req = audio_request_new(ep, IN_EP_MAX_PACKET_SIZE);
+		if (req) {
+			req->context = audio;
+			req->complete = audio_data_complete;
+			audio_req_put(audio, req);
+		} else
+			status = -ENOMEM;
+	}
+
+fail:
+	return status;
+}
+
+static void
+audio_unbind(struct usb_configuration *c, struct usb_function *f)
+{
+	struct audio_dev *audio = func_to_audio(f);
+	struct usb_request *req;
+
+	while ((req = audio_req_get(audio)))
+		audio_request_free(req, audio->in_ep);
+
+	snd_card_free_when_closed(audio->card);
+	audio->card = NULL;
+	audio->pcm = NULL;
+	audio->substream = NULL;
+	audio->in_ep = NULL;
+
+	if (IS_ENABLED(CONFIG_USB_CONFIGFS)) {
+		struct audio_source_instance *fi_audio =
+				to_fi_audio_source(f->fi);
+		struct audio_source_config *config =
+				fi_audio->config;
+
+		config->card = -1;
+		config->device = -1;
+	}
+}
+
+static void audio_pcm_playback_start(struct audio_dev *audio)
+{
+	audio->start_time = ktime_get();
+	audio->frames_sent = 0;
+	audio_send(audio);
+}
+
+static void audio_pcm_playback_stop(struct audio_dev *audio)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&audio->lock, flags);
+	audio->buffer_start = 0;
+	audio->buffer_end = 0;
+	audio->buffer_pos = 0;
+	spin_unlock_irqrestore(&audio->lock, flags);
+}
+
+static int audio_pcm_open(struct snd_pcm_substream *substream)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+	struct audio_dev *audio = substream->private_data;
+
+	runtime->private_data = audio;
+	runtime->hw = audio_hw_info;
+	snd_pcm_limit_hw_rates(runtime);
+	runtime->hw.channels_max = 2;
+
+	audio->substream = substream;
+
+	/* Add the QoS request and set the latency to 0 */
+	pm_qos_add_request(&audio->pm_qos, PM_QOS_CPU_DMA_LATENCY, 0);
+
+	return 0;
+}
+
+static int audio_pcm_close(struct snd_pcm_substream *substream)
+{
+	struct audio_dev *audio = substream->private_data;
+	unsigned long flags;
+
+	spin_lock_irqsave(&audio->lock, flags);
+
+	/* Remove the QoS request */
+	pm_qos_remove_request(&audio->pm_qos);
+
+	audio->substream = NULL;
+	spin_unlock_irqrestore(&audio->lock, flags);
+
+	return 0;
+}
+
+static int audio_pcm_hw_params(struct snd_pcm_substream *substream,
+				struct snd_pcm_hw_params *params)
+{
+	unsigned int channels = params_channels(params);
+	unsigned int rate = params_rate(params);
+
+	if (rate != SAMPLE_RATE)
+		return -EINVAL;
+	if (channels != 2)
+		return -EINVAL;
+
+	return snd_pcm_lib_alloc_vmalloc_buffer(substream,
+		params_buffer_bytes(params));
+}
+
+static int audio_pcm_hw_free(struct snd_pcm_substream *substream)
+{
+	return snd_pcm_lib_free_vmalloc_buffer(substream);
+}
+
+static int audio_pcm_prepare(struct snd_pcm_substream *substream)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+	struct audio_dev *audio = runtime->private_data;
+
+	audio->period = snd_pcm_lib_period_bytes(substream);
+	audio->period_offset = 0;
+	audio->buffer_start = runtime->dma_area;
+	audio->buffer_end = audio->buffer_start
+		+ snd_pcm_lib_buffer_bytes(substream);
+	audio->buffer_pos = audio->buffer_start;
+
+	return 0;
+}
+
+static snd_pcm_uframes_t audio_pcm_pointer(struct snd_pcm_substream *substream)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+	struct audio_dev *audio = runtime->private_data;
+	ssize_t bytes = audio->buffer_pos - audio->buffer_start;
+
+	/* return offset of next frame to fill in our buffer */
+	return bytes_to_frames(runtime, bytes);
+}
+
+static int audio_pcm_playback_trigger(struct snd_pcm_substream *substream,
+					int cmd)
+{
+	struct audio_dev *audio = substream->runtime->private_data;
+	int ret = 0;
+
+	switch (cmd) {
+	case SNDRV_PCM_TRIGGER_START:
+	case SNDRV_PCM_TRIGGER_RESUME:
+		audio_pcm_playback_start(audio);
+		break;
+
+	case SNDRV_PCM_TRIGGER_STOP:
+	case SNDRV_PCM_TRIGGER_SUSPEND:
+		audio_pcm_playback_stop(audio);
+		break;
+
+	default:
+		ret = -EINVAL;
+	}
+
+	return ret;
+}
+
+static struct audio_dev _audio_dev = {
+	.func = {
+		.name = "audio_source",
+		.bind = audio_bind,
+		.unbind = audio_unbind,
+		.set_alt = audio_set_alt,
+		.setup = audio_setup,
+		.disable = audio_disable,
+		.free_func = audio_free_func,
+	},
+	.lock = __SPIN_LOCK_UNLOCKED(_audio_dev.lock),
+	.idle_reqs = LIST_HEAD_INIT(_audio_dev.idle_reqs),
+};
+
+static struct snd_pcm_ops audio_playback_ops = {
+	.open		= audio_pcm_open,
+	.close		= audio_pcm_close,
+	.ioctl		= snd_pcm_lib_ioctl,
+	.hw_params	= audio_pcm_hw_params,
+	.hw_free	= audio_pcm_hw_free,
+	.prepare	= audio_pcm_prepare,
+	.trigger	= audio_pcm_playback_trigger,
+	.pointer	= audio_pcm_pointer,
+};
+
+int audio_source_bind_config(struct usb_configuration *c,
+		struct audio_source_config *config)
+{
+	struct audio_dev *audio;
+	int err;
+
+	config->card = -1;
+	config->device = -1;
+
+	audio = &_audio_dev;
+
+	err = snd_card_setup(c, config);
+	if (err)
+		return err;
+
+	err = usb_add_function(c, &audio->func);
+	if (err)
+		goto add_fail;
+
+	return 0;
+
+add_fail:
+	snd_card_free(audio->card);
+	return err;
+}
+
+static int snd_card_setup(struct usb_configuration *c,
+		struct audio_source_config *config)
+{
+	struct audio_dev *audio;
+	struct snd_card *card;
+	struct snd_pcm *pcm;
+	int err;
+
+	audio = &_audio_dev;
+
+	err = snd_card_new(&c->cdev->gadget->dev,
+			SNDRV_DEFAULT_IDX1, SNDRV_DEFAULT_STR1,
+			THIS_MODULE, 0, &card);
+	if (err)
+		return err;
+
+	err = snd_pcm_new(card, "USB audio source", 0, 1, 0, &pcm);
+	if (err)
+		goto pcm_fail;
+
+	pcm->private_data = audio;
+	pcm->info_flags = 0;
+	audio->pcm = pcm;
+
+	strlcpy(pcm->name, "USB gadget audio", sizeof(pcm->name));
+
+	snd_pcm_set_ops(pcm, SNDRV_PCM_STREAM_PLAYBACK, &audio_playback_ops);
+	snd_pcm_lib_preallocate_pages_for_all(pcm, SNDRV_DMA_TYPE_DEV,
+				NULL, 0, 64 * 1024);
+
+	strlcpy(card->driver, "audio_source", sizeof(card->driver));
+	strlcpy(card->shortname, card->driver, sizeof(card->shortname));
+	strlcpy(card->longname, "USB accessory audio source",
+		sizeof(card->longname));
+
+	err = snd_card_register(card);
+	if (err)
+		goto register_fail;
+
+	config->card = pcm->card->number;
+	config->device = pcm->device;
+	audio->card = card;
+	return 0;
+
+register_fail:
+pcm_fail:
+	snd_card_free(audio->card);
+	return err;
+}
+
+static struct audio_source_instance *to_audio_source_instance(
+					struct config_item *item)
+{
+	return container_of(to_config_group(item), struct audio_source_instance,
+		func_inst.group);
+}
+
+static struct audio_source_instance *to_fi_audio_source(
+					const struct usb_function_instance *fi)
+{
+	return container_of(fi, struct audio_source_instance, func_inst);
+}
+
+static void audio_source_attr_release(struct config_item *item)
+{
+	struct audio_source_instance *fi_audio = to_audio_source_instance(item);
+
+	usb_put_function_instance(&fi_audio->func_inst);
+}
+
+static int audio_source_set_inst_name(struct usb_function_instance *fi,
+					const char *name)
+{
+	struct audio_source_instance *fi_audio;
+	char *ptr;
+	int name_len;
+
+	name_len = strlen(name) + 1;
+	if (name_len > MAX_INST_NAME_LEN)
+		return -ENAMETOOLONG;
+
+	ptr = kstrndup(name, name_len, GFP_KERNEL);
+	if (!ptr)
+		return -ENOMEM;
+
+	fi_audio = to_fi_audio_source(fi);
+	fi_audio->name = ptr;
+
+	return 0;
+}
+
+static void audio_source_free_inst(struct usb_function_instance *fi)
+{
+	struct audio_source_instance *fi_audio;
+
+	fi_audio = to_fi_audio_source(fi);
+	device_destroy(fi_audio->audio_device->class,
+			fi_audio->audio_device->devt);
+	kfree(fi_audio->name);
+	kfree(fi_audio->config);
+}
+
+static ssize_t audio_source_pcm_show(struct device *dev,
+		struct device_attribute *attr, char *buf)
+{
+	struct audio_source_instance *fi_audio = dev_get_drvdata(dev);
+	struct audio_source_config *config = fi_audio->config;
+
+	/* print PCM card and device numbers */
+	return sprintf(buf, "%d %d\n", config->card, config->device);
+}
+
+struct device *create_function_device(char *name);
+
+static struct usb_function_instance *audio_source_alloc_inst(void)
+{
+	struct audio_source_instance *fi_audio;
+	struct device_attribute **attrs;
+	struct device_attribute *attr;
+	struct device *dev;
+	void *err_ptr;
+	int err = 0;
+
+	fi_audio = kzalloc(sizeof(*fi_audio), GFP_KERNEL);
+	if (!fi_audio)
+		return ERR_PTR(-ENOMEM);
+
+	fi_audio->func_inst.set_inst_name = audio_source_set_inst_name;
+	fi_audio->func_inst.free_func_inst = audio_source_free_inst;
+
+	fi_audio->config = kzalloc(sizeof(struct audio_source_config),
+							GFP_KERNEL);
+	if (!fi_audio->config) {
+		err_ptr = ERR_PTR(-ENOMEM);
+		goto fail_audio;
+	}
+
+	config_group_init_type_name(&fi_audio->func_inst.group, "",
+						&audio_source_func_type);
+	dev = create_function_device("f_audio_source");
+
+	if (IS_ERR(dev)) {
+		err_ptr = dev;
+		goto fail_audio_config;
+	}
+
+	fi_audio->config->card = -1;
+	fi_audio->config->device = -1;
+	fi_audio->audio_device = dev;
+
+	attrs = audio_source_function_attributes;
+	if (attrs) {
+		while ((attr = *attrs++) && !err)
+			err = device_create_file(dev, attr);
+		if (err) {
+			err_ptr = ERR_PTR(-EINVAL);
+			goto fail_device;
+		}
+	}
+
+	dev_set_drvdata(dev, fi_audio);
+	_audio_dev.config = fi_audio->config;
+
+	return  &fi_audio->func_inst;
+
+fail_device:
+	device_destroy(dev->class, dev->devt);
+fail_audio_config:
+	kfree(fi_audio->config);
+fail_audio:
+	kfree(fi_audio);
+	return err_ptr;
+
+}
+
+static struct usb_function *audio_source_alloc(struct usb_function_instance *fi)
+{
+	return &_audio_dev.func;
+}
+
+DECLARE_USB_FUNCTION_INIT(audio_source, audio_source_alloc_inst,
+			audio_source_alloc);
+MODULE_LICENSE("GPL");
diff --git a/drivers/usb/gadget/function/f_fs.c b/drivers/usb/gadget/function/f_fs.c
index 04eb643..b849555 100644
--- a/drivers/usb/gadget/function/f_fs.c
+++ b/drivers/usb/gadget/function/f_fs.c
@@ -3243,7 +3243,12 @@ static int ffs_func_setup(struct usb_function *f,
 	__ffs_event_add(ffs, FUNCTIONFS_SETUP);
 	spin_unlock_irqrestore(&ffs->ev.waitq.lock, flags);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Fix adnroid adb push big file fail */
+	return 0;
+#else
 	return creq->wLength == 0 ? USB_GADGET_DELAYED_STATUS : 0;
+#endif
 }
 
 static bool ffs_func_req_match(struct usb_function *f,
diff --git a/drivers/usb/gadget/function/f_midi.c b/drivers/usb/gadget/function/f_midi.c
index 70ac196..7d6a48c 100644
--- a/drivers/usb/gadget/function/f_midi.c
+++ b/drivers/usb/gadget/function/f_midi.c
@@ -1168,6 +1168,65 @@ static void f_midi_free_inst(struct usb_function_instance *f)
 	kfree(opts);
 }
 
+#ifdef CONFIG_USB_CONFIGFS_UEVENT
+extern struct device *create_function_device(char *name);
+static ssize_t alsa_show(struct device *dev,
+		struct device_attribute *attr, char *buf)
+{
+	struct usb_function_instance *fi_midi = dev_get_drvdata(dev);
+	struct f_midi *midi;
+
+	if (!fi_midi->f)
+		dev_warn(dev, "f_midi: function not set\n");
+
+	if (fi_midi && fi_midi->f) {
+		midi = func_to_midi(fi_midi->f);
+		if (midi->rmidi && midi->rmidi->card)
+			return sprintf(buf, "%d %d\n",
+			midi->rmidi->card->number, midi->rmidi->device);
+	}
+
+	/* print PCM card and device numbers */
+	return sprintf(buf, "%d %d\n", -1, -1);
+}
+
+static DEVICE_ATTR(alsa, S_IRUGO, alsa_show, NULL);
+
+static struct device_attribute *alsa_function_attributes[] = {
+	&dev_attr_alsa,
+	NULL
+};
+
+static int create_alsa_device(struct usb_function_instance *fi)
+{
+	struct device *dev;
+	struct device_attribute **attrs;
+	struct device_attribute *attr;
+	int err = 0;
+
+	dev = create_function_device("f_midi");
+	if (IS_ERR(dev))
+		return PTR_ERR(dev);
+
+	attrs = alsa_function_attributes;
+	if (attrs) {
+		while ((attr = *attrs++) && !err)
+			err = device_create_file(dev, attr);
+		if (err) {
+			device_destroy(dev->class, dev->devt);
+			return -EINVAL;
+		}
+	}
+	dev_set_drvdata(dev, fi);
+	return 0;
+}
+#else
+static int create_alsa_device(struct usb_function_instance *fi)
+{
+	return 0;
+}
+#endif
+
 static struct usb_function_instance *f_midi_alloc_inst(void)
 {
 	struct f_midi_opts *opts;
@@ -1185,6 +1244,11 @@ static struct usb_function_instance *f_midi_alloc_inst(void)
 	opts->in_ports = 1;
 	opts->out_ports = 1;
 
+	if (create_alsa_device(&opts->func_inst)) {
+		kfree(opts);
+		return ERR_PTR(-ENODEV);
+	}
+
 	config_group_init_type_name(&opts->func_inst.group, "",
 				    &midi_func_type);
 
@@ -1202,6 +1266,7 @@ static void f_midi_free(struct usb_function *f)
 	mutex_lock(&opts->lock);
 	kfifo_free(&midi->in_req_fifo);
 	kfree(midi);
+	opts->func_inst.f = NULL;
 	--opts->refcnt;
 	mutex_unlock(&opts->lock);
 }
@@ -1281,6 +1346,7 @@ static struct usb_function *f_midi_alloc(struct usb_function_instance *fi)
 	midi->func.disable	= f_midi_disable;
 	midi->func.free_func	= f_midi_free;
 
+	fi->f = &midi->func;
 	return &midi->func;
 
 setup_fail:
diff --git a/drivers/usb/gadget/function/f_mtp.c b/drivers/usb/gadget/function/f_mtp.c
new file mode 100644
index 00000000..8131ff9
--- /dev/null
+++ b/drivers/usb/gadget/function/f_mtp.c
@@ -0,0 +1,1717 @@
+/*
+ * Gadget Function Driver for MTP
+ *
+ * Copyright (C) 2010 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+/* #define DEBUG */
+/* #define VERBOSE_DEBUG */
+
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/poll.h>
+#include <linux/delay.h>
+#include <linux/wait.h>
+#include <linux/err.h>
+#include <linux/interrupt.h>
+
+#include <linux/types.h>
+#include <linux/file.h>
+#include <linux/device.h>
+#include <linux/miscdevice.h>
+
+#include <linux/usb.h>
+#include <linux/usb_usual.h>
+#include <linux/usb/ch9.h>
+#include <linux/usb/f_mtp.h>
+#include <linux/configfs.h>
+#include <linux/usb/composite.h>
+
+#include "configfs.h"
+
+#define MTP_BULK_BUFFER_SIZE       16384
+#define INTR_BUFFER_SIZE           28
+#define MAX_INST_NAME_LEN          40
+#define MTP_MAX_FILE_SIZE          0xFFFFFFFFL
+
+/* String IDs */
+#define INTERFACE_STRING_INDEX	0
+
+/* values for mtp_dev.state */
+#define STATE_OFFLINE               0   /* initial state, disconnected */
+#define STATE_READY                 1   /* ready for userspace calls */
+#define STATE_BUSY                  2   /* processing userspace calls */
+#define STATE_CANCELED              3   /* transaction canceled by host */
+#define STATE_ERROR                 4   /* error from completion routine */
+
+/* number of tx and rx requests to allocate */
+#define TX_REQ_MAX 4
+#define RX_REQ_MAX 2
+#define INTR_REQ_MAX 5
+
+/* ID for Microsoft MTP OS String */
+#define MTP_OS_STRING_ID   0xEE
+
+/* MTP class reqeusts */
+#define MTP_REQ_CANCEL              0x64
+#define MTP_REQ_GET_EXT_EVENT_DATA  0x65
+#define MTP_REQ_RESET               0x66
+#define MTP_REQ_GET_DEVICE_STATUS   0x67
+
+/* constants for device status */
+#define MTP_RESPONSE_OK             0x2001
+#define MTP_RESPONSE_DEVICE_BUSY    0x2019
+#define DRIVER_NAME "mtp"
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#define IOCNR_MTP_SEND_FILE 	0
+#define IOCNR_MTP_RECEIVE_FILE	1
+#define IOCNR_MTP_SEND_EVENT	3
+#define IOCNR_MTP_SEND_FILE_WITH_HEADER		4
+
+struct mtp_event_32 {
+	int32_t length;
+	int32_t data;
+};
+#endif
+
+static const char mtp_shortname[] = DRIVER_NAME "_usb";
+
+struct mtp_dev {
+	struct usb_function function;
+	struct usb_composite_dev *cdev;
+	spinlock_t lock;
+
+	struct usb_ep *ep_in;
+	struct usb_ep *ep_out;
+	struct usb_ep *ep_intr;
+
+	int state;
+
+	/* synchronize access to our device file */
+	atomic_t open_excl;
+	/* to enforce only one ioctl at a time */
+	atomic_t ioctl_excl;
+
+	struct list_head tx_idle;
+	struct list_head intr_idle;
+
+	wait_queue_head_t read_wq;
+	wait_queue_head_t write_wq;
+	wait_queue_head_t intr_wq;
+	struct usb_request *rx_req[RX_REQ_MAX];
+	int rx_done;
+
+	/* for processing MTP_SEND_FILE, MTP_RECEIVE_FILE and
+	 * MTP_SEND_FILE_WITH_HEADER ioctls on a work queue
+	 */
+	struct workqueue_struct *wq;
+	struct work_struct send_file_work;
+	struct work_struct receive_file_work;
+	struct file *xfer_file;
+	loff_t xfer_file_offset;
+	int64_t xfer_file_length;
+	unsigned xfer_send_header;
+	uint16_t xfer_command;
+	uint32_t xfer_transaction_id;
+	int xfer_result;
+};
+
+static struct usb_interface_descriptor mtp_interface_desc = {
+	.bLength                = USB_DT_INTERFACE_SIZE,
+	.bDescriptorType        = USB_DT_INTERFACE,
+	.bInterfaceNumber       = 0,
+	.bNumEndpoints          = 3,
+	.bInterfaceClass        = USB_CLASS_VENDOR_SPEC,
+	.bInterfaceSubClass     = USB_SUBCLASS_VENDOR_SPEC,
+	.bInterfaceProtocol     = 0,
+};
+
+static struct usb_interface_descriptor ptp_interface_desc = {
+	.bLength                = USB_DT_INTERFACE_SIZE,
+	.bDescriptorType        = USB_DT_INTERFACE,
+	.bInterfaceNumber       = 0,
+	.bNumEndpoints          = 3,
+	.bInterfaceClass        = USB_CLASS_STILL_IMAGE,
+	.bInterfaceSubClass     = 1,
+	.bInterfaceProtocol     = 1,
+};
+
+static struct usb_endpoint_descriptor mtp_ss_in_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_IN,
+	.bmAttributes           = USB_ENDPOINT_XFER_BULK,
+	.wMaxPacketSize         = __constant_cpu_to_le16(1024),
+};
+
+static struct usb_ss_ep_comp_descriptor mtp_ss_in_comp_desc = {
+	.bLength                = sizeof(mtp_ss_in_comp_desc),
+	.bDescriptorType        = USB_DT_SS_ENDPOINT_COMP,
+	/* .bMaxBurst           = DYNAMIC, */
+};
+
+static struct usb_endpoint_descriptor mtp_ss_out_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_OUT,
+	.bmAttributes           = USB_ENDPOINT_XFER_BULK,
+	.wMaxPacketSize         = __constant_cpu_to_le16(1024),
+};
+
+static struct usb_ss_ep_comp_descriptor mtp_ss_out_comp_desc = {
+	.bLength                = sizeof(mtp_ss_out_comp_desc),
+	.bDescriptorType        = USB_DT_SS_ENDPOINT_COMP,
+	/* .bMaxBurst           = DYNAMIC, */
+};
+
+static struct usb_endpoint_descriptor mtp_highspeed_in_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_IN,
+	.bmAttributes           = USB_ENDPOINT_XFER_BULK,
+	.wMaxPacketSize         = __constant_cpu_to_le16(512),
+};
+
+static struct usb_endpoint_descriptor mtp_highspeed_out_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_OUT,
+	.bmAttributes           = USB_ENDPOINT_XFER_BULK,
+	.wMaxPacketSize         = __constant_cpu_to_le16(512),
+};
+
+static struct usb_endpoint_descriptor mtp_fullspeed_in_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_IN,
+	.bmAttributes           = USB_ENDPOINT_XFER_BULK,
+};
+
+static struct usb_endpoint_descriptor mtp_fullspeed_out_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_OUT,
+	.bmAttributes           = USB_ENDPOINT_XFER_BULK,
+};
+
+static struct usb_endpoint_descriptor mtp_intr_desc = {
+	.bLength                = USB_DT_ENDPOINT_SIZE,
+	.bDescriptorType        = USB_DT_ENDPOINT,
+	.bEndpointAddress       = USB_DIR_IN,
+	.bmAttributes           = USB_ENDPOINT_XFER_INT,
+	.wMaxPacketSize         = __constant_cpu_to_le16(INTR_BUFFER_SIZE),
+	.bInterval              = 6,
+};
+
+static struct usb_ss_ep_comp_descriptor mtp_intr_ss_comp_desc = {
+	.bLength                = sizeof(mtp_intr_ss_comp_desc),
+	.bDescriptorType        = USB_DT_SS_ENDPOINT_COMP,
+	.wBytesPerInterval      = cpu_to_le16(INTR_BUFFER_SIZE),
+};
+
+static struct usb_descriptor_header *fs_mtp_descs[] = {
+	(struct usb_descriptor_header *) &mtp_interface_desc,
+	(struct usb_descriptor_header *) &mtp_fullspeed_in_desc,
+	(struct usb_descriptor_header *) &mtp_fullspeed_out_desc,
+	(struct usb_descriptor_header *) &mtp_intr_desc,
+	NULL,
+};
+
+static struct usb_descriptor_header *hs_mtp_descs[] = {
+	(struct usb_descriptor_header *) &mtp_interface_desc,
+	(struct usb_descriptor_header *) &mtp_highspeed_in_desc,
+	(struct usb_descriptor_header *) &mtp_highspeed_out_desc,
+	(struct usb_descriptor_header *) &mtp_intr_desc,
+	NULL,
+};
+
+static struct usb_descriptor_header *ss_mtp_descs[] = {
+	(struct usb_descriptor_header *) &mtp_interface_desc,
+	(struct usb_descriptor_header *) &mtp_ss_in_desc,
+	(struct usb_descriptor_header *) &mtp_ss_in_comp_desc,
+	(struct usb_descriptor_header *) &mtp_ss_out_desc,
+	(struct usb_descriptor_header *) &mtp_ss_out_comp_desc,
+	(struct usb_descriptor_header *) &mtp_intr_desc,
+	(struct usb_descriptor_header *) &mtp_intr_ss_comp_desc,
+	NULL,
+};
+
+static struct usb_descriptor_header *fs_ptp_descs[] = {
+	(struct usb_descriptor_header *) &ptp_interface_desc,
+	(struct usb_descriptor_header *) &mtp_fullspeed_in_desc,
+	(struct usb_descriptor_header *) &mtp_fullspeed_out_desc,
+	(struct usb_descriptor_header *) &mtp_intr_desc,
+	NULL,
+};
+
+static struct usb_descriptor_header *hs_ptp_descs[] = {
+	(struct usb_descriptor_header *) &ptp_interface_desc,
+	(struct usb_descriptor_header *) &mtp_highspeed_in_desc,
+	(struct usb_descriptor_header *) &mtp_highspeed_out_desc,
+	(struct usb_descriptor_header *) &mtp_intr_desc,
+	NULL,
+};
+
+static struct usb_descriptor_header *ss_ptp_descs[] = {
+	(struct usb_descriptor_header *) &ptp_interface_desc,
+	(struct usb_descriptor_header *) &mtp_ss_in_desc,
+	(struct usb_descriptor_header *) &mtp_ss_in_comp_desc,
+	(struct usb_descriptor_header *) &mtp_ss_out_desc,
+	(struct usb_descriptor_header *) &mtp_ss_out_comp_desc,
+	(struct usb_descriptor_header *) &mtp_intr_desc,
+	(struct usb_descriptor_header *) &mtp_intr_ss_comp_desc,
+	NULL,
+};
+
+static struct usb_string mtp_string_defs[] = {
+	/* Naming interface "MTP" so libmtp will recognize us */
+	[INTERFACE_STRING_INDEX].s	= "MTP",
+	{  },	/* end of list */
+};
+
+static struct usb_gadget_strings mtp_string_table = {
+	.language		= 0x0409,	/* en-US */
+	.strings		= mtp_string_defs,
+};
+
+static struct usb_gadget_strings *mtp_strings[] = {
+	&mtp_string_table,
+	NULL,
+};
+
+/* Microsoft MTP OS String */
+static u8 mtp_os_string[] = {
+	18, /* sizeof(mtp_os_string) */
+	USB_DT_STRING,
+	/* Signature field: "MSFT100" */
+	'M', 0, 'S', 0, 'F', 0, 'T', 0, '1', 0, '0', 0, '0', 0,
+	/* vendor code */
+	1,
+	/* padding */
+	0
+};
+
+/* Microsoft Extended Configuration Descriptor Header Section */
+struct mtp_ext_config_desc_header {
+	__le32	dwLength;
+	__u16	bcdVersion;
+	__le16	wIndex;
+	__u8	bCount;
+	__u8	reserved[7];
+};
+
+/* Microsoft Extended Configuration Descriptor Function Section */
+struct mtp_ext_config_desc_function {
+	__u8	bFirstInterfaceNumber;
+	__u8	bInterfaceCount;
+	__u8	compatibleID[8];
+	__u8	subCompatibleID[8];
+	__u8	reserved[6];
+};
+
+/* MTP Extended Configuration Descriptor */
+struct {
+	struct mtp_ext_config_desc_header	header;
+	struct mtp_ext_config_desc_function    function;
+} mtp_ext_config_desc = {
+	.header = {
+		.dwLength = __constant_cpu_to_le32(sizeof(mtp_ext_config_desc)),
+		.bcdVersion = __constant_cpu_to_le16(0x0100),
+		.wIndex = __constant_cpu_to_le16(4),
+		.bCount = 1,
+	},
+	.function = {
+		.bFirstInterfaceNumber = 0,
+		.bInterfaceCount = 1,
+		.compatibleID = { 'M', 'T', 'P' },
+	},
+};
+
+struct mtp_device_status {
+	__le16	wLength;
+	__le16	wCode;
+};
+
+struct mtp_data_header {
+	/* length of packet, including this header */
+	__le32	length;
+	/* container type (2 for data packet) */
+	__le16	type;
+	/* MTP command code */
+	__le16	command;
+	/* MTP transaction ID */
+	__le32	transaction_id;
+};
+
+struct mtp_instance {
+	struct usb_function_instance func_inst;
+	const char *name;
+	struct mtp_dev *dev;
+	char mtp_ext_compat_id[16];
+	struct usb_os_desc mtp_os_desc;
+};
+
+/* temporary variable used between mtp_open() and mtp_gadget_bind() */
+static struct mtp_dev *_mtp_dev;
+
+static inline struct mtp_dev *func_to_mtp(struct usb_function *f)
+{
+	return container_of(f, struct mtp_dev, function);
+}
+
+static struct usb_request *mtp_request_new(struct usb_ep *ep, int buffer_size)
+{
+	struct usb_request *req = usb_ep_alloc_request(ep, GFP_KERNEL);
+
+	if (!req)
+		return NULL;
+
+	/* now allocate buffers for the requests */
+	req->buf = kmalloc(buffer_size, GFP_KERNEL);
+	if (!req->buf) {
+		usb_ep_free_request(ep, req);
+		return NULL;
+	}
+
+	return req;
+}
+
+static void mtp_request_free(struct usb_request *req, struct usb_ep *ep)
+{
+	if (req) {
+		kfree(req->buf);
+		usb_ep_free_request(ep, req);
+	}
+}
+
+static inline int mtp_lock(atomic_t *excl)
+{
+	if (atomic_inc_return(excl) == 1) {
+		return 0;
+	} else {
+		atomic_dec(excl);
+		return -1;
+	}
+}
+
+static inline void mtp_unlock(atomic_t *excl)
+{
+	atomic_dec(excl);
+}
+
+/* add a request to the tail of a list */
+static void mtp_req_put(struct mtp_dev *dev, struct list_head *head,
+		struct usb_request *req)
+{
+	unsigned long flags;
+
+	spin_lock_irqsave(&dev->lock, flags);
+	list_add_tail(&req->list, head);
+	spin_unlock_irqrestore(&dev->lock, flags);
+}
+
+/* remove a request from the head of a list */
+static struct usb_request
+*mtp_req_get(struct mtp_dev *dev, struct list_head *head)
+{
+	unsigned long flags;
+	struct usb_request *req;
+
+	spin_lock_irqsave(&dev->lock, flags);
+	if (list_empty(head)) {
+		req = 0;
+	} else {
+		req = list_first_entry(head, struct usb_request, list);
+		list_del(&req->list);
+	}
+	spin_unlock_irqrestore(&dev->lock, flags);
+	return req;
+}
+
+static void mtp_complete_in(struct usb_ep *ep, struct usb_request *req)
+{
+	struct mtp_dev *dev = _mtp_dev;
+
+	if (req->status != 0)
+		dev->state = STATE_ERROR;
+
+	mtp_req_put(dev, &dev->tx_idle, req);
+
+	wake_up(&dev->write_wq);
+}
+
+static void mtp_complete_out(struct usb_ep *ep, struct usb_request *req)
+{
+	struct mtp_dev *dev = _mtp_dev;
+
+	dev->rx_done = 1;
+	if (req->status != 0)
+		dev->state = STATE_ERROR;
+
+	wake_up(&dev->read_wq);
+}
+
+static void mtp_complete_intr(struct usb_ep *ep, struct usb_request *req)
+{
+	struct mtp_dev *dev = _mtp_dev;
+
+	if (req->status != 0)
+		dev->state = STATE_ERROR;
+
+	mtp_req_put(dev, &dev->intr_idle, req);
+
+	wake_up(&dev->intr_wq);
+}
+
+static int mtp_create_bulk_endpoints(struct mtp_dev *dev,
+				struct usb_endpoint_descriptor *in_desc,
+				struct usb_endpoint_descriptor *out_desc,
+				struct usb_endpoint_descriptor *intr_desc)
+{
+	struct usb_composite_dev *cdev = dev->cdev;
+	struct usb_request *req;
+	struct usb_ep *ep;
+	int i;
+
+	DBG(cdev, "create_bulk_endpoints dev: %p\n", dev);
+
+	ep = usb_ep_autoconfig(cdev->gadget, in_desc);
+	if (!ep) {
+		DBG(cdev, "usb_ep_autoconfig for ep_in failed\n");
+		return -ENODEV;
+	}
+	DBG(cdev, "usb_ep_autoconfig for ep_in got %s\n", ep->name);
+	ep->driver_data = dev;		/* claim the endpoint */
+	dev->ep_in = ep;
+
+	ep = usb_ep_autoconfig(cdev->gadget, out_desc);
+	if (!ep) {
+		DBG(cdev, "usb_ep_autoconfig for ep_out failed\n");
+		return -ENODEV;
+	}
+	DBG(cdev, "usb_ep_autoconfig for mtp ep_out got %s\n", ep->name);
+	ep->driver_data = dev;		/* claim the endpoint */
+	dev->ep_out = ep;
+
+	ep = usb_ep_autoconfig(cdev->gadget, intr_desc);
+	if (!ep) {
+		DBG(cdev, "usb_ep_autoconfig for ep_intr failed\n");
+		return -ENODEV;
+	}
+	DBG(cdev, "usb_ep_autoconfig for mtp ep_intr got %s\n", ep->name);
+	ep->driver_data = dev;		/* claim the endpoint */
+	dev->ep_intr = ep;
+
+	/* now allocate requests for our endpoints */
+	for (i = 0; i < TX_REQ_MAX; i++) {
+		req = mtp_request_new(dev->ep_in, MTP_BULK_BUFFER_SIZE);
+		if (!req)
+			goto fail;
+		req->complete = mtp_complete_in;
+		mtp_req_put(dev, &dev->tx_idle, req);
+	}
+	for (i = 0; i < RX_REQ_MAX; i++) {
+		req = mtp_request_new(dev->ep_out, MTP_BULK_BUFFER_SIZE);
+		if (!req)
+			goto fail;
+		req->complete = mtp_complete_out;
+		dev->rx_req[i] = req;
+	}
+	for (i = 0; i < INTR_REQ_MAX; i++) {
+		req = mtp_request_new(dev->ep_intr, INTR_BUFFER_SIZE);
+		if (!req)
+			goto fail;
+		req->complete = mtp_complete_intr;
+		mtp_req_put(dev, &dev->intr_idle, req);
+	}
+
+	return 0;
+
+fail:
+	pr_err("mtp_bind() could not allocate requests\n");
+	return -1;
+}
+
+static ssize_t mtp_read(struct file *fp, char __user *buf,
+	size_t count, loff_t *pos)
+{
+	struct mtp_dev *dev = fp->private_data;
+	struct usb_composite_dev *cdev = dev->cdev;
+	struct usb_request *req;
+	ssize_t r = count;
+	unsigned xfer;
+	int ret = 0;
+	size_t len = 0;
+
+	DBG(cdev, "mtp_read(%zu)\n", count);
+
+	/* we will block until we're online */
+	DBG(cdev, "mtp_read: waiting for online state\n");
+	ret = wait_event_interruptible(dev->read_wq,
+		dev->state != STATE_OFFLINE);
+	if (ret < 0) {
+		r = ret;
+		goto done;
+	}
+	spin_lock_irq(&dev->lock);
+	if (dev->ep_out->desc) {
+		len = usb_ep_align_maybe(cdev->gadget, dev->ep_out, count);
+		if (len > MTP_BULK_BUFFER_SIZE) {
+			spin_unlock_irq(&dev->lock);
+			return -EINVAL;
+		}
+	}
+
+	if (dev->state == STATE_CANCELED) {
+		/* report cancelation to userspace */
+		dev->state = STATE_READY;
+		spin_unlock_irq(&dev->lock);
+		return -ECANCELED;
+	}
+	dev->state = STATE_BUSY;
+	spin_unlock_irq(&dev->lock);
+
+requeue_req:
+	/* queue a request */
+	req = dev->rx_req[0];
+	req->length = len;
+	dev->rx_done = 0;
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	// add workaround to fix Rx for bMaxPacketSize0
+	if (count == 512) {
+		struct usb_gadget *gadget = cdev->gadget;
+		if (gadget->speed == USB_SPEED_SUPER) {
+			req->length = 1024;
+			DBG(cdev, "mtp_read(%zu) for super speed fixed length to 1024\n", count);
+		}
+	}
+#endif
+	ret = usb_ep_queue(dev->ep_out, req, GFP_KERNEL);
+	if (ret < 0) {
+		r = -EIO;
+		goto done;
+	} else {
+		DBG(cdev, "rx %p queue\n", req);
+	}
+
+	/* wait for a request to complete */
+	ret = wait_event_interruptible(dev->read_wq, dev->rx_done);
+	if (ret < 0) {
+		r = ret;
+		usb_ep_dequeue(dev->ep_out, req);
+		goto done;
+	}
+	if (dev->state == STATE_BUSY) {
+		/* If we got a 0-len packet, throw it back and try again. */
+		if (req->actual == 0)
+			goto requeue_req;
+
+		DBG(cdev, "rx %p %d\n", req, req->actual);
+		xfer = (req->actual < count) ? req->actual : count;
+		r = xfer;
+		if (copy_to_user(buf, req->buf, xfer))
+			r = -EFAULT;
+	} else
+		r = -EIO;
+
+done:
+	spin_lock_irq(&dev->lock);
+	if (dev->state == STATE_CANCELED)
+		r = -ECANCELED;
+	else if (dev->state != STATE_OFFLINE)
+		dev->state = STATE_READY;
+	spin_unlock_irq(&dev->lock);
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* fixed when cdev->gadget is null */
+	pr_debug("mtp_read returning %zd\n", r);
+#else
+	DBG(cdev, "mtp_read returning %zd\n", r);
+#endif
+
+	return r;
+}
+
+static ssize_t mtp_write(struct file *fp, const char __user *buf,
+	size_t count, loff_t *pos)
+{
+	struct mtp_dev *dev = fp->private_data;
+	struct usb_composite_dev *cdev = dev->cdev;
+	struct usb_request *req = 0;
+	ssize_t r = count;
+	unsigned xfer;
+	int sendZLP = 0;
+	int ret;
+
+	DBG(cdev, "mtp_write(%zu)\n", count);
+
+	spin_lock_irq(&dev->lock);
+	if (dev->state == STATE_CANCELED) {
+		/* report cancelation to userspace */
+		dev->state = STATE_READY;
+		spin_unlock_irq(&dev->lock);
+		return -ECANCELED;
+	}
+	if (dev->state == STATE_OFFLINE) {
+		spin_unlock_irq(&dev->lock);
+		return -ENODEV;
+	}
+	dev->state = STATE_BUSY;
+	spin_unlock_irq(&dev->lock);
+
+	/* we need to send a zero length packet to signal the end of transfer
+	 * if the transfer size is aligned to a packet boundary.
+	 */
+	if ((count & (dev->ep_in->maxpacket - 1)) == 0)
+		sendZLP = 1;
+
+	while (count > 0 || sendZLP) {
+		/* so we exit after sending ZLP */
+		if (count == 0)
+			sendZLP = 0;
+
+		if (dev->state != STATE_BUSY) {
+			DBG(cdev, "mtp_write dev->error\n");
+			r = -EIO;
+			break;
+		}
+
+		/* get an idle tx request to use */
+		req = 0;
+		ret = wait_event_interruptible(dev->write_wq,
+			((req = mtp_req_get(dev, &dev->tx_idle))
+				|| dev->state != STATE_BUSY));
+		if (!req) {
+			r = ret;
+			break;
+		}
+
+		if (count > MTP_BULK_BUFFER_SIZE)
+			xfer = MTP_BULK_BUFFER_SIZE;
+		else
+			xfer = count;
+		if (xfer && copy_from_user(req->buf, buf, xfer)) {
+			r = -EFAULT;
+			break;
+		}
+
+		req->length = xfer;
+		ret = usb_ep_queue(dev->ep_in, req, GFP_KERNEL);
+		if (ret < 0) {
+			DBG(cdev, "mtp_write: xfer error %d\n", ret);
+			r = -EIO;
+			break;
+		}
+
+		buf += xfer;
+		count -= xfer;
+
+		/* zero this so we don't try to free it on error exit */
+		req = 0;
+	}
+
+	if (req)
+		mtp_req_put(dev, &dev->tx_idle, req);
+
+	spin_lock_irq(&dev->lock);
+	if (dev->state == STATE_CANCELED)
+		r = -ECANCELED;
+	else if (dev->state != STATE_OFFLINE)
+		dev->state = STATE_READY;
+	spin_unlock_irq(&dev->lock);
+
+	DBG(cdev, "mtp_write returning %zd\n", r);
+	return r;
+}
+
+/* read from a local file and write to USB */
+static void send_file_work(struct work_struct *data)
+{
+	struct mtp_dev *dev = container_of(data, struct mtp_dev,
+						send_file_work);
+	struct usb_composite_dev *cdev = dev->cdev;
+	struct usb_request *req = 0;
+	struct mtp_data_header *header;
+	struct file *filp;
+	loff_t offset;
+	int64_t count;
+	int xfer, ret, hdr_size;
+	int r = 0;
+	int sendZLP = 0;
+
+	/* read our parameters */
+	smp_rmb();
+	filp = dev->xfer_file;
+	offset = dev->xfer_file_offset;
+	count = dev->xfer_file_length;
+
+	DBG(cdev, "send_file_work(%lld %lld)\n", offset, count);
+
+	if (dev->xfer_send_header) {
+		hdr_size = sizeof(struct mtp_data_header);
+		count += hdr_size;
+	} else {
+		hdr_size = 0;
+	}
+
+	/* we need to send a zero length packet to signal the end of transfer
+	 * if the transfer size is aligned to a packet boundary.
+	 */
+	if ((count & (dev->ep_in->maxpacket - 1)) == 0)
+		sendZLP = 1;
+
+	while (count > 0 || sendZLP) {
+		/* so we exit after sending ZLP */
+		if (count == 0)
+			sendZLP = 0;
+
+		/* get an idle tx request to use */
+		req = 0;
+		ret = wait_event_interruptible(dev->write_wq,
+			(req = mtp_req_get(dev, &dev->tx_idle))
+			|| dev->state != STATE_BUSY);
+		if (dev->state == STATE_CANCELED) {
+			r = -ECANCELED;
+			break;
+		}
+		if (!req) {
+			r = ret;
+			break;
+		}
+
+		if (count > MTP_BULK_BUFFER_SIZE)
+			xfer = MTP_BULK_BUFFER_SIZE;
+		else
+			xfer = count;
+
+		if (hdr_size) {
+			/* prepend MTP data header */
+			header = (struct mtp_data_header *)req->buf;
+			/*
+                         * set file size with header according to
+                         * MTP Specification v1.0
+                         */
+			header->length = (count > MTP_MAX_FILE_SIZE) ?
+				MTP_MAX_FILE_SIZE : __cpu_to_le32(count);
+			header->type = __cpu_to_le16(2); /* data packet */
+			header->command = __cpu_to_le16(dev->xfer_command);
+			header->transaction_id =
+					__cpu_to_le32(dev->xfer_transaction_id);
+		}
+
+		ret = vfs_read(filp, req->buf + hdr_size, xfer - hdr_size,
+								&offset);
+		if (ret < 0) {
+			r = ret;
+			break;
+		}
+		xfer = ret + hdr_size;
+		hdr_size = 0;
+
+		req->length = xfer;
+		ret = usb_ep_queue(dev->ep_in, req, GFP_KERNEL);
+		if (ret < 0) {
+			DBG(cdev, "send_file_work: xfer error %d\n", ret);
+			dev->state = STATE_ERROR;
+			r = -EIO;
+			break;
+		}
+
+		count -= xfer;
+
+		/* zero this so we don't try to free it on error exit */
+		req = 0;
+	}
+
+	if (req)
+		mtp_req_put(dev, &dev->tx_idle, req);
+
+	DBG(cdev, "send_file_work returning %d\n", r);
+	/* write the result */
+	dev->xfer_result = r;
+	smp_wmb();
+}
+
+/* read from USB and write to a local file */
+static void receive_file_work(struct work_struct *data)
+{
+	struct mtp_dev *dev = container_of(data, struct mtp_dev,
+						receive_file_work);
+	struct usb_composite_dev *cdev = dev->cdev;
+	struct usb_request *read_req = NULL, *write_req = NULL;
+	struct file *filp;
+	loff_t offset;
+	int64_t count, len;
+	int ret, cur_buf = 0;
+	int r = 0;
+
+	/* read our parameters */
+	smp_rmb();
+	filp = dev->xfer_file;
+	offset = dev->xfer_file_offset;
+	count = dev->xfer_file_length;
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Fixed last transfer can't complete */
+	if (count != 0xFFFFFFFF)
+		count = count + offset;
+	DBG(cdev, "receive_file_work(%lld %lld)\n", offset, count);
+#endif
+
+	DBG(cdev, "receive_file_work(%lld)\n", count);
+
+	while (count > 0 || write_req) {
+		if (count > 0) {
+			/* queue a request */
+			read_req = dev->rx_req[cur_buf];
+			cur_buf = (cur_buf + 1) % RX_REQ_MAX;
+
+			len = usb_ep_align_maybe(cdev->gadget, dev->ep_out, count);
+			if (len > MTP_BULK_BUFFER_SIZE)
+				len = MTP_BULK_BUFFER_SIZE;
+			read_req->length = len;
+			dev->rx_done = 0;
+			ret = usb_ep_queue(dev->ep_out, read_req, GFP_KERNEL);
+			if (ret < 0) {
+				r = -EIO;
+				dev->state = STATE_ERROR;
+				break;
+			}
+		}
+
+		if (write_req) {
+			DBG(cdev, "rx %p %d\n", write_req, write_req->actual);
+			ret = vfs_write(filp, write_req->buf, write_req->actual,
+				&offset);
+			DBG(cdev, "vfs_write %d\n", ret);
+			if (ret != write_req->actual) {
+				r = -EIO;
+				dev->state = STATE_ERROR;
+				break;
+			}
+			write_req = NULL;
+		}
+
+		if (read_req) {
+			/* wait for our last read to complete */
+			ret = wait_event_interruptible(dev->read_wq,
+				dev->rx_done || dev->state != STATE_BUSY);
+			if (dev->state == STATE_CANCELED) {
+				r = -ECANCELED;
+				if (!dev->rx_done)
+					usb_ep_dequeue(dev->ep_out, read_req);
+				break;
+			}
+			if (read_req->status) {
+				r = read_req->status;
+				break;
+			}
+			/* if xfer_file_length is 0xFFFFFFFF, then we read until
+			 * we get a zero length packet
+			 */
+			if (count != 0xFFFFFFFF)
+				count -= read_req->actual;
+			if (read_req->actual < read_req->length) {
+				/*
+				 * short packet is used to signal EOF for
+				 * sizes > 4 gig
+				 */
+				DBG(cdev, "got short packet\n");
+				count = 0;
+			}
+
+			write_req = read_req;
+			read_req = NULL;
+		}
+	}
+
+	DBG(cdev, "receive_file_work returning %d\n", r);
+	/* write the result */
+	dev->xfer_result = r;
+	smp_wmb();
+}
+
+static int mtp_send_event(struct mtp_dev *dev, struct mtp_event *event)
+{
+	struct usb_request *req = NULL;
+	int ret;
+	int length = event->length;
+
+	DBG(dev->cdev, "mtp_send_event(%zu)\n", event->length);
+
+	if (length < 0 || length > INTR_BUFFER_SIZE)
+		return -EINVAL;
+	if (dev->state == STATE_OFFLINE)
+		return -ENODEV;
+
+	ret = wait_event_interruptible_timeout(dev->intr_wq,
+			(req = mtp_req_get(dev, &dev->intr_idle)),
+			msecs_to_jiffies(1000));
+	if (!req)
+		return -ETIME;
+
+	if (copy_from_user(req->buf, (void __user *)event->data, length)) {
+		mtp_req_put(dev, &dev->intr_idle, req);
+		return -EFAULT;
+	}
+	req->length = length;
+	ret = usb_ep_queue(dev->ep_intr, req, GFP_KERNEL);
+	if (ret)
+		mtp_req_put(dev, &dev->intr_idle, req);
+
+	return ret;
+}
+
+static long mtp_ioctl(struct file *fp, unsigned code, unsigned long value)
+{
+	struct mtp_dev *dev = fp->private_data;
+	struct file *filp = NULL;
+	int ret = -EINVAL;
+
+	if (mtp_lock(&dev->ioctl_excl))
+		return -EBUSY;
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	DBG(dev->cdev, "%s\n", __func__);
+
+	DBG(dev->cdev,
+		"mtp_ioctl: cmd=0x%x (%c nr=%d len=%d dir=%d)\n", code,
+		_IOC_TYPE(code), _IOC_NR(code), _IOC_SIZE(code), _IOC_DIR(code));
+
+	if ((_IOC_TYPE(code) != 'M') && (_IOC_DIR(code) != _IOC_WRITE)) {
+		ERROR(dev->cdev,
+			"mtp_ioctl: cmd=0x%x (%c nr=%d len=%d dir=%d)\n", code,
+			_IOC_TYPE(code), _IOC_NR(code), _IOC_SIZE(code), _IOC_DIR(code));
+		goto out;
+	}
+
+	switch (_IOC_NR(code)) {
+	case IOCNR_MTP_SEND_FILE:
+	case IOCNR_MTP_RECEIVE_FILE:
+	case IOCNR_MTP_SEND_FILE_WITH_HEADER:
+	{
+		struct mtp_file_range	mfr;
+		struct work_struct *work;
+
+		spin_lock_irq(&dev->lock);
+		if (dev->state == STATE_CANCELED) {
+			/* report cancelation to userspace */
+			dev->state = STATE_READY;
+			spin_unlock_irq(&dev->lock);
+			ret = -ECANCELED;
+			goto out;
+		}
+		if (dev->state == STATE_OFFLINE) {
+			spin_unlock_irq(&dev->lock);
+			ret = -ENODEV;
+			goto out;
+		}
+		dev->state = STATE_BUSY;
+		spin_unlock_irq(&dev->lock);
+
+		if (copy_from_user(&mfr, (void __user *)value, sizeof(mfr))) {
+			ret = -EFAULT;
+			goto fail;
+		}
+		/* hold a reference to the file while we are working with it */
+		filp = fget(mfr.fd);
+		if (!filp) {
+			ret = -EBADF;
+			goto fail;
+		}
+
+		/* write the parameters */
+		dev->xfer_file = filp;
+		dev->xfer_file_offset = mfr.offset;
+		dev->xfer_file_length = mfr.length;
+		smp_wmb();
+
+		if (_IOC_NR(code) == IOCNR_MTP_SEND_FILE_WITH_HEADER) {
+			work = &dev->send_file_work;
+			dev->xfer_send_header = 1;
+			dev->xfer_command = mfr.command;
+			dev->xfer_transaction_id = mfr.transaction_id;
+		} else if (_IOC_NR(code) == IOCNR_MTP_SEND_FILE) {
+			work = &dev->send_file_work;
+			dev->xfer_send_header = 0;
+		} else {
+			work = &dev->receive_file_work;
+		}
+
+		/* We do the file transfer on a work queue so it will run
+		 * in kernel context, which is necessary for vfs_read and
+		 * vfs_write to use our buffers in the kernel address space.
+		 */
+		queue_work(dev->wq, work);
+		/* wait for operation to complete */
+		flush_workqueue(dev->wq);
+		fput(filp);
+
+		/* read the result */
+		smp_rmb();
+		ret = dev->xfer_result;
+		break;
+	}
+	case IOCNR_MTP_SEND_EVENT:
+	{
+		struct mtp_event_32 event32;
+		struct mtp_event	event;
+		/* return here so we don't change dev->state below,
+		 * which would interfere with bulk transfer state.
+		 */
+		if (_IOC_SIZE(code) == sizeof(struct mtp_event)) {
+			if (copy_from_user(&event, (void __user *)value, sizeof(struct mtp_event)))
+				ret = -EFAULT;
+			else
+				ret = mtp_send_event(dev, &event);
+		} else if (_IOC_SIZE(code) == sizeof(struct mtp_event_32)) {
+			if (copy_from_user(&event32, (void __user *)value, _IOC_SIZE(code)))
+				ret = -EFAULT;
+			else {
+				event.length = event32.length;
+#if defined(CONFIG_CPU_V7)
+				event.data = event32.data;
+#else
+				event.data = compat_ptr(event32.data);
+#endif /* CONFIG_CPU_V7 */
+				DBG(dev->cdev, "%s: data %x data32 %x\n",__func__,  event.data, event32.data);
+				ret = mtp_send_event(dev, &event);
+			}
+		}
+		goto out;
+	}
+	}
+#else
+	switch (code) {
+	case MTP_SEND_FILE:
+	case MTP_RECEIVE_FILE:
+	case MTP_SEND_FILE_WITH_HEADER:
+	{
+		struct mtp_file_range	mfr;
+		struct work_struct *work;
+
+		spin_lock_irq(&dev->lock);
+		if (dev->state == STATE_CANCELED) {
+			/* report cancelation to userspace */
+			dev->state = STATE_READY;
+			spin_unlock_irq(&dev->lock);
+			ret = -ECANCELED;
+			goto out;
+		}
+		if (dev->state == STATE_OFFLINE) {
+			spin_unlock_irq(&dev->lock);
+			ret = -ENODEV;
+			goto out;
+		}
+		dev->state = STATE_BUSY;
+		spin_unlock_irq(&dev->lock);
+
+		if (copy_from_user(&mfr, (void __user *)value, sizeof(mfr))) {
+			ret = -EFAULT;
+			goto fail;
+		}
+		/* hold a reference to the file while we are working with it */
+		filp = fget(mfr.fd);
+		if (!filp) {
+			ret = -EBADF;
+			goto fail;
+		}
+
+		/* write the parameters */
+		dev->xfer_file = filp;
+		dev->xfer_file_offset = mfr.offset;
+		dev->xfer_file_length = mfr.length;
+		smp_wmb();
+
+		if (code == MTP_SEND_FILE_WITH_HEADER) {
+			work = &dev->send_file_work;
+			dev->xfer_send_header = 1;
+			dev->xfer_command = mfr.command;
+			dev->xfer_transaction_id = mfr.transaction_id;
+		} else if (code == MTP_SEND_FILE) {
+			work = &dev->send_file_work;
+			dev->xfer_send_header = 0;
+		} else {
+			work = &dev->receive_file_work;
+		}
+
+		/* We do the file transfer on a work queue so it will run
+		 * in kernel context, which is necessary for vfs_read and
+		 * vfs_write to use our buffers in the kernel address space.
+		 */
+		queue_work(dev->wq, work);
+		/* wait for operation to complete */
+		flush_workqueue(dev->wq);
+		fput(filp);
+
+		/* read the result */
+		smp_rmb();
+		ret = dev->xfer_result;
+		break;
+	}
+	case MTP_SEND_EVENT:
+	{
+		struct mtp_event	event;
+		/* return here so we don't change dev->state below,
+		 * which would interfere with bulk transfer state.
+		 */
+		if (copy_from_user(&event, (void __user *)value, sizeof(event)))
+			ret = -EFAULT;
+		else
+			ret = mtp_send_event(dev, &event);
+		goto out;
+	}
+	}
+#endif
+
+fail:
+	spin_lock_irq(&dev->lock);
+	if (dev->state == STATE_CANCELED)
+		ret = -ECANCELED;
+	else if (dev->state != STATE_OFFLINE)
+		dev->state = STATE_READY;
+	spin_unlock_irq(&dev->lock);
+out:
+	mtp_unlock(&dev->ioctl_excl);
+	DBG(dev->cdev, "ioctl returning %d\n", ret);
+	return ret;
+}
+
+#ifdef CONFIG_COMPAT
+static long mtp_compat_ioctl(struct file *fp, unsigned code, unsigned long value)
+{
+	struct mtp_dev *dev = fp->private_data;
+	int ret;
+	DBG(dev->cdev, "%s\n", __func__);
+#if defined(CONFIG_CPU_V7)
+	ret = mtp_ioctl(fp, code, value);
+#else
+	ret = mtp_ioctl(fp, code, compat_ptr(value));
+#endif /* CONFIG_CPU_V7 */
+	return ret;
+}
+#endif
+
+static int mtp_open(struct inode *ip, struct file *fp)
+{
+	printk(KERN_INFO "mtp_open\n");
+	if (mtp_lock(&_mtp_dev->open_excl))
+		return -EBUSY;
+
+	/* clear any error condition */
+	if (_mtp_dev->state != STATE_OFFLINE)
+		_mtp_dev->state = STATE_READY;
+
+	fp->private_data = _mtp_dev;
+	return 0;
+}
+
+static int mtp_release(struct inode *ip, struct file *fp)
+{
+	printk(KERN_INFO "mtp_release\n");
+
+	mtp_unlock(&_mtp_dev->open_excl);
+	return 0;
+}
+
+/* file operations for /dev/mtp_usb */
+static const struct file_operations mtp_fops = {
+	.owner = THIS_MODULE,
+	.read = mtp_read,
+	.write = mtp_write,
+	.unlocked_ioctl = mtp_ioctl,
+#ifdef CONFIG_COMPAT
+	.compat_ioctl =   mtp_compat_ioctl,
+#endif
+	.open = mtp_open,
+	.release = mtp_release,
+};
+
+static struct miscdevice mtp_device = {
+	.minor = MISC_DYNAMIC_MINOR,
+	.name = mtp_shortname,
+	.fops = &mtp_fops,
+};
+
+static int mtp_ctrlrequest(struct usb_composite_dev *cdev,
+				const struct usb_ctrlrequest *ctrl)
+{
+	struct mtp_dev *dev = _mtp_dev;
+	int	value = -EOPNOTSUPP;
+	u16	w_index = le16_to_cpu(ctrl->wIndex);
+	u16	w_value = le16_to_cpu(ctrl->wValue);
+	u16	w_length = le16_to_cpu(ctrl->wLength);
+	unsigned long	flags;
+
+	VDBG(cdev, "mtp_ctrlrequest "
+			"%02x.%02x v%04x i%04x l%u\n",
+			ctrl->bRequestType, ctrl->bRequest,
+			w_value, w_index, w_length);
+
+	/* Handle MTP OS string */
+	if (ctrl->bRequestType ==
+			(USB_DIR_IN | USB_TYPE_STANDARD | USB_RECIP_DEVICE)
+			&& ctrl->bRequest == USB_REQ_GET_DESCRIPTOR
+			&& (w_value >> 8) == USB_DT_STRING
+			&& (w_value & 0xFF) == MTP_OS_STRING_ID) {
+		value = (w_length < sizeof(mtp_os_string)
+				? w_length : sizeof(mtp_os_string));
+		memcpy(cdev->req->buf, mtp_os_string, value);
+	} else if ((ctrl->bRequestType & USB_TYPE_MASK) == USB_TYPE_VENDOR) {
+		/* Handle MTP OS descriptor */
+		DBG(cdev, "vendor request: %d index: %d value: %d length: %d\n",
+			ctrl->bRequest, w_index, w_value, w_length);
+
+		if (ctrl->bRequest == 1
+				&& (ctrl->bRequestType & USB_DIR_IN)
+				&& (w_index == 4 || w_index == 5)) {
+			value = (w_length < sizeof(mtp_ext_config_desc) ?
+					w_length : sizeof(mtp_ext_config_desc));
+			memcpy(cdev->req->buf, &mtp_ext_config_desc, value);
+		}
+	} else if ((ctrl->bRequestType & USB_TYPE_MASK) == USB_TYPE_CLASS) {
+		DBG(cdev, "class request: %d index: %d value: %d length: %d\n",
+			ctrl->bRequest, w_index, w_value, w_length);
+
+		if (ctrl->bRequest == MTP_REQ_CANCEL && w_index == 0
+				&& w_value == 0) {
+			DBG(cdev, "MTP_REQ_CANCEL\n");
+
+			spin_lock_irqsave(&dev->lock, flags);
+			if (dev->state == STATE_BUSY) {
+				dev->state = STATE_CANCELED;
+				wake_up(&dev->read_wq);
+				wake_up(&dev->write_wq);
+			}
+			spin_unlock_irqrestore(&dev->lock, flags);
+
+			/* We need to queue a request to read the remaining
+			 *  bytes, but we don't actually need to look at
+			 * the contents.
+			 */
+			value = w_length;
+		} else if (ctrl->bRequest == MTP_REQ_GET_DEVICE_STATUS
+				&& w_index == 0 && w_value == 0) {
+			struct mtp_device_status *status = cdev->req->buf;
+
+			status->wLength =
+				__constant_cpu_to_le16(sizeof(*status));
+
+			DBG(cdev, "MTP_REQ_GET_DEVICE_STATUS\n");
+			spin_lock_irqsave(&dev->lock, flags);
+			/* device status is "busy" until we report
+			 * the cancelation to userspace
+			 */
+			if (dev->state == STATE_CANCELED)
+				status->wCode =
+					__cpu_to_le16(MTP_RESPONSE_DEVICE_BUSY);
+			else
+				status->wCode =
+					__cpu_to_le16(MTP_RESPONSE_OK);
+			spin_unlock_irqrestore(&dev->lock, flags);
+			value = sizeof(*status);
+		}
+	}
+
+	/* respond with data transfer or status phase? */
+	if (value >= 0) {
+		int rc;
+
+		cdev->req->zero = value < w_length;
+		cdev->req->length = value;
+		rc = usb_ep_queue(cdev->gadget->ep0, cdev->req, GFP_ATOMIC);
+		if (rc < 0)
+			ERROR(cdev, "%s: response queue error\n", __func__);
+	}
+	return value;
+}
+
+static int
+mtp_function_bind(struct usb_configuration *c, struct usb_function *f)
+{
+	struct usb_composite_dev *cdev = c->cdev;
+	struct mtp_dev	*dev = func_to_mtp(f);
+	int			id;
+	int			ret;
+	struct mtp_instance *fi_mtp;
+
+	dev->cdev = cdev;
+	DBG(cdev, "mtp_function_bind dev: %p\n", dev);
+
+	/* allocate interface ID(s) */
+	id = usb_interface_id(c, f);
+	if (id < 0)
+		return id;
+	mtp_interface_desc.bInterfaceNumber = id;
+
+	if (mtp_string_defs[INTERFACE_STRING_INDEX].id == 0) {
+		ret = usb_string_id(c->cdev);
+		if (ret < 0)
+			return ret;
+		mtp_string_defs[INTERFACE_STRING_INDEX].id = ret;
+		mtp_interface_desc.iInterface = ret;
+	}
+
+	fi_mtp = container_of(f->fi, struct mtp_instance, func_inst);
+
+	if (cdev->use_os_string) {
+		f->os_desc_table = kzalloc(sizeof(*f->os_desc_table),
+					GFP_KERNEL);
+		if (!f->os_desc_table)
+			return -ENOMEM;
+		f->os_desc_n = 1;
+		f->os_desc_table[0].os_desc = &fi_mtp->mtp_os_desc;
+	}
+
+	/* allocate endpoints */
+	ret = mtp_create_bulk_endpoints(dev, &mtp_fullspeed_in_desc,
+			&mtp_fullspeed_out_desc, &mtp_intr_desc);
+	if (ret)
+		return ret;
+
+	/* support high speed hardware */
+	if (gadget_is_dualspeed(c->cdev->gadget)) {
+		mtp_highspeed_in_desc.bEndpointAddress =
+			mtp_fullspeed_in_desc.bEndpointAddress;
+		mtp_highspeed_out_desc.bEndpointAddress =
+			mtp_fullspeed_out_desc.bEndpointAddress;
+	}
+	/* support super speed hardware */
+	if (gadget_is_superspeed(c->cdev->gadget)) {
+		unsigned max_burst;
+
+		/* Calculate bMaxBurst, we know packet size is 1024 */
+		max_burst = min_t(unsigned, MTP_BULK_BUFFER_SIZE / 1024, 15);
+		mtp_ss_in_desc.bEndpointAddress =
+			mtp_fullspeed_in_desc.bEndpointAddress;
+		mtp_ss_in_comp_desc.bMaxBurst = max_burst;
+		mtp_ss_out_desc.bEndpointAddress =
+			mtp_fullspeed_out_desc.bEndpointAddress;
+		mtp_ss_out_comp_desc.bMaxBurst = max_burst;
+	}
+
+	DBG(cdev, "%s speed %s: IN/%s, OUT/%s\n",
+		gadget_is_superspeed(c->cdev->gadget) ? "super" :
+		(gadget_is_dualspeed(c->cdev->gadget) ? "dual" : "full"),
+		f->name, dev->ep_in->name, dev->ep_out->name);
+	return 0;
+}
+
+static void
+mtp_function_unbind(struct usb_configuration *c, struct usb_function *f)
+{
+	struct mtp_dev	*dev = func_to_mtp(f);
+	struct usb_request *req;
+	int i;
+
+	mtp_string_defs[INTERFACE_STRING_INDEX].id = 0;
+	while ((req = mtp_req_get(dev, &dev->tx_idle)))
+		mtp_request_free(req, dev->ep_in);
+	for (i = 0; i < RX_REQ_MAX; i++)
+		mtp_request_free(dev->rx_req[i], dev->ep_out);
+	while ((req = mtp_req_get(dev, &dev->intr_idle)))
+		mtp_request_free(req, dev->ep_intr);
+	dev->state = STATE_OFFLINE;
+	kfree(f->os_desc_table);
+	f->os_desc_n = 0;
+}
+
+static int mtp_function_set_alt(struct usb_function *f,
+		unsigned intf, unsigned alt)
+{
+	struct mtp_dev	*dev = func_to_mtp(f);
+	struct usb_composite_dev *cdev = f->config->cdev;
+	int ret;
+
+	DBG(cdev, "mtp_function_set_alt intf: %d alt: %d\n", intf, alt);
+
+	ret = config_ep_by_speed(cdev->gadget, f, dev->ep_in);
+	if (ret)
+		return ret;
+
+	ret = usb_ep_enable(dev->ep_in);
+	if (ret)
+		return ret;
+
+	ret = config_ep_by_speed(cdev->gadget, f, dev->ep_out);
+	if (ret)
+		return ret;
+
+	ret = usb_ep_enable(dev->ep_out);
+	if (ret) {
+		usb_ep_disable(dev->ep_in);
+		return ret;
+	}
+
+	ret = config_ep_by_speed(cdev->gadget, f, dev->ep_intr);
+	if (ret)
+		return ret;
+
+	ret = usb_ep_enable(dev->ep_intr);
+	if (ret) {
+		usb_ep_disable(dev->ep_out);
+		usb_ep_disable(dev->ep_in);
+		return ret;
+	}
+	dev->state = STATE_READY;
+
+	/* readers may be blocked waiting for us to go online */
+	wake_up(&dev->read_wq);
+	return 0;
+}
+
+static void mtp_function_disable(struct usb_function *f)
+{
+	struct mtp_dev	*dev = func_to_mtp(f);
+	struct usb_composite_dev	*cdev = dev->cdev;
+
+	DBG(cdev, "mtp_function_disable\n");
+	dev->state = STATE_OFFLINE;
+	usb_ep_disable(dev->ep_in);
+	usb_ep_disable(dev->ep_out);
+	usb_ep_disable(dev->ep_intr);
+
+	/* readers may be blocked waiting for us to go online */
+	wake_up(&dev->read_wq);
+
+	VDBG(cdev, "%s disabled\n", dev->function.name);
+}
+
+static int __mtp_setup(struct mtp_instance *fi_mtp)
+{
+	struct mtp_dev *dev;
+	int ret;
+
+	dev = kzalloc(sizeof(*dev), GFP_KERNEL);
+
+	if (fi_mtp != NULL)
+		fi_mtp->dev = dev;
+
+	if (!dev)
+		return -ENOMEM;
+
+	spin_lock_init(&dev->lock);
+	init_waitqueue_head(&dev->read_wq);
+	init_waitqueue_head(&dev->write_wq);
+	init_waitqueue_head(&dev->intr_wq);
+	atomic_set(&dev->open_excl, 0);
+	atomic_set(&dev->ioctl_excl, 0);
+	INIT_LIST_HEAD(&dev->tx_idle);
+	INIT_LIST_HEAD(&dev->intr_idle);
+
+	dev->wq = create_singlethread_workqueue("f_mtp");
+	if (!dev->wq) {
+		ret = -ENOMEM;
+		goto err1;
+	}
+	INIT_WORK(&dev->send_file_work, send_file_work);
+	INIT_WORK(&dev->receive_file_work, receive_file_work);
+
+	_mtp_dev = dev;
+
+	ret = misc_register(&mtp_device);
+	if (ret)
+		goto err2;
+
+	return 0;
+
+err2:
+	destroy_workqueue(dev->wq);
+err1:
+	_mtp_dev = NULL;
+	kfree(dev);
+	printk(KERN_ERR "mtp gadget driver failed to initialize\n");
+	return ret;
+}
+
+static int mtp_setup_configfs(struct mtp_instance *fi_mtp)
+{
+	return __mtp_setup(fi_mtp);
+}
+
+
+static void mtp_cleanup(void)
+{
+	struct mtp_dev *dev = _mtp_dev;
+
+	if (!dev)
+		return;
+
+	misc_deregister(&mtp_device);
+	destroy_workqueue(dev->wq);
+	_mtp_dev = NULL;
+	kfree(dev);
+}
+
+static struct mtp_instance *to_mtp_instance(struct config_item *item)
+{
+	return container_of(to_config_group(item), struct mtp_instance,
+		func_inst.group);
+}
+
+static void mtp_attr_release(struct config_item *item)
+{
+	struct mtp_instance *fi_mtp = to_mtp_instance(item);
+
+	usb_put_function_instance(&fi_mtp->func_inst);
+}
+
+static struct configfs_item_operations mtp_item_ops = {
+	.release        = mtp_attr_release,
+};
+
+static struct config_item_type mtp_func_type = {
+	.ct_item_ops    = &mtp_item_ops,
+	.ct_owner       = THIS_MODULE,
+};
+
+
+static struct mtp_instance *to_fi_mtp(struct usb_function_instance *fi)
+{
+	return container_of(fi, struct mtp_instance, func_inst);
+}
+
+static int mtp_set_inst_name(struct usb_function_instance *fi, const char *name)
+{
+	struct mtp_instance *fi_mtp;
+	char *ptr;
+	int name_len;
+
+	name_len = strlen(name) + 1;
+	if (name_len > MAX_INST_NAME_LEN)
+		return -ENAMETOOLONG;
+
+	ptr = kstrndup(name, name_len, GFP_KERNEL);
+	if (!ptr)
+		return -ENOMEM;
+
+	fi_mtp = to_fi_mtp(fi);
+	fi_mtp->name = ptr;
+
+	return 0;
+}
+
+static void mtp_free_inst(struct usb_function_instance *fi)
+{
+	struct mtp_instance *fi_mtp;
+
+	fi_mtp = to_fi_mtp(fi);
+	kfree(fi_mtp->name);
+	mtp_cleanup();
+	kfree(fi_mtp);
+}
+
+struct usb_function_instance *alloc_inst_mtp_ptp(bool mtp_config)
+{
+	struct mtp_instance *fi_mtp;
+	int ret = 0;
+	struct usb_os_desc *descs[1];
+	char *names[1];
+
+	fi_mtp = kzalloc(sizeof(*fi_mtp), GFP_KERNEL);
+	if (!fi_mtp)
+		return ERR_PTR(-ENOMEM);
+	fi_mtp->func_inst.set_inst_name = mtp_set_inst_name;
+	fi_mtp->func_inst.free_func_inst = mtp_free_inst;
+
+	fi_mtp->mtp_os_desc.ext_compat_id = fi_mtp->mtp_ext_compat_id;
+	INIT_LIST_HEAD(&fi_mtp->mtp_os_desc.ext_prop);
+	descs[0] = &fi_mtp->mtp_os_desc;
+	names[0] = "MTP";
+
+	if (mtp_config) {
+		ret = mtp_setup_configfs(fi_mtp);
+		if (ret) {
+			kfree(fi_mtp);
+			pr_err("Error setting MTP\n");
+			return ERR_PTR(ret);
+		}
+	} else
+		fi_mtp->dev = _mtp_dev;
+
+	config_group_init_type_name(&fi_mtp->func_inst.group,
+					"", &mtp_func_type);
+	usb_os_desc_prepare_interf_dir(&fi_mtp->func_inst.group, 1,
+					descs, names, THIS_MODULE);
+
+	return  &fi_mtp->func_inst;
+}
+EXPORT_SYMBOL_GPL(alloc_inst_mtp_ptp);
+
+static struct usb_function_instance *mtp_alloc_inst(void)
+{
+		return alloc_inst_mtp_ptp(true);
+}
+
+static int mtp_ctrlreq_configfs(struct usb_function *f,
+				const struct usb_ctrlrequest *ctrl)
+{
+	return mtp_ctrlrequest(f->config->cdev, ctrl);
+}
+
+static void mtp_free(struct usb_function *f)
+{
+	/*NO-OP: no function specific resource allocation in mtp_alloc*/
+}
+
+struct usb_function *function_alloc_mtp_ptp(struct usb_function_instance *fi,
+					bool mtp_config)
+{
+	struct mtp_instance *fi_mtp = to_fi_mtp(fi);
+	struct mtp_dev *dev;
+
+	/*
+	 * PTP piggybacks on MTP function so make sure we have
+	 * created MTP function before we associate this PTP
+	 * function with a gadget configuration.
+	 */
+	if (fi_mtp->dev == NULL) {
+		pr_err("Error: Create MTP function before linking"
+				" PTP function with a gadget configuration\n");
+		pr_err("\t1: Delete existing PTP function if any\n");
+		pr_err("\t2: Create MTP function\n");
+		pr_err("\t3: Create and symlink PTP function"
+				" with a gadget configuration\n");
+		return ERR_PTR(-EINVAL); /* Invalid Configuration */
+	}
+
+	dev = fi_mtp->dev;
+	dev->function.name = DRIVER_NAME;
+	dev->function.strings = mtp_strings;
+	if (mtp_config) {
+		dev->function.fs_descriptors = fs_mtp_descs;
+		dev->function.hs_descriptors = hs_mtp_descs;
+		dev->function.ss_descriptors = ss_mtp_descs;
+	} else {
+		dev->function.fs_descriptors = fs_ptp_descs;
+		dev->function.hs_descriptors = hs_ptp_descs;
+		dev->function.ss_descriptors = ss_ptp_descs;
+	}
+	dev->function.bind = mtp_function_bind;
+	dev->function.unbind = mtp_function_unbind;
+	dev->function.set_alt = mtp_function_set_alt;
+	dev->function.disable = mtp_function_disable;
+	dev->function.setup = mtp_ctrlreq_configfs;
+	dev->function.free_func = mtp_free;
+
+	return &dev->function;
+}
+EXPORT_SYMBOL_GPL(function_alloc_mtp_ptp);
+
+static struct usb_function *mtp_alloc(struct usb_function_instance *fi)
+{
+	return function_alloc_mtp_ptp(fi, true);
+}
+
+DECLARE_USB_FUNCTION_INIT(mtp, mtp_alloc_inst, mtp_alloc);
+MODULE_LICENSE("GPL");
diff --git a/drivers/usb/gadget/function/f_mtp.h b/drivers/usb/gadget/function/f_mtp.h
new file mode 100644
index 00000000..7adb1ff
--- /dev/null
+++ b/drivers/usb/gadget/function/f_mtp.h
@@ -0,0 +1,18 @@
+/*
+ * Copyright (C) 2014 Google, Inc.
+ * Author: Badhri Jagan Sridharan <badhri@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+extern struct usb_function_instance *alloc_inst_mtp_ptp(bool mtp_config);
+extern struct usb_function *function_alloc_mtp_ptp(
+			struct usb_function_instance *fi, bool mtp_config);
diff --git a/drivers/usb/gadget/function/f_ptp.c b/drivers/usb/gadget/function/f_ptp.c
new file mode 100644
index 00000000..da3e4d5
--- /dev/null
+++ b/drivers/usb/gadget/function/f_ptp.c
@@ -0,0 +1,38 @@
+/*
+ * Gadget Function Driver for PTP
+ *
+ * Copyright (C) 2014 Google, Inc.
+ * Author: Badhri Jagan Sridharan <badhri@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/module.h>
+#include <linux/types.h>
+
+#include <linux/configfs.h>
+#include <linux/usb/composite.h>
+
+#include "f_mtp.h"
+
+static struct usb_function_instance *ptp_alloc_inst(void)
+{
+	return alloc_inst_mtp_ptp(false);
+}
+
+static struct usb_function *ptp_alloc(struct usb_function_instance *fi)
+{
+	return function_alloc_mtp_ptp(fi, false);
+}
+
+DECLARE_USB_FUNCTION_INIT(ptp, ptp_alloc_inst, ptp_alloc);
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Badhri Jagan Sridharan");
diff --git a/drivers/usb/gadget/udc/Kconfig b/drivers/usb/gadget/udc/Kconfig
index 658b8da..74acee33 100644
--- a/drivers/usb/gadget/udc/Kconfig
+++ b/drivers/usb/gadget/udc/Kconfig
@@ -239,6 +239,19 @@ config USB_MV_U3D
 	  MARVELL PXA2128 Processor series include a super speed USB3.0 device
 	  controller, which support super speed USB peripheral.
 
+config USB_RTK_UDC
+	tristate "RTK USB2.0 Device Controller"
+	depends on ARCH_RTD129x
+	help
+		RTD129x Soc include a high speed USB2.0 OTG controller, which can be
+		configured as high speed or full speed USB peripheral.
+
+config USB_RTK_UDC_OTG_SWITCH
+	tristate "RTK USB2.0 HOST/Device switch by sysfs"
+	depends on USB_RTK_UDC && ARCH_RTD129x
+	help
+		Use sysfs to switch RTK 129x SOC USB2.0 OTG controller.
+
 #
 # Controllers available in both integrated and discrete versions
 #
diff --git a/drivers/usb/gadget/udc/Makefile b/drivers/usb/gadget/udc/Makefile
index 98e74ed..603739b 100644
--- a/drivers/usb/gadget/udc/Makefile
+++ b/drivers/usb/gadget/udc/Makefile
@@ -30,6 +30,7 @@ obj-$(CONFIG_USB_S3C_HSUDC)	+= s3c-hsudc.o
 obj-$(CONFIG_USB_LPC32XX)	+= lpc32xx_udc.o
 obj-$(CONFIG_USB_EG20T)		+= pch_udc.o
 obj-$(CONFIG_USB_MV_UDC)	+= mv_udc.o
+obj-$(CONFIG_USB_RTK_UDC)	+= rtk-hsotg.o
 mv_udc-y			:= mv_udc_core.o
 obj-$(CONFIG_USB_FUSB300)	+= fusb300_udc.o
 obj-$(CONFIG_USB_FOTG210_UDC)	+= fotg210-udc.o
diff --git a/drivers/usb/gadget/udc/core.c b/drivers/usb/gadget/udc/core.c
index 139f6cc..523f24e 100644
--- a/drivers/usb/gadget/udc/core.c
+++ b/drivers/usb/gadget/udc/core.c
@@ -1212,6 +1212,27 @@ char *usb_get_gadget_udc_name(void)
 }
 EXPORT_SYMBOL_GPL(usb_get_gadget_udc_name);
 
+#ifdef CONFIG_USB_RTK_DWC3_DRD_MODE
+int usb_gadget_find_udc(const char *name)
+{
+	struct usb_udc *udc = NULL;
+	int ret = -ENODEV;
+
+	mutex_lock(&udc_lock);
+	list_for_each_entry(udc, &udc_list, list) {
+		ret = strcmp(name, dev_name(&udc->dev));
+		if (!ret)
+			break;
+	}
+	if (ret) {
+		pr_info("%s No udc device for %s", __func__, name);
+	}
+	mutex_unlock(&udc_lock);
+	return ret;
+}
+EXPORT_SYMBOL_GPL(usb_gadget_find_udc);
+#endif
+
 /**
  * usb_add_gadget_udc - adds a new gadget to the udc class driver list
  * @parent: the parent device to this udc. Usually the controller
diff --git a/drivers/usb/gadget/udc/rtk-hsotg.c b/drivers/usb/gadget/udc/rtk-hsotg.c
new file mode 100644
index 00000000..066e466
--- /dev/null
+++ b/drivers/usb/gadget/udc/rtk-hsotg.c
@@ -0,0 +1,4077 @@
+/**
+ * linux/drivers/usb/gadget/rtk-hsotg.c
+ *
+ * RTK USB2.0 High-speed / OtG driver
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/spinlock.h>
+#include <linux/interrupt.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/debugfs.h>
+#include <linux/seq_file.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <linux/slab.h>
+#include <linux/clk.h>
+#include <linux/regulator/consumer.h>
+#include <linux/of_platform.h>
+//#include <linux/phy/phy.h>
+
+#include <linux/usb/ch9.h>
+#include <linux/usb/gadget.h>
+#include <linux/usb/phy.h>
+#include <linux/usb/otg.h>
+
+#include "rtk-hsotg.h"
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#include <soc/realtek/rtd129x_lockapi.h>
+
+static inline unsigned int otg_readl(void __iomem *reg)
+{
+	unsigned long flags;
+	u32 value;
+
+	rtk_lockapi_lock(flags, __FUNCTION__); /* Add global lock for emmc issue*/
+
+	value = readl_relaxed(reg);
+	__iormb();
+
+	rtk_lockapi_unlock(flags,__FUNCTION__); /* Add global lock for emmc issue*/
+
+	return value;
+}
+
+static inline void otg_writel(const unsigned int val, void __iomem *reg)
+{
+	unsigned long flags;
+
+	rtk_lockapi_lock(flags, __FUNCTION__); /* Add global lock for emmc issue*/
+
+	writel_relaxed(val, reg);
+	__iormb();
+
+	rtk_lockapi_unlock(flags,__FUNCTION__); /* Add global lock for emmc issue*/
+}
+
+#undef readl
+#define readl(addr) otg_readl(addr)
+#undef writel
+#define writel(val, addr) otg_writel(val, addr)
+
+#endif
+
+
+struct platform_device;
+enum rtk_hsotg_dmamode {
+	RTK_HSOTG_DMA_NONE,		/* do not use DMA at-all */
+	RTK_HSOTG_DMA_ONLY,		/* always use DMA */
+	RTK_HSOTG_DMA_DRV,		/* DMA is chosen by driver */
+};
+
+/**
+ * struct rtk_hsotg_plat - platform data for high-speed otg/udc
+ * @dma: Whether to use DMA or not.
+ * @is_osc: The clock source is an oscillator, not a crystal
+ */
+struct rtk_hsotg_plat {
+	enum rtk_hsotg_dmamode	dma;
+	unsigned int		is_osc:1;
+	int                     phy_type;
+
+	int (*phy_init)(struct platform_device *pdev, int type);
+	int (*phy_exit)(struct platform_device *pdev, int type);
+};
+
+extern void rtk_hsotg_set_platdata(struct rtk_hsotg_plat *pd);
+
+static const char * const rtk_hsotg_supply_names[] = {
+	"vusb_d",		/* digital USB supply, 1.2V */
+	"vusb_a",		/* analog USB supply, 1.1V */
+};
+
+/*
+ * EP0_MPS_LIMIT
+ *
+ * Unfortunately there seems to be a limit of the amount of data that can
+ * be transferred by IN transactions on EP0. This is either 127 bytes or 3
+ * packets (which practically means 1 packet and 63 bytes of data) when the
+ * MPS is set to 64.
+ *
+ * This means if we are wanting to move >127 bytes of data, we need to
+ * split the transactions up, but just doing one packet at a time does
+ * not work (this may be an implicit DATA0 PID on first packet of the
+ * transaction) and doing 2 packets is outside the controller's limits.
+ *
+ * If we try to lower the MPS size for EP0, then no transfers work properly
+ * for EP0, and the system will fail basic enumeration. As no cause for this
+ * has currently been found, we cannot support any large IN transfers for
+ * EP0.
+ */
+#define EP0_MPS_LIMIT	64
+
+struct rtk_hsotg;
+struct rtk_hsotg_req;
+
+/**
+ * struct rtk_hsotg_ep - driver endpoint definition.
+ * @ep: The gadget layer representation of the endpoint.
+ * @name: The driver generated name for the endpoint.
+ * @queue: Queue of requests for this endpoint.
+ * @parent: Reference back to the parent device structure.
+ * @req: The current request that the endpoint is processing. This is
+ *       used to indicate an request has been loaded onto the endpoint
+ *       and has yet to be completed (maybe due to data move, or simply
+ *	 awaiting an ack from the core all the data has been completed).
+ * @debugfs: File entry for debugfs file for this endpoint.
+ * @lock: State lock to protect contents of endpoint.
+ * @dir_in: Set to true if this endpoint is of the IN direction, which
+ *	    means that it is sending data to the Host.
+ * @index: The index for the endpoint registers.
+ * @mc: Multi Count - number of transactions per microframe
+ * @interval - Interval for periodic endpoints
+ * @name: The name array passed to the USB core.
+ * @halted: Set if the endpoint has been halted.
+ * @periodic: Set if this is a periodic ep, such as Interrupt
+ * @isochronous: Set if this is a isochronous ep
+ * @sent_zlp: Set if we've sent a zero-length packet.
+ * @total_data: The total number of data bytes done.
+ * @fifo_size: The size of the FIFO (for periodic IN endpoints)
+ * @fifo_load: The amount of data loaded into the FIFO (periodic IN)
+ * @last_load: The offset of data for the last start of request.
+ * @size_loaded: The last loaded size for DxEPTSIZE for periodic IN
+ *
+ * This is the driver's state for each registered enpoint, allowing it
+ * to keep track of transactions that need doing. Each endpoint has a
+ * lock to protect the state, to try and avoid using an overall lock
+ * for the host controller as much as possible.
+ *
+ * For periodic IN endpoints, we have fifo_size and fifo_load to try
+ * and keep track of the amount of data in the periodic FIFO for each
+ * of these as we don't have a status register that tells us how much
+ * is in each of them. (note, this may actually be useless information
+ * as in shared-fifo mode periodic in acts like a single-frame packet
+ * buffer than a fifo)
+ */
+struct rtk_hsotg_ep {
+	struct usb_ep		ep;
+	struct list_head	queue;
+	struct rtk_hsotg	*parent;
+	struct rtk_hsotg_req	*req;
+	struct dentry		*debugfs;
+
+
+	unsigned long		total_data;
+	unsigned int		size_loaded;
+	unsigned int		last_load;
+	unsigned int		fifo_load;
+	unsigned short		fifo_size;
+
+	unsigned char		dir_in;
+	unsigned char		index;
+	unsigned char		mc;
+	unsigned char		interval;
+
+	unsigned int		halted:1;
+	unsigned int		periodic:1;
+	unsigned int		isochronous:1;
+	unsigned int		sent_zlp:1;
+
+	char			name[10];
+};
+
+/**
+ * struct rtk_hsotg - driver state.
+ * @dev: The parent device supplied to the probe function
+ * @driver: USB gadget driver
+ * @phy: The otg phy transceiver structure for phy control.
+ * @uphy: The otg phy transceiver structure for old USB phy control.
+ * @plat: The platform specific configuration data. This can be removed once
+ * all SoCs support usb transceiver.
+ * @regs: The memory area mapped for accessing registers.
+ * @irq: The IRQ number we are using
+ * @supplies: Definition of USB power supplies
+ * @phyif: PHY interface width
+ * @dedicated_fifos: Set if the hardware has dedicated IN-EP fifos.
+ * @num_of_eps: Number of available EPs (excluding EP0)
+ * @debug_root: root directrory for debugfs.
+ * @debug_file: main status file for debugfs.
+ * @debug_fifo: FIFO status file for debugfs.
+ * @ep0_reply: Request used for ep0 reply.
+ * @ep0_buff: Buffer for EP0 reply data, if needed.
+ * @ctrl_buff: Buffer for EP0 control requests.
+ * @ctrl_req: Request for EP0 control packets.
+ * @setup: NAK management for EP0 SETUP
+ * @last_rst: Time of last reset
+ * @eps: The endpoints being supplied to the gadget framework
+ */
+struct rtk_hsotg {
+	struct device		 *dev;
+	struct usb_gadget_driver *driver;
+	struct phy		 *phy;
+	struct usb_phy		 *uphy;
+	struct rtk_hsotg_plat	 *plat;
+
+	spinlock_t              lock;
+
+	void __iomem		*regs;
+	void __iomem		*phyregs;
+	int			irq;
+	struct clk		*clk;
+
+	struct regulator_bulk_data supplies[ARRAY_SIZE(rtk_hsotg_supply_names)];
+
+	u32			phyif;
+	unsigned int		dedicated_fifos:1;
+	unsigned char           num_of_eps;
+
+	struct dentry		*debug_root;
+	struct dentry		*debug_file;
+	struct dentry		*debug_fifo;
+
+	struct usb_request	*ep0_reply;
+	struct usb_request	*ctrl_req;
+	u8			ep0_buff[8];
+	u8			ctrl_buff[8];
+
+	struct usb_gadget	gadget;
+	unsigned int		setup;
+	unsigned long           last_rst;
+	struct rtk_hsotg_ep	*eps;
+
+#ifdef CONFIG_USB_RTK_UDC_OTG_SWITCH
+	int otg_type;
+#define RTK_HOST_MODE 0
+#define RTK_DEVICE_MODE 1
+#endif //CONFIG_USB_RTK_UDC_OTG_SWITCH
+};
+
+/**
+ * struct rtk_hsotg_req - data transfer request
+ * @req: The USB gadget request
+ * @queue: The list of requests for the endpoint this is queued for.
+ * @in_progress: Has already had size/packets written to core
+ * @mapped: DMA buffer for this request has been mapped via dma_map_single().
+ */
+struct rtk_hsotg_req {
+	struct usb_request	req;
+	struct list_head	queue;
+	unsigned char		in_progress;
+	unsigned char		mapped;
+};
+
+/* conversion functions */
+static inline struct rtk_hsotg_req *our_req(struct usb_request *req)
+{
+	return container_of(req, struct rtk_hsotg_req, req);
+}
+
+static inline struct rtk_hsotg_ep *our_ep(struct usb_ep *ep)
+{
+	return container_of(ep, struct rtk_hsotg_ep, ep);
+}
+
+static inline struct rtk_hsotg *to_hsotg(struct usb_gadget *gadget)
+{
+	return container_of(gadget, struct rtk_hsotg, gadget);
+}
+
+static inline void __orr32(void __iomem *ptr, u32 val)
+{
+	writel(readl(ptr) | val, ptr);
+}
+
+static inline void __bic32(void __iomem *ptr, u32 val)
+{
+	writel(readl(ptr) & ~val, ptr);
+}
+
+/* forward decleration of functions */
+static void rtk_hsotg_dump(struct rtk_hsotg *hsotg);
+
+/**
+ * using_dma - return the DMA status of the driver.
+ * @hsotg: The driver state.
+ *
+ * Return true if we're using DMA.
+ *
+ * Currently, we have the DMA support code worked into everywhere
+ * that needs it, but the AMBA DMA implementation in the hardware can
+ * only DMA from 32bit aligned addresses. This means that gadgets such
+ * as the CDC Ethernet cannot work as they often pass packets which are
+ * not 32bit aligned.
+ *
+ * Unfortunately the choice to use DMA or not is global to the controller
+ * and seems to be only settable when the controller is being put through
+ * a core reset. This means we either need to fix the gadgets to take
+ * account of DMA alignment, or add bounce buffers (yuerk).
+ *
+ * Until this issue is sorted out, we always return 'false'.
+ */
+static inline bool using_dma(struct rtk_hsotg *hsotg)
+{
+	return false;	/* support is not complete */
+}
+
+/**
+ * rtk_hsotg_en_gsint - enable one or more of the general interrupt
+ * @hsotg: The device state
+ * @ints: A bitmask of the interrupts to enable
+ */
+static void rtk_hsotg_en_gsint(struct rtk_hsotg *hsotg, u32 ints)
+{
+	u32 gsintmsk = readl(hsotg->regs + GINTMSK);
+	u32 new_gsintmsk;
+
+	new_gsintmsk = gsintmsk | ints;
+
+	if (new_gsintmsk != gsintmsk) {
+		dev_dbg(hsotg->dev, "gsintmsk now 0x%08x\n", new_gsintmsk);
+		writel(new_gsintmsk, hsotg->regs + GINTMSK);
+	}
+}
+
+/**
+ * rtk_hsotg_disable_gsint - disable one or more of the general interrupt
+ * @hsotg: The device state
+ * @ints: A bitmask of the interrupts to enable
+ */
+static void rtk_hsotg_disable_gsint(struct rtk_hsotg *hsotg, u32 ints)
+{
+	u32 gsintmsk = readl(hsotg->regs + GINTMSK);
+	u32 new_gsintmsk;
+
+	new_gsintmsk = gsintmsk & ~ints;
+
+	if (new_gsintmsk != gsintmsk)
+		writel(new_gsintmsk, hsotg->regs + GINTMSK);
+}
+
+/**
+ * rtk_hsotg_ctrl_epint - enable/disable an endpoint irq
+ * @hsotg: The device state
+ * @ep: The endpoint index
+ * @dir_in: True if direction is in.
+ * @en: The enable value, true to enable
+ *
+ * Set or clear the mask for an individual endpoint's interrupt
+ * request.
+ */
+static void rtk_hsotg_ctrl_epint(struct rtk_hsotg *hsotg,
+				 unsigned int ep, unsigned int dir_in,
+				 unsigned int en)
+{
+	unsigned long flags;
+	u32 bit = 1 << ep;
+	u32 daint;
+
+	if (!dir_in)
+		bit <<= 16;
+
+	local_irq_save(flags);
+	daint = readl(hsotg->regs + DAINTMSK);
+	if (en)
+		daint |= bit;
+	else
+		daint &= ~bit;
+	writel(daint, hsotg->regs + DAINTMSK);
+	local_irq_restore(flags);
+}
+
+/**
+ * rtk_hsotg_init_fifo - initialise non-periodic FIFOs
+ * @hsotg: The device instance.
+ */
+static void rtk_hsotg_init_fifo(struct rtk_hsotg *hsotg)
+{
+	unsigned int ep;
+	unsigned int addr;
+	unsigned int size;
+	int timeout;
+	u32 val;
+
+#define FIFO_SZ		512	//2048
+#define FIFO_DEPTH	256	//1024
+	/* set FIFO sizes to 512/256 2048/1024 */
+
+	writel(FIFO_SZ, hsotg->regs + GRXFSIZ);
+	writel(GNPTXFSIZ_NPTxFStAddr(FIFO_SZ) |
+	       GNPTXFSIZ_NPTxFDep(FIFO_DEPTH),
+	       hsotg->regs + GNPTXFSIZ);
+
+	/*
+	 * arange all the rest of the TX FIFOs, as some versions of this
+	 * block have overlapping default addresses. This also ensures
+	 * that if the settings have been changed, then they are set to
+	 * known values.
+	 */
+
+	/* start at the end of the GNPTXFSIZ, rounded up */
+	addr = FIFO_SZ + FIFO_DEPTH;
+	size = 768;
+
+	/*
+	 * currently we allocate TX FIFOs for all possible endpoints,
+	 * and assume that they are all the same size.
+	 */
+
+	for (ep = 1; ep <= 15; ep++) {
+		val = addr;
+		val |= size << DPTXFSIZn_DPTxFSize_SHIFT;
+		addr += size;
+
+		writel(val, hsotg->regs + DPTXFSIZn(ep));
+	}
+
+	/*
+	 * according to p428 of the design guide, we need to ensure that
+	 * all fifos are flushed before continuing
+	 */
+
+	writel(GRSTCTL_TxFNum(0x10) | GRSTCTL_TxFFlsh |
+	       GRSTCTL_RxFFlsh, hsotg->regs + GRSTCTL);
+
+	/* wait until the fifos are both flushed */
+	timeout = 100;
+	while (1) {
+		val = readl(hsotg->regs + GRSTCTL);
+
+		if ((val & (GRSTCTL_TxFFlsh | GRSTCTL_RxFFlsh)) == 0)
+			break;
+
+		if (--timeout == 0) {
+			dev_err(hsotg->dev,
+				"%s: timeout flushing fifos (GRSTCTL=%08x)\n",
+				__func__, val);
+		}
+
+		udelay(1);
+	}
+
+	dev_dbg(hsotg->dev, "FIFOs reset, timeout at %d\n", timeout);
+}
+
+/**
+ * @ep: USB endpoint to allocate request for.
+ * @flags: Allocation flags
+ *
+ * Allocate a new USB request structure appropriate for the specified endpoint
+ */
+static struct usb_request *rtk_hsotg_ep_alloc_request(struct usb_ep *ep,
+						      gfp_t flags)
+{
+	struct rtk_hsotg_req *req;
+
+	req = kzalloc(sizeof(struct rtk_hsotg_req), flags);
+	if (!req)
+		return NULL;
+
+	INIT_LIST_HEAD(&req->queue);
+
+	return &req->req;
+}
+
+/**
+ * is_ep_periodic - return true if the endpoint is in periodic mode.
+ * @hs_ep: The endpoint to query.
+ *
+ * Returns true if the endpoint is in periodic mode, meaning it is being
+ * used for an Interrupt or ISO transfer.
+ */
+static inline int is_ep_periodic(struct rtk_hsotg_ep *hs_ep)
+{
+	return hs_ep->periodic;
+}
+
+/**
+ * rtk_hsotg_unmap_dma - unmap the DMA memory being used for the request
+ * @hsotg: The device state.
+ * @hs_ep: The endpoint for the request
+ * @hs_req: The request being processed.
+ *
+ * This is the reverse of rtk_hsotg_map_dma(), called for the completion
+ * of a request to ensure the buffer is ready for access by the caller.
+ */
+static void rtk_hsotg_unmap_dma(struct rtk_hsotg *hsotg,
+				struct rtk_hsotg_ep *hs_ep,
+				struct rtk_hsotg_req *hs_req)
+{
+	struct usb_request *req = &hs_req->req;
+
+	/* ignore this if we're not moving any data */
+	if (hs_req->req.length == 0)
+		return;
+
+	usb_gadget_unmap_request(&hsotg->gadget, req, hs_ep->dir_in);
+}
+
+/**
+ * rtk_hsotg_write_fifo - write packet Data to the TxFIFO
+ * @hsotg: The controller state.
+ * @hs_ep: The endpoint we're going to write for.
+ * @hs_req: The request to write data for.
+ *
+ * This is called when the TxFIFO has some space in it to hold a new
+ * transmission and we have something to give it. The actual setup of
+ * the data size is done elsewhere, so all we have to do is to actually
+ * write the data.
+ *
+ * The return value is zero if there is more space (or nothing was done)
+ * otherwise -ENOSPC is returned if the FIFO space was used up.
+ *
+ * This routine is only needed for PIO
+ */
+static int rtk_hsotg_write_fifo(struct rtk_hsotg *hsotg,
+				struct rtk_hsotg_ep *hs_ep,
+				struct rtk_hsotg_req *hs_req)
+{
+	bool periodic = is_ep_periodic(hs_ep);
+	u32 gnptxsts = readl(hsotg->regs + GNPTXSTS);
+	int buf_pos = hs_req->req.actual;
+	int to_write = hs_ep->size_loaded;
+	void *data;
+	int can_write;
+	int pkt_round;
+	int max_transfer;
+
+	to_write -= (buf_pos - hs_ep->last_load);
+
+	/* if there's nothing to write, get out early */
+	if (to_write == 0)
+		return 0;
+
+	if (periodic && !hsotg->dedicated_fifos) {
+		u32 epsize = readl(hsotg->regs + DIEPTSIZ(hs_ep->index));
+		int size_left;
+		int size_done;
+
+		/*
+		 * work out how much data was loaded so we can calculate
+		 * how much data is left in the fifo.
+		 */
+
+		size_left = DxEPTSIZ_XferSize_GET(epsize);
+
+		/*
+		 * if shared fifo, we cannot write anything until the
+		 * previous data has been completely sent.
+		 */
+		if (hs_ep->fifo_load != 0) {
+			rtk_hsotg_en_gsint(hsotg, GINTSTS_PTxFEmp);
+			return -ENOSPC;
+		}
+
+		dev_dbg(hsotg->dev, "%s: left=%d, load=%d, fifo=%d, size %d\n",
+			__func__, size_left,
+			hs_ep->size_loaded, hs_ep->fifo_load, hs_ep->fifo_size);
+
+		/* how much of the data has moved */
+		size_done = hs_ep->size_loaded - size_left;
+
+		/* how much data is left in the fifo */
+		can_write = hs_ep->fifo_load - size_done;
+		dev_dbg(hsotg->dev, "%s: => can_write1=%d\n",
+			__func__, can_write);
+
+		can_write = hs_ep->fifo_size - can_write;
+		dev_dbg(hsotg->dev, "%s: => can_write2=%d\n",
+			__func__, can_write);
+
+		if (can_write <= 0) {
+			rtk_hsotg_en_gsint(hsotg, GINTSTS_PTxFEmp);
+			return -ENOSPC;
+		}
+	} else if (hsotg->dedicated_fifos && hs_ep->index != 0) {
+		can_write = readl(hsotg->regs + DTXFSTS(hs_ep->index));
+
+		can_write &= 0xffff;
+		can_write *= 4;
+	} else {
+		if (GNPTXSTS_NPTxQSpcAvail_GET(gnptxsts) == 0) {
+			dev_dbg(hsotg->dev,
+				"%s: no queue slots available (0x%08x)\n",
+				__func__, gnptxsts);
+
+			rtk_hsotg_en_gsint(hsotg, GINTSTS_NPTxFEmp);
+			return -ENOSPC;
+		}
+
+		can_write = GNPTXSTS_NPTxFSpcAvail_GET(gnptxsts);
+		can_write *= 4;	/* fifo size is in 32bit quantities. */
+	}
+
+	max_transfer = hs_ep->ep.maxpacket * hs_ep->mc;
+
+	dev_dbg(hsotg->dev, "%s: GNPTXSTS=%08x, can=%d, to=%d, max_transfer %d\n",
+		 __func__, gnptxsts, can_write, to_write, max_transfer);
+
+	/*
+	 * limit to 512 bytes of data, it seems at least on the non-periodic
+	 * FIFO, requests of >512 cause the endpoint to get stuck with a
+	 * fragment of the end of the transfer in it.
+	 */
+	if (can_write > 512 && !periodic)
+		can_write = 512;
+
+	/*
+	 * limit the write to one max-packet size worth of data, but allow
+	 * the transfer to return that it did not run out of fifo space
+	 * doing it.
+	 */
+	if (to_write > max_transfer) {
+		to_write = max_transfer;
+
+		/* it's needed only when we do not use dedicated fifos */
+		if (!hsotg->dedicated_fifos)
+			rtk_hsotg_en_gsint(hsotg,
+					   periodic ? GINTSTS_PTxFEmp :
+					   GINTSTS_NPTxFEmp);
+	}
+
+	/* see if we can write data */
+
+	if (to_write > can_write) {
+		to_write = can_write;
+		pkt_round = to_write % max_transfer;
+
+		/*
+		 * Round the write down to an
+		 * exact number of packets.
+		 *
+		 * Note, we do not currently check to see if we can ever
+		 * write a full packet or not to the FIFO.
+		 */
+
+		if (pkt_round)
+			to_write -= pkt_round;
+
+		/*
+		 * enable correct FIFO interrupt to alert us when there
+		 * is more room left.
+		 */
+
+		/* it's needed only when we do not use dedicated fifos */
+		if (!hsotg->dedicated_fifos)
+			rtk_hsotg_en_gsint(hsotg,
+					   periodic ? GINTSTS_PTxFEmp :
+					   GINTSTS_NPTxFEmp);
+	}
+
+	dev_dbg(hsotg->dev, "write %d/%d, can_write %d, done %d\n",
+		 to_write, hs_req->req.length, can_write, buf_pos);
+
+	if (to_write <= 0)
+		return -ENOSPC;
+
+	hs_req->req.actual = buf_pos + to_write;
+	hs_ep->total_data += to_write;
+
+	if (periodic)
+		hs_ep->fifo_load += to_write;
+
+	to_write = DIV_ROUND_UP(to_write, 4);
+	data = hs_req->req.buf + buf_pos;
+
+	iowrite32_rep(hsotg->regs + EPFIFO(hs_ep->index), data, to_write);
+
+	return (to_write >= can_write) ? -ENOSPC : 0;
+}
+
+/**
+ * get_ep_limit - get the maximum data legnth for this endpoint
+ * @hs_ep: The endpoint
+ *
+ * Return the maximum data that can be queued in one go on a given endpoint
+ * so that transfers that are too long can be split.
+ */
+static unsigned get_ep_limit(struct rtk_hsotg_ep *hs_ep)
+{
+	int index = hs_ep->index;
+	unsigned maxsize;
+	unsigned maxpkt;
+
+	if (index != 0) {
+		maxsize = DxEPTSIZ_XferSize_LIMIT + 1;
+		maxpkt = DxEPTSIZ_PktCnt_LIMIT + 1;
+	} else {
+		maxsize = 64+64;
+		if (hs_ep->dir_in)
+			maxpkt = DIEPTSIZ0_PktCnt_LIMIT + 1;
+		else
+			maxpkt = 2;
+	}
+
+	/* we made the constant loading easier above by using +1 */
+	maxpkt--;
+	maxsize--;
+
+	/*
+	 * constrain by packet count if maxpkts*pktsize is greater
+	 * than the length register size.
+	 */
+
+	if ((maxpkt * hs_ep->ep.maxpacket) < maxsize)
+		maxsize = maxpkt * hs_ep->ep.maxpacket;
+
+	return maxsize;
+}
+
+/**
+ * rtk_hsotg_start_req - start a USB request from an endpoint's queue
+ * @hsotg: The controller state.
+ * @hs_ep: The endpoint to process a request for
+ * @hs_req: The request to start.
+ * @continuing: True if we are doing more for the current request.
+ *
+ * Start the given request running by setting the endpoint registers
+ * appropriately, and writing any data to the FIFOs.
+ */
+static void rtk_hsotg_start_req(struct rtk_hsotg *hsotg,
+				struct rtk_hsotg_ep *hs_ep,
+				struct rtk_hsotg_req *hs_req,
+				bool continuing)
+{
+	struct usb_request *ureq = &hs_req->req;
+	int index = hs_ep->index;
+	int dir_in = hs_ep->dir_in;
+	u32 epctrl_reg;
+	u32 epsize_reg;
+	u32 epsize;
+	u32 ctrl;
+	unsigned length;
+	unsigned packets;
+	unsigned maxreq;
+
+	if (index != 0) {
+		if (hs_ep->req && !continuing) {
+			dev_err(hsotg->dev, "%s: active request\n", __func__);
+			WARN_ON(1);
+			return;
+		} else if (hs_ep->req != hs_req && continuing) {
+			dev_err(hsotg->dev,
+				"%s: continue different req\n", __func__);
+			WARN_ON(1);
+			return;
+		}
+	}
+
+	epctrl_reg = dir_in ? DIEPCTL(index) : DOEPCTL(index);
+	epsize_reg = dir_in ? DIEPTSIZ(index) : DOEPTSIZ(index);
+
+	dev_dbg(hsotg->dev, "%s: DxEPCTL=0x%08x, ep %d, dir %s\n",
+		__func__, readl(hsotg->regs + epctrl_reg), index,
+		hs_ep->dir_in ? "in" : "out");
+
+	/* If endpoint is stalled, we will restart request later */
+	ctrl = readl(hsotg->regs + epctrl_reg);
+
+	if (ctrl & DxEPCTL_Stall) {
+		dev_warn(hsotg->dev, "%s: ep%d is stalled\n", __func__, index);
+		return;
+	}
+
+	length = ureq->length - ureq->actual;
+	dev_dbg(hsotg->dev, "ureq->length:%d ureq->actual:%d\n",
+		ureq->length, ureq->actual);
+	if (0)
+		dev_dbg(hsotg->dev,
+			"REQ buf %p len %d dma 0x%pad noi=%d zp=%d snok=%d\n",
+			ureq->buf, length, &ureq->dma,
+			ureq->no_interrupt, ureq->zero, ureq->short_not_ok);
+
+	maxreq = get_ep_limit(hs_ep);
+	if (length > maxreq) {
+		int round = maxreq % hs_ep->ep.maxpacket;
+
+		dev_dbg(hsotg->dev, "%s: length %d, max-req %d, r %d\n",
+			__func__, length, maxreq, round);
+
+		/* round down to multiple of packets */
+		if (round)
+			maxreq -= round;
+
+		length = maxreq;
+	}
+
+	if (length)
+		packets = DIV_ROUND_UP(length, hs_ep->ep.maxpacket);
+	else
+		packets = 1;	/* send one packet if length is zero. */
+
+	if (hs_ep->isochronous && length > (hs_ep->mc * hs_ep->ep.maxpacket)) {
+		dev_err(hsotg->dev, "req length > maxpacket*mc\n");
+		return;
+	}
+
+	if (dir_in && index != 0)
+		if (hs_ep->isochronous)
+			epsize = DxEPTSIZ_MC(packets);
+		else
+			epsize = DxEPTSIZ_MC(1);
+	else
+		epsize = 0;
+
+	if (index != 0 && ureq->zero) {
+		/*
+		 * test for the packets being exactly right for the
+		 * transfer
+		 */
+
+		if (length == (packets * hs_ep->ep.maxpacket))
+			packets++;
+	}
+
+	epsize |= DxEPTSIZ_PktCnt(packets);
+	epsize |= DxEPTSIZ_XferSize(length);
+
+	dev_dbg(hsotg->dev, "%s: %d@%d/%d, 0x%08x => 0x%08x\n",
+		__func__, packets, length, ureq->length, epsize, epsize_reg);
+
+	/* store the request as the current one we're doing */
+	hs_ep->req = hs_req;
+
+	/* write size / packets */
+	writel(epsize, hsotg->regs + epsize_reg);
+
+	if (using_dma(hsotg) && !continuing) {
+		unsigned int dma_reg;
+
+		/*
+		 * write DMA address to control register, buffer already
+		 * synced by rtk_hsotg_ep_queue().
+		 */
+
+		dma_reg = dir_in ? DIEPDMA(index) : DOEPDMA(index);
+		writel(ureq->dma, hsotg->regs + dma_reg);
+
+		dev_dbg(hsotg->dev, "%s: 0x%pad => 0x%08x\n",
+			__func__, &ureq->dma, dma_reg);
+	}
+
+	ctrl |= DxEPCTL_EPEna;	/* ensure ep enabled */
+	ctrl |= DxEPCTL_USBActEp;
+
+	dev_dbg(hsotg->dev, "setup req:%d\n", hsotg->setup);
+
+	/* For Setup request do not clear NAK */
+#if 0	//barry
+	if (hsotg->setup && index == 0)
+		hsotg->setup = 0;
+	else
+#endif
+		ctrl |= DxEPCTL_CNAK;	/* clear NAK set by core */
+
+
+	dev_dbg(hsotg->dev, "%s: DxEPCTL=0x%08x\n", __func__, ctrl);
+	writel(ctrl, hsotg->regs + epctrl_reg);
+
+	/*
+	 * set these, it seems that DMA support increments past the end
+	 * of the packet buffer so we need to calculate the length from
+	 * this information.
+	 */
+	hs_ep->size_loaded = length;
+	hs_ep->last_load = ureq->actual;
+
+	if (dir_in && !using_dma(hsotg)) {
+		/* set these anyway, we may need them for non-periodic in */
+		hs_ep->fifo_load = 0;
+
+		rtk_hsotg_write_fifo(hsotg, hs_ep, hs_req);
+	}
+
+	/*
+	 * clear the INTknTXFEmpMsk when we start request, more as a aide
+	 * to debugging to see what is going on.
+	 */
+	if (dir_in)
+		writel(DIEPMSK_INTknTXFEmpMsk,
+		       hsotg->regs + DIEPINT(index));
+
+	/* check ep is enabled */
+	if (!(readl(hsotg->regs + epctrl_reg) & DxEPCTL_EPEna))
+		dev_warn(hsotg->dev,
+			 "ep%d: failed to become enabled (DxEPCTL=0x%08x)?\n",
+			 index, readl(hsotg->regs + epctrl_reg));
+
+	dev_dbg(hsotg->dev, "%s: DxEPCTL=0x%08x\n",
+		__func__, readl(hsotg->regs + epctrl_reg));
+
+	/* enable ep interrupts */
+	rtk_hsotg_ctrl_epint(hsotg, hs_ep->index, hs_ep->dir_in, 1);
+}
+
+/**
+ * rtk_hsotg_map_dma - map the DMA memory being used for the request
+ * @hsotg: The device state.
+ * @hs_ep: The endpoint the request is on.
+ * @req: The request being processed.
+ *
+ * We've been asked to queue a request, so ensure that the memory buffer
+ * is correctly setup for DMA. If we've been passed an extant DMA address
+ * then ensure the buffer has been synced to memory. If our buffer has no
+ * DMA memory, then we map the memory and mark our request to allow us to
+ * cleanup on completion.
+ */
+static int rtk_hsotg_map_dma(struct rtk_hsotg *hsotg,
+			     struct rtk_hsotg_ep *hs_ep,
+			     struct usb_request *req)
+{
+	struct rtk_hsotg_req *hs_req = our_req(req);
+	int ret;
+
+	/* if the length is zero, ignore the DMA data */
+	if (hs_req->req.length == 0)
+		return 0;
+
+	ret = usb_gadget_map_request(&hsotg->gadget, req, hs_ep->dir_in);
+	if (ret)
+		goto dma_error;
+
+	return 0;
+
+dma_error:
+	dev_err(hsotg->dev, "%s: failed to map buffer %p, %d bytes\n",
+		__func__, req->buf, req->length);
+
+	return -EIO;
+}
+
+static int rtk_hsotg_ep_queue(struct usb_ep *ep, struct usb_request *req,
+			      gfp_t gfp_flags)
+{
+	struct rtk_hsotg_req *hs_req = our_req(req);
+	struct rtk_hsotg_ep *hs_ep = our_ep(ep);
+	struct rtk_hsotg *hs = hs_ep->parent;
+	bool first;
+
+	dev_dbg(hs->dev, "%s: req %p: %d@%p, noi=%d, zero=%d, snok=%d\n",
+		ep->name, req, req->length, req->buf, req->no_interrupt,
+		req->zero, req->short_not_ok);
+
+	/* initialise status of the request */
+	INIT_LIST_HEAD(&hs_req->queue);
+	req->actual = 0;
+	req->status = -EINPROGRESS;
+
+	/* if we're using DMA, sync the buffers as necessary */
+	if (using_dma(hs)) {
+		int ret = rtk_hsotg_map_dma(hs, hs_ep, req);
+		if (ret)
+			return ret;
+	}
+
+	first = list_empty(&hs_ep->queue);
+	list_add_tail(&hs_req->queue, &hs_ep->queue);
+
+	if (first)
+		rtk_hsotg_start_req(hs, hs_ep, hs_req, false);
+
+	return 0;
+}
+
+static int rtk_hsotg_ep_queue_lock(struct usb_ep *ep, struct usb_request *req,
+			      gfp_t gfp_flags)
+{
+	struct rtk_hsotg_ep *hs_ep = our_ep(ep);
+	struct rtk_hsotg *hs = hs_ep->parent;
+	unsigned long flags = 0;
+	int ret = 0;
+
+	spin_lock_irqsave(&hs->lock, flags);
+	ret = rtk_hsotg_ep_queue(ep, req, gfp_flags);
+	spin_unlock_irqrestore(&hs->lock, flags);
+
+	return ret;
+}
+
+static void rtk_hsotg_ep_free_request(struct usb_ep *ep,
+				      struct usb_request *req)
+{
+	struct rtk_hsotg_req *hs_req = our_req(req);
+
+	kfree(hs_req);
+}
+
+/**
+ * rtk_hsotg_complete_oursetup - setup completion callback
+ * @ep: The endpoint the request was on.
+ * @req: The request completed.
+ *
+ * Called on completion of any requests the driver itself
+ * submitted that need cleaning up.
+ */
+static void rtk_hsotg_complete_oursetup(struct usb_ep *ep,
+					struct usb_request *req)
+{
+	struct rtk_hsotg_ep *hs_ep = our_ep(ep);
+	struct rtk_hsotg *hsotg = hs_ep->parent;
+
+	dev_dbg(hsotg->dev, "%s: ep %p, req %p\n", __func__, ep, req);
+
+	rtk_hsotg_ep_free_request(ep, req);
+}
+
+/**
+ * ep_from_windex - convert control wIndex value to endpoint
+ * @hsotg: The driver state.
+ * @windex: The control request wIndex field (in host order).
+ *
+ * Convert the given wIndex into a pointer to an driver endpoint
+ * structure, or return NULL if it is not a valid endpoint.
+ */
+static struct rtk_hsotg_ep *ep_from_windex(struct rtk_hsotg *hsotg,
+					   u32 windex)
+{
+	struct rtk_hsotg_ep *ep = &hsotg->eps[windex & 0x7F];
+	int dir = (windex & USB_DIR_IN) ? 1 : 0;
+	int idx = windex & 0x7F;
+
+	if (windex >= 0x100)
+		return NULL;
+
+	if (idx > hsotg->num_of_eps)
+		return NULL;
+
+	if (idx && ep->dir_in != dir)
+		return NULL;
+
+	return ep;
+}
+
+/**
+ * rtk_hsotg_send_reply - send reply to control request
+ * @hsotg: The device state
+ * @ep: Endpoint 0
+ * @buff: Buffer for request
+ * @length: Length of reply.
+ *
+ * Create a request and queue it on the given endpoint. This is useful as
+ * an internal method of sending replies to certain control requests, etc.
+ */
+static int rtk_hsotg_send_reply(struct rtk_hsotg *hsotg,
+				struct rtk_hsotg_ep *ep,
+				void *buff,
+				int length)
+{
+	struct usb_request *req;
+	int ret;
+
+	dev_dbg(hsotg->dev, "%s: buff %p, len %d\n", __func__, buff, length);
+
+	req = rtk_hsotg_ep_alloc_request(&ep->ep, GFP_ATOMIC);
+	hsotg->ep0_reply = req;
+	if (!req) {
+		dev_warn(hsotg->dev, "%s: cannot alloc req\n", __func__);
+		return -ENOMEM;
+	}
+
+	req->buf = hsotg->ep0_buff;
+	req->length = length;
+	req->zero = 1; /* always do zero-length final transfer */
+	req->complete = rtk_hsotg_complete_oursetup;
+
+	if (length)
+		memcpy(req->buf, buff, length);
+	else
+		ep->sent_zlp = 1;
+
+	ret = rtk_hsotg_ep_queue(&ep->ep, req, GFP_ATOMIC);
+	if (ret) {
+		dev_warn(hsotg->dev, "%s: cannot queue req\n", __func__);
+		return ret;
+	}
+
+	return 0;
+}
+
+/**
+ * rtk_hsotg_process_req_status - process request GET_STATUS
+ * @hsotg: The device state
+ * @ctrl: USB control request
+ */
+static int rtk_hsotg_process_req_status(struct rtk_hsotg *hsotg,
+					struct usb_ctrlrequest *ctrl)
+{
+	struct rtk_hsotg_ep *ep0 = &hsotg->eps[0];
+	struct rtk_hsotg_ep *ep;
+	__le16 reply;
+	int ret;
+
+	dev_dbg(hsotg->dev, "%s: USB_REQ_GET_STATUS\n", __func__);
+
+	if (!ep0->dir_in) {
+		dev_warn(hsotg->dev, "%s: direction out?\n", __func__);
+		return -EINVAL;
+	}
+
+	switch (ctrl->bRequestType & USB_RECIP_MASK) {
+	case USB_RECIP_DEVICE:
+		reply = cpu_to_le16(0); /* bit 0 => self powered,
+					 * bit 1 => remote wakeup */
+		break;
+
+	case USB_RECIP_INTERFACE:
+		/* currently, the data result should be zero */
+		reply = cpu_to_le16(0);
+		break;
+
+	case USB_RECIP_ENDPOINT:
+		ep = ep_from_windex(hsotg, le16_to_cpu(ctrl->wIndex));
+		if (!ep)
+			return -ENOENT;
+
+		reply = cpu_to_le16(ep->halted ? 1 : 0);
+		break;
+
+	default:
+		return 0;
+	}
+
+	if (le16_to_cpu(ctrl->wLength) != 2)
+		return -EINVAL;
+
+	ret = rtk_hsotg_send_reply(hsotg, ep0, &reply, 2);
+	if (ret) {
+		dev_err(hsotg->dev, "%s: failed to send reply\n", __func__);
+		return ret;
+	}
+
+	return 1;
+}
+
+static int rtk_hsotg_ep_sethalt(struct usb_ep *ep, int value);
+
+/**
+ * get_ep_head - return the first request on the endpoint
+ * @hs_ep: The controller endpoint to get
+ *
+ * Get the first request on the endpoint.
+ */
+static struct rtk_hsotg_req *get_ep_head(struct rtk_hsotg_ep *hs_ep)
+{
+	if (list_empty(&hs_ep->queue))
+		return NULL;
+
+	return list_first_entry(&hs_ep->queue, struct rtk_hsotg_req, queue);
+}
+
+/**
+ * rtk_hsotg_process_req_featire - process request {SET,CLEAR}_FEATURE
+ * @hsotg: The device state
+ * @ctrl: USB control request
+ */
+static int rtk_hsotg_process_req_feature(struct rtk_hsotg *hsotg,
+					 struct usb_ctrlrequest *ctrl)
+{
+	struct rtk_hsotg_ep *ep0 = &hsotg->eps[0];
+	struct rtk_hsotg_req *hs_req;
+	bool restart;
+	bool set = (ctrl->bRequest == USB_REQ_SET_FEATURE);
+	struct rtk_hsotg_ep *ep;
+	int ret;
+	bool halted;
+
+	dev_dbg(hsotg->dev, "%s: %s_FEATURE\n",
+		__func__, set ? "SET" : "CLEAR");
+
+	if (ctrl->bRequestType == USB_RECIP_ENDPOINT) {
+		ep = ep_from_windex(hsotg, le16_to_cpu(ctrl->wIndex));
+		if (!ep) {
+			dev_dbg(hsotg->dev, "%s: no endpoint for 0x%04x\n",
+				__func__, le16_to_cpu(ctrl->wIndex));
+			return -ENOENT;
+		}
+
+		switch (le16_to_cpu(ctrl->wValue)) {
+		case USB_ENDPOINT_HALT:
+			halted = ep->halted;
+
+			rtk_hsotg_ep_sethalt(&ep->ep, set);
+
+			ret = rtk_hsotg_send_reply(hsotg, ep0, NULL, 0);
+			if (ret) {
+				dev_err(hsotg->dev,
+					"%s: failed to send reply\n", __func__);
+				return ret;
+			}
+
+			/*
+			 * we have to complete all requests for ep if it was
+			 * halted, and the halt was cleared by CLEAR_FEATURE
+			 */
+
+			if (!set && halted) {
+				/*
+				 * If we have request in progress,
+				 * then complete it
+				 */
+				if (ep->req) {
+					hs_req = ep->req;
+					ep->req = NULL;
+					list_del_init(&hs_req->queue);
+					hs_req->req.complete(&ep->ep,
+							     &hs_req->req);
+				}
+
+				/* If we have pending request, then start it */
+				restart = !list_empty(&ep->queue);
+				if (restart) {
+					hs_req = get_ep_head(ep);
+					rtk_hsotg_start_req(hsotg, ep,
+							    hs_req, false);
+				}
+			}
+
+			break;
+
+		default:
+			return -ENOENT;
+		}
+	} else
+		return -ENOENT;  /* currently only deal with endpoint */
+
+	return 1;
+}
+
+static void rtk_hsotg_enqueue_setup(struct rtk_hsotg *hsotg);
+static void rtk_hsotg_disconnect(struct rtk_hsotg *hsotg);
+
+/**
+ * rtk_hsotg_stall_ep0 - stall ep0
+ * @hsotg: The device state
+ *
+ * Set stall for ep0 as response for setup request.
+ */
+static void rtk_hsotg_stall_ep0(struct rtk_hsotg *hsotg) {
+	struct rtk_hsotg_ep *ep0 = &hsotg->eps[0];
+	u32 reg;
+	u32 ctrl;
+
+	dev_dbg(hsotg->dev, "ep0 stall (dir=%d)\n", ep0->dir_in);
+	reg = (ep0->dir_in) ? DIEPCTL0 : DOEPCTL0;
+
+	/*
+	 * DxEPCTL_Stall will be cleared by EP once it has
+	 * taken effect, so no need to clear later.
+	 */
+
+	ctrl = readl(hsotg->regs + reg);
+	ctrl |= DxEPCTL_Stall;
+	ctrl |= DxEPCTL_CNAK;
+	writel(ctrl, hsotg->regs + reg);
+
+	dev_dbg(hsotg->dev,
+		"written DxEPCTL=0x%08x to %08x (DxEPCTL=0x%08x)\n",
+		ctrl, reg, readl(hsotg->regs + reg));
+
+	 /*
+	  * complete won't be called, so we enqueue
+	  * setup request here
+	  */
+	 rtk_hsotg_enqueue_setup(hsotg);
+}
+
+/**
+ * rtk_hsotg_process_control - process a control request
+ * @hsotg: The device state
+ * @ctrl: The control request received
+ *
+ * The controller has received the SETUP phase of a control request, and
+ * needs to work out what to do next (and whether to pass it on to the
+ * gadget driver).
+ */
+static void rtk_hsotg_process_control(struct rtk_hsotg *hsotg,
+				      struct usb_ctrlrequest *ctrl)
+{
+	struct rtk_hsotg_ep *ep0 = &hsotg->eps[0];
+	int ret = 0;
+	u32 dcfg;
+
+	ep0->sent_zlp = 0;
+
+	dev_dbg(hsotg->dev, "ctrl Req=%02x, Type=%02x, V=%04x, L=%04x\n",
+		 ctrl->bRequest, ctrl->bRequestType,
+		 ctrl->wValue, ctrl->wLength);
+
+	/*
+	 * record the direction of the request, for later use when enquing
+	 * packets onto EP0.
+	 */
+
+	ep0->dir_in = (ctrl->bRequestType & USB_DIR_IN) ? 1 : 0;
+	dev_dbg(hsotg->dev, "ctrl: dir_in=%d\n", ep0->dir_in);
+
+	/*
+	 * if we've no data with this request, then the last part of the
+	 * transaction is going to implicitly be IN.
+	 */
+	if (ctrl->wLength == 0)
+		ep0->dir_in = 1;
+
+	if ((ctrl->bRequestType & USB_TYPE_MASK) == USB_TYPE_STANDARD) {
+		switch (ctrl->bRequest) {
+		case USB_REQ_SET_ADDRESS:
+			rtk_hsotg_disconnect(hsotg);
+			dcfg = readl(hsotg->regs + DCFG);
+			dcfg &= ~DCFG_DevAddr_MASK;
+			dcfg |= ctrl->wValue << DCFG_DevAddr_SHIFT;
+			writel(dcfg, hsotg->regs + DCFG);
+
+			dev_info(hsotg->dev, "new address %d\n", ctrl->wValue);
+
+			ret = rtk_hsotg_send_reply(hsotg, ep0, NULL, 0);
+			return;
+
+		case USB_REQ_GET_STATUS:
+			ret = rtk_hsotg_process_req_status(hsotg, ctrl);
+			break;
+
+		case USB_REQ_CLEAR_FEATURE:
+		case USB_REQ_SET_FEATURE:
+			ret = rtk_hsotg_process_req_feature(hsotg, ctrl);
+			break;
+		}
+	}
+
+	/* as a fallback, try delivering it to the driver to deal with */
+
+	if (ret == 0 && hsotg->driver) {
+		spin_unlock(&hsotg->lock);
+		ret = hsotg->driver->setup(&hsotg->gadget, ctrl);
+		spin_lock(&hsotg->lock);
+		if (ret < 0)
+			dev_dbg(hsotg->dev, "driver->setup() ret %d\n", ret);
+	}
+
+	/*
+	 * the request is either unhandlable, or is not formatted correctly
+	 * so respond with a STALL for the status stage to indicate failure.
+	 */
+
+	if (ret < 0)
+		rtk_hsotg_stall_ep0(hsotg);
+}
+
+/**
+ * rtk_hsotg_complete_setup - completion of a setup transfer
+ * @ep: The endpoint the request was on.
+ * @req: The request completed.
+ *
+ * Called on completion of any requests the driver itself submitted for
+ * EP0 setup packets
+ */
+static void rtk_hsotg_complete_setup(struct usb_ep *ep,
+				     struct usb_request *req)
+{
+	struct rtk_hsotg_ep *hs_ep = our_ep(ep);
+	struct rtk_hsotg *hsotg = hs_ep->parent;
+
+	if (req->status < 0) {
+		dev_dbg(hsotg->dev, "%s: failed %d\n", __func__, req->status);
+		return;
+	}
+
+	spin_lock(&hsotg->lock);
+	if (req->actual == 0)
+		rtk_hsotg_enqueue_setup(hsotg);
+	else
+		rtk_hsotg_process_control(hsotg, req->buf);
+	spin_unlock(&hsotg->lock);
+}
+
+/**
+ * rtk_hsotg_enqueue_setup - start a request for EP0 packets
+ * @hsotg: The device state.
+ *
+ * Enqueue a request on EP0 if necessary to received any SETUP packets
+ * received from the host.
+ */
+static void rtk_hsotg_enqueue_setup(struct rtk_hsotg *hsotg)
+{
+	struct usb_request *req = hsotg->ctrl_req;
+	struct rtk_hsotg_req *hs_req = our_req(req);
+	int ret;
+
+	dev_dbg(hsotg->dev, "%s: queueing setup request\n", __func__);
+
+	req->zero = 0;
+	req->length = 8;
+	req->buf = hsotg->ctrl_buff;
+	req->complete = rtk_hsotg_complete_setup;
+
+	if (!list_empty(&hs_req->queue)) {
+		dev_dbg(hsotg->dev, "%s already queued???\n", __func__);
+		return;
+	}
+
+	hsotg->eps[0].dir_in = 0;
+
+	ret = rtk_hsotg_ep_queue(&hsotg->eps[0].ep, req, GFP_ATOMIC);
+	if (ret < 0) {
+		dev_err(hsotg->dev, "%s: failed queue (%d)\n", __func__, ret);
+		/*
+		 * Don't think there's much we can do other than watch the
+		 * driver fail.
+		 */
+	}
+}
+
+/**
+ * rtk_hsotg_complete_request - complete a request given to us
+ * @hsotg: The device state.
+ * @hs_ep: The endpoint the request was on.
+ * @hs_req: The request to complete.
+ * @result: The result code (0 => Ok, otherwise errno)
+ *
+ * The given request has finished, so call the necessary completion
+ * if it has one and then look to see if we can start a new request
+ * on the endpoint.
+ *
+ * Note, expects the ep to already be locked as appropriate.
+ */
+static void rtk_hsotg_complete_request(struct rtk_hsotg *hsotg,
+				       struct rtk_hsotg_ep *hs_ep,
+				       struct rtk_hsotg_req *hs_req,
+				       int result)
+{
+	bool restart;
+
+	if (!hs_req) {
+		dev_dbg(hsotg->dev, "%s: nothing to complete?\n", __func__);
+		return;
+	}
+
+	dev_dbg(hsotg->dev, "complete: ep %p %s, req %p, %d => %p\n",
+		hs_ep, hs_ep->ep.name, hs_req, result, hs_req->req.complete);
+
+	/*
+	 * only replace the status if we've not already set an error
+	 * from a previous transaction
+	 */
+
+	if (hs_req->req.status == -EINPROGRESS)
+		hs_req->req.status = result;
+
+	hs_ep->req = NULL;
+	list_del_init(&hs_req->queue);
+
+	if (using_dma(hsotg))
+		rtk_hsotg_unmap_dma(hsotg, hs_ep, hs_req);
+
+	/*
+	 * call the complete request with the locks off, just in case the
+	 * request tries to queue more work for this endpoint.
+	 */
+
+	if (hs_req->req.complete) {
+		spin_unlock(&hsotg->lock);
+		hs_req->req.complete(&hs_ep->ep, &hs_req->req);
+		spin_lock(&hsotg->lock);
+	}
+
+	/*
+	 * Look to see if there is anything else to do. Note, the completion
+	 * of the previous request may have caused a new request to be started
+	 * so be careful when doing this.
+	 */
+
+	if (!hs_ep->req && result >= 0) {
+		restart = !list_empty(&hs_ep->queue);
+		if (restart) {
+			hs_req = get_ep_head(hs_ep);
+			rtk_hsotg_start_req(hsotg, hs_ep, hs_req, false);
+		}
+	}
+}
+
+/**
+ * rtk_hsotg_rx_data - receive data from the FIFO for an endpoint
+ * @hsotg: The device state.
+ * @ep_idx: The endpoint index for the data
+ * @size: The size of data in the fifo, in bytes
+ *
+ * The FIFO status shows there is data to read from the FIFO for a given
+ * endpoint, so sort out whether we need to read the data into a request
+ * that has been made for that endpoint.
+ */
+static void rtk_hsotg_rx_data(struct rtk_hsotg *hsotg, int ep_idx, int size)
+{
+	struct rtk_hsotg_ep *hs_ep = &hsotg->eps[ep_idx];
+	struct rtk_hsotg_req *hs_req = hs_ep->req;
+	void __iomem *fifo = hsotg->regs + EPFIFO(ep_idx);
+	int to_read;
+	int max_req;
+	int read_ptr;
+
+
+	if (!hs_req) {
+		u32 epctl = readl(hsotg->regs + DOEPCTL(ep_idx));
+		int ptr;
+
+		dev_warn(hsotg->dev,
+			 "%s: FIFO %d bytes on ep%d but no req (DxEPCTl=0x%08x)\n",
+			 __func__, size, ep_idx, epctl);
+
+		/* dump the data from the FIFO, we've nothing we can do */
+		for (ptr = 0; ptr < size; ptr += 4)
+			(void)readl(fifo);
+
+		return;
+	}
+
+	to_read = size;
+	read_ptr = hs_req->req.actual;
+	max_req = hs_req->req.length - read_ptr;
+
+	dev_dbg(hsotg->dev, "%s: read %d/%d, done %d/%d\n",
+		__func__, to_read, max_req, read_ptr, hs_req->req.length);
+
+	if (to_read > max_req) {
+		/*
+		 * more data appeared than we where willing
+		 * to deal with in this request.
+		 */
+
+		/* currently we don't deal this */
+		WARN_ON_ONCE(1);
+	}
+
+	hs_ep->total_data += to_read;
+	hs_req->req.actual += to_read;
+	to_read = DIV_ROUND_UP(to_read, 4);
+
+	/*
+	 * note, we might over-write the buffer end by 3 bytes depending on
+	 * alignment of the data.
+	 */
+	ioread32_rep(fifo, hs_req->req.buf + read_ptr, to_read);
+}
+
+/**
+ * rtk_hsotg_send_zlp - send zero-length packet on control endpoint
+ * @hsotg: The device instance
+ * @req: The request currently on this endpoint
+ *
+ * Generate a zero-length IN packet request for terminating a SETUP
+ * transaction.
+ *
+ * Note, since we don't write any data to the TxFIFO, then it is
+ * currently believed that we do not need to wait for any space in
+ * the TxFIFO.
+ */
+static void rtk_hsotg_send_zlp(struct rtk_hsotg *hsotg,
+			       struct rtk_hsotg_req *req)
+{
+	u32 ctrl;
+
+	if (!req) {
+		dev_warn(hsotg->dev, "%s: no request?\n", __func__);
+		return;
+	}
+
+	if (req->req.length == 0) {
+		hsotg->eps[0].sent_zlp = 1;
+		rtk_hsotg_enqueue_setup(hsotg);
+		return;
+	}
+
+	hsotg->eps[0].dir_in = 1;
+	hsotg->eps[0].sent_zlp = 1;
+
+	dev_dbg(hsotg->dev, "sending zero-length packet\n");
+
+	/* issue a zero-sized packet to terminate this */
+	writel(DxEPTSIZ_MC(1) | DxEPTSIZ_PktCnt(1) |
+	       DxEPTSIZ_XferSize(0), hsotg->regs + DIEPTSIZ(0));
+
+	ctrl = readl(hsotg->regs + DIEPCTL0);
+	ctrl |= DxEPCTL_CNAK;  /* clear NAK set by core */
+	ctrl |= DxEPCTL_EPEna; /* ensure ep enabled */
+	ctrl |= DxEPCTL_USBActEp;
+	writel(ctrl, hsotg->regs + DIEPCTL0);
+}
+
+/**
+ * rtk_hsotg_handle_outdone - handle receiving OutDone/SetupDone from RXFIFO
+ * @hsotg: The device instance
+ * @epnum: The endpoint received from
+ * @was_setup: Set if processing a SetupDone event.
+ *
+ * The RXFIFO has delivered an OutDone event, which means that the data
+ * transfer for an OUT endpoint has been completed, either by a short
+ * packet or by the finish of a transfer.
+ */
+static void rtk_hsotg_handle_outdone(struct rtk_hsotg *hsotg,
+				     int epnum, bool was_setup)
+{
+	u32 epsize = readl(hsotg->regs + DOEPTSIZ(epnum));
+	struct rtk_hsotg_ep *hs_ep = &hsotg->eps[epnum];
+	struct rtk_hsotg_req *hs_req = hs_ep->req;
+	struct usb_request *req = &hs_req->req;
+	unsigned size_left = DxEPTSIZ_XferSize_GET(epsize);
+	int result = 0;
+
+	if (!hs_req) {
+		dev_dbg(hsotg->dev, "%s: no request active\n", __func__);
+		return;
+	}
+
+	if (using_dma(hsotg)) {
+		unsigned size_done;
+
+		/*
+		 * Calculate the size of the transfer by checking how much
+		 * is left in the endpoint size register and then working it
+		 * out from the amount we loaded for the transfer.
+		 *
+		 * We need to do this as DMA pointers are always 32bit aligned
+		 * so may overshoot/undershoot the transfer.
+		 */
+
+		size_done = hs_ep->size_loaded - size_left;
+		size_done += hs_ep->last_load;
+
+		req->actual = size_done;
+	}
+
+	/* if there is more request to do, schedule new transfer */
+	if (req->actual < req->length && size_left == 0) {
+		rtk_hsotg_start_req(hsotg, hs_ep, hs_req, true);
+		return;
+	} else if (epnum == 0) {
+		/*
+		 * After was_setup = 1 =>
+		 * set CNAK for non Setup requests
+		 */
+		hsotg->setup = was_setup ? 0 : 1;
+	}
+
+	if (req->actual < req->length && req->short_not_ok) {
+		dev_dbg(hsotg->dev, "%s: got %d/%d (short not ok) => error\n",
+			__func__, req->actual, req->length);
+
+		/*
+		 * todo - what should we return here? there's no one else
+		 * even bothering to check the status.
+		 */
+	}
+
+	if (epnum == 0) {
+		/*
+		 * Condition req->complete != rtk_hsotg_complete_setup says:
+		 * send ZLP when we have an asynchronous request from gadget
+		 */
+		if (!was_setup && req->complete != rtk_hsotg_complete_setup)
+			rtk_hsotg_send_zlp(hsotg, hs_req);
+	}
+
+	rtk_hsotg_complete_request(hsotg, hs_ep, hs_req, result);
+}
+
+/**
+ * rtk_hsotg_read_frameno - read current frame number
+ * @hsotg: The device instance
+ *
+ * Return the current frame number
+ */
+static u32 rtk_hsotg_read_frameno(struct rtk_hsotg *hsotg)
+{
+	u32 dsts;
+
+	dsts = readl(hsotg->regs + DSTS);
+	dsts &= DSTS_SOFFN_MASK;
+	dsts >>= DSTS_SOFFN_SHIFT;
+
+	return dsts;
+}
+
+/**
+ * rtk_hsotg_handle_rx - RX FIFO has data
+ * @hsotg: The device instance
+ *
+ * The IRQ handler has detected that the RX FIFO has some data in it
+ * that requires processing, so find out what is in there and do the
+ * appropriate read.
+ *
+ * The RXFIFO is a true FIFO, the packets coming out are still in packet
+ * chunks, so if you have x packets received on an endpoint you'll get x
+ * FIFO events delivered, each with a packet's worth of data in it.
+ *
+ * When using DMA, we should not be processing events from the RXFIFO
+ * as the actual data should be sent to the memory directly and we turn
+ * on the completion interrupts to get notifications of transfer completion.
+ */
+static void rtk_hsotg_handle_rx(struct rtk_hsotg *hsotg)
+{
+	u32 grxstsr = readl(hsotg->regs + GRXSTSP);
+	u32 epnum, status, size;
+
+	WARN_ON(using_dma(hsotg));
+
+	epnum = grxstsr & GRXSTS_EPNum_MASK;
+	status = grxstsr & GRXSTS_PktSts_MASK;
+
+	size = grxstsr & GRXSTS_ByteCnt_MASK;
+	size >>= GRXSTS_ByteCnt_SHIFT;
+
+	if (1)
+		dev_dbg(hsotg->dev, "%s: GRXSTSP=0x%08x (%d@%d)\n",
+			__func__, grxstsr, size, epnum);
+
+#define __status(x) ((x) >> GRXSTS_PktSts_SHIFT)
+
+	switch (status >> GRXSTS_PktSts_SHIFT) {
+	case __status(GRXSTS_PktSts_GlobalOutNAK):
+		dev_dbg(hsotg->dev, "GlobalOutNAK\n");
+		break;
+
+	case __status(GRXSTS_PktSts_OutDone):
+		dev_dbg(hsotg->dev, "OutDone (Frame=0x%08x)\n",
+			rtk_hsotg_read_frameno(hsotg));
+
+		if (!using_dma(hsotg))
+			rtk_hsotg_handle_outdone(hsotg, epnum, false);
+		break;
+
+	case __status(GRXSTS_PktSts_SetupDone):
+		dev_dbg(hsotg->dev,
+			"SetupDone (Frame=0x%08x, DOPEPCTL=0x%08x)\n",
+			rtk_hsotg_read_frameno(hsotg),
+			readl(hsotg->regs + DOEPCTL(0)));
+
+		rtk_hsotg_handle_outdone(hsotg, epnum, true);
+		break;
+
+	case __status(GRXSTS_PktSts_OutRX):
+		rtk_hsotg_rx_data(hsotg, epnum, size);
+		break;
+
+	case __status(GRXSTS_PktSts_SetupRX):
+		dev_dbg(hsotg->dev,
+			"SetupRX (Frame=0x%08x, DOPEPCTL=0x%08x)\n",
+			rtk_hsotg_read_frameno(hsotg),
+			readl(hsotg->regs + DOEPCTL(0)));
+
+		rtk_hsotg_rx_data(hsotg, epnum, size);
+		break;
+
+	default:
+		dev_warn(hsotg->dev, "%s: unknown status %08x\n",
+			 __func__, grxstsr);
+
+		rtk_hsotg_dump(hsotg);
+		break;
+	}
+}
+
+/**
+ * rtk_hsotg_ep0_mps - turn max packet size into register setting
+ * @mps: The maximum packet size in bytes.
+ */
+static u32 rtk_hsotg_ep0_mps(unsigned int mps)
+{
+	switch (mps) {
+	case 64:
+		return D0EPCTL_MPS_64;
+	case 32:
+		return D0EPCTL_MPS_32;
+	case 16:
+		return D0EPCTL_MPS_16;
+	case 8:
+		return D0EPCTL_MPS_8;
+	}
+
+	/* bad max packet size, warn and return invalid result */
+	WARN_ON(1);
+	return (u32)-1;
+}
+
+/**
+ * rtk_hsotg_set_ep_maxpacket - set endpoint's max-packet field
+ * @hsotg: The driver state.
+ * @ep: The index number of the endpoint
+ * @mps: The maximum packet size in bytes
+ *
+ * Configure the maximum packet size for the given endpoint, updating
+ * the hardware control registers to reflect this.
+ */
+static void rtk_hsotg_set_ep_maxpacket(struct rtk_hsotg *hsotg,
+				       unsigned int ep, unsigned int mps)
+{
+	struct rtk_hsotg_ep *hs_ep = &hsotg->eps[ep];
+	void __iomem *regs = hsotg->regs;
+	u32 mpsval;
+	u32 mcval;
+	u32 reg;
+
+	if (ep == 0) {
+		/* EP0 is a special case */
+		mpsval = rtk_hsotg_ep0_mps(mps);
+		if (mpsval > 3)
+			goto bad_mps;
+		hs_ep->ep.maxpacket = mps;
+		hs_ep->mc = 1;
+	} else {
+		mpsval = mps & DxEPCTL_MPS_MASK;
+		if (mpsval > 1024)
+			goto bad_mps;
+		mcval = ((mps >> 11) & 0x3) + 1;
+		hs_ep->mc = mcval;
+		if (mcval > 3)
+			goto bad_mps;
+		hs_ep->ep.maxpacket = mpsval;
+	}
+
+	/*
+	 * update both the in and out endpoint controldir_ registers, even
+	 * if one of the directions may not be in use.
+	 */
+
+	reg = readl(regs + DIEPCTL(ep));
+	reg &= ~DxEPCTL_MPS_MASK;
+	reg |= mpsval;
+	writel(reg, regs + DIEPCTL(ep));
+
+	if (ep) {
+		reg = readl(regs + DOEPCTL(ep));
+		reg &= ~DxEPCTL_MPS_MASK;
+		reg |= mpsval;
+		writel(reg, regs + DOEPCTL(ep));
+	}
+
+	return;
+
+bad_mps:
+	dev_err(hsotg->dev, "ep%d: bad mps of %d\n", ep, mps);
+}
+
+/**
+ * rtk_hsotg_txfifo_flush - flush Tx FIFO
+ * @hsotg: The driver state
+ * @idx: The index for the endpoint (0..15)
+ */
+static void rtk_hsotg_txfifo_flush(struct rtk_hsotg *hsotg, unsigned int idx)
+{
+	int timeout;
+	int val;
+
+	writel(GRSTCTL_TxFNum(idx) | GRSTCTL_TxFFlsh,
+		hsotg->regs + GRSTCTL);
+
+	/* wait until the fifo is flushed */
+	timeout = 100;
+
+	while (1) {
+		val = readl(hsotg->regs + GRSTCTL);
+
+		if ((val & (GRSTCTL_TxFFlsh)) == 0)
+			break;
+
+		if (--timeout == 0) {
+			dev_err(hsotg->dev,
+				"%s: timeout flushing fifo (GRSTCTL=%08x)\n",
+				__func__, val);
+		}
+
+		udelay(1);
+	}
+}
+
+/**
+ * rtk_hsotg_trytx - check to see if anything needs transmitting
+ * @hsotg: The driver state
+ * @hs_ep: The driver endpoint to check.
+ *
+ * Check to see if there is a request that has data to send, and if so
+ * make an attempt to write data into the FIFO.
+ */
+static int rtk_hsotg_trytx(struct rtk_hsotg *hsotg,
+			   struct rtk_hsotg_ep *hs_ep)
+{
+	struct rtk_hsotg_req *hs_req = hs_ep->req;
+
+	if (!hs_ep->dir_in || !hs_req) {
+		/**
+		 * if request is not enqueued, we disable interrupts
+		 * for endpoints, excepting ep0
+		 */
+		if (hs_ep->index != 0)
+			rtk_hsotg_ctrl_epint(hsotg, hs_ep->index,
+					     hs_ep->dir_in, 0);
+		return 0;
+	}
+
+	if (hs_req->req.actual < hs_req->req.length) {
+		dev_dbg(hsotg->dev, "trying to write more for ep%d\n",
+			hs_ep->index);
+		return rtk_hsotg_write_fifo(hsotg, hs_ep, hs_req);
+	}
+
+	return 0;
+}
+
+/**
+ * rtk_hsotg_complete_in - complete IN transfer
+ * @hsotg: The device state.
+ * @hs_ep: The endpoint that has just completed.
+ *
+ * An IN transfer has been completed, update the transfer's state and then
+ * call the relevant completion routines.
+ */
+static void rtk_hsotg_complete_in(struct rtk_hsotg *hsotg,
+				  struct rtk_hsotg_ep *hs_ep)
+{
+	struct rtk_hsotg_req *hs_req = hs_ep->req;
+	u32 epsize = readl(hsotg->regs + DIEPTSIZ(hs_ep->index));
+	int size_left, size_done;
+
+	if (!hs_req) {
+		dev_dbg(hsotg->dev, "XferCompl but no req\n");
+		return;
+	}
+
+	/* Finish ZLP handling for IN EP0 transactions */
+	if (hsotg->eps[0].sent_zlp) {
+		dev_dbg(hsotg->dev, "zlp packet received\n");
+		rtk_hsotg_complete_request(hsotg, hs_ep, hs_req, 0);
+		return;
+	}
+
+	/*
+	 * Calculate the size of the transfer by checking how much is left
+	 * in the endpoint size register and then working it out from
+	 * the amount we loaded for the transfer.
+	 *
+	 * We do this even for DMA, as the transfer may have incremented
+	 * past the end of the buffer (DMA transfers are always 32bit
+	 * aligned).
+	 */
+
+	size_left = DxEPTSIZ_XferSize_GET(epsize);
+
+	size_done = hs_ep->size_loaded - size_left;
+	size_done += hs_ep->last_load;
+
+	if (hs_req->req.actual != size_done)
+		dev_dbg(hsotg->dev, "%s: adjusting size done %d => %d\n",
+			__func__, hs_req->req.actual, size_done);
+
+	hs_req->req.actual = size_done;
+	dev_dbg(hsotg->dev, "req->length:%d req->actual:%d req->zero:%d\n",
+		hs_req->req.length, hs_req->req.actual, hs_req->req.zero);
+
+	/*
+	 * Check if dealing with Maximum Packet Size(MPS) IN transfer at EP0
+	 * When sent data is a multiple MPS size (e.g. 64B ,128B ,192B
+	 * ,256B ... ), after last MPS sized packet send IN ZLP packet to
+	 * inform the host that no more data is available.
+	 * The state of req.zero member is checked to be sure that the value to
+	 * send is smaller than wValue expected from host.
+	 * Check req.length to NOT send another ZLP when the current one is
+	 * under completion (the one for which this completion has been called).
+	 */
+	if (hs_req->req.length && hs_ep->index == 0 && hs_req->req.zero &&
+	    hs_req->req.length == hs_req->req.actual &&
+	    !(hs_req->req.length % hs_ep->ep.maxpacket)) {
+
+		dev_dbg(hsotg->dev, "ep0 zlp IN packet sent\n");
+		rtk_hsotg_send_zlp(hsotg, hs_req);
+
+		return;
+	}
+
+	if (!size_left && hs_req->req.actual < hs_req->req.length) {
+		dev_dbg(hsotg->dev, "%s trying more for req...\n", __func__);
+		rtk_hsotg_start_req(hsotg, hs_ep, hs_req, true);
+	} else
+		rtk_hsotg_complete_request(hsotg, hs_ep, hs_req, 0);
+}
+
+/**
+ * rtk_hsotg_epint - handle an in/out endpoint interrupt
+ * @hsotg: The driver state
+ * @idx: The index for the endpoint (0..15)
+ * @dir_in: Set if this is an IN endpoint
+ *
+ * Process and clear any interrupt pending for an individual endpoint
+ */
+static void rtk_hsotg_epint(struct rtk_hsotg *hsotg, unsigned int idx,
+			    int dir_in)
+{
+	struct rtk_hsotg_ep *hs_ep = &hsotg->eps[idx];
+	u32 epint_reg = dir_in ? DIEPINT(idx) : DOEPINT(idx);
+	u32 epctl_reg = dir_in ? DIEPCTL(idx) : DOEPCTL(idx);
+	u32 epsiz_reg = dir_in ? DIEPTSIZ(idx) : DOEPTSIZ(idx);
+	u32 ints;
+	u32 ctrl;
+
+	ints = readl(hsotg->regs + epint_reg);
+	ctrl = readl(hsotg->regs + epctl_reg);
+
+	/* Clear endpoint interrupts */
+	writel(ints, hsotg->regs + epint_reg);
+
+	dev_dbg(hsotg->dev, "%s: ep%d(%s) DxEPINT=0x%08x\n",
+		__func__, idx, dir_in ? "in" : "out", ints);
+
+	if (ints & DxEPINT_XferCompl) {
+		if (hs_ep->isochronous && hs_ep->interval == 1) {
+			if (ctrl & DxEPCTL_EOFrNum)
+				ctrl |= DxEPCTL_SetEvenFr;
+			else
+				ctrl |= DxEPCTL_SetOddFr;
+			writel(ctrl, hsotg->regs + epctl_reg);
+		}
+
+		dev_dbg(hsotg->dev,
+			"%s: XferCompl: DxEPCTL=0x%08x, DxEPTSIZ=%08x\n",
+			__func__, readl(hsotg->regs + epctl_reg),
+			readl(hsotg->regs + epsiz_reg));
+
+		/*
+		 * we get OutDone from the FIFO, so we only need to look
+		 * at completing IN requests here
+		 */
+		if (dir_in) {
+			rtk_hsotg_complete_in(hsotg, hs_ep);
+
+			if (idx == 0 && !hs_ep->req)
+				rtk_hsotg_enqueue_setup(hsotg);
+		} else if (using_dma(hsotg)) {
+			/*
+			 * We're using DMA, we need to fire an OutDone here
+			 * as we ignore the RXFIFO.
+			 */
+
+			rtk_hsotg_handle_outdone(hsotg, idx, false);
+		}
+	}
+
+	if (ints & DxEPINT_EPDisbld) {
+		dev_dbg(hsotg->dev, "%s: EPDisbld\n", __func__);
+
+		if (dir_in) {
+			int epctl = readl(hsotg->regs + epctl_reg);
+
+			rtk_hsotg_txfifo_flush(hsotg, idx);
+
+			if ((epctl & DxEPCTL_Stall) &&
+				(epctl & DxEPCTL_EPType_Bulk)) {
+				int dctl = readl(hsotg->regs + DCTL);
+
+				dctl |= DCTL_CGNPInNAK;
+				writel(dctl, hsotg->regs + DCTL);
+			}
+		}
+	}
+
+	if (ints & DxEPINT_AHBErr)
+		dev_dbg(hsotg->dev, "%s: AHBErr\n", __func__);
+
+	if (ints & DxEPINT_Setup) {  /* Setup or Timeout */
+		dev_dbg(hsotg->dev, "%s: Setup/Timeout\n",  __func__);
+
+		if (using_dma(hsotg) && idx == 0) {
+			/*
+			 * this is the notification we've received a
+			 * setup packet. In non-DMA mode we'd get this
+			 * from the RXFIFO, instead we need to process
+			 * the setup here.
+			 */
+
+			if (dir_in)
+				WARN_ON_ONCE(1);
+			else
+				rtk_hsotg_handle_outdone(hsotg, 0, true);
+		}
+	}
+
+	if (ints & DxEPINT_Back2BackSetup)
+		dev_dbg(hsotg->dev, "%s: B2BSetup/INEPNakEff\n", __func__);
+
+	if (dir_in && !hs_ep->isochronous) {
+		/* not sure if this is important, but we'll clear it anyway */
+		if (ints & DIEPMSK_INTknTXFEmpMsk) {
+			dev_dbg(hsotg->dev, "%s: ep%d: INTknTXFEmpMsk\n",
+				__func__, idx);
+		}
+
+		/* this probably means something bad is happening */
+		if (ints & DIEPMSK_INTknEPMisMsk) {
+			dev_warn(hsotg->dev, "%s: ep%d: INTknEP\n",
+				 __func__, idx);
+		}
+
+		/* FIFO has space or is empty (see GAHBCFG) */
+		if (hsotg->dedicated_fifos &&
+		    ints & DIEPMSK_TxFIFOEmpty) {
+			dev_dbg(hsotg->dev, "%s: ep%d: TxFIFOEmpty\n",
+				__func__, idx);
+			if (!using_dma(hsotg))
+				rtk_hsotg_trytx(hsotg, hs_ep);
+		}
+	}
+}
+
+/**
+ * rtk_hsotg_irq_enumdone - Handle EnumDone interrupt (enumeration done)
+ * @hsotg: The device state.
+ *
+ * Handle updating the device settings after the enumeration phase has
+ * been completed.
+ */
+static void rtk_hsotg_irq_enumdone(struct rtk_hsotg *hsotg)
+{
+	u32 dsts = readl(hsotg->regs + DSTS);
+	int ep0_mps = 0, ep_mps;
+
+	/*
+	 * This should signal the finish of the enumeration phase
+	 * of the USB handshaking, so we should now know what rate
+	 * we connected at.
+	 */
+
+	dev_dbg(hsotg->dev, "EnumDone (DSTS=0x%08x)\n", dsts);
+
+	/*
+	 * note, since we're limited by the size of transfer on EP0, and
+	 * it seems IN transfers must be a even number of packets we do
+	 * not advertise a 64byte MPS on EP0.
+	 */
+
+	/* catch both EnumSpd_FS and EnumSpd_FS48 */
+	switch (dsts & DSTS_EnumSpd_MASK) {
+	case DSTS_EnumSpd_FS:
+	case DSTS_EnumSpd_FS48:
+		hsotg->gadget.speed = USB_SPEED_FULL;
+		ep0_mps = EP0_MPS_LIMIT;
+		ep_mps = 1023;
+	//	ep_mps = 64;	//barry
+		break;
+
+	case DSTS_EnumSpd_HS:
+		hsotg->gadget.speed = USB_SPEED_HIGH;
+		ep0_mps = EP0_MPS_LIMIT;
+		ep_mps = 1024;
+	//	ep_mps = 512;	//barry
+		break;
+
+	case DSTS_EnumSpd_LS:
+		hsotg->gadget.speed = USB_SPEED_LOW;
+		/*
+		 * note, we don't actually support LS in this driver at the
+		 * moment, and the documentation seems to imply that it isn't
+		 * supported by the PHYs on some of the devices.
+		 */
+		break;
+	}
+	dev_info(hsotg->dev, "new device is %s\n",
+		 usb_speed_string(hsotg->gadget.speed));
+
+	/*
+	 * we should now know the maximum packet size for an
+	 * endpoint, so set the endpoints to a default value.
+	 */
+
+	if (ep0_mps) {
+		int i;
+		rtk_hsotg_set_ep_maxpacket(hsotg, 0, ep0_mps);
+		for (i = 1; i < hsotg->num_of_eps; i++)
+			rtk_hsotg_set_ep_maxpacket(hsotg, i, ep_mps);
+	}
+
+	/* ensure after enumeration our EP0 is active */
+
+	rtk_hsotg_enqueue_setup(hsotg);
+
+	dev_dbg(hsotg->dev, "EP0: DIEPCTL0=0x%08x, DOEPCTL0=0x%08x\n",
+		readl(hsotg->regs + DIEPCTL0),
+		readl(hsotg->regs + DOEPCTL0));
+}
+
+/**
+ * kill_all_requests - remove all requests from the endpoint's queue
+ * @hsotg: The device state.
+ * @ep: The endpoint the requests may be on.
+ * @result: The result code to use.
+ * @force: Force removal of any current requests
+ *
+ * Go through the requests on the given endpoint and mark them
+ * completed with the given result code.
+ */
+static void kill_all_requests(struct rtk_hsotg *hsotg,
+			      struct rtk_hsotg_ep *ep,
+			      int result, bool force)
+{
+	struct rtk_hsotg_req *req, *treq;
+
+	list_for_each_entry_safe(req, treq, &ep->queue, queue) {
+		/*
+		 * currently, we can't do much about an already
+		 * running request on an in endpoint
+		 */
+
+		if (ep->req == req && ep->dir_in && !force)
+			continue;
+
+		rtk_hsotg_complete_request(hsotg, ep, req,
+					   result);
+	}
+	if(hsotg->dedicated_fifos)
+		if ((readl(hsotg->regs + DTXFSTS(ep->index)) & 0xffff) * 4 < 3072)
+			rtk_hsotg_txfifo_flush(hsotg, ep->index);
+}
+
+#define call_gadget(_hs, _entry) \
+do { \
+	if ((_hs)->gadget.speed != USB_SPEED_UNKNOWN &&	\
+	    (_hs)->driver && (_hs)->driver->_entry) { \
+		spin_unlock(&_hs->lock); \
+		(_hs)->driver->_entry(&(_hs)->gadget); \
+		spin_lock(&_hs->lock); \
+	} \
+} while (0)
+
+/**
+ * rtk_hsotg_disconnect - disconnect service
+ * @hsotg: The device state.
+ *
+ * The device has been disconnected. Remove all current
+ * transactions and signal the gadget driver that this
+ * has happened.
+ */
+static void rtk_hsotg_disconnect(struct rtk_hsotg *hsotg)
+{
+	unsigned ep;
+
+	for (ep = 0; ep < hsotg->num_of_eps; ep++)
+		kill_all_requests(hsotg, &hsotg->eps[ep], -ESHUTDOWN, true);
+
+	call_gadget(hsotg, disconnect);
+}
+
+/**
+ * rtk_hsotg_irq_fifoempty - TX FIFO empty interrupt handler
+ * @hsotg: The device state:
+ * @periodic: True if this is a periodic FIFO interrupt
+ */
+static void rtk_hsotg_irq_fifoempty(struct rtk_hsotg *hsotg, bool periodic)
+{
+	struct rtk_hsotg_ep *ep;
+	int epno, ret;
+
+	/* look through for any more data to transmit */
+
+	for (epno = 0; epno < hsotg->num_of_eps; epno++) {
+		ep = &hsotg->eps[epno];
+
+		if (!ep->dir_in)
+			continue;
+
+		if ((periodic && !ep->periodic) ||
+		    (!periodic && ep->periodic))
+			continue;
+
+		ret = rtk_hsotg_trytx(hsotg, ep);
+		if (ret < 0)
+			break;
+	}
+}
+
+/* IRQ flags which will trigger a retry around the IRQ loop */
+#define IRQ_RETRY_MASK (GINTSTS_NPTxFEmp | \
+			GINTSTS_PTxFEmp |  \
+			GINTSTS_RxFLvl)
+
+/**
+ * rtk_hsotg_corereset - issue softreset to the core
+ * @hsotg: The device state
+ *
+ * Issue a soft reset to the core, and await the core finishing it.
+ */
+static int rtk_hsotg_corereset(struct rtk_hsotg *hsotg)
+{
+	int timeout;
+	u32 grstctl;
+
+	dev_dbg(hsotg->dev, "resetting core\n");
+
+	/* issue soft reset */
+	writel(GRSTCTL_CSftRst, hsotg->regs + GRSTCTL);
+
+	timeout = 10000;
+	do {
+		grstctl = readl(hsotg->regs + GRSTCTL);
+	} while ((grstctl & GRSTCTL_CSftRst) && timeout-- > 0);
+
+	if (grstctl & GRSTCTL_CSftRst) {
+		dev_err(hsotg->dev, "Failed to get CSftRst asserted\n");
+		return -EINVAL;
+	}
+
+	timeout = 10000;
+
+	while (1) {
+		u32 grstctl = readl(hsotg->regs + GRSTCTL);
+
+		if (timeout-- < 0) {
+			dev_info(hsotg->dev,
+				 "%s: reset failed, GRSTCTL=%08x\n",
+				 __func__, grstctl);
+			return -ETIMEDOUT;
+		}
+
+		if (!(grstctl & GRSTCTL_AHBIdle))
+			continue;
+
+		break;		/* reset done */
+	}
+
+	dev_dbg(hsotg->dev, "reset successful\n");
+	return 0;
+}
+
+/**
+ * rtk_hsotg_core_init - issue softreset to the core
+ * @hsotg: The device state
+ *
+ * Issue a soft reset to the core, and await the core finishing it.
+ */
+static void rtk_hsotg_core_init(struct rtk_hsotg *hsotg)
+{
+	rtk_hsotg_corereset(hsotg);
+
+	/*
+	 * we must now enable ep0 ready for host detection and then
+	 * set configuration.
+	 */
+
+	/* set the PLL on, remove the HNP/SRP and set the PHY */
+	writel(hsotg->phyif | GUSBCFG_TOutCal(7) |
+	       (0x5 << 10), hsotg->regs + GUSBCFG);
+	mdelay(100);
+
+	rtk_hsotg_init_fifo(hsotg);
+
+	__orr32(hsotg->regs + DCTL, DCTL_SftDiscon);
+
+	writel(1 << 18 | DCFG_DevSpd_HS,  hsotg->regs + DCFG);
+
+	/* Clear any pending OTG interrupts */
+	writel(0xffffffff, hsotg->regs + GOTGINT);
+
+	/* Clear any pending interrupts */
+	writel(0xffffffff, hsotg->regs + GINTSTS);
+
+	writel(GINTSTS_ErlySusp | GINTSTS_SessReqInt |
+	       GINTSTS_GOUTNakEff | GINTSTS_GINNakEff |
+	       GINTSTS_ConIDStsChng | GINTSTS_USBRst |
+	       GINTSTS_EnumDone | GINTSTS_OTGInt |
+	       GINTSTS_USBSusp | GINTSTS_WkUpInt,
+	       hsotg->regs + GINTMSK);
+
+	if (using_dma(hsotg))
+		writel(GAHBCFG_GlblIntrEn | GAHBCFG_DMAEn |
+		       GAHBCFG_HBstLen_Incr4,
+		       hsotg->regs + GAHBCFG);
+	else
+		writel(((hsotg->dedicated_fifos) ? (GAHBCFG_NPTxFEmpLvl |
+						    GAHBCFG_PTxFEmpLvl) : 0) |
+		       GAHBCFG_GlblIntrEn,
+		       hsotg->regs + GAHBCFG);
+
+	/*
+	 * If INTknTXFEmpMsk is enabled, it's important to disable ep interrupts
+	 * when we have no data to transfer. Otherwise we get being flooded by
+	 * interrupts.
+	 */
+
+	writel(((hsotg->dedicated_fifos) ? DIEPMSK_TxFIFOEmpty |
+	       DIEPMSK_INTknTXFEmpMsk : 0) |
+	       DIEPMSK_EPDisbldMsk | DIEPMSK_XferComplMsk |
+	       DIEPMSK_TimeOUTMsk | DIEPMSK_AHBErrMsk |
+	       DIEPMSK_INTknEPMisMsk,
+	       hsotg->regs + DIEPMSK);
+
+	/*
+	 * don't need XferCompl, we get that from RXFIFO in slave mode. In
+	 * DMA mode we may need this.
+	 */
+	writel((using_dma(hsotg) ? (DIEPMSK_XferComplMsk |
+				    DIEPMSK_TimeOUTMsk) : 0) |
+	       DOEPMSK_EPDisbldMsk | DOEPMSK_AHBErrMsk |
+	       DOEPMSK_SetupMsk,
+	       hsotg->regs + DOEPMSK);
+
+	writel(0, hsotg->regs + DAINTMSK);
+
+	dev_dbg(hsotg->dev, "EP0: DIEPCTL0=0x%08x, DOEPCTL0=0x%08x\n",
+		readl(hsotg->regs + DIEPCTL0),
+		readl(hsotg->regs + DOEPCTL0));
+
+	/* enable in and out endpoint interrupts */
+	rtk_hsotg_en_gsint(hsotg, GINTSTS_OEPInt | GINTSTS_IEPInt);
+
+	/*
+	 * Enable the RXFIFO when in slave mode, as this is how we collect
+	 * the data. In DMA mode, we get events from the FIFO but also
+	 * things we cannot process, so do not use it.
+	 */
+	if (!using_dma(hsotg))
+		rtk_hsotg_en_gsint(hsotg, GINTSTS_RxFLvl);
+
+	/* Enable interrupts for EP0 in and out */
+	rtk_hsotg_ctrl_epint(hsotg, 0, 0, 1);
+	rtk_hsotg_ctrl_epint(hsotg, 0, 1, 1);
+
+	__orr32(hsotg->regs + DCTL, DCTL_PWROnPrgDone);
+	udelay(10);  /* see openiboot */
+	__bic32(hsotg->regs + DCTL, DCTL_PWROnPrgDone);
+
+	dev_dbg(hsotg->dev, "DCTL=0x%08x\n", readl(hsotg->regs + DCTL));
+
+	/*
+	 * DxEPCTL_USBActEp says RO in manual, but seems to be set by
+	 * writing to the EPCTL register..
+	 */
+
+	/* set to read 1 8byte packet */
+	writel(DxEPTSIZ_MC(1) | DxEPTSIZ_PktCnt(1) |
+	       DxEPTSIZ_XferSize(8), hsotg->regs + DOEPTSIZ0);
+
+	writel(rtk_hsotg_ep0_mps(hsotg->eps[0].ep.maxpacket) |
+	       DxEPCTL_CNAK | DxEPCTL_EPEna |
+	       DxEPCTL_USBActEp,
+	       hsotg->regs + DOEPCTL0);
+
+	/* enable, but don't activate EP0in */
+	writel(rtk_hsotg_ep0_mps(hsotg->eps[0].ep.maxpacket) |
+	       DxEPCTL_USBActEp, hsotg->regs + DIEPCTL0);
+
+	rtk_hsotg_enqueue_setup(hsotg);
+
+	dev_dbg(hsotg->dev, "EP0: DIEPCTL0=0x%08x, DOEPCTL0=0x%08x\n",
+		readl(hsotg->regs + DIEPCTL0),
+		readl(hsotg->regs + DOEPCTL0));
+
+	/* clear global NAKs */
+	writel(DCTL_CGOUTNak | DCTL_CGNPInNAK,
+	       hsotg->regs + DCTL);
+
+	/* must be at-least 3ms to allow bus to see disconnect */
+	mdelay(3);
+
+	/* remove the soft-disconnect and let's go */
+	__bic32(hsotg->regs + DCTL, DCTL_SftDiscon);
+}
+
+/**
+ * rtk_hsotg_irq - handle device interrupt
+ * @irq: The IRQ number triggered
+ * @pw: The pw value when registered the handler.
+ */
+static irqreturn_t rtk_hsotg_irq(int irq, void *pw)
+{
+	struct rtk_hsotg *hsotg = pw;
+	int retry_count = 8;
+	u32 gintsts;
+	u32 gintmsk;
+
+	spin_lock(&hsotg->lock);
+irq_retry:
+	gintsts = readl(hsotg->regs + GINTSTS);
+	gintmsk = readl(hsotg->regs + GINTMSK);
+
+	dev_dbg(hsotg->dev, "%s: %08x %08x (%08x) retry %d\n",
+		__func__, gintsts, gintsts & gintmsk, gintmsk, retry_count);
+
+	gintsts &= gintmsk;
+
+	if (gintsts & GINTSTS_OTGInt) {
+		u32 otgint = readl(hsotg->regs + GOTGINT);
+
+		dev_info(hsotg->dev, "OTGInt: %08x\n", otgint);
+
+		writel(otgint, hsotg->regs + GOTGINT);
+	}
+
+	if (gintsts & GINTSTS_SessReqInt) {
+		dev_dbg(hsotg->dev, "%s: SessReqInt\n", __func__);
+		writel(GINTSTS_SessReqInt, hsotg->regs + GINTSTS);
+	}
+
+	if (gintsts & GINTSTS_EnumDone) {
+		writel(GINTSTS_EnumDone, hsotg->regs + GINTSTS);
+
+		rtk_hsotg_irq_enumdone(hsotg);
+	}
+
+	if (gintsts & GINTSTS_ConIDStsChng) {
+		dev_dbg(hsotg->dev, "ConIDStsChg (DSTS=0x%08x, GOTCTL=%08x)\n",
+			readl(hsotg->regs + DSTS),
+			readl(hsotg->regs + GOTGCTL));
+
+		writel(GINTSTS_ConIDStsChng, hsotg->regs + GINTSTS);
+	}
+
+	if (gintsts & (GINTSTS_OEPInt | GINTSTS_IEPInt)) {
+		u32 daint = readl(hsotg->regs + DAINT);
+		u32 daintmsk = readl(hsotg->regs + DAINTMSK);
+		u32 daint_out, daint_in;
+		int ep;
+
+		daint &= daintmsk;
+		daint_out = daint >> DAINT_OutEP_SHIFT;
+		daint_in = daint & ~(daint_out << DAINT_OutEP_SHIFT);
+
+		dev_dbg(hsotg->dev, "%s: daint=%08x\n", __func__, daint);
+
+		for (ep = 0; ep < 15 && daint_out; ep++, daint_out >>= 1) {
+			if (daint_out & 1)
+				rtk_hsotg_epint(hsotg, ep, 0);
+		}
+
+		for (ep = 0; ep < 15 && daint_in; ep++, daint_in >>= 1) {
+			if (daint_in & 1)
+				rtk_hsotg_epint(hsotg, ep, 1);
+		}
+	}
+
+	if (gintsts & GINTSTS_USBRst) {
+
+		u32 usb_status = readl(hsotg->regs + GOTGCTL);
+
+		dev_info(hsotg->dev, "%s: USBRst\n", __func__);
+		dev_dbg(hsotg->dev, "GNPTXSTS=%08x\n",
+			readl(hsotg->regs + GNPTXSTS));
+
+		writel(GINTSTS_USBRst, hsotg->regs + GINTSTS);
+
+		if (usb_status & GOTGCTL_BSESVLD) {
+			if (time_after(jiffies, hsotg->last_rst +
+				       msecs_to_jiffies(200))) {
+
+				kill_all_requests(hsotg, &hsotg->eps[0],
+							  -ECONNRESET, true);
+
+				rtk_hsotg_core_init(hsotg);
+				hsotg->last_rst = jiffies;
+			}
+		}
+	}
+
+	/* check both FIFOs */
+
+	if (gintsts & GINTSTS_NPTxFEmp) {
+		dev_dbg(hsotg->dev, "NPTxFEmp\n");
+
+		/*
+		 * Disable the interrupt to stop it happening again
+		 * unless one of these endpoint routines decides that
+		 * it needs re-enabling
+		 */
+
+		rtk_hsotg_disable_gsint(hsotg, GINTSTS_NPTxFEmp);
+		rtk_hsotg_irq_fifoempty(hsotg, false);
+	}
+
+	if (gintsts & GINTSTS_PTxFEmp) {
+		dev_dbg(hsotg->dev, "PTxFEmp\n");
+
+		/* See note in GINTSTS_NPTxFEmp */
+
+		rtk_hsotg_disable_gsint(hsotg, GINTSTS_PTxFEmp);
+		rtk_hsotg_irq_fifoempty(hsotg, true);
+	}
+
+	if (gintsts & GINTSTS_RxFLvl) {
+		/*
+		 * note, since GINTSTS_RxFLvl doubles as FIFO-not-empty,
+		 * we need to retry rtk_hsotg_handle_rx if this is still
+		 * set.
+		 */
+
+		rtk_hsotg_handle_rx(hsotg);
+	}
+
+	if (gintsts & GINTSTS_ModeMis) {
+		dev_warn(hsotg->dev, "warning, mode mismatch triggered\n");
+		writel(GINTSTS_ModeMis, hsotg->regs + GINTSTS);
+	}
+
+	if (gintsts & GINTSTS_USBSusp) {
+		dev_info(hsotg->dev, "GINTSTS_USBSusp\n");
+		writel(GINTSTS_USBSusp, hsotg->regs + GINTSTS);
+
+		call_gadget(hsotg, suspend);
+	}
+
+	if (gintsts & GINTSTS_WkUpInt) {
+		dev_info(hsotg->dev, "GINTSTS_WkUpIn\n");
+		writel(GINTSTS_WkUpInt, hsotg->regs + GINTSTS);
+
+		call_gadget(hsotg, resume);
+	}
+
+	if (gintsts & GINTSTS_ErlySusp) {
+		dev_dbg(hsotg->dev, "GINTSTS_ErlySusp\n");
+		writel(GINTSTS_ErlySusp, hsotg->regs + GINTSTS);
+	}
+
+	/*
+	 * these next two seem to crop-up occasionally causing the core
+	 * to shutdown the USB transfer, so try clearing them and logging
+	 * the occurrence.
+	 */
+
+	if (gintsts & GINTSTS_GOUTNakEff) {
+		dev_info(hsotg->dev, "GOUTNakEff triggered\n");
+
+		writel(DCTL_CGOUTNak, hsotg->regs + DCTL);
+
+		rtk_hsotg_dump(hsotg);
+	}
+
+	if (gintsts & GINTSTS_GINNakEff) {
+		dev_info(hsotg->dev, "GINNakEff triggered\n");
+
+		writel(DCTL_CGNPInNAK, hsotg->regs + DCTL);
+
+		rtk_hsotg_dump(hsotg);
+	}
+
+	/*
+	 * if we've had fifo events, we should try and go around the
+	 * loop again to see if there's any point in returning yet.
+	 */
+
+	if (gintsts & IRQ_RETRY_MASK && --retry_count > 0)
+			goto irq_retry;
+
+	spin_unlock(&hsotg->lock);
+
+	return IRQ_HANDLED;
+}
+
+/**
+ * rtk_hsotg_ep_enable - enable the given endpoint
+ * @ep: The USB endpint to configure
+ * @desc: The USB endpoint descriptor to configure with.
+ *
+ * This is called from the USB gadget code's usb_ep_enable().
+ */
+static int rtk_hsotg_ep_enable(struct usb_ep *ep,
+			       const struct usb_endpoint_descriptor *desc)
+{
+	struct rtk_hsotg_ep *hs_ep = our_ep(ep);
+	struct rtk_hsotg *hsotg = hs_ep->parent;
+	unsigned long flags;
+	int index = hs_ep->index;
+	u32 epctrl_reg;
+	u32 epctrl;
+	u32 mps;
+	int dir_in;
+	int ret = 0;
+
+	dev_dbg(hsotg->dev,
+		"%s: ep %s: a 0x%02x, attr 0x%02x, mps 0x%04x, intr %d\n",
+		__func__, ep->name, desc->bEndpointAddress, desc->bmAttributes,
+		desc->wMaxPacketSize, desc->bInterval);
+
+	/* not to be called for EP0 */
+	WARN_ON(index == 0);
+
+	dir_in = (desc->bEndpointAddress & USB_ENDPOINT_DIR_MASK) ? 1 : 0;
+	if (dir_in != hs_ep->dir_in) {
+		dev_err(hsotg->dev, "%s: direction mismatch!\n", __func__);
+		return -EINVAL;
+	}
+
+	mps = usb_endpoint_maxp(desc);
+
+	/* note, we handle this here instead of rtk_hsotg_set_ep_maxpacket */
+
+	epctrl_reg = dir_in ? DIEPCTL(index) : DOEPCTL(index);
+	epctrl = readl(hsotg->regs + epctrl_reg);
+
+	dev_dbg(hsotg->dev, "%s: read DxEPCTL=0x%08x from 0x%08x\n",
+		__func__, epctrl, epctrl_reg);
+
+	spin_lock_irqsave(&hsotg->lock, flags);
+
+	epctrl &= ~(DxEPCTL_EPType_MASK | DxEPCTL_MPS_MASK);
+	epctrl |= DxEPCTL_MPS(mps);
+
+	/*
+	 * mark the endpoint as active, otherwise the core may ignore
+	 * transactions entirely for this endpoint
+	 */
+	epctrl |= DxEPCTL_USBActEp;
+
+	/*
+	 * set the NAK status on the endpoint, otherwise we might try and
+	 * do something with data that we've yet got a request to process
+	 * since the RXFIFO will take data for an endpoint even if the
+	 * size register hasn't been set.
+	 */
+
+	epctrl |= DxEPCTL_SNAK;
+
+	/* update the endpoint state */
+	rtk_hsotg_set_ep_maxpacket(hsotg, hs_ep->index, mps);
+
+	/* default, set to non-periodic */
+	hs_ep->isochronous = 0;
+	hs_ep->periodic = 0;
+	hs_ep->halted = 0;
+	hs_ep->interval = desc->bInterval;
+
+	if (hs_ep->interval > 1 && hs_ep->mc > 1)
+		dev_err(hsotg->dev, "MC > 1 when interval is not 1\n");
+
+	switch (desc->bmAttributes & USB_ENDPOINT_XFERTYPE_MASK) {
+	case USB_ENDPOINT_XFER_ISOC:
+		epctrl |= DxEPCTL_EPType_Iso;
+		epctrl |= DxEPCTL_SetEvenFr;
+		hs_ep->isochronous = 1;
+		if (dir_in)
+			hs_ep->periodic = 1;
+		break;
+
+	case USB_ENDPOINT_XFER_BULK:
+		epctrl |= DxEPCTL_EPType_Bulk;
+		break;
+
+	case USB_ENDPOINT_XFER_INT:
+		if (dir_in) {
+			/*
+			 * Allocate our TxFNum by simply using the index
+			 * of the endpoint for the moment. We could do
+			 * something better if the host indicates how
+			 * many FIFOs we are expecting to use.
+			 */
+
+			hs_ep->periodic = 1;
+			epctrl |= DxEPCTL_TxFNum(index);
+		}
+
+		epctrl |= DxEPCTL_EPType_Intterupt;
+		break;
+
+	case USB_ENDPOINT_XFER_CONTROL:
+		epctrl |= DxEPCTL_EPType_Control;
+		break;
+	}
+
+	/*
+	 * if the hardware has dedicated fifos, we must give each IN EP
+	 * a unique tx-fifo even if it is non-periodic.
+	 */
+	if (dir_in && hsotg->dedicated_fifos)
+		epctrl |= DxEPCTL_TxFNum(index);
+
+	/* for non control endpoints, set PID to D0 */
+	if (index)
+		epctrl |= DxEPCTL_SetD0PID;
+
+	dev_dbg(hsotg->dev, "%s: write DxEPCTL=0x%08x\n",
+		__func__, epctrl);
+
+	writel(epctrl, hsotg->regs + epctrl_reg);
+	dev_dbg(hsotg->dev, "%s: read DxEPCTL=0x%08x\n",
+		__func__, readl(hsotg->regs + epctrl_reg));
+
+	/* enable the endpoint interrupt */
+	rtk_hsotg_ctrl_epint(hsotg, index, dir_in, 1);
+
+	spin_unlock_irqrestore(&hsotg->lock, flags);
+	return ret;
+}
+
+/**
+ * rtk_hsotg_ep_disable - disable given endpoint
+ * @ep: The endpoint to disable.
+ */
+static int rtk_hsotg_ep_disable(struct usb_ep *ep)
+{
+	struct rtk_hsotg_ep *hs_ep = our_ep(ep);
+	struct rtk_hsotg *hsotg = hs_ep->parent;
+	int dir_in = hs_ep->dir_in;
+	int index = hs_ep->index;
+	unsigned long flags;
+	u32 epctrl_reg;
+	u32 ctrl;
+
+	dev_info(hsotg->dev, "%s(ep %p)\n", __func__, ep);
+
+	if (ep == &hsotg->eps[0].ep) {
+		dev_err(hsotg->dev, "%s: called for ep0\n", __func__);
+		return -EINVAL;
+	}
+
+	epctrl_reg = dir_in ? DIEPCTL(index) : DOEPCTL(index);
+
+	spin_lock_irqsave(&hsotg->lock, flags);
+	/* terminate all requests with shutdown */
+	kill_all_requests(hsotg, hs_ep, -ESHUTDOWN, false);
+
+
+	ctrl = readl(hsotg->regs + epctrl_reg);
+	ctrl &= ~DxEPCTL_EPEna;
+	ctrl &= ~DxEPCTL_USBActEp;
+	ctrl |= DxEPCTL_SNAK;
+
+	dev_dbg(hsotg->dev, "%s: DxEPCTL=0x%08x\n", __func__, ctrl);
+	writel(ctrl, hsotg->regs + epctrl_reg);
+
+	/* disable endpoint interrupts */
+	rtk_hsotg_ctrl_epint(hsotg, hs_ep->index, hs_ep->dir_in, 0);
+
+	spin_unlock_irqrestore(&hsotg->lock, flags);
+	return 0;
+}
+
+/**
+ * on_list - check request is on the given endpoint
+ * @ep: The endpoint to check.
+ * @test: The request to test if it is on the endpoint.
+ */
+static bool on_list(struct rtk_hsotg_ep *ep, struct rtk_hsotg_req *test)
+{
+	struct rtk_hsotg_req *req, *treq;
+
+	list_for_each_entry_safe(req, treq, &ep->queue, queue) {
+		if (req == test)
+			return true;
+	}
+
+	return false;
+}
+
+/**
+ * rtk_hsotg_ep_dequeue - dequeue given endpoint
+ * @ep: The endpoint to dequeue.
+ * @req: The request to be removed from a queue.
+ */
+static int rtk_hsotg_ep_dequeue(struct usb_ep *ep, struct usb_request *req)
+{
+	struct rtk_hsotg_req *hs_req = our_req(req);
+	struct rtk_hsotg_ep *hs_ep = our_ep(ep);
+	struct rtk_hsotg *hs = hs_ep->parent;
+	unsigned long flags;
+
+	dev_info(hs->dev, "ep_dequeue(%p,%p)\n", ep, req);
+
+	spin_lock_irqsave(&hs->lock, flags);
+
+	if (!on_list(hs_ep, hs_req)) {
+		spin_unlock_irqrestore(&hs->lock, flags);
+		return -EINVAL;
+	}
+
+	rtk_hsotg_complete_request(hs, hs_ep, hs_req, -ECONNRESET);
+	spin_unlock_irqrestore(&hs->lock, flags);
+
+	return 0;
+}
+
+/**
+ * rtk_hsotg_ep_sethalt - set halt on a given endpoint
+ * @ep: The endpoint to set halt.
+ * @value: Set or unset the halt.
+ */
+static int rtk_hsotg_ep_sethalt(struct usb_ep *ep, int value)
+{
+	struct rtk_hsotg_ep *hs_ep = our_ep(ep);
+	struct rtk_hsotg *hs = hs_ep->parent;
+	int index = hs_ep->index;
+	u32 epreg;
+	u32 epctl;
+	u32 xfertype;
+
+	dev_info(hs->dev, "%s(ep %p %s, %d)\n", __func__, ep, ep->name, value);
+
+	if (index == 0) {
+		if (value)
+			rtk_hsotg_stall_ep0(hs);
+		else
+			dev_warn(hs->dev,
+				 "%s: can't clear halt on ep0\n", __func__);
+		return 0;
+	}
+
+	/* write both IN and OUT control registers */
+
+	epreg = DIEPCTL(index);
+	epctl = readl(hs->regs + epreg);
+
+	if (value) {
+		epctl |= DxEPCTL_Stall + DxEPCTL_SNAK;
+		if (epctl & DxEPCTL_EPEna)
+			epctl |= DxEPCTL_EPDis;
+	} else {
+		epctl &= ~DxEPCTL_Stall;
+		xfertype = epctl & DxEPCTL_EPType_MASK;
+		if (xfertype == DxEPCTL_EPType_Bulk ||
+			xfertype == DxEPCTL_EPType_Intterupt)
+				epctl |= DxEPCTL_SetD0PID;
+	}
+
+	writel(epctl, hs->regs + epreg);
+
+	epreg = DOEPCTL(index);
+	epctl = readl(hs->regs + epreg);
+
+	if (value)
+		epctl |= DxEPCTL_Stall;
+	else {
+		epctl &= ~DxEPCTL_Stall;
+		xfertype = epctl & DxEPCTL_EPType_MASK;
+		if (xfertype == DxEPCTL_EPType_Bulk ||
+			xfertype == DxEPCTL_EPType_Intterupt)
+				epctl |= DxEPCTL_SetD0PID;
+	}
+
+	writel(epctl, hs->regs + epreg);
+
+	hs_ep->halted = value;
+
+	return 0;
+}
+
+/**
+ * rtk_hsotg_ep_sethalt_lock - set halt on a given endpoint with lock held
+ * @ep: The endpoint to set halt.
+ * @value: Set or unset the halt.
+ */
+static int rtk_hsotg_ep_sethalt_lock(struct usb_ep *ep, int value)
+{
+	struct rtk_hsotg_ep *hs_ep = our_ep(ep);
+	struct rtk_hsotg *hs = hs_ep->parent;
+	unsigned long flags = 0;
+	int ret = 0;
+
+	spin_lock_irqsave(&hs->lock, flags);
+	ret = rtk_hsotg_ep_sethalt(ep, value);
+	spin_unlock_irqrestore(&hs->lock, flags);
+
+	return ret;
+}
+
+static struct usb_ep_ops rtk_hsotg_ep_ops = {
+	.enable		= rtk_hsotg_ep_enable,
+	.disable	= rtk_hsotg_ep_disable,
+	.alloc_request	= rtk_hsotg_ep_alloc_request,
+	.free_request	= rtk_hsotg_ep_free_request,
+	.queue		= rtk_hsotg_ep_queue_lock,
+	.dequeue	= rtk_hsotg_ep_dequeue,
+	.set_halt	= rtk_hsotg_ep_sethalt_lock,
+	/* note, don't believe we have any call for the fifo routines */
+};
+
+/**
+ * rtk_hsotg_phy_enable - enable platform phy dev
+ * @hsotg: The driver state
+ *
+ * A wrapper for platform code responsible for controlling
+ * low-level USB code
+ */
+static void rtk_hsotg_phy_enable(struct rtk_hsotg *hsotg)
+{
+	struct platform_device *pdev = to_platform_device(hsotg->dev);
+
+	if(hsotg->phyregs) {
+		writel(readl(hsotg->phyregs+0xc)|BIT(0), hsotg->phyregs+0xc);
+		mdelay(100);
+		writel(readl(hsotg->phyregs+0x2c)|BIT(0), hsotg->phyregs+0x2c);
+		mdelay(100);
+		writel(readl(hsotg->phyregs+0x40)|BIT(0), hsotg->phyregs+0x40);
+		writel(readl(hsotg->phyregs+0x44)|0x180, hsotg->phyregs+0x44);
+		mdelay(100);
+	}
+}
+
+/**
+ * rtk_hsotg_phy_disable - disable platform phy dev
+ * @hsotg: The driver state
+ *
+ * A wrapper for platform code responsible for controlling
+ * low-level USB code
+ */
+static void rtk_hsotg_phy_disable(struct rtk_hsotg *hsotg)
+{
+#if 0	//barry
+	struct platform_device *pdev = to_platform_device(hsotg->dev);
+
+	if (hsotg->phy) {
+		phy_power_off(hsotg->phy);
+		phy_exit(hsotg->phy);
+	} else if (hsotg->uphy)
+		usb_phy_shutdown(hsotg->uphy);
+	else if (hsotg->plat->phy_exit)
+		hsotg->plat->phy_exit(pdev, hsotg->plat->phy_type);
+#endif
+#ifdef CONFIG_USB_OTG
+	if(hsotg->phyregs)
+		writel(readl(hsotg->phyregs+0x40)&~BIT(0), hsotg->phyregs+0x40);
+#endif
+}
+
+/**
+ * rtk_hsotg_init - initalize the usb core
+ * @hsotg: The driver state
+ */
+static void rtk_hsotg_init(struct rtk_hsotg *hsotg)
+{
+	/* unmask subset of endpoint interrupts */
+
+	writel(DIEPMSK_TimeOUTMsk | DIEPMSK_AHBErrMsk |
+	       DIEPMSK_EPDisbldMsk | DIEPMSK_XferComplMsk,
+	       hsotg->regs + DIEPMSK);
+
+	writel(DOEPMSK_SetupMsk | DOEPMSK_AHBErrMsk |
+	       DOEPMSK_EPDisbldMsk | DOEPMSK_XferComplMsk,
+	       hsotg->regs + DOEPMSK);
+
+	writel(0, hsotg->regs + DAINTMSK);
+
+	/* Be in disconnected state until gadget is registered */
+	__orr32(hsotg->regs + DCTL, DCTL_SftDiscon);
+
+	if (0) {
+		/* post global nak until we're ready */
+		writel(DCTL_SGNPInNAK | DCTL_SGOUTNak,
+		       hsotg->regs + DCTL);
+	}
+
+	/* setup fifos */
+
+	dev_dbg(hsotg->dev, "GRXFSIZ=0x%08x, GNPTXFSIZ=0x%08x\n",
+		readl(hsotg->regs + GRXFSIZ),
+		readl(hsotg->regs + GNPTXFSIZ));
+
+	rtk_hsotg_init_fifo(hsotg);
+
+	/* set the PLL on, remove the HNP/SRP and set the PHY */
+	writel(GUSBCFG_PHYIf16 | GUSBCFG_TOutCal(7) | (0x5 << 10),
+	       hsotg->regs + GUSBCFG);
+//	writel(hsotg->phyif | GUSBCFG_TOutCal(7) | (0x5 << 10),		//barry
+//	       hsotg->regs + GUSBCFG);
+	mdelay(100);
+
+	writel(using_dma(hsotg) ? GAHBCFG_DMAEn : 0x0,
+	       hsotg->regs + GAHBCFG);
+}
+
+/**
+ * rtk_hsotg_udc_start - prepare the udc for work
+ * @gadget: The usb gadget state
+ * @driver: The usb gadget driver
+ *
+ * Perform initialization to prepare udc device and driver
+ * to work.
+ */
+static int rtk_hsotg_udc_start(struct usb_gadget *gadget,
+			   struct usb_gadget_driver *driver)
+{
+	struct rtk_hsotg *hsotg = to_hsotg(gadget);
+	int ret;
+
+	if (!hsotg) {
+		pr_err("%s: called with no device\n", __func__);
+		return -ENODEV;
+	}
+
+	if (!driver) {
+		dev_err(hsotg->dev, "%s: no driver\n", __func__);
+		return -EINVAL;
+	}
+
+	if (driver->max_speed < USB_SPEED_FULL)
+		dev_err(hsotg->dev, "%s: bad speed\n", __func__);
+
+	if (!driver->setup) {
+		dev_err(hsotg->dev, "%s: missing entry points\n", __func__);
+		return -EINVAL;
+	}
+
+	WARN_ON(hsotg->driver);
+
+	driver->driver.bus = NULL;
+	hsotg->driver = driver;
+	hsotg->gadget.dev.of_node = hsotg->dev->of_node;
+	hsotg->gadget.speed = USB_SPEED_UNKNOWN;
+#if 0
+	ret = regulator_bulk_enable(ARRAY_SIZE(hsotg->supplies),
+				    hsotg->supplies);
+	if (ret) {
+		dev_err(hsotg->dev, "failed to enable supplies: %d\n", ret);
+		goto err;
+	}
+#endif
+	hsotg->last_rst = jiffies;
+	dev_info(hsotg->dev, "bound driver %s\n", driver->driver.name);
+	return 0;
+
+//err:
+	hsotg->driver = NULL;
+	return ret;
+}
+
+/**
+ * rtk_hsotg_udc_stop - stop the udc
+ * @gadget: The usb gadget state
+ * @driver: The usb gadget driver
+ *
+ * Stop udc hw block and stay tunned for future transmissions
+ */
+static int rtk_hsotg_udc_stop(struct usb_gadget *gadget,
+			  struct usb_gadget_driver *driver)
+{
+	struct rtk_hsotg *hsotg = to_hsotg(gadget);
+	unsigned long flags = 0;
+	int ep;
+
+	if (!hsotg)
+		return -ENODEV;
+
+	/* all endpoints should be shutdown */
+	for (ep = 0; ep < hsotg->num_of_eps; ep++)
+		rtk_hsotg_ep_disable(&hsotg->eps[ep].ep);
+
+	spin_lock_irqsave(&hsotg->lock, flags);
+
+	rtk_hsotg_phy_disable(hsotg);
+
+	if (!driver)
+		hsotg->driver = NULL;
+
+	hsotg->gadget.speed = USB_SPEED_UNKNOWN;
+
+	spin_unlock_irqrestore(&hsotg->lock, flags);
+#if 0
+	regulator_bulk_disable(ARRAY_SIZE(hsotg->supplies), hsotg->supplies);
+#endif
+	return 0;
+}
+
+/**
+ * rtk_hsotg_gadget_getframe - read the frame number
+ * @gadget: The usb gadget state
+ *
+ * Read the {micro} frame number
+ */
+static int rtk_hsotg_gadget_getframe(struct usb_gadget *gadget)
+{
+	return rtk_hsotg_read_frameno(to_hsotg(gadget));
+}
+
+/**
+ * rtk_hsotg_pullup - connect/disconnect the USB PHY
+ * @gadget: The usb gadget state
+ * @is_on: Current state of the USB PHY
+ *
+ * Connect/Disconnect the USB PHY pullup
+ */
+static int rtk_hsotg_pullup(struct usb_gadget *gadget, int is_on)
+{
+	struct rtk_hsotg *hsotg = to_hsotg(gadget);
+	unsigned long flags = 0;
+
+	dev_dbg(hsotg->dev, "%s: is_in: %d\n", __func__, is_on);
+
+	spin_lock_irqsave(&hsotg->lock, flags);
+	if (is_on) {
+		rtk_hsotg_phy_enable(hsotg);
+		rtk_hsotg_core_init(hsotg);
+	} else {
+		rtk_hsotg_disconnect(hsotg);
+		rtk_hsotg_phy_disable(hsotg);
+	}
+
+	hsotg->gadget.speed = USB_SPEED_UNKNOWN;
+	spin_unlock_irqrestore(&hsotg->lock, flags);
+
+	return 0;
+}
+
+static const struct usb_gadget_ops rtk_hsotg_gadget_ops = {
+	.get_frame	= rtk_hsotg_gadget_getframe,
+	.udc_start		= rtk_hsotg_udc_start,
+	.udc_stop		= rtk_hsotg_udc_stop,
+	.pullup                 = rtk_hsotg_pullup,
+};
+
+/**
+ * rtk_hsotg_initep - initialise a single endpoint
+ * @hsotg: The device state.
+ * @hs_ep: The endpoint to be initialised.
+ * @epnum: The endpoint number
+ *
+ * Initialise the given endpoint (as part of the probe and device state
+ * creation) to give to the gadget driver. Setup the endpoint name, any
+ * direction information and other state that may be required.
+ */
+static void rtk_hsotg_initep(struct rtk_hsotg *hsotg,
+				       struct rtk_hsotg_ep *hs_ep,
+				       int epnum)
+{
+	u32 ptxfifo;
+	char *dir;
+
+	if (epnum == 0)
+		dir = "";
+	else if ((epnum % 2) == 0) {
+		dir = "out";
+	} else {
+		dir = "in";
+		hs_ep->dir_in = 1;
+	}
+
+	hs_ep->index = epnum;
+
+	snprintf(hs_ep->name, sizeof(hs_ep->name), "ep%d%s", epnum, dir);
+
+	INIT_LIST_HEAD(&hs_ep->queue);
+	INIT_LIST_HEAD(&hs_ep->ep.ep_list);
+
+	/* add to the list of endpoints known by the gadget driver */
+	if (epnum)
+		list_add_tail(&hs_ep->ep.ep_list, &hsotg->gadget.ep_list);
+
+	hs_ep->parent = hsotg;
+	hs_ep->ep.name = hs_ep->name;
+	usb_ep_set_maxpacket_limit(&hs_ep->ep, epnum ? 1024 : EP0_MPS_LIMIT);
+	hs_ep->ep.ops = &rtk_hsotg_ep_ops;
+
+	/*
+	 * Read the FIFO size for the Periodic TX FIFO, even if we're
+	 * an OUT endpoint, we may as well do this if in future the
+	 * code is changed to make each endpoint's direction changeable.
+	 */
+
+	ptxfifo = readl(hsotg->regs + DPTXFSIZn(epnum));
+	hs_ep->fifo_size = DPTXFSIZn_DPTxFSize_GET(ptxfifo) * 4;
+
+	/*
+	 * if we're using dma, we need to set the next-endpoint pointer
+	 * to be something valid.
+	 */
+
+	if (using_dma(hsotg)) {
+		u32 next = DxEPCTL_NextEp((epnum + 1) % 15);
+		writel(next, hsotg->regs + DIEPCTL(epnum));
+		writel(next, hsotg->regs + DOEPCTL(epnum));
+	}
+}
+
+/**
+ * rtk_hsotg_hw_cfg - read HW configuration registers
+ * @param: The device state
+ *
+ * Read the USB core HW configuration registers
+ */
+static void rtk_hsotg_hw_cfg(struct rtk_hsotg *hsotg)
+{
+	u32 cfg2, cfg4;
+	/* check hardware configuration */
+
+#ifdef CONFIG_USB_OTG
+	hsotg->num_of_eps = 5;
+	hsotg->dedicated_fifos = 0;
+#else
+	cfg2 = readl(hsotg->regs + 0x48);
+	hsotg->num_of_eps = (cfg2 >> 10) & 0xF;
+
+	dev_info(hsotg->dev, "EPs:%d\n", hsotg->num_of_eps);
+
+	cfg4 = readl(hsotg->regs + 0x50);
+	hsotg->dedicated_fifos = (cfg4 >> 25) & 1;
+#endif
+	dev_info(hsotg->dev, "%s fifos\n",
+		 hsotg->dedicated_fifos ? "dedicated" : "shared");
+}
+
+/**
+ * rtk_hsotg_dump - dump state of the udc
+ * @param: The device state
+ */
+static void rtk_hsotg_dump(struct rtk_hsotg *hsotg)
+{
+#ifdef DEBUG
+	struct device *dev = hsotg->dev;
+	void __iomem *regs = hsotg->regs;
+	u32 val;
+	int idx;
+
+	dev_info(dev, "DCFG=0x%08x, DCTL=0x%08x, DIEPMSK=%08x\n",
+		 readl(regs + DCFG), readl(regs + DCTL),
+		 readl(regs + DIEPMSK));
+
+	dev_info(dev, "GAHBCFG=0x%08x, 0x44=0x%08x\n",
+		 readl(regs + GAHBCFG), readl(regs + 0x44));
+
+	dev_info(dev, "GRXFSIZ=0x%08x, GNPTXFSIZ=0x%08x\n",
+		 readl(regs + GRXFSIZ), readl(regs + GNPTXFSIZ));
+
+	/* show periodic fifo settings */
+
+	for (idx = 1; idx <= 15; idx++) {
+		val = readl(regs + DPTXFSIZn(idx));
+		dev_info(dev, "DPTx[%d] FSize=%d, StAddr=0x%08x\n", idx,
+			 val >> DPTXFSIZn_DPTxFSize_SHIFT,
+			 val & DPTXFSIZn_DPTxFStAddr_MASK);
+	}
+
+	for (idx = 0; idx < 15; idx++) {
+		dev_info(dev,
+			 "ep%d-in: EPCTL=0x%08x, SIZ=0x%08x, DMA=0x%08x\n", idx,
+			 readl(regs + DIEPCTL(idx)),
+			 readl(regs + DIEPTSIZ(idx)),
+			 readl(regs + DIEPDMA(idx)));
+
+		val = readl(regs + DOEPCTL(idx));
+		dev_info(dev,
+			 "ep%d-out: EPCTL=0x%08x, SIZ=0x%08x, DMA=0x%08x\n",
+			 idx, readl(regs + DOEPCTL(idx)),
+			 readl(regs + DOEPTSIZ(idx)),
+			 readl(regs + DOEPDMA(idx)));
+
+	}
+
+	dev_info(dev, "DVBUSDIS=0x%08x, DVBUSPULSE=%08x\n",
+		 readl(regs + DVBUSDIS), readl(regs + DVBUSPULSE));
+#endif
+}
+
+/**
+ * state_show - debugfs: show overall driver and device state.
+ * @seq: The seq file to write to.
+ * @v: Unused parameter.
+ *
+ * This debugfs entry shows the overall state of the hardware and
+ * some general information about each of the endpoints available
+ * to the system.
+ */
+static int state_show(struct seq_file *seq, void *v)
+{
+	struct rtk_hsotg *hsotg = seq->private;
+	void __iomem *regs = hsotg->regs;
+	int idx;
+
+	seq_printf(seq, "DCFG=0x%08x, DCTL=0x%08x, DSTS=0x%08x\n",
+		 readl(regs + DCFG),
+		 readl(regs + DCTL),
+		 readl(regs + DSTS));
+
+	seq_printf(seq, "DIEPMSK=0x%08x, DOEPMASK=0x%08x\n",
+		   readl(regs + DIEPMSK), readl(regs + DOEPMSK));
+
+	seq_printf(seq, "GINTMSK=0x%08x, GINTSTS=0x%08x\n",
+		   readl(regs + GINTMSK),
+		   readl(regs + GINTSTS));
+
+	seq_printf(seq, "DAINTMSK=0x%08x, DAINT=0x%08x\n",
+		   readl(regs + DAINTMSK),
+		   readl(regs + DAINT));
+
+	seq_printf(seq, "GNPTXSTS=0x%08x, GRXSTSR=%08x\n",
+		   readl(regs + GNPTXSTS),
+		   readl(regs + GRXSTSR));
+
+	seq_puts(seq, "\nEndpoint status:\n");
+
+	for (idx = 0; idx < 15; idx++) {
+		u32 in, out;
+
+		in = readl(regs + DIEPCTL(idx));
+		out = readl(regs + DOEPCTL(idx));
+
+		seq_printf(seq, "ep%d: DIEPCTL=0x%08x, DOEPCTL=0x%08x",
+			   idx, in, out);
+
+		in = readl(regs + DIEPTSIZ(idx));
+		out = readl(regs + DOEPTSIZ(idx));
+
+		seq_printf(seq, ", DIEPTSIZ=0x%08x, DOEPTSIZ=0x%08x",
+			   in, out);
+
+		seq_puts(seq, "\n");
+	}
+
+	return 0;
+}
+
+static int state_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, state_show, inode->i_private);
+}
+
+static const struct file_operations state_fops = {
+	.owner		= THIS_MODULE,
+	.open		= state_open,
+	.read		= seq_read,
+	.llseek		= seq_lseek,
+	.release	= single_release,
+};
+
+/**
+ * fifo_show - debugfs: show the fifo information
+ * @seq: The seq_file to write data to.
+ * @v: Unused parameter.
+ *
+ * Show the FIFO information for the overall fifo and all the
+ * periodic transmission FIFOs.
+ */
+static int fifo_show(struct seq_file *seq, void *v)
+{
+	struct rtk_hsotg *hsotg = seq->private;
+	void __iomem *regs = hsotg->regs;
+	u32 val;
+	int idx;
+
+	seq_puts(seq, "Non-periodic FIFOs:\n");
+	seq_printf(seq, "RXFIFO: Size %d\n", readl(regs + GRXFSIZ));
+
+	val = readl(regs + GNPTXFSIZ);
+	seq_printf(seq, "NPTXFIFO: Size %d, Start 0x%08x\n",
+		   val >> GNPTXFSIZ_NPTxFDep_SHIFT,
+		   val & GNPTXFSIZ_NPTxFStAddr_MASK);
+
+	seq_puts(seq, "\nPeriodic TXFIFOs:\n");
+
+	for (idx = 1; idx <= 15; idx++) {
+		val = readl(regs + DPTXFSIZn(idx));
+
+		seq_printf(seq, "\tDPTXFIFO%2d: Size %d, Start 0x%08x\n", idx,
+			   val >> DPTXFSIZn_DPTxFSize_SHIFT,
+			   val & DPTXFSIZn_DPTxFStAddr_MASK);
+	}
+
+	return 0;
+}
+
+static int fifo_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, fifo_show, inode->i_private);
+}
+
+static const struct file_operations fifo_fops = {
+	.owner		= THIS_MODULE,
+	.open		= fifo_open,
+	.read		= seq_read,
+	.llseek		= seq_lseek,
+	.release	= single_release,
+};
+
+
+static const char *decode_direction(int is_in)
+{
+	return is_in ? "in" : "out";
+}
+
+/**
+ * ep_show - debugfs: show the state of an endpoint.
+ * @seq: The seq_file to write data to.
+ * @v: Unused parameter.
+ *
+ * This debugfs entry shows the state of the given endpoint (one is
+ * registered for each available).
+ */
+static int ep_show(struct seq_file *seq, void *v)
+{
+	struct rtk_hsotg_ep *ep = seq->private;
+	struct rtk_hsotg *hsotg = ep->parent;
+	struct rtk_hsotg_req *req;
+	void __iomem *regs = hsotg->regs;
+	int index = ep->index;
+	int show_limit = 15;
+	unsigned long flags;
+
+	seq_printf(seq, "Endpoint index %d, named %s,  dir %s:\n",
+		   ep->index, ep->ep.name, decode_direction(ep->dir_in));
+
+	/* first show the register state */
+
+	seq_printf(seq, "\tDIEPCTL=0x%08x, DOEPCTL=0x%08x\n",
+		   readl(regs + DIEPCTL(index)),
+		   readl(regs + DOEPCTL(index)));
+
+	seq_printf(seq, "\tDIEPDMA=0x%08x, DOEPDMA=0x%08x\n",
+		   readl(regs + DIEPDMA(index)),
+		   readl(regs + DOEPDMA(index)));
+
+	seq_printf(seq, "\tDIEPINT=0x%08x, DOEPINT=0x%08x\n",
+		   readl(regs + DIEPINT(index)),
+		   readl(regs + DOEPINT(index)));
+
+	seq_printf(seq, "\tDIEPTSIZ=0x%08x, DOEPTSIZ=0x%08x\n",
+		   readl(regs + DIEPTSIZ(index)),
+		   readl(regs + DOEPTSIZ(index)));
+
+	seq_puts(seq, "\n");
+	seq_printf(seq, "mps %d\n", ep->ep.maxpacket);
+	seq_printf(seq, "total_data=%ld\n", ep->total_data);
+
+	seq_printf(seq, "request list (%p,%p):\n",
+		   ep->queue.next, ep->queue.prev);
+
+	spin_lock_irqsave(&hsotg->lock, flags);
+
+	list_for_each_entry(req, &ep->queue, queue) {
+		if (--show_limit < 0) {
+			seq_puts(seq, "not showing more requests...\n");
+			break;
+		}
+
+		seq_printf(seq, "%c req %p: %d bytes @%p, ",
+			   req == ep->req ? '*' : ' ',
+			   req, req->req.length, req->req.buf);
+		seq_printf(seq, "%d done, res %d\n",
+			   req->req.actual, req->req.status);
+	}
+
+	spin_unlock_irqrestore(&hsotg->lock, flags);
+
+	return 0;
+}
+
+static int ep_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, ep_show, inode->i_private);
+}
+
+static const struct file_operations ep_fops = {
+	.owner		= THIS_MODULE,
+	.open		= ep_open,
+	.read		= seq_read,
+	.llseek		= seq_lseek,
+	.release	= single_release,
+};
+
+/**
+ * rtk_hsotg_create_debug - create debugfs directory and files
+ * @hsotg: The driver state
+ *
+ * Create the debugfs files to allow the user to get information
+ * about the state of the system. The directory name is created
+ * with the same name as the device itself, in case we end up
+ * with multiple blocks in future systems.
+ */
+static void rtk_hsotg_create_debug(struct rtk_hsotg *hsotg)
+{
+	struct dentry *root;
+	unsigned epidx;
+
+	root = debugfs_create_dir(dev_name(hsotg->dev), NULL);
+	hsotg->debug_root = root;
+	if (IS_ERR(root)) {
+		dev_err(hsotg->dev, "cannot create debug root\n");
+		return;
+	}
+
+	/* create general state file */
+
+	hsotg->debug_file = debugfs_create_file("state", 0444, root,
+						hsotg, &state_fops);
+
+	if (IS_ERR(hsotg->debug_file))
+		dev_err(hsotg->dev, "%s: failed to create state\n", __func__);
+
+	hsotg->debug_fifo = debugfs_create_file("fifo", 0444, root,
+						hsotg, &fifo_fops);
+
+	if (IS_ERR(hsotg->debug_fifo))
+		dev_err(hsotg->dev, "%s: failed to create fifo\n", __func__);
+
+	/* create one file for each endpoint */
+
+	for (epidx = 0; epidx < hsotg->num_of_eps; epidx++) {
+		struct rtk_hsotg_ep *ep = &hsotg->eps[epidx];
+
+		ep->debugfs = debugfs_create_file(ep->name, 0444,
+						  root, ep, &ep_fops);
+
+		if (IS_ERR(ep->debugfs))
+			dev_err(hsotg->dev, "failed to create %s debug file\n",
+				ep->name);
+	}
+}
+
+/**
+ * rtk_hsotg_delete_debug - cleanup debugfs entries
+ * @hsotg: The driver state
+ *
+ * Cleanup (remove) the debugfs files for use on module exit.
+ */
+static void rtk_hsotg_delete_debug(struct rtk_hsotg *hsotg)
+{
+	unsigned epidx;
+
+	for (epidx = 0; epidx < hsotg->num_of_eps; epidx++) {
+		struct rtk_hsotg_ep *ep = &hsotg->eps[epidx];
+		debugfs_remove(ep->debugfs);
+	}
+
+	debugfs_remove(hsotg->debug_file);
+	debugfs_remove(hsotg->debug_fifo);
+	debugfs_remove(hsotg->debug_root);
+}
+
+#ifdef CONFIG_USB_RTK_UDC_OTG_SWITCH
+static int rtk_hsotg_gadget_suspend(struct platform_device *pdev)
+{
+	struct rtk_hsotg *hsotg = platform_get_drvdata(pdev);
+	unsigned long flags;
+	int ret = 0;
+
+	if (hsotg->driver)
+		dev_info(hsotg->dev, "suspending usb gadget %s\n",
+			 hsotg->driver->driver.name);
+
+	spin_lock_irqsave(&hsotg->lock, flags);
+	rtk_hsotg_disconnect(hsotg);
+	rtk_hsotg_phy_disable(hsotg);
+	hsotg->gadget.speed = USB_SPEED_UNKNOWN;
+	spin_unlock_irqrestore(&hsotg->lock, flags);
+
+	if (hsotg->driver) {
+		int ep;
+		for (ep = 0; ep < hsotg->num_of_eps; ep++)
+			rtk_hsotg_ep_disable(&hsotg->eps[ep].ep);
+	}
+
+	return ret;
+}
+
+static int rtk_hsotg_gadget_resume(struct platform_device *pdev)
+{
+	struct rtk_hsotg *hsotg = platform_get_drvdata(pdev);
+	unsigned long flags;
+	int ret = 0;
+
+	if (hsotg->driver) {
+		dev_info(hsotg->dev, "resuming usb gadget %s\n",
+			 hsotg->driver->driver.name);
+	}
+
+	spin_lock_irqsave(&hsotg->lock, flags);
+	hsotg->last_rst = jiffies;
+	rtk_hsotg_phy_enable(hsotg);
+	rtk_hsotg_core_init(hsotg);
+	spin_unlock_irqrestore(&hsotg->lock, flags);
+
+	return ret;
+}
+
+static int switch_to_device_mode(struct rtk_hsotg *hsotg)
+{
+	struct platform_device *pdev = to_platform_device(hsotg->dev);
+	return rtk_hsotg_gadget_resume(pdev);
+}
+
+static int switch_to_host_mode(struct rtk_hsotg *hsotg)
+{
+	struct platform_device *pdev = to_platform_device(hsotg->dev);
+	int ret;
+
+	ret = rtk_hsotg_gadget_suspend(pdev);
+
+	if(hsotg->phyregs) {
+		writel(readl(hsotg->phyregs+0xc)|BIT(0), hsotg->phyregs+0xc);
+		mdelay(100);
+		writel(readl(hsotg->phyregs+0x2c)|BIT(0), hsotg->phyregs+0x2c);
+		mdelay(100);
+		writel(readl(hsotg->phyregs+0x40) & ~BIT(0), hsotg->phyregs+0x40);
+		writel(readl(hsotg->phyregs+0x44) & ~0x180, hsotg->phyregs+0x44);
+		mdelay(100);
+	}
+	return ret;
+}
+
+static ssize_t switch_mode_show(struct device *dev, struct device_attribute *attr, char *buffer)
+{
+	struct rtk_hsotg *hsotg = dev_get_drvdata(dev);
+
+	return sprintf(buffer, "%s\n", hsotg->otg_type?"In device mode":"In host mode");
+}
+
+static ssize_t switch_mode_store(struct device *dev, struct device_attribute *attr,
+		const char *buffer, size_t size)
+{
+	struct rtk_hsotg *hsotg = dev_get_drvdata(dev);
+	int ret;
+	char str[8];
+
+	ret = sscanf(buffer, "%7s", str);
+	if (ret != 1)
+		return -EINVAL;
+
+	if (!strcmp(str, "device")) {
+		hsotg->otg_type = RTK_DEVICE_MODE;
+		dev_info(hsotg->dev, "switch to device mode\n");
+		switch_to_device_mode(hsotg);
+	} else if (!strcmp(str, "host")) {
+		hsotg->otg_type = RTK_HOST_MODE;
+		dev_info(hsotg->dev, "switch to host mode\n");
+		switch_to_host_mode(hsotg);
+	} else {
+		dev_err(hsotg->dev, "ERROR switch to %s mode\n", str);
+	}
+	return size;
+}
+
+static DEVICE_ATTR(switch_mode, 0644, switch_mode_show, switch_mode_store);
+
+static const struct attribute *switch_mode_attrs[] = {
+	&dev_attr_switch_mode.attr,
+	NULL
+};
+
+static int rtk_hsotg_create_sysfs_by_otg(struct rtk_hsotg *hsotg)
+{
+	struct device *dev = hsotg->dev;
+	int retval;
+
+	hsotg->otg_type = RTK_DEVICE_MODE;
+
+	retval = sysfs_create_files(&dev->kobj,
+			(const struct attribute **)switch_mode_attrs);
+
+	return retval;
+}
+#endif // CONFIG_USB_RTK_UDC_OTG_SWITCH
+
+/**
+ * rtk_hsotg_probe - probe function for hsotg driver
+ * @pdev: The platform information for the driver
+ */
+static int rtk_hsotg_probe(struct platform_device *pdev)
+{
+	struct rtk_hsotg_plat *plat = dev_get_platdata(&pdev->dev);
+//	struct phy *phy;
+	struct usb_phy *uphy;
+	struct device *dev = &pdev->dev;
+	struct rtk_hsotg_ep *eps;
+	struct rtk_hsotg *hsotg;
+	struct resource *res;
+	int epnum;
+	int ret;
+//	int i;
+
+	hsotg = devm_kzalloc(&pdev->dev, sizeof(struct rtk_hsotg), GFP_KERNEL);
+	if (!hsotg) {
+		dev_err(dev, "cannot get memory\n");
+		return -ENOMEM;
+	}
+
+	/*
+	 * Attempt to find a generic PHY, then look for an old style
+	 * USB PHY, finally fall back to pdata
+	 */
+	uphy = devm_usb_get_phy_by_phandle(dev, "usb-phy", 0);
+	if (IS_ERR(uphy)) {
+		/* Fallback for pdata */
+		plat = dev_get_platdata(&pdev->dev);
+		if (!plat) {
+			dev_err(&pdev->dev, "no platform data or transceiver defined\n");
+			return -EPROBE_DEFER;
+		}
+		hsotg->plat = plat;
+	} else {
+		hsotg->uphy = uphy;
+		res = platform_get_resource(pdev, IORESOURCE_MEM, 1);
+		hsotg->phyregs = devm_ioremap_nocache(dev, res->start, resource_size(res));
+	}
+
+	hsotg->dev = dev;
+#if 0	//barry
+	hsotg->clk = devm_clk_get(&pdev->dev, "otg");
+	if (IS_ERR(hsotg->clk)) {
+		dev_err(dev, "cannot get otg clock\n");
+		return PTR_ERR(hsotg->clk);
+	}
+#endif
+	platform_set_drvdata(pdev, hsotg);
+
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+
+	hsotg->regs = devm_ioremap_nocache(dev, res->start, resource_size(res));
+	//hsotg->regs = devm_ioremap_resource(&pdev->dev, res);
+	if (IS_ERR(hsotg->regs)) {
+		ret = PTR_ERR(hsotg->regs);
+		goto err_clk;
+	}
+
+	ret = platform_get_irq(pdev, 0);
+	if (ret < 0) {
+		dev_err(dev, "cannot find IRQ\n");
+		goto err_clk;
+	}
+
+	spin_lock_init(&hsotg->lock);
+
+	hsotg->irq = ret;
+
+	ret = devm_request_irq(&pdev->dev, hsotg->irq, rtk_hsotg_irq, IRQF_SHARED,
+				dev_name(dev), hsotg);
+	if (ret < 0) {
+		dev_err(dev, "cannot claim IRQ\n");
+		goto err_clk;
+	}
+
+	dev_info(dev, "regs %p, irq %d\n", hsotg->regs, hsotg->irq);
+
+	hsotg->gadget.max_speed = USB_SPEED_HIGH;
+	hsotg->gadget.ops = &rtk_hsotg_gadget_ops;
+	hsotg->gadget.name = dev_name(dev);
+
+	/* reset the system */
+#if 0	//barry
+	clk_prepare_enable(hsotg->clk);
+
+	/* regulators */
+
+	for (i = 0; i < ARRAY_SIZE(hsotg->supplies); i++)
+		hsotg->supplies[i].supply = rtk_hsotg_supply_names[i];
+
+	ret = devm_regulator_bulk_get(dev, ARRAY_SIZE(hsotg->supplies),
+				 hsotg->supplies);
+	if (ret) {
+		dev_err(dev, "failed to request supplies: %d\n", ret);
+		goto err_clk;
+	}
+
+	ret = regulator_bulk_enable(ARRAY_SIZE(hsotg->supplies),
+				    hsotg->supplies);
+
+	if (ret) {
+		dev_err(hsotg->dev, "failed to enable supplies: %d\n", ret);
+		goto err_supplies;
+	}
+#endif
+	/* Set default UTMI width */
+	//hsotg->phyif = GUSBCFG_PHYIf16;
+	hsotg->phyif = GUSBCFG_PHYIf16|GUSBCFG_FORCEDEVMODE;
+	//hsotg->phyif = GUSBCFG_PHYIf8|GUSBCFG_FORCEDEVMODE;
+
+	/* usb phy enable */
+	//	rtk_usb_phy_init();
+	rtk_hsotg_phy_enable(hsotg);
+	rtk_hsotg_corereset(hsotg);
+	rtk_hsotg_init(hsotg);
+	rtk_hsotg_hw_cfg(hsotg);
+
+	/* hsotg->num_of_eps holds number of EPs other than ep0 */
+
+	if (hsotg->num_of_eps == 0) {
+		dev_err(dev, "wrong number of EPs (zero)\n");
+		ret = -EINVAL;
+		goto err_supplies;
+	}
+
+	eps = kcalloc(hsotg->num_of_eps + 1, sizeof(struct rtk_hsotg_ep),
+		      GFP_KERNEL);
+	if (!eps) {
+		dev_err(dev, "cannot get memory\n");
+		ret = -ENOMEM;
+		goto err_supplies;
+	}
+
+	hsotg->eps = eps;
+
+	/* setup endpoint information */
+
+	INIT_LIST_HEAD(&hsotg->gadget.ep_list);
+	hsotg->gadget.ep0 = &hsotg->eps[0].ep;
+
+	/* allocate EP0 request */
+
+	hsotg->ctrl_req = rtk_hsotg_ep_alloc_request(&hsotg->eps[0].ep,
+						     GFP_KERNEL);
+	if (!hsotg->ctrl_req) {
+		dev_err(dev, "failed to allocate ctrl req\n");
+		ret = -ENOMEM;
+		goto err_ep_mem;
+	}
+
+	/* initialise the endpoints now the core has been initialised */
+	for (epnum = 0; epnum < hsotg->num_of_eps; epnum++)
+		rtk_hsotg_initep(hsotg, &hsotg->eps[epnum], epnum);
+
+	/* disable power and clock */
+#if 0
+	ret = regulator_bulk_disable(ARRAY_SIZE(hsotg->supplies),
+				    hsotg->supplies);
+	if (ret) {
+		dev_err(hsotg->dev, "failed to disable supplies: %d\n", ret);
+		goto err_ep_mem;
+	}
+#endif
+	rtk_hsotg_phy_disable(hsotg);
+
+	ret = usb_add_gadget_udc(&pdev->dev, &hsotg->gadget);
+	if (ret)
+		goto err_ep_mem;
+
+	rtk_hsotg_create_debug(hsotg);
+
+#ifdef CONFIG_USB_RTK_UDC_OTG_SWITCH
+	rtk_hsotg_create_sysfs_by_otg(hsotg);
+#endif // CONFIG_USB_RTK_UDC_OTG_SWITCH
+
+	rtk_hsotg_dump(hsotg);
+
+#ifdef CONFIG_USB_OTG
+	otg_set_peripheral(hsotg->uphy->otg, &hsotg->gadget);
+#endif
+	return 0;
+
+err_ep_mem:
+	kfree(eps);
+err_supplies:
+	rtk_hsotg_phy_disable(hsotg);
+err_clk:
+	clk_disable_unprepare(hsotg->clk);
+
+	return ret;
+}
+
+/**
+ * rtk_hsotg_remove - remove function for hsotg driver
+ * @pdev: The platform information for the driver
+ */
+static int rtk_hsotg_remove(struct platform_device *pdev)
+{
+	struct rtk_hsotg *hsotg = platform_get_drvdata(pdev);
+
+	usb_del_gadget_udc(&hsotg->gadget);
+
+	rtk_hsotg_delete_debug(hsotg);
+
+	if (hsotg->driver) {
+		/* should have been done already by driver model core */
+		usb_gadget_unregister_driver(hsotg->driver);
+	}
+
+	rtk_hsotg_phy_disable(hsotg);
+#if 0	//barry
+	if (hsotg->phy)
+		phy_exit(hsotg->phy);
+	clk_disable_unprepare(hsotg->clk);
+#endif
+	return 0;
+}
+
+#if 0	//barry
+static int rtk_hsotg_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct rtk_hsotg *hsotg = platform_get_drvdata(pdev);
+	unsigned long flags;
+	int ret = 0;
+
+	if (hsotg->driver)
+		dev_info(hsotg->dev, "suspending usb gadget %s\n",
+			 hsotg->driver->driver.name);
+
+	spin_lock_irqsave(&hsotg->lock, flags);
+	rtk_hsotg_disconnect(hsotg);
+	rtk_hsotg_phy_disable(hsotg);
+	hsotg->gadget.speed = USB_SPEED_UNKNOWN;
+	spin_unlock_irqrestore(&hsotg->lock, flags);
+
+	if (hsotg->driver) {
+		int ep;
+		for (ep = 0; ep < hsotg->num_of_eps; ep++)
+			rtk_hsotg_ep_disable(&hsotg->eps[ep].ep);
+
+		ret = regulator_bulk_disable(ARRAY_SIZE(hsotg->supplies),
+					     hsotg->supplies);
+	}
+
+	return ret;
+}
+
+static int rtk_hsotg_resume(struct platform_device *pdev)
+{
+	struct rtk_hsotg *hsotg = platform_get_drvdata(pdev);
+	unsigned long flags;
+	int ret = 0;
+
+	if (hsotg->driver) {
+		dev_info(hsotg->dev, "resuming usb gadget %s\n",
+			 hsotg->driver->driver.name);
+		ret = regulator_bulk_enable(ARRAY_SIZE(hsotg->supplies),
+				      hsotg->supplies);
+	}
+
+	spin_lock_irqsave(&hsotg->lock, flags);
+	hsotg->last_rst = jiffies;
+	rtk_hsotg_phy_enable(hsotg);
+	rtk_hsotg_core_init(hsotg);
+	spin_unlock_irqrestore(&hsotg->lock, flags);
+
+	return ret;
+}
+#else
+#define rtk_hsotg_suspend NULL
+#define rtk_hsotg_resume NULL
+#endif
+
+#ifdef CONFIG_OF
+static const struct of_device_id rtk_hsotg_of_ids[] = {
+	{ .compatible = "Realtek,rtd129x-usb2-udc" },
+	{ .compatible = "snps,dwc2", },
+	{ /* sentinel */ }
+};
+MODULE_DEVICE_TABLE(of, rtk_hsotg_of_ids);
+#endif
+
+#ifdef CONFIG_USB_OTG
+static int rtk_hsotg_otg_suspend(struct platform_device *pdev, pm_message_t state)
+{
+	struct rtk_hsotg *hsotg = platform_get_drvdata(pdev);
+	rtk_hsotg_phy_disable(hsotg);
+	return 0;
+}
+static int rtk_hsotg_otg_resume(struct platform_device *pdev)
+{
+	struct rtk_hsotg *hsotg = platform_get_drvdata(pdev);
+	rtk_hsotg_phy_enable(hsotg);
+//	rtk_hsotg_core_init(hsotg);
+	return 0;
+}
+#else
+#define rtk_hsotg_otg_suspend NULL
+#define rtk_hsotg_otg_resume NULL
+#endif
+
+static struct platform_driver rtk_hsotg_driver = {
+	.driver		= {
+		.name	= "rtk-hsotg",
+		.owner	= THIS_MODULE,
+		.of_match_table = of_match_ptr(rtk_hsotg_of_ids),
+#ifdef CONFIG_USB_OTG
+		.suspend = rtk_hsotg_otg_suspend,
+		.resume  = rtk_hsotg_otg_resume,
+#endif
+	},
+	.probe		= rtk_hsotg_probe,
+	.remove		= rtk_hsotg_remove,
+	.suspend	= rtk_hsotg_suspend,
+	.resume		= rtk_hsotg_resume,
+};
+
+module_platform_driver(rtk_hsotg_driver);
+
+MODULE_DESCRIPTION("Realtek USB High-speed/OtG device");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:rtk-hsotg");
diff --git a/drivers/usb/gadget/udc/rtk-hsotg.h b/drivers/usb/gadget/udc/rtk-hsotg.h
new file mode 100644
index 00000000..2a1231d
--- /dev/null
+++ b/drivers/usb/gadget/udc/rtk-hsotg.h
@@ -0,0 +1,380 @@
+/* drivers/usb/gadget/rtk-hsotg.h
+ *
+ * Copyright 2008 Openmoko, Inc.
+ * Copyright 2008 Simtec Electronics
+ *      http://armlinux.simtec.co.uk/
+ *      Ben Dooks <ben@simtec.co.uk>
+ *
+ * USB2.0 Highspeed/OtG Synopsis DWC2 device block registers
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+*/
+
+#ifndef __REGS_USB_HSOTG_H
+#define __REGS_USB_HSOTG_H __FILE__
+
+#define HSOTG_REG(x) (x)
+
+#define GOTGCTL				HSOTG_REG(0x000)
+#define GOTGCTL_BSESVLD			(1 << 19)
+#define GOTGCTL_ASESVLD			(1 << 18)
+#define GOTGCTL_DBNC_SHORT			(1 << 17)
+#define GOTGCTL_CONID_B			(1 << 16)
+#define GOTGCTL_DEVHNPEN			(1 << 11)
+#define GOTGCTL_HSSETHNPEN			(1 << 10)
+#define GOTGCTL_HNPREQ				(1 << 9)
+#define GOTGCTL_HSTNEGSCS			(1 << 8)
+#define GOTGCTL_SESREQ				(1 << 1)
+#define GOTGCTL_SESREQSCS			(1 << 0)
+
+#define GOTGINT				HSOTG_REG(0x004)
+#define GOTGINT_DbnceDone			(1 << 19)
+#define GOTGINT_ADevTOUTChg			(1 << 18)
+#define GOTGINT_HstNegDet			(1 << 17)
+#define GOTGINT_HstnegSucStsChng		(1 << 9)
+#define GOTGINT_SesReqSucStsChng		(1 << 8)
+#define GOTGINT_SesEndDet			(1 << 2)
+
+#define GAHBCFG				HSOTG_REG(0x008)
+#define GAHBCFG_PTxFEmpLvl			(1 << 8)
+#define GAHBCFG_NPTxFEmpLvl			(1 << 7)
+#define GAHBCFG_DMAEn				(1 << 5)
+#define GAHBCFG_HBstLen_MASK			(0xf << 1)
+#define GAHBCFG_HBstLen_SHIFT			(1)
+#define GAHBCFG_HBstLen_Single			(0x0 << 1)
+#define GAHBCFG_HBstLen_Incr			(0x1 << 1)
+#define GAHBCFG_HBstLen_Incr4			(0x3 << 1)
+#define GAHBCFG_HBstLen_Incr8			(0x5 << 1)
+#define GAHBCFG_HBstLen_Incr16			(0x7 << 1)
+#define GAHBCFG_GlblIntrEn			(1 << 0)
+
+#define GUSBCFG				HSOTG_REG(0x00C)
+#define GUSBCFG_FORCEDEVMODE		(1 << 30)
+#define GUSBCFG_FORCEHOSTMODE		(1 << 29)
+#define GUSBCFG_PHYLPClkSel			(1 << 15)
+#define GUSBCFG_HNPCap				(1 << 9)
+#define GUSBCFG_SRPCap				(1 << 8)
+#define GUSBCFG_PHYIf16			(1 << 3)
+#define GUSBCFG_PHYIf8				(0 << 3)
+#define GUSBCFG_TOutCal_MASK			(0x7 << 0)
+#define GUSBCFG_TOutCal_SHIFT			(0)
+#define GUSBCFG_TOutCal_LIMIT			(0x7)
+#define GUSBCFG_TOutCal(_x)			((_x) << 0)
+
+#define GRSTCTL				HSOTG_REG(0x010)
+
+#define GRSTCTL_AHBIdle			(1 << 31)
+#define GRSTCTL_DMAReq				(1 << 30)
+#define GRSTCTL_TxFNum_MASK			(0x1f << 6)
+#define GRSTCTL_TxFNum_SHIFT			(6)
+#define GRSTCTL_TxFNum_LIMIT			(0x1f)
+#define GRSTCTL_TxFNum(_x)			((_x) << 6)
+#define GRSTCTL_TxFFlsh			(1 << 5)
+#define GRSTCTL_RxFFlsh			(1 << 4)
+#define GRSTCTL_INTknQFlsh			(1 << 3)
+#define GRSTCTL_FrmCntrRst			(1 << 2)
+#define GRSTCTL_HSftRst			(1 << 1)
+#define GRSTCTL_CSftRst			(1 << 0)
+
+#define GINTSTS				HSOTG_REG(0x014)
+#define GINTMSK				HSOTG_REG(0x018)
+
+#define GINTSTS_WkUpInt			(1 << 31)
+#define GINTSTS_SessReqInt			(1 << 30)
+#define GINTSTS_DisconnInt			(1 << 29)
+#define GINTSTS_ConIDStsChng			(1 << 28)
+#define GINTSTS_PTxFEmp			(1 << 26)
+#define GINTSTS_HChInt				(1 << 25)
+#define GINTSTS_PrtInt				(1 << 24)
+#define GINTSTS_FetSusp			(1 << 22)
+#define GINTSTS_incompIP			(1 << 21)
+#define GINTSTS_IncomplSOIN			(1 << 20)
+#define GINTSTS_OEPInt				(1 << 19)
+#define GINTSTS_IEPInt				(1 << 18)
+#define GINTSTS_EPMis				(1 << 17)
+#define GINTSTS_EOPF				(1 << 15)
+#define GINTSTS_ISOutDrop			(1 << 14)
+#define GINTSTS_EnumDone			(1 << 13)
+#define GINTSTS_USBRst				(1 << 12)
+#define GINTSTS_USBSusp			(1 << 11)
+#define GINTSTS_ErlySusp			(1 << 10)
+#define GINTSTS_GOUTNakEff			(1 << 7)
+#define GINTSTS_GINNakEff			(1 << 6)
+#define GINTSTS_NPTxFEmp			(1 << 5)
+#define GINTSTS_RxFLvl				(1 << 4)
+#define GINTSTS_SOF				(1 << 3)
+#define GINTSTS_OTGInt				(1 << 2)
+#define GINTSTS_ModeMis			(1 << 1)
+#define GINTSTS_CurMod_Host			(1 << 0)
+
+#define GRXSTSR				HSOTG_REG(0x01C)
+#define GRXSTSP				HSOTG_REG(0x020)
+
+#define GRXSTS_FN_MASK				(0x7f << 25)
+#define GRXSTS_FN_SHIFT			(25)
+
+#define GRXSTS_PktSts_MASK			(0xf << 17)
+#define GRXSTS_PktSts_SHIFT			(17)
+#define GRXSTS_PktSts_GlobalOutNAK		(0x1 << 17)
+#define GRXSTS_PktSts_OutRX			(0x2 << 17)
+#define GRXSTS_PktSts_OutDone			(0x3 << 17)
+#define GRXSTS_PktSts_SetupDone		(0x4 << 17)
+#define GRXSTS_PktSts_SetupRX			(0x6 << 17)
+
+#define GRXSTS_DPID_MASK			(0x3 << 15)
+#define GRXSTS_DPID_SHIFT			(15)
+#define GRXSTS_ByteCnt_MASK			(0x7ff << 4)
+#define GRXSTS_ByteCnt_SHIFT			(4)
+#define GRXSTS_EPNum_MASK			(0xf << 0)
+#define GRXSTS_EPNum_SHIFT			(0)
+
+#define GRXFSIZ				HSOTG_REG(0x024)
+
+#define GNPTXFSIZ				HSOTG_REG(0x028)
+
+#define GNPTXFSIZ_NPTxFDep_MASK		(0xffff << 16)
+#define GNPTXFSIZ_NPTxFDep_SHIFT		(16)
+#define GNPTXFSIZ_NPTxFDep_LIMIT		(0xffff)
+#define GNPTXFSIZ_NPTxFDep(_x)			((_x) << 16)
+#define GNPTXFSIZ_NPTxFStAddr_MASK		(0xffff << 0)
+#define GNPTXFSIZ_NPTxFStAddr_SHIFT		(0)
+#define GNPTXFSIZ_NPTxFStAddr_LIMIT		(0xffff)
+#define GNPTXFSIZ_NPTxFStAddr(_x)		((_x) << 0)
+
+#define GNPTXSTS				HSOTG_REG(0x02C)
+
+#define GNPTXSTS_NPtxQTop_MASK			(0x7f << 24)
+#define GNPTXSTS_NPtxQTop_SHIFT		(24)
+
+#define GNPTXSTS_NPTxQSpcAvail_MASK		(0xff << 16)
+#define GNPTXSTS_NPTxQSpcAvail_SHIFT		(16)
+#define GNPTXSTS_NPTxQSpcAvail_GET(_v)		(((_v) >> 16) & 0xff)
+
+#define GNPTXSTS_NPTxFSpcAvail_MASK		(0xffff << 0)
+#define GNPTXSTS_NPTxFSpcAvail_SHIFT		(0)
+#define GNPTXSTS_NPTxFSpcAvail_GET(_v)		(((_v) >> 0) & 0xffff)
+
+
+#define HPTXFSIZ				HSOTG_REG(0x100)
+
+#define DPTXFSIZn(_a)		HSOTG_REG(0x104 + (((_a) - 1) * 4))
+
+#define DPTXFSIZn_DPTxFSize_MASK		(0xffff << 16)
+#define DPTXFSIZn_DPTxFSize_SHIFT		(16)
+#define DPTXFSIZn_DPTxFSize_GET(_v)		(((_v) >> 16) & 0xffff)
+#define DPTXFSIZn_DPTxFSize_LIMIT		(0xffff)
+#define DPTXFSIZn_DPTxFSize(_x)		((_x) << 16)
+
+#define DPTXFSIZn_DPTxFStAddr_MASK		(0xffff << 0)
+#define DPTXFSIZn_DPTxFStAddr_SHIFT		(0)
+
+/* Device mode registers */
+#define DCFG					HSOTG_REG(0x800)
+
+#define DCFG_EPMisCnt_MASK			(0x1f << 18)
+#define DCFG_EPMisCnt_SHIFT			(18)
+#define DCFG_EPMisCnt_LIMIT			(0x1f)
+#define DCFG_EPMisCnt(_x)			((_x) << 18)
+
+#define DCFG_PerFrInt_MASK			(0x3 << 11)
+#define DCFG_PerFrInt_SHIFT			(11)
+#define DCFG_PerFrInt_LIMIT			(0x3)
+#define DCFG_PerFrInt(_x)			((_x) << 11)
+
+#define DCFG_DevAddr_MASK			(0x7f << 4)
+#define DCFG_DevAddr_SHIFT			(4)
+#define DCFG_DevAddr_LIMIT			(0x7f)
+#define DCFG_DevAddr(_x)			((_x) << 4)
+
+#define DCFG_NZStsOUTHShk			(1 << 2)
+
+#define DCFG_DevSpd_MASK			(0x3 << 0)
+#define DCFG_DevSpd_SHIFT			(0)
+#define DCFG_DevSpd_HS				(0x0 << 0)
+#define DCFG_DevSpd_FS				(0x1 << 0)
+#define DCFG_DevSpd_LS				(0x2 << 0)
+#define DCFG_DevSpd_FS48			(0x3 << 0)
+
+#define DCTL					HSOTG_REG(0x804)
+
+#define DCTL_PWROnPrgDone			(1 << 11)
+#define DCTL_CGOUTNak				(1 << 10)
+#define DCTL_SGOUTNak				(1 << 9)
+#define DCTL_CGNPInNAK				(1 << 8)
+#define DCTL_SGNPInNAK				(1 << 7)
+#define DCTL_TstCtl_MASK			(0x7 << 4)
+#define DCTL_TstCtl_SHIFT			(4)
+#define DCTL_GOUTNakSts			(1 << 3)
+#define DCTL_GNPINNakSts			(1 << 2)
+#define DCTL_SftDiscon				(1 << 1)
+#define DCTL_RmtWkUpSig			(1 << 0)
+
+#define DSTS					HSOTG_REG(0x808)
+
+#define DSTS_SOFFN_MASK			(0x3fff << 8)
+#define DSTS_SOFFN_SHIFT			(8)
+#define DSTS_SOFFN_LIMIT			(0x3fff)
+#define DSTS_SOFFN(_x)				((_x) << 8)
+#define DSTS_ErraticErr			(1 << 3)
+#define DSTS_EnumSpd_MASK			(0x3 << 1)
+#define DSTS_EnumSpd_SHIFT			(1)
+#define DSTS_EnumSpd_HS			(0x0 << 1)
+#define DSTS_EnumSpd_FS			(0x1 << 1)
+#define DSTS_EnumSpd_LS			(0x2 << 1)
+#define DSTS_EnumSpd_FS48			(0x3 << 1)
+
+#define DSTS_SuspSts				(1 << 0)
+
+#define DIEPMSK				HSOTG_REG(0x810)
+
+#define DIEPMSK_TxFIFOEmpty			(1 << 7)
+#define DIEPMSK_INEPNakEffMsk			(1 << 6)
+#define DIEPMSK_INTknEPMisMsk			(1 << 5)
+#define DIEPMSK_INTknTXFEmpMsk			(1 << 4)
+#define DIEPMSK_TimeOUTMsk			(1 << 3)
+#define DIEPMSK_AHBErrMsk			(1 << 2)
+#define DIEPMSK_EPDisbldMsk			(1 << 1)
+#define DIEPMSK_XferComplMsk			(1 << 0)
+
+#define DOEPMSK				HSOTG_REG(0x814)
+
+#define DOEPMSK_Back2BackSetup			(1 << 6)
+#define DOEPMSK_OUTTknEPdisMsk			(1 << 4)
+#define DOEPMSK_SetupMsk			(1 << 3)
+#define DOEPMSK_AHBErrMsk			(1 << 2)
+#define DOEPMSK_EPDisbldMsk			(1 << 1)
+#define DOEPMSK_XferComplMsk			(1 << 0)
+
+#define DAINT					HSOTG_REG(0x818)
+#define DAINTMSK				HSOTG_REG(0x81C)
+
+#define DAINT_OutEP_SHIFT			(16)
+#define DAINT_OutEP(x)				(1 << ((x) + 16))
+#define DAINT_InEP(x)				(1 << (x))
+
+#define DTKNQR1				HSOTG_REG(0x820)
+#define DTKNQR2				HSOTG_REG(0x824)
+#define DTKNQR3				HSOTG_REG(0x830)
+#define DTKNQR4				HSOTG_REG(0x834)
+
+#define DVBUSDIS				HSOTG_REG(0x828)
+#define DVBUSPULSE				HSOTG_REG(0x82C)
+
+#define DIEPCTL0				HSOTG_REG(0x900)
+#define DOEPCTL0				HSOTG_REG(0xB00)
+#define DIEPCTL(_a)			HSOTG_REG(0x900 + ((_a) * 0x20))
+#define DOEPCTL(_a)			HSOTG_REG(0xB00 + ((_a) * 0x20))
+
+/* EP0 specialness:
+ * bits[29..28] - reserved (no SetD0PID, SetD1PID)
+ * bits[25..22] - should always be zero, this isn't a periodic endpoint
+ * bits[10..0] - MPS setting differenct for EP0
+ */
+#define D0EPCTL_MPS_MASK			(0x3 << 0)
+#define D0EPCTL_MPS_SHIFT			(0)
+#define D0EPCTL_MPS_64				(0x0 << 0)
+#define D0EPCTL_MPS_32				(0x1 << 0)
+#define D0EPCTL_MPS_16				(0x2 << 0)
+#define D0EPCTL_MPS_8				(0x3 << 0)
+
+#define DxEPCTL_EPEna				(1 << 31)
+#define DxEPCTL_EPDis				(1 << 30)
+#define DxEPCTL_SetD1PID			(1 << 29)
+#define DxEPCTL_SetOddFr			(1 << 29)
+#define DxEPCTL_SetD0PID			(1 << 28)
+#define DxEPCTL_SetEvenFr			(1 << 28)
+#define DxEPCTL_SNAK				(1 << 27)
+#define DxEPCTL_CNAK				(1 << 26)
+#define DxEPCTL_TxFNum_MASK			(0xf << 22)
+#define DxEPCTL_TxFNum_SHIFT			(22)
+#define DxEPCTL_TxFNum_LIMIT			(0xf)
+#define DxEPCTL_TxFNum(_x)			((_x) << 22)
+
+#define DxEPCTL_Stall				(1 << 21)
+#define DxEPCTL_Snp				(1 << 20)
+#define DxEPCTL_EPType_MASK			(0x3 << 18)
+#define DxEPCTL_EPType_SHIFT			(18)
+#define DxEPCTL_EPType_Control			(0x0 << 18)
+#define DxEPCTL_EPType_Iso			(0x1 << 18)
+#define DxEPCTL_EPType_Bulk			(0x2 << 18)
+#define DxEPCTL_EPType_Intterupt		(0x3 << 18)
+
+#define DxEPCTL_NAKsts				(1 << 17)
+#define DxEPCTL_DPID				(1 << 16)
+#define DxEPCTL_EOFrNum			(1 << 16)
+#define DxEPCTL_USBActEp			(1 << 15)
+#define DxEPCTL_NextEp_MASK			(0xf << 11)
+#define DxEPCTL_NextEp_SHIFT			(11)
+#define DxEPCTL_NextEp_LIMIT			(0xf)
+#define DxEPCTL_NextEp(_x)			((_x) << 11)
+
+#define DxEPCTL_MPS_MASK			(0x7ff << 0)
+#define DxEPCTL_MPS_SHIFT			(0)
+#define DxEPCTL_MPS_LIMIT			(0x7ff)
+#define DxEPCTL_MPS(_x)			((_x) << 0)
+
+#define DIEPINT(_a)			HSOTG_REG(0x908 + ((_a) * 0x20))
+#define DOEPINT(_a)			HSOTG_REG(0xB08 + ((_a) * 0x20))
+
+#define DxEPINT_INEPNakEff			(1 << 6)
+#define DxEPINT_Back2BackSetup			(1 << 6)
+#define DxEPINT_INTknEPMis			(1 << 5)
+#define DxEPINT_INTknTXFEmp			(1 << 4)
+#define DxEPINT_OUTTknEPdis			(1 << 4)
+#define DxEPINT_Timeout			(1 << 3)
+#define DxEPINT_Setup				(1 << 3)
+#define DxEPINT_AHBErr				(1 << 2)
+#define DxEPINT_EPDisbld			(1 << 1)
+#define DxEPINT_XferCompl			(1 << 0)
+
+#define DIEPTSIZ0				HSOTG_REG(0x910)
+
+#define DIEPTSIZ0_PktCnt_MASK			(0x3 << 19)
+#define DIEPTSIZ0_PktCnt_SHIFT			(19)
+#define DIEPTSIZ0_PktCnt_LIMIT			(0x3)
+#define DIEPTSIZ0_PktCnt(_x)			((_x) << 19)
+
+#define DIEPTSIZ0_XferSize_MASK		(0x7f << 0)
+#define DIEPTSIZ0_XferSize_SHIFT		(0)
+#define DIEPTSIZ0_XferSize_LIMIT		(0x7f)
+#define DIEPTSIZ0_XferSize(_x)			((_x) << 0)
+
+#define DOEPTSIZ0				HSOTG_REG(0xB10)
+#define DOEPTSIZ0_SUPCnt_MASK			(0x3 << 29)
+#define DOEPTSIZ0_SUPCnt_SHIFT			(29)
+#define DOEPTSIZ0_SUPCnt_LIMIT			(0x3)
+#define DOEPTSIZ0_SUPCnt(_x)			((_x) << 29)
+
+#define DOEPTSIZ0_PktCnt			(1 << 19)
+#define DOEPTSIZ0_XferSize_MASK		(0x7f << 0)
+#define DOEPTSIZ0_XferSize_SHIFT		(0)
+
+#define DIEPTSIZ(_a)			HSOTG_REG(0x910 + ((_a) * 0x20))
+#define DOEPTSIZ(_a)			HSOTG_REG(0xB10 + ((_a) * 0x20))
+
+#define DxEPTSIZ_MC_MASK			(0x3 << 29)
+#define DxEPTSIZ_MC_SHIFT			(29)
+#define DxEPTSIZ_MC_LIMIT			(0x3)
+#define DxEPTSIZ_MC(_x)			((_x) << 29)
+
+#define DxEPTSIZ_PktCnt_MASK			(0x3ff << 19)
+#define DxEPTSIZ_PktCnt_SHIFT			(19)
+#define DxEPTSIZ_PktCnt_GET(_v)		(((_v) >> 19) & 0x3ff)
+#define DxEPTSIZ_PktCnt_LIMIT			(0x3ff)
+#define DxEPTSIZ_PktCnt(_x)			((_x) << 19)
+
+#define DxEPTSIZ_XferSize_MASK			(0x7ffff << 0)
+#define DxEPTSIZ_XferSize_SHIFT		(0)
+#define DxEPTSIZ_XferSize_GET(_v)		(((_v) >> 0) & 0x7ffff)
+#define DxEPTSIZ_XferSize_LIMIT		(0x7ffff)
+#define DxEPTSIZ_XferSize(_x)			((_x) << 0)
+
+#define DIEPDMA(_a)			HSOTG_REG(0x914 + ((_a) * 0x20))
+#define DOEPDMA(_a)			HSOTG_REG(0xB14 + ((_a) * 0x20))
+#define DTXFSTS(_a)			HSOTG_REG(0x918 + ((_a) * 0x20))
+
+#define EPFIFO(_a)			HSOTG_REG(0x1000 + ((_a) * 0x1000))
+
+#endif /* __REGS_USB_HSOTG_H */
diff --git a/drivers/usb/host/Kconfig b/drivers/usb/host/Kconfig
index 0e7cc71..53e9f10 100644
--- a/drivers/usb/host/Kconfig
+++ b/drivers/usb/host/Kconfig
@@ -170,6 +170,17 @@ config USB_EHCI_FSL
 	---help---
 	  Variation of ARC USB block used in some Freescale chips.
 
+config USB_EHCI_RTK
+	tristate "Support for RTK on-chip EHCI USB controller"
+	depends on USB_EHCI_HCD
+	select USB_RTK_CTRL_MANAGER
+	select RTK_USB_RLE0599_PHY
+	---help---
+	  The Realtek chips are dual-role host/peripheral USB controllers.
+
+	  Enable this option to support this chip in host controller mode.
+	  If unsure, say N.
+
 config USB_EHCI_MXC
 	tristate "Support for Freescale i.MX on-chip EHCI USB controller"
 	depends on ARCH_MXC
@@ -412,6 +423,17 @@ config USB_OHCI_HCD
 
 if USB_OHCI_HCD
 
+config USB_OHCI_RTK
+	bool "Support for RTK on-chip OHCI USB controller"
+	depends on USB_OHCI_HCD && (ARCH_RTD119X || ARCH_RTD129x || ARCH_RTD139x)
+	select USB_RTK_CTRL_MANAGER
+	select RTK_USB_RLE0599_PHY
+	---help---
+	  The Realtek chips are dual-role host/peripheral USB controllers.
+
+	  Enable this option to support this chip in host controller mode.
+	  If unsure, say N.
+
 config USB_OHCI_HCD_OMAP1
 	tristate "OHCI support for OMAP1/2 chips"
 	depends on ARCH_OMAP1
@@ -804,3 +826,10 @@ config USB_HCD_TEST_MODE
 	  This option is of interest only to developers who need to validate
 	  their USB hardware designs.  It is not needed for normal use.  If
 	  unsure, say N.
+
+config USB_RTK_HCD_TEST_MODE
+       bool "RTK Host CTS test mode"
+       default n
+       help
+         Enable RTK USB Host CTS testing mode.
+
diff --git a/drivers/usb/host/Makefile b/drivers/usb/host/Makefile
index 6ef785b..571ebde 100644
--- a/drivers/usb/host/Makefile
+++ b/drivers/usb/host/Makefile
@@ -13,6 +13,7 @@ fhci-$(CONFIG_FHCI_DEBUG) += fhci-dbg.o
 xhci-hcd-y := xhci.o xhci-mem.o
 xhci-hcd-y += xhci-ring.o xhci-hub.o xhci-dbg.o
 xhci-hcd-y += xhci-trace.o
+xhci-hcd-y += xhci-debugfs.o
 ifneq ($(CONFIG_USB_XHCI_MTK), )
 	xhci-hcd-y += xhci-mtk-sch.o
 endif
@@ -44,6 +45,7 @@ obj-$(CONFIG_USB_EHCI_HCD_AT91) += ehci-atmel.o
 obj-$(CONFIG_USB_EHCI_MSM)	+= ehci-msm.o
 obj-$(CONFIG_USB_EHCI_TEGRA)	+= ehci-tegra.o
 obj-$(CONFIG_USB_W90X900_EHCI)	+= ehci-w90x900.o
+obj-$(CONFIG_USB_EHCI_RTK)	+= ehci-rtk.o
 
 obj-$(CONFIG_USB_OXU210HP_HCD)	+= oxu210hp-hcd.o
 obj-$(CONFIG_USB_ISP116X_HCD)	+= isp116x-hcd.o
diff --git a/drivers/usb/host/ehci-dbg.c b/drivers/usb/host/ehci-dbg.c
index 3ff6468..fae2ff9 100644
--- a/drivers/usb/host/ehci-dbg.c
+++ b/drivers/usb/host/ehci-dbg.c
@@ -877,6 +877,28 @@ static ssize_t fill_registers_buffer(struct debug_buffer *buf)
 	size -= temp;
 	next += temp;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	temp = scnprintf (next, size, "CTRLDSSEGMENT %08x\n",
+			ehci_readl(ehci, &ehci->regs->segment));
+	size -= temp;
+	next += temp;
+
+	temp = scnprintf (next, size, "PERIODIC_LIST_BASE %08x\n",
+			ehci_readl(ehci, &ehci->regs->frame_list));
+	size -= temp;
+	next += temp;
+
+	temp = scnprintf (next, size, "ASYNC_LIST_ADDR %08x\n",
+			ehci_readl(ehci, &ehci->regs->async_next));
+	size -= temp;
+	next += temp;
+
+	temp = scnprintf (next, size, "CONFIG_FLAG %08x\n",
+			ehci_readl(ehci, &ehci->regs->configured_flag));
+	size -= temp;
+	next += temp;
+#endif
+
 	for (i = 1; i <= HCS_N_PORTS(ehci->hcs_params); i++) {
 		temp = dbg_port_buf(scratch, sizeof(scratch), label, i,
 				ehci_readl(ehci,
diff --git a/drivers/usb/host/ehci-hub.c b/drivers/usb/host/ehci-hub.c
index 74f62d6..3324c7f 100644
--- a/drivers/usb/host/ehci-hub.c
+++ b/drivers/usb/host/ehci-hub.c
@@ -862,6 +862,34 @@ static int ehset_single_step_set_feature(struct usb_hcd *hcd, int port)
 #endif /* CONFIG_USB_HCD_TEST_MODE */
 /*-------------------------------------------------------------------------*/
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_USB_EHCI_RTK
+extern int RTK_ehci_usb2_phy_toggle(struct device *ehci_dev, bool isConnect);
+#endif
+
+static void RTK_phy_toggle(struct usb_hcd *hcd, u16 wValue, u16 wIndex,
+	    u32 temp)
+{
+	struct ehci_hcd *ehci = hcd_to_ehci(hcd);
+
+	if (wValue == USB_PORT_FEAT_C_CONNECTION) {
+		int port = wIndex;
+		u32 status = temp;
+		bool isConnect = (status & PORT_CONNECT)?true:false;
+
+#ifdef CONFIG_USB_EHCI_RTK
+		ehci_info(ehci, "%s to call RTK_ehci_usb2_phy_toggle (wValue=%x "
+			    "port=%d status=%x)\n",
+			    __func__, wValue, port, status);
+		RTK_ehci_usb2_phy_toggle(hcd->self.controller, isConnect);
+#else
+		ehci_info(ehci, "%s NO build CONFIG_USB_EHCI_RTK\n",
+			    __func__);
+#endif
+	}
+}
+#endif
+
 int ehci_hub_control(
 	struct usb_hcd	*hcd,
 	u16		typeReq,
@@ -973,6 +1001,9 @@ int ehci_hub_control(
 			}
 			break;
 		case USB_PORT_FEAT_C_CONNECTION:
+#ifdef CONFIG_USB_PATCH_ON_RTK
+			RTK_phy_toggle(hcd, wValue, wIndex, temp);
+#endif
 			ehci_writel(ehci, temp | PORT_CSC, status_reg);
 			break;
 		case USB_PORT_FEAT_C_OVER_CURRENT:
diff --git a/drivers/usb/host/ehci-q.c b/drivers/usb/host/ehci-q.c
index eca3710..2dc3c65 100644
--- a/drivers/usb/host/ehci-q.c
+++ b/drivers/usb/host/ehci-q.c
@@ -40,6 +40,32 @@
 
 /*-------------------------------------------------------------------------*/
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+extern int RTK_ohci_force_suspend(const char *func);
+
+/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+int check_and_restore_async_list(struct ehci_hcd *ehci, const char *func, int line) {
+
+	int retry = 0;
+	if (ehci->fixed_async_list_addr_bug) {
+		for (retry = 0; retry < 5; retry++) {
+			u32 async_next = ehci_readl(ehci, &ehci->regs->async_next);
+			if (async_next == 0) {
+				ehci_err(ehci, "%s:%d #%d async_next is NULL ==> fixed async_next to HEAD=%x\n",
+					func, line, retry, (unsigned int) ehci->async->qh_dma);
+				ehci_writel(ehci, (u32) ehci->async->qh_dma,
+					&ehci->regs->async_next);
+				wmb();
+				mdelay(2);
+			} else {
+				break;
+			}
+		}
+	}
+	return 0;
+}
+#endif
+
 /* fill a qtd, returning how much of the buffer we were able to queue up */
 
 static int
@@ -956,6 +982,11 @@ static void qtd_list_free (
 
 static void enable_async(struct ehci_hcd *ehci)
 {
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+	check_and_restore_async_list(ehci, __func__, __LINE__);
+#endif //CONFIG_USB_PATCH_ON_RTK
+
 	if (ehci->async_count++)
 		return;
 
@@ -969,6 +1000,11 @@ static void enable_async(struct ehci_hcd *ehci)
 
 static void disable_async(struct ehci_hcd *ehci)
 {
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+	check_and_restore_async_list(ehci, __func__, __LINE__);
+#endif
+
 	if (--ehci->async_count)
 		return;
 
@@ -987,6 +1023,12 @@ static void qh_link_async (struct ehci_hcd *ehci, struct ehci_qh *qh)
 	__hc32		dma = QH_NEXT(ehci, qh->qh_dma);
 	struct ehci_qh	*head;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+	/* When EHCI schedule actived, force suspend OHCI*/
+	check_and_restore_async_list(ehci, __func__, __LINE__);
+#endif //CONFIG_USB_PATCH_ON_RTK
+
 	/* Don't link a QH if there's a Clear-TT-Buffer pending */
 	if (unlikely(qh->clearing_tt))
 		return;
@@ -1116,6 +1158,13 @@ static struct ehci_qh *qh_append_tds (
 
 	epnum = urb->ep->desc.bEndpointAddress;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_USB_OHCI_RTK
+	/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+	RTK_ohci_force_suspend(__func__);
+#endif
+#endif
+
 #ifdef EHCI_URB_TRACE
 	{
 		struct ehci_qtd *qtd;
@@ -1279,6 +1328,11 @@ static void single_unlink_async(struct ehci_hcd *ehci, struct ehci_qh *qh)
 	prev->qh_next = qh->qh_next;
 	if (ehci->qh_scan_next == qh)
 		ehci->qh_scan_next = qh->qh_next.qh;
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+	check_and_restore_async_list(ehci, __func__, __LINE__);
+#endif //CONFIG_USB_PATCH_ON_RTK
 }
 
 static void start_iaa_cycle(struct ehci_hcd *ehci)
@@ -1308,6 +1362,11 @@ static void end_iaa_cycle(struct ehci_hcd *ehci)
 		ehci_writel(ehci, (u32) ehci->async->qh_dma,
 			    &ehci->regs->async_next);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+	check_and_restore_async_list(ehci, __func__, __LINE__);
+#endif //CONFIG_USB_PATCH_ON_RTK
+
 	/* The current IAA cycle has ended */
 	ehci->iaa_in_progress = false;
 
diff --git a/drivers/usb/host/ehci-rtk.c b/drivers/usb/host/ehci-rtk.c
new file mode 100644
index 00000000..e8b3c7e
--- /dev/null
+++ b/drivers/usb/host/ehci-rtk.c
@@ -0,0 +1,396 @@
+/*
+ *  ehic-rtk.c RTK EHCI HCD (Host Controller Driver)
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/mbus.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/usb.h>
+#include <linux/usb/hcd.h>
+#include <linux/io.h>
+#include <linux/dma-mapping.h>
+#include <linux/usb/phy.h>
+#include <linux/of_gpio.h>
+#include <linux/suspend.h>
+
+#include "ehci.h"
+
+#define DRIVER_DESC "EHCI realtek driver"
+
+static const char hcd_name[] = "ehci-rtk";
+
+static struct hc_driver __read_mostly ehci_rtk_hc_driver;
+
+static struct ehci_rtk {
+	struct device *dev;
+	struct usb_phy *phy;
+	struct ehci_hcd *ehci;
+	int irq;
+
+	struct work_struct work;
+};
+
+#ifdef CONFIG_RTK_USB_RLE0599_PHY
+extern void rtk_rle0599_phy_toggle(struct usb_phy *usb2_phy, bool isConnect);
+#endif
+
+int RTK_ehci_usb2_phy_toggle(struct device *hcd_dev, bool isConnect)
+{
+	struct usb_phy *phy = NULL;
+
+	if (hcd_dev == NULL)
+		return -ENODEV;
+
+	phy = devm_usb_get_phy_by_phandle(hcd_dev, "usb-phy", 0);
+	if (IS_ERR(phy)) {
+		dev_err(hcd_dev, "No usb phy found\n");
+		return -ENODEV;
+	}
+
+	dev_dbg(hcd_dev, "%s\n", __func__);
+#ifdef CONFIG_RTK_USB_RLE0599_PHY
+	if (phy != NULL)
+		rtk_rle0599_phy_toggle(phy, isConnect);
+#endif
+	return 0;
+}
+
+extern int rtk_usb_init_port_power_on(struct device *usb_dev);
+extern int rtk_usb_manager_schedule_work(struct device *usb_dev, struct work_struct *work);
+
+static void ehci_rtk_probe_work(struct work_struct *work)
+{
+	struct ehci_rtk *rtk = container_of(work, struct ehci_rtk, work);
+	struct device		*dev = rtk->dev;
+	struct usb_hcd *hcd = ehci_to_hcd(rtk->ehci);
+	struct usb_phy *phy = rtk->phy;
+
+	int irq = rtk->irq;
+	int ret = 0;
+
+	unsigned long probe_time = jiffies;
+
+	dev_info(dev, "%s Start ...\n", __func__);
+
+	usb_phy_init(phy);
+
+	ret = usb_add_hcd(hcd, irq, IRQF_SHARED);
+	if (ret) {
+		dev_err(dev, "%s: error add hcd\n", __func__);
+		usb_put_hcd(hcd);
+	}
+
+	rtk_usb_init_port_power_on(dev);
+
+	dev_info(dev, "%s End ... ok! (take %d ms)\n", __func__,
+			jiffies_to_msecs(jiffies - probe_time));
+	return;
+}
+
+static int ehci_rtk_drv_probe(struct platform_device *pdev)
+{
+	struct resource res;
+	struct usb_hcd *hcd;
+	struct ehci_hcd *ehci;
+	void __iomem *regs;
+	int irq, err = 0;
+	struct usb_phy *phy;
+	unsigned long probe_time = jiffies;
+
+	if (usb_disabled())
+		return -ENODEV;
+
+	dev_info(&pdev->dev, "Probe Realtek-SoC USB EHCI Host Controller\n");
+
+	//phy = devm_usb_get_phy(&pdev->dev, USB_PHY_TYPE_USB2);
+	phy = devm_usb_get_phy_by_phandle(&pdev->dev, "usb-phy", 0);
+	if (IS_ERR(phy)) {
+		dev_err(&pdev->dev, "No usb phy found\n");
+		return -ENODEV;
+	}
+
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (irq <= 0) {
+		dev_err(&pdev->dev,
+			"Found HC with no IRQ. Check %s setup!\n",
+			dev_name(&pdev->dev));
+		err = -ENODEV;
+		goto err1;
+	}
+
+	if (of_address_to_resource(pdev->dev.of_node, 0, &res)) {
+		dev_err(&pdev->dev,
+			"Found HC with no register addr. Check %s setup!\n",
+			dev_name(&pdev->dev));
+		err = -ENODEV;
+		goto err1;
+	}
+
+	/*
+	 * Right now device-tree probed devices don't get dma_mask
+	 * set. Since shared usb code relies on it, set it here for
+	 * now. Once we have dma capability bindings this can go away.
+	 */
+	if (!pdev->dev.dma_mask)
+		pdev->dev.dma_mask = &pdev->dev.coherent_dma_mask;
+	if (!pdev->dev.coherent_dma_mask)
+		pdev->dev.coherent_dma_mask = DMA_BIT_MASK(32);
+
+	regs = of_iomap(pdev->dev.of_node, 0);
+	if (regs == NULL) {
+		dev_err(&pdev->dev, "error mapping memory\n");
+		err = -EFAULT;
+		goto err3;
+	}
+
+	if (readl(regs) == 0xdeadbeef) {
+		dev_err(&pdev->dev, "%s error read ehci registers\n", __func__);
+		err = -ENODEV;
+		goto err3;
+	}
+
+	hcd = usb_create_hcd(&ehci_rtk_hc_driver,
+			&pdev->dev, dev_name(&pdev->dev));
+	if (!hcd) {
+		err = -ENOMEM;
+		goto err3;
+	}
+
+	hcd->rsrc_start = res.start;
+	hcd->rsrc_len = resource_size(&res);
+	hcd->regs = regs;
+
+	ehci = hcd_to_ehci(hcd);
+	ehci->caps = hcd->regs;
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (of_property_read_bool(pdev->dev.of_node, "fixed_async_list_addr_bug")) {
+		dev_info(&pdev->dev, "%s Enable fixed_async_list_addr_bug\n", __func__);
+		ehci->fixed_async_list_addr_bug  = 1;
+	}
+#endif
+
+	if (of_property_read_bool(pdev->dev.of_node, "delay_probe_work")) {
+		struct ehci_rtk *rtk;
+		rtk = devm_kzalloc(&pdev->dev, sizeof(*rtk), GFP_KERNEL);
+		if (!rtk) {
+			dev_err(&pdev->dev, "not enough memory\n");
+			err = -ENOMEM;
+			goto err4;
+		}
+		rtk->dev = &pdev->dev;
+		rtk->ehci = ehci;
+		rtk->irq = irq;
+		rtk->phy = phy;
+		INIT_WORK(&rtk->work, ehci_rtk_probe_work);
+		if (of_property_read_bool(pdev->dev.of_node, "ordered_probe"))
+			rtk_usb_manager_schedule_work(&pdev->dev, &rtk->work);
+		else
+			schedule_work(&rtk->work);
+	} else {
+		usb_phy_init(phy);
+
+		err = usb_add_hcd(hcd, irq, IRQF_SHARED);
+		if (err) {
+			dev_err(&pdev->dev, "error add hcd\n");
+			goto err4;
+		}
+	}
+
+	dev_info(&pdev->dev, "%s OK (take %d ms)\n", __func__, jiffies_to_msecs(jiffies - probe_time));
+	return 0;
+
+err4:
+	usb_put_hcd(hcd);
+err3:
+	irq_dispose_mapping(irq);
+err1:
+	dev_err(&pdev->dev, "%s: Probe %s fail, %d\n", __func__,
+		dev_name(&pdev->dev), err);
+
+	return err;
+
+}
+
+static int ehci_rtk_drv_remove(struct platform_device *pdev)
+{
+	struct usb_hcd *hcd = platform_get_drvdata(pdev);
+
+	dev_set_drvdata(&pdev->dev, NULL);
+
+	usb_remove_hcd(hcd);
+	irq_dispose_mapping(hcd->irq);
+	usb_put_hcd(hcd);
+
+	return 0;
+}
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+bool RTK_ehci_check_schedule_actived(const char *func)
+{
+	static struct ehci_hcd *ehci = NULL;
+	struct device_node *node = NULL;
+	struct platform_device *pdev = NULL;
+	struct usb_hcd *hcd = NULL;
+	bool connected = false;
+	u32 status;
+
+	if (ehci == NULL) {
+		node = of_find_compatible_node(NULL, NULL, "Realtek,rtd129x-ehci");
+		if (node != NULL)
+			pdev = of_find_device_by_node(node);
+		if (pdev != NULL) {
+			hcd = platform_get_drvdata(pdev);
+			ehci = hcd_to_ehci(hcd);
+		}
+	}
+	if (ehci == NULL) {
+		pr_debug("%s NO EHCI\n", __func__);
+		return false;
+	}
+	status = ehci_readl(ehci, &ehci->regs->status);
+	if (status & (STS_PSS | STS_ASS))
+		connected = true;
+	return connected;
+}
+#endif //CONFIG_USB_PATCH_ON_RTK
+
+#ifdef CONFIG_SUSPEND
+static int rtk_ehci_suspend(struct device *dev);
+int RTK_rtk_ehci_suspend(struct device *dev)
+{
+	return rtk_ehci_suspend(dev);
+}
+
+static int rtk_ehci_suspend(struct device *dev)
+{
+	struct usb_hcd *hcd = dev_get_drvdata(dev);
+	struct platform_device *pdev = to_platform_device(dev);
+	struct usb_phy *phy;
+	bool do_wakeup = device_may_wakeup(dev);
+	int rc = 0;
+
+	dev_info(dev, "[USB] Enter %s", __func__);
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		goto out;
+	}
+	dev_info(dev, "[USB] %s Suspend mode\n", __func__);
+
+	rc = ehci_suspend(hcd, do_wakeup);
+
+	phy = devm_usb_get_phy_by_phandle(&pdev->dev, "usb-phy", 0);
+	if (IS_ERR(phy)) {
+		dev_err(&pdev->dev, "No usb phy found\n");
+		return -ENODEV;
+	} else {
+		usb_phy_shutdown(phy);
+	}
+
+out:
+	dev_info(dev, "[USB] Exit %s", __func__);
+	return rc;
+}
+
+static int rtk_ehci_resume(struct device *dev);
+int RTK_rtk_ehci_resume(struct device *dev)
+{
+	return rtk_ehci_resume(dev);
+}
+
+static int rtk_ehci_resume(struct device *dev)
+{
+	struct usb_hcd *hcd = dev_get_drvdata(dev);
+	struct platform_device *pdev = to_platform_device(dev);
+	struct usb_phy *phy;
+
+	dev_info(dev, "[USB] Enter %s", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		goto out;
+	}
+	dev_info(dev, "[USB] %s Suspend mode\n", __func__);
+
+	phy = devm_usb_get_phy_by_phandle(&pdev->dev, "usb-phy", 0);
+	if (IS_ERR(phy)) {
+		dev_err(&pdev->dev, "No usb phy found\n");
+		return -ENODEV;
+	} else {
+		usb_phy_init(phy);
+	}
+
+	ehci_resume(hcd, false);
+
+out:
+	dev_info(dev, "[USB] Exit %s", __func__);
+	return 0;
+}
+
+#else
+#define rtk_ehci_suspend	NULL
+#define rtk_ehci_resume		NULL
+#endif
+
+static const struct dev_pm_ops rtk_ehci_pm_ops = {
+	SET_SYSTEM_SLEEP_PM_OPS(rtk_ehci_suspend, rtk_ehci_resume)
+	//SET_LATE_SYSTEM_SLEEP_PM_OPS(rtk_ehci_suspend, rtk_ehci_resume)
+};
+
+static const struct of_device_id ehci_rtk_dt_ids[] = {
+	{ .compatible = "Realtek,rtd119x-ehci", },
+	{ .compatible = "Realtek,rtd129x-ehci", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, ehci_rtk_dt_ids);
+
+static struct platform_driver ehci_rtk_driver = {
+	.probe		= ehci_rtk_drv_probe,
+	.remove		= ehci_rtk_drv_remove,
+	.shutdown	= usb_hcd_platform_shutdown,
+	.driver = {
+		.name	= "rtk-ehci",
+		.owner  = THIS_MODULE,
+		.pm		= &rtk_ehci_pm_ops,
+		.of_match_table = of_match_ptr(ehci_rtk_dt_ids),
+	},
+};
+
+static int __init ehci_rtk_init(void)
+{
+	if (usb_disabled())
+		return -ENODEV;
+
+	pr_info("%s: " DRIVER_DESC " init\n", hcd_name);
+
+	ehci_init_driver(&ehci_rtk_hc_driver, NULL);
+	return platform_driver_register(&ehci_rtk_driver);
+}
+module_init(ehci_rtk_init);
+//late_initcall_sync(ehci_rtk_init);
+
+static void __exit ehci_rtk_cleanup(void)
+{
+	platform_driver_unregister(&ehci_rtk_driver);
+}
+module_exit(ehci_rtk_cleanup);
+
+MODULE_DESCRIPTION(DRIVER_DESC);
+MODULE_ALIAS("platform:rtk-ehci");
+MODULE_LICENSE("GPL");
diff --git a/drivers/usb/host/ehci-sched.c b/drivers/usb/host/ehci-sched.c
index 1dfe54f..def3e9e 100644
--- a/drivers/usb/host/ehci-sched.c
+++ b/drivers/usb/host/ehci-sched.c
@@ -19,6 +19,11 @@
 
 /* this file is part of ehci-hcd.c */
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+extern int RTK_ohci_force_suspend(const char *func);
+#endif
+
 /*-------------------------------------------------------------------------*/
 
 /*
@@ -941,6 +946,14 @@ static int intr_submit(
 	/* get endpoint and transfer/schedule data */
 	epnum = urb->ep->desc.bEndpointAddress;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_USB_OHCI_RTK
+	/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+	/* When EHCI schedule actived, force suspend OHCI*/
+	RTK_ohci_force_suspend(__func__);
+#endif
+#endif
+
 	spin_lock_irqsave(&ehci->lock, flags);
 
 	if (unlikely(!HCD_HW_ACCESSIBLE(ehci_to_hcd(ehci)))) {
diff --git a/drivers/usb/host/ehci.h b/drivers/usb/host/ehci.h
index 3f3b74a..70f508b 100644
--- a/drivers/usb/host/ehci.h
+++ b/drivers/usb/host/ehci.h
@@ -230,6 +230,9 @@ struct ehci_hcd {			/* one per controller */
 	unsigned		frame_index_bug:1; /* MosChip (AKA NetMos) */
 	unsigned		need_oc_pp_cycle:1; /* MPC834X port power */
 	unsigned		imx28_write_fix:1; /* For Freescale i.MX28 */
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	unsigned		fixed_async_list_addr_bug:1;
+#endif
 
 	/* required for usb32 quirk */
 	#define OHCI_CTRL_HCFS          (3 << 6)
diff --git a/drivers/usb/host/ohci-hcd.c b/drivers/usb/host/ohci-hcd.c
index 1afb76e..1d5f6a6 100644
--- a/drivers/usb/host/ohci-hcd.c
+++ b/drivers/usb/host/ohci-hcd.c
@@ -1255,6 +1255,12 @@ void ohci_init_driver(struct hc_driver *drv,
 #define PLATFORM_DRIVER		ohci_hcd_tilegx_driver
 #endif
 
+#ifdef CONFIG_USB_OHCI_RTK
+#include "ohci-rtk.c"
+#define	PLATFORM_DRIVER		ohci_rtk_driver
+#endif
+
+
 static int __init ohci_hcd_mod_init(void)
 {
 	int retval = 0;
diff --git a/drivers/usb/host/ohci-hub.c b/drivers/usb/host/ohci-hub.c
index 798b2d2..eb3ba3d 100644
--- a/drivers/usb/host/ohci-hub.c
+++ b/drivers/usb/host/ohci-hub.c
@@ -42,6 +42,14 @@
 static void update_done_list(struct ohci_hcd *);
 static void ohci_work(struct ohci_hcd *);
 
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_USB_EHCI_RTK
+/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+extern bool RTK_ehci_check_schedule_actived(const char *func);
+#endif
+#endif
+
 #ifdef	CONFIG_PM
 static int ohci_rh_suspend (struct ohci_hcd *ohci, int autostop)
 __releases(ohci->lock)
@@ -154,6 +162,20 @@ static int ohci_rh_resume (struct ohci_hcd *ohci)
 	int			status = -EINPROGRESS;
 	int			autostopped = ohci->autostop;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_USB_EHCI_RTK
+	/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+	/* When EHCI schedule actived, don't resume OHCI*/
+	if (RTK_ehci_check_schedule_actived(__func__)) {
+		ohci_info (ohci, "[Workaround] %s EHCI schedule actived, skip resume OHCI\n", __func__);
+		return 0;
+	} else {
+		ohci->resuming = 1;
+		init_completion(&ohci->resuming_done);
+	}
+#endif
+#endif
+
 	ohci->autostop = 0;
 	ohci->hc_control = ohci_readl (ohci, &ohci->regs->control);
 
@@ -294,6 +316,12 @@ static int ohci_rh_resume (struct ohci_hcd *ohci)
 	}
 
 	ohci->rh_state = OHCI_RH_RUNNING;
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (ohci->resuming) {
+		complete(&ohci->resuming_done);
+		ohci->resuming = 0;
+	}
+#endif
 	return 0;
 }
 
@@ -520,6 +548,17 @@ int ohci_hub_status_data(struct usb_hcd *hcd, char *buf)
 	else
 		clear_bit(HCD_FLAG_POLL_RH, &hcd->flags);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* add to check OHCI register deadbeef */
+	if (true) {
+		u32 status = roothub_portstatus (ohci, 0);
+		if (status == 0xdeadbeef) {
+			ohci_err(ohci, "OHCI register is 0x%x"
+					" to clear HCD_FLAG_POLL_RH", status);
+			clear_bit(HCD_FLAG_POLL_RH, &hcd->flags);
+		}
+	}
+#endif //CONFIG_USB_PATCH_ON_RTK
 
 done:
 	spin_unlock_irqrestore (&ohci->lock, flags);
diff --git a/drivers/usb/host/ohci-rtk.c b/drivers/usb/host/ohci-rtk.c
new file mode 100644
index 00000000..06a6251
--- /dev/null
+++ b/drivers/usb/host/ohci-rtk.c
@@ -0,0 +1,440 @@
+/*
+ *  ohic-rtk.c RTK OHCI HCD (Host Controller Driver)
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/mbus.h>
+#include <linux/clk.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/usb.h>
+#include <linux/usb/hcd.h>
+#include <linux/io.h>
+#include <linux/dma-mapping.h>
+#include <linux/suspend.h>
+#include <linux/completion.h>
+
+#define RTK_OHCI_HCD_NAME "rtk-ohci"
+
+extern int usb_disabled(void);
+
+static int ohci_rtk_setup(struct usb_hcd *hcd)
+{
+	struct ohci_hcd	*ohci = hcd_to_ohci(hcd);
+	int ret;
+
+	ohci_dbg(ohci, "ohci_rtk_setup, ohci:%p", ohci);
+
+	ret = ohci_init(ohci);
+	if (ret < 0)
+		return ret;
+	return 0;
+}
+
+static int ohci_rtk_dmp_start(struct usb_hcd *hcd)
+{
+	struct ohci_hcd	*ohci = hcd_to_ohci(hcd);
+	int ret;
+
+	ohci_dbg(ohci, "ohci_rtk_dmp_start, ohci:%p", ohci);
+
+	ret = ohci_run(ohci);
+	if (ret < 0) {
+		printk ("can't start %s", hcd->self.bus_name);
+		ohci_stop(hcd);
+		return ret;
+	}
+
+	return 0;
+}
+
+static const struct hc_driver ohci_rtk_dmp_hc_driver = {
+	.description =		hcd_name,
+	.product_desc =		"Rtk Dmp OHCI",
+	.hcd_priv_size =	sizeof(struct ohci_hcd),
+
+	/*
+	 * generic hardware linkage
+	 */
+	.irq =			ohci_irq,
+	.flags =		HCD_USB11 | HCD_MEMORY,
+
+	/*
+	 * basic lifecycle operations
+	 */
+	.reset =		ohci_rtk_setup,
+	.start =		ohci_rtk_dmp_start,
+	.stop =			ohci_stop,
+	.shutdown =		ohci_shutdown,
+
+	/*
+	 * managing i/o requests and associated device resources
+	 */
+	.urb_enqueue =		ohci_urb_enqueue,
+	.urb_dequeue =		ohci_urb_dequeue,
+	.endpoint_disable =	ohci_endpoint_disable,
+
+	/*
+	 * scheduling support
+	 */
+	.get_frame_number =	ohci_get_frame,
+
+	/*
+	 * root hub support
+	 */
+	.hub_status_data =	ohci_hub_status_data,
+	.hub_control =		ohci_hub_control,
+#ifdef	CONFIG_PM
+	.bus_suspend =		ohci_bus_suspend,
+	.bus_resume =		ohci_bus_resume,
+#endif
+	.start_port_reset =	ohci_start_port_reset,
+};
+
+struct ohci_rtk {
+	struct device *dev;
+	struct ohci_hcd *ohci;
+	struct usb_phy *phy;
+	int irq;
+
+	struct work_struct work;
+};
+
+extern void rtk_usb_init_port_power_on(struct device *dev);
+extern int rtk_usb_manager_schedule_work(struct device *usb_dev, struct work_struct *work);
+
+static void ohci_rtk_probe_work(struct work_struct *work)
+{
+	struct ohci_rtk *rtk = container_of(work, struct ohci_rtk, work);
+	struct device		*dev = rtk->dev;
+	struct usb_hcd *hcd = ohci_to_hcd(rtk->ohci);
+	struct usb_phy *phy = rtk->phy;
+	int irq = rtk->irq;
+	int ret = 0;
+
+	unsigned long probe_time = jiffies;
+
+	dev_info(dev, "%s Start ...\n", __func__);
+
+	usb_phy_init(phy);
+
+	ret = usb_add_hcd(hcd, irq, IRQF_SHARED);
+	if (ret) {
+		dev_err(dev, "%s: error add hcd\n", __func__);
+		usb_put_hcd(hcd);
+	}
+
+	rtk_usb_init_port_power_on(dev);
+
+	dev_info(dev, "%s End ... ok! (take %d ms)\n", __func__, jiffies_to_msecs(jiffies - probe_time));
+	return;
+}
+
+static int ohci_rtk_drv_probe(struct platform_device *pdev)
+{
+	struct usb_hcd *hcd;
+	struct ohci_hcd *ohci;
+	void *reg_base;
+	struct resource res;
+	int irq;
+	int ret;
+	struct usb_phy *phy;
+	unsigned long probe_time = jiffies;
+
+	if (usb_disabled())
+		return -ENODEV;
+
+	dev_info(&pdev->dev, "Probe Realtek-SoC USB OHCI Host Controller\n");
+
+	//phy = devm_usb_get_phy(&pdev->dev, USB_PHY_TYPE_USB2);
+	phy = devm_usb_get_phy_by_phandle(&pdev->dev, "usb-phy", 0);
+	if (IS_ERR(phy)) {
+		dev_err(&pdev->dev, "No usb phy found\n");
+		return -ENODEV;
+	}
+
+	irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+	if (irq <= 0) {
+		dev_err(&pdev->dev,
+			"Found HC with no IRQ. Check %s setup!\n",
+			dev_name(&pdev->dev));
+		return -ENODEV;
+	}
+
+	if (of_address_to_resource(pdev->dev.of_node, 0, &res)) {
+		dev_err(&pdev->dev,
+			"Found HC with no register addr. Check %s setup!\n",
+			dev_name(&pdev->dev));
+		return -ENODEV;
+	}
+
+	/*
+	 * Right now device-tree probed devices don't get dma_mask
+	 * set. Since shared usb code relies on it, set it here for
+	 * now. Once we have dma capability bindings this can go away.
+	 */
+	if (!pdev->dev.dma_mask)
+		pdev->dev.dma_mask = &pdev->dev.coherent_dma_mask;
+	if (!pdev->dev.coherent_dma_mask)
+		pdev->dev.coherent_dma_mask = DMA_BIT_MASK(32);
+
+	hcd = usb_create_hcd(&ohci_rtk_dmp_hc_driver, &pdev->dev, dev_name(&pdev->dev));
+	if (!hcd)
+		return -ENOMEM;
+
+	hcd->rsrc_start = res.start;
+	hcd->rsrc_len = resource_size(&res);
+
+	reg_base = of_iomap(pdev->dev.of_node, 0);
+	if (!reg_base) {
+		dev_err(&pdev->dev, "ioremap failed\n");
+		ret = -ENOMEM;
+		goto err2;
+	}
+
+	if (readl(reg_base) == 0xdeadbeef) {
+		dev_err(&pdev->dev, "%s error read ohci registers\n", __func__);
+		ret = -ENODEV;
+		goto err2;
+	}
+
+	hcd->regs = reg_base;
+
+	ohci = hcd_to_ohci(hcd);
+
+	ohci_hcd_init(ohci);
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (pdev->dev.of_node) {
+		u32 wrap_reg = 0;
+		of_property_read_u32(pdev->dev.of_node, "wrap_reg", &wrap_reg);
+		if (wrap_reg)
+			ohci->wrap_reg = ioremap(wrap_reg, 0x4);
+		else
+			ohci->wrap_reg = NULL;
+	}
+#endif
+
+	if (of_property_read_bool(pdev->dev.of_node, "delay_probe_work")) {
+		struct ohci_rtk *rtk;
+		rtk = devm_kzalloc(&pdev->dev, sizeof(*rtk), GFP_KERNEL);
+		if (!rtk) {
+			dev_err(&pdev->dev, "not enough memory\n");
+			ret = -ENOMEM;
+			goto err2;
+		}
+		rtk->dev = &pdev->dev;
+		rtk->ohci = ohci;
+		rtk->phy = phy;
+		rtk->irq = irq;
+		INIT_WORK(&rtk->work, ohci_rtk_probe_work);
+		if (of_property_read_bool(pdev->dev.of_node, "ordered_probe"))
+			rtk_usb_manager_schedule_work(&pdev->dev, &rtk->work);
+		else
+			schedule_work(&rtk->work);
+	} else {
+		usb_phy_init(phy);
+
+		ret = usb_add_hcd(hcd, irq, IRQF_SHARED);
+		if (ret) {
+			dev_err(&pdev->dev, "failed to add hcd with err %d\n", ret);
+			goto err2;
+		}
+	}
+
+	platform_set_drvdata(pdev, hcd);
+
+	dev_info(&pdev->dev, "%s OK (take %d ms)\n", __func__, jiffies_to_msecs(jiffies - probe_time));
+	return 0;
+
+err2:
+	irq_dispose_mapping(irq);
+//err1:
+	usb_put_hcd(hcd);
+	return ret;
+}
+
+static int ohci_rtk_drv_remove(struct platform_device *pdev)
+{
+	struct usb_hcd *hcd = platform_get_drvdata(pdev);
+
+	usb_remove_hcd(hcd);
+
+	iounmap(hcd->regs);
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (hcd) {
+		struct ohci_hcd *ohci;
+		ohci = hcd_to_ohci(hcd);
+		if (ohci->wrap_reg)
+			__iounmap(ohci->wrap_reg);
+	}
+#endif
+
+	release_mem_region(hcd->rsrc_start, hcd->rsrc_len);
+	usb_put_hcd(hcd);
+
+	platform_set_drvdata(pdev, NULL);
+
+	return 0;
+}
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+extern int usb_runtime_suspend(struct device *dev);
+
+/* Add Workaround to fixed EHCI/OHCI Wrapper can't work simultaneously */
+int RTK_ohci_force_suspend(const char *func)
+{
+	static struct ohci_hcd *s_ohci = NULL;
+	struct device_node *node = NULL;
+	struct platform_device *pdev = NULL;
+	struct usb_hcd *hcd = NULL;
+	struct ohci_hcd *ohci = NULL;
+	unsigned long	flags;
+
+	if (s_ohci == NULL) {
+		node = of_find_compatible_node(NULL, NULL, "Realtek,rtd129x-ohci");
+		if (node != NULL)
+			pdev = of_find_device_by_node(node);
+		if (pdev != NULL) {
+			hcd = platform_get_drvdata(pdev);
+			s_ohci = hcd_to_ohci(hcd);
+		}
+	} else
+		ohci = s_ohci;
+
+	if (ohci) {
+		u32 hc_control;
+		int resuming;
+
+		spin_lock_irqsave(&ohci->lock, flags);
+		resuming = ohci->resuming;
+		spin_unlock_irqrestore(&ohci->lock, flags);
+
+		if (resuming) {
+			ohci_dbg(ohci, "%s wait for resuming done !!\n", __func__);
+			if (!wait_for_completion_timeout(&ohci->resuming_done, msecs_to_jiffies(1000))) {
+				ohci_info(ohci,
+					"%s timed out on wait resuming_done\n", __func__);
+			}
+		}
+
+		spin_lock_irqsave(&ohci->lock, flags);
+		hc_control = ohci_readl (ohci, &ohci->regs->control);
+		if ((hc_control&OHCI_CTRL_HCFS) == OHCI_USB_OPER) {
+#ifdef CONFIG_PM
+			ohci_info(ohci, "%s force suspend by %s\n",
+					__func__, func);
+			ohci_rh_suspend(ohci, 1);
+#else
+			ohci_err(ohci, "%s NO build config CONFIG_PM!!\n", __func__);
+#endif
+		}
+		spin_unlock_irqrestore (&ohci->lock, flags);
+
+	} else
+		pr_debug("%s NO OHCI !!!\n", __func__);
+	return 0;
+}
+#endif //CONFIG_USB_PATCH_ON_RTK
+
+#ifdef CONFIG_PM
+static int rtk_ohci_suspend(struct device *dev)
+{
+	struct usb_hcd *hcd = dev_get_drvdata(dev);
+	struct platform_device *pdev = to_platform_device(dev);
+	struct usb_phy *phy;
+	bool do_wakeup = device_may_wakeup(dev);
+	int rc = 0;
+
+	dev_info(dev, "[USB] Enter %s", __func__);
+
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		goto out;
+	}
+	dev_info(dev, "[USB] %s Suspend mode\n", __func__);
+
+	rc = ohci_suspend(hcd, do_wakeup);
+
+	phy = devm_usb_get_phy_by_phandle(&pdev->dev, "usb-phy", 0);
+	if (IS_ERR(phy)) {
+		dev_err(&pdev->dev, "No usb phy found\n");
+		return -ENODEV;
+	} else {
+		usb_phy_shutdown(phy);
+	}
+out:
+	dev_info(dev, "[USB] Exit %s", __func__);
+	return rc;
+}
+
+static int rtk_ohci_resume(struct device *dev)
+{
+	struct usb_hcd *hcd = dev_get_drvdata(dev);
+	struct platform_device *pdev = to_platform_device(dev);
+	struct usb_phy *phy;
+
+	dev_info(dev, "[USB] Enter %s", __func__);
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		//For idle mode
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		goto out;
+	}
+	dev_info(dev, "[USB] %s Suspend mode\n", __func__);
+
+	phy = devm_usb_get_phy_by_phandle(&pdev->dev, "usb-phy", 0);
+	if (IS_ERR(phy)) {
+		dev_err(&pdev->dev, "No usb phy found\n");
+		return -ENODEV;
+	} else {
+		usb_phy_init(phy);
+	}
+
+	ohci_resume(hcd, false);
+out:
+	dev_info(dev, "[USB] Exit %s", __func__);
+	return 0;
+}
+#else
+#define rtk_ohci_suspend       NULL
+#define rtk_ohci_resume        NULL
+#endif
+
+static const struct dev_pm_ops rtk_ohci_pm_ops = {
+	SET_SYSTEM_SLEEP_PM_OPS(rtk_ohci_suspend, rtk_ohci_resume)
+	//SET_LATE_SYSTEM_SLEEP_PM_OPS(rtk_ohci_suspend, rtk_ohci_resume)
+};
+
+static const struct of_device_id ohci_rtk_dt_ids[] = {
+	{ .compatible = "Realtek,rtd119x-ohci", },
+	{ .compatible = "Realtek,rtd129x-ohci", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, ohci_rtk_dt_ids);
+
+static struct platform_driver ohci_rtk_driver = {
+	.probe		= ohci_rtk_drv_probe,
+	.remove		= ohci_rtk_drv_remove,
+	.shutdown	= usb_hcd_platform_shutdown,
+	.driver		= {
+		.name	= RTK_OHCI_HCD_NAME,
+		.owner	= THIS_MODULE,
+		.pm		= &rtk_ohci_pm_ops,
+		.of_match_table = of_match_ptr(ohci_rtk_dt_ids),
+	},
+};
+
+MODULE_ALIAS("platform:" RTK_OHCI_HCD_NAME);
diff --git a/drivers/usb/host/ohci.h b/drivers/usb/host/ohci.h
index a51b189..9f021ce 100644
--- a/drivers/usb/host/ohci.h
+++ b/drivers/usb/host/ohci.h
@@ -7,6 +7,10 @@
  * This file is licenced under the GPL.
  */
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#include <soc/realtek/rtd129x_lockapi.h>
+#endif
+
 /*
  * __hc32 and __hc16 are "Host Controller" types, they may be equivalent to
  * __leXX (normally) or __beXX (given OHCI_BIG_ENDIAN), depending on the
@@ -366,6 +370,10 @@ struct ohci_hcd {
 	 */
 	struct ohci_regs __iomem *regs;
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	void __iomem *wrap_reg;
+#endif
+
 	/*
 	 * main memory used to communicate with the HC (dma-consistent).
 	 * hcd adds to schedule for a live hc any time, but removals finish
@@ -396,6 +404,10 @@ struct ohci_hcd {
 	 * driver state
 	 */
 	enum ohci_rh_state	rh_state;
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	int 		resuming;
+	struct completion resuming_done;
+#endif
 	int			num_ports;
 	int			load [NUM_INTS];
 	u32			hc_control;	/* copy of hc control reg */
@@ -561,6 +573,18 @@ static inline struct usb_hcd *ohci_to_hcd (const struct ohci_hcd *ohci)
 static inline unsigned int _ohci_readl (const struct ohci_hcd *ohci,
 					__hc32 __iomem * regs)
 {
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	unsigned long flags;
+	rtk_lockapi_lock(flags, __FUNCTION__); /* Add global lock for emmc issue*/
+	if (ohci->wrap_reg && readl(ohci->wrap_reg) == 0x0) {
+		ohci_err(ohci, "%s [USB Workaround] fixed force to enable "
+			    "ohci clock \n", __func__);
+		writel(0x40, ohci->wrap_reg);
+		mdelay(1);
+	}
+	rtk_lockapi_unlock(flags,__FUNCTION__); /* Add global lock for emmc issue*/
+#endif
+
 #ifdef CONFIG_USB_OHCI_BIG_ENDIAN_MMIO
 	return big_endian_mmio(ohci) ?
 		readl_be (regs) :
@@ -573,6 +597,17 @@ static inline unsigned int _ohci_readl (const struct ohci_hcd *ohci,
 static inline void _ohci_writel (const struct ohci_hcd *ohci,
 				 const unsigned int val, __hc32 __iomem *regs)
 {
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	unsigned long flags;
+	rtk_lockapi_lock(flags, __FUNCTION__); /* Add global lock for emmc issue*/
+	if (ohci->wrap_reg && readl(ohci->wrap_reg) == 0x0) {
+		ohci_err(ohci, "%s [USB Workaround] fixed force to enable ohci clock \n", __func__);
+		writel(0x40, ohci->wrap_reg);
+		mdelay(1);
+	}
+	rtk_lockapi_unlock(flags,__FUNCTION__); /* Add global lock for emmc issue*/
+#endif
+
 #ifdef CONFIG_USB_OHCI_BIG_ENDIAN_MMIO
 	big_endian_mmio(ohci) ?
 		writel_be (val, regs) :
diff --git a/drivers/usb/host/xhci-debugfs.c b/drivers/usb/host/xhci-debugfs.c
new file mode 100644
index 00000000..00187f7
--- /dev/null
+++ b/drivers/usb/host/xhci-debugfs.c
@@ -0,0 +1,1415 @@
+
+#include <linux/uaccess.h>
+#include <linux/debugfs.h>
+#include <linux/slab.h>
+#include "xhci.h"
+
+#define XHCI_INIT_VALUE 0x0
+
+#define TO_NEXT(next, size, inc) \
+do { 				\
+	size -= inc; 	\
+	next += inc; 	\
+} while (0)
+
+static struct dentry *xhci_debug_root;
+
+static void xhci_dbgfs_regs(struct xhci_hcd *xhci,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	u32 temp;
+
+	inc = snprintf(next, size, "// xHCI capability registers at %p:\n",
+			xhci->cap_regs);
+	TO_NEXT(next, size, inc);
+	temp = readl(&xhci->cap_regs->hc_capbase);
+	inc = snprintf(next, size, "// @%p = 0x%x (CAPLENGTH AND HCIVERSION)\n",
+			&xhci->cap_regs->hc_capbase, temp);
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "//   CAPLENGTH: 0x%x\n",
+			(unsigned int) HC_LENGTH(temp));
+	TO_NEXT(next, size, inc);
+#if 0
+	inc = snprintf(next, size, "//   HCIVERSION: 0x%x\n",
+			(unsigned int) HC_VERSION(temp));
+	TO_NEXT(next, size, inc);
+#endif
+
+	inc = snprintf(next, size, "// xHCI operational registers at %p:\n", xhci->op_regs);
+	TO_NEXT(next, size, inc);
+
+	temp = readl(&xhci->cap_regs->run_regs_off);
+	inc = snprintf(next, size, "// @%p = 0x%x RTSOFF\n",
+			&xhci->cap_regs->run_regs_off,
+			(unsigned int) temp & RTSOFF_MASK);
+	TO_NEXT(next, size, inc);
+
+	inc = snprintf(next, size, "// xHCI runtime registers at %p:\n", xhci->run_regs);
+	TO_NEXT(next, size, inc);
+
+	temp = readl(&xhci->cap_regs->db_off);
+	inc = snprintf(next, size, "// @%p = 0x%x DBOFF\n", &xhci->cap_regs->db_off, temp);
+	TO_NEXT(next, size, inc);
+
+	inc = snprintf(next, size, "// Doorbell array at %p:\n", xhci->dba);
+	TO_NEXT(next, size, inc);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_print_cap_regs(struct xhci_hcd *xhci,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	u32 temp;
+
+	inc = snprintf(next, size, "xHCI capability registers at %p:\n", xhci->cap_regs);
+	TO_NEXT(next, size, inc);
+
+	temp = readl(&xhci->cap_regs->hc_capbase);
+	inc = snprintf(next, size, "CAPLENGTH AND HCIVERSION 0x%x:\n",
+			(unsigned int) temp);
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "CAPLENGTH: 0x%x\n",
+			(unsigned int) HC_LENGTH(temp));
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "HCIVERSION: 0x%x\n",
+			(unsigned int) HC_VERSION(temp));
+	TO_NEXT(next, size, inc);
+
+	temp = readl(&xhci->cap_regs->hcs_params1);
+	inc = snprintf(next, size, "HCSPARAMS 1: 0x%x\n",
+			(unsigned int) temp);
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  Max device slots: %u\n",
+			(unsigned int) HCS_MAX_SLOTS(temp));
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  Max interrupters: %u\n",
+			(unsigned int) HCS_MAX_INTRS(temp));
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  Max ports: %u\n",
+			(unsigned int) HCS_MAX_PORTS(temp));
+	TO_NEXT(next, size, inc);
+
+	temp = readl(&xhci->cap_regs->hcs_params2);
+	inc = snprintf(next, size, "HCSPARAMS 2: 0x%x\n",
+			(unsigned int) temp);
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  Isoc scheduling threshold: %u\n",
+			(unsigned int) HCS_IST(temp));
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  Maximum allowed segments in event ring: %u\n",
+			(unsigned int) HCS_ERST_MAX(temp));
+	TO_NEXT(next, size, inc);
+
+	temp = readl(&xhci->cap_regs->hcs_params3);
+	inc = snprintf(next, size, "HCSPARAMS 3 0x%x:\n",
+			(unsigned int) temp);
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  Worst case U1 device exit latency: %u\n",
+			(unsigned int) HCS_U1_LATENCY(temp));
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  Worst case U2 device exit latency: %u\n",
+			(unsigned int) HCS_U2_LATENCY(temp));
+	TO_NEXT(next, size, inc);
+
+	temp = readl(&xhci->cap_regs->hcc_params);
+	inc = snprintf(next, size, "HCC PARAMS 0x%x:\n", (unsigned int) temp);
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  HC generates %s bit addresses\n",
+			HCC_64BIT_ADDR(temp) ? "64" : "32");
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  FIXME: more HCCPARAMS debugging\n");
+	TO_NEXT(next, size, inc);
+
+	temp = readl(&xhci->cap_regs->run_regs_off);
+	inc = snprintf(next, size, "RTSOFF 0x%x:\n", temp & RTSOFF_MASK);
+	TO_NEXT(next, size, inc);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_print_command_reg(struct xhci_hcd *xhci,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	u32 temp;
+
+	temp = readl(&xhci->op_regs->command);
+	inc = snprintf(next, size, "USBCMD 0x%x:\n", temp);
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  HC is %s\n",
+			(temp & CMD_RUN) ? "running" : "being stopped");
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  HC has %sfinished hard reset\n",
+			(temp & CMD_RESET) ? "not " : "");
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  Event Interrupts %s\n",
+			(temp & CMD_EIE) ? "enabled " : "disabled");
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  Host System Error Interrupts %s\n",
+			(temp & CMD_HSEIE) ? "enabled " : "disabled");
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  HC has %sfinished light reset\n",
+			(temp & CMD_LRESET) ? "not " : "");
+	TO_NEXT(next, size, inc);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_print_status(struct xhci_hcd *xhci,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	u32 temp;
+
+	temp = readl(&xhci->op_regs->status);
+	inc = snprintf(next, size, "USBSTS 0x%x:\n", temp);
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  Event ring is %sempty\n",
+			(temp & STS_EINT) ? "not " : "");
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  %sHost System Error\n",
+			(temp & STS_FATAL) ? "WARNING: " : "No ");
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "  HC is %s\n",
+			(temp & STS_HALT) ? "halted" : "running");
+	TO_NEXT(next, size, inc);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_print_op_regs(struct xhci_hcd *xhci,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	inc = snprintf(next, size, "xHCI operational registers at %p:\n", xhci->op_regs);
+	TO_NEXT(next, size, inc);
+	xhci_dbgfs_print_command_reg(xhci, &next, &size);
+	xhci_dbgfs_print_status(xhci, &next, &size);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_print_ports(struct xhci_hcd *xhci,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	__le32 __iomem *addr;
+	int i, j;
+	int ports;
+	char *names[NUM_PORT_REGS] = {
+		"status",
+		"power",
+		"link",
+		"reserved",
+	};
+
+	ports = HCS_MAX_PORTS(xhci->hcs_params1);
+	addr = &xhci->op_regs->port_status_base;
+	for (i = 0; i < ports; i++) {
+		for (j = 0; j < NUM_PORT_REGS; ++j) {
+			inc = snprintf(next, size, "%p port %s reg = 0x%x\n",
+					addr, names[j],
+					(unsigned int) readl(addr));
+			TO_NEXT(next, size, inc);
+			addr++;
+		}
+	}
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_print_ir_set(struct xhci_hcd *xhci, int set_num,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	struct xhci_intr_reg __iomem *ir_set = &xhci->run_regs->ir_set[set_num];
+	void __iomem *addr;
+	u32 temp;
+	u64 temp_64;
+
+	addr = &ir_set->irq_pending;
+	temp = readl(addr);
+	if (temp == XHCI_INIT_VALUE)
+		return;
+
+	inc = snprintf(next, size, "  %p: ir_set[%i]\n", ir_set, set_num);
+	TO_NEXT(next, size, inc);
+
+	inc = snprintf(next, size, "  %p: ir_set.pending = 0x%x\n", addr,
+			(unsigned int)temp);
+	TO_NEXT(next, size, inc);
+
+	addr = &ir_set->irq_control;
+	temp = readl(addr);
+	inc = snprintf(next, size, "  %p: ir_set.control = 0x%x\n", addr,
+			(unsigned int)temp);
+	TO_NEXT(next, size, inc);
+
+	addr = &ir_set->erst_size;
+	temp = readl(addr);
+	inc = snprintf(next, size, "  %p: ir_set.erst_size = 0x%x\n", addr,
+			(unsigned int)temp);
+	TO_NEXT(next, size, inc);
+
+	addr = &ir_set->rsvd;
+	temp = readl(addr);
+	if (temp != XHCI_INIT_VALUE) {
+		inc = snprintf(next, size, "  WARN: %p: ir_set.rsvd = 0x%x\n",
+				addr, (unsigned int)temp);
+		TO_NEXT(next, size, inc);
+	}
+
+	addr = &ir_set->erst_base;
+	temp_64 = xhci_read_64(xhci, addr);
+	inc = snprintf(next, size, "  %p: ir_set.erst_base = @%08llx\n",
+			addr, temp_64);
+	TO_NEXT(next, size, inc);
+
+	addr = &ir_set->erst_dequeue;
+	temp_64 = xhci_read_64(xhci, addr);
+	inc = snprintf(next, size, "  %p: ir_set.erst_dequeue = @%08llx\n",
+			addr, temp_64);
+	TO_NEXT(next, size, inc);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_print_run_regs(struct xhci_hcd *xhci,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	u32 temp;
+	int i;
+
+	inc = snprintf(next, size, "xHCI runtime registers at %p:\n", xhci->run_regs);
+	TO_NEXT(next, size, inc);
+	temp = readl(&xhci->run_regs->microframe_index);
+	inc = snprintf(next, size, "  %p: Microframe index = 0x%x\n",
+			&xhci->run_regs->microframe_index,
+			(unsigned int) temp);
+	TO_NEXT(next, size, inc);
+	for (i = 0; i < 7; ++i) {
+		temp = readl(&xhci->run_regs->rsvd[i]);
+		if (temp != XHCI_INIT_VALUE) {
+			inc = snprintf(next, size, "  WARN: %p: Rsvd[%i] = 0x%x\n",
+					&xhci->run_regs->rsvd[i],
+					i, (unsigned int) temp);
+			TO_NEXT(next, size, inc);
+		}
+	}
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_print_registers(struct xhci_hcd *xhci,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	xhci_dbgfs_print_cap_regs(xhci, &next, &size);
+	xhci_dbgfs_print_op_regs(xhci, &next, &size);
+	xhci_dbgfs_print_ports(xhci, &next, &size);
+	xhci_dbgfs_print_run_regs(xhci, &next, &size);
+	xhci_dbgfs_print_ir_set(xhci, 0, &next, &size);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_print_trb_offsets(struct xhci_hcd *xhci, union xhci_trb *trb,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	int i;
+	for (i = 0; i < 4; ++i) {
+		inc = snprintf(next, size, "Offset 0x%x = 0x%x\n",
+				i*4, trb->generic.field[i]);
+		TO_NEXT(next, size, inc);
+	}
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+/**
+ * Debug a transfer request block (TRB).
+ */
+static void xhci_dbgfs_trb(struct xhci_hcd *xhci, union xhci_trb *trb,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	u64	address;
+	u32	type = le32_to_cpu(trb->link.control) & TRB_TYPE_BITMASK;
+
+	switch (type) {
+	case TRB_TYPE(TRB_LINK):
+		inc = snprintf(next, size, "Link TRB:\n");
+		TO_NEXT(next, size, inc);
+		xhci_dbgfs_print_trb_offsets(xhci, trb, &next, &size);
+
+		address = le64_to_cpu(trb->link.segment_ptr);
+		inc = snprintf(next, size, "Next ring segment DMA address = 0x%llx\n", address);
+		TO_NEXT(next, size, inc);
+
+		inc = snprintf(next, size, "Interrupter target = 0x%x\n",
+			 GET_INTR_TARGET(le32_to_cpu(trb->link.intr_target)));
+		TO_NEXT(next, size, inc);
+		inc = snprintf(next, size, "Cycle bit = %u\n",
+			 le32_to_cpu(trb->link.control) & TRB_CYCLE);
+		TO_NEXT(next, size, inc);
+		inc = snprintf(next, size, "Toggle cycle bit = %u\n",
+			 le32_to_cpu(trb->link.control) & LINK_TOGGLE);
+		TO_NEXT(next, size, inc);
+		inc = snprintf(next, size, "No Snoop bit = %u\n",
+			 le32_to_cpu(trb->link.control) & TRB_NO_SNOOP);
+		TO_NEXT(next, size, inc);
+		break;
+	case TRB_TYPE(TRB_TRANSFER):
+		address = le64_to_cpu(trb->trans_event.buffer);
+		/*
+		 * FIXME: look at flags to figure out if it's an address or if
+		 * the data is directly in the buffer field.
+		 */
+		inc = snprintf(next, size, "DMA address or buffer contents= %llu\n", address);
+		TO_NEXT(next, size, inc);
+		break;
+	case TRB_TYPE(TRB_COMPLETION):
+		address = le64_to_cpu(trb->event_cmd.cmd_trb);
+		inc = snprintf(next, size, "Command TRB pointer = %llu\n", address);
+		TO_NEXT(next, size, inc);
+		inc = snprintf(next, size, "Completion status = %u\n",
+			 GET_COMP_CODE(le32_to_cpu(trb->event_cmd.status)));
+		TO_NEXT(next, size, inc);
+		inc = snprintf(next, size, "Flags = 0x%x\n",
+			 le32_to_cpu(trb->event_cmd.flags));
+		TO_NEXT(next, size, inc);
+		break;
+	default:
+		inc = snprintf(next, size, "Unknown TRB with TRB type ID %u\n",
+				(unsigned int) type>>10);
+		TO_NEXT(next, size, inc);
+		xhci_dbgfs_print_trb_offsets(xhci, trb, &next, &size);
+		break;
+	}
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+/**
+ * Debug a segment with an xHCI ring.
+ *
+ * @return The Link TRB of the segment, or NULL if there is no Link TRB
+ * (which is a bug, since all segments must have a Link TRB).
+ *
+ * Prints out all TRBs in the segment, even those after the Link TRB.
+ *
+ * XXX: should we print out TRBs that the HC owns?  As long as we don't
+ * write, that should be fine...  We shouldn't expect that the memory pointed to
+ * by the TRB is valid at all.  Do we care about ones the HC owns?  Probably,
+ * for HC debugging.
+ */
+static void xhci_dbgfs_segment(struct xhci_hcd *xhci, struct xhci_segment *seg,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	int i;
+	u64 addr = seg->dma;
+	union xhci_trb *trb = seg->trbs;
+
+	for (i = 0; i < TRBS_PER_SEGMENT; ++i) {
+		trb = &seg->trbs[i];
+		inc = snprintf(next, size, "@%016llx %08x %08x %08x %08x\n", addr,
+			 lower_32_bits(le64_to_cpu(trb->link.segment_ptr)),
+			 upper_32_bits(le64_to_cpu(trb->link.segment_ptr)),
+			 le32_to_cpu(trb->link.intr_target),
+			 le32_to_cpu(trb->link.control));
+		TO_NEXT(next, size, inc);
+		addr += sizeof(*trb);
+	}
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_ring_ptrs(struct xhci_hcd *xhci, struct xhci_ring *ring,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	inc = snprintf(next, size, "Ring deq = %p (virt), 0x%llx (dma)\n",
+			ring->dequeue,
+			(unsigned long long)xhci_trb_virt_to_dma(ring->deq_seg,
+							    ring->dequeue));
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "Ring deq updated %u times\n",
+			ring->deq_updates);
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "Ring enq = %p (virt), 0x%llx (dma)\n",
+			ring->enqueue,
+			(unsigned long long)xhci_trb_virt_to_dma(ring->enq_seg,
+							    ring->enqueue));
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "Ring enq updated %u times\n",
+			ring->enq_updates);
+	TO_NEXT(next, size, inc);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+/**
+ * Debugging for an xHCI ring, which is a queue broken into multiple segments.
+ *
+ * Print out each segment in the ring.  Check that the DMA address in
+ * each link segment actually matches the segment's stored DMA address.
+ * Check that the link end bit is only set at the end of the ring.
+ * Check that the dequeue and enqueue pointers point to real data in this ring
+ * (not some other ring).
+ */
+static void xhci_dbgfs_ring(struct xhci_hcd *xhci, struct xhci_ring *ring,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	/* FIXME: Throw an error if any segment doesn't have a Link TRB */
+	struct xhci_segment *seg;
+	struct xhci_segment *first_seg = ring->first_seg;
+	xhci_dbgfs_segment(xhci, first_seg, &next, &size);
+
+	if (!ring->enq_updates && !ring->deq_updates) {
+		inc = snprintf(next, size, "  Ring has not been updated\n");
+		TO_NEXT(next, size, inc);
+		goto done;
+	}
+	for (seg = first_seg->next; seg != first_seg; seg = seg->next)
+		xhci_dbgfs_segment(xhci, seg, &next, &size);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_ep_rings(struct xhci_hcd *xhci,
+		unsigned int slot_id, unsigned int ep_index,
+		struct xhci_virt_ep *ep,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	int i;
+	struct xhci_ring *ring;
+
+	if (ep->ep_state & EP_HAS_STREAMS) {
+		for (i = 1; i < ep->stream_info->num_streams; i++) {
+			ring = ep->stream_info->stream_rings[i];
+			inc = snprintf(next, size, "Dev %d endpoint %d stream ID %d:\n",
+				slot_id, ep_index, i);
+			TO_NEXT(next, size, inc);
+			xhci_dbgfs_segment(xhci, ring->deq_seg, &next, &size);
+		}
+	} else {
+		ring = ep->ring;
+		if (!ring)
+			goto done;
+		inc = snprintf(next, size, "Dev %d endpoint ring %d:\n",
+				slot_id, ep_index);
+		TO_NEXT(next, size, inc);
+		xhci_dbgfs_segment(xhci, ring->deq_seg, &next, &size);
+	}
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_erst(struct xhci_hcd *xhci, struct xhci_erst *erst,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+
+	u64 addr = erst->erst_dma_addr;
+	int i;
+	struct xhci_erst_entry *entry;
+
+	for (i = 0; i < erst->num_entries; ++i) {
+		entry = &erst->entries[i];
+		inc = snprintf(next, size, "@%016llx %08x %08x %08x %08x\n",
+			 addr,
+			 lower_32_bits(le64_to_cpu(entry->seg_addr)),
+			 upper_32_bits(le64_to_cpu(entry->seg_addr)),
+			 le32_to_cpu(entry->seg_size),
+			 le32_to_cpu(entry->rsvd));
+		TO_NEXT(next, size, inc);
+		addr += sizeof(*entry);
+	}
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_cmd_ptrs(struct xhci_hcd *xhci,
+		char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	u64 val;
+
+	val = xhci_read_64(xhci, &xhci->op_regs->cmd_ring);
+	inc = snprintf(next, size, "// xHC command ring deq ptr low bits + flags = @%08x\n",
+			lower_32_bits(val));
+	TO_NEXT(next, size, inc);
+	inc = snprintf(next, size, "// xHC command ring deq ptr high bits = @%08x\n",
+			upper_32_bits(val));
+	TO_NEXT(next, size, inc);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+/* Print the last 32 bytes for 64-byte contexts */
+static void dbgfs_rsvd64(struct xhci_hcd *xhci, u64 *ctx, dma_addr_t dma,
+		  char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	int i;
+	for (i = 0; i < 4; ++i) {
+		inc = snprintf(next, size, "@%p (virt) @%08llx "
+			 "(dma) %#08llx - rsvd64[%d]\n",
+			 &ctx[4 + i], (unsigned long long)dma,
+			 ctx[4 + i], i);
+		TO_NEXT(next, size, inc);
+
+		dma += 8;
+	}
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_slot_ctx(struct xhci_hcd *xhci, struct xhci_container_ctx *ctx,
+		  char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	/* Fields are 32 bits wide, DMA addresses are in bytes */
+	int field_size = 32 / 8;
+	int i;
+
+	struct xhci_slot_ctx *slot_ctx = xhci_get_slot_ctx(xhci, ctx);
+	dma_addr_t dma = ctx->dma +
+		((unsigned long)slot_ctx - (unsigned long)ctx->bytes);
+	int csz = HCC_64BYTE_CONTEXT(xhci->hcc_params);
+
+	inc = snprintf(next, size, "Slot Context:\n");
+	TO_NEXT(next, size, inc);
+
+	inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - dev_info\n",
+			&slot_ctx->dev_info,
+			(unsigned long long)dma, slot_ctx->dev_info);
+	TO_NEXT(next, size, inc);
+	dma += field_size;
+	inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - dev_info2\n",
+			&slot_ctx->dev_info2,
+			(unsigned long long)dma, slot_ctx->dev_info2);
+	TO_NEXT(next, size, inc);
+	dma += field_size;
+	inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - tt_info\n",
+			&slot_ctx->tt_info,
+			(unsigned long long)dma, slot_ctx->tt_info);
+	TO_NEXT(next, size, inc);
+	dma += field_size;
+	inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - dev_state\n",
+			&slot_ctx->dev_state,
+			(unsigned long long)dma, slot_ctx->dev_state);
+	TO_NEXT(next, size, inc);
+	dma += field_size;
+	for (i = 0; i < 4; ++i) {
+		inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - rsvd[%d]\n",
+				&slot_ctx->reserved[i], (unsigned long long)dma,
+				slot_ctx->reserved[i], i);
+		TO_NEXT(next, size, inc);
+		dma += field_size;
+	}
+
+	if (csz)
+		dbgfs_rsvd64(xhci, (u64 *)slot_ctx, dma, &next, &size);
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_ep_ctx(struct xhci_hcd *xhci,
+		     struct xhci_container_ctx *ctx,
+		     unsigned int last_ep,
+		     char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+
+	int i, j;
+	int last_ep_ctx = 31;
+	/* Fields are 32 bits wide, DMA addresses are in bytes */
+	int field_size = 32 / 8;
+	int csz = HCC_64BYTE_CONTEXT(xhci->hcc_params);
+
+	if (last_ep < 31)
+		last_ep_ctx = last_ep + 1;
+	for (i = 0; i < last_ep_ctx; ++i) {
+		unsigned int epaddr = xhci_get_endpoint_address(i);
+		struct xhci_ep_ctx *ep_ctx = xhci_get_ep_ctx(xhci, ctx, i);
+		dma_addr_t dma = ctx->dma +
+			((unsigned long)ep_ctx - (unsigned long)ctx->bytes);
+
+		inc = snprintf(next, size, "%s Endpoint %02d Context (ep_index %02d):\n",
+				usb_endpoint_out(epaddr) ? "OUT" : "IN",
+				epaddr & USB_ENDPOINT_NUMBER_MASK, i);
+		TO_NEXT(next, size, inc);
+		inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - ep_info\n",
+				&ep_ctx->ep_info,
+				(unsigned long long)dma, ep_ctx->ep_info);
+		TO_NEXT(next, size, inc);
+		dma += field_size;
+		inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - ep_info2\n",
+				&ep_ctx->ep_info2,
+				(unsigned long long)dma, ep_ctx->ep_info2);
+		TO_NEXT(next, size, inc);
+		dma += field_size;
+		inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08llx - deq\n",
+				&ep_ctx->deq,
+				(unsigned long long)dma, ep_ctx->deq);
+		TO_NEXT(next, size, inc);
+		dma += 2*field_size;
+		inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - tx_info\n",
+				&ep_ctx->tx_info,
+				(unsigned long long)dma, ep_ctx->tx_info);
+		TO_NEXT(next, size, inc);
+		dma += field_size;
+		for (j = 0; j < 3; ++j) {
+			inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - rsvd[%d]\n",
+					&ep_ctx->reserved[j],
+					(unsigned long long)dma,
+					ep_ctx->reserved[j], j);
+			TO_NEXT(next, size, inc);
+			dma += field_size;
+		}
+
+		if (csz)
+			dbgfs_rsvd64(xhci, (u64 *)ep_ctx, dma, &next, &size);
+
+	}
+
+done:
+	*sizep = size;
+	*nextp = next;
+}
+
+static void xhci_dbgfs_ctx(struct xhci_hcd *xhci,
+		  struct xhci_container_ctx *ctx,
+		  unsigned int last_ep,
+		  char **nextp, unsigned *sizep)
+{
+	unsigned		inc;
+	unsigned		size = *sizep;
+	char			*next = *nextp;
+	int i;
+	/* Fields are 32 bits wide, DMA addresses are in bytes */
+	int field_size = 32 / 8;
+	dma_addr_t dma = ctx->dma;
+	int csz = HCC_64BYTE_CONTEXT(xhci->hcc_params);
+
+	if (ctx->type == XHCI_CTX_TYPE_INPUT) {
+		struct xhci_input_control_ctx *ctrl_ctx =
+			xhci_get_input_control_ctx(ctx);
+		if (!ctrl_ctx) {
+			inc = snprintf(next, size, "Could not get input context, bad type.\n");
+			TO_NEXT(next, size, inc);
+			goto done;
+		}
+
+		inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - drop flags\n",
+			 &ctrl_ctx->drop_flags, (unsigned long long)dma,
+			 ctrl_ctx->drop_flags);
+		TO_NEXT(next, size, inc);
+
+		dma += field_size;
+		inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - add flags\n",
+			 &ctrl_ctx->add_flags, (unsigned long long)dma,
+			 ctrl_ctx->add_flags);
+		TO_NEXT(next, size, inc);
+
+		dma += field_size;
+		for (i = 0; i < 6; ++i) {
+			inc = snprintf(next, size, "@%p (virt) @%08llx (dma) %#08x - rsvd2[%d]\n",
+				 &ctrl_ctx->rsvd2[i], (unsigned long long)dma,
+				 ctrl_ctx->rsvd2[i], i);
+			TO_NEXT(next, size, inc);
+			dma += field_size;
+		}
+
+		if (csz)
+			dbgfs_rsvd64(xhci, (u64 *)ctrl_ctx, dma, &next, &size);
+	}
+
+	xhci_dbgfs_slot_ctx(xhci, ctx, &next, &size);
+	xhci_dbgfs_ep_ctx(xhci, ctx, last_ep, &next, &size);
+
+done:
+	*sizep = size;
+	*nextp = next;
+
+}
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+struct debug_buffer {
+	ssize_t (*fill_func)(struct debug_buffer *);	/* fill method */
+	struct usb_bus *bus;
+	struct mutex mutex;	/* protect filling of buffer */
+	size_t count;		/* number of characters filled into buffer */
+	char *output_buf;
+	size_t alloc_size;
+};
+
+static int debug_slot = MAX_HC_SLOTS;
+
+static ssize_t fill_ep_ring_buffer(struct debug_buffer *buf)
+{
+	struct usb_hcd		*hcd;
+	struct xhci_hcd		*xhci;
+	unsigned long		flags;
+	unsigned		inc, size;
+	char			*next;
+	int i,j;
+	struct xhci_container_ctx *in_ctx, *out_ctx;
+
+	hcd = bus_to_hcd(buf->bus);
+	xhci = hcd_to_xhci (hcd);
+	next = buf->output_buf;
+	size = buf->alloc_size;
+
+	*next = 0;
+
+	/* dumps a snapshot of the async schedule.
+	 * usually empty except for long-term bulk reads, or head.
+	 * one QH per line, and TDs we know about
+	 */
+	spin_lock_irqsave (&xhci->lock, flags);
+	for (i = 0; i < MAX_HC_SLOTS; i++) {
+		if (!xhci->devs[i])
+			continue;
+
+		if (debug_slot != i && debug_slot != MAX_HC_SLOTS)
+			continue;
+
+		in_ctx = xhci->devs[i]->in_ctx;
+		out_ctx = xhci->devs[i]->out_ctx;
+
+		inc = scnprintf(next, size, "Slot %d input context\n", i);
+		TO_NEXT(next, size, inc);
+		xhci_dbgfs_ctx(xhci, in_ctx, XHCI_MAX_RINGS_CACHED, &next, &size);
+
+		inc = scnprintf(next, size, "Slot %d output context\n", i);
+		TO_NEXT(next, size, inc);
+		xhci_dbgfs_ctx(xhci, out_ctx, XHCI_MAX_RINGS_CACHED, &next, &size);
+
+		for (j = 0; j < XHCI_MAX_RINGS_CACHED; j++) {
+			struct xhci_virt_ep *ep = &xhci->devs[i]->eps[j];
+			struct xhci_ring *ep_ring = ep->ring;
+
+			inc = scnprintf(next, size, "Slot %d ep_index %d endpoint ring @%p\n",
+					i, j, ep_ring);
+			TO_NEXT(next, size, inc);
+			if (ep) xhci_dbgfs_ep_rings(xhci, i, j, ep, &next, &size);
+		}
+	}
+
+	spin_unlock_irqrestore (&xhci->lock, flags);
+
+	inc = scnprintf(next, size, "Print Done (buffer use %d/%d bytes)..\n",
+			buf->alloc_size - size, buf->alloc_size);
+	TO_NEXT(next, size, inc);
+
+	return strlen(buf->output_buf);
+}
+
+static ssize_t fill_event_ring_buffer(struct debug_buffer *buf)
+{
+	struct usb_hcd		*hcd;
+	struct xhci_hcd		*xhci;
+	unsigned long		flags;
+	unsigned		inc, size;
+	char			*next;
+	int i,j;
+
+	hcd = bus_to_hcd(buf->bus);
+	xhci = hcd_to_xhci (hcd);
+	next = buf->output_buf;
+	size = buf->alloc_size;
+
+	*next = 0;
+
+	/* dumps a snapshot of the async schedule.
+	 * usually empty except for long-term bulk reads, or head.
+	 * one QH per line, and TDs we know about
+	 */
+	spin_lock_irqsave (&xhci->lock, flags);
+
+	inc = scnprintf(next, size, "ERST memory map follows:\n");
+	TO_NEXT(next, size, inc);
+
+	xhci_dbgfs_erst(xhci, &xhci->erst, &next, &size);
+
+	inc = scnprintf(next, size, "Dump Event Ring @%p\n", xhci->event_ring);
+	TO_NEXT(next, size, inc);
+
+	xhci_dbgfs_ring_ptrs(xhci, xhci->event_ring, &next, &size);
+
+	xhci_dbgfs_ring(xhci, xhci->event_ring, &next, &size);
+
+	spin_unlock_irqrestore (&xhci->lock, flags);
+
+	inc = scnprintf(next, size, "Print Done (buffer use %d/%d bytes)..\n",
+			buf->alloc_size - size, buf->alloc_size);
+	TO_NEXT(next, size, inc);
+
+	return strlen(buf->output_buf);
+}
+
+static ssize_t fill_cmd_ring_buffer(struct debug_buffer *buf)
+{
+	struct usb_hcd		*hcd;
+	struct xhci_hcd		*xhci;
+	unsigned long		flags;
+	unsigned		inc, size;
+	char			*next;
+	int i,j;
+
+	hcd = bus_to_hcd(buf->bus);
+	xhci = hcd_to_xhci (hcd);
+	next = buf->output_buf;
+	size = buf->alloc_size;
+
+	*next = 0;
+
+	/* dumps a snapshot of the async schedule.
+	 * usually empty except for long-term bulk reads, or head.
+	 * one QH per line, and TDs we know about
+	 */
+	spin_lock_irqsave (&xhci->lock, flags);
+
+	inc = scnprintf(next, size, "Dump Command Ring @%p\n", xhci->cmd_ring);
+	TO_NEXT(next, size, inc);
+
+	xhci_dbgfs_ring_ptrs(xhci, xhci->cmd_ring, &next, &size);
+	xhci_dbgfs_cmd_ptrs(xhci, &next, &size);
+	xhci_dbgfs_ring(xhci, xhci->cmd_ring, &next, &size);
+
+	spin_unlock_irqrestore (&xhci->lock, flags);
+
+	inc = scnprintf(next, size, "Print Done (buffer use %d/%d bytes)..\n",
+			buf->alloc_size - size, buf->alloc_size);
+	TO_NEXT(next, size, inc);
+
+	return strlen(buf->output_buf);
+}
+
+static ssize_t fill_context_buffer(struct debug_buffer *buf)
+{
+	struct usb_hcd		*hcd;
+	struct xhci_hcd		*xhci;
+	unsigned long		flags;
+	unsigned		inc, size;
+	char			*next;
+	int i,j;
+	struct xhci_container_ctx *in_ctx, *out_ctx;
+
+	hcd = bus_to_hcd(buf->bus);
+	xhci = hcd_to_xhci (hcd);
+	next = buf->output_buf;
+	size = buf->alloc_size;
+
+	*next = 0;
+
+	/* dumps a snapshot of the async schedule.
+	 * usually empty except for long-term bulk reads, or head.
+	 * one QH per line, and TDs we know about
+	 */
+	spin_lock_irqsave (&xhci->lock, flags);
+	for (i = 0; i < MAX_HC_SLOTS; i++) {
+		if (!xhci->devs[i])
+			continue;
+
+		if (debug_slot != i && debug_slot != MAX_HC_SLOTS)
+			continue;
+
+		in_ctx = xhci->devs[i]->in_ctx;
+		out_ctx = xhci->devs[i]->out_ctx;
+
+		inc = scnprintf(next, size, "Slot %d input context\n", i);
+		TO_NEXT(next, size, inc);
+		xhci_dbgfs_ctx(xhci, in_ctx, XHCI_MAX_RINGS_CACHED, &next, &size);
+
+		inc = scnprintf(next, size, "Slot %d output context\n", i);
+		TO_NEXT(next, size, inc);
+		xhci_dbgfs_ctx(xhci, out_ctx, XHCI_MAX_RINGS_CACHED, &next, &size);
+
+	}
+	spin_unlock_irqrestore (&xhci->lock, flags);
+
+	inc = scnprintf(next, size, "Print Done (buffer use %d/%d bytes)..\n",
+			buf->alloc_size - size, buf->alloc_size);
+	TO_NEXT(next, size, inc);
+
+	return strlen(buf->output_buf);
+}
+
+static ssize_t fill_registers_buffer(struct debug_buffer *buf)
+{
+	struct usb_hcd		*hcd;
+	struct xhci_hcd		*xhci;
+	unsigned long		flags;
+	unsigned		inc, size;
+	char			*next;
+	int i,j;
+	struct xhci_container_ctx *in_ctx, *out_ctx;
+
+	hcd = bus_to_hcd(buf->bus);
+	xhci = hcd_to_xhci (hcd);
+	next = buf->output_buf;
+	size = buf->alloc_size;
+
+	*next = 0;
+
+	/* dumps a snapshot of the async schedule.
+	 * usually empty except for long-term bulk reads, or head.
+	 * one QH per line, and TDs we know about
+	 */
+	spin_lock_irqsave (&xhci->lock, flags);
+
+	xhci_dbgfs_print_registers(xhci, &next, &size);
+
+	spin_unlock_irqrestore (&xhci->lock, flags);
+
+	inc = scnprintf(next, size, "Print Done (buffer use %d/%d bytes)..\n",
+			buf->alloc_size - size, buf->alloc_size);
+	TO_NEXT(next, size, inc);
+
+	return strlen(buf->output_buf);
+}
+
+static ssize_t fill_dump_all_buffer(struct debug_buffer *buf)
+{
+	struct usb_hcd		*hcd;
+	struct xhci_hcd		*xhci;
+	unsigned long		flags;
+	unsigned		inc, size;
+	char			*next;
+	int i,j;
+	struct xhci_container_ctx *in_ctx, *out_ctx;
+
+	hcd = bus_to_hcd(buf->bus);
+	xhci = hcd_to_xhci (hcd);
+	next = buf->output_buf;
+	size = buf->alloc_size;
+
+	*next = 0;
+
+	/* dumps a snapshot of the async schedule.
+	 * usually empty except for long-term bulk reads, or head.
+	 * one QH per line, and TDs we know about
+	 */
+	spin_lock_irqsave (&xhci->lock, flags);
+
+	xhci_dbgfs_print_registers(xhci, &next, &size);
+
+	inc = scnprintf(next, size, "Dump Command Ring @%p\n", xhci->cmd_ring);
+	TO_NEXT(next, size, inc);
+
+	xhci_dbgfs_ring_ptrs(xhci, xhci->cmd_ring, &next, &size);
+	xhci_dbgfs_cmd_ptrs(xhci, &next, &size);
+	xhci_dbgfs_ring(xhci, xhci->cmd_ring, &next, &size);
+
+
+	inc = scnprintf(next, size, "ERST memory map follows:\n");
+	TO_NEXT(next, size, inc);
+
+	xhci_dbgfs_erst(xhci, &xhci->erst, &next, &size);
+
+	inc = scnprintf(next, size, "Dump Event Ring @%p\n", xhci->event_ring);
+	TO_NEXT(next, size, inc);
+
+	xhci_dbgfs_ring_ptrs(xhci, xhci->event_ring, &next, &size);
+
+	xhci_dbgfs_ring(xhci, xhci->event_ring, &next, &size);
+
+	for (i = 0; i < MAX_HC_SLOTS; i++) {
+		if (!xhci->devs[i])
+			continue;
+		in_ctx = xhci->devs[i]->in_ctx;
+		out_ctx = xhci->devs[i]->out_ctx;
+
+		inc = scnprintf(next, size, "Slot %d input context\n", i);
+		TO_NEXT(next, size, inc);
+		xhci_dbgfs_ctx(xhci, in_ctx, XHCI_MAX_RINGS_CACHED, &next, &size);
+
+		inc = scnprintf(next, size, "Slot %d output context\n", i);
+		TO_NEXT(next, size, inc);
+		xhci_dbgfs_ctx(xhci, out_ctx, XHCI_MAX_RINGS_CACHED, &next, &size);
+
+		for (j = 0; j < XHCI_MAX_RINGS_CACHED; j++) {
+			struct xhci_virt_ep *ep = &xhci->devs[i]->eps[j];
+			struct xhci_ring *ep_ring = ep->ring;
+
+			inc = scnprintf(next, size, "Slot %d ep_index %d endpoint ring @%p\n",
+					i, j, ep_ring);
+			TO_NEXT(next, size, inc);
+			if (ep) xhci_dbgfs_ep_rings(xhci, i, j, ep, &next, &size);
+		}
+	}
+
+	spin_unlock_irqrestore (&xhci->lock, flags);
+
+	inc = scnprintf(next, size, "Print Done (buffer use %d/%d bytes)..\n",
+			buf->alloc_size - size, buf->alloc_size);
+	TO_NEXT(next, size, inc);
+
+	return strlen(buf->output_buf);
+}
+
+/* troubleshooting help: expose state in debugfs */
+
+static int debug_ep_ring_open(struct inode *, struct file *);
+static int debug_event_ring_open(struct inode *, struct file *);
+static int debug_cmd_ring_open(struct inode *, struct file *);
+static int debug_context_open(struct inode *, struct file *);
+static int debug_registers_open(struct inode *, struct file *);
+static int debug_dump_all_open(struct inode *, struct file *);
+
+static ssize_t debug_output(struct file*, char __user*, size_t, loff_t*);
+static int debug_close(struct inode *, struct file *);
+
+static ssize_t debug_set_slot_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos);
+
+static const struct file_operations debug_ep_ring_fops = {
+	.owner		= THIS_MODULE,
+	.open		= debug_ep_ring_open,
+	.read		= debug_output,
+	.write		= debug_set_slot_write,
+	.release	= debug_close,
+	.llseek		= default_llseek,
+};
+static const struct file_operations debug_event_ring_fops = {
+	.owner		= THIS_MODULE,
+	.open		= debug_event_ring_open,
+	.read		= debug_output,
+	.release	= debug_close,
+	.llseek		= default_llseek,
+};
+static const struct file_operations debug_cmd_ring_fops = {
+	.owner		= THIS_MODULE,
+	.open		= debug_cmd_ring_open,
+	.read		= debug_output,
+	.release	= debug_close,
+	.llseek		= default_llseek,
+};
+static const struct file_operations debug_context_fops = {
+	.owner		= THIS_MODULE,
+	.open		= debug_context_open,
+	.read		= debug_output,
+	.write		= debug_set_slot_write,
+	.release	= debug_close,
+	.llseek		= default_llseek,
+};
+static const struct file_operations debug_registers_fops = {
+	.owner		= THIS_MODULE,
+	.open		= debug_registers_open,
+	.read		= debug_output,
+	.release	= debug_close,
+	.llseek		= default_llseek,
+};
+static const struct file_operations debug_dump_all_fops = {
+	.owner		= THIS_MODULE,
+	.open		= debug_dump_all_open,
+	.read		= debug_output,
+	.release	= debug_close,
+	.llseek		= default_llseek,
+};
+
+static struct debug_buffer *alloc_buffer(struct usb_bus *bus,
+				ssize_t (*fill_func)(struct debug_buffer *))
+{
+	struct debug_buffer *buf;
+
+	buf = kzalloc(sizeof(struct debug_buffer), GFP_KERNEL);
+
+	if (buf) {
+		buf->bus = bus;
+		buf->fill_func = fill_func;
+		mutex_init(&buf->mutex);
+		buf->alloc_size = 100*PAGE_SIZE;
+	}
+
+	return buf;
+}
+
+static int fill_buffer(struct debug_buffer *buf)
+{
+	int ret = 0;
+
+	if (!buf->output_buf)
+		buf->output_buf = vmalloc(buf->alloc_size);
+
+	if (!buf->output_buf) {
+		ret = -ENOMEM;
+		goto out;
+	}
+
+	ret = buf->fill_func(buf);
+
+	if (ret >= 0) {
+		buf->count = ret;
+		ret = 0;
+	}
+
+out:
+	return ret;
+}
+
+static ssize_t debug_output(struct file *file, char __user *user_buf,
+			    size_t len, loff_t *offset)
+{
+	struct debug_buffer *buf = file->private_data;
+	int ret = 0;
+
+	mutex_lock(&buf->mutex);
+	if (buf->count == 0) {
+		ret = fill_buffer(buf);
+		if (ret != 0) {
+			mutex_unlock(&buf->mutex);
+			goto out;
+		}
+	}
+	mutex_unlock(&buf->mutex);
+
+	ret = simple_read_from_buffer(user_buf, len, offset,
+				      buf->output_buf, buf->count);
+
+out:
+	return ret;
+}
+
+static int debug_close(struct inode *inode, struct file *file)
+{
+	struct debug_buffer *buf = file->private_data;
+
+	if (buf) {
+		vfree(buf->output_buf);
+		kfree(buf);
+	}
+
+	return 0;
+}
+
+static int debug_ep_ring_open(struct inode *inode, struct file *file)
+{
+	file->private_data = alloc_buffer(inode->i_private, fill_ep_ring_buffer);
+
+	return file->private_data ? 0 : -ENOMEM;
+}
+
+static ssize_t debug_set_slot_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	static struct dentry *reg_file = NULL;
+	struct debug_buffer *dbuf = file->private_data;
+	char			buf[32];
+	int 			ret;
+
+	if (copy_from_user(&buf, ubuf, min_t(size_t, sizeof(buf) - 1, count)))
+		return -EFAULT;
+
+	if (!strncmp(buf, "all", 3)) {
+		debug_slot = MAX_HC_SLOTS;
+	} else {
+		int id;
+		ret = sscanf(buf, "%d", &id);
+		if (ret >= 1 && id >= 0 && id <= MAX_HC_SLOTS) {
+			debug_slot = id;
+		} else {
+			pr_err("Error: to set slot id = %d (MAX = %d)\n", id, MAX_HC_SLOTS);
+		}
+	}
+
+	return count;
+}
+
+static int debug_event_ring_open(struct inode *inode, struct file *file)
+{
+	file->private_data = alloc_buffer(inode->i_private, fill_event_ring_buffer);
+
+	return file->private_data ? 0 : -ENOMEM;
+}
+
+static int debug_cmd_ring_open(struct inode *inode, struct file *file)
+{
+	file->private_data = alloc_buffer(inode->i_private, fill_cmd_ring_buffer);
+
+	return file->private_data ? 0 : -ENOMEM;
+}
+
+static int debug_context_open(struct inode *inode, struct file *file)
+{
+	file->private_data = alloc_buffer(inode->i_private, fill_context_buffer);
+
+	return file->private_data ? 0 : -ENOMEM;
+}
+
+static int debug_registers_open(struct inode *inode, struct file *file)
+{
+	file->private_data = alloc_buffer(inode->i_private, fill_registers_buffer);
+
+	return file->private_data ? 0 : -ENOMEM;
+}
+
+static int debug_dump_all_open(struct inode *inode, struct file *file)
+{
+	file->private_data = alloc_buffer(inode->i_private, fill_dump_all_buffer);
+
+	return file->private_data ? 0 : -ENOMEM;
+}
+
+void create_xhci_debug_files(struct xhci_hcd *xhci)
+{
+	struct usb_bus *bus = &xhci_to_hcd(xhci)->self;
+
+	if (!xhci_debug_root) {
+		xhci_debug_root = debugfs_create_dir("xhci", usb_debug_root);
+		if (!xhci_debug_root) {
+			xhci_err(xhci, "Create debugfs dir xhci Fail\n");
+			return;
+		}
+	}
+
+	xhci->debug_dir = debugfs_create_dir(bus->bus_name, xhci_debug_root);
+	if (!xhci->debug_dir)
+		return;
+
+	if (!debugfs_create_file("ep_ring", S_IRUGO | S_IWUSR, xhci->debug_dir, bus,
+						&debug_ep_ring_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("event_ring", S_IRUGO, xhci->debug_dir, bus,
+						&debug_event_ring_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("cmd_ring", S_IRUGO, xhci->debug_dir, bus,
+						&debug_cmd_ring_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("context", S_IRUGO | S_IWUSR, xhci->debug_dir, bus,
+						&debug_context_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("registers", S_IRUGO, xhci->debug_dir, bus,
+						    &debug_registers_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("dump_all", S_IRUGO, xhci->debug_dir, bus,
+						&debug_dump_all_fops))
+		goto file_error;
+
+	return;
+
+file_error:
+	debugfs_remove_recursive(xhci->debug_dir);
+}
+
+void remove_xhci_debug_files(struct xhci_hcd *xhci)
+{
+	if (xhci->debug_dir) {
+		debugfs_remove_recursive(xhci->debug_dir);
+		xhci->debug_dir = NULL;
+	}
+}
+#endif
diff --git a/drivers/usb/host/xhci-hub.c b/drivers/usb/host/xhci-hub.c
index 0722f75..0d31f6b 100644
--- a/drivers/usb/host/xhci-hub.c
+++ b/drivers/usb/host/xhci-hub.c
@@ -902,6 +902,47 @@ static u32 xhci_get_port_status(struct usb_hcd *hcd,
 	return status;
 }
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#ifdef CONFIG_USB_DWC3_RTK
+extern void RTK_dwc3_usb3_phy_toggle(struct device *dwc3_dev, bool isConnect, int port);
+extern int RTK_dwc3_usb2_phy_toggle(struct device *dwc3_dev, bool isConnect, int port);
+#endif
+
+static void RTK_phy_toggle(struct usb_hcd *hcd, u16 wValue, u16 wIndex,
+	    u32 temp)
+{
+	struct xhci_hcd *xhci = hcd_to_xhci(hcd);
+
+	if (wValue == USB_PORT_FEAT_C_CONNECTION) {
+		int max_ports, port;
+		u32 status;
+		__le32 __iomem **port_array;
+		bool isConnect;
+
+		port = wIndex;
+		max_ports = xhci_get_ports(hcd, &port_array);
+		status = readl(port_array[wIndex]);
+		isConnect = (status & PORT_CONNECT)?true:false;
+
+#ifdef CONFIG_USB_DWC3_RTK
+		if (hcd->speed >= HCD_USB3 && status & PORT_CSC) {
+			xhci_info(xhci, "%s to call RTK_dwc3_usb3_phy_toggle (wValue=%x "
+				    "port=%d status=%x)\n",
+				    __func__, wValue, port, status);
+			RTK_dwc3_usb3_phy_toggle(hcd->self.controller, isConnect, port);
+		} else if (status & PORT_CSC) {
+			xhci_info(xhci, "%s to call RTK_dwc3_usb2_phy_toggle (wValue=%x "
+				    "port=%d status=%x)\n",
+				    __func__, wValue, port, status);
+			RTK_dwc3_usb2_phy_toggle(hcd->self.controller, isConnect, port);
+		}
+#else
+		xhci_info(xhci, "%s NO build CONFIG_USB_DWC3_RTK\n", __func__);
+#endif
+	}
+}
+#endif
+
 int xhci_hub_control(struct usb_hcd *hcd, u16 typeReq, u16 wValue,
 		u16 wIndex, char *buf, u16 wLength)
 {
@@ -916,6 +957,9 @@ int xhci_hub_control(struct usb_hcd *hcd, u16 typeReq, u16 wValue,
 	u16 link_state = 0;
 	u16 wake_mask = 0;
 	u16 timeout = 0;
+#ifdef CONFIG_USB_RTK_HCD_TEST_MODE
+	int test_mode = (wIndex & 0xff00) >> 8;
+#endif
 
 	max_ports = xhci_get_ports(hcd, &port_array);
 	bus_state = &xhci->bus_state[hcd_index(hcd)];
@@ -1164,6 +1208,25 @@ int xhci_hub_control(struct usb_hcd *hcd, u16 typeReq, u16 wValue,
 			temp |= PORT_U2_TIMEOUT(timeout);
 			writel(temp, port_array[wIndex] + PORTPMSC);
 			break;
+#ifdef CONFIG_USB_RTK_HCD_TEST_MODE
+		case USB_PORT_FEAT_TEST:
+			if (!test_mode || test_mode > 5)
+				goto error;
+
+			int slot_id = xhci_find_slot_id_by_port(hcd, xhci,
+					wIndex + 1);
+			if (test_mode && test_mode <= 5) {
+				/* unlock to execute stop endpoint commands */
+				spin_unlock_irqrestore(&xhci->lock, flags);
+				xhci_stop_device(xhci, slot_id, 1);
+				spin_lock_irqsave(&xhci->lock, flags);
+				xhci_halt(xhci);
+				temp = readl(port_array[wIndex] + PORTPMSC);
+				temp |= test_mode << 28;
+				writel(temp, port_array[wIndex] + PORTPMSC);
+			}
+			break;
+#endif
 		default:
 			goto error;
 		}
@@ -1217,6 +1280,9 @@ int xhci_hub_control(struct usb_hcd *hcd, u16 typeReq, u16 wValue,
 		case USB_PORT_FEAT_C_RESET:
 		case USB_PORT_FEAT_C_BH_PORT_RESET:
 		case USB_PORT_FEAT_C_CONNECTION:
+#ifdef CONFIG_USB_PATCH_ON_RTK
+			RTK_phy_toggle(hcd, wValue, wIndex, temp);
+#endif
 		case USB_PORT_FEAT_C_OVER_CURRENT:
 		case USB_PORT_FEAT_C_ENABLE:
 		case USB_PORT_FEAT_C_PORT_LINK_STATE:
diff --git a/drivers/usb/host/xhci-mem.c b/drivers/usb/host/xhci-mem.c
index 7199e40..1e24f1a 100644
--- a/drivers/usb/host/xhci-mem.c
+++ b/drivers/usb/host/xhci-mem.c
@@ -1109,6 +1109,71 @@ void xhci_copy_ep0_dequeue_into_input_ctx(struct xhci_hcd *xhci,
 	virt_dev = xhci->devs[udev->slot_id];
 	ep0_ctx = xhci_get_ep_ctx(xhci, virt_dev->in_ctx, 0);
 	ep_ring = virt_dev->eps[0].ring;
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#if 1
+	/* [DEV_FIX]xhci control tranfer will error occasionally (1/45)
+	 * commit 0d2ae2abc867c1a31b7d280dc6429d18ba3770c5
+	 */
+	{
+		int i = 0;
+		struct xhci_ring *ring = ep_ring;
+		union xhci_trb *next;
+		union xhci_trb *trb;
+
+		ring->enq_seg = ring->first_seg;
+		ring->enqueue = ring->first_seg->trbs;
+		next = ring->enqueue;
+		wmb();
+		for (i = 0; i < (TRBS_PER_SEGMENT); i++) {
+			trb = &ring->first_seg->trbs[i];
+			trb->generic.field[3] &= cpu_to_le32(~TRB_CYCLE);
+		}
+		for (i = 0; i < (TRBS_PER_SEGMENT); i++) {
+			trb = &ring->first_seg->next->trbs[i];
+			trb->generic.field[3] &= cpu_to_le32(~TRB_CYCLE);
+		}
+		ring->cycle_state = 1;
+		wmb();
+	}
+#else
+	/* [DEV_FIx]set address fail after warm/hot reset
+	 * commit e7afd2f2d0093553379a9e2d6874ef11897a394f
+	 */
+	/* Fixed : USB reset issue, which will cause set address fail.
+	 * by Ted.
+	 */
+	{
+		int i = 0;
+		struct xhci_ring *ring = ep_ring;
+		union xhci_trb *next;
+		union xhci_trb *trb;
+		ring->enq_seg = ring->first_seg;
+		ring->enqueue = ring->first_seg->trbs;
+		next = ring->enqueue;
+		wmb();
+		for (i = 0; i < (TRBS_PER_SEGMENT -1); ++i) {
+			trb = &ring->first_seg->trbs[i];
+			trb->generic.field[0] = 0x0;
+			trb->generic.field[1] = 0x0;
+			trb->generic.field[2] = 0x0;
+			trb->generic.field[3] = 0x0;
+		}
+		wmb();
+
+		for (i = 0; i < (TRBS_PER_SEGMENT -1); ++i) {
+			trb = &ring->first_seg->next->trbs[i];
+			trb->generic.field[0] = 0x0;
+			trb->generic.field[1] = 0x0;
+			trb->generic.field[2] = 0x0;
+			trb->generic.field[3] = 0x0;
+		}
+		ring->cycle_state = 1;
+		wmb();
+	}
+#endif
+#endif
+
 	/*
 	 * FIXME we don't keep track of the dequeue pointer very well after a
 	 * Set TR dequeue pointer, so we're setting the dequeue pointer of the
diff --git a/drivers/usb/host/xhci-plat.c b/drivers/usb/host/xhci-plat.c
index ca8b0b1..cc621a2 100644
--- a/drivers/usb/host/xhci-plat.c
+++ b/drivers/usb/host/xhci-plat.c
@@ -19,6 +19,7 @@
 #include <linux/usb/phy.h>
 #include <linux/slab.h>
 #include <linux/acpi.h>
+#include <linux/suspend.h>
 
 #include "xhci.h"
 #include "xhci-plat.h"
@@ -293,11 +294,30 @@ static int xhci_plat_remove(struct platform_device *dev)
 }
 
 #ifdef CONFIG_PM_SLEEP
+#ifdef CONFIG_USB_PATCH_ON_RTK
+/* [DEV_FIX]implement New USB reset mechanism with CRT reset to workaround any HW or IP issues
+ * commit 319ff9f5c298b94517a10d4ced59812b54994347
+ */
+static int xhci_plat_suspend(struct device *dev);
+int RTK_xhci_plat_suspend(struct device *dev) {
+	return xhci_plat_suspend(dev);
+}
+#endif
+
 static int xhci_plat_suspend(struct device *dev)
 {
 	struct usb_hcd	*hcd = dev_get_drvdata(dev);
 	struct xhci_hcd	*xhci = hcd_to_xhci(hcd);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		return 0;
+	 } else
+		xhci_info(xhci, "[USB] %s Suspend mode --> xhci_suspend (do_wakeup=%s)",
+			__func__, device_may_wakeup(dev)? "true":"false");
+#endif
+
 	/*
 	 * xhci_suspend() needs `do_wakeup` to know whether host is allowed
 	 * to do wakeup during suspend. Since xhci_plat_suspend is currently
@@ -309,11 +329,30 @@ static int xhci_plat_suspend(struct device *dev)
 	return xhci_suspend(xhci, device_may_wakeup(dev));
 }
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+/* [DEV_FIX]implement New USB reset mechanism with CRT reset to workaround any HW or IP issues
+ * commit 319ff9f5c298b94517a10d4ced59812b54994347
+ */
+static int xhci_plat_resume(struct device *dev);
+int RTK_xhci_plat_resume(struct device *dev)
+{
+	return xhci_plat_resume(dev);
+}
+#endif
+
 static int xhci_plat_resume(struct device *dev)
 {
 	struct usb_hcd	*hcd = dev_get_drvdata(dev);
 	struct xhci_hcd	*xhci = hcd_to_xhci(hcd);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (RTK_PM_STATE == PM_SUSPEND_STANDBY) {
+		dev_info(dev, "[USB] %s Idle mode\n", __func__);
+		return 0;
+	} else
+		dev_info(dev,  "[USB] %s Suspend mode --> xhci_resume\n", __func__);
+#endif
+
 	return xhci_resume(xhci, 0);
 }
 
diff --git a/drivers/usb/host/xhci-ring.c b/drivers/usb/host/xhci-ring.c
index 89a14d5..a0db4ea 100644
--- a/drivers/usb/host/xhci-ring.c
+++ b/drivers/usb/host/xhci-ring.c
@@ -1608,6 +1608,23 @@ static void handle_port_status(struct xhci_hcd *xhci,
 	if (hcd->speed >= HCD_USB3 && (temp & PORT_PLS_MASK) == XDEV_INACTIVE)
 		bus_state->port_remote_wakeup &= ~(1 << faked_port_index);
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	if (hcd->speed >= HCD_USB3 && (temp & PORT_PLS_MASK) == XDEV_INACTIVE &&
+		   (temp & PORT_PLC)) {
+		bus_state->port_remote_wakeup |= (1 << faked_port_index);
+		xhci_dbg(xhci, "Get port link state XDEV_INACTIVE and port link change "
+			    "to set port_remote_wakeup (port_status=0x%x)\n", temp);
+		if (bus_state->port_remote_wakeup & (1 << faked_port_index)) {
+			bus_state->port_remote_wakeup &=
+				~(1 << faked_port_index);
+			xhci_test_and_clear_bit(xhci, port_array,
+					faked_port_index, PORT_PLC);
+			usb_wakeup_notification(hcd->self.root_hub,
+					faked_port_index + 1);
+		}
+	}
+#endif
+
 	if ((temp & PORT_PLC) && (temp & PORT_PLS_MASK) == XDEV_RESUME) {
 		xhci_dbg(xhci, "port resume event for port %d\n", port_id);
 
@@ -2732,6 +2749,9 @@ static int xhci_handle_event(struct xhci_hcd *xhci)
 	return 1;
 }
 
+#ifdef CONFIG_XEN_USBHOST_FRONTEND
+extern void rtk_hostirq_unmask(void);
+#endif
 /*
  * xHCI spec says we can get an interrupt, and if the HC has an error condition,
  * we might get bad data out of the event ring.  Section 4.10.2.7 has a list of
@@ -2753,6 +2773,9 @@ irqreturn_t xhci_irq(struct usb_hcd *hcd)
 
 	if (!(status & STS_EINT)) {
 		spin_unlock(&xhci->lock);
+#ifdef CONFIG_XEN_USBHOST_FRONTEND
+		rtk_hostirq_unmask();
+#endif
 		return IRQ_NONE;
 	}
 	if (status & STS_FATAL) {
@@ -2760,6 +2783,9 @@ irqreturn_t xhci_irq(struct usb_hcd *hcd)
 		xhci_halt(xhci);
 hw_died:
 		spin_unlock(&xhci->lock);
+#ifdef CONFIG_XEN_USBHOST_FRONTEND
+		rtk_hostirq_unmask();
+#endif
 		return IRQ_HANDLED;
 	}
 
@@ -2792,7 +2818,9 @@ irqreturn_t xhci_irq(struct usb_hcd *hcd)
 		xhci_write_64(xhci, temp_64 | ERST_EHB,
 				&xhci->ir_set->erst_dequeue);
 		spin_unlock(&xhci->lock);
-
+#ifdef CONFIG_XEN_USBHOST_FRONTEND
+		rtk_hostirq_unmask();
+#endif
 		return IRQ_HANDLED;
 	}
 
@@ -2820,7 +2848,9 @@ irqreturn_t xhci_irq(struct usb_hcd *hcd)
 	xhci_write_64(xhci, temp_64, &xhci->ir_set->erst_dequeue);
 
 	spin_unlock(&xhci->lock);
-
+#ifdef CONFIG_XEN_USBHOST_FRONTEND
+	rtk_hostirq_unmask();
+#endif
 	return IRQ_HANDLED;
 }
 
@@ -3152,7 +3182,6 @@ static u32 xhci_td_remainder(struct xhci_hcd *xhci, int transferred,
 	return (total_packet_count - ((transferred + trb_buff_len) / maxp));
 }
 
-
 static int xhci_align_td(struct xhci_hcd *xhci, struct urb *urb, u32 enqd_len,
 			 u32 *trb_buff_len, struct xhci_segment *seg)
 {
diff --git a/drivers/usb/host/xhci.c b/drivers/usb/host/xhci.c
index 81f2521..bb7efcd 100644
--- a/drivers/usb/host/xhci.c
+++ b/drivers/usb/host/xhci.c
@@ -29,6 +29,10 @@
 #include <linux/dmi.h>
 #include <linux/dma-mapping.h>
 
+#ifdef CONFIG_USB_PATCH_ON_RTK
+#include <linux/usb/quirks.h>
+#endif
+
 #include "xhci.h"
 #include "xhci-trace.h"
 #include "xhci-mtk.h"
@@ -666,6 +670,11 @@ int xhci_run(struct usb_hcd *hcd)
 	}
 	xhci_dbg_trace(xhci, trace_xhci_dbg_init,
 			"Finished xhci_run for USB2 roothub");
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	create_xhci_debug_files(xhci);
+#endif
+
 	return 0;
 }
 EXPORT_SYMBOL_GPL(xhci_run);
@@ -684,6 +693,10 @@ void xhci_stop(struct usb_hcd *hcd)
 	u32 temp;
 	struct xhci_hcd *xhci = hcd_to_xhci(hcd);
 
+#ifdef CONFIG_DYNAMIC_DEBUG
+	remove_xhci_debug_files(xhci);
+#endif
+
 	mutex_lock(&xhci->mutex);
 
 	if (!(xhci->xhc_state & XHCI_STATE_HALTED)) {
diff --git a/drivers/usb/host/xhci.h b/drivers/usb/host/xhci.h
index b918128..220ca79 100644
--- a/drivers/usb/host/xhci.h
+++ b/drivers/usb/host/xhci.h
@@ -1694,6 +1694,11 @@ struct xhci_hcd {
 /* Compliance Mode Timer Triggered every 2 seconds */
 #define COMP_MODE_RCVRY_MSECS 2000
 
+#ifdef CONFIG_DYNAMIC_DEBUG
+	/* debug files */
+	struct dentry		*debug_dir;
+#endif
+
 	/* platform-specific data -- must come last */
 	unsigned long		priv[0] __aligned(sizeof(s64));
 };
@@ -2001,4 +2006,10 @@ static inline struct xhci_ring *xhci_urb_to_transfer_ring(struct xhci_hcd *xhci,
 					urb->stream_id);
 }
 
+#ifdef CONFIG_DYNAMIC_DEBUG
+void create_xhci_debug_files(struct xhci_hcd *xhci);
+
+void remove_xhci_debug_files(struct xhci_hcd *xhci);
+#endif //CONFIG_DYNAMIC_DEBUG
+
 #endif /* __LINUX_XHCI_HCD_H */
diff --git a/drivers/usb/phy/Kconfig b/drivers/usb/phy/Kconfig
index 125cea1..d4e33fee 100644
--- a/drivers/usb/phy/Kconfig
+++ b/drivers/usb/phy/Kconfig
@@ -6,6 +6,14 @@ menu "USB Physical Layer drivers"
 config USB_PHY
 	def_bool n
 
+config USB_OTG_WAKELOCK
+	bool "Hold a wakelock when USB connected"
+	depends on PM_WAKELOCKS
+	select USB_OTG_UTILS
+	help
+	  Select this to automatically hold a wakelock when USB is
+	  connected, preventing suspend.
+
 #
 # USB Transceiver Drivers
 #
@@ -209,4 +217,31 @@ config USB_ULPI_VIEWPORT
 	  Provides read/write operations to the ULPI phy register set for
 	  controllers with a viewport register (e.g. Chipidea/ARC controllers).
 
+config DUAL_ROLE_USB_INTF
+	bool "Generic DUAL ROLE sysfs interface"
+	depends on SYSFS && USB_PHY
+	help
+	  A generic sysfs interface to track and change the state of
+	  dual role usb phys. The usb phy drivers can register to
+	  this interface to expose it capabilities to the userspace
+	  and thereby allowing userspace to change the port mode.
+
+config RTK_USB_RLE0599_PHY
+	tristate "Realtek USB RLE0599 PHY Controller Driver"
+	select USB_PHY
+	help
+	  Enable this to support Realtek RLE0599 phy controller SoC.
+
+config RTK_USB2PHY
+	tristate "Realtek USB2 PHY Controller Driver"
+	select USB_PHY
+	help
+	  Enable this to support Realtek USB2 phy controller SoC.
+
+config RTK_USB3PHY
+	tristate "Realtek USB3 PHY Controller Driver"
+	select USB_PHY
+	help
+	  Enable this to support Realtek USB3 phy controller SoC.
+
 endmenu
diff --git a/drivers/usb/phy/Makefile b/drivers/usb/phy/Makefile
index b433e5d..2eb4f1f 100644
--- a/drivers/usb/phy/Makefile
+++ b/drivers/usb/phy/Makefile
@@ -3,6 +3,8 @@
 #
 obj-$(CONFIG_USB_PHY)			+= phy.o
 obj-$(CONFIG_OF)			+= of.o
+obj-$(CONFIG_USB_OTG_WAKELOCK)		+= otg-wakelock.o
+obj-$(CONFIG_DUAL_ROLE_USB_INTF)	+= class-dual-role.o
 
 # transceiver drivers, keep the list sorted
 
@@ -26,3 +28,6 @@ obj-$(CONFIG_USB_MXS_PHY)		+= phy-mxs-usb.o
 obj-$(CONFIG_USB_ULPI)			+= phy-ulpi.o
 obj-$(CONFIG_USB_ULPI_VIEWPORT)		+= phy-ulpi-viewport.o
 obj-$(CONFIG_KEYSTONE_USB_PHY)		+= phy-keystone.o
+obj-$(CONFIG_RTK_USB_RLE0599_PHY)	+= phy-rtk-rle0599.o
+obj-$(CONFIG_RTK_USB2PHY)		+= phy-rtk-usb2.o
+obj-$(CONFIG_RTK_USB3PHY)		+= phy-rtk-usb3.o
diff --git a/drivers/usb/phy/class-dual-role.c b/drivers/usb/phy/class-dual-role.c
new file mode 100644
index 00000000..51fcb54
--- /dev/null
+++ b/drivers/usb/phy/class-dual-role.c
@@ -0,0 +1,529 @@
+/*
+ * class-dual-role.c
+ *
+ * Copyright (C) 2015 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/ctype.h>
+#include <linux/device.h>
+#include <linux/usb/class-dual-role.h>
+#include <linux/err.h>
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/stat.h>
+#include <linux/types.h>
+
+#define DUAL_ROLE_NOTIFICATION_TIMEOUT 2000
+
+static ssize_t dual_role_store_property(struct device *dev,
+					struct device_attribute *attr,
+					const char *buf, size_t count);
+static ssize_t dual_role_show_property(struct device *dev,
+				       struct device_attribute *attr,
+				       char *buf);
+
+#define DUAL_ROLE_ATTR(_name)				\
+{							\
+	.attr = { .name = #_name },			\
+	.show = dual_role_show_property,		\
+	.store = dual_role_store_property,		\
+}
+
+static struct device_attribute dual_role_attrs[] = {
+	DUAL_ROLE_ATTR(supported_modes),
+	DUAL_ROLE_ATTR(mode),
+	DUAL_ROLE_ATTR(power_role),
+	DUAL_ROLE_ATTR(data_role),
+	DUAL_ROLE_ATTR(powers_vconn),
+};
+
+struct class *dual_role_class;
+EXPORT_SYMBOL_GPL(dual_role_class);
+
+static struct device_type dual_role_dev_type;
+
+static char *kstrdupcase(const char *str, gfp_t gfp, bool to_upper)
+{
+	char *ret, *ustr;
+
+	ustr = ret = kmalloc(strlen(str) + 1, gfp);
+
+	if (!ret)
+		return NULL;
+
+	while (*str)
+		*ustr++ = to_upper ? toupper(*str++) : tolower(*str++);
+
+	*ustr = 0;
+
+	return ret;
+}
+
+static void dual_role_changed_work(struct work_struct *work)
+{
+	struct dual_role_phy_instance *dual_role =
+	    container_of(work, struct dual_role_phy_instance,
+			 changed_work);
+
+	dev_dbg(&dual_role->dev, "%s\n", __func__);
+	kobject_uevent(&dual_role->dev.kobj, KOBJ_CHANGE);
+}
+
+void dual_role_instance_changed(struct dual_role_phy_instance *dual_role)
+{
+	dev_dbg(&dual_role->dev, "%s\n", __func__);
+	pm_wakeup_event(&dual_role->dev, DUAL_ROLE_NOTIFICATION_TIMEOUT);
+	schedule_work(&dual_role->changed_work);
+}
+EXPORT_SYMBOL_GPL(dual_role_instance_changed);
+
+int dual_role_get_property(struct dual_role_phy_instance *dual_role,
+			   enum dual_role_property prop,
+			   unsigned int *val)
+{
+	return dual_role->desc->get_property(dual_role, prop, val);
+}
+EXPORT_SYMBOL_GPL(dual_role_get_property);
+
+int dual_role_set_property(struct dual_role_phy_instance *dual_role,
+			   enum dual_role_property prop,
+			   const unsigned int *val)
+{
+	if (!dual_role->desc->set_property)
+		return -ENODEV;
+
+	return dual_role->desc->set_property(dual_role, prop, val);
+}
+EXPORT_SYMBOL_GPL(dual_role_set_property);
+
+int dual_role_property_is_writeable(struct dual_role_phy_instance *dual_role,
+				    enum dual_role_property prop)
+{
+	if (!dual_role->desc->property_is_writeable)
+		return -ENODEV;
+
+	return dual_role->desc->property_is_writeable(dual_role, prop);
+}
+EXPORT_SYMBOL_GPL(dual_role_property_is_writeable);
+
+static void dual_role_dev_release(struct device *dev)
+{
+	struct dual_role_phy_instance *dual_role =
+	    container_of(dev, struct dual_role_phy_instance, dev);
+	pr_debug("device: '%s': %s\n", dev_name(dev), __func__);
+	kfree(dual_role);
+}
+
+static struct dual_role_phy_instance *__must_check
+__dual_role_register(struct device *parent,
+		     const struct dual_role_phy_desc *desc)
+{
+	struct device *dev;
+	struct dual_role_phy_instance *dual_role;
+	int rc;
+
+	dual_role = kzalloc(sizeof(*dual_role), GFP_KERNEL);
+	if (!dual_role)
+		return ERR_PTR(-ENOMEM);
+
+	dev = &dual_role->dev;
+
+	device_initialize(dev);
+
+	dev->class = dual_role_class;
+	dev->type = &dual_role_dev_type;
+	dev->parent = parent;
+	dev->release = dual_role_dev_release;
+	dev_set_drvdata(dev, dual_role);
+	dual_role->desc = desc;
+
+	rc = dev_set_name(dev, "%s", desc->name);
+	if (rc)
+		goto dev_set_name_failed;
+
+	INIT_WORK(&dual_role->changed_work, dual_role_changed_work);
+
+	rc = device_init_wakeup(dev, true);
+	if (rc)
+		goto wakeup_init_failed;
+
+	rc = device_add(dev);
+	if (rc)
+		goto device_add_failed;
+
+	dual_role_instance_changed(dual_role);
+
+	return dual_role;
+
+device_add_failed:
+	device_init_wakeup(dev, false);
+wakeup_init_failed:
+dev_set_name_failed:
+	put_device(dev);
+	kfree(dual_role);
+
+	return ERR_PTR(rc);
+}
+
+static void dual_role_instance_unregister(struct dual_role_phy_instance
+					  *dual_role)
+{
+	cancel_work_sync(&dual_role->changed_work);
+	device_init_wakeup(&dual_role->dev, false);
+	device_unregister(&dual_role->dev);
+}
+
+static void devm_dual_role_release(struct device *dev, void *res)
+{
+	struct dual_role_phy_instance **dual_role = res;
+
+	dual_role_instance_unregister(*dual_role);
+}
+
+struct dual_role_phy_instance *__must_check
+devm_dual_role_instance_register(struct device *parent,
+				 const struct dual_role_phy_desc *desc)
+{
+	struct dual_role_phy_instance **ptr, *dual_role;
+
+	ptr = devres_alloc(devm_dual_role_release, sizeof(*ptr), GFP_KERNEL);
+
+	if (!ptr)
+		return ERR_PTR(-ENOMEM);
+	dual_role = __dual_role_register(parent, desc);
+	if (IS_ERR(dual_role)) {
+		devres_free(ptr);
+	} else {
+		*ptr = dual_role;
+		devres_add(parent, ptr);
+	}
+	return dual_role;
+}
+EXPORT_SYMBOL_GPL(devm_dual_role_instance_register);
+
+static int devm_dual_role_match(struct device *dev, void *res, void *data)
+{
+	struct dual_role_phy_instance **r = res;
+
+	if (WARN_ON(!r || !*r))
+		return 0;
+
+	return *r == data;
+}
+
+void devm_dual_role_instance_unregister(struct device *dev,
+					struct dual_role_phy_instance
+					*dual_role)
+{
+	int rc;
+
+	rc = devres_release(dev, devm_dual_role_release,
+			    devm_dual_role_match, dual_role);
+	WARN_ON(rc);
+}
+EXPORT_SYMBOL_GPL(devm_dual_role_instance_unregister);
+
+void *dual_role_get_drvdata(struct dual_role_phy_instance *dual_role)
+{
+	return dual_role->drv_data;
+}
+EXPORT_SYMBOL_GPL(dual_role_get_drvdata);
+
+/***************** Device attribute functions **************************/
+
+/* port type */
+static char *supported_modes_text[] = {
+	"ufp dfp", "dfp", "ufp"
+};
+
+/* current mode */
+static char *mode_text[] = {
+	"ufp", "dfp", "none"
+};
+
+/* Power role */
+static char *pr_text[] = {
+	"source", "sink", "none"
+};
+
+/* Data role */
+static char *dr_text[] = {
+	"host", "device", "none"
+};
+
+/* Vconn supply */
+static char *vconn_supply_text[] = {
+	"n", "y"
+};
+
+static ssize_t dual_role_show_property(struct device *dev,
+				       struct device_attribute *attr, char *buf)
+{
+	ssize_t ret = 0;
+	struct dual_role_phy_instance *dual_role = dev_get_drvdata(dev);
+	const ptrdiff_t off = attr - dual_role_attrs;
+	unsigned int value;
+
+	if (off == DUAL_ROLE_PROP_SUPPORTED_MODES) {
+		value = dual_role->desc->supported_modes;
+	} else {
+		ret = dual_role_get_property(dual_role, off, &value);
+
+		if (ret < 0) {
+			if (ret == -ENODATA)
+				dev_dbg(dev,
+					"driver has no data for `%s' property\n",
+					attr->attr.name);
+			else if (ret != -ENODEV)
+				dev_err(dev,
+					"driver failed to report `%s' property: %zd\n",
+					attr->attr.name, ret);
+			return ret;
+		}
+	}
+
+	if (off == DUAL_ROLE_PROP_SUPPORTED_MODES) {
+		BUILD_BUG_ON(DUAL_ROLE_PROP_SUPPORTED_MODES_TOTAL !=
+			ARRAY_SIZE(supported_modes_text));
+		if (value < DUAL_ROLE_PROP_SUPPORTED_MODES_TOTAL)
+			return snprintf(buf, PAGE_SIZE, "%s\n",
+					supported_modes_text[value]);
+		else
+			return -EIO;
+	} else if (off == DUAL_ROLE_PROP_MODE) {
+		BUILD_BUG_ON(DUAL_ROLE_PROP_MODE_TOTAL !=
+			ARRAY_SIZE(mode_text));
+		if (value < DUAL_ROLE_PROP_MODE_TOTAL)
+			return snprintf(buf, PAGE_SIZE, "%s\n",
+					mode_text[value]);
+		else
+			return -EIO;
+	} else if (off == DUAL_ROLE_PROP_PR) {
+		BUILD_BUG_ON(DUAL_ROLE_PROP_PR_TOTAL != ARRAY_SIZE(pr_text));
+		if (value < DUAL_ROLE_PROP_PR_TOTAL)
+			return snprintf(buf, PAGE_SIZE, "%s\n",
+					pr_text[value]);
+		else
+			return -EIO;
+	} else if (off == DUAL_ROLE_PROP_DR) {
+		BUILD_BUG_ON(DUAL_ROLE_PROP_DR_TOTAL != ARRAY_SIZE(dr_text));
+		if (value < DUAL_ROLE_PROP_DR_TOTAL)
+			return snprintf(buf, PAGE_SIZE, "%s\n",
+					dr_text[value]);
+		else
+			return -EIO;
+	} else if (off == DUAL_ROLE_PROP_VCONN_SUPPLY) {
+		BUILD_BUG_ON(DUAL_ROLE_PROP_VCONN_SUPPLY_TOTAL !=
+				ARRAY_SIZE(vconn_supply_text));
+		if (value < DUAL_ROLE_PROP_VCONN_SUPPLY_TOTAL)
+			return snprintf(buf, PAGE_SIZE, "%s\n",
+					vconn_supply_text[value]);
+		else
+			return -EIO;
+	} else
+		return -EIO;
+}
+
+static ssize_t dual_role_store_property(struct device *dev,
+					struct device_attribute *attr,
+					const char *buf, size_t count)
+{
+	ssize_t ret;
+	struct dual_role_phy_instance *dual_role = dev_get_drvdata(dev);
+	const ptrdiff_t off = attr - dual_role_attrs;
+	unsigned int value;
+	int total, i;
+	char *dup_buf, **text_array;
+	bool result = false;
+
+	dup_buf = kstrdupcase(buf, GFP_KERNEL, false);
+	switch (off) {
+	case DUAL_ROLE_PROP_MODE:
+		total = DUAL_ROLE_PROP_MODE_TOTAL;
+		text_array = mode_text;
+		break;
+	case DUAL_ROLE_PROP_PR:
+		total = DUAL_ROLE_PROP_PR_TOTAL;
+		text_array = pr_text;
+		break;
+	case DUAL_ROLE_PROP_DR:
+		total = DUAL_ROLE_PROP_DR_TOTAL;
+		text_array = dr_text;
+		break;
+	case DUAL_ROLE_PROP_VCONN_SUPPLY:
+		ret = strtobool(dup_buf, &result);
+		value = result;
+		if (!ret)
+			goto setprop;
+	default:
+		ret = -EINVAL;
+		goto error;
+	}
+
+	for (i = 0; i <= total; i++) {
+		if (i == total) {
+			ret = -ENOTSUPP;
+			goto error;
+		}
+		if (!strncmp(*(text_array + i), dup_buf,
+			     strlen(*(text_array + i)))) {
+			value = i;
+			break;
+		}
+	}
+
+setprop:
+	ret = dual_role->desc->set_property(dual_role, off, &value);
+
+error:
+	kfree(dup_buf);
+
+	if (ret < 0)
+		return ret;
+
+	return count;
+}
+
+static umode_t dual_role_attr_is_visible(struct kobject *kobj,
+					 struct attribute *attr, int attrno)
+{
+	struct device *dev = container_of(kobj, struct device, kobj);
+	struct dual_role_phy_instance *dual_role = dev_get_drvdata(dev);
+	umode_t mode = S_IRUSR | S_IRGRP | S_IROTH;
+	int i;
+
+	if (attrno == DUAL_ROLE_PROP_SUPPORTED_MODES)
+		return mode;
+
+	for (i = 0; i < dual_role->desc->num_properties; i++) {
+		int property = dual_role->desc->properties[i];
+
+		if (property == attrno) {
+			if (dual_role->desc->property_is_writeable &&
+			    dual_role_property_is_writeable(dual_role, property)
+			    > 0)
+				mode |= S_IWUSR;
+
+			return mode;
+		}
+	}
+
+	return 0;
+}
+
+static struct attribute *__dual_role_attrs[ARRAY_SIZE(dual_role_attrs) + 1];
+
+static struct attribute_group dual_role_attr_group = {
+	.attrs = __dual_role_attrs,
+	.is_visible = dual_role_attr_is_visible,
+};
+
+static const struct attribute_group *dual_role_attr_groups[] = {
+	&dual_role_attr_group,
+	NULL,
+};
+
+void dual_role_init_attrs(struct device_type *dev_type)
+{
+	int i;
+
+	dev_type->groups = dual_role_attr_groups;
+
+	for (i = 0; i < ARRAY_SIZE(dual_role_attrs); i++)
+		__dual_role_attrs[i] = &dual_role_attrs[i].attr;
+}
+
+int dual_role_uevent(struct device *dev, struct kobj_uevent_env *env)
+{
+	struct dual_role_phy_instance *dual_role = dev_get_drvdata(dev);
+	int ret = 0, j;
+	char *prop_buf;
+	char *attrname;
+
+	dev_dbg(dev, "uevent\n");
+
+	if (!dual_role || !dual_role->desc) {
+		dev_dbg(dev, "No dual_role phy yet\n");
+		return ret;
+	}
+
+	dev_dbg(dev, "DUAL_ROLE_NAME=%s\n", dual_role->desc->name);
+
+	ret = add_uevent_var(env, "DUAL_ROLE_NAME=%s", dual_role->desc->name);
+	if (ret)
+		return ret;
+
+	prop_buf = (char *)get_zeroed_page(GFP_KERNEL);
+	if (!prop_buf)
+		return -ENOMEM;
+
+	for (j = 0; j < dual_role->desc->num_properties; j++) {
+		struct device_attribute *attr;
+		char *line;
+
+		attr = &dual_role_attrs[dual_role->desc->properties[j]];
+
+		ret = dual_role_show_property(dev, attr, prop_buf);
+		if (ret == -ENODEV || ret == -ENODATA) {
+			ret = 0;
+			continue;
+		}
+
+		if (ret < 0)
+			goto out;
+		line = strnchr(prop_buf, PAGE_SIZE, '\n');
+		if (line)
+			*line = 0;
+
+		attrname = kstrdupcase(attr->attr.name, GFP_KERNEL, true);
+		if (!attrname)
+			ret = -ENOMEM;
+
+		dev_dbg(dev, "prop %s=%s\n", attrname, prop_buf);
+
+		ret = add_uevent_var(env, "DUAL_ROLE_%s=%s", attrname,
+				     prop_buf);
+		kfree(attrname);
+		if (ret)
+			goto out;
+	}
+
+out:
+	free_page((unsigned long)prop_buf);
+
+	return ret;
+}
+
+/******************* Module Init ***********************************/
+
+static int __init dual_role_class_init(void)
+{
+	dual_role_class = class_create(THIS_MODULE, "dual_role_usb");
+
+	if (IS_ERR(dual_role_class))
+		return PTR_ERR(dual_role_class);
+
+	dual_role_class->dev_uevent = dual_role_uevent;
+	dual_role_init_attrs(&dual_role_dev_type);
+
+	return 0;
+}
+
+static void __exit dual_role_class_exit(void)
+{
+	class_destroy(dual_role_class);
+}
+
+subsys_initcall(dual_role_class_init);
+module_exit(dual_role_class_exit);
diff --git a/drivers/usb/phy/otg-wakelock.c b/drivers/usb/phy/otg-wakelock.c
new file mode 100644
index 00000000..ecd7410
--- /dev/null
+++ b/drivers/usb/phy/otg-wakelock.c
@@ -0,0 +1,170 @@
+/*
+ * otg-wakelock.c
+ *
+ * Copyright (C) 2011 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/device.h>
+#include <linux/err.h>
+#include <linux/module.h>
+#include <linux/notifier.h>
+#include <linux/spinlock.h>
+#include <linux/usb/otg.h>
+
+#define TEMPORARY_HOLD_TIME	2000
+
+static bool enabled = true;
+static struct usb_phy *otgwl_xceiv;
+static struct notifier_block otgwl_nb;
+
+/*
+ * otgwl_spinlock is held while the VBUS lock is grabbed or dropped and the
+ * held field is updated to match.
+ */
+
+static DEFINE_SPINLOCK(otgwl_spinlock);
+
+/*
+ * Only one lock, but since these 3 fields are associated with each other...
+ */
+
+struct otgwl_lock {
+	char name[40];
+	struct wakeup_source wakesrc;
+	bool held;
+};
+
+/*
+ * VBUS present lock.  Also used as a timed lock on charger
+ * connect/disconnect and USB host disconnect, to allow the system
+ * to react to the change in power.
+ */
+
+static struct otgwl_lock vbus_lock;
+
+static void otgwl_hold(struct otgwl_lock *lock)
+{
+	if (!lock->held) {
+		__pm_stay_awake(&lock->wakesrc);
+		lock->held = true;
+	}
+}
+
+static void otgwl_temporary_hold(struct otgwl_lock *lock)
+{
+	__pm_wakeup_event(&lock->wakesrc, TEMPORARY_HOLD_TIME);
+	lock->held = false;
+}
+
+static void otgwl_drop(struct otgwl_lock *lock)
+{
+	if (lock->held) {
+		__pm_relax(&lock->wakesrc);
+		lock->held = false;
+	}
+}
+
+static void otgwl_handle_event(unsigned long event)
+{
+	unsigned long irqflags;
+
+	spin_lock_irqsave(&otgwl_spinlock, irqflags);
+
+	if (!enabled) {
+		otgwl_drop(&vbus_lock);
+		spin_unlock_irqrestore(&otgwl_spinlock, irqflags);
+		return;
+	}
+
+	switch (event) {
+	case USB_EVENT_VBUS:
+	case USB_EVENT_ENUMERATED:
+		otgwl_hold(&vbus_lock);
+		break;
+
+	case USB_EVENT_NONE:
+	case USB_EVENT_ID:
+	case USB_EVENT_CHARGER:
+		otgwl_temporary_hold(&vbus_lock);
+		break;
+
+	default:
+		break;
+	}
+
+	spin_unlock_irqrestore(&otgwl_spinlock, irqflags);
+}
+
+static int otgwl_otg_notifications(struct notifier_block *nb,
+				   unsigned long event, void *unused)
+{
+	otgwl_handle_event(event);
+	return NOTIFY_OK;
+}
+
+static int set_enabled(const char *val, const struct kernel_param *kp)
+{
+	int rv = param_set_bool(val, kp);
+
+	if (rv)
+		return rv;
+
+	if (otgwl_xceiv)
+		otgwl_handle_event(otgwl_xceiv->last_event);
+
+	return 0;
+}
+
+static struct kernel_param_ops enabled_param_ops = {
+	.set = set_enabled,
+	.get = param_get_bool,
+};
+
+module_param_cb(enabled, &enabled_param_ops, &enabled, 0644);
+MODULE_PARM_DESC(enabled, "enable wakelock when VBUS present");
+
+static int __init otg_wakelock_init(void)
+{
+	int ret;
+	struct usb_phy *phy;
+
+	phy = usb_get_phy(USB_PHY_TYPE_USB2);
+
+	if (IS_ERR(phy)) {
+		pr_err("%s: No USB transceiver found\n", __func__);
+		return PTR_ERR(phy);
+	}
+	otgwl_xceiv = phy;
+
+	snprintf(vbus_lock.name, sizeof(vbus_lock.name), "vbus-%s",
+		 dev_name(otgwl_xceiv->dev));
+	wakeup_source_init(&vbus_lock.wakesrc, vbus_lock.name);
+
+	otgwl_nb.notifier_call = otgwl_otg_notifications;
+	ret = usb_register_notifier(otgwl_xceiv, &otgwl_nb);
+
+	if (ret) {
+		pr_err("%s: usb_register_notifier on transceiver %s"
+		       " failed\n", __func__,
+		       dev_name(otgwl_xceiv->dev));
+		otgwl_xceiv = NULL;
+		wakeup_source_trash(&vbus_lock.wakesrc);
+		return ret;
+	}
+
+	otgwl_handle_event(otgwl_xceiv->last_event);
+	return ret;
+}
+
+late_initcall(otg_wakelock_init);
diff --git a/drivers/usb/phy/phy-rtk-rle0599.c b/drivers/usb/phy/phy-rtk-rle0599.c
new file mode 100644
index 00000000..a8a15ac
--- /dev/null
+++ b/drivers/usb/phy/phy-rtk-rle0599.c
@@ -0,0 +1,708 @@
+/*
+ *  phy-rtk-rle0599.c RTK rle0599 usb2.0 phy driver
+ *
+ * copyright (c) 2017 realtek semiconductor corporation
+ *
+ * this program is free software; you can redistribute it and/or modify
+ * it under the terms of the gnu general public license as published by
+ * the free software foundation; either version 2 of the license, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/delay.h>
+#include <linux/err.h>
+#include <linux/io.h>
+#include <linux/usb/otg.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/uaccess.h>
+#include <linux/debugfs.h>
+#include <soc/realtek/rtd129x_efuse.h>
+#include <soc/realtek/rtk_chip.h>
+
+#include "phy-rtk-usb.h"
+#ifdef CONFIG_USB_PATCH_ON_RTK
+/* Add global lock for emmc issue*/
+#include <soc/realtek/rtd129x_lockapi.h>
+#endif
+
+
+#define RTK_USB_RLE0599_PHY_NAME "rtk-usb-phy-rle0599"
+
+struct reg_addr {
+	void __iomem *REG_WRAP_VStatusOut2;
+	void __iomem *REG_EHCI_INSNREG05;
+};
+
+struct phy_data {
+	int page0_size;
+	struct rtk_usb_phy_data_s *page0;
+	int page1_size;
+	struct rtk_usb_phy_data_s *page1;
+
+	bool check_efuse;
+	u8 efuse_usb_dp_dm;
+	bool do_toggle;
+	bool use_default_parameter;
+};
+
+static u8 efuse_usb_dp_dm_table[0x10] = {0xe0, 0x80, 0x84, 0x88, 0x8c, 0x90, 0x94, 0x98,
+					 0x9c, 0xa0, 0xa4, 0xa8, 0xac, 0xb0, 0xb4, 0xb8};
+
+#define WAIT_VBUSY_RETRY	3
+
+#define OFFEST_PHY_READ 0x20
+
+#define USB_ST_BUSY		BIT(17)
+
+static DEFINE_SPINLOCK(rtk_phy_lock);
+
+static char rtk_usb_phy_read(struct rtk_usb_phy_s *rtk_phy, char addr)
+{
+	volatile unsigned int regVal;
+	struct reg_addr *regAddr = rtk_phy->reg_addr;
+	void __iomem *REG_EHCI_INSNREG05 = regAddr->REG_EHCI_INSNREG05;
+
+	utmi_wait_register(REG_EHCI_INSNREG05, USB_ST_BUSY, 0);
+
+	// VCtrl = low nibble of addr, VLoadM = 1
+	regVal = (1 << 13) | 	// Port num
+			 (1 << 12) |	// vload
+			 ((addr & 0x0f) << 8);	// vcontrol
+	phy_write(REG_EHCI_INSNREG05, regVal);
+	utmi_wait_register(REG_EHCI_INSNREG05, USB_ST_BUSY, 0);
+
+	// VCtrl = low nibble of addr, VLoadM = 0
+	regVal &= ~(1 << 12);
+	phy_write(REG_EHCI_INSNREG05, regVal);
+	utmi_wait_register(REG_EHCI_INSNREG05, USB_ST_BUSY, 0);
+
+	// VCtrl = high nibble of addr, VLoadM = 1
+	regVal = (1 << 13) | 	// Port num
+			 (1 << 12) |	// vload
+			 ((addr & 0xf0) << 4);	// vcontrol
+	phy_write(REG_EHCI_INSNREG05, regVal);
+	utmi_wait_register(REG_EHCI_INSNREG05, USB_ST_BUSY, 0);
+
+	// VCtrl = high nibble of addr, VLoadM = 0
+	regVal &= ~(1 << 12);
+	phy_write(REG_EHCI_INSNREG05, regVal);
+	utmi_wait_register(REG_EHCI_INSNREG05, USB_ST_BUSY, 0);
+
+	smp_rmb();
+	regVal = phy_read(REG_EHCI_INSNREG05);
+
+	return (char) (regVal & 0xff);
+}
+
+static int rtk_usb_phy_write(struct rtk_usb_phy_s *rtk_phy, char addr, char data)
+{
+	volatile unsigned int regVal;
+	struct reg_addr *regAddr = rtk_phy->reg_addr;
+	void __iomem *REG_WRAP_VStatusOut2 = regAddr->REG_WRAP_VStatusOut2;
+	void __iomem *REG_EHCI_INSNREG05 = regAddr->REG_EHCI_INSNREG05;
+
+	//printk("[%s:%d], addr = 0x%x, data = 0x%x\n", __FUNCTION__, __LINE__, addr, data);
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Add global lock for emmc issue*/
+	unsigned long flags;
+	rtk_lockapi_lock(flags,__FUNCTION__);
+#endif
+	//write data to VStatusOut2 (data output to phy)
+	phy_write(REG_WRAP_VStatusOut2, (u32) data);
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	/* Add global lock for emmc issue*/
+	rtk_lockapi_unlock(flags,__FUNCTION__);
+#endif
+
+	utmi_wait_register(REG_EHCI_INSNREG05, USB_ST_BUSY, 0);
+
+	// VCtrl = low nibble of addr, VLoadM = 1
+	regVal = (1 << 13) | 	// Port num
+			 (1 << 12) |	// vload
+			 ((addr & 0x0f) << 8);	// vcontrol
+	phy_write(REG_EHCI_INSNREG05, regVal);
+	utmi_wait_register(REG_EHCI_INSNREG05, USB_ST_BUSY, 0);
+
+	// VCtrl = low nibble of addr, VLoadM = 0
+	regVal &= ~(1 << 12);
+	phy_write(REG_EHCI_INSNREG05, regVal);
+	utmi_wait_register(REG_EHCI_INSNREG05, USB_ST_BUSY, 0);
+
+	// VCtrl = high nibble of addr, VLoadM = 1
+	regVal = (1 << 13) | 	// Port num
+			 (1 << 12) |	// vload
+			 ((addr & 0xf0) << 4);	// vcontrol
+	phy_write(REG_EHCI_INSNREG05, regVal);
+	utmi_wait_register(REG_EHCI_INSNREG05, USB_ST_BUSY, 0);
+
+	// VCtrl = high nibble of addr, VLoadM = 0
+	regVal &= ~(1 << 12);
+	phy_write(REG_EHCI_INSNREG05, regVal);
+	utmi_wait_register(REG_EHCI_INSNREG05, USB_ST_BUSY, 0);
+
+	return 0;
+}
+
+static int rtk_usb_phy_set_page(struct rtk_usb_phy_s *rtk_phy, int page)
+{
+	return rtk_usb_phy_write(rtk_phy, 0xf4, page == 0 ? 0x9b : 0xbb);
+}
+
+static int initialized=0;
+void rtk_usb_phy_shutdown(struct usb_phy *phy)
+{
+	/* Todo */
+	initialized = 0;
+}
+
+static int updated_phy_parameter_by_efuse(struct rtk_usb_phy_s *rtk_usb_phy){
+	u8 value = 0;
+	int size = 4;
+	int shift = 0;
+	int offest = 0x1dc;
+	int mask = (BIT(size) - 1);
+	struct phy_data *phy_data = rtk_usb_phy->phy_data;
+	struct rtk_usb_phy_data_s *phy_page0_default_setting = phy_data->page0;
+	int i;
+
+#if 0
+	value = (efuse_readb(offest) << shift) & mask;
+	dev_dbg(rtk_usb_phy->dev, "Get Efuse EFUSE_USB_DP_DM %x Mask %x\n",
+		    efuse_readb(offest), mask);
+#else
+	pr_err("%s(): ERROR Need implement efuse_readb\n", __func__);
+#endif
+	phy_data->efuse_usb_dp_dm = value;
+
+	for (i = 0; i<phy_data->page0_size; i++) {
+		if ((phy_page0_default_setting + i)->addr == 0xe0) {
+			(phy_page0_default_setting + i)->data = efuse_usb_dp_dm_table[value & mask];
+			dev_dbg(rtk_usb_phy->dev, "Set addr %x value %x\n",
+				(phy_page0_default_setting + i)->addr,
+				(phy_page0_default_setting + i)->data);
+		}
+	}
+	return 0;
+}
+
+void rtk_rle0599_phy_toggle(struct usb_phy *usb2_phy, bool isConnect);
+
+int rtk_usb_phy_init(struct usb_phy* phy)
+{
+	int i;
+	int ret=0;
+	unsigned long flags;
+
+	struct rtk_usb_phy_s *rtk_phy = (struct rtk_usb_phy_s*) phy;
+	//struct reg_addr *regAddr = rtk_phy->reg_addr;
+	struct phy_data *phy_data = rtk_phy->phy_data;
+	struct rtk_usb_phy_data_s *phy_page0_default_setting = phy_data->page0;
+	struct rtk_usb_phy_data_s *phy_page1_default_setting = phy_data->page1;
+
+	spin_lock_irqsave(&rtk_phy_lock, flags);
+
+	if (initialized) goto out;
+
+	if (phy_data->use_default_parameter) {
+		dev_info(phy->dev, "%s phy use default parameter\n",
+			    __func__);
+		goto do_toggle;
+	}
+
+	dev_info(phy->dev, "Init RTK USB phy-rle0599\n");
+
+	if (phy_data->check_efuse)
+		updated_phy_parameter_by_efuse(rtk_phy);
+
+	/* Set page 0 */
+	//printk("[%s:%d], Set page 0\n", __FUNCTION__, __LINE__);
+	rtk_usb_phy_set_page(rtk_phy, 0);
+
+	for (i=0; i<phy_data->page0_size; i++) {
+		if (rtk_usb_phy_write(rtk_phy, (phy_page0_default_setting + i)->addr, (phy_page0_default_setting + i)->data)) {
+			dev_err(phy->dev, "[%s:%d], page0 Error : addr = 0x%x, value = 0x%x\n",
+				__FUNCTION__, __LINE__,
+				(phy_page0_default_setting + i)->addr,
+				(phy_page0_default_setting + i)->data);
+			ret = -1;
+			goto out;
+		} else {
+			dev_dbg(phy->dev, "[%s:%d], page0 Good : addr = 0x%x, value = 0x%x\n",
+				__FUNCTION__, __LINE__,
+				(phy_page0_default_setting + i)->addr,
+				rtk_usb_phy_read(rtk_phy, (phy_page0_default_setting + i)->addr - OFFEST_PHY_READ));
+		}
+	}
+
+	/* Set page 1 */
+	//printk("[%s:%d], Set page 1\n", __FUNCTION__, __LINE__);
+	rtk_usb_phy_set_page(rtk_phy, 1);
+
+	for (i = 0; i < phy_data->page1_size; i++) {
+		if (rtk_usb_phy_write(rtk_phy, (phy_page1_default_setting + i)->addr, (phy_page1_default_setting + i)->data)) {
+			dev_err(phy->dev, "[%s:%d], page1 Error : addr = 0x%x, value = 0x%x\n",
+				__FUNCTION__, __LINE__,
+				(phy_page1_default_setting + i)->addr,
+				(phy_page1_default_setting + i)->data);
+			ret = -1;
+			goto out;
+		} else {
+				dev_dbg(phy->dev, "[%s:%d], page1 Good : addr = 0x%x, value = 0x%x\n",
+				__FUNCTION__, __LINE__,
+				(phy_page1_default_setting + i)->addr,
+				rtk_usb_phy_read(rtk_phy, (phy_page1_default_setting + i)->addr - OFFEST_PHY_READ));
+		}
+	}
+
+do_toggle:
+	rtk_rle0599_phy_toggle(phy, false);
+
+	initialized = 1;
+
+	dev_info(phy->dev, "%s Initialized RTK USB PHY rle0599\n", __FILE__);
+out:
+	spin_unlock_irqrestore(&rtk_phy_lock, flags);
+	return ret;
+}
+
+void rtk_rle0599_phy_toggle(struct usb_phy *usb2_phy, bool isConnect)
+{
+	struct rtk_usb_phy_s *rtk_phy = NULL;
+	struct phy_data *phy_data = NULL;
+
+	if (usb2_phy != NULL && usb2_phy->dev != NULL)
+		rtk_phy = dev_get_drvdata(usb2_phy->dev);
+
+	if (rtk_phy == NULL) {
+		pr_err("%s %s ERROR! NO this device", __FILE__, __func__);
+		return;
+	}
+
+	phy_data = rtk_phy->phy_data;
+
+	if (phy_data && !phy_data->do_toggle) return;
+
+	if (phy_data) {
+		int i;
+		struct rtk_usb_phy_data_s *phy_page0_default_setting = phy_data->page0;
+		struct rtk_usb_phy_data_s *phy_page1_default_setting = phy_data->page1;
+		/* Set page 0 */
+		rtk_usb_phy_set_page(rtk_phy, 0);
+		for (i=0; i<phy_data->page0_size; i++) {
+			if ((phy_page0_default_setting + i)->addr == 0xE7) {
+				if (isConnect) {
+					rtk_usb_phy_write(rtk_phy, (phy_page0_default_setting + i)->addr,
+							(phy_page0_default_setting + i)->data & (~(BIT(4) | BIT(5) | BIT(6))));
+				} else {
+					rtk_usb_phy_write(rtk_phy, (phy_page0_default_setting + i)->addr,
+							(phy_page0_default_setting + i)->data | (BIT(4) | BIT(5) | BIT(6)));
+				}
+				dev_dbg(rtk_phy->dev, "%s %sconnect to set Page0 0xE7 = %x\n", __func__,
+					isConnect?"":"dis",
+					rtk_usb_phy_read(rtk_phy, (phy_page0_default_setting + i)->addr));
+			}
+		}
+
+		/* Set page 1 */
+		rtk_usb_phy_set_page(rtk_phy, 1);
+
+		for (i=0; i < phy_data->page1_size; i++) {
+			if ((phy_page1_default_setting + i)->addr == 0xe0) {
+				dev_info(rtk_phy->dev, "%s ########## to toggle Page1 addr 0xe0 BIT(2)\n", __func__);
+				rtk_usb_phy_write(rtk_phy, (phy_page1_default_setting + i)->addr,
+										  ((phy_page1_default_setting + i)->data) & (~BIT(2)));
+				mdelay(1);
+				rtk_usb_phy_write(rtk_phy, (phy_page1_default_setting + i)->addr,
+										  (phy_page1_default_setting + i)->data);
+			}
+		}
+	}
+}
+EXPORT_SYMBOL(rtk_rle0599_phy_toggle);
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+extern struct dentry *create_phy_debug_root(void);
+
+static int rtk_rle0599_parameter_show(struct seq_file *s, void *unused)
+{
+	struct rtk_usb_phy_s		*rtk_phy = s->private;
+	struct phy_data *phy_data = rtk_phy->phy_data;
+	struct rtk_usb_phy_data_s *phy_page0_default_setting = phy_data->page0;
+	struct rtk_usb_phy_data_s *phy_page1_default_setting = phy_data->page1;
+	int i;
+	unsigned long flags;
+
+	seq_printf(s, "Page 0:\n");
+	spin_lock_irqsave(&rtk_phy_lock, flags);
+	/* Set page 0 */
+	rtk_usb_phy_set_page(rtk_phy, 0);
+
+	for (i=0; i<phy_data->page0_size; i++) {
+		seq_printf(s, "Page 0: addr = 0x%x, value = 0x%x\n",
+			(phy_page0_default_setting + i)->addr,
+			rtk_usb_phy_read(rtk_phy, (phy_page0_default_setting + i)->addr - OFFEST_PHY_READ));
+	}
+
+	seq_printf(s, "Page 1:\n");
+	/* Set page 1 */
+	rtk_usb_phy_set_page(rtk_phy, 1);
+
+	for (i = 0; i < phy_data->page1_size; i++) {
+		seq_printf(s, "Page 1: addr = 0x%x, value = 0x%x\n",
+			(phy_page1_default_setting + i)->addr,
+			rtk_usb_phy_read(rtk_phy, (phy_page1_default_setting + i)->addr - OFFEST_PHY_READ));
+	}
+
+	spin_unlock_irqrestore(&rtk_phy_lock, flags);
+
+	return 0;
+}
+
+static int rtk_rle0599_parameter_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_rle0599_parameter_show, inode->i_private);
+}
+
+static const struct file_operations rtk_rle0599_parameter_fops = {
+	.open			= rtk_rle0599_parameter_open,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int rtk_rle0599_set_parameter_show(struct seq_file *s, void *unused)
+{
+	//struct rtk_usb_phy_s	*rtk_phy = s->private;
+
+	seq_printf(s, "Set Phy parameter by following command\n");
+	seq_printf(s, "echo \"page addr value\" > set_parameter\n");
+	seq_printf(s, "echo \"page0 0xE1 0x30\" > set_parameter\n");
+	seq_printf(s, "echo \"page1 0xE1 0xEF\" > set_parameter\n");
+
+	return 0;
+}
+
+static int rtk_rle0599_set_parameter_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_rle0599_set_parameter_show, inode->i_private);
+}
+
+static ssize_t rtk_rle0599_set_parameter_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct rtk_usb_phy_s		*rtk_phy = s->private;
+	struct phy_data *phy_data = rtk_phy->phy_data;
+	struct rtk_usb_phy_data_s *phy_page0_default_setting = phy_data->page0;
+	struct rtk_usb_phy_data_s *phy_page1_default_setting = phy_data->page1;
+	unsigned long		flags;
+	char			buffer[40];
+	char *buf = buffer;
+	int i;
+	u32 addr;
+	u32 value;
+
+	if (copy_from_user(&buffer, ubuf, min_t(size_t, sizeof(buffer) - 1, count)))
+		return -EFAULT;
+
+	spin_lock_irqsave(&rtk_phy_lock, flags);
+	if (!strncmp(buf, "page0", 5)) {
+		buf = buf + 5;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x %x", &addr, &value);
+
+		rtk_usb_phy_set_page(rtk_phy, 0);
+		for (i = 0; i<phy_data->page0_size; i++) {
+			if ((phy_page0_default_setting + i)->addr == addr) {
+				(phy_page0_default_setting + i)->data = value;
+				if (rtk_usb_phy_write(rtk_phy, (phy_page0_default_setting + i)->addr,
+						(phy_page0_default_setting + i)->data))
+					dev_err(rtk_phy->dev, "[%s:%d], page0 Error : addr = 0x%x, value = 0x%x\n",
+						__FUNCTION__, __LINE__,
+						(phy_page0_default_setting + i)->addr,
+						(phy_page0_default_setting + i)->data);
+				else
+					dev_dbg(rtk_phy->dev, "[%s:%d], page0 Good : addr = 0x%x, value = 0x%x\n",
+						__FUNCTION__, __LINE__,
+						(phy_page0_default_setting + i)->addr,
+						rtk_usb_phy_read(rtk_phy, (phy_page0_default_setting + i)->addr - OFFEST_PHY_READ));
+			}
+		}
+	} else if (!strncmp(buf, "page1", 5)) {
+		buf = buf + 5;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x %x", &addr, &value);
+
+		rtk_usb_phy_set_page(rtk_phy, 1);
+		for (i = 0; i<phy_data->page1_size; i++) {
+			if ((phy_page1_default_setting + i)->addr == addr) {
+				(phy_page1_default_setting + i)->data = value;
+				if (rtk_usb_phy_write(rtk_phy, (phy_page1_default_setting + i)->addr,
+						(phy_page1_default_setting + i)->data))
+					dev_err(rtk_phy->dev, "[%s:%d], page1 Error : addr = 0x%x, value = 0x%x\n",
+						__FUNCTION__, __LINE__,
+						(phy_page1_default_setting + i)->addr,
+						(phy_page1_default_setting + i)->data);
+				else
+					dev_dbg(rtk_phy->dev, "[%s:%d], page1 Good : addr = 0x%x, value = 0x%x\n",
+						__FUNCTION__, __LINE__,
+						(phy_page1_default_setting + i)->addr,
+						rtk_usb_phy_read(rtk_phy, (phy_page1_default_setting + i)->addr - OFFEST_PHY_READ));
+			}
+		}
+	} else
+		dev_err(rtk_phy->dev, "UNKNOWN input (%s)", buf);
+
+	spin_unlock_irqrestore(&rtk_phy_lock, flags);
+	return count;
+}
+
+static const struct file_operations rtk_rle0599_set_parameter_fops = {
+	.open			= rtk_rle0599_set_parameter_open,
+	.write			= rtk_rle0599_set_parameter_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int rtk_rle0599_toggle_show(struct seq_file *s, void *unused)
+{
+	//struct rtk_usb_phy_s		*rtk_phy = s->private;
+
+	seq_printf(s, "ehco 1 to toggle Page1 addr 0xe0 BIT(2)\n");
+
+	return 0;
+}
+
+static int rtk_rle0599_toggle_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_rle0599_toggle_show, inode->i_private);
+}
+
+static ssize_t rtk_rle0599_toggle_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct rtk_usb_phy_s		*rtk_phy = s->private;
+	char			buf[32];
+
+	if (copy_from_user(&buf, ubuf, min_t(size_t, sizeof(buf) - 1, count)))
+		return -EFAULT;
+
+	if (!strncmp(buf, "1", 1))
+		rtk_rle0599_phy_toggle(&rtk_phy->phy, false);
+
+	return count;
+}
+
+static const struct file_operations rtk_rle0599_toggle_fops = {
+	.open			= rtk_rle0599_toggle_open,
+	.write			= rtk_rle0599_toggle_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static inline void create_debug_files(struct rtk_usb_phy_s *rtk_phy) {
+	struct dentry *phy_debug_root = NULL;
+
+	dev_dbg(rtk_phy->dev, "%s", __func__);
+
+	phy_debug_root = create_phy_debug_root();
+
+	if (!phy_debug_root) {
+		dev_err(rtk_phy->dev, "%s Error phy_debug_root is NULL", __func__);
+		return;
+	}
+
+	rtk_phy->debug_dir = debugfs_create_dir(dev_name(rtk_phy->dev), phy_debug_root);
+	if (!rtk_phy->debug_dir) {
+		dev_err(rtk_phy->dev, "%s Error debug_dir is NULL", __func__);
+		return;
+	}
+
+	if (!debugfs_create_file("parameter", S_IRUGO, rtk_phy->debug_dir, rtk_phy,
+						&rtk_rle0599_parameter_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("set_parameter", S_IRUGO | S_IWUSR, rtk_phy->debug_dir, rtk_phy,
+						&rtk_rle0599_set_parameter_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("toggle", S_IRUGO | S_IWUSR, rtk_phy->debug_dir, rtk_phy,
+						&rtk_rle0599_toggle_fops))
+		goto file_error;
+
+	return;
+
+file_error:
+	debugfs_remove_recursive(rtk_phy->debug_dir);
+}
+#endif //CONFIG_DYNAMIC_DEBUG
+
+static int rtk_usb_rle0599_phy_probe(struct platform_device *pdev)
+{
+	struct rtk_usb_phy_s *rtk_usb_phy;
+	struct device *dev = &pdev->dev;
+	int	ret = 0;
+	struct reg_addr *addr;
+	struct phy_data *phy_data;
+	int phy_data_page0_size, phy_data_page1_size;
+
+	rtk_usb_phy = devm_kzalloc(dev, sizeof(*rtk_usb_phy), GFP_KERNEL);
+	if (!rtk_usb_phy)
+		return -ENOMEM;
+
+	rtk_usb_phy->dev			= &pdev->dev;
+	rtk_usb_phy->phy.dev		= rtk_usb_phy->dev;
+	rtk_usb_phy->phy.label		= RTK_USB_RLE0599_PHY_NAME;
+	rtk_usb_phy->phy.init		= rtk_usb_phy_init;
+	rtk_usb_phy->phy.shutdown	= rtk_usb_phy_shutdown;
+
+	if (dev->of_node) {
+		ret = of_property_read_u32_index(dev->of_node, "phyN", 0, &rtk_usb_phy->phyN);
+		if (ret) goto err;
+		dev_dbg(dev, "%s %s phyN=%d\n", __FILE__, __func__, rtk_usb_phy->phyN);
+		addr = devm_kzalloc(dev, sizeof(*addr), GFP_KERNEL);
+		if (!addr) return -ENOMEM;
+
+		addr->REG_WRAP_VStatusOut2 = of_iomap(dev->of_node, 0);
+		addr->REG_EHCI_INSNREG05   = of_iomap(dev->of_node, 1);
+
+		rtk_usb_phy->reg_addr = addr;
+
+		dev_dbg(dev, "%s %s REG_WRAP_VStatusOut2=%p\n", __FILE__, __func__, addr->REG_WRAP_VStatusOut2);
+		dev_dbg(dev, "%s %s REG_EHCI_INSNREG05=%p\n", __FILE__, __func__, addr->REG_EHCI_INSNREG05);
+		ret = of_property_read_u32_index(dev->of_node, "phy_data_page0_size", 0, &phy_data_page0_size);
+		if (ret) goto err;
+		ret = of_property_read_u32_index(dev->of_node, "phy_data_page1_size", 0, &phy_data_page1_size);
+		if (ret) goto err;
+
+		dev_dbg(dev, "%s %s phy_data_page0_size=%d, phy_data_page1_size=%d\n",
+					__FILE__, __func__, phy_data_page0_size, phy_data_page1_size);
+	}
+
+	phy_data = devm_kzalloc(dev, sizeof(*phy_data), GFP_KERNEL);
+	if (!phy_data)
+		return -ENOMEM;
+	phy_data->page0_size = phy_data_page0_size;
+	phy_data->page0 = devm_kzalloc(dev, sizeof(struct rtk_usb_phy_data_s)*phy_data_page0_size, GFP_KERNEL);
+	if (!phy_data->page0)
+		return -ENOMEM;
+	phy_data->page1_size = phy_data_page1_size;
+	phy_data->page1 = devm_kzalloc(dev, sizeof(struct rtk_usb_phy_data_s)*phy_data_page1_size, GFP_KERNEL);
+	if (!phy_data->page1)
+		return -ENOMEM;
+
+	rtk_usb_phy->chip_id = get_rtd_chip_id();
+	rtk_usb_phy->chip_revision = get_rtd_chip_revision();
+
+	dev_info(dev, "%s: Chip %x revision is %x\n", __func__,
+		    rtk_usb_phy->chip_id, rtk_usb_phy->chip_revision);
+
+	if (dev->of_node) {
+		char tmp_addr[phy_data_page0_size];
+		char tmp_data[phy_data_page0_size];
+		int i = 0;
+		ret = of_property_read_u8_array(dev->of_node, "phy_data_page0_addr", tmp_addr, phy_data_page0_size);
+		if (ret) goto err;
+		ret = of_property_read_u8_array(dev->of_node, "phy_data_page0_data", tmp_data, phy_data_page0_size);
+		if (ret) goto err;
+		for (i = 0; i < phy_data_page0_size; i++) {
+			struct rtk_usb_phy_data_s *phy_data_page0 = (phy_data->page0 + i);
+			phy_data_page0->addr = tmp_addr[i];
+			phy_data_page0->data = tmp_data[i];
+		}
+		ret = of_property_read_u8_array(dev->of_node, "phy_data_page1_addr", tmp_addr, phy_data_page1_size);
+		if (ret) goto err;
+		ret = of_property_read_u8_array(dev->of_node, "phy_data_page1_data", tmp_data, phy_data_page1_size);
+		if (ret) goto err;
+		for (i = 0; i < phy_data_page1_size; i++) {
+			struct rtk_usb_phy_data_s *phy_data_page1 = (phy_data->page1 + i);
+			phy_data_page1->addr = tmp_addr[i];
+			phy_data_page1->data = tmp_data[i];
+		}
+		rtk_usb_phy->phy_data = phy_data;
+
+		if (of_property_read_bool(dev->of_node, "do_toggle"))
+			phy_data->do_toggle = true;
+		else
+			phy_data->do_toggle = false;
+
+		if (of_property_read_bool(dev->of_node, "check_efuse"))
+			phy_data->check_efuse = true;
+		else
+			phy_data->check_efuse = false;
+
+		if (of_property_read_bool(dev->of_node, "use_default_parameter"))
+			phy_data->use_default_parameter = true;
+		else
+			phy_data->use_default_parameter = false;
+
+	}
+
+#if 0
+	/* Due to usb_add_phy only support one USB2_phy and one USB3_phy
+	 * DWC3 use USB2_phy and USB3_phy, EHCI don't add it
+	 */
+	ret = usb_add_phy(&rtk_usb_phy->phy, USB_PHY_TYPE_USB2);
+	if (ret)
+		goto err;
+#endif
+
+	platform_set_drvdata(pdev, rtk_usb_phy);
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	create_debug_files(rtk_usb_phy);
+#endif
+
+	dev_info(&pdev->dev, "Probe RTK USB 2.0 RLE0599 PHY\n");
+
+err:
+	return ret;
+}
+
+static int rtk_usb_rle0599_phy_remove(struct platform_device *pdev)
+{
+	struct rtk_usb_phy_s *rtk_usb_phy = platform_get_drvdata(pdev);
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	debugfs_remove_recursive(rtk_usb_phy->debug_dir);
+#endif
+
+#if 0
+	/* Due to usb_add_phy only support one USB2_phy and one USB3_phy
+	 * DWC3 use USB2_phy and USB3_phy, EHCI don't add it
+	 */
+	usb_remove_phy(&rtk_usb_phy->phy);
+#endif
+
+	return 0;
+}
+
+static const struct of_device_id usb_phy_rle0599_rtk_dt_ids[] = {
+	{ .compatible = "Realtek,rtd119x-usb_phy_rle0599", },
+	{ .compatible = "Realtek,rtd129x-usb_phy_rle0599", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, usb_phy_rle0599_rtk_dt_ids);
+
+static struct platform_driver rtk_usb_rle0599_phy_driver = {
+	.probe		= rtk_usb_rle0599_phy_probe,
+	.remove		= rtk_usb_rle0599_phy_remove,
+	.driver		= {
+		.name	= RTK_USB_RLE0599_PHY_NAME,
+		.owner	= THIS_MODULE,
+		.of_match_table = of_match_ptr(usb_phy_rle0599_rtk_dt_ids),
+	},
+};
+
+module_platform_driver(rtk_usb_rle0599_phy_driver);
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:" RTK_USB_RLE0599_PHY_NAME);
diff --git a/drivers/usb/phy/phy-rtk-usb.h b/drivers/usb/phy/phy-rtk-usb.h
new file mode 100644
index 00000000..3b39b3c
--- /dev/null
+++ b/drivers/usb/phy/phy-rtk-usb.h
@@ -0,0 +1,53 @@
+/*
+ *  phy-rtk-usb.h RTK usb phy header file
+ *
+ * copyright (c) 2017 realtek semiconductor corporation
+ *
+ * this program is free software; you can redistribute it and/or modify
+ * it under the terms of the gnu general public license as published by
+ * the free software foundation; either version 2 of the license, or
+ * (at your option) any later version.
+ */
+
+#ifndef __PHY_RTK_USB_H__
+#define __PHY_RTK_USB_H__
+
+struct rtk_usb_phy_s {
+	struct usb_phy phy;
+	struct device *dev;
+
+	enum rtd_chip_id chip_id;
+	enum rtd_chip_revision chip_revision;
+
+	int phyN;
+	void *reg_addr;
+	void *phy_data;
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	struct dentry		*debug_dir;
+#endif
+};
+
+struct rtk_usb_phy_data_s {
+	char addr;
+	char data;
+};
+
+#define phy_read(addr)			__raw_readl(addr)
+#define phy_write(addr, val)	do { smp_wmb(); __raw_writel(val, addr); } while(0)
+#define PHY_IO_TIMEOUT_MSEC		(50)
+
+static inline int utmi_wait_register(void __iomem *reg, u32 mask, u32 result)
+{
+	unsigned long timeout = jiffies + msecs_to_jiffies(PHY_IO_TIMEOUT_MSEC);
+	while (time_before(jiffies, timeout)) {
+		smp_rmb();
+		if ((phy_read(reg) & mask) == result)
+			return 0;
+		udelay(100);
+	}
+	pr_err("\033[0;32;31m can't program USB phy \033[m\n");
+	return -1;
+}
+
+#endif /* __PHY_RTK_USB_H__ */
diff --git a/drivers/usb/phy/phy-rtk-usb2.c b/drivers/usb/phy/phy-rtk-usb2.c
new file mode 100644
index 00000000..1f92857
--- /dev/null
+++ b/drivers/usb/phy/phy-rtk-usb2.c
@@ -0,0 +1,759 @@
+/*
+ *  phy-rtk-usb2.c RTK usb2.0 PHY driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/delay.h>
+#include <linux/err.h>
+#include <linux/io.h>
+#include <linux/usb/otg.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/uaccess.h>
+#include <linux/debugfs.h>
+#include <soc/realtek/rtd129x_efuse.h>
+#include <soc/realtek/rtk_chip.h>
+
+#include "phy-rtk-usb.h"
+
+#define RTK_USB2PHY_NAME "rtk-usb2phy"
+
+#define WAIT_VBUSY_RETRY	3
+
+#define OFFEST_PHY_READ	0x20
+
+#define USB_ST_BUSY		BIT(23)
+
+struct reg_addr {
+	void __iomem *REG_WRAP_VStatusOut2;
+	void __iomem *REG_GUSB2PHYACC0;
+	int vstatus_index;
+};
+
+struct phy_data {
+	int page0_size;
+	struct rtk_usb_phy_data_s *page0;
+	int page1_size;
+	struct rtk_usb_phy_data_s *page1;
+
+	bool check_efuse;
+	u8 efuse_usb_dp_dm;
+	bool do_toggle;
+	bool use_default_parameter;
+};
+
+#define MAX_PHY_DATA_SIZE 20
+
+static u8 efuse_usb_dp_dm_table[0x10] = {0xe0, 0x80, 0x84, 0x88, 0x8c, 0x90, 0x94, 0x98,
+					 0x9c, 0xa0, 0xa4, 0xa8, 0xac, 0xb0, 0xb4, 0xb8};
+
+static char rtk_usb_phy_read(struct reg_addr *regAddr, char addr)
+{
+	volatile unsigned int regVal;
+	void __iomem *REG_GUSB2PHYACC0 = regAddr->REG_GUSB2PHYACC0;
+
+	// polling until VBusy == 0
+	utmi_wait_register(REG_GUSB2PHYACC0, USB_ST_BUSY, 0);
+
+	// VCtrl = low nibble of addr, VLoadM = 1
+	regVal = BIT(25) | // vload
+			 ((addr & 0x0f) << 8);	// vcontrol
+	phy_write(REG_GUSB2PHYACC0, regVal);
+	utmi_wait_register(REG_GUSB2PHYACC0, USB_ST_BUSY, 0);
+
+	// VCtrl = high nibble of addr, VLoadM = 1
+	regVal = BIT(25) | // vload
+			 ((addr & 0xf0) << 4);	// vcontrol
+	phy_write(REG_GUSB2PHYACC0, regVal);
+	utmi_wait_register(REG_GUSB2PHYACC0, USB_ST_BUSY, 0);
+
+	smp_rmb();
+	regVal = phy_read(REG_GUSB2PHYACC0);
+
+	return (char) (regVal & 0xff);
+}
+
+static int rtk_usb_phy_write(struct reg_addr *regAddr, char addr, char data)
+{
+	volatile unsigned int regVal;
+	void __iomem *REG_WRAP_VStatusOut2 = regAddr->REG_WRAP_VStatusOut2;
+	void __iomem *REG_GUSB2PHYACC0 = regAddr->REG_GUSB2PHYACC0;
+	int shift_bits = regAddr->vstatus_index * 8;
+
+	//write data to VStatusOut2 (data output to phy)
+	phy_write(REG_WRAP_VStatusOut2, (u32)data<<shift_bits);
+	utmi_wait_register(REG_GUSB2PHYACC0, USB_ST_BUSY, 0);
+
+	// VCtrl = low nibble of addr, VLoadM = 1
+	regVal = BIT(25) |
+			 ((addr & 0x0f) << 8);
+
+	phy_write(REG_GUSB2PHYACC0, regVal);
+	utmi_wait_register(REG_GUSB2PHYACC0, USB_ST_BUSY, 0);
+
+	// VCtrl = high nibble of addr, VLoadM = 1
+	regVal = BIT(25) |
+			 ((addr & 0xf0) << 4);
+
+	phy_write(REG_GUSB2PHYACC0, regVal);
+	utmi_wait_register(REG_GUSB2PHYACC0, USB_ST_BUSY, 0);
+
+	return 0;
+}
+
+static int rtk_usb_phy_set_page(struct reg_addr *regAddr, int page)
+{
+	return rtk_usb_phy_write(regAddr, 0xf4, page == 0 ? 0x9b : 0xbb);
+}
+
+static void rtk_usb2_phy_shutdown(struct usb_phy *phy)
+{
+	/* Todo */
+}
+
+static int updated_phy_parameter_by_efuse(struct phy_data *phy_data)
+{
+	u8 value = 0;
+	int size = 4;
+	int shift = 0;
+	int offest = 0x1dc;
+	int mask = (BIT(size) - 1);
+	struct rtk_usb_phy_data_s *phy_page0_default_setting = phy_data->page0;
+	int i;
+
+#if 0
+	value = (efuse_readb(offest) << shift) & mask;
+	dev_dbg(rtk_usb_phy->dev, "Get Efuse EFUSE_USB_DP_DM %x Mask %x\n",
+			efuse_readb(offest), mask);
+#else
+	pr_err("%s(): ERROR Need implement efuse_readb\n", __func__);
+#endif
+	phy_data->efuse_usb_dp_dm = value;
+
+	for (i = 0; i<phy_data->page0_size; i++) {
+		if ((phy_page0_default_setting + i)->addr == 0xe0) {
+			(phy_page0_default_setting + i)->data =
+				    efuse_usb_dp_dm_table[value & mask];
+			pr_debug("Set addr %x value %x\n",
+				(phy_page0_default_setting + i)->addr,
+				(phy_page0_default_setting + i)->data);
+		}
+	}
+	return 0;
+}
+
+void do_rtk_usb2_phy_toggle(struct rtk_usb_phy_s *rtk_phy, int index, bool isConnect);
+
+static int do_rtk_usb2_phy_init(struct usb_phy *phy, int index)
+{
+	int i;
+	struct rtk_usb_phy_s *rtk_phy = (struct rtk_usb_phy_s*) phy;
+	struct reg_addr *regAddr = &((struct reg_addr *)rtk_phy->reg_addr)[index];
+	struct phy_data *phy_data = &((struct phy_data *)rtk_phy->phy_data)[index];
+	struct rtk_usb_phy_data_s *phy_page0_default_setting = phy_data->page0;
+	struct rtk_usb_phy_data_s *phy_page1_default_setting = phy_data->page1;
+
+	dev_info(phy->dev, "%s Init RTK USB 2.0 PHY phy#%d\n", __func__, index);
+
+	if (phy_data->use_default_parameter) {
+		dev_info(phy->dev, "%s phy#%d use default parameter\n",
+			    __func__, index);
+		goto do_toggle;
+	}
+
+	if (phy_data->check_efuse)
+		updated_phy_parameter_by_efuse(phy_data);
+
+	/* Set page 0 */
+	rtk_usb_phy_set_page(regAddr, 0);
+
+	for (i=0; i<phy_data->page0_size; i++) {
+		if (rtk_usb_phy_write(regAddr, (phy_page0_default_setting + i)->addr,
+			    (phy_page0_default_setting + i)->data)) {
+			dev_err(phy->dev, "[%s:%d], page0 Error : addr = 0x%x, "
+				    "value = 0x%x\n",
+				    __FUNCTION__, __LINE__,
+				    (phy_page0_default_setting + i)->addr,
+				    (phy_page0_default_setting + i)->data);
+			return -1;
+		} else {
+			dev_dbg(phy->dev, "[%s:%d], page0 Good : addr = 0x%x, "
+				    "value = 0x%x\n",
+				    __FUNCTION__, __LINE__,
+				    (phy_page0_default_setting + i)->addr,
+				    rtk_usb_phy_read(regAddr,
+				        (phy_page0_default_setting + i)->addr - OFFEST_PHY_READ)
+				    );
+		}
+	}
+
+	/* Set page 1 */
+	rtk_usb_phy_set_page(regAddr, 1);
+
+	for (i=0; i<phy_data->page1_size; i++) {
+		if (rtk_usb_phy_write(regAddr, (phy_page1_default_setting + i)->addr,
+			    (phy_page1_default_setting + i)->data)) {
+			dev_err(phy->dev, "[%s:%d], page1 Error : addr = 0x%x, "
+				    "value = 0x%x\n",
+				    __FUNCTION__, __LINE__,
+				    (phy_page1_default_setting + i)->addr,
+				    (phy_page1_default_setting + i)->data);
+			return -1;
+		} else {
+			dev_dbg(phy->dev, "[%s:%d], page1 Good : addr = 0x%x, "
+				    "value = 0x%x\n",
+				    __FUNCTION__, __LINE__,
+				    (phy_page1_default_setting + i)->addr,
+				    rtk_usb_phy_read(regAddr,
+				        (phy_page1_default_setting + i)->addr - OFFEST_PHY_READ)
+				    );
+		}
+	}
+
+do_toggle:
+	do_rtk_usb2_phy_toggle(rtk_phy, index, false);
+
+	return 0;
+}
+
+static int rtk_usb2_phy_init(struct usb_phy *phy)
+{
+	struct rtk_usb_phy_s *rtk_phy = (struct rtk_usb_phy_s*) phy;
+	int i, ret = 0;
+	unsigned long phy_init_time = jiffies;
+
+	dev_info(phy->dev, "%s Init RTK USB 2.0 PHY\n", __func__);
+	for (i = 0; i < rtk_phy->phyN; i++) {
+		ret = do_rtk_usb2_phy_init(phy, i);
+	}
+	dev_info(phy->dev, "%s Initialized RTK USB 2.0 PHY (take %dms)\n",
+		    __func__,
+		    jiffies_to_msecs(jiffies - phy_init_time));
+	return ret;
+}
+
+void do_rtk_usb2_phy_toggle(struct rtk_usb_phy_s *rtk_phy, int index, bool isConnect)
+{
+	struct reg_addr *regAddr = &((struct reg_addr *)rtk_phy->reg_addr)[index];
+	struct phy_data *phy_data = &((struct phy_data *)rtk_phy->phy_data)[index];
+
+	if (phy_data && !phy_data->do_toggle) return;
+
+	if (phy_data) {
+		int i;
+		struct rtk_usb_phy_data_s *phy_page0_default_setting = phy_data->page0;
+		struct rtk_usb_phy_data_s *phy_page1_default_setting = phy_data->page1;
+		/* Set page 1 */
+		rtk_usb_phy_set_page(regAddr, 1);
+		for (i=0; i < phy_data->page1_size; i++) {
+			if ((phy_page1_default_setting + i)->addr == 0xe0) {
+				dev_info(rtk_phy->dev, "%s ########## to toggle Page1 addr 0xe0 BIT(2)\n", __func__);
+				rtk_usb_phy_write(regAddr,
+					    (phy_page1_default_setting + i)->addr,
+					    ((phy_page1_default_setting + i)->data) & (~BIT(2)));
+				mdelay(1);
+				rtk_usb_phy_write(regAddr,
+					    (phy_page1_default_setting + i)->addr,
+					    (phy_page1_default_setting + i)->data);
+			}
+		}
+
+		/* Set page 0 */
+		rtk_usb_phy_set_page(regAddr, 0);
+		for (i=0; i<phy_data->page0_size; i++) {
+			if ((phy_page0_default_setting + i)->addr == 0xE7) {
+				if (isConnect) {
+					rtk_usb_phy_write(regAddr,
+						    (phy_page0_default_setting + i)->addr,
+						    (phy_page0_default_setting + i)->data &
+						        (~(BIT(4) | BIT(5) | BIT(6)))
+						    );
+				} else {
+					rtk_usb_phy_write(regAddr,
+						    (phy_page0_default_setting + i)->addr,
+						    (phy_page0_default_setting + i)->data |
+						        (BIT(4) | BIT(5) | BIT(6))
+						    );
+				}
+				dev_info(rtk_phy->dev, "%s %sconnect to set Page0 0xE7 = %x\n",
+					    __func__,
+					    isConnect?"":"dis",
+					    rtk_usb_phy_read(regAddr,
+					        (phy_page0_default_setting + i)->addr));
+			}
+		}
+	}
+}
+
+void rtk_usb2_phy_toggle(struct usb_phy *usb2_phy, bool isConnect, int port)
+{
+	int index = port;
+	struct rtk_usb_phy_s *rtk_phy = NULL;
+
+	if (usb2_phy != NULL && usb2_phy->dev != NULL)
+		rtk_phy = dev_get_drvdata(usb2_phy->dev);
+
+	if (rtk_phy == NULL) {
+		pr_err("%s %d ERROR! NO this device\n", __func__, __LINE__);
+		return;
+	}
+
+	do_rtk_usb2_phy_toggle(rtk_phy, index, isConnect);
+
+}
+EXPORT_SYMBOL(rtk_usb2_phy_toggle);
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+extern struct dentry *create_phy_debug_root(void);
+
+static int rtk_usb2_parameter_show(struct seq_file *s, void *unused)
+{
+	struct rtk_usb_phy_s		*rtk_phy = s->private;
+	int i, index;
+
+	for (index = 0; index < rtk_phy->phyN; index++) {
+		struct reg_addr *regAddr =
+			    &((struct reg_addr *)rtk_phy->reg_addr)[index];
+		struct phy_data *phy_data =
+			    &((struct phy_data *)rtk_phy->phy_data)[index];
+		struct rtk_usb_phy_data_s *phy_page0_default_setting = phy_data->page0;
+		struct rtk_usb_phy_data_s *phy_page1_default_setting = phy_data->page1;
+
+		seq_printf(s, "PHY %d:\n", index);
+
+		seq_printf(s, "Page 0:\n");
+		/* Set page 0 */
+		rtk_usb_phy_set_page(regAddr, 0);
+
+		for (i = 0; i < phy_data->page0_size; i++) {
+			seq_printf(s, "Page 0: addr = 0x%x, value = 0x%x\n",
+				    (phy_page0_default_setting + i)->addr,
+				    rtk_usb_phy_read(regAddr,
+				        (phy_page0_default_setting + i)->addr - OFFEST_PHY_READ)
+				    );
+		}
+
+		seq_printf(s, "Page 1:\n");
+		/* Set page 1 */
+		rtk_usb_phy_set_page(regAddr, 1);
+
+		for (i = 0; i < phy_data->page1_size; i++) {
+			seq_printf(s, "Page 1: addr = 0x%x, value = 0x%x\n",
+				    (phy_page1_default_setting + i)->addr,
+				    rtk_usb_phy_read(regAddr,
+				        (phy_page1_default_setting + i)->addr - OFFEST_PHY_READ)
+				    );
+		}
+	}
+
+	return 0;
+}
+
+static int rtk_usb2_parameter_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_usb2_parameter_show, inode->i_private);
+}
+
+static const struct file_operations rtk_usb2_parameter_fops = {
+	.open			= rtk_usb2_parameter_open,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int rtk_usb2_set_parameter_show(struct seq_file *s, void *unused)
+{
+	//struct rtk_usb_phy_s	*rtk_phy = s->private;
+
+	seq_printf(s, "Set Phy parameter by following command\n");
+	seq_printf(s, "echo \"phy_num page addr value\" > set_parameter\n");
+	seq_printf(s, "echo \"0 page0 0xE1 0x30\" > set_parameter\n");
+	seq_printf(s, "echo \"0 page1 0xE1 0xEF\" > set_parameter\n");
+
+	return 0;
+}
+
+static int rtk_usb2_set_parameter_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_usb2_set_parameter_show, inode->i_private);
+}
+
+static ssize_t rtk_usb2_set_parameter_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct rtk_usb_phy_s		*rtk_phy = s->private;
+	struct reg_addr *regAddr;
+	struct phy_data *phy_data;
+	struct rtk_usb_phy_data_s *phy_page0_default_setting;
+	struct rtk_usb_phy_data_s *phy_page1_default_setting;
+	//unsigned long		flags;
+	char			buffer[40];
+	char *buf = buffer;
+	int i, index;
+	u32 addr;
+	u32 value;
+
+	if (copy_from_user(&buffer, ubuf, min_t(size_t, sizeof(buffer) - 1, count)))
+		return -EFAULT;
+
+	sscanf(buf, "%d", &index);
+	buf = buf + 2;
+	regAddr = &((struct reg_addr *)rtk_phy->reg_addr)[index];
+	phy_data = &((struct phy_data *)rtk_phy->phy_data)[index];
+	phy_page0_default_setting = phy_data->page0;
+	phy_page1_default_setting = phy_data->page1;
+
+	//spin_lock_irqsave(&rtk_phy_lock, flags);
+	if (!strncmp(buf, "page0", 5)) {
+		buf = buf + 5;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x %x", &addr, &value);
+
+		rtk_usb_phy_set_page(regAddr, 0);
+		for (i = 0; i<phy_data->page0_size; i++) {
+			if ((phy_page0_default_setting + i)->addr == addr) {
+				(phy_page0_default_setting + i)->data = value;
+				if (rtk_usb_phy_write(regAddr,
+					    (phy_page0_default_setting + i)->addr,
+					    (phy_page0_default_setting + i)->data))
+					dev_err(rtk_phy->dev, "[%s:%d], page0 Error : addr = 0x%x, "
+						    "value = 0x%x\n",
+						    __FUNCTION__, __LINE__,
+						    (phy_page0_default_setting + i)->addr,
+						    (phy_page0_default_setting + i)->data);
+				else
+					dev_dbg(rtk_phy->dev, "[%s:%d], page0 Good : addr = 0x%x, "
+						    "value = 0x%x\n",
+						    __FUNCTION__, __LINE__,
+						    (phy_page0_default_setting + i)->addr,
+						    rtk_usb_phy_read(regAddr,
+						    (phy_page0_default_setting + i)->addr -
+						        OFFEST_PHY_READ));
+			}
+		}
+	} else if (!strncmp(buf, "page1", 5)) {
+		buf = buf + 5;
+		buf = skip_spaces(buf);
+		sscanf(buf, "%x %x", &addr, &value);
+
+		rtk_usb_phy_set_page(regAddr, 1);
+		for (i = 0; i<phy_data->page1_size; i++) {
+			if ((phy_page1_default_setting + i)->addr == addr) {
+				(phy_page1_default_setting + i)->data = value;
+				if (rtk_usb_phy_write(regAddr,
+					    (phy_page1_default_setting + i)->addr,
+					    (phy_page1_default_setting + i)->data))
+					dev_err(rtk_phy->dev, "[%s:%d], page1 Error : addr = 0x%x, "
+						    "value = 0x%x\n",
+						    __FUNCTION__, __LINE__,
+						    (phy_page1_default_setting + i)->addr,
+						    (phy_page1_default_setting + i)->data);
+				else
+					dev_dbg(rtk_phy->dev, "[%s:%d], page1 Good : addr = 0x%x, "
+						    "value = 0x%x\n",
+						    __FUNCTION__, __LINE__,
+						    (phy_page1_default_setting + i)->addr,
+						    rtk_usb_phy_read(regAddr,
+						        (phy_page1_default_setting + i)->addr -
+						        OFFEST_PHY_READ));
+			}
+		}
+	} else
+		dev_err(rtk_phy->dev, "UNKNOWN input (%s)", buf);
+
+	//spin_unlock_irqrestore(&rtk_phy_lock, flags);
+	return count;
+}
+
+static const struct file_operations rtk_usb2_set_parameter_fops = {
+	.open			= rtk_usb2_set_parameter_open,
+	.write			= rtk_usb2_set_parameter_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int rtk_usb2_toggle_show(struct seq_file *s, void *unused)
+{
+	//struct rtk_usb_phy_s		*rtk_phy = s->private;
+
+	seq_printf(s, "ehco 1 to toggle Page1 addr 0xe0 BIT(2)\n");
+
+	return 0;
+}
+
+static int rtk_usb2_toggle_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_usb2_toggle_show, inode->i_private);
+}
+
+static ssize_t rtk_usb2_toggle_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct rtk_usb_phy_s		*rtk_phy = s->private;
+	char			buf[32];
+
+	if (copy_from_user(&buf, ubuf, min_t(size_t, sizeof(buf) - 1, count)))
+		return -EFAULT;
+
+	if (!strncmp(buf, "1", 1))
+		rtk_usb2_phy_toggle(&rtk_phy->phy, false, 0);
+
+	return count;
+}
+
+static const struct file_operations rtk_usb2_toggle_fops = {
+	.open			= rtk_usb2_toggle_open,
+	.write			= rtk_usb2_toggle_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static inline void create_debug_files(struct rtk_usb_phy_s *rtk_phy) {
+	struct dentry *phy_debug_root = NULL;
+
+	dev_dbg(rtk_phy->dev, "%s", __func__);
+
+	phy_debug_root = create_phy_debug_root();
+
+	if (!phy_debug_root) {
+		dev_err(rtk_phy->dev, "%s Error phy_debug_root is NULL", __func__);
+		return;
+	}
+
+	rtk_phy->debug_dir = debugfs_create_dir(dev_name(rtk_phy->dev),
+		    phy_debug_root);
+	if (!rtk_phy->debug_dir) {
+		dev_err(rtk_phy->dev, "%s Error debug_dir is NULL", __func__);
+		return;
+	}
+
+	if (!debugfs_create_file("parameter", S_IRUGO, rtk_phy->debug_dir, rtk_phy,
+		    &rtk_usb2_parameter_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("set_parameter", S_IRUGO | S_IWUSR,
+		    rtk_phy->debug_dir, rtk_phy, &rtk_usb2_set_parameter_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("toggle", S_IRUGO | S_IWUSR,
+		    rtk_phy->debug_dir, rtk_phy, &rtk_usb2_toggle_fops))
+		goto file_error;
+
+	return;
+
+file_error:
+	debugfs_remove_recursive(rtk_phy->debug_dir);
+}
+#endif //CONFIG_DYNAMIC_DEBUG
+
+static int rtk_usb2phy_probe(struct platform_device *pdev)
+{
+	struct rtk_usb_phy_s *rtk_usb_phy;
+	struct device *dev = &pdev->dev;
+	struct device_node	*node = dev->of_node;
+	int index, ret = 0;
+	int phyN;
+
+	rtk_usb_phy = devm_kzalloc(dev, sizeof(*rtk_usb_phy), GFP_KERNEL);
+	if (!rtk_usb_phy)
+		return -ENOMEM;
+
+	rtk_usb_phy->dev			= &pdev->dev;
+	rtk_usb_phy->phy.dev		= rtk_usb_phy->dev;
+	rtk_usb_phy->phy.label		= RTK_USB2PHY_NAME;
+	rtk_usb_phy->phy.init		= rtk_usb2_phy_init;
+	rtk_usb_phy->phy.shutdown	= rtk_usb2_phy_shutdown;
+
+	if (!dev->of_node) {
+		dev_err(dev, "%s %d No device node\n", __func__, __LINE__);
+		goto err;
+	}
+	ret = of_property_read_u32_index(dev->of_node, "phyN", 0,
+		    &phyN);
+	if (ret) goto err;
+
+	dev_dbg(dev, "%s %d phyN=%d\n", __func__, __LINE__, phyN);
+
+	rtk_usb_phy->phyN = phyN;
+	rtk_usb_phy->reg_addr = devm_kzalloc(dev,
+		    sizeof(struct reg_addr) * phyN, GFP_KERNEL);
+	if (!rtk_usb_phy->reg_addr) return -ENOMEM;
+
+	rtk_usb_phy->phy_data = devm_kzalloc(dev, sizeof(struct phy_data) * phyN,
+		    GFP_KERNEL);
+
+	if (!rtk_usb_phy->phy_data)
+		return -ENOMEM;
+
+	rtk_usb_phy->chip_id = get_rtd_chip_id();
+	rtk_usb_phy->chip_revision = get_rtd_chip_revision();
+
+	dev_info(dev, "%s: Chip %x revision is %x\n", __func__,
+		    rtk_usb_phy->chip_id, rtk_usb_phy->chip_revision);
+
+	for (index = 0; index < phyN; index++) {
+		struct reg_addr *addr =
+			    &((struct reg_addr *)rtk_usb_phy->reg_addr)[index];
+		struct phy_data *phy_data =
+			    &((struct phy_data *)rtk_usb_phy->phy_data)[index];
+		int phy_data_page0_size, phy_data_page1_size;
+		char phy_name[5];
+		struct device_node *sub_node;
+		char tmp_addr[MAX_PHY_DATA_SIZE];
+		char tmp_data[MAX_PHY_DATA_SIZE];
+		int i;
+
+		addr->REG_GUSB2PHYACC0     = of_iomap(dev->of_node, index);
+		addr->REG_WRAP_VStatusOut2 = of_iomap(dev->of_node, phyN);
+		addr->vstatus_index = index;
+		dev_dbg(dev, "%s %d #%d REG_WRAP_VStatusOut2=%p\n",
+			    __func__, __LINE__, index, addr->REG_WRAP_VStatusOut2);
+		dev_dbg(dev, "%s %d #%d REnprintf_GUSB2PHYACC0=%p\n",
+			    __func__, __LINE__, index, addr->REG_GUSB2PHYACC0);
+
+		snprintf(phy_name, 5, "phy%d", index);
+
+		sub_node = of_get_child_by_name(dev->of_node, phy_name);
+
+		if (!sub_node) {
+			dev_err(dev, "%s %d No device sub node for %s\n",
+				    __func__, __LINE__, phy_name);
+			goto err;
+		}
+
+		ret = of_property_read_u32_index(sub_node,
+			    "phy_data_page0_size", 0, &phy_data_page0_size);
+		if (ret) goto err;
+
+		ret = of_property_read_u32_index(sub_node,
+			    "phy_data_page1_size", 0, &phy_data_page1_size);
+		if (ret) goto err;
+
+		dev_dbg(dev, "%s %d #%d phy_data_page0_size=%d, "
+			    "phy_data_page1_size=%d\n", __func__, __LINE__, index,
+			    phy_data_page0_size, phy_data_page1_size);
+
+		if (phy_data_page0_size > MAX_PHY_DATA_SIZE ||
+			    phy_data_page1_size > MAX_PHY_DATA_SIZE) {
+			dev_err(dev, "%s phy_data size > MAX_PHY_DATA_SIZE\n",
+				    __func__);
+			goto err;
+		}
+
+		phy_data->page0_size = phy_data_page0_size;
+		phy_data->page0 = devm_kzalloc(dev,
+			    sizeof(struct rtk_usb_phy_data_s) * phy_data_page0_size,
+			    GFP_KERNEL);
+		if (!phy_data->page0)
+			return -ENOMEM;
+		phy_data->page1_size = phy_data_page1_size;
+		phy_data->page1 = devm_kzalloc(dev,
+			    sizeof(struct rtk_usb_phy_data_s) * phy_data_page1_size,
+			    GFP_KERNEL);
+		if (!phy_data->page1)
+			return -ENOMEM;
+
+		ret = of_property_read_u8_array(sub_node, "phy_data_page0_addr",
+			    tmp_addr, phy_data_page0_size);
+		if (ret) goto err;
+		ret = of_property_read_u8_array(sub_node, "phy_data_page0_data",
+			    tmp_data, phy_data_page0_size);
+		if (ret) goto err;
+		for (i = 0; i < phy_data_page0_size; i++) {
+			struct rtk_usb_phy_data_s *phy_data_page0 = (phy_data->page0 + i);
+			phy_data_page0->addr = tmp_addr[i];
+			phy_data_page0->data = tmp_data[i];
+		}
+		ret = of_property_read_u8_array(sub_node, "phy_data_page1_addr",
+			    tmp_addr, phy_data_page1_size);
+		if (ret) goto err;
+		ret = of_property_read_u8_array(sub_node, "phy_data_page1_data",
+			    tmp_data, phy_data_page1_size);
+		if (ret) goto err;
+		for (i = 0; i < phy_data_page1_size; i++) {
+			struct rtk_usb_phy_data_s *phy_data_page1 = (phy_data->page1 + i);
+			phy_data_page1->addr = tmp_addr[i];
+			phy_data_page1->data = tmp_data[i];
+		}
+
+		if (of_property_read_bool(sub_node, "do_toggle"))
+			phy_data->do_toggle = true;
+		else
+			phy_data->do_toggle = false;
+
+		if (of_property_read_bool(sub_node, "check_efuse"))
+			phy_data->check_efuse = true;
+		else
+			phy_data->check_efuse = false;
+
+		if (of_property_read_bool(sub_node, "use_default_parameter"))
+			phy_data->use_default_parameter = true;
+		else
+			phy_data->use_default_parameter = false;
+	}
+
+	platform_set_drvdata(pdev, rtk_usb_phy);
+
+	//ret = usb_add_phy(&rtk_usb_phy->phy, USB_PHY_TYPE_USB2);
+	//if (ret)
+	//	goto err;
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	create_debug_files(rtk_usb_phy);
+#endif
+
+	dev_info(&pdev->dev, "%s Probe RTK USB 2.0 PHY\n", __FILE__);
+err:
+	return ret;
+}
+
+static int rtk_usb2phy_remove(struct platform_device *pdev)
+{
+	struct rtk_usb_phy_s *rtk_usb_phy = platform_get_drvdata(pdev);
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	debugfs_remove_recursive(rtk_usb_phy->debug_dir);
+#endif
+
+	//usb_remove_phy(&rtk_usb_phy->phy);
+
+	return 0;
+}
+
+#ifdef CONFIG_OF
+static const struct of_device_id usbphy_rtk_dt_match[] = {
+	{ .compatible = "Realtek,usb2phy", },
+	{ .compatible = "Realtek,rtd119x-usb2phy", },
+	{ .compatible = "Realtek,rtd129x-usb2phy", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, usbphy_rtk_dt_match);
+#endif
+
+static struct platform_driver rtk_usb2phy_driver = {
+	.probe		= rtk_usb2phy_probe,
+	.remove		= rtk_usb2phy_remove,
+	.driver		= {
+		.name	= RTK_USB2PHY_NAME,
+		.owner	= THIS_MODULE,
+		.of_match_table = of_match_ptr(usbphy_rtk_dt_match),
+	},
+};
+
+module_platform_driver(rtk_usb2phy_driver);
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:" RTK_USB2PHY_NAME);
diff --git a/drivers/usb/phy/phy-rtk-usb3.c b/drivers/usb/phy/phy-rtk-usb3.c
new file mode 100644
index 00000000..df7fc8e
--- /dev/null
+++ b/drivers/usb/phy/phy-rtk-usb3.c
@@ -0,0 +1,525 @@
+/*
+ *  phy-rtk-usb3.c RTK usb3.0 phy driver
+ *
+ * copyright (c) 2017 realtek semiconductor corporation
+ *
+ * this program is free software; you can redistribute it and/or modify
+ * it under the terms of the gnu general public license as published by
+ * the free software foundation; either version 2 of the license, or
+ * (at your option) any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/delay.h>
+#include <linux/err.h>
+#include <linux/io.h>
+#include <linux/usb/otg.h>
+#include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/of_irq.h>
+#include <linux/of_address.h>
+#include <linux/usb/ch11.h>
+#include <linux/uaccess.h>
+#include <linux/debugfs.h>
+#include <soc/realtek/rtk_chip.h>
+
+#include "phy-rtk-usb.h"
+
+#define RTK_USB3PHY_NAME "rtk-usb3phy"
+
+struct reg_addr {
+	void __iomem *REG_MDIO_CTL;
+};
+
+struct phy_data {
+	int size;
+	u8 *addr;
+	u16 *data;
+
+	u16 saved_trim_value;//=0xFFFF;
+	u8 connected;//=0;
+
+	bool do_toggle;
+	bool use_default_parameter;
+};
+
+#define WAIT_VBUSY_RETRY	3
+#define USB_ST_BUSY		BIT(7)
+
+static int rtk_usb_phy3_wait_vbusy(struct reg_addr *regAddr)
+{
+	return utmi_wait_register(regAddr->REG_MDIO_CTL, BIT(7), 0);
+}
+
+static u32 rtk_usb_phy_read(struct reg_addr *regAddr, char addr)
+{
+	volatile unsigned int regVal;
+
+	regVal = (addr << 8);
+
+	writel(regVal, regAddr->REG_MDIO_CTL);
+
+	rtk_usb_phy3_wait_vbusy(regAddr);
+
+	return readl(regAddr->REG_MDIO_CTL);
+}
+
+static int rtk_usb_phy_write(struct reg_addr *regAddr, char addr, u16 data)
+{
+	volatile unsigned int regVal;
+
+	regVal = BIT(0)     |
+			(addr << 8) |
+			(data <<16);
+
+	writel(regVal, regAddr->REG_MDIO_CTL);
+
+	rtk_usb_phy3_wait_vbusy(regAddr);
+
+	return 0;
+}
+
+static void rtk_usb_phy_shutdown(struct usb_phy *phy)
+{
+	/* Todo */
+}
+
+void do_rtk_usb3_phy_toggle(struct rtk_usb_phy_s *rtk_phy, int index, bool isConnect);
+
+static int do_rtk_usb_phy_init(struct usb_phy *phy, int phy_index)
+{
+	struct rtk_usb_phy_s *rtk_phy = (struct rtk_usb_phy_s*) phy;
+	struct reg_addr *regAddr =
+		    &((struct reg_addr *)rtk_phy->reg_addr)[phy_index];
+	struct phy_data *phy_data =
+		    &((struct phy_data *)rtk_phy->phy_data)[phy_index];
+	int index = 0;
+	u8 *addr = phy_data->addr;
+	u16 *data = phy_data->data;
+
+	dev_info(phy->dev, "%s Init RTK USB 3.0 PHY phy#%d\n", __func__, phy_index);
+
+	if (phy_data->use_default_parameter) {
+		dev_info(phy->dev, "%s phy#%d use default parameter\n",
+			    __func__, phy_index);
+		goto do_toggle;
+	}
+
+	for (index = 0; index < phy_data->size; index++) {
+		rtk_usb_phy_write(regAddr, *(addr + index), *(data + index));
+	}
+
+	for (index = 0; index < phy_data->size; index++)
+		dev_dbg(phy->dev, "[USB3_PHY], addr = 0x%02x, data = 0x%08x\n",
+				*(addr + index), rtk_usb_phy_read(regAddr, *(addr + index)));
+
+do_toggle:
+	do_rtk_usb3_phy_toggle(rtk_phy, phy_index, false);
+
+	return 0;
+}
+
+static int rtk_usb_phy_init(struct usb_phy *phy)
+{
+	struct rtk_usb_phy_s *rtk_phy = (struct rtk_usb_phy_s*) phy;
+	int ret = 0;
+	int i;
+	unsigned long phy_init_time = jiffies;
+
+	dev_info(phy->dev, "%s Init RTK USB 3.0 PHY\n", __func__);
+	for (i = 0; i < rtk_phy->phyN; i++) {
+		ret = do_rtk_usb_phy_init(phy, i);
+	}
+	dev_info(phy->dev, "%s Initialized RTK USB 3.0 PHY (take %dms)\n",
+		    __func__,
+		    jiffies_to_msecs(jiffies - phy_init_time));
+	return ret;
+}
+
+void do_rtk_usb3_phy_toggle(struct rtk_usb_phy_s *rtk_phy, int i,
+	    bool isConnect)
+{
+	struct reg_addr *regAddr = &((struct reg_addr *)rtk_phy->reg_addr)[i];
+	struct phy_data *phy_data = &((struct phy_data *)rtk_phy->phy_data)[i];
+
+	if (phy_data && !phy_data->do_toggle) return;
+
+	if (phy_data) {
+		u8 *addr = phy_data->addr;
+		u16 *data = phy_data->data;
+		size_t index;
+
+		for (index = 0; index < phy_data->size; index++) {
+			if (*(addr + index) == 0x09) {
+				mdelay(1);
+				dev_info(rtk_phy->dev, "%s ########## to toggle PHY addr 0x09 "
+					    "BIT(9)\n", __func__);
+				rtk_usb_phy_write(regAddr, *(addr + index),
+					    *(data + index) & (~BIT(9)));
+				mdelay(1);
+				rtk_usb_phy_write(regAddr, *(addr + index), *(data + index));
+			}
+		}
+		dev_info(rtk_phy->dev, "%s ########## PHY addr 0x1f = 0x%08x\n",
+			    __func__, rtk_usb_phy_read(regAddr, 0x1f));
+	}
+}
+
+void rtk_usb3_phy_toggle(struct usb_phy *usb3_phy, bool isConnect, int port)
+{
+	int index = port;
+	struct rtk_usb_phy_s *rtk_phy = NULL;
+
+	if (usb3_phy != NULL && usb3_phy->dev != NULL)
+		rtk_phy = dev_get_drvdata(usb3_phy->dev);
+
+	if (rtk_phy == NULL) {
+		pr_err("%s ERROR! NO this device\n", __func__);
+		return;
+	}
+
+	do_rtk_usb3_phy_toggle(rtk_phy, index, isConnect);
+}
+EXPORT_SYMBOL(rtk_usb3_phy_toggle);
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+extern struct dentry *create_phy_debug_root(void);
+
+static int rtk_usb3_parameter_show(struct seq_file *s, void *unused)
+{
+	struct rtk_usb_phy_s		*rtk_phy = s->private;
+	int i, index;
+
+	for (i = 0; i < rtk_phy->phyN; i++) {
+		struct reg_addr *regAddr = &((struct reg_addr *)rtk_phy->reg_addr)[i];
+		struct phy_data *phy_data = &((struct phy_data *)rtk_phy->phy_data)[i];
+		u8 *addr = phy_data->addr;
+
+		seq_printf(s, "[USB3_PHY] PHY %d\n", i);
+
+		for (index = 0; index < phy_data->size; index++)
+			seq_printf(s, "[USB3_PHY], addr = 0x%02x, data = 0x%08x\n",
+				    *(addr + index),
+				    rtk_usb_phy_read(regAddr, *(addr + index)));
+	}
+	return 0;
+}
+
+static int rtk_usb3_parameter_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_usb3_parameter_show, inode->i_private);
+}
+
+static const struct file_operations rtk_usb3_parameter_fops = {
+	.open			= rtk_usb3_parameter_open,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int rtk_usb3_set_parameter_show(struct seq_file *s, void *unused)
+{
+	//struct rtk_usb_phy_s	*rtk_phy = s->private;
+
+	seq_printf(s, "Set Phy parameter by following command\n");
+	seq_printf(s, "echo \"phy_num addr value\" > set_parameter\n");
+	seq_printf(s, "echo \"0 0x00 0x4008\" > set_parameter\n");
+	seq_printf(s, "echo \"0 0x21 0x88AA\" > set_parameter\n");
+
+	return 0;
+}
+
+static int rtk_usb3_set_parameter_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_usb3_set_parameter_show, inode->i_private);
+}
+
+static ssize_t rtk_usb3_set_parameter_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct rtk_usb_phy_s		*rtk_phy = s->private;
+	struct reg_addr * regAddr;
+	struct phy_data *phy_data;
+	u8 *addr;
+	u16 *data;
+	int index, i;
+	char buffer[40];
+	char *buf = buffer;
+	u32 _addr;
+	u32 value;
+
+	if (copy_from_user(&buffer, ubuf, min_t(size_t, sizeof(buffer) - 1, count)))
+		return -EFAULT;
+
+	sscanf(buf, "%d", &i);
+	buf = buf + 1;
+
+	regAddr = &((struct reg_addr *)rtk_phy->reg_addr)[i];
+	phy_data = &((struct phy_data *)rtk_phy->phy_data)[i];
+	addr = phy_data->addr;
+	data = phy_data->data;
+
+	buf = skip_spaces(buf);
+	sscanf(buf, "%x %x", &_addr, &value);
+
+	for (index = 0; index < phy_data->size; index++) {
+		if (_addr == *(addr + index)) {
+			*(data + index) = value;
+			rtk_usb_phy_write(regAddr, *(addr + index), *(data + index));
+		}
+	}
+
+	return count;
+}
+
+static const struct file_operations rtk_usb3_set_parameter_fops = {
+	.open			= rtk_usb3_set_parameter_open,
+	.write			= rtk_usb3_set_parameter_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static int rtk_usb3_toggle_show(struct seq_file *s, void *unused)
+{
+	//struct rtk_usb_phy_s		*rtk_phy = s->private;
+
+	seq_printf(s, "ehco 1 to toggle Page1 addr 0xe0 BIT(2)\n");
+
+	return 0;
+}
+
+static int rtk_usb3_toggle_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, rtk_usb3_toggle_show, inode->i_private);
+}
+
+static ssize_t rtk_usb3_toggle_write(struct file *file,
+		const char __user *ubuf, size_t count, loff_t *ppos)
+{
+	struct seq_file		*s = file->private_data;
+	struct rtk_usb_phy_s		*rtk_phy = s->private;
+	char			buf[32];
+
+	if (copy_from_user(&buf, ubuf, min_t(size_t, sizeof(buf) - 1, count)))
+		return -EFAULT;
+
+	if (!strncmp(buf, "1", 1))
+		rtk_usb3_phy_toggle(&rtk_phy->phy, false, 0);
+
+	return count;
+}
+
+static const struct file_operations rtk_usb3_toggle_fops = {
+	.open			= rtk_usb3_toggle_open,
+	.write			= rtk_usb3_toggle_write,
+	.read			= seq_read,
+	.llseek			= seq_lseek,
+	.release		= single_release,
+};
+
+static inline void create_debug_files(struct rtk_usb_phy_s *rtk_phy) {
+	struct dentry *phy_debug_root = NULL;
+
+	dev_dbg(rtk_phy->dev, "%s", __func__);
+
+	phy_debug_root = create_phy_debug_root();
+
+	if (!phy_debug_root) {
+		dev_err(rtk_phy->dev, "%s Error phy_debug_root is NULL", __func__);
+		return;
+	}
+	rtk_phy->debug_dir = debugfs_create_dir(dev_name(rtk_phy->dev), phy_debug_root);
+	if (!rtk_phy->debug_dir) {
+		dev_err(rtk_phy->dev, "%s Error debug_dir is NULL", __func__);
+		return;
+	}
+
+	if (!debugfs_create_file("parameter", S_IRUGO, rtk_phy->debug_dir, rtk_phy,
+		    &rtk_usb3_parameter_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("set_parameter", S_IRUGO | S_IWUSR, rtk_phy->debug_dir, rtk_phy,
+		    &rtk_usb3_set_parameter_fops))
+		goto file_error;
+
+	if (!debugfs_create_file("toggle", S_IRUGO | S_IWUSR, rtk_phy->debug_dir, rtk_phy,
+		    &rtk_usb3_toggle_fops))
+		goto file_error;
+
+	return;
+
+file_error:
+	debugfs_remove_recursive(rtk_phy->debug_dir);
+}
+#endif //CONFIG_DYNAMIC_DEBUG
+
+static int rtk_usb3phy_probe(struct platform_device *pdev)
+{
+	struct rtk_usb_phy_s *rtk_usb_phy;
+	struct device *dev = &pdev->dev;
+	int phyN;
+	int i,ret = 0;
+
+	rtk_usb_phy = devm_kzalloc(dev, sizeof(*rtk_usb_phy), GFP_KERNEL);
+	if (!rtk_usb_phy)
+		return -ENOMEM;
+
+	rtk_usb_phy->dev			= &pdev->dev;
+	rtk_usb_phy->phy.dev		= rtk_usb_phy->dev;
+	rtk_usb_phy->phy.label		= RTK_USB3PHY_NAME;
+	rtk_usb_phy->phy.init		= rtk_usb_phy_init;
+	rtk_usb_phy->phy.shutdown	= rtk_usb_phy_shutdown;
+
+	if (!dev->of_node) {
+		dev_err(dev, "%s %d No device node\n", __func__, __LINE__);
+		goto err;
+	}
+
+	ret = of_property_read_u32_index(dev->of_node, "phyN", 0,
+		    &phyN);
+	if (ret) goto err;
+
+	rtk_usb_phy->phyN = phyN;
+
+	rtk_usb_phy->reg_addr = devm_kzalloc(dev,
+		    sizeof(struct reg_addr) * phyN, GFP_KERNEL);
+	if (!rtk_usb_phy->reg_addr)
+		return -ENOMEM;
+	rtk_usb_phy->phy_data = devm_kzalloc(dev,
+		    sizeof(struct phy_data) * phyN, GFP_KERNEL);
+	if (!rtk_usb_phy->phy_data)
+		return -ENOMEM;
+
+	rtk_usb_phy->chip_id = get_rtd_chip_id();
+	rtk_usb_phy->chip_revision = get_rtd_chip_revision();
+
+	dev_info(dev, "%s: Chip %x revision is %x\n", __func__,
+		    rtk_usb_phy->chip_id, rtk_usb_phy->chip_revision);
+
+	for (i = 0; i < phyN; i++) {
+		struct reg_addr *addr = &((struct reg_addr *)rtk_usb_phy->reg_addr)[i];
+		struct phy_data *phy_data =
+			    &((struct phy_data *)rtk_usb_phy->phy_data)[i];
+
+		char phy_name[5];
+		struct device_node *sub_node;
+		int rev = 0xA;
+
+		addr->REG_MDIO_CTL = of_iomap(dev->of_node, i);
+		dev_dbg(dev, "%s %d #%d REG_MDIO_CTL=%p\n",
+			    __func__, __LINE__, i, addr->REG_MDIO_CTL);
+
+		snprintf(phy_name, 5, "phy%d", i);
+
+		sub_node = of_get_child_by_name(dev->of_node, phy_name);
+		if (!sub_node) {
+			dev_err(dev, "%s %d No device sub node for %s\n",
+				    __func__, __LINE__, phy_name);
+			goto err;
+		}
+
+		phy_data->saved_trim_value = 0xFFFF;
+		phy_data->connected = 0;
+
+		ret = of_property_read_u32_index(sub_node, "phy_data_size", 0, &phy_data->size);
+		if (ret)
+			goto err;
+		phy_data->addr = devm_kzalloc(dev, sizeof(u8)*phy_data->size, GFP_KERNEL);
+		if (!phy_data->addr)
+			return -ENOMEM;
+		phy_data->data = devm_kzalloc(dev, sizeof(u16)*phy_data->size, GFP_KERNEL);
+		if (!phy_data->data)
+			return -ENOMEM;
+		ret = of_property_read_u8_array(sub_node, "phy_data_addr", phy_data->addr, phy_data->size);
+		if (ret)
+			goto err;
+
+		if (rtk_usb_phy->chip_revision == RTD_CHIP_A00)
+			rev = 0xA;
+		else if (rtk_usb_phy->chip_revision == RTD_CHIP_A01)
+			rev = 0xB;
+		else if (rtk_usb_phy->chip_revision == RTD_CHIP_B00)
+			rev = 0xC;
+		else if (rtk_usb_phy->chip_revision == RTD_CHIP_B01)
+			rev = 0xD;
+		while (rev >= 0xA) {
+			char phy_data_revision[15] = {0};
+
+			snprintf(phy_data_revision, 14, "phy_data_rev%X", rev);
+			ret = of_property_read_u16_array(sub_node, phy_data_revision,
+				    phy_data->data, phy_data->size);
+			if (!ret) {
+				dev_info(dev, "%s load %s parameter\n",
+					    __func__, phy_data_revision);
+				break;
+			}
+			rev--;
+		}
+		if (ret)
+			goto err;
+
+		if (of_property_read_bool(sub_node, "do_toggle"))
+			phy_data->do_toggle = true;
+		else
+			phy_data->do_toggle = false;
+
+		if (of_property_read_bool(sub_node, "use_default_parameter"))
+			phy_data->use_default_parameter = true;
+		else
+			phy_data->use_default_parameter = false;
+	}
+
+	platform_set_drvdata(pdev, rtk_usb_phy);
+
+	//ret = usb_add_phy(&rtk_usb_phy->phy, USB_PHY_TYPE_USB3);
+	//if (ret)
+	//	goto err;
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	create_debug_files(rtk_usb_phy);
+#endif
+
+	dev_info(&pdev->dev, "%s Probe RTK USB 3.0 PHY\n", __FILE__);
+err:
+	return ret;
+}
+
+static int rtk_usb3phy_remove(struct platform_device *pdev)
+{
+	struct rtk_usb_phy_s *rtk_usb_phy = platform_get_drvdata(pdev);
+
+#ifdef CONFIG_DYNAMIC_DEBUG
+	debugfs_remove_recursive(rtk_usb_phy->debug_dir);
+#endif
+
+	//usb_remove_phy(&rtk_usb_phy->phy);
+
+	return 0;
+}
+
+#ifdef CONFIG_OF
+static const struct of_device_id usbphy_rtk_dt_match[] = {
+	{ .compatible = "Realtek,usb3phy", },
+	{ .compatible = "Realtek,rtd119x-usb3phy", },
+	{ .compatible = "Realtek,rtd129x-usb3phy", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, usbphy_rtk_dt_match);
+#endif
+
+static struct platform_driver rtk_usb3phy_driver = {
+	.probe		= rtk_usb3phy_probe,
+	.remove		= rtk_usb3phy_remove,
+	.driver		= {
+		.name	= RTK_USB3PHY_NAME,
+		.owner	= THIS_MODULE,
+		.of_match_table = of_match_ptr(usbphy_rtk_dt_match),
+	},
+};
+
+module_platform_driver(rtk_usb3phy_driver);
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:" RTK_USB3PHY_NAME);
diff --git a/drivers/usb/phy/phy.c b/drivers/usb/phy/phy.c
index 98f75d28..28e95a2 100644
--- a/drivers/usb/phy/phy.c
+++ b/drivers/usb/phy/phy.c
@@ -15,9 +15,25 @@
 #include <linux/module.h>
 #include <linux/slab.h>
 #include <linux/of.h>
+#include <linux/of_device.h>
+#include <linux/debugfs.h>
 
 #include <linux/usb/phy.h>
 
+#ifdef CONFIG_DYNAMIC_DEBUG
+static struct dentry *phy_debug_root = NULL;
+
+struct dentry *create_phy_debug_root(void) {
+	if (!phy_debug_root)
+		phy_debug_root = debugfs_create_dir("phy", usb_debug_root);
+
+	if (!phy_debug_root) {
+		pr_err("%s Error phy_debug_root is NULL", __func__);
+	}
+	return phy_debug_root;
+}
+#endif
+
 static LIST_HEAD(phy_list);
 static LIST_HEAD(phy_bind_list);
 static DEFINE_SPINLOCK(phy_lock);
@@ -199,6 +215,25 @@ struct  usb_phy *devm_usb_get_phy_by_node(struct device *dev,
 	spin_lock_irqsave(&phy_lock, flags);
 
 	phy = __of_usb_find_phy(node);
+
+#ifdef CONFIG_USB_PATCH_ON_RTK
+	// Add to support different phy driver on multi-host controller
+	if (IS_ERR(phy)) {
+		if (node != NULL) {
+			struct platform_device *pdev = NULL;
+			pdev = of_find_device_by_node(node);
+			if (pdev == NULL) {
+				dev_err(dev, "No usb phy platform device\n");
+			} else {
+				phy = platform_get_drvdata(pdev);
+				if (phy == NULL) phy = ERR_PTR(-ENODEV);
+			}
+		} else {
+			dev_err(dev, "No usb phy node\n");
+		}
+	}
+#endif
+
 	if (IS_ERR(phy)) {
 		devres_free(ptr);
 		goto err1;
diff --git a/drivers/video/console/dummycon.c b/drivers/video/console/dummycon.c
index b90ef96..25d5bc3 100644
--- a/drivers/video/console/dummycon.c
+++ b/drivers/video/console/dummycon.c
@@ -41,12 +41,55 @@ static void dummycon_init(struct vc_data *vc, int init)
 	vc_resize(vc, DUMMY_COLUMNS, DUMMY_ROWS);
 }
 
-static int dummycon_dummy(void)
+static void dummycon_deinit(struct vc_data *vc)
+{
+}
+
+static void dummycon_clear(struct vc_data *vc, int a, int b, int c, int d)
+{
+}
+
+static void dummycon_putc(struct vc_data *vc, int a, int b, int c)
+{
+}
+
+static void dummycon_putcs(struct vc_data *vc, const unsigned short *s, int a, int b, int c)
+{
+}
+
+static void dummycon_cursor(struct vc_data *vc, int a)
+{
+}
+
+static int dummycon_scroll(struct vc_data *vc, int a, int b, int c, int d)
+{
+    return 0;
+}
+
+static int dummycon_switch(struct vc_data *vc)
 {
     return 0;
 }
 
-#define DUMMY	(void *)dummycon_dummy
+static int dummycon_blank(struct vc_data *vc, int a, int b)
+{
+    return 0;
+}
+
+static int dummycon_font_set(struct vc_data *vc, struct console_font *f, unsigned u)
+{
+    return 0;
+}
+
+static int dummycon_font_default(struct vc_data *vc, struct console_font *f, char *c)
+{
+    return 0;
+}
+
+static int dummycon_font_copy(struct vc_data *vc, int a)
+{
+    return 0;
+}
 
 /*
  *  The console `switch' structure for the dummy console
@@ -58,16 +101,16 @@ static int dummycon_dummy(void)
     .owner =		THIS_MODULE,
     .con_startup =	dummycon_startup,
     .con_init =		dummycon_init,
-    .con_deinit =	DUMMY,
-    .con_clear =	DUMMY,
-    .con_putc =		DUMMY,
-    .con_putcs =	DUMMY,
-    .con_cursor =	DUMMY,
-    .con_scroll =	DUMMY,
-    .con_switch =	DUMMY,
-    .con_blank =	DUMMY,
-    .con_font_set =	DUMMY,
-    .con_font_default =	DUMMY,
-    .con_font_copy =	DUMMY,
+    .con_deinit =	dummycon_deinit,
+    .con_clear =	dummycon_clear,
+    .con_putc =		dummycon_putc,
+    .con_putcs =	dummycon_putcs,
+    .con_cursor =	dummycon_cursor,
+    .con_scroll =	dummycon_scroll,
+    .con_switch =	dummycon_switch,
+    .con_blank =	dummycon_blank,
+    .con_font_set =	dummycon_font_set,
+    .con_font_default =	dummycon_font_default,
+    .con_font_copy =	dummycon_font_copy,
 };
 EXPORT_SYMBOL_GPL(dummy_con);
diff --git a/drivers/video/fbdev/Kconfig b/drivers/video/fbdev/Kconfig
index 5d3b0db..14c2379 100644
--- a/drivers/video/fbdev/Kconfig
+++ b/drivers/video/fbdev/Kconfig
@@ -2218,6 +2218,25 @@ config FB_DA8XX
 	  found on DA8xx/OMAP-L1xx/AM335x SoCs.
 	  If unsure, say N.
 
+config FB_RTK
+	tristate "RTK Framebuffer support"
+	default n
+	select SYNC
+	select SW_SYNC
+	select SW_SYNC_USER
+	help
+	  Realtek Frame Buffer driver
+
+config VFB_RTK
+        tristate "RTK Virtual Framebuffer support"
+	depends on FB_RTK
+        default n
+        select SYNC
+        select SW_SYNC
+        select SW_SYNC_USER
+        help
+          Realtek Virtual Frame Buffer driver
+
 config FB_VIRTUAL
 	tristate "Virtual Frame Buffer support (ONLY FOR TESTING!)"
 	depends on FB
diff --git a/drivers/video/fbdev/Makefile b/drivers/video/fbdev/Makefile
index ee8c814..56f5a60 100644
--- a/drivers/video/fbdev/Makefile
+++ b/drivers/video/fbdev/Makefile
@@ -146,6 +146,6 @@ obj-$(CONFIG_FB_DA8XX)		  += da8xx-fb.o
 obj-$(CONFIG_FB_MXS)		  += mxsfb.o
 obj-$(CONFIG_FB_SSD1307)	  += ssd1307fb.o
 obj-$(CONFIG_FB_SIMPLE)           += simplefb.o
-
+obj-$(CONFIG_FB_RTK)			+= rtk/
 # the test framebuffer is last
 obj-$(CONFIG_FB_VIRTUAL)          += vfb.o
diff --git a/drivers/video/fbdev/goldfishfb.c b/drivers/video/fbdev/goldfishfb.c
index 7f6c9e6..1e56b50 100644
--- a/drivers/video/fbdev/goldfishfb.c
+++ b/drivers/video/fbdev/goldfishfb.c
@@ -26,6 +26,7 @@
 #include <linux/interrupt.h>
 #include <linux/ioport.h>
 #include <linux/platform_device.h>
+#include <linux/acpi.h>
 
 enum {
 	FB_GET_WIDTH        = 0x00,
@@ -234,7 +235,7 @@ static int goldfish_fb_probe(struct platform_device *pdev)
 	fb->fb.var.activate	= FB_ACTIVATE_NOW;
 	fb->fb.var.height	= readl(fb->reg_base + FB_GET_PHYS_HEIGHT);
 	fb->fb.var.width	= readl(fb->reg_base + FB_GET_PHYS_WIDTH);
-	fb->fb.var.pixclock	= 10000;
+	fb->fb.var.pixclock	= 0;
 
 	fb->fb.var.red.offset = 11;
 	fb->fb.var.red.length = 5;
@@ -304,12 +305,25 @@ static int goldfish_fb_remove(struct platform_device *pdev)
 	return 0;
 }
 
+static const struct of_device_id goldfish_fb_of_match[] = {
+	{ .compatible = "google,goldfish-fb", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, goldfish_fb_of_match);
+
+static const struct acpi_device_id goldfish_fb_acpi_match[] = {
+	{ "GFSH0004", 0 },
+	{ },
+};
+MODULE_DEVICE_TABLE(acpi, goldfish_fb_acpi_match);
 
 static struct platform_driver goldfish_fb_driver = {
 	.probe		= goldfish_fb_probe,
 	.remove		= goldfish_fb_remove,
 	.driver = {
-		.name = "goldfish_fb"
+		.name = "goldfish_fb",
+		.of_match_table = goldfish_fb_of_match,
+		.acpi_match_table = ACPI_PTR(goldfish_fb_acpi_match),
 	}
 };
 
diff --git a/drivers/video/fbdev/rtk/Makefile b/drivers/video/fbdev/rtk/Makefile
new file mode 100644
index 00000000..f35aa23
--- /dev/null
+++ b/drivers/video/fbdev/rtk/Makefile
@@ -0,0 +1,11 @@
+ifeq ($(CONFIG_FB_RTK_FPGA),y)
+obj-$(CONFIG_FB_RTK) += dc2fpga/
+else
+obj-$(CONFIG_FB_RTK) += dc2vo/
+endif
+
+obj-$(CONFIG_FB_RTK) += rtk_fb.o
+obj-$(CONFIG_VFB_RTK) += rtk_vfb.o
+obj-$(CONFIG_FB_RTK) += rtk_fb_RPC.o
+obj-$(CONFIG_FB_RTK) += rtk_fb_freelogo.o
+
diff --git a/drivers/video/fbdev/rtk/dc2fpga/Makefile b/drivers/video/fbdev/rtk/dc2fpga/Makefile
new file mode 100644
index 00000000..fa50626
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2fpga/Makefile
@@ -0,0 +1 @@
+obj-$(CONFIG_FB_RTK) += dc2fpga.o
diff --git a/drivers/video/fbdev/rtk/dc2fpga/dc2fpga.c b/drivers/video/fbdev/rtk/dc2fpga/dc2fpga.c
new file mode 100644
index 00000000..ec68037
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2fpga/dc2fpga.c
@@ -0,0 +1,2389 @@
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/interrupt.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/uaccess.h>
+#include <linux/cdev.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/export.h>
+#include <linux/miscdevice.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/kthread.h>
+#include "vo_reg.h"
+#include "hdmi_reg.h"
+#include "dc2fpga.h"
+
+#define VPU_SUPPORT_ISR
+
+
+#ifdef VPU_SUPPORT_ISR
+#define HDMI_IRQ_NUM (63)
+#endif
+
+#ifdef VPU_SUPPORT_ISR
+static int s_hdmi_irq = HDMI_IRQ_NUM;
+#endif
+
+#define ENABLE_DEBUG_MSG
+#ifdef ENABLE_DEBUG_MSG
+#define DPRINTK(args...)		printk(KERN_INFO args);
+#else
+#define DPRINTK(args...)
+#endif
+
+
+
+unsigned long rbus_virt_address = 0;
+unsigned long hdmi_virt_address = 0;
+unsigned long vo_virt_address = 0;
+int fd_mem = -1;
+
+static inline void WRITE_REG_INT32U(unsigned long Addr, unsigned int Value) {
+    volatile unsigned int* ptr = NULL;
+    if (Addr > 0x98000000 && Addr < (0x98000000 + 0x1000))
+        ptr = (volatile unsigned int*) (((unsigned long)rbus_virt_address) + (Addr - 0x98000000));
+    else if (Addr>=HDMI_INTEN)
+        ptr = (volatile unsigned int*) (((unsigned long)hdmi_virt_address) + (Addr - HDMI_INTEN));
+    else
+        ptr = (volatile unsigned int*) (((unsigned long)vo_virt_address) + (Addr - VO_MODE));
+
+    writel(Value, ptr);
+}
+
+static inline unsigned int READ_REG_INT32U(unsigned long Addr) {
+    volatile unsigned int* ptr = NULL;
+    if (Addr > 0x98000000 && Addr < (0x98000000 + 0x1000))
+        ptr = (volatile unsigned int*) (((unsigned long)rbus_virt_address) + (Addr - 0x98000000));
+    else if (Addr>=HDMI_INTEN)
+        ptr = (volatile unsigned int*) (((unsigned long)hdmi_virt_address) + (Addr - HDMI_INTEN));
+    else
+        ptr = (volatile unsigned int*) (((unsigned long)vo_virt_address) + (Addr - VO_MODE));
+    return readl(ptr);
+}
+
+#define WIN_PHYS_ADDRESS             (0x10000000 - 0x100000) //1MB
+
+
+
+typedef struct vodrv_buffer_t {
+    unsigned int size;
+    unsigned long phys_addr;
+    unsigned long base;							/* kernel logical address in use kernel */
+    unsigned long virt_addr;				/* virtual user space address */
+} vodrv_buffer_t;
+
+static struct miscdevice s_vo_dev;
+static vodrv_buffer_t s_vo_register = {0};
+static vodrv_buffer_t s_hdmi_register = {0};
+static vodrv_buffer_t s_rbus_register = {0};
+
+#ifndef VM_RESERVED	/*for kernel up to 3.7.0 version*/
+# define  VM_RESERVED   (VM_DONTEXPAND | VM_DONTDUMP)
+#endif
+
+
+static struct task_struct *brook_task;
+static int brook_data;
+static int kbrook(void *arg);
+
+void HDMI_ISR(void) {
+    if(HDMI_INTSTV_get_vsyncupdated(READ_REG_INT32U(HDMI_INTSTV)))
+    {
+
+#if CW_DEBUG
+        unsigned int voinst =         READ_REG_INT32U(VO_INTST);
+        printf("222 VO_INTST:%x \n",voinst);
+#endif
+        //printk(KERN_ALERT "[%s %d] HDMI_INTSTV_get_vsyncupdated", __FUNCTION__, __LINE__);
+
+        //0xb800d278
+        WRITE_REG_INT32U(HDMI_INTSTV,
+                HDMI_INTSTV_vendupdated(0)|
+                HDMI_INTSTV_vsyncupdated(0));
+        //0x98005e84
+        WRITE_REG_INT32U(VO_INTST,
+                VO_INTST_afbc_parser_fail(0)|
+                VO_INTST_afbc_decode_fail(0)|
+                VO_INTST_h_under(0)|
+                VO_INTST_i_under(0)|
+                VO_INTST_p_under(0)|
+                VO_INTST_sub2(0)|
+                VO_INTST_sub1(0)|
+                VO_INTST_wb2fin(0)|
+                VO_INTST_wb1fin(0)|
+                VO_INTST_m3fin(0)|
+                VO_INTST_m2fin(0)|
+                VO_INTST_m1fin(1)|
+                VO_INTST_write_data(0));
+        /*
+        //0x98005e84  cwww
+        WRITE_REG_INT32U(VO_INTEN,
+
+        VO_INTEN_h_under(1)|
+        VO_INTEN_i_under(1)|
+        VO_INTEN_sub2(1)|
+        VO_INTEN_sub1(1)|
+        VO_INTEN_wb2fin(1)|
+        VO_INTEN_wb1fin(1)|
+        VO_INTEN_m3fin(1)|
+        VO_INTEN_m1fin(1)|
+        VO_INTEN_write_data(1));
+
+*/
+        WRITE_REG_INT32U(VO_INTEN,VO_INTEN_m1fin(1) | VO_INTEN_write_data(1));
+
+        //0x98005020
+        WRITE_REG_INT32U(VO_FC,
+                VO_FC_wb2go(0)|
+                VO_FC_wb1go(0)|
+                VO_FC_mddgo(0)|
+                VO_FC_m2go(0)|
+                VO_FC_m1go(1)|
+                VO_FC_write_data(1));
+
+
+
+
+        if(VO_INTST_get_h_under(READ_REG_INT32U(VO_INTST)))
+        {
+#if CW_DEBUG
+            printf("#@@ VO_INTST:get h_under \n");
+#endif
+            //0x98005e84
+            WRITE_REG_INT32U(VO_INTST,
+                    VO_INTST_afbc_parser_fail(0)|
+                    VO_INTST_afbc_decode_fail(0)|
+                    VO_INTST_h_under(1)|
+                    VO_INTST_i_under(0)|
+                    VO_INTST_p_under(0)|
+                    VO_INTST_sub2(0)|
+                    VO_INTST_sub1(0)|
+                    VO_INTST_wb2fin(0)|
+                    VO_INTST_wb1fin(0)|
+                    VO_INTST_m3fin(0)|
+                    VO_INTST_m2fin(0)|
+                    VO_INTST_m1fin(0)|
+                    VO_INTST_write_data(0));
+        }
+    }
+}
+static int kbrook(void *arg)
+{
+    unsigned int timeout;
+    int *d = (int *) arg;
+
+    for(;;) {
+        if (kthread_should_stop()) break;
+        //printk("%s(): %d\n", __FUNCTION__, (*d)++);
+        static int temp = 5000;
+        do {
+            set_current_state(TASK_INTERRUPTIBLE);
+            timeout = schedule_timeout(HZ/60);
+            while(temp > 0)
+            {
+                temp--;
+                //msleep(1000/120);
+                msleep(1);
+                //usleep((1000000/120)); //usleep (1/120)s
+
+#if 1
+                HDMI_ISR();
+#else
+                if(HDMI_INTSTV_get_vsyncupdated(READ_REG_INT32U(HDMI_INTSTV)))
+                {
+
+#if CW_DEBUG
+                    unsigned int voinst =         READ_REG_INT32U(VO_INTST);
+                    printf("222 VO_INTST:%x \n",voinst);
+#endif
+                    //printk(KERN_ALERT "[%s %d] HDMI_INTSTV_get_vsyncupdated", __FUNCTION__, __LINE__);
+                    msleep(1);
+
+                    //0xb800d278
+                    WRITE_REG_INT32U(HDMI_INTSTV,
+                            HDMI_INTSTV_vendupdated(0)|
+                            HDMI_INTSTV_vsyncupdated(0));
+                    //0x98005e84
+                    WRITE_REG_INT32U(VO_INTST,
+                            VO_INTST_afbc_parser_fail(0)|
+                            VO_INTST_afbc_decode_fail(0)|
+                            VO_INTST_h_under(0)|
+                            VO_INTST_i_under(0)|
+                            VO_INTST_p_under(0)|
+                            VO_INTST_sub2(0)|
+                            VO_INTST_sub1(0)|
+                            VO_INTST_wb2fin(0)|
+                            VO_INTST_wb1fin(0)|
+                            VO_INTST_m3fin(0)|
+                            VO_INTST_m2fin(0)|
+                            VO_INTST_m1fin(1)|
+                            VO_INTST_write_data(0));
+                    /*
+                    //0x98005e84  cwww
+                    WRITE_REG_INT32U(VO_INTEN,
+
+                    VO_INTEN_h_under(1)|
+                    VO_INTEN_i_under(1)|
+                    VO_INTEN_sub2(1)|
+                    VO_INTEN_sub1(1)|
+                    VO_INTEN_wb2fin(1)|
+                    VO_INTEN_wb1fin(1)|
+                    VO_INTEN_m3fin(1)|
+                    VO_INTEN_m1fin(1)|
+                    VO_INTEN_write_data(1));
+
+*/
+                    WRITE_REG_INT32U(VO_INTEN,VO_INTEN_m1fin(1) | VO_INTEN_write_data(1));
+
+                    //0x98005020
+                    WRITE_REG_INT32U(VO_FC,
+                            VO_FC_wb2go(0)|
+                            VO_FC_wb1go(0)|
+                            VO_FC_mddgo(0)|
+                            VO_FC_m2go(0)|
+                            VO_FC_m1go(1)|
+                            VO_FC_write_data(1));
+
+
+
+
+                    if(VO_INTST_get_h_under(READ_REG_INT32U(VO_INTST)))
+                    {
+#if CW_DEBUG
+                        printf("#@@ VO_INTST:get h_under \n");
+#endif
+                        //0x98005e84
+                        WRITE_REG_INT32U(VO_INTST,
+                                VO_INTST_afbc_parser_fail(0)|
+                                VO_INTST_afbc_decode_fail(0)|
+                                VO_INTST_h_under(1)|
+                                VO_INTST_i_under(0)|
+                                VO_INTST_p_under(0)|
+                                VO_INTST_sub2(0)|
+                                VO_INTST_sub1(0)|
+                                VO_INTST_wb2fin(0)|
+                                VO_INTST_wb1fin(0)|
+                                VO_INTST_m3fin(0)|
+                                VO_INTST_m2fin(0)|
+                                VO_INTST_m1fin(0)|
+                                VO_INTST_write_data(0));
+                    }
+                }
+#endif
+            }
+        } while(timeout);
+    }
+    printk("break\n");
+
+    return 0;
+}
+
+
+#if 1
+
+enum VO_OSD_COLOR_FORMAT {
+	VO_OSD_COLOR_FORMAT_2BIT = 0,
+	VO_OSD_COLOR_FORMAT_4BIT = 1,
+	VO_OSD_COLOR_FORMAT_8BIT = 2,
+	VO_OSD_COLOR_FORMAT_RGB332 = 3,
+	VO_OSD_COLOR_FORMAT_RGB565 = 4,
+	VO_OSD_COLOR_FORMAT_ARGB1555 = 5,
+	VO_OSD_COLOR_FORMAT_ARGB4444 = 6,
+	VO_OSD_COLOR_FORMAT_ARGB8888 = 7,
+	VO_OSD_COLOR_FORMAT_Reserved0 = 8,
+	VO_OSD_COLOR_FORMAT_Reserved1 = 9,
+	VO_OSD_COLOR_FORMAT_Reserved2 = 10,
+	VO_OSD_COLOR_FORMAT_YCBCRA4444 = 11,
+	VO_OSD_COLOR_FORMAT_YCBCRA8888 = 12,
+	VO_OSD_COLOR_FORMAT_RGBA5551 = 13,
+	VO_OSD_COLOR_FORMAT_RGBA4444 = 14,
+	VO_OSD_COLOR_FORMAT_RGBA8888 = 15,
+	VO_OSD_COLOR_FORMAT_420 = 16,
+	VO_OSD_COLOR_FORMAT_422 = 17,
+	VO_OSD_COLOR_FORMAT_RGB323 = 18,
+	VO_OSD_COLOR_FORMAT_RGB233 = 19,
+	VO_OSD_COLOR_FORMAT_RGB556 = 20,
+	VO_OSD_COLOR_FORMAT_RGB655 = 21,
+	VO_OSD_COLOR_FORMAT_RGB888 = 22,
+	VO_OSD_COLOR_FORMAT_RGB565_LITTLE = 36,
+	VO_OSD_COLOR_FORMAT_ARGB1555_LITTLE = 37,
+	VO_OSD_COLOR_FORMAT_ARGB4444_LITTLE = 38,
+	VO_OSD_COLOR_FORMAT_ARGB8888_LITTLE = 39,
+	VO_OSD_COLOR_FORMAT_YCBCRA4444_LITTLE = 43,
+	VO_OSD_COLOR_FORMAT_YCBCRA8888_LITTLE = 44,
+	VO_OSD_COLOR_FORMAT_RGBA5551_LITTLE = 45,
+	VO_OSD_COLOR_FORMAT_RGBA4444_LITTLE = 46,
+	VO_OSD_COLOR_FORMAT_RGBA8888_LITTLE = 47,
+	VO_OSD_COLOR_FORMAT_RGB556_LITTLE = 52,
+	VO_OSD_COLOR_FORMAT_RGB655_LITTLE = 53,
+	VO_OSD_COLOR_FORMAT_RGB888_LITTLE = 54,
+};
+typedef enum VO_OSD_COLOR_FORMAT VO_OSD_COLOR_FORMAT;
+
+enum VO_GRAPHIC_PLANE {
+	VO_GRAPHIC_OSD = 0,
+	VO_GRAPHIC_SUB1 = 1,
+	VO_GRAPHIC_SUB2 = 2,
+	VO_GRAPHIC_OSD1 = 0,
+	VO_GRAPHIC_OSD2 = 2,
+};
+typedef enum VO_GRAPHIC_PLANE VO_GRAPHIC_PLANE;
+
+struct VO_RECTANGLE {
+	short x;
+	short y;
+	unsigned short width;
+	unsigned short height;
+};
+typedef struct VO_RECTANGLE VO_RECTANGLE;
+
+enum VO_OSD_RGB_ORDER {
+	VO_OSD_COLOR_RGB = 0,
+	VO_OSD_COLOR_BGR = 1,
+	VO_OSD_COLOR_GRB = 2,
+	VO_OSD_COLOR_GBR = 3,
+	VO_OSD_COLOR_RBG = 4,
+	VO_OSD_COLOR_BRG = 5,
+};
+typedef enum VO_OSD_RGB_ORDER VO_OSD_RGB_ORDER;
+
+
+struct VIDEO_RPC_VOUT_CREATE_GRAPHIC_WIN {
+	enum VO_GRAPHIC_PLANE plane;
+	struct VO_RECTANGLE winPos;
+	enum VO_OSD_COLOR_FORMAT colorFmt;
+	enum VO_OSD_RGB_ORDER rgbOrder;
+	int colorKey;
+	unsigned char alpha;
+	unsigned char reserved;
+};
+typedef struct VIDEO_RPC_VOUT_CREATE_GRAPHIC_WIN VIDEO_RPC_VOUT_CREATE_GRAPHIC_WIN;
+
+
+struct VIDEO_RPC_VOUT_CONFIG_GRAPHIC_CANVAS {
+	enum VO_GRAPHIC_PLANE plane;
+	struct VO_RECTANGLE srcWin;
+	struct VO_RECTANGLE dispWin;
+	unsigned char go;
+};
+int already_init = 0;
+/*
+typedef struct
+{
+  unsigned int last:1 ;
+  unsigned int reserved:31 ;
+
+} VO_OSD_WIN_NEXT_ADDR ;
+
+typedef struct
+{
+  unsigned int y:16 ;
+  unsigned int x:16 ;
+
+} VO_OSD_WIN_XY ;
+
+
+typedef struct
+{
+  unsigned int height:16 ;
+  unsigned int width:16 ;
+
+} VO_OSD_WIN_WH ;
+
+typedef struct
+{
+  unsigned int extendMode:1 ;
+  unsigned int rgbOrder:3 ;
+  unsigned int alphaType:1 ;
+  unsigned int alphaEn:1 ;
+  unsigned int storageMode:1 ;
+  unsigned int objType:1 ;
+  unsigned int alpha:8 ;
+  unsigned int reserved1:6 ;
+  unsigned int littleEndian:1 ;
+  unsigned int keepPreCLUT:1 ;
+  unsigned int reserved2:3 ;
+  unsigned int type:5 ;
+
+} VO_OSD_WIN_ATTR ;
+
+typedef struct
+{
+  unsigned int reserved:7 ;
+  unsigned int keyEn:1 ;
+  unsigned int key:24 ;
+
+}VO_OSD_WIN_KEY ;
+
+typedef struct
+{
+  unsigned int objYoffset:16 ;
+  unsigned int objXoffset:16 ;
+
+} VO_OSD_WIN_INIT ;
+
+typedef struct
+{
+  unsigned int reserved:6 ;
+  unsigned int id:8 ;
+  unsigned int previd:8 ;
+  unsigned int nextid:8 ;
+  unsigned int drawn:1 ;
+  unsigned int occupied:1 ;
+
+} VO_OSD_WIN_CTRL ;
+*/
+typedef struct
+{
+  unsigned int reserved:31 ;
+
+  unsigned int last:1 ;
+
+} VO_OSD_WIN_NEXT_ADDR ;
+
+typedef struct
+{
+  unsigned int x:16 ;
+
+  unsigned int y:16 ;
+
+} VO_OSD_WIN_XY ;
+
+
+typedef struct
+{
+  unsigned int width:16 ;
+
+  unsigned int height:16 ;
+
+} VO_OSD_WIN_WH ;
+
+typedef struct
+{
+
+  unsigned int type:5 ;
+  //unsigned int reserved2:3 ;
+  unsigned int afbc_mode :1;
+  unsigned int afbc_yuv_trans:1;
+  unsigned int afbc_block_split:1;
+  unsigned int keepPreCLUT:1 ;
+  unsigned int littleEndian:1 ;
+ unsigned int reserved1:6 ;
+  
+ unsigned int alpha:8 ;
+
+  unsigned int objType:1 ;
+  unsigned int storageMode:1 ;
+  unsigned int alphaEn:1 ;
+   unsigned int alphaType:1 ;
+  unsigned int rgbOrder:3 ;
+  
+  unsigned int extendMode:1 ;
+
+
+
+
+ 
+
+
+
+
+} VO_OSD_WIN_ATTR ;
+
+typedef struct
+{
+
+unsigned int key:24 ;
+  unsigned int keyEn:1 ;
+
+  unsigned int reserved:7 ;
+  
+
+  
+}VO_OSD_WIN_KEY ;
+
+typedef struct
+{  unsigned int objXoffset:16 ;
+  unsigned int objYoffset:16 ;
+
+
+} VO_OSD_WIN_INIT ;
+
+typedef struct
+{
+  unsigned int occupied:1 ;
+  unsigned int drawn:1 ;
+  unsigned int nextid:8 ;
+  unsigned int previd:8 ;
+  unsigned int id:8 ;
+
+  unsigned int reserved:6 ;
+
+
+
+
+
+} VO_OSD_WIN_CTRL ;
+
+
+
+
+typedef struct
+{
+  VO_OSD_WIN_NEXT_ADDR reserve ;
+  // Window Region 
+  VO_OSD_WIN_XY   winXY ;
+  VO_OSD_WIN_WH   winWH ;
+  // Window Attribute 
+  VO_OSD_WIN_ATTR attr ;
+  unsigned int    CLUT_addr ;
+  VO_OSD_WIN_KEY  colorKey ;
+  unsigned int    top_addr ;    // top or progressive OSD start address (sequential) or index (block mode) 
+  unsigned int    bot_addr ;    // bottom OSD start address (sequential) or index (block mode) 
+  unsigned int    pitch ;
+  VO_OSD_WIN_INIT objOffset ;
+  unsigned int    nxtAddr ;
+  unsigned int afbc_head_addr;
+
+} VO_OSD_WIN ;
+#if 0
+typedef struct
+{
+  VO_OSD_WIN_NEXT_ADDR nxtAddr ;
+  /* Window Region */
+  VO_OSD_WIN_XY   winXY ;
+  VO_OSD_WIN_WH   winWH ;
+  /* Window Attribute */
+  VO_OSD_WIN_ATTR attr ;
+  unsigned int    CLUT_addr ;
+  VO_OSD_WIN_KEY  colorKey ;
+  unsigned int    top_addr ;    /* top or progressive OSD start address (sequential) or index (block mode) */
+  unsigned int    bot_addr ;    /* bottom OSD start address (sequential) or index (block mode) */
+  unsigned int    pitch ;
+  VO_OSD_WIN_INIT objOffset ;
+
+  // below size should be multiple of 16 s.t every element of VO_OSD_WIN array can be located at 16 byte-aligned address //
+  VO_OSD_WIN_CTRL ctrl __attribute__((aligned(16))) ;
+  unsigned int    srcImg[2] ;
+  unsigned short  srcPitch[2] ;
+  VO_OSD_WIN_XY   winXY_2D ;
+  VO_OSD_WIN_WH   winWH_2D ;
+  int dummy[4] __attribute__((aligned(16)));
+
+} VO_OSD_WIN ;
+#endif
+typedef struct
+{
+  short x ;        /* upper-left corner x coordinate */
+  short y ;        /* upper-left corner y coordinate */
+  short width ;    /* window width */
+  short height ;   /* window height */
+
+} VP_WINDOW ;
+
+
+enum VO_GRAPHIC_STORAGE_MODE {
+	VO_GRAPHIC_BLOCK = 0,
+	VO_GRAPHIC_SEQUENTIAL = 1,
+};
+typedef enum VO_GRAPHIC_STORAGE_MODE VO_GRAPHIC_STORAGE_MODE;
+
+struct VIDEO_RPC_VOUT_DRAW_GRAPHIC_WIN {
+	enum VO_GRAPHIC_PLANE plane;
+	u_short winID;
+	enum VO_GRAPHIC_STORAGE_MODE storageMode;
+	u_char paletteIndex;
+	u_char compressed;
+	u_char interlace_Frame;
+	u_char bottomField;
+	u_short startX[4];
+	u_short startY[4];
+	u_short imgPitch[4];
+	long pImage[4];
+	u_char reserved;
+	u_char go;
+};
+typedef struct VIDEO_RPC_VOUT_DRAW_GRAPHIC_WIN VIDEO_RPC_VOUT_DRAW_GRAPHIC_WIN;
+
+#if 0
+void SUB1_draw(void)
+{
+    int pImage, x, y, w, h  ;
+
+    w =720 ;
+    h = 576;
+    x = y = 0 ;
+	pImage = 0x10000000 ;
+
+	unsigned long tmp = (unsigned long)mmap(0, 0x100000, PROT_READ | PROT_WRITE, MAP_SHARED, fd_mem, WIN_PHYS_ADDRESS);;
+
+	VO_OSD_WIN *win = (VO_OSD_WIN *)tmp;
+	win->winXY.x        = x;
+    win->winXY.y        = y ;
+    win->winWH.width    = w ;
+    win->winWH.height   = h ;
+
+    win->attr.rgbOrder  = 0 ;//000   
+    win->attr.alphaType= 0;
+	win->attr.alphaEn   = 1 ;
+    win->attr.storageMode = 1;
+    win->attr.alpha= 20;
+	win->attr.littleEndian = 1 ;
+	win->attr.keepPreCLUT = 0;
+	win->attr.afbc_block_split =0;
+	win->attr.afbc_yuv_trans=0;
+	win->attr.afbc_mode = 0;
+	win->attr.type      =  7; //00111
+    win->CLUT_addr = 0;
+    win->colorKey.keyEn = 0 ;
+    win->colorKey.key   = 0xff ;
+
+    win->top_addr     = pImage ;
+    win->bot_addr     = pImage ;
+
+    win->pitch = w ;
+    win->objOffset.objXoffset = x;
+    win->objOffset.objYoffset = y ;
+          
+    win->nxtAddr = 0;
+    win->afbc_head_addr = 0;
+
+
+
+    //0xb8005000
+    WRITE_REG_INT32U(VO_MODE,
+                     VO_MODE_ch2(0)|
+                     VO_MODE_ch1(1)|
+                     VO_MODE_write_data(1));
+                     
+                    
+  
+     //0x98005018
+    WRITE_REG_INT32U(VO_M1_3D,
+                     VO_M1_3D_top_and_bottom(1)|
+                     VO_M1_3D_side_by_side(1)|
+                     VO_M1_3D_right(1)|
+                     VO_M1_3D_write_data(0));
+
+    WRITE_REG_INT32U(VO_MIX12,
+                     VO_MIX12_sub1(1));
+
+        //0xb8005604
+    WRITE_REG_INT32U(VO_M1_SIZE,
+                     VO_M1_SIZE_w(720)|
+                     VO_M1_SIZE_h(576));
+
+
+
+
+            //0xb8005004
+     WRITE_REG_INT32U(VO_OUT,
+                             VO_OUT_write_en3(1)|VO_OUT_h(1)
+                  );
+	// WRITE_REG_INT32U(VO_OSD1_WI,VO_OSD1_WI_endian( 1)|VO_OSD1_WI_swap_8byte(1));
+     unsigned long winAddr =(unsigned long) &win;
+     WRITE_REG_INT32U(VO_SUB1_WI_1,WIN_PHYS_ADDRESS);
+
+     WRITE_REG_INT32U(VO_SUB1,VO_SUB1_osd(1)|VO_SUB1_write_data(1));
+
+     WRITE_REG_INT32U(VO_SUB1_SIZE,VO_SUB1_SIZE_w(w)|VO_SUB1_SIZE_h(h));
+
+
+
+}
+#endif
+//void OSD_draw(void)
+int OSD_draw(unsigned int w, unsigned int h, unsigned long pImage)
+{
+    //printk(KERN_ALERT "[%s %d] w %d h %d pImage 0x%x", __FUNCTION__, __LINE__, w, h, pImage);
+    //int pImage, x, y, w, h  ;
+
+    //w =720 ;
+    //h = 576;
+    int x, y;
+    x = y = 0;
+	//pImage = 0x10000000 ;
+
+//	unsigned long tmp = (unsigned long)mmap(0, 0x100000, PROT_READ | PROT_WRITE, MAP_SHARED, fd_mem, WIN_PHYS_ADDRESS);
+    //printk(KERN_ALERT "this device %p\n", s_vo_dev.this_device);
+	unsigned long win_phy, win_vir;
+	win_vir = (unsigned long)dma_alloc_coherent(s_vo_dev.this_device, PAGE_ALIGN(sizeof(VO_OSD_WIN)), (dma_addr_t *) (&win_phy), GFP_DMA | GFP_KERNEL);
+    if ((void *)(win_vir) == NULL)	{
+        printk(KERN_ERR "[VPUDRV] Physical memory allocation error size=%d\n", sizeof(VO_OSD_WIN));
+        return -1;
+    }
+    //printk(KERN_ALERT "[%s %d] win_phy:%lx", __FUNCTION__, __LINE__, win_phy);
+
+
+	VO_OSD_WIN *win = (VO_OSD_WIN *)win_vir;
+	win->reserve.last = 1;
+	win->reserve.reserved= 0;
+	
+	win->winXY.x        = x;
+    win->winXY.y        = y ;
+    win->winWH.width    = w ;
+    win->winWH.height   = h ;
+
+    win->attr.rgbOrder  = 0 ;//000   
+    win->attr.alphaType= 0;
+	win->attr.alphaEn   = 1 ;
+    win->attr.storageMode = 1;
+    win->attr.alpha= 20;
+	win->attr.littleEndian = 1 ;
+	win->attr.keepPreCLUT = 0;
+	win->attr.afbc_block_split =0;
+	win->attr.afbc_yuv_trans=0;
+	win->attr.afbc_mode = 0;
+	win->attr.type      =  7; //00111
+    win->CLUT_addr = 0;
+    win->colorKey.keyEn = 0 ;
+    win->colorKey.key   = 0xff ;
+
+    win->top_addr     = pImage ;
+    win->bot_addr     = pImage ;
+
+    win->pitch = w * 4;
+    win->objOffset.objXoffset = x;
+    win->objOffset.objYoffset = y ;
+          
+    win->nxtAddr = 0;
+    win->afbc_head_addr = 0;
+
+
+
+    //0xb8005000
+    WRITE_REG_INT32U(VO_MODE,
+                     VO_MODE_ch2(0)|
+                     VO_MODE_ch1(1)|
+                     VO_MODE_write_data(1));
+                     
+                    
+  
+     //0x98005018
+    WRITE_REG_INT32U(VO_M1_3D,
+                     VO_M1_3D_top_and_bottom(1)|
+                     VO_M1_3D_side_by_side(1)|
+                     VO_M1_3D_right(1)|
+                     VO_M1_3D_write_data(0));
+
+
+   WRITE_REG_INT32U(VO_MIX12,
+                     VO_MIX12_vbi2(0)|
+                     VO_MIX12_vbi1(0)|
+                     VO_MIX12_csr(0)|
+                     VO_MIX12_osd1(1)|
+                    VO_MIX12_sub2(0)|
+                     VO_MIX12_sub1(0)|
+                     VO_MIX12_v2(0)|
+                     VO_MIX12_v1(0)|
+                     VO_MIX12_bg2(0)|
+                     VO_MIX12_bg1(0));
+
+        //0xb8005604
+    WRITE_REG_INT32U(VO_M1_SIZE,
+                     VO_M1_SIZE_w(1280)|
+                     VO_M1_SIZE_h(720));
+
+
+
+
+            //0xb8005004
+     WRITE_REG_INT32U(VO_OUT,
+                             VO_OUT_write_en3(1)|VO_OUT_h(1)
+                  );
+	// WRITE_REG_INT32U(VO_OSD1_WI,VO_OSD1_WI_endian( 1)|VO_OSD1_WI_swap_8byte(1));
+  //   unsigned long winAddr =(unsigned long) &win;
+  //   WRITE_REG_INT32U(VO_OSD1_WI_1,WIN_PHYS_ADDRESS);
+  //   WRITE_REG_INT32U(VO_OSD1_WI_3D,WIN_PHYS_ADDRESS);
+     WRITE_REG_INT32U(VO_OSD1_WI_1,win_phy);
+     WRITE_REG_INT32U(VO_OSD1_WI_3D,win_phy);
+
+
+
+     WRITE_REG_INT32U(VO_OSD1,VO_OSD1_osd(1)|VO_OSD1_write_data(1)/*|VO_OSD1_hs(1)|VO_OSD1_vs(1)*/);
+
+     WRITE_REG_INT32U(VO_OSD1_SIZE,VO_OSD1_SIZE_w(1280/*w*/)|VO_OSD1_SIZE_h(720/*h*/));
+
+     HDMI_ISR();
+
+#if 0 
+     static int temp = 1000;
+while(temp > 0)
+{
+    temp--;
+    msleep(1000/120);
+//usleep((1000000/120)); //usleep (1/120)s
+	
+     if(HDMI_INTSTV_get_vsyncupdated(READ_REG_INT32U(HDMI_INTSTV)))
+     {
+
+#if CW_DEBUG
+        unsigned int voinst =         READ_REG_INT32U(VO_INTST);
+		printf("222 VO_INTST:%x \n",voinst);
+#endif
+    //printk(KERN_ALERT "[%s %d] HDMI_INTSTV_get_vsyncupdated", __FUNCTION__, __LINE__);
+
+
+	//0xb800d278
+                WRITE_REG_INT32U(HDMI_INTSTV,
+                                 HDMI_INTSTV_vendupdated(0)|
+                                 HDMI_INTSTV_vsyncupdated(0));
+     //0x98005e84
+                WRITE_REG_INT32U(VO_INTST,
+                                 VO_INTST_afbc_parser_fail(0)|
+                                 VO_INTST_afbc_decode_fail(0)|
+                                 VO_INTST_h_under(0)|
+                                 VO_INTST_i_under(0)|
+                                 VO_INTST_p_under(0)|
+                                 VO_INTST_sub2(0)|
+                                 VO_INTST_sub1(0)|
+                                 VO_INTST_wb2fin(0)|
+                                 VO_INTST_wb1fin(0)|
+                                 VO_INTST_m3fin(0)|
+                                 VO_INTST_m2fin(0)|
+                                 VO_INTST_m1fin(1)|
+                                 VO_INTST_write_data(0));
+/*
+	           //0x98005e84  cwww
+                WRITE_REG_INT32U(VO_INTEN,
+            
+                                 VO_INTEN_h_under(1)|
+                                 VO_INTEN_i_under(1)|
+                                 VO_INTEN_sub2(1)|
+                                 VO_INTEN_sub1(1)|
+                                 VO_INTEN_wb2fin(1)|
+                                 VO_INTEN_wb1fin(1)|
+                                 VO_INTEN_m3fin(1)|
+                                 VO_INTEN_m1fin(1)|
+                                 VO_INTEN_write_data(1));
+
+*/
+                WRITE_REG_INT32U(VO_INTEN,VO_INTEN_m1fin(1) | VO_INTEN_write_data(1));
+				
+                //0x98005020
+                WRITE_REG_INT32U(VO_FC,
+                                 VO_FC_wb2go(0)|
+                                 VO_FC_wb1go(0)|
+                                 VO_FC_mddgo(0)|
+                                 VO_FC_m2go(0)|
+                                 VO_FC_m1go(1)|
+                                 VO_FC_write_data(1));
+
+
+
+				
+	  			if(VO_INTST_get_h_under(READ_REG_INT32U(VO_INTST)))
+        		{
+#if CW_DEBUG
+					printf("#@@ VO_INTST:get h_under \n");
+#endif
+					//0x98005e84
+                        WRITE_REG_INT32U(VO_INTST,
+                                         VO_INTST_afbc_parser_fail(0)|
+                                         VO_INTST_afbc_decode_fail(0)|
+                                         VO_INTST_h_under(1)|
+                                         VO_INTST_i_under(0)|
+                                         VO_INTST_p_under(0)|
+                                         VO_INTST_sub2(0)|
+                                         VO_INTST_sub1(0)|
+                                         VO_INTST_wb2fin(0)|
+                                         VO_INTST_wb1fin(0)|
+                                         VO_INTST_m3fin(0)|
+                                         VO_INTST_m2fin(0)|
+                                         VO_INTST_m1fin(0)|
+                                         VO_INTST_write_data(0));
+	  		}
+     }
+}
+#endif
+    return 0;
+}
+
+#endif
+
+#define TEST_Y_ADDR 0x10000000
+#define TEST_C_ADDR 0x15000000
+
+#define TEST_MC_OFFSET_ADDR 0x10000000
+#define TEST_MC_ADDR 0x15000000
+
+void V1_draw(int VE_Source)
+{
+
+	unsigned int MC_C_chroma_offset = 0x2400;
+	unsigned int MC_18_chroma_offset = 0x36A00;
+
+    //0xb8005000
+    WRITE_REG_INT32U(VO_MODE,
+                     VO_MODE_ch2(1)|
+                     VO_MODE_ch1(0)|
+                     VO_MODE_write_data(0));
+
+    //0xb8005000
+    WRITE_REG_INT32U(VO_MODE,
+                     VO_MODE_ch2(0)|
+                     VO_MODE_ch1(1)|
+                     VO_MODE_write_data(1));
+                     
+    //0xb8005004
+    WRITE_REG_INT32U(VO_OUT,
+                     VO_OUT_write_en3(1)|VO_OUT_h(1));
+    //0xb8005008
+    WRITE_REG_INT32U(VO_MIX12,
+                     VO_MIX12_v1(1));
+
+
+	if(VE_Source)
+    { //0xb8005020
+        WRITE_REG_INT32U(VO_V1,
+                         VO_V1_ve_fmt(0)|
+                         VO_V1_source(1)|
+                          VO_V1_seq(1)|
+                         VO_V1_f422(0)|  //cwww
+                         VO_V1_write_data(1));
+#if CW_DEBUG
+        unsigned int vo_v1_mc0 =         READ_REG_INT32U(VO_V1_MC_0);
+		printf("@@@ VO_V1_MC_0:%x \n",vo_v1_mc0);
+#endif
+
+		WRITE_REG_INT32U(VO_V1_MC_0, VO_V1_MC_0_int_mask(0)| VO_V1_MC_0_run(0));
+		WRITE_REG_INT32U(VO_V1_MC_4, VO_V1_MC_4_done(0));
+	
+		WRITE_REG_INT32U(VO_V1_MC_8, VO_V1_MC_8_luma_offset_sa(TEST_MC_OFFSET_ADDR));
+		WRITE_REG_INT32U(VO_V1_MC_C, VO_V1_MC_C_chroma_offset_sa(TEST_MC_OFFSET_ADDR+ MC_C_chroma_offset));
+		WRITE_REG_INT32U(VO_V1_MC_10, VO_V1_MC_10_luma_height(288)|VO_V1_MC_10_chroma_height(144));
+		WRITE_REG_INT32U(VO_V1_MC_14, VO_V1_MC_14_luma_sa(TEST_MC_ADDR));
+		WRITE_REG_INT32U(VO_V1_MC_18, VO_V1_MC_18_chroma_sa(TEST_MC_ADDR+MC_18_chroma_offset));
+
+		WRITE_REG_INT32U(VO_V1_MC_1C, VO_V1_MC_1C_luma_pitch(2880)|VO_V1_MC_1C_chroma_pitch(1440));
+		WRITE_REG_INT32U(VO_V1_MC_20, VO_V1_MC_20_x_pos(0)|VO_V1_MC_20_y_pos(0));
+		WRITE_REG_INT32U(VO_V1_MC_24, VO_V1_MC_24_x_size(720)|VO_V1_MC_24_y_size(288));
+		WRITE_REG_INT32U(VO_V1_MC_28, VO_V1_MC_28_luma_out_mode(0)|VO_V1_MC_28_chroma_out_mode(0)|VO_V1_MC_28_hsync_period(10));
+		WRITE_REG_INT32U(VO_V1_MC_30, VO_V1_MC_30_offset_endian(0)|VO_V1_MC_30_data_endian(0));
+		WRITE_REG_INT32U(VO_V1_TILE, VO_V1_TILE_mc_f422(0)|VO_V1_TILE_data_endian(1)|VO_V1_TILE_size(0));
+
+		WRITE_REG_INT32U(VO_V1_SIZE,
+                         VO_V1_SIZE_w(720)|
+                         VO_V1_SIZE_h(288));
+		         //0xb8005610
+        WRITE_REG_INT32U(VO_V1_XY,
+                         VO_V1_XY_x(0)|
+                         VO_V1_XY_y(0));
+                //0xb8005604
+       WRITE_REG_INT32U(VO_M1_SIZE,
+                     VO_M1_SIZE_w(720)|
+                     VO_M1_SIZE_h(288));                 
+	 }else{
+        WRITE_REG_INT32U(VO_V1,
+                         VO_V1_ve_fmt(0)|
+                         VO_V1_source(0)|
+                          VO_V1_seq(1)|
+                         VO_V1_f422(0)|  //cwww
+                         VO_V1_write_data(1));
+   		WRITE_REG_INT32U(VO_V1_SEQ_SA_C_Y, VO_V1_SEQ_SA_C_Y_a(TEST_Y_ADDR));
+
+            //0xb800503c
+        WRITE_REG_INT32U(VO_V1_SEQ_SA_C_C, VO_V1_SEQ_SA_C_C_a(TEST_C_ADDR));
+
+			        //0xb8005048
+        WRITE_REG_INT32U(VO_V1_SEQ_PITCH_C_Y, VO_V1_SEQ_PITCH_C_Y_p(720));
+        //0xb800504c
+        WRITE_REG_INT32U(VO_V1_SEQ_PITCH_C_C, VO_V1_SEQ_PITCH_C_C_p(720));
+        //0xb8005068
+        WRITE_REG_INT32U(VO_V1_SIZE,
+                         VO_V1_SIZE_w(720)|
+                         VO_V1_SIZE_h(576));
+                        
+        //0xb8005604
+        WRITE_REG_INT32U(VO_M1_SIZE,
+                         VO_M1_SIZE_w(720)|
+                         VO_M1_SIZE_h(576));
+                                 //0xb8005610
+        WRITE_REG_INT32U(VO_V1_XY,
+                         VO_V1_XY_x(0)|
+                         VO_V1_XY_y(0));
+	 }
+
+
+#if 0
+
+while(1)
+{	
+     if(HDMI_INTSTV_get_vsyncupdated(READ_REG_INT32U(HDMI_INTSTV)))
+     {
+
+#if CW_DEBUG
+        unsigned int voinst =         READ_REG_INT32U(VO_INTST);
+
+		printf("222 VO_INTST:%x \n",voinst);
+#endif
+
+		if(VE_Source)
+		{
+
+			WRITE_REG_INT32U(VO_V1_MC_0, VO_V1_MC_0_int_mask(0)| VO_V1_MC_0_run(0));
+			WRITE_REG_INT32U(VO_V1_MC_4, VO_V1_MC_4_done(1));
+
+		}	
+
+	//0xb800d278
+                WRITE_REG_INT32U(HDMI_INTSTV,
+                                 HDMI_INTSTV_vendupdated(0)|
+                                 HDMI_INTSTV_vsyncupdated(0));
+     //0x98005e84
+                WRITE_REG_INT32U(VO_INTST,
+                                 VO_INTST_afbc_parser_fail(0)|
+                                 VO_INTST_afbc_decode_fail(0)|
+                                 VO_INTST_h_under(0)|
+                                 VO_INTST_i_under(0)|
+                                 VO_INTST_p_under(0)|
+                                 VO_INTST_sub2(0)|
+                                 VO_INTST_sub1(0)|
+                                 VO_INTST_wb2fin(0)|
+                                 VO_INTST_wb1fin(0)|
+                                 VO_INTST_m3fin(0)|
+                                 VO_INTST_m2fin(0)|
+                                 VO_INTST_m1fin(1)|
+                                 VO_INTST_write_data(0));
+/*
+	           //0x98005e84  cwww
+                WRITE_REG_INT32U(VO_INTEN,
+            
+                                 VO_INTEN_h_under(1)|
+                                 VO_INTEN_i_under(1)|
+                                 VO_INTEN_sub2(1)|
+                                 VO_INTEN_sub1(1)|
+                                 VO_INTEN_wb2fin(1)|
+                                 VO_INTEN_wb1fin(1)|
+                                 VO_INTEN_m3fin(1)|
+                                 VO_INTEN_m1fin(1)|
+                                 VO_INTEN_write_data(1));
+*/
+   //0x98005e84  cwww
+                WRITE_REG_INT32U(VO_INTEN,
+                                 VO_INTEN_m1fin(1)|
+                                 VO_INTEN_write_data(1));
+
+
+				
+                //0x98005020
+                WRITE_REG_INT32U(VO_FC,
+                                 VO_FC_wb2go(0)|
+                                 VO_FC_wb1go(0)|
+                                 VO_FC_mddgo(0)|
+                                 VO_FC_m2go(0)|
+                                 VO_FC_m1go(1)|
+                                 VO_FC_write_data(1));
+
+
+					if(VO_INTST_get_h_under(READ_REG_INT32U(VO_INTST)))
+        		{
+
+#if CW_DEBUG
+					 printf("#@@ VO_INTST:get h_under \n");
+#endif
+					//0x98005e84
+                        WRITE_REG_INT32U(VO_INTST,
+                                         VO_INTST_afbc_parser_fail(0)|
+                                         VO_INTST_afbc_decode_fail(0)|
+                                         VO_INTST_h_under(1)|
+                                         VO_INTST_i_under(0)|
+                                         VO_INTST_p_under(0)|
+                                         VO_INTST_sub2(0)|
+                                         VO_INTST_sub1(0)|
+                                         VO_INTST_wb2fin(0)|
+                                         VO_INTST_wb1fin(0)|
+                                         VO_INTST_m3fin(0)|
+                                         VO_INTST_m2fin(0)|
+                                         VO_INTST_m1fin(0)|
+                                         VO_INTST_write_data(0));
+	  		}
+     }
+
+}
+#endif 
+}
+
+
+void SET_HDMI_Video_576p(int Pixel_Colocr_Format, int DVI_or_HDMI, int Deep_Color, int Deep_Depth, int xv_YCC, int Timing_Gen, int Enable_3D, int Format_3D)
+{
+	
+    //0xb800d034
+    WRITE_REG_INT32U(HDMI_CR,
+                     HDMI_CR_write_en3(1)|HDMI_CR_tmds_encen(0)|                  
+                     HDMI_CR_write_en1(1)|HDMI_CR_enablehdmi(0));
+    //0xb800d0bc
+    WRITE_REG_INT32U(HDMI_ICR,
+                     HDMI_ICR_write_en3(1)|HDMI_ICR_enaudio(0)|
+                     HDMI_ICR_write_en2(1)|HDMI_ICR_envitd(0)|
+                     HDMI_ICR_write_en1(0)|HDMI_ICR_vitd(0));
+
+    if(!DVI_or_HDMI) //DVI mode=================================================
+    {
+        //CRT & PHY config
+        //TMDS_27MHz(0, 0, 0, 0);
+        WRITE_REG_INT32U(0x9800d144,0x070c7d82);
+        WRITE_REG_INT32U(0x9800d148,0x00040504);
+        WRITE_REG_INT32U(0x9800d148,0x00000504);
+
+        //Timming setting
+        if(Timing_Gen)
+        {
+        	
+            //0xb800d234
+            WRITE_REG_INT32U(HDMI_H_PARA1,
+                             HDMI_H_PARA1_hblank(143)|
+                             HDMI_H_PARA1_hactive(719));
+            //0xb800d238
+            WRITE_REG_INT32U(HDMI_H_PARA2,
+                             HDMI_H_PARA2_hsync(63)|
+                             HDMI_H_PARA2_hfront(11));
+            //0xb800d23c
+            WRITE_REG_INT32U(HDMI_H_PARA3,
+                             HDMI_H_PARA3_hback(67));
+            //0xb800d240
+            WRITE_REG_INT32U(HDMI_V_PARA1,
+                             HDMI_V_PARA1_Vact_video(575)|
+                             HDMI_V_PARA1_vactive(575));
+            //0xb800d244
+            WRITE_REG_INT32U(HDMI_V_PARA2,
+                             HDMI_V_PARA2_Vact_space1(0)|
+                             HDMI_V_PARA2_Vact_space(0));
+            //0xb800d248
+            WRITE_REG_INT32U(HDMI_V_PARA3,
+                             HDMI_V_PARA3_Vblank3(0)|
+                             HDMI_V_PARA3_Vact_space2(0));
+            //0xb800d24c
+            WRITE_REG_INT32U(HDMI_V_PARA4,
+                             HDMI_V_PARA4_vsync((5<<1))|
+                             HDMI_V_PARA4_vblank(48));
+            //0xb800d250
+            WRITE_REG_INT32U(HDMI_V_PARA5,
+                             HDMI_V_PARA5_vback(38)|
+                             HDMI_V_PARA5_vfront((5<<1)));
+            //0xb800d254
+            WRITE_REG_INT32U(HDMI_V_PARA6,
+                             HDMI_V_PARA6_Vsync1((0<<1))|
+                             HDMI_V_PARA6_Vblank1(0));
+            //0xb800d258
+            WRITE_REG_INT32U(HDMI_V_PARA7,
+                             HDMI_V_PARA7_Vback1(0)|
+                             HDMI_V_PARA7_Vfront1((0<<1)));
+            //0xb800d25c
+            WRITE_REG_INT32U(HDMI_V_PARA8,
+                             HDMI_V_PARA8_Vsync2((0<<1))|
+                             HDMI_V_PARA8_Vblank2(0));
+            //0xb800d260
+            WRITE_REG_INT32U(HDMI_V_PARA9,
+                             HDMI_V_PARA9_Vback2(0)|
+                             HDMI_V_PARA9_Vfront2((0<<1)));
+            //0xb800d26c
+            WRITE_REG_INT32U(HDMI_V_PARA10,
+                             HDMI_V_PARA10_G(0x00beef));
+            //0xb800d270
+            WRITE_REG_INT32U(HDMI_V_PARA11,
+                             HDMI_V_PARA11_B(0x00beef)|
+                             HDMI_V_PARA11_R(0x00beef));
+            //0xb800d264
+            WRITE_REG_INT32U(HDMI_V_PARA12,
+                             HDMI_V_PARA12_vsynci((0<<1))|
+                             HDMI_V_PARA12_vblanki(0));
+            //0xb800d268
+            WRITE_REG_INT32U(HDMI_V_PARA13,
+                             HDMI_V_PARA13_vbacki(0)|
+                             HDMI_V_PARA13_vfronti((0<<1)));
+            //0xb800d030
+            WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                             HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                             HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                             HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                             HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+            //0xb800d154
+            WRITE_REG_INT32U(HDMI_DPC,
+                             HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                             HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                             HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                             HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                             HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                             HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(0)|
+                             HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(0));
+        }
+        else
+        {
+        }
+    }
+    else //HDMI mode============================================================
+    {
+        //CRT & PHY config
+        //TMDS_27MHz(Deep_Color, Deep_Depth, Enable_3D, Format_3D);
+
+        //Timming setting
+        if(Timing_Gen)
+        {
+            //0xb800d234
+            WRITE_REG_INT32U(HDMI_H_PARA1,
+                             HDMI_H_PARA1_hblank(143)|
+                             HDMI_H_PARA1_hactive(719));
+            //0xb800d238
+            WRITE_REG_INT32U(HDMI_H_PARA2,
+                             HDMI_H_PARA2_hsync(63)|
+                             HDMI_H_PARA2_hfront(11));
+            //0xb800d23c
+            WRITE_REG_INT32U(HDMI_H_PARA3,
+                             HDMI_H_PARA3_hback(67));
+            if(Enable_3D)
+            {
+                switch(Format_3D)
+                {
+                    case 0:
+                        //0xb800d240
+                        WRITE_REG_INT32U(HDMI_V_PARA1,
+                                         HDMI_V_PARA1_Vact_video(575)|
+                                         HDMI_V_PARA1_vactive(1200));
+                        //0xb800d244
+                        WRITE_REG_INT32U(HDMI_V_PARA2,
+                                         HDMI_V_PARA2_Vact_space1(0)|
+                                         HDMI_V_PARA2_Vact_space(48));
+                        break;
+                    case 6:
+                    case 8:
+                        //0xb800d240
+                        WRITE_REG_INT32U(HDMI_V_PARA1,
+                                         HDMI_V_PARA1_Vact_video(575)|
+                                         HDMI_V_PARA1_vactive(575));
+                        //0xb800d244
+                        WRITE_REG_INT32U(HDMI_V_PARA2,
+                                         HDMI_V_PARA2_Vact_space1(0)|
+                                         HDMI_V_PARA2_Vact_space(0));
+                        break;
+                    default:
+                        break;
+                }
+            }
+            else
+            {
+                //0xb800d240
+                WRITE_REG_INT32U(HDMI_V_PARA1,
+                                 HDMI_V_PARA1_Vact_video(575)|
+                                 HDMI_V_PARA1_vactive(575));
+                //0xb800d244
+                WRITE_REG_INT32U(HDMI_V_PARA2,
+                                 HDMI_V_PARA2_Vact_space1(0)|
+                                 HDMI_V_PARA2_Vact_space(0));
+            }
+            //0xb800d248
+            WRITE_REG_INT32U(HDMI_V_PARA3,
+                             HDMI_V_PARA3_Vblank3(0)|
+                             HDMI_V_PARA3_Vact_space2(0));
+            //0xb800d24c
+            WRITE_REG_INT32U(HDMI_V_PARA4,
+                             HDMI_V_PARA4_vsync((5<<1))|
+                             HDMI_V_PARA4_vblank(48));
+            //0xb800d250
+            WRITE_REG_INT32U(HDMI_V_PARA5,
+                             HDMI_V_PARA5_vback(38)|
+                             HDMI_V_PARA5_vfront((5<<1)));
+            //0xb800d254
+            WRITE_REG_INT32U(HDMI_V_PARA6,
+                             HDMI_V_PARA6_Vsync1((0<<1))|
+                             HDMI_V_PARA6_Vblank1(0));
+            //0xb800d258
+            WRITE_REG_INT32U(HDMI_V_PARA7,
+                             HDMI_V_PARA7_Vback1(0)|
+                             HDMI_V_PARA7_Vfront1((0<<1)));
+            //0xb800d25c
+            WRITE_REG_INT32U(HDMI_V_PARA8,
+                             HDMI_V_PARA8_Vsync2((0<<1))|
+                             HDMI_V_PARA8_Vblank2(0));
+            //0xb800d260
+            WRITE_REG_INT32U(HDMI_V_PARA9,
+                             HDMI_V_PARA9_Vback2(0)|
+                             HDMI_V_PARA9_Vfront2((0<<1)));
+            //0xb800d26c
+            WRITE_REG_INT32U(HDMI_V_PARA10,
+                             HDMI_V_PARA10_G(0x00beef));
+            //0xb800d270
+            WRITE_REG_INT32U(HDMI_V_PARA11,
+                             HDMI_V_PARA11_B(0x00beef)|
+                             HDMI_V_PARA11_R(0x00beef));
+            //0xb800d264
+            WRITE_REG_INT32U(HDMI_V_PARA12,
+                             HDMI_V_PARA12_vsynci((0<<1))|
+                             HDMI_V_PARA12_vblanki(0));
+            //0xb800d268
+            WRITE_REG_INT32U(HDMI_V_PARA13,
+                             HDMI_V_PARA13_vbacki(0)|
+                             HDMI_V_PARA13_vfronti((0<<1)));
+
+            //Deep Color 24bit========================================================================================
+            if(Deep_Color==0 || (Deep_Color==1 && Deep_Depth==4))
+            {
+                //0xb800d030
+                WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+                //0xb800d154
+                WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+            //Deep Color 30bit========================================================================================
+            if(Deep_Color==1 && Deep_Depth==5)
+            {
+                //0xb800d030
+                WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+                //0xb800d154
+                WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+            //Deep Color 36bit========================================================================================
+            if(Deep_Color==1 && Deep_Depth==6)
+            {
+                //0xb800d030
+                WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+                //0xb800d154
+                WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+        }
+        else
+        {
+        }
+    }
+
+    //=====================================================================================================
+    // HDMI Control
+    //=====================================================================================================
+    if(Timing_Gen)
+    {
+        //0xb800d020
+        WRITE_REG_INT32U(HDMI_CHNL_SEL,
+                         HDMI_CHNL_SEL_video_sd(1)|
+                         HDMI_CHNL_SEL_Interlaced_vfmt(0)|
+                         HDMI_CHNL_SEL_3D_video_format(Format_3D)|
+                         HDMI_CHNL_SEL_En_3D(Enable_3D)|
+                         HDMI_CHNL_SEL_timing_gen_en(1)|
+                         HDMI_CHNL_SEL_chl_sel(0));
+    }
+    else
+    {
+    }
+
+    if(DVI_or_HDMI==0) //DVI mode
+        Pixel_Colocr_Format = 0;
+    
+    if(Pixel_Colocr_Format==0) //RGB mode
+    {
+        //-- Color Transform (YCbCr 4:4:4 -> RGB 4:4:4)
+        //0xb800d024
+        WRITE_REG_INT32U(HDMI_CS_TRANS0, HDMI_CS_TRANS0_c1(0x04a80));
+        //0xb800d028
+        WRITE_REG_INT32U(HDMI_CS_TRANS1, HDMI_CS_TRANS1_c2(0x1e700));
+        //0xb800d02c
+        WRITE_REG_INT32U(HDMI_CS_TRANS2, HDMI_CS_TRANS2_c3(0x1cc40));
+        //0xb800d200
+        WRITE_REG_INT32U(HDMI_CS_TRANS3, HDMI_CS_TRANS3_c4(0x04a80));
+        //0xb800d204
+        WRITE_REG_INT32U(HDMI_CS_TRANS4, HDMI_CS_TRANS4_c5(0x08140));
+        //0xb800d208
+        WRITE_REG_INT32U(HDMI_CS_TRANS5, HDMI_CS_TRANS5_c6(0x00000));
+        //0xb800d20c
+        WRITE_REG_INT32U(HDMI_CS_TRANS6, HDMI_CS_TRANS6_c7(0x04a80));
+        //0xb800d210
+        WRITE_REG_INT32U(HDMI_CS_TRANS7, HDMI_CS_TRANS7_c8(0x00000));
+        //0xb800d214
+        WRITE_REG_INT32U(HDMI_CS_TRANS8, HDMI_CS_TRANS8_c9(0x06680));
+        //0xb800d218
+        WRITE_REG_INT32U(HDMI_CS_TRANS9, HDMI_CS_TRANS9_k1(0x21b0));
+        //0xb800d21c
+        WRITE_REG_INT32U(HDMI_CS_TRANS10, HDMI_CS_TRANS10_k2(0xba70));
+        //0xb800d220
+        WRITE_REG_INT32U(HDMI_CS_TRANS11, HDMI_CS_TRANS11_k3(0xc840));
+    }
+    else //YCbCr mode
+    {
+        //-- Color Transform (YCbCr 4:4:4 -> RGB 4:4:4)
+        //0xb800d024
+        WRITE_REG_INT32U(HDMI_CS_TRANS0, HDMI_CS_TRANS0_c1(0x04000));
+        //0xb800d028
+        WRITE_REG_INT32U(HDMI_CS_TRANS1, HDMI_CS_TRANS1_c2(0x00000));
+        //0xb800d02c
+        WRITE_REG_INT32U(HDMI_CS_TRANS2, HDMI_CS_TRANS2_c3(0x00000));
+        //0xb800d200
+        WRITE_REG_INT32U(HDMI_CS_TRANS3, HDMI_CS_TRANS3_c4(0x00000));
+        //0xb800d204
+        WRITE_REG_INT32U(HDMI_CS_TRANS4, HDMI_CS_TRANS4_c5(0x04000));
+        //0xb800d208
+        WRITE_REG_INT32U(HDMI_CS_TRANS5, HDMI_CS_TRANS5_c6(0x00000));
+        //0xb800d20c
+        WRITE_REG_INT32U(HDMI_CS_TRANS6, HDMI_CS_TRANS6_c7(0x00000));
+        //0xb800d210
+        WRITE_REG_INT32U(HDMI_CS_TRANS7, HDMI_CS_TRANS7_c8(0x00000));
+        //0xb800d214
+        WRITE_REG_INT32U(HDMI_CS_TRANS8, HDMI_CS_TRANS8_c9(0x04000));
+        //0xb800d218
+        WRITE_REG_INT32U(HDMI_CS_TRANS9, HDMI_CS_TRANS9_k1(0x0000));
+        //0xb800d21c
+        WRITE_REG_INT32U(HDMI_CS_TRANS10, HDMI_CS_TRANS10_k2(0x0000));
+        //0xb800d220
+        WRITE_REG_INT32U(HDMI_CS_TRANS11, HDMI_CS_TRANS11_k3(0x0000));
+    }
+
+    //0xb800d0b8
+    WRITE_REG_INT32U(HDMI_SCHCR,
+                     HDMI_SCHCR_write_en10(1)|
+                     HDMI_SCHCR_422_pixel_repeat(0));
+    //0xb800d078
+    WRITE_REG_INT32U(HDMI_GCPCR,
+                     HDMI_GCPCR_enablegcp(1)|
+                     HDMI_GCPCR_gcp_clearavmute(0)|
+                     HDMI_GCPCR_gcp_setavmute(0)|
+                     HDMI_GCPCR_write_data(0));
+    //0xb800d078
+    WRITE_REG_INT32U(HDMI_GCPCR,
+                     HDMI_GCPCR_enablegcp(1)|
+                     HDMI_GCPCR_gcp_clearavmute(0)|
+                     HDMI_GCPCR_gcp_setavmute(0)|
+                     HDMI_GCPCR_write_data(1));
+    //0xb800d0a0
+    WRITE_REG_INT32U(HDMI_RPCR,
+                     HDMI_RPCR_write_en6(1)|HDMI_RPCR_prp5period(0)| //unuse
+                     HDMI_RPCR_write_en5(1)|HDMI_RPCR_prp4period(0)| //unuse
+                     HDMI_RPCR_write_en4(1)|HDMI_RPCR_prp3period(0)| //Vendor Specific InfoFrame package use
+                     HDMI_RPCR_write_en3(1)|HDMI_RPCR_prp2period(0)| //Metadata package use
+                     HDMI_RPCR_write_en2(0)|HDMI_RPCR_prp1period(0)| //Audio InfoFrame package use by HDMI_audio_set
+                     HDMI_RPCR_write_en1(1)|HDMI_RPCR_prp0period(0)); //AVI InfoFrame package use
+    //0xb800d0a4
+    WRITE_REG_INT32U(HDMI_RPEN,
+                     HDMI_RPEN_enprpkt5(1)| //unuse
+                     HDMI_RPEN_enprpkt4(1)| //unuse
+                     HDMI_RPEN_enprpkt3(1)| //Vendor Specific InfoFrame package clear
+                     HDMI_RPEN_enprpkt2(1)| //Metadata package clear
+                     HDMI_RPEN_enprpkt1(0)| //Audio InfoFrame package clear by HDMI_audio_set
+                     HDMI_RPEN_enprpkt0(1)| //AVI InfoFrame package clear
+                     HDMI_RPEN_write_data(0));
+    //0xb800d0b4
+    WRITE_REG_INT32U(HDMI_DIPCCR,
+                     HDMI_DIPCCR_write_en2(1)|HDMI_DIPCCR_vbidipcnt(17)|//ver. max 18 packets
+                     HDMI_DIPCCR_write_en1(1)|HDMI_DIPCCR_hbidipcnt(1));//hor. max 2 packets
+
+    //=====================================================================================================
+    // Scheduler
+    //=====================================================================================================
+    if(DVI_or_HDMI==0) //DVI mode
+    {
+        //0xb800d0b8
+        WRITE_REG_INT32U(HDMI_SCHCR,
+                         HDMI_SCHCR_write_en12(1)|HDMI_SCHCR_color_transform_en(1)|
+                         HDMI_SCHCR_write_en11(0)|HDMI_SCHCR_ycbcr422_algo(0)|
+                         HDMI_SCHCR_write_en10(0)|HDMI_SCHCR_422_pixel_repeat(0)|
+                         HDMI_SCHCR_write_en9(0)|HDMI_SCHCR_vsyncpolin(0)|
+                         HDMI_SCHCR_write_en8(0)|HDMI_SCHCR_hsyncpolin(0)|
+                         HDMI_SCHCR_write_en7(1)|HDMI_SCHCR_vsyncpolinv(1)|
+                         HDMI_SCHCR_write_en6(1)|HDMI_SCHCR_hsyncpolinv(1)|
+                         HDMI_SCHCR_write_en5(1)|HDMI_SCHCR_pixelencycbcr422(0)|
+                         HDMI_SCHCR_write_en4(1)|HDMI_SCHCR_hdmi_videoxs(0)|
+                         HDMI_SCHCR_write_en3(1)|HDMI_SCHCR_pixelencfmt(0)| //RGB444
+                         HDMI_SCHCR_write_en2(1)|HDMI_SCHCR_pixelrepeat(0)|
+                         HDMI_SCHCR_write_en1(1)|HDMI_SCHCR_hdmi_modesel(0));
+    }
+    else //HDMI mode
+    {
+        //0xb800d0b8
+        WRITE_REG_INT32U(HDMI_SCHCR,
+                         HDMI_SCHCR_write_en12(1)|HDMI_SCHCR_color_transform_en(1)|
+                         HDMI_SCHCR_write_en11(0)|HDMI_SCHCR_ycbcr422_algo(0)|
+                         HDMI_SCHCR_write_en10(0)|HDMI_SCHCR_422_pixel_repeat(0)|
+                         HDMI_SCHCR_write_en9(0)|HDMI_SCHCR_vsyncpolin(0)|
+                         HDMI_SCHCR_write_en8(0)|HDMI_SCHCR_hsyncpolin(0)|
+                         HDMI_SCHCR_write_en7(1)|HDMI_SCHCR_vsyncpolinv(1)|
+                         HDMI_SCHCR_write_en6(1)|HDMI_SCHCR_hsyncpolinv(1)|
+                         HDMI_SCHCR_write_en5(1)|HDMI_SCHCR_pixelencycbcr422(0)|
+                         HDMI_SCHCR_write_en4(1)|HDMI_SCHCR_hdmi_videoxs(0)|
+                         HDMI_SCHCR_write_en3(1)|HDMI_SCHCR_pixelencfmt(Pixel_Colocr_Format)|
+                         HDMI_SCHCR_write_en2(1)|HDMI_SCHCR_pixelrepeat(0)|
+                         HDMI_SCHCR_write_en1(1)|HDMI_SCHCR_hdmi_modesel(1));
+    }
+
+    //0xb800d0f0
+    WRITE_REG_INT32U(HDMI_HDCP_KOWR, HDMI_HDCP_KOWR_hdcprekeykeepoutwin(0x2a));
+
+    //0xb800d000
+    WRITE_REG_INT32U(HDMI_INTEN,
+                     HDMI_INTEN_enriupdint(1)|
+                     HDMI_INTEN_enpjupdint(1)|
+                     HDMI_INTEN_write_data(0));
+
+
+/*cww
+    if(DVI_or_HDMI) HDMI_gen_avi_infoframe(17, Pixel_Colocr_Format, xv_YCC);
+
+    if(DVI_or_HDMI && xv_YCC) HDMI_gen_metadata();
+
+    if(DVI_or_HDMI && Enable_3D) HDMI_gen_vendor_Specific_infoframe(1, Format_3D, 0, 0);
+*/
+    //0xb800d034
+    WRITE_REG_INT32U(HDMI_CR,
+                     HDMI_CR_write_en3(1)|HDMI_CR_tmds_encen(1)|
+                     HDMI_CR_write_en1(1)|HDMI_CR_enablehdmi(1));
+    return;
+}
+
+void TMDS_74MHz(int Deep_Color, int Deep_Depth, int En_3D, int Format_3D)
+{
+    //CRT & PHY config
+    //Deep Color 24bit==========================================================
+    if(Deep_Color==0 || (Deep_Color==1 && Deep_Depth==4))
+    {
+        if(En_3D==1 && Format_3D==0) //PIXEL=148.5MHz, TMDS=148.5MHz
+        {
+        }
+        else  //PIXEL=74.25MHz, TMDS=74.25MHz
+        {
+            WRITE_REG_INT32U(0x98000204,0x93680013);
+            WRITE_REG_INT32U(0x98000208,0x90200ffe);
+            WRITE_REG_INT32U(0x9800021c,0x00000000);
+            WRITE_REG_INT32U(0x98000220,0x00800000);
+            WRITE_REG_INT32U(0x98000208,0x90200fff);
+            WRITE_REG_INT32U(0x98000230,0x0000000F);
+            WRITE_REG_INT32U(0x98000234,0x000000F0);
+            WRITE_REG_INT32U(0x98000238,0x00249000);
+            WRITE_REG_INT32U(0x9800023C,0x0004c092);
+            WRITE_REG_INT32U(0x98000240,0x00000002);
+            WRITE_REG_INT32U(0x98000194,0x00060232);
+            msleep(1000);
+        }
+    }
+    //Deep Color 30bit==========================================================
+    if(Deep_Color==1 && Deep_Depth==5)
+    {
+        if(En_3D==1 && Format_3D==0) //PIXEL=148.5MHz, TMDS=185.625MHz
+        {
+        }
+        else //PIXEL=74.25MHz, TMDS=92.8125MHz
+        {
+        }
+    }
+    //Deep Color 36bit==========================================================
+    if(Deep_Color==1 && Deep_Depth==6)
+    {
+        if(En_3D==1 && Format_3D==0) //PIXEL=148.5MHz, TMDS=222.75MHz
+        {
+        }
+        else //PIXEL=74.25MHz, TMDS=111.375MHz
+        {
+        }
+    }
+}
+
+void SET_HDMI_Video_720p60(int Pixel_Colocr_Format, int DVI_or_HDMI, int Deep_Color, int Deep_Depth, int xv_YCC, int Timing_Gen, int Enable_3D, int Format_3D)
+{
+    //0xb800d034
+    WRITE_REG_INT32U(HDMI_CR,
+                     HDMI_CR_write_en3(1)|HDMI_CR_tmds_encen(0)|
+                     HDMI_CR_write_en1(1)|HDMI_CR_enablehdmi(0));
+    //0xb800d0bc
+    WRITE_REG_INT32U(HDMI_ICR,
+                     HDMI_ICR_write_en3(1)|HDMI_ICR_enaudio(0)|
+                     HDMI_ICR_write_en2(1)|HDMI_ICR_envitd(0)|
+                     HDMI_ICR_write_en1(0)|HDMI_ICR_vitd(0));
+
+    if(!DVI_or_HDMI) //DVI mode=================================================
+    {
+        //CRT & PHY config
+        TMDS_74MHz(0, 0, 0, 0);
+
+        //Timming setting
+        if(Timing_Gen)
+        {
+            //0xb800d234
+            WRITE_REG_INT32U(HDMI_H_PARA1,
+                             HDMI_H_PARA1_hblank(369)|
+                             HDMI_H_PARA1_hactive(1279));
+            //0xb800d238
+            WRITE_REG_INT32U(HDMI_H_PARA2,
+                             HDMI_H_PARA2_hsync(39)|
+                             HDMI_H_PARA2_hfront(109));
+            //0xb800d23c
+            WRITE_REG_INT32U(HDMI_H_PARA3,
+                             HDMI_H_PARA3_hback(219));
+            //0xb800d240
+            WRITE_REG_INT32U(HDMI_V_PARA1,
+                             HDMI_V_PARA1_Vact_video(719)|
+                             HDMI_V_PARA1_vactive(719));
+            //0xb800d244
+            WRITE_REG_INT32U(HDMI_V_PARA2,
+                             HDMI_V_PARA2_Vact_space1(0)|
+                             HDMI_V_PARA2_Vact_space(0));
+            //0xb800d248
+            WRITE_REG_INT32U(HDMI_V_PARA3,
+                             HDMI_V_PARA3_Vblank3(0)|
+                             HDMI_V_PARA3_Vact_space2(0));
+            //0xb800d24c
+            WRITE_REG_INT32U(HDMI_V_PARA4,
+                             HDMI_V_PARA4_vsync((5<<1))|
+                             HDMI_V_PARA4_vblank(29));
+            //0xb800d250
+            WRITE_REG_INT32U(HDMI_V_PARA5,
+                             HDMI_V_PARA5_vback(19)|
+                             HDMI_V_PARA5_vfront((5<<1)));
+            //0xb800d254
+            WRITE_REG_INT32U(HDMI_V_PARA6,
+                             HDMI_V_PARA6_Vsync1((0<<1))|
+                             HDMI_V_PARA6_Vblank1(0));
+            //0xb800d258
+            WRITE_REG_INT32U(HDMI_V_PARA7,
+                             HDMI_V_PARA7_Vback1(0)|
+                             HDMI_V_PARA7_Vfront1((0<<1)));
+            //0xb800d25c
+            WRITE_REG_INT32U(HDMI_V_PARA8,
+                             HDMI_V_PARA8_Vsync2((0<<1))|
+                             HDMI_V_PARA8_Vblank2(0));
+            //0xb800d260
+            WRITE_REG_INT32U(HDMI_V_PARA9,
+                             HDMI_V_PARA9_Vback2(0)|
+                             HDMI_V_PARA9_Vfront2((0<<1)));
+            //0xb800d26c
+            WRITE_REG_INT32U(HDMI_V_PARA10,
+                             HDMI_V_PARA10_G(0x00beef));
+            //0xb800d270
+            WRITE_REG_INT32U(HDMI_V_PARA11,
+                             HDMI_V_PARA11_B(0x00beef)|
+                             HDMI_V_PARA11_R(0x00beef));
+            //0xb800d264
+            WRITE_REG_INT32U(HDMI_V_PARA12,
+                             HDMI_V_PARA12_vsynci((0<<1))|
+                             HDMI_V_PARA12_vblanki(0));
+            //0xb800d268
+            WRITE_REG_INT32U(HDMI_V_PARA13,
+                             HDMI_V_PARA13_vbacki(0)|
+                             HDMI_V_PARA13_vfronti((0<<1)));
+            //0xb800d030
+            WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                             HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                             HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                             HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                             HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+            //0xb800d154
+            WRITE_REG_INT32U(HDMI_DPC,
+                             HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                             HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                             HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                             HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                             HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                             HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(0)|
+                             HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(0));
+        }
+        else
+        {
+        }
+    }
+    else //HDMI mode============================================================
+    {
+        //CRT & PHY config
+        //TMDS_74MHz(Deep_Color, Deep_Depth, Enable_3D, Format_3D);
+
+        //Timming setting
+        if(Timing_Gen)
+        {
+            //0xb800d234
+            WRITE_REG_INT32U(HDMI_H_PARA1,
+                             HDMI_H_PARA1_hblank(369)|
+                             HDMI_H_PARA1_hactive(1279));
+            //0xb800d238
+            WRITE_REG_INT32U(HDMI_H_PARA2,
+                             HDMI_H_PARA2_hsync(39)|
+                             HDMI_H_PARA2_hfront(109));
+            //0xb800d23c
+            WRITE_REG_INT32U(HDMI_H_PARA3,
+                             HDMI_H_PARA3_hback(219));
+            if(Enable_3D)
+            {
+                switch(Format_3D)
+                {
+                    case 0:
+                        //0xb800d240
+                        WRITE_REG_INT32U(HDMI_V_PARA1,
+                                         HDMI_V_PARA1_Vact_video(719)|
+                                         HDMI_V_PARA1_vactive(1469));
+                        //0xb800d244
+                        WRITE_REG_INT32U(HDMI_V_PARA2,
+                                         HDMI_V_PARA2_Vact_space1(0)|
+                                         HDMI_V_PARA2_Vact_space(29));
+                        break;
+                    case 6:
+                    case 8:
+                        //0xb800d240
+                        WRITE_REG_INT32U(HDMI_V_PARA1,
+                                         HDMI_V_PARA1_Vact_video(719)|
+                                         HDMI_V_PARA1_vactive(719));
+                        //0xb800d244
+                        WRITE_REG_INT32U(HDMI_V_PARA2,
+                                         HDMI_V_PARA2_Vact_space1(0)|
+                                         HDMI_V_PARA2_Vact_space(0));
+                        break;
+                    default:
+                        break;
+                }
+            }
+            else
+            {
+                //0xb800d240
+                WRITE_REG_INT32U(HDMI_V_PARA1,
+                                 HDMI_V_PARA1_Vact_video(719)|
+                                 HDMI_V_PARA1_vactive(719));
+                //0xb800d244
+                WRITE_REG_INT32U(HDMI_V_PARA2,
+                                 HDMI_V_PARA2_Vact_space1(0)|
+                                 HDMI_V_PARA2_Vact_space(0));
+            }
+            //0xb800d248
+            WRITE_REG_INT32U(HDMI_V_PARA3,
+                             HDMI_V_PARA3_Vblank3(0)|
+                             HDMI_V_PARA3_Vact_space2(0));
+            //0xb800d24c
+            WRITE_REG_INT32U(HDMI_V_PARA4,
+                             HDMI_V_PARA4_vsync((5<<1))|
+                             HDMI_V_PARA4_vblank(29));
+            //0xb800d250
+            WRITE_REG_INT32U(HDMI_V_PARA5,
+                             HDMI_V_PARA5_vback(19)|
+                             HDMI_V_PARA5_vfront((5<<1)));
+            //0xb800d254
+            WRITE_REG_INT32U(HDMI_V_PARA6,
+                             HDMI_V_PARA6_Vsync1((0<<1))|
+                             HDMI_V_PARA6_Vblank1(0));
+            //0xb800d258
+            WRITE_REG_INT32U(HDMI_V_PARA7,
+                             HDMI_V_PARA7_Vback1(0)|
+                             HDMI_V_PARA7_Vfront1((0<<1)));
+            //0xb800d25c
+            WRITE_REG_INT32U(HDMI_V_PARA8,
+                             HDMI_V_PARA8_Vsync2((0<<1))|
+                             HDMI_V_PARA8_Vblank2(0));
+            //0xb800d260
+            WRITE_REG_INT32U(HDMI_V_PARA9,
+                             HDMI_V_PARA9_Vback2(0)|
+                             HDMI_V_PARA9_Vfront2((0<<1)));
+            //0xb800d26c
+            WRITE_REG_INT32U(HDMI_V_PARA10,
+                             HDMI_V_PARA10_G(0x00beef));
+            //0xb800d270
+            WRITE_REG_INT32U(HDMI_V_PARA11,
+                             HDMI_V_PARA11_B(0x00beef)|
+                             HDMI_V_PARA11_R(0x00beef));
+            //0xb800d264
+            WRITE_REG_INT32U(HDMI_V_PARA12,
+                             HDMI_V_PARA12_vsynci((0<<1))|
+                             HDMI_V_PARA12_vblanki(0));
+            //0xb800d268
+            WRITE_REG_INT32U(HDMI_V_PARA13,
+                             HDMI_V_PARA13_vbacki(0)|
+                             HDMI_V_PARA13_vfronti((0<<1)));
+
+            //Deep Color 24bit========================================================================================
+            if(Deep_Color==0 || (Deep_Color==1 && Deep_Depth==4))
+            {
+                //0xb800d030
+                WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+                //0xb800d154
+                WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+            //Deep Color 30bit========================================================================================
+            if(Deep_Color==1 && Deep_Depth==5)
+            {
+                //0xb800d030
+                WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+                //0xb800d154
+                WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(3)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(1)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(2)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(0)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+            //Deep Color 36bit========================================================================================
+            if(Deep_Color==1 && Deep_Depth==6)
+            {
+                //0xb800d030
+                WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+                //0xb800d154
+                WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+        }
+        else
+        {
+        }
+    }
+
+    //=====================================================================================================
+    // HDMI Control
+    //=====================================================================================================
+    if(Timing_Gen)
+    {
+        //0xb800d020
+        WRITE_REG_INT32U(HDMI_CHNL_SEL,
+                         HDMI_CHNL_SEL_video_sd(0)|
+                         HDMI_CHNL_SEL_Interlaced_vfmt(0)|
+                         HDMI_CHNL_SEL_3D_video_format(Format_3D)|
+                         HDMI_CHNL_SEL_En_3D(Enable_3D)|
+                         HDMI_CHNL_SEL_timing_gen_en(1)|
+                         HDMI_CHNL_SEL_chl_sel(0));
+    }
+    else
+    {
+    }
+
+    if(DVI_or_HDMI==0) //DVI mode
+        Pixel_Colocr_Format = 0;
+    
+    if(Pixel_Colocr_Format==0) //RGB mode
+    {
+        //-- Color Transform (YCbCr 4:4:4 -> RGB 4:4:4)
+        //0xb800d024
+        WRITE_REG_INT32U(HDMI_CS_TRANS0, HDMI_CS_TRANS0_c1(0x04a80));
+        //0xb800d028
+        WRITE_REG_INT32U(HDMI_CS_TRANS1, HDMI_CS_TRANS1_c2(0x1e700));
+        //0xb800d02c
+        WRITE_REG_INT32U(HDMI_CS_TRANS2, HDMI_CS_TRANS2_c3(0x1cc40));
+        //0xb800d200
+        WRITE_REG_INT32U(HDMI_CS_TRANS3, HDMI_CS_TRANS3_c4(0x04a80));
+        //0xb800d204
+        WRITE_REG_INT32U(HDMI_CS_TRANS4, HDMI_CS_TRANS4_c5(0x08140));
+        //0xb800d208
+        WRITE_REG_INT32U(HDMI_CS_TRANS5, HDMI_CS_TRANS5_c6(0x00000));
+        //0xb800d20c
+        WRITE_REG_INT32U(HDMI_CS_TRANS6, HDMI_CS_TRANS6_c7(0x04a80));
+        //0xb800d210
+        WRITE_REG_INT32U(HDMI_CS_TRANS7, HDMI_CS_TRANS7_c8(0x00000));
+        //0xb800d214
+        WRITE_REG_INT32U(HDMI_CS_TRANS8, HDMI_CS_TRANS8_c9(0x06680));
+        //0xb800d218
+        WRITE_REG_INT32U(HDMI_CS_TRANS9, HDMI_CS_TRANS9_k1(0x21b0));
+        //0xb800d21c
+        WRITE_REG_INT32U(HDMI_CS_TRANS10, HDMI_CS_TRANS10_k2(0xba70));
+        //0xb800d220
+        WRITE_REG_INT32U(HDMI_CS_TRANS11, HDMI_CS_TRANS11_k3(0xc840));
+    }
+    else //YCbCr mode
+    {
+        //-- Color Transform (YCbCr 4:4:4 -> RGB 4:4:4)
+        //0xb800d024
+        WRITE_REG_INT32U(HDMI_CS_TRANS0, HDMI_CS_TRANS0_c1(0x04000));
+        //0xb800d028
+        WRITE_REG_INT32U(HDMI_CS_TRANS1, HDMI_CS_TRANS1_c2(0x00000));
+        //0xb800d02c
+        WRITE_REG_INT32U(HDMI_CS_TRANS2, HDMI_CS_TRANS2_c3(0x00000));
+        //0xb800d200
+        WRITE_REG_INT32U(HDMI_CS_TRANS3, HDMI_CS_TRANS3_c4(0x00000));
+        //0xb800d204
+        WRITE_REG_INT32U(HDMI_CS_TRANS4, HDMI_CS_TRANS4_c5(0x04000));
+        //0xb800d208
+        WRITE_REG_INT32U(HDMI_CS_TRANS5, HDMI_CS_TRANS5_c6(0x00000));
+        //0xb800d20c
+        WRITE_REG_INT32U(HDMI_CS_TRANS6, HDMI_CS_TRANS6_c7(0x00000));
+        //0xb800d210
+        WRITE_REG_INT32U(HDMI_CS_TRANS7, HDMI_CS_TRANS7_c8(0x00000));
+        //0xb800d214
+        WRITE_REG_INT32U(HDMI_CS_TRANS8, HDMI_CS_TRANS8_c9(0x04000));
+        //0xb800d218
+        WRITE_REG_INT32U(HDMI_CS_TRANS9, HDMI_CS_TRANS9_k1(0x0000));
+        //0xb800d21c
+        WRITE_REG_INT32U(HDMI_CS_TRANS10, HDMI_CS_TRANS10_k2(0x0000));
+        //0xb800d220
+        WRITE_REG_INT32U(HDMI_CS_TRANS11, HDMI_CS_TRANS11_k3(0x0000));
+    }
+
+    //0xb800d0b8
+    WRITE_REG_INT32U(HDMI_SCHCR,
+                     HDMI_SCHCR_write_en10(1)|
+                     HDMI_SCHCR_422_pixel_repeat(0));
+    //0xb800d078
+    WRITE_REG_INT32U(HDMI_GCPCR,
+                     HDMI_GCPCR_enablegcp(1)|
+                     HDMI_GCPCR_gcp_clearavmute(0)|
+                     HDMI_GCPCR_gcp_setavmute(0)|
+                     HDMI_GCPCR_write_data(0));
+    //0xb800d078
+    WRITE_REG_INT32U(HDMI_GCPCR,
+                     HDMI_GCPCR_enablegcp(1)|
+                     HDMI_GCPCR_gcp_clearavmute(0)|
+                     HDMI_GCPCR_gcp_setavmute(0)|
+                     HDMI_GCPCR_write_data(1));
+    //0xb800d0a0
+    WRITE_REG_INT32U(HDMI_RPCR,
+                     HDMI_RPCR_write_en6(1)|HDMI_RPCR_prp5period(0)| //unuse
+                     HDMI_RPCR_write_en5(1)|HDMI_RPCR_prp4period(0)| //unuse
+                     HDMI_RPCR_write_en4(1)|HDMI_RPCR_prp3period(0)| //Vendor Specific InfoFrame package use
+                     HDMI_RPCR_write_en3(1)|HDMI_RPCR_prp2period(0)| //Metadata package use
+                     HDMI_RPCR_write_en2(0)|HDMI_RPCR_prp1period(0)| //Audio InfoFrame package use by HDMI_audio_set
+                     HDMI_RPCR_write_en1(1)|HDMI_RPCR_prp0period(0)); //AVI InfoFrame package use
+    //0xb800d0a4
+    WRITE_REG_INT32U(HDMI_RPEN,
+                     HDMI_RPEN_enprpkt5(1)| //unuse
+                     HDMI_RPEN_enprpkt4(1)| //unuse
+                     HDMI_RPEN_enprpkt3(1)| //Vendor Specific InfoFrame package clear
+                     HDMI_RPEN_enprpkt2(1)| //Metadata package clear
+                     HDMI_RPEN_enprpkt1(0)| //Audio InfoFrame package clear by HDMI_audio_set
+                     HDMI_RPEN_enprpkt0(1)| //AVI InfoFrame package clear
+                     HDMI_RPEN_write_data(0));
+    //0xb800d0b4
+    WRITE_REG_INT32U(HDMI_DIPCCR,
+                     HDMI_DIPCCR_write_en2(1)|HDMI_DIPCCR_vbidipcnt(17)|//ver. max 18 packets
+                     HDMI_DIPCCR_write_en1(1)|HDMI_DIPCCR_hbidipcnt(8));//hor. max 9 packets
+
+    //=====================================================================================================
+    // Scheduler
+    //=====================================================================================================
+    if(DVI_or_HDMI==0) //DVI mode
+    {
+        //0xb800d0b8
+        WRITE_REG_INT32U(HDMI_SCHCR,
+                         HDMI_SCHCR_write_en12(1)|HDMI_SCHCR_color_transform_en(1)|
+                         HDMI_SCHCR_write_en11(0)|HDMI_SCHCR_ycbcr422_algo(0)|
+                         HDMI_SCHCR_write_en10(0)|HDMI_SCHCR_422_pixel_repeat(0)|
+                         HDMI_SCHCR_write_en9(0)|HDMI_SCHCR_vsyncpolin(0)|
+                         HDMI_SCHCR_write_en8(0)|HDMI_SCHCR_hsyncpolin(0)|
+                         HDMI_SCHCR_write_en7(1)|HDMI_SCHCR_vsyncpolinv(0)|
+                         HDMI_SCHCR_write_en6(1)|HDMI_SCHCR_hsyncpolinv(0)|
+                         HDMI_SCHCR_write_en5(1)|HDMI_SCHCR_pixelencycbcr422(0)|
+                         HDMI_SCHCR_write_en4(1)|HDMI_SCHCR_hdmi_videoxs(0)|
+                         HDMI_SCHCR_write_en3(1)|HDMI_SCHCR_pixelencfmt(0)| //RGB444
+                         HDMI_SCHCR_write_en2(1)|HDMI_SCHCR_pixelrepeat(0)|
+                         HDMI_SCHCR_write_en1(1)|HDMI_SCHCR_hdmi_modesel(0));
+    }
+    else //HDMI mode
+    {
+        //0xb800d0b8
+        WRITE_REG_INT32U(HDMI_SCHCR,
+                         HDMI_SCHCR_write_en12(1)|HDMI_SCHCR_color_transform_en(1)|
+                         HDMI_SCHCR_write_en11(0)|HDMI_SCHCR_ycbcr422_algo(0)|
+                         HDMI_SCHCR_write_en10(0)|HDMI_SCHCR_422_pixel_repeat(0)|
+                         HDMI_SCHCR_write_en9(0)|HDMI_SCHCR_vsyncpolin(0)|
+                         HDMI_SCHCR_write_en8(0)|HDMI_SCHCR_hsyncpolin(0)|
+                         HDMI_SCHCR_write_en7(1)|HDMI_SCHCR_vsyncpolinv(0)|
+                         HDMI_SCHCR_write_en6(1)|HDMI_SCHCR_hsyncpolinv(0)|
+                         HDMI_SCHCR_write_en5(1)|HDMI_SCHCR_pixelencycbcr422(0)|
+                         HDMI_SCHCR_write_en4(1)|HDMI_SCHCR_hdmi_videoxs(0)|
+                         HDMI_SCHCR_write_en3(1)|HDMI_SCHCR_pixelencfmt(Pixel_Colocr_Format)|
+                         HDMI_SCHCR_write_en2(1)|HDMI_SCHCR_pixelrepeat(0)|
+                         HDMI_SCHCR_write_en1(1)|HDMI_SCHCR_hdmi_modesel(1));
+    }
+
+    //0xb800d0f0
+    WRITE_REG_INT32U(HDMI_HDCP_KOWR, HDMI_HDCP_KOWR_hdcprekeykeepoutwin(0x2a));
+
+    //0xb800d000
+    WRITE_REG_INT32U(HDMI_INTEN,
+                     HDMI_INTEN_enriupdint(1)|
+                     HDMI_INTEN_enpjupdint(1)|
+                     HDMI_INTEN_write_data(0));
+
+    /*
+    if(DVI_or_HDMI) HDMI_gen_avi_infoframe(4, Pixel_Colocr_Format, xv_YCC);
+
+    if(DVI_or_HDMI && xv_YCC) HDMI_gen_metadata();
+
+    if(DVI_or_HDMI && Enable_3D) HDMI_gen_vendor_Specific_infoframe(1, Format_3D, 0, 0);
+    */
+
+    //0xb800d034
+    WRITE_REG_INT32U(HDMI_CR,
+                     HDMI_CR_write_en3(1)|HDMI_CR_tmds_encen(1)|
+                     HDMI_CR_write_en1(1)|HDMI_CR_enablehdmi(1));
+    return;
+}
+
+
+
+
+static irqreturn_t vo_irq_handler(int irq, void *dev_id)
+{
+   // vpu_drv_context_t *dev = (vpu_drv_context_t *)dev_id;
+
+ 
+    HDMI_ISR();
+    return IRQ_HANDLED;
+//	if(VE_Source)
+     if((READ_REG_INT32U(VO_V1)&0x2000000) != 0);
+	{
+
+			WRITE_REG_INT32U(VO_V1_MC_0, VO_V1_MC_0_int_mask(0)| VO_V1_MC_0_run(0));
+			WRITE_REG_INT32U(VO_V1_MC_4, VO_V1_MC_4_done(1));
+
+	}	
+
+	//0xb800d278
+                WRITE_REG_INT32U(HDMI_INTSTV,
+                                 HDMI_INTSTV_vendupdated(0)|
+                                 HDMI_INTSTV_vsyncupdated(0));
+     //0x98005e84
+                WRITE_REG_INT32U(VO_INTST,
+                                 VO_INTST_afbc_parser_fail(0)|
+                                 VO_INTST_afbc_decode_fail(0)|
+                                 VO_INTST_h_under(0)|
+                                 VO_INTST_i_under(0)|
+                                 VO_INTST_p_under(0)|
+                                 VO_INTST_sub2(0)|
+                                 VO_INTST_sub1(0)|
+                                 VO_INTST_wb2fin(0)|
+                                 VO_INTST_wb1fin(0)|
+                                 VO_INTST_m3fin(0)|
+                                 VO_INTST_m2fin(0)|
+                                 VO_INTST_m1fin(1)|
+                                 VO_INTST_write_data(0));
+/*
+	           //0x98005e84  cwww
+                WRITE_REG_INT32U(VO_INTEN,
+            
+                                 VO_INTEN_h_under(1)|
+                                 VO_INTEN_i_under(1)|
+                                 VO_INTEN_sub2(1)|
+                                 VO_INTEN_sub1(1)|
+                                 VO_INTEN_wb2fin(1)|
+                                 VO_INTEN_wb1fin(1)|
+                                 VO_INTEN_m3fin(1)|
+                                 VO_INTEN_m1fin(1)|
+                                 VO_INTEN_write_data(1));
+*/
+   //0x98005e84  cwww
+                WRITE_REG_INT32U(VO_INTEN,
+                                 VO_INTEN_m1fin(1)|
+                                 VO_INTEN_write_data(1));
+
+
+				
+                //0x98005020
+                WRITE_REG_INT32U(VO_FC,
+                                 VO_FC_wb2go(0)|
+                                 VO_FC_wb1go(0)|
+                                 VO_FC_mddgo(0)|
+                                 VO_FC_m2go(0)|
+                                 VO_FC_m1go(1)|
+                                 VO_FC_write_data(1));
+
+
+					if(VO_INTST_get_h_under(READ_REG_INT32U(VO_INTST)))
+        		{
+
+#if CW_DEBUG
+					 printf("#@@ VO_INTST:get h_under \n");
+#endif
+					//0x98005e84
+                        WRITE_REG_INT32U(VO_INTST,
+                                         VO_INTST_afbc_parser_fail(0)|
+                                         VO_INTST_afbc_decode_fail(0)|
+                                         VO_INTST_h_under(1)|
+                                         VO_INTST_i_under(0)|
+                                         VO_INTST_p_under(0)|
+                                         VO_INTST_sub2(0)|
+                                         VO_INTST_sub1(0)|
+                                         VO_INTST_wb2fin(0)|
+                                         VO_INTST_wb1fin(0)|
+                                         VO_INTST_m3fin(0)|
+                                         VO_INTST_m2fin(0)|
+                                         VO_INTST_m1fin(0)|
+                                         VO_INTST_write_data(0));
+	  		}
+    return IRQ_HANDLED;
+}
+
+
+
+
+
+
+
+
+
+
+static int vo_open(struct inode *inode, struct file *filp)
+{
+    printk(KERN_INFO "[TEST_VO][+] %s\n", __func__);
+    printk(KERN_INFO "[TEST_VO][-] %s\n", __func__);
+
+    return 0;
+}
+
+static int vo_release(struct inode *inode, struct file *filp)
+{
+    int ret = 0;
+
+    printk(KERN_INFO "[TEST_VO] vo_release\n");
+
+    return 0;
+}
+
+static int vo_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+    printk(KERN_INFO "In[%s][%d]", __FUNCTION__, __LINE__);
+    unsigned long pfn;
+
+    vm->vm_flags |= VM_IO | VM_RESERVED;
+    vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+    pfn = s_vo_register.phys_addr >> PAGE_SHIFT;
+
+    return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int hdmi_map_to_register(struct file *fp, struct vm_area_struct *vm)
+{
+    printk(KERN_INFO "In[%s][%d]", __FUNCTION__, __LINE__);
+    unsigned long pfn;
+
+    vm->vm_flags |= VM_IO | VM_RESERVED;
+    vm->vm_page_prot = pgprot_noncached(vm->vm_page_prot);
+    pfn = s_hdmi_register.phys_addr >> PAGE_SHIFT;
+
+    return remap_pfn_range(vm, vm->vm_start, pfn, vm->vm_end-vm->vm_start, vm->vm_page_prot) ? -EAGAIN : 0;
+}
+
+static int vo_mmap(struct file *fp, struct vm_area_struct *vm)
+{
+    printk(KERN_INFO "vm->vm_pgoff:0x%08x, (s_vo_register.phys_addr>>PAGE_SHIFT):0x%08x, (s_hdmi_register.phys_addr>>PAGE_SHIFT):0x%08x\n", vm->vm_pgoff, (s_vo_register.phys_addr>>PAGE_SHIFT), (s_hdmi_register.phys_addr>>PAGE_SHIFT));
+    if ((unsigned int)vm->vm_pgoff == (unsigned int)(s_vo_register.phys_addr>>PAGE_SHIFT))
+        return vo_map_to_register(fp, vm);
+    else
+        return hdmi_map_to_register(fp, vm);
+}
+
+struct file_operations vo_fops = {
+    .owner = THIS_MODULE,
+    .open = vo_open,
+    .release = vo_release,
+    .mmap = vo_mmap,
+};
+
+static int vo_probe(struct platform_device *pdev)
+{
+    int err = 0;
+    struct resource res;
+    printk(KERN_INFO "[TEST_VO] vo_probe\n");
+	int irq;
+    void __iomem *iobase;
+    struct device_node *node = pdev->dev.of_node;
+
+	void *hdmi_irq_dev_id = (void *)&s_hdmi_irq;   //cw:not sure
+
+
+    of_address_to_resource(node, 0, &res);
+    iobase = of_iomap(node, 0);
+
+    s_vo_register.phys_addr = res.start;
+    s_vo_register.virt_addr = (unsigned long)iobase;
+    s_vo_register.size = res.end - res.start + 1;
+
+	vo_virt_address = s_vo_register.virt_addr;
+	
+    printk(KERN_INFO "[TEST_VO] : vo base address get from DTB physical base addr=0x%x, virtual base=0x%x, size=0x%x\n", s_vo_register.phys_addr , s_vo_register.virt_addr, s_vo_register.size);
+
+    of_address_to_resource(node, 1, &res);
+    iobase = of_iomap(node, 1);
+
+    s_hdmi_register.phys_addr = res.start;
+    s_hdmi_register.virt_addr = (unsigned long)iobase;
+    s_hdmi_register.size = res.end - res.start + 1;
+
+	hdmi_virt_address = s_hdmi_register.virt_addr;
+	
+    printk(KERN_INFO "[TEST_VO] : hdmi base address get from DTB physical base addr=0x%x, virtual base=0x%x, size=0x%x\n", s_hdmi_register.phys_addr , s_hdmi_register.virt_addr, s_hdmi_register.size);
+
+    of_address_to_resource(node, 2, &res);
+    iobase = of_iomap(node, 2);
+
+    s_rbus_register.phys_addr = res.start;
+    s_rbus_register.virt_addr = (unsigned long)iobase;
+    s_rbus_register.size = res.end - res.start + 1;
+
+	rbus_virt_address = s_rbus_register.virt_addr;
+	
+    printk(KERN_INFO "[TEST_VO] : rbus base address get from DTB physical base addr=0x%x, virtual base=0x%x, size=0x%x\n", s_rbus_register.phys_addr , s_rbus_register.virt_addr, s_rbus_register.size);
+
+
+    irq = irq_of_parse_and_map(node, 0);
+    if (irq <= 0)
+        panic("Can't parse IRQ");
+
+    s_hdmi_irq = irq;
+    DPRINTK("s_hdmi_irq:%d want to register VO_ISR\n", s_hdmi_irq);
+
+   
+/*
+    irq = platform_get_irq(pdev, 0);
+    s_hdmi_irq = irq;
+*/
+	
+	
+    DPRINTK("platform_get_irq -> irq:%d\n", irq);
+    err = request_irq(s_hdmi_irq, vo_irq_handler, 0, "VO_HDMI_IRQ", (void *)(&hdmi_irq_dev_id));
+    if (err != 0)
+    {
+        if(err == -EINVAL)
+        {
+            printk(KERN_ERR "[VPUDRV] : Bad s_hdmi_irq number or handler\n");
+        }
+        else if(err == -EBUSY)
+        {
+            printk(KERN_ERR "[VPUDRV] : s_hdmi_irq <%d> busy, change your config\n", s_hdmi_irq);
+        }
+    }
+    
+    s_vo_dev.minor = MISC_DYNAMIC_MINOR;
+    s_vo_dev.name = "test_vo";
+    s_vo_dev.fops = &vo_fops;
+    s_vo_dev.parent = NULL;
+    if (misc_register(&s_vo_dev)) {
+        printk("TEST_VO: failed to register misc device.");
+        goto ERROR_PROVE_DEVICE;
+    }
+
+    static int temp = 0;
+    if (temp == 0) {
+        //SET_HDMI_Video_576p(0, 0, 0, 0, 0, 1, 0, 0);
+        SET_HDMI_Video_720p60(0, 0, 0, 0, 0, 1, 0, 0);
+        msleep(1);
+        temp=1;
+    }
+
+#if 0
+    brook_task = kthread_create(kbrook, &brook_data, "brook");
+    if (IS_ERR(brook_task)) {
+        brook_task = NULL;
+        printk("[%s %d] ERROR!\n",__func__,__LINE__);
+    } 
+
+    wake_up_process(brook_task);
+#endif
+    
+    //////
+	OSD_draw(1280, 720, 0x22000000);
+    //V1_draw(0);
+
+    // set hdmi
+	DPRINTK("SET_HDMI_Video_720p\n");
+
+    return 0;
+
+
+ERROR_PROVE_DEVICE:
+
+    misc_deregister(&s_vo_dev);
+
+    return err;
+}
+
+static int vo_remove(struct platform_device *pdev)
+{
+    printk(KERN_INFO "[TEST_VO] vo_remove\n");
+
+    misc_deregister(&s_vo_dev);
+
+    return 0;
+}
+
+static int __init vo_init(void)
+{
+    int res = 0;
+
+    printk(KERN_INFO "[TEST_VO] begin vo_init\n");
+
+    printk(KERN_INFO "[TEST_VO] end vo_init result=0x%x\n", res);
+    return res;
+}
+
+static void __exit vo_exit(void)
+{
+    printk(KERN_INFO "[TEST_VO] vo_exit\n");
+
+    return;
+}
+
+MODULE_AUTHOR("A customer using TEST_VO, Inc.");
+MODULE_DESCRIPTION("TEST_VO linux driver");
+MODULE_LICENSE("GPL");
+
+module_init(vo_init);
+module_exit(vo_exit);
+
+static const struct of_device_id rtk_vo_dt_match[] = {
+    { .compatible = "Realtek,rtk1295-test_vo" },
+    {}
+};
+MODULE_DEVICE_TABLE(of, rtk_vo_dt_match);
+
+static struct platform_driver rtk_vo_driver = {
+    .driver		= {
+        .name	= "rtk-test_vo",
+        .owner	= THIS_MODULE,
+        .of_match_table = rtk_vo_dt_match,
+    },
+    .probe		= vo_probe,
+    .remove		= vo_remove,
+};
+
+module_platform_driver(rtk_vo_driver);
diff --git a/drivers/video/fbdev/rtk/dc2fpga/dc2fpga.h b/drivers/video/fbdev/rtk/dc2fpga/dc2fpga.h
new file mode 100644
index 00000000..e6a4dac
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2fpga/dc2fpga.h
@@ -0,0 +1,8 @@
+#ifndef _FPGA_TEST_INCLUDED_
+#define _FPGA_TEST_INCLUDED_
+
+//int fpgaInit(void);
+//int fpgaShow(unsigned int width, unsigned int height, unsigned long pImage);
+int OSD_draw(unsigned int w, unsigned int h, unsigned long pImage);
+//int fpgaDeinit(void);
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2fpga/hdmi_reg.h b/drivers/video/fbdev/rtk/dc2fpga/hdmi_reg.h
new file mode 100644
index 00000000..4d53239
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2fpga/hdmi_reg.h
@@ -0,0 +1,5702 @@
+/**************************************************************
+// Spec Version                  : 2.1
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/6/12 18:5:44
+***************************************************************/
+
+
+#ifndef _HDMI_REG_H_INCLUDED_
+#define _HDMI_REG_H_INCLUDED_
+#ifdef  _HDMI_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     rxsenseint:1;
+unsigned int     enriupdint:1;
+unsigned int     enpjupdint:1;
+unsigned int     write_data:1;
+}HDMI_INTEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     vendint:1;
+unsigned int     vsyncint:1;
+unsigned int     write_data:1;
+}HDMI_INTENV;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     asfifo_empty:1;
+unsigned int     asfifo_full:1;
+unsigned int     owctshw:1;
+unsigned int     asfifoow:1;
+unsigned int     write_data:1;
+}HDMI_AUDIO_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     rxupdated:1;
+unsigned int     riupdated:1;
+unsigned int     pjupdated:1;
+}HDMI_INTST;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     vendupdated:1;
+unsigned int     vsyncupdated:1;
+}HDMI_INTSTV;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     wdout:1;
+unsigned int     Rxstatus:1;
+}HDMI_PHY_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_en2:1;
+unsigned int     rirate:8;
+unsigned int     write_en1:1;
+unsigned int     pjrate:8;
+}HDMI_UPDATE_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     sram_shut_down_en:1;
+unsigned int     sram_sleep_en:1;
+unsigned int     video_sd:1;
+unsigned int     Interlaced_vfmt:1;
+unsigned int     3D_video_format:4;
+unsigned int     En_3D:1;
+unsigned int     timing_gen_en:1;
+unsigned int     chl_sel:2;
+}HDMI_CHNL_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c1:17;
+}HDMI_CS_TRANS0;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c2:17;
+}HDMI_CS_TRANS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c3:17;
+}HDMI_CS_TRANS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c4:17;
+}HDMI_CS_TRANS3;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c5:17;
+}HDMI_CS_TRANS4;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c6:17;
+}HDMI_CS_TRANS5;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c7:17;
+}HDMI_CS_TRANS6;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c8:17;
+}HDMI_CS_TRANS7;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c9:17;
+}HDMI_CS_TRANS8;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     k1:16;
+}HDMI_CS_TRANS9;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     k2:16;
+}HDMI_CS_TRANS10;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     k3:16;
+}HDMI_CS_TRANS11;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en2:1;
+unsigned int     ygmax:12;
+unsigned int     reserved_1:3;
+unsigned int     write_en1:1;
+unsigned int     ygmin:12;
+}HDMI_CS_TRANS12;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en2:1;
+unsigned int     cbbmax:12;
+unsigned int     reserved_1:3;
+unsigned int     write_en1:1;
+unsigned int     cbbmin:12;
+}HDMI_CS_TRANS13;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en2:1;
+unsigned int     crrmax:12;
+unsigned int     reserved_1:3;
+unsigned int     write_en1:1;
+unsigned int     crrmin:12;
+}HDMI_CS_TRANS14;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en4:1;
+unsigned int     nor_v:2;
+unsigned int     write_en3:1;
+unsigned int     nor_h:2;
+unsigned int     write_en2:1;
+unsigned int     disp_v:2;
+unsigned int     write_en1:1;
+unsigned int     disp_h:2;
+}HDMI_SYNC_DLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     write_en3:1;
+unsigned int     tmds_encen:1;
+unsigned int     reserved_1:2;
+unsigned int     write_en1:1;
+unsigned int     enablehdmi:1;
+}HDMI_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en9:1;
+unsigned int     dp_vfch_num:2;
+unsigned int     reserved_1:2;
+unsigned int     write_en8:1;
+unsigned int     fp_swen:1;
+unsigned int     write_en7:1;
+unsigned int     fp:3;
+unsigned int     write_en6:1;
+unsigned int     pp_swen:1;
+unsigned int     reserved_2:2;
+unsigned int     write_en4:1;
+unsigned int     dp_swen:1;
+unsigned int     write_en3:1;
+unsigned int     default_phase:1;
+unsigned int     reserved_3:3;
+unsigned int     write_en2:1;
+unsigned int     color_depth:4;
+unsigned int     reserved_4:2;
+unsigned int     write_en1:1;
+unsigned int     dpc_enable:1;
+}HDMI_DPC;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_en2:1;
+unsigned int     dp_vfch:1;
+unsigned int     reserved_1:3;
+unsigned int     write_en1:1;
+unsigned int     pp:4;
+}HDMI_DPC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     tmds_ch2_out:10;
+unsigned int     tmds_ch1_out:10;
+unsigned int     tmds_ch0_out:10;
+}HDMI_TMDS_EODR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     default_phase_st:1;
+unsigned int     reserved_1:2;
+unsigned int     tmds_clk_out:10;
+}HDMI_TMDS_EODR1;
+
+typedef struct 
+{
+unsigned int     tmds1ten:1;
+unsigned int     td1src:1;
+unsigned int     reserved_0:4;
+unsigned int     tmds1td:10;
+unsigned int     tmds0ten:1;
+unsigned int     td0src:1;
+unsigned int     reserved_1:4;
+unsigned int     tmds0td:10;
+}HDMI_TMDS_STR0;
+
+typedef struct 
+{
+unsigned int     tmdscten:1;
+unsigned int     tdcsrc:1;
+unsigned int     reserved_0:4;
+unsigned int     tmdsctd:10;
+unsigned int     tmds2ten:1;
+unsigned int     td2src:1;
+unsigned int     reserved_1:4;
+unsigned int     tmds2td:10;
+}HDMI_TMDS_STR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en8:1;
+unsigned int     ycbcr422_8bits:1;
+unsigned int     write_en7:1;
+unsigned int     cts_pkt_hp:1;
+unsigned int     write_en6:1;
+unsigned int     Audioheader0:8;
+unsigned int     write_en5:1;
+unsigned int     samplepresent:4;
+unsigned int     write_en4:1;
+unsigned int     forcesamplepresent:1;
+unsigned int     write_en3:1;
+unsigned int     b_frame:4;
+unsigned int     write_en2:1;
+unsigned int     forceb_frame:1;
+unsigned int     write_en1:1;
+unsigned int     audiolayout:1;
+}HDMI_ASPCR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_en4:1;
+unsigned int     hdmi_pk3map:3;
+unsigned int     write_en3:1;
+unsigned int     hdmi_pk2map:3;
+unsigned int     write_en2:1;
+unsigned int     hdmi_pk1map:3;
+unsigned int     write_en1:1;
+unsigned int     hdmi_pk0map:3;
+}HDMI_ACACR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en6:1;
+unsigned int     Audio_info_hp:1;
+unsigned int     write_en5:1;
+unsigned int     ac_hw_ctrl_en:1;
+unsigned int     write_en4:1;
+unsigned int     fs_div4:1;
+unsigned int     write_en3:1;
+unsigned int     disablecrp:1;
+unsigned int     write_en2:1;
+unsigned int     cts_source:1;
+unsigned int     write_en1:1;
+unsigned int     n_value:20;
+}HDMI_ACRPCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     ctssw:20;
+}HDMI_ACRPCTSR;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     ctshw:20;
+}HDMI_ACRPPR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     enablegcp:1;
+unsigned int     gcp_clearavmute:1;
+unsigned int     gcp_setavmute:1;
+unsigned int     write_data:1;
+}HDMI_GCPCR;
+
+typedef struct 
+{
+unsigned int     once_pkt:32;
+}HDMI_ORP6PH;
+
+typedef struct 
+{
+unsigned int     once_pkt:32;
+}HDMI_ORP6W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en6:1;
+unsigned int     prp5period:4;
+unsigned int     write_en5:1;
+unsigned int     prp4period:4;
+unsigned int     write_en4:1;
+unsigned int     prp3period:4;
+unsigned int     write_en3:1;
+unsigned int     prp2period:4;
+unsigned int     write_en2:1;
+unsigned int     prp1period:4;
+unsigned int     write_en1:1;
+unsigned int     prp0period:4;
+}HDMI_RPCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     enprpkt5:1;
+unsigned int     enprpkt4:1;
+unsigned int     enprpkt3:1;
+unsigned int     enprpkt2:1;
+unsigned int     enprpkt1:1;
+unsigned int     enprpkt0:1;
+unsigned int     write_data:1;
+}HDMI_RPEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     isramrbd:18;
+}HDMI_RPRBDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     write_en4:1;
+unsigned int     enrbpktsram:1;
+unsigned int     write_en3:1;
+unsigned int     wrdes:1;
+unsigned int     write_en2:1;
+unsigned int     rprwcmd:1;
+unsigned int     write_en1:1;
+unsigned int     rpadd:8;
+}HDMI_OPCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_en2:1;
+unsigned int     vbidipcnt:7;
+unsigned int     write_en1:1;
+unsigned int     hbidipcnt:7;
+}HDMI_DIPCCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     write_en2:1;
+unsigned int     FSM_mod:1;
+unsigned int     write_en1:1;
+unsigned int     hblank_pixel2tmds:14;
+}HDMI_DIPCCR_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en2:1;
+unsigned int     hblank_cnt_wait_st:14;
+unsigned int     write_en1:1;
+unsigned int     hblank_cnt_island_st:14;
+}HDMI_DIPCCR_3;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en12:1;
+unsigned int     color_transform_en:1;
+unsigned int     write_en11:1;
+unsigned int     ycbcr422_algo:1;
+unsigned int     write_en10:1;
+unsigned int     422_pixel_repeat:1;
+unsigned int     write_en9:1;
+unsigned int     vsyncpolin:1;
+unsigned int     write_en8:1;
+unsigned int     hsyncpolin:1;
+unsigned int     write_en7:1;
+unsigned int     vsyncpolinv:1;
+unsigned int     write_en6:1;
+unsigned int     hsyncpolinv:1;
+unsigned int     write_en5:1;
+unsigned int     pixelencycbcr422:1;
+unsigned int     write_en4:1;
+unsigned int     hdmi_videoxs:5;
+unsigned int     write_en3:1;
+unsigned int     pixelencfmt:2;
+unsigned int     write_en2:1;
+unsigned int     pixelrepeat:1;
+unsigned int     write_en1:1;
+unsigned int     hdmi_modesel:1;
+}HDMI_SCHCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en3:1;
+unsigned int     enaudio:1;
+unsigned int     write_en2:1;
+unsigned int     envitd:1;
+unsigned int     write_en1:1;
+unsigned int     vitd:24;
+}HDMI_ICR;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     write_en1:1;
+unsigned int     vitd:12;
+}HDMI_ICR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     write_en2:1;
+unsigned int     crcmode:1;
+unsigned int     write_en1:1;
+unsigned int     crcchsel:2;
+}HDMI_CRCCR;
+
+typedef struct 
+{
+unsigned int     crcvalue:32;
+}HDMI_CRCDOR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     hdcprekeykeepoutwin:8;
+}HDMI_HDCP_KOWR;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     hdcpverkeepoutwinend:12;
+unsigned int     write_en1:1;
+unsigned int     hdcpvertkeepoutwinstart:12;
+}HDMI_HDCP_KOWRSE;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     hdcpoppwinend:12;
+unsigned int     write_en1:1;
+unsigned int     hdcpoppwinstart:12;
+}HDMI_HDCP_OWR;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en6:1;
+unsigned int     avmute_sel:1;
+unsigned int     write_en5:1;
+unsigned int     enablehdcp:1;
+unsigned int     write_en4:1;
+unsigned int     en1_1_feature:1;
+unsigned int     write_en3:1;
+unsigned int     downstrisrepeater:1;
+unsigned int     write_en2:1;
+unsigned int     aninfluencemode:1;
+unsigned int     write_en1:1;
+unsigned int     hdcp_encryptenable:1;
+}HDMI_HDCP_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_en9:1;
+unsigned int     ddpken:1;
+unsigned int     write_en8:1;
+unsigned int     resetkmacc:1;
+unsigned int     write_en7:1;
+unsigned int     update_an:1;
+unsigned int     write_en6:1;
+unsigned int     aninfreq:1;
+unsigned int     write_en5:1;
+unsigned int     seedload:1;
+unsigned int     write_en4:1;
+unsigned int     deviceauthenticated:1;
+unsigned int     write_en3:1;
+unsigned int     forcetounauthenticated:1;
+unsigned int     write_en2:1;
+unsigned int     authcompute:1;
+unsigned int     write_en1:1;
+unsigned int     authrequest:1;
+}HDMI_HDCP_AUTH;
+
+typedef struct 
+{
+unsigned int     hdcpcipherstate:8;
+unsigned int     reserved_0:20;
+unsigned int     curdpkaccdone:1;
+unsigned int     hdcp_encrypt_status:1;
+unsigned int     authenticatedok:1;
+unsigned int     anready:1;
+}HDMI_HDCP_SR;
+
+typedef struct 
+{
+unsigned int     anlsw:32;
+}HDMI_HDCP_ANLR;
+
+typedef struct 
+{
+unsigned int     anmsw:32;
+}HDMI_HDCP_ANMR;
+
+typedef struct 
+{
+unsigned int     aninfluencelsw:32;
+}HDMI_HDCP_ANILR;
+
+typedef struct 
+{
+unsigned int     aninfluencemsw:32;
+}HDMI_HDCP_ANIMR;
+
+typedef struct 
+{
+unsigned int     ddpklsb24:24;
+unsigned int     dpkencpnt:8;
+}HDMI_HDCP_DPKLR;
+
+typedef struct 
+{
+unsigned int     ddpkmsw:32;
+}HDMI_HDCP_DPKMR;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ri:16;
+unsigned int     pj:8;
+}HDMI_HDCP_LIR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     shastart:1;
+unsigned int     shafirst:1;
+unsigned int     rstshaptr:1;
+unsigned int     write_data:1;
+}HDMI_HDCP_SHACR;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     vmatch:1;
+unsigned int     shaready:1;
+}HDMI_HDCP_SHARR;
+
+typedef struct 
+{
+unsigned int     sha_data:32;
+}HDMI_HDCP_SHADR;
+
+typedef struct 
+{
+unsigned int     milsw:32;
+}HDMI_HDCP_MILSW;
+
+typedef struct 
+{
+unsigned int     mimsw:32;
+}HDMI_HDCP_MIMSW;
+
+typedef struct 
+{
+unsigned int     kmlsw:32;
+}HDMI_HDCP_KMLSW;
+
+typedef struct 
+{
+unsigned int     kmmsw:32;
+}HDMI_HDCP_KMMSW;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_en5:1;
+unsigned int     pkt_vdo_cnt_add:1;
+unsigned int     write_en4:1;
+unsigned int     hdcp_2_2_en:1;
+unsigned int     write_en3:1;
+unsigned int     aes_sw_en:1;
+unsigned int     write_en2:1;
+unsigned int     aes_sw_start1:1;
+unsigned int     write_en1:1;
+unsigned int     aes_sw_start2:1;
+}HDMI_HDCP_2_2_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     rgs_sw_done_1:1;
+unsigned int     rgs_sw_done_2:1;
+}HDMI_HDCP_2_2_STATUS;
+
+typedef struct 
+{
+unsigned int     sw_data_1_1:32;
+}HDMI_HDCP_2_2_SW_DATA_1_1;
+
+typedef struct 
+{
+unsigned int     sw_data_1_2:32;
+}HDMI_HDCP_2_2_SW_DATA_1_2;
+
+typedef struct 
+{
+unsigned int     sw_data_1_3:32;
+}HDMI_HDCP_2_2_SW_DATA_1_3;
+
+typedef struct 
+{
+unsigned int     sw_data_1_4:32;
+}HDMI_HDCP_2_2_SW_DATA_1_4;
+
+typedef struct 
+{
+unsigned int     sw_data_2_1:32;
+}HDMI_HDCP_2_2_SW_DATA_2_1;
+
+typedef struct 
+{
+unsigned int     sw_data_2_2:32;
+}HDMI_HDCP_2_2_SW_DATA_2_2;
+
+typedef struct 
+{
+unsigned int     sw_data_2_3:32;
+}HDMI_HDCP_2_2_SW_DATA_2_3;
+
+typedef struct 
+{
+unsigned int     sw_data_2_4:32;
+}HDMI_HDCP_2_2_SW_DATA_2_4;
+
+typedef struct 
+{
+unsigned int     sw_key_1_1:32;
+}HDMI_HDCP_2_2_SW_KEY_1_1;
+
+typedef struct 
+{
+unsigned int     sw_key_1_2:32;
+}HDMI_HDCP_2_2_SW_KEY_1_2;
+
+typedef struct 
+{
+unsigned int     sw_key_1_3:32;
+}HDMI_HDCP_2_2_SW_KEY_1_3;
+
+typedef struct 
+{
+unsigned int     sw_key_1_4:32;
+}HDMI_HDCP_2_2_SW_KEY_1_4;
+
+typedef struct 
+{
+unsigned int     sw_key_2_1:32;
+}HDMI_HDCP_2_2_SW_KEY_2_1;
+
+typedef struct 
+{
+unsigned int     sw_key_2_2:32;
+}HDMI_HDCP_2_2_SW_KEY_2_2;
+
+typedef struct 
+{
+unsigned int     sw_key_2_3:32;
+}HDMI_HDCP_2_2_SW_KEY_2_3;
+
+typedef struct 
+{
+unsigned int     sw_key_2_4:32;
+}HDMI_HDCP_2_2_SW_KEY_2_4;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_1_1:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_1_1;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_1_2:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_1_2;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_1_3:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_1_3;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_1_4:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_1_4;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_2_1:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_2_1;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_2_2:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_2_2;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_2_3:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_2_3;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_2_4:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_2_4;
+
+typedef struct 
+{
+unsigned int     data_out_1_1:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_1_1;
+
+typedef struct 
+{
+unsigned int     data_out_1_2:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_1_2;
+
+typedef struct 
+{
+unsigned int     data_out_1_3:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_1_3;
+
+typedef struct 
+{
+unsigned int     data_out_1_4:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_1_4;
+
+typedef struct 
+{
+unsigned int     data_out_2_1:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_2_1;
+
+typedef struct 
+{
+unsigned int     data_out_2_2:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_2_2;
+
+typedef struct 
+{
+unsigned int     data_out_2_3:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_2_3;
+
+typedef struct 
+{
+unsigned int     data_out_2_4:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_2_4;
+
+typedef struct 
+{
+unsigned int     hw_riv_1_1:32;
+}HDMI_HDCP_2_2_HW_RIV_1;
+
+typedef struct 
+{
+unsigned int     hw_riv_1_2:32;
+}HDMI_HDCP_2_2_HW_RIV_2;
+
+typedef struct 
+{
+unsigned int     frame_num_1:32;
+}HDMI_HDCP_2_2_HW_FRAME_NUM_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     frame_num_2:6;
+}HDMI_HDCP_2_2_HW_FRAME_NUM_2;
+
+typedef struct 
+{
+unsigned int     frame_num_add_1:32;
+}HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     frame_num_add_2:6;
+}HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     data_num:26;
+}HDMI_HDCP_2_2_HW_DATA_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     data_num_add:26;
+}HDMI_HDCP_2_2_HW_DATA_NUM_ADD;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en2:1;
+unsigned int     free_run_mod_en:1;
+unsigned int     write_en1:1;
+unsigned int     keep_out_win:26;
+}HDMI_HDCP_2_2_HW_FREE_RUN;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     chsel0:5;
+unsigned int     chsel1:5;
+}HDMI_DBG;
+
+typedef struct 
+{
+unsigned int     dummy:32;
+}HDMI_DUMMY;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     test_mode:1;
+unsigned int     data_realign:1;
+}HDMI_PHY;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hblank:14;
+unsigned int     reserved_1:2;
+unsigned int     hactive:14;
+}HDMI_H_PARA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hsync:14;
+unsigned int     reserved_1:2;
+unsigned int     hfront:14;
+}HDMI_H_PARA2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     hback:14;
+}HDMI_H_PARA3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vact_video:14;
+unsigned int     reserved_1:2;
+unsigned int     vactive:14;
+}HDMI_V_PARA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vact_space1:14;
+unsigned int     reserved_1:2;
+unsigned int     Vact_space:14;
+}HDMI_V_PARA2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vblank3:14;
+unsigned int     reserved_1:2;
+unsigned int     Vact_space2:14;
+}HDMI_V_PARA3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vsync:14;
+unsigned int     reserved_1:2;
+unsigned int     vblank:14;
+}HDMI_V_PARA4;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vback:14;
+unsigned int     reserved_1:2;
+unsigned int     vfront:14;
+}HDMI_V_PARA5;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vsync1:14;
+unsigned int     reserved_1:2;
+unsigned int     Vblank1:14;
+}HDMI_V_PARA6;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vback1:14;
+unsigned int     reserved_1:2;
+unsigned int     Vfront1:14;
+}HDMI_V_PARA7;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vsync2:14;
+unsigned int     reserved_1:2;
+unsigned int     Vblank2:14;
+}HDMI_V_PARA8;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vback2:14;
+unsigned int     reserved_1:2;
+unsigned int     Vfront2:14;
+}HDMI_V_PARA9;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vsynci:14;
+unsigned int     reserved_1:2;
+unsigned int     vblanki:14;
+}HDMI_V_PARA12;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vbacki:14;
+unsigned int     reserved_1:2;
+unsigned int     vfronti:14;
+}HDMI_V_PARA13;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     G:12;
+}HDMI_V_PARA10;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     B:12;
+unsigned int     reserved_1:4;
+unsigned int     R:12;
+}HDMI_V_PARA11;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     interlace_field:1;
+}HDMI_TIMING_GEN_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     ls:1;
+unsigned int     dft_test_resume:1;
+unsigned int     dft_bist_mode:1;
+unsigned int     bist_mode:1;
+unsigned int     rme:1;
+unsigned int     rm:4;
+}HDMI_BIST1_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     ls:1;
+unsigned int     dft_test_resume:1;
+unsigned int     dft_bist_mode:1;
+unsigned int     bist_mode:1;
+unsigned int     rme:1;
+unsigned int     rm:4;
+}HDMI_BIST2_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     bist1_fail0:1;
+unsigned int     bist1_done:1;
+}HDMI_BIST1_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_bist1_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_bist1_fail0:1;
+unsigned int     drf_bist1_done:1;
+}HDMI_DRF_BIST1_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     bist2_fail0:1;
+unsigned int     bist2_done:1;
+}HDMI_BIST2_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_bist2_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_bist2_fail0:1;
+unsigned int     drf_bist2_done:1;
+}HDMI_DRF_BIST2_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     ls:1;
+unsigned int     dft_test_resume:1;
+unsigned int     dft_bist_mode:1;
+unsigned int     bist_mode:1;
+unsigned int     rme:1;
+unsigned int     rm:4;
+}HDMI_BIST3_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     bist3_fail0:1;
+unsigned int     bist3_done:1;
+}HDMI_BIST3_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_bist3_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_bist3_fail0:1;
+unsigned int     drf_bist3_done:1;
+}HDMI_DRF_BIST3_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_en7:1;
+unsigned int     xor_pixel_sel_di:3;
+unsigned int     write_en6:1;
+unsigned int     mhl_pp_ch1sel:1;
+unsigned int     write_en5:1;
+unsigned int     mhl_phy_test_mode:1;
+unsigned int     write_en4:1;
+unsigned int     xor_pixel_sel:3;
+unsigned int     write_en3:1;
+unsigned int     mhl_enc_sel:1;
+unsigned int     write_en2:1;
+unsigned int     mhl_pp_mode:1;
+unsigned int     write_en1:1;
+unsigned int     mhl_enable:1;
+}HDMI_MHLCTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     write_en3:1;
+unsigned int     mhl_ch_sel:1;
+unsigned int     write_en2:1;
+unsigned int     hdmi_chcclk_swap:1;
+unsigned int     write_en1:1;
+unsigned int     hdmi_chab_swap:1;
+}HDMI_CHSWAP;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     write_en2:1;
+unsigned int     hdmi_prefifo_inv:1;
+unsigned int     write_en1:1;
+unsigned int     async_update:1;
+}HDMI_PREFIFO_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     write_en5:1;
+unsigned int     data_pola_inv:1;
+unsigned int     write_en4:1;
+unsigned int     hdmi_chclk_data_swap:2;
+unsigned int     write_en3:1;
+unsigned int     hdmi_chc_data_swap:2;
+unsigned int     write_en2:1;
+unsigned int     hdmi_chb_data_swap:2;
+unsigned int     write_en1:1;
+unsigned int     hdmi_cha_data_swap:2;
+}HDMI_PHYCHCRTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     write_en4:1;
+unsigned int     chclk_div4_en:1;
+unsigned int     write_en3:1;
+unsigned int     scrmbl_en:1;
+unsigned int     write_en2:1;
+unsigned int     ycbcr420_hlfp:1;
+unsigned int     write_en1:1;
+unsigned int     ycbcr420:1;
+}HDMI_HDMI_2_0_CTRL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en2:1;
+unsigned int     sscp_hpxl:14;
+unsigned int     reserved_1:1;
+unsigned int     write_en1:1;
+unsigned int     sscp_vline:14;
+}HDMI_HDMI_2_0_CTRL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     sync_polarity:1;
+unsigned int     sync_source:1;
+unsigned int     reserved_1:1;
+unsigned int     extend_mode:1;
+unsigned int     24bit_en:1;
+unsigned int     mhl3_en:1;
+}HDMI_MHL3_REG1;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     fifo_cnt:7;
+}HDMI_MHL3_REG2;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     cp_fifo_reach_size:7;
+unsigned int     reserved_1:1;
+unsigned int     htotal_fifo_reach_size:7;
+unsigned int     reserved_2:1;
+unsigned int     blank_fifo_reach_size:7;
+unsigned int     reserved_3:1;
+unsigned int     video_fifo_reach_size:7;
+}HDMI_MHL3_REG3;
+
+typedef struct 
+{
+unsigned int     payload_blank_16bit:8;
+unsigned int     payload_blank_24bit:8;
+unsigned int     payload_video_16bit:8;
+unsigned int     payload_video_24bit:8;
+}HDMI_MHL3_REG4;
+
+typedef struct 
+{
+unsigned int     payload_cp_16bit:8;
+unsigned int     payload_cp_24bit:8;
+unsigned int     payload_htotal_16bit:8;
+unsigned int     payload_htotal_24bit:8;
+}HDMI_MHL3_REG5;
+
+typedef struct 
+{
+unsigned int     gap_blank_16bit:8;
+unsigned int     gap_blank_24bit:8;
+unsigned int     gap_video_16bit:8;
+unsigned int     gap_video_24bit:8;
+}HDMI_MHL3_REG6;
+
+typedef struct 
+{
+unsigned int     gap_cp_16bit:8;
+unsigned int     gap_cp_24bit:8;
+unsigned int     gap_htotal_16bit:8;
+unsigned int     gap_htotal_24bit:8;
+}HDMI_MHL3_REG7;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     tmds_en:1;
+unsigned int     cp_en:1;
+unsigned int     rr_en:1;
+}HDMI_MHL3_REG8;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     avlink_data:10;
+unsigned int     avlink_duration:8;
+unsigned int     reserved_1:2;
+unsigned int     avlink_fixed8_alg:1;
+unsigned int     avlink_bitwise_inv:2;
+unsigned int     avlink_pattern:2;
+unsigned int     avlink_bist_en:1;
+}HDMI_MHL3_REG9;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     rme:1;
+unsigned int     rm:4;
+unsigned int     reserved_1:4;
+unsigned int     ls:1;
+unsigned int     drf_resume:1;
+unsigned int     drf_bist_mode:1;
+unsigned int     bist_mode:1;
+}HDMI_MHL3_REG10;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     bist_fail:1;
+unsigned int     bist_done:1;
+}HDMI_MHL3_REG11;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_bist_fail:1;
+unsigned int     drf_bist_done:1;
+}HDMI_MHL3_REG12;
+
+typedef struct 
+{
+unsigned int     built_in_b:8;
+unsigned int     built_in_g:8;
+unsigned int     built_in_r:8;
+unsigned int     reserved_0:4;
+unsigned int     built_in_video_type:3;
+unsigned int     built_in_video_en:1;
+}HDMI_MHL3_REG13;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     vactive_front:14;
+}HDMI_MHL3_REG14;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     vactive_back:14;
+}HDMI_MHL3_REG15;
+
+typedef struct 
+{
+unsigned int     dummy:32;
+}HDMI_MHL3_REG16;
+
+typedef struct 
+{
+unsigned int     dummy:16;
+unsigned int     dbg1_sel:4;
+unsigned int     dbg0_sel:4;
+unsigned int     reserved_0:6;
+unsigned int     pwr_dis:1;
+unsigned int     dbg_en:1;
+}HDMI_MHL3_REG17;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     start_en:1;
+unsigned int     reserved_1:2;
+unsigned int     start_line:14;
+}HDMI_MHL3_REG18;
+
+typedef struct 
+{
+unsigned int     hdcp2p2_streamctr:32;
+}HDMI_MHL3_REG19;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     hdcp2p2_stream_id:8;
+}HDMI_MHL3_REG20;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     hdcp2p2_mhl3_sel:1;
+}HDMI_MHL3_REG21;
+
+typedef struct 
+{
+unsigned int     hdcp2p2_header_ext:32;
+}HDMI_MHL3_REG22;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     hdcp2p2_cp_crc_method:1;
+unsigned int     hdcp2p2_cp_crc_rev:1;
+unsigned int     hdcp2p2_cp_crc_inv:1;
+unsigned int     hdcp2p2_cp_crc_rev2:1;
+}HDMI_MHL3_REG23;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     link_st:12;
+unsigned int     reserved_1:12;
+unsigned int     bist_fixed8_status:1;
+unsigned int     bist_prbs_status:1;
+unsigned int     fifo_full_status:1;
+unsigned int     fifo_full_clr:1;
+}HDMI_MHL3_REG24;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     cp_pos_adj:14;
+}HDMI_MHL3_REG25;
+
+#endif
+
+#define HDMI_INTEN                                                                   0x9800D000
+#define HDMI_INTEN_reg_addr                                                          "0xD800D000"
+#define HDMI_INTEN_reg                                                               0xD800D000
+#define set_HDMI_INTEN_reg(data)   (*((volatile unsigned int*) HDMI_INTEN_reg)=data)
+#define get_HDMI_INTEN_reg   (*((volatile unsigned int*) HDMI_INTEN_reg))
+#define HDMI_INTEN_inst_adr                                                          "0x0000"
+#define HDMI_INTEN_inst                                                              0x0000
+#define HDMI_INTEN_rxsenseint_shift                                                  (3)
+#define HDMI_INTEN_rxsenseint_mask                                                   (0x00000008)
+#define HDMI_INTEN_rxsenseint(data)                                                  (0x00000008&((data)<<3))
+#define HDMI_INTEN_rxsenseint_src(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_INTEN_get_rxsenseint(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_INTEN_enriupdint_shift                                                  (2)
+#define HDMI_INTEN_enriupdint_mask                                                   (0x00000004)
+#define HDMI_INTEN_enriupdint(data)                                                  (0x00000004&((data)<<2))
+#define HDMI_INTEN_enriupdint_src(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_INTEN_get_enriupdint(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_INTEN_enpjupdint_shift                                                  (1)
+#define HDMI_INTEN_enpjupdint_mask                                                   (0x00000002)
+#define HDMI_INTEN_enpjupdint(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_INTEN_enpjupdint_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_INTEN_get_enpjupdint(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_INTEN_write_data_shift                                                  (0)
+#define HDMI_INTEN_write_data_mask                                                   (0x00000001)
+#define HDMI_INTEN_write_data(data)                                                  (0x00000001&((data)<<0))
+#define HDMI_INTEN_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define HDMI_INTEN_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define HDMI_INTENV                                                                  0x9800D274
+#define HDMI_INTENV_reg_addr                                                         "0xD800D274"
+#define HDMI_INTENV_reg                                                              0xD800D274
+#define set_HDMI_INTENV_reg(data)   (*((volatile unsigned int*) HDMI_INTENV_reg)=data)
+#define get_HDMI_INTENV_reg   (*((volatile unsigned int*) HDMI_INTENV_reg))
+#define HDMI_INTENV_inst_adr                                                         "0x009D"
+#define HDMI_INTENV_inst                                                             0x009D
+#define HDMI_INTENV_vendint_shift                                                    (2)
+#define HDMI_INTENV_vendint_mask                                                     (0x00000004)
+#define HDMI_INTENV_vendint(data)                                                    (0x00000004&((data)<<2))
+#define HDMI_INTENV_vendint_src(data)                                                ((0x00000004&(data))>>2)
+#define HDMI_INTENV_get_vendint(data)                                                ((0x00000004&(data))>>2)
+#define HDMI_INTENV_vsyncint_shift                                                   (1)
+#define HDMI_INTENV_vsyncint_mask                                                    (0x00000002)
+#define HDMI_INTENV_vsyncint(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_INTENV_vsyncint_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTENV_get_vsyncint(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTENV_write_data_shift                                                 (0)
+#define HDMI_INTENV_write_data_mask                                                  (0x00000001)
+#define HDMI_INTENV_write_data(data)                                                 (0x00000001&((data)<<0))
+#define HDMI_INTENV_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define HDMI_INTENV_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define HDMI_AUDIO_ST                                                                0x9800D004
+#define HDMI_AUDIO_ST_reg_addr                                                       "0xD800D004"
+#define HDMI_AUDIO_ST_reg                                                            0xD800D004
+#define set_HDMI_AUDIO_ST_reg(data)   (*((volatile unsigned int*) HDMI_AUDIO_ST_reg)=data)
+#define get_HDMI_AUDIO_ST_reg   (*((volatile unsigned int*) HDMI_AUDIO_ST_reg))
+#define HDMI_AUDIO_ST_inst_adr                                                       "0x0001"
+#define HDMI_AUDIO_ST_inst                                                           0x0001
+#define HDMI_AUDIO_ST_asfifo_empty_shift                                             (4)
+#define HDMI_AUDIO_ST_asfifo_empty_mask                                              (0x00000010)
+#define HDMI_AUDIO_ST_asfifo_empty(data)                                             (0x00000010&((data)<<4))
+#define HDMI_AUDIO_ST_asfifo_empty_src(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_AUDIO_ST_get_asfifo_empty(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_AUDIO_ST_asfifo_full_shift                                              (3)
+#define HDMI_AUDIO_ST_asfifo_full_mask                                               (0x00000008)
+#define HDMI_AUDIO_ST_asfifo_full(data)                                              (0x00000008&((data)<<3))
+#define HDMI_AUDIO_ST_asfifo_full_src(data)                                          ((0x00000008&(data))>>3)
+#define HDMI_AUDIO_ST_get_asfifo_full(data)                                          ((0x00000008&(data))>>3)
+#define HDMI_AUDIO_ST_owctshw_shift                                                  (2)
+#define HDMI_AUDIO_ST_owctshw_mask                                                   (0x00000004)
+#define HDMI_AUDIO_ST_owctshw(data)                                                  (0x00000004&((data)<<2))
+#define HDMI_AUDIO_ST_owctshw_src(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_AUDIO_ST_get_owctshw(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_AUDIO_ST_asfifoow_shift                                                 (1)
+#define HDMI_AUDIO_ST_asfifoow_mask                                                  (0x00000002)
+#define HDMI_AUDIO_ST_asfifoow(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_AUDIO_ST_asfifoow_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_AUDIO_ST_get_asfifoow(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_AUDIO_ST_write_data_shift                                               (0)
+#define HDMI_AUDIO_ST_write_data_mask                                                (0x00000001)
+#define HDMI_AUDIO_ST_write_data(data)                                               (0x00000001&((data)<<0))
+#define HDMI_AUDIO_ST_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_AUDIO_ST_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_INTST                                                                   0x9800D008
+#define HDMI_INTST_reg_addr                                                          "0xD800D008"
+#define HDMI_INTST_reg                                                               0xD800D008
+#define set_HDMI_INTST_reg(data)   (*((volatile unsigned int*) HDMI_INTST_reg)=data)
+#define get_HDMI_INTST_reg   (*((volatile unsigned int*) HDMI_INTST_reg))
+#define HDMI_INTST_inst_adr                                                          "0x0002"
+#define HDMI_INTST_inst                                                              0x0002
+#define HDMI_INTST_rxupdated_shift                                                   (2)
+#define HDMI_INTST_rxupdated_mask                                                    (0x00000004)
+#define HDMI_INTST_rxupdated(data)                                                   (0x00000004&((data)<<2))
+#define HDMI_INTST_rxupdated_src(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_INTST_get_rxupdated(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_INTST_riupdated_shift                                                   (1)
+#define HDMI_INTST_riupdated_mask                                                    (0x00000002)
+#define HDMI_INTST_riupdated(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_INTST_riupdated_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTST_get_riupdated(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTST_pjupdated_shift                                                   (0)
+#define HDMI_INTST_pjupdated_mask                                                    (0x00000001)
+#define HDMI_INTST_pjupdated(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_INTST_pjupdated_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_INTST_get_pjupdated(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_INTSTV                                                                  0x9800D278
+#define HDMI_INTSTV_reg_addr                                                         "0xD800D278"
+#define HDMI_INTSTV_reg                                                              0xD800D278
+#define set_HDMI_INTSTV_reg(data)   (*((volatile unsigned int*) HDMI_INTSTV_reg)=data)
+#define get_HDMI_INTSTV_reg   (*((volatile unsigned int*) HDMI_INTSTV_reg))
+#define HDMI_INTSTV_inst_adr                                                         "0x009E"
+#define HDMI_INTSTV_inst                                                             0x009E
+#define HDMI_INTSTV_vendupdated_shift                                                (1)
+#define HDMI_INTSTV_vendupdated_mask                                                 (0x00000002)
+#define HDMI_INTSTV_vendupdated(data)                                                (0x00000002&((data)<<1))
+#define HDMI_INTSTV_vendupdated_src(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_INTSTV_get_vendupdated(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_INTSTV_vsyncupdated_shift                                               (0)
+#define HDMI_INTSTV_vsyncupdated_mask                                                (0x00000001)
+#define HDMI_INTSTV_vsyncupdated(data)                                               (0x00000001&((data)<<0))
+#define HDMI_INTSTV_vsyncupdated_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_INTSTV_get_vsyncupdated(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_PHY_STATUS                                                              0x9800D15c
+#define HDMI_PHY_STATUS_reg_addr                                                     "0xD800D15C"
+#define HDMI_PHY_STATUS_reg                                                          0xD800D15C
+#define set_HDMI_PHY_STATUS_reg(data)   (*((volatile unsigned int*) HDMI_PHY_STATUS_reg)=data)
+#define get_HDMI_PHY_STATUS_reg   (*((volatile unsigned int*) HDMI_PHY_STATUS_reg))
+#define HDMI_PHY_STATUS_inst_adr                                                     "0x0057"
+#define HDMI_PHY_STATUS_inst                                                         0x0057
+#define HDMI_PHY_STATUS_wdout_shift                                                  (1)
+#define HDMI_PHY_STATUS_wdout_mask                                                   (0x00000002)
+#define HDMI_PHY_STATUS_wdout(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_PHY_STATUS_wdout_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_PHY_STATUS_get_wdout(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_PHY_STATUS_Rxstatus_shift                                               (0)
+#define HDMI_PHY_STATUS_Rxstatus_mask                                                (0x00000001)
+#define HDMI_PHY_STATUS_Rxstatus(data)                                               (0x00000001&((data)<<0))
+#define HDMI_PHY_STATUS_Rxstatus_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_PHY_STATUS_get_Rxstatus(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_UPDATE_ST                                                               0x9800D00c
+#define HDMI_UPDATE_ST_reg_addr                                                      "0xD800D00C"
+#define HDMI_UPDATE_ST_reg                                                           0xD800D00C
+#define set_HDMI_UPDATE_ST_reg(data)   (*((volatile unsigned int*) HDMI_UPDATE_ST_reg)=data)
+#define get_HDMI_UPDATE_ST_reg   (*((volatile unsigned int*) HDMI_UPDATE_ST_reg))
+#define HDMI_UPDATE_ST_inst_adr                                                      "0x0003"
+#define HDMI_UPDATE_ST_inst                                                          0x0003
+#define HDMI_UPDATE_ST_write_en2_shift                                               (17)
+#define HDMI_UPDATE_ST_write_en2_mask                                                (0x00020000)
+#define HDMI_UPDATE_ST_write_en2(data)                                               (0x00020000&((data)<<17))
+#define HDMI_UPDATE_ST_write_en2_src(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_UPDATE_ST_get_write_en2(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_UPDATE_ST_rirate_shift                                                  (9)
+#define HDMI_UPDATE_ST_rirate_mask                                                   (0x0001FE00)
+#define HDMI_UPDATE_ST_rirate(data)                                                  (0x0001FE00&((data)<<9))
+#define HDMI_UPDATE_ST_rirate_src(data)                                              ((0x0001FE00&(data))>>9)
+#define HDMI_UPDATE_ST_get_rirate(data)                                              ((0x0001FE00&(data))>>9)
+#define HDMI_UPDATE_ST_write_en1_shift                                               (8)
+#define HDMI_UPDATE_ST_write_en1_mask                                                (0x00000100)
+#define HDMI_UPDATE_ST_write_en1(data)                                               (0x00000100&((data)<<8))
+#define HDMI_UPDATE_ST_write_en1_src(data)                                           ((0x00000100&(data))>>8)
+#define HDMI_UPDATE_ST_get_write_en1(data)                                           ((0x00000100&(data))>>8)
+#define HDMI_UPDATE_ST_pjrate_shift                                                  (0)
+#define HDMI_UPDATE_ST_pjrate_mask                                                   (0x000000FF)
+#define HDMI_UPDATE_ST_pjrate(data)                                                  (0x000000FF&((data)<<0))
+#define HDMI_UPDATE_ST_pjrate_src(data)                                              ((0x000000FF&(data))>>0)
+#define HDMI_UPDATE_ST_get_pjrate(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define HDMI_CHNL_SEL                                                                0x9800D020
+#define HDMI_CHNL_SEL_reg_addr                                                       "0xD800D020"
+#define HDMI_CHNL_SEL_reg                                                            0xD800D020
+#define set_HDMI_CHNL_SEL_reg(data)   (*((volatile unsigned int*) HDMI_CHNL_SEL_reg)=data)
+#define get_HDMI_CHNL_SEL_reg   (*((volatile unsigned int*) HDMI_CHNL_SEL_reg))
+#define HDMI_CHNL_SEL_inst_adr                                                       "0x0008"
+#define HDMI_CHNL_SEL_inst                                                           0x0008
+#define HDMI_CHNL_SEL_sram_shut_down_en_shift                                        (11)
+#define HDMI_CHNL_SEL_sram_shut_down_en_mask                                         (0x00000800)
+#define HDMI_CHNL_SEL_sram_shut_down_en(data)                                        (0x00000800&((data)<<11))
+#define HDMI_CHNL_SEL_sram_shut_down_en_src(data)                                    ((0x00000800&(data))>>11)
+#define HDMI_CHNL_SEL_get_sram_shut_down_en(data)                                    ((0x00000800&(data))>>11)
+#define HDMI_CHNL_SEL_sram_sleep_en_shift                                            (10)
+#define HDMI_CHNL_SEL_sram_sleep_en_mask                                             (0x00000400)
+#define HDMI_CHNL_SEL_sram_sleep_en(data)                                            (0x00000400&((data)<<10))
+#define HDMI_CHNL_SEL_sram_sleep_en_src(data)                                        ((0x00000400&(data))>>10)
+#define HDMI_CHNL_SEL_get_sram_sleep_en(data)                                        ((0x00000400&(data))>>10)
+#define HDMI_CHNL_SEL_video_sd_shift                                                 (9)
+#define HDMI_CHNL_SEL_video_sd_mask                                                  (0x00000200)
+#define HDMI_CHNL_SEL_video_sd(data)                                                 (0x00000200&((data)<<9))
+#define HDMI_CHNL_SEL_video_sd_src(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_CHNL_SEL_get_video_sd(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_CHNL_SEL_Interlaced_vfmt_shift                                          (8)
+#define HDMI_CHNL_SEL_Interlaced_vfmt_mask                                           (0x00000100)
+#define HDMI_CHNL_SEL_Interlaced_vfmt(data)                                          (0x00000100&((data)<<8))
+#define HDMI_CHNL_SEL_Interlaced_vfmt_src(data)                                      ((0x00000100&(data))>>8)
+#define HDMI_CHNL_SEL_get_Interlaced_vfmt(data)                                      ((0x00000100&(data))>>8)
+#define HDMI_CHNL_SEL_3D_video_format_shift                                          (4)
+#define HDMI_CHNL_SEL_3D_video_format_mask                                           (0x000000F0)
+#define HDMI_CHNL_SEL_3D_video_format(data)                                          (0x000000F0&((data)<<4))
+#define HDMI_CHNL_SEL_3D_video_format_src(data)                                      ((0x000000F0&(data))>>4)
+#define HDMI_CHNL_SEL_get_3D_video_format(data)                                      ((0x000000F0&(data))>>4)
+#define HDMI_CHNL_SEL_En_3D_shift                                                    (3)
+#define HDMI_CHNL_SEL_En_3D_mask                                                     (0x00000008)
+#define HDMI_CHNL_SEL_En_3D(data)                                                    (0x00000008&((data)<<3))
+#define HDMI_CHNL_SEL_En_3D_src(data)                                                ((0x00000008&(data))>>3)
+#define HDMI_CHNL_SEL_get_En_3D(data)                                                ((0x00000008&(data))>>3)
+#define HDMI_CHNL_SEL_timing_gen_en_shift                                            (2)
+#define HDMI_CHNL_SEL_timing_gen_en_mask                                             (0x00000004)
+#define HDMI_CHNL_SEL_timing_gen_en(data)                                            (0x00000004&((data)<<2))
+#define HDMI_CHNL_SEL_timing_gen_en_src(data)                                        ((0x00000004&(data))>>2)
+#define HDMI_CHNL_SEL_get_timing_gen_en(data)                                        ((0x00000004&(data))>>2)
+#define HDMI_CHNL_SEL_chl_sel_shift                                                  (0)
+#define HDMI_CHNL_SEL_chl_sel_mask                                                   (0x00000003)
+#define HDMI_CHNL_SEL_chl_sel(data)                                                  (0x00000003&((data)<<0))
+#define HDMI_CHNL_SEL_chl_sel_src(data)                                              ((0x00000003&(data))>>0)
+#define HDMI_CHNL_SEL_get_chl_sel(data)                                              ((0x00000003&(data))>>0)
+
+
+#define HDMI_CS_TRANS0                                                               0x9800D024
+#define HDMI_CS_TRANS0_reg_addr                                                      "0xD800D024"
+#define HDMI_CS_TRANS0_reg                                                           0xD800D024
+#define set_HDMI_CS_TRANS0_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS0_reg)=data)
+#define get_HDMI_CS_TRANS0_reg   (*((volatile unsigned int*) HDMI_CS_TRANS0_reg))
+#define HDMI_CS_TRANS0_inst_adr                                                      "0x0009"
+#define HDMI_CS_TRANS0_inst                                                          0x0009
+#define HDMI_CS_TRANS0_c1_shift                                                      (0)
+#define HDMI_CS_TRANS0_c1_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS0_c1(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS0_c1_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS0_get_c1(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS1                                                               0x9800D028
+#define HDMI_CS_TRANS1_reg_addr                                                      "0xD800D028"
+#define HDMI_CS_TRANS1_reg                                                           0xD800D028
+#define set_HDMI_CS_TRANS1_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS1_reg)=data)
+#define get_HDMI_CS_TRANS1_reg   (*((volatile unsigned int*) HDMI_CS_TRANS1_reg))
+#define HDMI_CS_TRANS1_inst_adr                                                      "0x000A"
+#define HDMI_CS_TRANS1_inst                                                          0x000A
+#define HDMI_CS_TRANS1_c2_shift                                                      (0)
+#define HDMI_CS_TRANS1_c2_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS1_c2(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS1_c2_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS1_get_c2(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS2                                                               0x9800D02c
+#define HDMI_CS_TRANS2_reg_addr                                                      "0xD800D02C"
+#define HDMI_CS_TRANS2_reg                                                           0xD800D02C
+#define set_HDMI_CS_TRANS2_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS2_reg)=data)
+#define get_HDMI_CS_TRANS2_reg   (*((volatile unsigned int*) HDMI_CS_TRANS2_reg))
+#define HDMI_CS_TRANS2_inst_adr                                                      "0x000B"
+#define HDMI_CS_TRANS2_inst                                                          0x000B
+#define HDMI_CS_TRANS2_c3_shift                                                      (0)
+#define HDMI_CS_TRANS2_c3_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS2_c3(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS2_c3_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS2_get_c3(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS3                                                               0x9800D200
+#define HDMI_CS_TRANS3_reg_addr                                                      "0xD800D200"
+#define HDMI_CS_TRANS3_reg                                                           0xD800D200
+#define set_HDMI_CS_TRANS3_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS3_reg)=data)
+#define get_HDMI_CS_TRANS3_reg   (*((volatile unsigned int*) HDMI_CS_TRANS3_reg))
+#define HDMI_CS_TRANS3_inst_adr                                                      "0x0080"
+#define HDMI_CS_TRANS3_inst                                                          0x0080
+#define HDMI_CS_TRANS3_c4_shift                                                      (0)
+#define HDMI_CS_TRANS3_c4_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS3_c4(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS3_c4_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS3_get_c4(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS4                                                               0x9800D204
+#define HDMI_CS_TRANS4_reg_addr                                                      "0xD800D204"
+#define HDMI_CS_TRANS4_reg                                                           0xD800D204
+#define set_HDMI_CS_TRANS4_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS4_reg)=data)
+#define get_HDMI_CS_TRANS4_reg   (*((volatile unsigned int*) HDMI_CS_TRANS4_reg))
+#define HDMI_CS_TRANS4_inst_adr                                                      "0x0081"
+#define HDMI_CS_TRANS4_inst                                                          0x0081
+#define HDMI_CS_TRANS4_c5_shift                                                      (0)
+#define HDMI_CS_TRANS4_c5_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS4_c5(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS4_c5_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS4_get_c5(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS5                                                               0x9800D208
+#define HDMI_CS_TRANS5_reg_addr                                                      "0xD800D208"
+#define HDMI_CS_TRANS5_reg                                                           0xD800D208
+#define set_HDMI_CS_TRANS5_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS5_reg)=data)
+#define get_HDMI_CS_TRANS5_reg   (*((volatile unsigned int*) HDMI_CS_TRANS5_reg))
+#define HDMI_CS_TRANS5_inst_adr                                                      "0x0082"
+#define HDMI_CS_TRANS5_inst                                                          0x0082
+#define HDMI_CS_TRANS5_c6_shift                                                      (0)
+#define HDMI_CS_TRANS5_c6_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS5_c6(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS5_c6_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS5_get_c6(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS6                                                               0x9800D20c
+#define HDMI_CS_TRANS6_reg_addr                                                      "0xD800D20C"
+#define HDMI_CS_TRANS6_reg                                                           0xD800D20C
+#define set_HDMI_CS_TRANS6_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS6_reg)=data)
+#define get_HDMI_CS_TRANS6_reg   (*((volatile unsigned int*) HDMI_CS_TRANS6_reg))
+#define HDMI_CS_TRANS6_inst_adr                                                      "0x0083"
+#define HDMI_CS_TRANS6_inst                                                          0x0083
+#define HDMI_CS_TRANS6_c7_shift                                                      (0)
+#define HDMI_CS_TRANS6_c7_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS6_c7(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS6_c7_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS6_get_c7(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS7                                                               0x9800D210
+#define HDMI_CS_TRANS7_reg_addr                                                      "0xD800D210"
+#define HDMI_CS_TRANS7_reg                                                           0xD800D210
+#define set_HDMI_CS_TRANS7_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS7_reg)=data)
+#define get_HDMI_CS_TRANS7_reg   (*((volatile unsigned int*) HDMI_CS_TRANS7_reg))
+#define HDMI_CS_TRANS7_inst_adr                                                      "0x0084"
+#define HDMI_CS_TRANS7_inst                                                          0x0084
+#define HDMI_CS_TRANS7_c8_shift                                                      (0)
+#define HDMI_CS_TRANS7_c8_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS7_c8(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS7_c8_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS7_get_c8(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS8                                                               0x9800D214
+#define HDMI_CS_TRANS8_reg_addr                                                      "0xD800D214"
+#define HDMI_CS_TRANS8_reg                                                           0xD800D214
+#define set_HDMI_CS_TRANS8_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS8_reg)=data)
+#define get_HDMI_CS_TRANS8_reg   (*((volatile unsigned int*) HDMI_CS_TRANS8_reg))
+#define HDMI_CS_TRANS8_inst_adr                                                      "0x0085"
+#define HDMI_CS_TRANS8_inst                                                          0x0085
+#define HDMI_CS_TRANS8_c9_shift                                                      (0)
+#define HDMI_CS_TRANS8_c9_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS8_c9(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS8_c9_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS8_get_c9(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS9                                                               0x9800D218
+#define HDMI_CS_TRANS9_reg_addr                                                      "0xD800D218"
+#define HDMI_CS_TRANS9_reg                                                           0xD800D218
+#define set_HDMI_CS_TRANS9_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS9_reg)=data)
+#define get_HDMI_CS_TRANS9_reg   (*((volatile unsigned int*) HDMI_CS_TRANS9_reg))
+#define HDMI_CS_TRANS9_inst_adr                                                      "0x0086"
+#define HDMI_CS_TRANS9_inst                                                          0x0086
+#define HDMI_CS_TRANS9_k1_shift                                                      (0)
+#define HDMI_CS_TRANS9_k1_mask                                                       (0x0000FFFF)
+#define HDMI_CS_TRANS9_k1(data)                                                      (0x0000FFFF&((data)<<0))
+#define HDMI_CS_TRANS9_k1_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define HDMI_CS_TRANS9_get_k1(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS10                                                              0x9800D21c
+#define HDMI_CS_TRANS10_reg_addr                                                     "0xD800D21C"
+#define HDMI_CS_TRANS10_reg                                                          0xD800D21C
+#define set_HDMI_CS_TRANS10_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS10_reg)=data)
+#define get_HDMI_CS_TRANS10_reg   (*((volatile unsigned int*) HDMI_CS_TRANS10_reg))
+#define HDMI_CS_TRANS10_inst_adr                                                     "0x0087"
+#define HDMI_CS_TRANS10_inst                                                         0x0087
+#define HDMI_CS_TRANS10_k2_shift                                                     (0)
+#define HDMI_CS_TRANS10_k2_mask                                                      (0x0000FFFF)
+#define HDMI_CS_TRANS10_k2(data)                                                     (0x0000FFFF&((data)<<0))
+#define HDMI_CS_TRANS10_k2_src(data)                                                 ((0x0000FFFF&(data))>>0)
+#define HDMI_CS_TRANS10_get_k2(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS11                                                              0x9800D220
+#define HDMI_CS_TRANS11_reg_addr                                                     "0xD800D220"
+#define HDMI_CS_TRANS11_reg                                                          0xD800D220
+#define set_HDMI_CS_TRANS11_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS11_reg)=data)
+#define get_HDMI_CS_TRANS11_reg   (*((volatile unsigned int*) HDMI_CS_TRANS11_reg))
+#define HDMI_CS_TRANS11_inst_adr                                                     "0x0088"
+#define HDMI_CS_TRANS11_inst                                                         0x0088
+#define HDMI_CS_TRANS11_k3_shift                                                     (0)
+#define HDMI_CS_TRANS11_k3_mask                                                      (0x0000FFFF)
+#define HDMI_CS_TRANS11_k3(data)                                                     (0x0000FFFF&((data)<<0))
+#define HDMI_CS_TRANS11_k3_src(data)                                                 ((0x0000FFFF&(data))>>0)
+#define HDMI_CS_TRANS11_get_k3(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS12                                                              0x9800D224
+#define HDMI_CS_TRANS12_reg_addr                                                     "0xD800D224"
+#define HDMI_CS_TRANS12_reg                                                          0xD800D224
+#define set_HDMI_CS_TRANS12_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS12_reg)=data)
+#define get_HDMI_CS_TRANS12_reg   (*((volatile unsigned int*) HDMI_CS_TRANS12_reg))
+#define HDMI_CS_TRANS12_inst_adr                                                     "0x0089"
+#define HDMI_CS_TRANS12_inst                                                         0x0089
+#define HDMI_CS_TRANS12_write_en2_shift                                              (28)
+#define HDMI_CS_TRANS12_write_en2_mask                                               (0x10000000)
+#define HDMI_CS_TRANS12_write_en2(data)                                              (0x10000000&((data)<<28))
+#define HDMI_CS_TRANS12_write_en2_src(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS12_get_write_en2(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS12_ygmax_shift                                                  (16)
+#define HDMI_CS_TRANS12_ygmax_mask                                                   (0x0FFF0000)
+#define HDMI_CS_TRANS12_ygmax(data)                                                  (0x0FFF0000&((data)<<16))
+#define HDMI_CS_TRANS12_ygmax_src(data)                                              ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS12_get_ygmax(data)                                              ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS12_write_en1_shift                                              (12)
+#define HDMI_CS_TRANS12_write_en1_mask                                               (0x00001000)
+#define HDMI_CS_TRANS12_write_en1(data)                                              (0x00001000&((data)<<12))
+#define HDMI_CS_TRANS12_write_en1_src(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS12_get_write_en1(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS12_ygmin_shift                                                  (0)
+#define HDMI_CS_TRANS12_ygmin_mask                                                   (0x00000FFF)
+#define HDMI_CS_TRANS12_ygmin(data)                                                  (0x00000FFF&((data)<<0))
+#define HDMI_CS_TRANS12_ygmin_src(data)                                              ((0x00000FFF&(data))>>0)
+#define HDMI_CS_TRANS12_get_ygmin(data)                                              ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS13                                                              0x9800D228
+#define HDMI_CS_TRANS13_reg_addr                                                     "0xD800D228"
+#define HDMI_CS_TRANS13_reg                                                          0xD800D228
+#define set_HDMI_CS_TRANS13_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS13_reg)=data)
+#define get_HDMI_CS_TRANS13_reg   (*((volatile unsigned int*) HDMI_CS_TRANS13_reg))
+#define HDMI_CS_TRANS13_inst_adr                                                     "0x008A"
+#define HDMI_CS_TRANS13_inst                                                         0x008A
+#define HDMI_CS_TRANS13_write_en2_shift                                              (28)
+#define HDMI_CS_TRANS13_write_en2_mask                                               (0x10000000)
+#define HDMI_CS_TRANS13_write_en2(data)                                              (0x10000000&((data)<<28))
+#define HDMI_CS_TRANS13_write_en2_src(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS13_get_write_en2(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS13_cbbmax_shift                                                 (16)
+#define HDMI_CS_TRANS13_cbbmax_mask                                                  (0x0FFF0000)
+#define HDMI_CS_TRANS13_cbbmax(data)                                                 (0x0FFF0000&((data)<<16))
+#define HDMI_CS_TRANS13_cbbmax_src(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS13_get_cbbmax(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS13_write_en1_shift                                              (12)
+#define HDMI_CS_TRANS13_write_en1_mask                                               (0x00001000)
+#define HDMI_CS_TRANS13_write_en1(data)                                              (0x00001000&((data)<<12))
+#define HDMI_CS_TRANS13_write_en1_src(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS13_get_write_en1(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS13_cbbmin_shift                                                 (0)
+#define HDMI_CS_TRANS13_cbbmin_mask                                                  (0x00000FFF)
+#define HDMI_CS_TRANS13_cbbmin(data)                                                 (0x00000FFF&((data)<<0))
+#define HDMI_CS_TRANS13_cbbmin_src(data)                                             ((0x00000FFF&(data))>>0)
+#define HDMI_CS_TRANS13_get_cbbmin(data)                                             ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS14                                                              0x9800D22c
+#define HDMI_CS_TRANS14_reg_addr                                                     "0xD800D22C"
+#define HDMI_CS_TRANS14_reg                                                          0xD800D22C
+#define set_HDMI_CS_TRANS14_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS14_reg)=data)
+#define get_HDMI_CS_TRANS14_reg   (*((volatile unsigned int*) HDMI_CS_TRANS14_reg))
+#define HDMI_CS_TRANS14_inst_adr                                                     "0x008B"
+#define HDMI_CS_TRANS14_inst                                                         0x008B
+#define HDMI_CS_TRANS14_write_en2_shift                                              (28)
+#define HDMI_CS_TRANS14_write_en2_mask                                               (0x10000000)
+#define HDMI_CS_TRANS14_write_en2(data)                                              (0x10000000&((data)<<28))
+#define HDMI_CS_TRANS14_write_en2_src(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS14_get_write_en2(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS14_crrmax_shift                                                 (16)
+#define HDMI_CS_TRANS14_crrmax_mask                                                  (0x0FFF0000)
+#define HDMI_CS_TRANS14_crrmax(data)                                                 (0x0FFF0000&((data)<<16))
+#define HDMI_CS_TRANS14_crrmax_src(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS14_get_crrmax(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS14_write_en1_shift                                              (12)
+#define HDMI_CS_TRANS14_write_en1_mask                                               (0x00001000)
+#define HDMI_CS_TRANS14_write_en1(data)                                              (0x00001000&((data)<<12))
+#define HDMI_CS_TRANS14_write_en1_src(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS14_get_write_en1(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS14_crrmin_shift                                                 (0)
+#define HDMI_CS_TRANS14_crrmin_mask                                                  (0x00000FFF)
+#define HDMI_CS_TRANS14_crrmin(data)                                                 (0x00000FFF&((data)<<0))
+#define HDMI_CS_TRANS14_crrmin_src(data)                                             ((0x00000FFF&(data))>>0)
+#define HDMI_CS_TRANS14_get_crrmin(data)                                             ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_SYNC_DLY                                                                0x9800D030
+#define HDMI_SYNC_DLY_reg_addr                                                       "0xD800D030"
+#define HDMI_SYNC_DLY_reg                                                            0xD800D030
+#define set_HDMI_SYNC_DLY_reg(data)   (*((volatile unsigned int*) HDMI_SYNC_DLY_reg)=data)
+#define get_HDMI_SYNC_DLY_reg   (*((volatile unsigned int*) HDMI_SYNC_DLY_reg))
+#define HDMI_SYNC_DLY_inst_adr                                                       "0x000C"
+#define HDMI_SYNC_DLY_inst                                                           0x000C
+#define HDMI_SYNC_DLY_write_en4_shift                                                (11)
+#define HDMI_SYNC_DLY_write_en4_mask                                                 (0x00000800)
+#define HDMI_SYNC_DLY_write_en4(data)                                                (0x00000800&((data)<<11))
+#define HDMI_SYNC_DLY_write_en4_src(data)                                            ((0x00000800&(data))>>11)
+#define HDMI_SYNC_DLY_get_write_en4(data)                                            ((0x00000800&(data))>>11)
+#define HDMI_SYNC_DLY_nor_v_shift                                                    (9)
+#define HDMI_SYNC_DLY_nor_v_mask                                                     (0x00000600)
+#define HDMI_SYNC_DLY_nor_v(data)                                                    (0x00000600&((data)<<9))
+#define HDMI_SYNC_DLY_nor_v_src(data)                                                ((0x00000600&(data))>>9)
+#define HDMI_SYNC_DLY_get_nor_v(data)                                                ((0x00000600&(data))>>9)
+#define HDMI_SYNC_DLY_write_en3_shift                                                (8)
+#define HDMI_SYNC_DLY_write_en3_mask                                                 (0x00000100)
+#define HDMI_SYNC_DLY_write_en3(data)                                                (0x00000100&((data)<<8))
+#define HDMI_SYNC_DLY_write_en3_src(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_SYNC_DLY_get_write_en3(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_SYNC_DLY_nor_h_shift                                                    (6)
+#define HDMI_SYNC_DLY_nor_h_mask                                                     (0x000000C0)
+#define HDMI_SYNC_DLY_nor_h(data)                                                    (0x000000C0&((data)<<6))
+#define HDMI_SYNC_DLY_nor_h_src(data)                                                ((0x000000C0&(data))>>6)
+#define HDMI_SYNC_DLY_get_nor_h(data)                                                ((0x000000C0&(data))>>6)
+#define HDMI_SYNC_DLY_write_en2_shift                                                (5)
+#define HDMI_SYNC_DLY_write_en2_mask                                                 (0x00000020)
+#define HDMI_SYNC_DLY_write_en2(data)                                                (0x00000020&((data)<<5))
+#define HDMI_SYNC_DLY_write_en2_src(data)                                            ((0x00000020&(data))>>5)
+#define HDMI_SYNC_DLY_get_write_en2(data)                                            ((0x00000020&(data))>>5)
+#define HDMI_SYNC_DLY_disp_v_shift                                                   (3)
+#define HDMI_SYNC_DLY_disp_v_mask                                                    (0x00000018)
+#define HDMI_SYNC_DLY_disp_v(data)                                                   (0x00000018&((data)<<3))
+#define HDMI_SYNC_DLY_disp_v_src(data)                                               ((0x00000018&(data))>>3)
+#define HDMI_SYNC_DLY_get_disp_v(data)                                               ((0x00000018&(data))>>3)
+#define HDMI_SYNC_DLY_write_en1_shift                                                (2)
+#define HDMI_SYNC_DLY_write_en1_mask                                                 (0x00000004)
+#define HDMI_SYNC_DLY_write_en1(data)                                                (0x00000004&((data)<<2))
+#define HDMI_SYNC_DLY_write_en1_src(data)                                            ((0x00000004&(data))>>2)
+#define HDMI_SYNC_DLY_get_write_en1(data)                                            ((0x00000004&(data))>>2)
+#define HDMI_SYNC_DLY_disp_h_shift                                                   (0)
+#define HDMI_SYNC_DLY_disp_h_mask                                                    (0x00000003)
+#define HDMI_SYNC_DLY_disp_h(data)                                                   (0x00000003&((data)<<0))
+#define HDMI_SYNC_DLY_disp_h_src(data)                                               ((0x00000003&(data))>>0)
+#define HDMI_SYNC_DLY_get_disp_h(data)                                               ((0x00000003&(data))>>0)
+
+
+#define HDMI_CR                                                                      0x9800D034
+#define HDMI_CR_reg_addr                                                             "0xD800D034"
+#define HDMI_CR_reg                                                                  0xD800D034
+#define set_HDMI_CR_reg(data)   (*((volatile unsigned int*) HDMI_CR_reg)=data)
+#define get_HDMI_CR_reg   (*((volatile unsigned int*) HDMI_CR_reg))
+#define HDMI_CR_inst_adr                                                             "0x000D"
+#define HDMI_CR_inst                                                                 0x000D
+#define HDMI_CR_write_en3_shift                                                      (5)
+#define HDMI_CR_write_en3_mask                                                       (0x00000020)
+#define HDMI_CR_write_en3(data)                                                      (0x00000020&((data)<<5))
+#define HDMI_CR_write_en3_src(data)                                                  ((0x00000020&(data))>>5)
+#define HDMI_CR_get_write_en3(data)                                                  ((0x00000020&(data))>>5)
+#define HDMI_CR_tmds_encen_shift                                                     (4)
+#define HDMI_CR_tmds_encen_mask                                                      (0x00000010)
+#define HDMI_CR_tmds_encen(data)                                                     (0x00000010&((data)<<4))
+#define HDMI_CR_tmds_encen_src(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_CR_get_tmds_encen(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_CR_write_en1_shift                                                      (1)
+#define HDMI_CR_write_en1_mask                                                       (0x00000002)
+#define HDMI_CR_write_en1(data)                                                      (0x00000002&((data)<<1))
+#define HDMI_CR_write_en1_src(data)                                                  ((0x00000002&(data))>>1)
+#define HDMI_CR_get_write_en1(data)                                                  ((0x00000002&(data))>>1)
+#define HDMI_CR_enablehdmi_shift                                                     (0)
+#define HDMI_CR_enablehdmi_mask                                                      (0x00000001)
+#define HDMI_CR_enablehdmi(data)                                                     (0x00000001&((data)<<0))
+#define HDMI_CR_enablehdmi_src(data)                                                 ((0x00000001&(data))>>0)
+#define HDMI_CR_get_enablehdmi(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define HDMI_DPC                                                                     0x9800D154
+#define HDMI_DPC_reg_addr                                                            "0xD800D154"
+#define HDMI_DPC_reg                                                                 0xD800D154
+#define set_HDMI_DPC_reg(data)   (*((volatile unsigned int*) HDMI_DPC_reg)=data)
+#define get_HDMI_DPC_reg   (*((volatile unsigned int*) HDMI_DPC_reg))
+#define HDMI_DPC_inst_adr                                                            "0x0055"
+#define HDMI_DPC_inst                                                                0x0055
+#define HDMI_DPC_write_en9_shift                                                     (30)
+#define HDMI_DPC_write_en9_mask                                                      (0x40000000)
+#define HDMI_DPC_write_en9(data)                                                     (0x40000000&((data)<<30))
+#define HDMI_DPC_write_en9_src(data)                                                 ((0x40000000&(data))>>30)
+#define HDMI_DPC_get_write_en9(data)                                                 ((0x40000000&(data))>>30)
+#define HDMI_DPC_dp_vfch_num_shift                                                   (28)
+#define HDMI_DPC_dp_vfch_num_mask                                                    (0x30000000)
+#define HDMI_DPC_dp_vfch_num(data)                                                   (0x30000000&((data)<<28))
+#define HDMI_DPC_dp_vfch_num_src(data)                                               ((0x30000000&(data))>>28)
+#define HDMI_DPC_get_dp_vfch_num(data)                                               ((0x30000000&(data))>>28)
+#define HDMI_DPC_write_en8_shift                                                     (25)
+#define HDMI_DPC_write_en8_mask                                                      (0x02000000)
+#define HDMI_DPC_write_en8(data)                                                     (0x02000000&((data)<<25))
+#define HDMI_DPC_write_en8_src(data)                                                 ((0x02000000&(data))>>25)
+#define HDMI_DPC_get_write_en8(data)                                                 ((0x02000000&(data))>>25)
+#define HDMI_DPC_fp_swen_shift                                                       (24)
+#define HDMI_DPC_fp_swen_mask                                                        (0x01000000)
+#define HDMI_DPC_fp_swen(data)                                                       (0x01000000&((data)<<24))
+#define HDMI_DPC_fp_swen_src(data)                                                   ((0x01000000&(data))>>24)
+#define HDMI_DPC_get_fp_swen(data)                                                   ((0x01000000&(data))>>24)
+#define HDMI_DPC_write_en7_shift                                                     (23)
+#define HDMI_DPC_write_en7_mask                                                      (0x00800000)
+#define HDMI_DPC_write_en7(data)                                                     (0x00800000&((data)<<23))
+#define HDMI_DPC_write_en7_src(data)                                                 ((0x00800000&(data))>>23)
+#define HDMI_DPC_get_write_en7(data)                                                 ((0x00800000&(data))>>23)
+#define HDMI_DPC_fp_shift                                                            (20)
+#define HDMI_DPC_fp_mask                                                             (0x00700000)
+#define HDMI_DPC_fp(data)                                                            (0x00700000&((data)<<20))
+#define HDMI_DPC_fp_src(data)                                                        ((0x00700000&(data))>>20)
+#define HDMI_DPC_get_fp(data)                                                        ((0x00700000&(data))>>20)
+#define HDMI_DPC_write_en6_shift                                                     (19)
+#define HDMI_DPC_write_en6_mask                                                      (0x00080000)
+#define HDMI_DPC_write_en6(data)                                                     (0x00080000&((data)<<19))
+#define HDMI_DPC_write_en6_src(data)                                                 ((0x00080000&(data))>>19)
+#define HDMI_DPC_get_write_en6(data)                                                 ((0x00080000&(data))>>19)
+#define HDMI_DPC_pp_swen_shift                                                       (18)
+#define HDMI_DPC_pp_swen_mask                                                        (0x00040000)
+#define HDMI_DPC_pp_swen(data)                                                       (0x00040000&((data)<<18))
+#define HDMI_DPC_pp_swen_src(data)                                                   ((0x00040000&(data))>>18)
+#define HDMI_DPC_get_pp_swen(data)                                                   ((0x00040000&(data))>>18)
+#define HDMI_DPC_write_en4_shift                                                     (15)
+#define HDMI_DPC_write_en4_mask                                                      (0x00008000)
+#define HDMI_DPC_write_en4(data)                                                     (0x00008000&((data)<<15))
+#define HDMI_DPC_write_en4_src(data)                                                 ((0x00008000&(data))>>15)
+#define HDMI_DPC_get_write_en4(data)                                                 ((0x00008000&(data))>>15)
+#define HDMI_DPC_dp_swen_shift                                                       (14)
+#define HDMI_DPC_dp_swen_mask                                                        (0x00004000)
+#define HDMI_DPC_dp_swen(data)                                                       (0x00004000&((data)<<14))
+#define HDMI_DPC_dp_swen_src(data)                                                   ((0x00004000&(data))>>14)
+#define HDMI_DPC_get_dp_swen(data)                                                   ((0x00004000&(data))>>14)
+#define HDMI_DPC_write_en3_shift                                                     (13)
+#define HDMI_DPC_write_en3_mask                                                      (0x00002000)
+#define HDMI_DPC_write_en3(data)                                                     (0x00002000&((data)<<13))
+#define HDMI_DPC_write_en3_src(data)                                                 ((0x00002000&(data))>>13)
+#define HDMI_DPC_get_write_en3(data)                                                 ((0x00002000&(data))>>13)
+#define HDMI_DPC_default_phase_shift                                                 (12)
+#define HDMI_DPC_default_phase_mask                                                  (0x00001000)
+#define HDMI_DPC_default_phase(data)                                                 (0x00001000&((data)<<12))
+#define HDMI_DPC_default_phase_src(data)                                             ((0x00001000&(data))>>12)
+#define HDMI_DPC_get_default_phase(data)                                             ((0x00001000&(data))>>12)
+#define HDMI_DPC_write_en2_shift                                                     (8)
+#define HDMI_DPC_write_en2_mask                                                      (0x00000100)
+#define HDMI_DPC_write_en2(data)                                                     (0x00000100&((data)<<8))
+#define HDMI_DPC_write_en2_src(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_DPC_get_write_en2(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_DPC_color_depth_shift                                                   (4)
+#define HDMI_DPC_color_depth_mask                                                    (0x000000F0)
+#define HDMI_DPC_color_depth(data)                                                   (0x000000F0&((data)<<4))
+#define HDMI_DPC_color_depth_src(data)                                               ((0x000000F0&(data))>>4)
+#define HDMI_DPC_get_color_depth(data)                                               ((0x000000F0&(data))>>4)
+#define HDMI_DPC_write_en1_shift                                                     (1)
+#define HDMI_DPC_write_en1_mask                                                      (0x00000002)
+#define HDMI_DPC_write_en1(data)                                                     (0x00000002&((data)<<1))
+#define HDMI_DPC_write_en1_src(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_DPC_get_write_en1(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_DPC_dpc_enable_shift                                                    (0)
+#define HDMI_DPC_dpc_enable_mask                                                     (0x00000001)
+#define HDMI_DPC_dpc_enable(data)                                                    (0x00000001&((data)<<0))
+#define HDMI_DPC_dpc_enable_src(data)                                                ((0x00000001&(data))>>0)
+#define HDMI_DPC_get_dpc_enable(data)                                                ((0x00000001&(data))>>0)
+
+
+#define HDMI_DPC1                                                                    0x9800D158
+#define HDMI_DPC1_reg_addr                                                           "0xD800D158"
+#define HDMI_DPC1_reg                                                                0xD800D158
+#define set_HDMI_DPC1_reg(data)   (*((volatile unsigned int*) HDMI_DPC1_reg)=data)
+#define get_HDMI_DPC1_reg   (*((volatile unsigned int*) HDMI_DPC1_reg))
+#define HDMI_DPC1_inst_adr                                                           "0x0056"
+#define HDMI_DPC1_inst                                                               0x0056
+#define HDMI_DPC1_write_en2_shift                                                    (9)
+#define HDMI_DPC1_write_en2_mask                                                     (0x00000200)
+#define HDMI_DPC1_write_en2(data)                                                    (0x00000200&((data)<<9))
+#define HDMI_DPC1_write_en2_src(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_DPC1_get_write_en2(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_DPC1_dp_vfch_shift                                                      (8)
+#define HDMI_DPC1_dp_vfch_mask                                                       (0x00000100)
+#define HDMI_DPC1_dp_vfch(data)                                                      (0x00000100&((data)<<8))
+#define HDMI_DPC1_dp_vfch_src(data)                                                  ((0x00000100&(data))>>8)
+#define HDMI_DPC1_get_dp_vfch(data)                                                  ((0x00000100&(data))>>8)
+#define HDMI_DPC1_write_en1_shift                                                    (4)
+#define HDMI_DPC1_write_en1_mask                                                     (0x00000010)
+#define HDMI_DPC1_write_en1(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_DPC1_write_en1_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_DPC1_get_write_en1(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_DPC1_pp_shift                                                           (0)
+#define HDMI_DPC1_pp_mask                                                            (0x0000000F)
+#define HDMI_DPC1_pp(data)                                                           (0x0000000F&((data)<<0))
+#define HDMI_DPC1_pp_src(data)                                                       ((0x0000000F&(data))>>0)
+#define HDMI_DPC1_get_pp(data)                                                       ((0x0000000F&(data))>>0)
+
+
+#define HDMI_TMDS_EODR0                                                              0x9800D038
+#define HDMI_TMDS_EODR0_reg_addr                                                     "0xD800D038"
+#define HDMI_TMDS_EODR0_reg                                                          0xD800D038
+#define set_HDMI_TMDS_EODR0_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_EODR0_reg)=data)
+#define get_HDMI_TMDS_EODR0_reg   (*((volatile unsigned int*) HDMI_TMDS_EODR0_reg))
+#define HDMI_TMDS_EODR0_inst_adr                                                     "0x000E"
+#define HDMI_TMDS_EODR0_inst                                                         0x000E
+#define HDMI_TMDS_EODR0_tmds_ch2_out_shift                                           (20)
+#define HDMI_TMDS_EODR0_tmds_ch2_out_mask                                            (0x3FF00000)
+#define HDMI_TMDS_EODR0_tmds_ch2_out(data)                                           (0x3FF00000&((data)<<20))
+#define HDMI_TMDS_EODR0_tmds_ch2_out_src(data)                                       ((0x3FF00000&(data))>>20)
+#define HDMI_TMDS_EODR0_get_tmds_ch2_out(data)                                       ((0x3FF00000&(data))>>20)
+#define HDMI_TMDS_EODR0_tmds_ch1_out_shift                                           (10)
+#define HDMI_TMDS_EODR0_tmds_ch1_out_mask                                            (0x000FFC00)
+#define HDMI_TMDS_EODR0_tmds_ch1_out(data)                                           (0x000FFC00&((data)<<10))
+#define HDMI_TMDS_EODR0_tmds_ch1_out_src(data)                                       ((0x000FFC00&(data))>>10)
+#define HDMI_TMDS_EODR0_get_tmds_ch1_out(data)                                       ((0x000FFC00&(data))>>10)
+#define HDMI_TMDS_EODR0_tmds_ch0_out_shift                                           (0)
+#define HDMI_TMDS_EODR0_tmds_ch0_out_mask                                            (0x000003FF)
+#define HDMI_TMDS_EODR0_tmds_ch0_out(data)                                           (0x000003FF&((data)<<0))
+#define HDMI_TMDS_EODR0_tmds_ch0_out_src(data)                                       ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_EODR0_get_tmds_ch0_out(data)                                       ((0x000003FF&(data))>>0)
+
+
+#define HDMI_TMDS_EODR1                                                              0x9800D03c
+#define HDMI_TMDS_EODR1_reg_addr                                                     "0xD800D03C"
+#define HDMI_TMDS_EODR1_reg                                                          0xD800D03C
+#define set_HDMI_TMDS_EODR1_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_EODR1_reg)=data)
+#define get_HDMI_TMDS_EODR1_reg   (*((volatile unsigned int*) HDMI_TMDS_EODR1_reg))
+#define HDMI_TMDS_EODR1_inst_adr                                                     "0x000F"
+#define HDMI_TMDS_EODR1_inst                                                         0x000F
+#define HDMI_TMDS_EODR1_default_phase_st_shift                                       (12)
+#define HDMI_TMDS_EODR1_default_phase_st_mask                                        (0x00001000)
+#define HDMI_TMDS_EODR1_default_phase_st(data)                                       (0x00001000&((data)<<12))
+#define HDMI_TMDS_EODR1_default_phase_st_src(data)                                   ((0x00001000&(data))>>12)
+#define HDMI_TMDS_EODR1_get_default_phase_st(data)                                   ((0x00001000&(data))>>12)
+#define HDMI_TMDS_EODR1_tmds_clk_out_shift                                           (0)
+#define HDMI_TMDS_EODR1_tmds_clk_out_mask                                            (0x000003FF)
+#define HDMI_TMDS_EODR1_tmds_clk_out(data)                                           (0x000003FF&((data)<<0))
+#define HDMI_TMDS_EODR1_tmds_clk_out_src(data)                                       ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_EODR1_get_tmds_clk_out(data)                                       ((0x000003FF&(data))>>0)
+
+
+#define HDMI_TMDS_STR0                                                               0x9800D048
+#define HDMI_TMDS_STR0_reg_addr                                                      "0xD800D048"
+#define HDMI_TMDS_STR0_reg                                                           0xD800D048
+#define set_HDMI_TMDS_STR0_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_STR0_reg)=data)
+#define get_HDMI_TMDS_STR0_reg   (*((volatile unsigned int*) HDMI_TMDS_STR0_reg))
+#define HDMI_TMDS_STR0_inst_adr                                                      "0x0012"
+#define HDMI_TMDS_STR0_inst                                                          0x0012
+#define HDMI_TMDS_STR0_tmds1ten_shift                                                (31)
+#define HDMI_TMDS_STR0_tmds1ten_mask                                                 (0x80000000)
+#define HDMI_TMDS_STR0_tmds1ten(data)                                                (0x80000000&((data)<<31))
+#define HDMI_TMDS_STR0_tmds1ten_src(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR0_get_tmds1ten(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR0_td1src_shift                                                  (30)
+#define HDMI_TMDS_STR0_td1src_mask                                                   (0x40000000)
+#define HDMI_TMDS_STR0_td1src(data)                                                  (0x40000000&((data)<<30))
+#define HDMI_TMDS_STR0_td1src_src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR0_get_td1src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR0_tmds1td_shift                                                 (16)
+#define HDMI_TMDS_STR0_tmds1td_mask                                                  (0x03FF0000)
+#define HDMI_TMDS_STR0_tmds1td(data)                                                 (0x03FF0000&((data)<<16))
+#define HDMI_TMDS_STR0_tmds1td_src(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR0_get_tmds1td(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR0_tmds0ten_shift                                                (15)
+#define HDMI_TMDS_STR0_tmds0ten_mask                                                 (0x00008000)
+#define HDMI_TMDS_STR0_tmds0ten(data)                                                (0x00008000&((data)<<15))
+#define HDMI_TMDS_STR0_tmds0ten_src(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR0_get_tmds0ten(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR0_td0src_shift                                                  (14)
+#define HDMI_TMDS_STR0_td0src_mask                                                   (0x00004000)
+#define HDMI_TMDS_STR0_td0src(data)                                                  (0x00004000&((data)<<14))
+#define HDMI_TMDS_STR0_td0src_src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR0_get_td0src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR0_tmds0td_shift                                                 (0)
+#define HDMI_TMDS_STR0_tmds0td_mask                                                  (0x000003FF)
+#define HDMI_TMDS_STR0_tmds0td(data)                                                 (0x000003FF&((data)<<0))
+#define HDMI_TMDS_STR0_tmds0td_src(data)                                             ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_STR0_get_tmds0td(data)                                             ((0x000003FF&(data))>>0)
+
+
+#define HDMI_TMDS_STR1                                                               0x9800D04c
+#define HDMI_TMDS_STR1_reg_addr                                                      "0xD800D04C"
+#define HDMI_TMDS_STR1_reg                                                           0xD800D04C
+#define set_HDMI_TMDS_STR1_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_STR1_reg)=data)
+#define get_HDMI_TMDS_STR1_reg   (*((volatile unsigned int*) HDMI_TMDS_STR1_reg))
+#define HDMI_TMDS_STR1_inst_adr                                                      "0x0013"
+#define HDMI_TMDS_STR1_inst                                                          0x0013
+#define HDMI_TMDS_STR1_tmdscten_shift                                                (31)
+#define HDMI_TMDS_STR1_tmdscten_mask                                                 (0x80000000)
+#define HDMI_TMDS_STR1_tmdscten(data)                                                (0x80000000&((data)<<31))
+#define HDMI_TMDS_STR1_tmdscten_src(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR1_get_tmdscten(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR1_tdcsrc_shift                                                  (30)
+#define HDMI_TMDS_STR1_tdcsrc_mask                                                   (0x40000000)
+#define HDMI_TMDS_STR1_tdcsrc(data)                                                  (0x40000000&((data)<<30))
+#define HDMI_TMDS_STR1_tdcsrc_src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR1_get_tdcsrc(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR1_tmdsctd_shift                                                 (16)
+#define HDMI_TMDS_STR1_tmdsctd_mask                                                  (0x03FF0000)
+#define HDMI_TMDS_STR1_tmdsctd(data)                                                 (0x03FF0000&((data)<<16))
+#define HDMI_TMDS_STR1_tmdsctd_src(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR1_get_tmdsctd(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR1_tmds2ten_shift                                                (15)
+#define HDMI_TMDS_STR1_tmds2ten_mask                                                 (0x00008000)
+#define HDMI_TMDS_STR1_tmds2ten(data)                                                (0x00008000&((data)<<15))
+#define HDMI_TMDS_STR1_tmds2ten_src(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR1_get_tmds2ten(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR1_td2src_shift                                                  (14)
+#define HDMI_TMDS_STR1_td2src_mask                                                   (0x00004000)
+#define HDMI_TMDS_STR1_td2src(data)                                                  (0x00004000&((data)<<14))
+#define HDMI_TMDS_STR1_td2src_src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR1_get_td2src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR1_tmds2td_shift                                                 (0)
+#define HDMI_TMDS_STR1_tmds2td_mask                                                  (0x000003FF)
+#define HDMI_TMDS_STR1_tmds2td(data)                                                 (0x000003FF&((data)<<0))
+#define HDMI_TMDS_STR1_tmds2td_src(data)                                             ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_STR1_get_tmds2td(data)                                             ((0x000003FF&(data))>>0)
+
+
+#define HDMI_ASPCR1                                                                  0x9800D054
+#define HDMI_ASPCR1_reg_addr                                                         "0xD800D054"
+#define HDMI_ASPCR1_reg                                                              0xD800D054
+#define set_HDMI_ASPCR1_reg(data)   (*((volatile unsigned int*) HDMI_ASPCR1_reg)=data)
+#define get_HDMI_ASPCR1_reg   (*((volatile unsigned int*) HDMI_ASPCR1_reg))
+#define HDMI_ASPCR1_inst_adr                                                         "0x0015"
+#define HDMI_ASPCR1_inst                                                             0x0015
+#define HDMI_ASPCR1_write_en8_shift                                                  (28)
+#define HDMI_ASPCR1_write_en8_mask                                                   (0x10000000)
+#define HDMI_ASPCR1_write_en8(data)                                                  (0x10000000&((data)<<28))
+#define HDMI_ASPCR1_write_en8_src(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ASPCR1_get_write_en8(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ASPCR1_ycbcr422_8bits_shift                                             (27)
+#define HDMI_ASPCR1_ycbcr422_8bits_mask                                              (0x08000000)
+#define HDMI_ASPCR1_ycbcr422_8bits(data)                                             (0x08000000&((data)<<27))
+#define HDMI_ASPCR1_ycbcr422_8bits_src(data)                                         ((0x08000000&(data))>>27)
+#define HDMI_ASPCR1_get_ycbcr422_8bits(data)                                         ((0x08000000&(data))>>27)
+#define HDMI_ASPCR1_write_en7_shift                                                  (26)
+#define HDMI_ASPCR1_write_en7_mask                                                   (0x04000000)
+#define HDMI_ASPCR1_write_en7(data)                                                  (0x04000000&((data)<<26))
+#define HDMI_ASPCR1_write_en7_src(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ASPCR1_get_write_en7(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ASPCR1_cts_pkt_hp_shift                                                 (25)
+#define HDMI_ASPCR1_cts_pkt_hp_mask                                                  (0x02000000)
+#define HDMI_ASPCR1_cts_pkt_hp(data)                                                 (0x02000000&((data)<<25))
+#define HDMI_ASPCR1_cts_pkt_hp_src(data)                                             ((0x02000000&(data))>>25)
+#define HDMI_ASPCR1_get_cts_pkt_hp(data)                                             ((0x02000000&(data))>>25)
+#define HDMI_ASPCR1_write_en6_shift                                                  (24)
+#define HDMI_ASPCR1_write_en6_mask                                                   (0x01000000)
+#define HDMI_ASPCR1_write_en6(data)                                                  (0x01000000&((data)<<24))
+#define HDMI_ASPCR1_write_en6_src(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ASPCR1_get_write_en6(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ASPCR1_Audioheader0_shift                                               (16)
+#define HDMI_ASPCR1_Audioheader0_mask                                                (0x00FF0000)
+#define HDMI_ASPCR1_Audioheader0(data)                                               (0x00FF0000&((data)<<16))
+#define HDMI_ASPCR1_Audioheader0_src(data)                                           ((0x00FF0000&(data))>>16)
+#define HDMI_ASPCR1_get_Audioheader0(data)                                           ((0x00FF0000&(data))>>16)
+#define HDMI_ASPCR1_write_en5_shift                                                  (15)
+#define HDMI_ASPCR1_write_en5_mask                                                   (0x00008000)
+#define HDMI_ASPCR1_write_en5(data)                                                  (0x00008000&((data)<<15))
+#define HDMI_ASPCR1_write_en5_src(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_ASPCR1_get_write_en5(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_ASPCR1_samplepresent_shift                                              (11)
+#define HDMI_ASPCR1_samplepresent_mask                                               (0x00007800)
+#define HDMI_ASPCR1_samplepresent(data)                                              (0x00007800&((data)<<11))
+#define HDMI_ASPCR1_samplepresent_src(data)                                          ((0x00007800&(data))>>11)
+#define HDMI_ASPCR1_get_samplepresent(data)                                          ((0x00007800&(data))>>11)
+#define HDMI_ASPCR1_write_en4_shift                                                  (10)
+#define HDMI_ASPCR1_write_en4_mask                                                   (0x00000400)
+#define HDMI_ASPCR1_write_en4(data)                                                  (0x00000400&((data)<<10))
+#define HDMI_ASPCR1_write_en4_src(data)                                              ((0x00000400&(data))>>10)
+#define HDMI_ASPCR1_get_write_en4(data)                                              ((0x00000400&(data))>>10)
+#define HDMI_ASPCR1_forcesamplepresent_shift                                         (9)
+#define HDMI_ASPCR1_forcesamplepresent_mask                                          (0x00000200)
+#define HDMI_ASPCR1_forcesamplepresent(data)                                         (0x00000200&((data)<<9))
+#define HDMI_ASPCR1_forcesamplepresent_src(data)                                     ((0x00000200&(data))>>9)
+#define HDMI_ASPCR1_get_forcesamplepresent(data)                                     ((0x00000200&(data))>>9)
+#define HDMI_ASPCR1_write_en3_shift                                                  (8)
+#define HDMI_ASPCR1_write_en3_mask                                                   (0x00000100)
+#define HDMI_ASPCR1_write_en3(data)                                                  (0x00000100&((data)<<8))
+#define HDMI_ASPCR1_write_en3_src(data)                                              ((0x00000100&(data))>>8)
+#define HDMI_ASPCR1_get_write_en3(data)                                              ((0x00000100&(data))>>8)
+#define HDMI_ASPCR1_b_frame_shift                                                    (4)
+#define HDMI_ASPCR1_b_frame_mask                                                     (0x000000F0)
+#define HDMI_ASPCR1_b_frame(data)                                                    (0x000000F0&((data)<<4))
+#define HDMI_ASPCR1_b_frame_src(data)                                                ((0x000000F0&(data))>>4)
+#define HDMI_ASPCR1_get_b_frame(data)                                                ((0x000000F0&(data))>>4)
+#define HDMI_ASPCR1_write_en2_shift                                                  (3)
+#define HDMI_ASPCR1_write_en2_mask                                                   (0x00000008)
+#define HDMI_ASPCR1_write_en2(data)                                                  (0x00000008&((data)<<3))
+#define HDMI_ASPCR1_write_en2_src(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_ASPCR1_get_write_en2(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_ASPCR1_forceb_frame_shift                                               (2)
+#define HDMI_ASPCR1_forceb_frame_mask                                                (0x00000004)
+#define HDMI_ASPCR1_forceb_frame(data)                                               (0x00000004&((data)<<2))
+#define HDMI_ASPCR1_forceb_frame_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_ASPCR1_get_forceb_frame(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_ASPCR1_write_en1_shift                                                  (1)
+#define HDMI_ASPCR1_write_en1_mask                                                   (0x00000002)
+#define HDMI_ASPCR1_write_en1(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_ASPCR1_write_en1_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_ASPCR1_get_write_en1(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_ASPCR1_audiolayout_shift                                                (0)
+#define HDMI_ASPCR1_audiolayout_mask                                                 (0x00000001)
+#define HDMI_ASPCR1_audiolayout(data)                                                (0x00000001&((data)<<0))
+#define HDMI_ASPCR1_audiolayout_src(data)                                            ((0x00000001&(data))>>0)
+#define HDMI_ASPCR1_get_audiolayout(data)                                            ((0x00000001&(data))>>0)
+
+
+#define HDMI_ACACR                                                                   0x9800D058
+#define HDMI_ACACR_reg_addr                                                          "0xD800D058"
+#define HDMI_ACACR_reg                                                               0xD800D058
+#define set_HDMI_ACACR_reg(data)   (*((volatile unsigned int*) HDMI_ACACR_reg)=data)
+#define get_HDMI_ACACR_reg   (*((volatile unsigned int*) HDMI_ACACR_reg))
+#define HDMI_ACACR_inst_adr                                                          "0x0016"
+#define HDMI_ACACR_inst                                                              0x0016
+#define HDMI_ACACR_write_en4_shift                                                   (15)
+#define HDMI_ACACR_write_en4_mask                                                    (0x00008000)
+#define HDMI_ACACR_write_en4(data)                                                   (0x00008000&((data)<<15))
+#define HDMI_ACACR_write_en4_src(data)                                               ((0x00008000&(data))>>15)
+#define HDMI_ACACR_get_write_en4(data)                                               ((0x00008000&(data))>>15)
+#define HDMI_ACACR_hdmi_pk3map_shift                                                 (12)
+#define HDMI_ACACR_hdmi_pk3map_mask                                                  (0x00007000)
+#define HDMI_ACACR_hdmi_pk3map(data)                                                 (0x00007000&((data)<<12))
+#define HDMI_ACACR_hdmi_pk3map_src(data)                                             ((0x00007000&(data))>>12)
+#define HDMI_ACACR_get_hdmi_pk3map(data)                                             ((0x00007000&(data))>>12)
+#define HDMI_ACACR_write_en3_shift                                                   (11)
+#define HDMI_ACACR_write_en3_mask                                                    (0x00000800)
+#define HDMI_ACACR_write_en3(data)                                                   (0x00000800&((data)<<11))
+#define HDMI_ACACR_write_en3_src(data)                                               ((0x00000800&(data))>>11)
+#define HDMI_ACACR_get_write_en3(data)                                               ((0x00000800&(data))>>11)
+#define HDMI_ACACR_hdmi_pk2map_shift                                                 (8)
+#define HDMI_ACACR_hdmi_pk2map_mask                                                  (0x00000700)
+#define HDMI_ACACR_hdmi_pk2map(data)                                                 (0x00000700&((data)<<8))
+#define HDMI_ACACR_hdmi_pk2map_src(data)                                             ((0x00000700&(data))>>8)
+#define HDMI_ACACR_get_hdmi_pk2map(data)                                             ((0x00000700&(data))>>8)
+#define HDMI_ACACR_write_en2_shift                                                   (7)
+#define HDMI_ACACR_write_en2_mask                                                    (0x00000080)
+#define HDMI_ACACR_write_en2(data)                                                   (0x00000080&((data)<<7))
+#define HDMI_ACACR_write_en2_src(data)                                               ((0x00000080&(data))>>7)
+#define HDMI_ACACR_get_write_en2(data)                                               ((0x00000080&(data))>>7)
+#define HDMI_ACACR_hdmi_pk1map_shift                                                 (4)
+#define HDMI_ACACR_hdmi_pk1map_mask                                                  (0x00000070)
+#define HDMI_ACACR_hdmi_pk1map(data)                                                 (0x00000070&((data)<<4))
+#define HDMI_ACACR_hdmi_pk1map_src(data)                                             ((0x00000070&(data))>>4)
+#define HDMI_ACACR_get_hdmi_pk1map(data)                                             ((0x00000070&(data))>>4)
+#define HDMI_ACACR_write_en1_shift                                                   (3)
+#define HDMI_ACACR_write_en1_mask                                                    (0x00000008)
+#define HDMI_ACACR_write_en1(data)                                                   (0x00000008&((data)<<3))
+#define HDMI_ACACR_write_en1_src(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_ACACR_get_write_en1(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_ACACR_hdmi_pk0map_shift                                                 (0)
+#define HDMI_ACACR_hdmi_pk0map_mask                                                  (0x00000007)
+#define HDMI_ACACR_hdmi_pk0map(data)                                                 (0x00000007&((data)<<0))
+#define HDMI_ACACR_hdmi_pk0map_src(data)                                             ((0x00000007&(data))>>0)
+#define HDMI_ACACR_get_hdmi_pk0map(data)                                             ((0x00000007&(data))>>0)
+
+
+#define HDMI_ACRPCR                                                                  0x9800D06c
+#define HDMI_ACRPCR_reg_addr                                                         "0xD800D06C"
+#define HDMI_ACRPCR_reg                                                              0xD800D06C
+#define set_HDMI_ACRPCR_reg(data)   (*((volatile unsigned int*) HDMI_ACRPCR_reg)=data)
+#define get_HDMI_ACRPCR_reg   (*((volatile unsigned int*) HDMI_ACRPCR_reg))
+#define HDMI_ACRPCR_inst_adr                                                         "0x001B"
+#define HDMI_ACRPCR_inst                                                             0x001B
+#define HDMI_ACRPCR_write_en6_shift                                                  (30)
+#define HDMI_ACRPCR_write_en6_mask                                                   (0x40000000)
+#define HDMI_ACRPCR_write_en6(data)                                                  (0x40000000&((data)<<30))
+#define HDMI_ACRPCR_write_en6_src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_ACRPCR_get_write_en6(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_ACRPCR_Audio_info_hp_shift                                              (29)
+#define HDMI_ACRPCR_Audio_info_hp_mask                                               (0x20000000)
+#define HDMI_ACRPCR_Audio_info_hp(data)                                              (0x20000000&((data)<<29))
+#define HDMI_ACRPCR_Audio_info_hp_src(data)                                          ((0x20000000&(data))>>29)
+#define HDMI_ACRPCR_get_Audio_info_hp(data)                                          ((0x20000000&(data))>>29)
+#define HDMI_ACRPCR_write_en5_shift                                                  (28)
+#define HDMI_ACRPCR_write_en5_mask                                                   (0x10000000)
+#define HDMI_ACRPCR_write_en5(data)                                                  (0x10000000&((data)<<28))
+#define HDMI_ACRPCR_write_en5_src(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ACRPCR_get_write_en5(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ACRPCR_ac_hw_ctrl_en_shift                                              (27)
+#define HDMI_ACRPCR_ac_hw_ctrl_en_mask                                               (0x08000000)
+#define HDMI_ACRPCR_ac_hw_ctrl_en(data)                                              (0x08000000&((data)<<27))
+#define HDMI_ACRPCR_ac_hw_ctrl_en_src(data)                                          ((0x08000000&(data))>>27)
+#define HDMI_ACRPCR_get_ac_hw_ctrl_en(data)                                          ((0x08000000&(data))>>27)
+#define HDMI_ACRPCR_write_en4_shift                                                  (26)
+#define HDMI_ACRPCR_write_en4_mask                                                   (0x04000000)
+#define HDMI_ACRPCR_write_en4(data)                                                  (0x04000000&((data)<<26))
+#define HDMI_ACRPCR_write_en4_src(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ACRPCR_get_write_en4(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ACRPCR_fs_div4_shift                                                    (25)
+#define HDMI_ACRPCR_fs_div4_mask                                                     (0x02000000)
+#define HDMI_ACRPCR_fs_div4(data)                                                    (0x02000000&((data)<<25))
+#define HDMI_ACRPCR_fs_div4_src(data)                                                ((0x02000000&(data))>>25)
+#define HDMI_ACRPCR_get_fs_div4(data)                                                ((0x02000000&(data))>>25)
+#define HDMI_ACRPCR_write_en3_shift                                                  (24)
+#define HDMI_ACRPCR_write_en3_mask                                                   (0x01000000)
+#define HDMI_ACRPCR_write_en3(data)                                                  (0x01000000&((data)<<24))
+#define HDMI_ACRPCR_write_en3_src(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ACRPCR_get_write_en3(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ACRPCR_disablecrp_shift                                                 (23)
+#define HDMI_ACRPCR_disablecrp_mask                                                  (0x00800000)
+#define HDMI_ACRPCR_disablecrp(data)                                                 (0x00800000&((data)<<23))
+#define HDMI_ACRPCR_disablecrp_src(data)                                             ((0x00800000&(data))>>23)
+#define HDMI_ACRPCR_get_disablecrp(data)                                             ((0x00800000&(data))>>23)
+#define HDMI_ACRPCR_write_en2_shift                                                  (22)
+#define HDMI_ACRPCR_write_en2_mask                                                   (0x00400000)
+#define HDMI_ACRPCR_write_en2(data)                                                  (0x00400000&((data)<<22))
+#define HDMI_ACRPCR_write_en2_src(data)                                              ((0x00400000&(data))>>22)
+#define HDMI_ACRPCR_get_write_en2(data)                                              ((0x00400000&(data))>>22)
+#define HDMI_ACRPCR_cts_source_shift                                                 (21)
+#define HDMI_ACRPCR_cts_source_mask                                                  (0x00200000)
+#define HDMI_ACRPCR_cts_source(data)                                                 (0x00200000&((data)<<21))
+#define HDMI_ACRPCR_cts_source_src(data)                                             ((0x00200000&(data))>>21)
+#define HDMI_ACRPCR_get_cts_source(data)                                             ((0x00200000&(data))>>21)
+#define HDMI_ACRPCR_write_en1_shift                                                  (20)
+#define HDMI_ACRPCR_write_en1_mask                                                   (0x00100000)
+#define HDMI_ACRPCR_write_en1(data)                                                  (0x00100000&((data)<<20))
+#define HDMI_ACRPCR_write_en1_src(data)                                              ((0x00100000&(data))>>20)
+#define HDMI_ACRPCR_get_write_en1(data)                                              ((0x00100000&(data))>>20)
+#define HDMI_ACRPCR_n_value_shift                                                    (0)
+#define HDMI_ACRPCR_n_value_mask                                                     (0x000FFFFF)
+#define HDMI_ACRPCR_n_value(data)                                                    (0x000FFFFF&((data)<<0))
+#define HDMI_ACRPCR_n_value_src(data)                                                ((0x000FFFFF&(data))>>0)
+#define HDMI_ACRPCR_get_n_value(data)                                                ((0x000FFFFF&(data))>>0)
+
+
+#define HDMI_ACRPCTSR                                                                0x9800D070
+#define HDMI_ACRPCTSR_reg_addr                                                       "0xD800D070"
+#define HDMI_ACRPCTSR_reg                                                            0xD800D070
+#define set_HDMI_ACRPCTSR_reg(data)   (*((volatile unsigned int*) HDMI_ACRPCTSR_reg)=data)
+#define get_HDMI_ACRPCTSR_reg   (*((volatile unsigned int*) HDMI_ACRPCTSR_reg))
+#define HDMI_ACRPCTSR_inst_adr                                                       "0x001C"
+#define HDMI_ACRPCTSR_inst                                                           0x001C
+#define HDMI_ACRPCTSR_ctssw_shift                                                    (0)
+#define HDMI_ACRPCTSR_ctssw_mask                                                     (0x000FFFFF)
+#define HDMI_ACRPCTSR_ctssw(data)                                                    (0x000FFFFF&((data)<<0))
+#define HDMI_ACRPCTSR_ctssw_src(data)                                                ((0x000FFFFF&(data))>>0)
+#define HDMI_ACRPCTSR_get_ctssw(data)                                                ((0x000FFFFF&(data))>>0)
+
+
+#define HDMI_ACRPPR                                                                  0x9800D074
+#define HDMI_ACRPPR_reg_addr                                                         "0xD800D074"
+#define HDMI_ACRPPR_reg                                                              0xD800D074
+#define set_HDMI_ACRPPR_reg(data)   (*((volatile unsigned int*) HDMI_ACRPPR_reg)=data)
+#define get_HDMI_ACRPPR_reg   (*((volatile unsigned int*) HDMI_ACRPPR_reg))
+#define HDMI_ACRPPR_inst_adr                                                         "0x001D"
+#define HDMI_ACRPPR_inst                                                             0x001D
+#define HDMI_ACRPPR_ctshw_shift                                                      (0)
+#define HDMI_ACRPPR_ctshw_mask                                                       (0x000FFFFF)
+#define HDMI_ACRPPR_ctshw(data)                                                      (0x000FFFFF&((data)<<0))
+#define HDMI_ACRPPR_ctshw_src(data)                                                  ((0x000FFFFF&(data))>>0)
+#define HDMI_ACRPPR_get_ctshw(data)                                                  ((0x000FFFFF&(data))>>0)
+
+
+#define HDMI_GCPCR                                                                   0x9800D078
+#define HDMI_GCPCR_reg_addr                                                          "0xD800D078"
+#define HDMI_GCPCR_reg                                                               0xD800D078
+#define set_HDMI_GCPCR_reg(data)   (*((volatile unsigned int*) HDMI_GCPCR_reg)=data)
+#define get_HDMI_GCPCR_reg   (*((volatile unsigned int*) HDMI_GCPCR_reg))
+#define HDMI_GCPCR_inst_adr                                                          "0x001E"
+#define HDMI_GCPCR_inst                                                              0x001E
+#define HDMI_GCPCR_enablegcp_shift                                                   (3)
+#define HDMI_GCPCR_enablegcp_mask                                                    (0x00000008)
+#define HDMI_GCPCR_enablegcp(data)                                                   (0x00000008&((data)<<3))
+#define HDMI_GCPCR_enablegcp_src(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_GCPCR_get_enablegcp(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_GCPCR_gcp_clearavmute_shift                                             (2)
+#define HDMI_GCPCR_gcp_clearavmute_mask                                              (0x00000004)
+#define HDMI_GCPCR_gcp_clearavmute(data)                                             (0x00000004&((data)<<2))
+#define HDMI_GCPCR_gcp_clearavmute_src(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_GCPCR_get_gcp_clearavmute(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_GCPCR_gcp_setavmute_shift                                               (1)
+#define HDMI_GCPCR_gcp_setavmute_mask                                                (0x00000002)
+#define HDMI_GCPCR_gcp_setavmute(data)                                               (0x00000002&((data)<<1))
+#define HDMI_GCPCR_gcp_setavmute_src(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_GCPCR_get_gcp_setavmute(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_GCPCR_write_data_shift                                                  (0)
+#define HDMI_GCPCR_write_data_mask                                                   (0x00000001)
+#define HDMI_GCPCR_write_data(data)                                                  (0x00000001&((data)<<0))
+#define HDMI_GCPCR_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define HDMI_GCPCR_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define HDMI_ORP6PH                                                                  0x9800D07c
+#define HDMI_ORP6PH_reg_addr                                                         "0xD800D07C"
+#define HDMI_ORP6PH_reg                                                              0xD800D07C
+#define set_HDMI_ORP6PH_reg(data)   (*((volatile unsigned int*) HDMI_ORP6PH_reg)=data)
+#define get_HDMI_ORP6PH_reg   (*((volatile unsigned int*) HDMI_ORP6PH_reg))
+#define HDMI_ORP6PH_inst_adr                                                         "0x001F"
+#define HDMI_ORP6PH_inst                                                             0x001F
+#define HDMI_ORP6PH_once_pkt_shift                                                   (0)
+#define HDMI_ORP6PH_once_pkt_mask                                                    (0xFFFFFFFF)
+#define HDMI_ORP6PH_once_pkt(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_ORP6PH_once_pkt_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_ORP6PH_get_once_pkt(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_ORP6W_0                                                                 0x9800D080
+#define HDMI_ORP6W_1                                                                 0x9800D084
+#define HDMI_ORP6W_2                                                                 0x9800D088
+#define HDMI_ORP6W_3                                                                 0x9800D08C
+#define HDMI_ORP6W_4                                                                 0x9800D090
+#define HDMI_ORP6W_5                                                                 0x9800D094
+#define HDMI_ORP6W_6                                                                 0x9800D098
+#define HDMI_ORP6W_7                                                                 0x9800D09C
+#define HDMI_ORP6W_0_reg_addr                                                        "0xD800D080"
+#define HDMI_ORP6W_1_reg_addr                                                        "0xD800D084"
+#define HDMI_ORP6W_2_reg_addr                                                        "0xD800D088"
+#define HDMI_ORP6W_3_reg_addr                                                        "0xD800D08C"
+#define HDMI_ORP6W_4_reg_addr                                                        "0xD800D090"
+#define HDMI_ORP6W_5_reg_addr                                                        "0xD800D094"
+#define HDMI_ORP6W_6_reg_addr                                                        "0xD800D098"
+#define HDMI_ORP6W_7_reg_addr                                                        "0xD800D09C"
+#define HDMI_ORP6W_0_reg                                                             0xD800D080
+#define HDMI_ORP6W_1_reg                                                             0xD800D084
+#define HDMI_ORP6W_2_reg                                                             0xD800D088
+#define HDMI_ORP6W_3_reg                                                             0xD800D08C
+#define HDMI_ORP6W_4_reg                                                             0xD800D090
+#define HDMI_ORP6W_5_reg                                                             0xD800D094
+#define HDMI_ORP6W_6_reg                                                             0xD800D098
+#define HDMI_ORP6W_7_reg                                                             0xD800D09C
+#define set_HDMI_ORP6W_0_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_0_reg)=data)
+#define set_HDMI_ORP6W_1_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_1_reg)=data)
+#define set_HDMI_ORP6W_2_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_2_reg)=data)
+#define set_HDMI_ORP6W_3_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_3_reg)=data)
+#define set_HDMI_ORP6W_4_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_4_reg)=data)
+#define set_HDMI_ORP6W_5_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_5_reg)=data)
+#define set_HDMI_ORP6W_6_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_6_reg)=data)
+#define set_HDMI_ORP6W_7_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_7_reg)=data)
+#define get_HDMI_ORP6W_0_reg   (*((volatile unsigned int*) HDMI_ORP6W_0_reg))
+#define get_HDMI_ORP6W_1_reg   (*((volatile unsigned int*) HDMI_ORP6W_1_reg))
+#define get_HDMI_ORP6W_2_reg   (*((volatile unsigned int*) HDMI_ORP6W_2_reg))
+#define get_HDMI_ORP6W_3_reg   (*((volatile unsigned int*) HDMI_ORP6W_3_reg))
+#define get_HDMI_ORP6W_4_reg   (*((volatile unsigned int*) HDMI_ORP6W_4_reg))
+#define get_HDMI_ORP6W_5_reg   (*((volatile unsigned int*) HDMI_ORP6W_5_reg))
+#define get_HDMI_ORP6W_6_reg   (*((volatile unsigned int*) HDMI_ORP6W_6_reg))
+#define get_HDMI_ORP6W_7_reg   (*((volatile unsigned int*) HDMI_ORP6W_7_reg))
+#define HDMI_ORP6W_0_inst_adr                                                        "0x0020"
+#define HDMI_ORP6W_1_inst_adr                                                        "0x0021"
+#define HDMI_ORP6W_2_inst_adr                                                        "0x0022"
+#define HDMI_ORP6W_3_inst_adr                                                        "0x0023"
+#define HDMI_ORP6W_4_inst_adr                                                        "0x0024"
+#define HDMI_ORP6W_5_inst_adr                                                        "0x0025"
+#define HDMI_ORP6W_6_inst_adr                                                        "0x0026"
+#define HDMI_ORP6W_7_inst_adr                                                        "0x0027"
+#define HDMI_ORP6W_0_inst                                                            0x0020
+#define HDMI_ORP6W_1_inst                                                            0x0021
+#define HDMI_ORP6W_2_inst                                                            0x0022
+#define HDMI_ORP6W_3_inst                                                            0x0023
+#define HDMI_ORP6W_4_inst                                                            0x0024
+#define HDMI_ORP6W_5_inst                                                            0x0025
+#define HDMI_ORP6W_6_inst                                                            0x0026
+#define HDMI_ORP6W_7_inst                                                            0x0027
+#define HDMI_ORP6W_once_pkt_shift                                                    (0)
+#define HDMI_ORP6W_once_pkt_mask                                                     (0xFFFFFFFF)
+#define HDMI_ORP6W_once_pkt(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_ORP6W_once_pkt_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_ORP6W_get_once_pkt(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_RPCR                                                                    0x9800D0a0
+#define HDMI_RPCR_reg_addr                                                           "0xD800D0A0"
+#define HDMI_RPCR_reg                                                                0xD800D0A0
+#define set_HDMI_RPCR_reg(data)   (*((volatile unsigned int*) HDMI_RPCR_reg)=data)
+#define get_HDMI_RPCR_reg   (*((volatile unsigned int*) HDMI_RPCR_reg))
+#define HDMI_RPCR_inst_adr                                                           "0x0028"
+#define HDMI_RPCR_inst                                                               0x0028
+#define HDMI_RPCR_write_en6_shift                                                    (29)
+#define HDMI_RPCR_write_en6_mask                                                     (0x20000000)
+#define HDMI_RPCR_write_en6(data)                                                    (0x20000000&((data)<<29))
+#define HDMI_RPCR_write_en6_src(data)                                                ((0x20000000&(data))>>29)
+#define HDMI_RPCR_get_write_en6(data)                                                ((0x20000000&(data))>>29)
+#define HDMI_RPCR_prp5period_shift                                                   (25)
+#define HDMI_RPCR_prp5period_mask                                                    (0x1E000000)
+#define HDMI_RPCR_prp5period(data)                                                   (0x1E000000&((data)<<25))
+#define HDMI_RPCR_prp5period_src(data)                                               ((0x1E000000&(data))>>25)
+#define HDMI_RPCR_get_prp5period(data)                                               ((0x1E000000&(data))>>25)
+#define HDMI_RPCR_write_en5_shift                                                    (24)
+#define HDMI_RPCR_write_en5_mask                                                     (0x01000000)
+#define HDMI_RPCR_write_en5(data)                                                    (0x01000000&((data)<<24))
+#define HDMI_RPCR_write_en5_src(data)                                                ((0x01000000&(data))>>24)
+#define HDMI_RPCR_get_write_en5(data)                                                ((0x01000000&(data))>>24)
+#define HDMI_RPCR_prp4period_shift                                                   (20)
+#define HDMI_RPCR_prp4period_mask                                                    (0x00F00000)
+#define HDMI_RPCR_prp4period(data)                                                   (0x00F00000&((data)<<20))
+#define HDMI_RPCR_prp4period_src(data)                                               ((0x00F00000&(data))>>20)
+#define HDMI_RPCR_get_prp4period(data)                                               ((0x00F00000&(data))>>20)
+#define HDMI_RPCR_write_en4_shift                                                    (19)
+#define HDMI_RPCR_write_en4_mask                                                     (0x00080000)
+#define HDMI_RPCR_write_en4(data)                                                    (0x00080000&((data)<<19))
+#define HDMI_RPCR_write_en4_src(data)                                                ((0x00080000&(data))>>19)
+#define HDMI_RPCR_get_write_en4(data)                                                ((0x00080000&(data))>>19)
+#define HDMI_RPCR_prp3period_shift                                                   (15)
+#define HDMI_RPCR_prp3period_mask                                                    (0x00078000)
+#define HDMI_RPCR_prp3period(data)                                                   (0x00078000&((data)<<15))
+#define HDMI_RPCR_prp3period_src(data)                                               ((0x00078000&(data))>>15)
+#define HDMI_RPCR_get_prp3period(data)                                               ((0x00078000&(data))>>15)
+#define HDMI_RPCR_write_en3_shift                                                    (14)
+#define HDMI_RPCR_write_en3_mask                                                     (0x00004000)
+#define HDMI_RPCR_write_en3(data)                                                    (0x00004000&((data)<<14))
+#define HDMI_RPCR_write_en3_src(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_RPCR_get_write_en3(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_RPCR_prp2period_shift                                                   (10)
+#define HDMI_RPCR_prp2period_mask                                                    (0x00003C00)
+#define HDMI_RPCR_prp2period(data)                                                   (0x00003C00&((data)<<10))
+#define HDMI_RPCR_prp2period_src(data)                                               ((0x00003C00&(data))>>10)
+#define HDMI_RPCR_get_prp2period(data)                                               ((0x00003C00&(data))>>10)
+#define HDMI_RPCR_write_en2_shift                                                    (9)
+#define HDMI_RPCR_write_en2_mask                                                     (0x00000200)
+#define HDMI_RPCR_write_en2(data)                                                    (0x00000200&((data)<<9))
+#define HDMI_RPCR_write_en2_src(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_RPCR_get_write_en2(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_RPCR_prp1period_shift                                                   (5)
+#define HDMI_RPCR_prp1period_mask                                                    (0x000001E0)
+#define HDMI_RPCR_prp1period(data)                                                   (0x000001E0&((data)<<5))
+#define HDMI_RPCR_prp1period_src(data)                                               ((0x000001E0&(data))>>5)
+#define HDMI_RPCR_get_prp1period(data)                                               ((0x000001E0&(data))>>5)
+#define HDMI_RPCR_write_en1_shift                                                    (4)
+#define HDMI_RPCR_write_en1_mask                                                     (0x00000010)
+#define HDMI_RPCR_write_en1(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_RPCR_write_en1_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_RPCR_get_write_en1(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_RPCR_prp0period_shift                                                   (0)
+#define HDMI_RPCR_prp0period_mask                                                    (0x0000000F)
+#define HDMI_RPCR_prp0period(data)                                                   (0x0000000F&((data)<<0))
+#define HDMI_RPCR_prp0period_src(data)                                               ((0x0000000F&(data))>>0)
+#define HDMI_RPCR_get_prp0period(data)                                               ((0x0000000F&(data))>>0)
+
+
+#define HDMI_RPEN                                                                    0x9800D0a4
+#define HDMI_RPEN_reg_addr                                                           "0xD800D0A4"
+#define HDMI_RPEN_reg                                                                0xD800D0A4
+#define set_HDMI_RPEN_reg(data)   (*((volatile unsigned int*) HDMI_RPEN_reg)=data)
+#define get_HDMI_RPEN_reg   (*((volatile unsigned int*) HDMI_RPEN_reg))
+#define HDMI_RPEN_inst_adr                                                           "0x0029"
+#define HDMI_RPEN_inst                                                               0x0029
+#define HDMI_RPEN_enprpkt5_shift                                                     (6)
+#define HDMI_RPEN_enprpkt5_mask                                                      (0x00000040)
+#define HDMI_RPEN_enprpkt5(data)                                                     (0x00000040&((data)<<6))
+#define HDMI_RPEN_enprpkt5_src(data)                                                 ((0x00000040&(data))>>6)
+#define HDMI_RPEN_get_enprpkt5(data)                                                 ((0x00000040&(data))>>6)
+#define HDMI_RPEN_enprpkt4_shift                                                     (5)
+#define HDMI_RPEN_enprpkt4_mask                                                      (0x00000020)
+#define HDMI_RPEN_enprpkt4(data)                                                     (0x00000020&((data)<<5))
+#define HDMI_RPEN_enprpkt4_src(data)                                                 ((0x00000020&(data))>>5)
+#define HDMI_RPEN_get_enprpkt4(data)                                                 ((0x00000020&(data))>>5)
+#define HDMI_RPEN_enprpkt3_shift                                                     (4)
+#define HDMI_RPEN_enprpkt3_mask                                                      (0x00000010)
+#define HDMI_RPEN_enprpkt3(data)                                                     (0x00000010&((data)<<4))
+#define HDMI_RPEN_enprpkt3_src(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_RPEN_get_enprpkt3(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_RPEN_enprpkt2_shift                                                     (3)
+#define HDMI_RPEN_enprpkt2_mask                                                      (0x00000008)
+#define HDMI_RPEN_enprpkt2(data)                                                     (0x00000008&((data)<<3))
+#define HDMI_RPEN_enprpkt2_src(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_RPEN_get_enprpkt2(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_RPEN_enprpkt1_shift                                                     (2)
+#define HDMI_RPEN_enprpkt1_mask                                                      (0x00000004)
+#define HDMI_RPEN_enprpkt1(data)                                                     (0x00000004&((data)<<2))
+#define HDMI_RPEN_enprpkt1_src(data)                                                 ((0x00000004&(data))>>2)
+#define HDMI_RPEN_get_enprpkt1(data)                                                 ((0x00000004&(data))>>2)
+#define HDMI_RPEN_enprpkt0_shift                                                     (1)
+#define HDMI_RPEN_enprpkt0_mask                                                      (0x00000002)
+#define HDMI_RPEN_enprpkt0(data)                                                     (0x00000002&((data)<<1))
+#define HDMI_RPEN_enprpkt0_src(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_RPEN_get_enprpkt0(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_RPEN_write_data_shift                                                   (0)
+#define HDMI_RPEN_write_data_mask                                                    (0x00000001)
+#define HDMI_RPEN_write_data(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_RPEN_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_RPEN_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_RPRBDR                                                                  0x9800D0a8
+#define HDMI_RPRBDR_reg_addr                                                         "0xD800D0A8"
+#define HDMI_RPRBDR_reg                                                              0xD800D0A8
+#define set_HDMI_RPRBDR_reg(data)   (*((volatile unsigned int*) HDMI_RPRBDR_reg)=data)
+#define get_HDMI_RPRBDR_reg   (*((volatile unsigned int*) HDMI_RPRBDR_reg))
+#define HDMI_RPRBDR_inst_adr                                                         "0x002A"
+#define HDMI_RPRBDR_inst                                                             0x002A
+#define HDMI_RPRBDR_isramrbd_shift                                                   (0)
+#define HDMI_RPRBDR_isramrbd_mask                                                    (0x0003FFFF)
+#define HDMI_RPRBDR_isramrbd(data)                                                   (0x0003FFFF&((data)<<0))
+#define HDMI_RPRBDR_isramrbd_src(data)                                               ((0x0003FFFF&(data))>>0)
+#define HDMI_RPRBDR_get_isramrbd(data)                                               ((0x0003FFFF&(data))>>0)
+
+
+#define HDMI_OPCR                                                                    0x9800D0b0
+#define HDMI_OPCR_reg_addr                                                           "0xD800D0B0"
+#define HDMI_OPCR_reg                                                                0xD800D0B0
+#define set_HDMI_OPCR_reg(data)   (*((volatile unsigned int*) HDMI_OPCR_reg)=data)
+#define get_HDMI_OPCR_reg   (*((volatile unsigned int*) HDMI_OPCR_reg))
+#define HDMI_OPCR_inst_adr                                                           "0x002C"
+#define HDMI_OPCR_inst                                                               0x002C
+#define HDMI_OPCR_write_en4_shift                                                    (14)
+#define HDMI_OPCR_write_en4_mask                                                     (0x00004000)
+#define HDMI_OPCR_write_en4(data)                                                    (0x00004000&((data)<<14))
+#define HDMI_OPCR_write_en4_src(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_OPCR_get_write_en4(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_OPCR_enrbpktsram_shift                                                  (13)
+#define HDMI_OPCR_enrbpktsram_mask                                                   (0x00002000)
+#define HDMI_OPCR_enrbpktsram(data)                                                  (0x00002000&((data)<<13))
+#define HDMI_OPCR_enrbpktsram_src(data)                                              ((0x00002000&(data))>>13)
+#define HDMI_OPCR_get_enrbpktsram(data)                                              ((0x00002000&(data))>>13)
+#define HDMI_OPCR_write_en3_shift                                                    (12)
+#define HDMI_OPCR_write_en3_mask                                                     (0x00001000)
+#define HDMI_OPCR_write_en3(data)                                                    (0x00001000&((data)<<12))
+#define HDMI_OPCR_write_en3_src(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_OPCR_get_write_en3(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_OPCR_wrdes_shift                                                        (11)
+#define HDMI_OPCR_wrdes_mask                                                         (0x00000800)
+#define HDMI_OPCR_wrdes(data)                                                        (0x00000800&((data)<<11))
+#define HDMI_OPCR_wrdes_src(data)                                                    ((0x00000800&(data))>>11)
+#define HDMI_OPCR_get_wrdes(data)                                                    ((0x00000800&(data))>>11)
+#define HDMI_OPCR_write_en2_shift                                                    (10)
+#define HDMI_OPCR_write_en2_mask                                                     (0x00000400)
+#define HDMI_OPCR_write_en2(data)                                                    (0x00000400&((data)<<10))
+#define HDMI_OPCR_write_en2_src(data)                                                ((0x00000400&(data))>>10)
+#define HDMI_OPCR_get_write_en2(data)                                                ((0x00000400&(data))>>10)
+#define HDMI_OPCR_rprwcmd_shift                                                      (9)
+#define HDMI_OPCR_rprwcmd_mask                                                       (0x00000200)
+#define HDMI_OPCR_rprwcmd(data)                                                      (0x00000200&((data)<<9))
+#define HDMI_OPCR_rprwcmd_src(data)                                                  ((0x00000200&(data))>>9)
+#define HDMI_OPCR_get_rprwcmd(data)                                                  ((0x00000200&(data))>>9)
+#define HDMI_OPCR_write_en1_shift                                                    (8)
+#define HDMI_OPCR_write_en1_mask                                                     (0x00000100)
+#define HDMI_OPCR_write_en1(data)                                                    (0x00000100&((data)<<8))
+#define HDMI_OPCR_write_en1_src(data)                                                ((0x00000100&(data))>>8)
+#define HDMI_OPCR_get_write_en1(data)                                                ((0x00000100&(data))>>8)
+#define HDMI_OPCR_rpadd_shift                                                        (0)
+#define HDMI_OPCR_rpadd_mask                                                         (0x000000FF)
+#define HDMI_OPCR_rpadd(data)                                                        (0x000000FF&((data)<<0))
+#define HDMI_OPCR_rpadd_src(data)                                                    ((0x000000FF&(data))>>0)
+#define HDMI_OPCR_get_rpadd(data)                                                    ((0x000000FF&(data))>>0)
+
+
+#define HDMI_DIPCCR                                                                  0x9800D0b4
+#define HDMI_DIPCCR_reg_addr                                                         "0xD800D0B4"
+#define HDMI_DIPCCR_reg                                                              0xD800D0B4
+#define set_HDMI_DIPCCR_reg(data)   (*((volatile unsigned int*) HDMI_DIPCCR_reg)=data)
+#define get_HDMI_DIPCCR_reg   (*((volatile unsigned int*) HDMI_DIPCCR_reg))
+#define HDMI_DIPCCR_inst_adr                                                         "0x002D"
+#define HDMI_DIPCCR_inst                                                             0x002D
+#define HDMI_DIPCCR_write_en2_shift                                                  (15)
+#define HDMI_DIPCCR_write_en2_mask                                                   (0x00008000)
+#define HDMI_DIPCCR_write_en2(data)                                                  (0x00008000&((data)<<15))
+#define HDMI_DIPCCR_write_en2_src(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_DIPCCR_get_write_en2(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_DIPCCR_vbidipcnt_shift                                                  (8)
+#define HDMI_DIPCCR_vbidipcnt_mask                                                   (0x00007F00)
+#define HDMI_DIPCCR_vbidipcnt(data)                                                  (0x00007F00&((data)<<8))
+#define HDMI_DIPCCR_vbidipcnt_src(data)                                              ((0x00007F00&(data))>>8)
+#define HDMI_DIPCCR_get_vbidipcnt(data)                                              ((0x00007F00&(data))>>8)
+#define HDMI_DIPCCR_write_en1_shift                                                  (7)
+#define HDMI_DIPCCR_write_en1_mask                                                   (0x00000080)
+#define HDMI_DIPCCR_write_en1(data)                                                  (0x00000080&((data)<<7))
+#define HDMI_DIPCCR_write_en1_src(data)                                              ((0x00000080&(data))>>7)
+#define HDMI_DIPCCR_get_write_en1(data)                                              ((0x00000080&(data))>>7)
+#define HDMI_DIPCCR_hbidipcnt_shift                                                  (0)
+#define HDMI_DIPCCR_hbidipcnt_mask                                                   (0x0000007F)
+#define HDMI_DIPCCR_hbidipcnt(data)                                                  (0x0000007F&((data)<<0))
+#define HDMI_DIPCCR_hbidipcnt_src(data)                                              ((0x0000007F&(data))>>0)
+#define HDMI_DIPCCR_get_hbidipcnt(data)                                              ((0x0000007F&(data))>>0)
+
+
+#define HDMI_DIPCCR_2                                                                0x9800D2b0
+#define HDMI_DIPCCR_2_reg_addr                                                       "0xD800D2B0"
+#define HDMI_DIPCCR_2_reg                                                            0xD800D2B0
+#define set_HDMI_DIPCCR_2_reg(data)   (*((volatile unsigned int*) HDMI_DIPCCR_2_reg)=data)
+#define get_HDMI_DIPCCR_2_reg   (*((volatile unsigned int*) HDMI_DIPCCR_2_reg))
+#define HDMI_DIPCCR_2_inst_adr                                                       "0x00AC"
+#define HDMI_DIPCCR_2_inst                                                           0x00AC
+#define HDMI_DIPCCR_2_write_en2_shift                                                (16)
+#define HDMI_DIPCCR_2_write_en2_mask                                                 (0x00010000)
+#define HDMI_DIPCCR_2_write_en2(data)                                                (0x00010000&((data)<<16))
+#define HDMI_DIPCCR_2_write_en2_src(data)                                            ((0x00010000&(data))>>16)
+#define HDMI_DIPCCR_2_get_write_en2(data)                                            ((0x00010000&(data))>>16)
+#define HDMI_DIPCCR_2_FSM_mod_shift                                                  (15)
+#define HDMI_DIPCCR_2_FSM_mod_mask                                                   (0x00008000)
+#define HDMI_DIPCCR_2_FSM_mod(data)                                                  (0x00008000&((data)<<15))
+#define HDMI_DIPCCR_2_FSM_mod_src(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_DIPCCR_2_get_FSM_mod(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_DIPCCR_2_write_en1_shift                                                (14)
+#define HDMI_DIPCCR_2_write_en1_mask                                                 (0x00004000)
+#define HDMI_DIPCCR_2_write_en1(data)                                                (0x00004000&((data)<<14))
+#define HDMI_DIPCCR_2_write_en1_src(data)                                            ((0x00004000&(data))>>14)
+#define HDMI_DIPCCR_2_get_write_en1(data)                                            ((0x00004000&(data))>>14)
+#define HDMI_DIPCCR_2_hblank_pixel2tmds_shift                                        (0)
+#define HDMI_DIPCCR_2_hblank_pixel2tmds_mask                                         (0x00003FFF)
+#define HDMI_DIPCCR_2_hblank_pixel2tmds(data)                                        (0x00003FFF&((data)<<0))
+#define HDMI_DIPCCR_2_hblank_pixel2tmds_src(data)                                    ((0x00003FFF&(data))>>0)
+#define HDMI_DIPCCR_2_get_hblank_pixel2tmds(data)                                    ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_DIPCCR_3                                                                0x9800D2b4
+#define HDMI_DIPCCR_3_reg_addr                                                       "0xD800D2B4"
+#define HDMI_DIPCCR_3_reg                                                            0xD800D2B4
+#define set_HDMI_DIPCCR_3_reg(data)   (*((volatile unsigned int*) HDMI_DIPCCR_3_reg)=data)
+#define get_HDMI_DIPCCR_3_reg   (*((volatile unsigned int*) HDMI_DIPCCR_3_reg))
+#define HDMI_DIPCCR_3_inst_adr                                                       "0x00AD"
+#define HDMI_DIPCCR_3_inst                                                           0x00AD
+#define HDMI_DIPCCR_3_write_en2_shift                                                (29)
+#define HDMI_DIPCCR_3_write_en2_mask                                                 (0x20000000)
+#define HDMI_DIPCCR_3_write_en2(data)                                                (0x20000000&((data)<<29))
+#define HDMI_DIPCCR_3_write_en2_src(data)                                            ((0x20000000&(data))>>29)
+#define HDMI_DIPCCR_3_get_write_en2(data)                                            ((0x20000000&(data))>>29)
+#define HDMI_DIPCCR_3_hblank_cnt_wait_st_shift                                       (15)
+#define HDMI_DIPCCR_3_hblank_cnt_wait_st_mask                                        (0x1FFF8000)
+#define HDMI_DIPCCR_3_hblank_cnt_wait_st(data)                                       (0x1FFF8000&((data)<<15))
+#define HDMI_DIPCCR_3_hblank_cnt_wait_st_src(data)                                   ((0x1FFF8000&(data))>>15)
+#define HDMI_DIPCCR_3_get_hblank_cnt_wait_st(data)                                   ((0x1FFF8000&(data))>>15)
+#define HDMI_DIPCCR_3_write_en1_shift                                                (14)
+#define HDMI_DIPCCR_3_write_en1_mask                                                 (0x00004000)
+#define HDMI_DIPCCR_3_write_en1(data)                                                (0x00004000&((data)<<14))
+#define HDMI_DIPCCR_3_write_en1_src(data)                                            ((0x00004000&(data))>>14)
+#define HDMI_DIPCCR_3_get_write_en1(data)                                            ((0x00004000&(data))>>14)
+#define HDMI_DIPCCR_3_hblank_cnt_island_st_shift                                     (0)
+#define HDMI_DIPCCR_3_hblank_cnt_island_st_mask                                      (0x00003FFF)
+#define HDMI_DIPCCR_3_hblank_cnt_island_st(data)                                     (0x00003FFF&((data)<<0))
+#define HDMI_DIPCCR_3_hblank_cnt_island_st_src(data)                                 ((0x00003FFF&(data))>>0)
+#define HDMI_DIPCCR_3_get_hblank_cnt_island_st(data)                                 ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_SCHCR                                                                   0x9800D0b8
+#define HDMI_SCHCR_reg_addr                                                          "0xD800D0B8"
+#define HDMI_SCHCR_reg                                                               0xD800D0B8
+#define set_HDMI_SCHCR_reg(data)   (*((volatile unsigned int*) HDMI_SCHCR_reg)=data)
+#define get_HDMI_SCHCR_reg   (*((volatile unsigned int*) HDMI_SCHCR_reg))
+#define HDMI_SCHCR_inst_adr                                                          "0x002E"
+#define HDMI_SCHCR_inst                                                              0x002E
+#define HDMI_SCHCR_write_en12_shift                                                  (28)
+#define HDMI_SCHCR_write_en12_mask                                                   (0x10000000)
+#define HDMI_SCHCR_write_en12(data)                                                  (0x10000000&((data)<<28))
+#define HDMI_SCHCR_write_en12_src(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_SCHCR_get_write_en12(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_SCHCR_color_transform_en_shift                                          (27)
+#define HDMI_SCHCR_color_transform_en_mask                                           (0x08000000)
+#define HDMI_SCHCR_color_transform_en(data)                                          (0x08000000&((data)<<27))
+#define HDMI_SCHCR_color_transform_en_src(data)                                      ((0x08000000&(data))>>27)
+#define HDMI_SCHCR_get_color_transform_en(data)                                      ((0x08000000&(data))>>27)
+#define HDMI_SCHCR_write_en11_shift                                                  (26)
+#define HDMI_SCHCR_write_en11_mask                                                   (0x04000000)
+#define HDMI_SCHCR_write_en11(data)                                                  (0x04000000&((data)<<26))
+#define HDMI_SCHCR_write_en11_src(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_SCHCR_get_write_en11(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_SCHCR_ycbcr422_algo_shift                                               (25)
+#define HDMI_SCHCR_ycbcr422_algo_mask                                                (0x02000000)
+#define HDMI_SCHCR_ycbcr422_algo(data)                                               (0x02000000&((data)<<25))
+#define HDMI_SCHCR_ycbcr422_algo_src(data)                                           ((0x02000000&(data))>>25)
+#define HDMI_SCHCR_get_ycbcr422_algo(data)                                           ((0x02000000&(data))>>25)
+#define HDMI_SCHCR_write_en10_shift                                                  (24)
+#define HDMI_SCHCR_write_en10_mask                                                   (0x01000000)
+#define HDMI_SCHCR_write_en10(data)                                                  (0x01000000&((data)<<24))
+#define HDMI_SCHCR_write_en10_src(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_SCHCR_get_write_en10(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_SCHCR_422_pixel_repeat_shift                                            (23)
+#define HDMI_SCHCR_422_pixel_repeat_mask                                             (0x00800000)
+#define HDMI_SCHCR_422_pixel_repeat(data)                                            (0x00800000&((data)<<23))
+#define HDMI_SCHCR_422_pixel_repeat_src(data)                                        ((0x00800000&(data))>>23)
+#define HDMI_SCHCR_get_422_pixel_repeat(data)                                        ((0x00800000&(data))>>23)
+#define HDMI_SCHCR_write_en9_shift                                                   (22)
+#define HDMI_SCHCR_write_en9_mask                                                    (0x00400000)
+#define HDMI_SCHCR_write_en9(data)                                                   (0x00400000&((data)<<22))
+#define HDMI_SCHCR_write_en9_src(data)                                               ((0x00400000&(data))>>22)
+#define HDMI_SCHCR_get_write_en9(data)                                               ((0x00400000&(data))>>22)
+#define HDMI_SCHCR_vsyncpolin_shift                                                  (21)
+#define HDMI_SCHCR_vsyncpolin_mask                                                   (0x00200000)
+#define HDMI_SCHCR_vsyncpolin(data)                                                  (0x00200000&((data)<<21))
+#define HDMI_SCHCR_vsyncpolin_src(data)                                              ((0x00200000&(data))>>21)
+#define HDMI_SCHCR_get_vsyncpolin(data)                                              ((0x00200000&(data))>>21)
+#define HDMI_SCHCR_write_en8_shift                                                   (20)
+#define HDMI_SCHCR_write_en8_mask                                                    (0x00100000)
+#define HDMI_SCHCR_write_en8(data)                                                   (0x00100000&((data)<<20))
+#define HDMI_SCHCR_write_en8_src(data)                                               ((0x00100000&(data))>>20)
+#define HDMI_SCHCR_get_write_en8(data)                                               ((0x00100000&(data))>>20)
+#define HDMI_SCHCR_hsyncpolin_shift                                                  (19)
+#define HDMI_SCHCR_hsyncpolin_mask                                                   (0x00080000)
+#define HDMI_SCHCR_hsyncpolin(data)                                                  (0x00080000&((data)<<19))
+#define HDMI_SCHCR_hsyncpolin_src(data)                                              ((0x00080000&(data))>>19)
+#define HDMI_SCHCR_get_hsyncpolin(data)                                              ((0x00080000&(data))>>19)
+#define HDMI_SCHCR_write_en7_shift                                                   (18)
+#define HDMI_SCHCR_write_en7_mask                                                    (0x00040000)
+#define HDMI_SCHCR_write_en7(data)                                                   (0x00040000&((data)<<18))
+#define HDMI_SCHCR_write_en7_src(data)                                               ((0x00040000&(data))>>18)
+#define HDMI_SCHCR_get_write_en7(data)                                               ((0x00040000&(data))>>18)
+#define HDMI_SCHCR_vsyncpolinv_shift                                                 (17)
+#define HDMI_SCHCR_vsyncpolinv_mask                                                  (0x00020000)
+#define HDMI_SCHCR_vsyncpolinv(data)                                                 (0x00020000&((data)<<17))
+#define HDMI_SCHCR_vsyncpolinv_src(data)                                             ((0x00020000&(data))>>17)
+#define HDMI_SCHCR_get_vsyncpolinv(data)                                             ((0x00020000&(data))>>17)
+#define HDMI_SCHCR_write_en6_shift                                                   (16)
+#define HDMI_SCHCR_write_en6_mask                                                    (0x00010000)
+#define HDMI_SCHCR_write_en6(data)                                                   (0x00010000&((data)<<16))
+#define HDMI_SCHCR_write_en6_src(data)                                               ((0x00010000&(data))>>16)
+#define HDMI_SCHCR_get_write_en6(data)                                               ((0x00010000&(data))>>16)
+#define HDMI_SCHCR_hsyncpolinv_shift                                                 (15)
+#define HDMI_SCHCR_hsyncpolinv_mask                                                  (0x00008000)
+#define HDMI_SCHCR_hsyncpolinv(data)                                                 (0x00008000&((data)<<15))
+#define HDMI_SCHCR_hsyncpolinv_src(data)                                             ((0x00008000&(data))>>15)
+#define HDMI_SCHCR_get_hsyncpolinv(data)                                             ((0x00008000&(data))>>15)
+#define HDMI_SCHCR_write_en5_shift                                                   (14)
+#define HDMI_SCHCR_write_en5_mask                                                    (0x00004000)
+#define HDMI_SCHCR_write_en5(data)                                                   (0x00004000&((data)<<14))
+#define HDMI_SCHCR_write_en5_src(data)                                               ((0x00004000&(data))>>14)
+#define HDMI_SCHCR_get_write_en5(data)                                               ((0x00004000&(data))>>14)
+#define HDMI_SCHCR_pixelencycbcr422_shift                                            (13)
+#define HDMI_SCHCR_pixelencycbcr422_mask                                             (0x00002000)
+#define HDMI_SCHCR_pixelencycbcr422(data)                                            (0x00002000&((data)<<13))
+#define HDMI_SCHCR_pixelencycbcr422_src(data)                                        ((0x00002000&(data))>>13)
+#define HDMI_SCHCR_get_pixelencycbcr422(data)                                        ((0x00002000&(data))>>13)
+#define HDMI_SCHCR_write_en4_shift                                                   (12)
+#define HDMI_SCHCR_write_en4_mask                                                    (0x00001000)
+#define HDMI_SCHCR_write_en4(data)                                                   (0x00001000&((data)<<12))
+#define HDMI_SCHCR_write_en4_src(data)                                               ((0x00001000&(data))>>12)
+#define HDMI_SCHCR_get_write_en4(data)                                               ((0x00001000&(data))>>12)
+#define HDMI_SCHCR_hdmi_videoxs_shift                                                (7)
+#define HDMI_SCHCR_hdmi_videoxs_mask                                                 (0x00000F80)
+#define HDMI_SCHCR_hdmi_videoxs(data)                                                (0x00000F80&((data)<<7))
+#define HDMI_SCHCR_hdmi_videoxs_src(data)                                            ((0x00000F80&(data))>>7)
+#define HDMI_SCHCR_get_hdmi_videoxs(data)                                            ((0x00000F80&(data))>>7)
+#define HDMI_SCHCR_write_en3_shift                                                   (6)
+#define HDMI_SCHCR_write_en3_mask                                                    (0x00000040)
+#define HDMI_SCHCR_write_en3(data)                                                   (0x00000040&((data)<<6))
+#define HDMI_SCHCR_write_en3_src(data)                                               ((0x00000040&(data))>>6)
+#define HDMI_SCHCR_get_write_en3(data)                                               ((0x00000040&(data))>>6)
+#define HDMI_SCHCR_pixelencfmt_shift                                                 (4)
+#define HDMI_SCHCR_pixelencfmt_mask                                                  (0x00000030)
+#define HDMI_SCHCR_pixelencfmt(data)                                                 (0x00000030&((data)<<4))
+#define HDMI_SCHCR_pixelencfmt_src(data)                                             ((0x00000030&(data))>>4)
+#define HDMI_SCHCR_get_pixelencfmt(data)                                             ((0x00000030&(data))>>4)
+#define HDMI_SCHCR_write_en2_shift                                                   (3)
+#define HDMI_SCHCR_write_en2_mask                                                    (0x00000008)
+#define HDMI_SCHCR_write_en2(data)                                                   (0x00000008&((data)<<3))
+#define HDMI_SCHCR_write_en2_src(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_SCHCR_get_write_en2(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_SCHCR_pixelrepeat_shift                                                 (2)
+#define HDMI_SCHCR_pixelrepeat_mask                                                  (0x00000004)
+#define HDMI_SCHCR_pixelrepeat(data)                                                 (0x00000004&((data)<<2))
+#define HDMI_SCHCR_pixelrepeat_src(data)                                             ((0x00000004&(data))>>2)
+#define HDMI_SCHCR_get_pixelrepeat(data)                                             ((0x00000004&(data))>>2)
+#define HDMI_SCHCR_write_en1_shift                                                   (1)
+#define HDMI_SCHCR_write_en1_mask                                                    (0x00000002)
+#define HDMI_SCHCR_write_en1(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_SCHCR_write_en1_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_SCHCR_get_write_en1(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_SCHCR_hdmi_modesel_shift                                                (0)
+#define HDMI_SCHCR_hdmi_modesel_mask                                                 (0x00000001)
+#define HDMI_SCHCR_hdmi_modesel(data)                                                (0x00000001&((data)<<0))
+#define HDMI_SCHCR_hdmi_modesel_src(data)                                            ((0x00000001&(data))>>0)
+#define HDMI_SCHCR_get_hdmi_modesel(data)                                            ((0x00000001&(data))>>0)
+
+
+#define HDMI_ICR                                                                     0x9800D0bc
+#define HDMI_ICR_reg_addr                                                            "0xD800D0BC"
+#define HDMI_ICR_reg                                                                 0xD800D0BC
+#define set_HDMI_ICR_reg(data)   (*((volatile unsigned int*) HDMI_ICR_reg)=data)
+#define get_HDMI_ICR_reg   (*((volatile unsigned int*) HDMI_ICR_reg))
+#define HDMI_ICR_inst_adr                                                            "0x002F"
+#define HDMI_ICR_inst                                                                0x002F
+#define HDMI_ICR_write_en3_shift                                                     (28)
+#define HDMI_ICR_write_en3_mask                                                      (0x10000000)
+#define HDMI_ICR_write_en3(data)                                                     (0x10000000&((data)<<28))
+#define HDMI_ICR_write_en3_src(data)                                                 ((0x10000000&(data))>>28)
+#define HDMI_ICR_get_write_en3(data)                                                 ((0x10000000&(data))>>28)
+#define HDMI_ICR_enaudio_shift                                                       (27)
+#define HDMI_ICR_enaudio_mask                                                        (0x08000000)
+#define HDMI_ICR_enaudio(data)                                                       (0x08000000&((data)<<27))
+#define HDMI_ICR_enaudio_src(data)                                                   ((0x08000000&(data))>>27)
+#define HDMI_ICR_get_enaudio(data)                                                   ((0x08000000&(data))>>27)
+#define HDMI_ICR_write_en2_shift                                                     (26)
+#define HDMI_ICR_write_en2_mask                                                      (0x04000000)
+#define HDMI_ICR_write_en2(data)                                                     (0x04000000&((data)<<26))
+#define HDMI_ICR_write_en2_src(data)                                                 ((0x04000000&(data))>>26)
+#define HDMI_ICR_get_write_en2(data)                                                 ((0x04000000&(data))>>26)
+#define HDMI_ICR_envitd_shift                                                        (25)
+#define HDMI_ICR_envitd_mask                                                         (0x02000000)
+#define HDMI_ICR_envitd(data)                                                        (0x02000000&((data)<<25))
+#define HDMI_ICR_envitd_src(data)                                                    ((0x02000000&(data))>>25)
+#define HDMI_ICR_get_envitd(data)                                                    ((0x02000000&(data))>>25)
+#define HDMI_ICR_write_en1_shift                                                     (24)
+#define HDMI_ICR_write_en1_mask                                                      (0x01000000)
+#define HDMI_ICR_write_en1(data)                                                     (0x01000000&((data)<<24))
+#define HDMI_ICR_write_en1_src(data)                                                 ((0x01000000&(data))>>24)
+#define HDMI_ICR_get_write_en1(data)                                                 ((0x01000000&(data))>>24)
+#define HDMI_ICR_vitd_shift                                                          (0)
+#define HDMI_ICR_vitd_mask                                                           (0x00FFFFFF)
+#define HDMI_ICR_vitd(data)                                                          (0x00FFFFFF&((data)<<0))
+#define HDMI_ICR_vitd_src(data)                                                      ((0x00FFFFFF&(data))>>0)
+#define HDMI_ICR_get_vitd(data)                                                      ((0x00FFFFFF&(data))>>0)
+
+
+#define HDMI_ICR1                                                                    0x9800D150
+#define HDMI_ICR1_reg_addr                                                           "0xD800D150"
+#define HDMI_ICR1_reg                                                                0xD800D150
+#define set_HDMI_ICR1_reg(data)   (*((volatile unsigned int*) HDMI_ICR1_reg)=data)
+#define get_HDMI_ICR1_reg   (*((volatile unsigned int*) HDMI_ICR1_reg))
+#define HDMI_ICR1_inst_adr                                                           "0x0054"
+#define HDMI_ICR1_inst                                                               0x0054
+#define HDMI_ICR1_write_en1_shift                                                    (12)
+#define HDMI_ICR1_write_en1_mask                                                     (0x00001000)
+#define HDMI_ICR1_write_en1(data)                                                    (0x00001000&((data)<<12))
+#define HDMI_ICR1_write_en1_src(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_ICR1_get_write_en1(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_ICR1_vitd_shift                                                         (0)
+#define HDMI_ICR1_vitd_mask                                                          (0x00000FFF)
+#define HDMI_ICR1_vitd(data)                                                         (0x00000FFF&((data)<<0))
+#define HDMI_ICR1_vitd_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define HDMI_ICR1_get_vitd(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_CRCCR                                                                   0x9800D0c0
+#define HDMI_CRCCR_reg_addr                                                          "0xD800D0C0"
+#define HDMI_CRCCR_reg                                                               0xD800D0C0
+#define set_HDMI_CRCCR_reg(data)   (*((volatile unsigned int*) HDMI_CRCCR_reg)=data)
+#define get_HDMI_CRCCR_reg   (*((volatile unsigned int*) HDMI_CRCCR_reg))
+#define HDMI_CRCCR_inst_adr                                                          "0x0030"
+#define HDMI_CRCCR_inst                                                              0x0030
+#define HDMI_CRCCR_write_en2_shift                                                   (4)
+#define HDMI_CRCCR_write_en2_mask                                                    (0x00000010)
+#define HDMI_CRCCR_write_en2(data)                                                   (0x00000010&((data)<<4))
+#define HDMI_CRCCR_write_en2_src(data)                                               ((0x00000010&(data))>>4)
+#define HDMI_CRCCR_get_write_en2(data)                                               ((0x00000010&(data))>>4)
+#define HDMI_CRCCR_crcmode_shift                                                     (3)
+#define HDMI_CRCCR_crcmode_mask                                                      (0x00000008)
+#define HDMI_CRCCR_crcmode(data)                                                     (0x00000008&((data)<<3))
+#define HDMI_CRCCR_crcmode_src(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_CRCCR_get_crcmode(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_CRCCR_write_en1_shift                                                   (2)
+#define HDMI_CRCCR_write_en1_mask                                                    (0x00000004)
+#define HDMI_CRCCR_write_en1(data)                                                   (0x00000004&((data)<<2))
+#define HDMI_CRCCR_write_en1_src(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_CRCCR_get_write_en1(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_CRCCR_crcchsel_shift                                                    (0)
+#define HDMI_CRCCR_crcchsel_mask                                                     (0x00000003)
+#define HDMI_CRCCR_crcchsel(data)                                                    (0x00000003&((data)<<0))
+#define HDMI_CRCCR_crcchsel_src(data)                                                ((0x00000003&(data))>>0)
+#define HDMI_CRCCR_get_crcchsel(data)                                                ((0x00000003&(data))>>0)
+
+
+#define HDMI_CRCDOR                                                                  0x9800D0c4
+#define HDMI_CRCDOR_reg_addr                                                         "0xD800D0C4"
+#define HDMI_CRCDOR_reg                                                              0xD800D0C4
+#define set_HDMI_CRCDOR_reg(data)   (*((volatile unsigned int*) HDMI_CRCDOR_reg)=data)
+#define get_HDMI_CRCDOR_reg   (*((volatile unsigned int*) HDMI_CRCDOR_reg))
+#define HDMI_CRCDOR_inst_adr                                                         "0x0031"
+#define HDMI_CRCDOR_inst                                                             0x0031
+#define HDMI_CRCDOR_crcvalue_shift                                                   (0)
+#define HDMI_CRCDOR_crcvalue_mask                                                    (0xFFFFFFFF)
+#define HDMI_CRCDOR_crcvalue(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_CRCDOR_crcvalue_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_CRCDOR_get_crcvalue(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_KOWR                                                               0x9800D300
+#define HDMI_HDCP_KOWR_reg_addr                                                      "0xD800D300"
+#define HDMI_HDCP_KOWR_reg                                                           0xD800D300
+#define set_HDMI_HDCP_KOWR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KOWR_reg)=data)
+#define get_HDMI_HDCP_KOWR_reg   (*((volatile unsigned int*) HDMI_HDCP_KOWR_reg))
+#define HDMI_HDCP_KOWR_inst_adr                                                      "0x00C0"
+#define HDMI_HDCP_KOWR_inst                                                          0x00C0
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin_shift                                     (0)
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin_mask                                      (0x000000FF)
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin(data)                                     (0x000000FF&((data)<<0))
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin_src(data)                                 ((0x000000FF&(data))>>0)
+#define HDMI_HDCP_KOWR_get_hdcprekeykeepoutwin(data)                                 ((0x000000FF&(data))>>0)
+
+
+#define HDMI_HDCP_KOWRSE                                                             0x9800D304
+#define HDMI_HDCP_KOWRSE_reg_addr                                                    "0xD800D304"
+#define HDMI_HDCP_KOWRSE_reg                                                         0xD800D304
+#define set_HDMI_HDCP_KOWRSE_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KOWRSE_reg)=data)
+#define get_HDMI_HDCP_KOWRSE_reg   (*((volatile unsigned int*) HDMI_HDCP_KOWRSE_reg))
+#define HDMI_HDCP_KOWRSE_inst_adr                                                    "0x00C1"
+#define HDMI_HDCP_KOWRSE_inst                                                        0x00C1
+#define HDMI_HDCP_KOWRSE_write_en2_shift                                             (25)
+#define HDMI_HDCP_KOWRSE_write_en2_mask                                              (0x02000000)
+#define HDMI_HDCP_KOWRSE_write_en2(data)                                             (0x02000000&((data)<<25))
+#define HDMI_HDCP_KOWRSE_write_en2_src(data)                                         ((0x02000000&(data))>>25)
+#define HDMI_HDCP_KOWRSE_get_write_en2(data)                                         ((0x02000000&(data))>>25)
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend_shift                                  (13)
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend_mask                                   (0x01FFE000)
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend(data)                                  (0x01FFE000&((data)<<13))
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend_src(data)                              ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_KOWRSE_get_hdcpverkeepoutwinend(data)                              ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_KOWRSE_write_en1_shift                                             (12)
+#define HDMI_HDCP_KOWRSE_write_en1_mask                                              (0x00001000)
+#define HDMI_HDCP_KOWRSE_write_en1(data)                                             (0x00001000&((data)<<12))
+#define HDMI_HDCP_KOWRSE_write_en1_src(data)                                         ((0x00001000&(data))>>12)
+#define HDMI_HDCP_KOWRSE_get_write_en1(data)                                         ((0x00001000&(data))>>12)
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart_shift                               (0)
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart_mask                                (0x00000FFF)
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart(data)                               (0x00000FFF&((data)<<0))
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart_src(data)                           ((0x00000FFF&(data))>>0)
+#define HDMI_HDCP_KOWRSE_get_hdcpvertkeepoutwinstart(data)                           ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_HDCP_OWR                                                                0x9800D308
+#define HDMI_HDCP_OWR_reg_addr                                                       "0xD800D308"
+#define HDMI_HDCP_OWR_reg                                                            0xD800D308
+#define set_HDMI_HDCP_OWR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_OWR_reg)=data)
+#define get_HDMI_HDCP_OWR_reg   (*((volatile unsigned int*) HDMI_HDCP_OWR_reg))
+#define HDMI_HDCP_OWR_inst_adr                                                       "0x00C2"
+#define HDMI_HDCP_OWR_inst                                                           0x00C2
+#define HDMI_HDCP_OWR_write_en2_shift                                                (25)
+#define HDMI_HDCP_OWR_write_en2_mask                                                 (0x02000000)
+#define HDMI_HDCP_OWR_write_en2(data)                                                (0x02000000&((data)<<25))
+#define HDMI_HDCP_OWR_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define HDMI_HDCP_OWR_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define HDMI_HDCP_OWR_hdcpoppwinend_shift                                            (13)
+#define HDMI_HDCP_OWR_hdcpoppwinend_mask                                             (0x01FFE000)
+#define HDMI_HDCP_OWR_hdcpoppwinend(data)                                            (0x01FFE000&((data)<<13))
+#define HDMI_HDCP_OWR_hdcpoppwinend_src(data)                                        ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_OWR_get_hdcpoppwinend(data)                                        ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_OWR_write_en1_shift                                                (12)
+#define HDMI_HDCP_OWR_write_en1_mask                                                 (0x00001000)
+#define HDMI_HDCP_OWR_write_en1(data)                                                (0x00001000&((data)<<12))
+#define HDMI_HDCP_OWR_write_en1_src(data)                                            ((0x00001000&(data))>>12)
+#define HDMI_HDCP_OWR_get_write_en1(data)                                            ((0x00001000&(data))>>12)
+#define HDMI_HDCP_OWR_hdcpoppwinstart_shift                                          (0)
+#define HDMI_HDCP_OWR_hdcpoppwinstart_mask                                           (0x00000FFF)
+#define HDMI_HDCP_OWR_hdcpoppwinstart(data)                                          (0x00000FFF&((data)<<0))
+#define HDMI_HDCP_OWR_hdcpoppwinstart_src(data)                                      ((0x00000FFF&(data))>>0)
+#define HDMI_HDCP_OWR_get_hdcpoppwinstart(data)                                      ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_HDCP_CR                                                                 0x9800D30c
+#define HDMI_HDCP_CR_reg_addr                                                        "0xD800D30C"
+#define HDMI_HDCP_CR_reg                                                             0xD800D30C
+#define set_HDMI_HDCP_CR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_CR_reg)=data)
+#define get_HDMI_HDCP_CR_reg   (*((volatile unsigned int*) HDMI_HDCP_CR_reg))
+#define HDMI_HDCP_CR_inst_adr                                                        "0x00C3"
+#define HDMI_HDCP_CR_inst                                                            0x00C3
+#define HDMI_HDCP_CR_write_en6_shift                                                 (11)
+#define HDMI_HDCP_CR_write_en6_mask                                                  (0x00000800)
+#define HDMI_HDCP_CR_write_en6(data)                                                 (0x00000800&((data)<<11))
+#define HDMI_HDCP_CR_write_en6_src(data)                                             ((0x00000800&(data))>>11)
+#define HDMI_HDCP_CR_get_write_en6(data)                                             ((0x00000800&(data))>>11)
+#define HDMI_HDCP_CR_avmute_sel_shift                                                (10)
+#define HDMI_HDCP_CR_avmute_sel_mask                                                 (0x00000400)
+#define HDMI_HDCP_CR_avmute_sel(data)                                                (0x00000400&((data)<<10))
+#define HDMI_HDCP_CR_avmute_sel_src(data)                                            ((0x00000400&(data))>>10)
+#define HDMI_HDCP_CR_get_avmute_sel(data)                                            ((0x00000400&(data))>>10)
+#define HDMI_HDCP_CR_write_en5_shift                                                 (9)
+#define HDMI_HDCP_CR_write_en5_mask                                                  (0x00000200)
+#define HDMI_HDCP_CR_write_en5(data)                                                 (0x00000200&((data)<<9))
+#define HDMI_HDCP_CR_write_en5_src(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_HDCP_CR_get_write_en5(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_HDCP_CR_enablehdcp_shift                                                (8)
+#define HDMI_HDCP_CR_enablehdcp_mask                                                 (0x00000100)
+#define HDMI_HDCP_CR_enablehdcp(data)                                                (0x00000100&((data)<<8))
+#define HDMI_HDCP_CR_enablehdcp_src(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_HDCP_CR_get_enablehdcp(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_HDCP_CR_write_en4_shift                                                 (7)
+#define HDMI_HDCP_CR_write_en4_mask                                                  (0x00000080)
+#define HDMI_HDCP_CR_write_en4(data)                                                 (0x00000080&((data)<<7))
+#define HDMI_HDCP_CR_write_en4_src(data)                                             ((0x00000080&(data))>>7)
+#define HDMI_HDCP_CR_get_write_en4(data)                                             ((0x00000080&(data))>>7)
+#define HDMI_HDCP_CR_en1_1_feature_shift                                             (6)
+#define HDMI_HDCP_CR_en1_1_feature_mask                                              (0x00000040)
+#define HDMI_HDCP_CR_en1_1_feature(data)                                             (0x00000040&((data)<<6))
+#define HDMI_HDCP_CR_en1_1_feature_src(data)                                         ((0x00000040&(data))>>6)
+#define HDMI_HDCP_CR_get_en1_1_feature(data)                                         ((0x00000040&(data))>>6)
+#define HDMI_HDCP_CR_write_en3_shift                                                 (5)
+#define HDMI_HDCP_CR_write_en3_mask                                                  (0x00000020)
+#define HDMI_HDCP_CR_write_en3(data)                                                 (0x00000020&((data)<<5))
+#define HDMI_HDCP_CR_write_en3_src(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_HDCP_CR_get_write_en3(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_HDCP_CR_downstrisrepeater_shift                                         (4)
+#define HDMI_HDCP_CR_downstrisrepeater_mask                                          (0x00000010)
+#define HDMI_HDCP_CR_downstrisrepeater(data)                                         (0x00000010&((data)<<4))
+#define HDMI_HDCP_CR_downstrisrepeater_src(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_HDCP_CR_get_downstrisrepeater(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_HDCP_CR_write_en2_shift                                                 (3)
+#define HDMI_HDCP_CR_write_en2_mask                                                  (0x00000008)
+#define HDMI_HDCP_CR_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define HDMI_HDCP_CR_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_HDCP_CR_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_HDCP_CR_aninfluencemode_shift                                           (2)
+#define HDMI_HDCP_CR_aninfluencemode_mask                                            (0x00000004)
+#define HDMI_HDCP_CR_aninfluencemode(data)                                           (0x00000004&((data)<<2))
+#define HDMI_HDCP_CR_aninfluencemode_src(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_HDCP_CR_get_aninfluencemode(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_HDCP_CR_write_en1_shift                                                 (1)
+#define HDMI_HDCP_CR_write_en1_mask                                                  (0x00000002)
+#define HDMI_HDCP_CR_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_HDCP_CR_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_CR_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_CR_hdcp_encryptenable_shift                                        (0)
+#define HDMI_HDCP_CR_hdcp_encryptenable_mask                                         (0x00000001)
+#define HDMI_HDCP_CR_hdcp_encryptenable(data)                                        (0x00000001&((data)<<0))
+#define HDMI_HDCP_CR_hdcp_encryptenable_src(data)                                    ((0x00000001&(data))>>0)
+#define HDMI_HDCP_CR_get_hdcp_encryptenable(data)                                    ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_AUTH                                                               0x9800D310
+#define HDMI_HDCP_AUTH_reg_addr                                                      "0xD800D310"
+#define HDMI_HDCP_AUTH_reg                                                           0xD800D310
+#define set_HDMI_HDCP_AUTH_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_AUTH_reg)=data)
+#define get_HDMI_HDCP_AUTH_reg   (*((volatile unsigned int*) HDMI_HDCP_AUTH_reg))
+#define HDMI_HDCP_AUTH_inst_adr                                                      "0x00C4"
+#define HDMI_HDCP_AUTH_inst                                                          0x00C4
+#define HDMI_HDCP_AUTH_write_en9_shift                                               (17)
+#define HDMI_HDCP_AUTH_write_en9_mask                                                (0x00020000)
+#define HDMI_HDCP_AUTH_write_en9(data)                                               (0x00020000&((data)<<17))
+#define HDMI_HDCP_AUTH_write_en9_src(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_HDCP_AUTH_get_write_en9(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_HDCP_AUTH_ddpken_shift                                                  (16)
+#define HDMI_HDCP_AUTH_ddpken_mask                                                   (0x00010000)
+#define HDMI_HDCP_AUTH_ddpken(data)                                                  (0x00010000&((data)<<16))
+#define HDMI_HDCP_AUTH_ddpken_src(data)                                              ((0x00010000&(data))>>16)
+#define HDMI_HDCP_AUTH_get_ddpken(data)                                              ((0x00010000&(data))>>16)
+#define HDMI_HDCP_AUTH_write_en8_shift                                               (15)
+#define HDMI_HDCP_AUTH_write_en8_mask                                                (0x00008000)
+#define HDMI_HDCP_AUTH_write_en8(data)                                               (0x00008000&((data)<<15))
+#define HDMI_HDCP_AUTH_write_en8_src(data)                                           ((0x00008000&(data))>>15)
+#define HDMI_HDCP_AUTH_get_write_en8(data)                                           ((0x00008000&(data))>>15)
+#define HDMI_HDCP_AUTH_resetkmacc_shift                                              (14)
+#define HDMI_HDCP_AUTH_resetkmacc_mask                                               (0x00004000)
+#define HDMI_HDCP_AUTH_resetkmacc(data)                                              (0x00004000&((data)<<14))
+#define HDMI_HDCP_AUTH_resetkmacc_src(data)                                          ((0x00004000&(data))>>14)
+#define HDMI_HDCP_AUTH_get_resetkmacc(data)                                          ((0x00004000&(data))>>14)
+#define HDMI_HDCP_AUTH_write_en7_shift                                               (13)
+#define HDMI_HDCP_AUTH_write_en7_mask                                                (0x00002000)
+#define HDMI_HDCP_AUTH_write_en7(data)                                               (0x00002000&((data)<<13))
+#define HDMI_HDCP_AUTH_write_en7_src(data)                                           ((0x00002000&(data))>>13)
+#define HDMI_HDCP_AUTH_get_write_en7(data)                                           ((0x00002000&(data))>>13)
+#define HDMI_HDCP_AUTH_update_an_shift                                               (12)
+#define HDMI_HDCP_AUTH_update_an_mask                                                (0x00001000)
+#define HDMI_HDCP_AUTH_update_an(data)                                               (0x00001000&((data)<<12))
+#define HDMI_HDCP_AUTH_update_an_src(data)                                           ((0x00001000&(data))>>12)
+#define HDMI_HDCP_AUTH_get_update_an(data)                                           ((0x00001000&(data))>>12)
+#define HDMI_HDCP_AUTH_write_en6_shift                                               (11)
+#define HDMI_HDCP_AUTH_write_en6_mask                                                (0x00000800)
+#define HDMI_HDCP_AUTH_write_en6(data)                                               (0x00000800&((data)<<11))
+#define HDMI_HDCP_AUTH_write_en6_src(data)                                           ((0x00000800&(data))>>11)
+#define HDMI_HDCP_AUTH_get_write_en6(data)                                           ((0x00000800&(data))>>11)
+#define HDMI_HDCP_AUTH_aninfreq_shift                                                (10)
+#define HDMI_HDCP_AUTH_aninfreq_mask                                                 (0x00000400)
+#define HDMI_HDCP_AUTH_aninfreq(data)                                                (0x00000400&((data)<<10))
+#define HDMI_HDCP_AUTH_aninfreq_src(data)                                            ((0x00000400&(data))>>10)
+#define HDMI_HDCP_AUTH_get_aninfreq(data)                                            ((0x00000400&(data))>>10)
+#define HDMI_HDCP_AUTH_write_en5_shift                                               (9)
+#define HDMI_HDCP_AUTH_write_en5_mask                                                (0x00000200)
+#define HDMI_HDCP_AUTH_write_en5(data)                                               (0x00000200&((data)<<9))
+#define HDMI_HDCP_AUTH_write_en5_src(data)                                           ((0x00000200&(data))>>9)
+#define HDMI_HDCP_AUTH_get_write_en5(data)                                           ((0x00000200&(data))>>9)
+#define HDMI_HDCP_AUTH_seedload_shift                                                (8)
+#define HDMI_HDCP_AUTH_seedload_mask                                                 (0x00000100)
+#define HDMI_HDCP_AUTH_seedload(data)                                                (0x00000100&((data)<<8))
+#define HDMI_HDCP_AUTH_seedload_src(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_HDCP_AUTH_get_seedload(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_HDCP_AUTH_write_en4_shift                                               (7)
+#define HDMI_HDCP_AUTH_write_en4_mask                                                (0x00000080)
+#define HDMI_HDCP_AUTH_write_en4(data)                                               (0x00000080&((data)<<7))
+#define HDMI_HDCP_AUTH_write_en4_src(data)                                           ((0x00000080&(data))>>7)
+#define HDMI_HDCP_AUTH_get_write_en4(data)                                           ((0x00000080&(data))>>7)
+#define HDMI_HDCP_AUTH_deviceauthenticated_shift                                     (6)
+#define HDMI_HDCP_AUTH_deviceauthenticated_mask                                      (0x00000040)
+#define HDMI_HDCP_AUTH_deviceauthenticated(data)                                     (0x00000040&((data)<<6))
+#define HDMI_HDCP_AUTH_deviceauthenticated_src(data)                                 ((0x00000040&(data))>>6)
+#define HDMI_HDCP_AUTH_get_deviceauthenticated(data)                                 ((0x00000040&(data))>>6)
+#define HDMI_HDCP_AUTH_write_en3_shift                                               (5)
+#define HDMI_HDCP_AUTH_write_en3_mask                                                (0x00000020)
+#define HDMI_HDCP_AUTH_write_en3(data)                                               (0x00000020&((data)<<5))
+#define HDMI_HDCP_AUTH_write_en3_src(data)                                           ((0x00000020&(data))>>5)
+#define HDMI_HDCP_AUTH_get_write_en3(data)                                           ((0x00000020&(data))>>5)
+#define HDMI_HDCP_AUTH_forcetounauthenticated_shift                                  (4)
+#define HDMI_HDCP_AUTH_forcetounauthenticated_mask                                   (0x00000010)
+#define HDMI_HDCP_AUTH_forcetounauthenticated(data)                                  (0x00000010&((data)<<4))
+#define HDMI_HDCP_AUTH_forcetounauthenticated_src(data)                              ((0x00000010&(data))>>4)
+#define HDMI_HDCP_AUTH_get_forcetounauthenticated(data)                              ((0x00000010&(data))>>4)
+#define HDMI_HDCP_AUTH_write_en2_shift                                               (3)
+#define HDMI_HDCP_AUTH_write_en2_mask                                                (0x00000008)
+#define HDMI_HDCP_AUTH_write_en2(data)                                               (0x00000008&((data)<<3))
+#define HDMI_HDCP_AUTH_write_en2_src(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_AUTH_get_write_en2(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_AUTH_authcompute_shift                                             (2)
+#define HDMI_HDCP_AUTH_authcompute_mask                                              (0x00000004)
+#define HDMI_HDCP_AUTH_authcompute(data)                                             (0x00000004&((data)<<2))
+#define HDMI_HDCP_AUTH_authcompute_src(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_HDCP_AUTH_get_authcompute(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_HDCP_AUTH_write_en1_shift                                               (1)
+#define HDMI_HDCP_AUTH_write_en1_mask                                                (0x00000002)
+#define HDMI_HDCP_AUTH_write_en1(data)                                               (0x00000002&((data)<<1))
+#define HDMI_HDCP_AUTH_write_en1_src(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_HDCP_AUTH_get_write_en1(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_HDCP_AUTH_authrequest_shift                                             (0)
+#define HDMI_HDCP_AUTH_authrequest_mask                                              (0x00000001)
+#define HDMI_HDCP_AUTH_authrequest(data)                                             (0x00000001&((data)<<0))
+#define HDMI_HDCP_AUTH_authrequest_src(data)                                         ((0x00000001&(data))>>0)
+#define HDMI_HDCP_AUTH_get_authrequest(data)                                         ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_SR                                                                 0x9800D314
+#define HDMI_HDCP_SR_reg_addr                                                        "0xD800D314"
+#define HDMI_HDCP_SR_reg                                                             0xD800D314
+#define set_HDMI_HDCP_SR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SR_reg)=data)
+#define get_HDMI_HDCP_SR_reg   (*((volatile unsigned int*) HDMI_HDCP_SR_reg))
+#define HDMI_HDCP_SR_inst_adr                                                        "0x00C5"
+#define HDMI_HDCP_SR_inst                                                            0x00C5
+#define HDMI_HDCP_SR_hdcpcipherstate_shift                                           (24)
+#define HDMI_HDCP_SR_hdcpcipherstate_mask                                            (0xFF000000)
+#define HDMI_HDCP_SR_hdcpcipherstate(data)                                           (0xFF000000&((data)<<24))
+#define HDMI_HDCP_SR_hdcpcipherstate_src(data)                                       ((0xFF000000&(data))>>24)
+#define HDMI_HDCP_SR_get_hdcpcipherstate(data)                                       ((0xFF000000&(data))>>24)
+#define HDMI_HDCP_SR_curdpkaccdone_shift                                             (3)
+#define HDMI_HDCP_SR_curdpkaccdone_mask                                              (0x00000008)
+#define HDMI_HDCP_SR_curdpkaccdone(data)                                             (0x00000008&((data)<<3))
+#define HDMI_HDCP_SR_curdpkaccdone_src(data)                                         ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SR_get_curdpkaccdone(data)                                         ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SR_hdcp_encrypt_status_shift                                       (2)
+#define HDMI_HDCP_SR_hdcp_encrypt_status_mask                                        (0x00000004)
+#define HDMI_HDCP_SR_hdcp_encrypt_status(data)                                       (0x00000004&((data)<<2))
+#define HDMI_HDCP_SR_hdcp_encrypt_status_src(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SR_get_hdcp_encrypt_status(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SR_authenticatedok_shift                                           (1)
+#define HDMI_HDCP_SR_authenticatedok_mask                                            (0x00000002)
+#define HDMI_HDCP_SR_authenticatedok(data)                                           (0x00000002&((data)<<1))
+#define HDMI_HDCP_SR_authenticatedok_src(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SR_get_authenticatedok(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SR_anready_shift                                                   (0)
+#define HDMI_HDCP_SR_anready_mask                                                    (0x00000001)
+#define HDMI_HDCP_SR_anready(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_HDCP_SR_anready_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_HDCP_SR_get_anready(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_ANLR                                                               0x9800D318
+#define HDMI_HDCP_ANLR_reg_addr                                                      "0xD800D318"
+#define HDMI_HDCP_ANLR_reg                                                           0xD800D318
+#define set_HDMI_HDCP_ANLR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANLR_reg)=data)
+#define get_HDMI_HDCP_ANLR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANLR_reg))
+#define HDMI_HDCP_ANLR_inst_adr                                                      "0x00C6"
+#define HDMI_HDCP_ANLR_inst                                                          0x00C6
+#define HDMI_HDCP_ANLR_anlsw_shift                                                   (0)
+#define HDMI_HDCP_ANLR_anlsw_mask                                                    (0xFFFFFFFF)
+#define HDMI_HDCP_ANLR_anlsw(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANLR_anlsw_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANLR_get_anlsw(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_ANMR                                                               0x9800D31c
+#define HDMI_HDCP_ANMR_reg_addr                                                      "0xD800D31C"
+#define HDMI_HDCP_ANMR_reg                                                           0xD800D31C
+#define set_HDMI_HDCP_ANMR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANMR_reg)=data)
+#define get_HDMI_HDCP_ANMR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANMR_reg))
+#define HDMI_HDCP_ANMR_inst_adr                                                      "0x00C7"
+#define HDMI_HDCP_ANMR_inst                                                          0x00C7
+#define HDMI_HDCP_ANMR_anmsw_shift                                                   (0)
+#define HDMI_HDCP_ANMR_anmsw_mask                                                    (0xFFFFFFFF)
+#define HDMI_HDCP_ANMR_anmsw(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANMR_anmsw_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANMR_get_anmsw(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_ANILR                                                              0x9800D320
+#define HDMI_HDCP_ANILR_reg_addr                                                     "0xD800D320"
+#define HDMI_HDCP_ANILR_reg                                                          0xD800D320
+#define set_HDMI_HDCP_ANILR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANILR_reg)=data)
+#define get_HDMI_HDCP_ANILR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANILR_reg))
+#define HDMI_HDCP_ANILR_inst_adr                                                     "0x00C8"
+#define HDMI_HDCP_ANILR_inst                                                         0x00C8
+#define HDMI_HDCP_ANILR_aninfluencelsw_shift                                         (0)
+#define HDMI_HDCP_ANILR_aninfluencelsw_mask                                          (0xFFFFFFFF)
+#define HDMI_HDCP_ANILR_aninfluencelsw(data)                                         (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANILR_aninfluencelsw_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANILR_get_aninfluencelsw(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_ANIMR                                                              0x9800D324
+#define HDMI_HDCP_ANIMR_reg_addr                                                     "0xD800D324"
+#define HDMI_HDCP_ANIMR_reg                                                          0xD800D324
+#define set_HDMI_HDCP_ANIMR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANIMR_reg)=data)
+#define get_HDMI_HDCP_ANIMR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANIMR_reg))
+#define HDMI_HDCP_ANIMR_inst_adr                                                     "0x00C9"
+#define HDMI_HDCP_ANIMR_inst                                                         0x00C9
+#define HDMI_HDCP_ANIMR_aninfluencemsw_shift                                         (0)
+#define HDMI_HDCP_ANIMR_aninfluencemsw_mask                                          (0xFFFFFFFF)
+#define HDMI_HDCP_ANIMR_aninfluencemsw(data)                                         (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANIMR_aninfluencemsw_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANIMR_get_aninfluencemsw(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_DPKLR                                                              0x9800D328
+#define HDMI_HDCP_DPKLR_reg_addr                                                     "0xD800D328"
+#define HDMI_HDCP_DPKLR_reg                                                          0xD800D328
+#define set_HDMI_HDCP_DPKLR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_DPKLR_reg)=data)
+#define get_HDMI_HDCP_DPKLR_reg   (*((volatile unsigned int*) HDMI_HDCP_DPKLR_reg))
+#define HDMI_HDCP_DPKLR_inst_adr                                                     "0x00CA"
+#define HDMI_HDCP_DPKLR_inst                                                         0x00CA
+#define HDMI_HDCP_DPKLR_ddpklsb24_shift                                              (8)
+#define HDMI_HDCP_DPKLR_ddpklsb24_mask                                               (0xFFFFFF00)
+#define HDMI_HDCP_DPKLR_ddpklsb24(data)                                              (0xFFFFFF00&((data)<<8))
+#define HDMI_HDCP_DPKLR_ddpklsb24_src(data)                                          ((0xFFFFFF00&(data))>>8)
+#define HDMI_HDCP_DPKLR_get_ddpklsb24(data)                                          ((0xFFFFFF00&(data))>>8)
+#define HDMI_HDCP_DPKLR_dpkencpnt_shift                                              (0)
+#define HDMI_HDCP_DPKLR_dpkencpnt_mask                                               (0x000000FF)
+#define HDMI_HDCP_DPKLR_dpkencpnt(data)                                              (0x000000FF&((data)<<0))
+#define HDMI_HDCP_DPKLR_dpkencpnt_src(data)                                          ((0x000000FF&(data))>>0)
+#define HDMI_HDCP_DPKLR_get_dpkencpnt(data)                                          ((0x000000FF&(data))>>0)
+
+
+#define HDMI_HDCP_DPKMR                                                              0x9800D32c
+#define HDMI_HDCP_DPKMR_reg_addr                                                     "0xD800D32C"
+#define HDMI_HDCP_DPKMR_reg                                                          0xD800D32C
+#define set_HDMI_HDCP_DPKMR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_DPKMR_reg)=data)
+#define get_HDMI_HDCP_DPKMR_reg   (*((volatile unsigned int*) HDMI_HDCP_DPKMR_reg))
+#define HDMI_HDCP_DPKMR_inst_adr                                                     "0x00CB"
+#define HDMI_HDCP_DPKMR_inst                                                         0x00CB
+#define HDMI_HDCP_DPKMR_ddpkmsw_shift                                                (0)
+#define HDMI_HDCP_DPKMR_ddpkmsw_mask                                                 (0xFFFFFFFF)
+#define HDMI_HDCP_DPKMR_ddpkmsw(data)                                                (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_DPKMR_ddpkmsw_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_DPKMR_get_ddpkmsw(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_LIR                                                                0x9800D330
+#define HDMI_HDCP_LIR_reg_addr                                                       "0xD800D330"
+#define HDMI_HDCP_LIR_reg                                                            0xD800D330
+#define set_HDMI_HDCP_LIR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_LIR_reg)=data)
+#define get_HDMI_HDCP_LIR_reg   (*((volatile unsigned int*) HDMI_HDCP_LIR_reg))
+#define HDMI_HDCP_LIR_inst_adr                                                       "0x00CC"
+#define HDMI_HDCP_LIR_inst                                                           0x00CC
+#define HDMI_HDCP_LIR_ri_shift                                                       (8)
+#define HDMI_HDCP_LIR_ri_mask                                                        (0x00FFFF00)
+#define HDMI_HDCP_LIR_ri(data)                                                       (0x00FFFF00&((data)<<8))
+#define HDMI_HDCP_LIR_ri_src(data)                                                   ((0x00FFFF00&(data))>>8)
+#define HDMI_HDCP_LIR_get_ri(data)                                                   ((0x00FFFF00&(data))>>8)
+#define HDMI_HDCP_LIR_pj_shift                                                       (0)
+#define HDMI_HDCP_LIR_pj_mask                                                        (0x000000FF)
+#define HDMI_HDCP_LIR_pj(data)                                                       (0x000000FF&((data)<<0))
+#define HDMI_HDCP_LIR_pj_src(data)                                                   ((0x000000FF&(data))>>0)
+#define HDMI_HDCP_LIR_get_pj(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define HDMI_HDCP_SHACR                                                              0x9800D334
+#define HDMI_HDCP_SHACR_reg_addr                                                     "0xD800D334"
+#define HDMI_HDCP_SHACR_reg                                                          0xD800D334
+#define set_HDMI_HDCP_SHACR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SHACR_reg)=data)
+#define get_HDMI_HDCP_SHACR_reg   (*((volatile unsigned int*) HDMI_HDCP_SHACR_reg))
+#define HDMI_HDCP_SHACR_inst_adr                                                     "0x00CD"
+#define HDMI_HDCP_SHACR_inst                                                         0x00CD
+#define HDMI_HDCP_SHACR_shastart_shift                                               (3)
+#define HDMI_HDCP_SHACR_shastart_mask                                                (0x00000008)
+#define HDMI_HDCP_SHACR_shastart(data)                                               (0x00000008&((data)<<3))
+#define HDMI_HDCP_SHACR_shastart_src(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SHACR_get_shastart(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SHACR_shafirst_shift                                               (2)
+#define HDMI_HDCP_SHACR_shafirst_mask                                                (0x00000004)
+#define HDMI_HDCP_SHACR_shafirst(data)                                               (0x00000004&((data)<<2))
+#define HDMI_HDCP_SHACR_shafirst_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SHACR_get_shafirst(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SHACR_rstshaptr_shift                                              (1)
+#define HDMI_HDCP_SHACR_rstshaptr_mask                                               (0x00000002)
+#define HDMI_HDCP_SHACR_rstshaptr(data)                                              (0x00000002&((data)<<1))
+#define HDMI_HDCP_SHACR_rstshaptr_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHACR_get_rstshaptr(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHACR_write_data_shift                                             (0)
+#define HDMI_HDCP_SHACR_write_data_mask                                              (0x00000001)
+#define HDMI_HDCP_SHACR_write_data(data)                                             (0x00000001&((data)<<0))
+#define HDMI_HDCP_SHACR_write_data_src(data)                                         ((0x00000001&(data))>>0)
+#define HDMI_HDCP_SHACR_get_write_data(data)                                         ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_SHARR                                                              0x9800D338
+#define HDMI_HDCP_SHARR_reg_addr                                                     "0xD800D338"
+#define HDMI_HDCP_SHARR_reg                                                          0xD800D338
+#define set_HDMI_HDCP_SHARR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SHARR_reg)=data)
+#define get_HDMI_HDCP_SHARR_reg   (*((volatile unsigned int*) HDMI_HDCP_SHARR_reg))
+#define HDMI_HDCP_SHARR_inst_adr                                                     "0x00CE"
+#define HDMI_HDCP_SHARR_inst                                                         0x00CE
+#define HDMI_HDCP_SHARR_vmatch_shift                                                 (1)
+#define HDMI_HDCP_SHARR_vmatch_mask                                                  (0x00000002)
+#define HDMI_HDCP_SHARR_vmatch(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_HDCP_SHARR_vmatch_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHARR_get_vmatch(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHARR_shaready_shift                                               (0)
+#define HDMI_HDCP_SHARR_shaready_mask                                                (0x00000001)
+#define HDMI_HDCP_SHARR_shaready(data)                                               (0x00000001&((data)<<0))
+#define HDMI_HDCP_SHARR_shaready_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_HDCP_SHARR_get_shaready(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_SHADR                                                              0x9800D33c
+#define HDMI_HDCP_SHADR_reg_addr                                                     "0xD800D33C"
+#define HDMI_HDCP_SHADR_reg                                                          0xD800D33C
+#define set_HDMI_HDCP_SHADR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SHADR_reg)=data)
+#define get_HDMI_HDCP_SHADR_reg   (*((volatile unsigned int*) HDMI_HDCP_SHADR_reg))
+#define HDMI_HDCP_SHADR_inst_adr                                                     "0x00CF"
+#define HDMI_HDCP_SHADR_inst                                                         0x00CF
+#define HDMI_HDCP_SHADR_sha_data_shift                                               (0)
+#define HDMI_HDCP_SHADR_sha_data_mask                                                (0xFFFFFFFF)
+#define HDMI_HDCP_SHADR_sha_data(data)                                               (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_SHADR_sha_data_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_SHADR_get_sha_data(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_MILSW                                                              0x9800D340
+#define HDMI_HDCP_MILSW_reg_addr                                                     "0xD800D340"
+#define HDMI_HDCP_MILSW_reg                                                          0xD800D340
+#define set_HDMI_HDCP_MILSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_MILSW_reg)=data)
+#define get_HDMI_HDCP_MILSW_reg   (*((volatile unsigned int*) HDMI_HDCP_MILSW_reg))
+#define HDMI_HDCP_MILSW_inst_adr                                                     "0x00D0"
+#define HDMI_HDCP_MILSW_inst                                                         0x00D0
+#define HDMI_HDCP_MILSW_milsw_shift                                                  (0)
+#define HDMI_HDCP_MILSW_milsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_MILSW_milsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_MILSW_milsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_MILSW_get_milsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_MIMSW                                                              0x9800D344
+#define HDMI_HDCP_MIMSW_reg_addr                                                     "0xD800D344"
+#define HDMI_HDCP_MIMSW_reg                                                          0xD800D344
+#define set_HDMI_HDCP_MIMSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_MIMSW_reg)=data)
+#define get_HDMI_HDCP_MIMSW_reg   (*((volatile unsigned int*) HDMI_HDCP_MIMSW_reg))
+#define HDMI_HDCP_MIMSW_inst_adr                                                     "0x00D1"
+#define HDMI_HDCP_MIMSW_inst                                                         0x00D1
+#define HDMI_HDCP_MIMSW_mimsw_shift                                                  (0)
+#define HDMI_HDCP_MIMSW_mimsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_MIMSW_mimsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_MIMSW_mimsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_MIMSW_get_mimsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_KMLSW                                                              0x9800D348
+#define HDMI_HDCP_KMLSW_reg_addr                                                     "0xD800D348"
+#define HDMI_HDCP_KMLSW_reg                                                          0xD800D348
+#define set_HDMI_HDCP_KMLSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KMLSW_reg)=data)
+#define get_HDMI_HDCP_KMLSW_reg   (*((volatile unsigned int*) HDMI_HDCP_KMLSW_reg))
+#define HDMI_HDCP_KMLSW_inst_adr                                                     "0x00D2"
+#define HDMI_HDCP_KMLSW_inst                                                         0x00D2
+#define HDMI_HDCP_KMLSW_kmlsw_shift                                                  (0)
+#define HDMI_HDCP_KMLSW_kmlsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_KMLSW_kmlsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_KMLSW_kmlsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_KMLSW_get_kmlsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_KMMSW                                                              0x9800D34c
+#define HDMI_HDCP_KMMSW_reg_addr                                                     "0xD800D34C"
+#define HDMI_HDCP_KMMSW_reg                                                          0xD800D34C
+#define set_HDMI_HDCP_KMMSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KMMSW_reg)=data)
+#define get_HDMI_HDCP_KMMSW_reg   (*((volatile unsigned int*) HDMI_HDCP_KMMSW_reg))
+#define HDMI_HDCP_KMMSW_inst_adr                                                     "0x00D3"
+#define HDMI_HDCP_KMMSW_inst                                                         0x00D3
+#define HDMI_HDCP_KMMSW_kmmsw_shift                                                  (0)
+#define HDMI_HDCP_KMMSW_kmmsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_KMMSW_kmmsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_KMMSW_kmmsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_KMMSW_get_kmmsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_CTRL                                                           0x9800D350
+#define HDMI_HDCP_2_2_CTRL_reg_addr                                                  "0xD800D350"
+#define HDMI_HDCP_2_2_CTRL_reg                                                       0xD800D350
+#define set_HDMI_HDCP_2_2_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_CTRL_reg)=data)
+#define get_HDMI_HDCP_2_2_CTRL_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_CTRL_reg))
+#define HDMI_HDCP_2_2_CTRL_inst_adr                                                  "0x00D4"
+#define HDMI_HDCP_2_2_CTRL_inst                                                      0x00D4
+#define HDMI_HDCP_2_2_CTRL_write_en5_shift                                           (9)
+#define HDMI_HDCP_2_2_CTRL_write_en5_mask                                            (0x00000200)
+#define HDMI_HDCP_2_2_CTRL_write_en5(data)                                           (0x00000200&((data)<<9))
+#define HDMI_HDCP_2_2_CTRL_write_en5_src(data)                                       ((0x00000200&(data))>>9)
+#define HDMI_HDCP_2_2_CTRL_get_write_en5(data)                                       ((0x00000200&(data))>>9)
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add_shift                                     (8)
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add_mask                                      (0x00000100)
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add(data)                                     (0x00000100&((data)<<8))
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add_src(data)                                 ((0x00000100&(data))>>8)
+#define HDMI_HDCP_2_2_CTRL_get_pkt_vdo_cnt_add(data)                                 ((0x00000100&(data))>>8)
+#define HDMI_HDCP_2_2_CTRL_write_en4_shift                                           (7)
+#define HDMI_HDCP_2_2_CTRL_write_en4_mask                                            (0x00000080)
+#define HDMI_HDCP_2_2_CTRL_write_en4(data)                                           (0x00000080&((data)<<7))
+#define HDMI_HDCP_2_2_CTRL_write_en4_src(data)                                       ((0x00000080&(data))>>7)
+#define HDMI_HDCP_2_2_CTRL_get_write_en4(data)                                       ((0x00000080&(data))>>7)
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en_shift                                         (6)
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en_mask                                          (0x00000040)
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en(data)                                         (0x00000040&((data)<<6))
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en_src(data)                                     ((0x00000040&(data))>>6)
+#define HDMI_HDCP_2_2_CTRL_get_hdcp_2_2_en(data)                                     ((0x00000040&(data))>>6)
+#define HDMI_HDCP_2_2_CTRL_write_en3_shift                                           (5)
+#define HDMI_HDCP_2_2_CTRL_write_en3_mask                                            (0x00000020)
+#define HDMI_HDCP_2_2_CTRL_write_en3(data)                                           (0x00000020&((data)<<5))
+#define HDMI_HDCP_2_2_CTRL_write_en3_src(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_HDCP_2_2_CTRL_get_write_en3(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en_shift                                           (4)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en_mask                                            (0x00000010)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en(data)                                           (0x00000010&((data)<<4))
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en_src(data)                                       ((0x00000010&(data))>>4)
+#define HDMI_HDCP_2_2_CTRL_get_aes_sw_en(data)                                       ((0x00000010&(data))>>4)
+#define HDMI_HDCP_2_2_CTRL_write_en2_shift                                           (3)
+#define HDMI_HDCP_2_2_CTRL_write_en2_mask                                            (0x00000008)
+#define HDMI_HDCP_2_2_CTRL_write_en2(data)                                           (0x00000008&((data)<<3))
+#define HDMI_HDCP_2_2_CTRL_write_en2_src(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_HDCP_2_2_CTRL_get_write_en2(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1_shift                                       (2)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1_mask                                        (0x00000004)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1(data)                                       (0x00000004&((data)<<2))
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1_src(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_2_2_CTRL_get_aes_sw_start1(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_2_2_CTRL_write_en1_shift                                           (1)
+#define HDMI_HDCP_2_2_CTRL_write_en1_mask                                            (0x00000002)
+#define HDMI_HDCP_2_2_CTRL_write_en1(data)                                           (0x00000002&((data)<<1))
+#define HDMI_HDCP_2_2_CTRL_write_en1_src(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_CTRL_get_write_en1(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2_shift                                       (0)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2_mask                                        (0x00000001)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2(data)                                       (0x00000001&((data)<<0))
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_HDCP_2_2_CTRL_get_aes_sw_start2(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_STATUS                                                         0x9800D354
+#define HDMI_HDCP_2_2_STATUS_reg_addr                                                "0xD800D354"
+#define HDMI_HDCP_2_2_STATUS_reg                                                     0xD800D354
+#define set_HDMI_HDCP_2_2_STATUS_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_STATUS_reg)=data)
+#define get_HDMI_HDCP_2_2_STATUS_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_STATUS_reg))
+#define HDMI_HDCP_2_2_STATUS_inst_adr                                                "0x00D5"
+#define HDMI_HDCP_2_2_STATUS_inst                                                    0x00D5
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1_shift                                     (1)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1_mask                                      (0x00000002)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1(data)                                     (0x00000002&((data)<<1))
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1_src(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_STATUS_get_rgs_sw_done_1(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2_shift                                     (0)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2_mask                                      (0x00000001)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2(data)                                     (0x00000001&((data)<<0))
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2_src(data)                                 ((0x00000001&(data))>>0)
+#define HDMI_HDCP_2_2_STATUS_get_rgs_sw_done_2(data)                                 ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_1                                                    0x9800D358
+#define HDMI_HDCP_2_2_SW_DATA_1_1_reg_addr                                           "0xD800D358"
+#define HDMI_HDCP_2_2_SW_DATA_1_1_reg                                                0xD800D358
+#define set_HDMI_HDCP_2_2_SW_DATA_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_1_inst_adr                                           "0x00D6"
+#define HDMI_HDCP_2_2_SW_DATA_1_1_inst                                               0x00D6
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_1_get_sw_data_1_1(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_2                                                    0x9800D35c
+#define HDMI_HDCP_2_2_SW_DATA_1_2_reg_addr                                           "0xD800D35C"
+#define HDMI_HDCP_2_2_SW_DATA_1_2_reg                                                0xD800D35C
+#define set_HDMI_HDCP_2_2_SW_DATA_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_2_inst_adr                                           "0x00D7"
+#define HDMI_HDCP_2_2_SW_DATA_1_2_inst                                               0x00D7
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_2_get_sw_data_1_2(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_3                                                    0x9800D360
+#define HDMI_HDCP_2_2_SW_DATA_1_3_reg_addr                                           "0xD800D360"
+#define HDMI_HDCP_2_2_SW_DATA_1_3_reg                                                0xD800D360
+#define set_HDMI_HDCP_2_2_SW_DATA_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_3_inst_adr                                           "0x00D8"
+#define HDMI_HDCP_2_2_SW_DATA_1_3_inst                                               0x00D8
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_3_get_sw_data_1_3(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_4                                                    0x9800D364
+#define HDMI_HDCP_2_2_SW_DATA_1_4_reg_addr                                           "0xD800D364"
+#define HDMI_HDCP_2_2_SW_DATA_1_4_reg                                                0xD800D364
+#define set_HDMI_HDCP_2_2_SW_DATA_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_4_inst_adr                                           "0x00D9"
+#define HDMI_HDCP_2_2_SW_DATA_1_4_inst                                               0x00D9
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_4_get_sw_data_1_4(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_1                                                    0x9800D368
+#define HDMI_HDCP_2_2_SW_DATA_2_1_reg_addr                                           "0xD800D368"
+#define HDMI_HDCP_2_2_SW_DATA_2_1_reg                                                0xD800D368
+#define set_HDMI_HDCP_2_2_SW_DATA_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_1_inst_adr                                           "0x00DA"
+#define HDMI_HDCP_2_2_SW_DATA_2_1_inst                                               0x00DA
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_1_get_sw_data_2_1(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_2                                                    0x9800D36c
+#define HDMI_HDCP_2_2_SW_DATA_2_2_reg_addr                                           "0xD800D36C"
+#define HDMI_HDCP_2_2_SW_DATA_2_2_reg                                                0xD800D36C
+#define set_HDMI_HDCP_2_2_SW_DATA_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_2_inst_adr                                           "0x00DB"
+#define HDMI_HDCP_2_2_SW_DATA_2_2_inst                                               0x00DB
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_2_get_sw_data_2_2(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_3                                                    0x9800D370
+#define HDMI_HDCP_2_2_SW_DATA_2_3_reg_addr                                           "0xD800D370"
+#define HDMI_HDCP_2_2_SW_DATA_2_3_reg                                                0xD800D370
+#define set_HDMI_HDCP_2_2_SW_DATA_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_3_inst_adr                                           "0x00DC"
+#define HDMI_HDCP_2_2_SW_DATA_2_3_inst                                               0x00DC
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_3_get_sw_data_2_3(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_4                                                    0x9800D374
+#define HDMI_HDCP_2_2_SW_DATA_2_4_reg_addr                                           "0xD800D374"
+#define HDMI_HDCP_2_2_SW_DATA_2_4_reg                                                0xD800D374
+#define set_HDMI_HDCP_2_2_SW_DATA_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_4_inst_adr                                           "0x00DD"
+#define HDMI_HDCP_2_2_SW_DATA_2_4_inst                                               0x00DD
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_4_get_sw_data_2_4(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_1                                                     0x9800D378
+#define HDMI_HDCP_2_2_SW_KEY_1_1_reg_addr                                            "0xD800D378"
+#define HDMI_HDCP_2_2_SW_KEY_1_1_reg                                                 0xD800D378
+#define set_HDMI_HDCP_2_2_SW_KEY_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_1_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_1_inst_adr                                            "0x00DE"
+#define HDMI_HDCP_2_2_SW_KEY_1_1_inst                                                0x00DE
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_1_get_sw_key_1_1(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_2                                                     0x9800D37c
+#define HDMI_HDCP_2_2_SW_KEY_1_2_reg_addr                                            "0xD800D37C"
+#define HDMI_HDCP_2_2_SW_KEY_1_2_reg                                                 0xD800D37C
+#define set_HDMI_HDCP_2_2_SW_KEY_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_2_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_2_inst_adr                                            "0x00DF"
+#define HDMI_HDCP_2_2_SW_KEY_1_2_inst                                                0x00DF
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_2_get_sw_key_1_2(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_3                                                     0x9800D380
+#define HDMI_HDCP_2_2_SW_KEY_1_3_reg_addr                                            "0xD800D380"
+#define HDMI_HDCP_2_2_SW_KEY_1_3_reg                                                 0xD800D380
+#define set_HDMI_HDCP_2_2_SW_KEY_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_3_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_3_inst_adr                                            "0x00E0"
+#define HDMI_HDCP_2_2_SW_KEY_1_3_inst                                                0x00E0
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_3_get_sw_key_1_3(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_4                                                     0x9800D384
+#define HDMI_HDCP_2_2_SW_KEY_1_4_reg_addr                                            "0xD800D384"
+#define HDMI_HDCP_2_2_SW_KEY_1_4_reg                                                 0xD800D384
+#define set_HDMI_HDCP_2_2_SW_KEY_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_4_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_4_inst_adr                                            "0x00E1"
+#define HDMI_HDCP_2_2_SW_KEY_1_4_inst                                                0x00E1
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_4_get_sw_key_1_4(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_1                                                     0x9800D388
+#define HDMI_HDCP_2_2_SW_KEY_2_1_reg_addr                                            "0xD800D388"
+#define HDMI_HDCP_2_2_SW_KEY_2_1_reg                                                 0xD800D388
+#define set_HDMI_HDCP_2_2_SW_KEY_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_1_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_1_inst_adr                                            "0x00E2"
+#define HDMI_HDCP_2_2_SW_KEY_2_1_inst                                                0x00E2
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_1_get_sw_key_2_1(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_2                                                     0x9800D38c
+#define HDMI_HDCP_2_2_SW_KEY_2_2_reg_addr                                            "0xD800D38C"
+#define HDMI_HDCP_2_2_SW_KEY_2_2_reg                                                 0xD800D38C
+#define set_HDMI_HDCP_2_2_SW_KEY_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_2_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_2_inst_adr                                            "0x00E3"
+#define HDMI_HDCP_2_2_SW_KEY_2_2_inst                                                0x00E3
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_2_get_sw_key_2_2(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_3                                                     0x9800D390
+#define HDMI_HDCP_2_2_SW_KEY_2_3_reg_addr                                            "0xD800D390"
+#define HDMI_HDCP_2_2_SW_KEY_2_3_reg                                                 0xD800D390
+#define set_HDMI_HDCP_2_2_SW_KEY_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_3_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_3_inst_adr                                            "0x00E4"
+#define HDMI_HDCP_2_2_SW_KEY_2_3_inst                                                0x00E4
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_3_get_sw_key_2_3(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_4                                                     0x9800D394
+#define HDMI_HDCP_2_2_SW_KEY_2_4_reg_addr                                            "0xD800D394"
+#define HDMI_HDCP_2_2_SW_KEY_2_4_reg                                                 0xD800D394
+#define set_HDMI_HDCP_2_2_SW_KEY_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_4_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_4_inst_adr                                            "0x00E5"
+#define HDMI_HDCP_2_2_SW_KEY_2_4_inst                                                0x00E5
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_4_get_sw_key_2_4(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1                                                0x9800D398
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg_addr                                       "0xD800D398"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg                                            0xD800D398
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_inst_adr                                       "0x00E6"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_inst                                           0x00E6
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_get_sw_data_xor_1_1(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2                                                0x9800D39c
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg_addr                                       "0xD800D39C"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg                                            0xD800D39C
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_inst_adr                                       "0x00E7"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_inst                                           0x00E7
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_get_sw_data_xor_1_2(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3                                                0x9800D3a0
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg_addr                                       "0xD800D3A0"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg                                            0xD800D3A0
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_inst_adr                                       "0x00E8"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_inst                                           0x00E8
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_get_sw_data_xor_1_3(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4                                                0x9800D3a4
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg_addr                                       "0xD800D3A4"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg                                            0xD800D3A4
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_inst_adr                                       "0x00E9"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_inst                                           0x00E9
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_get_sw_data_xor_1_4(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1                                                0x9800D3a8
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg_addr                                       "0xD800D3A8"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg                                            0xD800D3A8
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_inst_adr                                       "0x00EA"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_inst                                           0x00EA
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_get_sw_data_xor_2_1(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2                                                0x9800D3ac
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg_addr                                       "0xD800D3AC"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg                                            0xD800D3AC
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_inst_adr                                       "0x00EB"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_inst                                           0x00EB
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_get_sw_data_xor_2_2(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3                                                0x9800D3b0
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg_addr                                       "0xD800D3B0"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg                                            0xD800D3B0
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_inst_adr                                       "0x00EC"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_inst                                           0x00EC
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_get_sw_data_xor_2_3(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4                                                0x9800D3b4
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg_addr                                       "0xD800D3B4"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg                                            0xD800D3B4
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_inst_adr                                       "0x00ED"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_inst                                           0x00ED
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_get_sw_data_xor_2_4(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1                                                0x9800D3b8
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg_addr                                       "0xD800D3B8"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg                                            0xD800D3B8
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_inst_adr                                       "0x00EE"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_inst                                           0x00EE
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_get_data_out_1_1(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2                                                0x9800D3bc
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg_addr                                       "0xD800D3BC"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg                                            0xD800D3BC
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_inst_adr                                       "0x00EF"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_inst                                           0x00EF
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_get_data_out_1_2(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3                                                0x9800D3c0
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg_addr                                       "0xD800D3C0"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg                                            0xD800D3C0
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_inst_adr                                       "0x00F0"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_inst                                           0x00F0
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_get_data_out_1_3(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4                                                0x9800D3c4
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg_addr                                       "0xD800D3C4"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg                                            0xD800D3C4
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_inst_adr                                       "0x00F1"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_inst                                           0x00F1
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_get_data_out_1_4(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1                                                0x9800D3c8
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg_addr                                       "0xD800D3C8"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg                                            0xD800D3C8
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_inst_adr                                       "0x00F2"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_inst                                           0x00F2
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_get_data_out_2_1(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2                                                0x9800D3cc
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg_addr                                       "0xD800D3CC"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg                                            0xD800D3CC
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_inst_adr                                       "0x00F3"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_inst                                           0x00F3
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_get_data_out_2_2(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3                                                0x9800D3d0
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg_addr                                       "0xD800D3D0"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg                                            0xD800D3D0
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_inst_adr                                       "0x00F4"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_inst                                           0x00F4
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_get_data_out_2_3(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4                                                0x9800D3d4
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg_addr                                       "0xD800D3D4"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg                                            0xD800D3D4
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_inst_adr                                       "0x00F5"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_inst                                           0x00F5
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_get_data_out_2_4(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_RIV_1                                                       0x9800D3d8
+#define HDMI_HDCP_2_2_HW_RIV_1_reg_addr                                              "0xD800D3D8"
+#define HDMI_HDCP_2_2_HW_RIV_1_reg                                                   0xD800D3D8
+#define set_HDMI_HDCP_2_2_HW_RIV_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_1_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_RIV_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_1_reg))
+#define HDMI_HDCP_2_2_HW_RIV_1_inst_adr                                              "0x00F6"
+#define HDMI_HDCP_2_2_HW_RIV_1_inst                                                  0x00F6
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1_shift                                      (0)
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1_mask                                       (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1(data)                                      (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_RIV_1_get_hw_riv_1_1(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_RIV_2                                                       0x9800D3dc
+#define HDMI_HDCP_2_2_HW_RIV_2_reg_addr                                              "0xD800D3DC"
+#define HDMI_HDCP_2_2_HW_RIV_2_reg                                                   0xD800D3DC
+#define set_HDMI_HDCP_2_2_HW_RIV_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_2_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_RIV_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_2_reg))
+#define HDMI_HDCP_2_2_HW_RIV_2_inst_adr                                              "0x00F7"
+#define HDMI_HDCP_2_2_HW_RIV_2_inst                                                  0x00F7
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2_shift                                      (0)
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2_mask                                       (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2(data)                                      (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_RIV_2_get_hw_riv_1_2(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1                                                 0x9800D3e0
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg_addr                                        "0xD800D3E0"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg                                             0xD800D3E0
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_inst_adr                                        "0x00F8"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_inst                                            0x00F8
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1_shift                               (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1_mask                                (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1(data)                               (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1_src(data)                           ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_get_frame_num_1(data)                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2                                                 0x9800D3e4
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg_addr                                        "0xD800D3E4"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg                                             0xD800D3E4
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_inst_adr                                        "0x00F9"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_inst                                            0x00F9
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2_shift                               (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2_mask                                (0x0000003F)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2(data)                               (0x0000003F&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2_src(data)                           ((0x0000003F&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_get_frame_num_2(data)                           ((0x0000003F&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1                                             0x9800D3e8
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg_addr                                    "0xD800D3E8"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg                                         0xD800D3E8
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_inst_adr                                    "0x00FA"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_inst                                        0x00FA
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1_shift                       (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1_mask                        (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1(data)                       (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1_src(data)                   ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_get_frame_num_add_1(data)                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2                                             0x9800D3ec
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg_addr                                    "0xD800D3EC"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg                                         0xD800D3EC
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_inst_adr                                    "0x00FB"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_inst                                        0x00FB
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2_shift                       (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2_mask                        (0x0000003F)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2(data)                       (0x0000003F&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2_src(data)                   ((0x0000003F&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_get_frame_num_add_2(data)                   ((0x0000003F&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_DATA_NUM                                                    0x9800D3f0
+#define HDMI_HDCP_2_2_HW_DATA_NUM_reg_addr                                           "0xD800D3F0"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_reg                                                0xD800D3F0
+#define set_HDMI_HDCP_2_2_HW_DATA_NUM_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_DATA_NUM_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_reg))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_inst_adr                                           "0x00FC"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_inst                                               0x00FC
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num_shift                                     (0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num_mask                                      (0x03FFFFFF)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num(data)                                     (0x03FFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num_src(data)                                 ((0x03FFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_get_data_num(data)                                 ((0x03FFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD                                                0x9800D3f4
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg_addr                                       "0xD800D3F4"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg                                            0xD800D3F4
+#define set_HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_inst_adr                                       "0x00FD"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_inst                                           0x00FD
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add_shift                             (0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add_mask                              (0x03FFFFFF)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add(data)                             (0x03FFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add_src(data)                         ((0x03FFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_get_data_num_add(data)                         ((0x03FFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FREE_RUN                                                    0x9800D3f8
+#define HDMI_HDCP_2_2_HW_FREE_RUN_reg_addr                                           "0xD800D3F8"
+#define HDMI_HDCP_2_2_HW_FREE_RUN_reg                                                0xD800D3F8
+#define set_HDMI_HDCP_2_2_HW_FREE_RUN_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FREE_RUN_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FREE_RUN_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FREE_RUN_reg))
+#define HDMI_HDCP_2_2_HW_FREE_RUN_inst_adr                                           "0x00FE"
+#define HDMI_HDCP_2_2_HW_FREE_RUN_inst                                               0x00FE
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en2_shift                                    (28)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en2_mask                                     (0x10000000)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en2(data)                                    (0x10000000&((data)<<28))
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en2_src(data)                                ((0x10000000&(data))>>28)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_get_write_en2(data)                                ((0x10000000&(data))>>28)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_free_run_mod_en_shift                              (27)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_free_run_mod_en_mask                               (0x08000000)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_free_run_mod_en(data)                              (0x08000000&((data)<<27))
+#define HDMI_HDCP_2_2_HW_FREE_RUN_free_run_mod_en_src(data)                          ((0x08000000&(data))>>27)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_get_free_run_mod_en(data)                          ((0x08000000&(data))>>27)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en1_shift                                    (26)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en1_mask                                     (0x04000000)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en1(data)                                    (0x04000000&((data)<<26))
+#define HDMI_HDCP_2_2_HW_FREE_RUN_write_en1_src(data)                                ((0x04000000&(data))>>26)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_get_write_en1(data)                                ((0x04000000&(data))>>26)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_keep_out_win_shift                                 (0)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_keep_out_win_mask                                  (0x03FFFFFF)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_keep_out_win(data)                                 (0x03FFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FREE_RUN_keep_out_win_src(data)                             ((0x03FFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FREE_RUN_get_keep_out_win(data)                             ((0x03FFFFFF&(data))>>0)
+
+
+#define HDMI_DBG                                                                     0x9800D140
+#define HDMI_DBG_reg_addr                                                            "0xD800D140"
+#define HDMI_DBG_reg                                                                 0xD800D140
+#define set_HDMI_DBG_reg(data)   (*((volatile unsigned int*) HDMI_DBG_reg)=data)
+#define get_HDMI_DBG_reg   (*((volatile unsigned int*) HDMI_DBG_reg))
+#define HDMI_DBG_inst_adr                                                            "0x0050"
+#define HDMI_DBG_inst                                                                0x0050
+#define HDMI_DBG_chsel0_shift                                                        (5)
+#define HDMI_DBG_chsel0_mask                                                         (0x000003E0)
+#define HDMI_DBG_chsel0(data)                                                        (0x000003E0&((data)<<5))
+#define HDMI_DBG_chsel0_src(data)                                                    ((0x000003E0&(data))>>5)
+#define HDMI_DBG_get_chsel0(data)                                                    ((0x000003E0&(data))>>5)
+#define HDMI_DBG_chsel1_shift                                                        (0)
+#define HDMI_DBG_chsel1_mask                                                         (0x0000001F)
+#define HDMI_DBG_chsel1(data)                                                        (0x0000001F&((data)<<0))
+#define HDMI_DBG_chsel1_src(data)                                                    ((0x0000001F&(data))>>0)
+#define HDMI_DBG_get_chsel1(data)                                                    ((0x0000001F&(data))>>0)
+
+
+#define HDMI_DUMMY_0                                                                 0x9800D144
+#define HDMI_DUMMY_1                                                                 0x9800D148
+#define HDMI_DUMMY_0_reg_addr                                                        "0xD800D144"
+#define HDMI_DUMMY_1_reg_addr                                                        "0xD800D148"
+#define HDMI_DUMMY_0_reg                                                             0xD800D144
+#define HDMI_DUMMY_1_reg                                                             0xD800D148
+#define set_HDMI_DUMMY_0_reg(data)   (*((volatile unsigned int*) HDMI_DUMMY_0_reg)=data)
+#define set_HDMI_DUMMY_1_reg(data)   (*((volatile unsigned int*) HDMI_DUMMY_1_reg)=data)
+#define get_HDMI_DUMMY_0_reg   (*((volatile unsigned int*) HDMI_DUMMY_0_reg))
+#define get_HDMI_DUMMY_1_reg   (*((volatile unsigned int*) HDMI_DUMMY_1_reg))
+#define HDMI_DUMMY_0_inst_adr                                                        "0x0051"
+#define HDMI_DUMMY_1_inst_adr                                                        "0x0052"
+#define HDMI_DUMMY_0_inst                                                            0x0051
+#define HDMI_DUMMY_1_inst                                                            0x0052
+#define HDMI_DUMMY_dummy_shift                                                       (0)
+#define HDMI_DUMMY_dummy_mask                                                        (0xFFFFFFFF)
+#define HDMI_DUMMY_dummy(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define HDMI_DUMMY_dummy_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define HDMI_DUMMY_get_dummy(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_PHY                                                                     0x9800D14C
+#define HDMI_PHY_reg_addr                                                            "0xD800D14C"
+#define HDMI_PHY_reg                                                                 0xD800D14C
+#define set_HDMI_PHY_reg(data)   (*((volatile unsigned int*) HDMI_PHY_reg)=data)
+#define get_HDMI_PHY_reg   (*((volatile unsigned int*) HDMI_PHY_reg))
+#define HDMI_PHY_inst_adr                                                            "0x0053"
+#define HDMI_PHY_inst                                                                0x0053
+#define HDMI_PHY_test_mode_shift                                                     (1)
+#define HDMI_PHY_test_mode_mask                                                      (0x00000002)
+#define HDMI_PHY_test_mode(data)                                                     (0x00000002&((data)<<1))
+#define HDMI_PHY_test_mode_src(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_PHY_get_test_mode(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_PHY_data_realign_shift                                                  (0)
+#define HDMI_PHY_data_realign_mask                                                   (0x00000001)
+#define HDMI_PHY_data_realign(data)                                                  (0x00000001&((data)<<0))
+#define HDMI_PHY_data_realign_src(data)                                              ((0x00000001&(data))>>0)
+#define HDMI_PHY_get_data_realign(data)                                              ((0x00000001&(data))>>0)
+
+
+#define HDMI_H_PARA1                                                                 0x9800D234
+#define HDMI_H_PARA1_reg_addr                                                        "0xD800D234"
+#define HDMI_H_PARA1_reg                                                             0xD800D234
+#define set_HDMI_H_PARA1_reg(data)   (*((volatile unsigned int*) HDMI_H_PARA1_reg)=data)
+#define get_HDMI_H_PARA1_reg   (*((volatile unsigned int*) HDMI_H_PARA1_reg))
+#define HDMI_H_PARA1_inst_adr                                                        "0x008D"
+#define HDMI_H_PARA1_inst                                                            0x008D
+#define HDMI_H_PARA1_hblank_shift                                                    (16)
+#define HDMI_H_PARA1_hblank_mask                                                     (0x3FFF0000)
+#define HDMI_H_PARA1_hblank(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_H_PARA1_hblank_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA1_get_hblank(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA1_hactive_shift                                                   (0)
+#define HDMI_H_PARA1_hactive_mask                                                    (0x00003FFF)
+#define HDMI_H_PARA1_hactive(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_H_PARA1_hactive_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_H_PARA1_get_hactive(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_H_PARA2                                                                 0x9800D238
+#define HDMI_H_PARA2_reg_addr                                                        "0xD800D238"
+#define HDMI_H_PARA2_reg                                                             0xD800D238
+#define set_HDMI_H_PARA2_reg(data)   (*((volatile unsigned int*) HDMI_H_PARA2_reg)=data)
+#define get_HDMI_H_PARA2_reg   (*((volatile unsigned int*) HDMI_H_PARA2_reg))
+#define HDMI_H_PARA2_inst_adr                                                        "0x008E"
+#define HDMI_H_PARA2_inst                                                            0x008E
+#define HDMI_H_PARA2_hsync_shift                                                     (16)
+#define HDMI_H_PARA2_hsync_mask                                                      (0x3FFF0000)
+#define HDMI_H_PARA2_hsync(data)                                                     (0x3FFF0000&((data)<<16))
+#define HDMI_H_PARA2_hsync_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA2_get_hsync(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA2_hfront_shift                                                    (0)
+#define HDMI_H_PARA2_hfront_mask                                                     (0x00003FFF)
+#define HDMI_H_PARA2_hfront(data)                                                    (0x00003FFF&((data)<<0))
+#define HDMI_H_PARA2_hfront_src(data)                                                ((0x00003FFF&(data))>>0)
+#define HDMI_H_PARA2_get_hfront(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_H_PARA3                                                                 0x9800D23c
+#define HDMI_H_PARA3_reg_addr                                                        "0xD800D23C"
+#define HDMI_H_PARA3_reg                                                             0xD800D23C
+#define set_HDMI_H_PARA3_reg(data)   (*((volatile unsigned int*) HDMI_H_PARA3_reg)=data)
+#define get_HDMI_H_PARA3_reg   (*((volatile unsigned int*) HDMI_H_PARA3_reg))
+#define HDMI_H_PARA3_inst_adr                                                        "0x008F"
+#define HDMI_H_PARA3_inst                                                            0x008F
+#define HDMI_H_PARA3_hback_shift                                                     (0)
+#define HDMI_H_PARA3_hback_mask                                                      (0x00003FFF)
+#define HDMI_H_PARA3_hback(data)                                                     (0x00003FFF&((data)<<0))
+#define HDMI_H_PARA3_hback_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define HDMI_H_PARA3_get_hback(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA1                                                                 0x9800D240
+#define HDMI_V_PARA1_reg_addr                                                        "0xD800D240"
+#define HDMI_V_PARA1_reg                                                             0xD800D240
+#define set_HDMI_V_PARA1_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA1_reg)=data)
+#define get_HDMI_V_PARA1_reg   (*((volatile unsigned int*) HDMI_V_PARA1_reg))
+#define HDMI_V_PARA1_inst_adr                                                        "0x0090"
+#define HDMI_V_PARA1_inst                                                            0x0090
+#define HDMI_V_PARA1_Vact_video_shift                                                (16)
+#define HDMI_V_PARA1_Vact_video_mask                                                 (0x3FFF0000)
+#define HDMI_V_PARA1_Vact_video(data)                                                (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA1_Vact_video_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA1_get_Vact_video(data)                                            ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA1_vactive_shift                                                   (0)
+#define HDMI_V_PARA1_vactive_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA1_vactive(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA1_vactive_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA1_get_vactive(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA2                                                                 0x9800D244
+#define HDMI_V_PARA2_reg_addr                                                        "0xD800D244"
+#define HDMI_V_PARA2_reg                                                             0xD800D244
+#define set_HDMI_V_PARA2_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA2_reg)=data)
+#define get_HDMI_V_PARA2_reg   (*((volatile unsigned int*) HDMI_V_PARA2_reg))
+#define HDMI_V_PARA2_inst_adr                                                        "0x0091"
+#define HDMI_V_PARA2_inst                                                            0x0091
+#define HDMI_V_PARA2_Vact_space1_shift                                               (16)
+#define HDMI_V_PARA2_Vact_space1_mask                                                (0x3FFF0000)
+#define HDMI_V_PARA2_Vact_space1(data)                                               (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA2_Vact_space1_src(data)                                           ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA2_get_Vact_space1(data)                                           ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA2_Vact_space_shift                                                (0)
+#define HDMI_V_PARA2_Vact_space_mask                                                 (0x00003FFF)
+#define HDMI_V_PARA2_Vact_space(data)                                                (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA2_Vact_space_src(data)                                            ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA2_get_Vact_space(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA3                                                                 0x9800D248
+#define HDMI_V_PARA3_reg_addr                                                        "0xD800D248"
+#define HDMI_V_PARA3_reg                                                             0xD800D248
+#define set_HDMI_V_PARA3_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA3_reg)=data)
+#define get_HDMI_V_PARA3_reg   (*((volatile unsigned int*) HDMI_V_PARA3_reg))
+#define HDMI_V_PARA3_inst_adr                                                        "0x0092"
+#define HDMI_V_PARA3_inst                                                            0x0092
+#define HDMI_V_PARA3_Vblank3_shift                                                   (16)
+#define HDMI_V_PARA3_Vblank3_mask                                                    (0x3FFF0000)
+#define HDMI_V_PARA3_Vblank3(data)                                                   (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA3_Vblank3_src(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA3_get_Vblank3(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA3_Vact_space2_shift                                               (0)
+#define HDMI_V_PARA3_Vact_space2_mask                                                (0x00003FFF)
+#define HDMI_V_PARA3_Vact_space2(data)                                               (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA3_Vact_space2_src(data)                                           ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA3_get_Vact_space2(data)                                           ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA4                                                                 0x9800D24C
+#define HDMI_V_PARA4_reg_addr                                                        "0xD800D24C"
+#define HDMI_V_PARA4_reg                                                             0xD800D24C
+#define set_HDMI_V_PARA4_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA4_reg)=data)
+#define get_HDMI_V_PARA4_reg   (*((volatile unsigned int*) HDMI_V_PARA4_reg))
+#define HDMI_V_PARA4_inst_adr                                                        "0x0093"
+#define HDMI_V_PARA4_inst                                                            0x0093
+#define HDMI_V_PARA4_vsync_shift                                                     (16)
+#define HDMI_V_PARA4_vsync_mask                                                      (0x3FFF0000)
+#define HDMI_V_PARA4_vsync(data)                                                     (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA4_vsync_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA4_get_vsync(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA4_vblank_shift                                                    (0)
+#define HDMI_V_PARA4_vblank_mask                                                     (0x00003FFF)
+#define HDMI_V_PARA4_vblank(data)                                                    (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA4_vblank_src(data)                                                ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA4_get_vblank(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA5                                                                 0x9800D250
+#define HDMI_V_PARA5_reg_addr                                                        "0xD800D250"
+#define HDMI_V_PARA5_reg                                                             0xD800D250
+#define set_HDMI_V_PARA5_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA5_reg)=data)
+#define get_HDMI_V_PARA5_reg   (*((volatile unsigned int*) HDMI_V_PARA5_reg))
+#define HDMI_V_PARA5_inst_adr                                                        "0x0094"
+#define HDMI_V_PARA5_inst                                                            0x0094
+#define HDMI_V_PARA5_vback_shift                                                     (16)
+#define HDMI_V_PARA5_vback_mask                                                      (0x3FFF0000)
+#define HDMI_V_PARA5_vback(data)                                                     (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA5_vback_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA5_get_vback(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA5_vfront_shift                                                    (0)
+#define HDMI_V_PARA5_vfront_mask                                                     (0x00003FFF)
+#define HDMI_V_PARA5_vfront(data)                                                    (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA5_vfront_src(data)                                                ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA5_get_vfront(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA6                                                                 0x9800D254
+#define HDMI_V_PARA6_reg_addr                                                        "0xD800D254"
+#define HDMI_V_PARA6_reg                                                             0xD800D254
+#define set_HDMI_V_PARA6_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA6_reg)=data)
+#define get_HDMI_V_PARA6_reg   (*((volatile unsigned int*) HDMI_V_PARA6_reg))
+#define HDMI_V_PARA6_inst_adr                                                        "0x0095"
+#define HDMI_V_PARA6_inst                                                            0x0095
+#define HDMI_V_PARA6_Vsync1_shift                                                    (16)
+#define HDMI_V_PARA6_Vsync1_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA6_Vsync1(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA6_Vsync1_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA6_get_Vsync1(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA6_Vblank1_shift                                                   (0)
+#define HDMI_V_PARA6_Vblank1_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA6_Vblank1(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA6_Vblank1_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA6_get_Vblank1(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA7                                                                 0x9800D258
+#define HDMI_V_PARA7_reg_addr                                                        "0xD800D258"
+#define HDMI_V_PARA7_reg                                                             0xD800D258
+#define set_HDMI_V_PARA7_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA7_reg)=data)
+#define get_HDMI_V_PARA7_reg   (*((volatile unsigned int*) HDMI_V_PARA7_reg))
+#define HDMI_V_PARA7_inst_adr                                                        "0x0096"
+#define HDMI_V_PARA7_inst                                                            0x0096
+#define HDMI_V_PARA7_Vback1_shift                                                    (16)
+#define HDMI_V_PARA7_Vback1_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA7_Vback1(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA7_Vback1_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA7_get_Vback1(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA7_Vfront1_shift                                                   (0)
+#define HDMI_V_PARA7_Vfront1_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA7_Vfront1(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA7_Vfront1_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA7_get_Vfront1(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA8                                                                 0x9800D25C
+#define HDMI_V_PARA8_reg_addr                                                        "0xD800D25C"
+#define HDMI_V_PARA8_reg                                                             0xD800D25C
+#define set_HDMI_V_PARA8_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA8_reg)=data)
+#define get_HDMI_V_PARA8_reg   (*((volatile unsigned int*) HDMI_V_PARA8_reg))
+#define HDMI_V_PARA8_inst_adr                                                        "0x0097"
+#define HDMI_V_PARA8_inst                                                            0x0097
+#define HDMI_V_PARA8_Vsync2_shift                                                    (16)
+#define HDMI_V_PARA8_Vsync2_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA8_Vsync2(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA8_Vsync2_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA8_get_Vsync2(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA8_Vblank2_shift                                                   (0)
+#define HDMI_V_PARA8_Vblank2_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA8_Vblank2(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA8_Vblank2_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA8_get_Vblank2(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA9                                                                 0x9800D260
+#define HDMI_V_PARA9_reg_addr                                                        "0xD800D260"
+#define HDMI_V_PARA9_reg                                                             0xD800D260
+#define set_HDMI_V_PARA9_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA9_reg)=data)
+#define get_HDMI_V_PARA9_reg   (*((volatile unsigned int*) HDMI_V_PARA9_reg))
+#define HDMI_V_PARA9_inst_adr                                                        "0x0098"
+#define HDMI_V_PARA9_inst                                                            0x0098
+#define HDMI_V_PARA9_Vback2_shift                                                    (16)
+#define HDMI_V_PARA9_Vback2_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA9_Vback2(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA9_Vback2_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA9_get_Vback2(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA9_Vfront2_shift                                                   (0)
+#define HDMI_V_PARA9_Vfront2_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA9_Vfront2(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA9_Vfront2_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA9_get_Vfront2(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA12                                                                0x9800D264
+#define HDMI_V_PARA12_reg_addr                                                       "0xD800D264"
+#define HDMI_V_PARA12_reg                                                            0xD800D264
+#define set_HDMI_V_PARA12_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA12_reg)=data)
+#define get_HDMI_V_PARA12_reg   (*((volatile unsigned int*) HDMI_V_PARA12_reg))
+#define HDMI_V_PARA12_inst_adr                                                       "0x0099"
+#define HDMI_V_PARA12_inst                                                           0x0099
+#define HDMI_V_PARA12_vsynci_shift                                                   (16)
+#define HDMI_V_PARA12_vsynci_mask                                                    (0x3FFF0000)
+#define HDMI_V_PARA12_vsynci(data)                                                   (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA12_vsynci_src(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA12_get_vsynci(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA12_vblanki_shift                                                  (0)
+#define HDMI_V_PARA12_vblanki_mask                                                   (0x00003FFF)
+#define HDMI_V_PARA12_vblanki(data)                                                  (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA12_vblanki_src(data)                                              ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA12_get_vblanki(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA13                                                                0x9800D268
+#define HDMI_V_PARA13_reg_addr                                                       "0xD800D268"
+#define HDMI_V_PARA13_reg                                                            0xD800D268
+#define set_HDMI_V_PARA13_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA13_reg)=data)
+#define get_HDMI_V_PARA13_reg   (*((volatile unsigned int*) HDMI_V_PARA13_reg))
+#define HDMI_V_PARA13_inst_adr                                                       "0x009A"
+#define HDMI_V_PARA13_inst                                                           0x009A
+#define HDMI_V_PARA13_vbacki_shift                                                   (16)
+#define HDMI_V_PARA13_vbacki_mask                                                    (0x3FFF0000)
+#define HDMI_V_PARA13_vbacki(data)                                                   (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA13_vbacki_src(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA13_get_vbacki(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA13_vfronti_shift                                                  (0)
+#define HDMI_V_PARA13_vfronti_mask                                                   (0x00003FFF)
+#define HDMI_V_PARA13_vfronti(data)                                                  (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA13_vfronti_src(data)                                              ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA13_get_vfronti(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA10                                                                0x9800D26C
+#define HDMI_V_PARA10_reg_addr                                                       "0xD800D26C"
+#define HDMI_V_PARA10_reg                                                            0xD800D26C
+#define set_HDMI_V_PARA10_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA10_reg)=data)
+#define get_HDMI_V_PARA10_reg   (*((volatile unsigned int*) HDMI_V_PARA10_reg))
+#define HDMI_V_PARA10_inst_adr                                                       "0x009B"
+#define HDMI_V_PARA10_inst                                                           0x009B
+#define HDMI_V_PARA10_G_shift                                                        (0)
+#define HDMI_V_PARA10_G_mask                                                         (0x00000FFF)
+#define HDMI_V_PARA10_G(data)                                                        (0x00000FFF&((data)<<0))
+#define HDMI_V_PARA10_G_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define HDMI_V_PARA10_get_G(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_V_PARA11                                                                0x9800D270
+#define HDMI_V_PARA11_reg_addr                                                       "0xD800D270"
+#define HDMI_V_PARA11_reg                                                            0xD800D270
+#define set_HDMI_V_PARA11_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA11_reg)=data)
+#define get_HDMI_V_PARA11_reg   (*((volatile unsigned int*) HDMI_V_PARA11_reg))
+#define HDMI_V_PARA11_inst_adr                                                       "0x009C"
+#define HDMI_V_PARA11_inst                                                           0x009C
+#define HDMI_V_PARA11_B_shift                                                        (16)
+#define HDMI_V_PARA11_B_mask                                                         (0x0FFF0000)
+#define HDMI_V_PARA11_B(data)                                                        (0x0FFF0000&((data)<<16))
+#define HDMI_V_PARA11_B_src(data)                                                    ((0x0FFF0000&(data))>>16)
+#define HDMI_V_PARA11_get_B(data)                                                    ((0x0FFF0000&(data))>>16)
+#define HDMI_V_PARA11_R_shift                                                        (0)
+#define HDMI_V_PARA11_R_mask                                                         (0x00000FFF)
+#define HDMI_V_PARA11_R(data)                                                        (0x00000FFF&((data)<<0))
+#define HDMI_V_PARA11_R_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define HDMI_V_PARA11_get_R(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_TIMING_GEN_STATUS                                                       0x9800D2A4
+#define HDMI_TIMING_GEN_STATUS_reg_addr                                              "0xD800D2A4"
+#define HDMI_TIMING_GEN_STATUS_reg                                                   0xD800D2A4
+#define set_HDMI_TIMING_GEN_STATUS_reg(data)   (*((volatile unsigned int*) HDMI_TIMING_GEN_STATUS_reg)=data)
+#define get_HDMI_TIMING_GEN_STATUS_reg   (*((volatile unsigned int*) HDMI_TIMING_GEN_STATUS_reg))
+#define HDMI_TIMING_GEN_STATUS_inst_adr                                              "0x00A9"
+#define HDMI_TIMING_GEN_STATUS_inst                                                  0x00A9
+#define HDMI_TIMING_GEN_STATUS_interlace_field_shift                                 (0)
+#define HDMI_TIMING_GEN_STATUS_interlace_field_mask                                  (0x00000001)
+#define HDMI_TIMING_GEN_STATUS_interlace_field(data)                                 (0x00000001&((data)<<0))
+#define HDMI_TIMING_GEN_STATUS_interlace_field_src(data)                             ((0x00000001&(data))>>0)
+#define HDMI_TIMING_GEN_STATUS_get_interlace_field(data)                             ((0x00000001&(data))>>0)
+
+
+#define HDMI_BIST1_CTRL                                                              0x9800D280
+#define HDMI_BIST1_CTRL_reg_addr                                                     "0xD800D280"
+#define HDMI_BIST1_CTRL_reg                                                          0xD800D280
+#define set_HDMI_BIST1_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_BIST1_CTRL_reg)=data)
+#define get_HDMI_BIST1_CTRL_reg   (*((volatile unsigned int*) HDMI_BIST1_CTRL_reg))
+#define HDMI_BIST1_CTRL_inst_adr                                                     "0x00A0"
+#define HDMI_BIST1_CTRL_inst                                                         0x00A0
+#define HDMI_BIST1_CTRL_ls_shift                                                     (8)
+#define HDMI_BIST1_CTRL_ls_mask                                                      (0x00000100)
+#define HDMI_BIST1_CTRL_ls(data)                                                     (0x00000100&((data)<<8))
+#define HDMI_BIST1_CTRL_ls_src(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST1_CTRL_get_ls(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST1_CTRL_dft_test_resume_shift                                        (7)
+#define HDMI_BIST1_CTRL_dft_test_resume_mask                                         (0x00000080)
+#define HDMI_BIST1_CTRL_dft_test_resume(data)                                        (0x00000080&((data)<<7))
+#define HDMI_BIST1_CTRL_dft_test_resume_src(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST1_CTRL_get_dft_test_resume(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST1_CTRL_dft_bist_mode_shift                                          (6)
+#define HDMI_BIST1_CTRL_dft_bist_mode_mask                                           (0x00000040)
+#define HDMI_BIST1_CTRL_dft_bist_mode(data)                                          (0x00000040&((data)<<6))
+#define HDMI_BIST1_CTRL_dft_bist_mode_src(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST1_CTRL_get_dft_bist_mode(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST1_CTRL_bist_mode_shift                                              (5)
+#define HDMI_BIST1_CTRL_bist_mode_mask                                               (0x00000020)
+#define HDMI_BIST1_CTRL_bist_mode(data)                                              (0x00000020&((data)<<5))
+#define HDMI_BIST1_CTRL_bist_mode_src(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST1_CTRL_get_bist_mode(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST1_CTRL_rme_shift                                                    (4)
+#define HDMI_BIST1_CTRL_rme_mask                                                     (0x00000010)
+#define HDMI_BIST1_CTRL_rme(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_BIST1_CTRL_rme_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST1_CTRL_get_rme(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST1_CTRL_rm_shift                                                     (0)
+#define HDMI_BIST1_CTRL_rm_mask                                                      (0x0000000F)
+#define HDMI_BIST1_CTRL_rm(data)                                                     (0x0000000F&((data)<<0))
+#define HDMI_BIST1_CTRL_rm_src(data)                                                 ((0x0000000F&(data))>>0)
+#define HDMI_BIST1_CTRL_get_rm(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define HDMI_BIST2_CTRL                                                              0x9800D29C
+#define HDMI_BIST2_CTRL_reg_addr                                                     "0xD800D29C"
+#define HDMI_BIST2_CTRL_reg                                                          0xD800D29C
+#define set_HDMI_BIST2_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_BIST2_CTRL_reg)=data)
+#define get_HDMI_BIST2_CTRL_reg   (*((volatile unsigned int*) HDMI_BIST2_CTRL_reg))
+#define HDMI_BIST2_CTRL_inst_adr                                                     "0x00A7"
+#define HDMI_BIST2_CTRL_inst                                                         0x00A7
+#define HDMI_BIST2_CTRL_ls_shift                                                     (8)
+#define HDMI_BIST2_CTRL_ls_mask                                                      (0x00000100)
+#define HDMI_BIST2_CTRL_ls(data)                                                     (0x00000100&((data)<<8))
+#define HDMI_BIST2_CTRL_ls_src(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST2_CTRL_get_ls(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST2_CTRL_dft_test_resume_shift                                        (7)
+#define HDMI_BIST2_CTRL_dft_test_resume_mask                                         (0x00000080)
+#define HDMI_BIST2_CTRL_dft_test_resume(data)                                        (0x00000080&((data)<<7))
+#define HDMI_BIST2_CTRL_dft_test_resume_src(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST2_CTRL_get_dft_test_resume(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST2_CTRL_dft_bist_mode_shift                                          (6)
+#define HDMI_BIST2_CTRL_dft_bist_mode_mask                                           (0x00000040)
+#define HDMI_BIST2_CTRL_dft_bist_mode(data)                                          (0x00000040&((data)<<6))
+#define HDMI_BIST2_CTRL_dft_bist_mode_src(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST2_CTRL_get_dft_bist_mode(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST2_CTRL_bist_mode_shift                                              (5)
+#define HDMI_BIST2_CTRL_bist_mode_mask                                               (0x00000020)
+#define HDMI_BIST2_CTRL_bist_mode(data)                                              (0x00000020&((data)<<5))
+#define HDMI_BIST2_CTRL_bist_mode_src(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST2_CTRL_get_bist_mode(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST2_CTRL_rme_shift                                                    (4)
+#define HDMI_BIST2_CTRL_rme_mask                                                     (0x00000010)
+#define HDMI_BIST2_CTRL_rme(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_BIST2_CTRL_rme_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST2_CTRL_get_rme(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST2_CTRL_rm_shift                                                     (0)
+#define HDMI_BIST2_CTRL_rm_mask                                                      (0x0000000F)
+#define HDMI_BIST2_CTRL_rm(data)                                                     (0x0000000F&((data)<<0))
+#define HDMI_BIST2_CTRL_rm_src(data)                                                 ((0x0000000F&(data))>>0)
+#define HDMI_BIST2_CTRL_get_rm(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define HDMI_BIST1_ST                                                                0x9800D284
+#define HDMI_BIST1_ST_reg_addr                                                       "0xD800D284"
+#define HDMI_BIST1_ST_reg                                                            0xD800D284
+#define set_HDMI_BIST1_ST_reg(data)   (*((volatile unsigned int*) HDMI_BIST1_ST_reg)=data)
+#define get_HDMI_BIST1_ST_reg   (*((volatile unsigned int*) HDMI_BIST1_ST_reg))
+#define HDMI_BIST1_ST_inst_adr                                                       "0x00A1"
+#define HDMI_BIST1_ST_inst                                                           0x00A1
+#define HDMI_BIST1_ST_bist1_fail0_shift                                              (1)
+#define HDMI_BIST1_ST_bist1_fail0_mask                                               (0x00000002)
+#define HDMI_BIST1_ST_bist1_fail0(data)                                              (0x00000002&((data)<<1))
+#define HDMI_BIST1_ST_bist1_fail0_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST1_ST_get_bist1_fail0(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST1_ST_bist1_done_shift                                               (0)
+#define HDMI_BIST1_ST_bist1_done_mask                                                (0x00000001)
+#define HDMI_BIST1_ST_bist1_done(data)                                               (0x00000001&((data)<<0))
+#define HDMI_BIST1_ST_bist1_done_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_BIST1_ST_get_bist1_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_DRF_BIST1_ST                                                            0x9800D288
+#define HDMI_DRF_BIST1_ST_reg_addr                                                   "0xD800D288"
+#define HDMI_DRF_BIST1_ST_reg                                                        0xD800D288
+#define set_HDMI_DRF_BIST1_ST_reg(data)   (*((volatile unsigned int*) HDMI_DRF_BIST1_ST_reg)=data)
+#define get_HDMI_DRF_BIST1_ST_reg   (*((volatile unsigned int*) HDMI_DRF_BIST1_ST_reg))
+#define HDMI_DRF_BIST1_ST_inst_adr                                                   "0x00A2"
+#define HDMI_DRF_BIST1_ST_inst                                                       0x00A2
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause_shift                                (16)
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause_mask                                 (0x00010000)
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause(data)                                (0x00010000&((data)<<16))
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause_src(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST1_ST_get_drf_bist1_start_pause(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0_shift                                      (1)
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0_mask                                       (0x00000002)
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0(data)                                      (0x00000002&((data)<<1))
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0_src(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST1_ST_get_drf_bist1_fail0(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST1_ST_drf_bist1_done_shift                                       (0)
+#define HDMI_DRF_BIST1_ST_drf_bist1_done_mask                                        (0x00000001)
+#define HDMI_DRF_BIST1_ST_drf_bist1_done(data)                                       (0x00000001&((data)<<0))
+#define HDMI_DRF_BIST1_ST_drf_bist1_done_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_DRF_BIST1_ST_get_drf_bist1_done(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_BIST2_ST                                                                0x9800D28C
+#define HDMI_BIST2_ST_reg_addr                                                       "0xD800D28C"
+#define HDMI_BIST2_ST_reg                                                            0xD800D28C
+#define set_HDMI_BIST2_ST_reg(data)   (*((volatile unsigned int*) HDMI_BIST2_ST_reg)=data)
+#define get_HDMI_BIST2_ST_reg   (*((volatile unsigned int*) HDMI_BIST2_ST_reg))
+#define HDMI_BIST2_ST_inst_adr                                                       "0x00A3"
+#define HDMI_BIST2_ST_inst                                                           0x00A3
+#define HDMI_BIST2_ST_bist2_fail0_shift                                              (1)
+#define HDMI_BIST2_ST_bist2_fail0_mask                                               (0x00000002)
+#define HDMI_BIST2_ST_bist2_fail0(data)                                              (0x00000002&((data)<<1))
+#define HDMI_BIST2_ST_bist2_fail0_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST2_ST_get_bist2_fail0(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST2_ST_bist2_done_shift                                               (0)
+#define HDMI_BIST2_ST_bist2_done_mask                                                (0x00000001)
+#define HDMI_BIST2_ST_bist2_done(data)                                               (0x00000001&((data)<<0))
+#define HDMI_BIST2_ST_bist2_done_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_BIST2_ST_get_bist2_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_DRF_BIST2_ST                                                            0x9800D290
+#define HDMI_DRF_BIST2_ST_reg_addr                                                   "0xD800D290"
+#define HDMI_DRF_BIST2_ST_reg                                                        0xD800D290
+#define set_HDMI_DRF_BIST2_ST_reg(data)   (*((volatile unsigned int*) HDMI_DRF_BIST2_ST_reg)=data)
+#define get_HDMI_DRF_BIST2_ST_reg   (*((volatile unsigned int*) HDMI_DRF_BIST2_ST_reg))
+#define HDMI_DRF_BIST2_ST_inst_adr                                                   "0x00A4"
+#define HDMI_DRF_BIST2_ST_inst                                                       0x00A4
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause_shift                                (16)
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause_mask                                 (0x00010000)
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause(data)                                (0x00010000&((data)<<16))
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause_src(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST2_ST_get_drf_bist2_start_pause(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0_shift                                      (1)
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0_mask                                       (0x00000002)
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0(data)                                      (0x00000002&((data)<<1))
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0_src(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST2_ST_get_drf_bist2_fail0(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST2_ST_drf_bist2_done_shift                                       (0)
+#define HDMI_DRF_BIST2_ST_drf_bist2_done_mask                                        (0x00000001)
+#define HDMI_DRF_BIST2_ST_drf_bist2_done(data)                                       (0x00000001&((data)<<0))
+#define HDMI_DRF_BIST2_ST_drf_bist2_done_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_DRF_BIST2_ST_get_drf_bist2_done(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_BIST3_CTRL                                                              0x9800D0f0
+#define HDMI_BIST3_CTRL_reg_addr                                                     "0xD800D0F0"
+#define HDMI_BIST3_CTRL_reg                                                          0xD800D0F0
+#define set_HDMI_BIST3_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_BIST3_CTRL_reg)=data)
+#define get_HDMI_BIST3_CTRL_reg   (*((volatile unsigned int*) HDMI_BIST3_CTRL_reg))
+#define HDMI_BIST3_CTRL_inst_adr                                                     "0x003C"
+#define HDMI_BIST3_CTRL_inst                                                         0x003C
+#define HDMI_BIST3_CTRL_ls_shift                                                     (8)
+#define HDMI_BIST3_CTRL_ls_mask                                                      (0x00000100)
+#define HDMI_BIST3_CTRL_ls(data)                                                     (0x00000100&((data)<<8))
+#define HDMI_BIST3_CTRL_ls_src(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST3_CTRL_get_ls(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_BIST3_CTRL_dft_test_resume_shift                                        (7)
+#define HDMI_BIST3_CTRL_dft_test_resume_mask                                         (0x00000080)
+#define HDMI_BIST3_CTRL_dft_test_resume(data)                                        (0x00000080&((data)<<7))
+#define HDMI_BIST3_CTRL_dft_test_resume_src(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST3_CTRL_get_dft_test_resume(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST3_CTRL_dft_bist_mode_shift                                          (6)
+#define HDMI_BIST3_CTRL_dft_bist_mode_mask                                           (0x00000040)
+#define HDMI_BIST3_CTRL_dft_bist_mode(data)                                          (0x00000040&((data)<<6))
+#define HDMI_BIST3_CTRL_dft_bist_mode_src(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST3_CTRL_get_dft_bist_mode(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST3_CTRL_bist_mode_shift                                              (5)
+#define HDMI_BIST3_CTRL_bist_mode_mask                                               (0x00000020)
+#define HDMI_BIST3_CTRL_bist_mode(data)                                              (0x00000020&((data)<<5))
+#define HDMI_BIST3_CTRL_bist_mode_src(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST3_CTRL_get_bist_mode(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST3_CTRL_rme_shift                                                    (4)
+#define HDMI_BIST3_CTRL_rme_mask                                                     (0x00000010)
+#define HDMI_BIST3_CTRL_rme(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_BIST3_CTRL_rme_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST3_CTRL_get_rme(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST3_CTRL_rm_shift                                                     (0)
+#define HDMI_BIST3_CTRL_rm_mask                                                      (0x0000000F)
+#define HDMI_BIST3_CTRL_rm(data)                                                     (0x0000000F&((data)<<0))
+#define HDMI_BIST3_CTRL_rm_src(data)                                                 ((0x0000000F&(data))>>0)
+#define HDMI_BIST3_CTRL_get_rm(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define HDMI_BIST3_ST                                                                0x9800D0f4
+#define HDMI_BIST3_ST_reg_addr                                                       "0xD800D0F4"
+#define HDMI_BIST3_ST_reg                                                            0xD800D0F4
+#define set_HDMI_BIST3_ST_reg(data)   (*((volatile unsigned int*) HDMI_BIST3_ST_reg)=data)
+#define get_HDMI_BIST3_ST_reg   (*((volatile unsigned int*) HDMI_BIST3_ST_reg))
+#define HDMI_BIST3_ST_inst_adr                                                       "0x003D"
+#define HDMI_BIST3_ST_inst                                                           0x003D
+#define HDMI_BIST3_ST_bist3_fail0_shift                                              (1)
+#define HDMI_BIST3_ST_bist3_fail0_mask                                               (0x00000002)
+#define HDMI_BIST3_ST_bist3_fail0(data)                                              (0x00000002&((data)<<1))
+#define HDMI_BIST3_ST_bist3_fail0_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST3_ST_get_bist3_fail0(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST3_ST_bist3_done_shift                                               (0)
+#define HDMI_BIST3_ST_bist3_done_mask                                                (0x00000001)
+#define HDMI_BIST3_ST_bist3_done(data)                                               (0x00000001&((data)<<0))
+#define HDMI_BIST3_ST_bist3_done_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_BIST3_ST_get_bist3_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_DRF_BIST3_ST                                                            0x9800D0f8
+#define HDMI_DRF_BIST3_ST_reg_addr                                                   "0xD800D0F8"
+#define HDMI_DRF_BIST3_ST_reg                                                        0xD800D0F8
+#define set_HDMI_DRF_BIST3_ST_reg(data)   (*((volatile unsigned int*) HDMI_DRF_BIST3_ST_reg)=data)
+#define get_HDMI_DRF_BIST3_ST_reg   (*((volatile unsigned int*) HDMI_DRF_BIST3_ST_reg))
+#define HDMI_DRF_BIST3_ST_inst_adr                                                   "0x003E"
+#define HDMI_DRF_BIST3_ST_inst                                                       0x003E
+#define HDMI_DRF_BIST3_ST_drf_bist3_start_pause_shift                                (16)
+#define HDMI_DRF_BIST3_ST_drf_bist3_start_pause_mask                                 (0x00010000)
+#define HDMI_DRF_BIST3_ST_drf_bist3_start_pause(data)                                (0x00010000&((data)<<16))
+#define HDMI_DRF_BIST3_ST_drf_bist3_start_pause_src(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST3_ST_get_drf_bist3_start_pause(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST3_ST_drf_bist3_fail0_shift                                      (1)
+#define HDMI_DRF_BIST3_ST_drf_bist3_fail0_mask                                       (0x00000002)
+#define HDMI_DRF_BIST3_ST_drf_bist3_fail0(data)                                      (0x00000002&((data)<<1))
+#define HDMI_DRF_BIST3_ST_drf_bist3_fail0_src(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST3_ST_get_drf_bist3_fail0(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST3_ST_drf_bist3_done_shift                                       (0)
+#define HDMI_DRF_BIST3_ST_drf_bist3_done_mask                                        (0x00000001)
+#define HDMI_DRF_BIST3_ST_drf_bist3_done(data)                                       (0x00000001&((data)<<0))
+#define HDMI_DRF_BIST3_ST_drf_bist3_done_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_DRF_BIST3_ST_get_drf_bist3_done(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHLCTRL                                                                 0x9800D298
+#define HDMI_MHLCTRL_reg_addr                                                        "0xD800D298"
+#define HDMI_MHLCTRL_reg                                                             0xD800D298
+#define set_HDMI_MHLCTRL_reg(data)   (*((volatile unsigned int*) HDMI_MHLCTRL_reg)=data)
+#define get_HDMI_MHLCTRL_reg   (*((volatile unsigned int*) HDMI_MHLCTRL_reg))
+#define HDMI_MHLCTRL_inst_adr                                                        "0x00A6"
+#define HDMI_MHLCTRL_inst                                                            0x00A6
+#define HDMI_MHLCTRL_write_en7_shift                                                 (17)
+#define HDMI_MHLCTRL_write_en7_mask                                                  (0x00020000)
+#define HDMI_MHLCTRL_write_en7(data)                                                 (0x00020000&((data)<<17))
+#define HDMI_MHLCTRL_write_en7_src(data)                                             ((0x00020000&(data))>>17)
+#define HDMI_MHLCTRL_get_write_en7(data)                                             ((0x00020000&(data))>>17)
+#define HDMI_MHLCTRL_xor_pixel_sel_di_shift                                          (14)
+#define HDMI_MHLCTRL_xor_pixel_sel_di_mask                                           (0x0001C000)
+#define HDMI_MHLCTRL_xor_pixel_sel_di(data)                                          (0x0001C000&((data)<<14))
+#define HDMI_MHLCTRL_xor_pixel_sel_di_src(data)                                      ((0x0001C000&(data))>>14)
+#define HDMI_MHLCTRL_get_xor_pixel_sel_di(data)                                      ((0x0001C000&(data))>>14)
+#define HDMI_MHLCTRL_write_en6_shift                                                 (13)
+#define HDMI_MHLCTRL_write_en6_mask                                                  (0x00002000)
+#define HDMI_MHLCTRL_write_en6(data)                                                 (0x00002000&((data)<<13))
+#define HDMI_MHLCTRL_write_en6_src(data)                                             ((0x00002000&(data))>>13)
+#define HDMI_MHLCTRL_get_write_en6(data)                                             ((0x00002000&(data))>>13)
+#define HDMI_MHLCTRL_mhl_pp_ch1sel_shift                                             (12)
+#define HDMI_MHLCTRL_mhl_pp_ch1sel_mask                                              (0x00001000)
+#define HDMI_MHLCTRL_mhl_pp_ch1sel(data)                                             (0x00001000&((data)<<12))
+#define HDMI_MHLCTRL_mhl_pp_ch1sel_src(data)                                         ((0x00001000&(data))>>12)
+#define HDMI_MHLCTRL_get_mhl_pp_ch1sel(data)                                         ((0x00001000&(data))>>12)
+#define HDMI_MHLCTRL_write_en5_shift                                                 (11)
+#define HDMI_MHLCTRL_write_en5_mask                                                  (0x00000800)
+#define HDMI_MHLCTRL_write_en5(data)                                                 (0x00000800&((data)<<11))
+#define HDMI_MHLCTRL_write_en5_src(data)                                             ((0x00000800&(data))>>11)
+#define HDMI_MHLCTRL_get_write_en5(data)                                             ((0x00000800&(data))>>11)
+#define HDMI_MHLCTRL_mhl_phy_test_mode_shift                                         (10)
+#define HDMI_MHLCTRL_mhl_phy_test_mode_mask                                          (0x00000400)
+#define HDMI_MHLCTRL_mhl_phy_test_mode(data)                                         (0x00000400&((data)<<10))
+#define HDMI_MHLCTRL_mhl_phy_test_mode_src(data)                                     ((0x00000400&(data))>>10)
+#define HDMI_MHLCTRL_get_mhl_phy_test_mode(data)                                     ((0x00000400&(data))>>10)
+#define HDMI_MHLCTRL_write_en4_shift                                                 (9)
+#define HDMI_MHLCTRL_write_en4_mask                                                  (0x00000200)
+#define HDMI_MHLCTRL_write_en4(data)                                                 (0x00000200&((data)<<9))
+#define HDMI_MHLCTRL_write_en4_src(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_MHLCTRL_get_write_en4(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_MHLCTRL_xor_pixel_sel_shift                                             (6)
+#define HDMI_MHLCTRL_xor_pixel_sel_mask                                              (0x000001C0)
+#define HDMI_MHLCTRL_xor_pixel_sel(data)                                             (0x000001C0&((data)<<6))
+#define HDMI_MHLCTRL_xor_pixel_sel_src(data)                                         ((0x000001C0&(data))>>6)
+#define HDMI_MHLCTRL_get_xor_pixel_sel(data)                                         ((0x000001C0&(data))>>6)
+#define HDMI_MHLCTRL_write_en3_shift                                                 (5)
+#define HDMI_MHLCTRL_write_en3_mask                                                  (0x00000020)
+#define HDMI_MHLCTRL_write_en3(data)                                                 (0x00000020&((data)<<5))
+#define HDMI_MHLCTRL_write_en3_src(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_MHLCTRL_get_write_en3(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_MHLCTRL_mhl_enc_sel_shift                                               (4)
+#define HDMI_MHLCTRL_mhl_enc_sel_mask                                                (0x00000010)
+#define HDMI_MHLCTRL_mhl_enc_sel(data)                                               (0x00000010&((data)<<4))
+#define HDMI_MHLCTRL_mhl_enc_sel_src(data)                                           ((0x00000010&(data))>>4)
+#define HDMI_MHLCTRL_get_mhl_enc_sel(data)                                           ((0x00000010&(data))>>4)
+#define HDMI_MHLCTRL_write_en2_shift                                                 (3)
+#define HDMI_MHLCTRL_write_en2_mask                                                  (0x00000008)
+#define HDMI_MHLCTRL_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define HDMI_MHLCTRL_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_MHLCTRL_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_MHLCTRL_mhl_pp_mode_shift                                               (2)
+#define HDMI_MHLCTRL_mhl_pp_mode_mask                                                (0x00000004)
+#define HDMI_MHLCTRL_mhl_pp_mode(data)                                               (0x00000004&((data)<<2))
+#define HDMI_MHLCTRL_mhl_pp_mode_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_MHLCTRL_get_mhl_pp_mode(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_MHLCTRL_write_en1_shift                                                 (1)
+#define HDMI_MHLCTRL_write_en1_mask                                                  (0x00000002)
+#define HDMI_MHLCTRL_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_MHLCTRL_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_MHLCTRL_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_MHLCTRL_mhl_enable_shift                                                (0)
+#define HDMI_MHLCTRL_mhl_enable_mask                                                 (0x00000001)
+#define HDMI_MHLCTRL_mhl_enable(data)                                                (0x00000001&((data)<<0))
+#define HDMI_MHLCTRL_mhl_enable_src(data)                                            ((0x00000001&(data))>>0)
+#define HDMI_MHLCTRL_get_mhl_enable(data)                                            ((0x00000001&(data))>>0)
+
+
+#define HDMI_CHSWAP                                                                  0x9800D2A0
+#define HDMI_CHSWAP_reg_addr                                                         "0xD800D2A0"
+#define HDMI_CHSWAP_reg                                                              0xD800D2A0
+#define set_HDMI_CHSWAP_reg(data)   (*((volatile unsigned int*) HDMI_CHSWAP_reg)=data)
+#define get_HDMI_CHSWAP_reg   (*((volatile unsigned int*) HDMI_CHSWAP_reg))
+#define HDMI_CHSWAP_inst_adr                                                         "0x00A8"
+#define HDMI_CHSWAP_inst                                                             0x00A8
+#define HDMI_CHSWAP_write_en3_shift                                                  (5)
+#define HDMI_CHSWAP_write_en3_mask                                                   (0x00000020)
+#define HDMI_CHSWAP_write_en3(data)                                                  (0x00000020&((data)<<5))
+#define HDMI_CHSWAP_write_en3_src(data)                                              ((0x00000020&(data))>>5)
+#define HDMI_CHSWAP_get_write_en3(data)                                              ((0x00000020&(data))>>5)
+#define HDMI_CHSWAP_mhl_ch_sel_shift                                                 (4)
+#define HDMI_CHSWAP_mhl_ch_sel_mask                                                  (0x00000010)
+#define HDMI_CHSWAP_mhl_ch_sel(data)                                                 (0x00000010&((data)<<4))
+#define HDMI_CHSWAP_mhl_ch_sel_src(data)                                             ((0x00000010&(data))>>4)
+#define HDMI_CHSWAP_get_mhl_ch_sel(data)                                             ((0x00000010&(data))>>4)
+#define HDMI_CHSWAP_write_en2_shift                                                  (3)
+#define HDMI_CHSWAP_write_en2_mask                                                   (0x00000008)
+#define HDMI_CHSWAP_write_en2(data)                                                  (0x00000008&((data)<<3))
+#define HDMI_CHSWAP_write_en2_src(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_CHSWAP_get_write_en2(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_CHSWAP_hdmi_chcclk_swap_shift                                           (2)
+#define HDMI_CHSWAP_hdmi_chcclk_swap_mask                                            (0x00000004)
+#define HDMI_CHSWAP_hdmi_chcclk_swap(data)                                           (0x00000004&((data)<<2))
+#define HDMI_CHSWAP_hdmi_chcclk_swap_src(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_CHSWAP_get_hdmi_chcclk_swap(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_CHSWAP_write_en1_shift                                                  (1)
+#define HDMI_CHSWAP_write_en1_mask                                                   (0x00000002)
+#define HDMI_CHSWAP_write_en1(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_CHSWAP_write_en1_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_CHSWAP_get_write_en1(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_CHSWAP_hdmi_chab_swap_shift                                             (0)
+#define HDMI_CHSWAP_hdmi_chab_swap_mask                                              (0x00000001)
+#define HDMI_CHSWAP_hdmi_chab_swap(data)                                             (0x00000001&((data)<<0))
+#define HDMI_CHSWAP_hdmi_chab_swap_src(data)                                         ((0x00000001&(data))>>0)
+#define HDMI_CHSWAP_get_hdmi_chab_swap(data)                                         ((0x00000001&(data))>>0)
+
+
+#define HDMI_PREFIFO_CTRL                                                            0x9800D294
+#define HDMI_PREFIFO_CTRL_reg_addr                                                   "0xD800D294"
+#define HDMI_PREFIFO_CTRL_reg                                                        0xD800D294
+#define set_HDMI_PREFIFO_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_PREFIFO_CTRL_reg)=data)
+#define get_HDMI_PREFIFO_CTRL_reg   (*((volatile unsigned int*) HDMI_PREFIFO_CTRL_reg))
+#define HDMI_PREFIFO_CTRL_inst_adr                                                   "0x00A5"
+#define HDMI_PREFIFO_CTRL_inst                                                       0x00A5
+#define HDMI_PREFIFO_CTRL_write_en2_shift                                            (3)
+#define HDMI_PREFIFO_CTRL_write_en2_mask                                             (0x00000008)
+#define HDMI_PREFIFO_CTRL_write_en2(data)                                            (0x00000008&((data)<<3))
+#define HDMI_PREFIFO_CTRL_write_en2_src(data)                                        ((0x00000008&(data))>>3)
+#define HDMI_PREFIFO_CTRL_get_write_en2(data)                                        ((0x00000008&(data))>>3)
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv_shift                                     (2)
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv_mask                                      (0x00000004)
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv(data)                                     (0x00000004&((data)<<2))
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv_src(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_PREFIFO_CTRL_get_hdmi_prefifo_inv(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_PREFIFO_CTRL_write_en1_shift                                            (1)
+#define HDMI_PREFIFO_CTRL_write_en1_mask                                             (0x00000002)
+#define HDMI_PREFIFO_CTRL_write_en1(data)                                            (0x00000002&((data)<<1))
+#define HDMI_PREFIFO_CTRL_write_en1_src(data)                                        ((0x00000002&(data))>>1)
+#define HDMI_PREFIFO_CTRL_get_write_en1(data)                                        ((0x00000002&(data))>>1)
+#define HDMI_PREFIFO_CTRL_async_update_shift                                         (0)
+#define HDMI_PREFIFO_CTRL_async_update_mask                                          (0x00000001)
+#define HDMI_PREFIFO_CTRL_async_update(data)                                         (0x00000001&((data)<<0))
+#define HDMI_PREFIFO_CTRL_async_update_src(data)                                     ((0x00000001&(data))>>0)
+#define HDMI_PREFIFO_CTRL_get_async_update(data)                                     ((0x00000001&(data))>>0)
+
+
+#define HDMI_PHYCHCRTL                                                               0x9800D2AC
+#define HDMI_PHYCHCRTL_reg_addr                                                      "0xD800D2AC"
+#define HDMI_PHYCHCRTL_reg                                                           0xD800D2AC
+#define set_HDMI_PHYCHCRTL_reg(data)   (*((volatile unsigned int*) HDMI_PHYCHCRTL_reg)=data)
+#define get_HDMI_PHYCHCRTL_reg   (*((volatile unsigned int*) HDMI_PHYCHCRTL_reg))
+#define HDMI_PHYCHCRTL_inst_adr                                                      "0x00AB"
+#define HDMI_PHYCHCRTL_inst                                                          0x00AB
+#define HDMI_PHYCHCRTL_write_en5_shift                                               (13)
+#define HDMI_PHYCHCRTL_write_en5_mask                                                (0x00002000)
+#define HDMI_PHYCHCRTL_write_en5(data)                                               (0x00002000&((data)<<13))
+#define HDMI_PHYCHCRTL_write_en5_src(data)                                           ((0x00002000&(data))>>13)
+#define HDMI_PHYCHCRTL_get_write_en5(data)                                           ((0x00002000&(data))>>13)
+#define HDMI_PHYCHCRTL_data_pola_inv_shift                                           (12)
+#define HDMI_PHYCHCRTL_data_pola_inv_mask                                            (0x00001000)
+#define HDMI_PHYCHCRTL_data_pola_inv(data)                                           (0x00001000&((data)<<12))
+#define HDMI_PHYCHCRTL_data_pola_inv_src(data)                                       ((0x00001000&(data))>>12)
+#define HDMI_PHYCHCRTL_get_data_pola_inv(data)                                       ((0x00001000&(data))>>12)
+#define HDMI_PHYCHCRTL_write_en4_shift                                               (11)
+#define HDMI_PHYCHCRTL_write_en4_mask                                                (0x00000800)
+#define HDMI_PHYCHCRTL_write_en4(data)                                               (0x00000800&((data)<<11))
+#define HDMI_PHYCHCRTL_write_en4_src(data)                                           ((0x00000800&(data))>>11)
+#define HDMI_PHYCHCRTL_get_write_en4(data)                                           ((0x00000800&(data))>>11)
+#define HDMI_PHYCHCRTL_hdmi_chclk_data_swap_shift                                    (9)
+#define HDMI_PHYCHCRTL_hdmi_chclk_data_swap_mask                                     (0x00000600)
+#define HDMI_PHYCHCRTL_hdmi_chclk_data_swap(data)                                    (0x00000600&((data)<<9))
+#define HDMI_PHYCHCRTL_hdmi_chclk_data_swap_src(data)                                ((0x00000600&(data))>>9)
+#define HDMI_PHYCHCRTL_get_hdmi_chclk_data_swap(data)                                ((0x00000600&(data))>>9)
+#define HDMI_PHYCHCRTL_write_en3_shift                                               (8)
+#define HDMI_PHYCHCRTL_write_en3_mask                                                (0x00000100)
+#define HDMI_PHYCHCRTL_write_en3(data)                                               (0x00000100&((data)<<8))
+#define HDMI_PHYCHCRTL_write_en3_src(data)                                           ((0x00000100&(data))>>8)
+#define HDMI_PHYCHCRTL_get_write_en3(data)                                           ((0x00000100&(data))>>8)
+#define HDMI_PHYCHCRTL_hdmi_chc_data_swap_shift                                      (6)
+#define HDMI_PHYCHCRTL_hdmi_chc_data_swap_mask                                       (0x000000C0)
+#define HDMI_PHYCHCRTL_hdmi_chc_data_swap(data)                                      (0x000000C0&((data)<<6))
+#define HDMI_PHYCHCRTL_hdmi_chc_data_swap_src(data)                                  ((0x000000C0&(data))>>6)
+#define HDMI_PHYCHCRTL_get_hdmi_chc_data_swap(data)                                  ((0x000000C0&(data))>>6)
+#define HDMI_PHYCHCRTL_write_en2_shift                                               (5)
+#define HDMI_PHYCHCRTL_write_en2_mask                                                (0x00000020)
+#define HDMI_PHYCHCRTL_write_en2(data)                                               (0x00000020&((data)<<5))
+#define HDMI_PHYCHCRTL_write_en2_src(data)                                           ((0x00000020&(data))>>5)
+#define HDMI_PHYCHCRTL_get_write_en2(data)                                           ((0x00000020&(data))>>5)
+#define HDMI_PHYCHCRTL_hdmi_chb_data_swap_shift                                      (3)
+#define HDMI_PHYCHCRTL_hdmi_chb_data_swap_mask                                       (0x00000018)
+#define HDMI_PHYCHCRTL_hdmi_chb_data_swap(data)                                      (0x00000018&((data)<<3))
+#define HDMI_PHYCHCRTL_hdmi_chb_data_swap_src(data)                                  ((0x00000018&(data))>>3)
+#define HDMI_PHYCHCRTL_get_hdmi_chb_data_swap(data)                                  ((0x00000018&(data))>>3)
+#define HDMI_PHYCHCRTL_write_en1_shift                                               (2)
+#define HDMI_PHYCHCRTL_write_en1_mask                                                (0x00000004)
+#define HDMI_PHYCHCRTL_write_en1(data)                                               (0x00000004&((data)<<2))
+#define HDMI_PHYCHCRTL_write_en1_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_PHYCHCRTL_get_write_en1(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_PHYCHCRTL_hdmi_cha_data_swap_shift                                      (0)
+#define HDMI_PHYCHCRTL_hdmi_cha_data_swap_mask                                       (0x00000003)
+#define HDMI_PHYCHCRTL_hdmi_cha_data_swap(data)                                      (0x00000003&((data)<<0))
+#define HDMI_PHYCHCRTL_hdmi_cha_data_swap_src(data)                                  ((0x00000003&(data))>>0)
+#define HDMI_PHYCHCRTL_get_hdmi_cha_data_swap(data)                                  ((0x00000003&(data))>>0)
+
+
+#define HDMI_HDMI_2_0_CTRL1                                                          0x9800D040
+#define HDMI_HDMI_2_0_CTRL1_reg_addr                                                 "0xD800D040"
+#define HDMI_HDMI_2_0_CTRL1_reg                                                      0xD800D040
+#define set_HDMI_HDMI_2_0_CTRL1_reg(data)   (*((volatile unsigned int*) HDMI_HDMI_2_0_CTRL1_reg)=data)
+#define get_HDMI_HDMI_2_0_CTRL1_reg   (*((volatile unsigned int*) HDMI_HDMI_2_0_CTRL1_reg))
+#define HDMI_HDMI_2_0_CTRL1_inst_adr                                                 "0x0010"
+#define HDMI_HDMI_2_0_CTRL1_inst                                                     0x0010
+#define HDMI_HDMI_2_0_CTRL1_write_en4_shift                                          (7)
+#define HDMI_HDMI_2_0_CTRL1_write_en4_mask                                           (0x00000080)
+#define HDMI_HDMI_2_0_CTRL1_write_en4(data)                                          (0x00000080&((data)<<7))
+#define HDMI_HDMI_2_0_CTRL1_write_en4_src(data)                                      ((0x00000080&(data))>>7)
+#define HDMI_HDMI_2_0_CTRL1_get_write_en4(data)                                      ((0x00000080&(data))>>7)
+#define HDMI_HDMI_2_0_CTRL1_chclk_div4_en_shift                                      (6)
+#define HDMI_HDMI_2_0_CTRL1_chclk_div4_en_mask                                       (0x00000040)
+#define HDMI_HDMI_2_0_CTRL1_chclk_div4_en(data)                                      (0x00000040&((data)<<6))
+#define HDMI_HDMI_2_0_CTRL1_chclk_div4_en_src(data)                                  ((0x00000040&(data))>>6)
+#define HDMI_HDMI_2_0_CTRL1_get_chclk_div4_en(data)                                  ((0x00000040&(data))>>6)
+#define HDMI_HDMI_2_0_CTRL1_write_en3_shift                                          (5)
+#define HDMI_HDMI_2_0_CTRL1_write_en3_mask                                           (0x00000020)
+#define HDMI_HDMI_2_0_CTRL1_write_en3(data)                                          (0x00000020&((data)<<5))
+#define HDMI_HDMI_2_0_CTRL1_write_en3_src(data)                                      ((0x00000020&(data))>>5)
+#define HDMI_HDMI_2_0_CTRL1_get_write_en3(data)                                      ((0x00000020&(data))>>5)
+#define HDMI_HDMI_2_0_CTRL1_scrmbl_en_shift                                          (4)
+#define HDMI_HDMI_2_0_CTRL1_scrmbl_en_mask                                           (0x00000010)
+#define HDMI_HDMI_2_0_CTRL1_scrmbl_en(data)                                          (0x00000010&((data)<<4))
+#define HDMI_HDMI_2_0_CTRL1_scrmbl_en_src(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_HDMI_2_0_CTRL1_get_scrmbl_en(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_HDMI_2_0_CTRL1_write_en2_shift                                          (3)
+#define HDMI_HDMI_2_0_CTRL1_write_en2_mask                                           (0x00000008)
+#define HDMI_HDMI_2_0_CTRL1_write_en2(data)                                          (0x00000008&((data)<<3))
+#define HDMI_HDMI_2_0_CTRL1_write_en2_src(data)                                      ((0x00000008&(data))>>3)
+#define HDMI_HDMI_2_0_CTRL1_get_write_en2(data)                                      ((0x00000008&(data))>>3)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_hlfp_shift                                      (2)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_hlfp_mask                                       (0x00000004)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_hlfp(data)                                      (0x00000004&((data)<<2))
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_hlfp_src(data)                                  ((0x00000004&(data))>>2)
+#define HDMI_HDMI_2_0_CTRL1_get_ycbcr420_hlfp(data)                                  ((0x00000004&(data))>>2)
+#define HDMI_HDMI_2_0_CTRL1_write_en1_shift                                          (1)
+#define HDMI_HDMI_2_0_CTRL1_write_en1_mask                                           (0x00000002)
+#define HDMI_HDMI_2_0_CTRL1_write_en1(data)                                          (0x00000002&((data)<<1))
+#define HDMI_HDMI_2_0_CTRL1_write_en1_src(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_HDMI_2_0_CTRL1_get_write_en1(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_shift                                           (0)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_mask                                            (0x00000001)
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420(data)                                           (0x00000001&((data)<<0))
+#define HDMI_HDMI_2_0_CTRL1_ycbcr420_src(data)                                       ((0x00000001&(data))>>0)
+#define HDMI_HDMI_2_0_CTRL1_get_ycbcr420(data)                                       ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDMI_2_0_CTRL2                                                          0x9800D044
+#define HDMI_HDMI_2_0_CTRL2_reg_addr                                                 "0xD800D044"
+#define HDMI_HDMI_2_0_CTRL2_reg                                                      0xD800D044
+#define set_HDMI_HDMI_2_0_CTRL2_reg(data)   (*((volatile unsigned int*) HDMI_HDMI_2_0_CTRL2_reg)=data)
+#define get_HDMI_HDMI_2_0_CTRL2_reg   (*((volatile unsigned int*) HDMI_HDMI_2_0_CTRL2_reg))
+#define HDMI_HDMI_2_0_CTRL2_inst_adr                                                 "0x0011"
+#define HDMI_HDMI_2_0_CTRL2_inst                                                     0x0011
+#define HDMI_HDMI_2_0_CTRL2_write_en2_shift                                          (30)
+#define HDMI_HDMI_2_0_CTRL2_write_en2_mask                                           (0x40000000)
+#define HDMI_HDMI_2_0_CTRL2_write_en2(data)                                          (0x40000000&((data)<<30))
+#define HDMI_HDMI_2_0_CTRL2_write_en2_src(data)                                      ((0x40000000&(data))>>30)
+#define HDMI_HDMI_2_0_CTRL2_get_write_en2(data)                                      ((0x40000000&(data))>>30)
+#define HDMI_HDMI_2_0_CTRL2_sscp_hpxl_shift                                          (16)
+#define HDMI_HDMI_2_0_CTRL2_sscp_hpxl_mask                                           (0x3FFF0000)
+#define HDMI_HDMI_2_0_CTRL2_sscp_hpxl(data)                                          (0x3FFF0000&((data)<<16))
+#define HDMI_HDMI_2_0_CTRL2_sscp_hpxl_src(data)                                      ((0x3FFF0000&(data))>>16)
+#define HDMI_HDMI_2_0_CTRL2_get_sscp_hpxl(data)                                      ((0x3FFF0000&(data))>>16)
+#define HDMI_HDMI_2_0_CTRL2_write_en1_shift                                          (14)
+#define HDMI_HDMI_2_0_CTRL2_write_en1_mask                                           (0x00004000)
+#define HDMI_HDMI_2_0_CTRL2_write_en1(data)                                          (0x00004000&((data)<<14))
+#define HDMI_HDMI_2_0_CTRL2_write_en1_src(data)                                      ((0x00004000&(data))>>14)
+#define HDMI_HDMI_2_0_CTRL2_get_write_en1(data)                                      ((0x00004000&(data))>>14)
+#define HDMI_HDMI_2_0_CTRL2_sscp_vline_shift                                         (0)
+#define HDMI_HDMI_2_0_CTRL2_sscp_vline_mask                                          (0x00003FFF)
+#define HDMI_HDMI_2_0_CTRL2_sscp_vline(data)                                         (0x00003FFF&((data)<<0))
+#define HDMI_HDMI_2_0_CTRL2_sscp_vline_src(data)                                     ((0x00003FFF&(data))>>0)
+#define HDMI_HDMI_2_0_CTRL2_get_sscp_vline(data)                                     ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG1                                                               0x9800D500
+#define HDMI_MHL3_REG1_reg_addr                                                      "0xD800D500"
+#define HDMI_MHL3_REG1_reg                                                           0xD800D500
+#define set_HDMI_MHL3_REG1_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG1_reg)=data)
+#define get_HDMI_MHL3_REG1_reg   (*((volatile unsigned int*) HDMI_MHL3_REG1_reg))
+#define HDMI_MHL3_REG1_inst_adr                                                      "0x0040"
+#define HDMI_MHL3_REG1_inst                                                          0x0040
+#define HDMI_MHL3_REG1_sync_polarity_shift                                           (5)
+#define HDMI_MHL3_REG1_sync_polarity_mask                                            (0x00000020)
+#define HDMI_MHL3_REG1_sync_polarity(data)                                           (0x00000020&((data)<<5))
+#define HDMI_MHL3_REG1_sync_polarity_src(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_MHL3_REG1_get_sync_polarity(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_MHL3_REG1_sync_source_shift                                             (4)
+#define HDMI_MHL3_REG1_sync_source_mask                                              (0x00000010)
+#define HDMI_MHL3_REG1_sync_source(data)                                             (0x00000010&((data)<<4))
+#define HDMI_MHL3_REG1_sync_source_src(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_MHL3_REG1_get_sync_source(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_MHL3_REG1_extend_mode_shift                                             (2)
+#define HDMI_MHL3_REG1_extend_mode_mask                                              (0x00000004)
+#define HDMI_MHL3_REG1_extend_mode(data)                                             (0x00000004&((data)<<2))
+#define HDMI_MHL3_REG1_extend_mode_src(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG1_get_extend_mode(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG1_24bit_en_shift                                                (1)
+#define HDMI_MHL3_REG1_24bit_en_mask                                                 (0x00000002)
+#define HDMI_MHL3_REG1_24bit_en(data)                                                (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG1_24bit_en_src(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG1_get_24bit_en(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG1_mhl3_en_shift                                                 (0)
+#define HDMI_MHL3_REG1_mhl3_en_mask                                                  (0x00000001)
+#define HDMI_MHL3_REG1_mhl3_en(data)                                                 (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG1_mhl3_en_src(data)                                             ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG1_get_mhl3_en(data)                                             ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG2                                                               0x9800D504
+#define HDMI_MHL3_REG2_reg_addr                                                      "0xD800D504"
+#define HDMI_MHL3_REG2_reg                                                           0xD800D504
+#define set_HDMI_MHL3_REG2_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG2_reg)=data)
+#define get_HDMI_MHL3_REG2_reg   (*((volatile unsigned int*) HDMI_MHL3_REG2_reg))
+#define HDMI_MHL3_REG2_inst_adr                                                      "0x0041"
+#define HDMI_MHL3_REG2_inst                                                          0x0041
+#define HDMI_MHL3_REG2_fifo_cnt_shift                                                (0)
+#define HDMI_MHL3_REG2_fifo_cnt_mask                                                 (0x0000007F)
+#define HDMI_MHL3_REG2_fifo_cnt(data)                                                (0x0000007F&((data)<<0))
+#define HDMI_MHL3_REG2_fifo_cnt_src(data)                                            ((0x0000007F&(data))>>0)
+#define HDMI_MHL3_REG2_get_fifo_cnt(data)                                            ((0x0000007F&(data))>>0)
+
+
+#define HDMI_MHL3_REG3                                                               0x9800D508
+#define HDMI_MHL3_REG3_reg_addr                                                      "0xD800D508"
+#define HDMI_MHL3_REG3_reg                                                           0xD800D508
+#define set_HDMI_MHL3_REG3_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG3_reg)=data)
+#define get_HDMI_MHL3_REG3_reg   (*((volatile unsigned int*) HDMI_MHL3_REG3_reg))
+#define HDMI_MHL3_REG3_inst_adr                                                      "0x0042"
+#define HDMI_MHL3_REG3_inst                                                          0x0042
+#define HDMI_MHL3_REG3_cp_fifo_reach_size_shift                                      (24)
+#define HDMI_MHL3_REG3_cp_fifo_reach_size_mask                                       (0x7F000000)
+#define HDMI_MHL3_REG3_cp_fifo_reach_size(data)                                      (0x7F000000&((data)<<24))
+#define HDMI_MHL3_REG3_cp_fifo_reach_size_src(data)                                  ((0x7F000000&(data))>>24)
+#define HDMI_MHL3_REG3_get_cp_fifo_reach_size(data)                                  ((0x7F000000&(data))>>24)
+#define HDMI_MHL3_REG3_htotal_fifo_reach_size_shift                                  (16)
+#define HDMI_MHL3_REG3_htotal_fifo_reach_size_mask                                   (0x007F0000)
+#define HDMI_MHL3_REG3_htotal_fifo_reach_size(data)                                  (0x007F0000&((data)<<16))
+#define HDMI_MHL3_REG3_htotal_fifo_reach_size_src(data)                              ((0x007F0000&(data))>>16)
+#define HDMI_MHL3_REG3_get_htotal_fifo_reach_size(data)                              ((0x007F0000&(data))>>16)
+#define HDMI_MHL3_REG3_blank_fifo_reach_size_shift                                   (8)
+#define HDMI_MHL3_REG3_blank_fifo_reach_size_mask                                    (0x00007F00)
+#define HDMI_MHL3_REG3_blank_fifo_reach_size(data)                                   (0x00007F00&((data)<<8))
+#define HDMI_MHL3_REG3_blank_fifo_reach_size_src(data)                               ((0x00007F00&(data))>>8)
+#define HDMI_MHL3_REG3_get_blank_fifo_reach_size(data)                               ((0x00007F00&(data))>>8)
+#define HDMI_MHL3_REG3_video_fifo_reach_size_shift                                   (0)
+#define HDMI_MHL3_REG3_video_fifo_reach_size_mask                                    (0x0000007F)
+#define HDMI_MHL3_REG3_video_fifo_reach_size(data)                                   (0x0000007F&((data)<<0))
+#define HDMI_MHL3_REG3_video_fifo_reach_size_src(data)                               ((0x0000007F&(data))>>0)
+#define HDMI_MHL3_REG3_get_video_fifo_reach_size(data)                               ((0x0000007F&(data))>>0)
+
+
+#define HDMI_MHL3_REG4                                                               0x9800D50C
+#define HDMI_MHL3_REG4_reg_addr                                                      "0xD800D50C"
+#define HDMI_MHL3_REG4_reg                                                           0xD800D50C
+#define set_HDMI_MHL3_REG4_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG4_reg)=data)
+#define get_HDMI_MHL3_REG4_reg   (*((volatile unsigned int*) HDMI_MHL3_REG4_reg))
+#define HDMI_MHL3_REG4_inst_adr                                                      "0x0043"
+#define HDMI_MHL3_REG4_inst                                                          0x0043
+#define HDMI_MHL3_REG4_payload_blank_16bit_shift                                     (24)
+#define HDMI_MHL3_REG4_payload_blank_16bit_mask                                      (0xFF000000)
+#define HDMI_MHL3_REG4_payload_blank_16bit(data)                                     (0xFF000000&((data)<<24))
+#define HDMI_MHL3_REG4_payload_blank_16bit_src(data)                                 ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG4_get_payload_blank_16bit(data)                                 ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG4_payload_blank_24bit_shift                                     (16)
+#define HDMI_MHL3_REG4_payload_blank_24bit_mask                                      (0x00FF0000)
+#define HDMI_MHL3_REG4_payload_blank_24bit(data)                                     (0x00FF0000&((data)<<16))
+#define HDMI_MHL3_REG4_payload_blank_24bit_src(data)                                 ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG4_get_payload_blank_24bit(data)                                 ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG4_payload_video_16bit_shift                                     (8)
+#define HDMI_MHL3_REG4_payload_video_16bit_mask                                      (0x0000FF00)
+#define HDMI_MHL3_REG4_payload_video_16bit(data)                                     (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG4_payload_video_16bit_src(data)                                 ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG4_get_payload_video_16bit(data)                                 ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG4_payload_video_24bit_shift                                     (0)
+#define HDMI_MHL3_REG4_payload_video_24bit_mask                                      (0x000000FF)
+#define HDMI_MHL3_REG4_payload_video_24bit(data)                                     (0x000000FF&((data)<<0))
+#define HDMI_MHL3_REG4_payload_video_24bit_src(data)                                 ((0x000000FF&(data))>>0)
+#define HDMI_MHL3_REG4_get_payload_video_24bit(data)                                 ((0x000000FF&(data))>>0)
+
+
+#define HDMI_MHL3_REG5                                                               0x9800D510
+#define HDMI_MHL3_REG5_reg_addr                                                      "0xD800D510"
+#define HDMI_MHL3_REG5_reg                                                           0xD800D510
+#define set_HDMI_MHL3_REG5_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG5_reg)=data)
+#define get_HDMI_MHL3_REG5_reg   (*((volatile unsigned int*) HDMI_MHL3_REG5_reg))
+#define HDMI_MHL3_REG5_inst_adr                                                      "0x0044"
+#define HDMI_MHL3_REG5_inst                                                          0x0044
+#define HDMI_MHL3_REG5_payload_cp_16bit_shift                                        (24)
+#define HDMI_MHL3_REG5_payload_cp_16bit_mask                                         (0xFF000000)
+#define HDMI_MHL3_REG5_payload_cp_16bit(data)                                        (0xFF000000&((data)<<24))
+#define HDMI_MHL3_REG5_payload_cp_16bit_src(data)                                    ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG5_get_payload_cp_16bit(data)                                    ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG5_payload_cp_24bit_shift                                        (16)
+#define HDMI_MHL3_REG5_payload_cp_24bit_mask                                         (0x00FF0000)
+#define HDMI_MHL3_REG5_payload_cp_24bit(data)                                        (0x00FF0000&((data)<<16))
+#define HDMI_MHL3_REG5_payload_cp_24bit_src(data)                                    ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG5_get_payload_cp_24bit(data)                                    ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG5_payload_htotal_16bit_shift                                    (8)
+#define HDMI_MHL3_REG5_payload_htotal_16bit_mask                                     (0x0000FF00)
+#define HDMI_MHL3_REG5_payload_htotal_16bit(data)                                    (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG5_payload_htotal_16bit_src(data)                                ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG5_get_payload_htotal_16bit(data)                                ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG5_payload_htotal_24bit_shift                                    (0)
+#define HDMI_MHL3_REG5_payload_htotal_24bit_mask                                     (0x000000FF)
+#define HDMI_MHL3_REG5_payload_htotal_24bit(data)                                    (0x000000FF&((data)<<0))
+#define HDMI_MHL3_REG5_payload_htotal_24bit_src(data)                                ((0x000000FF&(data))>>0)
+#define HDMI_MHL3_REG5_get_payload_htotal_24bit(data)                                ((0x000000FF&(data))>>0)
+
+
+#define HDMI_MHL3_REG6                                                               0x9800D514
+#define HDMI_MHL3_REG6_reg_addr                                                      "0xD800D514"
+#define HDMI_MHL3_REG6_reg                                                           0xD800D514
+#define set_HDMI_MHL3_REG6_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG6_reg)=data)
+#define get_HDMI_MHL3_REG6_reg   (*((volatile unsigned int*) HDMI_MHL3_REG6_reg))
+#define HDMI_MHL3_REG6_inst_adr                                                      "0x0045"
+#define HDMI_MHL3_REG6_inst                                                          0x0045
+#define HDMI_MHL3_REG6_gap_blank_16bit_shift                                         (24)
+#define HDMI_MHL3_REG6_gap_blank_16bit_mask                                          (0xFF000000)
+#define HDMI_MHL3_REG6_gap_blank_16bit(data)                                         (0xFF000000&((data)<<24))
+#define HDMI_MHL3_REG6_gap_blank_16bit_src(data)                                     ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG6_get_gap_blank_16bit(data)                                     ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG6_gap_blank_24bit_shift                                         (16)
+#define HDMI_MHL3_REG6_gap_blank_24bit_mask                                          (0x00FF0000)
+#define HDMI_MHL3_REG6_gap_blank_24bit(data)                                         (0x00FF0000&((data)<<16))
+#define HDMI_MHL3_REG6_gap_blank_24bit_src(data)                                     ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG6_get_gap_blank_24bit(data)                                     ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG6_gap_video_16bit_shift                                         (8)
+#define HDMI_MHL3_REG6_gap_video_16bit_mask                                          (0x0000FF00)
+#define HDMI_MHL3_REG6_gap_video_16bit(data)                                         (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG6_gap_video_16bit_src(data)                                     ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG6_get_gap_video_16bit(data)                                     ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG6_gap_video_24bit_shift                                         (0)
+#define HDMI_MHL3_REG6_gap_video_24bit_mask                                          (0x000000FF)
+#define HDMI_MHL3_REG6_gap_video_24bit(data)                                         (0x000000FF&((data)<<0))
+#define HDMI_MHL3_REG6_gap_video_24bit_src(data)                                     ((0x000000FF&(data))>>0)
+#define HDMI_MHL3_REG6_get_gap_video_24bit(data)                                     ((0x000000FF&(data))>>0)
+
+
+#define HDMI_MHL3_REG7                                                               0x9800D518
+#define HDMI_MHL3_REG7_reg_addr                                                      "0xD800D518"
+#define HDMI_MHL3_REG7_reg                                                           0xD800D518
+#define set_HDMI_MHL3_REG7_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG7_reg)=data)
+#define get_HDMI_MHL3_REG7_reg   (*((volatile unsigned int*) HDMI_MHL3_REG7_reg))
+#define HDMI_MHL3_REG7_inst_adr                                                      "0x0046"
+#define HDMI_MHL3_REG7_inst                                                          0x0046
+#define HDMI_MHL3_REG7_gap_cp_16bit_shift                                            (24)
+#define HDMI_MHL3_REG7_gap_cp_16bit_mask                                             (0xFF000000)
+#define HDMI_MHL3_REG7_gap_cp_16bit(data)                                            (0xFF000000&((data)<<24))
+#define HDMI_MHL3_REG7_gap_cp_16bit_src(data)                                        ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG7_get_gap_cp_16bit(data)                                        ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG7_gap_cp_24bit_shift                                            (16)
+#define HDMI_MHL3_REG7_gap_cp_24bit_mask                                             (0x00FF0000)
+#define HDMI_MHL3_REG7_gap_cp_24bit(data)                                            (0x00FF0000&((data)<<16))
+#define HDMI_MHL3_REG7_gap_cp_24bit_src(data)                                        ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG7_get_gap_cp_24bit(data)                                        ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG7_gap_htotal_16bit_shift                                        (8)
+#define HDMI_MHL3_REG7_gap_htotal_16bit_mask                                         (0x0000FF00)
+#define HDMI_MHL3_REG7_gap_htotal_16bit(data)                                        (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG7_gap_htotal_16bit_src(data)                                    ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG7_get_gap_htotal_16bit(data)                                    ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG7_gap_htotal_24bit_shift                                        (0)
+#define HDMI_MHL3_REG7_gap_htotal_24bit_mask                                         (0x000000FF)
+#define HDMI_MHL3_REG7_gap_htotal_24bit(data)                                        (0x000000FF&((data)<<0))
+#define HDMI_MHL3_REG7_gap_htotal_24bit_src(data)                                    ((0x000000FF&(data))>>0)
+#define HDMI_MHL3_REG7_get_gap_htotal_24bit(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define HDMI_MHL3_REG8                                                               0x9800D51C
+#define HDMI_MHL3_REG8_reg_addr                                                      "0xD800D51C"
+#define HDMI_MHL3_REG8_reg                                                           0xD800D51C
+#define set_HDMI_MHL3_REG8_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG8_reg)=data)
+#define get_HDMI_MHL3_REG8_reg   (*((volatile unsigned int*) HDMI_MHL3_REG8_reg))
+#define HDMI_MHL3_REG8_inst_adr                                                      "0x0047"
+#define HDMI_MHL3_REG8_inst                                                          0x0047
+#define HDMI_MHL3_REG8_tmds_en_shift                                                 (2)
+#define HDMI_MHL3_REG8_tmds_en_mask                                                  (0x00000004)
+#define HDMI_MHL3_REG8_tmds_en(data)                                                 (0x00000004&((data)<<2))
+#define HDMI_MHL3_REG8_tmds_en_src(data)                                             ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG8_get_tmds_en(data)                                             ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG8_cp_en_shift                                                   (1)
+#define HDMI_MHL3_REG8_cp_en_mask                                                    (0x00000002)
+#define HDMI_MHL3_REG8_cp_en(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG8_cp_en_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG8_get_cp_en(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG8_rr_en_shift                                                   (0)
+#define HDMI_MHL3_REG8_rr_en_mask                                                    (0x00000001)
+#define HDMI_MHL3_REG8_rr_en(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG8_rr_en_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG8_get_rr_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG9                                                               0x9800D520
+#define HDMI_MHL3_REG9_reg_addr                                                      "0xD800D520"
+#define HDMI_MHL3_REG9_reg                                                           0xD800D520
+#define set_HDMI_MHL3_REG9_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG9_reg)=data)
+#define get_HDMI_MHL3_REG9_reg   (*((volatile unsigned int*) HDMI_MHL3_REG9_reg))
+#define HDMI_MHL3_REG9_inst_adr                                                      "0x0048"
+#define HDMI_MHL3_REG9_inst                                                          0x0048
+#define HDMI_MHL3_REG9_avlink_data_shift                                             (16)
+#define HDMI_MHL3_REG9_avlink_data_mask                                              (0x03FF0000)
+#define HDMI_MHL3_REG9_avlink_data(data)                                             (0x03FF0000&((data)<<16))
+#define HDMI_MHL3_REG9_avlink_data_src(data)                                         ((0x03FF0000&(data))>>16)
+#define HDMI_MHL3_REG9_get_avlink_data(data)                                         ((0x03FF0000&(data))>>16)
+#define HDMI_MHL3_REG9_avlink_duration_shift                                         (8)
+#define HDMI_MHL3_REG9_avlink_duration_mask                                          (0x0000FF00)
+#define HDMI_MHL3_REG9_avlink_duration(data)                                         (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG9_avlink_duration_src(data)                                     ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG9_get_avlink_duration(data)                                     ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG9_avlink_fixed8_alg_shift                                       (5)
+#define HDMI_MHL3_REG9_avlink_fixed8_alg_mask                                        (0x00000020)
+#define HDMI_MHL3_REG9_avlink_fixed8_alg(data)                                       (0x00000020&((data)<<5))
+#define HDMI_MHL3_REG9_avlink_fixed8_alg_src(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_MHL3_REG9_get_avlink_fixed8_alg(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_MHL3_REG9_avlink_bitwise_inv_shift                                      (3)
+#define HDMI_MHL3_REG9_avlink_bitwise_inv_mask                                       (0x00000018)
+#define HDMI_MHL3_REG9_avlink_bitwise_inv(data)                                      (0x00000018&((data)<<3))
+#define HDMI_MHL3_REG9_avlink_bitwise_inv_src(data)                                  ((0x00000018&(data))>>3)
+#define HDMI_MHL3_REG9_get_avlink_bitwise_inv(data)                                  ((0x00000018&(data))>>3)
+#define HDMI_MHL3_REG9_avlink_pattern_shift                                          (1)
+#define HDMI_MHL3_REG9_avlink_pattern_mask                                           (0x00000006)
+#define HDMI_MHL3_REG9_avlink_pattern(data)                                          (0x00000006&((data)<<1))
+#define HDMI_MHL3_REG9_avlink_pattern_src(data)                                      ((0x00000006&(data))>>1)
+#define HDMI_MHL3_REG9_get_avlink_pattern(data)                                      ((0x00000006&(data))>>1)
+#define HDMI_MHL3_REG9_avlink_bist_en_shift                                          (0)
+#define HDMI_MHL3_REG9_avlink_bist_en_mask                                           (0x00000001)
+#define HDMI_MHL3_REG9_avlink_bist_en(data)                                          (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG9_avlink_bist_en_src(data)                                      ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG9_get_avlink_bist_en(data)                                      ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG10                                                              0x9800D524
+#define HDMI_MHL3_REG10_reg_addr                                                     "0xD800D524"
+#define HDMI_MHL3_REG10_reg                                                          0xD800D524
+#define set_HDMI_MHL3_REG10_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG10_reg)=data)
+#define get_HDMI_MHL3_REG10_reg   (*((volatile unsigned int*) HDMI_MHL3_REG10_reg))
+#define HDMI_MHL3_REG10_inst_adr                                                     "0x0049"
+#define HDMI_MHL3_REG10_inst                                                         0x0049
+#define HDMI_MHL3_REG10_rme_shift                                                    (12)
+#define HDMI_MHL3_REG10_rme_mask                                                     (0x00001000)
+#define HDMI_MHL3_REG10_rme(data)                                                    (0x00001000&((data)<<12))
+#define HDMI_MHL3_REG10_rme_src(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_MHL3_REG10_get_rme(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_MHL3_REG10_rm_shift                                                     (8)
+#define HDMI_MHL3_REG10_rm_mask                                                      (0x00000F00)
+#define HDMI_MHL3_REG10_rm(data)                                                     (0x00000F00&((data)<<8))
+#define HDMI_MHL3_REG10_rm_src(data)                                                 ((0x00000F00&(data))>>8)
+#define HDMI_MHL3_REG10_get_rm(data)                                                 ((0x00000F00&(data))>>8)
+#define HDMI_MHL3_REG10_ls_shift                                                     (3)
+#define HDMI_MHL3_REG10_ls_mask                                                      (0x00000008)
+#define HDMI_MHL3_REG10_ls(data)                                                     (0x00000008&((data)<<3))
+#define HDMI_MHL3_REG10_ls_src(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG10_get_ls(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG10_drf_resume_shift                                             (2)
+#define HDMI_MHL3_REG10_drf_resume_mask                                              (0x00000004)
+#define HDMI_MHL3_REG10_drf_resume(data)                                             (0x00000004&((data)<<2))
+#define HDMI_MHL3_REG10_drf_resume_src(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG10_get_drf_resume(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG10_drf_bist_mode_shift                                          (1)
+#define HDMI_MHL3_REG10_drf_bist_mode_mask                                           (0x00000002)
+#define HDMI_MHL3_REG10_drf_bist_mode(data)                                          (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG10_drf_bist_mode_src(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG10_get_drf_bist_mode(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG10_bist_mode_shift                                              (0)
+#define HDMI_MHL3_REG10_bist_mode_mask                                               (0x00000001)
+#define HDMI_MHL3_REG10_bist_mode(data)                                              (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG10_bist_mode_src(data)                                          ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG10_get_bist_mode(data)                                          ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG11                                                              0x9800D528
+#define HDMI_MHL3_REG11_reg_addr                                                     "0xD800D528"
+#define HDMI_MHL3_REG11_reg                                                          0xD800D528
+#define set_HDMI_MHL3_REG11_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG11_reg)=data)
+#define get_HDMI_MHL3_REG11_reg   (*((volatile unsigned int*) HDMI_MHL3_REG11_reg))
+#define HDMI_MHL3_REG11_inst_adr                                                     "0x004A"
+#define HDMI_MHL3_REG11_inst                                                         0x004A
+#define HDMI_MHL3_REG11_bist_fail_shift                                              (1)
+#define HDMI_MHL3_REG11_bist_fail_mask                                               (0x00000002)
+#define HDMI_MHL3_REG11_bist_fail(data)                                              (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG11_bist_fail_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG11_get_bist_fail(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG11_bist_done_shift                                              (0)
+#define HDMI_MHL3_REG11_bist_done_mask                                               (0x00000001)
+#define HDMI_MHL3_REG11_bist_done(data)                                              (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG11_bist_done_src(data)                                          ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG11_get_bist_done(data)                                          ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG12                                                              0x9800D52C
+#define HDMI_MHL3_REG12_reg_addr                                                     "0xD800D52C"
+#define HDMI_MHL3_REG12_reg                                                          0xD800D52C
+#define set_HDMI_MHL3_REG12_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG12_reg)=data)
+#define get_HDMI_MHL3_REG12_reg   (*((volatile unsigned int*) HDMI_MHL3_REG12_reg))
+#define HDMI_MHL3_REG12_inst_adr                                                     "0x004B"
+#define HDMI_MHL3_REG12_inst                                                         0x004B
+#define HDMI_MHL3_REG12_drf_start_pause_shift                                        (16)
+#define HDMI_MHL3_REG12_drf_start_pause_mask                                         (0x00010000)
+#define HDMI_MHL3_REG12_drf_start_pause(data)                                        (0x00010000&((data)<<16))
+#define HDMI_MHL3_REG12_drf_start_pause_src(data)                                    ((0x00010000&(data))>>16)
+#define HDMI_MHL3_REG12_get_drf_start_pause(data)                                    ((0x00010000&(data))>>16)
+#define HDMI_MHL3_REG12_drf_bist_fail_shift                                          (1)
+#define HDMI_MHL3_REG12_drf_bist_fail_mask                                           (0x00000002)
+#define HDMI_MHL3_REG12_drf_bist_fail(data)                                          (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG12_drf_bist_fail_src(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG12_get_drf_bist_fail(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG12_drf_bist_done_shift                                          (0)
+#define HDMI_MHL3_REG12_drf_bist_done_mask                                           (0x00000001)
+#define HDMI_MHL3_REG12_drf_bist_done(data)                                          (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG12_drf_bist_done_src(data)                                      ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG12_get_drf_bist_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG13                                                              0x9800D530
+#define HDMI_MHL3_REG13_reg_addr                                                     "0xD800D530"
+#define HDMI_MHL3_REG13_reg                                                          0xD800D530
+#define set_HDMI_MHL3_REG13_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG13_reg)=data)
+#define get_HDMI_MHL3_REG13_reg   (*((volatile unsigned int*) HDMI_MHL3_REG13_reg))
+#define HDMI_MHL3_REG13_inst_adr                                                     "0x004C"
+#define HDMI_MHL3_REG13_inst                                                         0x004C
+#define HDMI_MHL3_REG13_built_in_b_shift                                             (24)
+#define HDMI_MHL3_REG13_built_in_b_mask                                              (0xFF000000)
+#define HDMI_MHL3_REG13_built_in_b(data)                                             (0xFF000000&((data)<<24))
+#define HDMI_MHL3_REG13_built_in_b_src(data)                                         ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG13_get_built_in_b(data)                                         ((0xFF000000&(data))>>24)
+#define HDMI_MHL3_REG13_built_in_g_shift                                             (16)
+#define HDMI_MHL3_REG13_built_in_g_mask                                              (0x00FF0000)
+#define HDMI_MHL3_REG13_built_in_g(data)                                             (0x00FF0000&((data)<<16))
+#define HDMI_MHL3_REG13_built_in_g_src(data)                                         ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG13_get_built_in_g(data)                                         ((0x00FF0000&(data))>>16)
+#define HDMI_MHL3_REG13_built_in_r_shift                                             (8)
+#define HDMI_MHL3_REG13_built_in_r_mask                                              (0x0000FF00)
+#define HDMI_MHL3_REG13_built_in_r(data)                                             (0x0000FF00&((data)<<8))
+#define HDMI_MHL3_REG13_built_in_r_src(data)                                         ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG13_get_built_in_r(data)                                         ((0x0000FF00&(data))>>8)
+#define HDMI_MHL3_REG13_built_in_video_type_shift                                    (1)
+#define HDMI_MHL3_REG13_built_in_video_type_mask                                     (0x0000000E)
+#define HDMI_MHL3_REG13_built_in_video_type(data)                                    (0x0000000E&((data)<<1))
+#define HDMI_MHL3_REG13_built_in_video_type_src(data)                                ((0x0000000E&(data))>>1)
+#define HDMI_MHL3_REG13_get_built_in_video_type(data)                                ((0x0000000E&(data))>>1)
+#define HDMI_MHL3_REG13_built_in_video_en_shift                                      (0)
+#define HDMI_MHL3_REG13_built_in_video_en_mask                                       (0x00000001)
+#define HDMI_MHL3_REG13_built_in_video_en(data)                                      (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG13_built_in_video_en_src(data)                                  ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG13_get_built_in_video_en(data)                                  ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG14                                                              0x9800D534
+#define HDMI_MHL3_REG14_reg_addr                                                     "0xD800D534"
+#define HDMI_MHL3_REG14_reg                                                          0xD800D534
+#define set_HDMI_MHL3_REG14_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG14_reg)=data)
+#define get_HDMI_MHL3_REG14_reg   (*((volatile unsigned int*) HDMI_MHL3_REG14_reg))
+#define HDMI_MHL3_REG14_inst_adr                                                     "0x004D"
+#define HDMI_MHL3_REG14_inst                                                         0x004D
+#define HDMI_MHL3_REG14_vactive_front_shift                                          (0)
+#define HDMI_MHL3_REG14_vactive_front_mask                                           (0x00003FFF)
+#define HDMI_MHL3_REG14_vactive_front(data)                                          (0x00003FFF&((data)<<0))
+#define HDMI_MHL3_REG14_vactive_front_src(data)                                      ((0x00003FFF&(data))>>0)
+#define HDMI_MHL3_REG14_get_vactive_front(data)                                      ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG15                                                              0x9800D538
+#define HDMI_MHL3_REG15_reg_addr                                                     "0xD800D538"
+#define HDMI_MHL3_REG15_reg                                                          0xD800D538
+#define set_HDMI_MHL3_REG15_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG15_reg)=data)
+#define get_HDMI_MHL3_REG15_reg   (*((volatile unsigned int*) HDMI_MHL3_REG15_reg))
+#define HDMI_MHL3_REG15_inst_adr                                                     "0x004E"
+#define HDMI_MHL3_REG15_inst                                                         0x004E
+#define HDMI_MHL3_REG15_vactive_back_shift                                           (0)
+#define HDMI_MHL3_REG15_vactive_back_mask                                            (0x00003FFF)
+#define HDMI_MHL3_REG15_vactive_back(data)                                           (0x00003FFF&((data)<<0))
+#define HDMI_MHL3_REG15_vactive_back_src(data)                                       ((0x00003FFF&(data))>>0)
+#define HDMI_MHL3_REG15_get_vactive_back(data)                                       ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG16                                                              0x9800D53C
+#define HDMI_MHL3_REG16_reg_addr                                                     "0xD800D53C"
+#define HDMI_MHL3_REG16_reg                                                          0xD800D53C
+#define set_HDMI_MHL3_REG16_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG16_reg)=data)
+#define get_HDMI_MHL3_REG16_reg   (*((volatile unsigned int*) HDMI_MHL3_REG16_reg))
+#define HDMI_MHL3_REG16_inst_adr                                                     "0x004F"
+#define HDMI_MHL3_REG16_inst                                                         0x004F
+#define HDMI_MHL3_REG16_dummy_shift                                                  (0)
+#define HDMI_MHL3_REG16_dummy_mask                                                   (0xFFFFFFFF)
+#define HDMI_MHL3_REG16_dummy(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_MHL3_REG16_dummy_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_MHL3_REG16_get_dummy(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG17                                                              0x9800D540
+#define HDMI_MHL3_REG17_reg_addr                                                     "0xD800D540"
+#define HDMI_MHL3_REG17_reg                                                          0xD800D540
+#define set_HDMI_MHL3_REG17_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG17_reg)=data)
+#define get_HDMI_MHL3_REG17_reg   (*((volatile unsigned int*) HDMI_MHL3_REG17_reg))
+#define HDMI_MHL3_REG17_inst_adr                                                     "0x0050"
+#define HDMI_MHL3_REG17_inst                                                         0x0050
+#define HDMI_MHL3_REG17_dummy_shift                                                  (16)
+#define HDMI_MHL3_REG17_dummy_mask                                                   (0xFFFF0000)
+#define HDMI_MHL3_REG17_dummy(data)                                                  (0xFFFF0000&((data)<<16))
+#define HDMI_MHL3_REG17_dummy_src(data)                                              ((0xFFFF0000&(data))>>16)
+#define HDMI_MHL3_REG17_get_dummy(data)                                              ((0xFFFF0000&(data))>>16)
+#define HDMI_MHL3_REG17_dbg1_sel_shift                                               (12)
+#define HDMI_MHL3_REG17_dbg1_sel_mask                                                (0x0000F000)
+#define HDMI_MHL3_REG17_dbg1_sel(data)                                               (0x0000F000&((data)<<12))
+#define HDMI_MHL3_REG17_dbg1_sel_src(data)                                           ((0x0000F000&(data))>>12)
+#define HDMI_MHL3_REG17_get_dbg1_sel(data)                                           ((0x0000F000&(data))>>12)
+#define HDMI_MHL3_REG17_dbg0_sel_shift                                               (8)
+#define HDMI_MHL3_REG17_dbg0_sel_mask                                                (0x00000F00)
+#define HDMI_MHL3_REG17_dbg0_sel(data)                                               (0x00000F00&((data)<<8))
+#define HDMI_MHL3_REG17_dbg0_sel_src(data)                                           ((0x00000F00&(data))>>8)
+#define HDMI_MHL3_REG17_get_dbg0_sel(data)                                           ((0x00000F00&(data))>>8)
+#define HDMI_MHL3_REG17_pwr_dis_shift                                                (1)
+#define HDMI_MHL3_REG17_pwr_dis_mask                                                 (0x00000002)
+#define HDMI_MHL3_REG17_pwr_dis(data)                                                (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG17_pwr_dis_src(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG17_get_pwr_dis(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG17_dbg_en_shift                                                 (0)
+#define HDMI_MHL3_REG17_dbg_en_mask                                                  (0x00000001)
+#define HDMI_MHL3_REG17_dbg_en(data)                                                 (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG17_dbg_en_src(data)                                             ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG17_get_dbg_en(data)                                             ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG18                                                              0x9800D544
+#define HDMI_MHL3_REG18_reg_addr                                                     "0xD800D544"
+#define HDMI_MHL3_REG18_reg                                                          0xD800D544
+#define set_HDMI_MHL3_REG18_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG18_reg)=data)
+#define get_HDMI_MHL3_REG18_reg   (*((volatile unsigned int*) HDMI_MHL3_REG18_reg))
+#define HDMI_MHL3_REG18_inst_adr                                                     "0x0051"
+#define HDMI_MHL3_REG18_inst                                                         0x0051
+#define HDMI_MHL3_REG18_start_en_shift                                               (16)
+#define HDMI_MHL3_REG18_start_en_mask                                                (0x00010000)
+#define HDMI_MHL3_REG18_start_en(data)                                               (0x00010000&((data)<<16))
+#define HDMI_MHL3_REG18_start_en_src(data)                                           ((0x00010000&(data))>>16)
+#define HDMI_MHL3_REG18_get_start_en(data)                                           ((0x00010000&(data))>>16)
+#define HDMI_MHL3_REG18_start_line_shift                                             (0)
+#define HDMI_MHL3_REG18_start_line_mask                                              (0x00003FFF)
+#define HDMI_MHL3_REG18_start_line(data)                                             (0x00003FFF&((data)<<0))
+#define HDMI_MHL3_REG18_start_line_src(data)                                         ((0x00003FFF&(data))>>0)
+#define HDMI_MHL3_REG18_get_start_line(data)                                         ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG19                                                              0x9800D548
+#define HDMI_MHL3_REG19_reg_addr                                                     "0xD800D548"
+#define HDMI_MHL3_REG19_reg                                                          0xD800D548
+#define set_HDMI_MHL3_REG19_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG19_reg)=data)
+#define get_HDMI_MHL3_REG19_reg   (*((volatile unsigned int*) HDMI_MHL3_REG19_reg))
+#define HDMI_MHL3_REG19_inst_adr                                                     "0x0052"
+#define HDMI_MHL3_REG19_inst                                                         0x0052
+#define HDMI_MHL3_REG19_hdcp2p2_streamctr_shift                                      (0)
+#define HDMI_MHL3_REG19_hdcp2p2_streamctr_mask                                       (0xFFFFFFFF)
+#define HDMI_MHL3_REG19_hdcp2p2_streamctr(data)                                      (0xFFFFFFFF&((data)<<0))
+#define HDMI_MHL3_REG19_hdcp2p2_streamctr_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define HDMI_MHL3_REG19_get_hdcp2p2_streamctr(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG20                                                              0x9800D54C
+#define HDMI_MHL3_REG20_reg_addr                                                     "0xD800D54C"
+#define HDMI_MHL3_REG20_reg                                                          0xD800D54C
+#define set_HDMI_MHL3_REG20_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG20_reg)=data)
+#define get_HDMI_MHL3_REG20_reg   (*((volatile unsigned int*) HDMI_MHL3_REG20_reg))
+#define HDMI_MHL3_REG20_inst_adr                                                     "0x0053"
+#define HDMI_MHL3_REG20_inst                                                         0x0053
+#define HDMI_MHL3_REG20_hdcp2p2_stream_id_shift                                      (0)
+#define HDMI_MHL3_REG20_hdcp2p2_stream_id_mask                                       (0x000000FF)
+#define HDMI_MHL3_REG20_hdcp2p2_stream_id(data)                                      (0x000000FF&((data)<<0))
+#define HDMI_MHL3_REG20_hdcp2p2_stream_id_src(data)                                  ((0x000000FF&(data))>>0)
+#define HDMI_MHL3_REG20_get_hdcp2p2_stream_id(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define HDMI_MHL3_REG21                                                              0x9800D550
+#define HDMI_MHL3_REG21_reg_addr                                                     "0xD800D550"
+#define HDMI_MHL3_REG21_reg                                                          0xD800D550
+#define set_HDMI_MHL3_REG21_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG21_reg)=data)
+#define get_HDMI_MHL3_REG21_reg   (*((volatile unsigned int*) HDMI_MHL3_REG21_reg))
+#define HDMI_MHL3_REG21_inst_adr                                                     "0x0054"
+#define HDMI_MHL3_REG21_inst                                                         0x0054
+#define HDMI_MHL3_REG21_hdcp2p2_mhl3_sel_shift                                       (0)
+#define HDMI_MHL3_REG21_hdcp2p2_mhl3_sel_mask                                        (0x00000001)
+#define HDMI_MHL3_REG21_hdcp2p2_mhl3_sel(data)                                       (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG21_hdcp2p2_mhl3_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG21_get_hdcp2p2_mhl3_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG22                                                              0x9800D554
+#define HDMI_MHL3_REG22_reg_addr                                                     "0xD800D554"
+#define HDMI_MHL3_REG22_reg                                                          0xD800D554
+#define set_HDMI_MHL3_REG22_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG22_reg)=data)
+#define get_HDMI_MHL3_REG22_reg   (*((volatile unsigned int*) HDMI_MHL3_REG22_reg))
+#define HDMI_MHL3_REG22_inst_adr                                                     "0x0055"
+#define HDMI_MHL3_REG22_inst                                                         0x0055
+#define HDMI_MHL3_REG22_hdcp2p2_header_ext_shift                                     (0)
+#define HDMI_MHL3_REG22_hdcp2p2_header_ext_mask                                      (0xFFFFFFFF)
+#define HDMI_MHL3_REG22_hdcp2p2_header_ext(data)                                     (0xFFFFFFFF&((data)<<0))
+#define HDMI_MHL3_REG22_hdcp2p2_header_ext_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define HDMI_MHL3_REG22_get_hdcp2p2_header_ext(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_MHL3_REG23                                                              0x9800D558
+#define HDMI_MHL3_REG23_reg_addr                                                     "0xD800D558"
+#define HDMI_MHL3_REG23_reg                                                          0xD800D558
+#define set_HDMI_MHL3_REG23_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG23_reg)=data)
+#define get_HDMI_MHL3_REG23_reg   (*((volatile unsigned int*) HDMI_MHL3_REG23_reg))
+#define HDMI_MHL3_REG23_inst_adr                                                     "0x0056"
+#define HDMI_MHL3_REG23_inst                                                         0x0056
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_method_shift                                  (3)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_method_mask                                   (0x00000008)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_method(data)                                  (0x00000008&((data)<<3))
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_method_src(data)                              ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG23_get_hdcp2p2_cp_crc_method(data)                              ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev_shift                                     (2)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev_mask                                      (0x00000004)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev(data)                                     (0x00000004&((data)<<2))
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev_src(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG23_get_hdcp2p2_cp_crc_rev(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_inv_shift                                     (1)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_inv_mask                                      (0x00000002)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_inv(data)                                     (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_inv_src(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG23_get_hdcp2p2_cp_crc_inv(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev2_shift                                    (0)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev2_mask                                     (0x00000001)
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev2(data)                                    (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG23_hdcp2p2_cp_crc_rev2_src(data)                                ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG23_get_hdcp2p2_cp_crc_rev2(data)                                ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG24                                                              0x9800D55C
+#define HDMI_MHL3_REG24_reg_addr                                                     "0xD800D55C"
+#define HDMI_MHL3_REG24_reg                                                          0xD800D55C
+#define set_HDMI_MHL3_REG24_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG24_reg)=data)
+#define get_HDMI_MHL3_REG24_reg   (*((volatile unsigned int*) HDMI_MHL3_REG24_reg))
+#define HDMI_MHL3_REG24_inst_adr                                                     "0x0057"
+#define HDMI_MHL3_REG24_inst                                                         0x0057
+#define HDMI_MHL3_REG24_link_st_shift                                                (16)
+#define HDMI_MHL3_REG24_link_st_mask                                                 (0x0FFF0000)
+#define HDMI_MHL3_REG24_link_st(data)                                                (0x0FFF0000&((data)<<16))
+#define HDMI_MHL3_REG24_link_st_src(data)                                            ((0x0FFF0000&(data))>>16)
+#define HDMI_MHL3_REG24_get_link_st(data)                                            ((0x0FFF0000&(data))>>16)
+#define HDMI_MHL3_REG24_bist_fixed8_status_shift                                     (3)
+#define HDMI_MHL3_REG24_bist_fixed8_status_mask                                      (0x00000008)
+#define HDMI_MHL3_REG24_bist_fixed8_status(data)                                     (0x00000008&((data)<<3))
+#define HDMI_MHL3_REG24_bist_fixed8_status_src(data)                                 ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG24_get_bist_fixed8_status(data)                                 ((0x00000008&(data))>>3)
+#define HDMI_MHL3_REG24_bist_prbs_status_shift                                       (2)
+#define HDMI_MHL3_REG24_bist_prbs_status_mask                                        (0x00000004)
+#define HDMI_MHL3_REG24_bist_prbs_status(data)                                       (0x00000004&((data)<<2))
+#define HDMI_MHL3_REG24_bist_prbs_status_src(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG24_get_bist_prbs_status(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_MHL3_REG24_fifo_full_status_shift                                       (1)
+#define HDMI_MHL3_REG24_fifo_full_status_mask                                        (0x00000002)
+#define HDMI_MHL3_REG24_fifo_full_status(data)                                       (0x00000002&((data)<<1))
+#define HDMI_MHL3_REG24_fifo_full_status_src(data)                                   ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG24_get_fifo_full_status(data)                                   ((0x00000002&(data))>>1)
+#define HDMI_MHL3_REG24_fifo_full_clr_shift                                          (0)
+#define HDMI_MHL3_REG24_fifo_full_clr_mask                                           (0x00000001)
+#define HDMI_MHL3_REG24_fifo_full_clr(data)                                          (0x00000001&((data)<<0))
+#define HDMI_MHL3_REG24_fifo_full_clr_src(data)                                      ((0x00000001&(data))>>0)
+#define HDMI_MHL3_REG24_get_fifo_full_clr(data)                                      ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL3_REG25                                                              0x9800D560
+#define HDMI_MHL3_REG25_reg_addr                                                     "0xD800D560"
+#define HDMI_MHL3_REG25_reg                                                          0xD800D560
+#define set_HDMI_MHL3_REG25_reg(data)   (*((volatile unsigned int*) HDMI_MHL3_REG25_reg)=data)
+#define get_HDMI_MHL3_REG25_reg   (*((volatile unsigned int*) HDMI_MHL3_REG25_reg))
+#define HDMI_MHL3_REG25_inst_adr                                                     "0x0058"
+#define HDMI_MHL3_REG25_inst                                                         0x0058
+#define HDMI_MHL3_REG25_cp_pos_adj_shift                                             (0)
+#define HDMI_MHL3_REG25_cp_pos_adj_mask                                              (0x00003FFF)
+#define HDMI_MHL3_REG25_cp_pos_adj(data)                                             (0x00003FFF&((data)<<0))
+#define HDMI_MHL3_REG25_cp_pos_adj_src(data)                                         ((0x00003FFF&(data))>>0)
+#define HDMI_MHL3_REG25_get_cp_pos_adj(data)                                         ((0x00003FFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2fpga/vo_reg.h b/drivers/video/fbdev/rtk/dc2fpga/vo_reg.h
new file mode 100644
index 00000000..bc87777
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2fpga/vo_reg.h
@@ -0,0 +1,21938 @@
+/**************************************************************
+// Spec Version                  : 0.1
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2015/6/16 16:31:17
+***************************************************************/
+
+
+#ifndef _VO_REG_H_INCLUDED_
+#define _VO_REG_H_INCLUDED_
+#ifdef  _VO_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     v2_dynamic_sram_ls_enable:1;
+unsigned int     v1_dynamic_sram_ls_enable:1;
+unsigned int     sub2_dynamic_sram_ls_enable:1;
+unsigned int     sub1_dynamic_sram_ls_enable:1;
+unsigned int     osd_dynamic_sram_ls_enable:1;
+unsigned int     dispbuf_dynamic_sram_ls_enable:1;
+unsigned int     dma_dynamic_sram_ls_enable:1;
+unsigned int     wb2_dynamic_sram_ls_enable:1;
+unsigned int     dwa_dynamic_sram_ls_enable:1;
+unsigned int     csr_dynamic_sram_ls_enable:1;
+unsigned int     sram_gating_enable:1;
+unsigned int     wb2_gating_enable:1;
+unsigned int     dwa_gating_enable:1;
+unsigned int     dma_gating_enable:1;
+unsigned int     shut_down_enable:1;
+unsigned int     gating_enable:1;
+unsigned int     reserved_1:1;
+unsigned int     ch3:1;
+unsigned int     ch2:1;
+unsigned int     ch1:1;
+unsigned int     write_data:1;
+}VO_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     write_en3:1;
+unsigned int     h:2;
+unsigned int     reserved_1:1;
+unsigned int     write_en2:1;
+unsigned int     i:2;
+unsigned int     reserved_2:1;
+unsigned int     write_en1:1;
+unsigned int     p:2;
+}VO_OUT;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     vbi2:1;
+unsigned int     vbi1:1;
+unsigned int     csr:2;
+unsigned int     osd1:2;
+unsigned int     sub2:2;
+unsigned int     sub1:2;
+unsigned int     v2:2;
+unsigned int     v1:2;
+unsigned int     reserved_1:1;
+unsigned int     bg2:1;
+unsigned int     bg1:1;
+unsigned int     reserved_2:1;
+}VO_MIX12;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     reserved_1:1;
+unsigned int     vbi:1;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:1;
+unsigned int     reserved_4:1;
+unsigned int     reserved_5:1;
+unsigned int     reserved_6:1;
+unsigned int     reserved_7:1;
+unsigned int     dd:1;
+unsigned int     reserved_8:1;
+unsigned int     bg:1;
+unsigned int     write_data:1;
+}VO_MIXDD;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     relay_mix:1;
+unsigned int     csr:1;
+unsigned int     osd1:1;
+unsigned int     sub2:1;
+unsigned int     sub1:1;
+unsigned int     v2:1;
+unsigned int     v1:1;
+unsigned int     reserved_1:1;
+unsigned int     mix1:1;
+unsigned int     write_data:1;
+}VO_WB;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     relay_mix:1;
+unsigned int     csr:1;
+unsigned int     osd1:1;
+unsigned int     sub2:1;
+unsigned int     sub1:1;
+unsigned int     v2:1;
+unsigned int     v1:1;
+unsigned int     mix2:1;
+unsigned int     mix1:1;
+unsigned int     write_data:1;
+}VO_WB2;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     top_and_bottom:1;
+unsigned int     side_by_side:1;
+unsigned int     right:1;
+unsigned int     write_data:1;
+}VO_M1_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     top_and_bottom:1;
+unsigned int     side_by_side:1;
+unsigned int     right:1;
+unsigned int     write_data:1;
+}VO_M2_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     wb2go:1;
+unsigned int     wb1go:1;
+unsigned int     mddgo:1;
+unsigned int     m2go:1;
+unsigned int     m1go:1;
+unsigned int     write_data:1;
+}VO_FC;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     ref:3;
+unsigned int     pos:12;
+unsigned int     th:12;
+}VO_VBI_END;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     ve_fmt:1;
+unsigned int     source:1;
+unsigned int     nv21:1;
+unsigned int     mode_10b:1;
+unsigned int     ppc10b:1;
+unsigned int     finish_mode:1;
+unsigned int     d3_dbh:1;
+unsigned int     d3_dbw:1;
+unsigned int     d3_dup:1;
+unsigned int     reserved_1:1;
+unsigned int     st:1;
+unsigned int     sr:1;
+unsigned int     shp:1;
+unsigned int     seq:1;
+unsigned int     di:1;
+unsigned int     f422:1;
+unsigned int     vs:1;
+unsigned int     vs_near:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     hs:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     topfield:1;
+unsigned int     dmaweave:1;
+unsigned int     write_data:1;
+}VO_V1;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     w_l:6;
+unsigned int     reserved_1:9;
+unsigned int     l:7;
+}VO_V1_DMA;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_SEQ_SA_W_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_SEQ_SA_W_C;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_SEQ_SA_C_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_SEQ_SA_C_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_W_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_W_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_C_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_C_C;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_SEQ_SA_W_Y_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_SEQ_SA_W_C_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_SEQ_SA_C_Y_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_SEQ_SA_C_C_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     w_c_en:1;
+unsigned int     w_c:3;
+unsigned int     w_y_en:1;
+unsigned int     w_y:3;
+unsigned int     c_en:1;
+unsigned int     c:3;
+unsigned int     y_en:1;
+unsigned int     y:3;
+}VO_V1_INDEX_RR;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     a:9;
+}VO_V1_ALPHA;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_V1_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     th:10;
+}VO_V1_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     soft_reset:1;
+unsigned int     int_mask:1;
+unsigned int     run:1;
+}VO_V1_MC_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     check_soft_reset:1;
+unsigned int     error:1;
+unsigned int     done:1;
+}VO_V1_MC_4;
+
+typedef struct 
+{
+unsigned int     luma_offset_sa:32;
+}VO_V1_MC_8;
+
+typedef struct 
+{
+unsigned int     chroma_offset_sa:32;
+}VO_V1_MC_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     luma_height:14;
+unsigned int     reserved_1:2;
+unsigned int     chroma_height:14;
+}VO_V1_MC_10;
+
+typedef struct 
+{
+unsigned int     luma_sa:32;
+}VO_V1_MC_14;
+
+typedef struct 
+{
+unsigned int     chroma_sa:32;
+}VO_V1_MC_18;
+
+typedef struct 
+{
+unsigned int     luma_pitch:16;
+unsigned int     chroma_pitch:16;
+}VO_V1_MC_1C;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x_pos:13;
+unsigned int     reserved_1:3;
+unsigned int     y_pos:13;
+}VO_V1_MC_20;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     x_size:14;
+unsigned int     reserved_1:2;
+unsigned int     y_size:14;
+}VO_V1_MC_24;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     luma_out_mode:4;
+unsigned int     chroma_out_mode:4;
+unsigned int     reserved_1:2;
+unsigned int     hsync_period:14;
+}VO_V1_MC_28;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     time_out_count:16;
+}VO_V1_MC_2C;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     offset_endian:4;
+unsigned int     data_endian:4;
+}VO_V1_MC_30;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     luma_bit_depth:2;
+unsigned int     chroma_bit_depth:2;
+}VO_V1_MC_34;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     mc_f422:1;
+unsigned int     data_endian:1;
+unsigned int     reserved_1:2;
+unsigned int     size:2;
+}VO_V1_TILE;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     mode:2;
+}VO_V1_DI;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_DI_SEQ_SA_N_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_DI_SEQ_SA_N_C;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_DI_SEQ_SA_P_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_DI_SEQ_SA_P_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_N_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_N_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_P_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_P_C;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_DI_SEQ_SA_N_Y_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_DI_SEQ_SA_N_C_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_DI_SEQ_SA_P_Y_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_DI_SEQ_SA_P_C_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     n_c_en:1;
+unsigned int     n_c:3;
+unsigned int     n_y_en:1;
+unsigned int     n_y:3;
+unsigned int     p_c_en:1;
+unsigned int     p_c:3;
+unsigned int     p_y_en:1;
+unsigned int     p_y:3;
+}VO_V1_DI_3F_RR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     n_c_en:1;
+unsigned int     n_c:3;
+unsigned int     n_y_en:1;
+unsigned int     n_y:3;
+unsigned int     p_c_en:1;
+unsigned int     p_c:3;
+unsigned int     p_y_en:1;
+unsigned int     p_y:3;
+}VO_V1_DI_3F_RR_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_MA_FR;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_MA_FR_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_MA_FW;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V1_MA_FW_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     c_range:1;
+unsigned int     y_range:2;
+unsigned int     reserved_1:3;
+unsigned int     th_pos:5;
+unsigned int     reserved_2:1;
+unsigned int     th_prediff:7;
+unsigned int     reserved_3:2;
+unsigned int     th_refdiff:6;
+}VO_V1_INTRA;
+
+typedef struct 
+{
+unsigned int     split:1;
+unsigned int     c_intra:1;
+unsigned int     lp:1;
+unsigned int     fm:1;
+unsigned int     reserved_0:1;
+unsigned int     sc:3;
+unsigned int     th_noise:8;
+unsigned int     th_c:8;
+unsigned int     th_y:8;
+}VO_V1_MA;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     correct:1;
+unsigned int     fm:1;
+unsigned int     limit:1;
+unsigned int     weave:1;
+unsigned int     blend:1;
+unsigned int     noisy_high:1;
+unsigned int     noisy:1;
+unsigned int     ma:1;
+unsigned int     write_data:1;
+}VO_V1_MA_NEW;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     limit:8;
+unsigned int     big:8;
+unsigned int     th:8;
+}VO_V1_MA_FT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     noisy:8;
+unsigned int     th:8;
+}VO_V1_MA_FM;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     cth_log2:3;
+unsigned int     cth_low:8;
+unsigned int     reserved_1:5;
+unsigned int     yth_log2:3;
+unsigned int     yth_low:8;
+}VO_V1_DI_BLEND;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     mode:2;
+}VO_V1_FILM;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     th:8;
+unsigned int     reserved_1:4;
+unsigned int     wad:12;
+}VO_V1_WADTB;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     e:12;
+unsigned int     reserved_1:4;
+unsigned int     s:12;
+}VO_V1_DI_YWIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     e:12;
+unsigned int     reserved_1:4;
+unsigned int     s:12;
+}VO_V1_DI_CWIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V1_DI_WINX;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     swad:27;
+}VO_V1_FILM_SWAD;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     th:27;
+}VO_V1_FILM_TH;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     mode:3;
+}VO_V1_DI_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dbg_bob:1;
+unsigned int     dbg_chk_area:1;
+unsigned int     dbg_combing:1;
+unsigned int     dbg_blend_ratio:1;
+unsigned int     reserved_1:5;
+unsigned int     bob_chk2_en:1;
+unsigned int     bob_chk1_en:1;
+unsigned int     bob_chk0_en:1;
+unsigned int     reserved_2:3;
+unsigned int     escape_en:1;
+unsigned int     use_wb_diff:1;
+unsigned int     wb_max_diff:1;
+unsigned int     wb_chk_result:1;
+unsigned int     chk_use_max_mf:1;
+unsigned int     comb_chk_en:1;
+unsigned int     mf_select:1;
+unsigned int     mf_lpf_enable:1;
+unsigned int     use_lpf_data:1;
+unsigned int     light_comb_en:1;
+unsigned int     cu:1;
+unsigned int     en:1;
+unsigned int     write_data:1;
+}VO_V1_NEW_DI;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     c4:3;
+unsigned int     reserved_1:1;
+unsigned int     c3:3;
+unsigned int     reserved_2:1;
+unsigned int     c2:3;
+unsigned int     reserved_3:1;
+unsigned int     c1:3;
+unsigned int     reserved_4:1;
+unsigned int     c0:3;
+}VO_V1_DI_LPF1X5;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     c4:3;
+unsigned int     reserved_1:1;
+unsigned int     c3:3;
+unsigned int     reserved_2:1;
+unsigned int     c2:3;
+unsigned int     reserved_3:1;
+unsigned int     c1:3;
+unsigned int     reserved_4:1;
+unsigned int     c0:3;
+}VO_V1_DI_LPF3X5_T;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     c4:3;
+unsigned int     reserved_1:1;
+unsigned int     c3:3;
+unsigned int     reserved_2:1;
+unsigned int     c2:3;
+unsigned int     reserved_3:1;
+unsigned int     c1:3;
+unsigned int     reserved_4:1;
+unsigned int     c0:3;
+}VO_V1_DI_LPF3X5_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     c4:3;
+unsigned int     reserved_1:1;
+unsigned int     c3:3;
+unsigned int     reserved_2:1;
+unsigned int     c2:3;
+unsigned int     reserved_3:1;
+unsigned int     c1:3;
+unsigned int     reserved_4:1;
+unsigned int     c0:3;
+}VO_V1_DI_LPF3X5_B;
+
+typedef struct 
+{
+unsigned int     r:10;
+unsigned int     reserved_0:4;
+unsigned int     expand_range:2;
+unsigned int     h_th:8;
+unsigned int     l_th:8;
+}VO_V1_DI_MF;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     thd:8;
+}VO_V1_DI_COMB;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     h_th:8;
+unsigned int     reserved_1:8;
+unsigned int     l_th:8;
+}VO_V1_DI_COMB_CHK;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dis_chk_th:8;
+unsigned int     reserved_1:8;
+unsigned int     en_chk_th:8;
+}VO_V1_DI_COMB_CNT;
+
+typedef struct 
+{
+unsigned int     pn_thd1:8;
+unsigned int     pn_thd0:8;
+unsigned int     reserved_0:8;
+unsigned int     tb_thd:8;
+}VO_V1_DI_LIGHT_COMB0;
+
+typedef struct 
+{
+unsigned int     bw_thd:8;
+unsigned int     tw_thd:8;
+unsigned int     reserved_0:8;
+unsigned int     thd:8;
+}VO_V1_DI_LIGHT_COMB1;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     c2:3;
+unsigned int     reserved_1:1;
+unsigned int     c1:3;
+unsigned int     reserved_2:1;
+unsigned int     c0:3;
+}VO_V1_DI_DATA_LPF1X3;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     c2:3;
+unsigned int     reserved_1:1;
+unsigned int     c1:3;
+unsigned int     reserved_2:1;
+unsigned int     c0:3;
+}VO_V1_DI_DIFF_LPF1X3;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     max_min_thd:8;
+unsigned int     reserved_1:4;
+unsigned int     factor1:4;
+unsigned int     reserved_2:4;
+unsigned int     factor0:4;
+}VO_V1_DI_BOB_DIFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     intep_thd:10;
+unsigned int     final_min_thd:8;
+unsigned int     min_thd:8;
+}VO_V1_DI_BOB;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     thd:8;
+}VO_V1_DI_NC_COMB;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     thd:8;
+}VO_V1_DI_FINAL_COMB;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     nc_thd:8;
+unsigned int     reserved_1:8;
+unsigned int     pn_thd:8;
+}VO_V1_DI_DATA_DIFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     thd:10;
+}VO_V1_DI_ESCAPE;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     cnt:23;
+}VO_V1_STA_TOTAL;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sum:31;
+}VO_V1_STA_SUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     cnt:23;
+}VO_V1_STA_BKT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sum:31;
+}VO_V1_STA_AD;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     cnt:20;
+}VO_V1_STA_NC_COMB;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     cnt:20;
+}VO_V1_STA_FINAL_COMB;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     cnt:20;
+}VO_V1_STA_PN_DIFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     cnt:20;
+}VO_V1_STA_NC_DIFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     offset:14;
+unsigned int     phase:16;
+}VO_V1_VSYI;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     offset:14;
+unsigned int     phase:16;
+}VO_V1_VSCI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_V1_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_V1_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V1_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V1_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     offset:13;
+unsigned int     phase:16;
+}VO_V1_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_V1_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_V1_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V1_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V1_HSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     thd:10;
+unsigned int     reserved_1:8;
+unsigned int     gain:8;
+}VO_V1_SHARP;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     range:5;
+unsigned int     reserved_1:15;
+unsigned int     en:1;
+}VO_V1_SHARP_CLIP;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     c4:3;
+unsigned int     reserved_1:1;
+unsigned int     c3:3;
+unsigned int     reserved_2:1;
+unsigned int     c2:3;
+unsigned int     reserved_3:1;
+unsigned int     c1:3;
+unsigned int     reserved_4:1;
+unsigned int     c0:3;
+}VO_V1_SHARP_LPF;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     dbg_sel2:1;
+unsigned int     dbg_sel1:1;
+unsigned int     dbg_sel0:1;
+unsigned int     reserved_1:14;
+unsigned int     detatil_area:1;
+unsigned int     dyn_min_thd_en:1;
+unsigned int     double_chk_en:1;
+unsigned int     lpf_intrp_data:1;
+unsigned int     slope_post_en:1;
+unsigned int     diff_lpf_en:1;
+unsigned int     diff_y_only:1;
+unsigned int     cu:1;
+unsigned int     en:1;
+unsigned int     write_data:1;
+}VO_V1_SR_DI;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     c22:3;
+unsigned int     c21:3;
+unsigned int     c20:3;
+unsigned int     c12:3;
+unsigned int     c11:3;
+unsigned int     c10:3;
+unsigned int     c02:3;
+unsigned int     c01:3;
+unsigned int     c00:3;
+}VO_V1_SR_DI_LPF3X3;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     final:4;
+unsigned int     reserved_1:4;
+unsigned int     t05:4;
+unsigned int     reserved_2:4;
+unsigned int     h:4;
+unsigned int     reserved_3:4;
+unsigned int     v:4;
+}VO_V1_SR_DI_MIN_THD;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     thd:4;
+}VO_V1_SR_DETAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     acc:5;
+unsigned int     reserved_1:4;
+unsigned int     high_thd:4;
+unsigned int     reserved_2:4;
+unsigned int     low_thd:4;
+}VO_V1_SR_DYN_MIN_THD;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     high_detail:6;
+unsigned int     reserved_1:2;
+unsigned int     low_detail:6;
+}VO_V1_SR_DYN_MIN_THD_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     blend_en:1;
+unsigned int     usm_lpf_en:1;
+unsigned int     en:1;
+unsigned int     write_data:1;
+}VO_V1_SR_SHP;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     thd:10;
+}VO_V1_SR_SHP_CFG0;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     clip_range_min:6;
+unsigned int     reserved_1:2;
+unsigned int     clip_range_max:6;
+unsigned int     reserved_2:2;
+unsigned int     gain:6;
+}VO_V1_SR_SHP_CFG1;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     c4:4;
+unsigned int     c3:4;
+unsigned int     c2:4;
+unsigned int     c1:4;
+unsigned int     c0:4;
+}VO_V1_SR_SHP_LPF_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     c4:4;
+unsigned int     c3:4;
+unsigned int     c2:4;
+unsigned int     c1:4;
+unsigned int     c0:4;
+}VO_V1_SR_SHP_LPF_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     c4:4;
+unsigned int     c3:4;
+unsigned int     c2:4;
+unsigned int     c1:4;
+unsigned int     c0:4;
+}VO_V1_SR_SHP_LPF_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     high:10;
+unsigned int     reserved_1:6;
+unsigned int     low:10;
+}VO_V1_SR_SHP_WGT_THD;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     gain:8;
+}VO_V1_SR_SHP_WGT;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_V1_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_V1_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_V1_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_V1_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_V1_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     a1:11;
+unsigned int     reserved_1:5;
+unsigned int     a0:11;
+}VO_V1_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     a2:11;
+}VO_V1_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cd:1;
+unsigned int     gma:1;
+unsigned int     iga:1;
+unsigned int     en:1;
+}VO_V1_HDR;
+
+typedef struct 
+{
+unsigned int     tab_index:20;
+unsigned int     tab_d0:12;
+}VO_V1_IGA_PORT;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     dstat_srcsel:1;
+unsigned int     r_en:1;
+unsigned int     g_en:1;
+unsigned int     b_en:1;
+unsigned int     m_tab_sel:1;
+unsigned int     ax_rw:2;
+unsigned int     ax_ch:2;
+unsigned int     dstat_en:1;
+}VO_V1_IGA_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     fifo_empty:1;
+unsigned int     fifo_full:1;
+unsigned int     wr_error:1;
+}VO_V1_IGA_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     low:12;
+unsigned int     reserved_1:4;
+unsigned int     high:12;
+}VO_V1_IGA_DSTAT_CTRL_R;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     low:12;
+unsigned int     reserved_1:4;
+unsigned int     high:12;
+}VO_V1_IGA_DSTAT_CTRL_G;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     low:12;
+unsigned int     reserved_1:4;
+unsigned int     high:12;
+}VO_V1_IGA_DSTAT_CTRL_B;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     cnt:21;
+}VO_V1_IGA_DSTAT_O_R1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     min:12;
+unsigned int     reserved_1:4;
+unsigned int     max:12;
+}VO_V1_IGA_DSTAT_O_R2;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     cnt:21;
+}VO_V1_IGA_DSTAT_O_G1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     min:12;
+unsigned int     reserved_1:4;
+unsigned int     max:12;
+}VO_V1_IGA_DSTAT_O_G2;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     cnt:21;
+}VO_V1_IGA_DSTAT_O_B1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     min:12;
+unsigned int     reserved_1:4;
+unsigned int     max:12;
+}VO_V1_IGA_DSTAT_O_B2;
+
+typedef struct 
+{
+unsigned int     rvd:32;
+}VO_V1_IGA_DUMMY_0;
+
+typedef struct 
+{
+unsigned int     rvd:32;
+}VO_V1_IGA_DUMMY_1;
+
+typedef struct 
+{
+unsigned int     rvd:32;
+}VO_V1_IGA_DUMMY_2;
+
+typedef struct 
+{
+unsigned int     tab_index:20;
+unsigned int     tab_d0:12;
+}VO_V1_GMA_PORT;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     dstat_srcsel:1;
+unsigned int     r_en:1;
+unsigned int     g_en:1;
+unsigned int     b_en:1;
+unsigned int     m_tab_sel:1;
+unsigned int     ax_rw:2;
+unsigned int     ax_ch:2;
+unsigned int     dstat_en:1;
+}VO_V1_GMA_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     fifo_empty:1;
+unsigned int     fifo_full:1;
+unsigned int     wr_error:1;
+}VO_V1_GMA_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     low:12;
+unsigned int     reserved_1:4;
+unsigned int     high:12;
+}VO_V1_GMA_DSTAT_CTRL_R;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     low:12;
+unsigned int     reserved_1:4;
+unsigned int     high:12;
+}VO_V1_GMA_DSTAT_CTRL_G;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     low:12;
+unsigned int     reserved_1:4;
+unsigned int     high:12;
+}VO_V1_GMA_DSTAT_CTRL_B;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     cnt:21;
+}VO_V1_GMA_DSTAT_O_R1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     min:12;
+unsigned int     reserved_1:4;
+unsigned int     max:12;
+}VO_V1_GMA_DSTAT_O_R2;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     cnt:21;
+}VO_V1_GMA_DSTAT_O_G1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     min:12;
+unsigned int     reserved_1:4;
+unsigned int     max:12;
+}VO_V1_GMA_DSTAT_O_G2;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     cnt:21;
+}VO_V1_GMA_DSTAT_O_B1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     min:12;
+unsigned int     reserved_1:4;
+unsigned int     max:12;
+}VO_V1_GMA_DSTAT_O_B2;
+
+typedef struct 
+{
+unsigned int     rvd:32;
+}VO_V1_GMA_DUMMY_0;
+
+typedef struct 
+{
+unsigned int     rvd:32;
+}VO_V1_GMA_DUMMY_1;
+
+typedef struct 
+{
+unsigned int     rvd:32;
+}VO_V1_GMA_DUMMY_2;
+
+typedef struct 
+{
+unsigned int     m01:16;
+unsigned int     m00:16;
+}VO_V1_HDR_Y2R_CC1;
+
+typedef struct 
+{
+unsigned int     m10:16;
+unsigned int     m02:16;
+}VO_V1_HDR_Y2R_CC2;
+
+typedef struct 
+{
+unsigned int     m12:16;
+unsigned int     m11:16;
+}VO_V1_HDR_Y2R_CC3;
+
+typedef struct 
+{
+unsigned int     m21:16;
+unsigned int     m20:16;
+}VO_V1_HDR_Y2R_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     m22:16;
+}VO_V1_HDR_Y2R_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     a1:12;
+unsigned int     reserved_1:4;
+unsigned int     a0:12;
+}VO_V1_HDR_Y2R_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     a2:12;
+}VO_V1_HDR_Y2R_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     rmax:12;
+unsigned int     rmin:12;
+}VO_V1_HDR_Y2R_LMT_R;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     gmax:12;
+unsigned int     gmin:12;
+}VO_V1_HDR_Y2R_LMT_G;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     bmax:12;
+unsigned int     bmin:12;
+}VO_V1_HDR_Y2R_LMT_B;
+
+typedef struct 
+{
+unsigned int     m01:16;
+unsigned int     m00:16;
+}VO_V1_HDR_R2Y_CC1;
+
+typedef struct 
+{
+unsigned int     m10:16;
+unsigned int     m02:16;
+}VO_V1_HDR_R2Y_CC2;
+
+typedef struct 
+{
+unsigned int     m12:16;
+unsigned int     m11:16;
+}VO_V1_HDR_R2Y_CC3;
+
+typedef struct 
+{
+unsigned int     m21:16;
+unsigned int     m20:16;
+}VO_V1_HDR_R2Y_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     m22:16;
+}VO_V1_HDR_R2Y_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     a1:11;
+unsigned int     reserved_1:5;
+unsigned int     a0:11;
+}VO_V1_HDR_R2Y_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     a2:11;
+}VO_V1_HDR_R2Y_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ymax:12;
+unsigned int     ymin:12;
+}VO_V1_HDR_R2Y_LMT_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     umax:12;
+unsigned int     umin:12;
+}VO_V1_HDR_R2Y_LMT_U;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     vmax:12;
+unsigned int     vmin:12;
+}VO_V1_HDR_R2Y_LMT_V;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     m00:21;
+}VO_V1_HDR_CSC_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     m01:21;
+}VO_V1_HDR_CSC_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     m02:21;
+}VO_V1_HDR_CSC_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     m10:21;
+}VO_V1_HDR_CSC_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     m11:21;
+}VO_V1_HDR_CSC_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     m12:21;
+}VO_V1_HDR_CSC_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     m20:21;
+}VO_V1_HDR_CSC_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     m21:21;
+}VO_V1_HDR_CSC_CC8;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     m22:21;
+}VO_V1_HDR_CSC_CC9;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     a1:14;
+unsigned int     reserved_1:2;
+unsigned int     a0:14;
+}VO_V1_HDR_CSC_CC10;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     a2:14;
+}VO_V1_HDR_CSC_CC11;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     rmax:12;
+unsigned int     rmin:12;
+}VO_V1_HDR_CSC_LMT_R;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     gmax:12;
+unsigned int     gmin:12;
+}VO_V1_HDR_CSC_LMT_G;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     bmax:12;
+unsigned int     bmin:12;
+}VO_V1_HDR_CSC_LMT_B;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     ve_fmt:1;
+unsigned int     source:1;
+unsigned int     nv21:1;
+unsigned int     mode_10b:1;
+unsigned int     ppc10b:1;
+unsigned int     finish_mode:1;
+unsigned int     d3_dbh:1;
+unsigned int     d3_dbw:1;
+unsigned int     d3_dup:1;
+unsigned int     reserved_1:1;
+unsigned int     st:1;
+unsigned int     reserved_2:1;
+unsigned int     shp:1;
+unsigned int     seq:1;
+unsigned int     di:1;
+unsigned int     f422:1;
+unsigned int     vs:1;
+unsigned int     vs_near:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     hs:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     topfield:1;
+unsigned int     dmaweave:1;
+unsigned int     write_data:1;
+}VO_V2;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     w_l:6;
+unsigned int     reserved_1:9;
+unsigned int     l:7;
+}VO_V2_DMA;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_SEQ_SA_W_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_SEQ_SA_W_C;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_SEQ_SA_C_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_SEQ_SA_C_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V2_SEQ_PITCH_W_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V2_SEQ_PITCH_W_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V2_SEQ_PITCH_C_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V2_SEQ_PITCH_C_C;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_SEQ_SA_W_Y_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_SEQ_SA_W_C_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_SEQ_SA_C_Y_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_SEQ_SA_C_C_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     w_c_en:1;
+unsigned int     w_c:3;
+unsigned int     w_y_en:1;
+unsigned int     w_y:3;
+unsigned int     c_en:1;
+unsigned int     c:3;
+unsigned int     y_en:1;
+unsigned int     y:3;
+}VO_V2_INDEX_RR;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     a:9;
+}VO_V2_ALPHA;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_V2_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     th:10;
+}VO_V2_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     soft_reset:1;
+unsigned int     int_mask:1;
+unsigned int     run:1;
+}VO_V2_MC_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     check_soft_reset:1;
+unsigned int     error:1;
+unsigned int     done:1;
+}VO_V2_MC_4;
+
+typedef struct 
+{
+unsigned int     luma_offset_sa:32;
+}VO_V2_MC_8;
+
+typedef struct 
+{
+unsigned int     chroma_offset_sa:32;
+}VO_V2_MC_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     luma_height:14;
+unsigned int     reserved_1:2;
+unsigned int     chroma_height:14;
+}VO_V2_MC_10;
+
+typedef struct 
+{
+unsigned int     luma_sa:32;
+}VO_V2_MC_14;
+
+typedef struct 
+{
+unsigned int     chroma_sa:32;
+}VO_V2_MC_18;
+
+typedef struct 
+{
+unsigned int     luma_pitch:16;
+unsigned int     chroma_pitch:16;
+}VO_V2_MC_1C;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x_pos:13;
+unsigned int     reserved_1:3;
+unsigned int     y_pos:13;
+}VO_V2_MC_20;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     x_size:14;
+unsigned int     reserved_1:2;
+unsigned int     y_size:14;
+}VO_V2_MC_24;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     luma_out_mode:4;
+unsigned int     chroma_out_mode:4;
+unsigned int     reserved_1:2;
+unsigned int     hsync_period:14;
+}VO_V2_MC_28;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     time_out_count:16;
+}VO_V2_MC_2C;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     offset_endian:4;
+unsigned int     data_endian:4;
+}VO_V2_MC_30;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     luma_bit_depth:2;
+unsigned int     chroma_bit_depth:2;
+}VO_V2_MC_34;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     mc_f422:1;
+unsigned int     data_endian:1;
+unsigned int     reserved_1:2;
+unsigned int     size:2;
+}VO_V2_TILE;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     mode:2;
+}VO_V2_DI;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_DI_SEQ_SA_N_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_DI_SEQ_SA_N_C;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_DI_SEQ_SA_P_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_DI_SEQ_SA_P_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V2_SEQ_PITCH_N_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V2_SEQ_PITCH_N_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V2_SEQ_PITCH_P_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V2_SEQ_PITCH_P_C;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_DI_SEQ_SA_N_Y_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_DI_SEQ_SA_N_C_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_DI_SEQ_SA_P_Y_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_DI_SEQ_SA_P_C_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     n_c_en:1;
+unsigned int     n_c:3;
+unsigned int     n_y_en:1;
+unsigned int     n_y:3;
+unsigned int     p_c_en:1;
+unsigned int     p_c:3;
+unsigned int     p_y_en:1;
+unsigned int     p_y:3;
+}VO_V2_DI_3F_RR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     n_c_en:1;
+unsigned int     n_c:3;
+unsigned int     n_y_en:1;
+unsigned int     n_y:3;
+unsigned int     p_c_en:1;
+unsigned int     p_c:3;
+unsigned int     p_y_en:1;
+unsigned int     p_y:3;
+}VO_V2_DI_3F_RR_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_MA_FR;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_MA_FR_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_MA_FW;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_V2_MA_FW_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     c_range:1;
+unsigned int     y_range:2;
+unsigned int     reserved_1:3;
+unsigned int     th_pos:5;
+unsigned int     reserved_2:1;
+unsigned int     th_prediff:7;
+unsigned int     reserved_3:2;
+unsigned int     th_refdiff:6;
+}VO_V2_INTRA;
+
+typedef struct 
+{
+unsigned int     split:1;
+unsigned int     c_intra:1;
+unsigned int     lp:1;
+unsigned int     fm:1;
+unsigned int     reserved_0:1;
+unsigned int     sc:3;
+unsigned int     th_noise:8;
+unsigned int     th_c:8;
+unsigned int     th_y:8;
+}VO_V2_MA;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     correct:1;
+unsigned int     fm:1;
+unsigned int     limit:1;
+unsigned int     weave:1;
+unsigned int     blend:1;
+unsigned int     noisy_high:1;
+unsigned int     noisy:1;
+unsigned int     ma:1;
+unsigned int     write_data:1;
+}VO_V2_MA_NEW;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     limit:8;
+unsigned int     big:8;
+unsigned int     th:8;
+}VO_V2_MA_FT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     noisy:8;
+unsigned int     th:8;
+}VO_V2_MA_FM;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     cth_log2:3;
+unsigned int     cth_low:8;
+unsigned int     reserved_1:5;
+unsigned int     yth_log2:3;
+unsigned int     yth_low:8;
+}VO_V2_DI_BLEND;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     mode:2;
+}VO_V2_FILM;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     th:8;
+unsigned int     reserved_1:4;
+unsigned int     wad:12;
+}VO_V2_WADTB;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     e:12;
+unsigned int     reserved_1:4;
+unsigned int     s:12;
+}VO_V2_DI_YWIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     e:12;
+unsigned int     reserved_1:4;
+unsigned int     s:12;
+}VO_V2_DI_CWIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V2_DI_WINX;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     swad:27;
+}VO_V2_FILM_SWAD;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     th:27;
+}VO_V2_FILM_TH;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     mode:3;
+}VO_V2_DI_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dbg_bob:1;
+unsigned int     dbg_chk_area:1;
+unsigned int     dbg_combing:1;
+unsigned int     dbg_blend_ratio:1;
+unsigned int     reserved_1:5;
+unsigned int     bob_chk2_en:1;
+unsigned int     bob_chk1_en:1;
+unsigned int     bob_chk0_en:1;
+unsigned int     reserved_2:3;
+unsigned int     escape_en:1;
+unsigned int     use_wb_diff:1;
+unsigned int     wb_max_diff:1;
+unsigned int     wb_chk_result:1;
+unsigned int     chk_use_max_mf:1;
+unsigned int     comb_chk_en:1;
+unsigned int     mf_select:1;
+unsigned int     mf_lpf_enable:1;
+unsigned int     use_lpf_data:1;
+unsigned int     light_comb_en:1;
+unsigned int     cu:1;
+unsigned int     en:1;
+unsigned int     write_data:1;
+}VO_V2_NEW_DI;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     c4:3;
+unsigned int     reserved_1:1;
+unsigned int     c3:3;
+unsigned int     reserved_2:1;
+unsigned int     c2:3;
+unsigned int     reserved_3:1;
+unsigned int     c1:3;
+unsigned int     reserved_4:1;
+unsigned int     c0:3;
+}VO_V2_DI_LPF1X5;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     c4:3;
+unsigned int     reserved_1:1;
+unsigned int     c3:3;
+unsigned int     reserved_2:1;
+unsigned int     c2:3;
+unsigned int     reserved_3:1;
+unsigned int     c1:3;
+unsigned int     reserved_4:1;
+unsigned int     c0:3;
+}VO_V2_DI_LPF3X5_T;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     c4:3;
+unsigned int     reserved_1:1;
+unsigned int     c3:3;
+unsigned int     reserved_2:1;
+unsigned int     c2:3;
+unsigned int     reserved_3:1;
+unsigned int     c1:3;
+unsigned int     reserved_4:1;
+unsigned int     c0:3;
+}VO_V2_DI_LPF3X5_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     c4:3;
+unsigned int     reserved_1:1;
+unsigned int     c3:3;
+unsigned int     reserved_2:1;
+unsigned int     c2:3;
+unsigned int     reserved_3:1;
+unsigned int     c1:3;
+unsigned int     reserved_4:1;
+unsigned int     c0:3;
+}VO_V2_DI_LPF3X5_B;
+
+typedef struct 
+{
+unsigned int     r:10;
+unsigned int     reserved_0:4;
+unsigned int     expand_range:2;
+unsigned int     h_th:8;
+unsigned int     l_th:8;
+}VO_V2_DI_MF;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     thd:8;
+}VO_V2_DI_COMB;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     h_th:8;
+unsigned int     reserved_1:8;
+unsigned int     l_th:8;
+}VO_V2_DI_COMB_CHK;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dis_chk_th:8;
+unsigned int     reserved_1:8;
+unsigned int     en_chk_th:8;
+}VO_V2_DI_COMB_CNT;
+
+typedef struct 
+{
+unsigned int     pn_thd1:8;
+unsigned int     pn_thd0:8;
+unsigned int     reserved_0:8;
+unsigned int     tb_thd:8;
+}VO_V2_DI_LIGHT_COMB0;
+
+typedef struct 
+{
+unsigned int     bw_thd:8;
+unsigned int     tw_thd:8;
+unsigned int     reserved_0:8;
+unsigned int     thd:8;
+}VO_V2_DI_LIGHT_COMB1;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     c2:3;
+unsigned int     reserved_1:1;
+unsigned int     c1:3;
+unsigned int     reserved_2:1;
+unsigned int     c0:3;
+}VO_V2_DI_DATA_LPF1X3;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     c2:3;
+unsigned int     reserved_1:1;
+unsigned int     c1:3;
+unsigned int     reserved_2:1;
+unsigned int     c0:3;
+}VO_V2_DI_DIFF_LPF1X3;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     max_min_thd:8;
+unsigned int     reserved_1:4;
+unsigned int     factor1:4;
+unsigned int     reserved_2:4;
+unsigned int     factor0:4;
+}VO_V2_DI_BOB_DIFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     intep_thd:10;
+unsigned int     final_min_thd:8;
+unsigned int     min_thd:8;
+}VO_V2_DI_BOB;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     thd:8;
+}VO_V2_DI_NC_COMB;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     thd:8;
+}VO_V2_DI_FINAL_COMB;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     nc_thd:8;
+unsigned int     reserved_1:8;
+unsigned int     pn_thd:8;
+}VO_V2_DI_DATA_DIFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     thd:10;
+}VO_V2_DI_ESCAPE;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     cnt:23;
+}VO_V2_STA_TOTAL;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sum:31;
+}VO_V2_STA_SUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     cnt:23;
+}VO_V2_STA_BKT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sum:31;
+}VO_V2_STA_AD;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     cnt:20;
+}VO_V2_STA_NC_COMB;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     cnt:20;
+}VO_V2_STA_FINAL_COMB;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     cnt:20;
+}VO_V2_STA_PN_DIFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     cnt:20;
+}VO_V2_STA_NC_DIFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     offset:14;
+unsigned int     phase:16;
+}VO_V2_VSYI;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     offset:14;
+unsigned int     phase:16;
+}VO_V2_VSCI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_V2_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_V2_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V2_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V2_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     offset:13;
+unsigned int     phase:16;
+}VO_V2_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_V2_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_V2_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V2_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V2_HSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     thd:10;
+unsigned int     reserved_1:8;
+unsigned int     gain:8;
+}VO_V2_SHARP;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     range:5;
+unsigned int     reserved_1:15;
+unsigned int     en:1;
+}VO_V2_SHARP_CLIP;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     c4:3;
+unsigned int     reserved_1:1;
+unsigned int     c3:3;
+unsigned int     reserved_2:1;
+unsigned int     c2:3;
+unsigned int     reserved_3:1;
+unsigned int     c1:3;
+unsigned int     reserved_4:1;
+unsigned int     c0:3;
+}VO_V2_SHARP_LPF;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_V2_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_V2_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_V2_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_V2_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_V2_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     a1:11;
+unsigned int     reserved_1:5;
+unsigned int     a0:11;
+}VO_V2_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     a2:11;
+}VO_V2_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     d3_dbh:1;
+unsigned int     d3_vdup:1;
+unsigned int     d3_dbw:1;
+unsigned int     d3_dup:1;
+unsigned int     rgb_out:1;
+unsigned int     reserved_1:1;
+unsigned int     dvd:1;
+unsigned int     hddvd:1;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:1;
+unsigned int     hl:1;
+unsigned int     reserved_4:1;
+unsigned int     dvb:1;
+unsigned int     osd:1;
+unsigned int     fetch_1080i:1;
+unsigned int     odd_1080i:1;
+unsigned int     reserved_5:1;
+unsigned int     reserved_6:1;
+unsigned int     reserved_7:1;
+unsigned int     vs:1;
+unsigned int     vs_near:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     hs:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     reserved_8:1;
+unsigned int     reserved_9:1;
+unsigned int     reserved_10:1;
+unsigned int     write_data:1;
+}VO_SUB1;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     ref:3;
+unsigned int     pos:12;
+unsigned int     th:12;
+}VO_SUB1_START;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     w:12;
+}VO_SUB1_SUBP;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     w:11;
+unsigned int     reserved_1:1;
+unsigned int     h:11;
+}VO_SUB1_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     th:9;
+}VO_SUB1_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     swap_8byte:1;
+unsigned int     endian:1;
+}VO_SUB1_WI;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_SUB1_WI_1;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_SUB1_WI_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     keep:1;
+}VO_SUB1_CLUT;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_SUB1_CLUT_1;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_SUB1_PXDT;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_SUB1_PXDB;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     num:11;
+}VO_SUB1_LC;
+
+typedef struct 
+{
+unsigned int     a3:4;
+unsigned int     a2:4;
+unsigned int     a1:4;
+unsigned int     a0:4;
+unsigned int     i3:4;
+unsigned int     i2:4;
+unsigned int     i1:4;
+unsigned int     i0:4;
+}VO_SUB1_DFT;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     e:11;
+unsigned int     reserved_1:1;
+unsigned int     s:11;
+}VO_SUB1_HLX;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     e:11;
+unsigned int     reserved_1:1;
+unsigned int     s:11;
+}VO_SUB1_HLY;
+
+typedef struct 
+{
+unsigned int     a3:4;
+unsigned int     a2:4;
+unsigned int     a1:4;
+unsigned int     a0:4;
+unsigned int     i3:4;
+unsigned int     i2:4;
+unsigned int     i1:4;
+unsigned int     i0:4;
+}VO_SUB1_HL;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_SUB1_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_SUB1_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_SUB1_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_SUB1_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_SUB1_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     a1:11;
+unsigned int     a0:11;
+}VO_SUB1_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     a2:11;
+}VO_SUB1_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     offset:12;
+unsigned int     phase:16;
+}VO_SUB1_VSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_SUB1_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_SUB1_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB1_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB1_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     offset:11;
+unsigned int     phase:16;
+}VO_SUB1_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_SUB1_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_SUB1_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB1_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB1_HSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     d3_dbh:1;
+unsigned int     d3_vdup:1;
+unsigned int     d3_dbw:1;
+unsigned int     d3_dup:1;
+unsigned int     rgb_out:1;
+unsigned int     reserved_1:1;
+unsigned int     dvd:1;
+unsigned int     hddvd:1;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:1;
+unsigned int     hl:1;
+unsigned int     reserved_4:1;
+unsigned int     dvb:1;
+unsigned int     osd:1;
+unsigned int     fetch_1080i:1;
+unsigned int     odd_1080i:1;
+unsigned int     reserved_5:1;
+unsigned int     reserved_6:1;
+unsigned int     reserved_7:1;
+unsigned int     vs:1;
+unsigned int     vs_near:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     hs:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     reserved_8:1;
+unsigned int     reserved_9:1;
+unsigned int     reserved_10:1;
+unsigned int     write_data:1;
+}VO_SUB2;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     ref:3;
+unsigned int     pos:12;
+unsigned int     th:12;
+}VO_SUB2_START;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     w:12;
+}VO_SUB2_SUBP;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     w:11;
+unsigned int     reserved_1:1;
+unsigned int     h:11;
+}VO_SUB2_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     th:9;
+}VO_SUB2_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     swap_8byte:1;
+unsigned int     endian:1;
+}VO_SUB2_WI;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_SUB2_WI_1;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_SUB2_WI_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     keep:1;
+}VO_SUB2_CLUT;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_SUB2_CLUT_1;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_SUB2_PXDT;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_SUB2_PXDB;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     num:11;
+}VO_SUB2_LC;
+
+typedef struct 
+{
+unsigned int     a3:4;
+unsigned int     a2:4;
+unsigned int     a1:4;
+unsigned int     a0:4;
+unsigned int     i3:4;
+unsigned int     i2:4;
+unsigned int     i1:4;
+unsigned int     i0:4;
+}VO_SUB2_DFT;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     e:11;
+unsigned int     reserved_1:1;
+unsigned int     s:11;
+}VO_SUB2_HLX;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     e:11;
+unsigned int     reserved_1:1;
+unsigned int     s:11;
+}VO_SUB2_HLY;
+
+typedef struct 
+{
+unsigned int     a3:4;
+unsigned int     a2:4;
+unsigned int     a1:4;
+unsigned int     a0:4;
+unsigned int     i3:4;
+unsigned int     i2:4;
+unsigned int     i1:4;
+unsigned int     i0:4;
+}VO_SUB2_HL;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_SUB2_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_SUB2_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_SUB2_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_SUB2_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_SUB2_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     a1:11;
+unsigned int     a0:11;
+}VO_SUB2_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     a2:11;
+}VO_SUB2_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     offset:12;
+unsigned int     phase:16;
+}VO_SUB2_VSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_SUB2_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_SUB2_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB2_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB2_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     offset:11;
+unsigned int     phase:16;
+}VO_SUB2_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_SUB2_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_SUB2_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB2_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB2_HSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     d3_dbh:1;
+unsigned int     d3_vdup:1;
+unsigned int     d3_dbw:1;
+unsigned int     d3_dup:1;
+unsigned int     rgb_out:1;
+unsigned int     reserved_1:6;
+unsigned int     reserved_2:1;
+unsigned int     dvb:1;
+unsigned int     osd:1;
+unsigned int     fetch_1080i:1;
+unsigned int     odd_1080i:1;
+unsigned int     reserved_3:1;
+unsigned int     reserved_4:1;
+unsigned int     reserved_5:1;
+unsigned int     vs:1;
+unsigned int     vs_near:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     hs:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     reserved_6:1;
+unsigned int     reserved_7:1;
+unsigned int     reserved_8:1;
+unsigned int     write_data:1;
+}VO_OSD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     ref:3;
+unsigned int     pos:12;
+unsigned int     th:12;
+}VO_OSD1_START;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     swap_8byte:1;
+unsigned int     endian:1;
+}VO_OSD1_WI;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_OSD1_WI_1;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_OSD1_WI_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_OSD1_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     th:9;
+}VO_OSD1_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_OSD1_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_OSD1_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_OSD1_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_OSD1_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_OSD1_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     a1:11;
+unsigned int     a0:11;
+}VO_OSD1_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     a2:11;
+}VO_OSD1_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     offset:12;
+unsigned int     phase:16;
+}VO_OSD1_VSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_OSD1_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_OSD1_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_OSD1_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_OSD1_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     offset:13;
+unsigned int     phase:16;
+}VO_OSD1_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_OSD1_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_OSD1_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_OSD1_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_OSD1_HSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     d3_dbh:1;
+unsigned int     d3_dbw:1;
+unsigned int     reserved_1:1;
+unsigned int     fetch_1080i:1;
+unsigned int     odd_1080i:1;
+unsigned int     reserved_2:1;
+unsigned int     m4bit:1;
+unsigned int     m2bit:1;
+unsigned int     reload:1;
+unsigned int     update:1;
+unsigned int     reserved_3:1;
+unsigned int     reserved_4:1;
+unsigned int     write_data:1;
+}VO_CSR;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     w:9;
+unsigned int     reserved_1:3;
+unsigned int     h:9;
+}VO_CSR_SIZE;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_CSR_BS;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_CSR_BS_3D;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_CSR_CLUT;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     wb_mode_10b:1;
+unsigned int     wb_ppc10b:1;
+unsigned int     wb_tr:1;
+unsigned int     dd_nv21:1;
+unsigned int     wb_nv21:1;
+unsigned int     dd_seq:1;
+unsigned int     wb_seq:1;
+unsigned int     h2v:1;
+unsigned int     hd:1;
+unsigned int     f422:1;
+unsigned int     reint:1;
+unsigned int     bot:1;
+unsigned int     wb_f420:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     reserved_1:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     write_data:1;
+}VO_DDWB;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     write_en2:1;
+unsigned int     hs_sel:2;
+unsigned int     reserved_1:1;
+unsigned int     write_en1:1;
+unsigned int     vs_sel:2;
+}VO_DDWB_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en5:1;
+unsigned int     interlace:1;
+unsigned int     write_en4:1;
+unsigned int     bot:1;
+unsigned int     reserved_1:8;
+unsigned int     write_en2:1;
+unsigned int     c:7;
+unsigned int     write_en1:1;
+unsigned int     y:7;
+}VO_DD_INDEX;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_DD_SEQ_SA_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_DD_SEQ_PITCH_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_DD_SEQ_SA_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_DD_SEQ_PITCH_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en5:1;
+unsigned int     interlace:1;
+unsigned int     write_en4:1;
+unsigned int     bot:1;
+unsigned int     reserved_1:8;
+unsigned int     write_en2:1;
+unsigned int     c:7;
+unsigned int     write_en1:1;
+unsigned int     y:7;
+}VO_WB_INDEX;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_WB_SEQ_SA_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_WB_SEQ_PITCH_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_WB_SEQ_SA_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_WB_SEQ_PITCH_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_DD_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_WB_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_FS_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     num:8;
+}VO_WB_TPC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     offset:13;
+unsigned int     phase:16;
+}VO_DDWB_VSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_DDWB_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_DDWB_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_DDWB_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_DDWB_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     offset:13;
+unsigned int     phase:16;
+}VO_DDWB_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_DDWB_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_DDWB_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_DDWB_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_DDWB_HSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     mode_10b:1;
+unsigned int     ppc10b:1;
+unsigned int     wb_nv21:1;
+unsigned int     wb_seq:1;
+unsigned int     h2v:1;
+unsigned int     hd:1;
+unsigned int     reserved_1:1;
+unsigned int     reint:1;
+unsigned int     bot:1;
+unsigned int     wb_f420:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     reserved_2:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     write_data:1;
+}VO_WB2_CFG;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     write_en2:1;
+unsigned int     hs_en:1;
+unsigned int     reserved_1:2;
+unsigned int     write_en1:1;
+unsigned int     vs_en:1;
+}VO_WB2_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en5:1;
+unsigned int     interlace:1;
+unsigned int     write_en4:1;
+unsigned int     bot:1;
+unsigned int     reserved_1:8;
+unsigned int     write_en2:1;
+unsigned int     c:7;
+unsigned int     write_en1:1;
+unsigned int     y:7;
+}VO_WB2_INDEX;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_WB2_SEQ_SA_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_WB2_SEQ_PITCH_Y;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_WB2_SEQ_SA_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_WB2_SEQ_PITCH_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_WB2_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     num:8;
+}VO_WB2_TPC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     offset:13;
+unsigned int     phase:16;
+}VO_WB2_VSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_WB2_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_WB2_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_WB2_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_WB2_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     offset:13;
+unsigned int     phase:16;
+}VO_WB2_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_WB2_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_WB2_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_WB2_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_WB2_HSCC;
+
+typedef struct 
+{
+unsigned int     a:32;
+}VO_VBI;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     l:18;
+}VO_VBI_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     write_en6:1;
+unsigned int     w_l:6;
+unsigned int     write_en5:1;
+unsigned int     rdata_as_mode:1;
+unsigned int     write_en4:1;
+unsigned int     num_req_8:1;
+unsigned int     write_en3:1;
+unsigned int     dyn_id:1;
+unsigned int     write_en2:1;
+unsigned int     ref_mix:1;
+unsigned int     reserved_1:1;
+unsigned int     write_en1:1;
+unsigned int     l:6;
+}VO_DMA;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     wb2:4;
+unsigned int     wb1:4;
+unsigned int     vbi:4;
+unsigned int     dd:4;
+unsigned int     v2:4;
+unsigned int     v1:4;
+}VO_DMA_PV;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     csr:4;
+unsigned int     sub2:4;
+unsigned int     osd1:4;
+unsigned int     sub1:4;
+}VO_DMA_PG;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en3:1;
+unsigned int     init:8;
+unsigned int     reserved_1:3;
+unsigned int     write_en2:1;
+unsigned int     interval:8;
+unsigned int     reserved_2:2;
+unsigned int     write_en1:1;
+unsigned int     num:5;
+}VO_DMA_BWC;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     update:1;
+unsigned int     write_data:1;
+}VO_DMA_UPDATE;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V1_Y0;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V1_Y1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V1_Y2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V1_Y3;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V1_C0;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V1_C1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V1_C2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V1_C3;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V1DI;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V2_Y0;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V2_Y1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V2_Y2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V2_Y3;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V2_C0;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V2_C1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V2_C2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V2_C3;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_V2DI;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_SUB1_WI;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_SUB1_D0;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_SUB1_D1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_OSD1_WI;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_OSD1_D0;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_OSD1_D1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_SUB2_WI;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_SUB2_D0;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_SUB2_D1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_CSR;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_DD_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_DD_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     depth:10;
+unsigned int     reserved_1:4;
+unsigned int     sa:12;
+}VO_DMA_VBI;
+
+typedef struct 
+{
+unsigned int     flush_thd:8;
+unsigned int     reserved_0:4;
+unsigned int     depth:8;
+unsigned int     reserved_1:3;
+unsigned int     sa:9;
+}VO_DMA_WB1_Y;
+
+typedef struct 
+{
+unsigned int     flush_thd:8;
+unsigned int     reserved_0:4;
+unsigned int     depth:8;
+unsigned int     reserved_1:3;
+unsigned int     sa:9;
+}VO_DMA_WB1_C;
+
+typedef struct 
+{
+unsigned int     flush_thd:8;
+unsigned int     reserved_0:4;
+unsigned int     depth:8;
+unsigned int     reserved_1:3;
+unsigned int     sa:9;
+}VO_DMA_WB2_Y;
+
+typedef struct 
+{
+unsigned int     flush_thd:8;
+unsigned int     reserved_0:4;
+unsigned int     depth:8;
+unsigned int     reserved_1:3;
+unsigned int     sa:9;
+}VO_DMA_WB2_C;
+
+typedef struct 
+{
+unsigned int     flush_thd:8;
+unsigned int     reserved_0:4;
+unsigned int     depth:8;
+unsigned int     reserved_1:3;
+unsigned int     sa:9;
+}VO_DMA_WB_V1;
+
+typedef struct 
+{
+unsigned int     flush_thd:8;
+unsigned int     reserved_0:4;
+unsigned int     depth:8;
+unsigned int     reserved_1:3;
+unsigned int     sa:9;
+}VO_DMA_WB_V2;
+
+typedef struct 
+{
+unsigned int     csr:4;
+unsigned int     sub2:4;
+unsigned int     osd1:4;
+unsigned int     v2:4;
+unsigned int     sub1:4;
+unsigned int     v1:4;
+unsigned int     reserved_0:4;
+unsigned int     reserved_1:4;
+}VO_MIX_ORDER;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     cd:1;
+unsigned int     cu:1;
+unsigned int     tr:1;
+unsigned int     v2b:1;
+unsigned int     v1b:1;
+unsigned int     write_data:1;
+}VO_MIX;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     cr:10;
+unsigned int     cb:10;
+unsigned int     y:10;
+}VO_M1BG;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     w:13;
+unsigned int     reserved_1:3;
+unsigned int     h:13;
+}VO_M1_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     cr:10;
+unsigned int     cb:10;
+unsigned int     y:10;
+}VO_M2BG;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     w:13;
+unsigned int     reserved_1:3;
+unsigned int     h:13;
+}VO_M2_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     cr:10;
+unsigned int     cb:10;
+unsigned int     y:10;
+}VO_MDDBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     w:13;
+unsigned int     reserved_1:3;
+unsigned int     h:13;
+}VO_MDD_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_V1_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     cr:10;
+unsigned int     cb:10;
+unsigned int     y:10;
+}VO_V1B_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V1B_X;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V1B_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     dir_r:1;
+unsigned int     offset_r:13;
+unsigned int     reserved_1:2;
+unsigned int     dir_l:1;
+unsigned int     offset_l:13;
+}VO_V1_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_V2_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     cr:10;
+unsigned int     cb:10;
+unsigned int     y:10;
+}VO_V2B_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V2B_X;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V2B_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     y:8;
+unsigned int     cb:8;
+unsigned int     cr:8;
+}VO_V2BG_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V2BG_X;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V2BG_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     dir_r:1;
+unsigned int     offset_r:13;
+unsigned int     reserved_1:2;
+unsigned int     dir_l:1;
+unsigned int     offset_l:13;
+}VO_V2_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_SUB1_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     dir_r:1;
+unsigned int     offset_r:13;
+unsigned int     reserved_1:2;
+unsigned int     dir_l:1;
+unsigned int     offset_l:13;
+}VO_SUB1_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_SUB2_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     dir_r:1;
+unsigned int     offset_r:13;
+unsigned int     reserved_1:2;
+unsigned int     dir_l:1;
+unsigned int     offset_l:13;
+}VO_SUB2_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_OSD1_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     dir_r:1;
+unsigned int     offset_r:13;
+unsigned int     reserved_1:2;
+unsigned int     dir_l:1;
+unsigned int     offset_l:13;
+}VO_OSD1_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_CSR_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     dir_r:1;
+unsigned int     offset_r:13;
+unsigned int     reserved_1:2;
+unsigned int     dir_l:1;
+unsigned int     offset_l:13;
+}VO_CSR_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_DD_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     th:11;
+unsigned int     write_en1:1;
+unsigned int     b:11;
+}VO_CH1_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     th:11;
+unsigned int     write_en1:1;
+unsigned int     b:11;
+}VO_CH2_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     th:11;
+unsigned int     write_en1:1;
+unsigned int     b:11;
+}VO_CH3_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     top:1;
+unsigned int     reint:1;
+unsigned int     write_data:1;
+}VO_CH1;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     top:1;
+unsigned int     reint:1;
+unsigned int     write_data:1;
+}VO_CH2;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     top:1;
+unsigned int     reint:1;
+unsigned int     write_data:1;
+}VO_CH3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_PORT_L_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_PORT_L_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_PORT_L_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_PORT_L_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_PORT_L_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     a1:12;
+unsigned int     a0:12;
+}VO_PORT_L_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     a2:12;
+}VO_PORT_L_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     rmax:10;
+unsigned int     rmin:10;
+}VO_PORT_L_LMT_R;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     gmax:10;
+unsigned int     gmin:10;
+}VO_PORT_L_LMT_G;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     bmax:10;
+unsigned int     bmin:10;
+}VO_PORT_L_LMT_B;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     pport:1;
+}VO_PORT_L_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_PORT_I_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_PORT_I_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_PORT_I_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_PORT_I_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_PORT_I_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     a2:9;
+unsigned int     a1:9;
+unsigned int     a0:9;
+}VO_PORT_I_CC6;
+
+typedef struct 
+{
+unsigned int     cmax:8;
+unsigned int     cmin:8;
+unsigned int     ymax:8;
+unsigned int     ymin:8;
+}VO_PORT_I_LMT;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m00:18;
+}VO_PORT_H_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m01:18;
+}VO_PORT_H_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m02:18;
+}VO_PORT_H_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m10:18;
+}VO_PORT_H_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m11:18;
+}VO_PORT_H_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m12:18;
+}VO_PORT_H_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m20:18;
+}VO_PORT_H_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m21:18;
+}VO_PORT_H_CC8;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m22:18;
+}VO_PORT_H_CC9;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     a1:13;
+unsigned int     reserved_1:1;
+unsigned int     a0:13;
+}VO_PORT_H_CC10;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     a2:13;
+}VO_PORT_H_CC11;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ymax:12;
+unsigned int     reserved_1:4;
+unsigned int     ymin:12;
+}VO_PORT_H_LMT_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     cmax:12;
+unsigned int     reserved_1:4;
+unsigned int     cmin:12;
+}VO_PORT_H_LMT_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     lvds:1;
+unsigned int     write_data:1;
+}VO_SYNC;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     lvds:8;
+}VO_SYNC_DELAY;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     afbc:1;
+unsigned int     h_under:1;
+unsigned int     i_under:1;
+unsigned int     p_under:1;
+unsigned int     sub2:1;
+unsigned int     sub1:1;
+unsigned int     wb2fin:1;
+unsigned int     wb1fin:1;
+unsigned int     m3fin:1;
+unsigned int     m2fin:1;
+unsigned int     m1fin:1;
+unsigned int     write_data:1;
+}VO_INTEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     reserved_1:1;
+unsigned int     afbc_parser_fail:1;
+unsigned int     afbc_decode_fail:1;
+unsigned int     h_under:1;
+unsigned int     i_under:1;
+unsigned int     p_under:1;
+unsigned int     sub2:1;
+unsigned int     sub1:1;
+unsigned int     wb2fin:1;
+unsigned int     wb1fin:1;
+unsigned int     m3fin:1;
+unsigned int     m2fin:1;
+unsigned int     m1fin:1;
+unsigned int     write_data:1;
+}VO_INTST;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     tve_h_fetch:1;
+unsigned int     tve_i_fetch:1;
+unsigned int     tve_p_fetch:1;
+unsigned int     reserved_1:1;
+unsigned int     dd:1;
+unsigned int     csr:1;
+unsigned int     sub2:1;
+unsigned int     osd1:1;
+unsigned int     sub1:1;
+unsigned int     v2:1;
+unsigned int     v1:1;
+unsigned int     wb2:1;
+unsigned int     wb1:1;
+unsigned int     mixdd:1;
+unsigned int     mix2:1;
+unsigned int     mix1:1;
+}VO_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     udf_en:1;
+unsigned int     disp_en:1;
+unsigned int     delay_en:1;
+}VO_MON_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     wb2:1;
+unsigned int     wb1:1;
+unsigned int     reserved_1:1;
+unsigned int     dd:1;
+unsigned int     csr:1;
+unsigned int     sub2:1;
+unsigned int     osd1:1;
+unsigned int     sub1:1;
+unsigned int     v2:1;
+unsigned int     v1:1;
+unsigned int     ch3:1;
+unsigned int     ch2:1;
+unsigned int     ch1:1;
+unsigned int     reserved_2:6;
+unsigned int     th:10;
+}VO_MON_SETUP;
+
+typedef struct 
+{
+unsigned int     delay:16;
+unsigned int     reserved_0:6;
+unsigned int     wb2:1;
+unsigned int     wb1:1;
+unsigned int     reserved_1:1;
+unsigned int     dd:1;
+unsigned int     csr:1;
+unsigned int     sub2:1;
+unsigned int     osd1:1;
+unsigned int     sub1:1;
+unsigned int     v2:1;
+unsigned int     v1:1;
+}VO_MON_DLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     not_full:13;
+}VO_MON_DISP;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     y:13;
+}VO_MON_UF_I;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     y:13;
+}VO_MON_UF_P;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     y:13;
+}VO_MON_UF_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     cnt:10;
+}VO_MON_UF_V1;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     cnt:10;
+}VO_MON_UF_V2;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}VO_MON_UF_SUB1;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}VO_MON_UF_OSD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}VO_MON_UF_SUB2;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}VO_MON_UF_CSR;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     write_en3:1;
+unsigned int     sel1:8;
+unsigned int     reserved_1:3;
+unsigned int     write_en2:1;
+unsigned int     sel0:8;
+unsigned int     reserved_2:2;
+unsigned int     write_en1:1;
+unsigned int     en:1;
+}VO_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     fix_l:1;
+unsigned int     fix_h:1;
+unsigned int     ramp_8:1;
+unsigned int     ramp_4:1;
+unsigned int     ramp_2:1;
+unsigned int     ramp_1:1;
+unsigned int     go:1;
+unsigned int     en:1;
+unsigned int     write_data:1;
+}VO_DACT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     hld_time:8;
+unsigned int     reserved_1:6;
+unsigned int     mode:2;
+}VO_DACT_RAMP;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     l:11;
+}VO_DACT_L;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     a:10;
+}VO_DACT_R;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     a:10;
+}VO_DACT_A;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     d:16;
+}VO_DACT_D;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     en:1;
+unsigned int     write_data:1;
+}VO_RBRAM;
+
+typedef struct 
+{
+unsigned int     mode:32;
+}VO_VERF;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     rme_2:1;
+unsigned int     rm_2:4;
+unsigned int     reserved_1:3;
+unsigned int     rme_1:1;
+unsigned int     rm_1:4;
+}VO_SRAM_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     drf_start_pause_5:1;
+unsigned int     drf_test_resume_5:1;
+unsigned int     drf_bist_mode_5:1;
+unsigned int     bist_mode_5:1;
+unsigned int     drf_start_pause_4:1;
+unsigned int     drf_test_resume_4:1;
+unsigned int     drf_bist_mode_4:1;
+unsigned int     bist_mode_4:1;
+unsigned int     drf_start_pause_3:1;
+unsigned int     drf_test_resume_3:1;
+unsigned int     drf_bist_mode_3:1;
+unsigned int     bist_mode_3:1;
+unsigned int     drf_start_pause_2:1;
+unsigned int     drf_test_resume_2:1;
+unsigned int     drf_bist_mode_2:1;
+unsigned int     bist_mode_2:1;
+unsigned int     drf_start_pause_1:1;
+unsigned int     drf_test_resume_1:1;
+unsigned int     drf_bist_mode_1:1;
+unsigned int     bist_mode_1:1;
+}VO_MBIST;
+
+typedef struct 
+{
+unsigned int     drf_start_pause_13:1;
+unsigned int     drf_test_resume_13:1;
+unsigned int     drf_bist_mode_13:1;
+unsigned int     bist_mode_13:1;
+unsigned int     drf_start_pause_12:1;
+unsigned int     drf_test_resume_12:1;
+unsigned int     drf_bist_mode_12:1;
+unsigned int     bist_mode_12:1;
+unsigned int     drf_start_pause_11:1;
+unsigned int     drf_test_resume_11:1;
+unsigned int     drf_bist_mode_11:1;
+unsigned int     bist_mode_11:1;
+unsigned int     drf_start_pause_10:1;
+unsigned int     drf_test_resume_10:1;
+unsigned int     drf_bist_mode_10:1;
+unsigned int     bist_mode_10:1;
+unsigned int     drf_start_pause_9:1;
+unsigned int     drf_test_resume_9:1;
+unsigned int     drf_bist_mode_9:1;
+unsigned int     bist_mode_9:1;
+unsigned int     drf_start_pause_8:1;
+unsigned int     drf_test_resume_8:1;
+unsigned int     drf_bist_mode_8:1;
+unsigned int     bist_mode_8:1;
+unsigned int     drf_start_pause_7:1;
+unsigned int     drf_test_resume_7:1;
+unsigned int     drf_bist_mode_7:1;
+unsigned int     bist_mode_7:1;
+unsigned int     drf_start_pause_6:1;
+unsigned int     drf_test_resume_6:1;
+unsigned int     drf_bist_mode_6:1;
+unsigned int     bist_mode_6:1;
+}VO_MBIST_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     drf_start_pause_15:1;
+unsigned int     drf_test_resume_15:1;
+unsigned int     drf_bist_mode_15:1;
+unsigned int     bist_mode_15:1;
+unsigned int     drf_start_pause_14:1;
+unsigned int     drf_test_resume_14:1;
+unsigned int     drf_bist_mode_14:1;
+unsigned int     bist_mode_14:1;
+}VO_MBIST_2;
+
+typedef struct 
+{
+unsigned int     fail_5_2:1;
+unsigned int     fail_5_1:1;
+unsigned int     fail_5_0:1;
+unsigned int     fail_4_4:1;
+unsigned int     fail_4_3:1;
+unsigned int     fail_4_2:1;
+unsigned int     fail_4_1:1;
+unsigned int     fail_4_0:1;
+unsigned int     fail_3_3:1;
+unsigned int     fail_3_2:1;
+unsigned int     fail_3_1:1;
+unsigned int     fail_3_0:1;
+unsigned int     fail_2_6:1;
+unsigned int     fail_2_5:1;
+unsigned int     fail_2_4:1;
+unsigned int     fail_2_3:1;
+unsigned int     fail_2_2:1;
+unsigned int     fail_2_1:1;
+unsigned int     fail_2_0:1;
+unsigned int     fail_1_6:1;
+unsigned int     fail_1_5:1;
+unsigned int     fail_1_4:1;
+unsigned int     fail_1_3:1;
+unsigned int     fail_1_2:1;
+unsigned int     fail_1_1:1;
+unsigned int     fail_1_0:1;
+unsigned int     reserved_0:1;
+unsigned int     done_5:1;
+unsigned int     done_4:1;
+unsigned int     done_3:1;
+unsigned int     done_2:1;
+unsigned int     done_1:1;
+}VO_MBIST_OUT;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     fail_9_9:1;
+unsigned int     fail_9_8:1;
+unsigned int     fail_9_7:1;
+unsigned int     fail_9_6:1;
+unsigned int     fail_9_5:1;
+unsigned int     fail_9_4:1;
+unsigned int     fail_9_3:1;
+unsigned int     fail_9_2:1;
+unsigned int     fail_9_1:1;
+unsigned int     fail_9_0:1;
+unsigned int     fail_8_3:1;
+unsigned int     fail_8_2:1;
+unsigned int     fail_8_1:1;
+unsigned int     fail_8_0:1;
+unsigned int     fail_7_3:1;
+unsigned int     fail_7_2:1;
+unsigned int     fail_7_1:1;
+unsigned int     fail_7_0:1;
+unsigned int     fail_6_3:1;
+unsigned int     fail_6_2:1;
+unsigned int     fail_6_1:1;
+unsigned int     fail_6_0:1;
+unsigned int     fail_4_6:1;
+unsigned int     fail_4_5:1;
+unsigned int     reserved_1:2;
+unsigned int     done_9:1;
+unsigned int     done_8:1;
+unsigned int     done_7:1;
+unsigned int     done_6:1;
+}VO_MBIST_OUT_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     fail_15_2:1;
+unsigned int     fail_15_1:1;
+unsigned int     fail_15_0:1;
+unsigned int     fail_14_2:1;
+unsigned int     fail_14_1:1;
+unsigned int     fail_14_0:1;
+unsigned int     fail_13_5:1;
+unsigned int     fail_13_4:1;
+unsigned int     fail_13_3:1;
+unsigned int     fail_13_2:1;
+unsigned int     fail_13_1:1;
+unsigned int     fail_13_0:1;
+unsigned int     fail_12_1:1;
+unsigned int     fail_12_0:1;
+unsigned int     fail_11_5:1;
+unsigned int     fail_11_4:1;
+unsigned int     fail_11_3:1;
+unsigned int     fail_11_2:1;
+unsigned int     fail_11_1:1;
+unsigned int     fail_11_0:1;
+unsigned int     fail_10_1:1;
+unsigned int     fail_10_0:1;
+unsigned int     reserved_1:2;
+unsigned int     done_15:1;
+unsigned int     done_14:1;
+unsigned int     done_13:1;
+unsigned int     done_12:1;
+unsigned int     done_11:1;
+unsigned int     done_10:1;
+}VO_MBIST_OUT_2;
+
+typedef struct 
+{
+unsigned int     fail_5_2:1;
+unsigned int     fail_5_1:1;
+unsigned int     fail_5_0:1;
+unsigned int     fail_4_4:1;
+unsigned int     fail_4_3:1;
+unsigned int     fail_4_2:1;
+unsigned int     fail_4_1:1;
+unsigned int     fail_4_0:1;
+unsigned int     fail_3_3:1;
+unsigned int     fail_3_2:1;
+unsigned int     fail_3_1:1;
+unsigned int     fail_3_0:1;
+unsigned int     fail_2_6:1;
+unsigned int     fail_2_5:1;
+unsigned int     fail_2_4:1;
+unsigned int     fail_2_3:1;
+unsigned int     fail_2_2:1;
+unsigned int     fail_2_1:1;
+unsigned int     fail_2_0:1;
+unsigned int     fail_1_6:1;
+unsigned int     fail_1_5:1;
+unsigned int     fail_1_4:1;
+unsigned int     fail_1_3:1;
+unsigned int     fail_1_2:1;
+unsigned int     fail_1_1:1;
+unsigned int     fail_1_0:1;
+unsigned int     reserved_0:1;
+unsigned int     done_5:1;
+unsigned int     done_4:1;
+unsigned int     done_3:1;
+unsigned int     done_2:1;
+unsigned int     done_1:1;
+}VO_DRF_MBIST_OUT;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     fail_9_9:1;
+unsigned int     fail_9_8:1;
+unsigned int     fail_9_7:1;
+unsigned int     fail_9_6:1;
+unsigned int     fail_9_5:1;
+unsigned int     fail_9_4:1;
+unsigned int     fail_9_3:1;
+unsigned int     fail_9_2:1;
+unsigned int     fail_9_1:1;
+unsigned int     fail_9_0:1;
+unsigned int     fail_8_3:1;
+unsigned int     fail_8_2:1;
+unsigned int     fail_8_1:1;
+unsigned int     fail_8_0:1;
+unsigned int     fail_7_3:1;
+unsigned int     fail_7_2:1;
+unsigned int     fail_7_1:1;
+unsigned int     fail_7_0:1;
+unsigned int     fail_6_3:1;
+unsigned int     fail_6_2:1;
+unsigned int     fail_6_1:1;
+unsigned int     fail_6_0:1;
+unsigned int     fail_4_6:1;
+unsigned int     fail_4_5:1;
+unsigned int     reserved_1:2;
+unsigned int     done_9:1;
+unsigned int     done_8:1;
+unsigned int     done_7:1;
+unsigned int     done_6:1;
+}VO_DRF_MBIST_OUT_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     fail_15_2:1;
+unsigned int     fail_15_1:1;
+unsigned int     fail_15_0:1;
+unsigned int     fail_14_2:1;
+unsigned int     fail_14_1:1;
+unsigned int     fail_14_0:1;
+unsigned int     fail_13_5:1;
+unsigned int     fail_13_4:1;
+unsigned int     fail_13_3:1;
+unsigned int     fail_13_2:1;
+unsigned int     fail_13_1:1;
+unsigned int     fail_13_0:1;
+unsigned int     fail_12_1:1;
+unsigned int     fail_12_0:1;
+unsigned int     fail_11_5:1;
+unsigned int     fail_11_4:1;
+unsigned int     fail_11_3:1;
+unsigned int     fail_11_2:1;
+unsigned int     fail_11_1:1;
+unsigned int     fail_11_0:1;
+unsigned int     fail_10_1:1;
+unsigned int     fail_10_0:1;
+unsigned int     reserved_1:2;
+unsigned int     done_15:1;
+unsigned int     done_14:1;
+unsigned int     done_13:1;
+unsigned int     done_12:1;
+unsigned int     done_11:1;
+unsigned int     done_10:1;
+}VO_DRF_MBIST_OUT_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     afbc:1;
+unsigned int     sub2:1;
+unsigned int     wb2:1;
+unsigned int     csr:1;
+unsigned int     v2:1;
+unsigned int     vo_buf:1;
+unsigned int     wb_dd:1;
+unsigned int     sub:1;
+unsigned int     osd:1;
+unsigned int     v1:1;
+}VO_SRAM_LS;
+
+#endif
+
+#define VO_MODE                                                                      0x98005000
+#define VO_MODE_reg_addr                                                             "0xD8005000"
+#define VO_MODE_reg                                                                  0xD8005000
+#define set_VO_MODE_reg(data)   (*((volatile unsigned int*) VO_MODE_reg)=data)
+#define get_VO_MODE_reg   (*((volatile unsigned int*) VO_MODE_reg))
+#define VO_MODE_inst_adr                                                             "0x0000"
+#define VO_MODE_inst                                                                 0x0000
+#define VO_MODE_v2_dynamic_sram_ls_enable_shift                                      (20)
+#define VO_MODE_v2_dynamic_sram_ls_enable_mask                                       (0x00100000)
+#define VO_MODE_v2_dynamic_sram_ls_enable(data)                                      (0x00100000&((data)<<20))
+#define VO_MODE_v2_dynamic_sram_ls_enable_src(data)                                  ((0x00100000&(data))>>20)
+#define VO_MODE_get_v2_dynamic_sram_ls_enable(data)                                  ((0x00100000&(data))>>20)
+#define VO_MODE_v1_dynamic_sram_ls_enable_shift                                      (19)
+#define VO_MODE_v1_dynamic_sram_ls_enable_mask                                       (0x00080000)
+#define VO_MODE_v1_dynamic_sram_ls_enable(data)                                      (0x00080000&((data)<<19))
+#define VO_MODE_v1_dynamic_sram_ls_enable_src(data)                                  ((0x00080000&(data))>>19)
+#define VO_MODE_get_v1_dynamic_sram_ls_enable(data)                                  ((0x00080000&(data))>>19)
+#define VO_MODE_sub2_dynamic_sram_ls_enable_shift                                    (18)
+#define VO_MODE_sub2_dynamic_sram_ls_enable_mask                                     (0x00040000)
+#define VO_MODE_sub2_dynamic_sram_ls_enable(data)                                    (0x00040000&((data)<<18))
+#define VO_MODE_sub2_dynamic_sram_ls_enable_src(data)                                ((0x00040000&(data))>>18)
+#define VO_MODE_get_sub2_dynamic_sram_ls_enable(data)                                ((0x00040000&(data))>>18)
+#define VO_MODE_sub1_dynamic_sram_ls_enable_shift                                    (17)
+#define VO_MODE_sub1_dynamic_sram_ls_enable_mask                                     (0x00020000)
+#define VO_MODE_sub1_dynamic_sram_ls_enable(data)                                    (0x00020000&((data)<<17))
+#define VO_MODE_sub1_dynamic_sram_ls_enable_src(data)                                ((0x00020000&(data))>>17)
+#define VO_MODE_get_sub1_dynamic_sram_ls_enable(data)                                ((0x00020000&(data))>>17)
+#define VO_MODE_osd_dynamic_sram_ls_enable_shift                                     (16)
+#define VO_MODE_osd_dynamic_sram_ls_enable_mask                                      (0x00010000)
+#define VO_MODE_osd_dynamic_sram_ls_enable(data)                                     (0x00010000&((data)<<16))
+#define VO_MODE_osd_dynamic_sram_ls_enable_src(data)                                 ((0x00010000&(data))>>16)
+#define VO_MODE_get_osd_dynamic_sram_ls_enable(data)                                 ((0x00010000&(data))>>16)
+#define VO_MODE_dispbuf_dynamic_sram_ls_enable_shift                                 (15)
+#define VO_MODE_dispbuf_dynamic_sram_ls_enable_mask                                  (0x00008000)
+#define VO_MODE_dispbuf_dynamic_sram_ls_enable(data)                                 (0x00008000&((data)<<15))
+#define VO_MODE_dispbuf_dynamic_sram_ls_enable_src(data)                             ((0x00008000&(data))>>15)
+#define VO_MODE_get_dispbuf_dynamic_sram_ls_enable(data)                             ((0x00008000&(data))>>15)
+#define VO_MODE_dma_dynamic_sram_ls_enable_shift                                     (14)
+#define VO_MODE_dma_dynamic_sram_ls_enable_mask                                      (0x00004000)
+#define VO_MODE_dma_dynamic_sram_ls_enable(data)                                     (0x00004000&((data)<<14))
+#define VO_MODE_dma_dynamic_sram_ls_enable_src(data)                                 ((0x00004000&(data))>>14)
+#define VO_MODE_get_dma_dynamic_sram_ls_enable(data)                                 ((0x00004000&(data))>>14)
+#define VO_MODE_wb2_dynamic_sram_ls_enable_shift                                     (13)
+#define VO_MODE_wb2_dynamic_sram_ls_enable_mask                                      (0x00002000)
+#define VO_MODE_wb2_dynamic_sram_ls_enable(data)                                     (0x00002000&((data)<<13))
+#define VO_MODE_wb2_dynamic_sram_ls_enable_src(data)                                 ((0x00002000&(data))>>13)
+#define VO_MODE_get_wb2_dynamic_sram_ls_enable(data)                                 ((0x00002000&(data))>>13)
+#define VO_MODE_dwa_dynamic_sram_ls_enable_shift                                     (12)
+#define VO_MODE_dwa_dynamic_sram_ls_enable_mask                                      (0x00001000)
+#define VO_MODE_dwa_dynamic_sram_ls_enable(data)                                     (0x00001000&((data)<<12))
+#define VO_MODE_dwa_dynamic_sram_ls_enable_src(data)                                 ((0x00001000&(data))>>12)
+#define VO_MODE_get_dwa_dynamic_sram_ls_enable(data)                                 ((0x00001000&(data))>>12)
+#define VO_MODE_csr_dynamic_sram_ls_enable_shift                                     (11)
+#define VO_MODE_csr_dynamic_sram_ls_enable_mask                                      (0x00000800)
+#define VO_MODE_csr_dynamic_sram_ls_enable(data)                                     (0x00000800&((data)<<11))
+#define VO_MODE_csr_dynamic_sram_ls_enable_src(data)                                 ((0x00000800&(data))>>11)
+#define VO_MODE_get_csr_dynamic_sram_ls_enable(data)                                 ((0x00000800&(data))>>11)
+#define VO_MODE_sram_gating_enable_shift                                             (10)
+#define VO_MODE_sram_gating_enable_mask                                              (0x00000400)
+#define VO_MODE_sram_gating_enable(data)                                             (0x00000400&((data)<<10))
+#define VO_MODE_sram_gating_enable_src(data)                                         ((0x00000400&(data))>>10)
+#define VO_MODE_get_sram_gating_enable(data)                                         ((0x00000400&(data))>>10)
+#define VO_MODE_wb2_gating_enable_shift                                              (9)
+#define VO_MODE_wb2_gating_enable_mask                                               (0x00000200)
+#define VO_MODE_wb2_gating_enable(data)                                              (0x00000200&((data)<<9))
+#define VO_MODE_wb2_gating_enable_src(data)                                          ((0x00000200&(data))>>9)
+#define VO_MODE_get_wb2_gating_enable(data)                                          ((0x00000200&(data))>>9)
+#define VO_MODE_dwa_gating_enable_shift                                              (8)
+#define VO_MODE_dwa_gating_enable_mask                                               (0x00000100)
+#define VO_MODE_dwa_gating_enable(data)                                              (0x00000100&((data)<<8))
+#define VO_MODE_dwa_gating_enable_src(data)                                          ((0x00000100&(data))>>8)
+#define VO_MODE_get_dwa_gating_enable(data)                                          ((0x00000100&(data))>>8)
+#define VO_MODE_dma_gating_enable_shift                                              (7)
+#define VO_MODE_dma_gating_enable_mask                                               (0x00000080)
+#define VO_MODE_dma_gating_enable(data)                                              (0x00000080&((data)<<7))
+#define VO_MODE_dma_gating_enable_src(data)                                          ((0x00000080&(data))>>7)
+#define VO_MODE_get_dma_gating_enable(data)                                          ((0x00000080&(data))>>7)
+#define VO_MODE_shut_down_enable_shift                                               (6)
+#define VO_MODE_shut_down_enable_mask                                                (0x00000040)
+#define VO_MODE_shut_down_enable(data)                                               (0x00000040&((data)<<6))
+#define VO_MODE_shut_down_enable_src(data)                                           ((0x00000040&(data))>>6)
+#define VO_MODE_get_shut_down_enable(data)                                           ((0x00000040&(data))>>6)
+#define VO_MODE_gating_enable_shift                                                  (5)
+#define VO_MODE_gating_enable_mask                                                   (0x00000020)
+#define VO_MODE_gating_enable(data)                                                  (0x00000020&((data)<<5))
+#define VO_MODE_gating_enable_src(data)                                              ((0x00000020&(data))>>5)
+#define VO_MODE_get_gating_enable(data)                                              ((0x00000020&(data))>>5)
+#define VO_MODE_ch3_shift                                                            (3)
+#define VO_MODE_ch3_mask                                                             (0x00000008)
+#define VO_MODE_ch3(data)                                                            (0x00000008&((data)<<3))
+#define VO_MODE_ch3_src(data)                                                        ((0x00000008&(data))>>3)
+#define VO_MODE_get_ch3(data)                                                        ((0x00000008&(data))>>3)
+#define VO_MODE_ch2_shift                                                            (2)
+#define VO_MODE_ch2_mask                                                             (0x00000004)
+#define VO_MODE_ch2(data)                                                            (0x00000004&((data)<<2))
+#define VO_MODE_ch2_src(data)                                                        ((0x00000004&(data))>>2)
+#define VO_MODE_get_ch2(data)                                                        ((0x00000004&(data))>>2)
+#define VO_MODE_ch1_shift                                                            (1)
+#define VO_MODE_ch1_mask                                                             (0x00000002)
+#define VO_MODE_ch1(data)                                                            (0x00000002&((data)<<1))
+#define VO_MODE_ch1_src(data)                                                        ((0x00000002&(data))>>1)
+#define VO_MODE_get_ch1(data)                                                        ((0x00000002&(data))>>1)
+#define VO_MODE_write_data_shift                                                     (0)
+#define VO_MODE_write_data_mask                                                      (0x00000001)
+#define VO_MODE_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_MODE_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_MODE_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_OUT                                                                       0x98005004
+#define VO_OUT_reg_addr                                                              "0xD8005004"
+#define VO_OUT_reg                                                                   0xD8005004
+#define set_VO_OUT_reg(data)   (*((volatile unsigned int*) VO_OUT_reg)=data)
+#define get_VO_OUT_reg   (*((volatile unsigned int*) VO_OUT_reg))
+#define VO_OUT_inst_adr                                                              "0x0001"
+#define VO_OUT_inst                                                                  0x0001
+#define VO_OUT_write_en3_shift                                                       (10)
+#define VO_OUT_write_en3_mask                                                        (0x00000400)
+#define VO_OUT_write_en3(data)                                                       (0x00000400&((data)<<10))
+#define VO_OUT_write_en3_src(data)                                                   ((0x00000400&(data))>>10)
+#define VO_OUT_get_write_en3(data)                                                   ((0x00000400&(data))>>10)
+#define VO_OUT_h_shift                                                               (8)
+#define VO_OUT_h_mask                                                                (0x00000300)
+#define VO_OUT_h(data)                                                               (0x00000300&((data)<<8))
+#define VO_OUT_h_src(data)                                                           ((0x00000300&(data))>>8)
+#define VO_OUT_get_h(data)                                                           ((0x00000300&(data))>>8)
+#define VO_OUT_write_en2_shift                                                       (6)
+#define VO_OUT_write_en2_mask                                                        (0x00000040)
+#define VO_OUT_write_en2(data)                                                       (0x00000040&((data)<<6))
+#define VO_OUT_write_en2_src(data)                                                   ((0x00000040&(data))>>6)
+#define VO_OUT_get_write_en2(data)                                                   ((0x00000040&(data))>>6)
+#define VO_OUT_i_shift                                                               (4)
+#define VO_OUT_i_mask                                                                (0x00000030)
+#define VO_OUT_i(data)                                                               (0x00000030&((data)<<4))
+#define VO_OUT_i_src(data)                                                           ((0x00000030&(data))>>4)
+#define VO_OUT_get_i(data)                                                           ((0x00000030&(data))>>4)
+#define VO_OUT_write_en1_shift                                                       (2)
+#define VO_OUT_write_en1_mask                                                        (0x00000004)
+#define VO_OUT_write_en1(data)                                                       (0x00000004&((data)<<2))
+#define VO_OUT_write_en1_src(data)                                                   ((0x00000004&(data))>>2)
+#define VO_OUT_get_write_en1(data)                                                   ((0x00000004&(data))>>2)
+#define VO_OUT_p_shift                                                               (0)
+#define VO_OUT_p_mask                                                                (0x00000003)
+#define VO_OUT_p(data)                                                               (0x00000003&((data)<<0))
+#define VO_OUT_p_src(data)                                                           ((0x00000003&(data))>>0)
+#define VO_OUT_get_p(data)                                                           ((0x00000003&(data))>>0)
+
+
+#define VO_MIX12                                                                     0x98005008
+#define VO_MIX12_reg_addr                                                            "0xD8005008"
+#define VO_MIX12_reg                                                                 0xD8005008
+#define set_VO_MIX12_reg(data)   (*((volatile unsigned int*) VO_MIX12_reg)=data)
+#define get_VO_MIX12_reg   (*((volatile unsigned int*) VO_MIX12_reg))
+#define VO_MIX12_inst_adr                                                            "0x0002"
+#define VO_MIX12_inst                                                                0x0002
+#define VO_MIX12_vbi2_shift                                                          (17)
+#define VO_MIX12_vbi2_mask                                                           (0x00020000)
+#define VO_MIX12_vbi2(data)                                                          (0x00020000&((data)<<17))
+#define VO_MIX12_vbi2_src(data)                                                      ((0x00020000&(data))>>17)
+#define VO_MIX12_get_vbi2(data)                                                      ((0x00020000&(data))>>17)
+#define VO_MIX12_vbi1_shift                                                          (16)
+#define VO_MIX12_vbi1_mask                                                           (0x00010000)
+#define VO_MIX12_vbi1(data)                                                          (0x00010000&((data)<<16))
+#define VO_MIX12_vbi1_src(data)                                                      ((0x00010000&(data))>>16)
+#define VO_MIX12_get_vbi1(data)                                                      ((0x00010000&(data))>>16)
+#define VO_MIX12_csr_shift                                                           (14)
+#define VO_MIX12_csr_mask                                                            (0x0000C000)
+#define VO_MIX12_csr(data)                                                           (0x0000C000&((data)<<14))
+#define VO_MIX12_csr_src(data)                                                       ((0x0000C000&(data))>>14)
+#define VO_MIX12_get_csr(data)                                                       ((0x0000C000&(data))>>14)
+#define VO_MIX12_osd1_shift                                                          (12)
+#define VO_MIX12_osd1_mask                                                           (0x00003000)
+#define VO_MIX12_osd1(data)                                                          (0x00003000&((data)<<12))
+#define VO_MIX12_osd1_src(data)                                                      ((0x00003000&(data))>>12)
+#define VO_MIX12_get_osd1(data)                                                      ((0x00003000&(data))>>12)
+#define VO_MIX12_sub2_shift                                                          (10)
+#define VO_MIX12_sub2_mask                                                           (0x00000C00)
+#define VO_MIX12_sub2(data)                                                          (0x00000C00&((data)<<10))
+#define VO_MIX12_sub2_src(data)                                                      ((0x00000C00&(data))>>10)
+#define VO_MIX12_get_sub2(data)                                                      ((0x00000C00&(data))>>10)
+#define VO_MIX12_sub1_shift                                                          (8)
+#define VO_MIX12_sub1_mask                                                           (0x00000300)
+#define VO_MIX12_sub1(data)                                                          (0x00000300&((data)<<8))
+#define VO_MIX12_sub1_src(data)                                                      ((0x00000300&(data))>>8)
+#define VO_MIX12_get_sub1(data)                                                      ((0x00000300&(data))>>8)
+#define VO_MIX12_v2_shift                                                            (6)
+#define VO_MIX12_v2_mask                                                             (0x000000C0)
+#define VO_MIX12_v2(data)                                                            (0x000000C0&((data)<<6))
+#define VO_MIX12_v2_src(data)                                                        ((0x000000C0&(data))>>6)
+#define VO_MIX12_get_v2(data)                                                        ((0x000000C0&(data))>>6)
+#define VO_MIX12_v1_shift                                                            (4)
+#define VO_MIX12_v1_mask                                                             (0x00000030)
+#define VO_MIX12_v1(data)                                                            (0x00000030&((data)<<4))
+#define VO_MIX12_v1_src(data)                                                        ((0x00000030&(data))>>4)
+#define VO_MIX12_get_v1(data)                                                        ((0x00000030&(data))>>4)
+#define VO_MIX12_bg2_shift                                                           (2)
+#define VO_MIX12_bg2_mask                                                            (0x00000004)
+#define VO_MIX12_bg2(data)                                                           (0x00000004&((data)<<2))
+#define VO_MIX12_bg2_src(data)                                                       ((0x00000004&(data))>>2)
+#define VO_MIX12_get_bg2(data)                                                       ((0x00000004&(data))>>2)
+#define VO_MIX12_bg1_shift                                                           (1)
+#define VO_MIX12_bg1_mask                                                            (0x00000002)
+#define VO_MIX12_bg1(data)                                                           (0x00000002&((data)<<1))
+#define VO_MIX12_bg1_src(data)                                                       ((0x00000002&(data))>>1)
+#define VO_MIX12_get_bg1(data)                                                       ((0x00000002&(data))>>1)
+
+
+#define VO_MIXDD                                                                     0x9800500C
+#define VO_MIXDD_reg_addr                                                            "0xD800500C"
+#define VO_MIXDD_reg                                                                 0xD800500C
+#define set_VO_MIXDD_reg(data)   (*((volatile unsigned int*) VO_MIXDD_reg)=data)
+#define get_VO_MIXDD_reg   (*((volatile unsigned int*) VO_MIXDD_reg))
+#define VO_MIXDD_inst_adr                                                            "0x0003"
+#define VO_MIXDD_inst                                                                0x0003
+#define VO_MIXDD_vbi_shift                                                           (10)
+#define VO_MIXDD_vbi_mask                                                            (0x00000400)
+#define VO_MIXDD_vbi(data)                                                           (0x00000400&((data)<<10))
+#define VO_MIXDD_vbi_src(data)                                                       ((0x00000400&(data))>>10)
+#define VO_MIXDD_get_vbi(data)                                                       ((0x00000400&(data))>>10)
+#define VO_MIXDD_dd_shift                                                            (3)
+#define VO_MIXDD_dd_mask                                                             (0x00000008)
+#define VO_MIXDD_dd(data)                                                            (0x00000008&((data)<<3))
+#define VO_MIXDD_dd_src(data)                                                        ((0x00000008&(data))>>3)
+#define VO_MIXDD_get_dd(data)                                                        ((0x00000008&(data))>>3)
+#define VO_MIXDD_bg_shift                                                            (1)
+#define VO_MIXDD_bg_mask                                                             (0x00000002)
+#define VO_MIXDD_bg(data)                                                            (0x00000002&((data)<<1))
+#define VO_MIXDD_bg_src(data)                                                        ((0x00000002&(data))>>1)
+#define VO_MIXDD_get_bg(data)                                                        ((0x00000002&(data))>>1)
+#define VO_MIXDD_write_data_shift                                                    (0)
+#define VO_MIXDD_write_data_mask                                                     (0x00000001)
+#define VO_MIXDD_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VO_MIXDD_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_MIXDD_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_WB                                                                        0x98005010
+#define VO_WB_reg_addr                                                               "0xD8005010"
+#define VO_WB_reg                                                                    0xD8005010
+#define set_VO_WB_reg(data)   (*((volatile unsigned int*) VO_WB_reg)=data)
+#define get_VO_WB_reg   (*((volatile unsigned int*) VO_WB_reg))
+#define VO_WB_inst_adr                                                               "0x0004"
+#define VO_WB_inst                                                                   0x0004
+#define VO_WB_relay_mix_shift                                                        (9)
+#define VO_WB_relay_mix_mask                                                         (0x00000200)
+#define VO_WB_relay_mix(data)                                                        (0x00000200&((data)<<9))
+#define VO_WB_relay_mix_src(data)                                                    ((0x00000200&(data))>>9)
+#define VO_WB_get_relay_mix(data)                                                    ((0x00000200&(data))>>9)
+#define VO_WB_csr_shift                                                              (8)
+#define VO_WB_csr_mask                                                               (0x00000100)
+#define VO_WB_csr(data)                                                              (0x00000100&((data)<<8))
+#define VO_WB_csr_src(data)                                                          ((0x00000100&(data))>>8)
+#define VO_WB_get_csr(data)                                                          ((0x00000100&(data))>>8)
+#define VO_WB_osd1_shift                                                             (7)
+#define VO_WB_osd1_mask                                                              (0x00000080)
+#define VO_WB_osd1(data)                                                             (0x00000080&((data)<<7))
+#define VO_WB_osd1_src(data)                                                         ((0x00000080&(data))>>7)
+#define VO_WB_get_osd1(data)                                                         ((0x00000080&(data))>>7)
+#define VO_WB_sub2_shift                                                             (6)
+#define VO_WB_sub2_mask                                                              (0x00000040)
+#define VO_WB_sub2(data)                                                             (0x00000040&((data)<<6))
+#define VO_WB_sub2_src(data)                                                         ((0x00000040&(data))>>6)
+#define VO_WB_get_sub2(data)                                                         ((0x00000040&(data))>>6)
+#define VO_WB_sub1_shift                                                             (5)
+#define VO_WB_sub1_mask                                                              (0x00000020)
+#define VO_WB_sub1(data)                                                             (0x00000020&((data)<<5))
+#define VO_WB_sub1_src(data)                                                         ((0x00000020&(data))>>5)
+#define VO_WB_get_sub1(data)                                                         ((0x00000020&(data))>>5)
+#define VO_WB_v2_shift                                                               (4)
+#define VO_WB_v2_mask                                                                (0x00000010)
+#define VO_WB_v2(data)                                                               (0x00000010&((data)<<4))
+#define VO_WB_v2_src(data)                                                           ((0x00000010&(data))>>4)
+#define VO_WB_get_v2(data)                                                           ((0x00000010&(data))>>4)
+#define VO_WB_v1_shift                                                               (3)
+#define VO_WB_v1_mask                                                                (0x00000008)
+#define VO_WB_v1(data)                                                               (0x00000008&((data)<<3))
+#define VO_WB_v1_src(data)                                                           ((0x00000008&(data))>>3)
+#define VO_WB_get_v1(data)                                                           ((0x00000008&(data))>>3)
+#define VO_WB_mix1_shift                                                             (1)
+#define VO_WB_mix1_mask                                                              (0x00000002)
+#define VO_WB_mix1(data)                                                             (0x00000002&((data)<<1))
+#define VO_WB_mix1_src(data)                                                         ((0x00000002&(data))>>1)
+#define VO_WB_get_mix1(data)                                                         ((0x00000002&(data))>>1)
+#define VO_WB_write_data_shift                                                       (0)
+#define VO_WB_write_data_mask                                                        (0x00000001)
+#define VO_WB_write_data(data)                                                       (0x00000001&((data)<<0))
+#define VO_WB_write_data_src(data)                                                   ((0x00000001&(data))>>0)
+#define VO_WB_get_write_data(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define VO_WB2                                                                       0x98005014
+#define VO_WB2_reg_addr                                                              "0xD8005014"
+#define VO_WB2_reg                                                                   0xD8005014
+#define set_VO_WB2_reg(data)   (*((volatile unsigned int*) VO_WB2_reg)=data)
+#define get_VO_WB2_reg   (*((volatile unsigned int*) VO_WB2_reg))
+#define VO_WB2_inst_adr                                                              "0x0005"
+#define VO_WB2_inst                                                                  0x0005
+#define VO_WB2_relay_mix_shift                                                       (9)
+#define VO_WB2_relay_mix_mask                                                        (0x00000200)
+#define VO_WB2_relay_mix(data)                                                       (0x00000200&((data)<<9))
+#define VO_WB2_relay_mix_src(data)                                                   ((0x00000200&(data))>>9)
+#define VO_WB2_get_relay_mix(data)                                                   ((0x00000200&(data))>>9)
+#define VO_WB2_csr_shift                                                             (8)
+#define VO_WB2_csr_mask                                                              (0x00000100)
+#define VO_WB2_csr(data)                                                             (0x00000100&((data)<<8))
+#define VO_WB2_csr_src(data)                                                         ((0x00000100&(data))>>8)
+#define VO_WB2_get_csr(data)                                                         ((0x00000100&(data))>>8)
+#define VO_WB2_osd1_shift                                                            (7)
+#define VO_WB2_osd1_mask                                                             (0x00000080)
+#define VO_WB2_osd1(data)                                                            (0x00000080&((data)<<7))
+#define VO_WB2_osd1_src(data)                                                        ((0x00000080&(data))>>7)
+#define VO_WB2_get_osd1(data)                                                        ((0x00000080&(data))>>7)
+#define VO_WB2_sub2_shift                                                            (6)
+#define VO_WB2_sub2_mask                                                             (0x00000040)
+#define VO_WB2_sub2(data)                                                            (0x00000040&((data)<<6))
+#define VO_WB2_sub2_src(data)                                                        ((0x00000040&(data))>>6)
+#define VO_WB2_get_sub2(data)                                                        ((0x00000040&(data))>>6)
+#define VO_WB2_sub1_shift                                                            (5)
+#define VO_WB2_sub1_mask                                                             (0x00000020)
+#define VO_WB2_sub1(data)                                                            (0x00000020&((data)<<5))
+#define VO_WB2_sub1_src(data)                                                        ((0x00000020&(data))>>5)
+#define VO_WB2_get_sub1(data)                                                        ((0x00000020&(data))>>5)
+#define VO_WB2_v2_shift                                                              (4)
+#define VO_WB2_v2_mask                                                               (0x00000010)
+#define VO_WB2_v2(data)                                                              (0x00000010&((data)<<4))
+#define VO_WB2_v2_src(data)                                                          ((0x00000010&(data))>>4)
+#define VO_WB2_get_v2(data)                                                          ((0x00000010&(data))>>4)
+#define VO_WB2_v1_shift                                                              (3)
+#define VO_WB2_v1_mask                                                               (0x00000008)
+#define VO_WB2_v1(data)                                                              (0x00000008&((data)<<3))
+#define VO_WB2_v1_src(data)                                                          ((0x00000008&(data))>>3)
+#define VO_WB2_get_v1(data)                                                          ((0x00000008&(data))>>3)
+#define VO_WB2_mix2_shift                                                            (2)
+#define VO_WB2_mix2_mask                                                             (0x00000004)
+#define VO_WB2_mix2(data)                                                            (0x00000004&((data)<<2))
+#define VO_WB2_mix2_src(data)                                                        ((0x00000004&(data))>>2)
+#define VO_WB2_get_mix2(data)                                                        ((0x00000004&(data))>>2)
+#define VO_WB2_mix1_shift                                                            (1)
+#define VO_WB2_mix1_mask                                                             (0x00000002)
+#define VO_WB2_mix1(data)                                                            (0x00000002&((data)<<1))
+#define VO_WB2_mix1_src(data)                                                        ((0x00000002&(data))>>1)
+#define VO_WB2_get_mix1(data)                                                        ((0x00000002&(data))>>1)
+#define VO_WB2_write_data_shift                                                      (0)
+#define VO_WB2_write_data_mask                                                       (0x00000001)
+#define VO_WB2_write_data(data)                                                      (0x00000001&((data)<<0))
+#define VO_WB2_write_data_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_WB2_get_write_data(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_M1_3D                                                                     0x98005018
+#define VO_M1_3D_reg_addr                                                            "0xD8005018"
+#define VO_M1_3D_reg                                                                 0xD8005018
+#define set_VO_M1_3D_reg(data)   (*((volatile unsigned int*) VO_M1_3D_reg)=data)
+#define get_VO_M1_3D_reg   (*((volatile unsigned int*) VO_M1_3D_reg))
+#define VO_M1_3D_inst_adr                                                            "0x0006"
+#define VO_M1_3D_inst                                                                0x0006
+#define VO_M1_3D_top_and_bottom_shift                                                (3)
+#define VO_M1_3D_top_and_bottom_mask                                                 (0x00000008)
+#define VO_M1_3D_top_and_bottom(data)                                                (0x00000008&((data)<<3))
+#define VO_M1_3D_top_and_bottom_src(data)                                            ((0x00000008&(data))>>3)
+#define VO_M1_3D_get_top_and_bottom(data)                                            ((0x00000008&(data))>>3)
+#define VO_M1_3D_side_by_side_shift                                                  (2)
+#define VO_M1_3D_side_by_side_mask                                                   (0x00000004)
+#define VO_M1_3D_side_by_side(data)                                                  (0x00000004&((data)<<2))
+#define VO_M1_3D_side_by_side_src(data)                                              ((0x00000004&(data))>>2)
+#define VO_M1_3D_get_side_by_side(data)                                              ((0x00000004&(data))>>2)
+#define VO_M1_3D_right_shift                                                         (1)
+#define VO_M1_3D_right_mask                                                          (0x00000002)
+#define VO_M1_3D_right(data)                                                         (0x00000002&((data)<<1))
+#define VO_M1_3D_right_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_M1_3D_get_right(data)                                                     ((0x00000002&(data))>>1)
+#define VO_M1_3D_write_data_shift                                                    (0)
+#define VO_M1_3D_write_data_mask                                                     (0x00000001)
+#define VO_M1_3D_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VO_M1_3D_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_M1_3D_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_M2_3D                                                                     0x9800501C
+#define VO_M2_3D_reg_addr                                                            "0xD800501C"
+#define VO_M2_3D_reg                                                                 0xD800501C
+#define set_VO_M2_3D_reg(data)   (*((volatile unsigned int*) VO_M2_3D_reg)=data)
+#define get_VO_M2_3D_reg   (*((volatile unsigned int*) VO_M2_3D_reg))
+#define VO_M2_3D_inst_adr                                                            "0x0007"
+#define VO_M2_3D_inst                                                                0x0007
+#define VO_M2_3D_top_and_bottom_shift                                                (3)
+#define VO_M2_3D_top_and_bottom_mask                                                 (0x00000008)
+#define VO_M2_3D_top_and_bottom(data)                                                (0x00000008&((data)<<3))
+#define VO_M2_3D_top_and_bottom_src(data)                                            ((0x00000008&(data))>>3)
+#define VO_M2_3D_get_top_and_bottom(data)                                            ((0x00000008&(data))>>3)
+#define VO_M2_3D_side_by_side_shift                                                  (2)
+#define VO_M2_3D_side_by_side_mask                                                   (0x00000004)
+#define VO_M2_3D_side_by_side(data)                                                  (0x00000004&((data)<<2))
+#define VO_M2_3D_side_by_side_src(data)                                              ((0x00000004&(data))>>2)
+#define VO_M2_3D_get_side_by_side(data)                                              ((0x00000004&(data))>>2)
+#define VO_M2_3D_right_shift                                                         (1)
+#define VO_M2_3D_right_mask                                                          (0x00000002)
+#define VO_M2_3D_right(data)                                                         (0x00000002&((data)<<1))
+#define VO_M2_3D_right_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_M2_3D_get_right(data)                                                     ((0x00000002&(data))>>1)
+#define VO_M2_3D_write_data_shift                                                    (0)
+#define VO_M2_3D_write_data_mask                                                     (0x00000001)
+#define VO_M2_3D_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VO_M2_3D_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_M2_3D_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_FC                                                                        0x98005020
+#define VO_FC_reg_addr                                                               "0xD8005020"
+#define VO_FC_reg                                                                    0xD8005020
+#define set_VO_FC_reg(data)   (*((volatile unsigned int*) VO_FC_reg)=data)
+#define get_VO_FC_reg   (*((volatile unsigned int*) VO_FC_reg))
+#define VO_FC_inst_adr                                                               "0x0008"
+#define VO_FC_inst                                                                   0x0008
+#define VO_FC_wb2go_shift                                                            (5)
+#define VO_FC_wb2go_mask                                                             (0x00000020)
+#define VO_FC_wb2go(data)                                                            (0x00000020&((data)<<5))
+#define VO_FC_wb2go_src(data)                                                        ((0x00000020&(data))>>5)
+#define VO_FC_get_wb2go(data)                                                        ((0x00000020&(data))>>5)
+#define VO_FC_wb1go_shift                                                            (4)
+#define VO_FC_wb1go_mask                                                             (0x00000010)
+#define VO_FC_wb1go(data)                                                            (0x00000010&((data)<<4))
+#define VO_FC_wb1go_src(data)                                                        ((0x00000010&(data))>>4)
+#define VO_FC_get_wb1go(data)                                                        ((0x00000010&(data))>>4)
+#define VO_FC_mddgo_shift                                                            (3)
+#define VO_FC_mddgo_mask                                                             (0x00000008)
+#define VO_FC_mddgo(data)                                                            (0x00000008&((data)<<3))
+#define VO_FC_mddgo_src(data)                                                        ((0x00000008&(data))>>3)
+#define VO_FC_get_mddgo(data)                                                        ((0x00000008&(data))>>3)
+#define VO_FC_m2go_shift                                                             (2)
+#define VO_FC_m2go_mask                                                              (0x00000004)
+#define VO_FC_m2go(data)                                                             (0x00000004&((data)<<2))
+#define VO_FC_m2go_src(data)                                                         ((0x00000004&(data))>>2)
+#define VO_FC_get_m2go(data)                                                         ((0x00000004&(data))>>2)
+#define VO_FC_m1go_shift                                                             (1)
+#define VO_FC_m1go_mask                                                              (0x00000002)
+#define VO_FC_m1go(data)                                                             (0x00000002&((data)<<1))
+#define VO_FC_m1go_src(data)                                                         ((0x00000002&(data))>>1)
+#define VO_FC_get_m1go(data)                                                         ((0x00000002&(data))>>1)
+#define VO_FC_write_data_shift                                                       (0)
+#define VO_FC_write_data_mask                                                        (0x00000001)
+#define VO_FC_write_data(data)                                                       (0x00000001&((data)<<0))
+#define VO_FC_write_data_src(data)                                                   ((0x00000001&(data))>>0)
+#define VO_FC_get_write_data(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define VO_VBI_END                                                                   0x98005024
+#define VO_VBI_END_reg_addr                                                          "0xD8005024"
+#define VO_VBI_END_reg                                                               0xD8005024
+#define set_VO_VBI_END_reg(data)   (*((volatile unsigned int*) VO_VBI_END_reg)=data)
+#define get_VO_VBI_END_reg   (*((volatile unsigned int*) VO_VBI_END_reg))
+#define VO_VBI_END_inst_adr                                                          "0x0009"
+#define VO_VBI_END_inst                                                              0x0009
+#define VO_VBI_END_ref_shift                                                         (24)
+#define VO_VBI_END_ref_mask                                                          (0x07000000)
+#define VO_VBI_END_ref(data)                                                         (0x07000000&((data)<<24))
+#define VO_VBI_END_ref_src(data)                                                     ((0x07000000&(data))>>24)
+#define VO_VBI_END_get_ref(data)                                                     ((0x07000000&(data))>>24)
+#define VO_VBI_END_pos_shift                                                         (12)
+#define VO_VBI_END_pos_mask                                                          (0x00FFF000)
+#define VO_VBI_END_pos(data)                                                         (0x00FFF000&((data)<<12))
+#define VO_VBI_END_pos_src(data)                                                     ((0x00FFF000&(data))>>12)
+#define VO_VBI_END_get_pos(data)                                                     ((0x00FFF000&(data))>>12)
+#define VO_VBI_END_th_shift                                                          (0)
+#define VO_VBI_END_th_mask                                                           (0x00000FFF)
+#define VO_VBI_END_th(data)                                                          (0x00000FFF&((data)<<0))
+#define VO_VBI_END_th_src(data)                                                      ((0x00000FFF&(data))>>0)
+#define VO_VBI_END_get_th(data)                                                      ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1                                                                        0x98005028
+#define VO_V1_reg_addr                                                               "0xD8005028"
+#define VO_V1_reg                                                                    0xD8005028
+#define set_VO_V1_reg(data)   (*((volatile unsigned int*) VO_V1_reg)=data)
+#define get_VO_V1_reg   (*((volatile unsigned int*) VO_V1_reg))
+#define VO_V1_inst_adr                                                               "0x000A"
+#define VO_V1_inst                                                                   0x000A
+#define VO_V1_ve_fmt_shift                                                           (25)
+#define VO_V1_ve_fmt_mask                                                            (0x02000000)
+#define VO_V1_ve_fmt(data)                                                           (0x02000000&((data)<<25))
+#define VO_V1_ve_fmt_src(data)                                                       ((0x02000000&(data))>>25)
+#define VO_V1_get_ve_fmt(data)                                                       ((0x02000000&(data))>>25)
+#define VO_V1_source_shift                                                           (24)
+#define VO_V1_source_mask                                                            (0x01000000)
+#define VO_V1_source(data)                                                           (0x01000000&((data)<<24))
+#define VO_V1_source_src(data)                                                       ((0x01000000&(data))>>24)
+#define VO_V1_get_source(data)                                                       ((0x01000000&(data))>>24)
+#define VO_V1_nv21_shift                                                             (23)
+#define VO_V1_nv21_mask                                                              (0x00800000)
+#define VO_V1_nv21(data)                                                             (0x00800000&((data)<<23))
+#define VO_V1_nv21_src(data)                                                         ((0x00800000&(data))>>23)
+#define VO_V1_get_nv21(data)                                                         ((0x00800000&(data))>>23)
+#define VO_V1_mode_10b_shift                                                         (22)
+#define VO_V1_mode_10b_mask                                                          (0x00400000)
+#define VO_V1_mode_10b(data)                                                         (0x00400000&((data)<<22))
+#define VO_V1_mode_10b_src(data)                                                     ((0x00400000&(data))>>22)
+#define VO_V1_get_mode_10b(data)                                                     ((0x00400000&(data))>>22)
+#define VO_V1_ppc10b_shift                                                           (21)
+#define VO_V1_ppc10b_mask                                                            (0x00200000)
+#define VO_V1_ppc10b(data)                                                           (0x00200000&((data)<<21))
+#define VO_V1_ppc10b_src(data)                                                       ((0x00200000&(data))>>21)
+#define VO_V1_get_ppc10b(data)                                                       ((0x00200000&(data))>>21)
+#define VO_V1_finish_mode_shift                                                      (20)
+#define VO_V1_finish_mode_mask                                                       (0x00100000)
+#define VO_V1_finish_mode(data)                                                      (0x00100000&((data)<<20))
+#define VO_V1_finish_mode_src(data)                                                  ((0x00100000&(data))>>20)
+#define VO_V1_get_finish_mode(data)                                                  ((0x00100000&(data))>>20)
+#define VO_V1_d3_dbh_shift                                                           (19)
+#define VO_V1_d3_dbh_mask                                                            (0x00080000)
+#define VO_V1_d3_dbh(data)                                                           (0x00080000&((data)<<19))
+#define VO_V1_d3_dbh_src(data)                                                       ((0x00080000&(data))>>19)
+#define VO_V1_get_d3_dbh(data)                                                       ((0x00080000&(data))>>19)
+#define VO_V1_d3_dbw_shift                                                           (18)
+#define VO_V1_d3_dbw_mask                                                            (0x00040000)
+#define VO_V1_d3_dbw(data)                                                           (0x00040000&((data)<<18))
+#define VO_V1_d3_dbw_src(data)                                                       ((0x00040000&(data))>>18)
+#define VO_V1_get_d3_dbw(data)                                                       ((0x00040000&(data))>>18)
+#define VO_V1_d3_dup_shift                                                           (17)
+#define VO_V1_d3_dup_mask                                                            (0x00020000)
+#define VO_V1_d3_dup(data)                                                           (0x00020000&((data)<<17))
+#define VO_V1_d3_dup_src(data)                                                       ((0x00020000&(data))>>17)
+#define VO_V1_get_d3_dup(data)                                                       ((0x00020000&(data))>>17)
+#define VO_V1_st_shift                                                               (15)
+#define VO_V1_st_mask                                                                (0x00008000)
+#define VO_V1_st(data)                                                               (0x00008000&((data)<<15))
+#define VO_V1_st_src(data)                                                           ((0x00008000&(data))>>15)
+#define VO_V1_get_st(data)                                                           ((0x00008000&(data))>>15)
+#define VO_V1_sr_shift                                                               (14)
+#define VO_V1_sr_mask                                                                (0x00004000)
+#define VO_V1_sr(data)                                                               (0x00004000&((data)<<14))
+#define VO_V1_sr_src(data)                                                           ((0x00004000&(data))>>14)
+#define VO_V1_get_sr(data)                                                           ((0x00004000&(data))>>14)
+#define VO_V1_shp_shift                                                              (13)
+#define VO_V1_shp_mask                                                               (0x00002000)
+#define VO_V1_shp(data)                                                              (0x00002000&((data)<<13))
+#define VO_V1_shp_src(data)                                                          ((0x00002000&(data))>>13)
+#define VO_V1_get_shp(data)                                                          ((0x00002000&(data))>>13)
+#define VO_V1_seq_shift                                                              (12)
+#define VO_V1_seq_mask                                                               (0x00001000)
+#define VO_V1_seq(data)                                                              (0x00001000&((data)<<12))
+#define VO_V1_seq_src(data)                                                          ((0x00001000&(data))>>12)
+#define VO_V1_get_seq(data)                                                          ((0x00001000&(data))>>12)
+#define VO_V1_di_shift                                                               (11)
+#define VO_V1_di_mask                                                                (0x00000800)
+#define VO_V1_di(data)                                                               (0x00000800&((data)<<11))
+#define VO_V1_di_src(data)                                                           ((0x00000800&(data))>>11)
+#define VO_V1_get_di(data)                                                           ((0x00000800&(data))>>11)
+#define VO_V1_f422_shift                                                             (10)
+#define VO_V1_f422_mask                                                              (0x00000400)
+#define VO_V1_f422(data)                                                             (0x00000400&((data)<<10))
+#define VO_V1_f422_src(data)                                                         ((0x00000400&(data))>>10)
+#define VO_V1_get_f422(data)                                                         ((0x00000400&(data))>>10)
+#define VO_V1_vs_shift                                                               (9)
+#define VO_V1_vs_mask                                                                (0x00000200)
+#define VO_V1_vs(data)                                                               (0x00000200&((data)<<9))
+#define VO_V1_vs_src(data)                                                           ((0x00000200&(data))>>9)
+#define VO_V1_get_vs(data)                                                           ((0x00000200&(data))>>9)
+#define VO_V1_vs_near_shift                                                          (8)
+#define VO_V1_vs_near_mask                                                           (0x00000100)
+#define VO_V1_vs_near(data)                                                          (0x00000100&((data)<<8))
+#define VO_V1_vs_near_src(data)                                                      ((0x00000100&(data))>>8)
+#define VO_V1_get_vs_near(data)                                                      ((0x00000100&(data))>>8)
+#define VO_V1_vs_yodd_shift                                                          (7)
+#define VO_V1_vs_yodd_mask                                                           (0x00000080)
+#define VO_V1_vs_yodd(data)                                                          (0x00000080&((data)<<7))
+#define VO_V1_vs_yodd_src(data)                                                      ((0x00000080&(data))>>7)
+#define VO_V1_get_vs_yodd(data)                                                      ((0x00000080&(data))>>7)
+#define VO_V1_vs_codd_shift                                                          (6)
+#define VO_V1_vs_codd_mask                                                           (0x00000040)
+#define VO_V1_vs_codd(data)                                                          (0x00000040&((data)<<6))
+#define VO_V1_vs_codd_src(data)                                                      ((0x00000040&(data))>>6)
+#define VO_V1_get_vs_codd(data)                                                      ((0x00000040&(data))>>6)
+#define VO_V1_hs_shift                                                               (5)
+#define VO_V1_hs_mask                                                                (0x00000020)
+#define VO_V1_hs(data)                                                               (0x00000020&((data)<<5))
+#define VO_V1_hs_src(data)                                                           ((0x00000020&(data))>>5)
+#define VO_V1_get_hs(data)                                                           ((0x00000020&(data))>>5)
+#define VO_V1_hs_yodd_shift                                                          (4)
+#define VO_V1_hs_yodd_mask                                                           (0x00000010)
+#define VO_V1_hs_yodd(data)                                                          (0x00000010&((data)<<4))
+#define VO_V1_hs_yodd_src(data)                                                      ((0x00000010&(data))>>4)
+#define VO_V1_get_hs_yodd(data)                                                      ((0x00000010&(data))>>4)
+#define VO_V1_hs_codd_shift                                                          (3)
+#define VO_V1_hs_codd_mask                                                           (0x00000008)
+#define VO_V1_hs_codd(data)                                                          (0x00000008&((data)<<3))
+#define VO_V1_hs_codd_src(data)                                                      ((0x00000008&(data))>>3)
+#define VO_V1_get_hs_codd(data)                                                      ((0x00000008&(data))>>3)
+#define VO_V1_topfield_shift                                                         (2)
+#define VO_V1_topfield_mask                                                          (0x00000004)
+#define VO_V1_topfield(data)                                                         (0x00000004&((data)<<2))
+#define VO_V1_topfield_src(data)                                                     ((0x00000004&(data))>>2)
+#define VO_V1_get_topfield(data)                                                     ((0x00000004&(data))>>2)
+#define VO_V1_dmaweave_shift                                                         (1)
+#define VO_V1_dmaweave_mask                                                          (0x00000002)
+#define VO_V1_dmaweave(data)                                                         (0x00000002&((data)<<1))
+#define VO_V1_dmaweave_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_V1_get_dmaweave(data)                                                     ((0x00000002&(data))>>1)
+#define VO_V1_write_data_shift                                                       (0)
+#define VO_V1_write_data_mask                                                        (0x00000001)
+#define VO_V1_write_data(data)                                                       (0x00000001&((data)<<0))
+#define VO_V1_write_data_src(data)                                                   ((0x00000001&(data))>>0)
+#define VO_V1_get_write_data(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define VO_V1_DMA                                                                    0x9800502C
+#define VO_V1_DMA_reg_addr                                                           "0xD800502C"
+#define VO_V1_DMA_reg                                                                0xD800502C
+#define set_VO_V1_DMA_reg(data)   (*((volatile unsigned int*) VO_V1_DMA_reg)=data)
+#define get_VO_V1_DMA_reg   (*((volatile unsigned int*) VO_V1_DMA_reg))
+#define VO_V1_DMA_inst_adr                                                           "0x000B"
+#define VO_V1_DMA_inst                                                               0x000B
+#define VO_V1_DMA_w_l_shift                                                          (16)
+#define VO_V1_DMA_w_l_mask                                                           (0x003F0000)
+#define VO_V1_DMA_w_l(data)                                                          (0x003F0000&((data)<<16))
+#define VO_V1_DMA_w_l_src(data)                                                      ((0x003F0000&(data))>>16)
+#define VO_V1_DMA_get_w_l(data)                                                      ((0x003F0000&(data))>>16)
+#define VO_V1_DMA_l_shift                                                            (0)
+#define VO_V1_DMA_l_mask                                                             (0x0000007F)
+#define VO_V1_DMA_l(data)                                                            (0x0000007F&((data)<<0))
+#define VO_V1_DMA_l_src(data)                                                        ((0x0000007F&(data))>>0)
+#define VO_V1_DMA_get_l(data)                                                        ((0x0000007F&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_W_Y                                                             0x98005030
+#define VO_V1_SEQ_SA_W_Y_reg_addr                                                    "0xD8005030"
+#define VO_V1_SEQ_SA_W_Y_reg                                                         0xD8005030
+#define set_VO_V1_SEQ_SA_W_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_Y_reg)=data)
+#define get_VO_V1_SEQ_SA_W_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_Y_reg))
+#define VO_V1_SEQ_SA_W_Y_inst_adr                                                    "0x000C"
+#define VO_V1_SEQ_SA_W_Y_inst                                                        0x000C
+#define VO_V1_SEQ_SA_W_Y_a_shift                                                     (0)
+#define VO_V1_SEQ_SA_W_Y_a_mask                                                      (0xFFFFFFFF)
+#define VO_V1_SEQ_SA_W_Y_a(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_W_Y_a_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_W_Y_get_a(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_W_C                                                             0x98005034
+#define VO_V1_SEQ_SA_W_C_reg_addr                                                    "0xD8005034"
+#define VO_V1_SEQ_SA_W_C_reg                                                         0xD8005034
+#define set_VO_V1_SEQ_SA_W_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_C_reg)=data)
+#define get_VO_V1_SEQ_SA_W_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_C_reg))
+#define VO_V1_SEQ_SA_W_C_inst_adr                                                    "0x000D"
+#define VO_V1_SEQ_SA_W_C_inst                                                        0x000D
+#define VO_V1_SEQ_SA_W_C_a_shift                                                     (0)
+#define VO_V1_SEQ_SA_W_C_a_mask                                                      (0xFFFFFFFF)
+#define VO_V1_SEQ_SA_W_C_a(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_W_C_a_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_W_C_get_a(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_C_Y                                                             0x98005038
+#define VO_V1_SEQ_SA_C_Y_reg_addr                                                    "0xD8005038"
+#define VO_V1_SEQ_SA_C_Y_reg                                                         0xD8005038
+#define set_VO_V1_SEQ_SA_C_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_Y_reg)=data)
+#define get_VO_V1_SEQ_SA_C_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_Y_reg))
+#define VO_V1_SEQ_SA_C_Y_inst_adr                                                    "0x000E"
+#define VO_V1_SEQ_SA_C_Y_inst                                                        0x000E
+#define VO_V1_SEQ_SA_C_Y_a_shift                                                     (0)
+#define VO_V1_SEQ_SA_C_Y_a_mask                                                      (0xFFFFFFFF)
+#define VO_V1_SEQ_SA_C_Y_a(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_C_Y_a_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_C_Y_get_a(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_C_C                                                             0x9800503C
+#define VO_V1_SEQ_SA_C_C_reg_addr                                                    "0xD800503C"
+#define VO_V1_SEQ_SA_C_C_reg                                                         0xD800503C
+#define set_VO_V1_SEQ_SA_C_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_C_reg)=data)
+#define get_VO_V1_SEQ_SA_C_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_C_reg))
+#define VO_V1_SEQ_SA_C_C_inst_adr                                                    "0x000F"
+#define VO_V1_SEQ_SA_C_C_inst                                                        0x000F
+#define VO_V1_SEQ_SA_C_C_a_shift                                                     (0)
+#define VO_V1_SEQ_SA_C_C_a_mask                                                      (0xFFFFFFFF)
+#define VO_V1_SEQ_SA_C_C_a(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_C_C_a_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_C_C_get_a(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_W_Y                                                          0x98005040
+#define VO_V1_SEQ_PITCH_W_Y_reg_addr                                                 "0xD8005040"
+#define VO_V1_SEQ_PITCH_W_Y_reg                                                      0xD8005040
+#define set_VO_V1_SEQ_PITCH_W_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_W_Y_reg)=data)
+#define get_VO_V1_SEQ_PITCH_W_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_W_Y_reg))
+#define VO_V1_SEQ_PITCH_W_Y_inst_adr                                                 "0x0010"
+#define VO_V1_SEQ_PITCH_W_Y_inst                                                     0x0010
+#define VO_V1_SEQ_PITCH_W_Y_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_W_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_W_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_W_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_W_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_W_C                                                          0x98005044
+#define VO_V1_SEQ_PITCH_W_C_reg_addr                                                 "0xD8005044"
+#define VO_V1_SEQ_PITCH_W_C_reg                                                      0xD8005044
+#define set_VO_V1_SEQ_PITCH_W_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_W_C_reg)=data)
+#define get_VO_V1_SEQ_PITCH_W_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_W_C_reg))
+#define VO_V1_SEQ_PITCH_W_C_inst_adr                                                 "0x0011"
+#define VO_V1_SEQ_PITCH_W_C_inst                                                     0x0011
+#define VO_V1_SEQ_PITCH_W_C_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_W_C_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_W_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_W_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_W_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_C_Y                                                          0x98005048
+#define VO_V1_SEQ_PITCH_C_Y_reg_addr                                                 "0xD8005048"
+#define VO_V1_SEQ_PITCH_C_Y_reg                                                      0xD8005048
+#define set_VO_V1_SEQ_PITCH_C_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_C_Y_reg)=data)
+#define get_VO_V1_SEQ_PITCH_C_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_C_Y_reg))
+#define VO_V1_SEQ_PITCH_C_Y_inst_adr                                                 "0x0012"
+#define VO_V1_SEQ_PITCH_C_Y_inst                                                     0x0012
+#define VO_V1_SEQ_PITCH_C_Y_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_C_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_C_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_C_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_C_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_C_C                                                          0x9800504C
+#define VO_V1_SEQ_PITCH_C_C_reg_addr                                                 "0xD800504C"
+#define VO_V1_SEQ_PITCH_C_C_reg                                                      0xD800504C
+#define set_VO_V1_SEQ_PITCH_C_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_C_C_reg)=data)
+#define get_VO_V1_SEQ_PITCH_C_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_C_C_reg))
+#define VO_V1_SEQ_PITCH_C_C_inst_adr                                                 "0x0013"
+#define VO_V1_SEQ_PITCH_C_C_inst                                                     0x0013
+#define VO_V1_SEQ_PITCH_C_C_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_C_C_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_C_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_C_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_C_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_W_Y_3D                                                          0x98005050
+#define VO_V1_SEQ_SA_W_Y_3D_reg_addr                                                 "0xD8005050"
+#define VO_V1_SEQ_SA_W_Y_3D_reg                                                      0xD8005050
+#define set_VO_V1_SEQ_SA_W_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_Y_3D_reg)=data)
+#define get_VO_V1_SEQ_SA_W_Y_3D_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_Y_3D_reg))
+#define VO_V1_SEQ_SA_W_Y_3D_inst_adr                                                 "0x0014"
+#define VO_V1_SEQ_SA_W_Y_3D_inst                                                     0x0014
+#define VO_V1_SEQ_SA_W_Y_3D_a_shift                                                  (0)
+#define VO_V1_SEQ_SA_W_Y_3D_a_mask                                                   (0xFFFFFFFF)
+#define VO_V1_SEQ_SA_W_Y_3D_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_W_Y_3D_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_W_Y_3D_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_W_C_3D                                                          0x98005054
+#define VO_V1_SEQ_SA_W_C_3D_reg_addr                                                 "0xD8005054"
+#define VO_V1_SEQ_SA_W_C_3D_reg                                                      0xD8005054
+#define set_VO_V1_SEQ_SA_W_C_3D_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_C_3D_reg)=data)
+#define get_VO_V1_SEQ_SA_W_C_3D_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_C_3D_reg))
+#define VO_V1_SEQ_SA_W_C_3D_inst_adr                                                 "0x0015"
+#define VO_V1_SEQ_SA_W_C_3D_inst                                                     0x0015
+#define VO_V1_SEQ_SA_W_C_3D_a_shift                                                  (0)
+#define VO_V1_SEQ_SA_W_C_3D_a_mask                                                   (0xFFFFFFFF)
+#define VO_V1_SEQ_SA_W_C_3D_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_W_C_3D_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_W_C_3D_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_C_Y_3D                                                          0x98005058
+#define VO_V1_SEQ_SA_C_Y_3D_reg_addr                                                 "0xD8005058"
+#define VO_V1_SEQ_SA_C_Y_3D_reg                                                      0xD8005058
+#define set_VO_V1_SEQ_SA_C_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_Y_3D_reg)=data)
+#define get_VO_V1_SEQ_SA_C_Y_3D_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_Y_3D_reg))
+#define VO_V1_SEQ_SA_C_Y_3D_inst_adr                                                 "0x0016"
+#define VO_V1_SEQ_SA_C_Y_3D_inst                                                     0x0016
+#define VO_V1_SEQ_SA_C_Y_3D_a_shift                                                  (0)
+#define VO_V1_SEQ_SA_C_Y_3D_a_mask                                                   (0xFFFFFFFF)
+#define VO_V1_SEQ_SA_C_Y_3D_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_C_Y_3D_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_C_Y_3D_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_C_C_3D                                                          0x9800505C
+#define VO_V1_SEQ_SA_C_C_3D_reg_addr                                                 "0xD800505C"
+#define VO_V1_SEQ_SA_C_C_3D_reg                                                      0xD800505C
+#define set_VO_V1_SEQ_SA_C_C_3D_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_C_3D_reg)=data)
+#define get_VO_V1_SEQ_SA_C_C_3D_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_C_3D_reg))
+#define VO_V1_SEQ_SA_C_C_3D_inst_adr                                                 "0x0017"
+#define VO_V1_SEQ_SA_C_C_3D_inst                                                     0x0017
+#define VO_V1_SEQ_SA_C_C_3D_a_shift                                                  (0)
+#define VO_V1_SEQ_SA_C_C_3D_a_mask                                                   (0xFFFFFFFF)
+#define VO_V1_SEQ_SA_C_C_3D_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_C_C_3D_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_C_C_3D_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_INDEX_RR                                                               0x98005060
+#define VO_V1_INDEX_RR_reg_addr                                                      "0xD8005060"
+#define VO_V1_INDEX_RR_reg                                                           0xD8005060
+#define set_VO_V1_INDEX_RR_reg(data)   (*((volatile unsigned int*) VO_V1_INDEX_RR_reg)=data)
+#define get_VO_V1_INDEX_RR_reg   (*((volatile unsigned int*) VO_V1_INDEX_RR_reg))
+#define VO_V1_INDEX_RR_inst_adr                                                      "0x0018"
+#define VO_V1_INDEX_RR_inst                                                          0x0018
+#define VO_V1_INDEX_RR_w_c_en_shift                                                  (15)
+#define VO_V1_INDEX_RR_w_c_en_mask                                                   (0x00008000)
+#define VO_V1_INDEX_RR_w_c_en(data)                                                  (0x00008000&((data)<<15))
+#define VO_V1_INDEX_RR_w_c_en_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_V1_INDEX_RR_get_w_c_en(data)                                              ((0x00008000&(data))>>15)
+#define VO_V1_INDEX_RR_w_c_shift                                                     (12)
+#define VO_V1_INDEX_RR_w_c_mask                                                      (0x00007000)
+#define VO_V1_INDEX_RR_w_c(data)                                                     (0x00007000&((data)<<12))
+#define VO_V1_INDEX_RR_w_c_src(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_INDEX_RR_get_w_c(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_INDEX_RR_w_y_en_shift                                                  (11)
+#define VO_V1_INDEX_RR_w_y_en_mask                                                   (0x00000800)
+#define VO_V1_INDEX_RR_w_y_en(data)                                                  (0x00000800&((data)<<11))
+#define VO_V1_INDEX_RR_w_y_en_src(data)                                              ((0x00000800&(data))>>11)
+#define VO_V1_INDEX_RR_get_w_y_en(data)                                              ((0x00000800&(data))>>11)
+#define VO_V1_INDEX_RR_w_y_shift                                                     (8)
+#define VO_V1_INDEX_RR_w_y_mask                                                      (0x00000700)
+#define VO_V1_INDEX_RR_w_y(data)                                                     (0x00000700&((data)<<8))
+#define VO_V1_INDEX_RR_w_y_src(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_INDEX_RR_get_w_y(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_INDEX_RR_c_en_shift                                                    (7)
+#define VO_V1_INDEX_RR_c_en_mask                                                     (0x00000080)
+#define VO_V1_INDEX_RR_c_en(data)                                                    (0x00000080&((data)<<7))
+#define VO_V1_INDEX_RR_c_en_src(data)                                                ((0x00000080&(data))>>7)
+#define VO_V1_INDEX_RR_get_c_en(data)                                                ((0x00000080&(data))>>7)
+#define VO_V1_INDEX_RR_c_shift                                                       (4)
+#define VO_V1_INDEX_RR_c_mask                                                        (0x00000070)
+#define VO_V1_INDEX_RR_c(data)                                                       (0x00000070&((data)<<4))
+#define VO_V1_INDEX_RR_c_src(data)                                                   ((0x00000070&(data))>>4)
+#define VO_V1_INDEX_RR_get_c(data)                                                   ((0x00000070&(data))>>4)
+#define VO_V1_INDEX_RR_y_en_shift                                                    (3)
+#define VO_V1_INDEX_RR_y_en_mask                                                     (0x00000008)
+#define VO_V1_INDEX_RR_y_en(data)                                                    (0x00000008&((data)<<3))
+#define VO_V1_INDEX_RR_y_en_src(data)                                                ((0x00000008&(data))>>3)
+#define VO_V1_INDEX_RR_get_y_en(data)                                                ((0x00000008&(data))>>3)
+#define VO_V1_INDEX_RR_y_shift                                                       (0)
+#define VO_V1_INDEX_RR_y_mask                                                        (0x00000007)
+#define VO_V1_INDEX_RR_y(data)                                                       (0x00000007&((data)<<0))
+#define VO_V1_INDEX_RR_y_src(data)                                                   ((0x00000007&(data))>>0)
+#define VO_V1_INDEX_RR_get_y(data)                                                   ((0x00000007&(data))>>0)
+
+
+#define VO_V1_ALPHA                                                                  0x98005064
+#define VO_V1_ALPHA_reg_addr                                                         "0xD8005064"
+#define VO_V1_ALPHA_reg                                                              0xD8005064
+#define set_VO_V1_ALPHA_reg(data)   (*((volatile unsigned int*) VO_V1_ALPHA_reg)=data)
+#define get_VO_V1_ALPHA_reg   (*((volatile unsigned int*) VO_V1_ALPHA_reg))
+#define VO_V1_ALPHA_inst_adr                                                         "0x0019"
+#define VO_V1_ALPHA_inst                                                             0x0019
+#define VO_V1_ALPHA_a_shift                                                          (0)
+#define VO_V1_ALPHA_a_mask                                                           (0x000001FF)
+#define VO_V1_ALPHA_a(data)                                                          (0x000001FF&((data)<<0))
+#define VO_V1_ALPHA_a_src(data)                                                      ((0x000001FF&(data))>>0)
+#define VO_V1_ALPHA_get_a(data)                                                      ((0x000001FF&(data))>>0)
+
+
+#define VO_V1_SIZE                                                                   0x98005068
+#define VO_V1_SIZE_reg_addr                                                          "0xD8005068"
+#define VO_V1_SIZE_reg                                                               0xD8005068
+#define set_VO_V1_SIZE_reg(data)   (*((volatile unsigned int*) VO_V1_SIZE_reg)=data)
+#define get_VO_V1_SIZE_reg   (*((volatile unsigned int*) VO_V1_SIZE_reg))
+#define VO_V1_SIZE_inst_adr                                                          "0x001A"
+#define VO_V1_SIZE_inst                                                              0x001A
+#define VO_V1_SIZE_w_shift                                                           (12)
+#define VO_V1_SIZE_w_mask                                                            (0x01FFF000)
+#define VO_V1_SIZE_w(data)                                                           (0x01FFF000&((data)<<12))
+#define VO_V1_SIZE_w_src(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_V1_SIZE_get_w(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_V1_SIZE_h_shift                                                           (0)
+#define VO_V1_SIZE_h_mask                                                            (0x00000FFF)
+#define VO_V1_SIZE_h(data)                                                           (0x00000FFF&((data)<<0))
+#define VO_V1_SIZE_h_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VO_V1_SIZE_get_h(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_BUF                                                                    0x9800506C
+#define VO_V1_BUF_reg_addr                                                           "0xD800506C"
+#define VO_V1_BUF_reg                                                                0xD800506C
+#define set_VO_V1_BUF_reg(data)   (*((volatile unsigned int*) VO_V1_BUF_reg)=data)
+#define get_VO_V1_BUF_reg   (*((volatile unsigned int*) VO_V1_BUF_reg))
+#define VO_V1_BUF_inst_adr                                                           "0x001B"
+#define VO_V1_BUF_inst                                                               0x001B
+#define VO_V1_BUF_th_shift                                                           (0)
+#define VO_V1_BUF_th_mask                                                            (0x000003FF)
+#define VO_V1_BUF_th(data)                                                           (0x000003FF&((data)<<0))
+#define VO_V1_BUF_th_src(data)                                                       ((0x000003FF&(data))>>0)
+#define VO_V1_BUF_get_th(data)                                                       ((0x000003FF&(data))>>0)
+
+
+#define VO_V1_MC_0                                                                   0x98005070
+#define VO_V1_MC_0_reg_addr                                                          "0xD8005070"
+#define VO_V1_MC_0_reg                                                               0xD8005070
+#define set_VO_V1_MC_0_reg(data)   (*((volatile unsigned int*) VO_V1_MC_0_reg)=data)
+#define get_VO_V1_MC_0_reg   (*((volatile unsigned int*) VO_V1_MC_0_reg))
+#define VO_V1_MC_0_inst_adr                                                          "0x001C"
+#define VO_V1_MC_0_inst                                                              0x001C
+#define VO_V1_MC_0_soft_reset_shift                                                  (2)
+#define VO_V1_MC_0_soft_reset_mask                                                   (0x00000004)
+#define VO_V1_MC_0_soft_reset(data)                                                  (0x00000004&((data)<<2))
+#define VO_V1_MC_0_soft_reset_src(data)                                              ((0x00000004&(data))>>2)
+#define VO_V1_MC_0_get_soft_reset(data)                                              ((0x00000004&(data))>>2)
+#define VO_V1_MC_0_int_mask_shift                                                    (1)
+#define VO_V1_MC_0_int_mask_mask                                                     (0x00000002)
+#define VO_V1_MC_0_int_mask(data)                                                    (0x00000002&((data)<<1))
+#define VO_V1_MC_0_int_mask_src(data)                                                ((0x00000002&(data))>>1)
+#define VO_V1_MC_0_get_int_mask(data)                                                ((0x00000002&(data))>>1)
+#define VO_V1_MC_0_run_shift                                                         (0)
+#define VO_V1_MC_0_run_mask                                                          (0x00000001)
+#define VO_V1_MC_0_run(data)                                                         (0x00000001&((data)<<0))
+#define VO_V1_MC_0_run_src(data)                                                     ((0x00000001&(data))>>0)
+#define VO_V1_MC_0_get_run(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define VO_V1_MC_4                                                                   0x98005074
+#define VO_V1_MC_4_reg_addr                                                          "0xD8005074"
+#define VO_V1_MC_4_reg                                                               0xD8005074
+#define set_VO_V1_MC_4_reg(data)   (*((volatile unsigned int*) VO_V1_MC_4_reg)=data)
+#define get_VO_V1_MC_4_reg   (*((volatile unsigned int*) VO_V1_MC_4_reg))
+#define VO_V1_MC_4_inst_adr                                                          "0x001D"
+#define VO_V1_MC_4_inst                                                              0x001D
+#define VO_V1_MC_4_check_soft_reset_shift                                            (2)
+#define VO_V1_MC_4_check_soft_reset_mask                                             (0x00000004)
+#define VO_V1_MC_4_check_soft_reset(data)                                            (0x00000004&((data)<<2))
+#define VO_V1_MC_4_check_soft_reset_src(data)                                        ((0x00000004&(data))>>2)
+#define VO_V1_MC_4_get_check_soft_reset(data)                                        ((0x00000004&(data))>>2)
+#define VO_V1_MC_4_error_shift                                                       (1)
+#define VO_V1_MC_4_error_mask                                                        (0x00000002)
+#define VO_V1_MC_4_error(data)                                                       (0x00000002&((data)<<1))
+#define VO_V1_MC_4_error_src(data)                                                   ((0x00000002&(data))>>1)
+#define VO_V1_MC_4_get_error(data)                                                   ((0x00000002&(data))>>1)
+#define VO_V1_MC_4_done_shift                                                        (0)
+#define VO_V1_MC_4_done_mask                                                         (0x00000001)
+#define VO_V1_MC_4_done(data)                                                        (0x00000001&((data)<<0))
+#define VO_V1_MC_4_done_src(data)                                                    ((0x00000001&(data))>>0)
+#define VO_V1_MC_4_get_done(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define VO_V1_MC_8                                                                   0x98005078
+#define VO_V1_MC_8_reg_addr                                                          "0xD8005078"
+#define VO_V1_MC_8_reg                                                               0xD8005078
+#define set_VO_V1_MC_8_reg(data)   (*((volatile unsigned int*) VO_V1_MC_8_reg)=data)
+#define get_VO_V1_MC_8_reg   (*((volatile unsigned int*) VO_V1_MC_8_reg))
+#define VO_V1_MC_8_inst_adr                                                          "0x001E"
+#define VO_V1_MC_8_inst                                                              0x001E
+#define VO_V1_MC_8_luma_offset_sa_shift                                              (0)
+#define VO_V1_MC_8_luma_offset_sa_mask                                               (0xFFFFFFFF)
+#define VO_V1_MC_8_luma_offset_sa(data)                                              (0xFFFFFFFF&((data)<<0))
+#define VO_V1_MC_8_luma_offset_sa_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_MC_8_get_luma_offset_sa(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_MC_C                                                                   0x9800507C
+#define VO_V1_MC_C_reg_addr                                                          "0xD800507C"
+#define VO_V1_MC_C_reg                                                               0xD800507C
+#define set_VO_V1_MC_C_reg(data)   (*((volatile unsigned int*) VO_V1_MC_C_reg)=data)
+#define get_VO_V1_MC_C_reg   (*((volatile unsigned int*) VO_V1_MC_C_reg))
+#define VO_V1_MC_C_inst_adr                                                          "0x001F"
+#define VO_V1_MC_C_inst                                                              0x001F
+#define VO_V1_MC_C_chroma_offset_sa_shift                                            (0)
+#define VO_V1_MC_C_chroma_offset_sa_mask                                             (0xFFFFFFFF)
+#define VO_V1_MC_C_chroma_offset_sa(data)                                            (0xFFFFFFFF&((data)<<0))
+#define VO_V1_MC_C_chroma_offset_sa_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_MC_C_get_chroma_offset_sa(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_MC_10                                                                  0x98005080
+#define VO_V1_MC_10_reg_addr                                                         "0xD8005080"
+#define VO_V1_MC_10_reg                                                              0xD8005080
+#define set_VO_V1_MC_10_reg(data)   (*((volatile unsigned int*) VO_V1_MC_10_reg)=data)
+#define get_VO_V1_MC_10_reg   (*((volatile unsigned int*) VO_V1_MC_10_reg))
+#define VO_V1_MC_10_inst_adr                                                         "0x0020"
+#define VO_V1_MC_10_inst                                                             0x0020
+#define VO_V1_MC_10_luma_height_shift                                                (16)
+#define VO_V1_MC_10_luma_height_mask                                                 (0x3FFF0000)
+#define VO_V1_MC_10_luma_height(data)                                                (0x3FFF0000&((data)<<16))
+#define VO_V1_MC_10_luma_height_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define VO_V1_MC_10_get_luma_height(data)                                            ((0x3FFF0000&(data))>>16)
+#define VO_V1_MC_10_chroma_height_shift                                              (0)
+#define VO_V1_MC_10_chroma_height_mask                                               (0x00003FFF)
+#define VO_V1_MC_10_chroma_height(data)                                              (0x00003FFF&((data)<<0))
+#define VO_V1_MC_10_chroma_height_src(data)                                          ((0x00003FFF&(data))>>0)
+#define VO_V1_MC_10_get_chroma_height(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_MC_14                                                                  0x98005084
+#define VO_V1_MC_14_reg_addr                                                         "0xD8005084"
+#define VO_V1_MC_14_reg                                                              0xD8005084
+#define set_VO_V1_MC_14_reg(data)   (*((volatile unsigned int*) VO_V1_MC_14_reg)=data)
+#define get_VO_V1_MC_14_reg   (*((volatile unsigned int*) VO_V1_MC_14_reg))
+#define VO_V1_MC_14_inst_adr                                                         "0x0021"
+#define VO_V1_MC_14_inst                                                             0x0021
+#define VO_V1_MC_14_luma_sa_shift                                                    (0)
+#define VO_V1_MC_14_luma_sa_mask                                                     (0xFFFFFFFF)
+#define VO_V1_MC_14_luma_sa(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define VO_V1_MC_14_luma_sa_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_MC_14_get_luma_sa(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_MC_18                                                                  0x98005088
+#define VO_V1_MC_18_reg_addr                                                         "0xD8005088"
+#define VO_V1_MC_18_reg                                                              0xD8005088
+#define set_VO_V1_MC_18_reg(data)   (*((volatile unsigned int*) VO_V1_MC_18_reg)=data)
+#define get_VO_V1_MC_18_reg   (*((volatile unsigned int*) VO_V1_MC_18_reg))
+#define VO_V1_MC_18_inst_adr                                                         "0x0022"
+#define VO_V1_MC_18_inst                                                             0x0022
+#define VO_V1_MC_18_chroma_sa_shift                                                  (0)
+#define VO_V1_MC_18_chroma_sa_mask                                                   (0xFFFFFFFF)
+#define VO_V1_MC_18_chroma_sa(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_MC_18_chroma_sa_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_MC_18_get_chroma_sa(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_MC_1C                                                                  0x9800508C
+#define VO_V1_MC_1C_reg_addr                                                         "0xD800508C"
+#define VO_V1_MC_1C_reg                                                              0xD800508C
+#define set_VO_V1_MC_1C_reg(data)   (*((volatile unsigned int*) VO_V1_MC_1C_reg)=data)
+#define get_VO_V1_MC_1C_reg   (*((volatile unsigned int*) VO_V1_MC_1C_reg))
+#define VO_V1_MC_1C_inst_adr                                                         "0x0023"
+#define VO_V1_MC_1C_inst                                                             0x0023
+#define VO_V1_MC_1C_luma_pitch_shift                                                 (16)
+#define VO_V1_MC_1C_luma_pitch_mask                                                  (0xFFFF0000)
+#define VO_V1_MC_1C_luma_pitch(data)                                                 (0xFFFF0000&((data)<<16))
+#define VO_V1_MC_1C_luma_pitch_src(data)                                             ((0xFFFF0000&(data))>>16)
+#define VO_V1_MC_1C_get_luma_pitch(data)                                             ((0xFFFF0000&(data))>>16)
+#define VO_V1_MC_1C_chroma_pitch_shift                                               (0)
+#define VO_V1_MC_1C_chroma_pitch_mask                                                (0x0000FFFF)
+#define VO_V1_MC_1C_chroma_pitch(data)                                               (0x0000FFFF&((data)<<0))
+#define VO_V1_MC_1C_chroma_pitch_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define VO_V1_MC_1C_get_chroma_pitch(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_MC_20                                                                  0x98005090
+#define VO_V1_MC_20_reg_addr                                                         "0xD8005090"
+#define VO_V1_MC_20_reg                                                              0xD8005090
+#define set_VO_V1_MC_20_reg(data)   (*((volatile unsigned int*) VO_V1_MC_20_reg)=data)
+#define get_VO_V1_MC_20_reg   (*((volatile unsigned int*) VO_V1_MC_20_reg))
+#define VO_V1_MC_20_inst_adr                                                         "0x0024"
+#define VO_V1_MC_20_inst                                                             0x0024
+#define VO_V1_MC_20_x_pos_shift                                                      (16)
+#define VO_V1_MC_20_x_pos_mask                                                       (0x1FFF0000)
+#define VO_V1_MC_20_x_pos(data)                                                      (0x1FFF0000&((data)<<16))
+#define VO_V1_MC_20_x_pos_src(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_V1_MC_20_get_x_pos(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_V1_MC_20_y_pos_shift                                                      (0)
+#define VO_V1_MC_20_y_pos_mask                                                       (0x00001FFF)
+#define VO_V1_MC_20_y_pos(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_V1_MC_20_y_pos_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_V1_MC_20_get_y_pos(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1_MC_24                                                                  0x98005094
+#define VO_V1_MC_24_reg_addr                                                         "0xD8005094"
+#define VO_V1_MC_24_reg                                                              0xD8005094
+#define set_VO_V1_MC_24_reg(data)   (*((volatile unsigned int*) VO_V1_MC_24_reg)=data)
+#define get_VO_V1_MC_24_reg   (*((volatile unsigned int*) VO_V1_MC_24_reg))
+#define VO_V1_MC_24_inst_adr                                                         "0x0025"
+#define VO_V1_MC_24_inst                                                             0x0025
+#define VO_V1_MC_24_x_size_shift                                                     (16)
+#define VO_V1_MC_24_x_size_mask                                                      (0x3FFF0000)
+#define VO_V1_MC_24_x_size(data)                                                     (0x3FFF0000&((data)<<16))
+#define VO_V1_MC_24_x_size_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define VO_V1_MC_24_get_x_size(data)                                                 ((0x3FFF0000&(data))>>16)
+#define VO_V1_MC_24_y_size_shift                                                     (0)
+#define VO_V1_MC_24_y_size_mask                                                      (0x00003FFF)
+#define VO_V1_MC_24_y_size(data)                                                     (0x00003FFF&((data)<<0))
+#define VO_V1_MC_24_y_size_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define VO_V1_MC_24_get_y_size(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_MC_28                                                                  0x98005098
+#define VO_V1_MC_28_reg_addr                                                         "0xD8005098"
+#define VO_V1_MC_28_reg                                                              0xD8005098
+#define set_VO_V1_MC_28_reg(data)   (*((volatile unsigned int*) VO_V1_MC_28_reg)=data)
+#define get_VO_V1_MC_28_reg   (*((volatile unsigned int*) VO_V1_MC_28_reg))
+#define VO_V1_MC_28_inst_adr                                                         "0x0026"
+#define VO_V1_MC_28_inst                                                             0x0026
+#define VO_V1_MC_28_luma_out_mode_shift                                              (20)
+#define VO_V1_MC_28_luma_out_mode_mask                                               (0x00F00000)
+#define VO_V1_MC_28_luma_out_mode(data)                                              (0x00F00000&((data)<<20))
+#define VO_V1_MC_28_luma_out_mode_src(data)                                          ((0x00F00000&(data))>>20)
+#define VO_V1_MC_28_get_luma_out_mode(data)                                          ((0x00F00000&(data))>>20)
+#define VO_V1_MC_28_chroma_out_mode_shift                                            (16)
+#define VO_V1_MC_28_chroma_out_mode_mask                                             (0x000F0000)
+#define VO_V1_MC_28_chroma_out_mode(data)                                            (0x000F0000&((data)<<16))
+#define VO_V1_MC_28_chroma_out_mode_src(data)                                        ((0x000F0000&(data))>>16)
+#define VO_V1_MC_28_get_chroma_out_mode(data)                                        ((0x000F0000&(data))>>16)
+#define VO_V1_MC_28_hsync_period_shift                                               (0)
+#define VO_V1_MC_28_hsync_period_mask                                                (0x00003FFF)
+#define VO_V1_MC_28_hsync_period(data)                                               (0x00003FFF&((data)<<0))
+#define VO_V1_MC_28_hsync_period_src(data)                                           ((0x00003FFF&(data))>>0)
+#define VO_V1_MC_28_get_hsync_period(data)                                           ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_MC_2C                                                                  0x9800509C
+#define VO_V1_MC_2C_reg_addr                                                         "0xD800509C"
+#define VO_V1_MC_2C_reg                                                              0xD800509C
+#define set_VO_V1_MC_2C_reg(data)   (*((volatile unsigned int*) VO_V1_MC_2C_reg)=data)
+#define get_VO_V1_MC_2C_reg   (*((volatile unsigned int*) VO_V1_MC_2C_reg))
+#define VO_V1_MC_2C_inst_adr                                                         "0x0027"
+#define VO_V1_MC_2C_inst                                                             0x0027
+#define VO_V1_MC_2C_time_out_count_shift                                             (0)
+#define VO_V1_MC_2C_time_out_count_mask                                              (0x0000FFFF)
+#define VO_V1_MC_2C_time_out_count(data)                                             (0x0000FFFF&((data)<<0))
+#define VO_V1_MC_2C_time_out_count_src(data)                                         ((0x0000FFFF&(data))>>0)
+#define VO_V1_MC_2C_get_time_out_count(data)                                         ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_MC_30                                                                  0x980050A0
+#define VO_V1_MC_30_reg_addr                                                         "0xD80050A0"
+#define VO_V1_MC_30_reg                                                              0xD80050A0
+#define set_VO_V1_MC_30_reg(data)   (*((volatile unsigned int*) VO_V1_MC_30_reg)=data)
+#define get_VO_V1_MC_30_reg   (*((volatile unsigned int*) VO_V1_MC_30_reg))
+#define VO_V1_MC_30_inst_adr                                                         "0x0028"
+#define VO_V1_MC_30_inst                                                             0x0028
+#define VO_V1_MC_30_offset_endian_shift                                              (4)
+#define VO_V1_MC_30_offset_endian_mask                                               (0x000000F0)
+#define VO_V1_MC_30_offset_endian(data)                                              (0x000000F0&((data)<<4))
+#define VO_V1_MC_30_offset_endian_src(data)                                          ((0x000000F0&(data))>>4)
+#define VO_V1_MC_30_get_offset_endian(data)                                          ((0x000000F0&(data))>>4)
+#define VO_V1_MC_30_data_endian_shift                                                (0)
+#define VO_V1_MC_30_data_endian_mask                                                 (0x0000000F)
+#define VO_V1_MC_30_data_endian(data)                                                (0x0000000F&((data)<<0))
+#define VO_V1_MC_30_data_endian_src(data)                                            ((0x0000000F&(data))>>0)
+#define VO_V1_MC_30_get_data_endian(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define VO_V1_MC_34                                                                  0x980050A4
+#define VO_V1_MC_34_reg_addr                                                         "0xD80050A4"
+#define VO_V1_MC_34_reg                                                              0xD80050A4
+#define set_VO_V1_MC_34_reg(data)   (*((volatile unsigned int*) VO_V1_MC_34_reg)=data)
+#define get_VO_V1_MC_34_reg   (*((volatile unsigned int*) VO_V1_MC_34_reg))
+#define VO_V1_MC_34_inst_adr                                                         "0x0029"
+#define VO_V1_MC_34_inst                                                             0x0029
+#define VO_V1_MC_34_luma_bit_depth_shift                                             (2)
+#define VO_V1_MC_34_luma_bit_depth_mask                                              (0x0000000C)
+#define VO_V1_MC_34_luma_bit_depth(data)                                             (0x0000000C&((data)<<2))
+#define VO_V1_MC_34_luma_bit_depth_src(data)                                         ((0x0000000C&(data))>>2)
+#define VO_V1_MC_34_get_luma_bit_depth(data)                                         ((0x0000000C&(data))>>2)
+#define VO_V1_MC_34_chroma_bit_depth_shift                                           (0)
+#define VO_V1_MC_34_chroma_bit_depth_mask                                            (0x00000003)
+#define VO_V1_MC_34_chroma_bit_depth(data)                                           (0x00000003&((data)<<0))
+#define VO_V1_MC_34_chroma_bit_depth_src(data)                                       ((0x00000003&(data))>>0)
+#define VO_V1_MC_34_get_chroma_bit_depth(data)                                       ((0x00000003&(data))>>0)
+
+
+#define VO_V1_TILE                                                                   0x980050A8
+#define VO_V1_TILE_reg_addr                                                          "0xD80050A8"
+#define VO_V1_TILE_reg                                                               0xD80050A8
+#define set_VO_V1_TILE_reg(data)   (*((volatile unsigned int*) VO_V1_TILE_reg)=data)
+#define get_VO_V1_TILE_reg   (*((volatile unsigned int*) VO_V1_TILE_reg))
+#define VO_V1_TILE_inst_adr                                                          "0x002A"
+#define VO_V1_TILE_inst                                                              0x002A
+#define VO_V1_TILE_mc_f422_shift                                                     (5)
+#define VO_V1_TILE_mc_f422_mask                                                      (0x00000020)
+#define VO_V1_TILE_mc_f422(data)                                                     (0x00000020&((data)<<5))
+#define VO_V1_TILE_mc_f422_src(data)                                                 ((0x00000020&(data))>>5)
+#define VO_V1_TILE_get_mc_f422(data)                                                 ((0x00000020&(data))>>5)
+#define VO_V1_TILE_data_endian_shift                                                 (4)
+#define VO_V1_TILE_data_endian_mask                                                  (0x00000010)
+#define VO_V1_TILE_data_endian(data)                                                 (0x00000010&((data)<<4))
+#define VO_V1_TILE_data_endian_src(data)                                             ((0x00000010&(data))>>4)
+#define VO_V1_TILE_get_data_endian(data)                                             ((0x00000010&(data))>>4)
+#define VO_V1_TILE_size_shift                                                        (0)
+#define VO_V1_TILE_size_mask                                                         (0x00000003)
+#define VO_V1_TILE_size(data)                                                        (0x00000003&((data)<<0))
+#define VO_V1_TILE_size_src(data)                                                    ((0x00000003&(data))>>0)
+#define VO_V1_TILE_get_size(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define VO_V1_DI                                                                     0x980050AC
+#define VO_V1_DI_reg_addr                                                            "0xD80050AC"
+#define VO_V1_DI_reg                                                                 0xD80050AC
+#define set_VO_V1_DI_reg(data)   (*((volatile unsigned int*) VO_V1_DI_reg)=data)
+#define get_VO_V1_DI_reg   (*((volatile unsigned int*) VO_V1_DI_reg))
+#define VO_V1_DI_inst_adr                                                            "0x002B"
+#define VO_V1_DI_inst                                                                0x002B
+#define VO_V1_DI_mode_shift                                                          (0)
+#define VO_V1_DI_mode_mask                                                           (0x00000003)
+#define VO_V1_DI_mode(data)                                                          (0x00000003&((data)<<0))
+#define VO_V1_DI_mode_src(data)                                                      ((0x00000003&(data))>>0)
+#define VO_V1_DI_get_mode(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_N_Y                                                          0x980050B0
+#define VO_V1_DI_SEQ_SA_N_Y_reg_addr                                                 "0xD80050B0"
+#define VO_V1_DI_SEQ_SA_N_Y_reg                                                      0xD80050B0
+#define set_VO_V1_DI_SEQ_SA_N_Y_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_Y_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_N_Y_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_Y_reg))
+#define VO_V1_DI_SEQ_SA_N_Y_inst_adr                                                 "0x002C"
+#define VO_V1_DI_SEQ_SA_N_Y_inst                                                     0x002C
+#define VO_V1_DI_SEQ_SA_N_Y_a_shift                                                  (0)
+#define VO_V1_DI_SEQ_SA_N_Y_a_mask                                                   (0xFFFFFFFF)
+#define VO_V1_DI_SEQ_SA_N_Y_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_N_Y_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_N_Y_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_N_C                                                          0x980050B4
+#define VO_V1_DI_SEQ_SA_N_C_reg_addr                                                 "0xD80050B4"
+#define VO_V1_DI_SEQ_SA_N_C_reg                                                      0xD80050B4
+#define set_VO_V1_DI_SEQ_SA_N_C_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_C_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_N_C_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_C_reg))
+#define VO_V1_DI_SEQ_SA_N_C_inst_adr                                                 "0x002D"
+#define VO_V1_DI_SEQ_SA_N_C_inst                                                     0x002D
+#define VO_V1_DI_SEQ_SA_N_C_a_shift                                                  (0)
+#define VO_V1_DI_SEQ_SA_N_C_a_mask                                                   (0xFFFFFFFF)
+#define VO_V1_DI_SEQ_SA_N_C_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_N_C_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_N_C_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_P_Y                                                          0x980050B8
+#define VO_V1_DI_SEQ_SA_P_Y_reg_addr                                                 "0xD80050B8"
+#define VO_V1_DI_SEQ_SA_P_Y_reg                                                      0xD80050B8
+#define set_VO_V1_DI_SEQ_SA_P_Y_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_Y_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_P_Y_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_Y_reg))
+#define VO_V1_DI_SEQ_SA_P_Y_inst_adr                                                 "0x002E"
+#define VO_V1_DI_SEQ_SA_P_Y_inst                                                     0x002E
+#define VO_V1_DI_SEQ_SA_P_Y_a_shift                                                  (0)
+#define VO_V1_DI_SEQ_SA_P_Y_a_mask                                                   (0xFFFFFFFF)
+#define VO_V1_DI_SEQ_SA_P_Y_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_P_Y_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_P_Y_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_P_C                                                          0x980050BC
+#define VO_V1_DI_SEQ_SA_P_C_reg_addr                                                 "0xD80050BC"
+#define VO_V1_DI_SEQ_SA_P_C_reg                                                      0xD80050BC
+#define set_VO_V1_DI_SEQ_SA_P_C_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_C_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_P_C_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_C_reg))
+#define VO_V1_DI_SEQ_SA_P_C_inst_adr                                                 "0x002F"
+#define VO_V1_DI_SEQ_SA_P_C_inst                                                     0x002F
+#define VO_V1_DI_SEQ_SA_P_C_a_shift                                                  (0)
+#define VO_V1_DI_SEQ_SA_P_C_a_mask                                                   (0xFFFFFFFF)
+#define VO_V1_DI_SEQ_SA_P_C_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_P_C_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_P_C_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_N_Y                                                          0x980050C0
+#define VO_V1_SEQ_PITCH_N_Y_reg_addr                                                 "0xD80050C0"
+#define VO_V1_SEQ_PITCH_N_Y_reg                                                      0xD80050C0
+#define set_VO_V1_SEQ_PITCH_N_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_N_Y_reg)=data)
+#define get_VO_V1_SEQ_PITCH_N_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_N_Y_reg))
+#define VO_V1_SEQ_PITCH_N_Y_inst_adr                                                 "0x0030"
+#define VO_V1_SEQ_PITCH_N_Y_inst                                                     0x0030
+#define VO_V1_SEQ_PITCH_N_Y_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_N_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_N_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_N_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_N_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_N_C                                                          0x980050C4
+#define VO_V1_SEQ_PITCH_N_C_reg_addr                                                 "0xD80050C4"
+#define VO_V1_SEQ_PITCH_N_C_reg                                                      0xD80050C4
+#define set_VO_V1_SEQ_PITCH_N_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_N_C_reg)=data)
+#define get_VO_V1_SEQ_PITCH_N_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_N_C_reg))
+#define VO_V1_SEQ_PITCH_N_C_inst_adr                                                 "0x0031"
+#define VO_V1_SEQ_PITCH_N_C_inst                                                     0x0031
+#define VO_V1_SEQ_PITCH_N_C_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_N_C_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_N_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_N_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_N_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_P_Y                                                          0x980050C8
+#define VO_V1_SEQ_PITCH_P_Y_reg_addr                                                 "0xD80050C8"
+#define VO_V1_SEQ_PITCH_P_Y_reg                                                      0xD80050C8
+#define set_VO_V1_SEQ_PITCH_P_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_P_Y_reg)=data)
+#define get_VO_V1_SEQ_PITCH_P_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_P_Y_reg))
+#define VO_V1_SEQ_PITCH_P_Y_inst_adr                                                 "0x0032"
+#define VO_V1_SEQ_PITCH_P_Y_inst                                                     0x0032
+#define VO_V1_SEQ_PITCH_P_Y_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_P_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_P_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_P_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_P_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_P_C                                                          0x980050CC
+#define VO_V1_SEQ_PITCH_P_C_reg_addr                                                 "0xD80050CC"
+#define VO_V1_SEQ_PITCH_P_C_reg                                                      0xD80050CC
+#define set_VO_V1_SEQ_PITCH_P_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_P_C_reg)=data)
+#define get_VO_V1_SEQ_PITCH_P_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_P_C_reg))
+#define VO_V1_SEQ_PITCH_P_C_inst_adr                                                 "0x0033"
+#define VO_V1_SEQ_PITCH_P_C_inst                                                     0x0033
+#define VO_V1_SEQ_PITCH_P_C_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_P_C_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_P_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_P_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_P_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_N_Y_3D                                                       0x980050D0
+#define VO_V1_DI_SEQ_SA_N_Y_3D_reg_addr                                              "0xD80050D0"
+#define VO_V1_DI_SEQ_SA_N_Y_3D_reg                                                   0xD80050D0
+#define set_VO_V1_DI_SEQ_SA_N_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_Y_3D_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_N_Y_3D_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_Y_3D_reg))
+#define VO_V1_DI_SEQ_SA_N_Y_3D_inst_adr                                              "0x0034"
+#define VO_V1_DI_SEQ_SA_N_Y_3D_inst                                                  0x0034
+#define VO_V1_DI_SEQ_SA_N_Y_3D_a_shift                                               (0)
+#define VO_V1_DI_SEQ_SA_N_Y_3D_a_mask                                                (0xFFFFFFFF)
+#define VO_V1_DI_SEQ_SA_N_Y_3D_a(data)                                               (0xFFFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_N_Y_3D_a_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_N_Y_3D_get_a(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_N_C_3D                                                       0x980050D4
+#define VO_V1_DI_SEQ_SA_N_C_3D_reg_addr                                              "0xD80050D4"
+#define VO_V1_DI_SEQ_SA_N_C_3D_reg                                                   0xD80050D4
+#define set_VO_V1_DI_SEQ_SA_N_C_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_C_3D_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_N_C_3D_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_C_3D_reg))
+#define VO_V1_DI_SEQ_SA_N_C_3D_inst_adr                                              "0x0035"
+#define VO_V1_DI_SEQ_SA_N_C_3D_inst                                                  0x0035
+#define VO_V1_DI_SEQ_SA_N_C_3D_a_shift                                               (0)
+#define VO_V1_DI_SEQ_SA_N_C_3D_a_mask                                                (0xFFFFFFFF)
+#define VO_V1_DI_SEQ_SA_N_C_3D_a(data)                                               (0xFFFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_N_C_3D_a_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_N_C_3D_get_a(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_P_Y_3D                                                       0x980050D8
+#define VO_V1_DI_SEQ_SA_P_Y_3D_reg_addr                                              "0xD80050D8"
+#define VO_V1_DI_SEQ_SA_P_Y_3D_reg                                                   0xD80050D8
+#define set_VO_V1_DI_SEQ_SA_P_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_Y_3D_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_P_Y_3D_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_Y_3D_reg))
+#define VO_V1_DI_SEQ_SA_P_Y_3D_inst_adr                                              "0x0036"
+#define VO_V1_DI_SEQ_SA_P_Y_3D_inst                                                  0x0036
+#define VO_V1_DI_SEQ_SA_P_Y_3D_a_shift                                               (0)
+#define VO_V1_DI_SEQ_SA_P_Y_3D_a_mask                                                (0xFFFFFFFF)
+#define VO_V1_DI_SEQ_SA_P_Y_3D_a(data)                                               (0xFFFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_P_Y_3D_a_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_P_Y_3D_get_a(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_P_C_3D                                                       0x980050DC
+#define VO_V1_DI_SEQ_SA_P_C_3D_reg_addr                                              "0xD80050DC"
+#define VO_V1_DI_SEQ_SA_P_C_3D_reg                                                   0xD80050DC
+#define set_VO_V1_DI_SEQ_SA_P_C_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_C_3D_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_P_C_3D_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_C_3D_reg))
+#define VO_V1_DI_SEQ_SA_P_C_3D_inst_adr                                              "0x0037"
+#define VO_V1_DI_SEQ_SA_P_C_3D_inst                                                  0x0037
+#define VO_V1_DI_SEQ_SA_P_C_3D_a_shift                                               (0)
+#define VO_V1_DI_SEQ_SA_P_C_3D_a_mask                                                (0xFFFFFFFF)
+#define VO_V1_DI_SEQ_SA_P_C_3D_a(data)                                               (0xFFFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_P_C_3D_a_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_P_C_3D_get_a(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_3F_RR                                                               0x980050E0
+#define VO_V1_DI_3F_RR_reg_addr                                                      "0xD80050E0"
+#define VO_V1_DI_3F_RR_reg                                                           0xD80050E0
+#define set_VO_V1_DI_3F_RR_reg(data)   (*((volatile unsigned int*) VO_V1_DI_3F_RR_reg)=data)
+#define get_VO_V1_DI_3F_RR_reg   (*((volatile unsigned int*) VO_V1_DI_3F_RR_reg))
+#define VO_V1_DI_3F_RR_inst_adr                                                      "0x0038"
+#define VO_V1_DI_3F_RR_inst                                                          0x0038
+#define VO_V1_DI_3F_RR_n_c_en_shift                                                  (15)
+#define VO_V1_DI_3F_RR_n_c_en_mask                                                   (0x00008000)
+#define VO_V1_DI_3F_RR_n_c_en(data)                                                  (0x00008000&((data)<<15))
+#define VO_V1_DI_3F_RR_n_c_en_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_V1_DI_3F_RR_get_n_c_en(data)                                              ((0x00008000&(data))>>15)
+#define VO_V1_DI_3F_RR_n_c_shift                                                     (12)
+#define VO_V1_DI_3F_RR_n_c_mask                                                      (0x00007000)
+#define VO_V1_DI_3F_RR_n_c(data)                                                     (0x00007000&((data)<<12))
+#define VO_V1_DI_3F_RR_n_c_src(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_DI_3F_RR_get_n_c(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_DI_3F_RR_n_y_en_shift                                                  (11)
+#define VO_V1_DI_3F_RR_n_y_en_mask                                                   (0x00000800)
+#define VO_V1_DI_3F_RR_n_y_en(data)                                                  (0x00000800&((data)<<11))
+#define VO_V1_DI_3F_RR_n_y_en_src(data)                                              ((0x00000800&(data))>>11)
+#define VO_V1_DI_3F_RR_get_n_y_en(data)                                              ((0x00000800&(data))>>11)
+#define VO_V1_DI_3F_RR_n_y_shift                                                     (8)
+#define VO_V1_DI_3F_RR_n_y_mask                                                      (0x00000700)
+#define VO_V1_DI_3F_RR_n_y(data)                                                     (0x00000700&((data)<<8))
+#define VO_V1_DI_3F_RR_n_y_src(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_DI_3F_RR_get_n_y(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_DI_3F_RR_p_c_en_shift                                                  (7)
+#define VO_V1_DI_3F_RR_p_c_en_mask                                                   (0x00000080)
+#define VO_V1_DI_3F_RR_p_c_en(data)                                                  (0x00000080&((data)<<7))
+#define VO_V1_DI_3F_RR_p_c_en_src(data)                                              ((0x00000080&(data))>>7)
+#define VO_V1_DI_3F_RR_get_p_c_en(data)                                              ((0x00000080&(data))>>7)
+#define VO_V1_DI_3F_RR_p_c_shift                                                     (4)
+#define VO_V1_DI_3F_RR_p_c_mask                                                      (0x00000070)
+#define VO_V1_DI_3F_RR_p_c(data)                                                     (0x00000070&((data)<<4))
+#define VO_V1_DI_3F_RR_p_c_src(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V1_DI_3F_RR_get_p_c(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V1_DI_3F_RR_p_y_en_shift                                                  (3)
+#define VO_V1_DI_3F_RR_p_y_en_mask                                                   (0x00000008)
+#define VO_V1_DI_3F_RR_p_y_en(data)                                                  (0x00000008&((data)<<3))
+#define VO_V1_DI_3F_RR_p_y_en_src(data)                                              ((0x00000008&(data))>>3)
+#define VO_V1_DI_3F_RR_get_p_y_en(data)                                              ((0x00000008&(data))>>3)
+#define VO_V1_DI_3F_RR_p_y_shift                                                     (0)
+#define VO_V1_DI_3F_RR_p_y_mask                                                      (0x00000007)
+#define VO_V1_DI_3F_RR_p_y(data)                                                     (0x00000007&((data)<<0))
+#define VO_V1_DI_3F_RR_p_y_src(data)                                                 ((0x00000007&(data))>>0)
+#define VO_V1_DI_3F_RR_get_p_y(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define VO_V1_DI_3F_RR_3D                                                            0x980050E4
+#define VO_V1_DI_3F_RR_3D_reg_addr                                                   "0xD80050E4"
+#define VO_V1_DI_3F_RR_3D_reg                                                        0xD80050E4
+#define set_VO_V1_DI_3F_RR_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_3F_RR_3D_reg)=data)
+#define get_VO_V1_DI_3F_RR_3D_reg   (*((volatile unsigned int*) VO_V1_DI_3F_RR_3D_reg))
+#define VO_V1_DI_3F_RR_3D_inst_adr                                                   "0x0039"
+#define VO_V1_DI_3F_RR_3D_inst                                                       0x0039
+#define VO_V1_DI_3F_RR_3D_n_c_en_shift                                               (15)
+#define VO_V1_DI_3F_RR_3D_n_c_en_mask                                                (0x00008000)
+#define VO_V1_DI_3F_RR_3D_n_c_en(data)                                               (0x00008000&((data)<<15))
+#define VO_V1_DI_3F_RR_3D_n_c_en_src(data)                                           ((0x00008000&(data))>>15)
+#define VO_V1_DI_3F_RR_3D_get_n_c_en(data)                                           ((0x00008000&(data))>>15)
+#define VO_V1_DI_3F_RR_3D_n_c_shift                                                  (12)
+#define VO_V1_DI_3F_RR_3D_n_c_mask                                                   (0x00007000)
+#define VO_V1_DI_3F_RR_3D_n_c(data)                                                  (0x00007000&((data)<<12))
+#define VO_V1_DI_3F_RR_3D_n_c_src(data)                                              ((0x00007000&(data))>>12)
+#define VO_V1_DI_3F_RR_3D_get_n_c(data)                                              ((0x00007000&(data))>>12)
+#define VO_V1_DI_3F_RR_3D_n_y_en_shift                                               (11)
+#define VO_V1_DI_3F_RR_3D_n_y_en_mask                                                (0x00000800)
+#define VO_V1_DI_3F_RR_3D_n_y_en(data)                                               (0x00000800&((data)<<11))
+#define VO_V1_DI_3F_RR_3D_n_y_en_src(data)                                           ((0x00000800&(data))>>11)
+#define VO_V1_DI_3F_RR_3D_get_n_y_en(data)                                           ((0x00000800&(data))>>11)
+#define VO_V1_DI_3F_RR_3D_n_y_shift                                                  (8)
+#define VO_V1_DI_3F_RR_3D_n_y_mask                                                   (0x00000700)
+#define VO_V1_DI_3F_RR_3D_n_y(data)                                                  (0x00000700&((data)<<8))
+#define VO_V1_DI_3F_RR_3D_n_y_src(data)                                              ((0x00000700&(data))>>8)
+#define VO_V1_DI_3F_RR_3D_get_n_y(data)                                              ((0x00000700&(data))>>8)
+#define VO_V1_DI_3F_RR_3D_p_c_en_shift                                               (7)
+#define VO_V1_DI_3F_RR_3D_p_c_en_mask                                                (0x00000080)
+#define VO_V1_DI_3F_RR_3D_p_c_en(data)                                               (0x00000080&((data)<<7))
+#define VO_V1_DI_3F_RR_3D_p_c_en_src(data)                                           ((0x00000080&(data))>>7)
+#define VO_V1_DI_3F_RR_3D_get_p_c_en(data)                                           ((0x00000080&(data))>>7)
+#define VO_V1_DI_3F_RR_3D_p_c_shift                                                  (4)
+#define VO_V1_DI_3F_RR_3D_p_c_mask                                                   (0x00000070)
+#define VO_V1_DI_3F_RR_3D_p_c(data)                                                  (0x00000070&((data)<<4))
+#define VO_V1_DI_3F_RR_3D_p_c_src(data)                                              ((0x00000070&(data))>>4)
+#define VO_V1_DI_3F_RR_3D_get_p_c(data)                                              ((0x00000070&(data))>>4)
+#define VO_V1_DI_3F_RR_3D_p_y_en_shift                                               (3)
+#define VO_V1_DI_3F_RR_3D_p_y_en_mask                                                (0x00000008)
+#define VO_V1_DI_3F_RR_3D_p_y_en(data)                                               (0x00000008&((data)<<3))
+#define VO_V1_DI_3F_RR_3D_p_y_en_src(data)                                           ((0x00000008&(data))>>3)
+#define VO_V1_DI_3F_RR_3D_get_p_y_en(data)                                           ((0x00000008&(data))>>3)
+#define VO_V1_DI_3F_RR_3D_p_y_shift                                                  (0)
+#define VO_V1_DI_3F_RR_3D_p_y_mask                                                   (0x00000007)
+#define VO_V1_DI_3F_RR_3D_p_y(data)                                                  (0x00000007&((data)<<0))
+#define VO_V1_DI_3F_RR_3D_p_y_src(data)                                              ((0x00000007&(data))>>0)
+#define VO_V1_DI_3F_RR_3D_get_p_y(data)                                              ((0x00000007&(data))>>0)
+
+
+#define VO_V1_MA_FR                                                                  0x980050E8
+#define VO_V1_MA_FR_reg_addr                                                         "0xD80050E8"
+#define VO_V1_MA_FR_reg                                                              0xD80050E8
+#define set_VO_V1_MA_FR_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FR_reg)=data)
+#define get_VO_V1_MA_FR_reg   (*((volatile unsigned int*) VO_V1_MA_FR_reg))
+#define VO_V1_MA_FR_inst_adr                                                         "0x003A"
+#define VO_V1_MA_FR_inst                                                             0x003A
+#define VO_V1_MA_FR_a_shift                                                          (0)
+#define VO_V1_MA_FR_a_mask                                                           (0xFFFFFFFF)
+#define VO_V1_MA_FR_a(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define VO_V1_MA_FR_a_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_MA_FR_get_a(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_MA_FR_3D                                                               0x980050EC
+#define VO_V1_MA_FR_3D_reg_addr                                                      "0xD80050EC"
+#define VO_V1_MA_FR_3D_reg                                                           0xD80050EC
+#define set_VO_V1_MA_FR_3D_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FR_3D_reg)=data)
+#define get_VO_V1_MA_FR_3D_reg   (*((volatile unsigned int*) VO_V1_MA_FR_3D_reg))
+#define VO_V1_MA_FR_3D_inst_adr                                                      "0x003B"
+#define VO_V1_MA_FR_3D_inst                                                          0x003B
+#define VO_V1_MA_FR_3D_a_shift                                                       (0)
+#define VO_V1_MA_FR_3D_a_mask                                                        (0xFFFFFFFF)
+#define VO_V1_MA_FR_3D_a(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define VO_V1_MA_FR_3D_a_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_MA_FR_3D_get_a(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_MA_FW                                                                  0x980050F0
+#define VO_V1_MA_FW_reg_addr                                                         "0xD80050F0"
+#define VO_V1_MA_FW_reg                                                              0xD80050F0
+#define set_VO_V1_MA_FW_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FW_reg)=data)
+#define get_VO_V1_MA_FW_reg   (*((volatile unsigned int*) VO_V1_MA_FW_reg))
+#define VO_V1_MA_FW_inst_adr                                                         "0x003C"
+#define VO_V1_MA_FW_inst                                                             0x003C
+#define VO_V1_MA_FW_a_shift                                                          (0)
+#define VO_V1_MA_FW_a_mask                                                           (0xFFFFFFFF)
+#define VO_V1_MA_FW_a(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define VO_V1_MA_FW_a_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_MA_FW_get_a(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_MA_FW_3D                                                               0x980050F4
+#define VO_V1_MA_FW_3D_reg_addr                                                      "0xD80050F4"
+#define VO_V1_MA_FW_3D_reg                                                           0xD80050F4
+#define set_VO_V1_MA_FW_3D_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FW_3D_reg)=data)
+#define get_VO_V1_MA_FW_3D_reg   (*((volatile unsigned int*) VO_V1_MA_FW_3D_reg))
+#define VO_V1_MA_FW_3D_inst_adr                                                      "0x003D"
+#define VO_V1_MA_FW_3D_inst                                                          0x003D
+#define VO_V1_MA_FW_3D_a_shift                                                       (0)
+#define VO_V1_MA_FW_3D_a_mask                                                        (0xFFFFFFFF)
+#define VO_V1_MA_FW_3D_a(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define VO_V1_MA_FW_3D_a_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_MA_FW_3D_get_a(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_INTRA                                                                  0x980050F8
+#define VO_V1_INTRA_reg_addr                                                         "0xD80050F8"
+#define VO_V1_INTRA_reg                                                              0xD80050F8
+#define set_VO_V1_INTRA_reg(data)   (*((volatile unsigned int*) VO_V1_INTRA_reg)=data)
+#define get_VO_V1_INTRA_reg   (*((volatile unsigned int*) VO_V1_INTRA_reg))
+#define VO_V1_INTRA_inst_adr                                                         "0x003E"
+#define VO_V1_INTRA_inst                                                             0x003E
+#define VO_V1_INTRA_c_range_shift                                                    (26)
+#define VO_V1_INTRA_c_range_mask                                                     (0x04000000)
+#define VO_V1_INTRA_c_range(data)                                                    (0x04000000&((data)<<26))
+#define VO_V1_INTRA_c_range_src(data)                                                ((0x04000000&(data))>>26)
+#define VO_V1_INTRA_get_c_range(data)                                                ((0x04000000&(data))>>26)
+#define VO_V1_INTRA_y_range_shift                                                    (24)
+#define VO_V1_INTRA_y_range_mask                                                     (0x03000000)
+#define VO_V1_INTRA_y_range(data)                                                    (0x03000000&((data)<<24))
+#define VO_V1_INTRA_y_range_src(data)                                                ((0x03000000&(data))>>24)
+#define VO_V1_INTRA_get_y_range(data)                                                ((0x03000000&(data))>>24)
+#define VO_V1_INTRA_th_pos_shift                                                     (16)
+#define VO_V1_INTRA_th_pos_mask                                                      (0x001F0000)
+#define VO_V1_INTRA_th_pos(data)                                                     (0x001F0000&((data)<<16))
+#define VO_V1_INTRA_th_pos_src(data)                                                 ((0x001F0000&(data))>>16)
+#define VO_V1_INTRA_get_th_pos(data)                                                 ((0x001F0000&(data))>>16)
+#define VO_V1_INTRA_th_prediff_shift                                                 (8)
+#define VO_V1_INTRA_th_prediff_mask                                                  (0x00007F00)
+#define VO_V1_INTRA_th_prediff(data)                                                 (0x00007F00&((data)<<8))
+#define VO_V1_INTRA_th_prediff_src(data)                                             ((0x00007F00&(data))>>8)
+#define VO_V1_INTRA_get_th_prediff(data)                                             ((0x00007F00&(data))>>8)
+#define VO_V1_INTRA_th_refdiff_shift                                                 (0)
+#define VO_V1_INTRA_th_refdiff_mask                                                  (0x0000003F)
+#define VO_V1_INTRA_th_refdiff(data)                                                 (0x0000003F&((data)<<0))
+#define VO_V1_INTRA_th_refdiff_src(data)                                             ((0x0000003F&(data))>>0)
+#define VO_V1_INTRA_get_th_refdiff(data)                                             ((0x0000003F&(data))>>0)
+
+
+#define VO_V1_MA                                                                     0x980050FC
+#define VO_V1_MA_reg_addr                                                            "0xD80050FC"
+#define VO_V1_MA_reg                                                                 0xD80050FC
+#define set_VO_V1_MA_reg(data)   (*((volatile unsigned int*) VO_V1_MA_reg)=data)
+#define get_VO_V1_MA_reg   (*((volatile unsigned int*) VO_V1_MA_reg))
+#define VO_V1_MA_inst_adr                                                            "0x003F"
+#define VO_V1_MA_inst                                                                0x003F
+#define VO_V1_MA_split_shift                                                         (31)
+#define VO_V1_MA_split_mask                                                          (0x80000000)
+#define VO_V1_MA_split(data)                                                         (0x80000000&((data)<<31))
+#define VO_V1_MA_split_src(data)                                                     ((0x80000000&(data))>>31)
+#define VO_V1_MA_get_split(data)                                                     ((0x80000000&(data))>>31)
+#define VO_V1_MA_c_intra_shift                                                       (30)
+#define VO_V1_MA_c_intra_mask                                                        (0x40000000)
+#define VO_V1_MA_c_intra(data)                                                       (0x40000000&((data)<<30))
+#define VO_V1_MA_c_intra_src(data)                                                   ((0x40000000&(data))>>30)
+#define VO_V1_MA_get_c_intra(data)                                                   ((0x40000000&(data))>>30)
+#define VO_V1_MA_lp_shift                                                            (29)
+#define VO_V1_MA_lp_mask                                                             (0x20000000)
+#define VO_V1_MA_lp(data)                                                            (0x20000000&((data)<<29))
+#define VO_V1_MA_lp_src(data)                                                        ((0x20000000&(data))>>29)
+#define VO_V1_MA_get_lp(data)                                                        ((0x20000000&(data))>>29)
+#define VO_V1_MA_fm_shift                                                            (28)
+#define VO_V1_MA_fm_mask                                                             (0x10000000)
+#define VO_V1_MA_fm(data)                                                            (0x10000000&((data)<<28))
+#define VO_V1_MA_fm_src(data)                                                        ((0x10000000&(data))>>28)
+#define VO_V1_MA_get_fm(data)                                                        ((0x10000000&(data))>>28)
+#define VO_V1_MA_sc_shift                                                            (24)
+#define VO_V1_MA_sc_mask                                                             (0x07000000)
+#define VO_V1_MA_sc(data)                                                            (0x07000000&((data)<<24))
+#define VO_V1_MA_sc_src(data)                                                        ((0x07000000&(data))>>24)
+#define VO_V1_MA_get_sc(data)                                                        ((0x07000000&(data))>>24)
+#define VO_V1_MA_th_noise_shift                                                      (16)
+#define VO_V1_MA_th_noise_mask                                                       (0x00FF0000)
+#define VO_V1_MA_th_noise(data)                                                      (0x00FF0000&((data)<<16))
+#define VO_V1_MA_th_noise_src(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V1_MA_get_th_noise(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V1_MA_th_c_shift                                                          (8)
+#define VO_V1_MA_th_c_mask                                                           (0x0000FF00)
+#define VO_V1_MA_th_c(data)                                                          (0x0000FF00&((data)<<8))
+#define VO_V1_MA_th_c_src(data)                                                      ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_get_th_c(data)                                                      ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_th_y_shift                                                          (0)
+#define VO_V1_MA_th_y_mask                                                           (0x000000FF)
+#define VO_V1_MA_th_y(data)                                                          (0x000000FF&((data)<<0))
+#define VO_V1_MA_th_y_src(data)                                                      ((0x000000FF&(data))>>0)
+#define VO_V1_MA_get_th_y(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_MA_NEW                                                                 0x98005100
+#define VO_V1_MA_NEW_reg_addr                                                        "0xD8005100"
+#define VO_V1_MA_NEW_reg                                                             0xD8005100
+#define set_VO_V1_MA_NEW_reg(data)   (*((volatile unsigned int*) VO_V1_MA_NEW_reg)=data)
+#define get_VO_V1_MA_NEW_reg   (*((volatile unsigned int*) VO_V1_MA_NEW_reg))
+#define VO_V1_MA_NEW_inst_adr                                                        "0x0040"
+#define VO_V1_MA_NEW_inst                                                            0x0040
+#define VO_V1_MA_NEW_correct_shift                                                   (8)
+#define VO_V1_MA_NEW_correct_mask                                                    (0x00000100)
+#define VO_V1_MA_NEW_correct(data)                                                   (0x00000100&((data)<<8))
+#define VO_V1_MA_NEW_correct_src(data)                                               ((0x00000100&(data))>>8)
+#define VO_V1_MA_NEW_get_correct(data)                                               ((0x00000100&(data))>>8)
+#define VO_V1_MA_NEW_fm_shift                                                        (7)
+#define VO_V1_MA_NEW_fm_mask                                                         (0x00000080)
+#define VO_V1_MA_NEW_fm(data)                                                        (0x00000080&((data)<<7))
+#define VO_V1_MA_NEW_fm_src(data)                                                    ((0x00000080&(data))>>7)
+#define VO_V1_MA_NEW_get_fm(data)                                                    ((0x00000080&(data))>>7)
+#define VO_V1_MA_NEW_limit_shift                                                     (6)
+#define VO_V1_MA_NEW_limit_mask                                                      (0x00000040)
+#define VO_V1_MA_NEW_limit(data)                                                     (0x00000040&((data)<<6))
+#define VO_V1_MA_NEW_limit_src(data)                                                 ((0x00000040&(data))>>6)
+#define VO_V1_MA_NEW_get_limit(data)                                                 ((0x00000040&(data))>>6)
+#define VO_V1_MA_NEW_weave_shift                                                     (5)
+#define VO_V1_MA_NEW_weave_mask                                                      (0x00000020)
+#define VO_V1_MA_NEW_weave(data)                                                     (0x00000020&((data)<<5))
+#define VO_V1_MA_NEW_weave_src(data)                                                 ((0x00000020&(data))>>5)
+#define VO_V1_MA_NEW_get_weave(data)                                                 ((0x00000020&(data))>>5)
+#define VO_V1_MA_NEW_blend_shift                                                     (4)
+#define VO_V1_MA_NEW_blend_mask                                                      (0x00000010)
+#define VO_V1_MA_NEW_blend(data)                                                     (0x00000010&((data)<<4))
+#define VO_V1_MA_NEW_blend_src(data)                                                 ((0x00000010&(data))>>4)
+#define VO_V1_MA_NEW_get_blend(data)                                                 ((0x00000010&(data))>>4)
+#define VO_V1_MA_NEW_noisy_high_shift                                                (3)
+#define VO_V1_MA_NEW_noisy_high_mask                                                 (0x00000008)
+#define VO_V1_MA_NEW_noisy_high(data)                                                (0x00000008&((data)<<3))
+#define VO_V1_MA_NEW_noisy_high_src(data)                                            ((0x00000008&(data))>>3)
+#define VO_V1_MA_NEW_get_noisy_high(data)                                            ((0x00000008&(data))>>3)
+#define VO_V1_MA_NEW_noisy_shift                                                     (2)
+#define VO_V1_MA_NEW_noisy_mask                                                      (0x00000004)
+#define VO_V1_MA_NEW_noisy(data)                                                     (0x00000004&((data)<<2))
+#define VO_V1_MA_NEW_noisy_src(data)                                                 ((0x00000004&(data))>>2)
+#define VO_V1_MA_NEW_get_noisy(data)                                                 ((0x00000004&(data))>>2)
+#define VO_V1_MA_NEW_ma_shift                                                        (1)
+#define VO_V1_MA_NEW_ma_mask                                                         (0x00000002)
+#define VO_V1_MA_NEW_ma(data)                                                        (0x00000002&((data)<<1))
+#define VO_V1_MA_NEW_ma_src(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V1_MA_NEW_get_ma(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V1_MA_NEW_write_data_shift                                                (0)
+#define VO_V1_MA_NEW_write_data_mask                                                 (0x00000001)
+#define VO_V1_MA_NEW_write_data(data)                                                (0x00000001&((data)<<0))
+#define VO_V1_MA_NEW_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_V1_MA_NEW_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VO_V1_MA_FT                                                                  0x98005104
+#define VO_V1_MA_FT_reg_addr                                                         "0xD8005104"
+#define VO_V1_MA_FT_reg                                                              0xD8005104
+#define set_VO_V1_MA_FT_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FT_reg)=data)
+#define get_VO_V1_MA_FT_reg   (*((volatile unsigned int*) VO_V1_MA_FT_reg))
+#define VO_V1_MA_FT_inst_adr                                                         "0x0041"
+#define VO_V1_MA_FT_inst                                                             0x0041
+#define VO_V1_MA_FT_limit_shift                                                      (16)
+#define VO_V1_MA_FT_limit_mask                                                       (0x00FF0000)
+#define VO_V1_MA_FT_limit(data)                                                      (0x00FF0000&((data)<<16))
+#define VO_V1_MA_FT_limit_src(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V1_MA_FT_get_limit(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V1_MA_FT_big_shift                                                        (8)
+#define VO_V1_MA_FT_big_mask                                                         (0x0000FF00)
+#define VO_V1_MA_FT_big(data)                                                        (0x0000FF00&((data)<<8))
+#define VO_V1_MA_FT_big_src(data)                                                    ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_FT_get_big(data)                                                    ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_FT_th_shift                                                         (0)
+#define VO_V1_MA_FT_th_mask                                                          (0x000000FF)
+#define VO_V1_MA_FT_th(data)                                                         (0x000000FF&((data)<<0))
+#define VO_V1_MA_FT_th_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VO_V1_MA_FT_get_th(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_MA_FM                                                                  0x98005108
+#define VO_V1_MA_FM_reg_addr                                                         "0xD8005108"
+#define VO_V1_MA_FM_reg                                                              0xD8005108
+#define set_VO_V1_MA_FM_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FM_reg)=data)
+#define get_VO_V1_MA_FM_reg   (*((volatile unsigned int*) VO_V1_MA_FM_reg))
+#define VO_V1_MA_FM_inst_adr                                                         "0x0042"
+#define VO_V1_MA_FM_inst                                                             0x0042
+#define VO_V1_MA_FM_noisy_shift                                                      (8)
+#define VO_V1_MA_FM_noisy_mask                                                       (0x0000FF00)
+#define VO_V1_MA_FM_noisy(data)                                                      (0x0000FF00&((data)<<8))
+#define VO_V1_MA_FM_noisy_src(data)                                                  ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_FM_get_noisy(data)                                                  ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_FM_th_shift                                                         (0)
+#define VO_V1_MA_FM_th_mask                                                          (0x000000FF)
+#define VO_V1_MA_FM_th(data)                                                         (0x000000FF&((data)<<0))
+#define VO_V1_MA_FM_th_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VO_V1_MA_FM_get_th(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_BLEND                                                               0x9800510C
+#define VO_V1_DI_BLEND_reg_addr                                                      "0xD800510C"
+#define VO_V1_DI_BLEND_reg                                                           0xD800510C
+#define set_VO_V1_DI_BLEND_reg(data)   (*((volatile unsigned int*) VO_V1_DI_BLEND_reg)=data)
+#define get_VO_V1_DI_BLEND_reg   (*((volatile unsigned int*) VO_V1_DI_BLEND_reg))
+#define VO_V1_DI_BLEND_inst_adr                                                      "0x0043"
+#define VO_V1_DI_BLEND_inst                                                          0x0043
+#define VO_V1_DI_BLEND_cth_log2_shift                                                (24)
+#define VO_V1_DI_BLEND_cth_log2_mask                                                 (0x07000000)
+#define VO_V1_DI_BLEND_cth_log2(data)                                                (0x07000000&((data)<<24))
+#define VO_V1_DI_BLEND_cth_log2_src(data)                                            ((0x07000000&(data))>>24)
+#define VO_V1_DI_BLEND_get_cth_log2(data)                                            ((0x07000000&(data))>>24)
+#define VO_V1_DI_BLEND_cth_low_shift                                                 (16)
+#define VO_V1_DI_BLEND_cth_low_mask                                                  (0x00FF0000)
+#define VO_V1_DI_BLEND_cth_low(data)                                                 (0x00FF0000&((data)<<16))
+#define VO_V1_DI_BLEND_cth_low_src(data)                                             ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_BLEND_get_cth_low(data)                                             ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_BLEND_yth_log2_shift                                                (8)
+#define VO_V1_DI_BLEND_yth_log2_mask                                                 (0x00000700)
+#define VO_V1_DI_BLEND_yth_log2(data)                                                (0x00000700&((data)<<8))
+#define VO_V1_DI_BLEND_yth_log2_src(data)                                            ((0x00000700&(data))>>8)
+#define VO_V1_DI_BLEND_get_yth_log2(data)                                            ((0x00000700&(data))>>8)
+#define VO_V1_DI_BLEND_yth_low_shift                                                 (0)
+#define VO_V1_DI_BLEND_yth_low_mask                                                  (0x000000FF)
+#define VO_V1_DI_BLEND_yth_low(data)                                                 (0x000000FF&((data)<<0))
+#define VO_V1_DI_BLEND_yth_low_src(data)                                             ((0x000000FF&(data))>>0)
+#define VO_V1_DI_BLEND_get_yth_low(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_FILM                                                                   0x98005110
+#define VO_V1_FILM_reg_addr                                                          "0xD8005110"
+#define VO_V1_FILM_reg                                                               0xD8005110
+#define set_VO_V1_FILM_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_reg)=data)
+#define get_VO_V1_FILM_reg   (*((volatile unsigned int*) VO_V1_FILM_reg))
+#define VO_V1_FILM_inst_adr                                                          "0x0044"
+#define VO_V1_FILM_inst                                                              0x0044
+#define VO_V1_FILM_mode_shift                                                        (0)
+#define VO_V1_FILM_mode_mask                                                         (0x00000003)
+#define VO_V1_FILM_mode(data)                                                        (0x00000003&((data)<<0))
+#define VO_V1_FILM_mode_src(data)                                                    ((0x00000003&(data))>>0)
+#define VO_V1_FILM_get_mode(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define VO_V1_WADTB_0                                                                0x98005114
+#define VO_V1_WADTB_1                                                                0x98005118
+#define VO_V1_WADTB_2                                                                0x9800511C
+#define VO_V1_WADTB_3                                                                0x98005120
+#define VO_V1_WADTB_4                                                                0x98005124
+#define VO_V1_WADTB_5                                                                0x98005128
+#define VO_V1_WADTB_6                                                                0x9800512C
+#define VO_V1_WADTB_7                                                                0x98005130
+#define VO_V1_WADTB_8                                                                0x98005134
+#define VO_V1_WADTB_0_reg_addr                                                       "0xD8005114"
+#define VO_V1_WADTB_1_reg_addr                                                       "0xD8005118"
+#define VO_V1_WADTB_2_reg_addr                                                       "0xD800511C"
+#define VO_V1_WADTB_3_reg_addr                                                       "0xD8005120"
+#define VO_V1_WADTB_4_reg_addr                                                       "0xD8005124"
+#define VO_V1_WADTB_5_reg_addr                                                       "0xD8005128"
+#define VO_V1_WADTB_6_reg_addr                                                       "0xD800512C"
+#define VO_V1_WADTB_7_reg_addr                                                       "0xD8005130"
+#define VO_V1_WADTB_8_reg_addr                                                       "0xD8005134"
+#define VO_V1_WADTB_0_reg                                                            0xD8005114
+#define VO_V1_WADTB_1_reg                                                            0xD8005118
+#define VO_V1_WADTB_2_reg                                                            0xD800511C
+#define VO_V1_WADTB_3_reg                                                            0xD8005120
+#define VO_V1_WADTB_4_reg                                                            0xD8005124
+#define VO_V1_WADTB_5_reg                                                            0xD8005128
+#define VO_V1_WADTB_6_reg                                                            0xD800512C
+#define VO_V1_WADTB_7_reg                                                            0xD8005130
+#define VO_V1_WADTB_8_reg                                                            0xD8005134
+#define set_VO_V1_WADTB_0_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_0_reg)=data)
+#define set_VO_V1_WADTB_1_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_1_reg)=data)
+#define set_VO_V1_WADTB_2_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_2_reg)=data)
+#define set_VO_V1_WADTB_3_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_3_reg)=data)
+#define set_VO_V1_WADTB_4_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_4_reg)=data)
+#define set_VO_V1_WADTB_5_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_5_reg)=data)
+#define set_VO_V1_WADTB_6_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_6_reg)=data)
+#define set_VO_V1_WADTB_7_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_7_reg)=data)
+#define set_VO_V1_WADTB_8_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_8_reg)=data)
+#define get_VO_V1_WADTB_0_reg   (*((volatile unsigned int*) VO_V1_WADTB_0_reg))
+#define get_VO_V1_WADTB_1_reg   (*((volatile unsigned int*) VO_V1_WADTB_1_reg))
+#define get_VO_V1_WADTB_2_reg   (*((volatile unsigned int*) VO_V1_WADTB_2_reg))
+#define get_VO_V1_WADTB_3_reg   (*((volatile unsigned int*) VO_V1_WADTB_3_reg))
+#define get_VO_V1_WADTB_4_reg   (*((volatile unsigned int*) VO_V1_WADTB_4_reg))
+#define get_VO_V1_WADTB_5_reg   (*((volatile unsigned int*) VO_V1_WADTB_5_reg))
+#define get_VO_V1_WADTB_6_reg   (*((volatile unsigned int*) VO_V1_WADTB_6_reg))
+#define get_VO_V1_WADTB_7_reg   (*((volatile unsigned int*) VO_V1_WADTB_7_reg))
+#define get_VO_V1_WADTB_8_reg   (*((volatile unsigned int*) VO_V1_WADTB_8_reg))
+#define VO_V1_WADTB_0_inst_adr                                                       "0x0045"
+#define VO_V1_WADTB_1_inst_adr                                                       "0x0046"
+#define VO_V1_WADTB_2_inst_adr                                                       "0x0047"
+#define VO_V1_WADTB_3_inst_adr                                                       "0x0048"
+#define VO_V1_WADTB_4_inst_adr                                                       "0x0049"
+#define VO_V1_WADTB_5_inst_adr                                                       "0x004A"
+#define VO_V1_WADTB_6_inst_adr                                                       "0x004B"
+#define VO_V1_WADTB_7_inst_adr                                                       "0x004C"
+#define VO_V1_WADTB_8_inst_adr                                                       "0x004D"
+#define VO_V1_WADTB_0_inst                                                           0x0045
+#define VO_V1_WADTB_1_inst                                                           0x0046
+#define VO_V1_WADTB_2_inst                                                           0x0047
+#define VO_V1_WADTB_3_inst                                                           0x0048
+#define VO_V1_WADTB_4_inst                                                           0x0049
+#define VO_V1_WADTB_5_inst                                                           0x004A
+#define VO_V1_WADTB_6_inst                                                           0x004B
+#define VO_V1_WADTB_7_inst                                                           0x004C
+#define VO_V1_WADTB_8_inst                                                           0x004D
+#define VO_V1_WADTB_th_shift                                                         (16)
+#define VO_V1_WADTB_th_mask                                                          (0x00FF0000)
+#define VO_V1_WADTB_th(data)                                                         (0x00FF0000&((data)<<16))
+#define VO_V1_WADTB_th_src(data)                                                     ((0x00FF0000&(data))>>16)
+#define VO_V1_WADTB_get_th(data)                                                     ((0x00FF0000&(data))>>16)
+#define VO_V1_WADTB_wad_shift                                                        (0)
+#define VO_V1_WADTB_wad_mask                                                         (0x00000FFF)
+#define VO_V1_WADTB_wad(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V1_WADTB_wad_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V1_WADTB_get_wad(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_DI_YWIN                                                                0x98005138
+#define VO_V1_DI_YWIN_reg_addr                                                       "0xD8005138"
+#define VO_V1_DI_YWIN_reg                                                            0xD8005138
+#define set_VO_V1_DI_YWIN_reg(data)   (*((volatile unsigned int*) VO_V1_DI_YWIN_reg)=data)
+#define get_VO_V1_DI_YWIN_reg   (*((volatile unsigned int*) VO_V1_DI_YWIN_reg))
+#define VO_V1_DI_YWIN_inst_adr                                                       "0x004E"
+#define VO_V1_DI_YWIN_inst                                                           0x004E
+#define VO_V1_DI_YWIN_e_shift                                                        (16)
+#define VO_V1_DI_YWIN_e_mask                                                         (0x0FFF0000)
+#define VO_V1_DI_YWIN_e(data)                                                        (0x0FFF0000&((data)<<16))
+#define VO_V1_DI_YWIN_e_src(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V1_DI_YWIN_get_e(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V1_DI_YWIN_s_shift                                                        (0)
+#define VO_V1_DI_YWIN_s_mask                                                         (0x00000FFF)
+#define VO_V1_DI_YWIN_s(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V1_DI_YWIN_s_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V1_DI_YWIN_get_s(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_DI_CWIN                                                                0x9800513C
+#define VO_V1_DI_CWIN_reg_addr                                                       "0xD800513C"
+#define VO_V1_DI_CWIN_reg                                                            0xD800513C
+#define set_VO_V1_DI_CWIN_reg(data)   (*((volatile unsigned int*) VO_V1_DI_CWIN_reg)=data)
+#define get_VO_V1_DI_CWIN_reg   (*((volatile unsigned int*) VO_V1_DI_CWIN_reg))
+#define VO_V1_DI_CWIN_inst_adr                                                       "0x004F"
+#define VO_V1_DI_CWIN_inst                                                           0x004F
+#define VO_V1_DI_CWIN_e_shift                                                        (16)
+#define VO_V1_DI_CWIN_e_mask                                                         (0x0FFF0000)
+#define VO_V1_DI_CWIN_e(data)                                                        (0x0FFF0000&((data)<<16))
+#define VO_V1_DI_CWIN_e_src(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V1_DI_CWIN_get_e(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V1_DI_CWIN_s_shift                                                        (0)
+#define VO_V1_DI_CWIN_s_mask                                                         (0x00000FFF)
+#define VO_V1_DI_CWIN_s(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V1_DI_CWIN_s_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V1_DI_CWIN_get_s(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_DI_WINX                                                                0x98005140
+#define VO_V1_DI_WINX_reg_addr                                                       "0xD8005140"
+#define VO_V1_DI_WINX_reg                                                            0xD8005140
+#define set_VO_V1_DI_WINX_reg(data)   (*((volatile unsigned int*) VO_V1_DI_WINX_reg)=data)
+#define get_VO_V1_DI_WINX_reg   (*((volatile unsigned int*) VO_V1_DI_WINX_reg))
+#define VO_V1_DI_WINX_inst_adr                                                       "0x0050"
+#define VO_V1_DI_WINX_inst                                                           0x0050
+#define VO_V1_DI_WINX_e_shift                                                        (16)
+#define VO_V1_DI_WINX_e_mask                                                         (0x1FFF0000)
+#define VO_V1_DI_WINX_e(data)                                                        (0x1FFF0000&((data)<<16))
+#define VO_V1_DI_WINX_e_src(data)                                                    ((0x1FFF0000&(data))>>16)
+#define VO_V1_DI_WINX_get_e(data)                                                    ((0x1FFF0000&(data))>>16)
+#define VO_V1_DI_WINX_s_shift                                                        (0)
+#define VO_V1_DI_WINX_s_mask                                                         (0x00001FFF)
+#define VO_V1_DI_WINX_s(data)                                                        (0x00001FFF&((data)<<0))
+#define VO_V1_DI_WINX_s_src(data)                                                    ((0x00001FFF&(data))>>0)
+#define VO_V1_DI_WINX_get_s(data)                                                    ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1_FILM_SWAD_0                                                            0x98005144
+#define VO_V1_FILM_SWAD_1                                                            0x98005148
+#define VO_V1_FILM_SWAD_2                                                            0x9800514C
+#define VO_V1_FILM_SWAD_3                                                            0x98005150
+#define VO_V1_FILM_SWAD_4                                                            0x98005154
+#define VO_V1_FILM_SWAD_5                                                            0x98005158
+#define VO_V1_FILM_SWAD_0_reg_addr                                                   "0xD8005144"
+#define VO_V1_FILM_SWAD_1_reg_addr                                                   "0xD8005148"
+#define VO_V1_FILM_SWAD_2_reg_addr                                                   "0xD800514C"
+#define VO_V1_FILM_SWAD_3_reg_addr                                                   "0xD8005150"
+#define VO_V1_FILM_SWAD_4_reg_addr                                                   "0xD8005154"
+#define VO_V1_FILM_SWAD_5_reg_addr                                                   "0xD8005158"
+#define VO_V1_FILM_SWAD_0_reg                                                        0xD8005144
+#define VO_V1_FILM_SWAD_1_reg                                                        0xD8005148
+#define VO_V1_FILM_SWAD_2_reg                                                        0xD800514C
+#define VO_V1_FILM_SWAD_3_reg                                                        0xD8005150
+#define VO_V1_FILM_SWAD_4_reg                                                        0xD8005154
+#define VO_V1_FILM_SWAD_5_reg                                                        0xD8005158
+#define set_VO_V1_FILM_SWAD_0_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_0_reg)=data)
+#define set_VO_V1_FILM_SWAD_1_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_1_reg)=data)
+#define set_VO_V1_FILM_SWAD_2_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_2_reg)=data)
+#define set_VO_V1_FILM_SWAD_3_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_3_reg)=data)
+#define set_VO_V1_FILM_SWAD_4_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_4_reg)=data)
+#define set_VO_V1_FILM_SWAD_5_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_5_reg)=data)
+#define get_VO_V1_FILM_SWAD_0_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_0_reg))
+#define get_VO_V1_FILM_SWAD_1_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_1_reg))
+#define get_VO_V1_FILM_SWAD_2_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_2_reg))
+#define get_VO_V1_FILM_SWAD_3_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_3_reg))
+#define get_VO_V1_FILM_SWAD_4_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_4_reg))
+#define get_VO_V1_FILM_SWAD_5_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_5_reg))
+#define VO_V1_FILM_SWAD_0_inst_adr                                                   "0x0051"
+#define VO_V1_FILM_SWAD_1_inst_adr                                                   "0x0052"
+#define VO_V1_FILM_SWAD_2_inst_adr                                                   "0x0053"
+#define VO_V1_FILM_SWAD_3_inst_adr                                                   "0x0054"
+#define VO_V1_FILM_SWAD_4_inst_adr                                                   "0x0055"
+#define VO_V1_FILM_SWAD_5_inst_adr                                                   "0x0056"
+#define VO_V1_FILM_SWAD_0_inst                                                       0x0051
+#define VO_V1_FILM_SWAD_1_inst                                                       0x0052
+#define VO_V1_FILM_SWAD_2_inst                                                       0x0053
+#define VO_V1_FILM_SWAD_3_inst                                                       0x0054
+#define VO_V1_FILM_SWAD_4_inst                                                       0x0055
+#define VO_V1_FILM_SWAD_5_inst                                                       0x0056
+#define VO_V1_FILM_SWAD_swad_shift                                                   (0)
+#define VO_V1_FILM_SWAD_swad_mask                                                    (0x07FFFFFF)
+#define VO_V1_FILM_SWAD_swad(data)                                                   (0x07FFFFFF&((data)<<0))
+#define VO_V1_FILM_SWAD_swad_src(data)                                               ((0x07FFFFFF&(data))>>0)
+#define VO_V1_FILM_SWAD_get_swad(data)                                               ((0x07FFFFFF&(data))>>0)
+
+
+#define VO_V1_FILM_TH_0                                                              0x9800515C
+#define VO_V1_FILM_TH_1                                                              0x98005160
+#define VO_V1_FILM_TH_2                                                              0x98005164
+#define VO_V1_FILM_TH_3                                                              0x98005168
+#define VO_V1_FILM_TH_4                                                              0x9800516C
+#define VO_V1_FILM_TH_5                                                              0x98005170
+#define VO_V1_FILM_TH_0_reg_addr                                                     "0xD800515C"
+#define VO_V1_FILM_TH_1_reg_addr                                                     "0xD8005160"
+#define VO_V1_FILM_TH_2_reg_addr                                                     "0xD8005164"
+#define VO_V1_FILM_TH_3_reg_addr                                                     "0xD8005168"
+#define VO_V1_FILM_TH_4_reg_addr                                                     "0xD800516C"
+#define VO_V1_FILM_TH_5_reg_addr                                                     "0xD8005170"
+#define VO_V1_FILM_TH_0_reg                                                          0xD800515C
+#define VO_V1_FILM_TH_1_reg                                                          0xD8005160
+#define VO_V1_FILM_TH_2_reg                                                          0xD8005164
+#define VO_V1_FILM_TH_3_reg                                                          0xD8005168
+#define VO_V1_FILM_TH_4_reg                                                          0xD800516C
+#define VO_V1_FILM_TH_5_reg                                                          0xD8005170
+#define set_VO_V1_FILM_TH_0_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_0_reg)=data)
+#define set_VO_V1_FILM_TH_1_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_1_reg)=data)
+#define set_VO_V1_FILM_TH_2_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_2_reg)=data)
+#define set_VO_V1_FILM_TH_3_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_3_reg)=data)
+#define set_VO_V1_FILM_TH_4_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_4_reg)=data)
+#define set_VO_V1_FILM_TH_5_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_5_reg)=data)
+#define get_VO_V1_FILM_TH_0_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_0_reg))
+#define get_VO_V1_FILM_TH_1_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_1_reg))
+#define get_VO_V1_FILM_TH_2_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_2_reg))
+#define get_VO_V1_FILM_TH_3_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_3_reg))
+#define get_VO_V1_FILM_TH_4_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_4_reg))
+#define get_VO_V1_FILM_TH_5_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_5_reg))
+#define VO_V1_FILM_TH_0_inst_adr                                                     "0x0057"
+#define VO_V1_FILM_TH_1_inst_adr                                                     "0x0058"
+#define VO_V1_FILM_TH_2_inst_adr                                                     "0x0059"
+#define VO_V1_FILM_TH_3_inst_adr                                                     "0x005A"
+#define VO_V1_FILM_TH_4_inst_adr                                                     "0x005B"
+#define VO_V1_FILM_TH_5_inst_adr                                                     "0x005C"
+#define VO_V1_FILM_TH_0_inst                                                         0x0057
+#define VO_V1_FILM_TH_1_inst                                                         0x0058
+#define VO_V1_FILM_TH_2_inst                                                         0x0059
+#define VO_V1_FILM_TH_3_inst                                                         0x005A
+#define VO_V1_FILM_TH_4_inst                                                         0x005B
+#define VO_V1_FILM_TH_5_inst                                                         0x005C
+#define VO_V1_FILM_TH_th_shift                                                       (0)
+#define VO_V1_FILM_TH_th_mask                                                        (0x07FFFFFF)
+#define VO_V1_FILM_TH_th(data)                                                       (0x07FFFFFF&((data)<<0))
+#define VO_V1_FILM_TH_th_src(data)                                                   ((0x07FFFFFF&(data))>>0)
+#define VO_V1_FILM_TH_get_th(data)                                                   ((0x07FFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_DBG                                                                 0x98005174
+#define VO_V1_DI_DBG_reg_addr                                                        "0xD8005174"
+#define VO_V1_DI_DBG_reg                                                             0xD8005174
+#define set_VO_V1_DI_DBG_reg(data)   (*((volatile unsigned int*) VO_V1_DI_DBG_reg)=data)
+#define get_VO_V1_DI_DBG_reg   (*((volatile unsigned int*) VO_V1_DI_DBG_reg))
+#define VO_V1_DI_DBG_inst_adr                                                        "0x005D"
+#define VO_V1_DI_DBG_inst                                                            0x005D
+#define VO_V1_DI_DBG_mode_shift                                                      (0)
+#define VO_V1_DI_DBG_mode_mask                                                       (0x00000007)
+#define VO_V1_DI_DBG_mode(data)                                                      (0x00000007&((data)<<0))
+#define VO_V1_DI_DBG_mode_src(data)                                                  ((0x00000007&(data))>>0)
+#define VO_V1_DI_DBG_get_mode(data)                                                  ((0x00000007&(data))>>0)
+
+
+#define VO_V1_NEW_DI                                                                 0x98005178
+#define VO_V1_NEW_DI_reg_addr                                                        "0xD8005178"
+#define VO_V1_NEW_DI_reg                                                             0xD8005178
+#define set_VO_V1_NEW_DI_reg(data)   (*((volatile unsigned int*) VO_V1_NEW_DI_reg)=data)
+#define get_VO_V1_NEW_DI_reg   (*((volatile unsigned int*) VO_V1_NEW_DI_reg))
+#define VO_V1_NEW_DI_inst_adr                                                        "0x005E"
+#define VO_V1_NEW_DI_inst                                                            0x005E
+#define VO_V1_NEW_DI_dbg_bob_shift                                                   (27)
+#define VO_V1_NEW_DI_dbg_bob_mask                                                    (0x08000000)
+#define VO_V1_NEW_DI_dbg_bob(data)                                                   (0x08000000&((data)<<27))
+#define VO_V1_NEW_DI_dbg_bob_src(data)                                               ((0x08000000&(data))>>27)
+#define VO_V1_NEW_DI_get_dbg_bob(data)                                               ((0x08000000&(data))>>27)
+#define VO_V1_NEW_DI_dbg_chk_area_shift                                              (26)
+#define VO_V1_NEW_DI_dbg_chk_area_mask                                               (0x04000000)
+#define VO_V1_NEW_DI_dbg_chk_area(data)                                              (0x04000000&((data)<<26))
+#define VO_V1_NEW_DI_dbg_chk_area_src(data)                                          ((0x04000000&(data))>>26)
+#define VO_V1_NEW_DI_get_dbg_chk_area(data)                                          ((0x04000000&(data))>>26)
+#define VO_V1_NEW_DI_dbg_combing_shift                                               (25)
+#define VO_V1_NEW_DI_dbg_combing_mask                                                (0x02000000)
+#define VO_V1_NEW_DI_dbg_combing(data)                                               (0x02000000&((data)<<25))
+#define VO_V1_NEW_DI_dbg_combing_src(data)                                           ((0x02000000&(data))>>25)
+#define VO_V1_NEW_DI_get_dbg_combing(data)                                           ((0x02000000&(data))>>25)
+#define VO_V1_NEW_DI_dbg_blend_ratio_shift                                           (24)
+#define VO_V1_NEW_DI_dbg_blend_ratio_mask                                            (0x01000000)
+#define VO_V1_NEW_DI_dbg_blend_ratio(data)                                           (0x01000000&((data)<<24))
+#define VO_V1_NEW_DI_dbg_blend_ratio_src(data)                                       ((0x01000000&(data))>>24)
+#define VO_V1_NEW_DI_get_dbg_blend_ratio(data)                                       ((0x01000000&(data))>>24)
+#define VO_V1_NEW_DI_bob_chk2_en_shift                                               (18)
+#define VO_V1_NEW_DI_bob_chk2_en_mask                                                (0x00040000)
+#define VO_V1_NEW_DI_bob_chk2_en(data)                                               (0x00040000&((data)<<18))
+#define VO_V1_NEW_DI_bob_chk2_en_src(data)                                           ((0x00040000&(data))>>18)
+#define VO_V1_NEW_DI_get_bob_chk2_en(data)                                           ((0x00040000&(data))>>18)
+#define VO_V1_NEW_DI_bob_chk1_en_shift                                               (17)
+#define VO_V1_NEW_DI_bob_chk1_en_mask                                                (0x00020000)
+#define VO_V1_NEW_DI_bob_chk1_en(data)                                               (0x00020000&((data)<<17))
+#define VO_V1_NEW_DI_bob_chk1_en_src(data)                                           ((0x00020000&(data))>>17)
+#define VO_V1_NEW_DI_get_bob_chk1_en(data)                                           ((0x00020000&(data))>>17)
+#define VO_V1_NEW_DI_bob_chk0_en_shift                                               (16)
+#define VO_V1_NEW_DI_bob_chk0_en_mask                                                (0x00010000)
+#define VO_V1_NEW_DI_bob_chk0_en(data)                                               (0x00010000&((data)<<16))
+#define VO_V1_NEW_DI_bob_chk0_en_src(data)                                           ((0x00010000&(data))>>16)
+#define VO_V1_NEW_DI_get_bob_chk0_en(data)                                           ((0x00010000&(data))>>16)
+#define VO_V1_NEW_DI_escape_en_shift                                                 (12)
+#define VO_V1_NEW_DI_escape_en_mask                                                  (0x00001000)
+#define VO_V1_NEW_DI_escape_en(data)                                                 (0x00001000&((data)<<12))
+#define VO_V1_NEW_DI_escape_en_src(data)                                             ((0x00001000&(data))>>12)
+#define VO_V1_NEW_DI_get_escape_en(data)                                             ((0x00001000&(data))>>12)
+#define VO_V1_NEW_DI_use_wb_diff_shift                                               (11)
+#define VO_V1_NEW_DI_use_wb_diff_mask                                                (0x00000800)
+#define VO_V1_NEW_DI_use_wb_diff(data)                                               (0x00000800&((data)<<11))
+#define VO_V1_NEW_DI_use_wb_diff_src(data)                                           ((0x00000800&(data))>>11)
+#define VO_V1_NEW_DI_get_use_wb_diff(data)                                           ((0x00000800&(data))>>11)
+#define VO_V1_NEW_DI_wb_max_diff_shift                                               (10)
+#define VO_V1_NEW_DI_wb_max_diff_mask                                                (0x00000400)
+#define VO_V1_NEW_DI_wb_max_diff(data)                                               (0x00000400&((data)<<10))
+#define VO_V1_NEW_DI_wb_max_diff_src(data)                                           ((0x00000400&(data))>>10)
+#define VO_V1_NEW_DI_get_wb_max_diff(data)                                           ((0x00000400&(data))>>10)
+#define VO_V1_NEW_DI_wb_chk_result_shift                                             (9)
+#define VO_V1_NEW_DI_wb_chk_result_mask                                              (0x00000200)
+#define VO_V1_NEW_DI_wb_chk_result(data)                                             (0x00000200&((data)<<9))
+#define VO_V1_NEW_DI_wb_chk_result_src(data)                                         ((0x00000200&(data))>>9)
+#define VO_V1_NEW_DI_get_wb_chk_result(data)                                         ((0x00000200&(data))>>9)
+#define VO_V1_NEW_DI_chk_use_max_mf_shift                                            (8)
+#define VO_V1_NEW_DI_chk_use_max_mf_mask                                             (0x00000100)
+#define VO_V1_NEW_DI_chk_use_max_mf(data)                                            (0x00000100&((data)<<8))
+#define VO_V1_NEW_DI_chk_use_max_mf_src(data)                                        ((0x00000100&(data))>>8)
+#define VO_V1_NEW_DI_get_chk_use_max_mf(data)                                        ((0x00000100&(data))>>8)
+#define VO_V1_NEW_DI_comb_chk_en_shift                                               (7)
+#define VO_V1_NEW_DI_comb_chk_en_mask                                                (0x00000080)
+#define VO_V1_NEW_DI_comb_chk_en(data)                                               (0x00000080&((data)<<7))
+#define VO_V1_NEW_DI_comb_chk_en_src(data)                                           ((0x00000080&(data))>>7)
+#define VO_V1_NEW_DI_get_comb_chk_en(data)                                           ((0x00000080&(data))>>7)
+#define VO_V1_NEW_DI_mf_select_shift                                                 (6)
+#define VO_V1_NEW_DI_mf_select_mask                                                  (0x00000040)
+#define VO_V1_NEW_DI_mf_select(data)                                                 (0x00000040&((data)<<6))
+#define VO_V1_NEW_DI_mf_select_src(data)                                             ((0x00000040&(data))>>6)
+#define VO_V1_NEW_DI_get_mf_select(data)                                             ((0x00000040&(data))>>6)
+#define VO_V1_NEW_DI_mf_lpf_enable_shift                                             (5)
+#define VO_V1_NEW_DI_mf_lpf_enable_mask                                              (0x00000020)
+#define VO_V1_NEW_DI_mf_lpf_enable(data)                                             (0x00000020&((data)<<5))
+#define VO_V1_NEW_DI_mf_lpf_enable_src(data)                                         ((0x00000020&(data))>>5)
+#define VO_V1_NEW_DI_get_mf_lpf_enable(data)                                         ((0x00000020&(data))>>5)
+#define VO_V1_NEW_DI_use_lpf_data_shift                                              (4)
+#define VO_V1_NEW_DI_use_lpf_data_mask                                               (0x00000010)
+#define VO_V1_NEW_DI_use_lpf_data(data)                                              (0x00000010&((data)<<4))
+#define VO_V1_NEW_DI_use_lpf_data_src(data)                                          ((0x00000010&(data))>>4)
+#define VO_V1_NEW_DI_get_use_lpf_data(data)                                          ((0x00000010&(data))>>4)
+#define VO_V1_NEW_DI_light_comb_en_shift                                             (3)
+#define VO_V1_NEW_DI_light_comb_en_mask                                              (0x00000008)
+#define VO_V1_NEW_DI_light_comb_en(data)                                             (0x00000008&((data)<<3))
+#define VO_V1_NEW_DI_light_comb_en_src(data)                                         ((0x00000008&(data))>>3)
+#define VO_V1_NEW_DI_get_light_comb_en(data)                                         ((0x00000008&(data))>>3)
+#define VO_V1_NEW_DI_cu_shift                                                        (2)
+#define VO_V1_NEW_DI_cu_mask                                                         (0x00000004)
+#define VO_V1_NEW_DI_cu(data)                                                        (0x00000004&((data)<<2))
+#define VO_V1_NEW_DI_cu_src(data)                                                    ((0x00000004&(data))>>2)
+#define VO_V1_NEW_DI_get_cu(data)                                                    ((0x00000004&(data))>>2)
+#define VO_V1_NEW_DI_en_shift                                                        (1)
+#define VO_V1_NEW_DI_en_mask                                                         (0x00000002)
+#define VO_V1_NEW_DI_en(data)                                                        (0x00000002&((data)<<1))
+#define VO_V1_NEW_DI_en_src(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V1_NEW_DI_get_en(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V1_NEW_DI_write_data_shift                                                (0)
+#define VO_V1_NEW_DI_write_data_mask                                                 (0x00000001)
+#define VO_V1_NEW_DI_write_data(data)                                                (0x00000001&((data)<<0))
+#define VO_V1_NEW_DI_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_V1_NEW_DI_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VO_V1_DI_LPF1X5                                                              0x9800517C
+#define VO_V1_DI_LPF1X5_reg_addr                                                     "0xD800517C"
+#define VO_V1_DI_LPF1X5_reg                                                          0xD800517C
+#define set_VO_V1_DI_LPF1X5_reg(data)   (*((volatile unsigned int*) VO_V1_DI_LPF1X5_reg)=data)
+#define get_VO_V1_DI_LPF1X5_reg   (*((volatile unsigned int*) VO_V1_DI_LPF1X5_reg))
+#define VO_V1_DI_LPF1X5_inst_adr                                                     "0x005F"
+#define VO_V1_DI_LPF1X5_inst                                                         0x005F
+#define VO_V1_DI_LPF1X5_c4_shift                                                     (16)
+#define VO_V1_DI_LPF1X5_c4_mask                                                      (0x00070000)
+#define VO_V1_DI_LPF1X5_c4(data)                                                     (0x00070000&((data)<<16))
+#define VO_V1_DI_LPF1X5_c4_src(data)                                                 ((0x00070000&(data))>>16)
+#define VO_V1_DI_LPF1X5_get_c4(data)                                                 ((0x00070000&(data))>>16)
+#define VO_V1_DI_LPF1X5_c3_shift                                                     (12)
+#define VO_V1_DI_LPF1X5_c3_mask                                                      (0x00007000)
+#define VO_V1_DI_LPF1X5_c3(data)                                                     (0x00007000&((data)<<12))
+#define VO_V1_DI_LPF1X5_c3_src(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_DI_LPF1X5_get_c3(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_DI_LPF1X5_c2_shift                                                     (8)
+#define VO_V1_DI_LPF1X5_c2_mask                                                      (0x00000700)
+#define VO_V1_DI_LPF1X5_c2(data)                                                     (0x00000700&((data)<<8))
+#define VO_V1_DI_LPF1X5_c2_src(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_DI_LPF1X5_get_c2(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_DI_LPF1X5_c1_shift                                                     (4)
+#define VO_V1_DI_LPF1X5_c1_mask                                                      (0x00000070)
+#define VO_V1_DI_LPF1X5_c1(data)                                                     (0x00000070&((data)<<4))
+#define VO_V1_DI_LPF1X5_c1_src(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V1_DI_LPF1X5_get_c1(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V1_DI_LPF1X5_c0_shift                                                     (0)
+#define VO_V1_DI_LPF1X5_c0_mask                                                      (0x00000007)
+#define VO_V1_DI_LPF1X5_c0(data)                                                     (0x00000007&((data)<<0))
+#define VO_V1_DI_LPF1X5_c0_src(data)                                                 ((0x00000007&(data))>>0)
+#define VO_V1_DI_LPF1X5_get_c0(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define VO_V1_DI_LPF3X5_T                                                            0x98005180
+#define VO_V1_DI_LPF3X5_T_reg_addr                                                   "0xD8005180"
+#define VO_V1_DI_LPF3X5_T_reg                                                        0xD8005180
+#define set_VO_V1_DI_LPF3X5_T_reg(data)   (*((volatile unsigned int*) VO_V1_DI_LPF3X5_T_reg)=data)
+#define get_VO_V1_DI_LPF3X5_T_reg   (*((volatile unsigned int*) VO_V1_DI_LPF3X5_T_reg))
+#define VO_V1_DI_LPF3X5_T_inst_adr                                                   "0x0060"
+#define VO_V1_DI_LPF3X5_T_inst                                                       0x0060
+#define VO_V1_DI_LPF3X5_T_c4_shift                                                   (16)
+#define VO_V1_DI_LPF3X5_T_c4_mask                                                    (0x00070000)
+#define VO_V1_DI_LPF3X5_T_c4(data)                                                   (0x00070000&((data)<<16))
+#define VO_V1_DI_LPF3X5_T_c4_src(data)                                               ((0x00070000&(data))>>16)
+#define VO_V1_DI_LPF3X5_T_get_c4(data)                                               ((0x00070000&(data))>>16)
+#define VO_V1_DI_LPF3X5_T_c3_shift                                                   (12)
+#define VO_V1_DI_LPF3X5_T_c3_mask                                                    (0x00007000)
+#define VO_V1_DI_LPF3X5_T_c3(data)                                                   (0x00007000&((data)<<12))
+#define VO_V1_DI_LPF3X5_T_c3_src(data)                                               ((0x00007000&(data))>>12)
+#define VO_V1_DI_LPF3X5_T_get_c3(data)                                               ((0x00007000&(data))>>12)
+#define VO_V1_DI_LPF3X5_T_c2_shift                                                   (8)
+#define VO_V1_DI_LPF3X5_T_c2_mask                                                    (0x00000700)
+#define VO_V1_DI_LPF3X5_T_c2(data)                                                   (0x00000700&((data)<<8))
+#define VO_V1_DI_LPF3X5_T_c2_src(data)                                               ((0x00000700&(data))>>8)
+#define VO_V1_DI_LPF3X5_T_get_c2(data)                                               ((0x00000700&(data))>>8)
+#define VO_V1_DI_LPF3X5_T_c1_shift                                                   (4)
+#define VO_V1_DI_LPF3X5_T_c1_mask                                                    (0x00000070)
+#define VO_V1_DI_LPF3X5_T_c1(data)                                                   (0x00000070&((data)<<4))
+#define VO_V1_DI_LPF3X5_T_c1_src(data)                                               ((0x00000070&(data))>>4)
+#define VO_V1_DI_LPF3X5_T_get_c1(data)                                               ((0x00000070&(data))>>4)
+#define VO_V1_DI_LPF3X5_T_c0_shift                                                   (0)
+#define VO_V1_DI_LPF3X5_T_c0_mask                                                    (0x00000007)
+#define VO_V1_DI_LPF3X5_T_c0(data)                                                   (0x00000007&((data)<<0))
+#define VO_V1_DI_LPF3X5_T_c0_src(data)                                               ((0x00000007&(data))>>0)
+#define VO_V1_DI_LPF3X5_T_get_c0(data)                                               ((0x00000007&(data))>>0)
+
+
+#define VO_V1_DI_LPF3X5_C                                                            0x98005184
+#define VO_V1_DI_LPF3X5_C_reg_addr                                                   "0xD8005184"
+#define VO_V1_DI_LPF3X5_C_reg                                                        0xD8005184
+#define set_VO_V1_DI_LPF3X5_C_reg(data)   (*((volatile unsigned int*) VO_V1_DI_LPF3X5_C_reg)=data)
+#define get_VO_V1_DI_LPF3X5_C_reg   (*((volatile unsigned int*) VO_V1_DI_LPF3X5_C_reg))
+#define VO_V1_DI_LPF3X5_C_inst_adr                                                   "0x0061"
+#define VO_V1_DI_LPF3X5_C_inst                                                       0x0061
+#define VO_V1_DI_LPF3X5_C_c4_shift                                                   (16)
+#define VO_V1_DI_LPF3X5_C_c4_mask                                                    (0x00070000)
+#define VO_V1_DI_LPF3X5_C_c4(data)                                                   (0x00070000&((data)<<16))
+#define VO_V1_DI_LPF3X5_C_c4_src(data)                                               ((0x00070000&(data))>>16)
+#define VO_V1_DI_LPF3X5_C_get_c4(data)                                               ((0x00070000&(data))>>16)
+#define VO_V1_DI_LPF3X5_C_c3_shift                                                   (12)
+#define VO_V1_DI_LPF3X5_C_c3_mask                                                    (0x00007000)
+#define VO_V1_DI_LPF3X5_C_c3(data)                                                   (0x00007000&((data)<<12))
+#define VO_V1_DI_LPF3X5_C_c3_src(data)                                               ((0x00007000&(data))>>12)
+#define VO_V1_DI_LPF3X5_C_get_c3(data)                                               ((0x00007000&(data))>>12)
+#define VO_V1_DI_LPF3X5_C_c2_shift                                                   (8)
+#define VO_V1_DI_LPF3X5_C_c2_mask                                                    (0x00000700)
+#define VO_V1_DI_LPF3X5_C_c2(data)                                                   (0x00000700&((data)<<8))
+#define VO_V1_DI_LPF3X5_C_c2_src(data)                                               ((0x00000700&(data))>>8)
+#define VO_V1_DI_LPF3X5_C_get_c2(data)                                               ((0x00000700&(data))>>8)
+#define VO_V1_DI_LPF3X5_C_c1_shift                                                   (4)
+#define VO_V1_DI_LPF3X5_C_c1_mask                                                    (0x00000070)
+#define VO_V1_DI_LPF3X5_C_c1(data)                                                   (0x00000070&((data)<<4))
+#define VO_V1_DI_LPF3X5_C_c1_src(data)                                               ((0x00000070&(data))>>4)
+#define VO_V1_DI_LPF3X5_C_get_c1(data)                                               ((0x00000070&(data))>>4)
+#define VO_V1_DI_LPF3X5_C_c0_shift                                                   (0)
+#define VO_V1_DI_LPF3X5_C_c0_mask                                                    (0x00000007)
+#define VO_V1_DI_LPF3X5_C_c0(data)                                                   (0x00000007&((data)<<0))
+#define VO_V1_DI_LPF3X5_C_c0_src(data)                                               ((0x00000007&(data))>>0)
+#define VO_V1_DI_LPF3X5_C_get_c0(data)                                               ((0x00000007&(data))>>0)
+
+
+#define VO_V1_DI_LPF3X5_B                                                            0x98005188
+#define VO_V1_DI_LPF3X5_B_reg_addr                                                   "0xD8005188"
+#define VO_V1_DI_LPF3X5_B_reg                                                        0xD8005188
+#define set_VO_V1_DI_LPF3X5_B_reg(data)   (*((volatile unsigned int*) VO_V1_DI_LPF3X5_B_reg)=data)
+#define get_VO_V1_DI_LPF3X5_B_reg   (*((volatile unsigned int*) VO_V1_DI_LPF3X5_B_reg))
+#define VO_V1_DI_LPF3X5_B_inst_adr                                                   "0x0062"
+#define VO_V1_DI_LPF3X5_B_inst                                                       0x0062
+#define VO_V1_DI_LPF3X5_B_c4_shift                                                   (16)
+#define VO_V1_DI_LPF3X5_B_c4_mask                                                    (0x00070000)
+#define VO_V1_DI_LPF3X5_B_c4(data)                                                   (0x00070000&((data)<<16))
+#define VO_V1_DI_LPF3X5_B_c4_src(data)                                               ((0x00070000&(data))>>16)
+#define VO_V1_DI_LPF3X5_B_get_c4(data)                                               ((0x00070000&(data))>>16)
+#define VO_V1_DI_LPF3X5_B_c3_shift                                                   (12)
+#define VO_V1_DI_LPF3X5_B_c3_mask                                                    (0x00007000)
+#define VO_V1_DI_LPF3X5_B_c3(data)                                                   (0x00007000&((data)<<12))
+#define VO_V1_DI_LPF3X5_B_c3_src(data)                                               ((0x00007000&(data))>>12)
+#define VO_V1_DI_LPF3X5_B_get_c3(data)                                               ((0x00007000&(data))>>12)
+#define VO_V1_DI_LPF3X5_B_c2_shift                                                   (8)
+#define VO_V1_DI_LPF3X5_B_c2_mask                                                    (0x00000700)
+#define VO_V1_DI_LPF3X5_B_c2(data)                                                   (0x00000700&((data)<<8))
+#define VO_V1_DI_LPF3X5_B_c2_src(data)                                               ((0x00000700&(data))>>8)
+#define VO_V1_DI_LPF3X5_B_get_c2(data)                                               ((0x00000700&(data))>>8)
+#define VO_V1_DI_LPF3X5_B_c1_shift                                                   (4)
+#define VO_V1_DI_LPF3X5_B_c1_mask                                                    (0x00000070)
+#define VO_V1_DI_LPF3X5_B_c1(data)                                                   (0x00000070&((data)<<4))
+#define VO_V1_DI_LPF3X5_B_c1_src(data)                                               ((0x00000070&(data))>>4)
+#define VO_V1_DI_LPF3X5_B_get_c1(data)                                               ((0x00000070&(data))>>4)
+#define VO_V1_DI_LPF3X5_B_c0_shift                                                   (0)
+#define VO_V1_DI_LPF3X5_B_c0_mask                                                    (0x00000007)
+#define VO_V1_DI_LPF3X5_B_c0(data)                                                   (0x00000007&((data)<<0))
+#define VO_V1_DI_LPF3X5_B_c0_src(data)                                               ((0x00000007&(data))>>0)
+#define VO_V1_DI_LPF3X5_B_get_c0(data)                                               ((0x00000007&(data))>>0)
+
+
+#define VO_V1_DI_MF                                                                  0x9800518C
+#define VO_V1_DI_MF_reg_addr                                                         "0xD800518C"
+#define VO_V1_DI_MF_reg                                                              0xD800518C
+#define set_VO_V1_DI_MF_reg(data)   (*((volatile unsigned int*) VO_V1_DI_MF_reg)=data)
+#define get_VO_V1_DI_MF_reg   (*((volatile unsigned int*) VO_V1_DI_MF_reg))
+#define VO_V1_DI_MF_inst_adr                                                         "0x0063"
+#define VO_V1_DI_MF_inst                                                             0x0063
+#define VO_V1_DI_MF_r_shift                                                          (22)
+#define VO_V1_DI_MF_r_mask                                                           (0xFFC00000)
+#define VO_V1_DI_MF_r(data)                                                          (0xFFC00000&((data)<<22))
+#define VO_V1_DI_MF_r_src(data)                                                      ((0xFFC00000&(data))>>22)
+#define VO_V1_DI_MF_get_r(data)                                                      ((0xFFC00000&(data))>>22)
+#define VO_V1_DI_MF_expand_range_shift                                               (16)
+#define VO_V1_DI_MF_expand_range_mask                                                (0x00030000)
+#define VO_V1_DI_MF_expand_range(data)                                               (0x00030000&((data)<<16))
+#define VO_V1_DI_MF_expand_range_src(data)                                           ((0x00030000&(data))>>16)
+#define VO_V1_DI_MF_get_expand_range(data)                                           ((0x00030000&(data))>>16)
+#define VO_V1_DI_MF_h_th_shift                                                       (8)
+#define VO_V1_DI_MF_h_th_mask                                                        (0x0000FF00)
+#define VO_V1_DI_MF_h_th(data)                                                       (0x0000FF00&((data)<<8))
+#define VO_V1_DI_MF_h_th_src(data)                                                   ((0x0000FF00&(data))>>8)
+#define VO_V1_DI_MF_get_h_th(data)                                                   ((0x0000FF00&(data))>>8)
+#define VO_V1_DI_MF_l_th_shift                                                       (0)
+#define VO_V1_DI_MF_l_th_mask                                                        (0x000000FF)
+#define VO_V1_DI_MF_l_th(data)                                                       (0x000000FF&((data)<<0))
+#define VO_V1_DI_MF_l_th_src(data)                                                   ((0x000000FF&(data))>>0)
+#define VO_V1_DI_MF_get_l_th(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_COMB                                                                0x98005190
+#define VO_V1_DI_COMB_reg_addr                                                       "0xD8005190"
+#define VO_V1_DI_COMB_reg                                                            0xD8005190
+#define set_VO_V1_DI_COMB_reg(data)   (*((volatile unsigned int*) VO_V1_DI_COMB_reg)=data)
+#define get_VO_V1_DI_COMB_reg   (*((volatile unsigned int*) VO_V1_DI_COMB_reg))
+#define VO_V1_DI_COMB_inst_adr                                                       "0x0064"
+#define VO_V1_DI_COMB_inst                                                           0x0064
+#define VO_V1_DI_COMB_thd_shift                                                      (0)
+#define VO_V1_DI_COMB_thd_mask                                                       (0x000000FF)
+#define VO_V1_DI_COMB_thd(data)                                                      (0x000000FF&((data)<<0))
+#define VO_V1_DI_COMB_thd_src(data)                                                  ((0x000000FF&(data))>>0)
+#define VO_V1_DI_COMB_get_thd(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_COMB_CHK                                                            0x98005194
+#define VO_V1_DI_COMB_CHK_reg_addr                                                   "0xD8005194"
+#define VO_V1_DI_COMB_CHK_reg                                                        0xD8005194
+#define set_VO_V1_DI_COMB_CHK_reg(data)   (*((volatile unsigned int*) VO_V1_DI_COMB_CHK_reg)=data)
+#define get_VO_V1_DI_COMB_CHK_reg   (*((volatile unsigned int*) VO_V1_DI_COMB_CHK_reg))
+#define VO_V1_DI_COMB_CHK_inst_adr                                                   "0x0065"
+#define VO_V1_DI_COMB_CHK_inst                                                       0x0065
+#define VO_V1_DI_COMB_CHK_h_th_shift                                                 (16)
+#define VO_V1_DI_COMB_CHK_h_th_mask                                                  (0x00FF0000)
+#define VO_V1_DI_COMB_CHK_h_th(data)                                                 (0x00FF0000&((data)<<16))
+#define VO_V1_DI_COMB_CHK_h_th_src(data)                                             ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_COMB_CHK_get_h_th(data)                                             ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_COMB_CHK_l_th_shift                                                 (0)
+#define VO_V1_DI_COMB_CHK_l_th_mask                                                  (0x000000FF)
+#define VO_V1_DI_COMB_CHK_l_th(data)                                                 (0x000000FF&((data)<<0))
+#define VO_V1_DI_COMB_CHK_l_th_src(data)                                             ((0x000000FF&(data))>>0)
+#define VO_V1_DI_COMB_CHK_get_l_th(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_COMB_CNT                                                            0x98005198
+#define VO_V1_DI_COMB_CNT_reg_addr                                                   "0xD8005198"
+#define VO_V1_DI_COMB_CNT_reg                                                        0xD8005198
+#define set_VO_V1_DI_COMB_CNT_reg(data)   (*((volatile unsigned int*) VO_V1_DI_COMB_CNT_reg)=data)
+#define get_VO_V1_DI_COMB_CNT_reg   (*((volatile unsigned int*) VO_V1_DI_COMB_CNT_reg))
+#define VO_V1_DI_COMB_CNT_inst_adr                                                   "0x0066"
+#define VO_V1_DI_COMB_CNT_inst                                                       0x0066
+#define VO_V1_DI_COMB_CNT_dis_chk_th_shift                                           (16)
+#define VO_V1_DI_COMB_CNT_dis_chk_th_mask                                            (0x00FF0000)
+#define VO_V1_DI_COMB_CNT_dis_chk_th(data)                                           (0x00FF0000&((data)<<16))
+#define VO_V1_DI_COMB_CNT_dis_chk_th_src(data)                                       ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_COMB_CNT_get_dis_chk_th(data)                                       ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_COMB_CNT_en_chk_th_shift                                            (0)
+#define VO_V1_DI_COMB_CNT_en_chk_th_mask                                             (0x000000FF)
+#define VO_V1_DI_COMB_CNT_en_chk_th(data)                                            (0x000000FF&((data)<<0))
+#define VO_V1_DI_COMB_CNT_en_chk_th_src(data)                                        ((0x000000FF&(data))>>0)
+#define VO_V1_DI_COMB_CNT_get_en_chk_th(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_LIGHT_COMB0                                                         0x9800519C
+#define VO_V1_DI_LIGHT_COMB0_reg_addr                                                "0xD800519C"
+#define VO_V1_DI_LIGHT_COMB0_reg                                                     0xD800519C
+#define set_VO_V1_DI_LIGHT_COMB0_reg(data)   (*((volatile unsigned int*) VO_V1_DI_LIGHT_COMB0_reg)=data)
+#define get_VO_V1_DI_LIGHT_COMB0_reg   (*((volatile unsigned int*) VO_V1_DI_LIGHT_COMB0_reg))
+#define VO_V1_DI_LIGHT_COMB0_inst_adr                                                "0x0067"
+#define VO_V1_DI_LIGHT_COMB0_inst                                                    0x0067
+#define VO_V1_DI_LIGHT_COMB0_pn_thd1_shift                                           (24)
+#define VO_V1_DI_LIGHT_COMB0_pn_thd1_mask                                            (0xFF000000)
+#define VO_V1_DI_LIGHT_COMB0_pn_thd1(data)                                           (0xFF000000&((data)<<24))
+#define VO_V1_DI_LIGHT_COMB0_pn_thd1_src(data)                                       ((0xFF000000&(data))>>24)
+#define VO_V1_DI_LIGHT_COMB0_get_pn_thd1(data)                                       ((0xFF000000&(data))>>24)
+#define VO_V1_DI_LIGHT_COMB0_pn_thd0_shift                                           (16)
+#define VO_V1_DI_LIGHT_COMB0_pn_thd0_mask                                            (0x00FF0000)
+#define VO_V1_DI_LIGHT_COMB0_pn_thd0(data)                                           (0x00FF0000&((data)<<16))
+#define VO_V1_DI_LIGHT_COMB0_pn_thd0_src(data)                                       ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_LIGHT_COMB0_get_pn_thd0(data)                                       ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_LIGHT_COMB0_tb_thd_shift                                            (0)
+#define VO_V1_DI_LIGHT_COMB0_tb_thd_mask                                             (0x000000FF)
+#define VO_V1_DI_LIGHT_COMB0_tb_thd(data)                                            (0x000000FF&((data)<<0))
+#define VO_V1_DI_LIGHT_COMB0_tb_thd_src(data)                                        ((0x000000FF&(data))>>0)
+#define VO_V1_DI_LIGHT_COMB0_get_tb_thd(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_LIGHT_COMB1                                                         0x980051A0
+#define VO_V1_DI_LIGHT_COMB1_reg_addr                                                "0xD80051A0"
+#define VO_V1_DI_LIGHT_COMB1_reg                                                     0xD80051A0
+#define set_VO_V1_DI_LIGHT_COMB1_reg(data)   (*((volatile unsigned int*) VO_V1_DI_LIGHT_COMB1_reg)=data)
+#define get_VO_V1_DI_LIGHT_COMB1_reg   (*((volatile unsigned int*) VO_V1_DI_LIGHT_COMB1_reg))
+#define VO_V1_DI_LIGHT_COMB1_inst_adr                                                "0x0068"
+#define VO_V1_DI_LIGHT_COMB1_inst                                                    0x0068
+#define VO_V1_DI_LIGHT_COMB1_bw_thd_shift                                            (24)
+#define VO_V1_DI_LIGHT_COMB1_bw_thd_mask                                             (0xFF000000)
+#define VO_V1_DI_LIGHT_COMB1_bw_thd(data)                                            (0xFF000000&((data)<<24))
+#define VO_V1_DI_LIGHT_COMB1_bw_thd_src(data)                                        ((0xFF000000&(data))>>24)
+#define VO_V1_DI_LIGHT_COMB1_get_bw_thd(data)                                        ((0xFF000000&(data))>>24)
+#define VO_V1_DI_LIGHT_COMB1_tw_thd_shift                                            (16)
+#define VO_V1_DI_LIGHT_COMB1_tw_thd_mask                                             (0x00FF0000)
+#define VO_V1_DI_LIGHT_COMB1_tw_thd(data)                                            (0x00FF0000&((data)<<16))
+#define VO_V1_DI_LIGHT_COMB1_tw_thd_src(data)                                        ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_LIGHT_COMB1_get_tw_thd(data)                                        ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_LIGHT_COMB1_thd_shift                                               (0)
+#define VO_V1_DI_LIGHT_COMB1_thd_mask                                                (0x000000FF)
+#define VO_V1_DI_LIGHT_COMB1_thd(data)                                               (0x000000FF&((data)<<0))
+#define VO_V1_DI_LIGHT_COMB1_thd_src(data)                                           ((0x000000FF&(data))>>0)
+#define VO_V1_DI_LIGHT_COMB1_get_thd(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_DATA_LPF1X3                                                         0x980051A4
+#define VO_V1_DI_DATA_LPF1X3_reg_addr                                                "0xD80051A4"
+#define VO_V1_DI_DATA_LPF1X3_reg                                                     0xD80051A4
+#define set_VO_V1_DI_DATA_LPF1X3_reg(data)   (*((volatile unsigned int*) VO_V1_DI_DATA_LPF1X3_reg)=data)
+#define get_VO_V1_DI_DATA_LPF1X3_reg   (*((volatile unsigned int*) VO_V1_DI_DATA_LPF1X3_reg))
+#define VO_V1_DI_DATA_LPF1X3_inst_adr                                                "0x0069"
+#define VO_V1_DI_DATA_LPF1X3_inst                                                    0x0069
+#define VO_V1_DI_DATA_LPF1X3_c2_shift                                                (8)
+#define VO_V1_DI_DATA_LPF1X3_c2_mask                                                 (0x00000700)
+#define VO_V1_DI_DATA_LPF1X3_c2(data)                                                (0x00000700&((data)<<8))
+#define VO_V1_DI_DATA_LPF1X3_c2_src(data)                                            ((0x00000700&(data))>>8)
+#define VO_V1_DI_DATA_LPF1X3_get_c2(data)                                            ((0x00000700&(data))>>8)
+#define VO_V1_DI_DATA_LPF1X3_c1_shift                                                (4)
+#define VO_V1_DI_DATA_LPF1X3_c1_mask                                                 (0x00000070)
+#define VO_V1_DI_DATA_LPF1X3_c1(data)                                                (0x00000070&((data)<<4))
+#define VO_V1_DI_DATA_LPF1X3_c1_src(data)                                            ((0x00000070&(data))>>4)
+#define VO_V1_DI_DATA_LPF1X3_get_c1(data)                                            ((0x00000070&(data))>>4)
+#define VO_V1_DI_DATA_LPF1X3_c0_shift                                                (0)
+#define VO_V1_DI_DATA_LPF1X3_c0_mask                                                 (0x00000007)
+#define VO_V1_DI_DATA_LPF1X3_c0(data)                                                (0x00000007&((data)<<0))
+#define VO_V1_DI_DATA_LPF1X3_c0_src(data)                                            ((0x00000007&(data))>>0)
+#define VO_V1_DI_DATA_LPF1X3_get_c0(data)                                            ((0x00000007&(data))>>0)
+
+
+#define VO_V1_DI_DIFF_LPF1X3                                                         0x980051A8
+#define VO_V1_DI_DIFF_LPF1X3_reg_addr                                                "0xD80051A8"
+#define VO_V1_DI_DIFF_LPF1X3_reg                                                     0xD80051A8
+#define set_VO_V1_DI_DIFF_LPF1X3_reg(data)   (*((volatile unsigned int*) VO_V1_DI_DIFF_LPF1X3_reg)=data)
+#define get_VO_V1_DI_DIFF_LPF1X3_reg   (*((volatile unsigned int*) VO_V1_DI_DIFF_LPF1X3_reg))
+#define VO_V1_DI_DIFF_LPF1X3_inst_adr                                                "0x006A"
+#define VO_V1_DI_DIFF_LPF1X3_inst                                                    0x006A
+#define VO_V1_DI_DIFF_LPF1X3_c2_shift                                                (8)
+#define VO_V1_DI_DIFF_LPF1X3_c2_mask                                                 (0x00000700)
+#define VO_V1_DI_DIFF_LPF1X3_c2(data)                                                (0x00000700&((data)<<8))
+#define VO_V1_DI_DIFF_LPF1X3_c2_src(data)                                            ((0x00000700&(data))>>8)
+#define VO_V1_DI_DIFF_LPF1X3_get_c2(data)                                            ((0x00000700&(data))>>8)
+#define VO_V1_DI_DIFF_LPF1X3_c1_shift                                                (4)
+#define VO_V1_DI_DIFF_LPF1X3_c1_mask                                                 (0x00000070)
+#define VO_V1_DI_DIFF_LPF1X3_c1(data)                                                (0x00000070&((data)<<4))
+#define VO_V1_DI_DIFF_LPF1X3_c1_src(data)                                            ((0x00000070&(data))>>4)
+#define VO_V1_DI_DIFF_LPF1X3_get_c1(data)                                            ((0x00000070&(data))>>4)
+#define VO_V1_DI_DIFF_LPF1X3_c0_shift                                                (0)
+#define VO_V1_DI_DIFF_LPF1X3_c0_mask                                                 (0x00000007)
+#define VO_V1_DI_DIFF_LPF1X3_c0(data)                                                (0x00000007&((data)<<0))
+#define VO_V1_DI_DIFF_LPF1X3_c0_src(data)                                            ((0x00000007&(data))>>0)
+#define VO_V1_DI_DIFF_LPF1X3_get_c0(data)                                            ((0x00000007&(data))>>0)
+
+
+#define VO_V1_DI_BOB_DIFF                                                            0x980051AC
+#define VO_V1_DI_BOB_DIFF_reg_addr                                                   "0xD80051AC"
+#define VO_V1_DI_BOB_DIFF_reg                                                        0xD80051AC
+#define set_VO_V1_DI_BOB_DIFF_reg(data)   (*((volatile unsigned int*) VO_V1_DI_BOB_DIFF_reg)=data)
+#define get_VO_V1_DI_BOB_DIFF_reg   (*((volatile unsigned int*) VO_V1_DI_BOB_DIFF_reg))
+#define VO_V1_DI_BOB_DIFF_inst_adr                                                   "0x006B"
+#define VO_V1_DI_BOB_DIFF_inst                                                       0x006B
+#define VO_V1_DI_BOB_DIFF_max_min_thd_shift                                          (16)
+#define VO_V1_DI_BOB_DIFF_max_min_thd_mask                                           (0x00FF0000)
+#define VO_V1_DI_BOB_DIFF_max_min_thd(data)                                          (0x00FF0000&((data)<<16))
+#define VO_V1_DI_BOB_DIFF_max_min_thd_src(data)                                      ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_BOB_DIFF_get_max_min_thd(data)                                      ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_BOB_DIFF_factor1_shift                                              (8)
+#define VO_V1_DI_BOB_DIFF_factor1_mask                                               (0x00000F00)
+#define VO_V1_DI_BOB_DIFF_factor1(data)                                              (0x00000F00&((data)<<8))
+#define VO_V1_DI_BOB_DIFF_factor1_src(data)                                          ((0x00000F00&(data))>>8)
+#define VO_V1_DI_BOB_DIFF_get_factor1(data)                                          ((0x00000F00&(data))>>8)
+#define VO_V1_DI_BOB_DIFF_factor0_shift                                              (0)
+#define VO_V1_DI_BOB_DIFF_factor0_mask                                               (0x0000000F)
+#define VO_V1_DI_BOB_DIFF_factor0(data)                                              (0x0000000F&((data)<<0))
+#define VO_V1_DI_BOB_DIFF_factor0_src(data)                                          ((0x0000000F&(data))>>0)
+#define VO_V1_DI_BOB_DIFF_get_factor0(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define VO_V1_DI_BOB                                                                 0x980051B0
+#define VO_V1_DI_BOB_reg_addr                                                        "0xD80051B0"
+#define VO_V1_DI_BOB_reg                                                             0xD80051B0
+#define set_VO_V1_DI_BOB_reg(data)   (*((volatile unsigned int*) VO_V1_DI_BOB_reg)=data)
+#define get_VO_V1_DI_BOB_reg   (*((volatile unsigned int*) VO_V1_DI_BOB_reg))
+#define VO_V1_DI_BOB_inst_adr                                                        "0x006C"
+#define VO_V1_DI_BOB_inst                                                            0x006C
+#define VO_V1_DI_BOB_intep_thd_shift                                                 (16)
+#define VO_V1_DI_BOB_intep_thd_mask                                                  (0x03FF0000)
+#define VO_V1_DI_BOB_intep_thd(data)                                                 (0x03FF0000&((data)<<16))
+#define VO_V1_DI_BOB_intep_thd_src(data)                                             ((0x03FF0000&(data))>>16)
+#define VO_V1_DI_BOB_get_intep_thd(data)                                             ((0x03FF0000&(data))>>16)
+#define VO_V1_DI_BOB_final_min_thd_shift                                             (8)
+#define VO_V1_DI_BOB_final_min_thd_mask                                              (0x0000FF00)
+#define VO_V1_DI_BOB_final_min_thd(data)                                             (0x0000FF00&((data)<<8))
+#define VO_V1_DI_BOB_final_min_thd_src(data)                                         ((0x0000FF00&(data))>>8)
+#define VO_V1_DI_BOB_get_final_min_thd(data)                                         ((0x0000FF00&(data))>>8)
+#define VO_V1_DI_BOB_min_thd_shift                                                   (0)
+#define VO_V1_DI_BOB_min_thd_mask                                                    (0x000000FF)
+#define VO_V1_DI_BOB_min_thd(data)                                                   (0x000000FF&((data)<<0))
+#define VO_V1_DI_BOB_min_thd_src(data)                                               ((0x000000FF&(data))>>0)
+#define VO_V1_DI_BOB_get_min_thd(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_NC_COMB                                                             0x980051B4
+#define VO_V1_DI_NC_COMB_reg_addr                                                    "0xD80051B4"
+#define VO_V1_DI_NC_COMB_reg                                                         0xD80051B4
+#define set_VO_V1_DI_NC_COMB_reg(data)   (*((volatile unsigned int*) VO_V1_DI_NC_COMB_reg)=data)
+#define get_VO_V1_DI_NC_COMB_reg   (*((volatile unsigned int*) VO_V1_DI_NC_COMB_reg))
+#define VO_V1_DI_NC_COMB_inst_adr                                                    "0x006D"
+#define VO_V1_DI_NC_COMB_inst                                                        0x006D
+#define VO_V1_DI_NC_COMB_thd_shift                                                   (0)
+#define VO_V1_DI_NC_COMB_thd_mask                                                    (0x000000FF)
+#define VO_V1_DI_NC_COMB_thd(data)                                                   (0x000000FF&((data)<<0))
+#define VO_V1_DI_NC_COMB_thd_src(data)                                               ((0x000000FF&(data))>>0)
+#define VO_V1_DI_NC_COMB_get_thd(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_FINAL_COMB                                                          0x980051B8
+#define VO_V1_DI_FINAL_COMB_reg_addr                                                 "0xD80051B8"
+#define VO_V1_DI_FINAL_COMB_reg                                                      0xD80051B8
+#define set_VO_V1_DI_FINAL_COMB_reg(data)   (*((volatile unsigned int*) VO_V1_DI_FINAL_COMB_reg)=data)
+#define get_VO_V1_DI_FINAL_COMB_reg   (*((volatile unsigned int*) VO_V1_DI_FINAL_COMB_reg))
+#define VO_V1_DI_FINAL_COMB_inst_adr                                                 "0x006E"
+#define VO_V1_DI_FINAL_COMB_inst                                                     0x006E
+#define VO_V1_DI_FINAL_COMB_thd_shift                                                (0)
+#define VO_V1_DI_FINAL_COMB_thd_mask                                                 (0x000000FF)
+#define VO_V1_DI_FINAL_COMB_thd(data)                                                (0x000000FF&((data)<<0))
+#define VO_V1_DI_FINAL_COMB_thd_src(data)                                            ((0x000000FF&(data))>>0)
+#define VO_V1_DI_FINAL_COMB_get_thd(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_DATA_DIFF                                                           0x980051BC
+#define VO_V1_DI_DATA_DIFF_reg_addr                                                  "0xD80051BC"
+#define VO_V1_DI_DATA_DIFF_reg                                                       0xD80051BC
+#define set_VO_V1_DI_DATA_DIFF_reg(data)   (*((volatile unsigned int*) VO_V1_DI_DATA_DIFF_reg)=data)
+#define get_VO_V1_DI_DATA_DIFF_reg   (*((volatile unsigned int*) VO_V1_DI_DATA_DIFF_reg))
+#define VO_V1_DI_DATA_DIFF_inst_adr                                                  "0x006F"
+#define VO_V1_DI_DATA_DIFF_inst                                                      0x006F
+#define VO_V1_DI_DATA_DIFF_nc_thd_shift                                              (16)
+#define VO_V1_DI_DATA_DIFF_nc_thd_mask                                               (0x00FF0000)
+#define VO_V1_DI_DATA_DIFF_nc_thd(data)                                              (0x00FF0000&((data)<<16))
+#define VO_V1_DI_DATA_DIFF_nc_thd_src(data)                                          ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_DATA_DIFF_get_nc_thd(data)                                          ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_DATA_DIFF_pn_thd_shift                                              (0)
+#define VO_V1_DI_DATA_DIFF_pn_thd_mask                                               (0x000000FF)
+#define VO_V1_DI_DATA_DIFF_pn_thd(data)                                              (0x000000FF&((data)<<0))
+#define VO_V1_DI_DATA_DIFF_pn_thd_src(data)                                          ((0x000000FF&(data))>>0)
+#define VO_V1_DI_DATA_DIFF_get_pn_thd(data)                                          ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_ESCAPE                                                              0x980051C0
+#define VO_V1_DI_ESCAPE_reg_addr                                                     "0xD80051C0"
+#define VO_V1_DI_ESCAPE_reg                                                          0xD80051C0
+#define set_VO_V1_DI_ESCAPE_reg(data)   (*((volatile unsigned int*) VO_V1_DI_ESCAPE_reg)=data)
+#define get_VO_V1_DI_ESCAPE_reg   (*((volatile unsigned int*) VO_V1_DI_ESCAPE_reg))
+#define VO_V1_DI_ESCAPE_inst_adr                                                     "0x0070"
+#define VO_V1_DI_ESCAPE_inst                                                         0x0070
+#define VO_V1_DI_ESCAPE_thd_shift                                                    (0)
+#define VO_V1_DI_ESCAPE_thd_mask                                                     (0x000003FF)
+#define VO_V1_DI_ESCAPE_thd(data)                                                    (0x000003FF&((data)<<0))
+#define VO_V1_DI_ESCAPE_thd_src(data)                                                ((0x000003FF&(data))>>0)
+#define VO_V1_DI_ESCAPE_get_thd(data)                                                ((0x000003FF&(data))>>0)
+
+
+#define VO_V1_STA_TOTAL                                                              0x980051C4
+#define VO_V1_STA_TOTAL_reg_addr                                                     "0xD80051C4"
+#define VO_V1_STA_TOTAL_reg                                                          0xD80051C4
+#define set_VO_V1_STA_TOTAL_reg(data)   (*((volatile unsigned int*) VO_V1_STA_TOTAL_reg)=data)
+#define get_VO_V1_STA_TOTAL_reg   (*((volatile unsigned int*) VO_V1_STA_TOTAL_reg))
+#define VO_V1_STA_TOTAL_inst_adr                                                     "0x0071"
+#define VO_V1_STA_TOTAL_inst                                                         0x0071
+#define VO_V1_STA_TOTAL_cnt_shift                                                    (0)
+#define VO_V1_STA_TOTAL_cnt_mask                                                     (0x007FFFFF)
+#define VO_V1_STA_TOTAL_cnt(data)                                                    (0x007FFFFF&((data)<<0))
+#define VO_V1_STA_TOTAL_cnt_src(data)                                                ((0x007FFFFF&(data))>>0)
+#define VO_V1_STA_TOTAL_get_cnt(data)                                                ((0x007FFFFF&(data))>>0)
+
+
+#define VO_V1_STA_SUM                                                                0x980051C8
+#define VO_V1_STA_SUM_reg_addr                                                       "0xD80051C8"
+#define VO_V1_STA_SUM_reg                                                            0xD80051C8
+#define set_VO_V1_STA_SUM_reg(data)   (*((volatile unsigned int*) VO_V1_STA_SUM_reg)=data)
+#define get_VO_V1_STA_SUM_reg   (*((volatile unsigned int*) VO_V1_STA_SUM_reg))
+#define VO_V1_STA_SUM_inst_adr                                                       "0x0072"
+#define VO_V1_STA_SUM_inst                                                           0x0072
+#define VO_V1_STA_SUM_sum_shift                                                      (0)
+#define VO_V1_STA_SUM_sum_mask                                                       (0x7FFFFFFF)
+#define VO_V1_STA_SUM_sum(data)                                                      (0x7FFFFFFF&((data)<<0))
+#define VO_V1_STA_SUM_sum_src(data)                                                  ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_STA_SUM_get_sum(data)                                                  ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_STA_BKT_0                                                              0x980051CC
+#define VO_V1_STA_BKT_1                                                              0x980051D0
+#define VO_V1_STA_BKT_2                                                              0x980051D4
+#define VO_V1_STA_BKT_3                                                              0x980051D8
+#define VO_V1_STA_BKT_4                                                              0x980051DC
+#define VO_V1_STA_BKT_5                                                              0x980051E0
+#define VO_V1_STA_BKT_6                                                              0x980051E4
+#define VO_V1_STA_BKT_7                                                              0x980051E8
+#define VO_V1_STA_BKT_8                                                              0x980051EC
+#define VO_V1_STA_BKT_9                                                              0x980051F0
+#define VO_V1_STA_BKT_0_reg_addr                                                     "0xD80051CC"
+#define VO_V1_STA_BKT_1_reg_addr                                                     "0xD80051D0"
+#define VO_V1_STA_BKT_2_reg_addr                                                     "0xD80051D4"
+#define VO_V1_STA_BKT_3_reg_addr                                                     "0xD80051D8"
+#define VO_V1_STA_BKT_4_reg_addr                                                     "0xD80051DC"
+#define VO_V1_STA_BKT_5_reg_addr                                                     "0xD80051E0"
+#define VO_V1_STA_BKT_6_reg_addr                                                     "0xD80051E4"
+#define VO_V1_STA_BKT_7_reg_addr                                                     "0xD80051E8"
+#define VO_V1_STA_BKT_8_reg_addr                                                     "0xD80051EC"
+#define VO_V1_STA_BKT_9_reg_addr                                                     "0xD80051F0"
+#define VO_V1_STA_BKT_0_reg                                                          0xD80051CC
+#define VO_V1_STA_BKT_1_reg                                                          0xD80051D0
+#define VO_V1_STA_BKT_2_reg                                                          0xD80051D4
+#define VO_V1_STA_BKT_3_reg                                                          0xD80051D8
+#define VO_V1_STA_BKT_4_reg                                                          0xD80051DC
+#define VO_V1_STA_BKT_5_reg                                                          0xD80051E0
+#define VO_V1_STA_BKT_6_reg                                                          0xD80051E4
+#define VO_V1_STA_BKT_7_reg                                                          0xD80051E8
+#define VO_V1_STA_BKT_8_reg                                                          0xD80051EC
+#define VO_V1_STA_BKT_9_reg                                                          0xD80051F0
+#define set_VO_V1_STA_BKT_0_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_0_reg)=data)
+#define set_VO_V1_STA_BKT_1_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_1_reg)=data)
+#define set_VO_V1_STA_BKT_2_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_2_reg)=data)
+#define set_VO_V1_STA_BKT_3_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_3_reg)=data)
+#define set_VO_V1_STA_BKT_4_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_4_reg)=data)
+#define set_VO_V1_STA_BKT_5_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_5_reg)=data)
+#define set_VO_V1_STA_BKT_6_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_6_reg)=data)
+#define set_VO_V1_STA_BKT_7_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_7_reg)=data)
+#define set_VO_V1_STA_BKT_8_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_8_reg)=data)
+#define set_VO_V1_STA_BKT_9_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_9_reg)=data)
+#define get_VO_V1_STA_BKT_0_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_0_reg))
+#define get_VO_V1_STA_BKT_1_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_1_reg))
+#define get_VO_V1_STA_BKT_2_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_2_reg))
+#define get_VO_V1_STA_BKT_3_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_3_reg))
+#define get_VO_V1_STA_BKT_4_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_4_reg))
+#define get_VO_V1_STA_BKT_5_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_5_reg))
+#define get_VO_V1_STA_BKT_6_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_6_reg))
+#define get_VO_V1_STA_BKT_7_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_7_reg))
+#define get_VO_V1_STA_BKT_8_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_8_reg))
+#define get_VO_V1_STA_BKT_9_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_9_reg))
+#define VO_V1_STA_BKT_0_inst_adr                                                     "0x0073"
+#define VO_V1_STA_BKT_1_inst_adr                                                     "0x0074"
+#define VO_V1_STA_BKT_2_inst_adr                                                     "0x0075"
+#define VO_V1_STA_BKT_3_inst_adr                                                     "0x0076"
+#define VO_V1_STA_BKT_4_inst_adr                                                     "0x0077"
+#define VO_V1_STA_BKT_5_inst_adr                                                     "0x0078"
+#define VO_V1_STA_BKT_6_inst_adr                                                     "0x0079"
+#define VO_V1_STA_BKT_7_inst_adr                                                     "0x007A"
+#define VO_V1_STA_BKT_8_inst_adr                                                     "0x007B"
+#define VO_V1_STA_BKT_9_inst_adr                                                     "0x007C"
+#define VO_V1_STA_BKT_0_inst                                                         0x0073
+#define VO_V1_STA_BKT_1_inst                                                         0x0074
+#define VO_V1_STA_BKT_2_inst                                                         0x0075
+#define VO_V1_STA_BKT_3_inst                                                         0x0076
+#define VO_V1_STA_BKT_4_inst                                                         0x0077
+#define VO_V1_STA_BKT_5_inst                                                         0x0078
+#define VO_V1_STA_BKT_6_inst                                                         0x0079
+#define VO_V1_STA_BKT_7_inst                                                         0x007A
+#define VO_V1_STA_BKT_8_inst                                                         0x007B
+#define VO_V1_STA_BKT_9_inst                                                         0x007C
+#define VO_V1_STA_BKT_cnt_shift                                                      (0)
+#define VO_V1_STA_BKT_cnt_mask                                                       (0x007FFFFF)
+#define VO_V1_STA_BKT_cnt(data)                                                      (0x007FFFFF&((data)<<0))
+#define VO_V1_STA_BKT_cnt_src(data)                                                  ((0x007FFFFF&(data))>>0)
+#define VO_V1_STA_BKT_get_cnt(data)                                                  ((0x007FFFFF&(data))>>0)
+
+
+#define VO_V1_STA_AD_0                                                               0x980051F4
+#define VO_V1_STA_AD_1                                                               0x980051F8
+#define VO_V1_STA_AD_2                                                               0x980051FC
+#define VO_V1_STA_AD_3                                                               0x98005200
+#define VO_V1_STA_AD_4                                                               0x98005204
+#define VO_V1_STA_AD_5                                                               0x98005208
+#define VO_V1_STA_AD_6                                                               0x9800520C
+#define VO_V1_STA_AD_7                                                               0x98005210
+#define VO_V1_STA_AD_8                                                               0x98005214
+#define VO_V1_STA_AD_9                                                               0x98005218
+#define VO_V1_STA_AD_0_reg_addr                                                      "0xD80051F4"
+#define VO_V1_STA_AD_1_reg_addr                                                      "0xD80051F8"
+#define VO_V1_STA_AD_2_reg_addr                                                      "0xD80051FC"
+#define VO_V1_STA_AD_3_reg_addr                                                      "0xD8005200"
+#define VO_V1_STA_AD_4_reg_addr                                                      "0xD8005204"
+#define VO_V1_STA_AD_5_reg_addr                                                      "0xD8005208"
+#define VO_V1_STA_AD_6_reg_addr                                                      "0xD800520C"
+#define VO_V1_STA_AD_7_reg_addr                                                      "0xD8005210"
+#define VO_V1_STA_AD_8_reg_addr                                                      "0xD8005214"
+#define VO_V1_STA_AD_9_reg_addr                                                      "0xD8005218"
+#define VO_V1_STA_AD_0_reg                                                           0xD80051F4
+#define VO_V1_STA_AD_1_reg                                                           0xD80051F8
+#define VO_V1_STA_AD_2_reg                                                           0xD80051FC
+#define VO_V1_STA_AD_3_reg                                                           0xD8005200
+#define VO_V1_STA_AD_4_reg                                                           0xD8005204
+#define VO_V1_STA_AD_5_reg                                                           0xD8005208
+#define VO_V1_STA_AD_6_reg                                                           0xD800520C
+#define VO_V1_STA_AD_7_reg                                                           0xD8005210
+#define VO_V1_STA_AD_8_reg                                                           0xD8005214
+#define VO_V1_STA_AD_9_reg                                                           0xD8005218
+#define set_VO_V1_STA_AD_0_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_0_reg)=data)
+#define set_VO_V1_STA_AD_1_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_1_reg)=data)
+#define set_VO_V1_STA_AD_2_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_2_reg)=data)
+#define set_VO_V1_STA_AD_3_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_3_reg)=data)
+#define set_VO_V1_STA_AD_4_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_4_reg)=data)
+#define set_VO_V1_STA_AD_5_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_5_reg)=data)
+#define set_VO_V1_STA_AD_6_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_6_reg)=data)
+#define set_VO_V1_STA_AD_7_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_7_reg)=data)
+#define set_VO_V1_STA_AD_8_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_8_reg)=data)
+#define set_VO_V1_STA_AD_9_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_9_reg)=data)
+#define get_VO_V1_STA_AD_0_reg   (*((volatile unsigned int*) VO_V1_STA_AD_0_reg))
+#define get_VO_V1_STA_AD_1_reg   (*((volatile unsigned int*) VO_V1_STA_AD_1_reg))
+#define get_VO_V1_STA_AD_2_reg   (*((volatile unsigned int*) VO_V1_STA_AD_2_reg))
+#define get_VO_V1_STA_AD_3_reg   (*((volatile unsigned int*) VO_V1_STA_AD_3_reg))
+#define get_VO_V1_STA_AD_4_reg   (*((volatile unsigned int*) VO_V1_STA_AD_4_reg))
+#define get_VO_V1_STA_AD_5_reg   (*((volatile unsigned int*) VO_V1_STA_AD_5_reg))
+#define get_VO_V1_STA_AD_6_reg   (*((volatile unsigned int*) VO_V1_STA_AD_6_reg))
+#define get_VO_V1_STA_AD_7_reg   (*((volatile unsigned int*) VO_V1_STA_AD_7_reg))
+#define get_VO_V1_STA_AD_8_reg   (*((volatile unsigned int*) VO_V1_STA_AD_8_reg))
+#define get_VO_V1_STA_AD_9_reg   (*((volatile unsigned int*) VO_V1_STA_AD_9_reg))
+#define VO_V1_STA_AD_0_inst_adr                                                      "0x007D"
+#define VO_V1_STA_AD_1_inst_adr                                                      "0x007E"
+#define VO_V1_STA_AD_2_inst_adr                                                      "0x007F"
+#define VO_V1_STA_AD_3_inst_adr                                                      "0x0080"
+#define VO_V1_STA_AD_4_inst_adr                                                      "0x0081"
+#define VO_V1_STA_AD_5_inst_adr                                                      "0x0082"
+#define VO_V1_STA_AD_6_inst_adr                                                      "0x0083"
+#define VO_V1_STA_AD_7_inst_adr                                                      "0x0084"
+#define VO_V1_STA_AD_8_inst_adr                                                      "0x0085"
+#define VO_V1_STA_AD_9_inst_adr                                                      "0x0086"
+#define VO_V1_STA_AD_0_inst                                                          0x007D
+#define VO_V1_STA_AD_1_inst                                                          0x007E
+#define VO_V1_STA_AD_2_inst                                                          0x007F
+#define VO_V1_STA_AD_3_inst                                                          0x0080
+#define VO_V1_STA_AD_4_inst                                                          0x0081
+#define VO_V1_STA_AD_5_inst                                                          0x0082
+#define VO_V1_STA_AD_6_inst                                                          0x0083
+#define VO_V1_STA_AD_7_inst                                                          0x0084
+#define VO_V1_STA_AD_8_inst                                                          0x0085
+#define VO_V1_STA_AD_9_inst                                                          0x0086
+#define VO_V1_STA_AD_sum_shift                                                       (0)
+#define VO_V1_STA_AD_sum_mask                                                        (0x7FFFFFFF)
+#define VO_V1_STA_AD_sum(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define VO_V1_STA_AD_sum_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_STA_AD_get_sum(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_STA_NC_COMB                                                            0x9800521C
+#define VO_V1_STA_NC_COMB_reg_addr                                                   "0xD800521C"
+#define VO_V1_STA_NC_COMB_reg                                                        0xD800521C
+#define set_VO_V1_STA_NC_COMB_reg(data)   (*((volatile unsigned int*) VO_V1_STA_NC_COMB_reg)=data)
+#define get_VO_V1_STA_NC_COMB_reg   (*((volatile unsigned int*) VO_V1_STA_NC_COMB_reg))
+#define VO_V1_STA_NC_COMB_inst_adr                                                   "0x0087"
+#define VO_V1_STA_NC_COMB_inst                                                       0x0087
+#define VO_V1_STA_NC_COMB_cnt_shift                                                  (0)
+#define VO_V1_STA_NC_COMB_cnt_mask                                                   (0x000FFFFF)
+#define VO_V1_STA_NC_COMB_cnt(data)                                                  (0x000FFFFF&((data)<<0))
+#define VO_V1_STA_NC_COMB_cnt_src(data)                                              ((0x000FFFFF&(data))>>0)
+#define VO_V1_STA_NC_COMB_get_cnt(data)                                              ((0x000FFFFF&(data))>>0)
+
+
+#define VO_V1_STA_FINAL_COMB                                                         0x98005220
+#define VO_V1_STA_FINAL_COMB_reg_addr                                                "0xD8005220"
+#define VO_V1_STA_FINAL_COMB_reg                                                     0xD8005220
+#define set_VO_V1_STA_FINAL_COMB_reg(data)   (*((volatile unsigned int*) VO_V1_STA_FINAL_COMB_reg)=data)
+#define get_VO_V1_STA_FINAL_COMB_reg   (*((volatile unsigned int*) VO_V1_STA_FINAL_COMB_reg))
+#define VO_V1_STA_FINAL_COMB_inst_adr                                                "0x0088"
+#define VO_V1_STA_FINAL_COMB_inst                                                    0x0088
+#define VO_V1_STA_FINAL_COMB_cnt_shift                                               (0)
+#define VO_V1_STA_FINAL_COMB_cnt_mask                                                (0x000FFFFF)
+#define VO_V1_STA_FINAL_COMB_cnt(data)                                               (0x000FFFFF&((data)<<0))
+#define VO_V1_STA_FINAL_COMB_cnt_src(data)                                           ((0x000FFFFF&(data))>>0)
+#define VO_V1_STA_FINAL_COMB_get_cnt(data)                                           ((0x000FFFFF&(data))>>0)
+
+
+#define VO_V1_STA_PN_DIFF                                                            0x98005224
+#define VO_V1_STA_PN_DIFF_reg_addr                                                   "0xD8005224"
+#define VO_V1_STA_PN_DIFF_reg                                                        0xD8005224
+#define set_VO_V1_STA_PN_DIFF_reg(data)   (*((volatile unsigned int*) VO_V1_STA_PN_DIFF_reg)=data)
+#define get_VO_V1_STA_PN_DIFF_reg   (*((volatile unsigned int*) VO_V1_STA_PN_DIFF_reg))
+#define VO_V1_STA_PN_DIFF_inst_adr                                                   "0x0089"
+#define VO_V1_STA_PN_DIFF_inst                                                       0x0089
+#define VO_V1_STA_PN_DIFF_cnt_shift                                                  (0)
+#define VO_V1_STA_PN_DIFF_cnt_mask                                                   (0x000FFFFF)
+#define VO_V1_STA_PN_DIFF_cnt(data)                                                  (0x000FFFFF&((data)<<0))
+#define VO_V1_STA_PN_DIFF_cnt_src(data)                                              ((0x000FFFFF&(data))>>0)
+#define VO_V1_STA_PN_DIFF_get_cnt(data)                                              ((0x000FFFFF&(data))>>0)
+
+
+#define VO_V1_STA_NC_DIFF                                                            0x98005228
+#define VO_V1_STA_NC_DIFF_reg_addr                                                   "0xD8005228"
+#define VO_V1_STA_NC_DIFF_reg                                                        0xD8005228
+#define set_VO_V1_STA_NC_DIFF_reg(data)   (*((volatile unsigned int*) VO_V1_STA_NC_DIFF_reg)=data)
+#define get_VO_V1_STA_NC_DIFF_reg   (*((volatile unsigned int*) VO_V1_STA_NC_DIFF_reg))
+#define VO_V1_STA_NC_DIFF_inst_adr                                                   "0x008A"
+#define VO_V1_STA_NC_DIFF_inst                                                       0x008A
+#define VO_V1_STA_NC_DIFF_cnt_shift                                                  (0)
+#define VO_V1_STA_NC_DIFF_cnt_mask                                                   (0x000FFFFF)
+#define VO_V1_STA_NC_DIFF_cnt(data)                                                  (0x000FFFFF&((data)<<0))
+#define VO_V1_STA_NC_DIFF_cnt_src(data)                                              ((0x000FFFFF&(data))>>0)
+#define VO_V1_STA_NC_DIFF_get_cnt(data)                                              ((0x000FFFFF&(data))>>0)
+
+
+#define VO_V1_VSYI                                                                   0x9800522C
+#define VO_V1_VSYI_reg_addr                                                          "0xD800522C"
+#define VO_V1_VSYI_reg                                                               0xD800522C
+#define set_VO_V1_VSYI_reg(data)   (*((volatile unsigned int*) VO_V1_VSYI_reg)=data)
+#define get_VO_V1_VSYI_reg   (*((volatile unsigned int*) VO_V1_VSYI_reg))
+#define VO_V1_VSYI_inst_adr                                                          "0x008B"
+#define VO_V1_VSYI_inst                                                              0x008B
+#define VO_V1_VSYI_offset_shift                                                      (16)
+#define VO_V1_VSYI_offset_mask                                                       (0x3FFF0000)
+#define VO_V1_VSYI_offset(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_V1_VSYI_offset_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSYI_get_offset(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSYI_phase_shift                                                       (0)
+#define VO_V1_VSYI_phase_mask                                                        (0x0000FFFF)
+#define VO_V1_VSYI_phase(data)                                                       (0x0000FFFF&((data)<<0))
+#define VO_V1_VSYI_phase_src(data)                                                   ((0x0000FFFF&(data))>>0)
+#define VO_V1_VSYI_get_phase(data)                                                   ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_VSCI                                                                   0x98005230
+#define VO_V1_VSCI_reg_addr                                                          "0xD8005230"
+#define VO_V1_VSCI_reg                                                               0xD8005230
+#define set_VO_V1_VSCI_reg(data)   (*((volatile unsigned int*) VO_V1_VSCI_reg)=data)
+#define get_VO_V1_VSCI_reg   (*((volatile unsigned int*) VO_V1_VSCI_reg))
+#define VO_V1_VSCI_inst_adr                                                          "0x008C"
+#define VO_V1_VSCI_inst                                                              0x008C
+#define VO_V1_VSCI_offset_shift                                                      (16)
+#define VO_V1_VSCI_offset_mask                                                       (0x3FFF0000)
+#define VO_V1_VSCI_offset(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_V1_VSCI_offset_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSCI_get_offset(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSCI_phase_shift                                                       (0)
+#define VO_V1_VSCI_phase_mask                                                        (0x0000FFFF)
+#define VO_V1_VSCI_phase(data)                                                       (0x0000FFFF&((data)<<0))
+#define VO_V1_VSCI_phase_src(data)                                                   ((0x0000FFFF&(data))>>0)
+#define VO_V1_VSCI_get_phase(data)                                                   ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_VSD                                                                    0x98005234
+#define VO_V1_VSD_reg_addr                                                           "0xD8005234"
+#define VO_V1_VSD_reg                                                                0xD8005234
+#define set_VO_V1_VSD_reg(data)   (*((volatile unsigned int*) VO_V1_VSD_reg)=data)
+#define get_VO_V1_VSD_reg   (*((volatile unsigned int*) VO_V1_VSD_reg))
+#define VO_V1_VSD_inst_adr                                                           "0x008D"
+#define VO_V1_VSD_inst                                                               0x008D
+#define VO_V1_VSD_delta_shift                                                        (0)
+#define VO_V1_VSD_delta_mask                                                         (0x001FFFFF)
+#define VO_V1_VSD_delta(data)                                                        (0x001FFFFF&((data)<<0))
+#define VO_V1_VSD_delta_src(data)                                                    ((0x001FFFFF&(data))>>0)
+#define VO_V1_VSD_get_delta(data)                                                    ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_VSD_H                                                                  0x98005238
+#define VO_V1_VSD_H_reg_addr                                                         "0xD8005238"
+#define VO_V1_VSD_H_reg                                                              0xD8005238
+#define set_VO_V1_VSD_H_reg(data)   (*((volatile unsigned int*) VO_V1_VSD_H_reg)=data)
+#define get_VO_V1_VSD_H_reg   (*((volatile unsigned int*) VO_V1_VSD_H_reg))
+#define VO_V1_VSD_H_inst_adr                                                         "0x008E"
+#define VO_V1_VSD_H_inst                                                             0x008E
+#define VO_V1_VSD_H_out_shift                                                        (0)
+#define VO_V1_VSD_H_out_mask                                                         (0x00000FFF)
+#define VO_V1_VSD_H_out(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V1_VSD_H_out_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V1_VSD_H_get_out(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_VSYC_0                                                                 0x9800523C
+#define VO_V1_VSYC_1                                                                 0x98005240
+#define VO_V1_VSYC_2                                                                 0x98005244
+#define VO_V1_VSYC_3                                                                 0x98005248
+#define VO_V1_VSYC_4                                                                 0x9800524C
+#define VO_V1_VSYC_5                                                                 0x98005250
+#define VO_V1_VSYC_6                                                                 0x98005254
+#define VO_V1_VSYC_7                                                                 0x98005258
+#define VO_V1_VSYC_8                                                                 0x9800525C
+#define VO_V1_VSYC_9                                                                 0x98005260
+#define VO_V1_VSYC_10                                                                 0x98005264
+#define VO_V1_VSYC_11                                                                 0x98005268
+#define VO_V1_VSYC_12                                                                 0x9800526C
+#define VO_V1_VSYC_13                                                                 0x98005270
+#define VO_V1_VSYC_14                                                                 0x98005274
+#define VO_V1_VSYC_15                                                                 0x98005278
+#define VO_V1_VSYC_0_reg_addr                                                        "0xD800523C"
+#define VO_V1_VSYC_1_reg_addr                                                        "0xD8005240"
+#define VO_V1_VSYC_2_reg_addr                                                        "0xD8005244"
+#define VO_V1_VSYC_3_reg_addr                                                        "0xD8005248"
+#define VO_V1_VSYC_4_reg_addr                                                        "0xD800524C"
+#define VO_V1_VSYC_5_reg_addr                                                        "0xD8005250"
+#define VO_V1_VSYC_6_reg_addr                                                        "0xD8005254"
+#define VO_V1_VSYC_7_reg_addr                                                        "0xD8005258"
+#define VO_V1_VSYC_8_reg_addr                                                        "0xD800525C"
+#define VO_V1_VSYC_9_reg_addr                                                        "0xD8005260"
+#define VO_V1_VSYC_10_reg_addr                                                        "0xD8005264"
+#define VO_V1_VSYC_11_reg_addr                                                        "0xD8005268"
+#define VO_V1_VSYC_12_reg_addr                                                        "0xD800526C"
+#define VO_V1_VSYC_13_reg_addr                                                        "0xD8005270"
+#define VO_V1_VSYC_14_reg_addr                                                        "0xD8005274"
+#define VO_V1_VSYC_15_reg_addr                                                        "0xD8005278"
+#define VO_V1_VSYC_0_reg                                                             0xD800523C
+#define VO_V1_VSYC_1_reg                                                             0xD8005240
+#define VO_V1_VSYC_2_reg                                                             0xD8005244
+#define VO_V1_VSYC_3_reg                                                             0xD8005248
+#define VO_V1_VSYC_4_reg                                                             0xD800524C
+#define VO_V1_VSYC_5_reg                                                             0xD8005250
+#define VO_V1_VSYC_6_reg                                                             0xD8005254
+#define VO_V1_VSYC_7_reg                                                             0xD8005258
+#define VO_V1_VSYC_8_reg                                                             0xD800525C
+#define VO_V1_VSYC_9_reg                                                             0xD8005260
+#define VO_V1_VSYC_10_reg                                                             0xD8005264
+#define VO_V1_VSYC_11_reg                                                             0xD8005268
+#define VO_V1_VSYC_12_reg                                                             0xD800526C
+#define VO_V1_VSYC_13_reg                                                             0xD8005270
+#define VO_V1_VSYC_14_reg                                                             0xD8005274
+#define VO_V1_VSYC_15_reg                                                             0xD8005278
+#define set_VO_V1_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_0_reg)=data)
+#define set_VO_V1_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_1_reg)=data)
+#define set_VO_V1_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_2_reg)=data)
+#define set_VO_V1_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_3_reg)=data)
+#define set_VO_V1_VSYC_4_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_4_reg)=data)
+#define set_VO_V1_VSYC_5_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_5_reg)=data)
+#define set_VO_V1_VSYC_6_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_6_reg)=data)
+#define set_VO_V1_VSYC_7_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_7_reg)=data)
+#define set_VO_V1_VSYC_8_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_8_reg)=data)
+#define set_VO_V1_VSYC_9_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_9_reg)=data)
+#define set_VO_V1_VSYC_10_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_10_reg)=data)
+#define set_VO_V1_VSYC_11_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_11_reg)=data)
+#define set_VO_V1_VSYC_12_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_12_reg)=data)
+#define set_VO_V1_VSYC_13_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_13_reg)=data)
+#define set_VO_V1_VSYC_14_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_14_reg)=data)
+#define set_VO_V1_VSYC_15_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_15_reg)=data)
+#define get_VO_V1_VSYC_0_reg   (*((volatile unsigned int*) VO_V1_VSYC_0_reg))
+#define get_VO_V1_VSYC_1_reg   (*((volatile unsigned int*) VO_V1_VSYC_1_reg))
+#define get_VO_V1_VSYC_2_reg   (*((volatile unsigned int*) VO_V1_VSYC_2_reg))
+#define get_VO_V1_VSYC_3_reg   (*((volatile unsigned int*) VO_V1_VSYC_3_reg))
+#define get_VO_V1_VSYC_4_reg   (*((volatile unsigned int*) VO_V1_VSYC_4_reg))
+#define get_VO_V1_VSYC_5_reg   (*((volatile unsigned int*) VO_V1_VSYC_5_reg))
+#define get_VO_V1_VSYC_6_reg   (*((volatile unsigned int*) VO_V1_VSYC_6_reg))
+#define get_VO_V1_VSYC_7_reg   (*((volatile unsigned int*) VO_V1_VSYC_7_reg))
+#define get_VO_V1_VSYC_8_reg   (*((volatile unsigned int*) VO_V1_VSYC_8_reg))
+#define get_VO_V1_VSYC_9_reg   (*((volatile unsigned int*) VO_V1_VSYC_9_reg))
+#define get_VO_V1_VSYC_10_reg   (*((volatile unsigned int*) VO_V1_VSYC_10_reg))
+#define get_VO_V1_VSYC_11_reg   (*((volatile unsigned int*) VO_V1_VSYC_11_reg))
+#define get_VO_V1_VSYC_12_reg   (*((volatile unsigned int*) VO_V1_VSYC_12_reg))
+#define get_VO_V1_VSYC_13_reg   (*((volatile unsigned int*) VO_V1_VSYC_13_reg))
+#define get_VO_V1_VSYC_14_reg   (*((volatile unsigned int*) VO_V1_VSYC_14_reg))
+#define get_VO_V1_VSYC_15_reg   (*((volatile unsigned int*) VO_V1_VSYC_15_reg))
+#define VO_V1_VSYC_0_inst_adr                                                        "0x008F"
+#define VO_V1_VSYC_1_inst_adr                                                        "0x0090"
+#define VO_V1_VSYC_2_inst_adr                                                        "0x0091"
+#define VO_V1_VSYC_3_inst_adr                                                        "0x0092"
+#define VO_V1_VSYC_4_inst_adr                                                        "0x0093"
+#define VO_V1_VSYC_5_inst_adr                                                        "0x0094"
+#define VO_V1_VSYC_6_inst_adr                                                        "0x0095"
+#define VO_V1_VSYC_7_inst_adr                                                        "0x0096"
+#define VO_V1_VSYC_8_inst_adr                                                        "0x0097"
+#define VO_V1_VSYC_9_inst_adr                                                        "0x0098"
+#define VO_V1_VSYC_10_inst_adr                                                        "0x0099"
+#define VO_V1_VSYC_11_inst_adr                                                        "0x009A"
+#define VO_V1_VSYC_12_inst_adr                                                        "0x009B"
+#define VO_V1_VSYC_13_inst_adr                                                        "0x009C"
+#define VO_V1_VSYC_14_inst_adr                                                        "0x009D"
+#define VO_V1_VSYC_15_inst_adr                                                        "0x009E"
+#define VO_V1_VSYC_0_inst                                                            0x008F
+#define VO_V1_VSYC_1_inst                                                            0x0090
+#define VO_V1_VSYC_2_inst                                                            0x0091
+#define VO_V1_VSYC_3_inst                                                            0x0092
+#define VO_V1_VSYC_4_inst                                                            0x0093
+#define VO_V1_VSYC_5_inst                                                            0x0094
+#define VO_V1_VSYC_6_inst                                                            0x0095
+#define VO_V1_VSYC_7_inst                                                            0x0096
+#define VO_V1_VSYC_8_inst                                                            0x0097
+#define VO_V1_VSYC_9_inst                                                            0x0098
+#define VO_V1_VSYC_10_inst                                                            0x0099
+#define VO_V1_VSYC_11_inst                                                            0x009A
+#define VO_V1_VSYC_12_inst                                                            0x009B
+#define VO_V1_VSYC_13_inst                                                            0x009C
+#define VO_V1_VSYC_14_inst                                                            0x009D
+#define VO_V1_VSYC_15_inst                                                            0x009E
+#define VO_V1_VSYC_c1_shift                                                          (16)
+#define VO_V1_VSYC_c1_mask                                                           (0x3FFF0000)
+#define VO_V1_VSYC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_VSYC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSYC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSYC_c0_shift                                                          (0)
+#define VO_V1_VSYC_c0_mask                                                           (0x00003FFF)
+#define VO_V1_VSYC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_VSYC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_VSYC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_VSCC_0                                                                 0x9800527C
+#define VO_V1_VSCC_1                                                                 0x98005280
+#define VO_V1_VSCC_2                                                                 0x98005284
+#define VO_V1_VSCC_3                                                                 0x98005288
+#define VO_V1_VSCC_4                                                                 0x9800528C
+#define VO_V1_VSCC_5                                                                 0x98005290
+#define VO_V1_VSCC_6                                                                 0x98005294
+#define VO_V1_VSCC_7                                                                 0x98005298
+#define VO_V1_VSCC_8                                                                 0x9800529C
+#define VO_V1_VSCC_9                                                                 0x980052A0
+#define VO_V1_VSCC_10                                                                 0x980052A4
+#define VO_V1_VSCC_11                                                                 0x980052A8
+#define VO_V1_VSCC_12                                                                 0x980052AC
+#define VO_V1_VSCC_13                                                                 0x980052B0
+#define VO_V1_VSCC_14                                                                 0x980052B4
+#define VO_V1_VSCC_15                                                                 0x980052B8
+#define VO_V1_VSCC_0_reg_addr                                                        "0xD800527C"
+#define VO_V1_VSCC_1_reg_addr                                                        "0xD8005280"
+#define VO_V1_VSCC_2_reg_addr                                                        "0xD8005284"
+#define VO_V1_VSCC_3_reg_addr                                                        "0xD8005288"
+#define VO_V1_VSCC_4_reg_addr                                                        "0xD800528C"
+#define VO_V1_VSCC_5_reg_addr                                                        "0xD8005290"
+#define VO_V1_VSCC_6_reg_addr                                                        "0xD8005294"
+#define VO_V1_VSCC_7_reg_addr                                                        "0xD8005298"
+#define VO_V1_VSCC_8_reg_addr                                                        "0xD800529C"
+#define VO_V1_VSCC_9_reg_addr                                                        "0xD80052A0"
+#define VO_V1_VSCC_10_reg_addr                                                        "0xD80052A4"
+#define VO_V1_VSCC_11_reg_addr                                                        "0xD80052A8"
+#define VO_V1_VSCC_12_reg_addr                                                        "0xD80052AC"
+#define VO_V1_VSCC_13_reg_addr                                                        "0xD80052B0"
+#define VO_V1_VSCC_14_reg_addr                                                        "0xD80052B4"
+#define VO_V1_VSCC_15_reg_addr                                                        "0xD80052B8"
+#define VO_V1_VSCC_0_reg                                                             0xD800527C
+#define VO_V1_VSCC_1_reg                                                             0xD8005280
+#define VO_V1_VSCC_2_reg                                                             0xD8005284
+#define VO_V1_VSCC_3_reg                                                             0xD8005288
+#define VO_V1_VSCC_4_reg                                                             0xD800528C
+#define VO_V1_VSCC_5_reg                                                             0xD8005290
+#define VO_V1_VSCC_6_reg                                                             0xD8005294
+#define VO_V1_VSCC_7_reg                                                             0xD8005298
+#define VO_V1_VSCC_8_reg                                                             0xD800529C
+#define VO_V1_VSCC_9_reg                                                             0xD80052A0
+#define VO_V1_VSCC_10_reg                                                             0xD80052A4
+#define VO_V1_VSCC_11_reg                                                             0xD80052A8
+#define VO_V1_VSCC_12_reg                                                             0xD80052AC
+#define VO_V1_VSCC_13_reg                                                             0xD80052B0
+#define VO_V1_VSCC_14_reg                                                             0xD80052B4
+#define VO_V1_VSCC_15_reg                                                             0xD80052B8
+#define set_VO_V1_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_0_reg)=data)
+#define set_VO_V1_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_1_reg)=data)
+#define set_VO_V1_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_2_reg)=data)
+#define set_VO_V1_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_3_reg)=data)
+#define set_VO_V1_VSCC_4_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_4_reg)=data)
+#define set_VO_V1_VSCC_5_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_5_reg)=data)
+#define set_VO_V1_VSCC_6_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_6_reg)=data)
+#define set_VO_V1_VSCC_7_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_7_reg)=data)
+#define set_VO_V1_VSCC_8_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_8_reg)=data)
+#define set_VO_V1_VSCC_9_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_9_reg)=data)
+#define set_VO_V1_VSCC_10_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_10_reg)=data)
+#define set_VO_V1_VSCC_11_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_11_reg)=data)
+#define set_VO_V1_VSCC_12_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_12_reg)=data)
+#define set_VO_V1_VSCC_13_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_13_reg)=data)
+#define set_VO_V1_VSCC_14_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_14_reg)=data)
+#define set_VO_V1_VSCC_15_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_15_reg)=data)
+#define get_VO_V1_VSCC_0_reg   (*((volatile unsigned int*) VO_V1_VSCC_0_reg))
+#define get_VO_V1_VSCC_1_reg   (*((volatile unsigned int*) VO_V1_VSCC_1_reg))
+#define get_VO_V1_VSCC_2_reg   (*((volatile unsigned int*) VO_V1_VSCC_2_reg))
+#define get_VO_V1_VSCC_3_reg   (*((volatile unsigned int*) VO_V1_VSCC_3_reg))
+#define get_VO_V1_VSCC_4_reg   (*((volatile unsigned int*) VO_V1_VSCC_4_reg))
+#define get_VO_V1_VSCC_5_reg   (*((volatile unsigned int*) VO_V1_VSCC_5_reg))
+#define get_VO_V1_VSCC_6_reg   (*((volatile unsigned int*) VO_V1_VSCC_6_reg))
+#define get_VO_V1_VSCC_7_reg   (*((volatile unsigned int*) VO_V1_VSCC_7_reg))
+#define get_VO_V1_VSCC_8_reg   (*((volatile unsigned int*) VO_V1_VSCC_8_reg))
+#define get_VO_V1_VSCC_9_reg   (*((volatile unsigned int*) VO_V1_VSCC_9_reg))
+#define get_VO_V1_VSCC_10_reg   (*((volatile unsigned int*) VO_V1_VSCC_10_reg))
+#define get_VO_V1_VSCC_11_reg   (*((volatile unsigned int*) VO_V1_VSCC_11_reg))
+#define get_VO_V1_VSCC_12_reg   (*((volatile unsigned int*) VO_V1_VSCC_12_reg))
+#define get_VO_V1_VSCC_13_reg   (*((volatile unsigned int*) VO_V1_VSCC_13_reg))
+#define get_VO_V1_VSCC_14_reg   (*((volatile unsigned int*) VO_V1_VSCC_14_reg))
+#define get_VO_V1_VSCC_15_reg   (*((volatile unsigned int*) VO_V1_VSCC_15_reg))
+#define VO_V1_VSCC_0_inst_adr                                                        "0x009F"
+#define VO_V1_VSCC_1_inst_adr                                                        "0x00A0"
+#define VO_V1_VSCC_2_inst_adr                                                        "0x00A1"
+#define VO_V1_VSCC_3_inst_adr                                                        "0x00A2"
+#define VO_V1_VSCC_4_inst_adr                                                        "0x00A3"
+#define VO_V1_VSCC_5_inst_adr                                                        "0x00A4"
+#define VO_V1_VSCC_6_inst_adr                                                        "0x00A5"
+#define VO_V1_VSCC_7_inst_adr                                                        "0x00A6"
+#define VO_V1_VSCC_8_inst_adr                                                        "0x00A7"
+#define VO_V1_VSCC_9_inst_adr                                                        "0x00A8"
+#define VO_V1_VSCC_10_inst_adr                                                        "0x00A9"
+#define VO_V1_VSCC_11_inst_adr                                                        "0x00AA"
+#define VO_V1_VSCC_12_inst_adr                                                        "0x00AB"
+#define VO_V1_VSCC_13_inst_adr                                                        "0x00AC"
+#define VO_V1_VSCC_14_inst_adr                                                        "0x00AD"
+#define VO_V1_VSCC_15_inst_adr                                                        "0x00AE"
+#define VO_V1_VSCC_0_inst                                                            0x009F
+#define VO_V1_VSCC_1_inst                                                            0x00A0
+#define VO_V1_VSCC_2_inst                                                            0x00A1
+#define VO_V1_VSCC_3_inst                                                            0x00A2
+#define VO_V1_VSCC_4_inst                                                            0x00A3
+#define VO_V1_VSCC_5_inst                                                            0x00A4
+#define VO_V1_VSCC_6_inst                                                            0x00A5
+#define VO_V1_VSCC_7_inst                                                            0x00A6
+#define VO_V1_VSCC_8_inst                                                            0x00A7
+#define VO_V1_VSCC_9_inst                                                            0x00A8
+#define VO_V1_VSCC_10_inst                                                            0x00A9
+#define VO_V1_VSCC_11_inst                                                            0x00AA
+#define VO_V1_VSCC_12_inst                                                            0x00AB
+#define VO_V1_VSCC_13_inst                                                            0x00AC
+#define VO_V1_VSCC_14_inst                                                            0x00AD
+#define VO_V1_VSCC_15_inst                                                            0x00AE
+#define VO_V1_VSCC_c1_shift                                                          (16)
+#define VO_V1_VSCC_c1_mask                                                           (0x3FFF0000)
+#define VO_V1_VSCC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_VSCC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSCC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSCC_c0_shift                                                          (0)
+#define VO_V1_VSCC_c0_mask                                                           (0x00003FFF)
+#define VO_V1_VSCC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_VSCC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_VSCC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_HSI                                                                    0x980052BC
+#define VO_V1_HSI_reg_addr                                                           "0xD80052BC"
+#define VO_V1_HSI_reg                                                                0xD80052BC
+#define set_VO_V1_HSI_reg(data)   (*((volatile unsigned int*) VO_V1_HSI_reg)=data)
+#define get_VO_V1_HSI_reg   (*((volatile unsigned int*) VO_V1_HSI_reg))
+#define VO_V1_HSI_inst_adr                                                           "0x00AF"
+#define VO_V1_HSI_inst                                                               0x00AF
+#define VO_V1_HSI_offset_shift                                                       (16)
+#define VO_V1_HSI_offset_mask                                                        (0x1FFF0000)
+#define VO_V1_HSI_offset(data)                                                       (0x1FFF0000&((data)<<16))
+#define VO_V1_HSI_offset_src(data)                                                   ((0x1FFF0000&(data))>>16)
+#define VO_V1_HSI_get_offset(data)                                                   ((0x1FFF0000&(data))>>16)
+#define VO_V1_HSI_phase_shift                                                        (0)
+#define VO_V1_HSI_phase_mask                                                         (0x0000FFFF)
+#define VO_V1_HSI_phase(data)                                                        (0x0000FFFF&((data)<<0))
+#define VO_V1_HSI_phase_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define VO_V1_HSI_get_phase(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HSD                                                                    0x980052C0
+#define VO_V1_HSD_reg_addr                                                           "0xD80052C0"
+#define VO_V1_HSD_reg                                                                0xD80052C0
+#define set_VO_V1_HSD_reg(data)   (*((volatile unsigned int*) VO_V1_HSD_reg)=data)
+#define get_VO_V1_HSD_reg   (*((volatile unsigned int*) VO_V1_HSD_reg))
+#define VO_V1_HSD_inst_adr                                                           "0x00B0"
+#define VO_V1_HSD_inst                                                               0x00B0
+#define VO_V1_HSD_delta_shift                                                        (0)
+#define VO_V1_HSD_delta_mask                                                         (0x001FFFFF)
+#define VO_V1_HSD_delta(data)                                                        (0x001FFFFF&((data)<<0))
+#define VO_V1_HSD_delta_src(data)                                                    ((0x001FFFFF&(data))>>0)
+#define VO_V1_HSD_get_delta(data)                                                    ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HSD_W                                                                  0x980052C4
+#define VO_V1_HSD_W_reg_addr                                                         "0xD80052C4"
+#define VO_V1_HSD_W_reg                                                              0xD80052C4
+#define set_VO_V1_HSD_W_reg(data)   (*((volatile unsigned int*) VO_V1_HSD_W_reg)=data)
+#define get_VO_V1_HSD_W_reg   (*((volatile unsigned int*) VO_V1_HSD_W_reg))
+#define VO_V1_HSD_W_inst_adr                                                         "0x00B1"
+#define VO_V1_HSD_W_inst                                                             0x00B1
+#define VO_V1_HSD_W_out_shift                                                        (0)
+#define VO_V1_HSD_W_out_mask                                                         (0x00001FFF)
+#define VO_V1_HSD_W_out(data)                                                        (0x00001FFF&((data)<<0))
+#define VO_V1_HSD_W_out_src(data)                                                    ((0x00001FFF&(data))>>0)
+#define VO_V1_HSD_W_get_out(data)                                                    ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1_HSYC_0                                                                 0x980052C8
+#define VO_V1_HSYC_1                                                                 0x980052CC
+#define VO_V1_HSYC_2                                                                 0x980052D0
+#define VO_V1_HSYC_3                                                                 0x980052D4
+#define VO_V1_HSYC_4                                                                 0x980052D8
+#define VO_V1_HSYC_5                                                                 0x980052DC
+#define VO_V1_HSYC_6                                                                 0x980052E0
+#define VO_V1_HSYC_7                                                                 0x980052E4
+#define VO_V1_HSYC_8                                                                 0x980052E8
+#define VO_V1_HSYC_9                                                                 0x980052EC
+#define VO_V1_HSYC_10                                                                 0x980052F0
+#define VO_V1_HSYC_11                                                                 0x980052F4
+#define VO_V1_HSYC_12                                                                 0x980052F8
+#define VO_V1_HSYC_13                                                                 0x980052FC
+#define VO_V1_HSYC_14                                                                 0x98005300
+#define VO_V1_HSYC_15                                                                 0x98005304
+#define VO_V1_HSYC_16                                                                 0x98005308
+#define VO_V1_HSYC_17                                                                 0x9800530C
+#define VO_V1_HSYC_18                                                                 0x98005310
+#define VO_V1_HSYC_19                                                                 0x98005314
+#define VO_V1_HSYC_20                                                                 0x98005318
+#define VO_V1_HSYC_21                                                                 0x9800531C
+#define VO_V1_HSYC_22                                                                 0x98005320
+#define VO_V1_HSYC_23                                                                 0x98005324
+#define VO_V1_HSYC_24                                                                 0x98005328
+#define VO_V1_HSYC_25                                                                 0x9800532C
+#define VO_V1_HSYC_26                                                                 0x98005330
+#define VO_V1_HSYC_27                                                                 0x98005334
+#define VO_V1_HSYC_28                                                                 0x98005338
+#define VO_V1_HSYC_29                                                                 0x9800533C
+#define VO_V1_HSYC_30                                                                 0x98005340
+#define VO_V1_HSYC_31                                                                 0x98005344
+#define VO_V1_HSYC_0_reg_addr                                                        "0xD80052C8"
+#define VO_V1_HSYC_1_reg_addr                                                        "0xD80052CC"
+#define VO_V1_HSYC_2_reg_addr                                                        "0xD80052D0"
+#define VO_V1_HSYC_3_reg_addr                                                        "0xD80052D4"
+#define VO_V1_HSYC_4_reg_addr                                                        "0xD80052D8"
+#define VO_V1_HSYC_5_reg_addr                                                        "0xD80052DC"
+#define VO_V1_HSYC_6_reg_addr                                                        "0xD80052E0"
+#define VO_V1_HSYC_7_reg_addr                                                        "0xD80052E4"
+#define VO_V1_HSYC_8_reg_addr                                                        "0xD80052E8"
+#define VO_V1_HSYC_9_reg_addr                                                        "0xD80052EC"
+#define VO_V1_HSYC_10_reg_addr                                                        "0xD80052F0"
+#define VO_V1_HSYC_11_reg_addr                                                        "0xD80052F4"
+#define VO_V1_HSYC_12_reg_addr                                                        "0xD80052F8"
+#define VO_V1_HSYC_13_reg_addr                                                        "0xD80052FC"
+#define VO_V1_HSYC_14_reg_addr                                                        "0xD8005300"
+#define VO_V1_HSYC_15_reg_addr                                                        "0xD8005304"
+#define VO_V1_HSYC_16_reg_addr                                                        "0xD8005308"
+#define VO_V1_HSYC_17_reg_addr                                                        "0xD800530C"
+#define VO_V1_HSYC_18_reg_addr                                                        "0xD8005310"
+#define VO_V1_HSYC_19_reg_addr                                                        "0xD8005314"
+#define VO_V1_HSYC_20_reg_addr                                                        "0xD8005318"
+#define VO_V1_HSYC_21_reg_addr                                                        "0xD800531C"
+#define VO_V1_HSYC_22_reg_addr                                                        "0xD8005320"
+#define VO_V1_HSYC_23_reg_addr                                                        "0xD8005324"
+#define VO_V1_HSYC_24_reg_addr                                                        "0xD8005328"
+#define VO_V1_HSYC_25_reg_addr                                                        "0xD800532C"
+#define VO_V1_HSYC_26_reg_addr                                                        "0xD8005330"
+#define VO_V1_HSYC_27_reg_addr                                                        "0xD8005334"
+#define VO_V1_HSYC_28_reg_addr                                                        "0xD8005338"
+#define VO_V1_HSYC_29_reg_addr                                                        "0xD800533C"
+#define VO_V1_HSYC_30_reg_addr                                                        "0xD8005340"
+#define VO_V1_HSYC_31_reg_addr                                                        "0xD8005344"
+#define VO_V1_HSYC_0_reg                                                             0xD80052C8
+#define VO_V1_HSYC_1_reg                                                             0xD80052CC
+#define VO_V1_HSYC_2_reg                                                             0xD80052D0
+#define VO_V1_HSYC_3_reg                                                             0xD80052D4
+#define VO_V1_HSYC_4_reg                                                             0xD80052D8
+#define VO_V1_HSYC_5_reg                                                             0xD80052DC
+#define VO_V1_HSYC_6_reg                                                             0xD80052E0
+#define VO_V1_HSYC_7_reg                                                             0xD80052E4
+#define VO_V1_HSYC_8_reg                                                             0xD80052E8
+#define VO_V1_HSYC_9_reg                                                             0xD80052EC
+#define VO_V1_HSYC_10_reg                                                             0xD80052F0
+#define VO_V1_HSYC_11_reg                                                             0xD80052F4
+#define VO_V1_HSYC_12_reg                                                             0xD80052F8
+#define VO_V1_HSYC_13_reg                                                             0xD80052FC
+#define VO_V1_HSYC_14_reg                                                             0xD8005300
+#define VO_V1_HSYC_15_reg                                                             0xD8005304
+#define VO_V1_HSYC_16_reg                                                             0xD8005308
+#define VO_V1_HSYC_17_reg                                                             0xD800530C
+#define VO_V1_HSYC_18_reg                                                             0xD8005310
+#define VO_V1_HSYC_19_reg                                                             0xD8005314
+#define VO_V1_HSYC_20_reg                                                             0xD8005318
+#define VO_V1_HSYC_21_reg                                                             0xD800531C
+#define VO_V1_HSYC_22_reg                                                             0xD8005320
+#define VO_V1_HSYC_23_reg                                                             0xD8005324
+#define VO_V1_HSYC_24_reg                                                             0xD8005328
+#define VO_V1_HSYC_25_reg                                                             0xD800532C
+#define VO_V1_HSYC_26_reg                                                             0xD8005330
+#define VO_V1_HSYC_27_reg                                                             0xD8005334
+#define VO_V1_HSYC_28_reg                                                             0xD8005338
+#define VO_V1_HSYC_29_reg                                                             0xD800533C
+#define VO_V1_HSYC_30_reg                                                             0xD8005340
+#define VO_V1_HSYC_31_reg                                                             0xD8005344
+#define set_VO_V1_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_0_reg)=data)
+#define set_VO_V1_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_1_reg)=data)
+#define set_VO_V1_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_2_reg)=data)
+#define set_VO_V1_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_3_reg)=data)
+#define set_VO_V1_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_4_reg)=data)
+#define set_VO_V1_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_5_reg)=data)
+#define set_VO_V1_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_6_reg)=data)
+#define set_VO_V1_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_7_reg)=data)
+#define set_VO_V1_HSYC_8_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_8_reg)=data)
+#define set_VO_V1_HSYC_9_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_9_reg)=data)
+#define set_VO_V1_HSYC_10_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_10_reg)=data)
+#define set_VO_V1_HSYC_11_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_11_reg)=data)
+#define set_VO_V1_HSYC_12_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_12_reg)=data)
+#define set_VO_V1_HSYC_13_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_13_reg)=data)
+#define set_VO_V1_HSYC_14_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_14_reg)=data)
+#define set_VO_V1_HSYC_15_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_15_reg)=data)
+#define set_VO_V1_HSYC_16_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_16_reg)=data)
+#define set_VO_V1_HSYC_17_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_17_reg)=data)
+#define set_VO_V1_HSYC_18_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_18_reg)=data)
+#define set_VO_V1_HSYC_19_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_19_reg)=data)
+#define set_VO_V1_HSYC_20_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_20_reg)=data)
+#define set_VO_V1_HSYC_21_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_21_reg)=data)
+#define set_VO_V1_HSYC_22_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_22_reg)=data)
+#define set_VO_V1_HSYC_23_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_23_reg)=data)
+#define set_VO_V1_HSYC_24_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_24_reg)=data)
+#define set_VO_V1_HSYC_25_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_25_reg)=data)
+#define set_VO_V1_HSYC_26_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_26_reg)=data)
+#define set_VO_V1_HSYC_27_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_27_reg)=data)
+#define set_VO_V1_HSYC_28_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_28_reg)=data)
+#define set_VO_V1_HSYC_29_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_29_reg)=data)
+#define set_VO_V1_HSYC_30_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_30_reg)=data)
+#define set_VO_V1_HSYC_31_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_31_reg)=data)
+#define get_VO_V1_HSYC_0_reg   (*((volatile unsigned int*) VO_V1_HSYC_0_reg))
+#define get_VO_V1_HSYC_1_reg   (*((volatile unsigned int*) VO_V1_HSYC_1_reg))
+#define get_VO_V1_HSYC_2_reg   (*((volatile unsigned int*) VO_V1_HSYC_2_reg))
+#define get_VO_V1_HSYC_3_reg   (*((volatile unsigned int*) VO_V1_HSYC_3_reg))
+#define get_VO_V1_HSYC_4_reg   (*((volatile unsigned int*) VO_V1_HSYC_4_reg))
+#define get_VO_V1_HSYC_5_reg   (*((volatile unsigned int*) VO_V1_HSYC_5_reg))
+#define get_VO_V1_HSYC_6_reg   (*((volatile unsigned int*) VO_V1_HSYC_6_reg))
+#define get_VO_V1_HSYC_7_reg   (*((volatile unsigned int*) VO_V1_HSYC_7_reg))
+#define get_VO_V1_HSYC_8_reg   (*((volatile unsigned int*) VO_V1_HSYC_8_reg))
+#define get_VO_V1_HSYC_9_reg   (*((volatile unsigned int*) VO_V1_HSYC_9_reg))
+#define get_VO_V1_HSYC_10_reg   (*((volatile unsigned int*) VO_V1_HSYC_10_reg))
+#define get_VO_V1_HSYC_11_reg   (*((volatile unsigned int*) VO_V1_HSYC_11_reg))
+#define get_VO_V1_HSYC_12_reg   (*((volatile unsigned int*) VO_V1_HSYC_12_reg))
+#define get_VO_V1_HSYC_13_reg   (*((volatile unsigned int*) VO_V1_HSYC_13_reg))
+#define get_VO_V1_HSYC_14_reg   (*((volatile unsigned int*) VO_V1_HSYC_14_reg))
+#define get_VO_V1_HSYC_15_reg   (*((volatile unsigned int*) VO_V1_HSYC_15_reg))
+#define get_VO_V1_HSYC_16_reg   (*((volatile unsigned int*) VO_V1_HSYC_16_reg))
+#define get_VO_V1_HSYC_17_reg   (*((volatile unsigned int*) VO_V1_HSYC_17_reg))
+#define get_VO_V1_HSYC_18_reg   (*((volatile unsigned int*) VO_V1_HSYC_18_reg))
+#define get_VO_V1_HSYC_19_reg   (*((volatile unsigned int*) VO_V1_HSYC_19_reg))
+#define get_VO_V1_HSYC_20_reg   (*((volatile unsigned int*) VO_V1_HSYC_20_reg))
+#define get_VO_V1_HSYC_21_reg   (*((volatile unsigned int*) VO_V1_HSYC_21_reg))
+#define get_VO_V1_HSYC_22_reg   (*((volatile unsigned int*) VO_V1_HSYC_22_reg))
+#define get_VO_V1_HSYC_23_reg   (*((volatile unsigned int*) VO_V1_HSYC_23_reg))
+#define get_VO_V1_HSYC_24_reg   (*((volatile unsigned int*) VO_V1_HSYC_24_reg))
+#define get_VO_V1_HSYC_25_reg   (*((volatile unsigned int*) VO_V1_HSYC_25_reg))
+#define get_VO_V1_HSYC_26_reg   (*((volatile unsigned int*) VO_V1_HSYC_26_reg))
+#define get_VO_V1_HSYC_27_reg   (*((volatile unsigned int*) VO_V1_HSYC_27_reg))
+#define get_VO_V1_HSYC_28_reg   (*((volatile unsigned int*) VO_V1_HSYC_28_reg))
+#define get_VO_V1_HSYC_29_reg   (*((volatile unsigned int*) VO_V1_HSYC_29_reg))
+#define get_VO_V1_HSYC_30_reg   (*((volatile unsigned int*) VO_V1_HSYC_30_reg))
+#define get_VO_V1_HSYC_31_reg   (*((volatile unsigned int*) VO_V1_HSYC_31_reg))
+#define VO_V1_HSYC_0_inst_adr                                                        "0x00B2"
+#define VO_V1_HSYC_1_inst_adr                                                        "0x00B3"
+#define VO_V1_HSYC_2_inst_adr                                                        "0x00B4"
+#define VO_V1_HSYC_3_inst_adr                                                        "0x00B5"
+#define VO_V1_HSYC_4_inst_adr                                                        "0x00B6"
+#define VO_V1_HSYC_5_inst_adr                                                        "0x00B7"
+#define VO_V1_HSYC_6_inst_adr                                                        "0x00B8"
+#define VO_V1_HSYC_7_inst_adr                                                        "0x00B9"
+#define VO_V1_HSYC_8_inst_adr                                                        "0x00BA"
+#define VO_V1_HSYC_9_inst_adr                                                        "0x00BB"
+#define VO_V1_HSYC_10_inst_adr                                                        "0x00BC"
+#define VO_V1_HSYC_11_inst_adr                                                        "0x00BD"
+#define VO_V1_HSYC_12_inst_adr                                                        "0x00BE"
+#define VO_V1_HSYC_13_inst_adr                                                        "0x00BF"
+#define VO_V1_HSYC_14_inst_adr                                                        "0x00C0"
+#define VO_V1_HSYC_15_inst_adr                                                        "0x00C1"
+#define VO_V1_HSYC_16_inst_adr                                                        "0x00C2"
+#define VO_V1_HSYC_17_inst_adr                                                        "0x00C3"
+#define VO_V1_HSYC_18_inst_adr                                                        "0x00C4"
+#define VO_V1_HSYC_19_inst_adr                                                        "0x00C5"
+#define VO_V1_HSYC_20_inst_adr                                                        "0x00C6"
+#define VO_V1_HSYC_21_inst_adr                                                        "0x00C7"
+#define VO_V1_HSYC_22_inst_adr                                                        "0x00C8"
+#define VO_V1_HSYC_23_inst_adr                                                        "0x00C9"
+#define VO_V1_HSYC_24_inst_adr                                                        "0x00CA"
+#define VO_V1_HSYC_25_inst_adr                                                        "0x00CB"
+#define VO_V1_HSYC_26_inst_adr                                                        "0x00CC"
+#define VO_V1_HSYC_27_inst_adr                                                        "0x00CD"
+#define VO_V1_HSYC_28_inst_adr                                                        "0x00CE"
+#define VO_V1_HSYC_29_inst_adr                                                        "0x00CF"
+#define VO_V1_HSYC_30_inst_adr                                                        "0x00D0"
+#define VO_V1_HSYC_31_inst_adr                                                        "0x00D1"
+#define VO_V1_HSYC_0_inst                                                            0x00B2
+#define VO_V1_HSYC_1_inst                                                            0x00B3
+#define VO_V1_HSYC_2_inst                                                            0x00B4
+#define VO_V1_HSYC_3_inst                                                            0x00B5
+#define VO_V1_HSYC_4_inst                                                            0x00B6
+#define VO_V1_HSYC_5_inst                                                            0x00B7
+#define VO_V1_HSYC_6_inst                                                            0x00B8
+#define VO_V1_HSYC_7_inst                                                            0x00B9
+#define VO_V1_HSYC_8_inst                                                            0x00BA
+#define VO_V1_HSYC_9_inst                                                            0x00BB
+#define VO_V1_HSYC_10_inst                                                            0x00BC
+#define VO_V1_HSYC_11_inst                                                            0x00BD
+#define VO_V1_HSYC_12_inst                                                            0x00BE
+#define VO_V1_HSYC_13_inst                                                            0x00BF
+#define VO_V1_HSYC_14_inst                                                            0x00C0
+#define VO_V1_HSYC_15_inst                                                            0x00C1
+#define VO_V1_HSYC_16_inst                                                            0x00C2
+#define VO_V1_HSYC_17_inst                                                            0x00C3
+#define VO_V1_HSYC_18_inst                                                            0x00C4
+#define VO_V1_HSYC_19_inst                                                            0x00C5
+#define VO_V1_HSYC_20_inst                                                            0x00C6
+#define VO_V1_HSYC_21_inst                                                            0x00C7
+#define VO_V1_HSYC_22_inst                                                            0x00C8
+#define VO_V1_HSYC_23_inst                                                            0x00C9
+#define VO_V1_HSYC_24_inst                                                            0x00CA
+#define VO_V1_HSYC_25_inst                                                            0x00CB
+#define VO_V1_HSYC_26_inst                                                            0x00CC
+#define VO_V1_HSYC_27_inst                                                            0x00CD
+#define VO_V1_HSYC_28_inst                                                            0x00CE
+#define VO_V1_HSYC_29_inst                                                            0x00CF
+#define VO_V1_HSYC_30_inst                                                            0x00D0
+#define VO_V1_HSYC_31_inst                                                            0x00D1
+#define VO_V1_HSYC_c1_shift                                                          (16)
+#define VO_V1_HSYC_c1_mask                                                           (0x3FFF0000)
+#define VO_V1_HSYC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_HSYC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_HSYC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_HSYC_c0_shift                                                          (0)
+#define VO_V1_HSYC_c0_mask                                                           (0x00003FFF)
+#define VO_V1_HSYC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_HSYC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_HSYC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_HSCC_0                                                                 0x98005348
+#define VO_V1_HSCC_1                                                                 0x9800534C
+#define VO_V1_HSCC_2                                                                 0x98005350
+#define VO_V1_HSCC_3                                                                 0x98005354
+#define VO_V1_HSCC_4                                                                 0x98005358
+#define VO_V1_HSCC_5                                                                 0x9800535C
+#define VO_V1_HSCC_6                                                                 0x98005360
+#define VO_V1_HSCC_7                                                                 0x98005364
+#define VO_V1_HSCC_8                                                                 0x98005368
+#define VO_V1_HSCC_9                                                                 0x9800536C
+#define VO_V1_HSCC_10                                                                 0x98005370
+#define VO_V1_HSCC_11                                                                 0x98005374
+#define VO_V1_HSCC_12                                                                 0x98005378
+#define VO_V1_HSCC_13                                                                 0x9800537C
+#define VO_V1_HSCC_14                                                                 0x98005380
+#define VO_V1_HSCC_15                                                                 0x98005384
+#define VO_V1_HSCC_0_reg_addr                                                        "0xD8005348"
+#define VO_V1_HSCC_1_reg_addr                                                        "0xD800534C"
+#define VO_V1_HSCC_2_reg_addr                                                        "0xD8005350"
+#define VO_V1_HSCC_3_reg_addr                                                        "0xD8005354"
+#define VO_V1_HSCC_4_reg_addr                                                        "0xD8005358"
+#define VO_V1_HSCC_5_reg_addr                                                        "0xD800535C"
+#define VO_V1_HSCC_6_reg_addr                                                        "0xD8005360"
+#define VO_V1_HSCC_7_reg_addr                                                        "0xD8005364"
+#define VO_V1_HSCC_8_reg_addr                                                        "0xD8005368"
+#define VO_V1_HSCC_9_reg_addr                                                        "0xD800536C"
+#define VO_V1_HSCC_10_reg_addr                                                        "0xD8005370"
+#define VO_V1_HSCC_11_reg_addr                                                        "0xD8005374"
+#define VO_V1_HSCC_12_reg_addr                                                        "0xD8005378"
+#define VO_V1_HSCC_13_reg_addr                                                        "0xD800537C"
+#define VO_V1_HSCC_14_reg_addr                                                        "0xD8005380"
+#define VO_V1_HSCC_15_reg_addr                                                        "0xD8005384"
+#define VO_V1_HSCC_0_reg                                                             0xD8005348
+#define VO_V1_HSCC_1_reg                                                             0xD800534C
+#define VO_V1_HSCC_2_reg                                                             0xD8005350
+#define VO_V1_HSCC_3_reg                                                             0xD8005354
+#define VO_V1_HSCC_4_reg                                                             0xD8005358
+#define VO_V1_HSCC_5_reg                                                             0xD800535C
+#define VO_V1_HSCC_6_reg                                                             0xD8005360
+#define VO_V1_HSCC_7_reg                                                             0xD8005364
+#define VO_V1_HSCC_8_reg                                                             0xD8005368
+#define VO_V1_HSCC_9_reg                                                             0xD800536C
+#define VO_V1_HSCC_10_reg                                                             0xD8005370
+#define VO_V1_HSCC_11_reg                                                             0xD8005374
+#define VO_V1_HSCC_12_reg                                                             0xD8005378
+#define VO_V1_HSCC_13_reg                                                             0xD800537C
+#define VO_V1_HSCC_14_reg                                                             0xD8005380
+#define VO_V1_HSCC_15_reg                                                             0xD8005384
+#define set_VO_V1_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_0_reg)=data)
+#define set_VO_V1_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_1_reg)=data)
+#define set_VO_V1_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_2_reg)=data)
+#define set_VO_V1_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_3_reg)=data)
+#define set_VO_V1_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_4_reg)=data)
+#define set_VO_V1_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_5_reg)=data)
+#define set_VO_V1_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_6_reg)=data)
+#define set_VO_V1_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_7_reg)=data)
+#define set_VO_V1_HSCC_8_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_8_reg)=data)
+#define set_VO_V1_HSCC_9_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_9_reg)=data)
+#define set_VO_V1_HSCC_10_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_10_reg)=data)
+#define set_VO_V1_HSCC_11_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_11_reg)=data)
+#define set_VO_V1_HSCC_12_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_12_reg)=data)
+#define set_VO_V1_HSCC_13_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_13_reg)=data)
+#define set_VO_V1_HSCC_14_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_14_reg)=data)
+#define set_VO_V1_HSCC_15_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_15_reg)=data)
+#define get_VO_V1_HSCC_0_reg   (*((volatile unsigned int*) VO_V1_HSCC_0_reg))
+#define get_VO_V1_HSCC_1_reg   (*((volatile unsigned int*) VO_V1_HSCC_1_reg))
+#define get_VO_V1_HSCC_2_reg   (*((volatile unsigned int*) VO_V1_HSCC_2_reg))
+#define get_VO_V1_HSCC_3_reg   (*((volatile unsigned int*) VO_V1_HSCC_3_reg))
+#define get_VO_V1_HSCC_4_reg   (*((volatile unsigned int*) VO_V1_HSCC_4_reg))
+#define get_VO_V1_HSCC_5_reg   (*((volatile unsigned int*) VO_V1_HSCC_5_reg))
+#define get_VO_V1_HSCC_6_reg   (*((volatile unsigned int*) VO_V1_HSCC_6_reg))
+#define get_VO_V1_HSCC_7_reg   (*((volatile unsigned int*) VO_V1_HSCC_7_reg))
+#define get_VO_V1_HSCC_8_reg   (*((volatile unsigned int*) VO_V1_HSCC_8_reg))
+#define get_VO_V1_HSCC_9_reg   (*((volatile unsigned int*) VO_V1_HSCC_9_reg))
+#define get_VO_V1_HSCC_10_reg   (*((volatile unsigned int*) VO_V1_HSCC_10_reg))
+#define get_VO_V1_HSCC_11_reg   (*((volatile unsigned int*) VO_V1_HSCC_11_reg))
+#define get_VO_V1_HSCC_12_reg   (*((volatile unsigned int*) VO_V1_HSCC_12_reg))
+#define get_VO_V1_HSCC_13_reg   (*((volatile unsigned int*) VO_V1_HSCC_13_reg))
+#define get_VO_V1_HSCC_14_reg   (*((volatile unsigned int*) VO_V1_HSCC_14_reg))
+#define get_VO_V1_HSCC_15_reg   (*((volatile unsigned int*) VO_V1_HSCC_15_reg))
+#define VO_V1_HSCC_0_inst_adr                                                        "0x00D2"
+#define VO_V1_HSCC_1_inst_adr                                                        "0x00D3"
+#define VO_V1_HSCC_2_inst_adr                                                        "0x00D4"
+#define VO_V1_HSCC_3_inst_adr                                                        "0x00D5"
+#define VO_V1_HSCC_4_inst_adr                                                        "0x00D6"
+#define VO_V1_HSCC_5_inst_adr                                                        "0x00D7"
+#define VO_V1_HSCC_6_inst_adr                                                        "0x00D8"
+#define VO_V1_HSCC_7_inst_adr                                                        "0x00D9"
+#define VO_V1_HSCC_8_inst_adr                                                        "0x00DA"
+#define VO_V1_HSCC_9_inst_adr                                                        "0x00DB"
+#define VO_V1_HSCC_10_inst_adr                                                        "0x00DC"
+#define VO_V1_HSCC_11_inst_adr                                                        "0x00DD"
+#define VO_V1_HSCC_12_inst_adr                                                        "0x00DE"
+#define VO_V1_HSCC_13_inst_adr                                                        "0x00DF"
+#define VO_V1_HSCC_14_inst_adr                                                        "0x00E0"
+#define VO_V1_HSCC_15_inst_adr                                                        "0x00E1"
+#define VO_V1_HSCC_0_inst                                                            0x00D2
+#define VO_V1_HSCC_1_inst                                                            0x00D3
+#define VO_V1_HSCC_2_inst                                                            0x00D4
+#define VO_V1_HSCC_3_inst                                                            0x00D5
+#define VO_V1_HSCC_4_inst                                                            0x00D6
+#define VO_V1_HSCC_5_inst                                                            0x00D7
+#define VO_V1_HSCC_6_inst                                                            0x00D8
+#define VO_V1_HSCC_7_inst                                                            0x00D9
+#define VO_V1_HSCC_8_inst                                                            0x00DA
+#define VO_V1_HSCC_9_inst                                                            0x00DB
+#define VO_V1_HSCC_10_inst                                                            0x00DC
+#define VO_V1_HSCC_11_inst                                                            0x00DD
+#define VO_V1_HSCC_12_inst                                                            0x00DE
+#define VO_V1_HSCC_13_inst                                                            0x00DF
+#define VO_V1_HSCC_14_inst                                                            0x00E0
+#define VO_V1_HSCC_15_inst                                                            0x00E1
+#define VO_V1_HSCC_c1_shift                                                          (16)
+#define VO_V1_HSCC_c1_mask                                                           (0x3FFF0000)
+#define VO_V1_HSCC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_HSCC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_HSCC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_HSCC_c0_shift                                                          (0)
+#define VO_V1_HSCC_c0_mask                                                           (0x00003FFF)
+#define VO_V1_HSCC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_HSCC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_HSCC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_SHARP                                                                  0x98005388
+#define VO_V1_SHARP_reg_addr                                                         "0xD8005388"
+#define VO_V1_SHARP_reg                                                              0xD8005388
+#define set_VO_V1_SHARP_reg(data)   (*((volatile unsigned int*) VO_V1_SHARP_reg)=data)
+#define get_VO_V1_SHARP_reg   (*((volatile unsigned int*) VO_V1_SHARP_reg))
+#define VO_V1_SHARP_inst_adr                                                         "0x00E2"
+#define VO_V1_SHARP_inst                                                             0x00E2
+#define VO_V1_SHARP_thd_shift                                                        (16)
+#define VO_V1_SHARP_thd_mask                                                         (0x03FF0000)
+#define VO_V1_SHARP_thd(data)                                                        (0x03FF0000&((data)<<16))
+#define VO_V1_SHARP_thd_src(data)                                                    ((0x03FF0000&(data))>>16)
+#define VO_V1_SHARP_get_thd(data)                                                    ((0x03FF0000&(data))>>16)
+#define VO_V1_SHARP_gain_shift                                                       (0)
+#define VO_V1_SHARP_gain_mask                                                        (0x000000FF)
+#define VO_V1_SHARP_gain(data)                                                       (0x000000FF&((data)<<0))
+#define VO_V1_SHARP_gain_src(data)                                                   ((0x000000FF&(data))>>0)
+#define VO_V1_SHARP_get_gain(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_SHARP_CLIP                                                             0x9800538C
+#define VO_V1_SHARP_CLIP_reg_addr                                                    "0xD800538C"
+#define VO_V1_SHARP_CLIP_reg                                                         0xD800538C
+#define set_VO_V1_SHARP_CLIP_reg(data)   (*((volatile unsigned int*) VO_V1_SHARP_CLIP_reg)=data)
+#define get_VO_V1_SHARP_CLIP_reg   (*((volatile unsigned int*) VO_V1_SHARP_CLIP_reg))
+#define VO_V1_SHARP_CLIP_inst_adr                                                    "0x00E3"
+#define VO_V1_SHARP_CLIP_inst                                                        0x00E3
+#define VO_V1_SHARP_CLIP_range_shift                                                 (16)
+#define VO_V1_SHARP_CLIP_range_mask                                                  (0x001F0000)
+#define VO_V1_SHARP_CLIP_range(data)                                                 (0x001F0000&((data)<<16))
+#define VO_V1_SHARP_CLIP_range_src(data)                                             ((0x001F0000&(data))>>16)
+#define VO_V1_SHARP_CLIP_get_range(data)                                             ((0x001F0000&(data))>>16)
+#define VO_V1_SHARP_CLIP_en_shift                                                    (0)
+#define VO_V1_SHARP_CLIP_en_mask                                                     (0x00000001)
+#define VO_V1_SHARP_CLIP_en(data)                                                    (0x00000001&((data)<<0))
+#define VO_V1_SHARP_CLIP_en_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_V1_SHARP_CLIP_get_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_V1_SHARP_LPF                                                              0x98005390
+#define VO_V1_SHARP_LPF_reg_addr                                                     "0xD8005390"
+#define VO_V1_SHARP_LPF_reg                                                          0xD8005390
+#define set_VO_V1_SHARP_LPF_reg(data)   (*((volatile unsigned int*) VO_V1_SHARP_LPF_reg)=data)
+#define get_VO_V1_SHARP_LPF_reg   (*((volatile unsigned int*) VO_V1_SHARP_LPF_reg))
+#define VO_V1_SHARP_LPF_inst_adr                                                     "0x00E4"
+#define VO_V1_SHARP_LPF_inst                                                         0x00E4
+#define VO_V1_SHARP_LPF_c4_shift                                                     (16)
+#define VO_V1_SHARP_LPF_c4_mask                                                      (0x00070000)
+#define VO_V1_SHARP_LPF_c4(data)                                                     (0x00070000&((data)<<16))
+#define VO_V1_SHARP_LPF_c4_src(data)                                                 ((0x00070000&(data))>>16)
+#define VO_V1_SHARP_LPF_get_c4(data)                                                 ((0x00070000&(data))>>16)
+#define VO_V1_SHARP_LPF_c3_shift                                                     (12)
+#define VO_V1_SHARP_LPF_c3_mask                                                      (0x00007000)
+#define VO_V1_SHARP_LPF_c3(data)                                                     (0x00007000&((data)<<12))
+#define VO_V1_SHARP_LPF_c3_src(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_SHARP_LPF_get_c3(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_SHARP_LPF_c2_shift                                                     (8)
+#define VO_V1_SHARP_LPF_c2_mask                                                      (0x00000700)
+#define VO_V1_SHARP_LPF_c2(data)                                                     (0x00000700&((data)<<8))
+#define VO_V1_SHARP_LPF_c2_src(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_SHARP_LPF_get_c2(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_SHARP_LPF_c1_shift                                                     (4)
+#define VO_V1_SHARP_LPF_c1_mask                                                      (0x00000070)
+#define VO_V1_SHARP_LPF_c1(data)                                                     (0x00000070&((data)<<4))
+#define VO_V1_SHARP_LPF_c1_src(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V1_SHARP_LPF_get_c1(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V1_SHARP_LPF_c0_shift                                                     (0)
+#define VO_V1_SHARP_LPF_c0_mask                                                      (0x00000007)
+#define VO_V1_SHARP_LPF_c0(data)                                                     (0x00000007&((data)<<0))
+#define VO_V1_SHARP_LPF_c0_src(data)                                                 ((0x00000007&(data))>>0)
+#define VO_V1_SHARP_LPF_get_c0(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define VO_V1_SR_DI                                                                  0x98005394
+#define VO_V1_SR_DI_reg_addr                                                         "0xD8005394"
+#define VO_V1_SR_DI_reg                                                              0xD8005394
+#define set_VO_V1_SR_DI_reg(data)   (*((volatile unsigned int*) VO_V1_SR_DI_reg)=data)
+#define get_VO_V1_SR_DI_reg   (*((volatile unsigned int*) VO_V1_SR_DI_reg))
+#define VO_V1_SR_DI_inst_adr                                                         "0x00E5"
+#define VO_V1_SR_DI_inst                                                             0x00E5
+#define VO_V1_SR_DI_dbg_sel2_shift                                                   (26)
+#define VO_V1_SR_DI_dbg_sel2_mask                                                    (0x04000000)
+#define VO_V1_SR_DI_dbg_sel2(data)                                                   (0x04000000&((data)<<26))
+#define VO_V1_SR_DI_dbg_sel2_src(data)                                               ((0x04000000&(data))>>26)
+#define VO_V1_SR_DI_get_dbg_sel2(data)                                               ((0x04000000&(data))>>26)
+#define VO_V1_SR_DI_dbg_sel1_shift                                                   (25)
+#define VO_V1_SR_DI_dbg_sel1_mask                                                    (0x02000000)
+#define VO_V1_SR_DI_dbg_sel1(data)                                                   (0x02000000&((data)<<25))
+#define VO_V1_SR_DI_dbg_sel1_src(data)                                               ((0x02000000&(data))>>25)
+#define VO_V1_SR_DI_get_dbg_sel1(data)                                               ((0x02000000&(data))>>25)
+#define VO_V1_SR_DI_dbg_sel0_shift                                                   (24)
+#define VO_V1_SR_DI_dbg_sel0_mask                                                    (0x01000000)
+#define VO_V1_SR_DI_dbg_sel0(data)                                                   (0x01000000&((data)<<24))
+#define VO_V1_SR_DI_dbg_sel0_src(data)                                               ((0x01000000&(data))>>24)
+#define VO_V1_SR_DI_get_dbg_sel0(data)                                               ((0x01000000&(data))>>24)
+#define VO_V1_SR_DI_detatil_area_shift                                               (9)
+#define VO_V1_SR_DI_detatil_area_mask                                                (0x00000200)
+#define VO_V1_SR_DI_detatil_area(data)                                               (0x00000200&((data)<<9))
+#define VO_V1_SR_DI_detatil_area_src(data)                                           ((0x00000200&(data))>>9)
+#define VO_V1_SR_DI_get_detatil_area(data)                                           ((0x00000200&(data))>>9)
+#define VO_V1_SR_DI_dyn_min_thd_en_shift                                             (8)
+#define VO_V1_SR_DI_dyn_min_thd_en_mask                                              (0x00000100)
+#define VO_V1_SR_DI_dyn_min_thd_en(data)                                             (0x00000100&((data)<<8))
+#define VO_V1_SR_DI_dyn_min_thd_en_src(data)                                         ((0x00000100&(data))>>8)
+#define VO_V1_SR_DI_get_dyn_min_thd_en(data)                                         ((0x00000100&(data))>>8)
+#define VO_V1_SR_DI_double_chk_en_shift                                              (7)
+#define VO_V1_SR_DI_double_chk_en_mask                                               (0x00000080)
+#define VO_V1_SR_DI_double_chk_en(data)                                              (0x00000080&((data)<<7))
+#define VO_V1_SR_DI_double_chk_en_src(data)                                          ((0x00000080&(data))>>7)
+#define VO_V1_SR_DI_get_double_chk_en(data)                                          ((0x00000080&(data))>>7)
+#define VO_V1_SR_DI_lpf_intrp_data_shift                                             (6)
+#define VO_V1_SR_DI_lpf_intrp_data_mask                                              (0x00000040)
+#define VO_V1_SR_DI_lpf_intrp_data(data)                                             (0x00000040&((data)<<6))
+#define VO_V1_SR_DI_lpf_intrp_data_src(data)                                         ((0x00000040&(data))>>6)
+#define VO_V1_SR_DI_get_lpf_intrp_data(data)                                         ((0x00000040&(data))>>6)
+#define VO_V1_SR_DI_slope_post_en_shift                                              (5)
+#define VO_V1_SR_DI_slope_post_en_mask                                               (0x00000020)
+#define VO_V1_SR_DI_slope_post_en(data)                                              (0x00000020&((data)<<5))
+#define VO_V1_SR_DI_slope_post_en_src(data)                                          ((0x00000020&(data))>>5)
+#define VO_V1_SR_DI_get_slope_post_en(data)                                          ((0x00000020&(data))>>5)
+#define VO_V1_SR_DI_diff_lpf_en_shift                                                (4)
+#define VO_V1_SR_DI_diff_lpf_en_mask                                                 (0x00000010)
+#define VO_V1_SR_DI_diff_lpf_en(data)                                                (0x00000010&((data)<<4))
+#define VO_V1_SR_DI_diff_lpf_en_src(data)                                            ((0x00000010&(data))>>4)
+#define VO_V1_SR_DI_get_diff_lpf_en(data)                                            ((0x00000010&(data))>>4)
+#define VO_V1_SR_DI_diff_y_only_shift                                                (3)
+#define VO_V1_SR_DI_diff_y_only_mask                                                 (0x00000008)
+#define VO_V1_SR_DI_diff_y_only(data)                                                (0x00000008&((data)<<3))
+#define VO_V1_SR_DI_diff_y_only_src(data)                                            ((0x00000008&(data))>>3)
+#define VO_V1_SR_DI_get_diff_y_only(data)                                            ((0x00000008&(data))>>3)
+#define VO_V1_SR_DI_cu_shift                                                         (2)
+#define VO_V1_SR_DI_cu_mask                                                          (0x00000004)
+#define VO_V1_SR_DI_cu(data)                                                         (0x00000004&((data)<<2))
+#define VO_V1_SR_DI_cu_src(data)                                                     ((0x00000004&(data))>>2)
+#define VO_V1_SR_DI_get_cu(data)                                                     ((0x00000004&(data))>>2)
+#define VO_V1_SR_DI_en_shift                                                         (1)
+#define VO_V1_SR_DI_en_mask                                                          (0x00000002)
+#define VO_V1_SR_DI_en(data)                                                         (0x00000002&((data)<<1))
+#define VO_V1_SR_DI_en_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_V1_SR_DI_get_en(data)                                                     ((0x00000002&(data))>>1)
+#define VO_V1_SR_DI_write_data_shift                                                 (0)
+#define VO_V1_SR_DI_write_data_mask                                                  (0x00000001)
+#define VO_V1_SR_DI_write_data(data)                                                 (0x00000001&((data)<<0))
+#define VO_V1_SR_DI_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define VO_V1_SR_DI_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define VO_V1_SR_DI_LPF3X3                                                           0x98005398
+#define VO_V1_SR_DI_LPF3X3_reg_addr                                                  "0xD8005398"
+#define VO_V1_SR_DI_LPF3X3_reg                                                       0xD8005398
+#define set_VO_V1_SR_DI_LPF3X3_reg(data)   (*((volatile unsigned int*) VO_V1_SR_DI_LPF3X3_reg)=data)
+#define get_VO_V1_SR_DI_LPF3X3_reg   (*((volatile unsigned int*) VO_V1_SR_DI_LPF3X3_reg))
+#define VO_V1_SR_DI_LPF3X3_inst_adr                                                  "0x00E6"
+#define VO_V1_SR_DI_LPF3X3_inst                                                      0x00E6
+#define VO_V1_SR_DI_LPF3X3_c22_shift                                                 (24)
+#define VO_V1_SR_DI_LPF3X3_c22_mask                                                  (0x07000000)
+#define VO_V1_SR_DI_LPF3X3_c22(data)                                                 (0x07000000&((data)<<24))
+#define VO_V1_SR_DI_LPF3X3_c22_src(data)                                             ((0x07000000&(data))>>24)
+#define VO_V1_SR_DI_LPF3X3_get_c22(data)                                             ((0x07000000&(data))>>24)
+#define VO_V1_SR_DI_LPF3X3_c21_shift                                                 (21)
+#define VO_V1_SR_DI_LPF3X3_c21_mask                                                  (0x00E00000)
+#define VO_V1_SR_DI_LPF3X3_c21(data)                                                 (0x00E00000&((data)<<21))
+#define VO_V1_SR_DI_LPF3X3_c21_src(data)                                             ((0x00E00000&(data))>>21)
+#define VO_V1_SR_DI_LPF3X3_get_c21(data)                                             ((0x00E00000&(data))>>21)
+#define VO_V1_SR_DI_LPF3X3_c20_shift                                                 (18)
+#define VO_V1_SR_DI_LPF3X3_c20_mask                                                  (0x001C0000)
+#define VO_V1_SR_DI_LPF3X3_c20(data)                                                 (0x001C0000&((data)<<18))
+#define VO_V1_SR_DI_LPF3X3_c20_src(data)                                             ((0x001C0000&(data))>>18)
+#define VO_V1_SR_DI_LPF3X3_get_c20(data)                                             ((0x001C0000&(data))>>18)
+#define VO_V1_SR_DI_LPF3X3_c12_shift                                                 (15)
+#define VO_V1_SR_DI_LPF3X3_c12_mask                                                  (0x00038000)
+#define VO_V1_SR_DI_LPF3X3_c12(data)                                                 (0x00038000&((data)<<15))
+#define VO_V1_SR_DI_LPF3X3_c12_src(data)                                             ((0x00038000&(data))>>15)
+#define VO_V1_SR_DI_LPF3X3_get_c12(data)                                             ((0x00038000&(data))>>15)
+#define VO_V1_SR_DI_LPF3X3_c11_shift                                                 (12)
+#define VO_V1_SR_DI_LPF3X3_c11_mask                                                  (0x00007000)
+#define VO_V1_SR_DI_LPF3X3_c11(data)                                                 (0x00007000&((data)<<12))
+#define VO_V1_SR_DI_LPF3X3_c11_src(data)                                             ((0x00007000&(data))>>12)
+#define VO_V1_SR_DI_LPF3X3_get_c11(data)                                             ((0x00007000&(data))>>12)
+#define VO_V1_SR_DI_LPF3X3_c10_shift                                                 (9)
+#define VO_V1_SR_DI_LPF3X3_c10_mask                                                  (0x00000E00)
+#define VO_V1_SR_DI_LPF3X3_c10(data)                                                 (0x00000E00&((data)<<9))
+#define VO_V1_SR_DI_LPF3X3_c10_src(data)                                             ((0x00000E00&(data))>>9)
+#define VO_V1_SR_DI_LPF3X3_get_c10(data)                                             ((0x00000E00&(data))>>9)
+#define VO_V1_SR_DI_LPF3X3_c02_shift                                                 (6)
+#define VO_V1_SR_DI_LPF3X3_c02_mask                                                  (0x000001C0)
+#define VO_V1_SR_DI_LPF3X3_c02(data)                                                 (0x000001C0&((data)<<6))
+#define VO_V1_SR_DI_LPF3X3_c02_src(data)                                             ((0x000001C0&(data))>>6)
+#define VO_V1_SR_DI_LPF3X3_get_c02(data)                                             ((0x000001C0&(data))>>6)
+#define VO_V1_SR_DI_LPF3X3_c01_shift                                                 (3)
+#define VO_V1_SR_DI_LPF3X3_c01_mask                                                  (0x00000038)
+#define VO_V1_SR_DI_LPF3X3_c01(data)                                                 (0x00000038&((data)<<3))
+#define VO_V1_SR_DI_LPF3X3_c01_src(data)                                             ((0x00000038&(data))>>3)
+#define VO_V1_SR_DI_LPF3X3_get_c01(data)                                             ((0x00000038&(data))>>3)
+#define VO_V1_SR_DI_LPF3X3_c00_shift                                                 (0)
+#define VO_V1_SR_DI_LPF3X3_c00_mask                                                  (0x00000007)
+#define VO_V1_SR_DI_LPF3X3_c00(data)                                                 (0x00000007&((data)<<0))
+#define VO_V1_SR_DI_LPF3X3_c00_src(data)                                             ((0x00000007&(data))>>0)
+#define VO_V1_SR_DI_LPF3X3_get_c00(data)                                             ((0x00000007&(data))>>0)
+
+
+#define VO_V1_SR_DI_MIN_THD                                                          0x9800539C
+#define VO_V1_SR_DI_MIN_THD_reg_addr                                                 "0xD800539C"
+#define VO_V1_SR_DI_MIN_THD_reg                                                      0xD800539C
+#define set_VO_V1_SR_DI_MIN_THD_reg(data)   (*((volatile unsigned int*) VO_V1_SR_DI_MIN_THD_reg)=data)
+#define get_VO_V1_SR_DI_MIN_THD_reg   (*((volatile unsigned int*) VO_V1_SR_DI_MIN_THD_reg))
+#define VO_V1_SR_DI_MIN_THD_inst_adr                                                 "0x00E7"
+#define VO_V1_SR_DI_MIN_THD_inst                                                     0x00E7
+#define VO_V1_SR_DI_MIN_THD_final_shift                                              (24)
+#define VO_V1_SR_DI_MIN_THD_final_mask                                               (0x0F000000)
+#define VO_V1_SR_DI_MIN_THD_final(data)                                              (0x0F000000&((data)<<24))
+#define VO_V1_SR_DI_MIN_THD_final_src(data)                                          ((0x0F000000&(data))>>24)
+#define VO_V1_SR_DI_MIN_THD_get_final(data)                                          ((0x0F000000&(data))>>24)
+#define VO_V1_SR_DI_MIN_THD_t05_shift                                                (16)
+#define VO_V1_SR_DI_MIN_THD_t05_mask                                                 (0x000F0000)
+#define VO_V1_SR_DI_MIN_THD_t05(data)                                                (0x000F0000&((data)<<16))
+#define VO_V1_SR_DI_MIN_THD_t05_src(data)                                            ((0x000F0000&(data))>>16)
+#define VO_V1_SR_DI_MIN_THD_get_t05(data)                                            ((0x000F0000&(data))>>16)
+#define VO_V1_SR_DI_MIN_THD_h_shift                                                  (8)
+#define VO_V1_SR_DI_MIN_THD_h_mask                                                   (0x00000F00)
+#define VO_V1_SR_DI_MIN_THD_h(data)                                                  (0x00000F00&((data)<<8))
+#define VO_V1_SR_DI_MIN_THD_h_src(data)                                              ((0x00000F00&(data))>>8)
+#define VO_V1_SR_DI_MIN_THD_get_h(data)                                              ((0x00000F00&(data))>>8)
+#define VO_V1_SR_DI_MIN_THD_v_shift                                                  (0)
+#define VO_V1_SR_DI_MIN_THD_v_mask                                                   (0x0000000F)
+#define VO_V1_SR_DI_MIN_THD_v(data)                                                  (0x0000000F&((data)<<0))
+#define VO_V1_SR_DI_MIN_THD_v_src(data)                                              ((0x0000000F&(data))>>0)
+#define VO_V1_SR_DI_MIN_THD_get_v(data)                                              ((0x0000000F&(data))>>0)
+
+
+#define VO_V1_SR_DETAIL                                                              0x980053A0
+#define VO_V1_SR_DETAIL_reg_addr                                                     "0xD80053A0"
+#define VO_V1_SR_DETAIL_reg                                                          0xD80053A0
+#define set_VO_V1_SR_DETAIL_reg(data)   (*((volatile unsigned int*) VO_V1_SR_DETAIL_reg)=data)
+#define get_VO_V1_SR_DETAIL_reg   (*((volatile unsigned int*) VO_V1_SR_DETAIL_reg))
+#define VO_V1_SR_DETAIL_inst_adr                                                     "0x00E8"
+#define VO_V1_SR_DETAIL_inst                                                         0x00E8
+#define VO_V1_SR_DETAIL_thd_shift                                                    (0)
+#define VO_V1_SR_DETAIL_thd_mask                                                     (0x0000000F)
+#define VO_V1_SR_DETAIL_thd(data)                                                    (0x0000000F&((data)<<0))
+#define VO_V1_SR_DETAIL_thd_src(data)                                                ((0x0000000F&(data))>>0)
+#define VO_V1_SR_DETAIL_get_thd(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define VO_V1_SR_DYN_MIN_THD                                                         0x980053A4
+#define VO_V1_SR_DYN_MIN_THD_reg_addr                                                "0xD80053A4"
+#define VO_V1_SR_DYN_MIN_THD_reg                                                     0xD80053A4
+#define set_VO_V1_SR_DYN_MIN_THD_reg(data)   (*((volatile unsigned int*) VO_V1_SR_DYN_MIN_THD_reg)=data)
+#define get_VO_V1_SR_DYN_MIN_THD_reg   (*((volatile unsigned int*) VO_V1_SR_DYN_MIN_THD_reg))
+#define VO_V1_SR_DYN_MIN_THD_inst_adr                                                "0x00E9"
+#define VO_V1_SR_DYN_MIN_THD_inst                                                    0x00E9
+#define VO_V1_SR_DYN_MIN_THD_acc_shift                                               (16)
+#define VO_V1_SR_DYN_MIN_THD_acc_mask                                                (0x001F0000)
+#define VO_V1_SR_DYN_MIN_THD_acc(data)                                               (0x001F0000&((data)<<16))
+#define VO_V1_SR_DYN_MIN_THD_acc_src(data)                                           ((0x001F0000&(data))>>16)
+#define VO_V1_SR_DYN_MIN_THD_get_acc(data)                                           ((0x001F0000&(data))>>16)
+#define VO_V1_SR_DYN_MIN_THD_high_thd_shift                                          (8)
+#define VO_V1_SR_DYN_MIN_THD_high_thd_mask                                           (0x00000F00)
+#define VO_V1_SR_DYN_MIN_THD_high_thd(data)                                          (0x00000F00&((data)<<8))
+#define VO_V1_SR_DYN_MIN_THD_high_thd_src(data)                                      ((0x00000F00&(data))>>8)
+#define VO_V1_SR_DYN_MIN_THD_get_high_thd(data)                                      ((0x00000F00&(data))>>8)
+#define VO_V1_SR_DYN_MIN_THD_low_thd_shift                                           (0)
+#define VO_V1_SR_DYN_MIN_THD_low_thd_mask                                            (0x0000000F)
+#define VO_V1_SR_DYN_MIN_THD_low_thd(data)                                           (0x0000000F&((data)<<0))
+#define VO_V1_SR_DYN_MIN_THD_low_thd_src(data)                                       ((0x0000000F&(data))>>0)
+#define VO_V1_SR_DYN_MIN_THD_get_low_thd(data)                                       ((0x0000000F&(data))>>0)
+
+
+#define VO_V1_SR_DYN_MIN_THD_CNT                                                     0x980053A8
+#define VO_V1_SR_DYN_MIN_THD_CNT_reg_addr                                            "0xD80053A8"
+#define VO_V1_SR_DYN_MIN_THD_CNT_reg                                                 0xD80053A8
+#define set_VO_V1_SR_DYN_MIN_THD_CNT_reg(data)   (*((volatile unsigned int*) VO_V1_SR_DYN_MIN_THD_CNT_reg)=data)
+#define get_VO_V1_SR_DYN_MIN_THD_CNT_reg   (*((volatile unsigned int*) VO_V1_SR_DYN_MIN_THD_CNT_reg))
+#define VO_V1_SR_DYN_MIN_THD_CNT_inst_adr                                            "0x00EA"
+#define VO_V1_SR_DYN_MIN_THD_CNT_inst                                                0x00EA
+#define VO_V1_SR_DYN_MIN_THD_CNT_high_detail_shift                                   (8)
+#define VO_V1_SR_DYN_MIN_THD_CNT_high_detail_mask                                    (0x00003F00)
+#define VO_V1_SR_DYN_MIN_THD_CNT_high_detail(data)                                   (0x00003F00&((data)<<8))
+#define VO_V1_SR_DYN_MIN_THD_CNT_high_detail_src(data)                               ((0x00003F00&(data))>>8)
+#define VO_V1_SR_DYN_MIN_THD_CNT_get_high_detail(data)                               ((0x00003F00&(data))>>8)
+#define VO_V1_SR_DYN_MIN_THD_CNT_low_detail_shift                                    (0)
+#define VO_V1_SR_DYN_MIN_THD_CNT_low_detail_mask                                     (0x0000003F)
+#define VO_V1_SR_DYN_MIN_THD_CNT_low_detail(data)                                    (0x0000003F&((data)<<0))
+#define VO_V1_SR_DYN_MIN_THD_CNT_low_detail_src(data)                                ((0x0000003F&(data))>>0)
+#define VO_V1_SR_DYN_MIN_THD_CNT_get_low_detail(data)                                ((0x0000003F&(data))>>0)
+
+
+#define VO_V1_SR_SHP                                                                 0x980053AC
+#define VO_V1_SR_SHP_reg_addr                                                        "0xD80053AC"
+#define VO_V1_SR_SHP_reg                                                             0xD80053AC
+#define set_VO_V1_SR_SHP_reg(data)   (*((volatile unsigned int*) VO_V1_SR_SHP_reg)=data)
+#define get_VO_V1_SR_SHP_reg   (*((volatile unsigned int*) VO_V1_SR_SHP_reg))
+#define VO_V1_SR_SHP_inst_adr                                                        "0x00EB"
+#define VO_V1_SR_SHP_inst                                                            0x00EB
+#define VO_V1_SR_SHP_blend_en_shift                                                  (3)
+#define VO_V1_SR_SHP_blend_en_mask                                                   (0x00000008)
+#define VO_V1_SR_SHP_blend_en(data)                                                  (0x00000008&((data)<<3))
+#define VO_V1_SR_SHP_blend_en_src(data)                                              ((0x00000008&(data))>>3)
+#define VO_V1_SR_SHP_get_blend_en(data)                                              ((0x00000008&(data))>>3)
+#define VO_V1_SR_SHP_usm_lpf_en_shift                                                (2)
+#define VO_V1_SR_SHP_usm_lpf_en_mask                                                 (0x00000004)
+#define VO_V1_SR_SHP_usm_lpf_en(data)                                                (0x00000004&((data)<<2))
+#define VO_V1_SR_SHP_usm_lpf_en_src(data)                                            ((0x00000004&(data))>>2)
+#define VO_V1_SR_SHP_get_usm_lpf_en(data)                                            ((0x00000004&(data))>>2)
+#define VO_V1_SR_SHP_en_shift                                                        (1)
+#define VO_V1_SR_SHP_en_mask                                                         (0x00000002)
+#define VO_V1_SR_SHP_en(data)                                                        (0x00000002&((data)<<1))
+#define VO_V1_SR_SHP_en_src(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V1_SR_SHP_get_en(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V1_SR_SHP_write_data_shift                                                (0)
+#define VO_V1_SR_SHP_write_data_mask                                                 (0x00000001)
+#define VO_V1_SR_SHP_write_data(data)                                                (0x00000001&((data)<<0))
+#define VO_V1_SR_SHP_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_V1_SR_SHP_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VO_V1_SR_SHP_CFG0                                                            0x980053B0
+#define VO_V1_SR_SHP_CFG0_reg_addr                                                   "0xD80053B0"
+#define VO_V1_SR_SHP_CFG0_reg                                                        0xD80053B0
+#define set_VO_V1_SR_SHP_CFG0_reg(data)   (*((volatile unsigned int*) VO_V1_SR_SHP_CFG0_reg)=data)
+#define get_VO_V1_SR_SHP_CFG0_reg   (*((volatile unsigned int*) VO_V1_SR_SHP_CFG0_reg))
+#define VO_V1_SR_SHP_CFG0_inst_adr                                                   "0x00EC"
+#define VO_V1_SR_SHP_CFG0_inst                                                       0x00EC
+#define VO_V1_SR_SHP_CFG0_thd_shift                                                  (0)
+#define VO_V1_SR_SHP_CFG0_thd_mask                                                   (0x000003FF)
+#define VO_V1_SR_SHP_CFG0_thd(data)                                                  (0x000003FF&((data)<<0))
+#define VO_V1_SR_SHP_CFG0_thd_src(data)                                              ((0x000003FF&(data))>>0)
+#define VO_V1_SR_SHP_CFG0_get_thd(data)                                              ((0x000003FF&(data))>>0)
+
+
+#define VO_V1_SR_SHP_CFG1                                                            0x980053B4
+#define VO_V1_SR_SHP_CFG1_reg_addr                                                   "0xD80053B4"
+#define VO_V1_SR_SHP_CFG1_reg                                                        0xD80053B4
+#define set_VO_V1_SR_SHP_CFG1_reg(data)   (*((volatile unsigned int*) VO_V1_SR_SHP_CFG1_reg)=data)
+#define get_VO_V1_SR_SHP_CFG1_reg   (*((volatile unsigned int*) VO_V1_SR_SHP_CFG1_reg))
+#define VO_V1_SR_SHP_CFG1_inst_adr                                                   "0x00ED"
+#define VO_V1_SR_SHP_CFG1_inst                                                       0x00ED
+#define VO_V1_SR_SHP_CFG1_clip_range_min_shift                                       (16)
+#define VO_V1_SR_SHP_CFG1_clip_range_min_mask                                        (0x003F0000)
+#define VO_V1_SR_SHP_CFG1_clip_range_min(data)                                       (0x003F0000&((data)<<16))
+#define VO_V1_SR_SHP_CFG1_clip_range_min_src(data)                                   ((0x003F0000&(data))>>16)
+#define VO_V1_SR_SHP_CFG1_get_clip_range_min(data)                                   ((0x003F0000&(data))>>16)
+#define VO_V1_SR_SHP_CFG1_clip_range_max_shift                                       (8)
+#define VO_V1_SR_SHP_CFG1_clip_range_max_mask                                        (0x00003F00)
+#define VO_V1_SR_SHP_CFG1_clip_range_max(data)                                       (0x00003F00&((data)<<8))
+#define VO_V1_SR_SHP_CFG1_clip_range_max_src(data)                                   ((0x00003F00&(data))>>8)
+#define VO_V1_SR_SHP_CFG1_get_clip_range_max(data)                                   ((0x00003F00&(data))>>8)
+#define VO_V1_SR_SHP_CFG1_gain_shift                                                 (0)
+#define VO_V1_SR_SHP_CFG1_gain_mask                                                  (0x0000003F)
+#define VO_V1_SR_SHP_CFG1_gain(data)                                                 (0x0000003F&((data)<<0))
+#define VO_V1_SR_SHP_CFG1_gain_src(data)                                             ((0x0000003F&(data))>>0)
+#define VO_V1_SR_SHP_CFG1_get_gain(data)                                             ((0x0000003F&(data))>>0)
+
+
+#define VO_V1_SR_SHP_LPF_0                                                           0x980053B8
+#define VO_V1_SR_SHP_LPF_0_reg_addr                                                  "0xD80053B8"
+#define VO_V1_SR_SHP_LPF_0_reg                                                       0xD80053B8
+#define set_VO_V1_SR_SHP_LPF_0_reg(data)   (*((volatile unsigned int*) VO_V1_SR_SHP_LPF_0_reg)=data)
+#define get_VO_V1_SR_SHP_LPF_0_reg   (*((volatile unsigned int*) VO_V1_SR_SHP_LPF_0_reg))
+#define VO_V1_SR_SHP_LPF_0_inst_adr                                                  "0x00EE"
+#define VO_V1_SR_SHP_LPF_0_inst                                                      0x00EE
+#define VO_V1_SR_SHP_LPF_0_c4_shift                                                  (16)
+#define VO_V1_SR_SHP_LPF_0_c4_mask                                                   (0x000F0000)
+#define VO_V1_SR_SHP_LPF_0_c4(data)                                                  (0x000F0000&((data)<<16))
+#define VO_V1_SR_SHP_LPF_0_c4_src(data)                                              ((0x000F0000&(data))>>16)
+#define VO_V1_SR_SHP_LPF_0_get_c4(data)                                              ((0x000F0000&(data))>>16)
+#define VO_V1_SR_SHP_LPF_0_c3_shift                                                  (12)
+#define VO_V1_SR_SHP_LPF_0_c3_mask                                                   (0x0000F000)
+#define VO_V1_SR_SHP_LPF_0_c3(data)                                                  (0x0000F000&((data)<<12))
+#define VO_V1_SR_SHP_LPF_0_c3_src(data)                                              ((0x0000F000&(data))>>12)
+#define VO_V1_SR_SHP_LPF_0_get_c3(data)                                              ((0x0000F000&(data))>>12)
+#define VO_V1_SR_SHP_LPF_0_c2_shift                                                  (8)
+#define VO_V1_SR_SHP_LPF_0_c2_mask                                                   (0x00000F00)
+#define VO_V1_SR_SHP_LPF_0_c2(data)                                                  (0x00000F00&((data)<<8))
+#define VO_V1_SR_SHP_LPF_0_c2_src(data)                                              ((0x00000F00&(data))>>8)
+#define VO_V1_SR_SHP_LPF_0_get_c2(data)                                              ((0x00000F00&(data))>>8)
+#define VO_V1_SR_SHP_LPF_0_c1_shift                                                  (4)
+#define VO_V1_SR_SHP_LPF_0_c1_mask                                                   (0x000000F0)
+#define VO_V1_SR_SHP_LPF_0_c1(data)                                                  (0x000000F0&((data)<<4))
+#define VO_V1_SR_SHP_LPF_0_c1_src(data)                                              ((0x000000F0&(data))>>4)
+#define VO_V1_SR_SHP_LPF_0_get_c1(data)                                              ((0x000000F0&(data))>>4)
+#define VO_V1_SR_SHP_LPF_0_c0_shift                                                  (0)
+#define VO_V1_SR_SHP_LPF_0_c0_mask                                                   (0x0000000F)
+#define VO_V1_SR_SHP_LPF_0_c0(data)                                                  (0x0000000F&((data)<<0))
+#define VO_V1_SR_SHP_LPF_0_c0_src(data)                                              ((0x0000000F&(data))>>0)
+#define VO_V1_SR_SHP_LPF_0_get_c0(data)                                              ((0x0000000F&(data))>>0)
+
+
+#define VO_V1_SR_SHP_LPF_1                                                           0x980053BC
+#define VO_V1_SR_SHP_LPF_1_reg_addr                                                  "0xD80053BC"
+#define VO_V1_SR_SHP_LPF_1_reg                                                       0xD80053BC
+#define set_VO_V1_SR_SHP_LPF_1_reg(data)   (*((volatile unsigned int*) VO_V1_SR_SHP_LPF_1_reg)=data)
+#define get_VO_V1_SR_SHP_LPF_1_reg   (*((volatile unsigned int*) VO_V1_SR_SHP_LPF_1_reg))
+#define VO_V1_SR_SHP_LPF_1_inst_adr                                                  "0x00EF"
+#define VO_V1_SR_SHP_LPF_1_inst                                                      0x00EF
+#define VO_V1_SR_SHP_LPF_1_c4_shift                                                  (16)
+#define VO_V1_SR_SHP_LPF_1_c4_mask                                                   (0x000F0000)
+#define VO_V1_SR_SHP_LPF_1_c4(data)                                                  (0x000F0000&((data)<<16))
+#define VO_V1_SR_SHP_LPF_1_c4_src(data)                                              ((0x000F0000&(data))>>16)
+#define VO_V1_SR_SHP_LPF_1_get_c4(data)                                              ((0x000F0000&(data))>>16)
+#define VO_V1_SR_SHP_LPF_1_c3_shift                                                  (12)
+#define VO_V1_SR_SHP_LPF_1_c3_mask                                                   (0x0000F000)
+#define VO_V1_SR_SHP_LPF_1_c3(data)                                                  (0x0000F000&((data)<<12))
+#define VO_V1_SR_SHP_LPF_1_c3_src(data)                                              ((0x0000F000&(data))>>12)
+#define VO_V1_SR_SHP_LPF_1_get_c3(data)                                              ((0x0000F000&(data))>>12)
+#define VO_V1_SR_SHP_LPF_1_c2_shift                                                  (8)
+#define VO_V1_SR_SHP_LPF_1_c2_mask                                                   (0x00000F00)
+#define VO_V1_SR_SHP_LPF_1_c2(data)                                                  (0x00000F00&((data)<<8))
+#define VO_V1_SR_SHP_LPF_1_c2_src(data)                                              ((0x00000F00&(data))>>8)
+#define VO_V1_SR_SHP_LPF_1_get_c2(data)                                              ((0x00000F00&(data))>>8)
+#define VO_V1_SR_SHP_LPF_1_c1_shift                                                  (4)
+#define VO_V1_SR_SHP_LPF_1_c1_mask                                                   (0x000000F0)
+#define VO_V1_SR_SHP_LPF_1_c1(data)                                                  (0x000000F0&((data)<<4))
+#define VO_V1_SR_SHP_LPF_1_c1_src(data)                                              ((0x000000F0&(data))>>4)
+#define VO_V1_SR_SHP_LPF_1_get_c1(data)                                              ((0x000000F0&(data))>>4)
+#define VO_V1_SR_SHP_LPF_1_c0_shift                                                  (0)
+#define VO_V1_SR_SHP_LPF_1_c0_mask                                                   (0x0000000F)
+#define VO_V1_SR_SHP_LPF_1_c0(data)                                                  (0x0000000F&((data)<<0))
+#define VO_V1_SR_SHP_LPF_1_c0_src(data)                                              ((0x0000000F&(data))>>0)
+#define VO_V1_SR_SHP_LPF_1_get_c0(data)                                              ((0x0000000F&(data))>>0)
+
+
+#define VO_V1_SR_SHP_LPF_2                                                           0x980053C0
+#define VO_V1_SR_SHP_LPF_2_reg_addr                                                  "0xD80053C0"
+#define VO_V1_SR_SHP_LPF_2_reg                                                       0xD80053C0
+#define set_VO_V1_SR_SHP_LPF_2_reg(data)   (*((volatile unsigned int*) VO_V1_SR_SHP_LPF_2_reg)=data)
+#define get_VO_V1_SR_SHP_LPF_2_reg   (*((volatile unsigned int*) VO_V1_SR_SHP_LPF_2_reg))
+#define VO_V1_SR_SHP_LPF_2_inst_adr                                                  "0x00F0"
+#define VO_V1_SR_SHP_LPF_2_inst                                                      0x00F0
+#define VO_V1_SR_SHP_LPF_2_c4_shift                                                  (16)
+#define VO_V1_SR_SHP_LPF_2_c4_mask                                                   (0x000F0000)
+#define VO_V1_SR_SHP_LPF_2_c4(data)                                                  (0x000F0000&((data)<<16))
+#define VO_V1_SR_SHP_LPF_2_c4_src(data)                                              ((0x000F0000&(data))>>16)
+#define VO_V1_SR_SHP_LPF_2_get_c4(data)                                              ((0x000F0000&(data))>>16)
+#define VO_V1_SR_SHP_LPF_2_c3_shift                                                  (12)
+#define VO_V1_SR_SHP_LPF_2_c3_mask                                                   (0x0000F000)
+#define VO_V1_SR_SHP_LPF_2_c3(data)                                                  (0x0000F000&((data)<<12))
+#define VO_V1_SR_SHP_LPF_2_c3_src(data)                                              ((0x0000F000&(data))>>12)
+#define VO_V1_SR_SHP_LPF_2_get_c3(data)                                              ((0x0000F000&(data))>>12)
+#define VO_V1_SR_SHP_LPF_2_c2_shift                                                  (8)
+#define VO_V1_SR_SHP_LPF_2_c2_mask                                                   (0x00000F00)
+#define VO_V1_SR_SHP_LPF_2_c2(data)                                                  (0x00000F00&((data)<<8))
+#define VO_V1_SR_SHP_LPF_2_c2_src(data)                                              ((0x00000F00&(data))>>8)
+#define VO_V1_SR_SHP_LPF_2_get_c2(data)                                              ((0x00000F00&(data))>>8)
+#define VO_V1_SR_SHP_LPF_2_c1_shift                                                  (4)
+#define VO_V1_SR_SHP_LPF_2_c1_mask                                                   (0x000000F0)
+#define VO_V1_SR_SHP_LPF_2_c1(data)                                                  (0x000000F0&((data)<<4))
+#define VO_V1_SR_SHP_LPF_2_c1_src(data)                                              ((0x000000F0&(data))>>4)
+#define VO_V1_SR_SHP_LPF_2_get_c1(data)                                              ((0x000000F0&(data))>>4)
+#define VO_V1_SR_SHP_LPF_2_c0_shift                                                  (0)
+#define VO_V1_SR_SHP_LPF_2_c0_mask                                                   (0x0000000F)
+#define VO_V1_SR_SHP_LPF_2_c0(data)                                                  (0x0000000F&((data)<<0))
+#define VO_V1_SR_SHP_LPF_2_c0_src(data)                                              ((0x0000000F&(data))>>0)
+#define VO_V1_SR_SHP_LPF_2_get_c0(data)                                              ((0x0000000F&(data))>>0)
+
+
+#define VO_V1_SR_SHP_WGT_THD                                                         0x980053C4
+#define VO_V1_SR_SHP_WGT_THD_reg_addr                                                "0xD80053C4"
+#define VO_V1_SR_SHP_WGT_THD_reg                                                     0xD80053C4
+#define set_VO_V1_SR_SHP_WGT_THD_reg(data)   (*((volatile unsigned int*) VO_V1_SR_SHP_WGT_THD_reg)=data)
+#define get_VO_V1_SR_SHP_WGT_THD_reg   (*((volatile unsigned int*) VO_V1_SR_SHP_WGT_THD_reg))
+#define VO_V1_SR_SHP_WGT_THD_inst_adr                                                "0x00F1"
+#define VO_V1_SR_SHP_WGT_THD_inst                                                    0x00F1
+#define VO_V1_SR_SHP_WGT_THD_high_shift                                              (16)
+#define VO_V1_SR_SHP_WGT_THD_high_mask                                               (0x03FF0000)
+#define VO_V1_SR_SHP_WGT_THD_high(data)                                              (0x03FF0000&((data)<<16))
+#define VO_V1_SR_SHP_WGT_THD_high_src(data)                                          ((0x03FF0000&(data))>>16)
+#define VO_V1_SR_SHP_WGT_THD_get_high(data)                                          ((0x03FF0000&(data))>>16)
+#define VO_V1_SR_SHP_WGT_THD_low_shift                                               (0)
+#define VO_V1_SR_SHP_WGT_THD_low_mask                                                (0x000003FF)
+#define VO_V1_SR_SHP_WGT_THD_low(data)                                               (0x000003FF&((data)<<0))
+#define VO_V1_SR_SHP_WGT_THD_low_src(data)                                           ((0x000003FF&(data))>>0)
+#define VO_V1_SR_SHP_WGT_THD_get_low(data)                                           ((0x000003FF&(data))>>0)
+
+
+#define VO_V1_SR_SHP_WGT                                                             0x980053C8
+#define VO_V1_SR_SHP_WGT_reg_addr                                                    "0xD80053C8"
+#define VO_V1_SR_SHP_WGT_reg                                                         0xD80053C8
+#define set_VO_V1_SR_SHP_WGT_reg(data)   (*((volatile unsigned int*) VO_V1_SR_SHP_WGT_reg)=data)
+#define get_VO_V1_SR_SHP_WGT_reg   (*((volatile unsigned int*) VO_V1_SR_SHP_WGT_reg))
+#define VO_V1_SR_SHP_WGT_inst_adr                                                    "0x00F2"
+#define VO_V1_SR_SHP_WGT_inst                                                        0x00F2
+#define VO_V1_SR_SHP_WGT_gain_shift                                                  (0)
+#define VO_V1_SR_SHP_WGT_gain_mask                                                   (0x000000FF)
+#define VO_V1_SR_SHP_WGT_gain(data)                                                  (0x000000FF&((data)<<0))
+#define VO_V1_SR_SHP_WGT_gain_src(data)                                              ((0x000000FF&(data))>>0)
+#define VO_V1_SR_SHP_WGT_get_gain(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_CC1                                                                    0x980053CC
+#define VO_V1_CC1_reg_addr                                                           "0xD80053CC"
+#define VO_V1_CC1_reg                                                                0xD80053CC
+#define set_VO_V1_CC1_reg(data)   (*((volatile unsigned int*) VO_V1_CC1_reg)=data)
+#define get_VO_V1_CC1_reg   (*((volatile unsigned int*) VO_V1_CC1_reg))
+#define VO_V1_CC1_inst_adr                                                           "0x00F3"
+#define VO_V1_CC1_inst                                                               0x00F3
+#define VO_V1_CC1_m01_shift                                                          (16)
+#define VO_V1_CC1_m01_mask                                                           (0x3FFF0000)
+#define VO_V1_CC1_m01(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_CC1_m01_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC1_get_m01(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC1_m00_shift                                                          (0)
+#define VO_V1_CC1_m00_mask                                                           (0x00003FFF)
+#define VO_V1_CC1_m00(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_CC1_m00_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_CC1_get_m00(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC2                                                                    0x980053D0
+#define VO_V1_CC2_reg_addr                                                           "0xD80053D0"
+#define VO_V1_CC2_reg                                                                0xD80053D0
+#define set_VO_V1_CC2_reg(data)   (*((volatile unsigned int*) VO_V1_CC2_reg)=data)
+#define get_VO_V1_CC2_reg   (*((volatile unsigned int*) VO_V1_CC2_reg))
+#define VO_V1_CC2_inst_adr                                                           "0x00F4"
+#define VO_V1_CC2_inst                                                               0x00F4
+#define VO_V1_CC2_m10_shift                                                          (16)
+#define VO_V1_CC2_m10_mask                                                           (0x3FFF0000)
+#define VO_V1_CC2_m10(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_CC2_m10_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC2_get_m10(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC2_m02_shift                                                          (0)
+#define VO_V1_CC2_m02_mask                                                           (0x00003FFF)
+#define VO_V1_CC2_m02(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_CC2_m02_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_CC2_get_m02(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC3                                                                    0x980053D4
+#define VO_V1_CC3_reg_addr                                                           "0xD80053D4"
+#define VO_V1_CC3_reg                                                                0xD80053D4
+#define set_VO_V1_CC3_reg(data)   (*((volatile unsigned int*) VO_V1_CC3_reg)=data)
+#define get_VO_V1_CC3_reg   (*((volatile unsigned int*) VO_V1_CC3_reg))
+#define VO_V1_CC3_inst_adr                                                           "0x00F5"
+#define VO_V1_CC3_inst                                                               0x00F5
+#define VO_V1_CC3_m12_shift                                                          (16)
+#define VO_V1_CC3_m12_mask                                                           (0x3FFF0000)
+#define VO_V1_CC3_m12(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_CC3_m12_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC3_get_m12(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC3_m11_shift                                                          (0)
+#define VO_V1_CC3_m11_mask                                                           (0x00003FFF)
+#define VO_V1_CC3_m11(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_CC3_m11_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_CC3_get_m11(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC4                                                                    0x980053D8
+#define VO_V1_CC4_reg_addr                                                           "0xD80053D8"
+#define VO_V1_CC4_reg                                                                0xD80053D8
+#define set_VO_V1_CC4_reg(data)   (*((volatile unsigned int*) VO_V1_CC4_reg)=data)
+#define get_VO_V1_CC4_reg   (*((volatile unsigned int*) VO_V1_CC4_reg))
+#define VO_V1_CC4_inst_adr                                                           "0x00F6"
+#define VO_V1_CC4_inst                                                               0x00F6
+#define VO_V1_CC4_m21_shift                                                          (16)
+#define VO_V1_CC4_m21_mask                                                           (0x3FFF0000)
+#define VO_V1_CC4_m21(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_CC4_m21_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC4_get_m21(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC4_m20_shift                                                          (0)
+#define VO_V1_CC4_m20_mask                                                           (0x00003FFF)
+#define VO_V1_CC4_m20(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_CC4_m20_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_CC4_get_m20(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC5                                                                    0x980053DC
+#define VO_V1_CC5_reg_addr                                                           "0xD80053DC"
+#define VO_V1_CC5_reg                                                                0xD80053DC
+#define set_VO_V1_CC5_reg(data)   (*((volatile unsigned int*) VO_V1_CC5_reg)=data)
+#define get_VO_V1_CC5_reg   (*((volatile unsigned int*) VO_V1_CC5_reg))
+#define VO_V1_CC5_inst_adr                                                           "0x00F7"
+#define VO_V1_CC5_inst                                                               0x00F7
+#define VO_V1_CC5_m22_shift                                                          (0)
+#define VO_V1_CC5_m22_mask                                                           (0x00003FFF)
+#define VO_V1_CC5_m22(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_CC5_m22_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_CC5_get_m22(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC6                                                                    0x980053E0
+#define VO_V1_CC6_reg_addr                                                           "0xD80053E0"
+#define VO_V1_CC6_reg                                                                0xD80053E0
+#define set_VO_V1_CC6_reg(data)   (*((volatile unsigned int*) VO_V1_CC6_reg)=data)
+#define get_VO_V1_CC6_reg   (*((volatile unsigned int*) VO_V1_CC6_reg))
+#define VO_V1_CC6_inst_adr                                                           "0x00F8"
+#define VO_V1_CC6_inst                                                               0x00F8
+#define VO_V1_CC6_a1_shift                                                           (16)
+#define VO_V1_CC6_a1_mask                                                            (0x07FF0000)
+#define VO_V1_CC6_a1(data)                                                           (0x07FF0000&((data)<<16))
+#define VO_V1_CC6_a1_src(data)                                                       ((0x07FF0000&(data))>>16)
+#define VO_V1_CC6_get_a1(data)                                                       ((0x07FF0000&(data))>>16)
+#define VO_V1_CC6_a0_shift                                                           (0)
+#define VO_V1_CC6_a0_mask                                                            (0x000007FF)
+#define VO_V1_CC6_a0(data)                                                           (0x000007FF&((data)<<0))
+#define VO_V1_CC6_a0_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VO_V1_CC6_get_a0(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VO_V1_CC7                                                                    0x980053E4
+#define VO_V1_CC7_reg_addr                                                           "0xD80053E4"
+#define VO_V1_CC7_reg                                                                0xD80053E4
+#define set_VO_V1_CC7_reg(data)   (*((volatile unsigned int*) VO_V1_CC7_reg)=data)
+#define get_VO_V1_CC7_reg   (*((volatile unsigned int*) VO_V1_CC7_reg))
+#define VO_V1_CC7_inst_adr                                                           "0x00F9"
+#define VO_V1_CC7_inst                                                               0x00F9
+#define VO_V1_CC7_a2_shift                                                           (0)
+#define VO_V1_CC7_a2_mask                                                            (0x000007FF)
+#define VO_V1_CC7_a2(data)                                                           (0x000007FF&((data)<<0))
+#define VO_V1_CC7_a2_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VO_V1_CC7_get_a2(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VO_V1_HDR                                                                    0x980053E8
+#define VO_V1_HDR_reg_addr                                                           "0xD80053E8"
+#define VO_V1_HDR_reg                                                                0xD80053E8
+#define set_VO_V1_HDR_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_reg)=data)
+#define get_VO_V1_HDR_reg   (*((volatile unsigned int*) VO_V1_HDR_reg))
+#define VO_V1_HDR_inst_adr                                                           "0x00FA"
+#define VO_V1_HDR_inst                                                               0x00FA
+#define VO_V1_HDR_cd_shift                                                           (3)
+#define VO_V1_HDR_cd_mask                                                            (0x00000008)
+#define VO_V1_HDR_cd(data)                                                           (0x00000008&((data)<<3))
+#define VO_V1_HDR_cd_src(data)                                                       ((0x00000008&(data))>>3)
+#define VO_V1_HDR_get_cd(data)                                                       ((0x00000008&(data))>>3)
+#define VO_V1_HDR_gma_shift                                                          (2)
+#define VO_V1_HDR_gma_mask                                                           (0x00000004)
+#define VO_V1_HDR_gma(data)                                                          (0x00000004&((data)<<2))
+#define VO_V1_HDR_gma_src(data)                                                      ((0x00000004&(data))>>2)
+#define VO_V1_HDR_get_gma(data)                                                      ((0x00000004&(data))>>2)
+#define VO_V1_HDR_iga_shift                                                          (1)
+#define VO_V1_HDR_iga_mask                                                           (0x00000002)
+#define VO_V1_HDR_iga(data)                                                          (0x00000002&((data)<<1))
+#define VO_V1_HDR_iga_src(data)                                                      ((0x00000002&(data))>>1)
+#define VO_V1_HDR_get_iga(data)                                                      ((0x00000002&(data))>>1)
+#define VO_V1_HDR_en_shift                                                           (0)
+#define VO_V1_HDR_en_mask                                                            (0x00000001)
+#define VO_V1_HDR_en(data)                                                           (0x00000001&((data)<<0))
+#define VO_V1_HDR_en_src(data)                                                       ((0x00000001&(data))>>0)
+#define VO_V1_HDR_get_en(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define VO_V1_IGA_PORT                                                               0x180053EC
+#define VO_V1_IGA_PORT_reg_addr                                                      "0xD80053EC"
+#define VO_V1_IGA_PORT_reg                                                           0xD80053EC
+#define set_VO_V1_IGA_PORT_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_PORT_reg)=data)
+#define get_VO_V1_IGA_PORT_reg   (*((volatile unsigned int*) VO_V1_IGA_PORT_reg))
+#define VO_V1_IGA_PORT_inst_adr                                                      "0x00FB"
+#define VO_V1_IGA_PORT_inst                                                          0x00FB
+#define VO_V1_IGA_PORT_tab_index_shift                                               (12)
+#define VO_V1_IGA_PORT_tab_index_mask                                                (0xFFFFF000)
+#define VO_V1_IGA_PORT_tab_index(data)                                               (0xFFFFF000&((data)<<12))
+#define VO_V1_IGA_PORT_tab_index_src(data)                                           ((0xFFFFF000&(data))>>12)
+#define VO_V1_IGA_PORT_get_tab_index(data)                                           ((0xFFFFF000&(data))>>12)
+#define VO_V1_IGA_PORT_tab_d0_shift                                                  (0)
+#define VO_V1_IGA_PORT_tab_d0_mask                                                   (0x00000FFF)
+#define VO_V1_IGA_PORT_tab_d0(data)                                                  (0x00000FFF&((data)<<0))
+#define VO_V1_IGA_PORT_tab_d0_src(data)                                              ((0x00000FFF&(data))>>0)
+#define VO_V1_IGA_PORT_get_tab_d0(data)                                              ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_IGA_CTRL                                                               0x180053F0
+#define VO_V1_IGA_CTRL_reg_addr                                                      "0xD80053F0"
+#define VO_V1_IGA_CTRL_reg                                                           0xD80053F0
+#define set_VO_V1_IGA_CTRL_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_CTRL_reg)=data)
+#define get_VO_V1_IGA_CTRL_reg   (*((volatile unsigned int*) VO_V1_IGA_CTRL_reg))
+#define VO_V1_IGA_CTRL_inst_adr                                                      "0x00FC"
+#define VO_V1_IGA_CTRL_inst                                                          0x00FC
+#define VO_V1_IGA_CTRL_dstat_srcsel_shift                                            (9)
+#define VO_V1_IGA_CTRL_dstat_srcsel_mask                                             (0x00000200)
+#define VO_V1_IGA_CTRL_dstat_srcsel(data)                                            (0x00000200&((data)<<9))
+#define VO_V1_IGA_CTRL_dstat_srcsel_src(data)                                        ((0x00000200&(data))>>9)
+#define VO_V1_IGA_CTRL_get_dstat_srcsel(data)                                        ((0x00000200&(data))>>9)
+#define VO_V1_IGA_CTRL_r_en_shift                                                    (8)
+#define VO_V1_IGA_CTRL_r_en_mask                                                     (0x00000100)
+#define VO_V1_IGA_CTRL_r_en(data)                                                    (0x00000100&((data)<<8))
+#define VO_V1_IGA_CTRL_r_en_src(data)                                                ((0x00000100&(data))>>8)
+#define VO_V1_IGA_CTRL_get_r_en(data)                                                ((0x00000100&(data))>>8)
+#define VO_V1_IGA_CTRL_g_en_shift                                                    (7)
+#define VO_V1_IGA_CTRL_g_en_mask                                                     (0x00000080)
+#define VO_V1_IGA_CTRL_g_en(data)                                                    (0x00000080&((data)<<7))
+#define VO_V1_IGA_CTRL_g_en_src(data)                                                ((0x00000080&(data))>>7)
+#define VO_V1_IGA_CTRL_get_g_en(data)                                                ((0x00000080&(data))>>7)
+#define VO_V1_IGA_CTRL_b_en_shift                                                    (6)
+#define VO_V1_IGA_CTRL_b_en_mask                                                     (0x00000040)
+#define VO_V1_IGA_CTRL_b_en(data)                                                    (0x00000040&((data)<<6))
+#define VO_V1_IGA_CTRL_b_en_src(data)                                                ((0x00000040&(data))>>6)
+#define VO_V1_IGA_CTRL_get_b_en(data)                                                ((0x00000040&(data))>>6)
+#define VO_V1_IGA_CTRL_m_tab_sel_shift                                               (5)
+#define VO_V1_IGA_CTRL_m_tab_sel_mask                                                (0x00000020)
+#define VO_V1_IGA_CTRL_m_tab_sel(data)                                               (0x00000020&((data)<<5))
+#define VO_V1_IGA_CTRL_m_tab_sel_src(data)                                           ((0x00000020&(data))>>5)
+#define VO_V1_IGA_CTRL_get_m_tab_sel(data)                                           ((0x00000020&(data))>>5)
+#define VO_V1_IGA_CTRL_ax_rw_shift                                                   (3)
+#define VO_V1_IGA_CTRL_ax_rw_mask                                                    (0x00000018)
+#define VO_V1_IGA_CTRL_ax_rw(data)                                                   (0x00000018&((data)<<3))
+#define VO_V1_IGA_CTRL_ax_rw_src(data)                                               ((0x00000018&(data))>>3)
+#define VO_V1_IGA_CTRL_get_ax_rw(data)                                               ((0x00000018&(data))>>3)
+#define VO_V1_IGA_CTRL_ax_ch_shift                                                   (1)
+#define VO_V1_IGA_CTRL_ax_ch_mask                                                    (0x00000006)
+#define VO_V1_IGA_CTRL_ax_ch(data)                                                   (0x00000006&((data)<<1))
+#define VO_V1_IGA_CTRL_ax_ch_src(data)                                               ((0x00000006&(data))>>1)
+#define VO_V1_IGA_CTRL_get_ax_ch(data)                                               ((0x00000006&(data))>>1)
+#define VO_V1_IGA_CTRL_dstat_en_shift                                                (0)
+#define VO_V1_IGA_CTRL_dstat_en_mask                                                 (0x00000001)
+#define VO_V1_IGA_CTRL_dstat_en(data)                                                (0x00000001&((data)<<0))
+#define VO_V1_IGA_CTRL_dstat_en_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_V1_IGA_CTRL_get_dstat_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VO_V1_IGA_STATUS                                                             0x180053F4
+#define VO_V1_IGA_STATUS_reg_addr                                                    "0xD80053F4"
+#define VO_V1_IGA_STATUS_reg                                                         0xD80053F4
+#define set_VO_V1_IGA_STATUS_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_STATUS_reg)=data)
+#define get_VO_V1_IGA_STATUS_reg   (*((volatile unsigned int*) VO_V1_IGA_STATUS_reg))
+#define VO_V1_IGA_STATUS_inst_adr                                                    "0x00FD"
+#define VO_V1_IGA_STATUS_inst                                                        0x00FD
+#define VO_V1_IGA_STATUS_fifo_empty_shift                                            (2)
+#define VO_V1_IGA_STATUS_fifo_empty_mask                                             (0x00000004)
+#define VO_V1_IGA_STATUS_fifo_empty(data)                                            (0x00000004&((data)<<2))
+#define VO_V1_IGA_STATUS_fifo_empty_src(data)                                        ((0x00000004&(data))>>2)
+#define VO_V1_IGA_STATUS_get_fifo_empty(data)                                        ((0x00000004&(data))>>2)
+#define VO_V1_IGA_STATUS_fifo_full_shift                                             (1)
+#define VO_V1_IGA_STATUS_fifo_full_mask                                              (0x00000002)
+#define VO_V1_IGA_STATUS_fifo_full(data)                                             (0x00000002&((data)<<1))
+#define VO_V1_IGA_STATUS_fifo_full_src(data)                                         ((0x00000002&(data))>>1)
+#define VO_V1_IGA_STATUS_get_fifo_full(data)                                         ((0x00000002&(data))>>1)
+#define VO_V1_IGA_STATUS_wr_error_shift                                              (0)
+#define VO_V1_IGA_STATUS_wr_error_mask                                               (0x00000001)
+#define VO_V1_IGA_STATUS_wr_error(data)                                              (0x00000001&((data)<<0))
+#define VO_V1_IGA_STATUS_wr_error_src(data)                                          ((0x00000001&(data))>>0)
+#define VO_V1_IGA_STATUS_get_wr_error(data)                                          ((0x00000001&(data))>>0)
+
+
+#define VO_V1_IGA_DSTAT_CTRL_R                                                       0x180053F8
+#define VO_V1_IGA_DSTAT_CTRL_R_reg_addr                                              "0xD80053F8"
+#define VO_V1_IGA_DSTAT_CTRL_R_reg                                                   0xD80053F8
+#define set_VO_V1_IGA_DSTAT_CTRL_R_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_CTRL_R_reg)=data)
+#define get_VO_V1_IGA_DSTAT_CTRL_R_reg   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_CTRL_R_reg))
+#define VO_V1_IGA_DSTAT_CTRL_R_inst_adr                                              "0x00FE"
+#define VO_V1_IGA_DSTAT_CTRL_R_inst                                                  0x00FE
+#define VO_V1_IGA_DSTAT_CTRL_R_low_shift                                             (16)
+#define VO_V1_IGA_DSTAT_CTRL_R_low_mask                                              (0x0FFF0000)
+#define VO_V1_IGA_DSTAT_CTRL_R_low(data)                                             (0x0FFF0000&((data)<<16))
+#define VO_V1_IGA_DSTAT_CTRL_R_low_src(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_CTRL_R_get_low(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_CTRL_R_high_shift                                            (0)
+#define VO_V1_IGA_DSTAT_CTRL_R_high_mask                                             (0x00000FFF)
+#define VO_V1_IGA_DSTAT_CTRL_R_high(data)                                            (0x00000FFF&((data)<<0))
+#define VO_V1_IGA_DSTAT_CTRL_R_high_src(data)                                        ((0x00000FFF&(data))>>0)
+#define VO_V1_IGA_DSTAT_CTRL_R_get_high(data)                                        ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_IGA_DSTAT_CTRL_G                                                       0x180053FC
+#define VO_V1_IGA_DSTAT_CTRL_G_reg_addr                                              "0xD80053FC"
+#define VO_V1_IGA_DSTAT_CTRL_G_reg                                                   0xD80053FC
+#define set_VO_V1_IGA_DSTAT_CTRL_G_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_CTRL_G_reg)=data)
+#define get_VO_V1_IGA_DSTAT_CTRL_G_reg   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_CTRL_G_reg))
+#define VO_V1_IGA_DSTAT_CTRL_G_inst_adr                                              "0x00FF"
+#define VO_V1_IGA_DSTAT_CTRL_G_inst                                                  0x00FF
+#define VO_V1_IGA_DSTAT_CTRL_G_low_shift                                             (16)
+#define VO_V1_IGA_DSTAT_CTRL_G_low_mask                                              (0x0FFF0000)
+#define VO_V1_IGA_DSTAT_CTRL_G_low(data)                                             (0x0FFF0000&((data)<<16))
+#define VO_V1_IGA_DSTAT_CTRL_G_low_src(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_CTRL_G_get_low(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_CTRL_G_high_shift                                            (0)
+#define VO_V1_IGA_DSTAT_CTRL_G_high_mask                                             (0x00000FFF)
+#define VO_V1_IGA_DSTAT_CTRL_G_high(data)                                            (0x00000FFF&((data)<<0))
+#define VO_V1_IGA_DSTAT_CTRL_G_high_src(data)                                        ((0x00000FFF&(data))>>0)
+#define VO_V1_IGA_DSTAT_CTRL_G_get_high(data)                                        ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_IGA_DSTAT_CTRL_B                                                       0x18005400
+#define VO_V1_IGA_DSTAT_CTRL_B_reg_addr                                              "0xD8005400"
+#define VO_V1_IGA_DSTAT_CTRL_B_reg                                                   0xD8005400
+#define set_VO_V1_IGA_DSTAT_CTRL_B_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_CTRL_B_reg)=data)
+#define get_VO_V1_IGA_DSTAT_CTRL_B_reg   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_CTRL_B_reg))
+#define VO_V1_IGA_DSTAT_CTRL_B_inst_adr                                              "0x0000"
+#define VO_V1_IGA_DSTAT_CTRL_B_inst                                                  0x0000
+#define VO_V1_IGA_DSTAT_CTRL_B_low_shift                                             (16)
+#define VO_V1_IGA_DSTAT_CTRL_B_low_mask                                              (0x0FFF0000)
+#define VO_V1_IGA_DSTAT_CTRL_B_low(data)                                             (0x0FFF0000&((data)<<16))
+#define VO_V1_IGA_DSTAT_CTRL_B_low_src(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_CTRL_B_get_low(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_CTRL_B_high_shift                                            (0)
+#define VO_V1_IGA_DSTAT_CTRL_B_high_mask                                             (0x00000FFF)
+#define VO_V1_IGA_DSTAT_CTRL_B_high(data)                                            (0x00000FFF&((data)<<0))
+#define VO_V1_IGA_DSTAT_CTRL_B_high_src(data)                                        ((0x00000FFF&(data))>>0)
+#define VO_V1_IGA_DSTAT_CTRL_B_get_high(data)                                        ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_IGA_DSTAT_O_R1                                                         0x18005404
+#define VO_V1_IGA_DSTAT_O_R1_reg_addr                                                "0xD8005404"
+#define VO_V1_IGA_DSTAT_O_R1_reg                                                     0xD8005404
+#define set_VO_V1_IGA_DSTAT_O_R1_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_R1_reg)=data)
+#define get_VO_V1_IGA_DSTAT_O_R1_reg   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_R1_reg))
+#define VO_V1_IGA_DSTAT_O_R1_inst_adr                                                "0x0001"
+#define VO_V1_IGA_DSTAT_O_R1_inst                                                    0x0001
+#define VO_V1_IGA_DSTAT_O_R1_cnt_shift                                               (0)
+#define VO_V1_IGA_DSTAT_O_R1_cnt_mask                                                (0x001FFFFF)
+#define VO_V1_IGA_DSTAT_O_R1_cnt(data)                                               (0x001FFFFF&((data)<<0))
+#define VO_V1_IGA_DSTAT_O_R1_cnt_src(data)                                           ((0x001FFFFF&(data))>>0)
+#define VO_V1_IGA_DSTAT_O_R1_get_cnt(data)                                           ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_IGA_DSTAT_O_R2                                                         0x18005408
+#define VO_V1_IGA_DSTAT_O_R2_reg_addr                                                "0xD8005408"
+#define VO_V1_IGA_DSTAT_O_R2_reg                                                     0xD8005408
+#define set_VO_V1_IGA_DSTAT_O_R2_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_R2_reg)=data)
+#define get_VO_V1_IGA_DSTAT_O_R2_reg   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_R2_reg))
+#define VO_V1_IGA_DSTAT_O_R2_inst_adr                                                "0x0002"
+#define VO_V1_IGA_DSTAT_O_R2_inst                                                    0x0002
+#define VO_V1_IGA_DSTAT_O_R2_min_shift                                               (16)
+#define VO_V1_IGA_DSTAT_O_R2_min_mask                                                (0x0FFF0000)
+#define VO_V1_IGA_DSTAT_O_R2_min(data)                                               (0x0FFF0000&((data)<<16))
+#define VO_V1_IGA_DSTAT_O_R2_min_src(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_O_R2_get_min(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_O_R2_max_shift                                               (0)
+#define VO_V1_IGA_DSTAT_O_R2_max_mask                                                (0x00000FFF)
+#define VO_V1_IGA_DSTAT_O_R2_max(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_IGA_DSTAT_O_R2_max_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_IGA_DSTAT_O_R2_get_max(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_IGA_DSTAT_O_G1                                                         0x1800540C
+#define VO_V1_IGA_DSTAT_O_G1_reg_addr                                                "0xD800540C"
+#define VO_V1_IGA_DSTAT_O_G1_reg                                                     0xD800540C
+#define set_VO_V1_IGA_DSTAT_O_G1_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_G1_reg)=data)
+#define get_VO_V1_IGA_DSTAT_O_G1_reg   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_G1_reg))
+#define VO_V1_IGA_DSTAT_O_G1_inst_adr                                                "0x0003"
+#define VO_V1_IGA_DSTAT_O_G1_inst                                                    0x0003
+#define VO_V1_IGA_DSTAT_O_G1_cnt_shift                                               (0)
+#define VO_V1_IGA_DSTAT_O_G1_cnt_mask                                                (0x001FFFFF)
+#define VO_V1_IGA_DSTAT_O_G1_cnt(data)                                               (0x001FFFFF&((data)<<0))
+#define VO_V1_IGA_DSTAT_O_G1_cnt_src(data)                                           ((0x001FFFFF&(data))>>0)
+#define VO_V1_IGA_DSTAT_O_G1_get_cnt(data)                                           ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_IGA_DSTAT_O_G2                                                         0x18005410
+#define VO_V1_IGA_DSTAT_O_G2_reg_addr                                                "0xD8005410"
+#define VO_V1_IGA_DSTAT_O_G2_reg                                                     0xD8005410
+#define set_VO_V1_IGA_DSTAT_O_G2_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_G2_reg)=data)
+#define get_VO_V1_IGA_DSTAT_O_G2_reg   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_G2_reg))
+#define VO_V1_IGA_DSTAT_O_G2_inst_adr                                                "0x0004"
+#define VO_V1_IGA_DSTAT_O_G2_inst                                                    0x0004
+#define VO_V1_IGA_DSTAT_O_G2_min_shift                                               (16)
+#define VO_V1_IGA_DSTAT_O_G2_min_mask                                                (0x0FFF0000)
+#define VO_V1_IGA_DSTAT_O_G2_min(data)                                               (0x0FFF0000&((data)<<16))
+#define VO_V1_IGA_DSTAT_O_G2_min_src(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_O_G2_get_min(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_O_G2_max_shift                                               (0)
+#define VO_V1_IGA_DSTAT_O_G2_max_mask                                                (0x00000FFF)
+#define VO_V1_IGA_DSTAT_O_G2_max(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_IGA_DSTAT_O_G2_max_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_IGA_DSTAT_O_G2_get_max(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_IGA_DSTAT_O_B1                                                         0x18005414
+#define VO_V1_IGA_DSTAT_O_B1_reg_addr                                                "0xD8005414"
+#define VO_V1_IGA_DSTAT_O_B1_reg                                                     0xD8005414
+#define set_VO_V1_IGA_DSTAT_O_B1_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_B1_reg)=data)
+#define get_VO_V1_IGA_DSTAT_O_B1_reg   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_B1_reg))
+#define VO_V1_IGA_DSTAT_O_B1_inst_adr                                                "0x0005"
+#define VO_V1_IGA_DSTAT_O_B1_inst                                                    0x0005
+#define VO_V1_IGA_DSTAT_O_B1_cnt_shift                                               (0)
+#define VO_V1_IGA_DSTAT_O_B1_cnt_mask                                                (0x001FFFFF)
+#define VO_V1_IGA_DSTAT_O_B1_cnt(data)                                               (0x001FFFFF&((data)<<0))
+#define VO_V1_IGA_DSTAT_O_B1_cnt_src(data)                                           ((0x001FFFFF&(data))>>0)
+#define VO_V1_IGA_DSTAT_O_B1_get_cnt(data)                                           ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_IGA_DSTAT_O_B2                                                         0x18005418
+#define VO_V1_IGA_DSTAT_O_B2_reg_addr                                                "0xD8005418"
+#define VO_V1_IGA_DSTAT_O_B2_reg                                                     0xD8005418
+#define set_VO_V1_IGA_DSTAT_O_B2_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_B2_reg)=data)
+#define get_VO_V1_IGA_DSTAT_O_B2_reg   (*((volatile unsigned int*) VO_V1_IGA_DSTAT_O_B2_reg))
+#define VO_V1_IGA_DSTAT_O_B2_inst_adr                                                "0x0006"
+#define VO_V1_IGA_DSTAT_O_B2_inst                                                    0x0006
+#define VO_V1_IGA_DSTAT_O_B2_min_shift                                               (16)
+#define VO_V1_IGA_DSTAT_O_B2_min_mask                                                (0x0FFF0000)
+#define VO_V1_IGA_DSTAT_O_B2_min(data)                                               (0x0FFF0000&((data)<<16))
+#define VO_V1_IGA_DSTAT_O_B2_min_src(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_O_B2_get_min(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_IGA_DSTAT_O_B2_max_shift                                               (0)
+#define VO_V1_IGA_DSTAT_O_B2_max_mask                                                (0x00000FFF)
+#define VO_V1_IGA_DSTAT_O_B2_max(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_IGA_DSTAT_O_B2_max_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_IGA_DSTAT_O_B2_get_max(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_IGA_DUMMY_0                                                            0x1800541C
+#define VO_V1_IGA_DUMMY_0_reg_addr                                                   "0xD800541C"
+#define VO_V1_IGA_DUMMY_0_reg                                                        0xD800541C
+#define set_VO_V1_IGA_DUMMY_0_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DUMMY_0_reg)=data)
+#define get_VO_V1_IGA_DUMMY_0_reg   (*((volatile unsigned int*) VO_V1_IGA_DUMMY_0_reg))
+#define VO_V1_IGA_DUMMY_0_inst_adr                                                   "0x0007"
+#define VO_V1_IGA_DUMMY_0_inst                                                       0x0007
+#define VO_V1_IGA_DUMMY_0_rvd_shift                                                  (0)
+#define VO_V1_IGA_DUMMY_0_rvd_mask                                                   (0xFFFFFFFF)
+#define VO_V1_IGA_DUMMY_0_rvd(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_IGA_DUMMY_0_rvd_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_IGA_DUMMY_0_get_rvd(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_IGA_DUMMY_1                                                            0x18005420
+#define VO_V1_IGA_DUMMY_1_reg_addr                                                   "0xD8005420"
+#define VO_V1_IGA_DUMMY_1_reg                                                        0xD8005420
+#define set_VO_V1_IGA_DUMMY_1_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DUMMY_1_reg)=data)
+#define get_VO_V1_IGA_DUMMY_1_reg   (*((volatile unsigned int*) VO_V1_IGA_DUMMY_1_reg))
+#define VO_V1_IGA_DUMMY_1_inst_adr                                                   "0x0008"
+#define VO_V1_IGA_DUMMY_1_inst                                                       0x0008
+#define VO_V1_IGA_DUMMY_1_rvd_shift                                                  (0)
+#define VO_V1_IGA_DUMMY_1_rvd_mask                                                   (0xFFFFFFFF)
+#define VO_V1_IGA_DUMMY_1_rvd(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_IGA_DUMMY_1_rvd_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_IGA_DUMMY_1_get_rvd(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_IGA_DUMMY_2                                                            0x18005424
+#define VO_V1_IGA_DUMMY_2_reg_addr                                                   "0xD8005424"
+#define VO_V1_IGA_DUMMY_2_reg                                                        0xD8005424
+#define set_VO_V1_IGA_DUMMY_2_reg(data)   (*((volatile unsigned int*) VO_V1_IGA_DUMMY_2_reg)=data)
+#define get_VO_V1_IGA_DUMMY_2_reg   (*((volatile unsigned int*) VO_V1_IGA_DUMMY_2_reg))
+#define VO_V1_IGA_DUMMY_2_inst_adr                                                   "0x0009"
+#define VO_V1_IGA_DUMMY_2_inst                                                       0x0009
+#define VO_V1_IGA_DUMMY_2_rvd_shift                                                  (0)
+#define VO_V1_IGA_DUMMY_2_rvd_mask                                                   (0xFFFFFFFF)
+#define VO_V1_IGA_DUMMY_2_rvd(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_IGA_DUMMY_2_rvd_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_IGA_DUMMY_2_get_rvd(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_GMA_PORT                                                               0x18005428
+#define VO_V1_GMA_PORT_reg_addr                                                      "0xD8005428"
+#define VO_V1_GMA_PORT_reg                                                           0xD8005428
+#define set_VO_V1_GMA_PORT_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_PORT_reg)=data)
+#define get_VO_V1_GMA_PORT_reg   (*((volatile unsigned int*) VO_V1_GMA_PORT_reg))
+#define VO_V1_GMA_PORT_inst_adr                                                      "0x000A"
+#define VO_V1_GMA_PORT_inst                                                          0x000A
+#define VO_V1_GMA_PORT_tab_index_shift                                               (12)
+#define VO_V1_GMA_PORT_tab_index_mask                                                (0xFFFFF000)
+#define VO_V1_GMA_PORT_tab_index(data)                                               (0xFFFFF000&((data)<<12))
+#define VO_V1_GMA_PORT_tab_index_src(data)                                           ((0xFFFFF000&(data))>>12)
+#define VO_V1_GMA_PORT_get_tab_index(data)                                           ((0xFFFFF000&(data))>>12)
+#define VO_V1_GMA_PORT_tab_d0_shift                                                  (0)
+#define VO_V1_GMA_PORT_tab_d0_mask                                                   (0x00000FFF)
+#define VO_V1_GMA_PORT_tab_d0(data)                                                  (0x00000FFF&((data)<<0))
+#define VO_V1_GMA_PORT_tab_d0_src(data)                                              ((0x00000FFF&(data))>>0)
+#define VO_V1_GMA_PORT_get_tab_d0(data)                                              ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_GMA_CTRL                                                               0x1800542C
+#define VO_V1_GMA_CTRL_reg_addr                                                      "0xD800542C"
+#define VO_V1_GMA_CTRL_reg                                                           0xD800542C
+#define set_VO_V1_GMA_CTRL_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_CTRL_reg)=data)
+#define get_VO_V1_GMA_CTRL_reg   (*((volatile unsigned int*) VO_V1_GMA_CTRL_reg))
+#define VO_V1_GMA_CTRL_inst_adr                                                      "0x000B"
+#define VO_V1_GMA_CTRL_inst                                                          0x000B
+#define VO_V1_GMA_CTRL_dstat_srcsel_shift                                            (9)
+#define VO_V1_GMA_CTRL_dstat_srcsel_mask                                             (0x00000200)
+#define VO_V1_GMA_CTRL_dstat_srcsel(data)                                            (0x00000200&((data)<<9))
+#define VO_V1_GMA_CTRL_dstat_srcsel_src(data)                                        ((0x00000200&(data))>>9)
+#define VO_V1_GMA_CTRL_get_dstat_srcsel(data)                                        ((0x00000200&(data))>>9)
+#define VO_V1_GMA_CTRL_r_en_shift                                                    (8)
+#define VO_V1_GMA_CTRL_r_en_mask                                                     (0x00000100)
+#define VO_V1_GMA_CTRL_r_en(data)                                                    (0x00000100&((data)<<8))
+#define VO_V1_GMA_CTRL_r_en_src(data)                                                ((0x00000100&(data))>>8)
+#define VO_V1_GMA_CTRL_get_r_en(data)                                                ((0x00000100&(data))>>8)
+#define VO_V1_GMA_CTRL_g_en_shift                                                    (7)
+#define VO_V1_GMA_CTRL_g_en_mask                                                     (0x00000080)
+#define VO_V1_GMA_CTRL_g_en(data)                                                    (0x00000080&((data)<<7))
+#define VO_V1_GMA_CTRL_g_en_src(data)                                                ((0x00000080&(data))>>7)
+#define VO_V1_GMA_CTRL_get_g_en(data)                                                ((0x00000080&(data))>>7)
+#define VO_V1_GMA_CTRL_b_en_shift                                                    (6)
+#define VO_V1_GMA_CTRL_b_en_mask                                                     (0x00000040)
+#define VO_V1_GMA_CTRL_b_en(data)                                                    (0x00000040&((data)<<6))
+#define VO_V1_GMA_CTRL_b_en_src(data)                                                ((0x00000040&(data))>>6)
+#define VO_V1_GMA_CTRL_get_b_en(data)                                                ((0x00000040&(data))>>6)
+#define VO_V1_GMA_CTRL_m_tab_sel_shift                                               (5)
+#define VO_V1_GMA_CTRL_m_tab_sel_mask                                                (0x00000020)
+#define VO_V1_GMA_CTRL_m_tab_sel(data)                                               (0x00000020&((data)<<5))
+#define VO_V1_GMA_CTRL_m_tab_sel_src(data)                                           ((0x00000020&(data))>>5)
+#define VO_V1_GMA_CTRL_get_m_tab_sel(data)                                           ((0x00000020&(data))>>5)
+#define VO_V1_GMA_CTRL_ax_rw_shift                                                   (3)
+#define VO_V1_GMA_CTRL_ax_rw_mask                                                    (0x00000018)
+#define VO_V1_GMA_CTRL_ax_rw(data)                                                   (0x00000018&((data)<<3))
+#define VO_V1_GMA_CTRL_ax_rw_src(data)                                               ((0x00000018&(data))>>3)
+#define VO_V1_GMA_CTRL_get_ax_rw(data)                                               ((0x00000018&(data))>>3)
+#define VO_V1_GMA_CTRL_ax_ch_shift                                                   (1)
+#define VO_V1_GMA_CTRL_ax_ch_mask                                                    (0x00000006)
+#define VO_V1_GMA_CTRL_ax_ch(data)                                                   (0x00000006&((data)<<1))
+#define VO_V1_GMA_CTRL_ax_ch_src(data)                                               ((0x00000006&(data))>>1)
+#define VO_V1_GMA_CTRL_get_ax_ch(data)                                               ((0x00000006&(data))>>1)
+#define VO_V1_GMA_CTRL_dstat_en_shift                                                (0)
+#define VO_V1_GMA_CTRL_dstat_en_mask                                                 (0x00000001)
+#define VO_V1_GMA_CTRL_dstat_en(data)                                                (0x00000001&((data)<<0))
+#define VO_V1_GMA_CTRL_dstat_en_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_V1_GMA_CTRL_get_dstat_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VO_V1_GMA_STATUS                                                             0x18005430
+#define VO_V1_GMA_STATUS_reg_addr                                                    "0xD8005430"
+#define VO_V1_GMA_STATUS_reg                                                         0xD8005430
+#define set_VO_V1_GMA_STATUS_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_STATUS_reg)=data)
+#define get_VO_V1_GMA_STATUS_reg   (*((volatile unsigned int*) VO_V1_GMA_STATUS_reg))
+#define VO_V1_GMA_STATUS_inst_adr                                                    "0x000C"
+#define VO_V1_GMA_STATUS_inst                                                        0x000C
+#define VO_V1_GMA_STATUS_fifo_empty_shift                                            (2)
+#define VO_V1_GMA_STATUS_fifo_empty_mask                                             (0x00000004)
+#define VO_V1_GMA_STATUS_fifo_empty(data)                                            (0x00000004&((data)<<2))
+#define VO_V1_GMA_STATUS_fifo_empty_src(data)                                        ((0x00000004&(data))>>2)
+#define VO_V1_GMA_STATUS_get_fifo_empty(data)                                        ((0x00000004&(data))>>2)
+#define VO_V1_GMA_STATUS_fifo_full_shift                                             (1)
+#define VO_V1_GMA_STATUS_fifo_full_mask                                              (0x00000002)
+#define VO_V1_GMA_STATUS_fifo_full(data)                                             (0x00000002&((data)<<1))
+#define VO_V1_GMA_STATUS_fifo_full_src(data)                                         ((0x00000002&(data))>>1)
+#define VO_V1_GMA_STATUS_get_fifo_full(data)                                         ((0x00000002&(data))>>1)
+#define VO_V1_GMA_STATUS_wr_error_shift                                              (0)
+#define VO_V1_GMA_STATUS_wr_error_mask                                               (0x00000001)
+#define VO_V1_GMA_STATUS_wr_error(data)                                              (0x00000001&((data)<<0))
+#define VO_V1_GMA_STATUS_wr_error_src(data)                                          ((0x00000001&(data))>>0)
+#define VO_V1_GMA_STATUS_get_wr_error(data)                                          ((0x00000001&(data))>>0)
+
+
+#define VO_V1_GMA_DSTAT_CTRL_R                                                       0x18005434
+#define VO_V1_GMA_DSTAT_CTRL_R_reg_addr                                              "0xD8005434"
+#define VO_V1_GMA_DSTAT_CTRL_R_reg                                                   0xD8005434
+#define set_VO_V1_GMA_DSTAT_CTRL_R_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_CTRL_R_reg)=data)
+#define get_VO_V1_GMA_DSTAT_CTRL_R_reg   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_CTRL_R_reg))
+#define VO_V1_GMA_DSTAT_CTRL_R_inst_adr                                              "0x000D"
+#define VO_V1_GMA_DSTAT_CTRL_R_inst                                                  0x000D
+#define VO_V1_GMA_DSTAT_CTRL_R_low_shift                                             (16)
+#define VO_V1_GMA_DSTAT_CTRL_R_low_mask                                              (0x0FFF0000)
+#define VO_V1_GMA_DSTAT_CTRL_R_low(data)                                             (0x0FFF0000&((data)<<16))
+#define VO_V1_GMA_DSTAT_CTRL_R_low_src(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_CTRL_R_get_low(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_CTRL_R_high_shift                                            (0)
+#define VO_V1_GMA_DSTAT_CTRL_R_high_mask                                             (0x00000FFF)
+#define VO_V1_GMA_DSTAT_CTRL_R_high(data)                                            (0x00000FFF&((data)<<0))
+#define VO_V1_GMA_DSTAT_CTRL_R_high_src(data)                                        ((0x00000FFF&(data))>>0)
+#define VO_V1_GMA_DSTAT_CTRL_R_get_high(data)                                        ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_GMA_DSTAT_CTRL_G                                                       0x18005438
+#define VO_V1_GMA_DSTAT_CTRL_G_reg_addr                                              "0xD8005438"
+#define VO_V1_GMA_DSTAT_CTRL_G_reg                                                   0xD8005438
+#define set_VO_V1_GMA_DSTAT_CTRL_G_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_CTRL_G_reg)=data)
+#define get_VO_V1_GMA_DSTAT_CTRL_G_reg   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_CTRL_G_reg))
+#define VO_V1_GMA_DSTAT_CTRL_G_inst_adr                                              "0x000E"
+#define VO_V1_GMA_DSTAT_CTRL_G_inst                                                  0x000E
+#define VO_V1_GMA_DSTAT_CTRL_G_low_shift                                             (16)
+#define VO_V1_GMA_DSTAT_CTRL_G_low_mask                                              (0x0FFF0000)
+#define VO_V1_GMA_DSTAT_CTRL_G_low(data)                                             (0x0FFF0000&((data)<<16))
+#define VO_V1_GMA_DSTAT_CTRL_G_low_src(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_CTRL_G_get_low(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_CTRL_G_high_shift                                            (0)
+#define VO_V1_GMA_DSTAT_CTRL_G_high_mask                                             (0x00000FFF)
+#define VO_V1_GMA_DSTAT_CTRL_G_high(data)                                            (0x00000FFF&((data)<<0))
+#define VO_V1_GMA_DSTAT_CTRL_G_high_src(data)                                        ((0x00000FFF&(data))>>0)
+#define VO_V1_GMA_DSTAT_CTRL_G_get_high(data)                                        ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_GMA_DSTAT_CTRL_B                                                       0x1800543C
+#define VO_V1_GMA_DSTAT_CTRL_B_reg_addr                                              "0xD800543C"
+#define VO_V1_GMA_DSTAT_CTRL_B_reg                                                   0xD800543C
+#define set_VO_V1_GMA_DSTAT_CTRL_B_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_CTRL_B_reg)=data)
+#define get_VO_V1_GMA_DSTAT_CTRL_B_reg   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_CTRL_B_reg))
+#define VO_V1_GMA_DSTAT_CTRL_B_inst_adr                                              "0x000F"
+#define VO_V1_GMA_DSTAT_CTRL_B_inst                                                  0x000F
+#define VO_V1_GMA_DSTAT_CTRL_B_low_shift                                             (16)
+#define VO_V1_GMA_DSTAT_CTRL_B_low_mask                                              (0x0FFF0000)
+#define VO_V1_GMA_DSTAT_CTRL_B_low(data)                                             (0x0FFF0000&((data)<<16))
+#define VO_V1_GMA_DSTAT_CTRL_B_low_src(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_CTRL_B_get_low(data)                                         ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_CTRL_B_high_shift                                            (0)
+#define VO_V1_GMA_DSTAT_CTRL_B_high_mask                                             (0x00000FFF)
+#define VO_V1_GMA_DSTAT_CTRL_B_high(data)                                            (0x00000FFF&((data)<<0))
+#define VO_V1_GMA_DSTAT_CTRL_B_high_src(data)                                        ((0x00000FFF&(data))>>0)
+#define VO_V1_GMA_DSTAT_CTRL_B_get_high(data)                                        ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_GMA_DSTAT_O_R1                                                         0x18005440
+#define VO_V1_GMA_DSTAT_O_R1_reg_addr                                                "0xD8005440"
+#define VO_V1_GMA_DSTAT_O_R1_reg                                                     0xD8005440
+#define set_VO_V1_GMA_DSTAT_O_R1_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_R1_reg)=data)
+#define get_VO_V1_GMA_DSTAT_O_R1_reg   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_R1_reg))
+#define VO_V1_GMA_DSTAT_O_R1_inst_adr                                                "0x0010"
+#define VO_V1_GMA_DSTAT_O_R1_inst                                                    0x0010
+#define VO_V1_GMA_DSTAT_O_R1_cnt_shift                                               (0)
+#define VO_V1_GMA_DSTAT_O_R1_cnt_mask                                                (0x001FFFFF)
+#define VO_V1_GMA_DSTAT_O_R1_cnt(data)                                               (0x001FFFFF&((data)<<0))
+#define VO_V1_GMA_DSTAT_O_R1_cnt_src(data)                                           ((0x001FFFFF&(data))>>0)
+#define VO_V1_GMA_DSTAT_O_R1_get_cnt(data)                                           ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_GMA_DSTAT_O_R2                                                         0x18005444
+#define VO_V1_GMA_DSTAT_O_R2_reg_addr                                                "0xD8005444"
+#define VO_V1_GMA_DSTAT_O_R2_reg                                                     0xD8005444
+#define set_VO_V1_GMA_DSTAT_O_R2_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_R2_reg)=data)
+#define get_VO_V1_GMA_DSTAT_O_R2_reg   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_R2_reg))
+#define VO_V1_GMA_DSTAT_O_R2_inst_adr                                                "0x0011"
+#define VO_V1_GMA_DSTAT_O_R2_inst                                                    0x0011
+#define VO_V1_GMA_DSTAT_O_R2_min_shift                                               (16)
+#define VO_V1_GMA_DSTAT_O_R2_min_mask                                                (0x0FFF0000)
+#define VO_V1_GMA_DSTAT_O_R2_min(data)                                               (0x0FFF0000&((data)<<16))
+#define VO_V1_GMA_DSTAT_O_R2_min_src(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_O_R2_get_min(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_O_R2_max_shift                                               (0)
+#define VO_V1_GMA_DSTAT_O_R2_max_mask                                                (0x00000FFF)
+#define VO_V1_GMA_DSTAT_O_R2_max(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_GMA_DSTAT_O_R2_max_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_GMA_DSTAT_O_R2_get_max(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_GMA_DSTAT_O_G1                                                         0x18005448
+#define VO_V1_GMA_DSTAT_O_G1_reg_addr                                                "0xD8005448"
+#define VO_V1_GMA_DSTAT_O_G1_reg                                                     0xD8005448
+#define set_VO_V1_GMA_DSTAT_O_G1_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_G1_reg)=data)
+#define get_VO_V1_GMA_DSTAT_O_G1_reg   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_G1_reg))
+#define VO_V1_GMA_DSTAT_O_G1_inst_adr                                                "0x0012"
+#define VO_V1_GMA_DSTAT_O_G1_inst                                                    0x0012
+#define VO_V1_GMA_DSTAT_O_G1_cnt_shift                                               (0)
+#define VO_V1_GMA_DSTAT_O_G1_cnt_mask                                                (0x001FFFFF)
+#define VO_V1_GMA_DSTAT_O_G1_cnt(data)                                               (0x001FFFFF&((data)<<0))
+#define VO_V1_GMA_DSTAT_O_G1_cnt_src(data)                                           ((0x001FFFFF&(data))>>0)
+#define VO_V1_GMA_DSTAT_O_G1_get_cnt(data)                                           ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_GMA_DSTAT_O_G2                                                         0x1800544C
+#define VO_V1_GMA_DSTAT_O_G2_reg_addr                                                "0xD800544C"
+#define VO_V1_GMA_DSTAT_O_G2_reg                                                     0xD800544C
+#define set_VO_V1_GMA_DSTAT_O_G2_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_G2_reg)=data)
+#define get_VO_V1_GMA_DSTAT_O_G2_reg   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_G2_reg))
+#define VO_V1_GMA_DSTAT_O_G2_inst_adr                                                "0x0013"
+#define VO_V1_GMA_DSTAT_O_G2_inst                                                    0x0013
+#define VO_V1_GMA_DSTAT_O_G2_min_shift                                               (16)
+#define VO_V1_GMA_DSTAT_O_G2_min_mask                                                (0x0FFF0000)
+#define VO_V1_GMA_DSTAT_O_G2_min(data)                                               (0x0FFF0000&((data)<<16))
+#define VO_V1_GMA_DSTAT_O_G2_min_src(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_O_G2_get_min(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_O_G2_max_shift                                               (0)
+#define VO_V1_GMA_DSTAT_O_G2_max_mask                                                (0x00000FFF)
+#define VO_V1_GMA_DSTAT_O_G2_max(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_GMA_DSTAT_O_G2_max_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_GMA_DSTAT_O_G2_get_max(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_GMA_DSTAT_O_B1                                                         0x18005450
+#define VO_V1_GMA_DSTAT_O_B1_reg_addr                                                "0xD8005450"
+#define VO_V1_GMA_DSTAT_O_B1_reg                                                     0xD8005450
+#define set_VO_V1_GMA_DSTAT_O_B1_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_B1_reg)=data)
+#define get_VO_V1_GMA_DSTAT_O_B1_reg   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_B1_reg))
+#define VO_V1_GMA_DSTAT_O_B1_inst_adr                                                "0x0014"
+#define VO_V1_GMA_DSTAT_O_B1_inst                                                    0x0014
+#define VO_V1_GMA_DSTAT_O_B1_cnt_shift                                               (0)
+#define VO_V1_GMA_DSTAT_O_B1_cnt_mask                                                (0x001FFFFF)
+#define VO_V1_GMA_DSTAT_O_B1_cnt(data)                                               (0x001FFFFF&((data)<<0))
+#define VO_V1_GMA_DSTAT_O_B1_cnt_src(data)                                           ((0x001FFFFF&(data))>>0)
+#define VO_V1_GMA_DSTAT_O_B1_get_cnt(data)                                           ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_GMA_DSTAT_O_B2                                                         0x18005454
+#define VO_V1_GMA_DSTAT_O_B2_reg_addr                                                "0xD8005454"
+#define VO_V1_GMA_DSTAT_O_B2_reg                                                     0xD8005454
+#define set_VO_V1_GMA_DSTAT_O_B2_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_B2_reg)=data)
+#define get_VO_V1_GMA_DSTAT_O_B2_reg   (*((volatile unsigned int*) VO_V1_GMA_DSTAT_O_B2_reg))
+#define VO_V1_GMA_DSTAT_O_B2_inst_adr                                                "0x0015"
+#define VO_V1_GMA_DSTAT_O_B2_inst                                                    0x0015
+#define VO_V1_GMA_DSTAT_O_B2_min_shift                                               (16)
+#define VO_V1_GMA_DSTAT_O_B2_min_mask                                                (0x0FFF0000)
+#define VO_V1_GMA_DSTAT_O_B2_min(data)                                               (0x0FFF0000&((data)<<16))
+#define VO_V1_GMA_DSTAT_O_B2_min_src(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_O_B2_get_min(data)                                           ((0x0FFF0000&(data))>>16)
+#define VO_V1_GMA_DSTAT_O_B2_max_shift                                               (0)
+#define VO_V1_GMA_DSTAT_O_B2_max_mask                                                (0x00000FFF)
+#define VO_V1_GMA_DSTAT_O_B2_max(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_GMA_DSTAT_O_B2_max_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_GMA_DSTAT_O_B2_get_max(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_GMA_DUMMY_0                                                            0x18005458
+#define VO_V1_GMA_DUMMY_0_reg_addr                                                   "0xD8005458"
+#define VO_V1_GMA_DUMMY_0_reg                                                        0xD8005458
+#define set_VO_V1_GMA_DUMMY_0_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DUMMY_0_reg)=data)
+#define get_VO_V1_GMA_DUMMY_0_reg   (*((volatile unsigned int*) VO_V1_GMA_DUMMY_0_reg))
+#define VO_V1_GMA_DUMMY_0_inst_adr                                                   "0x0016"
+#define VO_V1_GMA_DUMMY_0_inst                                                       0x0016
+#define VO_V1_GMA_DUMMY_0_rvd_shift                                                  (0)
+#define VO_V1_GMA_DUMMY_0_rvd_mask                                                   (0xFFFFFFFF)
+#define VO_V1_GMA_DUMMY_0_rvd(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_GMA_DUMMY_0_rvd_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_GMA_DUMMY_0_get_rvd(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_GMA_DUMMY_1                                                            0x1800545C
+#define VO_V1_GMA_DUMMY_1_reg_addr                                                   "0xD800545C"
+#define VO_V1_GMA_DUMMY_1_reg                                                        0xD800545C
+#define set_VO_V1_GMA_DUMMY_1_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DUMMY_1_reg)=data)
+#define get_VO_V1_GMA_DUMMY_1_reg   (*((volatile unsigned int*) VO_V1_GMA_DUMMY_1_reg))
+#define VO_V1_GMA_DUMMY_1_inst_adr                                                   "0x0017"
+#define VO_V1_GMA_DUMMY_1_inst                                                       0x0017
+#define VO_V1_GMA_DUMMY_1_rvd_shift                                                  (0)
+#define VO_V1_GMA_DUMMY_1_rvd_mask                                                   (0xFFFFFFFF)
+#define VO_V1_GMA_DUMMY_1_rvd(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_GMA_DUMMY_1_rvd_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_GMA_DUMMY_1_get_rvd(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_GMA_DUMMY_2                                                            0x18005460
+#define VO_V1_GMA_DUMMY_2_reg_addr                                                   "0xD8005460"
+#define VO_V1_GMA_DUMMY_2_reg                                                        0xD8005460
+#define set_VO_V1_GMA_DUMMY_2_reg(data)   (*((volatile unsigned int*) VO_V1_GMA_DUMMY_2_reg)=data)
+#define get_VO_V1_GMA_DUMMY_2_reg   (*((volatile unsigned int*) VO_V1_GMA_DUMMY_2_reg))
+#define VO_V1_GMA_DUMMY_2_inst_adr                                                   "0x0018"
+#define VO_V1_GMA_DUMMY_2_inst                                                       0x0018
+#define VO_V1_GMA_DUMMY_2_rvd_shift                                                  (0)
+#define VO_V1_GMA_DUMMY_2_rvd_mask                                                   (0xFFFFFFFF)
+#define VO_V1_GMA_DUMMY_2_rvd(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V1_GMA_DUMMY_2_rvd_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V1_GMA_DUMMY_2_get_rvd(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V1_HDR_Y2R_CC1                                                            0x98005464
+#define VO_V1_HDR_Y2R_CC1_reg_addr                                                   "0xD8005464"
+#define VO_V1_HDR_Y2R_CC1_reg                                                        0xD8005464
+#define set_VO_V1_HDR_Y2R_CC1_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC1_reg)=data)
+#define get_VO_V1_HDR_Y2R_CC1_reg   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC1_reg))
+#define VO_V1_HDR_Y2R_CC1_inst_adr                                                   "0x0019"
+#define VO_V1_HDR_Y2R_CC1_inst                                                       0x0019
+#define VO_V1_HDR_Y2R_CC1_m01_shift                                                  (16)
+#define VO_V1_HDR_Y2R_CC1_m01_mask                                                   (0xFFFF0000)
+#define VO_V1_HDR_Y2R_CC1_m01(data)                                                  (0xFFFF0000&((data)<<16))
+#define VO_V1_HDR_Y2R_CC1_m01_src(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_Y2R_CC1_get_m01(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_Y2R_CC1_m00_shift                                                  (0)
+#define VO_V1_HDR_Y2R_CC1_m00_mask                                                   (0x0000FFFF)
+#define VO_V1_HDR_Y2R_CC1_m00(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_HDR_Y2R_CC1_m00_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_HDR_Y2R_CC1_get_m00(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HDR_Y2R_CC2                                                            0x98005468
+#define VO_V1_HDR_Y2R_CC2_reg_addr                                                   "0xD8005468"
+#define VO_V1_HDR_Y2R_CC2_reg                                                        0xD8005468
+#define set_VO_V1_HDR_Y2R_CC2_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC2_reg)=data)
+#define get_VO_V1_HDR_Y2R_CC2_reg   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC2_reg))
+#define VO_V1_HDR_Y2R_CC2_inst_adr                                                   "0x001A"
+#define VO_V1_HDR_Y2R_CC2_inst                                                       0x001A
+#define VO_V1_HDR_Y2R_CC2_m10_shift                                                  (16)
+#define VO_V1_HDR_Y2R_CC2_m10_mask                                                   (0xFFFF0000)
+#define VO_V1_HDR_Y2R_CC2_m10(data)                                                  (0xFFFF0000&((data)<<16))
+#define VO_V1_HDR_Y2R_CC2_m10_src(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_Y2R_CC2_get_m10(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_Y2R_CC2_m02_shift                                                  (0)
+#define VO_V1_HDR_Y2R_CC2_m02_mask                                                   (0x0000FFFF)
+#define VO_V1_HDR_Y2R_CC2_m02(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_HDR_Y2R_CC2_m02_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_HDR_Y2R_CC2_get_m02(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HDR_Y2R_CC3                                                            0x9800546C
+#define VO_V1_HDR_Y2R_CC3_reg_addr                                                   "0xD800546C"
+#define VO_V1_HDR_Y2R_CC3_reg                                                        0xD800546C
+#define set_VO_V1_HDR_Y2R_CC3_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC3_reg)=data)
+#define get_VO_V1_HDR_Y2R_CC3_reg   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC3_reg))
+#define VO_V1_HDR_Y2R_CC3_inst_adr                                                   "0x001B"
+#define VO_V1_HDR_Y2R_CC3_inst                                                       0x001B
+#define VO_V1_HDR_Y2R_CC3_m12_shift                                                  (16)
+#define VO_V1_HDR_Y2R_CC3_m12_mask                                                   (0xFFFF0000)
+#define VO_V1_HDR_Y2R_CC3_m12(data)                                                  (0xFFFF0000&((data)<<16))
+#define VO_V1_HDR_Y2R_CC3_m12_src(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_Y2R_CC3_get_m12(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_Y2R_CC3_m11_shift                                                  (0)
+#define VO_V1_HDR_Y2R_CC3_m11_mask                                                   (0x0000FFFF)
+#define VO_V1_HDR_Y2R_CC3_m11(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_HDR_Y2R_CC3_m11_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_HDR_Y2R_CC3_get_m11(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HDR_Y2R_CC4                                                            0x98005470
+#define VO_V1_HDR_Y2R_CC4_reg_addr                                                   "0xD8005470"
+#define VO_V1_HDR_Y2R_CC4_reg                                                        0xD8005470
+#define set_VO_V1_HDR_Y2R_CC4_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC4_reg)=data)
+#define get_VO_V1_HDR_Y2R_CC4_reg   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC4_reg))
+#define VO_V1_HDR_Y2R_CC4_inst_adr                                                   "0x001C"
+#define VO_V1_HDR_Y2R_CC4_inst                                                       0x001C
+#define VO_V1_HDR_Y2R_CC4_m21_shift                                                  (16)
+#define VO_V1_HDR_Y2R_CC4_m21_mask                                                   (0xFFFF0000)
+#define VO_V1_HDR_Y2R_CC4_m21(data)                                                  (0xFFFF0000&((data)<<16))
+#define VO_V1_HDR_Y2R_CC4_m21_src(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_Y2R_CC4_get_m21(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_Y2R_CC4_m20_shift                                                  (0)
+#define VO_V1_HDR_Y2R_CC4_m20_mask                                                   (0x0000FFFF)
+#define VO_V1_HDR_Y2R_CC4_m20(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_HDR_Y2R_CC4_m20_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_HDR_Y2R_CC4_get_m20(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HDR_Y2R_CC5                                                            0x98005474
+#define VO_V1_HDR_Y2R_CC5_reg_addr                                                   "0xD8005474"
+#define VO_V1_HDR_Y2R_CC5_reg                                                        0xD8005474
+#define set_VO_V1_HDR_Y2R_CC5_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC5_reg)=data)
+#define get_VO_V1_HDR_Y2R_CC5_reg   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC5_reg))
+#define VO_V1_HDR_Y2R_CC5_inst_adr                                                   "0x001D"
+#define VO_V1_HDR_Y2R_CC5_inst                                                       0x001D
+#define VO_V1_HDR_Y2R_CC5_m22_shift                                                  (0)
+#define VO_V1_HDR_Y2R_CC5_m22_mask                                                   (0x0000FFFF)
+#define VO_V1_HDR_Y2R_CC5_m22(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_HDR_Y2R_CC5_m22_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_HDR_Y2R_CC5_get_m22(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HDR_Y2R_CC6                                                            0x98005478
+#define VO_V1_HDR_Y2R_CC6_reg_addr                                                   "0xD8005478"
+#define VO_V1_HDR_Y2R_CC6_reg                                                        0xD8005478
+#define set_VO_V1_HDR_Y2R_CC6_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC6_reg)=data)
+#define get_VO_V1_HDR_Y2R_CC6_reg   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC6_reg))
+#define VO_V1_HDR_Y2R_CC6_inst_adr                                                   "0x001E"
+#define VO_V1_HDR_Y2R_CC6_inst                                                       0x001E
+#define VO_V1_HDR_Y2R_CC6_a1_shift                                                   (16)
+#define VO_V1_HDR_Y2R_CC6_a1_mask                                                    (0x0FFF0000)
+#define VO_V1_HDR_Y2R_CC6_a1(data)                                                   (0x0FFF0000&((data)<<16))
+#define VO_V1_HDR_Y2R_CC6_a1_src(data)                                               ((0x0FFF0000&(data))>>16)
+#define VO_V1_HDR_Y2R_CC6_get_a1(data)                                               ((0x0FFF0000&(data))>>16)
+#define VO_V1_HDR_Y2R_CC6_a0_shift                                                   (0)
+#define VO_V1_HDR_Y2R_CC6_a0_mask                                                    (0x00000FFF)
+#define VO_V1_HDR_Y2R_CC6_a0(data)                                                   (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_Y2R_CC6_a0_src(data)                                               ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_Y2R_CC6_get_a0(data)                                               ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_HDR_Y2R_CC7                                                            0x9800547C
+#define VO_V1_HDR_Y2R_CC7_reg_addr                                                   "0xD800547C"
+#define VO_V1_HDR_Y2R_CC7_reg                                                        0xD800547C
+#define set_VO_V1_HDR_Y2R_CC7_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC7_reg)=data)
+#define get_VO_V1_HDR_Y2R_CC7_reg   (*((volatile unsigned int*) VO_V1_HDR_Y2R_CC7_reg))
+#define VO_V1_HDR_Y2R_CC7_inst_adr                                                   "0x001F"
+#define VO_V1_HDR_Y2R_CC7_inst                                                       0x001F
+#define VO_V1_HDR_Y2R_CC7_a2_shift                                                   (0)
+#define VO_V1_HDR_Y2R_CC7_a2_mask                                                    (0x00000FFF)
+#define VO_V1_HDR_Y2R_CC7_a2(data)                                                   (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_Y2R_CC7_a2_src(data)                                               ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_Y2R_CC7_get_a2(data)                                               ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_HDR_Y2R_LMT_R                                                          0x98005480
+#define VO_V1_HDR_Y2R_LMT_R_reg_addr                                                 "0xD8005480"
+#define VO_V1_HDR_Y2R_LMT_R_reg                                                      0xD8005480
+#define set_VO_V1_HDR_Y2R_LMT_R_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_Y2R_LMT_R_reg)=data)
+#define get_VO_V1_HDR_Y2R_LMT_R_reg   (*((volatile unsigned int*) VO_V1_HDR_Y2R_LMT_R_reg))
+#define VO_V1_HDR_Y2R_LMT_R_inst_adr                                                 "0x0020"
+#define VO_V1_HDR_Y2R_LMT_R_inst                                                     0x0020
+#define VO_V1_HDR_Y2R_LMT_R_rmax_shift                                               (12)
+#define VO_V1_HDR_Y2R_LMT_R_rmax_mask                                                (0x00FFF000)
+#define VO_V1_HDR_Y2R_LMT_R_rmax(data)                                               (0x00FFF000&((data)<<12))
+#define VO_V1_HDR_Y2R_LMT_R_rmax_src(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_Y2R_LMT_R_get_rmax(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_Y2R_LMT_R_rmin_shift                                               (0)
+#define VO_V1_HDR_Y2R_LMT_R_rmin_mask                                                (0x00000FFF)
+#define VO_V1_HDR_Y2R_LMT_R_rmin(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_Y2R_LMT_R_rmin_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_Y2R_LMT_R_get_rmin(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_HDR_Y2R_LMT_G                                                          0x98005484
+#define VO_V1_HDR_Y2R_LMT_G_reg_addr                                                 "0xD8005484"
+#define VO_V1_HDR_Y2R_LMT_G_reg                                                      0xD8005484
+#define set_VO_V1_HDR_Y2R_LMT_G_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_Y2R_LMT_G_reg)=data)
+#define get_VO_V1_HDR_Y2R_LMT_G_reg   (*((volatile unsigned int*) VO_V1_HDR_Y2R_LMT_G_reg))
+#define VO_V1_HDR_Y2R_LMT_G_inst_adr                                                 "0x0021"
+#define VO_V1_HDR_Y2R_LMT_G_inst                                                     0x0021
+#define VO_V1_HDR_Y2R_LMT_G_gmax_shift                                               (12)
+#define VO_V1_HDR_Y2R_LMT_G_gmax_mask                                                (0x00FFF000)
+#define VO_V1_HDR_Y2R_LMT_G_gmax(data)                                               (0x00FFF000&((data)<<12))
+#define VO_V1_HDR_Y2R_LMT_G_gmax_src(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_Y2R_LMT_G_get_gmax(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_Y2R_LMT_G_gmin_shift                                               (0)
+#define VO_V1_HDR_Y2R_LMT_G_gmin_mask                                                (0x00000FFF)
+#define VO_V1_HDR_Y2R_LMT_G_gmin(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_Y2R_LMT_G_gmin_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_Y2R_LMT_G_get_gmin(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_HDR_Y2R_LMT_B                                                          0x98005488
+#define VO_V1_HDR_Y2R_LMT_B_reg_addr                                                 "0xD8005488"
+#define VO_V1_HDR_Y2R_LMT_B_reg                                                      0xD8005488
+#define set_VO_V1_HDR_Y2R_LMT_B_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_Y2R_LMT_B_reg)=data)
+#define get_VO_V1_HDR_Y2R_LMT_B_reg   (*((volatile unsigned int*) VO_V1_HDR_Y2R_LMT_B_reg))
+#define VO_V1_HDR_Y2R_LMT_B_inst_adr                                                 "0x0022"
+#define VO_V1_HDR_Y2R_LMT_B_inst                                                     0x0022
+#define VO_V1_HDR_Y2R_LMT_B_bmax_shift                                               (12)
+#define VO_V1_HDR_Y2R_LMT_B_bmax_mask                                                (0x00FFF000)
+#define VO_V1_HDR_Y2R_LMT_B_bmax(data)                                               (0x00FFF000&((data)<<12))
+#define VO_V1_HDR_Y2R_LMT_B_bmax_src(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_Y2R_LMT_B_get_bmax(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_Y2R_LMT_B_bmin_shift                                               (0)
+#define VO_V1_HDR_Y2R_LMT_B_bmin_mask                                                (0x00000FFF)
+#define VO_V1_HDR_Y2R_LMT_B_bmin(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_Y2R_LMT_B_bmin_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_Y2R_LMT_B_get_bmin(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_HDR_R2Y_CC1                                                            0x9800548C
+#define VO_V1_HDR_R2Y_CC1_reg_addr                                                   "0xD800548C"
+#define VO_V1_HDR_R2Y_CC1_reg                                                        0xD800548C
+#define set_VO_V1_HDR_R2Y_CC1_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC1_reg)=data)
+#define get_VO_V1_HDR_R2Y_CC1_reg   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC1_reg))
+#define VO_V1_HDR_R2Y_CC1_inst_adr                                                   "0x0023"
+#define VO_V1_HDR_R2Y_CC1_inst                                                       0x0023
+#define VO_V1_HDR_R2Y_CC1_m01_shift                                                  (16)
+#define VO_V1_HDR_R2Y_CC1_m01_mask                                                   (0xFFFF0000)
+#define VO_V1_HDR_R2Y_CC1_m01(data)                                                  (0xFFFF0000&((data)<<16))
+#define VO_V1_HDR_R2Y_CC1_m01_src(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_R2Y_CC1_get_m01(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_R2Y_CC1_m00_shift                                                  (0)
+#define VO_V1_HDR_R2Y_CC1_m00_mask                                                   (0x0000FFFF)
+#define VO_V1_HDR_R2Y_CC1_m00(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_HDR_R2Y_CC1_m00_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_HDR_R2Y_CC1_get_m00(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HDR_R2Y_CC2                                                            0x98005490
+#define VO_V1_HDR_R2Y_CC2_reg_addr                                                   "0xD8005490"
+#define VO_V1_HDR_R2Y_CC2_reg                                                        0xD8005490
+#define set_VO_V1_HDR_R2Y_CC2_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC2_reg)=data)
+#define get_VO_V1_HDR_R2Y_CC2_reg   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC2_reg))
+#define VO_V1_HDR_R2Y_CC2_inst_adr                                                   "0x0024"
+#define VO_V1_HDR_R2Y_CC2_inst                                                       0x0024
+#define VO_V1_HDR_R2Y_CC2_m10_shift                                                  (16)
+#define VO_V1_HDR_R2Y_CC2_m10_mask                                                   (0xFFFF0000)
+#define VO_V1_HDR_R2Y_CC2_m10(data)                                                  (0xFFFF0000&((data)<<16))
+#define VO_V1_HDR_R2Y_CC2_m10_src(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_R2Y_CC2_get_m10(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_R2Y_CC2_m02_shift                                                  (0)
+#define VO_V1_HDR_R2Y_CC2_m02_mask                                                   (0x0000FFFF)
+#define VO_V1_HDR_R2Y_CC2_m02(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_HDR_R2Y_CC2_m02_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_HDR_R2Y_CC2_get_m02(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HDR_R2Y_CC3                                                            0x98005494
+#define VO_V1_HDR_R2Y_CC3_reg_addr                                                   "0xD8005494"
+#define VO_V1_HDR_R2Y_CC3_reg                                                        0xD8005494
+#define set_VO_V1_HDR_R2Y_CC3_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC3_reg)=data)
+#define get_VO_V1_HDR_R2Y_CC3_reg   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC3_reg))
+#define VO_V1_HDR_R2Y_CC3_inst_adr                                                   "0x0025"
+#define VO_V1_HDR_R2Y_CC3_inst                                                       0x0025
+#define VO_V1_HDR_R2Y_CC3_m12_shift                                                  (16)
+#define VO_V1_HDR_R2Y_CC3_m12_mask                                                   (0xFFFF0000)
+#define VO_V1_HDR_R2Y_CC3_m12(data)                                                  (0xFFFF0000&((data)<<16))
+#define VO_V1_HDR_R2Y_CC3_m12_src(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_R2Y_CC3_get_m12(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_R2Y_CC3_m11_shift                                                  (0)
+#define VO_V1_HDR_R2Y_CC3_m11_mask                                                   (0x0000FFFF)
+#define VO_V1_HDR_R2Y_CC3_m11(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_HDR_R2Y_CC3_m11_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_HDR_R2Y_CC3_get_m11(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HDR_R2Y_CC4                                                            0x98005498
+#define VO_V1_HDR_R2Y_CC4_reg_addr                                                   "0xD8005498"
+#define VO_V1_HDR_R2Y_CC4_reg                                                        0xD8005498
+#define set_VO_V1_HDR_R2Y_CC4_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC4_reg)=data)
+#define get_VO_V1_HDR_R2Y_CC4_reg   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC4_reg))
+#define VO_V1_HDR_R2Y_CC4_inst_adr                                                   "0x0026"
+#define VO_V1_HDR_R2Y_CC4_inst                                                       0x0026
+#define VO_V1_HDR_R2Y_CC4_m21_shift                                                  (16)
+#define VO_V1_HDR_R2Y_CC4_m21_mask                                                   (0xFFFF0000)
+#define VO_V1_HDR_R2Y_CC4_m21(data)                                                  (0xFFFF0000&((data)<<16))
+#define VO_V1_HDR_R2Y_CC4_m21_src(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_R2Y_CC4_get_m21(data)                                              ((0xFFFF0000&(data))>>16)
+#define VO_V1_HDR_R2Y_CC4_m20_shift                                                  (0)
+#define VO_V1_HDR_R2Y_CC4_m20_mask                                                   (0x0000FFFF)
+#define VO_V1_HDR_R2Y_CC4_m20(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_HDR_R2Y_CC4_m20_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_HDR_R2Y_CC4_get_m20(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HDR_R2Y_CC5                                                            0x9800549C
+#define VO_V1_HDR_R2Y_CC5_reg_addr                                                   "0xD800549C"
+#define VO_V1_HDR_R2Y_CC5_reg                                                        0xD800549C
+#define set_VO_V1_HDR_R2Y_CC5_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC5_reg)=data)
+#define get_VO_V1_HDR_R2Y_CC5_reg   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC5_reg))
+#define VO_V1_HDR_R2Y_CC5_inst_adr                                                   "0x0027"
+#define VO_V1_HDR_R2Y_CC5_inst                                                       0x0027
+#define VO_V1_HDR_R2Y_CC5_m22_shift                                                  (0)
+#define VO_V1_HDR_R2Y_CC5_m22_mask                                                   (0x0000FFFF)
+#define VO_V1_HDR_R2Y_CC5_m22(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_HDR_R2Y_CC5_m22_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_HDR_R2Y_CC5_get_m22(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HDR_R2Y_CC6                                                            0x980054A0
+#define VO_V1_HDR_R2Y_CC6_reg_addr                                                   "0xD80054A0"
+#define VO_V1_HDR_R2Y_CC6_reg                                                        0xD80054A0
+#define set_VO_V1_HDR_R2Y_CC6_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC6_reg)=data)
+#define get_VO_V1_HDR_R2Y_CC6_reg   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC6_reg))
+#define VO_V1_HDR_R2Y_CC6_inst_adr                                                   "0x0028"
+#define VO_V1_HDR_R2Y_CC6_inst                                                       0x0028
+#define VO_V1_HDR_R2Y_CC6_a1_shift                                                   (16)
+#define VO_V1_HDR_R2Y_CC6_a1_mask                                                    (0x07FF0000)
+#define VO_V1_HDR_R2Y_CC6_a1(data)                                                   (0x07FF0000&((data)<<16))
+#define VO_V1_HDR_R2Y_CC6_a1_src(data)                                               ((0x07FF0000&(data))>>16)
+#define VO_V1_HDR_R2Y_CC6_get_a1(data)                                               ((0x07FF0000&(data))>>16)
+#define VO_V1_HDR_R2Y_CC6_a0_shift                                                   (0)
+#define VO_V1_HDR_R2Y_CC6_a0_mask                                                    (0x000007FF)
+#define VO_V1_HDR_R2Y_CC6_a0(data)                                                   (0x000007FF&((data)<<0))
+#define VO_V1_HDR_R2Y_CC6_a0_src(data)                                               ((0x000007FF&(data))>>0)
+#define VO_V1_HDR_R2Y_CC6_get_a0(data)                                               ((0x000007FF&(data))>>0)
+
+
+#define VO_V1_HDR_R2Y_CC7                                                            0x980054A4
+#define VO_V1_HDR_R2Y_CC7_reg_addr                                                   "0xD80054A4"
+#define VO_V1_HDR_R2Y_CC7_reg                                                        0xD80054A4
+#define set_VO_V1_HDR_R2Y_CC7_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC7_reg)=data)
+#define get_VO_V1_HDR_R2Y_CC7_reg   (*((volatile unsigned int*) VO_V1_HDR_R2Y_CC7_reg))
+#define VO_V1_HDR_R2Y_CC7_inst_adr                                                   "0x0029"
+#define VO_V1_HDR_R2Y_CC7_inst                                                       0x0029
+#define VO_V1_HDR_R2Y_CC7_a2_shift                                                   (0)
+#define VO_V1_HDR_R2Y_CC7_a2_mask                                                    (0x000007FF)
+#define VO_V1_HDR_R2Y_CC7_a2(data)                                                   (0x000007FF&((data)<<0))
+#define VO_V1_HDR_R2Y_CC7_a2_src(data)                                               ((0x000007FF&(data))>>0)
+#define VO_V1_HDR_R2Y_CC7_get_a2(data)                                               ((0x000007FF&(data))>>0)
+
+
+#define VO_V1_HDR_R2Y_LMT_Y                                                          0x980054A8
+#define VO_V1_HDR_R2Y_LMT_Y_reg_addr                                                 "0xD80054A8"
+#define VO_V1_HDR_R2Y_LMT_Y_reg                                                      0xD80054A8
+#define set_VO_V1_HDR_R2Y_LMT_Y_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_R2Y_LMT_Y_reg)=data)
+#define get_VO_V1_HDR_R2Y_LMT_Y_reg   (*((volatile unsigned int*) VO_V1_HDR_R2Y_LMT_Y_reg))
+#define VO_V1_HDR_R2Y_LMT_Y_inst_adr                                                 "0x002A"
+#define VO_V1_HDR_R2Y_LMT_Y_inst                                                     0x002A
+#define VO_V1_HDR_R2Y_LMT_Y_ymax_shift                                               (12)
+#define VO_V1_HDR_R2Y_LMT_Y_ymax_mask                                                (0x00FFF000)
+#define VO_V1_HDR_R2Y_LMT_Y_ymax(data)                                               (0x00FFF000&((data)<<12))
+#define VO_V1_HDR_R2Y_LMT_Y_ymax_src(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_R2Y_LMT_Y_get_ymax(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_R2Y_LMT_Y_ymin_shift                                               (0)
+#define VO_V1_HDR_R2Y_LMT_Y_ymin_mask                                                (0x00000FFF)
+#define VO_V1_HDR_R2Y_LMT_Y_ymin(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_R2Y_LMT_Y_ymin_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_R2Y_LMT_Y_get_ymin(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_HDR_R2Y_LMT_U                                                          0x980054AC
+#define VO_V1_HDR_R2Y_LMT_U_reg_addr                                                 "0xD80054AC"
+#define VO_V1_HDR_R2Y_LMT_U_reg                                                      0xD80054AC
+#define set_VO_V1_HDR_R2Y_LMT_U_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_R2Y_LMT_U_reg)=data)
+#define get_VO_V1_HDR_R2Y_LMT_U_reg   (*((volatile unsigned int*) VO_V1_HDR_R2Y_LMT_U_reg))
+#define VO_V1_HDR_R2Y_LMT_U_inst_adr                                                 "0x002B"
+#define VO_V1_HDR_R2Y_LMT_U_inst                                                     0x002B
+#define VO_V1_HDR_R2Y_LMT_U_umax_shift                                               (12)
+#define VO_V1_HDR_R2Y_LMT_U_umax_mask                                                (0x00FFF000)
+#define VO_V1_HDR_R2Y_LMT_U_umax(data)                                               (0x00FFF000&((data)<<12))
+#define VO_V1_HDR_R2Y_LMT_U_umax_src(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_R2Y_LMT_U_get_umax(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_R2Y_LMT_U_umin_shift                                               (0)
+#define VO_V1_HDR_R2Y_LMT_U_umin_mask                                                (0x00000FFF)
+#define VO_V1_HDR_R2Y_LMT_U_umin(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_R2Y_LMT_U_umin_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_R2Y_LMT_U_get_umin(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_HDR_R2Y_LMT_V                                                          0x980054B0
+#define VO_V1_HDR_R2Y_LMT_V_reg_addr                                                 "0xD80054B0"
+#define VO_V1_HDR_R2Y_LMT_V_reg                                                      0xD80054B0
+#define set_VO_V1_HDR_R2Y_LMT_V_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_R2Y_LMT_V_reg)=data)
+#define get_VO_V1_HDR_R2Y_LMT_V_reg   (*((volatile unsigned int*) VO_V1_HDR_R2Y_LMT_V_reg))
+#define VO_V1_HDR_R2Y_LMT_V_inst_adr                                                 "0x002C"
+#define VO_V1_HDR_R2Y_LMT_V_inst                                                     0x002C
+#define VO_V1_HDR_R2Y_LMT_V_vmax_shift                                               (12)
+#define VO_V1_HDR_R2Y_LMT_V_vmax_mask                                                (0x00FFF000)
+#define VO_V1_HDR_R2Y_LMT_V_vmax(data)                                               (0x00FFF000&((data)<<12))
+#define VO_V1_HDR_R2Y_LMT_V_vmax_src(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_R2Y_LMT_V_get_vmax(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_R2Y_LMT_V_vmin_shift                                               (0)
+#define VO_V1_HDR_R2Y_LMT_V_vmin_mask                                                (0x00000FFF)
+#define VO_V1_HDR_R2Y_LMT_V_vmin(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_R2Y_LMT_V_vmin_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_R2Y_LMT_V_get_vmin(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC1                                                            0x980054B4
+#define VO_V1_HDR_CSC_CC1_reg_addr                                                   "0xD80054B4"
+#define VO_V1_HDR_CSC_CC1_reg                                                        0xD80054B4
+#define set_VO_V1_HDR_CSC_CC1_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC1_reg)=data)
+#define get_VO_V1_HDR_CSC_CC1_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC1_reg))
+#define VO_V1_HDR_CSC_CC1_inst_adr                                                   "0x002D"
+#define VO_V1_HDR_CSC_CC1_inst                                                       0x002D
+#define VO_V1_HDR_CSC_CC1_m00_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC1_m00_mask                                                   (0x001FFFFF)
+#define VO_V1_HDR_CSC_CC1_m00(data)                                                  (0x001FFFFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC1_m00_src(data)                                              ((0x001FFFFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC1_get_m00(data)                                              ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC2                                                            0x980054B8
+#define VO_V1_HDR_CSC_CC2_reg_addr                                                   "0xD80054B8"
+#define VO_V1_HDR_CSC_CC2_reg                                                        0xD80054B8
+#define set_VO_V1_HDR_CSC_CC2_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC2_reg)=data)
+#define get_VO_V1_HDR_CSC_CC2_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC2_reg))
+#define VO_V1_HDR_CSC_CC2_inst_adr                                                   "0x002E"
+#define VO_V1_HDR_CSC_CC2_inst                                                       0x002E
+#define VO_V1_HDR_CSC_CC2_m01_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC2_m01_mask                                                   (0x001FFFFF)
+#define VO_V1_HDR_CSC_CC2_m01(data)                                                  (0x001FFFFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC2_m01_src(data)                                              ((0x001FFFFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC2_get_m01(data)                                              ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC3                                                            0x980054BC
+#define VO_V1_HDR_CSC_CC3_reg_addr                                                   "0xD80054BC"
+#define VO_V1_HDR_CSC_CC3_reg                                                        0xD80054BC
+#define set_VO_V1_HDR_CSC_CC3_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC3_reg)=data)
+#define get_VO_V1_HDR_CSC_CC3_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC3_reg))
+#define VO_V1_HDR_CSC_CC3_inst_adr                                                   "0x002F"
+#define VO_V1_HDR_CSC_CC3_inst                                                       0x002F
+#define VO_V1_HDR_CSC_CC3_m02_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC3_m02_mask                                                   (0x001FFFFF)
+#define VO_V1_HDR_CSC_CC3_m02(data)                                                  (0x001FFFFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC3_m02_src(data)                                              ((0x001FFFFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC3_get_m02(data)                                              ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC4                                                            0x980054C0
+#define VO_V1_HDR_CSC_CC4_reg_addr                                                   "0xD80054C0"
+#define VO_V1_HDR_CSC_CC4_reg                                                        0xD80054C0
+#define set_VO_V1_HDR_CSC_CC4_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC4_reg)=data)
+#define get_VO_V1_HDR_CSC_CC4_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC4_reg))
+#define VO_V1_HDR_CSC_CC4_inst_adr                                                   "0x0030"
+#define VO_V1_HDR_CSC_CC4_inst                                                       0x0030
+#define VO_V1_HDR_CSC_CC4_m10_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC4_m10_mask                                                   (0x001FFFFF)
+#define VO_V1_HDR_CSC_CC4_m10(data)                                                  (0x001FFFFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC4_m10_src(data)                                              ((0x001FFFFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC4_get_m10(data)                                              ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC5                                                            0x980054C4
+#define VO_V1_HDR_CSC_CC5_reg_addr                                                   "0xD80054C4"
+#define VO_V1_HDR_CSC_CC5_reg                                                        0xD80054C4
+#define set_VO_V1_HDR_CSC_CC5_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC5_reg)=data)
+#define get_VO_V1_HDR_CSC_CC5_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC5_reg))
+#define VO_V1_HDR_CSC_CC5_inst_adr                                                   "0x0031"
+#define VO_V1_HDR_CSC_CC5_inst                                                       0x0031
+#define VO_V1_HDR_CSC_CC5_m11_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC5_m11_mask                                                   (0x001FFFFF)
+#define VO_V1_HDR_CSC_CC5_m11(data)                                                  (0x001FFFFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC5_m11_src(data)                                              ((0x001FFFFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC5_get_m11(data)                                              ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC6                                                            0x980054C8
+#define VO_V1_HDR_CSC_CC6_reg_addr                                                   "0xD80054C8"
+#define VO_V1_HDR_CSC_CC6_reg                                                        0xD80054C8
+#define set_VO_V1_HDR_CSC_CC6_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC6_reg)=data)
+#define get_VO_V1_HDR_CSC_CC6_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC6_reg))
+#define VO_V1_HDR_CSC_CC6_inst_adr                                                   "0x0032"
+#define VO_V1_HDR_CSC_CC6_inst                                                       0x0032
+#define VO_V1_HDR_CSC_CC6_m12_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC6_m12_mask                                                   (0x001FFFFF)
+#define VO_V1_HDR_CSC_CC6_m12(data)                                                  (0x001FFFFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC6_m12_src(data)                                              ((0x001FFFFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC6_get_m12(data)                                              ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC7                                                            0x980054CC
+#define VO_V1_HDR_CSC_CC7_reg_addr                                                   "0xD80054CC"
+#define VO_V1_HDR_CSC_CC7_reg                                                        0xD80054CC
+#define set_VO_V1_HDR_CSC_CC7_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC7_reg)=data)
+#define get_VO_V1_HDR_CSC_CC7_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC7_reg))
+#define VO_V1_HDR_CSC_CC7_inst_adr                                                   "0x0033"
+#define VO_V1_HDR_CSC_CC7_inst                                                       0x0033
+#define VO_V1_HDR_CSC_CC7_m20_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC7_m20_mask                                                   (0x001FFFFF)
+#define VO_V1_HDR_CSC_CC7_m20(data)                                                  (0x001FFFFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC7_m20_src(data)                                              ((0x001FFFFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC7_get_m20(data)                                              ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC8                                                            0x980054D0
+#define VO_V1_HDR_CSC_CC8_reg_addr                                                   "0xD80054D0"
+#define VO_V1_HDR_CSC_CC8_reg                                                        0xD80054D0
+#define set_VO_V1_HDR_CSC_CC8_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC8_reg)=data)
+#define get_VO_V1_HDR_CSC_CC8_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC8_reg))
+#define VO_V1_HDR_CSC_CC8_inst_adr                                                   "0x0034"
+#define VO_V1_HDR_CSC_CC8_inst                                                       0x0034
+#define VO_V1_HDR_CSC_CC8_m21_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC8_m21_mask                                                   (0x001FFFFF)
+#define VO_V1_HDR_CSC_CC8_m21(data)                                                  (0x001FFFFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC8_m21_src(data)                                              ((0x001FFFFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC8_get_m21(data)                                              ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC9                                                            0x980054D4
+#define VO_V1_HDR_CSC_CC9_reg_addr                                                   "0xD80054D4"
+#define VO_V1_HDR_CSC_CC9_reg                                                        0xD80054D4
+#define set_VO_V1_HDR_CSC_CC9_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC9_reg)=data)
+#define get_VO_V1_HDR_CSC_CC9_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC9_reg))
+#define VO_V1_HDR_CSC_CC9_inst_adr                                                   "0x0035"
+#define VO_V1_HDR_CSC_CC9_inst                                                       0x0035
+#define VO_V1_HDR_CSC_CC9_m22_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC9_m22_mask                                                   (0x001FFFFF)
+#define VO_V1_HDR_CSC_CC9_m22(data)                                                  (0x001FFFFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC9_m22_src(data)                                              ((0x001FFFFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC9_get_m22(data)                                              ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC10                                                           0x980054D8
+#define VO_V1_HDR_CSC_CC10_reg_addr                                                  "0xD80054D8"
+#define VO_V1_HDR_CSC_CC10_reg                                                       0xD80054D8
+#define set_VO_V1_HDR_CSC_CC10_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC10_reg)=data)
+#define get_VO_V1_HDR_CSC_CC10_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC10_reg))
+#define VO_V1_HDR_CSC_CC10_inst_adr                                                  "0x0036"
+#define VO_V1_HDR_CSC_CC10_inst                                                      0x0036
+#define VO_V1_HDR_CSC_CC10_a1_shift                                                  (16)
+#define VO_V1_HDR_CSC_CC10_a1_mask                                                   (0x3FFF0000)
+#define VO_V1_HDR_CSC_CC10_a1(data)                                                  (0x3FFF0000&((data)<<16))
+#define VO_V1_HDR_CSC_CC10_a1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define VO_V1_HDR_CSC_CC10_get_a1(data)                                              ((0x3FFF0000&(data))>>16)
+#define VO_V1_HDR_CSC_CC10_a0_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC10_a0_mask                                                   (0x00003FFF)
+#define VO_V1_HDR_CSC_CC10_a0(data)                                                  (0x00003FFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC10_a0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC10_get_a0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_CC11                                                           0x980054DC
+#define VO_V1_HDR_CSC_CC11_reg_addr                                                  "0xD80054DC"
+#define VO_V1_HDR_CSC_CC11_reg                                                       0xD80054DC
+#define set_VO_V1_HDR_CSC_CC11_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC11_reg)=data)
+#define get_VO_V1_HDR_CSC_CC11_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_CC11_reg))
+#define VO_V1_HDR_CSC_CC11_inst_adr                                                  "0x0037"
+#define VO_V1_HDR_CSC_CC11_inst                                                      0x0037
+#define VO_V1_HDR_CSC_CC11_a2_shift                                                  (0)
+#define VO_V1_HDR_CSC_CC11_a2_mask                                                   (0x00003FFF)
+#define VO_V1_HDR_CSC_CC11_a2(data)                                                  (0x00003FFF&((data)<<0))
+#define VO_V1_HDR_CSC_CC11_a2_src(data)                                              ((0x00003FFF&(data))>>0)
+#define VO_V1_HDR_CSC_CC11_get_a2(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_LMT_R                                                          0x980054E0
+#define VO_V1_HDR_CSC_LMT_R_reg_addr                                                 "0xD80054E0"
+#define VO_V1_HDR_CSC_LMT_R_reg                                                      0xD80054E0
+#define set_VO_V1_HDR_CSC_LMT_R_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_LMT_R_reg)=data)
+#define get_VO_V1_HDR_CSC_LMT_R_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_LMT_R_reg))
+#define VO_V1_HDR_CSC_LMT_R_inst_adr                                                 "0x0038"
+#define VO_V1_HDR_CSC_LMT_R_inst                                                     0x0038
+#define VO_V1_HDR_CSC_LMT_R_rmax_shift                                               (12)
+#define VO_V1_HDR_CSC_LMT_R_rmax_mask                                                (0x00FFF000)
+#define VO_V1_HDR_CSC_LMT_R_rmax(data)                                               (0x00FFF000&((data)<<12))
+#define VO_V1_HDR_CSC_LMT_R_rmax_src(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_CSC_LMT_R_get_rmax(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_CSC_LMT_R_rmin_shift                                               (0)
+#define VO_V1_HDR_CSC_LMT_R_rmin_mask                                                (0x00000FFF)
+#define VO_V1_HDR_CSC_LMT_R_rmin(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_CSC_LMT_R_rmin_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_CSC_LMT_R_get_rmin(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_LMT_G                                                          0x980054E4
+#define VO_V1_HDR_CSC_LMT_G_reg_addr                                                 "0xD80054E4"
+#define VO_V1_HDR_CSC_LMT_G_reg                                                      0xD80054E4
+#define set_VO_V1_HDR_CSC_LMT_G_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_LMT_G_reg)=data)
+#define get_VO_V1_HDR_CSC_LMT_G_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_LMT_G_reg))
+#define VO_V1_HDR_CSC_LMT_G_inst_adr                                                 "0x0039"
+#define VO_V1_HDR_CSC_LMT_G_inst                                                     0x0039
+#define VO_V1_HDR_CSC_LMT_G_gmax_shift                                               (12)
+#define VO_V1_HDR_CSC_LMT_G_gmax_mask                                                (0x00FFF000)
+#define VO_V1_HDR_CSC_LMT_G_gmax(data)                                               (0x00FFF000&((data)<<12))
+#define VO_V1_HDR_CSC_LMT_G_gmax_src(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_CSC_LMT_G_get_gmax(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_CSC_LMT_G_gmin_shift                                               (0)
+#define VO_V1_HDR_CSC_LMT_G_gmin_mask                                                (0x00000FFF)
+#define VO_V1_HDR_CSC_LMT_G_gmin(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_CSC_LMT_G_gmin_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_CSC_LMT_G_get_gmin(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_HDR_CSC_LMT_B                                                          0x980054E8
+#define VO_V1_HDR_CSC_LMT_B_reg_addr                                                 "0xD80054E8"
+#define VO_V1_HDR_CSC_LMT_B_reg                                                      0xD80054E8
+#define set_VO_V1_HDR_CSC_LMT_B_reg(data)   (*((volatile unsigned int*) VO_V1_HDR_CSC_LMT_B_reg)=data)
+#define get_VO_V1_HDR_CSC_LMT_B_reg   (*((volatile unsigned int*) VO_V1_HDR_CSC_LMT_B_reg))
+#define VO_V1_HDR_CSC_LMT_B_inst_adr                                                 "0x003A"
+#define VO_V1_HDR_CSC_LMT_B_inst                                                     0x003A
+#define VO_V1_HDR_CSC_LMT_B_bmax_shift                                               (12)
+#define VO_V1_HDR_CSC_LMT_B_bmax_mask                                                (0x00FFF000)
+#define VO_V1_HDR_CSC_LMT_B_bmax(data)                                               (0x00FFF000&((data)<<12))
+#define VO_V1_HDR_CSC_LMT_B_bmax_src(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_CSC_LMT_B_get_bmax(data)                                           ((0x00FFF000&(data))>>12)
+#define VO_V1_HDR_CSC_LMT_B_bmin_shift                                               (0)
+#define VO_V1_HDR_CSC_LMT_B_bmin_mask                                                (0x00000FFF)
+#define VO_V1_HDR_CSC_LMT_B_bmin(data)                                               (0x00000FFF&((data)<<0))
+#define VO_V1_HDR_CSC_LMT_B_bmin_src(data)                                           ((0x00000FFF&(data))>>0)
+#define VO_V1_HDR_CSC_LMT_B_get_bmin(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define VO_V2                                                                        0x980054EC
+#define VO_V2_reg_addr                                                               "0xD80054EC"
+#define VO_V2_reg                                                                    0xD80054EC
+#define set_VO_V2_reg(data)   (*((volatile unsigned int*) VO_V2_reg)=data)
+#define get_VO_V2_reg   (*((volatile unsigned int*) VO_V2_reg))
+#define VO_V2_inst_adr                                                               "0x003B"
+#define VO_V2_inst                                                                   0x003B
+#define VO_V2_ve_fmt_shift                                                           (25)
+#define VO_V2_ve_fmt_mask                                                            (0x02000000)
+#define VO_V2_ve_fmt(data)                                                           (0x02000000&((data)<<25))
+#define VO_V2_ve_fmt_src(data)                                                       ((0x02000000&(data))>>25)
+#define VO_V2_get_ve_fmt(data)                                                       ((0x02000000&(data))>>25)
+#define VO_V2_source_shift                                                           (24)
+#define VO_V2_source_mask                                                            (0x01000000)
+#define VO_V2_source(data)                                                           (0x01000000&((data)<<24))
+#define VO_V2_source_src(data)                                                       ((0x01000000&(data))>>24)
+#define VO_V2_get_source(data)                                                       ((0x01000000&(data))>>24)
+#define VO_V2_nv21_shift                                                             (23)
+#define VO_V2_nv21_mask                                                              (0x00800000)
+#define VO_V2_nv21(data)                                                             (0x00800000&((data)<<23))
+#define VO_V2_nv21_src(data)                                                         ((0x00800000&(data))>>23)
+#define VO_V2_get_nv21(data)                                                         ((0x00800000&(data))>>23)
+#define VO_V2_mode_10b_shift                                                         (22)
+#define VO_V2_mode_10b_mask                                                          (0x00400000)
+#define VO_V2_mode_10b(data)                                                         (0x00400000&((data)<<22))
+#define VO_V2_mode_10b_src(data)                                                     ((0x00400000&(data))>>22)
+#define VO_V2_get_mode_10b(data)                                                     ((0x00400000&(data))>>22)
+#define VO_V2_ppc10b_shift                                                           (21)
+#define VO_V2_ppc10b_mask                                                            (0x00200000)
+#define VO_V2_ppc10b(data)                                                           (0x00200000&((data)<<21))
+#define VO_V2_ppc10b_src(data)                                                       ((0x00200000&(data))>>21)
+#define VO_V2_get_ppc10b(data)                                                       ((0x00200000&(data))>>21)
+#define VO_V2_finish_mode_shift                                                      (20)
+#define VO_V2_finish_mode_mask                                                       (0x00100000)
+#define VO_V2_finish_mode(data)                                                      (0x00100000&((data)<<20))
+#define VO_V2_finish_mode_src(data)                                                  ((0x00100000&(data))>>20)
+#define VO_V2_get_finish_mode(data)                                                  ((0x00100000&(data))>>20)
+#define VO_V2_d3_dbh_shift                                                           (19)
+#define VO_V2_d3_dbh_mask                                                            (0x00080000)
+#define VO_V2_d3_dbh(data)                                                           (0x00080000&((data)<<19))
+#define VO_V2_d3_dbh_src(data)                                                       ((0x00080000&(data))>>19)
+#define VO_V2_get_d3_dbh(data)                                                       ((0x00080000&(data))>>19)
+#define VO_V2_d3_dbw_shift                                                           (18)
+#define VO_V2_d3_dbw_mask                                                            (0x00040000)
+#define VO_V2_d3_dbw(data)                                                           (0x00040000&((data)<<18))
+#define VO_V2_d3_dbw_src(data)                                                       ((0x00040000&(data))>>18)
+#define VO_V2_get_d3_dbw(data)                                                       ((0x00040000&(data))>>18)
+#define VO_V2_d3_dup_shift                                                           (17)
+#define VO_V2_d3_dup_mask                                                            (0x00020000)
+#define VO_V2_d3_dup(data)                                                           (0x00020000&((data)<<17))
+#define VO_V2_d3_dup_src(data)                                                       ((0x00020000&(data))>>17)
+#define VO_V2_get_d3_dup(data)                                                       ((0x00020000&(data))>>17)
+#define VO_V2_st_shift                                                               (15)
+#define VO_V2_st_mask                                                                (0x00008000)
+#define VO_V2_st(data)                                                               (0x00008000&((data)<<15))
+#define VO_V2_st_src(data)                                                           ((0x00008000&(data))>>15)
+#define VO_V2_get_st(data)                                                           ((0x00008000&(data))>>15)
+#define VO_V2_shp_shift                                                              (13)
+#define VO_V2_shp_mask                                                               (0x00002000)
+#define VO_V2_shp(data)                                                              (0x00002000&((data)<<13))
+#define VO_V2_shp_src(data)                                                          ((0x00002000&(data))>>13)
+#define VO_V2_get_shp(data)                                                          ((0x00002000&(data))>>13)
+#define VO_V2_seq_shift                                                              (12)
+#define VO_V2_seq_mask                                                               (0x00001000)
+#define VO_V2_seq(data)                                                              (0x00001000&((data)<<12))
+#define VO_V2_seq_src(data)                                                          ((0x00001000&(data))>>12)
+#define VO_V2_get_seq(data)                                                          ((0x00001000&(data))>>12)
+#define VO_V2_di_shift                                                               (11)
+#define VO_V2_di_mask                                                                (0x00000800)
+#define VO_V2_di(data)                                                               (0x00000800&((data)<<11))
+#define VO_V2_di_src(data)                                                           ((0x00000800&(data))>>11)
+#define VO_V2_get_di(data)                                                           ((0x00000800&(data))>>11)
+#define VO_V2_f422_shift                                                             (10)
+#define VO_V2_f422_mask                                                              (0x00000400)
+#define VO_V2_f422(data)                                                             (0x00000400&((data)<<10))
+#define VO_V2_f422_src(data)                                                         ((0x00000400&(data))>>10)
+#define VO_V2_get_f422(data)                                                         ((0x00000400&(data))>>10)
+#define VO_V2_vs_shift                                                               (9)
+#define VO_V2_vs_mask                                                                (0x00000200)
+#define VO_V2_vs(data)                                                               (0x00000200&((data)<<9))
+#define VO_V2_vs_src(data)                                                           ((0x00000200&(data))>>9)
+#define VO_V2_get_vs(data)                                                           ((0x00000200&(data))>>9)
+#define VO_V2_vs_near_shift                                                          (8)
+#define VO_V2_vs_near_mask                                                           (0x00000100)
+#define VO_V2_vs_near(data)                                                          (0x00000100&((data)<<8))
+#define VO_V2_vs_near_src(data)                                                      ((0x00000100&(data))>>8)
+#define VO_V2_get_vs_near(data)                                                      ((0x00000100&(data))>>8)
+#define VO_V2_vs_yodd_shift                                                          (7)
+#define VO_V2_vs_yodd_mask                                                           (0x00000080)
+#define VO_V2_vs_yodd(data)                                                          (0x00000080&((data)<<7))
+#define VO_V2_vs_yodd_src(data)                                                      ((0x00000080&(data))>>7)
+#define VO_V2_get_vs_yodd(data)                                                      ((0x00000080&(data))>>7)
+#define VO_V2_vs_codd_shift                                                          (6)
+#define VO_V2_vs_codd_mask                                                           (0x00000040)
+#define VO_V2_vs_codd(data)                                                          (0x00000040&((data)<<6))
+#define VO_V2_vs_codd_src(data)                                                      ((0x00000040&(data))>>6)
+#define VO_V2_get_vs_codd(data)                                                      ((0x00000040&(data))>>6)
+#define VO_V2_hs_shift                                                               (5)
+#define VO_V2_hs_mask                                                                (0x00000020)
+#define VO_V2_hs(data)                                                               (0x00000020&((data)<<5))
+#define VO_V2_hs_src(data)                                                           ((0x00000020&(data))>>5)
+#define VO_V2_get_hs(data)                                                           ((0x00000020&(data))>>5)
+#define VO_V2_hs_yodd_shift                                                          (4)
+#define VO_V2_hs_yodd_mask                                                           (0x00000010)
+#define VO_V2_hs_yodd(data)                                                          (0x00000010&((data)<<4))
+#define VO_V2_hs_yodd_src(data)                                                      ((0x00000010&(data))>>4)
+#define VO_V2_get_hs_yodd(data)                                                      ((0x00000010&(data))>>4)
+#define VO_V2_hs_codd_shift                                                          (3)
+#define VO_V2_hs_codd_mask                                                           (0x00000008)
+#define VO_V2_hs_codd(data)                                                          (0x00000008&((data)<<3))
+#define VO_V2_hs_codd_src(data)                                                      ((0x00000008&(data))>>3)
+#define VO_V2_get_hs_codd(data)                                                      ((0x00000008&(data))>>3)
+#define VO_V2_topfield_shift                                                         (2)
+#define VO_V2_topfield_mask                                                          (0x00000004)
+#define VO_V2_topfield(data)                                                         (0x00000004&((data)<<2))
+#define VO_V2_topfield_src(data)                                                     ((0x00000004&(data))>>2)
+#define VO_V2_get_topfield(data)                                                     ((0x00000004&(data))>>2)
+#define VO_V2_dmaweave_shift                                                         (1)
+#define VO_V2_dmaweave_mask                                                          (0x00000002)
+#define VO_V2_dmaweave(data)                                                         (0x00000002&((data)<<1))
+#define VO_V2_dmaweave_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_V2_get_dmaweave(data)                                                     ((0x00000002&(data))>>1)
+#define VO_V2_write_data_shift                                                       (0)
+#define VO_V2_write_data_mask                                                        (0x00000001)
+#define VO_V2_write_data(data)                                                       (0x00000001&((data)<<0))
+#define VO_V2_write_data_src(data)                                                   ((0x00000001&(data))>>0)
+#define VO_V2_get_write_data(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define VO_V2_DMA                                                                    0x980054F0
+#define VO_V2_DMA_reg_addr                                                           "0xD80054F0"
+#define VO_V2_DMA_reg                                                                0xD80054F0
+#define set_VO_V2_DMA_reg(data)   (*((volatile unsigned int*) VO_V2_DMA_reg)=data)
+#define get_VO_V2_DMA_reg   (*((volatile unsigned int*) VO_V2_DMA_reg))
+#define VO_V2_DMA_inst_adr                                                           "0x003C"
+#define VO_V2_DMA_inst                                                               0x003C
+#define VO_V2_DMA_w_l_shift                                                          (16)
+#define VO_V2_DMA_w_l_mask                                                           (0x003F0000)
+#define VO_V2_DMA_w_l(data)                                                          (0x003F0000&((data)<<16))
+#define VO_V2_DMA_w_l_src(data)                                                      ((0x003F0000&(data))>>16)
+#define VO_V2_DMA_get_w_l(data)                                                      ((0x003F0000&(data))>>16)
+#define VO_V2_DMA_l_shift                                                            (0)
+#define VO_V2_DMA_l_mask                                                             (0x0000007F)
+#define VO_V2_DMA_l(data)                                                            (0x0000007F&((data)<<0))
+#define VO_V2_DMA_l_src(data)                                                        ((0x0000007F&(data))>>0)
+#define VO_V2_DMA_get_l(data)                                                        ((0x0000007F&(data))>>0)
+
+
+#define VO_V2_SEQ_SA_W_Y                                                             0x980054F4
+#define VO_V2_SEQ_SA_W_Y_reg_addr                                                    "0xD80054F4"
+#define VO_V2_SEQ_SA_W_Y_reg                                                         0xD80054F4
+#define set_VO_V2_SEQ_SA_W_Y_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_SA_W_Y_reg)=data)
+#define get_VO_V2_SEQ_SA_W_Y_reg   (*((volatile unsigned int*) VO_V2_SEQ_SA_W_Y_reg))
+#define VO_V2_SEQ_SA_W_Y_inst_adr                                                    "0x003D"
+#define VO_V2_SEQ_SA_W_Y_inst                                                        0x003D
+#define VO_V2_SEQ_SA_W_Y_a_shift                                                     (0)
+#define VO_V2_SEQ_SA_W_Y_a_mask                                                      (0xFFFFFFFF)
+#define VO_V2_SEQ_SA_W_Y_a(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define VO_V2_SEQ_SA_W_Y_a_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_SEQ_SA_W_Y_get_a(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_SA_W_C                                                             0x980054F8
+#define VO_V2_SEQ_SA_W_C_reg_addr                                                    "0xD80054F8"
+#define VO_V2_SEQ_SA_W_C_reg                                                         0xD80054F8
+#define set_VO_V2_SEQ_SA_W_C_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_SA_W_C_reg)=data)
+#define get_VO_V2_SEQ_SA_W_C_reg   (*((volatile unsigned int*) VO_V2_SEQ_SA_W_C_reg))
+#define VO_V2_SEQ_SA_W_C_inst_adr                                                    "0x003E"
+#define VO_V2_SEQ_SA_W_C_inst                                                        0x003E
+#define VO_V2_SEQ_SA_W_C_a_shift                                                     (0)
+#define VO_V2_SEQ_SA_W_C_a_mask                                                      (0xFFFFFFFF)
+#define VO_V2_SEQ_SA_W_C_a(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define VO_V2_SEQ_SA_W_C_a_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_SEQ_SA_W_C_get_a(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_SA_C_Y                                                             0x980054FC
+#define VO_V2_SEQ_SA_C_Y_reg_addr                                                    "0xD80054FC"
+#define VO_V2_SEQ_SA_C_Y_reg                                                         0xD80054FC
+#define set_VO_V2_SEQ_SA_C_Y_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_SA_C_Y_reg)=data)
+#define get_VO_V2_SEQ_SA_C_Y_reg   (*((volatile unsigned int*) VO_V2_SEQ_SA_C_Y_reg))
+#define VO_V2_SEQ_SA_C_Y_inst_adr                                                    "0x003F"
+#define VO_V2_SEQ_SA_C_Y_inst                                                        0x003F
+#define VO_V2_SEQ_SA_C_Y_a_shift                                                     (0)
+#define VO_V2_SEQ_SA_C_Y_a_mask                                                      (0xFFFFFFFF)
+#define VO_V2_SEQ_SA_C_Y_a(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define VO_V2_SEQ_SA_C_Y_a_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_SEQ_SA_C_Y_get_a(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_SA_C_C                                                             0x98005500
+#define VO_V2_SEQ_SA_C_C_reg_addr                                                    "0xD8005500"
+#define VO_V2_SEQ_SA_C_C_reg                                                         0xD8005500
+#define set_VO_V2_SEQ_SA_C_C_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_SA_C_C_reg)=data)
+#define get_VO_V2_SEQ_SA_C_C_reg   (*((volatile unsigned int*) VO_V2_SEQ_SA_C_C_reg))
+#define VO_V2_SEQ_SA_C_C_inst_adr                                                    "0x0040"
+#define VO_V2_SEQ_SA_C_C_inst                                                        0x0040
+#define VO_V2_SEQ_SA_C_C_a_shift                                                     (0)
+#define VO_V2_SEQ_SA_C_C_a_mask                                                      (0xFFFFFFFF)
+#define VO_V2_SEQ_SA_C_C_a(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define VO_V2_SEQ_SA_C_C_a_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_SEQ_SA_C_C_get_a(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_PITCH_W_Y                                                          0x98005504
+#define VO_V2_SEQ_PITCH_W_Y_reg_addr                                                 "0xD8005504"
+#define VO_V2_SEQ_PITCH_W_Y_reg                                                      0xD8005504
+#define set_VO_V2_SEQ_PITCH_W_Y_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_W_Y_reg)=data)
+#define get_VO_V2_SEQ_PITCH_W_Y_reg   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_W_Y_reg))
+#define VO_V2_SEQ_PITCH_W_Y_inst_adr                                                 "0x0041"
+#define VO_V2_SEQ_PITCH_W_Y_inst                                                     0x0041
+#define VO_V2_SEQ_PITCH_W_Y_p_shift                                                  (0)
+#define VO_V2_SEQ_PITCH_W_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V2_SEQ_PITCH_W_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V2_SEQ_PITCH_W_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V2_SEQ_PITCH_W_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_PITCH_W_C                                                          0x98005508
+#define VO_V2_SEQ_PITCH_W_C_reg_addr                                                 "0xD8005508"
+#define VO_V2_SEQ_PITCH_W_C_reg                                                      0xD8005508
+#define set_VO_V2_SEQ_PITCH_W_C_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_W_C_reg)=data)
+#define get_VO_V2_SEQ_PITCH_W_C_reg   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_W_C_reg))
+#define VO_V2_SEQ_PITCH_W_C_inst_adr                                                 "0x0042"
+#define VO_V2_SEQ_PITCH_W_C_inst                                                     0x0042
+#define VO_V2_SEQ_PITCH_W_C_p_shift                                                  (0)
+#define VO_V2_SEQ_PITCH_W_C_p_mask                                                   (0x0000FFFF)
+#define VO_V2_SEQ_PITCH_W_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V2_SEQ_PITCH_W_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V2_SEQ_PITCH_W_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_PITCH_C_Y                                                          0x9800550C
+#define VO_V2_SEQ_PITCH_C_Y_reg_addr                                                 "0xD800550C"
+#define VO_V2_SEQ_PITCH_C_Y_reg                                                      0xD800550C
+#define set_VO_V2_SEQ_PITCH_C_Y_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_C_Y_reg)=data)
+#define get_VO_V2_SEQ_PITCH_C_Y_reg   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_C_Y_reg))
+#define VO_V2_SEQ_PITCH_C_Y_inst_adr                                                 "0x0043"
+#define VO_V2_SEQ_PITCH_C_Y_inst                                                     0x0043
+#define VO_V2_SEQ_PITCH_C_Y_p_shift                                                  (0)
+#define VO_V2_SEQ_PITCH_C_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V2_SEQ_PITCH_C_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V2_SEQ_PITCH_C_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V2_SEQ_PITCH_C_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_PITCH_C_C                                                          0x98005510
+#define VO_V2_SEQ_PITCH_C_C_reg_addr                                                 "0xD8005510"
+#define VO_V2_SEQ_PITCH_C_C_reg                                                      0xD8005510
+#define set_VO_V2_SEQ_PITCH_C_C_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_C_C_reg)=data)
+#define get_VO_V2_SEQ_PITCH_C_C_reg   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_C_C_reg))
+#define VO_V2_SEQ_PITCH_C_C_inst_adr                                                 "0x0044"
+#define VO_V2_SEQ_PITCH_C_C_inst                                                     0x0044
+#define VO_V2_SEQ_PITCH_C_C_p_shift                                                  (0)
+#define VO_V2_SEQ_PITCH_C_C_p_mask                                                   (0x0000FFFF)
+#define VO_V2_SEQ_PITCH_C_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V2_SEQ_PITCH_C_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V2_SEQ_PITCH_C_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_SA_W_Y_3D                                                          0x98005514
+#define VO_V2_SEQ_SA_W_Y_3D_reg_addr                                                 "0xD8005514"
+#define VO_V2_SEQ_SA_W_Y_3D_reg                                                      0xD8005514
+#define set_VO_V2_SEQ_SA_W_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_SA_W_Y_3D_reg)=data)
+#define get_VO_V2_SEQ_SA_W_Y_3D_reg   (*((volatile unsigned int*) VO_V2_SEQ_SA_W_Y_3D_reg))
+#define VO_V2_SEQ_SA_W_Y_3D_inst_adr                                                 "0x0045"
+#define VO_V2_SEQ_SA_W_Y_3D_inst                                                     0x0045
+#define VO_V2_SEQ_SA_W_Y_3D_a_shift                                                  (0)
+#define VO_V2_SEQ_SA_W_Y_3D_a_mask                                                   (0xFFFFFFFF)
+#define VO_V2_SEQ_SA_W_Y_3D_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V2_SEQ_SA_W_Y_3D_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_SEQ_SA_W_Y_3D_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_SA_W_C_3D                                                          0x98005518
+#define VO_V2_SEQ_SA_W_C_3D_reg_addr                                                 "0xD8005518"
+#define VO_V2_SEQ_SA_W_C_3D_reg                                                      0xD8005518
+#define set_VO_V2_SEQ_SA_W_C_3D_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_SA_W_C_3D_reg)=data)
+#define get_VO_V2_SEQ_SA_W_C_3D_reg   (*((volatile unsigned int*) VO_V2_SEQ_SA_W_C_3D_reg))
+#define VO_V2_SEQ_SA_W_C_3D_inst_adr                                                 "0x0046"
+#define VO_V2_SEQ_SA_W_C_3D_inst                                                     0x0046
+#define VO_V2_SEQ_SA_W_C_3D_a_shift                                                  (0)
+#define VO_V2_SEQ_SA_W_C_3D_a_mask                                                   (0xFFFFFFFF)
+#define VO_V2_SEQ_SA_W_C_3D_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V2_SEQ_SA_W_C_3D_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_SEQ_SA_W_C_3D_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_SA_C_Y_3D                                                          0x9800551C
+#define VO_V2_SEQ_SA_C_Y_3D_reg_addr                                                 "0xD800551C"
+#define VO_V2_SEQ_SA_C_Y_3D_reg                                                      0xD800551C
+#define set_VO_V2_SEQ_SA_C_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_SA_C_Y_3D_reg)=data)
+#define get_VO_V2_SEQ_SA_C_Y_3D_reg   (*((volatile unsigned int*) VO_V2_SEQ_SA_C_Y_3D_reg))
+#define VO_V2_SEQ_SA_C_Y_3D_inst_adr                                                 "0x0047"
+#define VO_V2_SEQ_SA_C_Y_3D_inst                                                     0x0047
+#define VO_V2_SEQ_SA_C_Y_3D_a_shift                                                  (0)
+#define VO_V2_SEQ_SA_C_Y_3D_a_mask                                                   (0xFFFFFFFF)
+#define VO_V2_SEQ_SA_C_Y_3D_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V2_SEQ_SA_C_Y_3D_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_SEQ_SA_C_Y_3D_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_SA_C_C_3D                                                          0x98005520
+#define VO_V2_SEQ_SA_C_C_3D_reg_addr                                                 "0xD8005520"
+#define VO_V2_SEQ_SA_C_C_3D_reg                                                      0xD8005520
+#define set_VO_V2_SEQ_SA_C_C_3D_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_SA_C_C_3D_reg)=data)
+#define get_VO_V2_SEQ_SA_C_C_3D_reg   (*((volatile unsigned int*) VO_V2_SEQ_SA_C_C_3D_reg))
+#define VO_V2_SEQ_SA_C_C_3D_inst_adr                                                 "0x0048"
+#define VO_V2_SEQ_SA_C_C_3D_inst                                                     0x0048
+#define VO_V2_SEQ_SA_C_C_3D_a_shift                                                  (0)
+#define VO_V2_SEQ_SA_C_C_3D_a_mask                                                   (0xFFFFFFFF)
+#define VO_V2_SEQ_SA_C_C_3D_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V2_SEQ_SA_C_C_3D_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_SEQ_SA_C_C_3D_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_INDEX_RR                                                               0x98005524
+#define VO_V2_INDEX_RR_reg_addr                                                      "0xD8005524"
+#define VO_V2_INDEX_RR_reg                                                           0xD8005524
+#define set_VO_V2_INDEX_RR_reg(data)   (*((volatile unsigned int*) VO_V2_INDEX_RR_reg)=data)
+#define get_VO_V2_INDEX_RR_reg   (*((volatile unsigned int*) VO_V2_INDEX_RR_reg))
+#define VO_V2_INDEX_RR_inst_adr                                                      "0x0049"
+#define VO_V2_INDEX_RR_inst                                                          0x0049
+#define VO_V2_INDEX_RR_w_c_en_shift                                                  (15)
+#define VO_V2_INDEX_RR_w_c_en_mask                                                   (0x00008000)
+#define VO_V2_INDEX_RR_w_c_en(data)                                                  (0x00008000&((data)<<15))
+#define VO_V2_INDEX_RR_w_c_en_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_V2_INDEX_RR_get_w_c_en(data)                                              ((0x00008000&(data))>>15)
+#define VO_V2_INDEX_RR_w_c_shift                                                     (12)
+#define VO_V2_INDEX_RR_w_c_mask                                                      (0x00007000)
+#define VO_V2_INDEX_RR_w_c(data)                                                     (0x00007000&((data)<<12))
+#define VO_V2_INDEX_RR_w_c_src(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V2_INDEX_RR_get_w_c(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V2_INDEX_RR_w_y_en_shift                                                  (11)
+#define VO_V2_INDEX_RR_w_y_en_mask                                                   (0x00000800)
+#define VO_V2_INDEX_RR_w_y_en(data)                                                  (0x00000800&((data)<<11))
+#define VO_V2_INDEX_RR_w_y_en_src(data)                                              ((0x00000800&(data))>>11)
+#define VO_V2_INDEX_RR_get_w_y_en(data)                                              ((0x00000800&(data))>>11)
+#define VO_V2_INDEX_RR_w_y_shift                                                     (8)
+#define VO_V2_INDEX_RR_w_y_mask                                                      (0x00000700)
+#define VO_V2_INDEX_RR_w_y(data)                                                     (0x00000700&((data)<<8))
+#define VO_V2_INDEX_RR_w_y_src(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V2_INDEX_RR_get_w_y(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V2_INDEX_RR_c_en_shift                                                    (7)
+#define VO_V2_INDEX_RR_c_en_mask                                                     (0x00000080)
+#define VO_V2_INDEX_RR_c_en(data)                                                    (0x00000080&((data)<<7))
+#define VO_V2_INDEX_RR_c_en_src(data)                                                ((0x00000080&(data))>>7)
+#define VO_V2_INDEX_RR_get_c_en(data)                                                ((0x00000080&(data))>>7)
+#define VO_V2_INDEX_RR_c_shift                                                       (4)
+#define VO_V2_INDEX_RR_c_mask                                                        (0x00000070)
+#define VO_V2_INDEX_RR_c(data)                                                       (0x00000070&((data)<<4))
+#define VO_V2_INDEX_RR_c_src(data)                                                   ((0x00000070&(data))>>4)
+#define VO_V2_INDEX_RR_get_c(data)                                                   ((0x00000070&(data))>>4)
+#define VO_V2_INDEX_RR_y_en_shift                                                    (3)
+#define VO_V2_INDEX_RR_y_en_mask                                                     (0x00000008)
+#define VO_V2_INDEX_RR_y_en(data)                                                    (0x00000008&((data)<<3))
+#define VO_V2_INDEX_RR_y_en_src(data)                                                ((0x00000008&(data))>>3)
+#define VO_V2_INDEX_RR_get_y_en(data)                                                ((0x00000008&(data))>>3)
+#define VO_V2_INDEX_RR_y_shift                                                       (0)
+#define VO_V2_INDEX_RR_y_mask                                                        (0x00000007)
+#define VO_V2_INDEX_RR_y(data)                                                       (0x00000007&((data)<<0))
+#define VO_V2_INDEX_RR_y_src(data)                                                   ((0x00000007&(data))>>0)
+#define VO_V2_INDEX_RR_get_y(data)                                                   ((0x00000007&(data))>>0)
+
+
+#define VO_V2_ALPHA                                                                  0x98005528
+#define VO_V2_ALPHA_reg_addr                                                         "0xD8005528"
+#define VO_V2_ALPHA_reg                                                              0xD8005528
+#define set_VO_V2_ALPHA_reg(data)   (*((volatile unsigned int*) VO_V2_ALPHA_reg)=data)
+#define get_VO_V2_ALPHA_reg   (*((volatile unsigned int*) VO_V2_ALPHA_reg))
+#define VO_V2_ALPHA_inst_adr                                                         "0x004A"
+#define VO_V2_ALPHA_inst                                                             0x004A
+#define VO_V2_ALPHA_a_shift                                                          (0)
+#define VO_V2_ALPHA_a_mask                                                           (0x000001FF)
+#define VO_V2_ALPHA_a(data)                                                          (0x000001FF&((data)<<0))
+#define VO_V2_ALPHA_a_src(data)                                                      ((0x000001FF&(data))>>0)
+#define VO_V2_ALPHA_get_a(data)                                                      ((0x000001FF&(data))>>0)
+
+
+#define VO_V2_SIZE                                                                   0x9800552C
+#define VO_V2_SIZE_reg_addr                                                          "0xD800552C"
+#define VO_V2_SIZE_reg                                                               0xD800552C
+#define set_VO_V2_SIZE_reg(data)   (*((volatile unsigned int*) VO_V2_SIZE_reg)=data)
+#define get_VO_V2_SIZE_reg   (*((volatile unsigned int*) VO_V2_SIZE_reg))
+#define VO_V2_SIZE_inst_adr                                                          "0x004B"
+#define VO_V2_SIZE_inst                                                              0x004B
+#define VO_V2_SIZE_w_shift                                                           (12)
+#define VO_V2_SIZE_w_mask                                                            (0x01FFF000)
+#define VO_V2_SIZE_w(data)                                                           (0x01FFF000&((data)<<12))
+#define VO_V2_SIZE_w_src(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_V2_SIZE_get_w(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_V2_SIZE_h_shift                                                           (0)
+#define VO_V2_SIZE_h_mask                                                            (0x00000FFF)
+#define VO_V2_SIZE_h(data)                                                           (0x00000FFF&((data)<<0))
+#define VO_V2_SIZE_h_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VO_V2_SIZE_get_h(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VO_V2_BUF                                                                    0x98005530
+#define VO_V2_BUF_reg_addr                                                           "0xD8005530"
+#define VO_V2_BUF_reg                                                                0xD8005530
+#define set_VO_V2_BUF_reg(data)   (*((volatile unsigned int*) VO_V2_BUF_reg)=data)
+#define get_VO_V2_BUF_reg   (*((volatile unsigned int*) VO_V2_BUF_reg))
+#define VO_V2_BUF_inst_adr                                                           "0x004C"
+#define VO_V2_BUF_inst                                                               0x004C
+#define VO_V2_BUF_th_shift                                                           (0)
+#define VO_V2_BUF_th_mask                                                            (0x000003FF)
+#define VO_V2_BUF_th(data)                                                           (0x000003FF&((data)<<0))
+#define VO_V2_BUF_th_src(data)                                                       ((0x000003FF&(data))>>0)
+#define VO_V2_BUF_get_th(data)                                                       ((0x000003FF&(data))>>0)
+
+
+#define VO_V2_MC_0                                                                   0x98005534
+#define VO_V2_MC_0_reg_addr                                                          "0xD8005534"
+#define VO_V2_MC_0_reg                                                               0xD8005534
+#define set_VO_V2_MC_0_reg(data)   (*((volatile unsigned int*) VO_V2_MC_0_reg)=data)
+#define get_VO_V2_MC_0_reg   (*((volatile unsigned int*) VO_V2_MC_0_reg))
+#define VO_V2_MC_0_inst_adr                                                          "0x004D"
+#define VO_V2_MC_0_inst                                                              0x004D
+#define VO_V2_MC_0_soft_reset_shift                                                  (2)
+#define VO_V2_MC_0_soft_reset_mask                                                   (0x00000004)
+#define VO_V2_MC_0_soft_reset(data)                                                  (0x00000004&((data)<<2))
+#define VO_V2_MC_0_soft_reset_src(data)                                              ((0x00000004&(data))>>2)
+#define VO_V2_MC_0_get_soft_reset(data)                                              ((0x00000004&(data))>>2)
+#define VO_V2_MC_0_int_mask_shift                                                    (1)
+#define VO_V2_MC_0_int_mask_mask                                                     (0x00000002)
+#define VO_V2_MC_0_int_mask(data)                                                    (0x00000002&((data)<<1))
+#define VO_V2_MC_0_int_mask_src(data)                                                ((0x00000002&(data))>>1)
+#define VO_V2_MC_0_get_int_mask(data)                                                ((0x00000002&(data))>>1)
+#define VO_V2_MC_0_run_shift                                                         (0)
+#define VO_V2_MC_0_run_mask                                                          (0x00000001)
+#define VO_V2_MC_0_run(data)                                                         (0x00000001&((data)<<0))
+#define VO_V2_MC_0_run_src(data)                                                     ((0x00000001&(data))>>0)
+#define VO_V2_MC_0_get_run(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define VO_V2_MC_4                                                                   0x98005538
+#define VO_V2_MC_4_reg_addr                                                          "0xD8005538"
+#define VO_V2_MC_4_reg                                                               0xD8005538
+#define set_VO_V2_MC_4_reg(data)   (*((volatile unsigned int*) VO_V2_MC_4_reg)=data)
+#define get_VO_V2_MC_4_reg   (*((volatile unsigned int*) VO_V2_MC_4_reg))
+#define VO_V2_MC_4_inst_adr                                                          "0x004E"
+#define VO_V2_MC_4_inst                                                              0x004E
+#define VO_V2_MC_4_check_soft_reset_shift                                            (2)
+#define VO_V2_MC_4_check_soft_reset_mask                                             (0x00000004)
+#define VO_V2_MC_4_check_soft_reset(data)                                            (0x00000004&((data)<<2))
+#define VO_V2_MC_4_check_soft_reset_src(data)                                        ((0x00000004&(data))>>2)
+#define VO_V2_MC_4_get_check_soft_reset(data)                                        ((0x00000004&(data))>>2)
+#define VO_V2_MC_4_error_shift                                                       (1)
+#define VO_V2_MC_4_error_mask                                                        (0x00000002)
+#define VO_V2_MC_4_error(data)                                                       (0x00000002&((data)<<1))
+#define VO_V2_MC_4_error_src(data)                                                   ((0x00000002&(data))>>1)
+#define VO_V2_MC_4_get_error(data)                                                   ((0x00000002&(data))>>1)
+#define VO_V2_MC_4_done_shift                                                        (0)
+#define VO_V2_MC_4_done_mask                                                         (0x00000001)
+#define VO_V2_MC_4_done(data)                                                        (0x00000001&((data)<<0))
+#define VO_V2_MC_4_done_src(data)                                                    ((0x00000001&(data))>>0)
+#define VO_V2_MC_4_get_done(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define VO_V2_MC_8                                                                   0x9800553C
+#define VO_V2_MC_8_reg_addr                                                          "0xD800553C"
+#define VO_V2_MC_8_reg                                                               0xD800553C
+#define set_VO_V2_MC_8_reg(data)   (*((volatile unsigned int*) VO_V2_MC_8_reg)=data)
+#define get_VO_V2_MC_8_reg   (*((volatile unsigned int*) VO_V2_MC_8_reg))
+#define VO_V2_MC_8_inst_adr                                                          "0x004F"
+#define VO_V2_MC_8_inst                                                              0x004F
+#define VO_V2_MC_8_luma_offset_sa_shift                                              (0)
+#define VO_V2_MC_8_luma_offset_sa_mask                                               (0xFFFFFFFF)
+#define VO_V2_MC_8_luma_offset_sa(data)                                              (0xFFFFFFFF&((data)<<0))
+#define VO_V2_MC_8_luma_offset_sa_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_MC_8_get_luma_offset_sa(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_MC_C                                                                   0x98005540
+#define VO_V2_MC_C_reg_addr                                                          "0xD8005540"
+#define VO_V2_MC_C_reg                                                               0xD8005540
+#define set_VO_V2_MC_C_reg(data)   (*((volatile unsigned int*) VO_V2_MC_C_reg)=data)
+#define get_VO_V2_MC_C_reg   (*((volatile unsigned int*) VO_V2_MC_C_reg))
+#define VO_V2_MC_C_inst_adr                                                          "0x0050"
+#define VO_V2_MC_C_inst                                                              0x0050
+#define VO_V2_MC_C_chroma_offset_sa_shift                                            (0)
+#define VO_V2_MC_C_chroma_offset_sa_mask                                             (0xFFFFFFFF)
+#define VO_V2_MC_C_chroma_offset_sa(data)                                            (0xFFFFFFFF&((data)<<0))
+#define VO_V2_MC_C_chroma_offset_sa_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_MC_C_get_chroma_offset_sa(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_MC_10                                                                  0x98005544
+#define VO_V2_MC_10_reg_addr                                                         "0xD8005544"
+#define VO_V2_MC_10_reg                                                              0xD8005544
+#define set_VO_V2_MC_10_reg(data)   (*((volatile unsigned int*) VO_V2_MC_10_reg)=data)
+#define get_VO_V2_MC_10_reg   (*((volatile unsigned int*) VO_V2_MC_10_reg))
+#define VO_V2_MC_10_inst_adr                                                         "0x0051"
+#define VO_V2_MC_10_inst                                                             0x0051
+#define VO_V2_MC_10_luma_height_shift                                                (16)
+#define VO_V2_MC_10_luma_height_mask                                                 (0x3FFF0000)
+#define VO_V2_MC_10_luma_height(data)                                                (0x3FFF0000&((data)<<16))
+#define VO_V2_MC_10_luma_height_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define VO_V2_MC_10_get_luma_height(data)                                            ((0x3FFF0000&(data))>>16)
+#define VO_V2_MC_10_chroma_height_shift                                              (0)
+#define VO_V2_MC_10_chroma_height_mask                                               (0x00003FFF)
+#define VO_V2_MC_10_chroma_height(data)                                              (0x00003FFF&((data)<<0))
+#define VO_V2_MC_10_chroma_height_src(data)                                          ((0x00003FFF&(data))>>0)
+#define VO_V2_MC_10_get_chroma_height(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_MC_14                                                                  0x98005548
+#define VO_V2_MC_14_reg_addr                                                         "0xD8005548"
+#define VO_V2_MC_14_reg                                                              0xD8005548
+#define set_VO_V2_MC_14_reg(data)   (*((volatile unsigned int*) VO_V2_MC_14_reg)=data)
+#define get_VO_V2_MC_14_reg   (*((volatile unsigned int*) VO_V2_MC_14_reg))
+#define VO_V2_MC_14_inst_adr                                                         "0x0052"
+#define VO_V2_MC_14_inst                                                             0x0052
+#define VO_V2_MC_14_luma_sa_shift                                                    (0)
+#define VO_V2_MC_14_luma_sa_mask                                                     (0xFFFFFFFF)
+#define VO_V2_MC_14_luma_sa(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define VO_V2_MC_14_luma_sa_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_MC_14_get_luma_sa(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_MC_18                                                                  0x9800554C
+#define VO_V2_MC_18_reg_addr                                                         "0xD800554C"
+#define VO_V2_MC_18_reg                                                              0xD800554C
+#define set_VO_V2_MC_18_reg(data)   (*((volatile unsigned int*) VO_V2_MC_18_reg)=data)
+#define get_VO_V2_MC_18_reg   (*((volatile unsigned int*) VO_V2_MC_18_reg))
+#define VO_V2_MC_18_inst_adr                                                         "0x0053"
+#define VO_V2_MC_18_inst                                                             0x0053
+#define VO_V2_MC_18_chroma_sa_shift                                                  (0)
+#define VO_V2_MC_18_chroma_sa_mask                                                   (0xFFFFFFFF)
+#define VO_V2_MC_18_chroma_sa(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V2_MC_18_chroma_sa_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_MC_18_get_chroma_sa(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_MC_1C                                                                  0x98005550
+#define VO_V2_MC_1C_reg_addr                                                         "0xD8005550"
+#define VO_V2_MC_1C_reg                                                              0xD8005550
+#define set_VO_V2_MC_1C_reg(data)   (*((volatile unsigned int*) VO_V2_MC_1C_reg)=data)
+#define get_VO_V2_MC_1C_reg   (*((volatile unsigned int*) VO_V2_MC_1C_reg))
+#define VO_V2_MC_1C_inst_adr                                                         "0x0054"
+#define VO_V2_MC_1C_inst                                                             0x0054
+#define VO_V2_MC_1C_luma_pitch_shift                                                 (16)
+#define VO_V2_MC_1C_luma_pitch_mask                                                  (0xFFFF0000)
+#define VO_V2_MC_1C_luma_pitch(data)                                                 (0xFFFF0000&((data)<<16))
+#define VO_V2_MC_1C_luma_pitch_src(data)                                             ((0xFFFF0000&(data))>>16)
+#define VO_V2_MC_1C_get_luma_pitch(data)                                             ((0xFFFF0000&(data))>>16)
+#define VO_V2_MC_1C_chroma_pitch_shift                                               (0)
+#define VO_V2_MC_1C_chroma_pitch_mask                                                (0x0000FFFF)
+#define VO_V2_MC_1C_chroma_pitch(data)                                               (0x0000FFFF&((data)<<0))
+#define VO_V2_MC_1C_chroma_pitch_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define VO_V2_MC_1C_get_chroma_pitch(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_MC_20                                                                  0x98005554
+#define VO_V2_MC_20_reg_addr                                                         "0xD8005554"
+#define VO_V2_MC_20_reg                                                              0xD8005554
+#define set_VO_V2_MC_20_reg(data)   (*((volatile unsigned int*) VO_V2_MC_20_reg)=data)
+#define get_VO_V2_MC_20_reg   (*((volatile unsigned int*) VO_V2_MC_20_reg))
+#define VO_V2_MC_20_inst_adr                                                         "0x0055"
+#define VO_V2_MC_20_inst                                                             0x0055
+#define VO_V2_MC_20_x_pos_shift                                                      (16)
+#define VO_V2_MC_20_x_pos_mask                                                       (0x1FFF0000)
+#define VO_V2_MC_20_x_pos(data)                                                      (0x1FFF0000&((data)<<16))
+#define VO_V2_MC_20_x_pos_src(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_V2_MC_20_get_x_pos(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_V2_MC_20_y_pos_shift                                                      (0)
+#define VO_V2_MC_20_y_pos_mask                                                       (0x00001FFF)
+#define VO_V2_MC_20_y_pos(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_V2_MC_20_y_pos_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_V2_MC_20_get_y_pos(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_V2_MC_24                                                                  0x98005558
+#define VO_V2_MC_24_reg_addr                                                         "0xD8005558"
+#define VO_V2_MC_24_reg                                                              0xD8005558
+#define set_VO_V2_MC_24_reg(data)   (*((volatile unsigned int*) VO_V2_MC_24_reg)=data)
+#define get_VO_V2_MC_24_reg   (*((volatile unsigned int*) VO_V2_MC_24_reg))
+#define VO_V2_MC_24_inst_adr                                                         "0x0056"
+#define VO_V2_MC_24_inst                                                             0x0056
+#define VO_V2_MC_24_x_size_shift                                                     (16)
+#define VO_V2_MC_24_x_size_mask                                                      (0x3FFF0000)
+#define VO_V2_MC_24_x_size(data)                                                     (0x3FFF0000&((data)<<16))
+#define VO_V2_MC_24_x_size_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define VO_V2_MC_24_get_x_size(data)                                                 ((0x3FFF0000&(data))>>16)
+#define VO_V2_MC_24_y_size_shift                                                     (0)
+#define VO_V2_MC_24_y_size_mask                                                      (0x00003FFF)
+#define VO_V2_MC_24_y_size(data)                                                     (0x00003FFF&((data)<<0))
+#define VO_V2_MC_24_y_size_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define VO_V2_MC_24_get_y_size(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_MC_28                                                                  0x9800555C
+#define VO_V2_MC_28_reg_addr                                                         "0xD800555C"
+#define VO_V2_MC_28_reg                                                              0xD800555C
+#define set_VO_V2_MC_28_reg(data)   (*((volatile unsigned int*) VO_V2_MC_28_reg)=data)
+#define get_VO_V2_MC_28_reg   (*((volatile unsigned int*) VO_V2_MC_28_reg))
+#define VO_V2_MC_28_inst_adr                                                         "0x0057"
+#define VO_V2_MC_28_inst                                                             0x0057
+#define VO_V2_MC_28_luma_out_mode_shift                                              (20)
+#define VO_V2_MC_28_luma_out_mode_mask                                               (0x00F00000)
+#define VO_V2_MC_28_luma_out_mode(data)                                              (0x00F00000&((data)<<20))
+#define VO_V2_MC_28_luma_out_mode_src(data)                                          ((0x00F00000&(data))>>20)
+#define VO_V2_MC_28_get_luma_out_mode(data)                                          ((0x00F00000&(data))>>20)
+#define VO_V2_MC_28_chroma_out_mode_shift                                            (16)
+#define VO_V2_MC_28_chroma_out_mode_mask                                             (0x000F0000)
+#define VO_V2_MC_28_chroma_out_mode(data)                                            (0x000F0000&((data)<<16))
+#define VO_V2_MC_28_chroma_out_mode_src(data)                                        ((0x000F0000&(data))>>16)
+#define VO_V2_MC_28_get_chroma_out_mode(data)                                        ((0x000F0000&(data))>>16)
+#define VO_V2_MC_28_hsync_period_shift                                               (0)
+#define VO_V2_MC_28_hsync_period_mask                                                (0x00003FFF)
+#define VO_V2_MC_28_hsync_period(data)                                               (0x00003FFF&((data)<<0))
+#define VO_V2_MC_28_hsync_period_src(data)                                           ((0x00003FFF&(data))>>0)
+#define VO_V2_MC_28_get_hsync_period(data)                                           ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_MC_2C                                                                  0x98005560
+#define VO_V2_MC_2C_reg_addr                                                         "0xD8005560"
+#define VO_V2_MC_2C_reg                                                              0xD8005560
+#define set_VO_V2_MC_2C_reg(data)   (*((volatile unsigned int*) VO_V2_MC_2C_reg)=data)
+#define get_VO_V2_MC_2C_reg   (*((volatile unsigned int*) VO_V2_MC_2C_reg))
+#define VO_V2_MC_2C_inst_adr                                                         "0x0058"
+#define VO_V2_MC_2C_inst                                                             0x0058
+#define VO_V2_MC_2C_time_out_count_shift                                             (0)
+#define VO_V2_MC_2C_time_out_count_mask                                              (0x0000FFFF)
+#define VO_V2_MC_2C_time_out_count(data)                                             (0x0000FFFF&((data)<<0))
+#define VO_V2_MC_2C_time_out_count_src(data)                                         ((0x0000FFFF&(data))>>0)
+#define VO_V2_MC_2C_get_time_out_count(data)                                         ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_MC_30                                                                  0x98005564
+#define VO_V2_MC_30_reg_addr                                                         "0xD8005564"
+#define VO_V2_MC_30_reg                                                              0xD8005564
+#define set_VO_V2_MC_30_reg(data)   (*((volatile unsigned int*) VO_V2_MC_30_reg)=data)
+#define get_VO_V2_MC_30_reg   (*((volatile unsigned int*) VO_V2_MC_30_reg))
+#define VO_V2_MC_30_inst_adr                                                         "0x0059"
+#define VO_V2_MC_30_inst                                                             0x0059
+#define VO_V2_MC_30_offset_endian_shift                                              (4)
+#define VO_V2_MC_30_offset_endian_mask                                               (0x000000F0)
+#define VO_V2_MC_30_offset_endian(data)                                              (0x000000F0&((data)<<4))
+#define VO_V2_MC_30_offset_endian_src(data)                                          ((0x000000F0&(data))>>4)
+#define VO_V2_MC_30_get_offset_endian(data)                                          ((0x000000F0&(data))>>4)
+#define VO_V2_MC_30_data_endian_shift                                                (0)
+#define VO_V2_MC_30_data_endian_mask                                                 (0x0000000F)
+#define VO_V2_MC_30_data_endian(data)                                                (0x0000000F&((data)<<0))
+#define VO_V2_MC_30_data_endian_src(data)                                            ((0x0000000F&(data))>>0)
+#define VO_V2_MC_30_get_data_endian(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define VO_V2_MC_34                                                                  0x98005568
+#define VO_V2_MC_34_reg_addr                                                         "0xD8005568"
+#define VO_V2_MC_34_reg                                                              0xD8005568
+#define set_VO_V2_MC_34_reg(data)   (*((volatile unsigned int*) VO_V2_MC_34_reg)=data)
+#define get_VO_V2_MC_34_reg   (*((volatile unsigned int*) VO_V2_MC_34_reg))
+#define VO_V2_MC_34_inst_adr                                                         "0x005A"
+#define VO_V2_MC_34_inst                                                             0x005A
+#define VO_V2_MC_34_luma_bit_depth_shift                                             (2)
+#define VO_V2_MC_34_luma_bit_depth_mask                                              (0x0000000C)
+#define VO_V2_MC_34_luma_bit_depth(data)                                             (0x0000000C&((data)<<2))
+#define VO_V2_MC_34_luma_bit_depth_src(data)                                         ((0x0000000C&(data))>>2)
+#define VO_V2_MC_34_get_luma_bit_depth(data)                                         ((0x0000000C&(data))>>2)
+#define VO_V2_MC_34_chroma_bit_depth_shift                                           (0)
+#define VO_V2_MC_34_chroma_bit_depth_mask                                            (0x00000003)
+#define VO_V2_MC_34_chroma_bit_depth(data)                                           (0x00000003&((data)<<0))
+#define VO_V2_MC_34_chroma_bit_depth_src(data)                                       ((0x00000003&(data))>>0)
+#define VO_V2_MC_34_get_chroma_bit_depth(data)                                       ((0x00000003&(data))>>0)
+
+
+#define VO_V2_TILE                                                                   0x9800556C
+#define VO_V2_TILE_reg_addr                                                          "0xD800556C"
+#define VO_V2_TILE_reg                                                               0xD800556C
+#define set_VO_V2_TILE_reg(data)   (*((volatile unsigned int*) VO_V2_TILE_reg)=data)
+#define get_VO_V2_TILE_reg   (*((volatile unsigned int*) VO_V2_TILE_reg))
+#define VO_V2_TILE_inst_adr                                                          "0x005B"
+#define VO_V2_TILE_inst                                                              0x005B
+#define VO_V2_TILE_mc_f422_shift                                                     (5)
+#define VO_V2_TILE_mc_f422_mask                                                      (0x00000020)
+#define VO_V2_TILE_mc_f422(data)                                                     (0x00000020&((data)<<5))
+#define VO_V2_TILE_mc_f422_src(data)                                                 ((0x00000020&(data))>>5)
+#define VO_V2_TILE_get_mc_f422(data)                                                 ((0x00000020&(data))>>5)
+#define VO_V2_TILE_data_endian_shift                                                 (4)
+#define VO_V2_TILE_data_endian_mask                                                  (0x00000010)
+#define VO_V2_TILE_data_endian(data)                                                 (0x00000010&((data)<<4))
+#define VO_V2_TILE_data_endian_src(data)                                             ((0x00000010&(data))>>4)
+#define VO_V2_TILE_get_data_endian(data)                                             ((0x00000010&(data))>>4)
+#define VO_V2_TILE_size_shift                                                        (0)
+#define VO_V2_TILE_size_mask                                                         (0x00000003)
+#define VO_V2_TILE_size(data)                                                        (0x00000003&((data)<<0))
+#define VO_V2_TILE_size_src(data)                                                    ((0x00000003&(data))>>0)
+#define VO_V2_TILE_get_size(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define VO_V2_DI                                                                     0x98005570
+#define VO_V2_DI_reg_addr                                                            "0xD8005570"
+#define VO_V2_DI_reg                                                                 0xD8005570
+#define set_VO_V2_DI_reg(data)   (*((volatile unsigned int*) VO_V2_DI_reg)=data)
+#define get_VO_V2_DI_reg   (*((volatile unsigned int*) VO_V2_DI_reg))
+#define VO_V2_DI_inst_adr                                                            "0x005C"
+#define VO_V2_DI_inst                                                                0x005C
+#define VO_V2_DI_mode_shift                                                          (0)
+#define VO_V2_DI_mode_mask                                                           (0x00000003)
+#define VO_V2_DI_mode(data)                                                          (0x00000003&((data)<<0))
+#define VO_V2_DI_mode_src(data)                                                      ((0x00000003&(data))>>0)
+#define VO_V2_DI_get_mode(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define VO_V2_DI_SEQ_SA_N_Y                                                          0x98005574
+#define VO_V2_DI_SEQ_SA_N_Y_reg_addr                                                 "0xD8005574"
+#define VO_V2_DI_SEQ_SA_N_Y_reg                                                      0xD8005574
+#define set_VO_V2_DI_SEQ_SA_N_Y_reg(data)   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_N_Y_reg)=data)
+#define get_VO_V2_DI_SEQ_SA_N_Y_reg   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_N_Y_reg))
+#define VO_V2_DI_SEQ_SA_N_Y_inst_adr                                                 "0x005D"
+#define VO_V2_DI_SEQ_SA_N_Y_inst                                                     0x005D
+#define VO_V2_DI_SEQ_SA_N_Y_a_shift                                                  (0)
+#define VO_V2_DI_SEQ_SA_N_Y_a_mask                                                   (0xFFFFFFFF)
+#define VO_V2_DI_SEQ_SA_N_Y_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V2_DI_SEQ_SA_N_Y_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_DI_SEQ_SA_N_Y_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_DI_SEQ_SA_N_C                                                          0x98005578
+#define VO_V2_DI_SEQ_SA_N_C_reg_addr                                                 "0xD8005578"
+#define VO_V2_DI_SEQ_SA_N_C_reg                                                      0xD8005578
+#define set_VO_V2_DI_SEQ_SA_N_C_reg(data)   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_N_C_reg)=data)
+#define get_VO_V2_DI_SEQ_SA_N_C_reg   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_N_C_reg))
+#define VO_V2_DI_SEQ_SA_N_C_inst_adr                                                 "0x005E"
+#define VO_V2_DI_SEQ_SA_N_C_inst                                                     0x005E
+#define VO_V2_DI_SEQ_SA_N_C_a_shift                                                  (0)
+#define VO_V2_DI_SEQ_SA_N_C_a_mask                                                   (0xFFFFFFFF)
+#define VO_V2_DI_SEQ_SA_N_C_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V2_DI_SEQ_SA_N_C_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_DI_SEQ_SA_N_C_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_DI_SEQ_SA_P_Y                                                          0x9800557C
+#define VO_V2_DI_SEQ_SA_P_Y_reg_addr                                                 "0xD800557C"
+#define VO_V2_DI_SEQ_SA_P_Y_reg                                                      0xD800557C
+#define set_VO_V2_DI_SEQ_SA_P_Y_reg(data)   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_P_Y_reg)=data)
+#define get_VO_V2_DI_SEQ_SA_P_Y_reg   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_P_Y_reg))
+#define VO_V2_DI_SEQ_SA_P_Y_inst_adr                                                 "0x005F"
+#define VO_V2_DI_SEQ_SA_P_Y_inst                                                     0x005F
+#define VO_V2_DI_SEQ_SA_P_Y_a_shift                                                  (0)
+#define VO_V2_DI_SEQ_SA_P_Y_a_mask                                                   (0xFFFFFFFF)
+#define VO_V2_DI_SEQ_SA_P_Y_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V2_DI_SEQ_SA_P_Y_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_DI_SEQ_SA_P_Y_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_DI_SEQ_SA_P_C                                                          0x98005580
+#define VO_V2_DI_SEQ_SA_P_C_reg_addr                                                 "0xD8005580"
+#define VO_V2_DI_SEQ_SA_P_C_reg                                                      0xD8005580
+#define set_VO_V2_DI_SEQ_SA_P_C_reg(data)   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_P_C_reg)=data)
+#define get_VO_V2_DI_SEQ_SA_P_C_reg   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_P_C_reg))
+#define VO_V2_DI_SEQ_SA_P_C_inst_adr                                                 "0x0060"
+#define VO_V2_DI_SEQ_SA_P_C_inst                                                     0x0060
+#define VO_V2_DI_SEQ_SA_P_C_a_shift                                                  (0)
+#define VO_V2_DI_SEQ_SA_P_C_a_mask                                                   (0xFFFFFFFF)
+#define VO_V2_DI_SEQ_SA_P_C_a(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define VO_V2_DI_SEQ_SA_P_C_a_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_DI_SEQ_SA_P_C_get_a(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_PITCH_N_Y                                                          0x98005584
+#define VO_V2_SEQ_PITCH_N_Y_reg_addr                                                 "0xD8005584"
+#define VO_V2_SEQ_PITCH_N_Y_reg                                                      0xD8005584
+#define set_VO_V2_SEQ_PITCH_N_Y_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_N_Y_reg)=data)
+#define get_VO_V2_SEQ_PITCH_N_Y_reg   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_N_Y_reg))
+#define VO_V2_SEQ_PITCH_N_Y_inst_adr                                                 "0x0061"
+#define VO_V2_SEQ_PITCH_N_Y_inst                                                     0x0061
+#define VO_V2_SEQ_PITCH_N_Y_p_shift                                                  (0)
+#define VO_V2_SEQ_PITCH_N_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V2_SEQ_PITCH_N_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V2_SEQ_PITCH_N_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V2_SEQ_PITCH_N_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_PITCH_N_C                                                          0x98005588
+#define VO_V2_SEQ_PITCH_N_C_reg_addr                                                 "0xD8005588"
+#define VO_V2_SEQ_PITCH_N_C_reg                                                      0xD8005588
+#define set_VO_V2_SEQ_PITCH_N_C_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_N_C_reg)=data)
+#define get_VO_V2_SEQ_PITCH_N_C_reg   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_N_C_reg))
+#define VO_V2_SEQ_PITCH_N_C_inst_adr                                                 "0x0062"
+#define VO_V2_SEQ_PITCH_N_C_inst                                                     0x0062
+#define VO_V2_SEQ_PITCH_N_C_p_shift                                                  (0)
+#define VO_V2_SEQ_PITCH_N_C_p_mask                                                   (0x0000FFFF)
+#define VO_V2_SEQ_PITCH_N_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V2_SEQ_PITCH_N_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V2_SEQ_PITCH_N_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_PITCH_P_Y                                                          0x9800558C
+#define VO_V2_SEQ_PITCH_P_Y_reg_addr                                                 "0xD800558C"
+#define VO_V2_SEQ_PITCH_P_Y_reg                                                      0xD800558C
+#define set_VO_V2_SEQ_PITCH_P_Y_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_P_Y_reg)=data)
+#define get_VO_V2_SEQ_PITCH_P_Y_reg   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_P_Y_reg))
+#define VO_V2_SEQ_PITCH_P_Y_inst_adr                                                 "0x0063"
+#define VO_V2_SEQ_PITCH_P_Y_inst                                                     0x0063
+#define VO_V2_SEQ_PITCH_P_Y_p_shift                                                  (0)
+#define VO_V2_SEQ_PITCH_P_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V2_SEQ_PITCH_P_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V2_SEQ_PITCH_P_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V2_SEQ_PITCH_P_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_SEQ_PITCH_P_C                                                          0x98005590
+#define VO_V2_SEQ_PITCH_P_C_reg_addr                                                 "0xD8005590"
+#define VO_V2_SEQ_PITCH_P_C_reg                                                      0xD8005590
+#define set_VO_V2_SEQ_PITCH_P_C_reg(data)   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_P_C_reg)=data)
+#define get_VO_V2_SEQ_PITCH_P_C_reg   (*((volatile unsigned int*) VO_V2_SEQ_PITCH_P_C_reg))
+#define VO_V2_SEQ_PITCH_P_C_inst_adr                                                 "0x0064"
+#define VO_V2_SEQ_PITCH_P_C_inst                                                     0x0064
+#define VO_V2_SEQ_PITCH_P_C_p_shift                                                  (0)
+#define VO_V2_SEQ_PITCH_P_C_p_mask                                                   (0x0000FFFF)
+#define VO_V2_SEQ_PITCH_P_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V2_SEQ_PITCH_P_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V2_SEQ_PITCH_P_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_DI_SEQ_SA_N_Y_3D                                                       0x98005594
+#define VO_V2_DI_SEQ_SA_N_Y_3D_reg_addr                                              "0xD8005594"
+#define VO_V2_DI_SEQ_SA_N_Y_3D_reg                                                   0xD8005594
+#define set_VO_V2_DI_SEQ_SA_N_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_N_Y_3D_reg)=data)
+#define get_VO_V2_DI_SEQ_SA_N_Y_3D_reg   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_N_Y_3D_reg))
+#define VO_V2_DI_SEQ_SA_N_Y_3D_inst_adr                                              "0x0065"
+#define VO_V2_DI_SEQ_SA_N_Y_3D_inst                                                  0x0065
+#define VO_V2_DI_SEQ_SA_N_Y_3D_a_shift                                               (0)
+#define VO_V2_DI_SEQ_SA_N_Y_3D_a_mask                                                (0xFFFFFFFF)
+#define VO_V2_DI_SEQ_SA_N_Y_3D_a(data)                                               (0xFFFFFFFF&((data)<<0))
+#define VO_V2_DI_SEQ_SA_N_Y_3D_a_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_DI_SEQ_SA_N_Y_3D_get_a(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_DI_SEQ_SA_N_C_3D                                                       0x98005598
+#define VO_V2_DI_SEQ_SA_N_C_3D_reg_addr                                              "0xD8005598"
+#define VO_V2_DI_SEQ_SA_N_C_3D_reg                                                   0xD8005598
+#define set_VO_V2_DI_SEQ_SA_N_C_3D_reg(data)   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_N_C_3D_reg)=data)
+#define get_VO_V2_DI_SEQ_SA_N_C_3D_reg   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_N_C_3D_reg))
+#define VO_V2_DI_SEQ_SA_N_C_3D_inst_adr                                              "0x0066"
+#define VO_V2_DI_SEQ_SA_N_C_3D_inst                                                  0x0066
+#define VO_V2_DI_SEQ_SA_N_C_3D_a_shift                                               (0)
+#define VO_V2_DI_SEQ_SA_N_C_3D_a_mask                                                (0xFFFFFFFF)
+#define VO_V2_DI_SEQ_SA_N_C_3D_a(data)                                               (0xFFFFFFFF&((data)<<0))
+#define VO_V2_DI_SEQ_SA_N_C_3D_a_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_DI_SEQ_SA_N_C_3D_get_a(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_DI_SEQ_SA_P_Y_3D                                                       0x9800559C
+#define VO_V2_DI_SEQ_SA_P_Y_3D_reg_addr                                              "0xD800559C"
+#define VO_V2_DI_SEQ_SA_P_Y_3D_reg                                                   0xD800559C
+#define set_VO_V2_DI_SEQ_SA_P_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_P_Y_3D_reg)=data)
+#define get_VO_V2_DI_SEQ_SA_P_Y_3D_reg   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_P_Y_3D_reg))
+#define VO_V2_DI_SEQ_SA_P_Y_3D_inst_adr                                              "0x0067"
+#define VO_V2_DI_SEQ_SA_P_Y_3D_inst                                                  0x0067
+#define VO_V2_DI_SEQ_SA_P_Y_3D_a_shift                                               (0)
+#define VO_V2_DI_SEQ_SA_P_Y_3D_a_mask                                                (0xFFFFFFFF)
+#define VO_V2_DI_SEQ_SA_P_Y_3D_a(data)                                               (0xFFFFFFFF&((data)<<0))
+#define VO_V2_DI_SEQ_SA_P_Y_3D_a_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_DI_SEQ_SA_P_Y_3D_get_a(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_DI_SEQ_SA_P_C_3D                                                       0x980055A0
+#define VO_V2_DI_SEQ_SA_P_C_3D_reg_addr                                              "0xD80055A0"
+#define VO_V2_DI_SEQ_SA_P_C_3D_reg                                                   0xD80055A0
+#define set_VO_V2_DI_SEQ_SA_P_C_3D_reg(data)   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_P_C_3D_reg)=data)
+#define get_VO_V2_DI_SEQ_SA_P_C_3D_reg   (*((volatile unsigned int*) VO_V2_DI_SEQ_SA_P_C_3D_reg))
+#define VO_V2_DI_SEQ_SA_P_C_3D_inst_adr                                              "0x0068"
+#define VO_V2_DI_SEQ_SA_P_C_3D_inst                                                  0x0068
+#define VO_V2_DI_SEQ_SA_P_C_3D_a_shift                                               (0)
+#define VO_V2_DI_SEQ_SA_P_C_3D_a_mask                                                (0xFFFFFFFF)
+#define VO_V2_DI_SEQ_SA_P_C_3D_a(data)                                               (0xFFFFFFFF&((data)<<0))
+#define VO_V2_DI_SEQ_SA_P_C_3D_a_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_DI_SEQ_SA_P_C_3D_get_a(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_DI_3F_RR                                                               0x980055A4
+#define VO_V2_DI_3F_RR_reg_addr                                                      "0xD80055A4"
+#define VO_V2_DI_3F_RR_reg                                                           0xD80055A4
+#define set_VO_V2_DI_3F_RR_reg(data)   (*((volatile unsigned int*) VO_V2_DI_3F_RR_reg)=data)
+#define get_VO_V2_DI_3F_RR_reg   (*((volatile unsigned int*) VO_V2_DI_3F_RR_reg))
+#define VO_V2_DI_3F_RR_inst_adr                                                      "0x0069"
+#define VO_V2_DI_3F_RR_inst                                                          0x0069
+#define VO_V2_DI_3F_RR_n_c_en_shift                                                  (15)
+#define VO_V2_DI_3F_RR_n_c_en_mask                                                   (0x00008000)
+#define VO_V2_DI_3F_RR_n_c_en(data)                                                  (0x00008000&((data)<<15))
+#define VO_V2_DI_3F_RR_n_c_en_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_V2_DI_3F_RR_get_n_c_en(data)                                              ((0x00008000&(data))>>15)
+#define VO_V2_DI_3F_RR_n_c_shift                                                     (12)
+#define VO_V2_DI_3F_RR_n_c_mask                                                      (0x00007000)
+#define VO_V2_DI_3F_RR_n_c(data)                                                     (0x00007000&((data)<<12))
+#define VO_V2_DI_3F_RR_n_c_src(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V2_DI_3F_RR_get_n_c(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V2_DI_3F_RR_n_y_en_shift                                                  (11)
+#define VO_V2_DI_3F_RR_n_y_en_mask                                                   (0x00000800)
+#define VO_V2_DI_3F_RR_n_y_en(data)                                                  (0x00000800&((data)<<11))
+#define VO_V2_DI_3F_RR_n_y_en_src(data)                                              ((0x00000800&(data))>>11)
+#define VO_V2_DI_3F_RR_get_n_y_en(data)                                              ((0x00000800&(data))>>11)
+#define VO_V2_DI_3F_RR_n_y_shift                                                     (8)
+#define VO_V2_DI_3F_RR_n_y_mask                                                      (0x00000700)
+#define VO_V2_DI_3F_RR_n_y(data)                                                     (0x00000700&((data)<<8))
+#define VO_V2_DI_3F_RR_n_y_src(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V2_DI_3F_RR_get_n_y(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V2_DI_3F_RR_p_c_en_shift                                                  (7)
+#define VO_V2_DI_3F_RR_p_c_en_mask                                                   (0x00000080)
+#define VO_V2_DI_3F_RR_p_c_en(data)                                                  (0x00000080&((data)<<7))
+#define VO_V2_DI_3F_RR_p_c_en_src(data)                                              ((0x00000080&(data))>>7)
+#define VO_V2_DI_3F_RR_get_p_c_en(data)                                              ((0x00000080&(data))>>7)
+#define VO_V2_DI_3F_RR_p_c_shift                                                     (4)
+#define VO_V2_DI_3F_RR_p_c_mask                                                      (0x00000070)
+#define VO_V2_DI_3F_RR_p_c(data)                                                     (0x00000070&((data)<<4))
+#define VO_V2_DI_3F_RR_p_c_src(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V2_DI_3F_RR_get_p_c(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V2_DI_3F_RR_p_y_en_shift                                                  (3)
+#define VO_V2_DI_3F_RR_p_y_en_mask                                                   (0x00000008)
+#define VO_V2_DI_3F_RR_p_y_en(data)                                                  (0x00000008&((data)<<3))
+#define VO_V2_DI_3F_RR_p_y_en_src(data)                                              ((0x00000008&(data))>>3)
+#define VO_V2_DI_3F_RR_get_p_y_en(data)                                              ((0x00000008&(data))>>3)
+#define VO_V2_DI_3F_RR_p_y_shift                                                     (0)
+#define VO_V2_DI_3F_RR_p_y_mask                                                      (0x00000007)
+#define VO_V2_DI_3F_RR_p_y(data)                                                     (0x00000007&((data)<<0))
+#define VO_V2_DI_3F_RR_p_y_src(data)                                                 ((0x00000007&(data))>>0)
+#define VO_V2_DI_3F_RR_get_p_y(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define VO_V2_DI_3F_RR_3D                                                            0x980055A8
+#define VO_V2_DI_3F_RR_3D_reg_addr                                                   "0xD80055A8"
+#define VO_V2_DI_3F_RR_3D_reg                                                        0xD80055A8
+#define set_VO_V2_DI_3F_RR_3D_reg(data)   (*((volatile unsigned int*) VO_V2_DI_3F_RR_3D_reg)=data)
+#define get_VO_V2_DI_3F_RR_3D_reg   (*((volatile unsigned int*) VO_V2_DI_3F_RR_3D_reg))
+#define VO_V2_DI_3F_RR_3D_inst_adr                                                   "0x006A"
+#define VO_V2_DI_3F_RR_3D_inst                                                       0x006A
+#define VO_V2_DI_3F_RR_3D_n_c_en_shift                                               (15)
+#define VO_V2_DI_3F_RR_3D_n_c_en_mask                                                (0x00008000)
+#define VO_V2_DI_3F_RR_3D_n_c_en(data)                                               (0x00008000&((data)<<15))
+#define VO_V2_DI_3F_RR_3D_n_c_en_src(data)                                           ((0x00008000&(data))>>15)
+#define VO_V2_DI_3F_RR_3D_get_n_c_en(data)                                           ((0x00008000&(data))>>15)
+#define VO_V2_DI_3F_RR_3D_n_c_shift                                                  (12)
+#define VO_V2_DI_3F_RR_3D_n_c_mask                                                   (0x00007000)
+#define VO_V2_DI_3F_RR_3D_n_c(data)                                                  (0x00007000&((data)<<12))
+#define VO_V2_DI_3F_RR_3D_n_c_src(data)                                              ((0x00007000&(data))>>12)
+#define VO_V2_DI_3F_RR_3D_get_n_c(data)                                              ((0x00007000&(data))>>12)
+#define VO_V2_DI_3F_RR_3D_n_y_en_shift                                               (11)
+#define VO_V2_DI_3F_RR_3D_n_y_en_mask                                                (0x00000800)
+#define VO_V2_DI_3F_RR_3D_n_y_en(data)                                               (0x00000800&((data)<<11))
+#define VO_V2_DI_3F_RR_3D_n_y_en_src(data)                                           ((0x00000800&(data))>>11)
+#define VO_V2_DI_3F_RR_3D_get_n_y_en(data)                                           ((0x00000800&(data))>>11)
+#define VO_V2_DI_3F_RR_3D_n_y_shift                                                  (8)
+#define VO_V2_DI_3F_RR_3D_n_y_mask                                                   (0x00000700)
+#define VO_V2_DI_3F_RR_3D_n_y(data)                                                  (0x00000700&((data)<<8))
+#define VO_V2_DI_3F_RR_3D_n_y_src(data)                                              ((0x00000700&(data))>>8)
+#define VO_V2_DI_3F_RR_3D_get_n_y(data)                                              ((0x00000700&(data))>>8)
+#define VO_V2_DI_3F_RR_3D_p_c_en_shift                                               (7)
+#define VO_V2_DI_3F_RR_3D_p_c_en_mask                                                (0x00000080)
+#define VO_V2_DI_3F_RR_3D_p_c_en(data)                                               (0x00000080&((data)<<7))
+#define VO_V2_DI_3F_RR_3D_p_c_en_src(data)                                           ((0x00000080&(data))>>7)
+#define VO_V2_DI_3F_RR_3D_get_p_c_en(data)                                           ((0x00000080&(data))>>7)
+#define VO_V2_DI_3F_RR_3D_p_c_shift                                                  (4)
+#define VO_V2_DI_3F_RR_3D_p_c_mask                                                   (0x00000070)
+#define VO_V2_DI_3F_RR_3D_p_c(data)                                                  (0x00000070&((data)<<4))
+#define VO_V2_DI_3F_RR_3D_p_c_src(data)                                              ((0x00000070&(data))>>4)
+#define VO_V2_DI_3F_RR_3D_get_p_c(data)                                              ((0x00000070&(data))>>4)
+#define VO_V2_DI_3F_RR_3D_p_y_en_shift                                               (3)
+#define VO_V2_DI_3F_RR_3D_p_y_en_mask                                                (0x00000008)
+#define VO_V2_DI_3F_RR_3D_p_y_en(data)                                               (0x00000008&((data)<<3))
+#define VO_V2_DI_3F_RR_3D_p_y_en_src(data)                                           ((0x00000008&(data))>>3)
+#define VO_V2_DI_3F_RR_3D_get_p_y_en(data)                                           ((0x00000008&(data))>>3)
+#define VO_V2_DI_3F_RR_3D_p_y_shift                                                  (0)
+#define VO_V2_DI_3F_RR_3D_p_y_mask                                                   (0x00000007)
+#define VO_V2_DI_3F_RR_3D_p_y(data)                                                  (0x00000007&((data)<<0))
+#define VO_V2_DI_3F_RR_3D_p_y_src(data)                                              ((0x00000007&(data))>>0)
+#define VO_V2_DI_3F_RR_3D_get_p_y(data)                                              ((0x00000007&(data))>>0)
+
+
+#define VO_V2_MA_FR                                                                  0x980055AC
+#define VO_V2_MA_FR_reg_addr                                                         "0xD80055AC"
+#define VO_V2_MA_FR_reg                                                              0xD80055AC
+#define set_VO_V2_MA_FR_reg(data)   (*((volatile unsigned int*) VO_V2_MA_FR_reg)=data)
+#define get_VO_V2_MA_FR_reg   (*((volatile unsigned int*) VO_V2_MA_FR_reg))
+#define VO_V2_MA_FR_inst_adr                                                         "0x006B"
+#define VO_V2_MA_FR_inst                                                             0x006B
+#define VO_V2_MA_FR_a_shift                                                          (0)
+#define VO_V2_MA_FR_a_mask                                                           (0xFFFFFFFF)
+#define VO_V2_MA_FR_a(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define VO_V2_MA_FR_a_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_MA_FR_get_a(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_MA_FR_3D                                                               0x980055B0
+#define VO_V2_MA_FR_3D_reg_addr                                                      "0xD80055B0"
+#define VO_V2_MA_FR_3D_reg                                                           0xD80055B0
+#define set_VO_V2_MA_FR_3D_reg(data)   (*((volatile unsigned int*) VO_V2_MA_FR_3D_reg)=data)
+#define get_VO_V2_MA_FR_3D_reg   (*((volatile unsigned int*) VO_V2_MA_FR_3D_reg))
+#define VO_V2_MA_FR_3D_inst_adr                                                      "0x006C"
+#define VO_V2_MA_FR_3D_inst                                                          0x006C
+#define VO_V2_MA_FR_3D_a_shift                                                       (0)
+#define VO_V2_MA_FR_3D_a_mask                                                        (0xFFFFFFFF)
+#define VO_V2_MA_FR_3D_a(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define VO_V2_MA_FR_3D_a_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_MA_FR_3D_get_a(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_MA_FW                                                                  0x980055B4
+#define VO_V2_MA_FW_reg_addr                                                         "0xD80055B4"
+#define VO_V2_MA_FW_reg                                                              0xD80055B4
+#define set_VO_V2_MA_FW_reg(data)   (*((volatile unsigned int*) VO_V2_MA_FW_reg)=data)
+#define get_VO_V2_MA_FW_reg   (*((volatile unsigned int*) VO_V2_MA_FW_reg))
+#define VO_V2_MA_FW_inst_adr                                                         "0x006D"
+#define VO_V2_MA_FW_inst                                                             0x006D
+#define VO_V2_MA_FW_a_shift                                                          (0)
+#define VO_V2_MA_FW_a_mask                                                           (0xFFFFFFFF)
+#define VO_V2_MA_FW_a(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define VO_V2_MA_FW_a_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_MA_FW_get_a(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_MA_FW_3D                                                               0x980055B8
+#define VO_V2_MA_FW_3D_reg_addr                                                      "0xD80055B8"
+#define VO_V2_MA_FW_3D_reg                                                           0xD80055B8
+#define set_VO_V2_MA_FW_3D_reg(data)   (*((volatile unsigned int*) VO_V2_MA_FW_3D_reg)=data)
+#define get_VO_V2_MA_FW_3D_reg   (*((volatile unsigned int*) VO_V2_MA_FW_3D_reg))
+#define VO_V2_MA_FW_3D_inst_adr                                                      "0x006E"
+#define VO_V2_MA_FW_3D_inst                                                          0x006E
+#define VO_V2_MA_FW_3D_a_shift                                                       (0)
+#define VO_V2_MA_FW_3D_a_mask                                                        (0xFFFFFFFF)
+#define VO_V2_MA_FW_3D_a(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define VO_V2_MA_FW_3D_a_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define VO_V2_MA_FW_3D_get_a(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_V2_INTRA                                                                  0x980055BC
+#define VO_V2_INTRA_reg_addr                                                         "0xD80055BC"
+#define VO_V2_INTRA_reg                                                              0xD80055BC
+#define set_VO_V2_INTRA_reg(data)   (*((volatile unsigned int*) VO_V2_INTRA_reg)=data)
+#define get_VO_V2_INTRA_reg   (*((volatile unsigned int*) VO_V2_INTRA_reg))
+#define VO_V2_INTRA_inst_adr                                                         "0x006F"
+#define VO_V2_INTRA_inst                                                             0x006F
+#define VO_V2_INTRA_c_range_shift                                                    (26)
+#define VO_V2_INTRA_c_range_mask                                                     (0x04000000)
+#define VO_V2_INTRA_c_range(data)                                                    (0x04000000&((data)<<26))
+#define VO_V2_INTRA_c_range_src(data)                                                ((0x04000000&(data))>>26)
+#define VO_V2_INTRA_get_c_range(data)                                                ((0x04000000&(data))>>26)
+#define VO_V2_INTRA_y_range_shift                                                    (24)
+#define VO_V2_INTRA_y_range_mask                                                     (0x03000000)
+#define VO_V2_INTRA_y_range(data)                                                    (0x03000000&((data)<<24))
+#define VO_V2_INTRA_y_range_src(data)                                                ((0x03000000&(data))>>24)
+#define VO_V2_INTRA_get_y_range(data)                                                ((0x03000000&(data))>>24)
+#define VO_V2_INTRA_th_pos_shift                                                     (16)
+#define VO_V2_INTRA_th_pos_mask                                                      (0x001F0000)
+#define VO_V2_INTRA_th_pos(data)                                                     (0x001F0000&((data)<<16))
+#define VO_V2_INTRA_th_pos_src(data)                                                 ((0x001F0000&(data))>>16)
+#define VO_V2_INTRA_get_th_pos(data)                                                 ((0x001F0000&(data))>>16)
+#define VO_V2_INTRA_th_prediff_shift                                                 (8)
+#define VO_V2_INTRA_th_prediff_mask                                                  (0x00007F00)
+#define VO_V2_INTRA_th_prediff(data)                                                 (0x00007F00&((data)<<8))
+#define VO_V2_INTRA_th_prediff_src(data)                                             ((0x00007F00&(data))>>8)
+#define VO_V2_INTRA_get_th_prediff(data)                                             ((0x00007F00&(data))>>8)
+#define VO_V2_INTRA_th_refdiff_shift                                                 (0)
+#define VO_V2_INTRA_th_refdiff_mask                                                  (0x0000003F)
+#define VO_V2_INTRA_th_refdiff(data)                                                 (0x0000003F&((data)<<0))
+#define VO_V2_INTRA_th_refdiff_src(data)                                             ((0x0000003F&(data))>>0)
+#define VO_V2_INTRA_get_th_refdiff(data)                                             ((0x0000003F&(data))>>0)
+
+
+#define VO_V2_MA                                                                     0x980055C0
+#define VO_V2_MA_reg_addr                                                            "0xD80055C0"
+#define VO_V2_MA_reg                                                                 0xD80055C0
+#define set_VO_V2_MA_reg(data)   (*((volatile unsigned int*) VO_V2_MA_reg)=data)
+#define get_VO_V2_MA_reg   (*((volatile unsigned int*) VO_V2_MA_reg))
+#define VO_V2_MA_inst_adr                                                            "0x0070"
+#define VO_V2_MA_inst                                                                0x0070
+#define VO_V2_MA_split_shift                                                         (31)
+#define VO_V2_MA_split_mask                                                          (0x80000000)
+#define VO_V2_MA_split(data)                                                         (0x80000000&((data)<<31))
+#define VO_V2_MA_split_src(data)                                                     ((0x80000000&(data))>>31)
+#define VO_V2_MA_get_split(data)                                                     ((0x80000000&(data))>>31)
+#define VO_V2_MA_c_intra_shift                                                       (30)
+#define VO_V2_MA_c_intra_mask                                                        (0x40000000)
+#define VO_V2_MA_c_intra(data)                                                       (0x40000000&((data)<<30))
+#define VO_V2_MA_c_intra_src(data)                                                   ((0x40000000&(data))>>30)
+#define VO_V2_MA_get_c_intra(data)                                                   ((0x40000000&(data))>>30)
+#define VO_V2_MA_lp_shift                                                            (29)
+#define VO_V2_MA_lp_mask                                                             (0x20000000)
+#define VO_V2_MA_lp(data)                                                            (0x20000000&((data)<<29))
+#define VO_V2_MA_lp_src(data)                                                        ((0x20000000&(data))>>29)
+#define VO_V2_MA_get_lp(data)                                                        ((0x20000000&(data))>>29)
+#define VO_V2_MA_fm_shift                                                            (28)
+#define VO_V2_MA_fm_mask                                                             (0x10000000)
+#define VO_V2_MA_fm(data)                                                            (0x10000000&((data)<<28))
+#define VO_V2_MA_fm_src(data)                                                        ((0x10000000&(data))>>28)
+#define VO_V2_MA_get_fm(data)                                                        ((0x10000000&(data))>>28)
+#define VO_V2_MA_sc_shift                                                            (24)
+#define VO_V2_MA_sc_mask                                                             (0x07000000)
+#define VO_V2_MA_sc(data)                                                            (0x07000000&((data)<<24))
+#define VO_V2_MA_sc_src(data)                                                        ((0x07000000&(data))>>24)
+#define VO_V2_MA_get_sc(data)                                                        ((0x07000000&(data))>>24)
+#define VO_V2_MA_th_noise_shift                                                      (16)
+#define VO_V2_MA_th_noise_mask                                                       (0x00FF0000)
+#define VO_V2_MA_th_noise(data)                                                      (0x00FF0000&((data)<<16))
+#define VO_V2_MA_th_noise_src(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V2_MA_get_th_noise(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V2_MA_th_c_shift                                                          (8)
+#define VO_V2_MA_th_c_mask                                                           (0x0000FF00)
+#define VO_V2_MA_th_c(data)                                                          (0x0000FF00&((data)<<8))
+#define VO_V2_MA_th_c_src(data)                                                      ((0x0000FF00&(data))>>8)
+#define VO_V2_MA_get_th_c(data)                                                      ((0x0000FF00&(data))>>8)
+#define VO_V2_MA_th_y_shift                                                          (0)
+#define VO_V2_MA_th_y_mask                                                           (0x000000FF)
+#define VO_V2_MA_th_y(data)                                                          (0x000000FF&((data)<<0))
+#define VO_V2_MA_th_y_src(data)                                                      ((0x000000FF&(data))>>0)
+#define VO_V2_MA_get_th_y(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_MA_NEW                                                                 0x980055C4
+#define VO_V2_MA_NEW_reg_addr                                                        "0xD80055C4"
+#define VO_V2_MA_NEW_reg                                                             0xD80055C4
+#define set_VO_V2_MA_NEW_reg(data)   (*((volatile unsigned int*) VO_V2_MA_NEW_reg)=data)
+#define get_VO_V2_MA_NEW_reg   (*((volatile unsigned int*) VO_V2_MA_NEW_reg))
+#define VO_V2_MA_NEW_inst_adr                                                        "0x0071"
+#define VO_V2_MA_NEW_inst                                                            0x0071
+#define VO_V2_MA_NEW_correct_shift                                                   (8)
+#define VO_V2_MA_NEW_correct_mask                                                    (0x00000100)
+#define VO_V2_MA_NEW_correct(data)                                                   (0x00000100&((data)<<8))
+#define VO_V2_MA_NEW_correct_src(data)                                               ((0x00000100&(data))>>8)
+#define VO_V2_MA_NEW_get_correct(data)                                               ((0x00000100&(data))>>8)
+#define VO_V2_MA_NEW_fm_shift                                                        (7)
+#define VO_V2_MA_NEW_fm_mask                                                         (0x00000080)
+#define VO_V2_MA_NEW_fm(data)                                                        (0x00000080&((data)<<7))
+#define VO_V2_MA_NEW_fm_src(data)                                                    ((0x00000080&(data))>>7)
+#define VO_V2_MA_NEW_get_fm(data)                                                    ((0x00000080&(data))>>7)
+#define VO_V2_MA_NEW_limit_shift                                                     (6)
+#define VO_V2_MA_NEW_limit_mask                                                      (0x00000040)
+#define VO_V2_MA_NEW_limit(data)                                                     (0x00000040&((data)<<6))
+#define VO_V2_MA_NEW_limit_src(data)                                                 ((0x00000040&(data))>>6)
+#define VO_V2_MA_NEW_get_limit(data)                                                 ((0x00000040&(data))>>6)
+#define VO_V2_MA_NEW_weave_shift                                                     (5)
+#define VO_V2_MA_NEW_weave_mask                                                      (0x00000020)
+#define VO_V2_MA_NEW_weave(data)                                                     (0x00000020&((data)<<5))
+#define VO_V2_MA_NEW_weave_src(data)                                                 ((0x00000020&(data))>>5)
+#define VO_V2_MA_NEW_get_weave(data)                                                 ((0x00000020&(data))>>5)
+#define VO_V2_MA_NEW_blend_shift                                                     (4)
+#define VO_V2_MA_NEW_blend_mask                                                      (0x00000010)
+#define VO_V2_MA_NEW_blend(data)                                                     (0x00000010&((data)<<4))
+#define VO_V2_MA_NEW_blend_src(data)                                                 ((0x00000010&(data))>>4)
+#define VO_V2_MA_NEW_get_blend(data)                                                 ((0x00000010&(data))>>4)
+#define VO_V2_MA_NEW_noisy_high_shift                                                (3)
+#define VO_V2_MA_NEW_noisy_high_mask                                                 (0x00000008)
+#define VO_V2_MA_NEW_noisy_high(data)                                                (0x00000008&((data)<<3))
+#define VO_V2_MA_NEW_noisy_high_src(data)                                            ((0x00000008&(data))>>3)
+#define VO_V2_MA_NEW_get_noisy_high(data)                                            ((0x00000008&(data))>>3)
+#define VO_V2_MA_NEW_noisy_shift                                                     (2)
+#define VO_V2_MA_NEW_noisy_mask                                                      (0x00000004)
+#define VO_V2_MA_NEW_noisy(data)                                                     (0x00000004&((data)<<2))
+#define VO_V2_MA_NEW_noisy_src(data)                                                 ((0x00000004&(data))>>2)
+#define VO_V2_MA_NEW_get_noisy(data)                                                 ((0x00000004&(data))>>2)
+#define VO_V2_MA_NEW_ma_shift                                                        (1)
+#define VO_V2_MA_NEW_ma_mask                                                         (0x00000002)
+#define VO_V2_MA_NEW_ma(data)                                                        (0x00000002&((data)<<1))
+#define VO_V2_MA_NEW_ma_src(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V2_MA_NEW_get_ma(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V2_MA_NEW_write_data_shift                                                (0)
+#define VO_V2_MA_NEW_write_data_mask                                                 (0x00000001)
+#define VO_V2_MA_NEW_write_data(data)                                                (0x00000001&((data)<<0))
+#define VO_V2_MA_NEW_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_V2_MA_NEW_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VO_V2_MA_FT                                                                  0x980055C8
+#define VO_V2_MA_FT_reg_addr                                                         "0xD80055C8"
+#define VO_V2_MA_FT_reg                                                              0xD80055C8
+#define set_VO_V2_MA_FT_reg(data)   (*((volatile unsigned int*) VO_V2_MA_FT_reg)=data)
+#define get_VO_V2_MA_FT_reg   (*((volatile unsigned int*) VO_V2_MA_FT_reg))
+#define VO_V2_MA_FT_inst_adr                                                         "0x0072"
+#define VO_V2_MA_FT_inst                                                             0x0072
+#define VO_V2_MA_FT_limit_shift                                                      (16)
+#define VO_V2_MA_FT_limit_mask                                                       (0x00FF0000)
+#define VO_V2_MA_FT_limit(data)                                                      (0x00FF0000&((data)<<16))
+#define VO_V2_MA_FT_limit_src(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V2_MA_FT_get_limit(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V2_MA_FT_big_shift                                                        (8)
+#define VO_V2_MA_FT_big_mask                                                         (0x0000FF00)
+#define VO_V2_MA_FT_big(data)                                                        (0x0000FF00&((data)<<8))
+#define VO_V2_MA_FT_big_src(data)                                                    ((0x0000FF00&(data))>>8)
+#define VO_V2_MA_FT_get_big(data)                                                    ((0x0000FF00&(data))>>8)
+#define VO_V2_MA_FT_th_shift                                                         (0)
+#define VO_V2_MA_FT_th_mask                                                          (0x000000FF)
+#define VO_V2_MA_FT_th(data)                                                         (0x000000FF&((data)<<0))
+#define VO_V2_MA_FT_th_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VO_V2_MA_FT_get_th(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_MA_FM                                                                  0x980055CC
+#define VO_V2_MA_FM_reg_addr                                                         "0xD80055CC"
+#define VO_V2_MA_FM_reg                                                              0xD80055CC
+#define set_VO_V2_MA_FM_reg(data)   (*((volatile unsigned int*) VO_V2_MA_FM_reg)=data)
+#define get_VO_V2_MA_FM_reg   (*((volatile unsigned int*) VO_V2_MA_FM_reg))
+#define VO_V2_MA_FM_inst_adr                                                         "0x0073"
+#define VO_V2_MA_FM_inst                                                             0x0073
+#define VO_V2_MA_FM_noisy_shift                                                      (8)
+#define VO_V2_MA_FM_noisy_mask                                                       (0x0000FF00)
+#define VO_V2_MA_FM_noisy(data)                                                      (0x0000FF00&((data)<<8))
+#define VO_V2_MA_FM_noisy_src(data)                                                  ((0x0000FF00&(data))>>8)
+#define VO_V2_MA_FM_get_noisy(data)                                                  ((0x0000FF00&(data))>>8)
+#define VO_V2_MA_FM_th_shift                                                         (0)
+#define VO_V2_MA_FM_th_mask                                                          (0x000000FF)
+#define VO_V2_MA_FM_th(data)                                                         (0x000000FF&((data)<<0))
+#define VO_V2_MA_FM_th_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VO_V2_MA_FM_get_th(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_BLEND                                                               0x980055D0
+#define VO_V2_DI_BLEND_reg_addr                                                      "0xD80055D0"
+#define VO_V2_DI_BLEND_reg                                                           0xD80055D0
+#define set_VO_V2_DI_BLEND_reg(data)   (*((volatile unsigned int*) VO_V2_DI_BLEND_reg)=data)
+#define get_VO_V2_DI_BLEND_reg   (*((volatile unsigned int*) VO_V2_DI_BLEND_reg))
+#define VO_V2_DI_BLEND_inst_adr                                                      "0x0074"
+#define VO_V2_DI_BLEND_inst                                                          0x0074
+#define VO_V2_DI_BLEND_cth_log2_shift                                                (24)
+#define VO_V2_DI_BLEND_cth_log2_mask                                                 (0x07000000)
+#define VO_V2_DI_BLEND_cth_log2(data)                                                (0x07000000&((data)<<24))
+#define VO_V2_DI_BLEND_cth_log2_src(data)                                            ((0x07000000&(data))>>24)
+#define VO_V2_DI_BLEND_get_cth_log2(data)                                            ((0x07000000&(data))>>24)
+#define VO_V2_DI_BLEND_cth_low_shift                                                 (16)
+#define VO_V2_DI_BLEND_cth_low_mask                                                  (0x00FF0000)
+#define VO_V2_DI_BLEND_cth_low(data)                                                 (0x00FF0000&((data)<<16))
+#define VO_V2_DI_BLEND_cth_low_src(data)                                             ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_BLEND_get_cth_low(data)                                             ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_BLEND_yth_log2_shift                                                (8)
+#define VO_V2_DI_BLEND_yth_log2_mask                                                 (0x00000700)
+#define VO_V2_DI_BLEND_yth_log2(data)                                                (0x00000700&((data)<<8))
+#define VO_V2_DI_BLEND_yth_log2_src(data)                                            ((0x00000700&(data))>>8)
+#define VO_V2_DI_BLEND_get_yth_log2(data)                                            ((0x00000700&(data))>>8)
+#define VO_V2_DI_BLEND_yth_low_shift                                                 (0)
+#define VO_V2_DI_BLEND_yth_low_mask                                                  (0x000000FF)
+#define VO_V2_DI_BLEND_yth_low(data)                                                 (0x000000FF&((data)<<0))
+#define VO_V2_DI_BLEND_yth_low_src(data)                                             ((0x000000FF&(data))>>0)
+#define VO_V2_DI_BLEND_get_yth_low(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_FILM                                                                   0x980055D4
+#define VO_V2_FILM_reg_addr                                                          "0xD80055D4"
+#define VO_V2_FILM_reg                                                               0xD80055D4
+#define set_VO_V2_FILM_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_reg)=data)
+#define get_VO_V2_FILM_reg   (*((volatile unsigned int*) VO_V2_FILM_reg))
+#define VO_V2_FILM_inst_adr                                                          "0x0075"
+#define VO_V2_FILM_inst                                                              0x0075
+#define VO_V2_FILM_mode_shift                                                        (0)
+#define VO_V2_FILM_mode_mask                                                         (0x00000003)
+#define VO_V2_FILM_mode(data)                                                        (0x00000003&((data)<<0))
+#define VO_V2_FILM_mode_src(data)                                                    ((0x00000003&(data))>>0)
+#define VO_V2_FILM_get_mode(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define VO_V2_WADTB_0                                                                0x980055D8
+#define VO_V2_WADTB_1                                                                0x980055DC
+#define VO_V2_WADTB_2                                                                0x980055E0
+#define VO_V2_WADTB_3                                                                0x980055E4
+#define VO_V2_WADTB_4                                                                0x980055E8
+#define VO_V2_WADTB_5                                                                0x980055EC
+#define VO_V2_WADTB_6                                                                0x980055F0
+#define VO_V2_WADTB_7                                                                0x980055F4
+#define VO_V2_WADTB_8                                                                0x980055F8
+#define VO_V2_WADTB_0_reg_addr                                                       "0xD80055D8"
+#define VO_V2_WADTB_1_reg_addr                                                       "0xD80055DC"
+#define VO_V2_WADTB_2_reg_addr                                                       "0xD80055E0"
+#define VO_V2_WADTB_3_reg_addr                                                       "0xD80055E4"
+#define VO_V2_WADTB_4_reg_addr                                                       "0xD80055E8"
+#define VO_V2_WADTB_5_reg_addr                                                       "0xD80055EC"
+#define VO_V2_WADTB_6_reg_addr                                                       "0xD80055F0"
+#define VO_V2_WADTB_7_reg_addr                                                       "0xD80055F4"
+#define VO_V2_WADTB_8_reg_addr                                                       "0xD80055F8"
+#define VO_V2_WADTB_0_reg                                                            0xD80055D8
+#define VO_V2_WADTB_1_reg                                                            0xD80055DC
+#define VO_V2_WADTB_2_reg                                                            0xD80055E0
+#define VO_V2_WADTB_3_reg                                                            0xD80055E4
+#define VO_V2_WADTB_4_reg                                                            0xD80055E8
+#define VO_V2_WADTB_5_reg                                                            0xD80055EC
+#define VO_V2_WADTB_6_reg                                                            0xD80055F0
+#define VO_V2_WADTB_7_reg                                                            0xD80055F4
+#define VO_V2_WADTB_8_reg                                                            0xD80055F8
+#define set_VO_V2_WADTB_0_reg(data)   (*((volatile unsigned int*) VO_V2_WADTB_0_reg)=data)
+#define set_VO_V2_WADTB_1_reg(data)   (*((volatile unsigned int*) VO_V2_WADTB_1_reg)=data)
+#define set_VO_V2_WADTB_2_reg(data)   (*((volatile unsigned int*) VO_V2_WADTB_2_reg)=data)
+#define set_VO_V2_WADTB_3_reg(data)   (*((volatile unsigned int*) VO_V2_WADTB_3_reg)=data)
+#define set_VO_V2_WADTB_4_reg(data)   (*((volatile unsigned int*) VO_V2_WADTB_4_reg)=data)
+#define set_VO_V2_WADTB_5_reg(data)   (*((volatile unsigned int*) VO_V2_WADTB_5_reg)=data)
+#define set_VO_V2_WADTB_6_reg(data)   (*((volatile unsigned int*) VO_V2_WADTB_6_reg)=data)
+#define set_VO_V2_WADTB_7_reg(data)   (*((volatile unsigned int*) VO_V2_WADTB_7_reg)=data)
+#define set_VO_V2_WADTB_8_reg(data)   (*((volatile unsigned int*) VO_V2_WADTB_8_reg)=data)
+#define get_VO_V2_WADTB_0_reg   (*((volatile unsigned int*) VO_V2_WADTB_0_reg))
+#define get_VO_V2_WADTB_1_reg   (*((volatile unsigned int*) VO_V2_WADTB_1_reg))
+#define get_VO_V2_WADTB_2_reg   (*((volatile unsigned int*) VO_V2_WADTB_2_reg))
+#define get_VO_V2_WADTB_3_reg   (*((volatile unsigned int*) VO_V2_WADTB_3_reg))
+#define get_VO_V2_WADTB_4_reg   (*((volatile unsigned int*) VO_V2_WADTB_4_reg))
+#define get_VO_V2_WADTB_5_reg   (*((volatile unsigned int*) VO_V2_WADTB_5_reg))
+#define get_VO_V2_WADTB_6_reg   (*((volatile unsigned int*) VO_V2_WADTB_6_reg))
+#define get_VO_V2_WADTB_7_reg   (*((volatile unsigned int*) VO_V2_WADTB_7_reg))
+#define get_VO_V2_WADTB_8_reg   (*((volatile unsigned int*) VO_V2_WADTB_8_reg))
+#define VO_V2_WADTB_0_inst_adr                                                       "0x0076"
+#define VO_V2_WADTB_1_inst_adr                                                       "0x0077"
+#define VO_V2_WADTB_2_inst_adr                                                       "0x0078"
+#define VO_V2_WADTB_3_inst_adr                                                       "0x0079"
+#define VO_V2_WADTB_4_inst_adr                                                       "0x007A"
+#define VO_V2_WADTB_5_inst_adr                                                       "0x007B"
+#define VO_V2_WADTB_6_inst_adr                                                       "0x007C"
+#define VO_V2_WADTB_7_inst_adr                                                       "0x007D"
+#define VO_V2_WADTB_8_inst_adr                                                       "0x007E"
+#define VO_V2_WADTB_0_inst                                                           0x0076
+#define VO_V2_WADTB_1_inst                                                           0x0077
+#define VO_V2_WADTB_2_inst                                                           0x0078
+#define VO_V2_WADTB_3_inst                                                           0x0079
+#define VO_V2_WADTB_4_inst                                                           0x007A
+#define VO_V2_WADTB_5_inst                                                           0x007B
+#define VO_V2_WADTB_6_inst                                                           0x007C
+#define VO_V2_WADTB_7_inst                                                           0x007D
+#define VO_V2_WADTB_8_inst                                                           0x007E
+#define VO_V2_WADTB_th_shift                                                         (16)
+#define VO_V2_WADTB_th_mask                                                          (0x00FF0000)
+#define VO_V2_WADTB_th(data)                                                         (0x00FF0000&((data)<<16))
+#define VO_V2_WADTB_th_src(data)                                                     ((0x00FF0000&(data))>>16)
+#define VO_V2_WADTB_get_th(data)                                                     ((0x00FF0000&(data))>>16)
+#define VO_V2_WADTB_wad_shift                                                        (0)
+#define VO_V2_WADTB_wad_mask                                                         (0x00000FFF)
+#define VO_V2_WADTB_wad(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V2_WADTB_wad_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V2_WADTB_get_wad(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V2_DI_YWIN                                                                0x980055FC
+#define VO_V2_DI_YWIN_reg_addr                                                       "0xD80055FC"
+#define VO_V2_DI_YWIN_reg                                                            0xD80055FC
+#define set_VO_V2_DI_YWIN_reg(data)   (*((volatile unsigned int*) VO_V2_DI_YWIN_reg)=data)
+#define get_VO_V2_DI_YWIN_reg   (*((volatile unsigned int*) VO_V2_DI_YWIN_reg))
+#define VO_V2_DI_YWIN_inst_adr                                                       "0x007F"
+#define VO_V2_DI_YWIN_inst                                                           0x007F
+#define VO_V2_DI_YWIN_e_shift                                                        (16)
+#define VO_V2_DI_YWIN_e_mask                                                         (0x0FFF0000)
+#define VO_V2_DI_YWIN_e(data)                                                        (0x0FFF0000&((data)<<16))
+#define VO_V2_DI_YWIN_e_src(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V2_DI_YWIN_get_e(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V2_DI_YWIN_s_shift                                                        (0)
+#define VO_V2_DI_YWIN_s_mask                                                         (0x00000FFF)
+#define VO_V2_DI_YWIN_s(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V2_DI_YWIN_s_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V2_DI_YWIN_get_s(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V2_DI_CWIN                                                                0x98005600
+#define VO_V2_DI_CWIN_reg_addr                                                       "0xD8005600"
+#define VO_V2_DI_CWIN_reg                                                            0xD8005600
+#define set_VO_V2_DI_CWIN_reg(data)   (*((volatile unsigned int*) VO_V2_DI_CWIN_reg)=data)
+#define get_VO_V2_DI_CWIN_reg   (*((volatile unsigned int*) VO_V2_DI_CWIN_reg))
+#define VO_V2_DI_CWIN_inst_adr                                                       "0x0080"
+#define VO_V2_DI_CWIN_inst                                                           0x0080
+#define VO_V2_DI_CWIN_e_shift                                                        (16)
+#define VO_V2_DI_CWIN_e_mask                                                         (0x0FFF0000)
+#define VO_V2_DI_CWIN_e(data)                                                        (0x0FFF0000&((data)<<16))
+#define VO_V2_DI_CWIN_e_src(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V2_DI_CWIN_get_e(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V2_DI_CWIN_s_shift                                                        (0)
+#define VO_V2_DI_CWIN_s_mask                                                         (0x00000FFF)
+#define VO_V2_DI_CWIN_s(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V2_DI_CWIN_s_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V2_DI_CWIN_get_s(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V2_DI_WINX                                                                0x98005604
+#define VO_V2_DI_WINX_reg_addr                                                       "0xD8005604"
+#define VO_V2_DI_WINX_reg                                                            0xD8005604
+#define set_VO_V2_DI_WINX_reg(data)   (*((volatile unsigned int*) VO_V2_DI_WINX_reg)=data)
+#define get_VO_V2_DI_WINX_reg   (*((volatile unsigned int*) VO_V2_DI_WINX_reg))
+#define VO_V2_DI_WINX_inst_adr                                                       "0x0081"
+#define VO_V2_DI_WINX_inst                                                           0x0081
+#define VO_V2_DI_WINX_e_shift                                                        (16)
+#define VO_V2_DI_WINX_e_mask                                                         (0x1FFF0000)
+#define VO_V2_DI_WINX_e(data)                                                        (0x1FFF0000&((data)<<16))
+#define VO_V2_DI_WINX_e_src(data)                                                    ((0x1FFF0000&(data))>>16)
+#define VO_V2_DI_WINX_get_e(data)                                                    ((0x1FFF0000&(data))>>16)
+#define VO_V2_DI_WINX_s_shift                                                        (0)
+#define VO_V2_DI_WINX_s_mask                                                         (0x00001FFF)
+#define VO_V2_DI_WINX_s(data)                                                        (0x00001FFF&((data)<<0))
+#define VO_V2_DI_WINX_s_src(data)                                                    ((0x00001FFF&(data))>>0)
+#define VO_V2_DI_WINX_get_s(data)                                                    ((0x00001FFF&(data))>>0)
+
+
+#define VO_V2_FILM_SWAD_0                                                            0x98005608
+#define VO_V2_FILM_SWAD_1                                                            0x9800560C
+#define VO_V2_FILM_SWAD_2                                                            0x98005610
+#define VO_V2_FILM_SWAD_3                                                            0x98005614
+#define VO_V2_FILM_SWAD_4                                                            0x98005618
+#define VO_V2_FILM_SWAD_5                                                            0x9800561C
+#define VO_V2_FILM_SWAD_0_reg_addr                                                   "0xD8005608"
+#define VO_V2_FILM_SWAD_1_reg_addr                                                   "0xD800560C"
+#define VO_V2_FILM_SWAD_2_reg_addr                                                   "0xD8005610"
+#define VO_V2_FILM_SWAD_3_reg_addr                                                   "0xD8005614"
+#define VO_V2_FILM_SWAD_4_reg_addr                                                   "0xD8005618"
+#define VO_V2_FILM_SWAD_5_reg_addr                                                   "0xD800561C"
+#define VO_V2_FILM_SWAD_0_reg                                                        0xD8005608
+#define VO_V2_FILM_SWAD_1_reg                                                        0xD800560C
+#define VO_V2_FILM_SWAD_2_reg                                                        0xD8005610
+#define VO_V2_FILM_SWAD_3_reg                                                        0xD8005614
+#define VO_V2_FILM_SWAD_4_reg                                                        0xD8005618
+#define VO_V2_FILM_SWAD_5_reg                                                        0xD800561C
+#define set_VO_V2_FILM_SWAD_0_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_SWAD_0_reg)=data)
+#define set_VO_V2_FILM_SWAD_1_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_SWAD_1_reg)=data)
+#define set_VO_V2_FILM_SWAD_2_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_SWAD_2_reg)=data)
+#define set_VO_V2_FILM_SWAD_3_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_SWAD_3_reg)=data)
+#define set_VO_V2_FILM_SWAD_4_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_SWAD_4_reg)=data)
+#define set_VO_V2_FILM_SWAD_5_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_SWAD_5_reg)=data)
+#define get_VO_V2_FILM_SWAD_0_reg   (*((volatile unsigned int*) VO_V2_FILM_SWAD_0_reg))
+#define get_VO_V2_FILM_SWAD_1_reg   (*((volatile unsigned int*) VO_V2_FILM_SWAD_1_reg))
+#define get_VO_V2_FILM_SWAD_2_reg   (*((volatile unsigned int*) VO_V2_FILM_SWAD_2_reg))
+#define get_VO_V2_FILM_SWAD_3_reg   (*((volatile unsigned int*) VO_V2_FILM_SWAD_3_reg))
+#define get_VO_V2_FILM_SWAD_4_reg   (*((volatile unsigned int*) VO_V2_FILM_SWAD_4_reg))
+#define get_VO_V2_FILM_SWAD_5_reg   (*((volatile unsigned int*) VO_V2_FILM_SWAD_5_reg))
+#define VO_V2_FILM_SWAD_0_inst_adr                                                   "0x0082"
+#define VO_V2_FILM_SWAD_1_inst_adr                                                   "0x0083"
+#define VO_V2_FILM_SWAD_2_inst_adr                                                   "0x0084"
+#define VO_V2_FILM_SWAD_3_inst_adr                                                   "0x0085"
+#define VO_V2_FILM_SWAD_4_inst_adr                                                   "0x0086"
+#define VO_V2_FILM_SWAD_5_inst_adr                                                   "0x0087"
+#define VO_V2_FILM_SWAD_0_inst                                                       0x0082
+#define VO_V2_FILM_SWAD_1_inst                                                       0x0083
+#define VO_V2_FILM_SWAD_2_inst                                                       0x0084
+#define VO_V2_FILM_SWAD_3_inst                                                       0x0085
+#define VO_V2_FILM_SWAD_4_inst                                                       0x0086
+#define VO_V2_FILM_SWAD_5_inst                                                       0x0087
+#define VO_V2_FILM_SWAD_swad_shift                                                   (0)
+#define VO_V2_FILM_SWAD_swad_mask                                                    (0x07FFFFFF)
+#define VO_V2_FILM_SWAD_swad(data)                                                   (0x07FFFFFF&((data)<<0))
+#define VO_V2_FILM_SWAD_swad_src(data)                                               ((0x07FFFFFF&(data))>>0)
+#define VO_V2_FILM_SWAD_get_swad(data)                                               ((0x07FFFFFF&(data))>>0)
+
+
+#define VO_V2_FILM_TH_0                                                              0x98005620
+#define VO_V2_FILM_TH_1                                                              0x98005624
+#define VO_V2_FILM_TH_2                                                              0x98005628
+#define VO_V2_FILM_TH_3                                                              0x9800562C
+#define VO_V2_FILM_TH_4                                                              0x98005630
+#define VO_V2_FILM_TH_5                                                              0x98005634
+#define VO_V2_FILM_TH_0_reg_addr                                                     "0xD8005620"
+#define VO_V2_FILM_TH_1_reg_addr                                                     "0xD8005624"
+#define VO_V2_FILM_TH_2_reg_addr                                                     "0xD8005628"
+#define VO_V2_FILM_TH_3_reg_addr                                                     "0xD800562C"
+#define VO_V2_FILM_TH_4_reg_addr                                                     "0xD8005630"
+#define VO_V2_FILM_TH_5_reg_addr                                                     "0xD8005634"
+#define VO_V2_FILM_TH_0_reg                                                          0xD8005620
+#define VO_V2_FILM_TH_1_reg                                                          0xD8005624
+#define VO_V2_FILM_TH_2_reg                                                          0xD8005628
+#define VO_V2_FILM_TH_3_reg                                                          0xD800562C
+#define VO_V2_FILM_TH_4_reg                                                          0xD8005630
+#define VO_V2_FILM_TH_5_reg                                                          0xD8005634
+#define set_VO_V2_FILM_TH_0_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_TH_0_reg)=data)
+#define set_VO_V2_FILM_TH_1_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_TH_1_reg)=data)
+#define set_VO_V2_FILM_TH_2_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_TH_2_reg)=data)
+#define set_VO_V2_FILM_TH_3_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_TH_3_reg)=data)
+#define set_VO_V2_FILM_TH_4_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_TH_4_reg)=data)
+#define set_VO_V2_FILM_TH_5_reg(data)   (*((volatile unsigned int*) VO_V2_FILM_TH_5_reg)=data)
+#define get_VO_V2_FILM_TH_0_reg   (*((volatile unsigned int*) VO_V2_FILM_TH_0_reg))
+#define get_VO_V2_FILM_TH_1_reg   (*((volatile unsigned int*) VO_V2_FILM_TH_1_reg))
+#define get_VO_V2_FILM_TH_2_reg   (*((volatile unsigned int*) VO_V2_FILM_TH_2_reg))
+#define get_VO_V2_FILM_TH_3_reg   (*((volatile unsigned int*) VO_V2_FILM_TH_3_reg))
+#define get_VO_V2_FILM_TH_4_reg   (*((volatile unsigned int*) VO_V2_FILM_TH_4_reg))
+#define get_VO_V2_FILM_TH_5_reg   (*((volatile unsigned int*) VO_V2_FILM_TH_5_reg))
+#define VO_V2_FILM_TH_0_inst_adr                                                     "0x0088"
+#define VO_V2_FILM_TH_1_inst_adr                                                     "0x0089"
+#define VO_V2_FILM_TH_2_inst_adr                                                     "0x008A"
+#define VO_V2_FILM_TH_3_inst_adr                                                     "0x008B"
+#define VO_V2_FILM_TH_4_inst_adr                                                     "0x008C"
+#define VO_V2_FILM_TH_5_inst_adr                                                     "0x008D"
+#define VO_V2_FILM_TH_0_inst                                                         0x0088
+#define VO_V2_FILM_TH_1_inst                                                         0x0089
+#define VO_V2_FILM_TH_2_inst                                                         0x008A
+#define VO_V2_FILM_TH_3_inst                                                         0x008B
+#define VO_V2_FILM_TH_4_inst                                                         0x008C
+#define VO_V2_FILM_TH_5_inst                                                         0x008D
+#define VO_V2_FILM_TH_th_shift                                                       (0)
+#define VO_V2_FILM_TH_th_mask                                                        (0x07FFFFFF)
+#define VO_V2_FILM_TH_th(data)                                                       (0x07FFFFFF&((data)<<0))
+#define VO_V2_FILM_TH_th_src(data)                                                   ((0x07FFFFFF&(data))>>0)
+#define VO_V2_FILM_TH_get_th(data)                                                   ((0x07FFFFFF&(data))>>0)
+
+
+#define VO_V2_DI_DBG                                                                 0x98005638
+#define VO_V2_DI_DBG_reg_addr                                                        "0xD8005638"
+#define VO_V2_DI_DBG_reg                                                             0xD8005638
+#define set_VO_V2_DI_DBG_reg(data)   (*((volatile unsigned int*) VO_V2_DI_DBG_reg)=data)
+#define get_VO_V2_DI_DBG_reg   (*((volatile unsigned int*) VO_V2_DI_DBG_reg))
+#define VO_V2_DI_DBG_inst_adr                                                        "0x008E"
+#define VO_V2_DI_DBG_inst                                                            0x008E
+#define VO_V2_DI_DBG_mode_shift                                                      (0)
+#define VO_V2_DI_DBG_mode_mask                                                       (0x00000007)
+#define VO_V2_DI_DBG_mode(data)                                                      (0x00000007&((data)<<0))
+#define VO_V2_DI_DBG_mode_src(data)                                                  ((0x00000007&(data))>>0)
+#define VO_V2_DI_DBG_get_mode(data)                                                  ((0x00000007&(data))>>0)
+
+
+#define VO_V2_NEW_DI                                                                 0x9800563C
+#define VO_V2_NEW_DI_reg_addr                                                        "0xD800563C"
+#define VO_V2_NEW_DI_reg                                                             0xD800563C
+#define set_VO_V2_NEW_DI_reg(data)   (*((volatile unsigned int*) VO_V2_NEW_DI_reg)=data)
+#define get_VO_V2_NEW_DI_reg   (*((volatile unsigned int*) VO_V2_NEW_DI_reg))
+#define VO_V2_NEW_DI_inst_adr                                                        "0x008F"
+#define VO_V2_NEW_DI_inst                                                            0x008F
+#define VO_V2_NEW_DI_dbg_bob_shift                                                   (27)
+#define VO_V2_NEW_DI_dbg_bob_mask                                                    (0x08000000)
+#define VO_V2_NEW_DI_dbg_bob(data)                                                   (0x08000000&((data)<<27))
+#define VO_V2_NEW_DI_dbg_bob_src(data)                                               ((0x08000000&(data))>>27)
+#define VO_V2_NEW_DI_get_dbg_bob(data)                                               ((0x08000000&(data))>>27)
+#define VO_V2_NEW_DI_dbg_chk_area_shift                                              (26)
+#define VO_V2_NEW_DI_dbg_chk_area_mask                                               (0x04000000)
+#define VO_V2_NEW_DI_dbg_chk_area(data)                                              (0x04000000&((data)<<26))
+#define VO_V2_NEW_DI_dbg_chk_area_src(data)                                          ((0x04000000&(data))>>26)
+#define VO_V2_NEW_DI_get_dbg_chk_area(data)                                          ((0x04000000&(data))>>26)
+#define VO_V2_NEW_DI_dbg_combing_shift                                               (25)
+#define VO_V2_NEW_DI_dbg_combing_mask                                                (0x02000000)
+#define VO_V2_NEW_DI_dbg_combing(data)                                               (0x02000000&((data)<<25))
+#define VO_V2_NEW_DI_dbg_combing_src(data)                                           ((0x02000000&(data))>>25)
+#define VO_V2_NEW_DI_get_dbg_combing(data)                                           ((0x02000000&(data))>>25)
+#define VO_V2_NEW_DI_dbg_blend_ratio_shift                                           (24)
+#define VO_V2_NEW_DI_dbg_blend_ratio_mask                                            (0x01000000)
+#define VO_V2_NEW_DI_dbg_blend_ratio(data)                                           (0x01000000&((data)<<24))
+#define VO_V2_NEW_DI_dbg_blend_ratio_src(data)                                       ((0x01000000&(data))>>24)
+#define VO_V2_NEW_DI_get_dbg_blend_ratio(data)                                       ((0x01000000&(data))>>24)
+#define VO_V2_NEW_DI_bob_chk2_en_shift                                               (18)
+#define VO_V2_NEW_DI_bob_chk2_en_mask                                                (0x00040000)
+#define VO_V2_NEW_DI_bob_chk2_en(data)                                               (0x00040000&((data)<<18))
+#define VO_V2_NEW_DI_bob_chk2_en_src(data)                                           ((0x00040000&(data))>>18)
+#define VO_V2_NEW_DI_get_bob_chk2_en(data)                                           ((0x00040000&(data))>>18)
+#define VO_V2_NEW_DI_bob_chk1_en_shift                                               (17)
+#define VO_V2_NEW_DI_bob_chk1_en_mask                                                (0x00020000)
+#define VO_V2_NEW_DI_bob_chk1_en(data)                                               (0x00020000&((data)<<17))
+#define VO_V2_NEW_DI_bob_chk1_en_src(data)                                           ((0x00020000&(data))>>17)
+#define VO_V2_NEW_DI_get_bob_chk1_en(data)                                           ((0x00020000&(data))>>17)
+#define VO_V2_NEW_DI_bob_chk0_en_shift                                               (16)
+#define VO_V2_NEW_DI_bob_chk0_en_mask                                                (0x00010000)
+#define VO_V2_NEW_DI_bob_chk0_en(data)                                               (0x00010000&((data)<<16))
+#define VO_V2_NEW_DI_bob_chk0_en_src(data)                                           ((0x00010000&(data))>>16)
+#define VO_V2_NEW_DI_get_bob_chk0_en(data)                                           ((0x00010000&(data))>>16)
+#define VO_V2_NEW_DI_escape_en_shift                                                 (12)
+#define VO_V2_NEW_DI_escape_en_mask                                                  (0x00001000)
+#define VO_V2_NEW_DI_escape_en(data)                                                 (0x00001000&((data)<<12))
+#define VO_V2_NEW_DI_escape_en_src(data)                                             ((0x00001000&(data))>>12)
+#define VO_V2_NEW_DI_get_escape_en(data)                                             ((0x00001000&(data))>>12)
+#define VO_V2_NEW_DI_use_wb_diff_shift                                               (11)
+#define VO_V2_NEW_DI_use_wb_diff_mask                                                (0x00000800)
+#define VO_V2_NEW_DI_use_wb_diff(data)                                               (0x00000800&((data)<<11))
+#define VO_V2_NEW_DI_use_wb_diff_src(data)                                           ((0x00000800&(data))>>11)
+#define VO_V2_NEW_DI_get_use_wb_diff(data)                                           ((0x00000800&(data))>>11)
+#define VO_V2_NEW_DI_wb_max_diff_shift                                               (10)
+#define VO_V2_NEW_DI_wb_max_diff_mask                                                (0x00000400)
+#define VO_V2_NEW_DI_wb_max_diff(data)                                               (0x00000400&((data)<<10))
+#define VO_V2_NEW_DI_wb_max_diff_src(data)                                           ((0x00000400&(data))>>10)
+#define VO_V2_NEW_DI_get_wb_max_diff(data)                                           ((0x00000400&(data))>>10)
+#define VO_V2_NEW_DI_wb_chk_result_shift                                             (9)
+#define VO_V2_NEW_DI_wb_chk_result_mask                                              (0x00000200)
+#define VO_V2_NEW_DI_wb_chk_result(data)                                             (0x00000200&((data)<<9))
+#define VO_V2_NEW_DI_wb_chk_result_src(data)                                         ((0x00000200&(data))>>9)
+#define VO_V2_NEW_DI_get_wb_chk_result(data)                                         ((0x00000200&(data))>>9)
+#define VO_V2_NEW_DI_chk_use_max_mf_shift                                            (8)
+#define VO_V2_NEW_DI_chk_use_max_mf_mask                                             (0x00000100)
+#define VO_V2_NEW_DI_chk_use_max_mf(data)                                            (0x00000100&((data)<<8))
+#define VO_V2_NEW_DI_chk_use_max_mf_src(data)                                        ((0x00000100&(data))>>8)
+#define VO_V2_NEW_DI_get_chk_use_max_mf(data)                                        ((0x00000100&(data))>>8)
+#define VO_V2_NEW_DI_comb_chk_en_shift                                               (7)
+#define VO_V2_NEW_DI_comb_chk_en_mask                                                (0x00000080)
+#define VO_V2_NEW_DI_comb_chk_en(data)                                               (0x00000080&((data)<<7))
+#define VO_V2_NEW_DI_comb_chk_en_src(data)                                           ((0x00000080&(data))>>7)
+#define VO_V2_NEW_DI_get_comb_chk_en(data)                                           ((0x00000080&(data))>>7)
+#define VO_V2_NEW_DI_mf_select_shift                                                 (6)
+#define VO_V2_NEW_DI_mf_select_mask                                                  (0x00000040)
+#define VO_V2_NEW_DI_mf_select(data)                                                 (0x00000040&((data)<<6))
+#define VO_V2_NEW_DI_mf_select_src(data)                                             ((0x00000040&(data))>>6)
+#define VO_V2_NEW_DI_get_mf_select(data)                                             ((0x00000040&(data))>>6)
+#define VO_V2_NEW_DI_mf_lpf_enable_shift                                             (5)
+#define VO_V2_NEW_DI_mf_lpf_enable_mask                                              (0x00000020)
+#define VO_V2_NEW_DI_mf_lpf_enable(data)                                             (0x00000020&((data)<<5))
+#define VO_V2_NEW_DI_mf_lpf_enable_src(data)                                         ((0x00000020&(data))>>5)
+#define VO_V2_NEW_DI_get_mf_lpf_enable(data)                                         ((0x00000020&(data))>>5)
+#define VO_V2_NEW_DI_use_lpf_data_shift                                              (4)
+#define VO_V2_NEW_DI_use_lpf_data_mask                                               (0x00000010)
+#define VO_V2_NEW_DI_use_lpf_data(data)                                              (0x00000010&((data)<<4))
+#define VO_V2_NEW_DI_use_lpf_data_src(data)                                          ((0x00000010&(data))>>4)
+#define VO_V2_NEW_DI_get_use_lpf_data(data)                                          ((0x00000010&(data))>>4)
+#define VO_V2_NEW_DI_light_comb_en_shift                                             (3)
+#define VO_V2_NEW_DI_light_comb_en_mask                                              (0x00000008)
+#define VO_V2_NEW_DI_light_comb_en(data)                                             (0x00000008&((data)<<3))
+#define VO_V2_NEW_DI_light_comb_en_src(data)                                         ((0x00000008&(data))>>3)
+#define VO_V2_NEW_DI_get_light_comb_en(data)                                         ((0x00000008&(data))>>3)
+#define VO_V2_NEW_DI_cu_shift                                                        (2)
+#define VO_V2_NEW_DI_cu_mask                                                         (0x00000004)
+#define VO_V2_NEW_DI_cu(data)                                                        (0x00000004&((data)<<2))
+#define VO_V2_NEW_DI_cu_src(data)                                                    ((0x00000004&(data))>>2)
+#define VO_V2_NEW_DI_get_cu(data)                                                    ((0x00000004&(data))>>2)
+#define VO_V2_NEW_DI_en_shift                                                        (1)
+#define VO_V2_NEW_DI_en_mask                                                         (0x00000002)
+#define VO_V2_NEW_DI_en(data)                                                        (0x00000002&((data)<<1))
+#define VO_V2_NEW_DI_en_src(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V2_NEW_DI_get_en(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V2_NEW_DI_write_data_shift                                                (0)
+#define VO_V2_NEW_DI_write_data_mask                                                 (0x00000001)
+#define VO_V2_NEW_DI_write_data(data)                                                (0x00000001&((data)<<0))
+#define VO_V2_NEW_DI_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_V2_NEW_DI_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VO_V2_DI_LPF1X5                                                              0x98005640
+#define VO_V2_DI_LPF1X5_reg_addr                                                     "0xD8005640"
+#define VO_V2_DI_LPF1X5_reg                                                          0xD8005640
+#define set_VO_V2_DI_LPF1X5_reg(data)   (*((volatile unsigned int*) VO_V2_DI_LPF1X5_reg)=data)
+#define get_VO_V2_DI_LPF1X5_reg   (*((volatile unsigned int*) VO_V2_DI_LPF1X5_reg))
+#define VO_V2_DI_LPF1X5_inst_adr                                                     "0x0090"
+#define VO_V2_DI_LPF1X5_inst                                                         0x0090
+#define VO_V2_DI_LPF1X5_c4_shift                                                     (16)
+#define VO_V2_DI_LPF1X5_c4_mask                                                      (0x00070000)
+#define VO_V2_DI_LPF1X5_c4(data)                                                     (0x00070000&((data)<<16))
+#define VO_V2_DI_LPF1X5_c4_src(data)                                                 ((0x00070000&(data))>>16)
+#define VO_V2_DI_LPF1X5_get_c4(data)                                                 ((0x00070000&(data))>>16)
+#define VO_V2_DI_LPF1X5_c3_shift                                                     (12)
+#define VO_V2_DI_LPF1X5_c3_mask                                                      (0x00007000)
+#define VO_V2_DI_LPF1X5_c3(data)                                                     (0x00007000&((data)<<12))
+#define VO_V2_DI_LPF1X5_c3_src(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V2_DI_LPF1X5_get_c3(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V2_DI_LPF1X5_c2_shift                                                     (8)
+#define VO_V2_DI_LPF1X5_c2_mask                                                      (0x00000700)
+#define VO_V2_DI_LPF1X5_c2(data)                                                     (0x00000700&((data)<<8))
+#define VO_V2_DI_LPF1X5_c2_src(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V2_DI_LPF1X5_get_c2(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V2_DI_LPF1X5_c1_shift                                                     (4)
+#define VO_V2_DI_LPF1X5_c1_mask                                                      (0x00000070)
+#define VO_V2_DI_LPF1X5_c1(data)                                                     (0x00000070&((data)<<4))
+#define VO_V2_DI_LPF1X5_c1_src(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V2_DI_LPF1X5_get_c1(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V2_DI_LPF1X5_c0_shift                                                     (0)
+#define VO_V2_DI_LPF1X5_c0_mask                                                      (0x00000007)
+#define VO_V2_DI_LPF1X5_c0(data)                                                     (0x00000007&((data)<<0))
+#define VO_V2_DI_LPF1X5_c0_src(data)                                                 ((0x00000007&(data))>>0)
+#define VO_V2_DI_LPF1X5_get_c0(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define VO_V2_DI_LPF3X5_T                                                            0x98005644
+#define VO_V2_DI_LPF3X5_T_reg_addr                                                   "0xD8005644"
+#define VO_V2_DI_LPF3X5_T_reg                                                        0xD8005644
+#define set_VO_V2_DI_LPF3X5_T_reg(data)   (*((volatile unsigned int*) VO_V2_DI_LPF3X5_T_reg)=data)
+#define get_VO_V2_DI_LPF3X5_T_reg   (*((volatile unsigned int*) VO_V2_DI_LPF3X5_T_reg))
+#define VO_V2_DI_LPF3X5_T_inst_adr                                                   "0x0091"
+#define VO_V2_DI_LPF3X5_T_inst                                                       0x0091
+#define VO_V2_DI_LPF3X5_T_c4_shift                                                   (16)
+#define VO_V2_DI_LPF3X5_T_c4_mask                                                    (0x00070000)
+#define VO_V2_DI_LPF3X5_T_c4(data)                                                   (0x00070000&((data)<<16))
+#define VO_V2_DI_LPF3X5_T_c4_src(data)                                               ((0x00070000&(data))>>16)
+#define VO_V2_DI_LPF3X5_T_get_c4(data)                                               ((0x00070000&(data))>>16)
+#define VO_V2_DI_LPF3X5_T_c3_shift                                                   (12)
+#define VO_V2_DI_LPF3X5_T_c3_mask                                                    (0x00007000)
+#define VO_V2_DI_LPF3X5_T_c3(data)                                                   (0x00007000&((data)<<12))
+#define VO_V2_DI_LPF3X5_T_c3_src(data)                                               ((0x00007000&(data))>>12)
+#define VO_V2_DI_LPF3X5_T_get_c3(data)                                               ((0x00007000&(data))>>12)
+#define VO_V2_DI_LPF3X5_T_c2_shift                                                   (8)
+#define VO_V2_DI_LPF3X5_T_c2_mask                                                    (0x00000700)
+#define VO_V2_DI_LPF3X5_T_c2(data)                                                   (0x00000700&((data)<<8))
+#define VO_V2_DI_LPF3X5_T_c2_src(data)                                               ((0x00000700&(data))>>8)
+#define VO_V2_DI_LPF3X5_T_get_c2(data)                                               ((0x00000700&(data))>>8)
+#define VO_V2_DI_LPF3X5_T_c1_shift                                                   (4)
+#define VO_V2_DI_LPF3X5_T_c1_mask                                                    (0x00000070)
+#define VO_V2_DI_LPF3X5_T_c1(data)                                                   (0x00000070&((data)<<4))
+#define VO_V2_DI_LPF3X5_T_c1_src(data)                                               ((0x00000070&(data))>>4)
+#define VO_V2_DI_LPF3X5_T_get_c1(data)                                               ((0x00000070&(data))>>4)
+#define VO_V2_DI_LPF3X5_T_c0_shift                                                   (0)
+#define VO_V2_DI_LPF3X5_T_c0_mask                                                    (0x00000007)
+#define VO_V2_DI_LPF3X5_T_c0(data)                                                   (0x00000007&((data)<<0))
+#define VO_V2_DI_LPF3X5_T_c0_src(data)                                               ((0x00000007&(data))>>0)
+#define VO_V2_DI_LPF3X5_T_get_c0(data)                                               ((0x00000007&(data))>>0)
+
+
+#define VO_V2_DI_LPF3X5_C                                                            0x98005648
+#define VO_V2_DI_LPF3X5_C_reg_addr                                                   "0xD8005648"
+#define VO_V2_DI_LPF3X5_C_reg                                                        0xD8005648
+#define set_VO_V2_DI_LPF3X5_C_reg(data)   (*((volatile unsigned int*) VO_V2_DI_LPF3X5_C_reg)=data)
+#define get_VO_V2_DI_LPF3X5_C_reg   (*((volatile unsigned int*) VO_V2_DI_LPF3X5_C_reg))
+#define VO_V2_DI_LPF3X5_C_inst_adr                                                   "0x0092"
+#define VO_V2_DI_LPF3X5_C_inst                                                       0x0092
+#define VO_V2_DI_LPF3X5_C_c4_shift                                                   (16)
+#define VO_V2_DI_LPF3X5_C_c4_mask                                                    (0x00070000)
+#define VO_V2_DI_LPF3X5_C_c4(data)                                                   (0x00070000&((data)<<16))
+#define VO_V2_DI_LPF3X5_C_c4_src(data)                                               ((0x00070000&(data))>>16)
+#define VO_V2_DI_LPF3X5_C_get_c4(data)                                               ((0x00070000&(data))>>16)
+#define VO_V2_DI_LPF3X5_C_c3_shift                                                   (12)
+#define VO_V2_DI_LPF3X5_C_c3_mask                                                    (0x00007000)
+#define VO_V2_DI_LPF3X5_C_c3(data)                                                   (0x00007000&((data)<<12))
+#define VO_V2_DI_LPF3X5_C_c3_src(data)                                               ((0x00007000&(data))>>12)
+#define VO_V2_DI_LPF3X5_C_get_c3(data)                                               ((0x00007000&(data))>>12)
+#define VO_V2_DI_LPF3X5_C_c2_shift                                                   (8)
+#define VO_V2_DI_LPF3X5_C_c2_mask                                                    (0x00000700)
+#define VO_V2_DI_LPF3X5_C_c2(data)                                                   (0x00000700&((data)<<8))
+#define VO_V2_DI_LPF3X5_C_c2_src(data)                                               ((0x00000700&(data))>>8)
+#define VO_V2_DI_LPF3X5_C_get_c2(data)                                               ((0x00000700&(data))>>8)
+#define VO_V2_DI_LPF3X5_C_c1_shift                                                   (4)
+#define VO_V2_DI_LPF3X5_C_c1_mask                                                    (0x00000070)
+#define VO_V2_DI_LPF3X5_C_c1(data)                                                   (0x00000070&((data)<<4))
+#define VO_V2_DI_LPF3X5_C_c1_src(data)                                               ((0x00000070&(data))>>4)
+#define VO_V2_DI_LPF3X5_C_get_c1(data)                                               ((0x00000070&(data))>>4)
+#define VO_V2_DI_LPF3X5_C_c0_shift                                                   (0)
+#define VO_V2_DI_LPF3X5_C_c0_mask                                                    (0x00000007)
+#define VO_V2_DI_LPF3X5_C_c0(data)                                                   (0x00000007&((data)<<0))
+#define VO_V2_DI_LPF3X5_C_c0_src(data)                                               ((0x00000007&(data))>>0)
+#define VO_V2_DI_LPF3X5_C_get_c0(data)                                               ((0x00000007&(data))>>0)
+
+
+#define VO_V2_DI_LPF3X5_B                                                            0x9800564C
+#define VO_V2_DI_LPF3X5_B_reg_addr                                                   "0xD800564C"
+#define VO_V2_DI_LPF3X5_B_reg                                                        0xD800564C
+#define set_VO_V2_DI_LPF3X5_B_reg(data)   (*((volatile unsigned int*) VO_V2_DI_LPF3X5_B_reg)=data)
+#define get_VO_V2_DI_LPF3X5_B_reg   (*((volatile unsigned int*) VO_V2_DI_LPF3X5_B_reg))
+#define VO_V2_DI_LPF3X5_B_inst_adr                                                   "0x0093"
+#define VO_V2_DI_LPF3X5_B_inst                                                       0x0093
+#define VO_V2_DI_LPF3X5_B_c4_shift                                                   (16)
+#define VO_V2_DI_LPF3X5_B_c4_mask                                                    (0x00070000)
+#define VO_V2_DI_LPF3X5_B_c4(data)                                                   (0x00070000&((data)<<16))
+#define VO_V2_DI_LPF3X5_B_c4_src(data)                                               ((0x00070000&(data))>>16)
+#define VO_V2_DI_LPF3X5_B_get_c4(data)                                               ((0x00070000&(data))>>16)
+#define VO_V2_DI_LPF3X5_B_c3_shift                                                   (12)
+#define VO_V2_DI_LPF3X5_B_c3_mask                                                    (0x00007000)
+#define VO_V2_DI_LPF3X5_B_c3(data)                                                   (0x00007000&((data)<<12))
+#define VO_V2_DI_LPF3X5_B_c3_src(data)                                               ((0x00007000&(data))>>12)
+#define VO_V2_DI_LPF3X5_B_get_c3(data)                                               ((0x00007000&(data))>>12)
+#define VO_V2_DI_LPF3X5_B_c2_shift                                                   (8)
+#define VO_V2_DI_LPF3X5_B_c2_mask                                                    (0x00000700)
+#define VO_V2_DI_LPF3X5_B_c2(data)                                                   (0x00000700&((data)<<8))
+#define VO_V2_DI_LPF3X5_B_c2_src(data)                                               ((0x00000700&(data))>>8)
+#define VO_V2_DI_LPF3X5_B_get_c2(data)                                               ((0x00000700&(data))>>8)
+#define VO_V2_DI_LPF3X5_B_c1_shift                                                   (4)
+#define VO_V2_DI_LPF3X5_B_c1_mask                                                    (0x00000070)
+#define VO_V2_DI_LPF3X5_B_c1(data)                                                   (0x00000070&((data)<<4))
+#define VO_V2_DI_LPF3X5_B_c1_src(data)                                               ((0x00000070&(data))>>4)
+#define VO_V2_DI_LPF3X5_B_get_c1(data)                                               ((0x00000070&(data))>>4)
+#define VO_V2_DI_LPF3X5_B_c0_shift                                                   (0)
+#define VO_V2_DI_LPF3X5_B_c0_mask                                                    (0x00000007)
+#define VO_V2_DI_LPF3X5_B_c0(data)                                                   (0x00000007&((data)<<0))
+#define VO_V2_DI_LPF3X5_B_c0_src(data)                                               ((0x00000007&(data))>>0)
+#define VO_V2_DI_LPF3X5_B_get_c0(data)                                               ((0x00000007&(data))>>0)
+
+
+#define VO_V2_DI_MF                                                                  0x98005650
+#define VO_V2_DI_MF_reg_addr                                                         "0xD8005650"
+#define VO_V2_DI_MF_reg                                                              0xD8005650
+#define set_VO_V2_DI_MF_reg(data)   (*((volatile unsigned int*) VO_V2_DI_MF_reg)=data)
+#define get_VO_V2_DI_MF_reg   (*((volatile unsigned int*) VO_V2_DI_MF_reg))
+#define VO_V2_DI_MF_inst_adr                                                         "0x0094"
+#define VO_V2_DI_MF_inst                                                             0x0094
+#define VO_V2_DI_MF_r_shift                                                          (22)
+#define VO_V2_DI_MF_r_mask                                                           (0xFFC00000)
+#define VO_V2_DI_MF_r(data)                                                          (0xFFC00000&((data)<<22))
+#define VO_V2_DI_MF_r_src(data)                                                      ((0xFFC00000&(data))>>22)
+#define VO_V2_DI_MF_get_r(data)                                                      ((0xFFC00000&(data))>>22)
+#define VO_V2_DI_MF_expand_range_shift                                               (16)
+#define VO_V2_DI_MF_expand_range_mask                                                (0x00030000)
+#define VO_V2_DI_MF_expand_range(data)                                               (0x00030000&((data)<<16))
+#define VO_V2_DI_MF_expand_range_src(data)                                           ((0x00030000&(data))>>16)
+#define VO_V2_DI_MF_get_expand_range(data)                                           ((0x00030000&(data))>>16)
+#define VO_V2_DI_MF_h_th_shift                                                       (8)
+#define VO_V2_DI_MF_h_th_mask                                                        (0x0000FF00)
+#define VO_V2_DI_MF_h_th(data)                                                       (0x0000FF00&((data)<<8))
+#define VO_V2_DI_MF_h_th_src(data)                                                   ((0x0000FF00&(data))>>8)
+#define VO_V2_DI_MF_get_h_th(data)                                                   ((0x0000FF00&(data))>>8)
+#define VO_V2_DI_MF_l_th_shift                                                       (0)
+#define VO_V2_DI_MF_l_th_mask                                                        (0x000000FF)
+#define VO_V2_DI_MF_l_th(data)                                                       (0x000000FF&((data)<<0))
+#define VO_V2_DI_MF_l_th_src(data)                                                   ((0x000000FF&(data))>>0)
+#define VO_V2_DI_MF_get_l_th(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_COMB                                                                0x98005654
+#define VO_V2_DI_COMB_reg_addr                                                       "0xD8005654"
+#define VO_V2_DI_COMB_reg                                                            0xD8005654
+#define set_VO_V2_DI_COMB_reg(data)   (*((volatile unsigned int*) VO_V2_DI_COMB_reg)=data)
+#define get_VO_V2_DI_COMB_reg   (*((volatile unsigned int*) VO_V2_DI_COMB_reg))
+#define VO_V2_DI_COMB_inst_adr                                                       "0x0095"
+#define VO_V2_DI_COMB_inst                                                           0x0095
+#define VO_V2_DI_COMB_thd_shift                                                      (0)
+#define VO_V2_DI_COMB_thd_mask                                                       (0x000000FF)
+#define VO_V2_DI_COMB_thd(data)                                                      (0x000000FF&((data)<<0))
+#define VO_V2_DI_COMB_thd_src(data)                                                  ((0x000000FF&(data))>>0)
+#define VO_V2_DI_COMB_get_thd(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_COMB_CHK                                                            0x98005658
+#define VO_V2_DI_COMB_CHK_reg_addr                                                   "0xD8005658"
+#define VO_V2_DI_COMB_CHK_reg                                                        0xD8005658
+#define set_VO_V2_DI_COMB_CHK_reg(data)   (*((volatile unsigned int*) VO_V2_DI_COMB_CHK_reg)=data)
+#define get_VO_V2_DI_COMB_CHK_reg   (*((volatile unsigned int*) VO_V2_DI_COMB_CHK_reg))
+#define VO_V2_DI_COMB_CHK_inst_adr                                                   "0x0096"
+#define VO_V2_DI_COMB_CHK_inst                                                       0x0096
+#define VO_V2_DI_COMB_CHK_h_th_shift                                                 (16)
+#define VO_V2_DI_COMB_CHK_h_th_mask                                                  (0x00FF0000)
+#define VO_V2_DI_COMB_CHK_h_th(data)                                                 (0x00FF0000&((data)<<16))
+#define VO_V2_DI_COMB_CHK_h_th_src(data)                                             ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_COMB_CHK_get_h_th(data)                                             ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_COMB_CHK_l_th_shift                                                 (0)
+#define VO_V2_DI_COMB_CHK_l_th_mask                                                  (0x000000FF)
+#define VO_V2_DI_COMB_CHK_l_th(data)                                                 (0x000000FF&((data)<<0))
+#define VO_V2_DI_COMB_CHK_l_th_src(data)                                             ((0x000000FF&(data))>>0)
+#define VO_V2_DI_COMB_CHK_get_l_th(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_COMB_CNT                                                            0x9800565C
+#define VO_V2_DI_COMB_CNT_reg_addr                                                   "0xD800565C"
+#define VO_V2_DI_COMB_CNT_reg                                                        0xD800565C
+#define set_VO_V2_DI_COMB_CNT_reg(data)   (*((volatile unsigned int*) VO_V2_DI_COMB_CNT_reg)=data)
+#define get_VO_V2_DI_COMB_CNT_reg   (*((volatile unsigned int*) VO_V2_DI_COMB_CNT_reg))
+#define VO_V2_DI_COMB_CNT_inst_adr                                                   "0x0097"
+#define VO_V2_DI_COMB_CNT_inst                                                       0x0097
+#define VO_V2_DI_COMB_CNT_dis_chk_th_shift                                           (16)
+#define VO_V2_DI_COMB_CNT_dis_chk_th_mask                                            (0x00FF0000)
+#define VO_V2_DI_COMB_CNT_dis_chk_th(data)                                           (0x00FF0000&((data)<<16))
+#define VO_V2_DI_COMB_CNT_dis_chk_th_src(data)                                       ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_COMB_CNT_get_dis_chk_th(data)                                       ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_COMB_CNT_en_chk_th_shift                                            (0)
+#define VO_V2_DI_COMB_CNT_en_chk_th_mask                                             (0x000000FF)
+#define VO_V2_DI_COMB_CNT_en_chk_th(data)                                            (0x000000FF&((data)<<0))
+#define VO_V2_DI_COMB_CNT_en_chk_th_src(data)                                        ((0x000000FF&(data))>>0)
+#define VO_V2_DI_COMB_CNT_get_en_chk_th(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_LIGHT_COMB0                                                         0x98005660
+#define VO_V2_DI_LIGHT_COMB0_reg_addr                                                "0xD8005660"
+#define VO_V2_DI_LIGHT_COMB0_reg                                                     0xD8005660
+#define set_VO_V2_DI_LIGHT_COMB0_reg(data)   (*((volatile unsigned int*) VO_V2_DI_LIGHT_COMB0_reg)=data)
+#define get_VO_V2_DI_LIGHT_COMB0_reg   (*((volatile unsigned int*) VO_V2_DI_LIGHT_COMB0_reg))
+#define VO_V2_DI_LIGHT_COMB0_inst_adr                                                "0x0098"
+#define VO_V2_DI_LIGHT_COMB0_inst                                                    0x0098
+#define VO_V2_DI_LIGHT_COMB0_pn_thd1_shift                                           (24)
+#define VO_V2_DI_LIGHT_COMB0_pn_thd1_mask                                            (0xFF000000)
+#define VO_V2_DI_LIGHT_COMB0_pn_thd1(data)                                           (0xFF000000&((data)<<24))
+#define VO_V2_DI_LIGHT_COMB0_pn_thd1_src(data)                                       ((0xFF000000&(data))>>24)
+#define VO_V2_DI_LIGHT_COMB0_get_pn_thd1(data)                                       ((0xFF000000&(data))>>24)
+#define VO_V2_DI_LIGHT_COMB0_pn_thd0_shift                                           (16)
+#define VO_V2_DI_LIGHT_COMB0_pn_thd0_mask                                            (0x00FF0000)
+#define VO_V2_DI_LIGHT_COMB0_pn_thd0(data)                                           (0x00FF0000&((data)<<16))
+#define VO_V2_DI_LIGHT_COMB0_pn_thd0_src(data)                                       ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_LIGHT_COMB0_get_pn_thd0(data)                                       ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_LIGHT_COMB0_tb_thd_shift                                            (0)
+#define VO_V2_DI_LIGHT_COMB0_tb_thd_mask                                             (0x000000FF)
+#define VO_V2_DI_LIGHT_COMB0_tb_thd(data)                                            (0x000000FF&((data)<<0))
+#define VO_V2_DI_LIGHT_COMB0_tb_thd_src(data)                                        ((0x000000FF&(data))>>0)
+#define VO_V2_DI_LIGHT_COMB0_get_tb_thd(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_LIGHT_COMB1                                                         0x98005664
+#define VO_V2_DI_LIGHT_COMB1_reg_addr                                                "0xD8005664"
+#define VO_V2_DI_LIGHT_COMB1_reg                                                     0xD8005664
+#define set_VO_V2_DI_LIGHT_COMB1_reg(data)   (*((volatile unsigned int*) VO_V2_DI_LIGHT_COMB1_reg)=data)
+#define get_VO_V2_DI_LIGHT_COMB1_reg   (*((volatile unsigned int*) VO_V2_DI_LIGHT_COMB1_reg))
+#define VO_V2_DI_LIGHT_COMB1_inst_adr                                                "0x0099"
+#define VO_V2_DI_LIGHT_COMB1_inst                                                    0x0099
+#define VO_V2_DI_LIGHT_COMB1_bw_thd_shift                                            (24)
+#define VO_V2_DI_LIGHT_COMB1_bw_thd_mask                                             (0xFF000000)
+#define VO_V2_DI_LIGHT_COMB1_bw_thd(data)                                            (0xFF000000&((data)<<24))
+#define VO_V2_DI_LIGHT_COMB1_bw_thd_src(data)                                        ((0xFF000000&(data))>>24)
+#define VO_V2_DI_LIGHT_COMB1_get_bw_thd(data)                                        ((0xFF000000&(data))>>24)
+#define VO_V2_DI_LIGHT_COMB1_tw_thd_shift                                            (16)
+#define VO_V2_DI_LIGHT_COMB1_tw_thd_mask                                             (0x00FF0000)
+#define VO_V2_DI_LIGHT_COMB1_tw_thd(data)                                            (0x00FF0000&((data)<<16))
+#define VO_V2_DI_LIGHT_COMB1_tw_thd_src(data)                                        ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_LIGHT_COMB1_get_tw_thd(data)                                        ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_LIGHT_COMB1_thd_shift                                               (0)
+#define VO_V2_DI_LIGHT_COMB1_thd_mask                                                (0x000000FF)
+#define VO_V2_DI_LIGHT_COMB1_thd(data)                                               (0x000000FF&((data)<<0))
+#define VO_V2_DI_LIGHT_COMB1_thd_src(data)                                           ((0x000000FF&(data))>>0)
+#define VO_V2_DI_LIGHT_COMB1_get_thd(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_DATA_LPF1X3                                                         0x98005668
+#define VO_V2_DI_DATA_LPF1X3_reg_addr                                                "0xD8005668"
+#define VO_V2_DI_DATA_LPF1X3_reg                                                     0xD8005668
+#define set_VO_V2_DI_DATA_LPF1X3_reg(data)   (*((volatile unsigned int*) VO_V2_DI_DATA_LPF1X3_reg)=data)
+#define get_VO_V2_DI_DATA_LPF1X3_reg   (*((volatile unsigned int*) VO_V2_DI_DATA_LPF1X3_reg))
+#define VO_V2_DI_DATA_LPF1X3_inst_adr                                                "0x009A"
+#define VO_V2_DI_DATA_LPF1X3_inst                                                    0x009A
+#define VO_V2_DI_DATA_LPF1X3_c2_shift                                                (8)
+#define VO_V2_DI_DATA_LPF1X3_c2_mask                                                 (0x00000700)
+#define VO_V2_DI_DATA_LPF1X3_c2(data)                                                (0x00000700&((data)<<8))
+#define VO_V2_DI_DATA_LPF1X3_c2_src(data)                                            ((0x00000700&(data))>>8)
+#define VO_V2_DI_DATA_LPF1X3_get_c2(data)                                            ((0x00000700&(data))>>8)
+#define VO_V2_DI_DATA_LPF1X3_c1_shift                                                (4)
+#define VO_V2_DI_DATA_LPF1X3_c1_mask                                                 (0x00000070)
+#define VO_V2_DI_DATA_LPF1X3_c1(data)                                                (0x00000070&((data)<<4))
+#define VO_V2_DI_DATA_LPF1X3_c1_src(data)                                            ((0x00000070&(data))>>4)
+#define VO_V2_DI_DATA_LPF1X3_get_c1(data)                                            ((0x00000070&(data))>>4)
+#define VO_V2_DI_DATA_LPF1X3_c0_shift                                                (0)
+#define VO_V2_DI_DATA_LPF1X3_c0_mask                                                 (0x00000007)
+#define VO_V2_DI_DATA_LPF1X3_c0(data)                                                (0x00000007&((data)<<0))
+#define VO_V2_DI_DATA_LPF1X3_c0_src(data)                                            ((0x00000007&(data))>>0)
+#define VO_V2_DI_DATA_LPF1X3_get_c0(data)                                            ((0x00000007&(data))>>0)
+
+
+#define VO_V2_DI_DIFF_LPF1X3                                                         0x9800566C
+#define VO_V2_DI_DIFF_LPF1X3_reg_addr                                                "0xD800566C"
+#define VO_V2_DI_DIFF_LPF1X3_reg                                                     0xD800566C
+#define set_VO_V2_DI_DIFF_LPF1X3_reg(data)   (*((volatile unsigned int*) VO_V2_DI_DIFF_LPF1X3_reg)=data)
+#define get_VO_V2_DI_DIFF_LPF1X3_reg   (*((volatile unsigned int*) VO_V2_DI_DIFF_LPF1X3_reg))
+#define VO_V2_DI_DIFF_LPF1X3_inst_adr                                                "0x009B"
+#define VO_V2_DI_DIFF_LPF1X3_inst                                                    0x009B
+#define VO_V2_DI_DIFF_LPF1X3_c2_shift                                                (8)
+#define VO_V2_DI_DIFF_LPF1X3_c2_mask                                                 (0x00000700)
+#define VO_V2_DI_DIFF_LPF1X3_c2(data)                                                (0x00000700&((data)<<8))
+#define VO_V2_DI_DIFF_LPF1X3_c2_src(data)                                            ((0x00000700&(data))>>8)
+#define VO_V2_DI_DIFF_LPF1X3_get_c2(data)                                            ((0x00000700&(data))>>8)
+#define VO_V2_DI_DIFF_LPF1X3_c1_shift                                                (4)
+#define VO_V2_DI_DIFF_LPF1X3_c1_mask                                                 (0x00000070)
+#define VO_V2_DI_DIFF_LPF1X3_c1(data)                                                (0x00000070&((data)<<4))
+#define VO_V2_DI_DIFF_LPF1X3_c1_src(data)                                            ((0x00000070&(data))>>4)
+#define VO_V2_DI_DIFF_LPF1X3_get_c1(data)                                            ((0x00000070&(data))>>4)
+#define VO_V2_DI_DIFF_LPF1X3_c0_shift                                                (0)
+#define VO_V2_DI_DIFF_LPF1X3_c0_mask                                                 (0x00000007)
+#define VO_V2_DI_DIFF_LPF1X3_c0(data)                                                (0x00000007&((data)<<0))
+#define VO_V2_DI_DIFF_LPF1X3_c0_src(data)                                            ((0x00000007&(data))>>0)
+#define VO_V2_DI_DIFF_LPF1X3_get_c0(data)                                            ((0x00000007&(data))>>0)
+
+
+#define VO_V2_DI_BOB_DIFF                                                            0x98005670
+#define VO_V2_DI_BOB_DIFF_reg_addr                                                   "0xD8005670"
+#define VO_V2_DI_BOB_DIFF_reg                                                        0xD8005670
+#define set_VO_V2_DI_BOB_DIFF_reg(data)   (*((volatile unsigned int*) VO_V2_DI_BOB_DIFF_reg)=data)
+#define get_VO_V2_DI_BOB_DIFF_reg   (*((volatile unsigned int*) VO_V2_DI_BOB_DIFF_reg))
+#define VO_V2_DI_BOB_DIFF_inst_adr                                                   "0x009C"
+#define VO_V2_DI_BOB_DIFF_inst                                                       0x009C
+#define VO_V2_DI_BOB_DIFF_max_min_thd_shift                                          (16)
+#define VO_V2_DI_BOB_DIFF_max_min_thd_mask                                           (0x00FF0000)
+#define VO_V2_DI_BOB_DIFF_max_min_thd(data)                                          (0x00FF0000&((data)<<16))
+#define VO_V2_DI_BOB_DIFF_max_min_thd_src(data)                                      ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_BOB_DIFF_get_max_min_thd(data)                                      ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_BOB_DIFF_factor1_shift                                              (8)
+#define VO_V2_DI_BOB_DIFF_factor1_mask                                               (0x00000F00)
+#define VO_V2_DI_BOB_DIFF_factor1(data)                                              (0x00000F00&((data)<<8))
+#define VO_V2_DI_BOB_DIFF_factor1_src(data)                                          ((0x00000F00&(data))>>8)
+#define VO_V2_DI_BOB_DIFF_get_factor1(data)                                          ((0x00000F00&(data))>>8)
+#define VO_V2_DI_BOB_DIFF_factor0_shift                                              (0)
+#define VO_V2_DI_BOB_DIFF_factor0_mask                                               (0x0000000F)
+#define VO_V2_DI_BOB_DIFF_factor0(data)                                              (0x0000000F&((data)<<0))
+#define VO_V2_DI_BOB_DIFF_factor0_src(data)                                          ((0x0000000F&(data))>>0)
+#define VO_V2_DI_BOB_DIFF_get_factor0(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define VO_V2_DI_BOB                                                                 0x98005674
+#define VO_V2_DI_BOB_reg_addr                                                        "0xD8005674"
+#define VO_V2_DI_BOB_reg                                                             0xD8005674
+#define set_VO_V2_DI_BOB_reg(data)   (*((volatile unsigned int*) VO_V2_DI_BOB_reg)=data)
+#define get_VO_V2_DI_BOB_reg   (*((volatile unsigned int*) VO_V2_DI_BOB_reg))
+#define VO_V2_DI_BOB_inst_adr                                                        "0x009D"
+#define VO_V2_DI_BOB_inst                                                            0x009D
+#define VO_V2_DI_BOB_intep_thd_shift                                                 (16)
+#define VO_V2_DI_BOB_intep_thd_mask                                                  (0x03FF0000)
+#define VO_V2_DI_BOB_intep_thd(data)                                                 (0x03FF0000&((data)<<16))
+#define VO_V2_DI_BOB_intep_thd_src(data)                                             ((0x03FF0000&(data))>>16)
+#define VO_V2_DI_BOB_get_intep_thd(data)                                             ((0x03FF0000&(data))>>16)
+#define VO_V2_DI_BOB_final_min_thd_shift                                             (8)
+#define VO_V2_DI_BOB_final_min_thd_mask                                              (0x0000FF00)
+#define VO_V2_DI_BOB_final_min_thd(data)                                             (0x0000FF00&((data)<<8))
+#define VO_V2_DI_BOB_final_min_thd_src(data)                                         ((0x0000FF00&(data))>>8)
+#define VO_V2_DI_BOB_get_final_min_thd(data)                                         ((0x0000FF00&(data))>>8)
+#define VO_V2_DI_BOB_min_thd_shift                                                   (0)
+#define VO_V2_DI_BOB_min_thd_mask                                                    (0x000000FF)
+#define VO_V2_DI_BOB_min_thd(data)                                                   (0x000000FF&((data)<<0))
+#define VO_V2_DI_BOB_min_thd_src(data)                                               ((0x000000FF&(data))>>0)
+#define VO_V2_DI_BOB_get_min_thd(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_NC_COMB                                                             0x98005678
+#define VO_V2_DI_NC_COMB_reg_addr                                                    "0xD8005678"
+#define VO_V2_DI_NC_COMB_reg                                                         0xD8005678
+#define set_VO_V2_DI_NC_COMB_reg(data)   (*((volatile unsigned int*) VO_V2_DI_NC_COMB_reg)=data)
+#define get_VO_V2_DI_NC_COMB_reg   (*((volatile unsigned int*) VO_V2_DI_NC_COMB_reg))
+#define VO_V2_DI_NC_COMB_inst_adr                                                    "0x009E"
+#define VO_V2_DI_NC_COMB_inst                                                        0x009E
+#define VO_V2_DI_NC_COMB_thd_shift                                                   (0)
+#define VO_V2_DI_NC_COMB_thd_mask                                                    (0x000000FF)
+#define VO_V2_DI_NC_COMB_thd(data)                                                   (0x000000FF&((data)<<0))
+#define VO_V2_DI_NC_COMB_thd_src(data)                                               ((0x000000FF&(data))>>0)
+#define VO_V2_DI_NC_COMB_get_thd(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_FINAL_COMB                                                          0x9800567C
+#define VO_V2_DI_FINAL_COMB_reg_addr                                                 "0xD800567C"
+#define VO_V2_DI_FINAL_COMB_reg                                                      0xD800567C
+#define set_VO_V2_DI_FINAL_COMB_reg(data)   (*((volatile unsigned int*) VO_V2_DI_FINAL_COMB_reg)=data)
+#define get_VO_V2_DI_FINAL_COMB_reg   (*((volatile unsigned int*) VO_V2_DI_FINAL_COMB_reg))
+#define VO_V2_DI_FINAL_COMB_inst_adr                                                 "0x009F"
+#define VO_V2_DI_FINAL_COMB_inst                                                     0x009F
+#define VO_V2_DI_FINAL_COMB_thd_shift                                                (0)
+#define VO_V2_DI_FINAL_COMB_thd_mask                                                 (0x000000FF)
+#define VO_V2_DI_FINAL_COMB_thd(data)                                                (0x000000FF&((data)<<0))
+#define VO_V2_DI_FINAL_COMB_thd_src(data)                                            ((0x000000FF&(data))>>0)
+#define VO_V2_DI_FINAL_COMB_get_thd(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_DATA_DIFF                                                           0x98005680
+#define VO_V2_DI_DATA_DIFF_reg_addr                                                  "0xD8005680"
+#define VO_V2_DI_DATA_DIFF_reg                                                       0xD8005680
+#define set_VO_V2_DI_DATA_DIFF_reg(data)   (*((volatile unsigned int*) VO_V2_DI_DATA_DIFF_reg)=data)
+#define get_VO_V2_DI_DATA_DIFF_reg   (*((volatile unsigned int*) VO_V2_DI_DATA_DIFF_reg))
+#define VO_V2_DI_DATA_DIFF_inst_adr                                                  "0x00A0"
+#define VO_V2_DI_DATA_DIFF_inst                                                      0x00A0
+#define VO_V2_DI_DATA_DIFF_nc_thd_shift                                              (16)
+#define VO_V2_DI_DATA_DIFF_nc_thd_mask                                               (0x00FF0000)
+#define VO_V2_DI_DATA_DIFF_nc_thd(data)                                              (0x00FF0000&((data)<<16))
+#define VO_V2_DI_DATA_DIFF_nc_thd_src(data)                                          ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_DATA_DIFF_get_nc_thd(data)                                          ((0x00FF0000&(data))>>16)
+#define VO_V2_DI_DATA_DIFF_pn_thd_shift                                              (0)
+#define VO_V2_DI_DATA_DIFF_pn_thd_mask                                               (0x000000FF)
+#define VO_V2_DI_DATA_DIFF_pn_thd(data)                                              (0x000000FF&((data)<<0))
+#define VO_V2_DI_DATA_DIFF_pn_thd_src(data)                                          ((0x000000FF&(data))>>0)
+#define VO_V2_DI_DATA_DIFF_get_pn_thd(data)                                          ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_DI_ESCAPE                                                              0x98005684
+#define VO_V2_DI_ESCAPE_reg_addr                                                     "0xD8005684"
+#define VO_V2_DI_ESCAPE_reg                                                          0xD8005684
+#define set_VO_V2_DI_ESCAPE_reg(data)   (*((volatile unsigned int*) VO_V2_DI_ESCAPE_reg)=data)
+#define get_VO_V2_DI_ESCAPE_reg   (*((volatile unsigned int*) VO_V2_DI_ESCAPE_reg))
+#define VO_V2_DI_ESCAPE_inst_adr                                                     "0x00A1"
+#define VO_V2_DI_ESCAPE_inst                                                         0x00A1
+#define VO_V2_DI_ESCAPE_thd_shift                                                    (0)
+#define VO_V2_DI_ESCAPE_thd_mask                                                     (0x000003FF)
+#define VO_V2_DI_ESCAPE_thd(data)                                                    (0x000003FF&((data)<<0))
+#define VO_V2_DI_ESCAPE_thd_src(data)                                                ((0x000003FF&(data))>>0)
+#define VO_V2_DI_ESCAPE_get_thd(data)                                                ((0x000003FF&(data))>>0)
+
+
+#define VO_V2_STA_TOTAL                                                              0x98005688
+#define VO_V2_STA_TOTAL_reg_addr                                                     "0xD8005688"
+#define VO_V2_STA_TOTAL_reg                                                          0xD8005688
+#define set_VO_V2_STA_TOTAL_reg(data)   (*((volatile unsigned int*) VO_V2_STA_TOTAL_reg)=data)
+#define get_VO_V2_STA_TOTAL_reg   (*((volatile unsigned int*) VO_V2_STA_TOTAL_reg))
+#define VO_V2_STA_TOTAL_inst_adr                                                     "0x00A2"
+#define VO_V2_STA_TOTAL_inst                                                         0x00A2
+#define VO_V2_STA_TOTAL_cnt_shift                                                    (0)
+#define VO_V2_STA_TOTAL_cnt_mask                                                     (0x007FFFFF)
+#define VO_V2_STA_TOTAL_cnt(data)                                                    (0x007FFFFF&((data)<<0))
+#define VO_V2_STA_TOTAL_cnt_src(data)                                                ((0x007FFFFF&(data))>>0)
+#define VO_V2_STA_TOTAL_get_cnt(data)                                                ((0x007FFFFF&(data))>>0)
+
+
+#define VO_V2_STA_SUM                                                                0x9800568C
+#define VO_V2_STA_SUM_reg_addr                                                       "0xD800568C"
+#define VO_V2_STA_SUM_reg                                                            0xD800568C
+#define set_VO_V2_STA_SUM_reg(data)   (*((volatile unsigned int*) VO_V2_STA_SUM_reg)=data)
+#define get_VO_V2_STA_SUM_reg   (*((volatile unsigned int*) VO_V2_STA_SUM_reg))
+#define VO_V2_STA_SUM_inst_adr                                                       "0x00A3"
+#define VO_V2_STA_SUM_inst                                                           0x00A3
+#define VO_V2_STA_SUM_sum_shift                                                      (0)
+#define VO_V2_STA_SUM_sum_mask                                                       (0x7FFFFFFF)
+#define VO_V2_STA_SUM_sum(data)                                                      (0x7FFFFFFF&((data)<<0))
+#define VO_V2_STA_SUM_sum_src(data)                                                  ((0x7FFFFFFF&(data))>>0)
+#define VO_V2_STA_SUM_get_sum(data)                                                  ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V2_STA_BKT_0                                                              0x98005690
+#define VO_V2_STA_BKT_1                                                              0x98005694
+#define VO_V2_STA_BKT_2                                                              0x98005698
+#define VO_V2_STA_BKT_3                                                              0x9800569C
+#define VO_V2_STA_BKT_4                                                              0x980056A0
+#define VO_V2_STA_BKT_5                                                              0x980056A4
+#define VO_V2_STA_BKT_6                                                              0x980056A8
+#define VO_V2_STA_BKT_7                                                              0x980056AC
+#define VO_V2_STA_BKT_8                                                              0x980056B0
+#define VO_V2_STA_BKT_9                                                              0x980056B4
+#define VO_V2_STA_BKT_0_reg_addr                                                     "0xD8005690"
+#define VO_V2_STA_BKT_1_reg_addr                                                     "0xD8005694"
+#define VO_V2_STA_BKT_2_reg_addr                                                     "0xD8005698"
+#define VO_V2_STA_BKT_3_reg_addr                                                     "0xD800569C"
+#define VO_V2_STA_BKT_4_reg_addr                                                     "0xD80056A0"
+#define VO_V2_STA_BKT_5_reg_addr                                                     "0xD80056A4"
+#define VO_V2_STA_BKT_6_reg_addr                                                     "0xD80056A8"
+#define VO_V2_STA_BKT_7_reg_addr                                                     "0xD80056AC"
+#define VO_V2_STA_BKT_8_reg_addr                                                     "0xD80056B0"
+#define VO_V2_STA_BKT_9_reg_addr                                                     "0xD80056B4"
+#define VO_V2_STA_BKT_0_reg                                                          0xD8005690
+#define VO_V2_STA_BKT_1_reg                                                          0xD8005694
+#define VO_V2_STA_BKT_2_reg                                                          0xD8005698
+#define VO_V2_STA_BKT_3_reg                                                          0xD800569C
+#define VO_V2_STA_BKT_4_reg                                                          0xD80056A0
+#define VO_V2_STA_BKT_5_reg                                                          0xD80056A4
+#define VO_V2_STA_BKT_6_reg                                                          0xD80056A8
+#define VO_V2_STA_BKT_7_reg                                                          0xD80056AC
+#define VO_V2_STA_BKT_8_reg                                                          0xD80056B0
+#define VO_V2_STA_BKT_9_reg                                                          0xD80056B4
+#define set_VO_V2_STA_BKT_0_reg(data)   (*((volatile unsigned int*) VO_V2_STA_BKT_0_reg)=data)
+#define set_VO_V2_STA_BKT_1_reg(data)   (*((volatile unsigned int*) VO_V2_STA_BKT_1_reg)=data)
+#define set_VO_V2_STA_BKT_2_reg(data)   (*((volatile unsigned int*) VO_V2_STA_BKT_2_reg)=data)
+#define set_VO_V2_STA_BKT_3_reg(data)   (*((volatile unsigned int*) VO_V2_STA_BKT_3_reg)=data)
+#define set_VO_V2_STA_BKT_4_reg(data)   (*((volatile unsigned int*) VO_V2_STA_BKT_4_reg)=data)
+#define set_VO_V2_STA_BKT_5_reg(data)   (*((volatile unsigned int*) VO_V2_STA_BKT_5_reg)=data)
+#define set_VO_V2_STA_BKT_6_reg(data)   (*((volatile unsigned int*) VO_V2_STA_BKT_6_reg)=data)
+#define set_VO_V2_STA_BKT_7_reg(data)   (*((volatile unsigned int*) VO_V2_STA_BKT_7_reg)=data)
+#define set_VO_V2_STA_BKT_8_reg(data)   (*((volatile unsigned int*) VO_V2_STA_BKT_8_reg)=data)
+#define set_VO_V2_STA_BKT_9_reg(data)   (*((volatile unsigned int*) VO_V2_STA_BKT_9_reg)=data)
+#define get_VO_V2_STA_BKT_0_reg   (*((volatile unsigned int*) VO_V2_STA_BKT_0_reg))
+#define get_VO_V2_STA_BKT_1_reg   (*((volatile unsigned int*) VO_V2_STA_BKT_1_reg))
+#define get_VO_V2_STA_BKT_2_reg   (*((volatile unsigned int*) VO_V2_STA_BKT_2_reg))
+#define get_VO_V2_STA_BKT_3_reg   (*((volatile unsigned int*) VO_V2_STA_BKT_3_reg))
+#define get_VO_V2_STA_BKT_4_reg   (*((volatile unsigned int*) VO_V2_STA_BKT_4_reg))
+#define get_VO_V2_STA_BKT_5_reg   (*((volatile unsigned int*) VO_V2_STA_BKT_5_reg))
+#define get_VO_V2_STA_BKT_6_reg   (*((volatile unsigned int*) VO_V2_STA_BKT_6_reg))
+#define get_VO_V2_STA_BKT_7_reg   (*((volatile unsigned int*) VO_V2_STA_BKT_7_reg))
+#define get_VO_V2_STA_BKT_8_reg   (*((volatile unsigned int*) VO_V2_STA_BKT_8_reg))
+#define get_VO_V2_STA_BKT_9_reg   (*((volatile unsigned int*) VO_V2_STA_BKT_9_reg))
+#define VO_V2_STA_BKT_0_inst_adr                                                     "0x00A4"
+#define VO_V2_STA_BKT_1_inst_adr                                                     "0x00A5"
+#define VO_V2_STA_BKT_2_inst_adr                                                     "0x00A6"
+#define VO_V2_STA_BKT_3_inst_adr                                                     "0x00A7"
+#define VO_V2_STA_BKT_4_inst_adr                                                     "0x00A8"
+#define VO_V2_STA_BKT_5_inst_adr                                                     "0x00A9"
+#define VO_V2_STA_BKT_6_inst_adr                                                     "0x00AA"
+#define VO_V2_STA_BKT_7_inst_adr                                                     "0x00AB"
+#define VO_V2_STA_BKT_8_inst_adr                                                     "0x00AC"
+#define VO_V2_STA_BKT_9_inst_adr                                                     "0x00AD"
+#define VO_V2_STA_BKT_0_inst                                                         0x00A4
+#define VO_V2_STA_BKT_1_inst                                                         0x00A5
+#define VO_V2_STA_BKT_2_inst                                                         0x00A6
+#define VO_V2_STA_BKT_3_inst                                                         0x00A7
+#define VO_V2_STA_BKT_4_inst                                                         0x00A8
+#define VO_V2_STA_BKT_5_inst                                                         0x00A9
+#define VO_V2_STA_BKT_6_inst                                                         0x00AA
+#define VO_V2_STA_BKT_7_inst                                                         0x00AB
+#define VO_V2_STA_BKT_8_inst                                                         0x00AC
+#define VO_V2_STA_BKT_9_inst                                                         0x00AD
+#define VO_V2_STA_BKT_cnt_shift                                                      (0)
+#define VO_V2_STA_BKT_cnt_mask                                                       (0x007FFFFF)
+#define VO_V2_STA_BKT_cnt(data)                                                      (0x007FFFFF&((data)<<0))
+#define VO_V2_STA_BKT_cnt_src(data)                                                  ((0x007FFFFF&(data))>>0)
+#define VO_V2_STA_BKT_get_cnt(data)                                                  ((0x007FFFFF&(data))>>0)
+
+
+#define VO_V2_STA_AD_0                                                               0x980056B8
+#define VO_V2_STA_AD_1                                                               0x980056BC
+#define VO_V2_STA_AD_2                                                               0x980056C0
+#define VO_V2_STA_AD_3                                                               0x980056C4
+#define VO_V2_STA_AD_4                                                               0x980056C8
+#define VO_V2_STA_AD_5                                                               0x980056CC
+#define VO_V2_STA_AD_6                                                               0x980056D0
+#define VO_V2_STA_AD_7                                                               0x980056D4
+#define VO_V2_STA_AD_8                                                               0x980056D8
+#define VO_V2_STA_AD_9                                                               0x980056DC
+#define VO_V2_STA_AD_0_reg_addr                                                      "0xD80056B8"
+#define VO_V2_STA_AD_1_reg_addr                                                      "0xD80056BC"
+#define VO_V2_STA_AD_2_reg_addr                                                      "0xD80056C0"
+#define VO_V2_STA_AD_3_reg_addr                                                      "0xD80056C4"
+#define VO_V2_STA_AD_4_reg_addr                                                      "0xD80056C8"
+#define VO_V2_STA_AD_5_reg_addr                                                      "0xD80056CC"
+#define VO_V2_STA_AD_6_reg_addr                                                      "0xD80056D0"
+#define VO_V2_STA_AD_7_reg_addr                                                      "0xD80056D4"
+#define VO_V2_STA_AD_8_reg_addr                                                      "0xD80056D8"
+#define VO_V2_STA_AD_9_reg_addr                                                      "0xD80056DC"
+#define VO_V2_STA_AD_0_reg                                                           0xD80056B8
+#define VO_V2_STA_AD_1_reg                                                           0xD80056BC
+#define VO_V2_STA_AD_2_reg                                                           0xD80056C0
+#define VO_V2_STA_AD_3_reg                                                           0xD80056C4
+#define VO_V2_STA_AD_4_reg                                                           0xD80056C8
+#define VO_V2_STA_AD_5_reg                                                           0xD80056CC
+#define VO_V2_STA_AD_6_reg                                                           0xD80056D0
+#define VO_V2_STA_AD_7_reg                                                           0xD80056D4
+#define VO_V2_STA_AD_8_reg                                                           0xD80056D8
+#define VO_V2_STA_AD_9_reg                                                           0xD80056DC
+#define set_VO_V2_STA_AD_0_reg(data)   (*((volatile unsigned int*) VO_V2_STA_AD_0_reg)=data)
+#define set_VO_V2_STA_AD_1_reg(data)   (*((volatile unsigned int*) VO_V2_STA_AD_1_reg)=data)
+#define set_VO_V2_STA_AD_2_reg(data)   (*((volatile unsigned int*) VO_V2_STA_AD_2_reg)=data)
+#define set_VO_V2_STA_AD_3_reg(data)   (*((volatile unsigned int*) VO_V2_STA_AD_3_reg)=data)
+#define set_VO_V2_STA_AD_4_reg(data)   (*((volatile unsigned int*) VO_V2_STA_AD_4_reg)=data)
+#define set_VO_V2_STA_AD_5_reg(data)   (*((volatile unsigned int*) VO_V2_STA_AD_5_reg)=data)
+#define set_VO_V2_STA_AD_6_reg(data)   (*((volatile unsigned int*) VO_V2_STA_AD_6_reg)=data)
+#define set_VO_V2_STA_AD_7_reg(data)   (*((volatile unsigned int*) VO_V2_STA_AD_7_reg)=data)
+#define set_VO_V2_STA_AD_8_reg(data)   (*((volatile unsigned int*) VO_V2_STA_AD_8_reg)=data)
+#define set_VO_V2_STA_AD_9_reg(data)   (*((volatile unsigned int*) VO_V2_STA_AD_9_reg)=data)
+#define get_VO_V2_STA_AD_0_reg   (*((volatile unsigned int*) VO_V2_STA_AD_0_reg))
+#define get_VO_V2_STA_AD_1_reg   (*((volatile unsigned int*) VO_V2_STA_AD_1_reg))
+#define get_VO_V2_STA_AD_2_reg   (*((volatile unsigned int*) VO_V2_STA_AD_2_reg))
+#define get_VO_V2_STA_AD_3_reg   (*((volatile unsigned int*) VO_V2_STA_AD_3_reg))
+#define get_VO_V2_STA_AD_4_reg   (*((volatile unsigned int*) VO_V2_STA_AD_4_reg))
+#define get_VO_V2_STA_AD_5_reg   (*((volatile unsigned int*) VO_V2_STA_AD_5_reg))
+#define get_VO_V2_STA_AD_6_reg   (*((volatile unsigned int*) VO_V2_STA_AD_6_reg))
+#define get_VO_V2_STA_AD_7_reg   (*((volatile unsigned int*) VO_V2_STA_AD_7_reg))
+#define get_VO_V2_STA_AD_8_reg   (*((volatile unsigned int*) VO_V2_STA_AD_8_reg))
+#define get_VO_V2_STA_AD_9_reg   (*((volatile unsigned int*) VO_V2_STA_AD_9_reg))
+#define VO_V2_STA_AD_0_inst_adr                                                      "0x00AE"
+#define VO_V2_STA_AD_1_inst_adr                                                      "0x00AF"
+#define VO_V2_STA_AD_2_inst_adr                                                      "0x00B0"
+#define VO_V2_STA_AD_3_inst_adr                                                      "0x00B1"
+#define VO_V2_STA_AD_4_inst_adr                                                      "0x00B2"
+#define VO_V2_STA_AD_5_inst_adr                                                      "0x00B3"
+#define VO_V2_STA_AD_6_inst_adr                                                      "0x00B4"
+#define VO_V2_STA_AD_7_inst_adr                                                      "0x00B5"
+#define VO_V2_STA_AD_8_inst_adr                                                      "0x00B6"
+#define VO_V2_STA_AD_9_inst_adr                                                      "0x00B7"
+#define VO_V2_STA_AD_0_inst                                                          0x00AE
+#define VO_V2_STA_AD_1_inst                                                          0x00AF
+#define VO_V2_STA_AD_2_inst                                                          0x00B0
+#define VO_V2_STA_AD_3_inst                                                          0x00B1
+#define VO_V2_STA_AD_4_inst                                                          0x00B2
+#define VO_V2_STA_AD_5_inst                                                          0x00B3
+#define VO_V2_STA_AD_6_inst                                                          0x00B4
+#define VO_V2_STA_AD_7_inst                                                          0x00B5
+#define VO_V2_STA_AD_8_inst                                                          0x00B6
+#define VO_V2_STA_AD_9_inst                                                          0x00B7
+#define VO_V2_STA_AD_sum_shift                                                       (0)
+#define VO_V2_STA_AD_sum_mask                                                        (0x7FFFFFFF)
+#define VO_V2_STA_AD_sum(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define VO_V2_STA_AD_sum_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define VO_V2_STA_AD_get_sum(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V2_STA_NC_COMB                                                            0x980056E0
+#define VO_V2_STA_NC_COMB_reg_addr                                                   "0xD80056E0"
+#define VO_V2_STA_NC_COMB_reg                                                        0xD80056E0
+#define set_VO_V2_STA_NC_COMB_reg(data)   (*((volatile unsigned int*) VO_V2_STA_NC_COMB_reg)=data)
+#define get_VO_V2_STA_NC_COMB_reg   (*((volatile unsigned int*) VO_V2_STA_NC_COMB_reg))
+#define VO_V2_STA_NC_COMB_inst_adr                                                   "0x00B8"
+#define VO_V2_STA_NC_COMB_inst                                                       0x00B8
+#define VO_V2_STA_NC_COMB_cnt_shift                                                  (0)
+#define VO_V2_STA_NC_COMB_cnt_mask                                                   (0x000FFFFF)
+#define VO_V2_STA_NC_COMB_cnt(data)                                                  (0x000FFFFF&((data)<<0))
+#define VO_V2_STA_NC_COMB_cnt_src(data)                                              ((0x000FFFFF&(data))>>0)
+#define VO_V2_STA_NC_COMB_get_cnt(data)                                              ((0x000FFFFF&(data))>>0)
+
+
+#define VO_V2_STA_FINAL_COMB                                                         0x980056E4
+#define VO_V2_STA_FINAL_COMB_reg_addr                                                "0xD80056E4"
+#define VO_V2_STA_FINAL_COMB_reg                                                     0xD80056E4
+#define set_VO_V2_STA_FINAL_COMB_reg(data)   (*((volatile unsigned int*) VO_V2_STA_FINAL_COMB_reg)=data)
+#define get_VO_V2_STA_FINAL_COMB_reg   (*((volatile unsigned int*) VO_V2_STA_FINAL_COMB_reg))
+#define VO_V2_STA_FINAL_COMB_inst_adr                                                "0x00B9"
+#define VO_V2_STA_FINAL_COMB_inst                                                    0x00B9
+#define VO_V2_STA_FINAL_COMB_cnt_shift                                               (0)
+#define VO_V2_STA_FINAL_COMB_cnt_mask                                                (0x000FFFFF)
+#define VO_V2_STA_FINAL_COMB_cnt(data)                                               (0x000FFFFF&((data)<<0))
+#define VO_V2_STA_FINAL_COMB_cnt_src(data)                                           ((0x000FFFFF&(data))>>0)
+#define VO_V2_STA_FINAL_COMB_get_cnt(data)                                           ((0x000FFFFF&(data))>>0)
+
+
+#define VO_V2_STA_PN_DIFF                                                            0x980056E8
+#define VO_V2_STA_PN_DIFF_reg_addr                                                   "0xD80056E8"
+#define VO_V2_STA_PN_DIFF_reg                                                        0xD80056E8
+#define set_VO_V2_STA_PN_DIFF_reg(data)   (*((volatile unsigned int*) VO_V2_STA_PN_DIFF_reg)=data)
+#define get_VO_V2_STA_PN_DIFF_reg   (*((volatile unsigned int*) VO_V2_STA_PN_DIFF_reg))
+#define VO_V2_STA_PN_DIFF_inst_adr                                                   "0x00BA"
+#define VO_V2_STA_PN_DIFF_inst                                                       0x00BA
+#define VO_V2_STA_PN_DIFF_cnt_shift                                                  (0)
+#define VO_V2_STA_PN_DIFF_cnt_mask                                                   (0x000FFFFF)
+#define VO_V2_STA_PN_DIFF_cnt(data)                                                  (0x000FFFFF&((data)<<0))
+#define VO_V2_STA_PN_DIFF_cnt_src(data)                                              ((0x000FFFFF&(data))>>0)
+#define VO_V2_STA_PN_DIFF_get_cnt(data)                                              ((0x000FFFFF&(data))>>0)
+
+
+#define VO_V2_STA_NC_DIFF                                                            0x980056EC
+#define VO_V2_STA_NC_DIFF_reg_addr                                                   "0xD80056EC"
+#define VO_V2_STA_NC_DIFF_reg                                                        0xD80056EC
+#define set_VO_V2_STA_NC_DIFF_reg(data)   (*((volatile unsigned int*) VO_V2_STA_NC_DIFF_reg)=data)
+#define get_VO_V2_STA_NC_DIFF_reg   (*((volatile unsigned int*) VO_V2_STA_NC_DIFF_reg))
+#define VO_V2_STA_NC_DIFF_inst_adr                                                   "0x00BB"
+#define VO_V2_STA_NC_DIFF_inst                                                       0x00BB
+#define VO_V2_STA_NC_DIFF_cnt_shift                                                  (0)
+#define VO_V2_STA_NC_DIFF_cnt_mask                                                   (0x000FFFFF)
+#define VO_V2_STA_NC_DIFF_cnt(data)                                                  (0x000FFFFF&((data)<<0))
+#define VO_V2_STA_NC_DIFF_cnt_src(data)                                              ((0x000FFFFF&(data))>>0)
+#define VO_V2_STA_NC_DIFF_get_cnt(data)                                              ((0x000FFFFF&(data))>>0)
+
+
+#define VO_V2_VSYI                                                                   0x980056F0
+#define VO_V2_VSYI_reg_addr                                                          "0xD80056F0"
+#define VO_V2_VSYI_reg                                                               0xD80056F0
+#define set_VO_V2_VSYI_reg(data)   (*((volatile unsigned int*) VO_V2_VSYI_reg)=data)
+#define get_VO_V2_VSYI_reg   (*((volatile unsigned int*) VO_V2_VSYI_reg))
+#define VO_V2_VSYI_inst_adr                                                          "0x00BC"
+#define VO_V2_VSYI_inst                                                              0x00BC
+#define VO_V2_VSYI_offset_shift                                                      (16)
+#define VO_V2_VSYI_offset_mask                                                       (0x3FFF0000)
+#define VO_V2_VSYI_offset(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_V2_VSYI_offset_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V2_VSYI_get_offset(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V2_VSYI_phase_shift                                                       (0)
+#define VO_V2_VSYI_phase_mask                                                        (0x0000FFFF)
+#define VO_V2_VSYI_phase(data)                                                       (0x0000FFFF&((data)<<0))
+#define VO_V2_VSYI_phase_src(data)                                                   ((0x0000FFFF&(data))>>0)
+#define VO_V2_VSYI_get_phase(data)                                                   ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_VSCI                                                                   0x980056F4
+#define VO_V2_VSCI_reg_addr                                                          "0xD80056F4"
+#define VO_V2_VSCI_reg                                                               0xD80056F4
+#define set_VO_V2_VSCI_reg(data)   (*((volatile unsigned int*) VO_V2_VSCI_reg)=data)
+#define get_VO_V2_VSCI_reg   (*((volatile unsigned int*) VO_V2_VSCI_reg))
+#define VO_V2_VSCI_inst_adr                                                          "0x00BD"
+#define VO_V2_VSCI_inst                                                              0x00BD
+#define VO_V2_VSCI_offset_shift                                                      (16)
+#define VO_V2_VSCI_offset_mask                                                       (0x3FFF0000)
+#define VO_V2_VSCI_offset(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_V2_VSCI_offset_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V2_VSCI_get_offset(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V2_VSCI_phase_shift                                                       (0)
+#define VO_V2_VSCI_phase_mask                                                        (0x0000FFFF)
+#define VO_V2_VSCI_phase(data)                                                       (0x0000FFFF&((data)<<0))
+#define VO_V2_VSCI_phase_src(data)                                                   ((0x0000FFFF&(data))>>0)
+#define VO_V2_VSCI_get_phase(data)                                                   ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_VSD                                                                    0x980056F8
+#define VO_V2_VSD_reg_addr                                                           "0xD80056F8"
+#define VO_V2_VSD_reg                                                                0xD80056F8
+#define set_VO_V2_VSD_reg(data)   (*((volatile unsigned int*) VO_V2_VSD_reg)=data)
+#define get_VO_V2_VSD_reg   (*((volatile unsigned int*) VO_V2_VSD_reg))
+#define VO_V2_VSD_inst_adr                                                           "0x00BE"
+#define VO_V2_VSD_inst                                                               0x00BE
+#define VO_V2_VSD_delta_shift                                                        (0)
+#define VO_V2_VSD_delta_mask                                                         (0x001FFFFF)
+#define VO_V2_VSD_delta(data)                                                        (0x001FFFFF&((data)<<0))
+#define VO_V2_VSD_delta_src(data)                                                    ((0x001FFFFF&(data))>>0)
+#define VO_V2_VSD_get_delta(data)                                                    ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V2_VSD_H                                                                  0x980056FC
+#define VO_V2_VSD_H_reg_addr                                                         "0xD80056FC"
+#define VO_V2_VSD_H_reg                                                              0xD80056FC
+#define set_VO_V2_VSD_H_reg(data)   (*((volatile unsigned int*) VO_V2_VSD_H_reg)=data)
+#define get_VO_V2_VSD_H_reg   (*((volatile unsigned int*) VO_V2_VSD_H_reg))
+#define VO_V2_VSD_H_inst_adr                                                         "0x00BF"
+#define VO_V2_VSD_H_inst                                                             0x00BF
+#define VO_V2_VSD_H_out_shift                                                        (0)
+#define VO_V2_VSD_H_out_mask                                                         (0x00000FFF)
+#define VO_V2_VSD_H_out(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V2_VSD_H_out_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V2_VSD_H_get_out(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V2_VSYC_0                                                                 0x98005700
+#define VO_V2_VSYC_1                                                                 0x98005704
+#define VO_V2_VSYC_2                                                                 0x98005708
+#define VO_V2_VSYC_3                                                                 0x9800570C
+#define VO_V2_VSYC_4                                                                 0x98005710
+#define VO_V2_VSYC_5                                                                 0x98005714
+#define VO_V2_VSYC_6                                                                 0x98005718
+#define VO_V2_VSYC_7                                                                 0x9800571C
+#define VO_V2_VSYC_8                                                                 0x98005720
+#define VO_V2_VSYC_9                                                                 0x98005724
+#define VO_V2_VSYC_10                                                                 0x98005728
+#define VO_V2_VSYC_11                                                                 0x9800572C
+#define VO_V2_VSYC_12                                                                 0x98005730
+#define VO_V2_VSYC_13                                                                 0x98005734
+#define VO_V2_VSYC_14                                                                 0x98005738
+#define VO_V2_VSYC_15                                                                 0x9800573C
+#define VO_V2_VSYC_0_reg_addr                                                        "0xD8005700"
+#define VO_V2_VSYC_1_reg_addr                                                        "0xD8005704"
+#define VO_V2_VSYC_2_reg_addr                                                        "0xD8005708"
+#define VO_V2_VSYC_3_reg_addr                                                        "0xD800570C"
+#define VO_V2_VSYC_4_reg_addr                                                        "0xD8005710"
+#define VO_V2_VSYC_5_reg_addr                                                        "0xD8005714"
+#define VO_V2_VSYC_6_reg_addr                                                        "0xD8005718"
+#define VO_V2_VSYC_7_reg_addr                                                        "0xD800571C"
+#define VO_V2_VSYC_8_reg_addr                                                        "0xD8005720"
+#define VO_V2_VSYC_9_reg_addr                                                        "0xD8005724"
+#define VO_V2_VSYC_10_reg_addr                                                        "0xD8005728"
+#define VO_V2_VSYC_11_reg_addr                                                        "0xD800572C"
+#define VO_V2_VSYC_12_reg_addr                                                        "0xD8005730"
+#define VO_V2_VSYC_13_reg_addr                                                        "0xD8005734"
+#define VO_V2_VSYC_14_reg_addr                                                        "0xD8005738"
+#define VO_V2_VSYC_15_reg_addr                                                        "0xD800573C"
+#define VO_V2_VSYC_0_reg                                                             0xD8005700
+#define VO_V2_VSYC_1_reg                                                             0xD8005704
+#define VO_V2_VSYC_2_reg                                                             0xD8005708
+#define VO_V2_VSYC_3_reg                                                             0xD800570C
+#define VO_V2_VSYC_4_reg                                                             0xD8005710
+#define VO_V2_VSYC_5_reg                                                             0xD8005714
+#define VO_V2_VSYC_6_reg                                                             0xD8005718
+#define VO_V2_VSYC_7_reg                                                             0xD800571C
+#define VO_V2_VSYC_8_reg                                                             0xD8005720
+#define VO_V2_VSYC_9_reg                                                             0xD8005724
+#define VO_V2_VSYC_10_reg                                                             0xD8005728
+#define VO_V2_VSYC_11_reg                                                             0xD800572C
+#define VO_V2_VSYC_12_reg                                                             0xD8005730
+#define VO_V2_VSYC_13_reg                                                             0xD8005734
+#define VO_V2_VSYC_14_reg                                                             0xD8005738
+#define VO_V2_VSYC_15_reg                                                             0xD800573C
+#define set_VO_V2_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_0_reg)=data)
+#define set_VO_V2_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_1_reg)=data)
+#define set_VO_V2_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_2_reg)=data)
+#define set_VO_V2_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_3_reg)=data)
+#define set_VO_V2_VSYC_4_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_4_reg)=data)
+#define set_VO_V2_VSYC_5_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_5_reg)=data)
+#define set_VO_V2_VSYC_6_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_6_reg)=data)
+#define set_VO_V2_VSYC_7_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_7_reg)=data)
+#define set_VO_V2_VSYC_8_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_8_reg)=data)
+#define set_VO_V2_VSYC_9_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_9_reg)=data)
+#define set_VO_V2_VSYC_10_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_10_reg)=data)
+#define set_VO_V2_VSYC_11_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_11_reg)=data)
+#define set_VO_V2_VSYC_12_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_12_reg)=data)
+#define set_VO_V2_VSYC_13_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_13_reg)=data)
+#define set_VO_V2_VSYC_14_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_14_reg)=data)
+#define set_VO_V2_VSYC_15_reg(data)   (*((volatile unsigned int*) VO_V2_VSYC_15_reg)=data)
+#define get_VO_V2_VSYC_0_reg   (*((volatile unsigned int*) VO_V2_VSYC_0_reg))
+#define get_VO_V2_VSYC_1_reg   (*((volatile unsigned int*) VO_V2_VSYC_1_reg))
+#define get_VO_V2_VSYC_2_reg   (*((volatile unsigned int*) VO_V2_VSYC_2_reg))
+#define get_VO_V2_VSYC_3_reg   (*((volatile unsigned int*) VO_V2_VSYC_3_reg))
+#define get_VO_V2_VSYC_4_reg   (*((volatile unsigned int*) VO_V2_VSYC_4_reg))
+#define get_VO_V2_VSYC_5_reg   (*((volatile unsigned int*) VO_V2_VSYC_5_reg))
+#define get_VO_V2_VSYC_6_reg   (*((volatile unsigned int*) VO_V2_VSYC_6_reg))
+#define get_VO_V2_VSYC_7_reg   (*((volatile unsigned int*) VO_V2_VSYC_7_reg))
+#define get_VO_V2_VSYC_8_reg   (*((volatile unsigned int*) VO_V2_VSYC_8_reg))
+#define get_VO_V2_VSYC_9_reg   (*((volatile unsigned int*) VO_V2_VSYC_9_reg))
+#define get_VO_V2_VSYC_10_reg   (*((volatile unsigned int*) VO_V2_VSYC_10_reg))
+#define get_VO_V2_VSYC_11_reg   (*((volatile unsigned int*) VO_V2_VSYC_11_reg))
+#define get_VO_V2_VSYC_12_reg   (*((volatile unsigned int*) VO_V2_VSYC_12_reg))
+#define get_VO_V2_VSYC_13_reg   (*((volatile unsigned int*) VO_V2_VSYC_13_reg))
+#define get_VO_V2_VSYC_14_reg   (*((volatile unsigned int*) VO_V2_VSYC_14_reg))
+#define get_VO_V2_VSYC_15_reg   (*((volatile unsigned int*) VO_V2_VSYC_15_reg))
+#define VO_V2_VSYC_0_inst_adr                                                        "0x00C0"
+#define VO_V2_VSYC_1_inst_adr                                                        "0x00C1"
+#define VO_V2_VSYC_2_inst_adr                                                        "0x00C2"
+#define VO_V2_VSYC_3_inst_adr                                                        "0x00C3"
+#define VO_V2_VSYC_4_inst_adr                                                        "0x00C4"
+#define VO_V2_VSYC_5_inst_adr                                                        "0x00C5"
+#define VO_V2_VSYC_6_inst_adr                                                        "0x00C6"
+#define VO_V2_VSYC_7_inst_adr                                                        "0x00C7"
+#define VO_V2_VSYC_8_inst_adr                                                        "0x00C8"
+#define VO_V2_VSYC_9_inst_adr                                                        "0x00C9"
+#define VO_V2_VSYC_10_inst_adr                                                        "0x00CA"
+#define VO_V2_VSYC_11_inst_adr                                                        "0x00CB"
+#define VO_V2_VSYC_12_inst_adr                                                        "0x00CC"
+#define VO_V2_VSYC_13_inst_adr                                                        "0x00CD"
+#define VO_V2_VSYC_14_inst_adr                                                        "0x00CE"
+#define VO_V2_VSYC_15_inst_adr                                                        "0x00CF"
+#define VO_V2_VSYC_0_inst                                                            0x00C0
+#define VO_V2_VSYC_1_inst                                                            0x00C1
+#define VO_V2_VSYC_2_inst                                                            0x00C2
+#define VO_V2_VSYC_3_inst                                                            0x00C3
+#define VO_V2_VSYC_4_inst                                                            0x00C4
+#define VO_V2_VSYC_5_inst                                                            0x00C5
+#define VO_V2_VSYC_6_inst                                                            0x00C6
+#define VO_V2_VSYC_7_inst                                                            0x00C7
+#define VO_V2_VSYC_8_inst                                                            0x00C8
+#define VO_V2_VSYC_9_inst                                                            0x00C9
+#define VO_V2_VSYC_10_inst                                                            0x00CA
+#define VO_V2_VSYC_11_inst                                                            0x00CB
+#define VO_V2_VSYC_12_inst                                                            0x00CC
+#define VO_V2_VSYC_13_inst                                                            0x00CD
+#define VO_V2_VSYC_14_inst                                                            0x00CE
+#define VO_V2_VSYC_15_inst                                                            0x00CF
+#define VO_V2_VSYC_c1_shift                                                          (16)
+#define VO_V2_VSYC_c1_mask                                                           (0x3FFF0000)
+#define VO_V2_VSYC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V2_VSYC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_VSYC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_VSYC_c0_shift                                                          (0)
+#define VO_V2_VSYC_c0_mask                                                           (0x00003FFF)
+#define VO_V2_VSYC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V2_VSYC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V2_VSYC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_VSCC_0                                                                 0x98005740
+#define VO_V2_VSCC_1                                                                 0x98005744
+#define VO_V2_VSCC_2                                                                 0x98005748
+#define VO_V2_VSCC_3                                                                 0x9800574C
+#define VO_V2_VSCC_4                                                                 0x98005750
+#define VO_V2_VSCC_5                                                                 0x98005754
+#define VO_V2_VSCC_6                                                                 0x98005758
+#define VO_V2_VSCC_7                                                                 0x9800575C
+#define VO_V2_VSCC_8                                                                 0x98005760
+#define VO_V2_VSCC_9                                                                 0x98005764
+#define VO_V2_VSCC_10                                                                 0x98005768
+#define VO_V2_VSCC_11                                                                 0x9800576C
+#define VO_V2_VSCC_12                                                                 0x98005770
+#define VO_V2_VSCC_13                                                                 0x98005774
+#define VO_V2_VSCC_14                                                                 0x98005778
+#define VO_V2_VSCC_15                                                                 0x9800577C
+#define VO_V2_VSCC_0_reg_addr                                                        "0xD8005740"
+#define VO_V2_VSCC_1_reg_addr                                                        "0xD8005744"
+#define VO_V2_VSCC_2_reg_addr                                                        "0xD8005748"
+#define VO_V2_VSCC_3_reg_addr                                                        "0xD800574C"
+#define VO_V2_VSCC_4_reg_addr                                                        "0xD8005750"
+#define VO_V2_VSCC_5_reg_addr                                                        "0xD8005754"
+#define VO_V2_VSCC_6_reg_addr                                                        "0xD8005758"
+#define VO_V2_VSCC_7_reg_addr                                                        "0xD800575C"
+#define VO_V2_VSCC_8_reg_addr                                                        "0xD8005760"
+#define VO_V2_VSCC_9_reg_addr                                                        "0xD8005764"
+#define VO_V2_VSCC_10_reg_addr                                                        "0xD8005768"
+#define VO_V2_VSCC_11_reg_addr                                                        "0xD800576C"
+#define VO_V2_VSCC_12_reg_addr                                                        "0xD8005770"
+#define VO_V2_VSCC_13_reg_addr                                                        "0xD8005774"
+#define VO_V2_VSCC_14_reg_addr                                                        "0xD8005778"
+#define VO_V2_VSCC_15_reg_addr                                                        "0xD800577C"
+#define VO_V2_VSCC_0_reg                                                             0xD8005740
+#define VO_V2_VSCC_1_reg                                                             0xD8005744
+#define VO_V2_VSCC_2_reg                                                             0xD8005748
+#define VO_V2_VSCC_3_reg                                                             0xD800574C
+#define VO_V2_VSCC_4_reg                                                             0xD8005750
+#define VO_V2_VSCC_5_reg                                                             0xD8005754
+#define VO_V2_VSCC_6_reg                                                             0xD8005758
+#define VO_V2_VSCC_7_reg                                                             0xD800575C
+#define VO_V2_VSCC_8_reg                                                             0xD8005760
+#define VO_V2_VSCC_9_reg                                                             0xD8005764
+#define VO_V2_VSCC_10_reg                                                             0xD8005768
+#define VO_V2_VSCC_11_reg                                                             0xD800576C
+#define VO_V2_VSCC_12_reg                                                             0xD8005770
+#define VO_V2_VSCC_13_reg                                                             0xD8005774
+#define VO_V2_VSCC_14_reg                                                             0xD8005778
+#define VO_V2_VSCC_15_reg                                                             0xD800577C
+#define set_VO_V2_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_0_reg)=data)
+#define set_VO_V2_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_1_reg)=data)
+#define set_VO_V2_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_2_reg)=data)
+#define set_VO_V2_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_3_reg)=data)
+#define set_VO_V2_VSCC_4_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_4_reg)=data)
+#define set_VO_V2_VSCC_5_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_5_reg)=data)
+#define set_VO_V2_VSCC_6_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_6_reg)=data)
+#define set_VO_V2_VSCC_7_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_7_reg)=data)
+#define set_VO_V2_VSCC_8_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_8_reg)=data)
+#define set_VO_V2_VSCC_9_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_9_reg)=data)
+#define set_VO_V2_VSCC_10_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_10_reg)=data)
+#define set_VO_V2_VSCC_11_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_11_reg)=data)
+#define set_VO_V2_VSCC_12_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_12_reg)=data)
+#define set_VO_V2_VSCC_13_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_13_reg)=data)
+#define set_VO_V2_VSCC_14_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_14_reg)=data)
+#define set_VO_V2_VSCC_15_reg(data)   (*((volatile unsigned int*) VO_V2_VSCC_15_reg)=data)
+#define get_VO_V2_VSCC_0_reg   (*((volatile unsigned int*) VO_V2_VSCC_0_reg))
+#define get_VO_V2_VSCC_1_reg   (*((volatile unsigned int*) VO_V2_VSCC_1_reg))
+#define get_VO_V2_VSCC_2_reg   (*((volatile unsigned int*) VO_V2_VSCC_2_reg))
+#define get_VO_V2_VSCC_3_reg   (*((volatile unsigned int*) VO_V2_VSCC_3_reg))
+#define get_VO_V2_VSCC_4_reg   (*((volatile unsigned int*) VO_V2_VSCC_4_reg))
+#define get_VO_V2_VSCC_5_reg   (*((volatile unsigned int*) VO_V2_VSCC_5_reg))
+#define get_VO_V2_VSCC_6_reg   (*((volatile unsigned int*) VO_V2_VSCC_6_reg))
+#define get_VO_V2_VSCC_7_reg   (*((volatile unsigned int*) VO_V2_VSCC_7_reg))
+#define get_VO_V2_VSCC_8_reg   (*((volatile unsigned int*) VO_V2_VSCC_8_reg))
+#define get_VO_V2_VSCC_9_reg   (*((volatile unsigned int*) VO_V2_VSCC_9_reg))
+#define get_VO_V2_VSCC_10_reg   (*((volatile unsigned int*) VO_V2_VSCC_10_reg))
+#define get_VO_V2_VSCC_11_reg   (*((volatile unsigned int*) VO_V2_VSCC_11_reg))
+#define get_VO_V2_VSCC_12_reg   (*((volatile unsigned int*) VO_V2_VSCC_12_reg))
+#define get_VO_V2_VSCC_13_reg   (*((volatile unsigned int*) VO_V2_VSCC_13_reg))
+#define get_VO_V2_VSCC_14_reg   (*((volatile unsigned int*) VO_V2_VSCC_14_reg))
+#define get_VO_V2_VSCC_15_reg   (*((volatile unsigned int*) VO_V2_VSCC_15_reg))
+#define VO_V2_VSCC_0_inst_adr                                                        "0x00D0"
+#define VO_V2_VSCC_1_inst_adr                                                        "0x00D1"
+#define VO_V2_VSCC_2_inst_adr                                                        "0x00D2"
+#define VO_V2_VSCC_3_inst_adr                                                        "0x00D3"
+#define VO_V2_VSCC_4_inst_adr                                                        "0x00D4"
+#define VO_V2_VSCC_5_inst_adr                                                        "0x00D5"
+#define VO_V2_VSCC_6_inst_adr                                                        "0x00D6"
+#define VO_V2_VSCC_7_inst_adr                                                        "0x00D7"
+#define VO_V2_VSCC_8_inst_adr                                                        "0x00D8"
+#define VO_V2_VSCC_9_inst_adr                                                        "0x00D9"
+#define VO_V2_VSCC_10_inst_adr                                                        "0x00DA"
+#define VO_V2_VSCC_11_inst_adr                                                        "0x00DB"
+#define VO_V2_VSCC_12_inst_adr                                                        "0x00DC"
+#define VO_V2_VSCC_13_inst_adr                                                        "0x00DD"
+#define VO_V2_VSCC_14_inst_adr                                                        "0x00DE"
+#define VO_V2_VSCC_15_inst_adr                                                        "0x00DF"
+#define VO_V2_VSCC_0_inst                                                            0x00D0
+#define VO_V2_VSCC_1_inst                                                            0x00D1
+#define VO_V2_VSCC_2_inst                                                            0x00D2
+#define VO_V2_VSCC_3_inst                                                            0x00D3
+#define VO_V2_VSCC_4_inst                                                            0x00D4
+#define VO_V2_VSCC_5_inst                                                            0x00D5
+#define VO_V2_VSCC_6_inst                                                            0x00D6
+#define VO_V2_VSCC_7_inst                                                            0x00D7
+#define VO_V2_VSCC_8_inst                                                            0x00D8
+#define VO_V2_VSCC_9_inst                                                            0x00D9
+#define VO_V2_VSCC_10_inst                                                            0x00DA
+#define VO_V2_VSCC_11_inst                                                            0x00DB
+#define VO_V2_VSCC_12_inst                                                            0x00DC
+#define VO_V2_VSCC_13_inst                                                            0x00DD
+#define VO_V2_VSCC_14_inst                                                            0x00DE
+#define VO_V2_VSCC_15_inst                                                            0x00DF
+#define VO_V2_VSCC_c1_shift                                                          (16)
+#define VO_V2_VSCC_c1_mask                                                           (0x3FFF0000)
+#define VO_V2_VSCC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V2_VSCC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_VSCC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_VSCC_c0_shift                                                          (0)
+#define VO_V2_VSCC_c0_mask                                                           (0x00003FFF)
+#define VO_V2_VSCC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V2_VSCC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V2_VSCC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_HSI                                                                    0x98005780
+#define VO_V2_HSI_reg_addr                                                           "0xD8005780"
+#define VO_V2_HSI_reg                                                                0xD8005780
+#define set_VO_V2_HSI_reg(data)   (*((volatile unsigned int*) VO_V2_HSI_reg)=data)
+#define get_VO_V2_HSI_reg   (*((volatile unsigned int*) VO_V2_HSI_reg))
+#define VO_V2_HSI_inst_adr                                                           "0x00E0"
+#define VO_V2_HSI_inst                                                               0x00E0
+#define VO_V2_HSI_offset_shift                                                       (16)
+#define VO_V2_HSI_offset_mask                                                        (0x1FFF0000)
+#define VO_V2_HSI_offset(data)                                                       (0x1FFF0000&((data)<<16))
+#define VO_V2_HSI_offset_src(data)                                                   ((0x1FFF0000&(data))>>16)
+#define VO_V2_HSI_get_offset(data)                                                   ((0x1FFF0000&(data))>>16)
+#define VO_V2_HSI_phase_shift                                                        (0)
+#define VO_V2_HSI_phase_mask                                                         (0x0000FFFF)
+#define VO_V2_HSI_phase(data)                                                        (0x0000FFFF&((data)<<0))
+#define VO_V2_HSI_phase_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define VO_V2_HSI_get_phase(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V2_HSD                                                                    0x98005784
+#define VO_V2_HSD_reg_addr                                                           "0xD8005784"
+#define VO_V2_HSD_reg                                                                0xD8005784
+#define set_VO_V2_HSD_reg(data)   (*((volatile unsigned int*) VO_V2_HSD_reg)=data)
+#define get_VO_V2_HSD_reg   (*((volatile unsigned int*) VO_V2_HSD_reg))
+#define VO_V2_HSD_inst_adr                                                           "0x00E1"
+#define VO_V2_HSD_inst                                                               0x00E1
+#define VO_V2_HSD_delta_shift                                                        (0)
+#define VO_V2_HSD_delta_mask                                                         (0x001FFFFF)
+#define VO_V2_HSD_delta(data)                                                        (0x001FFFFF&((data)<<0))
+#define VO_V2_HSD_delta_src(data)                                                    ((0x001FFFFF&(data))>>0)
+#define VO_V2_HSD_get_delta(data)                                                    ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V2_HSD_W                                                                  0x98005788
+#define VO_V2_HSD_W_reg_addr                                                         "0xD8005788"
+#define VO_V2_HSD_W_reg                                                              0xD8005788
+#define set_VO_V2_HSD_W_reg(data)   (*((volatile unsigned int*) VO_V2_HSD_W_reg)=data)
+#define get_VO_V2_HSD_W_reg   (*((volatile unsigned int*) VO_V2_HSD_W_reg))
+#define VO_V2_HSD_W_inst_adr                                                         "0x00E2"
+#define VO_V2_HSD_W_inst                                                             0x00E2
+#define VO_V2_HSD_W_out_shift                                                        (0)
+#define VO_V2_HSD_W_out_mask                                                         (0x00001FFF)
+#define VO_V2_HSD_W_out(data)                                                        (0x00001FFF&((data)<<0))
+#define VO_V2_HSD_W_out_src(data)                                                    ((0x00001FFF&(data))>>0)
+#define VO_V2_HSD_W_get_out(data)                                                    ((0x00001FFF&(data))>>0)
+
+
+#define VO_V2_HSYC_0                                                                 0x9800578C
+#define VO_V2_HSYC_1                                                                 0x98005790
+#define VO_V2_HSYC_2                                                                 0x98005794
+#define VO_V2_HSYC_3                                                                 0x98005798
+#define VO_V2_HSYC_4                                                                 0x9800579C
+#define VO_V2_HSYC_5                                                                 0x980057A0
+#define VO_V2_HSYC_6                                                                 0x980057A4
+#define VO_V2_HSYC_7                                                                 0x980057A8
+#define VO_V2_HSYC_8                                                                 0x980057AC
+#define VO_V2_HSYC_9                                                                 0x980057B0
+#define VO_V2_HSYC_10                                                                 0x980057B4
+#define VO_V2_HSYC_11                                                                 0x980057B8
+#define VO_V2_HSYC_12                                                                 0x980057BC
+#define VO_V2_HSYC_13                                                                 0x980057C0
+#define VO_V2_HSYC_14                                                                 0x980057C4
+#define VO_V2_HSYC_15                                                                 0x980057C8
+#define VO_V2_HSYC_16                                                                 0x980057CC
+#define VO_V2_HSYC_17                                                                 0x980057D0
+#define VO_V2_HSYC_18                                                                 0x980057D4
+#define VO_V2_HSYC_19                                                                 0x980057D8
+#define VO_V2_HSYC_20                                                                 0x980057DC
+#define VO_V2_HSYC_21                                                                 0x980057E0
+#define VO_V2_HSYC_22                                                                 0x980057E4
+#define VO_V2_HSYC_23                                                                 0x980057E8
+#define VO_V2_HSYC_24                                                                 0x980057EC
+#define VO_V2_HSYC_25                                                                 0x980057F0
+#define VO_V2_HSYC_26                                                                 0x980057F4
+#define VO_V2_HSYC_27                                                                 0x980057F8
+#define VO_V2_HSYC_28                                                                 0x980057FC
+#define VO_V2_HSYC_29                                                                 0x98005800
+#define VO_V2_HSYC_30                                                                 0x98005804
+#define VO_V2_HSYC_31                                                                 0x98005808
+#define VO_V2_HSYC_0_reg_addr                                                        "0xD800578C"
+#define VO_V2_HSYC_1_reg_addr                                                        "0xD8005790"
+#define VO_V2_HSYC_2_reg_addr                                                        "0xD8005794"
+#define VO_V2_HSYC_3_reg_addr                                                        "0xD8005798"
+#define VO_V2_HSYC_4_reg_addr                                                        "0xD800579C"
+#define VO_V2_HSYC_5_reg_addr                                                        "0xD80057A0"
+#define VO_V2_HSYC_6_reg_addr                                                        "0xD80057A4"
+#define VO_V2_HSYC_7_reg_addr                                                        "0xD80057A8"
+#define VO_V2_HSYC_8_reg_addr                                                        "0xD80057AC"
+#define VO_V2_HSYC_9_reg_addr                                                        "0xD80057B0"
+#define VO_V2_HSYC_10_reg_addr                                                        "0xD80057B4"
+#define VO_V2_HSYC_11_reg_addr                                                        "0xD80057B8"
+#define VO_V2_HSYC_12_reg_addr                                                        "0xD80057BC"
+#define VO_V2_HSYC_13_reg_addr                                                        "0xD80057C0"
+#define VO_V2_HSYC_14_reg_addr                                                        "0xD80057C4"
+#define VO_V2_HSYC_15_reg_addr                                                        "0xD80057C8"
+#define VO_V2_HSYC_16_reg_addr                                                        "0xD80057CC"
+#define VO_V2_HSYC_17_reg_addr                                                        "0xD80057D0"
+#define VO_V2_HSYC_18_reg_addr                                                        "0xD80057D4"
+#define VO_V2_HSYC_19_reg_addr                                                        "0xD80057D8"
+#define VO_V2_HSYC_20_reg_addr                                                        "0xD80057DC"
+#define VO_V2_HSYC_21_reg_addr                                                        "0xD80057E0"
+#define VO_V2_HSYC_22_reg_addr                                                        "0xD80057E4"
+#define VO_V2_HSYC_23_reg_addr                                                        "0xD80057E8"
+#define VO_V2_HSYC_24_reg_addr                                                        "0xD80057EC"
+#define VO_V2_HSYC_25_reg_addr                                                        "0xD80057F0"
+#define VO_V2_HSYC_26_reg_addr                                                        "0xD80057F4"
+#define VO_V2_HSYC_27_reg_addr                                                        "0xD80057F8"
+#define VO_V2_HSYC_28_reg_addr                                                        "0xD80057FC"
+#define VO_V2_HSYC_29_reg_addr                                                        "0xD8005800"
+#define VO_V2_HSYC_30_reg_addr                                                        "0xD8005804"
+#define VO_V2_HSYC_31_reg_addr                                                        "0xD8005808"
+#define VO_V2_HSYC_0_reg                                                             0xD800578C
+#define VO_V2_HSYC_1_reg                                                             0xD8005790
+#define VO_V2_HSYC_2_reg                                                             0xD8005794
+#define VO_V2_HSYC_3_reg                                                             0xD8005798
+#define VO_V2_HSYC_4_reg                                                             0xD800579C
+#define VO_V2_HSYC_5_reg                                                             0xD80057A0
+#define VO_V2_HSYC_6_reg                                                             0xD80057A4
+#define VO_V2_HSYC_7_reg                                                             0xD80057A8
+#define VO_V2_HSYC_8_reg                                                             0xD80057AC
+#define VO_V2_HSYC_9_reg                                                             0xD80057B0
+#define VO_V2_HSYC_10_reg                                                             0xD80057B4
+#define VO_V2_HSYC_11_reg                                                             0xD80057B8
+#define VO_V2_HSYC_12_reg                                                             0xD80057BC
+#define VO_V2_HSYC_13_reg                                                             0xD80057C0
+#define VO_V2_HSYC_14_reg                                                             0xD80057C4
+#define VO_V2_HSYC_15_reg                                                             0xD80057C8
+#define VO_V2_HSYC_16_reg                                                             0xD80057CC
+#define VO_V2_HSYC_17_reg                                                             0xD80057D0
+#define VO_V2_HSYC_18_reg                                                             0xD80057D4
+#define VO_V2_HSYC_19_reg                                                             0xD80057D8
+#define VO_V2_HSYC_20_reg                                                             0xD80057DC
+#define VO_V2_HSYC_21_reg                                                             0xD80057E0
+#define VO_V2_HSYC_22_reg                                                             0xD80057E4
+#define VO_V2_HSYC_23_reg                                                             0xD80057E8
+#define VO_V2_HSYC_24_reg                                                             0xD80057EC
+#define VO_V2_HSYC_25_reg                                                             0xD80057F0
+#define VO_V2_HSYC_26_reg                                                             0xD80057F4
+#define VO_V2_HSYC_27_reg                                                             0xD80057F8
+#define VO_V2_HSYC_28_reg                                                             0xD80057FC
+#define VO_V2_HSYC_29_reg                                                             0xD8005800
+#define VO_V2_HSYC_30_reg                                                             0xD8005804
+#define VO_V2_HSYC_31_reg                                                             0xD8005808
+#define set_VO_V2_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_0_reg)=data)
+#define set_VO_V2_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_1_reg)=data)
+#define set_VO_V2_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_2_reg)=data)
+#define set_VO_V2_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_3_reg)=data)
+#define set_VO_V2_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_4_reg)=data)
+#define set_VO_V2_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_5_reg)=data)
+#define set_VO_V2_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_6_reg)=data)
+#define set_VO_V2_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_7_reg)=data)
+#define set_VO_V2_HSYC_8_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_8_reg)=data)
+#define set_VO_V2_HSYC_9_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_9_reg)=data)
+#define set_VO_V2_HSYC_10_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_10_reg)=data)
+#define set_VO_V2_HSYC_11_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_11_reg)=data)
+#define set_VO_V2_HSYC_12_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_12_reg)=data)
+#define set_VO_V2_HSYC_13_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_13_reg)=data)
+#define set_VO_V2_HSYC_14_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_14_reg)=data)
+#define set_VO_V2_HSYC_15_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_15_reg)=data)
+#define set_VO_V2_HSYC_16_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_16_reg)=data)
+#define set_VO_V2_HSYC_17_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_17_reg)=data)
+#define set_VO_V2_HSYC_18_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_18_reg)=data)
+#define set_VO_V2_HSYC_19_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_19_reg)=data)
+#define set_VO_V2_HSYC_20_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_20_reg)=data)
+#define set_VO_V2_HSYC_21_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_21_reg)=data)
+#define set_VO_V2_HSYC_22_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_22_reg)=data)
+#define set_VO_V2_HSYC_23_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_23_reg)=data)
+#define set_VO_V2_HSYC_24_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_24_reg)=data)
+#define set_VO_V2_HSYC_25_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_25_reg)=data)
+#define set_VO_V2_HSYC_26_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_26_reg)=data)
+#define set_VO_V2_HSYC_27_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_27_reg)=data)
+#define set_VO_V2_HSYC_28_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_28_reg)=data)
+#define set_VO_V2_HSYC_29_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_29_reg)=data)
+#define set_VO_V2_HSYC_30_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_30_reg)=data)
+#define set_VO_V2_HSYC_31_reg(data)   (*((volatile unsigned int*) VO_V2_HSYC_31_reg)=data)
+#define get_VO_V2_HSYC_0_reg   (*((volatile unsigned int*) VO_V2_HSYC_0_reg))
+#define get_VO_V2_HSYC_1_reg   (*((volatile unsigned int*) VO_V2_HSYC_1_reg))
+#define get_VO_V2_HSYC_2_reg   (*((volatile unsigned int*) VO_V2_HSYC_2_reg))
+#define get_VO_V2_HSYC_3_reg   (*((volatile unsigned int*) VO_V2_HSYC_3_reg))
+#define get_VO_V2_HSYC_4_reg   (*((volatile unsigned int*) VO_V2_HSYC_4_reg))
+#define get_VO_V2_HSYC_5_reg   (*((volatile unsigned int*) VO_V2_HSYC_5_reg))
+#define get_VO_V2_HSYC_6_reg   (*((volatile unsigned int*) VO_V2_HSYC_6_reg))
+#define get_VO_V2_HSYC_7_reg   (*((volatile unsigned int*) VO_V2_HSYC_7_reg))
+#define get_VO_V2_HSYC_8_reg   (*((volatile unsigned int*) VO_V2_HSYC_8_reg))
+#define get_VO_V2_HSYC_9_reg   (*((volatile unsigned int*) VO_V2_HSYC_9_reg))
+#define get_VO_V2_HSYC_10_reg   (*((volatile unsigned int*) VO_V2_HSYC_10_reg))
+#define get_VO_V2_HSYC_11_reg   (*((volatile unsigned int*) VO_V2_HSYC_11_reg))
+#define get_VO_V2_HSYC_12_reg   (*((volatile unsigned int*) VO_V2_HSYC_12_reg))
+#define get_VO_V2_HSYC_13_reg   (*((volatile unsigned int*) VO_V2_HSYC_13_reg))
+#define get_VO_V2_HSYC_14_reg   (*((volatile unsigned int*) VO_V2_HSYC_14_reg))
+#define get_VO_V2_HSYC_15_reg   (*((volatile unsigned int*) VO_V2_HSYC_15_reg))
+#define get_VO_V2_HSYC_16_reg   (*((volatile unsigned int*) VO_V2_HSYC_16_reg))
+#define get_VO_V2_HSYC_17_reg   (*((volatile unsigned int*) VO_V2_HSYC_17_reg))
+#define get_VO_V2_HSYC_18_reg   (*((volatile unsigned int*) VO_V2_HSYC_18_reg))
+#define get_VO_V2_HSYC_19_reg   (*((volatile unsigned int*) VO_V2_HSYC_19_reg))
+#define get_VO_V2_HSYC_20_reg   (*((volatile unsigned int*) VO_V2_HSYC_20_reg))
+#define get_VO_V2_HSYC_21_reg   (*((volatile unsigned int*) VO_V2_HSYC_21_reg))
+#define get_VO_V2_HSYC_22_reg   (*((volatile unsigned int*) VO_V2_HSYC_22_reg))
+#define get_VO_V2_HSYC_23_reg   (*((volatile unsigned int*) VO_V2_HSYC_23_reg))
+#define get_VO_V2_HSYC_24_reg   (*((volatile unsigned int*) VO_V2_HSYC_24_reg))
+#define get_VO_V2_HSYC_25_reg   (*((volatile unsigned int*) VO_V2_HSYC_25_reg))
+#define get_VO_V2_HSYC_26_reg   (*((volatile unsigned int*) VO_V2_HSYC_26_reg))
+#define get_VO_V2_HSYC_27_reg   (*((volatile unsigned int*) VO_V2_HSYC_27_reg))
+#define get_VO_V2_HSYC_28_reg   (*((volatile unsigned int*) VO_V2_HSYC_28_reg))
+#define get_VO_V2_HSYC_29_reg   (*((volatile unsigned int*) VO_V2_HSYC_29_reg))
+#define get_VO_V2_HSYC_30_reg   (*((volatile unsigned int*) VO_V2_HSYC_30_reg))
+#define get_VO_V2_HSYC_31_reg   (*((volatile unsigned int*) VO_V2_HSYC_31_reg))
+#define VO_V2_HSYC_0_inst_adr                                                        "0x00E3"
+#define VO_V2_HSYC_1_inst_adr                                                        "0x00E4"
+#define VO_V2_HSYC_2_inst_adr                                                        "0x00E5"
+#define VO_V2_HSYC_3_inst_adr                                                        "0x00E6"
+#define VO_V2_HSYC_4_inst_adr                                                        "0x00E7"
+#define VO_V2_HSYC_5_inst_adr                                                        "0x00E8"
+#define VO_V2_HSYC_6_inst_adr                                                        "0x00E9"
+#define VO_V2_HSYC_7_inst_adr                                                        "0x00EA"
+#define VO_V2_HSYC_8_inst_adr                                                        "0x00EB"
+#define VO_V2_HSYC_9_inst_adr                                                        "0x00EC"
+#define VO_V2_HSYC_10_inst_adr                                                        "0x00ED"
+#define VO_V2_HSYC_11_inst_adr                                                        "0x00EE"
+#define VO_V2_HSYC_12_inst_adr                                                        "0x00EF"
+#define VO_V2_HSYC_13_inst_adr                                                        "0x00F0"
+#define VO_V2_HSYC_14_inst_adr                                                        "0x00F1"
+#define VO_V2_HSYC_15_inst_adr                                                        "0x00F2"
+#define VO_V2_HSYC_16_inst_adr                                                        "0x00F3"
+#define VO_V2_HSYC_17_inst_adr                                                        "0x00F4"
+#define VO_V2_HSYC_18_inst_adr                                                        "0x00F5"
+#define VO_V2_HSYC_19_inst_adr                                                        "0x00F6"
+#define VO_V2_HSYC_20_inst_adr                                                        "0x00F7"
+#define VO_V2_HSYC_21_inst_adr                                                        "0x00F8"
+#define VO_V2_HSYC_22_inst_adr                                                        "0x00F9"
+#define VO_V2_HSYC_23_inst_adr                                                        "0x00FA"
+#define VO_V2_HSYC_24_inst_adr                                                        "0x00FB"
+#define VO_V2_HSYC_25_inst_adr                                                        "0x00FC"
+#define VO_V2_HSYC_26_inst_adr                                                        "0x00FD"
+#define VO_V2_HSYC_27_inst_adr                                                        "0x00FE"
+#define VO_V2_HSYC_28_inst_adr                                                        "0x00FF"
+#define VO_V2_HSYC_29_inst_adr                                                        "0x0100"
+#define VO_V2_HSYC_30_inst_adr                                                        "0x0101"
+#define VO_V2_HSYC_31_inst_adr                                                        "0x0102"
+#define VO_V2_HSYC_0_inst                                                            0x00E3
+#define VO_V2_HSYC_1_inst                                                            0x00E4
+#define VO_V2_HSYC_2_inst                                                            0x00E5
+#define VO_V2_HSYC_3_inst                                                            0x00E6
+#define VO_V2_HSYC_4_inst                                                            0x00E7
+#define VO_V2_HSYC_5_inst                                                            0x00E8
+#define VO_V2_HSYC_6_inst                                                            0x00E9
+#define VO_V2_HSYC_7_inst                                                            0x00EA
+#define VO_V2_HSYC_8_inst                                                            0x00EB
+#define VO_V2_HSYC_9_inst                                                            0x00EC
+#define VO_V2_HSYC_10_inst                                                            0x00ED
+#define VO_V2_HSYC_11_inst                                                            0x00EE
+#define VO_V2_HSYC_12_inst                                                            0x00EF
+#define VO_V2_HSYC_13_inst                                                            0x00F0
+#define VO_V2_HSYC_14_inst                                                            0x00F1
+#define VO_V2_HSYC_15_inst                                                            0x00F2
+#define VO_V2_HSYC_16_inst                                                            0x00F3
+#define VO_V2_HSYC_17_inst                                                            0x00F4
+#define VO_V2_HSYC_18_inst                                                            0x00F5
+#define VO_V2_HSYC_19_inst                                                            0x00F6
+#define VO_V2_HSYC_20_inst                                                            0x00F7
+#define VO_V2_HSYC_21_inst                                                            0x00F8
+#define VO_V2_HSYC_22_inst                                                            0x00F9
+#define VO_V2_HSYC_23_inst                                                            0x00FA
+#define VO_V2_HSYC_24_inst                                                            0x00FB
+#define VO_V2_HSYC_25_inst                                                            0x00FC
+#define VO_V2_HSYC_26_inst                                                            0x00FD
+#define VO_V2_HSYC_27_inst                                                            0x00FE
+#define VO_V2_HSYC_28_inst                                                            0x00FF
+#define VO_V2_HSYC_29_inst                                                            0x0100
+#define VO_V2_HSYC_30_inst                                                            0x0101
+#define VO_V2_HSYC_31_inst                                                            0x0102
+#define VO_V2_HSYC_c1_shift                                                          (16)
+#define VO_V2_HSYC_c1_mask                                                           (0x3FFF0000)
+#define VO_V2_HSYC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V2_HSYC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_HSYC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_HSYC_c0_shift                                                          (0)
+#define VO_V2_HSYC_c0_mask                                                           (0x00003FFF)
+#define VO_V2_HSYC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V2_HSYC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V2_HSYC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_HSCC_0                                                                 0x9800580C
+#define VO_V2_HSCC_1                                                                 0x98005810
+#define VO_V2_HSCC_2                                                                 0x98005814
+#define VO_V2_HSCC_3                                                                 0x98005818
+#define VO_V2_HSCC_4                                                                 0x9800581C
+#define VO_V2_HSCC_5                                                                 0x98005820
+#define VO_V2_HSCC_6                                                                 0x98005824
+#define VO_V2_HSCC_7                                                                 0x98005828
+#define VO_V2_HSCC_8                                                                 0x9800582C
+#define VO_V2_HSCC_9                                                                 0x98005830
+#define VO_V2_HSCC_10                                                                 0x98005834
+#define VO_V2_HSCC_11                                                                 0x98005838
+#define VO_V2_HSCC_12                                                                 0x9800583C
+#define VO_V2_HSCC_13                                                                 0x98005840
+#define VO_V2_HSCC_14                                                                 0x98005844
+#define VO_V2_HSCC_15                                                                 0x98005848
+#define VO_V2_HSCC_0_reg_addr                                                        "0xD800580C"
+#define VO_V2_HSCC_1_reg_addr                                                        "0xD8005810"
+#define VO_V2_HSCC_2_reg_addr                                                        "0xD8005814"
+#define VO_V2_HSCC_3_reg_addr                                                        "0xD8005818"
+#define VO_V2_HSCC_4_reg_addr                                                        "0xD800581C"
+#define VO_V2_HSCC_5_reg_addr                                                        "0xD8005820"
+#define VO_V2_HSCC_6_reg_addr                                                        "0xD8005824"
+#define VO_V2_HSCC_7_reg_addr                                                        "0xD8005828"
+#define VO_V2_HSCC_8_reg_addr                                                        "0xD800582C"
+#define VO_V2_HSCC_9_reg_addr                                                        "0xD8005830"
+#define VO_V2_HSCC_10_reg_addr                                                        "0xD8005834"
+#define VO_V2_HSCC_11_reg_addr                                                        "0xD8005838"
+#define VO_V2_HSCC_12_reg_addr                                                        "0xD800583C"
+#define VO_V2_HSCC_13_reg_addr                                                        "0xD8005840"
+#define VO_V2_HSCC_14_reg_addr                                                        "0xD8005844"
+#define VO_V2_HSCC_15_reg_addr                                                        "0xD8005848"
+#define VO_V2_HSCC_0_reg                                                             0xD800580C
+#define VO_V2_HSCC_1_reg                                                             0xD8005810
+#define VO_V2_HSCC_2_reg                                                             0xD8005814
+#define VO_V2_HSCC_3_reg                                                             0xD8005818
+#define VO_V2_HSCC_4_reg                                                             0xD800581C
+#define VO_V2_HSCC_5_reg                                                             0xD8005820
+#define VO_V2_HSCC_6_reg                                                             0xD8005824
+#define VO_V2_HSCC_7_reg                                                             0xD8005828
+#define VO_V2_HSCC_8_reg                                                             0xD800582C
+#define VO_V2_HSCC_9_reg                                                             0xD8005830
+#define VO_V2_HSCC_10_reg                                                             0xD8005834
+#define VO_V2_HSCC_11_reg                                                             0xD8005838
+#define VO_V2_HSCC_12_reg                                                             0xD800583C
+#define VO_V2_HSCC_13_reg                                                             0xD8005840
+#define VO_V2_HSCC_14_reg                                                             0xD8005844
+#define VO_V2_HSCC_15_reg                                                             0xD8005848
+#define set_VO_V2_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_0_reg)=data)
+#define set_VO_V2_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_1_reg)=data)
+#define set_VO_V2_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_2_reg)=data)
+#define set_VO_V2_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_3_reg)=data)
+#define set_VO_V2_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_4_reg)=data)
+#define set_VO_V2_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_5_reg)=data)
+#define set_VO_V2_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_6_reg)=data)
+#define set_VO_V2_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_7_reg)=data)
+#define set_VO_V2_HSCC_8_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_8_reg)=data)
+#define set_VO_V2_HSCC_9_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_9_reg)=data)
+#define set_VO_V2_HSCC_10_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_10_reg)=data)
+#define set_VO_V2_HSCC_11_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_11_reg)=data)
+#define set_VO_V2_HSCC_12_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_12_reg)=data)
+#define set_VO_V2_HSCC_13_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_13_reg)=data)
+#define set_VO_V2_HSCC_14_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_14_reg)=data)
+#define set_VO_V2_HSCC_15_reg(data)   (*((volatile unsigned int*) VO_V2_HSCC_15_reg)=data)
+#define get_VO_V2_HSCC_0_reg   (*((volatile unsigned int*) VO_V2_HSCC_0_reg))
+#define get_VO_V2_HSCC_1_reg   (*((volatile unsigned int*) VO_V2_HSCC_1_reg))
+#define get_VO_V2_HSCC_2_reg   (*((volatile unsigned int*) VO_V2_HSCC_2_reg))
+#define get_VO_V2_HSCC_3_reg   (*((volatile unsigned int*) VO_V2_HSCC_3_reg))
+#define get_VO_V2_HSCC_4_reg   (*((volatile unsigned int*) VO_V2_HSCC_4_reg))
+#define get_VO_V2_HSCC_5_reg   (*((volatile unsigned int*) VO_V2_HSCC_5_reg))
+#define get_VO_V2_HSCC_6_reg   (*((volatile unsigned int*) VO_V2_HSCC_6_reg))
+#define get_VO_V2_HSCC_7_reg   (*((volatile unsigned int*) VO_V2_HSCC_7_reg))
+#define get_VO_V2_HSCC_8_reg   (*((volatile unsigned int*) VO_V2_HSCC_8_reg))
+#define get_VO_V2_HSCC_9_reg   (*((volatile unsigned int*) VO_V2_HSCC_9_reg))
+#define get_VO_V2_HSCC_10_reg   (*((volatile unsigned int*) VO_V2_HSCC_10_reg))
+#define get_VO_V2_HSCC_11_reg   (*((volatile unsigned int*) VO_V2_HSCC_11_reg))
+#define get_VO_V2_HSCC_12_reg   (*((volatile unsigned int*) VO_V2_HSCC_12_reg))
+#define get_VO_V2_HSCC_13_reg   (*((volatile unsigned int*) VO_V2_HSCC_13_reg))
+#define get_VO_V2_HSCC_14_reg   (*((volatile unsigned int*) VO_V2_HSCC_14_reg))
+#define get_VO_V2_HSCC_15_reg   (*((volatile unsigned int*) VO_V2_HSCC_15_reg))
+#define VO_V2_HSCC_0_inst_adr                                                        "0x0003"
+#define VO_V2_HSCC_1_inst_adr                                                        "0x0004"
+#define VO_V2_HSCC_2_inst_adr                                                        "0x0005"
+#define VO_V2_HSCC_3_inst_adr                                                        "0x0006"
+#define VO_V2_HSCC_4_inst_adr                                                        "0x0007"
+#define VO_V2_HSCC_5_inst_adr                                                        "0x0008"
+#define VO_V2_HSCC_6_inst_adr                                                        "0x0009"
+#define VO_V2_HSCC_7_inst_adr                                                        "0x000A"
+#define VO_V2_HSCC_8_inst_adr                                                        "0x000B"
+#define VO_V2_HSCC_9_inst_adr                                                        "0x000C"
+#define VO_V2_HSCC_10_inst_adr                                                        "0x000D"
+#define VO_V2_HSCC_11_inst_adr                                                        "0x000E"
+#define VO_V2_HSCC_12_inst_adr                                                        "0x000F"
+#define VO_V2_HSCC_13_inst_adr                                                        "0x0010"
+#define VO_V2_HSCC_14_inst_adr                                                        "0x0011"
+#define VO_V2_HSCC_15_inst_adr                                                        "0x0012"
+#define VO_V2_HSCC_0_inst                                                            0x0003
+#define VO_V2_HSCC_1_inst                                                            0x0004
+#define VO_V2_HSCC_2_inst                                                            0x0005
+#define VO_V2_HSCC_3_inst                                                            0x0006
+#define VO_V2_HSCC_4_inst                                                            0x0007
+#define VO_V2_HSCC_5_inst                                                            0x0008
+#define VO_V2_HSCC_6_inst                                                            0x0009
+#define VO_V2_HSCC_7_inst                                                            0x000A
+#define VO_V2_HSCC_8_inst                                                            0x000B
+#define VO_V2_HSCC_9_inst                                                            0x000C
+#define VO_V2_HSCC_10_inst                                                            0x000D
+#define VO_V2_HSCC_11_inst                                                            0x000E
+#define VO_V2_HSCC_12_inst                                                            0x000F
+#define VO_V2_HSCC_13_inst                                                            0x0010
+#define VO_V2_HSCC_14_inst                                                            0x0011
+#define VO_V2_HSCC_15_inst                                                            0x0012
+#define VO_V2_HSCC_c1_shift                                                          (16)
+#define VO_V2_HSCC_c1_mask                                                           (0x3FFF0000)
+#define VO_V2_HSCC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V2_HSCC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_HSCC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_HSCC_c0_shift                                                          (0)
+#define VO_V2_HSCC_c0_mask                                                           (0x00003FFF)
+#define VO_V2_HSCC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V2_HSCC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V2_HSCC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_SHARP                                                                  0x9800584C
+#define VO_V2_SHARP_reg_addr                                                         "0xD800584C"
+#define VO_V2_SHARP_reg                                                              0xD800584C
+#define set_VO_V2_SHARP_reg(data)   (*((volatile unsigned int*) VO_V2_SHARP_reg)=data)
+#define get_VO_V2_SHARP_reg   (*((volatile unsigned int*) VO_V2_SHARP_reg))
+#define VO_V2_SHARP_inst_adr                                                         "0x0013"
+#define VO_V2_SHARP_inst                                                             0x0013
+#define VO_V2_SHARP_thd_shift                                                        (16)
+#define VO_V2_SHARP_thd_mask                                                         (0x03FF0000)
+#define VO_V2_SHARP_thd(data)                                                        (0x03FF0000&((data)<<16))
+#define VO_V2_SHARP_thd_src(data)                                                    ((0x03FF0000&(data))>>16)
+#define VO_V2_SHARP_get_thd(data)                                                    ((0x03FF0000&(data))>>16)
+#define VO_V2_SHARP_gain_shift                                                       (0)
+#define VO_V2_SHARP_gain_mask                                                        (0x000000FF)
+#define VO_V2_SHARP_gain(data)                                                       (0x000000FF&((data)<<0))
+#define VO_V2_SHARP_gain_src(data)                                                   ((0x000000FF&(data))>>0)
+#define VO_V2_SHARP_get_gain(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define VO_V2_SHARP_CLIP                                                             0x98005850
+#define VO_V2_SHARP_CLIP_reg_addr                                                    "0xD8005850"
+#define VO_V2_SHARP_CLIP_reg                                                         0xD8005850
+#define set_VO_V2_SHARP_CLIP_reg(data)   (*((volatile unsigned int*) VO_V2_SHARP_CLIP_reg)=data)
+#define get_VO_V2_SHARP_CLIP_reg   (*((volatile unsigned int*) VO_V2_SHARP_CLIP_reg))
+#define VO_V2_SHARP_CLIP_inst_adr                                                    "0x0014"
+#define VO_V2_SHARP_CLIP_inst                                                        0x0014
+#define VO_V2_SHARP_CLIP_range_shift                                                 (16)
+#define VO_V2_SHARP_CLIP_range_mask                                                  (0x001F0000)
+#define VO_V2_SHARP_CLIP_range(data)                                                 (0x001F0000&((data)<<16))
+#define VO_V2_SHARP_CLIP_range_src(data)                                             ((0x001F0000&(data))>>16)
+#define VO_V2_SHARP_CLIP_get_range(data)                                             ((0x001F0000&(data))>>16)
+#define VO_V2_SHARP_CLIP_en_shift                                                    (0)
+#define VO_V2_SHARP_CLIP_en_mask                                                     (0x00000001)
+#define VO_V2_SHARP_CLIP_en(data)                                                    (0x00000001&((data)<<0))
+#define VO_V2_SHARP_CLIP_en_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_V2_SHARP_CLIP_get_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_V2_SHARP_LPF                                                              0x98005854
+#define VO_V2_SHARP_LPF_reg_addr                                                     "0xD8005854"
+#define VO_V2_SHARP_LPF_reg                                                          0xD8005854
+#define set_VO_V2_SHARP_LPF_reg(data)   (*((volatile unsigned int*) VO_V2_SHARP_LPF_reg)=data)
+#define get_VO_V2_SHARP_LPF_reg   (*((volatile unsigned int*) VO_V2_SHARP_LPF_reg))
+#define VO_V2_SHARP_LPF_inst_adr                                                     "0x0015"
+#define VO_V2_SHARP_LPF_inst                                                         0x0015
+#define VO_V2_SHARP_LPF_c4_shift                                                     (16)
+#define VO_V2_SHARP_LPF_c4_mask                                                      (0x00070000)
+#define VO_V2_SHARP_LPF_c4(data)                                                     (0x00070000&((data)<<16))
+#define VO_V2_SHARP_LPF_c4_src(data)                                                 ((0x00070000&(data))>>16)
+#define VO_V2_SHARP_LPF_get_c4(data)                                                 ((0x00070000&(data))>>16)
+#define VO_V2_SHARP_LPF_c3_shift                                                     (12)
+#define VO_V2_SHARP_LPF_c3_mask                                                      (0x00007000)
+#define VO_V2_SHARP_LPF_c3(data)                                                     (0x00007000&((data)<<12))
+#define VO_V2_SHARP_LPF_c3_src(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V2_SHARP_LPF_get_c3(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V2_SHARP_LPF_c2_shift                                                     (8)
+#define VO_V2_SHARP_LPF_c2_mask                                                      (0x00000700)
+#define VO_V2_SHARP_LPF_c2(data)                                                     (0x00000700&((data)<<8))
+#define VO_V2_SHARP_LPF_c2_src(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V2_SHARP_LPF_get_c2(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V2_SHARP_LPF_c1_shift                                                     (4)
+#define VO_V2_SHARP_LPF_c1_mask                                                      (0x00000070)
+#define VO_V2_SHARP_LPF_c1(data)                                                     (0x00000070&((data)<<4))
+#define VO_V2_SHARP_LPF_c1_src(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V2_SHARP_LPF_get_c1(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V2_SHARP_LPF_c0_shift                                                     (0)
+#define VO_V2_SHARP_LPF_c0_mask                                                      (0x00000007)
+#define VO_V2_SHARP_LPF_c0(data)                                                     (0x00000007&((data)<<0))
+#define VO_V2_SHARP_LPF_c0_src(data)                                                 ((0x00000007&(data))>>0)
+#define VO_V2_SHARP_LPF_get_c0(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define VO_V2_CC1                                                                    0x98005858
+#define VO_V2_CC1_reg_addr                                                           "0xD8005858"
+#define VO_V2_CC1_reg                                                                0xD8005858
+#define set_VO_V2_CC1_reg(data)   (*((volatile unsigned int*) VO_V2_CC1_reg)=data)
+#define get_VO_V2_CC1_reg   (*((volatile unsigned int*) VO_V2_CC1_reg))
+#define VO_V2_CC1_inst_adr                                                           "0x0016"
+#define VO_V2_CC1_inst                                                               0x0016
+#define VO_V2_CC1_m01_shift                                                          (16)
+#define VO_V2_CC1_m01_mask                                                           (0x3FFF0000)
+#define VO_V2_CC1_m01(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V2_CC1_m01_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_CC1_get_m01(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_CC1_m00_shift                                                          (0)
+#define VO_V2_CC1_m00_mask                                                           (0x00003FFF)
+#define VO_V2_CC1_m00(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V2_CC1_m00_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V2_CC1_get_m00(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_CC2                                                                    0x9800585C
+#define VO_V2_CC2_reg_addr                                                           "0xD800585C"
+#define VO_V2_CC2_reg                                                                0xD800585C
+#define set_VO_V2_CC2_reg(data)   (*((volatile unsigned int*) VO_V2_CC2_reg)=data)
+#define get_VO_V2_CC2_reg   (*((volatile unsigned int*) VO_V2_CC2_reg))
+#define VO_V2_CC2_inst_adr                                                           "0x0017"
+#define VO_V2_CC2_inst                                                               0x0017
+#define VO_V2_CC2_m10_shift                                                          (16)
+#define VO_V2_CC2_m10_mask                                                           (0x3FFF0000)
+#define VO_V2_CC2_m10(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V2_CC2_m10_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_CC2_get_m10(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_CC2_m02_shift                                                          (0)
+#define VO_V2_CC2_m02_mask                                                           (0x00003FFF)
+#define VO_V2_CC2_m02(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V2_CC2_m02_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V2_CC2_get_m02(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_CC3                                                                    0x98005860
+#define VO_V2_CC3_reg_addr                                                           "0xD8005860"
+#define VO_V2_CC3_reg                                                                0xD8005860
+#define set_VO_V2_CC3_reg(data)   (*((volatile unsigned int*) VO_V2_CC3_reg)=data)
+#define get_VO_V2_CC3_reg   (*((volatile unsigned int*) VO_V2_CC3_reg))
+#define VO_V2_CC3_inst_adr                                                           "0x0018"
+#define VO_V2_CC3_inst                                                               0x0018
+#define VO_V2_CC3_m12_shift                                                          (16)
+#define VO_V2_CC3_m12_mask                                                           (0x3FFF0000)
+#define VO_V2_CC3_m12(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V2_CC3_m12_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_CC3_get_m12(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_CC3_m11_shift                                                          (0)
+#define VO_V2_CC3_m11_mask                                                           (0x00003FFF)
+#define VO_V2_CC3_m11(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V2_CC3_m11_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V2_CC3_get_m11(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_CC4                                                                    0x98005864
+#define VO_V2_CC4_reg_addr                                                           "0xD8005864"
+#define VO_V2_CC4_reg                                                                0xD8005864
+#define set_VO_V2_CC4_reg(data)   (*((volatile unsigned int*) VO_V2_CC4_reg)=data)
+#define get_VO_V2_CC4_reg   (*((volatile unsigned int*) VO_V2_CC4_reg))
+#define VO_V2_CC4_inst_adr                                                           "0x0019"
+#define VO_V2_CC4_inst                                                               0x0019
+#define VO_V2_CC4_m21_shift                                                          (16)
+#define VO_V2_CC4_m21_mask                                                           (0x3FFF0000)
+#define VO_V2_CC4_m21(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V2_CC4_m21_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_CC4_get_m21(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V2_CC4_m20_shift                                                          (0)
+#define VO_V2_CC4_m20_mask                                                           (0x00003FFF)
+#define VO_V2_CC4_m20(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V2_CC4_m20_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V2_CC4_get_m20(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_CC5                                                                    0x98005868
+#define VO_V2_CC5_reg_addr                                                           "0xD8005868"
+#define VO_V2_CC5_reg                                                                0xD8005868
+#define set_VO_V2_CC5_reg(data)   (*((volatile unsigned int*) VO_V2_CC5_reg)=data)
+#define get_VO_V2_CC5_reg   (*((volatile unsigned int*) VO_V2_CC5_reg))
+#define VO_V2_CC5_inst_adr                                                           "0x001A"
+#define VO_V2_CC5_inst                                                               0x001A
+#define VO_V2_CC5_m22_shift                                                          (0)
+#define VO_V2_CC5_m22_mask                                                           (0x00003FFF)
+#define VO_V2_CC5_m22(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V2_CC5_m22_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V2_CC5_get_m22(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V2_CC6                                                                    0x9800586C
+#define VO_V2_CC6_reg_addr                                                           "0xD800586C"
+#define VO_V2_CC6_reg                                                                0xD800586C
+#define set_VO_V2_CC6_reg(data)   (*((volatile unsigned int*) VO_V2_CC6_reg)=data)
+#define get_VO_V2_CC6_reg   (*((volatile unsigned int*) VO_V2_CC6_reg))
+#define VO_V2_CC6_inst_adr                                                           "0x001B"
+#define VO_V2_CC6_inst                                                               0x001B
+#define VO_V2_CC6_a1_shift                                                           (16)
+#define VO_V2_CC6_a1_mask                                                            (0x07FF0000)
+#define VO_V2_CC6_a1(data)                                                           (0x07FF0000&((data)<<16))
+#define VO_V2_CC6_a1_src(data)                                                       ((0x07FF0000&(data))>>16)
+#define VO_V2_CC6_get_a1(data)                                                       ((0x07FF0000&(data))>>16)
+#define VO_V2_CC6_a0_shift                                                           (0)
+#define VO_V2_CC6_a0_mask                                                            (0x000007FF)
+#define VO_V2_CC6_a0(data)                                                           (0x000007FF&((data)<<0))
+#define VO_V2_CC6_a0_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VO_V2_CC6_get_a0(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VO_V2_CC7                                                                    0x98005870
+#define VO_V2_CC7_reg_addr                                                           "0xD8005870"
+#define VO_V2_CC7_reg                                                                0xD8005870
+#define set_VO_V2_CC7_reg(data)   (*((volatile unsigned int*) VO_V2_CC7_reg)=data)
+#define get_VO_V2_CC7_reg   (*((volatile unsigned int*) VO_V2_CC7_reg))
+#define VO_V2_CC7_inst_adr                                                           "0x001C"
+#define VO_V2_CC7_inst                                                               0x001C
+#define VO_V2_CC7_a2_shift                                                           (0)
+#define VO_V2_CC7_a2_mask                                                            (0x000007FF)
+#define VO_V2_CC7_a2(data)                                                           (0x000007FF&((data)<<0))
+#define VO_V2_CC7_a2_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VO_V2_CC7_get_a2(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1                                                                      0x98005874
+#define VO_SUB1_reg_addr                                                             "0xD8005874"
+#define VO_SUB1_reg                                                                  0xD8005874
+#define set_VO_SUB1_reg(data)   (*((volatile unsigned int*) VO_SUB1_reg)=data)
+#define get_VO_SUB1_reg   (*((volatile unsigned int*) VO_SUB1_reg))
+#define VO_SUB1_inst_adr                                                             "0x001D"
+#define VO_SUB1_inst                                                                 0x001D
+#define VO_SUB1_d3_dbh_shift                                                         (29)
+#define VO_SUB1_d3_dbh_mask                                                          (0x20000000)
+#define VO_SUB1_d3_dbh(data)                                                         (0x20000000&((data)<<29))
+#define VO_SUB1_d3_dbh_src(data)                                                     ((0x20000000&(data))>>29)
+#define VO_SUB1_get_d3_dbh(data)                                                     ((0x20000000&(data))>>29)
+#define VO_SUB1_d3_vdup_shift                                                        (28)
+#define VO_SUB1_d3_vdup_mask                                                         (0x10000000)
+#define VO_SUB1_d3_vdup(data)                                                        (0x10000000&((data)<<28))
+#define VO_SUB1_d3_vdup_src(data)                                                    ((0x10000000&(data))>>28)
+#define VO_SUB1_get_d3_vdup(data)                                                    ((0x10000000&(data))>>28)
+#define VO_SUB1_d3_dbw_shift                                                         (27)
+#define VO_SUB1_d3_dbw_mask                                                          (0x08000000)
+#define VO_SUB1_d3_dbw(data)                                                         (0x08000000&((data)<<27))
+#define VO_SUB1_d3_dbw_src(data)                                                     ((0x08000000&(data))>>27)
+#define VO_SUB1_get_d3_dbw(data)                                                     ((0x08000000&(data))>>27)
+#define VO_SUB1_d3_dup_shift                                                         (26)
+#define VO_SUB1_d3_dup_mask                                                          (0x04000000)
+#define VO_SUB1_d3_dup(data)                                                         (0x04000000&((data)<<26))
+#define VO_SUB1_d3_dup_src(data)                                                     ((0x04000000&(data))>>26)
+#define VO_SUB1_get_d3_dup(data)                                                     ((0x04000000&(data))>>26)
+#define VO_SUB1_rgb_out_shift                                                        (25)
+#define VO_SUB1_rgb_out_mask                                                         (0x02000000)
+#define VO_SUB1_rgb_out(data)                                                        (0x02000000&((data)<<25))
+#define VO_SUB1_rgb_out_src(data)                                                    ((0x02000000&(data))>>25)
+#define VO_SUB1_get_rgb_out(data)                                                    ((0x02000000&(data))>>25)
+#define VO_SUB1_dvd_shift                                                            (23)
+#define VO_SUB1_dvd_mask                                                             (0x00800000)
+#define VO_SUB1_dvd(data)                                                            (0x00800000&((data)<<23))
+#define VO_SUB1_dvd_src(data)                                                        ((0x00800000&(data))>>23)
+#define VO_SUB1_get_dvd(data)                                                        ((0x00800000&(data))>>23)
+#define VO_SUB1_hddvd_shift                                                          (22)
+#define VO_SUB1_hddvd_mask                                                           (0x00400000)
+#define VO_SUB1_hddvd(data)                                                          (0x00400000&((data)<<22))
+#define VO_SUB1_hddvd_src(data)                                                      ((0x00400000&(data))>>22)
+#define VO_SUB1_get_hddvd(data)                                                      ((0x00400000&(data))>>22)
+#define VO_SUB1_hl_shift                                                             (19)
+#define VO_SUB1_hl_mask                                                              (0x00080000)
+#define VO_SUB1_hl(data)                                                             (0x00080000&((data)<<19))
+#define VO_SUB1_hl_src(data)                                                         ((0x00080000&(data))>>19)
+#define VO_SUB1_get_hl(data)                                                         ((0x00080000&(data))>>19)
+#define VO_SUB1_dvb_shift                                                            (17)
+#define VO_SUB1_dvb_mask                                                             (0x00020000)
+#define VO_SUB1_dvb(data)                                                            (0x00020000&((data)<<17))
+#define VO_SUB1_dvb_src(data)                                                        ((0x00020000&(data))>>17)
+#define VO_SUB1_get_dvb(data)                                                        ((0x00020000&(data))>>17)
+#define VO_SUB1_osd_shift                                                            (16)
+#define VO_SUB1_osd_mask                                                             (0x00010000)
+#define VO_SUB1_osd(data)                                                            (0x00010000&((data)<<16))
+#define VO_SUB1_osd_src(data)                                                        ((0x00010000&(data))>>16)
+#define VO_SUB1_get_osd(data)                                                        ((0x00010000&(data))>>16)
+#define VO_SUB1_fetch_1080i_shift                                                    (15)
+#define VO_SUB1_fetch_1080i_mask                                                     (0x00008000)
+#define VO_SUB1_fetch_1080i(data)                                                    (0x00008000&((data)<<15))
+#define VO_SUB1_fetch_1080i_src(data)                                                ((0x00008000&(data))>>15)
+#define VO_SUB1_get_fetch_1080i(data)                                                ((0x00008000&(data))>>15)
+#define VO_SUB1_odd_1080i_shift                                                      (14)
+#define VO_SUB1_odd_1080i_mask                                                       (0x00004000)
+#define VO_SUB1_odd_1080i(data)                                                      (0x00004000&((data)<<14))
+#define VO_SUB1_odd_1080i_src(data)                                                  ((0x00004000&(data))>>14)
+#define VO_SUB1_get_odd_1080i(data)                                                  ((0x00004000&(data))>>14)
+#define VO_SUB1_vs_shift                                                             (10)
+#define VO_SUB1_vs_mask                                                              (0x00000400)
+#define VO_SUB1_vs(data)                                                             (0x00000400&((data)<<10))
+#define VO_SUB1_vs_src(data)                                                         ((0x00000400&(data))>>10)
+#define VO_SUB1_get_vs(data)                                                         ((0x00000400&(data))>>10)
+#define VO_SUB1_vs_near_shift                                                        (9)
+#define VO_SUB1_vs_near_mask                                                         (0x00000200)
+#define VO_SUB1_vs_near(data)                                                        (0x00000200&((data)<<9))
+#define VO_SUB1_vs_near_src(data)                                                    ((0x00000200&(data))>>9)
+#define VO_SUB1_get_vs_near(data)                                                    ((0x00000200&(data))>>9)
+#define VO_SUB1_vs_yodd_shift                                                        (8)
+#define VO_SUB1_vs_yodd_mask                                                         (0x00000100)
+#define VO_SUB1_vs_yodd(data)                                                        (0x00000100&((data)<<8))
+#define VO_SUB1_vs_yodd_src(data)                                                    ((0x00000100&(data))>>8)
+#define VO_SUB1_get_vs_yodd(data)                                                    ((0x00000100&(data))>>8)
+#define VO_SUB1_vs_codd_shift                                                        (7)
+#define VO_SUB1_vs_codd_mask                                                         (0x00000080)
+#define VO_SUB1_vs_codd(data)                                                        (0x00000080&((data)<<7))
+#define VO_SUB1_vs_codd_src(data)                                                    ((0x00000080&(data))>>7)
+#define VO_SUB1_get_vs_codd(data)                                                    ((0x00000080&(data))>>7)
+#define VO_SUB1_hs_shift                                                             (6)
+#define VO_SUB1_hs_mask                                                              (0x00000040)
+#define VO_SUB1_hs(data)                                                             (0x00000040&((data)<<6))
+#define VO_SUB1_hs_src(data)                                                         ((0x00000040&(data))>>6)
+#define VO_SUB1_get_hs(data)                                                         ((0x00000040&(data))>>6)
+#define VO_SUB1_hs_yodd_shift                                                        (5)
+#define VO_SUB1_hs_yodd_mask                                                         (0x00000020)
+#define VO_SUB1_hs_yodd(data)                                                        (0x00000020&((data)<<5))
+#define VO_SUB1_hs_yodd_src(data)                                                    ((0x00000020&(data))>>5)
+#define VO_SUB1_get_hs_yodd(data)                                                    ((0x00000020&(data))>>5)
+#define VO_SUB1_hs_codd_shift                                                        (4)
+#define VO_SUB1_hs_codd_mask                                                         (0x00000010)
+#define VO_SUB1_hs_codd(data)                                                        (0x00000010&((data)<<4))
+#define VO_SUB1_hs_codd_src(data)                                                    ((0x00000010&(data))>>4)
+#define VO_SUB1_get_hs_codd(data)                                                    ((0x00000010&(data))>>4)
+#define VO_SUB1_write_data_shift                                                     (0)
+#define VO_SUB1_write_data_mask                                                      (0x00000001)
+#define VO_SUB1_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_SUB1_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_SUB1_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_SUB1_START                                                                0x98005878
+#define VO_SUB1_START_reg_addr                                                       "0xD8005878"
+#define VO_SUB1_START_reg                                                            0xD8005878
+#define set_VO_SUB1_START_reg(data)   (*((volatile unsigned int*) VO_SUB1_START_reg)=data)
+#define get_VO_SUB1_START_reg   (*((volatile unsigned int*) VO_SUB1_START_reg))
+#define VO_SUB1_START_inst_adr                                                       "0x001E"
+#define VO_SUB1_START_inst                                                           0x001E
+#define VO_SUB1_START_ref_shift                                                      (24)
+#define VO_SUB1_START_ref_mask                                                       (0x07000000)
+#define VO_SUB1_START_ref(data)                                                      (0x07000000&((data)<<24))
+#define VO_SUB1_START_ref_src(data)                                                  ((0x07000000&(data))>>24)
+#define VO_SUB1_START_get_ref(data)                                                  ((0x07000000&(data))>>24)
+#define VO_SUB1_START_pos_shift                                                      (12)
+#define VO_SUB1_START_pos_mask                                                       (0x00FFF000)
+#define VO_SUB1_START_pos(data)                                                      (0x00FFF000&((data)<<12))
+#define VO_SUB1_START_pos_src(data)                                                  ((0x00FFF000&(data))>>12)
+#define VO_SUB1_START_get_pos(data)                                                  ((0x00FFF000&(data))>>12)
+#define VO_SUB1_START_th_shift                                                       (0)
+#define VO_SUB1_START_th_mask                                                        (0x00000FFF)
+#define VO_SUB1_START_th(data)                                                       (0x00000FFF&((data)<<0))
+#define VO_SUB1_START_th_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VO_SUB1_START_get_th(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VO_SUB1_SUBP                                                                 0x9800587C
+#define VO_SUB1_SUBP_reg_addr                                                        "0xD800587C"
+#define VO_SUB1_SUBP_reg                                                             0xD800587C
+#define set_VO_SUB1_SUBP_reg(data)   (*((volatile unsigned int*) VO_SUB1_SUBP_reg)=data)
+#define get_VO_SUB1_SUBP_reg   (*((volatile unsigned int*) VO_SUB1_SUBP_reg))
+#define VO_SUB1_SUBP_inst_adr                                                        "0x001F"
+#define VO_SUB1_SUBP_inst                                                            0x001F
+#define VO_SUB1_SUBP_w_shift                                                         (0)
+#define VO_SUB1_SUBP_w_mask                                                          (0x00000FFF)
+#define VO_SUB1_SUBP_w(data)                                                         (0x00000FFF&((data)<<0))
+#define VO_SUB1_SUBP_w_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define VO_SUB1_SUBP_get_w(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define VO_SUB1_SIZE                                                                 0x98005880
+#define VO_SUB1_SIZE_reg_addr                                                        "0xD8005880"
+#define VO_SUB1_SIZE_reg                                                             0xD8005880
+#define set_VO_SUB1_SIZE_reg(data)   (*((volatile unsigned int*) VO_SUB1_SIZE_reg)=data)
+#define get_VO_SUB1_SIZE_reg   (*((volatile unsigned int*) VO_SUB1_SIZE_reg))
+#define VO_SUB1_SIZE_inst_adr                                                        "0x0020"
+#define VO_SUB1_SIZE_inst                                                            0x0020
+#define VO_SUB1_SIZE_w_shift                                                         (12)
+#define VO_SUB1_SIZE_w_mask                                                          (0x007FF000)
+#define VO_SUB1_SIZE_w(data)                                                         (0x007FF000&((data)<<12))
+#define VO_SUB1_SIZE_w_src(data)                                                     ((0x007FF000&(data))>>12)
+#define VO_SUB1_SIZE_get_w(data)                                                     ((0x007FF000&(data))>>12)
+#define VO_SUB1_SIZE_h_shift                                                         (0)
+#define VO_SUB1_SIZE_h_mask                                                          (0x000007FF)
+#define VO_SUB1_SIZE_h(data)                                                         (0x000007FF&((data)<<0))
+#define VO_SUB1_SIZE_h_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_SUB1_SIZE_get_h(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1_BUF                                                                  0x98005884
+#define VO_SUB1_BUF_reg_addr                                                         "0xD8005884"
+#define VO_SUB1_BUF_reg                                                              0xD8005884
+#define set_VO_SUB1_BUF_reg(data)   (*((volatile unsigned int*) VO_SUB1_BUF_reg)=data)
+#define get_VO_SUB1_BUF_reg   (*((volatile unsigned int*) VO_SUB1_BUF_reg))
+#define VO_SUB1_BUF_inst_adr                                                         "0x0021"
+#define VO_SUB1_BUF_inst                                                             0x0021
+#define VO_SUB1_BUF_th_shift                                                         (0)
+#define VO_SUB1_BUF_th_mask                                                          (0x000001FF)
+#define VO_SUB1_BUF_th(data)                                                         (0x000001FF&((data)<<0))
+#define VO_SUB1_BUF_th_src(data)                                                     ((0x000001FF&(data))>>0)
+#define VO_SUB1_BUF_get_th(data)                                                     ((0x000001FF&(data))>>0)
+
+
+#define VO_SUB1_WI                                                                   0x98005888
+#define VO_SUB1_WI_reg_addr                                                          "0xD8005888"
+#define VO_SUB1_WI_reg                                                               0xD8005888
+#define set_VO_SUB1_WI_reg(data)   (*((volatile unsigned int*) VO_SUB1_WI_reg)=data)
+#define get_VO_SUB1_WI_reg   (*((volatile unsigned int*) VO_SUB1_WI_reg))
+#define VO_SUB1_WI_inst_adr                                                          "0x0022"
+#define VO_SUB1_WI_inst                                                              0x0022
+#define VO_SUB1_WI_swap_8byte_shift                                                  (1)
+#define VO_SUB1_WI_swap_8byte_mask                                                   (0x00000002)
+#define VO_SUB1_WI_swap_8byte(data)                                                  (0x00000002&((data)<<1))
+#define VO_SUB1_WI_swap_8byte_src(data)                                              ((0x00000002&(data))>>1)
+#define VO_SUB1_WI_get_swap_8byte(data)                                              ((0x00000002&(data))>>1)
+#define VO_SUB1_WI_endian_shift                                                      (0)
+#define VO_SUB1_WI_endian_mask                                                       (0x00000001)
+#define VO_SUB1_WI_endian(data)                                                      (0x00000001&((data)<<0))
+#define VO_SUB1_WI_endian_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_SUB1_WI_get_endian(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_SUB1_WI_1                                                                 0x9800588C
+#define VO_SUB1_WI_1_reg_addr                                                        "0xD800588C"
+#define VO_SUB1_WI_1_reg                                                             0xD800588C
+#define set_VO_SUB1_WI_1_reg(data)   (*((volatile unsigned int*) VO_SUB1_WI_1_reg)=data)
+#define get_VO_SUB1_WI_1_reg   (*((volatile unsigned int*) VO_SUB1_WI_1_reg))
+#define VO_SUB1_WI_1_inst_adr                                                        "0x0023"
+#define VO_SUB1_WI_1_inst                                                            0x0023
+#define VO_SUB1_WI_1_a_shift                                                         (0)
+#define VO_SUB1_WI_1_a_mask                                                          (0xFFFFFFFF)
+#define VO_SUB1_WI_1_a(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define VO_SUB1_WI_1_a_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define VO_SUB1_WI_1_get_a(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SUB1_WI_3D                                                                0x98005890
+#define VO_SUB1_WI_3D_reg_addr                                                       "0xD8005890"
+#define VO_SUB1_WI_3D_reg                                                            0xD8005890
+#define set_VO_SUB1_WI_3D_reg(data)   (*((volatile unsigned int*) VO_SUB1_WI_3D_reg)=data)
+#define get_VO_SUB1_WI_3D_reg   (*((volatile unsigned int*) VO_SUB1_WI_3D_reg))
+#define VO_SUB1_WI_3D_inst_adr                                                       "0x0024"
+#define VO_SUB1_WI_3D_inst                                                           0x0024
+#define VO_SUB1_WI_3D_a_shift                                                        (0)
+#define VO_SUB1_WI_3D_a_mask                                                         (0xFFFFFFFF)
+#define VO_SUB1_WI_3D_a(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define VO_SUB1_WI_3D_a_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define VO_SUB1_WI_3D_get_a(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SUB1_CLUT                                                                 0x98005894
+#define VO_SUB1_CLUT_reg_addr                                                        "0xD8005894"
+#define VO_SUB1_CLUT_reg                                                             0xD8005894
+#define set_VO_SUB1_CLUT_reg(data)   (*((volatile unsigned int*) VO_SUB1_CLUT_reg)=data)
+#define get_VO_SUB1_CLUT_reg   (*((volatile unsigned int*) VO_SUB1_CLUT_reg))
+#define VO_SUB1_CLUT_inst_adr                                                        "0x0025"
+#define VO_SUB1_CLUT_inst                                                            0x0025
+#define VO_SUB1_CLUT_keep_shift                                                      (0)
+#define VO_SUB1_CLUT_keep_mask                                                       (0x00000001)
+#define VO_SUB1_CLUT_keep(data)                                                      (0x00000001&((data)<<0))
+#define VO_SUB1_CLUT_keep_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_SUB1_CLUT_get_keep(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_SUB1_CLUT_1                                                               0x98005898
+#define VO_SUB1_CLUT_1_reg_addr                                                      "0xD8005898"
+#define VO_SUB1_CLUT_1_reg                                                           0xD8005898
+#define set_VO_SUB1_CLUT_1_reg(data)   (*((volatile unsigned int*) VO_SUB1_CLUT_1_reg)=data)
+#define get_VO_SUB1_CLUT_1_reg   (*((volatile unsigned int*) VO_SUB1_CLUT_1_reg))
+#define VO_SUB1_CLUT_1_inst_adr                                                      "0x0026"
+#define VO_SUB1_CLUT_1_inst                                                          0x0026
+#define VO_SUB1_CLUT_1_a_shift                                                       (0)
+#define VO_SUB1_CLUT_1_a_mask                                                        (0xFFFFFFFF)
+#define VO_SUB1_CLUT_1_a(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define VO_SUB1_CLUT_1_a_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define VO_SUB1_CLUT_1_get_a(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SUB1_PXDT                                                                 0x9800589C
+#define VO_SUB1_PXDT_reg_addr                                                        "0xD800589C"
+#define VO_SUB1_PXDT_reg                                                             0xD800589C
+#define set_VO_SUB1_PXDT_reg(data)   (*((volatile unsigned int*) VO_SUB1_PXDT_reg)=data)
+#define get_VO_SUB1_PXDT_reg   (*((volatile unsigned int*) VO_SUB1_PXDT_reg))
+#define VO_SUB1_PXDT_inst_adr                                                        "0x0027"
+#define VO_SUB1_PXDT_inst                                                            0x0027
+#define VO_SUB1_PXDT_a_shift                                                         (0)
+#define VO_SUB1_PXDT_a_mask                                                          (0xFFFFFFFF)
+#define VO_SUB1_PXDT_a(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define VO_SUB1_PXDT_a_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define VO_SUB1_PXDT_get_a(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SUB1_PXDB                                                                 0x980058A0
+#define VO_SUB1_PXDB_reg_addr                                                        "0xD80058A0"
+#define VO_SUB1_PXDB_reg                                                             0xD80058A0
+#define set_VO_SUB1_PXDB_reg(data)   (*((volatile unsigned int*) VO_SUB1_PXDB_reg)=data)
+#define get_VO_SUB1_PXDB_reg   (*((volatile unsigned int*) VO_SUB1_PXDB_reg))
+#define VO_SUB1_PXDB_inst_adr                                                        "0x0028"
+#define VO_SUB1_PXDB_inst                                                            0x0028
+#define VO_SUB1_PXDB_a_shift                                                         (0)
+#define VO_SUB1_PXDB_a_mask                                                          (0xFFFFFFFF)
+#define VO_SUB1_PXDB_a(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define VO_SUB1_PXDB_a_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define VO_SUB1_PXDB_get_a(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SUB1_LC                                                                   0x980058A4
+#define VO_SUB1_LC_reg_addr                                                          "0xD80058A4"
+#define VO_SUB1_LC_reg                                                               0xD80058A4
+#define set_VO_SUB1_LC_reg(data)   (*((volatile unsigned int*) VO_SUB1_LC_reg)=data)
+#define get_VO_SUB1_LC_reg   (*((volatile unsigned int*) VO_SUB1_LC_reg))
+#define VO_SUB1_LC_inst_adr                                                          "0x0029"
+#define VO_SUB1_LC_inst                                                              0x0029
+#define VO_SUB1_LC_num_shift                                                         (0)
+#define VO_SUB1_LC_num_mask                                                          (0x000007FF)
+#define VO_SUB1_LC_num(data)                                                         (0x000007FF&((data)<<0))
+#define VO_SUB1_LC_num_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_SUB1_LC_get_num(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1_DFT                                                                  0x980058A8
+#define VO_SUB1_DFT_reg_addr                                                         "0xD80058A8"
+#define VO_SUB1_DFT_reg                                                              0xD80058A8
+#define set_VO_SUB1_DFT_reg(data)   (*((volatile unsigned int*) VO_SUB1_DFT_reg)=data)
+#define get_VO_SUB1_DFT_reg   (*((volatile unsigned int*) VO_SUB1_DFT_reg))
+#define VO_SUB1_DFT_inst_adr                                                         "0x002A"
+#define VO_SUB1_DFT_inst                                                             0x002A
+#define VO_SUB1_DFT_a3_shift                                                         (28)
+#define VO_SUB1_DFT_a3_mask                                                          (0xF0000000)
+#define VO_SUB1_DFT_a3(data)                                                         (0xF0000000&((data)<<28))
+#define VO_SUB1_DFT_a3_src(data)                                                     ((0xF0000000&(data))>>28)
+#define VO_SUB1_DFT_get_a3(data)                                                     ((0xF0000000&(data))>>28)
+#define VO_SUB1_DFT_a2_shift                                                         (24)
+#define VO_SUB1_DFT_a2_mask                                                          (0x0F000000)
+#define VO_SUB1_DFT_a2(data)                                                         (0x0F000000&((data)<<24))
+#define VO_SUB1_DFT_a2_src(data)                                                     ((0x0F000000&(data))>>24)
+#define VO_SUB1_DFT_get_a2(data)                                                     ((0x0F000000&(data))>>24)
+#define VO_SUB1_DFT_a1_shift                                                         (20)
+#define VO_SUB1_DFT_a1_mask                                                          (0x00F00000)
+#define VO_SUB1_DFT_a1(data)                                                         (0x00F00000&((data)<<20))
+#define VO_SUB1_DFT_a1_src(data)                                                     ((0x00F00000&(data))>>20)
+#define VO_SUB1_DFT_get_a1(data)                                                     ((0x00F00000&(data))>>20)
+#define VO_SUB1_DFT_a0_shift                                                         (16)
+#define VO_SUB1_DFT_a0_mask                                                          (0x000F0000)
+#define VO_SUB1_DFT_a0(data)                                                         (0x000F0000&((data)<<16))
+#define VO_SUB1_DFT_a0_src(data)                                                     ((0x000F0000&(data))>>16)
+#define VO_SUB1_DFT_get_a0(data)                                                     ((0x000F0000&(data))>>16)
+#define VO_SUB1_DFT_i3_shift                                                         (12)
+#define VO_SUB1_DFT_i3_mask                                                          (0x0000F000)
+#define VO_SUB1_DFT_i3(data)                                                         (0x0000F000&((data)<<12))
+#define VO_SUB1_DFT_i3_src(data)                                                     ((0x0000F000&(data))>>12)
+#define VO_SUB1_DFT_get_i3(data)                                                     ((0x0000F000&(data))>>12)
+#define VO_SUB1_DFT_i2_shift                                                         (8)
+#define VO_SUB1_DFT_i2_mask                                                          (0x00000F00)
+#define VO_SUB1_DFT_i2(data)                                                         (0x00000F00&((data)<<8))
+#define VO_SUB1_DFT_i2_src(data)                                                     ((0x00000F00&(data))>>8)
+#define VO_SUB1_DFT_get_i2(data)                                                     ((0x00000F00&(data))>>8)
+#define VO_SUB1_DFT_i1_shift                                                         (4)
+#define VO_SUB1_DFT_i1_mask                                                          (0x000000F0)
+#define VO_SUB1_DFT_i1(data)                                                         (0x000000F0&((data)<<4))
+#define VO_SUB1_DFT_i1_src(data)                                                     ((0x000000F0&(data))>>4)
+#define VO_SUB1_DFT_get_i1(data)                                                     ((0x000000F0&(data))>>4)
+#define VO_SUB1_DFT_i0_shift                                                         (0)
+#define VO_SUB1_DFT_i0_mask                                                          (0x0000000F)
+#define VO_SUB1_DFT_i0(data)                                                         (0x0000000F&((data)<<0))
+#define VO_SUB1_DFT_i0_src(data)                                                     ((0x0000000F&(data))>>0)
+#define VO_SUB1_DFT_get_i0(data)                                                     ((0x0000000F&(data))>>0)
+
+
+#define VO_SUB1_HLX                                                                  0x980058AC
+#define VO_SUB1_HLX_reg_addr                                                         "0xD80058AC"
+#define VO_SUB1_HLX_reg                                                              0xD80058AC
+#define set_VO_SUB1_HLX_reg(data)   (*((volatile unsigned int*) VO_SUB1_HLX_reg)=data)
+#define get_VO_SUB1_HLX_reg   (*((volatile unsigned int*) VO_SUB1_HLX_reg))
+#define VO_SUB1_HLX_inst_adr                                                         "0x002B"
+#define VO_SUB1_HLX_inst                                                             0x002B
+#define VO_SUB1_HLX_e_shift                                                          (12)
+#define VO_SUB1_HLX_e_mask                                                           (0x007FF000)
+#define VO_SUB1_HLX_e(data)                                                          (0x007FF000&((data)<<12))
+#define VO_SUB1_HLX_e_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB1_HLX_get_e(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB1_HLX_s_shift                                                          (0)
+#define VO_SUB1_HLX_s_mask                                                           (0x000007FF)
+#define VO_SUB1_HLX_s(data)                                                          (0x000007FF&((data)<<0))
+#define VO_SUB1_HLX_s_src(data)                                                      ((0x000007FF&(data))>>0)
+#define VO_SUB1_HLX_get_s(data)                                                      ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1_HLY                                                                  0x980058B0
+#define VO_SUB1_HLY_reg_addr                                                         "0xD80058B0"
+#define VO_SUB1_HLY_reg                                                              0xD80058B0
+#define set_VO_SUB1_HLY_reg(data)   (*((volatile unsigned int*) VO_SUB1_HLY_reg)=data)
+#define get_VO_SUB1_HLY_reg   (*((volatile unsigned int*) VO_SUB1_HLY_reg))
+#define VO_SUB1_HLY_inst_adr                                                         "0x002C"
+#define VO_SUB1_HLY_inst                                                             0x002C
+#define VO_SUB1_HLY_e_shift                                                          (12)
+#define VO_SUB1_HLY_e_mask                                                           (0x007FF000)
+#define VO_SUB1_HLY_e(data)                                                          (0x007FF000&((data)<<12))
+#define VO_SUB1_HLY_e_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB1_HLY_get_e(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB1_HLY_s_shift                                                          (0)
+#define VO_SUB1_HLY_s_mask                                                           (0x000007FF)
+#define VO_SUB1_HLY_s(data)                                                          (0x000007FF&((data)<<0))
+#define VO_SUB1_HLY_s_src(data)                                                      ((0x000007FF&(data))>>0)
+#define VO_SUB1_HLY_get_s(data)                                                      ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1_HL                                                                   0x980058B4
+#define VO_SUB1_HL_reg_addr                                                          "0xD80058B4"
+#define VO_SUB1_HL_reg                                                               0xD80058B4
+#define set_VO_SUB1_HL_reg(data)   (*((volatile unsigned int*) VO_SUB1_HL_reg)=data)
+#define get_VO_SUB1_HL_reg   (*((volatile unsigned int*) VO_SUB1_HL_reg))
+#define VO_SUB1_HL_inst_adr                                                          "0x002D"
+#define VO_SUB1_HL_inst                                                              0x002D
+#define VO_SUB1_HL_a3_shift                                                          (28)
+#define VO_SUB1_HL_a3_mask                                                           (0xF0000000)
+#define VO_SUB1_HL_a3(data)                                                          (0xF0000000&((data)<<28))
+#define VO_SUB1_HL_a3_src(data)                                                      ((0xF0000000&(data))>>28)
+#define VO_SUB1_HL_get_a3(data)                                                      ((0xF0000000&(data))>>28)
+#define VO_SUB1_HL_a2_shift                                                          (24)
+#define VO_SUB1_HL_a2_mask                                                           (0x0F000000)
+#define VO_SUB1_HL_a2(data)                                                          (0x0F000000&((data)<<24))
+#define VO_SUB1_HL_a2_src(data)                                                      ((0x0F000000&(data))>>24)
+#define VO_SUB1_HL_get_a2(data)                                                      ((0x0F000000&(data))>>24)
+#define VO_SUB1_HL_a1_shift                                                          (20)
+#define VO_SUB1_HL_a1_mask                                                           (0x00F00000)
+#define VO_SUB1_HL_a1(data)                                                          (0x00F00000&((data)<<20))
+#define VO_SUB1_HL_a1_src(data)                                                      ((0x00F00000&(data))>>20)
+#define VO_SUB1_HL_get_a1(data)                                                      ((0x00F00000&(data))>>20)
+#define VO_SUB1_HL_a0_shift                                                          (16)
+#define VO_SUB1_HL_a0_mask                                                           (0x000F0000)
+#define VO_SUB1_HL_a0(data)                                                          (0x000F0000&((data)<<16))
+#define VO_SUB1_HL_a0_src(data)                                                      ((0x000F0000&(data))>>16)
+#define VO_SUB1_HL_get_a0(data)                                                      ((0x000F0000&(data))>>16)
+#define VO_SUB1_HL_i3_shift                                                          (12)
+#define VO_SUB1_HL_i3_mask                                                           (0x0000F000)
+#define VO_SUB1_HL_i3(data)                                                          (0x0000F000&((data)<<12))
+#define VO_SUB1_HL_i3_src(data)                                                      ((0x0000F000&(data))>>12)
+#define VO_SUB1_HL_get_i3(data)                                                      ((0x0000F000&(data))>>12)
+#define VO_SUB1_HL_i2_shift                                                          (8)
+#define VO_SUB1_HL_i2_mask                                                           (0x00000F00)
+#define VO_SUB1_HL_i2(data)                                                          (0x00000F00&((data)<<8))
+#define VO_SUB1_HL_i2_src(data)                                                      ((0x00000F00&(data))>>8)
+#define VO_SUB1_HL_get_i2(data)                                                      ((0x00000F00&(data))>>8)
+#define VO_SUB1_HL_i1_shift                                                          (4)
+#define VO_SUB1_HL_i1_mask                                                           (0x000000F0)
+#define VO_SUB1_HL_i1(data)                                                          (0x000000F0&((data)<<4))
+#define VO_SUB1_HL_i1_src(data)                                                      ((0x000000F0&(data))>>4)
+#define VO_SUB1_HL_get_i1(data)                                                      ((0x000000F0&(data))>>4)
+#define VO_SUB1_HL_i0_shift                                                          (0)
+#define VO_SUB1_HL_i0_mask                                                           (0x0000000F)
+#define VO_SUB1_HL_i0(data)                                                          (0x0000000F&((data)<<0))
+#define VO_SUB1_HL_i0_src(data)                                                      ((0x0000000F&(data))>>0)
+#define VO_SUB1_HL_get_i0(data)                                                      ((0x0000000F&(data))>>0)
+
+
+#define VO_SUB1_CC1                                                                  0x980058B8
+#define VO_SUB1_CC1_reg_addr                                                         "0xD80058B8"
+#define VO_SUB1_CC1_reg                                                              0xD80058B8
+#define set_VO_SUB1_CC1_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC1_reg)=data)
+#define get_VO_SUB1_CC1_reg   (*((volatile unsigned int*) VO_SUB1_CC1_reg))
+#define VO_SUB1_CC1_inst_adr                                                         "0x002E"
+#define VO_SUB1_CC1_inst                                                             0x002E
+#define VO_SUB1_CC1_m01_shift                                                        (16)
+#define VO_SUB1_CC1_m01_mask                                                         (0x3FFF0000)
+#define VO_SUB1_CC1_m01(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_CC1_m01_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC1_get_m01(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC1_m00_shift                                                        (0)
+#define VO_SUB1_CC1_m00_mask                                                         (0x00003FFF)
+#define VO_SUB1_CC1_m00(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_CC1_m00_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_CC1_get_m00(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_CC2                                                                  0x980058BC
+#define VO_SUB1_CC2_reg_addr                                                         "0xD80058BC"
+#define VO_SUB1_CC2_reg                                                              0xD80058BC
+#define set_VO_SUB1_CC2_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC2_reg)=data)
+#define get_VO_SUB1_CC2_reg   (*((volatile unsigned int*) VO_SUB1_CC2_reg))
+#define VO_SUB1_CC2_inst_adr                                                         "0x002F"
+#define VO_SUB1_CC2_inst                                                             0x002F
+#define VO_SUB1_CC2_m10_shift                                                        (16)
+#define VO_SUB1_CC2_m10_mask                                                         (0x3FFF0000)
+#define VO_SUB1_CC2_m10(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_CC2_m10_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC2_get_m10(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC2_m02_shift                                                        (0)
+#define VO_SUB1_CC2_m02_mask                                                         (0x00003FFF)
+#define VO_SUB1_CC2_m02(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_CC2_m02_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_CC2_get_m02(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_CC3                                                                  0x980058C0
+#define VO_SUB1_CC3_reg_addr                                                         "0xD80058C0"
+#define VO_SUB1_CC3_reg                                                              0xD80058C0
+#define set_VO_SUB1_CC3_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC3_reg)=data)
+#define get_VO_SUB1_CC3_reg   (*((volatile unsigned int*) VO_SUB1_CC3_reg))
+#define VO_SUB1_CC3_inst_adr                                                         "0x0030"
+#define VO_SUB1_CC3_inst                                                             0x0030
+#define VO_SUB1_CC3_m12_shift                                                        (16)
+#define VO_SUB1_CC3_m12_mask                                                         (0x3FFF0000)
+#define VO_SUB1_CC3_m12(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_CC3_m12_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC3_get_m12(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC3_m11_shift                                                        (0)
+#define VO_SUB1_CC3_m11_mask                                                         (0x00003FFF)
+#define VO_SUB1_CC3_m11(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_CC3_m11_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_CC3_get_m11(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_CC4                                                                  0x980058C4
+#define VO_SUB1_CC4_reg_addr                                                         "0xD80058C4"
+#define VO_SUB1_CC4_reg                                                              0xD80058C4
+#define set_VO_SUB1_CC4_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC4_reg)=data)
+#define get_VO_SUB1_CC4_reg   (*((volatile unsigned int*) VO_SUB1_CC4_reg))
+#define VO_SUB1_CC4_inst_adr                                                         "0x0031"
+#define VO_SUB1_CC4_inst                                                             0x0031
+#define VO_SUB1_CC4_m21_shift                                                        (16)
+#define VO_SUB1_CC4_m21_mask                                                         (0x3FFF0000)
+#define VO_SUB1_CC4_m21(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_CC4_m21_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC4_get_m21(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC4_m20_shift                                                        (0)
+#define VO_SUB1_CC4_m20_mask                                                         (0x00003FFF)
+#define VO_SUB1_CC4_m20(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_CC4_m20_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_CC4_get_m20(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_CC5                                                                  0x980058C8
+#define VO_SUB1_CC5_reg_addr                                                         "0xD80058C8"
+#define VO_SUB1_CC5_reg                                                              0xD80058C8
+#define set_VO_SUB1_CC5_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC5_reg)=data)
+#define get_VO_SUB1_CC5_reg   (*((volatile unsigned int*) VO_SUB1_CC5_reg))
+#define VO_SUB1_CC5_inst_adr                                                         "0x0032"
+#define VO_SUB1_CC5_inst                                                             0x0032
+#define VO_SUB1_CC5_m22_shift                                                        (0)
+#define VO_SUB1_CC5_m22_mask                                                         (0x00003FFF)
+#define VO_SUB1_CC5_m22(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_CC5_m22_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_CC5_get_m22(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_CC6                                                                  0x980058CC
+#define VO_SUB1_CC6_reg_addr                                                         "0xD80058CC"
+#define VO_SUB1_CC6_reg                                                              0xD80058CC
+#define set_VO_SUB1_CC6_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC6_reg)=data)
+#define get_VO_SUB1_CC6_reg   (*((volatile unsigned int*) VO_SUB1_CC6_reg))
+#define VO_SUB1_CC6_inst_adr                                                         "0x0033"
+#define VO_SUB1_CC6_inst                                                             0x0033
+#define VO_SUB1_CC6_a1_shift                                                         (11)
+#define VO_SUB1_CC6_a1_mask                                                          (0x003FF800)
+#define VO_SUB1_CC6_a1(data)                                                         (0x003FF800&((data)<<11))
+#define VO_SUB1_CC6_a1_src(data)                                                     ((0x003FF800&(data))>>11)
+#define VO_SUB1_CC6_get_a1(data)                                                     ((0x003FF800&(data))>>11)
+#define VO_SUB1_CC6_a0_shift                                                         (0)
+#define VO_SUB1_CC6_a0_mask                                                          (0x000007FF)
+#define VO_SUB1_CC6_a0(data)                                                         (0x000007FF&((data)<<0))
+#define VO_SUB1_CC6_a0_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_SUB1_CC6_get_a0(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1_CC7                                                                  0x980058D0
+#define VO_SUB1_CC7_reg_addr                                                         "0xD80058D0"
+#define VO_SUB1_CC7_reg                                                              0xD80058D0
+#define set_VO_SUB1_CC7_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC7_reg)=data)
+#define get_VO_SUB1_CC7_reg   (*((volatile unsigned int*) VO_SUB1_CC7_reg))
+#define VO_SUB1_CC7_inst_adr                                                         "0x0034"
+#define VO_SUB1_CC7_inst                                                             0x0034
+#define VO_SUB1_CC7_a2_shift                                                         (0)
+#define VO_SUB1_CC7_a2_mask                                                          (0x000007FF)
+#define VO_SUB1_CC7_a2(data)                                                         (0x000007FF&((data)<<0))
+#define VO_SUB1_CC7_a2_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_SUB1_CC7_get_a2(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1_VSI                                                                  0x980058D4
+#define VO_SUB1_VSI_reg_addr                                                         "0xD80058D4"
+#define VO_SUB1_VSI_reg                                                              0xD80058D4
+#define set_VO_SUB1_VSI_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSI_reg)=data)
+#define get_VO_SUB1_VSI_reg   (*((volatile unsigned int*) VO_SUB1_VSI_reg))
+#define VO_SUB1_VSI_inst_adr                                                         "0x0035"
+#define VO_SUB1_VSI_inst                                                             0x0035
+#define VO_SUB1_VSI_offset_shift                                                     (16)
+#define VO_SUB1_VSI_offset_mask                                                      (0x0FFF0000)
+#define VO_SUB1_VSI_offset(data)                                                     (0x0FFF0000&((data)<<16))
+#define VO_SUB1_VSI_offset_src(data)                                                 ((0x0FFF0000&(data))>>16)
+#define VO_SUB1_VSI_get_offset(data)                                                 ((0x0FFF0000&(data))>>16)
+#define VO_SUB1_VSI_phase_shift                                                      (0)
+#define VO_SUB1_VSI_phase_mask                                                       (0x0000FFFF)
+#define VO_SUB1_VSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_SUB1_VSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_SUB1_VSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_SUB1_VSD                                                                  0x980058D8
+#define VO_SUB1_VSD_reg_addr                                                         "0xD80058D8"
+#define VO_SUB1_VSD_reg                                                              0xD80058D8
+#define set_VO_SUB1_VSD_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSD_reg)=data)
+#define get_VO_SUB1_VSD_reg   (*((volatile unsigned int*) VO_SUB1_VSD_reg))
+#define VO_SUB1_VSD_inst_adr                                                         "0x0036"
+#define VO_SUB1_VSD_inst                                                             0x0036
+#define VO_SUB1_VSD_delta_shift                                                      (0)
+#define VO_SUB1_VSD_delta_mask                                                       (0x001FFFFF)
+#define VO_SUB1_VSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_SUB1_VSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_SUB1_VSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_SUB1_VSD_H                                                                0x980058DC
+#define VO_SUB1_VSD_H_reg_addr                                                       "0xD80058DC"
+#define VO_SUB1_VSD_H_reg                                                            0xD80058DC
+#define set_VO_SUB1_VSD_H_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSD_H_reg)=data)
+#define get_VO_SUB1_VSD_H_reg   (*((volatile unsigned int*) VO_SUB1_VSD_H_reg))
+#define VO_SUB1_VSD_H_inst_adr                                                       "0x0037"
+#define VO_SUB1_VSD_H_inst                                                           0x0037
+#define VO_SUB1_VSD_H_out_shift                                                      (0)
+#define VO_SUB1_VSD_H_out_mask                                                       (0x00000FFF)
+#define VO_SUB1_VSD_H_out(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_SUB1_VSD_H_out_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_SUB1_VSD_H_get_out(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_SUB1_VSYC_0                                                               0x980058E0
+#define VO_SUB1_VSYC_1                                                               0x980058E4
+#define VO_SUB1_VSYC_2                                                               0x980058E8
+#define VO_SUB1_VSYC_3                                                               0x980058EC
+#define VO_SUB1_VSYC_0_reg_addr                                                      "0xD80058E0"
+#define VO_SUB1_VSYC_1_reg_addr                                                      "0xD80058E4"
+#define VO_SUB1_VSYC_2_reg_addr                                                      "0xD80058E8"
+#define VO_SUB1_VSYC_3_reg_addr                                                      "0xD80058EC"
+#define VO_SUB1_VSYC_0_reg                                                           0xD80058E0
+#define VO_SUB1_VSYC_1_reg                                                           0xD80058E4
+#define VO_SUB1_VSYC_2_reg                                                           0xD80058E8
+#define VO_SUB1_VSYC_3_reg                                                           0xD80058EC
+#define set_VO_SUB1_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSYC_0_reg)=data)
+#define set_VO_SUB1_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSYC_1_reg)=data)
+#define set_VO_SUB1_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSYC_2_reg)=data)
+#define set_VO_SUB1_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSYC_3_reg)=data)
+#define get_VO_SUB1_VSYC_0_reg   (*((volatile unsigned int*) VO_SUB1_VSYC_0_reg))
+#define get_VO_SUB1_VSYC_1_reg   (*((volatile unsigned int*) VO_SUB1_VSYC_1_reg))
+#define get_VO_SUB1_VSYC_2_reg   (*((volatile unsigned int*) VO_SUB1_VSYC_2_reg))
+#define get_VO_SUB1_VSYC_3_reg   (*((volatile unsigned int*) VO_SUB1_VSYC_3_reg))
+#define VO_SUB1_VSYC_0_inst_adr                                                      "0x0038"
+#define VO_SUB1_VSYC_1_inst_adr                                                      "0x0039"
+#define VO_SUB1_VSYC_2_inst_adr                                                      "0x003A"
+#define VO_SUB1_VSYC_3_inst_adr                                                      "0x003B"
+#define VO_SUB1_VSYC_0_inst                                                          0x0038
+#define VO_SUB1_VSYC_1_inst                                                          0x0039
+#define VO_SUB1_VSYC_2_inst                                                          0x003A
+#define VO_SUB1_VSYC_3_inst                                                          0x003B
+#define VO_SUB1_VSYC_c1_shift                                                        (16)
+#define VO_SUB1_VSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB1_VSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_VSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_VSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_VSYC_c0_shift                                                        (0)
+#define VO_SUB1_VSYC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB1_VSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_VSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_VSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_VSCC_0                                                               0x980058F0
+#define VO_SUB1_VSCC_1                                                               0x980058F4
+#define VO_SUB1_VSCC_2                                                               0x980058F8
+#define VO_SUB1_VSCC_3                                                               0x980058FC
+#define VO_SUB1_VSCC_0_reg_addr                                                      "0xD80058F0"
+#define VO_SUB1_VSCC_1_reg_addr                                                      "0xD80058F4"
+#define VO_SUB1_VSCC_2_reg_addr                                                      "0xD80058F8"
+#define VO_SUB1_VSCC_3_reg_addr                                                      "0xD80058FC"
+#define VO_SUB1_VSCC_0_reg                                                           0xD80058F0
+#define VO_SUB1_VSCC_1_reg                                                           0xD80058F4
+#define VO_SUB1_VSCC_2_reg                                                           0xD80058F8
+#define VO_SUB1_VSCC_3_reg                                                           0xD80058FC
+#define set_VO_SUB1_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSCC_0_reg)=data)
+#define set_VO_SUB1_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSCC_1_reg)=data)
+#define set_VO_SUB1_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSCC_2_reg)=data)
+#define set_VO_SUB1_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSCC_3_reg)=data)
+#define get_VO_SUB1_VSCC_0_reg   (*((volatile unsigned int*) VO_SUB1_VSCC_0_reg))
+#define get_VO_SUB1_VSCC_1_reg   (*((volatile unsigned int*) VO_SUB1_VSCC_1_reg))
+#define get_VO_SUB1_VSCC_2_reg   (*((volatile unsigned int*) VO_SUB1_VSCC_2_reg))
+#define get_VO_SUB1_VSCC_3_reg   (*((volatile unsigned int*) VO_SUB1_VSCC_3_reg))
+#define VO_SUB1_VSCC_0_inst_adr                                                      "0x003C"
+#define VO_SUB1_VSCC_1_inst_adr                                                      "0x003D"
+#define VO_SUB1_VSCC_2_inst_adr                                                      "0x003E"
+#define VO_SUB1_VSCC_3_inst_adr                                                      "0x003F"
+#define VO_SUB1_VSCC_0_inst                                                          0x003C
+#define VO_SUB1_VSCC_1_inst                                                          0x003D
+#define VO_SUB1_VSCC_2_inst                                                          0x003E
+#define VO_SUB1_VSCC_3_inst                                                          0x003F
+#define VO_SUB1_VSCC_c1_shift                                                        (16)
+#define VO_SUB1_VSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB1_VSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_VSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_VSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_VSCC_c0_shift                                                        (0)
+#define VO_SUB1_VSCC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB1_VSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_VSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_VSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_HSI                                                                  0x98005900
+#define VO_SUB1_HSI_reg_addr                                                         "0xD8005900"
+#define VO_SUB1_HSI_reg                                                              0xD8005900
+#define set_VO_SUB1_HSI_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSI_reg)=data)
+#define get_VO_SUB1_HSI_reg   (*((volatile unsigned int*) VO_SUB1_HSI_reg))
+#define VO_SUB1_HSI_inst_adr                                                         "0x0040"
+#define VO_SUB1_HSI_inst                                                             0x0040
+#define VO_SUB1_HSI_offset_shift                                                     (16)
+#define VO_SUB1_HSI_offset_mask                                                      (0x07FF0000)
+#define VO_SUB1_HSI_offset(data)                                                     (0x07FF0000&((data)<<16))
+#define VO_SUB1_HSI_offset_src(data)                                                 ((0x07FF0000&(data))>>16)
+#define VO_SUB1_HSI_get_offset(data)                                                 ((0x07FF0000&(data))>>16)
+#define VO_SUB1_HSI_phase_shift                                                      (0)
+#define VO_SUB1_HSI_phase_mask                                                       (0x0000FFFF)
+#define VO_SUB1_HSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_SUB1_HSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_SUB1_HSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_SUB1_HSD                                                                  0x98005904
+#define VO_SUB1_HSD_reg_addr                                                         "0xD8005904"
+#define VO_SUB1_HSD_reg                                                              0xD8005904
+#define set_VO_SUB1_HSD_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSD_reg)=data)
+#define get_VO_SUB1_HSD_reg   (*((volatile unsigned int*) VO_SUB1_HSD_reg))
+#define VO_SUB1_HSD_inst_adr                                                         "0x0041"
+#define VO_SUB1_HSD_inst                                                             0x0041
+#define VO_SUB1_HSD_delta_shift                                                      (0)
+#define VO_SUB1_HSD_delta_mask                                                       (0x001FFFFF)
+#define VO_SUB1_HSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_SUB1_HSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_SUB1_HSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_SUB1_HSD_W                                                                0x98005908
+#define VO_SUB1_HSD_W_reg_addr                                                       "0xD8005908"
+#define VO_SUB1_HSD_W_reg                                                            0xD8005908
+#define set_VO_SUB1_HSD_W_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSD_W_reg)=data)
+#define get_VO_SUB1_HSD_W_reg   (*((volatile unsigned int*) VO_SUB1_HSD_W_reg))
+#define VO_SUB1_HSD_W_inst_adr                                                       "0x0042"
+#define VO_SUB1_HSD_W_inst                                                           0x0042
+#define VO_SUB1_HSD_W_out_shift                                                      (0)
+#define VO_SUB1_HSD_W_out_mask                                                       (0x00001FFF)
+#define VO_SUB1_HSD_W_out(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_SUB1_HSD_W_out_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_SUB1_HSD_W_get_out(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_SUB1_HSYC_0                                                               0x9800590C
+#define VO_SUB1_HSYC_1                                                               0x98005910
+#define VO_SUB1_HSYC_2                                                               0x98005914
+#define VO_SUB1_HSYC_3                                                               0x98005918
+#define VO_SUB1_HSYC_4                                                               0x9800591C
+#define VO_SUB1_HSYC_5                                                               0x98005920
+#define VO_SUB1_HSYC_6                                                               0x98005924
+#define VO_SUB1_HSYC_7                                                               0x98005928
+#define VO_SUB1_HSYC_0_reg_addr                                                      "0xD800590C"
+#define VO_SUB1_HSYC_1_reg_addr                                                      "0xD8005910"
+#define VO_SUB1_HSYC_2_reg_addr                                                      "0xD8005914"
+#define VO_SUB1_HSYC_3_reg_addr                                                      "0xD8005918"
+#define VO_SUB1_HSYC_4_reg_addr                                                      "0xD800591C"
+#define VO_SUB1_HSYC_5_reg_addr                                                      "0xD8005920"
+#define VO_SUB1_HSYC_6_reg_addr                                                      "0xD8005924"
+#define VO_SUB1_HSYC_7_reg_addr                                                      "0xD8005928"
+#define VO_SUB1_HSYC_0_reg                                                           0xD800590C
+#define VO_SUB1_HSYC_1_reg                                                           0xD8005910
+#define VO_SUB1_HSYC_2_reg                                                           0xD8005914
+#define VO_SUB1_HSYC_3_reg                                                           0xD8005918
+#define VO_SUB1_HSYC_4_reg                                                           0xD800591C
+#define VO_SUB1_HSYC_5_reg                                                           0xD8005920
+#define VO_SUB1_HSYC_6_reg                                                           0xD8005924
+#define VO_SUB1_HSYC_7_reg                                                           0xD8005928
+#define set_VO_SUB1_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_0_reg)=data)
+#define set_VO_SUB1_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_1_reg)=data)
+#define set_VO_SUB1_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_2_reg)=data)
+#define set_VO_SUB1_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_3_reg)=data)
+#define set_VO_SUB1_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_4_reg)=data)
+#define set_VO_SUB1_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_5_reg)=data)
+#define set_VO_SUB1_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_6_reg)=data)
+#define set_VO_SUB1_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_7_reg)=data)
+#define get_VO_SUB1_HSYC_0_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_0_reg))
+#define get_VO_SUB1_HSYC_1_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_1_reg))
+#define get_VO_SUB1_HSYC_2_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_2_reg))
+#define get_VO_SUB1_HSYC_3_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_3_reg))
+#define get_VO_SUB1_HSYC_4_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_4_reg))
+#define get_VO_SUB1_HSYC_5_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_5_reg))
+#define get_VO_SUB1_HSYC_6_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_6_reg))
+#define get_VO_SUB1_HSYC_7_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_7_reg))
+#define VO_SUB1_HSYC_0_inst_adr                                                      "0x0043"
+#define VO_SUB1_HSYC_1_inst_adr                                                      "0x0044"
+#define VO_SUB1_HSYC_2_inst_adr                                                      "0x0045"
+#define VO_SUB1_HSYC_3_inst_adr                                                      "0x0046"
+#define VO_SUB1_HSYC_4_inst_adr                                                      "0x0047"
+#define VO_SUB1_HSYC_5_inst_adr                                                      "0x0048"
+#define VO_SUB1_HSYC_6_inst_adr                                                      "0x0049"
+#define VO_SUB1_HSYC_7_inst_adr                                                      "0x004A"
+#define VO_SUB1_HSYC_0_inst                                                          0x0043
+#define VO_SUB1_HSYC_1_inst                                                          0x0044
+#define VO_SUB1_HSYC_2_inst                                                          0x0045
+#define VO_SUB1_HSYC_3_inst                                                          0x0046
+#define VO_SUB1_HSYC_4_inst                                                          0x0047
+#define VO_SUB1_HSYC_5_inst                                                          0x0048
+#define VO_SUB1_HSYC_6_inst                                                          0x0049
+#define VO_SUB1_HSYC_7_inst                                                          0x004A
+#define VO_SUB1_HSYC_c1_shift                                                        (16)
+#define VO_SUB1_HSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB1_HSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_HSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_HSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_HSYC_c0_shift                                                        (0)
+#define VO_SUB1_HSYC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB1_HSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_HSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_HSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_HSCC_0                                                               0x9800592C
+#define VO_SUB1_HSCC_1                                                               0x98005930
+#define VO_SUB1_HSCC_2                                                               0x98005934
+#define VO_SUB1_HSCC_3                                                               0x98005938
+#define VO_SUB1_HSCC_4                                                               0x9800593C
+#define VO_SUB1_HSCC_5                                                               0x98005940
+#define VO_SUB1_HSCC_6                                                               0x98005944
+#define VO_SUB1_HSCC_7                                                               0x98005948
+#define VO_SUB1_HSCC_0_reg_addr                                                      "0xD800592C"
+#define VO_SUB1_HSCC_1_reg_addr                                                      "0xD8005930"
+#define VO_SUB1_HSCC_2_reg_addr                                                      "0xD8005934"
+#define VO_SUB1_HSCC_3_reg_addr                                                      "0xD8005938"
+#define VO_SUB1_HSCC_4_reg_addr                                                      "0xD800593C"
+#define VO_SUB1_HSCC_5_reg_addr                                                      "0xD8005940"
+#define VO_SUB1_HSCC_6_reg_addr                                                      "0xD8005944"
+#define VO_SUB1_HSCC_7_reg_addr                                                      "0xD8005948"
+#define VO_SUB1_HSCC_0_reg                                                           0xD800592C
+#define VO_SUB1_HSCC_1_reg                                                           0xD8005930
+#define VO_SUB1_HSCC_2_reg                                                           0xD8005934
+#define VO_SUB1_HSCC_3_reg                                                           0xD8005938
+#define VO_SUB1_HSCC_4_reg                                                           0xD800593C
+#define VO_SUB1_HSCC_5_reg                                                           0xD8005940
+#define VO_SUB1_HSCC_6_reg                                                           0xD8005944
+#define VO_SUB1_HSCC_7_reg                                                           0xD8005948
+#define set_VO_SUB1_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_0_reg)=data)
+#define set_VO_SUB1_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_1_reg)=data)
+#define set_VO_SUB1_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_2_reg)=data)
+#define set_VO_SUB1_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_3_reg)=data)
+#define set_VO_SUB1_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_4_reg)=data)
+#define set_VO_SUB1_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_5_reg)=data)
+#define set_VO_SUB1_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_6_reg)=data)
+#define set_VO_SUB1_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_7_reg)=data)
+#define get_VO_SUB1_HSCC_0_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_0_reg))
+#define get_VO_SUB1_HSCC_1_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_1_reg))
+#define get_VO_SUB1_HSCC_2_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_2_reg))
+#define get_VO_SUB1_HSCC_3_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_3_reg))
+#define get_VO_SUB1_HSCC_4_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_4_reg))
+#define get_VO_SUB1_HSCC_5_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_5_reg))
+#define get_VO_SUB1_HSCC_6_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_6_reg))
+#define get_VO_SUB1_HSCC_7_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_7_reg))
+#define VO_SUB1_HSCC_0_inst_adr                                                      "0x004B"
+#define VO_SUB1_HSCC_1_inst_adr                                                      "0x004C"
+#define VO_SUB1_HSCC_2_inst_adr                                                      "0x004D"
+#define VO_SUB1_HSCC_3_inst_adr                                                      "0x004E"
+#define VO_SUB1_HSCC_4_inst_adr                                                      "0x004F"
+#define VO_SUB1_HSCC_5_inst_adr                                                      "0x0050"
+#define VO_SUB1_HSCC_6_inst_adr                                                      "0x0051"
+#define VO_SUB1_HSCC_7_inst_adr                                                      "0x0052"
+#define VO_SUB1_HSCC_0_inst                                                          0x004B
+#define VO_SUB1_HSCC_1_inst                                                          0x004C
+#define VO_SUB1_HSCC_2_inst                                                          0x004D
+#define VO_SUB1_HSCC_3_inst                                                          0x004E
+#define VO_SUB1_HSCC_4_inst                                                          0x004F
+#define VO_SUB1_HSCC_5_inst                                                          0x0050
+#define VO_SUB1_HSCC_6_inst                                                          0x0051
+#define VO_SUB1_HSCC_7_inst                                                          0x0052
+#define VO_SUB1_HSCC_c1_shift                                                        (16)
+#define VO_SUB1_HSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB1_HSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_HSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_HSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_HSCC_c0_shift                                                        (0)
+#define VO_SUB1_HSCC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB1_HSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_HSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_HSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB2                                                                      0x9800594C
+#define VO_SUB2_reg_addr                                                             "0xD800594C"
+#define VO_SUB2_reg                                                                  0xD800594C
+#define set_VO_SUB2_reg(data)   (*((volatile unsigned int*) VO_SUB2_reg)=data)
+#define get_VO_SUB2_reg   (*((volatile unsigned int*) VO_SUB2_reg))
+#define VO_SUB2_inst_adr                                                             "0x0053"
+#define VO_SUB2_inst                                                                 0x0053
+#define VO_SUB2_d3_dbh_shift                                                         (29)
+#define VO_SUB2_d3_dbh_mask                                                          (0x20000000)
+#define VO_SUB2_d3_dbh(data)                                                         (0x20000000&((data)<<29))
+#define VO_SUB2_d3_dbh_src(data)                                                     ((0x20000000&(data))>>29)
+#define VO_SUB2_get_d3_dbh(data)                                                     ((0x20000000&(data))>>29)
+#define VO_SUB2_d3_vdup_shift                                                        (28)
+#define VO_SUB2_d3_vdup_mask                                                         (0x10000000)
+#define VO_SUB2_d3_vdup(data)                                                        (0x10000000&((data)<<28))
+#define VO_SUB2_d3_vdup_src(data)                                                    ((0x10000000&(data))>>28)
+#define VO_SUB2_get_d3_vdup(data)                                                    ((0x10000000&(data))>>28)
+#define VO_SUB2_d3_dbw_shift                                                         (27)
+#define VO_SUB2_d3_dbw_mask                                                          (0x08000000)
+#define VO_SUB2_d3_dbw(data)                                                         (0x08000000&((data)<<27))
+#define VO_SUB2_d3_dbw_src(data)                                                     ((0x08000000&(data))>>27)
+#define VO_SUB2_get_d3_dbw(data)                                                     ((0x08000000&(data))>>27)
+#define VO_SUB2_d3_dup_shift                                                         (26)
+#define VO_SUB2_d3_dup_mask                                                          (0x04000000)
+#define VO_SUB2_d3_dup(data)                                                         (0x04000000&((data)<<26))
+#define VO_SUB2_d3_dup_src(data)                                                     ((0x04000000&(data))>>26)
+#define VO_SUB2_get_d3_dup(data)                                                     ((0x04000000&(data))>>26)
+#define VO_SUB2_rgb_out_shift                                                        (25)
+#define VO_SUB2_rgb_out_mask                                                         (0x02000000)
+#define VO_SUB2_rgb_out(data)                                                        (0x02000000&((data)<<25))
+#define VO_SUB2_rgb_out_src(data)                                                    ((0x02000000&(data))>>25)
+#define VO_SUB2_get_rgb_out(data)                                                    ((0x02000000&(data))>>25)
+#define VO_SUB2_dvd_shift                                                            (23)
+#define VO_SUB2_dvd_mask                                                             (0x00800000)
+#define VO_SUB2_dvd(data)                                                            (0x00800000&((data)<<23))
+#define VO_SUB2_dvd_src(data)                                                        ((0x00800000&(data))>>23)
+#define VO_SUB2_get_dvd(data)                                                        ((0x00800000&(data))>>23)
+#define VO_SUB2_hddvd_shift                                                          (22)
+#define VO_SUB2_hddvd_mask                                                           (0x00400000)
+#define VO_SUB2_hddvd(data)                                                          (0x00400000&((data)<<22))
+#define VO_SUB2_hddvd_src(data)                                                      ((0x00400000&(data))>>22)
+#define VO_SUB2_get_hddvd(data)                                                      ((0x00400000&(data))>>22)
+#define VO_SUB2_hl_shift                                                             (19)
+#define VO_SUB2_hl_mask                                                              (0x00080000)
+#define VO_SUB2_hl(data)                                                             (0x00080000&((data)<<19))
+#define VO_SUB2_hl_src(data)                                                         ((0x00080000&(data))>>19)
+#define VO_SUB2_get_hl(data)                                                         ((0x00080000&(data))>>19)
+#define VO_SUB2_dvb_shift                                                            (17)
+#define VO_SUB2_dvb_mask                                                             (0x00020000)
+#define VO_SUB2_dvb(data)                                                            (0x00020000&((data)<<17))
+#define VO_SUB2_dvb_src(data)                                                        ((0x00020000&(data))>>17)
+#define VO_SUB2_get_dvb(data)                                                        ((0x00020000&(data))>>17)
+#define VO_SUB2_osd_shift                                                            (16)
+#define VO_SUB2_osd_mask                                                             (0x00010000)
+#define VO_SUB2_osd(data)                                                            (0x00010000&((data)<<16))
+#define VO_SUB2_osd_src(data)                                                        ((0x00010000&(data))>>16)
+#define VO_SUB2_get_osd(data)                                                        ((0x00010000&(data))>>16)
+#define VO_SUB2_fetch_1080i_shift                                                    (15)
+#define VO_SUB2_fetch_1080i_mask                                                     (0x00008000)
+#define VO_SUB2_fetch_1080i(data)                                                    (0x00008000&((data)<<15))
+#define VO_SUB2_fetch_1080i_src(data)                                                ((0x00008000&(data))>>15)
+#define VO_SUB2_get_fetch_1080i(data)                                                ((0x00008000&(data))>>15)
+#define VO_SUB2_odd_1080i_shift                                                      (14)
+#define VO_SUB2_odd_1080i_mask                                                       (0x00004000)
+#define VO_SUB2_odd_1080i(data)                                                      (0x00004000&((data)<<14))
+#define VO_SUB2_odd_1080i_src(data)                                                  ((0x00004000&(data))>>14)
+#define VO_SUB2_get_odd_1080i(data)                                                  ((0x00004000&(data))>>14)
+#define VO_SUB2_vs_shift                                                             (10)
+#define VO_SUB2_vs_mask                                                              (0x00000400)
+#define VO_SUB2_vs(data)                                                             (0x00000400&((data)<<10))
+#define VO_SUB2_vs_src(data)                                                         ((0x00000400&(data))>>10)
+#define VO_SUB2_get_vs(data)                                                         ((0x00000400&(data))>>10)
+#define VO_SUB2_vs_near_shift                                                        (9)
+#define VO_SUB2_vs_near_mask                                                         (0x00000200)
+#define VO_SUB2_vs_near(data)                                                        (0x00000200&((data)<<9))
+#define VO_SUB2_vs_near_src(data)                                                    ((0x00000200&(data))>>9)
+#define VO_SUB2_get_vs_near(data)                                                    ((0x00000200&(data))>>9)
+#define VO_SUB2_vs_yodd_shift                                                        (8)
+#define VO_SUB2_vs_yodd_mask                                                         (0x00000100)
+#define VO_SUB2_vs_yodd(data)                                                        (0x00000100&((data)<<8))
+#define VO_SUB2_vs_yodd_src(data)                                                    ((0x00000100&(data))>>8)
+#define VO_SUB2_get_vs_yodd(data)                                                    ((0x00000100&(data))>>8)
+#define VO_SUB2_vs_codd_shift                                                        (7)
+#define VO_SUB2_vs_codd_mask                                                         (0x00000080)
+#define VO_SUB2_vs_codd(data)                                                        (0x00000080&((data)<<7))
+#define VO_SUB2_vs_codd_src(data)                                                    ((0x00000080&(data))>>7)
+#define VO_SUB2_get_vs_codd(data)                                                    ((0x00000080&(data))>>7)
+#define VO_SUB2_hs_shift                                                             (6)
+#define VO_SUB2_hs_mask                                                              (0x00000040)
+#define VO_SUB2_hs(data)                                                             (0x00000040&((data)<<6))
+#define VO_SUB2_hs_src(data)                                                         ((0x00000040&(data))>>6)
+#define VO_SUB2_get_hs(data)                                                         ((0x00000040&(data))>>6)
+#define VO_SUB2_hs_yodd_shift                                                        (5)
+#define VO_SUB2_hs_yodd_mask                                                         (0x00000020)
+#define VO_SUB2_hs_yodd(data)                                                        (0x00000020&((data)<<5))
+#define VO_SUB2_hs_yodd_src(data)                                                    ((0x00000020&(data))>>5)
+#define VO_SUB2_get_hs_yodd(data)                                                    ((0x00000020&(data))>>5)
+#define VO_SUB2_hs_codd_shift                                                        (4)
+#define VO_SUB2_hs_codd_mask                                                         (0x00000010)
+#define VO_SUB2_hs_codd(data)                                                        (0x00000010&((data)<<4))
+#define VO_SUB2_hs_codd_src(data)                                                    ((0x00000010&(data))>>4)
+#define VO_SUB2_get_hs_codd(data)                                                    ((0x00000010&(data))>>4)
+#define VO_SUB2_write_data_shift                                                     (0)
+#define VO_SUB2_write_data_mask                                                      (0x00000001)
+#define VO_SUB2_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_SUB2_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_SUB2_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_SUB2_START                                                                0x98005950
+#define VO_SUB2_START_reg_addr                                                       "0xD8005950"
+#define VO_SUB2_START_reg                                                            0xD8005950
+#define set_VO_SUB2_START_reg(data)   (*((volatile unsigned int*) VO_SUB2_START_reg)=data)
+#define get_VO_SUB2_START_reg   (*((volatile unsigned int*) VO_SUB2_START_reg))
+#define VO_SUB2_START_inst_adr                                                       "0x0054"
+#define VO_SUB2_START_inst                                                           0x0054
+#define VO_SUB2_START_ref_shift                                                      (24)
+#define VO_SUB2_START_ref_mask                                                       (0x07000000)
+#define VO_SUB2_START_ref(data)                                                      (0x07000000&((data)<<24))
+#define VO_SUB2_START_ref_src(data)                                                  ((0x07000000&(data))>>24)
+#define VO_SUB2_START_get_ref(data)                                                  ((0x07000000&(data))>>24)
+#define VO_SUB2_START_pos_shift                                                      (12)
+#define VO_SUB2_START_pos_mask                                                       (0x00FFF000)
+#define VO_SUB2_START_pos(data)                                                      (0x00FFF000&((data)<<12))
+#define VO_SUB2_START_pos_src(data)                                                  ((0x00FFF000&(data))>>12)
+#define VO_SUB2_START_get_pos(data)                                                  ((0x00FFF000&(data))>>12)
+#define VO_SUB2_START_th_shift                                                       (0)
+#define VO_SUB2_START_th_mask                                                        (0x00000FFF)
+#define VO_SUB2_START_th(data)                                                       (0x00000FFF&((data)<<0))
+#define VO_SUB2_START_th_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VO_SUB2_START_get_th(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VO_SUB2_SUBP                                                                 0x98005954
+#define VO_SUB2_SUBP_reg_addr                                                        "0xD8005954"
+#define VO_SUB2_SUBP_reg                                                             0xD8005954
+#define set_VO_SUB2_SUBP_reg(data)   (*((volatile unsigned int*) VO_SUB2_SUBP_reg)=data)
+#define get_VO_SUB2_SUBP_reg   (*((volatile unsigned int*) VO_SUB2_SUBP_reg))
+#define VO_SUB2_SUBP_inst_adr                                                        "0x0055"
+#define VO_SUB2_SUBP_inst                                                            0x0055
+#define VO_SUB2_SUBP_w_shift                                                         (0)
+#define VO_SUB2_SUBP_w_mask                                                          (0x00000FFF)
+#define VO_SUB2_SUBP_w(data)                                                         (0x00000FFF&((data)<<0))
+#define VO_SUB2_SUBP_w_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define VO_SUB2_SUBP_get_w(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define VO_SUB2_SIZE                                                                 0x98005958
+#define VO_SUB2_SIZE_reg_addr                                                        "0xD8005958"
+#define VO_SUB2_SIZE_reg                                                             0xD8005958
+#define set_VO_SUB2_SIZE_reg(data)   (*((volatile unsigned int*) VO_SUB2_SIZE_reg)=data)
+#define get_VO_SUB2_SIZE_reg   (*((volatile unsigned int*) VO_SUB2_SIZE_reg))
+#define VO_SUB2_SIZE_inst_adr                                                        "0x0056"
+#define VO_SUB2_SIZE_inst                                                            0x0056
+#define VO_SUB2_SIZE_w_shift                                                         (12)
+#define VO_SUB2_SIZE_w_mask                                                          (0x007FF000)
+#define VO_SUB2_SIZE_w(data)                                                         (0x007FF000&((data)<<12))
+#define VO_SUB2_SIZE_w_src(data)                                                     ((0x007FF000&(data))>>12)
+#define VO_SUB2_SIZE_get_w(data)                                                     ((0x007FF000&(data))>>12)
+#define VO_SUB2_SIZE_h_shift                                                         (0)
+#define VO_SUB2_SIZE_h_mask                                                          (0x000007FF)
+#define VO_SUB2_SIZE_h(data)                                                         (0x000007FF&((data)<<0))
+#define VO_SUB2_SIZE_h_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_SUB2_SIZE_get_h(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB2_BUF                                                                  0x9800595C
+#define VO_SUB2_BUF_reg_addr                                                         "0xD800595C"
+#define VO_SUB2_BUF_reg                                                              0xD800595C
+#define set_VO_SUB2_BUF_reg(data)   (*((volatile unsigned int*) VO_SUB2_BUF_reg)=data)
+#define get_VO_SUB2_BUF_reg   (*((volatile unsigned int*) VO_SUB2_BUF_reg))
+#define VO_SUB2_BUF_inst_adr                                                         "0x0057"
+#define VO_SUB2_BUF_inst                                                             0x0057
+#define VO_SUB2_BUF_th_shift                                                         (0)
+#define VO_SUB2_BUF_th_mask                                                          (0x000001FF)
+#define VO_SUB2_BUF_th(data)                                                         (0x000001FF&((data)<<0))
+#define VO_SUB2_BUF_th_src(data)                                                     ((0x000001FF&(data))>>0)
+#define VO_SUB2_BUF_get_th(data)                                                     ((0x000001FF&(data))>>0)
+
+
+#define VO_SUB2_WI                                                                   0x98005960
+#define VO_SUB2_WI_reg_addr                                                          "0xD8005960"
+#define VO_SUB2_WI_reg                                                               0xD8005960
+#define set_VO_SUB2_WI_reg(data)   (*((volatile unsigned int*) VO_SUB2_WI_reg)=data)
+#define get_VO_SUB2_WI_reg   (*((volatile unsigned int*) VO_SUB2_WI_reg))
+#define VO_SUB2_WI_inst_adr                                                          "0x0058"
+#define VO_SUB2_WI_inst                                                              0x0058
+#define VO_SUB2_WI_swap_8byte_shift                                                  (1)
+#define VO_SUB2_WI_swap_8byte_mask                                                   (0x00000002)
+#define VO_SUB2_WI_swap_8byte(data)                                                  (0x00000002&((data)<<1))
+#define VO_SUB2_WI_swap_8byte_src(data)                                              ((0x00000002&(data))>>1)
+#define VO_SUB2_WI_get_swap_8byte(data)                                              ((0x00000002&(data))>>1)
+#define VO_SUB2_WI_endian_shift                                                      (0)
+#define VO_SUB2_WI_endian_mask                                                       (0x00000001)
+#define VO_SUB2_WI_endian(data)                                                      (0x00000001&((data)<<0))
+#define VO_SUB2_WI_endian_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_SUB2_WI_get_endian(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_SUB2_WI_1                                                                 0x98005964
+#define VO_SUB2_WI_1_reg_addr                                                        "0xD8005964"
+#define VO_SUB2_WI_1_reg                                                             0xD8005964
+#define set_VO_SUB2_WI_1_reg(data)   (*((volatile unsigned int*) VO_SUB2_WI_1_reg)=data)
+#define get_VO_SUB2_WI_1_reg   (*((volatile unsigned int*) VO_SUB2_WI_1_reg))
+#define VO_SUB2_WI_1_inst_adr                                                        "0x0059"
+#define VO_SUB2_WI_1_inst                                                            0x0059
+#define VO_SUB2_WI_1_a_shift                                                         (0)
+#define VO_SUB2_WI_1_a_mask                                                          (0xFFFFFFFF)
+#define VO_SUB2_WI_1_a(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define VO_SUB2_WI_1_a_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define VO_SUB2_WI_1_get_a(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SUB2_WI_3D                                                                0x98005968
+#define VO_SUB2_WI_3D_reg_addr                                                       "0xD8005968"
+#define VO_SUB2_WI_3D_reg                                                            0xD8005968
+#define set_VO_SUB2_WI_3D_reg(data)   (*((volatile unsigned int*) VO_SUB2_WI_3D_reg)=data)
+#define get_VO_SUB2_WI_3D_reg   (*((volatile unsigned int*) VO_SUB2_WI_3D_reg))
+#define VO_SUB2_WI_3D_inst_adr                                                       "0x005A"
+#define VO_SUB2_WI_3D_inst                                                           0x005A
+#define VO_SUB2_WI_3D_a_shift                                                        (0)
+#define VO_SUB2_WI_3D_a_mask                                                         (0xFFFFFFFF)
+#define VO_SUB2_WI_3D_a(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define VO_SUB2_WI_3D_a_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define VO_SUB2_WI_3D_get_a(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SUB2_CLUT                                                                 0x9800596C
+#define VO_SUB2_CLUT_reg_addr                                                        "0xD800596C"
+#define VO_SUB2_CLUT_reg                                                             0xD800596C
+#define set_VO_SUB2_CLUT_reg(data)   (*((volatile unsigned int*) VO_SUB2_CLUT_reg)=data)
+#define get_VO_SUB2_CLUT_reg   (*((volatile unsigned int*) VO_SUB2_CLUT_reg))
+#define VO_SUB2_CLUT_inst_adr                                                        "0x005B"
+#define VO_SUB2_CLUT_inst                                                            0x005B
+#define VO_SUB2_CLUT_keep_shift                                                      (0)
+#define VO_SUB2_CLUT_keep_mask                                                       (0x00000001)
+#define VO_SUB2_CLUT_keep(data)                                                      (0x00000001&((data)<<0))
+#define VO_SUB2_CLUT_keep_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_SUB2_CLUT_get_keep(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_SUB2_CLUT_1                                                               0x98005970
+#define VO_SUB2_CLUT_1_reg_addr                                                      "0xD8005970"
+#define VO_SUB2_CLUT_1_reg                                                           0xD8005970
+#define set_VO_SUB2_CLUT_1_reg(data)   (*((volatile unsigned int*) VO_SUB2_CLUT_1_reg)=data)
+#define get_VO_SUB2_CLUT_1_reg   (*((volatile unsigned int*) VO_SUB2_CLUT_1_reg))
+#define VO_SUB2_CLUT_1_inst_adr                                                      "0x005C"
+#define VO_SUB2_CLUT_1_inst                                                          0x005C
+#define VO_SUB2_CLUT_1_a_shift                                                       (0)
+#define VO_SUB2_CLUT_1_a_mask                                                        (0xFFFFFFFF)
+#define VO_SUB2_CLUT_1_a(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define VO_SUB2_CLUT_1_a_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define VO_SUB2_CLUT_1_get_a(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SUB2_PXDT                                                                 0x98005974
+#define VO_SUB2_PXDT_reg_addr                                                        "0xD8005974"
+#define VO_SUB2_PXDT_reg                                                             0xD8005974
+#define set_VO_SUB2_PXDT_reg(data)   (*((volatile unsigned int*) VO_SUB2_PXDT_reg)=data)
+#define get_VO_SUB2_PXDT_reg   (*((volatile unsigned int*) VO_SUB2_PXDT_reg))
+#define VO_SUB2_PXDT_inst_adr                                                        "0x005D"
+#define VO_SUB2_PXDT_inst                                                            0x005D
+#define VO_SUB2_PXDT_a_shift                                                         (0)
+#define VO_SUB2_PXDT_a_mask                                                          (0xFFFFFFFF)
+#define VO_SUB2_PXDT_a(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define VO_SUB2_PXDT_a_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define VO_SUB2_PXDT_get_a(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SUB2_PXDB                                                                 0x98005978
+#define VO_SUB2_PXDB_reg_addr                                                        "0xD8005978"
+#define VO_SUB2_PXDB_reg                                                             0xD8005978
+#define set_VO_SUB2_PXDB_reg(data)   (*((volatile unsigned int*) VO_SUB2_PXDB_reg)=data)
+#define get_VO_SUB2_PXDB_reg   (*((volatile unsigned int*) VO_SUB2_PXDB_reg))
+#define VO_SUB2_PXDB_inst_adr                                                        "0x005E"
+#define VO_SUB2_PXDB_inst                                                            0x005E
+#define VO_SUB2_PXDB_a_shift                                                         (0)
+#define VO_SUB2_PXDB_a_mask                                                          (0xFFFFFFFF)
+#define VO_SUB2_PXDB_a(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define VO_SUB2_PXDB_a_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define VO_SUB2_PXDB_get_a(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SUB2_LC                                                                   0x9800597C
+#define VO_SUB2_LC_reg_addr                                                          "0xD800597C"
+#define VO_SUB2_LC_reg                                                               0xD800597C
+#define set_VO_SUB2_LC_reg(data)   (*((volatile unsigned int*) VO_SUB2_LC_reg)=data)
+#define get_VO_SUB2_LC_reg   (*((volatile unsigned int*) VO_SUB2_LC_reg))
+#define VO_SUB2_LC_inst_adr                                                          "0x005F"
+#define VO_SUB2_LC_inst                                                              0x005F
+#define VO_SUB2_LC_num_shift                                                         (0)
+#define VO_SUB2_LC_num_mask                                                          (0x000007FF)
+#define VO_SUB2_LC_num(data)                                                         (0x000007FF&((data)<<0))
+#define VO_SUB2_LC_num_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_SUB2_LC_get_num(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB2_DFT                                                                  0x98005980
+#define VO_SUB2_DFT_reg_addr                                                         "0xD8005980"
+#define VO_SUB2_DFT_reg                                                              0xD8005980
+#define set_VO_SUB2_DFT_reg(data)   (*((volatile unsigned int*) VO_SUB2_DFT_reg)=data)
+#define get_VO_SUB2_DFT_reg   (*((volatile unsigned int*) VO_SUB2_DFT_reg))
+#define VO_SUB2_DFT_inst_adr                                                         "0x0060"
+#define VO_SUB2_DFT_inst                                                             0x0060
+#define VO_SUB2_DFT_a3_shift                                                         (28)
+#define VO_SUB2_DFT_a3_mask                                                          (0xF0000000)
+#define VO_SUB2_DFT_a3(data)                                                         (0xF0000000&((data)<<28))
+#define VO_SUB2_DFT_a3_src(data)                                                     ((0xF0000000&(data))>>28)
+#define VO_SUB2_DFT_get_a3(data)                                                     ((0xF0000000&(data))>>28)
+#define VO_SUB2_DFT_a2_shift                                                         (24)
+#define VO_SUB2_DFT_a2_mask                                                          (0x0F000000)
+#define VO_SUB2_DFT_a2(data)                                                         (0x0F000000&((data)<<24))
+#define VO_SUB2_DFT_a2_src(data)                                                     ((0x0F000000&(data))>>24)
+#define VO_SUB2_DFT_get_a2(data)                                                     ((0x0F000000&(data))>>24)
+#define VO_SUB2_DFT_a1_shift                                                         (20)
+#define VO_SUB2_DFT_a1_mask                                                          (0x00F00000)
+#define VO_SUB2_DFT_a1(data)                                                         (0x00F00000&((data)<<20))
+#define VO_SUB2_DFT_a1_src(data)                                                     ((0x00F00000&(data))>>20)
+#define VO_SUB2_DFT_get_a1(data)                                                     ((0x00F00000&(data))>>20)
+#define VO_SUB2_DFT_a0_shift                                                         (16)
+#define VO_SUB2_DFT_a0_mask                                                          (0x000F0000)
+#define VO_SUB2_DFT_a0(data)                                                         (0x000F0000&((data)<<16))
+#define VO_SUB2_DFT_a0_src(data)                                                     ((0x000F0000&(data))>>16)
+#define VO_SUB2_DFT_get_a0(data)                                                     ((0x000F0000&(data))>>16)
+#define VO_SUB2_DFT_i3_shift                                                         (12)
+#define VO_SUB2_DFT_i3_mask                                                          (0x0000F000)
+#define VO_SUB2_DFT_i3(data)                                                         (0x0000F000&((data)<<12))
+#define VO_SUB2_DFT_i3_src(data)                                                     ((0x0000F000&(data))>>12)
+#define VO_SUB2_DFT_get_i3(data)                                                     ((0x0000F000&(data))>>12)
+#define VO_SUB2_DFT_i2_shift                                                         (8)
+#define VO_SUB2_DFT_i2_mask                                                          (0x00000F00)
+#define VO_SUB2_DFT_i2(data)                                                         (0x00000F00&((data)<<8))
+#define VO_SUB2_DFT_i2_src(data)                                                     ((0x00000F00&(data))>>8)
+#define VO_SUB2_DFT_get_i2(data)                                                     ((0x00000F00&(data))>>8)
+#define VO_SUB2_DFT_i1_shift                                                         (4)
+#define VO_SUB2_DFT_i1_mask                                                          (0x000000F0)
+#define VO_SUB2_DFT_i1(data)                                                         (0x000000F0&((data)<<4))
+#define VO_SUB2_DFT_i1_src(data)                                                     ((0x000000F0&(data))>>4)
+#define VO_SUB2_DFT_get_i1(data)                                                     ((0x000000F0&(data))>>4)
+#define VO_SUB2_DFT_i0_shift                                                         (0)
+#define VO_SUB2_DFT_i0_mask                                                          (0x0000000F)
+#define VO_SUB2_DFT_i0(data)                                                         (0x0000000F&((data)<<0))
+#define VO_SUB2_DFT_i0_src(data)                                                     ((0x0000000F&(data))>>0)
+#define VO_SUB2_DFT_get_i0(data)                                                     ((0x0000000F&(data))>>0)
+
+
+#define VO_SUB2_HLX                                                                  0x98005984
+#define VO_SUB2_HLX_reg_addr                                                         "0xD8005984"
+#define VO_SUB2_HLX_reg                                                              0xD8005984
+#define set_VO_SUB2_HLX_reg(data)   (*((volatile unsigned int*) VO_SUB2_HLX_reg)=data)
+#define get_VO_SUB2_HLX_reg   (*((volatile unsigned int*) VO_SUB2_HLX_reg))
+#define VO_SUB2_HLX_inst_adr                                                         "0x0061"
+#define VO_SUB2_HLX_inst                                                             0x0061
+#define VO_SUB2_HLX_e_shift                                                          (12)
+#define VO_SUB2_HLX_e_mask                                                           (0x007FF000)
+#define VO_SUB2_HLX_e(data)                                                          (0x007FF000&((data)<<12))
+#define VO_SUB2_HLX_e_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB2_HLX_get_e(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB2_HLX_s_shift                                                          (0)
+#define VO_SUB2_HLX_s_mask                                                           (0x000007FF)
+#define VO_SUB2_HLX_s(data)                                                          (0x000007FF&((data)<<0))
+#define VO_SUB2_HLX_s_src(data)                                                      ((0x000007FF&(data))>>0)
+#define VO_SUB2_HLX_get_s(data)                                                      ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB2_HLY                                                                  0x98005988
+#define VO_SUB2_HLY_reg_addr                                                         "0xD8005988"
+#define VO_SUB2_HLY_reg                                                              0xD8005988
+#define set_VO_SUB2_HLY_reg(data)   (*((volatile unsigned int*) VO_SUB2_HLY_reg)=data)
+#define get_VO_SUB2_HLY_reg   (*((volatile unsigned int*) VO_SUB2_HLY_reg))
+#define VO_SUB2_HLY_inst_adr                                                         "0x0062"
+#define VO_SUB2_HLY_inst                                                             0x0062
+#define VO_SUB2_HLY_e_shift                                                          (12)
+#define VO_SUB2_HLY_e_mask                                                           (0x007FF000)
+#define VO_SUB2_HLY_e(data)                                                          (0x007FF000&((data)<<12))
+#define VO_SUB2_HLY_e_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB2_HLY_get_e(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB2_HLY_s_shift                                                          (0)
+#define VO_SUB2_HLY_s_mask                                                           (0x000007FF)
+#define VO_SUB2_HLY_s(data)                                                          (0x000007FF&((data)<<0))
+#define VO_SUB2_HLY_s_src(data)                                                      ((0x000007FF&(data))>>0)
+#define VO_SUB2_HLY_get_s(data)                                                      ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB2_HL                                                                   0x9800598C
+#define VO_SUB2_HL_reg_addr                                                          "0xD800598C"
+#define VO_SUB2_HL_reg                                                               0xD800598C
+#define set_VO_SUB2_HL_reg(data)   (*((volatile unsigned int*) VO_SUB2_HL_reg)=data)
+#define get_VO_SUB2_HL_reg   (*((volatile unsigned int*) VO_SUB2_HL_reg))
+#define VO_SUB2_HL_inst_adr                                                          "0x0063"
+#define VO_SUB2_HL_inst                                                              0x0063
+#define VO_SUB2_HL_a3_shift                                                          (28)
+#define VO_SUB2_HL_a3_mask                                                           (0xF0000000)
+#define VO_SUB2_HL_a3(data)                                                          (0xF0000000&((data)<<28))
+#define VO_SUB2_HL_a3_src(data)                                                      ((0xF0000000&(data))>>28)
+#define VO_SUB2_HL_get_a3(data)                                                      ((0xF0000000&(data))>>28)
+#define VO_SUB2_HL_a2_shift                                                          (24)
+#define VO_SUB2_HL_a2_mask                                                           (0x0F000000)
+#define VO_SUB2_HL_a2(data)                                                          (0x0F000000&((data)<<24))
+#define VO_SUB2_HL_a2_src(data)                                                      ((0x0F000000&(data))>>24)
+#define VO_SUB2_HL_get_a2(data)                                                      ((0x0F000000&(data))>>24)
+#define VO_SUB2_HL_a1_shift                                                          (20)
+#define VO_SUB2_HL_a1_mask                                                           (0x00F00000)
+#define VO_SUB2_HL_a1(data)                                                          (0x00F00000&((data)<<20))
+#define VO_SUB2_HL_a1_src(data)                                                      ((0x00F00000&(data))>>20)
+#define VO_SUB2_HL_get_a1(data)                                                      ((0x00F00000&(data))>>20)
+#define VO_SUB2_HL_a0_shift                                                          (16)
+#define VO_SUB2_HL_a0_mask                                                           (0x000F0000)
+#define VO_SUB2_HL_a0(data)                                                          (0x000F0000&((data)<<16))
+#define VO_SUB2_HL_a0_src(data)                                                      ((0x000F0000&(data))>>16)
+#define VO_SUB2_HL_get_a0(data)                                                      ((0x000F0000&(data))>>16)
+#define VO_SUB2_HL_i3_shift                                                          (12)
+#define VO_SUB2_HL_i3_mask                                                           (0x0000F000)
+#define VO_SUB2_HL_i3(data)                                                          (0x0000F000&((data)<<12))
+#define VO_SUB2_HL_i3_src(data)                                                      ((0x0000F000&(data))>>12)
+#define VO_SUB2_HL_get_i3(data)                                                      ((0x0000F000&(data))>>12)
+#define VO_SUB2_HL_i2_shift                                                          (8)
+#define VO_SUB2_HL_i2_mask                                                           (0x00000F00)
+#define VO_SUB2_HL_i2(data)                                                          (0x00000F00&((data)<<8))
+#define VO_SUB2_HL_i2_src(data)                                                      ((0x00000F00&(data))>>8)
+#define VO_SUB2_HL_get_i2(data)                                                      ((0x00000F00&(data))>>8)
+#define VO_SUB2_HL_i1_shift                                                          (4)
+#define VO_SUB2_HL_i1_mask                                                           (0x000000F0)
+#define VO_SUB2_HL_i1(data)                                                          (0x000000F0&((data)<<4))
+#define VO_SUB2_HL_i1_src(data)                                                      ((0x000000F0&(data))>>4)
+#define VO_SUB2_HL_get_i1(data)                                                      ((0x000000F0&(data))>>4)
+#define VO_SUB2_HL_i0_shift                                                          (0)
+#define VO_SUB2_HL_i0_mask                                                           (0x0000000F)
+#define VO_SUB2_HL_i0(data)                                                          (0x0000000F&((data)<<0))
+#define VO_SUB2_HL_i0_src(data)                                                      ((0x0000000F&(data))>>0)
+#define VO_SUB2_HL_get_i0(data)                                                      ((0x0000000F&(data))>>0)
+
+
+#define VO_SUB2_CC1                                                                  0x98005990
+#define VO_SUB2_CC1_reg_addr                                                         "0xD8005990"
+#define VO_SUB2_CC1_reg                                                              0xD8005990
+#define set_VO_SUB2_CC1_reg(data)   (*((volatile unsigned int*) VO_SUB2_CC1_reg)=data)
+#define get_VO_SUB2_CC1_reg   (*((volatile unsigned int*) VO_SUB2_CC1_reg))
+#define VO_SUB2_CC1_inst_adr                                                         "0x0064"
+#define VO_SUB2_CC1_inst                                                             0x0064
+#define VO_SUB2_CC1_m01_shift                                                        (16)
+#define VO_SUB2_CC1_m01_mask                                                         (0x3FFF0000)
+#define VO_SUB2_CC1_m01(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB2_CC1_m01_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_CC1_get_m01(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_CC1_m00_shift                                                        (0)
+#define VO_SUB2_CC1_m00_mask                                                         (0x00003FFF)
+#define VO_SUB2_CC1_m00(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB2_CC1_m00_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB2_CC1_get_m00(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB2_CC2                                                                  0x98005994
+#define VO_SUB2_CC2_reg_addr                                                         "0xD8005994"
+#define VO_SUB2_CC2_reg                                                              0xD8005994
+#define set_VO_SUB2_CC2_reg(data)   (*((volatile unsigned int*) VO_SUB2_CC2_reg)=data)
+#define get_VO_SUB2_CC2_reg   (*((volatile unsigned int*) VO_SUB2_CC2_reg))
+#define VO_SUB2_CC2_inst_adr                                                         "0x0065"
+#define VO_SUB2_CC2_inst                                                             0x0065
+#define VO_SUB2_CC2_m10_shift                                                        (16)
+#define VO_SUB2_CC2_m10_mask                                                         (0x3FFF0000)
+#define VO_SUB2_CC2_m10(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB2_CC2_m10_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_CC2_get_m10(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_CC2_m02_shift                                                        (0)
+#define VO_SUB2_CC2_m02_mask                                                         (0x00003FFF)
+#define VO_SUB2_CC2_m02(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB2_CC2_m02_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB2_CC2_get_m02(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB2_CC3                                                                  0x98005998
+#define VO_SUB2_CC3_reg_addr                                                         "0xD8005998"
+#define VO_SUB2_CC3_reg                                                              0xD8005998
+#define set_VO_SUB2_CC3_reg(data)   (*((volatile unsigned int*) VO_SUB2_CC3_reg)=data)
+#define get_VO_SUB2_CC3_reg   (*((volatile unsigned int*) VO_SUB2_CC3_reg))
+#define VO_SUB2_CC3_inst_adr                                                         "0x0066"
+#define VO_SUB2_CC3_inst                                                             0x0066
+#define VO_SUB2_CC3_m12_shift                                                        (16)
+#define VO_SUB2_CC3_m12_mask                                                         (0x3FFF0000)
+#define VO_SUB2_CC3_m12(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB2_CC3_m12_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_CC3_get_m12(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_CC3_m11_shift                                                        (0)
+#define VO_SUB2_CC3_m11_mask                                                         (0x00003FFF)
+#define VO_SUB2_CC3_m11(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB2_CC3_m11_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB2_CC3_get_m11(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB2_CC4                                                                  0x9800599C
+#define VO_SUB2_CC4_reg_addr                                                         "0xD800599C"
+#define VO_SUB2_CC4_reg                                                              0xD800599C
+#define set_VO_SUB2_CC4_reg(data)   (*((volatile unsigned int*) VO_SUB2_CC4_reg)=data)
+#define get_VO_SUB2_CC4_reg   (*((volatile unsigned int*) VO_SUB2_CC4_reg))
+#define VO_SUB2_CC4_inst_adr                                                         "0x0067"
+#define VO_SUB2_CC4_inst                                                             0x0067
+#define VO_SUB2_CC4_m21_shift                                                        (16)
+#define VO_SUB2_CC4_m21_mask                                                         (0x3FFF0000)
+#define VO_SUB2_CC4_m21(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB2_CC4_m21_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_CC4_get_m21(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_CC4_m20_shift                                                        (0)
+#define VO_SUB2_CC4_m20_mask                                                         (0x00003FFF)
+#define VO_SUB2_CC4_m20(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB2_CC4_m20_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB2_CC4_get_m20(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB2_CC5                                                                  0x980059A0
+#define VO_SUB2_CC5_reg_addr                                                         "0xD80059A0"
+#define VO_SUB2_CC5_reg                                                              0xD80059A0
+#define set_VO_SUB2_CC5_reg(data)   (*((volatile unsigned int*) VO_SUB2_CC5_reg)=data)
+#define get_VO_SUB2_CC5_reg   (*((volatile unsigned int*) VO_SUB2_CC5_reg))
+#define VO_SUB2_CC5_inst_adr                                                         "0x0068"
+#define VO_SUB2_CC5_inst                                                             0x0068
+#define VO_SUB2_CC5_m22_shift                                                        (0)
+#define VO_SUB2_CC5_m22_mask                                                         (0x00003FFF)
+#define VO_SUB2_CC5_m22(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB2_CC5_m22_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB2_CC5_get_m22(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB2_CC6                                                                  0x980059A4
+#define VO_SUB2_CC6_reg_addr                                                         "0xD80059A4"
+#define VO_SUB2_CC6_reg                                                              0xD80059A4
+#define set_VO_SUB2_CC6_reg(data)   (*((volatile unsigned int*) VO_SUB2_CC6_reg)=data)
+#define get_VO_SUB2_CC6_reg   (*((volatile unsigned int*) VO_SUB2_CC6_reg))
+#define VO_SUB2_CC6_inst_adr                                                         "0x0069"
+#define VO_SUB2_CC6_inst                                                             0x0069
+#define VO_SUB2_CC6_a1_shift                                                         (11)
+#define VO_SUB2_CC6_a1_mask                                                          (0x003FF800)
+#define VO_SUB2_CC6_a1(data)                                                         (0x003FF800&((data)<<11))
+#define VO_SUB2_CC6_a1_src(data)                                                     ((0x003FF800&(data))>>11)
+#define VO_SUB2_CC6_get_a1(data)                                                     ((0x003FF800&(data))>>11)
+#define VO_SUB2_CC6_a0_shift                                                         (0)
+#define VO_SUB2_CC6_a0_mask                                                          (0x000007FF)
+#define VO_SUB2_CC6_a0(data)                                                         (0x000007FF&((data)<<0))
+#define VO_SUB2_CC6_a0_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_SUB2_CC6_get_a0(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB2_CC7                                                                  0x980059A8
+#define VO_SUB2_CC7_reg_addr                                                         "0xD80059A8"
+#define VO_SUB2_CC7_reg                                                              0xD80059A8
+#define set_VO_SUB2_CC7_reg(data)   (*((volatile unsigned int*) VO_SUB2_CC7_reg)=data)
+#define get_VO_SUB2_CC7_reg   (*((volatile unsigned int*) VO_SUB2_CC7_reg))
+#define VO_SUB2_CC7_inst_adr                                                         "0x006A"
+#define VO_SUB2_CC7_inst                                                             0x006A
+#define VO_SUB2_CC7_a2_shift                                                         (0)
+#define VO_SUB2_CC7_a2_mask                                                          (0x000007FF)
+#define VO_SUB2_CC7_a2(data)                                                         (0x000007FF&((data)<<0))
+#define VO_SUB2_CC7_a2_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_SUB2_CC7_get_a2(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB2_VSI                                                                  0x980059AC
+#define VO_SUB2_VSI_reg_addr                                                         "0xD80059AC"
+#define VO_SUB2_VSI_reg                                                              0xD80059AC
+#define set_VO_SUB2_VSI_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSI_reg)=data)
+#define get_VO_SUB2_VSI_reg   (*((volatile unsigned int*) VO_SUB2_VSI_reg))
+#define VO_SUB2_VSI_inst_adr                                                         "0x006B"
+#define VO_SUB2_VSI_inst                                                             0x006B
+#define VO_SUB2_VSI_offset_shift                                                     (16)
+#define VO_SUB2_VSI_offset_mask                                                      (0x0FFF0000)
+#define VO_SUB2_VSI_offset(data)                                                     (0x0FFF0000&((data)<<16))
+#define VO_SUB2_VSI_offset_src(data)                                                 ((0x0FFF0000&(data))>>16)
+#define VO_SUB2_VSI_get_offset(data)                                                 ((0x0FFF0000&(data))>>16)
+#define VO_SUB2_VSI_phase_shift                                                      (0)
+#define VO_SUB2_VSI_phase_mask                                                       (0x0000FFFF)
+#define VO_SUB2_VSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_SUB2_VSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_SUB2_VSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_SUB2_VSD                                                                  0x980059B0
+#define VO_SUB2_VSD_reg_addr                                                         "0xD80059B0"
+#define VO_SUB2_VSD_reg                                                              0xD80059B0
+#define set_VO_SUB2_VSD_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSD_reg)=data)
+#define get_VO_SUB2_VSD_reg   (*((volatile unsigned int*) VO_SUB2_VSD_reg))
+#define VO_SUB2_VSD_inst_adr                                                         "0x006C"
+#define VO_SUB2_VSD_inst                                                             0x006C
+#define VO_SUB2_VSD_delta_shift                                                      (0)
+#define VO_SUB2_VSD_delta_mask                                                       (0x001FFFFF)
+#define VO_SUB2_VSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_SUB2_VSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_SUB2_VSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_SUB2_VSD_H                                                                0x980059B4
+#define VO_SUB2_VSD_H_reg_addr                                                       "0xD80059B4"
+#define VO_SUB2_VSD_H_reg                                                            0xD80059B4
+#define set_VO_SUB2_VSD_H_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSD_H_reg)=data)
+#define get_VO_SUB2_VSD_H_reg   (*((volatile unsigned int*) VO_SUB2_VSD_H_reg))
+#define VO_SUB2_VSD_H_inst_adr                                                       "0x006D"
+#define VO_SUB2_VSD_H_inst                                                           0x006D
+#define VO_SUB2_VSD_H_out_shift                                                      (0)
+#define VO_SUB2_VSD_H_out_mask                                                       (0x00000FFF)
+#define VO_SUB2_VSD_H_out(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_SUB2_VSD_H_out_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_SUB2_VSD_H_get_out(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_SUB2_VSYC_0                                                               0x980059B8
+#define VO_SUB2_VSYC_1                                                               0x980059BC
+#define VO_SUB2_VSYC_2                                                               0x980059C0
+#define VO_SUB2_VSYC_3                                                               0x980059C4
+#define VO_SUB2_VSYC_0_reg_addr                                                      "0xD80059B8"
+#define VO_SUB2_VSYC_1_reg_addr                                                      "0xD80059BC"
+#define VO_SUB2_VSYC_2_reg_addr                                                      "0xD80059C0"
+#define VO_SUB2_VSYC_3_reg_addr                                                      "0xD80059C4"
+#define VO_SUB2_VSYC_0_reg                                                           0xD80059B8
+#define VO_SUB2_VSYC_1_reg                                                           0xD80059BC
+#define VO_SUB2_VSYC_2_reg                                                           0xD80059C0
+#define VO_SUB2_VSYC_3_reg                                                           0xD80059C4
+#define set_VO_SUB2_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSYC_0_reg)=data)
+#define set_VO_SUB2_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSYC_1_reg)=data)
+#define set_VO_SUB2_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSYC_2_reg)=data)
+#define set_VO_SUB2_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSYC_3_reg)=data)
+#define get_VO_SUB2_VSYC_0_reg   (*((volatile unsigned int*) VO_SUB2_VSYC_0_reg))
+#define get_VO_SUB2_VSYC_1_reg   (*((volatile unsigned int*) VO_SUB2_VSYC_1_reg))
+#define get_VO_SUB2_VSYC_2_reg   (*((volatile unsigned int*) VO_SUB2_VSYC_2_reg))
+#define get_VO_SUB2_VSYC_3_reg   (*((volatile unsigned int*) VO_SUB2_VSYC_3_reg))
+#define VO_SUB2_VSYC_0_inst_adr                                                      "0x006E"
+#define VO_SUB2_VSYC_1_inst_adr                                                      "0x006F"
+#define VO_SUB2_VSYC_2_inst_adr                                                      "0x0070"
+#define VO_SUB2_VSYC_3_inst_adr                                                      "0x0071"
+#define VO_SUB2_VSYC_0_inst                                                          0x006E
+#define VO_SUB2_VSYC_1_inst                                                          0x006F
+#define VO_SUB2_VSYC_2_inst                                                          0x0070
+#define VO_SUB2_VSYC_3_inst                                                          0x0071
+#define VO_SUB2_VSYC_c1_shift                                                        (16)
+#define VO_SUB2_VSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB2_VSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB2_VSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_VSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_VSYC_c0_shift                                                        (0)
+#define VO_SUB2_VSYC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB2_VSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB2_VSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB2_VSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB2_VSCC_0                                                               0x980059C8
+#define VO_SUB2_VSCC_1                                                               0x980059CC
+#define VO_SUB2_VSCC_2                                                               0x980059D0
+#define VO_SUB2_VSCC_3                                                               0x980059D4
+#define VO_SUB2_VSCC_0_reg_addr                                                      "0xD80059C8"
+#define VO_SUB2_VSCC_1_reg_addr                                                      "0xD80059CC"
+#define VO_SUB2_VSCC_2_reg_addr                                                      "0xD80059D0"
+#define VO_SUB2_VSCC_3_reg_addr                                                      "0xD80059D4"
+#define VO_SUB2_VSCC_0_reg                                                           0xD80059C8
+#define VO_SUB2_VSCC_1_reg                                                           0xD80059CC
+#define VO_SUB2_VSCC_2_reg                                                           0xD80059D0
+#define VO_SUB2_VSCC_3_reg                                                           0xD80059D4
+#define set_VO_SUB2_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSCC_0_reg)=data)
+#define set_VO_SUB2_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSCC_1_reg)=data)
+#define set_VO_SUB2_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSCC_2_reg)=data)
+#define set_VO_SUB2_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_SUB2_VSCC_3_reg)=data)
+#define get_VO_SUB2_VSCC_0_reg   (*((volatile unsigned int*) VO_SUB2_VSCC_0_reg))
+#define get_VO_SUB2_VSCC_1_reg   (*((volatile unsigned int*) VO_SUB2_VSCC_1_reg))
+#define get_VO_SUB2_VSCC_2_reg   (*((volatile unsigned int*) VO_SUB2_VSCC_2_reg))
+#define get_VO_SUB2_VSCC_3_reg   (*((volatile unsigned int*) VO_SUB2_VSCC_3_reg))
+#define VO_SUB2_VSCC_0_inst_adr                                                      "0x0072"
+#define VO_SUB2_VSCC_1_inst_adr                                                      "0x0073"
+#define VO_SUB2_VSCC_2_inst_adr                                                      "0x0074"
+#define VO_SUB2_VSCC_3_inst_adr                                                      "0x0075"
+#define VO_SUB2_VSCC_0_inst                                                          0x0072
+#define VO_SUB2_VSCC_1_inst                                                          0x0073
+#define VO_SUB2_VSCC_2_inst                                                          0x0074
+#define VO_SUB2_VSCC_3_inst                                                          0x0075
+#define VO_SUB2_VSCC_c1_shift                                                        (16)
+#define VO_SUB2_VSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB2_VSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB2_VSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_VSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_VSCC_c0_shift                                                        (0)
+#define VO_SUB2_VSCC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB2_VSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB2_VSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB2_VSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB2_HSI                                                                  0x980059D8
+#define VO_SUB2_HSI_reg_addr                                                         "0xD80059D8"
+#define VO_SUB2_HSI_reg                                                              0xD80059D8
+#define set_VO_SUB2_HSI_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSI_reg)=data)
+#define get_VO_SUB2_HSI_reg   (*((volatile unsigned int*) VO_SUB2_HSI_reg))
+#define VO_SUB2_HSI_inst_adr                                                         "0x0076"
+#define VO_SUB2_HSI_inst                                                             0x0076
+#define VO_SUB2_HSI_offset_shift                                                     (16)
+#define VO_SUB2_HSI_offset_mask                                                      (0x07FF0000)
+#define VO_SUB2_HSI_offset(data)                                                     (0x07FF0000&((data)<<16))
+#define VO_SUB2_HSI_offset_src(data)                                                 ((0x07FF0000&(data))>>16)
+#define VO_SUB2_HSI_get_offset(data)                                                 ((0x07FF0000&(data))>>16)
+#define VO_SUB2_HSI_phase_shift                                                      (0)
+#define VO_SUB2_HSI_phase_mask                                                       (0x0000FFFF)
+#define VO_SUB2_HSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_SUB2_HSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_SUB2_HSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_SUB2_HSD                                                                  0x980059DC
+#define VO_SUB2_HSD_reg_addr                                                         "0xD80059DC"
+#define VO_SUB2_HSD_reg                                                              0xD80059DC
+#define set_VO_SUB2_HSD_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSD_reg)=data)
+#define get_VO_SUB2_HSD_reg   (*((volatile unsigned int*) VO_SUB2_HSD_reg))
+#define VO_SUB2_HSD_inst_adr                                                         "0x0077"
+#define VO_SUB2_HSD_inst                                                             0x0077
+#define VO_SUB2_HSD_delta_shift                                                      (0)
+#define VO_SUB2_HSD_delta_mask                                                       (0x001FFFFF)
+#define VO_SUB2_HSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_SUB2_HSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_SUB2_HSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_SUB2_HSD_W                                                                0x980059E0
+#define VO_SUB2_HSD_W_reg_addr                                                       "0xD80059E0"
+#define VO_SUB2_HSD_W_reg                                                            0xD80059E0
+#define set_VO_SUB2_HSD_W_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSD_W_reg)=data)
+#define get_VO_SUB2_HSD_W_reg   (*((volatile unsigned int*) VO_SUB2_HSD_W_reg))
+#define VO_SUB2_HSD_W_inst_adr                                                       "0x0078"
+#define VO_SUB2_HSD_W_inst                                                           0x0078
+#define VO_SUB2_HSD_W_out_shift                                                      (0)
+#define VO_SUB2_HSD_W_out_mask                                                       (0x00001FFF)
+#define VO_SUB2_HSD_W_out(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_SUB2_HSD_W_out_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_SUB2_HSD_W_get_out(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_SUB2_HSYC_0                                                               0x980059E4
+#define VO_SUB2_HSYC_1                                                               0x980059E8
+#define VO_SUB2_HSYC_2                                                               0x980059EC
+#define VO_SUB2_HSYC_3                                                               0x980059F0
+#define VO_SUB2_HSYC_4                                                               0x980059F4
+#define VO_SUB2_HSYC_5                                                               0x980059F8
+#define VO_SUB2_HSYC_6                                                               0x980059FC
+#define VO_SUB2_HSYC_7                                                               0x98005A00
+#define VO_SUB2_HSYC_0_reg_addr                                                      "0xD80059E4"
+#define VO_SUB2_HSYC_1_reg_addr                                                      "0xD80059E8"
+#define VO_SUB2_HSYC_2_reg_addr                                                      "0xD80059EC"
+#define VO_SUB2_HSYC_3_reg_addr                                                      "0xD80059F0"
+#define VO_SUB2_HSYC_4_reg_addr                                                      "0xD80059F4"
+#define VO_SUB2_HSYC_5_reg_addr                                                      "0xD80059F8"
+#define VO_SUB2_HSYC_6_reg_addr                                                      "0xD80059FC"
+#define VO_SUB2_HSYC_7_reg_addr                                                      "0xD8005A00"
+#define VO_SUB2_HSYC_0_reg                                                           0xD80059E4
+#define VO_SUB2_HSYC_1_reg                                                           0xD80059E8
+#define VO_SUB2_HSYC_2_reg                                                           0xD80059EC
+#define VO_SUB2_HSYC_3_reg                                                           0xD80059F0
+#define VO_SUB2_HSYC_4_reg                                                           0xD80059F4
+#define VO_SUB2_HSYC_5_reg                                                           0xD80059F8
+#define VO_SUB2_HSYC_6_reg                                                           0xD80059FC
+#define VO_SUB2_HSYC_7_reg                                                           0xD8005A00
+#define set_VO_SUB2_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSYC_0_reg)=data)
+#define set_VO_SUB2_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSYC_1_reg)=data)
+#define set_VO_SUB2_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSYC_2_reg)=data)
+#define set_VO_SUB2_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSYC_3_reg)=data)
+#define set_VO_SUB2_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSYC_4_reg)=data)
+#define set_VO_SUB2_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSYC_5_reg)=data)
+#define set_VO_SUB2_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSYC_6_reg)=data)
+#define set_VO_SUB2_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSYC_7_reg)=data)
+#define get_VO_SUB2_HSYC_0_reg   (*((volatile unsigned int*) VO_SUB2_HSYC_0_reg))
+#define get_VO_SUB2_HSYC_1_reg   (*((volatile unsigned int*) VO_SUB2_HSYC_1_reg))
+#define get_VO_SUB2_HSYC_2_reg   (*((volatile unsigned int*) VO_SUB2_HSYC_2_reg))
+#define get_VO_SUB2_HSYC_3_reg   (*((volatile unsigned int*) VO_SUB2_HSYC_3_reg))
+#define get_VO_SUB2_HSYC_4_reg   (*((volatile unsigned int*) VO_SUB2_HSYC_4_reg))
+#define get_VO_SUB2_HSYC_5_reg   (*((volatile unsigned int*) VO_SUB2_HSYC_5_reg))
+#define get_VO_SUB2_HSYC_6_reg   (*((volatile unsigned int*) VO_SUB2_HSYC_6_reg))
+#define get_VO_SUB2_HSYC_7_reg   (*((volatile unsigned int*) VO_SUB2_HSYC_7_reg))
+#define VO_SUB2_HSYC_0_inst_adr                                                      "0x0079"
+#define VO_SUB2_HSYC_1_inst_adr                                                      "0x007A"
+#define VO_SUB2_HSYC_2_inst_adr                                                      "0x007B"
+#define VO_SUB2_HSYC_3_inst_adr                                                      "0x007C"
+#define VO_SUB2_HSYC_4_inst_adr                                                      "0x007D"
+#define VO_SUB2_HSYC_5_inst_adr                                                      "0x007E"
+#define VO_SUB2_HSYC_6_inst_adr                                                      "0x007F"
+#define VO_SUB2_HSYC_7_inst_adr                                                      "0x0080"
+#define VO_SUB2_HSYC_0_inst                                                          0x0079
+#define VO_SUB2_HSYC_1_inst                                                          0x007A
+#define VO_SUB2_HSYC_2_inst                                                          0x007B
+#define VO_SUB2_HSYC_3_inst                                                          0x007C
+#define VO_SUB2_HSYC_4_inst                                                          0x007D
+#define VO_SUB2_HSYC_5_inst                                                          0x007E
+#define VO_SUB2_HSYC_6_inst                                                          0x007F
+#define VO_SUB2_HSYC_7_inst                                                          0x0080
+#define VO_SUB2_HSYC_c1_shift                                                        (16)
+#define VO_SUB2_HSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB2_HSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB2_HSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_HSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_HSYC_c0_shift                                                        (0)
+#define VO_SUB2_HSYC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB2_HSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB2_HSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB2_HSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB2_HSCC_0                                                               0x98005A04
+#define VO_SUB2_HSCC_1                                                               0x98005A08
+#define VO_SUB2_HSCC_2                                                               0x98005A0C
+#define VO_SUB2_HSCC_3                                                               0x98005A10
+#define VO_SUB2_HSCC_4                                                               0x98005A14
+#define VO_SUB2_HSCC_5                                                               0x98005A18
+#define VO_SUB2_HSCC_6                                                               0x98005A1C
+#define VO_SUB2_HSCC_7                                                               0x98005A20
+#define VO_SUB2_HSCC_0_reg_addr                                                      "0xD8005A04"
+#define VO_SUB2_HSCC_1_reg_addr                                                      "0xD8005A08"
+#define VO_SUB2_HSCC_2_reg_addr                                                      "0xD8005A0C"
+#define VO_SUB2_HSCC_3_reg_addr                                                      "0xD8005A10"
+#define VO_SUB2_HSCC_4_reg_addr                                                      "0xD8005A14"
+#define VO_SUB2_HSCC_5_reg_addr                                                      "0xD8005A18"
+#define VO_SUB2_HSCC_6_reg_addr                                                      "0xD8005A1C"
+#define VO_SUB2_HSCC_7_reg_addr                                                      "0xD8005A20"
+#define VO_SUB2_HSCC_0_reg                                                           0xD8005A04
+#define VO_SUB2_HSCC_1_reg                                                           0xD8005A08
+#define VO_SUB2_HSCC_2_reg                                                           0xD8005A0C
+#define VO_SUB2_HSCC_3_reg                                                           0xD8005A10
+#define VO_SUB2_HSCC_4_reg                                                           0xD8005A14
+#define VO_SUB2_HSCC_5_reg                                                           0xD8005A18
+#define VO_SUB2_HSCC_6_reg                                                           0xD8005A1C
+#define VO_SUB2_HSCC_7_reg                                                           0xD8005A20
+#define set_VO_SUB2_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSCC_0_reg)=data)
+#define set_VO_SUB2_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSCC_1_reg)=data)
+#define set_VO_SUB2_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSCC_2_reg)=data)
+#define set_VO_SUB2_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSCC_3_reg)=data)
+#define set_VO_SUB2_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSCC_4_reg)=data)
+#define set_VO_SUB2_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSCC_5_reg)=data)
+#define set_VO_SUB2_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSCC_6_reg)=data)
+#define set_VO_SUB2_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_SUB2_HSCC_7_reg)=data)
+#define get_VO_SUB2_HSCC_0_reg   (*((volatile unsigned int*) VO_SUB2_HSCC_0_reg))
+#define get_VO_SUB2_HSCC_1_reg   (*((volatile unsigned int*) VO_SUB2_HSCC_1_reg))
+#define get_VO_SUB2_HSCC_2_reg   (*((volatile unsigned int*) VO_SUB2_HSCC_2_reg))
+#define get_VO_SUB2_HSCC_3_reg   (*((volatile unsigned int*) VO_SUB2_HSCC_3_reg))
+#define get_VO_SUB2_HSCC_4_reg   (*((volatile unsigned int*) VO_SUB2_HSCC_4_reg))
+#define get_VO_SUB2_HSCC_5_reg   (*((volatile unsigned int*) VO_SUB2_HSCC_5_reg))
+#define get_VO_SUB2_HSCC_6_reg   (*((volatile unsigned int*) VO_SUB2_HSCC_6_reg))
+#define get_VO_SUB2_HSCC_7_reg   (*((volatile unsigned int*) VO_SUB2_HSCC_7_reg))
+#define VO_SUB2_HSCC_0_inst_adr                                                      "0x0081"
+#define VO_SUB2_HSCC_1_inst_adr                                                      "0x0082"
+#define VO_SUB2_HSCC_2_inst_adr                                                      "0x0083"
+#define VO_SUB2_HSCC_3_inst_adr                                                      "0x0084"
+#define VO_SUB2_HSCC_4_inst_adr                                                      "0x0085"
+#define VO_SUB2_HSCC_5_inst_adr                                                      "0x0086"
+#define VO_SUB2_HSCC_6_inst_adr                                                      "0x0087"
+#define VO_SUB2_HSCC_7_inst_adr                                                      "0x0088"
+#define VO_SUB2_HSCC_0_inst                                                          0x0081
+#define VO_SUB2_HSCC_1_inst                                                          0x0082
+#define VO_SUB2_HSCC_2_inst                                                          0x0083
+#define VO_SUB2_HSCC_3_inst                                                          0x0084
+#define VO_SUB2_HSCC_4_inst                                                          0x0085
+#define VO_SUB2_HSCC_5_inst                                                          0x0086
+#define VO_SUB2_HSCC_6_inst                                                          0x0087
+#define VO_SUB2_HSCC_7_inst                                                          0x0088
+#define VO_SUB2_HSCC_c1_shift                                                        (16)
+#define VO_SUB2_HSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB2_HSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB2_HSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_HSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB2_HSCC_c0_shift                                                        (0)
+#define VO_SUB2_HSCC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB2_HSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB2_HSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB2_HSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1                                                                      0x98005A24
+#define VO_OSD1_reg_addr                                                             "0xD8005A24"
+#define VO_OSD1_reg                                                                  0xD8005A24
+#define set_VO_OSD1_reg(data)   (*((volatile unsigned int*) VO_OSD1_reg)=data)
+#define get_VO_OSD1_reg   (*((volatile unsigned int*) VO_OSD1_reg))
+#define VO_OSD1_inst_adr                                                             "0x0089"
+#define VO_OSD1_inst                                                                 0x0089
+#define VO_OSD1_d3_dbh_shift                                                         (29)
+#define VO_OSD1_d3_dbh_mask                                                          (0x20000000)
+#define VO_OSD1_d3_dbh(data)                                                         (0x20000000&((data)<<29))
+#define VO_OSD1_d3_dbh_src(data)                                                     ((0x20000000&(data))>>29)
+#define VO_OSD1_get_d3_dbh(data)                                                     ((0x20000000&(data))>>29)
+#define VO_OSD1_d3_vdup_shift                                                        (28)
+#define VO_OSD1_d3_vdup_mask                                                         (0x10000000)
+#define VO_OSD1_d3_vdup(data)                                                        (0x10000000&((data)<<28))
+#define VO_OSD1_d3_vdup_src(data)                                                    ((0x10000000&(data))>>28)
+#define VO_OSD1_get_d3_vdup(data)                                                    ((0x10000000&(data))>>28)
+#define VO_OSD1_d3_dbw_shift                                                         (27)
+#define VO_OSD1_d3_dbw_mask                                                          (0x08000000)
+#define VO_OSD1_d3_dbw(data)                                                         (0x08000000&((data)<<27))
+#define VO_OSD1_d3_dbw_src(data)                                                     ((0x08000000&(data))>>27)
+#define VO_OSD1_get_d3_dbw(data)                                                     ((0x08000000&(data))>>27)
+#define VO_OSD1_d3_dup_shift                                                         (26)
+#define VO_OSD1_d3_dup_mask                                                          (0x04000000)
+#define VO_OSD1_d3_dup(data)                                                         (0x04000000&((data)<<26))
+#define VO_OSD1_d3_dup_src(data)                                                     ((0x04000000&(data))>>26)
+#define VO_OSD1_get_d3_dup(data)                                                     ((0x04000000&(data))>>26)
+#define VO_OSD1_rgb_out_shift                                                        (25)
+#define VO_OSD1_rgb_out_mask                                                         (0x02000000)
+#define VO_OSD1_rgb_out(data)                                                        (0x02000000&((data)<<25))
+#define VO_OSD1_rgb_out_src(data)                                                    ((0x02000000&(data))>>25)
+#define VO_OSD1_get_rgb_out(data)                                                    ((0x02000000&(data))>>25)
+#define VO_OSD1_dvb_shift                                                            (17)
+#define VO_OSD1_dvb_mask                                                             (0x00020000)
+#define VO_OSD1_dvb(data)                                                            (0x00020000&((data)<<17))
+#define VO_OSD1_dvb_src(data)                                                        ((0x00020000&(data))>>17)
+#define VO_OSD1_get_dvb(data)                                                        ((0x00020000&(data))>>17)
+#define VO_OSD1_osd_shift                                                            (16)
+#define VO_OSD1_osd_mask                                                             (0x00010000)
+#define VO_OSD1_osd(data)                                                            (0x00010000&((data)<<16))
+#define VO_OSD1_osd_src(data)                                                        ((0x00010000&(data))>>16)
+#define VO_OSD1_get_osd(data)                                                        ((0x00010000&(data))>>16)
+#define VO_OSD1_fetch_1080i_shift                                                    (15)
+#define VO_OSD1_fetch_1080i_mask                                                     (0x00008000)
+#define VO_OSD1_fetch_1080i(data)                                                    (0x00008000&((data)<<15))
+#define VO_OSD1_fetch_1080i_src(data)                                                ((0x00008000&(data))>>15)
+#define VO_OSD1_get_fetch_1080i(data)                                                ((0x00008000&(data))>>15)
+#define VO_OSD1_odd_1080i_shift                                                      (14)
+#define VO_OSD1_odd_1080i_mask                                                       (0x00004000)
+#define VO_OSD1_odd_1080i(data)                                                      (0x00004000&((data)<<14))
+#define VO_OSD1_odd_1080i_src(data)                                                  ((0x00004000&(data))>>14)
+#define VO_OSD1_get_odd_1080i(data)                                                  ((0x00004000&(data))>>14)
+#define VO_OSD1_vs_shift                                                             (10)
+#define VO_OSD1_vs_mask                                                              (0x00000400)
+#define VO_OSD1_vs(data)                                                             (0x00000400&((data)<<10))
+#define VO_OSD1_vs_src(data)                                                         ((0x00000400&(data))>>10)
+#define VO_OSD1_get_vs(data)                                                         ((0x00000400&(data))>>10)
+#define VO_OSD1_vs_near_shift                                                        (9)
+#define VO_OSD1_vs_near_mask                                                         (0x00000200)
+#define VO_OSD1_vs_near(data)                                                        (0x00000200&((data)<<9))
+#define VO_OSD1_vs_near_src(data)                                                    ((0x00000200&(data))>>9)
+#define VO_OSD1_get_vs_near(data)                                                    ((0x00000200&(data))>>9)
+#define VO_OSD1_vs_yodd_shift                                                        (8)
+#define VO_OSD1_vs_yodd_mask                                                         (0x00000100)
+#define VO_OSD1_vs_yodd(data)                                                        (0x00000100&((data)<<8))
+#define VO_OSD1_vs_yodd_src(data)                                                    ((0x00000100&(data))>>8)
+#define VO_OSD1_get_vs_yodd(data)                                                    ((0x00000100&(data))>>8)
+#define VO_OSD1_vs_codd_shift                                                        (7)
+#define VO_OSD1_vs_codd_mask                                                         (0x00000080)
+#define VO_OSD1_vs_codd(data)                                                        (0x00000080&((data)<<7))
+#define VO_OSD1_vs_codd_src(data)                                                    ((0x00000080&(data))>>7)
+#define VO_OSD1_get_vs_codd(data)                                                    ((0x00000080&(data))>>7)
+#define VO_OSD1_hs_shift                                                             (6)
+#define VO_OSD1_hs_mask                                                              (0x00000040)
+#define VO_OSD1_hs(data)                                                             (0x00000040&((data)<<6))
+#define VO_OSD1_hs_src(data)                                                         ((0x00000040&(data))>>6)
+#define VO_OSD1_get_hs(data)                                                         ((0x00000040&(data))>>6)
+#define VO_OSD1_hs_yodd_shift                                                        (5)
+#define VO_OSD1_hs_yodd_mask                                                         (0x00000020)
+#define VO_OSD1_hs_yodd(data)                                                        (0x00000020&((data)<<5))
+#define VO_OSD1_hs_yodd_src(data)                                                    ((0x00000020&(data))>>5)
+#define VO_OSD1_get_hs_yodd(data)                                                    ((0x00000020&(data))>>5)
+#define VO_OSD1_hs_codd_shift                                                        (4)
+#define VO_OSD1_hs_codd_mask                                                         (0x00000010)
+#define VO_OSD1_hs_codd(data)                                                        (0x00000010&((data)<<4))
+#define VO_OSD1_hs_codd_src(data)                                                    ((0x00000010&(data))>>4)
+#define VO_OSD1_get_hs_codd(data)                                                    ((0x00000010&(data))>>4)
+#define VO_OSD1_write_data_shift                                                     (0)
+#define VO_OSD1_write_data_mask                                                      (0x00000001)
+#define VO_OSD1_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_OSD1_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_OSD1_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_OSD1_START                                                                0x98005A28
+#define VO_OSD1_START_reg_addr                                                       "0xD8005A28"
+#define VO_OSD1_START_reg                                                            0xD8005A28
+#define set_VO_OSD1_START_reg(data)   (*((volatile unsigned int*) VO_OSD1_START_reg)=data)
+#define get_VO_OSD1_START_reg   (*((volatile unsigned int*) VO_OSD1_START_reg))
+#define VO_OSD1_START_inst_adr                                                       "0x008A"
+#define VO_OSD1_START_inst                                                           0x008A
+#define VO_OSD1_START_ref_shift                                                      (24)
+#define VO_OSD1_START_ref_mask                                                       (0x07000000)
+#define VO_OSD1_START_ref(data)                                                      (0x07000000&((data)<<24))
+#define VO_OSD1_START_ref_src(data)                                                  ((0x07000000&(data))>>24)
+#define VO_OSD1_START_get_ref(data)                                                  ((0x07000000&(data))>>24)
+#define VO_OSD1_START_pos_shift                                                      (12)
+#define VO_OSD1_START_pos_mask                                                       (0x00FFF000)
+#define VO_OSD1_START_pos(data)                                                      (0x00FFF000&((data)<<12))
+#define VO_OSD1_START_pos_src(data)                                                  ((0x00FFF000&(data))>>12)
+#define VO_OSD1_START_get_pos(data)                                                  ((0x00FFF000&(data))>>12)
+#define VO_OSD1_START_th_shift                                                       (0)
+#define VO_OSD1_START_th_mask                                                        (0x00000FFF)
+#define VO_OSD1_START_th(data)                                                       (0x00000FFF&((data)<<0))
+#define VO_OSD1_START_th_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VO_OSD1_START_get_th(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VO_OSD1_WI                                                                   0x98005A2C
+#define VO_OSD1_WI_reg_addr                                                          "0xD8005A2C"
+#define VO_OSD1_WI_reg                                                               0xD8005A2C
+#define set_VO_OSD1_WI_reg(data)   (*((volatile unsigned int*) VO_OSD1_WI_reg)=data)
+#define get_VO_OSD1_WI_reg   (*((volatile unsigned int*) VO_OSD1_WI_reg))
+#define VO_OSD1_WI_inst_adr                                                          "0x008B"
+#define VO_OSD1_WI_inst                                                              0x008B
+#define VO_OSD1_WI_swap_8byte_shift                                                  (1)
+#define VO_OSD1_WI_swap_8byte_mask                                                   (0x00000002)
+#define VO_OSD1_WI_swap_8byte(data)                                                  (0x00000002&((data)<<1))
+#define VO_OSD1_WI_swap_8byte_src(data)                                              ((0x00000002&(data))>>1)
+#define VO_OSD1_WI_get_swap_8byte(data)                                              ((0x00000002&(data))>>1)
+#define VO_OSD1_WI_endian_shift                                                      (0)
+#define VO_OSD1_WI_endian_mask                                                       (0x00000001)
+#define VO_OSD1_WI_endian(data)                                                      (0x00000001&((data)<<0))
+#define VO_OSD1_WI_endian_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_OSD1_WI_get_endian(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_OSD1_WI_1                                                                 0x98005A30
+#define VO_OSD1_WI_1_reg_addr                                                        "0xD8005A30"
+#define VO_OSD1_WI_1_reg                                                             0xD8005A30
+#define set_VO_OSD1_WI_1_reg(data)   (*((volatile unsigned int*) VO_OSD1_WI_1_reg)=data)
+#define get_VO_OSD1_WI_1_reg   (*((volatile unsigned int*) VO_OSD1_WI_1_reg))
+#define VO_OSD1_WI_1_inst_adr                                                        "0x008C"
+#define VO_OSD1_WI_1_inst                                                            0x008C
+#define VO_OSD1_WI_1_a_shift                                                         (0)
+#define VO_OSD1_WI_1_a_mask                                                          (0xFFFFFFFF)
+#define VO_OSD1_WI_1_a(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define VO_OSD1_WI_1_a_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define VO_OSD1_WI_1_get_a(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_OSD1_WI_3D                                                                0x98005A34
+#define VO_OSD1_WI_3D_reg_addr                                                       "0xD8005A34"
+#define VO_OSD1_WI_3D_reg                                                            0xD8005A34
+#define set_VO_OSD1_WI_3D_reg(data)   (*((volatile unsigned int*) VO_OSD1_WI_3D_reg)=data)
+#define get_VO_OSD1_WI_3D_reg   (*((volatile unsigned int*) VO_OSD1_WI_3D_reg))
+#define VO_OSD1_WI_3D_inst_adr                                                       "0x008D"
+#define VO_OSD1_WI_3D_inst                                                           0x008D
+#define VO_OSD1_WI_3D_a_shift                                                        (0)
+#define VO_OSD1_WI_3D_a_mask                                                         (0xFFFFFFFF)
+#define VO_OSD1_WI_3D_a(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define VO_OSD1_WI_3D_a_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define VO_OSD1_WI_3D_get_a(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_OSD1_SIZE                                                                 0x98005A38
+#define VO_OSD1_SIZE_reg_addr                                                        "0xD8005A38"
+#define VO_OSD1_SIZE_reg                                                             0xD8005A38
+#define set_VO_OSD1_SIZE_reg(data)   (*((volatile unsigned int*) VO_OSD1_SIZE_reg)=data)
+#define get_VO_OSD1_SIZE_reg   (*((volatile unsigned int*) VO_OSD1_SIZE_reg))
+#define VO_OSD1_SIZE_inst_adr                                                        "0x008E"
+#define VO_OSD1_SIZE_inst                                                            0x008E
+#define VO_OSD1_SIZE_w_shift                                                         (12)
+#define VO_OSD1_SIZE_w_mask                                                          (0x01FFF000)
+#define VO_OSD1_SIZE_w(data)                                                         (0x01FFF000&((data)<<12))
+#define VO_OSD1_SIZE_w_src(data)                                                     ((0x01FFF000&(data))>>12)
+#define VO_OSD1_SIZE_get_w(data)                                                     ((0x01FFF000&(data))>>12)
+#define VO_OSD1_SIZE_h_shift                                                         (0)
+#define VO_OSD1_SIZE_h_mask                                                          (0x00000FFF)
+#define VO_OSD1_SIZE_h(data)                                                         (0x00000FFF&((data)<<0))
+#define VO_OSD1_SIZE_h_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define VO_OSD1_SIZE_get_h(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define VO_OSD1_BUF                                                                  0x98005A3C
+#define VO_OSD1_BUF_reg_addr                                                         "0xD8005A3C"
+#define VO_OSD1_BUF_reg                                                              0xD8005A3C
+#define set_VO_OSD1_BUF_reg(data)   (*((volatile unsigned int*) VO_OSD1_BUF_reg)=data)
+#define get_VO_OSD1_BUF_reg   (*((volatile unsigned int*) VO_OSD1_BUF_reg))
+#define VO_OSD1_BUF_inst_adr                                                         "0x008F"
+#define VO_OSD1_BUF_inst                                                             0x008F
+#define VO_OSD1_BUF_th_shift                                                         (0)
+#define VO_OSD1_BUF_th_mask                                                          (0x000001FF)
+#define VO_OSD1_BUF_th(data)                                                         (0x000001FF&((data)<<0))
+#define VO_OSD1_BUF_th_src(data)                                                     ((0x000001FF&(data))>>0)
+#define VO_OSD1_BUF_get_th(data)                                                     ((0x000001FF&(data))>>0)
+
+
+#define VO_OSD1_CC1                                                                  0x98005A40
+#define VO_OSD1_CC1_reg_addr                                                         "0xD8005A40"
+#define VO_OSD1_CC1_reg                                                              0xD8005A40
+#define set_VO_OSD1_CC1_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC1_reg)=data)
+#define get_VO_OSD1_CC1_reg   (*((volatile unsigned int*) VO_OSD1_CC1_reg))
+#define VO_OSD1_CC1_inst_adr                                                         "0x0090"
+#define VO_OSD1_CC1_inst                                                             0x0090
+#define VO_OSD1_CC1_m01_shift                                                        (16)
+#define VO_OSD1_CC1_m01_mask                                                         (0x3FFF0000)
+#define VO_OSD1_CC1_m01(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_CC1_m01_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC1_get_m01(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC1_m00_shift                                                        (0)
+#define VO_OSD1_CC1_m00_mask                                                         (0x00003FFF)
+#define VO_OSD1_CC1_m00(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_CC1_m00_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_CC1_get_m00(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_CC2                                                                  0x98005A44
+#define VO_OSD1_CC2_reg_addr                                                         "0xD8005A44"
+#define VO_OSD1_CC2_reg                                                              0xD8005A44
+#define set_VO_OSD1_CC2_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC2_reg)=data)
+#define get_VO_OSD1_CC2_reg   (*((volatile unsigned int*) VO_OSD1_CC2_reg))
+#define VO_OSD1_CC2_inst_adr                                                         "0x0091"
+#define VO_OSD1_CC2_inst                                                             0x0091
+#define VO_OSD1_CC2_m10_shift                                                        (16)
+#define VO_OSD1_CC2_m10_mask                                                         (0x3FFF0000)
+#define VO_OSD1_CC2_m10(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_CC2_m10_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC2_get_m10(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC2_m02_shift                                                        (0)
+#define VO_OSD1_CC2_m02_mask                                                         (0x00003FFF)
+#define VO_OSD1_CC2_m02(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_CC2_m02_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_CC2_get_m02(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_CC3                                                                  0x98005A48
+#define VO_OSD1_CC3_reg_addr                                                         "0xD8005A48"
+#define VO_OSD1_CC3_reg                                                              0xD8005A48
+#define set_VO_OSD1_CC3_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC3_reg)=data)
+#define get_VO_OSD1_CC3_reg   (*((volatile unsigned int*) VO_OSD1_CC3_reg))
+#define VO_OSD1_CC3_inst_adr                                                         "0x0092"
+#define VO_OSD1_CC3_inst                                                             0x0092
+#define VO_OSD1_CC3_m12_shift                                                        (16)
+#define VO_OSD1_CC3_m12_mask                                                         (0x3FFF0000)
+#define VO_OSD1_CC3_m12(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_CC3_m12_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC3_get_m12(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC3_m11_shift                                                        (0)
+#define VO_OSD1_CC3_m11_mask                                                         (0x00003FFF)
+#define VO_OSD1_CC3_m11(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_CC3_m11_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_CC3_get_m11(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_CC4                                                                  0x98005A4C
+#define VO_OSD1_CC4_reg_addr                                                         "0xD8005A4C"
+#define VO_OSD1_CC4_reg                                                              0xD8005A4C
+#define set_VO_OSD1_CC4_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC4_reg)=data)
+#define get_VO_OSD1_CC4_reg   (*((volatile unsigned int*) VO_OSD1_CC4_reg))
+#define VO_OSD1_CC4_inst_adr                                                         "0x0093"
+#define VO_OSD1_CC4_inst                                                             0x0093
+#define VO_OSD1_CC4_m21_shift                                                        (16)
+#define VO_OSD1_CC4_m21_mask                                                         (0x3FFF0000)
+#define VO_OSD1_CC4_m21(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_CC4_m21_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC4_get_m21(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC4_m20_shift                                                        (0)
+#define VO_OSD1_CC4_m20_mask                                                         (0x00003FFF)
+#define VO_OSD1_CC4_m20(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_CC4_m20_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_CC4_get_m20(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_CC5                                                                  0x98005A50
+#define VO_OSD1_CC5_reg_addr                                                         "0xD8005A50"
+#define VO_OSD1_CC5_reg                                                              0xD8005A50
+#define set_VO_OSD1_CC5_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC5_reg)=data)
+#define get_VO_OSD1_CC5_reg   (*((volatile unsigned int*) VO_OSD1_CC5_reg))
+#define VO_OSD1_CC5_inst_adr                                                         "0x0094"
+#define VO_OSD1_CC5_inst                                                             0x0094
+#define VO_OSD1_CC5_m22_shift                                                        (0)
+#define VO_OSD1_CC5_m22_mask                                                         (0x00003FFF)
+#define VO_OSD1_CC5_m22(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_CC5_m22_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_CC5_get_m22(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_CC6                                                                  0x98005A54
+#define VO_OSD1_CC6_reg_addr                                                         "0xD8005A54"
+#define VO_OSD1_CC6_reg                                                              0xD8005A54
+#define set_VO_OSD1_CC6_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC6_reg)=data)
+#define get_VO_OSD1_CC6_reg   (*((volatile unsigned int*) VO_OSD1_CC6_reg))
+#define VO_OSD1_CC6_inst_adr                                                         "0x0095"
+#define VO_OSD1_CC6_inst                                                             0x0095
+#define VO_OSD1_CC6_a1_shift                                                         (11)
+#define VO_OSD1_CC6_a1_mask                                                          (0x003FF800)
+#define VO_OSD1_CC6_a1(data)                                                         (0x003FF800&((data)<<11))
+#define VO_OSD1_CC6_a1_src(data)                                                     ((0x003FF800&(data))>>11)
+#define VO_OSD1_CC6_get_a1(data)                                                     ((0x003FF800&(data))>>11)
+#define VO_OSD1_CC6_a0_shift                                                         (0)
+#define VO_OSD1_CC6_a0_mask                                                          (0x000007FF)
+#define VO_OSD1_CC6_a0(data)                                                         (0x000007FF&((data)<<0))
+#define VO_OSD1_CC6_a0_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_OSD1_CC6_get_a0(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_OSD1_CC7                                                                  0x98005A58
+#define VO_OSD1_CC7_reg_addr                                                         "0xD8005A58"
+#define VO_OSD1_CC7_reg                                                              0xD8005A58
+#define set_VO_OSD1_CC7_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC7_reg)=data)
+#define get_VO_OSD1_CC7_reg   (*((volatile unsigned int*) VO_OSD1_CC7_reg))
+#define VO_OSD1_CC7_inst_adr                                                         "0x0096"
+#define VO_OSD1_CC7_inst                                                             0x0096
+#define VO_OSD1_CC7_a2_shift                                                         (0)
+#define VO_OSD1_CC7_a2_mask                                                          (0x000007FF)
+#define VO_OSD1_CC7_a2(data)                                                         (0x000007FF&((data)<<0))
+#define VO_OSD1_CC7_a2_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_OSD1_CC7_get_a2(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_OSD1_VSI                                                                  0x98005A5C
+#define VO_OSD1_VSI_reg_addr                                                         "0xD8005A5C"
+#define VO_OSD1_VSI_reg                                                              0xD8005A5C
+#define set_VO_OSD1_VSI_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSI_reg)=data)
+#define get_VO_OSD1_VSI_reg   (*((volatile unsigned int*) VO_OSD1_VSI_reg))
+#define VO_OSD1_VSI_inst_adr                                                         "0x0097"
+#define VO_OSD1_VSI_inst                                                             0x0097
+#define VO_OSD1_VSI_offset_shift                                                     (16)
+#define VO_OSD1_VSI_offset_mask                                                      (0x0FFF0000)
+#define VO_OSD1_VSI_offset(data)                                                     (0x0FFF0000&((data)<<16))
+#define VO_OSD1_VSI_offset_src(data)                                                 ((0x0FFF0000&(data))>>16)
+#define VO_OSD1_VSI_get_offset(data)                                                 ((0x0FFF0000&(data))>>16)
+#define VO_OSD1_VSI_phase_shift                                                      (0)
+#define VO_OSD1_VSI_phase_mask                                                       (0x0000FFFF)
+#define VO_OSD1_VSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_OSD1_VSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_OSD1_VSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_OSD1_VSD                                                                  0x98005A60
+#define VO_OSD1_VSD_reg_addr                                                         "0xD8005A60"
+#define VO_OSD1_VSD_reg                                                              0xD8005A60
+#define set_VO_OSD1_VSD_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSD_reg)=data)
+#define get_VO_OSD1_VSD_reg   (*((volatile unsigned int*) VO_OSD1_VSD_reg))
+#define VO_OSD1_VSD_inst_adr                                                         "0x0098"
+#define VO_OSD1_VSD_inst                                                             0x0098
+#define VO_OSD1_VSD_delta_shift                                                      (0)
+#define VO_OSD1_VSD_delta_mask                                                       (0x001FFFFF)
+#define VO_OSD1_VSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_OSD1_VSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_OSD1_VSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_OSD1_VSD_H                                                                0x98005A64
+#define VO_OSD1_VSD_H_reg_addr                                                       "0xD8005A64"
+#define VO_OSD1_VSD_H_reg                                                            0xD8005A64
+#define set_VO_OSD1_VSD_H_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSD_H_reg)=data)
+#define get_VO_OSD1_VSD_H_reg   (*((volatile unsigned int*) VO_OSD1_VSD_H_reg))
+#define VO_OSD1_VSD_H_inst_adr                                                       "0x0099"
+#define VO_OSD1_VSD_H_inst                                                           0x0099
+#define VO_OSD1_VSD_H_out_shift                                                      (0)
+#define VO_OSD1_VSD_H_out_mask                                                       (0x00000FFF)
+#define VO_OSD1_VSD_H_out(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_OSD1_VSD_H_out_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_OSD1_VSD_H_get_out(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_OSD1_VSYC_0                                                               0x98005A68
+#define VO_OSD1_VSYC_1                                                               0x98005A6C
+#define VO_OSD1_VSYC_2                                                               0x98005A70
+#define VO_OSD1_VSYC_3                                                               0x98005A74
+#define VO_OSD1_VSYC_0_reg_addr                                                      "0xD8005A68"
+#define VO_OSD1_VSYC_1_reg_addr                                                      "0xD8005A6C"
+#define VO_OSD1_VSYC_2_reg_addr                                                      "0xD8005A70"
+#define VO_OSD1_VSYC_3_reg_addr                                                      "0xD8005A74"
+#define VO_OSD1_VSYC_0_reg                                                           0xD8005A68
+#define VO_OSD1_VSYC_1_reg                                                           0xD8005A6C
+#define VO_OSD1_VSYC_2_reg                                                           0xD8005A70
+#define VO_OSD1_VSYC_3_reg                                                           0xD8005A74
+#define set_VO_OSD1_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSYC_0_reg)=data)
+#define set_VO_OSD1_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSYC_1_reg)=data)
+#define set_VO_OSD1_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSYC_2_reg)=data)
+#define set_VO_OSD1_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSYC_3_reg)=data)
+#define get_VO_OSD1_VSYC_0_reg   (*((volatile unsigned int*) VO_OSD1_VSYC_0_reg))
+#define get_VO_OSD1_VSYC_1_reg   (*((volatile unsigned int*) VO_OSD1_VSYC_1_reg))
+#define get_VO_OSD1_VSYC_2_reg   (*((volatile unsigned int*) VO_OSD1_VSYC_2_reg))
+#define get_VO_OSD1_VSYC_3_reg   (*((volatile unsigned int*) VO_OSD1_VSYC_3_reg))
+#define VO_OSD1_VSYC_0_inst_adr                                                      "0x009A"
+#define VO_OSD1_VSYC_1_inst_adr                                                      "0x009B"
+#define VO_OSD1_VSYC_2_inst_adr                                                      "0x009C"
+#define VO_OSD1_VSYC_3_inst_adr                                                      "0x009D"
+#define VO_OSD1_VSYC_0_inst                                                          0x009A
+#define VO_OSD1_VSYC_1_inst                                                          0x009B
+#define VO_OSD1_VSYC_2_inst                                                          0x009C
+#define VO_OSD1_VSYC_3_inst                                                          0x009D
+#define VO_OSD1_VSYC_c1_shift                                                        (16)
+#define VO_OSD1_VSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_OSD1_VSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_VSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_VSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_VSYC_c0_shift                                                        (0)
+#define VO_OSD1_VSYC_c0_mask                                                         (0x00003FFF)
+#define VO_OSD1_VSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_VSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_VSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_VSCC_0                                                               0x98005A78
+#define VO_OSD1_VSCC_1                                                               0x98005A7C
+#define VO_OSD1_VSCC_2                                                               0x98005A80
+#define VO_OSD1_VSCC_3                                                               0x98005A84
+#define VO_OSD1_VSCC_0_reg_addr                                                      "0xD8005A78"
+#define VO_OSD1_VSCC_1_reg_addr                                                      "0xD8005A7C"
+#define VO_OSD1_VSCC_2_reg_addr                                                      "0xD8005A80"
+#define VO_OSD1_VSCC_3_reg_addr                                                      "0xD8005A84"
+#define VO_OSD1_VSCC_0_reg                                                           0xD8005A78
+#define VO_OSD1_VSCC_1_reg                                                           0xD8005A7C
+#define VO_OSD1_VSCC_2_reg                                                           0xD8005A80
+#define VO_OSD1_VSCC_3_reg                                                           0xD8005A84
+#define set_VO_OSD1_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSCC_0_reg)=data)
+#define set_VO_OSD1_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSCC_1_reg)=data)
+#define set_VO_OSD1_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSCC_2_reg)=data)
+#define set_VO_OSD1_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSCC_3_reg)=data)
+#define get_VO_OSD1_VSCC_0_reg   (*((volatile unsigned int*) VO_OSD1_VSCC_0_reg))
+#define get_VO_OSD1_VSCC_1_reg   (*((volatile unsigned int*) VO_OSD1_VSCC_1_reg))
+#define get_VO_OSD1_VSCC_2_reg   (*((volatile unsigned int*) VO_OSD1_VSCC_2_reg))
+#define get_VO_OSD1_VSCC_3_reg   (*((volatile unsigned int*) VO_OSD1_VSCC_3_reg))
+#define VO_OSD1_VSCC_0_inst_adr                                                      "0x009E"
+#define VO_OSD1_VSCC_1_inst_adr                                                      "0x009F"
+#define VO_OSD1_VSCC_2_inst_adr                                                      "0x00A0"
+#define VO_OSD1_VSCC_3_inst_adr                                                      "0x00A1"
+#define VO_OSD1_VSCC_0_inst                                                          0x009E
+#define VO_OSD1_VSCC_1_inst                                                          0x009F
+#define VO_OSD1_VSCC_2_inst                                                          0x00A0
+#define VO_OSD1_VSCC_3_inst                                                          0x00A1
+#define VO_OSD1_VSCC_c1_shift                                                        (16)
+#define VO_OSD1_VSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_OSD1_VSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_VSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_VSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_VSCC_c0_shift                                                        (0)
+#define VO_OSD1_VSCC_c0_mask                                                         (0x00003FFF)
+#define VO_OSD1_VSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_VSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_VSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_HSI                                                                  0x98005A88
+#define VO_OSD1_HSI_reg_addr                                                         "0xD8005A88"
+#define VO_OSD1_HSI_reg                                                              0xD8005A88
+#define set_VO_OSD1_HSI_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSI_reg)=data)
+#define get_VO_OSD1_HSI_reg   (*((volatile unsigned int*) VO_OSD1_HSI_reg))
+#define VO_OSD1_HSI_inst_adr                                                         "0x00A2"
+#define VO_OSD1_HSI_inst                                                             0x00A2
+#define VO_OSD1_HSI_offset_shift                                                     (16)
+#define VO_OSD1_HSI_offset_mask                                                      (0x1FFF0000)
+#define VO_OSD1_HSI_offset(data)                                                     (0x1FFF0000&((data)<<16))
+#define VO_OSD1_HSI_offset_src(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_OSD1_HSI_get_offset(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_OSD1_HSI_phase_shift                                                      (0)
+#define VO_OSD1_HSI_phase_mask                                                       (0x0000FFFF)
+#define VO_OSD1_HSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_OSD1_HSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_OSD1_HSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_OSD1_HSD                                                                  0x98005A8C
+#define VO_OSD1_HSD_reg_addr                                                         "0xD8005A8C"
+#define VO_OSD1_HSD_reg                                                              0xD8005A8C
+#define set_VO_OSD1_HSD_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSD_reg)=data)
+#define get_VO_OSD1_HSD_reg   (*((volatile unsigned int*) VO_OSD1_HSD_reg))
+#define VO_OSD1_HSD_inst_adr                                                         "0x00A3"
+#define VO_OSD1_HSD_inst                                                             0x00A3
+#define VO_OSD1_HSD_delta_shift                                                      (0)
+#define VO_OSD1_HSD_delta_mask                                                       (0x001FFFFF)
+#define VO_OSD1_HSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_OSD1_HSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_OSD1_HSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_OSD1_HSD_W                                                                0x98005A90
+#define VO_OSD1_HSD_W_reg_addr                                                       "0xD8005A90"
+#define VO_OSD1_HSD_W_reg                                                            0xD8005A90
+#define set_VO_OSD1_HSD_W_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSD_W_reg)=data)
+#define get_VO_OSD1_HSD_W_reg   (*((volatile unsigned int*) VO_OSD1_HSD_W_reg))
+#define VO_OSD1_HSD_W_inst_adr                                                       "0x00A4"
+#define VO_OSD1_HSD_W_inst                                                           0x00A4
+#define VO_OSD1_HSD_W_out_shift                                                      (0)
+#define VO_OSD1_HSD_W_out_mask                                                       (0x00001FFF)
+#define VO_OSD1_HSD_W_out(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_OSD1_HSD_W_out_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_OSD1_HSD_W_get_out(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_OSD1_HSYC_0                                                               0x98005A94
+#define VO_OSD1_HSYC_1                                                               0x98005A98
+#define VO_OSD1_HSYC_2                                                               0x98005A9C
+#define VO_OSD1_HSYC_3                                                               0x98005AA0
+#define VO_OSD1_HSYC_4                                                               0x98005AA4
+#define VO_OSD1_HSYC_5                                                               0x98005AA8
+#define VO_OSD1_HSYC_6                                                               0x98005AAC
+#define VO_OSD1_HSYC_7                                                               0x98005AB0
+#define VO_OSD1_HSYC_0_reg_addr                                                      "0xD8005A94"
+#define VO_OSD1_HSYC_1_reg_addr                                                      "0xD8005A98"
+#define VO_OSD1_HSYC_2_reg_addr                                                      "0xD8005A9C"
+#define VO_OSD1_HSYC_3_reg_addr                                                      "0xD8005AA0"
+#define VO_OSD1_HSYC_4_reg_addr                                                      "0xD8005AA4"
+#define VO_OSD1_HSYC_5_reg_addr                                                      "0xD8005AA8"
+#define VO_OSD1_HSYC_6_reg_addr                                                      "0xD8005AAC"
+#define VO_OSD1_HSYC_7_reg_addr                                                      "0xD8005AB0"
+#define VO_OSD1_HSYC_0_reg                                                           0xD8005A94
+#define VO_OSD1_HSYC_1_reg                                                           0xD8005A98
+#define VO_OSD1_HSYC_2_reg                                                           0xD8005A9C
+#define VO_OSD1_HSYC_3_reg                                                           0xD8005AA0
+#define VO_OSD1_HSYC_4_reg                                                           0xD8005AA4
+#define VO_OSD1_HSYC_5_reg                                                           0xD8005AA8
+#define VO_OSD1_HSYC_6_reg                                                           0xD8005AAC
+#define VO_OSD1_HSYC_7_reg                                                           0xD8005AB0
+#define set_VO_OSD1_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_0_reg)=data)
+#define set_VO_OSD1_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_1_reg)=data)
+#define set_VO_OSD1_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_2_reg)=data)
+#define set_VO_OSD1_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_3_reg)=data)
+#define set_VO_OSD1_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_4_reg)=data)
+#define set_VO_OSD1_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_5_reg)=data)
+#define set_VO_OSD1_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_6_reg)=data)
+#define set_VO_OSD1_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_7_reg)=data)
+#define get_VO_OSD1_HSYC_0_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_0_reg))
+#define get_VO_OSD1_HSYC_1_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_1_reg))
+#define get_VO_OSD1_HSYC_2_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_2_reg))
+#define get_VO_OSD1_HSYC_3_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_3_reg))
+#define get_VO_OSD1_HSYC_4_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_4_reg))
+#define get_VO_OSD1_HSYC_5_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_5_reg))
+#define get_VO_OSD1_HSYC_6_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_6_reg))
+#define get_VO_OSD1_HSYC_7_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_7_reg))
+#define VO_OSD1_HSYC_0_inst_adr                                                      "0x00A5"
+#define VO_OSD1_HSYC_1_inst_adr                                                      "0x00A6"
+#define VO_OSD1_HSYC_2_inst_adr                                                      "0x00A7"
+#define VO_OSD1_HSYC_3_inst_adr                                                      "0x00A8"
+#define VO_OSD1_HSYC_4_inst_adr                                                      "0x00A9"
+#define VO_OSD1_HSYC_5_inst_adr                                                      "0x00AA"
+#define VO_OSD1_HSYC_6_inst_adr                                                      "0x00AB"
+#define VO_OSD1_HSYC_7_inst_adr                                                      "0x00AC"
+#define VO_OSD1_HSYC_0_inst                                                          0x00A5
+#define VO_OSD1_HSYC_1_inst                                                          0x00A6
+#define VO_OSD1_HSYC_2_inst                                                          0x00A7
+#define VO_OSD1_HSYC_3_inst                                                          0x00A8
+#define VO_OSD1_HSYC_4_inst                                                          0x00A9
+#define VO_OSD1_HSYC_5_inst                                                          0x00AA
+#define VO_OSD1_HSYC_6_inst                                                          0x00AB
+#define VO_OSD1_HSYC_7_inst                                                          0x00AC
+#define VO_OSD1_HSYC_c1_shift                                                        (16)
+#define VO_OSD1_HSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_OSD1_HSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_HSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_HSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_HSYC_c0_shift                                                        (0)
+#define VO_OSD1_HSYC_c0_mask                                                         (0x00003FFF)
+#define VO_OSD1_HSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_HSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_HSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_HSCC_0                                                               0x98005AB4
+#define VO_OSD1_HSCC_1                                                               0x98005AB8
+#define VO_OSD1_HSCC_2                                                               0x98005ABC
+#define VO_OSD1_HSCC_3                                                               0x98005AC0
+#define VO_OSD1_HSCC_4                                                               0x98005AC4
+#define VO_OSD1_HSCC_5                                                               0x98005AC8
+#define VO_OSD1_HSCC_6                                                               0x98005ACC
+#define VO_OSD1_HSCC_7                                                               0x98005AD0
+#define VO_OSD1_HSCC_0_reg_addr                                                      "0xD8005AB4"
+#define VO_OSD1_HSCC_1_reg_addr                                                      "0xD8005AB8"
+#define VO_OSD1_HSCC_2_reg_addr                                                      "0xD8005ABC"
+#define VO_OSD1_HSCC_3_reg_addr                                                      "0xD8005AC0"
+#define VO_OSD1_HSCC_4_reg_addr                                                      "0xD8005AC4"
+#define VO_OSD1_HSCC_5_reg_addr                                                      "0xD8005AC8"
+#define VO_OSD1_HSCC_6_reg_addr                                                      "0xD8005ACC"
+#define VO_OSD1_HSCC_7_reg_addr                                                      "0xD8005AD0"
+#define VO_OSD1_HSCC_0_reg                                                           0xD8005AB4
+#define VO_OSD1_HSCC_1_reg                                                           0xD8005AB8
+#define VO_OSD1_HSCC_2_reg                                                           0xD8005ABC
+#define VO_OSD1_HSCC_3_reg                                                           0xD8005AC0
+#define VO_OSD1_HSCC_4_reg                                                           0xD8005AC4
+#define VO_OSD1_HSCC_5_reg                                                           0xD8005AC8
+#define VO_OSD1_HSCC_6_reg                                                           0xD8005ACC
+#define VO_OSD1_HSCC_7_reg                                                           0xD8005AD0
+#define set_VO_OSD1_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_0_reg)=data)
+#define set_VO_OSD1_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_1_reg)=data)
+#define set_VO_OSD1_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_2_reg)=data)
+#define set_VO_OSD1_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_3_reg)=data)
+#define set_VO_OSD1_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_4_reg)=data)
+#define set_VO_OSD1_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_5_reg)=data)
+#define set_VO_OSD1_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_6_reg)=data)
+#define set_VO_OSD1_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_7_reg)=data)
+#define get_VO_OSD1_HSCC_0_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_0_reg))
+#define get_VO_OSD1_HSCC_1_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_1_reg))
+#define get_VO_OSD1_HSCC_2_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_2_reg))
+#define get_VO_OSD1_HSCC_3_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_3_reg))
+#define get_VO_OSD1_HSCC_4_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_4_reg))
+#define get_VO_OSD1_HSCC_5_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_5_reg))
+#define get_VO_OSD1_HSCC_6_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_6_reg))
+#define get_VO_OSD1_HSCC_7_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_7_reg))
+#define VO_OSD1_HSCC_0_inst_adr                                                      "0x00AD"
+#define VO_OSD1_HSCC_1_inst_adr                                                      "0x00AE"
+#define VO_OSD1_HSCC_2_inst_adr                                                      "0x00AF"
+#define VO_OSD1_HSCC_3_inst_adr                                                      "0x00B0"
+#define VO_OSD1_HSCC_4_inst_adr                                                      "0x00B1"
+#define VO_OSD1_HSCC_5_inst_adr                                                      "0x00B2"
+#define VO_OSD1_HSCC_6_inst_adr                                                      "0x00B3"
+#define VO_OSD1_HSCC_7_inst_adr                                                      "0x00B4"
+#define VO_OSD1_HSCC_0_inst                                                          0x00AD
+#define VO_OSD1_HSCC_1_inst                                                          0x00AE
+#define VO_OSD1_HSCC_2_inst                                                          0x00AF
+#define VO_OSD1_HSCC_3_inst                                                          0x00B0
+#define VO_OSD1_HSCC_4_inst                                                          0x00B1
+#define VO_OSD1_HSCC_5_inst                                                          0x00B2
+#define VO_OSD1_HSCC_6_inst                                                          0x00B3
+#define VO_OSD1_HSCC_7_inst                                                          0x00B4
+#define VO_OSD1_HSCC_c1_shift                                                        (16)
+#define VO_OSD1_HSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_OSD1_HSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_HSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_HSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_HSCC_c0_shift                                                        (0)
+#define VO_OSD1_HSCC_c0_mask                                                         (0x00003FFF)
+#define VO_OSD1_HSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_HSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_HSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_CSR                                                                       0x98005AD4
+#define VO_CSR_reg_addr                                                              "0xD8005AD4"
+#define VO_CSR_reg                                                                   0xD8005AD4
+#define set_VO_CSR_reg(data)   (*((volatile unsigned int*) VO_CSR_reg)=data)
+#define get_VO_CSR_reg   (*((volatile unsigned int*) VO_CSR_reg))
+#define VO_CSR_inst_adr                                                              "0x00B5"
+#define VO_CSR_inst                                                                  0x00B5
+#define VO_CSR_d3_dbh_shift                                                          (12)
+#define VO_CSR_d3_dbh_mask                                                           (0x00001000)
+#define VO_CSR_d3_dbh(data)                                                          (0x00001000&((data)<<12))
+#define VO_CSR_d3_dbh_src(data)                                                      ((0x00001000&(data))>>12)
+#define VO_CSR_get_d3_dbh(data)                                                      ((0x00001000&(data))>>12)
+#define VO_CSR_d3_dbw_shift                                                          (11)
+#define VO_CSR_d3_dbw_mask                                                           (0x00000800)
+#define VO_CSR_d3_dbw(data)                                                          (0x00000800&((data)<<11))
+#define VO_CSR_d3_dbw_src(data)                                                      ((0x00000800&(data))>>11)
+#define VO_CSR_get_d3_dbw(data)                                                      ((0x00000800&(data))>>11)
+#define VO_CSR_fetch_1080i_shift                                                     (9)
+#define VO_CSR_fetch_1080i_mask                                                      (0x00000200)
+#define VO_CSR_fetch_1080i(data)                                                     (0x00000200&((data)<<9))
+#define VO_CSR_fetch_1080i_src(data)                                                 ((0x00000200&(data))>>9)
+#define VO_CSR_get_fetch_1080i(data)                                                 ((0x00000200&(data))>>9)
+#define VO_CSR_odd_1080i_shift                                                       (8)
+#define VO_CSR_odd_1080i_mask                                                        (0x00000100)
+#define VO_CSR_odd_1080i(data)                                                       (0x00000100&((data)<<8))
+#define VO_CSR_odd_1080i_src(data)                                                   ((0x00000100&(data))>>8)
+#define VO_CSR_get_odd_1080i(data)                                                   ((0x00000100&(data))>>8)
+#define VO_CSR_m4bit_shift                                                           (6)
+#define VO_CSR_m4bit_mask                                                            (0x00000040)
+#define VO_CSR_m4bit(data)                                                           (0x00000040&((data)<<6))
+#define VO_CSR_m4bit_src(data)                                                       ((0x00000040&(data))>>6)
+#define VO_CSR_get_m4bit(data)                                                       ((0x00000040&(data))>>6)
+#define VO_CSR_m2bit_shift                                                           (5)
+#define VO_CSR_m2bit_mask                                                            (0x00000020)
+#define VO_CSR_m2bit(data)                                                           (0x00000020&((data)<<5))
+#define VO_CSR_m2bit_src(data)                                                       ((0x00000020&(data))>>5)
+#define VO_CSR_get_m2bit(data)                                                       ((0x00000020&(data))>>5)
+#define VO_CSR_reload_shift                                                          (4)
+#define VO_CSR_reload_mask                                                           (0x00000010)
+#define VO_CSR_reload(data)                                                          (0x00000010&((data)<<4))
+#define VO_CSR_reload_src(data)                                                      ((0x00000010&(data))>>4)
+#define VO_CSR_get_reload(data)                                                      ((0x00000010&(data))>>4)
+#define VO_CSR_update_shift                                                          (3)
+#define VO_CSR_update_mask                                                           (0x00000008)
+#define VO_CSR_update(data)                                                          (0x00000008&((data)<<3))
+#define VO_CSR_update_src(data)                                                      ((0x00000008&(data))>>3)
+#define VO_CSR_get_update(data)                                                      ((0x00000008&(data))>>3)
+#define VO_CSR_write_data_shift                                                      (0)
+#define VO_CSR_write_data_mask                                                       (0x00000001)
+#define VO_CSR_write_data(data)                                                      (0x00000001&((data)<<0))
+#define VO_CSR_write_data_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_CSR_get_write_data(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_CSR_SIZE                                                                  0x98005AD8
+#define VO_CSR_SIZE_reg_addr                                                         "0xD8005AD8"
+#define VO_CSR_SIZE_reg                                                              0xD8005AD8
+#define set_VO_CSR_SIZE_reg(data)   (*((volatile unsigned int*) VO_CSR_SIZE_reg)=data)
+#define get_VO_CSR_SIZE_reg   (*((volatile unsigned int*) VO_CSR_SIZE_reg))
+#define VO_CSR_SIZE_inst_adr                                                         "0x00B6"
+#define VO_CSR_SIZE_inst                                                             0x00B6
+#define VO_CSR_SIZE_w_shift                                                          (12)
+#define VO_CSR_SIZE_w_mask                                                           (0x001FF000)
+#define VO_CSR_SIZE_w(data)                                                          (0x001FF000&((data)<<12))
+#define VO_CSR_SIZE_w_src(data)                                                      ((0x001FF000&(data))>>12)
+#define VO_CSR_SIZE_get_w(data)                                                      ((0x001FF000&(data))>>12)
+#define VO_CSR_SIZE_h_shift                                                          (0)
+#define VO_CSR_SIZE_h_mask                                                           (0x000001FF)
+#define VO_CSR_SIZE_h(data)                                                          (0x000001FF&((data)<<0))
+#define VO_CSR_SIZE_h_src(data)                                                      ((0x000001FF&(data))>>0)
+#define VO_CSR_SIZE_get_h(data)                                                      ((0x000001FF&(data))>>0)
+
+
+#define VO_CSR_BS                                                                    0x98005ADC
+#define VO_CSR_BS_reg_addr                                                           "0xD8005ADC"
+#define VO_CSR_BS_reg                                                                0xD8005ADC
+#define set_VO_CSR_BS_reg(data)   (*((volatile unsigned int*) VO_CSR_BS_reg)=data)
+#define get_VO_CSR_BS_reg   (*((volatile unsigned int*) VO_CSR_BS_reg))
+#define VO_CSR_BS_inst_adr                                                           "0x00B7"
+#define VO_CSR_BS_inst                                                               0x00B7
+#define VO_CSR_BS_a_shift                                                            (0)
+#define VO_CSR_BS_a_mask                                                             (0xFFFFFFFF)
+#define VO_CSR_BS_a(data)                                                            (0xFFFFFFFF&((data)<<0))
+#define VO_CSR_BS_a_src(data)                                                        ((0xFFFFFFFF&(data))>>0)
+#define VO_CSR_BS_get_a(data)                                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_CSR_BS_3D                                                                 0x98005AE0
+#define VO_CSR_BS_3D_reg_addr                                                        "0xD8005AE0"
+#define VO_CSR_BS_3D_reg                                                             0xD8005AE0
+#define set_VO_CSR_BS_3D_reg(data)   (*((volatile unsigned int*) VO_CSR_BS_3D_reg)=data)
+#define get_VO_CSR_BS_3D_reg   (*((volatile unsigned int*) VO_CSR_BS_3D_reg))
+#define VO_CSR_BS_3D_inst_adr                                                        "0x00B8"
+#define VO_CSR_BS_3D_inst                                                            0x00B8
+#define VO_CSR_BS_3D_a_shift                                                         (0)
+#define VO_CSR_BS_3D_a_mask                                                          (0xFFFFFFFF)
+#define VO_CSR_BS_3D_a(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define VO_CSR_BS_3D_a_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define VO_CSR_BS_3D_get_a(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_CSR_CLUT                                                                  0x98005AE4
+#define VO_CSR_CLUT_reg_addr                                                         "0xD8005AE4"
+#define VO_CSR_CLUT_reg                                                              0xD8005AE4
+#define set_VO_CSR_CLUT_reg(data)   (*((volatile unsigned int*) VO_CSR_CLUT_reg)=data)
+#define get_VO_CSR_CLUT_reg   (*((volatile unsigned int*) VO_CSR_CLUT_reg))
+#define VO_CSR_CLUT_inst_adr                                                         "0x00B9"
+#define VO_CSR_CLUT_inst                                                             0x00B9
+#define VO_CSR_CLUT_a_shift                                                          (0)
+#define VO_CSR_CLUT_a_mask                                                           (0xFFFFFFFF)
+#define VO_CSR_CLUT_a(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define VO_CSR_CLUT_a_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define VO_CSR_CLUT_get_a(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_DDWB                                                                      0x98005AE8
+#define VO_DDWB_reg_addr                                                             "0xD8005AE8"
+#define VO_DDWB_reg                                                                  0xD8005AE8
+#define set_VO_DDWB_reg(data)   (*((volatile unsigned int*) VO_DDWB_reg)=data)
+#define get_VO_DDWB_reg   (*((volatile unsigned int*) VO_DDWB_reg))
+#define VO_DDWB_inst_adr                                                             "0x00BA"
+#define VO_DDWB_inst                                                                 0x00BA
+#define VO_DDWB_wb_mode_10b_shift                                                    (18)
+#define VO_DDWB_wb_mode_10b_mask                                                     (0x00040000)
+#define VO_DDWB_wb_mode_10b(data)                                                    (0x00040000&((data)<<18))
+#define VO_DDWB_wb_mode_10b_src(data)                                                ((0x00040000&(data))>>18)
+#define VO_DDWB_get_wb_mode_10b(data)                                                ((0x00040000&(data))>>18)
+#define VO_DDWB_wb_ppc10b_shift                                                      (17)
+#define VO_DDWB_wb_ppc10b_mask                                                       (0x00020000)
+#define VO_DDWB_wb_ppc10b(data)                                                      (0x00020000&((data)<<17))
+#define VO_DDWB_wb_ppc10b_src(data)                                                  ((0x00020000&(data))>>17)
+#define VO_DDWB_get_wb_ppc10b(data)                                                  ((0x00020000&(data))>>17)
+#define VO_DDWB_wb_tr_shift                                                          (16)
+#define VO_DDWB_wb_tr_mask                                                           (0x00010000)
+#define VO_DDWB_wb_tr(data)                                                          (0x00010000&((data)<<16))
+#define VO_DDWB_wb_tr_src(data)                                                      ((0x00010000&(data))>>16)
+#define VO_DDWB_get_wb_tr(data)                                                      ((0x00010000&(data))>>16)
+#define VO_DDWB_dd_nv21_shift                                                        (15)
+#define VO_DDWB_dd_nv21_mask                                                         (0x00008000)
+#define VO_DDWB_dd_nv21(data)                                                        (0x00008000&((data)<<15))
+#define VO_DDWB_dd_nv21_src(data)                                                    ((0x00008000&(data))>>15)
+#define VO_DDWB_get_dd_nv21(data)                                                    ((0x00008000&(data))>>15)
+#define VO_DDWB_wb_nv21_shift                                                        (14)
+#define VO_DDWB_wb_nv21_mask                                                         (0x00004000)
+#define VO_DDWB_wb_nv21(data)                                                        (0x00004000&((data)<<14))
+#define VO_DDWB_wb_nv21_src(data)                                                    ((0x00004000&(data))>>14)
+#define VO_DDWB_get_wb_nv21(data)                                                    ((0x00004000&(data))>>14)
+#define VO_DDWB_dd_seq_shift                                                         (13)
+#define VO_DDWB_dd_seq_mask                                                          (0x00002000)
+#define VO_DDWB_dd_seq(data)                                                         (0x00002000&((data)<<13))
+#define VO_DDWB_dd_seq_src(data)                                                     ((0x00002000&(data))>>13)
+#define VO_DDWB_get_dd_seq(data)                                                     ((0x00002000&(data))>>13)
+#define VO_DDWB_wb_seq_shift                                                         (12)
+#define VO_DDWB_wb_seq_mask                                                          (0x00001000)
+#define VO_DDWB_wb_seq(data)                                                         (0x00001000&((data)<<12))
+#define VO_DDWB_wb_seq_src(data)                                                     ((0x00001000&(data))>>12)
+#define VO_DDWB_get_wb_seq(data)                                                     ((0x00001000&(data))>>12)
+#define VO_DDWB_h2v_shift                                                            (11)
+#define VO_DDWB_h2v_mask                                                             (0x00000800)
+#define VO_DDWB_h2v(data)                                                            (0x00000800&((data)<<11))
+#define VO_DDWB_h2v_src(data)                                                        ((0x00000800&(data))>>11)
+#define VO_DDWB_get_h2v(data)                                                        ((0x00000800&(data))>>11)
+#define VO_DDWB_hd_shift                                                             (10)
+#define VO_DDWB_hd_mask                                                              (0x00000400)
+#define VO_DDWB_hd(data)                                                             (0x00000400&((data)<<10))
+#define VO_DDWB_hd_src(data)                                                         ((0x00000400&(data))>>10)
+#define VO_DDWB_get_hd(data)                                                         ((0x00000400&(data))>>10)
+#define VO_DDWB_f422_shift                                                           (9)
+#define VO_DDWB_f422_mask                                                            (0x00000200)
+#define VO_DDWB_f422(data)                                                           (0x00000200&((data)<<9))
+#define VO_DDWB_f422_src(data)                                                       ((0x00000200&(data))>>9)
+#define VO_DDWB_get_f422(data)                                                       ((0x00000200&(data))>>9)
+#define VO_DDWB_reint_shift                                                          (8)
+#define VO_DDWB_reint_mask                                                           (0x00000100)
+#define VO_DDWB_reint(data)                                                          (0x00000100&((data)<<8))
+#define VO_DDWB_reint_src(data)                                                      ((0x00000100&(data))>>8)
+#define VO_DDWB_get_reint(data)                                                      ((0x00000100&(data))>>8)
+#define VO_DDWB_bot_shift                                                            (7)
+#define VO_DDWB_bot_mask                                                             (0x00000080)
+#define VO_DDWB_bot(data)                                                            (0x00000080&((data)<<7))
+#define VO_DDWB_bot_src(data)                                                        ((0x00000080&(data))>>7)
+#define VO_DDWB_get_bot(data)                                                        ((0x00000080&(data))>>7)
+#define VO_DDWB_wb_f420_shift                                                        (6)
+#define VO_DDWB_wb_f420_mask                                                         (0x00000040)
+#define VO_DDWB_wb_f420(data)                                                        (0x00000040&((data)<<6))
+#define VO_DDWB_wb_f420_src(data)                                                    ((0x00000040&(data))>>6)
+#define VO_DDWB_get_wb_f420(data)                                                    ((0x00000040&(data))>>6)
+#define VO_DDWB_vs_yodd_shift                                                        (5)
+#define VO_DDWB_vs_yodd_mask                                                         (0x00000020)
+#define VO_DDWB_vs_yodd(data)                                                        (0x00000020&((data)<<5))
+#define VO_DDWB_vs_yodd_src(data)                                                    ((0x00000020&(data))>>5)
+#define VO_DDWB_get_vs_yodd(data)                                                    ((0x00000020&(data))>>5)
+#define VO_DDWB_vs_codd_shift                                                        (4)
+#define VO_DDWB_vs_codd_mask                                                         (0x00000010)
+#define VO_DDWB_vs_codd(data)                                                        (0x00000010&((data)<<4))
+#define VO_DDWB_vs_codd_src(data)                                                    ((0x00000010&(data))>>4)
+#define VO_DDWB_get_vs_codd(data)                                                    ((0x00000010&(data))>>4)
+#define VO_DDWB_hs_yodd_shift                                                        (2)
+#define VO_DDWB_hs_yodd_mask                                                         (0x00000004)
+#define VO_DDWB_hs_yodd(data)                                                        (0x00000004&((data)<<2))
+#define VO_DDWB_hs_yodd_src(data)                                                    ((0x00000004&(data))>>2)
+#define VO_DDWB_get_hs_yodd(data)                                                    ((0x00000004&(data))>>2)
+#define VO_DDWB_hs_codd_shift                                                        (1)
+#define VO_DDWB_hs_codd_mask                                                         (0x00000002)
+#define VO_DDWB_hs_codd(data)                                                        (0x00000002&((data)<<1))
+#define VO_DDWB_hs_codd_src(data)                                                    ((0x00000002&(data))>>1)
+#define VO_DDWB_get_hs_codd(data)                                                    ((0x00000002&(data))>>1)
+#define VO_DDWB_write_data_shift                                                     (0)
+#define VO_DDWB_write_data_mask                                                      (0x00000001)
+#define VO_DDWB_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_DDWB_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_DDWB_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_DDWB_SEL                                                                  0x98005AEC
+#define VO_DDWB_SEL_reg_addr                                                         "0xD8005AEC"
+#define VO_DDWB_SEL_reg                                                              0xD8005AEC
+#define set_VO_DDWB_SEL_reg(data)   (*((volatile unsigned int*) VO_DDWB_SEL_reg)=data)
+#define get_VO_DDWB_SEL_reg   (*((volatile unsigned int*) VO_DDWB_SEL_reg))
+#define VO_DDWB_SEL_inst_adr                                                         "0x00BB"
+#define VO_DDWB_SEL_inst                                                             0x00BB
+#define VO_DDWB_SEL_write_en2_shift                                                  (6)
+#define VO_DDWB_SEL_write_en2_mask                                                   (0x00000040)
+#define VO_DDWB_SEL_write_en2(data)                                                  (0x00000040&((data)<<6))
+#define VO_DDWB_SEL_write_en2_src(data)                                              ((0x00000040&(data))>>6)
+#define VO_DDWB_SEL_get_write_en2(data)                                              ((0x00000040&(data))>>6)
+#define VO_DDWB_SEL_hs_sel_shift                                                     (4)
+#define VO_DDWB_SEL_hs_sel_mask                                                      (0x00000030)
+#define VO_DDWB_SEL_hs_sel(data)                                                     (0x00000030&((data)<<4))
+#define VO_DDWB_SEL_hs_sel_src(data)                                                 ((0x00000030&(data))>>4)
+#define VO_DDWB_SEL_get_hs_sel(data)                                                 ((0x00000030&(data))>>4)
+#define VO_DDWB_SEL_write_en1_shift                                                  (2)
+#define VO_DDWB_SEL_write_en1_mask                                                   (0x00000004)
+#define VO_DDWB_SEL_write_en1(data)                                                  (0x00000004&((data)<<2))
+#define VO_DDWB_SEL_write_en1_src(data)                                              ((0x00000004&(data))>>2)
+#define VO_DDWB_SEL_get_write_en1(data)                                              ((0x00000004&(data))>>2)
+#define VO_DDWB_SEL_vs_sel_shift                                                     (0)
+#define VO_DDWB_SEL_vs_sel_mask                                                      (0x00000003)
+#define VO_DDWB_SEL_vs_sel(data)                                                     (0x00000003&((data)<<0))
+#define VO_DDWB_SEL_vs_sel_src(data)                                                 ((0x00000003&(data))>>0)
+#define VO_DDWB_SEL_get_vs_sel(data)                                                 ((0x00000003&(data))>>0)
+
+
+#define VO_DD_INDEX                                                                  0x98005AF0
+#define VO_DD_INDEX_reg_addr                                                         "0xD8005AF0"
+#define VO_DD_INDEX_reg                                                              0xD8005AF0
+#define set_VO_DD_INDEX_reg(data)   (*((volatile unsigned int*) VO_DD_INDEX_reg)=data)
+#define get_VO_DD_INDEX_reg   (*((volatile unsigned int*) VO_DD_INDEX_reg))
+#define VO_DD_INDEX_inst_adr                                                         "0x00BC"
+#define VO_DD_INDEX_inst                                                             0x00BC
+#define VO_DD_INDEX_write_en5_shift                                                  (27)
+#define VO_DD_INDEX_write_en5_mask                                                   (0x08000000)
+#define VO_DD_INDEX_write_en5(data)                                                  (0x08000000&((data)<<27))
+#define VO_DD_INDEX_write_en5_src(data)                                              ((0x08000000&(data))>>27)
+#define VO_DD_INDEX_get_write_en5(data)                                              ((0x08000000&(data))>>27)
+#define VO_DD_INDEX_interlace_shift                                                  (26)
+#define VO_DD_INDEX_interlace_mask                                                   (0x04000000)
+#define VO_DD_INDEX_interlace(data)                                                  (0x04000000&((data)<<26))
+#define VO_DD_INDEX_interlace_src(data)                                              ((0x04000000&(data))>>26)
+#define VO_DD_INDEX_get_interlace(data)                                              ((0x04000000&(data))>>26)
+#define VO_DD_INDEX_write_en4_shift                                                  (25)
+#define VO_DD_INDEX_write_en4_mask                                                   (0x02000000)
+#define VO_DD_INDEX_write_en4(data)                                                  (0x02000000&((data)<<25))
+#define VO_DD_INDEX_write_en4_src(data)                                              ((0x02000000&(data))>>25)
+#define VO_DD_INDEX_get_write_en4(data)                                              ((0x02000000&(data))>>25)
+#define VO_DD_INDEX_bot_shift                                                        (24)
+#define VO_DD_INDEX_bot_mask                                                         (0x01000000)
+#define VO_DD_INDEX_bot(data)                                                        (0x01000000&((data)<<24))
+#define VO_DD_INDEX_bot_src(data)                                                    ((0x01000000&(data))>>24)
+#define VO_DD_INDEX_get_bot(data)                                                    ((0x01000000&(data))>>24)
+#define VO_DD_INDEX_write_en2_shift                                                  (15)
+#define VO_DD_INDEX_write_en2_mask                                                   (0x00008000)
+#define VO_DD_INDEX_write_en2(data)                                                  (0x00008000&((data)<<15))
+#define VO_DD_INDEX_write_en2_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_DD_INDEX_get_write_en2(data)                                              ((0x00008000&(data))>>15)
+#define VO_DD_INDEX_c_shift                                                          (8)
+#define VO_DD_INDEX_c_mask                                                           (0x00007F00)
+#define VO_DD_INDEX_c(data)                                                          (0x00007F00&((data)<<8))
+#define VO_DD_INDEX_c_src(data)                                                      ((0x00007F00&(data))>>8)
+#define VO_DD_INDEX_get_c(data)                                                      ((0x00007F00&(data))>>8)
+#define VO_DD_INDEX_write_en1_shift                                                  (7)
+#define VO_DD_INDEX_write_en1_mask                                                   (0x00000080)
+#define VO_DD_INDEX_write_en1(data)                                                  (0x00000080&((data)<<7))
+#define VO_DD_INDEX_write_en1_src(data)                                              ((0x00000080&(data))>>7)
+#define VO_DD_INDEX_get_write_en1(data)                                              ((0x00000080&(data))>>7)
+#define VO_DD_INDEX_y_shift                                                          (0)
+#define VO_DD_INDEX_y_mask                                                           (0x0000007F)
+#define VO_DD_INDEX_y(data)                                                          (0x0000007F&((data)<<0))
+#define VO_DD_INDEX_y_src(data)                                                      ((0x0000007F&(data))>>0)
+#define VO_DD_INDEX_get_y(data)                                                      ((0x0000007F&(data))>>0)
+
+
+#define VO_DD_SEQ_SA_Y                                                               0x98005AF4
+#define VO_DD_SEQ_SA_Y_reg_addr                                                      "0xD8005AF4"
+#define VO_DD_SEQ_SA_Y_reg                                                           0xD8005AF4
+#define set_VO_DD_SEQ_SA_Y_reg(data)   (*((volatile unsigned int*) VO_DD_SEQ_SA_Y_reg)=data)
+#define get_VO_DD_SEQ_SA_Y_reg   (*((volatile unsigned int*) VO_DD_SEQ_SA_Y_reg))
+#define VO_DD_SEQ_SA_Y_inst_adr                                                      "0x00BD"
+#define VO_DD_SEQ_SA_Y_inst                                                          0x00BD
+#define VO_DD_SEQ_SA_Y_a_shift                                                       (0)
+#define VO_DD_SEQ_SA_Y_a_mask                                                        (0xFFFFFFFF)
+#define VO_DD_SEQ_SA_Y_a(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define VO_DD_SEQ_SA_Y_a_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define VO_DD_SEQ_SA_Y_get_a(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_DD_SEQ_PITCH_Y                                                            0x98005AF8
+#define VO_DD_SEQ_PITCH_Y_reg_addr                                                   "0xD8005AF8"
+#define VO_DD_SEQ_PITCH_Y_reg                                                        0xD8005AF8
+#define set_VO_DD_SEQ_PITCH_Y_reg(data)   (*((volatile unsigned int*) VO_DD_SEQ_PITCH_Y_reg)=data)
+#define get_VO_DD_SEQ_PITCH_Y_reg   (*((volatile unsigned int*) VO_DD_SEQ_PITCH_Y_reg))
+#define VO_DD_SEQ_PITCH_Y_inst_adr                                                   "0x00BE"
+#define VO_DD_SEQ_PITCH_Y_inst                                                       0x00BE
+#define VO_DD_SEQ_PITCH_Y_p_shift                                                    (0)
+#define VO_DD_SEQ_PITCH_Y_p_mask                                                     (0x0000FFFF)
+#define VO_DD_SEQ_PITCH_Y_p(data)                                                    (0x0000FFFF&((data)<<0))
+#define VO_DD_SEQ_PITCH_Y_p_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define VO_DD_SEQ_PITCH_Y_get_p(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define VO_DD_SEQ_SA_C                                                               0x98005AFC
+#define VO_DD_SEQ_SA_C_reg_addr                                                      "0xD8005AFC"
+#define VO_DD_SEQ_SA_C_reg                                                           0xD8005AFC
+#define set_VO_DD_SEQ_SA_C_reg(data)   (*((volatile unsigned int*) VO_DD_SEQ_SA_C_reg)=data)
+#define get_VO_DD_SEQ_SA_C_reg   (*((volatile unsigned int*) VO_DD_SEQ_SA_C_reg))
+#define VO_DD_SEQ_SA_C_inst_adr                                                      "0x00BF"
+#define VO_DD_SEQ_SA_C_inst                                                          0x00BF
+#define VO_DD_SEQ_SA_C_a_shift                                                       (0)
+#define VO_DD_SEQ_SA_C_a_mask                                                        (0xFFFFFFFF)
+#define VO_DD_SEQ_SA_C_a(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define VO_DD_SEQ_SA_C_a_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define VO_DD_SEQ_SA_C_get_a(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_DD_SEQ_PITCH_C                                                            0x98005B00
+#define VO_DD_SEQ_PITCH_C_reg_addr                                                   "0xD8005B00"
+#define VO_DD_SEQ_PITCH_C_reg                                                        0xD8005B00
+#define set_VO_DD_SEQ_PITCH_C_reg(data)   (*((volatile unsigned int*) VO_DD_SEQ_PITCH_C_reg)=data)
+#define get_VO_DD_SEQ_PITCH_C_reg   (*((volatile unsigned int*) VO_DD_SEQ_PITCH_C_reg))
+#define VO_DD_SEQ_PITCH_C_inst_adr                                                   "0x00C0"
+#define VO_DD_SEQ_PITCH_C_inst                                                       0x00C0
+#define VO_DD_SEQ_PITCH_C_p_shift                                                    (0)
+#define VO_DD_SEQ_PITCH_C_p_mask                                                     (0x0000FFFF)
+#define VO_DD_SEQ_PITCH_C_p(data)                                                    (0x0000FFFF&((data)<<0))
+#define VO_DD_SEQ_PITCH_C_p_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define VO_DD_SEQ_PITCH_C_get_p(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define VO_WB_INDEX                                                                  0x98005B04
+#define VO_WB_INDEX_reg_addr                                                         "0xD8005B04"
+#define VO_WB_INDEX_reg                                                              0xD8005B04
+#define set_VO_WB_INDEX_reg(data)   (*((volatile unsigned int*) VO_WB_INDEX_reg)=data)
+#define get_VO_WB_INDEX_reg   (*((volatile unsigned int*) VO_WB_INDEX_reg))
+#define VO_WB_INDEX_inst_adr                                                         "0x00C1"
+#define VO_WB_INDEX_inst                                                             0x00C1
+#define VO_WB_INDEX_write_en5_shift                                                  (27)
+#define VO_WB_INDEX_write_en5_mask                                                   (0x08000000)
+#define VO_WB_INDEX_write_en5(data)                                                  (0x08000000&((data)<<27))
+#define VO_WB_INDEX_write_en5_src(data)                                              ((0x08000000&(data))>>27)
+#define VO_WB_INDEX_get_write_en5(data)                                              ((0x08000000&(data))>>27)
+#define VO_WB_INDEX_interlace_shift                                                  (26)
+#define VO_WB_INDEX_interlace_mask                                                   (0x04000000)
+#define VO_WB_INDEX_interlace(data)                                                  (0x04000000&((data)<<26))
+#define VO_WB_INDEX_interlace_src(data)                                              ((0x04000000&(data))>>26)
+#define VO_WB_INDEX_get_interlace(data)                                              ((0x04000000&(data))>>26)
+#define VO_WB_INDEX_write_en4_shift                                                  (25)
+#define VO_WB_INDEX_write_en4_mask                                                   (0x02000000)
+#define VO_WB_INDEX_write_en4(data)                                                  (0x02000000&((data)<<25))
+#define VO_WB_INDEX_write_en4_src(data)                                              ((0x02000000&(data))>>25)
+#define VO_WB_INDEX_get_write_en4(data)                                              ((0x02000000&(data))>>25)
+#define VO_WB_INDEX_bot_shift                                                        (24)
+#define VO_WB_INDEX_bot_mask                                                         (0x01000000)
+#define VO_WB_INDEX_bot(data)                                                        (0x01000000&((data)<<24))
+#define VO_WB_INDEX_bot_src(data)                                                    ((0x01000000&(data))>>24)
+#define VO_WB_INDEX_get_bot(data)                                                    ((0x01000000&(data))>>24)
+#define VO_WB_INDEX_write_en2_shift                                                  (15)
+#define VO_WB_INDEX_write_en2_mask                                                   (0x00008000)
+#define VO_WB_INDEX_write_en2(data)                                                  (0x00008000&((data)<<15))
+#define VO_WB_INDEX_write_en2_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_WB_INDEX_get_write_en2(data)                                              ((0x00008000&(data))>>15)
+#define VO_WB_INDEX_c_shift                                                          (8)
+#define VO_WB_INDEX_c_mask                                                           (0x00007F00)
+#define VO_WB_INDEX_c(data)                                                          (0x00007F00&((data)<<8))
+#define VO_WB_INDEX_c_src(data)                                                      ((0x00007F00&(data))>>8)
+#define VO_WB_INDEX_get_c(data)                                                      ((0x00007F00&(data))>>8)
+#define VO_WB_INDEX_write_en1_shift                                                  (7)
+#define VO_WB_INDEX_write_en1_mask                                                   (0x00000080)
+#define VO_WB_INDEX_write_en1(data)                                                  (0x00000080&((data)<<7))
+#define VO_WB_INDEX_write_en1_src(data)                                              ((0x00000080&(data))>>7)
+#define VO_WB_INDEX_get_write_en1(data)                                              ((0x00000080&(data))>>7)
+#define VO_WB_INDEX_y_shift                                                          (0)
+#define VO_WB_INDEX_y_mask                                                           (0x0000007F)
+#define VO_WB_INDEX_y(data)                                                          (0x0000007F&((data)<<0))
+#define VO_WB_INDEX_y_src(data)                                                      ((0x0000007F&(data))>>0)
+#define VO_WB_INDEX_get_y(data)                                                      ((0x0000007F&(data))>>0)
+
+
+#define VO_WB_SEQ_SA_Y                                                               0x98005B08
+#define VO_WB_SEQ_SA_Y_reg_addr                                                      "0xD8005B08"
+#define VO_WB_SEQ_SA_Y_reg                                                           0xD8005B08
+#define set_VO_WB_SEQ_SA_Y_reg(data)   (*((volatile unsigned int*) VO_WB_SEQ_SA_Y_reg)=data)
+#define get_VO_WB_SEQ_SA_Y_reg   (*((volatile unsigned int*) VO_WB_SEQ_SA_Y_reg))
+#define VO_WB_SEQ_SA_Y_inst_adr                                                      "0x00C2"
+#define VO_WB_SEQ_SA_Y_inst                                                          0x00C2
+#define VO_WB_SEQ_SA_Y_a_shift                                                       (0)
+#define VO_WB_SEQ_SA_Y_a_mask                                                        (0xFFFFFFFF)
+#define VO_WB_SEQ_SA_Y_a(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define VO_WB_SEQ_SA_Y_a_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define VO_WB_SEQ_SA_Y_get_a(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_WB_SEQ_PITCH_Y                                                            0x98005B0C
+#define VO_WB_SEQ_PITCH_Y_reg_addr                                                   "0xD8005B0C"
+#define VO_WB_SEQ_PITCH_Y_reg                                                        0xD8005B0C
+#define set_VO_WB_SEQ_PITCH_Y_reg(data)   (*((volatile unsigned int*) VO_WB_SEQ_PITCH_Y_reg)=data)
+#define get_VO_WB_SEQ_PITCH_Y_reg   (*((volatile unsigned int*) VO_WB_SEQ_PITCH_Y_reg))
+#define VO_WB_SEQ_PITCH_Y_inst_adr                                                   "0x00C3"
+#define VO_WB_SEQ_PITCH_Y_inst                                                       0x00C3
+#define VO_WB_SEQ_PITCH_Y_p_shift                                                    (0)
+#define VO_WB_SEQ_PITCH_Y_p_mask                                                     (0x0000FFFF)
+#define VO_WB_SEQ_PITCH_Y_p(data)                                                    (0x0000FFFF&((data)<<0))
+#define VO_WB_SEQ_PITCH_Y_p_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define VO_WB_SEQ_PITCH_Y_get_p(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define VO_WB_SEQ_SA_C                                                               0x98005B10
+#define VO_WB_SEQ_SA_C_reg_addr                                                      "0xD8005B10"
+#define VO_WB_SEQ_SA_C_reg                                                           0xD8005B10
+#define set_VO_WB_SEQ_SA_C_reg(data)   (*((volatile unsigned int*) VO_WB_SEQ_SA_C_reg)=data)
+#define get_VO_WB_SEQ_SA_C_reg   (*((volatile unsigned int*) VO_WB_SEQ_SA_C_reg))
+#define VO_WB_SEQ_SA_C_inst_adr                                                      "0x00C4"
+#define VO_WB_SEQ_SA_C_inst                                                          0x00C4
+#define VO_WB_SEQ_SA_C_a_shift                                                       (0)
+#define VO_WB_SEQ_SA_C_a_mask                                                        (0xFFFFFFFF)
+#define VO_WB_SEQ_SA_C_a(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define VO_WB_SEQ_SA_C_a_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define VO_WB_SEQ_SA_C_get_a(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_WB_SEQ_PITCH_C                                                            0x98005B14
+#define VO_WB_SEQ_PITCH_C_reg_addr                                                   "0xD8005B14"
+#define VO_WB_SEQ_PITCH_C_reg                                                        0xD8005B14
+#define set_VO_WB_SEQ_PITCH_C_reg(data)   (*((volatile unsigned int*) VO_WB_SEQ_PITCH_C_reg)=data)
+#define get_VO_WB_SEQ_PITCH_C_reg   (*((volatile unsigned int*) VO_WB_SEQ_PITCH_C_reg))
+#define VO_WB_SEQ_PITCH_C_inst_adr                                                   "0x00C5"
+#define VO_WB_SEQ_PITCH_C_inst                                                       0x00C5
+#define VO_WB_SEQ_PITCH_C_p_shift                                                    (0)
+#define VO_WB_SEQ_PITCH_C_p_mask                                                     (0x0000FFFF)
+#define VO_WB_SEQ_PITCH_C_p(data)                                                    (0x0000FFFF&((data)<<0))
+#define VO_WB_SEQ_PITCH_C_p_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define VO_WB_SEQ_PITCH_C_get_p(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define VO_DD_SIZE                                                                   0x98005B18
+#define VO_DD_SIZE_reg_addr                                                          "0xD8005B18"
+#define VO_DD_SIZE_reg                                                               0xD8005B18
+#define set_VO_DD_SIZE_reg(data)   (*((volatile unsigned int*) VO_DD_SIZE_reg)=data)
+#define get_VO_DD_SIZE_reg   (*((volatile unsigned int*) VO_DD_SIZE_reg))
+#define VO_DD_SIZE_inst_adr                                                          "0x00C6"
+#define VO_DD_SIZE_inst                                                              0x00C6
+#define VO_DD_SIZE_w_shift                                                           (12)
+#define VO_DD_SIZE_w_mask                                                            (0x01FFF000)
+#define VO_DD_SIZE_w(data)                                                           (0x01FFF000&((data)<<12))
+#define VO_DD_SIZE_w_src(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_DD_SIZE_get_w(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_DD_SIZE_h_shift                                                           (0)
+#define VO_DD_SIZE_h_mask                                                            (0x00000FFF)
+#define VO_DD_SIZE_h(data)                                                           (0x00000FFF&((data)<<0))
+#define VO_DD_SIZE_h_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VO_DD_SIZE_get_h(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VO_WB_SIZE                                                                   0x98005B1C
+#define VO_WB_SIZE_reg_addr                                                          "0xD8005B1C"
+#define VO_WB_SIZE_reg                                                               0xD8005B1C
+#define set_VO_WB_SIZE_reg(data)   (*((volatile unsigned int*) VO_WB_SIZE_reg)=data)
+#define get_VO_WB_SIZE_reg   (*((volatile unsigned int*) VO_WB_SIZE_reg))
+#define VO_WB_SIZE_inst_adr                                                          "0x00C7"
+#define VO_WB_SIZE_inst                                                              0x00C7
+#define VO_WB_SIZE_w_shift                                                           (12)
+#define VO_WB_SIZE_w_mask                                                            (0x01FFF000)
+#define VO_WB_SIZE_w(data)                                                           (0x01FFF000&((data)<<12))
+#define VO_WB_SIZE_w_src(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_WB_SIZE_get_w(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_WB_SIZE_h_shift                                                           (0)
+#define VO_WB_SIZE_h_mask                                                            (0x00000FFF)
+#define VO_WB_SIZE_h(data)                                                           (0x00000FFF&((data)<<0))
+#define VO_WB_SIZE_h_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VO_WB_SIZE_get_h(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VO_FS_SIZE                                                                   0x98005B20
+#define VO_FS_SIZE_reg_addr                                                          "0xD8005B20"
+#define VO_FS_SIZE_reg                                                               0xD8005B20
+#define set_VO_FS_SIZE_reg(data)   (*((volatile unsigned int*) VO_FS_SIZE_reg)=data)
+#define get_VO_FS_SIZE_reg   (*((volatile unsigned int*) VO_FS_SIZE_reg))
+#define VO_FS_SIZE_inst_adr                                                          "0x00C8"
+#define VO_FS_SIZE_inst                                                              0x00C8
+#define VO_FS_SIZE_w_shift                                                           (12)
+#define VO_FS_SIZE_w_mask                                                            (0x01FFF000)
+#define VO_FS_SIZE_w(data)                                                           (0x01FFF000&((data)<<12))
+#define VO_FS_SIZE_w_src(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_FS_SIZE_get_w(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_FS_SIZE_h_shift                                                           (0)
+#define VO_FS_SIZE_h_mask                                                            (0x00000FFF)
+#define VO_FS_SIZE_h(data)                                                           (0x00000FFF&((data)<<0))
+#define VO_FS_SIZE_h_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VO_FS_SIZE_get_h(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VO_WB_TPC                                                                    0x98005B24
+#define VO_WB_TPC_reg_addr                                                           "0xD8005B24"
+#define VO_WB_TPC_reg                                                                0xD8005B24
+#define set_VO_WB_TPC_reg(data)   (*((volatile unsigned int*) VO_WB_TPC_reg)=data)
+#define get_VO_WB_TPC_reg   (*((volatile unsigned int*) VO_WB_TPC_reg))
+#define VO_WB_TPC_inst_adr                                                           "0x00C9"
+#define VO_WB_TPC_inst                                                               0x00C9
+#define VO_WB_TPC_num_shift                                                          (0)
+#define VO_WB_TPC_num_mask                                                           (0x000000FF)
+#define VO_WB_TPC_num(data)                                                          (0x000000FF&((data)<<0))
+#define VO_WB_TPC_num_src(data)                                                      ((0x000000FF&(data))>>0)
+#define VO_WB_TPC_get_num(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define VO_DDWB_VSI                                                                  0x98005B28
+#define VO_DDWB_VSI_reg_addr                                                         "0xD8005B28"
+#define VO_DDWB_VSI_reg                                                              0xD8005B28
+#define set_VO_DDWB_VSI_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSI_reg)=data)
+#define get_VO_DDWB_VSI_reg   (*((volatile unsigned int*) VO_DDWB_VSI_reg))
+#define VO_DDWB_VSI_inst_adr                                                         "0x00CA"
+#define VO_DDWB_VSI_inst                                                             0x00CA
+#define VO_DDWB_VSI_offset_shift                                                     (16)
+#define VO_DDWB_VSI_offset_mask                                                      (0x1FFF0000)
+#define VO_DDWB_VSI_offset(data)                                                     (0x1FFF0000&((data)<<16))
+#define VO_DDWB_VSI_offset_src(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_DDWB_VSI_get_offset(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_DDWB_VSI_phase_shift                                                      (0)
+#define VO_DDWB_VSI_phase_mask                                                       (0x0000FFFF)
+#define VO_DDWB_VSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_DDWB_VSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_DDWB_VSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_DDWB_VSD                                                                  0x98005B2C
+#define VO_DDWB_VSD_reg_addr                                                         "0xD8005B2C"
+#define VO_DDWB_VSD_reg                                                              0xD8005B2C
+#define set_VO_DDWB_VSD_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSD_reg)=data)
+#define get_VO_DDWB_VSD_reg   (*((volatile unsigned int*) VO_DDWB_VSD_reg))
+#define VO_DDWB_VSD_inst_adr                                                         "0x00CB"
+#define VO_DDWB_VSD_inst                                                             0x00CB
+#define VO_DDWB_VSD_delta_shift                                                      (0)
+#define VO_DDWB_VSD_delta_mask                                                       (0x001FFFFF)
+#define VO_DDWB_VSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_DDWB_VSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_DDWB_VSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_DDWB_VSD_H                                                                0x98005B30
+#define VO_DDWB_VSD_H_reg_addr                                                       "0xD8005B30"
+#define VO_DDWB_VSD_H_reg                                                            0xD8005B30
+#define set_VO_DDWB_VSD_H_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSD_H_reg)=data)
+#define get_VO_DDWB_VSD_H_reg   (*((volatile unsigned int*) VO_DDWB_VSD_H_reg))
+#define VO_DDWB_VSD_H_inst_adr                                                       "0x00CC"
+#define VO_DDWB_VSD_H_inst                                                           0x00CC
+#define VO_DDWB_VSD_H_out_shift                                                      (0)
+#define VO_DDWB_VSD_H_out_mask                                                       (0x00000FFF)
+#define VO_DDWB_VSD_H_out(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DDWB_VSD_H_out_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DDWB_VSD_H_get_out(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DDWB_VSYC_0                                                               0x98005B34
+#define VO_DDWB_VSYC_1                                                               0x98005B38
+#define VO_DDWB_VSYC_2                                                               0x98005B3C
+#define VO_DDWB_VSYC_3                                                               0x98005B40
+#define VO_DDWB_VSYC_4                                                               0x98005B44
+#define VO_DDWB_VSYC_5                                                               0x98005B48
+#define VO_DDWB_VSYC_6                                                               0x98005B4C
+#define VO_DDWB_VSYC_7                                                               0x98005B50
+#define VO_DDWB_VSYC_0_reg_addr                                                      "0xD8005B34"
+#define VO_DDWB_VSYC_1_reg_addr                                                      "0xD8005B38"
+#define VO_DDWB_VSYC_2_reg_addr                                                      "0xD8005B3C"
+#define VO_DDWB_VSYC_3_reg_addr                                                      "0xD8005B40"
+#define VO_DDWB_VSYC_4_reg_addr                                                      "0xD8005B44"
+#define VO_DDWB_VSYC_5_reg_addr                                                      "0xD8005B48"
+#define VO_DDWB_VSYC_6_reg_addr                                                      "0xD8005B4C"
+#define VO_DDWB_VSYC_7_reg_addr                                                      "0xD8005B50"
+#define VO_DDWB_VSYC_0_reg                                                           0xD8005B34
+#define VO_DDWB_VSYC_1_reg                                                           0xD8005B38
+#define VO_DDWB_VSYC_2_reg                                                           0xD8005B3C
+#define VO_DDWB_VSYC_3_reg                                                           0xD8005B40
+#define VO_DDWB_VSYC_4_reg                                                           0xD8005B44
+#define VO_DDWB_VSYC_5_reg                                                           0xD8005B48
+#define VO_DDWB_VSYC_6_reg                                                           0xD8005B4C
+#define VO_DDWB_VSYC_7_reg                                                           0xD8005B50
+#define set_VO_DDWB_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_0_reg)=data)
+#define set_VO_DDWB_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_1_reg)=data)
+#define set_VO_DDWB_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_2_reg)=data)
+#define set_VO_DDWB_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_3_reg)=data)
+#define set_VO_DDWB_VSYC_4_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_4_reg)=data)
+#define set_VO_DDWB_VSYC_5_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_5_reg)=data)
+#define set_VO_DDWB_VSYC_6_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_6_reg)=data)
+#define set_VO_DDWB_VSYC_7_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_7_reg)=data)
+#define get_VO_DDWB_VSYC_0_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_0_reg))
+#define get_VO_DDWB_VSYC_1_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_1_reg))
+#define get_VO_DDWB_VSYC_2_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_2_reg))
+#define get_VO_DDWB_VSYC_3_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_3_reg))
+#define get_VO_DDWB_VSYC_4_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_4_reg))
+#define get_VO_DDWB_VSYC_5_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_5_reg))
+#define get_VO_DDWB_VSYC_6_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_6_reg))
+#define get_VO_DDWB_VSYC_7_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_7_reg))
+#define VO_DDWB_VSYC_0_inst_adr                                                      "0x00CD"
+#define VO_DDWB_VSYC_1_inst_adr                                                      "0x00CE"
+#define VO_DDWB_VSYC_2_inst_adr                                                      "0x00CF"
+#define VO_DDWB_VSYC_3_inst_adr                                                      "0x00D0"
+#define VO_DDWB_VSYC_4_inst_adr                                                      "0x00D1"
+#define VO_DDWB_VSYC_5_inst_adr                                                      "0x00D2"
+#define VO_DDWB_VSYC_6_inst_adr                                                      "0x00D3"
+#define VO_DDWB_VSYC_7_inst_adr                                                      "0x00D4"
+#define VO_DDWB_VSYC_0_inst                                                          0x00CD
+#define VO_DDWB_VSYC_1_inst                                                          0x00CE
+#define VO_DDWB_VSYC_2_inst                                                          0x00CF
+#define VO_DDWB_VSYC_3_inst                                                          0x00D0
+#define VO_DDWB_VSYC_4_inst                                                          0x00D1
+#define VO_DDWB_VSYC_5_inst                                                          0x00D2
+#define VO_DDWB_VSYC_6_inst                                                          0x00D3
+#define VO_DDWB_VSYC_7_inst                                                          0x00D4
+#define VO_DDWB_VSYC_c1_shift                                                        (16)
+#define VO_DDWB_VSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_DDWB_VSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_DDWB_VSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_VSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_VSYC_c0_shift                                                        (0)
+#define VO_DDWB_VSYC_c0_mask                                                         (0x00003FFF)
+#define VO_DDWB_VSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_DDWB_VSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_DDWB_VSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_DDWB_VSCC_0                                                               0x98005B54
+#define VO_DDWB_VSCC_1                                                               0x98005B58
+#define VO_DDWB_VSCC_2                                                               0x98005B5C
+#define VO_DDWB_VSCC_3                                                               0x98005B60
+#define VO_DDWB_VSCC_4                                                               0x98005B64
+#define VO_DDWB_VSCC_5                                                               0x98005B68
+#define VO_DDWB_VSCC_6                                                               0x98005B6C
+#define VO_DDWB_VSCC_7                                                               0x98005B70
+#define VO_DDWB_VSCC_0_reg_addr                                                      "0xD8005B54"
+#define VO_DDWB_VSCC_1_reg_addr                                                      "0xD8005B58"
+#define VO_DDWB_VSCC_2_reg_addr                                                      "0xD8005B5C"
+#define VO_DDWB_VSCC_3_reg_addr                                                      "0xD8005B60"
+#define VO_DDWB_VSCC_4_reg_addr                                                      "0xD8005B64"
+#define VO_DDWB_VSCC_5_reg_addr                                                      "0xD8005B68"
+#define VO_DDWB_VSCC_6_reg_addr                                                      "0xD8005B6C"
+#define VO_DDWB_VSCC_7_reg_addr                                                      "0xD8005B70"
+#define VO_DDWB_VSCC_0_reg                                                           0xD8005B54
+#define VO_DDWB_VSCC_1_reg                                                           0xD8005B58
+#define VO_DDWB_VSCC_2_reg                                                           0xD8005B5C
+#define VO_DDWB_VSCC_3_reg                                                           0xD8005B60
+#define VO_DDWB_VSCC_4_reg                                                           0xD8005B64
+#define VO_DDWB_VSCC_5_reg                                                           0xD8005B68
+#define VO_DDWB_VSCC_6_reg                                                           0xD8005B6C
+#define VO_DDWB_VSCC_7_reg                                                           0xD8005B70
+#define set_VO_DDWB_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_0_reg)=data)
+#define set_VO_DDWB_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_1_reg)=data)
+#define set_VO_DDWB_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_2_reg)=data)
+#define set_VO_DDWB_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_3_reg)=data)
+#define set_VO_DDWB_VSCC_4_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_4_reg)=data)
+#define set_VO_DDWB_VSCC_5_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_5_reg)=data)
+#define set_VO_DDWB_VSCC_6_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_6_reg)=data)
+#define set_VO_DDWB_VSCC_7_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_7_reg)=data)
+#define get_VO_DDWB_VSCC_0_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_0_reg))
+#define get_VO_DDWB_VSCC_1_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_1_reg))
+#define get_VO_DDWB_VSCC_2_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_2_reg))
+#define get_VO_DDWB_VSCC_3_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_3_reg))
+#define get_VO_DDWB_VSCC_4_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_4_reg))
+#define get_VO_DDWB_VSCC_5_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_5_reg))
+#define get_VO_DDWB_VSCC_6_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_6_reg))
+#define get_VO_DDWB_VSCC_7_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_7_reg))
+#define VO_DDWB_VSCC_0_inst_adr                                                      "0x00D5"
+#define VO_DDWB_VSCC_1_inst_adr                                                      "0x00D6"
+#define VO_DDWB_VSCC_2_inst_adr                                                      "0x00D7"
+#define VO_DDWB_VSCC_3_inst_adr                                                      "0x00D8"
+#define VO_DDWB_VSCC_4_inst_adr                                                      "0x00D9"
+#define VO_DDWB_VSCC_5_inst_adr                                                      "0x00DA"
+#define VO_DDWB_VSCC_6_inst_adr                                                      "0x00DB"
+#define VO_DDWB_VSCC_7_inst_adr                                                      "0x00DC"
+#define VO_DDWB_VSCC_0_inst                                                          0x00D5
+#define VO_DDWB_VSCC_1_inst                                                          0x00D6
+#define VO_DDWB_VSCC_2_inst                                                          0x00D7
+#define VO_DDWB_VSCC_3_inst                                                          0x00D8
+#define VO_DDWB_VSCC_4_inst                                                          0x00D9
+#define VO_DDWB_VSCC_5_inst                                                          0x00DA
+#define VO_DDWB_VSCC_6_inst                                                          0x00DB
+#define VO_DDWB_VSCC_7_inst                                                          0x00DC
+#define VO_DDWB_VSCC_c1_shift                                                        (16)
+#define VO_DDWB_VSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_DDWB_VSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_DDWB_VSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_VSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_VSCC_c0_shift                                                        (0)
+#define VO_DDWB_VSCC_c0_mask                                                         (0x00003FFF)
+#define VO_DDWB_VSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_DDWB_VSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_DDWB_VSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_DDWB_HSI                                                                  0x98005B74
+#define VO_DDWB_HSI_reg_addr                                                         "0xD8005B74"
+#define VO_DDWB_HSI_reg                                                              0xD8005B74
+#define set_VO_DDWB_HSI_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSI_reg)=data)
+#define get_VO_DDWB_HSI_reg   (*((volatile unsigned int*) VO_DDWB_HSI_reg))
+#define VO_DDWB_HSI_inst_adr                                                         "0x00DD"
+#define VO_DDWB_HSI_inst                                                             0x00DD
+#define VO_DDWB_HSI_offset_shift                                                     (16)
+#define VO_DDWB_HSI_offset_mask                                                      (0x1FFF0000)
+#define VO_DDWB_HSI_offset(data)                                                     (0x1FFF0000&((data)<<16))
+#define VO_DDWB_HSI_offset_src(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_DDWB_HSI_get_offset(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_DDWB_HSI_phase_shift                                                      (0)
+#define VO_DDWB_HSI_phase_mask                                                       (0x0000FFFF)
+#define VO_DDWB_HSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_DDWB_HSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_DDWB_HSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_DDWB_HSD                                                                  0x98005B78
+#define VO_DDWB_HSD_reg_addr                                                         "0xD8005B78"
+#define VO_DDWB_HSD_reg                                                              0xD8005B78
+#define set_VO_DDWB_HSD_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSD_reg)=data)
+#define get_VO_DDWB_HSD_reg   (*((volatile unsigned int*) VO_DDWB_HSD_reg))
+#define VO_DDWB_HSD_inst_adr                                                         "0x00DE"
+#define VO_DDWB_HSD_inst                                                             0x00DE
+#define VO_DDWB_HSD_delta_shift                                                      (0)
+#define VO_DDWB_HSD_delta_mask                                                       (0x001FFFFF)
+#define VO_DDWB_HSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_DDWB_HSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_DDWB_HSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_DDWB_HSD_W                                                                0x98005B7C
+#define VO_DDWB_HSD_W_reg_addr                                                       "0xD8005B7C"
+#define VO_DDWB_HSD_W_reg                                                            0xD8005B7C
+#define set_VO_DDWB_HSD_W_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSD_W_reg)=data)
+#define get_VO_DDWB_HSD_W_reg   (*((volatile unsigned int*) VO_DDWB_HSD_W_reg))
+#define VO_DDWB_HSD_W_inst_adr                                                       "0x00DF"
+#define VO_DDWB_HSD_W_inst                                                           0x00DF
+#define VO_DDWB_HSD_W_out_shift                                                      (0)
+#define VO_DDWB_HSD_W_out_mask                                                       (0x00001FFF)
+#define VO_DDWB_HSD_W_out(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_DDWB_HSD_W_out_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_DDWB_HSD_W_get_out(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_DDWB_HSYC_0                                                               0x98005B80
+#define VO_DDWB_HSYC_1                                                               0x98005B84
+#define VO_DDWB_HSYC_2                                                               0x98005B88
+#define VO_DDWB_HSYC_3                                                               0x98005B8C
+#define VO_DDWB_HSYC_4                                                               0x98005B90
+#define VO_DDWB_HSYC_5                                                               0x98005B94
+#define VO_DDWB_HSYC_6                                                               0x98005B98
+#define VO_DDWB_HSYC_7                                                               0x98005B9C
+#define VO_DDWB_HSYC_8                                                               0x98005BA0
+#define VO_DDWB_HSYC_9                                                               0x98005BA4
+#define VO_DDWB_HSYC_10                                                               0x98005BA8
+#define VO_DDWB_HSYC_11                                                               0x98005BAC
+#define VO_DDWB_HSYC_12                                                               0x98005BB0
+#define VO_DDWB_HSYC_13                                                               0x98005BB4
+#define VO_DDWB_HSYC_14                                                               0x98005BB8
+#define VO_DDWB_HSYC_15                                                               0x98005BBC
+#define VO_DDWB_HSYC_0_reg_addr                                                      "0xD8005B80"
+#define VO_DDWB_HSYC_1_reg_addr                                                      "0xD8005B84"
+#define VO_DDWB_HSYC_2_reg_addr                                                      "0xD8005B88"
+#define VO_DDWB_HSYC_3_reg_addr                                                      "0xD8005B8C"
+#define VO_DDWB_HSYC_4_reg_addr                                                      "0xD8005B90"
+#define VO_DDWB_HSYC_5_reg_addr                                                      "0xD8005B94"
+#define VO_DDWB_HSYC_6_reg_addr                                                      "0xD8005B98"
+#define VO_DDWB_HSYC_7_reg_addr                                                      "0xD8005B9C"
+#define VO_DDWB_HSYC_8_reg_addr                                                      "0xD8005BA0"
+#define VO_DDWB_HSYC_9_reg_addr                                                      "0xD8005BA4"
+#define VO_DDWB_HSYC_10_reg_addr                                                      "0xD8005BA8"
+#define VO_DDWB_HSYC_11_reg_addr                                                      "0xD8005BAC"
+#define VO_DDWB_HSYC_12_reg_addr                                                      "0xD8005BB0"
+#define VO_DDWB_HSYC_13_reg_addr                                                      "0xD8005BB4"
+#define VO_DDWB_HSYC_14_reg_addr                                                      "0xD8005BB8"
+#define VO_DDWB_HSYC_15_reg_addr                                                      "0xD8005BBC"
+#define VO_DDWB_HSYC_0_reg                                                           0xD8005B80
+#define VO_DDWB_HSYC_1_reg                                                           0xD8005B84
+#define VO_DDWB_HSYC_2_reg                                                           0xD8005B88
+#define VO_DDWB_HSYC_3_reg                                                           0xD8005B8C
+#define VO_DDWB_HSYC_4_reg                                                           0xD8005B90
+#define VO_DDWB_HSYC_5_reg                                                           0xD8005B94
+#define VO_DDWB_HSYC_6_reg                                                           0xD8005B98
+#define VO_DDWB_HSYC_7_reg                                                           0xD8005B9C
+#define VO_DDWB_HSYC_8_reg                                                           0xD8005BA0
+#define VO_DDWB_HSYC_9_reg                                                           0xD8005BA4
+#define VO_DDWB_HSYC_10_reg                                                           0xD8005BA8
+#define VO_DDWB_HSYC_11_reg                                                           0xD8005BAC
+#define VO_DDWB_HSYC_12_reg                                                           0xD8005BB0
+#define VO_DDWB_HSYC_13_reg                                                           0xD8005BB4
+#define VO_DDWB_HSYC_14_reg                                                           0xD8005BB8
+#define VO_DDWB_HSYC_15_reg                                                           0xD8005BBC
+#define set_VO_DDWB_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_0_reg)=data)
+#define set_VO_DDWB_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_1_reg)=data)
+#define set_VO_DDWB_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_2_reg)=data)
+#define set_VO_DDWB_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_3_reg)=data)
+#define set_VO_DDWB_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_4_reg)=data)
+#define set_VO_DDWB_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_5_reg)=data)
+#define set_VO_DDWB_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_6_reg)=data)
+#define set_VO_DDWB_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_7_reg)=data)
+#define set_VO_DDWB_HSYC_8_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_8_reg)=data)
+#define set_VO_DDWB_HSYC_9_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_9_reg)=data)
+#define set_VO_DDWB_HSYC_10_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_10_reg)=data)
+#define set_VO_DDWB_HSYC_11_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_11_reg)=data)
+#define set_VO_DDWB_HSYC_12_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_12_reg)=data)
+#define set_VO_DDWB_HSYC_13_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_13_reg)=data)
+#define set_VO_DDWB_HSYC_14_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_14_reg)=data)
+#define set_VO_DDWB_HSYC_15_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_15_reg)=data)
+#define get_VO_DDWB_HSYC_0_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_0_reg))
+#define get_VO_DDWB_HSYC_1_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_1_reg))
+#define get_VO_DDWB_HSYC_2_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_2_reg))
+#define get_VO_DDWB_HSYC_3_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_3_reg))
+#define get_VO_DDWB_HSYC_4_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_4_reg))
+#define get_VO_DDWB_HSYC_5_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_5_reg))
+#define get_VO_DDWB_HSYC_6_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_6_reg))
+#define get_VO_DDWB_HSYC_7_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_7_reg))
+#define get_VO_DDWB_HSYC_8_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_8_reg))
+#define get_VO_DDWB_HSYC_9_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_9_reg))
+#define get_VO_DDWB_HSYC_10_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_10_reg))
+#define get_VO_DDWB_HSYC_11_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_11_reg))
+#define get_VO_DDWB_HSYC_12_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_12_reg))
+#define get_VO_DDWB_HSYC_13_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_13_reg))
+#define get_VO_DDWB_HSYC_14_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_14_reg))
+#define get_VO_DDWB_HSYC_15_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_15_reg))
+#define VO_DDWB_HSYC_0_inst_adr                                                      "0x00E0"
+#define VO_DDWB_HSYC_1_inst_adr                                                      "0x00E1"
+#define VO_DDWB_HSYC_2_inst_adr                                                      "0x00E2"
+#define VO_DDWB_HSYC_3_inst_adr                                                      "0x00E3"
+#define VO_DDWB_HSYC_4_inst_adr                                                      "0x00E4"
+#define VO_DDWB_HSYC_5_inst_adr                                                      "0x00E5"
+#define VO_DDWB_HSYC_6_inst_adr                                                      "0x00E6"
+#define VO_DDWB_HSYC_7_inst_adr                                                      "0x00E7"
+#define VO_DDWB_HSYC_8_inst_adr                                                      "0x00E8"
+#define VO_DDWB_HSYC_9_inst_adr                                                      "0x00E9"
+#define VO_DDWB_HSYC_10_inst_adr                                                      "0x00EA"
+#define VO_DDWB_HSYC_11_inst_adr                                                      "0x00EB"
+#define VO_DDWB_HSYC_12_inst_adr                                                      "0x00EC"
+#define VO_DDWB_HSYC_13_inst_adr                                                      "0x00ED"
+#define VO_DDWB_HSYC_14_inst_adr                                                      "0x00EE"
+#define VO_DDWB_HSYC_15_inst_adr                                                      "0x00EF"
+#define VO_DDWB_HSYC_0_inst                                                          0x00E0
+#define VO_DDWB_HSYC_1_inst                                                          0x00E1
+#define VO_DDWB_HSYC_2_inst                                                          0x00E2
+#define VO_DDWB_HSYC_3_inst                                                          0x00E3
+#define VO_DDWB_HSYC_4_inst                                                          0x00E4
+#define VO_DDWB_HSYC_5_inst                                                          0x00E5
+#define VO_DDWB_HSYC_6_inst                                                          0x00E6
+#define VO_DDWB_HSYC_7_inst                                                          0x00E7
+#define VO_DDWB_HSYC_8_inst                                                          0x00E8
+#define VO_DDWB_HSYC_9_inst                                                          0x00E9
+#define VO_DDWB_HSYC_10_inst                                                          0x00EA
+#define VO_DDWB_HSYC_11_inst                                                          0x00EB
+#define VO_DDWB_HSYC_12_inst                                                          0x00EC
+#define VO_DDWB_HSYC_13_inst                                                          0x00ED
+#define VO_DDWB_HSYC_14_inst                                                          0x00EE
+#define VO_DDWB_HSYC_15_inst                                                          0x00EF
+#define VO_DDWB_HSYC_c1_shift                                                        (16)
+#define VO_DDWB_HSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_DDWB_HSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_DDWB_HSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_HSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_HSYC_c0_shift                                                        (0)
+#define VO_DDWB_HSYC_c0_mask                                                         (0x00003FFF)
+#define VO_DDWB_HSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_DDWB_HSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_DDWB_HSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_DDWB_HSCC_0                                                               0x98005BC0
+#define VO_DDWB_HSCC_1                                                               0x98005BC4
+#define VO_DDWB_HSCC_2                                                               0x98005BC8
+#define VO_DDWB_HSCC_3                                                               0x98005BCC
+#define VO_DDWB_HSCC_4                                                               0x98005BD0
+#define VO_DDWB_HSCC_5                                                               0x98005BD4
+#define VO_DDWB_HSCC_6                                                               0x98005BD8
+#define VO_DDWB_HSCC_7                                                               0x98005BDC
+#define VO_DDWB_HSCC_0_reg_addr                                                      "0xD8005BC0"
+#define VO_DDWB_HSCC_1_reg_addr                                                      "0xD8005BC4"
+#define VO_DDWB_HSCC_2_reg_addr                                                      "0xD8005BC8"
+#define VO_DDWB_HSCC_3_reg_addr                                                      "0xD8005BCC"
+#define VO_DDWB_HSCC_4_reg_addr                                                      "0xD8005BD0"
+#define VO_DDWB_HSCC_5_reg_addr                                                      "0xD8005BD4"
+#define VO_DDWB_HSCC_6_reg_addr                                                      "0xD8005BD8"
+#define VO_DDWB_HSCC_7_reg_addr                                                      "0xD8005BDC"
+#define VO_DDWB_HSCC_0_reg                                                           0xD8005BC0
+#define VO_DDWB_HSCC_1_reg                                                           0xD8005BC4
+#define VO_DDWB_HSCC_2_reg                                                           0xD8005BC8
+#define VO_DDWB_HSCC_3_reg                                                           0xD8005BCC
+#define VO_DDWB_HSCC_4_reg                                                           0xD8005BD0
+#define VO_DDWB_HSCC_5_reg                                                           0xD8005BD4
+#define VO_DDWB_HSCC_6_reg                                                           0xD8005BD8
+#define VO_DDWB_HSCC_7_reg                                                           0xD8005BDC
+#define set_VO_DDWB_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_0_reg)=data)
+#define set_VO_DDWB_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_1_reg)=data)
+#define set_VO_DDWB_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_2_reg)=data)
+#define set_VO_DDWB_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_3_reg)=data)
+#define set_VO_DDWB_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_4_reg)=data)
+#define set_VO_DDWB_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_5_reg)=data)
+#define set_VO_DDWB_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_6_reg)=data)
+#define set_VO_DDWB_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_7_reg)=data)
+#define get_VO_DDWB_HSCC_0_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_0_reg))
+#define get_VO_DDWB_HSCC_1_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_1_reg))
+#define get_VO_DDWB_HSCC_2_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_2_reg))
+#define get_VO_DDWB_HSCC_3_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_3_reg))
+#define get_VO_DDWB_HSCC_4_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_4_reg))
+#define get_VO_DDWB_HSCC_5_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_5_reg))
+#define get_VO_DDWB_HSCC_6_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_6_reg))
+#define get_VO_DDWB_HSCC_7_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_7_reg))
+#define VO_DDWB_HSCC_0_inst_adr                                                      "0x00F0"
+#define VO_DDWB_HSCC_1_inst_adr                                                      "0x00F1"
+#define VO_DDWB_HSCC_2_inst_adr                                                      "0x00F2"
+#define VO_DDWB_HSCC_3_inst_adr                                                      "0x00F3"
+#define VO_DDWB_HSCC_4_inst_adr                                                      "0x00F4"
+#define VO_DDWB_HSCC_5_inst_adr                                                      "0x00F5"
+#define VO_DDWB_HSCC_6_inst_adr                                                      "0x00F6"
+#define VO_DDWB_HSCC_7_inst_adr                                                      "0x00F7"
+#define VO_DDWB_HSCC_0_inst                                                          0x00F0
+#define VO_DDWB_HSCC_1_inst                                                          0x00F1
+#define VO_DDWB_HSCC_2_inst                                                          0x00F2
+#define VO_DDWB_HSCC_3_inst                                                          0x00F3
+#define VO_DDWB_HSCC_4_inst                                                          0x00F4
+#define VO_DDWB_HSCC_5_inst                                                          0x00F5
+#define VO_DDWB_HSCC_6_inst                                                          0x00F6
+#define VO_DDWB_HSCC_7_inst                                                          0x00F7
+#define VO_DDWB_HSCC_c1_shift                                                        (16)
+#define VO_DDWB_HSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_DDWB_HSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_DDWB_HSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_HSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_HSCC_c0_shift                                                        (0)
+#define VO_DDWB_HSCC_c0_mask                                                         (0x00003FFF)
+#define VO_DDWB_HSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_DDWB_HSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_DDWB_HSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_WB2_CFG                                                                   0x98005BE0
+#define VO_WB2_CFG_reg_addr                                                          "0xD8005BE0"
+#define VO_WB2_CFG_reg                                                               0xD8005BE0
+#define set_VO_WB2_CFG_reg(data)   (*((volatile unsigned int*) VO_WB2_CFG_reg)=data)
+#define get_VO_WB2_CFG_reg   (*((volatile unsigned int*) VO_WB2_CFG_reg))
+#define VO_WB2_CFG_inst_adr                                                          "0x00F8"
+#define VO_WB2_CFG_inst                                                              0x00F8
+#define VO_WB2_CFG_mode_10b_shift                                                    (15)
+#define VO_WB2_CFG_mode_10b_mask                                                     (0x00008000)
+#define VO_WB2_CFG_mode_10b(data)                                                    (0x00008000&((data)<<15))
+#define VO_WB2_CFG_mode_10b_src(data)                                                ((0x00008000&(data))>>15)
+#define VO_WB2_CFG_get_mode_10b(data)                                                ((0x00008000&(data))>>15)
+#define VO_WB2_CFG_ppc10b_shift                                                      (14)
+#define VO_WB2_CFG_ppc10b_mask                                                       (0x00004000)
+#define VO_WB2_CFG_ppc10b(data)                                                      (0x00004000&((data)<<14))
+#define VO_WB2_CFG_ppc10b_src(data)                                                  ((0x00004000&(data))>>14)
+#define VO_WB2_CFG_get_ppc10b(data)                                                  ((0x00004000&(data))>>14)
+#define VO_WB2_CFG_wb_nv21_shift                                                     (13)
+#define VO_WB2_CFG_wb_nv21_mask                                                      (0x00002000)
+#define VO_WB2_CFG_wb_nv21(data)                                                     (0x00002000&((data)<<13))
+#define VO_WB2_CFG_wb_nv21_src(data)                                                 ((0x00002000&(data))>>13)
+#define VO_WB2_CFG_get_wb_nv21(data)                                                 ((0x00002000&(data))>>13)
+#define VO_WB2_CFG_wb_seq_shift                                                      (12)
+#define VO_WB2_CFG_wb_seq_mask                                                       (0x00001000)
+#define VO_WB2_CFG_wb_seq(data)                                                      (0x00001000&((data)<<12))
+#define VO_WB2_CFG_wb_seq_src(data)                                                  ((0x00001000&(data))>>12)
+#define VO_WB2_CFG_get_wb_seq(data)                                                  ((0x00001000&(data))>>12)
+#define VO_WB2_CFG_h2v_shift                                                         (11)
+#define VO_WB2_CFG_h2v_mask                                                          (0x00000800)
+#define VO_WB2_CFG_h2v(data)                                                         (0x00000800&((data)<<11))
+#define VO_WB2_CFG_h2v_src(data)                                                     ((0x00000800&(data))>>11)
+#define VO_WB2_CFG_get_h2v(data)                                                     ((0x00000800&(data))>>11)
+#define VO_WB2_CFG_hd_shift                                                          (10)
+#define VO_WB2_CFG_hd_mask                                                           (0x00000400)
+#define VO_WB2_CFG_hd(data)                                                          (0x00000400&((data)<<10))
+#define VO_WB2_CFG_hd_src(data)                                                      ((0x00000400&(data))>>10)
+#define VO_WB2_CFG_get_hd(data)                                                      ((0x00000400&(data))>>10)
+#define VO_WB2_CFG_reint_shift                                                       (8)
+#define VO_WB2_CFG_reint_mask                                                        (0x00000100)
+#define VO_WB2_CFG_reint(data)                                                       (0x00000100&((data)<<8))
+#define VO_WB2_CFG_reint_src(data)                                                   ((0x00000100&(data))>>8)
+#define VO_WB2_CFG_get_reint(data)                                                   ((0x00000100&(data))>>8)
+#define VO_WB2_CFG_bot_shift                                                         (7)
+#define VO_WB2_CFG_bot_mask                                                          (0x00000080)
+#define VO_WB2_CFG_bot(data)                                                         (0x00000080&((data)<<7))
+#define VO_WB2_CFG_bot_src(data)                                                     ((0x00000080&(data))>>7)
+#define VO_WB2_CFG_get_bot(data)                                                     ((0x00000080&(data))>>7)
+#define VO_WB2_CFG_wb_f420_shift                                                     (6)
+#define VO_WB2_CFG_wb_f420_mask                                                      (0x00000040)
+#define VO_WB2_CFG_wb_f420(data)                                                     (0x00000040&((data)<<6))
+#define VO_WB2_CFG_wb_f420_src(data)                                                 ((0x00000040&(data))>>6)
+#define VO_WB2_CFG_get_wb_f420(data)                                                 ((0x00000040&(data))>>6)
+#define VO_WB2_CFG_vs_yodd_shift                                                     (5)
+#define VO_WB2_CFG_vs_yodd_mask                                                      (0x00000020)
+#define VO_WB2_CFG_vs_yodd(data)                                                     (0x00000020&((data)<<5))
+#define VO_WB2_CFG_vs_yodd_src(data)                                                 ((0x00000020&(data))>>5)
+#define VO_WB2_CFG_get_vs_yodd(data)                                                 ((0x00000020&(data))>>5)
+#define VO_WB2_CFG_vs_codd_shift                                                     (4)
+#define VO_WB2_CFG_vs_codd_mask                                                      (0x00000010)
+#define VO_WB2_CFG_vs_codd(data)                                                     (0x00000010&((data)<<4))
+#define VO_WB2_CFG_vs_codd_src(data)                                                 ((0x00000010&(data))>>4)
+#define VO_WB2_CFG_get_vs_codd(data)                                                 ((0x00000010&(data))>>4)
+#define VO_WB2_CFG_hs_yodd_shift                                                     (2)
+#define VO_WB2_CFG_hs_yodd_mask                                                      (0x00000004)
+#define VO_WB2_CFG_hs_yodd(data)                                                     (0x00000004&((data)<<2))
+#define VO_WB2_CFG_hs_yodd_src(data)                                                 ((0x00000004&(data))>>2)
+#define VO_WB2_CFG_get_hs_yodd(data)                                                 ((0x00000004&(data))>>2)
+#define VO_WB2_CFG_hs_codd_shift                                                     (1)
+#define VO_WB2_CFG_hs_codd_mask                                                      (0x00000002)
+#define VO_WB2_CFG_hs_codd(data)                                                     (0x00000002&((data)<<1))
+#define VO_WB2_CFG_hs_codd_src(data)                                                 ((0x00000002&(data))>>1)
+#define VO_WB2_CFG_get_hs_codd(data)                                                 ((0x00000002&(data))>>1)
+#define VO_WB2_CFG_write_data_shift                                                  (0)
+#define VO_WB2_CFG_write_data_mask                                                   (0x00000001)
+#define VO_WB2_CFG_write_data(data)                                                  (0x00000001&((data)<<0))
+#define VO_WB2_CFG_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define VO_WB2_CFG_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define VO_WB2_SEL                                                                   0x98005BE4
+#define VO_WB2_SEL_reg_addr                                                          "0xD8005BE4"
+#define VO_WB2_SEL_reg                                                               0xD8005BE4
+#define set_VO_WB2_SEL_reg(data)   (*((volatile unsigned int*) VO_WB2_SEL_reg)=data)
+#define get_VO_WB2_SEL_reg   (*((volatile unsigned int*) VO_WB2_SEL_reg))
+#define VO_WB2_SEL_inst_adr                                                          "0x00F9"
+#define VO_WB2_SEL_inst                                                              0x00F9
+#define VO_WB2_SEL_write_en2_shift                                                   (5)
+#define VO_WB2_SEL_write_en2_mask                                                    (0x00000020)
+#define VO_WB2_SEL_write_en2(data)                                                   (0x00000020&((data)<<5))
+#define VO_WB2_SEL_write_en2_src(data)                                               ((0x00000020&(data))>>5)
+#define VO_WB2_SEL_get_write_en2(data)                                               ((0x00000020&(data))>>5)
+#define VO_WB2_SEL_hs_en_shift                                                       (4)
+#define VO_WB2_SEL_hs_en_mask                                                        (0x00000010)
+#define VO_WB2_SEL_hs_en(data)                                                       (0x00000010&((data)<<4))
+#define VO_WB2_SEL_hs_en_src(data)                                                   ((0x00000010&(data))>>4)
+#define VO_WB2_SEL_get_hs_en(data)                                                   ((0x00000010&(data))>>4)
+#define VO_WB2_SEL_write_en1_shift                                                   (1)
+#define VO_WB2_SEL_write_en1_mask                                                    (0x00000002)
+#define VO_WB2_SEL_write_en1(data)                                                   (0x00000002&((data)<<1))
+#define VO_WB2_SEL_write_en1_src(data)                                               ((0x00000002&(data))>>1)
+#define VO_WB2_SEL_get_write_en1(data)                                               ((0x00000002&(data))>>1)
+#define VO_WB2_SEL_vs_en_shift                                                       (0)
+#define VO_WB2_SEL_vs_en_mask                                                        (0x00000001)
+#define VO_WB2_SEL_vs_en(data)                                                       (0x00000001&((data)<<0))
+#define VO_WB2_SEL_vs_en_src(data)                                                   ((0x00000001&(data))>>0)
+#define VO_WB2_SEL_get_vs_en(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define VO_WB2_INDEX                                                                 0x98005BE8
+#define VO_WB2_INDEX_reg_addr                                                        "0xD8005BE8"
+#define VO_WB2_INDEX_reg                                                             0xD8005BE8
+#define set_VO_WB2_INDEX_reg(data)   (*((volatile unsigned int*) VO_WB2_INDEX_reg)=data)
+#define get_VO_WB2_INDEX_reg   (*((volatile unsigned int*) VO_WB2_INDEX_reg))
+#define VO_WB2_INDEX_inst_adr                                                        "0x00FA"
+#define VO_WB2_INDEX_inst                                                            0x00FA
+#define VO_WB2_INDEX_write_en5_shift                                                 (27)
+#define VO_WB2_INDEX_write_en5_mask                                                  (0x08000000)
+#define VO_WB2_INDEX_write_en5(data)                                                 (0x08000000&((data)<<27))
+#define VO_WB2_INDEX_write_en5_src(data)                                             ((0x08000000&(data))>>27)
+#define VO_WB2_INDEX_get_write_en5(data)                                             ((0x08000000&(data))>>27)
+#define VO_WB2_INDEX_interlace_shift                                                 (26)
+#define VO_WB2_INDEX_interlace_mask                                                  (0x04000000)
+#define VO_WB2_INDEX_interlace(data)                                                 (0x04000000&((data)<<26))
+#define VO_WB2_INDEX_interlace_src(data)                                             ((0x04000000&(data))>>26)
+#define VO_WB2_INDEX_get_interlace(data)                                             ((0x04000000&(data))>>26)
+#define VO_WB2_INDEX_write_en4_shift                                                 (25)
+#define VO_WB2_INDEX_write_en4_mask                                                  (0x02000000)
+#define VO_WB2_INDEX_write_en4(data)                                                 (0x02000000&((data)<<25))
+#define VO_WB2_INDEX_write_en4_src(data)                                             ((0x02000000&(data))>>25)
+#define VO_WB2_INDEX_get_write_en4(data)                                             ((0x02000000&(data))>>25)
+#define VO_WB2_INDEX_bot_shift                                                       (24)
+#define VO_WB2_INDEX_bot_mask                                                        (0x01000000)
+#define VO_WB2_INDEX_bot(data)                                                       (0x01000000&((data)<<24))
+#define VO_WB2_INDEX_bot_src(data)                                                   ((0x01000000&(data))>>24)
+#define VO_WB2_INDEX_get_bot(data)                                                   ((0x01000000&(data))>>24)
+#define VO_WB2_INDEX_write_en2_shift                                                 (15)
+#define VO_WB2_INDEX_write_en2_mask                                                  (0x00008000)
+#define VO_WB2_INDEX_write_en2(data)                                                 (0x00008000&((data)<<15))
+#define VO_WB2_INDEX_write_en2_src(data)                                             ((0x00008000&(data))>>15)
+#define VO_WB2_INDEX_get_write_en2(data)                                             ((0x00008000&(data))>>15)
+#define VO_WB2_INDEX_c_shift                                                         (8)
+#define VO_WB2_INDEX_c_mask                                                          (0x00007F00)
+#define VO_WB2_INDEX_c(data)                                                         (0x00007F00&((data)<<8))
+#define VO_WB2_INDEX_c_src(data)                                                     ((0x00007F00&(data))>>8)
+#define VO_WB2_INDEX_get_c(data)                                                     ((0x00007F00&(data))>>8)
+#define VO_WB2_INDEX_write_en1_shift                                                 (7)
+#define VO_WB2_INDEX_write_en1_mask                                                  (0x00000080)
+#define VO_WB2_INDEX_write_en1(data)                                                 (0x00000080&((data)<<7))
+#define VO_WB2_INDEX_write_en1_src(data)                                             ((0x00000080&(data))>>7)
+#define VO_WB2_INDEX_get_write_en1(data)                                             ((0x00000080&(data))>>7)
+#define VO_WB2_INDEX_y_shift                                                         (0)
+#define VO_WB2_INDEX_y_mask                                                          (0x0000007F)
+#define VO_WB2_INDEX_y(data)                                                         (0x0000007F&((data)<<0))
+#define VO_WB2_INDEX_y_src(data)                                                     ((0x0000007F&(data))>>0)
+#define VO_WB2_INDEX_get_y(data)                                                     ((0x0000007F&(data))>>0)
+
+
+#define VO_WB2_SEQ_SA_Y                                                              0x98005BEC
+#define VO_WB2_SEQ_SA_Y_reg_addr                                                     "0xD8005BEC"
+#define VO_WB2_SEQ_SA_Y_reg                                                          0xD8005BEC
+#define set_VO_WB2_SEQ_SA_Y_reg(data)   (*((volatile unsigned int*) VO_WB2_SEQ_SA_Y_reg)=data)
+#define get_VO_WB2_SEQ_SA_Y_reg   (*((volatile unsigned int*) VO_WB2_SEQ_SA_Y_reg))
+#define VO_WB2_SEQ_SA_Y_inst_adr                                                     "0x00FB"
+#define VO_WB2_SEQ_SA_Y_inst                                                         0x00FB
+#define VO_WB2_SEQ_SA_Y_a_shift                                                      (0)
+#define VO_WB2_SEQ_SA_Y_a_mask                                                       (0xFFFFFFFF)
+#define VO_WB2_SEQ_SA_Y_a(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define VO_WB2_SEQ_SA_Y_a_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define VO_WB2_SEQ_SA_Y_get_a(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_WB2_SEQ_PITCH_Y                                                           0x98005BF0
+#define VO_WB2_SEQ_PITCH_Y_reg_addr                                                  "0xD8005BF0"
+#define VO_WB2_SEQ_PITCH_Y_reg                                                       0xD8005BF0
+#define set_VO_WB2_SEQ_PITCH_Y_reg(data)   (*((volatile unsigned int*) VO_WB2_SEQ_PITCH_Y_reg)=data)
+#define get_VO_WB2_SEQ_PITCH_Y_reg   (*((volatile unsigned int*) VO_WB2_SEQ_PITCH_Y_reg))
+#define VO_WB2_SEQ_PITCH_Y_inst_adr                                                  "0x00FC"
+#define VO_WB2_SEQ_PITCH_Y_inst                                                      0x00FC
+#define VO_WB2_SEQ_PITCH_Y_p_shift                                                   (0)
+#define VO_WB2_SEQ_PITCH_Y_p_mask                                                    (0x0000FFFF)
+#define VO_WB2_SEQ_PITCH_Y_p(data)                                                   (0x0000FFFF&((data)<<0))
+#define VO_WB2_SEQ_PITCH_Y_p_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define VO_WB2_SEQ_PITCH_Y_get_p(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define VO_WB2_SEQ_SA_C                                                              0x98005BF4
+#define VO_WB2_SEQ_SA_C_reg_addr                                                     "0xD8005BF4"
+#define VO_WB2_SEQ_SA_C_reg                                                          0xD8005BF4
+#define set_VO_WB2_SEQ_SA_C_reg(data)   (*((volatile unsigned int*) VO_WB2_SEQ_SA_C_reg)=data)
+#define get_VO_WB2_SEQ_SA_C_reg   (*((volatile unsigned int*) VO_WB2_SEQ_SA_C_reg))
+#define VO_WB2_SEQ_SA_C_inst_adr                                                     "0x00FD"
+#define VO_WB2_SEQ_SA_C_inst                                                         0x00FD
+#define VO_WB2_SEQ_SA_C_a_shift                                                      (0)
+#define VO_WB2_SEQ_SA_C_a_mask                                                       (0xFFFFFFFF)
+#define VO_WB2_SEQ_SA_C_a(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define VO_WB2_SEQ_SA_C_a_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define VO_WB2_SEQ_SA_C_get_a(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_WB2_SEQ_PITCH_C                                                           0x98005BF8
+#define VO_WB2_SEQ_PITCH_C_reg_addr                                                  "0xD8005BF8"
+#define VO_WB2_SEQ_PITCH_C_reg                                                       0xD8005BF8
+#define set_VO_WB2_SEQ_PITCH_C_reg(data)   (*((volatile unsigned int*) VO_WB2_SEQ_PITCH_C_reg)=data)
+#define get_VO_WB2_SEQ_PITCH_C_reg   (*((volatile unsigned int*) VO_WB2_SEQ_PITCH_C_reg))
+#define VO_WB2_SEQ_PITCH_C_inst_adr                                                  "0x00FE"
+#define VO_WB2_SEQ_PITCH_C_inst                                                      0x00FE
+#define VO_WB2_SEQ_PITCH_C_p_shift                                                   (0)
+#define VO_WB2_SEQ_PITCH_C_p_mask                                                    (0x0000FFFF)
+#define VO_WB2_SEQ_PITCH_C_p(data)                                                   (0x0000FFFF&((data)<<0))
+#define VO_WB2_SEQ_PITCH_C_p_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define VO_WB2_SEQ_PITCH_C_get_p(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define VO_WB2_SIZE                                                                  0x98005BFC
+#define VO_WB2_SIZE_reg_addr                                                         "0xD8005BFC"
+#define VO_WB2_SIZE_reg                                                              0xD8005BFC
+#define set_VO_WB2_SIZE_reg(data)   (*((volatile unsigned int*) VO_WB2_SIZE_reg)=data)
+#define get_VO_WB2_SIZE_reg   (*((volatile unsigned int*) VO_WB2_SIZE_reg))
+#define VO_WB2_SIZE_inst_adr                                                         "0x00FF"
+#define VO_WB2_SIZE_inst                                                             0x00FF
+#define VO_WB2_SIZE_w_shift                                                          (12)
+#define VO_WB2_SIZE_w_mask                                                           (0x01FFF000)
+#define VO_WB2_SIZE_w(data)                                                          (0x01FFF000&((data)<<12))
+#define VO_WB2_SIZE_w_src(data)                                                      ((0x01FFF000&(data))>>12)
+#define VO_WB2_SIZE_get_w(data)                                                      ((0x01FFF000&(data))>>12)
+#define VO_WB2_SIZE_h_shift                                                          (0)
+#define VO_WB2_SIZE_h_mask                                                           (0x00000FFF)
+#define VO_WB2_SIZE_h(data)                                                          (0x00000FFF&((data)<<0))
+#define VO_WB2_SIZE_h_src(data)                                                      ((0x00000FFF&(data))>>0)
+#define VO_WB2_SIZE_get_h(data)                                                      ((0x00000FFF&(data))>>0)
+
+
+#define VO_WB2_TPC                                                                   0x98005C00
+#define VO_WB2_TPC_reg_addr                                                          "0xD8005C00"
+#define VO_WB2_TPC_reg                                                               0xD8005C00
+#define set_VO_WB2_TPC_reg(data)   (*((volatile unsigned int*) VO_WB2_TPC_reg)=data)
+#define get_VO_WB2_TPC_reg   (*((volatile unsigned int*) VO_WB2_TPC_reg))
+#define VO_WB2_TPC_inst_adr                                                          "0x0000"
+#define VO_WB2_TPC_inst                                                              0x0000
+#define VO_WB2_TPC_num_shift                                                         (0)
+#define VO_WB2_TPC_num_mask                                                          (0x000000FF)
+#define VO_WB2_TPC_num(data)                                                         (0x000000FF&((data)<<0))
+#define VO_WB2_TPC_num_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VO_WB2_TPC_get_num(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VO_WB2_VSI                                                                   0x98005C04
+#define VO_WB2_VSI_reg_addr                                                          "0xD8005C04"
+#define VO_WB2_VSI_reg                                                               0xD8005C04
+#define set_VO_WB2_VSI_reg(data)   (*((volatile unsigned int*) VO_WB2_VSI_reg)=data)
+#define get_VO_WB2_VSI_reg   (*((volatile unsigned int*) VO_WB2_VSI_reg))
+#define VO_WB2_VSI_inst_adr                                                          "0x0001"
+#define VO_WB2_VSI_inst                                                              0x0001
+#define VO_WB2_VSI_offset_shift                                                      (16)
+#define VO_WB2_VSI_offset_mask                                                       (0x1FFF0000)
+#define VO_WB2_VSI_offset(data)                                                      (0x1FFF0000&((data)<<16))
+#define VO_WB2_VSI_offset_src(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_WB2_VSI_get_offset(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_WB2_VSI_phase_shift                                                       (0)
+#define VO_WB2_VSI_phase_mask                                                        (0x0000FFFF)
+#define VO_WB2_VSI_phase(data)                                                       (0x0000FFFF&((data)<<0))
+#define VO_WB2_VSI_phase_src(data)                                                   ((0x0000FFFF&(data))>>0)
+#define VO_WB2_VSI_get_phase(data)                                                   ((0x0000FFFF&(data))>>0)
+
+
+#define VO_WB2_VSD                                                                   0x98005C08
+#define VO_WB2_VSD_reg_addr                                                          "0xD8005C08"
+#define VO_WB2_VSD_reg                                                               0xD8005C08
+#define set_VO_WB2_VSD_reg(data)   (*((volatile unsigned int*) VO_WB2_VSD_reg)=data)
+#define get_VO_WB2_VSD_reg   (*((volatile unsigned int*) VO_WB2_VSD_reg))
+#define VO_WB2_VSD_inst_adr                                                          "0x0002"
+#define VO_WB2_VSD_inst                                                              0x0002
+#define VO_WB2_VSD_delta_shift                                                       (0)
+#define VO_WB2_VSD_delta_mask                                                        (0x001FFFFF)
+#define VO_WB2_VSD_delta(data)                                                       (0x001FFFFF&((data)<<0))
+#define VO_WB2_VSD_delta_src(data)                                                   ((0x001FFFFF&(data))>>0)
+#define VO_WB2_VSD_get_delta(data)                                                   ((0x001FFFFF&(data))>>0)
+
+
+#define VO_WB2_VSD_H                                                                 0x98005C0C
+#define VO_WB2_VSD_H_reg_addr                                                        "0xD8005C0C"
+#define VO_WB2_VSD_H_reg                                                             0xD8005C0C
+#define set_VO_WB2_VSD_H_reg(data)   (*((volatile unsigned int*) VO_WB2_VSD_H_reg)=data)
+#define get_VO_WB2_VSD_H_reg   (*((volatile unsigned int*) VO_WB2_VSD_H_reg))
+#define VO_WB2_VSD_H_inst_adr                                                        "0x0003"
+#define VO_WB2_VSD_H_inst                                                            0x0003
+#define VO_WB2_VSD_H_out_shift                                                       (0)
+#define VO_WB2_VSD_H_out_mask                                                        (0x00000FFF)
+#define VO_WB2_VSD_H_out(data)                                                       (0x00000FFF&((data)<<0))
+#define VO_WB2_VSD_H_out_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VO_WB2_VSD_H_get_out(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VO_WB2_VSYC_0                                                                0x98005C10
+#define VO_WB2_VSYC_1                                                                0x98005C14
+#define VO_WB2_VSYC_2                                                                0x98005C18
+#define VO_WB2_VSYC_3                                                                0x98005C1C
+#define VO_WB2_VSYC_4                                                                0x98005C20
+#define VO_WB2_VSYC_5                                                                0x98005C24
+#define VO_WB2_VSYC_6                                                                0x98005C28
+#define VO_WB2_VSYC_7                                                                0x98005C2C
+#define VO_WB2_VSYC_0_reg_addr                                                       "0xD8005C10"
+#define VO_WB2_VSYC_1_reg_addr                                                       "0xD8005C14"
+#define VO_WB2_VSYC_2_reg_addr                                                       "0xD8005C18"
+#define VO_WB2_VSYC_3_reg_addr                                                       "0xD8005C1C"
+#define VO_WB2_VSYC_4_reg_addr                                                       "0xD8005C20"
+#define VO_WB2_VSYC_5_reg_addr                                                       "0xD8005C24"
+#define VO_WB2_VSYC_6_reg_addr                                                       "0xD8005C28"
+#define VO_WB2_VSYC_7_reg_addr                                                       "0xD8005C2C"
+#define VO_WB2_VSYC_0_reg                                                            0xD8005C10
+#define VO_WB2_VSYC_1_reg                                                            0xD8005C14
+#define VO_WB2_VSYC_2_reg                                                            0xD8005C18
+#define VO_WB2_VSYC_3_reg                                                            0xD8005C1C
+#define VO_WB2_VSYC_4_reg                                                            0xD8005C20
+#define VO_WB2_VSYC_5_reg                                                            0xD8005C24
+#define VO_WB2_VSYC_6_reg                                                            0xD8005C28
+#define VO_WB2_VSYC_7_reg                                                            0xD8005C2C
+#define set_VO_WB2_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_WB2_VSYC_0_reg)=data)
+#define set_VO_WB2_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_WB2_VSYC_1_reg)=data)
+#define set_VO_WB2_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_WB2_VSYC_2_reg)=data)
+#define set_VO_WB2_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_WB2_VSYC_3_reg)=data)
+#define set_VO_WB2_VSYC_4_reg(data)   (*((volatile unsigned int*) VO_WB2_VSYC_4_reg)=data)
+#define set_VO_WB2_VSYC_5_reg(data)   (*((volatile unsigned int*) VO_WB2_VSYC_5_reg)=data)
+#define set_VO_WB2_VSYC_6_reg(data)   (*((volatile unsigned int*) VO_WB2_VSYC_6_reg)=data)
+#define set_VO_WB2_VSYC_7_reg(data)   (*((volatile unsigned int*) VO_WB2_VSYC_7_reg)=data)
+#define get_VO_WB2_VSYC_0_reg   (*((volatile unsigned int*) VO_WB2_VSYC_0_reg))
+#define get_VO_WB2_VSYC_1_reg   (*((volatile unsigned int*) VO_WB2_VSYC_1_reg))
+#define get_VO_WB2_VSYC_2_reg   (*((volatile unsigned int*) VO_WB2_VSYC_2_reg))
+#define get_VO_WB2_VSYC_3_reg   (*((volatile unsigned int*) VO_WB2_VSYC_3_reg))
+#define get_VO_WB2_VSYC_4_reg   (*((volatile unsigned int*) VO_WB2_VSYC_4_reg))
+#define get_VO_WB2_VSYC_5_reg   (*((volatile unsigned int*) VO_WB2_VSYC_5_reg))
+#define get_VO_WB2_VSYC_6_reg   (*((volatile unsigned int*) VO_WB2_VSYC_6_reg))
+#define get_VO_WB2_VSYC_7_reg   (*((volatile unsigned int*) VO_WB2_VSYC_7_reg))
+#define VO_WB2_VSYC_0_inst_adr                                                       "0x0004"
+#define VO_WB2_VSYC_1_inst_adr                                                       "0x0005"
+#define VO_WB2_VSYC_2_inst_adr                                                       "0x0006"
+#define VO_WB2_VSYC_3_inst_adr                                                       "0x0007"
+#define VO_WB2_VSYC_4_inst_adr                                                       "0x0008"
+#define VO_WB2_VSYC_5_inst_adr                                                       "0x0009"
+#define VO_WB2_VSYC_6_inst_adr                                                       "0x000A"
+#define VO_WB2_VSYC_7_inst_adr                                                       "0x000B"
+#define VO_WB2_VSYC_0_inst                                                           0x0004
+#define VO_WB2_VSYC_1_inst                                                           0x0005
+#define VO_WB2_VSYC_2_inst                                                           0x0006
+#define VO_WB2_VSYC_3_inst                                                           0x0007
+#define VO_WB2_VSYC_4_inst                                                           0x0008
+#define VO_WB2_VSYC_5_inst                                                           0x0009
+#define VO_WB2_VSYC_6_inst                                                           0x000A
+#define VO_WB2_VSYC_7_inst                                                           0x000B
+#define VO_WB2_VSYC_c1_shift                                                         (16)
+#define VO_WB2_VSYC_c1_mask                                                          (0x3FFF0000)
+#define VO_WB2_VSYC_c1(data)                                                         (0x3FFF0000&((data)<<16))
+#define VO_WB2_VSYC_c1_src(data)                                                     ((0x3FFF0000&(data))>>16)
+#define VO_WB2_VSYC_get_c1(data)                                                     ((0x3FFF0000&(data))>>16)
+#define VO_WB2_VSYC_c0_shift                                                         (0)
+#define VO_WB2_VSYC_c0_mask                                                          (0x00003FFF)
+#define VO_WB2_VSYC_c0(data)                                                         (0x00003FFF&((data)<<0))
+#define VO_WB2_VSYC_c0_src(data)                                                     ((0x00003FFF&(data))>>0)
+#define VO_WB2_VSYC_get_c0(data)                                                     ((0x00003FFF&(data))>>0)
+
+
+#define VO_WB2_VSCC_0                                                                0x98005C30
+#define VO_WB2_VSCC_1                                                                0x98005C34
+#define VO_WB2_VSCC_2                                                                0x98005C38
+#define VO_WB2_VSCC_3                                                                0x98005C3C
+#define VO_WB2_VSCC_4                                                                0x98005C40
+#define VO_WB2_VSCC_5                                                                0x98005C44
+#define VO_WB2_VSCC_6                                                                0x98005C48
+#define VO_WB2_VSCC_7                                                                0x98005C4C
+#define VO_WB2_VSCC_0_reg_addr                                                       "0xD8005C30"
+#define VO_WB2_VSCC_1_reg_addr                                                       "0xD8005C34"
+#define VO_WB2_VSCC_2_reg_addr                                                       "0xD8005C38"
+#define VO_WB2_VSCC_3_reg_addr                                                       "0xD8005C3C"
+#define VO_WB2_VSCC_4_reg_addr                                                       "0xD8005C40"
+#define VO_WB2_VSCC_5_reg_addr                                                       "0xD8005C44"
+#define VO_WB2_VSCC_6_reg_addr                                                       "0xD8005C48"
+#define VO_WB2_VSCC_7_reg_addr                                                       "0xD8005C4C"
+#define VO_WB2_VSCC_0_reg                                                            0xD8005C30
+#define VO_WB2_VSCC_1_reg                                                            0xD8005C34
+#define VO_WB2_VSCC_2_reg                                                            0xD8005C38
+#define VO_WB2_VSCC_3_reg                                                            0xD8005C3C
+#define VO_WB2_VSCC_4_reg                                                            0xD8005C40
+#define VO_WB2_VSCC_5_reg                                                            0xD8005C44
+#define VO_WB2_VSCC_6_reg                                                            0xD8005C48
+#define VO_WB2_VSCC_7_reg                                                            0xD8005C4C
+#define set_VO_WB2_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_WB2_VSCC_0_reg)=data)
+#define set_VO_WB2_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_WB2_VSCC_1_reg)=data)
+#define set_VO_WB2_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_WB2_VSCC_2_reg)=data)
+#define set_VO_WB2_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_WB2_VSCC_3_reg)=data)
+#define set_VO_WB2_VSCC_4_reg(data)   (*((volatile unsigned int*) VO_WB2_VSCC_4_reg)=data)
+#define set_VO_WB2_VSCC_5_reg(data)   (*((volatile unsigned int*) VO_WB2_VSCC_5_reg)=data)
+#define set_VO_WB2_VSCC_6_reg(data)   (*((volatile unsigned int*) VO_WB2_VSCC_6_reg)=data)
+#define set_VO_WB2_VSCC_7_reg(data)   (*((volatile unsigned int*) VO_WB2_VSCC_7_reg)=data)
+#define get_VO_WB2_VSCC_0_reg   (*((volatile unsigned int*) VO_WB2_VSCC_0_reg))
+#define get_VO_WB2_VSCC_1_reg   (*((volatile unsigned int*) VO_WB2_VSCC_1_reg))
+#define get_VO_WB2_VSCC_2_reg   (*((volatile unsigned int*) VO_WB2_VSCC_2_reg))
+#define get_VO_WB2_VSCC_3_reg   (*((volatile unsigned int*) VO_WB2_VSCC_3_reg))
+#define get_VO_WB2_VSCC_4_reg   (*((volatile unsigned int*) VO_WB2_VSCC_4_reg))
+#define get_VO_WB2_VSCC_5_reg   (*((volatile unsigned int*) VO_WB2_VSCC_5_reg))
+#define get_VO_WB2_VSCC_6_reg   (*((volatile unsigned int*) VO_WB2_VSCC_6_reg))
+#define get_VO_WB2_VSCC_7_reg   (*((volatile unsigned int*) VO_WB2_VSCC_7_reg))
+#define VO_WB2_VSCC_0_inst_adr                                                       "0x000C"
+#define VO_WB2_VSCC_1_inst_adr                                                       "0x000D"
+#define VO_WB2_VSCC_2_inst_adr                                                       "0x000E"
+#define VO_WB2_VSCC_3_inst_adr                                                       "0x000F"
+#define VO_WB2_VSCC_4_inst_adr                                                       "0x0010"
+#define VO_WB2_VSCC_5_inst_adr                                                       "0x0011"
+#define VO_WB2_VSCC_6_inst_adr                                                       "0x0012"
+#define VO_WB2_VSCC_7_inst_adr                                                       "0x0013"
+#define VO_WB2_VSCC_0_inst                                                           0x000C
+#define VO_WB2_VSCC_1_inst                                                           0x000D
+#define VO_WB2_VSCC_2_inst                                                           0x000E
+#define VO_WB2_VSCC_3_inst                                                           0x000F
+#define VO_WB2_VSCC_4_inst                                                           0x0010
+#define VO_WB2_VSCC_5_inst                                                           0x0011
+#define VO_WB2_VSCC_6_inst                                                           0x0012
+#define VO_WB2_VSCC_7_inst                                                           0x0013
+#define VO_WB2_VSCC_c1_shift                                                         (16)
+#define VO_WB2_VSCC_c1_mask                                                          (0x3FFF0000)
+#define VO_WB2_VSCC_c1(data)                                                         (0x3FFF0000&((data)<<16))
+#define VO_WB2_VSCC_c1_src(data)                                                     ((0x3FFF0000&(data))>>16)
+#define VO_WB2_VSCC_get_c1(data)                                                     ((0x3FFF0000&(data))>>16)
+#define VO_WB2_VSCC_c0_shift                                                         (0)
+#define VO_WB2_VSCC_c0_mask                                                          (0x00003FFF)
+#define VO_WB2_VSCC_c0(data)                                                         (0x00003FFF&((data)<<0))
+#define VO_WB2_VSCC_c0_src(data)                                                     ((0x00003FFF&(data))>>0)
+#define VO_WB2_VSCC_get_c0(data)                                                     ((0x00003FFF&(data))>>0)
+
+
+#define VO_WB2_HSI                                                                   0x98005C50
+#define VO_WB2_HSI_reg_addr                                                          "0xD8005C50"
+#define VO_WB2_HSI_reg                                                               0xD8005C50
+#define set_VO_WB2_HSI_reg(data)   (*((volatile unsigned int*) VO_WB2_HSI_reg)=data)
+#define get_VO_WB2_HSI_reg   (*((volatile unsigned int*) VO_WB2_HSI_reg))
+#define VO_WB2_HSI_inst_adr                                                          "0x0014"
+#define VO_WB2_HSI_inst                                                              0x0014
+#define VO_WB2_HSI_offset_shift                                                      (16)
+#define VO_WB2_HSI_offset_mask                                                       (0x1FFF0000)
+#define VO_WB2_HSI_offset(data)                                                      (0x1FFF0000&((data)<<16))
+#define VO_WB2_HSI_offset_src(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_WB2_HSI_get_offset(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_WB2_HSI_phase_shift                                                       (0)
+#define VO_WB2_HSI_phase_mask                                                        (0x0000FFFF)
+#define VO_WB2_HSI_phase(data)                                                       (0x0000FFFF&((data)<<0))
+#define VO_WB2_HSI_phase_src(data)                                                   ((0x0000FFFF&(data))>>0)
+#define VO_WB2_HSI_get_phase(data)                                                   ((0x0000FFFF&(data))>>0)
+
+
+#define VO_WB2_HSD                                                                   0x98005C54
+#define VO_WB2_HSD_reg_addr                                                          "0xD8005C54"
+#define VO_WB2_HSD_reg                                                               0xD8005C54
+#define set_VO_WB2_HSD_reg(data)   (*((volatile unsigned int*) VO_WB2_HSD_reg)=data)
+#define get_VO_WB2_HSD_reg   (*((volatile unsigned int*) VO_WB2_HSD_reg))
+#define VO_WB2_HSD_inst_adr                                                          "0x0015"
+#define VO_WB2_HSD_inst                                                              0x0015
+#define VO_WB2_HSD_delta_shift                                                       (0)
+#define VO_WB2_HSD_delta_mask                                                        (0x001FFFFF)
+#define VO_WB2_HSD_delta(data)                                                       (0x001FFFFF&((data)<<0))
+#define VO_WB2_HSD_delta_src(data)                                                   ((0x001FFFFF&(data))>>0)
+#define VO_WB2_HSD_get_delta(data)                                                   ((0x001FFFFF&(data))>>0)
+
+
+#define VO_WB2_HSD_W                                                                 0x98005C58
+#define VO_WB2_HSD_W_reg_addr                                                        "0xD8005C58"
+#define VO_WB2_HSD_W_reg                                                             0xD8005C58
+#define set_VO_WB2_HSD_W_reg(data)   (*((volatile unsigned int*) VO_WB2_HSD_W_reg)=data)
+#define get_VO_WB2_HSD_W_reg   (*((volatile unsigned int*) VO_WB2_HSD_W_reg))
+#define VO_WB2_HSD_W_inst_adr                                                        "0x0016"
+#define VO_WB2_HSD_W_inst                                                            0x0016
+#define VO_WB2_HSD_W_out_shift                                                       (0)
+#define VO_WB2_HSD_W_out_mask                                                        (0x00001FFF)
+#define VO_WB2_HSD_W_out(data)                                                       (0x00001FFF&((data)<<0))
+#define VO_WB2_HSD_W_out_src(data)                                                   ((0x00001FFF&(data))>>0)
+#define VO_WB2_HSD_W_get_out(data)                                                   ((0x00001FFF&(data))>>0)
+
+
+#define VO_WB2_HSYC_0                                                                0x98005C5C
+#define VO_WB2_HSYC_1                                                                0x98005C60
+#define VO_WB2_HSYC_2                                                                0x98005C64
+#define VO_WB2_HSYC_3                                                                0x98005C68
+#define VO_WB2_HSYC_4                                                                0x98005C6C
+#define VO_WB2_HSYC_5                                                                0x98005C70
+#define VO_WB2_HSYC_6                                                                0x98005C74
+#define VO_WB2_HSYC_7                                                                0x98005C78
+#define VO_WB2_HSYC_8                                                                0x98005C7C
+#define VO_WB2_HSYC_9                                                                0x98005C80
+#define VO_WB2_HSYC_10                                                                0x98005C84
+#define VO_WB2_HSYC_11                                                                0x98005C88
+#define VO_WB2_HSYC_12                                                                0x98005C8C
+#define VO_WB2_HSYC_13                                                                0x98005C90
+#define VO_WB2_HSYC_14                                                                0x98005C94
+#define VO_WB2_HSYC_15                                                                0x98005C98
+#define VO_WB2_HSYC_0_reg_addr                                                       "0xD8005C5C"
+#define VO_WB2_HSYC_1_reg_addr                                                       "0xD8005C60"
+#define VO_WB2_HSYC_2_reg_addr                                                       "0xD8005C64"
+#define VO_WB2_HSYC_3_reg_addr                                                       "0xD8005C68"
+#define VO_WB2_HSYC_4_reg_addr                                                       "0xD8005C6C"
+#define VO_WB2_HSYC_5_reg_addr                                                       "0xD8005C70"
+#define VO_WB2_HSYC_6_reg_addr                                                       "0xD8005C74"
+#define VO_WB2_HSYC_7_reg_addr                                                       "0xD8005C78"
+#define VO_WB2_HSYC_8_reg_addr                                                       "0xD8005C7C"
+#define VO_WB2_HSYC_9_reg_addr                                                       "0xD8005C80"
+#define VO_WB2_HSYC_10_reg_addr                                                       "0xD8005C84"
+#define VO_WB2_HSYC_11_reg_addr                                                       "0xD8005C88"
+#define VO_WB2_HSYC_12_reg_addr                                                       "0xD8005C8C"
+#define VO_WB2_HSYC_13_reg_addr                                                       "0xD8005C90"
+#define VO_WB2_HSYC_14_reg_addr                                                       "0xD8005C94"
+#define VO_WB2_HSYC_15_reg_addr                                                       "0xD8005C98"
+#define VO_WB2_HSYC_0_reg                                                            0xD8005C5C
+#define VO_WB2_HSYC_1_reg                                                            0xD8005C60
+#define VO_WB2_HSYC_2_reg                                                            0xD8005C64
+#define VO_WB2_HSYC_3_reg                                                            0xD8005C68
+#define VO_WB2_HSYC_4_reg                                                            0xD8005C6C
+#define VO_WB2_HSYC_5_reg                                                            0xD8005C70
+#define VO_WB2_HSYC_6_reg                                                            0xD8005C74
+#define VO_WB2_HSYC_7_reg                                                            0xD8005C78
+#define VO_WB2_HSYC_8_reg                                                            0xD8005C7C
+#define VO_WB2_HSYC_9_reg                                                            0xD8005C80
+#define VO_WB2_HSYC_10_reg                                                            0xD8005C84
+#define VO_WB2_HSYC_11_reg                                                            0xD8005C88
+#define VO_WB2_HSYC_12_reg                                                            0xD8005C8C
+#define VO_WB2_HSYC_13_reg                                                            0xD8005C90
+#define VO_WB2_HSYC_14_reg                                                            0xD8005C94
+#define VO_WB2_HSYC_15_reg                                                            0xD8005C98
+#define set_VO_WB2_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_0_reg)=data)
+#define set_VO_WB2_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_1_reg)=data)
+#define set_VO_WB2_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_2_reg)=data)
+#define set_VO_WB2_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_3_reg)=data)
+#define set_VO_WB2_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_4_reg)=data)
+#define set_VO_WB2_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_5_reg)=data)
+#define set_VO_WB2_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_6_reg)=data)
+#define set_VO_WB2_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_7_reg)=data)
+#define set_VO_WB2_HSYC_8_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_8_reg)=data)
+#define set_VO_WB2_HSYC_9_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_9_reg)=data)
+#define set_VO_WB2_HSYC_10_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_10_reg)=data)
+#define set_VO_WB2_HSYC_11_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_11_reg)=data)
+#define set_VO_WB2_HSYC_12_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_12_reg)=data)
+#define set_VO_WB2_HSYC_13_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_13_reg)=data)
+#define set_VO_WB2_HSYC_14_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_14_reg)=data)
+#define set_VO_WB2_HSYC_15_reg(data)   (*((volatile unsigned int*) VO_WB2_HSYC_15_reg)=data)
+#define get_VO_WB2_HSYC_0_reg   (*((volatile unsigned int*) VO_WB2_HSYC_0_reg))
+#define get_VO_WB2_HSYC_1_reg   (*((volatile unsigned int*) VO_WB2_HSYC_1_reg))
+#define get_VO_WB2_HSYC_2_reg   (*((volatile unsigned int*) VO_WB2_HSYC_2_reg))
+#define get_VO_WB2_HSYC_3_reg   (*((volatile unsigned int*) VO_WB2_HSYC_3_reg))
+#define get_VO_WB2_HSYC_4_reg   (*((volatile unsigned int*) VO_WB2_HSYC_4_reg))
+#define get_VO_WB2_HSYC_5_reg   (*((volatile unsigned int*) VO_WB2_HSYC_5_reg))
+#define get_VO_WB2_HSYC_6_reg   (*((volatile unsigned int*) VO_WB2_HSYC_6_reg))
+#define get_VO_WB2_HSYC_7_reg   (*((volatile unsigned int*) VO_WB2_HSYC_7_reg))
+#define get_VO_WB2_HSYC_8_reg   (*((volatile unsigned int*) VO_WB2_HSYC_8_reg))
+#define get_VO_WB2_HSYC_9_reg   (*((volatile unsigned int*) VO_WB2_HSYC_9_reg))
+#define get_VO_WB2_HSYC_10_reg   (*((volatile unsigned int*) VO_WB2_HSYC_10_reg))
+#define get_VO_WB2_HSYC_11_reg   (*((volatile unsigned int*) VO_WB2_HSYC_11_reg))
+#define get_VO_WB2_HSYC_12_reg   (*((volatile unsigned int*) VO_WB2_HSYC_12_reg))
+#define get_VO_WB2_HSYC_13_reg   (*((volatile unsigned int*) VO_WB2_HSYC_13_reg))
+#define get_VO_WB2_HSYC_14_reg   (*((volatile unsigned int*) VO_WB2_HSYC_14_reg))
+#define get_VO_WB2_HSYC_15_reg   (*((volatile unsigned int*) VO_WB2_HSYC_15_reg))
+#define VO_WB2_HSYC_0_inst_adr                                                       "0x0017"
+#define VO_WB2_HSYC_1_inst_adr                                                       "0x0018"
+#define VO_WB2_HSYC_2_inst_adr                                                       "0x0019"
+#define VO_WB2_HSYC_3_inst_adr                                                       "0x001A"
+#define VO_WB2_HSYC_4_inst_adr                                                       "0x001B"
+#define VO_WB2_HSYC_5_inst_adr                                                       "0x001C"
+#define VO_WB2_HSYC_6_inst_adr                                                       "0x001D"
+#define VO_WB2_HSYC_7_inst_adr                                                       "0x001E"
+#define VO_WB2_HSYC_8_inst_adr                                                       "0x001F"
+#define VO_WB2_HSYC_9_inst_adr                                                       "0x0020"
+#define VO_WB2_HSYC_10_inst_adr                                                       "0x0021"
+#define VO_WB2_HSYC_11_inst_adr                                                       "0x0022"
+#define VO_WB2_HSYC_12_inst_adr                                                       "0x0023"
+#define VO_WB2_HSYC_13_inst_adr                                                       "0x0024"
+#define VO_WB2_HSYC_14_inst_adr                                                       "0x0025"
+#define VO_WB2_HSYC_15_inst_adr                                                       "0x0026"
+#define VO_WB2_HSYC_0_inst                                                           0x0017
+#define VO_WB2_HSYC_1_inst                                                           0x0018
+#define VO_WB2_HSYC_2_inst                                                           0x0019
+#define VO_WB2_HSYC_3_inst                                                           0x001A
+#define VO_WB2_HSYC_4_inst                                                           0x001B
+#define VO_WB2_HSYC_5_inst                                                           0x001C
+#define VO_WB2_HSYC_6_inst                                                           0x001D
+#define VO_WB2_HSYC_7_inst                                                           0x001E
+#define VO_WB2_HSYC_8_inst                                                           0x001F
+#define VO_WB2_HSYC_9_inst                                                           0x0020
+#define VO_WB2_HSYC_10_inst                                                           0x0021
+#define VO_WB2_HSYC_11_inst                                                           0x0022
+#define VO_WB2_HSYC_12_inst                                                           0x0023
+#define VO_WB2_HSYC_13_inst                                                           0x0024
+#define VO_WB2_HSYC_14_inst                                                           0x0025
+#define VO_WB2_HSYC_15_inst                                                           0x0026
+#define VO_WB2_HSYC_c1_shift                                                         (16)
+#define VO_WB2_HSYC_c1_mask                                                          (0x3FFF0000)
+#define VO_WB2_HSYC_c1(data)                                                         (0x3FFF0000&((data)<<16))
+#define VO_WB2_HSYC_c1_src(data)                                                     ((0x3FFF0000&(data))>>16)
+#define VO_WB2_HSYC_get_c1(data)                                                     ((0x3FFF0000&(data))>>16)
+#define VO_WB2_HSYC_c0_shift                                                         (0)
+#define VO_WB2_HSYC_c0_mask                                                          (0x00003FFF)
+#define VO_WB2_HSYC_c0(data)                                                         (0x00003FFF&((data)<<0))
+#define VO_WB2_HSYC_c0_src(data)                                                     ((0x00003FFF&(data))>>0)
+#define VO_WB2_HSYC_get_c0(data)                                                     ((0x00003FFF&(data))>>0)
+
+
+#define VO_WB2_HSCC_0                                                                0x98005C9C
+#define VO_WB2_HSCC_1                                                                0x98005CA0
+#define VO_WB2_HSCC_2                                                                0x98005CA4
+#define VO_WB2_HSCC_3                                                                0x98005CA8
+#define VO_WB2_HSCC_4                                                                0x98005CAC
+#define VO_WB2_HSCC_5                                                                0x98005CB0
+#define VO_WB2_HSCC_6                                                                0x98005CB4
+#define VO_WB2_HSCC_7                                                                0x98005CB8
+#define VO_WB2_HSCC_0_reg_addr                                                       "0xD8005C9C"
+#define VO_WB2_HSCC_1_reg_addr                                                       "0xD8005CA0"
+#define VO_WB2_HSCC_2_reg_addr                                                       "0xD8005CA4"
+#define VO_WB2_HSCC_3_reg_addr                                                       "0xD8005CA8"
+#define VO_WB2_HSCC_4_reg_addr                                                       "0xD8005CAC"
+#define VO_WB2_HSCC_5_reg_addr                                                       "0xD8005CB0"
+#define VO_WB2_HSCC_6_reg_addr                                                       "0xD8005CB4"
+#define VO_WB2_HSCC_7_reg_addr                                                       "0xD8005CB8"
+#define VO_WB2_HSCC_0_reg                                                            0xD8005C9C
+#define VO_WB2_HSCC_1_reg                                                            0xD8005CA0
+#define VO_WB2_HSCC_2_reg                                                            0xD8005CA4
+#define VO_WB2_HSCC_3_reg                                                            0xD8005CA8
+#define VO_WB2_HSCC_4_reg                                                            0xD8005CAC
+#define VO_WB2_HSCC_5_reg                                                            0xD8005CB0
+#define VO_WB2_HSCC_6_reg                                                            0xD8005CB4
+#define VO_WB2_HSCC_7_reg                                                            0xD8005CB8
+#define set_VO_WB2_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_WB2_HSCC_0_reg)=data)
+#define set_VO_WB2_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_WB2_HSCC_1_reg)=data)
+#define set_VO_WB2_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_WB2_HSCC_2_reg)=data)
+#define set_VO_WB2_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_WB2_HSCC_3_reg)=data)
+#define set_VO_WB2_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_WB2_HSCC_4_reg)=data)
+#define set_VO_WB2_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_WB2_HSCC_5_reg)=data)
+#define set_VO_WB2_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_WB2_HSCC_6_reg)=data)
+#define set_VO_WB2_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_WB2_HSCC_7_reg)=data)
+#define get_VO_WB2_HSCC_0_reg   (*((volatile unsigned int*) VO_WB2_HSCC_0_reg))
+#define get_VO_WB2_HSCC_1_reg   (*((volatile unsigned int*) VO_WB2_HSCC_1_reg))
+#define get_VO_WB2_HSCC_2_reg   (*((volatile unsigned int*) VO_WB2_HSCC_2_reg))
+#define get_VO_WB2_HSCC_3_reg   (*((volatile unsigned int*) VO_WB2_HSCC_3_reg))
+#define get_VO_WB2_HSCC_4_reg   (*((volatile unsigned int*) VO_WB2_HSCC_4_reg))
+#define get_VO_WB2_HSCC_5_reg   (*((volatile unsigned int*) VO_WB2_HSCC_5_reg))
+#define get_VO_WB2_HSCC_6_reg   (*((volatile unsigned int*) VO_WB2_HSCC_6_reg))
+#define get_VO_WB2_HSCC_7_reg   (*((volatile unsigned int*) VO_WB2_HSCC_7_reg))
+#define VO_WB2_HSCC_0_inst_adr                                                       "0x0027"
+#define VO_WB2_HSCC_1_inst_adr                                                       "0x0028"
+#define VO_WB2_HSCC_2_inst_adr                                                       "0x0029"
+#define VO_WB2_HSCC_3_inst_adr                                                       "0x002A"
+#define VO_WB2_HSCC_4_inst_adr                                                       "0x002B"
+#define VO_WB2_HSCC_5_inst_adr                                                       "0x002C"
+#define VO_WB2_HSCC_6_inst_adr                                                       "0x002D"
+#define VO_WB2_HSCC_7_inst_adr                                                       "0x002E"
+#define VO_WB2_HSCC_0_inst                                                           0x0027
+#define VO_WB2_HSCC_1_inst                                                           0x0028
+#define VO_WB2_HSCC_2_inst                                                           0x0029
+#define VO_WB2_HSCC_3_inst                                                           0x002A
+#define VO_WB2_HSCC_4_inst                                                           0x002B
+#define VO_WB2_HSCC_5_inst                                                           0x002C
+#define VO_WB2_HSCC_6_inst                                                           0x002D
+#define VO_WB2_HSCC_7_inst                                                           0x002E
+#define VO_WB2_HSCC_c1_shift                                                         (16)
+#define VO_WB2_HSCC_c1_mask                                                          (0x3FFF0000)
+#define VO_WB2_HSCC_c1(data)                                                         (0x3FFF0000&((data)<<16))
+#define VO_WB2_HSCC_c1_src(data)                                                     ((0x3FFF0000&(data))>>16)
+#define VO_WB2_HSCC_get_c1(data)                                                     ((0x3FFF0000&(data))>>16)
+#define VO_WB2_HSCC_c0_shift                                                         (0)
+#define VO_WB2_HSCC_c0_mask                                                          (0x00003FFF)
+#define VO_WB2_HSCC_c0(data)                                                         (0x00003FFF&((data)<<0))
+#define VO_WB2_HSCC_c0_src(data)                                                     ((0x00003FFF&(data))>>0)
+#define VO_WB2_HSCC_get_c0(data)                                                     ((0x00003FFF&(data))>>0)
+
+
+#define VO_VBI                                                                       0x98005CBC
+#define VO_VBI_reg_addr                                                              "0xD8005CBC"
+#define VO_VBI_reg                                                                   0xD8005CBC
+#define set_VO_VBI_reg(data)   (*((volatile unsigned int*) VO_VBI_reg)=data)
+#define get_VO_VBI_reg   (*((volatile unsigned int*) VO_VBI_reg))
+#define VO_VBI_inst_adr                                                              "0x002F"
+#define VO_VBI_inst                                                                  0x002F
+#define VO_VBI_a_shift                                                               (0)
+#define VO_VBI_a_mask                                                                (0xFFFFFFFF)
+#define VO_VBI_a(data)                                                               (0xFFFFFFFF&((data)<<0))
+#define VO_VBI_a_src(data)                                                           ((0xFFFFFFFF&(data))>>0)
+#define VO_VBI_get_a(data)                                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_VBI_SIZE                                                                  0x98005CC0
+#define VO_VBI_SIZE_reg_addr                                                         "0xD8005CC0"
+#define VO_VBI_SIZE_reg                                                              0xD8005CC0
+#define set_VO_VBI_SIZE_reg(data)   (*((volatile unsigned int*) VO_VBI_SIZE_reg)=data)
+#define get_VO_VBI_SIZE_reg   (*((volatile unsigned int*) VO_VBI_SIZE_reg))
+#define VO_VBI_SIZE_inst_adr                                                         "0x0030"
+#define VO_VBI_SIZE_inst                                                             0x0030
+#define VO_VBI_SIZE_l_shift                                                          (0)
+#define VO_VBI_SIZE_l_mask                                                           (0x0003FFFF)
+#define VO_VBI_SIZE_l(data)                                                          (0x0003FFFF&((data)<<0))
+#define VO_VBI_SIZE_l_src(data)                                                      ((0x0003FFFF&(data))>>0)
+#define VO_VBI_SIZE_get_l(data)                                                      ((0x0003FFFF&(data))>>0)
+
+
+#define VO_DMA                                                                       0x98005CC4
+#define VO_DMA_reg_addr                                                              "0xD8005CC4"
+#define VO_DMA_reg                                                                   0xD8005CC4
+#define set_VO_DMA_reg(data)   (*((volatile unsigned int*) VO_DMA_reg)=data)
+#define get_VO_DMA_reg   (*((volatile unsigned int*) VO_DMA_reg))
+#define VO_DMA_inst_adr                                                              "0x0031"
+#define VO_DMA_inst                                                                  0x0031
+#define VO_DMA_write_en6_shift                                                       (22)
+#define VO_DMA_write_en6_mask                                                        (0x00400000)
+#define VO_DMA_write_en6(data)                                                       (0x00400000&((data)<<22))
+#define VO_DMA_write_en6_src(data)                                                   ((0x00400000&(data))>>22)
+#define VO_DMA_get_write_en6(data)                                                   ((0x00400000&(data))>>22)
+#define VO_DMA_w_l_shift                                                             (16)
+#define VO_DMA_w_l_mask                                                              (0x003F0000)
+#define VO_DMA_w_l(data)                                                             (0x003F0000&((data)<<16))
+#define VO_DMA_w_l_src(data)                                                         ((0x003F0000&(data))>>16)
+#define VO_DMA_get_w_l(data)                                                         ((0x003F0000&(data))>>16)
+#define VO_DMA_write_en5_shift                                                       (15)
+#define VO_DMA_write_en5_mask                                                        (0x00008000)
+#define VO_DMA_write_en5(data)                                                       (0x00008000&((data)<<15))
+#define VO_DMA_write_en5_src(data)                                                   ((0x00008000&(data))>>15)
+#define VO_DMA_get_write_en5(data)                                                   ((0x00008000&(data))>>15)
+#define VO_DMA_rdata_as_mode_shift                                                   (14)
+#define VO_DMA_rdata_as_mode_mask                                                    (0x00004000)
+#define VO_DMA_rdata_as_mode(data)                                                   (0x00004000&((data)<<14))
+#define VO_DMA_rdata_as_mode_src(data)                                               ((0x00004000&(data))>>14)
+#define VO_DMA_get_rdata_as_mode(data)                                               ((0x00004000&(data))>>14)
+#define VO_DMA_write_en4_shift                                                       (13)
+#define VO_DMA_write_en4_mask                                                        (0x00002000)
+#define VO_DMA_write_en4(data)                                                       (0x00002000&((data)<<13))
+#define VO_DMA_write_en4_src(data)                                                   ((0x00002000&(data))>>13)
+#define VO_DMA_get_write_en4(data)                                                   ((0x00002000&(data))>>13)
+#define VO_DMA_num_req_8_shift                                                       (12)
+#define VO_DMA_num_req_8_mask                                                        (0x00001000)
+#define VO_DMA_num_req_8(data)                                                       (0x00001000&((data)<<12))
+#define VO_DMA_num_req_8_src(data)                                                   ((0x00001000&(data))>>12)
+#define VO_DMA_get_num_req_8(data)                                                   ((0x00001000&(data))>>12)
+#define VO_DMA_write_en3_shift                                                       (11)
+#define VO_DMA_write_en3_mask                                                        (0x00000800)
+#define VO_DMA_write_en3(data)                                                       (0x00000800&((data)<<11))
+#define VO_DMA_write_en3_src(data)                                                   ((0x00000800&(data))>>11)
+#define VO_DMA_get_write_en3(data)                                                   ((0x00000800&(data))>>11)
+#define VO_DMA_dyn_id_shift                                                          (10)
+#define VO_DMA_dyn_id_mask                                                           (0x00000400)
+#define VO_DMA_dyn_id(data)                                                          (0x00000400&((data)<<10))
+#define VO_DMA_dyn_id_src(data)                                                      ((0x00000400&(data))>>10)
+#define VO_DMA_get_dyn_id(data)                                                      ((0x00000400&(data))>>10)
+#define VO_DMA_write_en2_shift                                                       (9)
+#define VO_DMA_write_en2_mask                                                        (0x00000200)
+#define VO_DMA_write_en2(data)                                                       (0x00000200&((data)<<9))
+#define VO_DMA_write_en2_src(data)                                                   ((0x00000200&(data))>>9)
+#define VO_DMA_get_write_en2(data)                                                   ((0x00000200&(data))>>9)
+#define VO_DMA_ref_mix_shift                                                         (8)
+#define VO_DMA_ref_mix_mask                                                          (0x00000100)
+#define VO_DMA_ref_mix(data)                                                         (0x00000100&((data)<<8))
+#define VO_DMA_ref_mix_src(data)                                                     ((0x00000100&(data))>>8)
+#define VO_DMA_get_ref_mix(data)                                                     ((0x00000100&(data))>>8)
+#define VO_DMA_write_en1_shift                                                       (6)
+#define VO_DMA_write_en1_mask                                                        (0x00000040)
+#define VO_DMA_write_en1(data)                                                       (0x00000040&((data)<<6))
+#define VO_DMA_write_en1_src(data)                                                   ((0x00000040&(data))>>6)
+#define VO_DMA_get_write_en1(data)                                                   ((0x00000040&(data))>>6)
+#define VO_DMA_l_shift                                                               (0)
+#define VO_DMA_l_mask                                                                (0x0000003F)
+#define VO_DMA_l(data)                                                               (0x0000003F&((data)<<0))
+#define VO_DMA_l_src(data)                                                           ((0x0000003F&(data))>>0)
+#define VO_DMA_get_l(data)                                                           ((0x0000003F&(data))>>0)
+
+
+#define VO_DMA_PV                                                                    0x98005CC8
+#define VO_DMA_PV_reg_addr                                                           "0xD8005CC8"
+#define VO_DMA_PV_reg                                                                0xD8005CC8
+#define set_VO_DMA_PV_reg(data)   (*((volatile unsigned int*) VO_DMA_PV_reg)=data)
+#define get_VO_DMA_PV_reg   (*((volatile unsigned int*) VO_DMA_PV_reg))
+#define VO_DMA_PV_inst_adr                                                           "0x0032"
+#define VO_DMA_PV_inst                                                               0x0032
+#define VO_DMA_PV_wb2_shift                                                          (20)
+#define VO_DMA_PV_wb2_mask                                                           (0x00F00000)
+#define VO_DMA_PV_wb2(data)                                                          (0x00F00000&((data)<<20))
+#define VO_DMA_PV_wb2_src(data)                                                      ((0x00F00000&(data))>>20)
+#define VO_DMA_PV_get_wb2(data)                                                      ((0x00F00000&(data))>>20)
+#define VO_DMA_PV_wb1_shift                                                          (16)
+#define VO_DMA_PV_wb1_mask                                                           (0x000F0000)
+#define VO_DMA_PV_wb1(data)                                                          (0x000F0000&((data)<<16))
+#define VO_DMA_PV_wb1_src(data)                                                      ((0x000F0000&(data))>>16)
+#define VO_DMA_PV_get_wb1(data)                                                      ((0x000F0000&(data))>>16)
+#define VO_DMA_PV_vbi_shift                                                          (12)
+#define VO_DMA_PV_vbi_mask                                                           (0x0000F000)
+#define VO_DMA_PV_vbi(data)                                                          (0x0000F000&((data)<<12))
+#define VO_DMA_PV_vbi_src(data)                                                      ((0x0000F000&(data))>>12)
+#define VO_DMA_PV_get_vbi(data)                                                      ((0x0000F000&(data))>>12)
+#define VO_DMA_PV_dd_shift                                                           (8)
+#define VO_DMA_PV_dd_mask                                                            (0x00000F00)
+#define VO_DMA_PV_dd(data)                                                           (0x00000F00&((data)<<8))
+#define VO_DMA_PV_dd_src(data)                                                       ((0x00000F00&(data))>>8)
+#define VO_DMA_PV_get_dd(data)                                                       ((0x00000F00&(data))>>8)
+#define VO_DMA_PV_v2_shift                                                           (4)
+#define VO_DMA_PV_v2_mask                                                            (0x000000F0)
+#define VO_DMA_PV_v2(data)                                                           (0x000000F0&((data)<<4))
+#define VO_DMA_PV_v2_src(data)                                                       ((0x000000F0&(data))>>4)
+#define VO_DMA_PV_get_v2(data)                                                       ((0x000000F0&(data))>>4)
+#define VO_DMA_PV_v1_shift                                                           (0)
+#define VO_DMA_PV_v1_mask                                                            (0x0000000F)
+#define VO_DMA_PV_v1(data)                                                           (0x0000000F&((data)<<0))
+#define VO_DMA_PV_v1_src(data)                                                       ((0x0000000F&(data))>>0)
+#define VO_DMA_PV_get_v1(data)                                                       ((0x0000000F&(data))>>0)
+
+
+#define VO_DMA_PG                                                                    0x98005CCC
+#define VO_DMA_PG_reg_addr                                                           "0xD8005CCC"
+#define VO_DMA_PG_reg                                                                0xD8005CCC
+#define set_VO_DMA_PG_reg(data)   (*((volatile unsigned int*) VO_DMA_PG_reg)=data)
+#define get_VO_DMA_PG_reg   (*((volatile unsigned int*) VO_DMA_PG_reg))
+#define VO_DMA_PG_inst_adr                                                           "0x0033"
+#define VO_DMA_PG_inst                                                               0x0033
+#define VO_DMA_PG_csr_shift                                                          (12)
+#define VO_DMA_PG_csr_mask                                                           (0x0000F000)
+#define VO_DMA_PG_csr(data)                                                          (0x0000F000&((data)<<12))
+#define VO_DMA_PG_csr_src(data)                                                      ((0x0000F000&(data))>>12)
+#define VO_DMA_PG_get_csr(data)                                                      ((0x0000F000&(data))>>12)
+#define VO_DMA_PG_sub2_shift                                                         (8)
+#define VO_DMA_PG_sub2_mask                                                          (0x00000F00)
+#define VO_DMA_PG_sub2(data)                                                         (0x00000F00&((data)<<8))
+#define VO_DMA_PG_sub2_src(data)                                                     ((0x00000F00&(data))>>8)
+#define VO_DMA_PG_get_sub2(data)                                                     ((0x00000F00&(data))>>8)
+#define VO_DMA_PG_osd1_shift                                                         (4)
+#define VO_DMA_PG_osd1_mask                                                          (0x000000F0)
+#define VO_DMA_PG_osd1(data)                                                         (0x000000F0&((data)<<4))
+#define VO_DMA_PG_osd1_src(data)                                                     ((0x000000F0&(data))>>4)
+#define VO_DMA_PG_get_osd1(data)                                                     ((0x000000F0&(data))>>4)
+#define VO_DMA_PG_sub1_shift                                                         (0)
+#define VO_DMA_PG_sub1_mask                                                          (0x0000000F)
+#define VO_DMA_PG_sub1(data)                                                         (0x0000000F&((data)<<0))
+#define VO_DMA_PG_sub1_src(data)                                                     ((0x0000000F&(data))>>0)
+#define VO_DMA_PG_get_sub1(data)                                                     ((0x0000000F&(data))>>0)
+
+
+#define VO_DMA_BWC                                                                   0x98005CD0
+#define VO_DMA_BWC_reg_addr                                                          "0xD8005CD0"
+#define VO_DMA_BWC_reg                                                               0xD8005CD0
+#define set_VO_DMA_BWC_reg(data)   (*((volatile unsigned int*) VO_DMA_BWC_reg)=data)
+#define get_VO_DMA_BWC_reg   (*((volatile unsigned int*) VO_DMA_BWC_reg))
+#define VO_DMA_BWC_inst_adr                                                          "0x0034"
+#define VO_DMA_BWC_inst                                                              0x0034
+#define VO_DMA_BWC_write_en3_shift                                                   (28)
+#define VO_DMA_BWC_write_en3_mask                                                    (0x10000000)
+#define VO_DMA_BWC_write_en3(data)                                                   (0x10000000&((data)<<28))
+#define VO_DMA_BWC_write_en3_src(data)                                               ((0x10000000&(data))>>28)
+#define VO_DMA_BWC_get_write_en3(data)                                               ((0x10000000&(data))>>28)
+#define VO_DMA_BWC_init_shift                                                        (20)
+#define VO_DMA_BWC_init_mask                                                         (0x0FF00000)
+#define VO_DMA_BWC_init(data)                                                        (0x0FF00000&((data)<<20))
+#define VO_DMA_BWC_init_src(data)                                                    ((0x0FF00000&(data))>>20)
+#define VO_DMA_BWC_get_init(data)                                                    ((0x0FF00000&(data))>>20)
+#define VO_DMA_BWC_write_en2_shift                                                   (16)
+#define VO_DMA_BWC_write_en2_mask                                                    (0x00010000)
+#define VO_DMA_BWC_write_en2(data)                                                   (0x00010000&((data)<<16))
+#define VO_DMA_BWC_write_en2_src(data)                                               ((0x00010000&(data))>>16)
+#define VO_DMA_BWC_get_write_en2(data)                                               ((0x00010000&(data))>>16)
+#define VO_DMA_BWC_interval_shift                                                    (8)
+#define VO_DMA_BWC_interval_mask                                                     (0x0000FF00)
+#define VO_DMA_BWC_interval(data)                                                    (0x0000FF00&((data)<<8))
+#define VO_DMA_BWC_interval_src(data)                                                ((0x0000FF00&(data))>>8)
+#define VO_DMA_BWC_get_interval(data)                                                ((0x0000FF00&(data))>>8)
+#define VO_DMA_BWC_write_en1_shift                                                   (5)
+#define VO_DMA_BWC_write_en1_mask                                                    (0x00000020)
+#define VO_DMA_BWC_write_en1(data)                                                   (0x00000020&((data)<<5))
+#define VO_DMA_BWC_write_en1_src(data)                                               ((0x00000020&(data))>>5)
+#define VO_DMA_BWC_get_write_en1(data)                                               ((0x00000020&(data))>>5)
+#define VO_DMA_BWC_num_shift                                                         (0)
+#define VO_DMA_BWC_num_mask                                                          (0x0000001F)
+#define VO_DMA_BWC_num(data)                                                         (0x0000001F&((data)<<0))
+#define VO_DMA_BWC_num_src(data)                                                     ((0x0000001F&(data))>>0)
+#define VO_DMA_BWC_get_num(data)                                                     ((0x0000001F&(data))>>0)
+
+
+#define VO_DMA_UPDATE                                                                0x98005CD4
+#define VO_DMA_UPDATE_reg_addr                                                       "0xD8005CD4"
+#define VO_DMA_UPDATE_reg                                                            0xD8005CD4
+#define set_VO_DMA_UPDATE_reg(data)   (*((volatile unsigned int*) VO_DMA_UPDATE_reg)=data)
+#define get_VO_DMA_UPDATE_reg   (*((volatile unsigned int*) VO_DMA_UPDATE_reg))
+#define VO_DMA_UPDATE_inst_adr                                                       "0x0035"
+#define VO_DMA_UPDATE_inst                                                           0x0035
+#define VO_DMA_UPDATE_update_shift                                                   (1)
+#define VO_DMA_UPDATE_update_mask                                                    (0x00000002)
+#define VO_DMA_UPDATE_update(data)                                                   (0x00000002&((data)<<1))
+#define VO_DMA_UPDATE_update_src(data)                                               ((0x00000002&(data))>>1)
+#define VO_DMA_UPDATE_get_update(data)                                               ((0x00000002&(data))>>1)
+#define VO_DMA_UPDATE_write_data_shift                                               (0)
+#define VO_DMA_UPDATE_write_data_mask                                                (0x00000001)
+#define VO_DMA_UPDATE_write_data(data)                                               (0x00000001&((data)<<0))
+#define VO_DMA_UPDATE_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define VO_DMA_UPDATE_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define VO_DMA_V1_Y0                                                                 0x98005CD8
+#define VO_DMA_V1_Y0_reg_addr                                                        "0xD8005CD8"
+#define VO_DMA_V1_Y0_reg                                                             0xD8005CD8
+#define set_VO_DMA_V1_Y0_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_Y0_reg)=data)
+#define get_VO_DMA_V1_Y0_reg   (*((volatile unsigned int*) VO_DMA_V1_Y0_reg))
+#define VO_DMA_V1_Y0_inst_adr                                                        "0x0036"
+#define VO_DMA_V1_Y0_inst                                                            0x0036
+#define VO_DMA_V1_Y0_depth_shift                                                     (16)
+#define VO_DMA_V1_Y0_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V1_Y0_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V1_Y0_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_Y0_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_Y0_sa_shift                                                        (0)
+#define VO_DMA_V1_Y0_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V1_Y0_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V1_Y0_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V1_Y0_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V1_Y1                                                                 0x98005CDC
+#define VO_DMA_V1_Y1_reg_addr                                                        "0xD8005CDC"
+#define VO_DMA_V1_Y1_reg                                                             0xD8005CDC
+#define set_VO_DMA_V1_Y1_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_Y1_reg)=data)
+#define get_VO_DMA_V1_Y1_reg   (*((volatile unsigned int*) VO_DMA_V1_Y1_reg))
+#define VO_DMA_V1_Y1_inst_adr                                                        "0x0037"
+#define VO_DMA_V1_Y1_inst                                                            0x0037
+#define VO_DMA_V1_Y1_depth_shift                                                     (16)
+#define VO_DMA_V1_Y1_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V1_Y1_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V1_Y1_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_Y1_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_Y1_sa_shift                                                        (0)
+#define VO_DMA_V1_Y1_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V1_Y1_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V1_Y1_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V1_Y1_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V1_Y2                                                                 0x98005CE0
+#define VO_DMA_V1_Y2_reg_addr                                                        "0xD8005CE0"
+#define VO_DMA_V1_Y2_reg                                                             0xD8005CE0
+#define set_VO_DMA_V1_Y2_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_Y2_reg)=data)
+#define get_VO_DMA_V1_Y2_reg   (*((volatile unsigned int*) VO_DMA_V1_Y2_reg))
+#define VO_DMA_V1_Y2_inst_adr                                                        "0x0038"
+#define VO_DMA_V1_Y2_inst                                                            0x0038
+#define VO_DMA_V1_Y2_depth_shift                                                     (16)
+#define VO_DMA_V1_Y2_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V1_Y2_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V1_Y2_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_Y2_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_Y2_sa_shift                                                        (0)
+#define VO_DMA_V1_Y2_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V1_Y2_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V1_Y2_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V1_Y2_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V1_Y3                                                                 0x98005CE4
+#define VO_DMA_V1_Y3_reg_addr                                                        "0xD8005CE4"
+#define VO_DMA_V1_Y3_reg                                                             0xD8005CE4
+#define set_VO_DMA_V1_Y3_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_Y3_reg)=data)
+#define get_VO_DMA_V1_Y3_reg   (*((volatile unsigned int*) VO_DMA_V1_Y3_reg))
+#define VO_DMA_V1_Y3_inst_adr                                                        "0x0039"
+#define VO_DMA_V1_Y3_inst                                                            0x0039
+#define VO_DMA_V1_Y3_depth_shift                                                     (16)
+#define VO_DMA_V1_Y3_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V1_Y3_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V1_Y3_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_Y3_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_Y3_sa_shift                                                        (0)
+#define VO_DMA_V1_Y3_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V1_Y3_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V1_Y3_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V1_Y3_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V1_C0                                                                 0x98005CE8
+#define VO_DMA_V1_C0_reg_addr                                                        "0xD8005CE8"
+#define VO_DMA_V1_C0_reg                                                             0xD8005CE8
+#define set_VO_DMA_V1_C0_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_C0_reg)=data)
+#define get_VO_DMA_V1_C0_reg   (*((volatile unsigned int*) VO_DMA_V1_C0_reg))
+#define VO_DMA_V1_C0_inst_adr                                                        "0x003A"
+#define VO_DMA_V1_C0_inst                                                            0x003A
+#define VO_DMA_V1_C0_depth_shift                                                     (16)
+#define VO_DMA_V1_C0_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V1_C0_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V1_C0_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_C0_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_C0_sa_shift                                                        (0)
+#define VO_DMA_V1_C0_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V1_C0_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V1_C0_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V1_C0_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V1_C1                                                                 0x98005CEC
+#define VO_DMA_V1_C1_reg_addr                                                        "0xD8005CEC"
+#define VO_DMA_V1_C1_reg                                                             0xD8005CEC
+#define set_VO_DMA_V1_C1_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_C1_reg)=data)
+#define get_VO_DMA_V1_C1_reg   (*((volatile unsigned int*) VO_DMA_V1_C1_reg))
+#define VO_DMA_V1_C1_inst_adr                                                        "0x003B"
+#define VO_DMA_V1_C1_inst                                                            0x003B
+#define VO_DMA_V1_C1_depth_shift                                                     (16)
+#define VO_DMA_V1_C1_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V1_C1_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V1_C1_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_C1_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_C1_sa_shift                                                        (0)
+#define VO_DMA_V1_C1_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V1_C1_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V1_C1_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V1_C1_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V1_C2                                                                 0x98005CF0
+#define VO_DMA_V1_C2_reg_addr                                                        "0xD8005CF0"
+#define VO_DMA_V1_C2_reg                                                             0xD8005CF0
+#define set_VO_DMA_V1_C2_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_C2_reg)=data)
+#define get_VO_DMA_V1_C2_reg   (*((volatile unsigned int*) VO_DMA_V1_C2_reg))
+#define VO_DMA_V1_C2_inst_adr                                                        "0x003C"
+#define VO_DMA_V1_C2_inst                                                            0x003C
+#define VO_DMA_V1_C2_depth_shift                                                     (16)
+#define VO_DMA_V1_C2_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V1_C2_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V1_C2_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_C2_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_C2_sa_shift                                                        (0)
+#define VO_DMA_V1_C2_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V1_C2_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V1_C2_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V1_C2_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V1_C3                                                                 0x98005CF4
+#define VO_DMA_V1_C3_reg_addr                                                        "0xD8005CF4"
+#define VO_DMA_V1_C3_reg                                                             0xD8005CF4
+#define set_VO_DMA_V1_C3_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_C3_reg)=data)
+#define get_VO_DMA_V1_C3_reg   (*((volatile unsigned int*) VO_DMA_V1_C3_reg))
+#define VO_DMA_V1_C3_inst_adr                                                        "0x003D"
+#define VO_DMA_V1_C3_inst                                                            0x003D
+#define VO_DMA_V1_C3_depth_shift                                                     (16)
+#define VO_DMA_V1_C3_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V1_C3_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V1_C3_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_C3_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1_C3_sa_shift                                                        (0)
+#define VO_DMA_V1_C3_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V1_C3_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V1_C3_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V1_C3_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V1DI                                                                  0x98005CF8
+#define VO_DMA_V1DI_reg_addr                                                         "0xD8005CF8"
+#define VO_DMA_V1DI_reg                                                              0xD8005CF8
+#define set_VO_DMA_V1DI_reg(data)   (*((volatile unsigned int*) VO_DMA_V1DI_reg)=data)
+#define get_VO_DMA_V1DI_reg   (*((volatile unsigned int*) VO_DMA_V1DI_reg))
+#define VO_DMA_V1DI_inst_adr                                                         "0x003E"
+#define VO_DMA_V1DI_inst                                                             0x003E
+#define VO_DMA_V1DI_depth_shift                                                      (16)
+#define VO_DMA_V1DI_depth_mask                                                       (0x03FF0000)
+#define VO_DMA_V1DI_depth(data)                                                      (0x03FF0000&((data)<<16))
+#define VO_DMA_V1DI_depth_src(data)                                                  ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1DI_get_depth(data)                                                  ((0x03FF0000&(data))>>16)
+#define VO_DMA_V1DI_sa_shift                                                         (0)
+#define VO_DMA_V1DI_sa_mask                                                          (0x00000FFF)
+#define VO_DMA_V1DI_sa(data)                                                         (0x00000FFF&((data)<<0))
+#define VO_DMA_V1DI_sa_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define VO_DMA_V1DI_get_sa(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V2_Y0                                                                 0x98005CFC
+#define VO_DMA_V2_Y0_reg_addr                                                        "0xD8005CFC"
+#define VO_DMA_V2_Y0_reg                                                             0xD8005CFC
+#define set_VO_DMA_V2_Y0_reg(data)   (*((volatile unsigned int*) VO_DMA_V2_Y0_reg)=data)
+#define get_VO_DMA_V2_Y0_reg   (*((volatile unsigned int*) VO_DMA_V2_Y0_reg))
+#define VO_DMA_V2_Y0_inst_adr                                                        "0x003F"
+#define VO_DMA_V2_Y0_inst                                                            0x003F
+#define VO_DMA_V2_Y0_depth_shift                                                     (16)
+#define VO_DMA_V2_Y0_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V2_Y0_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V2_Y0_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_Y0_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_Y0_sa_shift                                                        (0)
+#define VO_DMA_V2_Y0_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V2_Y0_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V2_Y0_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V2_Y0_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V2_Y1                                                                 0x98005D00
+#define VO_DMA_V2_Y1_reg_addr                                                        "0xD8005D00"
+#define VO_DMA_V2_Y1_reg                                                             0xD8005D00
+#define set_VO_DMA_V2_Y1_reg(data)   (*((volatile unsigned int*) VO_DMA_V2_Y1_reg)=data)
+#define get_VO_DMA_V2_Y1_reg   (*((volatile unsigned int*) VO_DMA_V2_Y1_reg))
+#define VO_DMA_V2_Y1_inst_adr                                                        "0x0040"
+#define VO_DMA_V2_Y1_inst                                                            0x0040
+#define VO_DMA_V2_Y1_depth_shift                                                     (16)
+#define VO_DMA_V2_Y1_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V2_Y1_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V2_Y1_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_Y1_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_Y1_sa_shift                                                        (0)
+#define VO_DMA_V2_Y1_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V2_Y1_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V2_Y1_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V2_Y1_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V2_Y2                                                                 0x98005D04
+#define VO_DMA_V2_Y2_reg_addr                                                        "0xD8005D04"
+#define VO_DMA_V2_Y2_reg                                                             0xD8005D04
+#define set_VO_DMA_V2_Y2_reg(data)   (*((volatile unsigned int*) VO_DMA_V2_Y2_reg)=data)
+#define get_VO_DMA_V2_Y2_reg   (*((volatile unsigned int*) VO_DMA_V2_Y2_reg))
+#define VO_DMA_V2_Y2_inst_adr                                                        "0x0041"
+#define VO_DMA_V2_Y2_inst                                                            0x0041
+#define VO_DMA_V2_Y2_depth_shift                                                     (16)
+#define VO_DMA_V2_Y2_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V2_Y2_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V2_Y2_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_Y2_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_Y2_sa_shift                                                        (0)
+#define VO_DMA_V2_Y2_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V2_Y2_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V2_Y2_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V2_Y2_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V2_Y3                                                                 0x98005D08
+#define VO_DMA_V2_Y3_reg_addr                                                        "0xD8005D08"
+#define VO_DMA_V2_Y3_reg                                                             0xD8005D08
+#define set_VO_DMA_V2_Y3_reg(data)   (*((volatile unsigned int*) VO_DMA_V2_Y3_reg)=data)
+#define get_VO_DMA_V2_Y3_reg   (*((volatile unsigned int*) VO_DMA_V2_Y3_reg))
+#define VO_DMA_V2_Y3_inst_adr                                                        "0x0042"
+#define VO_DMA_V2_Y3_inst                                                            0x0042
+#define VO_DMA_V2_Y3_depth_shift                                                     (16)
+#define VO_DMA_V2_Y3_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V2_Y3_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V2_Y3_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_Y3_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_Y3_sa_shift                                                        (0)
+#define VO_DMA_V2_Y3_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V2_Y3_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V2_Y3_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V2_Y3_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V2_C0                                                                 0x98005D0C
+#define VO_DMA_V2_C0_reg_addr                                                        "0xD8005D0C"
+#define VO_DMA_V2_C0_reg                                                             0xD8005D0C
+#define set_VO_DMA_V2_C0_reg(data)   (*((volatile unsigned int*) VO_DMA_V2_C0_reg)=data)
+#define get_VO_DMA_V2_C0_reg   (*((volatile unsigned int*) VO_DMA_V2_C0_reg))
+#define VO_DMA_V2_C0_inst_adr                                                        "0x0043"
+#define VO_DMA_V2_C0_inst                                                            0x0043
+#define VO_DMA_V2_C0_depth_shift                                                     (16)
+#define VO_DMA_V2_C0_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V2_C0_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V2_C0_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_C0_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_C0_sa_shift                                                        (0)
+#define VO_DMA_V2_C0_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V2_C0_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V2_C0_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V2_C0_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V2_C1                                                                 0x98005D10
+#define VO_DMA_V2_C1_reg_addr                                                        "0xD8005D10"
+#define VO_DMA_V2_C1_reg                                                             0xD8005D10
+#define set_VO_DMA_V2_C1_reg(data)   (*((volatile unsigned int*) VO_DMA_V2_C1_reg)=data)
+#define get_VO_DMA_V2_C1_reg   (*((volatile unsigned int*) VO_DMA_V2_C1_reg))
+#define VO_DMA_V2_C1_inst_adr                                                        "0x0044"
+#define VO_DMA_V2_C1_inst                                                            0x0044
+#define VO_DMA_V2_C1_depth_shift                                                     (16)
+#define VO_DMA_V2_C1_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V2_C1_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V2_C1_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_C1_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_C1_sa_shift                                                        (0)
+#define VO_DMA_V2_C1_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V2_C1_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V2_C1_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V2_C1_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V2_C2                                                                 0x98005D14
+#define VO_DMA_V2_C2_reg_addr                                                        "0xD8005D14"
+#define VO_DMA_V2_C2_reg                                                             0xD8005D14
+#define set_VO_DMA_V2_C2_reg(data)   (*((volatile unsigned int*) VO_DMA_V2_C2_reg)=data)
+#define get_VO_DMA_V2_C2_reg   (*((volatile unsigned int*) VO_DMA_V2_C2_reg))
+#define VO_DMA_V2_C2_inst_adr                                                        "0x0045"
+#define VO_DMA_V2_C2_inst                                                            0x0045
+#define VO_DMA_V2_C2_depth_shift                                                     (16)
+#define VO_DMA_V2_C2_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V2_C2_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V2_C2_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_C2_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_C2_sa_shift                                                        (0)
+#define VO_DMA_V2_C2_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V2_C2_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V2_C2_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V2_C2_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V2_C3                                                                 0x98005D18
+#define VO_DMA_V2_C3_reg_addr                                                        "0xD8005D18"
+#define VO_DMA_V2_C3_reg                                                             0xD8005D18
+#define set_VO_DMA_V2_C3_reg(data)   (*((volatile unsigned int*) VO_DMA_V2_C3_reg)=data)
+#define get_VO_DMA_V2_C3_reg   (*((volatile unsigned int*) VO_DMA_V2_C3_reg))
+#define VO_DMA_V2_C3_inst_adr                                                        "0x0046"
+#define VO_DMA_V2_C3_inst                                                            0x0046
+#define VO_DMA_V2_C3_depth_shift                                                     (16)
+#define VO_DMA_V2_C3_depth_mask                                                      (0x03FF0000)
+#define VO_DMA_V2_C3_depth(data)                                                     (0x03FF0000&((data)<<16))
+#define VO_DMA_V2_C3_depth_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_C3_get_depth(data)                                                 ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2_C3_sa_shift                                                        (0)
+#define VO_DMA_V2_C3_sa_mask                                                         (0x00000FFF)
+#define VO_DMA_V2_C3_sa(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_DMA_V2_C3_sa_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_DMA_V2_C3_get_sa(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_V2DI                                                                  0x98005D1C
+#define VO_DMA_V2DI_reg_addr                                                         "0xD8005D1C"
+#define VO_DMA_V2DI_reg                                                              0xD8005D1C
+#define set_VO_DMA_V2DI_reg(data)   (*((volatile unsigned int*) VO_DMA_V2DI_reg)=data)
+#define get_VO_DMA_V2DI_reg   (*((volatile unsigned int*) VO_DMA_V2DI_reg))
+#define VO_DMA_V2DI_inst_adr                                                         "0x0047"
+#define VO_DMA_V2DI_inst                                                             0x0047
+#define VO_DMA_V2DI_depth_shift                                                      (16)
+#define VO_DMA_V2DI_depth_mask                                                       (0x03FF0000)
+#define VO_DMA_V2DI_depth(data)                                                      (0x03FF0000&((data)<<16))
+#define VO_DMA_V2DI_depth_src(data)                                                  ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2DI_get_depth(data)                                                  ((0x03FF0000&(data))>>16)
+#define VO_DMA_V2DI_sa_shift                                                         (0)
+#define VO_DMA_V2DI_sa_mask                                                          (0x00000FFF)
+#define VO_DMA_V2DI_sa(data)                                                         (0x00000FFF&((data)<<0))
+#define VO_DMA_V2DI_sa_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define VO_DMA_V2DI_get_sa(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_SUB1_WI                                                               0x98005D20
+#define VO_DMA_SUB1_WI_reg_addr                                                      "0xD8005D20"
+#define VO_DMA_SUB1_WI_reg                                                           0xD8005D20
+#define set_VO_DMA_SUB1_WI_reg(data)   (*((volatile unsigned int*) VO_DMA_SUB1_WI_reg)=data)
+#define get_VO_DMA_SUB1_WI_reg   (*((volatile unsigned int*) VO_DMA_SUB1_WI_reg))
+#define VO_DMA_SUB1_WI_inst_adr                                                      "0x0048"
+#define VO_DMA_SUB1_WI_inst                                                          0x0048
+#define VO_DMA_SUB1_WI_depth_shift                                                   (16)
+#define VO_DMA_SUB1_WI_depth_mask                                                    (0x03FF0000)
+#define VO_DMA_SUB1_WI_depth(data)                                                   (0x03FF0000&((data)<<16))
+#define VO_DMA_SUB1_WI_depth_src(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB1_WI_get_depth(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB1_WI_sa_shift                                                      (0)
+#define VO_DMA_SUB1_WI_sa_mask                                                       (0x00000FFF)
+#define VO_DMA_SUB1_WI_sa(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DMA_SUB1_WI_sa_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DMA_SUB1_WI_get_sa(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_SUB1_D0                                                               0x98005D24
+#define VO_DMA_SUB1_D0_reg_addr                                                      "0xD8005D24"
+#define VO_DMA_SUB1_D0_reg                                                           0xD8005D24
+#define set_VO_DMA_SUB1_D0_reg(data)   (*((volatile unsigned int*) VO_DMA_SUB1_D0_reg)=data)
+#define get_VO_DMA_SUB1_D0_reg   (*((volatile unsigned int*) VO_DMA_SUB1_D0_reg))
+#define VO_DMA_SUB1_D0_inst_adr                                                      "0x0049"
+#define VO_DMA_SUB1_D0_inst                                                          0x0049
+#define VO_DMA_SUB1_D0_depth_shift                                                   (16)
+#define VO_DMA_SUB1_D0_depth_mask                                                    (0x03FF0000)
+#define VO_DMA_SUB1_D0_depth(data)                                                   (0x03FF0000&((data)<<16))
+#define VO_DMA_SUB1_D0_depth_src(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB1_D0_get_depth(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB1_D0_sa_shift                                                      (0)
+#define VO_DMA_SUB1_D0_sa_mask                                                       (0x00000FFF)
+#define VO_DMA_SUB1_D0_sa(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DMA_SUB1_D0_sa_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DMA_SUB1_D0_get_sa(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_SUB1_D1                                                               0x98005D28
+#define VO_DMA_SUB1_D1_reg_addr                                                      "0xD8005D28"
+#define VO_DMA_SUB1_D1_reg                                                           0xD8005D28
+#define set_VO_DMA_SUB1_D1_reg(data)   (*((volatile unsigned int*) VO_DMA_SUB1_D1_reg)=data)
+#define get_VO_DMA_SUB1_D1_reg   (*((volatile unsigned int*) VO_DMA_SUB1_D1_reg))
+#define VO_DMA_SUB1_D1_inst_adr                                                      "0x004A"
+#define VO_DMA_SUB1_D1_inst                                                          0x004A
+#define VO_DMA_SUB1_D1_depth_shift                                                   (16)
+#define VO_DMA_SUB1_D1_depth_mask                                                    (0x03FF0000)
+#define VO_DMA_SUB1_D1_depth(data)                                                   (0x03FF0000&((data)<<16))
+#define VO_DMA_SUB1_D1_depth_src(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB1_D1_get_depth(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB1_D1_sa_shift                                                      (0)
+#define VO_DMA_SUB1_D1_sa_mask                                                       (0x00000FFF)
+#define VO_DMA_SUB1_D1_sa(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DMA_SUB1_D1_sa_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DMA_SUB1_D1_get_sa(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_OSD1_WI                                                               0x98005D2C
+#define VO_DMA_OSD1_WI_reg_addr                                                      "0xD8005D2C"
+#define VO_DMA_OSD1_WI_reg                                                           0xD8005D2C
+#define set_VO_DMA_OSD1_WI_reg(data)   (*((volatile unsigned int*) VO_DMA_OSD1_WI_reg)=data)
+#define get_VO_DMA_OSD1_WI_reg   (*((volatile unsigned int*) VO_DMA_OSD1_WI_reg))
+#define VO_DMA_OSD1_WI_inst_adr                                                      "0x004B"
+#define VO_DMA_OSD1_WI_inst                                                          0x004B
+#define VO_DMA_OSD1_WI_depth_shift                                                   (16)
+#define VO_DMA_OSD1_WI_depth_mask                                                    (0x03FF0000)
+#define VO_DMA_OSD1_WI_depth(data)                                                   (0x03FF0000&((data)<<16))
+#define VO_DMA_OSD1_WI_depth_src(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_OSD1_WI_get_depth(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_OSD1_WI_sa_shift                                                      (0)
+#define VO_DMA_OSD1_WI_sa_mask                                                       (0x00000FFF)
+#define VO_DMA_OSD1_WI_sa(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DMA_OSD1_WI_sa_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DMA_OSD1_WI_get_sa(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_OSD1_D0                                                               0x98005D30
+#define VO_DMA_OSD1_D0_reg_addr                                                      "0xD8005D30"
+#define VO_DMA_OSD1_D0_reg                                                           0xD8005D30
+#define set_VO_DMA_OSD1_D0_reg(data)   (*((volatile unsigned int*) VO_DMA_OSD1_D0_reg)=data)
+#define get_VO_DMA_OSD1_D0_reg   (*((volatile unsigned int*) VO_DMA_OSD1_D0_reg))
+#define VO_DMA_OSD1_D0_inst_adr                                                      "0x004C"
+#define VO_DMA_OSD1_D0_inst                                                          0x004C
+#define VO_DMA_OSD1_D0_depth_shift                                                   (16)
+#define VO_DMA_OSD1_D0_depth_mask                                                    (0x03FF0000)
+#define VO_DMA_OSD1_D0_depth(data)                                                   (0x03FF0000&((data)<<16))
+#define VO_DMA_OSD1_D0_depth_src(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_OSD1_D0_get_depth(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_OSD1_D0_sa_shift                                                      (0)
+#define VO_DMA_OSD1_D0_sa_mask                                                       (0x00000FFF)
+#define VO_DMA_OSD1_D0_sa(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DMA_OSD1_D0_sa_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DMA_OSD1_D0_get_sa(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_OSD1_D1                                                               0x98005D34
+#define VO_DMA_OSD1_D1_reg_addr                                                      "0xD8005D34"
+#define VO_DMA_OSD1_D1_reg                                                           0xD8005D34
+#define set_VO_DMA_OSD1_D1_reg(data)   (*((volatile unsigned int*) VO_DMA_OSD1_D1_reg)=data)
+#define get_VO_DMA_OSD1_D1_reg   (*((volatile unsigned int*) VO_DMA_OSD1_D1_reg))
+#define VO_DMA_OSD1_D1_inst_adr                                                      "0x004D"
+#define VO_DMA_OSD1_D1_inst                                                          0x004D
+#define VO_DMA_OSD1_D1_depth_shift                                                   (16)
+#define VO_DMA_OSD1_D1_depth_mask                                                    (0x03FF0000)
+#define VO_DMA_OSD1_D1_depth(data)                                                   (0x03FF0000&((data)<<16))
+#define VO_DMA_OSD1_D1_depth_src(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_OSD1_D1_get_depth(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_OSD1_D1_sa_shift                                                      (0)
+#define VO_DMA_OSD1_D1_sa_mask                                                       (0x00000FFF)
+#define VO_DMA_OSD1_D1_sa(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DMA_OSD1_D1_sa_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DMA_OSD1_D1_get_sa(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_SUB2_WI                                                               0x98005D38
+#define VO_DMA_SUB2_WI_reg_addr                                                      "0xD8005D38"
+#define VO_DMA_SUB2_WI_reg                                                           0xD8005D38
+#define set_VO_DMA_SUB2_WI_reg(data)   (*((volatile unsigned int*) VO_DMA_SUB2_WI_reg)=data)
+#define get_VO_DMA_SUB2_WI_reg   (*((volatile unsigned int*) VO_DMA_SUB2_WI_reg))
+#define VO_DMA_SUB2_WI_inst_adr                                                      "0x004E"
+#define VO_DMA_SUB2_WI_inst                                                          0x004E
+#define VO_DMA_SUB2_WI_depth_shift                                                   (16)
+#define VO_DMA_SUB2_WI_depth_mask                                                    (0x03FF0000)
+#define VO_DMA_SUB2_WI_depth(data)                                                   (0x03FF0000&((data)<<16))
+#define VO_DMA_SUB2_WI_depth_src(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB2_WI_get_depth(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB2_WI_sa_shift                                                      (0)
+#define VO_DMA_SUB2_WI_sa_mask                                                       (0x00000FFF)
+#define VO_DMA_SUB2_WI_sa(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DMA_SUB2_WI_sa_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DMA_SUB2_WI_get_sa(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_SUB2_D0                                                               0x98005D3C
+#define VO_DMA_SUB2_D0_reg_addr                                                      "0xD8005D3C"
+#define VO_DMA_SUB2_D0_reg                                                           0xD8005D3C
+#define set_VO_DMA_SUB2_D0_reg(data)   (*((volatile unsigned int*) VO_DMA_SUB2_D0_reg)=data)
+#define get_VO_DMA_SUB2_D0_reg   (*((volatile unsigned int*) VO_DMA_SUB2_D0_reg))
+#define VO_DMA_SUB2_D0_inst_adr                                                      "0x004F"
+#define VO_DMA_SUB2_D0_inst                                                          0x004F
+#define VO_DMA_SUB2_D0_depth_shift                                                   (16)
+#define VO_DMA_SUB2_D0_depth_mask                                                    (0x03FF0000)
+#define VO_DMA_SUB2_D0_depth(data)                                                   (0x03FF0000&((data)<<16))
+#define VO_DMA_SUB2_D0_depth_src(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB2_D0_get_depth(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB2_D0_sa_shift                                                      (0)
+#define VO_DMA_SUB2_D0_sa_mask                                                       (0x00000FFF)
+#define VO_DMA_SUB2_D0_sa(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DMA_SUB2_D0_sa_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DMA_SUB2_D0_get_sa(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_SUB2_D1                                                               0x98005D40
+#define VO_DMA_SUB2_D1_reg_addr                                                      "0xD8005D40"
+#define VO_DMA_SUB2_D1_reg                                                           0xD8005D40
+#define set_VO_DMA_SUB2_D1_reg(data)   (*((volatile unsigned int*) VO_DMA_SUB2_D1_reg)=data)
+#define get_VO_DMA_SUB2_D1_reg   (*((volatile unsigned int*) VO_DMA_SUB2_D1_reg))
+#define VO_DMA_SUB2_D1_inst_adr                                                      "0x0050"
+#define VO_DMA_SUB2_D1_inst                                                          0x0050
+#define VO_DMA_SUB2_D1_depth_shift                                                   (16)
+#define VO_DMA_SUB2_D1_depth_mask                                                    (0x03FF0000)
+#define VO_DMA_SUB2_D1_depth(data)                                                   (0x03FF0000&((data)<<16))
+#define VO_DMA_SUB2_D1_depth_src(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB2_D1_get_depth(data)                                               ((0x03FF0000&(data))>>16)
+#define VO_DMA_SUB2_D1_sa_shift                                                      (0)
+#define VO_DMA_SUB2_D1_sa_mask                                                       (0x00000FFF)
+#define VO_DMA_SUB2_D1_sa(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DMA_SUB2_D1_sa_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DMA_SUB2_D1_get_sa(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_CSR                                                                   0x98005D44
+#define VO_DMA_CSR_reg_addr                                                          "0xD8005D44"
+#define VO_DMA_CSR_reg                                                               0xD8005D44
+#define set_VO_DMA_CSR_reg(data)   (*((volatile unsigned int*) VO_DMA_CSR_reg)=data)
+#define get_VO_DMA_CSR_reg   (*((volatile unsigned int*) VO_DMA_CSR_reg))
+#define VO_DMA_CSR_inst_adr                                                          "0x0051"
+#define VO_DMA_CSR_inst                                                              0x0051
+#define VO_DMA_CSR_depth_shift                                                       (16)
+#define VO_DMA_CSR_depth_mask                                                        (0x03FF0000)
+#define VO_DMA_CSR_depth(data)                                                       (0x03FF0000&((data)<<16))
+#define VO_DMA_CSR_depth_src(data)                                                   ((0x03FF0000&(data))>>16)
+#define VO_DMA_CSR_get_depth(data)                                                   ((0x03FF0000&(data))>>16)
+#define VO_DMA_CSR_sa_shift                                                          (0)
+#define VO_DMA_CSR_sa_mask                                                           (0x00000FFF)
+#define VO_DMA_CSR_sa(data)                                                          (0x00000FFF&((data)<<0))
+#define VO_DMA_CSR_sa_src(data)                                                      ((0x00000FFF&(data))>>0)
+#define VO_DMA_CSR_get_sa(data)                                                      ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_DD_Y                                                                  0x98005D48
+#define VO_DMA_DD_Y_reg_addr                                                         "0xD8005D48"
+#define VO_DMA_DD_Y_reg                                                              0xD8005D48
+#define set_VO_DMA_DD_Y_reg(data)   (*((volatile unsigned int*) VO_DMA_DD_Y_reg)=data)
+#define get_VO_DMA_DD_Y_reg   (*((volatile unsigned int*) VO_DMA_DD_Y_reg))
+#define VO_DMA_DD_Y_inst_adr                                                         "0x0052"
+#define VO_DMA_DD_Y_inst                                                             0x0052
+#define VO_DMA_DD_Y_depth_shift                                                      (16)
+#define VO_DMA_DD_Y_depth_mask                                                       (0x03FF0000)
+#define VO_DMA_DD_Y_depth(data)                                                      (0x03FF0000&((data)<<16))
+#define VO_DMA_DD_Y_depth_src(data)                                                  ((0x03FF0000&(data))>>16)
+#define VO_DMA_DD_Y_get_depth(data)                                                  ((0x03FF0000&(data))>>16)
+#define VO_DMA_DD_Y_sa_shift                                                         (0)
+#define VO_DMA_DD_Y_sa_mask                                                          (0x00000FFF)
+#define VO_DMA_DD_Y_sa(data)                                                         (0x00000FFF&((data)<<0))
+#define VO_DMA_DD_Y_sa_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define VO_DMA_DD_Y_get_sa(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_DD_C                                                                  0x98005D4C
+#define VO_DMA_DD_C_reg_addr                                                         "0xD8005D4C"
+#define VO_DMA_DD_C_reg                                                              0xD8005D4C
+#define set_VO_DMA_DD_C_reg(data)   (*((volatile unsigned int*) VO_DMA_DD_C_reg)=data)
+#define get_VO_DMA_DD_C_reg   (*((volatile unsigned int*) VO_DMA_DD_C_reg))
+#define VO_DMA_DD_C_inst_adr                                                         "0x0053"
+#define VO_DMA_DD_C_inst                                                             0x0053
+#define VO_DMA_DD_C_depth_shift                                                      (16)
+#define VO_DMA_DD_C_depth_mask                                                       (0x03FF0000)
+#define VO_DMA_DD_C_depth(data)                                                      (0x03FF0000&((data)<<16))
+#define VO_DMA_DD_C_depth_src(data)                                                  ((0x03FF0000&(data))>>16)
+#define VO_DMA_DD_C_get_depth(data)                                                  ((0x03FF0000&(data))>>16)
+#define VO_DMA_DD_C_sa_shift                                                         (0)
+#define VO_DMA_DD_C_sa_mask                                                          (0x00000FFF)
+#define VO_DMA_DD_C_sa(data)                                                         (0x00000FFF&((data)<<0))
+#define VO_DMA_DD_C_sa_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define VO_DMA_DD_C_get_sa(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_VBI                                                                   0x98005D50
+#define VO_DMA_VBI_reg_addr                                                          "0xD8005D50"
+#define VO_DMA_VBI_reg                                                               0xD8005D50
+#define set_VO_DMA_VBI_reg(data)   (*((volatile unsigned int*) VO_DMA_VBI_reg)=data)
+#define get_VO_DMA_VBI_reg   (*((volatile unsigned int*) VO_DMA_VBI_reg))
+#define VO_DMA_VBI_inst_adr                                                          "0x0054"
+#define VO_DMA_VBI_inst                                                              0x0054
+#define VO_DMA_VBI_depth_shift                                                       (16)
+#define VO_DMA_VBI_depth_mask                                                        (0x03FF0000)
+#define VO_DMA_VBI_depth(data)                                                       (0x03FF0000&((data)<<16))
+#define VO_DMA_VBI_depth_src(data)                                                   ((0x03FF0000&(data))>>16)
+#define VO_DMA_VBI_get_depth(data)                                                   ((0x03FF0000&(data))>>16)
+#define VO_DMA_VBI_sa_shift                                                          (0)
+#define VO_DMA_VBI_sa_mask                                                           (0x00000FFF)
+#define VO_DMA_VBI_sa(data)                                                          (0x00000FFF&((data)<<0))
+#define VO_DMA_VBI_sa_src(data)                                                      ((0x00000FFF&(data))>>0)
+#define VO_DMA_VBI_get_sa(data)                                                      ((0x00000FFF&(data))>>0)
+
+
+#define VO_DMA_WB1_Y                                                                 0x98005D54
+#define VO_DMA_WB1_Y_reg_addr                                                        "0xD8005D54"
+#define VO_DMA_WB1_Y_reg                                                             0xD8005D54
+#define set_VO_DMA_WB1_Y_reg(data)   (*((volatile unsigned int*) VO_DMA_WB1_Y_reg)=data)
+#define get_VO_DMA_WB1_Y_reg   (*((volatile unsigned int*) VO_DMA_WB1_Y_reg))
+#define VO_DMA_WB1_Y_inst_adr                                                        "0x0055"
+#define VO_DMA_WB1_Y_inst                                                            0x0055
+#define VO_DMA_WB1_Y_flush_thd_shift                                                 (24)
+#define VO_DMA_WB1_Y_flush_thd_mask                                                  (0xFF000000)
+#define VO_DMA_WB1_Y_flush_thd(data)                                                 (0xFF000000&((data)<<24))
+#define VO_DMA_WB1_Y_flush_thd_src(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB1_Y_get_flush_thd(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB1_Y_depth_shift                                                     (12)
+#define VO_DMA_WB1_Y_depth_mask                                                      (0x000FF000)
+#define VO_DMA_WB1_Y_depth(data)                                                     (0x000FF000&((data)<<12))
+#define VO_DMA_WB1_Y_depth_src(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB1_Y_get_depth(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB1_Y_sa_shift                                                        (0)
+#define VO_DMA_WB1_Y_sa_mask                                                         (0x000001FF)
+#define VO_DMA_WB1_Y_sa(data)                                                        (0x000001FF&((data)<<0))
+#define VO_DMA_WB1_Y_sa_src(data)                                                    ((0x000001FF&(data))>>0)
+#define VO_DMA_WB1_Y_get_sa(data)                                                    ((0x000001FF&(data))>>0)
+
+
+#define VO_DMA_WB1_C                                                                 0x98005D58
+#define VO_DMA_WB1_C_reg_addr                                                        "0xD8005D58"
+#define VO_DMA_WB1_C_reg                                                             0xD8005D58
+#define set_VO_DMA_WB1_C_reg(data)   (*((volatile unsigned int*) VO_DMA_WB1_C_reg)=data)
+#define get_VO_DMA_WB1_C_reg   (*((volatile unsigned int*) VO_DMA_WB1_C_reg))
+#define VO_DMA_WB1_C_inst_adr                                                        "0x0056"
+#define VO_DMA_WB1_C_inst                                                            0x0056
+#define VO_DMA_WB1_C_flush_thd_shift                                                 (24)
+#define VO_DMA_WB1_C_flush_thd_mask                                                  (0xFF000000)
+#define VO_DMA_WB1_C_flush_thd(data)                                                 (0xFF000000&((data)<<24))
+#define VO_DMA_WB1_C_flush_thd_src(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB1_C_get_flush_thd(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB1_C_depth_shift                                                     (12)
+#define VO_DMA_WB1_C_depth_mask                                                      (0x000FF000)
+#define VO_DMA_WB1_C_depth(data)                                                     (0x000FF000&((data)<<12))
+#define VO_DMA_WB1_C_depth_src(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB1_C_get_depth(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB1_C_sa_shift                                                        (0)
+#define VO_DMA_WB1_C_sa_mask                                                         (0x000001FF)
+#define VO_DMA_WB1_C_sa(data)                                                        (0x000001FF&((data)<<0))
+#define VO_DMA_WB1_C_sa_src(data)                                                    ((0x000001FF&(data))>>0)
+#define VO_DMA_WB1_C_get_sa(data)                                                    ((0x000001FF&(data))>>0)
+
+
+#define VO_DMA_WB2_Y                                                                 0x98005D5C
+#define VO_DMA_WB2_Y_reg_addr                                                        "0xD8005D5C"
+#define VO_DMA_WB2_Y_reg                                                             0xD8005D5C
+#define set_VO_DMA_WB2_Y_reg(data)   (*((volatile unsigned int*) VO_DMA_WB2_Y_reg)=data)
+#define get_VO_DMA_WB2_Y_reg   (*((volatile unsigned int*) VO_DMA_WB2_Y_reg))
+#define VO_DMA_WB2_Y_inst_adr                                                        "0x0057"
+#define VO_DMA_WB2_Y_inst                                                            0x0057
+#define VO_DMA_WB2_Y_flush_thd_shift                                                 (24)
+#define VO_DMA_WB2_Y_flush_thd_mask                                                  (0xFF000000)
+#define VO_DMA_WB2_Y_flush_thd(data)                                                 (0xFF000000&((data)<<24))
+#define VO_DMA_WB2_Y_flush_thd_src(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB2_Y_get_flush_thd(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB2_Y_depth_shift                                                     (12)
+#define VO_DMA_WB2_Y_depth_mask                                                      (0x000FF000)
+#define VO_DMA_WB2_Y_depth(data)                                                     (0x000FF000&((data)<<12))
+#define VO_DMA_WB2_Y_depth_src(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB2_Y_get_depth(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB2_Y_sa_shift                                                        (0)
+#define VO_DMA_WB2_Y_sa_mask                                                         (0x000001FF)
+#define VO_DMA_WB2_Y_sa(data)                                                        (0x000001FF&((data)<<0))
+#define VO_DMA_WB2_Y_sa_src(data)                                                    ((0x000001FF&(data))>>0)
+#define VO_DMA_WB2_Y_get_sa(data)                                                    ((0x000001FF&(data))>>0)
+
+
+#define VO_DMA_WB2_C                                                                 0x98005D60
+#define VO_DMA_WB2_C_reg_addr                                                        "0xD8005D60"
+#define VO_DMA_WB2_C_reg                                                             0xD8005D60
+#define set_VO_DMA_WB2_C_reg(data)   (*((volatile unsigned int*) VO_DMA_WB2_C_reg)=data)
+#define get_VO_DMA_WB2_C_reg   (*((volatile unsigned int*) VO_DMA_WB2_C_reg))
+#define VO_DMA_WB2_C_inst_adr                                                        "0x0058"
+#define VO_DMA_WB2_C_inst                                                            0x0058
+#define VO_DMA_WB2_C_flush_thd_shift                                                 (24)
+#define VO_DMA_WB2_C_flush_thd_mask                                                  (0xFF000000)
+#define VO_DMA_WB2_C_flush_thd(data)                                                 (0xFF000000&((data)<<24))
+#define VO_DMA_WB2_C_flush_thd_src(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB2_C_get_flush_thd(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB2_C_depth_shift                                                     (12)
+#define VO_DMA_WB2_C_depth_mask                                                      (0x000FF000)
+#define VO_DMA_WB2_C_depth(data)                                                     (0x000FF000&((data)<<12))
+#define VO_DMA_WB2_C_depth_src(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB2_C_get_depth(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB2_C_sa_shift                                                        (0)
+#define VO_DMA_WB2_C_sa_mask                                                         (0x000001FF)
+#define VO_DMA_WB2_C_sa(data)                                                        (0x000001FF&((data)<<0))
+#define VO_DMA_WB2_C_sa_src(data)                                                    ((0x000001FF&(data))>>0)
+#define VO_DMA_WB2_C_get_sa(data)                                                    ((0x000001FF&(data))>>0)
+
+
+#define VO_DMA_WB_V1                                                                 0x98005D64
+#define VO_DMA_WB_V1_reg_addr                                                        "0xD8005D64"
+#define VO_DMA_WB_V1_reg                                                             0xD8005D64
+#define set_VO_DMA_WB_V1_reg(data)   (*((volatile unsigned int*) VO_DMA_WB_V1_reg)=data)
+#define get_VO_DMA_WB_V1_reg   (*((volatile unsigned int*) VO_DMA_WB_V1_reg))
+#define VO_DMA_WB_V1_inst_adr                                                        "0x0059"
+#define VO_DMA_WB_V1_inst                                                            0x0059
+#define VO_DMA_WB_V1_flush_thd_shift                                                 (24)
+#define VO_DMA_WB_V1_flush_thd_mask                                                  (0xFF000000)
+#define VO_DMA_WB_V1_flush_thd(data)                                                 (0xFF000000&((data)<<24))
+#define VO_DMA_WB_V1_flush_thd_src(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB_V1_get_flush_thd(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB_V1_depth_shift                                                     (12)
+#define VO_DMA_WB_V1_depth_mask                                                      (0x000FF000)
+#define VO_DMA_WB_V1_depth(data)                                                     (0x000FF000&((data)<<12))
+#define VO_DMA_WB_V1_depth_src(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB_V1_get_depth(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB_V1_sa_shift                                                        (0)
+#define VO_DMA_WB_V1_sa_mask                                                         (0x000001FF)
+#define VO_DMA_WB_V1_sa(data)                                                        (0x000001FF&((data)<<0))
+#define VO_DMA_WB_V1_sa_src(data)                                                    ((0x000001FF&(data))>>0)
+#define VO_DMA_WB_V1_get_sa(data)                                                    ((0x000001FF&(data))>>0)
+
+
+#define VO_DMA_WB_V2                                                                 0x98005D68
+#define VO_DMA_WB_V2_reg_addr                                                        "0xD8005D68"
+#define VO_DMA_WB_V2_reg                                                             0xD8005D68
+#define set_VO_DMA_WB_V2_reg(data)   (*((volatile unsigned int*) VO_DMA_WB_V2_reg)=data)
+#define get_VO_DMA_WB_V2_reg   (*((volatile unsigned int*) VO_DMA_WB_V2_reg))
+#define VO_DMA_WB_V2_inst_adr                                                        "0x005A"
+#define VO_DMA_WB_V2_inst                                                            0x005A
+#define VO_DMA_WB_V2_flush_thd_shift                                                 (24)
+#define VO_DMA_WB_V2_flush_thd_mask                                                  (0xFF000000)
+#define VO_DMA_WB_V2_flush_thd(data)                                                 (0xFF000000&((data)<<24))
+#define VO_DMA_WB_V2_flush_thd_src(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB_V2_get_flush_thd(data)                                             ((0xFF000000&(data))>>24)
+#define VO_DMA_WB_V2_depth_shift                                                     (12)
+#define VO_DMA_WB_V2_depth_mask                                                      (0x000FF000)
+#define VO_DMA_WB_V2_depth(data)                                                     (0x000FF000&((data)<<12))
+#define VO_DMA_WB_V2_depth_src(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB_V2_get_depth(data)                                                 ((0x000FF000&(data))>>12)
+#define VO_DMA_WB_V2_sa_shift                                                        (0)
+#define VO_DMA_WB_V2_sa_mask                                                         (0x000001FF)
+#define VO_DMA_WB_V2_sa(data)                                                        (0x000001FF&((data)<<0))
+#define VO_DMA_WB_V2_sa_src(data)                                                    ((0x000001FF&(data))>>0)
+#define VO_DMA_WB_V2_get_sa(data)                                                    ((0x000001FF&(data))>>0)
+
+
+#define VO_MIX_ORDER                                                                 0x98005D6C
+#define VO_MIX_ORDER_reg_addr                                                        "0xD8005D6C"
+#define VO_MIX_ORDER_reg                                                             0xD8005D6C
+#define set_VO_MIX_ORDER_reg(data)   (*((volatile unsigned int*) VO_MIX_ORDER_reg)=data)
+#define get_VO_MIX_ORDER_reg   (*((volatile unsigned int*) VO_MIX_ORDER_reg))
+#define VO_MIX_ORDER_inst_adr                                                        "0x005B"
+#define VO_MIX_ORDER_inst                                                            0x005B
+#define VO_MIX_ORDER_csr_shift                                                       (28)
+#define VO_MIX_ORDER_csr_mask                                                        (0xF0000000)
+#define VO_MIX_ORDER_csr(data)                                                       (0xF0000000&((data)<<28))
+#define VO_MIX_ORDER_csr_src(data)                                                   ((0xF0000000&(data))>>28)
+#define VO_MIX_ORDER_get_csr(data)                                                   ((0xF0000000&(data))>>28)
+#define VO_MIX_ORDER_sub2_shift                                                      (24)
+#define VO_MIX_ORDER_sub2_mask                                                       (0x0F000000)
+#define VO_MIX_ORDER_sub2(data)                                                      (0x0F000000&((data)<<24))
+#define VO_MIX_ORDER_sub2_src(data)                                                  ((0x0F000000&(data))>>24)
+#define VO_MIX_ORDER_get_sub2(data)                                                  ((0x0F000000&(data))>>24)
+#define VO_MIX_ORDER_osd1_shift                                                      (20)
+#define VO_MIX_ORDER_osd1_mask                                                       (0x00F00000)
+#define VO_MIX_ORDER_osd1(data)                                                      (0x00F00000&((data)<<20))
+#define VO_MIX_ORDER_osd1_src(data)                                                  ((0x00F00000&(data))>>20)
+#define VO_MIX_ORDER_get_osd1(data)                                                  ((0x00F00000&(data))>>20)
+#define VO_MIX_ORDER_v2_shift                                                        (16)
+#define VO_MIX_ORDER_v2_mask                                                         (0x000F0000)
+#define VO_MIX_ORDER_v2(data)                                                        (0x000F0000&((data)<<16))
+#define VO_MIX_ORDER_v2_src(data)                                                    ((0x000F0000&(data))>>16)
+#define VO_MIX_ORDER_get_v2(data)                                                    ((0x000F0000&(data))>>16)
+#define VO_MIX_ORDER_sub1_shift                                                      (12)
+#define VO_MIX_ORDER_sub1_mask                                                       (0x0000F000)
+#define VO_MIX_ORDER_sub1(data)                                                      (0x0000F000&((data)<<12))
+#define VO_MIX_ORDER_sub1_src(data)                                                  ((0x0000F000&(data))>>12)
+#define VO_MIX_ORDER_get_sub1(data)                                                  ((0x0000F000&(data))>>12)
+#define VO_MIX_ORDER_v1_shift                                                        (8)
+#define VO_MIX_ORDER_v1_mask                                                         (0x00000F00)
+#define VO_MIX_ORDER_v1(data)                                                        (0x00000F00&((data)<<8))
+#define VO_MIX_ORDER_v1_src(data)                                                    ((0x00000F00&(data))>>8)
+#define VO_MIX_ORDER_get_v1(data)                                                    ((0x00000F00&(data))>>8)
+
+
+#define VO_MIX                                                                       0x98005D70
+#define VO_MIX_reg_addr                                                              "0xD8005D70"
+#define VO_MIX_reg                                                                   0xD8005D70
+#define set_VO_MIX_reg(data)   (*((volatile unsigned int*) VO_MIX_reg)=data)
+#define get_VO_MIX_reg   (*((volatile unsigned int*) VO_MIX_reg))
+#define VO_MIX_inst_adr                                                              "0x005C"
+#define VO_MIX_inst                                                                  0x005C
+#define VO_MIX_cd_shift                                                              (5)
+#define VO_MIX_cd_mask                                                               (0x00000020)
+#define VO_MIX_cd(data)                                                              (0x00000020&((data)<<5))
+#define VO_MIX_cd_src(data)                                                          ((0x00000020&(data))>>5)
+#define VO_MIX_get_cd(data)                                                          ((0x00000020&(data))>>5)
+#define VO_MIX_cu_shift                                                              (4)
+#define VO_MIX_cu_mask                                                               (0x00000010)
+#define VO_MIX_cu(data)                                                              (0x00000010&((data)<<4))
+#define VO_MIX_cu_src(data)                                                          ((0x00000010&(data))>>4)
+#define VO_MIX_get_cu(data)                                                          ((0x00000010&(data))>>4)
+#define VO_MIX_tr_shift                                                              (3)
+#define VO_MIX_tr_mask                                                               (0x00000008)
+#define VO_MIX_tr(data)                                                              (0x00000008&((data)<<3))
+#define VO_MIX_tr_src(data)                                                          ((0x00000008&(data))>>3)
+#define VO_MIX_get_tr(data)                                                          ((0x00000008&(data))>>3)
+#define VO_MIX_v2b_shift                                                             (2)
+#define VO_MIX_v2b_mask                                                              (0x00000004)
+#define VO_MIX_v2b(data)                                                             (0x00000004&((data)<<2))
+#define VO_MIX_v2b_src(data)                                                         ((0x00000004&(data))>>2)
+#define VO_MIX_get_v2b(data)                                                         ((0x00000004&(data))>>2)
+#define VO_MIX_v1b_shift                                                             (1)
+#define VO_MIX_v1b_mask                                                              (0x00000002)
+#define VO_MIX_v1b(data)                                                             (0x00000002&((data)<<1))
+#define VO_MIX_v1b_src(data)                                                         ((0x00000002&(data))>>1)
+#define VO_MIX_get_v1b(data)                                                         ((0x00000002&(data))>>1)
+#define VO_MIX_write_data_shift                                                      (0)
+#define VO_MIX_write_data_mask                                                       (0x00000001)
+#define VO_MIX_write_data(data)                                                      (0x00000001&((data)<<0))
+#define VO_MIX_write_data_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_MIX_get_write_data(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_M1BG                                                                      0x98005D74
+#define VO_M1BG_reg_addr                                                             "0xD8005D74"
+#define VO_M1BG_reg                                                                  0xD8005D74
+#define set_VO_M1BG_reg(data)   (*((volatile unsigned int*) VO_M1BG_reg)=data)
+#define get_VO_M1BG_reg   (*((volatile unsigned int*) VO_M1BG_reg))
+#define VO_M1BG_inst_adr                                                             "0x005D"
+#define VO_M1BG_inst                                                                 0x005D
+#define VO_M1BG_cr_shift                                                             (20)
+#define VO_M1BG_cr_mask                                                              (0x3FF00000)
+#define VO_M1BG_cr(data)                                                             (0x3FF00000&((data)<<20))
+#define VO_M1BG_cr_src(data)                                                         ((0x3FF00000&(data))>>20)
+#define VO_M1BG_get_cr(data)                                                         ((0x3FF00000&(data))>>20)
+#define VO_M1BG_cb_shift                                                             (10)
+#define VO_M1BG_cb_mask                                                              (0x000FFC00)
+#define VO_M1BG_cb(data)                                                             (0x000FFC00&((data)<<10))
+#define VO_M1BG_cb_src(data)                                                         ((0x000FFC00&(data))>>10)
+#define VO_M1BG_get_cb(data)                                                         ((0x000FFC00&(data))>>10)
+#define VO_M1BG_y_shift                                                              (0)
+#define VO_M1BG_y_mask                                                               (0x000003FF)
+#define VO_M1BG_y(data)                                                              (0x000003FF&((data)<<0))
+#define VO_M1BG_y_src(data)                                                          ((0x000003FF&(data))>>0)
+#define VO_M1BG_get_y(data)                                                          ((0x000003FF&(data))>>0)
+
+
+#define VO_M1_SIZE                                                                   0x98005D78
+#define VO_M1_SIZE_reg_addr                                                          "0xD8005D78"
+#define VO_M1_SIZE_reg                                                               0xD8005D78
+#define set_VO_M1_SIZE_reg(data)   (*((volatile unsigned int*) VO_M1_SIZE_reg)=data)
+#define get_VO_M1_SIZE_reg   (*((volatile unsigned int*) VO_M1_SIZE_reg))
+#define VO_M1_SIZE_inst_adr                                                          "0x005E"
+#define VO_M1_SIZE_inst                                                              0x005E
+#define VO_M1_SIZE_w_shift                                                           (16)
+#define VO_M1_SIZE_w_mask                                                            (0x1FFF0000)
+#define VO_M1_SIZE_w(data)                                                           (0x1FFF0000&((data)<<16))
+#define VO_M1_SIZE_w_src(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_M1_SIZE_get_w(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_M1_SIZE_h_shift                                                           (0)
+#define VO_M1_SIZE_h_mask                                                            (0x00001FFF)
+#define VO_M1_SIZE_h(data)                                                           (0x00001FFF&((data)<<0))
+#define VO_M1_SIZE_h_src(data)                                                       ((0x00001FFF&(data))>>0)
+#define VO_M1_SIZE_get_h(data)                                                       ((0x00001FFF&(data))>>0)
+
+
+#define VO_M2BG                                                                      0x98005D7C
+#define VO_M2BG_reg_addr                                                             "0xD8005D7C"
+#define VO_M2BG_reg                                                                  0xD8005D7C
+#define set_VO_M2BG_reg(data)   (*((volatile unsigned int*) VO_M2BG_reg)=data)
+#define get_VO_M2BG_reg   (*((volatile unsigned int*) VO_M2BG_reg))
+#define VO_M2BG_inst_adr                                                             "0x005F"
+#define VO_M2BG_inst                                                                 0x005F
+#define VO_M2BG_cr_shift                                                             (20)
+#define VO_M2BG_cr_mask                                                              (0x3FF00000)
+#define VO_M2BG_cr(data)                                                             (0x3FF00000&((data)<<20))
+#define VO_M2BG_cr_src(data)                                                         ((0x3FF00000&(data))>>20)
+#define VO_M2BG_get_cr(data)                                                         ((0x3FF00000&(data))>>20)
+#define VO_M2BG_cb_shift                                                             (10)
+#define VO_M2BG_cb_mask                                                              (0x000FFC00)
+#define VO_M2BG_cb(data)                                                             (0x000FFC00&((data)<<10))
+#define VO_M2BG_cb_src(data)                                                         ((0x000FFC00&(data))>>10)
+#define VO_M2BG_get_cb(data)                                                         ((0x000FFC00&(data))>>10)
+#define VO_M2BG_y_shift                                                              (0)
+#define VO_M2BG_y_mask                                                               (0x000003FF)
+#define VO_M2BG_y(data)                                                              (0x000003FF&((data)<<0))
+#define VO_M2BG_y_src(data)                                                          ((0x000003FF&(data))>>0)
+#define VO_M2BG_get_y(data)                                                          ((0x000003FF&(data))>>0)
+
+
+#define VO_M2_SIZE                                                                   0x98005D80
+#define VO_M2_SIZE_reg_addr                                                          "0xD8005D80"
+#define VO_M2_SIZE_reg                                                               0xD8005D80
+#define set_VO_M2_SIZE_reg(data)   (*((volatile unsigned int*) VO_M2_SIZE_reg)=data)
+#define get_VO_M2_SIZE_reg   (*((volatile unsigned int*) VO_M2_SIZE_reg))
+#define VO_M2_SIZE_inst_adr                                                          "0x0060"
+#define VO_M2_SIZE_inst                                                              0x0060
+#define VO_M2_SIZE_w_shift                                                           (16)
+#define VO_M2_SIZE_w_mask                                                            (0x1FFF0000)
+#define VO_M2_SIZE_w(data)                                                           (0x1FFF0000&((data)<<16))
+#define VO_M2_SIZE_w_src(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_M2_SIZE_get_w(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_M2_SIZE_h_shift                                                           (0)
+#define VO_M2_SIZE_h_mask                                                            (0x00001FFF)
+#define VO_M2_SIZE_h(data)                                                           (0x00001FFF&((data)<<0))
+#define VO_M2_SIZE_h_src(data)                                                       ((0x00001FFF&(data))>>0)
+#define VO_M2_SIZE_get_h(data)                                                       ((0x00001FFF&(data))>>0)
+
+
+#define VO_MDDBG                                                                     0x98005D84
+#define VO_MDDBG_reg_addr                                                            "0xD8005D84"
+#define VO_MDDBG_reg                                                                 0xD8005D84
+#define set_VO_MDDBG_reg(data)   (*((volatile unsigned int*) VO_MDDBG_reg)=data)
+#define get_VO_MDDBG_reg   (*((volatile unsigned int*) VO_MDDBG_reg))
+#define VO_MDDBG_inst_adr                                                            "0x0061"
+#define VO_MDDBG_inst                                                                0x0061
+#define VO_MDDBG_cr_shift                                                            (20)
+#define VO_MDDBG_cr_mask                                                             (0x3FF00000)
+#define VO_MDDBG_cr(data)                                                            (0x3FF00000&((data)<<20))
+#define VO_MDDBG_cr_src(data)                                                        ((0x3FF00000&(data))>>20)
+#define VO_MDDBG_get_cr(data)                                                        ((0x3FF00000&(data))>>20)
+#define VO_MDDBG_cb_shift                                                            (10)
+#define VO_MDDBG_cb_mask                                                             (0x000FFC00)
+#define VO_MDDBG_cb(data)                                                            (0x000FFC00&((data)<<10))
+#define VO_MDDBG_cb_src(data)                                                        ((0x000FFC00&(data))>>10)
+#define VO_MDDBG_get_cb(data)                                                        ((0x000FFC00&(data))>>10)
+#define VO_MDDBG_y_shift                                                             (0)
+#define VO_MDDBG_y_mask                                                              (0x000003FF)
+#define VO_MDDBG_y(data)                                                             (0x000003FF&((data)<<0))
+#define VO_MDDBG_y_src(data)                                                         ((0x000003FF&(data))>>0)
+#define VO_MDDBG_get_y(data)                                                         ((0x000003FF&(data))>>0)
+
+
+#define VO_MDD_SIZE                                                                  0x98005D88
+#define VO_MDD_SIZE_reg_addr                                                         "0xD8005D88"
+#define VO_MDD_SIZE_reg                                                              0xD8005D88
+#define set_VO_MDD_SIZE_reg(data)   (*((volatile unsigned int*) VO_MDD_SIZE_reg)=data)
+#define get_VO_MDD_SIZE_reg   (*((volatile unsigned int*) VO_MDD_SIZE_reg))
+#define VO_MDD_SIZE_inst_adr                                                         "0x0062"
+#define VO_MDD_SIZE_inst                                                             0x0062
+#define VO_MDD_SIZE_w_shift                                                          (16)
+#define VO_MDD_SIZE_w_mask                                                           (0x1FFF0000)
+#define VO_MDD_SIZE_w(data)                                                          (0x1FFF0000&((data)<<16))
+#define VO_MDD_SIZE_w_src(data)                                                      ((0x1FFF0000&(data))>>16)
+#define VO_MDD_SIZE_get_w(data)                                                      ((0x1FFF0000&(data))>>16)
+#define VO_MDD_SIZE_h_shift                                                          (0)
+#define VO_MDD_SIZE_h_mask                                                           (0x00001FFF)
+#define VO_MDD_SIZE_h(data)                                                          (0x00001FFF&((data)<<0))
+#define VO_MDD_SIZE_h_src(data)                                                      ((0x00001FFF&(data))>>0)
+#define VO_MDD_SIZE_get_h(data)                                                      ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1_XY                                                                     0x98005D8C
+#define VO_V1_XY_reg_addr                                                            "0xD8005D8C"
+#define VO_V1_XY_reg                                                                 0xD8005D8C
+#define set_VO_V1_XY_reg(data)   (*((volatile unsigned int*) VO_V1_XY_reg)=data)
+#define get_VO_V1_XY_reg   (*((volatile unsigned int*) VO_V1_XY_reg))
+#define VO_V1_XY_inst_adr                                                            "0x0063"
+#define VO_V1_XY_inst                                                                0x0063
+#define VO_V1_XY_x_shift                                                             (16)
+#define VO_V1_XY_x_mask                                                              (0x1FFF0000)
+#define VO_V1_XY_x(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_V1_XY_x_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1_XY_get_x(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1_XY_y_shift                                                             (0)
+#define VO_V1_XY_y_mask                                                              (0x00001FFF)
+#define VO_V1_XY_y(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_V1_XY_y_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_V1_XY_get_y(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1B_C                                                                     0x98005D90
+#define VO_V1B_C_reg_addr                                                            "0xD8005D90"
+#define VO_V1B_C_reg                                                                 0xD8005D90
+#define set_VO_V1B_C_reg(data)   (*((volatile unsigned int*) VO_V1B_C_reg)=data)
+#define get_VO_V1B_C_reg   (*((volatile unsigned int*) VO_V1B_C_reg))
+#define VO_V1B_C_inst_adr                                                            "0x0064"
+#define VO_V1B_C_inst                                                                0x0064
+#define VO_V1B_C_cr_shift                                                            (20)
+#define VO_V1B_C_cr_mask                                                             (0x3FF00000)
+#define VO_V1B_C_cr(data)                                                            (0x3FF00000&((data)<<20))
+#define VO_V1B_C_cr_src(data)                                                        ((0x3FF00000&(data))>>20)
+#define VO_V1B_C_get_cr(data)                                                        ((0x3FF00000&(data))>>20)
+#define VO_V1B_C_cb_shift                                                            (10)
+#define VO_V1B_C_cb_mask                                                             (0x000FFC00)
+#define VO_V1B_C_cb(data)                                                            (0x000FFC00&((data)<<10))
+#define VO_V1B_C_cb_src(data)                                                        ((0x000FFC00&(data))>>10)
+#define VO_V1B_C_get_cb(data)                                                        ((0x000FFC00&(data))>>10)
+#define VO_V1B_C_y_shift                                                             (0)
+#define VO_V1B_C_y_mask                                                              (0x000003FF)
+#define VO_V1B_C_y(data)                                                             (0x000003FF&((data)<<0))
+#define VO_V1B_C_y_src(data)                                                         ((0x000003FF&(data))>>0)
+#define VO_V1B_C_get_y(data)                                                         ((0x000003FF&(data))>>0)
+
+
+#define VO_V1B_X                                                                     0x98005D94
+#define VO_V1B_X_reg_addr                                                            "0xD8005D94"
+#define VO_V1B_X_reg                                                                 0xD8005D94
+#define set_VO_V1B_X_reg(data)   (*((volatile unsigned int*) VO_V1B_X_reg)=data)
+#define get_VO_V1B_X_reg   (*((volatile unsigned int*) VO_V1B_X_reg))
+#define VO_V1B_X_inst_adr                                                            "0x0065"
+#define VO_V1B_X_inst                                                                0x0065
+#define VO_V1B_X_e_shift                                                             (16)
+#define VO_V1B_X_e_mask                                                              (0x1FFF0000)
+#define VO_V1B_X_e(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_V1B_X_e_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1B_X_get_e(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1B_X_s_shift                                                             (0)
+#define VO_V1B_X_s_mask                                                              (0x00001FFF)
+#define VO_V1B_X_s(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_V1B_X_s_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_V1B_X_get_s(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1B_Y                                                                     0x98005D98
+#define VO_V1B_Y_reg_addr                                                            "0xD8005D98"
+#define VO_V1B_Y_reg                                                                 0xD8005D98
+#define set_VO_V1B_Y_reg(data)   (*((volatile unsigned int*) VO_V1B_Y_reg)=data)
+#define get_VO_V1B_Y_reg   (*((volatile unsigned int*) VO_V1B_Y_reg))
+#define VO_V1B_Y_inst_adr                                                            "0x0066"
+#define VO_V1B_Y_inst                                                                0x0066
+#define VO_V1B_Y_e_shift                                                             (16)
+#define VO_V1B_Y_e_mask                                                              (0x1FFF0000)
+#define VO_V1B_Y_e(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_V1B_Y_e_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1B_Y_get_e(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1B_Y_s_shift                                                             (0)
+#define VO_V1B_Y_s_mask                                                              (0x00001FFF)
+#define VO_V1B_Y_s(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_V1B_Y_s_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_V1B_Y_get_s(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1_3D                                                                     0x98005D9C
+#define VO_V1_3D_reg_addr                                                            "0xD8005D9C"
+#define VO_V1_3D_reg                                                                 0xD8005D9C
+#define set_VO_V1_3D_reg(data)   (*((volatile unsigned int*) VO_V1_3D_reg)=data)
+#define get_VO_V1_3D_reg   (*((volatile unsigned int*) VO_V1_3D_reg))
+#define VO_V1_3D_inst_adr                                                            "0x0067"
+#define VO_V1_3D_inst                                                                0x0067
+#define VO_V1_3D_dir_r_shift                                                         (29)
+#define VO_V1_3D_dir_r_mask                                                          (0x20000000)
+#define VO_V1_3D_dir_r(data)                                                         (0x20000000&((data)<<29))
+#define VO_V1_3D_dir_r_src(data)                                                     ((0x20000000&(data))>>29)
+#define VO_V1_3D_get_dir_r(data)                                                     ((0x20000000&(data))>>29)
+#define VO_V1_3D_offset_r_shift                                                      (16)
+#define VO_V1_3D_offset_r_mask                                                       (0x1FFF0000)
+#define VO_V1_3D_offset_r(data)                                                      (0x1FFF0000&((data)<<16))
+#define VO_V1_3D_offset_r_src(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_V1_3D_get_offset_r(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_V1_3D_dir_l_shift                                                         (13)
+#define VO_V1_3D_dir_l_mask                                                          (0x00002000)
+#define VO_V1_3D_dir_l(data)                                                         (0x00002000&((data)<<13))
+#define VO_V1_3D_dir_l_src(data)                                                     ((0x00002000&(data))>>13)
+#define VO_V1_3D_get_dir_l(data)                                                     ((0x00002000&(data))>>13)
+#define VO_V1_3D_offset_l_shift                                                      (0)
+#define VO_V1_3D_offset_l_mask                                                       (0x00001FFF)
+#define VO_V1_3D_offset_l(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_V1_3D_offset_l_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_V1_3D_get_offset_l(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_V2_XY                                                                     0x98005DA0
+#define VO_V2_XY_reg_addr                                                            "0xD8005DA0"
+#define VO_V2_XY_reg                                                                 0xD8005DA0
+#define set_VO_V2_XY_reg(data)   (*((volatile unsigned int*) VO_V2_XY_reg)=data)
+#define get_VO_V2_XY_reg   (*((volatile unsigned int*) VO_V2_XY_reg))
+#define VO_V2_XY_inst_adr                                                            "0x0068"
+#define VO_V2_XY_inst                                                                0x0068
+#define VO_V2_XY_x_shift                                                             (16)
+#define VO_V2_XY_x_mask                                                              (0x1FFF0000)
+#define VO_V2_XY_x(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_V2_XY_x_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V2_XY_get_x(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V2_XY_y_shift                                                             (0)
+#define VO_V2_XY_y_mask                                                              (0x00001FFF)
+#define VO_V2_XY_y(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_V2_XY_y_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_V2_XY_get_y(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_V2B_C                                                                     0x98005DA4
+#define VO_V2B_C_reg_addr                                                            "0xD8005DA4"
+#define VO_V2B_C_reg                                                                 0xD8005DA4
+#define set_VO_V2B_C_reg(data)   (*((volatile unsigned int*) VO_V2B_C_reg)=data)
+#define get_VO_V2B_C_reg   (*((volatile unsigned int*) VO_V2B_C_reg))
+#define VO_V2B_C_inst_adr                                                            "0x0069"
+#define VO_V2B_C_inst                                                                0x0069
+#define VO_V2B_C_cr_shift                                                            (20)
+#define VO_V2B_C_cr_mask                                                             (0x3FF00000)
+#define VO_V2B_C_cr(data)                                                            (0x3FF00000&((data)<<20))
+#define VO_V2B_C_cr_src(data)                                                        ((0x3FF00000&(data))>>20)
+#define VO_V2B_C_get_cr(data)                                                        ((0x3FF00000&(data))>>20)
+#define VO_V2B_C_cb_shift                                                            (10)
+#define VO_V2B_C_cb_mask                                                             (0x000FFC00)
+#define VO_V2B_C_cb(data)                                                            (0x000FFC00&((data)<<10))
+#define VO_V2B_C_cb_src(data)                                                        ((0x000FFC00&(data))>>10)
+#define VO_V2B_C_get_cb(data)                                                        ((0x000FFC00&(data))>>10)
+#define VO_V2B_C_y_shift                                                             (0)
+#define VO_V2B_C_y_mask                                                              (0x000003FF)
+#define VO_V2B_C_y(data)                                                             (0x000003FF&((data)<<0))
+#define VO_V2B_C_y_src(data)                                                         ((0x000003FF&(data))>>0)
+#define VO_V2B_C_get_y(data)                                                         ((0x000003FF&(data))>>0)
+
+
+#define VO_V2B_X                                                                     0x98005DA8
+#define VO_V2B_X_reg_addr                                                            "0xD8005DA8"
+#define VO_V2B_X_reg                                                                 0xD8005DA8
+#define set_VO_V2B_X_reg(data)   (*((volatile unsigned int*) VO_V2B_X_reg)=data)
+#define get_VO_V2B_X_reg   (*((volatile unsigned int*) VO_V2B_X_reg))
+#define VO_V2B_X_inst_adr                                                            "0x006A"
+#define VO_V2B_X_inst                                                                0x006A
+#define VO_V2B_X_e_shift                                                             (16)
+#define VO_V2B_X_e_mask                                                              (0x1FFF0000)
+#define VO_V2B_X_e(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_V2B_X_e_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V2B_X_get_e(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V2B_X_s_shift                                                             (0)
+#define VO_V2B_X_s_mask                                                              (0x00001FFF)
+#define VO_V2B_X_s(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_V2B_X_s_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_V2B_X_get_s(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_V2B_Y                                                                     0x98005DAC
+#define VO_V2B_Y_reg_addr                                                            "0xD8005DAC"
+#define VO_V2B_Y_reg                                                                 0xD8005DAC
+#define set_VO_V2B_Y_reg(data)   (*((volatile unsigned int*) VO_V2B_Y_reg)=data)
+#define get_VO_V2B_Y_reg   (*((volatile unsigned int*) VO_V2B_Y_reg))
+#define VO_V2B_Y_inst_adr                                                            "0x006B"
+#define VO_V2B_Y_inst                                                                0x006B
+#define VO_V2B_Y_e_shift                                                             (16)
+#define VO_V2B_Y_e_mask                                                              (0x1FFF0000)
+#define VO_V2B_Y_e(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_V2B_Y_e_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V2B_Y_get_e(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V2B_Y_s_shift                                                             (0)
+#define VO_V2B_Y_s_mask                                                              (0x00001FFF)
+#define VO_V2B_Y_s(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_V2B_Y_s_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_V2B_Y_get_s(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_V2BG_C                                                                    0x98005DB0
+#define VO_V2BG_C_reg_addr                                                           "0xD8005DB0"
+#define VO_V2BG_C_reg                                                                0xD8005DB0
+#define set_VO_V2BG_C_reg(data)   (*((volatile unsigned int*) VO_V2BG_C_reg)=data)
+#define get_VO_V2BG_C_reg   (*((volatile unsigned int*) VO_V2BG_C_reg))
+#define VO_V2BG_C_inst_adr                                                           "0x006C"
+#define VO_V2BG_C_inst                                                               0x006C
+#define VO_V2BG_C_y_shift                                                            (16)
+#define VO_V2BG_C_y_mask                                                             (0x00FF0000)
+#define VO_V2BG_C_y(data)                                                            (0x00FF0000&((data)<<16))
+#define VO_V2BG_C_y_src(data)                                                        ((0x00FF0000&(data))>>16)
+#define VO_V2BG_C_get_y(data)                                                        ((0x00FF0000&(data))>>16)
+#define VO_V2BG_C_cb_shift                                                           (8)
+#define VO_V2BG_C_cb_mask                                                            (0x0000FF00)
+#define VO_V2BG_C_cb(data)                                                           (0x0000FF00&((data)<<8))
+#define VO_V2BG_C_cb_src(data)                                                       ((0x0000FF00&(data))>>8)
+#define VO_V2BG_C_get_cb(data)                                                       ((0x0000FF00&(data))>>8)
+#define VO_V2BG_C_cr_shift                                                           (0)
+#define VO_V2BG_C_cr_mask                                                            (0x000000FF)
+#define VO_V2BG_C_cr(data)                                                           (0x000000FF&((data)<<0))
+#define VO_V2BG_C_cr_src(data)                                                       ((0x000000FF&(data))>>0)
+#define VO_V2BG_C_get_cr(data)                                                       ((0x000000FF&(data))>>0)
+
+
+#define VO_V2BG_X                                                                    0x98005DB4
+#define VO_V2BG_X_reg_addr                                                           "0xD8005DB4"
+#define VO_V2BG_X_reg                                                                0xD8005DB4
+#define set_VO_V2BG_X_reg(data)   (*((volatile unsigned int*) VO_V2BG_X_reg)=data)
+#define get_VO_V2BG_X_reg   (*((volatile unsigned int*) VO_V2BG_X_reg))
+#define VO_V2BG_X_inst_adr                                                           "0x006D"
+#define VO_V2BG_X_inst                                                               0x006D
+#define VO_V2BG_X_e_shift                                                            (16)
+#define VO_V2BG_X_e_mask                                                             (0x1FFF0000)
+#define VO_V2BG_X_e(data)                                                            (0x1FFF0000&((data)<<16))
+#define VO_V2BG_X_e_src(data)                                                        ((0x1FFF0000&(data))>>16)
+#define VO_V2BG_X_get_e(data)                                                        ((0x1FFF0000&(data))>>16)
+#define VO_V2BG_X_s_shift                                                            (0)
+#define VO_V2BG_X_s_mask                                                             (0x00001FFF)
+#define VO_V2BG_X_s(data)                                                            (0x00001FFF&((data)<<0))
+#define VO_V2BG_X_s_src(data)                                                        ((0x00001FFF&(data))>>0)
+#define VO_V2BG_X_get_s(data)                                                        ((0x00001FFF&(data))>>0)
+
+
+#define VO_V2BG_Y                                                                    0x98005DB8
+#define VO_V2BG_Y_reg_addr                                                           "0xD8005DB8"
+#define VO_V2BG_Y_reg                                                                0xD8005DB8
+#define set_VO_V2BG_Y_reg(data)   (*((volatile unsigned int*) VO_V2BG_Y_reg)=data)
+#define get_VO_V2BG_Y_reg   (*((volatile unsigned int*) VO_V2BG_Y_reg))
+#define VO_V2BG_Y_inst_adr                                                           "0x006E"
+#define VO_V2BG_Y_inst                                                               0x006E
+#define VO_V2BG_Y_e_shift                                                            (16)
+#define VO_V2BG_Y_e_mask                                                             (0x1FFF0000)
+#define VO_V2BG_Y_e(data)                                                            (0x1FFF0000&((data)<<16))
+#define VO_V2BG_Y_e_src(data)                                                        ((0x1FFF0000&(data))>>16)
+#define VO_V2BG_Y_get_e(data)                                                        ((0x1FFF0000&(data))>>16)
+#define VO_V2BG_Y_s_shift                                                            (0)
+#define VO_V2BG_Y_s_mask                                                             (0x00001FFF)
+#define VO_V2BG_Y_s(data)                                                            (0x00001FFF&((data)<<0))
+#define VO_V2BG_Y_s_src(data)                                                        ((0x00001FFF&(data))>>0)
+#define VO_V2BG_Y_get_s(data)                                                        ((0x00001FFF&(data))>>0)
+
+
+#define VO_V2_3D                                                                     0x98005DBC
+#define VO_V2_3D_reg_addr                                                            "0xD8005DBC"
+#define VO_V2_3D_reg                                                                 0xD8005DBC
+#define set_VO_V2_3D_reg(data)   (*((volatile unsigned int*) VO_V2_3D_reg)=data)
+#define get_VO_V2_3D_reg   (*((volatile unsigned int*) VO_V2_3D_reg))
+#define VO_V2_3D_inst_adr                                                            "0x006F"
+#define VO_V2_3D_inst                                                                0x006F
+#define VO_V2_3D_dir_r_shift                                                         (29)
+#define VO_V2_3D_dir_r_mask                                                          (0x20000000)
+#define VO_V2_3D_dir_r(data)                                                         (0x20000000&((data)<<29))
+#define VO_V2_3D_dir_r_src(data)                                                     ((0x20000000&(data))>>29)
+#define VO_V2_3D_get_dir_r(data)                                                     ((0x20000000&(data))>>29)
+#define VO_V2_3D_offset_r_shift                                                      (16)
+#define VO_V2_3D_offset_r_mask                                                       (0x1FFF0000)
+#define VO_V2_3D_offset_r(data)                                                      (0x1FFF0000&((data)<<16))
+#define VO_V2_3D_offset_r_src(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_V2_3D_get_offset_r(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_V2_3D_dir_l_shift                                                         (13)
+#define VO_V2_3D_dir_l_mask                                                          (0x00002000)
+#define VO_V2_3D_dir_l(data)                                                         (0x00002000&((data)<<13))
+#define VO_V2_3D_dir_l_src(data)                                                     ((0x00002000&(data))>>13)
+#define VO_V2_3D_get_dir_l(data)                                                     ((0x00002000&(data))>>13)
+#define VO_V2_3D_offset_l_shift                                                      (0)
+#define VO_V2_3D_offset_l_mask                                                       (0x00001FFF)
+#define VO_V2_3D_offset_l(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_V2_3D_offset_l_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_V2_3D_get_offset_l(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_SUB1_XY                                                                   0x98005DC0
+#define VO_SUB1_XY_reg_addr                                                          "0xD8005DC0"
+#define VO_SUB1_XY_reg                                                               0xD8005DC0
+#define set_VO_SUB1_XY_reg(data)   (*((volatile unsigned int*) VO_SUB1_XY_reg)=data)
+#define get_VO_SUB1_XY_reg   (*((volatile unsigned int*) VO_SUB1_XY_reg))
+#define VO_SUB1_XY_inst_adr                                                          "0x0070"
+#define VO_SUB1_XY_inst                                                              0x0070
+#define VO_SUB1_XY_x_shift                                                           (16)
+#define VO_SUB1_XY_x_mask                                                            (0x1FFF0000)
+#define VO_SUB1_XY_x(data)                                                           (0x1FFF0000&((data)<<16))
+#define VO_SUB1_XY_x_src(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_SUB1_XY_get_x(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_SUB1_XY_y_shift                                                           (0)
+#define VO_SUB1_XY_y_mask                                                            (0x00001FFF)
+#define VO_SUB1_XY_y(data)                                                           (0x00001FFF&((data)<<0))
+#define VO_SUB1_XY_y_src(data)                                                       ((0x00001FFF&(data))>>0)
+#define VO_SUB1_XY_get_y(data)                                                       ((0x00001FFF&(data))>>0)
+
+
+#define VO_SUB1_3D                                                                   0x98005DC4
+#define VO_SUB1_3D_reg_addr                                                          "0xD8005DC4"
+#define VO_SUB1_3D_reg                                                               0xD8005DC4
+#define set_VO_SUB1_3D_reg(data)   (*((volatile unsigned int*) VO_SUB1_3D_reg)=data)
+#define get_VO_SUB1_3D_reg   (*((volatile unsigned int*) VO_SUB1_3D_reg))
+#define VO_SUB1_3D_inst_adr                                                          "0x0071"
+#define VO_SUB1_3D_inst                                                              0x0071
+#define VO_SUB1_3D_dir_r_shift                                                       (29)
+#define VO_SUB1_3D_dir_r_mask                                                        (0x20000000)
+#define VO_SUB1_3D_dir_r(data)                                                       (0x20000000&((data)<<29))
+#define VO_SUB1_3D_dir_r_src(data)                                                   ((0x20000000&(data))>>29)
+#define VO_SUB1_3D_get_dir_r(data)                                                   ((0x20000000&(data))>>29)
+#define VO_SUB1_3D_offset_r_shift                                                    (16)
+#define VO_SUB1_3D_offset_r_mask                                                     (0x1FFF0000)
+#define VO_SUB1_3D_offset_r(data)                                                    (0x1FFF0000&((data)<<16))
+#define VO_SUB1_3D_offset_r_src(data)                                                ((0x1FFF0000&(data))>>16)
+#define VO_SUB1_3D_get_offset_r(data)                                                ((0x1FFF0000&(data))>>16)
+#define VO_SUB1_3D_dir_l_shift                                                       (13)
+#define VO_SUB1_3D_dir_l_mask                                                        (0x00002000)
+#define VO_SUB1_3D_dir_l(data)                                                       (0x00002000&((data)<<13))
+#define VO_SUB1_3D_dir_l_src(data)                                                   ((0x00002000&(data))>>13)
+#define VO_SUB1_3D_get_dir_l(data)                                                   ((0x00002000&(data))>>13)
+#define VO_SUB1_3D_offset_l_shift                                                    (0)
+#define VO_SUB1_3D_offset_l_mask                                                     (0x00001FFF)
+#define VO_SUB1_3D_offset_l(data)                                                    (0x00001FFF&((data)<<0))
+#define VO_SUB1_3D_offset_l_src(data)                                                ((0x00001FFF&(data))>>0)
+#define VO_SUB1_3D_get_offset_l(data)                                                ((0x00001FFF&(data))>>0)
+
+
+#define VO_SUB2_XY                                                                   0x98005DC8
+#define VO_SUB2_XY_reg_addr                                                          "0xD8005DC8"
+#define VO_SUB2_XY_reg                                                               0xD8005DC8
+#define set_VO_SUB2_XY_reg(data)   (*((volatile unsigned int*) VO_SUB2_XY_reg)=data)
+#define get_VO_SUB2_XY_reg   (*((volatile unsigned int*) VO_SUB2_XY_reg))
+#define VO_SUB2_XY_inst_adr                                                          "0x0072"
+#define VO_SUB2_XY_inst                                                              0x0072
+#define VO_SUB2_XY_x_shift                                                           (16)
+#define VO_SUB2_XY_x_mask                                                            (0x1FFF0000)
+#define VO_SUB2_XY_x(data)                                                           (0x1FFF0000&((data)<<16))
+#define VO_SUB2_XY_x_src(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_SUB2_XY_get_x(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_SUB2_XY_y_shift                                                           (0)
+#define VO_SUB2_XY_y_mask                                                            (0x00001FFF)
+#define VO_SUB2_XY_y(data)                                                           (0x00001FFF&((data)<<0))
+#define VO_SUB2_XY_y_src(data)                                                       ((0x00001FFF&(data))>>0)
+#define VO_SUB2_XY_get_y(data)                                                       ((0x00001FFF&(data))>>0)
+
+
+#define VO_SUB2_3D                                                                   0x98005DCC
+#define VO_SUB2_3D_reg_addr                                                          "0xD8005DCC"
+#define VO_SUB2_3D_reg                                                               0xD8005DCC
+#define set_VO_SUB2_3D_reg(data)   (*((volatile unsigned int*) VO_SUB2_3D_reg)=data)
+#define get_VO_SUB2_3D_reg   (*((volatile unsigned int*) VO_SUB2_3D_reg))
+#define VO_SUB2_3D_inst_adr                                                          "0x0073"
+#define VO_SUB2_3D_inst                                                              0x0073
+#define VO_SUB2_3D_dir_r_shift                                                       (29)
+#define VO_SUB2_3D_dir_r_mask                                                        (0x20000000)
+#define VO_SUB2_3D_dir_r(data)                                                       (0x20000000&((data)<<29))
+#define VO_SUB2_3D_dir_r_src(data)                                                   ((0x20000000&(data))>>29)
+#define VO_SUB2_3D_get_dir_r(data)                                                   ((0x20000000&(data))>>29)
+#define VO_SUB2_3D_offset_r_shift                                                    (16)
+#define VO_SUB2_3D_offset_r_mask                                                     (0x1FFF0000)
+#define VO_SUB2_3D_offset_r(data)                                                    (0x1FFF0000&((data)<<16))
+#define VO_SUB2_3D_offset_r_src(data)                                                ((0x1FFF0000&(data))>>16)
+#define VO_SUB2_3D_get_offset_r(data)                                                ((0x1FFF0000&(data))>>16)
+#define VO_SUB2_3D_dir_l_shift                                                       (13)
+#define VO_SUB2_3D_dir_l_mask                                                        (0x00002000)
+#define VO_SUB2_3D_dir_l(data)                                                       (0x00002000&((data)<<13))
+#define VO_SUB2_3D_dir_l_src(data)                                                   ((0x00002000&(data))>>13)
+#define VO_SUB2_3D_get_dir_l(data)                                                   ((0x00002000&(data))>>13)
+#define VO_SUB2_3D_offset_l_shift                                                    (0)
+#define VO_SUB2_3D_offset_l_mask                                                     (0x00001FFF)
+#define VO_SUB2_3D_offset_l(data)                                                    (0x00001FFF&((data)<<0))
+#define VO_SUB2_3D_offset_l_src(data)                                                ((0x00001FFF&(data))>>0)
+#define VO_SUB2_3D_get_offset_l(data)                                                ((0x00001FFF&(data))>>0)
+
+
+#define VO_OSD1_XY                                                                   0x98005DD0
+#define VO_OSD1_XY_reg_addr                                                          "0xD8005DD0"
+#define VO_OSD1_XY_reg                                                               0xD8005DD0
+#define set_VO_OSD1_XY_reg(data)   (*((volatile unsigned int*) VO_OSD1_XY_reg)=data)
+#define get_VO_OSD1_XY_reg   (*((volatile unsigned int*) VO_OSD1_XY_reg))
+#define VO_OSD1_XY_inst_adr                                                          "0x0074"
+#define VO_OSD1_XY_inst                                                              0x0074
+#define VO_OSD1_XY_x_shift                                                           (16)
+#define VO_OSD1_XY_x_mask                                                            (0x1FFF0000)
+#define VO_OSD1_XY_x(data)                                                           (0x1FFF0000&((data)<<16))
+#define VO_OSD1_XY_x_src(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_OSD1_XY_get_x(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_OSD1_XY_y_shift                                                           (0)
+#define VO_OSD1_XY_y_mask                                                            (0x00001FFF)
+#define VO_OSD1_XY_y(data)                                                           (0x00001FFF&((data)<<0))
+#define VO_OSD1_XY_y_src(data)                                                       ((0x00001FFF&(data))>>0)
+#define VO_OSD1_XY_get_y(data)                                                       ((0x00001FFF&(data))>>0)
+
+
+#define VO_OSD1_3D                                                                   0x98005DD4
+#define VO_OSD1_3D_reg_addr                                                          "0xD8005DD4"
+#define VO_OSD1_3D_reg                                                               0xD8005DD4
+#define set_VO_OSD1_3D_reg(data)   (*((volatile unsigned int*) VO_OSD1_3D_reg)=data)
+#define get_VO_OSD1_3D_reg   (*((volatile unsigned int*) VO_OSD1_3D_reg))
+#define VO_OSD1_3D_inst_adr                                                          "0x0075"
+#define VO_OSD1_3D_inst                                                              0x0075
+#define VO_OSD1_3D_dir_r_shift                                                       (29)
+#define VO_OSD1_3D_dir_r_mask                                                        (0x20000000)
+#define VO_OSD1_3D_dir_r(data)                                                       (0x20000000&((data)<<29))
+#define VO_OSD1_3D_dir_r_src(data)                                                   ((0x20000000&(data))>>29)
+#define VO_OSD1_3D_get_dir_r(data)                                                   ((0x20000000&(data))>>29)
+#define VO_OSD1_3D_offset_r_shift                                                    (16)
+#define VO_OSD1_3D_offset_r_mask                                                     (0x1FFF0000)
+#define VO_OSD1_3D_offset_r(data)                                                    (0x1FFF0000&((data)<<16))
+#define VO_OSD1_3D_offset_r_src(data)                                                ((0x1FFF0000&(data))>>16)
+#define VO_OSD1_3D_get_offset_r(data)                                                ((0x1FFF0000&(data))>>16)
+#define VO_OSD1_3D_dir_l_shift                                                       (13)
+#define VO_OSD1_3D_dir_l_mask                                                        (0x00002000)
+#define VO_OSD1_3D_dir_l(data)                                                       (0x00002000&((data)<<13))
+#define VO_OSD1_3D_dir_l_src(data)                                                   ((0x00002000&(data))>>13)
+#define VO_OSD1_3D_get_dir_l(data)                                                   ((0x00002000&(data))>>13)
+#define VO_OSD1_3D_offset_l_shift                                                    (0)
+#define VO_OSD1_3D_offset_l_mask                                                     (0x00001FFF)
+#define VO_OSD1_3D_offset_l(data)                                                    (0x00001FFF&((data)<<0))
+#define VO_OSD1_3D_offset_l_src(data)                                                ((0x00001FFF&(data))>>0)
+#define VO_OSD1_3D_get_offset_l(data)                                                ((0x00001FFF&(data))>>0)
+
+
+#define VO_CSR_XY                                                                    0x98005DD8
+#define VO_CSR_XY_reg_addr                                                           "0xD8005DD8"
+#define VO_CSR_XY_reg                                                                0xD8005DD8
+#define set_VO_CSR_XY_reg(data)   (*((volatile unsigned int*) VO_CSR_XY_reg)=data)
+#define get_VO_CSR_XY_reg   (*((volatile unsigned int*) VO_CSR_XY_reg))
+#define VO_CSR_XY_inst_adr                                                           "0x0076"
+#define VO_CSR_XY_inst                                                               0x0076
+#define VO_CSR_XY_x_shift                                                            (16)
+#define VO_CSR_XY_x_mask                                                             (0x1FFF0000)
+#define VO_CSR_XY_x(data)                                                            (0x1FFF0000&((data)<<16))
+#define VO_CSR_XY_x_src(data)                                                        ((0x1FFF0000&(data))>>16)
+#define VO_CSR_XY_get_x(data)                                                        ((0x1FFF0000&(data))>>16)
+#define VO_CSR_XY_y_shift                                                            (0)
+#define VO_CSR_XY_y_mask                                                             (0x00001FFF)
+#define VO_CSR_XY_y(data)                                                            (0x00001FFF&((data)<<0))
+#define VO_CSR_XY_y_src(data)                                                        ((0x00001FFF&(data))>>0)
+#define VO_CSR_XY_get_y(data)                                                        ((0x00001FFF&(data))>>0)
+
+
+#define VO_CSR_3D                                                                    0x98005DDC
+#define VO_CSR_3D_reg_addr                                                           "0xD8005DDC"
+#define VO_CSR_3D_reg                                                                0xD8005DDC
+#define set_VO_CSR_3D_reg(data)   (*((volatile unsigned int*) VO_CSR_3D_reg)=data)
+#define get_VO_CSR_3D_reg   (*((volatile unsigned int*) VO_CSR_3D_reg))
+#define VO_CSR_3D_inst_adr                                                           "0x0077"
+#define VO_CSR_3D_inst                                                               0x0077
+#define VO_CSR_3D_dir_r_shift                                                        (29)
+#define VO_CSR_3D_dir_r_mask                                                         (0x20000000)
+#define VO_CSR_3D_dir_r(data)                                                        (0x20000000&((data)<<29))
+#define VO_CSR_3D_dir_r_src(data)                                                    ((0x20000000&(data))>>29)
+#define VO_CSR_3D_get_dir_r(data)                                                    ((0x20000000&(data))>>29)
+#define VO_CSR_3D_offset_r_shift                                                     (16)
+#define VO_CSR_3D_offset_r_mask                                                      (0x1FFF0000)
+#define VO_CSR_3D_offset_r(data)                                                     (0x1FFF0000&((data)<<16))
+#define VO_CSR_3D_offset_r_src(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_CSR_3D_get_offset_r(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_CSR_3D_dir_l_shift                                                        (13)
+#define VO_CSR_3D_dir_l_mask                                                         (0x00002000)
+#define VO_CSR_3D_dir_l(data)                                                        (0x00002000&((data)<<13))
+#define VO_CSR_3D_dir_l_src(data)                                                    ((0x00002000&(data))>>13)
+#define VO_CSR_3D_get_dir_l(data)                                                    ((0x00002000&(data))>>13)
+#define VO_CSR_3D_offset_l_shift                                                     (0)
+#define VO_CSR_3D_offset_l_mask                                                      (0x00001FFF)
+#define VO_CSR_3D_offset_l(data)                                                     (0x00001FFF&((data)<<0))
+#define VO_CSR_3D_offset_l_src(data)                                                 ((0x00001FFF&(data))>>0)
+#define VO_CSR_3D_get_offset_l(data)                                                 ((0x00001FFF&(data))>>0)
+
+
+#define VO_DD_XY                                                                     0x98005DE0
+#define VO_DD_XY_reg_addr                                                            "0xD8005DE0"
+#define VO_DD_XY_reg                                                                 0xD8005DE0
+#define set_VO_DD_XY_reg(data)   (*((volatile unsigned int*) VO_DD_XY_reg)=data)
+#define get_VO_DD_XY_reg   (*((volatile unsigned int*) VO_DD_XY_reg))
+#define VO_DD_XY_inst_adr                                                            "0x0078"
+#define VO_DD_XY_inst                                                                0x0078
+#define VO_DD_XY_x_shift                                                             (16)
+#define VO_DD_XY_x_mask                                                              (0x1FFF0000)
+#define VO_DD_XY_x(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_DD_XY_x_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_DD_XY_get_x(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_DD_XY_y_shift                                                             (0)
+#define VO_DD_XY_y_mask                                                              (0x00001FFF)
+#define VO_DD_XY_y(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_DD_XY_y_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_DD_XY_get_y(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_CH1_BUF                                                                   0x98005DE4
+#define VO_CH1_BUF_reg_addr                                                          "0xD8005DE4"
+#define VO_CH1_BUF_reg                                                               0xD8005DE4
+#define set_VO_CH1_BUF_reg(data)   (*((volatile unsigned int*) VO_CH1_BUF_reg)=data)
+#define get_VO_CH1_BUF_reg   (*((volatile unsigned int*) VO_CH1_BUF_reg))
+#define VO_CH1_BUF_inst_adr                                                          "0x0079"
+#define VO_CH1_BUF_inst                                                              0x0079
+#define VO_CH1_BUF_write_en2_shift                                                   (23)
+#define VO_CH1_BUF_write_en2_mask                                                    (0x00800000)
+#define VO_CH1_BUF_write_en2(data)                                                   (0x00800000&((data)<<23))
+#define VO_CH1_BUF_write_en2_src(data)                                               ((0x00800000&(data))>>23)
+#define VO_CH1_BUF_get_write_en2(data)                                               ((0x00800000&(data))>>23)
+#define VO_CH1_BUF_th_shift                                                          (12)
+#define VO_CH1_BUF_th_mask                                                           (0x007FF000)
+#define VO_CH1_BUF_th(data)                                                          (0x007FF000&((data)<<12))
+#define VO_CH1_BUF_th_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CH1_BUF_get_th(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CH1_BUF_write_en1_shift                                                   (11)
+#define VO_CH1_BUF_write_en1_mask                                                    (0x00000800)
+#define VO_CH1_BUF_write_en1(data)                                                   (0x00000800&((data)<<11))
+#define VO_CH1_BUF_write_en1_src(data)                                               ((0x00000800&(data))>>11)
+#define VO_CH1_BUF_get_write_en1(data)                                               ((0x00000800&(data))>>11)
+#define VO_CH1_BUF_b_shift                                                           (0)
+#define VO_CH1_BUF_b_mask                                                            (0x000007FF)
+#define VO_CH1_BUF_b(data)                                                           (0x000007FF&((data)<<0))
+#define VO_CH1_BUF_b_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VO_CH1_BUF_get_b(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VO_CH2_BUF                                                                   0x98005DE8
+#define VO_CH2_BUF_reg_addr                                                          "0xD8005DE8"
+#define VO_CH2_BUF_reg                                                               0xD8005DE8
+#define set_VO_CH2_BUF_reg(data)   (*((volatile unsigned int*) VO_CH2_BUF_reg)=data)
+#define get_VO_CH2_BUF_reg   (*((volatile unsigned int*) VO_CH2_BUF_reg))
+#define VO_CH2_BUF_inst_adr                                                          "0x007A"
+#define VO_CH2_BUF_inst                                                              0x007A
+#define VO_CH2_BUF_write_en2_shift                                                   (23)
+#define VO_CH2_BUF_write_en2_mask                                                    (0x00800000)
+#define VO_CH2_BUF_write_en2(data)                                                   (0x00800000&((data)<<23))
+#define VO_CH2_BUF_write_en2_src(data)                                               ((0x00800000&(data))>>23)
+#define VO_CH2_BUF_get_write_en2(data)                                               ((0x00800000&(data))>>23)
+#define VO_CH2_BUF_th_shift                                                          (12)
+#define VO_CH2_BUF_th_mask                                                           (0x007FF000)
+#define VO_CH2_BUF_th(data)                                                          (0x007FF000&((data)<<12))
+#define VO_CH2_BUF_th_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CH2_BUF_get_th(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CH2_BUF_write_en1_shift                                                   (11)
+#define VO_CH2_BUF_write_en1_mask                                                    (0x00000800)
+#define VO_CH2_BUF_write_en1(data)                                                   (0x00000800&((data)<<11))
+#define VO_CH2_BUF_write_en1_src(data)                                               ((0x00000800&(data))>>11)
+#define VO_CH2_BUF_get_write_en1(data)                                               ((0x00000800&(data))>>11)
+#define VO_CH2_BUF_b_shift                                                           (0)
+#define VO_CH2_BUF_b_mask                                                            (0x000007FF)
+#define VO_CH2_BUF_b(data)                                                           (0x000007FF&((data)<<0))
+#define VO_CH2_BUF_b_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VO_CH2_BUF_get_b(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VO_CH3_BUF                                                                   0x98005DEC
+#define VO_CH3_BUF_reg_addr                                                          "0xD8005DEC"
+#define VO_CH3_BUF_reg                                                               0xD8005DEC
+#define set_VO_CH3_BUF_reg(data)   (*((volatile unsigned int*) VO_CH3_BUF_reg)=data)
+#define get_VO_CH3_BUF_reg   (*((volatile unsigned int*) VO_CH3_BUF_reg))
+#define VO_CH3_BUF_inst_adr                                                          "0x007B"
+#define VO_CH3_BUF_inst                                                              0x007B
+#define VO_CH3_BUF_write_en2_shift                                                   (23)
+#define VO_CH3_BUF_write_en2_mask                                                    (0x00800000)
+#define VO_CH3_BUF_write_en2(data)                                                   (0x00800000&((data)<<23))
+#define VO_CH3_BUF_write_en2_src(data)                                               ((0x00800000&(data))>>23)
+#define VO_CH3_BUF_get_write_en2(data)                                               ((0x00800000&(data))>>23)
+#define VO_CH3_BUF_th_shift                                                          (12)
+#define VO_CH3_BUF_th_mask                                                           (0x007FF000)
+#define VO_CH3_BUF_th(data)                                                          (0x007FF000&((data)<<12))
+#define VO_CH3_BUF_th_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CH3_BUF_get_th(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CH3_BUF_write_en1_shift                                                   (11)
+#define VO_CH3_BUF_write_en1_mask                                                    (0x00000800)
+#define VO_CH3_BUF_write_en1(data)                                                   (0x00000800&((data)<<11))
+#define VO_CH3_BUF_write_en1_src(data)                                               ((0x00000800&(data))>>11)
+#define VO_CH3_BUF_get_write_en1(data)                                               ((0x00000800&(data))>>11)
+#define VO_CH3_BUF_b_shift                                                           (0)
+#define VO_CH3_BUF_b_mask                                                            (0x000007FF)
+#define VO_CH3_BUF_b(data)                                                           (0x000007FF&((data)<<0))
+#define VO_CH3_BUF_b_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VO_CH3_BUF_get_b(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VO_CH1                                                                       0x98005DF0
+#define VO_CH1_reg_addr                                                              "0xD8005DF0"
+#define VO_CH1_reg                                                                   0xD8005DF0
+#define set_VO_CH1_reg(data)   (*((volatile unsigned int*) VO_CH1_reg)=data)
+#define get_VO_CH1_reg   (*((volatile unsigned int*) VO_CH1_reg))
+#define VO_CH1_inst_adr                                                              "0x007C"
+#define VO_CH1_inst                                                                  0x007C
+#define VO_CH1_top_shift                                                             (2)
+#define VO_CH1_top_mask                                                              (0x00000004)
+#define VO_CH1_top(data)                                                             (0x00000004&((data)<<2))
+#define VO_CH1_top_src(data)                                                         ((0x00000004&(data))>>2)
+#define VO_CH1_get_top(data)                                                         ((0x00000004&(data))>>2)
+#define VO_CH1_reint_shift                                                           (1)
+#define VO_CH1_reint_mask                                                            (0x00000002)
+#define VO_CH1_reint(data)                                                           (0x00000002&((data)<<1))
+#define VO_CH1_reint_src(data)                                                       ((0x00000002&(data))>>1)
+#define VO_CH1_get_reint(data)                                                       ((0x00000002&(data))>>1)
+#define VO_CH1_write_data_shift                                                      (0)
+#define VO_CH1_write_data_mask                                                       (0x00000001)
+#define VO_CH1_write_data(data)                                                      (0x00000001&((data)<<0))
+#define VO_CH1_write_data_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_CH1_get_write_data(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_CH2                                                                       0x98005DF4
+#define VO_CH2_reg_addr                                                              "0xD8005DF4"
+#define VO_CH2_reg                                                                   0xD8005DF4
+#define set_VO_CH2_reg(data)   (*((volatile unsigned int*) VO_CH2_reg)=data)
+#define get_VO_CH2_reg   (*((volatile unsigned int*) VO_CH2_reg))
+#define VO_CH2_inst_adr                                                              "0x007D"
+#define VO_CH2_inst                                                                  0x007D
+#define VO_CH2_top_shift                                                             (2)
+#define VO_CH2_top_mask                                                              (0x00000004)
+#define VO_CH2_top(data)                                                             (0x00000004&((data)<<2))
+#define VO_CH2_top_src(data)                                                         ((0x00000004&(data))>>2)
+#define VO_CH2_get_top(data)                                                         ((0x00000004&(data))>>2)
+#define VO_CH2_reint_shift                                                           (1)
+#define VO_CH2_reint_mask                                                            (0x00000002)
+#define VO_CH2_reint(data)                                                           (0x00000002&((data)<<1))
+#define VO_CH2_reint_src(data)                                                       ((0x00000002&(data))>>1)
+#define VO_CH2_get_reint(data)                                                       ((0x00000002&(data))>>1)
+#define VO_CH2_write_data_shift                                                      (0)
+#define VO_CH2_write_data_mask                                                       (0x00000001)
+#define VO_CH2_write_data(data)                                                      (0x00000001&((data)<<0))
+#define VO_CH2_write_data_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_CH2_get_write_data(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_CH3                                                                       0x98005DF8
+#define VO_CH3_reg_addr                                                              "0xD8005DF8"
+#define VO_CH3_reg                                                                   0xD8005DF8
+#define set_VO_CH3_reg(data)   (*((volatile unsigned int*) VO_CH3_reg)=data)
+#define get_VO_CH3_reg   (*((volatile unsigned int*) VO_CH3_reg))
+#define VO_CH3_inst_adr                                                              "0x007E"
+#define VO_CH3_inst                                                                  0x007E
+#define VO_CH3_top_shift                                                             (2)
+#define VO_CH3_top_mask                                                              (0x00000004)
+#define VO_CH3_top(data)                                                             (0x00000004&((data)<<2))
+#define VO_CH3_top_src(data)                                                         ((0x00000004&(data))>>2)
+#define VO_CH3_get_top(data)                                                         ((0x00000004&(data))>>2)
+#define VO_CH3_reint_shift                                                           (1)
+#define VO_CH3_reint_mask                                                            (0x00000002)
+#define VO_CH3_reint(data)                                                           (0x00000002&((data)<<1))
+#define VO_CH3_reint_src(data)                                                       ((0x00000002&(data))>>1)
+#define VO_CH3_get_reint(data)                                                       ((0x00000002&(data))>>1)
+#define VO_CH3_write_data_shift                                                      (0)
+#define VO_CH3_write_data_mask                                                       (0x00000001)
+#define VO_CH3_write_data(data)                                                      (0x00000001&((data)<<0))
+#define VO_CH3_write_data_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_CH3_get_write_data(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_PORT_L_CC1                                                                0x98005DFC
+#define VO_PORT_L_CC1_reg_addr                                                       "0xD8005DFC"
+#define VO_PORT_L_CC1_reg                                                            0xD8005DFC
+#define set_VO_PORT_L_CC1_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC1_reg)=data)
+#define get_VO_PORT_L_CC1_reg   (*((volatile unsigned int*) VO_PORT_L_CC1_reg))
+#define VO_PORT_L_CC1_inst_adr                                                       "0x007F"
+#define VO_PORT_L_CC1_inst                                                           0x007F
+#define VO_PORT_L_CC1_m01_shift                                                      (16)
+#define VO_PORT_L_CC1_m01_mask                                                       (0x3FFF0000)
+#define VO_PORT_L_CC1_m01(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_L_CC1_m01_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC1_get_m01(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC1_m00_shift                                                      (0)
+#define VO_PORT_L_CC1_m00_mask                                                       (0x00003FFF)
+#define VO_PORT_L_CC1_m00(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_L_CC1_m00_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_L_CC1_get_m00(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC2                                                                0x98005E00
+#define VO_PORT_L_CC2_reg_addr                                                       "0xD8005E00"
+#define VO_PORT_L_CC2_reg                                                            0xD8005E00
+#define set_VO_PORT_L_CC2_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC2_reg)=data)
+#define get_VO_PORT_L_CC2_reg   (*((volatile unsigned int*) VO_PORT_L_CC2_reg))
+#define VO_PORT_L_CC2_inst_adr                                                       "0x0080"
+#define VO_PORT_L_CC2_inst                                                           0x0080
+#define VO_PORT_L_CC2_m10_shift                                                      (16)
+#define VO_PORT_L_CC2_m10_mask                                                       (0x3FFF0000)
+#define VO_PORT_L_CC2_m10(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_L_CC2_m10_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC2_get_m10(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC2_m02_shift                                                      (0)
+#define VO_PORT_L_CC2_m02_mask                                                       (0x00003FFF)
+#define VO_PORT_L_CC2_m02(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_L_CC2_m02_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_L_CC2_get_m02(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC3                                                                0x98005E04
+#define VO_PORT_L_CC3_reg_addr                                                       "0xD8005E04"
+#define VO_PORT_L_CC3_reg                                                            0xD8005E04
+#define set_VO_PORT_L_CC3_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC3_reg)=data)
+#define get_VO_PORT_L_CC3_reg   (*((volatile unsigned int*) VO_PORT_L_CC3_reg))
+#define VO_PORT_L_CC3_inst_adr                                                       "0x0081"
+#define VO_PORT_L_CC3_inst                                                           0x0081
+#define VO_PORT_L_CC3_m12_shift                                                      (16)
+#define VO_PORT_L_CC3_m12_mask                                                       (0x3FFF0000)
+#define VO_PORT_L_CC3_m12(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_L_CC3_m12_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC3_get_m12(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC3_m11_shift                                                      (0)
+#define VO_PORT_L_CC3_m11_mask                                                       (0x00003FFF)
+#define VO_PORT_L_CC3_m11(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_L_CC3_m11_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_L_CC3_get_m11(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC4                                                                0x98005E08
+#define VO_PORT_L_CC4_reg_addr                                                       "0xD8005E08"
+#define VO_PORT_L_CC4_reg                                                            0xD8005E08
+#define set_VO_PORT_L_CC4_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC4_reg)=data)
+#define get_VO_PORT_L_CC4_reg   (*((volatile unsigned int*) VO_PORT_L_CC4_reg))
+#define VO_PORT_L_CC4_inst_adr                                                       "0x0082"
+#define VO_PORT_L_CC4_inst                                                           0x0082
+#define VO_PORT_L_CC4_m21_shift                                                      (16)
+#define VO_PORT_L_CC4_m21_mask                                                       (0x3FFF0000)
+#define VO_PORT_L_CC4_m21(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_L_CC4_m21_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC4_get_m21(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC4_m20_shift                                                      (0)
+#define VO_PORT_L_CC4_m20_mask                                                       (0x00003FFF)
+#define VO_PORT_L_CC4_m20(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_L_CC4_m20_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_L_CC4_get_m20(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC5                                                                0x98005E0C
+#define VO_PORT_L_CC5_reg_addr                                                       "0xD8005E0C"
+#define VO_PORT_L_CC5_reg                                                            0xD8005E0C
+#define set_VO_PORT_L_CC5_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC5_reg)=data)
+#define get_VO_PORT_L_CC5_reg   (*((volatile unsigned int*) VO_PORT_L_CC5_reg))
+#define VO_PORT_L_CC5_inst_adr                                                       "0x0083"
+#define VO_PORT_L_CC5_inst                                                           0x0083
+#define VO_PORT_L_CC5_m22_shift                                                      (0)
+#define VO_PORT_L_CC5_m22_mask                                                       (0x00003FFF)
+#define VO_PORT_L_CC5_m22(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_L_CC5_m22_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_L_CC5_get_m22(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC6                                                                0x98005E10
+#define VO_PORT_L_CC6_reg_addr                                                       "0xD8005E10"
+#define VO_PORT_L_CC6_reg                                                            0xD8005E10
+#define set_VO_PORT_L_CC6_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC6_reg)=data)
+#define get_VO_PORT_L_CC6_reg   (*((volatile unsigned int*) VO_PORT_L_CC6_reg))
+#define VO_PORT_L_CC6_inst_adr                                                       "0x0084"
+#define VO_PORT_L_CC6_inst                                                           0x0084
+#define VO_PORT_L_CC6_a1_shift                                                       (12)
+#define VO_PORT_L_CC6_a1_mask                                                        (0x00FFF000)
+#define VO_PORT_L_CC6_a1(data)                                                       (0x00FFF000&((data)<<12))
+#define VO_PORT_L_CC6_a1_src(data)                                                   ((0x00FFF000&(data))>>12)
+#define VO_PORT_L_CC6_get_a1(data)                                                   ((0x00FFF000&(data))>>12)
+#define VO_PORT_L_CC6_a0_shift                                                       (0)
+#define VO_PORT_L_CC6_a0_mask                                                        (0x00000FFF)
+#define VO_PORT_L_CC6_a0(data)                                                       (0x00000FFF&((data)<<0))
+#define VO_PORT_L_CC6_a0_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VO_PORT_L_CC6_get_a0(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC7                                                                0x98005E14
+#define VO_PORT_L_CC7_reg_addr                                                       "0xD8005E14"
+#define VO_PORT_L_CC7_reg                                                            0xD8005E14
+#define set_VO_PORT_L_CC7_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC7_reg)=data)
+#define get_VO_PORT_L_CC7_reg   (*((volatile unsigned int*) VO_PORT_L_CC7_reg))
+#define VO_PORT_L_CC7_inst_adr                                                       "0x0085"
+#define VO_PORT_L_CC7_inst                                                           0x0085
+#define VO_PORT_L_CC7_a2_shift                                                       (0)
+#define VO_PORT_L_CC7_a2_mask                                                        (0x00000FFF)
+#define VO_PORT_L_CC7_a2(data)                                                       (0x00000FFF&((data)<<0))
+#define VO_PORT_L_CC7_a2_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VO_PORT_L_CC7_get_a2(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VO_PORT_L_LMT_R                                                              0x98005E18
+#define VO_PORT_L_LMT_R_reg_addr                                                     "0xD8005E18"
+#define VO_PORT_L_LMT_R_reg                                                          0xD8005E18
+#define set_VO_PORT_L_LMT_R_reg(data)   (*((volatile unsigned int*) VO_PORT_L_LMT_R_reg)=data)
+#define get_VO_PORT_L_LMT_R_reg   (*((volatile unsigned int*) VO_PORT_L_LMT_R_reg))
+#define VO_PORT_L_LMT_R_inst_adr                                                     "0x0086"
+#define VO_PORT_L_LMT_R_inst                                                         0x0086
+#define VO_PORT_L_LMT_R_rmax_shift                                                   (10)
+#define VO_PORT_L_LMT_R_rmax_mask                                                    (0x000FFC00)
+#define VO_PORT_L_LMT_R_rmax(data)                                                   (0x000FFC00&((data)<<10))
+#define VO_PORT_L_LMT_R_rmax_src(data)                                               ((0x000FFC00&(data))>>10)
+#define VO_PORT_L_LMT_R_get_rmax(data)                                               ((0x000FFC00&(data))>>10)
+#define VO_PORT_L_LMT_R_rmin_shift                                                   (0)
+#define VO_PORT_L_LMT_R_rmin_mask                                                    (0x000003FF)
+#define VO_PORT_L_LMT_R_rmin(data)                                                   (0x000003FF&((data)<<0))
+#define VO_PORT_L_LMT_R_rmin_src(data)                                               ((0x000003FF&(data))>>0)
+#define VO_PORT_L_LMT_R_get_rmin(data)                                               ((0x000003FF&(data))>>0)
+
+
+#define VO_PORT_L_LMT_G                                                              0x98005E1C
+#define VO_PORT_L_LMT_G_reg_addr                                                     "0xD8005E1C"
+#define VO_PORT_L_LMT_G_reg                                                          0xD8005E1C
+#define set_VO_PORT_L_LMT_G_reg(data)   (*((volatile unsigned int*) VO_PORT_L_LMT_G_reg)=data)
+#define get_VO_PORT_L_LMT_G_reg   (*((volatile unsigned int*) VO_PORT_L_LMT_G_reg))
+#define VO_PORT_L_LMT_G_inst_adr                                                     "0x0087"
+#define VO_PORT_L_LMT_G_inst                                                         0x0087
+#define VO_PORT_L_LMT_G_gmax_shift                                                   (10)
+#define VO_PORT_L_LMT_G_gmax_mask                                                    (0x000FFC00)
+#define VO_PORT_L_LMT_G_gmax(data)                                                   (0x000FFC00&((data)<<10))
+#define VO_PORT_L_LMT_G_gmax_src(data)                                               ((0x000FFC00&(data))>>10)
+#define VO_PORT_L_LMT_G_get_gmax(data)                                               ((0x000FFC00&(data))>>10)
+#define VO_PORT_L_LMT_G_gmin_shift                                                   (0)
+#define VO_PORT_L_LMT_G_gmin_mask                                                    (0x000003FF)
+#define VO_PORT_L_LMT_G_gmin(data)                                                   (0x000003FF&((data)<<0))
+#define VO_PORT_L_LMT_G_gmin_src(data)                                               ((0x000003FF&(data))>>0)
+#define VO_PORT_L_LMT_G_get_gmin(data)                                               ((0x000003FF&(data))>>0)
+
+
+#define VO_PORT_L_LMT_B                                                              0x98005E20
+#define VO_PORT_L_LMT_B_reg_addr                                                     "0xD8005E20"
+#define VO_PORT_L_LMT_B_reg                                                          0xD8005E20
+#define set_VO_PORT_L_LMT_B_reg(data)   (*((volatile unsigned int*) VO_PORT_L_LMT_B_reg)=data)
+#define get_VO_PORT_L_LMT_B_reg   (*((volatile unsigned int*) VO_PORT_L_LMT_B_reg))
+#define VO_PORT_L_LMT_B_inst_adr                                                     "0x0088"
+#define VO_PORT_L_LMT_B_inst                                                         0x0088
+#define VO_PORT_L_LMT_B_bmax_shift                                                   (10)
+#define VO_PORT_L_LMT_B_bmax_mask                                                    (0x000FFC00)
+#define VO_PORT_L_LMT_B_bmax(data)                                                   (0x000FFC00&((data)<<10))
+#define VO_PORT_L_LMT_B_bmax_src(data)                                               ((0x000FFC00&(data))>>10)
+#define VO_PORT_L_LMT_B_get_bmax(data)                                               ((0x000FFC00&(data))>>10)
+#define VO_PORT_L_LMT_B_bmin_shift                                                   (0)
+#define VO_PORT_L_LMT_B_bmin_mask                                                    (0x000003FF)
+#define VO_PORT_L_LMT_B_bmin(data)                                                   (0x000003FF&((data)<<0))
+#define VO_PORT_L_LMT_B_bmin_src(data)                                               ((0x000003FF&(data))>>0)
+#define VO_PORT_L_LMT_B_get_bmin(data)                                               ((0x000003FF&(data))>>0)
+
+
+#define VO_PORT_L_MODE                                                               0x98005E24
+#define VO_PORT_L_MODE_reg_addr                                                      "0xD8005E24"
+#define VO_PORT_L_MODE_reg                                                           0xD8005E24
+#define set_VO_PORT_L_MODE_reg(data)   (*((volatile unsigned int*) VO_PORT_L_MODE_reg)=data)
+#define get_VO_PORT_L_MODE_reg   (*((volatile unsigned int*) VO_PORT_L_MODE_reg))
+#define VO_PORT_L_MODE_inst_adr                                                      "0x0089"
+#define VO_PORT_L_MODE_inst                                                          0x0089
+#define VO_PORT_L_MODE_pport_shift                                                   (0)
+#define VO_PORT_L_MODE_pport_mask                                                    (0x00000001)
+#define VO_PORT_L_MODE_pport(data)                                                   (0x00000001&((data)<<0))
+#define VO_PORT_L_MODE_pport_src(data)                                               ((0x00000001&(data))>>0)
+#define VO_PORT_L_MODE_get_pport(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VO_PORT_I_CC1                                                                0x98005E28
+#define VO_PORT_I_CC1_reg_addr                                                       "0xD8005E28"
+#define VO_PORT_I_CC1_reg                                                            0xD8005E28
+#define set_VO_PORT_I_CC1_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC1_reg)=data)
+#define get_VO_PORT_I_CC1_reg   (*((volatile unsigned int*) VO_PORT_I_CC1_reg))
+#define VO_PORT_I_CC1_inst_adr                                                       "0x008A"
+#define VO_PORT_I_CC1_inst                                                           0x008A
+#define VO_PORT_I_CC1_m01_shift                                                      (16)
+#define VO_PORT_I_CC1_m01_mask                                                       (0x3FFF0000)
+#define VO_PORT_I_CC1_m01(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_I_CC1_m01_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC1_get_m01(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC1_m00_shift                                                      (0)
+#define VO_PORT_I_CC1_m00_mask                                                       (0x00003FFF)
+#define VO_PORT_I_CC1_m00(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_I_CC1_m00_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_I_CC1_get_m00(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_I_CC2                                                                0x98005E2C
+#define VO_PORT_I_CC2_reg_addr                                                       "0xD8005E2C"
+#define VO_PORT_I_CC2_reg                                                            0xD8005E2C
+#define set_VO_PORT_I_CC2_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC2_reg)=data)
+#define get_VO_PORT_I_CC2_reg   (*((volatile unsigned int*) VO_PORT_I_CC2_reg))
+#define VO_PORT_I_CC2_inst_adr                                                       "0x008B"
+#define VO_PORT_I_CC2_inst                                                           0x008B
+#define VO_PORT_I_CC2_m10_shift                                                      (16)
+#define VO_PORT_I_CC2_m10_mask                                                       (0x3FFF0000)
+#define VO_PORT_I_CC2_m10(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_I_CC2_m10_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC2_get_m10(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC2_m02_shift                                                      (0)
+#define VO_PORT_I_CC2_m02_mask                                                       (0x00003FFF)
+#define VO_PORT_I_CC2_m02(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_I_CC2_m02_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_I_CC2_get_m02(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_I_CC3                                                                0x98005E30
+#define VO_PORT_I_CC3_reg_addr                                                       "0xD8005E30"
+#define VO_PORT_I_CC3_reg                                                            0xD8005E30
+#define set_VO_PORT_I_CC3_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC3_reg)=data)
+#define get_VO_PORT_I_CC3_reg   (*((volatile unsigned int*) VO_PORT_I_CC3_reg))
+#define VO_PORT_I_CC3_inst_adr                                                       "0x008C"
+#define VO_PORT_I_CC3_inst                                                           0x008C
+#define VO_PORT_I_CC3_m12_shift                                                      (16)
+#define VO_PORT_I_CC3_m12_mask                                                       (0x3FFF0000)
+#define VO_PORT_I_CC3_m12(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_I_CC3_m12_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC3_get_m12(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC3_m11_shift                                                      (0)
+#define VO_PORT_I_CC3_m11_mask                                                       (0x00003FFF)
+#define VO_PORT_I_CC3_m11(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_I_CC3_m11_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_I_CC3_get_m11(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_I_CC4                                                                0x98005E34
+#define VO_PORT_I_CC4_reg_addr                                                       "0xD8005E34"
+#define VO_PORT_I_CC4_reg                                                            0xD8005E34
+#define set_VO_PORT_I_CC4_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC4_reg)=data)
+#define get_VO_PORT_I_CC4_reg   (*((volatile unsigned int*) VO_PORT_I_CC4_reg))
+#define VO_PORT_I_CC4_inst_adr                                                       "0x008D"
+#define VO_PORT_I_CC4_inst                                                           0x008D
+#define VO_PORT_I_CC4_m21_shift                                                      (16)
+#define VO_PORT_I_CC4_m21_mask                                                       (0x3FFF0000)
+#define VO_PORT_I_CC4_m21(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_I_CC4_m21_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC4_get_m21(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC4_m20_shift                                                      (0)
+#define VO_PORT_I_CC4_m20_mask                                                       (0x00003FFF)
+#define VO_PORT_I_CC4_m20(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_I_CC4_m20_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_I_CC4_get_m20(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_I_CC5                                                                0x98005E38
+#define VO_PORT_I_CC5_reg_addr                                                       "0xD8005E38"
+#define VO_PORT_I_CC5_reg                                                            0xD8005E38
+#define set_VO_PORT_I_CC5_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC5_reg)=data)
+#define get_VO_PORT_I_CC5_reg   (*((volatile unsigned int*) VO_PORT_I_CC5_reg))
+#define VO_PORT_I_CC5_inst_adr                                                       "0x008E"
+#define VO_PORT_I_CC5_inst                                                           0x008E
+#define VO_PORT_I_CC5_m22_shift                                                      (0)
+#define VO_PORT_I_CC5_m22_mask                                                       (0x00003FFF)
+#define VO_PORT_I_CC5_m22(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_I_CC5_m22_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_I_CC5_get_m22(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_I_CC6                                                                0x98005E3C
+#define VO_PORT_I_CC6_reg_addr                                                       "0xD8005E3C"
+#define VO_PORT_I_CC6_reg                                                            0xD8005E3C
+#define set_VO_PORT_I_CC6_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC6_reg)=data)
+#define get_VO_PORT_I_CC6_reg   (*((volatile unsigned int*) VO_PORT_I_CC6_reg))
+#define VO_PORT_I_CC6_inst_adr                                                       "0x008F"
+#define VO_PORT_I_CC6_inst                                                           0x008F
+#define VO_PORT_I_CC6_a2_shift                                                       (18)
+#define VO_PORT_I_CC6_a2_mask                                                        (0x07FC0000)
+#define VO_PORT_I_CC6_a2(data)                                                       (0x07FC0000&((data)<<18))
+#define VO_PORT_I_CC6_a2_src(data)                                                   ((0x07FC0000&(data))>>18)
+#define VO_PORT_I_CC6_get_a2(data)                                                   ((0x07FC0000&(data))>>18)
+#define VO_PORT_I_CC6_a1_shift                                                       (9)
+#define VO_PORT_I_CC6_a1_mask                                                        (0x0003FE00)
+#define VO_PORT_I_CC6_a1(data)                                                       (0x0003FE00&((data)<<9))
+#define VO_PORT_I_CC6_a1_src(data)                                                   ((0x0003FE00&(data))>>9)
+#define VO_PORT_I_CC6_get_a1(data)                                                   ((0x0003FE00&(data))>>9)
+#define VO_PORT_I_CC6_a0_shift                                                       (0)
+#define VO_PORT_I_CC6_a0_mask                                                        (0x000001FF)
+#define VO_PORT_I_CC6_a0(data)                                                       (0x000001FF&((data)<<0))
+#define VO_PORT_I_CC6_a0_src(data)                                                   ((0x000001FF&(data))>>0)
+#define VO_PORT_I_CC6_get_a0(data)                                                   ((0x000001FF&(data))>>0)
+
+
+#define VO_PORT_I_LMT                                                                0x98005E40
+#define VO_PORT_I_LMT_reg_addr                                                       "0xD8005E40"
+#define VO_PORT_I_LMT_reg                                                            0xD8005E40
+#define set_VO_PORT_I_LMT_reg(data)   (*((volatile unsigned int*) VO_PORT_I_LMT_reg)=data)
+#define get_VO_PORT_I_LMT_reg   (*((volatile unsigned int*) VO_PORT_I_LMT_reg))
+#define VO_PORT_I_LMT_inst_adr                                                       "0x0090"
+#define VO_PORT_I_LMT_inst                                                           0x0090
+#define VO_PORT_I_LMT_cmax_shift                                                     (24)
+#define VO_PORT_I_LMT_cmax_mask                                                      (0xFF000000)
+#define VO_PORT_I_LMT_cmax(data)                                                     (0xFF000000&((data)<<24))
+#define VO_PORT_I_LMT_cmax_src(data)                                                 ((0xFF000000&(data))>>24)
+#define VO_PORT_I_LMT_get_cmax(data)                                                 ((0xFF000000&(data))>>24)
+#define VO_PORT_I_LMT_cmin_shift                                                     (16)
+#define VO_PORT_I_LMT_cmin_mask                                                      (0x00FF0000)
+#define VO_PORT_I_LMT_cmin(data)                                                     (0x00FF0000&((data)<<16))
+#define VO_PORT_I_LMT_cmin_src(data)                                                 ((0x00FF0000&(data))>>16)
+#define VO_PORT_I_LMT_get_cmin(data)                                                 ((0x00FF0000&(data))>>16)
+#define VO_PORT_I_LMT_ymax_shift                                                     (8)
+#define VO_PORT_I_LMT_ymax_mask                                                      (0x0000FF00)
+#define VO_PORT_I_LMT_ymax(data)                                                     (0x0000FF00&((data)<<8))
+#define VO_PORT_I_LMT_ymax_src(data)                                                 ((0x0000FF00&(data))>>8)
+#define VO_PORT_I_LMT_get_ymax(data)                                                 ((0x0000FF00&(data))>>8)
+#define VO_PORT_I_LMT_ymin_shift                                                     (0)
+#define VO_PORT_I_LMT_ymin_mask                                                      (0x000000FF)
+#define VO_PORT_I_LMT_ymin(data)                                                     (0x000000FF&((data)<<0))
+#define VO_PORT_I_LMT_ymin_src(data)                                                 ((0x000000FF&(data))>>0)
+#define VO_PORT_I_LMT_get_ymin(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define VO_PORT_H_CC1                                                                0x98005E44
+#define VO_PORT_H_CC1_reg_addr                                                       "0xD8005E44"
+#define VO_PORT_H_CC1_reg                                                            0xD8005E44
+#define set_VO_PORT_H_CC1_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC1_reg)=data)
+#define get_VO_PORT_H_CC1_reg   (*((volatile unsigned int*) VO_PORT_H_CC1_reg))
+#define VO_PORT_H_CC1_inst_adr                                                       "0x0091"
+#define VO_PORT_H_CC1_inst                                                           0x0091
+#define VO_PORT_H_CC1_m00_shift                                                      (0)
+#define VO_PORT_H_CC1_m00_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC1_m00(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC1_m00_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC1_get_m00(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC2                                                                0x98005E48
+#define VO_PORT_H_CC2_reg_addr                                                       "0xD8005E48"
+#define VO_PORT_H_CC2_reg                                                            0xD8005E48
+#define set_VO_PORT_H_CC2_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC2_reg)=data)
+#define get_VO_PORT_H_CC2_reg   (*((volatile unsigned int*) VO_PORT_H_CC2_reg))
+#define VO_PORT_H_CC2_inst_adr                                                       "0x0092"
+#define VO_PORT_H_CC2_inst                                                           0x0092
+#define VO_PORT_H_CC2_m01_shift                                                      (0)
+#define VO_PORT_H_CC2_m01_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC2_m01(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC2_m01_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC2_get_m01(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC3                                                                0x98005E4C
+#define VO_PORT_H_CC3_reg_addr                                                       "0xD8005E4C"
+#define VO_PORT_H_CC3_reg                                                            0xD8005E4C
+#define set_VO_PORT_H_CC3_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC3_reg)=data)
+#define get_VO_PORT_H_CC3_reg   (*((volatile unsigned int*) VO_PORT_H_CC3_reg))
+#define VO_PORT_H_CC3_inst_adr                                                       "0x0093"
+#define VO_PORT_H_CC3_inst                                                           0x0093
+#define VO_PORT_H_CC3_m02_shift                                                      (0)
+#define VO_PORT_H_CC3_m02_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC3_m02(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC3_m02_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC3_get_m02(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC4                                                                0x98005E50
+#define VO_PORT_H_CC4_reg_addr                                                       "0xD8005E50"
+#define VO_PORT_H_CC4_reg                                                            0xD8005E50
+#define set_VO_PORT_H_CC4_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC4_reg)=data)
+#define get_VO_PORT_H_CC4_reg   (*((volatile unsigned int*) VO_PORT_H_CC4_reg))
+#define VO_PORT_H_CC4_inst_adr                                                       "0x0094"
+#define VO_PORT_H_CC4_inst                                                           0x0094
+#define VO_PORT_H_CC4_m10_shift                                                      (0)
+#define VO_PORT_H_CC4_m10_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC4_m10(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC4_m10_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC4_get_m10(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC5                                                                0x98005E54
+#define VO_PORT_H_CC5_reg_addr                                                       "0xD8005E54"
+#define VO_PORT_H_CC5_reg                                                            0xD8005E54
+#define set_VO_PORT_H_CC5_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC5_reg)=data)
+#define get_VO_PORT_H_CC5_reg   (*((volatile unsigned int*) VO_PORT_H_CC5_reg))
+#define VO_PORT_H_CC5_inst_adr                                                       "0x0095"
+#define VO_PORT_H_CC5_inst                                                           0x0095
+#define VO_PORT_H_CC5_m11_shift                                                      (0)
+#define VO_PORT_H_CC5_m11_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC5_m11(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC5_m11_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC5_get_m11(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC6                                                                0x98005E58
+#define VO_PORT_H_CC6_reg_addr                                                       "0xD8005E58"
+#define VO_PORT_H_CC6_reg                                                            0xD8005E58
+#define set_VO_PORT_H_CC6_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC6_reg)=data)
+#define get_VO_PORT_H_CC6_reg   (*((volatile unsigned int*) VO_PORT_H_CC6_reg))
+#define VO_PORT_H_CC6_inst_adr                                                       "0x0096"
+#define VO_PORT_H_CC6_inst                                                           0x0096
+#define VO_PORT_H_CC6_m12_shift                                                      (0)
+#define VO_PORT_H_CC6_m12_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC6_m12(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC6_m12_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC6_get_m12(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC7                                                                0x98005E5C
+#define VO_PORT_H_CC7_reg_addr                                                       "0xD8005E5C"
+#define VO_PORT_H_CC7_reg                                                            0xD8005E5C
+#define set_VO_PORT_H_CC7_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC7_reg)=data)
+#define get_VO_PORT_H_CC7_reg   (*((volatile unsigned int*) VO_PORT_H_CC7_reg))
+#define VO_PORT_H_CC7_inst_adr                                                       "0x0097"
+#define VO_PORT_H_CC7_inst                                                           0x0097
+#define VO_PORT_H_CC7_m20_shift                                                      (0)
+#define VO_PORT_H_CC7_m20_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC7_m20(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC7_m20_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC7_get_m20(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC8                                                                0x98005E60
+#define VO_PORT_H_CC8_reg_addr                                                       "0xD8005E60"
+#define VO_PORT_H_CC8_reg                                                            0xD8005E60
+#define set_VO_PORT_H_CC8_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC8_reg)=data)
+#define get_VO_PORT_H_CC8_reg   (*((volatile unsigned int*) VO_PORT_H_CC8_reg))
+#define VO_PORT_H_CC8_inst_adr                                                       "0x0098"
+#define VO_PORT_H_CC8_inst                                                           0x0098
+#define VO_PORT_H_CC8_m21_shift                                                      (0)
+#define VO_PORT_H_CC8_m21_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC8_m21(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC8_m21_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC8_get_m21(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC9                                                                0x98005E64
+#define VO_PORT_H_CC9_reg_addr                                                       "0xD8005E64"
+#define VO_PORT_H_CC9_reg                                                            0xD8005E64
+#define set_VO_PORT_H_CC9_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC9_reg)=data)
+#define get_VO_PORT_H_CC9_reg   (*((volatile unsigned int*) VO_PORT_H_CC9_reg))
+#define VO_PORT_H_CC9_inst_adr                                                       "0x0099"
+#define VO_PORT_H_CC9_inst                                                           0x0099
+#define VO_PORT_H_CC9_m22_shift                                                      (0)
+#define VO_PORT_H_CC9_m22_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC9_m22(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC9_m22_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC9_get_m22(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC10                                                               0x98005E68
+#define VO_PORT_H_CC10_reg_addr                                                      "0xD8005E68"
+#define VO_PORT_H_CC10_reg                                                           0xD8005E68
+#define set_VO_PORT_H_CC10_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC10_reg)=data)
+#define get_VO_PORT_H_CC10_reg   (*((volatile unsigned int*) VO_PORT_H_CC10_reg))
+#define VO_PORT_H_CC10_inst_adr                                                      "0x009A"
+#define VO_PORT_H_CC10_inst                                                          0x009A
+#define VO_PORT_H_CC10_a1_shift                                                      (14)
+#define VO_PORT_H_CC10_a1_mask                                                       (0x07FFC000)
+#define VO_PORT_H_CC10_a1(data)                                                      (0x07FFC000&((data)<<14))
+#define VO_PORT_H_CC10_a1_src(data)                                                  ((0x07FFC000&(data))>>14)
+#define VO_PORT_H_CC10_get_a1(data)                                                  ((0x07FFC000&(data))>>14)
+#define VO_PORT_H_CC10_a0_shift                                                      (0)
+#define VO_PORT_H_CC10_a0_mask                                                       (0x00001FFF)
+#define VO_PORT_H_CC10_a0(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_PORT_H_CC10_a0_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_PORT_H_CC10_get_a0(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_PORT_H_CC11                                                               0x98005E6C
+#define VO_PORT_H_CC11_reg_addr                                                      "0xD8005E6C"
+#define VO_PORT_H_CC11_reg                                                           0xD8005E6C
+#define set_VO_PORT_H_CC11_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC11_reg)=data)
+#define get_VO_PORT_H_CC11_reg   (*((volatile unsigned int*) VO_PORT_H_CC11_reg))
+#define VO_PORT_H_CC11_inst_adr                                                      "0x009B"
+#define VO_PORT_H_CC11_inst                                                          0x009B
+#define VO_PORT_H_CC11_a2_shift                                                      (0)
+#define VO_PORT_H_CC11_a2_mask                                                       (0x00001FFF)
+#define VO_PORT_H_CC11_a2(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_PORT_H_CC11_a2_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_PORT_H_CC11_get_a2(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_PORT_H_LMT_Y                                                              0x98005E70
+#define VO_PORT_H_LMT_Y_reg_addr                                                     "0xD8005E70"
+#define VO_PORT_H_LMT_Y_reg                                                          0xD8005E70
+#define set_VO_PORT_H_LMT_Y_reg(data)   (*((volatile unsigned int*) VO_PORT_H_LMT_Y_reg)=data)
+#define get_VO_PORT_H_LMT_Y_reg   (*((volatile unsigned int*) VO_PORT_H_LMT_Y_reg))
+#define VO_PORT_H_LMT_Y_inst_adr                                                     "0x009C"
+#define VO_PORT_H_LMT_Y_inst                                                         0x009C
+#define VO_PORT_H_LMT_Y_ymax_shift                                                   (16)
+#define VO_PORT_H_LMT_Y_ymax_mask                                                    (0x0FFF0000)
+#define VO_PORT_H_LMT_Y_ymax(data)                                                   (0x0FFF0000&((data)<<16))
+#define VO_PORT_H_LMT_Y_ymax_src(data)                                               ((0x0FFF0000&(data))>>16)
+#define VO_PORT_H_LMT_Y_get_ymax(data)                                               ((0x0FFF0000&(data))>>16)
+#define VO_PORT_H_LMT_Y_ymin_shift                                                   (0)
+#define VO_PORT_H_LMT_Y_ymin_mask                                                    (0x00000FFF)
+#define VO_PORT_H_LMT_Y_ymin(data)                                                   (0x00000FFF&((data)<<0))
+#define VO_PORT_H_LMT_Y_ymin_src(data)                                               ((0x00000FFF&(data))>>0)
+#define VO_PORT_H_LMT_Y_get_ymin(data)                                               ((0x00000FFF&(data))>>0)
+
+
+#define VO_PORT_H_LMT_C                                                              0x98005E74
+#define VO_PORT_H_LMT_C_reg_addr                                                     "0xD8005E74"
+#define VO_PORT_H_LMT_C_reg                                                          0xD8005E74
+#define set_VO_PORT_H_LMT_C_reg(data)   (*((volatile unsigned int*) VO_PORT_H_LMT_C_reg)=data)
+#define get_VO_PORT_H_LMT_C_reg   (*((volatile unsigned int*) VO_PORT_H_LMT_C_reg))
+#define VO_PORT_H_LMT_C_inst_adr                                                     "0x009D"
+#define VO_PORT_H_LMT_C_inst                                                         0x009D
+#define VO_PORT_H_LMT_C_cmax_shift                                                   (16)
+#define VO_PORT_H_LMT_C_cmax_mask                                                    (0x0FFF0000)
+#define VO_PORT_H_LMT_C_cmax(data)                                                   (0x0FFF0000&((data)<<16))
+#define VO_PORT_H_LMT_C_cmax_src(data)                                               ((0x0FFF0000&(data))>>16)
+#define VO_PORT_H_LMT_C_get_cmax(data)                                               ((0x0FFF0000&(data))>>16)
+#define VO_PORT_H_LMT_C_cmin_shift                                                   (0)
+#define VO_PORT_H_LMT_C_cmin_mask                                                    (0x00000FFF)
+#define VO_PORT_H_LMT_C_cmin(data)                                                   (0x00000FFF&((data)<<0))
+#define VO_PORT_H_LMT_C_cmin_src(data)                                               ((0x00000FFF&(data))>>0)
+#define VO_PORT_H_LMT_C_get_cmin(data)                                               ((0x00000FFF&(data))>>0)
+
+
+#define VO_SYNC                                                                      0x98005E78
+#define VO_SYNC_reg_addr                                                             "0xD8005E78"
+#define VO_SYNC_reg                                                                  0xD8005E78
+#define set_VO_SYNC_reg(data)   (*((volatile unsigned int*) VO_SYNC_reg)=data)
+#define get_VO_SYNC_reg   (*((volatile unsigned int*) VO_SYNC_reg))
+#define VO_SYNC_inst_adr                                                             "0x009E"
+#define VO_SYNC_inst                                                                 0x009E
+#define VO_SYNC_lvds_shift                                                           (1)
+#define VO_SYNC_lvds_mask                                                            (0x00000002)
+#define VO_SYNC_lvds(data)                                                           (0x00000002&((data)<<1))
+#define VO_SYNC_lvds_src(data)                                                       ((0x00000002&(data))>>1)
+#define VO_SYNC_get_lvds(data)                                                       ((0x00000002&(data))>>1)
+#define VO_SYNC_write_data_shift                                                     (0)
+#define VO_SYNC_write_data_mask                                                      (0x00000001)
+#define VO_SYNC_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_SYNC_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_SYNC_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_SYNC_DELAY                                                                0x98005E7C
+#define VO_SYNC_DELAY_reg_addr                                                       "0xD8005E7C"
+#define VO_SYNC_DELAY_reg                                                            0xD8005E7C
+#define set_VO_SYNC_DELAY_reg(data)   (*((volatile unsigned int*) VO_SYNC_DELAY_reg)=data)
+#define get_VO_SYNC_DELAY_reg   (*((volatile unsigned int*) VO_SYNC_DELAY_reg))
+#define VO_SYNC_DELAY_inst_adr                                                       "0x009F"
+#define VO_SYNC_DELAY_inst                                                           0x009F
+#define VO_SYNC_DELAY_lvds_shift                                                     (0)
+#define VO_SYNC_DELAY_lvds_mask                                                      (0x000000FF)
+#define VO_SYNC_DELAY_lvds(data)                                                     (0x000000FF&((data)<<0))
+#define VO_SYNC_DELAY_lvds_src(data)                                                 ((0x000000FF&(data))>>0)
+#define VO_SYNC_DELAY_get_lvds(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define VO_INTEN                                                                     0x98005E80
+#define VO_INTEN_reg_addr                                                            "0xD8005E80"
+#define VO_INTEN_reg                                                                 0xD8005E80
+#define set_VO_INTEN_reg(data)   (*((volatile unsigned int*) VO_INTEN_reg)=data)
+#define get_VO_INTEN_reg   (*((volatile unsigned int*) VO_INTEN_reg))
+#define VO_INTEN_inst_adr                                                            "0x00A0"
+#define VO_INTEN_inst                                                                0x00A0
+#define VO_INTEN_afbc_shift                                                          (11)
+#define VO_INTEN_afbc_mask                                                           (0x00000800)
+#define VO_INTEN_afbc(data)                                                          (0x00000800&((data)<<11))
+#define VO_INTEN_afbc_src(data)                                                      ((0x00000800&(data))>>11)
+#define VO_INTEN_get_afbc(data)                                                      ((0x00000800&(data))>>11)
+#define VO_INTEN_h_under_shift                                                       (10)
+#define VO_INTEN_h_under_mask                                                        (0x00000400)
+#define VO_INTEN_h_under(data)                                                       (0x00000400&((data)<<10))
+#define VO_INTEN_h_under_src(data)                                                   ((0x00000400&(data))>>10)
+#define VO_INTEN_get_h_under(data)                                                   ((0x00000400&(data))>>10)
+#define VO_INTEN_i_under_shift                                                       (9)
+#define VO_INTEN_i_under_mask                                                        (0x00000200)
+#define VO_INTEN_i_under(data)                                                       (0x00000200&((data)<<9))
+#define VO_INTEN_i_under_src(data)                                                   ((0x00000200&(data))>>9)
+#define VO_INTEN_get_i_under(data)                                                   ((0x00000200&(data))>>9)
+#define VO_INTEN_p_under_shift                                                       (8)
+#define VO_INTEN_p_under_mask                                                        (0x00000100)
+#define VO_INTEN_p_under(data)                                                       (0x00000100&((data)<<8))
+#define VO_INTEN_p_under_src(data)                                                   ((0x00000100&(data))>>8)
+#define VO_INTEN_get_p_under(data)                                                   ((0x00000100&(data))>>8)
+#define VO_INTEN_sub2_shift                                                          (7)
+#define VO_INTEN_sub2_mask                                                           (0x00000080)
+#define VO_INTEN_sub2(data)                                                          (0x00000080&((data)<<7))
+#define VO_INTEN_sub2_src(data)                                                      ((0x00000080&(data))>>7)
+#define VO_INTEN_get_sub2(data)                                                      ((0x00000080&(data))>>7)
+#define VO_INTEN_sub1_shift                                                          (6)
+#define VO_INTEN_sub1_mask                                                           (0x00000040)
+#define VO_INTEN_sub1(data)                                                          (0x00000040&((data)<<6))
+#define VO_INTEN_sub1_src(data)                                                      ((0x00000040&(data))>>6)
+#define VO_INTEN_get_sub1(data)                                                      ((0x00000040&(data))>>6)
+#define VO_INTEN_wb2fin_shift                                                        (5)
+#define VO_INTEN_wb2fin_mask                                                         (0x00000020)
+#define VO_INTEN_wb2fin(data)                                                        (0x00000020&((data)<<5))
+#define VO_INTEN_wb2fin_src(data)                                                    ((0x00000020&(data))>>5)
+#define VO_INTEN_get_wb2fin(data)                                                    ((0x00000020&(data))>>5)
+#define VO_INTEN_wb1fin_shift                                                        (4)
+#define VO_INTEN_wb1fin_mask                                                         (0x00000010)
+#define VO_INTEN_wb1fin(data)                                                        (0x00000010&((data)<<4))
+#define VO_INTEN_wb1fin_src(data)                                                    ((0x00000010&(data))>>4)
+#define VO_INTEN_get_wb1fin(data)                                                    ((0x00000010&(data))>>4)
+#define VO_INTEN_m3fin_shift                                                         (3)
+#define VO_INTEN_m3fin_mask                                                          (0x00000008)
+#define VO_INTEN_m3fin(data)                                                         (0x00000008&((data)<<3))
+#define VO_INTEN_m3fin_src(data)                                                     ((0x00000008&(data))>>3)
+#define VO_INTEN_get_m3fin(data)                                                     ((0x00000008&(data))>>3)
+#define VO_INTEN_m2fin_shift                                                         (2)
+#define VO_INTEN_m2fin_mask                                                          (0x00000004)
+#define VO_INTEN_m2fin(data)                                                         (0x00000004&((data)<<2))
+#define VO_INTEN_m2fin_src(data)                                                     ((0x00000004&(data))>>2)
+#define VO_INTEN_get_m2fin(data)                                                     ((0x00000004&(data))>>2)
+#define VO_INTEN_m1fin_shift                                                         (1)
+#define VO_INTEN_m1fin_mask                                                          (0x00000002)
+#define VO_INTEN_m1fin(data)                                                         (0x00000002&((data)<<1))
+#define VO_INTEN_m1fin_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_INTEN_get_m1fin(data)                                                     ((0x00000002&(data))>>1)
+#define VO_INTEN_write_data_shift                                                    (0)
+#define VO_INTEN_write_data_mask                                                     (0x00000001)
+#define VO_INTEN_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VO_INTEN_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_INTEN_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_INTST                                                                     0x98005E84
+#define VO_INTST_reg_addr                                                            "0xD8005E84"
+#define VO_INTST_reg                                                                 0xD8005E84
+#define set_VO_INTST_reg(data)   (*((volatile unsigned int*) VO_INTST_reg)=data)
+#define get_VO_INTST_reg   (*((volatile unsigned int*) VO_INTST_reg))
+#define VO_INTST_inst_adr                                                            "0x00A1"
+#define VO_INTST_inst                                                                0x00A1
+#define VO_INTST_afbc_parser_fail_shift                                              (12)
+#define VO_INTST_afbc_parser_fail_mask                                               (0x00001000)
+#define VO_INTST_afbc_parser_fail(data)                                              (0x00001000&((data)<<12))
+#define VO_INTST_afbc_parser_fail_src(data)                                          ((0x00001000&(data))>>12)
+#define VO_INTST_get_afbc_parser_fail(data)                                          ((0x00001000&(data))>>12)
+#define VO_INTST_afbc_decode_fail_shift                                              (11)
+#define VO_INTST_afbc_decode_fail_mask                                               (0x00000800)
+#define VO_INTST_afbc_decode_fail(data)                                              (0x00000800&((data)<<11))
+#define VO_INTST_afbc_decode_fail_src(data)                                          ((0x00000800&(data))>>11)
+#define VO_INTST_get_afbc_decode_fail(data)                                          ((0x00000800&(data))>>11)
+#define VO_INTST_h_under_shift                                                       (10)
+#define VO_INTST_h_under_mask                                                        (0x00000400)
+#define VO_INTST_h_under(data)                                                       (0x00000400&((data)<<10))
+#define VO_INTST_h_under_src(data)                                                   ((0x00000400&(data))>>10)
+#define VO_INTST_get_h_under(data)                                                   ((0x00000400&(data))>>10)
+#define VO_INTST_i_under_shift                                                       (9)
+#define VO_INTST_i_under_mask                                                        (0x00000200)
+#define VO_INTST_i_under(data)                                                       (0x00000200&((data)<<9))
+#define VO_INTST_i_under_src(data)                                                   ((0x00000200&(data))>>9)
+#define VO_INTST_get_i_under(data)                                                   ((0x00000200&(data))>>9)
+#define VO_INTST_p_under_shift                                                       (8)
+#define VO_INTST_p_under_mask                                                        (0x00000100)
+#define VO_INTST_p_under(data)                                                       (0x00000100&((data)<<8))
+#define VO_INTST_p_under_src(data)                                                   ((0x00000100&(data))>>8)
+#define VO_INTST_get_p_under(data)                                                   ((0x00000100&(data))>>8)
+#define VO_INTST_sub2_shift                                                          (7)
+#define VO_INTST_sub2_mask                                                           (0x00000080)
+#define VO_INTST_sub2(data)                                                          (0x00000080&((data)<<7))
+#define VO_INTST_sub2_src(data)                                                      ((0x00000080&(data))>>7)
+#define VO_INTST_get_sub2(data)                                                      ((0x00000080&(data))>>7)
+#define VO_INTST_sub1_shift                                                          (6)
+#define VO_INTST_sub1_mask                                                           (0x00000040)
+#define VO_INTST_sub1(data)                                                          (0x00000040&((data)<<6))
+#define VO_INTST_sub1_src(data)                                                      ((0x00000040&(data))>>6)
+#define VO_INTST_get_sub1(data)                                                      ((0x00000040&(data))>>6)
+#define VO_INTST_wb2fin_shift                                                        (5)
+#define VO_INTST_wb2fin_mask                                                         (0x00000020)
+#define VO_INTST_wb2fin(data)                                                        (0x00000020&((data)<<5))
+#define VO_INTST_wb2fin_src(data)                                                    ((0x00000020&(data))>>5)
+#define VO_INTST_get_wb2fin(data)                                                    ((0x00000020&(data))>>5)
+#define VO_INTST_wb1fin_shift                                                        (4)
+#define VO_INTST_wb1fin_mask                                                         (0x00000010)
+#define VO_INTST_wb1fin(data)                                                        (0x00000010&((data)<<4))
+#define VO_INTST_wb1fin_src(data)                                                    ((0x00000010&(data))>>4)
+#define VO_INTST_get_wb1fin(data)                                                    ((0x00000010&(data))>>4)
+#define VO_INTST_m3fin_shift                                                         (3)
+#define VO_INTST_m3fin_mask                                                          (0x00000008)
+#define VO_INTST_m3fin(data)                                                         (0x00000008&((data)<<3))
+#define VO_INTST_m3fin_src(data)                                                     ((0x00000008&(data))>>3)
+#define VO_INTST_get_m3fin(data)                                                     ((0x00000008&(data))>>3)
+#define VO_INTST_m2fin_shift                                                         (2)
+#define VO_INTST_m2fin_mask                                                          (0x00000004)
+#define VO_INTST_m2fin(data)                                                         (0x00000004&((data)<<2))
+#define VO_INTST_m2fin_src(data)                                                     ((0x00000004&(data))>>2)
+#define VO_INTST_get_m2fin(data)                                                     ((0x00000004&(data))>>2)
+#define VO_INTST_m1fin_shift                                                         (1)
+#define VO_INTST_m1fin_mask                                                          (0x00000002)
+#define VO_INTST_m1fin(data)                                                         (0x00000002&((data)<<1))
+#define VO_INTST_m1fin_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_INTST_get_m1fin(data)                                                     ((0x00000002&(data))>>1)
+#define VO_INTST_write_data_shift                                                    (0)
+#define VO_INTST_write_data_mask                                                     (0x00000001)
+#define VO_INTST_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VO_INTST_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_INTST_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_STATUS                                                                    0x98005E88
+#define VO_STATUS_reg_addr                                                           "0xD8005E88"
+#define VO_STATUS_reg                                                                0xD8005E88
+#define set_VO_STATUS_reg(data)   (*((volatile unsigned int*) VO_STATUS_reg)=data)
+#define get_VO_STATUS_reg   (*((volatile unsigned int*) VO_STATUS_reg))
+#define VO_STATUS_inst_adr                                                           "0x00A2"
+#define VO_STATUS_inst                                                               0x00A2
+#define VO_STATUS_tve_h_fetch_shift                                                  (15)
+#define VO_STATUS_tve_h_fetch_mask                                                   (0x00008000)
+#define VO_STATUS_tve_h_fetch(data)                                                  (0x00008000&((data)<<15))
+#define VO_STATUS_tve_h_fetch_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_STATUS_get_tve_h_fetch(data)                                              ((0x00008000&(data))>>15)
+#define VO_STATUS_tve_i_fetch_shift                                                  (14)
+#define VO_STATUS_tve_i_fetch_mask                                                   (0x00004000)
+#define VO_STATUS_tve_i_fetch(data)                                                  (0x00004000&((data)<<14))
+#define VO_STATUS_tve_i_fetch_src(data)                                              ((0x00004000&(data))>>14)
+#define VO_STATUS_get_tve_i_fetch(data)                                              ((0x00004000&(data))>>14)
+#define VO_STATUS_tve_p_fetch_shift                                                  (13)
+#define VO_STATUS_tve_p_fetch_mask                                                   (0x00002000)
+#define VO_STATUS_tve_p_fetch(data)                                                  (0x00002000&((data)<<13))
+#define VO_STATUS_tve_p_fetch_src(data)                                              ((0x00002000&(data))>>13)
+#define VO_STATUS_get_tve_p_fetch(data)                                              ((0x00002000&(data))>>13)
+#define VO_STATUS_dd_shift                                                           (11)
+#define VO_STATUS_dd_mask                                                            (0x00000800)
+#define VO_STATUS_dd(data)                                                           (0x00000800&((data)<<11))
+#define VO_STATUS_dd_src(data)                                                       ((0x00000800&(data))>>11)
+#define VO_STATUS_get_dd(data)                                                       ((0x00000800&(data))>>11)
+#define VO_STATUS_csr_shift                                                          (10)
+#define VO_STATUS_csr_mask                                                           (0x00000400)
+#define VO_STATUS_csr(data)                                                          (0x00000400&((data)<<10))
+#define VO_STATUS_csr_src(data)                                                      ((0x00000400&(data))>>10)
+#define VO_STATUS_get_csr(data)                                                      ((0x00000400&(data))>>10)
+#define VO_STATUS_sub2_shift                                                         (9)
+#define VO_STATUS_sub2_mask                                                          (0x00000200)
+#define VO_STATUS_sub2(data)                                                         (0x00000200&((data)<<9))
+#define VO_STATUS_sub2_src(data)                                                     ((0x00000200&(data))>>9)
+#define VO_STATUS_get_sub2(data)                                                     ((0x00000200&(data))>>9)
+#define VO_STATUS_osd1_shift                                                         (8)
+#define VO_STATUS_osd1_mask                                                          (0x00000100)
+#define VO_STATUS_osd1(data)                                                         (0x00000100&((data)<<8))
+#define VO_STATUS_osd1_src(data)                                                     ((0x00000100&(data))>>8)
+#define VO_STATUS_get_osd1(data)                                                     ((0x00000100&(data))>>8)
+#define VO_STATUS_sub1_shift                                                         (7)
+#define VO_STATUS_sub1_mask                                                          (0x00000080)
+#define VO_STATUS_sub1(data)                                                         (0x00000080&((data)<<7))
+#define VO_STATUS_sub1_src(data)                                                     ((0x00000080&(data))>>7)
+#define VO_STATUS_get_sub1(data)                                                     ((0x00000080&(data))>>7)
+#define VO_STATUS_v2_shift                                                           (6)
+#define VO_STATUS_v2_mask                                                            (0x00000040)
+#define VO_STATUS_v2(data)                                                           (0x00000040&((data)<<6))
+#define VO_STATUS_v2_src(data)                                                       ((0x00000040&(data))>>6)
+#define VO_STATUS_get_v2(data)                                                       ((0x00000040&(data))>>6)
+#define VO_STATUS_v1_shift                                                           (5)
+#define VO_STATUS_v1_mask                                                            (0x00000020)
+#define VO_STATUS_v1(data)                                                           (0x00000020&((data)<<5))
+#define VO_STATUS_v1_src(data)                                                       ((0x00000020&(data))>>5)
+#define VO_STATUS_get_v1(data)                                                       ((0x00000020&(data))>>5)
+#define VO_STATUS_wb2_shift                                                          (4)
+#define VO_STATUS_wb2_mask                                                           (0x00000010)
+#define VO_STATUS_wb2(data)                                                          (0x00000010&((data)<<4))
+#define VO_STATUS_wb2_src(data)                                                      ((0x00000010&(data))>>4)
+#define VO_STATUS_get_wb2(data)                                                      ((0x00000010&(data))>>4)
+#define VO_STATUS_wb1_shift                                                          (3)
+#define VO_STATUS_wb1_mask                                                           (0x00000008)
+#define VO_STATUS_wb1(data)                                                          (0x00000008&((data)<<3))
+#define VO_STATUS_wb1_src(data)                                                      ((0x00000008&(data))>>3)
+#define VO_STATUS_get_wb1(data)                                                      ((0x00000008&(data))>>3)
+#define VO_STATUS_mixdd_shift                                                        (2)
+#define VO_STATUS_mixdd_mask                                                         (0x00000004)
+#define VO_STATUS_mixdd(data)                                                        (0x00000004&((data)<<2))
+#define VO_STATUS_mixdd_src(data)                                                    ((0x00000004&(data))>>2)
+#define VO_STATUS_get_mixdd(data)                                                    ((0x00000004&(data))>>2)
+#define VO_STATUS_mix2_shift                                                         (1)
+#define VO_STATUS_mix2_mask                                                          (0x00000002)
+#define VO_STATUS_mix2(data)                                                         (0x00000002&((data)<<1))
+#define VO_STATUS_mix2_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_STATUS_get_mix2(data)                                                     ((0x00000002&(data))>>1)
+#define VO_STATUS_mix1_shift                                                         (0)
+#define VO_STATUS_mix1_mask                                                          (0x00000001)
+#define VO_STATUS_mix1(data)                                                         (0x00000001&((data)<<0))
+#define VO_STATUS_mix1_src(data)                                                     ((0x00000001&(data))>>0)
+#define VO_STATUS_get_mix1(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define VO_MON_EN                                                                    0x98005E8C
+#define VO_MON_EN_reg_addr                                                           "0xD8005E8C"
+#define VO_MON_EN_reg                                                                0xD8005E8C
+#define set_VO_MON_EN_reg(data)   (*((volatile unsigned int*) VO_MON_EN_reg)=data)
+#define get_VO_MON_EN_reg   (*((volatile unsigned int*) VO_MON_EN_reg))
+#define VO_MON_EN_inst_adr                                                           "0x00A3"
+#define VO_MON_EN_inst                                                               0x00A3
+#define VO_MON_EN_udf_en_shift                                                       (2)
+#define VO_MON_EN_udf_en_mask                                                        (0x00000004)
+#define VO_MON_EN_udf_en(data)                                                       (0x00000004&((data)<<2))
+#define VO_MON_EN_udf_en_src(data)                                                   ((0x00000004&(data))>>2)
+#define VO_MON_EN_get_udf_en(data)                                                   ((0x00000004&(data))>>2)
+#define VO_MON_EN_disp_en_shift                                                      (1)
+#define VO_MON_EN_disp_en_mask                                                       (0x00000002)
+#define VO_MON_EN_disp_en(data)                                                      (0x00000002&((data)<<1))
+#define VO_MON_EN_disp_en_src(data)                                                  ((0x00000002&(data))>>1)
+#define VO_MON_EN_get_disp_en(data)                                                  ((0x00000002&(data))>>1)
+#define VO_MON_EN_delay_en_shift                                                     (0)
+#define VO_MON_EN_delay_en_mask                                                      (0x00000001)
+#define VO_MON_EN_delay_en(data)                                                     (0x00000001&((data)<<0))
+#define VO_MON_EN_delay_en_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_MON_EN_get_delay_en(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_MON_SETUP                                                                 0x98005E90
+#define VO_MON_SETUP_reg_addr                                                        "0xD8005E90"
+#define VO_MON_SETUP_reg                                                             0xD8005E90
+#define set_VO_MON_SETUP_reg(data)   (*((volatile unsigned int*) VO_MON_SETUP_reg)=data)
+#define get_VO_MON_SETUP_reg   (*((volatile unsigned int*) VO_MON_SETUP_reg))
+#define VO_MON_SETUP_inst_adr                                                        "0x00A4"
+#define VO_MON_SETUP_inst                                                            0x00A4
+#define VO_MON_SETUP_wb2_shift                                                       (28)
+#define VO_MON_SETUP_wb2_mask                                                        (0x10000000)
+#define VO_MON_SETUP_wb2(data)                                                       (0x10000000&((data)<<28))
+#define VO_MON_SETUP_wb2_src(data)                                                   ((0x10000000&(data))>>28)
+#define VO_MON_SETUP_get_wb2(data)                                                   ((0x10000000&(data))>>28)
+#define VO_MON_SETUP_wb1_shift                                                       (27)
+#define VO_MON_SETUP_wb1_mask                                                        (0x08000000)
+#define VO_MON_SETUP_wb1(data)                                                       (0x08000000&((data)<<27))
+#define VO_MON_SETUP_wb1_src(data)                                                   ((0x08000000&(data))>>27)
+#define VO_MON_SETUP_get_wb1(data)                                                   ((0x08000000&(data))>>27)
+#define VO_MON_SETUP_dd_shift                                                        (25)
+#define VO_MON_SETUP_dd_mask                                                         (0x02000000)
+#define VO_MON_SETUP_dd(data)                                                        (0x02000000&((data)<<25))
+#define VO_MON_SETUP_dd_src(data)                                                    ((0x02000000&(data))>>25)
+#define VO_MON_SETUP_get_dd(data)                                                    ((0x02000000&(data))>>25)
+#define VO_MON_SETUP_csr_shift                                                       (24)
+#define VO_MON_SETUP_csr_mask                                                        (0x01000000)
+#define VO_MON_SETUP_csr(data)                                                       (0x01000000&((data)<<24))
+#define VO_MON_SETUP_csr_src(data)                                                   ((0x01000000&(data))>>24)
+#define VO_MON_SETUP_get_csr(data)                                                   ((0x01000000&(data))>>24)
+#define VO_MON_SETUP_sub2_shift                                                      (23)
+#define VO_MON_SETUP_sub2_mask                                                       (0x00800000)
+#define VO_MON_SETUP_sub2(data)                                                      (0x00800000&((data)<<23))
+#define VO_MON_SETUP_sub2_src(data)                                                  ((0x00800000&(data))>>23)
+#define VO_MON_SETUP_get_sub2(data)                                                  ((0x00800000&(data))>>23)
+#define VO_MON_SETUP_osd1_shift                                                      (22)
+#define VO_MON_SETUP_osd1_mask                                                       (0x00400000)
+#define VO_MON_SETUP_osd1(data)                                                      (0x00400000&((data)<<22))
+#define VO_MON_SETUP_osd1_src(data)                                                  ((0x00400000&(data))>>22)
+#define VO_MON_SETUP_get_osd1(data)                                                  ((0x00400000&(data))>>22)
+#define VO_MON_SETUP_sub1_shift                                                      (21)
+#define VO_MON_SETUP_sub1_mask                                                       (0x00200000)
+#define VO_MON_SETUP_sub1(data)                                                      (0x00200000&((data)<<21))
+#define VO_MON_SETUP_sub1_src(data)                                                  ((0x00200000&(data))>>21)
+#define VO_MON_SETUP_get_sub1(data)                                                  ((0x00200000&(data))>>21)
+#define VO_MON_SETUP_v2_shift                                                        (20)
+#define VO_MON_SETUP_v2_mask                                                         (0x00100000)
+#define VO_MON_SETUP_v2(data)                                                        (0x00100000&((data)<<20))
+#define VO_MON_SETUP_v2_src(data)                                                    ((0x00100000&(data))>>20)
+#define VO_MON_SETUP_get_v2(data)                                                    ((0x00100000&(data))>>20)
+#define VO_MON_SETUP_v1_shift                                                        (19)
+#define VO_MON_SETUP_v1_mask                                                         (0x00080000)
+#define VO_MON_SETUP_v1(data)                                                        (0x00080000&((data)<<19))
+#define VO_MON_SETUP_v1_src(data)                                                    ((0x00080000&(data))>>19)
+#define VO_MON_SETUP_get_v1(data)                                                    ((0x00080000&(data))>>19)
+#define VO_MON_SETUP_ch3_shift                                                       (18)
+#define VO_MON_SETUP_ch3_mask                                                        (0x00040000)
+#define VO_MON_SETUP_ch3(data)                                                       (0x00040000&((data)<<18))
+#define VO_MON_SETUP_ch3_src(data)                                                   ((0x00040000&(data))>>18)
+#define VO_MON_SETUP_get_ch3(data)                                                   ((0x00040000&(data))>>18)
+#define VO_MON_SETUP_ch2_shift                                                       (17)
+#define VO_MON_SETUP_ch2_mask                                                        (0x00020000)
+#define VO_MON_SETUP_ch2(data)                                                       (0x00020000&((data)<<17))
+#define VO_MON_SETUP_ch2_src(data)                                                   ((0x00020000&(data))>>17)
+#define VO_MON_SETUP_get_ch2(data)                                                   ((0x00020000&(data))>>17)
+#define VO_MON_SETUP_ch1_shift                                                       (16)
+#define VO_MON_SETUP_ch1_mask                                                        (0x00010000)
+#define VO_MON_SETUP_ch1(data)                                                       (0x00010000&((data)<<16))
+#define VO_MON_SETUP_ch1_src(data)                                                   ((0x00010000&(data))>>16)
+#define VO_MON_SETUP_get_ch1(data)                                                   ((0x00010000&(data))>>16)
+#define VO_MON_SETUP_th_shift                                                        (0)
+#define VO_MON_SETUP_th_mask                                                         (0x000003FF)
+#define VO_MON_SETUP_th(data)                                                        (0x000003FF&((data)<<0))
+#define VO_MON_SETUP_th_src(data)                                                    ((0x000003FF&(data))>>0)
+#define VO_MON_SETUP_get_th(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define VO_MON_DLY                                                                   0x98005E94
+#define VO_MON_DLY_reg_addr                                                          "0xD8005E94"
+#define VO_MON_DLY_reg                                                               0xD8005E94
+#define set_VO_MON_DLY_reg(data)   (*((volatile unsigned int*) VO_MON_DLY_reg)=data)
+#define get_VO_MON_DLY_reg   (*((volatile unsigned int*) VO_MON_DLY_reg))
+#define VO_MON_DLY_inst_adr                                                          "0x00A5"
+#define VO_MON_DLY_inst                                                              0x00A5
+#define VO_MON_DLY_delay_shift                                                       (16)
+#define VO_MON_DLY_delay_mask                                                        (0xFFFF0000)
+#define VO_MON_DLY_delay(data)                                                       (0xFFFF0000&((data)<<16))
+#define VO_MON_DLY_delay_src(data)                                                   ((0xFFFF0000&(data))>>16)
+#define VO_MON_DLY_get_delay(data)                                                   ((0xFFFF0000&(data))>>16)
+#define VO_MON_DLY_wb2_shift                                                         (9)
+#define VO_MON_DLY_wb2_mask                                                          (0x00000200)
+#define VO_MON_DLY_wb2(data)                                                         (0x00000200&((data)<<9))
+#define VO_MON_DLY_wb2_src(data)                                                     ((0x00000200&(data))>>9)
+#define VO_MON_DLY_get_wb2(data)                                                     ((0x00000200&(data))>>9)
+#define VO_MON_DLY_wb1_shift                                                         (8)
+#define VO_MON_DLY_wb1_mask                                                          (0x00000100)
+#define VO_MON_DLY_wb1(data)                                                         (0x00000100&((data)<<8))
+#define VO_MON_DLY_wb1_src(data)                                                     ((0x00000100&(data))>>8)
+#define VO_MON_DLY_get_wb1(data)                                                     ((0x00000100&(data))>>8)
+#define VO_MON_DLY_dd_shift                                                          (6)
+#define VO_MON_DLY_dd_mask                                                           (0x00000040)
+#define VO_MON_DLY_dd(data)                                                          (0x00000040&((data)<<6))
+#define VO_MON_DLY_dd_src(data)                                                      ((0x00000040&(data))>>6)
+#define VO_MON_DLY_get_dd(data)                                                      ((0x00000040&(data))>>6)
+#define VO_MON_DLY_csr_shift                                                         (5)
+#define VO_MON_DLY_csr_mask                                                          (0x00000020)
+#define VO_MON_DLY_csr(data)                                                         (0x00000020&((data)<<5))
+#define VO_MON_DLY_csr_src(data)                                                     ((0x00000020&(data))>>5)
+#define VO_MON_DLY_get_csr(data)                                                     ((0x00000020&(data))>>5)
+#define VO_MON_DLY_sub2_shift                                                        (4)
+#define VO_MON_DLY_sub2_mask                                                         (0x00000010)
+#define VO_MON_DLY_sub2(data)                                                        (0x00000010&((data)<<4))
+#define VO_MON_DLY_sub2_src(data)                                                    ((0x00000010&(data))>>4)
+#define VO_MON_DLY_get_sub2(data)                                                    ((0x00000010&(data))>>4)
+#define VO_MON_DLY_osd1_shift                                                        (3)
+#define VO_MON_DLY_osd1_mask                                                         (0x00000008)
+#define VO_MON_DLY_osd1(data)                                                        (0x00000008&((data)<<3))
+#define VO_MON_DLY_osd1_src(data)                                                    ((0x00000008&(data))>>3)
+#define VO_MON_DLY_get_osd1(data)                                                    ((0x00000008&(data))>>3)
+#define VO_MON_DLY_sub1_shift                                                        (2)
+#define VO_MON_DLY_sub1_mask                                                         (0x00000004)
+#define VO_MON_DLY_sub1(data)                                                        (0x00000004&((data)<<2))
+#define VO_MON_DLY_sub1_src(data)                                                    ((0x00000004&(data))>>2)
+#define VO_MON_DLY_get_sub1(data)                                                    ((0x00000004&(data))>>2)
+#define VO_MON_DLY_v2_shift                                                          (1)
+#define VO_MON_DLY_v2_mask                                                           (0x00000002)
+#define VO_MON_DLY_v2(data)                                                          (0x00000002&((data)<<1))
+#define VO_MON_DLY_v2_src(data)                                                      ((0x00000002&(data))>>1)
+#define VO_MON_DLY_get_v2(data)                                                      ((0x00000002&(data))>>1)
+#define VO_MON_DLY_v1_shift                                                          (0)
+#define VO_MON_DLY_v1_mask                                                           (0x00000001)
+#define VO_MON_DLY_v1(data)                                                          (0x00000001&((data)<<0))
+#define VO_MON_DLY_v1_src(data)                                                      ((0x00000001&(data))>>0)
+#define VO_MON_DLY_get_v1(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define VO_MON_DISP                                                                  0x98005E98
+#define VO_MON_DISP_reg_addr                                                         "0xD8005E98"
+#define VO_MON_DISP_reg                                                              0xD8005E98
+#define set_VO_MON_DISP_reg(data)   (*((volatile unsigned int*) VO_MON_DISP_reg)=data)
+#define get_VO_MON_DISP_reg   (*((volatile unsigned int*) VO_MON_DISP_reg))
+#define VO_MON_DISP_inst_adr                                                         "0x00A6"
+#define VO_MON_DISP_inst                                                             0x00A6
+#define VO_MON_DISP_not_full_shift                                                   (0)
+#define VO_MON_DISP_not_full_mask                                                    (0x00001FFF)
+#define VO_MON_DISP_not_full(data)                                                   (0x00001FFF&((data)<<0))
+#define VO_MON_DISP_not_full_src(data)                                               ((0x00001FFF&(data))>>0)
+#define VO_MON_DISP_get_not_full(data)                                               ((0x00001FFF&(data))>>0)
+
+
+#define VO_MON_UF_I                                                                  0x98005E9C
+#define VO_MON_UF_I_reg_addr                                                         "0xD8005E9C"
+#define VO_MON_UF_I_reg                                                              0xD8005E9C
+#define set_VO_MON_UF_I_reg(data)   (*((volatile unsigned int*) VO_MON_UF_I_reg)=data)
+#define get_VO_MON_UF_I_reg   (*((volatile unsigned int*) VO_MON_UF_I_reg))
+#define VO_MON_UF_I_inst_adr                                                         "0x00A7"
+#define VO_MON_UF_I_inst                                                             0x00A7
+#define VO_MON_UF_I_y_shift                                                          (0)
+#define VO_MON_UF_I_y_mask                                                           (0x00001FFF)
+#define VO_MON_UF_I_y(data)                                                          (0x00001FFF&((data)<<0))
+#define VO_MON_UF_I_y_src(data)                                                      ((0x00001FFF&(data))>>0)
+#define VO_MON_UF_I_get_y(data)                                                      ((0x00001FFF&(data))>>0)
+
+
+#define VO_MON_UF_P                                                                  0x98005EA0
+#define VO_MON_UF_P_reg_addr                                                         "0xD8005EA0"
+#define VO_MON_UF_P_reg                                                              0xD8005EA0
+#define set_VO_MON_UF_P_reg(data)   (*((volatile unsigned int*) VO_MON_UF_P_reg)=data)
+#define get_VO_MON_UF_P_reg   (*((volatile unsigned int*) VO_MON_UF_P_reg))
+#define VO_MON_UF_P_inst_adr                                                         "0x00A8"
+#define VO_MON_UF_P_inst                                                             0x00A8
+#define VO_MON_UF_P_y_shift                                                          (0)
+#define VO_MON_UF_P_y_mask                                                           (0x00001FFF)
+#define VO_MON_UF_P_y(data)                                                          (0x00001FFF&((data)<<0))
+#define VO_MON_UF_P_y_src(data)                                                      ((0x00001FFF&(data))>>0)
+#define VO_MON_UF_P_get_y(data)                                                      ((0x00001FFF&(data))>>0)
+
+
+#define VO_MON_UF_H                                                                  0x98005EA4
+#define VO_MON_UF_H_reg_addr                                                         "0xD8005EA4"
+#define VO_MON_UF_H_reg                                                              0xD8005EA4
+#define set_VO_MON_UF_H_reg(data)   (*((volatile unsigned int*) VO_MON_UF_H_reg)=data)
+#define get_VO_MON_UF_H_reg   (*((volatile unsigned int*) VO_MON_UF_H_reg))
+#define VO_MON_UF_H_inst_adr                                                         "0x00A9"
+#define VO_MON_UF_H_inst                                                             0x00A9
+#define VO_MON_UF_H_y_shift                                                          (0)
+#define VO_MON_UF_H_y_mask                                                           (0x00001FFF)
+#define VO_MON_UF_H_y(data)                                                          (0x00001FFF&((data)<<0))
+#define VO_MON_UF_H_y_src(data)                                                      ((0x00001FFF&(data))>>0)
+#define VO_MON_UF_H_get_y(data)                                                      ((0x00001FFF&(data))>>0)
+
+
+#define VO_MON_UF_V1                                                                 0x98005EA8
+#define VO_MON_UF_V1_reg_addr                                                        "0xD8005EA8"
+#define VO_MON_UF_V1_reg                                                             0xD8005EA8
+#define set_VO_MON_UF_V1_reg(data)   (*((volatile unsigned int*) VO_MON_UF_V1_reg)=data)
+#define get_VO_MON_UF_V1_reg   (*((volatile unsigned int*) VO_MON_UF_V1_reg))
+#define VO_MON_UF_V1_inst_adr                                                        "0x00AA"
+#define VO_MON_UF_V1_inst                                                            0x00AA
+#define VO_MON_UF_V1_cnt_shift                                                       (0)
+#define VO_MON_UF_V1_cnt_mask                                                        (0x000003FF)
+#define VO_MON_UF_V1_cnt(data)                                                       (0x000003FF&((data)<<0))
+#define VO_MON_UF_V1_cnt_src(data)                                                   ((0x000003FF&(data))>>0)
+#define VO_MON_UF_V1_get_cnt(data)                                                   ((0x000003FF&(data))>>0)
+
+
+#define VO_MON_UF_V2                                                                 0x98005EAC
+#define VO_MON_UF_V2_reg_addr                                                        "0xD8005EAC"
+#define VO_MON_UF_V2_reg                                                             0xD8005EAC
+#define set_VO_MON_UF_V2_reg(data)   (*((volatile unsigned int*) VO_MON_UF_V2_reg)=data)
+#define get_VO_MON_UF_V2_reg   (*((volatile unsigned int*) VO_MON_UF_V2_reg))
+#define VO_MON_UF_V2_inst_adr                                                        "0x00AB"
+#define VO_MON_UF_V2_inst                                                            0x00AB
+#define VO_MON_UF_V2_cnt_shift                                                       (0)
+#define VO_MON_UF_V2_cnt_mask                                                        (0x000003FF)
+#define VO_MON_UF_V2_cnt(data)                                                       (0x000003FF&((data)<<0))
+#define VO_MON_UF_V2_cnt_src(data)                                                   ((0x000003FF&(data))>>0)
+#define VO_MON_UF_V2_get_cnt(data)                                                   ((0x000003FF&(data))>>0)
+
+
+#define VO_MON_UF_SUB1                                                               0x98005EB0
+#define VO_MON_UF_SUB1_reg_addr                                                      "0xD8005EB0"
+#define VO_MON_UF_SUB1_reg                                                           0xD8005EB0
+#define set_VO_MON_UF_SUB1_reg(data)   (*((volatile unsigned int*) VO_MON_UF_SUB1_reg)=data)
+#define get_VO_MON_UF_SUB1_reg   (*((volatile unsigned int*) VO_MON_UF_SUB1_reg))
+#define VO_MON_UF_SUB1_inst_adr                                                      "0x00AC"
+#define VO_MON_UF_SUB1_inst                                                          0x00AC
+#define VO_MON_UF_SUB1_cnt_shift                                                     (0)
+#define VO_MON_UF_SUB1_cnt_mask                                                      (0x000001FF)
+#define VO_MON_UF_SUB1_cnt(data)                                                     (0x000001FF&((data)<<0))
+#define VO_MON_UF_SUB1_cnt_src(data)                                                 ((0x000001FF&(data))>>0)
+#define VO_MON_UF_SUB1_get_cnt(data)                                                 ((0x000001FF&(data))>>0)
+
+
+#define VO_MON_UF_OSD1                                                               0x98005EB4
+#define VO_MON_UF_OSD1_reg_addr                                                      "0xD8005EB4"
+#define VO_MON_UF_OSD1_reg                                                           0xD8005EB4
+#define set_VO_MON_UF_OSD1_reg(data)   (*((volatile unsigned int*) VO_MON_UF_OSD1_reg)=data)
+#define get_VO_MON_UF_OSD1_reg   (*((volatile unsigned int*) VO_MON_UF_OSD1_reg))
+#define VO_MON_UF_OSD1_inst_adr                                                      "0x00AD"
+#define VO_MON_UF_OSD1_inst                                                          0x00AD
+#define VO_MON_UF_OSD1_cnt_shift                                                     (0)
+#define VO_MON_UF_OSD1_cnt_mask                                                      (0x000001FF)
+#define VO_MON_UF_OSD1_cnt(data)                                                     (0x000001FF&((data)<<0))
+#define VO_MON_UF_OSD1_cnt_src(data)                                                 ((0x000001FF&(data))>>0)
+#define VO_MON_UF_OSD1_get_cnt(data)                                                 ((0x000001FF&(data))>>0)
+
+
+#define VO_MON_UF_SUB2                                                               0x98005EB8
+#define VO_MON_UF_SUB2_reg_addr                                                      "0xD8005EB8"
+#define VO_MON_UF_SUB2_reg                                                           0xD8005EB8
+#define set_VO_MON_UF_SUB2_reg(data)   (*((volatile unsigned int*) VO_MON_UF_SUB2_reg)=data)
+#define get_VO_MON_UF_SUB2_reg   (*((volatile unsigned int*) VO_MON_UF_SUB2_reg))
+#define VO_MON_UF_SUB2_inst_adr                                                      "0x00AE"
+#define VO_MON_UF_SUB2_inst                                                          0x00AE
+#define VO_MON_UF_SUB2_cnt_shift                                                     (0)
+#define VO_MON_UF_SUB2_cnt_mask                                                      (0x000001FF)
+#define VO_MON_UF_SUB2_cnt(data)                                                     (0x000001FF&((data)<<0))
+#define VO_MON_UF_SUB2_cnt_src(data)                                                 ((0x000001FF&(data))>>0)
+#define VO_MON_UF_SUB2_get_cnt(data)                                                 ((0x000001FF&(data))>>0)
+
+
+#define VO_MON_UF_CSR                                                                0x98005EBC
+#define VO_MON_UF_CSR_reg_addr                                                       "0xD8005EBC"
+#define VO_MON_UF_CSR_reg                                                            0xD8005EBC
+#define set_VO_MON_UF_CSR_reg(data)   (*((volatile unsigned int*) VO_MON_UF_CSR_reg)=data)
+#define get_VO_MON_UF_CSR_reg   (*((volatile unsigned int*) VO_MON_UF_CSR_reg))
+#define VO_MON_UF_CSR_inst_adr                                                       "0x00AF"
+#define VO_MON_UF_CSR_inst                                                           0x00AF
+#define VO_MON_UF_CSR_cnt_shift                                                      (0)
+#define VO_MON_UF_CSR_cnt_mask                                                       (0x000001FF)
+#define VO_MON_UF_CSR_cnt(data)                                                      (0x000001FF&((data)<<0))
+#define VO_MON_UF_CSR_cnt_src(data)                                                  ((0x000001FF&(data))>>0)
+#define VO_MON_UF_CSR_get_cnt(data)                                                  ((0x000001FF&(data))>>0)
+
+
+#define VO_DBG                                                                       0x98005EC0
+#define VO_DBG_reg_addr                                                              "0xD8005EC0"
+#define VO_DBG_reg                                                                   0xD8005EC0
+#define set_VO_DBG_reg(data)   (*((volatile unsigned int*) VO_DBG_reg)=data)
+#define get_VO_DBG_reg   (*((volatile unsigned int*) VO_DBG_reg))
+#define VO_DBG_inst_adr                                                              "0x00B0"
+#define VO_DBG_inst                                                                  0x00B0
+#define VO_DBG_write_en3_shift                                                       (24)
+#define VO_DBG_write_en3_mask                                                        (0x01000000)
+#define VO_DBG_write_en3(data)                                                       (0x01000000&((data)<<24))
+#define VO_DBG_write_en3_src(data)                                                   ((0x01000000&(data))>>24)
+#define VO_DBG_get_write_en3(data)                                                   ((0x01000000&(data))>>24)
+#define VO_DBG_sel1_shift                                                            (16)
+#define VO_DBG_sel1_mask                                                             (0x00FF0000)
+#define VO_DBG_sel1(data)                                                            (0x00FF0000&((data)<<16))
+#define VO_DBG_sel1_src(data)                                                        ((0x00FF0000&(data))>>16)
+#define VO_DBG_get_sel1(data)                                                        ((0x00FF0000&(data))>>16)
+#define VO_DBG_write_en2_shift                                                       (12)
+#define VO_DBG_write_en2_mask                                                        (0x00001000)
+#define VO_DBG_write_en2(data)                                                       (0x00001000&((data)<<12))
+#define VO_DBG_write_en2_src(data)                                                   ((0x00001000&(data))>>12)
+#define VO_DBG_get_write_en2(data)                                                   ((0x00001000&(data))>>12)
+#define VO_DBG_sel0_shift                                                            (4)
+#define VO_DBG_sel0_mask                                                             (0x00000FF0)
+#define VO_DBG_sel0(data)                                                            (0x00000FF0&((data)<<4))
+#define VO_DBG_sel0_src(data)                                                        ((0x00000FF0&(data))>>4)
+#define VO_DBG_get_sel0(data)                                                        ((0x00000FF0&(data))>>4)
+#define VO_DBG_write_en1_shift                                                       (1)
+#define VO_DBG_write_en1_mask                                                        (0x00000002)
+#define VO_DBG_write_en1(data)                                                       (0x00000002&((data)<<1))
+#define VO_DBG_write_en1_src(data)                                                   ((0x00000002&(data))>>1)
+#define VO_DBG_get_write_en1(data)                                                   ((0x00000002&(data))>>1)
+#define VO_DBG_en_shift                                                              (0)
+#define VO_DBG_en_mask                                                               (0x00000001)
+#define VO_DBG_en(data)                                                              (0x00000001&((data)<<0))
+#define VO_DBG_en_src(data)                                                          ((0x00000001&(data))>>0)
+#define VO_DBG_get_en(data)                                                          ((0x00000001&(data))>>0)
+
+
+#define VO_DACT                                                                      0x98005EC4
+#define VO_DACT_reg_addr                                                             "0xD8005EC4"
+#define VO_DACT_reg                                                                  0xD8005EC4
+#define set_VO_DACT_reg(data)   (*((volatile unsigned int*) VO_DACT_reg)=data)
+#define get_VO_DACT_reg   (*((volatile unsigned int*) VO_DACT_reg))
+#define VO_DACT_inst_adr                                                             "0x00B1"
+#define VO_DACT_inst                                                                 0x00B1
+#define VO_DACT_fix_l_shift                                                          (8)
+#define VO_DACT_fix_l_mask                                                           (0x00000100)
+#define VO_DACT_fix_l(data)                                                          (0x00000100&((data)<<8))
+#define VO_DACT_fix_l_src(data)                                                      ((0x00000100&(data))>>8)
+#define VO_DACT_get_fix_l(data)                                                      ((0x00000100&(data))>>8)
+#define VO_DACT_fix_h_shift                                                          (7)
+#define VO_DACT_fix_h_mask                                                           (0x00000080)
+#define VO_DACT_fix_h(data)                                                          (0x00000080&((data)<<7))
+#define VO_DACT_fix_h_src(data)                                                      ((0x00000080&(data))>>7)
+#define VO_DACT_get_fix_h(data)                                                      ((0x00000080&(data))>>7)
+#define VO_DACT_ramp_8_shift                                                         (6)
+#define VO_DACT_ramp_8_mask                                                          (0x00000040)
+#define VO_DACT_ramp_8(data)                                                         (0x00000040&((data)<<6))
+#define VO_DACT_ramp_8_src(data)                                                     ((0x00000040&(data))>>6)
+#define VO_DACT_get_ramp_8(data)                                                     ((0x00000040&(data))>>6)
+#define VO_DACT_ramp_4_shift                                                         (5)
+#define VO_DACT_ramp_4_mask                                                          (0x00000020)
+#define VO_DACT_ramp_4(data)                                                         (0x00000020&((data)<<5))
+#define VO_DACT_ramp_4_src(data)                                                     ((0x00000020&(data))>>5)
+#define VO_DACT_get_ramp_4(data)                                                     ((0x00000020&(data))>>5)
+#define VO_DACT_ramp_2_shift                                                         (4)
+#define VO_DACT_ramp_2_mask                                                          (0x00000010)
+#define VO_DACT_ramp_2(data)                                                         (0x00000010&((data)<<4))
+#define VO_DACT_ramp_2_src(data)                                                     ((0x00000010&(data))>>4)
+#define VO_DACT_get_ramp_2(data)                                                     ((0x00000010&(data))>>4)
+#define VO_DACT_ramp_1_shift                                                         (3)
+#define VO_DACT_ramp_1_mask                                                          (0x00000008)
+#define VO_DACT_ramp_1(data)                                                         (0x00000008&((data)<<3))
+#define VO_DACT_ramp_1_src(data)                                                     ((0x00000008&(data))>>3)
+#define VO_DACT_get_ramp_1(data)                                                     ((0x00000008&(data))>>3)
+#define VO_DACT_go_shift                                                             (2)
+#define VO_DACT_go_mask                                                              (0x00000004)
+#define VO_DACT_go(data)                                                             (0x00000004&((data)<<2))
+#define VO_DACT_go_src(data)                                                         ((0x00000004&(data))>>2)
+#define VO_DACT_get_go(data)                                                         ((0x00000004&(data))>>2)
+#define VO_DACT_en_shift                                                             (1)
+#define VO_DACT_en_mask                                                              (0x00000002)
+#define VO_DACT_en(data)                                                             (0x00000002&((data)<<1))
+#define VO_DACT_en_src(data)                                                         ((0x00000002&(data))>>1)
+#define VO_DACT_get_en(data)                                                         ((0x00000002&(data))>>1)
+#define VO_DACT_write_data_shift                                                     (0)
+#define VO_DACT_write_data_mask                                                      (0x00000001)
+#define VO_DACT_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_DACT_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_DACT_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_DACT_RAMP                                                                 0x98005EC8
+#define VO_DACT_RAMP_reg_addr                                                        "0xD8005EC8"
+#define VO_DACT_RAMP_reg                                                             0xD8005EC8
+#define set_VO_DACT_RAMP_reg(data)   (*((volatile unsigned int*) VO_DACT_RAMP_reg)=data)
+#define get_VO_DACT_RAMP_reg   (*((volatile unsigned int*) VO_DACT_RAMP_reg))
+#define VO_DACT_RAMP_inst_adr                                                        "0x00B2"
+#define VO_DACT_RAMP_inst                                                            0x00B2
+#define VO_DACT_RAMP_hld_time_shift                                                  (8)
+#define VO_DACT_RAMP_hld_time_mask                                                   (0x0000FF00)
+#define VO_DACT_RAMP_hld_time(data)                                                  (0x0000FF00&((data)<<8))
+#define VO_DACT_RAMP_hld_time_src(data)                                              ((0x0000FF00&(data))>>8)
+#define VO_DACT_RAMP_get_hld_time(data)                                              ((0x0000FF00&(data))>>8)
+#define VO_DACT_RAMP_mode_shift                                                      (0)
+#define VO_DACT_RAMP_mode_mask                                                       (0x00000003)
+#define VO_DACT_RAMP_mode(data)                                                      (0x00000003&((data)<<0))
+#define VO_DACT_RAMP_mode_src(data)                                                  ((0x00000003&(data))>>0)
+#define VO_DACT_RAMP_get_mode(data)                                                  ((0x00000003&(data))>>0)
+
+
+#define VO_DACT_L                                                                    0x98005ECC
+#define VO_DACT_L_reg_addr                                                           "0xD8005ECC"
+#define VO_DACT_L_reg                                                                0xD8005ECC
+#define set_VO_DACT_L_reg(data)   (*((volatile unsigned int*) VO_DACT_L_reg)=data)
+#define get_VO_DACT_L_reg   (*((volatile unsigned int*) VO_DACT_L_reg))
+#define VO_DACT_L_inst_adr                                                           "0x00B3"
+#define VO_DACT_L_inst                                                               0x00B3
+#define VO_DACT_L_l_shift                                                            (0)
+#define VO_DACT_L_l_mask                                                             (0x000007FF)
+#define VO_DACT_L_l(data)                                                            (0x000007FF&((data)<<0))
+#define VO_DACT_L_l_src(data)                                                        ((0x000007FF&(data))>>0)
+#define VO_DACT_L_get_l(data)                                                        ((0x000007FF&(data))>>0)
+
+
+#define VO_DACT_R                                                                    0x98005ED0
+#define VO_DACT_R_reg_addr                                                           "0xD8005ED0"
+#define VO_DACT_R_reg                                                                0xD8005ED0
+#define set_VO_DACT_R_reg(data)   (*((volatile unsigned int*) VO_DACT_R_reg)=data)
+#define get_VO_DACT_R_reg   (*((volatile unsigned int*) VO_DACT_R_reg))
+#define VO_DACT_R_inst_adr                                                           "0x00B4"
+#define VO_DACT_R_inst                                                               0x00B4
+#define VO_DACT_R_a_shift                                                            (0)
+#define VO_DACT_R_a_mask                                                             (0x000003FF)
+#define VO_DACT_R_a(data)                                                            (0x000003FF&((data)<<0))
+#define VO_DACT_R_a_src(data)                                                        ((0x000003FF&(data))>>0)
+#define VO_DACT_R_get_a(data)                                                        ((0x000003FF&(data))>>0)
+
+
+#define VO_DACT_A                                                                    0x98005ED4
+#define VO_DACT_A_reg_addr                                                           "0xD8005ED4"
+#define VO_DACT_A_reg                                                                0xD8005ED4
+#define set_VO_DACT_A_reg(data)   (*((volatile unsigned int*) VO_DACT_A_reg)=data)
+#define get_VO_DACT_A_reg   (*((volatile unsigned int*) VO_DACT_A_reg))
+#define VO_DACT_A_inst_adr                                                           "0x00B5"
+#define VO_DACT_A_inst                                                               0x00B5
+#define VO_DACT_A_a_shift                                                            (0)
+#define VO_DACT_A_a_mask                                                             (0x000003FF)
+#define VO_DACT_A_a(data)                                                            (0x000003FF&((data)<<0))
+#define VO_DACT_A_a_src(data)                                                        ((0x000003FF&(data))>>0)
+#define VO_DACT_A_get_a(data)                                                        ((0x000003FF&(data))>>0)
+
+
+#define VO_DACT_D                                                                    0x98005ED8
+#define VO_DACT_D_reg_addr                                                           "0xD8005ED8"
+#define VO_DACT_D_reg                                                                0xD8005ED8
+#define set_VO_DACT_D_reg(data)   (*((volatile unsigned int*) VO_DACT_D_reg)=data)
+#define get_VO_DACT_D_reg   (*((volatile unsigned int*) VO_DACT_D_reg))
+#define VO_DACT_D_inst_adr                                                           "0x00B6"
+#define VO_DACT_D_inst                                                               0x00B6
+#define VO_DACT_D_d_shift                                                            (0)
+#define VO_DACT_D_d_mask                                                             (0x0000FFFF)
+#define VO_DACT_D_d(data)                                                            (0x0000FFFF&((data)<<0))
+#define VO_DACT_D_d_src(data)                                                        ((0x0000FFFF&(data))>>0)
+#define VO_DACT_D_get_d(data)                                                        ((0x0000FFFF&(data))>>0)
+
+
+#define VO_RBRAM                                                                     0x98005EDC
+#define VO_RBRAM_reg_addr                                                            "0xD8005EDC"
+#define VO_RBRAM_reg                                                                 0xD8005EDC
+#define set_VO_RBRAM_reg(data)   (*((volatile unsigned int*) VO_RBRAM_reg)=data)
+#define get_VO_RBRAM_reg   (*((volatile unsigned int*) VO_RBRAM_reg))
+#define VO_RBRAM_inst_adr                                                            "0x00B7"
+#define VO_RBRAM_inst                                                                0x00B7
+#define VO_RBRAM_en_shift                                                            (1)
+#define VO_RBRAM_en_mask                                                             (0x00000002)
+#define VO_RBRAM_en(data)                                                            (0x00000002&((data)<<1))
+#define VO_RBRAM_en_src(data)                                                        ((0x00000002&(data))>>1)
+#define VO_RBRAM_get_en(data)                                                        ((0x00000002&(data))>>1)
+#define VO_RBRAM_write_data_shift                                                    (0)
+#define VO_RBRAM_write_data_mask                                                     (0x00000001)
+#define VO_RBRAM_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VO_RBRAM_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_RBRAM_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_VERF_0                                                                    0x98005EE0
+#define VO_VERF_1                                                                    0x98005EE4
+#define VO_VERF_2                                                                    0x98005EE8
+#define VO_VERF_0_reg_addr                                                           "0xD8005EE0"
+#define VO_VERF_1_reg_addr                                                           "0xD8005EE4"
+#define VO_VERF_2_reg_addr                                                           "0xD8005EE8"
+#define VO_VERF_0_reg                                                                0xD8005EE0
+#define VO_VERF_1_reg                                                                0xD8005EE4
+#define VO_VERF_2_reg                                                                0xD8005EE8
+#define set_VO_VERF_0_reg(data)   (*((volatile unsigned int*) VO_VERF_0_reg)=data)
+#define set_VO_VERF_1_reg(data)   (*((volatile unsigned int*) VO_VERF_1_reg)=data)
+#define set_VO_VERF_2_reg(data)   (*((volatile unsigned int*) VO_VERF_2_reg)=data)
+#define get_VO_VERF_0_reg   (*((volatile unsigned int*) VO_VERF_0_reg))
+#define get_VO_VERF_1_reg   (*((volatile unsigned int*) VO_VERF_1_reg))
+#define get_VO_VERF_2_reg   (*((volatile unsigned int*) VO_VERF_2_reg))
+#define VO_VERF_0_inst_adr                                                           "0x00B8"
+#define VO_VERF_1_inst_adr                                                           "0x00B9"
+#define VO_VERF_2_inst_adr                                                           "0x00BA"
+#define VO_VERF_0_inst                                                               0x00B8
+#define VO_VERF_1_inst                                                               0x00B9
+#define VO_VERF_2_inst                                                               0x00BA
+#define VO_VERF_mode_shift                                                           (0)
+#define VO_VERF_mode_mask                                                            (0xFFFFFFFF)
+#define VO_VERF_mode(data)                                                           (0xFFFFFFFF&((data)<<0))
+#define VO_VERF_mode_src(data)                                                       ((0xFFFFFFFF&(data))>>0)
+#define VO_VERF_get_mode(data)                                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SRAM_RM                                                                   0x98005EEC
+#define VO_SRAM_RM_reg_addr                                                          "0xD8005EEC"
+#define VO_SRAM_RM_reg                                                               0xD8005EEC
+#define set_VO_SRAM_RM_reg(data)   (*((volatile unsigned int*) VO_SRAM_RM_reg)=data)
+#define get_VO_SRAM_RM_reg   (*((volatile unsigned int*) VO_SRAM_RM_reg))
+#define VO_SRAM_RM_inst_adr                                                          "0x00BB"
+#define VO_SRAM_RM_inst                                                              0x00BB
+#define VO_SRAM_RM_rme_2_shift                                                       (12)
+#define VO_SRAM_RM_rme_2_mask                                                        (0x00001000)
+#define VO_SRAM_RM_rme_2(data)                                                       (0x00001000&((data)<<12))
+#define VO_SRAM_RM_rme_2_src(data)                                                   ((0x00001000&(data))>>12)
+#define VO_SRAM_RM_get_rme_2(data)                                                   ((0x00001000&(data))>>12)
+#define VO_SRAM_RM_rm_2_shift                                                        (8)
+#define VO_SRAM_RM_rm_2_mask                                                         (0x00000F00)
+#define VO_SRAM_RM_rm_2(data)                                                        (0x00000F00&((data)<<8))
+#define VO_SRAM_RM_rm_2_src(data)                                                    ((0x00000F00&(data))>>8)
+#define VO_SRAM_RM_get_rm_2(data)                                                    ((0x00000F00&(data))>>8)
+#define VO_SRAM_RM_rme_1_shift                                                       (4)
+#define VO_SRAM_RM_rme_1_mask                                                        (0x00000010)
+#define VO_SRAM_RM_rme_1(data)                                                       (0x00000010&((data)<<4))
+#define VO_SRAM_RM_rme_1_src(data)                                                   ((0x00000010&(data))>>4)
+#define VO_SRAM_RM_get_rme_1(data)                                                   ((0x00000010&(data))>>4)
+#define VO_SRAM_RM_rm_1_shift                                                        (0)
+#define VO_SRAM_RM_rm_1_mask                                                         (0x0000000F)
+#define VO_SRAM_RM_rm_1(data)                                                        (0x0000000F&((data)<<0))
+#define VO_SRAM_RM_rm_1_src(data)                                                    ((0x0000000F&(data))>>0)
+#define VO_SRAM_RM_get_rm_1(data)                                                    ((0x0000000F&(data))>>0)
+
+
+#define VO_MBIST                                                                     0x98005EF0
+#define VO_MBIST_reg_addr                                                            "0xD8005EF0"
+#define VO_MBIST_reg                                                                 0xD8005EF0
+#define set_VO_MBIST_reg(data)   (*((volatile unsigned int*) VO_MBIST_reg)=data)
+#define get_VO_MBIST_reg   (*((volatile unsigned int*) VO_MBIST_reg))
+#define VO_MBIST_inst_adr                                                            "0x00BC"
+#define VO_MBIST_inst                                                                0x00BC
+#define VO_MBIST_drf_start_pause_5_shift                                             (19)
+#define VO_MBIST_drf_start_pause_5_mask                                              (0x00080000)
+#define VO_MBIST_drf_start_pause_5(data)                                             (0x00080000&((data)<<19))
+#define VO_MBIST_drf_start_pause_5_src(data)                                         ((0x00080000&(data))>>19)
+#define VO_MBIST_get_drf_start_pause_5(data)                                         ((0x00080000&(data))>>19)
+#define VO_MBIST_drf_test_resume_5_shift                                             (18)
+#define VO_MBIST_drf_test_resume_5_mask                                              (0x00040000)
+#define VO_MBIST_drf_test_resume_5(data)                                             (0x00040000&((data)<<18))
+#define VO_MBIST_drf_test_resume_5_src(data)                                         ((0x00040000&(data))>>18)
+#define VO_MBIST_get_drf_test_resume_5(data)                                         ((0x00040000&(data))>>18)
+#define VO_MBIST_drf_bist_mode_5_shift                                               (17)
+#define VO_MBIST_drf_bist_mode_5_mask                                                (0x00020000)
+#define VO_MBIST_drf_bist_mode_5(data)                                               (0x00020000&((data)<<17))
+#define VO_MBIST_drf_bist_mode_5_src(data)                                           ((0x00020000&(data))>>17)
+#define VO_MBIST_get_drf_bist_mode_5(data)                                           ((0x00020000&(data))>>17)
+#define VO_MBIST_bist_mode_5_shift                                                   (16)
+#define VO_MBIST_bist_mode_5_mask                                                    (0x00010000)
+#define VO_MBIST_bist_mode_5(data)                                                   (0x00010000&((data)<<16))
+#define VO_MBIST_bist_mode_5_src(data)                                               ((0x00010000&(data))>>16)
+#define VO_MBIST_get_bist_mode_5(data)                                               ((0x00010000&(data))>>16)
+#define VO_MBIST_drf_start_pause_4_shift                                             (15)
+#define VO_MBIST_drf_start_pause_4_mask                                              (0x00008000)
+#define VO_MBIST_drf_start_pause_4(data)                                             (0x00008000&((data)<<15))
+#define VO_MBIST_drf_start_pause_4_src(data)                                         ((0x00008000&(data))>>15)
+#define VO_MBIST_get_drf_start_pause_4(data)                                         ((0x00008000&(data))>>15)
+#define VO_MBIST_drf_test_resume_4_shift                                             (14)
+#define VO_MBIST_drf_test_resume_4_mask                                              (0x00004000)
+#define VO_MBIST_drf_test_resume_4(data)                                             (0x00004000&((data)<<14))
+#define VO_MBIST_drf_test_resume_4_src(data)                                         ((0x00004000&(data))>>14)
+#define VO_MBIST_get_drf_test_resume_4(data)                                         ((0x00004000&(data))>>14)
+#define VO_MBIST_drf_bist_mode_4_shift                                               (13)
+#define VO_MBIST_drf_bist_mode_4_mask                                                (0x00002000)
+#define VO_MBIST_drf_bist_mode_4(data)                                               (0x00002000&((data)<<13))
+#define VO_MBIST_drf_bist_mode_4_src(data)                                           ((0x00002000&(data))>>13)
+#define VO_MBIST_get_drf_bist_mode_4(data)                                           ((0x00002000&(data))>>13)
+#define VO_MBIST_bist_mode_4_shift                                                   (12)
+#define VO_MBIST_bist_mode_4_mask                                                    (0x00001000)
+#define VO_MBIST_bist_mode_4(data)                                                   (0x00001000&((data)<<12))
+#define VO_MBIST_bist_mode_4_src(data)                                               ((0x00001000&(data))>>12)
+#define VO_MBIST_get_bist_mode_4(data)                                               ((0x00001000&(data))>>12)
+#define VO_MBIST_drf_start_pause_3_shift                                             (11)
+#define VO_MBIST_drf_start_pause_3_mask                                              (0x00000800)
+#define VO_MBIST_drf_start_pause_3(data)                                             (0x00000800&((data)<<11))
+#define VO_MBIST_drf_start_pause_3_src(data)                                         ((0x00000800&(data))>>11)
+#define VO_MBIST_get_drf_start_pause_3(data)                                         ((0x00000800&(data))>>11)
+#define VO_MBIST_drf_test_resume_3_shift                                             (10)
+#define VO_MBIST_drf_test_resume_3_mask                                              (0x00000400)
+#define VO_MBIST_drf_test_resume_3(data)                                             (0x00000400&((data)<<10))
+#define VO_MBIST_drf_test_resume_3_src(data)                                         ((0x00000400&(data))>>10)
+#define VO_MBIST_get_drf_test_resume_3(data)                                         ((0x00000400&(data))>>10)
+#define VO_MBIST_drf_bist_mode_3_shift                                               (9)
+#define VO_MBIST_drf_bist_mode_3_mask                                                (0x00000200)
+#define VO_MBIST_drf_bist_mode_3(data)                                               (0x00000200&((data)<<9))
+#define VO_MBIST_drf_bist_mode_3_src(data)                                           ((0x00000200&(data))>>9)
+#define VO_MBIST_get_drf_bist_mode_3(data)                                           ((0x00000200&(data))>>9)
+#define VO_MBIST_bist_mode_3_shift                                                   (8)
+#define VO_MBIST_bist_mode_3_mask                                                    (0x00000100)
+#define VO_MBIST_bist_mode_3(data)                                                   (0x00000100&((data)<<8))
+#define VO_MBIST_bist_mode_3_src(data)                                               ((0x00000100&(data))>>8)
+#define VO_MBIST_get_bist_mode_3(data)                                               ((0x00000100&(data))>>8)
+#define VO_MBIST_drf_start_pause_2_shift                                             (7)
+#define VO_MBIST_drf_start_pause_2_mask                                              (0x00000080)
+#define VO_MBIST_drf_start_pause_2(data)                                             (0x00000080&((data)<<7))
+#define VO_MBIST_drf_start_pause_2_src(data)                                         ((0x00000080&(data))>>7)
+#define VO_MBIST_get_drf_start_pause_2(data)                                         ((0x00000080&(data))>>7)
+#define VO_MBIST_drf_test_resume_2_shift                                             (6)
+#define VO_MBIST_drf_test_resume_2_mask                                              (0x00000040)
+#define VO_MBIST_drf_test_resume_2(data)                                             (0x00000040&((data)<<6))
+#define VO_MBIST_drf_test_resume_2_src(data)                                         ((0x00000040&(data))>>6)
+#define VO_MBIST_get_drf_test_resume_2(data)                                         ((0x00000040&(data))>>6)
+#define VO_MBIST_drf_bist_mode_2_shift                                               (5)
+#define VO_MBIST_drf_bist_mode_2_mask                                                (0x00000020)
+#define VO_MBIST_drf_bist_mode_2(data)                                               (0x00000020&((data)<<5))
+#define VO_MBIST_drf_bist_mode_2_src(data)                                           ((0x00000020&(data))>>5)
+#define VO_MBIST_get_drf_bist_mode_2(data)                                           ((0x00000020&(data))>>5)
+#define VO_MBIST_bist_mode_2_shift                                                   (4)
+#define VO_MBIST_bist_mode_2_mask                                                    (0x00000010)
+#define VO_MBIST_bist_mode_2(data)                                                   (0x00000010&((data)<<4))
+#define VO_MBIST_bist_mode_2_src(data)                                               ((0x00000010&(data))>>4)
+#define VO_MBIST_get_bist_mode_2(data)                                               ((0x00000010&(data))>>4)
+#define VO_MBIST_drf_start_pause_1_shift                                             (3)
+#define VO_MBIST_drf_start_pause_1_mask                                              (0x00000008)
+#define VO_MBIST_drf_start_pause_1(data)                                             (0x00000008&((data)<<3))
+#define VO_MBIST_drf_start_pause_1_src(data)                                         ((0x00000008&(data))>>3)
+#define VO_MBIST_get_drf_start_pause_1(data)                                         ((0x00000008&(data))>>3)
+#define VO_MBIST_drf_test_resume_1_shift                                             (2)
+#define VO_MBIST_drf_test_resume_1_mask                                              (0x00000004)
+#define VO_MBIST_drf_test_resume_1(data)                                             (0x00000004&((data)<<2))
+#define VO_MBIST_drf_test_resume_1_src(data)                                         ((0x00000004&(data))>>2)
+#define VO_MBIST_get_drf_test_resume_1(data)                                         ((0x00000004&(data))>>2)
+#define VO_MBIST_drf_bist_mode_1_shift                                               (1)
+#define VO_MBIST_drf_bist_mode_1_mask                                                (0x00000002)
+#define VO_MBIST_drf_bist_mode_1(data)                                               (0x00000002&((data)<<1))
+#define VO_MBIST_drf_bist_mode_1_src(data)                                           ((0x00000002&(data))>>1)
+#define VO_MBIST_get_drf_bist_mode_1(data)                                           ((0x00000002&(data))>>1)
+#define VO_MBIST_bist_mode_1_shift                                                   (0)
+#define VO_MBIST_bist_mode_1_mask                                                    (0x00000001)
+#define VO_MBIST_bist_mode_1(data)                                                   (0x00000001&((data)<<0))
+#define VO_MBIST_bist_mode_1_src(data)                                               ((0x00000001&(data))>>0)
+#define VO_MBIST_get_bist_mode_1(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VO_MBIST_1                                                                   0x98005EF4
+#define VO_MBIST_1_reg_addr                                                          "0xD8005EF4"
+#define VO_MBIST_1_reg                                                               0xD8005EF4
+#define set_VO_MBIST_1_reg(data)   (*((volatile unsigned int*) VO_MBIST_1_reg)=data)
+#define get_VO_MBIST_1_reg   (*((volatile unsigned int*) VO_MBIST_1_reg))
+#define VO_MBIST_1_inst_adr                                                          "0x00BD"
+#define VO_MBIST_1_inst                                                              0x00BD
+#define VO_MBIST_1_drf_start_pause_13_shift                                          (31)
+#define VO_MBIST_1_drf_start_pause_13_mask                                           (0x80000000)
+#define VO_MBIST_1_drf_start_pause_13(data)                                          (0x80000000&((data)<<31))
+#define VO_MBIST_1_drf_start_pause_13_src(data)                                      ((0x80000000&(data))>>31)
+#define VO_MBIST_1_get_drf_start_pause_13(data)                                      ((0x80000000&(data))>>31)
+#define VO_MBIST_1_drf_test_resume_13_shift                                          (30)
+#define VO_MBIST_1_drf_test_resume_13_mask                                           (0x40000000)
+#define VO_MBIST_1_drf_test_resume_13(data)                                          (0x40000000&((data)<<30))
+#define VO_MBIST_1_drf_test_resume_13_src(data)                                      ((0x40000000&(data))>>30)
+#define VO_MBIST_1_get_drf_test_resume_13(data)                                      ((0x40000000&(data))>>30)
+#define VO_MBIST_1_drf_bist_mode_13_shift                                            (29)
+#define VO_MBIST_1_drf_bist_mode_13_mask                                             (0x20000000)
+#define VO_MBIST_1_drf_bist_mode_13(data)                                            (0x20000000&((data)<<29))
+#define VO_MBIST_1_drf_bist_mode_13_src(data)                                        ((0x20000000&(data))>>29)
+#define VO_MBIST_1_get_drf_bist_mode_13(data)                                        ((0x20000000&(data))>>29)
+#define VO_MBIST_1_bist_mode_13_shift                                                (28)
+#define VO_MBIST_1_bist_mode_13_mask                                                 (0x10000000)
+#define VO_MBIST_1_bist_mode_13(data)                                                (0x10000000&((data)<<28))
+#define VO_MBIST_1_bist_mode_13_src(data)                                            ((0x10000000&(data))>>28)
+#define VO_MBIST_1_get_bist_mode_13(data)                                            ((0x10000000&(data))>>28)
+#define VO_MBIST_1_drf_start_pause_12_shift                                          (27)
+#define VO_MBIST_1_drf_start_pause_12_mask                                           (0x08000000)
+#define VO_MBIST_1_drf_start_pause_12(data)                                          (0x08000000&((data)<<27))
+#define VO_MBIST_1_drf_start_pause_12_src(data)                                      ((0x08000000&(data))>>27)
+#define VO_MBIST_1_get_drf_start_pause_12(data)                                      ((0x08000000&(data))>>27)
+#define VO_MBIST_1_drf_test_resume_12_shift                                          (26)
+#define VO_MBIST_1_drf_test_resume_12_mask                                           (0x04000000)
+#define VO_MBIST_1_drf_test_resume_12(data)                                          (0x04000000&((data)<<26))
+#define VO_MBIST_1_drf_test_resume_12_src(data)                                      ((0x04000000&(data))>>26)
+#define VO_MBIST_1_get_drf_test_resume_12(data)                                      ((0x04000000&(data))>>26)
+#define VO_MBIST_1_drf_bist_mode_12_shift                                            (25)
+#define VO_MBIST_1_drf_bist_mode_12_mask                                             (0x02000000)
+#define VO_MBIST_1_drf_bist_mode_12(data)                                            (0x02000000&((data)<<25))
+#define VO_MBIST_1_drf_bist_mode_12_src(data)                                        ((0x02000000&(data))>>25)
+#define VO_MBIST_1_get_drf_bist_mode_12(data)                                        ((0x02000000&(data))>>25)
+#define VO_MBIST_1_bist_mode_12_shift                                                (24)
+#define VO_MBIST_1_bist_mode_12_mask                                                 (0x01000000)
+#define VO_MBIST_1_bist_mode_12(data)                                                (0x01000000&((data)<<24))
+#define VO_MBIST_1_bist_mode_12_src(data)                                            ((0x01000000&(data))>>24)
+#define VO_MBIST_1_get_bist_mode_12(data)                                            ((0x01000000&(data))>>24)
+#define VO_MBIST_1_drf_start_pause_11_shift                                          (23)
+#define VO_MBIST_1_drf_start_pause_11_mask                                           (0x00800000)
+#define VO_MBIST_1_drf_start_pause_11(data)                                          (0x00800000&((data)<<23))
+#define VO_MBIST_1_drf_start_pause_11_src(data)                                      ((0x00800000&(data))>>23)
+#define VO_MBIST_1_get_drf_start_pause_11(data)                                      ((0x00800000&(data))>>23)
+#define VO_MBIST_1_drf_test_resume_11_shift                                          (22)
+#define VO_MBIST_1_drf_test_resume_11_mask                                           (0x00400000)
+#define VO_MBIST_1_drf_test_resume_11(data)                                          (0x00400000&((data)<<22))
+#define VO_MBIST_1_drf_test_resume_11_src(data)                                      ((0x00400000&(data))>>22)
+#define VO_MBIST_1_get_drf_test_resume_11(data)                                      ((0x00400000&(data))>>22)
+#define VO_MBIST_1_drf_bist_mode_11_shift                                            (21)
+#define VO_MBIST_1_drf_bist_mode_11_mask                                             (0x00200000)
+#define VO_MBIST_1_drf_bist_mode_11(data)                                            (0x00200000&((data)<<21))
+#define VO_MBIST_1_drf_bist_mode_11_src(data)                                        ((0x00200000&(data))>>21)
+#define VO_MBIST_1_get_drf_bist_mode_11(data)                                        ((0x00200000&(data))>>21)
+#define VO_MBIST_1_bist_mode_11_shift                                                (20)
+#define VO_MBIST_1_bist_mode_11_mask                                                 (0x00100000)
+#define VO_MBIST_1_bist_mode_11(data)                                                (0x00100000&((data)<<20))
+#define VO_MBIST_1_bist_mode_11_src(data)                                            ((0x00100000&(data))>>20)
+#define VO_MBIST_1_get_bist_mode_11(data)                                            ((0x00100000&(data))>>20)
+#define VO_MBIST_1_drf_start_pause_10_shift                                          (19)
+#define VO_MBIST_1_drf_start_pause_10_mask                                           (0x00080000)
+#define VO_MBIST_1_drf_start_pause_10(data)                                          (0x00080000&((data)<<19))
+#define VO_MBIST_1_drf_start_pause_10_src(data)                                      ((0x00080000&(data))>>19)
+#define VO_MBIST_1_get_drf_start_pause_10(data)                                      ((0x00080000&(data))>>19)
+#define VO_MBIST_1_drf_test_resume_10_shift                                          (18)
+#define VO_MBIST_1_drf_test_resume_10_mask                                           (0x00040000)
+#define VO_MBIST_1_drf_test_resume_10(data)                                          (0x00040000&((data)<<18))
+#define VO_MBIST_1_drf_test_resume_10_src(data)                                      ((0x00040000&(data))>>18)
+#define VO_MBIST_1_get_drf_test_resume_10(data)                                      ((0x00040000&(data))>>18)
+#define VO_MBIST_1_drf_bist_mode_10_shift                                            (17)
+#define VO_MBIST_1_drf_bist_mode_10_mask                                             (0x00020000)
+#define VO_MBIST_1_drf_bist_mode_10(data)                                            (0x00020000&((data)<<17))
+#define VO_MBIST_1_drf_bist_mode_10_src(data)                                        ((0x00020000&(data))>>17)
+#define VO_MBIST_1_get_drf_bist_mode_10(data)                                        ((0x00020000&(data))>>17)
+#define VO_MBIST_1_bist_mode_10_shift                                                (16)
+#define VO_MBIST_1_bist_mode_10_mask                                                 (0x00010000)
+#define VO_MBIST_1_bist_mode_10(data)                                                (0x00010000&((data)<<16))
+#define VO_MBIST_1_bist_mode_10_src(data)                                            ((0x00010000&(data))>>16)
+#define VO_MBIST_1_get_bist_mode_10(data)                                            ((0x00010000&(data))>>16)
+#define VO_MBIST_1_drf_start_pause_9_shift                                           (15)
+#define VO_MBIST_1_drf_start_pause_9_mask                                            (0x00008000)
+#define VO_MBIST_1_drf_start_pause_9(data)                                           (0x00008000&((data)<<15))
+#define VO_MBIST_1_drf_start_pause_9_src(data)                                       ((0x00008000&(data))>>15)
+#define VO_MBIST_1_get_drf_start_pause_9(data)                                       ((0x00008000&(data))>>15)
+#define VO_MBIST_1_drf_test_resume_9_shift                                           (14)
+#define VO_MBIST_1_drf_test_resume_9_mask                                            (0x00004000)
+#define VO_MBIST_1_drf_test_resume_9(data)                                           (0x00004000&((data)<<14))
+#define VO_MBIST_1_drf_test_resume_9_src(data)                                       ((0x00004000&(data))>>14)
+#define VO_MBIST_1_get_drf_test_resume_9(data)                                       ((0x00004000&(data))>>14)
+#define VO_MBIST_1_drf_bist_mode_9_shift                                             (13)
+#define VO_MBIST_1_drf_bist_mode_9_mask                                              (0x00002000)
+#define VO_MBIST_1_drf_bist_mode_9(data)                                             (0x00002000&((data)<<13))
+#define VO_MBIST_1_drf_bist_mode_9_src(data)                                         ((0x00002000&(data))>>13)
+#define VO_MBIST_1_get_drf_bist_mode_9(data)                                         ((0x00002000&(data))>>13)
+#define VO_MBIST_1_bist_mode_9_shift                                                 (12)
+#define VO_MBIST_1_bist_mode_9_mask                                                  (0x00001000)
+#define VO_MBIST_1_bist_mode_9(data)                                                 (0x00001000&((data)<<12))
+#define VO_MBIST_1_bist_mode_9_src(data)                                             ((0x00001000&(data))>>12)
+#define VO_MBIST_1_get_bist_mode_9(data)                                             ((0x00001000&(data))>>12)
+#define VO_MBIST_1_drf_start_pause_8_shift                                           (11)
+#define VO_MBIST_1_drf_start_pause_8_mask                                            (0x00000800)
+#define VO_MBIST_1_drf_start_pause_8(data)                                           (0x00000800&((data)<<11))
+#define VO_MBIST_1_drf_start_pause_8_src(data)                                       ((0x00000800&(data))>>11)
+#define VO_MBIST_1_get_drf_start_pause_8(data)                                       ((0x00000800&(data))>>11)
+#define VO_MBIST_1_drf_test_resume_8_shift                                           (10)
+#define VO_MBIST_1_drf_test_resume_8_mask                                            (0x00000400)
+#define VO_MBIST_1_drf_test_resume_8(data)                                           (0x00000400&((data)<<10))
+#define VO_MBIST_1_drf_test_resume_8_src(data)                                       ((0x00000400&(data))>>10)
+#define VO_MBIST_1_get_drf_test_resume_8(data)                                       ((0x00000400&(data))>>10)
+#define VO_MBIST_1_drf_bist_mode_8_shift                                             (9)
+#define VO_MBIST_1_drf_bist_mode_8_mask                                              (0x00000200)
+#define VO_MBIST_1_drf_bist_mode_8(data)                                             (0x00000200&((data)<<9))
+#define VO_MBIST_1_drf_bist_mode_8_src(data)                                         ((0x00000200&(data))>>9)
+#define VO_MBIST_1_get_drf_bist_mode_8(data)                                         ((0x00000200&(data))>>9)
+#define VO_MBIST_1_bist_mode_8_shift                                                 (8)
+#define VO_MBIST_1_bist_mode_8_mask                                                  (0x00000100)
+#define VO_MBIST_1_bist_mode_8(data)                                                 (0x00000100&((data)<<8))
+#define VO_MBIST_1_bist_mode_8_src(data)                                             ((0x00000100&(data))>>8)
+#define VO_MBIST_1_get_bist_mode_8(data)                                             ((0x00000100&(data))>>8)
+#define VO_MBIST_1_drf_start_pause_7_shift                                           (7)
+#define VO_MBIST_1_drf_start_pause_7_mask                                            (0x00000080)
+#define VO_MBIST_1_drf_start_pause_7(data)                                           (0x00000080&((data)<<7))
+#define VO_MBIST_1_drf_start_pause_7_src(data)                                       ((0x00000080&(data))>>7)
+#define VO_MBIST_1_get_drf_start_pause_7(data)                                       ((0x00000080&(data))>>7)
+#define VO_MBIST_1_drf_test_resume_7_shift                                           (6)
+#define VO_MBIST_1_drf_test_resume_7_mask                                            (0x00000040)
+#define VO_MBIST_1_drf_test_resume_7(data)                                           (0x00000040&((data)<<6))
+#define VO_MBIST_1_drf_test_resume_7_src(data)                                       ((0x00000040&(data))>>6)
+#define VO_MBIST_1_get_drf_test_resume_7(data)                                       ((0x00000040&(data))>>6)
+#define VO_MBIST_1_drf_bist_mode_7_shift                                             (5)
+#define VO_MBIST_1_drf_bist_mode_7_mask                                              (0x00000020)
+#define VO_MBIST_1_drf_bist_mode_7(data)                                             (0x00000020&((data)<<5))
+#define VO_MBIST_1_drf_bist_mode_7_src(data)                                         ((0x00000020&(data))>>5)
+#define VO_MBIST_1_get_drf_bist_mode_7(data)                                         ((0x00000020&(data))>>5)
+#define VO_MBIST_1_bist_mode_7_shift                                                 (4)
+#define VO_MBIST_1_bist_mode_7_mask                                                  (0x00000010)
+#define VO_MBIST_1_bist_mode_7(data)                                                 (0x00000010&((data)<<4))
+#define VO_MBIST_1_bist_mode_7_src(data)                                             ((0x00000010&(data))>>4)
+#define VO_MBIST_1_get_bist_mode_7(data)                                             ((0x00000010&(data))>>4)
+#define VO_MBIST_1_drf_start_pause_6_shift                                           (3)
+#define VO_MBIST_1_drf_start_pause_6_mask                                            (0x00000008)
+#define VO_MBIST_1_drf_start_pause_6(data)                                           (0x00000008&((data)<<3))
+#define VO_MBIST_1_drf_start_pause_6_src(data)                                       ((0x00000008&(data))>>3)
+#define VO_MBIST_1_get_drf_start_pause_6(data)                                       ((0x00000008&(data))>>3)
+#define VO_MBIST_1_drf_test_resume_6_shift                                           (2)
+#define VO_MBIST_1_drf_test_resume_6_mask                                            (0x00000004)
+#define VO_MBIST_1_drf_test_resume_6(data)                                           (0x00000004&((data)<<2))
+#define VO_MBIST_1_drf_test_resume_6_src(data)                                       ((0x00000004&(data))>>2)
+#define VO_MBIST_1_get_drf_test_resume_6(data)                                       ((0x00000004&(data))>>2)
+#define VO_MBIST_1_drf_bist_mode_6_shift                                             (1)
+#define VO_MBIST_1_drf_bist_mode_6_mask                                              (0x00000002)
+#define VO_MBIST_1_drf_bist_mode_6(data)                                             (0x00000002&((data)<<1))
+#define VO_MBIST_1_drf_bist_mode_6_src(data)                                         ((0x00000002&(data))>>1)
+#define VO_MBIST_1_get_drf_bist_mode_6(data)                                         ((0x00000002&(data))>>1)
+#define VO_MBIST_1_bist_mode_6_shift                                                 (0)
+#define VO_MBIST_1_bist_mode_6_mask                                                  (0x00000001)
+#define VO_MBIST_1_bist_mode_6(data)                                                 (0x00000001&((data)<<0))
+#define VO_MBIST_1_bist_mode_6_src(data)                                             ((0x00000001&(data))>>0)
+#define VO_MBIST_1_get_bist_mode_6(data)                                             ((0x00000001&(data))>>0)
+
+
+#define VO_MBIST_2                                                                   0x98005EF8
+#define VO_MBIST_2_reg_addr                                                          "0xD8005EF8"
+#define VO_MBIST_2_reg                                                               0xD8005EF8
+#define set_VO_MBIST_2_reg(data)   (*((volatile unsigned int*) VO_MBIST_2_reg)=data)
+#define get_VO_MBIST_2_reg   (*((volatile unsigned int*) VO_MBIST_2_reg))
+#define VO_MBIST_2_inst_adr                                                          "0x00BE"
+#define VO_MBIST_2_inst                                                              0x00BE
+#define VO_MBIST_2_drf_start_pause_15_shift                                          (7)
+#define VO_MBIST_2_drf_start_pause_15_mask                                           (0x00000080)
+#define VO_MBIST_2_drf_start_pause_15(data)                                          (0x00000080&((data)<<7))
+#define VO_MBIST_2_drf_start_pause_15_src(data)                                      ((0x00000080&(data))>>7)
+#define VO_MBIST_2_get_drf_start_pause_15(data)                                      ((0x00000080&(data))>>7)
+#define VO_MBIST_2_drf_test_resume_15_shift                                          (6)
+#define VO_MBIST_2_drf_test_resume_15_mask                                           (0x00000040)
+#define VO_MBIST_2_drf_test_resume_15(data)                                          (0x00000040&((data)<<6))
+#define VO_MBIST_2_drf_test_resume_15_src(data)                                      ((0x00000040&(data))>>6)
+#define VO_MBIST_2_get_drf_test_resume_15(data)                                      ((0x00000040&(data))>>6)
+#define VO_MBIST_2_drf_bist_mode_15_shift                                            (5)
+#define VO_MBIST_2_drf_bist_mode_15_mask                                             (0x00000020)
+#define VO_MBIST_2_drf_bist_mode_15(data)                                            (0x00000020&((data)<<5))
+#define VO_MBIST_2_drf_bist_mode_15_src(data)                                        ((0x00000020&(data))>>5)
+#define VO_MBIST_2_get_drf_bist_mode_15(data)                                        ((0x00000020&(data))>>5)
+#define VO_MBIST_2_bist_mode_15_shift                                                (4)
+#define VO_MBIST_2_bist_mode_15_mask                                                 (0x00000010)
+#define VO_MBIST_2_bist_mode_15(data)                                                (0x00000010&((data)<<4))
+#define VO_MBIST_2_bist_mode_15_src(data)                                            ((0x00000010&(data))>>4)
+#define VO_MBIST_2_get_bist_mode_15(data)                                            ((0x00000010&(data))>>4)
+#define VO_MBIST_2_drf_start_pause_14_shift                                          (3)
+#define VO_MBIST_2_drf_start_pause_14_mask                                           (0x00000008)
+#define VO_MBIST_2_drf_start_pause_14(data)                                          (0x00000008&((data)<<3))
+#define VO_MBIST_2_drf_start_pause_14_src(data)                                      ((0x00000008&(data))>>3)
+#define VO_MBIST_2_get_drf_start_pause_14(data)                                      ((0x00000008&(data))>>3)
+#define VO_MBIST_2_drf_test_resume_14_shift                                          (2)
+#define VO_MBIST_2_drf_test_resume_14_mask                                           (0x00000004)
+#define VO_MBIST_2_drf_test_resume_14(data)                                          (0x00000004&((data)<<2))
+#define VO_MBIST_2_drf_test_resume_14_src(data)                                      ((0x00000004&(data))>>2)
+#define VO_MBIST_2_get_drf_test_resume_14(data)                                      ((0x00000004&(data))>>2)
+#define VO_MBIST_2_drf_bist_mode_14_shift                                            (1)
+#define VO_MBIST_2_drf_bist_mode_14_mask                                             (0x00000002)
+#define VO_MBIST_2_drf_bist_mode_14(data)                                            (0x00000002&((data)<<1))
+#define VO_MBIST_2_drf_bist_mode_14_src(data)                                        ((0x00000002&(data))>>1)
+#define VO_MBIST_2_get_drf_bist_mode_14(data)                                        ((0x00000002&(data))>>1)
+#define VO_MBIST_2_bist_mode_14_shift                                                (0)
+#define VO_MBIST_2_bist_mode_14_mask                                                 (0x00000001)
+#define VO_MBIST_2_bist_mode_14(data)                                                (0x00000001&((data)<<0))
+#define VO_MBIST_2_bist_mode_14_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_MBIST_2_get_bist_mode_14(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VO_MBIST_OUT                                                                 0x98005EFC
+#define VO_MBIST_OUT_reg_addr                                                        "0xD8005EFC"
+#define VO_MBIST_OUT_reg                                                             0xD8005EFC
+#define set_VO_MBIST_OUT_reg(data)   (*((volatile unsigned int*) VO_MBIST_OUT_reg)=data)
+#define get_VO_MBIST_OUT_reg   (*((volatile unsigned int*) VO_MBIST_OUT_reg))
+#define VO_MBIST_OUT_inst_adr                                                        "0x00BF"
+#define VO_MBIST_OUT_inst                                                            0x00BF
+#define VO_MBIST_OUT_fail_5_2_shift                                                  (31)
+#define VO_MBIST_OUT_fail_5_2_mask                                                   (0x80000000)
+#define VO_MBIST_OUT_fail_5_2(data)                                                  (0x80000000&((data)<<31))
+#define VO_MBIST_OUT_fail_5_2_src(data)                                              ((0x80000000&(data))>>31)
+#define VO_MBIST_OUT_get_fail_5_2(data)                                              ((0x80000000&(data))>>31)
+#define VO_MBIST_OUT_fail_5_1_shift                                                  (30)
+#define VO_MBIST_OUT_fail_5_1_mask                                                   (0x40000000)
+#define VO_MBIST_OUT_fail_5_1(data)                                                  (0x40000000&((data)<<30))
+#define VO_MBIST_OUT_fail_5_1_src(data)                                              ((0x40000000&(data))>>30)
+#define VO_MBIST_OUT_get_fail_5_1(data)                                              ((0x40000000&(data))>>30)
+#define VO_MBIST_OUT_fail_5_0_shift                                                  (29)
+#define VO_MBIST_OUT_fail_5_0_mask                                                   (0x20000000)
+#define VO_MBIST_OUT_fail_5_0(data)                                                  (0x20000000&((data)<<29))
+#define VO_MBIST_OUT_fail_5_0_src(data)                                              ((0x20000000&(data))>>29)
+#define VO_MBIST_OUT_get_fail_5_0(data)                                              ((0x20000000&(data))>>29)
+#define VO_MBIST_OUT_fail_4_4_shift                                                  (28)
+#define VO_MBIST_OUT_fail_4_4_mask                                                   (0x10000000)
+#define VO_MBIST_OUT_fail_4_4(data)                                                  (0x10000000&((data)<<28))
+#define VO_MBIST_OUT_fail_4_4_src(data)                                              ((0x10000000&(data))>>28)
+#define VO_MBIST_OUT_get_fail_4_4(data)                                              ((0x10000000&(data))>>28)
+#define VO_MBIST_OUT_fail_4_3_shift                                                  (27)
+#define VO_MBIST_OUT_fail_4_3_mask                                                   (0x08000000)
+#define VO_MBIST_OUT_fail_4_3(data)                                                  (0x08000000&((data)<<27))
+#define VO_MBIST_OUT_fail_4_3_src(data)                                              ((0x08000000&(data))>>27)
+#define VO_MBIST_OUT_get_fail_4_3(data)                                              ((0x08000000&(data))>>27)
+#define VO_MBIST_OUT_fail_4_2_shift                                                  (26)
+#define VO_MBIST_OUT_fail_4_2_mask                                                   (0x04000000)
+#define VO_MBIST_OUT_fail_4_2(data)                                                  (0x04000000&((data)<<26))
+#define VO_MBIST_OUT_fail_4_2_src(data)                                              ((0x04000000&(data))>>26)
+#define VO_MBIST_OUT_get_fail_4_2(data)                                              ((0x04000000&(data))>>26)
+#define VO_MBIST_OUT_fail_4_1_shift                                                  (25)
+#define VO_MBIST_OUT_fail_4_1_mask                                                   (0x02000000)
+#define VO_MBIST_OUT_fail_4_1(data)                                                  (0x02000000&((data)<<25))
+#define VO_MBIST_OUT_fail_4_1_src(data)                                              ((0x02000000&(data))>>25)
+#define VO_MBIST_OUT_get_fail_4_1(data)                                              ((0x02000000&(data))>>25)
+#define VO_MBIST_OUT_fail_4_0_shift                                                  (24)
+#define VO_MBIST_OUT_fail_4_0_mask                                                   (0x01000000)
+#define VO_MBIST_OUT_fail_4_0(data)                                                  (0x01000000&((data)<<24))
+#define VO_MBIST_OUT_fail_4_0_src(data)                                              ((0x01000000&(data))>>24)
+#define VO_MBIST_OUT_get_fail_4_0(data)                                              ((0x01000000&(data))>>24)
+#define VO_MBIST_OUT_fail_3_3_shift                                                  (23)
+#define VO_MBIST_OUT_fail_3_3_mask                                                   (0x00800000)
+#define VO_MBIST_OUT_fail_3_3(data)                                                  (0x00800000&((data)<<23))
+#define VO_MBIST_OUT_fail_3_3_src(data)                                              ((0x00800000&(data))>>23)
+#define VO_MBIST_OUT_get_fail_3_3(data)                                              ((0x00800000&(data))>>23)
+#define VO_MBIST_OUT_fail_3_2_shift                                                  (22)
+#define VO_MBIST_OUT_fail_3_2_mask                                                   (0x00400000)
+#define VO_MBIST_OUT_fail_3_2(data)                                                  (0x00400000&((data)<<22))
+#define VO_MBIST_OUT_fail_3_2_src(data)                                              ((0x00400000&(data))>>22)
+#define VO_MBIST_OUT_get_fail_3_2(data)                                              ((0x00400000&(data))>>22)
+#define VO_MBIST_OUT_fail_3_1_shift                                                  (21)
+#define VO_MBIST_OUT_fail_3_1_mask                                                   (0x00200000)
+#define VO_MBIST_OUT_fail_3_1(data)                                                  (0x00200000&((data)<<21))
+#define VO_MBIST_OUT_fail_3_1_src(data)                                              ((0x00200000&(data))>>21)
+#define VO_MBIST_OUT_get_fail_3_1(data)                                              ((0x00200000&(data))>>21)
+#define VO_MBIST_OUT_fail_3_0_shift                                                  (20)
+#define VO_MBIST_OUT_fail_3_0_mask                                                   (0x00100000)
+#define VO_MBIST_OUT_fail_3_0(data)                                                  (0x00100000&((data)<<20))
+#define VO_MBIST_OUT_fail_3_0_src(data)                                              ((0x00100000&(data))>>20)
+#define VO_MBIST_OUT_get_fail_3_0(data)                                              ((0x00100000&(data))>>20)
+#define VO_MBIST_OUT_fail_2_6_shift                                                  (19)
+#define VO_MBIST_OUT_fail_2_6_mask                                                   (0x00080000)
+#define VO_MBIST_OUT_fail_2_6(data)                                                  (0x00080000&((data)<<19))
+#define VO_MBIST_OUT_fail_2_6_src(data)                                              ((0x00080000&(data))>>19)
+#define VO_MBIST_OUT_get_fail_2_6(data)                                              ((0x00080000&(data))>>19)
+#define VO_MBIST_OUT_fail_2_5_shift                                                  (18)
+#define VO_MBIST_OUT_fail_2_5_mask                                                   (0x00040000)
+#define VO_MBIST_OUT_fail_2_5(data)                                                  (0x00040000&((data)<<18))
+#define VO_MBIST_OUT_fail_2_5_src(data)                                              ((0x00040000&(data))>>18)
+#define VO_MBIST_OUT_get_fail_2_5(data)                                              ((0x00040000&(data))>>18)
+#define VO_MBIST_OUT_fail_2_4_shift                                                  (17)
+#define VO_MBIST_OUT_fail_2_4_mask                                                   (0x00020000)
+#define VO_MBIST_OUT_fail_2_4(data)                                                  (0x00020000&((data)<<17))
+#define VO_MBIST_OUT_fail_2_4_src(data)                                              ((0x00020000&(data))>>17)
+#define VO_MBIST_OUT_get_fail_2_4(data)                                              ((0x00020000&(data))>>17)
+#define VO_MBIST_OUT_fail_2_3_shift                                                  (16)
+#define VO_MBIST_OUT_fail_2_3_mask                                                   (0x00010000)
+#define VO_MBIST_OUT_fail_2_3(data)                                                  (0x00010000&((data)<<16))
+#define VO_MBIST_OUT_fail_2_3_src(data)                                              ((0x00010000&(data))>>16)
+#define VO_MBIST_OUT_get_fail_2_3(data)                                              ((0x00010000&(data))>>16)
+#define VO_MBIST_OUT_fail_2_2_shift                                                  (15)
+#define VO_MBIST_OUT_fail_2_2_mask                                                   (0x00008000)
+#define VO_MBIST_OUT_fail_2_2(data)                                                  (0x00008000&((data)<<15))
+#define VO_MBIST_OUT_fail_2_2_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_MBIST_OUT_get_fail_2_2(data)                                              ((0x00008000&(data))>>15)
+#define VO_MBIST_OUT_fail_2_1_shift                                                  (14)
+#define VO_MBIST_OUT_fail_2_1_mask                                                   (0x00004000)
+#define VO_MBIST_OUT_fail_2_1(data)                                                  (0x00004000&((data)<<14))
+#define VO_MBIST_OUT_fail_2_1_src(data)                                              ((0x00004000&(data))>>14)
+#define VO_MBIST_OUT_get_fail_2_1(data)                                              ((0x00004000&(data))>>14)
+#define VO_MBIST_OUT_fail_2_0_shift                                                  (13)
+#define VO_MBIST_OUT_fail_2_0_mask                                                   (0x00002000)
+#define VO_MBIST_OUT_fail_2_0(data)                                                  (0x00002000&((data)<<13))
+#define VO_MBIST_OUT_fail_2_0_src(data)                                              ((0x00002000&(data))>>13)
+#define VO_MBIST_OUT_get_fail_2_0(data)                                              ((0x00002000&(data))>>13)
+#define VO_MBIST_OUT_fail_1_6_shift                                                  (12)
+#define VO_MBIST_OUT_fail_1_6_mask                                                   (0x00001000)
+#define VO_MBIST_OUT_fail_1_6(data)                                                  (0x00001000&((data)<<12))
+#define VO_MBIST_OUT_fail_1_6_src(data)                                              ((0x00001000&(data))>>12)
+#define VO_MBIST_OUT_get_fail_1_6(data)                                              ((0x00001000&(data))>>12)
+#define VO_MBIST_OUT_fail_1_5_shift                                                  (11)
+#define VO_MBIST_OUT_fail_1_5_mask                                                   (0x00000800)
+#define VO_MBIST_OUT_fail_1_5(data)                                                  (0x00000800&((data)<<11))
+#define VO_MBIST_OUT_fail_1_5_src(data)                                              ((0x00000800&(data))>>11)
+#define VO_MBIST_OUT_get_fail_1_5(data)                                              ((0x00000800&(data))>>11)
+#define VO_MBIST_OUT_fail_1_4_shift                                                  (10)
+#define VO_MBIST_OUT_fail_1_4_mask                                                   (0x00000400)
+#define VO_MBIST_OUT_fail_1_4(data)                                                  (0x00000400&((data)<<10))
+#define VO_MBIST_OUT_fail_1_4_src(data)                                              ((0x00000400&(data))>>10)
+#define VO_MBIST_OUT_get_fail_1_4(data)                                              ((0x00000400&(data))>>10)
+#define VO_MBIST_OUT_fail_1_3_shift                                                  (9)
+#define VO_MBIST_OUT_fail_1_3_mask                                                   (0x00000200)
+#define VO_MBIST_OUT_fail_1_3(data)                                                  (0x00000200&((data)<<9))
+#define VO_MBIST_OUT_fail_1_3_src(data)                                              ((0x00000200&(data))>>9)
+#define VO_MBIST_OUT_get_fail_1_3(data)                                              ((0x00000200&(data))>>9)
+#define VO_MBIST_OUT_fail_1_2_shift                                                  (8)
+#define VO_MBIST_OUT_fail_1_2_mask                                                   (0x00000100)
+#define VO_MBIST_OUT_fail_1_2(data)                                                  (0x00000100&((data)<<8))
+#define VO_MBIST_OUT_fail_1_2_src(data)                                              ((0x00000100&(data))>>8)
+#define VO_MBIST_OUT_get_fail_1_2(data)                                              ((0x00000100&(data))>>8)
+#define VO_MBIST_OUT_fail_1_1_shift                                                  (7)
+#define VO_MBIST_OUT_fail_1_1_mask                                                   (0x00000080)
+#define VO_MBIST_OUT_fail_1_1(data)                                                  (0x00000080&((data)<<7))
+#define VO_MBIST_OUT_fail_1_1_src(data)                                              ((0x00000080&(data))>>7)
+#define VO_MBIST_OUT_get_fail_1_1(data)                                              ((0x00000080&(data))>>7)
+#define VO_MBIST_OUT_fail_1_0_shift                                                  (6)
+#define VO_MBIST_OUT_fail_1_0_mask                                                   (0x00000040)
+#define VO_MBIST_OUT_fail_1_0(data)                                                  (0x00000040&((data)<<6))
+#define VO_MBIST_OUT_fail_1_0_src(data)                                              ((0x00000040&(data))>>6)
+#define VO_MBIST_OUT_get_fail_1_0(data)                                              ((0x00000040&(data))>>6)
+#define VO_MBIST_OUT_done_5_shift                                                    (4)
+#define VO_MBIST_OUT_done_5_mask                                                     (0x00000010)
+#define VO_MBIST_OUT_done_5(data)                                                    (0x00000010&((data)<<4))
+#define VO_MBIST_OUT_done_5_src(data)                                                ((0x00000010&(data))>>4)
+#define VO_MBIST_OUT_get_done_5(data)                                                ((0x00000010&(data))>>4)
+#define VO_MBIST_OUT_done_4_shift                                                    (3)
+#define VO_MBIST_OUT_done_4_mask                                                     (0x00000008)
+#define VO_MBIST_OUT_done_4(data)                                                    (0x00000008&((data)<<3))
+#define VO_MBIST_OUT_done_4_src(data)                                                ((0x00000008&(data))>>3)
+#define VO_MBIST_OUT_get_done_4(data)                                                ((0x00000008&(data))>>3)
+#define VO_MBIST_OUT_done_3_shift                                                    (2)
+#define VO_MBIST_OUT_done_3_mask                                                     (0x00000004)
+#define VO_MBIST_OUT_done_3(data)                                                    (0x00000004&((data)<<2))
+#define VO_MBIST_OUT_done_3_src(data)                                                ((0x00000004&(data))>>2)
+#define VO_MBIST_OUT_get_done_3(data)                                                ((0x00000004&(data))>>2)
+#define VO_MBIST_OUT_done_2_shift                                                    (1)
+#define VO_MBIST_OUT_done_2_mask                                                     (0x00000002)
+#define VO_MBIST_OUT_done_2(data)                                                    (0x00000002&((data)<<1))
+#define VO_MBIST_OUT_done_2_src(data)                                                ((0x00000002&(data))>>1)
+#define VO_MBIST_OUT_get_done_2(data)                                                ((0x00000002&(data))>>1)
+#define VO_MBIST_OUT_done_1_shift                                                    (0)
+#define VO_MBIST_OUT_done_1_mask                                                     (0x00000001)
+#define VO_MBIST_OUT_done_1(data)                                                    (0x00000001&((data)<<0))
+#define VO_MBIST_OUT_done_1_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_MBIST_OUT_get_done_1(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_MBIST_OUT_1                                                               0x98005F00
+#define VO_MBIST_OUT_1_reg_addr                                                      "0xD8005F00"
+#define VO_MBIST_OUT_1_reg                                                           0xD8005F00
+#define set_VO_MBIST_OUT_1_reg(data)   (*((volatile unsigned int*) VO_MBIST_OUT_1_reg)=data)
+#define get_VO_MBIST_OUT_1_reg   (*((volatile unsigned int*) VO_MBIST_OUT_1_reg))
+#define VO_MBIST_OUT_1_inst_adr                                                      "0x00C0"
+#define VO_MBIST_OUT_1_inst                                                          0x00C0
+#define VO_MBIST_OUT_1_fail_9_9_shift                                                (29)
+#define VO_MBIST_OUT_1_fail_9_9_mask                                                 (0x20000000)
+#define VO_MBIST_OUT_1_fail_9_9(data)                                                (0x20000000&((data)<<29))
+#define VO_MBIST_OUT_1_fail_9_9_src(data)                                            ((0x20000000&(data))>>29)
+#define VO_MBIST_OUT_1_get_fail_9_9(data)                                            ((0x20000000&(data))>>29)
+#define VO_MBIST_OUT_1_fail_9_8_shift                                                (28)
+#define VO_MBIST_OUT_1_fail_9_8_mask                                                 (0x10000000)
+#define VO_MBIST_OUT_1_fail_9_8(data)                                                (0x10000000&((data)<<28))
+#define VO_MBIST_OUT_1_fail_9_8_src(data)                                            ((0x10000000&(data))>>28)
+#define VO_MBIST_OUT_1_get_fail_9_8(data)                                            ((0x10000000&(data))>>28)
+#define VO_MBIST_OUT_1_fail_9_7_shift                                                (27)
+#define VO_MBIST_OUT_1_fail_9_7_mask                                                 (0x08000000)
+#define VO_MBIST_OUT_1_fail_9_7(data)                                                (0x08000000&((data)<<27))
+#define VO_MBIST_OUT_1_fail_9_7_src(data)                                            ((0x08000000&(data))>>27)
+#define VO_MBIST_OUT_1_get_fail_9_7(data)                                            ((0x08000000&(data))>>27)
+#define VO_MBIST_OUT_1_fail_9_6_shift                                                (26)
+#define VO_MBIST_OUT_1_fail_9_6_mask                                                 (0x04000000)
+#define VO_MBIST_OUT_1_fail_9_6(data)                                                (0x04000000&((data)<<26))
+#define VO_MBIST_OUT_1_fail_9_6_src(data)                                            ((0x04000000&(data))>>26)
+#define VO_MBIST_OUT_1_get_fail_9_6(data)                                            ((0x04000000&(data))>>26)
+#define VO_MBIST_OUT_1_fail_9_5_shift                                                (25)
+#define VO_MBIST_OUT_1_fail_9_5_mask                                                 (0x02000000)
+#define VO_MBIST_OUT_1_fail_9_5(data)                                                (0x02000000&((data)<<25))
+#define VO_MBIST_OUT_1_fail_9_5_src(data)                                            ((0x02000000&(data))>>25)
+#define VO_MBIST_OUT_1_get_fail_9_5(data)                                            ((0x02000000&(data))>>25)
+#define VO_MBIST_OUT_1_fail_9_4_shift                                                (24)
+#define VO_MBIST_OUT_1_fail_9_4_mask                                                 (0x01000000)
+#define VO_MBIST_OUT_1_fail_9_4(data)                                                (0x01000000&((data)<<24))
+#define VO_MBIST_OUT_1_fail_9_4_src(data)                                            ((0x01000000&(data))>>24)
+#define VO_MBIST_OUT_1_get_fail_9_4(data)                                            ((0x01000000&(data))>>24)
+#define VO_MBIST_OUT_1_fail_9_3_shift                                                (23)
+#define VO_MBIST_OUT_1_fail_9_3_mask                                                 (0x00800000)
+#define VO_MBIST_OUT_1_fail_9_3(data)                                                (0x00800000&((data)<<23))
+#define VO_MBIST_OUT_1_fail_9_3_src(data)                                            ((0x00800000&(data))>>23)
+#define VO_MBIST_OUT_1_get_fail_9_3(data)                                            ((0x00800000&(data))>>23)
+#define VO_MBIST_OUT_1_fail_9_2_shift                                                (22)
+#define VO_MBIST_OUT_1_fail_9_2_mask                                                 (0x00400000)
+#define VO_MBIST_OUT_1_fail_9_2(data)                                                (0x00400000&((data)<<22))
+#define VO_MBIST_OUT_1_fail_9_2_src(data)                                            ((0x00400000&(data))>>22)
+#define VO_MBIST_OUT_1_get_fail_9_2(data)                                            ((0x00400000&(data))>>22)
+#define VO_MBIST_OUT_1_fail_9_1_shift                                                (21)
+#define VO_MBIST_OUT_1_fail_9_1_mask                                                 (0x00200000)
+#define VO_MBIST_OUT_1_fail_9_1(data)                                                (0x00200000&((data)<<21))
+#define VO_MBIST_OUT_1_fail_9_1_src(data)                                            ((0x00200000&(data))>>21)
+#define VO_MBIST_OUT_1_get_fail_9_1(data)                                            ((0x00200000&(data))>>21)
+#define VO_MBIST_OUT_1_fail_9_0_shift                                                (20)
+#define VO_MBIST_OUT_1_fail_9_0_mask                                                 (0x00100000)
+#define VO_MBIST_OUT_1_fail_9_0(data)                                                (0x00100000&((data)<<20))
+#define VO_MBIST_OUT_1_fail_9_0_src(data)                                            ((0x00100000&(data))>>20)
+#define VO_MBIST_OUT_1_get_fail_9_0(data)                                            ((0x00100000&(data))>>20)
+#define VO_MBIST_OUT_1_fail_8_3_shift                                                (19)
+#define VO_MBIST_OUT_1_fail_8_3_mask                                                 (0x00080000)
+#define VO_MBIST_OUT_1_fail_8_3(data)                                                (0x00080000&((data)<<19))
+#define VO_MBIST_OUT_1_fail_8_3_src(data)                                            ((0x00080000&(data))>>19)
+#define VO_MBIST_OUT_1_get_fail_8_3(data)                                            ((0x00080000&(data))>>19)
+#define VO_MBIST_OUT_1_fail_8_2_shift                                                (18)
+#define VO_MBIST_OUT_1_fail_8_2_mask                                                 (0x00040000)
+#define VO_MBIST_OUT_1_fail_8_2(data)                                                (0x00040000&((data)<<18))
+#define VO_MBIST_OUT_1_fail_8_2_src(data)                                            ((0x00040000&(data))>>18)
+#define VO_MBIST_OUT_1_get_fail_8_2(data)                                            ((0x00040000&(data))>>18)
+#define VO_MBIST_OUT_1_fail_8_1_shift                                                (17)
+#define VO_MBIST_OUT_1_fail_8_1_mask                                                 (0x00020000)
+#define VO_MBIST_OUT_1_fail_8_1(data)                                                (0x00020000&((data)<<17))
+#define VO_MBIST_OUT_1_fail_8_1_src(data)                                            ((0x00020000&(data))>>17)
+#define VO_MBIST_OUT_1_get_fail_8_1(data)                                            ((0x00020000&(data))>>17)
+#define VO_MBIST_OUT_1_fail_8_0_shift                                                (16)
+#define VO_MBIST_OUT_1_fail_8_0_mask                                                 (0x00010000)
+#define VO_MBIST_OUT_1_fail_8_0(data)                                                (0x00010000&((data)<<16))
+#define VO_MBIST_OUT_1_fail_8_0_src(data)                                            ((0x00010000&(data))>>16)
+#define VO_MBIST_OUT_1_get_fail_8_0(data)                                            ((0x00010000&(data))>>16)
+#define VO_MBIST_OUT_1_fail_7_3_shift                                                (15)
+#define VO_MBIST_OUT_1_fail_7_3_mask                                                 (0x00008000)
+#define VO_MBIST_OUT_1_fail_7_3(data)                                                (0x00008000&((data)<<15))
+#define VO_MBIST_OUT_1_fail_7_3_src(data)                                            ((0x00008000&(data))>>15)
+#define VO_MBIST_OUT_1_get_fail_7_3(data)                                            ((0x00008000&(data))>>15)
+#define VO_MBIST_OUT_1_fail_7_2_shift                                                (14)
+#define VO_MBIST_OUT_1_fail_7_2_mask                                                 (0x00004000)
+#define VO_MBIST_OUT_1_fail_7_2(data)                                                (0x00004000&((data)<<14))
+#define VO_MBIST_OUT_1_fail_7_2_src(data)                                            ((0x00004000&(data))>>14)
+#define VO_MBIST_OUT_1_get_fail_7_2(data)                                            ((0x00004000&(data))>>14)
+#define VO_MBIST_OUT_1_fail_7_1_shift                                                (13)
+#define VO_MBIST_OUT_1_fail_7_1_mask                                                 (0x00002000)
+#define VO_MBIST_OUT_1_fail_7_1(data)                                                (0x00002000&((data)<<13))
+#define VO_MBIST_OUT_1_fail_7_1_src(data)                                            ((0x00002000&(data))>>13)
+#define VO_MBIST_OUT_1_get_fail_7_1(data)                                            ((0x00002000&(data))>>13)
+#define VO_MBIST_OUT_1_fail_7_0_shift                                                (12)
+#define VO_MBIST_OUT_1_fail_7_0_mask                                                 (0x00001000)
+#define VO_MBIST_OUT_1_fail_7_0(data)                                                (0x00001000&((data)<<12))
+#define VO_MBIST_OUT_1_fail_7_0_src(data)                                            ((0x00001000&(data))>>12)
+#define VO_MBIST_OUT_1_get_fail_7_0(data)                                            ((0x00001000&(data))>>12)
+#define VO_MBIST_OUT_1_fail_6_3_shift                                                (11)
+#define VO_MBIST_OUT_1_fail_6_3_mask                                                 (0x00000800)
+#define VO_MBIST_OUT_1_fail_6_3(data)                                                (0x00000800&((data)<<11))
+#define VO_MBIST_OUT_1_fail_6_3_src(data)                                            ((0x00000800&(data))>>11)
+#define VO_MBIST_OUT_1_get_fail_6_3(data)                                            ((0x00000800&(data))>>11)
+#define VO_MBIST_OUT_1_fail_6_2_shift                                                (10)
+#define VO_MBIST_OUT_1_fail_6_2_mask                                                 (0x00000400)
+#define VO_MBIST_OUT_1_fail_6_2(data)                                                (0x00000400&((data)<<10))
+#define VO_MBIST_OUT_1_fail_6_2_src(data)                                            ((0x00000400&(data))>>10)
+#define VO_MBIST_OUT_1_get_fail_6_2(data)                                            ((0x00000400&(data))>>10)
+#define VO_MBIST_OUT_1_fail_6_1_shift                                                (9)
+#define VO_MBIST_OUT_1_fail_6_1_mask                                                 (0x00000200)
+#define VO_MBIST_OUT_1_fail_6_1(data)                                                (0x00000200&((data)<<9))
+#define VO_MBIST_OUT_1_fail_6_1_src(data)                                            ((0x00000200&(data))>>9)
+#define VO_MBIST_OUT_1_get_fail_6_1(data)                                            ((0x00000200&(data))>>9)
+#define VO_MBIST_OUT_1_fail_6_0_shift                                                (8)
+#define VO_MBIST_OUT_1_fail_6_0_mask                                                 (0x00000100)
+#define VO_MBIST_OUT_1_fail_6_0(data)                                                (0x00000100&((data)<<8))
+#define VO_MBIST_OUT_1_fail_6_0_src(data)                                            ((0x00000100&(data))>>8)
+#define VO_MBIST_OUT_1_get_fail_6_0(data)                                            ((0x00000100&(data))>>8)
+#define VO_MBIST_OUT_1_fail_4_6_shift                                                (7)
+#define VO_MBIST_OUT_1_fail_4_6_mask                                                 (0x00000080)
+#define VO_MBIST_OUT_1_fail_4_6(data)                                                (0x00000080&((data)<<7))
+#define VO_MBIST_OUT_1_fail_4_6_src(data)                                            ((0x00000080&(data))>>7)
+#define VO_MBIST_OUT_1_get_fail_4_6(data)                                            ((0x00000080&(data))>>7)
+#define VO_MBIST_OUT_1_fail_4_5_shift                                                (6)
+#define VO_MBIST_OUT_1_fail_4_5_mask                                                 (0x00000040)
+#define VO_MBIST_OUT_1_fail_4_5(data)                                                (0x00000040&((data)<<6))
+#define VO_MBIST_OUT_1_fail_4_5_src(data)                                            ((0x00000040&(data))>>6)
+#define VO_MBIST_OUT_1_get_fail_4_5(data)                                            ((0x00000040&(data))>>6)
+#define VO_MBIST_OUT_1_done_9_shift                                                  (3)
+#define VO_MBIST_OUT_1_done_9_mask                                                   (0x00000008)
+#define VO_MBIST_OUT_1_done_9(data)                                                  (0x00000008&((data)<<3))
+#define VO_MBIST_OUT_1_done_9_src(data)                                              ((0x00000008&(data))>>3)
+#define VO_MBIST_OUT_1_get_done_9(data)                                              ((0x00000008&(data))>>3)
+#define VO_MBIST_OUT_1_done_8_shift                                                  (2)
+#define VO_MBIST_OUT_1_done_8_mask                                                   (0x00000004)
+#define VO_MBIST_OUT_1_done_8(data)                                                  (0x00000004&((data)<<2))
+#define VO_MBIST_OUT_1_done_8_src(data)                                              ((0x00000004&(data))>>2)
+#define VO_MBIST_OUT_1_get_done_8(data)                                              ((0x00000004&(data))>>2)
+#define VO_MBIST_OUT_1_done_7_shift                                                  (1)
+#define VO_MBIST_OUT_1_done_7_mask                                                   (0x00000002)
+#define VO_MBIST_OUT_1_done_7(data)                                                  (0x00000002&((data)<<1))
+#define VO_MBIST_OUT_1_done_7_src(data)                                              ((0x00000002&(data))>>1)
+#define VO_MBIST_OUT_1_get_done_7(data)                                              ((0x00000002&(data))>>1)
+#define VO_MBIST_OUT_1_done_6_shift                                                  (0)
+#define VO_MBIST_OUT_1_done_6_mask                                                   (0x00000001)
+#define VO_MBIST_OUT_1_done_6(data)                                                  (0x00000001&((data)<<0))
+#define VO_MBIST_OUT_1_done_6_src(data)                                              ((0x00000001&(data))>>0)
+#define VO_MBIST_OUT_1_get_done_6(data)                                              ((0x00000001&(data))>>0)
+
+
+#define VO_MBIST_OUT_2                                                               0x98005F04
+#define VO_MBIST_OUT_2_reg_addr                                                      "0xD8005F04"
+#define VO_MBIST_OUT_2_reg                                                           0xD8005F04
+#define set_VO_MBIST_OUT_2_reg(data)   (*((volatile unsigned int*) VO_MBIST_OUT_2_reg)=data)
+#define get_VO_MBIST_OUT_2_reg   (*((volatile unsigned int*) VO_MBIST_OUT_2_reg))
+#define VO_MBIST_OUT_2_inst_adr                                                      "0x00C1"
+#define VO_MBIST_OUT_2_inst                                                          0x00C1
+#define VO_MBIST_OUT_2_fail_15_2_shift                                               (29)
+#define VO_MBIST_OUT_2_fail_15_2_mask                                                (0x20000000)
+#define VO_MBIST_OUT_2_fail_15_2(data)                                               (0x20000000&((data)<<29))
+#define VO_MBIST_OUT_2_fail_15_2_src(data)                                           ((0x20000000&(data))>>29)
+#define VO_MBIST_OUT_2_get_fail_15_2(data)                                           ((0x20000000&(data))>>29)
+#define VO_MBIST_OUT_2_fail_15_1_shift                                               (28)
+#define VO_MBIST_OUT_2_fail_15_1_mask                                                (0x10000000)
+#define VO_MBIST_OUT_2_fail_15_1(data)                                               (0x10000000&((data)<<28))
+#define VO_MBIST_OUT_2_fail_15_1_src(data)                                           ((0x10000000&(data))>>28)
+#define VO_MBIST_OUT_2_get_fail_15_1(data)                                           ((0x10000000&(data))>>28)
+#define VO_MBIST_OUT_2_fail_15_0_shift                                               (27)
+#define VO_MBIST_OUT_2_fail_15_0_mask                                                (0x08000000)
+#define VO_MBIST_OUT_2_fail_15_0(data)                                               (0x08000000&((data)<<27))
+#define VO_MBIST_OUT_2_fail_15_0_src(data)                                           ((0x08000000&(data))>>27)
+#define VO_MBIST_OUT_2_get_fail_15_0(data)                                           ((0x08000000&(data))>>27)
+#define VO_MBIST_OUT_2_fail_14_2_shift                                               (26)
+#define VO_MBIST_OUT_2_fail_14_2_mask                                                (0x04000000)
+#define VO_MBIST_OUT_2_fail_14_2(data)                                               (0x04000000&((data)<<26))
+#define VO_MBIST_OUT_2_fail_14_2_src(data)                                           ((0x04000000&(data))>>26)
+#define VO_MBIST_OUT_2_get_fail_14_2(data)                                           ((0x04000000&(data))>>26)
+#define VO_MBIST_OUT_2_fail_14_1_shift                                               (25)
+#define VO_MBIST_OUT_2_fail_14_1_mask                                                (0x02000000)
+#define VO_MBIST_OUT_2_fail_14_1(data)                                               (0x02000000&((data)<<25))
+#define VO_MBIST_OUT_2_fail_14_1_src(data)                                           ((0x02000000&(data))>>25)
+#define VO_MBIST_OUT_2_get_fail_14_1(data)                                           ((0x02000000&(data))>>25)
+#define VO_MBIST_OUT_2_fail_14_0_shift                                               (24)
+#define VO_MBIST_OUT_2_fail_14_0_mask                                                (0x01000000)
+#define VO_MBIST_OUT_2_fail_14_0(data)                                               (0x01000000&((data)<<24))
+#define VO_MBIST_OUT_2_fail_14_0_src(data)                                           ((0x01000000&(data))>>24)
+#define VO_MBIST_OUT_2_get_fail_14_0(data)                                           ((0x01000000&(data))>>24)
+#define VO_MBIST_OUT_2_fail_13_5_shift                                               (23)
+#define VO_MBIST_OUT_2_fail_13_5_mask                                                (0x00800000)
+#define VO_MBIST_OUT_2_fail_13_5(data)                                               (0x00800000&((data)<<23))
+#define VO_MBIST_OUT_2_fail_13_5_src(data)                                           ((0x00800000&(data))>>23)
+#define VO_MBIST_OUT_2_get_fail_13_5(data)                                           ((0x00800000&(data))>>23)
+#define VO_MBIST_OUT_2_fail_13_4_shift                                               (22)
+#define VO_MBIST_OUT_2_fail_13_4_mask                                                (0x00400000)
+#define VO_MBIST_OUT_2_fail_13_4(data)                                               (0x00400000&((data)<<22))
+#define VO_MBIST_OUT_2_fail_13_4_src(data)                                           ((0x00400000&(data))>>22)
+#define VO_MBIST_OUT_2_get_fail_13_4(data)                                           ((0x00400000&(data))>>22)
+#define VO_MBIST_OUT_2_fail_13_3_shift                                               (21)
+#define VO_MBIST_OUT_2_fail_13_3_mask                                                (0x00200000)
+#define VO_MBIST_OUT_2_fail_13_3(data)                                               (0x00200000&((data)<<21))
+#define VO_MBIST_OUT_2_fail_13_3_src(data)                                           ((0x00200000&(data))>>21)
+#define VO_MBIST_OUT_2_get_fail_13_3(data)                                           ((0x00200000&(data))>>21)
+#define VO_MBIST_OUT_2_fail_13_2_shift                                               (20)
+#define VO_MBIST_OUT_2_fail_13_2_mask                                                (0x00100000)
+#define VO_MBIST_OUT_2_fail_13_2(data)                                               (0x00100000&((data)<<20))
+#define VO_MBIST_OUT_2_fail_13_2_src(data)                                           ((0x00100000&(data))>>20)
+#define VO_MBIST_OUT_2_get_fail_13_2(data)                                           ((0x00100000&(data))>>20)
+#define VO_MBIST_OUT_2_fail_13_1_shift                                               (19)
+#define VO_MBIST_OUT_2_fail_13_1_mask                                                (0x00080000)
+#define VO_MBIST_OUT_2_fail_13_1(data)                                               (0x00080000&((data)<<19))
+#define VO_MBIST_OUT_2_fail_13_1_src(data)                                           ((0x00080000&(data))>>19)
+#define VO_MBIST_OUT_2_get_fail_13_1(data)                                           ((0x00080000&(data))>>19)
+#define VO_MBIST_OUT_2_fail_13_0_shift                                               (18)
+#define VO_MBIST_OUT_2_fail_13_0_mask                                                (0x00040000)
+#define VO_MBIST_OUT_2_fail_13_0(data)                                               (0x00040000&((data)<<18))
+#define VO_MBIST_OUT_2_fail_13_0_src(data)                                           ((0x00040000&(data))>>18)
+#define VO_MBIST_OUT_2_get_fail_13_0(data)                                           ((0x00040000&(data))>>18)
+#define VO_MBIST_OUT_2_fail_12_1_shift                                               (17)
+#define VO_MBIST_OUT_2_fail_12_1_mask                                                (0x00020000)
+#define VO_MBIST_OUT_2_fail_12_1(data)                                               (0x00020000&((data)<<17))
+#define VO_MBIST_OUT_2_fail_12_1_src(data)                                           ((0x00020000&(data))>>17)
+#define VO_MBIST_OUT_2_get_fail_12_1(data)                                           ((0x00020000&(data))>>17)
+#define VO_MBIST_OUT_2_fail_12_0_shift                                               (16)
+#define VO_MBIST_OUT_2_fail_12_0_mask                                                (0x00010000)
+#define VO_MBIST_OUT_2_fail_12_0(data)                                               (0x00010000&((data)<<16))
+#define VO_MBIST_OUT_2_fail_12_0_src(data)                                           ((0x00010000&(data))>>16)
+#define VO_MBIST_OUT_2_get_fail_12_0(data)                                           ((0x00010000&(data))>>16)
+#define VO_MBIST_OUT_2_fail_11_5_shift                                               (15)
+#define VO_MBIST_OUT_2_fail_11_5_mask                                                (0x00008000)
+#define VO_MBIST_OUT_2_fail_11_5(data)                                               (0x00008000&((data)<<15))
+#define VO_MBIST_OUT_2_fail_11_5_src(data)                                           ((0x00008000&(data))>>15)
+#define VO_MBIST_OUT_2_get_fail_11_5(data)                                           ((0x00008000&(data))>>15)
+#define VO_MBIST_OUT_2_fail_11_4_shift                                               (14)
+#define VO_MBIST_OUT_2_fail_11_4_mask                                                (0x00004000)
+#define VO_MBIST_OUT_2_fail_11_4(data)                                               (0x00004000&((data)<<14))
+#define VO_MBIST_OUT_2_fail_11_4_src(data)                                           ((0x00004000&(data))>>14)
+#define VO_MBIST_OUT_2_get_fail_11_4(data)                                           ((0x00004000&(data))>>14)
+#define VO_MBIST_OUT_2_fail_11_3_shift                                               (13)
+#define VO_MBIST_OUT_2_fail_11_3_mask                                                (0x00002000)
+#define VO_MBIST_OUT_2_fail_11_3(data)                                               (0x00002000&((data)<<13))
+#define VO_MBIST_OUT_2_fail_11_3_src(data)                                           ((0x00002000&(data))>>13)
+#define VO_MBIST_OUT_2_get_fail_11_3(data)                                           ((0x00002000&(data))>>13)
+#define VO_MBIST_OUT_2_fail_11_2_shift                                               (12)
+#define VO_MBIST_OUT_2_fail_11_2_mask                                                (0x00001000)
+#define VO_MBIST_OUT_2_fail_11_2(data)                                               (0x00001000&((data)<<12))
+#define VO_MBIST_OUT_2_fail_11_2_src(data)                                           ((0x00001000&(data))>>12)
+#define VO_MBIST_OUT_2_get_fail_11_2(data)                                           ((0x00001000&(data))>>12)
+#define VO_MBIST_OUT_2_fail_11_1_shift                                               (11)
+#define VO_MBIST_OUT_2_fail_11_1_mask                                                (0x00000800)
+#define VO_MBIST_OUT_2_fail_11_1(data)                                               (0x00000800&((data)<<11))
+#define VO_MBIST_OUT_2_fail_11_1_src(data)                                           ((0x00000800&(data))>>11)
+#define VO_MBIST_OUT_2_get_fail_11_1(data)                                           ((0x00000800&(data))>>11)
+#define VO_MBIST_OUT_2_fail_11_0_shift                                               (10)
+#define VO_MBIST_OUT_2_fail_11_0_mask                                                (0x00000400)
+#define VO_MBIST_OUT_2_fail_11_0(data)                                               (0x00000400&((data)<<10))
+#define VO_MBIST_OUT_2_fail_11_0_src(data)                                           ((0x00000400&(data))>>10)
+#define VO_MBIST_OUT_2_get_fail_11_0(data)                                           ((0x00000400&(data))>>10)
+#define VO_MBIST_OUT_2_fail_10_1_shift                                               (9)
+#define VO_MBIST_OUT_2_fail_10_1_mask                                                (0x00000200)
+#define VO_MBIST_OUT_2_fail_10_1(data)                                               (0x00000200&((data)<<9))
+#define VO_MBIST_OUT_2_fail_10_1_src(data)                                           ((0x00000200&(data))>>9)
+#define VO_MBIST_OUT_2_get_fail_10_1(data)                                           ((0x00000200&(data))>>9)
+#define VO_MBIST_OUT_2_fail_10_0_shift                                               (8)
+#define VO_MBIST_OUT_2_fail_10_0_mask                                                (0x00000100)
+#define VO_MBIST_OUT_2_fail_10_0(data)                                               (0x00000100&((data)<<8))
+#define VO_MBIST_OUT_2_fail_10_0_src(data)                                           ((0x00000100&(data))>>8)
+#define VO_MBIST_OUT_2_get_fail_10_0(data)                                           ((0x00000100&(data))>>8)
+#define VO_MBIST_OUT_2_done_15_shift                                                 (5)
+#define VO_MBIST_OUT_2_done_15_mask                                                  (0x00000020)
+#define VO_MBIST_OUT_2_done_15(data)                                                 (0x00000020&((data)<<5))
+#define VO_MBIST_OUT_2_done_15_src(data)                                             ((0x00000020&(data))>>5)
+#define VO_MBIST_OUT_2_get_done_15(data)                                             ((0x00000020&(data))>>5)
+#define VO_MBIST_OUT_2_done_14_shift                                                 (4)
+#define VO_MBIST_OUT_2_done_14_mask                                                  (0x00000010)
+#define VO_MBIST_OUT_2_done_14(data)                                                 (0x00000010&((data)<<4))
+#define VO_MBIST_OUT_2_done_14_src(data)                                             ((0x00000010&(data))>>4)
+#define VO_MBIST_OUT_2_get_done_14(data)                                             ((0x00000010&(data))>>4)
+#define VO_MBIST_OUT_2_done_13_shift                                                 (3)
+#define VO_MBIST_OUT_2_done_13_mask                                                  (0x00000008)
+#define VO_MBIST_OUT_2_done_13(data)                                                 (0x00000008&((data)<<3))
+#define VO_MBIST_OUT_2_done_13_src(data)                                             ((0x00000008&(data))>>3)
+#define VO_MBIST_OUT_2_get_done_13(data)                                             ((0x00000008&(data))>>3)
+#define VO_MBIST_OUT_2_done_12_shift                                                 (2)
+#define VO_MBIST_OUT_2_done_12_mask                                                  (0x00000004)
+#define VO_MBIST_OUT_2_done_12(data)                                                 (0x00000004&((data)<<2))
+#define VO_MBIST_OUT_2_done_12_src(data)                                             ((0x00000004&(data))>>2)
+#define VO_MBIST_OUT_2_get_done_12(data)                                             ((0x00000004&(data))>>2)
+#define VO_MBIST_OUT_2_done_11_shift                                                 (1)
+#define VO_MBIST_OUT_2_done_11_mask                                                  (0x00000002)
+#define VO_MBIST_OUT_2_done_11(data)                                                 (0x00000002&((data)<<1))
+#define VO_MBIST_OUT_2_done_11_src(data)                                             ((0x00000002&(data))>>1)
+#define VO_MBIST_OUT_2_get_done_11(data)                                             ((0x00000002&(data))>>1)
+#define VO_MBIST_OUT_2_done_10_shift                                                 (0)
+#define VO_MBIST_OUT_2_done_10_mask                                                  (0x00000001)
+#define VO_MBIST_OUT_2_done_10(data)                                                 (0x00000001&((data)<<0))
+#define VO_MBIST_OUT_2_done_10_src(data)                                             ((0x00000001&(data))>>0)
+#define VO_MBIST_OUT_2_get_done_10(data)                                             ((0x00000001&(data))>>0)
+
+
+#define VO_DRF_MBIST_OUT                                                             0x98005F08
+#define VO_DRF_MBIST_OUT_reg_addr                                                    "0xD8005F08"
+#define VO_DRF_MBIST_OUT_reg                                                         0xD8005F08
+#define set_VO_DRF_MBIST_OUT_reg(data)   (*((volatile unsigned int*) VO_DRF_MBIST_OUT_reg)=data)
+#define get_VO_DRF_MBIST_OUT_reg   (*((volatile unsigned int*) VO_DRF_MBIST_OUT_reg))
+#define VO_DRF_MBIST_OUT_inst_adr                                                    "0x00C2"
+#define VO_DRF_MBIST_OUT_inst                                                        0x00C2
+#define VO_DRF_MBIST_OUT_fail_5_2_shift                                              (31)
+#define VO_DRF_MBIST_OUT_fail_5_2_mask                                               (0x80000000)
+#define VO_DRF_MBIST_OUT_fail_5_2(data)                                              (0x80000000&((data)<<31))
+#define VO_DRF_MBIST_OUT_fail_5_2_src(data)                                          ((0x80000000&(data))>>31)
+#define VO_DRF_MBIST_OUT_get_fail_5_2(data)                                          ((0x80000000&(data))>>31)
+#define VO_DRF_MBIST_OUT_fail_5_1_shift                                              (30)
+#define VO_DRF_MBIST_OUT_fail_5_1_mask                                               (0x40000000)
+#define VO_DRF_MBIST_OUT_fail_5_1(data)                                              (0x40000000&((data)<<30))
+#define VO_DRF_MBIST_OUT_fail_5_1_src(data)                                          ((0x40000000&(data))>>30)
+#define VO_DRF_MBIST_OUT_get_fail_5_1(data)                                          ((0x40000000&(data))>>30)
+#define VO_DRF_MBIST_OUT_fail_5_0_shift                                              (29)
+#define VO_DRF_MBIST_OUT_fail_5_0_mask                                               (0x20000000)
+#define VO_DRF_MBIST_OUT_fail_5_0(data)                                              (0x20000000&((data)<<29))
+#define VO_DRF_MBIST_OUT_fail_5_0_src(data)                                          ((0x20000000&(data))>>29)
+#define VO_DRF_MBIST_OUT_get_fail_5_0(data)                                          ((0x20000000&(data))>>29)
+#define VO_DRF_MBIST_OUT_fail_4_4_shift                                              (28)
+#define VO_DRF_MBIST_OUT_fail_4_4_mask                                               (0x10000000)
+#define VO_DRF_MBIST_OUT_fail_4_4(data)                                              (0x10000000&((data)<<28))
+#define VO_DRF_MBIST_OUT_fail_4_4_src(data)                                          ((0x10000000&(data))>>28)
+#define VO_DRF_MBIST_OUT_get_fail_4_4(data)                                          ((0x10000000&(data))>>28)
+#define VO_DRF_MBIST_OUT_fail_4_3_shift                                              (27)
+#define VO_DRF_MBIST_OUT_fail_4_3_mask                                               (0x08000000)
+#define VO_DRF_MBIST_OUT_fail_4_3(data)                                              (0x08000000&((data)<<27))
+#define VO_DRF_MBIST_OUT_fail_4_3_src(data)                                          ((0x08000000&(data))>>27)
+#define VO_DRF_MBIST_OUT_get_fail_4_3(data)                                          ((0x08000000&(data))>>27)
+#define VO_DRF_MBIST_OUT_fail_4_2_shift                                              (26)
+#define VO_DRF_MBIST_OUT_fail_4_2_mask                                               (0x04000000)
+#define VO_DRF_MBIST_OUT_fail_4_2(data)                                              (0x04000000&((data)<<26))
+#define VO_DRF_MBIST_OUT_fail_4_2_src(data)                                          ((0x04000000&(data))>>26)
+#define VO_DRF_MBIST_OUT_get_fail_4_2(data)                                          ((0x04000000&(data))>>26)
+#define VO_DRF_MBIST_OUT_fail_4_1_shift                                              (25)
+#define VO_DRF_MBIST_OUT_fail_4_1_mask                                               (0x02000000)
+#define VO_DRF_MBIST_OUT_fail_4_1(data)                                              (0x02000000&((data)<<25))
+#define VO_DRF_MBIST_OUT_fail_4_1_src(data)                                          ((0x02000000&(data))>>25)
+#define VO_DRF_MBIST_OUT_get_fail_4_1(data)                                          ((0x02000000&(data))>>25)
+#define VO_DRF_MBIST_OUT_fail_4_0_shift                                              (24)
+#define VO_DRF_MBIST_OUT_fail_4_0_mask                                               (0x01000000)
+#define VO_DRF_MBIST_OUT_fail_4_0(data)                                              (0x01000000&((data)<<24))
+#define VO_DRF_MBIST_OUT_fail_4_0_src(data)                                          ((0x01000000&(data))>>24)
+#define VO_DRF_MBIST_OUT_get_fail_4_0(data)                                          ((0x01000000&(data))>>24)
+#define VO_DRF_MBIST_OUT_fail_3_3_shift                                              (23)
+#define VO_DRF_MBIST_OUT_fail_3_3_mask                                               (0x00800000)
+#define VO_DRF_MBIST_OUT_fail_3_3(data)                                              (0x00800000&((data)<<23))
+#define VO_DRF_MBIST_OUT_fail_3_3_src(data)                                          ((0x00800000&(data))>>23)
+#define VO_DRF_MBIST_OUT_get_fail_3_3(data)                                          ((0x00800000&(data))>>23)
+#define VO_DRF_MBIST_OUT_fail_3_2_shift                                              (22)
+#define VO_DRF_MBIST_OUT_fail_3_2_mask                                               (0x00400000)
+#define VO_DRF_MBIST_OUT_fail_3_2(data)                                              (0x00400000&((data)<<22))
+#define VO_DRF_MBIST_OUT_fail_3_2_src(data)                                          ((0x00400000&(data))>>22)
+#define VO_DRF_MBIST_OUT_get_fail_3_2(data)                                          ((0x00400000&(data))>>22)
+#define VO_DRF_MBIST_OUT_fail_3_1_shift                                              (21)
+#define VO_DRF_MBIST_OUT_fail_3_1_mask                                               (0x00200000)
+#define VO_DRF_MBIST_OUT_fail_3_1(data)                                              (0x00200000&((data)<<21))
+#define VO_DRF_MBIST_OUT_fail_3_1_src(data)                                          ((0x00200000&(data))>>21)
+#define VO_DRF_MBIST_OUT_get_fail_3_1(data)                                          ((0x00200000&(data))>>21)
+#define VO_DRF_MBIST_OUT_fail_3_0_shift                                              (20)
+#define VO_DRF_MBIST_OUT_fail_3_0_mask                                               (0x00100000)
+#define VO_DRF_MBIST_OUT_fail_3_0(data)                                              (0x00100000&((data)<<20))
+#define VO_DRF_MBIST_OUT_fail_3_0_src(data)                                          ((0x00100000&(data))>>20)
+#define VO_DRF_MBIST_OUT_get_fail_3_0(data)                                          ((0x00100000&(data))>>20)
+#define VO_DRF_MBIST_OUT_fail_2_6_shift                                              (19)
+#define VO_DRF_MBIST_OUT_fail_2_6_mask                                               (0x00080000)
+#define VO_DRF_MBIST_OUT_fail_2_6(data)                                              (0x00080000&((data)<<19))
+#define VO_DRF_MBIST_OUT_fail_2_6_src(data)                                          ((0x00080000&(data))>>19)
+#define VO_DRF_MBIST_OUT_get_fail_2_6(data)                                          ((0x00080000&(data))>>19)
+#define VO_DRF_MBIST_OUT_fail_2_5_shift                                              (18)
+#define VO_DRF_MBIST_OUT_fail_2_5_mask                                               (0x00040000)
+#define VO_DRF_MBIST_OUT_fail_2_5(data)                                              (0x00040000&((data)<<18))
+#define VO_DRF_MBIST_OUT_fail_2_5_src(data)                                          ((0x00040000&(data))>>18)
+#define VO_DRF_MBIST_OUT_get_fail_2_5(data)                                          ((0x00040000&(data))>>18)
+#define VO_DRF_MBIST_OUT_fail_2_4_shift                                              (17)
+#define VO_DRF_MBIST_OUT_fail_2_4_mask                                               (0x00020000)
+#define VO_DRF_MBIST_OUT_fail_2_4(data)                                              (0x00020000&((data)<<17))
+#define VO_DRF_MBIST_OUT_fail_2_4_src(data)                                          ((0x00020000&(data))>>17)
+#define VO_DRF_MBIST_OUT_get_fail_2_4(data)                                          ((0x00020000&(data))>>17)
+#define VO_DRF_MBIST_OUT_fail_2_3_shift                                              (16)
+#define VO_DRF_MBIST_OUT_fail_2_3_mask                                               (0x00010000)
+#define VO_DRF_MBIST_OUT_fail_2_3(data)                                              (0x00010000&((data)<<16))
+#define VO_DRF_MBIST_OUT_fail_2_3_src(data)                                          ((0x00010000&(data))>>16)
+#define VO_DRF_MBIST_OUT_get_fail_2_3(data)                                          ((0x00010000&(data))>>16)
+#define VO_DRF_MBIST_OUT_fail_2_2_shift                                              (15)
+#define VO_DRF_MBIST_OUT_fail_2_2_mask                                               (0x00008000)
+#define VO_DRF_MBIST_OUT_fail_2_2(data)                                              (0x00008000&((data)<<15))
+#define VO_DRF_MBIST_OUT_fail_2_2_src(data)                                          ((0x00008000&(data))>>15)
+#define VO_DRF_MBIST_OUT_get_fail_2_2(data)                                          ((0x00008000&(data))>>15)
+#define VO_DRF_MBIST_OUT_fail_2_1_shift                                              (14)
+#define VO_DRF_MBIST_OUT_fail_2_1_mask                                               (0x00004000)
+#define VO_DRF_MBIST_OUT_fail_2_1(data)                                              (0x00004000&((data)<<14))
+#define VO_DRF_MBIST_OUT_fail_2_1_src(data)                                          ((0x00004000&(data))>>14)
+#define VO_DRF_MBIST_OUT_get_fail_2_1(data)                                          ((0x00004000&(data))>>14)
+#define VO_DRF_MBIST_OUT_fail_2_0_shift                                              (13)
+#define VO_DRF_MBIST_OUT_fail_2_0_mask                                               (0x00002000)
+#define VO_DRF_MBIST_OUT_fail_2_0(data)                                              (0x00002000&((data)<<13))
+#define VO_DRF_MBIST_OUT_fail_2_0_src(data)                                          ((0x00002000&(data))>>13)
+#define VO_DRF_MBIST_OUT_get_fail_2_0(data)                                          ((0x00002000&(data))>>13)
+#define VO_DRF_MBIST_OUT_fail_1_6_shift                                              (12)
+#define VO_DRF_MBIST_OUT_fail_1_6_mask                                               (0x00001000)
+#define VO_DRF_MBIST_OUT_fail_1_6(data)                                              (0x00001000&((data)<<12))
+#define VO_DRF_MBIST_OUT_fail_1_6_src(data)                                          ((0x00001000&(data))>>12)
+#define VO_DRF_MBIST_OUT_get_fail_1_6(data)                                          ((0x00001000&(data))>>12)
+#define VO_DRF_MBIST_OUT_fail_1_5_shift                                              (11)
+#define VO_DRF_MBIST_OUT_fail_1_5_mask                                               (0x00000800)
+#define VO_DRF_MBIST_OUT_fail_1_5(data)                                              (0x00000800&((data)<<11))
+#define VO_DRF_MBIST_OUT_fail_1_5_src(data)                                          ((0x00000800&(data))>>11)
+#define VO_DRF_MBIST_OUT_get_fail_1_5(data)                                          ((0x00000800&(data))>>11)
+#define VO_DRF_MBIST_OUT_fail_1_4_shift                                              (10)
+#define VO_DRF_MBIST_OUT_fail_1_4_mask                                               (0x00000400)
+#define VO_DRF_MBIST_OUT_fail_1_4(data)                                              (0x00000400&((data)<<10))
+#define VO_DRF_MBIST_OUT_fail_1_4_src(data)                                          ((0x00000400&(data))>>10)
+#define VO_DRF_MBIST_OUT_get_fail_1_4(data)                                          ((0x00000400&(data))>>10)
+#define VO_DRF_MBIST_OUT_fail_1_3_shift                                              (9)
+#define VO_DRF_MBIST_OUT_fail_1_3_mask                                               (0x00000200)
+#define VO_DRF_MBIST_OUT_fail_1_3(data)                                              (0x00000200&((data)<<9))
+#define VO_DRF_MBIST_OUT_fail_1_3_src(data)                                          ((0x00000200&(data))>>9)
+#define VO_DRF_MBIST_OUT_get_fail_1_3(data)                                          ((0x00000200&(data))>>9)
+#define VO_DRF_MBIST_OUT_fail_1_2_shift                                              (8)
+#define VO_DRF_MBIST_OUT_fail_1_2_mask                                               (0x00000100)
+#define VO_DRF_MBIST_OUT_fail_1_2(data)                                              (0x00000100&((data)<<8))
+#define VO_DRF_MBIST_OUT_fail_1_2_src(data)                                          ((0x00000100&(data))>>8)
+#define VO_DRF_MBIST_OUT_get_fail_1_2(data)                                          ((0x00000100&(data))>>8)
+#define VO_DRF_MBIST_OUT_fail_1_1_shift                                              (7)
+#define VO_DRF_MBIST_OUT_fail_1_1_mask                                               (0x00000080)
+#define VO_DRF_MBIST_OUT_fail_1_1(data)                                              (0x00000080&((data)<<7))
+#define VO_DRF_MBIST_OUT_fail_1_1_src(data)                                          ((0x00000080&(data))>>7)
+#define VO_DRF_MBIST_OUT_get_fail_1_1(data)                                          ((0x00000080&(data))>>7)
+#define VO_DRF_MBIST_OUT_fail_1_0_shift                                              (6)
+#define VO_DRF_MBIST_OUT_fail_1_0_mask                                               (0x00000040)
+#define VO_DRF_MBIST_OUT_fail_1_0(data)                                              (0x00000040&((data)<<6))
+#define VO_DRF_MBIST_OUT_fail_1_0_src(data)                                          ((0x00000040&(data))>>6)
+#define VO_DRF_MBIST_OUT_get_fail_1_0(data)                                          ((0x00000040&(data))>>6)
+#define VO_DRF_MBIST_OUT_done_5_shift                                                (4)
+#define VO_DRF_MBIST_OUT_done_5_mask                                                 (0x00000010)
+#define VO_DRF_MBIST_OUT_done_5(data)                                                (0x00000010&((data)<<4))
+#define VO_DRF_MBIST_OUT_done_5_src(data)                                            ((0x00000010&(data))>>4)
+#define VO_DRF_MBIST_OUT_get_done_5(data)                                            ((0x00000010&(data))>>4)
+#define VO_DRF_MBIST_OUT_done_4_shift                                                (3)
+#define VO_DRF_MBIST_OUT_done_4_mask                                                 (0x00000008)
+#define VO_DRF_MBIST_OUT_done_4(data)                                                (0x00000008&((data)<<3))
+#define VO_DRF_MBIST_OUT_done_4_src(data)                                            ((0x00000008&(data))>>3)
+#define VO_DRF_MBIST_OUT_get_done_4(data)                                            ((0x00000008&(data))>>3)
+#define VO_DRF_MBIST_OUT_done_3_shift                                                (2)
+#define VO_DRF_MBIST_OUT_done_3_mask                                                 (0x00000004)
+#define VO_DRF_MBIST_OUT_done_3(data)                                                (0x00000004&((data)<<2))
+#define VO_DRF_MBIST_OUT_done_3_src(data)                                            ((0x00000004&(data))>>2)
+#define VO_DRF_MBIST_OUT_get_done_3(data)                                            ((0x00000004&(data))>>2)
+#define VO_DRF_MBIST_OUT_done_2_shift                                                (1)
+#define VO_DRF_MBIST_OUT_done_2_mask                                                 (0x00000002)
+#define VO_DRF_MBIST_OUT_done_2(data)                                                (0x00000002&((data)<<1))
+#define VO_DRF_MBIST_OUT_done_2_src(data)                                            ((0x00000002&(data))>>1)
+#define VO_DRF_MBIST_OUT_get_done_2(data)                                            ((0x00000002&(data))>>1)
+#define VO_DRF_MBIST_OUT_done_1_shift                                                (0)
+#define VO_DRF_MBIST_OUT_done_1_mask                                                 (0x00000001)
+#define VO_DRF_MBIST_OUT_done_1(data)                                                (0x00000001&((data)<<0))
+#define VO_DRF_MBIST_OUT_done_1_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_DRF_MBIST_OUT_get_done_1(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VO_DRF_MBIST_OUT_1                                                           0x98005F0C
+#define VO_DRF_MBIST_OUT_1_reg_addr                                                  "0xD8005F0C"
+#define VO_DRF_MBIST_OUT_1_reg                                                       0xD8005F0C
+#define set_VO_DRF_MBIST_OUT_1_reg(data)   (*((volatile unsigned int*) VO_DRF_MBIST_OUT_1_reg)=data)
+#define get_VO_DRF_MBIST_OUT_1_reg   (*((volatile unsigned int*) VO_DRF_MBIST_OUT_1_reg))
+#define VO_DRF_MBIST_OUT_1_inst_adr                                                  "0x00C3"
+#define VO_DRF_MBIST_OUT_1_inst                                                      0x00C3
+#define VO_DRF_MBIST_OUT_1_fail_9_9_shift                                            (29)
+#define VO_DRF_MBIST_OUT_1_fail_9_9_mask                                             (0x20000000)
+#define VO_DRF_MBIST_OUT_1_fail_9_9(data)                                            (0x20000000&((data)<<29))
+#define VO_DRF_MBIST_OUT_1_fail_9_9_src(data)                                        ((0x20000000&(data))>>29)
+#define VO_DRF_MBIST_OUT_1_get_fail_9_9(data)                                        ((0x20000000&(data))>>29)
+#define VO_DRF_MBIST_OUT_1_fail_9_8_shift                                            (28)
+#define VO_DRF_MBIST_OUT_1_fail_9_8_mask                                             (0x10000000)
+#define VO_DRF_MBIST_OUT_1_fail_9_8(data)                                            (0x10000000&((data)<<28))
+#define VO_DRF_MBIST_OUT_1_fail_9_8_src(data)                                        ((0x10000000&(data))>>28)
+#define VO_DRF_MBIST_OUT_1_get_fail_9_8(data)                                        ((0x10000000&(data))>>28)
+#define VO_DRF_MBIST_OUT_1_fail_9_7_shift                                            (27)
+#define VO_DRF_MBIST_OUT_1_fail_9_7_mask                                             (0x08000000)
+#define VO_DRF_MBIST_OUT_1_fail_9_7(data)                                            (0x08000000&((data)<<27))
+#define VO_DRF_MBIST_OUT_1_fail_9_7_src(data)                                        ((0x08000000&(data))>>27)
+#define VO_DRF_MBIST_OUT_1_get_fail_9_7(data)                                        ((0x08000000&(data))>>27)
+#define VO_DRF_MBIST_OUT_1_fail_9_6_shift                                            (26)
+#define VO_DRF_MBIST_OUT_1_fail_9_6_mask                                             (0x04000000)
+#define VO_DRF_MBIST_OUT_1_fail_9_6(data)                                            (0x04000000&((data)<<26))
+#define VO_DRF_MBIST_OUT_1_fail_9_6_src(data)                                        ((0x04000000&(data))>>26)
+#define VO_DRF_MBIST_OUT_1_get_fail_9_6(data)                                        ((0x04000000&(data))>>26)
+#define VO_DRF_MBIST_OUT_1_fail_9_5_shift                                            (25)
+#define VO_DRF_MBIST_OUT_1_fail_9_5_mask                                             (0x02000000)
+#define VO_DRF_MBIST_OUT_1_fail_9_5(data)                                            (0x02000000&((data)<<25))
+#define VO_DRF_MBIST_OUT_1_fail_9_5_src(data)                                        ((0x02000000&(data))>>25)
+#define VO_DRF_MBIST_OUT_1_get_fail_9_5(data)                                        ((0x02000000&(data))>>25)
+#define VO_DRF_MBIST_OUT_1_fail_9_4_shift                                            (24)
+#define VO_DRF_MBIST_OUT_1_fail_9_4_mask                                             (0x01000000)
+#define VO_DRF_MBIST_OUT_1_fail_9_4(data)                                            (0x01000000&((data)<<24))
+#define VO_DRF_MBIST_OUT_1_fail_9_4_src(data)                                        ((0x01000000&(data))>>24)
+#define VO_DRF_MBIST_OUT_1_get_fail_9_4(data)                                        ((0x01000000&(data))>>24)
+#define VO_DRF_MBIST_OUT_1_fail_9_3_shift                                            (23)
+#define VO_DRF_MBIST_OUT_1_fail_9_3_mask                                             (0x00800000)
+#define VO_DRF_MBIST_OUT_1_fail_9_3(data)                                            (0x00800000&((data)<<23))
+#define VO_DRF_MBIST_OUT_1_fail_9_3_src(data)                                        ((0x00800000&(data))>>23)
+#define VO_DRF_MBIST_OUT_1_get_fail_9_3(data)                                        ((0x00800000&(data))>>23)
+#define VO_DRF_MBIST_OUT_1_fail_9_2_shift                                            (22)
+#define VO_DRF_MBIST_OUT_1_fail_9_2_mask                                             (0x00400000)
+#define VO_DRF_MBIST_OUT_1_fail_9_2(data)                                            (0x00400000&((data)<<22))
+#define VO_DRF_MBIST_OUT_1_fail_9_2_src(data)                                        ((0x00400000&(data))>>22)
+#define VO_DRF_MBIST_OUT_1_get_fail_9_2(data)                                        ((0x00400000&(data))>>22)
+#define VO_DRF_MBIST_OUT_1_fail_9_1_shift                                            (21)
+#define VO_DRF_MBIST_OUT_1_fail_9_1_mask                                             (0x00200000)
+#define VO_DRF_MBIST_OUT_1_fail_9_1(data)                                            (0x00200000&((data)<<21))
+#define VO_DRF_MBIST_OUT_1_fail_9_1_src(data)                                        ((0x00200000&(data))>>21)
+#define VO_DRF_MBIST_OUT_1_get_fail_9_1(data)                                        ((0x00200000&(data))>>21)
+#define VO_DRF_MBIST_OUT_1_fail_9_0_shift                                            (20)
+#define VO_DRF_MBIST_OUT_1_fail_9_0_mask                                             (0x00100000)
+#define VO_DRF_MBIST_OUT_1_fail_9_0(data)                                            (0x00100000&((data)<<20))
+#define VO_DRF_MBIST_OUT_1_fail_9_0_src(data)                                        ((0x00100000&(data))>>20)
+#define VO_DRF_MBIST_OUT_1_get_fail_9_0(data)                                        ((0x00100000&(data))>>20)
+#define VO_DRF_MBIST_OUT_1_fail_8_3_shift                                            (19)
+#define VO_DRF_MBIST_OUT_1_fail_8_3_mask                                             (0x00080000)
+#define VO_DRF_MBIST_OUT_1_fail_8_3(data)                                            (0x00080000&((data)<<19))
+#define VO_DRF_MBIST_OUT_1_fail_8_3_src(data)                                        ((0x00080000&(data))>>19)
+#define VO_DRF_MBIST_OUT_1_get_fail_8_3(data)                                        ((0x00080000&(data))>>19)
+#define VO_DRF_MBIST_OUT_1_fail_8_2_shift                                            (18)
+#define VO_DRF_MBIST_OUT_1_fail_8_2_mask                                             (0x00040000)
+#define VO_DRF_MBIST_OUT_1_fail_8_2(data)                                            (0x00040000&((data)<<18))
+#define VO_DRF_MBIST_OUT_1_fail_8_2_src(data)                                        ((0x00040000&(data))>>18)
+#define VO_DRF_MBIST_OUT_1_get_fail_8_2(data)                                        ((0x00040000&(data))>>18)
+#define VO_DRF_MBIST_OUT_1_fail_8_1_shift                                            (17)
+#define VO_DRF_MBIST_OUT_1_fail_8_1_mask                                             (0x00020000)
+#define VO_DRF_MBIST_OUT_1_fail_8_1(data)                                            (0x00020000&((data)<<17))
+#define VO_DRF_MBIST_OUT_1_fail_8_1_src(data)                                        ((0x00020000&(data))>>17)
+#define VO_DRF_MBIST_OUT_1_get_fail_8_1(data)                                        ((0x00020000&(data))>>17)
+#define VO_DRF_MBIST_OUT_1_fail_8_0_shift                                            (16)
+#define VO_DRF_MBIST_OUT_1_fail_8_0_mask                                             (0x00010000)
+#define VO_DRF_MBIST_OUT_1_fail_8_0(data)                                            (0x00010000&((data)<<16))
+#define VO_DRF_MBIST_OUT_1_fail_8_0_src(data)                                        ((0x00010000&(data))>>16)
+#define VO_DRF_MBIST_OUT_1_get_fail_8_0(data)                                        ((0x00010000&(data))>>16)
+#define VO_DRF_MBIST_OUT_1_fail_7_3_shift                                            (15)
+#define VO_DRF_MBIST_OUT_1_fail_7_3_mask                                             (0x00008000)
+#define VO_DRF_MBIST_OUT_1_fail_7_3(data)                                            (0x00008000&((data)<<15))
+#define VO_DRF_MBIST_OUT_1_fail_7_3_src(data)                                        ((0x00008000&(data))>>15)
+#define VO_DRF_MBIST_OUT_1_get_fail_7_3(data)                                        ((0x00008000&(data))>>15)
+#define VO_DRF_MBIST_OUT_1_fail_7_2_shift                                            (14)
+#define VO_DRF_MBIST_OUT_1_fail_7_2_mask                                             (0x00004000)
+#define VO_DRF_MBIST_OUT_1_fail_7_2(data)                                            (0x00004000&((data)<<14))
+#define VO_DRF_MBIST_OUT_1_fail_7_2_src(data)                                        ((0x00004000&(data))>>14)
+#define VO_DRF_MBIST_OUT_1_get_fail_7_2(data)                                        ((0x00004000&(data))>>14)
+#define VO_DRF_MBIST_OUT_1_fail_7_1_shift                                            (13)
+#define VO_DRF_MBIST_OUT_1_fail_7_1_mask                                             (0x00002000)
+#define VO_DRF_MBIST_OUT_1_fail_7_1(data)                                            (0x00002000&((data)<<13))
+#define VO_DRF_MBIST_OUT_1_fail_7_1_src(data)                                        ((0x00002000&(data))>>13)
+#define VO_DRF_MBIST_OUT_1_get_fail_7_1(data)                                        ((0x00002000&(data))>>13)
+#define VO_DRF_MBIST_OUT_1_fail_7_0_shift                                            (12)
+#define VO_DRF_MBIST_OUT_1_fail_7_0_mask                                             (0x00001000)
+#define VO_DRF_MBIST_OUT_1_fail_7_0(data)                                            (0x00001000&((data)<<12))
+#define VO_DRF_MBIST_OUT_1_fail_7_0_src(data)                                        ((0x00001000&(data))>>12)
+#define VO_DRF_MBIST_OUT_1_get_fail_7_0(data)                                        ((0x00001000&(data))>>12)
+#define VO_DRF_MBIST_OUT_1_fail_6_3_shift                                            (11)
+#define VO_DRF_MBIST_OUT_1_fail_6_3_mask                                             (0x00000800)
+#define VO_DRF_MBIST_OUT_1_fail_6_3(data)                                            (0x00000800&((data)<<11))
+#define VO_DRF_MBIST_OUT_1_fail_6_3_src(data)                                        ((0x00000800&(data))>>11)
+#define VO_DRF_MBIST_OUT_1_get_fail_6_3(data)                                        ((0x00000800&(data))>>11)
+#define VO_DRF_MBIST_OUT_1_fail_6_2_shift                                            (10)
+#define VO_DRF_MBIST_OUT_1_fail_6_2_mask                                             (0x00000400)
+#define VO_DRF_MBIST_OUT_1_fail_6_2(data)                                            (0x00000400&((data)<<10))
+#define VO_DRF_MBIST_OUT_1_fail_6_2_src(data)                                        ((0x00000400&(data))>>10)
+#define VO_DRF_MBIST_OUT_1_get_fail_6_2(data)                                        ((0x00000400&(data))>>10)
+#define VO_DRF_MBIST_OUT_1_fail_6_1_shift                                            (9)
+#define VO_DRF_MBIST_OUT_1_fail_6_1_mask                                             (0x00000200)
+#define VO_DRF_MBIST_OUT_1_fail_6_1(data)                                            (0x00000200&((data)<<9))
+#define VO_DRF_MBIST_OUT_1_fail_6_1_src(data)                                        ((0x00000200&(data))>>9)
+#define VO_DRF_MBIST_OUT_1_get_fail_6_1(data)                                        ((0x00000200&(data))>>9)
+#define VO_DRF_MBIST_OUT_1_fail_6_0_shift                                            (8)
+#define VO_DRF_MBIST_OUT_1_fail_6_0_mask                                             (0x00000100)
+#define VO_DRF_MBIST_OUT_1_fail_6_0(data)                                            (0x00000100&((data)<<8))
+#define VO_DRF_MBIST_OUT_1_fail_6_0_src(data)                                        ((0x00000100&(data))>>8)
+#define VO_DRF_MBIST_OUT_1_get_fail_6_0(data)                                        ((0x00000100&(data))>>8)
+#define VO_DRF_MBIST_OUT_1_fail_4_6_shift                                            (7)
+#define VO_DRF_MBIST_OUT_1_fail_4_6_mask                                             (0x00000080)
+#define VO_DRF_MBIST_OUT_1_fail_4_6(data)                                            (0x00000080&((data)<<7))
+#define VO_DRF_MBIST_OUT_1_fail_4_6_src(data)                                        ((0x00000080&(data))>>7)
+#define VO_DRF_MBIST_OUT_1_get_fail_4_6(data)                                        ((0x00000080&(data))>>7)
+#define VO_DRF_MBIST_OUT_1_fail_4_5_shift                                            (6)
+#define VO_DRF_MBIST_OUT_1_fail_4_5_mask                                             (0x00000040)
+#define VO_DRF_MBIST_OUT_1_fail_4_5(data)                                            (0x00000040&((data)<<6))
+#define VO_DRF_MBIST_OUT_1_fail_4_5_src(data)                                        ((0x00000040&(data))>>6)
+#define VO_DRF_MBIST_OUT_1_get_fail_4_5(data)                                        ((0x00000040&(data))>>6)
+#define VO_DRF_MBIST_OUT_1_done_9_shift                                              (3)
+#define VO_DRF_MBIST_OUT_1_done_9_mask                                               (0x00000008)
+#define VO_DRF_MBIST_OUT_1_done_9(data)                                              (0x00000008&((data)<<3))
+#define VO_DRF_MBIST_OUT_1_done_9_src(data)                                          ((0x00000008&(data))>>3)
+#define VO_DRF_MBIST_OUT_1_get_done_9(data)                                          ((0x00000008&(data))>>3)
+#define VO_DRF_MBIST_OUT_1_done_8_shift                                              (2)
+#define VO_DRF_MBIST_OUT_1_done_8_mask                                               (0x00000004)
+#define VO_DRF_MBIST_OUT_1_done_8(data)                                              (0x00000004&((data)<<2))
+#define VO_DRF_MBIST_OUT_1_done_8_src(data)                                          ((0x00000004&(data))>>2)
+#define VO_DRF_MBIST_OUT_1_get_done_8(data)                                          ((0x00000004&(data))>>2)
+#define VO_DRF_MBIST_OUT_1_done_7_shift                                              (1)
+#define VO_DRF_MBIST_OUT_1_done_7_mask                                               (0x00000002)
+#define VO_DRF_MBIST_OUT_1_done_7(data)                                              (0x00000002&((data)<<1))
+#define VO_DRF_MBIST_OUT_1_done_7_src(data)                                          ((0x00000002&(data))>>1)
+#define VO_DRF_MBIST_OUT_1_get_done_7(data)                                          ((0x00000002&(data))>>1)
+#define VO_DRF_MBIST_OUT_1_done_6_shift                                              (0)
+#define VO_DRF_MBIST_OUT_1_done_6_mask                                               (0x00000001)
+#define VO_DRF_MBIST_OUT_1_done_6(data)                                              (0x00000001&((data)<<0))
+#define VO_DRF_MBIST_OUT_1_done_6_src(data)                                          ((0x00000001&(data))>>0)
+#define VO_DRF_MBIST_OUT_1_get_done_6(data)                                          ((0x00000001&(data))>>0)
+
+
+#define VO_DRF_MBIST_OUT_2                                                           0x98005F10
+#define VO_DRF_MBIST_OUT_2_reg_addr                                                  "0xD8005F10"
+#define VO_DRF_MBIST_OUT_2_reg                                                       0xD8005F10
+#define set_VO_DRF_MBIST_OUT_2_reg(data)   (*((volatile unsigned int*) VO_DRF_MBIST_OUT_2_reg)=data)
+#define get_VO_DRF_MBIST_OUT_2_reg   (*((volatile unsigned int*) VO_DRF_MBIST_OUT_2_reg))
+#define VO_DRF_MBIST_OUT_2_inst_adr                                                  "0x00C4"
+#define VO_DRF_MBIST_OUT_2_inst                                                      0x00C4
+#define VO_DRF_MBIST_OUT_2_fail_15_2_shift                                           (29)
+#define VO_DRF_MBIST_OUT_2_fail_15_2_mask                                            (0x20000000)
+#define VO_DRF_MBIST_OUT_2_fail_15_2(data)                                           (0x20000000&((data)<<29))
+#define VO_DRF_MBIST_OUT_2_fail_15_2_src(data)                                       ((0x20000000&(data))>>29)
+#define VO_DRF_MBIST_OUT_2_get_fail_15_2(data)                                       ((0x20000000&(data))>>29)
+#define VO_DRF_MBIST_OUT_2_fail_15_1_shift                                           (28)
+#define VO_DRF_MBIST_OUT_2_fail_15_1_mask                                            (0x10000000)
+#define VO_DRF_MBIST_OUT_2_fail_15_1(data)                                           (0x10000000&((data)<<28))
+#define VO_DRF_MBIST_OUT_2_fail_15_1_src(data)                                       ((0x10000000&(data))>>28)
+#define VO_DRF_MBIST_OUT_2_get_fail_15_1(data)                                       ((0x10000000&(data))>>28)
+#define VO_DRF_MBIST_OUT_2_fail_15_0_shift                                           (27)
+#define VO_DRF_MBIST_OUT_2_fail_15_0_mask                                            (0x08000000)
+#define VO_DRF_MBIST_OUT_2_fail_15_0(data)                                           (0x08000000&((data)<<27))
+#define VO_DRF_MBIST_OUT_2_fail_15_0_src(data)                                       ((0x08000000&(data))>>27)
+#define VO_DRF_MBIST_OUT_2_get_fail_15_0(data)                                       ((0x08000000&(data))>>27)
+#define VO_DRF_MBIST_OUT_2_fail_14_2_shift                                           (26)
+#define VO_DRF_MBIST_OUT_2_fail_14_2_mask                                            (0x04000000)
+#define VO_DRF_MBIST_OUT_2_fail_14_2(data)                                           (0x04000000&((data)<<26))
+#define VO_DRF_MBIST_OUT_2_fail_14_2_src(data)                                       ((0x04000000&(data))>>26)
+#define VO_DRF_MBIST_OUT_2_get_fail_14_2(data)                                       ((0x04000000&(data))>>26)
+#define VO_DRF_MBIST_OUT_2_fail_14_1_shift                                           (25)
+#define VO_DRF_MBIST_OUT_2_fail_14_1_mask                                            (0x02000000)
+#define VO_DRF_MBIST_OUT_2_fail_14_1(data)                                           (0x02000000&((data)<<25))
+#define VO_DRF_MBIST_OUT_2_fail_14_1_src(data)                                       ((0x02000000&(data))>>25)
+#define VO_DRF_MBIST_OUT_2_get_fail_14_1(data)                                       ((0x02000000&(data))>>25)
+#define VO_DRF_MBIST_OUT_2_fail_14_0_shift                                           (24)
+#define VO_DRF_MBIST_OUT_2_fail_14_0_mask                                            (0x01000000)
+#define VO_DRF_MBIST_OUT_2_fail_14_0(data)                                           (0x01000000&((data)<<24))
+#define VO_DRF_MBIST_OUT_2_fail_14_0_src(data)                                       ((0x01000000&(data))>>24)
+#define VO_DRF_MBIST_OUT_2_get_fail_14_0(data)                                       ((0x01000000&(data))>>24)
+#define VO_DRF_MBIST_OUT_2_fail_13_5_shift                                           (23)
+#define VO_DRF_MBIST_OUT_2_fail_13_5_mask                                            (0x00800000)
+#define VO_DRF_MBIST_OUT_2_fail_13_5(data)                                           (0x00800000&((data)<<23))
+#define VO_DRF_MBIST_OUT_2_fail_13_5_src(data)                                       ((0x00800000&(data))>>23)
+#define VO_DRF_MBIST_OUT_2_get_fail_13_5(data)                                       ((0x00800000&(data))>>23)
+#define VO_DRF_MBIST_OUT_2_fail_13_4_shift                                           (22)
+#define VO_DRF_MBIST_OUT_2_fail_13_4_mask                                            (0x00400000)
+#define VO_DRF_MBIST_OUT_2_fail_13_4(data)                                           (0x00400000&((data)<<22))
+#define VO_DRF_MBIST_OUT_2_fail_13_4_src(data)                                       ((0x00400000&(data))>>22)
+#define VO_DRF_MBIST_OUT_2_get_fail_13_4(data)                                       ((0x00400000&(data))>>22)
+#define VO_DRF_MBIST_OUT_2_fail_13_3_shift                                           (21)
+#define VO_DRF_MBIST_OUT_2_fail_13_3_mask                                            (0x00200000)
+#define VO_DRF_MBIST_OUT_2_fail_13_3(data)                                           (0x00200000&((data)<<21))
+#define VO_DRF_MBIST_OUT_2_fail_13_3_src(data)                                       ((0x00200000&(data))>>21)
+#define VO_DRF_MBIST_OUT_2_get_fail_13_3(data)                                       ((0x00200000&(data))>>21)
+#define VO_DRF_MBIST_OUT_2_fail_13_2_shift                                           (20)
+#define VO_DRF_MBIST_OUT_2_fail_13_2_mask                                            (0x00100000)
+#define VO_DRF_MBIST_OUT_2_fail_13_2(data)                                           (0x00100000&((data)<<20))
+#define VO_DRF_MBIST_OUT_2_fail_13_2_src(data)                                       ((0x00100000&(data))>>20)
+#define VO_DRF_MBIST_OUT_2_get_fail_13_2(data)                                       ((0x00100000&(data))>>20)
+#define VO_DRF_MBIST_OUT_2_fail_13_1_shift                                           (19)
+#define VO_DRF_MBIST_OUT_2_fail_13_1_mask                                            (0x00080000)
+#define VO_DRF_MBIST_OUT_2_fail_13_1(data)                                           (0x00080000&((data)<<19))
+#define VO_DRF_MBIST_OUT_2_fail_13_1_src(data)                                       ((0x00080000&(data))>>19)
+#define VO_DRF_MBIST_OUT_2_get_fail_13_1(data)                                       ((0x00080000&(data))>>19)
+#define VO_DRF_MBIST_OUT_2_fail_13_0_shift                                           (18)
+#define VO_DRF_MBIST_OUT_2_fail_13_0_mask                                            (0x00040000)
+#define VO_DRF_MBIST_OUT_2_fail_13_0(data)                                           (0x00040000&((data)<<18))
+#define VO_DRF_MBIST_OUT_2_fail_13_0_src(data)                                       ((0x00040000&(data))>>18)
+#define VO_DRF_MBIST_OUT_2_get_fail_13_0(data)                                       ((0x00040000&(data))>>18)
+#define VO_DRF_MBIST_OUT_2_fail_12_1_shift                                           (17)
+#define VO_DRF_MBIST_OUT_2_fail_12_1_mask                                            (0x00020000)
+#define VO_DRF_MBIST_OUT_2_fail_12_1(data)                                           (0x00020000&((data)<<17))
+#define VO_DRF_MBIST_OUT_2_fail_12_1_src(data)                                       ((0x00020000&(data))>>17)
+#define VO_DRF_MBIST_OUT_2_get_fail_12_1(data)                                       ((0x00020000&(data))>>17)
+#define VO_DRF_MBIST_OUT_2_fail_12_0_shift                                           (16)
+#define VO_DRF_MBIST_OUT_2_fail_12_0_mask                                            (0x00010000)
+#define VO_DRF_MBIST_OUT_2_fail_12_0(data)                                           (0x00010000&((data)<<16))
+#define VO_DRF_MBIST_OUT_2_fail_12_0_src(data)                                       ((0x00010000&(data))>>16)
+#define VO_DRF_MBIST_OUT_2_get_fail_12_0(data)                                       ((0x00010000&(data))>>16)
+#define VO_DRF_MBIST_OUT_2_fail_11_5_shift                                           (15)
+#define VO_DRF_MBIST_OUT_2_fail_11_5_mask                                            (0x00008000)
+#define VO_DRF_MBIST_OUT_2_fail_11_5(data)                                           (0x00008000&((data)<<15))
+#define VO_DRF_MBIST_OUT_2_fail_11_5_src(data)                                       ((0x00008000&(data))>>15)
+#define VO_DRF_MBIST_OUT_2_get_fail_11_5(data)                                       ((0x00008000&(data))>>15)
+#define VO_DRF_MBIST_OUT_2_fail_11_4_shift                                           (14)
+#define VO_DRF_MBIST_OUT_2_fail_11_4_mask                                            (0x00004000)
+#define VO_DRF_MBIST_OUT_2_fail_11_4(data)                                           (0x00004000&((data)<<14))
+#define VO_DRF_MBIST_OUT_2_fail_11_4_src(data)                                       ((0x00004000&(data))>>14)
+#define VO_DRF_MBIST_OUT_2_get_fail_11_4(data)                                       ((0x00004000&(data))>>14)
+#define VO_DRF_MBIST_OUT_2_fail_11_3_shift                                           (13)
+#define VO_DRF_MBIST_OUT_2_fail_11_3_mask                                            (0x00002000)
+#define VO_DRF_MBIST_OUT_2_fail_11_3(data)                                           (0x00002000&((data)<<13))
+#define VO_DRF_MBIST_OUT_2_fail_11_3_src(data)                                       ((0x00002000&(data))>>13)
+#define VO_DRF_MBIST_OUT_2_get_fail_11_3(data)                                       ((0x00002000&(data))>>13)
+#define VO_DRF_MBIST_OUT_2_fail_11_2_shift                                           (12)
+#define VO_DRF_MBIST_OUT_2_fail_11_2_mask                                            (0x00001000)
+#define VO_DRF_MBIST_OUT_2_fail_11_2(data)                                           (0x00001000&((data)<<12))
+#define VO_DRF_MBIST_OUT_2_fail_11_2_src(data)                                       ((0x00001000&(data))>>12)
+#define VO_DRF_MBIST_OUT_2_get_fail_11_2(data)                                       ((0x00001000&(data))>>12)
+#define VO_DRF_MBIST_OUT_2_fail_11_1_shift                                           (11)
+#define VO_DRF_MBIST_OUT_2_fail_11_1_mask                                            (0x00000800)
+#define VO_DRF_MBIST_OUT_2_fail_11_1(data)                                           (0x00000800&((data)<<11))
+#define VO_DRF_MBIST_OUT_2_fail_11_1_src(data)                                       ((0x00000800&(data))>>11)
+#define VO_DRF_MBIST_OUT_2_get_fail_11_1(data)                                       ((0x00000800&(data))>>11)
+#define VO_DRF_MBIST_OUT_2_fail_11_0_shift                                           (10)
+#define VO_DRF_MBIST_OUT_2_fail_11_0_mask                                            (0x00000400)
+#define VO_DRF_MBIST_OUT_2_fail_11_0(data)                                           (0x00000400&((data)<<10))
+#define VO_DRF_MBIST_OUT_2_fail_11_0_src(data)                                       ((0x00000400&(data))>>10)
+#define VO_DRF_MBIST_OUT_2_get_fail_11_0(data)                                       ((0x00000400&(data))>>10)
+#define VO_DRF_MBIST_OUT_2_fail_10_1_shift                                           (9)
+#define VO_DRF_MBIST_OUT_2_fail_10_1_mask                                            (0x00000200)
+#define VO_DRF_MBIST_OUT_2_fail_10_1(data)                                           (0x00000200&((data)<<9))
+#define VO_DRF_MBIST_OUT_2_fail_10_1_src(data)                                       ((0x00000200&(data))>>9)
+#define VO_DRF_MBIST_OUT_2_get_fail_10_1(data)                                       ((0x00000200&(data))>>9)
+#define VO_DRF_MBIST_OUT_2_fail_10_0_shift                                           (8)
+#define VO_DRF_MBIST_OUT_2_fail_10_0_mask                                            (0x00000100)
+#define VO_DRF_MBIST_OUT_2_fail_10_0(data)                                           (0x00000100&((data)<<8))
+#define VO_DRF_MBIST_OUT_2_fail_10_0_src(data)                                       ((0x00000100&(data))>>8)
+#define VO_DRF_MBIST_OUT_2_get_fail_10_0(data)                                       ((0x00000100&(data))>>8)
+#define VO_DRF_MBIST_OUT_2_done_15_shift                                             (5)
+#define VO_DRF_MBIST_OUT_2_done_15_mask                                              (0x00000020)
+#define VO_DRF_MBIST_OUT_2_done_15(data)                                             (0x00000020&((data)<<5))
+#define VO_DRF_MBIST_OUT_2_done_15_src(data)                                         ((0x00000020&(data))>>5)
+#define VO_DRF_MBIST_OUT_2_get_done_15(data)                                         ((0x00000020&(data))>>5)
+#define VO_DRF_MBIST_OUT_2_done_14_shift                                             (4)
+#define VO_DRF_MBIST_OUT_2_done_14_mask                                              (0x00000010)
+#define VO_DRF_MBIST_OUT_2_done_14(data)                                             (0x00000010&((data)<<4))
+#define VO_DRF_MBIST_OUT_2_done_14_src(data)                                         ((0x00000010&(data))>>4)
+#define VO_DRF_MBIST_OUT_2_get_done_14(data)                                         ((0x00000010&(data))>>4)
+#define VO_DRF_MBIST_OUT_2_done_13_shift                                             (3)
+#define VO_DRF_MBIST_OUT_2_done_13_mask                                              (0x00000008)
+#define VO_DRF_MBIST_OUT_2_done_13(data)                                             (0x00000008&((data)<<3))
+#define VO_DRF_MBIST_OUT_2_done_13_src(data)                                         ((0x00000008&(data))>>3)
+#define VO_DRF_MBIST_OUT_2_get_done_13(data)                                         ((0x00000008&(data))>>3)
+#define VO_DRF_MBIST_OUT_2_done_12_shift                                             (2)
+#define VO_DRF_MBIST_OUT_2_done_12_mask                                              (0x00000004)
+#define VO_DRF_MBIST_OUT_2_done_12(data)                                             (0x00000004&((data)<<2))
+#define VO_DRF_MBIST_OUT_2_done_12_src(data)                                         ((0x00000004&(data))>>2)
+#define VO_DRF_MBIST_OUT_2_get_done_12(data)                                         ((0x00000004&(data))>>2)
+#define VO_DRF_MBIST_OUT_2_done_11_shift                                             (1)
+#define VO_DRF_MBIST_OUT_2_done_11_mask                                              (0x00000002)
+#define VO_DRF_MBIST_OUT_2_done_11(data)                                             (0x00000002&((data)<<1))
+#define VO_DRF_MBIST_OUT_2_done_11_src(data)                                         ((0x00000002&(data))>>1)
+#define VO_DRF_MBIST_OUT_2_get_done_11(data)                                         ((0x00000002&(data))>>1)
+#define VO_DRF_MBIST_OUT_2_done_10_shift                                             (0)
+#define VO_DRF_MBIST_OUT_2_done_10_mask                                              (0x00000001)
+#define VO_DRF_MBIST_OUT_2_done_10(data)                                             (0x00000001&((data)<<0))
+#define VO_DRF_MBIST_OUT_2_done_10_src(data)                                         ((0x00000001&(data))>>0)
+#define VO_DRF_MBIST_OUT_2_get_done_10(data)                                         ((0x00000001&(data))>>0)
+
+
+#define VO_SRAM_LS                                                                   0x98005F14
+#define VO_SRAM_LS_reg_addr                                                          "0xD8005F14"
+#define VO_SRAM_LS_reg                                                               0xD8005F14
+#define set_VO_SRAM_LS_reg(data)   (*((volatile unsigned int*) VO_SRAM_LS_reg)=data)
+#define get_VO_SRAM_LS_reg   (*((volatile unsigned int*) VO_SRAM_LS_reg))
+#define VO_SRAM_LS_inst_adr                                                          "0x00C5"
+#define VO_SRAM_LS_inst                                                              0x00C5
+#define VO_SRAM_LS_afbc_shift                                                        (9)
+#define VO_SRAM_LS_afbc_mask                                                         (0x00000200)
+#define VO_SRAM_LS_afbc(data)                                                        (0x00000200&((data)<<9))
+#define VO_SRAM_LS_afbc_src(data)                                                    ((0x00000200&(data))>>9)
+#define VO_SRAM_LS_get_afbc(data)                                                    ((0x00000200&(data))>>9)
+#define VO_SRAM_LS_sub2_shift                                                        (8)
+#define VO_SRAM_LS_sub2_mask                                                         (0x00000100)
+#define VO_SRAM_LS_sub2(data)                                                        (0x00000100&((data)<<8))
+#define VO_SRAM_LS_sub2_src(data)                                                    ((0x00000100&(data))>>8)
+#define VO_SRAM_LS_get_sub2(data)                                                    ((0x00000100&(data))>>8)
+#define VO_SRAM_LS_wb2_shift                                                         (7)
+#define VO_SRAM_LS_wb2_mask                                                          (0x00000080)
+#define VO_SRAM_LS_wb2(data)                                                         (0x00000080&((data)<<7))
+#define VO_SRAM_LS_wb2_src(data)                                                     ((0x00000080&(data))>>7)
+#define VO_SRAM_LS_get_wb2(data)                                                     ((0x00000080&(data))>>7)
+#define VO_SRAM_LS_csr_shift                                                         (6)
+#define VO_SRAM_LS_csr_mask                                                          (0x00000040)
+#define VO_SRAM_LS_csr(data)                                                         (0x00000040&((data)<<6))
+#define VO_SRAM_LS_csr_src(data)                                                     ((0x00000040&(data))>>6)
+#define VO_SRAM_LS_get_csr(data)                                                     ((0x00000040&(data))>>6)
+#define VO_SRAM_LS_v2_shift                                                          (5)
+#define VO_SRAM_LS_v2_mask                                                           (0x00000020)
+#define VO_SRAM_LS_v2(data)                                                          (0x00000020&((data)<<5))
+#define VO_SRAM_LS_v2_src(data)                                                      ((0x00000020&(data))>>5)
+#define VO_SRAM_LS_get_v2(data)                                                      ((0x00000020&(data))>>5)
+#define VO_SRAM_LS_vo_buf_shift                                                      (4)
+#define VO_SRAM_LS_vo_buf_mask                                                       (0x00000010)
+#define VO_SRAM_LS_vo_buf(data)                                                      (0x00000010&((data)<<4))
+#define VO_SRAM_LS_vo_buf_src(data)                                                  ((0x00000010&(data))>>4)
+#define VO_SRAM_LS_get_vo_buf(data)                                                  ((0x00000010&(data))>>4)
+#define VO_SRAM_LS_wb_dd_shift                                                       (3)
+#define VO_SRAM_LS_wb_dd_mask                                                        (0x00000008)
+#define VO_SRAM_LS_wb_dd(data)                                                       (0x00000008&((data)<<3))
+#define VO_SRAM_LS_wb_dd_src(data)                                                   ((0x00000008&(data))>>3)
+#define VO_SRAM_LS_get_wb_dd(data)                                                   ((0x00000008&(data))>>3)
+#define VO_SRAM_LS_sub_shift                                                         (2)
+#define VO_SRAM_LS_sub_mask                                                          (0x00000004)
+#define VO_SRAM_LS_sub(data)                                                         (0x00000004&((data)<<2))
+#define VO_SRAM_LS_sub_src(data)                                                     ((0x00000004&(data))>>2)
+#define VO_SRAM_LS_get_sub(data)                                                     ((0x00000004&(data))>>2)
+#define VO_SRAM_LS_osd_shift                                                         (1)
+#define VO_SRAM_LS_osd_mask                                                          (0x00000002)
+#define VO_SRAM_LS_osd(data)                                                         (0x00000002&((data)<<1))
+#define VO_SRAM_LS_osd_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_SRAM_LS_get_osd(data)                                                     ((0x00000002&(data))>>1)
+#define VO_SRAM_LS_v1_shift                                                          (0)
+#define VO_SRAM_LS_v1_mask                                                           (0x00000001)
+#define VO_SRAM_LS_v1(data)                                                          (0x00000001&((data)<<0))
+#define VO_SRAM_LS_v1_src(data)                                                      ((0x00000001&(data))>>0)
+#define VO_SRAM_LS_get_v1(data)                                                      ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/Makefile b/drivers/video/fbdev/rtk/dc2vo/Makefile
new file mode 100644
index 00000000..96b5b61
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/Makefile
@@ -0,0 +1,4 @@
+ccflags-y += -DDC2VO_SUPPORT_MEMORY_TRASH=1
+obj-$(CONFIG_FB_RTK)       += dc_util.o
+obj-$(CONFIG_FB_RTK)       += dc2vo.o
+#obj-$(CONFIG_FB_RTK)       += fpga/
diff --git a/drivers/video/fbdev/rtk/dc2vo/dc2vo.c b/drivers/video/fbdev/rtk/dc2vo/dc2vo.c
new file mode 100644
index 00000000..73b34d4
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/dc2vo.c
@@ -0,0 +1,2279 @@
+#include <generated/autoconf.h>
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/string.h>
+#include <linux/mm.h>
+#include <linux/slab.h>
+#include <linux/delay.h>
+#include <linux/fb.h>
+#include <linux/init.h>
+#include <linux/ioport.h>
+#include <linux/pci.h>
+#include <linux/uaccess.h>
+#include <linux/interrupt.h>
+#include <linux/pagemap.h>
+#include <linux/radix-tree.h>
+#include <linux/blkdev.h>
+#include <linux/module.h>
+#include <linux/blkpg.h>
+#include <linux/buffer_head.h>
+#include <linux/mpage.h>
+#include <linux/ioctl.h> /* needed for the _IOW etc stuff used later */
+#include <linux/sched.h>
+#include <linux/dcache.h>
+#include <linux/kthread.h>
+#include <linux/ktime.h>
+#include <linux/file.h>
+#include <linux/console.h>
+#include <linux/platform_device.h>
+#include <linux/fence.h>
+#include <linux/sync_file.h>
+#include <linux/dma-buf.h>
+#include <uapi/linux/sync_file.h>
+
+
+#include "../../../../../drivers/staging/android/ion/ion.h"
+#include "../../../../../drivers/dma-buf/sync_debug.h"
+#include "../../../../../drivers/soc/realtek/common/rpc/rtk_rpc.h"
+#include <soc/realtek/rtk_ipc_shm.h>
+
+#ifdef CONFIG_REALTEK_RPC
+#include <linux/RPCDriver.h>
+#endif
+#ifdef CONFIG_REALTEK_AVCPU
+#include "../avcpu.h"
+#endif
+
+#define RTKFB_SET_VSYNC_INT _IOW('F', 206, unsigned int)
+#define FBIO_RTK_SHOWSTATICBUFFER  _IO('F', 0x23)
+
+#include "../rtk_fb.h"
+#include "dc2vo.h"
+
+static int debug = 1;
+static int warning = 1;
+static int info = 1;
+
+#define dprintk(msg...) \
+	if (debug) { \
+		pr_debug("D/DC: " msg); \
+	}
+#define eprintk(msg...) \
+	if (1) { \
+		pr_err("E/DC: " msg); \
+	}
+#define wprintk(msg...) \
+	if (warning) { \
+		pr_warn("W/DC: " msg); \
+	}
+#define iprintk(msg...) \
+	if (info) { \
+		pr_info("I/DC: " msg); \
+	}
+
+#ifndef DC_UNREFERENCED_PARAMETER
+#define DC_UNREFERENCED_PARAMETER(param) (param) = (param)
+#endif
+
+#ifdef CONFIG_RTK_RPC
+extern void dc2vo_send_interrupt(void);
+#endif
+
+#ifdef DC2VO_SUPPORT_MEMORY_TRASH
+#define AFBC_MODE_MASK 0x0000ffff
+#define AFBC_MODE_EXT_MASK 0xffff0000
+__maybe_unused static enum _AFBC_MODE_EXT {
+	VO_AFBC_DEBUG_MASK = 0x1u<<16, //1:afbc debug enable
+} AFBC_MODE_EXT;
+static bool gbMemoryTrash = false;
+#endif /* End of DC2VO_SUPPORT_MEMORY_TRASH */
+
+//#define CREATE_THREAD_FOR_RELEASE_DEBUG
+//#define DC2VO_SUPPORT_DCSYS_DEBUG
+
+#ifdef DC2VO_SUPPORT_DCSYS_DEBUG
+#define DC2VO_DCSYS_CONTROL 0x98008300
+#define DC2VO_DCSYS_CONTROL_SETUP 0x03000000
+#define DC2VO_DCSYS_CONTROL_ERROR ((0x1U << 22) | (0x1U << 23))
+static void __iomem * gpDcSysControl = NULL;
+static bool gbDcSysError = false;
+static struct task_struct *gsDcSysDebugThread = NULL;
+static struct kthread_work gsDcSysDebugWork;
+static struct kthread_worker	gsDcSysDebugWorker;
+static inline void dc_sys_debug_trigger(void);
+#endif /* End of DC2VO_SUPPORT_DCSYS_DEBUG */
+
+static int DCINIT = 0;
+extern struct ion_device *rtk_phoenix_ion_device;
+
+typedef struct {
+	struct fb_info *pfbi;
+
+	REFCLOCK *REF_CLK;
+	RINGBUFFER_HEADER *RING_HEADER;
+	void *RING_HEADER_BASE;
+    long long vo_instance_id;
+	struct ion_client *gpsIONClient;
+	unsigned int gAlpha; /* [0]:Pixel Alpha	[0x01 ~ 0xFF]:Global Alpha */
+
+	volatile unsigned int *CLK_ADDR_LOW; /* legacy */
+	volatile unsigned int *CLK_ADDR_HI; /* legacy */
+
+	int64_t PTS;
+	unsigned int CTX;
+	unsigned int flags;
+	int irq;
+
+	wait_queue_head_t vsync_wait;
+	long long vsync_timeout_ms;
+	rwlock_t vsync_lock;
+	ktime_t  vsync_timestamp;
+
+	volatile void *vo_vsync_flag; /* VSync enable and notify. (VOut => SCPU) */
+
+	unsigned int uiRes32Width;
+	unsigned int uiRes32Height;
+
+	struct sync_timeline *timeline;
+
+	int timeline_max;
+
+	struct dc_pending_post *onscreen;
+
+	struct list_head post_list;
+	struct mutex post_lock;
+	struct task_struct *post_thread;
+	struct kthread_work post_work;
+	struct kthread_worker post_worker;
+
+	struct list_head complete_list;
+	struct mutex complete_lock;
+	struct task_struct *complete_thread;
+	struct kthread_work complete_work;
+	struct kthread_worker complete_worker;
+
+#ifdef CREATE_THREAD_FOR_RELEASE_DEBUG
+	struct list_head free_list;
+	struct mutex free_lock;
+	struct task_struct *free_thread;
+	struct kthread_work free_work;
+	struct kthread_worker free_worker;
+#endif /* End of CREATE_THREAD_FOR_RELEASE_DEBUG */
+
+	DC_SYSTEM_TIME_INFO DC_TIME_INFO;
+} DC_INFO;
+
+enum {
+	RPC_READY			   = (1U << 0),
+	ISR_INIT				= (1U << 2),
+	WAIT_VSYNC			  = (1U << 3),
+	CHANGE_RES			  = (1U << 4),
+	BG_SWAP				 = (1U << 5),
+	SUSPEND				 = (1U << 6),
+	VSYNC_FORCE_LOCK		= (1U << 7),
+};
+
+static ktime_t  dc_read_vsync_timestamp     (DC_INFO *pdc_info);
+static void     dc_write_vsync_timestamp    (DC_INFO *pdc_info, ktime_t timestamp);
+inline long	 dc_wait_vsync_timeout	   (DC_INFO *pdc_info);
+void			dc_update_vsync_timestamp   (DC_INFO *pdc_info);
+static int dc_do_simple_post_config(VENUSFB_MACH_INFO * video_info, void *arg);
+static int dc_do_static_post_config(VENUSFB_MACH_INFO * video_info);
+
+#ifdef CONFIG_RTK_RPC
+DC_INFO *gpdc_info;
+DEFINE_SPINLOCK(gASLock);
+//EXPORT_SYSMBOL(gASLock);
+EXPORT_SYMBOL(gASLock);
+#else
+static DEFINE_SPINLOCK(gASLock);
+#endif
+
+void DC_Reset_OSD_param(struct fb_info *fb, VENUSFB_MACH_INFO * video_info)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (fb);
+	pdc_info->PTS = 0;
+	pdc_info->CTX = 0;
+	clkResetPresentation(pdc_info->REF_CLK);
+}
+
+int DC_Set_RPCAddr_Virt(struct fb_info *fb, VENUSFB_MACH_INFO *video_info, DCRT_PARAM_RPC_VIRT_ADDR *param)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+
+	pdc_info->RING_HEADER_BASE = param->ringheaderbaseVirtAddr;
+	pdc_info->RING_HEADER = param->ringVirtAddr;
+	pdc_info->REF_CLK = param->refclockVirtAddr;
+
+	return 0;
+}
+
+int DC_Set_RPCAddr(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, DCRT_PARAM_RPC_ADDR* param)
+{
+
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+
+	#if 0
+	// Set RefClk Table
+	pdc_info->REF_CLK = (REFCLOCK*)
+		phys_to_virt((phys_addr_t)ulPhyAddrFilter(param->refclockAddr));
+		//ioremap((phys_addr_t)ulPhyAddrFilter(param->refclockAddr),sizeof(pdc_info->REF_CLK));
+
+	// Set CMD Queue (Ring Buffer)
+	pdc_info->RING_HEADER = (RINGBUFFER_HEADER*)
+		phys_to_virt((phys_addr_t)ulPhyAddrFilter(param->ringPhyAddr));
+		//ioremap((phys_addr_t)ulPhyAddrFilter(param->ringPhyAddr),sizeof(pdc_info->RING_HEADER));
+	#endif
+
+	dprintk("[%s] REFCLK: phy:0x%08x vir:%p\n", __func__, (u32)param->refclockAddr, pdc_info->REF_CLK);
+	dprintk("[%s] RING_HEADER: phy:0x%08x vir:%p\n", __func__, (u32)param->ringPhyAddr, pdc_info->RING_HEADER);
+	DC_Reset_OSD_param(fb,video_info);
+
+	pdc_info->REF_CLK->mastership.videoMode = AVSYNC_FORCED_MASTER;
+
+	{
+		DC_PRESENTATION_INFO pos;
+		clkGetPresentation(pdc_info->REF_CLK, &pos);
+		iprintk("CLK pts:%lld ctx:%d\n", pos.videoSystemPTS,pos.videoContext);
+		iprintk("drvBeAddr:%x s:%u id:%u rw:(%x %x) #rPtr:%u\n",
+				(unsigned int)pli_IPCReadULONG((BYTE*)&pdc_info->RING_HEADER->beginAddr),
+				pli_IPCReadULONG((BYTE*)&pdc_info->RING_HEADER->size),
+				pli_IPCReadULONG((BYTE*)&pdc_info->RING_HEADER->bufferID),
+				(unsigned int)pli_IPCReadULONG( (BYTE*)&pdc_info->RING_HEADER->readPtr[0]),
+				(unsigned int)pli_IPCReadULONG( (BYTE*)&pdc_info->RING_HEADER->writePtr),
+				pli_IPCReadULONG((BYTE*) &pdc_info->RING_HEADER->numOfReadPtr)
+			  );
+	}
+
+	smp_mb();
+	pdc_info->flags |= RPC_READY;
+	smp_mb();
+
+	return 0;
+}
+
+int Get_RefClock(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, REFCLOCK* pclk)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	REFCLOCK* clk = pdc_info->REF_CLK;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+	if(clk == NULL) return -EAGAIN;
+	else {
+		unsigned long PliReadMastership = (unsigned long)   pli_IPCReadULONG		((BYTE*)&clk->mastership	  );
+		pclk->mastership.systemMode	 = (unsigned char)   ((PliReadMastership & 0xff000000) >> 24);
+		pclk->mastership.videoMode	  = (unsigned char)   ((PliReadMastership & 0x00ff0000) >> 16);
+		pclk->mastership.audioMode	  = (unsigned char)   ((PliReadMastership & 0x0000ff00) >> 8);
+		pclk->mastership.masterState	= (unsigned char)   ((PliReadMastership & 0x000000ff) >> 0);
+		pclk->AO_Underflow			  = (unsigned long)   pli_IPCReadULONG		((BYTE*)&clk->AO_Underflow	);
+		pclk->GPTSTimeout			   = (long long)	   pli_IPCReadULONGLONG	((BYTE*)&clk->GPTSTimeout	 );
+		pclk->RCD					   = (long long)	   pli_IPCReadULONGLONG	((BYTE*)&clk->RCD			 );
+		pclk->RCD_ext				   = (unsigned long)   pli_IPCReadULONG		((BYTE*)&clk->RCD_ext		 );
+		pclk->VO_Underflow			  = (unsigned long)   pli_IPCReadULONG		((BYTE*)&clk->VO_Underflow	);
+		pclk->audioContext			  = (unsigned long)   pli_IPCReadULONG		((BYTE*)&clk->audioContext	);
+		pclk->videoContext			  = (unsigned long)   pli_IPCReadULONG		((BYTE*)&clk->videoContext	);
+		pclk->masterGPTS				= (long long)	   pli_IPCReadULONGLONG	((BYTE*)&clk->masterGPTS	  );
+		pclk->audioSystemPTS			= (long long)	   pli_IPCReadULONGLONG	((BYTE*)&clk->audioSystemPTS  );
+		pclk->videoSystemPTS			= (long long)	   pli_IPCReadULONGLONG	((BYTE*)&clk->videoSystemPTS  );
+		pclk->audioRPTS				 = (long long)	   pli_IPCReadULONGLONG	((BYTE*)&clk->audioRPTS	   );
+		pclk->videoRPTS				 = (long long)	   pli_IPCReadULONGLONG	((BYTE*)&clk->videoRPTS	   );
+	}
+	return 0;
+}
+
+int DC_Get_BufferAddr(struct fb_info *fb, VENUSFB_MACH_INFO * video_info,DCRT_PARAM_BUF_ADDR* param)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	DC_UNREFERENCED_PARAMETER (video_info);
+	//TODO: Info from fb framebuffer info
+#if 1
+	memset(param, 0, sizeof(*param));
+	param->width  = fb->var.xres;
+	param->height = fb->var.yres;
+	return 0;
+#else
+	DC_NOHW_DEVINFO *psDevInfo;
+	psDevInfo = GetAnchorPtr();
+	if( param->buf_id <= DC_NOHW_MAX_BACKBUFFERS)
+	{
+		param->buf_Paddr = psDevInfo->asBackBuffers[param->buf_id].sSysAddr.uiAddr | 0xa0000000;
+		param->buf_Vaddr = (unsigned int)psDevInfo->asBackBuffers[param->buf_id].sCPUVAddr;
+		param->buf_size = psDevInfo->sSysDims.ui32Height * psDevInfo->sSysDims.ui32ByteStride;
+		param->width = psDevInfo->sSysDims.ui32Width;
+		param->height = psDevInfo->sSysDims.ui32Height;
+		param->format =  psDevInfo->sSysFormat.pixelformat; //PVRSRV_PIXEL_FORMAT
+		DCRT_DEBUG("get BUF_ADDR 0x%x 0x%x id:%d %u %d wh(%u %u)\n", param->buf_Paddr,
+				param->buf_Vaddr,
+				param->buf_id, param->buf_size, param->format, param->width, param->height);
+	}
+	else
+	{
+		memset(param, 0, sizeof(param));
+	}
+	return 0;
+#endif
+}
+
+int DC_VsyncWait(unsigned long long *nsecs)
+{
+	if (gpdc_info)
+		dc_wait_vsync_timeout(gpdc_info);
+	else
+		msleep(16);
+
+	if (nsecs)
+		*nsecs = ktime_to_ns(ktime_get());
+
+	return 0;
+}
+EXPORT_SYMBOL(DC_VsyncWait);
+
+int DC_Wait_Vsync(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, unsigned long long *nsecs)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+
+	// WIAT VSYNC EVENT
+#if 0
+	msleep(16);
+#else
+	dc_wait_vsync_timeout(pdc_info);
+#endif
+
+	// WRITE NSECS TO USER
+#if 0
+	*nsecs = ktime_to_ns(ktime_get());
+#else
+	*nsecs = ktime_to_ns(dc_read_vsync_timestamp(pdc_info));
+#endif
+	return 0;
+}
+
+int DC_Set_RateInfo(struct fb_info *fb, VENUSFB_MACH_INFO * video_info,DCRT_PARAM_RATE_INFO* param)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+#if 0
+	pdc_info->CLK_ADDR_LOW = (unsigned int*)ioremap((phys_addr_t)ulPhyAddrFilter(param->clockAddrLow) ,0x4);
+	pdc_info->CLK_ADDR_HI =  (unsigned int*)ioremap((phys_addr_t)ulPhyAddrFilter(param->clockAddrHi)   ,0x4);
+#else
+	pdc_info->CLK_ADDR_LOW = (unsigned int*)phys_to_virt((phys_addr_t)ulPhyAddrFilter(param->clockAddrLow));
+	pdc_info->CLK_ADDR_HI =  (unsigned int*)phys_to_virt((phys_addr_t)ulPhyAddrFilter(param->clockAddrHi));
+#endif
+	iprintk("DC rInfo: pdc_info->CLK_ADDR_LOW=%p pdc_info->CLK_ADDR_HI=%p\n", pdc_info->CLK_ADDR_LOW, pdc_info->CLK_ADDR_HI);
+	return 0;
+}
+
+int DC_Get_Clock_Map_Info(struct fb_info *fb, VENUSFB_MACH_INFO * video_info,DC_CLOCK_MAP_INFO * param)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+#if 1
+	wprintk("[%s] WE ARE NOT SUPPORT!\n",__func__);
+	memset(param,0,sizeof(DC_CLOCK_MAP_INFO));
+#else
+	if(pdc_info->CLK_ADDR_LOW == NULL || pdc_info->CLK_ADDR_HI == NULL) return -EAGAIN;
+	else {
+		DC_CLOCK_MAP_INFO info;
+		info.HiOffset   = ((unsigned int)pdc_info->CLK_ADDR_HI) &  (PAGE_SIZE-1);
+		info.LowOffset  = ((unsigned int)pdc_info->CLK_ADDR_LOW) & (PAGE_SIZE-1);
+		memcpy(param,&info,sizeof(DC_CLOCK_MAP_INFO));
+	}
+#endif
+	return 0;
+}
+
+int DC_Get_Clock_Info(struct fb_info *fb, VENUSFB_MACH_INFO * video_info,REFCLOCK * RefClock)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+	return Get_RefClock(fb,video_info,RefClock);
+}
+
+int DC_Reset_RefClock_Table(struct fb_info *fb, VENUSFB_MACH_INFO * video_info,unsigned int option)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	REFCLOCK* clk = pdc_info->REF_CLK;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+	if( clk != NULL)
+	{
+		if(option & ResetOption_videoSystemPTS)
+			pli_IPCWriteULONGLONG(  (BYTE*)&clk->videoSystemPTS	 , -1ULL);
+		if(option & ResetOption_audioSystemPTS)
+			pli_IPCWriteULONGLONG(  (BYTE*)&clk->audioSystemPTS	 , -1ULL);
+		if(option & ResetOption_videoRPTS)
+			pli_IPCWriteULONGLONG(  (BYTE*)&clk->videoRPTS		  , -1ULL);
+		if(option & ResetOption_audioRPTS)
+			pli_IPCWriteULONGLONG(  (BYTE*)&clk->audioRPTS		  , -1ULL);
+		if(option & ResetOption_videoContext)
+			pli_IPCWriteULONG(	  (BYTE*)&clk->videoContext	   , -1U);
+		if(option & ResetOption_audioContext)
+			pli_IPCWriteULONG(	  (BYTE*)&clk->audioContext	   , -1U);
+		if(option & ResetOption_videoEndOfSegment)
+			pli_IPCWriteULONG(	  (BYTE*)&clk->videoEndOfSegment  , -1U);
+		//if(option & ResetOption_RCD)
+		//	pli_IPCWriteULONGLONG(  (BYTE*)&clk->RCD				,-1);
+		return 0;
+	}
+	else return -1;
+}
+
+int DC_Get_System_Time_Info(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, DC_SYSTEM_TIME_INFO * param)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+	pdc_info->DC_TIME_INFO.PTS			  =					   pdc_info->PTS;
+	pdc_info->DC_TIME_INFO.CTX			  =					   pdc_info->CTX;
+	pdc_info->DC_TIME_INFO.RefClockAddr	 = (unsigned long long)  pdc_info->REF_CLK;
+	pdc_info->DC_TIME_INFO.ClockAddr_HI	 = (unsigned long long)  pdc_info->CLK_ADDR_HI;
+	pdc_info->DC_TIME_INFO.ClockAddr_LOW	= (unsigned long long)  pdc_info->CLK_ADDR_LOW;
+	pdc_info->DC_TIME_INFO.WAIT_ISR		 =				   0;//atomic_read(&pdc_info->ISR_FLIP);
+	pdc_info->DC_TIME_INFO.RTK90KClock	  = 0;
+	pdc_info->DC_TIME_INFO.RTK90KClock	  = ((unsigned long long) readl(pdc_info->CLK_ADDR_HI))<<32;
+	pdc_info->DC_TIME_INFO.RTK90KClock	 |= readl(pdc_info->CLK_ADDR_LOW);
+
+	if(Get_RefClock(fb,video_info,&pdc_info->DC_TIME_INFO.RefClock) != 0) return -EAGAIN;
+	memcpy(param,&pdc_info->DC_TIME_INFO,sizeof(DC_SYSTEM_TIME_INFO));
+	return 0;
+}
+
+int DC_Get_Surface(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, DCRT_PARAM_SURFACE* param)
+{
+#if 1
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+	DC_UNREFERENCED_PARAMETER (param);
+	wprintk("[%s] WE ARE NOT SUPPORT!\n",__func__);
+	return 0;
+#else
+	int err=0;
+	int idx = 0;
+	DC_NOHW_DEVINFO *psDevInfo = (DC_NOHW_DEVINFO *)gpvAnchor;
+	DCRT_VSYNC_FLIP_ITEM *psFlipItem= NULL;
+	unsigned long ulLockFlags;
+
+	if( psDevInfo == NULL || psDevInfo->psSwapChain == NULL) {
+		err = -ENOENT;
+		goto DC_Get_Surface_End;
+	}
+	else if( psDevInfo->ui32BufferSize < param->buf_size) {
+		err = -EINVAL;
+		goto DC_Get_Surface_End;
+	}
+	spin_lock_irqsave(&psDevInfo->psSwapChainLock, ulLockFlags);
+	if( psDevInfo->ulInsertIndex != psDevInfo->ulRemoveIndex)
+	{
+		idx = psDevInfo->ulInsertIndex;
+	}
+	else { //==, use last one
+		idx = psDevInfo->ulInsertIndex;
+	}
+	psFlipItem = &psDevInfo->psVSyncFlips[idx];
+	{
+		unsigned int srcAddr  = (unsigned int )phys_to_virt(psFlipItem->phyAddr);
+		unsigned int dstAddr = (unsigned int )phys_to_virt(param->buf_Paddr);
+		if( md_memcpy( (void*)dstAddr, (void*)srcAddr,  param->buf_size, true) != 0 )
+		{  //md copy err
+			err = -EAGAIN;
+		}
+	}
+	spin_unlock_irqrestore(&psDevInfo->psSwapChainLock, ulLockFlags);
+DC_Get_Surface_End:
+	if( err) {
+		//****   ****//
+	}
+	return err;
+#endif
+}
+
+int DC_Set_ION_Share_Memory(struct fb_info *fb, VENUSFB_MACH_INFO *video_info,
+	DC_ION_SHARE_MEMORY *param)
+{
+	extern int osd_status;
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+
+	if (pdc_info->gpsIONClient == NULL)
+		pdc_info->gpsIONClient = ion_client_create(rtk_phoenix_ion_device, "dc2vo");
+    //For supporting osd-init in rtk fb driver
+    if (osd_status == 1){
+        if ((param->sfd_rbHeader== 0)&&(param->sfd_rbBase == 0)) {
+        /*  +---------------+
+            | RingBuffer 64k|
+            +---------------+
+            | RingBuffer 1k |
+            +---------------+
+            | RefClk    1k  |
+            +---------------+    */
+
+        struct ion_handle *handle;
+        handle = ion_import_dma_buf(pdc_info->gpsIONClient, dma_buf_get(param->sfd_refclk));
+        pdc_info->RING_HEADER_BASE = ion_map_kernel(pdc_info->gpsIONClient,handle);
+        pdc_info->RING_HEADER = (void*)((unsigned long)pdc_info->RING_HEADER_BASE + 64*1024);
+        pdc_info->REF_CLK = (void*)((unsigned long)pdc_info->RING_HEADER + 1024);
+
+        dprintk("[%s] refclk sfd:%d handle:%p vAddr:%p\n",__func__,
+                param->sfd_refclk, handle, pdc_info->REF_CLK);
+        dprintk("[%s] rbHeader sfd:%d handle:%p vAddr:%p\n",__func__,
+                param->sfd_rbHeader, handle, pdc_info->RING_HEADER);
+        dprintk("[%s] rbHeaderBase sfd:%d handle:%p vAddr:%p\n",__func__,
+                param->sfd_rbBase, handle, pdc_info->RING_HEADER_BASE);
+
+        return 0;
+        }
+    }
+
+	if (param->sfd_refclk != 0) {
+		struct ion_handle *refclk_handle;
+
+		refclk_handle = ion_import_dma_buf(pdc_info->gpsIONClient, dma_buf_get(param->sfd_refclk));
+		pdc_info->REF_CLK = ion_map_kernel(pdc_info->gpsIONClient, refclk_handle);
+		dprintk("[%s] refclk sfd:%d handle:%p vAddr:%p\n", __func__,
+				param->sfd_refclk, refclk_handle, pdc_info->REF_CLK);
+	}
+	if (param->sfd_rbHeader!= 0) {
+		struct ion_handle *rbHeader_handle;
+
+		rbHeader_handle = ion_import_dma_buf(pdc_info->gpsIONClient, dma_buf_get(param->sfd_rbHeader));
+		pdc_info->RING_HEADER =  ion_map_kernel(pdc_info->gpsIONClient, rbHeader_handle);
+		dprintk("[%s] rbHeader sfd:%d handle:%p vAddr:%p\n", __func__,
+				param->sfd_rbHeader, rbHeader_handle, pdc_info->RING_HEADER);
+	}
+	if (param->sfd_rbBase != 0) {
+		struct ion_handle *rbBase_handle;
+
+		rbBase_handle = ion_import_dma_buf(pdc_info->gpsIONClient, dma_buf_get(param->sfd_rbBase));
+		pdc_info->RING_HEADER_BASE = ion_map_kernel(pdc_info->gpsIONClient, rbBase_handle);
+		dprintk("[%s] rbHeaderBase sfd:%d handle:%p vAddr:%p\n", __func__,
+				param->sfd_rbBase, rbBase_handle, pdc_info->RING_HEADER_BASE);
+	}
+	return 0;
+}
+
+int DC_Set_Buffer_Info(struct fb_info *fb, VENUSFB_MACH_INFO *video_info, DC_BUFFER_INFO *param)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (fb);
+	DC_UNREFERENCED_PARAMETER (video_info);
+	if (pdc_info == NULL || param == NULL)
+		goto err;
+
+	if (param->enable)
+		pdc_info->flags |= CHANGE_RES;
+	else
+		pdc_info->flags &= ~CHANGE_RES;
+
+	pdc_info->uiRes32Width = param->width;
+	pdc_info->uiRes32Height = param->height;
+
+	dprintk("[%s] enable:%d width:%d height:%d\n",__func__,param->enable,param->width,param->height);
+	return 0;
+err:
+	eprintk("[%s] ERROR!",__func__);
+	return -1;
+}
+
+#define goERROR(tag) { \
+eprintk("ERROR! CMD = %u LINE = %d tag = %d",cmd,__LINE__,tag); \
+goto ERROR; \
+}
+
+int DC_Ioctl (struct fb_info *fb, VENUSFB_MACH_INFO *video_info,
+	unsigned int cmd, unsigned long arg)
+{
+	int retval = 0;
+
+	switch (cmd) {
+	case DC2VO_GET_BUFFER_ADDR:
+		{
+			DCRT_PARAM_BUF_ADDR param;
+			if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)
+				goERROR(0);
+			retval = DC_Get_BufferAddr(fb,video_info,&param);
+			if (copy_to_user((void *)arg, &param, sizeof(param)) != 0)
+				goERROR(0);
+			break;
+		}
+	case DC2VO_SET_RING_INFO:
+		{
+			DCRT_PARAM_RPC_ADDR param;
+			if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)
+				goERROR(0);
+			retval = DC_Set_RPCAddr(fb, video_info, &param);
+			break;
+		}
+	case DC2VO_SET_OUT_RATE_INFO:
+		{
+			DCRT_PARAM_RATE_INFO param;
+			if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)
+				goERROR(0);
+			if( param.param_size != sizeof(DCRT_PARAM_RATE_INFO) )
+				goERROR(0);
+			retval = DC_Set_RateInfo(fb, video_info, &param);
+			break;
+		}
+	case DC2VO_GET_CLOCK_MAP_INFO:
+		{
+			DC_CLOCK_MAP_INFO param;
+
+			if(DC_Get_Clock_Map_Info(fb, video_info, &param) != 0)
+				goERROR(0);
+			if(copy_to_user((void *)arg, &param, sizeof(DC_CLOCK_MAP_INFO)) != 0)
+				goERROR(0);
+			break;
+		}
+	case DC2VO_GET_CLOCK_INFO:
+		{
+			REFCLOCK RefClock;
+
+			if(DC_Get_Clock_Info(fb, video_info, &RefClock) != 0)
+				goERROR(0);
+			if(copy_to_user((void *)arg, &RefClock, sizeof(REFCLOCK)) != 0)
+				goERROR(0);
+			break;
+		}
+	case DC2VO_RESET_CLOCK_TABLE	 :
+		{
+			unsigned int option = 0;
+
+			if(copy_from_user(&option,(void *)arg, sizeof(option)) != 0)
+				goERROR(0);
+			if(DC_Reset_RefClock_Table(fb, video_info, option) != 0)
+				goERROR(0);
+			break;
+		}
+	case FBIO_WAITFORVSYNC:
+		{
+			unsigned long long nsecs;
+
+			if (DC_Wait_Vsync(fb, video_info, &nsecs) != 0)
+				goERROR(0);
+			//if(copy_to_user((void *)arg,&nsecs,sizeof(u32)) != 0)
+			// goERROR(0);
+			break;
+		}
+	case DC2VO_WAIT_FOR_VSYNC:
+		{
+			unsigned long long nsecs;
+
+			if (DC_Wait_Vsync(fb, video_info, &nsecs) != 0)
+				goERROR(0);
+			if(copy_to_user((void *)arg, &nsecs, sizeof(nsecs)) != 0)
+				goERROR(0);
+			break;
+		}
+	case DC2VO_GET_SURFACE:
+		{
+			DCRT_PARAM_SURFACE param;
+
+			if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)
+				goERROR(0);
+			if( param.param_size != sizeof(DCRT_PARAM_SURFACE) )
+				goERROR(0);
+			retval = DC_Get_Surface(fb, video_info, &param);
+			break;
+		}
+	case DC2VO_GET_SYSTEM_TIME_INFO:
+		{
+			DC_SYSTEM_TIME_INFO param;
+
+			DC_Get_System_Time_Info(fb, video_info, &param);
+			if(copy_to_user((void *)arg, &param, sizeof(DC_SYSTEM_TIME_INFO)) != 0)
+				goERROR(0);
+			break;
+		}
+	case DC2VO_GET_MAX_FRAME_BUFFER:
+		{
+			unsigned int MAX_FRAME_BUFFER = DC_NOHW_MAX_BACKBUFFERS;
+			if (copy_to_user((void *)arg, &MAX_FRAME_BUFFER, sizeof(MAX_FRAME_BUFFER)) != 0)
+				goERROR(0);
+			break;
+		}
+	case RTKFB_SET_VSYNC_INT	:
+		{
+			/*
+			 * 1: enable vsync
+			 * 0: disable vsync
+			 */
+			break;
+		}
+	case DC2VO_SET_ION_SHARE_MEMORY:
+		{
+			DC_ION_SHARE_MEMORY param;
+
+			if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)
+				goERROR(0);
+			if (DC_Set_ION_Share_Memory(fb, video_info, &param) != 0)
+				goERROR(0);
+
+            {
+                DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+                pdc_info->vo_instance_id = param.vo_instance_id;
+            }
+			break;
+		}
+    case DC2VO_GET_VO_INSTANCE_INFO:
+        {
+            DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+            DC_VO_INSTANCE_INFO param;
+            memset(&param, 0, sizeof(param));
+            param.vo_instance_id = pdc_info->vo_instance_id;
+			if(copy_to_user((void *)arg, &param, sizeof(param)) != 0)
+				goERROR(0);
+            break;
+        }
+	case DC2VO_SET_BUFFER_INFO:
+		{
+			DC_BUFFER_INFO param;
+
+			if (copy_from_user(&param, (void *)arg, sizeof(param)) != 0)
+				goERROR(0);
+			if (DC_Set_Buffer_Info(fb, video_info, &param) != 0)
+				goERROR(0);
+			break;
+		}
+	case DC2VO_SET_BG_SWAP:
+		{
+			DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+			unsigned int swap;
+
+			if (pdc_info == NULL)
+				goERROR(0);
+			if (copy_from_user(&swap, (void *)arg, sizeof(swap)) != 0)
+				goERROR(0);
+
+			if (swap)
+				pdc_info->flags |= BG_SWAP;
+			else
+				pdc_info->flags &= ~BG_SWAP;
+
+			break;
+		}
+	case DC2VO_SET_VSYNC_FORCE_LOCK:
+		{
+			DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+			unsigned int lock;
+
+			if (pdc_info == NULL)
+				goERROR(0);
+			if (copy_from_user(&lock, (void *)arg, sizeof(lock)) != 0)
+				goERROR(0);
+
+			if (lock)
+				pdc_info->flags |= VSYNC_FORCE_LOCK;
+			else
+				pdc_info->flags &= ~VSYNC_FORCE_LOCK;
+
+			break;
+		}
+	case DC2VO_SET_GLOBAL_ALPHA:
+		{
+			DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+			unsigned int alpha;
+
+			if (pdc_info == NULL)
+				goERROR(0);
+			if (copy_from_user(&alpha, (void *)arg, sizeof(alpha)) != 0)
+				goERROR(0);
+
+			if (alpha <= 0xFF)
+				pdc_info->gAlpha = alpha;
+			else
+				pdc_info->gAlpha = 0; /* 0 : Pixel Alpha */
+
+			break;
+		}
+	case DC2VO_SIMPLE_POST_CONFIG:
+		{
+			if (dc_do_simple_post_config(video_info, (void *)arg))
+				goERROR(0);
+			break;
+		}
+	case FBIO_RTK_SHOWSTATICBUFFER:
+		{
+			if (dc_do_static_post_config(video_info))
+				goERROR(0);
+			break;
+		}
+	case DC2VO_SET_SYSTEM_TIME_INFO:
+	case DC2VO_SET_BUFFER_ADDR:
+	case DC2VO_SET_DISABLE:
+	case DC2VO_SET_MODIFY:
+		{
+			dprintk("[%s %d] CMD = %u \n",__func__,__LINE__,cmd);
+			break;
+		}
+	default:
+		retval = -EAGAIN;
+	}
+
+	return retval;
+
+ERROR:
+
+#undef goERROR
+
+	return -EFAULT;
+}
+
+#ifdef CONFIG_RTK_RPC
+void dc_irq_handler(void)
+{
+	DC_INFO * pdc_info = gpdc_info;
+	if (DCINIT == 0)
+		return;
+
+	if(!DC_HAS_BIT(pdc_info->vo_vsync_flag, DC_VO_FEEDBACK_NOTIFY))
+		return;
+
+	DC_RESET_BIT(pdc_info->vo_vsync_flag,  DC_VO_FEEDBACK_NOTIFY) ;
+	dc_update_vsync_timestamp(pdc_info);
+
+	return;
+}
+EXPORT_SYMBOL(dc_irq_handler);
+#else
+irqreturn_t dc_irq_handler(int irq, void *dev_id)
+{
+	VENUSFB_MACH_INFO * video_info = (VENUSFB_MACH_INFO *)dev_id;
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+
+	if(!DC_HAS_BIT(pdc_info->vo_vsync_flag, DC_VO_FEEDBACK_NOTIFY))
+		return IRQ_NONE;
+
+	DC_RESET_BIT(pdc_info->vo_vsync_flag,  DC_VO_FEEDBACK_NOTIFY) ;
+	dc_update_vsync_timestamp(pdc_info);
+
+	return IRQ_HANDLED;
+}
+#endif
+
+int Activate_vSync(VENUSFB_MACH_INFO * video_info)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	int result=0;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	dprintk("%s:%d DEBUG!!!! \n", __func__, __LINE__);
+#ifndef CONFIG_RTK_RPC
+	if( !(pdc_info->flags & ISR_INIT))
+	{
+		if (pdc_info->irq > 0)
+			result = request_irq(pdc_info->irq, dc_irq_handler, IRQF_SHARED, "dc2vo", (void *) video_info);
+		else
+			result = request_irq(DCRT_IRQ, dc_irq_handler, IRQF_SHARED, "dc2vo", (void *) video_info);
+		if(result)
+		{
+			eprintk("DC: irq ins fail %i\n", DCRT_IRQ);
+			return result;
+		}
+		else {
+			dprintk("DC irq Ins\n");
+			smp_mb();
+			pdc_info->flags |= ISR_INIT;
+			smp_mb();
+		}
+	}
+#endif
+	spin_lock_irq(&gASLock);
+	DC_SET_BIT(pdc_info->vo_vsync_flag, DC_VO_SET_NOTIFY);
+	spin_unlock_irq(&gASLock);
+	return result;
+}
+
+int DeInit_vSync(VENUSFB_MACH_INFO * video_info)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	unsigned long ulLockFlags;
+	static spinlock_t  vSyncLock;
+	DC_UNREFERENCED_PARAMETER (pdc_info);
+	spin_lock_irqsave(&vSyncLock, ulLockFlags);
+	if( pdc_info->flags & ISR_INIT ) {
+#ifndef CONFIG_RTK_RPC
+		free_irq(DCRT_IRQ, (void *) video_info);
+#endif
+		smp_mb();
+		pdc_info->flags &= ~ISR_INIT;
+		smp_mb();
+		dprintk("DC irqUn\n");
+	}
+	spin_unlock_irqrestore(&vSyncLock, ulLockFlags);
+	return 0;
+}
+
+static ktime_t dc_read_vsync_timestamp(DC_INFO *pdc_info)
+{
+    unsigned long flags;
+    ktime_t		 timestamp;
+    read_lock_irqsave(&pdc_info->vsync_lock, flags);
+    timestamp = pdc_info->vsync_timestamp;
+    read_unlock_irqrestore(&pdc_info->vsync_lock, flags);
+    return timestamp;
+}
+
+static void dc_write_vsync_timestamp(DC_INFO *pdc_info, ktime_t timestamp)
+{
+    unsigned long flags;
+    write_lock_irqsave(&pdc_info->vsync_lock, flags);
+    pdc_info->vsync_timestamp = timestamp;
+    write_unlock_irqrestore(&pdc_info->vsync_lock, flags);
+    return;
+}
+
+long dc_wait_vsync_timeout(DC_INFO *pdc_info)
+{
+    long ret = 0;
+	ktime_t		 timestamp;
+	long			timeout;
+
+	timestamp = dc_read_vsync_timestamp(pdc_info);
+
+	timeout = wait_event_interruptible_hrtimeout(pdc_info->vsync_wait,
+			!ktime_equal(timestamp, dc_read_vsync_timestamp(pdc_info)),
+            ktime_set( 0, (pdc_info->vsync_timeout_ms * NSEC_PER_MSEC)));
+
+	if (timeout ==  -ETIME) {
+		unsigned int flag = pli_IPCReadULONG((BYTE*)pdc_info->vo_vsync_flag);
+		eprintk("[%s %d] wait vsync timeout! vo_vsync_flag:0x%08x\n",
+				__func__, __LINE__, flag);
+        ret = -1L;
+	}
+
+	return ret;
+}
+
+void dc_update_vsync_timestamp(DC_INFO *pdc_info)
+{
+    dc_write_vsync_timestamp(pdc_info, ktime_get());
+	wake_up_interruptible_all(&pdc_info->vsync_wait);
+}
+
+static void dc_fence_wait(DC_INFO * pdc_info, struct sync_file *fence)
+{
+	/* fence_wait() dumps debug information on timeout.  Experience
+	 * has shown that if the pipeline gets stuck, a short timeout followed
+	 * by a longer one provides useful information for debugging.
+	 */
+
+	int err = fence_wait_timeout(fence->fence, 1, DC_SHORT_FENCE_TIMEOUT);
+
+	if (err >= 0)
+		return;
+
+	if (err == -ETIME)
+		err = fence_wait_timeout(fence->fence, 1, DC_LONG_FENCE_TIMEOUT);
+
+	if (err < 0)
+		pr_warn("error waiting on fence: %d\n", err);
+}
+
+static void dc_fence_put(struct sync_file *fence)
+{
+	struct fence *my_fence = fence->fence;
+
+	if (my_fence)
+		kref_put(&my_fence->refcount, fence_release);
+}
+
+void dc_buffer_dump(struct dc_buffer *buf)
+{
+	if (!buf) {
+		eprintk("buffer is null!\n");
+		return;
+	}
+	wprintk("buffer:%p id:%d ov_engine:%d fmt:%d offset:0x%x ctx:%d [%d %d %d %d] [%d %d %d %d]\n",
+			buf, buf->id, buf->overlay_engine, buf->format, buf->offset, buf->context,
+			buf->sourceCrop.left,
+			buf->sourceCrop.top,
+			buf->sourceCrop.right,
+			buf->sourceCrop.bottom,
+			buf->displayFrame.left,
+			buf->displayFrame.top,
+			buf->displayFrame.right,
+			buf->displayFrame.bottom);
+}
+
+void dc_buffer_cleanup(struct dc_buffer *buf)
+{
+	if (buf->acquire.fence)
+		dc_fence_put(buf->acquire.fence);
+
+	kfree(buf);
+}
+
+void dc_post_cleanup(DC_INFO *pdc_info, struct dc_pending_post *post)
+{
+	size_t i;
+	for (i = 0; i < post->config.n_bufs; i++)
+		dc_buffer_cleanup(&post->config.bufs[i]);
+
+#if 0
+	if (post->release.fence)
+		dc_fence_put(post->release.fence);
+#endif
+
+	kfree(post);
+}
+
+#if 0
+static struct sync_file *dc_sw_complete_fence(DC_INFO *pdc_info)
+{
+	struct sync_pt *pt;
+	struct sync_file *complete_fence;
+
+	if (!pdc_info->timeline) {
+		pdc_info->timeline = sw_sync_timeline_create("rtk_fb");
+		if (!pdc_info->timeline)
+			return ERR_PTR(-ENOMEM);
+		pdc_info->timeline_max = 1;
+	}
+
+	dprintk("[%s %d] sw_sync_pt_create (%d)\n", __func__, __LINE__, pdc_info->timeline_max);
+	pt = sw_sync_pt_create(pdc_info->timeline, pdc_info->timeline_max);
+	pdc_info->timeline_max++;
+	if (!pt)
+		goto err_pt_create;
+
+	complete_fence = sync_fence_create("rtk_fb", pt);
+	if (!complete_fence)
+		goto err_fence_create;
+
+
+	return complete_fence;
+
+err_fence_create:
+	eprintk("[%s %d]\n", __func__, __LINE__);
+	sync_pt_free(pt);
+err_pt_create:
+	eprintk("[%s %d]\n", __func__, __LINE__);
+	pdc_info->timeline_max--;
+	return ERR_PTR(-ENOSYS);
+}
+#endif
+
+static struct sync_file *dc_sw_complete_fence(DC_INFO *pdc_info)
+{
+	struct sync_pt *pt;
+	struct sync_file *complete_fence;
+
+	if (!pdc_info->timeline) {
+		pdc_info->timeline = sync_timeline_create("rtk_fb");
+		if (!pdc_info->timeline)
+			return ERR_PTR(-ENOMEM);
+		pdc_info->timeline_max = 1;
+	}
+
+	pr_debug("[%s %d] sync_pt_create (%d)\n", __func__, __LINE__, pdc_info->timeline_max);
+
+	pt = sync_pt_create(pdc_info->timeline, pdc_info->timeline_max);
+	pdc_info->timeline_max++;
+	if (!pt)
+		goto err_pt_create;
+
+	complete_fence = sync_file_create(&pt->base);
+
+	if (!complete_fence)
+		goto err_fence_create;
+
+    fence_put(&pt->base);
+
+	return complete_fence;
+
+err_fence_create:
+	pr_err("[%s %d]\n", __func__, __LINE__);
+	fence_put(&pt->base);
+
+err_pt_create:
+	pr_err("[%s %d]\n", __func__, __LINE__);
+	pdc_info->timeline_max--;
+
+	return ERR_PTR(-ENOSYS);
+}
+
+static int dc_buffer_import(DC_INFO *pdc_info,
+		struct dc_buffer __user *buf_from_user, struct dc_buffer *buf)
+{
+	struct dc_buffer user_buf;
+	int ret = 0;
+
+	if (copy_from_user(&user_buf, buf_from_user, sizeof(user_buf)))
+		return -EFAULT;
+
+	memcpy(buf, &user_buf, sizeof(struct dc_buffer));
+
+	if (user_buf.acquire.fence_fd >= 0) {
+		buf->acquire.fence = sync_file_fdget(user_buf.acquire.fence_fd);
+		if (!buf->acquire.fence) {
+			eprintk("getting fence fd %lld failed\n", user_buf.acquire.fence_fd);
+			ret = -EINVAL;
+			goto done;
+		}
+	} else
+		buf->acquire.fence = (struct sync_file *) NULL;
+
+	if (buf->overlay_engine > eEngine_MAX) {
+		eprintk("invalid overlay engine id mask %u\n", buf->overlay_engine);
+		//ret = -EINVAL;
+		//goto done;
+	}
+
+	dprintk("[%s %d] buf->acquire_fenc : %p\n", __func__, __LINE__, buf->acquire.fence);
+done:
+	/*
+	 * if (ret < 0)
+	 * dc_buffer_cleanup(buf);
+	 */
+	return ret;
+}
+
+static void dc_sw_advance_timeline(DC_INFO *pdc_info)
+{
+#ifdef CONFIG_SW_SYNC
+	sync_timeline_signal(pdc_info->timeline, 1);
+#else
+	BUG();
+#endif
+}
+
+struct sync_file *dc_device_post_to_work(DC_INFO * pdc_info,
+		struct dc_buffer *bufs, size_t n_bufs)
+{
+	struct dc_pending_post *cfg;
+	struct sync_file *ret;
+
+	cfg = kzalloc(sizeof(*cfg), GFP_KERNEL);
+	if (!cfg) {
+		ret = ERR_PTR(-ENOMEM);
+		goto err_alloc;
+	}
+
+	INIT_LIST_HEAD(&cfg->head);
+	cfg->config.n_bufs = n_bufs;
+	cfg->config.bufs = bufs;
+
+	mutex_lock(&pdc_info->post_lock);
+	ret = dc_sw_complete_fence(pdc_info);
+	if (IS_ERR(ret))
+		goto err_fence;
+
+	cfg->release.fence = ret;
+
+	list_add_tail(&cfg->head, &pdc_info->post_list);
+	kthread_queue_work(&pdc_info->post_worker, &pdc_info->post_work);
+	mutex_unlock(&pdc_info->post_lock);
+
+	return ret;
+
+err_fence:
+	mutex_unlock(&pdc_info->post_lock);
+
+err_alloc:
+	if (cfg) {
+		if (cfg->config.bufs)
+			kfree(cfg->config.bufs);
+		kfree(cfg);
+	}
+	return ret;
+}
+
+struct sync_file *dc_device_post(DC_INFO *pdc_info,
+	struct dc_buffer *bufs, size_t n_bufs)
+{
+	struct dc_buffer *bufs_copy = NULL;
+
+	bufs_copy = kzalloc(sizeof(bufs_copy[0]) * n_bufs, GFP_KERNEL);
+	if (!bufs_copy)
+		return ERR_PTR(-ENOMEM);
+
+	memcpy(bufs_copy, bufs, sizeof(bufs_copy[0]) * n_bufs);
+
+	return dc_device_post_to_work(pdc_info, bufs_copy, n_bufs);
+}
+
+struct sync_file *dc_simple_post(DC_INFO *pdc_info,
+		struct dc_buffer *buf)
+{
+	return dc_device_post(pdc_info, buf, 1);
+}
+
+struct sync_file * DC_QueueBuffer(struct dc_buffer *buf)
+{
+	return dc_simple_post(gpdc_info, buf);
+}
+EXPORT_SYMBOL(DC_QueueBuffer);
+
+static int dc_do_simple_post_config(VENUSFB_MACH_INFO * video_info, void *arg)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	struct dc_simple_post_config __user *cfg = (struct dc_simple_post_config __user *) arg;
+	struct sync_file *complete_fence = NULL;
+	int complete_fence_fd;
+	struct dc_buffer buf;
+	int ret = 0;
+	extern int osd_status;
+	struct fb_info *fb;
+
+	if (osd_status==1){
+		fb  = pdc_info->pfbi;
+	}
+
+	//complete_fence_fd = get_unused_fd();
+	complete_fence_fd = get_unused_fd_flags(O_CLOEXEC);
+	if (complete_fence_fd < 0) {
+		eprintk("[%s %d] complete_fence_fd = %d\n", __func__, __LINE__, complete_fence_fd);
+		return complete_fence_fd;
+	}
+
+	ret = dc_buffer_import(pdc_info, &cfg->buf, &buf);
+	if (ret < 0) {
+		eprintk("[%s %d] ret = %d\n", __func__, __LINE__, ret);
+		goto err_import;
+	}
+	if (osd_status==1){
+		if (buf.phyAddr==0)
+		buf.phyAddr=fb->fix.smem_start
+	                            + fb->fix.line_length * fb->var.yoffset
+	                            + fb->var.xoffset *  (fb->var.bits_per_pixel / 8);
+	}
+
+	complete_fence = dc_simple_post(pdc_info, &buf);
+	if (IS_ERR(complete_fence)) {
+		ret = PTR_ERR(complete_fence);
+		eprintk("[%s %d] complete_fence : %p\n", __func__, __LINE__, complete_fence);
+		goto err_put_user;
+	}
+
+	 fd_install(complete_fence_fd, complete_fence->file);
+
+	if (put_user(complete_fence_fd, &cfg->complete_fence_fd)) {
+		eprintk("[%s %d] put_user complete_fence_fd:%d failed!\n", __func__, __LINE__, complete_fence_fd);
+		ret = -EFAULT;
+		goto err_put_user;
+	}
+
+	return 0;
+
+err_put_user:
+	//dc_buffer_cleanup(&buf);
+err_import:
+	put_unused_fd(complete_fence_fd);
+	return ret;
+}
+
+static int dc_do_static_post_config(VENUSFB_MACH_INFO * video_info)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	struct dc_simple_post_config cfg;
+	struct sync_file *complete_fence = NULL;
+	int ret = 0;
+	extern int osd_status;
+	struct fb_info *fb;
+
+	if (osd_status==1){
+		fb  = pdc_info->pfbi;
+	} else {
+		pr_err("[%d] osd_status is disabled!!\n", __LINE__);
+		return -EPERM;
+	}
+
+	memset(&cfg, 0, sizeof(cfg));
+	cfg.buf.sourceCrop.left=0;
+	cfg.buf.sourceCrop.right=fb->var.xres;
+	cfg.buf.sourceCrop.top=0;
+	cfg.buf.sourceCrop.bottom=fb->var.yres;
+	cfg.buf.displayFrame.left=0;
+	cfg.buf.displayFrame.right=fb->var.xres;
+	cfg.buf.displayFrame.top=0;
+	cfg.buf.displayFrame.bottom=fb->var.yres;
+
+	cfg.buf.width=fb->var.xres;
+	cfg.buf.height=fb->var.yres;
+	cfg.buf.stride=fb->fix.line_length; //m_FixInfo.line_length
+	cfg.buf.id = eFrameBufferTarget;
+	cfg.buf.overlay_engine = eEngine_VO;
+	cfg.buf.acquire.fence_fd = -1;
+	cfg.buf.phyAddr=fb->fix.smem_start
+	                            + fb->fix.line_length * fb->var.yoffset
+	                            + fb->var.xoffset *  (fb->var.bits_per_pixel / 8);
+	cfg.buf.format = INBAND_CMD_GRAPHIC_FORMAT_ARGB8888_LITTLE;
+
+	//dc_buffer_import
+	cfg.buf.acquire.fence = (struct sync_file *) NULL;
+
+	complete_fence = dc_simple_post(pdc_info, &cfg.buf);
+	if (IS_ERR(complete_fence)) {
+		ret = PTR_ERR(complete_fence);
+		pr_err("[%s %d] complete_fence : %p\n", __func__, __LINE__, complete_fence);
+		goto err;
+	}
+
+	return 0;
+
+err:
+	return ret;
+}
+
+int DC_Swap_Buffer(struct fb_info *fb, VENUSFB_MACH_INFO * video_info)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	struct sync_file *complete_fence = NULL;
+	struct dc_buffer buf;
+
+	if (pdc_info->flags & SUSPEND) {
+		dc_wait_vsync_timeout(pdc_info);
+		return 0;
+	}
+
+	if (debug)
+		console_unlock();
+
+	memset(&buf, 0, sizeof(buf));
+
+	buf.id						  = eFrameBuffer;
+	buf.overlay_engine			  = eEngine_VO;
+	buf.offset					  = fb->var.yoffset;
+	buf.acquire.fence			   = (struct sync_file *) 0;
+
+	complete_fence = dc_simple_post(pdc_info, &buf);
+
+	if (IS_ERR(complete_fence))
+		goto err;
+
+	dc_fence_wait(pdc_info, complete_fence);
+
+    fput(complete_fence->file);
+
+	if (debug)
+		console_lock();
+	return 0;
+
+err:
+	eprintk("[%s %d]!!!!!!! \n", __func__, __LINE__);
+	if (debug)
+		console_lock();
+	return -EFAULT;
+}
+
+static int dc_prepare_framebuffer(DC_INFO *pdc_info, struct dc_buffer *buffer)
+{
+	struct fb_info *fb  = pdc_info->pfbi;
+
+
+	fb->var.yoffset	 = buffer->offset;
+
+	buffer->phyAddr	 = fb->fix.smem_start
+							+ fb->fix.line_length * fb->var.yoffset
+							+ fb->var.xoffset *  (fb->var.bits_per_pixel / 8);
+
+	buffer->stride	  = fb->fix.line_length;
+	buffer->format	  = (pdc_info->flags & BG_SWAP)? INBAND_CMD_GRAPHIC_FORMAT_RGBA8888 : INBAND_CMD_GRAPHIC_FORMAT_ARGB8888_LITTLE;
+
+	if (pdc_info->flags & CHANGE_RES && pdc_info->uiRes32Width > 0 && pdc_info->uiRes32Height > 0) {
+		buffer->width   = pdc_info->uiRes32Width;
+		buffer->height  = pdc_info->uiRes32Height;
+	} else {
+		buffer->width   = fb->var.xres;
+		buffer->height  = fb->var.yres;
+	}
+
+	if (!(buffer->flags & eBuffer_USE_GLOBAL_ALPHA))
+		buffer->alpha	   = pdc_info->gAlpha;
+
+	if (pdc_info->CTX == -1)
+		pdc_info->CTX = 0;
+	else
+		pdc_info->CTX++;
+
+	buffer->context = pdc_info->CTX;
+	return 0;
+}
+
+static int dc_prepare_framebuffer_target(DC_INFO *pdc_info, struct dc_buffer *buffer)
+{
+	struct fb_info *fb  = pdc_info->pfbi;
+	bool bIsAFBC = (buffer->flags & eBuffer_AFBC_Enable)?true:false;
+
+	//dprintk("[%s] phyAddr:0x%08x", __FUNCTION__, buffer->phyAddr);
+	buffer->stride	  = fb->fix.line_length;
+	buffer->format	  = (pdc_info->flags & BG_SWAP)? INBAND_CMD_GRAPHIC_FORMAT_RGBA8888 : INBAND_CMD_GRAPHIC_FORMAT_ARGB8888_LITTLE;
+
+	if (!bIsAFBC && pdc_info->flags & CHANGE_RES && pdc_info->uiRes32Width > 0 && pdc_info->uiRes32Height > 0) {
+		buffer->width   = pdc_info->uiRes32Width;
+		buffer->height  = pdc_info->uiRes32Height;
+	} else {
+		buffer->width   = fb->var.xres;
+		buffer->height  = fb->var.yres;
+	}
+
+	if (!(buffer->flags & eBuffer_USE_GLOBAL_ALPHA))
+		buffer->alpha	   = pdc_info->gAlpha;
+
+	if (pdc_info->CTX == -1)
+		pdc_info->CTX = 0;
+	else
+		pdc_info->CTX++;
+
+	buffer->context = pdc_info->CTX;
+	return 0;
+}
+
+static int dc_prepare_user_buffer(DC_INFO *pdc_info, struct dc_buffer *buffer)
+{
+	struct fb_info *fb  = pdc_info->pfbi;
+	{
+		if (buffer->width == 0)
+			buffer->width   = fb->var.xres;
+
+		if (buffer->height == 0)
+			buffer->height  = fb->var.yres;
+
+		if (buffer->stride == 0)
+			buffer->stride = buffer->width * 4;
+
+		if (buffer->format == 0)
+			buffer->format	  = (pdc_info->flags & BG_SWAP)?
+				INBAND_CMD_GRAPHIC_FORMAT_RGBA8888 : INBAND_CMD_GRAPHIC_FORMAT_ARGB8888_LITTLE;
+
+		if (!(buffer->flags & eBuffer_USE_GLOBAL_ALPHA))
+			buffer->alpha	   = pdc_info->gAlpha;
+	}
+
+	if (pdc_info->CTX == -1)
+		pdc_info->CTX = 0;
+	else
+		pdc_info->CTX++;
+
+	buffer->context = pdc_info->CTX;
+
+	return 0;
+}
+
+static int dc_queue_vo_buffer(DC_INFO *pdc_info, struct dc_buffer *buffer)
+{
+	VIDEO_GRAPHIC_PICTURE_OBJECT obj;
+
+	if (!(pdc_info->flags & RPC_READY)) {
+		eprintk("[%s %d] pdc_info->RING_HEADER = %p\n",
+			__func__, __LINE__, pdc_info->RING_HEADER);
+		buffer->id = eFrameBufferSkip;
+		return 0;
+	}
+
+	if (pdc_info->flags & SUSPEND) {
+		buffer->id = eFrameBufferSkip;
+		return 0;
+	}
+
+	obj.header.type = VIDEO_GRAPHIC_INBAND_CMD_TYPE_PICTURE_OBJECT;
+	obj.header.size = sizeof(VIDEO_GRAPHIC_PICTURE_OBJECT);
+	obj.context = (unsigned int) buffer->context;
+	obj.PTSH = 0;
+	obj.PTSL = 0;
+	obj.colorkey = -1;
+	obj.alpha = buffer->alpha;
+	obj.x = 0;
+	obj.y = 0;
+	obj.format = buffer->format;
+	obj.width = buffer->width;
+	obj.height = buffer->height;
+	obj.pitch = buffer->stride;
+	obj.address = buffer->phyAddr;
+	obj.address_right = 0;
+	obj.pitch_right = 0;
+	obj.picLayout = INBAND_CMD_GRAPHIC_2D_MODE;
+	obj.afbc = (buffer->flags & eBuffer_AFBC_Enable)?1:0;
+	obj.afbc_block_split = (buffer->flags & eBuffer_AFBC_Split)?1:0;
+	obj.afbc_yuv_transform = (buffer->flags & eBuffer_AFBC_YUV_Transform)?1:0;
+
+#ifdef DC2VO_SUPPORT_MEMORY_TRASH
+	if (gbMemoryTrash && obj.afbc)
+		obj.afbc |= VO_AFBC_DEBUG_MASK;
+#endif /* End of DC2VO_SUPPORT_MEMORY_TRASH */
+
+	if (ICQ_WriteCmd(&obj, pdc_info->RING_HEADER, pdc_info->RING_HEADER_BASE)) {
+		eprintk("[%s %d]ERROR!! Write CMD Error!\n",__FUNCTION__, __LINE__);
+		return -EAGAIN;
+	}
+
+#ifdef CONFIG_RTK_RPC
+	dc2vo_send_interrupt();
+#endif
+
+	return 0;
+}
+
+static int dc_queue_vo_buffer_partial(DC_INFO *pdc_info, struct dc_buffer *buffer)
+{
+	VIDEO_GRAPHIC_PICTURE_OBJECT_VERSION obj;
+
+	if (!(pdc_info->flags & RPC_READY)) {
+		eprintk("[%s %d] pdc_info->RING_HEADER = %p\n",
+			__func__, __LINE__, pdc_info->RING_HEADER);
+		buffer->id = eFrameBufferSkip;
+		return 0;
+	}
+
+	if (pdc_info->flags & SUSPEND) {
+		buffer->id = eFrameBufferSkip;
+		return 0;
+	}
+
+	obj.header.type = VIDEO_GRAPHIC_INBAND_CMD_TYPE_PICTURE_OBJECT;
+	obj.header.size = sizeof(VIDEO_GRAPHIC_PICTURE_OBJECT_VERSION);
+	obj.version = RTK_VERSION_0;
+	obj.format = buffer->format;
+	obj.PTSH = 0;
+	obj.PTSL = 0;
+	obj.context = (unsigned int) buffer->context;
+	obj.colorkey = -1;
+	obj.alpha = buffer->alpha;
+	obj.x = 0;
+	obj.y = 0;
+	obj.width = buffer->width;
+	obj.height = buffer->height;
+	obj.address = buffer->phyAddr;
+	obj.pitch = buffer->stride;
+	obj.address_right = 0;
+	obj.pitch_right = 0;
+	obj.picLayout = INBAND_CMD_GRAPHIC_2D_MODE;
+	// partial update only support non-afbc
+	obj.afbc = 0;
+	obj.afbc_block_split = 0;
+	obj.afbc_yuv_transform = 0;
+	obj.partialSrcWin_x = buffer->partial_x;
+	obj.partialSrcWin_y = buffer->partial_y;
+	obj.partialSrcWin_w = buffer->partial_w;
+	obj.partialSrcWin_h = buffer->partial_h;
+
+	if (ICQ_WriteCmd(&obj, pdc_info->RING_HEADER, pdc_info->RING_HEADER_BASE)) {
+		eprintk("[%s %d]ERROR!! Write CMD Error!\n",__FUNCTION__, __LINE__);
+		return -EAGAIN;
+	}
+
+#ifdef CONFIG_RTK_RPC
+	dc2vo_send_interrupt();
+#endif
+
+	return 0;
+}
+
+static int dc_queue_framebuffer(DC_INFO *pdc_info, struct dc_buffer *buffer)
+{
+
+	dprintk("[%s %d]\n", __func__, __LINE__);
+
+	if(dc_prepare_framebuffer(pdc_info, buffer))
+		goto err;
+
+	if(dc_queue_vo_buffer(pdc_info, buffer))
+		goto err;
+
+	return 0;
+
+err:
+	return -EAGAIN;
+}
+
+static int dc_queue_framebuffer_target(DC_INFO *pdc_info, struct dc_buffer *buffer)
+{
+
+	dprintk("[%s %d]\n", __func__, __LINE__);
+
+	if(dc_prepare_framebuffer_target(pdc_info, buffer))
+		goto err;
+
+	if(dc_queue_vo_buffer(pdc_info, buffer))
+		goto err;
+
+	return 0;
+
+err:
+	return -EAGAIN;
+}
+
+static int dc_queue_framebuffer_partial(DC_INFO *pdc_info, struct dc_buffer *buffer)
+{
+
+	dprintk("[%s %d]\n", __func__, __LINE__);
+
+	if(dc_prepare_framebuffer_target(pdc_info, buffer))
+		goto err;
+
+	if(dc_queue_vo_buffer_partial(pdc_info, buffer))
+		goto err;
+
+	return 0;
+
+err:
+	return -EAGAIN;
+}
+
+static int dc_queue_user_buffer(DC_INFO *pdc_info, struct dc_buffer *buffer)
+{
+
+	dprintk("[%s %d]\n", __func__, __LINE__);
+
+	if(dc_prepare_user_buffer(pdc_info, buffer))
+		goto err;
+
+	if(dc_queue_vo_buffer(pdc_info, buffer))
+		goto err;
+
+	return 0;
+
+err:
+	return -EAGAIN;
+}
+
+static int dc_wait_context_ready(DC_INFO *pdc_info, unsigned int context, unsigned int maxWaitVsync)
+{
+	u32 refContext = 0;
+	bool recheck;
+	bool overflow;
+
+	do {
+		refContext = pli_IPCReadULONG((BYTE*)&pdc_info->REF_CLK->videoContext);
+
+		if ((refContext > (context + 1)) && (refContext != -1U))
+			wprintk("refContext:%d context:%d \n", refContext, context);
+
+		if (context > refContext && (context - refContext) > (-1U/2))
+			overflow = true;
+		else
+			overflow = false;
+
+		if (!overflow) {
+			if (refContext >= context)
+				break;
+		} else {
+			iprintk("refContext:%d context:%d overflow:%d\n", refContext, context, overflow);
+			break;
+		}
+
+		if (pdc_info->flags & SUSPEND)
+			break;
+
+		if (dc_wait_vsync_timeout(pdc_info))
+			goto err;
+
+		if (maxWaitVsync == -1U || maxWaitVsync > 0)
+			recheck = true;
+		else
+			recheck = false;
+
+		if (maxWaitVsync != -1U)
+			maxWaitVsync--;
+
+	} while (recheck);
+
+	if (!maxWaitVsync)
+		goto err;
+
+	return 0;
+err:
+	eprintk("[%s %d] context:%d refContext:%d waitVsyncTimes %d\n",
+			__func__, __LINE__, context, refContext, 10 - maxWaitVsync);
+	return -EAGAIN;
+}
+
+static int dc_vo_post(DC_INFO *pdc_info, struct dc_buffer *buf)
+{
+	int ret = 0;
+
+	if (buf->id == eFrameBuffer) {
+		ret = dc_queue_framebuffer(pdc_info, buf);
+	} else if (buf->id == eUserBuffer) {
+		ret = dc_queue_user_buffer(pdc_info, buf);
+	} else if (buf->id == eFrameBufferTarget) {
+		ret = dc_queue_framebuffer_target(pdc_info, buf);
+	} else if (buf->id == eFrameBufferPartial) {
+		ret = dc_queue_framebuffer_partial(pdc_info, buf);
+	} else if (buf->id == eFrameBufferSkip) {
+		dprintk("eFrameBufferSkip!");
+	} else
+		eprintk("buffer id (%u) is not ready!",buf->id)
+
+	if (ret)
+		goto err;
+
+	return 0;
+err:
+	dc_buffer_dump(buf);
+	return ret;
+}
+
+static int dc_vo_complete(DC_INFO *pdc_info, struct dc_buffer *buf)
+{
+	int ret = 0;
+
+	switch (buf->id) {
+		case eUserBuffer:
+		case eFrameBuffer:
+			{
+				unsigned int maxWaitVsync = 10;
+				unsigned int waitContext;
+				if ((buf->context > 0) && !(pdc_info->flags & VSYNC_FORCE_LOCK))
+					waitContext = buf->context - 1;
+				else
+					waitContext = buf->context;
+				ret = dc_wait_context_ready(pdc_info, waitContext, maxWaitVsync);
+				break;
+			}
+		case eFrameBufferTarget:
+		case eFrameBufferPartial:
+			{
+				unsigned int maxWaitVsync = -1U;
+				unsigned int waitContext;
+				if ((buf->context > 0) && !(pdc_info->flags & VSYNC_FORCE_LOCK))
+					waitContext = buf->context;
+				else
+					waitContext = buf->context + 1;
+				ret = dc_wait_context_ready(pdc_info, waitContext, maxWaitVsync);
+				break;
+			}
+		case eFrameBufferSkip:
+			{
+				dprintk("eFrameBufferSkip!");
+				break;
+			}
+		default:
+			{
+				eprintk("buffer id (%u) is not ready!",buf->id);
+				ret = -1;
+				break;
+			}
+	}
+
+	if (ret)
+		goto err;
+
+#ifdef DC2VO_SUPPORT_MEMORY_TRASH
+	if (gbMemoryTrash) {
+		static u32 tempContext = -1U;
+		u32 errContext = pli_IPCReadULONG((BYTE*)&pdc_info->REF_CLK->memorytrashContext);
+		if (errContext != -1) {
+			u32 errPhyAddr = pli_IPCReadULONG((BYTE*)&pdc_info->REF_CLK->memorytrashAddr);
+			wprintk("[%s] (MemoryTrash) err: %d(0x%08x) free: %d(%08x) CTX:%d\n",
+					__FUNCTION__, errContext, errPhyAddr, buf->context, buf->phyAddr, pdc_info->CTX);
+			pli_IPCWriteULONG((BYTE *) &pdc_info->REF_CLK->memorytrashContext, -1);
+		}
+
+		if (tempContext != -1U && buf->context != (tempContext+1))
+			wprintk("[%s] tempContext:%d free: %d(%08x) CTX:%d\n",
+					__FUNCTION__, tempContext, buf->context, buf->phyAddr, pdc_info->CTX);
+
+		tempContext = buf->context;
+	}
+#endif /* End of DC2VO_SUPPORT_MEMORY_TRASH */
+
+#ifdef DC2VO_SUPPORT_DCSYS_DEBUG
+	dc_sys_debug_trigger();
+#endif /* End of DC2VO_SUPPORT_DCSYS_DEBUG */
+	return 0;
+err:
+	dc_buffer_dump(buf);
+	return ret;
+}
+
+static void dc_post_work_func(struct kthread_work *work)
+{
+	DC_INFO *pdc_info =
+		container_of(work, DC_INFO, post_work);
+	struct dc_pending_post *post, *next;
+	struct list_head saved_list;
+
+	mutex_lock(&pdc_info->post_lock);
+	memcpy(&saved_list, &pdc_info->post_list, sizeof(saved_list));
+	list_replace_init(&pdc_info->post_list, &saved_list);
+	mutex_unlock(&pdc_info->post_lock);
+
+	dprintk("[%s %d]\n", __func__, __LINE__);
+
+	list_for_each_entry_safe(post, next, &saved_list, head) {
+		int i;
+
+		for (i = 0; i < post->config.n_bufs; i++) {
+			struct sync_file *fence =
+				post->config.bufs[i].acquire.fence;
+			if (fence)
+				dc_fence_wait(pdc_info, fence);
+		}
+
+		for (i = 0; i < post->config.n_bufs; i++) {
+			struct dc_buffer *buffer = &post->config.bufs[i];
+			if (buffer->overlay_engine == eEngine_VO) {
+				dc_vo_post(pdc_info, buffer);
+			} else
+				eprintk("overlay_engine (%u) is not ready!",buffer->overlay_engine)
+		}
+
+		mutex_lock(&pdc_info->complete_lock);
+		INIT_LIST_HEAD(&post->head);
+		list_add_tail(&post->head, &pdc_info->complete_list);
+		kthread_queue_work(&pdc_info->complete_worker, &pdc_info->complete_work);
+		mutex_unlock(&pdc_info->complete_lock);
+	}
+}
+
+static void dc_complete_work_func(struct kthread_work *work)
+{
+	DC_INFO *pdc_info =
+		container_of(work, DC_INFO, complete_work);
+	struct dc_pending_post *post, *next;
+	struct list_head saved_list;
+
+	mutex_lock(&pdc_info->complete_lock);
+	memcpy(&saved_list, &pdc_info->complete_list, sizeof(saved_list));
+	list_replace_init(&pdc_info->complete_list, &saved_list);
+	mutex_unlock(&pdc_info->complete_lock);
+
+	list_for_each_entry_safe(post, next, &saved_list, head) {
+		int i;
+		for (i = 0; i < post->config.n_bufs; i++) {
+			struct dc_buffer *buffer = &post->config.bufs[i];
+			if (buffer->overlay_engine == eEngine_VO) {
+				dc_vo_complete(pdc_info, buffer);
+			} else
+				eprintk("overlay_engine (%u) is not ready!",buffer->overlay_engine)
+		}
+#ifdef CREATE_THREAD_FOR_RELEASE_DEBUG
+		mutex_lock(&pdc_info->free_lock);
+		INIT_LIST_HEAD(&post->head);
+		list_add_tail(&post->head, &pdc_info->free_list);
+		kthread_queue_work(&pdc_info->free_worker, &pdc_info->free_work);
+		mutex_unlock(&pdc_info->free_lock);
+#else /* else of CREATE_THREAD_FOR_RELEASE_DEBUG */
+		dc_sw_advance_timeline(pdc_info);
+		list_del(&post->head);
+		if (pdc_info->onscreen)
+			dc_post_cleanup(pdc_info, pdc_info->onscreen);
+		pdc_info->onscreen = post;
+		//dc_post_cleanup(pdc_info, post);
+#endif /* End of CREATE_THREAD_FOR_RELEASE_DEBUG */
+	}
+}
+
+#ifdef CREATE_THREAD_FOR_RELEASE_DEBUG
+static void dc_free_work_func(struct kthread_work *work)
+{
+	DC_INFO *pdc_info =
+		container_of(work, DC_INFO, free_work);
+	struct dc_pending_post *post, *next;
+	struct list_head saved_list;
+
+	mutex_lock(&pdc_info->free_lock);
+	memcpy(&saved_list, &pdc_info->free_list, sizeof(saved_list));
+	list_replace_init(&pdc_info->free_list, &saved_list);
+	mutex_unlock(&pdc_info->free_lock);
+
+	list_for_each_entry_safe(post, next, &saved_list, head) {
+		//dc_wait_vsync_timeout(pdc_info);
+		dc_sw_advance_timeline(pdc_info);
+		list_del(&post->head);
+		if (pdc_info->onscreen)
+			dc_post_cleanup(pdc_info, pdc_info->onscreen);
+		pdc_info->onscreen = post;
+		//dc_post_cleanup(pdc_info, post);
+	}
+}
+#endif /* End of CREATE_THREAD_FOR_RELEASE_DEBUG */
+
+int Init_post_Worker(VENUSFB_MACH_INFO * video_info)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+    struct sched_param param = { .sched_priority = MAX_RT_PRIO - 1 };
+
+	INIT_LIST_HEAD(&pdc_info->post_list);
+	INIT_LIST_HEAD(&pdc_info->complete_list);
+	mutex_init(&pdc_info->post_lock);
+	mutex_init(&pdc_info->complete_lock);
+	kthread_init_worker(&pdc_info->post_worker);
+	kthread_init_worker(&pdc_info->complete_worker);
+#ifdef CREATE_THREAD_FOR_RELEASE_DEBUG
+	INIT_LIST_HEAD(&pdc_info->free_list);
+	mutex_init(&pdc_info->free_lock);
+	kthread_init_worker(&pdc_info->free_worker);
+#endif /* End of CREATE_THREAD_FOR_RELEASE_DEBUG */
+
+	pdc_info->timeline = NULL;
+	pdc_info->timeline_max = 0;
+
+	pdc_info->post_thread = kthread_run(kthread_worker_fn,
+			&pdc_info->post_worker, "rtk_post_worker");
+    sched_setscheduler(pdc_info->post_thread , SCHED_FIFO, &param);
+
+	pdc_info->complete_thread = kthread_run(kthread_worker_fn,
+			&pdc_info->complete_worker, "rtk_complete_worker");
+    sched_setscheduler(pdc_info->complete_thread , SCHED_FIFO, &param);
+
+#ifdef CREATE_THREAD_FOR_RELEASE_DEBUG
+	pdc_info->free_thread = kthread_run(kthread_worker_fn,
+			&pdc_info->free_worker, "rtk_complete_worker");
+    sched_setscheduler(pdc_info->free_thread , SCHED_FIFO, &param);
+#endif /* End of CREATE_THREAD_FOR_RELEASE_DEBUG */
+
+	if (IS_ERR(pdc_info->post_thread)) {
+		int ret = PTR_ERR(pdc_info->post_thread);
+		pdc_info->post_thread = NULL;
+		pr_err("%s: failed to run config posting thread: %d\n",
+				__func__, ret);
+		goto err;
+	}
+
+	if (IS_ERR(pdc_info->complete_thread)) {
+		int ret = PTR_ERR(pdc_info->complete_thread);
+		pdc_info->complete_thread = NULL;
+		pr_err("%s: failed to run config complete thread: %d\n",
+				__func__, ret);
+		goto err;
+	}
+
+#ifdef CREATE_THREAD_FOR_RELEASE_DEBUG
+	if (IS_ERR(pdc_info->free_thread)) {
+		int ret = PTR_ERR(pdc_info->free_thread);
+		pdc_info->free_thread = NULL;
+		pr_err("%s: failed to run config complete thread: %d\n",
+				__func__, ret);
+		goto err;
+	}
+#endif /* End of CREATE_THREAD_FOR_RELEASE_DEBUG */
+
+	kthread_init_work(&pdc_info->post_work, dc_post_work_func);
+	kthread_init_work(&pdc_info->complete_work, dc_complete_work_func);
+#ifdef CREATE_THREAD_FOR_RELEASE_DEBUG
+	kthread_init_work(&pdc_info->free_work, dc_free_work_func);
+#endif /* End of CREATE_THREAD_FOR_RELEASE_DEBUG */
+
+	return 0;
+
+err:
+	if (pdc_info->post_thread) {
+		kthread_flush_worker(&pdc_info->post_worker);
+		kthread_stop(pdc_info->post_thread);
+	}
+
+	if (pdc_info->complete_thread) {
+		kthread_flush_worker(&pdc_info->complete_worker);
+		kthread_stop(pdc_info->complete_thread);
+	}
+
+#ifdef CREATE_THREAD_FOR_RELEASE_DEBUG
+	if (pdc_info->free_thread) {
+		kthread_flush_worker(&pdc_info->free_worker);
+		kthread_stop(pdc_info->free_thread);
+	}
+#endif /* End of CREATE_THREAD_FOR_RELEASE_DEBUG */
+	return -1;
+}
+
+int DeInit_post_Worker(VENUSFB_MACH_INFO * video_info)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	if (pdc_info->post_thread) {
+		kthread_flush_worker(&pdc_info->post_worker);
+		kthread_stop(pdc_info->post_thread);
+	}
+	if (pdc_info->complete_thread) {
+		kthread_flush_worker(&pdc_info->complete_worker);
+		kthread_stop(pdc_info->complete_thread);
+	}
+#ifdef CREATE_THREAD_FOR_RELEASE_DEBUG
+	if (pdc_info->free_thread) {
+		kthread_flush_worker(&pdc_info->free_worker);
+		kthread_stop(pdc_info->free_thread);
+	}
+#endif /* End of CREATE_THREAD_FOR_RELEASE_DEBUG */
+
+	if (pdc_info->timeline)
+		sync_timeline_put( (struct sync_timeline *) pdc_info->timeline);
+
+	return 0;
+}
+
+int DC_Init(VENUSFB_MACH_INFO * video_info, struct fb_info *fbi, int irq)
+{
+	int retval = 0;
+
+	pr_info("[%s] start\n", __func__);
+
+	if (DCINIT)
+	{
+#ifdef CONFIG_VFB_RTK //def __LINUX_MEDIA_NAS_
+		//Fix Graphic(/dev/fb0) and Video(/dev/fb1) use the same dc2vo issue
+	        if(video_info->dc_info == NULL)
+        	    video_info->dc_info = gpdc_info;
+#endif
+		goto DONE;
+	}
+
+	if (video_info->dc_info == NULL) {
+
+		DC_INFO *pdc_info = NULL;
+		struct rtk_ipc_shm __iomem *ipc = (void __iomem *)IPC_SHM_VIRT;
+		ipc = (void __iomem *)IPC_SHM_VIRT;
+
+		pr_info("[%s] allocate DC info buffer\n", __func__);
+
+		video_info->dc_info = (DC_INFO *) kzalloc(sizeof(DC_INFO), GFP_KERNEL);
+		pdc_info = (DC_INFO *) video_info->dc_info;
+
+		/* DC_INFO SET DEFAULT */
+		memset(video_info->dc_info, 0, sizeof(DC_INFO));
+
+		pr_info("[%s] rpc_common_base = %p, ipc = %p\n", __func__, rpc_common_base, ipc);
+
+		init_waitqueue_head(&pdc_info->vsync_wait);
+
+		pdc_info->gAlpha = 0;
+		pdc_info->vsync_timeout_ms = 1000;
+		pdc_info->flags &= ~BG_SWAP;
+		pdc_info->flags |= VSYNC_FORCE_LOCK;
+		pdc_info->pfbi = fbi;
+		pdc_info->vo_vsync_flag = &ipc->vo_int_sync;
+		pdc_info->irq = irq;
+		rwlock_init(&pdc_info->vsync_lock);
+
+#ifdef CONFIG_RTK_RPC
+		gpdc_info = (DC_INFO*)video_info->dc_info;
+#endif
+	} else {
+		pr_warn("[%s] allocate DC info buffer are alrealy done? (%p)\n",  __func__, video_info->dc_info);
+	}
+
+	retval = Init_post_Worker(video_info);
+	if (retval)
+		goto DONE;
+
+	if (Activate_vSync(video_info)) {
+		pr_err("[%s %d] error video_info = %p\n", __func__, __LINE__, video_info);
+		retval = -1;
+		goto DONE;
+	}
+
+	DCINIT = 1;
+
+DONE:
+	pr_info("[%s] done\n", __func__);
+
+	return retval;
+}
+
+void DC_Deinit(VENUSFB_MACH_INFO * video_info)
+{
+	iprintk("[%s %d]\n",__func__,__LINE__);
+	DeInit_post_Worker(video_info);
+	DeInit_vSync(video_info);
+	if (video_info->dc_info != NULL) {
+#if 1
+		iprintk("[%s %d] NOT TO FREE DC INFO BUFFER!",__func__,__LINE__);
+#else
+		kfree(video_info->dc_info);
+		video_info->dc_info = NULL;
+#endif
+	} else {
+		wprintk("[%s %d] video_info->dc_info == NULL \n",__func__,__LINE__);
+	}
+	DCINIT = 0;
+}
+
+int DC_Suspend (VENUSFB_MACH_INFO * video_info)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	pdc_info->flags |= SUSPEND;
+	kthread_flush_worker(&pdc_info->post_worker);
+	//kthread_flush_worker(&pdc_info->complete_worker);
+
+	/* Disable the interrup */
+	DC_RESET_BIT(pdc_info->vo_vsync_flag, DC_VO_SET_NOTIFY);
+
+	msleep(5);
+	return 0;
+}
+
+int DC_Resume (VENUSFB_MACH_INFO * video_info)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	DC_SET_BIT(pdc_info->vo_vsync_flag, DC_VO_SET_NOTIFY);
+	smp_mb();
+	pdc_info->flags		 &= ~SUSPEND;
+	smp_mb();
+	return 0;
+}
+
+#ifdef CONFIG_REALTEK_AVCPU
+int DC_avcpu_event_notify(unsigned long action, VENUSFB_MACH_INFO * video_info)
+{
+	DC_INFO * pdc_info = (DC_INFO*)video_info->dc_info;
+	switch (action) {
+		case AVCPU_RESET_PREPARE:
+			smp_mb();
+			pdc_info->flags &= ~RPC_READY;
+			smp_mb();
+			DC_RESET_BIT(pdc_info->vo_vsync_flag, DC_VO_SET_NOTIFY);
+			break;
+		case AVCPU_RESET_DONE:
+			DC_SET_BIT(pdc_info->vo_vsync_flag, DC_VO_SET_NOTIFY);
+			break;
+		case AVCPU_SUSPEND:
+		case AVCPU_RESUME:
+			break;
+		default:
+			break;
+	}
+	return 0;
+}
+#endif
+
+#ifdef DC2VO_SUPPORT_DCSYS_DEBUG
+static inline void dc_sys_debug_trigger(void) {
+	if (gsDcSysDebugThread != NULL)
+		kthread_queue_work(&gsDcSysDebugWorker, &gsDcSysDebugWork);
+}
+
+static void dc_sys_debug_work_func(struct kthread_work *work)
+{
+	if (gpDcSysControl == NULL)
+		return;
+
+	if (readl(gpDcSysControl) & DC2VO_DCSYS_CONTROL_ERROR)
+		gbDcSysError = true;
+
+	if (gbDcSysError)
+		eprintk("[%s] dc_sys_debug(0x%08x) = 0x%08x\n", __FUNCTION__,
+				DC2VO_DCSYS_CONTROL, readl(gpDcSysControl));
+}
+
+static int __init dc2vo_dcsys_debug_init(void)
+{
+	if (gpDcSysControl == NULL)
+		gpDcSysControl = ioremap(DC2VO_DCSYS_CONTROL, 0x4);
+
+	if (gpDcSysControl == NULL)
+		return -ENOMEM;
+
+	gbDcSysError = false;
+
+	writel((readl(gpDcSysControl) | DC2VO_DCSYS_CONTROL_SETUP) & ~DC2VO_DCSYS_CONTROL_ERROR, gpDcSysControl);
+
+	kthread_init_worker(&gsDcSysDebugWorker);
+
+	gsDcSysDebugThread = kthread_run(kthread_worker_fn,
+			&gsDcSysDebugWorker, "dc_sys_debug_worker");
+
+	kthread_init_work(&gsDcSysDebugWork, dc_sys_debug_work_func);
+	return 0;
+}
+
+module_init(dc2vo_dcsys_debug_init)
+#endif /* End of DC2VO_SUPPORT_DCSYS_DEBUG */
+
+#ifdef CONFIG_SYSFS
+
+#define DC2VO_ATTR(_name)				   \
+{										   \
+	.attr = {.name = #_name, .mode = 0644}, \
+	.show =  dc2vo_##_name##_show,	\
+	.store = dc2vo_##_name##_store,   \
+}
+
+#ifdef DC2VO_SUPPORT_MEMORY_TRASH
+static ssize_t dc2vo_memory_trash_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+	int n = 0;
+	n += sprintf(buf+n,			 "MemoryTrashEn  : %d\n", gbMemoryTrash);
+	return n;
+}
+
+static ssize_t dc2vo_memory_trash_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+	if (ret < 0)
+		return -ENOMEM;
+	gbMemoryTrash = (val == 0)?false:true;
+	return count;
+}
+
+static struct kobj_attribute dc2vo_memory_trash_attr = DC2VO_ATTR(memory_trash);
+#endif /* End of DC2VO_SUPPORT_MEMORY_TRASH */
+
+#ifdef DC2VO_SUPPORT_DCSYS_DEBUG
+static ssize_t dc2vo_dcsys_debug_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+	int n = 0;
+	n += sprintf(buf+n,			 "DcSysError	 : %d\n", gbDcSysError);
+	if (gpDcSysControl != NULL)
+		n += sprintf(buf+n,		 "DcSysControl   : 0x%08x\n", readl(gpDcSysControl));
+	return n;
+}
+
+static ssize_t dc2vo_dcsys_debug_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+	long val;
+	int ret = kstrtol(buf, 10, &val);
+	if (ret < 0)
+		return -ENOMEM;
+	if (ret == 0) {
+		if (gpDcSysControl != NULL && gbDcSysError)
+			writel(readl(gpDcSysControl) & ~DC2VO_DCSYS_CONTROL_ERROR, gpDcSysControl);
+		gbDcSysError = false;
+	}
+	return count;
+}
+
+static struct kobj_attribute dc2vo_dcsys_debug_attr = DC2VO_ATTR(dcsys_debug);
+#endif /* End of DC2VO_SUPPORT_DCSYS_DEBUG */
+
+static struct attribute *dc2vo_attrs[] = {
+#ifdef DC2VO_SUPPORT_MEMORY_TRASH
+	&dc2vo_memory_trash_attr.attr,
+#endif /* End of DC2VO_SUPPORT_MEMORY_TRASH */
+#ifdef DC2VO_SUPPORT_DCSYS_DEBUG
+	&dc2vo_dcsys_debug_attr.attr,
+#endif /* End of DC2VO_SUPPORT_DCSYS_DEBUG */
+	NULL,
+};
+
+static struct attribute_group dc2vo_attr_group = {
+	.attrs = dc2vo_attrs,
+};
+
+static struct kobject *dc2vo_kobj;
+
+static int __init dc2vo_sysfs_init(void)
+{
+	int ret;
+
+	dc2vo_kobj = kobject_create_and_add("display", kernel_kobj);
+	if (!dc2vo_kobj)
+		return -ENOMEM;
+	ret = sysfs_create_group(dc2vo_kobj, &dc2vo_attr_group);
+	if (ret)
+		kobject_put(dc2vo_kobj);
+	return ret;
+}
+
+module_init(dc2vo_sysfs_init)
+#endif /* End of CONFIG_SYSFS */
diff --git a/drivers/video/fbdev/rtk/dc2vo/dc2vo.h b/drivers/video/fbdev/rtk/dc2vo/dc2vo.h
new file mode 100644
index 00000000..b86894d
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/dc2vo.h
@@ -0,0 +1,416 @@
+#ifndef __DC_HW_H__
+#define __DC_HW_H__
+
+#include <linux/fb.h>
+#include "dc_rpc.h"
+#include "../rtk_fb.h"
+
+#if defined(__cplusplus)
+extern "C" {
+#endif
+
+typedef struct DCRT_PARAM_BUF_ADDR
+{
+    unsigned int buf_Vaddr;
+    unsigned int buf_Paddr;
+    int buf_id;
+    unsigned int buf_size;
+    int format;
+    unsigned int width;
+    unsigned int height;
+    int param_size;	//fix to [7] position
+} DCRT_PARAM_BUF_ADDR;
+
+typedef struct DCRT_PARAM_OSD_ADDR
+{
+    int param_size;
+    //unsigned int buf_Vaddr;
+    unsigned int buf_Paddr;
+    //	unsigned int buf_size;
+    //int format;
+    int go;
+
+} DCRT_PARAM_OSD_ADDR;
+
+typedef struct DCRT_PARAM_RPC_ADDR
+{
+    unsigned int ringPhyAddr;
+    unsigned int refclockAddr;
+    int param_size;	//[2]-th pos
+
+} DCRT_PARAM_RPC_ADDR;
+
+typedef struct DCRT_PARAM_RPC_VIRT_ADDR
+{
+    void* ringheaderbaseVirtAddr;
+    void* ringVirtAddr;
+    void* refclockVirtAddr;
+} DCRT_PARAM_RPC_VIRT_ADDR;
+
+
+typedef struct 
+{
+    int param_size;
+    unsigned int pts_gap;
+    unsigned int hz; //50000, 60000 HZ ?
+    unsigned int clockAddrLow;
+    unsigned int clockAddrHi;
+
+} DCRT_PARAM_RATE_INFO;
+
+
+typedef struct 
+{
+    int param_size;
+    unsigned int interval;
+    unsigned int rateMode;
+
+} DCRT_PARAM_RATE_MODE;
+
+typedef struct 
+{
+    int param_size;
+    unsigned int mode;
+
+} DCRT_PARAM_DISABLE_MODE;
+
+typedef struct
+{
+    int ver;
+    int param_size;
+    unsigned int buf_Vaddr;
+    unsigned int buf_Paddr;
+    unsigned int buf_size;
+    int width;
+    int height;
+    int x;
+    int y;
+    //int format;
+} DCRT_PARAM_SURFACE;
+
+typedef enum
+{
+    DC_RT_FRAME_DISP_SYNC= 0,	//show last pic only
+    DC_RT_FRAME_DISP_ALL,
+} DC_RT_FRAME_DISP_MODE; 
+
+typedef enum
+{
+    GLDC_MODIFY_RESET       = 1<<1,
+    GLDC_MODIFY_ALPHA       = 1<<2,
+    GLDC_MODIFY_PLANE       = 1<<3,
+    GLDC_MODIFY_MODE_3D     = 1<<4,
+    GLDC_MODIFY_DISP_WIN    = 1<<5,
+    GLDC_MODIFY_BLENDING    = 1<<6
+} GLDC_CONFIG_MASK;
+
+typedef enum
+{
+    GLDC_BLEND_MODE_OVERLAY = 0,
+    GLDC_BLEND_MODE_BLENDING = 1  //default
+
+} GLDC_OSD_BLEND_MODE;
+
+enum VO_GRAPHIC_PLANE {
+    VO_GRAPHIC_OSD            = 0,
+    VO_GRAPHIC_SUB1            = 1,
+    VO_GRAPHIC_SUB2            = 2,
+};
+typedef enum VO_GRAPHIC_PLANE VO_GRAPHIC_PLANE;
+
+struct VO_RECTANGLE {
+    u_short                x;
+    u_short                y;
+    u_short                width;
+    u_short                height;
+};
+typedef struct VO_RECTANGLE VO_RECTANGLE;
+
+typedef struct 
+{
+    unsigned int		 	cfg;
+    VO_GRAPHIC_PLANE		plane;
+    VO_RECTANGLE       		dispWin;
+    unsigned int			alpha;//valid value: 0~254
+    int 					mode3D; //0: disable (INBAND_CMD_GRAPHIC_3D_MODE)
+
+    char				blendMode; //1: blending, 0: overlay
+    char 				rev[31]; 	//reserve
+
+} GLDC_MODIFY_COMMAND;
+
+
+typedef struct{
+    REFCLOCK RefClock;
+    unsigned long long PTS;
+    unsigned int CTX;
+    unsigned int OSD2VO_Delay_us;
+    unsigned int FPS;
+    unsigned int RATE_GAP;
+    unsigned long long RefClockAddr;
+    unsigned long long ClockAddr_HI;
+    unsigned long long ClockAddr_LOW;
+    long long RTK90KClock;
+    int WAIT_ISR;
+    unsigned int FlipTimeTemp;
+} DC_SYSTEM_TIME_INFO;
+
+typedef struct{
+    unsigned int HiOffset;
+    unsigned int LowOffset;
+} DC_CLOCK_MAP_INFO;
+
+typedef enum {
+    ResetOption_videoSystemPTS      = 0x1 <<0,
+    ResetOption_audioSystemPTS      = 0x1 <<1,
+    ResetOption_videoRPTS           = 0x1 <<2,
+    ResetOption_audioRPTS           = 0x1 <<3,
+    ResetOption_videoContext        = 0x1 <<4,
+    ResetOption_audioContext        = 0x1 <<5,
+    ResetOption_videoEndOfSegment   = 0x1 <<6,
+    ResetOption_RCD                 = 0x1 <<7,
+}ResetOption;
+
+typedef enum
+{ 
+    INBAND_CMD_GRAPHIC_2D_MODE              = 0,
+    INBAND_CMD_GRAPHIC_SIDE_BY_SIDE         = 1,
+    INBAND_CMD_GRAPHIC_TOP_AND_BOTTOM       = 2,
+    INBAND_CMD_GRAPHIC_FRAME_PACKING        = 3
+} INBAND_CMD_GRAPHIC_3D_MODE ;
+
+typedef struct
+{
+    INBAND_CMD_PKT_HEADER header ;
+    INBAND_CMD_GRAPHIC_FORMAT format ;
+    unsigned int PTSH ;
+    unsigned int PTSL ;
+    unsigned int context ;  /* system can check it to know which picture displaying on VO */
+    int colorkey ;          /* -1: disable colorkey */
+    int alpha ;             /*  0: disable constant alpha */
+    unsigned int x ;
+    unsigned int y ;
+    unsigned int width ;
+    unsigned int height ;
+    unsigned int address ;
+    unsigned int pitch ;
+    unsigned int address_right ;
+    unsigned int pitch_right ;
+    INBAND_CMD_GRAPHIC_3D_MODE picLayout ;
+    unsigned int afbc ;
+    unsigned int afbc_block_split ;
+    unsigned int afbc_yuv_transform ;
+
+} VIDEO_GRAPHIC_PICTURE_OBJECT ;
+
+typedef struct
+{
+    INBAND_CMD_PKT_HEADER header;
+    unsigned int version;
+    INBAND_CMD_GRAPHIC_FORMAT format;
+    unsigned int PTSH;
+    unsigned int PTSL;
+    unsigned int context;  /* system can check it to know which picture displaying on VO */
+    int colorkey;          /* -1: disable colorkey */
+    int alpha;             /*  0: disable constant alpha */
+    unsigned int x;
+    unsigned int y;
+    unsigned int width;
+    unsigned int height;
+    unsigned int address;
+    unsigned int pitch;
+    unsigned int address_right;
+    unsigned int pitch_right;
+    INBAND_CMD_GRAPHIC_3D_MODE picLayout;
+    unsigned int afbc;
+    unsigned int afbc_block_split;
+    unsigned int afbc_yuv_transform;
+    unsigned int partialSrcWin_x;
+    unsigned int partialSrcWin_y;
+    unsigned int partialSrcWin_w;
+    unsigned int partialSrcWin_h;
+} VIDEO_GRAPHIC_PICTURE_OBJECT_VERSION;
+
+#define RTK_VERSION_0 0x72746B30
+
+typedef struct {
+    int sfd_refclk;
+    int sfd_rbHeader;
+    int sfd_rbBase;
+    long long vo_instance_id;
+    unsigned int reserve[16-5];
+} DC_ION_SHARE_MEMORY ;
+
+typedef struct {
+    long long vo_instance_id;
+    unsigned int reserve[16-2];
+} DC_VO_INSTANCE_INFO;
+
+typedef struct {
+    unsigned int enable ;
+    unsigned int width ;
+    unsigned int height ;
+    unsigned int reserve[16-3];
+} DC_BUFFER_INFO ;
+
+#define DC_SHORT_FENCE_TIMEOUT  (60)
+#define DC_LONG_FENCE_TIMEOUT   (120)
+
+enum dc_buffer_id {
+    eFrameBuffer            = 0x1U << 0,
+    eIONBuffer              = 0x1U << 1,
+    eUserBuffer             = 0x1U << 2,
+    eFrameBufferTarget      = 0x1U << 3,
+    eFrameBufferPartial     = 0x1U << 4,
+    eFrameBufferSkip        = 0x1U << 5,
+};
+
+enum dc_overlay_engine {
+    eEngine_VO              = 0x1U << 0,
+    eEngine_SE              = 0x1U << 1,
+    eEngine_DMA             = 0x1U << 2,
+    eEngine_MAX             = 0x1U << 3,
+};
+
+struct dc_buffer_rect {
+    u32                     left;
+    u32                     top;
+    u32                     right;
+    u32                     bottom;
+};
+
+union _fence_data{
+    int64_t                 fence_fd;   /* user   space : fenceFd (input) */
+    struct sync_file       *fence;     /* kernel space : sync_file to wait fence sync */
+};
+
+enum dc_buffer_flags {
+    eBuffer_AFBC_Enable            = 0x1U << 16,
+    eBuffer_AFBC_Split             = 0x1U << 17,
+    eBuffer_AFBC_YUV_Transform     = 0x1U << 18,
+    eBuffer_USE_GLOBAL_ALPHA       = 0x1U << 19,
+};
+
+struct dc_buffer {
+    u32                     id;                 /* enum dc_buffer_id */
+    u32                     overlay_engine;     /* enum dc_overlay_engine */
+    struct dc_buffer_rect   sourceCrop;
+    struct dc_buffer_rect   displayFrame;       /* base on framebuffer */
+    u32                     format;
+    u32                     offset;
+    u32                     phyAddr;
+    u32                     width;
+    u32                     height;
+    u32                     stride;
+    u32                     context;
+    int64_t                 pts;
+    u32                     flags;
+    u32                     alpha; /* need to enable eBuffer_USE_GLOBAL_ALPHA, 0 : Pixel Alpha */
+    u32                     partial_x;
+    u32                     partial_y;
+    u32                     partial_w;
+    u32                     partial_h;
+    u32                     reserve[27];
+    union _fence_data       acquire;
+};
+
+#if 0
+struct dc_buffer_config {
+    struct dc_buffer        buffer;
+};
+#endif
+
+struct dc_post {
+    u32                     n_bufs;
+    struct dc_buffer        *bufs;
+};
+
+struct dc_pending_post {
+    struct list_head        head;
+    struct dc_post          config;
+    union _fence_data       release;
+};
+
+//TODO::
+#if 0
+struct dc_post_config {
+    size_t                  n_bufs;
+    struct dc_buffer_config __user *bufs;
+    __s64                   complete_fence;
+};
+#endif
+
+struct dc_simple_post_config {
+	struct dc_buffer        buf;
+	int                     complete_fence_fd;
+};
+
+
+/*
+ * Ioctl
+ */
+
+#define DC2VO_IOC_MAGIC        'd'
+#define DC2VO_IOC_MAXNR        32
+#define DC2VO_WAIT_FOR_VSYNC             _IO    (DC2VO_IOC_MAGIC,  0)
+#define DC2VO_SET_BUFFER_ADDR            _IO    (DC2VO_IOC_MAGIC,  1)
+#define DC2VO_GET_BUFFER_ADDR            _IO    (DC2VO_IOC_MAGIC,  2)
+#define DC2VO_SET_RING_INFO              _IO    (DC2VO_IOC_MAGIC,  3)
+#define DC2VO_SET_OUT_RATE_INFO          _IO    (DC2VO_IOC_MAGIC,  4)
+#define DC2VO_SET_DISABLE                _IO    (DC2VO_IOC_MAGIC,  5)
+#define DC2VO_GET_SURFACE                _IO    (DC2VO_IOC_MAGIC,  6)
+#define DC2VO_SET_MODIFY                 _IO    (DC2VO_IOC_MAGIC,  7)
+#define DC2VO_GET_MAX_FRAME_BUFFER       _IO    (DC2VO_IOC_MAGIC,  8)
+#define DC2VO_GET_SYSTEM_TIME_INFO       _IO    (DC2VO_IOC_MAGIC,  9)
+#define DC2VO_SET_SYSTEM_TIME_INFO       _IO    (DC2VO_IOC_MAGIC, 10)
+#define DC2VO_GET_CLOCK_MAP_INFO         _IO    (DC2VO_IOC_MAGIC, 11)
+#define DC2VO_GET_CLOCK_INFO             _IO    (DC2VO_IOC_MAGIC, 12)
+#define DC2VO_RESET_CLOCK_TABLE          _IO    (DC2VO_IOC_MAGIC, 13)
+#define DC2VO_SET_ION_SHARE_MEMORY       _IO    (DC2VO_IOC_MAGIC, 17)
+#define DC2VO_SET_BUFFER_INFO            _IO    (DC2VO_IOC_MAGIC, 18)
+#define DC2VO_SET_BG_SWAP                _IO    (DC2VO_IOC_MAGIC, 19)
+#define DC2VO_SET_GLOBAL_ALPHA           _IO    (DC2VO_IOC_MAGIC, 20)
+#define DC2VO_SET_VSYNC_FORCE_LOCK       _IO    (DC2VO_IOC_MAGIC, 21)
+#define DC2VO_SIMPLE_POST_CONFIG         _IO    (DC2VO_IOC_MAGIC, 22)
+#define DC2VO_GET_VO_INSTANCE_INFO       _IO    (DC2VO_IOC_MAGIC, 23)
+
+/*
+ * legacy : DCRT_IRQ, DC_NOHW_MAX_BACKBUFFERS
+ */
+#define DCRT_IRQ                        (65) /* AVCPU_NWC : AVCPU => SCPU */
+#define DC_NOHW_MAX_BACKBUFFERS         (4)
+
+#define DC_VO_SET_NOTIFY                (__cpu_to_be32(1U << 0)) /* SCPU write */
+#define DC_VO_FEEDBACK_NOTIFY           (__cpu_to_be32(1U << 1))
+#define RPC_AUDIO_SET_NOTIFY            (__cpu_to_be32(1U << 8)) /* SCPU write */
+#define RPC_AUDIO_FEEDBACK_NOTIFY       (__cpu_to_be32(1U << 9))
+
+#define VO_DC_SET_NOTIFY                (__cpu_to_be32(1U << 16)) /* ACPU write */
+#define VO_DC_FEEDBACK_NOTIFY           (__cpu_to_be32(1U << 17))
+#define AUDIO_RPC_SET_NOTIFY            (__cpu_to_be32(1U << 24)) /* ACPU write */
+#define AUDIO_RPC_FEEDBACK_NOTIFY       (__cpu_to_be32(1U << 25))
+
+#define DC_HAS_BIT(addr, bit)           (readl(addr) & bit)
+#define DC_SET_BIT(addr,bit)            (writel((readl(addr)|bit), addr))
+#define DC_RESET_BIT(addr,bit)          (writel((readl(addr)&~bit), addr))
+
+int     DC_Ioctl        (struct fb_info *fbi, VENUSFB_MACH_INFO * video_info,unsigned int cmd, unsigned long arg);
+int     DC_Swap_Buffer  (struct fb_info *fbi, VENUSFB_MACH_INFO * video_info);
+int     DC_Init         (VENUSFB_MACH_INFO * video_info, struct fb_info *fbi, int irq);
+void    DC_Deinit       (VENUSFB_MACH_INFO * video_info);
+int     DC_Suspend      (VENUSFB_MACH_INFO * video_info);
+int     DC_Resume       (VENUSFB_MACH_INFO * video_info);
+int     DC_avcpu_event_notify (unsigned long action, VENUSFB_MACH_INFO * video_info);
+struct sync_file * DC_QueueBuffer(struct dc_buffer *buf);
+int     DC_VsyncWait    (unsigned long long *nsecs);
+
+/* offer function to osd-init */
+int     DC_Set_RateInfo (struct fb_info *fb, VENUSFB_MACH_INFO * video_info,DCRT_PARAM_RATE_INFO* param);
+int     DC_Set_ION_Share_Memory(struct fb_info *fb, VENUSFB_MACH_INFO *video_info,DC_ION_SHARE_MEMORY *param);
+int     DC_Set_RPCAddr(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, DCRT_PARAM_RPC_ADDR* param);
+int     DC_Set_RPCAddr_Virt(struct fb_info *fb, VENUSFB_MACH_INFO * video_info, DCRT_PARAM_RPC_VIRT_ADDR* param);
+
+#if defined(__cplusplus)
+}
+#endif
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/dc_rpc.h b/drivers/video/fbdev/rtk/dc2vo/dc_rpc.h
new file mode 100644
index 00000000..d14fb4c
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/dc_rpc.h
@@ -0,0 +1,249 @@
+
+/*
+kjw note:**
+	need to sync with rpc_common.h
+*/
+
+
+#ifndef __DC_RPC_H__
+#define __DC_RPC_H__
+
+typedef unsigned char BYTE;
+
+typedef enum _tagAVSyncMode{
+    AVSYNC_FORCED_SLAVE,
+    AVSYNC_FORCED_MASTER,
+    AVSYNC_AUTO_SLAVE,
+    AVSYNC_AUTO_MASTER,
+    AVSYNC_AUTO_MASTER_NO_SKIP,
+    AVSYNC_AUTO_MASTER_CONSTANT_DELAY   /* after getback mastership, it become force master */
+} AVSYNC_MODE;
+
+struct _tagMastership {
+  unsigned char systemMode;  /* enum AVSYNC_MODE */
+  unsigned char videoMode;   /* enum AVSYNC_MODE */
+  unsigned char audioMode;   /* enum AVSYNC_MODE */
+  unsigned char masterState; /* enum AUTOMASTER_STATE */
+};
+typedef struct _tagMastership MASTERSHIP;
+
+/* change this structure, make sure to change the CReferenceClock definition*/
+struct _tagRefClock {
+  long long      RCD;
+  unsigned int  RCD_ext;
+  long long      GPTSTimeout;
+  long long      videoSystemPTS;
+  long long      audioSystemPTS;
+  long long      videoRPTS;
+  long long      audioRPTS;
+  unsigned int  videoContext;
+  unsigned int  audioContext;
+
+  MASTERSHIP     mastership;
+  unsigned int  videoFreeRunThreshold;
+  unsigned int  audioFreeRunThreshold;
+  long long      masterGPTS;   // this is the value of GPTS (hardware PTS) when master set the reference clock
+  int           audioFullness;   // This flag will be turned on when AE's output buffer is almost full.
+                                  // VE which is monitoring this flag will issue auto-pause then.
+                                  // (0: still have enough output space for encoding.   1: AE request pause)
+  int           audioPauseFlag;  // This flag will be turned on when VE decides to auto-pause.
+                                  // AE which is monitoring this flag will auto-pause itself then.
+                                  // (0: ignore.  1: AE have to pauseEncode immediately)
+
+  int           VO_Underflow; // (0: VO is working properly; otherwise, VO underflow)
+  int           AO_Underflow; // (0: AO is working properly; otherwise, AO underflow)
+  int           videoEndOfSegment; // set to the flow EOS.eventID by VO after presenting the EOS sample
+  int           audioEndOfSegment; // set to the flow EOS.eventID by AO after presenting the EOS sample
+#ifdef DC2VO_SUPPORT_MEMORY_TRASH
+  unsigned int  memorytrashAddr;
+  unsigned int  memorytrashContext;
+  unsigned char reserved[8];
+#else /* DC2VO_SUPPORT_MEMORY_TRASH */
+  unsigned char  reserved[16];
+#endif /* End of DC2VO_SUPPORT_MEMORY_TRASH */
+};
+typedef struct _tagRefClock  REFCLOCK;
+
+typedef enum _tagRingBufferType{
+    RINGBUFFER_STREAM,
+    RINGBUFFER_COMMAND,
+    RINGBUFFER_MESSAGE,
+    RINGBUFFER_VBI,
+    RINGBUFFER_PTS,
+    RINGBUFFER_DTVCC,
+    RINGBUFFER_STREAM1,
+    RINGBUFFER_COMMAND1
+} RINGBUFFER_TYPE;
+
+// Ring Buffer header is the shared memory structure
+typedef struct _tagRingBufferHeader {
+  unsigned int magic;   //Magic number
+  unsigned int beginAddr;
+  unsigned int size;
+  unsigned int bufferID;  // RINGBUFFER_TYPE, choose a type from RINGBUFFER_TYPE
+
+  unsigned int  writePtr;
+  unsigned int  numOfReadPtr;
+  unsigned int  reserve2;  //Reserve for Red Zone
+  unsigned int  reserve3;  //Reserve for Red Zone
+
+  unsigned int readPtr[4];
+
+  int          fileOffset ;
+  int          requestedFileOffset ;
+  int          fileSize ;
+
+  int          bSeekable ;  /* Can't be sought if data is streamed by HTTP */
+
+} RINGBUFFER_HEADER;
+
+//// *** need to sync with InbandApi.h  **//
+typedef enum
+{
+  INBAND_CMD_GRAPHIC_FORMAT_RGB565            = 4,    /* 16-bit RGB    (565)  with constant alpha */
+  INBAND_CMD_GRAPHIC_FORMAT_ARGB1555          = 5,    /* 16-bit ARGB   (1555) */
+  INBAND_CMD_GRAPHIC_FORMAT_ARGB4444          = 6,    /* 16-bit ARGB   (4444) */
+  INBAND_CMD_GRAPHIC_FORMAT_ARGB8888          = 7,    /* 32-bit ARGB   (8888) */
+  INBAND_CMD_GRAPHIC_FORMAT_YCBCRA4444        = 11,   /* 16-bit YCBCRA (4444) */
+  INBAND_CMD_GRAPHIC_FORMAT_YCBCRA8888        = 12,   /* 32-bit YCBCRA (8888) */
+  INBAND_CMD_GRAPHIC_FORMAT_RGBA5551          = 13,   /* 16-bit RGBA   (5551) */
+  INBAND_CMD_GRAPHIC_FORMAT_RGBA4444          = 14,   /* 16-bit RGBA   (4444) */
+  INBAND_CMD_GRAPHIC_FORMAT_RGBA8888          = 15,   /* 32-bit RGBA   (8888) */
+  INBAND_CMD_GRAPHIC_FORMAT_RGB556            = 20,   /* 16-bit RGB    (556)  with constant alpha */
+  INBAND_CMD_GRAPHIC_FORMAT_RGB655            = 21,   /* 16-bit RGB    (655)  with constant alpha */
+  INBAND_CMD_GRAPHIC_FORMAT_RGB888            = 22,   /* 24-bit RGB    (888)  with constant alpha */
+  INBAND_CMD_GRAPHIC_FORMAT_RGB565_LITTLE     = 36,   /* litttle endian below */
+  INBAND_CMD_GRAPHIC_FORMAT_ARGB1555_LITTLE   = 37,
+  INBAND_CMD_GRAPHIC_FORMAT_ARGB4444_LITTLE   = 38,
+  INBAND_CMD_GRAPHIC_FORMAT_ARGB8888_LITTLE   = 39,
+  INBAND_CMD_GRAPHIC_FORMAT_YCBCRA4444_LITTLE = 43,
+  INBAND_CMD_GRAPHIC_FORMAT_YCBCRA8888_LITTLE = 44,
+  INBAND_CMD_GRAPHIC_FORMAT_RGBA5551_LITTLE   = 45,
+  INBAND_CMD_GRAPHIC_FORMAT_RGBA4444_LITTLE   = 46,
+  INBAND_CMD_GRAPHIC_FORMAT_RGBA8888_LITTLE   = 47,
+  INBAND_CMD_GRAPHIC_FORMAT_RGB556_LITTLE     = 52,
+  INBAND_CMD_GRAPHIC_FORMAT_RGB655_LITTLE     = 53,
+  INBAND_CMD_GRAPHIC_FORMAT_RGB888_LITTLE     = 54
+
+} INBAND_CMD_GRAPHIC_FORMAT ;
+
+/** inband cmd type. I use prefix "VIDEO_DEC_" to label the cmd used in video decoder. */
+typedef enum
+{
+  INBAND_CMD_TYPE_PTS = 0,
+  INBAND_CMD_TYPE_PTS_SKIP,
+  INBAND_CMD_TYPE_NEW_SEG,
+  INBAND_CMD_TYPE_SEQ_END,
+  INBAND_CMD_TYPE_EOS,
+  INBAND_CMD_TYPE_CONTEXT,
+  INBAND_CMD_TYPE_DECODE,
+
+  /* Video Decoder In-band Command */
+  VIDEO_DEC_INBAND_CMD_TYPE_VOBU,
+  VIDEO_DEC_INBAND_CMD_TYPE_DVDVR_DCI_CCI,
+  VIDEO_DEC_INBAND_CMD_TYPE_DVDV_VATR,
+
+  /* MSG Type for parse mode */
+  VIDEO_DEC_INBAND_CMD_TYPE_SEG_INFO,
+  VIDEO_DEC_INBAND_CMD_TYPE_PIC_INFO,
+
+  /* Sub-picture Decoder In-band Command */
+  VIDEO_SUBP_INBAND_CMD_TYPE_SET_PALETTE,
+  VIDEO_SUBP_INBAND_CMD_TYPE_SET_HIGHLIGHT,
+
+  /* Video Mixer In-band Command */
+  VIDEO_MIXER_INBAND_CMD_TYPE_SET_BG_COLOR,
+  VIDEO_MIXER_INBAND_CMD_TYPE_SET_MIXER_RPTS,
+  VIDEO_MIXER_INBAND_CMD_TYPE_BLEND,
+
+  /* Video Scaler In-band Command */
+  VIDEO_SCALER_INBAND_CMD_TYPE_OUTPUT_FMT,
+
+  /*DivX3 resolution In-band Command*/
+  VIDEO_DIVX3_INBAND_CMD_TYPE_RESOLUTION,
+
+  /*MPEG4 DivX4 detected In-band command*/
+  VIDEO_MPEG4_INBAND_CMD_TYPE_DIVX4,
+  /* Audio In-band Commands Start Here */
+
+  /* DV In-band Commands */
+  VIDEO_DV_INBAND_CMD_TYPE_VAUX,
+  VIDEO_DV_INBAND_CMD_TYPE_FF,                //fast forward
+
+  /* Transport Demux In-band command */
+  VIDEO_TRANSPORT_DEMUX_INBAND_CMD_TYPE_PID,
+  VIDEO_TRANSPORT_DEMUX_INBAND_CMD_TYPE_PTS_OFFSET,
+  VIDEO_TRANSPORT_DEMUX_INBAND_CMD_TYPE_PACKET_SIZE,
+
+  /* Real Video In-band command */
+  VIDEO_RV_INBAND_CMD_TYPE_FRAME_INFO,
+  VIDEO_RV_INBAND_CMD_TYPE_FORMAT_INFO,
+  VIDEO_RV_INBAND_CMD_TYPE_SEGMENT_INFO,
+
+  /*VC1 video In-band command*/
+  VIDEO_VC1_INBAND_CMD_TYPE_SEQ_INFO,
+
+  /* general video properties */
+  VIDEO_INBAND_CMD_TYPE_VIDEO_USABILITY_INFO,
+  VIDEO_INBAND_CMD_TYPE_VIDEO_MPEG4_USABILITY_INFO,
+
+  /*MJPEG resolution In-band Command*/
+  VIDEO_MJPEG_INBAND_CMD_TYPE_RESOLUTION,
+
+  /* picture object for graphic */
+  VIDEO_GRAPHIC_INBAND_CMD_TYPE_PICTURE_OBJECT,
+  VIDEO_GRAPHIC_INBAND_CMD_TYPE_DISPLAY_INFO,
+
+
+
+} INBAND_CMD_TYPE ;
+/* kjw note. need to sync with common */
+
+typedef struct
+{
+  INBAND_CMD_TYPE type ;
+  unsigned int size ;
+} INBAND_CMD_PKT_HEADER ;
+
+
+typedef struct
+{
+  INBAND_CMD_PKT_HEADER header ;
+  unsigned int wPtr ;
+  unsigned int eventID ;
+} EOS ;
+
+typedef struct
+{
+  INBAND_CMD_PKT_HEADER header ;
+  int displayEachPic ;      /* 1: each picture sent by upstream must be displayed, 0: follow av-sync to drop/repeat picture */
+
+} VIDEO_GRAPHIC_DISPLAY_INFO ;
+
+
+typedef struct{
+    long long                    videoSystemPTS;
+    unsigned int               videoContext;
+    int                        videoEndOfSegment;
+} DC_PRESENTATION_INFO;
+
+
+unsigned int    pli_IPCReadULONG(BYTE* src);
+unsigned long long  pli_IPCReadULONGLONG(BYTE* src);
+void    pli_IPCWriteULONG(BYTE* des, unsigned int data);
+void    pli_IPCWriteULONGLONG(BYTE* des, unsigned long long data);
+
+
+
+void pli_ipcCopyMemory(void * des, void * src, unsigned long size);
+int ICQ_WriteCmd (void *cmd, RINGBUFFER_HEADER* rbHeader, void *rbHeaderBase);
+
+void clkGetPresentation(REFCLOCK* clk, DC_PRESENTATION_INFO *pos);
+void clkResetPresentation(REFCLOCK* clk);
+#define ulPhyAddrFilter(x) ((x) & ~0xe0000000)
+
+
+
+#endif//__DC_RPC_H__
+
+
diff --git a/drivers/video/fbdev/rtk/dc2vo/dc_util.c b/drivers/video/fbdev/rtk/dc2vo/dc_util.c
new file mode 100644
index 00000000..1a6c374
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/dc_util.c
@@ -0,0 +1,250 @@
+#include <linux/kernel.h>
+#include <linux/spinlock.h>
+#include <asm/io.h> 
+#include "dc_rpc.h"
+
+
+#define IPCREAD(x) IPCRead(&(x))
+#define IPCWRITE(x,y) IPCWrite(&(x),y)
+
+extern unsigned int G_LAST_VCTX;
+
+__maybe_unused static unsigned int reverseInteger(unsigned int value)
+{
+#if 1
+    return __cpu_to_be32(value);
+#else
+	unsigned long b0 = value & 0x000000ff;
+	unsigned long b1 = (value & 0x0000ff00) >> 8;
+	unsigned long b2 = (value & 0x00ff0000) >> 16;
+	unsigned long b3 = (value & 0xff000000) >> 24;
+
+	return (b0 << 24) | (b1 << 16) | (b2 << 8) | b3;
+#endif
+}
+
+__maybe_unused static unsigned long long reverseLongInteger(unsigned long long value)
+{
+#if 1
+    return __cpu_to_be64(value);
+#else
+  unsigned long long ret;
+  unsigned char *des, *src;
+  src = (unsigned char *)&value;
+  des = (unsigned char *)&ret;
+  des[0] = src[7];
+  des[1] = src[6];
+  des[2] = src[5];
+  des[3] = src[4];
+  des[4] = src[3];
+  des[5] = src[2];
+  des[6] = src[1];
+  des[7] = src[0];
+  return ret;
+#endif
+}
+
+
+unsigned int pli_IPCReadULONG(BYTE* src)
+{
+#if 1
+    return __be32_to_cpu(readl(src));
+#else
+  volatile unsigned int A;  // prevent gcc -O3 optimization to create non-atomic access
+	if (((int)src & 0x3) != 0)
+		printk("error in pli_IPCReadULONG()...\n");
+	A = *(unsigned int *)src;
+	return reverseInteger(A);
+#endif
+}
+
+
+unsigned long long  pli_IPCReadULONGLONG(BYTE* src)
+{
+#if 1
+
+#if defined(CONFIG_CPU_V7)
+    return __be32_to_cpu(readl(src));
+#else
+    return __be64_to_cpu(readq(src));
+#endif /* CONFIG_CPU_V7 */
+
+#else
+    volatile unsigned long long A;  // prevent gcc -O3 optimization to create non-atomic access
+	if (((int)src & 0x3) != 0)
+		printk("error in pli_IPCReadULONG()...\n");
+
+	A = *(unsigned long long*)src;
+	return reverseLongInteger(A);
+#endif
+}
+
+void    pli_IPCWriteULONG(BYTE* des, unsigned int data)
+{
+#if 1
+    return writel(__cpu_to_be32(data), des);
+#else
+  volatile unsigned int A;  // prevent gcc -O3 optimization to create non-atomic access
+	if (((int)des & 0x3) != 0)
+		printk("error in pli_IPCWriteULONG()...\n");
+
+	A = reverseInteger(data);
+	*(unsigned int *)des = A;
+#endif
+}
+void    pli_IPCWriteULONGLONG(BYTE* des, unsigned long long data)
+{
+#if 1
+
+#if defined(CONFIG_CPU_V7)
+    return writel(__cpu_to_be32(data), des);
+#else
+    return writeq(__cpu_to_be64(data), des);
+#endif /* CONFIG_CPU_V7 */
+
+#else
+  volatile unsigned long long A; // prevent gcc -O3 optimization to create non-atomic access
+	if (((int)des & 0x3) != 0)
+		printk("error in pli_IPCWriteULONG()...\n");
+	A = reverseLongInteger(data);
+	*(unsigned long long*)des = A;
+#endif
+}
+
+
+
+void pli_ipcCopyMemory(void * p_des, void * p_src, unsigned long len)
+{
+#if 1
+    volatile unsigned char * des = (volatile unsigned char *) p_des;
+    volatile unsigned char * src = (volatile unsigned char *) p_src;
+    int i;
+    //printk("[%s] des:%p src:%p size:%lu\n", __func__, des, src, len);
+    for (i = 0; i < len; i+=4)
+        writel(__cpu_to_be32(readl(&src[i])), &des[i]);
+#else
+	unsigned long i;
+	unsigned int /*long*/ *psrc, *pdes;
+
+	if ((((int)src & 0x3) != 0) || (((int)des & 0x3) != 0) || ((len & 0x3) != 0)) {
+		printk("error in pli_IPCCopyMemory() %x %x %lu\n", (unsigned int)(des),
+			(unsigned int)(src), len);
+
+	}
+
+	for (i = 0; i < len; i+=4) {
+        writel(__cpu_to_be32(readl(&src[i])), &des[i]);
+		psrc = (unsigned int *)&src[i];
+		pdes = (unsigned int *)&des[i];
+		*pdes = reverseInteger(*psrc);
+		printf("%x, %x...\n", src[i], des[i]);
+	}
+#endif
+}
+
+__maybe_unused static DEFINE_SPINLOCK(lock);
+__maybe_unused static DEFINE_SPINLOCK(wlock);
+
+int ICQ_WriteCmd (void *cmd, RINGBUFFER_HEADER* rbHeader, void *rbHeaderBase)
+{
+    //spin_lock_irq(&lock);
+    volatile void * base_iomap = rbHeaderBase;
+    unsigned int size  = ((INBAND_CMD_PKT_HEADER *)cmd)->size;
+    unsigned int read  = pli_IPCReadULONG((BYTE*)&rbHeader->readPtr[0]) /*| 0xa0000000*/;
+    unsigned int write = pli_IPCReadULONG((BYTE*)&(rbHeader->writePtr)) /*| 0xa0000000*/;
+    unsigned int base  = pli_IPCReadULONG((BYTE*)&(rbHeader->beginAddr))/*| 0xa0000000*/;
+    unsigned int b_size = pli_IPCReadULONG((BYTE*)&(rbHeader->size))/*| 0xa0000000*/;
+#if 1
+    unsigned int limit = base + b_size;
+#else
+    unsigned int limit = (rbHeader->beginAddr + rbHeader->size);
+	limit = pli_IPCReadULONG((BYTE*)&limit) /*| 0xa0000000*/;
+#endif
+    //printk("[%s] r:%x w:%x size:%u base:%u limit:%u\n", __func__, read, write, size, base, limit);
+
+    if ( read + (read > write ? 0 : limit - base) - write > size )
+    {
+        //spin_lock_irq(&wlock);
+      if ( write + size <= limit ) {
+          unsigned long offset = write - base;
+          void * write_io = (void*)((unsigned long) base_iomap + offset);
+          pli_ipcCopyMemory ((void *)write_io, cmd, size) ;
+      }
+      else
+      {
+          unsigned long offset = write - base;
+          void * write_io = (void*)((unsigned long) base_iomap + offset);
+          pli_ipcCopyMemory ((void *)write_io, cmd, limit - write) ;
+          pli_ipcCopyMemory ((void *)base_iomap,  (void *)((unsigned long)cmd + limit - write), size - (limit - write)) ;
+      }
+
+		write += size ;
+		write = write < limit ? write : write - (limit - base) ;
+
+        #if 0
+        { /* writecombine */
+            unsigned int offset = write - base;
+            volatile int temp_read = * (volatile int *)base_iomap + offset;
+        }
+        #endif
+
+        //spin_unlock_irq(&wlock);
+		rbHeader->writePtr =  pli_IPCReadULONG((BYTE*)&write);
+
+        #if 0
+        { /* writecombine */
+            volatile int temp_read = rbHeader->writePtr;
+        }
+        #endif
+
+	  	//printk("new wp:0x%x r:0x%x\n", write, read);
+
+		// sb2 flush
+		//*(volatile unsigned int *)0xb801a020;       // sb2 flush
+		//__asm__ volatile ("sync");
+   	}
+	else
+	{
+		printk("errQ r:%x w:%x size:%u base:%u limit:%u\n", read, write, size, base, limit);
+
+        goto err;
+	}
+
+    //spin_unlock_irq(&lock);
+ 	return 0;
+err:
+    //spin_unlock_irq(&lock);
+    return -1;
+}
+
+void clkGetPresentation(REFCLOCK* clk, DC_PRESENTATION_INFO *pos)
+{
+	//printk("dcA 0x%x %llx\n", (unsigned int)clk, clk->videoSystemPTS);
+	if( clk != 0)
+	{
+    		//pos->videoSystemPTS = pli_IPCReadULONGLONG( (BYTE*)&clk->videoSystemPTS );
+	    pos->videoContext   = pli_IPCReadULONG( (BYTE*)&clk->videoContext);
+	    //pos->videoEndOfSegment = pli_IPCReadULONG( (BYTE*)&clk->videoEndOfSegment);
+	}
+	else
+		pos->videoContext = -1U;
+
+}
+void clkResetPresentation(REFCLOCK* clk)
+{
+	if( clk != 0)
+	{
+        pli_IPCWriteULONGLONG( (BYTE*)&clk->videoSystemPTS, -1U);
+        pli_IPCWriteULONGLONG( (BYTE*)&clk->audioSystemPTS, -1U);
+        pli_IPCWriteULONGLONG( (BYTE*)&clk->videoRPTS,      -1U);
+        pli_IPCWriteULONGLONG((BYTE*)&clk->audioRPTS,       -1U);
+        pli_IPCWriteULONG((BYTE*)&clk->videoContext,        -1U);
+        pli_IPCWriteULONG((BYTE*)&clk->audioContext,        -1U);
+        pli_IPCWriteULONG((BYTE*)&clk->videoEndOfSegment,   -1U);
+#ifdef DC2VO_SUPPORT_MEMORY_TRASH
+        pli_IPCWriteULONG((BYTE*)&clk->memorytrashContext,  -1U);
+#endif /* End of DC2VO_SUPPORT_MEMORY_TRASH */
+	}
+
+}
+
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/Makefile b/drivers/video/fbdev/rtk/dc2vo/fpga/Makefile
new file mode 100644
index 00000000..598cef3
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/Makefile
@@ -0,0 +1,5 @@
+obj-y       += osd/osd.o
+obj-y       += hdmi/HDMI_480p.o
+obj-y       += example/GO_function.o
+obj-y       += main/fpga.o
+obj-y       += vo/VO_480p.o
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/example/GO_function.c b/drivers/video/fbdev/rtk/dc2vo/fpga/example/GO_function.c
new file mode 100644
index 00000000..6c88a6a
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/example/GO_function.c
@@ -0,0 +1,170 @@
+#include <generated/autoconf.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/string.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <asm/io.h>
+#include "../include/os/type.h"
+#include "../include/hdmi_reg.h"
+#include "../include/tve_reg.h"
+#include "../include/aio_reg.h"
+//extern void delay1(INT32U);
+
+void GO_function(INT32U display_mode, INT8U DVI_or_HDMI, INT8U Timing_Gen)
+{
+    if(Timing_Gen)
+    {
+        //0xb800d020
+        WRITE_REG_INT32U(HDMI_CHNL_SEL, READ_REG_INT32U(HDMI_CHNL_SEL)|HDMI_CHNL_SEL_timing_gen_en_mask);
+    }
+
+//    switch(display_mode)
+//    {
+//        case 1 ://525i
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(1)|TVE_SYNCGEN_RST_hi_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en4(1)|TVE_SYNCGEN_RST_pi_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(0)|TVE_SYNCGEN_RST_p_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en1(0)|TVE_SYNCGEN_RST_h_sync_go(0));
+//            break;
+//        case 2 ://525p(700/300)
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(1)|TVE_SYNCGEN_RST_hi_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en4(1)|TVE_SYNCGEN_RST_pi_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(0)|TVE_SYNCGEN_RST_p_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en1(0)|TVE_SYNCGEN_RST_h_sync_go(0));
+//            break;
+//        case 3 ://625i
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(1)|TVE_SYNCGEN_RST_hi_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en4(1)|TVE_SYNCGEN_RST_pi_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(0)|TVE_SYNCGEN_RST_p_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en1(0)|TVE_SYNCGEN_RST_h_sync_go(0));
+//            break;
+//        case 4 ://625p
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(1)|TVE_SYNCGEN_RST_hi_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en4(1)|TVE_SYNCGEN_RST_pi_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(0)|TVE_SYNCGEN_RST_p_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en1(0)|TVE_SYNCGEN_RST_h_sync_go(0));
+//            break;
+//        case 5 ://720p60
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(0)|TVE_SYNCGEN_RST_hi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en4(0)|TVE_SYNCGEN_RST_pi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(1)|TVE_SYNCGEN_RST_p_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en1(1)|TVE_SYNCGEN_RST_h_sync_go(1));
+//            break;
+//        case 6 ://1080i50
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(0)|TVE_SYNCGEN_RST_hi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en4(0)|TVE_SYNCGEN_RST_pi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(1)|TVE_SYNCGEN_RST_p_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en1(1)|TVE_SYNCGEN_RST_h_sync_go(1));
+//            break;
+//        case 7 ://1080i60
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(0)|TVE_SYNCGEN_RST_hi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en4(0)|TVE_SYNCGEN_RST_pi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(1)|TVE_SYNCGEN_RST_p_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en1(1)|TVE_SYNCGEN_RST_h_sync_go(1));
+//            break;
+//        case 17 ://525p(714/286)
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(1)|TVE_SYNCGEN_RST_hi_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en4(1)|TVE_SYNCGEN_RST_pi_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(0)|TVE_SYNCGEN_RST_p_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en1(0)|TVE_SYNCGEN_RST_h_sync_go(0));
+//            break;
+//        case 18 ://1080p24
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(0)|TVE_SYNCGEN_RST_hi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en4(0)|TVE_SYNCGEN_RST_pi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(1)|TVE_SYNCGEN_RST_p_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en1(1)|TVE_SYNCGEN_RST_h_sync_go(1));
+//            break;
+//        case 19 ://1080p30
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(0)|TVE_SYNCGEN_RST_hi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en4(0)|TVE_SYNCGEN_RST_pi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(1)|TVE_SYNCGEN_RST_p_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en1(1)|TVE_SYNCGEN_RST_h_sync_go(1));
+//            break;
+//        case 20 ://720p50
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(0)|TVE_SYNCGEN_RST_hi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en4(0)|TVE_SYNCGEN_RST_pi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(1)|TVE_SYNCGEN_RST_p_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en1(1)|TVE_SYNCGEN_RST_h_sync_go(1));
+//            break;
+//        case 21 ://1080p50
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(0)|TVE_SYNCGEN_RST_hi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en4(0)|TVE_SYNCGEN_RST_pi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(1)|TVE_SYNCGEN_RST_p_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en1(1)|TVE_SYNCGEN_RST_h_sync_go(1));
+//            break;
+//        case 22 ://1080p60
+//            //0xb8018000
+//            WRITE_REG_INT32U(TVE_SYNCGEN_RST_reg,
+//                             TVE_SYNCGEN_RST_write_en5(0)|TVE_SYNCGEN_RST_hi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en4(0)|TVE_SYNCGEN_RST_pi_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en3(0)|TVE_SYNCGEN_RST_i_sync_go(0)|
+//                             TVE_SYNCGEN_RST_write_en2(1)|TVE_SYNCGEN_RST_p_sync_go(1)|
+//                             TVE_SYNCGEN_RST_write_en1(1)|TVE_SYNCGEN_RST_h_sync_go(1));
+//            break;
+//        default:
+//            break;
+//    } //switch(display_mode)
+
+    //0xb800d158
+    WRITE_REG_INT32U(HDMI_DPC1,
+                     HDMI_DPC1_write_en2(1)|HDMI_DPC1_dp_vfch(1)|
+                     HDMI_DPC1_write_en1(0)|HDMI_DPC1_pp(0));
+
+    //delay1(1000);
+    msleep(1000);
+
+    if(DVI_or_HDMI == 1)
+    {
+        //HDMI Audio GO=================================================================================
+        //0xb800d0bc
+        WRITE_REG_INT32U(HDMI_ICR,
+                         HDMI_ICR_write_en3(1)|HDMI_ICR_enaudio(1)| //1:enable HDMI audio data path
+                         HDMI_ICR_write_en2(1)|HDMI_ICR_envitd(0)|
+                         HDMI_ICR_write_en1(0)|HDMI_ICR_vitd(0));
+    }
+    //0xb8006304
+    WRITE_REG_INT32U(AIO_O_GO,
+                     AIO_O_GO_goacdac(0)|
+                     AIO_O_GO_gohdmi(1)|
+                     AIO_O_GO_goi2s(1)| //enable I2S output
+                     AIO_O_GO_gospf(1)); //S-PDIF output
+
+    return;
+}
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/example/example.c b/drivers/video/fbdev/rtk/dc2vo/fpga/example/example.c
new file mode 100644
index 00000000..48529f1
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/example/example.c
@@ -0,0 +1,27 @@
+
+ 
+
+INT8U DVIorHDMI_flag=1; //0:DVI, 1:HDMI
+
+INT8U xvYCC=0; //Extended-gamut YCC color space
+
+INT8U PixelColorFormat=2; //0:RGB444, 1:Reserved, 2:YCbCr444, 3:YCbCr422
+
+INT8U DeepColorEnable=1; //0:disable 1:enable
+
+INT8U DeepColorDepth=4; //0:not indicated, 4:24bits, 5:30bits, 6:36bits, other:reserved
+
+INT8U TimingGen=1;        //0: TVE 1:HDMI
+
+INT8U Enable3D=0;
+
+INT8U Format3D=0;         //0: frame packing 1: field alternative 2: line alternative 3: side-by-side
+
+                           //4: l+depth 5: l+depth+graphics+graphics-depth 6: top-and-down
+
+                           //8: side-by-side(half)
+
+
+SET_HDMI_Video_480p(PixelColorFormat, DVIorHDMI_flag, DeepColorEnable, DeepColorDepth, xvYCC, TimingGen, Enable3D, Format3D);
+VO_480p(Test_Pattern, TimingGen, Enable3D, Format3D);//Test_Pattern= 0 or 1, to switch frame buffer addr
+GO_function(0, DVIorHDMI_flag, TimingGen);
\ No newline at end of file
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/example/example.h b/drivers/video/fbdev/rtk/dc2vo/fpga/example/example.h
new file mode 100644
index 00000000..378800d
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/example/example.h
@@ -0,0 +1,4 @@
+#ifndef __FPGA_EXAMPLE_H__
+#define __FPGA_EXAMPLE_H__
+void GO_function(INT32U display_mode, INT8U DVI_or_HDMI, INT8U Timing_Gen);
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/hdmi/HDMI_480p.c b/drivers/video/fbdev/rtk/dc2vo/fpga/hdmi/HDMI_480p.c
new file mode 100644
index 00000000..ed9e28a
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/hdmi/HDMI_480p.c
@@ -0,0 +1,712 @@
+#include <generated/autoconf.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/string.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <asm/io.h>
+#include "../include/os/type.h"
+#include "../include/hdmi_reg.h"
+#include "../include/tve_reg.h"
+#include "hdmi.h"
+//#######################################################################################################
+//
+//  File Name:      HDMI_480p.C
+//  Description:    HDMI Video 720x480p @59.94/60Hz initial setting
+//
+//#######################################################################################################
+#ifdef FPGA_USE_IOMAP
+#define HDMI_IO_BASE HDMI_INTEN
+#define HDMI_IO_SIZE 0x1000
+#define HDMI_WRITE_REG_INT32U(addr,val) WRITE_REG_INT32U(((unsigned int)hdmi_iomap+(addr-HDMI_IO_BASE)),val)
+static void* hdmi_iomap = NULL;
+#else
+#define HDMI_WRITE_REG_INT32U(addr,val) WRITE_REG_INT32U(addr,val)
+#endif
+
+#ifdef FPGA_USE_IOMAP
+#define TVE_IO_BASE TVE_SYNCGEN_RST
+#define TVE_IO_SIZE 0x1000
+#define TVE_WRITE_REG_INT32U(addr,val) WRITE_REG_INT32U(((unsigned int)tve_iomap+(addr-TVE_IO_BASE)),val)
+static void* tve_iomap = NULL;
+#else
+#define TVE_WRITE_REG_INT32U(addr,val) WRITE_REG_INT32U(addr,val)
+#endif
+void SET_HDMI_Video_480p(INT8U Pixel_Colocr_Format, INT8U DVI_or_HDMI, INT8U Deep_Color, INT8U Deep_Depth, INT8U xv_YCC, INT8U Timing_Gen, INT8U En_3D, INT8U Format_3D)
+{
+#ifdef FPGA_USE_IOMAP
+    if (hdmi_iomap == NULL)
+        hdmi_iomap = ioremap(HDMI_IO_BASE,HDMI_IO_SIZE);
+        //hdmi_iomap = phys_to_virt(HDMI_IO_BASE);
+    if (tve_iomap == NULL)
+        tve_iomap = ioremap(TVE_IO_BASE,TVE_IO_SIZE);
+        //tve_iomap = phys_to_virt(TVE_IO_BASE);
+#endif
+    //0xb800d034
+    HDMI_WRITE_REG_INT32U(HDMI_CR,
+                     HDMI_CR_write_en3(1)|HDMI_CR_tmds_encen(0)| //TMDS Encoder disable
+                     HDMI_CR_write_en2(0)|HDMI_CR_enablehdcp(0)|
+                     HDMI_CR_write_en1(1)|HDMI_CR_enablehdmi(0)); //HDMI disable
+    //0xb800d0bc
+    HDMI_WRITE_REG_INT32U(HDMI_ICR,
+                     HDMI_ICR_write_en3(1)|HDMI_ICR_enaudio(0)| //0:disable HDMI audio data path
+                     HDMI_ICR_write_en2(1)|HDMI_ICR_envitd(0)|
+                     HDMI_ICR_write_en1(0)|HDMI_ICR_vitd(0));
+
+    if(!DVI_or_HDMI) //DVI mode=================================================
+    {
+        //CRT & PHY config
+        //Timming setting
+        if(Timing_Gen)//using HDMI timing generator control
+        {
+            //0xb800d234
+            HDMI_WRITE_REG_INT32U(HDMI_H_PARA1,
+                             HDMI_H_PARA1_hblank(137)|
+                             HDMI_H_PARA1_hactive(719));
+            //0xb800d238
+            HDMI_WRITE_REG_INT32U(HDMI_H_PARA2,
+                             HDMI_H_PARA2_hsync(61)|
+                             HDMI_H_PARA2_hfront(15));
+            //0xb800d23c
+            HDMI_WRITE_REG_INT32U(HDMI_H_PARA3,
+                             HDMI_H_PARA3_hback(59));
+            //0xb800d240
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA1,
+                             HDMI_V_PARA1_Vact_video(479)|
+                             HDMI_V_PARA1_vactive(479));
+            //0xb800d244
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA2,
+                             HDMI_V_PARA2_Vact_space1(0)|
+                             HDMI_V_PARA2_Vact_space(0));
+            //0xb800d248
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA3,
+                             HDMI_V_PARA3_Vblank3(0)|
+                             HDMI_V_PARA3_Vact_space2(0));
+            //0xb800d24c
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA4,
+                             HDMI_V_PARA4_vsync((6<<1))|
+                             HDMI_V_PARA4_vblank(44));
+            //0xb800d250
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA5,
+                             HDMI_V_PARA5_vback(29)|
+                             HDMI_V_PARA5_vfront((9<<1)));
+            //0xb800d254
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA6,
+                             HDMI_V_PARA6_Vsync1((0<<1))|
+                             HDMI_V_PARA6_Vblank1(0));
+            //0xb800d258
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA7,
+                             HDMI_V_PARA7_Vback1(0)|
+                             HDMI_V_PARA7_Vfront1((0<<1)));
+            //0xb800d25c
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA8,
+                             HDMI_V_PARA8_Vsync2((0<<1))|
+                             HDMI_V_PARA8_Vblank2(0));
+            //0xb800d260
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA9,
+                             HDMI_V_PARA9_Vback2(0)|
+                             HDMI_V_PARA9_Vfront2((0<<1)));
+            //0xb800d26c
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA10,
+                             HDMI_V_PARA10_G(0x00beef));
+            //0xb800d270
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA11,
+                             HDMI_V_PARA11_B(0x00beef)|
+                             HDMI_V_PARA11_R(0x00beef));
+            //0xb800d264
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA12,
+                             HDMI_V_PARA12_vsynci((0<<1))|
+                             HDMI_V_PARA12_vblanki(0));
+            //0xb800d268
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA13,
+                             HDMI_V_PARA13_vbacki(0)|
+                             HDMI_V_PARA13_vfronti((0<<1)));
+            //0xb800d030
+            HDMI_WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                             HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                             HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                             HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                             HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+            //0xb800d154
+            HDMI_WRITE_REG_INT32U(HDMI_DPC,
+                             HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                             HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                             HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                             HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                             HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                             HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(0)|
+                             HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(0));
+        }
+        else //using TVE timing generator control
+        {
+            //0xb80180b8
+            TVE_WRITE_REG_INT32U(TVE_HDMI_ST,
+                             TVE_HDMI_ST_write_en4(1)|TVE_HDMI_ST_sync_en(1)|
+                             TVE_HDMI_ST_write_en3(1)|TVE_HDMI_ST_ch_sel(0)| //0:progressive, 1:interlace
+                             TVE_HDMI_ST_write_en2(1)|TVE_HDMI_ST_vpos(0)|
+                             TVE_HDMI_ST_write_en1(1)|TVE_HDMI_ST_hpos(0));
+            //0xb80180bc
+            TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_HS,
+                             TVE_HDMI_DISP_HS_write_en2(1)|TVE_HDMI_DISP_HS_hs_start(15)|
+                             TVE_HDMI_DISP_HS_write_en1(1)|TVE_HDMI_DISP_HS_hs_end(77));
+            //0xb80180c0
+            TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSST1,
+                             TVE_HDMI_DISP_VSST1_write_en2(1)|TVE_HDMI_DISP_VSST1_vs_st_pos1v(6)|
+                             TVE_HDMI_DISP_VSST1_write_en1(1)|TVE_HDMI_DISP_VSST1_vs_st_pos1h(15));
+            //0xb80180c4
+            TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSED1,
+                             TVE_HDMI_DISP_VSED1_write_en2(1)|TVE_HDMI_DISP_VSED1_vs_end_pos1v(12)|
+                             TVE_HDMI_DISP_VSED1_write_en1(1)|TVE_HDMI_DISP_VSED1_vs_end_pos1h(15));
+            //0xb80180c8
+            TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSST2,
+                             TVE_HDMI_DISP_VSST2_write_en2(1)|TVE_HDMI_DISP_VSST2_vs_st_pos2v(0)|
+                             TVE_HDMI_DISP_VSST2_write_en1(1)|TVE_HDMI_DISP_VSST2_vs_st_pos2h(0));
+            //0xb80180cc
+            TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSED2,
+                             TVE_HDMI_DISP_VSED2_write_en2(1)|TVE_HDMI_DISP_VSED2_vs_end_pos2v(0)|
+                             TVE_HDMI_DISP_VSED2_write_en1(1)|TVE_HDMI_DISP_VSED2_vs_end_pos2h(0));
+            //0xb80180d0
+            TVE_WRITE_REG_INT32U(TVE_HDMI_PXLACT,
+                             TVE_HDMI_PXLACT_write_en2(1)|TVE_HDMI_PXLACT_hpos_end(850)|
+                             TVE_HDMI_PXLACT_write_en1(1)|TVE_HDMI_PXLACT_hpos_st(116));
+            //0xb800d030
+            HDMI_WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                             HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                             HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                             HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(2)|
+                             HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(2));
+            //0xb800d154
+            HDMI_WRITE_REG_INT32U(HDMI_DPC,
+                             HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                             HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                             HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                             HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                             HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                             HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(0)|
+                             HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(0));
+        }
+    }
+    else //HDMI mode============================================================
+    {
+        //CRT & PHY config
+        //Timming setting
+        if(Timing_Gen)//using HDMI timing generator control
+        {
+            //0xb800d234
+            HDMI_WRITE_REG_INT32U(HDMI_H_PARA1,
+                             HDMI_H_PARA1_hblank(137)|
+                             HDMI_H_PARA1_hactive(719));
+            //0xb800d238
+            HDMI_WRITE_REG_INT32U(HDMI_H_PARA2,
+                             HDMI_H_PARA2_hsync(61)|
+                             HDMI_H_PARA2_hfront(15));
+            //0xb800d23c
+            HDMI_WRITE_REG_INT32U(HDMI_H_PARA3,
+                             HDMI_H_PARA3_hback(59));
+            if(En_3D)
+            {
+                switch(Format_3D)
+                {
+                    case 0:
+                    case 4:
+                        //0xb800d240
+                        HDMI_WRITE_REG_INT32U(HDMI_V_PARA1,
+                                         HDMI_V_PARA1_Vact_video(479)|
+                                         HDMI_V_PARA1_vactive(1004));
+                        //0xb800d244
+                        HDMI_WRITE_REG_INT32U(HDMI_V_PARA2,
+                                         HDMI_V_PARA2_Vact_space1(0)|
+                                         HDMI_V_PARA2_Vact_space(44));
+                        break;
+                    case 1:
+                        //Field alternative no support!!
+                        break;
+                    case 2:
+                    case 3:
+                        //0xb800d240
+                        HDMI_WRITE_REG_INT32U(HDMI_V_PARA1,
+                                         HDMI_V_PARA1_Vact_video(479)|
+                                         HDMI_V_PARA1_vactive(479));
+                        //0xb800d244
+                        HDMI_WRITE_REG_INT32U(HDMI_V_PARA2,
+                                         HDMI_V_PARA2_Vact_space1(0)|
+                                         HDMI_V_PARA2_Vact_space(0));
+                        break;
+                    case 5:
+                        //0xb800d240
+                        HDMI_WRITE_REG_INT32U(HDMI_V_PARA1,
+                                         HDMI_V_PARA1_Vact_video(479)|
+                                         HDMI_V_PARA1_vactive(2054));
+                        //0xb800d244
+                        HDMI_WRITE_REG_INT32U(HDMI_V_PARA2,
+                                         HDMI_V_PARA2_Vact_space1(0)|
+                                         HDMI_V_PARA2_Vact_space(44));
+                        break;
+                    case 6:
+                    case 8:
+                        //0xb800d240
+                        HDMI_WRITE_REG_INT32U(HDMI_V_PARA1,
+                                         HDMI_V_PARA1_Vact_video(479)|
+                                         HDMI_V_PARA1_vactive(479));
+                        //0xb800d244
+                        HDMI_WRITE_REG_INT32U(HDMI_V_PARA2,
+                                         HDMI_V_PARA2_Vact_space1(0)|
+                                         HDMI_V_PARA2_Vact_space(0));
+                        break;
+                    case 7:
+                        break;
+                    default:
+                        break;
+                }
+            }
+            else
+            {
+                //0xb800d240
+                HDMI_WRITE_REG_INT32U(HDMI_V_PARA1,
+                                 HDMI_V_PARA1_Vact_video(479)|
+                                 HDMI_V_PARA1_vactive(479));
+                //0xb800d244
+                HDMI_WRITE_REG_INT32U(HDMI_V_PARA2,
+                                 HDMI_V_PARA2_Vact_space1(0)|
+                                 HDMI_V_PARA2_Vact_space(0));
+            }
+            //0xb800d248
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA3,
+                             HDMI_V_PARA3_Vblank3(0)|
+                             HDMI_V_PARA3_Vact_space2(0));
+            //0xb800d24c
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA4,
+                             HDMI_V_PARA4_vsync((6<<1))|
+                             HDMI_V_PARA4_vblank(44));
+            //0xb800d250
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA5,
+                             HDMI_V_PARA5_vback(29)|
+                             HDMI_V_PARA5_vfront((9<<1)));
+            //0xb800d254
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA6,
+                             HDMI_V_PARA6_Vsync1((0<<1))|
+                             HDMI_V_PARA6_Vblank1(0));
+            //0xb800d258
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA7,
+                             HDMI_V_PARA7_Vback1(0)|
+                             HDMI_V_PARA7_Vfront1((0<<1)));
+            //0xb800d25c
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA8,
+                             HDMI_V_PARA8_Vsync2((0<<1))|
+                             HDMI_V_PARA8_Vblank2(0));
+            //0xb800d260
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA9,
+                             HDMI_V_PARA9_Vback2(0)|
+                             HDMI_V_PARA9_Vfront2((0<<1)));
+            //0xb800d26c
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA10,
+                             HDMI_V_PARA10_G(0x00beef));
+            //0xb800d270
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA11,
+                             HDMI_V_PARA11_B(0x00beef)|
+                             HDMI_V_PARA11_R(0x00beef));
+            //0xb800d264
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA12,
+                             HDMI_V_PARA12_vsynci((0<<1))|
+                             HDMI_V_PARA12_vblanki(0));
+            //0xb800d268
+            HDMI_WRITE_REG_INT32U(HDMI_V_PARA13,
+                             HDMI_V_PARA13_vbacki(0)|
+                             HDMI_V_PARA13_vfronti((0<<1)));
+
+            //Deep Color 24bit========================================================================================
+            if(Deep_Color==0 || (Deep_Color==1 && Deep_Depth==4))
+            {
+                //0xb800d030
+                HDMI_WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+                //0xb800d154
+                HDMI_WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+            //Deep Color 30bit========================================================================================
+            if(Deep_Color==1 && Deep_Depth==5)
+            {
+                //0xb800d030
+                HDMI_WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+                //0xb800d154
+                HDMI_WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(3)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(1)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(1)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(0)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+            //Deep Color 36bit========================================================================================
+            if(Deep_Color==1 && Deep_Depth==6)
+            {
+                //0xb800d030
+                HDMI_WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(0)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(0));
+                //0xb800d154
+                HDMI_WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+        }
+        else //using TVE timing control
+        {
+            //Deep Color 24bit========================================================================================
+            if(Deep_Color==0 || (Deep_Color==1 && Deep_Depth==4))
+            {
+                //0xb80180b8
+                TVE_WRITE_REG_INT32U(TVE_HDMI_ST,
+                                 TVE_HDMI_ST_write_en4(1)|TVE_HDMI_ST_sync_en(1)|
+                                 TVE_HDMI_ST_write_en3(1)|TVE_HDMI_ST_ch_sel(0)| //0:progressive, 1:interlace
+                                 TVE_HDMI_ST_write_en2(1)|TVE_HDMI_ST_vpos(0)|
+                                 TVE_HDMI_ST_write_en1(1)|TVE_HDMI_ST_hpos(0));
+                //0xb80180bc
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_HS,
+                                 TVE_HDMI_DISP_HS_write_en2(1)|TVE_HDMI_DISP_HS_hs_start(15)|
+                                 TVE_HDMI_DISP_HS_write_en1(1)|TVE_HDMI_DISP_HS_hs_end(77));
+                //0xb80180c0
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSST1,
+                                 TVE_HDMI_DISP_VSST1_write_en2(1)|TVE_HDMI_DISP_VSST1_vs_st_pos1v(6)|
+                                 TVE_HDMI_DISP_VSST1_write_en1(1)|TVE_HDMI_DISP_VSST1_vs_st_pos1h(15));
+                //0xb80180c4
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSED1,
+                                 TVE_HDMI_DISP_VSED1_write_en2(1)|TVE_HDMI_DISP_VSED1_vs_end_pos1v(12)|
+                                 TVE_HDMI_DISP_VSED1_write_en1(1)|TVE_HDMI_DISP_VSED1_vs_end_pos1h(15));
+                //0xb80180c8
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSST2,
+                                 TVE_HDMI_DISP_VSST2_write_en2(1)|TVE_HDMI_DISP_VSST2_vs_st_pos2v(0)|
+                                 TVE_HDMI_DISP_VSST2_write_en1(1)|TVE_HDMI_DISP_VSST2_vs_st_pos2h(0));
+                //0xb80180cc
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSED2,
+                                 TVE_HDMI_DISP_VSED2_write_en2(1)|TVE_HDMI_DISP_VSED2_vs_end_pos2v(0)|
+                                 TVE_HDMI_DISP_VSED2_write_en1(1)|TVE_HDMI_DISP_VSED2_vs_end_pos2h(0));
+                //0xb80180d0
+                TVE_WRITE_REG_INT32U(TVE_HDMI_PXLACT,
+                                 TVE_HDMI_PXLACT_write_en2(1)|TVE_HDMI_PXLACT_hpos_end(850)|
+                                 TVE_HDMI_PXLACT_write_en1(1)|TVE_HDMI_PXLACT_hpos_st(116));
+                //0xb800d030
+                HDMI_WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(2)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(2));
+                //0xb800d154
+                HDMI_WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+            //Deep Color 30bit========================================================================================
+            if(Deep_Color==1 && Deep_Depth==5)
+            {
+                //0xb80180b8
+                TVE_WRITE_REG_INT32U(TVE_HDMI_ST,
+                                 TVE_HDMI_ST_write_en4(1)|TVE_HDMI_ST_sync_en(1)|
+                                 TVE_HDMI_ST_write_en3(1)|TVE_HDMI_ST_ch_sel(0)| //0:progressive, 1:interlace
+                                 TVE_HDMI_ST_write_en2(1)|TVE_HDMI_ST_vpos(0)|
+                                 TVE_HDMI_ST_write_en1(1)|TVE_HDMI_ST_hpos(0));
+                //0xb80180bc
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_HS,
+                                 TVE_HDMI_DISP_HS_write_en2(1)|TVE_HDMI_DISP_HS_hs_start(15)|
+                                 TVE_HDMI_DISP_HS_write_en1(1)|TVE_HDMI_DISP_HS_hs_end(77));
+                //0xb80180c0
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSST1,
+                                 TVE_HDMI_DISP_VSST1_write_en2(1)|TVE_HDMI_DISP_VSST1_vs_st_pos1v(6)|
+                                 TVE_HDMI_DISP_VSST1_write_en1(1)|TVE_HDMI_DISP_VSST1_vs_st_pos1h(15));
+                //0xb80180c4
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSED1,
+                                 TVE_HDMI_DISP_VSED1_write_en2(1)|TVE_HDMI_DISP_VSED1_vs_end_pos1v(12)|
+                                 TVE_HDMI_DISP_VSED1_write_en1(1)|TVE_HDMI_DISP_VSED1_vs_end_pos1h(15));
+                //0xb80180c8
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSST2,
+                                 TVE_HDMI_DISP_VSST2_write_en2(1)|TVE_HDMI_DISP_VSST2_vs_st_pos2v(0)|
+                                 TVE_HDMI_DISP_VSST2_write_en1(1)|TVE_HDMI_DISP_VSST2_vs_st_pos2h(0));
+                //0xb80180cc
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSED2,
+                                 TVE_HDMI_DISP_VSED2_write_en2(1)|TVE_HDMI_DISP_VSED2_vs_end_pos2v(0)|
+                                 TVE_HDMI_DISP_VSED2_write_en1(1)|TVE_HDMI_DISP_VSED2_vs_end_pos2h(0));
+                //0xb80180d0
+                TVE_WRITE_REG_INT32U(TVE_HDMI_PXLACT,
+                                 TVE_HDMI_PXLACT_write_en2(1)|TVE_HDMI_PXLACT_hpos_end(850)|
+                                 TVE_HDMI_PXLACT_write_en1(1)|TVE_HDMI_PXLACT_hpos_st(116));
+                //0xb800d030
+                HDMI_WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(2)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(2));
+                //0xb800d154
+                HDMI_WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(3)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(1)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(2)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(0)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+            //Deep Color 36bit========================================================================================
+            if(Deep_Color==1 && Deep_Depth==6)
+            {
+                //0xb80180b8
+                TVE_WRITE_REG_INT32U(TVE_HDMI_ST,
+                                 TVE_HDMI_ST_write_en4(1)|TVE_HDMI_ST_sync_en(1)|
+                                 TVE_HDMI_ST_write_en3(1)|TVE_HDMI_ST_ch_sel(0)| //0:progressive, 1:interlace
+                                 TVE_HDMI_ST_write_en2(1)|TVE_HDMI_ST_vpos(0)|
+                                 TVE_HDMI_ST_write_en1(1)|TVE_HDMI_ST_hpos(0));
+                //0xb80180bc
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_HS,
+                                 TVE_HDMI_DISP_HS_write_en2(1)|TVE_HDMI_DISP_HS_hs_start(15)|
+                                 TVE_HDMI_DISP_HS_write_en1(1)|TVE_HDMI_DISP_HS_hs_end(77));
+                //0xb80180c0
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSST1,
+                                 TVE_HDMI_DISP_VSST1_write_en2(1)|TVE_HDMI_DISP_VSST1_vs_st_pos1v(6)|
+                                 TVE_HDMI_DISP_VSST1_write_en1(1)|TVE_HDMI_DISP_VSST1_vs_st_pos1h(15));
+                //0xb80180c4
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSED1,
+                                 TVE_HDMI_DISP_VSED1_write_en2(1)|TVE_HDMI_DISP_VSED1_vs_end_pos1v(12)|
+                                 TVE_HDMI_DISP_VSED1_write_en1(1)|TVE_HDMI_DISP_VSED1_vs_end_pos1h(15));
+                //0xb80180c8
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSST2,
+                                 TVE_HDMI_DISP_VSST2_write_en2(1)|TVE_HDMI_DISP_VSST2_vs_st_pos2v(0)|
+                                 TVE_HDMI_DISP_VSST2_write_en1(1)|TVE_HDMI_DISP_VSST2_vs_st_pos2h(0));
+                //0xb80180cc
+                TVE_WRITE_REG_INT32U(TVE_HDMI_DISP_VSED2,
+                                 TVE_HDMI_DISP_VSED2_write_en2(1)|TVE_HDMI_DISP_VSED2_vs_end_pos2v(0)|
+                                 TVE_HDMI_DISP_VSED2_write_en1(1)|TVE_HDMI_DISP_VSED2_vs_end_pos2h(0));
+                //0xb80180d0
+                TVE_WRITE_REG_INT32U(TVE_HDMI_PXLACT,
+                                 TVE_HDMI_PXLACT_write_en2(1)|TVE_HDMI_PXLACT_hpos_end(850)|
+                                 TVE_HDMI_PXLACT_write_en1(1)|TVE_HDMI_PXLACT_hpos_st(116));
+                //0xb800d030
+                HDMI_WRITE_REG_INT32U(HDMI_SYNC_DLY,
+                                 HDMI_SYNC_DLY_write_en4(1)|HDMI_SYNC_DLY_nor_v(0)|
+                                 HDMI_SYNC_DLY_write_en3(1)|HDMI_SYNC_DLY_nor_h(0)|
+                                 HDMI_SYNC_DLY_write_en2(1)|HDMI_SYNC_DLY_disp_v(2)|
+                                 HDMI_SYNC_DLY_write_en1(1)|HDMI_SYNC_DLY_disp_h(2));
+                //0xb800d154
+                HDMI_WRITE_REG_INT32U(HDMI_DPC,
+                                 HDMI_DPC_write_en9(1)|HDMI_DPC_dp_vfch_num(1)|
+                                 HDMI_DPC_write_en8(1)|HDMI_DPC_fp_swen(0)|
+                                 HDMI_DPC_write_en7(1)|HDMI_DPC_fp(0)|
+                                 HDMI_DPC_write_en4(1)|HDMI_DPC_dp_swen(1)|
+                                 HDMI_DPC_write_en3(1)|HDMI_DPC_default_phase(1)|
+                                 HDMI_DPC_write_en2(1)|HDMI_DPC_color_depth(Deep_Depth)|
+                                 HDMI_DPC_write_en1(1)|HDMI_DPC_dpc_enable(Deep_Color));
+            }
+        }
+    }
+
+    //=====================================================================================================
+    // HDMI Control
+    //=====================================================================================================
+    if(Timing_Gen)
+    {
+        //0xb800d020
+        HDMI_WRITE_REG_INT32U(HDMI_CHNL_SEL,
+                         HDMI_CHNL_SEL_video_sd(1)|
+                         HDMI_CHNL_SEL_Interlaced_vfmt(0)|
+                         HDMI_CHNL_SEL_3D_video_format(Format_3D)|
+                         HDMI_CHNL_SEL_En_3D(En_3D)|
+                         HDMI_CHNL_SEL_timing_gen_en(1)|
+                         HDMI_CHNL_SEL_chl_sel(0)); //0:P channel 1:I channel
+    }
+    else
+    {
+        //0xb800d020
+        HDMI_WRITE_REG_INT32U(HDMI_CHNL_SEL,
+                         HDMI_CHNL_SEL_video_sd(1)|
+                         HDMI_CHNL_SEL_Interlaced_vfmt(0)|
+                         HDMI_CHNL_SEL_3D_video_format(0xf)|
+                         HDMI_CHNL_SEL_En_3D(0)|
+                         HDMI_CHNL_SEL_timing_gen_en(0)|
+                         HDMI_CHNL_SEL_chl_sel(0)); //0:P channel 1:I channel
+    }
+
+    if(DVI_or_HDMI==0) //DVI mode
+        Pixel_Colocr_Format = 0;
+    
+    if(Pixel_Colocr_Format==0) //RGB mode
+    {
+        //-- Color Transform (YCbCr 4:4:4 -> RGB 4:4:4)
+        //0xb800d024
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS0, HDMI_CS_TRANS0_c1(0x04a80));
+        //0xb800d028
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS1, HDMI_CS_TRANS1_c2(0x1e700));
+        //0xb800d02c
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS2, HDMI_CS_TRANS2_c3(0x1cc40));
+        //0xb800d200
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS3, HDMI_CS_TRANS3_c4(0x04a80));
+        //0xb800d204
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS4, HDMI_CS_TRANS4_c5(0x08140));
+        //0xb800d208
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS5, HDMI_CS_TRANS5_c6(0x00000));
+        //0xb800d20c
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS6, HDMI_CS_TRANS6_c7(0x04a80));
+        //0xb800d210
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS7, HDMI_CS_TRANS7_c8(0x00000));
+        //0xb800d214
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS8, HDMI_CS_TRANS8_c9(0x06680));
+        //0xb800d218
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS9, HDMI_CS_TRANS9_k1(0x21b0));
+        //0xb800d21c
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS10, HDMI_CS_TRANS10_k2(0xba70));
+        //0xb800d220
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS11, HDMI_CS_TRANS11_k3(0xc840));
+    }
+    else //YCbCr mode
+    {
+        //-- Color Transform (YCbCr 4:4:4 -> RGB 4:4:4)
+        //0xb800d024
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS0, HDMI_CS_TRANS0_c1(0x04000));
+        //0xb800d028
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS1, HDMI_CS_TRANS1_c2(0x00000));
+        //0xb800d02c
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS2, HDMI_CS_TRANS2_c3(0x00000));
+        //0xb800d200
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS3, HDMI_CS_TRANS3_c4(0x00000));
+        //0xb800d204
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS4, HDMI_CS_TRANS4_c5(0x04000));
+        //0xb800d208
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS5, HDMI_CS_TRANS5_c6(0x00000));
+        //0xb800d20c
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS6, HDMI_CS_TRANS6_c7(0x00000));
+        //0xb800d210
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS7, HDMI_CS_TRANS7_c8(0x00000));
+        //0xb800d214
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS8, HDMI_CS_TRANS8_c9(0x04000));
+        //0xb800d218
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS9, HDMI_CS_TRANS9_k1(0x0000));
+        //0xb800d21c
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS10, HDMI_CS_TRANS10_k2(0x0000));
+        //0xb800d220
+        HDMI_WRITE_REG_INT32U(HDMI_CS_TRANS11, HDMI_CS_TRANS11_k3(0x0000));
+    }
+
+    //0xb800d0b8
+    HDMI_WRITE_REG_INT32U(HDMI_SCHCR,
+                     HDMI_SCHCR_write_en10(1)|
+                     HDMI_SCHCR_422_pixel_repeat(0));
+    //0xb800d078
+    HDMI_WRITE_REG_INT32U(HDMI_GCPCR,
+                     HDMI_GCPCR_enablegcp(1)|
+                     HDMI_GCPCR_gcp_clearavmute(0)|
+                     HDMI_GCPCR_gcp_setavmute(0)|
+                     HDMI_GCPCR_write_data(0));
+    //0xb800d078
+    HDMI_WRITE_REG_INT32U(HDMI_GCPCR,
+                     HDMI_GCPCR_enablegcp(1)|
+                     HDMI_GCPCR_gcp_clearavmute(0)|
+                     HDMI_GCPCR_gcp_setavmute(0)|
+                     HDMI_GCPCR_write_data(1));
+    //0xb800d0a0
+    HDMI_WRITE_REG_INT32U(HDMI_RPCR,
+                     HDMI_RPCR_write_en6(1)|HDMI_RPCR_prp5period(0)|
+                     HDMI_RPCR_write_en5(1)|HDMI_RPCR_prp4period(0)|
+                     HDMI_RPCR_write_en4(1)|HDMI_RPCR_prp3period(0)|
+                     HDMI_RPCR_write_en3(1)|HDMI_RPCR_prp2period(0)|
+                     HDMI_RPCR_write_en2(0)|HDMI_RPCR_prp1period(0)|
+                     HDMI_RPCR_write_en1(1)|HDMI_RPCR_prp0period(0));
+    //0xb800d0a4
+    HDMI_WRITE_REG_INT32U(HDMI_RPEN,
+                     HDMI_RPEN_enprpkt5(1)|
+                     HDMI_RPEN_enprpkt4(1)|
+                     HDMI_RPEN_enprpkt3(1)|
+                     HDMI_RPEN_enprpkt2(1)| //Metadata package clear
+                     HDMI_RPEN_enprpkt1(0)| //Audio InfoFrame package clear by HDMI_audio_set
+                     HDMI_RPEN_enprpkt0(1)| //AVI InfoFrame package clear
+                     HDMI_RPEN_write_data(0));
+    //0xb800d0b4
+    HDMI_WRITE_REG_INT32U(HDMI_DIPCCR,
+                     HDMI_DIPCCR_write_en2(1)|HDMI_DIPCCR_vbidipcnt(17)|//18)|//ver. max 18 packets
+                     HDMI_DIPCCR_write_en1(1)|HDMI_DIPCCR_hbidipcnt(1));//hor. max 2 packets
+
+    //=====================================================================================================
+    // Scheduler
+    //=====================================================================================================
+    if(DVI_or_HDMI==0) //DVI mode
+    {
+        //0xb800d0b8
+        HDMI_WRITE_REG_INT32U(HDMI_SCHCR,
+                         HDMI_SCHCR_write_en12(1)|HDMI_SCHCR_color_transform_en(1)|
+                         HDMI_SCHCR_write_en11(0)|HDMI_SCHCR_ycbcr422_algo(0)|
+                         HDMI_SCHCR_write_en10(0)|HDMI_SCHCR_422_pixel_repeat(0)|
+                         HDMI_SCHCR_write_en9(0)|HDMI_SCHCR_vsyncpolin(0)|
+                         HDMI_SCHCR_write_en8(0)|HDMI_SCHCR_hsyncpolin(0)|
+                         HDMI_SCHCR_write_en7(1)|HDMI_SCHCR_vsyncpolinv(1)|
+                         HDMI_SCHCR_write_en6(1)|HDMI_SCHCR_hsyncpolinv(1)|
+                         HDMI_SCHCR_write_en5(1)|HDMI_SCHCR_pixelencycbcr422(0)|
+                         HDMI_SCHCR_write_en4(1)|HDMI_SCHCR_hdmi_videoxs(0)|
+                         HDMI_SCHCR_write_en3(1)|HDMI_SCHCR_pixelencfmt(0)| //RGB444
+                         HDMI_SCHCR_write_en2(1)|HDMI_SCHCR_pixelrepeat(0)|
+                         HDMI_SCHCR_write_en1(1)|HDMI_SCHCR_hdmi_modesel(0)); //0:DVI mode 1:HDMI mode
+    }
+    else //HDMI mode
+    {
+        //0xb800d0b8
+        HDMI_WRITE_REG_INT32U(HDMI_SCHCR,
+                         HDMI_SCHCR_write_en12(1)|HDMI_SCHCR_color_transform_en(1)|
+                         HDMI_SCHCR_write_en11(0)|HDMI_SCHCR_ycbcr422_algo(0)|
+                         HDMI_SCHCR_write_en10(0)|HDMI_SCHCR_422_pixel_repeat(0)|
+                         HDMI_SCHCR_write_en9(0)|HDMI_SCHCR_vsyncpolin(0)|
+                         HDMI_SCHCR_write_en8(0)|HDMI_SCHCR_hsyncpolin(0)|
+                         HDMI_SCHCR_write_en7(1)|HDMI_SCHCR_vsyncpolinv(1)|
+                         HDMI_SCHCR_write_en6(1)|HDMI_SCHCR_hsyncpolinv(1)|
+                         HDMI_SCHCR_write_en5(1)|HDMI_SCHCR_pixelencycbcr422(0)|
+                         HDMI_SCHCR_write_en4(1)|HDMI_SCHCR_hdmi_videoxs(0)|
+                         HDMI_SCHCR_write_en3(1)|HDMI_SCHCR_pixelencfmt(Pixel_Colocr_Format)|
+                         HDMI_SCHCR_write_en2(1)|HDMI_SCHCR_pixelrepeat(0)|
+                         HDMI_SCHCR_write_en1(1)|HDMI_SCHCR_hdmi_modesel(1)); //0:DVI mode 1:HDMI mode
+    }
+
+    //0xb800d0f0
+    HDMI_WRITE_REG_INT32U(HDMI_HDCP_KOWR, HDMI_HDCP_KOWR_hdcprekeykeepoutwin(0x29));
+
+    //0xb800d000
+    HDMI_WRITE_REG_INT32U(HDMI_INTEN,
+                     HDMI_INTEN_enriupdint(1)|
+                     HDMI_INTEN_enpjupdint(1)|
+                     HDMI_INTEN_write_data(0));
+
+#if 0
+    if(DVI_or_HDMI) HDMI_gen_avi_infoframe(2, Pixel_Colocr_Format, xv_YCC);
+
+    if(En_3D) HDMI_gen_vendor_Specific_infoframe(Format_3D);
+
+    if(DVI_or_HDMI && xv_YCC) HDMI_gen_metadata();
+#endif
+
+    //0xb800d034
+    HDMI_WRITE_REG_INT32U(HDMI_CR,
+                     HDMI_CR_write_en3(1)|HDMI_CR_tmds_encen(1)| //TMDS Encoder enable
+                     HDMI_CR_write_en2(1)|HDMI_CR_enablehdcp(1)| //Fixed a critical case of 480p with HDCP
+                     HDMI_CR_write_en1(1)|HDMI_CR_enablehdmi(1)); //HDMI enable
+    return;
+}
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/hdmi/hdmi.h b/drivers/video/fbdev/rtk/dc2vo/fpga/hdmi/hdmi.h
new file mode 100644
index 00000000..dd8e1e6
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/hdmi/hdmi.h
@@ -0,0 +1,12 @@
+#ifndef __FPGA_HDMI_H__
+#define __FPGA_HDMI_H__
+void SET_HDMI_Video_480p(
+        unsigned short int Pixel_Colocr_Format,
+        unsigned short int DVI_or_HDMI,
+        unsigned short int Deep_Color,
+        unsigned short int Deep_Depth,
+        unsigned short int xv_YCC,
+        unsigned short int Timing_Gen,
+        unsigned short int En_3D,
+        unsigned short int Format_3D);
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/CBUS_fw.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/CBUS_fw.h
new file mode 100644
index 00000000..e5fe4d4
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/CBUS_fw.h
@@ -0,0 +1,4488 @@
+// This file is generated using the spec version 1.39, firmware template version 1.39and SRIF Parser                                                                                source code SVN rev:802                    Version flow no.:1.1.66
+#ifndef _CBUS_REG_H_INCLUDED_
+#define _CBUS_REG_H_INCLUDED_
+
+//#define  _CBUS_USE_STRUCT
+#ifdef _CBUS_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    reserved_0:28;
+    unsigned int    wake_pulse_det:1;
+    unsigned int    dis_pulse_det:1;
+    unsigned int    wake_irq_en:1;
+    unsigned int    dis_irq_en:1;
+}CBUS_standby_00;
+
+typedef struct
+{
+    unsigned int    reserved_0:18;
+    unsigned int    clk_1m_div:4;
+    unsigned int    clk_1k_div:10;
+}CBUS_standby_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dis_deb_lv:3;
+    unsigned int    deb_lv:3;
+    unsigned int    disconn:2;
+}CBUS_standby_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:18;
+    unsigned int    wake_offset_low2:3;
+    unsigned int    wake_offset_low:3;
+    unsigned int    wake_cnt:3;
+    unsigned int    wake_offset:3;
+    unsigned int    cbus_disconn:1;
+    unsigned int    disconn_irq_en:1;
+}CBUS_standby_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dis_upper:4;
+    unsigned int    dis_lower:3;
+    unsigned int    wake_eco_en:1;
+}CBUS_standby_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    wake_num:3;
+    unsigned int    dis_num:5;
+}CBUS_standby_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    cbus_imp_auto:1;
+    unsigned int    bypass_mode:1;
+    unsigned int    sink_fsm_st:3;
+    unsigned int    cbus_100k_en:1;
+    unsigned int    cbus_1k_en:1;
+    unsigned int    cbus_in_sig:1;
+}CBUS_standby_07;
+
+typedef struct
+{
+    unsigned int    reserved_0:26;
+    unsigned int    goto_sink1_pos:1;
+    unsigned int    goto_float:1;
+    unsigned int    goto_sink1:1;
+    unsigned int    cable_det:1;
+    unsigned int    reserved_1:1;
+    unsigned int    dbg_sel_phy:1;
+}CBUS_standby_08;
+
+typedef struct
+{
+    unsigned int    ctrl_09_resv:32;
+}CBUS_standby_09;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    cbus_sr:1;
+    unsigned int    cbus_smt:1;
+    unsigned int    cbus_pu:1;
+    unsigned int    cbus_pd:1;
+    unsigned int    cbus_i:1;
+    unsigned int    cbus_e2:1;
+    unsigned int    cbus_e:1;
+}CBUS_phy_0;
+
+typedef struct
+{
+    unsigned int    adjr_1k:4;
+    unsigned int    adjr_100k:5;
+    unsigned int    auto_k_1k:1;
+    unsigned int    auto_k_100k:1;
+    unsigned int    en_res_cal_cbus:1;
+    unsigned int    sel_cbus0_input_high:2;
+    unsigned int    sel_cbus0_input_low:2;
+    unsigned int    sel_cbus_0_driving:3;
+    unsigned int    sel_vref_ldo:2;
+    unsigned int    trim_ldo_cbus:4;
+    unsigned int    triming_mode:1;
+    unsigned int    en_cbus:1;
+    unsigned int    en_cmp_cbus:1;
+    unsigned int    en_driver_cbus:1;
+    unsigned int    en_ldo_cbus:1;
+    unsigned int    psm_cbus:1;
+    unsigned int    sel_cbusb_gpio:1;
+}CBUS_phy_1;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    cbus_o:1;
+}CBUS_phy_2;
+
+typedef struct
+{
+    unsigned int    reserved_0:20;
+    unsigned int    sel_phy_soft_rst_n:1;
+    unsigned int    cbus_res_tst:10;
+    unsigned int    res_ok:1;
+}CBUS_phy_3;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dev_state:8;
+}MSC_reg_00;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    mhl_ver:8;
+}MSC_reg_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dev_cat:1;
+    unsigned int    plim:2;
+    unsigned int    pow:1;
+    unsigned int    dev_type:4;
+}MSC_reg_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    adop_id_h:8;
+}MSC_reg_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    adop_id_l:8;
+}MSC_reg_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    vid_link_md:2;
+    unsigned int    supp_vga:1;
+    unsigned int    supp_islands:1;
+    unsigned int    supp_ppixel:1;
+    unsigned int    supp_yuv422:1;
+    unsigned int    supp_yuv444:1;
+    unsigned int    supp_rgb444:1;
+}MSC_reg_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    aud_link_md:6;
+    unsigned int    aud_8ch:1;
+    unsigned int    aud_2ch:1;
+}MSC_reg_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    supp_vt:1;
+    unsigned int    video_type:3;
+    unsigned int    vt_game:1;
+    unsigned int    vt_cinema:1;
+    unsigned int    vt_photo:1;
+    unsigned int    vt_graphics:1;
+}MSC_reg_07;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ld_gui:1;
+    unsigned int    ld_speaker:1;
+    unsigned int    ld_record:1;
+    unsigned int    ld_tuner:1;
+    unsigned int    ld_media:1;
+    unsigned int    ld_audio:1;
+    unsigned int    ld_video:1;
+    unsigned int    ld_display:1;
+}MSC_reg_08;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    bandwid:8;
+}MSC_reg_09;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    feature_flag:3;
+    unsigned int    ucp_recv_supp:1;
+    unsigned int    ucp_send_supp:1;
+    unsigned int    sp_supp:1;
+    unsigned int    rap_supp:1;
+    unsigned int    rcp_supp:1;
+}MSC_reg_0a;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    device_id_h:8;
+}MSC_reg_0b;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    device_id_l:8;
+}MSC_reg_0c;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scr_size:8;
+}MSC_reg_0d;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    stat_size:4;
+    unsigned int    int_size:4;
+}MSC_reg_0e;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    cap_0f:8;
+}MSC_reg_0f;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    rchg_int_7:1;
+    unsigned int    rchg_int_6:1;
+    unsigned int    rchg_int_5:1;
+    unsigned int    cbus_3d_req:1;
+    unsigned int    grt_wrt:1;
+    unsigned int    req_wrt:1;
+    unsigned int    dscr_chg:1;
+    unsigned int    dcap_chg:1;
+}MSC_reg_20;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dchg_int_7:1;
+    unsigned int    dchg_int_6:1;
+    unsigned int    dchg_int_5:1;
+    unsigned int    dchg_int_4:1;
+    unsigned int    dchg_int_3:1;
+    unsigned int    dchg_int_2:1;
+    unsigned int    edid_chg:1;
+    unsigned int    dchg_int_0:1;
+}MSC_reg_21;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    chg22_7:1;
+    unsigned int    chg22_6:1;
+    unsigned int    chg22_5:1;
+    unsigned int    chg22_4:1;
+    unsigned int    chg22_3:1;
+    unsigned int    chg22_2:1;
+    unsigned int    chg22_1:1;
+    unsigned int    chg22_0:1;
+}MSC_reg_22;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    chg23_7:1;
+    unsigned int    chg23_6:1;
+    unsigned int    chg23_5:1;
+    unsigned int    chg23_4:1;
+    unsigned int    chg23_3:1;
+    unsigned int    chg23_2:1;
+    unsigned int    chg23_1:1;
+    unsigned int    chg23_0:1;
+}MSC_reg_23;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    chg24_7:1;
+    unsigned int    chg24_6:1;
+    unsigned int    chg24_5:1;
+    unsigned int    chg24_4:1;
+    unsigned int    chg24_3:1;
+    unsigned int    chg24_2:1;
+    unsigned int    chg24_1:1;
+    unsigned int    chg24_0:1;
+}MSC_reg_24;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    chg25_7:1;
+    unsigned int    chg25_6:1;
+    unsigned int    chg25_5:1;
+    unsigned int    chg25_4:1;
+    unsigned int    chg25_3:1;
+    unsigned int    chg25_2:1;
+    unsigned int    chg25_1:1;
+    unsigned int    chg25_0:1;
+}MSC_reg_25;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    chg26_7:1;
+    unsigned int    chg26_6:1;
+    unsigned int    chg26_5:1;
+    unsigned int    chg26_4:1;
+    unsigned int    chg26_3:1;
+    unsigned int    chg26_2:1;
+    unsigned int    chg26_1:1;
+    unsigned int    chg26_0:1;
+}MSC_reg_26;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    chg27_7:1;
+    unsigned int    chg27_6:1;
+    unsigned int    chg27_5:1;
+    unsigned int    chg27_4:1;
+    unsigned int    chg27_3:1;
+    unsigned int    chg27_2:1;
+    unsigned int    chg27_1:1;
+    unsigned int    chg27_0:1;
+}MSC_reg_27;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    conn_rdy:7;
+    unsigned int    dcap_rdy:1;
+}MSC_reg_30;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    link_mode:3;
+    unsigned int    muted:1;
+    unsigned int    path_en:1;
+    unsigned int    clk_mode:3;
+}MSC_reg_31;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    stat_32:8;
+}MSC_reg_32;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    stat_33:8;
+}MSC_reg_33;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    stat_34:8;
+}MSC_reg_34;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    stat_35:8;
+}MSC_reg_35;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    stat_36:8;
+}MSC_reg_36;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    stat_37:8;
+}MSC_reg_37;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_40:8;
+}MSC_reg_40;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_41:8;
+}MSC_reg_41;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_42:8;
+}MSC_reg_42;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_43:8;
+}MSC_reg_43;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_44:8;
+}MSC_reg_44;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_45:8;
+}MSC_reg_45;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_46:8;
+}MSC_reg_46;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_47:8;
+}MSC_reg_47;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_48:8;
+}MSC_reg_48;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_49:8;
+}MSC_reg_49;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_4a:8;
+}MSC_reg_4a;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_4b:8;
+}MSC_reg_4b;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_4c:8;
+}MSC_reg_4c;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_4d:8;
+}MSC_reg_4d;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_4e:8;
+}MSC_reg_4e;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_4f:8;
+}MSC_reg_4f;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_50:8;
+}MSC_reg_50;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_51:8;
+}MSC_reg_51;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_52:8;
+}MSC_reg_52;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_53:8;
+}MSC_reg_53;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_54:8;
+}MSC_reg_54;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_55:8;
+}MSC_reg_55;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_56:8;
+}MSC_reg_56;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_57:8;
+}MSC_reg_57;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_58:8;
+}MSC_reg_58;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_59:8;
+}MSC_reg_59;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_5a:8;
+}MSC_reg_5a;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_5b:8;
+}MSC_reg_5b;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_5c:8;
+}MSC_reg_5c;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_5d:8;
+}MSC_reg_5d;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_5e:8;
+}MSC_reg_5e;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scratch_5f:8;
+}MSC_reg_5f;
+
+typedef struct
+{
+    unsigned int    reserved_0:14;
+    unsigned int    sync0_hb_8_0:9;
+    unsigned int    sync0_lb_8_0:9;
+}CBUS_link_00;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    sync1_hb_7_0:8;
+    unsigned int    sync1_lb_7_0:8;
+}CBUS_link_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    sync_bit_time:8;
+}CBUS_link_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:23;
+    unsigned int    abs_thres_en:1;
+    unsigned int    abs_threshold:8;
+}CBUS_link_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    parity_time:8;
+}CBUS_link_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    parity_fail:1;
+    unsigned int    parity_irq_en:1;
+    unsigned int    ctrl_16_resv:1;
+    unsigned int    parity_limit:5;
+}CBUS_link_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    ack_fall:7;
+}CBUS_link_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    ack_0:7;
+}CBUS_link_07;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    tx_bit_time:8;
+}CBUS_link_08;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    chk_win_up:3;
+    unsigned int    chk_win_lo:2;
+    unsigned int    fast_reply_en:1;
+    unsigned int    ctrl_1b_resv:2;
+}CBUS_link_09;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    reserved_1:1;
+    unsigned int    tx_ack_fal:7;
+}CBUS_link_0a;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    tx_ack_low_hb:7;
+}CBUS_link_0b;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    tx_ack_low_lb:7;
+}CBUS_link_0c;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    retry_lv:3;
+    unsigned int    retry_flag:1;
+    unsigned int    ctrl_1f_resv:4;
+}CBUS_link_0d;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    drv_str:2;
+    unsigned int    drv_hi_cbus:6;
+}CBUS_link_0e;
+
+typedef struct
+{
+    unsigned int    reserved_0:26;
+    unsigned int    wait:4;
+    unsigned int    req_opp_int:2;
+}CBUS_link_0f;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    req_opp_flt:8;
+}CBUS_link_10;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    req_cont:8;
+}CBUS_link_11;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    req_hold:4;
+    unsigned int    resp_hold:4;
+}CBUS_link_12;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    glob_time:2;
+    unsigned int    link_time:5;
+    unsigned int    link_err:1;
+}CBUS_link_13;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    chk_point:6;
+    unsigned int    chk_err:1;
+    unsigned int    avoid_conf:1;
+}CBUS_link_14;
+
+typedef struct
+{
+    unsigned int    reserved_0:26;
+    unsigned int    mcumsc_en:1;
+    unsigned int    msc_wait_arb:1;
+    unsigned int    ctrl_28_resv:4;
+}CBUS_msc_00;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    na_msc_cmd:8;
+}CBUS_msc_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    na_msc_offset:8;
+}CBUS_msc_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    rx_fifo_full:1;
+    unsigned int    rx_fifo_empty:1;
+    unsigned int    rx_fifo_clr:1;
+    unsigned int    na_rx_len:5;
+}CBUS_msc_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    rx_fifo_data:8;
+}CBUS_msc_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fwdef_cmd_rev:8;
+}CBUS_msc_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    ucp_irq:1;
+    unsigned int    ucpk_irq:1;
+    unsigned int    ucpe_irq:1;
+    unsigned int    dcap_rdy_chg:1;
+    unsigned int    muted_chg:1;
+    unsigned int    path_en_chg:1;
+    unsigned int    clk_mode_chg:1;
+    unsigned int    msge_irq:1;
+    unsigned int    rcp_irq:1;
+    unsigned int    rcpk_irq:1;
+    unsigned int    rcpe_irq:1;
+    unsigned int    rap_irq:1;
+    unsigned int    rapk_irq:1;
+    unsigned int    msg_sub_irq:1;
+    unsigned int    wr_stat_irq:1;
+    unsigned int    rd_devcap_irq:1;
+    unsigned int    get_stat_irq:1;
+    unsigned int    get_id_irq:1;
+    unsigned int    get_msg_irq:1;
+    unsigned int    sc1_err_irq:1;
+    unsigned int    ddc_err_irq:1;
+    unsigned int    msc_err_irq:1;
+    unsigned int    wr_burst_irq:1;
+    unsigned int    sc3_err_irq:1;
+    unsigned int    fwdef_cmd_irq:1;
+    unsigned int    allmsc_cmd_irq:1;
+    unsigned int    abort_res_irq:1;
+    unsigned int    abort_req_irq:1;
+    unsigned int    ddc_abort_irq:1;
+}CBUS_msc_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    ucp_irq_en:1;
+    unsigned int    ucpk_irq_en:1;
+    unsigned int    ucpe_irq_en:1;
+    unsigned int    dcap_rdy_irq_en:1;
+    unsigned int    muted_chg_irq_en:1;
+    unsigned int    path_en_irq_en:1;
+    unsigned int    clk_mode_irq_en:1;
+    unsigned int    msge_irq_en:1;
+    unsigned int    rcp_irq_en:1;
+    unsigned int    rcpk_irq_en:1;
+    unsigned int    rcpe_irq_en:1;
+    unsigned int    rap_irq_en:1;
+    unsigned int    rapk_irq_en:1;
+    unsigned int    msg_sub_irq_en:1;
+    unsigned int    wr_stat_irq_en:1;
+    unsigned int    rd_devcap_irq_en:1;
+    unsigned int    get_stat_irq_en:1;
+    unsigned int    get_id_irq_en:1;
+    unsigned int    get_msg_irq_en:1;
+    unsigned int    sc1_err_irq_en:1;
+    unsigned int    ddc_err_irq_en:1;
+    unsigned int    msc_err_irq_en:1;
+    unsigned int    wr_burst_irq_en:1;
+    unsigned int    sc3_err_irq_en:1;
+    unsigned int    fwdef_cmd_irq_en:1;
+    unsigned int    allmsc_cmd_irq_en:1;
+    unsigned int    abort_res_irq_en:1;
+    unsigned int    abort_req_irq_en:1;
+    unsigned int    ddc_abort_irq_en:1;
+}CBUS_msc_07;
+
+typedef struct
+{
+    unsigned int    rchg_irq_en:3;
+    unsigned int    cbus_3d_req_irq_en:1;
+    unsigned int    grt_irq_en:1;
+    unsigned int    req_irq_en:1;
+    unsigned int    dscr_irq_en:1;
+    unsigned int    dcap_irq_en:1;
+    unsigned int    dchg_bit7_irq_en:1;
+    unsigned int    dchg_bit6_irq_en:1;
+    unsigned int    dchg_bit5_irq_en:1;
+    unsigned int    dchg_bit4_irq_en:1;
+    unsigned int    dchg_bit3_irq_en:1;
+    unsigned int    dchg_bit2_irq_en:1;
+    unsigned int    edid_irq_en:1;
+    unsigned int    dchg_bit0_irq_en:1;
+    unsigned int    chg22_irq_en:8;
+    unsigned int    chg23_irq_en:8;
+}CBUS_msc_08;
+
+typedef struct
+{
+    unsigned int    chg24_irq_en:8;
+    unsigned int    chg25_irq_en:8;
+    unsigned int    chg26_irq_en:8;
+    unsigned int    chg27_irq_en:8;
+}CBUS_msc_09;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    msc_err_code:8;
+}CBUS_msc_0a;
+
+typedef struct
+{
+    unsigned int    reserved_0:22;
+    unsigned int    rcp_reply_abort:1;
+    unsigned int    rcp_reply_nack:1;
+    unsigned int    vendor_id:8;
+}CBUS_msc_0b;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    msg_cmd:8;
+}CBUS_msc_0c;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    msg_dat:8;
+}CBUS_msc_0d;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    msge_rcv:8;
+}CBUS_msc_0e;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    rcp_rcv:8;
+}CBUS_msc_0f;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    rcpk_rcv:8;
+}CBUS_msc_10;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    rcpe_rcv:8;
+}CBUS_msc_11;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    rap_rcv:8;
+}CBUS_msc_12;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    rapk_rcv:8;
+}CBUS_msc_13;
+
+typedef struct
+{
+    unsigned int    reserved_0:26;
+    unsigned int    burst_timeout:1;
+    unsigned int    wb_id_chk:1;
+    unsigned int    burst_wait:4;
+}CBUS_msc_14;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    adop_idh_rcv:8;
+    unsigned int    adop_idl_rcv:8;
+}CBUS_msc_15;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    auto_handshake:1;
+    unsigned int    insert_id:1;
+    unsigned int    wb_byte_num0:6;
+    unsigned int    wb_byte_num1:6;
+    unsigned int    adop_txid_h:8;
+    unsigned int    adop_txid_l:8;
+}CBUS_msc_16;
+
+typedef struct
+{
+    unsigned int    reserved_0:29;
+    unsigned int    que_fsm_clr:1;
+    unsigned int    sch_fsm_clr:1;
+    unsigned int    spi_fsm_clr:1;
+}CBUS_msc_17;
+
+typedef struct
+{
+    unsigned int    reserved_0:20;
+    unsigned int    que_fsm:4;
+    unsigned int    sch_fsm:4;
+    unsigned int    spi_fsm:4;
+}CBUS_msc_18;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    cap_offset:8;
+}CBUS_msc_19;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    int_offset:8;
+}CBUS_msc_1a;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    sta_offset:8;
+}CBUS_msc_1b;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    scr_offset:8;
+}CBUS_msc_1c;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    ddc_err_force:1;
+    unsigned int    msc_err_force:1;
+}CBUS_msc_1d;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ddc_err_fw:8;
+}CBUS_msc_1e;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    msc_err_fw:8;
+}CBUS_msc_1f;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ucp_rcv:8;
+}CBUS_msc_20;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ucpk_rcv:8;
+}CBUS_msc_21;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ucpe_rcv:8;
+}CBUS_msc_22;
+
+typedef struct
+{
+    unsigned int    reserved_0:23;
+    unsigned int    fw0_req:1;
+    unsigned int    fw0_fifo_clr:1;
+    unsigned int    fw0_fifo_full:1;
+    unsigned int    fw0_fifo_empty:1;
+    unsigned int    fw0_tx_case:3;
+    unsigned int    fw0_head:2;
+}FW0_req_00;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw0_cmd1:8;
+}FW0_req_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw0_cmd2:8;
+}FW0_req_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw0_offset:8;
+}FW0_req_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw0_data:8;
+}FW0_req_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:22;
+    unsigned int    fw0_rty_ovr:1;
+    unsigned int    fw0_fin:1;
+    unsigned int    fw0_cmd_event:1;
+    unsigned int    fw0_data_event:1;
+    unsigned int    fw0_rcv_err:1;
+    unsigned int    fw0_fin_irq_en:1;
+    unsigned int    fw0_cmd_irq_en:1;
+    unsigned int    fw0_data_irq_en:1;
+    unsigned int    fw0_wait_case:2;
+}FW0_req_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw0_cmd_rcv:8;
+}FW0_req_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw0_data_rcv:8;
+}FW0_req_07;
+
+typedef struct
+{
+    unsigned int    reserved_0:18;
+    unsigned int    fw0_rd_en:1;
+    unsigned int    fw0_fifo_len:5;
+    unsigned int    fw0_rdata:8;
+}FW0_req_08;
+
+typedef struct
+{
+    unsigned int    reserved_0:23;
+    unsigned int    fw1_req:1;
+    unsigned int    fw1_fifo_clr:1;
+    unsigned int    fw1_fifo_full:1;
+    unsigned int    fw1_fifo_empty:1;
+    unsigned int    fw1_tx_case:3;
+    unsigned int    fw1_head:2;
+}FW1_req_00;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw1_cmd1:8;
+}FW1_req_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw1_cmd2:8;
+}FW1_req_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw1_offset:8;
+}FW1_req_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw1_data:8;
+}FW1_req_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:22;
+    unsigned int    fw1_rty_ovr:1;
+    unsigned int    fw1_fin:1;
+    unsigned int    fw1_cmd_event:1;
+    unsigned int    fw1_data_event:1;
+    unsigned int    fw1_rcv_err:1;
+    unsigned int    fw1_fin_irq_en:1;
+    unsigned int    fw1_cmd_irq_en:1;
+    unsigned int    fw1_data_irq_en:1;
+    unsigned int    fw1_wait_case:2;
+}FW1_req_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw1_cmd_rcv:8;
+}FW1_req_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw1_data_rcv:8;
+}FW1_req_07;
+
+typedef struct
+{
+    unsigned int    reserved_0:18;
+    unsigned int    fw1_rd_en:1;
+    unsigned int    fw1_fifo_len:5;
+    unsigned int    fw1_rdata:8;
+}FW1_req_08;
+
+typedef struct
+{
+    unsigned int    reserved_0:23;
+    unsigned int    fw2_req:1;
+    unsigned int    fw2_fifo_clr:1;
+    unsigned int    fw2_fifo_full:1;
+    unsigned int    fw2_fifo_empty:1;
+    unsigned int    fw2_tx_case:3;
+    unsigned int    fw2_head:2;
+}FW2_req_00;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw2_cmd1:8;
+}FW2_req_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw2_cmd2:8;
+}FW2_req_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw2_offset:8;
+}FW2_req_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw2_data:8;
+}FW2_req_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:22;
+    unsigned int    fw2_rty_ovr:1;
+    unsigned int    fw2_fin:1;
+    unsigned int    fw2_cmd_event:1;
+    unsigned int    fw2_data_event:1;
+    unsigned int    fw2_rcv_err:1;
+    unsigned int    fw2_fin_irq_en:1;
+    unsigned int    fw2_cmd_irq_en:1;
+    unsigned int    fw2_data_irq_en:1;
+    unsigned int    fw2_wait_case:2;
+}FW2_req_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw2_cmd_rcv:8;
+}FW2_req_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fw2_data_rcv:8;
+}FW2_req_07;
+
+typedef struct
+{
+    unsigned int    reserved_0:18;
+    unsigned int    fw2_rd_en:1;
+    unsigned int    fw2_fifo_len:5;
+    unsigned int    fw2_rdata:8;
+}FW2_req_08;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ddc_err_code:8;
+}CBUS_ddc_00;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    iic_ck_tgt:8;
+}CBUS_ddc_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    mcuddc_en:1;
+    unsigned int    ddc_prior_dis:1;
+    unsigned int    ddc_cmd_event:1;
+    unsigned int    ddc_data_event:1;
+    unsigned int    ddc_cmd_irq_en:1;
+    unsigned int    ddc_data_irq_en:1;
+    unsigned int    ddc_req_ctrl:1;
+    unsigned int    ddc_req:1;
+}CBUS_ddc_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ddc_rcv_cmd:8;
+}CBUS_ddc_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ddc_rcv_data:8;
+}CBUS_ddc_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ddc_data_fw:8;
+}CBUS_ddc_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:28;
+    unsigned int    ddc_eof_irq:1;
+    unsigned int    ddc_eof_irq_en:1;
+    unsigned int    ddcrd_rst_en:1;
+    unsigned int    ddcrd_new_md:1;
+}CBUS_ddc_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:26;
+    unsigned int    clk_mod_vwd:1;
+    unsigned int    clk_mod_awd:1;
+    unsigned int    mute_en_vwd:1;
+    unsigned int    mute_en_awd:1;
+    unsigned int    path_en_off_vwd:1;
+    unsigned int    path_en_off_awd:1;
+}CBUS_wdog;
+
+typedef struct
+{
+    unsigned int    reserved_0:26;
+    unsigned int    arbiter_irq:1;
+    unsigned int    ddc_irq:1;
+    unsigned int    msc_ch_irq:1;
+    unsigned int    msc_int_irq:1;
+    unsigned int    msc_stat_irq:1;
+    unsigned int    ctrl_01_resv:1;
+}CBUS_int_index;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    cbus_test_md:2;
+    unsigned int    fw_out:1;
+    unsigned int    dbg_sel:3;
+    unsigned int    reserved_1:2;
+}CBUS_test;
+
+typedef struct
+{
+    unsigned int    cbus_dummy0:32;
+}CBUS_dummy0;
+#endif
+
+
+#define CBUS_STANDBY_00                                               0x18037400
+#define CBUS_STANDBY_00_reg_addr                                      "0xb8037400"
+#define CBUS_STANDBY_00_reg                                           0xb8037400
+#define CBUS_STANDBY_00_inst_addr                                     "0x0100"
+#define CBUS_STANDBY_00_inst                                          0x0100
+#define CBUS_STANDBY_00_wake_pulse_det_shift                          (3)
+#define CBUS_STANDBY_00_dis_pulse_det_shift                           (2)
+#define CBUS_STANDBY_00_wake_irq_en_shift                             (1)
+#define CBUS_STANDBY_00_dis_irq_en_shift                              (0)
+#define CBUS_STANDBY_00_wake_pulse_det_mask                           (0x00000008)
+#define CBUS_STANDBY_00_dis_pulse_det_mask                            (0x00000004)
+#define CBUS_STANDBY_00_wake_irq_en_mask                              (0x00000002)
+#define CBUS_STANDBY_00_dis_irq_en_mask                               (0x00000001)
+#define CBUS_STANDBY_00_wake_pulse_det(data)                          (0x00000008&((data)<<3))
+#define CBUS_STANDBY_00_dis_pulse_det(data)                           (0x00000004&((data)<<2))
+#define CBUS_STANDBY_00_wake_irq_en(data)                             (0x00000002&((data)<<1))
+#define CBUS_STANDBY_00_dis_irq_en(data)                              (0x00000001&(data))
+#define CBUS_STANDBY_00_get_wake_pulse_det(data)                      ((0x00000008&(data))>>3)
+#define CBUS_STANDBY_00_get_dis_pulse_det(data)                       ((0x00000004&(data))>>2)
+#define CBUS_STANDBY_00_get_wake_irq_en(data)                         ((0x00000002&(data))>>1)
+#define CBUS_STANDBY_00_get_dis_irq_en(data)                          (0x00000001&(data))
+
+
+#define CBUS_STANDBY_01                                               0x18037404
+#define CBUS_STANDBY_01_reg_addr                                      "0xb8037404"
+#define CBUS_STANDBY_01_reg                                           0xb8037404
+#define CBUS_STANDBY_01_inst_addr                                     "0x0101"
+#define CBUS_STANDBY_01_inst                                          0x0101
+#define CBUS_STANDBY_01_clk_1m_div_shift                              (10)
+#define CBUS_STANDBY_01_clk_1k_div_shift                              (0)
+#define CBUS_STANDBY_01_clk_1m_div_mask                               (0x00003C00)
+#define CBUS_STANDBY_01_clk_1k_div_mask                               (0x000003FF)
+#define CBUS_STANDBY_01_clk_1m_div(data)                              (0x00003C00&((data)<<10))
+#define CBUS_STANDBY_01_clk_1k_div(data)                              (0x000003FF&(data))
+#define CBUS_STANDBY_01_get_clk_1m_div(data)                          ((0x00003C00&(data))>>10)
+#define CBUS_STANDBY_01_get_clk_1k_div(data)                          (0x000003FF&(data))
+
+
+#define CBUS_STANDBY_02                                               0x18037408
+#define CBUS_STANDBY_02_reg_addr                                      "0xb8037408"
+#define CBUS_STANDBY_02_reg                                           0xb8037408
+#define CBUS_STANDBY_02_inst_addr                                     "0x0102"
+#define CBUS_STANDBY_02_inst                                          0x0102
+#define CBUS_STANDBY_02_dis_deb_lv_shift                              (5)
+#define CBUS_STANDBY_02_deb_lv_shift                                  (2)
+#define CBUS_STANDBY_02_disconn_shift                                 (0)
+#define CBUS_STANDBY_02_dis_deb_lv_mask                               (0x000000E0)
+#define CBUS_STANDBY_02_deb_lv_mask                                   (0x0000001C)
+#define CBUS_STANDBY_02_disconn_mask                                  (0x00000003)
+#define CBUS_STANDBY_02_dis_deb_lv(data)                              (0x000000E0&((data)<<5))
+#define CBUS_STANDBY_02_deb_lv(data)                                  (0x0000001C&((data)<<2))
+#define CBUS_STANDBY_02_disconn(data)                                 (0x00000003&(data))
+#define CBUS_STANDBY_02_get_dis_deb_lv(data)                          ((0x000000E0&(data))>>5)
+#define CBUS_STANDBY_02_get_deb_lv(data)                              ((0x0000001C&(data))>>2)
+#define CBUS_STANDBY_02_get_disconn(data)                             (0x00000003&(data))
+
+
+#define CBUS_STANDBY_04                                               0x18037410
+#define CBUS_STANDBY_04_reg_addr                                      "0xb8037410"
+#define CBUS_STANDBY_04_reg                                           0xb8037410
+#define CBUS_STANDBY_04_inst_addr                                     "0x0104"
+#define CBUS_STANDBY_04_inst                                          0x0104
+#define CBUS_STANDBY_04_wake_offset_low2_shift                        (11)
+#define CBUS_STANDBY_04_wake_offset_low_shift                         (8)
+#define CBUS_STANDBY_04_wake_cnt_shift                                (5)
+#define CBUS_STANDBY_04_wake_offset_shift                             (2)
+#define CBUS_STANDBY_04_cbus_disconn_shift                            (1)
+#define CBUS_STANDBY_04_disconn_irq_en_shift                          (0)
+#define CBUS_STANDBY_04_wake_offset_low2_mask                         (0x00003800)
+#define CBUS_STANDBY_04_wake_offset_low_mask                          (0x00000700)
+#define CBUS_STANDBY_04_wake_cnt_mask                                 (0x000000E0)
+#define CBUS_STANDBY_04_wake_offset_mask                              (0x0000001C)
+#define CBUS_STANDBY_04_cbus_disconn_mask                             (0x00000002)
+#define CBUS_STANDBY_04_disconn_irq_en_mask                           (0x00000001)
+#define CBUS_STANDBY_04_wake_offset_low2(data)                        (0x00003800&((data)<<11))
+#define CBUS_STANDBY_04_wake_offset_low(data)                         (0x00000700&((data)<<8))
+#define CBUS_STANDBY_04_wake_cnt(data)                                (0x000000E0&((data)<<5))
+#define CBUS_STANDBY_04_wake_offset(data)                             (0x0000001C&((data)<<2))
+#define CBUS_STANDBY_04_cbus_disconn(data)                            (0x00000002&((data)<<1))
+#define CBUS_STANDBY_04_disconn_irq_en(data)                          (0x00000001&(data))
+#define CBUS_STANDBY_04_get_wake_offset_low2(data)                    ((0x00003800&(data))>>11)
+#define CBUS_STANDBY_04_get_wake_offset_low(data)                     ((0x00000700&(data))>>8)
+#define CBUS_STANDBY_04_get_wake_cnt(data)                            ((0x000000E0&(data))>>5)
+#define CBUS_STANDBY_04_get_wake_offset(data)                         ((0x0000001C&(data))>>2)
+#define CBUS_STANDBY_04_get_cbus_disconn(data)                        ((0x00000002&(data))>>1)
+#define CBUS_STANDBY_04_get_disconn_irq_en(data)                      (0x00000001&(data))
+
+
+#define CBUS_STANDBY_05                                               0x18037414
+#define CBUS_STANDBY_05_reg_addr                                      "0xb8037414"
+#define CBUS_STANDBY_05_reg                                           0xb8037414
+#define CBUS_STANDBY_05_inst_addr                                     "0x0105"
+#define CBUS_STANDBY_05_inst                                          0x0105
+#define CBUS_STANDBY_05_dis_upper_shift                               (4)
+#define CBUS_STANDBY_05_dis_lower_shift                               (1)
+#define CBUS_STANDBY_05_wake_eco_en_shift                             (0)
+#define CBUS_STANDBY_05_dis_upper_mask                                (0x000000F0)
+#define CBUS_STANDBY_05_dis_lower_mask                                (0x0000000E)
+#define CBUS_STANDBY_05_wake_eco_en_mask                              (0x00000001)
+#define CBUS_STANDBY_05_dis_upper(data)                               (0x000000F0&((data)<<4))
+#define CBUS_STANDBY_05_dis_lower(data)                               (0x0000000E&((data)<<1))
+#define CBUS_STANDBY_05_wake_eco_en(data)                             (0x00000001&(data))
+#define CBUS_STANDBY_05_get_dis_upper(data)                           ((0x000000F0&(data))>>4)
+#define CBUS_STANDBY_05_get_dis_lower(data)                           ((0x0000000E&(data))>>1)
+#define CBUS_STANDBY_05_get_wake_eco_en(data)                         (0x00000001&(data))
+
+
+#define CBUS_STANDBY_06                                               0x18037418
+#define CBUS_STANDBY_06_reg_addr                                      "0xb8037418"
+#define CBUS_STANDBY_06_reg                                           0xb8037418
+#define CBUS_STANDBY_06_inst_addr                                     "0x0106"
+#define CBUS_STANDBY_06_inst                                          0x0106
+#define CBUS_STANDBY_06_wake_num_shift                                (5)
+#define CBUS_STANDBY_06_dis_num_shift                                 (0)
+#define CBUS_STANDBY_06_wake_num_mask                                 (0x000000E0)
+#define CBUS_STANDBY_06_dis_num_mask                                  (0x0000001F)
+#define CBUS_STANDBY_06_wake_num(data)                                (0x000000E0&((data)<<5))
+#define CBUS_STANDBY_06_dis_num(data)                                 (0x0000001F&(data))
+#define CBUS_STANDBY_06_get_wake_num(data)                            ((0x000000E0&(data))>>5)
+#define CBUS_STANDBY_06_get_dis_num(data)                             (0x0000001F&(data))
+
+
+#define CBUS_STANDBY_07                                               0x1803741c
+#define CBUS_STANDBY_07_reg_addr                                      "0xb803741c"
+#define CBUS_STANDBY_07_reg                                           0xb803741c
+#define CBUS_STANDBY_07_inst_addr                                     "0x0107"
+#define CBUS_STANDBY_07_inst                                          0x0107
+#define CBUS_STANDBY_07_cbus_imp_auto_shift                           (7)
+#define CBUS_STANDBY_07_bypass_mode_shift                             (6)
+#define CBUS_STANDBY_07_sink_fsm_st_shift                             (3)
+#define CBUS_STANDBY_07_cbus_100k_en_shift                            (2)
+#define CBUS_STANDBY_07_cbus_1k_en_shift                              (1)
+#define CBUS_STANDBY_07_cbus_in_sig_shift                             (0)
+#define CBUS_STANDBY_07_cbus_imp_auto_mask                            (0x00000080)
+#define CBUS_STANDBY_07_bypass_mode_mask                              (0x00000040)
+#define CBUS_STANDBY_07_sink_fsm_st_mask                              (0x00000038)
+#define CBUS_STANDBY_07_cbus_100k_en_mask                             (0x00000004)
+#define CBUS_STANDBY_07_cbus_1k_en_mask                               (0x00000002)
+#define CBUS_STANDBY_07_cbus_in_sig_mask                              (0x00000001)
+#define CBUS_STANDBY_07_cbus_imp_auto(data)                           (0x00000080&((data)<<7))
+#define CBUS_STANDBY_07_bypass_mode(data)                             (0x00000040&((data)<<6))
+#define CBUS_STANDBY_07_sink_fsm_st(data)                             (0x00000038&((data)<<3))
+#define CBUS_STANDBY_07_cbus_100k_en(data)                            (0x00000004&((data)<<2))
+#define CBUS_STANDBY_07_cbus_1k_en(data)                              (0x00000002&((data)<<1))
+#define CBUS_STANDBY_07_cbus_in_sig(data)                             (0x00000001&(data))
+#define CBUS_STANDBY_07_get_cbus_imp_auto(data)                       ((0x00000080&(data))>>7)
+#define CBUS_STANDBY_07_get_bypass_mode(data)                         ((0x00000040&(data))>>6)
+#define CBUS_STANDBY_07_get_sink_fsm_st(data)                         ((0x00000038&(data))>>3)
+#define CBUS_STANDBY_07_get_cbus_100k_en(data)                        ((0x00000004&(data))>>2)
+#define CBUS_STANDBY_07_get_cbus_1k_en(data)                          ((0x00000002&(data))>>1)
+#define CBUS_STANDBY_07_get_cbus_in_sig(data)                         (0x00000001&(data))
+
+
+#define CBUS_STANDBY_08                                               0x18037420
+#define CBUS_STANDBY_08_reg_addr                                      "0xb8037420"
+#define CBUS_STANDBY_08_reg                                           0xb8037420
+#define CBUS_STANDBY_08_inst_addr                                     "0x0108"
+#define CBUS_STANDBY_08_inst                                          0x0108
+#define CBUS_STANDBY_08_goto_sink1_pos_shift                          (5)
+#define CBUS_STANDBY_08_goto_float_shift                              (4)
+#define CBUS_STANDBY_08_goto_sink1_shift                              (3)
+#define CBUS_STANDBY_08_cable_det_shift                               (2)
+#define CBUS_STANDBY_08_dbg_sel_phy_shift                             (0)
+#define CBUS_STANDBY_08_goto_sink1_pos_mask                           (0x00000020)
+#define CBUS_STANDBY_08_goto_float_mask                               (0x00000010)
+#define CBUS_STANDBY_08_goto_sink1_mask                               (0x00000008)
+#define CBUS_STANDBY_08_cable_det_mask                                (0x00000004)
+#define CBUS_STANDBY_08_dbg_sel_phy_mask                              (0x00000001)
+#define CBUS_STANDBY_08_goto_sink1_pos(data)                          (0x00000020&((data)<<5))
+#define CBUS_STANDBY_08_goto_float(data)                              (0x00000010&((data)<<4))
+#define CBUS_STANDBY_08_goto_sink1(data)                              (0x00000008&((data)<<3))
+#define CBUS_STANDBY_08_cable_det(data)                               (0x00000004&((data)<<2))
+#define CBUS_STANDBY_08_dbg_sel_phy(data)                             (0x00000001&(data))
+#define CBUS_STANDBY_08_get_goto_sink1_pos(data)                      ((0x00000020&(data))>>5)
+#define CBUS_STANDBY_08_get_goto_float(data)                          ((0x00000010&(data))>>4)
+#define CBUS_STANDBY_08_get_goto_sink1(data)                          ((0x00000008&(data))>>3)
+#define CBUS_STANDBY_08_get_cable_det(data)                           ((0x00000004&(data))>>2)
+#define CBUS_STANDBY_08_get_dbg_sel_phy(data)                         (0x00000001&(data))
+
+
+#define CBUS_STANDBY_09                                               0x18037424
+#define CBUS_STANDBY_09_reg_addr                                      "0xb8037424"
+#define CBUS_STANDBY_09_reg                                           0xb8037424
+#define CBUS_STANDBY_09_inst_addr                                     "0x0109"
+#define CBUS_STANDBY_09_inst                                          0x0109
+#define CBUS_STANDBY_09_ctrl_09_resv_shift                            (0)
+#define CBUS_STANDBY_09_ctrl_09_resv_mask                             (0xFFFFFFFF)
+#define CBUS_STANDBY_09_ctrl_09_resv(data)                            (0xFFFFFFFF&(data))
+#define CBUS_STANDBY_09_get_ctrl_09_resv(data)                        (0xFFFFFFFF&(data))
+
+
+#define CBUS_PHY_0                                                    0x18037430
+#define CBUS_PHY_0_reg_addr                                           "0xb8037430"
+#define CBUS_PHY_0_reg                                                0xb8037430
+#define CBUS_PHY_0_inst_addr                                          "0x010C"
+#define CBUS_PHY_0_inst                                               0x010C
+#define CBUS_PHY_0_cbus_sr_shift                                      (6)
+#define CBUS_PHY_0_cbus_smt_shift                                     (5)
+#define CBUS_PHY_0_cbus_pu_shift                                      (4)
+#define CBUS_PHY_0_cbus_pd_shift                                      (3)
+#define CBUS_PHY_0_cbus_i_shift                                       (2)
+#define CBUS_PHY_0_cbus_e2_shift                                      (1)
+#define CBUS_PHY_0_cbus_e_shift                                       (0)
+#define CBUS_PHY_0_cbus_sr_mask                                       (0x00000040)
+#define CBUS_PHY_0_cbus_smt_mask                                      (0x00000020)
+#define CBUS_PHY_0_cbus_pu_mask                                       (0x00000010)
+#define CBUS_PHY_0_cbus_pd_mask                                       (0x00000008)
+#define CBUS_PHY_0_cbus_i_mask                                        (0x00000004)
+#define CBUS_PHY_0_cbus_e2_mask                                       (0x00000002)
+#define CBUS_PHY_0_cbus_e_mask                                        (0x00000001)
+#define CBUS_PHY_0_cbus_sr(data)                                      (0x00000040&((data)<<6))
+#define CBUS_PHY_0_cbus_smt(data)                                     (0x00000020&((data)<<5))
+#define CBUS_PHY_0_cbus_pu(data)                                      (0x00000010&((data)<<4))
+#define CBUS_PHY_0_cbus_pd(data)                                      (0x00000008&((data)<<3))
+#define CBUS_PHY_0_cbus_i(data)                                       (0x00000004&((data)<<2))
+#define CBUS_PHY_0_cbus_e2(data)                                      (0x00000002&((data)<<1))
+#define CBUS_PHY_0_cbus_e(data)                                       (0x00000001&(data))
+#define CBUS_PHY_0_get_cbus_sr(data)                                  ((0x00000040&(data))>>6)
+#define CBUS_PHY_0_get_cbus_smt(data)                                 ((0x00000020&(data))>>5)
+#define CBUS_PHY_0_get_cbus_pu(data)                                  ((0x00000010&(data))>>4)
+#define CBUS_PHY_0_get_cbus_pd(data)                                  ((0x00000008&(data))>>3)
+#define CBUS_PHY_0_get_cbus_i(data)                                   ((0x00000004&(data))>>2)
+#define CBUS_PHY_0_get_cbus_e2(data)                                  ((0x00000002&(data))>>1)
+#define CBUS_PHY_0_get_cbus_e(data)                                   (0x00000001&(data))
+
+
+#define CBUS_PHY_1                                                    0x18037434
+#define CBUS_PHY_1_reg_addr                                           "0xb8037434"
+#define CBUS_PHY_1_reg                                                0xb8037434
+#define CBUS_PHY_1_inst_addr                                          "0x010D"
+#define CBUS_PHY_1_inst                                               0x010D
+#define CBUS_PHY_1_adjr_1k_shift                                      (28)
+#define CBUS_PHY_1_adjr_100k_shift                                    (23)
+#define CBUS_PHY_1_auto_k_1k_shift                                    (22)
+#define CBUS_PHY_1_auto_k_100k_shift                                  (21)
+#define CBUS_PHY_1_en_res_cal_cbus_shift                              (20)
+#define CBUS_PHY_1_sel_cbus0_input_high_shift                         (18)
+#define CBUS_PHY_1_sel_cbus0_input_low_shift                          (16)
+#define CBUS_PHY_1_sel_cbus_0_driving_shift                           (13)
+#define CBUS_PHY_1_sel_vref_ldo_shift                                 (11)
+#define CBUS_PHY_1_trim_ldo_cbus_shift                                (7)
+#define CBUS_PHY_1_triming_mode_shift                                 (6)
+#define CBUS_PHY_1_en_cbus_shift                                      (5)
+#define CBUS_PHY_1_en_cmp_cbus_shift                                  (4)
+#define CBUS_PHY_1_en_driver_cbus_shift                               (3)
+#define CBUS_PHY_1_en_ldo_cbus_shift                                  (2)
+#define CBUS_PHY_1_psm_cbus_shift                                     (1)
+#define CBUS_PHY_1_sel_cbusb_gpio_shift                               (0)
+#define CBUS_PHY_1_adjr_1k_mask                                       (0xF0000000)
+#define CBUS_PHY_1_adjr_100k_mask                                     (0x0F800000)
+#define CBUS_PHY_1_auto_k_1k_mask                                     (0x00400000)
+#define CBUS_PHY_1_auto_k_100k_mask                                   (0x00200000)
+#define CBUS_PHY_1_en_res_cal_cbus_mask                               (0x00100000)
+#define CBUS_PHY_1_sel_cbus0_input_high_mask                          (0x000C0000)
+#define CBUS_PHY_1_sel_cbus0_input_low_mask                           (0x00030000)
+#define CBUS_PHY_1_sel_cbus_0_driving_mask                            (0x0000E000)
+#define CBUS_PHY_1_sel_vref_ldo_mask                                  (0x00001800)
+#define CBUS_PHY_1_trim_ldo_cbus_mask                                 (0x00000780)
+#define CBUS_PHY_1_triming_mode_mask                                  (0x00000040)
+#define CBUS_PHY_1_en_cbus_mask                                       (0x00000020)
+#define CBUS_PHY_1_en_cmp_cbus_mask                                   (0x00000010)
+#define CBUS_PHY_1_en_driver_cbus_mask                                (0x00000008)
+#define CBUS_PHY_1_en_ldo_cbus_mask                                   (0x00000004)
+#define CBUS_PHY_1_psm_cbus_mask                                      (0x00000002)
+#define CBUS_PHY_1_sel_cbusb_gpio_mask                                (0x00000001)
+#define CBUS_PHY_1_adjr_1k(data)                                      (0xF0000000&((data)<<28))
+#define CBUS_PHY_1_adjr_100k(data)                                    (0x0F800000&((data)<<23))
+#define CBUS_PHY_1_auto_k_1k(data)                                    (0x00400000&((data)<<22))
+#define CBUS_PHY_1_auto_k_100k(data)                                  (0x00200000&((data)<<21))
+#define CBUS_PHY_1_en_res_cal_cbus(data)                              (0x00100000&((data)<<20))
+#define CBUS_PHY_1_sel_cbus0_input_high(data)                         (0x000C0000&((data)<<18))
+#define CBUS_PHY_1_sel_cbus0_input_low(data)                          (0x00030000&((data)<<16))
+#define CBUS_PHY_1_sel_cbus_0_driving(data)                           (0x0000E000&((data)<<13))
+#define CBUS_PHY_1_sel_vref_ldo(data)                                 (0x00001800&((data)<<11))
+#define CBUS_PHY_1_trim_ldo_cbus(data)                                (0x00000780&((data)<<7))
+#define CBUS_PHY_1_triming_mode(data)                                 (0x00000040&((data)<<6))
+#define CBUS_PHY_1_en_cbus(data)                                      (0x00000020&((data)<<5))
+#define CBUS_PHY_1_en_cmp_cbus(data)                                  (0x00000010&((data)<<4))
+#define CBUS_PHY_1_en_driver_cbus(data)                               (0x00000008&((data)<<3))
+#define CBUS_PHY_1_en_ldo_cbus(data)                                  (0x00000004&((data)<<2))
+#define CBUS_PHY_1_psm_cbus(data)                                     (0x00000002&((data)<<1))
+#define CBUS_PHY_1_sel_cbusb_gpio(data)                               (0x00000001&(data))
+#define CBUS_PHY_1_get_adjr_1k(data)                                  ((0xF0000000&(data))>>28)
+#define CBUS_PHY_1_get_adjr_100k(data)                                ((0x0F800000&(data))>>23)
+#define CBUS_PHY_1_get_auto_k_1k(data)                                ((0x00400000&(data))>>22)
+#define CBUS_PHY_1_get_auto_k_100k(data)                              ((0x00200000&(data))>>21)
+#define CBUS_PHY_1_get_en_res_cal_cbus(data)                          ((0x00100000&(data))>>20)
+#define CBUS_PHY_1_get_sel_cbus0_input_high(data)                     ((0x000C0000&(data))>>18)
+#define CBUS_PHY_1_get_sel_cbus0_input_low(data)                      ((0x00030000&(data))>>16)
+#define CBUS_PHY_1_get_sel_cbus_0_driving(data)                       ((0x0000E000&(data))>>13)
+#define CBUS_PHY_1_get_sel_vref_ldo(data)                             ((0x00001800&(data))>>11)
+#define CBUS_PHY_1_get_trim_ldo_cbus(data)                            ((0x00000780&(data))>>7)
+#define CBUS_PHY_1_get_triming_mode(data)                             ((0x00000040&(data))>>6)
+#define CBUS_PHY_1_get_en_cbus(data)                                  ((0x00000020&(data))>>5)
+#define CBUS_PHY_1_get_en_cmp_cbus(data)                              ((0x00000010&(data))>>4)
+#define CBUS_PHY_1_get_en_driver_cbus(data)                           ((0x00000008&(data))>>3)
+#define CBUS_PHY_1_get_en_ldo_cbus(data)                              ((0x00000004&(data))>>2)
+#define CBUS_PHY_1_get_psm_cbus(data)                                 ((0x00000002&(data))>>1)
+#define CBUS_PHY_1_get_sel_cbusb_gpio(data)                           (0x00000001&(data))
+
+
+#define CBUS_PHY_2                                                    0x18037438
+#define CBUS_PHY_2_reg_addr                                           "0xb8037438"
+#define CBUS_PHY_2_reg                                                0xb8037438
+#define CBUS_PHY_2_inst_addr                                          "0x010E"
+#define CBUS_PHY_2_inst                                               0x010E
+#define CBUS_PHY_2_cbus_o_shift                                       (0)
+#define CBUS_PHY_2_cbus_o_mask                                        (0x00000001)
+#define CBUS_PHY_2_cbus_o(data)                                       (0x00000001&(data))
+#define CBUS_PHY_2_get_cbus_o(data)                                   (0x00000001&(data))
+
+
+#define CBUS_PHY_3                                                    0x1803743c
+#define CBUS_PHY_3_reg_addr                                           "0xb803743c"
+#define CBUS_PHY_3_reg                                                0xb803743c
+#define CBUS_PHY_3_inst_addr                                          "0x010F"
+#define CBUS_PHY_3_inst                                               0x010F
+#define CBUS_PHY_3_sel_phy_soft_rst_n_shift                           (11)
+#define CBUS_PHY_3_cbus_res_tst_shift                                 (1)
+#define CBUS_PHY_3_res_ok_shift                                       (0)
+#define CBUS_PHY_3_sel_phy_soft_rst_n_mask                            (0x00000800)
+#define CBUS_PHY_3_cbus_res_tst_mask                                  (0x000007FE)
+#define CBUS_PHY_3_res_ok_mask                                        (0x00000001)
+#define CBUS_PHY_3_sel_phy_soft_rst_n(data)                           (0x00000800&((data)<<11))
+#define CBUS_PHY_3_cbus_res_tst(data)                                 (0x000007FE&((data)<<1))
+#define CBUS_PHY_3_res_ok(data)                                       (0x00000001&(data))
+#define CBUS_PHY_3_get_sel_phy_soft_rst_n(data)                       ((0x00000800&(data))>>11)
+#define CBUS_PHY_3_get_cbus_res_tst(data)                             ((0x000007FE&(data))>>1)
+#define CBUS_PHY_3_get_res_ok(data)                                   (0x00000001&(data))
+
+
+#define MSC_REG_00                                                    0x1800f000
+#define MSC_REG_00_reg_addr                                           "0xb800f000"
+#define MSC_REG_00_reg                                                0xb800f000
+#define MSC_REG_00_inst_addr                                          "0x0000"
+#define MSC_REG_00_inst                                               0x0000
+#define MSC_REG_00_dev_state_shift                                    (0)
+#define MSC_REG_00_dev_state_mask                                     (0x000000FF)
+#define MSC_REG_00_dev_state(data)                                    (0x000000FF&(data))
+#define MSC_REG_00_get_dev_state(data)                                (0x000000FF&(data))
+
+
+#define MSC_REG_01                                                    0x1800f004
+#define MSC_REG_01_reg_addr                                           "0xb800f004"
+#define MSC_REG_01_reg                                                0xb800f004
+#define MSC_REG_01_inst_addr                                          "0x0001"
+#define MSC_REG_01_inst                                               0x0001
+#define MSC_REG_01_mhl_ver_shift                                      (0)
+#define MSC_REG_01_mhl_ver_mask                                       (0x000000FF)
+#define MSC_REG_01_mhl_ver(data)                                      (0x000000FF&(data))
+#define MSC_REG_01_get_mhl_ver(data)                                  (0x000000FF&(data))
+
+
+#define MSC_REG_02                                                    0x1800f008
+#define MSC_REG_02_reg_addr                                           "0xb800f008"
+#define MSC_REG_02_reg                                                0xb800f008
+#define MSC_REG_02_inst_addr                                          "0x0002"
+#define MSC_REG_02_inst                                               0x0002
+#define MSC_REG_02_dev_cat_shift                                      (7)
+#define MSC_REG_02_plim_shift                                         (5)
+#define MSC_REG_02_pow_shift                                          (4)
+#define MSC_REG_02_dev_type_shift                                     (0)
+#define MSC_REG_02_dev_cat_mask                                       (0x00000080)
+#define MSC_REG_02_plim_mask                                          (0x00000060)
+#define MSC_REG_02_pow_mask                                           (0x00000010)
+#define MSC_REG_02_dev_type_mask                                      (0x0000000F)
+#define MSC_REG_02_dev_cat(data)                                      (0x00000080&((data)<<7))
+#define MSC_REG_02_plim(data)                                         (0x00000060&((data)<<5))
+#define MSC_REG_02_pow(data)                                          (0x00000010&((data)<<4))
+#define MSC_REG_02_dev_type(data)                                     (0x0000000F&(data))
+#define MSC_REG_02_get_dev_cat(data)                                  ((0x00000080&(data))>>7)
+#define MSC_REG_02_get_plim(data)                                     ((0x00000060&(data))>>5)
+#define MSC_REG_02_get_pow(data)                                      ((0x00000010&(data))>>4)
+#define MSC_REG_02_get_dev_type(data)                                 (0x0000000F&(data))
+
+
+#define MSC_REG_03                                                    0x1800f00c
+#define MSC_REG_03_reg_addr                                           "0xb800f00c"
+#define MSC_REG_03_reg                                                0xb800f00c
+#define MSC_REG_03_inst_addr                                          "0x0003"
+#define MSC_REG_03_inst                                               0x0003
+#define MSC_REG_03_adop_id_h_shift                                    (0)
+#define MSC_REG_03_adop_id_h_mask                                     (0x000000FF)
+#define MSC_REG_03_adop_id_h(data)                                    (0x000000FF&(data))
+#define MSC_REG_03_get_adop_id_h(data)                                (0x000000FF&(data))
+
+
+#define MSC_REG_04                                                    0x1800f010
+#define MSC_REG_04_reg_addr                                           "0xb800f010"
+#define MSC_REG_04_reg                                                0xb800f010
+#define MSC_REG_04_inst_addr                                          "0x0004"
+#define MSC_REG_04_inst                                               0x0004
+#define MSC_REG_04_adop_id_l_shift                                    (0)
+#define MSC_REG_04_adop_id_l_mask                                     (0x000000FF)
+#define MSC_REG_04_adop_id_l(data)                                    (0x000000FF&(data))
+#define MSC_REG_04_get_adop_id_l(data)                                (0x000000FF&(data))
+
+
+#define MSC_REG_05                                                    0x1800f014
+#define MSC_REG_05_reg_addr                                           "0xb800f014"
+#define MSC_REG_05_reg                                                0xb800f014
+#define MSC_REG_05_inst_addr                                          "0x0005"
+#define MSC_REG_05_inst                                               0x0005
+#define MSC_REG_05_vid_link_md_shift                                  (6)
+#define MSC_REG_05_supp_vga_shift                                     (5)
+#define MSC_REG_05_supp_islands_shift                                 (4)
+#define MSC_REG_05_supp_ppixel_shift                                  (3)
+#define MSC_REG_05_supp_yuv422_shift                                  (2)
+#define MSC_REG_05_supp_yuv444_shift                                  (1)
+#define MSC_REG_05_supp_rgb444_shift                                  (0)
+#define MSC_REG_05_vid_link_md_mask                                   (0x000000C0)
+#define MSC_REG_05_supp_vga_mask                                      (0x00000020)
+#define MSC_REG_05_supp_islands_mask                                  (0x00000010)
+#define MSC_REG_05_supp_ppixel_mask                                   (0x00000008)
+#define MSC_REG_05_supp_yuv422_mask                                   (0x00000004)
+#define MSC_REG_05_supp_yuv444_mask                                   (0x00000002)
+#define MSC_REG_05_supp_rgb444_mask                                   (0x00000001)
+#define MSC_REG_05_vid_link_md(data)                                  (0x000000C0&((data)<<6))
+#define MSC_REG_05_supp_vga(data)                                     (0x00000020&((data)<<5))
+#define MSC_REG_05_supp_islands(data)                                 (0x00000010&((data)<<4))
+#define MSC_REG_05_supp_ppixel(data)                                  (0x00000008&((data)<<3))
+#define MSC_REG_05_supp_yuv422(data)                                  (0x00000004&((data)<<2))
+#define MSC_REG_05_supp_yuv444(data)                                  (0x00000002&((data)<<1))
+#define MSC_REG_05_supp_rgb444(data)                                  (0x00000001&(data))
+#define MSC_REG_05_get_vid_link_md(data)                              ((0x000000C0&(data))>>6)
+#define MSC_REG_05_get_supp_vga(data)                                 ((0x00000020&(data))>>5)
+#define MSC_REG_05_get_supp_islands(data)                             ((0x00000010&(data))>>4)
+#define MSC_REG_05_get_supp_ppixel(data)                              ((0x00000008&(data))>>3)
+#define MSC_REG_05_get_supp_yuv422(data)                              ((0x00000004&(data))>>2)
+#define MSC_REG_05_get_supp_yuv444(data)                              ((0x00000002&(data))>>1)
+#define MSC_REG_05_get_supp_rgb444(data)                              (0x00000001&(data))
+
+
+#define MSC_REG_06                                                    0x1800f018
+#define MSC_REG_06_reg_addr                                           "0xb800f018"
+#define MSC_REG_06_reg                                                0xb800f018
+#define MSC_REG_06_inst_addr                                          "0x0006"
+#define MSC_REG_06_inst                                               0x0006
+#define MSC_REG_06_aud_link_md_shift                                  (2)
+#define MSC_REG_06_aud_8ch_shift                                      (1)
+#define MSC_REG_06_aud_2ch_shift                                      (0)
+#define MSC_REG_06_aud_link_md_mask                                   (0x000000FC)
+#define MSC_REG_06_aud_8ch_mask                                       (0x00000002)
+#define MSC_REG_06_aud_2ch_mask                                       (0x00000001)
+#define MSC_REG_06_aud_link_md(data)                                  (0x000000FC&((data)<<2))
+#define MSC_REG_06_aud_8ch(data)                                      (0x00000002&((data)<<1))
+#define MSC_REG_06_aud_2ch(data)                                      (0x00000001&(data))
+#define MSC_REG_06_get_aud_link_md(data)                              ((0x000000FC&(data))>>2)
+#define MSC_REG_06_get_aud_8ch(data)                                  ((0x00000002&(data))>>1)
+#define MSC_REG_06_get_aud_2ch(data)                                  (0x00000001&(data))
+
+
+#define MSC_REG_07                                                    0x1800f01c
+#define MSC_REG_07_reg_addr                                           "0xb800f01c"
+#define MSC_REG_07_reg                                                0xb800f01c
+#define MSC_REG_07_inst_addr                                          "0x0007"
+#define MSC_REG_07_inst                                               0x0007
+#define MSC_REG_07_supp_vt_shift                                      (7)
+#define MSC_REG_07_video_type_shift                                   (4)
+#define MSC_REG_07_vt_game_shift                                      (3)
+#define MSC_REG_07_vt_cinema_shift                                    (2)
+#define MSC_REG_07_vt_photo_shift                                     (1)
+#define MSC_REG_07_vt_graphics_shift                                  (0)
+#define MSC_REG_07_supp_vt_mask                                       (0x00000080)
+#define MSC_REG_07_video_type_mask                                    (0x00000070)
+#define MSC_REG_07_vt_game_mask                                       (0x00000008)
+#define MSC_REG_07_vt_cinema_mask                                     (0x00000004)
+#define MSC_REG_07_vt_photo_mask                                      (0x00000002)
+#define MSC_REG_07_vt_graphics_mask                                   (0x00000001)
+#define MSC_REG_07_supp_vt(data)                                      (0x00000080&((data)<<7))
+#define MSC_REG_07_video_type(data)                                   (0x00000070&((data)<<4))
+#define MSC_REG_07_vt_game(data)                                      (0x00000008&((data)<<3))
+#define MSC_REG_07_vt_cinema(data)                                    (0x00000004&((data)<<2))
+#define MSC_REG_07_vt_photo(data)                                     (0x00000002&((data)<<1))
+#define MSC_REG_07_vt_graphics(data)                                  (0x00000001&(data))
+#define MSC_REG_07_get_supp_vt(data)                                  ((0x00000080&(data))>>7)
+#define MSC_REG_07_get_video_type(data)                               ((0x00000070&(data))>>4)
+#define MSC_REG_07_get_vt_game(data)                                  ((0x00000008&(data))>>3)
+#define MSC_REG_07_get_vt_cinema(data)                                ((0x00000004&(data))>>2)
+#define MSC_REG_07_get_vt_photo(data)                                 ((0x00000002&(data))>>1)
+#define MSC_REG_07_get_vt_graphics(data)                              (0x00000001&(data))
+
+
+#define MSC_REG_08                                                    0x1800f020
+#define MSC_REG_08_reg_addr                                           "0xb800f020"
+#define MSC_REG_08_reg                                                0xb800f020
+#define MSC_REG_08_inst_addr                                          "0x0008"
+#define MSC_REG_08_inst                                               0x0008
+#define MSC_REG_08_ld_gui_shift                                       (7)
+#define MSC_REG_08_ld_speaker_shift                                   (6)
+#define MSC_REG_08_ld_record_shift                                    (5)
+#define MSC_REG_08_ld_tuner_shift                                     (4)
+#define MSC_REG_08_ld_media_shift                                     (3)
+#define MSC_REG_08_ld_audio_shift                                     (2)
+#define MSC_REG_08_ld_video_shift                                     (1)
+#define MSC_REG_08_ld_display_shift                                   (0)
+#define MSC_REG_08_ld_gui_mask                                        (0x00000080)
+#define MSC_REG_08_ld_speaker_mask                                    (0x00000040)
+#define MSC_REG_08_ld_record_mask                                     (0x00000020)
+#define MSC_REG_08_ld_tuner_mask                                      (0x00000010)
+#define MSC_REG_08_ld_media_mask                                      (0x00000008)
+#define MSC_REG_08_ld_audio_mask                                      (0x00000004)
+#define MSC_REG_08_ld_video_mask                                      (0x00000002)
+#define MSC_REG_08_ld_display_mask                                    (0x00000001)
+#define MSC_REG_08_ld_gui(data)                                       (0x00000080&((data)<<7))
+#define MSC_REG_08_ld_speaker(data)                                   (0x00000040&((data)<<6))
+#define MSC_REG_08_ld_record(data)                                    (0x00000020&((data)<<5))
+#define MSC_REG_08_ld_tuner(data)                                     (0x00000010&((data)<<4))
+#define MSC_REG_08_ld_media(data)                                     (0x00000008&((data)<<3))
+#define MSC_REG_08_ld_audio(data)                                     (0x00000004&((data)<<2))
+#define MSC_REG_08_ld_video(data)                                     (0x00000002&((data)<<1))
+#define MSC_REG_08_ld_display(data)                                   (0x00000001&(data))
+#define MSC_REG_08_get_ld_gui(data)                                   ((0x00000080&(data))>>7)
+#define MSC_REG_08_get_ld_speaker(data)                               ((0x00000040&(data))>>6)
+#define MSC_REG_08_get_ld_record(data)                                ((0x00000020&(data))>>5)
+#define MSC_REG_08_get_ld_tuner(data)                                 ((0x00000010&(data))>>4)
+#define MSC_REG_08_get_ld_media(data)                                 ((0x00000008&(data))>>3)
+#define MSC_REG_08_get_ld_audio(data)                                 ((0x00000004&(data))>>2)
+#define MSC_REG_08_get_ld_video(data)                                 ((0x00000002&(data))>>1)
+#define MSC_REG_08_get_ld_display(data)                               (0x00000001&(data))
+
+
+#define MSC_REG_09                                                    0x1800f024
+#define MSC_REG_09_reg_addr                                           "0xb800f024"
+#define MSC_REG_09_reg                                                0xb800f024
+#define MSC_REG_09_inst_addr                                          "0x0009"
+#define MSC_REG_09_inst                                               0x0009
+#define MSC_REG_09_bandwid_shift                                      (0)
+#define MSC_REG_09_bandwid_mask                                       (0x000000FF)
+#define MSC_REG_09_bandwid(data)                                      (0x000000FF&(data))
+#define MSC_REG_09_get_bandwid(data)                                  (0x000000FF&(data))
+
+
+#define MSC_REG_0A                                                    0x1800f028
+#define MSC_REG_0A_reg_addr                                           "0xb800f028"
+#define MSC_REG_0A_reg                                                0xb800f028
+#define MSC_REG_0A_inst_addr                                          "0x000A"
+#define MSC_REG_0A_inst                                               0x000A
+#define MSC_REG_0A_feature_flag_shift                                 (5)
+#define MSC_REG_0A_ucp_recv_supp_shift                                (4)
+#define MSC_REG_0A_ucp_send_supp_shift                                (3)
+#define MSC_REG_0A_sp_supp_shift                                      (2)
+#define MSC_REG_0A_rap_supp_shift                                     (1)
+#define MSC_REG_0A_rcp_supp_shift                                     (0)
+#define MSC_REG_0A_feature_flag_mask                                  (0x000000E0)
+#define MSC_REG_0A_ucp_recv_supp_mask                                 (0x00000010)
+#define MSC_REG_0A_ucp_send_supp_mask                                 (0x00000008)
+#define MSC_REG_0A_sp_supp_mask                                       (0x00000004)
+#define MSC_REG_0A_rap_supp_mask                                      (0x00000002)
+#define MSC_REG_0A_rcp_supp_mask                                      (0x00000001)
+#define MSC_REG_0A_feature_flag(data)                                 (0x000000E0&((data)<<5))
+#define MSC_REG_0A_ucp_recv_supp(data)                                (0x00000010&((data)<<4))
+#define MSC_REG_0A_ucp_send_supp(data)                                (0x00000008&((data)<<3))
+#define MSC_REG_0A_sp_supp(data)                                      (0x00000004&((data)<<2))
+#define MSC_REG_0A_rap_supp(data)                                     (0x00000002&((data)<<1))
+#define MSC_REG_0A_rcp_supp(data)                                     (0x00000001&(data))
+#define MSC_REG_0A_get_feature_flag(data)                             ((0x000000E0&(data))>>5)
+#define MSC_REG_0A_get_ucp_recv_supp(data)                            ((0x00000010&(data))>>4)
+#define MSC_REG_0A_get_ucp_send_supp(data)                            ((0x00000008&(data))>>3)
+#define MSC_REG_0A_get_sp_supp(data)                                  ((0x00000004&(data))>>2)
+#define MSC_REG_0A_get_rap_supp(data)                                 ((0x00000002&(data))>>1)
+#define MSC_REG_0A_get_rcp_supp(data)                                 (0x00000001&(data))
+
+
+#define MSC_REG_0B                                                    0x1800f02c
+#define MSC_REG_0B_reg_addr                                           "0xb800f02c"
+#define MSC_REG_0B_reg                                                0xb800f02c
+#define MSC_REG_0B_inst_addr                                          "0x000B"
+#define MSC_REG_0B_inst                                               0x000B
+#define MSC_REG_0B_device_id_h_shift                                  (0)
+#define MSC_REG_0B_device_id_h_mask                                   (0x000000FF)
+#define MSC_REG_0B_device_id_h(data)                                  (0x000000FF&(data))
+#define MSC_REG_0B_get_device_id_h(data)                              (0x000000FF&(data))
+
+
+#define MSC_REG_0C                                                    0x1800f030
+#define MSC_REG_0C_reg_addr                                           "0xb800f030"
+#define MSC_REG_0C_reg                                                0xb800f030
+#define MSC_REG_0C_inst_addr                                          "0x000C"
+#define MSC_REG_0C_inst                                               0x000C
+#define MSC_REG_0C_device_id_l_shift                                  (0)
+#define MSC_REG_0C_device_id_l_mask                                   (0x000000FF)
+#define MSC_REG_0C_device_id_l(data)                                  (0x000000FF&(data))
+#define MSC_REG_0C_get_device_id_l(data)                              (0x000000FF&(data))
+
+
+#define MSC_REG_0D                                                    0x1800f034
+#define MSC_REG_0D_reg_addr                                           "0xb800f034"
+#define MSC_REG_0D_reg                                                0xb800f034
+#define MSC_REG_0D_inst_addr                                          "0x000D"
+#define MSC_REG_0D_inst                                               0x000D
+#define MSC_REG_0D_scr_size_shift                                     (0)
+#define MSC_REG_0D_scr_size_mask                                      (0x000000FF)
+#define MSC_REG_0D_scr_size(data)                                     (0x000000FF&(data))
+#define MSC_REG_0D_get_scr_size(data)                                 (0x000000FF&(data))
+
+
+#define MSC_REG_0E                                                    0x1800f038
+#define MSC_REG_0E_reg_addr                                           "0xb800f038"
+#define MSC_REG_0E_reg                                                0xb800f038
+#define MSC_REG_0E_inst_addr                                          "0x000E"
+#define MSC_REG_0E_inst                                               0x000E
+#define MSC_REG_0E_stat_size_shift                                    (4)
+#define MSC_REG_0E_int_size_shift                                     (0)
+#define MSC_REG_0E_stat_size_mask                                     (0x000000F0)
+#define MSC_REG_0E_int_size_mask                                      (0x0000000F)
+#define MSC_REG_0E_stat_size(data)                                    (0x000000F0&((data)<<4))
+#define MSC_REG_0E_int_size(data)                                     (0x0000000F&(data))
+#define MSC_REG_0E_get_stat_size(data)                                ((0x000000F0&(data))>>4)
+#define MSC_REG_0E_get_int_size(data)                                 (0x0000000F&(data))
+
+
+#define MSC_REG_0F                                                    0x1800f03c
+#define MSC_REG_0F_reg_addr                                           "0xb800f03c"
+#define MSC_REG_0F_reg                                                0xb800f03c
+#define MSC_REG_0F_inst_addr                                          "0x000F"
+#define MSC_REG_0F_inst                                               0x000F
+#define MSC_REG_0F_cap_0f_shift                                       (0)
+#define MSC_REG_0F_cap_0f_mask                                        (0x000000FF)
+#define MSC_REG_0F_cap_0f(data)                                       (0x000000FF&(data))
+#define MSC_REG_0F_get_cap_0f(data)                                   (0x000000FF&(data))
+
+
+#define MSC_REG_20                                                    0x1800f080
+#define MSC_REG_20_reg_addr                                           "0xb800f080"
+#define MSC_REG_20_reg                                                0xb800f080
+#define MSC_REG_20_inst_addr                                          "0x0020"
+#define MSC_REG_20_inst                                               0x0020
+#define MSC_REG_20_rchg_int_7_shift                                   (7)
+#define MSC_REG_20_rchg_int_6_shift                                   (6)
+#define MSC_REG_20_rchg_int_5_shift                                   (5)
+#define MSC_REG_20_cbus_3d_req_shift                                  (4)
+#define MSC_REG_20_grt_wrt_shift                                      (3)
+#define MSC_REG_20_req_wrt_shift                                      (2)
+#define MSC_REG_20_dscr_chg_shift                                     (1)
+#define MSC_REG_20_dcap_chg_shift                                     (0)
+#define MSC_REG_20_rchg_int_7_mask                                    (0x00000080)
+#define MSC_REG_20_rchg_int_6_mask                                    (0x00000040)
+#define MSC_REG_20_rchg_int_5_mask                                    (0x00000020)
+#define MSC_REG_20_cbus_3d_req_mask                                   (0x00000010)
+#define MSC_REG_20_grt_wrt_mask                                       (0x00000008)
+#define MSC_REG_20_req_wrt_mask                                       (0x00000004)
+#define MSC_REG_20_dscr_chg_mask                                      (0x00000002)
+#define MSC_REG_20_dcap_chg_mask                                      (0x00000001)
+#define MSC_REG_20_rchg_int_7(data)                                   (0x00000080&((data)<<7))
+#define MSC_REG_20_rchg_int_6(data)                                   (0x00000040&((data)<<6))
+#define MSC_REG_20_rchg_int_5(data)                                   (0x00000020&((data)<<5))
+#define MSC_REG_20_cbus_3d_req(data)                                  (0x00000010&((data)<<4))
+#define MSC_REG_20_grt_wrt(data)                                      (0x00000008&((data)<<3))
+#define MSC_REG_20_req_wrt(data)                                      (0x00000004&((data)<<2))
+#define MSC_REG_20_dscr_chg(data)                                     (0x00000002&((data)<<1))
+#define MSC_REG_20_dcap_chg(data)                                     (0x00000001&(data))
+#define MSC_REG_20_get_rchg_int_7(data)                               ((0x00000080&(data))>>7)
+#define MSC_REG_20_get_rchg_int_6(data)                               ((0x00000040&(data))>>6)
+#define MSC_REG_20_get_rchg_int_5(data)                               ((0x00000020&(data))>>5)
+#define MSC_REG_20_get_cbus_3d_req(data)                              ((0x00000010&(data))>>4)
+#define MSC_REG_20_get_grt_wrt(data)                                  ((0x00000008&(data))>>3)
+#define MSC_REG_20_get_req_wrt(data)                                  ((0x00000004&(data))>>2)
+#define MSC_REG_20_get_dscr_chg(data)                                 ((0x00000002&(data))>>1)
+#define MSC_REG_20_get_dcap_chg(data)                                 (0x00000001&(data))
+
+
+#define MSC_REG_21                                                    0x1800f084
+#define MSC_REG_21_reg_addr                                           "0xb800f084"
+#define MSC_REG_21_reg                                                0xb800f084
+#define MSC_REG_21_inst_addr                                          "0x0021"
+#define MSC_REG_21_inst                                               0x0021
+#define MSC_REG_21_dchg_int_7_shift                                   (7)
+#define MSC_REG_21_dchg_int_6_shift                                   (6)
+#define MSC_REG_21_dchg_int_5_shift                                   (5)
+#define MSC_REG_21_dchg_int_4_shift                                   (4)
+#define MSC_REG_21_dchg_int_3_shift                                   (3)
+#define MSC_REG_21_dchg_int_2_shift                                   (2)
+#define MSC_REG_21_edid_chg_shift                                     (1)
+#define MSC_REG_21_dchg_int_0_shift                                   (0)
+#define MSC_REG_21_dchg_int_7_mask                                    (0x00000080)
+#define MSC_REG_21_dchg_int_6_mask                                    (0x00000040)
+#define MSC_REG_21_dchg_int_5_mask                                    (0x00000020)
+#define MSC_REG_21_dchg_int_4_mask                                    (0x00000010)
+#define MSC_REG_21_dchg_int_3_mask                                    (0x00000008)
+#define MSC_REG_21_dchg_int_2_mask                                    (0x00000004)
+#define MSC_REG_21_edid_chg_mask                                      (0x00000002)
+#define MSC_REG_21_dchg_int_0_mask                                    (0x00000001)
+#define MSC_REG_21_dchg_int_7(data)                                   (0x00000080&((data)<<7))
+#define MSC_REG_21_dchg_int_6(data)                                   (0x00000040&((data)<<6))
+#define MSC_REG_21_dchg_int_5(data)                                   (0x00000020&((data)<<5))
+#define MSC_REG_21_dchg_int_4(data)                                   (0x00000010&((data)<<4))
+#define MSC_REG_21_dchg_int_3(data)                                   (0x00000008&((data)<<3))
+#define MSC_REG_21_dchg_int_2(data)                                   (0x00000004&((data)<<2))
+#define MSC_REG_21_edid_chg(data)                                     (0x00000002&((data)<<1))
+#define MSC_REG_21_dchg_int_0(data)                                   (0x00000001&(data))
+#define MSC_REG_21_get_dchg_int_7(data)                               ((0x00000080&(data))>>7)
+#define MSC_REG_21_get_dchg_int_6(data)                               ((0x00000040&(data))>>6)
+#define MSC_REG_21_get_dchg_int_5(data)                               ((0x00000020&(data))>>5)
+#define MSC_REG_21_get_dchg_int_4(data)                               ((0x00000010&(data))>>4)
+#define MSC_REG_21_get_dchg_int_3(data)                               ((0x00000008&(data))>>3)
+#define MSC_REG_21_get_dchg_int_2(data)                               ((0x00000004&(data))>>2)
+#define MSC_REG_21_get_edid_chg(data)                                 ((0x00000002&(data))>>1)
+#define MSC_REG_21_get_dchg_int_0(data)                               (0x00000001&(data))
+
+
+#define MSC_REG_22                                                    0x1800f088
+#define MSC_REG_22_reg_addr                                           "0xb800f088"
+#define MSC_REG_22_reg                                                0xb800f088
+#define MSC_REG_22_inst_addr                                          "0x0022"
+#define MSC_REG_22_inst                                               0x0022
+#define MSC_REG_22_chg22_7_shift                                      (7)
+#define MSC_REG_22_chg22_6_shift                                      (6)
+#define MSC_REG_22_chg22_5_shift                                      (5)
+#define MSC_REG_22_chg22_4_shift                                      (4)
+#define MSC_REG_22_chg22_3_shift                                      (3)
+#define MSC_REG_22_chg22_2_shift                                      (2)
+#define MSC_REG_22_chg22_1_shift                                      (1)
+#define MSC_REG_22_chg22_0_shift                                      (0)
+#define MSC_REG_22_chg22_7_mask                                       (0x00000080)
+#define MSC_REG_22_chg22_6_mask                                       (0x00000040)
+#define MSC_REG_22_chg22_5_mask                                       (0x00000020)
+#define MSC_REG_22_chg22_4_mask                                       (0x00000010)
+#define MSC_REG_22_chg22_3_mask                                       (0x00000008)
+#define MSC_REG_22_chg22_2_mask                                       (0x00000004)
+#define MSC_REG_22_chg22_1_mask                                       (0x00000002)
+#define MSC_REG_22_chg22_0_mask                                       (0x00000001)
+#define MSC_REG_22_chg22_7(data)                                      (0x00000080&((data)<<7))
+#define MSC_REG_22_chg22_6(data)                                      (0x00000040&((data)<<6))
+#define MSC_REG_22_chg22_5(data)                                      (0x00000020&((data)<<5))
+#define MSC_REG_22_chg22_4(data)                                      (0x00000010&((data)<<4))
+#define MSC_REG_22_chg22_3(data)                                      (0x00000008&((data)<<3))
+#define MSC_REG_22_chg22_2(data)                                      (0x00000004&((data)<<2))
+#define MSC_REG_22_chg22_1(data)                                      (0x00000002&((data)<<1))
+#define MSC_REG_22_chg22_0(data)                                      (0x00000001&(data))
+#define MSC_REG_22_get_chg22_7(data)                                  ((0x00000080&(data))>>7)
+#define MSC_REG_22_get_chg22_6(data)                                  ((0x00000040&(data))>>6)
+#define MSC_REG_22_get_chg22_5(data)                                  ((0x00000020&(data))>>5)
+#define MSC_REG_22_get_chg22_4(data)                                  ((0x00000010&(data))>>4)
+#define MSC_REG_22_get_chg22_3(data)                                  ((0x00000008&(data))>>3)
+#define MSC_REG_22_get_chg22_2(data)                                  ((0x00000004&(data))>>2)
+#define MSC_REG_22_get_chg22_1(data)                                  ((0x00000002&(data))>>1)
+#define MSC_REG_22_get_chg22_0(data)                                  (0x00000001&(data))
+
+
+#define MSC_REG_23                                                    0x1800f08c
+#define MSC_REG_23_reg_addr                                           "0xb800f08c"
+#define MSC_REG_23_reg                                                0xb800f08c
+#define MSC_REG_23_inst_addr                                          "0x0023"
+#define MSC_REG_23_inst                                               0x0023
+#define MSC_REG_23_chg23_7_shift                                      (7)
+#define MSC_REG_23_chg23_6_shift                                      (6)
+#define MSC_REG_23_chg23_5_shift                                      (5)
+#define MSC_REG_23_chg23_4_shift                                      (4)
+#define MSC_REG_23_chg23_3_shift                                      (3)
+#define MSC_REG_23_chg23_2_shift                                      (2)
+#define MSC_REG_23_chg23_1_shift                                      (1)
+#define MSC_REG_23_chg23_0_shift                                      (0)
+#define MSC_REG_23_chg23_7_mask                                       (0x00000080)
+#define MSC_REG_23_chg23_6_mask                                       (0x00000040)
+#define MSC_REG_23_chg23_5_mask                                       (0x00000020)
+#define MSC_REG_23_chg23_4_mask                                       (0x00000010)
+#define MSC_REG_23_chg23_3_mask                                       (0x00000008)
+#define MSC_REG_23_chg23_2_mask                                       (0x00000004)
+#define MSC_REG_23_chg23_1_mask                                       (0x00000002)
+#define MSC_REG_23_chg23_0_mask                                       (0x00000001)
+#define MSC_REG_23_chg23_7(data)                                      (0x00000080&((data)<<7))
+#define MSC_REG_23_chg23_6(data)                                      (0x00000040&((data)<<6))
+#define MSC_REG_23_chg23_5(data)                                      (0x00000020&((data)<<5))
+#define MSC_REG_23_chg23_4(data)                                      (0x00000010&((data)<<4))
+#define MSC_REG_23_chg23_3(data)                                      (0x00000008&((data)<<3))
+#define MSC_REG_23_chg23_2(data)                                      (0x00000004&((data)<<2))
+#define MSC_REG_23_chg23_1(data)                                      (0x00000002&((data)<<1))
+#define MSC_REG_23_chg23_0(data)                                      (0x00000001&(data))
+#define MSC_REG_23_get_chg23_7(data)                                  ((0x00000080&(data))>>7)
+#define MSC_REG_23_get_chg23_6(data)                                  ((0x00000040&(data))>>6)
+#define MSC_REG_23_get_chg23_5(data)                                  ((0x00000020&(data))>>5)
+#define MSC_REG_23_get_chg23_4(data)                                  ((0x00000010&(data))>>4)
+#define MSC_REG_23_get_chg23_3(data)                                  ((0x00000008&(data))>>3)
+#define MSC_REG_23_get_chg23_2(data)                                  ((0x00000004&(data))>>2)
+#define MSC_REG_23_get_chg23_1(data)                                  ((0x00000002&(data))>>1)
+#define MSC_REG_23_get_chg23_0(data)                                  (0x00000001&(data))
+
+
+#define MSC_REG_24                                                    0x1800f090
+#define MSC_REG_24_reg_addr                                           "0xb800f090"
+#define MSC_REG_24_reg                                                0xb800f090
+#define MSC_REG_24_inst_addr                                          "0x0024"
+#define MSC_REG_24_inst                                               0x0024
+#define MSC_REG_24_chg24_7_shift                                      (7)
+#define MSC_REG_24_chg24_6_shift                                      (6)
+#define MSC_REG_24_chg24_5_shift                                      (5)
+#define MSC_REG_24_chg24_4_shift                                      (4)
+#define MSC_REG_24_chg24_3_shift                                      (3)
+#define MSC_REG_24_chg24_2_shift                                      (2)
+#define MSC_REG_24_chg24_1_shift                                      (1)
+#define MSC_REG_24_chg24_0_shift                                      (0)
+#define MSC_REG_24_chg24_7_mask                                       (0x00000080)
+#define MSC_REG_24_chg24_6_mask                                       (0x00000040)
+#define MSC_REG_24_chg24_5_mask                                       (0x00000020)
+#define MSC_REG_24_chg24_4_mask                                       (0x00000010)
+#define MSC_REG_24_chg24_3_mask                                       (0x00000008)
+#define MSC_REG_24_chg24_2_mask                                       (0x00000004)
+#define MSC_REG_24_chg24_1_mask                                       (0x00000002)
+#define MSC_REG_24_chg24_0_mask                                       (0x00000001)
+#define MSC_REG_24_chg24_7(data)                                      (0x00000080&((data)<<7))
+#define MSC_REG_24_chg24_6(data)                                      (0x00000040&((data)<<6))
+#define MSC_REG_24_chg24_5(data)                                      (0x00000020&((data)<<5))
+#define MSC_REG_24_chg24_4(data)                                      (0x00000010&((data)<<4))
+#define MSC_REG_24_chg24_3(data)                                      (0x00000008&((data)<<3))
+#define MSC_REG_24_chg24_2(data)                                      (0x00000004&((data)<<2))
+#define MSC_REG_24_chg24_1(data)                                      (0x00000002&((data)<<1))
+#define MSC_REG_24_chg24_0(data)                                      (0x00000001&(data))
+#define MSC_REG_24_get_chg24_7(data)                                  ((0x00000080&(data))>>7)
+#define MSC_REG_24_get_chg24_6(data)                                  ((0x00000040&(data))>>6)
+#define MSC_REG_24_get_chg24_5(data)                                  ((0x00000020&(data))>>5)
+#define MSC_REG_24_get_chg24_4(data)                                  ((0x00000010&(data))>>4)
+#define MSC_REG_24_get_chg24_3(data)                                  ((0x00000008&(data))>>3)
+#define MSC_REG_24_get_chg24_2(data)                                  ((0x00000004&(data))>>2)
+#define MSC_REG_24_get_chg24_1(data)                                  ((0x00000002&(data))>>1)
+#define MSC_REG_24_get_chg24_0(data)                                  (0x00000001&(data))
+
+
+#define MSC_REG_25                                                    0x1800f094
+#define MSC_REG_25_reg_addr                                           "0xb800f094"
+#define MSC_REG_25_reg                                                0xb800f094
+#define MSC_REG_25_inst_addr                                          "0x0025"
+#define MSC_REG_25_inst                                               0x0025
+#define MSC_REG_25_chg25_7_shift                                      (7)
+#define MSC_REG_25_chg25_6_shift                                      (6)
+#define MSC_REG_25_chg25_5_shift                                      (5)
+#define MSC_REG_25_chg25_4_shift                                      (4)
+#define MSC_REG_25_chg25_3_shift                                      (3)
+#define MSC_REG_25_chg25_2_shift                                      (2)
+#define MSC_REG_25_chg25_1_shift                                      (1)
+#define MSC_REG_25_chg25_0_shift                                      (0)
+#define MSC_REG_25_chg25_7_mask                                       (0x00000080)
+#define MSC_REG_25_chg25_6_mask                                       (0x00000040)
+#define MSC_REG_25_chg25_5_mask                                       (0x00000020)
+#define MSC_REG_25_chg25_4_mask                                       (0x00000010)
+#define MSC_REG_25_chg25_3_mask                                       (0x00000008)
+#define MSC_REG_25_chg25_2_mask                                       (0x00000004)
+#define MSC_REG_25_chg25_1_mask                                       (0x00000002)
+#define MSC_REG_25_chg25_0_mask                                       (0x00000001)
+#define MSC_REG_25_chg25_7(data)                                      (0x00000080&((data)<<7))
+#define MSC_REG_25_chg25_6(data)                                      (0x00000040&((data)<<6))
+#define MSC_REG_25_chg25_5(data)                                      (0x00000020&((data)<<5))
+#define MSC_REG_25_chg25_4(data)                                      (0x00000010&((data)<<4))
+#define MSC_REG_25_chg25_3(data)                                      (0x00000008&((data)<<3))
+#define MSC_REG_25_chg25_2(data)                                      (0x00000004&((data)<<2))
+#define MSC_REG_25_chg25_1(data)                                      (0x00000002&((data)<<1))
+#define MSC_REG_25_chg25_0(data)                                      (0x00000001&(data))
+#define MSC_REG_25_get_chg25_7(data)                                  ((0x00000080&(data))>>7)
+#define MSC_REG_25_get_chg25_6(data)                                  ((0x00000040&(data))>>6)
+#define MSC_REG_25_get_chg25_5(data)                                  ((0x00000020&(data))>>5)
+#define MSC_REG_25_get_chg25_4(data)                                  ((0x00000010&(data))>>4)
+#define MSC_REG_25_get_chg25_3(data)                                  ((0x00000008&(data))>>3)
+#define MSC_REG_25_get_chg25_2(data)                                  ((0x00000004&(data))>>2)
+#define MSC_REG_25_get_chg25_1(data)                                  ((0x00000002&(data))>>1)
+#define MSC_REG_25_get_chg25_0(data)                                  (0x00000001&(data))
+
+
+#define MSC_REG_26                                                    0x1800f098
+#define MSC_REG_26_reg_addr                                           "0xb800f098"
+#define MSC_REG_26_reg                                                0xb800f098
+#define MSC_REG_26_inst_addr                                          "0x0026"
+#define MSC_REG_26_inst                                               0x0026
+#define MSC_REG_26_chg26_7_shift                                      (7)
+#define MSC_REG_26_chg26_6_shift                                      (6)
+#define MSC_REG_26_chg26_5_shift                                      (5)
+#define MSC_REG_26_chg26_4_shift                                      (4)
+#define MSC_REG_26_chg26_3_shift                                      (3)
+#define MSC_REG_26_chg26_2_shift                                      (2)
+#define MSC_REG_26_chg26_1_shift                                      (1)
+#define MSC_REG_26_chg26_0_shift                                      (0)
+#define MSC_REG_26_chg26_7_mask                                       (0x00000080)
+#define MSC_REG_26_chg26_6_mask                                       (0x00000040)
+#define MSC_REG_26_chg26_5_mask                                       (0x00000020)
+#define MSC_REG_26_chg26_4_mask                                       (0x00000010)
+#define MSC_REG_26_chg26_3_mask                                       (0x00000008)
+#define MSC_REG_26_chg26_2_mask                                       (0x00000004)
+#define MSC_REG_26_chg26_1_mask                                       (0x00000002)
+#define MSC_REG_26_chg26_0_mask                                       (0x00000001)
+#define MSC_REG_26_chg26_7(data)                                      (0x00000080&((data)<<7))
+#define MSC_REG_26_chg26_6(data)                                      (0x00000040&((data)<<6))
+#define MSC_REG_26_chg26_5(data)                                      (0x00000020&((data)<<5))
+#define MSC_REG_26_chg26_4(data)                                      (0x00000010&((data)<<4))
+#define MSC_REG_26_chg26_3(data)                                      (0x00000008&((data)<<3))
+#define MSC_REG_26_chg26_2(data)                                      (0x00000004&((data)<<2))
+#define MSC_REG_26_chg26_1(data)                                      (0x00000002&((data)<<1))
+#define MSC_REG_26_chg26_0(data)                                      (0x00000001&(data))
+#define MSC_REG_26_get_chg26_7(data)                                  ((0x00000080&(data))>>7)
+#define MSC_REG_26_get_chg26_6(data)                                  ((0x00000040&(data))>>6)
+#define MSC_REG_26_get_chg26_5(data)                                  ((0x00000020&(data))>>5)
+#define MSC_REG_26_get_chg26_4(data)                                  ((0x00000010&(data))>>4)
+#define MSC_REG_26_get_chg26_3(data)                                  ((0x00000008&(data))>>3)
+#define MSC_REG_26_get_chg26_2(data)                                  ((0x00000004&(data))>>2)
+#define MSC_REG_26_get_chg26_1(data)                                  ((0x00000002&(data))>>1)
+#define MSC_REG_26_get_chg26_0(data)                                  (0x00000001&(data))
+
+
+#define MSC_REG_27                                                    0x1800f09c
+#define MSC_REG_27_reg_addr                                           "0xb800f09c"
+#define MSC_REG_27_reg                                                0xb800f09c
+#define MSC_REG_27_inst_addr                                          "0x0027"
+#define MSC_REG_27_inst                                               0x0027
+#define MSC_REG_27_chg27_7_shift                                      (7)
+#define MSC_REG_27_chg27_6_shift                                      (6)
+#define MSC_REG_27_chg27_5_shift                                      (5)
+#define MSC_REG_27_chg27_4_shift                                      (4)
+#define MSC_REG_27_chg27_3_shift                                      (3)
+#define MSC_REG_27_chg27_2_shift                                      (2)
+#define MSC_REG_27_chg27_1_shift                                      (1)
+#define MSC_REG_27_chg27_0_shift                                      (0)
+#define MSC_REG_27_chg27_7_mask                                       (0x00000080)
+#define MSC_REG_27_chg27_6_mask                                       (0x00000040)
+#define MSC_REG_27_chg27_5_mask                                       (0x00000020)
+#define MSC_REG_27_chg27_4_mask                                       (0x00000010)
+#define MSC_REG_27_chg27_3_mask                                       (0x00000008)
+#define MSC_REG_27_chg27_2_mask                                       (0x00000004)
+#define MSC_REG_27_chg27_1_mask                                       (0x00000002)
+#define MSC_REG_27_chg27_0_mask                                       (0x00000001)
+#define MSC_REG_27_chg27_7(data)                                      (0x00000080&((data)<<7))
+#define MSC_REG_27_chg27_6(data)                                      (0x00000040&((data)<<6))
+#define MSC_REG_27_chg27_5(data)                                      (0x00000020&((data)<<5))
+#define MSC_REG_27_chg27_4(data)                                      (0x00000010&((data)<<4))
+#define MSC_REG_27_chg27_3(data)                                      (0x00000008&((data)<<3))
+#define MSC_REG_27_chg27_2(data)                                      (0x00000004&((data)<<2))
+#define MSC_REG_27_chg27_1(data)                                      (0x00000002&((data)<<1))
+#define MSC_REG_27_chg27_0(data)                                      (0x00000001&(data))
+#define MSC_REG_27_get_chg27_7(data)                                  ((0x00000080&(data))>>7)
+#define MSC_REG_27_get_chg27_6(data)                                  ((0x00000040&(data))>>6)
+#define MSC_REG_27_get_chg27_5(data)                                  ((0x00000020&(data))>>5)
+#define MSC_REG_27_get_chg27_4(data)                                  ((0x00000010&(data))>>4)
+#define MSC_REG_27_get_chg27_3(data)                                  ((0x00000008&(data))>>3)
+#define MSC_REG_27_get_chg27_2(data)                                  ((0x00000004&(data))>>2)
+#define MSC_REG_27_get_chg27_1(data)                                  ((0x00000002&(data))>>1)
+#define MSC_REG_27_get_chg27_0(data)                                  (0x00000001&(data))
+
+
+#define MSC_REG_30                                                    0x1800f0c0
+#define MSC_REG_30_reg_addr                                           "0xb800f0c0"
+#define MSC_REG_30_reg                                                0xb800f0c0
+#define MSC_REG_30_inst_addr                                          "0x0030"
+#define MSC_REG_30_inst                                               0x0030
+#define MSC_REG_30_conn_rdy_shift                                     (1)
+#define MSC_REG_30_dcap_rdy_shift                                     (0)
+#define MSC_REG_30_conn_rdy_mask                                      (0x000000FE)
+#define MSC_REG_30_dcap_rdy_mask                                      (0x00000001)
+#define MSC_REG_30_conn_rdy(data)                                     (0x000000FE&((data)<<1))
+#define MSC_REG_30_dcap_rdy(data)                                     (0x00000001&(data))
+#define MSC_REG_30_get_conn_rdy(data)                                 ((0x000000FE&(data))>>1)
+#define MSC_REG_30_get_dcap_rdy(data)                                 (0x00000001&(data))
+
+
+#define MSC_REG_31                                                    0x1800f0c4
+#define MSC_REG_31_reg_addr                                           "0xb800f0c4"
+#define MSC_REG_31_reg                                                0xb800f0c4
+#define MSC_REG_31_inst_addr                                          "0x0031"
+#define MSC_REG_31_inst                                               0x0031
+#define MSC_REG_31_link_mode_shift                                    (5)
+#define MSC_REG_31_muted_shift                                        (4)
+#define MSC_REG_31_path_en_shift                                      (3)
+#define MSC_REG_31_clk_mode_shift                                     (0)
+#define MSC_REG_31_link_mode_mask                                     (0x000000E0)
+#define MSC_REG_31_muted_mask                                         (0x00000010)
+#define MSC_REG_31_path_en_mask                                       (0x00000008)
+#define MSC_REG_31_clk_mode_mask                                      (0x00000007)
+#define MSC_REG_31_link_mode(data)                                    (0x000000E0&((data)<<5))
+#define MSC_REG_31_muted(data)                                        (0x00000010&((data)<<4))
+#define MSC_REG_31_path_en(data)                                      (0x00000008&((data)<<3))
+#define MSC_REG_31_clk_mode(data)                                     (0x00000007&(data))
+#define MSC_REG_31_get_link_mode(data)                                ((0x000000E0&(data))>>5)
+#define MSC_REG_31_get_muted(data)                                    ((0x00000010&(data))>>4)
+#define MSC_REG_31_get_path_en(data)                                  ((0x00000008&(data))>>3)
+#define MSC_REG_31_get_clk_mode(data)                                 (0x00000007&(data))
+
+
+#define MSC_REG_32                                                    0x1800f0c8
+#define MSC_REG_32_reg_addr                                           "0xb800f0c8"
+#define MSC_REG_32_reg                                                0xb800f0c8
+#define MSC_REG_32_inst_addr                                          "0x0032"
+#define MSC_REG_32_inst                                               0x0032
+#define MSC_REG_32_stat_32_shift                                      (0)
+#define MSC_REG_32_stat_32_mask                                       (0x000000FF)
+#define MSC_REG_32_stat_32(data)                                      (0x000000FF&(data))
+#define MSC_REG_32_get_stat_32(data)                                  (0x000000FF&(data))
+
+
+#define MSC_REG_33                                                    0x1800f0cc
+#define MSC_REG_33_reg_addr                                           "0xb800f0cc"
+#define MSC_REG_33_reg                                                0xb800f0cc
+#define MSC_REG_33_inst_addr                                          "0x0033"
+#define MSC_REG_33_inst                                               0x0033
+#define MSC_REG_33_stat_33_shift                                      (0)
+#define MSC_REG_33_stat_33_mask                                       (0x000000FF)
+#define MSC_REG_33_stat_33(data)                                      (0x000000FF&(data))
+#define MSC_REG_33_get_stat_33(data)                                  (0x000000FF&(data))
+
+
+#define MSC_REG_34                                                    0x1800f0d0
+#define MSC_REG_34_reg_addr                                           "0xb800f0d0"
+#define MSC_REG_34_reg                                                0xb800f0d0
+#define MSC_REG_34_inst_addr                                          "0x0034"
+#define MSC_REG_34_inst                                               0x0034
+#define MSC_REG_34_stat_34_shift                                      (0)
+#define MSC_REG_34_stat_34_mask                                       (0x000000FF)
+#define MSC_REG_34_stat_34(data)                                      (0x000000FF&(data))
+#define MSC_REG_34_get_stat_34(data)                                  (0x000000FF&(data))
+
+
+#define MSC_REG_35                                                    0x1800f0d4
+#define MSC_REG_35_reg_addr                                           "0xb800f0d4"
+#define MSC_REG_35_reg                                                0xb800f0d4
+#define MSC_REG_35_inst_addr                                          "0x0035"
+#define MSC_REG_35_inst                                               0x0035
+#define MSC_REG_35_stat_35_shift                                      (0)
+#define MSC_REG_35_stat_35_mask                                       (0x000000FF)
+#define MSC_REG_35_stat_35(data)                                      (0x000000FF&(data))
+#define MSC_REG_35_get_stat_35(data)                                  (0x000000FF&(data))
+
+
+#define MSC_REG_36                                                    0x1800f0d8
+#define MSC_REG_36_reg_addr                                           "0xb800f0d8"
+#define MSC_REG_36_reg                                                0xb800f0d8
+#define MSC_REG_36_inst_addr                                          "0x0036"
+#define MSC_REG_36_inst                                               0x0036
+#define MSC_REG_36_stat_36_shift                                      (0)
+#define MSC_REG_36_stat_36_mask                                       (0x000000FF)
+#define MSC_REG_36_stat_36(data)                                      (0x000000FF&(data))
+#define MSC_REG_36_get_stat_36(data)                                  (0x000000FF&(data))
+
+
+#define MSC_REG_37                                                    0x1800f0dc
+#define MSC_REG_37_reg_addr                                           "0xb800f0dc"
+#define MSC_REG_37_reg                                                0xb800f0dc
+#define MSC_REG_37_inst_addr                                          "0x0037"
+#define MSC_REG_37_inst                                               0x0037
+#define MSC_REG_37_stat_37_shift                                      (0)
+#define MSC_REG_37_stat_37_mask                                       (0x000000FF)
+#define MSC_REG_37_stat_37(data)                                      (0x000000FF&(data))
+#define MSC_REG_37_get_stat_37(data)                                  (0x000000FF&(data))
+
+
+#define MSC_REG_40                                                    0x1800f100
+#define MSC_REG_40_reg_addr                                           "0xb800f100"
+#define MSC_REG_40_reg                                                0xb800f100
+#define MSC_REG_40_inst_addr                                          "0x0040"
+#define MSC_REG_40_inst                                               0x0040
+#define MSC_REG_40_scratch_40_shift                                   (0)
+#define MSC_REG_40_scratch_40_mask                                    (0x000000FF)
+#define MSC_REG_40_scratch_40(data)                                   (0x000000FF&(data))
+#define MSC_REG_40_get_scratch_40(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_41                                                    0x1800f104
+#define MSC_REG_41_reg_addr                                           "0xb800f104"
+#define MSC_REG_41_reg                                                0xb800f104
+#define MSC_REG_41_inst_addr                                          "0x0041"
+#define MSC_REG_41_inst                                               0x0041
+#define MSC_REG_41_scratch_41_shift                                   (0)
+#define MSC_REG_41_scratch_41_mask                                    (0x000000FF)
+#define MSC_REG_41_scratch_41(data)                                   (0x000000FF&(data))
+#define MSC_REG_41_get_scratch_41(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_42                                                    0x1800f108
+#define MSC_REG_42_reg_addr                                           "0xb800f108"
+#define MSC_REG_42_reg                                                0xb800f108
+#define MSC_REG_42_inst_addr                                          "0x0042"
+#define MSC_REG_42_inst                                               0x0042
+#define MSC_REG_42_scratch_42_shift                                   (0)
+#define MSC_REG_42_scratch_42_mask                                    (0x000000FF)
+#define MSC_REG_42_scratch_42(data)                                   (0x000000FF&(data))
+#define MSC_REG_42_get_scratch_42(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_43                                                    0x1800f10c
+#define MSC_REG_43_reg_addr                                           "0xb800f10c"
+#define MSC_REG_43_reg                                                0xb800f10c
+#define MSC_REG_43_inst_addr                                          "0x0043"
+#define MSC_REG_43_inst                                               0x0043
+#define MSC_REG_43_scratch_43_shift                                   (0)
+#define MSC_REG_43_scratch_43_mask                                    (0x000000FF)
+#define MSC_REG_43_scratch_43(data)                                   (0x000000FF&(data))
+#define MSC_REG_43_get_scratch_43(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_44                                                    0x1800f110
+#define MSC_REG_44_reg_addr                                           "0xb800f110"
+#define MSC_REG_44_reg                                                0xb800f110
+#define MSC_REG_44_inst_addr                                          "0x0044"
+#define MSC_REG_44_inst                                               0x0044
+#define MSC_REG_44_scratch_44_shift                                   (0)
+#define MSC_REG_44_scratch_44_mask                                    (0x000000FF)
+#define MSC_REG_44_scratch_44(data)                                   (0x000000FF&(data))
+#define MSC_REG_44_get_scratch_44(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_45                                                    0x1800f114
+#define MSC_REG_45_reg_addr                                           "0xb800f114"
+#define MSC_REG_45_reg                                                0xb800f114
+#define MSC_REG_45_inst_addr                                          "0x0045"
+#define MSC_REG_45_inst                                               0x0045
+#define MSC_REG_45_scratch_45_shift                                   (0)
+#define MSC_REG_45_scratch_45_mask                                    (0x000000FF)
+#define MSC_REG_45_scratch_45(data)                                   (0x000000FF&(data))
+#define MSC_REG_45_get_scratch_45(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_46                                                    0x1800f118
+#define MSC_REG_46_reg_addr                                           "0xb800f118"
+#define MSC_REG_46_reg                                                0xb800f118
+#define MSC_REG_46_inst_addr                                          "0x0046"
+#define MSC_REG_46_inst                                               0x0046
+#define MSC_REG_46_scratch_46_shift                                   (0)
+#define MSC_REG_46_scratch_46_mask                                    (0x000000FF)
+#define MSC_REG_46_scratch_46(data)                                   (0x000000FF&(data))
+#define MSC_REG_46_get_scratch_46(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_47                                                    0x1800f11c
+#define MSC_REG_47_reg_addr                                           "0xb800f11c"
+#define MSC_REG_47_reg                                                0xb800f11c
+#define MSC_REG_47_inst_addr                                          "0x0047"
+#define MSC_REG_47_inst                                               0x0047
+#define MSC_REG_47_scratch_47_shift                                   (0)
+#define MSC_REG_47_scratch_47_mask                                    (0x000000FF)
+#define MSC_REG_47_scratch_47(data)                                   (0x000000FF&(data))
+#define MSC_REG_47_get_scratch_47(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_48                                                    0x1800f120
+#define MSC_REG_48_reg_addr                                           "0xb800f120"
+#define MSC_REG_48_reg                                                0xb800f120
+#define MSC_REG_48_inst_addr                                          "0x0048"
+#define MSC_REG_48_inst                                               0x0048
+#define MSC_REG_48_scratch_48_shift                                   (0)
+#define MSC_REG_48_scratch_48_mask                                    (0x000000FF)
+#define MSC_REG_48_scratch_48(data)                                   (0x000000FF&(data))
+#define MSC_REG_48_get_scratch_48(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_49                                                    0x1800f124
+#define MSC_REG_49_reg_addr                                           "0xb800f124"
+#define MSC_REG_49_reg                                                0xb800f124
+#define MSC_REG_49_inst_addr                                          "0x0049"
+#define MSC_REG_49_inst                                               0x0049
+#define MSC_REG_49_scratch_49_shift                                   (0)
+#define MSC_REG_49_scratch_49_mask                                    (0x000000FF)
+#define MSC_REG_49_scratch_49(data)                                   (0x000000FF&(data))
+#define MSC_REG_49_get_scratch_49(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_4A                                                    0x1800f128
+#define MSC_REG_4A_reg_addr                                           "0xb800f128"
+#define MSC_REG_4A_reg                                                0xb800f128
+#define MSC_REG_4A_inst_addr                                          "0x004A"
+#define MSC_REG_4A_inst                                               0x004A
+#define MSC_REG_4A_scratch_4a_shift                                   (0)
+#define MSC_REG_4A_scratch_4a_mask                                    (0x000000FF)
+#define MSC_REG_4A_scratch_4a(data)                                   (0x000000FF&(data))
+#define MSC_REG_4A_get_scratch_4a(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_4B                                                    0x1800f12c
+#define MSC_REG_4B_reg_addr                                           "0xb800f12c"
+#define MSC_REG_4B_reg                                                0xb800f12c
+#define MSC_REG_4B_inst_addr                                          "0x004B"
+#define MSC_REG_4B_inst                                               0x004B
+#define MSC_REG_4B_scratch_4b_shift                                   (0)
+#define MSC_REG_4B_scratch_4b_mask                                    (0x000000FF)
+#define MSC_REG_4B_scratch_4b(data)                                   (0x000000FF&(data))
+#define MSC_REG_4B_get_scratch_4b(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_4C                                                    0x1800f130
+#define MSC_REG_4C_reg_addr                                           "0xb800f130"
+#define MSC_REG_4C_reg                                                0xb800f130
+#define MSC_REG_4C_inst_addr                                          "0x004C"
+#define MSC_REG_4C_inst                                               0x004C
+#define MSC_REG_4C_scratch_4c_shift                                   (0)
+#define MSC_REG_4C_scratch_4c_mask                                    (0x000000FF)
+#define MSC_REG_4C_scratch_4c(data)                                   (0x000000FF&(data))
+#define MSC_REG_4C_get_scratch_4c(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_4D                                                    0x1800f134
+#define MSC_REG_4D_reg_addr                                           "0xb800f134"
+#define MSC_REG_4D_reg                                                0xb800f134
+#define MSC_REG_4D_inst_addr                                          "0x004D"
+#define MSC_REG_4D_inst                                               0x004D
+#define MSC_REG_4D_scratch_4d_shift                                   (0)
+#define MSC_REG_4D_scratch_4d_mask                                    (0x000000FF)
+#define MSC_REG_4D_scratch_4d(data)                                   (0x000000FF&(data))
+#define MSC_REG_4D_get_scratch_4d(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_4E                                                    0x1800f138
+#define MSC_REG_4E_reg_addr                                           "0xb800f138"
+#define MSC_REG_4E_reg                                                0xb800f138
+#define MSC_REG_4E_inst_addr                                          "0x004E"
+#define MSC_REG_4E_inst                                               0x004E
+#define MSC_REG_4E_scratch_4e_shift                                   (0)
+#define MSC_REG_4E_scratch_4e_mask                                    (0x000000FF)
+#define MSC_REG_4E_scratch_4e(data)                                   (0x000000FF&(data))
+#define MSC_REG_4E_get_scratch_4e(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_4F                                                    0x1800f13c
+#define MSC_REG_4F_reg_addr                                           "0xb800f13c"
+#define MSC_REG_4F_reg                                                0xb800f13c
+#define MSC_REG_4F_inst_addr                                          "0x004F"
+#define MSC_REG_4F_inst                                               0x004F
+#define MSC_REG_4F_scratch_4f_shift                                   (0)
+#define MSC_REG_4F_scratch_4f_mask                                    (0x000000FF)
+#define MSC_REG_4F_scratch_4f(data)                                   (0x000000FF&(data))
+#define MSC_REG_4F_get_scratch_4f(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_50                                                    0x1800f140
+#define MSC_REG_50_reg_addr                                           "0xb800f140"
+#define MSC_REG_50_reg                                                0xb800f140
+#define MSC_REG_50_inst_addr                                          "0x0050"
+#define MSC_REG_50_inst                                               0x0050
+#define MSC_REG_50_scratch_50_shift                                   (0)
+#define MSC_REG_50_scratch_50_mask                                    (0x000000FF)
+#define MSC_REG_50_scratch_50(data)                                   (0x000000FF&(data))
+#define MSC_REG_50_get_scratch_50(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_51                                                    0x1800f144
+#define MSC_REG_51_reg_addr                                           "0xb800f144"
+#define MSC_REG_51_reg                                                0xb800f144
+#define MSC_REG_51_inst_addr                                          "0x0051"
+#define MSC_REG_51_inst                                               0x0051
+#define MSC_REG_51_scratch_51_shift                                   (0)
+#define MSC_REG_51_scratch_51_mask                                    (0x000000FF)
+#define MSC_REG_51_scratch_51(data)                                   (0x000000FF&(data))
+#define MSC_REG_51_get_scratch_51(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_52                                                    0x1800f148
+#define MSC_REG_52_reg_addr                                           "0xb800f148"
+#define MSC_REG_52_reg                                                0xb800f148
+#define MSC_REG_52_inst_addr                                          "0x0052"
+#define MSC_REG_52_inst                                               0x0052
+#define MSC_REG_52_scratch_52_shift                                   (0)
+#define MSC_REG_52_scratch_52_mask                                    (0x000000FF)
+#define MSC_REG_52_scratch_52(data)                                   (0x000000FF&(data))
+#define MSC_REG_52_get_scratch_52(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_53                                                    0x1800f14c
+#define MSC_REG_53_reg_addr                                           "0xb800f14c"
+#define MSC_REG_53_reg                                                0xb800f14c
+#define MSC_REG_53_inst_addr                                          "0x0053"
+#define MSC_REG_53_inst                                               0x0053
+#define MSC_REG_53_scratch_53_shift                                   (0)
+#define MSC_REG_53_scratch_53_mask                                    (0x000000FF)
+#define MSC_REG_53_scratch_53(data)                                   (0x000000FF&(data))
+#define MSC_REG_53_get_scratch_53(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_54                                                    0x1800f150
+#define MSC_REG_54_reg_addr                                           "0xb800f150"
+#define MSC_REG_54_reg                                                0xb800f150
+#define MSC_REG_54_inst_addr                                          "0x0054"
+#define MSC_REG_54_inst                                               0x0054
+#define MSC_REG_54_scratch_54_shift                                   (0)
+#define MSC_REG_54_scratch_54_mask                                    (0x000000FF)
+#define MSC_REG_54_scratch_54(data)                                   (0x000000FF&(data))
+#define MSC_REG_54_get_scratch_54(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_55                                                    0x1800f154
+#define MSC_REG_55_reg_addr                                           "0xb800f154"
+#define MSC_REG_55_reg                                                0xb800f154
+#define MSC_REG_55_inst_addr                                          "0x0055"
+#define MSC_REG_55_inst                                               0x0055
+#define MSC_REG_55_scratch_55_shift                                   (0)
+#define MSC_REG_55_scratch_55_mask                                    (0x000000FF)
+#define MSC_REG_55_scratch_55(data)                                   (0x000000FF&(data))
+#define MSC_REG_55_get_scratch_55(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_56                                                    0x1800f158
+#define MSC_REG_56_reg_addr                                           "0xb800f158"
+#define MSC_REG_56_reg                                                0xb800f158
+#define MSC_REG_56_inst_addr                                          "0x0056"
+#define MSC_REG_56_inst                                               0x0056
+#define MSC_REG_56_scratch_56_shift                                   (0)
+#define MSC_REG_56_scratch_56_mask                                    (0x000000FF)
+#define MSC_REG_56_scratch_56(data)                                   (0x000000FF&(data))
+#define MSC_REG_56_get_scratch_56(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_57                                                    0x1800f15c
+#define MSC_REG_57_reg_addr                                           "0xb800f15c"
+#define MSC_REG_57_reg                                                0xb800f15c
+#define MSC_REG_57_inst_addr                                          "0x0057"
+#define MSC_REG_57_inst                                               0x0057
+#define MSC_REG_57_scratch_57_shift                                   (0)
+#define MSC_REG_57_scratch_57_mask                                    (0x000000FF)
+#define MSC_REG_57_scratch_57(data)                                   (0x000000FF&(data))
+#define MSC_REG_57_get_scratch_57(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_58                                                    0x1800f160
+#define MSC_REG_58_reg_addr                                           "0xb800f160"
+#define MSC_REG_58_reg                                                0xb800f160
+#define MSC_REG_58_inst_addr                                          "0x0058"
+#define MSC_REG_58_inst                                               0x0058
+#define MSC_REG_58_scratch_58_shift                                   (0)
+#define MSC_REG_58_scratch_58_mask                                    (0x000000FF)
+#define MSC_REG_58_scratch_58(data)                                   (0x000000FF&(data))
+#define MSC_REG_58_get_scratch_58(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_59                                                    0x1800f164
+#define MSC_REG_59_reg_addr                                           "0xb800f164"
+#define MSC_REG_59_reg                                                0xb800f164
+#define MSC_REG_59_inst_addr                                          "0x0059"
+#define MSC_REG_59_inst                                               0x0059
+#define MSC_REG_59_scratch_59_shift                                   (0)
+#define MSC_REG_59_scratch_59_mask                                    (0x000000FF)
+#define MSC_REG_59_scratch_59(data)                                   (0x000000FF&(data))
+#define MSC_REG_59_get_scratch_59(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_5A                                                    0x1800f168
+#define MSC_REG_5A_reg_addr                                           "0xb800f168"
+#define MSC_REG_5A_reg                                                0xb800f168
+#define MSC_REG_5A_inst_addr                                          "0x005A"
+#define MSC_REG_5A_inst                                               0x005A
+#define MSC_REG_5A_scratch_5a_shift                                   (0)
+#define MSC_REG_5A_scratch_5a_mask                                    (0x000000FF)
+#define MSC_REG_5A_scratch_5a(data)                                   (0x000000FF&(data))
+#define MSC_REG_5A_get_scratch_5a(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_5B                                                    0x1800f16c
+#define MSC_REG_5B_reg_addr                                           "0xb800f16c"
+#define MSC_REG_5B_reg                                                0xb800f16c
+#define MSC_REG_5B_inst_addr                                          "0x005B"
+#define MSC_REG_5B_inst                                               0x005B
+#define MSC_REG_5B_scratch_5b_shift                                   (0)
+#define MSC_REG_5B_scratch_5b_mask                                    (0x000000FF)
+#define MSC_REG_5B_scratch_5b(data)                                   (0x000000FF&(data))
+#define MSC_REG_5B_get_scratch_5b(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_5C                                                    0x1800f170
+#define MSC_REG_5C_reg_addr                                           "0xb800f170"
+#define MSC_REG_5C_reg                                                0xb800f170
+#define MSC_REG_5C_inst_addr                                          "0x005C"
+#define MSC_REG_5C_inst                                               0x005C
+#define MSC_REG_5C_scratch_5c_shift                                   (0)
+#define MSC_REG_5C_scratch_5c_mask                                    (0x000000FF)
+#define MSC_REG_5C_scratch_5c(data)                                   (0x000000FF&(data))
+#define MSC_REG_5C_get_scratch_5c(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_5D                                                    0x1800f174
+#define MSC_REG_5D_reg_addr                                           "0xb800f174"
+#define MSC_REG_5D_reg                                                0xb800f174
+#define MSC_REG_5D_inst_addr                                          "0x005D"
+#define MSC_REG_5D_inst                                               0x005D
+#define MSC_REG_5D_scratch_5d_shift                                   (0)
+#define MSC_REG_5D_scratch_5d_mask                                    (0x000000FF)
+#define MSC_REG_5D_scratch_5d(data)                                   (0x000000FF&(data))
+#define MSC_REG_5D_get_scratch_5d(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_5E                                                    0x1800f178
+#define MSC_REG_5E_reg_addr                                           "0xb800f178"
+#define MSC_REG_5E_reg                                                0xb800f178
+#define MSC_REG_5E_inst_addr                                          "0x005E"
+#define MSC_REG_5E_inst                                               0x005E
+#define MSC_REG_5E_scratch_5e_shift                                   (0)
+#define MSC_REG_5E_scratch_5e_mask                                    (0x000000FF)
+#define MSC_REG_5E_scratch_5e(data)                                   (0x000000FF&(data))
+#define MSC_REG_5E_get_scratch_5e(data)                               (0x000000FF&(data))
+
+
+#define MSC_REG_5F                                                    0x1800f17c
+#define MSC_REG_5F_reg_addr                                           "0xb800f17c"
+#define MSC_REG_5F_reg                                                0xb800f17c
+#define MSC_REG_5F_inst_addr                                          "0x005F"
+#define MSC_REG_5F_inst                                               0x005F
+#define MSC_REG_5F_scratch_5f_shift                                   (0)
+#define MSC_REG_5F_scratch_5f_mask                                    (0x000000FF)
+#define MSC_REG_5F_scratch_5f(data)                                   (0x000000FF&(data))
+#define MSC_REG_5F_get_scratch_5f(data)                               (0x000000FF&(data))
+
+
+#define CBUS_LINK_00                                                  0x1800f200
+#define CBUS_LINK_00_reg_addr                                         "0xb800f200"
+#define CBUS_LINK_00_reg                                              0xb800f200
+#define CBUS_LINK_00_inst_addr                                        "0x0080"
+#define CBUS_LINK_00_inst                                             0x0080
+#define CBUS_LINK_00_sync0_hb_8_0_shift                               (9)
+#define CBUS_LINK_00_sync0_lb_8_0_shift                               (0)
+#define CBUS_LINK_00_sync0_hb_8_0_mask                                (0x0003FE00)
+#define CBUS_LINK_00_sync0_lb_8_0_mask                                (0x000001FF)
+#define CBUS_LINK_00_sync0_hb_8_0(data)                               (0x0003FE00&((data)<<9))
+#define CBUS_LINK_00_sync0_lb_8_0(data)                               (0x000001FF&(data))
+#define CBUS_LINK_00_get_sync0_hb_8_0(data)                           ((0x0003FE00&(data))>>9)
+#define CBUS_LINK_00_get_sync0_lb_8_0(data)                           (0x000001FF&(data))
+
+
+#define CBUS_LINK_01                                                  0x1800f204
+#define CBUS_LINK_01_reg_addr                                         "0xb800f204"
+#define CBUS_LINK_01_reg                                              0xb800f204
+#define CBUS_LINK_01_inst_addr                                        "0x0081"
+#define CBUS_LINK_01_inst                                             0x0081
+#define CBUS_LINK_01_sync1_hb_7_0_shift                               (8)
+#define CBUS_LINK_01_sync1_lb_7_0_shift                               (0)
+#define CBUS_LINK_01_sync1_hb_7_0_mask                                (0x0000FF00)
+#define CBUS_LINK_01_sync1_lb_7_0_mask                                (0x000000FF)
+#define CBUS_LINK_01_sync1_hb_7_0(data)                               (0x0000FF00&((data)<<8))
+#define CBUS_LINK_01_sync1_lb_7_0(data)                               (0x000000FF&(data))
+#define CBUS_LINK_01_get_sync1_hb_7_0(data)                           ((0x0000FF00&(data))>>8)
+#define CBUS_LINK_01_get_sync1_lb_7_0(data)                           (0x000000FF&(data))
+
+
+#define CBUS_LINK_02                                                  0x1800f208
+#define CBUS_LINK_02_reg_addr                                         "0xb800f208"
+#define CBUS_LINK_02_reg                                              0xb800f208
+#define CBUS_LINK_02_inst_addr                                        "0x0082"
+#define CBUS_LINK_02_inst                                             0x0082
+#define CBUS_LINK_02_sync_bit_time_shift                              (0)
+#define CBUS_LINK_02_sync_bit_time_mask                               (0x000000FF)
+#define CBUS_LINK_02_sync_bit_time(data)                              (0x000000FF&(data))
+#define CBUS_LINK_02_get_sync_bit_time(data)                          (0x000000FF&(data))
+
+
+#define CBUS_LINK_03                                                  0x1800f20c
+#define CBUS_LINK_03_reg_addr                                         "0xb800f20c"
+#define CBUS_LINK_03_reg                                              0xb800f20c
+#define CBUS_LINK_03_inst_addr                                        "0x0083"
+#define CBUS_LINK_03_inst                                             0x0083
+#define CBUS_LINK_03_abs_thres_en_shift                               (8)
+#define CBUS_LINK_03_abs_threshold_shift                              (0)
+#define CBUS_LINK_03_abs_thres_en_mask                                (0x00000100)
+#define CBUS_LINK_03_abs_threshold_mask                               (0x000000FF)
+#define CBUS_LINK_03_abs_thres_en(data)                               (0x00000100&((data)<<8))
+#define CBUS_LINK_03_abs_threshold(data)                              (0x000000FF&(data))
+#define CBUS_LINK_03_get_abs_thres_en(data)                           ((0x00000100&(data))>>8)
+#define CBUS_LINK_03_get_abs_threshold(data)                          (0x000000FF&(data))
+
+
+#define CBUS_LINK_04                                                  0x1800f210
+#define CBUS_LINK_04_reg_addr                                         "0xb800f210"
+#define CBUS_LINK_04_reg                                              0xb800f210
+#define CBUS_LINK_04_inst_addr                                        "0x0084"
+#define CBUS_LINK_04_inst                                             0x0084
+#define CBUS_LINK_04_parity_time_shift                                (0)
+#define CBUS_LINK_04_parity_time_mask                                 (0x000000FF)
+#define CBUS_LINK_04_parity_time(data)                                (0x000000FF&(data))
+#define CBUS_LINK_04_get_parity_time(data)                            (0x000000FF&(data))
+
+
+#define CBUS_LINK_05                                                  0x1800f214
+#define CBUS_LINK_05_reg_addr                                         "0xb800f214"
+#define CBUS_LINK_05_reg                                              0xb800f214
+#define CBUS_LINK_05_inst_addr                                        "0x0085"
+#define CBUS_LINK_05_inst                                             0x0085
+#define CBUS_LINK_05_parity_fail_shift                                (7)
+#define CBUS_LINK_05_parity_irq_en_shift                              (6)
+#define CBUS_LINK_05_ctrl_16_resv_shift                               (5)
+#define CBUS_LINK_05_parity_limit_shift                               (0)
+#define CBUS_LINK_05_parity_fail_mask                                 (0x00000080)
+#define CBUS_LINK_05_parity_irq_en_mask                               (0x00000040)
+#define CBUS_LINK_05_ctrl_16_resv_mask                                (0x00000020)
+#define CBUS_LINK_05_parity_limit_mask                                (0x0000001F)
+#define CBUS_LINK_05_parity_fail(data)                                (0x00000080&((data)<<7))
+#define CBUS_LINK_05_parity_irq_en(data)                              (0x00000040&((data)<<6))
+#define CBUS_LINK_05_ctrl_16_resv(data)                               (0x00000020&((data)<<5))
+#define CBUS_LINK_05_parity_limit(data)                               (0x0000001F&(data))
+#define CBUS_LINK_05_get_parity_fail(data)                            ((0x00000080&(data))>>7)
+#define CBUS_LINK_05_get_parity_irq_en(data)                          ((0x00000040&(data))>>6)
+#define CBUS_LINK_05_get_ctrl_16_resv(data)                           ((0x00000020&(data))>>5)
+#define CBUS_LINK_05_get_parity_limit(data)                           (0x0000001F&(data))
+
+
+#define CBUS_LINK_06                                                  0x1800f218
+#define CBUS_LINK_06_reg_addr                                         "0xb800f218"
+#define CBUS_LINK_06_reg                                              0xb800f218
+#define CBUS_LINK_06_inst_addr                                        "0x0086"
+#define CBUS_LINK_06_inst                                             0x0086
+#define CBUS_LINK_06_ack_fall_shift                                   (0)
+#define CBUS_LINK_06_ack_fall_mask                                    (0x0000007F)
+#define CBUS_LINK_06_ack_fall(data)                                   (0x0000007F&(data))
+#define CBUS_LINK_06_get_ack_fall(data)                               (0x0000007F&(data))
+
+
+#define CBUS_LINK_07                                                  0x1800f21c
+#define CBUS_LINK_07_reg_addr                                         "0xb800f21c"
+#define CBUS_LINK_07_reg                                              0xb800f21c
+#define CBUS_LINK_07_inst_addr                                        "0x0087"
+#define CBUS_LINK_07_inst                                             0x0087
+#define CBUS_LINK_07_ack_0_shift                                      (0)
+#define CBUS_LINK_07_ack_0_mask                                       (0x0000007F)
+#define CBUS_LINK_07_ack_0(data)                                      (0x0000007F&(data))
+#define CBUS_LINK_07_get_ack_0(data)                                  (0x0000007F&(data))
+
+
+#define CBUS_LINK_08                                                  0x1800f220
+#define CBUS_LINK_08_reg_addr                                         "0xb800f220"
+#define CBUS_LINK_08_reg                                              0xb800f220
+#define CBUS_LINK_08_inst_addr                                        "0x0088"
+#define CBUS_LINK_08_inst                                             0x0088
+#define CBUS_LINK_08_tx_bit_time_shift                                (0)
+#define CBUS_LINK_08_tx_bit_time_mask                                 (0x000000FF)
+#define CBUS_LINK_08_tx_bit_time(data)                                (0x000000FF&(data))
+#define CBUS_LINK_08_get_tx_bit_time(data)                            (0x000000FF&(data))
+
+
+#define CBUS_LINK_09                                                  0x1800f224
+#define CBUS_LINK_09_reg_addr                                         "0xb800f224"
+#define CBUS_LINK_09_reg                                              0xb800f224
+#define CBUS_LINK_09_inst_addr                                        "0x0089"
+#define CBUS_LINK_09_inst                                             0x0089
+#define CBUS_LINK_09_chk_win_up_shift                                 (5)
+#define CBUS_LINK_09_chk_win_lo_shift                                 (3)
+#define CBUS_LINK_09_fast_reply_en_shift                              (2)
+#define CBUS_LINK_09_ctrl_1b_resv_shift                               (0)
+#define CBUS_LINK_09_chk_win_up_mask                                  (0x000000E0)
+#define CBUS_LINK_09_chk_win_lo_mask                                  (0x00000018)
+#define CBUS_LINK_09_fast_reply_en_mask                               (0x00000004)
+#define CBUS_LINK_09_ctrl_1b_resv_mask                                (0x00000003)
+#define CBUS_LINK_09_chk_win_up(data)                                 (0x000000E0&((data)<<5))
+#define CBUS_LINK_09_chk_win_lo(data)                                 (0x00000018&((data)<<3))
+#define CBUS_LINK_09_fast_reply_en(data)                              (0x00000004&((data)<<2))
+#define CBUS_LINK_09_ctrl_1b_resv(data)                               (0x00000003&(data))
+#define CBUS_LINK_09_get_chk_win_up(data)                             ((0x000000E0&(data))>>5)
+#define CBUS_LINK_09_get_chk_win_lo(data)                             ((0x00000018&(data))>>3)
+#define CBUS_LINK_09_get_fast_reply_en(data)                          ((0x00000004&(data))>>2)
+#define CBUS_LINK_09_get_ctrl_1b_resv(data)                           (0x00000003&(data))
+
+
+#define CBUS_LINK_0A                                                  0x1800f228
+#define CBUS_LINK_0A_reg_addr                                         "0xb800f228"
+#define CBUS_LINK_0A_reg                                              0xb800f228
+#define CBUS_LINK_0A_inst_addr                                        "0x008A"
+#define CBUS_LINK_0A_inst                                             0x008A
+#define CBUS_LINK_0A_tx_ack_fal_shift                                 (0)
+#define CBUS_LINK_0A_tx_ack_fal_mask                                  (0x0000007F)
+#define CBUS_LINK_0A_tx_ack_fal(data)                                 (0x0000007F&(data))
+#define CBUS_LINK_0A_get_tx_ack_fal(data)                             (0x0000007F&(data))
+
+
+#define CBUS_LINK_0B                                                  0x1800f22c
+#define CBUS_LINK_0B_reg_addr                                         "0xb800f22c"
+#define CBUS_LINK_0B_reg                                              0xb800f22c
+#define CBUS_LINK_0B_inst_addr                                        "0x008B"
+#define CBUS_LINK_0B_inst                                             0x008B
+#define CBUS_LINK_0B_tx_ack_low_hb_shift                              (0)
+#define CBUS_LINK_0B_tx_ack_low_hb_mask                               (0x0000007F)
+#define CBUS_LINK_0B_tx_ack_low_hb(data)                              (0x0000007F&(data))
+#define CBUS_LINK_0B_get_tx_ack_low_hb(data)                          (0x0000007F&(data))
+
+
+#define CBUS_LINK_0C                                                  0x1800f230
+#define CBUS_LINK_0C_reg_addr                                         "0xb800f230"
+#define CBUS_LINK_0C_reg                                              0xb800f230
+#define CBUS_LINK_0C_inst_addr                                        "0x008C"
+#define CBUS_LINK_0C_inst                                             0x008C
+#define CBUS_LINK_0C_tx_ack_low_lb_shift                              (0)
+#define CBUS_LINK_0C_tx_ack_low_lb_mask                               (0x0000007F)
+#define CBUS_LINK_0C_tx_ack_low_lb(data)                              (0x0000007F&(data))
+#define CBUS_LINK_0C_get_tx_ack_low_lb(data)                          (0x0000007F&(data))
+
+
+#define CBUS_LINK_0D                                                  0x1800f234
+#define CBUS_LINK_0D_reg_addr                                         "0xb800f234"
+#define CBUS_LINK_0D_reg                                              0xb800f234
+#define CBUS_LINK_0D_inst_addr                                        "0x008D"
+#define CBUS_LINK_0D_inst                                             0x008D
+#define CBUS_LINK_0D_retry_lv_shift                                   (5)
+#define CBUS_LINK_0D_retry_flag_shift                                 (4)
+#define CBUS_LINK_0D_ctrl_1f_resv_shift                               (0)
+#define CBUS_LINK_0D_retry_lv_mask                                    (0x000000E0)
+#define CBUS_LINK_0D_retry_flag_mask                                  (0x00000010)
+#define CBUS_LINK_0D_ctrl_1f_resv_mask                                (0x0000000F)
+#define CBUS_LINK_0D_retry_lv(data)                                   (0x000000E0&((data)<<5))
+#define CBUS_LINK_0D_retry_flag(data)                                 (0x00000010&((data)<<4))
+#define CBUS_LINK_0D_ctrl_1f_resv(data)                               (0x0000000F&(data))
+#define CBUS_LINK_0D_get_retry_lv(data)                               ((0x000000E0&(data))>>5)
+#define CBUS_LINK_0D_get_retry_flag(data)                             ((0x00000010&(data))>>4)
+#define CBUS_LINK_0D_get_ctrl_1f_resv(data)                           (0x0000000F&(data))
+
+
+#define CBUS_LINK_0E                                                  0x1800f238
+#define CBUS_LINK_0E_reg_addr                                         "0xb800f238"
+#define CBUS_LINK_0E_reg                                              0xb800f238
+#define CBUS_LINK_0E_inst_addr                                        "0x008E"
+#define CBUS_LINK_0E_inst                                             0x008E
+#define CBUS_LINK_0E_drv_str_shift                                    (6)
+#define CBUS_LINK_0E_drv_hi_cbus_shift                                (0)
+#define CBUS_LINK_0E_drv_str_mask                                     (0x000000C0)
+#define CBUS_LINK_0E_drv_hi_cbus_mask                                 (0x0000003F)
+#define CBUS_LINK_0E_drv_str(data)                                    (0x000000C0&((data)<<6))
+#define CBUS_LINK_0E_drv_hi_cbus(data)                                (0x0000003F&(data))
+#define CBUS_LINK_0E_get_drv_str(data)                                ((0x000000C0&(data))>>6)
+#define CBUS_LINK_0E_get_drv_hi_cbus(data)                            (0x0000003F&(data))
+
+
+#define CBUS_LINK_0F                                                  0x1800f23c
+#define CBUS_LINK_0F_reg_addr                                         "0xb800f23c"
+#define CBUS_LINK_0F_reg                                              0xb800f23c
+#define CBUS_LINK_0F_inst_addr                                        "0x008F"
+#define CBUS_LINK_0F_inst                                             0x008F
+#define CBUS_LINK_0F_wait_shift                                       (2)
+#define CBUS_LINK_0F_req_opp_int_shift                                (0)
+#define CBUS_LINK_0F_wait_mask                                        (0x0000003C)
+#define CBUS_LINK_0F_req_opp_int_mask                                 (0x00000003)
+#define CBUS_LINK_0F_wait(data)                                       (0x0000003C&((data)<<2))
+#define CBUS_LINK_0F_req_opp_int(data)                                (0x00000003&(data))
+#define CBUS_LINK_0F_get_wait(data)                                   ((0x0000003C&(data))>>2)
+#define CBUS_LINK_0F_get_req_opp_int(data)                            (0x00000003&(data))
+
+
+#define CBUS_LINK_10                                                  0x1800f240
+#define CBUS_LINK_10_reg_addr                                         "0xb800f240"
+#define CBUS_LINK_10_reg                                              0xb800f240
+#define CBUS_LINK_10_inst_addr                                        "0x0090"
+#define CBUS_LINK_10_inst                                             0x0090
+#define CBUS_LINK_10_req_opp_flt_shift                                (0)
+#define CBUS_LINK_10_req_opp_flt_mask                                 (0x000000FF)
+#define CBUS_LINK_10_req_opp_flt(data)                                (0x000000FF&(data))
+#define CBUS_LINK_10_get_req_opp_flt(data)                            (0x000000FF&(data))
+
+
+#define CBUS_LINK_11                                                  0x1800f244
+#define CBUS_LINK_11_reg_addr                                         "0xb800f244"
+#define CBUS_LINK_11_reg                                              0xb800f244
+#define CBUS_LINK_11_inst_addr                                        "0x0091"
+#define CBUS_LINK_11_inst                                             0x0091
+#define CBUS_LINK_11_req_cont_shift                                   (0)
+#define CBUS_LINK_11_req_cont_mask                                    (0x000000FF)
+#define CBUS_LINK_11_req_cont(data)                                   (0x000000FF&(data))
+#define CBUS_LINK_11_get_req_cont(data)                               (0x000000FF&(data))
+
+
+#define CBUS_LINK_12                                                  0x1800f248
+#define CBUS_LINK_12_reg_addr                                         "0xb800f248"
+#define CBUS_LINK_12_reg                                              0xb800f248
+#define CBUS_LINK_12_inst_addr                                        "0x0092"
+#define CBUS_LINK_12_inst                                             0x0092
+#define CBUS_LINK_12_req_hold_shift                                   (4)
+#define CBUS_LINK_12_resp_hold_shift                                  (0)
+#define CBUS_LINK_12_req_hold_mask                                    (0x000000F0)
+#define CBUS_LINK_12_resp_hold_mask                                   (0x0000000F)
+#define CBUS_LINK_12_req_hold(data)                                   (0x000000F0&((data)<<4))
+#define CBUS_LINK_12_resp_hold(data)                                  (0x0000000F&(data))
+#define CBUS_LINK_12_get_req_hold(data)                               ((0x000000F0&(data))>>4)
+#define CBUS_LINK_12_get_resp_hold(data)                              (0x0000000F&(data))
+
+
+#define CBUS_LINK_13                                                  0x1800f24c
+#define CBUS_LINK_13_reg_addr                                         "0xb800f24c"
+#define CBUS_LINK_13_reg                                              0xb800f24c
+#define CBUS_LINK_13_inst_addr                                        "0x0093"
+#define CBUS_LINK_13_inst                                             0x0093
+#define CBUS_LINK_13_glob_time_shift                                  (6)
+#define CBUS_LINK_13_link_time_shift                                  (1)
+#define CBUS_LINK_13_link_err_shift                                   (0)
+#define CBUS_LINK_13_glob_time_mask                                   (0x000000C0)
+#define CBUS_LINK_13_link_time_mask                                   (0x0000003E)
+#define CBUS_LINK_13_link_err_mask                                    (0x00000001)
+#define CBUS_LINK_13_glob_time(data)                                  (0x000000C0&((data)<<6))
+#define CBUS_LINK_13_link_time(data)                                  (0x0000003E&((data)<<1))
+#define CBUS_LINK_13_link_err(data)                                   (0x00000001&(data))
+#define CBUS_LINK_13_get_glob_time(data)                              ((0x000000C0&(data))>>6)
+#define CBUS_LINK_13_get_link_time(data)                              ((0x0000003E&(data))>>1)
+#define CBUS_LINK_13_get_link_err(data)                               (0x00000001&(data))
+
+
+#define CBUS_LINK_14                                                  0x1800f250
+#define CBUS_LINK_14_reg_addr                                         "0xb800f250"
+#define CBUS_LINK_14_reg                                              0xb800f250
+#define CBUS_LINK_14_inst_addr                                        "0x0094"
+#define CBUS_LINK_14_inst                                             0x0094
+#define CBUS_LINK_14_chk_point_shift                                  (2)
+#define CBUS_LINK_14_chk_err_shift                                    (1)
+#define CBUS_LINK_14_avoid_conf_shift                                 (0)
+#define CBUS_LINK_14_chk_point_mask                                   (0x000000FC)
+#define CBUS_LINK_14_chk_err_mask                                     (0x00000002)
+#define CBUS_LINK_14_avoid_conf_mask                                  (0x00000001)
+#define CBUS_LINK_14_chk_point(data)                                  (0x000000FC&((data)<<2))
+#define CBUS_LINK_14_chk_err(data)                                    (0x00000002&((data)<<1))
+#define CBUS_LINK_14_avoid_conf(data)                                 (0x00000001&(data))
+#define CBUS_LINK_14_get_chk_point(data)                              ((0x000000FC&(data))>>2)
+#define CBUS_LINK_14_get_chk_err(data)                                ((0x00000002&(data))>>1)
+#define CBUS_LINK_14_get_avoid_conf(data)                             (0x00000001&(data))
+
+
+#define CBUS_MSC_00                                                   0x1800f260
+#define CBUS_MSC_00_reg_addr                                          "0xb800f260"
+#define CBUS_MSC_00_reg                                               0xb800f260
+#define CBUS_MSC_00_inst_addr                                         "0x0098"
+#define CBUS_MSC_00_inst                                              0x0098
+#define CBUS_MSC_00_mcumsc_en_shift                                   (5)
+#define CBUS_MSC_00_msc_wait_arb_shift                                (4)
+#define CBUS_MSC_00_ctrl_28_resv_shift                                (0)
+#define CBUS_MSC_00_mcumsc_en_mask                                    (0x00000020)
+#define CBUS_MSC_00_msc_wait_arb_mask                                 (0x00000010)
+#define CBUS_MSC_00_ctrl_28_resv_mask                                 (0x0000000F)
+#define CBUS_MSC_00_mcumsc_en(data)                                   (0x00000020&((data)<<5))
+#define CBUS_MSC_00_msc_wait_arb(data)                                (0x00000010&((data)<<4))
+#define CBUS_MSC_00_ctrl_28_resv(data)                                (0x0000000F&(data))
+#define CBUS_MSC_00_get_mcumsc_en(data)                               ((0x00000020&(data))>>5)
+#define CBUS_MSC_00_get_msc_wait_arb(data)                            ((0x00000010&(data))>>4)
+#define CBUS_MSC_00_get_ctrl_28_resv(data)                            (0x0000000F&(data))
+
+
+#define CBUS_MSC_01                                                   0x1800f264
+#define CBUS_MSC_01_reg_addr                                          "0xb800f264"
+#define CBUS_MSC_01_reg                                               0xb800f264
+#define CBUS_MSC_01_inst_addr                                         "0x0099"
+#define CBUS_MSC_01_inst                                              0x0099
+#define CBUS_MSC_01_na_msc_cmd_shift                                  (0)
+#define CBUS_MSC_01_na_msc_cmd_mask                                   (0x000000FF)
+#define CBUS_MSC_01_na_msc_cmd(data)                                  (0x000000FF&(data))
+#define CBUS_MSC_01_get_na_msc_cmd(data)                              (0x000000FF&(data))
+
+
+#define CBUS_MSC_02                                                   0x1800f268
+#define CBUS_MSC_02_reg_addr                                          "0xb800f268"
+#define CBUS_MSC_02_reg                                               0xb800f268
+#define CBUS_MSC_02_inst_addr                                         "0x009A"
+#define CBUS_MSC_02_inst                                              0x009A
+#define CBUS_MSC_02_na_msc_offset_shift                               (0)
+#define CBUS_MSC_02_na_msc_offset_mask                                (0x000000FF)
+#define CBUS_MSC_02_na_msc_offset(data)                               (0x000000FF&(data))
+#define CBUS_MSC_02_get_na_msc_offset(data)                           (0x000000FF&(data))
+
+
+#define CBUS_MSC_03                                                   0x1800f26c
+#define CBUS_MSC_03_reg_addr                                          "0xb800f26c"
+#define CBUS_MSC_03_reg                                               0xb800f26c
+#define CBUS_MSC_03_inst_addr                                         "0x009B"
+#define CBUS_MSC_03_inst                                              0x009B
+#define CBUS_MSC_03_rx_fifo_full_shift                                (7)
+#define CBUS_MSC_03_rx_fifo_empty_shift                               (6)
+#define CBUS_MSC_03_rx_fifo_clr_shift                                 (5)
+#define CBUS_MSC_03_na_rx_len_shift                                   (0)
+#define CBUS_MSC_03_rx_fifo_full_mask                                 (0x00000080)
+#define CBUS_MSC_03_rx_fifo_empty_mask                                (0x00000040)
+#define CBUS_MSC_03_rx_fifo_clr_mask                                  (0x00000020)
+#define CBUS_MSC_03_na_rx_len_mask                                    (0x0000001F)
+#define CBUS_MSC_03_rx_fifo_full(data)                                (0x00000080&((data)<<7))
+#define CBUS_MSC_03_rx_fifo_empty(data)                               (0x00000040&((data)<<6))
+#define CBUS_MSC_03_rx_fifo_clr(data)                                 (0x00000020&((data)<<5))
+#define CBUS_MSC_03_na_rx_len(data)                                   (0x0000001F&(data))
+#define CBUS_MSC_03_get_rx_fifo_full(data)                            ((0x00000080&(data))>>7)
+#define CBUS_MSC_03_get_rx_fifo_empty(data)                           ((0x00000040&(data))>>6)
+#define CBUS_MSC_03_get_rx_fifo_clr(data)                             ((0x00000020&(data))>>5)
+#define CBUS_MSC_03_get_na_rx_len(data)                               (0x0000001F&(data))
+
+
+#define CBUS_MSC_04                                                   0x1800f270
+#define CBUS_MSC_04_reg_addr                                          "0xb800f270"
+#define CBUS_MSC_04_reg                                               0xb800f270
+#define CBUS_MSC_04_inst_addr                                         "0x009C"
+#define CBUS_MSC_04_inst                                              0x009C
+#define CBUS_MSC_04_rx_fifo_data_shift                                (0)
+#define CBUS_MSC_04_rx_fifo_data_mask                                 (0x000000FF)
+#define CBUS_MSC_04_rx_fifo_data(data)                                (0x000000FF&(data))
+#define CBUS_MSC_04_get_rx_fifo_data(data)                            (0x000000FF&(data))
+
+
+#define CBUS_MSC_05                                                   0x1800f274
+#define CBUS_MSC_05_reg_addr                                          "0xb800f274"
+#define CBUS_MSC_05_reg                                               0xb800f274
+#define CBUS_MSC_05_inst_addr                                         "0x009D"
+#define CBUS_MSC_05_inst                                              0x009D
+#define CBUS_MSC_05_fwdef_cmd_rev_shift                               (0)
+#define CBUS_MSC_05_fwdef_cmd_rev_mask                                (0x000000FF)
+#define CBUS_MSC_05_fwdef_cmd_rev(data)                               (0x000000FF&(data))
+#define CBUS_MSC_05_get_fwdef_cmd_rev(data)                           (0x000000FF&(data))
+
+
+#define CBUS_MSC_06                                                   0x1800f278
+#define CBUS_MSC_06_reg_addr                                          "0xb800f278"
+#define CBUS_MSC_06_reg                                               0xb800f278
+#define CBUS_MSC_06_inst_addr                                         "0x009E"
+#define CBUS_MSC_06_inst                                              0x009E
+#define CBUS_MSC_06_ucp_irq_shift                                     (28)
+#define CBUS_MSC_06_ucpk_irq_shift                                    (27)
+#define CBUS_MSC_06_ucpe_irq_shift                                    (26)
+#define CBUS_MSC_06_dcap_rdy_chg_shift                                (25)
+#define CBUS_MSC_06_muted_chg_shift                                   (24)
+#define CBUS_MSC_06_path_en_chg_shift                                 (23)
+#define CBUS_MSC_06_clk_mode_chg_shift                                (22)
+#define CBUS_MSC_06_msge_irq_shift                                    (21)
+#define CBUS_MSC_06_rcp_irq_shift                                     (20)
+#define CBUS_MSC_06_rcpk_irq_shift                                    (19)
+#define CBUS_MSC_06_rcpe_irq_shift                                    (18)
+#define CBUS_MSC_06_rap_irq_shift                                     (17)
+#define CBUS_MSC_06_rapk_irq_shift                                    (16)
+#define CBUS_MSC_06_msg_sub_irq_shift                                 (15)
+#define CBUS_MSC_06_wr_stat_irq_shift                                 (14)
+#define CBUS_MSC_06_rd_devcap_irq_shift                               (13)
+#define CBUS_MSC_06_get_stat_irq_shift                                (12)
+#define CBUS_MSC_06_get_id_irq_shift                                  (11)
+#define CBUS_MSC_06_get_msg_irq_shift                                 (10)
+#define CBUS_MSC_06_sc1_err_irq_shift                                 (9)
+#define CBUS_MSC_06_ddc_err_irq_shift                                 (8)
+#define CBUS_MSC_06_msc_err_irq_shift                                 (7)
+#define CBUS_MSC_06_wr_burst_irq_shift                                (6)
+#define CBUS_MSC_06_sc3_err_irq_shift                                 (5)
+#define CBUS_MSC_06_fwdef_cmd_irq_shift                               (4)
+#define CBUS_MSC_06_allmsc_cmd_irq_shift                              (3)
+#define CBUS_MSC_06_abort_res_irq_shift                               (2)
+#define CBUS_MSC_06_abort_req_irq_shift                               (1)
+#define CBUS_MSC_06_ddc_abort_irq_shift                               (0)
+#define CBUS_MSC_06_ucp_irq_mask                                      (0x10000000)
+#define CBUS_MSC_06_ucpk_irq_mask                                     (0x08000000)
+#define CBUS_MSC_06_ucpe_irq_mask                                     (0x04000000)
+#define CBUS_MSC_06_dcap_rdy_chg_mask                                 (0x02000000)
+#define CBUS_MSC_06_muted_chg_mask                                    (0x01000000)
+#define CBUS_MSC_06_path_en_chg_mask                                  (0x00800000)
+#define CBUS_MSC_06_clk_mode_chg_mask                                 (0x00400000)
+#define CBUS_MSC_06_msge_irq_mask                                     (0x00200000)
+#define CBUS_MSC_06_rcp_irq_mask                                      (0x00100000)
+#define CBUS_MSC_06_rcpk_irq_mask                                     (0x00080000)
+#define CBUS_MSC_06_rcpe_irq_mask                                     (0x00040000)
+#define CBUS_MSC_06_rap_irq_mask                                      (0x00020000)
+#define CBUS_MSC_06_rapk_irq_mask                                     (0x00010000)
+#define CBUS_MSC_06_msg_sub_irq_mask                                  (0x00008000)
+#define CBUS_MSC_06_wr_stat_irq_mask                                  (0x00004000)
+#define CBUS_MSC_06_rd_devcap_irq_mask                                (0x00002000)
+#define CBUS_MSC_06_get_stat_irq_mask                                 (0x00001000)
+#define CBUS_MSC_06_get_id_irq_mask                                   (0x00000800)
+#define CBUS_MSC_06_get_msg_irq_mask                                  (0x00000400)
+#define CBUS_MSC_06_sc1_err_irq_mask                                  (0x00000200)
+#define CBUS_MSC_06_ddc_err_irq_mask                                  (0x00000100)
+#define CBUS_MSC_06_msc_err_irq_mask                                  (0x00000080)
+#define CBUS_MSC_06_wr_burst_irq_mask                                 (0x00000040)
+#define CBUS_MSC_06_sc3_err_irq_mask                                  (0x00000020)
+#define CBUS_MSC_06_fwdef_cmd_irq_mask                                (0x00000010)
+#define CBUS_MSC_06_allmsc_cmd_irq_mask                               (0x00000008)
+#define CBUS_MSC_06_abort_res_irq_mask                                (0x00000004)
+#define CBUS_MSC_06_abort_req_irq_mask                                (0x00000002)
+#define CBUS_MSC_06_ddc_abort_irq_mask                                (0x00000001)
+#define CBUS_MSC_06_ucp_irq(data)                                     (0x10000000&((data)<<28))
+#define CBUS_MSC_06_ucpk_irq(data)                                    (0x08000000&((data)<<27))
+#define CBUS_MSC_06_ucpe_irq(data)                                    (0x04000000&((data)<<26))
+#define CBUS_MSC_06_dcap_rdy_chg(data)                                (0x02000000&((data)<<25))
+#define CBUS_MSC_06_muted_chg(data)                                   (0x01000000&((data)<<24))
+#define CBUS_MSC_06_path_en_chg(data)                                 (0x00800000&((data)<<23))
+#define CBUS_MSC_06_clk_mode_chg(data)                                (0x00400000&((data)<<22))
+#define CBUS_MSC_06_msge_irq(data)                                    (0x00200000&((data)<<21))
+#define CBUS_MSC_06_rcp_irq(data)                                     (0x00100000&((data)<<20))
+#define CBUS_MSC_06_rcpk_irq(data)                                    (0x00080000&((data)<<19))
+#define CBUS_MSC_06_rcpe_irq(data)                                    (0x00040000&((data)<<18))
+#define CBUS_MSC_06_rap_irq(data)                                     (0x00020000&((data)<<17))
+#define CBUS_MSC_06_rapk_irq(data)                                    (0x00010000&((data)<<16))
+#define CBUS_MSC_06_msg_sub_irq(data)                                 (0x00008000&((data)<<15))
+#define CBUS_MSC_06_wr_stat_irq(data)                                 (0x00004000&((data)<<14))
+#define CBUS_MSC_06_rd_devcap_irq(data)                               (0x00002000&((data)<<13))
+#define CBUS_MSC_06_get_stat_irq(data)                                (0x00001000&((data)<<12))
+#define CBUS_MSC_06_get_id_irq(data)                                  (0x00000800&((data)<<11))
+#define CBUS_MSC_06_get_msg_irq(data)                                 (0x00000400&((data)<<10))
+#define CBUS_MSC_06_sc1_err_irq(data)                                 (0x00000200&((data)<<9))
+#define CBUS_MSC_06_ddc_err_irq(data)                                 (0x00000100&((data)<<8))
+#define CBUS_MSC_06_msc_err_irq(data)                                 (0x00000080&((data)<<7))
+#define CBUS_MSC_06_wr_burst_irq(data)                                (0x00000040&((data)<<6))
+#define CBUS_MSC_06_sc3_err_irq(data)                                 (0x00000020&((data)<<5))
+#define CBUS_MSC_06_fwdef_cmd_irq(data)                               (0x00000010&((data)<<4))
+#define CBUS_MSC_06_allmsc_cmd_irq(data)                              (0x00000008&((data)<<3))
+#define CBUS_MSC_06_abort_res_irq(data)                               (0x00000004&((data)<<2))
+#define CBUS_MSC_06_abort_req_irq(data)                               (0x00000002&((data)<<1))
+#define CBUS_MSC_06_ddc_abort_irq(data)                               (0x00000001&(data))
+#define CBUS_MSC_06_get_ucp_irq(data)                                 ((0x10000000&(data))>>28)
+#define CBUS_MSC_06_get_ucpk_irq(data)                                ((0x08000000&(data))>>27)
+#define CBUS_MSC_06_get_ucpe_irq(data)                                ((0x04000000&(data))>>26)
+#define CBUS_MSC_06_get_dcap_rdy_chg(data)                            ((0x02000000&(data))>>25)
+#define CBUS_MSC_06_get_muted_chg(data)                               ((0x01000000&(data))>>24)
+#define CBUS_MSC_06_get_path_en_chg(data)                             ((0x00800000&(data))>>23)
+#define CBUS_MSC_06_get_clk_mode_chg(data)                            ((0x00400000&(data))>>22)
+#define CBUS_MSC_06_get_msge_irq(data)                                ((0x00200000&(data))>>21)
+#define CBUS_MSC_06_get_rcp_irq(data)                                 ((0x00100000&(data))>>20)
+#define CBUS_MSC_06_get_rcpk_irq(data)                                ((0x00080000&(data))>>19)
+#define CBUS_MSC_06_get_rcpe_irq(data)                                ((0x00040000&(data))>>18)
+#define CBUS_MSC_06_get_rap_irq(data)                                 ((0x00020000&(data))>>17)
+#define CBUS_MSC_06_get_rapk_irq(data)                                ((0x00010000&(data))>>16)
+#define CBUS_MSC_06_get_msg_sub_irq(data)                             ((0x00008000&(data))>>15)
+#define CBUS_MSC_06_get_wr_stat_irq(data)                             ((0x00004000&(data))>>14)
+#define CBUS_MSC_06_get_rd_devcap_irq(data)                           ((0x00002000&(data))>>13)
+#define CBUS_MSC_06_get_get_stat_irq(data)                            ((0x00001000&(data))>>12)
+#define CBUS_MSC_06_get_get_id_irq(data)                              ((0x00000800&(data))>>11)
+#define CBUS_MSC_06_get_get_msg_irq(data)                             ((0x00000400&(data))>>10)
+#define CBUS_MSC_06_get_sc1_err_irq(data)                             ((0x00000200&(data))>>9)
+#define CBUS_MSC_06_get_ddc_err_irq(data)                             ((0x00000100&(data))>>8)
+#define CBUS_MSC_06_get_msc_err_irq(data)                             ((0x00000080&(data))>>7)
+#define CBUS_MSC_06_get_wr_burst_irq(data)                            ((0x00000040&(data))>>6)
+#define CBUS_MSC_06_get_sc3_err_irq(data)                             ((0x00000020&(data))>>5)
+#define CBUS_MSC_06_get_fwdef_cmd_irq(data)                           ((0x00000010&(data))>>4)
+#define CBUS_MSC_06_get_allmsc_cmd_irq(data)                          ((0x00000008&(data))>>3)
+#define CBUS_MSC_06_get_abort_res_irq(data)                           ((0x00000004&(data))>>2)
+#define CBUS_MSC_06_get_abort_req_irq(data)                           ((0x00000002&(data))>>1)
+#define CBUS_MSC_06_get_ddc_abort_irq(data)                           (0x00000001&(data))
+
+
+#define CBUS_MSC_07                                                   0x1800f27c
+#define CBUS_MSC_07_reg_addr                                          "0xb800f27c"
+#define CBUS_MSC_07_reg                                               0xb800f27c
+#define CBUS_MSC_07_inst_addr                                         "0x009F"
+#define CBUS_MSC_07_inst                                              0x009F
+#define CBUS_MSC_07_ucp_irq_en_shift                                  (28)
+#define CBUS_MSC_07_ucpk_irq_en_shift                                 (27)
+#define CBUS_MSC_07_ucpe_irq_en_shift                                 (26)
+#define CBUS_MSC_07_dcap_rdy_irq_en_shift                             (25)
+#define CBUS_MSC_07_muted_chg_irq_en_shift                            (24)
+#define CBUS_MSC_07_path_en_irq_en_shift                              (23)
+#define CBUS_MSC_07_clk_mode_irq_en_shift                             (22)
+#define CBUS_MSC_07_msge_irq_en_shift                                 (21)
+#define CBUS_MSC_07_rcp_irq_en_shift                                  (20)
+#define CBUS_MSC_07_rcpk_irq_en_shift                                 (19)
+#define CBUS_MSC_07_rcpe_irq_en_shift                                 (18)
+#define CBUS_MSC_07_rap_irq_en_shift                                  (17)
+#define CBUS_MSC_07_rapk_irq_en_shift                                 (16)
+#define CBUS_MSC_07_msg_sub_irq_en_shift                              (15)
+#define CBUS_MSC_07_wr_stat_irq_en_shift                              (14)
+#define CBUS_MSC_07_rd_devcap_irq_en_shift                            (13)
+#define CBUS_MSC_07_get_stat_irq_en_shift                             (12)
+#define CBUS_MSC_07_get_id_irq_en_shift                               (11)
+#define CBUS_MSC_07_get_msg_irq_en_shift                              (10)
+#define CBUS_MSC_07_sc1_err_irq_en_shift                              (9)
+#define CBUS_MSC_07_ddc_err_irq_en_shift                              (8)
+#define CBUS_MSC_07_msc_err_irq_en_shift                              (7)
+#define CBUS_MSC_07_wr_burst_irq_en_shift                             (6)
+#define CBUS_MSC_07_sc3_err_irq_en_shift                              (5)
+#define CBUS_MSC_07_fwdef_cmd_irq_en_shift                            (4)
+#define CBUS_MSC_07_allmsc_cmd_irq_en_shift                           (3)
+#define CBUS_MSC_07_abort_res_irq_en_shift                            (2)
+#define CBUS_MSC_07_abort_req_irq_en_shift                            (1)
+#define CBUS_MSC_07_ddc_abort_irq_en_shift                            (0)
+#define CBUS_MSC_07_ucp_irq_en_mask                                   (0x10000000)
+#define CBUS_MSC_07_ucpk_irq_en_mask                                  (0x08000000)
+#define CBUS_MSC_07_ucpe_irq_en_mask                                  (0x04000000)
+#define CBUS_MSC_07_dcap_rdy_irq_en_mask                              (0x02000000)
+#define CBUS_MSC_07_muted_chg_irq_en_mask                             (0x01000000)
+#define CBUS_MSC_07_path_en_irq_en_mask                               (0x00800000)
+#define CBUS_MSC_07_clk_mode_irq_en_mask                              (0x00400000)
+#define CBUS_MSC_07_msge_irq_en_mask                                  (0x00200000)
+#define CBUS_MSC_07_rcp_irq_en_mask                                   (0x00100000)
+#define CBUS_MSC_07_rcpk_irq_en_mask                                  (0x00080000)
+#define CBUS_MSC_07_rcpe_irq_en_mask                                  (0x00040000)
+#define CBUS_MSC_07_rap_irq_en_mask                                   (0x00020000)
+#define CBUS_MSC_07_rapk_irq_en_mask                                  (0x00010000)
+#define CBUS_MSC_07_msg_sub_irq_en_mask                               (0x00008000)
+#define CBUS_MSC_07_wr_stat_irq_en_mask                               (0x00004000)
+#define CBUS_MSC_07_rd_devcap_irq_en_mask                             (0x00002000)
+#define CBUS_MSC_07_get_stat_irq_en_mask                              (0x00001000)
+#define CBUS_MSC_07_get_id_irq_en_mask                                (0x00000800)
+#define CBUS_MSC_07_get_msg_irq_en_mask                               (0x00000400)
+#define CBUS_MSC_07_sc1_err_irq_en_mask                               (0x00000200)
+#define CBUS_MSC_07_ddc_err_irq_en_mask                               (0x00000100)
+#define CBUS_MSC_07_msc_err_irq_en_mask                               (0x00000080)
+#define CBUS_MSC_07_wr_burst_irq_en_mask                              (0x00000040)
+#define CBUS_MSC_07_sc3_err_irq_en_mask                               (0x00000020)
+#define CBUS_MSC_07_fwdef_cmd_irq_en_mask                             (0x00000010)
+#define CBUS_MSC_07_allmsc_cmd_irq_en_mask                            (0x00000008)
+#define CBUS_MSC_07_abort_res_irq_en_mask                             (0x00000004)
+#define CBUS_MSC_07_abort_req_irq_en_mask                             (0x00000002)
+#define CBUS_MSC_07_ddc_abort_irq_en_mask                             (0x00000001)
+#define CBUS_MSC_07_ucp_irq_en(data)                                  (0x10000000&((data)<<28))
+#define CBUS_MSC_07_ucpk_irq_en(data)                                 (0x08000000&((data)<<27))
+#define CBUS_MSC_07_ucpe_irq_en(data)                                 (0x04000000&((data)<<26))
+#define CBUS_MSC_07_dcap_rdy_irq_en(data)                             (0x02000000&((data)<<25))
+#define CBUS_MSC_07_muted_chg_irq_en(data)                            (0x01000000&((data)<<24))
+#define CBUS_MSC_07_path_en_irq_en(data)                              (0x00800000&((data)<<23))
+#define CBUS_MSC_07_clk_mode_irq_en(data)                             (0x00400000&((data)<<22))
+#define CBUS_MSC_07_msge_irq_en(data)                                 (0x00200000&((data)<<21))
+#define CBUS_MSC_07_rcp_irq_en(data)                                  (0x00100000&((data)<<20))
+#define CBUS_MSC_07_rcpk_irq_en(data)                                 (0x00080000&((data)<<19))
+#define CBUS_MSC_07_rcpe_irq_en(data)                                 (0x00040000&((data)<<18))
+#define CBUS_MSC_07_rap_irq_en(data)                                  (0x00020000&((data)<<17))
+#define CBUS_MSC_07_rapk_irq_en(data)                                 (0x00010000&((data)<<16))
+#define CBUS_MSC_07_msg_sub_irq_en(data)                              (0x00008000&((data)<<15))
+#define CBUS_MSC_07_wr_stat_irq_en(data)                              (0x00004000&((data)<<14))
+#define CBUS_MSC_07_rd_devcap_irq_en(data)                            (0x00002000&((data)<<13))
+#define CBUS_MSC_07_get_stat_irq_en(data)                             (0x00001000&((data)<<12))
+#define CBUS_MSC_07_get_id_irq_en(data)                               (0x00000800&((data)<<11))
+#define CBUS_MSC_07_get_msg_irq_en(data)                              (0x00000400&((data)<<10))
+#define CBUS_MSC_07_sc1_err_irq_en(data)                              (0x00000200&((data)<<9))
+#define CBUS_MSC_07_ddc_err_irq_en(data)                              (0x00000100&((data)<<8))
+#define CBUS_MSC_07_msc_err_irq_en(data)                              (0x00000080&((data)<<7))
+#define CBUS_MSC_07_wr_burst_irq_en(data)                             (0x00000040&((data)<<6))
+#define CBUS_MSC_07_sc3_err_irq_en(data)                              (0x00000020&((data)<<5))
+#define CBUS_MSC_07_fwdef_cmd_irq_en(data)                            (0x00000010&((data)<<4))
+#define CBUS_MSC_07_allmsc_cmd_irq_en(data)                           (0x00000008&((data)<<3))
+#define CBUS_MSC_07_abort_res_irq_en(data)                            (0x00000004&((data)<<2))
+#define CBUS_MSC_07_abort_req_irq_en(data)                            (0x00000002&((data)<<1))
+#define CBUS_MSC_07_ddc_abort_irq_en(data)                            (0x00000001&(data))
+#define CBUS_MSC_07_get_ucp_irq_en(data)                              ((0x10000000&(data))>>28)
+#define CBUS_MSC_07_get_ucpk_irq_en(data)                             ((0x08000000&(data))>>27)
+#define CBUS_MSC_07_get_ucpe_irq_en(data)                             ((0x04000000&(data))>>26)
+#define CBUS_MSC_07_get_dcap_rdy_irq_en(data)                         ((0x02000000&(data))>>25)
+#define CBUS_MSC_07_get_muted_chg_irq_en(data)                        ((0x01000000&(data))>>24)
+#define CBUS_MSC_07_get_path_en_irq_en(data)                          ((0x00800000&(data))>>23)
+#define CBUS_MSC_07_get_clk_mode_irq_en(data)                         ((0x00400000&(data))>>22)
+#define CBUS_MSC_07_get_msge_irq_en(data)                             ((0x00200000&(data))>>21)
+#define CBUS_MSC_07_get_rcp_irq_en(data)                              ((0x00100000&(data))>>20)
+#define CBUS_MSC_07_get_rcpk_irq_en(data)                             ((0x00080000&(data))>>19)
+#define CBUS_MSC_07_get_rcpe_irq_en(data)                             ((0x00040000&(data))>>18)
+#define CBUS_MSC_07_get_rap_irq_en(data)                              ((0x00020000&(data))>>17)
+#define CBUS_MSC_07_get_rapk_irq_en(data)                             ((0x00010000&(data))>>16)
+#define CBUS_MSC_07_get_msg_sub_irq_en(data)                          ((0x00008000&(data))>>15)
+#define CBUS_MSC_07_get_wr_stat_irq_en(data)                          ((0x00004000&(data))>>14)
+#define CBUS_MSC_07_get_rd_devcap_irq_en(data)                        ((0x00002000&(data))>>13)
+#define CBUS_MSC_07_get_get_stat_irq_en(data)                         ((0x00001000&(data))>>12)
+#define CBUS_MSC_07_get_get_id_irq_en(data)                           ((0x00000800&(data))>>11)
+#define CBUS_MSC_07_get_get_msg_irq_en(data)                          ((0x00000400&(data))>>10)
+#define CBUS_MSC_07_get_sc1_err_irq_en(data)                          ((0x00000200&(data))>>9)
+#define CBUS_MSC_07_get_ddc_err_irq_en(data)                          ((0x00000100&(data))>>8)
+#define CBUS_MSC_07_get_msc_err_irq_en(data)                          ((0x00000080&(data))>>7)
+#define CBUS_MSC_07_get_wr_burst_irq_en(data)                         ((0x00000040&(data))>>6)
+#define CBUS_MSC_07_get_sc3_err_irq_en(data)                          ((0x00000020&(data))>>5)
+#define CBUS_MSC_07_get_fwdef_cmd_irq_en(data)                        ((0x00000010&(data))>>4)
+#define CBUS_MSC_07_get_allmsc_cmd_irq_en(data)                       ((0x00000008&(data))>>3)
+#define CBUS_MSC_07_get_abort_res_irq_en(data)                        ((0x00000004&(data))>>2)
+#define CBUS_MSC_07_get_abort_req_irq_en(data)                        ((0x00000002&(data))>>1)
+#define CBUS_MSC_07_get_ddc_abort_irq_en(data)                        (0x00000001&(data))
+
+
+#define CBUS_MSC_08                                                   0x1800f280
+#define CBUS_MSC_08_reg_addr                                          "0xb800f280"
+#define CBUS_MSC_08_reg                                               0xb800f280
+#define CBUS_MSC_08_inst_addr                                         "0x00A0"
+#define CBUS_MSC_08_inst                                              0x00A0
+#define CBUS_MSC_08_rchg_irq_en_shift                                 (29)
+#define CBUS_MSC_08_cbus_3d_req_irq_en_shift                          (28)
+#define CBUS_MSC_08_grt_irq_en_shift                                  (27)
+#define CBUS_MSC_08_req_irq_en_shift                                  (26)
+#define CBUS_MSC_08_dscr_irq_en_shift                                 (25)
+#define CBUS_MSC_08_dcap_irq_en_shift                                 (24)
+#define CBUS_MSC_08_dchg_bit7_irq_en_shift                            (23)
+#define CBUS_MSC_08_dchg_bit6_irq_en_shift                            (22)
+#define CBUS_MSC_08_dchg_bit5_irq_en_shift                            (21)
+#define CBUS_MSC_08_dchg_bit4_irq_en_shift                            (20)
+#define CBUS_MSC_08_dchg_bit3_irq_en_shift                            (19)
+#define CBUS_MSC_08_dchg_bit2_irq_en_shift                            (18)
+#define CBUS_MSC_08_edid_irq_en_shift                                 (17)
+#define CBUS_MSC_08_dchg_bit0_irq_en_shift                            (16)
+#define CBUS_MSC_08_chg22_irq_en_shift                                (8)
+#define CBUS_MSC_08_chg23_irq_en_shift                                (0)
+#define CBUS_MSC_08_rchg_irq_en_mask                                  (0xE0000000)
+#define CBUS_MSC_08_cbus_3d_req_irq_en_mask                           (0x10000000)
+#define CBUS_MSC_08_grt_irq_en_mask                                   (0x08000000)
+#define CBUS_MSC_08_req_irq_en_mask                                   (0x04000000)
+#define CBUS_MSC_08_dscr_irq_en_mask                                  (0x02000000)
+#define CBUS_MSC_08_dcap_irq_en_mask                                  (0x01000000)
+#define CBUS_MSC_08_dchg_bit7_irq_en_mask                             (0x00800000)
+#define CBUS_MSC_08_dchg_bit6_irq_en_mask                             (0x00400000)
+#define CBUS_MSC_08_dchg_bit5_irq_en_mask                             (0x00200000)
+#define CBUS_MSC_08_dchg_bit4_irq_en_mask                             (0x00100000)
+#define CBUS_MSC_08_dchg_bit3_irq_en_mask                             (0x00080000)
+#define CBUS_MSC_08_dchg_bit2_irq_en_mask                             (0x00040000)
+#define CBUS_MSC_08_edid_irq_en_mask                                  (0x00020000)
+#define CBUS_MSC_08_dchg_bit0_irq_en_mask                             (0x00010000)
+#define CBUS_MSC_08_chg22_irq_en_mask                                 (0x0000FF00)
+#define CBUS_MSC_08_chg23_irq_en_mask                                 (0x000000FF)
+#define CBUS_MSC_08_rchg_irq_en(data)                                 (0xE0000000&((data)<<29))
+#define CBUS_MSC_08_cbus_3d_req_irq_en(data)                          (0x10000000&((data)<<28))
+#define CBUS_MSC_08_grt_irq_en(data)                                  (0x08000000&((data)<<27))
+#define CBUS_MSC_08_req_irq_en(data)                                  (0x04000000&((data)<<26))
+#define CBUS_MSC_08_dscr_irq_en(data)                                 (0x02000000&((data)<<25))
+#define CBUS_MSC_08_dcap_irq_en(data)                                 (0x01000000&((data)<<24))
+#define CBUS_MSC_08_dchg_bit7_irq_en(data)                            (0x00800000&((data)<<23))
+#define CBUS_MSC_08_dchg_bit6_irq_en(data)                            (0x00400000&((data)<<22))
+#define CBUS_MSC_08_dchg_bit5_irq_en(data)                            (0x00200000&((data)<<21))
+#define CBUS_MSC_08_dchg_bit4_irq_en(data)                            (0x00100000&((data)<<20))
+#define CBUS_MSC_08_dchg_bit3_irq_en(data)                            (0x00080000&((data)<<19))
+#define CBUS_MSC_08_dchg_bit2_irq_en(data)                            (0x00040000&((data)<<18))
+#define CBUS_MSC_08_edid_irq_en(data)                                 (0x00020000&((data)<<17))
+#define CBUS_MSC_08_dchg_bit0_irq_en(data)                            (0x00010000&((data)<<16))
+#define CBUS_MSC_08_chg22_irq_en(data)                                (0x0000FF00&((data)<<8))
+#define CBUS_MSC_08_chg23_irq_en(data)                                (0x000000FF&(data))
+#define CBUS_MSC_08_get_rchg_irq_en(data)                             ((0xE0000000&(data))>>29)
+#define CBUS_MSC_08_get_cbus_3d_req_irq_en(data)                      ((0x10000000&(data))>>28)
+#define CBUS_MSC_08_get_grt_irq_en(data)                              ((0x08000000&(data))>>27)
+#define CBUS_MSC_08_get_req_irq_en(data)                              ((0x04000000&(data))>>26)
+#define CBUS_MSC_08_get_dscr_irq_en(data)                             ((0x02000000&(data))>>25)
+#define CBUS_MSC_08_get_dcap_irq_en(data)                             ((0x01000000&(data))>>24)
+#define CBUS_MSC_08_get_dchg_bit7_irq_en(data)                        ((0x00800000&(data))>>23)
+#define CBUS_MSC_08_get_dchg_bit6_irq_en(data)                        ((0x00400000&(data))>>22)
+#define CBUS_MSC_08_get_dchg_bit5_irq_en(data)                        ((0x00200000&(data))>>21)
+#define CBUS_MSC_08_get_dchg_bit4_irq_en(data)                        ((0x00100000&(data))>>20)
+#define CBUS_MSC_08_get_dchg_bit3_irq_en(data)                        ((0x00080000&(data))>>19)
+#define CBUS_MSC_08_get_dchg_bit2_irq_en(data)                        ((0x00040000&(data))>>18)
+#define CBUS_MSC_08_get_edid_irq_en(data)                             ((0x00020000&(data))>>17)
+#define CBUS_MSC_08_get_dchg_bit0_irq_en(data)                        ((0x00010000&(data))>>16)
+#define CBUS_MSC_08_get_chg22_irq_en(data)                            ((0x0000FF00&(data))>>8)
+#define CBUS_MSC_08_get_chg23_irq_en(data)                            (0x000000FF&(data))
+
+
+#define CBUS_MSC_09                                                   0x1800f284
+#define CBUS_MSC_09_reg_addr                                          "0xb800f284"
+#define CBUS_MSC_09_reg                                               0xb800f284
+#define CBUS_MSC_09_inst_addr                                         "0x00A1"
+#define CBUS_MSC_09_inst                                              0x00A1
+#define CBUS_MSC_09_chg24_irq_en_shift                                (24)
+#define CBUS_MSC_09_chg25_irq_en_shift                                (16)
+#define CBUS_MSC_09_chg26_irq_en_shift                                (8)
+#define CBUS_MSC_09_chg27_irq_en_shift                                (0)
+#define CBUS_MSC_09_chg24_irq_en_mask                                 (0xFF000000)
+#define CBUS_MSC_09_chg25_irq_en_mask                                 (0x00FF0000)
+#define CBUS_MSC_09_chg26_irq_en_mask                                 (0x0000FF00)
+#define CBUS_MSC_09_chg27_irq_en_mask                                 (0x000000FF)
+#define CBUS_MSC_09_chg24_irq_en(data)                                (0xFF000000&((data)<<24))
+#define CBUS_MSC_09_chg25_irq_en(data)                                (0x00FF0000&((data)<<16))
+#define CBUS_MSC_09_chg26_irq_en(data)                                (0x0000FF00&((data)<<8))
+#define CBUS_MSC_09_chg27_irq_en(data)                                (0x000000FF&(data))
+#define CBUS_MSC_09_get_chg24_irq_en(data)                            ((0xFF000000&(data))>>24)
+#define CBUS_MSC_09_get_chg25_irq_en(data)                            ((0x00FF0000&(data))>>16)
+#define CBUS_MSC_09_get_chg26_irq_en(data)                            ((0x0000FF00&(data))>>8)
+#define CBUS_MSC_09_get_chg27_irq_en(data)                            (0x000000FF&(data))
+
+
+#define CBUS_MSC_0A                                                   0x1800f288
+#define CBUS_MSC_0A_reg_addr                                          "0xb800f288"
+#define CBUS_MSC_0A_reg                                               0xb800f288
+#define CBUS_MSC_0A_inst_addr                                         "0x00A2"
+#define CBUS_MSC_0A_inst                                              0x00A2
+#define CBUS_MSC_0A_msc_err_code_shift                                (0)
+#define CBUS_MSC_0A_msc_err_code_mask                                 (0x000000FF)
+#define CBUS_MSC_0A_msc_err_code(data)                                (0x000000FF&(data))
+#define CBUS_MSC_0A_get_msc_err_code(data)                            (0x000000FF&(data))
+
+
+#define CBUS_MSC_0B                                                   0x1800f28c
+#define CBUS_MSC_0B_reg_addr                                          "0xb800f28c"
+#define CBUS_MSC_0B_reg                                               0xb800f28c
+#define CBUS_MSC_0B_inst_addr                                         "0x00A3"
+#define CBUS_MSC_0B_inst                                              0x00A3
+#define CBUS_MSC_0B_rcp_reply_abort_shift                             (9)
+#define CBUS_MSC_0B_rcp_reply_nack_shift                              (8)
+#define CBUS_MSC_0B_vendor_id_shift                                   (0)
+#define CBUS_MSC_0B_rcp_reply_abort_mask                              (0x00000200)
+#define CBUS_MSC_0B_rcp_reply_nack_mask                               (0x00000100)
+#define CBUS_MSC_0B_vendor_id_mask                                    (0x000000FF)
+#define CBUS_MSC_0B_rcp_reply_abort(data)                             (0x00000200&((data)<<9))
+#define CBUS_MSC_0B_rcp_reply_nack(data)                              (0x00000100&((data)<<8))
+#define CBUS_MSC_0B_vendor_id(data)                                   (0x000000FF&(data))
+#define CBUS_MSC_0B_get_rcp_reply_abort(data)                         ((0x00000200&(data))>>9)
+#define CBUS_MSC_0B_get_rcp_reply_nack(data)                          ((0x00000100&(data))>>8)
+#define CBUS_MSC_0B_get_vendor_id(data)                               (0x000000FF&(data))
+
+
+#define CBUS_MSC_0C                                                   0x1800f290
+#define CBUS_MSC_0C_reg_addr                                          "0xb800f290"
+#define CBUS_MSC_0C_reg                                               0xb800f290
+#define CBUS_MSC_0C_inst_addr                                         "0x00A4"
+#define CBUS_MSC_0C_inst                                              0x00A4
+#define CBUS_MSC_0C_msg_cmd_shift                                     (0)
+#define CBUS_MSC_0C_msg_cmd_mask                                      (0x000000FF)
+#define CBUS_MSC_0C_msg_cmd(data)                                     (0x000000FF&(data))
+#define CBUS_MSC_0C_get_msg_cmd(data)                                 (0x000000FF&(data))
+
+
+#define CBUS_MSC_0D                                                   0x1800f294
+#define CBUS_MSC_0D_reg_addr                                          "0xb800f294"
+#define CBUS_MSC_0D_reg                                               0xb800f294
+#define CBUS_MSC_0D_inst_addr                                         "0x00A5"
+#define CBUS_MSC_0D_inst                                              0x00A5
+#define CBUS_MSC_0D_msg_dat_shift                                     (0)
+#define CBUS_MSC_0D_msg_dat_mask                                      (0x000000FF)
+#define CBUS_MSC_0D_msg_dat(data)                                     (0x000000FF&(data))
+#define CBUS_MSC_0D_get_msg_dat(data)                                 (0x000000FF&(data))
+
+
+#define CBUS_MSC_0E                                                   0x1800f298
+#define CBUS_MSC_0E_reg_addr                                          "0xb800f298"
+#define CBUS_MSC_0E_reg                                               0xb800f298
+#define CBUS_MSC_0E_inst_addr                                         "0x00A6"
+#define CBUS_MSC_0E_inst                                              0x00A6
+#define CBUS_MSC_0E_msge_rcv_shift                                    (0)
+#define CBUS_MSC_0E_msge_rcv_mask                                     (0x000000FF)
+#define CBUS_MSC_0E_msge_rcv(data)                                    (0x000000FF&(data))
+#define CBUS_MSC_0E_get_msge_rcv(data)                                (0x000000FF&(data))
+
+
+#define CBUS_MSC_0F                                                   0x1800f29c
+#define CBUS_MSC_0F_reg_addr                                          "0xb800f29c"
+#define CBUS_MSC_0F_reg                                               0xb800f29c
+#define CBUS_MSC_0F_inst_addr                                         "0x00A7"
+#define CBUS_MSC_0F_inst                                              0x00A7
+#define CBUS_MSC_0F_rcp_rcv_shift                                     (0)
+#define CBUS_MSC_0F_rcp_rcv_mask                                      (0x000000FF)
+#define CBUS_MSC_0F_rcp_rcv(data)                                     (0x000000FF&(data))
+#define CBUS_MSC_0F_get_rcp_rcv(data)                                 (0x000000FF&(data))
+
+
+#define CBUS_MSC_10                                                   0x1800f2a0
+#define CBUS_MSC_10_reg_addr                                          "0xb800f2a0"
+#define CBUS_MSC_10_reg                                               0xb800f2a0
+#define CBUS_MSC_10_inst_addr                                         "0x00A8"
+#define CBUS_MSC_10_inst                                              0x00A8
+#define CBUS_MSC_10_rcpk_rcv_shift                                    (0)
+#define CBUS_MSC_10_rcpk_rcv_mask                                     (0x000000FF)
+#define CBUS_MSC_10_rcpk_rcv(data)                                    (0x000000FF&(data))
+#define CBUS_MSC_10_get_rcpk_rcv(data)                                (0x000000FF&(data))
+
+
+#define CBUS_MSC_11                                                   0x1800f2a4
+#define CBUS_MSC_11_reg_addr                                          "0xb800f2a4"
+#define CBUS_MSC_11_reg                                               0xb800f2a4
+#define CBUS_MSC_11_inst_addr                                         "0x00A9"
+#define CBUS_MSC_11_inst                                              0x00A9
+#define CBUS_MSC_11_rcpe_rcv_shift                                    (0)
+#define CBUS_MSC_11_rcpe_rcv_mask                                     (0x000000FF)
+#define CBUS_MSC_11_rcpe_rcv(data)                                    (0x000000FF&(data))
+#define CBUS_MSC_11_get_rcpe_rcv(data)                                (0x000000FF&(data))
+
+
+#define CBUS_MSC_12                                                   0x1800f2a8
+#define CBUS_MSC_12_reg_addr                                          "0xb800f2a8"
+#define CBUS_MSC_12_reg                                               0xb800f2a8
+#define CBUS_MSC_12_inst_addr                                         "0x00AA"
+#define CBUS_MSC_12_inst                                              0x00AA
+#define CBUS_MSC_12_rap_rcv_shift                                     (0)
+#define CBUS_MSC_12_rap_rcv_mask                                      (0x000000FF)
+#define CBUS_MSC_12_rap_rcv(data)                                     (0x000000FF&(data))
+#define CBUS_MSC_12_get_rap_rcv(data)                                 (0x000000FF&(data))
+
+
+#define CBUS_MSC_13                                                   0x1800f2ac
+#define CBUS_MSC_13_reg_addr                                          "0xb800f2ac"
+#define CBUS_MSC_13_reg                                               0xb800f2ac
+#define CBUS_MSC_13_inst_addr                                         "0x00AB"
+#define CBUS_MSC_13_inst                                              0x00AB
+#define CBUS_MSC_13_rapk_rcv_shift                                    (0)
+#define CBUS_MSC_13_rapk_rcv_mask                                     (0x000000FF)
+#define CBUS_MSC_13_rapk_rcv(data)                                    (0x000000FF&(data))
+#define CBUS_MSC_13_get_rapk_rcv(data)                                (0x000000FF&(data))
+
+
+#define CBUS_MSC_14                                                   0x1800f2b0
+#define CBUS_MSC_14_reg_addr                                          "0xb800f2b0"
+#define CBUS_MSC_14_reg                                               0xb800f2b0
+#define CBUS_MSC_14_inst_addr                                         "0x00AC"
+#define CBUS_MSC_14_inst                                              0x00AC
+#define CBUS_MSC_14_burst_timeout_shift                               (5)
+#define CBUS_MSC_14_wb_id_chk_shift                                   (4)
+#define CBUS_MSC_14_burst_wait_shift                                  (0)
+#define CBUS_MSC_14_burst_timeout_mask                                (0x00000020)
+#define CBUS_MSC_14_wb_id_chk_mask                                    (0x00000010)
+#define CBUS_MSC_14_burst_wait_mask                                   (0x0000000F)
+#define CBUS_MSC_14_burst_timeout(data)                               (0x00000020&((data)<<5))
+#define CBUS_MSC_14_wb_id_chk(data)                                   (0x00000010&((data)<<4))
+#define CBUS_MSC_14_burst_wait(data)                                  (0x0000000F&(data))
+#define CBUS_MSC_14_get_burst_timeout(data)                           ((0x00000020&(data))>>5)
+#define CBUS_MSC_14_get_wb_id_chk(data)                               ((0x00000010&(data))>>4)
+#define CBUS_MSC_14_get_burst_wait(data)                              (0x0000000F&(data))
+
+
+#define CBUS_MSC_15                                                   0x1800f2b4
+#define CBUS_MSC_15_reg_addr                                          "0xb800f2b4"
+#define CBUS_MSC_15_reg                                               0xb800f2b4
+#define CBUS_MSC_15_inst_addr                                         "0x00AD"
+#define CBUS_MSC_15_inst                                              0x00AD
+#define CBUS_MSC_15_adop_idh_rcv_shift                                (8)
+#define CBUS_MSC_15_adop_idl_rcv_shift                                (0)
+#define CBUS_MSC_15_adop_idh_rcv_mask                                 (0x0000FF00)
+#define CBUS_MSC_15_adop_idl_rcv_mask                                 (0x000000FF)
+#define CBUS_MSC_15_adop_idh_rcv(data)                                (0x0000FF00&((data)<<8))
+#define CBUS_MSC_15_adop_idl_rcv(data)                                (0x000000FF&(data))
+#define CBUS_MSC_15_get_adop_idh_rcv(data)                            ((0x0000FF00&(data))>>8)
+#define CBUS_MSC_15_get_adop_idl_rcv(data)                            (0x000000FF&(data))
+
+
+#define CBUS_MSC_16                                                   0x1800f2b8
+#define CBUS_MSC_16_reg_addr                                          "0xb800f2b8"
+#define CBUS_MSC_16_reg                                               0xb800f2b8
+#define CBUS_MSC_16_inst_addr                                         "0x00AE"
+#define CBUS_MSC_16_inst                                              0x00AE
+#define CBUS_MSC_16_auto_handshake_shift                              (29)
+#define CBUS_MSC_16_insert_id_shift                                   (28)
+#define CBUS_MSC_16_wb_byte_num0_shift                                (22)
+#define CBUS_MSC_16_wb_byte_num1_shift                                (16)
+#define CBUS_MSC_16_adop_txid_h_shift                                 (8)
+#define CBUS_MSC_16_adop_txid_l_shift                                 (0)
+#define CBUS_MSC_16_auto_handshake_mask                               (0x20000000)
+#define CBUS_MSC_16_insert_id_mask                                    (0x10000000)
+#define CBUS_MSC_16_wb_byte_num0_mask                                 (0x0FC00000)
+#define CBUS_MSC_16_wb_byte_num1_mask                                 (0x003F0000)
+#define CBUS_MSC_16_adop_txid_h_mask                                  (0x0000FF00)
+#define CBUS_MSC_16_adop_txid_l_mask                                  (0x000000FF)
+#define CBUS_MSC_16_auto_handshake(data)                              (0x20000000&((data)<<29))
+#define CBUS_MSC_16_insert_id(data)                                   (0x10000000&((data)<<28))
+#define CBUS_MSC_16_wb_byte_num0(data)                                (0x0FC00000&((data)<<22))
+#define CBUS_MSC_16_wb_byte_num1(data)                                (0x003F0000&((data)<<16))
+#define CBUS_MSC_16_adop_txid_h(data)                                 (0x0000FF00&((data)<<8))
+#define CBUS_MSC_16_adop_txid_l(data)                                 (0x000000FF&(data))
+#define CBUS_MSC_16_get_auto_handshake(data)                          ((0x20000000&(data))>>29)
+#define CBUS_MSC_16_get_insert_id(data)                               ((0x10000000&(data))>>28)
+#define CBUS_MSC_16_get_wb_byte_num0(data)                            ((0x0FC00000&(data))>>22)
+#define CBUS_MSC_16_get_wb_byte_num1(data)                            ((0x003F0000&(data))>>16)
+#define CBUS_MSC_16_get_adop_txid_h(data)                             ((0x0000FF00&(data))>>8)
+#define CBUS_MSC_16_get_adop_txid_l(data)                             (0x000000FF&(data))
+
+
+#define CBUS_MSC_17                                                   0x1800f2bc
+#define CBUS_MSC_17_reg_addr                                          "0xb800f2bc"
+#define CBUS_MSC_17_reg                                               0xb800f2bc
+#define CBUS_MSC_17_inst_addr                                         "0x00AF"
+#define CBUS_MSC_17_inst                                              0x00AF
+#define CBUS_MSC_17_que_fsm_clr_shift                                 (2)
+#define CBUS_MSC_17_sch_fsm_clr_shift                                 (1)
+#define CBUS_MSC_17_spi_fsm_clr_shift                                 (0)
+#define CBUS_MSC_17_que_fsm_clr_mask                                  (0x00000004)
+#define CBUS_MSC_17_sch_fsm_clr_mask                                  (0x00000002)
+#define CBUS_MSC_17_spi_fsm_clr_mask                                  (0x00000001)
+#define CBUS_MSC_17_que_fsm_clr(data)                                 (0x00000004&((data)<<2))
+#define CBUS_MSC_17_sch_fsm_clr(data)                                 (0x00000002&((data)<<1))
+#define CBUS_MSC_17_spi_fsm_clr(data)                                 (0x00000001&(data))
+#define CBUS_MSC_17_get_que_fsm_clr(data)                             ((0x00000004&(data))>>2)
+#define CBUS_MSC_17_get_sch_fsm_clr(data)                             ((0x00000002&(data))>>1)
+#define CBUS_MSC_17_get_spi_fsm_clr(data)                             (0x00000001&(data))
+
+
+#define CBUS_MSC_18                                                   0x1800f2c0
+#define CBUS_MSC_18_reg_addr                                          "0xb800f2c0"
+#define CBUS_MSC_18_reg                                               0xb800f2c0
+#define CBUS_MSC_18_inst_addr                                         "0x00B0"
+#define CBUS_MSC_18_inst                                              0x00B0
+#define CBUS_MSC_18_que_fsm_shift                                     (8)
+#define CBUS_MSC_18_sch_fsm_shift                                     (4)
+#define CBUS_MSC_18_spi_fsm_shift                                     (0)
+#define CBUS_MSC_18_que_fsm_mask                                      (0x00000F00)
+#define CBUS_MSC_18_sch_fsm_mask                                      (0x000000F0)
+#define CBUS_MSC_18_spi_fsm_mask                                      (0x0000000F)
+#define CBUS_MSC_18_que_fsm(data)                                     (0x00000F00&((data)<<8))
+#define CBUS_MSC_18_sch_fsm(data)                                     (0x000000F0&((data)<<4))
+#define CBUS_MSC_18_spi_fsm(data)                                     (0x0000000F&(data))
+#define CBUS_MSC_18_get_que_fsm(data)                                 ((0x00000F00&(data))>>8)
+#define CBUS_MSC_18_get_sch_fsm(data)                                 ((0x000000F0&(data))>>4)
+#define CBUS_MSC_18_get_spi_fsm(data)                                 (0x0000000F&(data))
+
+
+#define CBUS_MSC_19                                                   0x1800f2c4
+#define CBUS_MSC_19_reg_addr                                          "0xb800f2c4"
+#define CBUS_MSC_19_reg                                               0xb800f2c4
+#define CBUS_MSC_19_inst_addr                                         "0x00B1"
+#define CBUS_MSC_19_inst                                              0x00B1
+#define CBUS_MSC_19_cap_offset_shift                                  (0)
+#define CBUS_MSC_19_cap_offset_mask                                   (0x000000FF)
+#define CBUS_MSC_19_cap_offset(data)                                  (0x000000FF&(data))
+#define CBUS_MSC_19_get_cap_offset(data)                              (0x000000FF&(data))
+
+
+#define CBUS_MSC_1A                                                   0x1800f2c8
+#define CBUS_MSC_1A_reg_addr                                          "0xb800f2c8"
+#define CBUS_MSC_1A_reg                                               0xb800f2c8
+#define CBUS_MSC_1A_inst_addr                                         "0x00B2"
+#define CBUS_MSC_1A_inst                                              0x00B2
+#define CBUS_MSC_1A_int_offset_shift                                  (0)
+#define CBUS_MSC_1A_int_offset_mask                                   (0x000000FF)
+#define CBUS_MSC_1A_int_offset(data)                                  (0x000000FF&(data))
+#define CBUS_MSC_1A_get_int_offset(data)                              (0x000000FF&(data))
+
+
+#define CBUS_MSC_1B                                                   0x1800f2cc
+#define CBUS_MSC_1B_reg_addr                                          "0xb800f2cc"
+#define CBUS_MSC_1B_reg                                               0xb800f2cc
+#define CBUS_MSC_1B_inst_addr                                         "0x00B3"
+#define CBUS_MSC_1B_inst                                              0x00B3
+#define CBUS_MSC_1B_sta_offset_shift                                  (0)
+#define CBUS_MSC_1B_sta_offset_mask                                   (0x000000FF)
+#define CBUS_MSC_1B_sta_offset(data)                                  (0x000000FF&(data))
+#define CBUS_MSC_1B_get_sta_offset(data)                              (0x000000FF&(data))
+
+
+#define CBUS_MSC_1C                                                   0x1800f2d0
+#define CBUS_MSC_1C_reg_addr                                          "0xb800f2d0"
+#define CBUS_MSC_1C_reg                                               0xb800f2d0
+#define CBUS_MSC_1C_inst_addr                                         "0x00B4"
+#define CBUS_MSC_1C_inst                                              0x00B4
+#define CBUS_MSC_1C_scr_offset_shift                                  (0)
+#define CBUS_MSC_1C_scr_offset_mask                                   (0x000000FF)
+#define CBUS_MSC_1C_scr_offset(data)                                  (0x000000FF&(data))
+#define CBUS_MSC_1C_get_scr_offset(data)                              (0x000000FF&(data))
+
+
+#define CBUS_MSC_1D                                                   0x1800f2d4
+#define CBUS_MSC_1D_reg_addr                                          "0xb800f2d4"
+#define CBUS_MSC_1D_reg                                               0xb800f2d4
+#define CBUS_MSC_1D_inst_addr                                         "0x00B5"
+#define CBUS_MSC_1D_inst                                              0x00B5
+#define CBUS_MSC_1D_ddc_err_force_shift                               (1)
+#define CBUS_MSC_1D_msc_err_force_shift                               (0)
+#define CBUS_MSC_1D_ddc_err_force_mask                                (0x00000002)
+#define CBUS_MSC_1D_msc_err_force_mask                                (0x00000001)
+#define CBUS_MSC_1D_ddc_err_force(data)                               (0x00000002&((data)<<1))
+#define CBUS_MSC_1D_msc_err_force(data)                               (0x00000001&(data))
+#define CBUS_MSC_1D_get_ddc_err_force(data)                           ((0x00000002&(data))>>1)
+#define CBUS_MSC_1D_get_msc_err_force(data)                           (0x00000001&(data))
+
+
+#define CBUS_MSC_1E                                                   0x1800f2d8
+#define CBUS_MSC_1E_reg_addr                                          "0xb800f2d8"
+#define CBUS_MSC_1E_reg                                               0xb800f2d8
+#define CBUS_MSC_1E_inst_addr                                         "0x00B6"
+#define CBUS_MSC_1E_inst                                              0x00B6
+#define CBUS_MSC_1E_ddc_err_fw_shift                                  (0)
+#define CBUS_MSC_1E_ddc_err_fw_mask                                   (0x000000FF)
+#define CBUS_MSC_1E_ddc_err_fw(data)                                  (0x000000FF&(data))
+#define CBUS_MSC_1E_get_ddc_err_fw(data)                              (0x000000FF&(data))
+
+
+#define CBUS_MSC_1F                                                   0x1800f2dc
+#define CBUS_MSC_1F_reg_addr                                          "0xb800f2dc"
+#define CBUS_MSC_1F_reg                                               0xb800f2dc
+#define CBUS_MSC_1F_inst_addr                                         "0x00B7"
+#define CBUS_MSC_1F_inst                                              0x00B7
+#define CBUS_MSC_1F_msc_err_fw_shift                                  (0)
+#define CBUS_MSC_1F_msc_err_fw_mask                                   (0x000000FF)
+#define CBUS_MSC_1F_msc_err_fw(data)                                  (0x000000FF&(data))
+#define CBUS_MSC_1F_get_msc_err_fw(data)                              (0x000000FF&(data))
+
+
+#define CBUS_MSC_20                                                   0x1800f2e0
+#define CBUS_MSC_20_reg_addr                                          "0xb800f2e0"
+#define CBUS_MSC_20_reg                                               0xb800f2e0
+#define CBUS_MSC_20_inst_addr                                         "0x00B8"
+#define CBUS_MSC_20_inst                                              0x00B8
+#define CBUS_MSC_20_ucp_rcv_shift                                     (0)
+#define CBUS_MSC_20_ucp_rcv_mask                                      (0x000000FF)
+#define CBUS_MSC_20_ucp_rcv(data)                                     (0x000000FF&(data))
+#define CBUS_MSC_20_get_ucp_rcv(data)                                 (0x000000FF&(data))
+
+
+#define CBUS_MSC_21                                                   0x1800f2e4
+#define CBUS_MSC_21_reg_addr                                          "0xb800f2e4"
+#define CBUS_MSC_21_reg                                               0xb800f2e4
+#define CBUS_MSC_21_inst_addr                                         "0x00B9"
+#define CBUS_MSC_21_inst                                              0x00B9
+#define CBUS_MSC_21_ucpk_rcv_shift                                    (0)
+#define CBUS_MSC_21_ucpk_rcv_mask                                     (0x000000FF)
+#define CBUS_MSC_21_ucpk_rcv(data)                                    (0x000000FF&(data))
+#define CBUS_MSC_21_get_ucpk_rcv(data)                                (0x000000FF&(data))
+
+
+#define CBUS_MSC_22                                                   0x1800f2e8
+#define CBUS_MSC_22_reg_addr                                          "0xb800f2e8"
+#define CBUS_MSC_22_reg                                               0xb800f2e8
+#define CBUS_MSC_22_inst_addr                                         "0x00BA"
+#define CBUS_MSC_22_inst                                              0x00BA
+#define CBUS_MSC_22_ucpe_rcv_shift                                    (0)
+#define CBUS_MSC_22_ucpe_rcv_mask                                     (0x000000FF)
+#define CBUS_MSC_22_ucpe_rcv(data)                                    (0x000000FF&(data))
+#define CBUS_MSC_22_get_ucpe_rcv(data)                                (0x000000FF&(data))
+
+
+#define FW0_REQ_00                                                    0x1800f300
+#define FW0_REQ_00_reg_addr                                           "0xb800f300"
+#define FW0_REQ_00_reg                                                0xb800f300
+#define FW0_REQ_00_inst_addr                                          "0x00C0"
+#define FW0_REQ_00_inst                                               0x00C0
+#define FW0_REQ_00_fw0_req_shift                                      (8)
+#define FW0_REQ_00_fw0_fifo_clr_shift                                 (7)
+#define FW0_REQ_00_fw0_fifo_full_shift                                (6)
+#define FW0_REQ_00_fw0_fifo_empty_shift                               (5)
+#define FW0_REQ_00_fw0_tx_case_shift                                  (2)
+#define FW0_REQ_00_fw0_head_shift                                     (0)
+#define FW0_REQ_00_fw0_req_mask                                       (0x00000100)
+#define FW0_REQ_00_fw0_fifo_clr_mask                                  (0x00000080)
+#define FW0_REQ_00_fw0_fifo_full_mask                                 (0x00000040)
+#define FW0_REQ_00_fw0_fifo_empty_mask                                (0x00000020)
+#define FW0_REQ_00_fw0_tx_case_mask                                   (0x0000001C)
+#define FW0_REQ_00_fw0_head_mask                                      (0x00000003)
+#define FW0_REQ_00_fw0_req(data)                                      (0x00000100&((data)<<8))
+#define FW0_REQ_00_fw0_fifo_clr(data)                                 (0x00000080&((data)<<7))
+#define FW0_REQ_00_fw0_fifo_full(data)                                (0x00000040&((data)<<6))
+#define FW0_REQ_00_fw0_fifo_empty(data)                               (0x00000020&((data)<<5))
+#define FW0_REQ_00_fw0_tx_case(data)                                  (0x0000001C&((data)<<2))
+#define FW0_REQ_00_fw0_head(data)                                     (0x00000003&(data))
+#define FW0_REQ_00_get_fw0_req(data)                                  ((0x00000100&(data))>>8)
+#define FW0_REQ_00_get_fw0_fifo_clr(data)                             ((0x00000080&(data))>>7)
+#define FW0_REQ_00_get_fw0_fifo_full(data)                            ((0x00000040&(data))>>6)
+#define FW0_REQ_00_get_fw0_fifo_empty(data)                           ((0x00000020&(data))>>5)
+#define FW0_REQ_00_get_fw0_tx_case(data)                              ((0x0000001C&(data))>>2)
+#define FW0_REQ_00_get_fw0_head(data)                                 (0x00000003&(data))
+
+
+#define FW0_REQ_01                                                    0x1800f304
+#define FW0_REQ_01_reg_addr                                           "0xb800f304"
+#define FW0_REQ_01_reg                                                0xb800f304
+#define FW0_REQ_01_inst_addr                                          "0x00C1"
+#define FW0_REQ_01_inst                                               0x00C1
+#define FW0_REQ_01_fw0_cmd1_shift                                     (0)
+#define FW0_REQ_01_fw0_cmd1_mask                                      (0x000000FF)
+#define FW0_REQ_01_fw0_cmd1(data)                                     (0x000000FF&(data))
+#define FW0_REQ_01_get_fw0_cmd1(data)                                 (0x000000FF&(data))
+
+
+#define FW0_REQ_02                                                    0x1800f308
+#define FW0_REQ_02_reg_addr                                           "0xb800f308"
+#define FW0_REQ_02_reg                                                0xb800f308
+#define FW0_REQ_02_inst_addr                                          "0x00C2"
+#define FW0_REQ_02_inst                                               0x00C2
+#define FW0_REQ_02_fw0_cmd2_shift                                     (0)
+#define FW0_REQ_02_fw0_cmd2_mask                                      (0x000000FF)
+#define FW0_REQ_02_fw0_cmd2(data)                                     (0x000000FF&(data))
+#define FW0_REQ_02_get_fw0_cmd2(data)                                 (0x000000FF&(data))
+
+
+#define FW0_REQ_03                                                    0x1800f30c
+#define FW0_REQ_03_reg_addr                                           "0xb800f30c"
+#define FW0_REQ_03_reg                                                0xb800f30c
+#define FW0_REQ_03_inst_addr                                          "0x00C3"
+#define FW0_REQ_03_inst                                               0x00C3
+#define FW0_REQ_03_fw0_offset_shift                                   (0)
+#define FW0_REQ_03_fw0_offset_mask                                    (0x000000FF)
+#define FW0_REQ_03_fw0_offset(data)                                   (0x000000FF&(data))
+#define FW0_REQ_03_get_fw0_offset(data)                               (0x000000FF&(data))
+
+
+#define FW0_REQ_04                                                    0x1800f310
+#define FW0_REQ_04_reg_addr                                           "0xb800f310"
+#define FW0_REQ_04_reg                                                0xb800f310
+#define FW0_REQ_04_inst_addr                                          "0x00C4"
+#define FW0_REQ_04_inst                                               0x00C4
+#define FW0_REQ_04_fw0_data_shift                                     (0)
+#define FW0_REQ_04_fw0_data_mask                                      (0x000000FF)
+#define FW0_REQ_04_fw0_data(data)                                     (0x000000FF&(data))
+#define FW0_REQ_04_get_fw0_data(data)                                 (0x000000FF&(data))
+
+
+#define FW0_REQ_05                                                    0x1800f314
+#define FW0_REQ_05_reg_addr                                           "0xb800f314"
+#define FW0_REQ_05_reg                                                0xb800f314
+#define FW0_REQ_05_inst_addr                                          "0x00C5"
+#define FW0_REQ_05_inst                                               0x00C5
+#define FW0_REQ_05_fw0_rty_ovr_shift                                  (9)
+#define FW0_REQ_05_fw0_fin_shift                                      (8)
+#define FW0_REQ_05_fw0_cmd_event_shift                                (7)
+#define FW0_REQ_05_fw0_data_event_shift                               (6)
+#define FW0_REQ_05_fw0_rcv_err_shift                                  (5)
+#define FW0_REQ_05_fw0_fin_irq_en_shift                               (4)
+#define FW0_REQ_05_fw0_cmd_irq_en_shift                               (3)
+#define FW0_REQ_05_fw0_data_irq_en_shift                              (2)
+#define FW0_REQ_05_fw0_wait_case_shift                                (0)
+#define FW0_REQ_05_fw0_rty_ovr_mask                                   (0x00000200)
+#define FW0_REQ_05_fw0_fin_mask                                       (0x00000100)
+#define FW0_REQ_05_fw0_cmd_event_mask                                 (0x00000080)
+#define FW0_REQ_05_fw0_data_event_mask                                (0x00000040)
+#define FW0_REQ_05_fw0_rcv_err_mask                                   (0x00000020)
+#define FW0_REQ_05_fw0_fin_irq_en_mask                                (0x00000010)
+#define FW0_REQ_05_fw0_cmd_irq_en_mask                                (0x00000008)
+#define FW0_REQ_05_fw0_data_irq_en_mask                               (0x00000004)
+#define FW0_REQ_05_fw0_wait_case_mask                                 (0x00000003)
+#define FW0_REQ_05_fw0_rty_ovr(data)                                  (0x00000200&((data)<<9))
+#define FW0_REQ_05_fw0_fin(data)                                      (0x00000100&((data)<<8))
+#define FW0_REQ_05_fw0_cmd_event(data)                                (0x00000080&((data)<<7))
+#define FW0_REQ_05_fw0_data_event(data)                               (0x00000040&((data)<<6))
+#define FW0_REQ_05_fw0_rcv_err(data)                                  (0x00000020&((data)<<5))
+#define FW0_REQ_05_fw0_fin_irq_en(data)                               (0x00000010&((data)<<4))
+#define FW0_REQ_05_fw0_cmd_irq_en(data)                               (0x00000008&((data)<<3))
+#define FW0_REQ_05_fw0_data_irq_en(data)                              (0x00000004&((data)<<2))
+#define FW0_REQ_05_fw0_wait_case(data)                                (0x00000003&(data))
+#define FW0_REQ_05_get_fw0_rty_ovr(data)                              ((0x00000200&(data))>>9)
+#define FW0_REQ_05_get_fw0_fin(data)                                  ((0x00000100&(data))>>8)
+#define FW0_REQ_05_get_fw0_cmd_event(data)                            ((0x00000080&(data))>>7)
+#define FW0_REQ_05_get_fw0_data_event(data)                           ((0x00000040&(data))>>6)
+#define FW0_REQ_05_get_fw0_rcv_err(data)                              ((0x00000020&(data))>>5)
+#define FW0_REQ_05_get_fw0_fin_irq_en(data)                           ((0x00000010&(data))>>4)
+#define FW0_REQ_05_get_fw0_cmd_irq_en(data)                           ((0x00000008&(data))>>3)
+#define FW0_REQ_05_get_fw0_data_irq_en(data)                          ((0x00000004&(data))>>2)
+#define FW0_REQ_05_get_fw0_wait_case(data)                            (0x00000003&(data))
+
+
+#define FW0_REQ_06                                                    0x1800f318
+#define FW0_REQ_06_reg_addr                                           "0xb800f318"
+#define FW0_REQ_06_reg                                                0xb800f318
+#define FW0_REQ_06_inst_addr                                          "0x00C6"
+#define FW0_REQ_06_inst                                               0x00C6
+#define FW0_REQ_06_fw0_cmd_rcv_shift                                  (0)
+#define FW0_REQ_06_fw0_cmd_rcv_mask                                   (0x000000FF)
+#define FW0_REQ_06_fw0_cmd_rcv(data)                                  (0x000000FF&(data))
+#define FW0_REQ_06_get_fw0_cmd_rcv(data)                              (0x000000FF&(data))
+
+
+#define FW0_REQ_07                                                    0x1800f31c
+#define FW0_REQ_07_reg_addr                                           "0xb800f31c"
+#define FW0_REQ_07_reg                                                0xb800f31c
+#define FW0_REQ_07_inst_addr                                          "0x00C7"
+#define FW0_REQ_07_inst                                               0x00C7
+#define FW0_REQ_07_fw0_data_rcv_shift                                 (0)
+#define FW0_REQ_07_fw0_data_rcv_mask                                  (0x000000FF)
+#define FW0_REQ_07_fw0_data_rcv(data)                                 (0x000000FF&(data))
+#define FW0_REQ_07_get_fw0_data_rcv(data)                             (0x000000FF&(data))
+
+
+#define FW0_REQ_08                                                    0x1800f320
+#define FW0_REQ_08_reg_addr                                           "0xb800f320"
+#define FW0_REQ_08_reg                                                0xb800f320
+#define FW0_REQ_08_inst_addr                                          "0x00C8"
+#define FW0_REQ_08_inst                                               0x00C8
+#define FW0_REQ_08_fw0_rd_en_shift                                    (13)
+#define FW0_REQ_08_fw0_fifo_len_shift                                 (8)
+#define FW0_REQ_08_fw0_rdata_shift                                    (0)
+#define FW0_REQ_08_fw0_rd_en_mask                                     (0x00002000)
+#define FW0_REQ_08_fw0_fifo_len_mask                                  (0x00001F00)
+#define FW0_REQ_08_fw0_rdata_mask                                     (0x000000FF)
+#define FW0_REQ_08_fw0_rd_en(data)                                    (0x00002000&((data)<<13))
+#define FW0_REQ_08_fw0_fifo_len(data)                                 (0x00001F00&((data)<<8))
+#define FW0_REQ_08_fw0_rdata(data)                                    (0x000000FF&(data))
+#define FW0_REQ_08_get_fw0_rd_en(data)                                ((0x00002000&(data))>>13)
+#define FW0_REQ_08_get_fw0_fifo_len(data)                             ((0x00001F00&(data))>>8)
+#define FW0_REQ_08_get_fw0_rdata(data)                                (0x000000FF&(data))
+
+
+#define FW1_REQ_00                                                    0x1800f340
+#define FW1_REQ_00_reg_addr                                           "0xb800f340"
+#define FW1_REQ_00_reg                                                0xb800f340
+#define FW1_REQ_00_inst_addr                                          "0x00D0"
+#define FW1_REQ_00_inst                                               0x00D0
+#define FW1_REQ_00_fw1_req_shift                                      (8)
+#define FW1_REQ_00_fw1_fifo_clr_shift                                 (7)
+#define FW1_REQ_00_fw1_fifo_full_shift                                (6)
+#define FW1_REQ_00_fw1_fifo_empty_shift                               (5)
+#define FW1_REQ_00_fw1_tx_case_shift                                  (2)
+#define FW1_REQ_00_fw1_head_shift                                     (0)
+#define FW1_REQ_00_fw1_req_mask                                       (0x00000100)
+#define FW1_REQ_00_fw1_fifo_clr_mask                                  (0x00000080)
+#define FW1_REQ_00_fw1_fifo_full_mask                                 (0x00000040)
+#define FW1_REQ_00_fw1_fifo_empty_mask                                (0x00000020)
+#define FW1_REQ_00_fw1_tx_case_mask                                   (0x0000001C)
+#define FW1_REQ_00_fw1_head_mask                                      (0x00000003)
+#define FW1_REQ_00_fw1_req(data)                                      (0x00000100&((data)<<8))
+#define FW1_REQ_00_fw1_fifo_clr(data)                                 (0x00000080&((data)<<7))
+#define FW1_REQ_00_fw1_fifo_full(data)                                (0x00000040&((data)<<6))
+#define FW1_REQ_00_fw1_fifo_empty(data)                               (0x00000020&((data)<<5))
+#define FW1_REQ_00_fw1_tx_case(data)                                  (0x0000001C&((data)<<2))
+#define FW1_REQ_00_fw1_head(data)                                     (0x00000003&(data))
+#define FW1_REQ_00_get_fw1_req(data)                                  ((0x00000100&(data))>>8)
+#define FW1_REQ_00_get_fw1_fifo_clr(data)                             ((0x00000080&(data))>>7)
+#define FW1_REQ_00_get_fw1_fifo_full(data)                            ((0x00000040&(data))>>6)
+#define FW1_REQ_00_get_fw1_fifo_empty(data)                           ((0x00000020&(data))>>5)
+#define FW1_REQ_00_get_fw1_tx_case(data)                              ((0x0000001C&(data))>>2)
+#define FW1_REQ_00_get_fw1_head(data)                                 (0x00000003&(data))
+
+
+#define FW1_REQ_01                                                    0x1800f344
+#define FW1_REQ_01_reg_addr                                           "0xb800f344"
+#define FW1_REQ_01_reg                                                0xb800f344
+#define FW1_REQ_01_inst_addr                                          "0x00D1"
+#define FW1_REQ_01_inst                                               0x00D1
+#define FW1_REQ_01_fw1_cmd1_shift                                     (0)
+#define FW1_REQ_01_fw1_cmd1_mask                                      (0x000000FF)
+#define FW1_REQ_01_fw1_cmd1(data)                                     (0x000000FF&(data))
+#define FW1_REQ_01_get_fw1_cmd1(data)                                 (0x000000FF&(data))
+
+
+#define FW1_REQ_02                                                    0x1800f348
+#define FW1_REQ_02_reg_addr                                           "0xb800f348"
+#define FW1_REQ_02_reg                                                0xb800f348
+#define FW1_REQ_02_inst_addr                                          "0x00D2"
+#define FW1_REQ_02_inst                                               0x00D2
+#define FW1_REQ_02_fw1_cmd2_shift                                     (0)
+#define FW1_REQ_02_fw1_cmd2_mask                                      (0x000000FF)
+#define FW1_REQ_02_fw1_cmd2(data)                                     (0x000000FF&(data))
+#define FW1_REQ_02_get_fw1_cmd2(data)                                 (0x000000FF&(data))
+
+
+#define FW1_REQ_03                                                    0x1800f34c
+#define FW1_REQ_03_reg_addr                                           "0xb800f34c"
+#define FW1_REQ_03_reg                                                0xb800f34c
+#define FW1_REQ_03_inst_addr                                          "0x00D3"
+#define FW1_REQ_03_inst                                               0x00D3
+#define FW1_REQ_03_fw1_offset_shift                                   (0)
+#define FW1_REQ_03_fw1_offset_mask                                    (0x000000FF)
+#define FW1_REQ_03_fw1_offset(data)                                   (0x000000FF&(data))
+#define FW1_REQ_03_get_fw1_offset(data)                               (0x000000FF&(data))
+
+
+#define FW1_REQ_04                                                    0x1800f350
+#define FW1_REQ_04_reg_addr                                           "0xb800f350"
+#define FW1_REQ_04_reg                                                0xb800f350
+#define FW1_REQ_04_inst_addr                                          "0x00D4"
+#define FW1_REQ_04_inst                                               0x00D4
+#define FW1_REQ_04_fw1_data_shift                                     (0)
+#define FW1_REQ_04_fw1_data_mask                                      (0x000000FF)
+#define FW1_REQ_04_fw1_data(data)                                     (0x000000FF&(data))
+#define FW1_REQ_04_get_fw1_data(data)                                 (0x000000FF&(data))
+
+
+#define FW1_REQ_05                                                    0x1800f354
+#define FW1_REQ_05_reg_addr                                           "0xb800f354"
+#define FW1_REQ_05_reg                                                0xb800f354
+#define FW1_REQ_05_inst_addr                                          "0x00D5"
+#define FW1_REQ_05_inst                                               0x00D5
+#define FW1_REQ_05_fw1_rty_ovr_shift                                  (9)
+#define FW1_REQ_05_fw1_fin_shift                                      (8)
+#define FW1_REQ_05_fw1_cmd_event_shift                                (7)
+#define FW1_REQ_05_fw1_data_event_shift                               (6)
+#define FW1_REQ_05_fw1_rcv_err_shift                                  (5)
+#define FW1_REQ_05_fw1_fin_irq_en_shift                               (4)
+#define FW1_REQ_05_fw1_cmd_irq_en_shift                               (3)
+#define FW1_REQ_05_fw1_data_irq_en_shift                              (2)
+#define FW1_REQ_05_fw1_wait_case_shift                                (0)
+#define FW1_REQ_05_fw1_rty_ovr_mask                                   (0x00000200)
+#define FW1_REQ_05_fw1_fin_mask                                       (0x00000100)
+#define FW1_REQ_05_fw1_cmd_event_mask                                 (0x00000080)
+#define FW1_REQ_05_fw1_data_event_mask                                (0x00000040)
+#define FW1_REQ_05_fw1_rcv_err_mask                                   (0x00000020)
+#define FW1_REQ_05_fw1_fin_irq_en_mask                                (0x00000010)
+#define FW1_REQ_05_fw1_cmd_irq_en_mask                                (0x00000008)
+#define FW1_REQ_05_fw1_data_irq_en_mask                               (0x00000004)
+#define FW1_REQ_05_fw1_wait_case_mask                                 (0x00000003)
+#define FW1_REQ_05_fw1_rty_ovr(data)                                  (0x00000200&((data)<<9))
+#define FW1_REQ_05_fw1_fin(data)                                      (0x00000100&((data)<<8))
+#define FW1_REQ_05_fw1_cmd_event(data)                                (0x00000080&((data)<<7))
+#define FW1_REQ_05_fw1_data_event(data)                               (0x00000040&((data)<<6))
+#define FW1_REQ_05_fw1_rcv_err(data)                                  (0x00000020&((data)<<5))
+#define FW1_REQ_05_fw1_fin_irq_en(data)                               (0x00000010&((data)<<4))
+#define FW1_REQ_05_fw1_cmd_irq_en(data)                               (0x00000008&((data)<<3))
+#define FW1_REQ_05_fw1_data_irq_en(data)                              (0x00000004&((data)<<2))
+#define FW1_REQ_05_fw1_wait_case(data)                                (0x00000003&(data))
+#define FW1_REQ_05_get_fw1_rty_ovr(data)                              ((0x00000200&(data))>>9)
+#define FW1_REQ_05_get_fw1_fin(data)                                  ((0x00000100&(data))>>8)
+#define FW1_REQ_05_get_fw1_cmd_event(data)                            ((0x00000080&(data))>>7)
+#define FW1_REQ_05_get_fw1_data_event(data)                           ((0x00000040&(data))>>6)
+#define FW1_REQ_05_get_fw1_rcv_err(data)                              ((0x00000020&(data))>>5)
+#define FW1_REQ_05_get_fw1_fin_irq_en(data)                           ((0x00000010&(data))>>4)
+#define FW1_REQ_05_get_fw1_cmd_irq_en(data)                           ((0x00000008&(data))>>3)
+#define FW1_REQ_05_get_fw1_data_irq_en(data)                          ((0x00000004&(data))>>2)
+#define FW1_REQ_05_get_fw1_wait_case(data)                            (0x00000003&(data))
+
+
+#define FW1_REQ_06                                                    0x1800f358
+#define FW1_REQ_06_reg_addr                                           "0xb800f358"
+#define FW1_REQ_06_reg                                                0xb800f358
+#define FW1_REQ_06_inst_addr                                          "0x00D6"
+#define FW1_REQ_06_inst                                               0x00D6
+#define FW1_REQ_06_fw1_cmd_rcv_shift                                  (0)
+#define FW1_REQ_06_fw1_cmd_rcv_mask                                   (0x000000FF)
+#define FW1_REQ_06_fw1_cmd_rcv(data)                                  (0x000000FF&(data))
+#define FW1_REQ_06_get_fw1_cmd_rcv(data)                              (0x000000FF&(data))
+
+
+#define FW1_REQ_07                                                    0x1800f35c
+#define FW1_REQ_07_reg_addr                                           "0xb800f35c"
+#define FW1_REQ_07_reg                                                0xb800f35c
+#define FW1_REQ_07_inst_addr                                          "0x00D7"
+#define FW1_REQ_07_inst                                               0x00D7
+#define FW1_REQ_07_fw1_data_rcv_shift                                 (0)
+#define FW1_REQ_07_fw1_data_rcv_mask                                  (0x000000FF)
+#define FW1_REQ_07_fw1_data_rcv(data)                                 (0x000000FF&(data))
+#define FW1_REQ_07_get_fw1_data_rcv(data)                             (0x000000FF&(data))
+
+
+#define FW1_REQ_08                                                    0x1800f360
+#define FW1_REQ_08_reg_addr                                           "0xb800f360"
+#define FW1_REQ_08_reg                                                0xb800f360
+#define FW1_REQ_08_inst_addr                                          "0x00D8"
+#define FW1_REQ_08_inst                                               0x00D8
+#define FW1_REQ_08_fw1_rd_en_shift                                    (13)
+#define FW1_REQ_08_fw1_fifo_len_shift                                 (8)
+#define FW1_REQ_08_fw1_rdata_shift                                    (0)
+#define FW1_REQ_08_fw1_rd_en_mask                                     (0x00002000)
+#define FW1_REQ_08_fw1_fifo_len_mask                                  (0x00001F00)
+#define FW1_REQ_08_fw1_rdata_mask                                     (0x000000FF)
+#define FW1_REQ_08_fw1_rd_en(data)                                    (0x00002000&((data)<<13))
+#define FW1_REQ_08_fw1_fifo_len(data)                                 (0x00001F00&((data)<<8))
+#define FW1_REQ_08_fw1_rdata(data)                                    (0x000000FF&(data))
+#define FW1_REQ_08_get_fw1_rd_en(data)                                ((0x00002000&(data))>>13)
+#define FW1_REQ_08_get_fw1_fifo_len(data)                             ((0x00001F00&(data))>>8)
+#define FW1_REQ_08_get_fw1_rdata(data)                                (0x000000FF&(data))
+
+
+#define FW2_REQ_00                                                    0x1800f380
+#define FW2_REQ_00_reg_addr                                           "0xb800f380"
+#define FW2_REQ_00_reg                                                0xb800f380
+#define FW2_REQ_00_inst_addr                                          "0x00E0"
+#define FW2_REQ_00_inst                                               0x00E0
+#define FW2_REQ_00_fw2_req_shift                                      (8)
+#define FW2_REQ_00_fw2_fifo_clr_shift                                 (7)
+#define FW2_REQ_00_fw2_fifo_full_shift                                (6)
+#define FW2_REQ_00_fw2_fifo_empty_shift                               (5)
+#define FW2_REQ_00_fw2_tx_case_shift                                  (2)
+#define FW2_REQ_00_fw2_head_shift                                     (0)
+#define FW2_REQ_00_fw2_req_mask                                       (0x00000100)
+#define FW2_REQ_00_fw2_fifo_clr_mask                                  (0x00000080)
+#define FW2_REQ_00_fw2_fifo_full_mask                                 (0x00000040)
+#define FW2_REQ_00_fw2_fifo_empty_mask                                (0x00000020)
+#define FW2_REQ_00_fw2_tx_case_mask                                   (0x0000001C)
+#define FW2_REQ_00_fw2_head_mask                                      (0x00000003)
+#define FW2_REQ_00_fw2_req(data)                                      (0x00000100&((data)<<8))
+#define FW2_REQ_00_fw2_fifo_clr(data)                                 (0x00000080&((data)<<7))
+#define FW2_REQ_00_fw2_fifo_full(data)                                (0x00000040&((data)<<6))
+#define FW2_REQ_00_fw2_fifo_empty(data)                               (0x00000020&((data)<<5))
+#define FW2_REQ_00_fw2_tx_case(data)                                  (0x0000001C&((data)<<2))
+#define FW2_REQ_00_fw2_head(data)                                     (0x00000003&(data))
+#define FW2_REQ_00_get_fw2_req(data)                                  ((0x00000100&(data))>>8)
+#define FW2_REQ_00_get_fw2_fifo_clr(data)                             ((0x00000080&(data))>>7)
+#define FW2_REQ_00_get_fw2_fifo_full(data)                            ((0x00000040&(data))>>6)
+#define FW2_REQ_00_get_fw2_fifo_empty(data)                           ((0x00000020&(data))>>5)
+#define FW2_REQ_00_get_fw2_tx_case(data)                              ((0x0000001C&(data))>>2)
+#define FW2_REQ_00_get_fw2_head(data)                                 (0x00000003&(data))
+
+
+#define FW2_REQ_01                                                    0x1800f384
+#define FW2_REQ_01_reg_addr                                           "0xb800f384"
+#define FW2_REQ_01_reg                                                0xb800f384
+#define FW2_REQ_01_inst_addr                                          "0x00E1"
+#define FW2_REQ_01_inst                                               0x00E1
+#define FW2_REQ_01_fw2_cmd1_shift                                     (0)
+#define FW2_REQ_01_fw2_cmd1_mask                                      (0x000000FF)
+#define FW2_REQ_01_fw2_cmd1(data)                                     (0x000000FF&(data))
+#define FW2_REQ_01_get_fw2_cmd1(data)                                 (0x000000FF&(data))
+
+
+#define FW2_REQ_02                                                    0x1800f388
+#define FW2_REQ_02_reg_addr                                           "0xb800f388"
+#define FW2_REQ_02_reg                                                0xb800f388
+#define FW2_REQ_02_inst_addr                                          "0x00E2"
+#define FW2_REQ_02_inst                                               0x00E2
+#define FW2_REQ_02_fw2_cmd2_shift                                     (0)
+#define FW2_REQ_02_fw2_cmd2_mask                                      (0x000000FF)
+#define FW2_REQ_02_fw2_cmd2(data)                                     (0x000000FF&(data))
+#define FW2_REQ_02_get_fw2_cmd2(data)                                 (0x000000FF&(data))
+
+
+#define FW2_REQ_03                                                    0x1800f38c
+#define FW2_REQ_03_reg_addr                                           "0xb800f38c"
+#define FW2_REQ_03_reg                                                0xb800f38c
+#define FW2_REQ_03_inst_addr                                          "0x00E3"
+#define FW2_REQ_03_inst                                               0x00E3
+#define FW2_REQ_03_fw2_offset_shift                                   (0)
+#define FW2_REQ_03_fw2_offset_mask                                    (0x000000FF)
+#define FW2_REQ_03_fw2_offset(data)                                   (0x000000FF&(data))
+#define FW2_REQ_03_get_fw2_offset(data)                               (0x000000FF&(data))
+
+
+#define FW2_REQ_04                                                    0x1800f390
+#define FW2_REQ_04_reg_addr                                           "0xb800f390"
+#define FW2_REQ_04_reg                                                0xb800f390
+#define FW2_REQ_04_inst_addr                                          "0x00E4"
+#define FW2_REQ_04_inst                                               0x00E4
+#define FW2_REQ_04_fw2_data_shift                                     (0)
+#define FW2_REQ_04_fw2_data_mask                                      (0x000000FF)
+#define FW2_REQ_04_fw2_data(data)                                     (0x000000FF&(data))
+#define FW2_REQ_04_get_fw2_data(data)                                 (0x000000FF&(data))
+
+
+#define FW2_REQ_05                                                    0x1800f394
+#define FW2_REQ_05_reg_addr                                           "0xb800f394"
+#define FW2_REQ_05_reg                                                0xb800f394
+#define FW2_REQ_05_inst_addr                                          "0x00E5"
+#define FW2_REQ_05_inst                                               0x00E5
+#define FW2_REQ_05_fw2_rty_ovr_shift                                  (9)
+#define FW2_REQ_05_fw2_fin_shift                                      (8)
+#define FW2_REQ_05_fw2_cmd_event_shift                                (7)
+#define FW2_REQ_05_fw2_data_event_shift                               (6)
+#define FW2_REQ_05_fw2_rcv_err_shift                                  (5)
+#define FW2_REQ_05_fw2_fin_irq_en_shift                               (4)
+#define FW2_REQ_05_fw2_cmd_irq_en_shift                               (3)
+#define FW2_REQ_05_fw2_data_irq_en_shift                              (2)
+#define FW2_REQ_05_fw2_wait_case_shift                                (0)
+#define FW2_REQ_05_fw2_rty_ovr_mask                                   (0x00000200)
+#define FW2_REQ_05_fw2_fin_mask                                       (0x00000100)
+#define FW2_REQ_05_fw2_cmd_event_mask                                 (0x00000080)
+#define FW2_REQ_05_fw2_data_event_mask                                (0x00000040)
+#define FW2_REQ_05_fw2_rcv_err_mask                                   (0x00000020)
+#define FW2_REQ_05_fw2_fin_irq_en_mask                                (0x00000010)
+#define FW2_REQ_05_fw2_cmd_irq_en_mask                                (0x00000008)
+#define FW2_REQ_05_fw2_data_irq_en_mask                               (0x00000004)
+#define FW2_REQ_05_fw2_wait_case_mask                                 (0x00000003)
+#define FW2_REQ_05_fw2_rty_ovr(data)                                  (0x00000200&((data)<<9))
+#define FW2_REQ_05_fw2_fin(data)                                      (0x00000100&((data)<<8))
+#define FW2_REQ_05_fw2_cmd_event(data)                                (0x00000080&((data)<<7))
+#define FW2_REQ_05_fw2_data_event(data)                               (0x00000040&((data)<<6))
+#define FW2_REQ_05_fw2_rcv_err(data)                                  (0x00000020&((data)<<5))
+#define FW2_REQ_05_fw2_fin_irq_en(data)                               (0x00000010&((data)<<4))
+#define FW2_REQ_05_fw2_cmd_irq_en(data)                               (0x00000008&((data)<<3))
+#define FW2_REQ_05_fw2_data_irq_en(data)                              (0x00000004&((data)<<2))
+#define FW2_REQ_05_fw2_wait_case(data)                                (0x00000003&(data))
+#define FW2_REQ_05_get_fw2_rty_ovr(data)                              ((0x00000200&(data))>>9)
+#define FW2_REQ_05_get_fw2_fin(data)                                  ((0x00000100&(data))>>8)
+#define FW2_REQ_05_get_fw2_cmd_event(data)                            ((0x00000080&(data))>>7)
+#define FW2_REQ_05_get_fw2_data_event(data)                           ((0x00000040&(data))>>6)
+#define FW2_REQ_05_get_fw2_rcv_err(data)                              ((0x00000020&(data))>>5)
+#define FW2_REQ_05_get_fw2_fin_irq_en(data)                           ((0x00000010&(data))>>4)
+#define FW2_REQ_05_get_fw2_cmd_irq_en(data)                           ((0x00000008&(data))>>3)
+#define FW2_REQ_05_get_fw2_data_irq_en(data)                          ((0x00000004&(data))>>2)
+#define FW2_REQ_05_get_fw2_wait_case(data)                            (0x00000003&(data))
+
+
+#define FW2_REQ_06                                                    0x1800f398
+#define FW2_REQ_06_reg_addr                                           "0xb800f398"
+#define FW2_REQ_06_reg                                                0xb800f398
+#define FW2_REQ_06_inst_addr                                          "0x00E6"
+#define FW2_REQ_06_inst                                               0x00E6
+#define FW2_REQ_06_fw2_cmd_rcv_shift                                  (0)
+#define FW2_REQ_06_fw2_cmd_rcv_mask                                   (0x000000FF)
+#define FW2_REQ_06_fw2_cmd_rcv(data)                                  (0x000000FF&(data))
+#define FW2_REQ_06_get_fw2_cmd_rcv(data)                              (0x000000FF&(data))
+
+
+#define FW2_REQ_07                                                    0x1800f39c
+#define FW2_REQ_07_reg_addr                                           "0xb800f39c"
+#define FW2_REQ_07_reg                                                0xb800f39c
+#define FW2_REQ_07_inst_addr                                          "0x00E7"
+#define FW2_REQ_07_inst                                               0x00E7
+#define FW2_REQ_07_fw2_data_rcv_shift                                 (0)
+#define FW2_REQ_07_fw2_data_rcv_mask                                  (0x000000FF)
+#define FW2_REQ_07_fw2_data_rcv(data)                                 (0x000000FF&(data))
+#define FW2_REQ_07_get_fw2_data_rcv(data)                             (0x000000FF&(data))
+
+
+#define FW2_REQ_08                                                    0x1800f3a0
+#define FW2_REQ_08_reg_addr                                           "0xb800f3a0"
+#define FW2_REQ_08_reg                                                0xb800f3a0
+#define FW2_REQ_08_inst_addr                                          "0x00E8"
+#define FW2_REQ_08_inst                                               0x00E8
+#define FW2_REQ_08_fw2_rd_en_shift                                    (13)
+#define FW2_REQ_08_fw2_fifo_len_shift                                 (8)
+#define FW2_REQ_08_fw2_rdata_shift                                    (0)
+#define FW2_REQ_08_fw2_rd_en_mask                                     (0x00002000)
+#define FW2_REQ_08_fw2_fifo_len_mask                                  (0x00001F00)
+#define FW2_REQ_08_fw2_rdata_mask                                     (0x000000FF)
+#define FW2_REQ_08_fw2_rd_en(data)                                    (0x00002000&((data)<<13))
+#define FW2_REQ_08_fw2_fifo_len(data)                                 (0x00001F00&((data)<<8))
+#define FW2_REQ_08_fw2_rdata(data)                                    (0x000000FF&(data))
+#define FW2_REQ_08_get_fw2_rd_en(data)                                ((0x00002000&(data))>>13)
+#define FW2_REQ_08_get_fw2_fifo_len(data)                             ((0x00001F00&(data))>>8)
+#define FW2_REQ_08_get_fw2_rdata(data)                                (0x000000FF&(data))
+
+
+#define CBUS_DDC_00                                                   0x1800f3c0
+#define CBUS_DDC_00_reg_addr                                          "0xb800f3c0"
+#define CBUS_DDC_00_reg                                               0xb800f3c0
+#define CBUS_DDC_00_inst_addr                                         "0x00F0"
+#define CBUS_DDC_00_inst                                              0x00F0
+#define CBUS_DDC_00_ddc_err_code_shift                                (0)
+#define CBUS_DDC_00_ddc_err_code_mask                                 (0x000000FF)
+#define CBUS_DDC_00_ddc_err_code(data)                                (0x000000FF&(data))
+#define CBUS_DDC_00_get_ddc_err_code(data)                            (0x000000FF&(data))
+
+
+#define CBUS_DDC_01                                                   0x1800f3c4
+#define CBUS_DDC_01_reg_addr                                          "0xb800f3c4"
+#define CBUS_DDC_01_reg                                               0xb800f3c4
+#define CBUS_DDC_01_inst_addr                                         "0x00F1"
+#define CBUS_DDC_01_inst                                              0x00F1
+#define CBUS_DDC_01_iic_ck_tgt_shift                                  (0)
+#define CBUS_DDC_01_iic_ck_tgt_mask                                   (0x000000FF)
+#define CBUS_DDC_01_iic_ck_tgt(data)                                  (0x000000FF&(data))
+#define CBUS_DDC_01_get_iic_ck_tgt(data)                              (0x000000FF&(data))
+
+
+#define CBUS_DDC_02                                                   0x1800f3c8
+#define CBUS_DDC_02_reg_addr                                          "0xb800f3c8"
+#define CBUS_DDC_02_reg                                               0xb800f3c8
+#define CBUS_DDC_02_inst_addr                                         "0x00F2"
+#define CBUS_DDC_02_inst                                              0x00F2
+#define CBUS_DDC_02_mcuddc_en_shift                                   (7)
+#define CBUS_DDC_02_ddc_prior_dis_shift                               (6)
+#define CBUS_DDC_02_ddc_cmd_event_shift                               (5)
+#define CBUS_DDC_02_ddc_data_event_shift                              (4)
+#define CBUS_DDC_02_ddc_cmd_irq_en_shift                              (3)
+#define CBUS_DDC_02_ddc_data_irq_en_shift                             (2)
+#define CBUS_DDC_02_ddc_req_ctrl_shift                                (1)
+#define CBUS_DDC_02_ddc_req_shift                                     (0)
+#define CBUS_DDC_02_mcuddc_en_mask                                    (0x00000080)
+#define CBUS_DDC_02_ddc_prior_dis_mask                                (0x00000040)
+#define CBUS_DDC_02_ddc_cmd_event_mask                                (0x00000020)
+#define CBUS_DDC_02_ddc_data_event_mask                               (0x00000010)
+#define CBUS_DDC_02_ddc_cmd_irq_en_mask                               (0x00000008)
+#define CBUS_DDC_02_ddc_data_irq_en_mask                              (0x00000004)
+#define CBUS_DDC_02_ddc_req_ctrl_mask                                 (0x00000002)
+#define CBUS_DDC_02_ddc_req_mask                                      (0x00000001)
+#define CBUS_DDC_02_mcuddc_en(data)                                   (0x00000080&((data)<<7))
+#define CBUS_DDC_02_ddc_prior_dis(data)                               (0x00000040&((data)<<6))
+#define CBUS_DDC_02_ddc_cmd_event(data)                               (0x00000020&((data)<<5))
+#define CBUS_DDC_02_ddc_data_event(data)                              (0x00000010&((data)<<4))
+#define CBUS_DDC_02_ddc_cmd_irq_en(data)                              (0x00000008&((data)<<3))
+#define CBUS_DDC_02_ddc_data_irq_en(data)                             (0x00000004&((data)<<2))
+#define CBUS_DDC_02_ddc_req_ctrl(data)                                (0x00000002&((data)<<1))
+#define CBUS_DDC_02_ddc_req(data)                                     (0x00000001&(data))
+#define CBUS_DDC_02_get_mcuddc_en(data)                               ((0x00000080&(data))>>7)
+#define CBUS_DDC_02_get_ddc_prior_dis(data)                           ((0x00000040&(data))>>6)
+#define CBUS_DDC_02_get_ddc_cmd_event(data)                           ((0x00000020&(data))>>5)
+#define CBUS_DDC_02_get_ddc_data_event(data)                          ((0x00000010&(data))>>4)
+#define CBUS_DDC_02_get_ddc_cmd_irq_en(data)                          ((0x00000008&(data))>>3)
+#define CBUS_DDC_02_get_ddc_data_irq_en(data)                         ((0x00000004&(data))>>2)
+#define CBUS_DDC_02_get_ddc_req_ctrl(data)                            ((0x00000002&(data))>>1)
+#define CBUS_DDC_02_get_ddc_req(data)                                 (0x00000001&(data))
+
+
+#define CBUS_DDC_03                                                   0x1800f3cc
+#define CBUS_DDC_03_reg_addr                                          "0xb800f3cc"
+#define CBUS_DDC_03_reg                                               0xb800f3cc
+#define CBUS_DDC_03_inst_addr                                         "0x00F3"
+#define CBUS_DDC_03_inst                                              0x00F3
+#define CBUS_DDC_03_ddc_rcv_cmd_shift                                 (0)
+#define CBUS_DDC_03_ddc_rcv_cmd_mask                                  (0x000000FF)
+#define CBUS_DDC_03_ddc_rcv_cmd(data)                                 (0x000000FF&(data))
+#define CBUS_DDC_03_get_ddc_rcv_cmd(data)                             (0x000000FF&(data))
+
+
+#define CBUS_DDC_04                                                   0x1800f3d0
+#define CBUS_DDC_04_reg_addr                                          "0xb800f3d0"
+#define CBUS_DDC_04_reg                                               0xb800f3d0
+#define CBUS_DDC_04_inst_addr                                         "0x00F4"
+#define CBUS_DDC_04_inst                                              0x00F4
+#define CBUS_DDC_04_ddc_rcv_data_shift                                (0)
+#define CBUS_DDC_04_ddc_rcv_data_mask                                 (0x000000FF)
+#define CBUS_DDC_04_ddc_rcv_data(data)                                (0x000000FF&(data))
+#define CBUS_DDC_04_get_ddc_rcv_data(data)                            (0x000000FF&(data))
+
+
+#define CBUS_DDC_05                                                   0x1800f3d4
+#define CBUS_DDC_05_reg_addr                                          "0xb800f3d4"
+#define CBUS_DDC_05_reg                                               0xb800f3d4
+#define CBUS_DDC_05_inst_addr                                         "0x00F5"
+#define CBUS_DDC_05_inst                                              0x00F5
+#define CBUS_DDC_05_ddc_data_fw_shift                                 (0)
+#define CBUS_DDC_05_ddc_data_fw_mask                                  (0x000000FF)
+#define CBUS_DDC_05_ddc_data_fw(data)                                 (0x000000FF&(data))
+#define CBUS_DDC_05_get_ddc_data_fw(data)                             (0x000000FF&(data))
+
+
+#define CBUS_DDC_06                                                   0x1800f3d8
+#define CBUS_DDC_06_reg_addr                                          "0xb800f3d8"
+#define CBUS_DDC_06_reg                                               0xb800f3d8
+#define CBUS_DDC_06_inst_addr                                         "0x00F6"
+#define CBUS_DDC_06_inst                                              0x00F6
+#define CBUS_DDC_06_ddc_eof_irq_shift                                 (3)
+#define CBUS_DDC_06_ddc_eof_irq_en_shift                              (2)
+#define CBUS_DDC_06_ddcrd_rst_en_shift                                (1)
+#define CBUS_DDC_06_ddcrd_new_md_shift                                (0)
+#define CBUS_DDC_06_ddc_eof_irq_mask                                  (0x00000008)
+#define CBUS_DDC_06_ddc_eof_irq_en_mask                               (0x00000004)
+#define CBUS_DDC_06_ddcrd_rst_en_mask                                 (0x00000002)
+#define CBUS_DDC_06_ddcrd_new_md_mask                                 (0x00000001)
+#define CBUS_DDC_06_ddc_eof_irq(data)                                 (0x00000008&((data)<<3))
+#define CBUS_DDC_06_ddc_eof_irq_en(data)                              (0x00000004&((data)<<2))
+#define CBUS_DDC_06_ddcrd_rst_en(data)                                (0x00000002&((data)<<1))
+#define CBUS_DDC_06_ddcrd_new_md(data)                                (0x00000001&(data))
+#define CBUS_DDC_06_get_ddc_eof_irq(data)                             ((0x00000008&(data))>>3)
+#define CBUS_DDC_06_get_ddc_eof_irq_en(data)                          ((0x00000004&(data))>>2)
+#define CBUS_DDC_06_get_ddcrd_rst_en(data)                            ((0x00000002&(data))>>1)
+#define CBUS_DDC_06_get_ddcrd_new_md(data)                            (0x00000001&(data))
+
+
+#define CBUS_WDOG                                                     0x1800f3e0
+#define CBUS_WDOG_reg_addr                                            "0xb800f3e0"
+#define CBUS_WDOG_reg                                                 0xb800f3e0
+#define CBUS_WDOG_inst_addr                                           "0x00F8"
+#define CBUS_WDOG_inst                                                0x00F8
+#define CBUS_WDOG_clk_mod_vwd_shift                                   (5)
+#define CBUS_WDOG_clk_mod_awd_shift                                   (4)
+#define CBUS_WDOG_mute_en_vwd_shift                                   (3)
+#define CBUS_WDOG_mute_en_awd_shift                                   (2)
+#define CBUS_WDOG_path_en_off_vwd_shift                               (1)
+#define CBUS_WDOG_path_en_off_awd_shift                               (0)
+#define CBUS_WDOG_clk_mod_vwd_mask                                    (0x00000020)
+#define CBUS_WDOG_clk_mod_awd_mask                                    (0x00000010)
+#define CBUS_WDOG_mute_en_vwd_mask                                    (0x00000008)
+#define CBUS_WDOG_mute_en_awd_mask                                    (0x00000004)
+#define CBUS_WDOG_path_en_off_vwd_mask                                (0x00000002)
+#define CBUS_WDOG_path_en_off_awd_mask                                (0x00000001)
+#define CBUS_WDOG_clk_mod_vwd(data)                                   (0x00000020&((data)<<5))
+#define CBUS_WDOG_clk_mod_awd(data)                                   (0x00000010&((data)<<4))
+#define CBUS_WDOG_mute_en_vwd(data)                                   (0x00000008&((data)<<3))
+#define CBUS_WDOG_mute_en_awd(data)                                   (0x00000004&((data)<<2))
+#define CBUS_WDOG_path_en_off_vwd(data)                               (0x00000002&((data)<<1))
+#define CBUS_WDOG_path_en_off_awd(data)                               (0x00000001&(data))
+#define CBUS_WDOG_get_clk_mod_vwd(data)                               ((0x00000020&(data))>>5)
+#define CBUS_WDOG_get_clk_mod_awd(data)                               ((0x00000010&(data))>>4)
+#define CBUS_WDOG_get_mute_en_vwd(data)                               ((0x00000008&(data))>>3)
+#define CBUS_WDOG_get_mute_en_awd(data)                               ((0x00000004&(data))>>2)
+#define CBUS_WDOG_get_path_en_off_vwd(data)                           ((0x00000002&(data))>>1)
+#define CBUS_WDOG_get_path_en_off_awd(data)                           (0x00000001&(data))
+
+
+#define CBUS_INT_INDEX                                                0x1800f3e4
+#define CBUS_INT_INDEX_reg_addr                                       "0xb800f3e4"
+#define CBUS_INT_INDEX_reg                                            0xb800f3e4
+#define CBUS_INT_INDEX_inst_addr                                      "0x00F9"
+#define CBUS_INT_INDEX_inst                                           0x00F9
+#define CBUS_INT_INDEX_arbiter_irq_shift                              (5)
+#define CBUS_INT_INDEX_ddc_irq_shift                                  (4)
+#define CBUS_INT_INDEX_msc_ch_irq_shift                               (3)
+#define CBUS_INT_INDEX_msc_int_irq_shift                              (2)
+#define CBUS_INT_INDEX_msc_stat_irq_shift                             (1)
+#define CBUS_INT_INDEX_ctrl_01_resv_shift                             (0)
+#define CBUS_INT_INDEX_arbiter_irq_mask                               (0x00000020)
+#define CBUS_INT_INDEX_ddc_irq_mask                                   (0x00000010)
+#define CBUS_INT_INDEX_msc_ch_irq_mask                                (0x00000008)
+#define CBUS_INT_INDEX_msc_int_irq_mask                               (0x00000004)
+#define CBUS_INT_INDEX_msc_stat_irq_mask                              (0x00000002)
+#define CBUS_INT_INDEX_ctrl_01_resv_mask                              (0x00000001)
+#define CBUS_INT_INDEX_arbiter_irq(data)                              (0x00000020&((data)<<5))
+#define CBUS_INT_INDEX_ddc_irq(data)                                  (0x00000010&((data)<<4))
+#define CBUS_INT_INDEX_msc_ch_irq(data)                               (0x00000008&((data)<<3))
+#define CBUS_INT_INDEX_msc_int_irq(data)                              (0x00000004&((data)<<2))
+#define CBUS_INT_INDEX_msc_stat_irq(data)                             (0x00000002&((data)<<1))
+#define CBUS_INT_INDEX_ctrl_01_resv(data)                             (0x00000001&(data))
+#define CBUS_INT_INDEX_get_arbiter_irq(data)                          ((0x00000020&(data))>>5)
+#define CBUS_INT_INDEX_get_ddc_irq(data)                              ((0x00000010&(data))>>4)
+#define CBUS_INT_INDEX_get_msc_ch_irq(data)                           ((0x00000008&(data))>>3)
+#define CBUS_INT_INDEX_get_msc_int_irq(data)                          ((0x00000004&(data))>>2)
+#define CBUS_INT_INDEX_get_msc_stat_irq(data)                         ((0x00000002&(data))>>1)
+#define CBUS_INT_INDEX_get_ctrl_01_resv(data)                         (0x00000001&(data))
+
+
+#define CBUS_TEST                                                     0x1800f3e8
+#define CBUS_TEST_reg_addr                                            "0xb800f3e8"
+#define CBUS_TEST_reg                                                 0xb800f3e8
+#define CBUS_TEST_inst_addr                                           "0x00FA"
+#define CBUS_TEST_inst                                                0x00FA
+#define CBUS_TEST_cbus_test_md_shift                                  (6)
+#define CBUS_TEST_fw_out_shift                                        (5)
+#define CBUS_TEST_dbg_sel_shift                                       (2)
+#define CBUS_TEST_cbus_test_md_mask                                   (0x000000C0)
+#define CBUS_TEST_fw_out_mask                                         (0x00000020)
+#define CBUS_TEST_dbg_sel_mask                                        (0x0000001C)
+#define CBUS_TEST_cbus_test_md(data)                                  (0x000000C0&((data)<<6))
+#define CBUS_TEST_fw_out(data)                                        (0x00000020&((data)<<5))
+#define CBUS_TEST_dbg_sel(data)                                       (0x0000001C&((data)<<2))
+#define CBUS_TEST_get_cbus_test_md(data)                              ((0x000000C0&(data))>>6)
+#define CBUS_TEST_get_fw_out(data)                                    ((0x00000020&(data))>>5)
+#define CBUS_TEST_get_dbg_sel(data)                                   ((0x0000001C&(data))>>2)
+
+
+#define CBUS_DUMMY0                                                   0x1800f3ec
+#define CBUS_DUMMY0_reg_addr                                          "0xb800f3ec"
+#define CBUS_DUMMY0_reg                                               0xb800f3ec
+#define CBUS_DUMMY0_inst_addr                                         "0x00FB"
+#define CBUS_DUMMY0_inst                                              0x00FB
+#define CBUS_DUMMY0_cbus_dummy0_shift                                 (0)
+#define CBUS_DUMMY0_cbus_dummy0_mask                                  (0xFFFFFFFF)
+#define CBUS_DUMMY0_cbus_dummy0(data)                                 (0xFFFFFFFF&(data))
+#define CBUS_DUMMY0_get_cbus_dummy0(data)                             (0xFFFFFFFF&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/CEC_fw.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/CEC_fw.h
new file mode 100644
index 00000000..b849cd8
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/CEC_fw.h
@@ -0,0 +1,1471 @@
+// This file is generated using the spec version 1.39, firmware template version 1.39and SRIF Parser                                                                                source code SVN rev:802                    Version flow no.:1.1.66
+#ifndef _CEC_REG_H_INCLUDED_
+#define _CEC_REG_H_INCLUDED_
+
+//#define  _CEC_USE_STRUCT
+#ifdef _CEC_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    cec_mode:2;
+    unsigned int    reserved_0:1;
+    unsigned int    test_mode_pad_en:1;
+    unsigned int    logical_addr:4;
+    unsigned int    timer_div:8;
+    unsigned int    pre_div:8;
+    unsigned int    unreg_ack_en:1;
+    unsigned int    reserved_1:1;
+    unsigned int    cdc_arbitration_en:1;
+    unsigned int    test_mode_pad_data:5;
+}CEC_cr0;
+
+typedef struct
+{
+    unsigned int    cec_pad_in:1;
+    unsigned int    dummy18037204_30_18:13;
+    unsigned int    cec_pad_en:1;
+    unsigned int    cec_pad_en_mode:1;
+    unsigned int    dummy18037204_15_13:3;
+    unsigned int    cec_hw_retry_en:1;
+    unsigned int    clear_cec_int:1;
+    unsigned int    wt_cnt:6;
+    unsigned int    lattest:1;
+    unsigned int    retry_no:4;
+}CEC_rtcr0;
+
+typedef struct
+{
+    unsigned int    broadcast_addr:1;
+    unsigned int    reserved_0:10;
+    unsigned int    standby_addr_sel:1;
+    unsigned int    standby_init_addr:4;
+    unsigned int    rx_en:1;
+    unsigned int    rx_rst:1;
+    unsigned int    rx_continuous:1;
+    unsigned int    rx_int_en:1;
+    unsigned int    init_addr:4;
+    unsigned int    rx_eom:1;
+    unsigned int    rx_int:1;
+    unsigned int    rx_fifo_ov:1;
+    unsigned int    rx_fifo_cnt:5;
+}CEC_rxcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:11;
+    unsigned int    tx_addr_en:1;
+    unsigned int    tx_addr:4;
+    unsigned int    tx_en:1;
+    unsigned int    tx_rst:1;
+    unsigned int    tx_continuous:1;
+    unsigned int    tx_int_en:1;
+    unsigned int    dest_addr:4;
+    unsigned int    tx_eom:1;
+    unsigned int    tx_int:1;
+    unsigned int    tx_fifo_ud:1;
+    unsigned int    tx_fifo_cnt:5;
+}CEC_txcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    tx_add_cnt:1;
+    unsigned int    rx_sub_cnt:1;
+    unsigned int    fifo_cnt:5;
+}CEC_txdr0;
+
+typedef struct
+{
+    unsigned int    tx_fifo_0:8;
+    unsigned int    tx_fifo_1:8;
+    unsigned int    tx_fifo_2:8;
+    unsigned int    tx_fifo_3:8;
+}CEC_txdr1;
+
+typedef struct
+{
+    unsigned int    tx_fifo_4:8;
+    unsigned int    tx_fifo_5:8;
+    unsigned int    tx_fifo_6:8;
+    unsigned int    tx_fifo_7:8;
+}CEC_txdr2;
+
+typedef struct
+{
+    unsigned int    tx_fifo_8:8;
+    unsigned int    tx_fifo_9:8;
+    unsigned int    tx_fifo_a:8;
+    unsigned int    tx_fifo_b:8;
+}CEC_txdr3;
+
+typedef struct
+{
+    unsigned int    tx_fifo_c:8;
+    unsigned int    tx_fifo_d:8;
+    unsigned int    tx_fifo_e:8;
+    unsigned int    tx_fifo_f:8;
+}CEC_txdr4;
+
+typedef struct
+{
+    unsigned int    rx_fifo_0:8;
+    unsigned int    rx_fifo_1:8;
+    unsigned int    rx_fifo_2:8;
+    unsigned int    rx_fifo_3:8;
+}CEC_rxdr1;
+
+typedef struct
+{
+    unsigned int    rx_fifo_4:8;
+    unsigned int    rx_fifo_5:8;
+    unsigned int    rx_fifo_6:8;
+    unsigned int    rx_fifo_7:8;
+}CEC_rxdr2;
+
+typedef struct
+{
+    unsigned int    rx_fifo_8:8;
+    unsigned int    rx_fifo_9:8;
+    unsigned int    rx_fifo_a:8;
+    unsigned int    rx_fifo_b:8;
+}CEC_rxdr3;
+
+typedef struct
+{
+    unsigned int    rx_fifo_c:8;
+    unsigned int    rx_fifo_d:8;
+    unsigned int    rx_fifo_e:8;
+    unsigned int    rx_fifo_f:8;
+}CEC_rxdr4;
+
+typedef struct
+{
+    unsigned int    rx_start_low:8;
+    unsigned int    rx_start_period:8;
+    unsigned int    rx_data_sample:8;
+    unsigned int    rx_data_period:8;
+}CEC_rxtcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    tx_start_low:8;
+    unsigned int    tx_start_high:8;
+}CEC_txtcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    tx_data_low:8;
+    unsigned int    tx_data_01:8;
+    unsigned int    tx_data_high:8;
+}CEC_txtcr1;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_01:8;
+}GDI_cec_compare_opcode_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:19;
+    unsigned int    send_init_address_01:1;
+    unsigned int    init_address_01:4;
+    unsigned int    send_opcode_01:8;
+}GDI_cec_send_opcode_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    reserved_1:6;
+    unsigned int    operand_number_01:2;
+}GDI_cec_send_operand_number_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_01:8;
+}GDI_cec_operand_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_02:8;
+}GDI_cec_operand_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_03:8;
+}GDI_cec_operand_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_02:8;
+}GDI_cec_compare_opcode_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:19;
+    unsigned int    send_init_address_02:1;
+    unsigned int    init_address_02:4;
+    unsigned int    send_opcode_02:8;
+}GDI_cec_send_opcode_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    reserved_1:6;
+    unsigned int    operand_number_02:2;
+}GDI_cec_send_operand_number_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_04:8;
+}GDI_cec_operand_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_05:8;
+}GDI_cec_operand_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_06:8;
+}GDI_cec_operand_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_03:8;
+}GDI_cec_compare_opcode_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:19;
+    unsigned int    send_init_address_03:1;
+    unsigned int    init_address_03:4;
+    unsigned int    send_opcode_03:8;
+}GDI_cec_send_opcode_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    reserved_1:6;
+    unsigned int    operand_number_03:2;
+}GDI_cec_send_operand_number_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_07:8;
+}GDI_cec_operand_07;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_08:8;
+}GDI_cec_operand_08;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_09:8;
+}GDI_cec_operand_09;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_04:8;
+}GDI_cec_compare_opcode_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:19;
+    unsigned int    send_init_address_04:1;
+    unsigned int    init_address_04:4;
+    unsigned int    send_opcode_04:8;
+}GDI_cec_send_opcode_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    reserved_1:6;
+    unsigned int    operand_number_04:2;
+}GDI_cec_send_operand_number_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_10:8;
+}GDI_cec_operand_10;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_11:8;
+}GDI_cec_operand_11;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_12:8;
+}GDI_cec_operand_12;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_05:8;
+}GDI_cec_compare_opcode_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_06:8;
+}GDI_cec_compare_opcode_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_07:8;
+}GDI_cec_compare_opcode_07;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_08:8;
+}GDI_cec_compare_opcode_08;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_09:8;
+}GDI_cec_compare_opcode_09;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_10:8;
+}GDI_cec_compare_opcode_10;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_11:8;
+}GDI_cec_compare_opcode_11;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_12:8;
+}GDI_cec_compare_opcode_12;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_13:8;
+}GDI_cec_compare_opcode_13;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_14:8;
+}GDI_cec_compare_opcode_14;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_15:8;
+}GDI_cec_compare_opcode_15;
+
+typedef struct
+{
+    unsigned int    reserved_0:17;
+    unsigned int    en_compare_opcode_15:1;
+    unsigned int    en_compare_opcode_14:1;
+    unsigned int    en_compare_opcode_13:1;
+    unsigned int    en_compare_opcode_12:1;
+    unsigned int    en_compare_opcode_11:1;
+    unsigned int    en_compare_opcode_10:1;
+    unsigned int    en_compare_opcode_09:1;
+    unsigned int    en_compare_opcode_08:1;
+    unsigned int    en_compare_opcode_07:1;
+    unsigned int    en_compare_opcode_06:1;
+    unsigned int    en_compare_opcode_05:1;
+    unsigned int    en_compare_opcode_04:1;
+    unsigned int    en_compare_opcode_03:1;
+    unsigned int    en_compare_opcode_02:1;
+    unsigned int    en_compare_opcode_01:1;
+}GDI_cec_opcode_enable;
+
+typedef struct
+{
+    unsigned int    irq_pending:1;
+    unsigned int    reserved_0:5;
+    unsigned int    cec_msg_status_01:1;
+    unsigned int    cec_msg_status_02:1;
+    unsigned int    reserved_1:15;
+    unsigned int    irq_by_cec_receive_special_cmd:1;
+    unsigned int    reserved_2:3;
+    unsigned int    cec_rpu_en:1;
+    unsigned int    reserved_3:1;
+    unsigned int    cec_rsel:3;
+}GDI_power_saving_mode;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    rx_ack_wait_1_sel:1;
+    unsigned int    rx_ack_wait_2_sel:1;
+    unsigned int    rx_ack_wait_3_sel:1;
+    unsigned int    rx_ack_wait_1:8;
+    unsigned int    rx_ack_wait_2:8;
+    unsigned int    rx_ack_wait_3:8;
+}CEC_rxacktcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    rx_ack_low_sel:1;
+    unsigned int    rx_ack_bit_sel:1;
+    unsigned int    rx_ack_line_err_sel:1;
+    unsigned int    rx_ack_low:8;
+    unsigned int    rx_ack_bit:8;
+    unsigned int    rx_ack_line_err:8;
+}CEC_rxacktcr1;
+#endif
+
+
+#define CEC_CR0                                                       0x18037200
+#define CEC_CR0_reg_addr                                              "0xb8037200"
+#define CEC_CR0_reg                                                   0xb8037200
+#define CEC_CR0_inst_addr                                             "0x0080"
+#define CEC_CR0_inst                                                  0x0080
+#define CEC_CR0_cec_mode_shift                                        (30)
+#define CEC_CR0_test_mode_pad_en_shift                                (28)
+#define CEC_CR0_logical_addr_shift                                    (24)
+#define CEC_CR0_timer_div_shift                                       (16)
+#define CEC_CR0_pre_div_shift                                         (8)
+#define CEC_CR0_unreg_ack_en_shift                                    (7)
+#define CEC_CR0_cdc_arbitration_en_shift                              (5)
+#define CEC_CR0_test_mode_pad_data_shift                              (0)
+#define CEC_CR0_cec_mode_mask                                         (0xC0000000)
+#define CEC_CR0_test_mode_pad_en_mask                                 (0x10000000)
+#define CEC_CR0_logical_addr_mask                                     (0x0F000000)
+#define CEC_CR0_timer_div_mask                                        (0x00FF0000)
+#define CEC_CR0_pre_div_mask                                          (0x0000FF00)
+#define CEC_CR0_unreg_ack_en_mask                                     (0x00000080)
+#define CEC_CR0_cdc_arbitration_en_mask                               (0x00000020)
+#define CEC_CR0_test_mode_pad_data_mask                               (0x0000001F)
+#define CEC_CR0_cec_mode(data)                                        (0xC0000000&((data)<<30))
+#define CEC_CR0_test_mode_pad_en(data)                                (0x10000000&((data)<<28))
+#define CEC_CR0_logical_addr(data)                                    (0x0F000000&((data)<<24))
+#define CEC_CR0_timer_div(data)                                       (0x00FF0000&((data)<<16))
+#define CEC_CR0_pre_div(data)                                         (0x0000FF00&((data)<<8))
+#define CEC_CR0_unreg_ack_en(data)                                    (0x00000080&((data)<<7))
+#define CEC_CR0_cdc_arbitration_en(data)                              (0x00000020&((data)<<5))
+#define CEC_CR0_test_mode_pad_data(data)                              (0x0000001F&(data))
+#define CEC_CR0_get_cec_mode(data)                                    ((0xC0000000&(data))>>30)
+#define CEC_CR0_get_test_mode_pad_en(data)                            ((0x10000000&(data))>>28)
+#define CEC_CR0_get_logical_addr(data)                                ((0x0F000000&(data))>>24)
+#define CEC_CR0_get_timer_div(data)                                   ((0x00FF0000&(data))>>16)
+#define CEC_CR0_get_pre_div(data)                                     ((0x0000FF00&(data))>>8)
+#define CEC_CR0_get_unreg_ack_en(data)                                ((0x00000080&(data))>>7)
+#define CEC_CR0_get_cdc_arbitration_en(data)                          ((0x00000020&(data))>>5)
+#define CEC_CR0_get_test_mode_pad_data(data)                          (0x0000001F&(data))
+
+
+#define CEC_RTCR0                                                     0x18037204
+#define CEC_RTCR0_reg_addr                                            "0xb8037204"
+#define CEC_RTCR0_reg                                                 0xb8037204
+#define CEC_RTCR0_inst_addr                                           "0x0081"
+#define CEC_RTCR0_inst                                                0x0081
+#define CEC_RTCR0_cec_pad_in_shift                                    (31)
+#define CEC_RTCR0_dummy18037204_30_18_shift                           (18)
+#define CEC_RTCR0_cec_pad_en_shift                                    (17)
+#define CEC_RTCR0_cec_pad_en_mode_shift                               (16)
+#define CEC_RTCR0_dummy18037204_15_13_shift                           (13)
+#define CEC_RTCR0_cec_hw_retry_en_shift                               (12)
+#define CEC_RTCR0_clear_cec_int_shift                                 (11)
+#define CEC_RTCR0_wt_cnt_shift                                        (5)
+#define CEC_RTCR0_lattest_shift                                       (4)
+#define CEC_RTCR0_retry_no_shift                                      (0)
+#define CEC_RTCR0_cec_pad_in_mask                                     (0x80000000)
+#define CEC_RTCR0_dummy18037204_30_18_mask                            (0x7FFC0000)
+#define CEC_RTCR0_cec_pad_en_mask                                     (0x00020000)
+#define CEC_RTCR0_cec_pad_en_mode_mask                                (0x00010000)
+#define CEC_RTCR0_dummy18037204_15_13_mask                            (0x0000E000)
+#define CEC_RTCR0_cec_hw_retry_en_mask                                (0x00001000)
+#define CEC_RTCR0_clear_cec_int_mask                                  (0x00000800)
+#define CEC_RTCR0_wt_cnt_mask                                         (0x000007E0)
+#define CEC_RTCR0_lattest_mask                                        (0x00000010)
+#define CEC_RTCR0_retry_no_mask                                       (0x0000000F)
+#define CEC_RTCR0_cec_pad_in(data)                                    (0x80000000&((data)<<31))
+#define CEC_RTCR0_dummy18037204_30_18(data)                           (0x7FFC0000&((data)<<18))
+#define CEC_RTCR0_cec_pad_en(data)                                    (0x00020000&((data)<<17))
+#define CEC_RTCR0_cec_pad_en_mode(data)                               (0x00010000&((data)<<16))
+#define CEC_RTCR0_dummy18037204_15_13(data)                           (0x0000E000&((data)<<13))
+#define CEC_RTCR0_cec_hw_retry_en(data)                               (0x00001000&((data)<<12))
+#define CEC_RTCR0_clear_cec_int(data)                                 (0x00000800&((data)<<11))
+#define CEC_RTCR0_wt_cnt(data)                                        (0x000007E0&((data)<<5))
+#define CEC_RTCR0_lattest(data)                                       (0x00000010&((data)<<4))
+#define CEC_RTCR0_retry_no(data)                                      (0x0000000F&(data))
+#define CEC_RTCR0_get_cec_pad_in(data)                                ((0x80000000&(data))>>31)
+#define CEC_RTCR0_get_dummy18037204_30_18(data)                       ((0x7FFC0000&(data))>>18)
+#define CEC_RTCR0_get_cec_pad_en(data)                                ((0x00020000&(data))>>17)
+#define CEC_RTCR0_get_cec_pad_en_mode(data)                           ((0x00010000&(data))>>16)
+#define CEC_RTCR0_get_dummy18037204_15_13(data)                       ((0x0000E000&(data))>>13)
+#define CEC_RTCR0_get_cec_hw_retry_en(data)                           ((0x00001000&(data))>>12)
+#define CEC_RTCR0_get_clear_cec_int(data)                             ((0x00000800&(data))>>11)
+#define CEC_RTCR0_get_wt_cnt(data)                                    ((0x000007E0&(data))>>5)
+#define CEC_RTCR0_get_lattest(data)                                   ((0x00000010&(data))>>4)
+#define CEC_RTCR0_get_retry_no(data)                                  (0x0000000F&(data))
+
+
+#define CEC_RXCR0                                                     0x18037208
+#define CEC_RXCR0_reg_addr                                            "0xb8037208"
+#define CEC_RXCR0_reg                                                 0xb8037208
+#define CEC_RXCR0_inst_addr                                           "0x0082"
+#define CEC_RXCR0_inst                                                0x0082
+#define CEC_RXCR0_broadcast_addr_shift                                (31)
+#define CEC_RXCR0_standby_addr_sel_shift                              (20)
+#define CEC_RXCR0_standby_init_addr_shift                             (16)
+#define CEC_RXCR0_rx_en_shift                                         (15)
+#define CEC_RXCR0_rx_rst_shift                                        (14)
+#define CEC_RXCR0_rx_continuous_shift                                 (13)
+#define CEC_RXCR0_rx_int_en_shift                                     (12)
+#define CEC_RXCR0_init_addr_shift                                     (8)
+#define CEC_RXCR0_rx_eom_shift                                        (7)
+#define CEC_RXCR0_rx_int_shift                                        (6)
+#define CEC_RXCR0_rx_fifo_ov_shift                                    (5)
+#define CEC_RXCR0_rx_fifo_cnt_shift                                   (0)
+#define CEC_RXCR0_broadcast_addr_mask                                 (0x80000000)
+#define CEC_RXCR0_standby_addr_sel_mask                               (0x00100000)
+#define CEC_RXCR0_standby_init_addr_mask                              (0x000F0000)
+#define CEC_RXCR0_rx_en_mask                                          (0x00008000)
+#define CEC_RXCR0_rx_rst_mask                                         (0x00004000)
+#define CEC_RXCR0_rx_continuous_mask                                  (0x00002000)
+#define CEC_RXCR0_rx_int_en_mask                                      (0x00001000)
+#define CEC_RXCR0_init_addr_mask                                      (0x00000F00)
+#define CEC_RXCR0_rx_eom_mask                                         (0x00000080)
+#define CEC_RXCR0_rx_int_mask                                         (0x00000040)
+#define CEC_RXCR0_rx_fifo_ov_mask                                     (0x00000020)
+#define CEC_RXCR0_rx_fifo_cnt_mask                                    (0x0000001F)
+#define CEC_RXCR0_broadcast_addr(data)                                (0x80000000&((data)<<31))
+#define CEC_RXCR0_standby_addr_sel(data)                              (0x00100000&((data)<<20))
+#define CEC_RXCR0_standby_init_addr(data)                             (0x000F0000&((data)<<16))
+#define CEC_RXCR0_rx_en(data)                                         (0x00008000&((data)<<15))
+#define CEC_RXCR0_rx_rst(data)                                        (0x00004000&((data)<<14))
+#define CEC_RXCR0_rx_continuous(data)                                 (0x00002000&((data)<<13))
+#define CEC_RXCR0_rx_int_en(data)                                     (0x00001000&((data)<<12))
+#define CEC_RXCR0_init_addr(data)                                     (0x00000F00&((data)<<8))
+#define CEC_RXCR0_rx_eom(data)                                        (0x00000080&((data)<<7))
+#define CEC_RXCR0_rx_int(data)                                        (0x00000040&((data)<<6))
+#define CEC_RXCR0_rx_fifo_ov(data)                                    (0x00000020&((data)<<5))
+#define CEC_RXCR0_rx_fifo_cnt(data)                                   (0x0000001F&(data))
+#define CEC_RXCR0_get_broadcast_addr(data)                            ((0x80000000&(data))>>31)
+#define CEC_RXCR0_get_standby_addr_sel(data)                          ((0x00100000&(data))>>20)
+#define CEC_RXCR0_get_standby_init_addr(data)                         ((0x000F0000&(data))>>16)
+#define CEC_RXCR0_get_rx_en(data)                                     ((0x00008000&(data))>>15)
+#define CEC_RXCR0_get_rx_rst(data)                                    ((0x00004000&(data))>>14)
+#define CEC_RXCR0_get_rx_continuous(data)                             ((0x00002000&(data))>>13)
+#define CEC_RXCR0_get_rx_int_en(data)                                 ((0x00001000&(data))>>12)
+#define CEC_RXCR0_get_init_addr(data)                                 ((0x00000F00&(data))>>8)
+#define CEC_RXCR0_get_rx_eom(data)                                    ((0x00000080&(data))>>7)
+#define CEC_RXCR0_get_rx_int(data)                                    ((0x00000040&(data))>>6)
+#define CEC_RXCR0_get_rx_fifo_ov(data)                                ((0x00000020&(data))>>5)
+#define CEC_RXCR0_get_rx_fifo_cnt(data)                               (0x0000001F&(data))
+
+
+#define CEC_TXCR0                                                     0x1803720c
+#define CEC_TXCR0_reg_addr                                            "0xb803720c"
+#define CEC_TXCR0_reg                                                 0xb803720c
+#define CEC_TXCR0_inst_addr                                           "0x0083"
+#define CEC_TXCR0_inst                                                0x0083
+#define CEC_TXCR0_tx_addr_en_shift                                    (20)
+#define CEC_TXCR0_tx_addr_shift                                       (16)
+#define CEC_TXCR0_tx_en_shift                                         (15)
+#define CEC_TXCR0_tx_rst_shift                                        (14)
+#define CEC_TXCR0_tx_continuous_shift                                 (13)
+#define CEC_TXCR0_tx_int_en_shift                                     (12)
+#define CEC_TXCR0_dest_addr_shift                                     (8)
+#define CEC_TXCR0_tx_eom_shift                                        (7)
+#define CEC_TXCR0_tx_int_shift                                        (6)
+#define CEC_TXCR0_tx_fifo_ud_shift                                    (5)
+#define CEC_TXCR0_tx_fifo_cnt_shift                                   (0)
+#define CEC_TXCR0_tx_addr_en_mask                                     (0x00100000)
+#define CEC_TXCR0_tx_addr_mask                                        (0x000F0000)
+#define CEC_TXCR0_tx_en_mask                                          (0x00008000)
+#define CEC_TXCR0_tx_rst_mask                                         (0x00004000)
+#define CEC_TXCR0_tx_continuous_mask                                  (0x00002000)
+#define CEC_TXCR0_tx_int_en_mask                                      (0x00001000)
+#define CEC_TXCR0_dest_addr_mask                                      (0x00000F00)
+#define CEC_TXCR0_tx_eom_mask                                         (0x00000080)
+#define CEC_TXCR0_tx_int_mask                                         (0x00000040)
+#define CEC_TXCR0_tx_fifo_ud_mask                                     (0x00000020)
+#define CEC_TXCR0_tx_fifo_cnt_mask                                    (0x0000001F)
+#define CEC_TXCR0_tx_addr_en(data)                                    (0x00100000&((data)<<20))
+#define CEC_TXCR0_tx_addr(data)                                       (0x000F0000&((data)<<16))
+#define CEC_TXCR0_tx_en(data)                                         (0x00008000&((data)<<15))
+#define CEC_TXCR0_tx_rst(data)                                        (0x00004000&((data)<<14))
+#define CEC_TXCR0_tx_continuous(data)                                 (0x00002000&((data)<<13))
+#define CEC_TXCR0_tx_int_en(data)                                     (0x00001000&((data)<<12))
+#define CEC_TXCR0_dest_addr(data)                                     (0x00000F00&((data)<<8))
+#define CEC_TXCR0_tx_eom(data)                                        (0x00000080&((data)<<7))
+#define CEC_TXCR0_tx_int(data)                                        (0x00000040&((data)<<6))
+#define CEC_TXCR0_tx_fifo_ud(data)                                    (0x00000020&((data)<<5))
+#define CEC_TXCR0_tx_fifo_cnt(data)                                   (0x0000001F&(data))
+#define CEC_TXCR0_get_tx_addr_en(data)                                ((0x00100000&(data))>>20)
+#define CEC_TXCR0_get_tx_addr(data)                                   ((0x000F0000&(data))>>16)
+#define CEC_TXCR0_get_tx_en(data)                                     ((0x00008000&(data))>>15)
+#define CEC_TXCR0_get_tx_rst(data)                                    ((0x00004000&(data))>>14)
+#define CEC_TXCR0_get_tx_continuous(data)                             ((0x00002000&(data))>>13)
+#define CEC_TXCR0_get_tx_int_en(data)                                 ((0x00001000&(data))>>12)
+#define CEC_TXCR0_get_dest_addr(data)                                 ((0x00000F00&(data))>>8)
+#define CEC_TXCR0_get_tx_eom(data)                                    ((0x00000080&(data))>>7)
+#define CEC_TXCR0_get_tx_int(data)                                    ((0x00000040&(data))>>6)
+#define CEC_TXCR0_get_tx_fifo_ud(data)                                ((0x00000020&(data))>>5)
+#define CEC_TXCR0_get_tx_fifo_cnt(data)                               (0x0000001F&(data))
+
+
+#define CEC_TXDR0                                                     0x18037210
+#define CEC_TXDR0_reg_addr                                            "0xb8037210"
+#define CEC_TXDR0_reg                                                 0xb8037210
+#define CEC_TXDR0_inst_addr                                           "0x0084"
+#define CEC_TXDR0_inst                                                0x0084
+#define CEC_TXDR0_tx_add_cnt_shift                                    (6)
+#define CEC_TXDR0_rx_sub_cnt_shift                                    (5)
+#define CEC_TXDR0_fifo_cnt_shift                                      (0)
+#define CEC_TXDR0_tx_add_cnt_mask                                     (0x00000040)
+#define CEC_TXDR0_rx_sub_cnt_mask                                     (0x00000020)
+#define CEC_TXDR0_fifo_cnt_mask                                       (0x0000001F)
+#define CEC_TXDR0_tx_add_cnt(data)                                    (0x00000040&((data)<<6))
+#define CEC_TXDR0_rx_sub_cnt(data)                                    (0x00000020&((data)<<5))
+#define CEC_TXDR0_fifo_cnt(data)                                      (0x0000001F&(data))
+#define CEC_TXDR0_get_tx_add_cnt(data)                                ((0x00000040&(data))>>6)
+#define CEC_TXDR0_get_rx_sub_cnt(data)                                ((0x00000020&(data))>>5)
+#define CEC_TXDR0_get_fifo_cnt(data)                                  (0x0000001F&(data))
+
+
+#define CEC_TXDR1                                                     0x18037214
+#define CEC_TXDR1_reg_addr                                            "0xb8037214"
+#define CEC_TXDR1_reg                                                 0xb8037214
+#define CEC_TXDR1_inst_addr                                           "0x0085"
+#define CEC_TXDR1_inst                                                0x0085
+#define CEC_TXDR1_tx_fifo_0_shift                                     (24)
+#define CEC_TXDR1_tx_fifo_1_shift                                     (16)
+#define CEC_TXDR1_tx_fifo_2_shift                                     (8)
+#define CEC_TXDR1_tx_fifo_3_shift                                     (0)
+#define CEC_TXDR1_tx_fifo_0_mask                                      (0xFF000000)
+#define CEC_TXDR1_tx_fifo_1_mask                                      (0x00FF0000)
+#define CEC_TXDR1_tx_fifo_2_mask                                      (0x0000FF00)
+#define CEC_TXDR1_tx_fifo_3_mask                                      (0x000000FF)
+#define CEC_TXDR1_tx_fifo_0(data)                                     (0xFF000000&((data)<<24))
+#define CEC_TXDR1_tx_fifo_1(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_TXDR1_tx_fifo_2(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_TXDR1_tx_fifo_3(data)                                     (0x000000FF&(data))
+#define CEC_TXDR1_get_tx_fifo_0(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_TXDR1_get_tx_fifo_1(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_TXDR1_get_tx_fifo_2(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_TXDR1_get_tx_fifo_3(data)                                 (0x000000FF&(data))
+
+
+#define CEC_TXDR2                                                     0x18037218
+#define CEC_TXDR2_reg_addr                                            "0xb8037218"
+#define CEC_TXDR2_reg                                                 0xb8037218
+#define CEC_TXDR2_inst_addr                                           "0x0086"
+#define CEC_TXDR2_inst                                                0x0086
+#define CEC_TXDR2_tx_fifo_4_shift                                     (24)
+#define CEC_TXDR2_tx_fifo_5_shift                                     (16)
+#define CEC_TXDR2_tx_fifo_6_shift                                     (8)
+#define CEC_TXDR2_tx_fifo_7_shift                                     (0)
+#define CEC_TXDR2_tx_fifo_4_mask                                      (0xFF000000)
+#define CEC_TXDR2_tx_fifo_5_mask                                      (0x00FF0000)
+#define CEC_TXDR2_tx_fifo_6_mask                                      (0x0000FF00)
+#define CEC_TXDR2_tx_fifo_7_mask                                      (0x000000FF)
+#define CEC_TXDR2_tx_fifo_4(data)                                     (0xFF000000&((data)<<24))
+#define CEC_TXDR2_tx_fifo_5(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_TXDR2_tx_fifo_6(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_TXDR2_tx_fifo_7(data)                                     (0x000000FF&(data))
+#define CEC_TXDR2_get_tx_fifo_4(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_TXDR2_get_tx_fifo_5(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_TXDR2_get_tx_fifo_6(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_TXDR2_get_tx_fifo_7(data)                                 (0x000000FF&(data))
+
+
+#define CEC_TXDR3                                                     0x1803721c
+#define CEC_TXDR3_reg_addr                                            "0xb803721c"
+#define CEC_TXDR3_reg                                                 0xb803721c
+#define CEC_TXDR3_inst_addr                                           "0x0087"
+#define CEC_TXDR3_inst                                                0x0087
+#define CEC_TXDR3_tx_fifo_8_shift                                     (24)
+#define CEC_TXDR3_tx_fifo_9_shift                                     (16)
+#define CEC_TXDR3_tx_fifo_a_shift                                     (8)
+#define CEC_TXDR3_tx_fifo_b_shift                                     (0)
+#define CEC_TXDR3_tx_fifo_8_mask                                      (0xFF000000)
+#define CEC_TXDR3_tx_fifo_9_mask                                      (0x00FF0000)
+#define CEC_TXDR3_tx_fifo_a_mask                                      (0x0000FF00)
+#define CEC_TXDR3_tx_fifo_b_mask                                      (0x000000FF)
+#define CEC_TXDR3_tx_fifo_8(data)                                     (0xFF000000&((data)<<24))
+#define CEC_TXDR3_tx_fifo_9(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_TXDR3_tx_fifo_a(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_TXDR3_tx_fifo_b(data)                                     (0x000000FF&(data))
+#define CEC_TXDR3_get_tx_fifo_8(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_TXDR3_get_tx_fifo_9(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_TXDR3_get_tx_fifo_a(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_TXDR3_get_tx_fifo_b(data)                                 (0x000000FF&(data))
+
+
+#define CEC_TXDR4                                                     0x18037220
+#define CEC_TXDR4_reg_addr                                            "0xb8037220"
+#define CEC_TXDR4_reg                                                 0xb8037220
+#define CEC_TXDR4_inst_addr                                           "0x0088"
+#define CEC_TXDR4_inst                                                0x0088
+#define CEC_TXDR4_tx_fifo_c_shift                                     (24)
+#define CEC_TXDR4_tx_fifo_d_shift                                     (16)
+#define CEC_TXDR4_tx_fifo_e_shift                                     (8)
+#define CEC_TXDR4_tx_fifo_f_shift                                     (0)
+#define CEC_TXDR4_tx_fifo_c_mask                                      (0xFF000000)
+#define CEC_TXDR4_tx_fifo_d_mask                                      (0x00FF0000)
+#define CEC_TXDR4_tx_fifo_e_mask                                      (0x0000FF00)
+#define CEC_TXDR4_tx_fifo_f_mask                                      (0x000000FF)
+#define CEC_TXDR4_tx_fifo_c(data)                                     (0xFF000000&((data)<<24))
+#define CEC_TXDR4_tx_fifo_d(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_TXDR4_tx_fifo_e(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_TXDR4_tx_fifo_f(data)                                     (0x000000FF&(data))
+#define CEC_TXDR4_get_tx_fifo_c(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_TXDR4_get_tx_fifo_d(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_TXDR4_get_tx_fifo_e(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_TXDR4_get_tx_fifo_f(data)                                 (0x000000FF&(data))
+
+
+#define CEC_RXDR1                                                     0x18037224
+#define CEC_RXDR1_reg_addr                                            "0xb8037224"
+#define CEC_RXDR1_reg                                                 0xb8037224
+#define CEC_RXDR1_inst_addr                                           "0x0089"
+#define CEC_RXDR1_inst                                                0x0089
+#define CEC_RXDR1_rx_fifo_0_shift                                     (24)
+#define CEC_RXDR1_rx_fifo_1_shift                                     (16)
+#define CEC_RXDR1_rx_fifo_2_shift                                     (8)
+#define CEC_RXDR1_rx_fifo_3_shift                                     (0)
+#define CEC_RXDR1_rx_fifo_0_mask                                      (0xFF000000)
+#define CEC_RXDR1_rx_fifo_1_mask                                      (0x00FF0000)
+#define CEC_RXDR1_rx_fifo_2_mask                                      (0x0000FF00)
+#define CEC_RXDR1_rx_fifo_3_mask                                      (0x000000FF)
+#define CEC_RXDR1_rx_fifo_0(data)                                     (0xFF000000&((data)<<24))
+#define CEC_RXDR1_rx_fifo_1(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_RXDR1_rx_fifo_2(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_RXDR1_rx_fifo_3(data)                                     (0x000000FF&(data))
+#define CEC_RXDR1_get_rx_fifo_0(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_RXDR1_get_rx_fifo_1(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_RXDR1_get_rx_fifo_2(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_RXDR1_get_rx_fifo_3(data)                                 (0x000000FF&(data))
+
+
+#define CEC_RXDR2                                                     0x18037228
+#define CEC_RXDR2_reg_addr                                            "0xb8037228"
+#define CEC_RXDR2_reg                                                 0xb8037228
+#define CEC_RXDR2_inst_addr                                           "0x008A"
+#define CEC_RXDR2_inst                                                0x008A
+#define CEC_RXDR2_rx_fifo_4_shift                                     (24)
+#define CEC_RXDR2_rx_fifo_5_shift                                     (16)
+#define CEC_RXDR2_rx_fifo_6_shift                                     (8)
+#define CEC_RXDR2_rx_fifo_7_shift                                     (0)
+#define CEC_RXDR2_rx_fifo_4_mask                                      (0xFF000000)
+#define CEC_RXDR2_rx_fifo_5_mask                                      (0x00FF0000)
+#define CEC_RXDR2_rx_fifo_6_mask                                      (0x0000FF00)
+#define CEC_RXDR2_rx_fifo_7_mask                                      (0x000000FF)
+#define CEC_RXDR2_rx_fifo_4(data)                                     (0xFF000000&((data)<<24))
+#define CEC_RXDR2_rx_fifo_5(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_RXDR2_rx_fifo_6(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_RXDR2_rx_fifo_7(data)                                     (0x000000FF&(data))
+#define CEC_RXDR2_get_rx_fifo_4(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_RXDR2_get_rx_fifo_5(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_RXDR2_get_rx_fifo_6(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_RXDR2_get_rx_fifo_7(data)                                 (0x000000FF&(data))
+
+
+#define CEC_RXDR3                                                     0x1803722c
+#define CEC_RXDR3_reg_addr                                            "0xb803722c"
+#define CEC_RXDR3_reg                                                 0xb803722c
+#define CEC_RXDR3_inst_addr                                           "0x008B"
+#define CEC_RXDR3_inst                                                0x008B
+#define CEC_RXDR3_rx_fifo_8_shift                                     (24)
+#define CEC_RXDR3_rx_fifo_9_shift                                     (16)
+#define CEC_RXDR3_rx_fifo_a_shift                                     (8)
+#define CEC_RXDR3_rx_fifo_b_shift                                     (0)
+#define CEC_RXDR3_rx_fifo_8_mask                                      (0xFF000000)
+#define CEC_RXDR3_rx_fifo_9_mask                                      (0x00FF0000)
+#define CEC_RXDR3_rx_fifo_a_mask                                      (0x0000FF00)
+#define CEC_RXDR3_rx_fifo_b_mask                                      (0x000000FF)
+#define CEC_RXDR3_rx_fifo_8(data)                                     (0xFF000000&((data)<<24))
+#define CEC_RXDR3_rx_fifo_9(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_RXDR3_rx_fifo_a(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_RXDR3_rx_fifo_b(data)                                     (0x000000FF&(data))
+#define CEC_RXDR3_get_rx_fifo_8(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_RXDR3_get_rx_fifo_9(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_RXDR3_get_rx_fifo_a(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_RXDR3_get_rx_fifo_b(data)                                 (0x000000FF&(data))
+
+
+#define CEC_RXDR4                                                     0x18037230
+#define CEC_RXDR4_reg_addr                                            "0xb8037230"
+#define CEC_RXDR4_reg                                                 0xb8037230
+#define CEC_RXDR4_inst_addr                                           "0x008C"
+#define CEC_RXDR4_inst                                                0x008C
+#define CEC_RXDR4_rx_fifo_c_shift                                     (24)
+#define CEC_RXDR4_rx_fifo_d_shift                                     (16)
+#define CEC_RXDR4_rx_fifo_e_shift                                     (8)
+#define CEC_RXDR4_rx_fifo_f_shift                                     (0)
+#define CEC_RXDR4_rx_fifo_c_mask                                      (0xFF000000)
+#define CEC_RXDR4_rx_fifo_d_mask                                      (0x00FF0000)
+#define CEC_RXDR4_rx_fifo_e_mask                                      (0x0000FF00)
+#define CEC_RXDR4_rx_fifo_f_mask                                      (0x000000FF)
+#define CEC_RXDR4_rx_fifo_c(data)                                     (0xFF000000&((data)<<24))
+#define CEC_RXDR4_rx_fifo_d(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_RXDR4_rx_fifo_e(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_RXDR4_rx_fifo_f(data)                                     (0x000000FF&(data))
+#define CEC_RXDR4_get_rx_fifo_c(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_RXDR4_get_rx_fifo_d(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_RXDR4_get_rx_fifo_e(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_RXDR4_get_rx_fifo_f(data)                                 (0x000000FF&(data))
+
+
+#define CEC_RXTCR0                                                    0x18037234
+#define CEC_RXTCR0_reg_addr                                           "0xb8037234"
+#define CEC_RXTCR0_reg                                                0xb8037234
+#define CEC_RXTCR0_inst_addr                                          "0x008D"
+#define CEC_RXTCR0_inst                                               0x008D
+#define CEC_RXTCR0_rx_start_low_shift                                 (24)
+#define CEC_RXTCR0_rx_start_period_shift                              (16)
+#define CEC_RXTCR0_rx_data_sample_shift                               (8)
+#define CEC_RXTCR0_rx_data_period_shift                               (0)
+#define CEC_RXTCR0_rx_start_low_mask                                  (0xFF000000)
+#define CEC_RXTCR0_rx_start_period_mask                               (0x00FF0000)
+#define CEC_RXTCR0_rx_data_sample_mask                                (0x0000FF00)
+#define CEC_RXTCR0_rx_data_period_mask                                (0x000000FF)
+#define CEC_RXTCR0_rx_start_low(data)                                 (0xFF000000&((data)<<24))
+#define CEC_RXTCR0_rx_start_period(data)                              (0x00FF0000&((data)<<16))
+#define CEC_RXTCR0_rx_data_sample(data)                               (0x0000FF00&((data)<<8))
+#define CEC_RXTCR0_rx_data_period(data)                               (0x000000FF&(data))
+#define CEC_RXTCR0_get_rx_start_low(data)                             ((0xFF000000&(data))>>24)
+#define CEC_RXTCR0_get_rx_start_period(data)                          ((0x00FF0000&(data))>>16)
+#define CEC_RXTCR0_get_rx_data_sample(data)                           ((0x0000FF00&(data))>>8)
+#define CEC_RXTCR0_get_rx_data_period(data)                           (0x000000FF&(data))
+
+
+#define CEC_TXTCR0                                                    0x18037238
+#define CEC_TXTCR0_reg_addr                                           "0xb8037238"
+#define CEC_TXTCR0_reg                                                0xb8037238
+#define CEC_TXTCR0_inst_addr                                          "0x008E"
+#define CEC_TXTCR0_inst                                               0x008E
+#define CEC_TXTCR0_tx_start_low_shift                                 (8)
+#define CEC_TXTCR0_tx_start_high_shift                                (0)
+#define CEC_TXTCR0_tx_start_low_mask                                  (0x0000FF00)
+#define CEC_TXTCR0_tx_start_high_mask                                 (0x000000FF)
+#define CEC_TXTCR0_tx_start_low(data)                                 (0x0000FF00&((data)<<8))
+#define CEC_TXTCR0_tx_start_high(data)                                (0x000000FF&(data))
+#define CEC_TXTCR0_get_tx_start_low(data)                             ((0x0000FF00&(data))>>8)
+#define CEC_TXTCR0_get_tx_start_high(data)                            (0x000000FF&(data))
+
+
+#define CEC_TXTCR1                                                    0x1803723c
+#define CEC_TXTCR1_reg_addr                                           "0xb803723c"
+#define CEC_TXTCR1_reg                                                0xb803723c
+#define CEC_TXTCR1_inst_addr                                          "0x008F"
+#define CEC_TXTCR1_inst                                               0x008F
+#define CEC_TXTCR1_tx_data_low_shift                                  (16)
+#define CEC_TXTCR1_tx_data_01_shift                                   (8)
+#define CEC_TXTCR1_tx_data_high_shift                                 (0)
+#define CEC_TXTCR1_tx_data_low_mask                                   (0x00FF0000)
+#define CEC_TXTCR1_tx_data_01_mask                                    (0x0000FF00)
+#define CEC_TXTCR1_tx_data_high_mask                                  (0x000000FF)
+#define CEC_TXTCR1_tx_data_low(data)                                  (0x00FF0000&((data)<<16))
+#define CEC_TXTCR1_tx_data_01(data)                                   (0x0000FF00&((data)<<8))
+#define CEC_TXTCR1_tx_data_high(data)                                 (0x000000FF&(data))
+#define CEC_TXTCR1_get_tx_data_low(data)                              ((0x00FF0000&(data))>>16)
+#define CEC_TXTCR1_get_tx_data_01(data)                               ((0x0000FF00&(data))>>8)
+#define CEC_TXTCR1_get_tx_data_high(data)                             (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_01                                     0x18037240
+#define GDI_CEC_COMPARE_OPCODE_01_reg_addr                            "0xb8037240"
+#define GDI_CEC_COMPARE_OPCODE_01_reg                                 0xb8037240
+#define GDI_CEC_COMPARE_OPCODE_01_inst_addr                           "0x0090"
+#define GDI_CEC_COMPARE_OPCODE_01_inst                                0x0090
+#define GDI_CEC_COMPARE_OPCODE_01_compare_opcode_01_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_01_compare_opcode_01_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_01_compare_opcode_01(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_01_get_compare_opcode_01(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPCODE_01                                        0x18037244
+#define GDI_CEC_SEND_OPCODE_01_reg_addr                               "0xb8037244"
+#define GDI_CEC_SEND_OPCODE_01_reg                                    0xb8037244
+#define GDI_CEC_SEND_OPCODE_01_inst_addr                              "0x0091"
+#define GDI_CEC_SEND_OPCODE_01_inst                                   0x0091
+#define GDI_CEC_SEND_OPCODE_01_send_init_address_01_shift             (12)
+#define GDI_CEC_SEND_OPCODE_01_init_address_01_shift                  (8)
+#define GDI_CEC_SEND_OPCODE_01_send_opcode_01_shift                   (0)
+#define GDI_CEC_SEND_OPCODE_01_send_init_address_01_mask              (0x00001000)
+#define GDI_CEC_SEND_OPCODE_01_init_address_01_mask                   (0x00000F00)
+#define GDI_CEC_SEND_OPCODE_01_send_opcode_01_mask                    (0x000000FF)
+#define GDI_CEC_SEND_OPCODE_01_send_init_address_01(data)             (0x00001000&((data)<<12))
+#define GDI_CEC_SEND_OPCODE_01_init_address_01(data)                  (0x00000F00&((data)<<8))
+#define GDI_CEC_SEND_OPCODE_01_send_opcode_01(data)                   (0x000000FF&(data))
+#define GDI_CEC_SEND_OPCODE_01_get_send_init_address_01(data)         ((0x00001000&(data))>>12)
+#define GDI_CEC_SEND_OPCODE_01_get_init_address_01(data)              ((0x00000F00&(data))>>8)
+#define GDI_CEC_SEND_OPCODE_01_get_send_opcode_01(data)               (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPERAND_NUMBER_01                                0x18037248
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_reg_addr                       "0xb8037248"
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_reg                            0xb8037248
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_inst_addr                      "0x0092"
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_inst                           0x0092
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_operand_number_01_shift        (0)
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_operand_number_01_mask         (0x00000003)
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_operand_number_01(data)        (0x00000003&(data))
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_get_operand_number_01(data)    (0x00000003&(data))
+
+
+#define GDI_CEC_OPERAND_01                                            0x1803724c
+#define GDI_CEC_OPERAND_01_reg_addr                                   "0xb803724c"
+#define GDI_CEC_OPERAND_01_reg                                        0xb803724c
+#define GDI_CEC_OPERAND_01_inst_addr                                  "0x0093"
+#define GDI_CEC_OPERAND_01_inst                                       0x0093
+#define GDI_CEC_OPERAND_01_operand_01_shift                           (0)
+#define GDI_CEC_OPERAND_01_operand_01_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_01_operand_01(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_01_get_operand_01(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_02                                            0x18037250
+#define GDI_CEC_OPERAND_02_reg_addr                                   "0xb8037250"
+#define GDI_CEC_OPERAND_02_reg                                        0xb8037250
+#define GDI_CEC_OPERAND_02_inst_addr                                  "0x0094"
+#define GDI_CEC_OPERAND_02_inst                                       0x0094
+#define GDI_CEC_OPERAND_02_operand_02_shift                           (0)
+#define GDI_CEC_OPERAND_02_operand_02_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_02_operand_02(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_02_get_operand_02(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_03                                            0x18037254
+#define GDI_CEC_OPERAND_03_reg_addr                                   "0xb8037254"
+#define GDI_CEC_OPERAND_03_reg                                        0xb8037254
+#define GDI_CEC_OPERAND_03_inst_addr                                  "0x0095"
+#define GDI_CEC_OPERAND_03_inst                                       0x0095
+#define GDI_CEC_OPERAND_03_operand_03_shift                           (0)
+#define GDI_CEC_OPERAND_03_operand_03_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_03_operand_03(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_03_get_operand_03(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_02                                     0x18037258
+#define GDI_CEC_COMPARE_OPCODE_02_reg_addr                            "0xb8037258"
+#define GDI_CEC_COMPARE_OPCODE_02_reg                                 0xb8037258
+#define GDI_CEC_COMPARE_OPCODE_02_inst_addr                           "0x0096"
+#define GDI_CEC_COMPARE_OPCODE_02_inst                                0x0096
+#define GDI_CEC_COMPARE_OPCODE_02_compare_opcode_02_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_02_compare_opcode_02_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_02_compare_opcode_02(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_02_get_compare_opcode_02(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPCODE_02                                        0x1803725c
+#define GDI_CEC_SEND_OPCODE_02_reg_addr                               "0xb803725c"
+#define GDI_CEC_SEND_OPCODE_02_reg                                    0xb803725c
+#define GDI_CEC_SEND_OPCODE_02_inst_addr                              "0x0097"
+#define GDI_CEC_SEND_OPCODE_02_inst                                   0x0097
+#define GDI_CEC_SEND_OPCODE_02_send_init_address_02_shift             (12)
+#define GDI_CEC_SEND_OPCODE_02_init_address_02_shift                  (8)
+#define GDI_CEC_SEND_OPCODE_02_send_opcode_02_shift                   (0)
+#define GDI_CEC_SEND_OPCODE_02_send_init_address_02_mask              (0x00001000)
+#define GDI_CEC_SEND_OPCODE_02_init_address_02_mask                   (0x00000F00)
+#define GDI_CEC_SEND_OPCODE_02_send_opcode_02_mask                    (0x000000FF)
+#define GDI_CEC_SEND_OPCODE_02_send_init_address_02(data)             (0x00001000&((data)<<12))
+#define GDI_CEC_SEND_OPCODE_02_init_address_02(data)                  (0x00000F00&((data)<<8))
+#define GDI_CEC_SEND_OPCODE_02_send_opcode_02(data)                   (0x000000FF&(data))
+#define GDI_CEC_SEND_OPCODE_02_get_send_init_address_02(data)         ((0x00001000&(data))>>12)
+#define GDI_CEC_SEND_OPCODE_02_get_init_address_02(data)              ((0x00000F00&(data))>>8)
+#define GDI_CEC_SEND_OPCODE_02_get_send_opcode_02(data)               (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPERAND_NUMBER_02                                0x18037260
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_reg_addr                       "0xb8037260"
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_reg                            0xb8037260
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_inst_addr                      "0x0098"
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_inst                           0x0098
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_operand_number_02_shift        (0)
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_operand_number_02_mask         (0x00000003)
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_operand_number_02(data)        (0x00000003&(data))
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_get_operand_number_02(data)    (0x00000003&(data))
+
+
+#define GDI_CEC_OPERAND_04                                            0x18037264
+#define GDI_CEC_OPERAND_04_reg_addr                                   "0xb8037264"
+#define GDI_CEC_OPERAND_04_reg                                        0xb8037264
+#define GDI_CEC_OPERAND_04_inst_addr                                  "0x0099"
+#define GDI_CEC_OPERAND_04_inst                                       0x0099
+#define GDI_CEC_OPERAND_04_operand_04_shift                           (0)
+#define GDI_CEC_OPERAND_04_operand_04_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_04_operand_04(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_04_get_operand_04(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_05                                            0x18037268
+#define GDI_CEC_OPERAND_05_reg_addr                                   "0xb8037268"
+#define GDI_CEC_OPERAND_05_reg                                        0xb8037268
+#define GDI_CEC_OPERAND_05_inst_addr                                  "0x009A"
+#define GDI_CEC_OPERAND_05_inst                                       0x009A
+#define GDI_CEC_OPERAND_05_operand_05_shift                           (0)
+#define GDI_CEC_OPERAND_05_operand_05_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_05_operand_05(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_05_get_operand_05(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_06                                            0x1803726c
+#define GDI_CEC_OPERAND_06_reg_addr                                   "0xb803726c"
+#define GDI_CEC_OPERAND_06_reg                                        0xb803726c
+#define GDI_CEC_OPERAND_06_inst_addr                                  "0x009B"
+#define GDI_CEC_OPERAND_06_inst                                       0x009B
+#define GDI_CEC_OPERAND_06_operand_06_shift                           (0)
+#define GDI_CEC_OPERAND_06_operand_06_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_06_operand_06(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_06_get_operand_06(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_03                                     0x18037270
+#define GDI_CEC_COMPARE_OPCODE_03_reg_addr                            "0xb8037270"
+#define GDI_CEC_COMPARE_OPCODE_03_reg                                 0xb8037270
+#define GDI_CEC_COMPARE_OPCODE_03_inst_addr                           "0x009C"
+#define GDI_CEC_COMPARE_OPCODE_03_inst                                0x009C
+#define GDI_CEC_COMPARE_OPCODE_03_compare_opcode_03_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_03_compare_opcode_03_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_03_compare_opcode_03(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_03_get_compare_opcode_03(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPCODE_03                                        0x18037274
+#define GDI_CEC_SEND_OPCODE_03_reg_addr                               "0xb8037274"
+#define GDI_CEC_SEND_OPCODE_03_reg                                    0xb8037274
+#define GDI_CEC_SEND_OPCODE_03_inst_addr                              "0x009D"
+#define GDI_CEC_SEND_OPCODE_03_inst                                   0x009D
+#define GDI_CEC_SEND_OPCODE_03_send_init_address_03_shift             (12)
+#define GDI_CEC_SEND_OPCODE_03_init_address_03_shift                  (8)
+#define GDI_CEC_SEND_OPCODE_03_send_opcode_03_shift                   (0)
+#define GDI_CEC_SEND_OPCODE_03_send_init_address_03_mask              (0x00001000)
+#define GDI_CEC_SEND_OPCODE_03_init_address_03_mask                   (0x00000F00)
+#define GDI_CEC_SEND_OPCODE_03_send_opcode_03_mask                    (0x000000FF)
+#define GDI_CEC_SEND_OPCODE_03_send_init_address_03(data)             (0x00001000&((data)<<12))
+#define GDI_CEC_SEND_OPCODE_03_init_address_03(data)                  (0x00000F00&((data)<<8))
+#define GDI_CEC_SEND_OPCODE_03_send_opcode_03(data)                   (0x000000FF&(data))
+#define GDI_CEC_SEND_OPCODE_03_get_send_init_address_03(data)         ((0x00001000&(data))>>12)
+#define GDI_CEC_SEND_OPCODE_03_get_init_address_03(data)              ((0x00000F00&(data))>>8)
+#define GDI_CEC_SEND_OPCODE_03_get_send_opcode_03(data)               (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPERAND_NUMBER_03                                0x18037278
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_reg_addr                       "0xb8037278"
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_reg                            0xb8037278
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_inst_addr                      "0x009E"
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_inst                           0x009E
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_operand_number_03_shift        (0)
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_operand_number_03_mask         (0x00000003)
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_operand_number_03(data)        (0x00000003&(data))
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_get_operand_number_03(data)    (0x00000003&(data))
+
+
+#define GDI_CEC_OPERAND_07                                            0x1803727c
+#define GDI_CEC_OPERAND_07_reg_addr                                   "0xb803727c"
+#define GDI_CEC_OPERAND_07_reg                                        0xb803727c
+#define GDI_CEC_OPERAND_07_inst_addr                                  "0x009F"
+#define GDI_CEC_OPERAND_07_inst                                       0x009F
+#define GDI_CEC_OPERAND_07_operand_07_shift                           (0)
+#define GDI_CEC_OPERAND_07_operand_07_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_07_operand_07(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_07_get_operand_07(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_08                                            0x18037280
+#define GDI_CEC_OPERAND_08_reg_addr                                   "0xb8037280"
+#define GDI_CEC_OPERAND_08_reg                                        0xb8037280
+#define GDI_CEC_OPERAND_08_inst_addr                                  "0x00A0"
+#define GDI_CEC_OPERAND_08_inst                                       0x00A0
+#define GDI_CEC_OPERAND_08_operand_08_shift                           (0)
+#define GDI_CEC_OPERAND_08_operand_08_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_08_operand_08(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_08_get_operand_08(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_09                                            0x18037284
+#define GDI_CEC_OPERAND_09_reg_addr                                   "0xb8037284"
+#define GDI_CEC_OPERAND_09_reg                                        0xb8037284
+#define GDI_CEC_OPERAND_09_inst_addr                                  "0x00A1"
+#define GDI_CEC_OPERAND_09_inst                                       0x00A1
+#define GDI_CEC_OPERAND_09_operand_09_shift                           (0)
+#define GDI_CEC_OPERAND_09_operand_09_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_09_operand_09(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_09_get_operand_09(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_04                                     0x18037288
+#define GDI_CEC_COMPARE_OPCODE_04_reg_addr                            "0xb8037288"
+#define GDI_CEC_COMPARE_OPCODE_04_reg                                 0xb8037288
+#define GDI_CEC_COMPARE_OPCODE_04_inst_addr                           "0x00A2"
+#define GDI_CEC_COMPARE_OPCODE_04_inst                                0x00A2
+#define GDI_CEC_COMPARE_OPCODE_04_compare_opcode_04_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_04_compare_opcode_04_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_04_compare_opcode_04(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_04_get_compare_opcode_04(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPCODE_04                                        0x1803728c
+#define GDI_CEC_SEND_OPCODE_04_reg_addr                               "0xb803728c"
+#define GDI_CEC_SEND_OPCODE_04_reg                                    0xb803728c
+#define GDI_CEC_SEND_OPCODE_04_inst_addr                              "0x00A3"
+#define GDI_CEC_SEND_OPCODE_04_inst                                   0x00A3
+#define GDI_CEC_SEND_OPCODE_04_send_init_address_04_shift             (12)
+#define GDI_CEC_SEND_OPCODE_04_init_address_04_shift                  (8)
+#define GDI_CEC_SEND_OPCODE_04_send_opcode_04_shift                   (0)
+#define GDI_CEC_SEND_OPCODE_04_send_init_address_04_mask              (0x00001000)
+#define GDI_CEC_SEND_OPCODE_04_init_address_04_mask                   (0x00000F00)
+#define GDI_CEC_SEND_OPCODE_04_send_opcode_04_mask                    (0x000000FF)
+#define GDI_CEC_SEND_OPCODE_04_send_init_address_04(data)             (0x00001000&((data)<<12))
+#define GDI_CEC_SEND_OPCODE_04_init_address_04(data)                  (0x00000F00&((data)<<8))
+#define GDI_CEC_SEND_OPCODE_04_send_opcode_04(data)                   (0x000000FF&(data))
+#define GDI_CEC_SEND_OPCODE_04_get_send_init_address_04(data)         ((0x00001000&(data))>>12)
+#define GDI_CEC_SEND_OPCODE_04_get_init_address_04(data)              ((0x00000F00&(data))>>8)
+#define GDI_CEC_SEND_OPCODE_04_get_send_opcode_04(data)               (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPERAND_NUMBER_04                                0x18037290
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_reg_addr                       "0xb8037290"
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_reg                            0xb8037290
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_inst_addr                      "0x00A4"
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_inst                           0x00A4
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_operand_number_04_shift        (0)
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_operand_number_04_mask         (0x00000003)
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_operand_number_04(data)        (0x00000003&(data))
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_get_operand_number_04(data)    (0x00000003&(data))
+
+
+#define GDI_CEC_OPERAND_10                                            0x18037294
+#define GDI_CEC_OPERAND_10_reg_addr                                   "0xb8037294"
+#define GDI_CEC_OPERAND_10_reg                                        0xb8037294
+#define GDI_CEC_OPERAND_10_inst_addr                                  "0x00A5"
+#define GDI_CEC_OPERAND_10_inst                                       0x00A5
+#define GDI_CEC_OPERAND_10_operand_10_shift                           (0)
+#define GDI_CEC_OPERAND_10_operand_10_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_10_operand_10(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_10_get_operand_10(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_11                                            0x18037298
+#define GDI_CEC_OPERAND_11_reg_addr                                   "0xb8037298"
+#define GDI_CEC_OPERAND_11_reg                                        0xb8037298
+#define GDI_CEC_OPERAND_11_inst_addr                                  "0x00A6"
+#define GDI_CEC_OPERAND_11_inst                                       0x00A6
+#define GDI_CEC_OPERAND_11_operand_11_shift                           (0)
+#define GDI_CEC_OPERAND_11_operand_11_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_11_operand_11(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_11_get_operand_11(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_12                                            0x1803729c
+#define GDI_CEC_OPERAND_12_reg_addr                                   "0xb803729c"
+#define GDI_CEC_OPERAND_12_reg                                        0xb803729c
+#define GDI_CEC_OPERAND_12_inst_addr                                  "0x00A7"
+#define GDI_CEC_OPERAND_12_inst                                       0x00A7
+#define GDI_CEC_OPERAND_12_operand_12_shift                           (0)
+#define GDI_CEC_OPERAND_12_operand_12_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_12_operand_12(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_12_get_operand_12(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_05                                     0x180372a0
+#define GDI_CEC_COMPARE_OPCODE_05_reg_addr                            "0xb80372a0"
+#define GDI_CEC_COMPARE_OPCODE_05_reg                                 0xb80372a0
+#define GDI_CEC_COMPARE_OPCODE_05_inst_addr                           "0x00A8"
+#define GDI_CEC_COMPARE_OPCODE_05_inst                                0x00A8
+#define GDI_CEC_COMPARE_OPCODE_05_compare_opcode_05_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_05_compare_opcode_05_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_05_compare_opcode_05(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_05_get_compare_opcode_05(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_06                                     0x180372a4
+#define GDI_CEC_COMPARE_OPCODE_06_reg_addr                            "0xb80372a4"
+#define GDI_CEC_COMPARE_OPCODE_06_reg                                 0xb80372a4
+#define GDI_CEC_COMPARE_OPCODE_06_inst_addr                           "0x00A9"
+#define GDI_CEC_COMPARE_OPCODE_06_inst                                0x00A9
+#define GDI_CEC_COMPARE_OPCODE_06_compare_opcode_06_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_06_compare_opcode_06_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_06_compare_opcode_06(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_06_get_compare_opcode_06(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_07                                     0x180372a8
+#define GDI_CEC_COMPARE_OPCODE_07_reg_addr                            "0xb80372a8"
+#define GDI_CEC_COMPARE_OPCODE_07_reg                                 0xb80372a8
+#define GDI_CEC_COMPARE_OPCODE_07_inst_addr                           "0x00AA"
+#define GDI_CEC_COMPARE_OPCODE_07_inst                                0x00AA
+#define GDI_CEC_COMPARE_OPCODE_07_compare_opcode_07_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_07_compare_opcode_07_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_07_compare_opcode_07(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_07_get_compare_opcode_07(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_08                                     0x180372ac
+#define GDI_CEC_COMPARE_OPCODE_08_reg_addr                            "0xb80372ac"
+#define GDI_CEC_COMPARE_OPCODE_08_reg                                 0xb80372ac
+#define GDI_CEC_COMPARE_OPCODE_08_inst_addr                           "0x00AB"
+#define GDI_CEC_COMPARE_OPCODE_08_inst                                0x00AB
+#define GDI_CEC_COMPARE_OPCODE_08_compare_opcode_08_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_08_compare_opcode_08_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_08_compare_opcode_08(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_08_get_compare_opcode_08(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_09                                     0x180372b0
+#define GDI_CEC_COMPARE_OPCODE_09_reg_addr                            "0xb80372b0"
+#define GDI_CEC_COMPARE_OPCODE_09_reg                                 0xb80372b0
+#define GDI_CEC_COMPARE_OPCODE_09_inst_addr                           "0x00AC"
+#define GDI_CEC_COMPARE_OPCODE_09_inst                                0x00AC
+#define GDI_CEC_COMPARE_OPCODE_09_compare_opcode_09_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_09_compare_opcode_09_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_09_compare_opcode_09(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_09_get_compare_opcode_09(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_10                                     0x180372b4
+#define GDI_CEC_COMPARE_OPCODE_10_reg_addr                            "0xb80372b4"
+#define GDI_CEC_COMPARE_OPCODE_10_reg                                 0xb80372b4
+#define GDI_CEC_COMPARE_OPCODE_10_inst_addr                           "0x00AD"
+#define GDI_CEC_COMPARE_OPCODE_10_inst                                0x00AD
+#define GDI_CEC_COMPARE_OPCODE_10_compare_opcode_10_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_10_compare_opcode_10_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_10_compare_opcode_10(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_10_get_compare_opcode_10(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_11                                     0x180372b8
+#define GDI_CEC_COMPARE_OPCODE_11_reg_addr                            "0xb80372b8"
+#define GDI_CEC_COMPARE_OPCODE_11_reg                                 0xb80372b8
+#define GDI_CEC_COMPARE_OPCODE_11_inst_addr                           "0x00AE"
+#define GDI_CEC_COMPARE_OPCODE_11_inst                                0x00AE
+#define GDI_CEC_COMPARE_OPCODE_11_compare_opcode_11_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_11_compare_opcode_11_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_11_compare_opcode_11(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_11_get_compare_opcode_11(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_12                                     0x180372bc
+#define GDI_CEC_COMPARE_OPCODE_12_reg_addr                            "0xb80372bc"
+#define GDI_CEC_COMPARE_OPCODE_12_reg                                 0xb80372bc
+#define GDI_CEC_COMPARE_OPCODE_12_inst_addr                           "0x00AF"
+#define GDI_CEC_COMPARE_OPCODE_12_inst                                0x00AF
+#define GDI_CEC_COMPARE_OPCODE_12_compare_opcode_12_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_12_compare_opcode_12_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_12_compare_opcode_12(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_12_get_compare_opcode_12(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_13                                     0x180372c0
+#define GDI_CEC_COMPARE_OPCODE_13_reg_addr                            "0xb80372c0"
+#define GDI_CEC_COMPARE_OPCODE_13_reg                                 0xb80372c0
+#define GDI_CEC_COMPARE_OPCODE_13_inst_addr                           "0x00B0"
+#define GDI_CEC_COMPARE_OPCODE_13_inst                                0x00B0
+#define GDI_CEC_COMPARE_OPCODE_13_compare_opcode_13_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_13_compare_opcode_13_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_13_compare_opcode_13(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_13_get_compare_opcode_13(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_14                                     0x180372c4
+#define GDI_CEC_COMPARE_OPCODE_14_reg_addr                            "0xb80372c4"
+#define GDI_CEC_COMPARE_OPCODE_14_reg                                 0xb80372c4
+#define GDI_CEC_COMPARE_OPCODE_14_inst_addr                           "0x00B1"
+#define GDI_CEC_COMPARE_OPCODE_14_inst                                0x00B1
+#define GDI_CEC_COMPARE_OPCODE_14_compare_opcode_14_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_14_compare_opcode_14_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_14_compare_opcode_14(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_14_get_compare_opcode_14(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_15                                     0x180372c8
+#define GDI_CEC_COMPARE_OPCODE_15_reg_addr                            "0xb80372c8"
+#define GDI_CEC_COMPARE_OPCODE_15_reg                                 0xb80372c8
+#define GDI_CEC_COMPARE_OPCODE_15_inst_addr                           "0x00B2"
+#define GDI_CEC_COMPARE_OPCODE_15_inst                                0x00B2
+#define GDI_CEC_COMPARE_OPCODE_15_compare_opcode_15_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_15_compare_opcode_15_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_15_compare_opcode_15(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_15_get_compare_opcode_15(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_OPCODE_ENABLE                                         0x180372cc
+#define GDI_CEC_OPCODE_ENABLE_reg_addr                                "0xb80372cc"
+#define GDI_CEC_OPCODE_ENABLE_reg                                     0xb80372cc
+#define GDI_CEC_OPCODE_ENABLE_inst_addr                               "0x00B3"
+#define GDI_CEC_OPCODE_ENABLE_inst                                    0x00B3
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_15_shift              (14)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_14_shift              (13)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_13_shift              (12)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_12_shift              (11)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_11_shift              (10)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_10_shift              (9)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_09_shift              (8)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_08_shift              (7)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_07_shift              (6)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_06_shift              (5)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_05_shift              (4)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_04_shift              (3)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_03_shift              (2)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_02_shift              (1)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_01_shift              (0)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_15_mask               (0x00004000)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_14_mask               (0x00002000)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_13_mask               (0x00001000)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_12_mask               (0x00000800)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_11_mask               (0x00000400)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_10_mask               (0x00000200)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_09_mask               (0x00000100)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_08_mask               (0x00000080)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_07_mask               (0x00000040)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_06_mask               (0x00000020)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_05_mask               (0x00000010)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_04_mask               (0x00000008)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_03_mask               (0x00000004)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_02_mask               (0x00000002)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_01_mask               (0x00000001)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_15(data)              (0x00004000&((data)<<14))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_14(data)              (0x00002000&((data)<<13))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_13(data)              (0x00001000&((data)<<12))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_12(data)              (0x00000800&((data)<<11))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_11(data)              (0x00000400&((data)<<10))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_10(data)              (0x00000200&((data)<<9))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_09(data)              (0x00000100&((data)<<8))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_08(data)              (0x00000080&((data)<<7))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_07(data)              (0x00000040&((data)<<6))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_06(data)              (0x00000020&((data)<<5))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_05(data)              (0x00000010&((data)<<4))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_04(data)              (0x00000008&((data)<<3))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_03(data)              (0x00000004&((data)<<2))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_02(data)              (0x00000002&((data)<<1))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_01(data)              (0x00000001&(data))
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_15(data)          ((0x00004000&(data))>>14)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_14(data)          ((0x00002000&(data))>>13)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_13(data)          ((0x00001000&(data))>>12)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_12(data)          ((0x00000800&(data))>>11)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_11(data)          ((0x00000400&(data))>>10)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_10(data)          ((0x00000200&(data))>>9)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_09(data)          ((0x00000100&(data))>>8)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_08(data)          ((0x00000080&(data))>>7)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_07(data)          ((0x00000040&(data))>>6)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_06(data)          ((0x00000020&(data))>>5)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_05(data)          ((0x00000010&(data))>>4)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_04(data)          ((0x00000008&(data))>>3)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_03(data)          ((0x00000004&(data))>>2)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_02(data)          ((0x00000002&(data))>>1)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_01(data)          (0x00000001&(data))
+
+
+#define GDI_POWER_SAVING_MODE                                         0x180372d0
+#define GDI_POWER_SAVING_MODE_reg_addr                                "0xb80372d0"
+#define GDI_POWER_SAVING_MODE_reg                                     0xb80372d0
+#define GDI_POWER_SAVING_MODE_inst_addr                               "0x00B4"
+#define GDI_POWER_SAVING_MODE_inst                                    0x00B4
+#define GDI_POWER_SAVING_MODE_irq_pending_shift                       (31)
+#define GDI_POWER_SAVING_MODE_cec_msg_status_01_shift                 (25)
+#define GDI_POWER_SAVING_MODE_cec_msg_status_02_shift                 (24)
+#define GDI_POWER_SAVING_MODE_irq_by_cec_receive_special_cmd_shift    (8)
+#define GDI_POWER_SAVING_MODE_cec_rpu_en_shift                        (4)
+#define GDI_POWER_SAVING_MODE_cec_rsel_shift                          (0)
+#define GDI_POWER_SAVING_MODE_irq_pending_mask                        (0x80000000)
+#define GDI_POWER_SAVING_MODE_cec_msg_status_01_mask                  (0x02000000)
+#define GDI_POWER_SAVING_MODE_cec_msg_status_02_mask                  (0x01000000)
+#define GDI_POWER_SAVING_MODE_irq_by_cec_receive_special_cmd_mask     (0x00000100)
+#define GDI_POWER_SAVING_MODE_cec_rpu_en_mask                         (0x00000010)
+#define GDI_POWER_SAVING_MODE_cec_rsel_mask                           (0x00000007)
+#define GDI_POWER_SAVING_MODE_irq_pending(data)                       (0x80000000&((data)<<31))
+#define GDI_POWER_SAVING_MODE_cec_msg_status_01(data)                 (0x02000000&((data)<<25))
+#define GDI_POWER_SAVING_MODE_cec_msg_status_02(data)                 (0x01000000&((data)<<24))
+#define GDI_POWER_SAVING_MODE_irq_by_cec_receive_special_cmd(data)    (0x00000100&((data)<<8))
+#define GDI_POWER_SAVING_MODE_cec_rpu_en(data)                        (0x00000010&((data)<<4))
+#define GDI_POWER_SAVING_MODE_cec_rsel(data)                          (0x00000007&(data))
+#define GDI_POWER_SAVING_MODE_get_irq_pending(data)                   ((0x80000000&(data))>>31)
+#define GDI_POWER_SAVING_MODE_get_cec_msg_status_01(data)             ((0x02000000&(data))>>25)
+#define GDI_POWER_SAVING_MODE_get_cec_msg_status_02(data)             ((0x01000000&(data))>>24)
+#define GDI_POWER_SAVING_MODE_get_irq_by_cec_receive_special_cmd(data)  ((0x00000100&(data))>>8)
+#define GDI_POWER_SAVING_MODE_get_cec_rpu_en(data)                    ((0x00000010&(data))>>4)
+#define GDI_POWER_SAVING_MODE_get_cec_rsel(data)                      (0x00000007&(data))
+
+
+#define CEC_RXACKTCR0                                                 0x180372d4
+#define CEC_RXACKTCR0_reg_addr                                        "0xb80372d4"
+#define CEC_RXACKTCR0_reg                                             0xb80372d4
+#define CEC_RXACKTCR0_inst_addr                                       "0x00B5"
+#define CEC_RXACKTCR0_inst                                            0x00B5
+#define CEC_RXACKTCR0_rx_ack_wait_1_sel_shift                         (26)
+#define CEC_RXACKTCR0_rx_ack_wait_2_sel_shift                         (25)
+#define CEC_RXACKTCR0_rx_ack_wait_3_sel_shift                         (24)
+#define CEC_RXACKTCR0_rx_ack_wait_1_shift                             (16)
+#define CEC_RXACKTCR0_rx_ack_wait_2_shift                             (8)
+#define CEC_RXACKTCR0_rx_ack_wait_3_shift                             (0)
+#define CEC_RXACKTCR0_rx_ack_wait_1_sel_mask                          (0x04000000)
+#define CEC_RXACKTCR0_rx_ack_wait_2_sel_mask                          (0x02000000)
+#define CEC_RXACKTCR0_rx_ack_wait_3_sel_mask                          (0x01000000)
+#define CEC_RXACKTCR0_rx_ack_wait_1_mask                              (0x00FF0000)
+#define CEC_RXACKTCR0_rx_ack_wait_2_mask                              (0x0000FF00)
+#define CEC_RXACKTCR0_rx_ack_wait_3_mask                              (0x000000FF)
+#define CEC_RXACKTCR0_rx_ack_wait_1_sel(data)                         (0x04000000&((data)<<26))
+#define CEC_RXACKTCR0_rx_ack_wait_2_sel(data)                         (0x02000000&((data)<<25))
+#define CEC_RXACKTCR0_rx_ack_wait_3_sel(data)                         (0x01000000&((data)<<24))
+#define CEC_RXACKTCR0_rx_ack_wait_1(data)                             (0x00FF0000&((data)<<16))
+#define CEC_RXACKTCR0_rx_ack_wait_2(data)                             (0x0000FF00&((data)<<8))
+#define CEC_RXACKTCR0_rx_ack_wait_3(data)                             (0x000000FF&(data))
+#define CEC_RXACKTCR0_get_rx_ack_wait_1_sel(data)                     ((0x04000000&(data))>>26)
+#define CEC_RXACKTCR0_get_rx_ack_wait_2_sel(data)                     ((0x02000000&(data))>>25)
+#define CEC_RXACKTCR0_get_rx_ack_wait_3_sel(data)                     ((0x01000000&(data))>>24)
+#define CEC_RXACKTCR0_get_rx_ack_wait_1(data)                         ((0x00FF0000&(data))>>16)
+#define CEC_RXACKTCR0_get_rx_ack_wait_2(data)                         ((0x0000FF00&(data))>>8)
+#define CEC_RXACKTCR0_get_rx_ack_wait_3(data)                         (0x000000FF&(data))
+
+
+#define CEC_RXACKTCR1                                                 0x180372d8
+#define CEC_RXACKTCR1_reg_addr                                        "0xb80372d8"
+#define CEC_RXACKTCR1_reg                                             0xb80372d8
+#define CEC_RXACKTCR1_inst_addr                                       "0x00B6"
+#define CEC_RXACKTCR1_inst                                            0x00B6
+#define CEC_RXACKTCR1_rx_ack_low_sel_shift                            (26)
+#define CEC_RXACKTCR1_rx_ack_bit_sel_shift                            (25)
+#define CEC_RXACKTCR1_rx_ack_line_err_sel_shift                       (24)
+#define CEC_RXACKTCR1_rx_ack_low_shift                                (16)
+#define CEC_RXACKTCR1_rx_ack_bit_shift                                (8)
+#define CEC_RXACKTCR1_rx_ack_line_err_shift                           (0)
+#define CEC_RXACKTCR1_rx_ack_low_sel_mask                             (0x04000000)
+#define CEC_RXACKTCR1_rx_ack_bit_sel_mask                             (0x02000000)
+#define CEC_RXACKTCR1_rx_ack_line_err_sel_mask                        (0x01000000)
+#define CEC_RXACKTCR1_rx_ack_low_mask                                 (0x00FF0000)
+#define CEC_RXACKTCR1_rx_ack_bit_mask                                 (0x0000FF00)
+#define CEC_RXACKTCR1_rx_ack_line_err_mask                            (0x000000FF)
+#define CEC_RXACKTCR1_rx_ack_low_sel(data)                            (0x04000000&((data)<<26))
+#define CEC_RXACKTCR1_rx_ack_bit_sel(data)                            (0x02000000&((data)<<25))
+#define CEC_RXACKTCR1_rx_ack_line_err_sel(data)                       (0x01000000&((data)<<24))
+#define CEC_RXACKTCR1_rx_ack_low(data)                                (0x00FF0000&((data)<<16))
+#define CEC_RXACKTCR1_rx_ack_bit(data)                                (0x0000FF00&((data)<<8))
+#define CEC_RXACKTCR1_rx_ack_line_err(data)                           (0x000000FF&(data))
+#define CEC_RXACKTCR1_get_rx_ack_low_sel(data)                        ((0x04000000&(data))>>26)
+#define CEC_RXACKTCR1_get_rx_ack_bit_sel(data)                        ((0x02000000&(data))>>25)
+#define CEC_RXACKTCR1_get_rx_ack_line_err_sel(data)                   ((0x01000000&(data))>>24)
+#define CEC_RXACKTCR1_get_rx_ack_low(data)                            ((0x00FF0000&(data))>>16)
+#define CEC_RXACKTCR1_get_rx_ack_bit(data)                            ((0x0000FF00&(data))>>8)
+#define CEC_RXACKTCR1_get_rx_ack_line_err(data)                       (0x000000FF&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/MHL_fw.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/MHL_fw.h
new file mode 100644
index 00000000..dbe6e54
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/MHL_fw.h
@@ -0,0 +1,297 @@
+// This file is generated using the spec version 1.39, firmware template version 1.39and SRIF Parser                                                                                source code SVN rev:802                    Version flow no.:1.1.66
+#ifndef _MHL_REG_H_INCLUDED_
+#define _MHL_REG_H_INCLUDED_
+
+//#define  _MHL_USE_STRUCT
+#ifdef _MHL_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    mhl_de_sel:1;
+    unsigned int    mhl_tran_err_thrd:4;
+    unsigned int    mhl_neg_de_err_thrd:4;
+    unsigned int    mhl_pos_de_err_thrd:4;
+    unsigned int    dummy1800f600_15:1;
+    unsigned int    mhl_neg_de_lowbd:7;
+    unsigned int    dummy1800f600_7_6:2;
+    unsigned int    mhl_pos_de_lowbd:6;
+}MHL_dal_ctrl;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    mhl_de_glitch_cycle:4;
+    unsigned int    reserved_1:1;
+    unsigned int    mhl_ver_1_2:1;
+    unsigned int    mhl_de_glitch_en:1;
+    unsigned int    pn_swap:1;
+}MHL_dal_status;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    mhl_mode_err_wd:1;
+    unsigned int    mhl_mode_err_int:1;
+    unsigned int    mhl_mode:1;
+    unsigned int    reserved_1:3;
+    unsigned int    mhl_mode_det_per_sel:1;
+    unsigned int    mhl_mode_det_per:16;
+    unsigned int    mhl_mode_det:2;
+    unsigned int    mhl_mode_det_cont:1;
+    unsigned int    mhl_mode_det_start:1;
+}MHL_md_ctrl;
+
+typedef struct
+{
+    unsigned int    threshold_pp:16;
+    unsigned int    threshold_24bits:16;
+}MHL_md_threshold;
+
+typedef struct
+{
+    unsigned int    det_cnt_pp:16;
+    unsigned int    det_cnt_24bit:16;
+}MHL_md_cnt;
+
+typedef struct
+{
+    unsigned int    reserved_0:19;
+    unsigned int    video_wd_en:1;
+    unsigned int    audio_wd_en:1;
+    unsigned int    ch_bound_chg_wd_en:1;
+    unsigned int    ch_bound_chg_int_en:1;
+    unsigned int    ch_bound_chg_det:1;
+    unsigned int    reserved_1:1;
+    unsigned int    demux_sel:3;
+    unsigned int    dvi_ch_sync:1;
+    unsigned int    reserved_2:1;
+    unsigned int    mhl_pp_en:1;
+    unsigned int    mhl_en:1;
+}MHL_demux_ctrl;
+
+typedef struct
+{
+    unsigned int    reserved_0:19;
+    unsigned int    ch_bound_chg:1;
+    unsigned int    reserved_1:3;
+    unsigned int    mhl_mode_err:1;
+    unsigned int    reserved_2:2;
+    unsigned int    non_ctrl_glitch_occ_flag:1;
+    unsigned int    ctrl_glitch_occr_flag:1;
+    unsigned int    reserved_3:1;
+    unsigned int    mhl_tran_err_flag:1;
+    unsigned int    mhl_pos_de_err_flag:1;
+    unsigned int    mhl_neg_de_err_flag:1;
+}MHL_status;
+#endif
+
+
+#define MHL_DAL_CTRL                                                  0x1800f600
+#define MHL_DAL_CTRL_reg_addr                                         "0xb800f600"
+#define MHL_DAL_CTRL_reg                                              0xb800f600
+#define MHL_DAL_CTRL_inst_addr                                        "0x0180"
+#define MHL_DAL_CTRL_inst                                             0x0180
+#define MHL_DAL_CTRL_mhl_de_sel_shift                                 (28)
+#define MHL_DAL_CTRL_mhl_tran_err_thrd_shift                          (24)
+#define MHL_DAL_CTRL_mhl_neg_de_err_thrd_shift                        (20)
+#define MHL_DAL_CTRL_mhl_pos_de_err_thrd_shift                        (16)
+#define MHL_DAL_CTRL_dummy1800f600_15_shift                           (15)
+#define MHL_DAL_CTRL_mhl_neg_de_lowbd_shift                           (8)
+#define MHL_DAL_CTRL_dummy1800f600_7_6_shift                          (6)
+#define MHL_DAL_CTRL_mhl_pos_de_lowbd_shift                           (0)
+#define MHL_DAL_CTRL_mhl_de_sel_mask                                  (0x10000000)
+#define MHL_DAL_CTRL_mhl_tran_err_thrd_mask                           (0x0F000000)
+#define MHL_DAL_CTRL_mhl_neg_de_err_thrd_mask                         (0x00F00000)
+#define MHL_DAL_CTRL_mhl_pos_de_err_thrd_mask                         (0x000F0000)
+#define MHL_DAL_CTRL_dummy1800f600_15_mask                            (0x00008000)
+#define MHL_DAL_CTRL_mhl_neg_de_lowbd_mask                            (0x00007F00)
+#define MHL_DAL_CTRL_dummy1800f600_7_6_mask                           (0x000000C0)
+#define MHL_DAL_CTRL_mhl_pos_de_lowbd_mask                            (0x0000003F)
+#define MHL_DAL_CTRL_mhl_de_sel(data)                                 (0x10000000&((data)<<28))
+#define MHL_DAL_CTRL_mhl_tran_err_thrd(data)                          (0x0F000000&((data)<<24))
+#define MHL_DAL_CTRL_mhl_neg_de_err_thrd(data)                        (0x00F00000&((data)<<20))
+#define MHL_DAL_CTRL_mhl_pos_de_err_thrd(data)                        (0x000F0000&((data)<<16))
+#define MHL_DAL_CTRL_dummy1800f600_15(data)                           (0x00008000&((data)<<15))
+#define MHL_DAL_CTRL_mhl_neg_de_lowbd(data)                           (0x00007F00&((data)<<8))
+#define MHL_DAL_CTRL_dummy1800f600_7_6(data)                          (0x000000C0&((data)<<6))
+#define MHL_DAL_CTRL_mhl_pos_de_lowbd(data)                           (0x0000003F&(data))
+#define MHL_DAL_CTRL_get_mhl_de_sel(data)                             ((0x10000000&(data))>>28)
+#define MHL_DAL_CTRL_get_mhl_tran_err_thrd(data)                      ((0x0F000000&(data))>>24)
+#define MHL_DAL_CTRL_get_mhl_neg_de_err_thrd(data)                    ((0x00F00000&(data))>>20)
+#define MHL_DAL_CTRL_get_mhl_pos_de_err_thrd(data)                    ((0x000F0000&(data))>>16)
+#define MHL_DAL_CTRL_get_dummy1800f600_15(data)                       ((0x00008000&(data))>>15)
+#define MHL_DAL_CTRL_get_mhl_neg_de_lowbd(data)                       ((0x00007F00&(data))>>8)
+#define MHL_DAL_CTRL_get_dummy1800f600_7_6(data)                      ((0x000000C0&(data))>>6)
+#define MHL_DAL_CTRL_get_mhl_pos_de_lowbd(data)                       (0x0000003F&(data))
+
+
+#define MHL_DAL_STATUS                                                0x1800f604
+#define MHL_DAL_STATUS_reg_addr                                       "0xb800f604"
+#define MHL_DAL_STATUS_reg                                            0xb800f604
+#define MHL_DAL_STATUS_inst_addr                                      "0x0181"
+#define MHL_DAL_STATUS_inst                                           0x0181
+#define MHL_DAL_STATUS_mhl_de_glitch_cycle_shift                      (4)
+#define MHL_DAL_STATUS_mhl_ver_1_2_shift                              (2)
+#define MHL_DAL_STATUS_mhl_de_glitch_en_shift                         (1)
+#define MHL_DAL_STATUS_pn_swap_shift                                  (0)
+#define MHL_DAL_STATUS_mhl_de_glitch_cycle_mask                       (0x000000F0)
+#define MHL_DAL_STATUS_mhl_ver_1_2_mask                               (0x00000004)
+#define MHL_DAL_STATUS_mhl_de_glitch_en_mask                          (0x00000002)
+#define MHL_DAL_STATUS_pn_swap_mask                                   (0x00000001)
+#define MHL_DAL_STATUS_mhl_de_glitch_cycle(data)                      (0x000000F0&((data)<<4))
+#define MHL_DAL_STATUS_mhl_ver_1_2(data)                              (0x00000004&((data)<<2))
+#define MHL_DAL_STATUS_mhl_de_glitch_en(data)                         (0x00000002&((data)<<1))
+#define MHL_DAL_STATUS_pn_swap(data)                                  (0x00000001&(data))
+#define MHL_DAL_STATUS_get_mhl_de_glitch_cycle(data)                  ((0x000000F0&(data))>>4)
+#define MHL_DAL_STATUS_get_mhl_ver_1_2(data)                          ((0x00000004&(data))>>2)
+#define MHL_DAL_STATUS_get_mhl_de_glitch_en(data)                     ((0x00000002&(data))>>1)
+#define MHL_DAL_STATUS_get_pn_swap(data)                              (0x00000001&(data))
+
+
+#define MHL_MD_CTRL                                                   0x1800f608
+#define MHL_MD_CTRL_reg_addr                                          "0xb800f608"
+#define MHL_MD_CTRL_reg                                               0xb800f608
+#define MHL_MD_CTRL_inst_addr                                         "0x0182"
+#define MHL_MD_CTRL_inst                                              0x0182
+#define MHL_MD_CTRL_mhl_mode_err_wd_shift                             (26)
+#define MHL_MD_CTRL_mhl_mode_err_int_shift                            (25)
+#define MHL_MD_CTRL_mhl_mode_shift                                    (24)
+#define MHL_MD_CTRL_mhl_mode_det_per_sel_shift                        (20)
+#define MHL_MD_CTRL_mhl_mode_det_per_shift                            (4)
+#define MHL_MD_CTRL_mhl_mode_det_shift                                (2)
+#define MHL_MD_CTRL_mhl_mode_det_cont_shift                           (1)
+#define MHL_MD_CTRL_mhl_mode_det_start_shift                          (0)
+#define MHL_MD_CTRL_mhl_mode_err_wd_mask                              (0x04000000)
+#define MHL_MD_CTRL_mhl_mode_err_int_mask                             (0x02000000)
+#define MHL_MD_CTRL_mhl_mode_mask                                     (0x01000000)
+#define MHL_MD_CTRL_mhl_mode_det_per_sel_mask                         (0x00100000)
+#define MHL_MD_CTRL_mhl_mode_det_per_mask                             (0x000FFFF0)
+#define MHL_MD_CTRL_mhl_mode_det_mask                                 (0x0000000C)
+#define MHL_MD_CTRL_mhl_mode_det_cont_mask                            (0x00000002)
+#define MHL_MD_CTRL_mhl_mode_det_start_mask                           (0x00000001)
+#define MHL_MD_CTRL_mhl_mode_err_wd(data)                             (0x04000000&((data)<<26))
+#define MHL_MD_CTRL_mhl_mode_err_int(data)                            (0x02000000&((data)<<25))
+#define MHL_MD_CTRL_mhl_mode(data)                                    (0x01000000&((data)<<24))
+#define MHL_MD_CTRL_mhl_mode_det_per_sel(data)                        (0x00100000&((data)<<20))
+#define MHL_MD_CTRL_mhl_mode_det_per(data)                            (0x000FFFF0&((data)<<4))
+#define MHL_MD_CTRL_mhl_mode_det(data)                                (0x0000000C&((data)<<2))
+#define MHL_MD_CTRL_mhl_mode_det_cont(data)                           (0x00000002&((data)<<1))
+#define MHL_MD_CTRL_mhl_mode_det_start(data)                          (0x00000001&(data))
+#define MHL_MD_CTRL_get_mhl_mode_err_wd(data)                         ((0x04000000&(data))>>26)
+#define MHL_MD_CTRL_get_mhl_mode_err_int(data)                        ((0x02000000&(data))>>25)
+#define MHL_MD_CTRL_get_mhl_mode(data)                                ((0x01000000&(data))>>24)
+#define MHL_MD_CTRL_get_mhl_mode_det_per_sel(data)                    ((0x00100000&(data))>>20)
+#define MHL_MD_CTRL_get_mhl_mode_det_per(data)                        ((0x000FFFF0&(data))>>4)
+#define MHL_MD_CTRL_get_mhl_mode_det(data)                            ((0x0000000C&(data))>>2)
+#define MHL_MD_CTRL_get_mhl_mode_det_cont(data)                       ((0x00000002&(data))>>1)
+#define MHL_MD_CTRL_get_mhl_mode_det_start(data)                      (0x00000001&(data))
+
+
+#define MHL_MD_THRESHOLD                                              0x1800f60c
+#define MHL_MD_THRESHOLD_reg_addr                                     "0xb800f60c"
+#define MHL_MD_THRESHOLD_reg                                          0xb800f60c
+#define MHL_MD_THRESHOLD_inst_addr                                    "0x0183"
+#define MHL_MD_THRESHOLD_inst                                         0x0183
+#define MHL_MD_THRESHOLD_threshold_pp_shift                           (16)
+#define MHL_MD_THRESHOLD_threshold_24bits_shift                       (0)
+#define MHL_MD_THRESHOLD_threshold_pp_mask                            (0xFFFF0000)
+#define MHL_MD_THRESHOLD_threshold_24bits_mask                        (0x0000FFFF)
+#define MHL_MD_THRESHOLD_threshold_pp(data)                           (0xFFFF0000&((data)<<16))
+#define MHL_MD_THRESHOLD_threshold_24bits(data)                       (0x0000FFFF&(data))
+#define MHL_MD_THRESHOLD_get_threshold_pp(data)                       ((0xFFFF0000&(data))>>16)
+#define MHL_MD_THRESHOLD_get_threshold_24bits(data)                   (0x0000FFFF&(data))
+
+
+#define MHL_MD_CNT                                                    0x1800f610
+#define MHL_MD_CNT_reg_addr                                           "0xb800f610"
+#define MHL_MD_CNT_reg                                                0xb800f610
+#define MHL_MD_CNT_inst_addr                                          "0x0184"
+#define MHL_MD_CNT_inst                                               0x0184
+#define MHL_MD_CNT_det_cnt_pp_shift                                   (16)
+#define MHL_MD_CNT_det_cnt_24bit_shift                                (0)
+#define MHL_MD_CNT_det_cnt_pp_mask                                    (0xFFFF0000)
+#define MHL_MD_CNT_det_cnt_24bit_mask                                 (0x0000FFFF)
+#define MHL_MD_CNT_det_cnt_pp(data)                                   (0xFFFF0000&((data)<<16))
+#define MHL_MD_CNT_det_cnt_24bit(data)                                (0x0000FFFF&(data))
+#define MHL_MD_CNT_get_det_cnt_pp(data)                               ((0xFFFF0000&(data))>>16)
+#define MHL_MD_CNT_get_det_cnt_24bit(data)                            (0x0000FFFF&(data))
+
+
+#define MHL_DEMUX_CTRL                                                0x1800f614
+#define MHL_DEMUX_CTRL_reg_addr                                       "0xb800f614"
+#define MHL_DEMUX_CTRL_reg                                            0xb800f614
+#define MHL_DEMUX_CTRL_inst_addr                                      "0x0185"
+#define MHL_DEMUX_CTRL_inst                                           0x0185
+#define MHL_DEMUX_CTRL_video_wd_en_shift                              (12)
+#define MHL_DEMUX_CTRL_audio_wd_en_shift                              (11)
+#define MHL_DEMUX_CTRL_ch_bound_chg_wd_en_shift                       (10)
+#define MHL_DEMUX_CTRL_ch_bound_chg_int_en_shift                      (9)
+#define MHL_DEMUX_CTRL_ch_bound_chg_det_shift                         (8)
+#define MHL_DEMUX_CTRL_demux_sel_shift                                (4)
+#define MHL_DEMUX_CTRL_dvi_ch_sync_shift                              (3)
+#define MHL_DEMUX_CTRL_mhl_pp_en_shift                                (1)
+#define MHL_DEMUX_CTRL_mhl_en_shift                                   (0)
+#define MHL_DEMUX_CTRL_video_wd_en_mask                               (0x00001000)
+#define MHL_DEMUX_CTRL_audio_wd_en_mask                               (0x00000800)
+#define MHL_DEMUX_CTRL_ch_bound_chg_wd_en_mask                        (0x00000400)
+#define MHL_DEMUX_CTRL_ch_bound_chg_int_en_mask                       (0x00000200)
+#define MHL_DEMUX_CTRL_ch_bound_chg_det_mask                          (0x00000100)
+#define MHL_DEMUX_CTRL_demux_sel_mask                                 (0x00000070)
+#define MHL_DEMUX_CTRL_dvi_ch_sync_mask                               (0x00000008)
+#define MHL_DEMUX_CTRL_mhl_pp_en_mask                                 (0x00000002)
+#define MHL_DEMUX_CTRL_mhl_en_mask                                    (0x00000001)
+#define MHL_DEMUX_CTRL_video_wd_en(data)                              (0x00001000&((data)<<12))
+#define MHL_DEMUX_CTRL_audio_wd_en(data)                              (0x00000800&((data)<<11))
+#define MHL_DEMUX_CTRL_ch_bound_chg_wd_en(data)                       (0x00000400&((data)<<10))
+#define MHL_DEMUX_CTRL_ch_bound_chg_int_en(data)                      (0x00000200&((data)<<9))
+#define MHL_DEMUX_CTRL_ch_bound_chg_det(data)                         (0x00000100&((data)<<8))
+#define MHL_DEMUX_CTRL_demux_sel(data)                                (0x00000070&((data)<<4))
+#define MHL_DEMUX_CTRL_dvi_ch_sync(data)                              (0x00000008&((data)<<3))
+#define MHL_DEMUX_CTRL_mhl_pp_en(data)                                (0x00000002&((data)<<1))
+#define MHL_DEMUX_CTRL_mhl_en(data)                                   (0x00000001&(data))
+#define MHL_DEMUX_CTRL_get_video_wd_en(data)                          ((0x00001000&(data))>>12)
+#define MHL_DEMUX_CTRL_get_audio_wd_en(data)                          ((0x00000800&(data))>>11)
+#define MHL_DEMUX_CTRL_get_ch_bound_chg_wd_en(data)                   ((0x00000400&(data))>>10)
+#define MHL_DEMUX_CTRL_get_ch_bound_chg_int_en(data)                  ((0x00000200&(data))>>9)
+#define MHL_DEMUX_CTRL_get_ch_bound_chg_det(data)                     ((0x00000100&(data))>>8)
+#define MHL_DEMUX_CTRL_get_demux_sel(data)                            ((0x00000070&(data))>>4)
+#define MHL_DEMUX_CTRL_get_dvi_ch_sync(data)                          ((0x00000008&(data))>>3)
+#define MHL_DEMUX_CTRL_get_mhl_pp_en(data)                            ((0x00000002&(data))>>1)
+#define MHL_DEMUX_CTRL_get_mhl_en(data)                               (0x00000001&(data))
+
+
+#define MHL_STATUS                                                    0x1800f618
+#define MHL_STATUS_reg_addr                                           "0xb800f618"
+#define MHL_STATUS_reg                                                0xb800f618
+#define MHL_STATUS_inst_addr                                          "0x0186"
+#define MHL_STATUS_inst                                               0x0186
+#define MHL_STATUS_ch_bound_chg_shift                                 (12)
+#define MHL_STATUS_mhl_mode_err_shift                                 (8)
+#define MHL_STATUS_non_ctrl_glitch_occ_flag_shift                     (5)
+#define MHL_STATUS_ctrl_glitch_occr_flag_shift                        (4)
+#define MHL_STATUS_mhl_tran_err_flag_shift                            (2)
+#define MHL_STATUS_mhl_pos_de_err_flag_shift                          (1)
+#define MHL_STATUS_mhl_neg_de_err_flag_shift                          (0)
+#define MHL_STATUS_ch_bound_chg_mask                                  (0x00001000)
+#define MHL_STATUS_mhl_mode_err_mask                                  (0x00000100)
+#define MHL_STATUS_non_ctrl_glitch_occ_flag_mask                      (0x00000020)
+#define MHL_STATUS_ctrl_glitch_occr_flag_mask                         (0x00000010)
+#define MHL_STATUS_mhl_tran_err_flag_mask                             (0x00000004)
+#define MHL_STATUS_mhl_pos_de_err_flag_mask                           (0x00000002)
+#define MHL_STATUS_mhl_neg_de_err_flag_mask                           (0x00000001)
+#define MHL_STATUS_ch_bound_chg(data)                                 (0x00001000&((data)<<12))
+#define MHL_STATUS_mhl_mode_err(data)                                 (0x00000100&((data)<<8))
+#define MHL_STATUS_non_ctrl_glitch_occ_flag(data)                     (0x00000020&((data)<<5))
+#define MHL_STATUS_ctrl_glitch_occr_flag(data)                        (0x00000010&((data)<<4))
+#define MHL_STATUS_mhl_tran_err_flag(data)                            (0x00000004&((data)<<2))
+#define MHL_STATUS_mhl_pos_de_err_flag(data)                          (0x00000002&((data)<<1))
+#define MHL_STATUS_mhl_neg_de_err_flag(data)                          (0x00000001&(data))
+#define MHL_STATUS_get_ch_bound_chg(data)                             ((0x00001000&(data))>>12)
+#define MHL_STATUS_get_mhl_mode_err(data)                             ((0x00000100&(data))>>8)
+#define MHL_STATUS_get_non_ctrl_glitch_occ_flag(data)                 ((0x00000020&(data))>>5)
+#define MHL_STATUS_get_ctrl_glitch_occr_flag(data)                    ((0x00000010&(data))>>4)
+#define MHL_STATUS_get_mhl_tran_err_flag(data)                        ((0x00000004&(data))>>2)
+#define MHL_STATUS_get_mhl_pos_de_err_flag(data)                      ((0x00000002&(data))>>1)
+#define MHL_STATUS_get_mhl_neg_de_err_flag(data)                      (0x00000001&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/dragon_verify.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/dragon_verify.h
new file mode 100644
index 00000000..544f1d3
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/dragon_verify.h
@@ -0,0 +1,162 @@
+
+/*=============================================================
+ * Copyright C        Realtek Semiconductor Corporation, 2006 *
+ * All rights reserved.                                       *
+ *============================================================*/
+
+/*======================= Description ========================*/
+/**
+ * @file
+ *   This header file for Dragon's defines.
+ * @Author Temin Kuo
+ * @date 2006/10/12
+ * @version { 1.0 }
+ *
+ */
+
+/*======================= CVS Headers =========================
+  $Header: $
+
+  $Log: $
+ *=============================================================*/
+
+#ifndef _DRAGON_VERIFY_H
+
+#define _DRAGON_VERIFY_H
+
+#define CONFIG_SYS_202000
+
+#ifdef CONFIG_SYS_189000
+#undef CPU_CLOCK
+#define CPU_CLOCK       (189000*1000)
+#endif
+
+#ifdef CONFIG_SYS_202000
+#undef CPU_CLOCK
+#define CPU_CLOCK       (202000*1000)
+#endif
+
+
+#ifndef CPU_CLOCK
+#define CPU_CLOCK		(27000*1000)
+#endif
+
+#define BIT(x)	(1 << (x))
+
+#define rtd_inb(offset)		(*(volatile unsigned char *)( offset))
+#define rtd_inw(offset)	(*(volatile unsigned short *)(offset))
+#define rtd_inl(offset)		(*(volatile unsigned long *)(offset))
+
+#define rtd_outb(offset,val)	(*(volatile unsigned char *)(offset) = val)
+#define rtd_outw(offset,val)	(*(volatile unsigned short *)(offset) = val)
+#define rtd_outl(offset,val)		(*(volatile unsigned long *)(offset) = val)
+
+#ifndef MAX
+#define MAX(x,y)		((x)>(y)?(x):(y))
+#endif
+#ifndef ALIGNED
+#define ALIGNED(addr, size)	(((addr)+(size)-1)  & ~((size)-1))
+#endif
+
+/// ****************************
+
+//For Memory Controller
+
+///////////////////////////////////////////////////////
+//
+// Memory Mapping Area
+//
+///////////////////////////////////////////////////////
+#define MMA_CODE_PHY_START 	(0x1000)		///< Physical address for verifier code/data, just for info.
+#define MMA_STACK_PHY_START 	(0x100000)	///< Physical address for verifier stack
+
+/// Audio delay buffers
+#define MMA_AUDIO_PHY_START	MMA_STACK_PHY_START
+#define MMA_AUDIO_SIZE			(3820*4*8)	///< 3820 samples * 4 Byte/sample * 8 channels
+#define MMA_AUDIO_PHY_END		(MMA_AUDIO_PHY_START+MMA_AUDIO_SIZE)
+
+/// Video Decoder 3D-mode field buffers
+#define MMA_VDC_NTSC_SIZE		((((910*525*2-256*64*4)*10/8)+4) & (~3))		///< Word-aligned
+#define MMA_VDC_PAL_SIZE		((((1135*625*2-256*64*4)*10/8)+4) & (~3))	///< Word-aligned, 0x19CF7D
+
+#define MMA_VDC_PHY_START		MMA_AUDIO_PHY_END	
+#define MMA_VDC_SIZE			MMA_VDC_PAL_SIZE
+#define MMA_VDC_PHY_END		(MMA_VDC_PHY_START+MMA_VDC_SIZE)
+
+#define DDR_ROW_SIZE                    (2*512*4*2)             ///< 16-bit DDR, 9/8 bit column address, 4 banks
+
+/// Cross Color, De-interlace, Noise_Reduction field buffers
+#define MMA_XCDINR_PHY_START	  MMA_VDC_PHY_END
+#define MMA_XCDINR_3A_SIZE	  (1920*(1080/2)*2*2) ///< each pixel with 2 bytes, 2 field buffes, 0x7E9000
+#define MMA_XCDINR_5A_SIZE	  (720*(576/2)*2*4) ///< each pixel with 2 bytes, 4 field buffes, 0x195000
+#define MMA_XCDINR_SIZE		  MAX(MMA_XCDINR_3A_SIZE, MMA_XCDINR_5A_SIZE)
+#define MMA_XCDINR_FIELD_SIZE     ((1920*(1080/2)*20)/8) ///each pixel is 20 bits  
+#define MMA_XCDINR_ADDR1_PHY_ADDR ALIGNED(MMA_XCDINR_PHY_START, DDR_ROW_SIZE)
+#define MMA_XCDINR_ADDR1_PHY_END  (MMA_XCDINR_ADDR1_PHY_ADDR+MMA_XCDINR_FIELD_SIZE)
+#define MMA_XCDINR_ADDR2_PHY_ADDR ALIGNED(MMA_XCDINR_ADDR1_PHY_END, DDR_ROW_SIZE)
+#define MMA_XCDINR_ADDR2_PHY_END  (MMA_XCDINR_ADDR2_PHY_ADDR+MMA_XCDINR_FIELD_SIZE)
+#define MMA_XCDINR_ADDR3_PHY_ADDR ALIGNED(MMA_XCDINR_ADDR2_PHY_END, DDR_ROW_SIZE)
+#define MMA_XCDINR_ADDR3_PHY_END  (MMA_XCDINR_ADDR3_PHY_ADDR+MMA_XCDINR_FIELD_SIZE)
+#define MMA_XCDINR_ADDR4_PHY_ADDR ALIGNED(MMA_XCDINR_ADDR3_PHY_END, DDR_ROW_SIZE)
+#define MMA_XCDINR_ADDR4_PHY_END  (MMA_XCDINR_ADDR4_PHY_ADDR+MMA_XCDINR_FIELD_SIZE)
+
+#define MMA_XCDINR_ADDR1_3D_PHY_ADDR ALIGNED(MMA_XCDINR_ADDR4_PHY_END, DDR_ROW_SIZE)
+#define MMA_XCDINR_ADDR1_3D_PHY_END  (MMA_XCDINR_ADDR1_3D_PHY_ADDR+MMA_XCDINR_FIELD_SIZE)
+#define MMA_XCDINR_ADDR2_3D_PHY_ADDR ALIGNED(MMA_XCDINR_ADDR1_3D_PHY_END, DDR_ROW_SIZE)
+#define MMA_XCDINR_ADDR2_3D_PHY_END  (MMA_XCDINR_ADDR2_3D_PHY_ADDR+MMA_XCDINR_FIELD_SIZE)
+#define MMA_XCDINR_ADDR3_3D_PHY_ADDR ALIGNED(MMA_XCDINR_ADDR2_3D_PHY_END, DDR_ROW_SIZE)
+#define MMA_XCDINR_ADDR3_3D_PHY_END  (MMA_XCDINR_ADDR3_3D_PHY_ADDR+MMA_XCDINR_FIELD_SIZE)
+#define MMA_XCDINR_ADDR4_3D_PHY_ADDR ALIGNED(MMA_XCDINR_ADDR3_3D_PHY_END, DDR_ROW_SIZE)
+#define MMA_XCDINR_ADDR4_3D_PHY_END  (MMA_XCDINR_ADDR4_3D_PHY_ADDR+MMA_XCDINR_FIELD_SIZE)
+
+
+//#define MMA_XCDINR_PHY_END	(MMA_XCDINR_PHY_START+MMA_XCDINR_SIZE)
+#define MMA_XCDINR_PHY_END    (MMA_XCDINR_ADDR4_3D_PHY_END)
+
+/// Disp2 FRC buffers, double buffer ( 2 blocks)
+//#define MMA_FRC2B1_PHY_ADDR		ALIGNED(MMA_XCDINR_PHY_END, DDR_ROW_SIZE)	///< Physical address for frame rate conversion
+#define MMA_FRC2B1_PHY_ADDR		ALIGNED((MMA_FRC1B1_PHY_START+0x40000000), DDR_ROW_SIZE)
+//#define MMA_FRC2B1_SIZE			(1366*768*2)	///< each pixel with 16bits, 0xCA8000
+#define MMA_FRC2B1_SIZE                 (1920*1080*2)    ///< each pixel with 16bits, 0xCA8000
+#define MMA_FRC2B1_PHY_END		(MMA_FRC2B1_PHY_ADDR+MMA_FRC2B1_SIZE)
+#define MMA_FRC2B2_PHY_ADDR		ALIGNED(MMA_FRC2B1_PHY_END, DDR_ROW_SIZE)
+#define MMA_FRC2B2_SIZE			MMA_FRC2B1_SIZE
+#define MMA_FRC2B2_PHY_END		(MMA_FRC2B2_PHY_ADDR+MMA_FRC2B2_SIZE)
+#define MMA_FRC2B3_PHY_ADDR		ALIGNED(MMA_FRC2B2_PHY_END, DDR_ROW_SIZE)
+#define MMA_FRC2B3_SIZE			MMA_FRC2B1_SIZE
+#define MMA_FRC2B3_PHY_END		(MMA_FRC2B3_PHY_ADDR+MMA_FRC2B3_SIZE)
+
+/// Disp1 FRC buffer shall not be used.  Use frame sync for bandwidth concern
+//#define MMA_FRC1B1_PHY_START	ALIGNED(MMA_FRC2B3_PHY_END, DDR_ROW_SIZE)///< Physical address for frame rate conversion
+#define MMA_FRC1B1_PHY_START	ALIGNED(0x4000000, DDR_ROW_SIZE)
+//#define MMA_FRC1B1_SIZE		(720*610*2)
+#define MMA_FRC1B1_SIZE		(1920*1080*2)  
+#define MMA_FRC1B1_PHY_END	(MMA_FRC1B1_PHY_START+MMA_FRC1B1_SIZE)
+#define MMA_FRC1B2_PHY_ADDR	ALIGNED(MMA_FRC1B1_PHY_END, DDR_ROW_SIZE)
+#define MMA_FRC1B2_SIZE		MMA_FRC1B1_SIZE
+#define MMA_FRC1B2_PHY_END	(MMA_FRC1B2_PHY_ADDR+MMA_FRC1B2_SIZE)
+#define MMA_FRC1B3_PHY_ADDR	ALIGNED(MMA_FRC1B2_PHY_END, DDR_ROW_SIZE)
+#define MMA_FRC1B3_SIZE		MMA_FRC1B1_SIZE
+#define MMA_FRC1B3_PHY_END	(MMA_FRC1B3_PHY_ADDR+MMA_FRC1B3_SIZE)
+
+
+
+
+/// Disp1 FRC buffer shall not be used.  Use frame sync for bandwidth concern
+#define MMA_3DDMAB1_PHY_LADDR	ALIGNED(MMA_FRC1B3_PHY_END, DDR_ROW_SIZE)///< Physical address for frame rate conversion
+#define MMA_3DDMAB1_SIZE	(1920*1080*4)	///< each pixel with 30bits, 
+#define MMA_3DDMAB1_PHY_LEND	(MMA_3DDMAB1_PHY_LADDR+MMA_3DDMAB1_SIZE)
+#define MMA_3DDMAB2_PHY_LADDR	ALIGNED(MMA_3DDMAB1_PHY_LEND, DDR_ROW_SIZE)
+#define MMA_3DDMAB2_SIZE	MMA_3DDMAB1_SIZE
+#define MMA_3DDMAB2_PHY_LEND	(MMA_3DDMAB2_PHY_LADDR+MMA_3DDMAB2_SIZE)
+
+/// Disp1 FRC buffer shall not be used.  Use frame sync for bandwidth concern
+#define MMA_3DDMAB1_PHY_RADDR	ALIGNED(MMA_3DDMAB2_PHY_LEND, DDR_ROW_SIZE)///< Physical address for frame rate conversion
+#define MMA_3DDMAB1_SIZE	(1920*1080*4)	///< each pixel with 30bits, 
+#define MMA_3DDMAB1_PHY_REND	(MMA_3DDMAB1_PHY_RADDR+MMA_3DDMAB1_SIZE)
+#define MMA_3DDMAB2_PHY_RADDR	ALIGNED(MMA_3DDMAB1_PHY_REND, DDR_ROW_SIZE)
+#define MMA_3DDMAB2_SIZE	MMA_3DDMAB1_SIZE
+#define MMA_3DDMAB2_PHY_REND	(MMA_3DDMAB2_PHY_RADDR+MMA_3DDMAB2_SIZE)
+
+
+#endif //_DRAGON_VERIFY_H
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/hdmi_rx_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/hdmi_rx_reg.h
new file mode 100644
index 00000000..f90bf02
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/hdmi_rx_reg.h
@@ -0,0 +1,4779 @@
+// This file is generated using the spec version 1.39, firmware template version 1.39and SRIF Parser                                                                                source code SVN rev:802                    Version flow no.:1.1.66
+#ifndef _HDMI_RX_REG_H_INCLUDED_
+#define _HDMI_RX_REG_H_INCLUDED_
+
+//#define  _HDMI_RX_USE_STRUCT
+#ifdef _HDMI_RX_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    tmm:1;
+    unsigned int    mt:3;
+    unsigned int    ncp:4;
+}TMDS_msr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:19;
+    unsigned int    tms:1;
+    unsigned int    mrs:2;
+    unsigned int    ms:2;
+    unsigned int    ctc:1;
+    unsigned int    vmr:7;
+}TMDS_msr1;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    crc_done:1;
+    unsigned int    crc_nonstable:1;
+    unsigned int    crcts:2;
+    unsigned int    crcc:1;
+}TMDS_crcc;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    crcob2_3:8;
+    unsigned int    crcob2_2:8;
+    unsigned int    crcob2_1:8;
+}TMDS_crco0;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    crcob2_6:8;
+    unsigned int    crcob2_5:8;
+    unsigned int    crcob2_4:8;
+}TMDS_crco1;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    bcd:1;
+    unsigned int    gcd:1;
+    unsigned int    rcd:1;
+    unsigned int    ho:1;
+    unsigned int    yo:1;
+    unsigned int    dummy1800f014_2_0:3;
+}TMDS_ctrl;
+
+typedef struct
+{
+    unsigned int    reserved_0:18;
+    unsigned int    trcoe_r:1;
+    unsigned int    tgcoe_r:1;
+    unsigned int    tbcoe_r:1;
+    unsigned int    ocke_r:1;
+    unsigned int    aoe:1;
+    unsigned int    trcoe:1;
+    unsigned int    tgcoe:1;
+    unsigned int    tbcoe:1;
+    unsigned int    ocke:1;
+    unsigned int    ockie:1;
+    unsigned int    dummy1800f018_3:1;
+    unsigned int    clk25xinv_r:1;
+    unsigned int    clk25xinv_g:1;
+    unsigned int    clk25xinv_b:1;
+}TMDS_outctl;
+
+typedef struct
+{
+    unsigned int    ecc_r:1;
+    unsigned int    erip_r:1;
+    unsigned int    egip_r:1;
+    unsigned int    ebip_r:1;
+    unsigned int    dummy1800f01c_27_10:18;
+    unsigned int    video_preamble_off_en:1;
+    unsigned int    hs_width_sel:1;
+    unsigned int    deo:1;
+    unsigned int    brcw:1;
+    unsigned int    pnsw:1;
+    unsigned int    iccaf:1;
+    unsigned int    ecc:1;
+    unsigned int    erip:1;
+    unsigned int    egip:1;
+    unsigned int    ebip:1;
+}TMDS_pwdctl;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    hde:1;
+}TMDS_z0cc;
+
+typedef struct
+{
+    unsigned int    reserved_0:22;
+    unsigned int    pll_div2_en:1;
+    unsigned int    no_clk_in:1;
+    unsigned int    clkv_meas_sel:2;
+    unsigned int    de_inv_disable:1;
+    unsigned int    de_err_pulse_en:1;
+    unsigned int    clr_infoframe_dvi:1;
+    unsigned int    auto_dvi2hdmi:1;
+    unsigned int    dummy1800f024_1_0:2;
+}TMDS_cps;
+
+typedef struct
+{
+    unsigned int    reserved_0:22;
+    unsigned int    debug_sel:6;
+    unsigned int    dummy1800f028_3:1;
+    unsigned int    cptest:1;
+    unsigned int    hmtm:2;
+}TMDS_udc;
+
+typedef struct
+{
+    unsigned int    reserved_0:29;
+    unsigned int    nl:3;
+}TMDS_errc;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    tmds_bypass:1;
+    unsigned int    dummy1800f030_6_0:7;
+}TMDS_out_ctrl;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    tmds_rout_h:8;
+    unsigned int    tmds_rout_l:8;
+}TMDS_rout;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    tmds_gout_h:8;
+    unsigned int    tmds_gout_l:8;
+}TMDS_gout;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    tmds_bout_h:8;
+    unsigned int    tmds_bout_l:8;
+}TMDS_bout;
+
+typedef struct
+{
+    unsigned int    reserved_0:22;
+    unsigned int    dpc_pp_valid:1;
+    unsigned int    dpc_default_ph:1;
+    unsigned int    dpc_pp:4;
+    unsigned int    dpc_cd:4;
+}TMDS_dpc0;
+
+typedef struct
+{
+    unsigned int    reserved_0:13;
+    unsigned int    dpc_cd_chg_flag:1;
+    unsigned int    dpc_cd_chg_wd_en:1;
+    unsigned int    dpc_cd_chg_int_en:1;
+    unsigned int    dummy1800f044_15_11:5;
+    unsigned int    dpc_auto:1;
+    unsigned int    dpc_pp_valid_fw:1;
+    unsigned int    dpc_default_ph_fw:1;
+    unsigned int    dpc_pp_fw:4;
+    unsigned int    dpc_cd_fw:4;
+}TMDS_dpc1;
+
+typedef struct
+{
+    unsigned int    reserved_0:23;
+    unsigned int    dpc_bypass_dis:1;
+    unsigned int    dpc_en:1;
+    unsigned int    phase_errcnt_in:3;
+    unsigned int    phase_clrcnt_in:3;
+    unsigned int    phase_clr_sel:1;
+}TMDS_dpc_set0;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    set_full_noti:4;
+    unsigned int    set_empty_noti:4;
+}TMDS_dpc_set1;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fifo_errcnt_in:3;
+    unsigned int    clr_phase_flag:1;
+    unsigned int    clr_fifo_flag:1;
+    unsigned int    dpc_phase_ok:1;
+    unsigned int    dpc_phase_err_flag:1;
+    unsigned int    dpc_fifo_err_flag:1;
+}TMDS_dpc_set2;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dpc_fifo_over_flag:1;
+    unsigned int    dpc_fifo_under_flag:1;
+    unsigned int    dpc_fifo_over_xflag:1;
+    unsigned int    dpc_fifo_under_xflag:1;
+    unsigned int    reserved_1:4;
+}TMDS_dpc_set3;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    de_sel:1;
+    unsigned int    tran_err_thrd:4;
+    unsigned int    neg_de_err_thrd:4;
+    unsigned int    pos_de_err_thrd:4;
+    unsigned int    dummy1800f058_15:1;
+    unsigned int    neg_de_lowbd:7;
+    unsigned int    dummy1800f058_7_6:2;
+    unsigned int    pos_de_lowbd:6;
+}TMDS_det_ctl;
+
+typedef struct
+{
+    unsigned int    reserved_0:23;
+    unsigned int    red_tran_err_flag:1;
+    unsigned int    grn_tran_err_flag:1;
+    unsigned int    blu_tran_err_flag:1;
+    unsigned int    red_pos_de_err_flag:1;
+    unsigned int    grn_pos_de_err_flag:1;
+    unsigned int    blu_pos_de_err_flag:1;
+    unsigned int    red_neg_de_err_flag:1;
+    unsigned int    grn_neg_de_err_flag:1;
+    unsigned int    blu_neg_de_err_flag:1;
+}TMDS_det_sts;
+
+typedef struct
+{
+    unsigned int    thd:16;
+    unsigned int    reserved_0:4;
+    unsigned int    irq_en:1;
+    unsigned int    reset:1;
+    unsigned int    period:6;
+    unsigned int    ch_sel:2;
+    unsigned int    mode:1;
+    unsigned int    en:1;
+}VIDEO_bit_err_det;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    ad_max:5;
+    unsigned int    ad_min:5;
+    unsigned int    no_dis_reset:1;
+    unsigned int    bit_err_thd:1;
+    unsigned int    bit_err:1;
+    unsigned int    bit_err_cnt_of:1;
+    unsigned int    bit_err_cnt:16;
+}VIDEO_bit_err_status;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    avmute_bg:1;
+    unsigned int    avmute:1;
+    unsigned int    vic:1;
+    unsigned int    spdiftype:1;
+    unsigned int    pllsts:1;
+    unsigned int    afifoof:1;
+    unsigned int    afifouf:1;
+    unsigned int    mode:1;
+}HDMI_sr;
+
+typedef struct
+{
+    unsigned int    reserved_0:18;
+    unsigned int    gmps_v:1;
+    unsigned int    vsps_v:1;
+    unsigned int    gmps:1;
+    unsigned int    vsps:1;
+    unsigned int    nps:1;
+    unsigned int    pis_8:1;
+    unsigned int    pis_7:1;
+    unsigned int    pis_6:1;
+    unsigned int    pis_5:1;
+    unsigned int    pvs_4:1;
+    unsigned int    pvs_3:1;
+    unsigned int    pvs_2:1;
+    unsigned int    pvs_1:1;
+    unsigned int    pvs_0:1;
+}HDMI_gpvs;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    apss:8;
+}HDMI_psap;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dpss:8;
+}HDMI_psdp;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    nval:8;
+    unsigned int    reserved_1:2;
+    unsigned int    dvi_reset_ds_cm_en:1;
+    unsigned int    packet_ignore:1;
+    unsigned int    mode:1;
+    unsigned int    msmode:1;
+    unsigned int    cabs:1;
+    unsigned int    fcddip:1;
+}HDMI_scr;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    reserved_1:2;
+    unsigned int    spcss:1;
+    unsigned int    enrwe:1;
+    unsigned int    bche:1;
+    unsigned int    bches:1;
+    unsigned int    bches2:1;
+    unsigned int    pe:1;
+}HDMI_bchcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:21;
+    unsigned int    wd_ptg_en:1;
+    unsigned int    wd_vclk_en:1;
+    unsigned int    avmute_flag:1;
+    unsigned int    avmute_win_en:1;
+    unsigned int    aoc:1;
+    unsigned int    aomc:1;
+    unsigned int    awd:1;
+    unsigned int    ve:1;
+    unsigned int    ampic:1;
+    unsigned int    vdpic:1;
+    unsigned int    nfpss:1;
+}HDMI_avmcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    vwdap:1;
+    unsigned int    vwdlf:1;
+    unsigned int    vwdafo:1;
+    unsigned int    vwdafu:1;
+    unsigned int    yv:4;
+    unsigned int    awdck:1;
+    unsigned int    awdlf:1;
+    unsigned int    ch_st_sel:1;
+    unsigned int    vwdact:1;
+    unsigned int    xv:4;
+    unsigned int    asmfe:1;
+    unsigned int    load_d:1;
+    unsigned int    bt_track_en:1;
+    unsigned int    awdct:1;
+    unsigned int    awdap:1;
+    unsigned int    awdfo:1;
+    unsigned int    awdfu:1;
+    unsigned int    ct:1;
+}HDMI_wdcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:28;
+    unsigned int    aldbfv:1;
+    unsigned int    aldbfo:1;
+    unsigned int    aldbfu:1;
+    unsigned int    aldbpn:1;
+}HDMI_dbcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    awdpvsb:7;
+}HDMI_awdsr;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    vwdpvsb:7;
+}HDMI_vwdsr;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    icpvsb:7;
+}HDMI_pamicr;
+
+typedef struct
+{
+    unsigned int    pt4:8;
+    unsigned int    pt3:8;
+    unsigned int    pt2:8;
+    unsigned int    pt1:8;
+}HDMI_ptrsv1;
+
+typedef struct
+{
+    unsigned int    pvsef:32;
+}HDMI_pvgcr0;
+
+typedef struct
+{
+    unsigned int    pvs:32;
+}HDMI_pvsr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    cbus_ddc_chsel:1;
+    unsigned int    hdmi_field:1;
+    unsigned int    int_pro_chg_flag:1;
+    unsigned int    int_pro_chg_wd_en:1;
+    unsigned int    int_pro_chg_int_en:1;
+    unsigned int    hdcp_ddc_chsel:2;
+    unsigned int    iclk_sel:2;
+    unsigned int    csc_r:2;
+    unsigned int    hdirq:1;
+    unsigned int    csam:1;
+    unsigned int    csc:2;
+    unsigned int    field_decide_sel:1;
+    unsigned int    prdsam:1;
+    unsigned int    dsc_r:4;
+    unsigned int    eoi:1;
+    unsigned int    eot:1;
+    unsigned int    se:1;
+    unsigned int    rs:1;
+    unsigned int    dsc:4;
+}HDMI_vcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    pucnr:1;
+    unsigned int    pucsr:1;
+}HDMI_acrcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:12;
+    unsigned int    cts:20;
+}HDMI_acrsr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:12;
+    unsigned int    n:20;
+}HDMI_acrsr1;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    cs:16;
+}HDMI_acs0;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    cs:24;
+}HDMI_acs1;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    pending:1;
+    unsigned int    avmute:1;
+    unsigned int    fifod:1;
+    unsigned int    act:1;
+    unsigned int    apll:1;
+    unsigned int    afifoo:1;
+    unsigned int    afifou:1;
+    unsigned int    vc:1;
+}HDMI_intcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    lo1:2;
+    unsigned int    lo2:2;
+    unsigned int    lo3:2;
+    unsigned int    lo4:2;
+}HDMI_alcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:23;
+    unsigned int    i2s_clk_en_dvi:1;
+    unsigned int    spdifo1:1;
+    unsigned int    spdifo2:1;
+    unsigned int    spdifo3:1;
+    unsigned int    spdifo4:1;
+    unsigned int    i2so1:1;
+    unsigned int    i2so2:1;
+    unsigned int    i2so3:1;
+    unsigned int    i2so4:1;
+}HDMI_aocr;
+
+typedef struct
+{
+    unsigned int    reserved_0:26;
+    unsigned int    nvlgb:1;
+    unsigned int    nalgb:1;
+    unsigned int    natgb:1;
+    unsigned int    ngb:1;
+    unsigned int    pe:1;
+    unsigned int    gcp:1;
+}HDMI_bcsr;
+
+typedef struct
+{
+    unsigned int    reserved_0:29;
+    unsigned int    fsre:1;
+    unsigned int    fsif:1;
+    unsigned int    fscs:1;
+}HDMI_asr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    fbif:3;
+    unsigned int    fbcs:4;
+}HDMI_asr1;
+
+typedef struct
+{
+    unsigned int    reserved_0:21;
+    unsigned int    hvf:3;
+    unsigned int    hdmi_vic:8;
+}HDMI_video_format;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    hdmi_3d_ext_data:4;
+    unsigned int    hdmi_3d_metadata_type:3;
+    unsigned int    reserved_1:1;
+    unsigned int    hdmi_3d_structure:4;
+    unsigned int    hdmi_3d_meta_present:1;
+    unsigned int    reserved_2:3;
+}HDMI_3d_format;
+
+typedef struct
+{
+    unsigned int    reserved_0:28;
+    unsigned int    en_ncts_chg_irq:1;
+    unsigned int    ncts_chg_irq:1;
+    unsigned int    en_ch_status_chg_irq:1;
+    unsigned int    ch_status_chg_irq:1;
+}AUDIO_sample_rate_change_irq;
+
+typedef struct
+{
+    unsigned int    reserved_0:29;
+    unsigned int    hbr_audio_mode_manual:1;
+    unsigned int    hbr_audio_mode_fw:1;
+    unsigned int    hbr_audio_mode:1;
+}HIGH_bit_rate_audio_packet;
+
+typedef struct
+{
+    unsigned int    dummy1800f108_31_14:18;
+    unsigned int    gain_bypass_en:1;
+    unsigned int    afifof:1;
+    unsigned int    afifoe:1;
+    unsigned int    afifowe_r:1;
+    unsigned int    afifore_r:2;
+    unsigned int    tst_i2s_sw:1;
+    unsigned int    aoem:1;
+    unsigned int    aoc:1;
+    unsigned int    audio_test_enable:1;
+    unsigned int    mgc:1;
+    unsigned int    afifowe:1;
+    unsigned int    afifore:2;
+}HDMI_afcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    audio_bist_clksel:1;
+}HDMI_afsr;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    agi:3;
+    unsigned int    agd:5;
+    unsigned int    mg:8;
+}HDMI_magcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:1;
+    unsigned int    ldp_time:10;
+    unsigned int    ldp_time_mode:1;
+    unsigned int    fg_r:8;
+    unsigned int    fg_l:8;
+    unsigned int    auto_dly_mod:1;
+    unsigned int    fg_en:1;
+    unsigned int    ffg_l:1;
+    unsigned int    ffg_r:1;
+}HDMI_mag_m_final;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    zcd_ch7_done:1;
+    unsigned int    zcd_ch6_done:1;
+    unsigned int    zcd_ch5_done:1;
+    unsigned int    zcd_ch4_done:1;
+    unsigned int    zcd_ch3_done:1;
+    unsigned int    zcd_ch2_done:1;
+    unsigned int    zcd_ch1_done:1;
+    unsigned int    zcd_ch0_done:1;
+    unsigned int    reserved_1:1;
+    unsigned int    zcd_timeout:7;
+    unsigned int    zcd_en:1;
+    unsigned int    zcd_sep_8ch:1;
+    unsigned int    zcd_sep_st:1;
+    unsigned int    dummy1800f118_4_0:5;
+}ZCD_ctrl;
+
+typedef struct
+{
+    unsigned int    xtal_div:8;
+    unsigned int    afreq_meas_result:12;
+    unsigned int    afreq_meas_range:3;
+    unsigned int    popup_afreq_meas_result:1;
+    unsigned int    audio_freq_detect:1;
+    unsigned int    auto_load_scode:1;
+    unsigned int    awd_by_freqchange:1;
+    unsigned int    awd_by_noaudio:1;
+    unsigned int    irq_by_freqchange:1;
+    unsigned int    irq_by_noaudio:1;
+    unsigned int    freqchange:1;
+    unsigned int    noaudio:1;
+}AUDIO_freqdet;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    range0_th:12;
+    unsigned int    range1_th:12;
+}RANGE0_1;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    range2_th:12;
+    unsigned int    range3_th:12;
+}RANGE2_3;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    range4_th:12;
+    unsigned int    range5_th:12;
+}RANGE4_5;
+
+typedef struct
+{
+    unsigned int    pre_set_s1_code3:1;
+    unsigned int    pre_set_s_code3:7;
+    unsigned int    pre_set_s1_code2:1;
+    unsigned int    pre_set_s_code2:7;
+    unsigned int    pre_set_s1_code1:1;
+    unsigned int    pre_set_s_code1:7;
+    unsigned int    pre_set_s1_code0:1;
+    unsigned int    pre_set_s_code0:7;
+}PRESET_s_code0;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    dp_abuf_wr_mod_en:1;
+    unsigned int    auto_stop_trk_en:1;
+    unsigned int    trk_mod_en:1;
+    unsigned int    afsm_mod_en:1;
+    unsigned int    reserved_1:4;
+    unsigned int    pre_set_sm_code0:1;
+    unsigned int    pre_set_sm_code1:1;
+    unsigned int    pre_set_sm_code2:1;
+    unsigned int    pre_set_sm_code3:1;
+    unsigned int    pre_set_sm_code4:1;
+    unsigned int    reserved_2:3;
+    unsigned int    pre_set_s1_code4:1;
+    unsigned int    pre_set_s_code4:7;
+}PRESET_s_code1;
+
+typedef struct
+{
+    unsigned int    reserved_0:4;
+    unsigned int    prbs7_rxbist_err_cnt:8;
+    unsigned int    prbs7_err_cnt:4;
+    unsigned int    reserved_1:2;
+    unsigned int    prbs7_bit_err:10;
+    unsigned int    prbs7_lock:1;
+    unsigned int    prbs7_err_cnt_clr:1;
+    unsigned int    prbs7_reverse:1;
+    unsigned int    prbs7_rxen:1;
+}PRBS7_r_ctrl;
+
+typedef struct
+{
+    unsigned int    reserved_0:4;
+    unsigned int    prbs7_rxbist_err_cnt:8;
+    unsigned int    prbs7_err_cnt:4;
+    unsigned int    reserved_1:2;
+    unsigned int    prbs7_bit_err:10;
+    unsigned int    prbs7_lock:1;
+    unsigned int    prbs7_err_cnt_clr:1;
+    unsigned int    prbs7_reverse:1;
+    unsigned int    prbs7_rxen:1;
+}PRBS7_g_ctrl;
+
+typedef struct
+{
+    unsigned int    reserved_0:4;
+    unsigned int    prbs7_rxbist_err_cnt:8;
+    unsigned int    prbs7_err_cnt:4;
+    unsigned int    reserved_1:2;
+    unsigned int    prbs7_bit_err:10;
+    unsigned int    prbs7_lock:1;
+    unsigned int    prbs7_err_cnt_clr:1;
+    unsigned int    prbs7_reverse:1;
+    unsigned int    prbs7_rxen:1;
+}PRBS7_b_ctrl;
+
+typedef struct
+{
+    unsigned int    reserved_0:1;
+    unsigned int    cmp_err_flag:1;
+    unsigned int    cmp_err_wd_en:1;
+    unsigned int    cmp_err_int_en:1;
+    unsigned int    preamble:4;
+    unsigned int    reserved_1:6;
+    unsigned int    cmp_value:10;
+    unsigned int    reserved_2:3;
+    unsigned int    dvi_mode_sel:1;
+    unsigned int    channel_sel:2;
+    unsigned int    lgb_cal_conti:1;
+    unsigned int    lgb_cal_en:1;
+}HDMI_leading_gb_cmp_ctrl;
+
+typedef struct
+{
+    unsigned int    cmp_err_cnt:16;
+    unsigned int    cmp_times:16;
+}HDMI_leading_gb_cmp_times;
+
+typedef struct
+{
+    unsigned int    preamble_cmp_cnt:16;
+    unsigned int    preamble_cmp_cnt_by_frame:16;
+}HDMI_leading_gb_cmp_cnt;
+
+typedef struct
+{
+    unsigned int    cts_over_flag:1;
+    unsigned int    reserved_0:10;
+    unsigned int    cts_clip_en:1;
+    unsigned int    cts_up_bound:20;
+}AUDIO_cts_up_bound;
+
+typedef struct
+{
+    unsigned int    cts_under_flag:1;
+    unsigned int    reserved_0:11;
+    unsigned int    cts_low_bound:20;
+}AUDIO_cts_low_bound;
+
+typedef struct
+{
+    unsigned int    n_over_flag:1;
+    unsigned int    reserved_0:10;
+    unsigned int    n_clip_en:1;
+    unsigned int    n_up_bound:20;
+}AUDIO_n_up_bound;
+
+typedef struct
+{
+    unsigned int    n_under_flag:1;
+    unsigned int    reserved_0:11;
+    unsigned int    n_low_bound:20;
+}AUDIO_n_low_bound;
+
+typedef struct
+{
+    unsigned int    reserved_0:19;
+    unsigned int    pp_mode_output:1;
+    unsigned int    reserved_1:3;
+    unsigned int    packet_mhl_en:1;
+    unsigned int    xor_pixel_sel:3;
+    unsigned int    cal_pixel_sel:1;
+    unsigned int    reserved_2:3;
+    unsigned int    ch_dec_pp_mode_en:1;
+}MHL_hdmi_mac_ctrl;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    mhl_3d_fmt:4;
+    unsigned int    mhl_vid:2;
+    unsigned int    oui:24;
+}MHL_3d_format;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_ls:1;
+    unsigned int    audio_ls:1;
+}LIGHT_sleep;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_ds:1;
+    unsigned int    audio_ds:1;
+}DEEP_sleep;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_sd:1;
+    unsigned int    audio_sd:1;
+}SHOT_down;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_rme:1;
+    unsigned int    audio_rme:1;
+}READ_margin_enable;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    hdcp_rm:4;
+    unsigned int    audio_rm:4;
+}READ_margin;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_bist_en:1;
+    unsigned int    audio_bist_en:1;
+}BIST_mode;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_bist_done:1;
+    unsigned int    audio_bist_done:1;
+}BIST_done;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_bist_fail:1;
+    unsigned int    audio_bist_fail:1;
+}BIST_fail;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_drf_mode:1;
+    unsigned int    audio_drf_mode:1;
+}DRF_mode;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_drf_resume:1;
+    unsigned int    audio_drf_resume:1;
+}DRF_resume;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_drf_done:1;
+    unsigned int    audio_drf_done:1;
+}DRF_done;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_drf_pause:1;
+    unsigned int    audio_drf_pause:1;
+}DRF_pause;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_drf_fail:1;
+    unsigned int    audio_drf_fail:1;
+}DRF_fail;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    hdcp_dvs:4;
+    unsigned int    audio_dvs:4;
+}DVS;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    hdcp_dvse:1;
+    unsigned int    audio_dvse:1;
+}DVSE;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    hdmi_test_sel:3;
+    unsigned int    hdmi_out_sel:1;
+    unsigned int    force_ctsfifo_rstn_hdmi:1;
+    unsigned int    en_ctsfifo_vsrst_hdmi:1;
+    unsigned int    en_ctsfifo_bypass_hdmi:1;
+}CTS_fifo_ctl;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    sys_clk_div:3;
+    unsigned int    reserved_1:2;
+    unsigned int    cbus_core_pwdn:1;
+    unsigned int    sys_clk_en:1;
+}CBUS_clk_ctl;
+
+typedef struct
+{
+    unsigned int    reserved_0:32;
+}HDCP_bist;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    namfe:1;
+    unsigned int    dummy1800f204_6:1;
+    unsigned int    ivsp:1;
+    unsigned int    invvs:1;
+    unsigned int    ivspm:1;
+    unsigned int    maddf:1;
+    unsigned int    dkapde:1;
+    unsigned int    hdcp_en:1;
+}HDCP_cr;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dkap:8;
+}HDCP_dkap;
+
+typedef struct
+{
+    unsigned int    reserved_0:4;
+    unsigned int    i2c_scl_dly_sel:4;
+    unsigned int    i2c_sda_dly_sel:4;
+    unsigned int    reserved_1:2;
+    unsigned int    tune_up_down:1;
+    unsigned int    tune_range:7;
+    unsigned int    ddcdbnc:1;
+    unsigned int    dummy1800f20c_8:1;
+    unsigned int    dbnc_level_sel:1;
+    unsigned int    km_clk_sel:1;
+    unsigned int    hdcp_vs_sel:1;
+    unsigned int    enc_tog:1;
+    unsigned int    avmute_dis:1;
+    unsigned int    dummy1800f20c_2_1:2;
+    unsigned int    apai:1;
+}HDCP_pcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    wr_aksv_flag:1;
+    unsigned int    rd_ri_flag:1;
+    unsigned int    rd_bksv_flag:1;
+    unsigned int    dummy1800f210_1_0:2;
+}HDCP_flag1;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    irq_aksv_en:1;
+    unsigned int    irq_ri_en:1;
+    unsigned int    irq_bksv_en:1;
+    unsigned int    dummy1800f214_1_0:2;
+}HDCP_flag2;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ap1:8;
+}HDCP_ap;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dp1:8;
+}HDCP_dp;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    icmux:1;
+    unsigned int    ocs:2;
+    unsigned int    dbdcb:1;
+    unsigned int    dummy1800f300_3_0:4;
+}HDMI_cmcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dummy1800f304_7_0:8;
+}HDMI_mcapr;
+
+typedef struct
+{
+    unsigned int    reserved_0:14;
+    unsigned int    s1_code_msb_r:1;
+    unsigned int    slc_r:1;
+    unsigned int    sc_r:7;
+    unsigned int    s1_code_msb:1;
+    unsigned int    slc:1;
+    unsigned int    sc:7;
+}HDMI_scapr;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    dcaprh:8;
+    unsigned int    dcaprl:8;
+}HDMI_dcapr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fdint:3;
+    unsigned int    etcn:1;
+    unsigned int    etfd:1;
+    unsigned int    etfbc:1;
+    unsigned int    pecs:2;
+}HDMI_pscr;
+
+typedef struct
+{
+    unsigned int    mfddf:8;
+    unsigned int    mfddr:8;
+    unsigned int    fddf:8;
+    unsigned int    fddr:8;
+}HDMI_afdd;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    tl2der:2;
+    unsigned int    tl2def:2;
+    unsigned int    tt:4;
+}HDMI_ftr;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    tfd:5;
+    unsigned int    bad:3;
+}HDMI_fbr;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    ich:8;
+    unsigned int    icl:8;
+}HDMI_icpsncr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    pch:8;
+    unsigned int    pcl:8;
+}HDMI_pcpsncr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    icth:8;
+    unsigned int    ictl:8;
+}HDMI_ictpsr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    pcth:8;
+    unsigned int    pctl:8;
+}HDMI_pctpsr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    icbh:8;
+    unsigned int    icbl:8;
+}HDMI_icbpsr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    pcbh:8;
+    unsigned int    pcbl:8;
+}HDMI_pcbpsr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:19;
+    unsigned int    rm:1;
+    unsigned int    nt:12;
+}HDMI_ntx1024tr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ftb:8;
+}HDMI_stbpr;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    ncper:8;
+}HDMI_ncper;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    petr:8;
+}HDMI_petr;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    cmvtc:1;
+    unsigned int    cmvbc:1;
+    unsigned int    ssdmou:1;
+    unsigned int    tef:1;
+    unsigned int    w1c5:1;
+    unsigned int    pem:1;
+    unsigned int    esdm:1;
+    unsigned int    dummy1800f350_0:1;
+}HDMI_aapnr;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dummy1800f354_7:1;
+    unsigned int    dummy1800f354_6:1;
+    unsigned int    edm:1;
+    unsigned int    pst:1;
+    unsigned int    psc:4;
+}HDMI_apdmcr;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    fps:4;
+    unsigned int    sps:4;
+}HDMI_aptmcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    plltm:1;
+    unsigned int    fpsd:1;
+    unsigned int    spsd:1;
+    unsigned int    nfpss:4;
+}HDMI_aptmcr1;
+
+typedef struct
+{
+    unsigned int    ncts_disable_pe_check_en:1;
+    unsigned int    ncts_re_enable_off_en:1;
+    unsigned int    ncts_disable_pe_check_status:1;
+    unsigned int    ncts_disable_pe_check_irq_en:1;
+    unsigned int    dummy1800f360_27_20:8;
+    unsigned int    ncts_disable_pe_check_cnt:20;
+}HDMI_npecr;
+
+typedef struct
+{
+    unsigned int    ncts_re_enable_off_start:16;
+    unsigned int    ncts_re_enable_off_end:16;
+}HDMI_nror;
+
+typedef struct
+{
+    unsigned int    over_threshold:1;
+    unsigned int    under_threshold:1;
+    unsigned int    wd_by_tmds_clk:1;
+    unsigned int    irq_by_tmds_clk:1;
+    unsigned int    nt_up_threshold:12;
+    unsigned int    reserved_0:4;
+    unsigned int    nt_low_threshold:12;
+}HDMI_ntx1024tr0_threshold;
+
+typedef struct
+{
+    unsigned int    dpll_reg:2;
+    unsigned int    dpll_m:8;
+    unsigned int    reserved_0:1;
+    unsigned int    dpll_reser:4;
+    unsigned int    dpll_bpn:1;
+    unsigned int    dpll_o:2;
+    unsigned int    reserved_1:5;
+    unsigned int    dpll_n:3;
+    unsigned int    dpll_rs:3;
+    unsigned int    dpll_ip:3;
+}HDMI_apllcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:9;
+    unsigned int    dpll_cp:2;
+    unsigned int    dpll_seltst:2;
+    unsigned int    dpll_cs:2;
+    unsigned int    reserved_1:2;
+    unsigned int    reserved_2:1;
+    unsigned int    reserved_3:1;
+    unsigned int    reserved_4:1;
+    unsigned int    reserved_5:1;
+    unsigned int    reserved_6:1;
+    unsigned int    dpll_reserve:1;
+    unsigned int    dpll_bpphs:1;
+    unsigned int    dpll_wdo:1;
+    unsigned int    dpll_wdrst:1;
+    unsigned int    dpll_wdset:1;
+    unsigned int    dummy1800f384_4:1;
+    unsigned int    dpll_stop:1;
+    unsigned int    dpll_freeze:1;
+    unsigned int    dpll_vcorstb:1;
+    unsigned int    dpll_pwdn:1;
+}HDMI_apllcr1;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    reserved_1:1;
+    unsigned int    reserved_2:1;
+    unsigned int    reserved_3:2;
+    unsigned int    dpll_rloadm:1;
+}HDMI_apllcr2;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    sum_c_samp:16;
+}HDMI_apllcr3;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    dpll_m_test:8;
+    unsigned int    reserved_1:20;
+    unsigned int    dpll_m_db:1;
+    unsigned int    dpll_m_sel:1;
+}HDMI_apll_testm;
+
+typedef struct
+{
+    unsigned int    dpll_reg:2;
+    unsigned int    dpll_m:8;
+    unsigned int    reserved_0:1;
+    unsigned int    dpll_reser:4;
+    unsigned int    dpll_bpn:1;
+    unsigned int    dpll_o:2;
+    unsigned int    reserved_1:5;
+    unsigned int    dpll_n:3;
+    unsigned int    dpll_rs:3;
+    unsigned int    dpll_ip:3;
+}HDMI_vpllcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:9;
+    unsigned int    dpll_cp:2;
+    unsigned int    dpll_seltst:2;
+    unsigned int    dpll_cs:2;
+    unsigned int    reserved_1:2;
+    unsigned int    reserved_2:1;
+    unsigned int    reserved_3:1;
+    unsigned int    reserved_4:1;
+    unsigned int    reserved_5:1;
+    unsigned int    reserved_6:1;
+    unsigned int    dpll_reserve:1;
+    unsigned int    dpll_bpphs:1;
+    unsigned int    dpll_wdo:1;
+    unsigned int    dpll_wdrst:1;
+    unsigned int    dpll_wdset:1;
+    unsigned int    dummy1800f404_4:1;
+    unsigned int    dpll_stop:1;
+    unsigned int    dpll_freeze:1;
+    unsigned int    dpll_vcorstb:1;
+    unsigned int    dpll_pwdn:1;
+}HDMI_vpllcr1;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    reserved_1:1;
+    unsigned int    reserved_2:1;
+    unsigned int    reserved_3:2;
+    unsigned int    dpll_rloadm:1;
+}HDMI_vpllcr2;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    sclkg_pll_in_sel:1;
+    unsigned int    sclkg_oclk_sel:2;
+    unsigned int    sclkg_dbuf:1;
+    unsigned int    dummy1800f410_3_0:4;
+}MN_sclkg_ctrl;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    sclkg_pll_div2_en:1;
+    unsigned int    sclkg_pll_divs:7;
+}MN_sclkg_divs;
+#endif
+
+
+#define TMDS_MSR0                                                     0x1800f000
+#define TMDS_MSR0_reg_addr                                            "0xb800f000"
+#define TMDS_MSR0_reg                                                 0xb800f000
+#define TMDS_MSR0_inst_addr                                           "0x0000"
+#define TMDS_MSR0_inst                                                0x0000
+#define TMDS_MSR0_tmm_shift                                           (7)
+#define TMDS_MSR0_mt_shift                                            (4)
+#define TMDS_MSR0_ncp_shift                                           (0)
+#define TMDS_MSR0_tmm_mask                                            (0x00000080)
+#define TMDS_MSR0_mt_mask                                             (0x00000070)
+#define TMDS_MSR0_ncp_mask                                            (0x0000000F)
+#define TMDS_MSR0_tmm(data)                                           (0x00000080&((data)<<7))
+#define TMDS_MSR0_mt(data)                                            (0x00000070&((data)<<4))
+#define TMDS_MSR0_ncp(data)                                           (0x0000000F&(data))
+#define TMDS_MSR0_get_tmm(data)                                       ((0x00000080&(data))>>7)
+#define TMDS_MSR0_get_mt(data)                                        ((0x00000070&(data))>>4)
+#define TMDS_MSR0_get_ncp(data)                                       (0x0000000F&(data))
+
+
+#define TMDS_MSR1                                                     0x1800f004
+#define TMDS_MSR1_reg_addr                                            "0xb800f004"
+#define TMDS_MSR1_reg                                                 0xb800f004
+#define TMDS_MSR1_inst_addr                                           "0x0001"
+#define TMDS_MSR1_inst                                                0x0001
+#define TMDS_MSR1_tms_shift                                           (12)
+#define TMDS_MSR1_mrs_shift                                           (10)
+#define TMDS_MSR1_ms_shift                                            (8)
+#define TMDS_MSR1_ctc_shift                                           (7)
+#define TMDS_MSR1_vmr_shift                                           (0)
+#define TMDS_MSR1_tms_mask                                            (0x00001000)
+#define TMDS_MSR1_mrs_mask                                            (0x00000C00)
+#define TMDS_MSR1_ms_mask                                             (0x00000300)
+#define TMDS_MSR1_ctc_mask                                            (0x00000080)
+#define TMDS_MSR1_vmr_mask                                            (0x0000007F)
+#define TMDS_MSR1_tms(data)                                           (0x00001000&((data)<<12))
+#define TMDS_MSR1_mrs(data)                                           (0x00000C00&((data)<<10))
+#define TMDS_MSR1_ms(data)                                            (0x00000300&((data)<<8))
+#define TMDS_MSR1_ctc(data)                                           (0x00000080&((data)<<7))
+#define TMDS_MSR1_vmr(data)                                           (0x0000007F&(data))
+#define TMDS_MSR1_get_tms(data)                                       ((0x00001000&(data))>>12)
+#define TMDS_MSR1_get_mrs(data)                                       ((0x00000C00&(data))>>10)
+#define TMDS_MSR1_get_ms(data)                                        ((0x00000300&(data))>>8)
+#define TMDS_MSR1_get_ctc(data)                                       ((0x00000080&(data))>>7)
+#define TMDS_MSR1_get_vmr(data)                                       (0x0000007F&(data))
+
+
+#define TMDS_CRCC                                                     0x1800f008
+#define TMDS_CRCC_reg_addr                                            "0xb800f008"
+#define TMDS_CRCC_reg                                                 0xb800f008
+#define TMDS_CRCC_inst_addr                                           "0x0002"
+#define TMDS_CRCC_inst                                                0x0002
+#define TMDS_CRCC_crc_done_shift                                      (4)
+#define TMDS_CRCC_crc_nonstable_shift                                 (3)
+#define TMDS_CRCC_crcts_shift                                         (1)
+#define TMDS_CRCC_crcc_shift                                          (0)
+#define TMDS_CRCC_crc_done_mask                                       (0x00000010)
+#define TMDS_CRCC_crc_nonstable_mask                                  (0x00000008)
+#define TMDS_CRCC_crcts_mask                                          (0x00000006)
+#define TMDS_CRCC_crcc_mask                                           (0x00000001)
+#define TMDS_CRCC_crc_done(data)                                      (0x00000010&((data)<<4))
+#define TMDS_CRCC_crc_nonstable(data)                                 (0x00000008&((data)<<3))
+#define TMDS_CRCC_crcts(data)                                         (0x00000006&((data)<<1))
+#define TMDS_CRCC_crcc(data)                                          (0x00000001&(data))
+#define TMDS_CRCC_get_crc_done(data)                                  ((0x00000010&(data))>>4)
+#define TMDS_CRCC_get_crc_nonstable(data)                             ((0x00000008&(data))>>3)
+#define TMDS_CRCC_get_crcts(data)                                     ((0x00000006&(data))>>1)
+#define TMDS_CRCC_get_crcc(data)                                      (0x00000001&(data))
+
+
+#define TMDS_CRCO0                                                    0x1800f00c
+#define TMDS_CRCO0_reg_addr                                           "0xb800f00c"
+#define TMDS_CRCO0_reg                                                0xb800f00c
+#define TMDS_CRCO0_inst_addr                                          "0x0003"
+#define TMDS_CRCO0_inst                                               0x0003
+#define TMDS_CRCO0_crcob2_3_shift                                     (16)
+#define TMDS_CRCO0_crcob2_2_shift                                     (8)
+#define TMDS_CRCO0_crcob2_1_shift                                     (0)
+#define TMDS_CRCO0_crcob2_3_mask                                      (0x00FF0000)
+#define TMDS_CRCO0_crcob2_2_mask                                      (0x0000FF00)
+#define TMDS_CRCO0_crcob2_1_mask                                      (0x000000FF)
+#define TMDS_CRCO0_crcob2_3(data)                                     (0x00FF0000&((data)<<16))
+#define TMDS_CRCO0_crcob2_2(data)                                     (0x0000FF00&((data)<<8))
+#define TMDS_CRCO0_crcob2_1(data)                                     (0x000000FF&(data))
+#define TMDS_CRCO0_get_crcob2_3(data)                                 ((0x00FF0000&(data))>>16)
+#define TMDS_CRCO0_get_crcob2_2(data)                                 ((0x0000FF00&(data))>>8)
+#define TMDS_CRCO0_get_crcob2_1(data)                                 (0x000000FF&(data))
+
+
+#define TMDS_CRCO1                                                    0x1800f010
+#define TMDS_CRCO1_reg_addr                                           "0xb800f010"
+#define TMDS_CRCO1_reg                                                0xb800f010
+#define TMDS_CRCO1_inst_addr                                          "0x0004"
+#define TMDS_CRCO1_inst                                               0x0004
+#define TMDS_CRCO1_crcob2_6_shift                                     (16)
+#define TMDS_CRCO1_crcob2_5_shift                                     (8)
+#define TMDS_CRCO1_crcob2_4_shift                                     (0)
+#define TMDS_CRCO1_crcob2_6_mask                                      (0x00FF0000)
+#define TMDS_CRCO1_crcob2_5_mask                                      (0x0000FF00)
+#define TMDS_CRCO1_crcob2_4_mask                                      (0x000000FF)
+#define TMDS_CRCO1_crcob2_6(data)                                     (0x00FF0000&((data)<<16))
+#define TMDS_CRCO1_crcob2_5(data)                                     (0x0000FF00&((data)<<8))
+#define TMDS_CRCO1_crcob2_4(data)                                     (0x000000FF&(data))
+#define TMDS_CRCO1_get_crcob2_6(data)                                 ((0x00FF0000&(data))>>16)
+#define TMDS_CRCO1_get_crcob2_5(data)                                 ((0x0000FF00&(data))>>8)
+#define TMDS_CRCO1_get_crcob2_4(data)                                 (0x000000FF&(data))
+
+
+#define TMDS_CTRL                                                     0x1800f014
+#define TMDS_CTRL_reg_addr                                            "0xb800f014"
+#define TMDS_CTRL_reg                                                 0xb800f014
+#define TMDS_CTRL_inst_addr                                           "0x0005"
+#define TMDS_CTRL_inst                                                0x0005
+#define TMDS_CTRL_bcd_shift                                           (7)
+#define TMDS_CTRL_gcd_shift                                           (6)
+#define TMDS_CTRL_rcd_shift                                           (5)
+#define TMDS_CTRL_ho_shift                                            (4)
+#define TMDS_CTRL_yo_shift                                            (3)
+#define TMDS_CTRL_dummy1800f014_2_0_shift                             (0)
+#define TMDS_CTRL_bcd_mask                                            (0x00000080)
+#define TMDS_CTRL_gcd_mask                                            (0x00000040)
+#define TMDS_CTRL_rcd_mask                                            (0x00000020)
+#define TMDS_CTRL_ho_mask                                             (0x00000010)
+#define TMDS_CTRL_yo_mask                                             (0x00000008)
+#define TMDS_CTRL_dummy1800f014_2_0_mask                              (0x00000007)
+#define TMDS_CTRL_bcd(data)                                           (0x00000080&((data)<<7))
+#define TMDS_CTRL_gcd(data)                                           (0x00000040&((data)<<6))
+#define TMDS_CTRL_rcd(data)                                           (0x00000020&((data)<<5))
+#define TMDS_CTRL_ho(data)                                            (0x00000010&((data)<<4))
+#define TMDS_CTRL_yo(data)                                            (0x00000008&((data)<<3))
+#define TMDS_CTRL_dummy1800f014_2_0(data)                             (0x00000007&(data))
+#define TMDS_CTRL_get_bcd(data)                                       ((0x00000080&(data))>>7)
+#define TMDS_CTRL_get_gcd(data)                                       ((0x00000040&(data))>>6)
+#define TMDS_CTRL_get_rcd(data)                                       ((0x00000020&(data))>>5)
+#define TMDS_CTRL_get_ho(data)                                        ((0x00000010&(data))>>4)
+#define TMDS_CTRL_get_yo(data)                                        ((0x00000008&(data))>>3)
+#define TMDS_CTRL_get_dummy1800f014_2_0(data)                         (0x00000007&(data))
+
+
+#define TMDS_OUTCTL                                                   0x1800f018
+#define TMDS_OUTCTL_reg_addr                                          "0xb800f018"
+#define TMDS_OUTCTL_reg                                               0xb800f018
+#define TMDS_OUTCTL_inst_addr                                         "0x0006"
+#define TMDS_OUTCTL_inst                                              0x0006
+#define TMDS_OUTCTL_trcoe_r_shift                                     (13)
+#define TMDS_OUTCTL_tgcoe_r_shift                                     (12)
+#define TMDS_OUTCTL_tbcoe_r_shift                                     (11)
+#define TMDS_OUTCTL_ocke_r_shift                                      (10)
+#define TMDS_OUTCTL_aoe_shift                                         (9)
+#define TMDS_OUTCTL_trcoe_shift                                       (8)
+#define TMDS_OUTCTL_tgcoe_shift                                       (7)
+#define TMDS_OUTCTL_tbcoe_shift                                       (6)
+#define TMDS_OUTCTL_ocke_shift                                        (5)
+#define TMDS_OUTCTL_ockie_shift                                       (4)
+#define TMDS_OUTCTL_dummy1800f018_3_shift                             (3)
+#define TMDS_OUTCTL_clk25xinv_r_shift                                 (2)
+#define TMDS_OUTCTL_clk25xinv_g_shift                                 (1)
+#define TMDS_OUTCTL_clk25xinv_b_shift                                 (0)
+#define TMDS_OUTCTL_trcoe_r_mask                                      (0x00002000)
+#define TMDS_OUTCTL_tgcoe_r_mask                                      (0x00001000)
+#define TMDS_OUTCTL_tbcoe_r_mask                                      (0x00000800)
+#define TMDS_OUTCTL_ocke_r_mask                                       (0x00000400)
+#define TMDS_OUTCTL_aoe_mask                                          (0x00000200)
+#define TMDS_OUTCTL_trcoe_mask                                        (0x00000100)
+#define TMDS_OUTCTL_tgcoe_mask                                        (0x00000080)
+#define TMDS_OUTCTL_tbcoe_mask                                        (0x00000040)
+#define TMDS_OUTCTL_ocke_mask                                         (0x00000020)
+#define TMDS_OUTCTL_ockie_mask                                        (0x00000010)
+#define TMDS_OUTCTL_dummy1800f018_3_mask                              (0x00000008)
+#define TMDS_OUTCTL_clk25xinv_r_mask                                  (0x00000004)
+#define TMDS_OUTCTL_clk25xinv_g_mask                                  (0x00000002)
+#define TMDS_OUTCTL_clk25xinv_b_mask                                  (0x00000001)
+#define TMDS_OUTCTL_trcoe_r(data)                                     (0x00002000&((data)<<13))
+#define TMDS_OUTCTL_tgcoe_r(data)                                     (0x00001000&((data)<<12))
+#define TMDS_OUTCTL_tbcoe_r(data)                                     (0x00000800&((data)<<11))
+#define TMDS_OUTCTL_ocke_r(data)                                      (0x00000400&((data)<<10))
+#define TMDS_OUTCTL_aoe(data)                                         (0x00000200&((data)<<9))
+#define TMDS_OUTCTL_trcoe(data)                                       (0x00000100&((data)<<8))
+#define TMDS_OUTCTL_tgcoe(data)                                       (0x00000080&((data)<<7))
+#define TMDS_OUTCTL_tbcoe(data)                                       (0x00000040&((data)<<6))
+#define TMDS_OUTCTL_ocke(data)                                        (0x00000020&((data)<<5))
+#define TMDS_OUTCTL_ockie(data)                                       (0x00000010&((data)<<4))
+#define TMDS_OUTCTL_dummy1800f018_3(data)                             (0x00000008&((data)<<3))
+#define TMDS_OUTCTL_clk25xinv_r(data)                                 (0x00000004&((data)<<2))
+#define TMDS_OUTCTL_clk25xinv_g(data)                                 (0x00000002&((data)<<1))
+#define TMDS_OUTCTL_clk25xinv_b(data)                                 (0x00000001&(data))
+#define TMDS_OUTCTL_get_trcoe_r(data)                                 ((0x00002000&(data))>>13)
+#define TMDS_OUTCTL_get_tgcoe_r(data)                                 ((0x00001000&(data))>>12)
+#define TMDS_OUTCTL_get_tbcoe_r(data)                                 ((0x00000800&(data))>>11)
+#define TMDS_OUTCTL_get_ocke_r(data)                                  ((0x00000400&(data))>>10)
+#define TMDS_OUTCTL_get_aoe(data)                                     ((0x00000200&(data))>>9)
+#define TMDS_OUTCTL_get_trcoe(data)                                   ((0x00000100&(data))>>8)
+#define TMDS_OUTCTL_get_tgcoe(data)                                   ((0x00000080&(data))>>7)
+#define TMDS_OUTCTL_get_tbcoe(data)                                   ((0x00000040&(data))>>6)
+#define TMDS_OUTCTL_get_ocke(data)                                    ((0x00000020&(data))>>5)
+#define TMDS_OUTCTL_get_ockie(data)                                   ((0x00000010&(data))>>4)
+#define TMDS_OUTCTL_get_dummy1800f018_3(data)                         ((0x00000008&(data))>>3)
+#define TMDS_OUTCTL_get_clk25xinv_r(data)                             ((0x00000004&(data))>>2)
+#define TMDS_OUTCTL_get_clk25xinv_g(data)                             ((0x00000002&(data))>>1)
+#define TMDS_OUTCTL_get_clk25xinv_b(data)                             (0x00000001&(data))
+
+
+#define TMDS_PWDCTL                                                   0x1800f01c
+#define TMDS_PWDCTL_reg_addr                                          "0xb800f01c"
+#define TMDS_PWDCTL_reg                                               0xb800f01c
+#define TMDS_PWDCTL_inst_addr                                         "0x0007"
+#define TMDS_PWDCTL_inst                                              0x0007
+#define TMDS_PWDCTL_ecc_r_shift                                       (31)
+#define TMDS_PWDCTL_erip_r_shift                                      (30)
+#define TMDS_PWDCTL_egip_r_shift                                      (29)
+#define TMDS_PWDCTL_ebip_r_shift                                      (28)
+#define TMDS_PWDCTL_dummy1800f01c_27_10_shift                         (10)
+#define TMDS_PWDCTL_video_preamble_off_en_shift                       (9)
+#define TMDS_PWDCTL_hs_width_sel_shift                                (8)
+#define TMDS_PWDCTL_deo_shift                                         (7)
+#define TMDS_PWDCTL_brcw_shift                                        (6)
+#define TMDS_PWDCTL_pnsw_shift                                        (5)
+#define TMDS_PWDCTL_iccaf_shift                                       (4)
+#define TMDS_PWDCTL_ecc_shift                                         (3)
+#define TMDS_PWDCTL_erip_shift                                        (2)
+#define TMDS_PWDCTL_egip_shift                                        (1)
+#define TMDS_PWDCTL_ebip_shift                                        (0)
+#define TMDS_PWDCTL_ecc_r_mask                                        (0x80000000)
+#define TMDS_PWDCTL_erip_r_mask                                       (0x40000000)
+#define TMDS_PWDCTL_egip_r_mask                                       (0x20000000)
+#define TMDS_PWDCTL_ebip_r_mask                                       (0x10000000)
+#define TMDS_PWDCTL_dummy1800f01c_27_10_mask                          (0x0FFFFC00)
+#define TMDS_PWDCTL_video_preamble_off_en_mask                        (0x00000200)
+#define TMDS_PWDCTL_hs_width_sel_mask                                 (0x00000100)
+#define TMDS_PWDCTL_deo_mask                                          (0x00000080)
+#define TMDS_PWDCTL_brcw_mask                                         (0x00000040)
+#define TMDS_PWDCTL_pnsw_mask                                         (0x00000020)
+#define TMDS_PWDCTL_iccaf_mask                                        (0x00000010)
+#define TMDS_PWDCTL_ecc_mask                                          (0x00000008)
+#define TMDS_PWDCTL_erip_mask                                         (0x00000004)
+#define TMDS_PWDCTL_egip_mask                                         (0x00000002)
+#define TMDS_PWDCTL_ebip_mask                                         (0x00000001)
+#define TMDS_PWDCTL_ecc_r(data)                                       (0x80000000&((data)<<31))
+#define TMDS_PWDCTL_erip_r(data)                                      (0x40000000&((data)<<30))
+#define TMDS_PWDCTL_egip_r(data)                                      (0x20000000&((data)<<29))
+#define TMDS_PWDCTL_ebip_r(data)                                      (0x10000000&((data)<<28))
+#define TMDS_PWDCTL_dummy1800f01c_27_10(data)                         (0x0FFFFC00&((data)<<10))
+#define TMDS_PWDCTL_video_preamble_off_en(data)                       (0x00000200&((data)<<9))
+#define TMDS_PWDCTL_hs_width_sel(data)                                (0x00000100&((data)<<8))
+#define TMDS_PWDCTL_deo(data)                                         (0x00000080&((data)<<7))
+#define TMDS_PWDCTL_brcw(data)                                        (0x00000040&((data)<<6))
+#define TMDS_PWDCTL_pnsw(data)                                        (0x00000020&((data)<<5))
+#define TMDS_PWDCTL_iccaf(data)                                       (0x00000010&((data)<<4))
+#define TMDS_PWDCTL_ecc(data)                                         (0x00000008&((data)<<3))
+#define TMDS_PWDCTL_erip(data)                                        (0x00000004&((data)<<2))
+#define TMDS_PWDCTL_egip(data)                                        (0x00000002&((data)<<1))
+#define TMDS_PWDCTL_ebip(data)                                        (0x00000001&(data))
+#define TMDS_PWDCTL_get_ecc_r(data)                                   ((0x80000000&(data))>>31)
+#define TMDS_PWDCTL_get_erip_r(data)                                  ((0x40000000&(data))>>30)
+#define TMDS_PWDCTL_get_egip_r(data)                                  ((0x20000000&(data))>>29)
+#define TMDS_PWDCTL_get_ebip_r(data)                                  ((0x10000000&(data))>>28)
+#define TMDS_PWDCTL_get_dummy1800f01c_27_10(data)                     ((0x0FFFFC00&(data))>>10)
+#define TMDS_PWDCTL_get_video_preamble_off_en(data)                   ((0x00000200&(data))>>9)
+#define TMDS_PWDCTL_get_hs_width_sel(data)                            ((0x00000100&(data))>>8)
+#define TMDS_PWDCTL_get_deo(data)                                     ((0x00000080&(data))>>7)
+#define TMDS_PWDCTL_get_brcw(data)                                    ((0x00000040&(data))>>6)
+#define TMDS_PWDCTL_get_pnsw(data)                                    ((0x00000020&(data))>>5)
+#define TMDS_PWDCTL_get_iccaf(data)                                   ((0x00000010&(data))>>4)
+#define TMDS_PWDCTL_get_ecc(data)                                     ((0x00000008&(data))>>3)
+#define TMDS_PWDCTL_get_erip(data)                                    ((0x00000004&(data))>>2)
+#define TMDS_PWDCTL_get_egip(data)                                    ((0x00000002&(data))>>1)
+#define TMDS_PWDCTL_get_ebip(data)                                    (0x00000001&(data))
+
+
+#define TMDS_Z0CC                                                     0x1800f020
+#define TMDS_Z0CC_reg_addr                                            "0xb800f020"
+#define TMDS_Z0CC_reg                                                 0xb800f020
+#define TMDS_Z0CC_inst_addr                                           "0x0008"
+#define TMDS_Z0CC_inst                                                0x0008
+#define TMDS_Z0CC_hde_shift                                           (0)
+#define TMDS_Z0CC_hde_mask                                            (0x00000001)
+#define TMDS_Z0CC_hde(data)                                           (0x00000001&(data))
+#define TMDS_Z0CC_get_hde(data)                                       (0x00000001&(data))
+
+
+#define TMDS_CPS                                                      0x1800f024
+#define TMDS_CPS_reg_addr                                             "0xb800f024"
+#define TMDS_CPS_reg                                                  0xb800f024
+#define TMDS_CPS_inst_addr                                            "0x0009"
+#define TMDS_CPS_inst                                                 0x0009
+#define TMDS_CPS_pll_div2_en_shift                                    (9)
+#define TMDS_CPS_no_clk_in_shift                                      (8)
+#define TMDS_CPS_clkv_meas_sel_shift                                  (6)
+#define TMDS_CPS_de_inv_disable_shift                                 (5)
+#define TMDS_CPS_de_err_pulse_en_shift                                (4)
+#define TMDS_CPS_clr_infoframe_dvi_shift                              (3)
+#define TMDS_CPS_auto_dvi2hdmi_shift                                  (2)
+#define TMDS_CPS_dummy1800f024_1_0_shift                              (0)
+#define TMDS_CPS_pll_div2_en_mask                                     (0x00000200)
+#define TMDS_CPS_no_clk_in_mask                                       (0x00000100)
+#define TMDS_CPS_clkv_meas_sel_mask                                   (0x000000C0)
+#define TMDS_CPS_de_inv_disable_mask                                  (0x00000020)
+#define TMDS_CPS_de_err_pulse_en_mask                                 (0x00000010)
+#define TMDS_CPS_clr_infoframe_dvi_mask                               (0x00000008)
+#define TMDS_CPS_auto_dvi2hdmi_mask                                   (0x00000004)
+#define TMDS_CPS_dummy1800f024_1_0_mask                               (0x00000003)
+#define TMDS_CPS_pll_div2_en(data)                                    (0x00000200&((data)<<9))
+#define TMDS_CPS_no_clk_in(data)                                      (0x00000100&((data)<<8))
+#define TMDS_CPS_clkv_meas_sel(data)                                  (0x000000C0&((data)<<6))
+#define TMDS_CPS_de_inv_disable(data)                                 (0x00000020&((data)<<5))
+#define TMDS_CPS_de_err_pulse_en(data)                                (0x00000010&((data)<<4))
+#define TMDS_CPS_clr_infoframe_dvi(data)                              (0x00000008&((data)<<3))
+#define TMDS_CPS_auto_dvi2hdmi(data)                                  (0x00000004&((data)<<2))
+#define TMDS_CPS_dummy1800f024_1_0(data)                              (0x00000003&(data))
+#define TMDS_CPS_get_pll_div2_en(data)                                ((0x00000200&(data))>>9)
+#define TMDS_CPS_get_no_clk_in(data)                                  ((0x00000100&(data))>>8)
+#define TMDS_CPS_get_clkv_meas_sel(data)                              ((0x000000C0&(data))>>6)
+#define TMDS_CPS_get_de_inv_disable(data)                             ((0x00000020&(data))>>5)
+#define TMDS_CPS_get_de_err_pulse_en(data)                            ((0x00000010&(data))>>4)
+#define TMDS_CPS_get_clr_infoframe_dvi(data)                          ((0x00000008&(data))>>3)
+#define TMDS_CPS_get_auto_dvi2hdmi(data)                              ((0x00000004&(data))>>2)
+#define TMDS_CPS_get_dummy1800f024_1_0(data)                          (0x00000003&(data))
+
+
+#define TMDS_UDC                                                      0x1800f028
+#define TMDS_UDC_reg_addr                                             "0xb800f028"
+#define TMDS_UDC_reg                                                  0xb800f028
+#define TMDS_UDC_inst_addr                                            "0x000A"
+#define TMDS_UDC_inst                                                 0x000A
+#define TMDS_UDC_debug_sel_shift                                      (4)
+#define TMDS_UDC_dummy1800f028_3_shift                                (3)
+#define TMDS_UDC_cptest_shift                                         (2)
+#define TMDS_UDC_hmtm_shift                                           (0)
+#define TMDS_UDC_debug_sel_mask                                       (0x000003F0)
+#define TMDS_UDC_dummy1800f028_3_mask                                 (0x00000008)
+#define TMDS_UDC_cptest_mask                                          (0x00000004)
+#define TMDS_UDC_hmtm_mask                                            (0x00000003)
+#define TMDS_UDC_debug_sel(data)                                      (0x000003F0&((data)<<4))
+#define TMDS_UDC_dummy1800f028_3(data)                                (0x00000008&((data)<<3))
+#define TMDS_UDC_cptest(data)                                         (0x00000004&((data)<<2))
+#define TMDS_UDC_hmtm(data)                                           (0x00000003&(data))
+#define TMDS_UDC_get_debug_sel(data)                                  ((0x000003F0&(data))>>4)
+#define TMDS_UDC_get_dummy1800f028_3(data)                            ((0x00000008&(data))>>3)
+#define TMDS_UDC_get_cptest(data)                                     ((0x00000004&(data))>>2)
+#define TMDS_UDC_get_hmtm(data)                                       (0x00000003&(data))
+
+
+#define TMDS_ERRC                                                     0x1800f02c
+#define TMDS_ERRC_reg_addr                                            "0xb800f02c"
+#define TMDS_ERRC_reg                                                 0xb800f02c
+#define TMDS_ERRC_inst_addr                                           "0x000B"
+#define TMDS_ERRC_inst                                                0x000B
+#define TMDS_ERRC_nl_shift                                            (0)
+#define TMDS_ERRC_nl_mask                                             (0x00000007)
+#define TMDS_ERRC_nl(data)                                            (0x00000007&(data))
+#define TMDS_ERRC_get_nl(data)                                        (0x00000007&(data))
+
+
+#define TMDS_OUT_CTRL                                                 0x1800f030
+#define TMDS_OUT_CTRL_reg_addr                                        "0xb800f030"
+#define TMDS_OUT_CTRL_reg                                             0xb800f030
+#define TMDS_OUT_CTRL_inst_addr                                       "0x000C"
+#define TMDS_OUT_CTRL_inst                                            0x000C
+#define TMDS_OUT_CTRL_tmds_bypass_shift                               (7)
+#define TMDS_OUT_CTRL_dummy1800f030_6_0_shift                         (0)
+#define TMDS_OUT_CTRL_tmds_bypass_mask                                (0x00000080)
+#define TMDS_OUT_CTRL_dummy1800f030_6_0_mask                          (0x0000007F)
+#define TMDS_OUT_CTRL_tmds_bypass(data)                               (0x00000080&((data)<<7))
+#define TMDS_OUT_CTRL_dummy1800f030_6_0(data)                         (0x0000007F&(data))
+#define TMDS_OUT_CTRL_get_tmds_bypass(data)                           ((0x00000080&(data))>>7)
+#define TMDS_OUT_CTRL_get_dummy1800f030_6_0(data)                     (0x0000007F&(data))
+
+
+#define TMDS_ROUT                                                     0x1800f034
+#define TMDS_ROUT_reg_addr                                            "0xb800f034"
+#define TMDS_ROUT_reg                                                 0xb800f034
+#define TMDS_ROUT_inst_addr                                           "0x000D"
+#define TMDS_ROUT_inst                                                0x000D
+#define TMDS_ROUT_tmds_rout_h_shift                                   (8)
+#define TMDS_ROUT_tmds_rout_l_shift                                   (0)
+#define TMDS_ROUT_tmds_rout_h_mask                                    (0x0000FF00)
+#define TMDS_ROUT_tmds_rout_l_mask                                    (0x000000FF)
+#define TMDS_ROUT_tmds_rout_h(data)                                   (0x0000FF00&((data)<<8))
+#define TMDS_ROUT_tmds_rout_l(data)                                   (0x000000FF&(data))
+#define TMDS_ROUT_get_tmds_rout_h(data)                               ((0x0000FF00&(data))>>8)
+#define TMDS_ROUT_get_tmds_rout_l(data)                               (0x000000FF&(data))
+
+
+#define TMDS_GOUT                                                     0x1800f038
+#define TMDS_GOUT_reg_addr                                            "0xb800f038"
+#define TMDS_GOUT_reg                                                 0xb800f038
+#define TMDS_GOUT_inst_addr                                           "0x000E"
+#define TMDS_GOUT_inst                                                0x000E
+#define TMDS_GOUT_tmds_gout_h_shift                                   (8)
+#define TMDS_GOUT_tmds_gout_l_shift                                   (0)
+#define TMDS_GOUT_tmds_gout_h_mask                                    (0x0000FF00)
+#define TMDS_GOUT_tmds_gout_l_mask                                    (0x000000FF)
+#define TMDS_GOUT_tmds_gout_h(data)                                   (0x0000FF00&((data)<<8))
+#define TMDS_GOUT_tmds_gout_l(data)                                   (0x000000FF&(data))
+#define TMDS_GOUT_get_tmds_gout_h(data)                               ((0x0000FF00&(data))>>8)
+#define TMDS_GOUT_get_tmds_gout_l(data)                               (0x000000FF&(data))
+
+
+#define TMDS_BOUT                                                     0x1800f03c
+#define TMDS_BOUT_reg_addr                                            "0xb800f03c"
+#define TMDS_BOUT_reg                                                 0xb800f03c
+#define TMDS_BOUT_inst_addr                                           "0x000F"
+#define TMDS_BOUT_inst                                                0x000F
+#define TMDS_BOUT_tmds_bout_h_shift                                   (8)
+#define TMDS_BOUT_tmds_bout_l_shift                                   (0)
+#define TMDS_BOUT_tmds_bout_h_mask                                    (0x0000FF00)
+#define TMDS_BOUT_tmds_bout_l_mask                                    (0x000000FF)
+#define TMDS_BOUT_tmds_bout_h(data)                                   (0x0000FF00&((data)<<8))
+#define TMDS_BOUT_tmds_bout_l(data)                                   (0x000000FF&(data))
+#define TMDS_BOUT_get_tmds_bout_h(data)                               ((0x0000FF00&(data))>>8)
+#define TMDS_BOUT_get_tmds_bout_l(data)                               (0x000000FF&(data))
+
+
+#define TMDS_DPC0                                                     0x1800f040
+#define TMDS_DPC0_reg_addr                                            "0xb800f040"
+#define TMDS_DPC0_reg                                                 0xb800f040
+#define TMDS_DPC0_inst_addr                                           "0x0010"
+#define TMDS_DPC0_inst                                                0x0010
+#define TMDS_DPC0_dpc_pp_valid_shift                                  (9)
+#define TMDS_DPC0_dpc_default_ph_shift                                (8)
+#define TMDS_DPC0_dpc_pp_shift                                        (4)
+#define TMDS_DPC0_dpc_cd_shift                                        (0)
+#define TMDS_DPC0_dpc_pp_valid_mask                                   (0x00000200)
+#define TMDS_DPC0_dpc_default_ph_mask                                 (0x00000100)
+#define TMDS_DPC0_dpc_pp_mask                                         (0x000000F0)
+#define TMDS_DPC0_dpc_cd_mask                                         (0x0000000F)
+#define TMDS_DPC0_dpc_pp_valid(data)                                  (0x00000200&((data)<<9))
+#define TMDS_DPC0_dpc_default_ph(data)                                (0x00000100&((data)<<8))
+#define TMDS_DPC0_dpc_pp(data)                                        (0x000000F0&((data)<<4))
+#define TMDS_DPC0_dpc_cd(data)                                        (0x0000000F&(data))
+#define TMDS_DPC0_get_dpc_pp_valid(data)                              ((0x00000200&(data))>>9)
+#define TMDS_DPC0_get_dpc_default_ph(data)                            ((0x00000100&(data))>>8)
+#define TMDS_DPC0_get_dpc_pp(data)                                    ((0x000000F0&(data))>>4)
+#define TMDS_DPC0_get_dpc_cd(data)                                    (0x0000000F&(data))
+
+
+#define TMDS_DPC1                                                     0x1800f044
+#define TMDS_DPC1_reg_addr                                            "0xb800f044"
+#define TMDS_DPC1_reg                                                 0xb800f044
+#define TMDS_DPC1_inst_addr                                           "0x0011"
+#define TMDS_DPC1_inst                                                0x0011
+#define TMDS_DPC1_dpc_cd_chg_flag_shift                               (18)
+#define TMDS_DPC1_dpc_cd_chg_wd_en_shift                              (17)
+#define TMDS_DPC1_dpc_cd_chg_int_en_shift                             (16)
+#define TMDS_DPC1_dummy1800f044_15_11_shift                           (11)
+#define TMDS_DPC1_dpc_auto_shift                                      (10)
+#define TMDS_DPC1_dpc_pp_valid_fw_shift                               (9)
+#define TMDS_DPC1_dpc_default_ph_fw_shift                             (8)
+#define TMDS_DPC1_dpc_pp_fw_shift                                     (4)
+#define TMDS_DPC1_dpc_cd_fw_shift                                     (0)
+#define TMDS_DPC1_dpc_cd_chg_flag_mask                                (0x00040000)
+#define TMDS_DPC1_dpc_cd_chg_wd_en_mask                               (0x00020000)
+#define TMDS_DPC1_dpc_cd_chg_int_en_mask                              (0x00010000)
+#define TMDS_DPC1_dummy1800f044_15_11_mask                            (0x0000F800)
+#define TMDS_DPC1_dpc_auto_mask                                       (0x00000400)
+#define TMDS_DPC1_dpc_pp_valid_fw_mask                                (0x00000200)
+#define TMDS_DPC1_dpc_default_ph_fw_mask                              (0x00000100)
+#define TMDS_DPC1_dpc_pp_fw_mask                                      (0x000000F0)
+#define TMDS_DPC1_dpc_cd_fw_mask                                      (0x0000000F)
+#define TMDS_DPC1_dpc_cd_chg_flag(data)                               (0x00040000&((data)<<18))
+#define TMDS_DPC1_dpc_cd_chg_wd_en(data)                              (0x00020000&((data)<<17))
+#define TMDS_DPC1_dpc_cd_chg_int_en(data)                             (0x00010000&((data)<<16))
+#define TMDS_DPC1_dummy1800f044_15_11(data)                           (0x0000F800&((data)<<11))
+#define TMDS_DPC1_dpc_auto(data)                                      (0x00000400&((data)<<10))
+#define TMDS_DPC1_dpc_pp_valid_fw(data)                               (0x00000200&((data)<<9))
+#define TMDS_DPC1_dpc_default_ph_fw(data)                             (0x00000100&((data)<<8))
+#define TMDS_DPC1_dpc_pp_fw(data)                                     (0x000000F0&((data)<<4))
+#define TMDS_DPC1_dpc_cd_fw(data)                                     (0x0000000F&(data))
+#define TMDS_DPC1_get_dpc_cd_chg_flag(data)                           ((0x00040000&(data))>>18)
+#define TMDS_DPC1_get_dpc_cd_chg_wd_en(data)                          ((0x00020000&(data))>>17)
+#define TMDS_DPC1_get_dpc_cd_chg_int_en(data)                         ((0x00010000&(data))>>16)
+#define TMDS_DPC1_get_dummy1800f044_15_11(data)                       ((0x0000F800&(data))>>11)
+#define TMDS_DPC1_get_dpc_auto(data)                                  ((0x00000400&(data))>>10)
+#define TMDS_DPC1_get_dpc_pp_valid_fw(data)                           ((0x00000200&(data))>>9)
+#define TMDS_DPC1_get_dpc_default_ph_fw(data)                         ((0x00000100&(data))>>8)
+#define TMDS_DPC1_get_dpc_pp_fw(data)                                 ((0x000000F0&(data))>>4)
+#define TMDS_DPC1_get_dpc_cd_fw(data)                                 (0x0000000F&(data))
+
+
+#define TMDS_DPC_SET0                                                 0x1800f048
+#define TMDS_DPC_SET0_reg_addr                                        "0xb800f048"
+#define TMDS_DPC_SET0_reg                                             0xb800f048
+#define TMDS_DPC_SET0_inst_addr                                       "0x0012"
+#define TMDS_DPC_SET0_inst                                            0x0012
+#define TMDS_DPC_SET0_dpc_bypass_dis_shift                            (8)
+#define TMDS_DPC_SET0_dpc_en_shift                                    (7)
+#define TMDS_DPC_SET0_phase_errcnt_in_shift                           (4)
+#define TMDS_DPC_SET0_phase_clrcnt_in_shift                           (1)
+#define TMDS_DPC_SET0_phase_clr_sel_shift                             (0)
+#define TMDS_DPC_SET0_dpc_bypass_dis_mask                             (0x00000100)
+#define TMDS_DPC_SET0_dpc_en_mask                                     (0x00000080)
+#define TMDS_DPC_SET0_phase_errcnt_in_mask                            (0x00000070)
+#define TMDS_DPC_SET0_phase_clrcnt_in_mask                            (0x0000000E)
+#define TMDS_DPC_SET0_phase_clr_sel_mask                              (0x00000001)
+#define TMDS_DPC_SET0_dpc_bypass_dis(data)                            (0x00000100&((data)<<8))
+#define TMDS_DPC_SET0_dpc_en(data)                                    (0x00000080&((data)<<7))
+#define TMDS_DPC_SET0_phase_errcnt_in(data)                           (0x00000070&((data)<<4))
+#define TMDS_DPC_SET0_phase_clrcnt_in(data)                           (0x0000000E&((data)<<1))
+#define TMDS_DPC_SET0_phase_clr_sel(data)                             (0x00000001&(data))
+#define TMDS_DPC_SET0_get_dpc_bypass_dis(data)                        ((0x00000100&(data))>>8)
+#define TMDS_DPC_SET0_get_dpc_en(data)                                ((0x00000080&(data))>>7)
+#define TMDS_DPC_SET0_get_phase_errcnt_in(data)                       ((0x00000070&(data))>>4)
+#define TMDS_DPC_SET0_get_phase_clrcnt_in(data)                       ((0x0000000E&(data))>>1)
+#define TMDS_DPC_SET0_get_phase_clr_sel(data)                         (0x00000001&(data))
+
+
+#define TMDS_DPC_SET1                                                 0x1800f04c
+#define TMDS_DPC_SET1_reg_addr                                        "0xb800f04c"
+#define TMDS_DPC_SET1_reg                                             0xb800f04c
+#define TMDS_DPC_SET1_inst_addr                                       "0x0013"
+#define TMDS_DPC_SET1_inst                                            0x0013
+#define TMDS_DPC_SET1_set_full_noti_shift                             (4)
+#define TMDS_DPC_SET1_set_empty_noti_shift                            (0)
+#define TMDS_DPC_SET1_set_full_noti_mask                              (0x000000F0)
+#define TMDS_DPC_SET1_set_empty_noti_mask                             (0x0000000F)
+#define TMDS_DPC_SET1_set_full_noti(data)                             (0x000000F0&((data)<<4))
+#define TMDS_DPC_SET1_set_empty_noti(data)                            (0x0000000F&(data))
+#define TMDS_DPC_SET1_get_set_full_noti(data)                         ((0x000000F0&(data))>>4)
+#define TMDS_DPC_SET1_get_set_empty_noti(data)                        (0x0000000F&(data))
+
+
+#define TMDS_DPC_SET2                                                 0x1800f050
+#define TMDS_DPC_SET2_reg_addr                                        "0xb800f050"
+#define TMDS_DPC_SET2_reg                                             0xb800f050
+#define TMDS_DPC_SET2_inst_addr                                       "0x0014"
+#define TMDS_DPC_SET2_inst                                            0x0014
+#define TMDS_DPC_SET2_fifo_errcnt_in_shift                            (5)
+#define TMDS_DPC_SET2_clr_phase_flag_shift                            (4)
+#define TMDS_DPC_SET2_clr_fifo_flag_shift                             (3)
+#define TMDS_DPC_SET2_dpc_phase_ok_shift                              (2)
+#define TMDS_DPC_SET2_dpc_phase_err_flag_shift                        (1)
+#define TMDS_DPC_SET2_dpc_fifo_err_flag_shift                         (0)
+#define TMDS_DPC_SET2_fifo_errcnt_in_mask                             (0x000000E0)
+#define TMDS_DPC_SET2_clr_phase_flag_mask                             (0x00000010)
+#define TMDS_DPC_SET2_clr_fifo_flag_mask                              (0x00000008)
+#define TMDS_DPC_SET2_dpc_phase_ok_mask                               (0x00000004)
+#define TMDS_DPC_SET2_dpc_phase_err_flag_mask                         (0x00000002)
+#define TMDS_DPC_SET2_dpc_fifo_err_flag_mask                          (0x00000001)
+#define TMDS_DPC_SET2_fifo_errcnt_in(data)                            (0x000000E0&((data)<<5))
+#define TMDS_DPC_SET2_clr_phase_flag(data)                            (0x00000010&((data)<<4))
+#define TMDS_DPC_SET2_clr_fifo_flag(data)                             (0x00000008&((data)<<3))
+#define TMDS_DPC_SET2_dpc_phase_ok(data)                              (0x00000004&((data)<<2))
+#define TMDS_DPC_SET2_dpc_phase_err_flag(data)                        (0x00000002&((data)<<1))
+#define TMDS_DPC_SET2_dpc_fifo_err_flag(data)                         (0x00000001&(data))
+#define TMDS_DPC_SET2_get_fifo_errcnt_in(data)                        ((0x000000E0&(data))>>5)
+#define TMDS_DPC_SET2_get_clr_phase_flag(data)                        ((0x00000010&(data))>>4)
+#define TMDS_DPC_SET2_get_clr_fifo_flag(data)                         ((0x00000008&(data))>>3)
+#define TMDS_DPC_SET2_get_dpc_phase_ok(data)                          ((0x00000004&(data))>>2)
+#define TMDS_DPC_SET2_get_dpc_phase_err_flag(data)                    ((0x00000002&(data))>>1)
+#define TMDS_DPC_SET2_get_dpc_fifo_err_flag(data)                     (0x00000001&(data))
+
+
+#define TMDS_DPC_SET3                                                 0x1800f054
+#define TMDS_DPC_SET3_reg_addr                                        "0xb800f054"
+#define TMDS_DPC_SET3_reg                                             0xb800f054
+#define TMDS_DPC_SET3_inst_addr                                       "0x0015"
+#define TMDS_DPC_SET3_inst                                            0x0015
+#define TMDS_DPC_SET3_dpc_fifo_over_flag_shift                        (7)
+#define TMDS_DPC_SET3_dpc_fifo_under_flag_shift                       (6)
+#define TMDS_DPC_SET3_dpc_fifo_over_xflag_shift                       (5)
+#define TMDS_DPC_SET3_dpc_fifo_under_xflag_shift                      (4)
+#define TMDS_DPC_SET3_dpc_fifo_over_flag_mask                         (0x00000080)
+#define TMDS_DPC_SET3_dpc_fifo_under_flag_mask                        (0x00000040)
+#define TMDS_DPC_SET3_dpc_fifo_over_xflag_mask                        (0x00000020)
+#define TMDS_DPC_SET3_dpc_fifo_under_xflag_mask                       (0x00000010)
+#define TMDS_DPC_SET3_dpc_fifo_over_flag(data)                        (0x00000080&((data)<<7))
+#define TMDS_DPC_SET3_dpc_fifo_under_flag(data)                       (0x00000040&((data)<<6))
+#define TMDS_DPC_SET3_dpc_fifo_over_xflag(data)                       (0x00000020&((data)<<5))
+#define TMDS_DPC_SET3_dpc_fifo_under_xflag(data)                      (0x00000010&((data)<<4))
+#define TMDS_DPC_SET3_get_dpc_fifo_over_flag(data)                    ((0x00000080&(data))>>7)
+#define TMDS_DPC_SET3_get_dpc_fifo_under_flag(data)                   ((0x00000040&(data))>>6)
+#define TMDS_DPC_SET3_get_dpc_fifo_over_xflag(data)                   ((0x00000020&(data))>>5)
+#define TMDS_DPC_SET3_get_dpc_fifo_under_xflag(data)                  ((0x00000010&(data))>>4)
+
+
+#define TMDS_DET_CTL                                                  0x1800f058
+#define TMDS_DET_CTL_reg_addr                                         "0xb800f058"
+#define TMDS_DET_CTL_reg                                              0xb800f058
+#define TMDS_DET_CTL_inst_addr                                        "0x0016"
+#define TMDS_DET_CTL_inst                                             0x0016
+#define TMDS_DET_CTL_de_sel_shift                                     (28)
+#define TMDS_DET_CTL_tran_err_thrd_shift                              (24)
+#define TMDS_DET_CTL_neg_de_err_thrd_shift                            (20)
+#define TMDS_DET_CTL_pos_de_err_thrd_shift                            (16)
+#define TMDS_DET_CTL_dummy1800f058_15_shift                           (15)
+#define TMDS_DET_CTL_neg_de_lowbd_shift                               (8)
+#define TMDS_DET_CTL_dummy1800f058_7_6_shift                          (6)
+#define TMDS_DET_CTL_pos_de_lowbd_shift                               (0)
+#define TMDS_DET_CTL_de_sel_mask                                      (0x10000000)
+#define TMDS_DET_CTL_tran_err_thrd_mask                               (0x0F000000)
+#define TMDS_DET_CTL_neg_de_err_thrd_mask                             (0x00F00000)
+#define TMDS_DET_CTL_pos_de_err_thrd_mask                             (0x000F0000)
+#define TMDS_DET_CTL_dummy1800f058_15_mask                            (0x00008000)
+#define TMDS_DET_CTL_neg_de_lowbd_mask                                (0x00007F00)
+#define TMDS_DET_CTL_dummy1800f058_7_6_mask                           (0x000000C0)
+#define TMDS_DET_CTL_pos_de_lowbd_mask                                (0x0000003F)
+#define TMDS_DET_CTL_de_sel(data)                                     (0x10000000&((data)<<28))
+#define TMDS_DET_CTL_tran_err_thrd(data)                              (0x0F000000&((data)<<24))
+#define TMDS_DET_CTL_neg_de_err_thrd(data)                            (0x00F00000&((data)<<20))
+#define TMDS_DET_CTL_pos_de_err_thrd(data)                            (0x000F0000&((data)<<16))
+#define TMDS_DET_CTL_dummy1800f058_15(data)                           (0x00008000&((data)<<15))
+#define TMDS_DET_CTL_neg_de_lowbd(data)                               (0x00007F00&((data)<<8))
+#define TMDS_DET_CTL_dummy1800f058_7_6(data)                          (0x000000C0&((data)<<6))
+#define TMDS_DET_CTL_pos_de_lowbd(data)                               (0x0000003F&(data))
+#define TMDS_DET_CTL_get_de_sel(data)                                 ((0x10000000&(data))>>28)
+#define TMDS_DET_CTL_get_tran_err_thrd(data)                          ((0x0F000000&(data))>>24)
+#define TMDS_DET_CTL_get_neg_de_err_thrd(data)                        ((0x00F00000&(data))>>20)
+#define TMDS_DET_CTL_get_pos_de_err_thrd(data)                        ((0x000F0000&(data))>>16)
+#define TMDS_DET_CTL_get_dummy1800f058_15(data)                       ((0x00008000&(data))>>15)
+#define TMDS_DET_CTL_get_neg_de_lowbd(data)                           ((0x00007F00&(data))>>8)
+#define TMDS_DET_CTL_get_dummy1800f058_7_6(data)                      ((0x000000C0&(data))>>6)
+#define TMDS_DET_CTL_get_pos_de_lowbd(data)                           (0x0000003F&(data))
+
+
+#define TMDS_DET_STS                                                  0x1800f05c
+#define TMDS_DET_STS_reg_addr                                         "0xb800f05c"
+#define TMDS_DET_STS_reg                                              0xb800f05c
+#define TMDS_DET_STS_inst_addr                                        "0x0017"
+#define TMDS_DET_STS_inst                                             0x0017
+#define TMDS_DET_STS_red_tran_err_flag_shift                          (8)
+#define TMDS_DET_STS_grn_tran_err_flag_shift                          (7)
+#define TMDS_DET_STS_blu_tran_err_flag_shift                          (6)
+#define TMDS_DET_STS_red_pos_de_err_flag_shift                        (5)
+#define TMDS_DET_STS_grn_pos_de_err_flag_shift                        (4)
+#define TMDS_DET_STS_blu_pos_de_err_flag_shift                        (3)
+#define TMDS_DET_STS_red_neg_de_err_flag_shift                        (2)
+#define TMDS_DET_STS_grn_neg_de_err_flag_shift                        (1)
+#define TMDS_DET_STS_blu_neg_de_err_flag_shift                        (0)
+#define TMDS_DET_STS_red_tran_err_flag_mask                           (0x00000100)
+#define TMDS_DET_STS_grn_tran_err_flag_mask                           (0x00000080)
+#define TMDS_DET_STS_blu_tran_err_flag_mask                           (0x00000040)
+#define TMDS_DET_STS_red_pos_de_err_flag_mask                         (0x00000020)
+#define TMDS_DET_STS_grn_pos_de_err_flag_mask                         (0x00000010)
+#define TMDS_DET_STS_blu_pos_de_err_flag_mask                         (0x00000008)
+#define TMDS_DET_STS_red_neg_de_err_flag_mask                         (0x00000004)
+#define TMDS_DET_STS_grn_neg_de_err_flag_mask                         (0x00000002)
+#define TMDS_DET_STS_blu_neg_de_err_flag_mask                         (0x00000001)
+#define TMDS_DET_STS_red_tran_err_flag(data)                          (0x00000100&((data)<<8))
+#define TMDS_DET_STS_grn_tran_err_flag(data)                          (0x00000080&((data)<<7))
+#define TMDS_DET_STS_blu_tran_err_flag(data)                          (0x00000040&((data)<<6))
+#define TMDS_DET_STS_red_pos_de_err_flag(data)                        (0x00000020&((data)<<5))
+#define TMDS_DET_STS_grn_pos_de_err_flag(data)                        (0x00000010&((data)<<4))
+#define TMDS_DET_STS_blu_pos_de_err_flag(data)                        (0x00000008&((data)<<3))
+#define TMDS_DET_STS_red_neg_de_err_flag(data)                        (0x00000004&((data)<<2))
+#define TMDS_DET_STS_grn_neg_de_err_flag(data)                        (0x00000002&((data)<<1))
+#define TMDS_DET_STS_blu_neg_de_err_flag(data)                        (0x00000001&(data))
+#define TMDS_DET_STS_get_red_tran_err_flag(data)                      ((0x00000100&(data))>>8)
+#define TMDS_DET_STS_get_grn_tran_err_flag(data)                      ((0x00000080&(data))>>7)
+#define TMDS_DET_STS_get_blu_tran_err_flag(data)                      ((0x00000040&(data))>>6)
+#define TMDS_DET_STS_get_red_pos_de_err_flag(data)                    ((0x00000020&(data))>>5)
+#define TMDS_DET_STS_get_grn_pos_de_err_flag(data)                    ((0x00000010&(data))>>4)
+#define TMDS_DET_STS_get_blu_pos_de_err_flag(data)                    ((0x00000008&(data))>>3)
+#define TMDS_DET_STS_get_red_neg_de_err_flag(data)                    ((0x00000004&(data))>>2)
+#define TMDS_DET_STS_get_grn_neg_de_err_flag(data)                    ((0x00000002&(data))>>1)
+#define TMDS_DET_STS_get_blu_neg_de_err_flag(data)                    (0x00000001&(data))
+
+
+#define VIDEO_BIT_ERR_DET                                             0x1800f060
+#define VIDEO_BIT_ERR_DET_reg_addr                                    "0xb800f060"
+#define VIDEO_BIT_ERR_DET_reg                                         0xb800f060
+#define VIDEO_BIT_ERR_DET_inst_addr                                   "0x0018"
+#define VIDEO_BIT_ERR_DET_inst                                        0x0018
+#define VIDEO_BIT_ERR_DET_thd_shift                                   (16)
+#define VIDEO_BIT_ERR_DET_irq_en_shift                                (11)
+#define VIDEO_BIT_ERR_DET_reset_shift                                 (10)
+#define VIDEO_BIT_ERR_DET_period_shift                                (4)
+#define VIDEO_BIT_ERR_DET_ch_sel_shift                                (2)
+#define VIDEO_BIT_ERR_DET_mode_shift                                  (1)
+#define VIDEO_BIT_ERR_DET_en_shift                                    (0)
+#define VIDEO_BIT_ERR_DET_thd_mask                                    (0xFFFF0000)
+#define VIDEO_BIT_ERR_DET_irq_en_mask                                 (0x00000800)
+#define VIDEO_BIT_ERR_DET_reset_mask                                  (0x00000400)
+#define VIDEO_BIT_ERR_DET_period_mask                                 (0x000003F0)
+#define VIDEO_BIT_ERR_DET_ch_sel_mask                                 (0x0000000C)
+#define VIDEO_BIT_ERR_DET_mode_mask                                   (0x00000002)
+#define VIDEO_BIT_ERR_DET_en_mask                                     (0x00000001)
+#define VIDEO_BIT_ERR_DET_thd(data)                                   (0xFFFF0000&((data)<<16))
+#define VIDEO_BIT_ERR_DET_irq_en(data)                                (0x00000800&((data)<<11))
+#define VIDEO_BIT_ERR_DET_reset(data)                                 (0x00000400&((data)<<10))
+#define VIDEO_BIT_ERR_DET_period(data)                                (0x000003F0&((data)<<4))
+#define VIDEO_BIT_ERR_DET_ch_sel(data)                                (0x0000000C&((data)<<2))
+#define VIDEO_BIT_ERR_DET_mode(data)                                  (0x00000002&((data)<<1))
+#define VIDEO_BIT_ERR_DET_en(data)                                    (0x00000001&(data))
+#define VIDEO_BIT_ERR_DET_get_thd(data)                               ((0xFFFF0000&(data))>>16)
+#define VIDEO_BIT_ERR_DET_get_irq_en(data)                            ((0x00000800&(data))>>11)
+#define VIDEO_BIT_ERR_DET_get_reset(data)                             ((0x00000400&(data))>>10)
+#define VIDEO_BIT_ERR_DET_get_period(data)                            ((0x000003F0&(data))>>4)
+#define VIDEO_BIT_ERR_DET_get_ch_sel(data)                            ((0x0000000C&(data))>>2)
+#define VIDEO_BIT_ERR_DET_get_mode(data)                              ((0x00000002&(data))>>1)
+#define VIDEO_BIT_ERR_DET_get_en(data)                                (0x00000001&(data))
+
+
+#define VIDEO_BIT_ERR_STATUS                                          0x1800f064
+#define VIDEO_BIT_ERR_STATUS_reg_addr                                 "0xb800f064"
+#define VIDEO_BIT_ERR_STATUS_reg                                      0xb800f064
+#define VIDEO_BIT_ERR_STATUS_inst_addr                                "0x0019"
+#define VIDEO_BIT_ERR_STATUS_inst                                     0x0019
+#define VIDEO_BIT_ERR_STATUS_ad_max_shift                             (25)
+#define VIDEO_BIT_ERR_STATUS_ad_min_shift                             (20)
+#define VIDEO_BIT_ERR_STATUS_no_dis_reset_shift                       (19)
+#define VIDEO_BIT_ERR_STATUS_bit_err_thd_shift                        (18)
+#define VIDEO_BIT_ERR_STATUS_bit_err_shift                            (17)
+#define VIDEO_BIT_ERR_STATUS_bit_err_cnt_of_shift                     (16)
+#define VIDEO_BIT_ERR_STATUS_bit_err_cnt_shift                        (0)
+#define VIDEO_BIT_ERR_STATUS_ad_max_mask                              (0x3E000000)
+#define VIDEO_BIT_ERR_STATUS_ad_min_mask                              (0x01F00000)
+#define VIDEO_BIT_ERR_STATUS_no_dis_reset_mask                        (0x00080000)
+#define VIDEO_BIT_ERR_STATUS_bit_err_thd_mask                         (0x00040000)
+#define VIDEO_BIT_ERR_STATUS_bit_err_mask                             (0x00020000)
+#define VIDEO_BIT_ERR_STATUS_bit_err_cnt_of_mask                      (0x00010000)
+#define VIDEO_BIT_ERR_STATUS_bit_err_cnt_mask                         (0x0000FFFF)
+#define VIDEO_BIT_ERR_STATUS_ad_max(data)                             (0x3E000000&((data)<<25))
+#define VIDEO_BIT_ERR_STATUS_ad_min(data)                             (0x01F00000&((data)<<20))
+#define VIDEO_BIT_ERR_STATUS_no_dis_reset(data)                       (0x00080000&((data)<<19))
+#define VIDEO_BIT_ERR_STATUS_bit_err_thd(data)                        (0x00040000&((data)<<18))
+#define VIDEO_BIT_ERR_STATUS_bit_err(data)                            (0x00020000&((data)<<17))
+#define VIDEO_BIT_ERR_STATUS_bit_err_cnt_of(data)                     (0x00010000&((data)<<16))
+#define VIDEO_BIT_ERR_STATUS_bit_err_cnt(data)                        (0x0000FFFF&(data))
+#define VIDEO_BIT_ERR_STATUS_get_ad_max(data)                         ((0x3E000000&(data))>>25)
+#define VIDEO_BIT_ERR_STATUS_get_ad_min(data)                         ((0x01F00000&(data))>>20)
+#define VIDEO_BIT_ERR_STATUS_get_no_dis_reset(data)                   ((0x00080000&(data))>>19)
+#define VIDEO_BIT_ERR_STATUS_get_bit_err_thd(data)                    ((0x00040000&(data))>>18)
+#define VIDEO_BIT_ERR_STATUS_get_bit_err(data)                        ((0x00020000&(data))>>17)
+#define VIDEO_BIT_ERR_STATUS_get_bit_err_cnt_of(data)                 ((0x00010000&(data))>>16)
+#define VIDEO_BIT_ERR_STATUS_get_bit_err_cnt(data)                    (0x0000FFFF&(data))
+
+
+#define HDMI_SR                                                       0x1800f080
+#define HDMI_SR_reg_addr                                              "0xb800f080"
+#define HDMI_SR_reg                                                   0xb800f080
+#define HDMI_SR_inst_addr                                             "0x0020"
+#define HDMI_SR_inst                                                  0x0020
+#define HDMI_SR_avmute_bg_shift                                       (7)
+#define HDMI_SR_avmute_shift                                          (6)
+#define HDMI_SR_vic_shift                                             (5)
+#define HDMI_SR_spdiftype_shift                                       (4)
+#define HDMI_SR_pllsts_shift                                          (3)
+#define HDMI_SR_afifoof_shift                                         (2)
+#define HDMI_SR_afifouf_shift                                         (1)
+#define HDMI_SR_mode_shift                                            (0)
+#define HDMI_SR_avmute_bg_mask                                        (0x00000080)
+#define HDMI_SR_avmute_mask                                           (0x00000040)
+#define HDMI_SR_vic_mask                                              (0x00000020)
+#define HDMI_SR_spdiftype_mask                                        (0x00000010)
+#define HDMI_SR_pllsts_mask                                           (0x00000008)
+#define HDMI_SR_afifoof_mask                                          (0x00000004)
+#define HDMI_SR_afifouf_mask                                          (0x00000002)
+#define HDMI_SR_mode_mask                                             (0x00000001)
+#define HDMI_SR_avmute_bg(data)                                       (0x00000080&((data)<<7))
+#define HDMI_SR_avmute(data)                                          (0x00000040&((data)<<6))
+#define HDMI_SR_vic(data)                                             (0x00000020&((data)<<5))
+#define HDMI_SR_spdiftype(data)                                       (0x00000010&((data)<<4))
+#define HDMI_SR_pllsts(data)                                          (0x00000008&((data)<<3))
+#define HDMI_SR_afifoof(data)                                         (0x00000004&((data)<<2))
+#define HDMI_SR_afifouf(data)                                         (0x00000002&((data)<<1))
+#define HDMI_SR_mode(data)                                            (0x00000001&(data))
+#define HDMI_SR_get_avmute_bg(data)                                   ((0x00000080&(data))>>7)
+#define HDMI_SR_get_avmute(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_SR_get_vic(data)                                         ((0x00000020&(data))>>5)
+#define HDMI_SR_get_spdiftype(data)                                   ((0x00000010&(data))>>4)
+#define HDMI_SR_get_pllsts(data)                                      ((0x00000008&(data))>>3)
+#define HDMI_SR_get_afifoof(data)                                     ((0x00000004&(data))>>2)
+#define HDMI_SR_get_afifouf(data)                                     ((0x00000002&(data))>>1)
+#define HDMI_SR_get_mode(data)                                        (0x00000001&(data))
+
+
+#define HDMI_GPVS                                                     0x1800f084
+#define HDMI_GPVS_reg_addr                                            "0xb800f084"
+#define HDMI_GPVS_reg                                                 0xb800f084
+#define HDMI_GPVS_inst_addr                                           "0x0021"
+#define HDMI_GPVS_inst                                                0x0021
+#define HDMI_GPVS_gmps_v_shift                                        (13)
+#define HDMI_GPVS_vsps_v_shift                                        (12)
+#define HDMI_GPVS_gmps_shift                                          (11)
+#define HDMI_GPVS_vsps_shift                                          (10)
+#define HDMI_GPVS_nps_shift                                           (9)
+#define HDMI_GPVS_pis_8_shift                                         (8)
+#define HDMI_GPVS_pis_7_shift                                         (7)
+#define HDMI_GPVS_pis_6_shift                                         (6)
+#define HDMI_GPVS_pis_5_shift                                         (5)
+#define HDMI_GPVS_pvs_4_shift                                         (4)
+#define HDMI_GPVS_pvs_3_shift                                         (3)
+#define HDMI_GPVS_pvs_2_shift                                         (2)
+#define HDMI_GPVS_pvs_1_shift                                         (1)
+#define HDMI_GPVS_pvs_0_shift                                         (0)
+#define HDMI_GPVS_gmps_v_mask                                         (0x00002000)
+#define HDMI_GPVS_vsps_v_mask                                         (0x00001000)
+#define HDMI_GPVS_gmps_mask                                           (0x00000800)
+#define HDMI_GPVS_vsps_mask                                           (0x00000400)
+#define HDMI_GPVS_nps_mask                                            (0x00000200)
+#define HDMI_GPVS_pis_8_mask                                          (0x00000100)
+#define HDMI_GPVS_pis_7_mask                                          (0x00000080)
+#define HDMI_GPVS_pis_6_mask                                          (0x00000040)
+#define HDMI_GPVS_pis_5_mask                                          (0x00000020)
+#define HDMI_GPVS_pvs_4_mask                                          (0x00000010)
+#define HDMI_GPVS_pvs_3_mask                                          (0x00000008)
+#define HDMI_GPVS_pvs_2_mask                                          (0x00000004)
+#define HDMI_GPVS_pvs_1_mask                                          (0x00000002)
+#define HDMI_GPVS_pvs_0_mask                                          (0x00000001)
+#define HDMI_GPVS_gmps_v(data)                                        (0x00002000&((data)<<13))
+#define HDMI_GPVS_vsps_v(data)                                        (0x00001000&((data)<<12))
+#define HDMI_GPVS_gmps(data)                                          (0x00000800&((data)<<11))
+#define HDMI_GPVS_vsps(data)                                          (0x00000400&((data)<<10))
+#define HDMI_GPVS_nps(data)                                           (0x00000200&((data)<<9))
+#define HDMI_GPVS_pis_8(data)                                         (0x00000100&((data)<<8))
+#define HDMI_GPVS_pis_7(data)                                         (0x00000080&((data)<<7))
+#define HDMI_GPVS_pis_6(data)                                         (0x00000040&((data)<<6))
+#define HDMI_GPVS_pis_5(data)                                         (0x00000020&((data)<<5))
+#define HDMI_GPVS_pvs_4(data)                                         (0x00000010&((data)<<4))
+#define HDMI_GPVS_pvs_3(data)                                         (0x00000008&((data)<<3))
+#define HDMI_GPVS_pvs_2(data)                                         (0x00000004&((data)<<2))
+#define HDMI_GPVS_pvs_1(data)                                         (0x00000002&((data)<<1))
+#define HDMI_GPVS_pvs_0(data)                                         (0x00000001&(data))
+#define HDMI_GPVS_get_gmps_v(data)                                    ((0x00002000&(data))>>13)
+#define HDMI_GPVS_get_vsps_v(data)                                    ((0x00001000&(data))>>12)
+#define HDMI_GPVS_get_gmps(data)                                      ((0x00000800&(data))>>11)
+#define HDMI_GPVS_get_vsps(data)                                      ((0x00000400&(data))>>10)
+#define HDMI_GPVS_get_nps(data)                                       ((0x00000200&(data))>>9)
+#define HDMI_GPVS_get_pis_8(data)                                     ((0x00000100&(data))>>8)
+#define HDMI_GPVS_get_pis_7(data)                                     ((0x00000080&(data))>>7)
+#define HDMI_GPVS_get_pis_6(data)                                     ((0x00000040&(data))>>6)
+#define HDMI_GPVS_get_pis_5(data)                                     ((0x00000020&(data))>>5)
+#define HDMI_GPVS_get_pvs_4(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_GPVS_get_pvs_3(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_GPVS_get_pvs_2(data)                                     ((0x00000004&(data))>>2)
+#define HDMI_GPVS_get_pvs_1(data)                                     ((0x00000002&(data))>>1)
+#define HDMI_GPVS_get_pvs_0(data)                                     (0x00000001&(data))
+
+
+#define HDMI_PSAP                                                     0x1800f088
+#define HDMI_PSAP_reg_addr                                            "0xb800f088"
+#define HDMI_PSAP_reg                                                 0xb800f088
+#define HDMI_PSAP_inst_addr                                           "0x0022"
+#define HDMI_PSAP_inst                                                0x0022
+#define HDMI_PSAP_apss_shift                                          (0)
+#define HDMI_PSAP_apss_mask                                           (0x000000FF)
+#define HDMI_PSAP_apss(data)                                          (0x000000FF&(data))
+#define HDMI_PSAP_get_apss(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_PSDP                                                     0x1800f08c
+#define HDMI_PSDP_reg_addr                                            "0xb800f08c"
+#define HDMI_PSDP_reg                                                 0xb800f08c
+#define HDMI_PSDP_inst_addr                                           "0x0023"
+#define HDMI_PSDP_inst                                                0x0023
+#define HDMI_PSDP_dpss_shift                                          (0)
+#define HDMI_PSDP_dpss_mask                                           (0x000000FF)
+#define HDMI_PSDP_dpss(data)                                          (0x000000FF&(data))
+#define HDMI_PSDP_get_dpss(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_SCR                                                      0x1800f090
+#define HDMI_SCR_reg_addr                                             "0xb800f090"
+#define HDMI_SCR_reg                                                  0xb800f090
+#define HDMI_SCR_inst_addr                                            "0x0024"
+#define HDMI_SCR_inst                                                 0x0024
+#define HDMI_SCR_nval_shift                                           (8)
+#define HDMI_SCR_dvi_reset_ds_cm_en_shift                             (5)
+#define HDMI_SCR_packet_ignore_shift                                  (4)
+#define HDMI_SCR_mode_shift                                           (3)
+#define HDMI_SCR_msmode_shift                                         (2)
+#define HDMI_SCR_cabs_shift                                           (1)
+#define HDMI_SCR_fcddip_shift                                         (0)
+#define HDMI_SCR_nval_mask                                            (0x0000FF00)
+#define HDMI_SCR_dvi_reset_ds_cm_en_mask                              (0x00000020)
+#define HDMI_SCR_packet_ignore_mask                                   (0x00000010)
+#define HDMI_SCR_mode_mask                                            (0x00000008)
+#define HDMI_SCR_msmode_mask                                          (0x00000004)
+#define HDMI_SCR_cabs_mask                                            (0x00000002)
+#define HDMI_SCR_fcddip_mask                                          (0x00000001)
+#define HDMI_SCR_nval(data)                                           (0x0000FF00&((data)<<8))
+#define HDMI_SCR_dvi_reset_ds_cm_en(data)                             (0x00000020&((data)<<5))
+#define HDMI_SCR_packet_ignore(data)                                  (0x00000010&((data)<<4))
+#define HDMI_SCR_mode(data)                                           (0x00000008&((data)<<3))
+#define HDMI_SCR_msmode(data)                                         (0x00000004&((data)<<2))
+#define HDMI_SCR_cabs(data)                                           (0x00000002&((data)<<1))
+#define HDMI_SCR_fcddip(data)                                         (0x00000001&(data))
+#define HDMI_SCR_get_nval(data)                                       ((0x0000FF00&(data))>>8)
+#define HDMI_SCR_get_dvi_reset_ds_cm_en(data)                         ((0x00000020&(data))>>5)
+#define HDMI_SCR_get_packet_ignore(data)                              ((0x00000010&(data))>>4)
+#define HDMI_SCR_get_mode(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_SCR_get_msmode(data)                                     ((0x00000004&(data))>>2)
+#define HDMI_SCR_get_cabs(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_SCR_get_fcddip(data)                                     (0x00000001&(data))
+
+
+#define HDMI_BCHCR                                                    0x1800f094
+#define HDMI_BCHCR_reg_addr                                           "0xb800f094"
+#define HDMI_BCHCR_reg                                                0xb800f094
+#define HDMI_BCHCR_inst_addr                                          "0x0025"
+#define HDMI_BCHCR_inst                                               0x0025
+#define HDMI_BCHCR_spcss_shift                                        (5)
+#define HDMI_BCHCR_enrwe_shift                                        (4)
+#define HDMI_BCHCR_bche_shift                                         (3)
+#define HDMI_BCHCR_bches_shift                                        (2)
+#define HDMI_BCHCR_bches2_shift                                       (1)
+#define HDMI_BCHCR_pe_shift                                           (0)
+#define HDMI_BCHCR_spcss_mask                                         (0x00000020)
+#define HDMI_BCHCR_enrwe_mask                                         (0x00000010)
+#define HDMI_BCHCR_bche_mask                                          (0x00000008)
+#define HDMI_BCHCR_bches_mask                                         (0x00000004)
+#define HDMI_BCHCR_bches2_mask                                        (0x00000002)
+#define HDMI_BCHCR_pe_mask                                            (0x00000001)
+#define HDMI_BCHCR_spcss(data)                                        (0x00000020&((data)<<5))
+#define HDMI_BCHCR_enrwe(data)                                        (0x00000010&((data)<<4))
+#define HDMI_BCHCR_bche(data)                                         (0x00000008&((data)<<3))
+#define HDMI_BCHCR_bches(data)                                        (0x00000004&((data)<<2))
+#define HDMI_BCHCR_bches2(data)                                       (0x00000002&((data)<<1))
+#define HDMI_BCHCR_pe(data)                                           (0x00000001&(data))
+#define HDMI_BCHCR_get_spcss(data)                                    ((0x00000020&(data))>>5)
+#define HDMI_BCHCR_get_enrwe(data)                                    ((0x00000010&(data))>>4)
+#define HDMI_BCHCR_get_bche(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_BCHCR_get_bches(data)                                    ((0x00000004&(data))>>2)
+#define HDMI_BCHCR_get_bches2(data)                                   ((0x00000002&(data))>>1)
+#define HDMI_BCHCR_get_pe(data)                                       (0x00000001&(data))
+
+
+#define HDMI_AVMCR                                                    0x1800f098
+#define HDMI_AVMCR_reg_addr                                           "0xb800f098"
+#define HDMI_AVMCR_reg                                                0xb800f098
+#define HDMI_AVMCR_inst_addr                                          "0x0026"
+#define HDMI_AVMCR_inst                                               0x0026
+#define HDMI_AVMCR_wd_ptg_en_shift                                    (10)
+#define HDMI_AVMCR_wd_vclk_en_shift                                   (9)
+#define HDMI_AVMCR_avmute_flag_shift                                  (8)
+#define HDMI_AVMCR_avmute_win_en_shift                                (7)
+#define HDMI_AVMCR_aoc_shift                                          (6)
+#define HDMI_AVMCR_aomc_shift                                         (5)
+#define HDMI_AVMCR_awd_shift                                          (4)
+#define HDMI_AVMCR_ve_shift                                           (3)
+#define HDMI_AVMCR_ampic_shift                                        (2)
+#define HDMI_AVMCR_vdpic_shift                                        (1)
+#define HDMI_AVMCR_nfpss_shift                                        (0)
+#define HDMI_AVMCR_wd_ptg_en_mask                                     (0x00000400)
+#define HDMI_AVMCR_wd_vclk_en_mask                                    (0x00000200)
+#define HDMI_AVMCR_avmute_flag_mask                                   (0x00000100)
+#define HDMI_AVMCR_avmute_win_en_mask                                 (0x00000080)
+#define HDMI_AVMCR_aoc_mask                                           (0x00000040)
+#define HDMI_AVMCR_aomc_mask                                          (0x00000020)
+#define HDMI_AVMCR_awd_mask                                           (0x00000010)
+#define HDMI_AVMCR_ve_mask                                            (0x00000008)
+#define HDMI_AVMCR_ampic_mask                                         (0x00000004)
+#define HDMI_AVMCR_vdpic_mask                                         (0x00000002)
+#define HDMI_AVMCR_nfpss_mask                                         (0x00000001)
+#define HDMI_AVMCR_wd_ptg_en(data)                                    (0x00000400&((data)<<10))
+#define HDMI_AVMCR_wd_vclk_en(data)                                   (0x00000200&((data)<<9))
+#define HDMI_AVMCR_avmute_flag(data)                                  (0x00000100&((data)<<8))
+#define HDMI_AVMCR_avmute_win_en(data)                                (0x00000080&((data)<<7))
+#define HDMI_AVMCR_aoc(data)                                          (0x00000040&((data)<<6))
+#define HDMI_AVMCR_aomc(data)                                         (0x00000020&((data)<<5))
+#define HDMI_AVMCR_awd(data)                                          (0x00000010&((data)<<4))
+#define HDMI_AVMCR_ve(data)                                           (0x00000008&((data)<<3))
+#define HDMI_AVMCR_ampic(data)                                        (0x00000004&((data)<<2))
+#define HDMI_AVMCR_vdpic(data)                                        (0x00000002&((data)<<1))
+#define HDMI_AVMCR_nfpss(data)                                        (0x00000001&(data))
+#define HDMI_AVMCR_get_wd_ptg_en(data)                                ((0x00000400&(data))>>10)
+#define HDMI_AVMCR_get_wd_vclk_en(data)                               ((0x00000200&(data))>>9)
+#define HDMI_AVMCR_get_avmute_flag(data)                              ((0x00000100&(data))>>8)
+#define HDMI_AVMCR_get_avmute_win_en(data)                            ((0x00000080&(data))>>7)
+#define HDMI_AVMCR_get_aoc(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_AVMCR_get_aomc(data)                                     ((0x00000020&(data))>>5)
+#define HDMI_AVMCR_get_awd(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_AVMCR_get_ve(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_AVMCR_get_ampic(data)                                    ((0x00000004&(data))>>2)
+#define HDMI_AVMCR_get_vdpic(data)                                    ((0x00000002&(data))>>1)
+#define HDMI_AVMCR_get_nfpss(data)                                    (0x00000001&(data))
+
+
+#define HDMI_WDCR0                                                    0x1800f09c
+#define HDMI_WDCR0_reg_addr                                           "0xb800f09c"
+#define HDMI_WDCR0_reg                                                0xb800f09c
+#define HDMI_WDCR0_inst_addr                                          "0x0027"
+#define HDMI_WDCR0_inst                                               0x0027
+#define HDMI_WDCR0_vwdap_shift                                        (23)
+#define HDMI_WDCR0_vwdlf_shift                                        (22)
+#define HDMI_WDCR0_vwdafo_shift                                       (21)
+#define HDMI_WDCR0_vwdafu_shift                                       (20)
+#define HDMI_WDCR0_yv_shift                                           (16)
+#define HDMI_WDCR0_awdck_shift                                        (15)
+#define HDMI_WDCR0_awdlf_shift                                        (14)
+#define HDMI_WDCR0_ch_st_sel_shift                                    (13)
+#define HDMI_WDCR0_vwdact_shift                                       (12)
+#define HDMI_WDCR0_xv_shift                                           (8)
+#define HDMI_WDCR0_asmfe_shift                                        (7)
+#define HDMI_WDCR0_load_d_shift                                       (6)
+#define HDMI_WDCR0_bt_track_en_shift                                  (5)
+#define HDMI_WDCR0_awdct_shift                                        (4)
+#define HDMI_WDCR0_awdap_shift                                        (3)
+#define HDMI_WDCR0_awdfo_shift                                        (2)
+#define HDMI_WDCR0_awdfu_shift                                        (1)
+#define HDMI_WDCR0_ct_shift                                           (0)
+#define HDMI_WDCR0_vwdap_mask                                         (0x00800000)
+#define HDMI_WDCR0_vwdlf_mask                                         (0x00400000)
+#define HDMI_WDCR0_vwdafo_mask                                        (0x00200000)
+#define HDMI_WDCR0_vwdafu_mask                                        (0x00100000)
+#define HDMI_WDCR0_yv_mask                                            (0x000F0000)
+#define HDMI_WDCR0_awdck_mask                                         (0x00008000)
+#define HDMI_WDCR0_awdlf_mask                                         (0x00004000)
+#define HDMI_WDCR0_ch_st_sel_mask                                     (0x00002000)
+#define HDMI_WDCR0_vwdact_mask                                        (0x00001000)
+#define HDMI_WDCR0_xv_mask                                            (0x00000F00)
+#define HDMI_WDCR0_asmfe_mask                                         (0x00000080)
+#define HDMI_WDCR0_load_d_mask                                        (0x00000040)
+#define HDMI_WDCR0_bt_track_en_mask                                   (0x00000020)
+#define HDMI_WDCR0_awdct_mask                                         (0x00000010)
+#define HDMI_WDCR0_awdap_mask                                         (0x00000008)
+#define HDMI_WDCR0_awdfo_mask                                         (0x00000004)
+#define HDMI_WDCR0_awdfu_mask                                         (0x00000002)
+#define HDMI_WDCR0_ct_mask                                            (0x00000001)
+#define HDMI_WDCR0_vwdap(data)                                        (0x00800000&((data)<<23))
+#define HDMI_WDCR0_vwdlf(data)                                        (0x00400000&((data)<<22))
+#define HDMI_WDCR0_vwdafo(data)                                       (0x00200000&((data)<<21))
+#define HDMI_WDCR0_vwdafu(data)                                       (0x00100000&((data)<<20))
+#define HDMI_WDCR0_yv(data)                                           (0x000F0000&((data)<<16))
+#define HDMI_WDCR0_awdck(data)                                        (0x00008000&((data)<<15))
+#define HDMI_WDCR0_awdlf(data)                                        (0x00004000&((data)<<14))
+#define HDMI_WDCR0_ch_st_sel(data)                                    (0x00002000&((data)<<13))
+#define HDMI_WDCR0_vwdact(data)                                       (0x00001000&((data)<<12))
+#define HDMI_WDCR0_xv(data)                                           (0x00000F00&((data)<<8))
+#define HDMI_WDCR0_asmfe(data)                                        (0x00000080&((data)<<7))
+#define HDMI_WDCR0_load_d(data)                                       (0x00000040&((data)<<6))
+#define HDMI_WDCR0_bt_track_en(data)                                  (0x00000020&((data)<<5))
+#define HDMI_WDCR0_awdct(data)                                        (0x00000010&((data)<<4))
+#define HDMI_WDCR0_awdap(data)                                        (0x00000008&((data)<<3))
+#define HDMI_WDCR0_awdfo(data)                                        (0x00000004&((data)<<2))
+#define HDMI_WDCR0_awdfu(data)                                        (0x00000002&((data)<<1))
+#define HDMI_WDCR0_ct(data)                                           (0x00000001&(data))
+#define HDMI_WDCR0_get_vwdap(data)                                    ((0x00800000&(data))>>23)
+#define HDMI_WDCR0_get_vwdlf(data)                                    ((0x00400000&(data))>>22)
+#define HDMI_WDCR0_get_vwdafo(data)                                   ((0x00200000&(data))>>21)
+#define HDMI_WDCR0_get_vwdafu(data)                                   ((0x00100000&(data))>>20)
+#define HDMI_WDCR0_get_yv(data)                                       ((0x000F0000&(data))>>16)
+#define HDMI_WDCR0_get_awdck(data)                                    ((0x00008000&(data))>>15)
+#define HDMI_WDCR0_get_awdlf(data)                                    ((0x00004000&(data))>>14)
+#define HDMI_WDCR0_get_ch_st_sel(data)                                ((0x00002000&(data))>>13)
+#define HDMI_WDCR0_get_vwdact(data)                                   ((0x00001000&(data))>>12)
+#define HDMI_WDCR0_get_xv(data)                                       ((0x00000F00&(data))>>8)
+#define HDMI_WDCR0_get_asmfe(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_WDCR0_get_load_d(data)                                   ((0x00000040&(data))>>6)
+#define HDMI_WDCR0_get_bt_track_en(data)                              ((0x00000020&(data))>>5)
+#define HDMI_WDCR0_get_awdct(data)                                    ((0x00000010&(data))>>4)
+#define HDMI_WDCR0_get_awdap(data)                                    ((0x00000008&(data))>>3)
+#define HDMI_WDCR0_get_awdfo(data)                                    ((0x00000004&(data))>>2)
+#define HDMI_WDCR0_get_awdfu(data)                                    ((0x00000002&(data))>>1)
+#define HDMI_WDCR0_get_ct(data)                                       (0x00000001&(data))
+
+
+#define HDMI_DBCR                                                     0x1800f0a0
+#define HDMI_DBCR_reg_addr                                            "0xb800f0a0"
+#define HDMI_DBCR_reg                                                 0xb800f0a0
+#define HDMI_DBCR_inst_addr                                           "0x0028"
+#define HDMI_DBCR_inst                                                0x0028
+#define HDMI_DBCR_aldbfv_shift                                        (3)
+#define HDMI_DBCR_aldbfo_shift                                        (2)
+#define HDMI_DBCR_aldbfu_shift                                        (1)
+#define HDMI_DBCR_aldbpn_shift                                        (0)
+#define HDMI_DBCR_aldbfv_mask                                         (0x00000008)
+#define HDMI_DBCR_aldbfo_mask                                         (0x00000004)
+#define HDMI_DBCR_aldbfu_mask                                         (0x00000002)
+#define HDMI_DBCR_aldbpn_mask                                         (0x00000001)
+#define HDMI_DBCR_aldbfv(data)                                        (0x00000008&((data)<<3))
+#define HDMI_DBCR_aldbfo(data)                                        (0x00000004&((data)<<2))
+#define HDMI_DBCR_aldbfu(data)                                        (0x00000002&((data)<<1))
+#define HDMI_DBCR_aldbpn(data)                                        (0x00000001&(data))
+#define HDMI_DBCR_get_aldbfv(data)                                    ((0x00000008&(data))>>3)
+#define HDMI_DBCR_get_aldbfo(data)                                    ((0x00000004&(data))>>2)
+#define HDMI_DBCR_get_aldbfu(data)                                    ((0x00000002&(data))>>1)
+#define HDMI_DBCR_get_aldbpn(data)                                    (0x00000001&(data))
+
+
+#define HDMI_AWDSR                                                    0x1800f0a4
+#define HDMI_AWDSR_reg_addr                                           "0xb800f0a4"
+#define HDMI_AWDSR_reg                                                0xb800f0a4
+#define HDMI_AWDSR_inst_addr                                          "0x0029"
+#define HDMI_AWDSR_inst                                               0x0029
+#define HDMI_AWDSR_awdpvsb_shift                                      (0)
+#define HDMI_AWDSR_awdpvsb_mask                                       (0x0000007F)
+#define HDMI_AWDSR_awdpvsb(data)                                      (0x0000007F&(data))
+#define HDMI_AWDSR_get_awdpvsb(data)                                  (0x0000007F&(data))
+
+
+#define HDMI_VWDSR                                                    0x1800f0a8
+#define HDMI_VWDSR_reg_addr                                           "0xb800f0a8"
+#define HDMI_VWDSR_reg                                                0xb800f0a8
+#define HDMI_VWDSR_inst_addr                                          "0x002A"
+#define HDMI_VWDSR_inst                                               0x002A
+#define HDMI_VWDSR_vwdpvsb_shift                                      (0)
+#define HDMI_VWDSR_vwdpvsb_mask                                       (0x0000007F)
+#define HDMI_VWDSR_vwdpvsb(data)                                      (0x0000007F&(data))
+#define HDMI_VWDSR_get_vwdpvsb(data)                                  (0x0000007F&(data))
+
+
+#define HDMI_PAMICR                                                   0x1800f0ac
+#define HDMI_PAMICR_reg_addr                                          "0xb800f0ac"
+#define HDMI_PAMICR_reg                                               0xb800f0ac
+#define HDMI_PAMICR_inst_addr                                         "0x002B"
+#define HDMI_PAMICR_inst                                              0x002B
+#define HDMI_PAMICR_icpvsb_shift                                      (0)
+#define HDMI_PAMICR_icpvsb_mask                                       (0x0000007F)
+#define HDMI_PAMICR_icpvsb(data)                                      (0x0000007F&(data))
+#define HDMI_PAMICR_get_icpvsb(data)                                  (0x0000007F&(data))
+
+
+#define HDMI_PTRSV1                                                   0x1800f0b0
+#define HDMI_PTRSV1_reg_addr                                          "0xb800f0b0"
+#define HDMI_PTRSV1_reg                                               0xb800f0b0
+#define HDMI_PTRSV1_inst_addr                                         "0x002C"
+#define HDMI_PTRSV1_inst                                              0x002C
+#define HDMI_PTRSV1_pt4_shift                                         (24)
+#define HDMI_PTRSV1_pt3_shift                                         (16)
+#define HDMI_PTRSV1_pt2_shift                                         (8)
+#define HDMI_PTRSV1_pt1_shift                                         (0)
+#define HDMI_PTRSV1_pt4_mask                                          (0xFF000000)
+#define HDMI_PTRSV1_pt3_mask                                          (0x00FF0000)
+#define HDMI_PTRSV1_pt2_mask                                          (0x0000FF00)
+#define HDMI_PTRSV1_pt1_mask                                          (0x000000FF)
+#define HDMI_PTRSV1_pt4(data)                                         (0xFF000000&((data)<<24))
+#define HDMI_PTRSV1_pt3(data)                                         (0x00FF0000&((data)<<16))
+#define HDMI_PTRSV1_pt2(data)                                         (0x0000FF00&((data)<<8))
+#define HDMI_PTRSV1_pt1(data)                                         (0x000000FF&(data))
+#define HDMI_PTRSV1_get_pt4(data)                                     ((0xFF000000&(data))>>24)
+#define HDMI_PTRSV1_get_pt3(data)                                     ((0x00FF0000&(data))>>16)
+#define HDMI_PTRSV1_get_pt2(data)                                     ((0x0000FF00&(data))>>8)
+#define HDMI_PTRSV1_get_pt1(data)                                     (0x000000FF&(data))
+
+
+#define HDMI_PVGCR0                                                   0x1800f0b4
+#define HDMI_PVGCR0_reg_addr                                          "0xb800f0b4"
+#define HDMI_PVGCR0_reg                                               0xb800f0b4
+#define HDMI_PVGCR0_inst_addr                                         "0x002D"
+#define HDMI_PVGCR0_inst                                              0x002D
+#define HDMI_PVGCR0_pvsef_shift                                       (0)
+#define HDMI_PVGCR0_pvsef_mask                                        (0xFFFFFFFF)
+#define HDMI_PVGCR0_pvsef(data)                                       (0xFFFFFFFF&(data))
+#define HDMI_PVGCR0_get_pvsef(data)                                   (0xFFFFFFFF&(data))
+
+
+#define HDMI_PVSR0                                                    0x1800f0b8
+#define HDMI_PVSR0_reg_addr                                           "0xb800f0b8"
+#define HDMI_PVSR0_reg                                                0xb800f0b8
+#define HDMI_PVSR0_inst_addr                                          "0x002E"
+#define HDMI_PVSR0_inst                                               0x002E
+#define HDMI_PVSR0_pvs_shift                                          (0)
+#define HDMI_PVSR0_pvs_mask                                           (0xFFFFFFFF)
+#define HDMI_PVSR0_pvs(data)                                          (0xFFFFFFFF&(data))
+#define HDMI_PVSR0_get_pvs(data)                                      (0xFFFFFFFF&(data))
+
+
+#define HDMI_VCR                                                      0x1800f0bc
+#define HDMI_VCR_reg_addr                                             "0xb800f0bc"
+#define HDMI_VCR_reg                                                  0xb800f0bc
+#define HDMI_VCR_inst_addr                                            "0x002F"
+#define HDMI_VCR_inst                                                 0x002F
+#define HDMI_VCR_cbus_ddc_chsel_shift                                 (28)
+#define HDMI_VCR_hdmi_field_shift                                     (27)
+#define HDMI_VCR_int_pro_chg_flag_shift                               (26)
+#define HDMI_VCR_int_pro_chg_wd_en_shift                              (25)
+#define HDMI_VCR_int_pro_chg_int_en_shift                             (24)
+#define HDMI_VCR_hdcp_ddc_chsel_shift                                 (22)
+#define HDMI_VCR_iclk_sel_shift                                       (20)
+#define HDMI_VCR_csc_r_shift                                          (18)
+#define HDMI_VCR_hdirq_shift                                          (17)
+#define HDMI_VCR_csam_shift                                           (16)
+#define HDMI_VCR_csc_shift                                            (14)
+#define HDMI_VCR_field_decide_sel_shift                               (13)
+#define HDMI_VCR_prdsam_shift                                         (12)
+#define HDMI_VCR_dsc_r_shift                                          (8)
+#define HDMI_VCR_eoi_shift                                            (7)
+#define HDMI_VCR_eot_shift                                            (6)
+#define HDMI_VCR_se_shift                                             (5)
+#define HDMI_VCR_rs_shift                                             (4)
+#define HDMI_VCR_dsc_shift                                            (0)
+#define HDMI_VCR_cbus_ddc_chsel_mask                                  (0x10000000)
+#define HDMI_VCR_hdmi_field_mask                                      (0x08000000)
+#define HDMI_VCR_int_pro_chg_flag_mask                                (0x04000000)
+#define HDMI_VCR_int_pro_chg_wd_en_mask                               (0x02000000)
+#define HDMI_VCR_int_pro_chg_int_en_mask                              (0x01000000)
+#define HDMI_VCR_hdcp_ddc_chsel_mask                                  (0x00C00000)
+#define HDMI_VCR_iclk_sel_mask                                        (0x00300000)
+#define HDMI_VCR_csc_r_mask                                           (0x000C0000)
+#define HDMI_VCR_hdirq_mask                                           (0x00020000)
+#define HDMI_VCR_csam_mask                                            (0x00010000)
+#define HDMI_VCR_csc_mask                                             (0x0000C000)
+#define HDMI_VCR_field_decide_sel_mask                                (0x00002000)
+#define HDMI_VCR_prdsam_mask                                          (0x00001000)
+#define HDMI_VCR_dsc_r_mask                                           (0x00000F00)
+#define HDMI_VCR_eoi_mask                                             (0x00000080)
+#define HDMI_VCR_eot_mask                                             (0x00000040)
+#define HDMI_VCR_se_mask                                              (0x00000020)
+#define HDMI_VCR_rs_mask                                              (0x00000010)
+#define HDMI_VCR_dsc_mask                                             (0x0000000F)
+#define HDMI_VCR_cbus_ddc_chsel(data)                                 (0x10000000&((data)<<28))
+#define HDMI_VCR_hdmi_field(data)                                     (0x08000000&((data)<<27))
+#define HDMI_VCR_int_pro_chg_flag(data)                               (0x04000000&((data)<<26))
+#define HDMI_VCR_int_pro_chg_wd_en(data)                              (0x02000000&((data)<<25))
+#define HDMI_VCR_int_pro_chg_int_en(data)                             (0x01000000&((data)<<24))
+#define HDMI_VCR_hdcp_ddc_chsel(data)                                 (0x00C00000&((data)<<22))
+#define HDMI_VCR_iclk_sel(data)                                       (0x00300000&((data)<<20))
+#define HDMI_VCR_csc_r(data)                                          (0x000C0000&((data)<<18))
+#define HDMI_VCR_hdirq(data)                                          (0x00020000&((data)<<17))
+#define HDMI_VCR_csam(data)                                           (0x00010000&((data)<<16))
+#define HDMI_VCR_csc(data)                                            (0x0000C000&((data)<<14))
+#define HDMI_VCR_field_decide_sel(data)                               (0x00002000&((data)<<13))
+#define HDMI_VCR_prdsam(data)                                         (0x00001000&((data)<<12))
+#define HDMI_VCR_dsc_r(data)                                          (0x00000F00&((data)<<8))
+#define HDMI_VCR_eoi(data)                                            (0x00000080&((data)<<7))
+#define HDMI_VCR_eot(data)                                            (0x00000040&((data)<<6))
+#define HDMI_VCR_se(data)                                             (0x00000020&((data)<<5))
+#define HDMI_VCR_rs(data)                                             (0x00000010&((data)<<4))
+#define HDMI_VCR_dsc(data)                                            (0x0000000F&(data))
+#define HDMI_VCR_get_cbus_ddc_chsel(data)                             ((0x10000000&(data))>>28)
+#define HDMI_VCR_get_hdmi_field(data)                                 ((0x08000000&(data))>>27)
+#define HDMI_VCR_get_int_pro_chg_flag(data)                           ((0x04000000&(data))>>26)
+#define HDMI_VCR_get_int_pro_chg_wd_en(data)                          ((0x02000000&(data))>>25)
+#define HDMI_VCR_get_int_pro_chg_int_en(data)                         ((0x01000000&(data))>>24)
+#define HDMI_VCR_get_hdcp_ddc_chsel(data)                             ((0x00C00000&(data))>>22)
+#define HDMI_VCR_get_iclk_sel(data)                                   ((0x00300000&(data))>>20)
+#define HDMI_VCR_get_csc_r(data)                                      ((0x000C0000&(data))>>18)
+#define HDMI_VCR_get_hdirq(data)                                      ((0x00020000&(data))>>17)
+#define HDMI_VCR_get_csam(data)                                       ((0x00010000&(data))>>16)
+#define HDMI_VCR_get_csc(data)                                        ((0x0000C000&(data))>>14)
+#define HDMI_VCR_get_field_decide_sel(data)                           ((0x00002000&(data))>>13)
+#define HDMI_VCR_get_prdsam(data)                                     ((0x00001000&(data))>>12)
+#define HDMI_VCR_get_dsc_r(data)                                      ((0x00000F00&(data))>>8)
+#define HDMI_VCR_get_eoi(data)                                        ((0x00000080&(data))>>7)
+#define HDMI_VCR_get_eot(data)                                        ((0x00000040&(data))>>6)
+#define HDMI_VCR_get_se(data)                                         ((0x00000020&(data))>>5)
+#define HDMI_VCR_get_rs(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_VCR_get_dsc(data)                                        (0x0000000F&(data))
+
+
+#define HDMI_ACRCR                                                    0x1800f0c0
+#define HDMI_ACRCR_reg_addr                                           "0xb800f0c0"
+#define HDMI_ACRCR_reg                                                0xb800f0c0
+#define HDMI_ACRCR_inst_addr                                          "0x0030"
+#define HDMI_ACRCR_inst                                               0x0030
+#define HDMI_ACRCR_pucnr_shift                                        (1)
+#define HDMI_ACRCR_pucsr_shift                                        (0)
+#define HDMI_ACRCR_pucnr_mask                                         (0x00000002)
+#define HDMI_ACRCR_pucsr_mask                                         (0x00000001)
+#define HDMI_ACRCR_pucnr(data)                                        (0x00000002&((data)<<1))
+#define HDMI_ACRCR_pucsr(data)                                        (0x00000001&(data))
+#define HDMI_ACRCR_get_pucnr(data)                                    ((0x00000002&(data))>>1)
+#define HDMI_ACRCR_get_pucsr(data)                                    (0x00000001&(data))
+
+
+#define HDMI_ACRSR0                                                   0x1800f0c4
+#define HDMI_ACRSR0_reg_addr                                          "0xb800f0c4"
+#define HDMI_ACRSR0_reg                                               0xb800f0c4
+#define HDMI_ACRSR0_inst_addr                                         "0x0031"
+#define HDMI_ACRSR0_inst                                              0x0031
+#define HDMI_ACRSR0_cts_shift                                         (0)
+#define HDMI_ACRSR0_cts_mask                                          (0x000FFFFF)
+#define HDMI_ACRSR0_cts(data)                                         (0x000FFFFF&(data))
+#define HDMI_ACRSR0_get_cts(data)                                     (0x000FFFFF&(data))
+
+
+#define HDMI_ACRSR1                                                   0x1800f0c8
+#define HDMI_ACRSR1_reg_addr                                          "0xb800f0c8"
+#define HDMI_ACRSR1_reg                                               0xb800f0c8
+#define HDMI_ACRSR1_inst_addr                                         "0x0032"
+#define HDMI_ACRSR1_inst                                              0x0032
+#define HDMI_ACRSR1_n_shift                                           (0)
+#define HDMI_ACRSR1_n_mask                                            (0x000FFFFF)
+#define HDMI_ACRSR1_n(data)                                           (0x000FFFFF&(data))
+#define HDMI_ACRSR1_get_n(data)                                       (0x000FFFFF&(data))
+
+
+#define HDMI_ACS0                                                     0x1800f0cc
+#define HDMI_ACS0_reg_addr                                            "0xb800f0cc"
+#define HDMI_ACS0_reg                                                 0xb800f0cc
+#define HDMI_ACS0_inst_addr                                           "0x0033"
+#define HDMI_ACS0_inst                                                0x0033
+#define HDMI_ACS0_cs_shift                                            (0)
+#define HDMI_ACS0_cs_mask                                             (0x0000FFFF)
+#define HDMI_ACS0_cs(data)                                            (0x0000FFFF&(data))
+#define HDMI_ACS0_get_cs(data)                                        (0x0000FFFF&(data))
+
+
+#define HDMI_ACS1                                                     0x1800f0d0
+#define HDMI_ACS1_reg_addr                                            "0xb800f0d0"
+#define HDMI_ACS1_reg                                                 0xb800f0d0
+#define HDMI_ACS1_inst_addr                                           "0x0034"
+#define HDMI_ACS1_inst                                                0x0034
+#define HDMI_ACS1_cs_shift                                            (0)
+#define HDMI_ACS1_cs_mask                                             (0x00FFFFFF)
+#define HDMI_ACS1_cs(data)                                            (0x00FFFFFF&(data))
+#define HDMI_ACS1_get_cs(data)                                        (0x00FFFFFF&(data))
+
+
+#define HDMI_INTCR                                                    0x1800f0d4
+#define HDMI_INTCR_reg_addr                                           "0xb800f0d4"
+#define HDMI_INTCR_reg                                                0xb800f0d4
+#define HDMI_INTCR_inst_addr                                          "0x0035"
+#define HDMI_INTCR_inst                                               0x0035
+#define HDMI_INTCR_pending_shift                                      (7)
+#define HDMI_INTCR_avmute_shift                                       (6)
+#define HDMI_INTCR_fifod_shift                                        (5)
+#define HDMI_INTCR_act_shift                                          (4)
+#define HDMI_INTCR_apll_shift                                         (3)
+#define HDMI_INTCR_afifoo_shift                                       (2)
+#define HDMI_INTCR_afifou_shift                                       (1)
+#define HDMI_INTCR_vc_shift                                           (0)
+#define HDMI_INTCR_pending_mask                                       (0x00000080)
+#define HDMI_INTCR_avmute_mask                                        (0x00000040)
+#define HDMI_INTCR_fifod_mask                                         (0x00000020)
+#define HDMI_INTCR_act_mask                                           (0x00000010)
+#define HDMI_INTCR_apll_mask                                          (0x00000008)
+#define HDMI_INTCR_afifoo_mask                                        (0x00000004)
+#define HDMI_INTCR_afifou_mask                                        (0x00000002)
+#define HDMI_INTCR_vc_mask                                            (0x00000001)
+#define HDMI_INTCR_pending(data)                                      (0x00000080&((data)<<7))
+#define HDMI_INTCR_avmute(data)                                       (0x00000040&((data)<<6))
+#define HDMI_INTCR_fifod(data)                                        (0x00000020&((data)<<5))
+#define HDMI_INTCR_act(data)                                          (0x00000010&((data)<<4))
+#define HDMI_INTCR_apll(data)                                         (0x00000008&((data)<<3))
+#define HDMI_INTCR_afifoo(data)                                       (0x00000004&((data)<<2))
+#define HDMI_INTCR_afifou(data)                                       (0x00000002&((data)<<1))
+#define HDMI_INTCR_vc(data)                                           (0x00000001&(data))
+#define HDMI_INTCR_get_pending(data)                                  ((0x00000080&(data))>>7)
+#define HDMI_INTCR_get_avmute(data)                                   ((0x00000040&(data))>>6)
+#define HDMI_INTCR_get_fifod(data)                                    ((0x00000020&(data))>>5)
+#define HDMI_INTCR_get_act(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_INTCR_get_apll(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_INTCR_get_afifoo(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_INTCR_get_afifou(data)                                   ((0x00000002&(data))>>1)
+#define HDMI_INTCR_get_vc(data)                                       (0x00000001&(data))
+
+
+#define HDMI_ALCR                                                     0x1800f0d8
+#define HDMI_ALCR_reg_addr                                            "0xb800f0d8"
+#define HDMI_ALCR_reg                                                 0xb800f0d8
+#define HDMI_ALCR_inst_addr                                           "0x0036"
+#define HDMI_ALCR_inst                                                0x0036
+#define HDMI_ALCR_lo1_shift                                           (6)
+#define HDMI_ALCR_lo2_shift                                           (4)
+#define HDMI_ALCR_lo3_shift                                           (2)
+#define HDMI_ALCR_lo4_shift                                           (0)
+#define HDMI_ALCR_lo1_mask                                            (0x000000C0)
+#define HDMI_ALCR_lo2_mask                                            (0x00000030)
+#define HDMI_ALCR_lo3_mask                                            (0x0000000C)
+#define HDMI_ALCR_lo4_mask                                            (0x00000003)
+#define HDMI_ALCR_lo1(data)                                           (0x000000C0&((data)<<6))
+#define HDMI_ALCR_lo2(data)                                           (0x00000030&((data)<<4))
+#define HDMI_ALCR_lo3(data)                                           (0x0000000C&((data)<<2))
+#define HDMI_ALCR_lo4(data)                                           (0x00000003&(data))
+#define HDMI_ALCR_get_lo1(data)                                       ((0x000000C0&(data))>>6)
+#define HDMI_ALCR_get_lo2(data)                                       ((0x00000030&(data))>>4)
+#define HDMI_ALCR_get_lo3(data)                                       ((0x0000000C&(data))>>2)
+#define HDMI_ALCR_get_lo4(data)                                       (0x00000003&(data))
+
+
+#define HDMI_AOCR                                                     0x1800f0dc
+#define HDMI_AOCR_reg_addr                                            "0xb800f0dc"
+#define HDMI_AOCR_reg                                                 0xb800f0dc
+#define HDMI_AOCR_inst_addr                                           "0x0037"
+#define HDMI_AOCR_inst                                                0x0037
+#define HDMI_AOCR_i2s_clk_en_dvi_shift                                (8)
+#define HDMI_AOCR_spdifo1_shift                                       (7)
+#define HDMI_AOCR_spdifo2_shift                                       (6)
+#define HDMI_AOCR_spdifo3_shift                                       (5)
+#define HDMI_AOCR_spdifo4_shift                                       (4)
+#define HDMI_AOCR_i2so1_shift                                         (3)
+#define HDMI_AOCR_i2so2_shift                                         (2)
+#define HDMI_AOCR_i2so3_shift                                         (1)
+#define HDMI_AOCR_i2so4_shift                                         (0)
+#define HDMI_AOCR_i2s_clk_en_dvi_mask                                 (0x00000100)
+#define HDMI_AOCR_spdifo1_mask                                        (0x00000080)
+#define HDMI_AOCR_spdifo2_mask                                        (0x00000040)
+#define HDMI_AOCR_spdifo3_mask                                        (0x00000020)
+#define HDMI_AOCR_spdifo4_mask                                        (0x00000010)
+#define HDMI_AOCR_i2so1_mask                                          (0x00000008)
+#define HDMI_AOCR_i2so2_mask                                          (0x00000004)
+#define HDMI_AOCR_i2so3_mask                                          (0x00000002)
+#define HDMI_AOCR_i2so4_mask                                          (0x00000001)
+#define HDMI_AOCR_i2s_clk_en_dvi(data)                                (0x00000100&((data)<<8))
+#define HDMI_AOCR_spdifo1(data)                                       (0x00000080&((data)<<7))
+#define HDMI_AOCR_spdifo2(data)                                       (0x00000040&((data)<<6))
+#define HDMI_AOCR_spdifo3(data)                                       (0x00000020&((data)<<5))
+#define HDMI_AOCR_spdifo4(data)                                       (0x00000010&((data)<<4))
+#define HDMI_AOCR_i2so1(data)                                         (0x00000008&((data)<<3))
+#define HDMI_AOCR_i2so2(data)                                         (0x00000004&((data)<<2))
+#define HDMI_AOCR_i2so3(data)                                         (0x00000002&((data)<<1))
+#define HDMI_AOCR_i2so4(data)                                         (0x00000001&(data))
+#define HDMI_AOCR_get_i2s_clk_en_dvi(data)                            ((0x00000100&(data))>>8)
+#define HDMI_AOCR_get_spdifo1(data)                                   ((0x00000080&(data))>>7)
+#define HDMI_AOCR_get_spdifo2(data)                                   ((0x00000040&(data))>>6)
+#define HDMI_AOCR_get_spdifo3(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_AOCR_get_spdifo4(data)                                   ((0x00000010&(data))>>4)
+#define HDMI_AOCR_get_i2so1(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_AOCR_get_i2so2(data)                                     ((0x00000004&(data))>>2)
+#define HDMI_AOCR_get_i2so3(data)                                     ((0x00000002&(data))>>1)
+#define HDMI_AOCR_get_i2so4(data)                                     (0x00000001&(data))
+
+
+#define HDMI_BCSR                                                     0x1800f0e0
+#define HDMI_BCSR_reg_addr                                            "0xb800f0e0"
+#define HDMI_BCSR_reg                                                 0xb800f0e0
+#define HDMI_BCSR_inst_addr                                           "0x0038"
+#define HDMI_BCSR_inst                                                0x0038
+#define HDMI_BCSR_nvlgb_shift                                         (5)
+#define HDMI_BCSR_nalgb_shift                                         (4)
+#define HDMI_BCSR_natgb_shift                                         (3)
+#define HDMI_BCSR_ngb_shift                                           (2)
+#define HDMI_BCSR_pe_shift                                            (1)
+#define HDMI_BCSR_gcp_shift                                           (0)
+#define HDMI_BCSR_nvlgb_mask                                          (0x00000020)
+#define HDMI_BCSR_nalgb_mask                                          (0x00000010)
+#define HDMI_BCSR_natgb_mask                                          (0x00000008)
+#define HDMI_BCSR_ngb_mask                                            (0x00000004)
+#define HDMI_BCSR_pe_mask                                             (0x00000002)
+#define HDMI_BCSR_gcp_mask                                            (0x00000001)
+#define HDMI_BCSR_nvlgb(data)                                         (0x00000020&((data)<<5))
+#define HDMI_BCSR_nalgb(data)                                         (0x00000010&((data)<<4))
+#define HDMI_BCSR_natgb(data)                                         (0x00000008&((data)<<3))
+#define HDMI_BCSR_ngb(data)                                           (0x00000004&((data)<<2))
+#define HDMI_BCSR_pe(data)                                            (0x00000002&((data)<<1))
+#define HDMI_BCSR_gcp(data)                                           (0x00000001&(data))
+#define HDMI_BCSR_get_nvlgb(data)                                     ((0x00000020&(data))>>5)
+#define HDMI_BCSR_get_nalgb(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_BCSR_get_natgb(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_BCSR_get_ngb(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_BCSR_get_pe(data)                                        ((0x00000002&(data))>>1)
+#define HDMI_BCSR_get_gcp(data)                                       (0x00000001&(data))
+
+
+#define HDMI_ASR0                                                     0x1800f0e4
+#define HDMI_ASR0_reg_addr                                            "0xb800f0e4"
+#define HDMI_ASR0_reg                                                 0xb800f0e4
+#define HDMI_ASR0_inst_addr                                           "0x0039"
+#define HDMI_ASR0_inst                                                0x0039
+#define HDMI_ASR0_fsre_shift                                          (2)
+#define HDMI_ASR0_fsif_shift                                          (1)
+#define HDMI_ASR0_fscs_shift                                          (0)
+#define HDMI_ASR0_fsre_mask                                           (0x00000004)
+#define HDMI_ASR0_fsif_mask                                           (0x00000002)
+#define HDMI_ASR0_fscs_mask                                           (0x00000001)
+#define HDMI_ASR0_fsre(data)                                          (0x00000004&((data)<<2))
+#define HDMI_ASR0_fsif(data)                                          (0x00000002&((data)<<1))
+#define HDMI_ASR0_fscs(data)                                          (0x00000001&(data))
+#define HDMI_ASR0_get_fsre(data)                                      ((0x00000004&(data))>>2)
+#define HDMI_ASR0_get_fsif(data)                                      ((0x00000002&(data))>>1)
+#define HDMI_ASR0_get_fscs(data)                                      (0x00000001&(data))
+
+
+#define HDMI_ASR1                                                     0x1800f0e8
+#define HDMI_ASR1_reg_addr                                            "0xb800f0e8"
+#define HDMI_ASR1_reg                                                 0xb800f0e8
+#define HDMI_ASR1_inst_addr                                           "0x003A"
+#define HDMI_ASR1_inst                                                0x003A
+#define HDMI_ASR1_fbif_shift                                          (4)
+#define HDMI_ASR1_fbcs_shift                                          (0)
+#define HDMI_ASR1_fbif_mask                                           (0x00000070)
+#define HDMI_ASR1_fbcs_mask                                           (0x0000000F)
+#define HDMI_ASR1_fbif(data)                                          (0x00000070&((data)<<4))
+#define HDMI_ASR1_fbcs(data)                                          (0x0000000F&(data))
+#define HDMI_ASR1_get_fbif(data)                                      ((0x00000070&(data))>>4)
+#define HDMI_ASR1_get_fbcs(data)                                      (0x0000000F&(data))
+
+
+#define HDMI_VIDEO_FORMAT                                             0x1800f0ec
+#define HDMI_VIDEO_FORMAT_reg_addr                                    "0xb800f0ec"
+#define HDMI_VIDEO_FORMAT_reg                                         0xb800f0ec
+#define HDMI_VIDEO_FORMAT_inst_addr                                   "0x003B"
+#define HDMI_VIDEO_FORMAT_inst                                        0x003B
+#define HDMI_VIDEO_FORMAT_hvf_shift                                   (8)
+#define HDMI_VIDEO_FORMAT_hdmi_vic_shift                              (0)
+#define HDMI_VIDEO_FORMAT_hvf_mask                                    (0x00000700)
+#define HDMI_VIDEO_FORMAT_hdmi_vic_mask                               (0x000000FF)
+#define HDMI_VIDEO_FORMAT_hvf(data)                                   (0x00000700&((data)<<8))
+#define HDMI_VIDEO_FORMAT_hdmi_vic(data)                              (0x000000FF&(data))
+#define HDMI_VIDEO_FORMAT_get_hvf(data)                               ((0x00000700&(data))>>8)
+#define HDMI_VIDEO_FORMAT_get_hdmi_vic(data)                          (0x000000FF&(data))
+
+
+#define HDMI_3D_FORMAT                                                0x1800f0f0
+#define HDMI_3D_FORMAT_reg_addr                                       "0xb800f0f0"
+#define HDMI_3D_FORMAT_reg                                            0xb800f0f0
+#define HDMI_3D_FORMAT_inst_addr                                      "0x003C"
+#define HDMI_3D_FORMAT_inst                                           0x003C
+#define HDMI_3D_FORMAT_hdmi_3d_ext_data_shift                         (12)
+#define HDMI_3D_FORMAT_hdmi_3d_metadata_type_shift                    (9)
+#define HDMI_3D_FORMAT_hdmi_3d_structure_shift                        (4)
+#define HDMI_3D_FORMAT_hdmi_3d_meta_present_shift                     (3)
+#define HDMI_3D_FORMAT_hdmi_3d_ext_data_mask                          (0x0000F000)
+#define HDMI_3D_FORMAT_hdmi_3d_metadata_type_mask                     (0x00000E00)
+#define HDMI_3D_FORMAT_hdmi_3d_structure_mask                         (0x000000F0)
+#define HDMI_3D_FORMAT_hdmi_3d_meta_present_mask                      (0x00000008)
+#define HDMI_3D_FORMAT_hdmi_3d_ext_data(data)                         (0x0000F000&((data)<<12))
+#define HDMI_3D_FORMAT_hdmi_3d_metadata_type(data)                    (0x00000E00&((data)<<9))
+#define HDMI_3D_FORMAT_hdmi_3d_structure(data)                        (0x000000F0&((data)<<4))
+#define HDMI_3D_FORMAT_hdmi_3d_meta_present(data)                     (0x00000008&((data)<<3))
+#define HDMI_3D_FORMAT_get_hdmi_3d_ext_data(data)                     ((0x0000F000&(data))>>12)
+#define HDMI_3D_FORMAT_get_hdmi_3d_metadata_type(data)                ((0x00000E00&(data))>>9)
+#define HDMI_3D_FORMAT_get_hdmi_3d_structure(data)                    ((0x000000F0&(data))>>4)
+#define HDMI_3D_FORMAT_get_hdmi_3d_meta_present(data)                 ((0x00000008&(data))>>3)
+
+
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ                                  0x1800f100
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_reg_addr                         "0xb800f100"
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_reg                              0xb800f100
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_inst_addr                        "0x0040"
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_inst                             0x0040
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ncts_chg_irq_shift            (3)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ncts_chg_irq_shift               (2)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ch_status_chg_irq_shift       (1)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ch_status_chg_irq_shift          (0)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ncts_chg_irq_mask             (0x00000008)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ncts_chg_irq_mask                (0x00000004)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ch_status_chg_irq_mask        (0x00000002)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ch_status_chg_irq_mask           (0x00000001)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ncts_chg_irq(data)            (0x00000008&((data)<<3))
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ncts_chg_irq(data)               (0x00000004&((data)<<2))
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_en_ch_status_chg_irq(data)       (0x00000002&((data)<<1))
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_ch_status_chg_irq(data)          (0x00000001&(data))
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_en_ncts_chg_irq(data)        ((0x00000008&(data))>>3)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_ncts_chg_irq(data)           ((0x00000004&(data))>>2)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_en_ch_status_chg_irq(data)   ((0x00000002&(data))>>1)
+#define AUDIO_SAMPLE_RATE_CHANGE_IRQ_get_ch_status_chg_irq(data)      (0x00000001&(data))
+
+
+#define HIGH_BIT_RATE_AUDIO_PACKET                                    0x1800f104
+#define HIGH_BIT_RATE_AUDIO_PACKET_reg_addr                           "0xb800f104"
+#define HIGH_BIT_RATE_AUDIO_PACKET_reg                                0xb800f104
+#define HIGH_BIT_RATE_AUDIO_PACKET_inst_addr                          "0x0041"
+#define HIGH_BIT_RATE_AUDIO_PACKET_inst                               0x0041
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual_shift        (2)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw_shift            (1)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_shift               (0)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual_mask         (0x00000004)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw_mask             (0x00000002)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_mask                (0x00000001)
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_manual(data)        (0x00000004&((data)<<2))
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode_fw(data)            (0x00000002&((data)<<1))
+#define HIGH_BIT_RATE_AUDIO_PACKET_hbr_audio_mode(data)               (0x00000001&(data))
+#define HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode_manual(data)    ((0x00000004&(data))>>2)
+#define HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode_fw(data)        ((0x00000002&(data))>>1)
+#define HIGH_BIT_RATE_AUDIO_PACKET_get_hbr_audio_mode(data)           (0x00000001&(data))
+
+
+#define HDMI_AFCR                                                     0x1800f108
+#define HDMI_AFCR_reg_addr                                            "0xb800f108"
+#define HDMI_AFCR_reg                                                 0xb800f108
+#define HDMI_AFCR_inst_addr                                           "0x0042"
+#define HDMI_AFCR_inst                                                0x0042
+#define HDMI_AFCR_dummy1800f108_31_14_shift                           (14)
+#define HDMI_AFCR_gain_bypass_en_shift                                (13)
+#define HDMI_AFCR_afifof_shift                                        (12)
+#define HDMI_AFCR_afifoe_shift                                        (11)
+#define HDMI_AFCR_afifowe_r_shift                                     (10)
+#define HDMI_AFCR_afifore_r_shift                                     (8)
+#define HDMI_AFCR_tst_i2s_sw_shift                                    (7)
+#define HDMI_AFCR_aoem_shift                                          (6)
+#define HDMI_AFCR_aoc_shift                                           (5)
+#define HDMI_AFCR_audio_test_enable_shift                             (4)
+#define HDMI_AFCR_mgc_shift                                           (3)
+#define HDMI_AFCR_afifowe_shift                                       (2)
+#define HDMI_AFCR_afifore_shift                                       (0)
+#define HDMI_AFCR_dummy1800f108_31_14_mask                            (0xFFFFC000)
+#define HDMI_AFCR_gain_bypass_en_mask                                 (0x00002000)
+#define HDMI_AFCR_afifof_mask                                         (0x00001000)
+#define HDMI_AFCR_afifoe_mask                                         (0x00000800)
+#define HDMI_AFCR_afifowe_r_mask                                      (0x00000400)
+#define HDMI_AFCR_afifore_r_mask                                      (0x00000300)
+#define HDMI_AFCR_tst_i2s_sw_mask                                     (0x00000080)
+#define HDMI_AFCR_aoem_mask                                           (0x00000040)
+#define HDMI_AFCR_aoc_mask                                            (0x00000020)
+#define HDMI_AFCR_audio_test_enable_mask                              (0x00000010)
+#define HDMI_AFCR_mgc_mask                                            (0x00000008)
+#define HDMI_AFCR_afifowe_mask                                        (0x00000004)
+#define HDMI_AFCR_afifore_mask                                        (0x00000003)
+#define HDMI_AFCR_dummy1800f108_31_14(data)                           (0xFFFFC000&((data)<<14))
+#define HDMI_AFCR_gain_bypass_en(data)                                (0x00002000&((data)<<13))
+#define HDMI_AFCR_afifof(data)                                        (0x00001000&((data)<<12))
+#define HDMI_AFCR_afifoe(data)                                        (0x00000800&((data)<<11))
+#define HDMI_AFCR_afifowe_r(data)                                     (0x00000400&((data)<<10))
+#define HDMI_AFCR_afifore_r(data)                                     (0x00000300&((data)<<8))
+#define HDMI_AFCR_tst_i2s_sw(data)                                    (0x00000080&((data)<<7))
+#define HDMI_AFCR_aoem(data)                                          (0x00000040&((data)<<6))
+#define HDMI_AFCR_aoc(data)                                           (0x00000020&((data)<<5))
+#define HDMI_AFCR_audio_test_enable(data)                             (0x00000010&((data)<<4))
+#define HDMI_AFCR_mgc(data)                                           (0x00000008&((data)<<3))
+#define HDMI_AFCR_afifowe(data)                                       (0x00000004&((data)<<2))
+#define HDMI_AFCR_afifore(data)                                       (0x00000003&(data))
+#define HDMI_AFCR_get_dummy1800f108_31_14(data)                       ((0xFFFFC000&(data))>>14)
+#define HDMI_AFCR_get_gain_bypass_en(data)                            ((0x00002000&(data))>>13)
+#define HDMI_AFCR_get_afifof(data)                                    ((0x00001000&(data))>>12)
+#define HDMI_AFCR_get_afifoe(data)                                    ((0x00000800&(data))>>11)
+#define HDMI_AFCR_get_afifowe_r(data)                                 ((0x00000400&(data))>>10)
+#define HDMI_AFCR_get_afifore_r(data)                                 ((0x00000300&(data))>>8)
+#define HDMI_AFCR_get_tst_i2s_sw(data)                                ((0x00000080&(data))>>7)
+#define HDMI_AFCR_get_aoem(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_AFCR_get_aoc(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_AFCR_get_audio_test_enable(data)                         ((0x00000010&(data))>>4)
+#define HDMI_AFCR_get_mgc(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_AFCR_get_afifowe(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_AFCR_get_afifore(data)                                   (0x00000003&(data))
+
+
+#define HDMI_AFSR                                                     0x1800f10c
+#define HDMI_AFSR_reg_addr                                            "0xb800f10c"
+#define HDMI_AFSR_reg                                                 0xb800f10c
+#define HDMI_AFSR_inst_addr                                           "0x0043"
+#define HDMI_AFSR_inst                                                0x0043
+#define HDMI_AFSR_audio_bist_clksel_shift                             (0)
+#define HDMI_AFSR_audio_bist_clksel_mask                              (0x00000001)
+#define HDMI_AFSR_audio_bist_clksel(data)                             (0x00000001&(data))
+#define HDMI_AFSR_get_audio_bist_clksel(data)                         (0x00000001&(data))
+
+
+#define HDMI_MAGCR0                                                   0x1800f110
+#define HDMI_MAGCR0_reg_addr                                          "0xb800f110"
+#define HDMI_MAGCR0_reg                                               0xb800f110
+#define HDMI_MAGCR0_inst_addr                                         "0x0044"
+#define HDMI_MAGCR0_inst                                              0x0044
+#define HDMI_MAGCR0_agi_shift                                         (13)
+#define HDMI_MAGCR0_agd_shift                                         (8)
+#define HDMI_MAGCR0_mg_shift                                          (0)
+#define HDMI_MAGCR0_agi_mask                                          (0x0000E000)
+#define HDMI_MAGCR0_agd_mask                                          (0x00001F00)
+#define HDMI_MAGCR0_mg_mask                                           (0x000000FF)
+#define HDMI_MAGCR0_agi(data)                                         (0x0000E000&((data)<<13))
+#define HDMI_MAGCR0_agd(data)                                         (0x00001F00&((data)<<8))
+#define HDMI_MAGCR0_mg(data)                                          (0x000000FF&(data))
+#define HDMI_MAGCR0_get_agi(data)                                     ((0x0000E000&(data))>>13)
+#define HDMI_MAGCR0_get_agd(data)                                     ((0x00001F00&(data))>>8)
+#define HDMI_MAGCR0_get_mg(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_MAG_M_FINAL                                              0x1800f114
+#define HDMI_MAG_M_FINAL_reg_addr                                     "0xb800f114"
+#define HDMI_MAG_M_FINAL_reg                                          0xb800f114
+#define HDMI_MAG_M_FINAL_inst_addr                                    "0x0045"
+#define HDMI_MAG_M_FINAL_inst                                         0x0045
+#define HDMI_MAG_M_FINAL_ldp_time_shift                               (21)
+#define HDMI_MAG_M_FINAL_ldp_time_mode_shift                          (20)
+#define HDMI_MAG_M_FINAL_fg_r_shift                                   (12)
+#define HDMI_MAG_M_FINAL_fg_l_shift                                   (4)
+#define HDMI_MAG_M_FINAL_auto_dly_mod_shift                           (3)
+#define HDMI_MAG_M_FINAL_fg_en_shift                                  (2)
+#define HDMI_MAG_M_FINAL_ffg_l_shift                                  (1)
+#define HDMI_MAG_M_FINAL_ffg_r_shift                                  (0)
+#define HDMI_MAG_M_FINAL_ldp_time_mask                                (0x7FE00000)
+#define HDMI_MAG_M_FINAL_ldp_time_mode_mask                           (0x00100000)
+#define HDMI_MAG_M_FINAL_fg_r_mask                                    (0x000FF000)
+#define HDMI_MAG_M_FINAL_fg_l_mask                                    (0x00000FF0)
+#define HDMI_MAG_M_FINAL_auto_dly_mod_mask                            (0x00000008)
+#define HDMI_MAG_M_FINAL_fg_en_mask                                   (0x00000004)
+#define HDMI_MAG_M_FINAL_ffg_l_mask                                   (0x00000002)
+#define HDMI_MAG_M_FINAL_ffg_r_mask                                   (0x00000001)
+#define HDMI_MAG_M_FINAL_ldp_time(data)                               (0x7FE00000&((data)<<21))
+#define HDMI_MAG_M_FINAL_ldp_time_mode(data)                          (0x00100000&((data)<<20))
+#define HDMI_MAG_M_FINAL_fg_r(data)                                   (0x000FF000&((data)<<12))
+#define HDMI_MAG_M_FINAL_fg_l(data)                                   (0x00000FF0&((data)<<4))
+#define HDMI_MAG_M_FINAL_auto_dly_mod(data)                           (0x00000008&((data)<<3))
+#define HDMI_MAG_M_FINAL_fg_en(data)                                  (0x00000004&((data)<<2))
+#define HDMI_MAG_M_FINAL_ffg_l(data)                                  (0x00000002&((data)<<1))
+#define HDMI_MAG_M_FINAL_ffg_r(data)                                  (0x00000001&(data))
+#define HDMI_MAG_M_FINAL_get_ldp_time(data)                           ((0x7FE00000&(data))>>21)
+#define HDMI_MAG_M_FINAL_get_ldp_time_mode(data)                      ((0x00100000&(data))>>20)
+#define HDMI_MAG_M_FINAL_get_fg_r(data)                               ((0x000FF000&(data))>>12)
+#define HDMI_MAG_M_FINAL_get_fg_l(data)                               ((0x00000FF0&(data))>>4)
+#define HDMI_MAG_M_FINAL_get_auto_dly_mod(data)                       ((0x00000008&(data))>>3)
+#define HDMI_MAG_M_FINAL_get_fg_en(data)                              ((0x00000004&(data))>>2)
+#define HDMI_MAG_M_FINAL_get_ffg_l(data)                              ((0x00000002&(data))>>1)
+#define HDMI_MAG_M_FINAL_get_ffg_r(data)                              (0x00000001&(data))
+
+
+#define ZCD_CTRL                                                      0x1800f118
+#define ZCD_CTRL_reg_addr                                             "0xb800f118"
+#define ZCD_CTRL_reg                                                  0xb800f118
+#define ZCD_CTRL_inst_addr                                            "0x0046"
+#define ZCD_CTRL_inst                                                 0x0046
+#define ZCD_CTRL_zcd_ch7_done_shift                                   (23)
+#define ZCD_CTRL_zcd_ch6_done_shift                                   (22)
+#define ZCD_CTRL_zcd_ch5_done_shift                                   (21)
+#define ZCD_CTRL_zcd_ch4_done_shift                                   (20)
+#define ZCD_CTRL_zcd_ch3_done_shift                                   (19)
+#define ZCD_CTRL_zcd_ch2_done_shift                                   (18)
+#define ZCD_CTRL_zcd_ch1_done_shift                                   (17)
+#define ZCD_CTRL_zcd_ch0_done_shift                                   (16)
+#define ZCD_CTRL_zcd_timeout_shift                                    (8)
+#define ZCD_CTRL_zcd_en_shift                                         (7)
+#define ZCD_CTRL_zcd_sep_8ch_shift                                    (6)
+#define ZCD_CTRL_zcd_sep_st_shift                                     (5)
+#define ZCD_CTRL_dummy1800f118_4_0_shift                              (0)
+#define ZCD_CTRL_zcd_ch7_done_mask                                    (0x00800000)
+#define ZCD_CTRL_zcd_ch6_done_mask                                    (0x00400000)
+#define ZCD_CTRL_zcd_ch5_done_mask                                    (0x00200000)
+#define ZCD_CTRL_zcd_ch4_done_mask                                    (0x00100000)
+#define ZCD_CTRL_zcd_ch3_done_mask                                    (0x00080000)
+#define ZCD_CTRL_zcd_ch2_done_mask                                    (0x00040000)
+#define ZCD_CTRL_zcd_ch1_done_mask                                    (0x00020000)
+#define ZCD_CTRL_zcd_ch0_done_mask                                    (0x00010000)
+#define ZCD_CTRL_zcd_timeout_mask                                     (0x00007F00)
+#define ZCD_CTRL_zcd_en_mask                                          (0x00000080)
+#define ZCD_CTRL_zcd_sep_8ch_mask                                     (0x00000040)
+#define ZCD_CTRL_zcd_sep_st_mask                                      (0x00000020)
+#define ZCD_CTRL_dummy1800f118_4_0_mask                               (0x0000001F)
+#define ZCD_CTRL_zcd_ch7_done(data)                                   (0x00800000&((data)<<23))
+#define ZCD_CTRL_zcd_ch6_done(data)                                   (0x00400000&((data)<<22))
+#define ZCD_CTRL_zcd_ch5_done(data)                                   (0x00200000&((data)<<21))
+#define ZCD_CTRL_zcd_ch4_done(data)                                   (0x00100000&((data)<<20))
+#define ZCD_CTRL_zcd_ch3_done(data)                                   (0x00080000&((data)<<19))
+#define ZCD_CTRL_zcd_ch2_done(data)                                   (0x00040000&((data)<<18))
+#define ZCD_CTRL_zcd_ch1_done(data)                                   (0x00020000&((data)<<17))
+#define ZCD_CTRL_zcd_ch0_done(data)                                   (0x00010000&((data)<<16))
+#define ZCD_CTRL_zcd_timeout(data)                                    (0x00007F00&((data)<<8))
+#define ZCD_CTRL_zcd_en(data)                                         (0x00000080&((data)<<7))
+#define ZCD_CTRL_zcd_sep_8ch(data)                                    (0x00000040&((data)<<6))
+#define ZCD_CTRL_zcd_sep_st(data)                                     (0x00000020&((data)<<5))
+#define ZCD_CTRL_dummy1800f118_4_0(data)                              (0x0000001F&(data))
+#define ZCD_CTRL_get_zcd_ch7_done(data)                               ((0x00800000&(data))>>23)
+#define ZCD_CTRL_get_zcd_ch6_done(data)                               ((0x00400000&(data))>>22)
+#define ZCD_CTRL_get_zcd_ch5_done(data)                               ((0x00200000&(data))>>21)
+#define ZCD_CTRL_get_zcd_ch4_done(data)                               ((0x00100000&(data))>>20)
+#define ZCD_CTRL_get_zcd_ch3_done(data)                               ((0x00080000&(data))>>19)
+#define ZCD_CTRL_get_zcd_ch2_done(data)                               ((0x00040000&(data))>>18)
+#define ZCD_CTRL_get_zcd_ch1_done(data)                               ((0x00020000&(data))>>17)
+#define ZCD_CTRL_get_zcd_ch0_done(data)                               ((0x00010000&(data))>>16)
+#define ZCD_CTRL_get_zcd_timeout(data)                                ((0x00007F00&(data))>>8)
+#define ZCD_CTRL_get_zcd_en(data)                                     ((0x00000080&(data))>>7)
+#define ZCD_CTRL_get_zcd_sep_8ch(data)                                ((0x00000040&(data))>>6)
+#define ZCD_CTRL_get_zcd_sep_st(data)                                 ((0x00000020&(data))>>5)
+#define ZCD_CTRL_get_dummy1800f118_4_0(data)                          (0x0000001F&(data))
+
+
+#define AUDIO_FREQDET                                                 0x1800f11c
+#define AUDIO_FREQDET_reg_addr                                        "0xb800f11c"
+#define AUDIO_FREQDET_reg                                             0xb800f11c
+#define AUDIO_FREQDET_inst_addr                                       "0x0047"
+#define AUDIO_FREQDET_inst                                            0x0047
+#define AUDIO_FREQDET_xtal_div_shift                                  (24)
+#define AUDIO_FREQDET_afreq_meas_result_shift                         (12)
+#define AUDIO_FREQDET_afreq_meas_range_shift                          (9)
+#define AUDIO_FREQDET_popup_afreq_meas_result_shift                   (8)
+#define AUDIO_FREQDET_audio_freq_detect_shift                         (7)
+#define AUDIO_FREQDET_auto_load_scode_shift                           (6)
+#define AUDIO_FREQDET_awd_by_freqchange_shift                         (5)
+#define AUDIO_FREQDET_awd_by_noaudio_shift                            (4)
+#define AUDIO_FREQDET_irq_by_freqchange_shift                         (3)
+#define AUDIO_FREQDET_irq_by_noaudio_shift                            (2)
+#define AUDIO_FREQDET_freqchange_shift                                (1)
+#define AUDIO_FREQDET_noaudio_shift                                   (0)
+#define AUDIO_FREQDET_xtal_div_mask                                   (0xFF000000)
+#define AUDIO_FREQDET_afreq_meas_result_mask                          (0x00FFF000)
+#define AUDIO_FREQDET_afreq_meas_range_mask                           (0x00000E00)
+#define AUDIO_FREQDET_popup_afreq_meas_result_mask                    (0x00000100)
+#define AUDIO_FREQDET_audio_freq_detect_mask                          (0x00000080)
+#define AUDIO_FREQDET_auto_load_scode_mask                            (0x00000040)
+#define AUDIO_FREQDET_awd_by_freqchange_mask                          (0x00000020)
+#define AUDIO_FREQDET_awd_by_noaudio_mask                             (0x00000010)
+#define AUDIO_FREQDET_irq_by_freqchange_mask                          (0x00000008)
+#define AUDIO_FREQDET_irq_by_noaudio_mask                             (0x00000004)
+#define AUDIO_FREQDET_freqchange_mask                                 (0x00000002)
+#define AUDIO_FREQDET_noaudio_mask                                    (0x00000001)
+#define AUDIO_FREQDET_xtal_div(data)                                  (0xFF000000&((data)<<24))
+#define AUDIO_FREQDET_afreq_meas_result(data)                         (0x00FFF000&((data)<<12))
+#define AUDIO_FREQDET_afreq_meas_range(data)                          (0x00000E00&((data)<<9))
+#define AUDIO_FREQDET_popup_afreq_meas_result(data)                   (0x00000100&((data)<<8))
+#define AUDIO_FREQDET_audio_freq_detect(data)                         (0x00000080&((data)<<7))
+#define AUDIO_FREQDET_auto_load_scode(data)                           (0x00000040&((data)<<6))
+#define AUDIO_FREQDET_awd_by_freqchange(data)                         (0x00000020&((data)<<5))
+#define AUDIO_FREQDET_awd_by_noaudio(data)                            (0x00000010&((data)<<4))
+#define AUDIO_FREQDET_irq_by_freqchange(data)                         (0x00000008&((data)<<3))
+#define AUDIO_FREQDET_irq_by_noaudio(data)                            (0x00000004&((data)<<2))
+#define AUDIO_FREQDET_freqchange(data)                                (0x00000002&((data)<<1))
+#define AUDIO_FREQDET_noaudio(data)                                   (0x00000001&(data))
+#define AUDIO_FREQDET_get_xtal_div(data)                              ((0xFF000000&(data))>>24)
+#define AUDIO_FREQDET_get_afreq_meas_result(data)                     ((0x00FFF000&(data))>>12)
+#define AUDIO_FREQDET_get_afreq_meas_range(data)                      ((0x00000E00&(data))>>9)
+#define AUDIO_FREQDET_get_popup_afreq_meas_result(data)               ((0x00000100&(data))>>8)
+#define AUDIO_FREQDET_get_audio_freq_detect(data)                     ((0x00000080&(data))>>7)
+#define AUDIO_FREQDET_get_auto_load_scode(data)                       ((0x00000040&(data))>>6)
+#define AUDIO_FREQDET_get_awd_by_freqchange(data)                     ((0x00000020&(data))>>5)
+#define AUDIO_FREQDET_get_awd_by_noaudio(data)                        ((0x00000010&(data))>>4)
+#define AUDIO_FREQDET_get_irq_by_freqchange(data)                     ((0x00000008&(data))>>3)
+#define AUDIO_FREQDET_get_irq_by_noaudio(data)                        ((0x00000004&(data))>>2)
+#define AUDIO_FREQDET_get_freqchange(data)                            ((0x00000002&(data))>>1)
+#define AUDIO_FREQDET_get_noaudio(data)                               (0x00000001&(data))
+
+
+#define RANGE0_1                                                      0x1800f120
+#define RANGE0_1_reg_addr                                             "0xb800f120"
+#define RANGE0_1_reg                                                  0xb800f120
+#define RANGE0_1_inst_addr                                            "0x0048"
+#define RANGE0_1_inst                                                 0x0048
+#define RANGE0_1_range0_th_shift                                      (12)
+#define RANGE0_1_range1_th_shift                                      (0)
+#define RANGE0_1_range0_th_mask                                       (0x00FFF000)
+#define RANGE0_1_range1_th_mask                                       (0x00000FFF)
+#define RANGE0_1_range0_th(data)                                      (0x00FFF000&((data)<<12))
+#define RANGE0_1_range1_th(data)                                      (0x00000FFF&(data))
+#define RANGE0_1_get_range0_th(data)                                  ((0x00FFF000&(data))>>12)
+#define RANGE0_1_get_range1_th(data)                                  (0x00000FFF&(data))
+
+
+#define RANGE2_3                                                      0x1800f124
+#define RANGE2_3_reg_addr                                             "0xb800f124"
+#define RANGE2_3_reg                                                  0xb800f124
+#define RANGE2_3_inst_addr                                            "0x0049"
+#define RANGE2_3_inst                                                 0x0049
+#define RANGE2_3_range2_th_shift                                      (12)
+#define RANGE2_3_range3_th_shift                                      (0)
+#define RANGE2_3_range2_th_mask                                       (0x00FFF000)
+#define RANGE2_3_range3_th_mask                                       (0x00000FFF)
+#define RANGE2_3_range2_th(data)                                      (0x00FFF000&((data)<<12))
+#define RANGE2_3_range3_th(data)                                      (0x00000FFF&(data))
+#define RANGE2_3_get_range2_th(data)                                  ((0x00FFF000&(data))>>12)
+#define RANGE2_3_get_range3_th(data)                                  (0x00000FFF&(data))
+
+
+#define RANGE4_5                                                      0x1800f128
+#define RANGE4_5_reg_addr                                             "0xb800f128"
+#define RANGE4_5_reg                                                  0xb800f128
+#define RANGE4_5_inst_addr                                            "0x004A"
+#define RANGE4_5_inst                                                 0x004A
+#define RANGE4_5_range4_th_shift                                      (12)
+#define RANGE4_5_range5_th_shift                                      (0)
+#define RANGE4_5_range4_th_mask                                       (0x00FFF000)
+#define RANGE4_5_range5_th_mask                                       (0x00000FFF)
+#define RANGE4_5_range4_th(data)                                      (0x00FFF000&((data)<<12))
+#define RANGE4_5_range5_th(data)                                      (0x00000FFF&(data))
+#define RANGE4_5_get_range4_th(data)                                  ((0x00FFF000&(data))>>12)
+#define RANGE4_5_get_range5_th(data)                                  (0x00000FFF&(data))
+
+
+#define PRESET_S_CODE0                                                0x1800f12c
+#define PRESET_S_CODE0_reg_addr                                       "0xb800f12c"
+#define PRESET_S_CODE0_reg                                            0xb800f12c
+#define PRESET_S_CODE0_inst_addr                                      "0x004B"
+#define PRESET_S_CODE0_inst                                           0x004B
+#define PRESET_S_CODE0_pre_set_s1_code3_shift                         (31)
+#define PRESET_S_CODE0_pre_set_s_code3_shift                          (24)
+#define PRESET_S_CODE0_pre_set_s1_code2_shift                         (23)
+#define PRESET_S_CODE0_pre_set_s_code2_shift                          (16)
+#define PRESET_S_CODE0_pre_set_s1_code1_shift                         (15)
+#define PRESET_S_CODE0_pre_set_s_code1_shift                          (8)
+#define PRESET_S_CODE0_pre_set_s1_code0_shift                         (7)
+#define PRESET_S_CODE0_pre_set_s_code0_shift                          (0)
+#define PRESET_S_CODE0_pre_set_s1_code3_mask                          (0x80000000)
+#define PRESET_S_CODE0_pre_set_s_code3_mask                           (0x7F000000)
+#define PRESET_S_CODE0_pre_set_s1_code2_mask                          (0x00800000)
+#define PRESET_S_CODE0_pre_set_s_code2_mask                           (0x007F0000)
+#define PRESET_S_CODE0_pre_set_s1_code1_mask                          (0x00008000)
+#define PRESET_S_CODE0_pre_set_s_code1_mask                           (0x00007F00)
+#define PRESET_S_CODE0_pre_set_s1_code0_mask                          (0x00000080)
+#define PRESET_S_CODE0_pre_set_s_code0_mask                           (0x0000007F)
+#define PRESET_S_CODE0_pre_set_s1_code3(data)                         (0x80000000&((data)<<31))
+#define PRESET_S_CODE0_pre_set_s_code3(data)                          (0x7F000000&((data)<<24))
+#define PRESET_S_CODE0_pre_set_s1_code2(data)                         (0x00800000&((data)<<23))
+#define PRESET_S_CODE0_pre_set_s_code2(data)                          (0x007F0000&((data)<<16))
+#define PRESET_S_CODE0_pre_set_s1_code1(data)                         (0x00008000&((data)<<15))
+#define PRESET_S_CODE0_pre_set_s_code1(data)                          (0x00007F00&((data)<<8))
+#define PRESET_S_CODE0_pre_set_s1_code0(data)                         (0x00000080&((data)<<7))
+#define PRESET_S_CODE0_pre_set_s_code0(data)                          (0x0000007F&(data))
+#define PRESET_S_CODE0_get_pre_set_s1_code3(data)                     ((0x80000000&(data))>>31)
+#define PRESET_S_CODE0_get_pre_set_s_code3(data)                      ((0x7F000000&(data))>>24)
+#define PRESET_S_CODE0_get_pre_set_s1_code2(data)                     ((0x00800000&(data))>>23)
+#define PRESET_S_CODE0_get_pre_set_s_code2(data)                      ((0x007F0000&(data))>>16)
+#define PRESET_S_CODE0_get_pre_set_s1_code1(data)                     ((0x00008000&(data))>>15)
+#define PRESET_S_CODE0_get_pre_set_s_code1(data)                      ((0x00007F00&(data))>>8)
+#define PRESET_S_CODE0_get_pre_set_s1_code0(data)                     ((0x00000080&(data))>>7)
+#define PRESET_S_CODE0_get_pre_set_s_code0(data)                      (0x0000007F&(data))
+
+
+#define PRESET_S_CODE1                                                0x1800f130
+#define PRESET_S_CODE1_reg_addr                                       "0xb800f130"
+#define PRESET_S_CODE1_reg                                            0xb800f130
+#define PRESET_S_CODE1_inst_addr                                      "0x004C"
+#define PRESET_S_CODE1_inst                                           0x004C
+#define PRESET_S_CODE1_dp_abuf_wr_mod_en_shift                        (23)
+#define PRESET_S_CODE1_auto_stop_trk_en_shift                         (22)
+#define PRESET_S_CODE1_trk_mod_en_shift                               (21)
+#define PRESET_S_CODE1_afsm_mod_en_shift                              (20)
+#define PRESET_S_CODE1_pre_set_sm_code0_shift                         (15)
+#define PRESET_S_CODE1_pre_set_sm_code1_shift                         (14)
+#define PRESET_S_CODE1_pre_set_sm_code2_shift                         (13)
+#define PRESET_S_CODE1_pre_set_sm_code3_shift                         (12)
+#define PRESET_S_CODE1_pre_set_sm_code4_shift                         (11)
+#define PRESET_S_CODE1_pre_set_s1_code4_shift                         (7)
+#define PRESET_S_CODE1_pre_set_s_code4_shift                          (0)
+#define PRESET_S_CODE1_dp_abuf_wr_mod_en_mask                         (0x00800000)
+#define PRESET_S_CODE1_auto_stop_trk_en_mask                          (0x00400000)
+#define PRESET_S_CODE1_trk_mod_en_mask                                (0x00200000)
+#define PRESET_S_CODE1_afsm_mod_en_mask                               (0x00100000)
+#define PRESET_S_CODE1_pre_set_sm_code0_mask                          (0x00008000)
+#define PRESET_S_CODE1_pre_set_sm_code1_mask                          (0x00004000)
+#define PRESET_S_CODE1_pre_set_sm_code2_mask                          (0x00002000)
+#define PRESET_S_CODE1_pre_set_sm_code3_mask                          (0x00001000)
+#define PRESET_S_CODE1_pre_set_sm_code4_mask                          (0x00000800)
+#define PRESET_S_CODE1_pre_set_s1_code4_mask                          (0x00000080)
+#define PRESET_S_CODE1_pre_set_s_code4_mask                           (0x0000007F)
+#define PRESET_S_CODE1_dp_abuf_wr_mod_en(data)                        (0x00800000&((data)<<23))
+#define PRESET_S_CODE1_auto_stop_trk_en(data)                         (0x00400000&((data)<<22))
+#define PRESET_S_CODE1_trk_mod_en(data)                               (0x00200000&((data)<<21))
+#define PRESET_S_CODE1_afsm_mod_en(data)                              (0x00100000&((data)<<20))
+#define PRESET_S_CODE1_pre_set_sm_code0(data)                         (0x00008000&((data)<<15))
+#define PRESET_S_CODE1_pre_set_sm_code1(data)                         (0x00004000&((data)<<14))
+#define PRESET_S_CODE1_pre_set_sm_code2(data)                         (0x00002000&((data)<<13))
+#define PRESET_S_CODE1_pre_set_sm_code3(data)                         (0x00001000&((data)<<12))
+#define PRESET_S_CODE1_pre_set_sm_code4(data)                         (0x00000800&((data)<<11))
+#define PRESET_S_CODE1_pre_set_s1_code4(data)                         (0x00000080&((data)<<7))
+#define PRESET_S_CODE1_pre_set_s_code4(data)                          (0x0000007F&(data))
+#define PRESET_S_CODE1_get_dp_abuf_wr_mod_en(data)                    ((0x00800000&(data))>>23)
+#define PRESET_S_CODE1_get_auto_stop_trk_en(data)                     ((0x00400000&(data))>>22)
+#define PRESET_S_CODE1_get_trk_mod_en(data)                           ((0x00200000&(data))>>21)
+#define PRESET_S_CODE1_get_afsm_mod_en(data)                          ((0x00100000&(data))>>20)
+#define PRESET_S_CODE1_get_pre_set_sm_code0(data)                     ((0x00008000&(data))>>15)
+#define PRESET_S_CODE1_get_pre_set_sm_code1(data)                     ((0x00004000&(data))>>14)
+#define PRESET_S_CODE1_get_pre_set_sm_code2(data)                     ((0x00002000&(data))>>13)
+#define PRESET_S_CODE1_get_pre_set_sm_code3(data)                     ((0x00001000&(data))>>12)
+#define PRESET_S_CODE1_get_pre_set_sm_code4(data)                     ((0x00000800&(data))>>11)
+#define PRESET_S_CODE1_get_pre_set_s1_code4(data)                     ((0x00000080&(data))>>7)
+#define PRESET_S_CODE1_get_pre_set_s_code4(data)                      (0x0000007F&(data))
+
+
+#define PRBS7_R_CTRL                                                  0x1800f134
+#define PRBS7_R_CTRL_reg_addr                                         "0xb800f134"
+#define PRBS7_R_CTRL_reg                                              0xb800f134
+#define PRBS7_R_CTRL_inst_addr                                        "0x004D"
+#define PRBS7_R_CTRL_inst                                             0x004D
+#define PRBS7_R_CTRL_prbs7_rxbist_err_cnt_shift                       (20)
+#define PRBS7_R_CTRL_prbs7_err_cnt_shift                              (16)
+#define PRBS7_R_CTRL_prbs7_bit_err_shift                              (4)
+#define PRBS7_R_CTRL_prbs7_lock_shift                                 (3)
+#define PRBS7_R_CTRL_prbs7_err_cnt_clr_shift                          (2)
+#define PRBS7_R_CTRL_prbs7_reverse_shift                              (1)
+#define PRBS7_R_CTRL_prbs7_rxen_shift                                 (0)
+#define PRBS7_R_CTRL_prbs7_rxbist_err_cnt_mask                        (0x0FF00000)
+#define PRBS7_R_CTRL_prbs7_err_cnt_mask                               (0x000F0000)
+#define PRBS7_R_CTRL_prbs7_bit_err_mask                               (0x00003FF0)
+#define PRBS7_R_CTRL_prbs7_lock_mask                                  (0x00000008)
+#define PRBS7_R_CTRL_prbs7_err_cnt_clr_mask                           (0x00000004)
+#define PRBS7_R_CTRL_prbs7_reverse_mask                               (0x00000002)
+#define PRBS7_R_CTRL_prbs7_rxen_mask                                  (0x00000001)
+#define PRBS7_R_CTRL_prbs7_rxbist_err_cnt(data)                       (0x0FF00000&((data)<<20))
+#define PRBS7_R_CTRL_prbs7_err_cnt(data)                              (0x000F0000&((data)<<16))
+#define PRBS7_R_CTRL_prbs7_bit_err(data)                              (0x00003FF0&((data)<<4))
+#define PRBS7_R_CTRL_prbs7_lock(data)                                 (0x00000008&((data)<<3))
+#define PRBS7_R_CTRL_prbs7_err_cnt_clr(data)                          (0x00000004&((data)<<2))
+#define PRBS7_R_CTRL_prbs7_reverse(data)                              (0x00000002&((data)<<1))
+#define PRBS7_R_CTRL_prbs7_rxen(data)                                 (0x00000001&(data))
+#define PRBS7_R_CTRL_get_prbs7_rxbist_err_cnt(data)                   ((0x0FF00000&(data))>>20)
+#define PRBS7_R_CTRL_get_prbs7_err_cnt(data)                          ((0x000F0000&(data))>>16)
+#define PRBS7_R_CTRL_get_prbs7_bit_err(data)                          ((0x00003FF0&(data))>>4)
+#define PRBS7_R_CTRL_get_prbs7_lock(data)                             ((0x00000008&(data))>>3)
+#define PRBS7_R_CTRL_get_prbs7_err_cnt_clr(data)                      ((0x00000004&(data))>>2)
+#define PRBS7_R_CTRL_get_prbs7_reverse(data)                          ((0x00000002&(data))>>1)
+#define PRBS7_R_CTRL_get_prbs7_rxen(data)                             (0x00000001&(data))
+
+
+#define PRBS7_G_CTRL                                                  0x1800f138
+#define PRBS7_G_CTRL_reg_addr                                         "0xb800f138"
+#define PRBS7_G_CTRL_reg                                              0xb800f138
+#define PRBS7_G_CTRL_inst_addr                                        "0x004E"
+#define PRBS7_G_CTRL_inst                                             0x004E
+#define PRBS7_G_CTRL_prbs7_rxbist_err_cnt_shift                       (20)
+#define PRBS7_G_CTRL_prbs7_err_cnt_shift                              (16)
+#define PRBS7_G_CTRL_prbs7_bit_err_shift                              (4)
+#define PRBS7_G_CTRL_prbs7_lock_shift                                 (3)
+#define PRBS7_G_CTRL_prbs7_err_cnt_clr_shift                          (2)
+#define PRBS7_G_CTRL_prbs7_reverse_shift                              (1)
+#define PRBS7_G_CTRL_prbs7_rxen_shift                                 (0)
+#define PRBS7_G_CTRL_prbs7_rxbist_err_cnt_mask                        (0x0FF00000)
+#define PRBS7_G_CTRL_prbs7_err_cnt_mask                               (0x000F0000)
+#define PRBS7_G_CTRL_prbs7_bit_err_mask                               (0x00003FF0)
+#define PRBS7_G_CTRL_prbs7_lock_mask                                  (0x00000008)
+#define PRBS7_G_CTRL_prbs7_err_cnt_clr_mask                           (0x00000004)
+#define PRBS7_G_CTRL_prbs7_reverse_mask                               (0x00000002)
+#define PRBS7_G_CTRL_prbs7_rxen_mask                                  (0x00000001)
+#define PRBS7_G_CTRL_prbs7_rxbist_err_cnt(data)                       (0x0FF00000&((data)<<20))
+#define PRBS7_G_CTRL_prbs7_err_cnt(data)                              (0x000F0000&((data)<<16))
+#define PRBS7_G_CTRL_prbs7_bit_err(data)                              (0x00003FF0&((data)<<4))
+#define PRBS7_G_CTRL_prbs7_lock(data)                                 (0x00000008&((data)<<3))
+#define PRBS7_G_CTRL_prbs7_err_cnt_clr(data)                          (0x00000004&((data)<<2))
+#define PRBS7_G_CTRL_prbs7_reverse(data)                              (0x00000002&((data)<<1))
+#define PRBS7_G_CTRL_prbs7_rxen(data)                                 (0x00000001&(data))
+#define PRBS7_G_CTRL_get_prbs7_rxbist_err_cnt(data)                   ((0x0FF00000&(data))>>20)
+#define PRBS7_G_CTRL_get_prbs7_err_cnt(data)                          ((0x000F0000&(data))>>16)
+#define PRBS7_G_CTRL_get_prbs7_bit_err(data)                          ((0x00003FF0&(data))>>4)
+#define PRBS7_G_CTRL_get_prbs7_lock(data)                             ((0x00000008&(data))>>3)
+#define PRBS7_G_CTRL_get_prbs7_err_cnt_clr(data)                      ((0x00000004&(data))>>2)
+#define PRBS7_G_CTRL_get_prbs7_reverse(data)                          ((0x00000002&(data))>>1)
+#define PRBS7_G_CTRL_get_prbs7_rxen(data)                             (0x00000001&(data))
+
+
+#define PRBS7_B_CTRL                                                  0x1800f13c
+#define PRBS7_B_CTRL_reg_addr                                         "0xb800f13c"
+#define PRBS7_B_CTRL_reg                                              0xb800f13c
+#define PRBS7_B_CTRL_inst_addr                                        "0x004F"
+#define PRBS7_B_CTRL_inst                                             0x004F
+#define PRBS7_B_CTRL_prbs7_rxbist_err_cnt_shift                       (20)
+#define PRBS7_B_CTRL_prbs7_err_cnt_shift                              (16)
+#define PRBS7_B_CTRL_prbs7_bit_err_shift                              (4)
+#define PRBS7_B_CTRL_prbs7_lock_shift                                 (3)
+#define PRBS7_B_CTRL_prbs7_err_cnt_clr_shift                          (2)
+#define PRBS7_B_CTRL_prbs7_reverse_shift                              (1)
+#define PRBS7_B_CTRL_prbs7_rxen_shift                                 (0)
+#define PRBS7_B_CTRL_prbs7_rxbist_err_cnt_mask                        (0x0FF00000)
+#define PRBS7_B_CTRL_prbs7_err_cnt_mask                               (0x000F0000)
+#define PRBS7_B_CTRL_prbs7_bit_err_mask                               (0x00003FF0)
+#define PRBS7_B_CTRL_prbs7_lock_mask                                  (0x00000008)
+#define PRBS7_B_CTRL_prbs7_err_cnt_clr_mask                           (0x00000004)
+#define PRBS7_B_CTRL_prbs7_reverse_mask                               (0x00000002)
+#define PRBS7_B_CTRL_prbs7_rxen_mask                                  (0x00000001)
+#define PRBS7_B_CTRL_prbs7_rxbist_err_cnt(data)                       (0x0FF00000&((data)<<20))
+#define PRBS7_B_CTRL_prbs7_err_cnt(data)                              (0x000F0000&((data)<<16))
+#define PRBS7_B_CTRL_prbs7_bit_err(data)                              (0x00003FF0&((data)<<4))
+#define PRBS7_B_CTRL_prbs7_lock(data)                                 (0x00000008&((data)<<3))
+#define PRBS7_B_CTRL_prbs7_err_cnt_clr(data)                          (0x00000004&((data)<<2))
+#define PRBS7_B_CTRL_prbs7_reverse(data)                              (0x00000002&((data)<<1))
+#define PRBS7_B_CTRL_prbs7_rxen(data)                                 (0x00000001&(data))
+#define PRBS7_B_CTRL_get_prbs7_rxbist_err_cnt(data)                   ((0x0FF00000&(data))>>20)
+#define PRBS7_B_CTRL_get_prbs7_err_cnt(data)                          ((0x000F0000&(data))>>16)
+#define PRBS7_B_CTRL_get_prbs7_bit_err(data)                          ((0x00003FF0&(data))>>4)
+#define PRBS7_B_CTRL_get_prbs7_lock(data)                             ((0x00000008&(data))>>3)
+#define PRBS7_B_CTRL_get_prbs7_err_cnt_clr(data)                      ((0x00000004&(data))>>2)
+#define PRBS7_B_CTRL_get_prbs7_reverse(data)                          ((0x00000002&(data))>>1)
+#define PRBS7_B_CTRL_get_prbs7_rxen(data)                             (0x00000001&(data))
+
+
+#define HDMI_LEADING_GB_CMP_CTRL                                      0x1800f140
+#define HDMI_LEADING_GB_CMP_CTRL_reg_addr                             "0xb800f140"
+#define HDMI_LEADING_GB_CMP_CTRL_reg                                  0xb800f140
+#define HDMI_LEADING_GB_CMP_CTRL_inst_addr                            "0x0050"
+#define HDMI_LEADING_GB_CMP_CTRL_inst                                 0x0050
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag_shift                   (30)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en_shift                  (29)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en_shift                 (28)
+#define HDMI_LEADING_GB_CMP_CTRL_preamble_shift                       (24)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_value_shift                      (8)
+#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel_shift                   (4)
+#define HDMI_LEADING_GB_CMP_CTRL_channel_sel_shift                    (2)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti_shift                  (1)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en_shift                     (0)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag_mask                    (0x40000000)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en_mask                   (0x20000000)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en_mask                  (0x10000000)
+#define HDMI_LEADING_GB_CMP_CTRL_preamble_mask                        (0x0F000000)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_value_mask                       (0x0003FF00)
+#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel_mask                    (0x00000010)
+#define HDMI_LEADING_GB_CMP_CTRL_channel_sel_mask                     (0x0000000C)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti_mask                   (0x00000002)
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en_mask                      (0x00000001)
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_flag(data)                   (0x40000000&((data)<<30))
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_wd_en(data)                  (0x20000000&((data)<<29))
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_err_int_en(data)                 (0x10000000&((data)<<28))
+#define HDMI_LEADING_GB_CMP_CTRL_preamble(data)                       (0x0F000000&((data)<<24))
+#define HDMI_LEADING_GB_CMP_CTRL_cmp_value(data)                      (0x0003FF00&((data)<<8))
+#define HDMI_LEADING_GB_CMP_CTRL_dvi_mode_sel(data)                   (0x00000010&((data)<<4))
+#define HDMI_LEADING_GB_CMP_CTRL_channel_sel(data)                    (0x0000000C&((data)<<2))
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_conti(data)                  (0x00000002&((data)<<1))
+#define HDMI_LEADING_GB_CMP_CTRL_lgb_cal_en(data)                     (0x00000001&(data))
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_flag(data)               ((0x40000000&(data))>>30)
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_wd_en(data)              ((0x20000000&(data))>>29)
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_err_int_en(data)             ((0x10000000&(data))>>28)
+#define HDMI_LEADING_GB_CMP_CTRL_get_preamble(data)                   ((0x0F000000&(data))>>24)
+#define HDMI_LEADING_GB_CMP_CTRL_get_cmp_value(data)                  ((0x0003FF00&(data))>>8)
+#define HDMI_LEADING_GB_CMP_CTRL_get_dvi_mode_sel(data)               ((0x00000010&(data))>>4)
+#define HDMI_LEADING_GB_CMP_CTRL_get_channel_sel(data)                ((0x0000000C&(data))>>2)
+#define HDMI_LEADING_GB_CMP_CTRL_get_lgb_cal_conti(data)              ((0x00000002&(data))>>1)
+#define HDMI_LEADING_GB_CMP_CTRL_get_lgb_cal_en(data)                 (0x00000001&(data))
+
+
+#define HDMI_LEADING_GB_CMP_TIMES                                     0x1800f144
+#define HDMI_LEADING_GB_CMP_TIMES_reg_addr                            "0xb800f144"
+#define HDMI_LEADING_GB_CMP_TIMES_reg                                 0xb800f144
+#define HDMI_LEADING_GB_CMP_TIMES_inst_addr                           "0x0051"
+#define HDMI_LEADING_GB_CMP_TIMES_inst                                0x0051
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt_shift                   (16)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_times_shift                     (0)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt_mask                    (0xFFFF0000)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_times_mask                      (0x0000FFFF)
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_err_cnt(data)                   (0xFFFF0000&((data)<<16))
+#define HDMI_LEADING_GB_CMP_TIMES_cmp_times(data)                     (0x0000FFFF&(data))
+#define HDMI_LEADING_GB_CMP_TIMES_get_cmp_err_cnt(data)               ((0xFFFF0000&(data))>>16)
+#define HDMI_LEADING_GB_CMP_TIMES_get_cmp_times(data)                 (0x0000FFFF&(data))
+
+
+#define HDMI_LEADING_GB_CMP_CNT                                       0x1800f148
+#define HDMI_LEADING_GB_CMP_CNT_reg_addr                              "0xb800f148"
+#define HDMI_LEADING_GB_CMP_CNT_reg                                   0xb800f148
+#define HDMI_LEADING_GB_CMP_CNT_inst_addr                             "0x0052"
+#define HDMI_LEADING_GB_CMP_CNT_inst                                  0x0052
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_shift                (16)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame_shift       (0)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_mask                 (0xFFFF0000)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame_mask        (0x0000FFFF)
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt(data)                (0xFFFF0000&((data)<<16))
+#define HDMI_LEADING_GB_CMP_CNT_preamble_cmp_cnt_by_frame(data)       (0x0000FFFF&(data))
+#define HDMI_LEADING_GB_CMP_CNT_get_preamble_cmp_cnt(data)            ((0xFFFF0000&(data))>>16)
+#define HDMI_LEADING_GB_CMP_CNT_get_preamble_cmp_cnt_by_frame(data)   (0x0000FFFF&(data))
+
+
+#define AUDIO_CTS_UP_BOUND                                            0x1800f14c
+#define AUDIO_CTS_UP_BOUND_reg_addr                                   "0xb800f14c"
+#define AUDIO_CTS_UP_BOUND_reg                                        0xb800f14c
+#define AUDIO_CTS_UP_BOUND_inst_addr                                  "0x0053"
+#define AUDIO_CTS_UP_BOUND_inst                                       0x0053
+#define AUDIO_CTS_UP_BOUND_cts_over_flag_shift                        (31)
+#define AUDIO_CTS_UP_BOUND_cts_clip_en_shift                          (20)
+#define AUDIO_CTS_UP_BOUND_cts_up_bound_shift                         (0)
+#define AUDIO_CTS_UP_BOUND_cts_over_flag_mask                         (0x80000000)
+#define AUDIO_CTS_UP_BOUND_cts_clip_en_mask                           (0x00100000)
+#define AUDIO_CTS_UP_BOUND_cts_up_bound_mask                          (0x000FFFFF)
+#define AUDIO_CTS_UP_BOUND_cts_over_flag(data)                        (0x80000000&((data)<<31))
+#define AUDIO_CTS_UP_BOUND_cts_clip_en(data)                          (0x00100000&((data)<<20))
+#define AUDIO_CTS_UP_BOUND_cts_up_bound(data)                         (0x000FFFFF&(data))
+#define AUDIO_CTS_UP_BOUND_get_cts_over_flag(data)                    ((0x80000000&(data))>>31)
+#define AUDIO_CTS_UP_BOUND_get_cts_clip_en(data)                      ((0x00100000&(data))>>20)
+#define AUDIO_CTS_UP_BOUND_get_cts_up_bound(data)                     (0x000FFFFF&(data))
+
+
+#define AUDIO_CTS_LOW_BOUND                                           0x1800f150
+#define AUDIO_CTS_LOW_BOUND_reg_addr                                  "0xb800f150"
+#define AUDIO_CTS_LOW_BOUND_reg                                       0xb800f150
+#define AUDIO_CTS_LOW_BOUND_inst_addr                                 "0x0054"
+#define AUDIO_CTS_LOW_BOUND_inst                                      0x0054
+#define AUDIO_CTS_LOW_BOUND_cts_under_flag_shift                      (31)
+#define AUDIO_CTS_LOW_BOUND_cts_low_bound_shift                       (0)
+#define AUDIO_CTS_LOW_BOUND_cts_under_flag_mask                       (0x80000000)
+#define AUDIO_CTS_LOW_BOUND_cts_low_bound_mask                        (0x000FFFFF)
+#define AUDIO_CTS_LOW_BOUND_cts_under_flag(data)                      (0x80000000&((data)<<31))
+#define AUDIO_CTS_LOW_BOUND_cts_low_bound(data)                       (0x000FFFFF&(data))
+#define AUDIO_CTS_LOW_BOUND_get_cts_under_flag(data)                  ((0x80000000&(data))>>31)
+#define AUDIO_CTS_LOW_BOUND_get_cts_low_bound(data)                   (0x000FFFFF&(data))
+
+
+#define AUDIO_N_UP_BOUND                                              0x1800f154
+#define AUDIO_N_UP_BOUND_reg_addr                                     "0xb800f154"
+#define AUDIO_N_UP_BOUND_reg                                          0xb800f154
+#define AUDIO_N_UP_BOUND_inst_addr                                    "0x0055"
+#define AUDIO_N_UP_BOUND_inst                                         0x0055
+#define AUDIO_N_UP_BOUND_n_over_flag_shift                            (31)
+#define AUDIO_N_UP_BOUND_n_clip_en_shift                              (20)
+#define AUDIO_N_UP_BOUND_n_up_bound_shift                             (0)
+#define AUDIO_N_UP_BOUND_n_over_flag_mask                             (0x80000000)
+#define AUDIO_N_UP_BOUND_n_clip_en_mask                               (0x00100000)
+#define AUDIO_N_UP_BOUND_n_up_bound_mask                              (0x000FFFFF)
+#define AUDIO_N_UP_BOUND_n_over_flag(data)                            (0x80000000&((data)<<31))
+#define AUDIO_N_UP_BOUND_n_clip_en(data)                              (0x00100000&((data)<<20))
+#define AUDIO_N_UP_BOUND_n_up_bound(data)                             (0x000FFFFF&(data))
+#define AUDIO_N_UP_BOUND_get_n_over_flag(data)                        ((0x80000000&(data))>>31)
+#define AUDIO_N_UP_BOUND_get_n_clip_en(data)                          ((0x00100000&(data))>>20)
+#define AUDIO_N_UP_BOUND_get_n_up_bound(data)                         (0x000FFFFF&(data))
+
+
+#define AUDIO_N_LOW_BOUND                                             0x1800f158
+#define AUDIO_N_LOW_BOUND_reg_addr                                    "0xb800f158"
+#define AUDIO_N_LOW_BOUND_reg                                         0xb800f158
+#define AUDIO_N_LOW_BOUND_inst_addr                                   "0x0056"
+#define AUDIO_N_LOW_BOUND_inst                                        0x0056
+#define AUDIO_N_LOW_BOUND_n_under_flag_shift                          (31)
+#define AUDIO_N_LOW_BOUND_n_low_bound_shift                           (0)
+#define AUDIO_N_LOW_BOUND_n_under_flag_mask                           (0x80000000)
+#define AUDIO_N_LOW_BOUND_n_low_bound_mask                            (0x000FFFFF)
+#define AUDIO_N_LOW_BOUND_n_under_flag(data)                          (0x80000000&((data)<<31))
+#define AUDIO_N_LOW_BOUND_n_low_bound(data)                           (0x000FFFFF&(data))
+#define AUDIO_N_LOW_BOUND_get_n_under_flag(data)                      ((0x80000000&(data))>>31)
+#define AUDIO_N_LOW_BOUND_get_n_low_bound(data)                       (0x000FFFFF&(data))
+
+
+#define MHL_HDMI_MAC_CTRL                                             0x1800f15c
+#define MHL_HDMI_MAC_CTRL_reg_addr                                    "0xb800f15c"
+#define MHL_HDMI_MAC_CTRL_reg                                         0xb800f15c
+#define MHL_HDMI_MAC_CTRL_inst_addr                                   "0x0057"
+#define MHL_HDMI_MAC_CTRL_inst                                        0x0057
+#define MHL_HDMI_MAC_CTRL_pp_mode_output_shift                        (12)
+#define MHL_HDMI_MAC_CTRL_packet_mhl_en_shift                         (8)
+#define MHL_HDMI_MAC_CTRL_xor_pixel_sel_shift                         (5)
+#define MHL_HDMI_MAC_CTRL_cal_pixel_sel_shift                         (4)
+#define MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_shift                     (0)
+#define MHL_HDMI_MAC_CTRL_pp_mode_output_mask                         (0x00001000)
+#define MHL_HDMI_MAC_CTRL_packet_mhl_en_mask                          (0x00000100)
+#define MHL_HDMI_MAC_CTRL_xor_pixel_sel_mask                          (0x000000E0)
+#define MHL_HDMI_MAC_CTRL_cal_pixel_sel_mask                          (0x00000010)
+#define MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_mask                      (0x00000001)
+#define MHL_HDMI_MAC_CTRL_pp_mode_output(data)                        (0x00001000&((data)<<12))
+#define MHL_HDMI_MAC_CTRL_packet_mhl_en(data)                         (0x00000100&((data)<<8))
+#define MHL_HDMI_MAC_CTRL_xor_pixel_sel(data)                         (0x000000E0&((data)<<5))
+#define MHL_HDMI_MAC_CTRL_cal_pixel_sel(data)                         (0x00000010&((data)<<4))
+#define MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en(data)                     (0x00000001&(data))
+#define MHL_HDMI_MAC_CTRL_get_pp_mode_output(data)                    ((0x00001000&(data))>>12)
+#define MHL_HDMI_MAC_CTRL_get_packet_mhl_en(data)                     ((0x00000100&(data))>>8)
+#define MHL_HDMI_MAC_CTRL_get_xor_pixel_sel(data)                     ((0x000000E0&(data))>>5)
+#define MHL_HDMI_MAC_CTRL_get_cal_pixel_sel(data)                     ((0x00000010&(data))>>4)
+#define MHL_HDMI_MAC_CTRL_get_ch_dec_pp_mode_en(data)                 (0x00000001&(data))
+
+
+#define MHL_3D_FORMAT                                                 0x1800f160
+#define MHL_3D_FORMAT_reg_addr                                        "0xb800f160"
+#define MHL_3D_FORMAT_reg                                             0xb800f160
+#define MHL_3D_FORMAT_inst_addr                                       "0x0058"
+#define MHL_3D_FORMAT_inst                                            0x0058
+#define MHL_3D_FORMAT_mhl_3d_fmt_shift                                (26)
+#define MHL_3D_FORMAT_mhl_vid_shift                                   (24)
+#define MHL_3D_FORMAT_oui_shift                                       (0)
+#define MHL_3D_FORMAT_mhl_3d_fmt_mask                                 (0x3C000000)
+#define MHL_3D_FORMAT_mhl_vid_mask                                    (0x03000000)
+#define MHL_3D_FORMAT_oui_mask                                        (0x00FFFFFF)
+#define MHL_3D_FORMAT_mhl_3d_fmt(data)                                (0x3C000000&((data)<<26))
+#define MHL_3D_FORMAT_mhl_vid(data)                                   (0x03000000&((data)<<24))
+#define MHL_3D_FORMAT_oui(data)                                       (0x00FFFFFF&(data))
+#define MHL_3D_FORMAT_get_mhl_3d_fmt(data)                            ((0x3C000000&(data))>>26)
+#define MHL_3D_FORMAT_get_mhl_vid(data)                               ((0x03000000&(data))>>24)
+#define MHL_3D_FORMAT_get_oui(data)                                   (0x00FFFFFF&(data))
+
+
+#define LIGHT_SLEEP                                                   0x1800f170
+#define LIGHT_SLEEP_reg_addr                                          "0xb800f170"
+#define LIGHT_SLEEP_reg                                               0xb800f170
+#define LIGHT_SLEEP_inst_addr                                         "0x005C"
+#define LIGHT_SLEEP_inst                                              0x005C
+#define LIGHT_SLEEP_hdcp_ls_shift                                     (1)
+#define LIGHT_SLEEP_audio_ls_shift                                    (0)
+#define LIGHT_SLEEP_hdcp_ls_mask                                      (0x00000002)
+#define LIGHT_SLEEP_audio_ls_mask                                     (0x00000001)
+#define LIGHT_SLEEP_hdcp_ls(data)                                     (0x00000002&((data)<<1))
+#define LIGHT_SLEEP_audio_ls(data)                                    (0x00000001&(data))
+#define LIGHT_SLEEP_get_hdcp_ls(data)                                 ((0x00000002&(data))>>1)
+#define LIGHT_SLEEP_get_audio_ls(data)                                (0x00000001&(data))
+
+
+#define DEEP_SLEEP                                                    0x1800f174
+#define DEEP_SLEEP_reg_addr                                           "0xb800f174"
+#define DEEP_SLEEP_reg                                                0xb800f174
+#define DEEP_SLEEP_inst_addr                                          "0x005D"
+#define DEEP_SLEEP_inst                                               0x005D
+#define DEEP_SLEEP_hdcp_ds_shift                                      (1)
+#define DEEP_SLEEP_audio_ds_shift                                     (0)
+#define DEEP_SLEEP_hdcp_ds_mask                                       (0x00000002)
+#define DEEP_SLEEP_audio_ds_mask                                      (0x00000001)
+#define DEEP_SLEEP_hdcp_ds(data)                                      (0x00000002&((data)<<1))
+#define DEEP_SLEEP_audio_ds(data)                                     (0x00000001&(data))
+#define DEEP_SLEEP_get_hdcp_ds(data)                                  ((0x00000002&(data))>>1)
+#define DEEP_SLEEP_get_audio_ds(data)                                 (0x00000001&(data))
+
+
+#define SHOT_DOWN                                                     0x1800f178
+#define SHOT_DOWN_reg_addr                                            "0xb800f178"
+#define SHOT_DOWN_reg                                                 0xb800f178
+#define SHOT_DOWN_inst_addr                                           "0x005E"
+#define SHOT_DOWN_inst                                                0x005E
+#define SHOT_DOWN_hdcp_sd_shift                                       (1)
+#define SHOT_DOWN_audio_sd_shift                                      (0)
+#define SHOT_DOWN_hdcp_sd_mask                                        (0x00000002)
+#define SHOT_DOWN_audio_sd_mask                                       (0x00000001)
+#define SHOT_DOWN_hdcp_sd(data)                                       (0x00000002&((data)<<1))
+#define SHOT_DOWN_audio_sd(data)                                      (0x00000001&(data))
+#define SHOT_DOWN_get_hdcp_sd(data)                                   ((0x00000002&(data))>>1)
+#define SHOT_DOWN_get_audio_sd(data)                                  (0x00000001&(data))
+
+
+#define READ_MARGIN_ENABLE                                            0x1800f17c
+#define READ_MARGIN_ENABLE_reg_addr                                   "0xb800f17c"
+#define READ_MARGIN_ENABLE_reg                                        0xb800f17c
+#define READ_MARGIN_ENABLE_inst_addr                                  "0x005F"
+#define READ_MARGIN_ENABLE_inst                                       0x005F
+#define READ_MARGIN_ENABLE_hdcp_rme_shift                             (1)
+#define READ_MARGIN_ENABLE_audio_rme_shift                            (0)
+#define READ_MARGIN_ENABLE_hdcp_rme_mask                              (0x00000002)
+#define READ_MARGIN_ENABLE_audio_rme_mask                             (0x00000001)
+#define READ_MARGIN_ENABLE_hdcp_rme(data)                             (0x00000002&((data)<<1))
+#define READ_MARGIN_ENABLE_audio_rme(data)                            (0x00000001&(data))
+#define READ_MARGIN_ENABLE_get_hdcp_rme(data)                         ((0x00000002&(data))>>1)
+#define READ_MARGIN_ENABLE_get_audio_rme(data)                        (0x00000001&(data))
+
+
+#define READ_MARGIN                                                   0x1800f180
+#define READ_MARGIN_reg_addr                                          "0xb800f180"
+#define READ_MARGIN_reg                                               0xb800f180
+#define READ_MARGIN_inst_addr                                         "0x0060"
+#define READ_MARGIN_inst                                              0x0060
+#define READ_MARGIN_hdcp_rm_shift                                     (4)
+#define READ_MARGIN_audio_rm_shift                                    (0)
+#define READ_MARGIN_hdcp_rm_mask                                      (0x000000F0)
+#define READ_MARGIN_audio_rm_mask                                     (0x0000000F)
+#define READ_MARGIN_hdcp_rm(data)                                     (0x000000F0&((data)<<4))
+#define READ_MARGIN_audio_rm(data)                                    (0x0000000F&(data))
+#define READ_MARGIN_get_hdcp_rm(data)                                 ((0x000000F0&(data))>>4)
+#define READ_MARGIN_get_audio_rm(data)                                (0x0000000F&(data))
+
+
+#define BIST_MODE                                                     0x1800f184
+#define BIST_MODE_reg_addr                                            "0xb800f184"
+#define BIST_MODE_reg                                                 0xb800f184
+#define BIST_MODE_inst_addr                                           "0x0061"
+#define BIST_MODE_inst                                                0x0061
+#define BIST_MODE_hdcp_bist_en_shift                                  (1)
+#define BIST_MODE_audio_bist_en_shift                                 (0)
+#define BIST_MODE_hdcp_bist_en_mask                                   (0x00000002)
+#define BIST_MODE_audio_bist_en_mask                                  (0x00000001)
+#define BIST_MODE_hdcp_bist_en(data)                                  (0x00000002&((data)<<1))
+#define BIST_MODE_audio_bist_en(data)                                 (0x00000001&(data))
+#define BIST_MODE_get_hdcp_bist_en(data)                              ((0x00000002&(data))>>1)
+#define BIST_MODE_get_audio_bist_en(data)                             (0x00000001&(data))
+
+
+#define BIST_DONE                                                     0x1800f188
+#define BIST_DONE_reg_addr                                            "0xb800f188"
+#define BIST_DONE_reg                                                 0xb800f188
+#define BIST_DONE_inst_addr                                           "0x0062"
+#define BIST_DONE_inst                                                0x0062
+#define BIST_DONE_hdcp_bist_done_shift                                (1)
+#define BIST_DONE_audio_bist_done_shift                               (0)
+#define BIST_DONE_hdcp_bist_done_mask                                 (0x00000002)
+#define BIST_DONE_audio_bist_done_mask                                (0x00000001)
+#define BIST_DONE_hdcp_bist_done(data)                                (0x00000002&((data)<<1))
+#define BIST_DONE_audio_bist_done(data)                               (0x00000001&(data))
+#define BIST_DONE_get_hdcp_bist_done(data)                            ((0x00000002&(data))>>1)
+#define BIST_DONE_get_audio_bist_done(data)                           (0x00000001&(data))
+
+
+#define BIST_FAIL                                                     0x1800f18c
+#define BIST_FAIL_reg_addr                                            "0xb800f18c"
+#define BIST_FAIL_reg                                                 0xb800f18c
+#define BIST_FAIL_inst_addr                                           "0x0063"
+#define BIST_FAIL_inst                                                0x0063
+#define BIST_FAIL_hdcp_bist_fail_shift                                (1)
+#define BIST_FAIL_audio_bist_fail_shift                               (0)
+#define BIST_FAIL_hdcp_bist_fail_mask                                 (0x00000002)
+#define BIST_FAIL_audio_bist_fail_mask                                (0x00000001)
+#define BIST_FAIL_hdcp_bist_fail(data)                                (0x00000002&((data)<<1))
+#define BIST_FAIL_audio_bist_fail(data)                               (0x00000001&(data))
+#define BIST_FAIL_get_hdcp_bist_fail(data)                            ((0x00000002&(data))>>1)
+#define BIST_FAIL_get_audio_bist_fail(data)                           (0x00000001&(data))
+
+
+#define DRF_MODE                                                      0x1800f190
+#define DRF_MODE_reg_addr                                             "0xb800f190"
+#define DRF_MODE_reg                                                  0xb800f190
+#define DRF_MODE_inst_addr                                            "0x0064"
+#define DRF_MODE_inst                                                 0x0064
+#define DRF_MODE_hdcp_drf_mode_shift                                  (1)
+#define DRF_MODE_audio_drf_mode_shift                                 (0)
+#define DRF_MODE_hdcp_drf_mode_mask                                   (0x00000002)
+#define DRF_MODE_audio_drf_mode_mask                                  (0x00000001)
+#define DRF_MODE_hdcp_drf_mode(data)                                  (0x00000002&((data)<<1))
+#define DRF_MODE_audio_drf_mode(data)                                 (0x00000001&(data))
+#define DRF_MODE_get_hdcp_drf_mode(data)                              ((0x00000002&(data))>>1)
+#define DRF_MODE_get_audio_drf_mode(data)                             (0x00000001&(data))
+
+
+#define DRF_RESUME                                                    0x1800f194
+#define DRF_RESUME_reg_addr                                           "0xb800f194"
+#define DRF_RESUME_reg                                                0xb800f194
+#define DRF_RESUME_inst_addr                                          "0x0065"
+#define DRF_RESUME_inst                                               0x0065
+#define DRF_RESUME_hdcp_drf_resume_shift                              (1)
+#define DRF_RESUME_audio_drf_resume_shift                             (0)
+#define DRF_RESUME_hdcp_drf_resume_mask                               (0x00000002)
+#define DRF_RESUME_audio_drf_resume_mask                              (0x00000001)
+#define DRF_RESUME_hdcp_drf_resume(data)                              (0x00000002&((data)<<1))
+#define DRF_RESUME_audio_drf_resume(data)                             (0x00000001&(data))
+#define DRF_RESUME_get_hdcp_drf_resume(data)                          ((0x00000002&(data))>>1)
+#define DRF_RESUME_get_audio_drf_resume(data)                         (0x00000001&(data))
+
+
+#define DRF_DONE                                                      0x1800f198
+#define DRF_DONE_reg_addr                                             "0xb800f198"
+#define DRF_DONE_reg                                                  0xb800f198
+#define DRF_DONE_inst_addr                                            "0x0066"
+#define DRF_DONE_inst                                                 0x0066
+#define DRF_DONE_hdcp_drf_done_shift                                  (1)
+#define DRF_DONE_audio_drf_done_shift                                 (0)
+#define DRF_DONE_hdcp_drf_done_mask                                   (0x00000002)
+#define DRF_DONE_audio_drf_done_mask                                  (0x00000001)
+#define DRF_DONE_hdcp_drf_done(data)                                  (0x00000002&((data)<<1))
+#define DRF_DONE_audio_drf_done(data)                                 (0x00000001&(data))
+#define DRF_DONE_get_hdcp_drf_done(data)                              ((0x00000002&(data))>>1)
+#define DRF_DONE_get_audio_drf_done(data)                             (0x00000001&(data))
+
+
+#define DRF_PAUSE                                                     0x1800f19c
+#define DRF_PAUSE_reg_addr                                            "0xb800f19c"
+#define DRF_PAUSE_reg                                                 0xb800f19c
+#define DRF_PAUSE_inst_addr                                           "0x0067"
+#define DRF_PAUSE_inst                                                0x0067
+#define DRF_PAUSE_hdcp_drf_pause_shift                                (1)
+#define DRF_PAUSE_audio_drf_pause_shift                               (0)
+#define DRF_PAUSE_hdcp_drf_pause_mask                                 (0x00000002)
+#define DRF_PAUSE_audio_drf_pause_mask                                (0x00000001)
+#define DRF_PAUSE_hdcp_drf_pause(data)                                (0x00000002&((data)<<1))
+#define DRF_PAUSE_audio_drf_pause(data)                               (0x00000001&(data))
+#define DRF_PAUSE_get_hdcp_drf_pause(data)                            ((0x00000002&(data))>>1)
+#define DRF_PAUSE_get_audio_drf_pause(data)                           (0x00000001&(data))
+
+
+#define DRF_FAIL                                                      0x1800f1a0
+#define DRF_FAIL_reg_addr                                             "0xb800f1a0"
+#define DRF_FAIL_reg                                                  0xb800f1a0
+#define DRF_FAIL_inst_addr                                            "0x0068"
+#define DRF_FAIL_inst                                                 0x0068
+#define DRF_FAIL_hdcp_drf_fail_shift                                  (1)
+#define DRF_FAIL_audio_drf_fail_shift                                 (0)
+#define DRF_FAIL_hdcp_drf_fail_mask                                   (0x00000002)
+#define DRF_FAIL_audio_drf_fail_mask                                  (0x00000001)
+#define DRF_FAIL_hdcp_drf_fail(data)                                  (0x00000002&((data)<<1))
+#define DRF_FAIL_audio_drf_fail(data)                                 (0x00000001&(data))
+#define DRF_FAIL_get_hdcp_drf_fail(data)                              ((0x00000002&(data))>>1)
+#define DRF_FAIL_get_audio_drf_fail(data)                             (0x00000001&(data))
+
+
+#define DVS                                                           0x1800f1a4
+#define DVS_reg_addr                                                  "0xb800f1a4"
+#define DVS_reg                                                       0xb800f1a4
+#define DVS_inst_addr                                                 "0x0069"
+#define DVS_inst                                                      0x0069
+#define DVS_hdcp_dvs_shift                                            (4)
+#define DVS_audio_dvs_shift                                           (0)
+#define DVS_hdcp_dvs_mask                                             (0x000000F0)
+#define DVS_audio_dvs_mask                                            (0x0000000F)
+#define DVS_hdcp_dvs(data)                                            (0x000000F0&((data)<<4))
+#define DVS_audio_dvs(data)                                           (0x0000000F&(data))
+#define DVS_get_hdcp_dvs(data)                                        ((0x000000F0&(data))>>4)
+#define DVS_get_audio_dvs(data)                                       (0x0000000F&(data))
+
+
+#define DVSE                                                          0x1800f1a8
+#define DVSE_reg_addr                                                 "0xb800f1a8"
+#define DVSE_reg                                                      0xb800f1a8
+#define DVSE_inst_addr                                                "0x006A"
+#define DVSE_inst                                                     0x006A
+#define DVSE_hdcp_dvse_shift                                          (1)
+#define DVSE_audio_dvse_shift                                         (0)
+#define DVSE_hdcp_dvse_mask                                           (0x00000002)
+#define DVSE_audio_dvse_mask                                          (0x00000001)
+#define DVSE_hdcp_dvse(data)                                          (0x00000002&((data)<<1))
+#define DVSE_audio_dvse(data)                                         (0x00000001&(data))
+#define DVSE_get_hdcp_dvse(data)                                      ((0x00000002&(data))>>1)
+#define DVSE_get_audio_dvse(data)                                     (0x00000001&(data))
+
+
+#define CTS_FIFO_CTL                                                  0x1800f1ac
+#define CTS_FIFO_CTL_reg_addr                                         "0xb800f1ac"
+#define CTS_FIFO_CTL_reg                                              0xb800f1ac
+#define CTS_FIFO_CTL_inst_addr                                        "0x006B"
+#define CTS_FIFO_CTL_inst                                             0x006B
+#define CTS_FIFO_CTL_hdmi_test_sel_shift                              (4)
+#define CTS_FIFO_CTL_hdmi_out_sel_shift                               (3)
+#define CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi_shift                    (2)
+#define CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi_shift                      (1)
+#define CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi_shift                     (0)
+#define CTS_FIFO_CTL_hdmi_test_sel_mask                               (0x00000070)
+#define CTS_FIFO_CTL_hdmi_out_sel_mask                                (0x00000008)
+#define CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi_mask                     (0x00000004)
+#define CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi_mask                       (0x00000002)
+#define CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi_mask                      (0x00000001)
+#define CTS_FIFO_CTL_hdmi_test_sel(data)                              (0x00000070&((data)<<4))
+#define CTS_FIFO_CTL_hdmi_out_sel(data)                               (0x00000008&((data)<<3))
+#define CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi(data)                    (0x00000004&((data)<<2))
+#define CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi(data)                      (0x00000002&((data)<<1))
+#define CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi(data)                     (0x00000001&(data))
+#define CTS_FIFO_CTL_get_hdmi_test_sel(data)                          ((0x00000070&(data))>>4)
+#define CTS_FIFO_CTL_get_hdmi_out_sel(data)                           ((0x00000008&(data))>>3)
+#define CTS_FIFO_CTL_get_force_ctsfifo_rstn_hdmi(data)                ((0x00000004&(data))>>2)
+#define CTS_FIFO_CTL_get_en_ctsfifo_vsrst_hdmi(data)                  ((0x00000002&(data))>>1)
+#define CTS_FIFO_CTL_get_en_ctsfifo_bypass_hdmi(data)                 (0x00000001&(data))
+
+
+#define CBUS_CLK_CTL                                                  0x1800f1b0
+#define CBUS_CLK_CTL_reg_addr                                         "0xb800f1b0"
+#define CBUS_CLK_CTL_reg                                              0xb800f1b0
+#define CBUS_CLK_CTL_inst_addr                                        "0x006C"
+#define CBUS_CLK_CTL_inst                                             0x006C
+#define CBUS_CLK_CTL_sys_clk_div_shift                                (4)
+#define CBUS_CLK_CTL_cbus_core_pwdn_shift                             (1)
+#define CBUS_CLK_CTL_sys_clk_en_shift                                 (0)
+#define CBUS_CLK_CTL_sys_clk_div_mask                                 (0x00000070)
+#define CBUS_CLK_CTL_cbus_core_pwdn_mask                              (0x00000002)
+#define CBUS_CLK_CTL_sys_clk_en_mask                                  (0x00000001)
+#define CBUS_CLK_CTL_sys_clk_div(data)                                (0x00000070&((data)<<4))
+#define CBUS_CLK_CTL_cbus_core_pwdn(data)                             (0x00000002&((data)<<1))
+#define CBUS_CLK_CTL_sys_clk_en(data)                                 (0x00000001&(data))
+#define CBUS_CLK_CTL_get_sys_clk_div(data)                            ((0x00000070&(data))>>4)
+#define CBUS_CLK_CTL_get_cbus_core_pwdn(data)                         ((0x00000002&(data))>>1)
+#define CBUS_CLK_CTL_get_sys_clk_en(data)                             (0x00000001&(data))
+
+
+#define HDCP_BIST                                                     0x1800f200
+#define HDCP_BIST_reg_addr                                            "0xb800f200"
+#define HDCP_BIST_reg                                                 0xb800f200
+#define HDCP_BIST_inst_addr                                           "0x0080"
+#define HDCP_BIST_inst                                                0x0080
+
+
+#define HDCP_CR                                                       0x1800f204
+#define HDCP_CR_reg_addr                                              "0xb800f204"
+#define HDCP_CR_reg                                                   0xb800f204
+#define HDCP_CR_inst_addr                                             "0x0081"
+#define HDCP_CR_inst                                                  0x0081
+#define HDCP_CR_namfe_shift                                           (7)
+#define HDCP_CR_dummy1800f204_6_shift                                 (6)
+#define HDCP_CR_ivsp_shift                                            (5)
+#define HDCP_CR_invvs_shift                                           (4)
+#define HDCP_CR_ivspm_shift                                           (3)
+#define HDCP_CR_maddf_shift                                           (2)
+#define HDCP_CR_dkapde_shift                                          (1)
+#define HDCP_CR_hdcp_en_shift                                         (0)
+#define HDCP_CR_namfe_mask                                            (0x00000080)
+#define HDCP_CR_dummy1800f204_6_mask                                  (0x00000040)
+#define HDCP_CR_ivsp_mask                                             (0x00000020)
+#define HDCP_CR_invvs_mask                                            (0x00000010)
+#define HDCP_CR_ivspm_mask                                            (0x00000008)
+#define HDCP_CR_maddf_mask                                            (0x00000004)
+#define HDCP_CR_dkapde_mask                                           (0x00000002)
+#define HDCP_CR_hdcp_en_mask                                          (0x00000001)
+#define HDCP_CR_namfe(data)                                           (0x00000080&((data)<<7))
+#define HDCP_CR_dummy1800f204_6(data)                                 (0x00000040&((data)<<6))
+#define HDCP_CR_ivsp(data)                                            (0x00000020&((data)<<5))
+#define HDCP_CR_invvs(data)                                           (0x00000010&((data)<<4))
+#define HDCP_CR_ivspm(data)                                           (0x00000008&((data)<<3))
+#define HDCP_CR_maddf(data)                                           (0x00000004&((data)<<2))
+#define HDCP_CR_dkapde(data)                                          (0x00000002&((data)<<1))
+#define HDCP_CR_hdcp_en(data)                                         (0x00000001&(data))
+#define HDCP_CR_get_namfe(data)                                       ((0x00000080&(data))>>7)
+#define HDCP_CR_get_dummy1800f204_6(data)                             ((0x00000040&(data))>>6)
+#define HDCP_CR_get_ivsp(data)                                        ((0x00000020&(data))>>5)
+#define HDCP_CR_get_invvs(data)                                       ((0x00000010&(data))>>4)
+#define HDCP_CR_get_ivspm(data)                                       ((0x00000008&(data))>>3)
+#define HDCP_CR_get_maddf(data)                                       ((0x00000004&(data))>>2)
+#define HDCP_CR_get_dkapde(data)                                      ((0x00000002&(data))>>1)
+#define HDCP_CR_get_hdcp_en(data)                                     (0x00000001&(data))
+
+
+#define HDCP_DKAP                                                     0x1800f208
+#define HDCP_DKAP_reg_addr                                            "0xb800f208"
+#define HDCP_DKAP_reg                                                 0xb800f208
+#define HDCP_DKAP_inst_addr                                           "0x0082"
+#define HDCP_DKAP_inst                                                0x0082
+#define HDCP_DKAP_dkap_shift                                          (0)
+#define HDCP_DKAP_dkap_mask                                           (0x000000FF)
+#define HDCP_DKAP_dkap(data)                                          (0x000000FF&(data))
+#define HDCP_DKAP_get_dkap(data)                                      (0x000000FF&(data))
+
+
+#define HDCP_PCR                                                      0x1800f20c
+#define HDCP_PCR_reg_addr                                             "0xb800f20c"
+#define HDCP_PCR_reg                                                  0xb800f20c
+#define HDCP_PCR_inst_addr                                            "0x0083"
+#define HDCP_PCR_inst                                                 0x0083
+#define HDCP_PCR_i2c_scl_dly_sel_shift                                (24)
+#define HDCP_PCR_i2c_sda_dly_sel_shift                                (20)
+#define HDCP_PCR_tune_up_down_shift                                   (17)
+#define HDCP_PCR_tune_range_shift                                     (10)
+#define HDCP_PCR_ddcdbnc_shift                                        (9)
+#define HDCP_PCR_dummy1800f20c_8_shift                                (8)
+#define HDCP_PCR_dbnc_level_sel_shift                                 (7)
+#define HDCP_PCR_km_clk_sel_shift                                     (6)
+#define HDCP_PCR_hdcp_vs_sel_shift                                    (5)
+#define HDCP_PCR_enc_tog_shift                                        (4)
+#define HDCP_PCR_avmute_dis_shift                                     (3)
+#define HDCP_PCR_dummy1800f20c_2_1_shift                              (1)
+#define HDCP_PCR_apai_shift                                           (0)
+#define HDCP_PCR_i2c_scl_dly_sel_mask                                 (0x0F000000)
+#define HDCP_PCR_i2c_sda_dly_sel_mask                                 (0x00F00000)
+#define HDCP_PCR_tune_up_down_mask                                    (0x00020000)
+#define HDCP_PCR_tune_range_mask                                      (0x0001FC00)
+#define HDCP_PCR_ddcdbnc_mask                                         (0x00000200)
+#define HDCP_PCR_dummy1800f20c_8_mask                                 (0x00000100)
+#define HDCP_PCR_dbnc_level_sel_mask                                  (0x00000080)
+#define HDCP_PCR_km_clk_sel_mask                                      (0x00000040)
+#define HDCP_PCR_hdcp_vs_sel_mask                                     (0x00000020)
+#define HDCP_PCR_enc_tog_mask                                         (0x00000010)
+#define HDCP_PCR_avmute_dis_mask                                      (0x00000008)
+#define HDCP_PCR_dummy1800f20c_2_1_mask                               (0x00000006)
+#define HDCP_PCR_apai_mask                                            (0x00000001)
+#define HDCP_PCR_i2c_scl_dly_sel(data)                                (0x0F000000&((data)<<24))
+#define HDCP_PCR_i2c_sda_dly_sel(data)                                (0x00F00000&((data)<<20))
+#define HDCP_PCR_tune_up_down(data)                                   (0x00020000&((data)<<17))
+#define HDCP_PCR_tune_range(data)                                     (0x0001FC00&((data)<<10))
+#define HDCP_PCR_ddcdbnc(data)                                        (0x00000200&((data)<<9))
+#define HDCP_PCR_dummy1800f20c_8(data)                                (0x00000100&((data)<<8))
+#define HDCP_PCR_dbnc_level_sel(data)                                 (0x00000080&((data)<<7))
+#define HDCP_PCR_km_clk_sel(data)                                     (0x00000040&((data)<<6))
+#define HDCP_PCR_hdcp_vs_sel(data)                                    (0x00000020&((data)<<5))
+#define HDCP_PCR_enc_tog(data)                                        (0x00000010&((data)<<4))
+#define HDCP_PCR_avmute_dis(data)                                     (0x00000008&((data)<<3))
+#define HDCP_PCR_dummy1800f20c_2_1(data)                              (0x00000006&((data)<<1))
+#define HDCP_PCR_apai(data)                                           (0x00000001&(data))
+#define HDCP_PCR_get_i2c_scl_dly_sel(data)                            ((0x0F000000&(data))>>24)
+#define HDCP_PCR_get_i2c_sda_dly_sel(data)                            ((0x00F00000&(data))>>20)
+#define HDCP_PCR_get_tune_up_down(data)                               ((0x00020000&(data))>>17)
+#define HDCP_PCR_get_tune_range(data)                                 ((0x0001FC00&(data))>>10)
+#define HDCP_PCR_get_ddcdbnc(data)                                    ((0x00000200&(data))>>9)
+#define HDCP_PCR_get_dummy1800f20c_8(data)                            ((0x00000100&(data))>>8)
+#define HDCP_PCR_get_dbnc_level_sel(data)                             ((0x00000080&(data))>>7)
+#define HDCP_PCR_get_km_clk_sel(data)                                 ((0x00000040&(data))>>6)
+#define HDCP_PCR_get_hdcp_vs_sel(data)                                ((0x00000020&(data))>>5)
+#define HDCP_PCR_get_enc_tog(data)                                    ((0x00000010&(data))>>4)
+#define HDCP_PCR_get_avmute_dis(data)                                 ((0x00000008&(data))>>3)
+#define HDCP_PCR_get_dummy1800f20c_2_1(data)                          ((0x00000006&(data))>>1)
+#define HDCP_PCR_get_apai(data)                                       (0x00000001&(data))
+
+
+#define HDCP_FLAG1                                                    0x1800f210
+#define HDCP_FLAG1_reg_addr                                           "0xb800f210"
+#define HDCP_FLAG1_reg                                                0xb800f210
+#define HDCP_FLAG1_inst_addr                                          "0x0084"
+#define HDCP_FLAG1_inst                                               0x0084
+#define HDCP_FLAG1_wr_aksv_flag_shift                                 (4)
+#define HDCP_FLAG1_rd_ri_flag_shift                                   (3)
+#define HDCP_FLAG1_rd_bksv_flag_shift                                 (2)
+#define HDCP_FLAG1_dummy1800f210_1_0_shift                            (0)
+#define HDCP_FLAG1_wr_aksv_flag_mask                                  (0x00000010)
+#define HDCP_FLAG1_rd_ri_flag_mask                                    (0x00000008)
+#define HDCP_FLAG1_rd_bksv_flag_mask                                  (0x00000004)
+#define HDCP_FLAG1_dummy1800f210_1_0_mask                             (0x00000003)
+#define HDCP_FLAG1_wr_aksv_flag(data)                                 (0x00000010&((data)<<4))
+#define HDCP_FLAG1_rd_ri_flag(data)                                   (0x00000008&((data)<<3))
+#define HDCP_FLAG1_rd_bksv_flag(data)                                 (0x00000004&((data)<<2))
+#define HDCP_FLAG1_dummy1800f210_1_0(data)                            (0x00000003&(data))
+#define HDCP_FLAG1_get_wr_aksv_flag(data)                             ((0x00000010&(data))>>4)
+#define HDCP_FLAG1_get_rd_ri_flag(data)                               ((0x00000008&(data))>>3)
+#define HDCP_FLAG1_get_rd_bksv_flag(data)                             ((0x00000004&(data))>>2)
+#define HDCP_FLAG1_get_dummy1800f210_1_0(data)                        (0x00000003&(data))
+
+
+#define HDCP_FLAG2                                                    0x1800f214
+#define HDCP_FLAG2_reg_addr                                           "0xb800f214"
+#define HDCP_FLAG2_reg                                                0xb800f214
+#define HDCP_FLAG2_inst_addr                                          "0x0085"
+#define HDCP_FLAG2_inst                                               0x0085
+#define HDCP_FLAG2_irq_aksv_en_shift                                  (4)
+#define HDCP_FLAG2_irq_ri_en_shift                                    (3)
+#define HDCP_FLAG2_irq_bksv_en_shift                                  (2)
+#define HDCP_FLAG2_dummy1800f214_1_0_shift                            (0)
+#define HDCP_FLAG2_irq_aksv_en_mask                                   (0x00000010)
+#define HDCP_FLAG2_irq_ri_en_mask                                     (0x00000008)
+#define HDCP_FLAG2_irq_bksv_en_mask                                   (0x00000004)
+#define HDCP_FLAG2_dummy1800f214_1_0_mask                             (0x00000003)
+#define HDCP_FLAG2_irq_aksv_en(data)                                  (0x00000010&((data)<<4))
+#define HDCP_FLAG2_irq_ri_en(data)                                    (0x00000008&((data)<<3))
+#define HDCP_FLAG2_irq_bksv_en(data)                                  (0x00000004&((data)<<2))
+#define HDCP_FLAG2_dummy1800f214_1_0(data)                            (0x00000003&(data))
+#define HDCP_FLAG2_get_irq_aksv_en(data)                              ((0x00000010&(data))>>4)
+#define HDCP_FLAG2_get_irq_ri_en(data)                                ((0x00000008&(data))>>3)
+#define HDCP_FLAG2_get_irq_bksv_en(data)                              ((0x00000004&(data))>>2)
+#define HDCP_FLAG2_get_dummy1800f214_1_0(data)                        (0x00000003&(data))
+
+
+#define HDCP_AP                                                       0x1800f218
+#define HDCP_AP_reg_addr                                              "0xb800f218"
+#define HDCP_AP_reg                                                   0xb800f218
+#define HDCP_AP_inst_addr                                             "0x0086"
+#define HDCP_AP_inst                                                  0x0086
+#define HDCP_AP_ap1_shift                                             (0)
+#define HDCP_AP_ap1_mask                                              (0x000000FF)
+#define HDCP_AP_ap1(data)                                             (0x000000FF&(data))
+#define HDCP_AP_get_ap1(data)                                         (0x000000FF&(data))
+
+
+#define HDCP_DP                                                       0x1800f21c
+#define HDCP_DP_reg_addr                                              "0xb800f21c"
+#define HDCP_DP_reg                                                   0xb800f21c
+#define HDCP_DP_inst_addr                                             "0x0087"
+#define HDCP_DP_inst                                                  0x0087
+#define HDCP_DP_dp1_shift                                             (0)
+#define HDCP_DP_dp1_mask                                              (0x000000FF)
+#define HDCP_DP_dp1(data)                                             (0x000000FF&(data))
+#define HDCP_DP_get_dp1(data)                                         (0x000000FF&(data))
+
+
+#define HDMI_CMCR                                                     0x1800f300
+#define HDMI_CMCR_reg_addr                                            "0xb800f300"
+#define HDMI_CMCR_reg                                                 0xb800f300
+#define HDMI_CMCR_inst_addr                                           "0x00C0"
+#define HDMI_CMCR_inst                                                0x00C0
+#define HDMI_CMCR_icmux_shift                                         (7)
+#define HDMI_CMCR_ocs_shift                                           (5)
+#define HDMI_CMCR_dbdcb_shift                                         (4)
+#define HDMI_CMCR_dummy1800f300_3_0_shift                             (0)
+#define HDMI_CMCR_icmux_mask                                          (0x00000080)
+#define HDMI_CMCR_ocs_mask                                            (0x00000060)
+#define HDMI_CMCR_dbdcb_mask                                          (0x00000010)
+#define HDMI_CMCR_dummy1800f300_3_0_mask                              (0x0000000F)
+#define HDMI_CMCR_icmux(data)                                         (0x00000080&((data)<<7))
+#define HDMI_CMCR_ocs(data)                                           (0x00000060&((data)<<5))
+#define HDMI_CMCR_dbdcb(data)                                         (0x00000010&((data)<<4))
+#define HDMI_CMCR_dummy1800f300_3_0(data)                             (0x0000000F&(data))
+#define HDMI_CMCR_get_icmux(data)                                     ((0x00000080&(data))>>7)
+#define HDMI_CMCR_get_ocs(data)                                       ((0x00000060&(data))>>5)
+#define HDMI_CMCR_get_dbdcb(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_CMCR_get_dummy1800f300_3_0(data)                         (0x0000000F&(data))
+
+
+#define HDMI_MCAPR                                                    0x1800f304
+#define HDMI_MCAPR_reg_addr                                           "0xb800f304"
+#define HDMI_MCAPR_reg                                                0xb800f304
+#define HDMI_MCAPR_inst_addr                                          "0x00C1"
+#define HDMI_MCAPR_inst                                               0x00C1
+#define HDMI_MCAPR_dummy1800f304_7_0_shift                            (0)
+#define HDMI_MCAPR_dummy1800f304_7_0_mask                             (0x000000FF)
+#define HDMI_MCAPR_dummy1800f304_7_0(data)                            (0x000000FF&(data))
+#define HDMI_MCAPR_get_dummy1800f304_7_0(data)                        (0x000000FF&(data))
+
+
+#define HDMI_SCAPR                                                    0x1800f308
+#define HDMI_SCAPR_reg_addr                                           "0xb800f308"
+#define HDMI_SCAPR_reg                                                0xb800f308
+#define HDMI_SCAPR_inst_addr                                          "0x00C2"
+#define HDMI_SCAPR_inst                                               0x00C2
+#define HDMI_SCAPR_s1_code_msb_r_shift                                (17)
+#define HDMI_SCAPR_slc_r_shift                                        (16)
+#define HDMI_SCAPR_sc_r_shift                                         (9)
+#define HDMI_SCAPR_s1_code_msb_shift                                  (8)
+#define HDMI_SCAPR_slc_shift                                          (7)
+#define HDMI_SCAPR_sc_shift                                           (0)
+#define HDMI_SCAPR_s1_code_msb_r_mask                                 (0x00020000)
+#define HDMI_SCAPR_slc_r_mask                                         (0x00010000)
+#define HDMI_SCAPR_sc_r_mask                                          (0x0000FE00)
+#define HDMI_SCAPR_s1_code_msb_mask                                   (0x00000100)
+#define HDMI_SCAPR_slc_mask                                           (0x00000080)
+#define HDMI_SCAPR_sc_mask                                            (0x0000007F)
+#define HDMI_SCAPR_s1_code_msb_r(data)                                (0x00020000&((data)<<17))
+#define HDMI_SCAPR_slc_r(data)                                        (0x00010000&((data)<<16))
+#define HDMI_SCAPR_sc_r(data)                                         (0x0000FE00&((data)<<9))
+#define HDMI_SCAPR_s1_code_msb(data)                                  (0x00000100&((data)<<8))
+#define HDMI_SCAPR_slc(data)                                          (0x00000080&((data)<<7))
+#define HDMI_SCAPR_sc(data)                                           (0x0000007F&(data))
+#define HDMI_SCAPR_get_s1_code_msb_r(data)                            ((0x00020000&(data))>>17)
+#define HDMI_SCAPR_get_slc_r(data)                                    ((0x00010000&(data))>>16)
+#define HDMI_SCAPR_get_sc_r(data)                                     ((0x0000FE00&(data))>>9)
+#define HDMI_SCAPR_get_s1_code_msb(data)                              ((0x00000100&(data))>>8)
+#define HDMI_SCAPR_get_slc(data)                                      ((0x00000080&(data))>>7)
+#define HDMI_SCAPR_get_sc(data)                                       (0x0000007F&(data))
+
+
+#define HDMI_DCAPR0                                                   0x1800f30c
+#define HDMI_DCAPR0_reg_addr                                          "0xb800f30c"
+#define HDMI_DCAPR0_reg                                               0xb800f30c
+#define HDMI_DCAPR0_inst_addr                                         "0x00C3"
+#define HDMI_DCAPR0_inst                                              0x00C3
+#define HDMI_DCAPR0_dcaprh_shift                                      (8)
+#define HDMI_DCAPR0_dcaprl_shift                                      (0)
+#define HDMI_DCAPR0_dcaprh_mask                                       (0x0000FF00)
+#define HDMI_DCAPR0_dcaprl_mask                                       (0x000000FF)
+#define HDMI_DCAPR0_dcaprh(data)                                      (0x0000FF00&((data)<<8))
+#define HDMI_DCAPR0_dcaprl(data)                                      (0x000000FF&(data))
+#define HDMI_DCAPR0_get_dcaprh(data)                                  ((0x0000FF00&(data))>>8)
+#define HDMI_DCAPR0_get_dcaprl(data)                                  (0x000000FF&(data))
+
+
+#define HDMI_PSCR                                                     0x1800f310
+#define HDMI_PSCR_reg_addr                                            "0xb800f310"
+#define HDMI_PSCR_reg                                                 0xb800f310
+#define HDMI_PSCR_inst_addr                                           "0x00C4"
+#define HDMI_PSCR_inst                                                0x00C4
+#define HDMI_PSCR_fdint_shift                                         (5)
+#define HDMI_PSCR_etcn_shift                                          (4)
+#define HDMI_PSCR_etfd_shift                                          (3)
+#define HDMI_PSCR_etfbc_shift                                         (2)
+#define HDMI_PSCR_pecs_shift                                          (0)
+#define HDMI_PSCR_fdint_mask                                          (0x000000E0)
+#define HDMI_PSCR_etcn_mask                                           (0x00000010)
+#define HDMI_PSCR_etfd_mask                                           (0x00000008)
+#define HDMI_PSCR_etfbc_mask                                          (0x00000004)
+#define HDMI_PSCR_pecs_mask                                           (0x00000003)
+#define HDMI_PSCR_fdint(data)                                         (0x000000E0&((data)<<5))
+#define HDMI_PSCR_etcn(data)                                          (0x00000010&((data)<<4))
+#define HDMI_PSCR_etfd(data)                                          (0x00000008&((data)<<3))
+#define HDMI_PSCR_etfbc(data)                                         (0x00000004&((data)<<2))
+#define HDMI_PSCR_pecs(data)                                          (0x00000003&(data))
+#define HDMI_PSCR_get_fdint(data)                                     ((0x000000E0&(data))>>5)
+#define HDMI_PSCR_get_etcn(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_PSCR_get_etfd(data)                                      ((0x00000008&(data))>>3)
+#define HDMI_PSCR_get_etfbc(data)                                     ((0x00000004&(data))>>2)
+#define HDMI_PSCR_get_pecs(data)                                      (0x00000003&(data))
+
+
+#define HDMI_AFDD                                                     0x1800f31c
+#define HDMI_AFDD_reg_addr                                            "0xb800f31c"
+#define HDMI_AFDD_reg                                                 0xb800f31c
+#define HDMI_AFDD_inst_addr                                           "0x00C7"
+#define HDMI_AFDD_inst                                                0x00C7
+#define HDMI_AFDD_mfddf_shift                                         (24)
+#define HDMI_AFDD_mfddr_shift                                         (16)
+#define HDMI_AFDD_fddf_shift                                          (8)
+#define HDMI_AFDD_fddr_shift                                          (0)
+#define HDMI_AFDD_mfddf_mask                                          (0xFF000000)
+#define HDMI_AFDD_mfddr_mask                                          (0x00FF0000)
+#define HDMI_AFDD_fddf_mask                                           (0x0000FF00)
+#define HDMI_AFDD_fddr_mask                                           (0x000000FF)
+#define HDMI_AFDD_mfddf(data)                                         (0xFF000000&((data)<<24))
+#define HDMI_AFDD_mfddr(data)                                         (0x00FF0000&((data)<<16))
+#define HDMI_AFDD_fddf(data)                                          (0x0000FF00&((data)<<8))
+#define HDMI_AFDD_fddr(data)                                          (0x000000FF&(data))
+#define HDMI_AFDD_get_mfddf(data)                                     ((0xFF000000&(data))>>24)
+#define HDMI_AFDD_get_mfddr(data)                                     ((0x00FF0000&(data))>>16)
+#define HDMI_AFDD_get_fddf(data)                                      ((0x0000FF00&(data))>>8)
+#define HDMI_AFDD_get_fddr(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_FTR                                                      0x1800f320
+#define HDMI_FTR_reg_addr                                             "0xb800f320"
+#define HDMI_FTR_reg                                                  0xb800f320
+#define HDMI_FTR_inst_addr                                            "0x00C8"
+#define HDMI_FTR_inst                                                 0x00C8
+#define HDMI_FTR_tl2der_shift                                         (6)
+#define HDMI_FTR_tl2def_shift                                         (4)
+#define HDMI_FTR_tt_shift                                             (0)
+#define HDMI_FTR_tl2der_mask                                          (0x000000C0)
+#define HDMI_FTR_tl2def_mask                                          (0x00000030)
+#define HDMI_FTR_tt_mask                                              (0x0000000F)
+#define HDMI_FTR_tl2der(data)                                         (0x000000C0&((data)<<6))
+#define HDMI_FTR_tl2def(data)                                         (0x00000030&((data)<<4))
+#define HDMI_FTR_tt(data)                                             (0x0000000F&(data))
+#define HDMI_FTR_get_tl2der(data)                                     ((0x000000C0&(data))>>6)
+#define HDMI_FTR_get_tl2def(data)                                     ((0x00000030&(data))>>4)
+#define HDMI_FTR_get_tt(data)                                         (0x0000000F&(data))
+
+
+#define HDMI_FBR                                                      0x1800f324
+#define HDMI_FBR_reg_addr                                             "0xb800f324"
+#define HDMI_FBR_reg                                                  0xb800f324
+#define HDMI_FBR_inst_addr                                            "0x00C9"
+#define HDMI_FBR_inst                                                 0x00C9
+#define HDMI_FBR_tfd_shift                                            (3)
+#define HDMI_FBR_bad_shift                                            (0)
+#define HDMI_FBR_tfd_mask                                             (0x000000F8)
+#define HDMI_FBR_bad_mask                                             (0x00000007)
+#define HDMI_FBR_tfd(data)                                            (0x000000F8&((data)<<3))
+#define HDMI_FBR_bad(data)                                            (0x00000007&(data))
+#define HDMI_FBR_get_tfd(data)                                        ((0x000000F8&(data))>>3)
+#define HDMI_FBR_get_bad(data)                                        (0x00000007&(data))
+
+
+#define HDMI_ICPSNCR0                                                 0x1800f328
+#define HDMI_ICPSNCR0_reg_addr                                        "0xb800f328"
+#define HDMI_ICPSNCR0_reg                                             0xb800f328
+#define HDMI_ICPSNCR0_inst_addr                                       "0x00CA"
+#define HDMI_ICPSNCR0_inst                                            0x00CA
+#define HDMI_ICPSNCR0_ich_shift                                       (8)
+#define HDMI_ICPSNCR0_icl_shift                                       (0)
+#define HDMI_ICPSNCR0_ich_mask                                        (0x0000FF00)
+#define HDMI_ICPSNCR0_icl_mask                                        (0x000000FF)
+#define HDMI_ICPSNCR0_ich(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_ICPSNCR0_icl(data)                                       (0x000000FF&(data))
+#define HDMI_ICPSNCR0_get_ich(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_ICPSNCR0_get_icl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_PCPSNCR0                                                 0x1800f32c
+#define HDMI_PCPSNCR0_reg_addr                                        "0xb800f32c"
+#define HDMI_PCPSNCR0_reg                                             0xb800f32c
+#define HDMI_PCPSNCR0_inst_addr                                       "0x00CB"
+#define HDMI_PCPSNCR0_inst                                            0x00CB
+#define HDMI_PCPSNCR0_pch_shift                                       (8)
+#define HDMI_PCPSNCR0_pcl_shift                                       (0)
+#define HDMI_PCPSNCR0_pch_mask                                        (0x0000FF00)
+#define HDMI_PCPSNCR0_pcl_mask                                        (0x000000FF)
+#define HDMI_PCPSNCR0_pch(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_PCPSNCR0_pcl(data)                                       (0x000000FF&(data))
+#define HDMI_PCPSNCR0_get_pch(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_PCPSNCR0_get_pcl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_ICTPSR0                                                  0x1800f330
+#define HDMI_ICTPSR0_reg_addr                                         "0xb800f330"
+#define HDMI_ICTPSR0_reg                                              0xb800f330
+#define HDMI_ICTPSR0_inst_addr                                        "0x00CC"
+#define HDMI_ICTPSR0_inst                                             0x00CC
+#define HDMI_ICTPSR0_icth_shift                                       (8)
+#define HDMI_ICTPSR0_ictl_shift                                       (0)
+#define HDMI_ICTPSR0_icth_mask                                        (0x0000FF00)
+#define HDMI_ICTPSR0_ictl_mask                                        (0x000000FF)
+#define HDMI_ICTPSR0_icth(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_ICTPSR0_ictl(data)                                       (0x000000FF&(data))
+#define HDMI_ICTPSR0_get_icth(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_ICTPSR0_get_ictl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_PCTPSR0                                                  0x1800f334
+#define HDMI_PCTPSR0_reg_addr                                         "0xb800f334"
+#define HDMI_PCTPSR0_reg                                              0xb800f334
+#define HDMI_PCTPSR0_inst_addr                                        "0x00CD"
+#define HDMI_PCTPSR0_inst                                             0x00CD
+#define HDMI_PCTPSR0_pcth_shift                                       (8)
+#define HDMI_PCTPSR0_pctl_shift                                       (0)
+#define HDMI_PCTPSR0_pcth_mask                                        (0x0000FF00)
+#define HDMI_PCTPSR0_pctl_mask                                        (0x000000FF)
+#define HDMI_PCTPSR0_pcth(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_PCTPSR0_pctl(data)                                       (0x000000FF&(data))
+#define HDMI_PCTPSR0_get_pcth(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_PCTPSR0_get_pctl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_ICBPSR0                                                  0x1800f338
+#define HDMI_ICBPSR0_reg_addr                                         "0xb800f338"
+#define HDMI_ICBPSR0_reg                                              0xb800f338
+#define HDMI_ICBPSR0_inst_addr                                        "0x00CE"
+#define HDMI_ICBPSR0_inst                                             0x00CE
+#define HDMI_ICBPSR0_icbh_shift                                       (8)
+#define HDMI_ICBPSR0_icbl_shift                                       (0)
+#define HDMI_ICBPSR0_icbh_mask                                        (0x0000FF00)
+#define HDMI_ICBPSR0_icbl_mask                                        (0x000000FF)
+#define HDMI_ICBPSR0_icbh(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_ICBPSR0_icbl(data)                                       (0x000000FF&(data))
+#define HDMI_ICBPSR0_get_icbh(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_ICBPSR0_get_icbl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_PCBPSR0                                                  0x1800f33c
+#define HDMI_PCBPSR0_reg_addr                                         "0xb800f33c"
+#define HDMI_PCBPSR0_reg                                              0xb800f33c
+#define HDMI_PCBPSR0_inst_addr                                        "0x00CF"
+#define HDMI_PCBPSR0_inst                                             0x00CF
+#define HDMI_PCBPSR0_pcbh_shift                                       (8)
+#define HDMI_PCBPSR0_pcbl_shift                                       (0)
+#define HDMI_PCBPSR0_pcbh_mask                                        (0x0000FF00)
+#define HDMI_PCBPSR0_pcbl_mask                                        (0x000000FF)
+#define HDMI_PCBPSR0_pcbh(data)                                       (0x0000FF00&((data)<<8))
+#define HDMI_PCBPSR0_pcbl(data)                                       (0x000000FF&(data))
+#define HDMI_PCBPSR0_get_pcbh(data)                                   ((0x0000FF00&(data))>>8)
+#define HDMI_PCBPSR0_get_pcbl(data)                                   (0x000000FF&(data))
+
+
+#define HDMI_NTX1024TR0                                               0x1800f340
+#define HDMI_NTX1024TR0_reg_addr                                      "0xb800f340"
+#define HDMI_NTX1024TR0_reg                                           0xb800f340
+#define HDMI_NTX1024TR0_inst_addr                                     "0x00D0"
+#define HDMI_NTX1024TR0_inst                                          0x00D0
+#define HDMI_NTX1024TR0_rm_shift                                      (12)
+#define HDMI_NTX1024TR0_nt_shift                                      (0)
+#define HDMI_NTX1024TR0_rm_mask                                       (0x00001000)
+#define HDMI_NTX1024TR0_nt_mask                                       (0x00000FFF)
+#define HDMI_NTX1024TR0_rm(data)                                      (0x00001000&((data)<<12))
+#define HDMI_NTX1024TR0_nt(data)                                      (0x00000FFF&(data))
+#define HDMI_NTX1024TR0_get_rm(data)                                  ((0x00001000&(data))>>12)
+#define HDMI_NTX1024TR0_get_nt(data)                                  (0x00000FFF&(data))
+
+
+#define HDMI_STBPR                                                    0x1800f344
+#define HDMI_STBPR_reg_addr                                           "0xb800f344"
+#define HDMI_STBPR_reg                                                0xb800f344
+#define HDMI_STBPR_inst_addr                                          "0x00D1"
+#define HDMI_STBPR_inst                                               0x00D1
+#define HDMI_STBPR_ftb_shift                                          (0)
+#define HDMI_STBPR_ftb_mask                                           (0x000000FF)
+#define HDMI_STBPR_ftb(data)                                          (0x000000FF&(data))
+#define HDMI_STBPR_get_ftb(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_NCPER                                                    0x1800f348
+#define HDMI_NCPER_reg_addr                                           "0xb800f348"
+#define HDMI_NCPER_reg                                                0xb800f348
+#define HDMI_NCPER_inst_addr                                          "0x00D2"
+#define HDMI_NCPER_inst                                               0x00D2
+#define HDMI_NCPER_ncper_shift                                        (0)
+#define HDMI_NCPER_ncper_mask                                         (0x000000FF)
+#define HDMI_NCPER_ncper(data)                                        (0x000000FF&(data))
+#define HDMI_NCPER_get_ncper(data)                                    (0x000000FF&(data))
+
+
+#define HDMI_PETR                                                     0x1800f34c
+#define HDMI_PETR_reg_addr                                            "0xb800f34c"
+#define HDMI_PETR_reg                                                 0xb800f34c
+#define HDMI_PETR_inst_addr                                           "0x00D3"
+#define HDMI_PETR_inst                                                0x00D3
+#define HDMI_PETR_petr_shift                                          (0)
+#define HDMI_PETR_petr_mask                                           (0x000000FF)
+#define HDMI_PETR_petr(data)                                          (0x000000FF&(data))
+#define HDMI_PETR_get_petr(data)                                      (0x000000FF&(data))
+
+
+#define HDMI_AAPNR                                                    0x1800f350
+#define HDMI_AAPNR_reg_addr                                           "0xb800f350"
+#define HDMI_AAPNR_reg                                                0xb800f350
+#define HDMI_AAPNR_inst_addr                                          "0x00D4"
+#define HDMI_AAPNR_inst                                               0x00D4
+#define HDMI_AAPNR_cmvtc_shift                                        (7)
+#define HDMI_AAPNR_cmvbc_shift                                        (6)
+#define HDMI_AAPNR_ssdmou_shift                                       (5)
+#define HDMI_AAPNR_tef_shift                                          (4)
+#define HDMI_AAPNR_w1c5_shift                                         (3)
+#define HDMI_AAPNR_pem_shift                                          (2)
+#define HDMI_AAPNR_esdm_shift                                         (1)
+#define HDMI_AAPNR_dummy1800f350_0_shift                              (0)
+#define HDMI_AAPNR_cmvtc_mask                                         (0x00000080)
+#define HDMI_AAPNR_cmvbc_mask                                         (0x00000040)
+#define HDMI_AAPNR_ssdmou_mask                                        (0x00000020)
+#define HDMI_AAPNR_tef_mask                                           (0x00000010)
+#define HDMI_AAPNR_w1c5_mask                                          (0x00000008)
+#define HDMI_AAPNR_pem_mask                                           (0x00000004)
+#define HDMI_AAPNR_esdm_mask                                          (0x00000002)
+#define HDMI_AAPNR_dummy1800f350_0_mask                               (0x00000001)
+#define HDMI_AAPNR_cmvtc(data)                                        (0x00000080&((data)<<7))
+#define HDMI_AAPNR_cmvbc(data)                                        (0x00000040&((data)<<6))
+#define HDMI_AAPNR_ssdmou(data)                                       (0x00000020&((data)<<5))
+#define HDMI_AAPNR_tef(data)                                          (0x00000010&((data)<<4))
+#define HDMI_AAPNR_w1c5(data)                                         (0x00000008&((data)<<3))
+#define HDMI_AAPNR_pem(data)                                          (0x00000004&((data)<<2))
+#define HDMI_AAPNR_esdm(data)                                         (0x00000002&((data)<<1))
+#define HDMI_AAPNR_dummy1800f350_0(data)                              (0x00000001&(data))
+#define HDMI_AAPNR_get_cmvtc(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_AAPNR_get_cmvbc(data)                                    ((0x00000040&(data))>>6)
+#define HDMI_AAPNR_get_ssdmou(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_AAPNR_get_tef(data)                                      ((0x00000010&(data))>>4)
+#define HDMI_AAPNR_get_w1c5(data)                                     ((0x00000008&(data))>>3)
+#define HDMI_AAPNR_get_pem(data)                                      ((0x00000004&(data))>>2)
+#define HDMI_AAPNR_get_esdm(data)                                     ((0x00000002&(data))>>1)
+#define HDMI_AAPNR_get_dummy1800f350_0(data)                          (0x00000001&(data))
+
+
+#define HDMI_APDMCR                                                   0x1800f354
+#define HDMI_APDMCR_reg_addr                                          "0xb800f354"
+#define HDMI_APDMCR_reg                                               0xb800f354
+#define HDMI_APDMCR_inst_addr                                         "0x00D5"
+#define HDMI_APDMCR_inst                                              0x00D5
+#define HDMI_APDMCR_dummy1800f354_7_shift                             (7)
+#define HDMI_APDMCR_dummy1800f354_6_shift                             (6)
+#define HDMI_APDMCR_edm_shift                                         (5)
+#define HDMI_APDMCR_pst_shift                                         (4)
+#define HDMI_APDMCR_psc_shift                                         (0)
+#define HDMI_APDMCR_dummy1800f354_7_mask                              (0x00000080)
+#define HDMI_APDMCR_dummy1800f354_6_mask                              (0x00000040)
+#define HDMI_APDMCR_edm_mask                                          (0x00000020)
+#define HDMI_APDMCR_pst_mask                                          (0x00000010)
+#define HDMI_APDMCR_psc_mask                                          (0x0000000F)
+#define HDMI_APDMCR_dummy1800f354_7(data)                             (0x00000080&((data)<<7))
+#define HDMI_APDMCR_dummy1800f354_6(data)                             (0x00000040&((data)<<6))
+#define HDMI_APDMCR_edm(data)                                         (0x00000020&((data)<<5))
+#define HDMI_APDMCR_pst(data)                                         (0x00000010&((data)<<4))
+#define HDMI_APDMCR_psc(data)                                         (0x0000000F&(data))
+#define HDMI_APDMCR_get_dummy1800f354_7(data)                         ((0x00000080&(data))>>7)
+#define HDMI_APDMCR_get_dummy1800f354_6(data)                         ((0x00000040&(data))>>6)
+#define HDMI_APDMCR_get_edm(data)                                     ((0x00000020&(data))>>5)
+#define HDMI_APDMCR_get_pst(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_APDMCR_get_psc(data)                                     (0x0000000F&(data))
+
+
+#define HDMI_APTMCR0                                                  0x1800f358
+#define HDMI_APTMCR0_reg_addr                                         "0xb800f358"
+#define HDMI_APTMCR0_reg                                              0xb800f358
+#define HDMI_APTMCR0_inst_addr                                        "0x00D6"
+#define HDMI_APTMCR0_inst                                             0x00D6
+#define HDMI_APTMCR0_fps_shift                                        (4)
+#define HDMI_APTMCR0_sps_shift                                        (0)
+#define HDMI_APTMCR0_fps_mask                                         (0x000000F0)
+#define HDMI_APTMCR0_sps_mask                                         (0x0000000F)
+#define HDMI_APTMCR0_fps(data)                                        (0x000000F0&((data)<<4))
+#define HDMI_APTMCR0_sps(data)                                        (0x0000000F&(data))
+#define HDMI_APTMCR0_get_fps(data)                                    ((0x000000F0&(data))>>4)
+#define HDMI_APTMCR0_get_sps(data)                                    (0x0000000F&(data))
+
+
+#define HDMI_APTMCR1                                                  0x1800f35c
+#define HDMI_APTMCR1_reg_addr                                         "0xb800f35c"
+#define HDMI_APTMCR1_reg                                              0xb800f35c
+#define HDMI_APTMCR1_inst_addr                                        "0x00D7"
+#define HDMI_APTMCR1_inst                                             0x00D7
+#define HDMI_APTMCR1_plltm_shift                                      (6)
+#define HDMI_APTMCR1_fpsd_shift                                       (5)
+#define HDMI_APTMCR1_spsd_shift                                       (4)
+#define HDMI_APTMCR1_nfpss_shift                                      (0)
+#define HDMI_APTMCR1_plltm_mask                                       (0x00000040)
+#define HDMI_APTMCR1_fpsd_mask                                        (0x00000020)
+#define HDMI_APTMCR1_spsd_mask                                        (0x00000010)
+#define HDMI_APTMCR1_nfpss_mask                                       (0x0000000F)
+#define HDMI_APTMCR1_plltm(data)                                      (0x00000040&((data)<<6))
+#define HDMI_APTMCR1_fpsd(data)                                       (0x00000020&((data)<<5))
+#define HDMI_APTMCR1_spsd(data)                                       (0x00000010&((data)<<4))
+#define HDMI_APTMCR1_nfpss(data)                                      (0x0000000F&(data))
+#define HDMI_APTMCR1_get_plltm(data)                                  ((0x00000040&(data))>>6)
+#define HDMI_APTMCR1_get_fpsd(data)                                   ((0x00000020&(data))>>5)
+#define HDMI_APTMCR1_get_spsd(data)                                   ((0x00000010&(data))>>4)
+#define HDMI_APTMCR1_get_nfpss(data)                                  (0x0000000F&(data))
+
+
+#define HDMI_NPECR                                                    0x1800f360
+#define HDMI_NPECR_reg_addr                                           "0xb800f360"
+#define HDMI_NPECR_reg                                                0xb800f360
+#define HDMI_NPECR_inst_addr                                          "0x00D8"
+#define HDMI_NPECR_inst                                               0x00D8
+#define HDMI_NPECR_ncts_disable_pe_check_en_shift                     (31)
+#define HDMI_NPECR_ncts_re_enable_off_en_shift                        (30)
+#define HDMI_NPECR_ncts_disable_pe_check_status_shift                 (29)
+#define HDMI_NPECR_ncts_disable_pe_check_irq_en_shift                 (28)
+#define HDMI_NPECR_dummy1800f360_27_20_shift                          (20)
+#define HDMI_NPECR_ncts_disable_pe_check_cnt_shift                    (0)
+#define HDMI_NPECR_ncts_disable_pe_check_en_mask                      (0x80000000)
+#define HDMI_NPECR_ncts_re_enable_off_en_mask                         (0x40000000)
+#define HDMI_NPECR_ncts_disable_pe_check_status_mask                  (0x20000000)
+#define HDMI_NPECR_ncts_disable_pe_check_irq_en_mask                  (0x10000000)
+#define HDMI_NPECR_dummy1800f360_27_20_mask                           (0x0FF00000)
+#define HDMI_NPECR_ncts_disable_pe_check_cnt_mask                     (0x000FFFFF)
+#define HDMI_NPECR_ncts_disable_pe_check_en(data)                     (0x80000000&((data)<<31))
+#define HDMI_NPECR_ncts_re_enable_off_en(data)                        (0x40000000&((data)<<30))
+#define HDMI_NPECR_ncts_disable_pe_check_status(data)                 (0x20000000&((data)<<29))
+#define HDMI_NPECR_ncts_disable_pe_check_irq_en(data)                 (0x10000000&((data)<<28))
+#define HDMI_NPECR_dummy1800f360_27_20(data)                          (0x0FF00000&((data)<<20))
+#define HDMI_NPECR_ncts_disable_pe_check_cnt(data)                    (0x000FFFFF&(data))
+#define HDMI_NPECR_get_ncts_disable_pe_check_en(data)                 ((0x80000000&(data))>>31)
+#define HDMI_NPECR_get_ncts_re_enable_off_en(data)                    ((0x40000000&(data))>>30)
+#define HDMI_NPECR_get_ncts_disable_pe_check_status(data)             ((0x20000000&(data))>>29)
+#define HDMI_NPECR_get_ncts_disable_pe_check_irq_en(data)             ((0x10000000&(data))>>28)
+#define HDMI_NPECR_get_dummy1800f360_27_20(data)                      ((0x0FF00000&(data))>>20)
+#define HDMI_NPECR_get_ncts_disable_pe_check_cnt(data)                (0x000FFFFF&(data))
+
+
+#define HDMI_NROR                                                     0x1800f364
+#define HDMI_NROR_reg_addr                                            "0xb800f364"
+#define HDMI_NROR_reg                                                 0xb800f364
+#define HDMI_NROR_inst_addr                                           "0x00D9"
+#define HDMI_NROR_inst                                                0x00D9
+#define HDMI_NROR_ncts_re_enable_off_start_shift                      (16)
+#define HDMI_NROR_ncts_re_enable_off_end_shift                        (0)
+#define HDMI_NROR_ncts_re_enable_off_start_mask                       (0xFFFF0000)
+#define HDMI_NROR_ncts_re_enable_off_end_mask                         (0x0000FFFF)
+#define HDMI_NROR_ncts_re_enable_off_start(data)                      (0xFFFF0000&((data)<<16))
+#define HDMI_NROR_ncts_re_enable_off_end(data)                        (0x0000FFFF&(data))
+#define HDMI_NROR_get_ncts_re_enable_off_start(data)                  ((0xFFFF0000&(data))>>16)
+#define HDMI_NROR_get_ncts_re_enable_off_end(data)                    (0x0000FFFF&(data))
+
+
+#define HDMI_NTX1024TR0_THRESHOLD                                     0x1800f368
+#define HDMI_NTX1024TR0_THRESHOLD_reg_addr                            "0xb800f368"
+#define HDMI_NTX1024TR0_THRESHOLD_reg                                 0xb800f368
+#define HDMI_NTX1024TR0_THRESHOLD_inst_addr                           "0x00DA"
+#define HDMI_NTX1024TR0_THRESHOLD_inst                                0x00DA
+#define HDMI_NTX1024TR0_THRESHOLD_over_threshold_shift                (31)
+#define HDMI_NTX1024TR0_THRESHOLD_under_threshold_shift               (30)
+#define HDMI_NTX1024TR0_THRESHOLD_wd_by_tmds_clk_shift                (29)
+#define HDMI_NTX1024TR0_THRESHOLD_irq_by_tmds_clk_shift               (28)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_up_threshold_shift               (16)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_low_threshold_shift              (0)
+#define HDMI_NTX1024TR0_THRESHOLD_over_threshold_mask                 (0x80000000)
+#define HDMI_NTX1024TR0_THRESHOLD_under_threshold_mask                (0x40000000)
+#define HDMI_NTX1024TR0_THRESHOLD_wd_by_tmds_clk_mask                 (0x20000000)
+#define HDMI_NTX1024TR0_THRESHOLD_irq_by_tmds_clk_mask                (0x10000000)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_up_threshold_mask                (0x0FFF0000)
+#define HDMI_NTX1024TR0_THRESHOLD_nt_low_threshold_mask               (0x00000FFF)
+#define HDMI_NTX1024TR0_THRESHOLD_over_threshold(data)                (0x80000000&((data)<<31))
+#define HDMI_NTX1024TR0_THRESHOLD_under_threshold(data)               (0x40000000&((data)<<30))
+#define HDMI_NTX1024TR0_THRESHOLD_wd_by_tmds_clk(data)                (0x20000000&((data)<<29))
+#define HDMI_NTX1024TR0_THRESHOLD_irq_by_tmds_clk(data)               (0x10000000&((data)<<28))
+#define HDMI_NTX1024TR0_THRESHOLD_nt_up_threshold(data)               (0x0FFF0000&((data)<<16))
+#define HDMI_NTX1024TR0_THRESHOLD_nt_low_threshold(data)              (0x00000FFF&(data))
+#define HDMI_NTX1024TR0_THRESHOLD_get_over_threshold(data)            ((0x80000000&(data))>>31)
+#define HDMI_NTX1024TR0_THRESHOLD_get_under_threshold(data)           ((0x40000000&(data))>>30)
+#define HDMI_NTX1024TR0_THRESHOLD_get_wd_by_tmds_clk(data)            ((0x20000000&(data))>>29)
+#define HDMI_NTX1024TR0_THRESHOLD_get_irq_by_tmds_clk(data)           ((0x10000000&(data))>>28)
+#define HDMI_NTX1024TR0_THRESHOLD_get_nt_up_threshold(data)           ((0x0FFF0000&(data))>>16)
+#define HDMI_NTX1024TR0_THRESHOLD_get_nt_low_threshold(data)          (0x00000FFF&(data))
+
+
+#define HDMI_APLLCR0                                                  0x1800f380
+#define HDMI_APLLCR0_reg_addr                                         "0xb800f380"
+#define HDMI_APLLCR0_reg                                              0xb800f380
+#define HDMI_APLLCR0_inst_addr                                        "0x00E0"
+#define HDMI_APLLCR0_inst                                             0x00E0
+#define HDMI_APLLCR0_dpll_reg_shift                                   (30)
+#define HDMI_APLLCR0_dpll_m_shift                                     (22)
+#define HDMI_APLLCR0_dpll_reser_shift                                 (17)
+#define HDMI_APLLCR0_dpll_bpn_shift                                   (16)
+#define HDMI_APLLCR0_dpll_o_shift                                     (14)
+#define HDMI_APLLCR0_dpll_n_shift                                     (6)
+#define HDMI_APLLCR0_dpll_rs_shift                                    (3)
+#define HDMI_APLLCR0_dpll_ip_shift                                    (0)
+#define HDMI_APLLCR0_dpll_reg_mask                                    (0xC0000000)
+#define HDMI_APLLCR0_dpll_m_mask                                      (0x3FC00000)
+#define HDMI_APLLCR0_dpll_reser_mask                                  (0x001E0000)
+#define HDMI_APLLCR0_dpll_bpn_mask                                    (0x00010000)
+#define HDMI_APLLCR0_dpll_o_mask                                      (0x0000C000)
+#define HDMI_APLLCR0_dpll_n_mask                                      (0x000001C0)
+#define HDMI_APLLCR0_dpll_rs_mask                                     (0x00000038)
+#define HDMI_APLLCR0_dpll_ip_mask                                     (0x00000007)
+#define HDMI_APLLCR0_dpll_reg(data)                                   (0xC0000000&((data)<<30))
+#define HDMI_APLLCR0_dpll_m(data)                                     (0x3FC00000&((data)<<22))
+#define HDMI_APLLCR0_dpll_reser(data)                                 (0x001E0000&((data)<<17))
+#define HDMI_APLLCR0_dpll_bpn(data)                                   (0x00010000&((data)<<16))
+#define HDMI_APLLCR0_dpll_o(data)                                     (0x0000C000&((data)<<14))
+#define HDMI_APLLCR0_dpll_n(data)                                     (0x000001C0&((data)<<6))
+#define HDMI_APLLCR0_dpll_rs(data)                                    (0x00000038&((data)<<3))
+#define HDMI_APLLCR0_dpll_ip(data)                                    (0x00000007&(data))
+#define HDMI_APLLCR0_get_dpll_reg(data)                               ((0xC0000000&(data))>>30)
+#define HDMI_APLLCR0_get_dpll_m(data)                                 ((0x3FC00000&(data))>>22)
+#define HDMI_APLLCR0_get_dpll_reser(data)                             ((0x001E0000&(data))>>17)
+#define HDMI_APLLCR0_get_dpll_bpn(data)                               ((0x00010000&(data))>>16)
+#define HDMI_APLLCR0_get_dpll_o(data)                                 ((0x0000C000&(data))>>14)
+#define HDMI_APLLCR0_get_dpll_n(data)                                 ((0x000001C0&(data))>>6)
+#define HDMI_APLLCR0_get_dpll_rs(data)                                ((0x00000038&(data))>>3)
+#define HDMI_APLLCR0_get_dpll_ip(data)                                (0x00000007&(data))
+
+
+#define HDMI_APLLCR1                                                  0x1800f384
+#define HDMI_APLLCR1_reg_addr                                         "0xb800f384"
+#define HDMI_APLLCR1_reg                                              0xb800f384
+#define HDMI_APLLCR1_inst_addr                                        "0x00E1"
+#define HDMI_APLLCR1_inst                                             0x00E1
+#define HDMI_APLLCR1_dpll_cp_shift                                    (21)
+#define HDMI_APLLCR1_dpll_seltst_shift                                (19)
+#define HDMI_APLLCR1_dpll_cs_shift                                    (17)
+#define HDMI_APLLCR1_dpll_reserve_shift                               (9)
+#define HDMI_APLLCR1_dpll_bpphs_shift                                 (8)
+#define HDMI_APLLCR1_dpll_wdo_shift                                   (7)
+#define HDMI_APLLCR1_dpll_wdrst_shift                                 (6)
+#define HDMI_APLLCR1_dpll_wdset_shift                                 (5)
+#define HDMI_APLLCR1_dummy1800f384_4_shift                            (4)
+#define HDMI_APLLCR1_dpll_stop_shift                                  (3)
+#define HDMI_APLLCR1_dpll_freeze_shift                                (2)
+#define HDMI_APLLCR1_dpll_vcorstb_shift                               (1)
+#define HDMI_APLLCR1_dpll_pwdn_shift                                  (0)
+#define HDMI_APLLCR1_dpll_cp_mask                                     (0x00600000)
+#define HDMI_APLLCR1_dpll_seltst_mask                                 (0x00180000)
+#define HDMI_APLLCR1_dpll_cs_mask                                     (0x00060000)
+#define HDMI_APLLCR1_dpll_reserve_mask                                (0x00000200)
+#define HDMI_APLLCR1_dpll_bpphs_mask                                  (0x00000100)
+#define HDMI_APLLCR1_dpll_wdo_mask                                    (0x00000080)
+#define HDMI_APLLCR1_dpll_wdrst_mask                                  (0x00000040)
+#define HDMI_APLLCR1_dpll_wdset_mask                                  (0x00000020)
+#define HDMI_APLLCR1_dummy1800f384_4_mask                             (0x00000010)
+#define HDMI_APLLCR1_dpll_stop_mask                                   (0x00000008)
+#define HDMI_APLLCR1_dpll_freeze_mask                                 (0x00000004)
+#define HDMI_APLLCR1_dpll_vcorstb_mask                                (0x00000002)
+#define HDMI_APLLCR1_dpll_pwdn_mask                                   (0x00000001)
+#define HDMI_APLLCR1_dpll_cp(data)                                    (0x00600000&((data)<<21))
+#define HDMI_APLLCR1_dpll_seltst(data)                                (0x00180000&((data)<<19))
+#define HDMI_APLLCR1_dpll_cs(data)                                    (0x00060000&((data)<<17))
+#define HDMI_APLLCR1_dpll_reserve(data)                               (0x00000200&((data)<<9))
+#define HDMI_APLLCR1_dpll_bpphs(data)                                 (0x00000100&((data)<<8))
+#define HDMI_APLLCR1_dpll_wdo(data)                                   (0x00000080&((data)<<7))
+#define HDMI_APLLCR1_dpll_wdrst(data)                                 (0x00000040&((data)<<6))
+#define HDMI_APLLCR1_dpll_wdset(data)                                 (0x00000020&((data)<<5))
+#define HDMI_APLLCR1_dummy1800f384_4(data)                            (0x00000010&((data)<<4))
+#define HDMI_APLLCR1_dpll_stop(data)                                  (0x00000008&((data)<<3))
+#define HDMI_APLLCR1_dpll_freeze(data)                                (0x00000004&((data)<<2))
+#define HDMI_APLLCR1_dpll_vcorstb(data)                               (0x00000002&((data)<<1))
+#define HDMI_APLLCR1_dpll_pwdn(data)                                  (0x00000001&(data))
+#define HDMI_APLLCR1_get_dpll_cp(data)                                ((0x00600000&(data))>>21)
+#define HDMI_APLLCR1_get_dpll_seltst(data)                            ((0x00180000&(data))>>19)
+#define HDMI_APLLCR1_get_dpll_cs(data)                                ((0x00060000&(data))>>17)
+#define HDMI_APLLCR1_get_dpll_reserve(data)                           ((0x00000200&(data))>>9)
+#define HDMI_APLLCR1_get_dpll_bpphs(data)                             ((0x00000100&(data))>>8)
+#define HDMI_APLLCR1_get_dpll_wdo(data)                               ((0x00000080&(data))>>7)
+#define HDMI_APLLCR1_get_dpll_wdrst(data)                             ((0x00000040&(data))>>6)
+#define HDMI_APLLCR1_get_dpll_wdset(data)                             ((0x00000020&(data))>>5)
+#define HDMI_APLLCR1_get_dummy1800f384_4(data)                        ((0x00000010&(data))>>4)
+#define HDMI_APLLCR1_get_dpll_stop(data)                              ((0x00000008&(data))>>3)
+#define HDMI_APLLCR1_get_dpll_freeze(data)                            ((0x00000004&(data))>>2)
+#define HDMI_APLLCR1_get_dpll_vcorstb(data)                           ((0x00000002&(data))>>1)
+#define HDMI_APLLCR1_get_dpll_pwdn(data)                              (0x00000001&(data))
+
+
+#define HDMI_APLLCR2                                                  0x1800f388
+#define HDMI_APLLCR2_reg_addr                                         "0xb800f388"
+#define HDMI_APLLCR2_reg                                              0xb800f388
+#define HDMI_APLLCR2_inst_addr                                        "0x00E2"
+#define HDMI_APLLCR2_inst                                             0x00E2
+#define HDMI_APLLCR2_dpll_rloadm_shift                                (0)
+#define HDMI_APLLCR2_dpll_rloadm_mask                                 (0x00000001)
+#define HDMI_APLLCR2_dpll_rloadm(data)                                (0x00000001&(data))
+#define HDMI_APLLCR2_get_dpll_rloadm(data)                            (0x00000001&(data))
+
+
+#define HDMI_APLLCR3                                                  0x1800f38c
+#define HDMI_APLLCR3_reg_addr                                         "0xb800f38c"
+#define HDMI_APLLCR3_reg                                              0xb800f38c
+#define HDMI_APLLCR3_inst_addr                                        "0x00E3"
+#define HDMI_APLLCR3_inst                                             0x00E3
+#define HDMI_APLLCR3_sum_c_samp_shift                                 (0)
+#define HDMI_APLLCR3_sum_c_samp_mask                                  (0x0000FFFF)
+#define HDMI_APLLCR3_sum_c_samp(data)                                 (0x0000FFFF&(data))
+#define HDMI_APLLCR3_get_sum_c_samp(data)                             (0x0000FFFF&(data))
+
+
+#define HDMI_APLL_TESTM                                               0x1800f390
+#define HDMI_APLL_TESTM_reg_addr                                      "0xb800f390"
+#define HDMI_APLL_TESTM_reg                                           0xb800f390
+#define HDMI_APLL_TESTM_inst_addr                                     "0x00E4"
+#define HDMI_APLL_TESTM_inst                                          0x00E4
+#define HDMI_APLL_TESTM_dpll_m_test_shift                             (22)
+#define HDMI_APLL_TESTM_dpll_m_db_shift                               (1)
+#define HDMI_APLL_TESTM_dpll_m_sel_shift                              (0)
+#define HDMI_APLL_TESTM_dpll_m_test_mask                              (0x3FC00000)
+#define HDMI_APLL_TESTM_dpll_m_db_mask                                (0x00000002)
+#define HDMI_APLL_TESTM_dpll_m_sel_mask                               (0x00000001)
+#define HDMI_APLL_TESTM_dpll_m_test(data)                             (0x3FC00000&((data)<<22))
+#define HDMI_APLL_TESTM_dpll_m_db(data)                               (0x00000002&((data)<<1))
+#define HDMI_APLL_TESTM_dpll_m_sel(data)                              (0x00000001&(data))
+#define HDMI_APLL_TESTM_get_dpll_m_test(data)                         ((0x3FC00000&(data))>>22)
+#define HDMI_APLL_TESTM_get_dpll_m_db(data)                           ((0x00000002&(data))>>1)
+#define HDMI_APLL_TESTM_get_dpll_m_sel(data)                          (0x00000001&(data))
+
+
+#define HDMI_VPLLCR0                                                  0x1800f400
+#define HDMI_VPLLCR0_reg_addr                                         "0xb800f400"
+#define HDMI_VPLLCR0_reg                                              0xb800f400
+#define HDMI_VPLLCR0_inst_addr                                        "0x0100"
+#define HDMI_VPLLCR0_inst                                             0x0100
+#define HDMI_VPLLCR0_dpll_reg_shift                                   (30)
+#define HDMI_VPLLCR0_dpll_m_shift                                     (22)
+#define HDMI_VPLLCR0_dpll_reser_shift                                 (17)
+#define HDMI_VPLLCR0_dpll_bpn_shift                                   (16)
+#define HDMI_VPLLCR0_dpll_o_shift                                     (14)
+#define HDMI_VPLLCR0_dpll_n_shift                                     (6)
+#define HDMI_VPLLCR0_dpll_rs_shift                                    (3)
+#define HDMI_VPLLCR0_dpll_ip_shift                                    (0)
+#define HDMI_VPLLCR0_dpll_reg_mask                                    (0xC0000000)
+#define HDMI_VPLLCR0_dpll_m_mask                                      (0x3FC00000)
+#define HDMI_VPLLCR0_dpll_reser_mask                                  (0x001E0000)
+#define HDMI_VPLLCR0_dpll_bpn_mask                                    (0x00010000)
+#define HDMI_VPLLCR0_dpll_o_mask                                      (0x0000C000)
+#define HDMI_VPLLCR0_dpll_n_mask                                      (0x000001C0)
+#define HDMI_VPLLCR0_dpll_rs_mask                                     (0x00000038)
+#define HDMI_VPLLCR0_dpll_ip_mask                                     (0x00000007)
+#define HDMI_VPLLCR0_dpll_reg(data)                                   (0xC0000000&((data)<<30))
+#define HDMI_VPLLCR0_dpll_m(data)                                     (0x3FC00000&((data)<<22))
+#define HDMI_VPLLCR0_dpll_reser(data)                                 (0x001E0000&((data)<<17))
+#define HDMI_VPLLCR0_dpll_bpn(data)                                   (0x00010000&((data)<<16))
+#define HDMI_VPLLCR0_dpll_o(data)                                     (0x0000C000&((data)<<14))
+#define HDMI_VPLLCR0_dpll_n(data)                                     (0x000001C0&((data)<<6))
+#define HDMI_VPLLCR0_dpll_rs(data)                                    (0x00000038&((data)<<3))
+#define HDMI_VPLLCR0_dpll_ip(data)                                    (0x00000007&(data))
+#define HDMI_VPLLCR0_get_dpll_reg(data)                               ((0xC0000000&(data))>>30)
+#define HDMI_VPLLCR0_get_dpll_m(data)                                 ((0x3FC00000&(data))>>22)
+#define HDMI_VPLLCR0_get_dpll_reser(data)                             ((0x001E0000&(data))>>17)
+#define HDMI_VPLLCR0_get_dpll_bpn(data)                               ((0x00010000&(data))>>16)
+#define HDMI_VPLLCR0_get_dpll_o(data)                                 ((0x0000C000&(data))>>14)
+#define HDMI_VPLLCR0_get_dpll_n(data)                                 ((0x000001C0&(data))>>6)
+#define HDMI_VPLLCR0_get_dpll_rs(data)                                ((0x00000038&(data))>>3)
+#define HDMI_VPLLCR0_get_dpll_ip(data)                                (0x00000007&(data))
+
+
+#define HDMI_VPLLCR1                                                  0x1800f404
+#define HDMI_VPLLCR1_reg_addr                                         "0xb800f404"
+#define HDMI_VPLLCR1_reg                                              0xb800f404
+#define HDMI_VPLLCR1_inst_addr                                        "0x0101"
+#define HDMI_VPLLCR1_inst                                             0x0101
+#define HDMI_VPLLCR1_dpll_cp_shift                                    (21)
+#define HDMI_VPLLCR1_dpll_seltst_shift                                (19)
+#define HDMI_VPLLCR1_dpll_cs_shift                                    (17)
+#define HDMI_VPLLCR1_dpll_reserve_shift                               (9)
+#define HDMI_VPLLCR1_dpll_bpphs_shift                                 (8)
+#define HDMI_VPLLCR1_dpll_wdo_shift                                   (7)
+#define HDMI_VPLLCR1_dpll_wdrst_shift                                 (6)
+#define HDMI_VPLLCR1_dpll_wdset_shift                                 (5)
+#define HDMI_VPLLCR1_dummy1800f404_4_shift                            (4)
+#define HDMI_VPLLCR1_dpll_stop_shift                                  (3)
+#define HDMI_VPLLCR1_dpll_freeze_shift                                (2)
+#define HDMI_VPLLCR1_dpll_vcorstb_shift                               (1)
+#define HDMI_VPLLCR1_dpll_pwdn_shift                                  (0)
+#define HDMI_VPLLCR1_dpll_cp_mask                                     (0x00600000)
+#define HDMI_VPLLCR1_dpll_seltst_mask                                 (0x00180000)
+#define HDMI_VPLLCR1_dpll_cs_mask                                     (0x00060000)
+#define HDMI_VPLLCR1_dpll_reserve_mask                                (0x00000200)
+#define HDMI_VPLLCR1_dpll_bpphs_mask                                  (0x00000100)
+#define HDMI_VPLLCR1_dpll_wdo_mask                                    (0x00000080)
+#define HDMI_VPLLCR1_dpll_wdrst_mask                                  (0x00000040)
+#define HDMI_VPLLCR1_dpll_wdset_mask                                  (0x00000020)
+#define HDMI_VPLLCR1_dummy1800f404_4_mask                             (0x00000010)
+#define HDMI_VPLLCR1_dpll_stop_mask                                   (0x00000008)
+#define HDMI_VPLLCR1_dpll_freeze_mask                                 (0x00000004)
+#define HDMI_VPLLCR1_dpll_vcorstb_mask                                (0x00000002)
+#define HDMI_VPLLCR1_dpll_pwdn_mask                                   (0x00000001)
+#define HDMI_VPLLCR1_dpll_cp(data)                                    (0x00600000&((data)<<21))
+#define HDMI_VPLLCR1_dpll_seltst(data)                                (0x00180000&((data)<<19))
+#define HDMI_VPLLCR1_dpll_cs(data)                                    (0x00060000&((data)<<17))
+#define HDMI_VPLLCR1_dpll_reserve(data)                               (0x00000200&((data)<<9))
+#define HDMI_VPLLCR1_dpll_bpphs(data)                                 (0x00000100&((data)<<8))
+#define HDMI_VPLLCR1_dpll_wdo(data)                                   (0x00000080&((data)<<7))
+#define HDMI_VPLLCR1_dpll_wdrst(data)                                 (0x00000040&((data)<<6))
+#define HDMI_VPLLCR1_dpll_wdset(data)                                 (0x00000020&((data)<<5))
+#define HDMI_VPLLCR1_dummy1800f404_4(data)                            (0x00000010&((data)<<4))
+#define HDMI_VPLLCR1_dpll_stop(data)                                  (0x00000008&((data)<<3))
+#define HDMI_VPLLCR1_dpll_freeze(data)                                (0x00000004&((data)<<2))
+#define HDMI_VPLLCR1_dpll_vcorstb(data)                               (0x00000002&((data)<<1))
+#define HDMI_VPLLCR1_dpll_pwdn(data)                                  (0x00000001&(data))
+#define HDMI_VPLLCR1_get_dpll_cp(data)                                ((0x00600000&(data))>>21)
+#define HDMI_VPLLCR1_get_dpll_seltst(data)                            ((0x00180000&(data))>>19)
+#define HDMI_VPLLCR1_get_dpll_cs(data)                                ((0x00060000&(data))>>17)
+#define HDMI_VPLLCR1_get_dpll_reserve(data)                           ((0x00000200&(data))>>9)
+#define HDMI_VPLLCR1_get_dpll_bpphs(data)                             ((0x00000100&(data))>>8)
+#define HDMI_VPLLCR1_get_dpll_wdo(data)                               ((0x00000080&(data))>>7)
+#define HDMI_VPLLCR1_get_dpll_wdrst(data)                             ((0x00000040&(data))>>6)
+#define HDMI_VPLLCR1_get_dpll_wdset(data)                             ((0x00000020&(data))>>5)
+#define HDMI_VPLLCR1_get_dummy1800f404_4(data)                        ((0x00000010&(data))>>4)
+#define HDMI_VPLLCR1_get_dpll_stop(data)                              ((0x00000008&(data))>>3)
+#define HDMI_VPLLCR1_get_dpll_freeze(data)                            ((0x00000004&(data))>>2)
+#define HDMI_VPLLCR1_get_dpll_vcorstb(data)                           ((0x00000002&(data))>>1)
+#define HDMI_VPLLCR1_get_dpll_pwdn(data)                              (0x00000001&(data))
+
+
+#define HDMI_VPLLCR2                                                  0x1800f408
+#define HDMI_VPLLCR2_reg_addr                                         "0xb800f408"
+#define HDMI_VPLLCR2_reg                                              0xb800f408
+#define HDMI_VPLLCR2_inst_addr                                        "0x0102"
+#define HDMI_VPLLCR2_inst                                             0x0102
+#define HDMI_VPLLCR2_dpll_rloadm_shift                                (0)
+#define HDMI_VPLLCR2_dpll_rloadm_mask                                 (0x00000001)
+#define HDMI_VPLLCR2_dpll_rloadm(data)                                (0x00000001&(data))
+#define HDMI_VPLLCR2_get_dpll_rloadm(data)                            (0x00000001&(data))
+
+
+#define MN_SCLKG_CTRL                                                 0x1800f410
+#define MN_SCLKG_CTRL_reg_addr                                        "0xb800f410"
+#define MN_SCLKG_CTRL_reg                                             0xb800f410
+#define MN_SCLKG_CTRL_inst_addr                                       "0x0104"
+#define MN_SCLKG_CTRL_inst                                            0x0104
+#define MN_SCLKG_CTRL_sclkg_pll_in_sel_shift                          (7)
+#define MN_SCLKG_CTRL_sclkg_oclk_sel_shift                            (5)
+#define MN_SCLKG_CTRL_sclkg_dbuf_shift                                (4)
+#define MN_SCLKG_CTRL_dummy1800f410_3_0_shift                         (0)
+#define MN_SCLKG_CTRL_sclkg_pll_in_sel_mask                           (0x00000080)
+#define MN_SCLKG_CTRL_sclkg_oclk_sel_mask                             (0x00000060)
+#define MN_SCLKG_CTRL_sclkg_dbuf_mask                                 (0x00000010)
+#define MN_SCLKG_CTRL_dummy1800f410_3_0_mask                          (0x0000000F)
+#define MN_SCLKG_CTRL_sclkg_pll_in_sel(data)                          (0x00000080&((data)<<7))
+#define MN_SCLKG_CTRL_sclkg_oclk_sel(data)                            (0x00000060&((data)<<5))
+#define MN_SCLKG_CTRL_sclkg_dbuf(data)                                (0x00000010&((data)<<4))
+#define MN_SCLKG_CTRL_dummy1800f410_3_0(data)                         (0x0000000F&(data))
+#define MN_SCLKG_CTRL_get_sclkg_pll_in_sel(data)                      ((0x00000080&(data))>>7)
+#define MN_SCLKG_CTRL_get_sclkg_oclk_sel(data)                        ((0x00000060&(data))>>5)
+#define MN_SCLKG_CTRL_get_sclkg_dbuf(data)                            ((0x00000010&(data))>>4)
+#define MN_SCLKG_CTRL_get_dummy1800f410_3_0(data)                     (0x0000000F&(data))
+
+
+#define MN_SCLKG_DIVS                                                 0x1800f414
+#define MN_SCLKG_DIVS_reg_addr                                        "0xb800f414"
+#define MN_SCLKG_DIVS_reg                                             0xb800f414
+#define MN_SCLKG_DIVS_inst_addr                                       "0x0105"
+#define MN_SCLKG_DIVS_inst                                            0x0105
+#define MN_SCLKG_DIVS_sclkg_pll_div2_en_shift                         (7)
+#define MN_SCLKG_DIVS_sclkg_pll_divs_shift                            (0)
+#define MN_SCLKG_DIVS_sclkg_pll_div2_en_mask                          (0x00000080)
+#define MN_SCLKG_DIVS_sclkg_pll_divs_mask                             (0x0000007F)
+#define MN_SCLKG_DIVS_sclkg_pll_div2_en(data)                         (0x00000080&((data)<<7))
+#define MN_SCLKG_DIVS_sclkg_pll_divs(data)                            (0x0000007F&(data))
+#define MN_SCLKG_DIVS_get_sclkg_pll_div2_en(data)                     ((0x00000080&(data))>>7)
+#define MN_SCLKG_DIVS_get_sclkg_pll_divs(data)                        (0x0000007F&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/rbusCbusReg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/rbusCbusReg.h
new file mode 100644
index 00000000..15ad8bf
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/rbusCbusReg.h
@@ -0,0 +1,3924 @@
+/**
+* @file rbusCBUSReg.h
+* RBus systemc program.
+*
+* @author Yu-Cheng Huang
+* @email timhuang@realtek.com.tw
+* @date 2013/5/17
+* @version 802
+* @ingroup model_rbus
+*
+*/
+
+#ifndef _RBUS_CBUS_REG_H_
+#define _RBUS_CBUS_REG_H_
+
+#include "rbusTypes.h"
+
+
+
+
+// CBUS Register Address
+
+#define CBUS_STANDBY_00_VADDR                 (0xb8037400)
+#define CBUS_STANDBY_01_VADDR                 (0xb8037404)
+#define CBUS_STANDBY_02_VADDR                 (0xb8037408)
+#define CBUS_STANDBY_04_VADDR                 (0xb8037410)
+#define CBUS_STANDBY_05_VADDR                 (0xb8037414)
+#define CBUS_STANDBY_06_VADDR                 (0xb8037418)
+#define CBUS_STANDBY_07_VADDR                 (0xb803741c)
+#define CBUS_STANDBY_08_VADDR                 (0xb8037420)
+#define CBUS_STANDBY_09_VADDR                 (0xb8037424)
+#define CBUS_CBUS_PHY_0_VADDR                      (0xb8037430)
+#define CBUS_CBUS_PHY_1_VADDR                      (0xb8037434)
+#define CBUS_CBUS_PHY_2_VADDR                      (0xb8037438)
+#define CBUS_CBUS_PHY_3_VADDR                      (0xb803743c)
+#define CBUS_MSC_REG_00_VADDR                      (0xb800f000)
+#define CBUS_MSC_REG_01_VADDR                      (0xb800f004)
+#define CBUS_MSC_REG_02_VADDR                      (0xb800f008)
+#define CBUS_MSC_REG_03_VADDR                      (0xb800f00c)
+#define CBUS_MSC_REG_04_VADDR                      (0xb800f010)
+#define CBUS_MSC_REG_05_VADDR                      (0xb800f014)
+#define CBUS_MSC_REG_06_VADDR                      (0xb800f018)
+#define CBUS_MSC_REG_07_VADDR                      (0xb800f01c)
+#define CBUS_MSC_REG_08_VADDR                      (0xb800f020)
+#define CBUS_MSC_REG_09_VADDR                      (0xb800f024)
+#define CBUS_MSC_REG_0A_VADDR                      (0xb800f028)
+#define CBUS_MSC_REG_0B_VADDR                      (0xb800f02c)
+#define CBUS_MSC_REG_0C_VADDR                      (0xb800f030)
+#define CBUS_MSC_REG_0D_VADDR                      (0xb800f034)
+#define CBUS_MSC_REG_0E_VADDR                      (0xb800f038)
+#define CBUS_MSC_REG_0F_VADDR                      (0xb800f03c)
+#define CBUS_MSC_REG_20_VADDR                      (0xb800f080)
+#define CBUS_MSC_REG_21_VADDR                      (0xb800f084)
+#define CBUS_MSC_REG_22_VADDR                      (0xb800f088)
+#define CBUS_MSC_REG_23_VADDR                      (0xb800f08c)
+#define CBUS_MSC_REG_24_VADDR                      (0xb800f090)
+#define CBUS_MSC_REG_25_VADDR                      (0xb800f094)
+#define CBUS_MSC_REG_26_VADDR                      (0xb800f098)
+#define CBUS_MSC_REG_27_VADDR                      (0xb800f09c)
+#define CBUS_MSC_REG_30_VADDR                      (0xb800f0c0)
+#define CBUS_MSC_REG_31_VADDR                      (0xb800f0c4)
+#define CBUS_MSC_REG_32_VADDR                      (0xb800f0c8)
+#define CBUS_MSC_REG_33_VADDR                      (0xb800f0cc)
+#define CBUS_MSC_REG_34_VADDR                      (0xb800f0d0)
+#define CBUS_MSC_REG_35_VADDR                      (0xb800f0d4)
+#define CBUS_MSC_REG_36_VADDR                      (0xb800f0d8)
+#define CBUS_MSC_REG_37_VADDR                      (0xb800f0dc)
+#define CBUS_MSC_REG_40_VADDR                      (0xb800f100)
+#define CBUS_MSC_REG_41_VADDR                      (0xb800f104)
+#define CBUS_MSC_REG_42_VADDR                      (0xb800f108)
+#define CBUS_MSC_REG_43_VADDR                      (0xb800f10c)
+#define CBUS_MSC_REG_44_VADDR                      (0xb800f110)
+#define CBUS_MSC_REG_45_VADDR                      (0xb800f114)
+#define CBUS_MSC_REG_46_VADDR                      (0xb800f118)
+#define CBUS_MSC_REG_47_VADDR                      (0xb800f11c)
+#define CBUS_MSC_REG_48_VADDR                      (0xb800f120)
+#define CBUS_MSC_REG_49_VADDR                      (0xb800f124)
+#define CBUS_MSC_REG_4A_VADDR                      (0xb800f128)
+#define CBUS_MSC_REG_4B_VADDR                      (0xb800f12c)
+#define CBUS_MSC_REG_4C_VADDR                      (0xb800f130)
+#define CBUS_MSC_REG_4D_VADDR                      (0xb800f134)
+#define CBUS_MSC_REG_4E_VADDR                      (0xb800f138)
+#define CBUS_MSC_REG_4F_VADDR                      (0xb800f13c)
+#define CBUS_MSC_REG_50_VADDR                      (0xb800f140)
+#define CBUS_MSC_REG_51_VADDR                      (0xb800f144)
+#define CBUS_MSC_REG_52_VADDR                      (0xb800f148)
+#define CBUS_MSC_REG_53_VADDR                      (0xb800f14c)
+#define CBUS_MSC_REG_54_VADDR                      (0xb800f150)
+#define CBUS_MSC_REG_55_VADDR                      (0xb800f154)
+#define CBUS_MSC_REG_56_VADDR                      (0xb800f158)
+#define CBUS_MSC_REG_57_VADDR                      (0xb800f15c)
+#define CBUS_MSC_REG_58_VADDR                      (0xb800f160)
+#define CBUS_MSC_REG_59_VADDR                      (0xb800f164)
+#define CBUS_MSC_REG_5A_VADDR                      (0xb800f168)
+#define CBUS_MSC_REG_5B_VADDR                      (0xb800f16c)
+#define CBUS_MSC_REG_5C_VADDR                      (0xb800f170)
+#define CBUS_MSC_REG_5D_VADDR                      (0xb800f174)
+#define CBUS_MSC_REG_5E_VADDR                      (0xb800f178)
+#define CBUS_MSC_REG_5F_VADDR                      (0xb800f17c)
+#define CBUS_LINK_00_VADDR                    (0xb800f200)
+#define CBUS_LINK_01_VADDR                    (0xb800f204)
+#define CBUS_LINK_02_VADDR                    (0xb800f208)
+#define CBUS_LINK_03_VADDR                    (0xb800f20c)
+#define CBUS_LINK_04_VADDR                    (0xb800f210)
+#define CBUS_LINK_05_VADDR                    (0xb800f214)
+#define CBUS_LINK_06_VADDR                    (0xb800f218)
+#define CBUS_LINK_07_VADDR                    (0xb800f21c)
+#define CBUS_LINK_08_VADDR                    (0xb800f220)
+#define CBUS_LINK_09_VADDR                    (0xb800f224)
+#define CBUS_LINK_0A_VADDR                    (0xb800f228)
+#define CBUS_LINK_0B_VADDR                    (0xb800f22c)
+#define CBUS_LINK_0C_VADDR                    (0xb800f230)
+#define CBUS_LINK_0D_VADDR                    (0xb800f234)
+#define CBUS_LINK_0E_VADDR                    (0xb800f238)
+#define CBUS_LINK_0F_VADDR                    (0xb800f23c)
+#define CBUS_LINK_10_VADDR                    (0xb800f240)
+#define CBUS_LINK_11_VADDR                    (0xb800f244)
+#define CBUS_LINK_12_VADDR                    (0xb800f248)
+#define CBUS_LINK_13_VADDR                    (0xb800f24c)
+#define CBUS_LINK_14_VADDR                    (0xb800f250)
+#define CBUS_MSC_00_VADDR                     (0xb800f260)
+#define CBUS_MSC_01_VADDR                     (0xb800f264)
+#define CBUS_MSC_02_VADDR                     (0xb800f268)
+#define CBUS_MSC_03_VADDR                     (0xb800f26c)
+#define CBUS_MSC_04_VADDR                     (0xb800f270)
+#define CBUS_MSC_05_VADDR                     (0xb800f274)
+#define CBUS_MSC_06_VADDR                     (0xb800f278)
+#define CBUS_MSC_07_VADDR                     (0xb800f27c)
+#define CBUS_MSC_08_VADDR                     (0xb800f280)
+#define CBUS_MSC_09_VADDR                     (0xb800f284)
+#define CBUS_MSC_0A_VADDR                     (0xb800f288)
+#define CBUS_MSC_0B_VADDR                     (0xb800f28c)
+#define CBUS_MSC_0C_VADDR                     (0xb800f290)
+#define CBUS_MSC_0D_VADDR                     (0xb800f294)
+#define CBUS_MSC_0E_VADDR                     (0xb800f298)
+#define CBUS_MSC_0F_VADDR                     (0xb800f29c)
+#define CBUS_MSC_10_VADDR                     (0xb800f2a0)
+#define CBUS_MSC_11_VADDR                     (0xb800f2a4)
+#define CBUS_MSC_12_VADDR                     (0xb800f2a8)
+#define CBUS_MSC_13_VADDR                     (0xb800f2ac)
+#define CBUS_MSC_14_VADDR                     (0xb800f2b0)
+#define CBUS_MSC_15_VADDR                     (0xb800f2b4)
+#define CBUS_MSC_16_VADDR                     (0xb800f2b8)
+#define CBUS_MSC_17_VADDR                     (0xb800f2bc)
+#define CBUS_MSC_18_VADDR                     (0xb800f2c0)
+#define CBUS_MSC_19_VADDR                     (0xb800f2c4)
+#define CBUS_MSC_1A_VADDR                     (0xb800f2c8)
+#define CBUS_MSC_1B_VADDR                     (0xb800f2cc)
+#define CBUS_MSC_1C_VADDR                     (0xb800f2d0)
+#define CBUS_MSC_1D_VADDR                     (0xb800f2d4)
+#define CBUS_MSC_1E_VADDR                     (0xb800f2d8)
+#define CBUS_MSC_1F_VADDR                     (0xb800f2dc)
+#define CBUS_MSC_20_VADDR                     (0xb800f2e0)
+#define CBUS_MSC_21_VADDR                     (0xb800f2e4)
+#define CBUS_MSC_22_VADDR                     (0xb800f2e8)
+#define CBUS_FW0_REQ_00_VADDR                      (0xb800f300)
+#define CBUS_FW0_REQ_01_VADDR                      (0xb800f304)
+#define CBUS_FW0_REQ_02_VADDR                      (0xb800f308)
+#define CBUS_FW0_REQ_03_VADDR                      (0xb800f30c)
+#define CBUS_FW0_REQ_04_VADDR                      (0xb800f310)
+#define CBUS_FW0_REQ_05_VADDR                      (0xb800f314)
+#define CBUS_FW0_REQ_06_VADDR                      (0xb800f318)
+#define CBUS_FW0_REQ_07_VADDR                      (0xb800f31c)
+#define CBUS_FW0_REQ_08_VADDR                      (0xb800f320)
+#define CBUS_FW1_REQ_00_VADDR                      (0xb800f340)
+#define CBUS_FW1_REQ_01_VADDR                      (0xb800f344)
+#define CBUS_FW1_REQ_02_VADDR                      (0xb800f348)
+#define CBUS_FW1_REQ_03_VADDR                      (0xb800f34c)
+#define CBUS_FW1_REQ_04_VADDR                      (0xb800f350)
+#define CBUS_FW1_REQ_05_VADDR                      (0xb800f354)
+#define CBUS_FW1_REQ_06_VADDR                      (0xb800f358)
+#define CBUS_FW1_REQ_07_VADDR                      (0xb800f35c)
+#define CBUS_FW1_REQ_08_VADDR                      (0xb800f360)
+#define CBUS_FW2_REQ_00_VADDR                      (0xb800f380)
+#define CBUS_FW2_REQ_01_VADDR                      (0xb800f384)
+#define CBUS_FW2_REQ_02_VADDR                      (0xb800f388)
+#define CBUS_FW2_REQ_03_VADDR                      (0xb800f38c)
+#define CBUS_FW2_REQ_04_VADDR                      (0xb800f390)
+#define CBUS_FW2_REQ_05_VADDR                      (0xb800f394)
+#define CBUS_FW2_REQ_06_VADDR                      (0xb800f398)
+#define CBUS_FW2_REQ_07_VADDR                      (0xb800f39c)
+#define CBUS_FW2_REQ_08_VADDR                      (0xb800f3a0)
+#define CBUS_DDC_00_VADDR                     (0xb800f3c0)
+#define CBUS_DDC_01_VADDR                     (0xb800f3c4)
+#define CBUS_DDC_02_VADDR                     (0xb800f3c8)
+#define CBUS_DDC_03_VADDR                     (0xb800f3cc)
+#define CBUS_DDC_04_VADDR                     (0xb800f3d0)
+#define CBUS_DDC_05_VADDR                     (0xb800f3d4)
+#define CBUS_DDC_06_VADDR                     (0xb800f3d8)
+#define CBUS_CBUS_WDOG_VADDR                       (0xb800f3e0)
+#define CBUS_INT_INDEX_VADDR                  (0xb800f3e4)
+#define CBUS_TEST_VADDR                       (0xb800f3e8)
+#define CBUS_DUMMY0_VADDR                     (0xb800f3ec)
+
+
+
+
+#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN
+
+
+//======CBUS register structure define==========
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:28;
+        RBus_UInt32  wake_pulse_det:1;
+        RBus_UInt32  dis_pulse_det:1;
+        RBus_UInt32  wake_irq_en:1;
+        RBus_UInt32  dis_irq_en:1;
+    };
+}cbus_standby_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:18;
+        RBus_UInt32  clk_1m_div:4;
+        RBus_UInt32  clk_1k_div:10;
+    };
+}cbus_standby_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  dis_deb_lv:3;
+        RBus_UInt32  deb_lv:3;
+        RBus_UInt32  disconn:2;
+    };
+}cbus_standby_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:18;
+        RBus_UInt32  wake_offset_low2:3;
+        RBus_UInt32  wake_offset_low:3;
+        RBus_UInt32  wake_cnt:3;
+        RBus_UInt32  wake_offset:3;
+        RBus_UInt32  cbus_disconn:1;
+        RBus_UInt32  disconn_irq_en:1;
+    };
+}cbus_standby_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  dis_upper:4;
+        RBus_UInt32  dis_lower:3;
+        RBus_UInt32  wake_eco_en:1;
+    };
+}cbus_standby_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  wake_num:3;
+        RBus_UInt32  dis_num:5;
+    };
+}cbus_standby_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  cbus_imp_auto:1;
+        RBus_UInt32  bypass_mode:1;
+        RBus_UInt32  sink_fsm_st:3;
+        RBus_UInt32  cbus_100k_en:1;
+        RBus_UInt32  cbus_1k_en:1;
+        RBus_UInt32  cbus_in_sig:1;
+    };
+}cbus_standby_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:26;
+        RBus_UInt32  goto_sink1_pos:1;
+        RBus_UInt32  goto_float:1;
+        RBus_UInt32  goto_sink1:1;
+        RBus_UInt32  cable_det:1;
+        RBus_UInt32  res2:1;
+        RBus_UInt32  dbg_sel_phy:1;
+    };
+}cbus_standby_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ctrl_09_resv:32;
+    };
+}cbus_standby_09_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:25;
+        RBus_UInt32  cbus_sr:1;
+        RBus_UInt32  cbus_smt:1;
+        RBus_UInt32  cbus_pu:1;
+        RBus_UInt32  cbus_pd:1;
+        RBus_UInt32  cbus_i:1;
+        RBus_UInt32  cbus_e2:1;
+        RBus_UInt32  cbus_e:1;
+    };
+}cbus_phy_0_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  adjr_1k:4;
+        RBus_UInt32  adjr_100k:5;
+        RBus_UInt32  auto_k_1k:1;
+        RBus_UInt32  auto_k_100k:1;
+        RBus_UInt32  en_res_cal_cbus:1;
+        RBus_UInt32  sel_cbus0_input_high:2;
+        RBus_UInt32  sel_cbus0_input_low:2;
+        RBus_UInt32  sel_cbus_0_driving:3;
+        RBus_UInt32  sel_vref_ldo:2;
+        RBus_UInt32  trim_ldo_cbus:4;
+        RBus_UInt32  triming_mode:1;
+        RBus_UInt32  en_cbus:1;
+        RBus_UInt32  en_cmp_cbus:1;
+        RBus_UInt32  en_driver_cbus:1;
+        RBus_UInt32  en_ldo_cbus:1;
+        RBus_UInt32  psm_cbus:1;
+        RBus_UInt32  sel_cbusb_gpio:1;
+    };
+}cbus_phy_1_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:31;
+        RBus_UInt32  cbus_o:1;
+    };
+}cbus_phy_2_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:20;
+        RBus_UInt32  sel_phy_soft_rst_n:1;
+        RBus_UInt32  cbus_res_tst:10;
+        RBus_UInt32  res_ok:1;
+    };
+}cbus_phy_3_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  dev_state:8;
+    };
+}msc_reg_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  mhl_ver:8;
+    };
+}msc_reg_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  dev_cat:1;
+        RBus_UInt32  plim:2;
+        RBus_UInt32  pow:1;
+        RBus_UInt32  dev_type:4;
+    };
+}msc_reg_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  adop_id_h:8;
+    };
+}msc_reg_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  adop_id_l:8;
+    };
+}msc_reg_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  vid_link_md:2;
+        RBus_UInt32  supp_vga:1;
+        RBus_UInt32  supp_islands:1;
+        RBus_UInt32  supp_ppixel:1;
+        RBus_UInt32  supp_yuv422:1;
+        RBus_UInt32  supp_yuv444:1;
+        RBus_UInt32  supp_rgb444:1;
+    };
+}msc_reg_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  aud_link_md:6;
+        RBus_UInt32  aud_8ch:1;
+        RBus_UInt32  aud_2ch:1;
+    };
+}msc_reg_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  supp_vt:1;
+        RBus_UInt32  video_type:3;
+        RBus_UInt32  vt_game:1;
+        RBus_UInt32  vt_cinema:1;
+        RBus_UInt32  vt_photo:1;
+        RBus_UInt32  vt_graphics:1;
+    };
+}msc_reg_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  ld_gui:1;
+        RBus_UInt32  ld_speaker:1;
+        RBus_UInt32  ld_record:1;
+        RBus_UInt32  ld_tuner:1;
+        RBus_UInt32  ld_media:1;
+        RBus_UInt32  ld_audio:1;
+        RBus_UInt32  ld_video:1;
+        RBus_UInt32  ld_display:1;
+    };
+}msc_reg_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  bandwid:8;
+    };
+}msc_reg_09_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  feature_flag:3;
+        RBus_UInt32  ucp_recv_supp:1;
+        RBus_UInt32  ucp_send_supp:1;
+        RBus_UInt32  sp_supp:1;
+        RBus_UInt32  rap_supp:1;
+        RBus_UInt32  rcp_supp:1;
+    };
+}msc_reg_0a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  device_id_h:8;
+    };
+}msc_reg_0b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  device_id_l:8;
+    };
+}msc_reg_0c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scr_size:8;
+    };
+}msc_reg_0d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  stat_size:4;
+        RBus_UInt32  int_size:4;
+    };
+}msc_reg_0e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  cap_0f:8;
+    };
+}msc_reg_0f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  rchg_int_7:1;
+        RBus_UInt32  rchg_int_6:1;
+        RBus_UInt32  rchg_int_5:1;
+        RBus_UInt32  cbus_3d_req:1;
+        RBus_UInt32  grt_wrt:1;
+        RBus_UInt32  req_wrt:1;
+        RBus_UInt32  dscr_chg:1;
+        RBus_UInt32  dcap_chg:1;
+    };
+}msc_reg_20_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  dchg_int_7:1;
+        RBus_UInt32  dchg_int_6:1;
+        RBus_UInt32  dchg_int_5:1;
+        RBus_UInt32  dchg_int_4:1;
+        RBus_UInt32  dchg_int_3:1;
+        RBus_UInt32  dchg_int_2:1;
+        RBus_UInt32  edid_chg:1;
+        RBus_UInt32  dchg_int_0:1;
+    };
+}msc_reg_21_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  chg22_7:1;
+        RBus_UInt32  chg22_6:1;
+        RBus_UInt32  chg22_5:1;
+        RBus_UInt32  chg22_4:1;
+        RBus_UInt32  chg22_3:1;
+        RBus_UInt32  chg22_2:1;
+        RBus_UInt32  chg22_1:1;
+        RBus_UInt32  chg22_0:1;
+    };
+}msc_reg_22_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  chg23_7:1;
+        RBus_UInt32  chg23_6:1;
+        RBus_UInt32  chg23_5:1;
+        RBus_UInt32  chg23_4:1;
+        RBus_UInt32  chg23_3:1;
+        RBus_UInt32  chg23_2:1;
+        RBus_UInt32  chg23_1:1;
+        RBus_UInt32  chg23_0:1;
+    };
+}msc_reg_23_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  chg24_7:1;
+        RBus_UInt32  chg24_6:1;
+        RBus_UInt32  chg24_5:1;
+        RBus_UInt32  chg24_4:1;
+        RBus_UInt32  chg24_3:1;
+        RBus_UInt32  chg24_2:1;
+        RBus_UInt32  chg24_1:1;
+        RBus_UInt32  chg24_0:1;
+    };
+}msc_reg_24_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  chg25_7:1;
+        RBus_UInt32  chg25_6:1;
+        RBus_UInt32  chg25_5:1;
+        RBus_UInt32  chg25_4:1;
+        RBus_UInt32  chg25_3:1;
+        RBus_UInt32  chg25_2:1;
+        RBus_UInt32  chg25_1:1;
+        RBus_UInt32  chg25_0:1;
+    };
+}msc_reg_25_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  chg26_7:1;
+        RBus_UInt32  chg26_6:1;
+        RBus_UInt32  chg26_5:1;
+        RBus_UInt32  chg26_4:1;
+        RBus_UInt32  chg26_3:1;
+        RBus_UInt32  chg26_2:1;
+        RBus_UInt32  chg26_1:1;
+        RBus_UInt32  chg26_0:1;
+    };
+}msc_reg_26_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  chg27_7:1;
+        RBus_UInt32  chg27_6:1;
+        RBus_UInt32  chg27_5:1;
+        RBus_UInt32  chg27_4:1;
+        RBus_UInt32  chg27_3:1;
+        RBus_UInt32  chg27_2:1;
+        RBus_UInt32  chg27_1:1;
+        RBus_UInt32  chg27_0:1;
+    };
+}msc_reg_27_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  conn_rdy:7;
+        RBus_UInt32  dcap_rdy:1;
+    };
+}msc_reg_30_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  link_mode:3;
+        RBus_UInt32  muted:1;
+        RBus_UInt32  path_en:1;
+        RBus_UInt32  clk_mode:3;
+    };
+}msc_reg_31_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  stat_32:8;
+    };
+}msc_reg_32_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  stat_33:8;
+    };
+}msc_reg_33_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  stat_34:8;
+    };
+}msc_reg_34_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  stat_35:8;
+    };
+}msc_reg_35_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  stat_36:8;
+    };
+}msc_reg_36_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  stat_37:8;
+    };
+}msc_reg_37_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_40:8;
+    };
+}msc_reg_40_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_41:8;
+    };
+}msc_reg_41_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_42:8;
+    };
+}msc_reg_42_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_43:8;
+    };
+}msc_reg_43_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_44:8;
+    };
+}msc_reg_44_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_45:8;
+    };
+}msc_reg_45_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_46:8;
+    };
+}msc_reg_46_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_47:8;
+    };
+}msc_reg_47_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_48:8;
+    };
+}msc_reg_48_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_49:8;
+    };
+}msc_reg_49_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_4a:8;
+    };
+}msc_reg_4a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_4b:8;
+    };
+}msc_reg_4b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_4c:8;
+    };
+}msc_reg_4c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_4d:8;
+    };
+}msc_reg_4d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_4e:8;
+    };
+}msc_reg_4e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_4f:8;
+    };
+}msc_reg_4f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_50:8;
+    };
+}msc_reg_50_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_51:8;
+    };
+}msc_reg_51_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_52:8;
+    };
+}msc_reg_52_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_53:8;
+    };
+}msc_reg_53_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_54:8;
+    };
+}msc_reg_54_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_55:8;
+    };
+}msc_reg_55_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_56:8;
+    };
+}msc_reg_56_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_57:8;
+    };
+}msc_reg_57_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_58:8;
+    };
+}msc_reg_58_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_59:8;
+    };
+}msc_reg_59_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_5a:8;
+    };
+}msc_reg_5a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_5b:8;
+    };
+}msc_reg_5b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_5c:8;
+    };
+}msc_reg_5c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_5d:8;
+    };
+}msc_reg_5d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_5e:8;
+    };
+}msc_reg_5e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scratch_5f:8;
+    };
+}msc_reg_5f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:14;
+        RBus_UInt32  sync0_hb:9;
+        RBus_UInt32  sync0_lb:9;
+    };
+}cbus_link_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:16;
+        RBus_UInt32  sync1_hb:8;
+        RBus_UInt32  sync1_lb:8;
+    };
+}cbus_link_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  sync_bit_time:8;
+    };
+}cbus_link_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:23;
+        RBus_UInt32  abs_thres_en:1;
+        RBus_UInt32  abs_threshold:8;
+    };
+}cbus_link_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  parity_time:8;
+    };
+}cbus_link_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  parity_fail:1;
+        RBus_UInt32  parity_irq_en:1;
+        RBus_UInt32  ctrl_16_resv:1;
+        RBus_UInt32  parity_limit:5;
+    };
+}cbus_link_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:25;
+        RBus_UInt32  ack_fall:7;
+    };
+}cbus_link_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:25;
+        RBus_UInt32  ack_0:7;
+    };
+}cbus_link_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  tx_bit_time:8;
+    };
+}cbus_link_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  chk_win_up:3;
+        RBus_UInt32  chk_win_lo:2;
+        RBus_UInt32  fast_reply_en:1;
+        RBus_UInt32  ctrl_1b_resv:2;
+    };
+}cbus_link_09_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  res2:1;
+        RBus_UInt32  tx_ack_fal:7;
+    };
+}cbus_link_0a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:25;
+        RBus_UInt32  tx_ack_low_hb:7;
+    };
+}cbus_link_0b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:25;
+        RBus_UInt32  tx_ack_low_lb:7;
+    };
+}cbus_link_0c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  retry_lv:3;
+        RBus_UInt32  retry_flag:1;
+        RBus_UInt32  ctrl_1f_resv:4;
+    };
+}cbus_link_0d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  drv_str:2;
+        RBus_UInt32  drv_hi_cbus:6;
+    };
+}cbus_link_0e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:26;
+        RBus_UInt32  wait:4;
+        RBus_UInt32  req_opp_int:2;
+    };
+}cbus_link_0f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  req_opp_flt:8;
+    };
+}cbus_link_10_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  req_cont:8;
+    };
+}cbus_link_11_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  req_hold:4;
+        RBus_UInt32  resp_hold:4;
+    };
+}cbus_link_12_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  glob_time:2;
+        RBus_UInt32  link_time:5;
+        RBus_UInt32  link_err:1;
+    };
+}cbus_link_13_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  chk_point:6;
+        RBus_UInt32  chk_err:1;
+        RBus_UInt32  avoid_conf:1;
+    };
+}cbus_link_14_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:26;
+        RBus_UInt32  mcumsc_en:1;
+        RBus_UInt32  msc_wait_arb:1;
+        RBus_UInt32  ctrl_28_resv:4;
+    };
+}cbus_msc_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  na_msc_cmd:8;
+    };
+}cbus_msc_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  na_msc_offset:8;
+    };
+}cbus_msc_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  rx_fifo_full:1;
+        RBus_UInt32  rx_fifo_empty:1;
+        RBus_UInt32  rx_fifo_clr:1;
+        RBus_UInt32  na_rx_len:5;
+    };
+}cbus_msc_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  rx_fifo_data:8;
+    };
+}cbus_msc_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fwdef_cmd_rev:8;
+    };
+}cbus_msc_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:3;
+        RBus_UInt32  ucp_irq:1;
+        RBus_UInt32  ucpk_irq:1;
+        RBus_UInt32  ucpe_irq:1;
+        RBus_UInt32  dcap_rdy_chg:1;
+        RBus_UInt32  muted_chg:1;
+        RBus_UInt32  path_en_chg:1;
+        RBus_UInt32  clk_mode_chg:1;
+        RBus_UInt32  msge_irq:1;
+        RBus_UInt32  rcp_irq:1;
+        RBus_UInt32  rcpk_irq:1;
+        RBus_UInt32  rcpe_irq:1;
+        RBus_UInt32  rap_irq:1;
+        RBus_UInt32  rapk_irq:1;
+        RBus_UInt32  msg_sub_irq:1;
+        RBus_UInt32  wr_stat_irq:1;
+        RBus_UInt32  rd_devcap_irq:1;
+        RBus_UInt32  get_stat_irq:1;
+        RBus_UInt32  get_id_irq:1;
+        RBus_UInt32  get_msg_irq:1;
+        RBus_UInt32  sc1_err_irq:1;
+        RBus_UInt32  ddc_err_irq:1;
+        RBus_UInt32  msc_err_irq:1;
+        RBus_UInt32  wr_burst_irq:1;
+        RBus_UInt32  sc3_err_irq:1;
+        RBus_UInt32  fwdef_cmd_irq:1;
+        RBus_UInt32  allmsc_cmd_irq:1;
+        RBus_UInt32  abort_res_irq:1;
+        RBus_UInt32  abort_req_irq:1;
+        RBus_UInt32  ddc_abort_irq:1;
+    };
+}cbus_msc_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:3;
+        RBus_UInt32  ucp_irq_en:1;
+        RBus_UInt32  ucpk_irq_en:1;
+        RBus_UInt32  ucpe_irq_en:1;
+        RBus_UInt32  dcap_rdy_irq_en:1;
+        RBus_UInt32  muted_chg_irq_en:1;
+        RBus_UInt32  path_en_irq_en:1;
+        RBus_UInt32  clk_mode_irq_en:1;
+        RBus_UInt32  msge_irq_en:1;
+        RBus_UInt32  rcp_irq_en:1;
+        RBus_UInt32  rcpk_irq_en:1;
+        RBus_UInt32  rcpe_irq_en:1;
+        RBus_UInt32  rap_irq_en:1;
+        RBus_UInt32  rapk_irq_en:1;
+        RBus_UInt32  msg_sub_irq_en:1;
+        RBus_UInt32  wr_stat_irq_en:1;
+        RBus_UInt32  rd_devcap_irq_en:1;
+        RBus_UInt32  get_stat_irq_en:1;
+        RBus_UInt32  get_id_irq_en:1;
+        RBus_UInt32  get_msg_irq_en:1;
+        RBus_UInt32  sc1_err_irq_en:1;
+        RBus_UInt32  ddc_err_irq_en:1;
+        RBus_UInt32  msc_err_irq_en:1;
+        RBus_UInt32  wr_burst_irq_en:1;
+        RBus_UInt32  sc3_err_irq_en:1;
+        RBus_UInt32  fwdef_cmd_irq_en:1;
+        RBus_UInt32  allmsc_cmd_irq_en:1;
+        RBus_UInt32  abort_res_irq_en:1;
+        RBus_UInt32  abort_req_irq_en:1;
+        RBus_UInt32  ddc_abort_irq_en:1;
+    };
+}cbus_msc_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  rchg_irq_en:3;
+        RBus_UInt32  cbus_3d_req_irq_en:1;
+        RBus_UInt32  grt_irq_en:1;
+        RBus_UInt32  req_irq_en:1;
+        RBus_UInt32  dscr_irq_en:1;
+        RBus_UInt32  dcap_irq_en:1;
+        RBus_UInt32  dchg_bit7_irq_en:1;
+        RBus_UInt32  dchg_bit6_irq_en:1;
+        RBus_UInt32  dchg_bit5_irq_en:1;
+        RBus_UInt32  dchg_bit4_irq_en:1;
+        RBus_UInt32  dchg_bit3_irq_en:1;
+        RBus_UInt32  dchg_bit2_irq_en:1;
+        RBus_UInt32  edid_irq_en:1;
+        RBus_UInt32  dchg_bit0_irq_en:1;
+        RBus_UInt32  chg22_irq_en:8;
+        RBus_UInt32  chg23_irq_en:8;
+    };
+}cbus_msc_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  chg24_irq_en:8;
+        RBus_UInt32  chg25_irq_en:8;
+        RBus_UInt32  chg26_irq_en:8;
+        RBus_UInt32  chg27_irq_en:8;
+    };
+}cbus_msc_09_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  msc_err_code:8;
+    };
+}cbus_msc_0a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:22;
+        RBus_UInt32  rcp_reply_abort:1;
+        RBus_UInt32  rcp_reply_nack:1;
+        RBus_UInt32  vendor_id:8;
+    };
+}cbus_msc_0b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  msg_cmd:8;
+    };
+}cbus_msc_0c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  msg_dat:8;
+    };
+}cbus_msc_0d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  msge_rcv:8;
+    };
+}cbus_msc_0e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  rcp_rcv:8;
+    };
+}cbus_msc_0f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  rcpk_rcv:8;
+    };
+}cbus_msc_10_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  rcpe_rcv:8;
+    };
+}cbus_msc_11_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  rap_rcv:8;
+    };
+}cbus_msc_12_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  rapk_rcv:8;
+    };
+}cbus_msc_13_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:26;
+        RBus_UInt32  burst_timeout:1;
+        RBus_UInt32  wb_id_chk:1;
+        RBus_UInt32  burst_wait:4;
+    };
+}cbus_msc_14_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:16;
+        RBus_UInt32  adop_idh_rcv:8;
+        RBus_UInt32  adop_idl_rcv:8;
+    };
+}cbus_msc_15_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:2;
+        RBus_UInt32  auto_handshake:1;
+        RBus_UInt32  insert_id:1;
+        RBus_UInt32  wb_byte_num0:6;
+        RBus_UInt32  wb_byte_num1:6;
+        RBus_UInt32  adop_txid_h:8;
+        RBus_UInt32  adop_txid_l:8;
+    };
+}cbus_msc_16_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:29;
+        RBus_UInt32  que_fsm_clr:1;
+        RBus_UInt32  sch_fsm_clr:1;
+        RBus_UInt32  spi_fsm_clr:1;
+    };
+}cbus_msc_17_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:20;
+        RBus_UInt32  que_fsm:4;
+        RBus_UInt32  sch_fsm:4;
+        RBus_UInt32  spi_fsm:4;
+    };
+}cbus_msc_18_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  cap_offset:8;
+    };
+}cbus_msc_19_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  int_offset:8;
+    };
+}cbus_msc_1a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  sta_offset:8;
+    };
+}cbus_msc_1b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  scr_offset:8;
+    };
+}cbus_msc_1c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:30;
+        RBus_UInt32  ddc_err_force:1;
+        RBus_UInt32  msc_err_force:1;
+    };
+}cbus_msc_1d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  ddc_err_fw:8;
+    };
+}cbus_msc_1e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  msc_err_fw:8;
+    };
+}cbus_msc_1f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  ucp_rcv:8;
+    };
+}cbus_msc_20_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  ucpk_rcv:8;
+    };
+}cbus_msc_21_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  ucpe_rcv:8;
+    };
+}cbus_msc_22_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:23;
+        RBus_UInt32  fw0_req:1;
+        RBus_UInt32  fw0_fifo_clr:1;
+        RBus_UInt32  fw0_fifo_full:1;
+        RBus_UInt32  fw0_fifo_empty:1;
+        RBus_UInt32  fw0_tx_case:3;
+        RBus_UInt32  fw0_head:2;
+    };
+}fw0_req_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw0_cmd1:8;
+    };
+}fw0_req_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw0_cmd2:8;
+    };
+}fw0_req_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw0_offset:8;
+    };
+}fw0_req_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw0_data:8;
+    };
+}fw0_req_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:22;
+        RBus_UInt32  fw0_rty_ovr:1;
+        RBus_UInt32  fw0_fin:1;
+        RBus_UInt32  fw0_cmd_event:1;
+        RBus_UInt32  fw0_data_event:1;
+        RBus_UInt32  fw0_rcv_err:1;
+        RBus_UInt32  fw0_fin_irq_en:1;
+        RBus_UInt32  fw0_cmd_irq_en:1;
+        RBus_UInt32  fw0_data_irq_en:1;
+        RBus_UInt32  fw0_wait_case:2;
+    };
+}fw0_req_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw0_cmd_rcv:8;
+    };
+}fw0_req_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw0_data_rcv:8;
+    };
+}fw0_req_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:18;
+        RBus_UInt32  fw0_rd_en:1;
+        RBus_UInt32  fw0_fifo_len:5;
+        RBus_UInt32  fw0_rdata:8;
+    };
+}fw0_req_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:23;
+        RBus_UInt32  fw1_req:1;
+        RBus_UInt32  fw1_fifo_clr:1;
+        RBus_UInt32  fw1_fifo_full:1;
+        RBus_UInt32  fw1_fifo_empty:1;
+        RBus_UInt32  fw1_tx_case:3;
+        RBus_UInt32  fw1_head:2;
+    };
+}fw1_req_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw1_cmd1:8;
+    };
+}fw1_req_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw1_cmd2:8;
+    };
+}fw1_req_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw1_offset:8;
+    };
+}fw1_req_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw1_data:8;
+    };
+}fw1_req_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:22;
+        RBus_UInt32  fw1_rty_ovr:1;
+        RBus_UInt32  fw1_fin:1;
+        RBus_UInt32  fw1_cmd_event:1;
+        RBus_UInt32  fw1_data_event:1;
+        RBus_UInt32  fw1_rcv_err:1;
+        RBus_UInt32  fw1_fin_irq_en:1;
+        RBus_UInt32  fw1_cmd_irq_en:1;
+        RBus_UInt32  fw1_data_irq_en:1;
+        RBus_UInt32  fw1_wait_case:2;
+    };
+}fw1_req_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw1_cmd_rcv:8;
+    };
+}fw1_req_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw1_data_rcv:8;
+    };
+}fw1_req_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:18;
+        RBus_UInt32  fw1_rd_en:1;
+        RBus_UInt32  fw1_fifo_len:5;
+        RBus_UInt32  fw1_rdata:8;
+    };
+}fw1_req_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:23;
+        RBus_UInt32  fw2_req:1;
+        RBus_UInt32  fw2_fifo_clr:1;
+        RBus_UInt32  fw2_fifo_full:1;
+        RBus_UInt32  fw2_fifo_empty:1;
+        RBus_UInt32  fw2_tx_case:3;
+        RBus_UInt32  fw2_head:2;
+    };
+}fw2_req_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw2_cmd1:8;
+    };
+}fw2_req_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw2_cmd2:8;
+    };
+}fw2_req_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw2_offset:8;
+    };
+}fw2_req_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw2_data:8;
+    };
+}fw2_req_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:22;
+        RBus_UInt32  fw2_rty_ovr:1;
+        RBus_UInt32  fw2_fin:1;
+        RBus_UInt32  fw2_cmd_event:1;
+        RBus_UInt32  fw2_data_event:1;
+        RBus_UInt32  fw2_rcv_err:1;
+        RBus_UInt32  fw2_fin_irq_en:1;
+        RBus_UInt32  fw2_cmd_irq_en:1;
+        RBus_UInt32  fw2_data_irq_en:1;
+        RBus_UInt32  fw2_wait_case:2;
+    };
+}fw2_req_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw2_cmd_rcv:8;
+    };
+}fw2_req_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  fw2_data_rcv:8;
+    };
+}fw2_req_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:18;
+        RBus_UInt32  fw2_rd_en:1;
+        RBus_UInt32  fw2_fifo_len:5;
+        RBus_UInt32  fw2_rdata:8;
+    };
+}fw2_req_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  ddc_err_code:8;
+    };
+}cbus_ddc_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  iic_ck_tgt:8;
+    };
+}cbus_ddc_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  mcuddc_en:1;
+        RBus_UInt32  ddc_prior_dis:1;
+        RBus_UInt32  ddc_cmd_event:1;
+        RBus_UInt32  ddc_data_event:1;
+        RBus_UInt32  ddc_cmd_irq_en:1;
+        RBus_UInt32  ddc_data_irq_en:1;
+        RBus_UInt32  ddc_req_ctrl:1;
+        RBus_UInt32  ddc_req:1;
+    };
+}cbus_ddc_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  ddc_rcv_cmd:8;
+    };
+}cbus_ddc_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  ddc_rcv_data:8;
+    };
+}cbus_ddc_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  ddc_data_fw:8;
+    };
+}cbus_ddc_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:28;
+        RBus_UInt32  ddc_eof_irq:1;
+        RBus_UInt32  ddc_eof_irq_en:1;
+        RBus_UInt32  ddcrd_rst_en:1;
+        RBus_UInt32  ddcrd_new_md:1;
+    };
+}cbus_ddc_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:26;
+        RBus_UInt32  clk_mod_vwd:1;
+        RBus_UInt32  clk_mod_awd:1;
+        RBus_UInt32  mute_en_vwd:1;
+        RBus_UInt32  mute_en_awd:1;
+        RBus_UInt32  path_en_off_vwd:1;
+        RBus_UInt32  path_en_off_awd:1;
+    };
+}cbus_wdog_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:26;
+        RBus_UInt32  arbiter_irq:1;
+        RBus_UInt32  ddc_irq:1;
+        RBus_UInt32  msc_ch_irq:1;
+        RBus_UInt32  msc_int_irq:1;
+        RBus_UInt32  msc_stat_irq:1;
+        RBus_UInt32  ctrl_01_resv:1;
+    };
+}cbus_int_index_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res1:24;
+        RBus_UInt32  cbus_test_md:2;
+        RBus_UInt32  fw_out:1;
+        RBus_UInt32  dbg_sel:3;
+        RBus_UInt32  res2:2;
+    };
+}cbus_test_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  cbus_dummy0:32;
+    };
+}cbus_dummy0_RBUS;
+
+
+
+
+
+#else //apply LITTLE_ENDIAN
+
+
+//======CBUS register structure define==========
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  dis_irq_en:1;
+        RBus_UInt32  wake_irq_en:1;
+        RBus_UInt32  dis_pulse_det:1;
+        RBus_UInt32  wake_pulse_det:1;
+        RBus_UInt32  res1:28;
+    };
+}cbus_standby_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  clk_1k_div:10;
+        RBus_UInt32  clk_1m_div:4;
+        RBus_UInt32  res1:18;
+    };
+}cbus_standby_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  disconn:2;
+        RBus_UInt32  deb_lv:3;
+        RBus_UInt32  dis_deb_lv:3;
+        RBus_UInt32  res1:24;
+    };
+}cbus_standby_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  disconn_irq_en:1;
+        RBus_UInt32  cbus_disconn:1;
+        RBus_UInt32  wake_offset:3;
+        RBus_UInt32  wake_cnt:3;
+        RBus_UInt32  wake_offset_low:3;
+        RBus_UInt32  wake_offset_low2:3;
+        RBus_UInt32  res1:18;
+    };
+}cbus_standby_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  wake_eco_en:1;
+        RBus_UInt32  dis_lower:3;
+        RBus_UInt32  dis_upper:4;
+        RBus_UInt32  res1:24;
+    };
+}cbus_standby_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  dis_num:5;
+        RBus_UInt32  wake_num:3;
+        RBus_UInt32  res1:24;
+    };
+}cbus_standby_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  cbus_in_sig:1;
+        RBus_UInt32  cbus_1k_en:1;
+        RBus_UInt32  cbus_100k_en:1;
+        RBus_UInt32  sink_fsm_st:3;
+        RBus_UInt32  bypass_mode:1;
+        RBus_UInt32  cbus_imp_auto:1;
+        RBus_UInt32  res1:24;
+    };
+}cbus_standby_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  dbg_sel_phy:1;
+        RBus_UInt32  res2:1;
+        RBus_UInt32  cable_det:1;
+        RBus_UInt32  goto_sink1:1;
+        RBus_UInt32  goto_float:1;
+        RBus_UInt32  goto_sink1_pos:1;
+        RBus_UInt32  res1:26;
+    };
+}cbus_standby_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ctrl_09_resv:32;
+    };
+}cbus_standby_09_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  cbus_e:1;
+        RBus_UInt32  cbus_e2:1;
+        RBus_UInt32  cbus_i:1;
+        RBus_UInt32  cbus_pd:1;
+        RBus_UInt32  cbus_pu:1;
+        RBus_UInt32  cbus_smt:1;
+        RBus_UInt32  cbus_sr:1;
+        RBus_UInt32  res1:25;
+    };
+}cbus_phy_0_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  sel_cbusb_gpio:1;
+        RBus_UInt32  psm_cbus:1;
+        RBus_UInt32  en_ldo_cbus:1;
+        RBus_UInt32  en_driver_cbus:1;
+        RBus_UInt32  en_cmp_cbus:1;
+        RBus_UInt32  en_cbus:1;
+        RBus_UInt32  triming_mode:1;
+        RBus_UInt32  trim_ldo_cbus:4;
+        RBus_UInt32  sel_vref_ldo:2;
+        RBus_UInt32  sel_cbus_0_driving:3;
+        RBus_UInt32  sel_cbus0_input_low:2;
+        RBus_UInt32  sel_cbus0_input_high:2;
+        RBus_UInt32  en_res_cal_cbus:1;
+        RBus_UInt32  auto_k_100k:1;
+        RBus_UInt32  auto_k_1k:1;
+        RBus_UInt32  adjr_100k:5;
+        RBus_UInt32  adjr_1k:4;
+    };
+}cbus_phy_1_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  cbus_o:1;
+        RBus_UInt32  res1:31;
+    };
+}cbus_phy_2_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res_ok:1;
+        RBus_UInt32  cbus_res_tst:10;
+        RBus_UInt32  sel_phy_soft_rst_n:1;
+        RBus_UInt32  res1:20;
+    };
+}cbus_phy_3_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  dev_state:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  mhl_ver:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  dev_type:4;
+        RBus_UInt32  pow:1;
+        RBus_UInt32  plim:2;
+        RBus_UInt32  dev_cat:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  adop_id_h:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  adop_id_l:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  supp_rgb444:1;
+        RBus_UInt32  supp_yuv444:1;
+        RBus_UInt32  supp_yuv422:1;
+        RBus_UInt32  supp_ppixel:1;
+        RBus_UInt32  supp_islands:1;
+        RBus_UInt32  supp_vga:1;
+        RBus_UInt32  vid_link_md:2;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  aud_2ch:1;
+        RBus_UInt32  aud_8ch:1;
+        RBus_UInt32  aud_link_md:6;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  vt_graphics:1;
+        RBus_UInt32  vt_photo:1;
+        RBus_UInt32  vt_cinema:1;
+        RBus_UInt32  vt_game:1;
+        RBus_UInt32  video_type:3;
+        RBus_UInt32  supp_vt:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ld_display:1;
+        RBus_UInt32  ld_video:1;
+        RBus_UInt32  ld_audio:1;
+        RBus_UInt32  ld_media:1;
+        RBus_UInt32  ld_tuner:1;
+        RBus_UInt32  ld_record:1;
+        RBus_UInt32  ld_speaker:1;
+        RBus_UInt32  ld_gui:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  bandwid:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_09_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  rcp_supp:1;
+        RBus_UInt32  rap_supp:1;
+        RBus_UInt32  sp_supp:1;
+        RBus_UInt32  ucp_send_supp:1;
+        RBus_UInt32  ucp_recv_supp:1;
+        RBus_UInt32  feature_flag:3;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_0a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  device_id_h:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_0b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  device_id_l:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_0c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scr_size:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_0d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  int_size:4;
+        RBus_UInt32  stat_size:4;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_0e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  cap_0f:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_0f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  dcap_chg:1;
+        RBus_UInt32  dscr_chg:1;
+        RBus_UInt32  req_wrt:1;
+        RBus_UInt32  grt_wrt:1;
+        RBus_UInt32  cbus_3d_req:1;
+        RBus_UInt32  rchg_int_5:1;
+        RBus_UInt32  rchg_int_6:1;
+        RBus_UInt32  rchg_int_7:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_20_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  dchg_int_0:1;
+        RBus_UInt32  edid_chg:1;
+        RBus_UInt32  dchg_int_2:1;
+        RBus_UInt32  dchg_int_3:1;
+        RBus_UInt32  dchg_int_4:1;
+        RBus_UInt32  dchg_int_5:1;
+        RBus_UInt32  dchg_int_6:1;
+        RBus_UInt32  dchg_int_7:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_21_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  chg22_0:1;
+        RBus_UInt32  chg22_1:1;
+        RBus_UInt32  chg22_2:1;
+        RBus_UInt32  chg22_3:1;
+        RBus_UInt32  chg22_4:1;
+        RBus_UInt32  chg22_5:1;
+        RBus_UInt32  chg22_6:1;
+        RBus_UInt32  chg22_7:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_22_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  chg23_0:1;
+        RBus_UInt32  chg23_1:1;
+        RBus_UInt32  chg23_2:1;
+        RBus_UInt32  chg23_3:1;
+        RBus_UInt32  chg23_4:1;
+        RBus_UInt32  chg23_5:1;
+        RBus_UInt32  chg23_6:1;
+        RBus_UInt32  chg23_7:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_23_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  chg24_0:1;
+        RBus_UInt32  chg24_1:1;
+        RBus_UInt32  chg24_2:1;
+        RBus_UInt32  chg24_3:1;
+        RBus_UInt32  chg24_4:1;
+        RBus_UInt32  chg24_5:1;
+        RBus_UInt32  chg24_6:1;
+        RBus_UInt32  chg24_7:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_24_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  chg25_0:1;
+        RBus_UInt32  chg25_1:1;
+        RBus_UInt32  chg25_2:1;
+        RBus_UInt32  chg25_3:1;
+        RBus_UInt32  chg25_4:1;
+        RBus_UInt32  chg25_5:1;
+        RBus_UInt32  chg25_6:1;
+        RBus_UInt32  chg25_7:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_25_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  chg26_0:1;
+        RBus_UInt32  chg26_1:1;
+        RBus_UInt32  chg26_2:1;
+        RBus_UInt32  chg26_3:1;
+        RBus_UInt32  chg26_4:1;
+        RBus_UInt32  chg26_5:1;
+        RBus_UInt32  chg26_6:1;
+        RBus_UInt32  chg26_7:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_26_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  chg27_0:1;
+        RBus_UInt32  chg27_1:1;
+        RBus_UInt32  chg27_2:1;
+        RBus_UInt32  chg27_3:1;
+        RBus_UInt32  chg27_4:1;
+        RBus_UInt32  chg27_5:1;
+        RBus_UInt32  chg27_6:1;
+        RBus_UInt32  chg27_7:1;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_27_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  dcap_rdy:1;
+        RBus_UInt32  conn_rdy:7;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_30_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  clk_mode:3;
+        RBus_UInt32  path_en:1;
+        RBus_UInt32  muted:1;
+        RBus_UInt32  link_mode:3;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_31_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  stat_32:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_32_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  stat_33:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_33_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  stat_34:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_34_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  stat_35:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_35_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  stat_36:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_36_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  stat_37:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_37_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_40:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_40_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_41:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_41_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_42:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_42_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_43:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_43_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_44:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_44_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_45:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_45_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_46:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_46_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_47:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_47_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_48:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_48_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_49:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_49_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_4a:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_4a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_4b:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_4b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_4c:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_4c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_4d:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_4d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_4e:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_4e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_4f:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_4f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_50:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_50_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_51:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_51_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_52:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_52_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_53:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_53_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_54:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_54_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_55:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_55_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_56:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_56_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_57:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_57_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_58:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_58_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_59:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_59_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_5a:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_5a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_5b:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_5b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_5c:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_5c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_5d:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_5d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_5e:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_5e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scratch_5f:8;
+        RBus_UInt32  res1:24;
+    };
+}msc_reg_5f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  sync0_lb_8_0:9;
+        RBus_UInt32  sync0_hb_8_0:9;
+        RBus_UInt32  res1:14;
+    };
+}cbus_link_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  sync1_lb_7_0:8;
+        RBus_UInt32  sync1_hb_7_0:8;
+        RBus_UInt32  res1:16;
+    };
+}cbus_link_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  sync_bit_time:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  abs_threshold:8;
+        RBus_UInt32  abs_thres_en:1;
+        RBus_UInt32  res1:23;
+    };
+}cbus_link_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  parity_time:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  parity_limit:5;
+        RBus_UInt32  ctrl_16_resv:1;
+        RBus_UInt32  parity_irq_en:1;
+        RBus_UInt32  parity_fail:1;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ack_fall:7;
+        RBus_UInt32  res1:25;
+    };
+}cbus_link_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ack_0:7;
+        RBus_UInt32  res1:25;
+    };
+}cbus_link_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  tx_bit_time:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ctrl_1b_resv:2;
+        RBus_UInt32  fast_reply_en:1;
+        RBus_UInt32  chk_win_lo:2;
+        RBus_UInt32  chk_win_up:3;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_09_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  tx_ack_fal:7;
+        RBus_UInt32  res2:1;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_0a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  tx_ack_low_hb:7;
+        RBus_UInt32  res1:25;
+    };
+}cbus_link_0b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  tx_ack_low_lb:7;
+        RBus_UInt32  res1:25;
+    };
+}cbus_link_0c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ctrl_1f_resv:4;
+        RBus_UInt32  retry_flag:1;
+        RBus_UInt32  retry_lv:3;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_0d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  drv_hi_cbus:6;
+        RBus_UInt32  drv_str:2;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_0e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  req_opp_int:2;
+        RBus_UInt32  wait:4;
+        RBus_UInt32  res1:26;
+    };
+}cbus_link_0f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  req_opp_flt:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_10_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  req_cont:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_11_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  resp_hold:4;
+        RBus_UInt32  req_hold:4;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_12_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  link_err:1;
+        RBus_UInt32  link_time:5;
+        RBus_UInt32  glob_time:2;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_13_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  avoid_conf:1;
+        RBus_UInt32  chk_err:1;
+        RBus_UInt32  chk_point:6;
+        RBus_UInt32  res1:24;
+    };
+}cbus_link_14_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ctrl_28_resv:4;
+        RBus_UInt32  msc_wait_arb:1;
+        RBus_UInt32  mcumsc_en:1;
+        RBus_UInt32  res1:26;
+    };
+}cbus_msc_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  na_msc_cmd:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  na_msc_offset:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  na_rx_len:5;
+        RBus_UInt32  rx_fifo_clr:1;
+        RBus_UInt32  rx_fifo_empty:1;
+        RBus_UInt32  rx_fifo_full:1;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  rx_fifo_data:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fwdef_cmd_rev:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ddc_abort_irq:1;
+        RBus_UInt32  abort_req_irq:1;
+        RBus_UInt32  abort_res_irq:1;
+        RBus_UInt32  allmsc_cmd_irq:1;
+        RBus_UInt32  fwdef_cmd_irq:1;
+        RBus_UInt32  sc3_err_irq:1;
+        RBus_UInt32  wr_burst_irq:1;
+        RBus_UInt32  msc_err_irq:1;
+        RBus_UInt32  ddc_err_irq:1;
+        RBus_UInt32  sc1_err_irq:1;
+        RBus_UInt32  get_msg_irq:1;
+        RBus_UInt32  get_id_irq:1;
+        RBus_UInt32  get_stat_irq:1;
+        RBus_UInt32  rd_devcap_irq:1;
+        RBus_UInt32  wr_stat_irq:1;
+        RBus_UInt32  msg_sub_irq:1;
+        RBus_UInt32  rapk_irq:1;
+        RBus_UInt32  rap_irq:1;
+        RBus_UInt32  rcpe_irq:1;
+        RBus_UInt32  rcpk_irq:1;
+        RBus_UInt32  rcp_irq:1;
+        RBus_UInt32  msge_irq:1;
+        RBus_UInt32  clk_mode_chg:1;
+        RBus_UInt32  path_en_chg:1;
+        RBus_UInt32  muted_chg:1;
+        RBus_UInt32  dcap_rdy_chg:1;
+        RBus_UInt32  ucpe_irq:1;
+        RBus_UInt32  ucpk_irq:1;
+        RBus_UInt32  ucp_irq:1;
+        RBus_UInt32  res1:3;
+    };
+}cbus_msc_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ddc_abort_irq_en:1;
+        RBus_UInt32  abort_req_irq_en:1;
+        RBus_UInt32  abort_res_irq_en:1;
+        RBus_UInt32  allmsc_cmd_irq_en:1;
+        RBus_UInt32  fwdef_cmd_irq_en:1;
+        RBus_UInt32  sc3_err_irq_en:1;
+        RBus_UInt32  wr_burst_irq_en:1;
+        RBus_UInt32  msc_err_irq_en:1;
+        RBus_UInt32  ddc_err_irq_en:1;
+        RBus_UInt32  sc1_err_irq_en:1;
+        RBus_UInt32  get_msg_irq_en:1;
+        RBus_UInt32  get_id_irq_en:1;
+        RBus_UInt32  get_stat_irq_en:1;
+        RBus_UInt32  rd_devcap_irq_en:1;
+        RBus_UInt32  wr_stat_irq_en:1;
+        RBus_UInt32  msg_sub_irq_en:1;
+        RBus_UInt32  rapk_irq_en:1;
+        RBus_UInt32  rap_irq_en:1;
+        RBus_UInt32  rcpe_irq_en:1;
+        RBus_UInt32  rcpk_irq_en:1;
+        RBus_UInt32  rcp_irq_en:1;
+        RBus_UInt32  msge_irq_en:1;
+        RBus_UInt32  clk_mode_irq_en:1;
+        RBus_UInt32  path_en_irq_en:1;
+        RBus_UInt32  muted_chg_irq_en:1;
+        RBus_UInt32  dcap_rdy_irq_en:1;
+        RBus_UInt32  ucpe_irq_en:1;
+        RBus_UInt32  ucpk_irq_en:1;
+        RBus_UInt32  ucp_irq_en:1;
+        RBus_UInt32  res1:3;
+    };
+}cbus_msc_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  chg23_irq_en:8;
+        RBus_UInt32  chg22_irq_en:8;
+        RBus_UInt32  dchg_bit0_irq_en:1;
+        RBus_UInt32  edid_irq_en:1;
+        RBus_UInt32  dchg_bit2_irq_en:1;
+        RBus_UInt32  dchg_bit3_irq_en:1;
+        RBus_UInt32  dchg_bit4_irq_en:1;
+        RBus_UInt32  dchg_bit5_irq_en:1;
+        RBus_UInt32  dchg_bit6_irq_en:1;
+        RBus_UInt32  dchg_bit7_irq_en:1;
+        RBus_UInt32  dcap_irq_en:1;
+        RBus_UInt32  dscr_irq_en:1;
+        RBus_UInt32  req_irq_en:1;
+        RBus_UInt32  grt_irq_en:1;
+        RBus_UInt32  cbus_3d_req_irq_en:1;
+        RBus_UInt32  rchg_irq_en:3;
+    };
+}cbus_msc_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  chg27_irq_en:8;
+        RBus_UInt32  chg26_irq_en:8;
+        RBus_UInt32  chg25_irq_en:8;
+        RBus_UInt32  chg24_irq_en:8;
+    };
+}cbus_msc_09_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  msc_err_code:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_0a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  vendor_id:8;
+        RBus_UInt32  rcp_reply_nack:1;
+        RBus_UInt32  rcp_reply_abort:1;
+        RBus_UInt32  res1:22;
+    };
+}cbus_msc_0b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  msg_cmd:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_0c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  msg_dat:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_0d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  msge_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_0e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  rcp_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_0f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  rcpk_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_10_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  rcpe_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_11_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  rap_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_12_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  rapk_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_13_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  burst_wait:4;
+        RBus_UInt32  wb_id_chk:1;
+        RBus_UInt32  burst_timeout:1;
+        RBus_UInt32  res1:26;
+    };
+}cbus_msc_14_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  adop_idl_rcv:8;
+        RBus_UInt32  adop_idh_rcv:8;
+        RBus_UInt32  res1:16;
+    };
+}cbus_msc_15_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  adop_txid_l:8;
+        RBus_UInt32  adop_txid_h:8;
+        RBus_UInt32  wb_byte_num1:6;
+        RBus_UInt32  wb_byte_num0:6;
+        RBus_UInt32  insert_id:1;
+        RBus_UInt32  auto_handshake:1;
+        RBus_UInt32  res1:2;
+    };
+}cbus_msc_16_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  spi_fsm_clr:1;
+        RBus_UInt32  sch_fsm_clr:1;
+        RBus_UInt32  que_fsm_clr:1;
+        RBus_UInt32  res1:29;
+    };
+}cbus_msc_17_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  spi_fsm:4;
+        RBus_UInt32  sch_fsm:4;
+        RBus_UInt32  que_fsm:4;
+        RBus_UInt32  res1:20;
+    };
+}cbus_msc_18_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  cap_offset:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_19_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  int_offset:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_1a_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  sta_offset:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_1b_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  scr_offset:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_1c_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  msc_err_force:1;
+        RBus_UInt32  ddc_err_force:1;
+        RBus_UInt32  res1:30;
+    };
+}cbus_msc_1d_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ddc_err_fw:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_1e_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  msc_err_fw:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_1f_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ucp_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_20_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ucpk_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_21_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ucpe_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_msc_22_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw0_head:2;
+        RBus_UInt32  fw0_tx_case:3;
+        RBus_UInt32  fw0_fifo_empty:1;
+        RBus_UInt32  fw0_fifo_full:1;
+        RBus_UInt32  fw0_fifo_clr:1;
+        RBus_UInt32  fw0_req:1;
+        RBus_UInt32  res1:23;
+    };
+}fw0_req_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw0_cmd1:8;
+        RBus_UInt32  res1:24;
+    };
+}fw0_req_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw0_cmd2:8;
+        RBus_UInt32  res1:24;
+    };
+}fw0_req_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw0_offset:8;
+        RBus_UInt32  res1:24;
+    };
+}fw0_req_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw0_data:8;
+        RBus_UInt32  res1:24;
+    };
+}fw0_req_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw0_wait_case:2;
+        RBus_UInt32  fw0_data_irq_en:1;
+        RBus_UInt32  fw0_cmd_irq_en:1;
+        RBus_UInt32  fw0_fin_irq_en:1;
+        RBus_UInt32  fw0_rcv_err:1;
+        RBus_UInt32  fw0_data_event:1;
+        RBus_UInt32  fw0_cmd_event:1;
+        RBus_UInt32  fw0_fin:1;
+        RBus_UInt32  fw0_rty_ovr:1;
+        RBus_UInt32  res1:22;
+    };
+}fw0_req_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw0_cmd_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}fw0_req_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw0_data_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}fw0_req_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw0_rdata:8;
+        RBus_UInt32  fw0_fifo_len:5;
+        RBus_UInt32  fw0_rd_en:1;
+        RBus_UInt32  res1:18;
+    };
+}fw0_req_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw1_head:2;
+        RBus_UInt32  fw1_tx_case:3;
+        RBus_UInt32  fw1_fifo_empty:1;
+        RBus_UInt32  fw1_fifo_full:1;
+        RBus_UInt32  fw1_fifo_clr:1;
+        RBus_UInt32  fw1_req:1;
+        RBus_UInt32  res1:23;
+    };
+}fw1_req_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw1_cmd1:8;
+        RBus_UInt32  res1:24;
+    };
+}fw1_req_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw1_cmd2:8;
+        RBus_UInt32  res1:24;
+    };
+}fw1_req_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw1_offset:8;
+        RBus_UInt32  res1:24;
+    };
+}fw1_req_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw1_data:8;
+        RBus_UInt32  res1:24;
+    };
+}fw1_req_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw1_wait_case:2;
+        RBus_UInt32  fw1_data_irq_en:1;
+        RBus_UInt32  fw1_cmd_irq_en:1;
+        RBus_UInt32  fw1_fin_irq_en:1;
+        RBus_UInt32  fw1_rcv_err:1;
+        RBus_UInt32  fw1_data_event:1;
+        RBus_UInt32  fw1_cmd_event:1;
+        RBus_UInt32  fw1_fin:1;
+        RBus_UInt32  fw1_rty_ovr:1;
+        RBus_UInt32  res1:22;
+    };
+}fw1_req_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw1_cmd_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}fw1_req_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw1_data_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}fw1_req_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw1_rdata:8;
+        RBus_UInt32  fw1_fifo_len:5;
+        RBus_UInt32  fw1_rd_en:1;
+        RBus_UInt32  res1:18;
+    };
+}fw1_req_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw2_head:2;
+        RBus_UInt32  fw2_tx_case:3;
+        RBus_UInt32  fw2_fifo_empty:1;
+        RBus_UInt32  fw2_fifo_full:1;
+        RBus_UInt32  fw2_fifo_clr:1;
+        RBus_UInt32  fw2_req:1;
+        RBus_UInt32  res1:23;
+    };
+}fw2_req_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw2_cmd1:8;
+        RBus_UInt32  res1:24;
+    };
+}fw2_req_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw2_cmd2:8;
+        RBus_UInt32  res1:24;
+    };
+}fw2_req_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw2_offset:8;
+        RBus_UInt32  res1:24;
+    };
+}fw2_req_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw2_data:8;
+        RBus_UInt32  res1:24;
+    };
+}fw2_req_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw2_wait_case:2;
+        RBus_UInt32  fw2_data_irq_en:1;
+        RBus_UInt32  fw2_cmd_irq_en:1;
+        RBus_UInt32  fw2_fin_irq_en:1;
+        RBus_UInt32  fw2_rcv_err:1;
+        RBus_UInt32  fw2_data_event:1;
+        RBus_UInt32  fw2_cmd_event:1;
+        RBus_UInt32  fw2_fin:1;
+        RBus_UInt32  fw2_rty_ovr:1;
+        RBus_UInt32  res1:22;
+    };
+}fw2_req_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw2_cmd_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}fw2_req_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw2_data_rcv:8;
+        RBus_UInt32  res1:24;
+    };
+}fw2_req_07_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  fw2_rdata:8;
+        RBus_UInt32  fw2_fifo_len:5;
+        RBus_UInt32  fw2_rd_en:1;
+        RBus_UInt32  res1:18;
+    };
+}fw2_req_08_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ddc_err_code:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_ddc_00_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  iic_ck_tgt:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_ddc_01_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ddc_req:1;
+        RBus_UInt32  ddc_req_ctrl:1;
+        RBus_UInt32  ddc_data_irq_en:1;
+        RBus_UInt32  ddc_cmd_irq_en:1;
+        RBus_UInt32  ddc_data_event:1;
+        RBus_UInt32  ddc_cmd_event:1;
+        RBus_UInt32  ddc_prior_dis:1;
+        RBus_UInt32  mcuddc_en:1;
+        RBus_UInt32  res1:24;
+    };
+}cbus_ddc_02_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ddc_rcv_cmd:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_ddc_03_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ddc_rcv_data:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_ddc_04_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ddc_data_fw:8;
+        RBus_UInt32  res1:24;
+    };
+}cbus_ddc_05_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ddcrd_new_md:1;
+        RBus_UInt32  ddcrd_rst_en:1;
+        RBus_UInt32  ddc_eof_irq_en:1;
+        RBus_UInt32  ddc_eof_irq:1;
+        RBus_UInt32  res1:28;
+    };
+}cbus_ddc_06_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  path_en_off_awd:1;
+        RBus_UInt32  path_en_off_vwd:1;
+        RBus_UInt32  mute_en_awd:1;
+        RBus_UInt32  mute_en_vwd:1;
+        RBus_UInt32  clk_mod_awd:1;
+        RBus_UInt32  clk_mod_vwd:1;
+        RBus_UInt32  res1:26;
+    };
+}cbus_wdog_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  ctrl_01_resv:1;
+        RBus_UInt32  msc_stat_irq:1;
+        RBus_UInt32  msc_int_irq:1;
+        RBus_UInt32  msc_ch_irq:1;
+        RBus_UInt32  ddc_irq:1;
+        RBus_UInt32  arbiter_irq:1;
+        RBus_UInt32  res1:26;
+    };
+}cbus_int_index_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  res2:2;
+        RBus_UInt32  dbg_sel:3;
+        RBus_UInt32  fw_out:1;
+        RBus_UInt32  cbus_test_md:2;
+        RBus_UInt32  res1:24;
+    };
+}cbus_test_RBUS;
+
+typedef union
+{
+    RBus_UInt32 regValue;
+    struct{
+        RBus_UInt32  cbus_dummy0:32;
+    };
+}cbus_dummy0_RBUS;
+
+
+#endif
+
+
+
+
+
+
+
+#endif //_RBUS_CBUS_REG_H_
+
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/rbusTypes.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/rbusTypes.h
new file mode 100644
index 00000000..b0344a0
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/TV_IP/rbusTypes.h
@@ -0,0 +1,50 @@
+/**
+ * @file RBus_types.h
+ * RBus systemc program.
+ *
+ * @author Yu-Cheng Huang
+ * @email timhuang@realtek.com.tw 
+ * @date Wednesday June 21 2006
+ * @version 1.1
+ * @ingroup model_rbus
+ *
+ */
+
+#ifndef _RBUS_TYPES_H_
+#define _RBUS_TYPES_H_
+
+// Data types
+typedef unsigned long long RBus_UInt64;
+typedef unsigned long RBus_UInt32;
+typedef unsigned short RBus_UInt16;
+typedef unsigned char RBus_UInt8;
+typedef unsigned long ULONG;
+
+
+#define SC_MODEL
+
+#ifndef SC_MODEL
+typedef unsigned char bool;
+#define true     0x01
+#define false    0x00
+#define BIG_ENDIAN
+#define VBIPPR_PG_ENABLE
+#endif
+
+#define RBUS_DEADCODE 0xDEADC0DE
+#define RBUS_MAX_MASTER_NUM 2
+#define RBUS_CO_SIM_FILE "rbus2rtl_reg.log"
+
+enum VIDEO_MODE {
+  VIDEO_NTSC = 0,
+  VIDEO_PAL,
+};
+
+enum VTE_MODE {
+  VTE_MODE_MICRONAS = 0,
+  VTE_MODE_PHILIPS = 1,
+};
+
+#define BIG_ENDIA_SWAP(src,des) {des = ((src&0xFF)<<24) | ((src&0xFF00)<<8) | ((src&0xFF0000)>>8) | ((src&0xFF000000)>>24);};
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/VE_TOP_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/VE_TOP_reg.h
new file mode 100644
index 00000000..9ed619f
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/VE_TOP_reg.h
@@ -0,0 +1,9 @@
+#include "predblk_reg.h"
+#include "rif_reg_reg.h"
+#include "codeblkreg_reg.h"
+#include "vma_reg.h"
+#include "deblk_reg.h"
+#include "mvdblk_reg.h"
+#include "rl_reg.h"
+#include "img_reg.h"
+
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/XXa_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/XXa_reg.h
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/XXb_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/XXb_reg.h
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/adsp_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/adsp_reg.h
new file mode 100644
index 00000000..774cf8f
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/adsp_reg.h
@@ -0,0 +1,2322 @@
+/**************************************************************
+// Spec Version                  : 2012
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/10/1 11:15:30
+***************************************************************/
+
+
+#ifndef _AE_REG_H_INCLUDED_
+#define _AE_REG_H_INCLUDED_
+#ifdef  _AE_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     src:31;
+}ADSP_ADE_SRC;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     dst:31;
+}ADSP_ADE_DST;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     valid:1;
+unsigned int     dir:1;
+unsigned int     size:14;
+}ADSP_ADE_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     done_7:1;
+unsigned int     done_6:1;
+unsigned int     done_5:1;
+unsigned int     done_4:1;
+unsigned int     done_3:1;
+unsigned int     done_2:1;
+unsigned int     done_1:1;
+unsigned int     done_0:1;
+}ADSP_ADE_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_en1:1;
+unsigned int     max_xfer:6;
+unsigned int     reserved_1:5;
+unsigned int     write_en3:1;
+unsigned int     dmem_req_en:1;
+unsigned int     write_en4:1;
+unsigned int     stop:1;
+unsigned int     write_en5:1;
+unsigned int     go:1;
+}ADSP_ADE_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     int_done:1;
+}ADSP_ADE_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     int_done_en:1;
+}ADSP_ADE_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     max_xfer:6;
+unsigned int     reserved_1:4;
+unsigned int     threshold:6;
+unsigned int     reserved_2:3;
+}ADSP_AEE_THLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     bit_cnt:14;
+}ADSP_AEE_VBIT_CNT;
+
+typedef struct 
+{
+unsigned int     used_cnt:32;
+}ADSP_AEE_USED_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     write_en1:1;
+unsigned int     stop:1;
+unsigned int     write_en2:1;
+unsigned int     dir:1;
+unsigned int     go:1;
+}ADSP_AEE_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     int4:1;
+unsigned int     int3:1;
+unsigned int     int2:1;
+unsigned int     int1:1;
+unsigned int     write_data:1;
+}ADSP_AEE_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     int4_en:1;
+unsigned int     int3_en:1;
+unsigned int     int2_en:1;
+unsigned int     int1_en:1;
+unsigned int     write_data:1;
+}ADSP_AEE_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     ring_limit:28;
+unsigned int     reserved_1:3;
+}ADSP_AEE_RING_LIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     ring_base:28;
+unsigned int     reserved_1:3;
+}ADSP_AEE_RING_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     ring_rp:31;
+}ADSP_AEE_RING_RP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     ring_wp:31;
+}ADSP_AEE_RING_WP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     ring_cp:31;
+}ADSP_AEE_RING_CP;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     limit:16;
+}ADSP_AEE_SEARCH_LIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     crc_init:16;
+}ADSP_AEE_CRC_INIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     write_en4:1;
+unsigned int     crc_mode:1;
+unsigned int     write_en1:1;
+unsigned int     crc_reset:1;
+unsigned int     write_en2:1;
+unsigned int     crc_cont:1;
+unsigned int     write_en3:1;
+unsigned int     crc_on:1;
+}ADSP_AEE_CRC_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     crc_length:16;
+}ADSP_AEE_CRC_LENGTH;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     crc_result:16;
+}ADSP_AEE_CRC_RESULT;
+
+typedef struct 
+{
+unsigned int     crc_bit_cnt:32;
+}ADSP_AEE_BIT_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     acc:16;
+}ADSP_AEE_CRC_ACC;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     acc_cnt:4;
+}ADSP_AEE_CRC_ACC_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     aee_audio_mode:2;
+}AEE_OGG_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     RME:1;
+unsigned int     RM_3:1;
+unsigned int     RM_2:1;
+unsigned int     RM_1:1;
+unsigned int     RM_0:1;
+}BIST_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     bist_fail3:1;
+unsigned int     bist_fail2:1;
+unsigned int     bist_fail1:1;
+unsigned int     bist_fail0:1;
+unsigned int     bist_done:1;
+}BIST_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:11;
+unsigned int     drf_fail3:1;
+unsigned int     drf_fail2:1;
+unsigned int     drf_fail1:1;
+unsigned int     drf_fail0:1;
+unsigned int     drf_done:1;
+}DRF_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     RME:1;
+unsigned int     RM_3:1;
+unsigned int     RM_2:1;
+unsigned int     RM_1:1;
+unsigned int     RM_0:1;
+}ROM_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     bist_done:1;
+}ROM_ST1;
+
+typedef struct 
+{
+unsigned int     ae_rom_bist_crc:32;
+}ROM_ST2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ae_sys_dbg_en:1;
+unsigned int     ae_sys_dbg_sel1:5;
+unsigned int     ae_sys_dbg_sel0:5;
+unsigned int     ae_dbg_en:1;
+unsigned int     ae_dbg_sel1:6;
+unsigned int     ae_dbg_sel0:6;
+}AE_DEBUG;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     src_src_base:28;
+unsigned int     reserved_1:3;
+}SRC_SRC_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     src_src_wp:29;
+unsigned int     reserved_1:2;
+}SRC_SRC_WP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     src_src_rp:29;
+unsigned int     reserved_1:2;
+}SRC_SRC_RP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     src_dest_base:28;
+unsigned int     reserved_1:3;
+}SRC_DEST_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     src_dest_wp:29;
+unsigned int     reserved_1:2;
+}SRC_DEST_WP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     src_dest_rp:29;
+unsigned int     reserved_1:2;
+}SRC_DEST_RP;
+
+typedef struct 
+{
+unsigned int     write_en6:1;
+unsigned int     src_rb_size:7;
+unsigned int     write_en5:1;
+unsigned int     dest_rb_size:7;
+unsigned int     write_en4:1;
+unsigned int     reserved_0:1;
+unsigned int     write_en3:1;
+unsigned int     chan_num:3;
+unsigned int     write_en2:1;
+unsigned int     src_mode:3;
+unsigned int     write_en1:1;
+unsigned int     size:5;
+}SRC_CTRL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     write_en6:1;
+unsigned int     rom_sync_selc:1;
+unsigned int     write_en5:1;
+unsigned int     filter_tap:2;
+unsigned int     write_en4:1;
+unsigned int     idx:8;
+unsigned int     write_en3:1;
+unsigned int     mode:2;
+unsigned int     write_en2:1;
+unsigned int     stop:1;
+unsigned int     write_en1:1;
+unsigned int     go:1;
+}SRC_CTRL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     chan_busy:3;
+}SRC_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_en5:1;
+unsigned int     time_out:1;
+unsigned int     write_en4:1;
+unsigned int     done:1;
+unsigned int     write_en3:1;
+unsigned int     error:1;
+unsigned int     write_en2:1;
+unsigned int     src_rb_empty:1;
+unsigned int     write_en1:1;
+unsigned int     dest_rb_full:1;
+}SRC_RB_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_en5:1;
+unsigned int     time_out:1;
+unsigned int     write_en4:1;
+unsigned int     done_en:1;
+unsigned int     write_en3:1;
+unsigned int     error_en:1;
+unsigned int     write_en2:1;
+unsigned int     src_rb_empty_en:1;
+unsigned int     write_en1:1;
+unsigned int     dest_rb_full_en:1;
+}SRC_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     thld:25;
+}SRC_SRC_THRESHOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     adr:29;
+unsigned int     reserved_1:2;
+}FILTER_COEF;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     load_coef:1;
+}FILTER_COEF_CTRL;
+
+typedef struct 
+{
+unsigned int     dummy:32;
+}AE_DUMMY;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     src_stg2:5;
+unsigned int     src_stg1:5;
+unsigned int     reserved_1:1;
+unsigned int     src_ctrl:4;
+}AE_SRC_SM;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     rst:1;
+}AE_SRC_RST;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     idle_ctr:10;
+unsigned int     en_src:1;
+unsigned int     en_ade:1;
+unsigned int     en_aee:1;
+unsigned int     sram_ctr:10;
+}AE_PWM;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     rme_acpu:1;
+unsigned int     rm_dc_data:4;
+unsigned int     rm_dc_tag:4;
+unsigned int     rm_dw_data0:4;
+unsigned int     rm_ic_data1:4;
+unsigned int     rm_ic_data0:4;
+unsigned int     rm_ic_tag1:4;
+unsigned int     rm_ic_tag0:4;
+}MBIST_ACPU_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     bist_fail_10:1;
+unsigned int     bist_fail_9:1;
+unsigned int     bist_fail_8:1;
+unsigned int     bist_fail_7:1;
+unsigned int     bist_fail_6:1;
+unsigned int     bist_fail_5:1;
+unsigned int     bist_fail_4:1;
+unsigned int     bist_fail_3:1;
+unsigned int     bist_fail_2:1;
+unsigned int     bist_fail_1:1;
+unsigned int     bist_fail_0:1;
+unsigned int     bist_done:1;
+}MBIST_ACPU_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:4;
+unsigned int     drf_bist_fail_10:1;
+unsigned int     drf_bist_fail_9:1;
+unsigned int     drf_bist_fail_8:1;
+unsigned int     drf_bist_fail_7:1;
+unsigned int     drf_bist_fail_6:1;
+unsigned int     drf_bist_fail_5:1;
+unsigned int     drf_bist_fail_4:1;
+unsigned int     drf_bist_fail_3:1;
+unsigned int     drf_bist_fail_2:1;
+unsigned int     drf_bist_fail_1:1;
+unsigned int     drf_bist_fail_0:1;
+unsigned int     drf_bist_done:1;
+}MBIST_DRF_ACPU_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     pfn3129_110:3;
+unsigned int     pfn3129_101:3;
+unsigned int     pfn3129_100:3;
+unsigned int     pfn3129_011:3;
+unsigned int     pfn3129_010:3;
+unsigned int     pfn3129_001:3;
+unsigned int     pfn3129_000:3;
+}ACPU_PFN3129;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     ncable_110:1;
+unsigned int     ncable_101:1;
+unsigned int     ncable_100:1;
+unsigned int     ncable_011:1;
+unsigned int     ncable_010:1;
+unsigned int     ncable_001:1;
+unsigned int     ncable_000:1;
+}ACPU_NCABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     imem_enable:1;
+}ACPU_IMEM;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     rm_dw_data4:4;
+unsigned int     rm_dw_data3:4;
+unsigned int     rm_dw_data2:4;
+unsigned int     rm_dw_data1:4;
+}MBIST_ACPU_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     drf_test_resume:1;
+unsigned int     drf_en:1;
+unsigned int     en:1;
+}MBIST_ACPU;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     rom_en:1;
+unsigned int     drf_test_resume:1;
+unsigned int     drf_en:1;
+unsigned int     en:1;
+}MBIST;
+
+#endif
+
+#define ADSP_ADE_SRC_0                                                               0x18002000
+#define ADSP_ADE_SRC_1                                                               0x18002004
+#define ADSP_ADE_SRC_2                                                               0x18002008
+#define ADSP_ADE_SRC_3                                                               0x1800200C
+#define ADSP_ADE_SRC_4                                                               0x18002010
+#define ADSP_ADE_SRC_5                                                               0x18002014
+#define ADSP_ADE_SRC_6                                                               0x18002018
+#define ADSP_ADE_SRC_7                                                               0x1800201C
+#define ADSP_ADE_SRC_0_reg_addr                                                      "0xB8002000"
+#define ADSP_ADE_SRC_1_reg_addr                                                      "0xB8002004"
+#define ADSP_ADE_SRC_2_reg_addr                                                      "0xB8002008"
+#define ADSP_ADE_SRC_3_reg_addr                                                      "0xB800200C"
+#define ADSP_ADE_SRC_4_reg_addr                                                      "0xB8002010"
+#define ADSP_ADE_SRC_5_reg_addr                                                      "0xB8002014"
+#define ADSP_ADE_SRC_6_reg_addr                                                      "0xB8002018"
+#define ADSP_ADE_SRC_7_reg_addr                                                      "0xB800201C"
+#define ADSP_ADE_SRC_0_reg                                                           0xB8002000
+#define ADSP_ADE_SRC_1_reg                                                           0xB8002004
+#define ADSP_ADE_SRC_2_reg                                                           0xB8002008
+#define ADSP_ADE_SRC_3_reg                                                           0xB800200C
+#define ADSP_ADE_SRC_4_reg                                                           0xB8002010
+#define ADSP_ADE_SRC_5_reg                                                           0xB8002014
+#define ADSP_ADE_SRC_6_reg                                                           0xB8002018
+#define ADSP_ADE_SRC_7_reg                                                           0xB800201C
+#define set_ADSP_ADE_SRC_0_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SRC_0_reg)=data)
+#define set_ADSP_ADE_SRC_1_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SRC_1_reg)=data)
+#define set_ADSP_ADE_SRC_2_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SRC_2_reg)=data)
+#define set_ADSP_ADE_SRC_3_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SRC_3_reg)=data)
+#define set_ADSP_ADE_SRC_4_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SRC_4_reg)=data)
+#define set_ADSP_ADE_SRC_5_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SRC_5_reg)=data)
+#define set_ADSP_ADE_SRC_6_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SRC_6_reg)=data)
+#define set_ADSP_ADE_SRC_7_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SRC_7_reg)=data)
+#define get_ADSP_ADE_SRC_0_reg   (*((volatile unsigned int*) ADSP_ADE_SRC_0_reg))
+#define get_ADSP_ADE_SRC_1_reg   (*((volatile unsigned int*) ADSP_ADE_SRC_1_reg))
+#define get_ADSP_ADE_SRC_2_reg   (*((volatile unsigned int*) ADSP_ADE_SRC_2_reg))
+#define get_ADSP_ADE_SRC_3_reg   (*((volatile unsigned int*) ADSP_ADE_SRC_3_reg))
+#define get_ADSP_ADE_SRC_4_reg   (*((volatile unsigned int*) ADSP_ADE_SRC_4_reg))
+#define get_ADSP_ADE_SRC_5_reg   (*((volatile unsigned int*) ADSP_ADE_SRC_5_reg))
+#define get_ADSP_ADE_SRC_6_reg   (*((volatile unsigned int*) ADSP_ADE_SRC_6_reg))
+#define get_ADSP_ADE_SRC_7_reg   (*((volatile unsigned int*) ADSP_ADE_SRC_7_reg))
+#define ADSP_ADE_SRC_0_inst_adr                                                      "0x0000"
+#define ADSP_ADE_SRC_1_inst_adr                                                      "0x0001"
+#define ADSP_ADE_SRC_2_inst_adr                                                      "0x0002"
+#define ADSP_ADE_SRC_3_inst_adr                                                      "0x0003"
+#define ADSP_ADE_SRC_4_inst_adr                                                      "0x0004"
+#define ADSP_ADE_SRC_5_inst_adr                                                      "0x0005"
+#define ADSP_ADE_SRC_6_inst_adr                                                      "0x0006"
+#define ADSP_ADE_SRC_7_inst_adr                                                      "0x0007"
+#define ADSP_ADE_SRC_0_inst                                                          0x0000
+#define ADSP_ADE_SRC_1_inst                                                          0x0001
+#define ADSP_ADE_SRC_2_inst                                                          0x0002
+#define ADSP_ADE_SRC_3_inst                                                          0x0003
+#define ADSP_ADE_SRC_4_inst                                                          0x0004
+#define ADSP_ADE_SRC_5_inst                                                          0x0005
+#define ADSP_ADE_SRC_6_inst                                                          0x0006
+#define ADSP_ADE_SRC_7_inst                                                          0x0007
+#define ADSP_ADE_SRC_src_shift                                                       (0)
+#define ADSP_ADE_SRC_src_mask                                                        (0x7FFFFFFF)
+#define ADSP_ADE_SRC_src(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define ADSP_ADE_SRC_src_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define ADSP_ADE_SRC_get_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define ADSP_ADE_DST_0                                                               0x18002020
+#define ADSP_ADE_DST_1                                                               0x18002024
+#define ADSP_ADE_DST_2                                                               0x18002028
+#define ADSP_ADE_DST_3                                                               0x1800202C
+#define ADSP_ADE_DST_4                                                               0x18002030
+#define ADSP_ADE_DST_5                                                               0x18002034
+#define ADSP_ADE_DST_6                                                               0x18002038
+#define ADSP_ADE_DST_7                                                               0x1800203C
+#define ADSP_ADE_DST_0_reg_addr                                                      "0xB8002020"
+#define ADSP_ADE_DST_1_reg_addr                                                      "0xB8002024"
+#define ADSP_ADE_DST_2_reg_addr                                                      "0xB8002028"
+#define ADSP_ADE_DST_3_reg_addr                                                      "0xB800202C"
+#define ADSP_ADE_DST_4_reg_addr                                                      "0xB8002030"
+#define ADSP_ADE_DST_5_reg_addr                                                      "0xB8002034"
+#define ADSP_ADE_DST_6_reg_addr                                                      "0xB8002038"
+#define ADSP_ADE_DST_7_reg_addr                                                      "0xB800203C"
+#define ADSP_ADE_DST_0_reg                                                           0xB8002020
+#define ADSP_ADE_DST_1_reg                                                           0xB8002024
+#define ADSP_ADE_DST_2_reg                                                           0xB8002028
+#define ADSP_ADE_DST_3_reg                                                           0xB800202C
+#define ADSP_ADE_DST_4_reg                                                           0xB8002030
+#define ADSP_ADE_DST_5_reg                                                           0xB8002034
+#define ADSP_ADE_DST_6_reg                                                           0xB8002038
+#define ADSP_ADE_DST_7_reg                                                           0xB800203C
+#define set_ADSP_ADE_DST_0_reg(data)   (*((volatile unsigned int*) ADSP_ADE_DST_0_reg)=data)
+#define set_ADSP_ADE_DST_1_reg(data)   (*((volatile unsigned int*) ADSP_ADE_DST_1_reg)=data)
+#define set_ADSP_ADE_DST_2_reg(data)   (*((volatile unsigned int*) ADSP_ADE_DST_2_reg)=data)
+#define set_ADSP_ADE_DST_3_reg(data)   (*((volatile unsigned int*) ADSP_ADE_DST_3_reg)=data)
+#define set_ADSP_ADE_DST_4_reg(data)   (*((volatile unsigned int*) ADSP_ADE_DST_4_reg)=data)
+#define set_ADSP_ADE_DST_5_reg(data)   (*((volatile unsigned int*) ADSP_ADE_DST_5_reg)=data)
+#define set_ADSP_ADE_DST_6_reg(data)   (*((volatile unsigned int*) ADSP_ADE_DST_6_reg)=data)
+#define set_ADSP_ADE_DST_7_reg(data)   (*((volatile unsigned int*) ADSP_ADE_DST_7_reg)=data)
+#define get_ADSP_ADE_DST_0_reg   (*((volatile unsigned int*) ADSP_ADE_DST_0_reg))
+#define get_ADSP_ADE_DST_1_reg   (*((volatile unsigned int*) ADSP_ADE_DST_1_reg))
+#define get_ADSP_ADE_DST_2_reg   (*((volatile unsigned int*) ADSP_ADE_DST_2_reg))
+#define get_ADSP_ADE_DST_3_reg   (*((volatile unsigned int*) ADSP_ADE_DST_3_reg))
+#define get_ADSP_ADE_DST_4_reg   (*((volatile unsigned int*) ADSP_ADE_DST_4_reg))
+#define get_ADSP_ADE_DST_5_reg   (*((volatile unsigned int*) ADSP_ADE_DST_5_reg))
+#define get_ADSP_ADE_DST_6_reg   (*((volatile unsigned int*) ADSP_ADE_DST_6_reg))
+#define get_ADSP_ADE_DST_7_reg   (*((volatile unsigned int*) ADSP_ADE_DST_7_reg))
+#define ADSP_ADE_DST_0_inst_adr                                                      "0x0008"
+#define ADSP_ADE_DST_1_inst_adr                                                      "0x0009"
+#define ADSP_ADE_DST_2_inst_adr                                                      "0x000A"
+#define ADSP_ADE_DST_3_inst_adr                                                      "0x000B"
+#define ADSP_ADE_DST_4_inst_adr                                                      "0x000C"
+#define ADSP_ADE_DST_5_inst_adr                                                      "0x000D"
+#define ADSP_ADE_DST_6_inst_adr                                                      "0x000E"
+#define ADSP_ADE_DST_7_inst_adr                                                      "0x000F"
+#define ADSP_ADE_DST_0_inst                                                          0x0008
+#define ADSP_ADE_DST_1_inst                                                          0x0009
+#define ADSP_ADE_DST_2_inst                                                          0x000A
+#define ADSP_ADE_DST_3_inst                                                          0x000B
+#define ADSP_ADE_DST_4_inst                                                          0x000C
+#define ADSP_ADE_DST_5_inst                                                          0x000D
+#define ADSP_ADE_DST_6_inst                                                          0x000E
+#define ADSP_ADE_DST_7_inst                                                          0x000F
+#define ADSP_ADE_DST_dst_shift                                                       (0)
+#define ADSP_ADE_DST_dst_mask                                                        (0x7FFFFFFF)
+#define ADSP_ADE_DST_dst(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define ADSP_ADE_DST_dst_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define ADSP_ADE_DST_get_dst(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define ADSP_ADE_SIZE_0                                                              0x18002040
+#define ADSP_ADE_SIZE_1                                                              0x18002044
+#define ADSP_ADE_SIZE_2                                                              0x18002048
+#define ADSP_ADE_SIZE_3                                                              0x1800204C
+#define ADSP_ADE_SIZE_4                                                              0x18002050
+#define ADSP_ADE_SIZE_5                                                              0x18002054
+#define ADSP_ADE_SIZE_6                                                              0x18002058
+#define ADSP_ADE_SIZE_7                                                              0x1800205C
+#define ADSP_ADE_SIZE_0_reg_addr                                                     "0xB8002040"
+#define ADSP_ADE_SIZE_1_reg_addr                                                     "0xB8002044"
+#define ADSP_ADE_SIZE_2_reg_addr                                                     "0xB8002048"
+#define ADSP_ADE_SIZE_3_reg_addr                                                     "0xB800204C"
+#define ADSP_ADE_SIZE_4_reg_addr                                                     "0xB8002050"
+#define ADSP_ADE_SIZE_5_reg_addr                                                     "0xB8002054"
+#define ADSP_ADE_SIZE_6_reg_addr                                                     "0xB8002058"
+#define ADSP_ADE_SIZE_7_reg_addr                                                     "0xB800205C"
+#define ADSP_ADE_SIZE_0_reg                                                          0xB8002040
+#define ADSP_ADE_SIZE_1_reg                                                          0xB8002044
+#define ADSP_ADE_SIZE_2_reg                                                          0xB8002048
+#define ADSP_ADE_SIZE_3_reg                                                          0xB800204C
+#define ADSP_ADE_SIZE_4_reg                                                          0xB8002050
+#define ADSP_ADE_SIZE_5_reg                                                          0xB8002054
+#define ADSP_ADE_SIZE_6_reg                                                          0xB8002058
+#define ADSP_ADE_SIZE_7_reg                                                          0xB800205C
+#define set_ADSP_ADE_SIZE_0_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SIZE_0_reg)=data)
+#define set_ADSP_ADE_SIZE_1_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SIZE_1_reg)=data)
+#define set_ADSP_ADE_SIZE_2_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SIZE_2_reg)=data)
+#define set_ADSP_ADE_SIZE_3_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SIZE_3_reg)=data)
+#define set_ADSP_ADE_SIZE_4_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SIZE_4_reg)=data)
+#define set_ADSP_ADE_SIZE_5_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SIZE_5_reg)=data)
+#define set_ADSP_ADE_SIZE_6_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SIZE_6_reg)=data)
+#define set_ADSP_ADE_SIZE_7_reg(data)   (*((volatile unsigned int*) ADSP_ADE_SIZE_7_reg)=data)
+#define get_ADSP_ADE_SIZE_0_reg   (*((volatile unsigned int*) ADSP_ADE_SIZE_0_reg))
+#define get_ADSP_ADE_SIZE_1_reg   (*((volatile unsigned int*) ADSP_ADE_SIZE_1_reg))
+#define get_ADSP_ADE_SIZE_2_reg   (*((volatile unsigned int*) ADSP_ADE_SIZE_2_reg))
+#define get_ADSP_ADE_SIZE_3_reg   (*((volatile unsigned int*) ADSP_ADE_SIZE_3_reg))
+#define get_ADSP_ADE_SIZE_4_reg   (*((volatile unsigned int*) ADSP_ADE_SIZE_4_reg))
+#define get_ADSP_ADE_SIZE_5_reg   (*((volatile unsigned int*) ADSP_ADE_SIZE_5_reg))
+#define get_ADSP_ADE_SIZE_6_reg   (*((volatile unsigned int*) ADSP_ADE_SIZE_6_reg))
+#define get_ADSP_ADE_SIZE_7_reg   (*((volatile unsigned int*) ADSP_ADE_SIZE_7_reg))
+#define ADSP_ADE_SIZE_0_inst_adr                                                     "0x0010"
+#define ADSP_ADE_SIZE_1_inst_adr                                                     "0x0011"
+#define ADSP_ADE_SIZE_2_inst_adr                                                     "0x0012"
+#define ADSP_ADE_SIZE_3_inst_adr                                                     "0x0013"
+#define ADSP_ADE_SIZE_4_inst_adr                                                     "0x0014"
+#define ADSP_ADE_SIZE_5_inst_adr                                                     "0x0015"
+#define ADSP_ADE_SIZE_6_inst_adr                                                     "0x0016"
+#define ADSP_ADE_SIZE_7_inst_adr                                                     "0x0017"
+#define ADSP_ADE_SIZE_0_inst                                                         0x0010
+#define ADSP_ADE_SIZE_1_inst                                                         0x0011
+#define ADSP_ADE_SIZE_2_inst                                                         0x0012
+#define ADSP_ADE_SIZE_3_inst                                                         0x0013
+#define ADSP_ADE_SIZE_4_inst                                                         0x0014
+#define ADSP_ADE_SIZE_5_inst                                                         0x0015
+#define ADSP_ADE_SIZE_6_inst                                                         0x0016
+#define ADSP_ADE_SIZE_7_inst                                                         0x0017
+#define ADSP_ADE_SIZE_valid_shift                                                    (15)
+#define ADSP_ADE_SIZE_valid_mask                                                     (0x00008000)
+#define ADSP_ADE_SIZE_valid(data)                                                    (0x00008000&((data)<<15))
+#define ADSP_ADE_SIZE_valid_src(data)                                                ((0x00008000&(data))>>15)
+#define ADSP_ADE_SIZE_get_valid(data)                                                ((0x00008000&(data))>>15)
+#define ADSP_ADE_SIZE_dir_shift                                                      (14)
+#define ADSP_ADE_SIZE_dir_mask                                                       (0x00004000)
+#define ADSP_ADE_SIZE_dir(data)                                                      (0x00004000&((data)<<14))
+#define ADSP_ADE_SIZE_dir_src(data)                                                  ((0x00004000&(data))>>14)
+#define ADSP_ADE_SIZE_get_dir(data)                                                  ((0x00004000&(data))>>14)
+#define ADSP_ADE_SIZE_size_shift                                                     (0)
+#define ADSP_ADE_SIZE_size_mask                                                      (0x00003FFF)
+#define ADSP_ADE_SIZE_size(data)                                                     (0x00003FFF&((data)<<0))
+#define ADSP_ADE_SIZE_size_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define ADSP_ADE_SIZE_get_size(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define ADSP_ADE_STATUS                                                              0x18002060
+#define ADSP_ADE_STATUS_reg_addr                                                     "0xB8002060"
+#define ADSP_ADE_STATUS_reg                                                          0xB8002060
+#define set_ADSP_ADE_STATUS_reg(data)   (*((volatile unsigned int*) ADSP_ADE_STATUS_reg)=data)
+#define get_ADSP_ADE_STATUS_reg   (*((volatile unsigned int*) ADSP_ADE_STATUS_reg))
+#define ADSP_ADE_STATUS_inst_adr                                                     "0x0018"
+#define ADSP_ADE_STATUS_inst                                                         0x0018
+#define ADSP_ADE_STATUS_done_7_shift                                                 (7)
+#define ADSP_ADE_STATUS_done_7_mask                                                  (0x00000080)
+#define ADSP_ADE_STATUS_done_7(data)                                                 (0x00000080&((data)<<7))
+#define ADSP_ADE_STATUS_done_7_src(data)                                             ((0x00000080&(data))>>7)
+#define ADSP_ADE_STATUS_get_done_7(data)                                             ((0x00000080&(data))>>7)
+#define ADSP_ADE_STATUS_done_6_shift                                                 (6)
+#define ADSP_ADE_STATUS_done_6_mask                                                  (0x00000040)
+#define ADSP_ADE_STATUS_done_6(data)                                                 (0x00000040&((data)<<6))
+#define ADSP_ADE_STATUS_done_6_src(data)                                             ((0x00000040&(data))>>6)
+#define ADSP_ADE_STATUS_get_done_6(data)                                             ((0x00000040&(data))>>6)
+#define ADSP_ADE_STATUS_done_5_shift                                                 (5)
+#define ADSP_ADE_STATUS_done_5_mask                                                  (0x00000020)
+#define ADSP_ADE_STATUS_done_5(data)                                                 (0x00000020&((data)<<5))
+#define ADSP_ADE_STATUS_done_5_src(data)                                             ((0x00000020&(data))>>5)
+#define ADSP_ADE_STATUS_get_done_5(data)                                             ((0x00000020&(data))>>5)
+#define ADSP_ADE_STATUS_done_4_shift                                                 (4)
+#define ADSP_ADE_STATUS_done_4_mask                                                  (0x00000010)
+#define ADSP_ADE_STATUS_done_4(data)                                                 (0x00000010&((data)<<4))
+#define ADSP_ADE_STATUS_done_4_src(data)                                             ((0x00000010&(data))>>4)
+#define ADSP_ADE_STATUS_get_done_4(data)                                             ((0x00000010&(data))>>4)
+#define ADSP_ADE_STATUS_done_3_shift                                                 (3)
+#define ADSP_ADE_STATUS_done_3_mask                                                  (0x00000008)
+#define ADSP_ADE_STATUS_done_3(data)                                                 (0x00000008&((data)<<3))
+#define ADSP_ADE_STATUS_done_3_src(data)                                             ((0x00000008&(data))>>3)
+#define ADSP_ADE_STATUS_get_done_3(data)                                             ((0x00000008&(data))>>3)
+#define ADSP_ADE_STATUS_done_2_shift                                                 (2)
+#define ADSP_ADE_STATUS_done_2_mask                                                  (0x00000004)
+#define ADSP_ADE_STATUS_done_2(data)                                                 (0x00000004&((data)<<2))
+#define ADSP_ADE_STATUS_done_2_src(data)                                             ((0x00000004&(data))>>2)
+#define ADSP_ADE_STATUS_get_done_2(data)                                             ((0x00000004&(data))>>2)
+#define ADSP_ADE_STATUS_done_1_shift                                                 (1)
+#define ADSP_ADE_STATUS_done_1_mask                                                  (0x00000002)
+#define ADSP_ADE_STATUS_done_1(data)                                                 (0x00000002&((data)<<1))
+#define ADSP_ADE_STATUS_done_1_src(data)                                             ((0x00000002&(data))>>1)
+#define ADSP_ADE_STATUS_get_done_1(data)                                             ((0x00000002&(data))>>1)
+#define ADSP_ADE_STATUS_done_0_shift                                                 (0)
+#define ADSP_ADE_STATUS_done_0_mask                                                  (0x00000001)
+#define ADSP_ADE_STATUS_done_0(data)                                                 (0x00000001&((data)<<0))
+#define ADSP_ADE_STATUS_done_0_src(data)                                             ((0x00000001&(data))>>0)
+#define ADSP_ADE_STATUS_get_done_0(data)                                             ((0x00000001&(data))>>0)
+
+
+#define ADSP_ADE_CNTL                                                                0x18002064
+#define ADSP_ADE_CNTL_reg_addr                                                       "0xB8002064"
+#define ADSP_ADE_CNTL_reg                                                            0xB8002064
+#define set_ADSP_ADE_CNTL_reg(data)   (*((volatile unsigned int*) ADSP_ADE_CNTL_reg)=data)
+#define get_ADSP_ADE_CNTL_reg   (*((volatile unsigned int*) ADSP_ADE_CNTL_reg))
+#define ADSP_ADE_CNTL_inst_adr                                                       "0x0019"
+#define ADSP_ADE_CNTL_inst                                                           0x0019
+#define ADSP_ADE_CNTL_write_en1_shift                                                (17)
+#define ADSP_ADE_CNTL_write_en1_mask                                                 (0x00020000)
+#define ADSP_ADE_CNTL_write_en1(data)                                                (0x00020000&((data)<<17))
+#define ADSP_ADE_CNTL_write_en1_src(data)                                            ((0x00020000&(data))>>17)
+#define ADSP_ADE_CNTL_get_write_en1(data)                                            ((0x00020000&(data))>>17)
+#define ADSP_ADE_CNTL_max_xfer_shift                                                 (11)
+#define ADSP_ADE_CNTL_max_xfer_mask                                                  (0x0001F800)
+#define ADSP_ADE_CNTL_max_xfer(data)                                                 (0x0001F800&((data)<<11))
+#define ADSP_ADE_CNTL_max_xfer_src(data)                                             ((0x0001F800&(data))>>11)
+#define ADSP_ADE_CNTL_get_max_xfer(data)                                             ((0x0001F800&(data))>>11)
+#define ADSP_ADE_CNTL_write_en3_shift                                                (5)
+#define ADSP_ADE_CNTL_write_en3_mask                                                 (0x00000020)
+#define ADSP_ADE_CNTL_write_en3(data)                                                (0x00000020&((data)<<5))
+#define ADSP_ADE_CNTL_write_en3_src(data)                                            ((0x00000020&(data))>>5)
+#define ADSP_ADE_CNTL_get_write_en3(data)                                            ((0x00000020&(data))>>5)
+#define ADSP_ADE_CNTL_dmem_req_en_shift                                              (4)
+#define ADSP_ADE_CNTL_dmem_req_en_mask                                               (0x00000010)
+#define ADSP_ADE_CNTL_dmem_req_en(data)                                              (0x00000010&((data)<<4))
+#define ADSP_ADE_CNTL_dmem_req_en_src(data)                                          ((0x00000010&(data))>>4)
+#define ADSP_ADE_CNTL_get_dmem_req_en(data)                                          ((0x00000010&(data))>>4)
+#define ADSP_ADE_CNTL_write_en4_shift                                                (3)
+#define ADSP_ADE_CNTL_write_en4_mask                                                 (0x00000008)
+#define ADSP_ADE_CNTL_write_en4(data)                                                (0x00000008&((data)<<3))
+#define ADSP_ADE_CNTL_write_en4_src(data)                                            ((0x00000008&(data))>>3)
+#define ADSP_ADE_CNTL_get_write_en4(data)                                            ((0x00000008&(data))>>3)
+#define ADSP_ADE_CNTL_stop_shift                                                     (2)
+#define ADSP_ADE_CNTL_stop_mask                                                      (0x00000004)
+#define ADSP_ADE_CNTL_stop(data)                                                     (0x00000004&((data)<<2))
+#define ADSP_ADE_CNTL_stop_src(data)                                                 ((0x00000004&(data))>>2)
+#define ADSP_ADE_CNTL_get_stop(data)                                                 ((0x00000004&(data))>>2)
+#define ADSP_ADE_CNTL_write_en5_shift                                                (1)
+#define ADSP_ADE_CNTL_write_en5_mask                                                 (0x00000002)
+#define ADSP_ADE_CNTL_write_en5(data)                                                (0x00000002&((data)<<1))
+#define ADSP_ADE_CNTL_write_en5_src(data)                                            ((0x00000002&(data))>>1)
+#define ADSP_ADE_CNTL_get_write_en5(data)                                            ((0x00000002&(data))>>1)
+#define ADSP_ADE_CNTL_go_shift                                                       (0)
+#define ADSP_ADE_CNTL_go_mask                                                        (0x00000001)
+#define ADSP_ADE_CNTL_go(data)                                                       (0x00000001&((data)<<0))
+#define ADSP_ADE_CNTL_go_src(data)                                                   ((0x00000001&(data))>>0)
+#define ADSP_ADE_CNTL_get_go(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define ADSP_ADE_INT                                                                 0x18002068
+#define ADSP_ADE_INT_reg_addr                                                        "0xB8002068"
+#define ADSP_ADE_INT_reg                                                             0xB8002068
+#define set_ADSP_ADE_INT_reg(data)   (*((volatile unsigned int*) ADSP_ADE_INT_reg)=data)
+#define get_ADSP_ADE_INT_reg   (*((volatile unsigned int*) ADSP_ADE_INT_reg))
+#define ADSP_ADE_INT_inst_adr                                                        "0x001A"
+#define ADSP_ADE_INT_inst                                                            0x001A
+#define ADSP_ADE_INT_int_done_shift                                                  (0)
+#define ADSP_ADE_INT_int_done_mask                                                   (0x00000001)
+#define ADSP_ADE_INT_int_done(data)                                                  (0x00000001&((data)<<0))
+#define ADSP_ADE_INT_int_done_src(data)                                              ((0x00000001&(data))>>0)
+#define ADSP_ADE_INT_get_int_done(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ADSP_ADE_INT_EN                                                              0x1800206c
+#define ADSP_ADE_INT_EN_reg_addr                                                     "0xB800206C"
+#define ADSP_ADE_INT_EN_reg                                                          0xB800206C
+#define set_ADSP_ADE_INT_EN_reg(data)   (*((volatile unsigned int*) ADSP_ADE_INT_EN_reg)=data)
+#define get_ADSP_ADE_INT_EN_reg   (*((volatile unsigned int*) ADSP_ADE_INT_EN_reg))
+#define ADSP_ADE_INT_EN_inst_adr                                                     "0x001B"
+#define ADSP_ADE_INT_EN_inst                                                         0x001B
+#define ADSP_ADE_INT_EN_int_done_en_shift                                            (0)
+#define ADSP_ADE_INT_EN_int_done_en_mask                                             (0x00000001)
+#define ADSP_ADE_INT_EN_int_done_en(data)                                            (0x00000001&((data)<<0))
+#define ADSP_ADE_INT_EN_int_done_en_src(data)                                        ((0x00000001&(data))>>0)
+#define ADSP_ADE_INT_EN_get_int_done_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define ADSP_AEE_THLD                                                                0x18002078
+#define ADSP_AEE_THLD_reg_addr                                                       "0xB8002078"
+#define ADSP_AEE_THLD_reg                                                            0xB8002078
+#define set_ADSP_AEE_THLD_reg(data)   (*((volatile unsigned int*) ADSP_AEE_THLD_reg)=data)
+#define get_ADSP_AEE_THLD_reg   (*((volatile unsigned int*) ADSP_AEE_THLD_reg))
+#define ADSP_AEE_THLD_inst_adr                                                       "0x001E"
+#define ADSP_AEE_THLD_inst                                                           0x001E
+#define ADSP_AEE_THLD_max_xfer_shift                                                 (13)
+#define ADSP_AEE_THLD_max_xfer_mask                                                  (0x0007E000)
+#define ADSP_AEE_THLD_max_xfer(data)                                                 (0x0007E000&((data)<<13))
+#define ADSP_AEE_THLD_max_xfer_src(data)                                             ((0x0007E000&(data))>>13)
+#define ADSP_AEE_THLD_get_max_xfer(data)                                             ((0x0007E000&(data))>>13)
+#define ADSP_AEE_THLD_threshold_shift                                                (3)
+#define ADSP_AEE_THLD_threshold_mask                                                 (0x000001F8)
+#define ADSP_AEE_THLD_threshold(data)                                                (0x000001F8&((data)<<3))
+#define ADSP_AEE_THLD_threshold_src(data)                                            ((0x000001F8&(data))>>3)
+#define ADSP_AEE_THLD_get_threshold(data)                                            ((0x000001F8&(data))>>3)
+
+
+#define ADSP_AEE_VBIT_CNT                                                            0x1800207c
+#define ADSP_AEE_VBIT_CNT_reg_addr                                                   "0xB800207C"
+#define ADSP_AEE_VBIT_CNT_reg                                                        0xB800207C
+#define set_ADSP_AEE_VBIT_CNT_reg(data)   (*((volatile unsigned int*) ADSP_AEE_VBIT_CNT_reg)=data)
+#define get_ADSP_AEE_VBIT_CNT_reg   (*((volatile unsigned int*) ADSP_AEE_VBIT_CNT_reg))
+#define ADSP_AEE_VBIT_CNT_inst_adr                                                   "0x001F"
+#define ADSP_AEE_VBIT_CNT_inst                                                       0x001F
+#define ADSP_AEE_VBIT_CNT_bit_cnt_shift                                              (0)
+#define ADSP_AEE_VBIT_CNT_bit_cnt_mask                                               (0x00003FFF)
+#define ADSP_AEE_VBIT_CNT_bit_cnt(data)                                              (0x00003FFF&((data)<<0))
+#define ADSP_AEE_VBIT_CNT_bit_cnt_src(data)                                          ((0x00003FFF&(data))>>0)
+#define ADSP_AEE_VBIT_CNT_get_bit_cnt(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#define ADSP_AEE_USED_CNT                                                            0x18002080
+#define ADSP_AEE_USED_CNT_reg_addr                                                   "0xB8002080"
+#define ADSP_AEE_USED_CNT_reg                                                        0xB8002080
+#define set_ADSP_AEE_USED_CNT_reg(data)   (*((volatile unsigned int*) ADSP_AEE_USED_CNT_reg)=data)
+#define get_ADSP_AEE_USED_CNT_reg   (*((volatile unsigned int*) ADSP_AEE_USED_CNT_reg))
+#define ADSP_AEE_USED_CNT_inst_adr                                                   "0x0020"
+#define ADSP_AEE_USED_CNT_inst                                                       0x0020
+#define ADSP_AEE_USED_CNT_used_cnt_shift                                             (0)
+#define ADSP_AEE_USED_CNT_used_cnt_mask                                              (0xFFFFFFFF)
+#define ADSP_AEE_USED_CNT_used_cnt(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ADSP_AEE_USED_CNT_used_cnt_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ADSP_AEE_USED_CNT_get_used_cnt(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define ADSP_AEE_CTRL                                                                0x18002084
+#define ADSP_AEE_CTRL_reg_addr                                                       "0xB8002084"
+#define ADSP_AEE_CTRL_reg                                                            0xB8002084
+#define set_ADSP_AEE_CTRL_reg(data)   (*((volatile unsigned int*) ADSP_AEE_CTRL_reg)=data)
+#define get_ADSP_AEE_CTRL_reg   (*((volatile unsigned int*) ADSP_AEE_CTRL_reg))
+#define ADSP_AEE_CTRL_inst_adr                                                       "0x0021"
+#define ADSP_AEE_CTRL_inst                                                           0x0021
+#define ADSP_AEE_CTRL_write_en1_shift                                                (4)
+#define ADSP_AEE_CTRL_write_en1_mask                                                 (0x00000010)
+#define ADSP_AEE_CTRL_write_en1(data)                                                (0x00000010&((data)<<4))
+#define ADSP_AEE_CTRL_write_en1_src(data)                                            ((0x00000010&(data))>>4)
+#define ADSP_AEE_CTRL_get_write_en1(data)                                            ((0x00000010&(data))>>4)
+#define ADSP_AEE_CTRL_stop_shift                                                     (3)
+#define ADSP_AEE_CTRL_stop_mask                                                      (0x00000008)
+#define ADSP_AEE_CTRL_stop(data)                                                     (0x00000008&((data)<<3))
+#define ADSP_AEE_CTRL_stop_src(data)                                                 ((0x00000008&(data))>>3)
+#define ADSP_AEE_CTRL_get_stop(data)                                                 ((0x00000008&(data))>>3)
+#define ADSP_AEE_CTRL_write_en2_shift                                                (2)
+#define ADSP_AEE_CTRL_write_en2_mask                                                 (0x00000004)
+#define ADSP_AEE_CTRL_write_en2(data)                                                (0x00000004&((data)<<2))
+#define ADSP_AEE_CTRL_write_en2_src(data)                                            ((0x00000004&(data))>>2)
+#define ADSP_AEE_CTRL_get_write_en2(data)                                            ((0x00000004&(data))>>2)
+#define ADSP_AEE_CTRL_dir_shift                                                      (1)
+#define ADSP_AEE_CTRL_dir_mask                                                       (0x00000002)
+#define ADSP_AEE_CTRL_dir(data)                                                      (0x00000002&((data)<<1))
+#define ADSP_AEE_CTRL_dir_src(data)                                                  ((0x00000002&(data))>>1)
+#define ADSP_AEE_CTRL_get_dir(data)                                                  ((0x00000002&(data))>>1)
+#define ADSP_AEE_CTRL_go_shift                                                       (0)
+#define ADSP_AEE_CTRL_go_mask                                                        (0x00000001)
+#define ADSP_AEE_CTRL_go(data)                                                       (0x00000001&((data)<<0))
+#define ADSP_AEE_CTRL_go_src(data)                                                   ((0x00000001&(data))>>0)
+#define ADSP_AEE_CTRL_get_go(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define ADSP_AEE_INT                                                                 0x18002088
+#define ADSP_AEE_INT_reg_addr                                                        "0xB8002088"
+#define ADSP_AEE_INT_reg                                                             0xB8002088
+#define set_ADSP_AEE_INT_reg(data)   (*((volatile unsigned int*) ADSP_AEE_INT_reg)=data)
+#define get_ADSP_AEE_INT_reg   (*((volatile unsigned int*) ADSP_AEE_INT_reg))
+#define ADSP_AEE_INT_inst_adr                                                        "0x0022"
+#define ADSP_AEE_INT_inst                                                            0x0022
+#define ADSP_AEE_INT_int4_shift                                                      (4)
+#define ADSP_AEE_INT_int4_mask                                                       (0x00000010)
+#define ADSP_AEE_INT_int4(data)                                                      (0x00000010&((data)<<4))
+#define ADSP_AEE_INT_int4_src(data)                                                  ((0x00000010&(data))>>4)
+#define ADSP_AEE_INT_get_int4(data)                                                  ((0x00000010&(data))>>4)
+#define ADSP_AEE_INT_int3_shift                                                      (3)
+#define ADSP_AEE_INT_int3_mask                                                       (0x00000008)
+#define ADSP_AEE_INT_int3(data)                                                      (0x00000008&((data)<<3))
+#define ADSP_AEE_INT_int3_src(data)                                                  ((0x00000008&(data))>>3)
+#define ADSP_AEE_INT_get_int3(data)                                                  ((0x00000008&(data))>>3)
+#define ADSP_AEE_INT_int2_shift                                                      (2)
+#define ADSP_AEE_INT_int2_mask                                                       (0x00000004)
+#define ADSP_AEE_INT_int2(data)                                                      (0x00000004&((data)<<2))
+#define ADSP_AEE_INT_int2_src(data)                                                  ((0x00000004&(data))>>2)
+#define ADSP_AEE_INT_get_int2(data)                                                  ((0x00000004&(data))>>2)
+#define ADSP_AEE_INT_int1_shift                                                      (1)
+#define ADSP_AEE_INT_int1_mask                                                       (0x00000002)
+#define ADSP_AEE_INT_int1(data)                                                      (0x00000002&((data)<<1))
+#define ADSP_AEE_INT_int1_src(data)                                                  ((0x00000002&(data))>>1)
+#define ADSP_AEE_INT_get_int1(data)                                                  ((0x00000002&(data))>>1)
+#define ADSP_AEE_INT_write_data_shift                                                (0)
+#define ADSP_AEE_INT_write_data_mask                                                 (0x00000001)
+#define ADSP_AEE_INT_write_data(data)                                                (0x00000001&((data)<<0))
+#define ADSP_AEE_INT_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define ADSP_AEE_INT_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ADSP_AEE_INT_EN                                                              0x1800208c
+#define ADSP_AEE_INT_EN_reg_addr                                                     "0xB800208C"
+#define ADSP_AEE_INT_EN_reg                                                          0xB800208C
+#define set_ADSP_AEE_INT_EN_reg(data)   (*((volatile unsigned int*) ADSP_AEE_INT_EN_reg)=data)
+#define get_ADSP_AEE_INT_EN_reg   (*((volatile unsigned int*) ADSP_AEE_INT_EN_reg))
+#define ADSP_AEE_INT_EN_inst_adr                                                     "0x0023"
+#define ADSP_AEE_INT_EN_inst                                                         0x0023
+#define ADSP_AEE_INT_EN_int4_en_shift                                                (4)
+#define ADSP_AEE_INT_EN_int4_en_mask                                                 (0x00000010)
+#define ADSP_AEE_INT_EN_int4_en(data)                                                (0x00000010&((data)<<4))
+#define ADSP_AEE_INT_EN_int4_en_src(data)                                            ((0x00000010&(data))>>4)
+#define ADSP_AEE_INT_EN_get_int4_en(data)                                            ((0x00000010&(data))>>4)
+#define ADSP_AEE_INT_EN_int3_en_shift                                                (3)
+#define ADSP_AEE_INT_EN_int3_en_mask                                                 (0x00000008)
+#define ADSP_AEE_INT_EN_int3_en(data)                                                (0x00000008&((data)<<3))
+#define ADSP_AEE_INT_EN_int3_en_src(data)                                            ((0x00000008&(data))>>3)
+#define ADSP_AEE_INT_EN_get_int3_en(data)                                            ((0x00000008&(data))>>3)
+#define ADSP_AEE_INT_EN_int2_en_shift                                                (2)
+#define ADSP_AEE_INT_EN_int2_en_mask                                                 (0x00000004)
+#define ADSP_AEE_INT_EN_int2_en(data)                                                (0x00000004&((data)<<2))
+#define ADSP_AEE_INT_EN_int2_en_src(data)                                            ((0x00000004&(data))>>2)
+#define ADSP_AEE_INT_EN_get_int2_en(data)                                            ((0x00000004&(data))>>2)
+#define ADSP_AEE_INT_EN_int1_en_shift                                                (1)
+#define ADSP_AEE_INT_EN_int1_en_mask                                                 (0x00000002)
+#define ADSP_AEE_INT_EN_int1_en(data)                                                (0x00000002&((data)<<1))
+#define ADSP_AEE_INT_EN_int1_en_src(data)                                            ((0x00000002&(data))>>1)
+#define ADSP_AEE_INT_EN_get_int1_en(data)                                            ((0x00000002&(data))>>1)
+#define ADSP_AEE_INT_EN_write_data_shift                                             (0)
+#define ADSP_AEE_INT_EN_write_data_mask                                              (0x00000001)
+#define ADSP_AEE_INT_EN_write_data(data)                                             (0x00000001&((data)<<0))
+#define ADSP_AEE_INT_EN_write_data_src(data)                                         ((0x00000001&(data))>>0)
+#define ADSP_AEE_INT_EN_get_write_data(data)                                         ((0x00000001&(data))>>0)
+
+
+#define ADSP_AEE_RING_LIMIT                                                          0x18002094
+#define ADSP_AEE_RING_LIMIT_reg_addr                                                 "0xB8002094"
+#define ADSP_AEE_RING_LIMIT_reg                                                      0xB8002094
+#define set_ADSP_AEE_RING_LIMIT_reg(data)   (*((volatile unsigned int*) ADSP_AEE_RING_LIMIT_reg)=data)
+#define get_ADSP_AEE_RING_LIMIT_reg   (*((volatile unsigned int*) ADSP_AEE_RING_LIMIT_reg))
+#define ADSP_AEE_RING_LIMIT_inst_adr                                                 "0x0025"
+#define ADSP_AEE_RING_LIMIT_inst                                                     0x0025
+#define ADSP_AEE_RING_LIMIT_ring_limit_shift                                         (3)
+#define ADSP_AEE_RING_LIMIT_ring_limit_mask                                          (0x7FFFFFF8)
+#define ADSP_AEE_RING_LIMIT_ring_limit(data)                                         (0x7FFFFFF8&((data)<<3))
+#define ADSP_AEE_RING_LIMIT_ring_limit_src(data)                                     ((0x7FFFFFF8&(data))>>3)
+#define ADSP_AEE_RING_LIMIT_get_ring_limit(data)                                     ((0x7FFFFFF8&(data))>>3)
+
+
+#define ADSP_AEE_RING_BASE                                                           0x18002098
+#define ADSP_AEE_RING_BASE_reg_addr                                                  "0xB8002098"
+#define ADSP_AEE_RING_BASE_reg                                                       0xB8002098
+#define set_ADSP_AEE_RING_BASE_reg(data)   (*((volatile unsigned int*) ADSP_AEE_RING_BASE_reg)=data)
+#define get_ADSP_AEE_RING_BASE_reg   (*((volatile unsigned int*) ADSP_AEE_RING_BASE_reg))
+#define ADSP_AEE_RING_BASE_inst_adr                                                  "0x0026"
+#define ADSP_AEE_RING_BASE_inst                                                      0x0026
+#define ADSP_AEE_RING_BASE_ring_base_shift                                           (3)
+#define ADSP_AEE_RING_BASE_ring_base_mask                                            (0x7FFFFFF8)
+#define ADSP_AEE_RING_BASE_ring_base(data)                                           (0x7FFFFFF8&((data)<<3))
+#define ADSP_AEE_RING_BASE_ring_base_src(data)                                       ((0x7FFFFFF8&(data))>>3)
+#define ADSP_AEE_RING_BASE_get_ring_base(data)                                       ((0x7FFFFFF8&(data))>>3)
+
+
+#define ADSP_AEE_RING_RP                                                             0x1800209c
+#define ADSP_AEE_RING_RP_reg_addr                                                    "0xB800209C"
+#define ADSP_AEE_RING_RP_reg                                                         0xB800209C
+#define set_ADSP_AEE_RING_RP_reg(data)   (*((volatile unsigned int*) ADSP_AEE_RING_RP_reg)=data)
+#define get_ADSP_AEE_RING_RP_reg   (*((volatile unsigned int*) ADSP_AEE_RING_RP_reg))
+#define ADSP_AEE_RING_RP_inst_adr                                                    "0x0027"
+#define ADSP_AEE_RING_RP_inst                                                        0x0027
+#define ADSP_AEE_RING_RP_ring_rp_shift                                               (0)
+#define ADSP_AEE_RING_RP_ring_rp_mask                                                (0x7FFFFFFF)
+#define ADSP_AEE_RING_RP_ring_rp(data)                                               (0x7FFFFFFF&((data)<<0))
+#define ADSP_AEE_RING_RP_ring_rp_src(data)                                           ((0x7FFFFFFF&(data))>>0)
+#define ADSP_AEE_RING_RP_get_ring_rp(data)                                           ((0x7FFFFFFF&(data))>>0)
+
+
+#define ADSP_AEE_RING_WP                                                             0x180020a0
+#define ADSP_AEE_RING_WP_reg_addr                                                    "0xB80020A0"
+#define ADSP_AEE_RING_WP_reg                                                         0xB80020A0
+#define set_ADSP_AEE_RING_WP_reg(data)   (*((volatile unsigned int*) ADSP_AEE_RING_WP_reg)=data)
+#define get_ADSP_AEE_RING_WP_reg   (*((volatile unsigned int*) ADSP_AEE_RING_WP_reg))
+#define ADSP_AEE_RING_WP_inst_adr                                                    "0x0028"
+#define ADSP_AEE_RING_WP_inst                                                        0x0028
+#define ADSP_AEE_RING_WP_ring_wp_shift                                               (0)
+#define ADSP_AEE_RING_WP_ring_wp_mask                                                (0x7FFFFFFF)
+#define ADSP_AEE_RING_WP_ring_wp(data)                                               (0x7FFFFFFF&((data)<<0))
+#define ADSP_AEE_RING_WP_ring_wp_src(data)                                           ((0x7FFFFFFF&(data))>>0)
+#define ADSP_AEE_RING_WP_get_ring_wp(data)                                           ((0x7FFFFFFF&(data))>>0)
+
+
+#define ADSP_AEE_RING_CP                                                             0x180020a4
+#define ADSP_AEE_RING_CP_reg_addr                                                    "0xB80020A4"
+#define ADSP_AEE_RING_CP_reg                                                         0xB80020A4
+#define set_ADSP_AEE_RING_CP_reg(data)   (*((volatile unsigned int*) ADSP_AEE_RING_CP_reg)=data)
+#define get_ADSP_AEE_RING_CP_reg   (*((volatile unsigned int*) ADSP_AEE_RING_CP_reg))
+#define ADSP_AEE_RING_CP_inst_adr                                                    "0x0029"
+#define ADSP_AEE_RING_CP_inst                                                        0x0029
+#define ADSP_AEE_RING_CP_ring_cp_shift                                               (0)
+#define ADSP_AEE_RING_CP_ring_cp_mask                                                (0x7FFFFFFF)
+#define ADSP_AEE_RING_CP_ring_cp(data)                                               (0x7FFFFFFF&((data)<<0))
+#define ADSP_AEE_RING_CP_ring_cp_src(data)                                           ((0x7FFFFFFF&(data))>>0)
+#define ADSP_AEE_RING_CP_get_ring_cp(data)                                           ((0x7FFFFFFF&(data))>>0)
+
+
+#define ADSP_AEE_SEARCH_LIMIT                                                        0x180020c8
+#define ADSP_AEE_SEARCH_LIMIT_reg_addr                                               "0xB80020C8"
+#define ADSP_AEE_SEARCH_LIMIT_reg                                                    0xB80020C8
+#define set_ADSP_AEE_SEARCH_LIMIT_reg(data)   (*((volatile unsigned int*) ADSP_AEE_SEARCH_LIMIT_reg)=data)
+#define get_ADSP_AEE_SEARCH_LIMIT_reg   (*((volatile unsigned int*) ADSP_AEE_SEARCH_LIMIT_reg))
+#define ADSP_AEE_SEARCH_LIMIT_inst_adr                                               "0x0032"
+#define ADSP_AEE_SEARCH_LIMIT_inst                                                   0x0032
+#define ADSP_AEE_SEARCH_LIMIT_limit_shift                                            (0)
+#define ADSP_AEE_SEARCH_LIMIT_limit_mask                                             (0x0000FFFF)
+#define ADSP_AEE_SEARCH_LIMIT_limit(data)                                            (0x0000FFFF&((data)<<0))
+#define ADSP_AEE_SEARCH_LIMIT_limit_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define ADSP_AEE_SEARCH_LIMIT_get_limit(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define ADSP_AEE_CRC_INIT                                                            0x180020ac
+#define ADSP_AEE_CRC_INIT_reg_addr                                                   "0xB80020AC"
+#define ADSP_AEE_CRC_INIT_reg                                                        0xB80020AC
+#define set_ADSP_AEE_CRC_INIT_reg(data)   (*((volatile unsigned int*) ADSP_AEE_CRC_INIT_reg)=data)
+#define get_ADSP_AEE_CRC_INIT_reg   (*((volatile unsigned int*) ADSP_AEE_CRC_INIT_reg))
+#define ADSP_AEE_CRC_INIT_inst_adr                                                   "0x002B"
+#define ADSP_AEE_CRC_INIT_inst                                                       0x002B
+#define ADSP_AEE_CRC_INIT_crc_init_shift                                             (0)
+#define ADSP_AEE_CRC_INIT_crc_init_mask                                              (0x0000FFFF)
+#define ADSP_AEE_CRC_INIT_crc_init(data)                                             (0x0000FFFF&((data)<<0))
+#define ADSP_AEE_CRC_INIT_crc_init_src(data)                                         ((0x0000FFFF&(data))>>0)
+#define ADSP_AEE_CRC_INIT_get_crc_init(data)                                         ((0x0000FFFF&(data))>>0)
+
+
+#define ADSP_AEE_CRC_CNTL                                                            0x180020b0
+#define ADSP_AEE_CRC_CNTL_reg_addr                                                   "0xB80020B0"
+#define ADSP_AEE_CRC_CNTL_reg                                                        0xB80020B0
+#define set_ADSP_AEE_CRC_CNTL_reg(data)   (*((volatile unsigned int*) ADSP_AEE_CRC_CNTL_reg)=data)
+#define get_ADSP_AEE_CRC_CNTL_reg   (*((volatile unsigned int*) ADSP_AEE_CRC_CNTL_reg))
+#define ADSP_AEE_CRC_CNTL_inst_adr                                                   "0x002C"
+#define ADSP_AEE_CRC_CNTL_inst                                                       0x002C
+#define ADSP_AEE_CRC_CNTL_write_en4_shift                                            (7)
+#define ADSP_AEE_CRC_CNTL_write_en4_mask                                             (0x00000080)
+#define ADSP_AEE_CRC_CNTL_write_en4(data)                                            (0x00000080&((data)<<7))
+#define ADSP_AEE_CRC_CNTL_write_en4_src(data)                                        ((0x00000080&(data))>>7)
+#define ADSP_AEE_CRC_CNTL_get_write_en4(data)                                        ((0x00000080&(data))>>7)
+#define ADSP_AEE_CRC_CNTL_crc_mode_shift                                             (6)
+#define ADSP_AEE_CRC_CNTL_crc_mode_mask                                              (0x00000040)
+#define ADSP_AEE_CRC_CNTL_crc_mode(data)                                             (0x00000040&((data)<<6))
+#define ADSP_AEE_CRC_CNTL_crc_mode_src(data)                                         ((0x00000040&(data))>>6)
+#define ADSP_AEE_CRC_CNTL_get_crc_mode(data)                                         ((0x00000040&(data))>>6)
+#define ADSP_AEE_CRC_CNTL_write_en1_shift                                            (5)
+#define ADSP_AEE_CRC_CNTL_write_en1_mask                                             (0x00000020)
+#define ADSP_AEE_CRC_CNTL_write_en1(data)                                            (0x00000020&((data)<<5))
+#define ADSP_AEE_CRC_CNTL_write_en1_src(data)                                        ((0x00000020&(data))>>5)
+#define ADSP_AEE_CRC_CNTL_get_write_en1(data)                                        ((0x00000020&(data))>>5)
+#define ADSP_AEE_CRC_CNTL_crc_reset_shift                                            (4)
+#define ADSP_AEE_CRC_CNTL_crc_reset_mask                                             (0x00000010)
+#define ADSP_AEE_CRC_CNTL_crc_reset(data)                                            (0x00000010&((data)<<4))
+#define ADSP_AEE_CRC_CNTL_crc_reset_src(data)                                        ((0x00000010&(data))>>4)
+#define ADSP_AEE_CRC_CNTL_get_crc_reset(data)                                        ((0x00000010&(data))>>4)
+#define ADSP_AEE_CRC_CNTL_write_en2_shift                                            (3)
+#define ADSP_AEE_CRC_CNTL_write_en2_mask                                             (0x00000008)
+#define ADSP_AEE_CRC_CNTL_write_en2(data)                                            (0x00000008&((data)<<3))
+#define ADSP_AEE_CRC_CNTL_write_en2_src(data)                                        ((0x00000008&(data))>>3)
+#define ADSP_AEE_CRC_CNTL_get_write_en2(data)                                        ((0x00000008&(data))>>3)
+#define ADSP_AEE_CRC_CNTL_crc_cont_shift                                             (2)
+#define ADSP_AEE_CRC_CNTL_crc_cont_mask                                              (0x00000004)
+#define ADSP_AEE_CRC_CNTL_crc_cont(data)                                             (0x00000004&((data)<<2))
+#define ADSP_AEE_CRC_CNTL_crc_cont_src(data)                                         ((0x00000004&(data))>>2)
+#define ADSP_AEE_CRC_CNTL_get_crc_cont(data)                                         ((0x00000004&(data))>>2)
+#define ADSP_AEE_CRC_CNTL_write_en3_shift                                            (1)
+#define ADSP_AEE_CRC_CNTL_write_en3_mask                                             (0x00000002)
+#define ADSP_AEE_CRC_CNTL_write_en3(data)                                            (0x00000002&((data)<<1))
+#define ADSP_AEE_CRC_CNTL_write_en3_src(data)                                        ((0x00000002&(data))>>1)
+#define ADSP_AEE_CRC_CNTL_get_write_en3(data)                                        ((0x00000002&(data))>>1)
+#define ADSP_AEE_CRC_CNTL_crc_on_shift                                               (0)
+#define ADSP_AEE_CRC_CNTL_crc_on_mask                                                (0x00000001)
+#define ADSP_AEE_CRC_CNTL_crc_on(data)                                               (0x00000001&((data)<<0))
+#define ADSP_AEE_CRC_CNTL_crc_on_src(data)                                           ((0x00000001&(data))>>0)
+#define ADSP_AEE_CRC_CNTL_get_crc_on(data)                                           ((0x00000001&(data))>>0)
+
+
+#define ADSP_AEE_CRC_LENGTH                                                          0x180020b4
+#define ADSP_AEE_CRC_LENGTH_reg_addr                                                 "0xB80020B4"
+#define ADSP_AEE_CRC_LENGTH_reg                                                      0xB80020B4
+#define set_ADSP_AEE_CRC_LENGTH_reg(data)   (*((volatile unsigned int*) ADSP_AEE_CRC_LENGTH_reg)=data)
+#define get_ADSP_AEE_CRC_LENGTH_reg   (*((volatile unsigned int*) ADSP_AEE_CRC_LENGTH_reg))
+#define ADSP_AEE_CRC_LENGTH_inst_adr                                                 "0x002D"
+#define ADSP_AEE_CRC_LENGTH_inst                                                     0x002D
+#define ADSP_AEE_CRC_LENGTH_crc_length_shift                                         (0)
+#define ADSP_AEE_CRC_LENGTH_crc_length_mask                                          (0x0000FFFF)
+#define ADSP_AEE_CRC_LENGTH_crc_length(data)                                         (0x0000FFFF&((data)<<0))
+#define ADSP_AEE_CRC_LENGTH_crc_length_src(data)                                     ((0x0000FFFF&(data))>>0)
+#define ADSP_AEE_CRC_LENGTH_get_crc_length(data)                                     ((0x0000FFFF&(data))>>0)
+
+
+#define ADSP_AEE_CRC_RESULT                                                          0x180020b8
+#define ADSP_AEE_CRC_RESULT_reg_addr                                                 "0xB80020B8"
+#define ADSP_AEE_CRC_RESULT_reg                                                      0xB80020B8
+#define set_ADSP_AEE_CRC_RESULT_reg(data)   (*((volatile unsigned int*) ADSP_AEE_CRC_RESULT_reg)=data)
+#define get_ADSP_AEE_CRC_RESULT_reg   (*((volatile unsigned int*) ADSP_AEE_CRC_RESULT_reg))
+#define ADSP_AEE_CRC_RESULT_inst_adr                                                 "0x002E"
+#define ADSP_AEE_CRC_RESULT_inst                                                     0x002E
+#define ADSP_AEE_CRC_RESULT_crc_result_shift                                         (0)
+#define ADSP_AEE_CRC_RESULT_crc_result_mask                                          (0x0000FFFF)
+#define ADSP_AEE_CRC_RESULT_crc_result(data)                                         (0x0000FFFF&((data)<<0))
+#define ADSP_AEE_CRC_RESULT_crc_result_src(data)                                     ((0x0000FFFF&(data))>>0)
+#define ADSP_AEE_CRC_RESULT_get_crc_result(data)                                     ((0x0000FFFF&(data))>>0)
+
+
+#define ADSP_AEE_BIT_CNT                                                             0x180020bc
+#define ADSP_AEE_BIT_CNT_reg_addr                                                    "0xB80020BC"
+#define ADSP_AEE_BIT_CNT_reg                                                         0xB80020BC
+#define set_ADSP_AEE_BIT_CNT_reg(data)   (*((volatile unsigned int*) ADSP_AEE_BIT_CNT_reg)=data)
+#define get_ADSP_AEE_BIT_CNT_reg   (*((volatile unsigned int*) ADSP_AEE_BIT_CNT_reg))
+#define ADSP_AEE_BIT_CNT_inst_adr                                                    "0x002F"
+#define ADSP_AEE_BIT_CNT_inst                                                        0x002F
+#define ADSP_AEE_BIT_CNT_crc_bit_cnt_shift                                           (0)
+#define ADSP_AEE_BIT_CNT_crc_bit_cnt_mask                                            (0xFFFFFFFF)
+#define ADSP_AEE_BIT_CNT_crc_bit_cnt(data)                                           (0xFFFFFFFF&((data)<<0))
+#define ADSP_AEE_BIT_CNT_crc_bit_cnt_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define ADSP_AEE_BIT_CNT_get_crc_bit_cnt(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define ADSP_AEE_CRC_ACC                                                             0x180020c0
+#define ADSP_AEE_CRC_ACC_reg_addr                                                    "0xB80020C0"
+#define ADSP_AEE_CRC_ACC_reg                                                         0xB80020C0
+#define set_ADSP_AEE_CRC_ACC_reg(data)   (*((volatile unsigned int*) ADSP_AEE_CRC_ACC_reg)=data)
+#define get_ADSP_AEE_CRC_ACC_reg   (*((volatile unsigned int*) ADSP_AEE_CRC_ACC_reg))
+#define ADSP_AEE_CRC_ACC_inst_adr                                                    "0x0030"
+#define ADSP_AEE_CRC_ACC_inst                                                        0x0030
+#define ADSP_AEE_CRC_ACC_acc_shift                                                   (0)
+#define ADSP_AEE_CRC_ACC_acc_mask                                                    (0x0000FFFF)
+#define ADSP_AEE_CRC_ACC_acc(data)                                                   (0x0000FFFF&((data)<<0))
+#define ADSP_AEE_CRC_ACC_acc_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define ADSP_AEE_CRC_ACC_get_acc(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define ADSP_AEE_CRC_ACC_CNT                                                         0x180020c4
+#define ADSP_AEE_CRC_ACC_CNT_reg_addr                                                "0xB80020C4"
+#define ADSP_AEE_CRC_ACC_CNT_reg                                                     0xB80020C4
+#define set_ADSP_AEE_CRC_ACC_CNT_reg(data)   (*((volatile unsigned int*) ADSP_AEE_CRC_ACC_CNT_reg)=data)
+#define get_ADSP_AEE_CRC_ACC_CNT_reg   (*((volatile unsigned int*) ADSP_AEE_CRC_ACC_CNT_reg))
+#define ADSP_AEE_CRC_ACC_CNT_inst_adr                                                "0x0031"
+#define ADSP_AEE_CRC_ACC_CNT_inst                                                    0x0031
+#define ADSP_AEE_CRC_ACC_CNT_acc_cnt_shift                                           (0)
+#define ADSP_AEE_CRC_ACC_CNT_acc_cnt_mask                                            (0x0000000F)
+#define ADSP_AEE_CRC_ACC_CNT_acc_cnt(data)                                           (0x0000000F&((data)<<0))
+#define ADSP_AEE_CRC_ACC_CNT_acc_cnt_src(data)                                       ((0x0000000F&(data))>>0)
+#define ADSP_AEE_CRC_ACC_CNT_get_acc_cnt(data)                                       ((0x0000000F&(data))>>0)
+
+
+#define AEE_OGG_MODE                                                                 0x180020d0
+#define AEE_OGG_MODE_reg_addr                                                        "0xB80020D0"
+#define AEE_OGG_MODE_reg                                                             0xB80020D0
+#define set_AEE_OGG_MODE_reg(data)   (*((volatile unsigned int*) AEE_OGG_MODE_reg)=data)
+#define get_AEE_OGG_MODE_reg   (*((volatile unsigned int*) AEE_OGG_MODE_reg))
+#define AEE_OGG_MODE_inst_adr                                                        "0x0034"
+#define AEE_OGG_MODE_inst                                                            0x0034
+#define AEE_OGG_MODE_aee_audio_mode_shift                                            (0)
+#define AEE_OGG_MODE_aee_audio_mode_mask                                             (0x00000003)
+#define AEE_OGG_MODE_aee_audio_mode(data)                                            (0x00000003&((data)<<0))
+#define AEE_OGG_MODE_aee_audio_mode_src(data)                                        ((0x00000003&(data))>>0)
+#define AEE_OGG_MODE_get_aee_audio_mode(data)                                        ((0x00000003&(data))>>0)
+
+
+#define ADSP_BIST_RM                                                                      0x180020dc
+#define ADSP_BIST_RM_reg_addr                                                             "0xB80020DC"
+#define ADSP_BIST_RM_reg                                                                  0xB80020DC
+#define set_ADSP_BIST_RM_reg(data)   (*((volatile unsigned int*) ADSP_BIST_RM_reg)=data)
+#define get_ADSP_BIST_RM_reg   (*((volatile unsigned int*) ADSP_BIST_RM_reg))
+#define ADSP_BIST_RM_inst_adr                                                             "0x0037"
+#define ADSP_BIST_RM_inst                                                                 0x0037
+#define ADSP_BIST_RM_RME_shift                                                            (4)
+#define ADSP_BIST_RM_RME_mask                                                             (0x00000010)
+#define ADSP_BIST_RM_RME(data)                                                            (0x00000010&((data)<<4))
+#define ADSP_BIST_RM_RME_src(data)                                                        ((0x00000010&(data))>>4)
+#define ADSP_BIST_RM_get_RME(data)                                                        ((0x00000010&(data))>>4)
+#define ADSP_BIST_RM_RM_3_shift                                                           (3)
+#define ADSP_BIST_RM_RM_3_mask                                                            (0x00000008)
+#define ADSP_BIST_RM_RM_3(data)                                                           (0x00000008&((data)<<3))
+#define ADSP_BIST_RM_RM_3_src(data)                                                       ((0x00000008&(data))>>3)
+#define ADSP_BIST_RM_get_RM_3(data)                                                       ((0x00000008&(data))>>3)
+#define ADSP_BIST_RM_RM_2_shift                                                           (2)
+#define ADSP_BIST_RM_RM_2_mask                                                            (0x00000004)
+#define ADSP_BIST_RM_RM_2(data)                                                           (0x00000004&((data)<<2))
+#define ADSP_BIST_RM_RM_2_src(data)                                                       ((0x00000004&(data))>>2)
+#define ADSP_BIST_RM_get_RM_2(data)                                                       ((0x00000004&(data))>>2)
+#define ADSP_BIST_RM_RM_1_shift                                                           (1)
+#define ADSP_BIST_RM_RM_1_mask                                                            (0x00000002)
+#define ADSP_BIST_RM_RM_1(data)                                                           (0x00000002&((data)<<1))
+#define ADSP_BIST_RM_RM_1_src(data)                                                       ((0x00000002&(data))>>1)
+#define ADSP_BIST_RM_get_RM_1(data)                                                       ((0x00000002&(data))>>1)
+#define ADSP_BIST_RM_RM_0_shift                                                           (0)
+#define ADSP_BIST_RM_RM_0_mask                                                            (0x00000001)
+#define ADSP_BIST_RM_RM_0(data)                                                           (0x00000001&((data)<<0))
+#define ADSP_BIST_RM_RM_0_src(data)                                                       ((0x00000001&(data))>>0)
+#define ADSP_BIST_RM_get_RM_0(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define BIST_ST                                                                      0x180020e0
+#define BIST_ST_reg_addr                                                             "0xB80020E0"
+#define BIST_ST_reg                                                                  0xB80020E0
+#define set_BIST_ST_reg(data)   (*((volatile unsigned int*) BIST_ST_reg)=data)
+#define get_BIST_ST_reg   (*((volatile unsigned int*) BIST_ST_reg))
+#define BIST_ST_inst_adr                                                             "0x0038"
+#define BIST_ST_inst                                                                 0x0038
+#define BIST_ST_bist_fail3_shift                                                     (4)
+#define BIST_ST_bist_fail3_mask                                                      (0x00000010)
+#define BIST_ST_bist_fail3(data)                                                     (0x00000010&((data)<<4))
+#define BIST_ST_bist_fail3_src(data)                                                 ((0x00000010&(data))>>4)
+#define BIST_ST_get_bist_fail3(data)                                                 ((0x00000010&(data))>>4)
+#define BIST_ST_bist_fail2_shift                                                     (3)
+#define BIST_ST_bist_fail2_mask                                                      (0x00000008)
+#define BIST_ST_bist_fail2(data)                                                     (0x00000008&((data)<<3))
+#define BIST_ST_bist_fail2_src(data)                                                 ((0x00000008&(data))>>3)
+#define BIST_ST_get_bist_fail2(data)                                                 ((0x00000008&(data))>>3)
+#define BIST_ST_bist_fail1_shift                                                     (2)
+#define BIST_ST_bist_fail1_mask                                                      (0x00000004)
+#define BIST_ST_bist_fail1(data)                                                     (0x00000004&((data)<<2))
+#define BIST_ST_bist_fail1_src(data)                                                 ((0x00000004&(data))>>2)
+#define BIST_ST_get_bist_fail1(data)                                                 ((0x00000004&(data))>>2)
+#define BIST_ST_bist_fail0_shift                                                     (1)
+#define BIST_ST_bist_fail0_mask                                                      (0x00000002)
+#define BIST_ST_bist_fail0(data)                                                     (0x00000002&((data)<<1))
+#define BIST_ST_bist_fail0_src(data)                                                 ((0x00000002&(data))>>1)
+#define BIST_ST_get_bist_fail0(data)                                                 ((0x00000002&(data))>>1)
+#define BIST_ST_bist_done_shift                                                      (0)
+#define BIST_ST_bist_done_mask                                                       (0x00000001)
+#define BIST_ST_bist_done(data)                                                      (0x00000001&((data)<<0))
+#define BIST_ST_bist_done_src(data)                                                  ((0x00000001&(data))>>0)
+#define BIST_ST_get_bist_done(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define DRF_ST                                                                       0x180020e4
+#define DRF_ST_reg_addr                                                              "0xB80020E4"
+#define DRF_ST_reg                                                                   0xB80020E4
+#define set_DRF_ST_reg(data)   (*((volatile unsigned int*) DRF_ST_reg)=data)
+#define get_DRF_ST_reg   (*((volatile unsigned int*) DRF_ST_reg))
+#define DRF_ST_inst_adr                                                              "0x0039"
+#define DRF_ST_inst                                                                  0x0039
+#define DRF_ST_drf_start_pause_shift                                                 (16)
+#define DRF_ST_drf_start_pause_mask                                                  (0x00010000)
+#define DRF_ST_drf_start_pause(data)                                                 (0x00010000&((data)<<16))
+#define DRF_ST_drf_start_pause_src(data)                                             ((0x00010000&(data))>>16)
+#define DRF_ST_get_drf_start_pause(data)                                             ((0x00010000&(data))>>16)
+#define DRF_ST_drf_fail3_shift                                                       (4)
+#define DRF_ST_drf_fail3_mask                                                        (0x00000010)
+#define DRF_ST_drf_fail3(data)                                                       (0x00000010&((data)<<4))
+#define DRF_ST_drf_fail3_src(data)                                                   ((0x00000010&(data))>>4)
+#define DRF_ST_get_drf_fail3(data)                                                   ((0x00000010&(data))>>4)
+#define DRF_ST_drf_fail2_shift                                                       (3)
+#define DRF_ST_drf_fail2_mask                                                        (0x00000008)
+#define DRF_ST_drf_fail2(data)                                                       (0x00000008&((data)<<3))
+#define DRF_ST_drf_fail2_src(data)                                                   ((0x00000008&(data))>>3)
+#define DRF_ST_get_drf_fail2(data)                                                   ((0x00000008&(data))>>3)
+#define DRF_ST_drf_fail1_shift                                                       (2)
+#define DRF_ST_drf_fail1_mask                                                        (0x00000004)
+#define DRF_ST_drf_fail1(data)                                                       (0x00000004&((data)<<2))
+#define DRF_ST_drf_fail1_src(data)                                                   ((0x00000004&(data))>>2)
+#define DRF_ST_get_drf_fail1(data)                                                   ((0x00000004&(data))>>2)
+#define DRF_ST_drf_fail0_shift                                                       (1)
+#define DRF_ST_drf_fail0_mask                                                        (0x00000002)
+#define DRF_ST_drf_fail0(data)                                                       (0x00000002&((data)<<1))
+#define DRF_ST_drf_fail0_src(data)                                                   ((0x00000002&(data))>>1)
+#define DRF_ST_get_drf_fail0(data)                                                   ((0x00000002&(data))>>1)
+#define DRF_ST_drf_done_shift                                                        (0)
+#define DRF_ST_drf_done_mask                                                         (0x00000001)
+#define DRF_ST_drf_done(data)                                                        (0x00000001&((data)<<0))
+#define DRF_ST_drf_done_src(data)                                                    ((0x00000001&(data))>>0)
+#define DRF_ST_get_drf_done(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ROM_RM                                                                       0x180020e8
+#define ROM_RM_reg_addr                                                              "0xB80020E8"
+#define ROM_RM_reg                                                                   0xB80020E8
+#define set_ROM_RM_reg(data)   (*((volatile unsigned int*) ROM_RM_reg)=data)
+#define get_ROM_RM_reg   (*((volatile unsigned int*) ROM_RM_reg))
+#define ROM_RM_inst_adr                                                              "0x003A"
+#define ROM_RM_inst                                                                  0x003A
+#define ROM_RM_RME_shift                                                             (4)
+#define ROM_RM_RME_mask                                                              (0x00000010)
+#define ROM_RM_RME(data)                                                             (0x00000010&((data)<<4))
+#define ROM_RM_RME_src(data)                                                         ((0x00000010&(data))>>4)
+#define ROM_RM_get_RME(data)                                                         ((0x00000010&(data))>>4)
+#define ROM_RM_RM_3_shift                                                            (3)
+#define ROM_RM_RM_3_mask                                                             (0x00000008)
+#define ROM_RM_RM_3(data)                                                            (0x00000008&((data)<<3))
+#define ROM_RM_RM_3_src(data)                                                        ((0x00000008&(data))>>3)
+#define ROM_RM_get_RM_3(data)                                                        ((0x00000008&(data))>>3)
+#define ROM_RM_RM_2_shift                                                            (2)
+#define ROM_RM_RM_2_mask                                                             (0x00000004)
+#define ROM_RM_RM_2(data)                                                            (0x00000004&((data)<<2))
+#define ROM_RM_RM_2_src(data)                                                        ((0x00000004&(data))>>2)
+#define ROM_RM_get_RM_2(data)                                                        ((0x00000004&(data))>>2)
+#define ROM_RM_RM_1_shift                                                            (1)
+#define ROM_RM_RM_1_mask                                                             (0x00000002)
+#define ROM_RM_RM_1(data)                                                            (0x00000002&((data)<<1))
+#define ROM_RM_RM_1_src(data)                                                        ((0x00000002&(data))>>1)
+#define ROM_RM_get_RM_1(data)                                                        ((0x00000002&(data))>>1)
+#define ROM_RM_RM_0_shift                                                            (0)
+#define ROM_RM_RM_0_mask                                                             (0x00000001)
+#define ROM_RM_RM_0(data)                                                            (0x00000001&((data)<<0))
+#define ROM_RM_RM_0_src(data)                                                        ((0x00000001&(data))>>0)
+#define ROM_RM_get_RM_0(data)                                                        ((0x00000001&(data))>>0)
+
+
+#define ROM_ST1                                                                      0x180020ec
+#define ROM_ST1_reg_addr                                                             "0xB80020EC"
+#define ROM_ST1_reg                                                                  0xB80020EC
+#define set_ROM_ST1_reg(data)   (*((volatile unsigned int*) ROM_ST1_reg)=data)
+#define get_ROM_ST1_reg   (*((volatile unsigned int*) ROM_ST1_reg))
+#define ROM_ST1_inst_adr                                                             "0x003B"
+#define ROM_ST1_inst                                                                 0x003B
+#define ROM_ST1_bist_done_shift                                                      (0)
+#define ROM_ST1_bist_done_mask                                                       (0x00000001)
+#define ROM_ST1_bist_done(data)                                                      (0x00000001&((data)<<0))
+#define ROM_ST1_bist_done_src(data)                                                  ((0x00000001&(data))>>0)
+#define ROM_ST1_get_bist_done(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define ROM_ST2_0                                                                    0x180020F0
+#define ROM_ST2_1                                                                    0x180020F4
+#define ROM_ST2_0_reg_addr                                                           "0xB80020F0"
+#define ROM_ST2_1_reg_addr                                                           "0xB80020F4"
+#define ROM_ST2_0_reg                                                                0xB80020F0
+#define ROM_ST2_1_reg                                                                0xB80020F4
+#define set_ROM_ST2_0_reg(data)   (*((volatile unsigned int*) ROM_ST2_0_reg)=data)
+#define set_ROM_ST2_1_reg(data)   (*((volatile unsigned int*) ROM_ST2_1_reg)=data)
+#define get_ROM_ST2_0_reg   (*((volatile unsigned int*) ROM_ST2_0_reg))
+#define get_ROM_ST2_1_reg   (*((volatile unsigned int*) ROM_ST2_1_reg))
+#define ROM_ST2_0_inst_adr                                                           "0x003C"
+#define ROM_ST2_1_inst_adr                                                           "0x003D"
+#define ROM_ST2_0_inst                                                               0x003C
+#define ROM_ST2_1_inst                                                               0x003D
+#define ROM_ST2_ae_rom_bist_crc_shift                                                (0)
+#define ROM_ST2_ae_rom_bist_crc_mask                                                 (0xFFFFFFFF)
+#define ROM_ST2_ae_rom_bist_crc(data)                                                (0xFFFFFFFF&((data)<<0))
+#define ROM_ST2_ae_rom_bist_crc_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define ROM_ST2_get_ae_rom_bist_crc(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define AE_DEBUG                                                                     0x180020d8
+#define AE_DEBUG_reg_addr                                                            "0xB80020D8"
+#define AE_DEBUG_reg                                                                 0xB80020D8
+#define set_AE_DEBUG_reg(data)   (*((volatile unsigned int*) AE_DEBUG_reg)=data)
+#define get_AE_DEBUG_reg   (*((volatile unsigned int*) AE_DEBUG_reg))
+#define AE_DEBUG_inst_adr                                                            "0x0036"
+#define AE_DEBUG_inst                                                                0x0036
+#define AE_DEBUG_ae_sys_dbg_en_shift                                                 (23)
+#define AE_DEBUG_ae_sys_dbg_en_mask                                                  (0x00800000)
+#define AE_DEBUG_ae_sys_dbg_en(data)                                                 (0x00800000&((data)<<23))
+#define AE_DEBUG_ae_sys_dbg_en_src(data)                                             ((0x00800000&(data))>>23)
+#define AE_DEBUG_get_ae_sys_dbg_en(data)                                             ((0x00800000&(data))>>23)
+#define AE_DEBUG_ae_sys_dbg_sel1_shift                                               (18)
+#define AE_DEBUG_ae_sys_dbg_sel1_mask                                                (0x007C0000)
+#define AE_DEBUG_ae_sys_dbg_sel1(data)                                               (0x007C0000&((data)<<18))
+#define AE_DEBUG_ae_sys_dbg_sel1_src(data)                                           ((0x007C0000&(data))>>18)
+#define AE_DEBUG_get_ae_sys_dbg_sel1(data)                                           ((0x007C0000&(data))>>18)
+#define AE_DEBUG_ae_sys_dbg_sel0_shift                                               (13)
+#define AE_DEBUG_ae_sys_dbg_sel0_mask                                                (0x0003E000)
+#define AE_DEBUG_ae_sys_dbg_sel0(data)                                               (0x0003E000&((data)<<13))
+#define AE_DEBUG_ae_sys_dbg_sel0_src(data)                                           ((0x0003E000&(data))>>13)
+#define AE_DEBUG_get_ae_sys_dbg_sel0(data)                                           ((0x0003E000&(data))>>13)
+#define AE_DEBUG_ae_dbg_en_shift                                                     (12)
+#define AE_DEBUG_ae_dbg_en_mask                                                      (0x00001000)
+#define AE_DEBUG_ae_dbg_en(data)                                                     (0x00001000&((data)<<12))
+#define AE_DEBUG_ae_dbg_en_src(data)                                                 ((0x00001000&(data))>>12)
+#define AE_DEBUG_get_ae_dbg_en(data)                                                 ((0x00001000&(data))>>12)
+#define AE_DEBUG_ae_dbg_sel1_shift                                                   (6)
+#define AE_DEBUG_ae_dbg_sel1_mask                                                    (0x00000FC0)
+#define AE_DEBUG_ae_dbg_sel1(data)                                                   (0x00000FC0&((data)<<6))
+#define AE_DEBUG_ae_dbg_sel1_src(data)                                               ((0x00000FC0&(data))>>6)
+#define AE_DEBUG_get_ae_dbg_sel1(data)                                               ((0x00000FC0&(data))>>6)
+#define AE_DEBUG_ae_dbg_sel0_shift                                                   (0)
+#define AE_DEBUG_ae_dbg_sel0_mask                                                    (0x0000003F)
+#define AE_DEBUG_ae_dbg_sel0(data)                                                   (0x0000003F&((data)<<0))
+#define AE_DEBUG_ae_dbg_sel0_src(data)                                               ((0x0000003F&(data))>>0)
+#define AE_DEBUG_get_ae_dbg_sel0(data)                                               ((0x0000003F&(data))>>0)
+
+
+#define SRC_SRC_BASE                                                                 0x18002100
+#define SRC_SRC_BASE_reg_addr                                                        "0xB8002100"
+#define SRC_SRC_BASE_reg                                                             0xB8002100
+#define set_SRC_SRC_BASE_reg(data)   (*((volatile unsigned int*) SRC_SRC_BASE_reg)=data)
+#define get_SRC_SRC_BASE_reg   (*((volatile unsigned int*) SRC_SRC_BASE_reg))
+#define SRC_SRC_BASE_inst_adr                                                        "0x0040"
+#define SRC_SRC_BASE_inst                                                            0x0040
+#define SRC_SRC_BASE_src_src_base_shift                                              (3)
+#define SRC_SRC_BASE_src_src_base_mask                                               (0x7FFFFFF8)
+#define SRC_SRC_BASE_src_src_base(data)                                              (0x7FFFFFF8&((data)<<3))
+#define SRC_SRC_BASE_src_src_base_src(data)                                          ((0x7FFFFFF8&(data))>>3)
+#define SRC_SRC_BASE_get_src_src_base(data)                                          ((0x7FFFFFF8&(data))>>3)
+
+
+#define SRC_SRC_WP                                                                   0x18002104
+#define SRC_SRC_WP_reg_addr                                                          "0xB8002104"
+#define SRC_SRC_WP_reg                                                               0xB8002104
+#define set_SRC_SRC_WP_reg(data)   (*((volatile unsigned int*) SRC_SRC_WP_reg)=data)
+#define get_SRC_SRC_WP_reg   (*((volatile unsigned int*) SRC_SRC_WP_reg))
+#define SRC_SRC_WP_inst_adr                                                          "0x0041"
+#define SRC_SRC_WP_inst                                                              0x0041
+#define SRC_SRC_WP_src_src_wp_shift                                                  (2)
+#define SRC_SRC_WP_src_src_wp_mask                                                   (0x7FFFFFFC)
+#define SRC_SRC_WP_src_src_wp(data)                                                  (0x7FFFFFFC&((data)<<2))
+#define SRC_SRC_WP_src_src_wp_src(data)                                              ((0x7FFFFFFC&(data))>>2)
+#define SRC_SRC_WP_get_src_src_wp(data)                                              ((0x7FFFFFFC&(data))>>2)
+
+
+#define SRC_SRC_RP                                                                   0x18002108
+#define SRC_SRC_RP_reg_addr                                                          "0xB8002108"
+#define SRC_SRC_RP_reg                                                               0xB8002108
+#define set_SRC_SRC_RP_reg(data)   (*((volatile unsigned int*) SRC_SRC_RP_reg)=data)
+#define get_SRC_SRC_RP_reg   (*((volatile unsigned int*) SRC_SRC_RP_reg))
+#define SRC_SRC_RP_inst_adr                                                          "0x0042"
+#define SRC_SRC_RP_inst                                                              0x0042
+#define SRC_SRC_RP_src_src_rp_shift                                                  (2)
+#define SRC_SRC_RP_src_src_rp_mask                                                   (0x7FFFFFFC)
+#define SRC_SRC_RP_src_src_rp(data)                                                  (0x7FFFFFFC&((data)<<2))
+#define SRC_SRC_RP_src_src_rp_src(data)                                              ((0x7FFFFFFC&(data))>>2)
+#define SRC_SRC_RP_get_src_src_rp(data)                                              ((0x7FFFFFFC&(data))>>2)
+
+
+#define SRC_DEST_BASE                                                                0x1800210c
+#define SRC_DEST_BASE_reg_addr                                                       "0xB800210C"
+#define SRC_DEST_BASE_reg                                                            0xB800210C
+#define set_SRC_DEST_BASE_reg(data)   (*((volatile unsigned int*) SRC_DEST_BASE_reg)=data)
+#define get_SRC_DEST_BASE_reg   (*((volatile unsigned int*) SRC_DEST_BASE_reg))
+#define SRC_DEST_BASE_inst_adr                                                       "0x0043"
+#define SRC_DEST_BASE_inst                                                           0x0043
+#define SRC_DEST_BASE_src_dest_base_shift                                            (3)
+#define SRC_DEST_BASE_src_dest_base_mask                                             (0x7FFFFFF8)
+#define SRC_DEST_BASE_src_dest_base(data)                                            (0x7FFFFFF8&((data)<<3))
+#define SRC_DEST_BASE_src_dest_base_src(data)                                        ((0x7FFFFFF8&(data))>>3)
+#define SRC_DEST_BASE_get_src_dest_base(data)                                        ((0x7FFFFFF8&(data))>>3)
+
+
+#define SRC_DEST_WP                                                                  0x18002110
+#define SRC_DEST_WP_reg_addr                                                         "0xB8002110"
+#define SRC_DEST_WP_reg                                                              0xB8002110
+#define set_SRC_DEST_WP_reg(data)   (*((volatile unsigned int*) SRC_DEST_WP_reg)=data)
+#define get_SRC_DEST_WP_reg   (*((volatile unsigned int*) SRC_DEST_WP_reg))
+#define SRC_DEST_WP_inst_adr                                                         "0x0044"
+#define SRC_DEST_WP_inst                                                             0x0044
+#define SRC_DEST_WP_src_dest_wp_shift                                                (2)
+#define SRC_DEST_WP_src_dest_wp_mask                                                 (0x7FFFFFFC)
+#define SRC_DEST_WP_src_dest_wp(data)                                                (0x7FFFFFFC&((data)<<2))
+#define SRC_DEST_WP_src_dest_wp_src(data)                                            ((0x7FFFFFFC&(data))>>2)
+#define SRC_DEST_WP_get_src_dest_wp(data)                                            ((0x7FFFFFFC&(data))>>2)
+
+
+#define SRC_DEST_RP                                                                  0x18002114
+#define SRC_DEST_RP_reg_addr                                                         "0xB8002114"
+#define SRC_DEST_RP_reg                                                              0xB8002114
+#define set_SRC_DEST_RP_reg(data)   (*((volatile unsigned int*) SRC_DEST_RP_reg)=data)
+#define get_SRC_DEST_RP_reg   (*((volatile unsigned int*) SRC_DEST_RP_reg))
+#define SRC_DEST_RP_inst_adr                                                         "0x0045"
+#define SRC_DEST_RP_inst                                                             0x0045
+#define SRC_DEST_RP_src_dest_rp_shift                                                (2)
+#define SRC_DEST_RP_src_dest_rp_mask                                                 (0x7FFFFFFC)
+#define SRC_DEST_RP_src_dest_rp(data)                                                (0x7FFFFFFC&((data)<<2))
+#define SRC_DEST_RP_src_dest_rp_src(data)                                            ((0x7FFFFFFC&(data))>>2)
+#define SRC_DEST_RP_get_src_dest_rp(data)                                            ((0x7FFFFFFC&(data))>>2)
+
+
+#define SRC_CTRL1                                                                    0x18002118
+#define SRC_CTRL1_reg_addr                                                           "0xB8002118"
+#define SRC_CTRL1_reg                                                                0xB8002118
+#define set_SRC_CTRL1_reg(data)   (*((volatile unsigned int*) SRC_CTRL1_reg)=data)
+#define get_SRC_CTRL1_reg   (*((volatile unsigned int*) SRC_CTRL1_reg))
+#define SRC_CTRL1_inst_adr                                                           "0x0046"
+#define SRC_CTRL1_inst                                                               0x0046
+#define SRC_CTRL1_write_en6_shift                                                    (31)
+#define SRC_CTRL1_write_en6_mask                                                     (0x80000000)
+#define SRC_CTRL1_write_en6(data)                                                    (0x80000000&((data)<<31))
+#define SRC_CTRL1_write_en6_src(data)                                                ((0x80000000&(data))>>31)
+#define SRC_CTRL1_get_write_en6(data)                                                ((0x80000000&(data))>>31)
+#define SRC_CTRL1_src_rb_size_shift                                                  (24)
+#define SRC_CTRL1_src_rb_size_mask                                                   (0x7F000000)
+#define SRC_CTRL1_src_rb_size(data)                                                  (0x7F000000&((data)<<24))
+#define SRC_CTRL1_src_rb_size_src(data)                                              ((0x7F000000&(data))>>24)
+#define SRC_CTRL1_get_src_rb_size(data)                                              ((0x7F000000&(data))>>24)
+#define SRC_CTRL1_write_en5_shift                                                    (23)
+#define SRC_CTRL1_write_en5_mask                                                     (0x00800000)
+#define SRC_CTRL1_write_en5(data)                                                    (0x00800000&((data)<<23))
+#define SRC_CTRL1_write_en5_src(data)                                                ((0x00800000&(data))>>23)
+#define SRC_CTRL1_get_write_en5(data)                                                ((0x00800000&(data))>>23)
+#define SRC_CTRL1_dest_rb_size_shift                                                 (16)
+#define SRC_CTRL1_dest_rb_size_mask                                                  (0x007F0000)
+#define SRC_CTRL1_dest_rb_size(data)                                                 (0x007F0000&((data)<<16))
+#define SRC_CTRL1_dest_rb_size_src(data)                                             ((0x007F0000&(data))>>16)
+#define SRC_CTRL1_get_dest_rb_size(data)                                             ((0x007F0000&(data))>>16)
+#define SRC_CTRL1_write_en4_shift                                                    (15)
+#define SRC_CTRL1_write_en4_mask                                                     (0x00008000)
+#define SRC_CTRL1_write_en4(data)                                                    (0x00008000&((data)<<15))
+#define SRC_CTRL1_write_en4_src(data)                                                ((0x00008000&(data))>>15)
+#define SRC_CTRL1_get_write_en4(data)                                                ((0x00008000&(data))>>15)
+#define SRC_CTRL1_write_en3_shift                                                    (13)
+#define SRC_CTRL1_write_en3_mask                                                     (0x00002000)
+#define SRC_CTRL1_write_en3(data)                                                    (0x00002000&((data)<<13))
+#define SRC_CTRL1_write_en3_src(data)                                                ((0x00002000&(data))>>13)
+#define SRC_CTRL1_get_write_en3(data)                                                ((0x00002000&(data))>>13)
+#define SRC_CTRL1_chan_num_shift                                                     (10)
+#define SRC_CTRL1_chan_num_mask                                                      (0x00001C00)
+#define SRC_CTRL1_chan_num(data)                                                     (0x00001C00&((data)<<10))
+#define SRC_CTRL1_chan_num_src(data)                                                 ((0x00001C00&(data))>>10)
+#define SRC_CTRL1_get_chan_num(data)                                                 ((0x00001C00&(data))>>10)
+#define SRC_CTRL1_write_en2_shift                                                    (9)
+#define SRC_CTRL1_write_en2_mask                                                     (0x00000200)
+#define SRC_CTRL1_write_en2(data)                                                    (0x00000200&((data)<<9))
+#define SRC_CTRL1_write_en2_src(data)                                                ((0x00000200&(data))>>9)
+#define SRC_CTRL1_get_write_en2(data)                                                ((0x00000200&(data))>>9)
+#define SRC_CTRL1_src_mode_shift                                                     (6)
+#define SRC_CTRL1_src_mode_mask                                                      (0x000001C0)
+#define SRC_CTRL1_src_mode(data)                                                     (0x000001C0&((data)<<6))
+#define SRC_CTRL1_src_mode_src(data)                                                 ((0x000001C0&(data))>>6)
+#define SRC_CTRL1_get_src_mode(data)                                                 ((0x000001C0&(data))>>6)
+#define SRC_CTRL1_write_en1_shift                                                    (5)
+#define SRC_CTRL1_write_en1_mask                                                     (0x00000020)
+#define SRC_CTRL1_write_en1(data)                                                    (0x00000020&((data)<<5))
+#define SRC_CTRL1_write_en1_src(data)                                                ((0x00000020&(data))>>5)
+#define SRC_CTRL1_get_write_en1(data)                                                ((0x00000020&(data))>>5)
+#define SRC_CTRL1_size_shift                                                         (0)
+#define SRC_CTRL1_size_mask                                                          (0x0000001F)
+#define SRC_CTRL1_size(data)                                                         (0x0000001F&((data)<<0))
+#define SRC_CTRL1_size_src(data)                                                     ((0x0000001F&(data))>>0)
+#define SRC_CTRL1_get_size(data)                                                     ((0x0000001F&(data))>>0)
+
+
+#define SRC_CTRL2                                                                    0x1800211c
+#define SRC_CTRL2_reg_addr                                                           "0xB800211C"
+#define SRC_CTRL2_reg                                                                0xB800211C
+#define set_SRC_CTRL2_reg(data)   (*((volatile unsigned int*) SRC_CTRL2_reg)=data)
+#define get_SRC_CTRL2_reg   (*((volatile unsigned int*) SRC_CTRL2_reg))
+#define SRC_CTRL2_inst_adr                                                           "0x0047"
+#define SRC_CTRL2_inst                                                               0x0047
+#define SRC_CTRL2_write_en6_shift                                                    (20)
+#define SRC_CTRL2_write_en6_mask                                                     (0x00100000)
+#define SRC_CTRL2_write_en6(data)                                                    (0x00100000&((data)<<20))
+#define SRC_CTRL2_write_en6_src(data)                                                ((0x00100000&(data))>>20)
+#define SRC_CTRL2_get_write_en6(data)                                                ((0x00100000&(data))>>20)
+#define SRC_CTRL2_rom_sync_selc_shift                                                (19)
+#define SRC_CTRL2_rom_sync_selc_mask                                                 (0x00080000)
+#define SRC_CTRL2_rom_sync_selc(data)                                                (0x00080000&((data)<<19))
+#define SRC_CTRL2_rom_sync_selc_src(data)                                            ((0x00080000&(data))>>19)
+#define SRC_CTRL2_get_rom_sync_selc(data)                                            ((0x00080000&(data))>>19)
+#define SRC_CTRL2_write_en5_shift                                                    (18)
+#define SRC_CTRL2_write_en5_mask                                                     (0x00040000)
+#define SRC_CTRL2_write_en5(data)                                                    (0x00040000&((data)<<18))
+#define SRC_CTRL2_write_en5_src(data)                                                ((0x00040000&(data))>>18)
+#define SRC_CTRL2_get_write_en5(data)                                                ((0x00040000&(data))>>18)
+#define SRC_CTRL2_filter_tap_shift                                                   (16)
+#define SRC_CTRL2_filter_tap_mask                                                    (0x00030000)
+#define SRC_CTRL2_filter_tap(data)                                                   (0x00030000&((data)<<16))
+#define SRC_CTRL2_filter_tap_src(data)                                               ((0x00030000&(data))>>16)
+#define SRC_CTRL2_get_filter_tap(data)                                               ((0x00030000&(data))>>16)
+#define SRC_CTRL2_write_en4_shift                                                    (15)
+#define SRC_CTRL2_write_en4_mask                                                     (0x00008000)
+#define SRC_CTRL2_write_en4(data)                                                    (0x00008000&((data)<<15))
+#define SRC_CTRL2_write_en4_src(data)                                                ((0x00008000&(data))>>15)
+#define SRC_CTRL2_get_write_en4(data)                                                ((0x00008000&(data))>>15)
+#define SRC_CTRL2_idx_shift                                                          (7)
+#define SRC_CTRL2_idx_mask                                                           (0x00007F80)
+#define SRC_CTRL2_idx(data)                                                          (0x00007F80&((data)<<7))
+#define SRC_CTRL2_idx_src(data)                                                      ((0x00007F80&(data))>>7)
+#define SRC_CTRL2_get_idx(data)                                                      ((0x00007F80&(data))>>7)
+#define SRC_CTRL2_write_en3_shift                                                    (6)
+#define SRC_CTRL2_write_en3_mask                                                     (0x00000040)
+#define SRC_CTRL2_write_en3(data)                                                    (0x00000040&((data)<<6))
+#define SRC_CTRL2_write_en3_src(data)                                                ((0x00000040&(data))>>6)
+#define SRC_CTRL2_get_write_en3(data)                                                ((0x00000040&(data))>>6)
+#define SRC_CTRL2_mode_shift                                                         (4)
+#define SRC_CTRL2_mode_mask                                                          (0x00000030)
+#define SRC_CTRL2_mode(data)                                                         (0x00000030&((data)<<4))
+#define SRC_CTRL2_mode_src(data)                                                     ((0x00000030&(data))>>4)
+#define SRC_CTRL2_get_mode(data)                                                     ((0x00000030&(data))>>4)
+#define SRC_CTRL2_write_en2_shift                                                    (3)
+#define SRC_CTRL2_write_en2_mask                                                     (0x00000008)
+#define SRC_CTRL2_write_en2(data)                                                    (0x00000008&((data)<<3))
+#define SRC_CTRL2_write_en2_src(data)                                                ((0x00000008&(data))>>3)
+#define SRC_CTRL2_get_write_en2(data)                                                ((0x00000008&(data))>>3)
+#define SRC_CTRL2_stop_shift                                                         (2)
+#define SRC_CTRL2_stop_mask                                                          (0x00000004)
+#define SRC_CTRL2_stop(data)                                                         (0x00000004&((data)<<2))
+#define SRC_CTRL2_stop_src(data)                                                     ((0x00000004&(data))>>2)
+#define SRC_CTRL2_get_stop(data)                                                     ((0x00000004&(data))>>2)
+#define SRC_CTRL2_write_en1_shift                                                    (1)
+#define SRC_CTRL2_write_en1_mask                                                     (0x00000002)
+#define SRC_CTRL2_write_en1(data)                                                    (0x00000002&((data)<<1))
+#define SRC_CTRL2_write_en1_src(data)                                                ((0x00000002&(data))>>1)
+#define SRC_CTRL2_get_write_en1(data)                                                ((0x00000002&(data))>>1)
+#define SRC_CTRL2_go_shift                                                           (0)
+#define SRC_CTRL2_go_mask                                                            (0x00000001)
+#define SRC_CTRL2_go(data)                                                           (0x00000001&((data)<<0))
+#define SRC_CTRL2_go_src(data)                                                       ((0x00000001&(data))>>0)
+#define SRC_CTRL2_get_go(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define SRC_STATUS                                                                   0x18002120
+#define SRC_STATUS_reg_addr                                                          "0xB8002120"
+#define SRC_STATUS_reg                                                               0xB8002120
+#define set_SRC_STATUS_reg(data)   (*((volatile unsigned int*) SRC_STATUS_reg)=data)
+#define get_SRC_STATUS_reg   (*((volatile unsigned int*) SRC_STATUS_reg))
+#define SRC_STATUS_inst_adr                                                          "0x0048"
+#define SRC_STATUS_inst                                                              0x0048
+#define SRC_STATUS_chan_busy_shift                                                   (0)
+#define SRC_STATUS_chan_busy_mask                                                    (0x00000007)
+#define SRC_STATUS_chan_busy(data)                                                   (0x00000007&((data)<<0))
+#define SRC_STATUS_chan_busy_src(data)                                               ((0x00000007&(data))>>0)
+#define SRC_STATUS_get_chan_busy(data)                                               ((0x00000007&(data))>>0)
+
+
+#define SRC_RB_STATUS                                                                0x18002124
+#define SRC_RB_STATUS_reg_addr                                                       "0xB8002124"
+#define SRC_RB_STATUS_reg                                                            0xB8002124
+#define set_SRC_RB_STATUS_reg(data)   (*((volatile unsigned int*) SRC_RB_STATUS_reg)=data)
+#define get_SRC_RB_STATUS_reg   (*((volatile unsigned int*) SRC_RB_STATUS_reg))
+#define SRC_RB_STATUS_inst_adr                                                       "0x0049"
+#define SRC_RB_STATUS_inst                                                           0x0049
+#define SRC_RB_STATUS_write_en5_shift                                                (9)
+#define SRC_RB_STATUS_write_en5_mask                                                 (0x00000200)
+#define SRC_RB_STATUS_write_en5(data)                                                (0x00000200&((data)<<9))
+#define SRC_RB_STATUS_write_en5_src(data)                                            ((0x00000200&(data))>>9)
+#define SRC_RB_STATUS_get_write_en5(data)                                            ((0x00000200&(data))>>9)
+#define SRC_RB_STATUS_time_out_shift                                                 (8)
+#define SRC_RB_STATUS_time_out_mask                                                  (0x00000100)
+#define SRC_RB_STATUS_time_out(data)                                                 (0x00000100&((data)<<8))
+#define SRC_RB_STATUS_time_out_src(data)                                             ((0x00000100&(data))>>8)
+#define SRC_RB_STATUS_get_time_out(data)                                             ((0x00000100&(data))>>8)
+#define SRC_RB_STATUS_write_en4_shift                                                (7)
+#define SRC_RB_STATUS_write_en4_mask                                                 (0x00000080)
+#define SRC_RB_STATUS_write_en4(data)                                                (0x00000080&((data)<<7))
+#define SRC_RB_STATUS_write_en4_src(data)                                            ((0x00000080&(data))>>7)
+#define SRC_RB_STATUS_get_write_en4(data)                                            ((0x00000080&(data))>>7)
+#define SRC_RB_STATUS_done_shift                                                     (6)
+#define SRC_RB_STATUS_done_mask                                                      (0x00000040)
+#define SRC_RB_STATUS_done(data)                                                     (0x00000040&((data)<<6))
+#define SRC_RB_STATUS_done_src(data)                                                 ((0x00000040&(data))>>6)
+#define SRC_RB_STATUS_get_done(data)                                                 ((0x00000040&(data))>>6)
+#define SRC_RB_STATUS_write_en3_shift                                                (5)
+#define SRC_RB_STATUS_write_en3_mask                                                 (0x00000020)
+#define SRC_RB_STATUS_write_en3(data)                                                (0x00000020&((data)<<5))
+#define SRC_RB_STATUS_write_en3_src(data)                                            ((0x00000020&(data))>>5)
+#define SRC_RB_STATUS_get_write_en3(data)                                            ((0x00000020&(data))>>5)
+#define SRC_RB_STATUS_error_shift                                                    (4)
+#define SRC_RB_STATUS_error_mask                                                     (0x00000010)
+#define SRC_RB_STATUS_error(data)                                                    (0x00000010&((data)<<4))
+#define SRC_RB_STATUS_error_src(data)                                                ((0x00000010&(data))>>4)
+#define SRC_RB_STATUS_get_error(data)                                                ((0x00000010&(data))>>4)
+#define SRC_RB_STATUS_write_en2_shift                                                (3)
+#define SRC_RB_STATUS_write_en2_mask                                                 (0x00000008)
+#define SRC_RB_STATUS_write_en2(data)                                                (0x00000008&((data)<<3))
+#define SRC_RB_STATUS_write_en2_src(data)                                            ((0x00000008&(data))>>3)
+#define SRC_RB_STATUS_get_write_en2(data)                                            ((0x00000008&(data))>>3)
+#define SRC_RB_STATUS_src_rb_empty_shift                                             (2)
+#define SRC_RB_STATUS_src_rb_empty_mask                                              (0x00000004)
+#define SRC_RB_STATUS_src_rb_empty(data)                                             (0x00000004&((data)<<2))
+#define SRC_RB_STATUS_src_rb_empty_src(data)                                         ((0x00000004&(data))>>2)
+#define SRC_RB_STATUS_get_src_rb_empty(data)                                         ((0x00000004&(data))>>2)
+#define SRC_RB_STATUS_write_en1_shift                                                (1)
+#define SRC_RB_STATUS_write_en1_mask                                                 (0x00000002)
+#define SRC_RB_STATUS_write_en1(data)                                                (0x00000002&((data)<<1))
+#define SRC_RB_STATUS_write_en1_src(data)                                            ((0x00000002&(data))>>1)
+#define SRC_RB_STATUS_get_write_en1(data)                                            ((0x00000002&(data))>>1)
+#define SRC_RB_STATUS_dest_rb_full_shift                                             (0)
+#define SRC_RB_STATUS_dest_rb_full_mask                                              (0x00000001)
+#define SRC_RB_STATUS_dest_rb_full(data)                                             (0x00000001&((data)<<0))
+#define SRC_RB_STATUS_dest_rb_full_src(data)                                         ((0x00000001&(data))>>0)
+#define SRC_RB_STATUS_get_dest_rb_full(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SRC_INT_EN                                                                   0x18002128
+#define SRC_INT_EN_reg_addr                                                          "0xB8002128"
+#define SRC_INT_EN_reg                                                               0xB8002128
+#define set_SRC_INT_EN_reg(data)   (*((volatile unsigned int*) SRC_INT_EN_reg)=data)
+#define get_SRC_INT_EN_reg   (*((volatile unsigned int*) SRC_INT_EN_reg))
+#define SRC_INT_EN_inst_adr                                                          "0x004A"
+#define SRC_INT_EN_inst                                                              0x004A
+#define SRC_INT_EN_write_en5_shift                                                   (9)
+#define SRC_INT_EN_write_en5_mask                                                    (0x00000200)
+#define SRC_INT_EN_write_en5(data)                                                   (0x00000200&((data)<<9))
+#define SRC_INT_EN_write_en5_src(data)                                               ((0x00000200&(data))>>9)
+#define SRC_INT_EN_get_write_en5(data)                                               ((0x00000200&(data))>>9)
+#define SRC_INT_EN_time_out_shift                                                    (8)
+#define SRC_INT_EN_time_out_mask                                                     (0x00000100)
+#define SRC_INT_EN_time_out(data)                                                    (0x00000100&((data)<<8))
+#define SRC_INT_EN_time_out_src(data)                                                ((0x00000100&(data))>>8)
+#define SRC_INT_EN_get_time_out(data)                                                ((0x00000100&(data))>>8)
+#define SRC_INT_EN_write_en4_shift                                                   (7)
+#define SRC_INT_EN_write_en4_mask                                                    (0x00000080)
+#define SRC_INT_EN_write_en4(data)                                                   (0x00000080&((data)<<7))
+#define SRC_INT_EN_write_en4_src(data)                                               ((0x00000080&(data))>>7)
+#define SRC_INT_EN_get_write_en4(data)                                               ((0x00000080&(data))>>7)
+#define SRC_INT_EN_done_en_shift                                                     (6)
+#define SRC_INT_EN_done_en_mask                                                      (0x00000040)
+#define SRC_INT_EN_done_en(data)                                                     (0x00000040&((data)<<6))
+#define SRC_INT_EN_done_en_src(data)                                                 ((0x00000040&(data))>>6)
+#define SRC_INT_EN_get_done_en(data)                                                 ((0x00000040&(data))>>6)
+#define SRC_INT_EN_write_en3_shift                                                   (5)
+#define SRC_INT_EN_write_en3_mask                                                    (0x00000020)
+#define SRC_INT_EN_write_en3(data)                                                   (0x00000020&((data)<<5))
+#define SRC_INT_EN_write_en3_src(data)                                               ((0x00000020&(data))>>5)
+#define SRC_INT_EN_get_write_en3(data)                                               ((0x00000020&(data))>>5)
+#define SRC_INT_EN_error_en_shift                                                    (4)
+#define SRC_INT_EN_error_en_mask                                                     (0x00000010)
+#define SRC_INT_EN_error_en(data)                                                    (0x00000010&((data)<<4))
+#define SRC_INT_EN_error_en_src(data)                                                ((0x00000010&(data))>>4)
+#define SRC_INT_EN_get_error_en(data)                                                ((0x00000010&(data))>>4)
+#define SRC_INT_EN_write_en2_shift                                                   (3)
+#define SRC_INT_EN_write_en2_mask                                                    (0x00000008)
+#define SRC_INT_EN_write_en2(data)                                                   (0x00000008&((data)<<3))
+#define SRC_INT_EN_write_en2_src(data)                                               ((0x00000008&(data))>>3)
+#define SRC_INT_EN_get_write_en2(data)                                               ((0x00000008&(data))>>3)
+#define SRC_INT_EN_src_rb_empty_en_shift                                             (2)
+#define SRC_INT_EN_src_rb_empty_en_mask                                              (0x00000004)
+#define SRC_INT_EN_src_rb_empty_en(data)                                             (0x00000004&((data)<<2))
+#define SRC_INT_EN_src_rb_empty_en_src(data)                                         ((0x00000004&(data))>>2)
+#define SRC_INT_EN_get_src_rb_empty_en(data)                                         ((0x00000004&(data))>>2)
+#define SRC_INT_EN_write_en1_shift                                                   (1)
+#define SRC_INT_EN_write_en1_mask                                                    (0x00000002)
+#define SRC_INT_EN_write_en1(data)                                                   (0x00000002&((data)<<1))
+#define SRC_INT_EN_write_en1_src(data)                                               ((0x00000002&(data))>>1)
+#define SRC_INT_EN_get_write_en1(data)                                               ((0x00000002&(data))>>1)
+#define SRC_INT_EN_dest_rb_full_en_shift                                             (0)
+#define SRC_INT_EN_dest_rb_full_en_mask                                              (0x00000001)
+#define SRC_INT_EN_dest_rb_full_en(data)                                             (0x00000001&((data)<<0))
+#define SRC_INT_EN_dest_rb_full_en_src(data)                                         ((0x00000001&(data))>>0)
+#define SRC_INT_EN_get_dest_rb_full_en(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SRC_SRC_THRESHOLD                                                            0x1800212c
+#define SRC_SRC_THRESHOLD_reg_addr                                                   "0xB800212C"
+#define SRC_SRC_THRESHOLD_reg                                                        0xB800212C
+#define set_SRC_SRC_THRESHOLD_reg(data)   (*((volatile unsigned int*) SRC_SRC_THRESHOLD_reg)=data)
+#define get_SRC_SRC_THRESHOLD_reg   (*((volatile unsigned int*) SRC_SRC_THRESHOLD_reg))
+#define SRC_SRC_THRESHOLD_inst_adr                                                   "0x004B"
+#define SRC_SRC_THRESHOLD_inst                                                       0x004B
+#define SRC_SRC_THRESHOLD_thld_shift                                                 (0)
+#define SRC_SRC_THRESHOLD_thld_mask                                                  (0x01FFFFFF)
+#define SRC_SRC_THRESHOLD_thld(data)                                                 (0x01FFFFFF&((data)<<0))
+#define SRC_SRC_THRESHOLD_thld_src(data)                                             ((0x01FFFFFF&(data))>>0)
+#define SRC_SRC_THRESHOLD_get_thld(data)                                             ((0x01FFFFFF&(data))>>0)
+
+
+#define FILTER_COEF                                                                  0x18002134
+#define FILTER_COEF_reg_addr                                                         "0xB8002134"
+#define FILTER_COEF_reg                                                              0xB8002134
+#define set_FILTER_COEF_reg(data)   (*((volatile unsigned int*) FILTER_COEF_reg)=data)
+#define get_FILTER_COEF_reg   (*((volatile unsigned int*) FILTER_COEF_reg))
+#define FILTER_COEF_inst_adr                                                         "0x004D"
+#define FILTER_COEF_inst                                                             0x004D
+#define FILTER_COEF_adr_shift                                                        (2)
+#define FILTER_COEF_adr_mask                                                         (0x7FFFFFFC)
+#define FILTER_COEF_adr(data)                                                        (0x7FFFFFFC&((data)<<2))
+#define FILTER_COEF_adr_src(data)                                                    ((0x7FFFFFFC&(data))>>2)
+#define FILTER_COEF_get_adr(data)                                                    ((0x7FFFFFFC&(data))>>2)
+
+
+#define FILTER_COEF_CTRL                                                             0x18002138
+#define FILTER_COEF_CTRL_reg_addr                                                    "0xB8002138"
+#define FILTER_COEF_CTRL_reg                                                         0xB8002138
+#define set_FILTER_COEF_CTRL_reg(data)   (*((volatile unsigned int*) FILTER_COEF_CTRL_reg)=data)
+#define get_FILTER_COEF_CTRL_reg   (*((volatile unsigned int*) FILTER_COEF_CTRL_reg))
+#define FILTER_COEF_CTRL_inst_adr                                                    "0x004E"
+#define FILTER_COEF_CTRL_inst                                                        0x004E
+#define FILTER_COEF_CTRL_load_coef_shift                                             (0)
+#define FILTER_COEF_CTRL_load_coef_mask                                              (0x00000001)
+#define FILTER_COEF_CTRL_load_coef(data)                                             (0x00000001&((data)<<0))
+#define FILTER_COEF_CTRL_load_coef_src(data)                                         ((0x00000001&(data))>>0)
+#define FILTER_COEF_CTRL_get_load_coef(data)                                         ((0x00000001&(data))>>0)
+
+
+#define AE_DUMMY                                                                     0x1800213C
+#define AE_DUMMY_reg_addr                                                            "0xB800213C"
+#define AE_DUMMY_reg                                                                 0xB800213C
+#define set_AE_DUMMY_reg(data)   (*((volatile unsigned int*) AE_DUMMY_reg)=data)
+#define get_AE_DUMMY_reg   (*((volatile unsigned int*) AE_DUMMY_reg))
+#define AE_DUMMY_inst_adr                                                            "0x004F"
+#define AE_DUMMY_inst                                                                0x004F
+#define AE_DUMMY_dummy_shift                                                         (0)
+#define AE_DUMMY_dummy_mask                                                          (0xFFFFFFFF)
+#define AE_DUMMY_dummy(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define AE_DUMMY_dummy_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define AE_DUMMY_get_dummy(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define AE_SRC_SM                                                                    0x18002140
+#define AE_SRC_SM_reg_addr                                                           "0xB8002140"
+#define AE_SRC_SM_reg                                                                0xB8002140
+#define set_AE_SRC_SM_reg(data)   (*((volatile unsigned int*) AE_SRC_SM_reg)=data)
+#define get_AE_SRC_SM_reg   (*((volatile unsigned int*) AE_SRC_SM_reg))
+#define AE_SRC_SM_inst_adr                                                           "0x0050"
+#define AE_SRC_SM_inst                                                               0x0050
+#define AE_SRC_SM_src_stg2_shift                                                     (10)
+#define AE_SRC_SM_src_stg2_mask                                                      (0x00007C00)
+#define AE_SRC_SM_src_stg2(data)                                                     (0x00007C00&((data)<<10))
+#define AE_SRC_SM_src_stg2_src(data)                                                 ((0x00007C00&(data))>>10)
+#define AE_SRC_SM_get_src_stg2(data)                                                 ((0x00007C00&(data))>>10)
+#define AE_SRC_SM_src_stg1_shift                                                     (5)
+#define AE_SRC_SM_src_stg1_mask                                                      (0x000003E0)
+#define AE_SRC_SM_src_stg1(data)                                                     (0x000003E0&((data)<<5))
+#define AE_SRC_SM_src_stg1_src(data)                                                 ((0x000003E0&(data))>>5)
+#define AE_SRC_SM_get_src_stg1(data)                                                 ((0x000003E0&(data))>>5)
+#define AE_SRC_SM_src_ctrl_shift                                                     (0)
+#define AE_SRC_SM_src_ctrl_mask                                                      (0x0000000F)
+#define AE_SRC_SM_src_ctrl(data)                                                     (0x0000000F&((data)<<0))
+#define AE_SRC_SM_src_ctrl_src(data)                                                 ((0x0000000F&(data))>>0)
+#define AE_SRC_SM_get_src_ctrl(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define AE_SRC_RST                                                                   0x18002144
+#define AE_SRC_RST_reg_addr                                                          "0xB8002144"
+#define AE_SRC_RST_reg                                                               0xB8002144
+#define set_AE_SRC_RST_reg(data)   (*((volatile unsigned int*) AE_SRC_RST_reg)=data)
+#define get_AE_SRC_RST_reg   (*((volatile unsigned int*) AE_SRC_RST_reg))
+#define AE_SRC_RST_inst_adr                                                          "0x0051"
+#define AE_SRC_RST_inst                                                              0x0051
+#define AE_SRC_RST_rst_shift                                                         (0)
+#define AE_SRC_RST_rst_mask                                                          (0x00000001)
+#define AE_SRC_RST_rst(data)                                                         (0x00000001&((data)<<0))
+#define AE_SRC_RST_rst_src(data)                                                     ((0x00000001&(data))>>0)
+#define AE_SRC_RST_get_rst(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define AE_PWM                                                                       0x18002148
+#define AE_PWM_reg_addr                                                              "0xB8002148"
+#define AE_PWM_reg                                                                   0xB8002148
+#define set_AE_PWM_reg(data)   (*((volatile unsigned int*) AE_PWM_reg)=data)
+#define get_AE_PWM_reg   (*((volatile unsigned int*) AE_PWM_reg))
+#define AE_PWM_inst_adr                                                              "0x0052"
+#define AE_PWM_inst                                                                  0x0052
+#define AE_PWM_idle_ctr_shift                                                        (13)
+#define AE_PWM_idle_ctr_mask                                                         (0x007FE000)
+#define AE_PWM_idle_ctr(data)                                                        (0x007FE000&((data)<<13))
+#define AE_PWM_idle_ctr_src(data)                                                    ((0x007FE000&(data))>>13)
+#define AE_PWM_get_idle_ctr(data)                                                    ((0x007FE000&(data))>>13)
+#define AE_PWM_en_src_shift                                                          (12)
+#define AE_PWM_en_src_mask                                                           (0x00001000)
+#define AE_PWM_en_src(data)                                                          (0x00001000&((data)<<12))
+#define AE_PWM_en_src_src(data)                                                      ((0x00001000&(data))>>12)
+#define AE_PWM_get_en_src(data)                                                      ((0x00001000&(data))>>12)
+#define AE_PWM_en_ade_shift                                                          (11)
+#define AE_PWM_en_ade_mask                                                           (0x00000800)
+#define AE_PWM_en_ade(data)                                                          (0x00000800&((data)<<11))
+#define AE_PWM_en_ade_src(data)                                                      ((0x00000800&(data))>>11)
+#define AE_PWM_get_en_ade(data)                                                      ((0x00000800&(data))>>11)
+#define AE_PWM_en_aee_shift                                                          (10)
+#define AE_PWM_en_aee_mask                                                           (0x00000400)
+#define AE_PWM_en_aee(data)                                                          (0x00000400&((data)<<10))
+#define AE_PWM_en_aee_src(data)                                                      ((0x00000400&(data))>>10)
+#define AE_PWM_get_en_aee(data)                                                      ((0x00000400&(data))>>10)
+#define AE_PWM_sram_ctr_shift                                                        (0)
+#define AE_PWM_sram_ctr_mask                                                         (0x000003FF)
+#define AE_PWM_sram_ctr(data)                                                        (0x000003FF&((data)<<0))
+#define AE_PWM_sram_ctr_src(data)                                                    ((0x000003FF&(data))>>0)
+#define AE_PWM_get_sram_ctr(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define MBIST_ACPU_RM                                                                0x1800214C
+#define MBIST_ACPU_RM_reg_addr                                                       "0xB800214C"
+#define MBIST_ACPU_RM_reg                                                            0xB800214C
+#define set_MBIST_ACPU_RM_reg(data)   (*((volatile unsigned int*) MBIST_ACPU_RM_reg)=data)
+#define get_MBIST_ACPU_RM_reg   (*((volatile unsigned int*) MBIST_ACPU_RM_reg))
+#define MBIST_ACPU_RM_inst_adr                                                       "0x0053"
+#define MBIST_ACPU_RM_inst                                                           0x0053
+#define MBIST_ACPU_RM_rme_acpu_shift                                                 (28)
+#define MBIST_ACPU_RM_rme_acpu_mask                                                  (0x10000000)
+#define MBIST_ACPU_RM_rme_acpu(data)                                                 (0x10000000&((data)<<28))
+#define MBIST_ACPU_RM_rme_acpu_src(data)                                             ((0x10000000&(data))>>28)
+#define MBIST_ACPU_RM_get_rme_acpu(data)                                             ((0x10000000&(data))>>28)
+#define MBIST_ACPU_RM_rm_dc_data_shift                                               (24)
+#define MBIST_ACPU_RM_rm_dc_data_mask                                                (0x0F000000)
+#define MBIST_ACPU_RM_rm_dc_data(data)                                               (0x0F000000&((data)<<24))
+#define MBIST_ACPU_RM_rm_dc_data_src(data)                                           ((0x0F000000&(data))>>24)
+#define MBIST_ACPU_RM_get_rm_dc_data(data)                                           ((0x0F000000&(data))>>24)
+#define MBIST_ACPU_RM_rm_dc_tag_shift                                                (20)
+#define MBIST_ACPU_RM_rm_dc_tag_mask                                                 (0x00F00000)
+#define MBIST_ACPU_RM_rm_dc_tag(data)                                                (0x00F00000&((data)<<20))
+#define MBIST_ACPU_RM_rm_dc_tag_src(data)                                            ((0x00F00000&(data))>>20)
+#define MBIST_ACPU_RM_get_rm_dc_tag(data)                                            ((0x00F00000&(data))>>20)
+#define MBIST_ACPU_RM_rm_dw_data0_shift                                              (16)
+#define MBIST_ACPU_RM_rm_dw_data0_mask                                               (0x000F0000)
+#define MBIST_ACPU_RM_rm_dw_data0(data)                                              (0x000F0000&((data)<<16))
+#define MBIST_ACPU_RM_rm_dw_data0_src(data)                                          ((0x000F0000&(data))>>16)
+#define MBIST_ACPU_RM_get_rm_dw_data0(data)                                          ((0x000F0000&(data))>>16)
+#define MBIST_ACPU_RM_rm_ic_data1_shift                                              (12)
+#define MBIST_ACPU_RM_rm_ic_data1_mask                                               (0x0000F000)
+#define MBIST_ACPU_RM_rm_ic_data1(data)                                              (0x0000F000&((data)<<12))
+#define MBIST_ACPU_RM_rm_ic_data1_src(data)                                          ((0x0000F000&(data))>>12)
+#define MBIST_ACPU_RM_get_rm_ic_data1(data)                                          ((0x0000F000&(data))>>12)
+#define MBIST_ACPU_RM_rm_ic_data0_shift                                              (8)
+#define MBIST_ACPU_RM_rm_ic_data0_mask                                               (0x00000F00)
+#define MBIST_ACPU_RM_rm_ic_data0(data)                                              (0x00000F00&((data)<<8))
+#define MBIST_ACPU_RM_rm_ic_data0_src(data)                                          ((0x00000F00&(data))>>8)
+#define MBIST_ACPU_RM_get_rm_ic_data0(data)                                          ((0x00000F00&(data))>>8)
+#define MBIST_ACPU_RM_rm_ic_tag1_shift                                               (4)
+#define MBIST_ACPU_RM_rm_ic_tag1_mask                                                (0x000000F0)
+#define MBIST_ACPU_RM_rm_ic_tag1(data)                                               (0x000000F0&((data)<<4))
+#define MBIST_ACPU_RM_rm_ic_tag1_src(data)                                           ((0x000000F0&(data))>>4)
+#define MBIST_ACPU_RM_get_rm_ic_tag1(data)                                           ((0x000000F0&(data))>>4)
+#define MBIST_ACPU_RM_rm_ic_tag0_shift                                               (0)
+#define MBIST_ACPU_RM_rm_ic_tag0_mask                                                (0x0000000F)
+#define MBIST_ACPU_RM_rm_ic_tag0(data)                                               (0x0000000F&((data)<<0))
+#define MBIST_ACPU_RM_rm_ic_tag0_src(data)                                           ((0x0000000F&(data))>>0)
+#define MBIST_ACPU_RM_get_rm_ic_tag0(data)                                           ((0x0000000F&(data))>>0)
+
+
+#define MBIST_ACPU_ST                                                                0x18002150
+#define MBIST_ACPU_ST_reg_addr                                                       "0xB8002150"
+#define MBIST_ACPU_ST_reg                                                            0xB8002150
+#define set_MBIST_ACPU_ST_reg(data)   (*((volatile unsigned int*) MBIST_ACPU_ST_reg)=data)
+#define get_MBIST_ACPU_ST_reg   (*((volatile unsigned int*) MBIST_ACPU_ST_reg))
+#define MBIST_ACPU_ST_inst_adr                                                       "0x0054"
+#define MBIST_ACPU_ST_inst                                                           0x0054
+#define MBIST_ACPU_ST_bist_fail_10_shift                                             (11)
+#define MBIST_ACPU_ST_bist_fail_10_mask                                              (0x00000800)
+#define MBIST_ACPU_ST_bist_fail_10(data)                                             (0x00000800&((data)<<11))
+#define MBIST_ACPU_ST_bist_fail_10_src(data)                                         ((0x00000800&(data))>>11)
+#define MBIST_ACPU_ST_get_bist_fail_10(data)                                         ((0x00000800&(data))>>11)
+#define MBIST_ACPU_ST_bist_fail_9_shift                                              (10)
+#define MBIST_ACPU_ST_bist_fail_9_mask                                               (0x00000400)
+#define MBIST_ACPU_ST_bist_fail_9(data)                                              (0x00000400&((data)<<10))
+#define MBIST_ACPU_ST_bist_fail_9_src(data)                                          ((0x00000400&(data))>>10)
+#define MBIST_ACPU_ST_get_bist_fail_9(data)                                          ((0x00000400&(data))>>10)
+#define MBIST_ACPU_ST_bist_fail_8_shift                                              (9)
+#define MBIST_ACPU_ST_bist_fail_8_mask                                               (0x00000200)
+#define MBIST_ACPU_ST_bist_fail_8(data)                                              (0x00000200&((data)<<9))
+#define MBIST_ACPU_ST_bist_fail_8_src(data)                                          ((0x00000200&(data))>>9)
+#define MBIST_ACPU_ST_get_bist_fail_8(data)                                          ((0x00000200&(data))>>9)
+#define MBIST_ACPU_ST_bist_fail_7_shift                                              (8)
+#define MBIST_ACPU_ST_bist_fail_7_mask                                               (0x00000100)
+#define MBIST_ACPU_ST_bist_fail_7(data)                                              (0x00000100&((data)<<8))
+#define MBIST_ACPU_ST_bist_fail_7_src(data)                                          ((0x00000100&(data))>>8)
+#define MBIST_ACPU_ST_get_bist_fail_7(data)                                          ((0x00000100&(data))>>8)
+#define MBIST_ACPU_ST_bist_fail_6_shift                                              (7)
+#define MBIST_ACPU_ST_bist_fail_6_mask                                               (0x00000080)
+#define MBIST_ACPU_ST_bist_fail_6(data)                                              (0x00000080&((data)<<7))
+#define MBIST_ACPU_ST_bist_fail_6_src(data)                                          ((0x00000080&(data))>>7)
+#define MBIST_ACPU_ST_get_bist_fail_6(data)                                          ((0x00000080&(data))>>7)
+#define MBIST_ACPU_ST_bist_fail_5_shift                                              (6)
+#define MBIST_ACPU_ST_bist_fail_5_mask                                               (0x00000040)
+#define MBIST_ACPU_ST_bist_fail_5(data)                                              (0x00000040&((data)<<6))
+#define MBIST_ACPU_ST_bist_fail_5_src(data)                                          ((0x00000040&(data))>>6)
+#define MBIST_ACPU_ST_get_bist_fail_5(data)                                          ((0x00000040&(data))>>6)
+#define MBIST_ACPU_ST_bist_fail_4_shift                                              (5)
+#define MBIST_ACPU_ST_bist_fail_4_mask                                               (0x00000020)
+#define MBIST_ACPU_ST_bist_fail_4(data)                                              (0x00000020&((data)<<5))
+#define MBIST_ACPU_ST_bist_fail_4_src(data)                                          ((0x00000020&(data))>>5)
+#define MBIST_ACPU_ST_get_bist_fail_4(data)                                          ((0x00000020&(data))>>5)
+#define MBIST_ACPU_ST_bist_fail_3_shift                                              (4)
+#define MBIST_ACPU_ST_bist_fail_3_mask                                               (0x00000010)
+#define MBIST_ACPU_ST_bist_fail_3(data)                                              (0x00000010&((data)<<4))
+#define MBIST_ACPU_ST_bist_fail_3_src(data)                                          ((0x00000010&(data))>>4)
+#define MBIST_ACPU_ST_get_bist_fail_3(data)                                          ((0x00000010&(data))>>4)
+#define MBIST_ACPU_ST_bist_fail_2_shift                                              (3)
+#define MBIST_ACPU_ST_bist_fail_2_mask                                               (0x00000008)
+#define MBIST_ACPU_ST_bist_fail_2(data)                                              (0x00000008&((data)<<3))
+#define MBIST_ACPU_ST_bist_fail_2_src(data)                                          ((0x00000008&(data))>>3)
+#define MBIST_ACPU_ST_get_bist_fail_2(data)                                          ((0x00000008&(data))>>3)
+#define MBIST_ACPU_ST_bist_fail_1_shift                                              (2)
+#define MBIST_ACPU_ST_bist_fail_1_mask                                               (0x00000004)
+#define MBIST_ACPU_ST_bist_fail_1(data)                                              (0x00000004&((data)<<2))
+#define MBIST_ACPU_ST_bist_fail_1_src(data)                                          ((0x00000004&(data))>>2)
+#define MBIST_ACPU_ST_get_bist_fail_1(data)                                          ((0x00000004&(data))>>2)
+#define MBIST_ACPU_ST_bist_fail_0_shift                                              (1)
+#define MBIST_ACPU_ST_bist_fail_0_mask                                               (0x00000002)
+#define MBIST_ACPU_ST_bist_fail_0(data)                                              (0x00000002&((data)<<1))
+#define MBIST_ACPU_ST_bist_fail_0_src(data)                                          ((0x00000002&(data))>>1)
+#define MBIST_ACPU_ST_get_bist_fail_0(data)                                          ((0x00000002&(data))>>1)
+#define MBIST_ACPU_ST_bist_done_shift                                                (0)
+#define MBIST_ACPU_ST_bist_done_mask                                                 (0x00000001)
+#define MBIST_ACPU_ST_bist_done(data)                                                (0x00000001&((data)<<0))
+#define MBIST_ACPU_ST_bist_done_src(data)                                            ((0x00000001&(data))>>0)
+#define MBIST_ACPU_ST_get_bist_done(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MBIST_DRF_ACPU_ST                                                            0x18002154
+#define MBIST_DRF_ACPU_ST_reg_addr                                                   "0xB8002154"
+#define MBIST_DRF_ACPU_ST_reg                                                        0xB8002154
+#define set_MBIST_DRF_ACPU_ST_reg(data)   (*((volatile unsigned int*) MBIST_DRF_ACPU_ST_reg)=data)
+#define get_MBIST_DRF_ACPU_ST_reg   (*((volatile unsigned int*) MBIST_DRF_ACPU_ST_reg))
+#define MBIST_DRF_ACPU_ST_inst_adr                                                   "0x0055"
+#define MBIST_DRF_ACPU_ST_inst                                                       0x0055
+#define MBIST_DRF_ACPU_ST_drf_start_pause_shift                                      (16)
+#define MBIST_DRF_ACPU_ST_drf_start_pause_mask                                       (0x00010000)
+#define MBIST_DRF_ACPU_ST_drf_start_pause(data)                                      (0x00010000&((data)<<16))
+#define MBIST_DRF_ACPU_ST_drf_start_pause_src(data)                                  ((0x00010000&(data))>>16)
+#define MBIST_DRF_ACPU_ST_get_drf_start_pause(data)                                  ((0x00010000&(data))>>16)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_10_shift                                     (11)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_10_mask                                      (0x00000800)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_10(data)                                     (0x00000800&((data)<<11))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_10_src(data)                                 ((0x00000800&(data))>>11)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_10(data)                                 ((0x00000800&(data))>>11)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_9_shift                                      (10)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_9_mask                                       (0x00000400)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_9(data)                                      (0x00000400&((data)<<10))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_9_src(data)                                  ((0x00000400&(data))>>10)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_9(data)                                  ((0x00000400&(data))>>10)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_8_shift                                      (9)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_8_mask                                       (0x00000200)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_8(data)                                      (0x00000200&((data)<<9))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_8_src(data)                                  ((0x00000200&(data))>>9)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_8(data)                                  ((0x00000200&(data))>>9)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_7_shift                                      (8)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_7_mask                                       (0x00000100)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_7(data)                                      (0x00000100&((data)<<8))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_7_src(data)                                  ((0x00000100&(data))>>8)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_7(data)                                  ((0x00000100&(data))>>8)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_6_shift                                      (7)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_6_mask                                       (0x00000080)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_6(data)                                      (0x00000080&((data)<<7))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_6_src(data)                                  ((0x00000080&(data))>>7)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_6(data)                                  ((0x00000080&(data))>>7)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_5_shift                                      (6)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_5_mask                                       (0x00000040)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_5(data)                                      (0x00000040&((data)<<6))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_5_src(data)                                  ((0x00000040&(data))>>6)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_5(data)                                  ((0x00000040&(data))>>6)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_4_shift                                      (5)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_4_mask                                       (0x00000020)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_4(data)                                      (0x00000020&((data)<<5))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_4_src(data)                                  ((0x00000020&(data))>>5)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_4(data)                                  ((0x00000020&(data))>>5)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_3_shift                                      (4)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_3_mask                                       (0x00000010)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_3(data)                                      (0x00000010&((data)<<4))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_3_src(data)                                  ((0x00000010&(data))>>4)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_3(data)                                  ((0x00000010&(data))>>4)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_2_shift                                      (3)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_2_mask                                       (0x00000008)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_2(data)                                      (0x00000008&((data)<<3))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_2_src(data)                                  ((0x00000008&(data))>>3)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_2(data)                                  ((0x00000008&(data))>>3)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_1_shift                                      (2)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_1_mask                                       (0x00000004)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_1(data)                                      (0x00000004&((data)<<2))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_1_src(data)                                  ((0x00000004&(data))>>2)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_1(data)                                  ((0x00000004&(data))>>2)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_0_shift                                      (1)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_0_mask                                       (0x00000002)
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_0(data)                                      (0x00000002&((data)<<1))
+#define MBIST_DRF_ACPU_ST_drf_bist_fail_0_src(data)                                  ((0x00000002&(data))>>1)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_fail_0(data)                                  ((0x00000002&(data))>>1)
+#define MBIST_DRF_ACPU_ST_drf_bist_done_shift                                        (0)
+#define MBIST_DRF_ACPU_ST_drf_bist_done_mask                                         (0x00000001)
+#define MBIST_DRF_ACPU_ST_drf_bist_done(data)                                        (0x00000001&((data)<<0))
+#define MBIST_DRF_ACPU_ST_drf_bist_done_src(data)                                    ((0x00000001&(data))>>0)
+#define MBIST_DRF_ACPU_ST_get_drf_bist_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ACPU_PFN3129                                                                 0x18002158
+#define ACPU_PFN3129_reg_addr                                                        "0xB8002158"
+#define ACPU_PFN3129_reg                                                             0xB8002158
+#define set_ACPU_PFN3129_reg(data)   (*((volatile unsigned int*) ACPU_PFN3129_reg)=data)
+#define get_ACPU_PFN3129_reg   (*((volatile unsigned int*) ACPU_PFN3129_reg))
+#define ACPU_PFN3129_inst_adr                                                        "0x0056"
+#define ACPU_PFN3129_inst                                                            0x0056
+#define ACPU_PFN3129_pfn3129_110_shift                                               (18)
+#define ACPU_PFN3129_pfn3129_110_mask                                                (0x001C0000)
+#define ACPU_PFN3129_pfn3129_110(data)                                               (0x001C0000&((data)<<18))
+#define ACPU_PFN3129_pfn3129_110_src(data)                                           ((0x001C0000&(data))>>18)
+#define ACPU_PFN3129_get_pfn3129_110(data)                                           ((0x001C0000&(data))>>18)
+#define ACPU_PFN3129_pfn3129_101_shift                                               (15)
+#define ACPU_PFN3129_pfn3129_101_mask                                                (0x00038000)
+#define ACPU_PFN3129_pfn3129_101(data)                                               (0x00038000&((data)<<15))
+#define ACPU_PFN3129_pfn3129_101_src(data)                                           ((0x00038000&(data))>>15)
+#define ACPU_PFN3129_get_pfn3129_101(data)                                           ((0x00038000&(data))>>15)
+#define ACPU_PFN3129_pfn3129_100_shift                                               (12)
+#define ACPU_PFN3129_pfn3129_100_mask                                                (0x00007000)
+#define ACPU_PFN3129_pfn3129_100(data)                                               (0x00007000&((data)<<12))
+#define ACPU_PFN3129_pfn3129_100_src(data)                                           ((0x00007000&(data))>>12)
+#define ACPU_PFN3129_get_pfn3129_100(data)                                           ((0x00007000&(data))>>12)
+#define ACPU_PFN3129_pfn3129_011_shift                                               (9)
+#define ACPU_PFN3129_pfn3129_011_mask                                                (0x00000E00)
+#define ACPU_PFN3129_pfn3129_011(data)                                               (0x00000E00&((data)<<9))
+#define ACPU_PFN3129_pfn3129_011_src(data)                                           ((0x00000E00&(data))>>9)
+#define ACPU_PFN3129_get_pfn3129_011(data)                                           ((0x00000E00&(data))>>9)
+#define ACPU_PFN3129_pfn3129_010_shift                                               (6)
+#define ACPU_PFN3129_pfn3129_010_mask                                                (0x000001C0)
+#define ACPU_PFN3129_pfn3129_010(data)                                               (0x000001C0&((data)<<6))
+#define ACPU_PFN3129_pfn3129_010_src(data)                                           ((0x000001C0&(data))>>6)
+#define ACPU_PFN3129_get_pfn3129_010(data)                                           ((0x000001C0&(data))>>6)
+#define ACPU_PFN3129_pfn3129_001_shift                                               (3)
+#define ACPU_PFN3129_pfn3129_001_mask                                                (0x00000038)
+#define ACPU_PFN3129_pfn3129_001(data)                                               (0x00000038&((data)<<3))
+#define ACPU_PFN3129_pfn3129_001_src(data)                                           ((0x00000038&(data))>>3)
+#define ACPU_PFN3129_get_pfn3129_001(data)                                           ((0x00000038&(data))>>3)
+#define ACPU_PFN3129_pfn3129_000_shift                                               (0)
+#define ACPU_PFN3129_pfn3129_000_mask                                                (0x00000007)
+#define ACPU_PFN3129_pfn3129_000(data)                                               (0x00000007&((data)<<0))
+#define ACPU_PFN3129_pfn3129_000_src(data)                                           ((0x00000007&(data))>>0)
+#define ACPU_PFN3129_get_pfn3129_000(data)                                           ((0x00000007&(data))>>0)
+
+
+#define ACPU_NCABLE                                                                  0x1800215C
+#define ACPU_NCABLE_reg_addr                                                         "0xB800215C"
+#define ACPU_NCABLE_reg                                                              0xB800215C
+#define set_ACPU_NCABLE_reg(data)   (*((volatile unsigned int*) ACPU_NCABLE_reg)=data)
+#define get_ACPU_NCABLE_reg   (*((volatile unsigned int*) ACPU_NCABLE_reg))
+#define ACPU_NCABLE_inst_adr                                                         "0x0057"
+#define ACPU_NCABLE_inst                                                             0x0057
+#define ACPU_NCABLE_ncable_110_shift                                                 (6)
+#define ACPU_NCABLE_ncable_110_mask                                                  (0x00000040)
+#define ACPU_NCABLE_ncable_110(data)                                                 (0x00000040&((data)<<6))
+#define ACPU_NCABLE_ncable_110_src(data)                                             ((0x00000040&(data))>>6)
+#define ACPU_NCABLE_get_ncable_110(data)                                             ((0x00000040&(data))>>6)
+#define ACPU_NCABLE_ncable_101_shift                                                 (5)
+#define ACPU_NCABLE_ncable_101_mask                                                  (0x00000020)
+#define ACPU_NCABLE_ncable_101(data)                                                 (0x00000020&((data)<<5))
+#define ACPU_NCABLE_ncable_101_src(data)                                             ((0x00000020&(data))>>5)
+#define ACPU_NCABLE_get_ncable_101(data)                                             ((0x00000020&(data))>>5)
+#define ACPU_NCABLE_ncable_100_shift                                                 (4)
+#define ACPU_NCABLE_ncable_100_mask                                                  (0x00000010)
+#define ACPU_NCABLE_ncable_100(data)                                                 (0x00000010&((data)<<4))
+#define ACPU_NCABLE_ncable_100_src(data)                                             ((0x00000010&(data))>>4)
+#define ACPU_NCABLE_get_ncable_100(data)                                             ((0x00000010&(data))>>4)
+#define ACPU_NCABLE_ncable_011_shift                                                 (3)
+#define ACPU_NCABLE_ncable_011_mask                                                  (0x00000008)
+#define ACPU_NCABLE_ncable_011(data)                                                 (0x00000008&((data)<<3))
+#define ACPU_NCABLE_ncable_011_src(data)                                             ((0x00000008&(data))>>3)
+#define ACPU_NCABLE_get_ncable_011(data)                                             ((0x00000008&(data))>>3)
+#define ACPU_NCABLE_ncable_010_shift                                                 (2)
+#define ACPU_NCABLE_ncable_010_mask                                                  (0x00000004)
+#define ACPU_NCABLE_ncable_010(data)                                                 (0x00000004&((data)<<2))
+#define ACPU_NCABLE_ncable_010_src(data)                                             ((0x00000004&(data))>>2)
+#define ACPU_NCABLE_get_ncable_010(data)                                             ((0x00000004&(data))>>2)
+#define ACPU_NCABLE_ncable_001_shift                                                 (1)
+#define ACPU_NCABLE_ncable_001_mask                                                  (0x00000002)
+#define ACPU_NCABLE_ncable_001(data)                                                 (0x00000002&((data)<<1))
+#define ACPU_NCABLE_ncable_001_src(data)                                             ((0x00000002&(data))>>1)
+#define ACPU_NCABLE_get_ncable_001(data)                                             ((0x00000002&(data))>>1)
+#define ACPU_NCABLE_ncable_000_shift                                                 (0)
+#define ACPU_NCABLE_ncable_000_mask                                                  (0x00000001)
+#define ACPU_NCABLE_ncable_000(data)                                                 (0x00000001&((data)<<0))
+#define ACPU_NCABLE_ncable_000_src(data)                                             ((0x00000001&(data))>>0)
+#define ACPU_NCABLE_get_ncable_000(data)                                             ((0x00000001&(data))>>0)
+
+
+#define ACPU_IMEM                                                                    0x18002160
+#define ACPU_IMEM_reg_addr                                                           "0xB8002160"
+#define ACPU_IMEM_reg                                                                0xB8002160
+#define set_ACPU_IMEM_reg(data)   (*((volatile unsigned int*) ACPU_IMEM_reg)=data)
+#define get_ACPU_IMEM_reg   (*((volatile unsigned int*) ACPU_IMEM_reg))
+#define ACPU_IMEM_inst_adr                                                           "0x0058"
+#define ACPU_IMEM_inst                                                               0x0058
+#define ACPU_IMEM_imem_enable_shift                                                  (0)
+#define ACPU_IMEM_imem_enable_mask                                                   (0x00000001)
+#define ACPU_IMEM_imem_enable(data)                                                  (0x00000001&((data)<<0))
+#define ACPU_IMEM_imem_enable_src(data)                                              ((0x00000001&(data))>>0)
+#define ACPU_IMEM_get_imem_enable(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MBIST_ACPU_RM                                                                0x18002164
+#define MBIST_ACPU_RM_reg_addr                                                       "0xB8002164"
+#define MBIST_ACPU_RM_reg                                                            0xB8002164
+#define set_MBIST_ACPU_RM_reg(data)   (*((volatile unsigned int*) MBIST_ACPU_RM_reg)=data)
+#define get_MBIST_ACPU_RM_reg   (*((volatile unsigned int*) MBIST_ACPU_RM_reg))
+#define MBIST_ACPU_RM_inst_adr                                                       "0x0059"
+#define MBIST_ACPU_RM_inst                                                           0x0059
+#define MBIST_ACPU_RM_rm_dw_data4_shift                                              (12)
+#define MBIST_ACPU_RM_rm_dw_data4_mask                                               (0x0000F000)
+#define MBIST_ACPU_RM_rm_dw_data4(data)                                              (0x0000F000&((data)<<12))
+#define MBIST_ACPU_RM_rm_dw_data4_src(data)                                          ((0x0000F000&(data))>>12)
+#define MBIST_ACPU_RM_get_rm_dw_data4(data)                                          ((0x0000F000&(data))>>12)
+#define MBIST_ACPU_RM_rm_dw_data3_shift                                              (8)
+#define MBIST_ACPU_RM_rm_dw_data3_mask                                               (0x00000F00)
+#define MBIST_ACPU_RM_rm_dw_data3(data)                                              (0x00000F00&((data)<<8))
+#define MBIST_ACPU_RM_rm_dw_data3_src(data)                                          ((0x00000F00&(data))>>8)
+#define MBIST_ACPU_RM_get_rm_dw_data3(data)                                          ((0x00000F00&(data))>>8)
+#define MBIST_ACPU_RM_rm_dw_data2_shift                                              (4)
+#define MBIST_ACPU_RM_rm_dw_data2_mask                                               (0x000000F0)
+#define MBIST_ACPU_RM_rm_dw_data2(data)                                              (0x000000F0&((data)<<4))
+#define MBIST_ACPU_RM_rm_dw_data2_src(data)                                          ((0x000000F0&(data))>>4)
+#define MBIST_ACPU_RM_get_rm_dw_data2(data)                                          ((0x000000F0&(data))>>4)
+#define MBIST_ACPU_RM_rm_dw_data1_shift                                              (0)
+#define MBIST_ACPU_RM_rm_dw_data1_mask                                               (0x0000000F)
+#define MBIST_ACPU_RM_rm_dw_data1(data)                                              (0x0000000F&((data)<<0))
+#define MBIST_ACPU_RM_rm_dw_data1_src(data)                                          ((0x0000000F&(data))>>0)
+#define MBIST_ACPU_RM_get_rm_dw_data1(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define MBIST_ACPU                                                                   0x18002168
+#define MBIST_ACPU_reg_addr                                                          "0xB8002168"
+#define MBIST_ACPU_reg                                                               0xB8002168
+#define set_MBIST_ACPU_reg(data)   (*((volatile unsigned int*) MBIST_ACPU_reg)=data)
+#define get_MBIST_ACPU_reg   (*((volatile unsigned int*) MBIST_ACPU_reg))
+#define MBIST_ACPU_inst_adr                                                          "0x005A"
+#define MBIST_ACPU_inst                                                              0x005A
+#define MBIST_ACPU_drf_test_resume_shift                                             (2)
+#define MBIST_ACPU_drf_test_resume_mask                                              (0x00000004)
+#define MBIST_ACPU_drf_test_resume(data)                                             (0x00000004&((data)<<2))
+#define MBIST_ACPU_drf_test_resume_src(data)                                         ((0x00000004&(data))>>2)
+#define MBIST_ACPU_get_drf_test_resume(data)                                         ((0x00000004&(data))>>2)
+#define MBIST_ACPU_drf_en_shift                                                      (1)
+#define MBIST_ACPU_drf_en_mask                                                       (0x00000002)
+#define MBIST_ACPU_drf_en(data)                                                      (0x00000002&((data)<<1))
+#define MBIST_ACPU_drf_en_src(data)                                                  ((0x00000002&(data))>>1)
+#define MBIST_ACPU_get_drf_en(data)                                                  ((0x00000002&(data))>>1)
+#define MBIST_ACPU_en_shift                                                          (0)
+#define MBIST_ACPU_en_mask                                                           (0x00000001)
+#define MBIST_ACPU_en(data)                                                          (0x00000001&((data)<<0))
+#define MBIST_ACPU_en_src(data)                                                      ((0x00000001&(data))>>0)
+#define MBIST_ACPU_get_en(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define MBIST                                                                        0x1800216c
+#define MBIST_reg_addr                                                               "0xB800216C"
+#define MBIST_reg                                                                    0xB800216C
+#define set_MBIST_reg(data)   (*((volatile unsigned int*) MBIST_reg)=data)
+#define get_MBIST_reg   (*((volatile unsigned int*) MBIST_reg))
+#define MBIST_inst_adr                                                               "0x005B"
+#define MBIST_inst                                                                   0x005B
+#define MBIST_rom_en_shift                                                           (3)
+#define MBIST_rom_en_mask                                                            (0x00000008)
+#define MBIST_rom_en(data)                                                           (0x00000008&((data)<<3))
+#define MBIST_rom_en_src(data)                                                       ((0x00000008&(data))>>3)
+#define MBIST_get_rom_en(data)                                                       ((0x00000008&(data))>>3)
+#define MBIST_drf_test_resume_shift                                                  (2)
+#define MBIST_drf_test_resume_mask                                                   (0x00000004)
+#define MBIST_drf_test_resume(data)                                                  (0x00000004&((data)<<2))
+#define MBIST_drf_test_resume_src(data)                                              ((0x00000004&(data))>>2)
+#define MBIST_get_drf_test_resume(data)                                              ((0x00000004&(data))>>2)
+#define MBIST_drf_en_shift                                                           (1)
+#define MBIST_drf_en_mask                                                            (0x00000002)
+#define MBIST_drf_en(data)                                                           (0x00000002&((data)<<1))
+#define MBIST_drf_en_src(data)                                                       ((0x00000002&(data))>>1)
+#define MBIST_get_drf_en(data)                                                       ((0x00000002&(data))>>1)
+#define MBIST_en_shift                                                               (0)
+#define MBIST_en_mask                                                                (0x00000001)
+#define MBIST_en(data)                                                               (0x00000001&((data)<<0))
+#define MBIST_en_src(data)                                                           ((0x00000001&(data))>>0)
+#define MBIST_get_en(data)                                                           ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/aio_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/aio_reg.h
new file mode 100644
index 00000000..b72725e
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/aio_reg.h
@@ -0,0 +1,2950 @@
+/**************************************************************
+// Spec Version                  : 0.1
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/8/15 18:41:16
+***************************************************************/
+
+
+#ifndef _AIO_REG_H_INCLUDED_
+#define _AIO_REG_H_INCLUDED_
+#ifdef  _AIO_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     hdmirx:1;
+unsigned int     edgeneg:1;
+unsigned int     wsdelay:1;
+unsigned int     slave:1;
+unsigned int     bit:3;
+unsigned int     reserved_1:9;
+unsigned int     rmute0:1;
+unsigned int     lmute0:1;
+unsigned int     en0:1;
+}AIO_I_I2S_GCTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     rgain:7;
+unsigned int     lgain:7;
+unsigned int     r2ren:1;
+unsigned int     r2len:1;
+unsigned int     l2ren:1;
+unsigned int     l2len:1;
+}AIO_I_I2S_LBMIX;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     pcm2chsel:1;
+unsigned int     wsperiod:6;
+unsigned int     protocol:2;
+unsigned int     wsdelay:1;
+unsigned int     slave:1;
+unsigned int     bit:3;
+unsigned int     reserved_1:12;
+unsigned int     rmute0:1;
+unsigned int     lmute0:1;
+unsigned int     en0:1;
+}AIO_O_I2S_GCTL;
+
+typedef struct 
+{
+unsigned int     cs1:32;
+}AIO_O_PCM_CS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cs2:8;
+}AIO_O_PCM_CS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     pcm2chsel:1;
+unsigned int     bit:3;
+unsigned int     wait_en:1;
+unsigned int     valid:1;
+unsigned int     format:1;
+unsigned int     rmute:1;
+unsigned int     lmute:1;
+unsigned int     en:1;
+}AIO_O_SPF_GCTL;
+
+typedef struct 
+{
+unsigned int     cs1:32;
+}AIO_O_RAW_CS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cs2:8;
+}AIO_O_RAW_CS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     realgo:1;
+unsigned int     spcnt:7;
+unsigned int     fcnt:8;
+}AIO_O_SPF_FCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     pcm8chlben:1;
+unsigned int     pcm8chlbsel:2;
+unsigned int     pcm2chsel:1;
+unsigned int     clk_sel:3;
+unsigned int     pcmsync:1;
+unsigned int     pkt:1;
+unsigned int     sample_flat:4;
+unsigned int     rmute3:1;
+unsigned int     lmute3:1;
+unsigned int     rmute2:1;
+unsigned int     lmute2:1;
+unsigned int     rmute1:1;
+unsigned int     lmute1:1;
+unsigned int     8ch:1;
+unsigned int     bit:3;
+unsigned int     wait_en:1;
+unsigned int     reserved_1:1;
+unsigned int     rmute:1;
+unsigned int     lmute:1;
+unsigned int     switch_wait_en:1;
+unsigned int     sel:2;
+unsigned int     en:1;
+}AIO_O_HDMI_GCTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     realgo:1;
+unsigned int     fcnt:8;
+}AIO_O_HDMI_FCNT;
+
+typedef struct 
+{
+unsigned int     cs1:32;
+}AIO_O_HDMI_CS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cs2:8;
+}AIO_O_HDMI_CS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     userdata:8;
+unsigned int     valid:8;
+}AIO_O_HDMI_INFO;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     pcm2chsel:1;
+unsigned int     rgain:7;
+unsigned int     lgain:7;
+unsigned int     bit:3;
+unsigned int     hpfen:1;
+unsigned int     rmute:1;
+unsigned int     lmute:1;
+unsigned int     en:1;
+}AIO_O_ACDAC_GCTL;
+
+typedef struct 
+{
+unsigned int     write_en14:1;
+unsigned int     isel_df2se:2;
+unsigned int     write_en13:1;
+unsigned int     isel_depop:2;
+unsigned int     write_en12:1;
+unsigned int     isel_dacvcm:2;
+unsigned int     write_en11:1;
+unsigned int     isel_dacop:2;
+unsigned int     write_en10:1;
+unsigned int     powvref:1;
+unsigned int     write_en9:1;
+unsigned int     powmbias:1;
+unsigned int     write_en8:1;
+unsigned int     powhpo:1;
+unsigned int     write_en7:1;
+unsigned int     powdf2se:1;
+unsigned int     write_en6:1;
+unsigned int     powdepop:1;
+unsigned int     write_en5:1;
+unsigned int     powdac:1;
+unsigned int     write_en4:1;
+unsigned int     hpo_normal:1;
+unsigned int     write_en3:1;
+unsigned int     hpo_hpmode:1;
+unsigned int     write_en2:1;
+unsigned int     hpo_mr:1;
+unsigned int     write_en1:1;
+unsigned int     hpo_ml:1;
+}AIO_O_ACANA_GCTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en11:1;
+unsigned int     crt_depop_clk_sel:2;
+unsigned int     write_en10:1;
+unsigned int     depop_csel:2;
+unsigned int     write_en9:1;
+unsigned int     depop_enramp:1;
+unsigned int     write_en8:1;
+unsigned int     hpo_gr:2;
+unsigned int     write_en7:1;
+unsigned int     hpo_gl:2;
+unsigned int     write_en6:1;
+unsigned int     hpo_encopy:2;
+unsigned int     write_en5:1;
+unsigned int     vref_vrefsel:2;
+unsigned int     write_en4:1;
+unsigned int     hpo_engr:1;
+unsigned int     write_en3:1;
+unsigned int     hpo_engl:1;
+unsigned int     write_en2:1;
+unsigned int     isel_vref:2;
+unsigned int     write_en1:1;
+unsigned int     isel_hpo:2;
+}AIO_O_ACANA_GCTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     thd:5;
+unsigned int     en:1;
+}AIO_I_FIFOCTL0;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     en10:1;
+unsigned int     en9:1;
+unsigned int     en8:1;
+unsigned int     en7:1;
+unsigned int     en6:1;
+unsigned int     emptystopen:1;
+unsigned int     thd:5;
+unsigned int     en5:1;
+unsigned int     en4:1;
+unsigned int     en3:1;
+unsigned int     en2:1;
+unsigned int     en1:1;
+unsigned int     en0:1;
+}AIO_O_FIFOCTL;
+
+typedef struct 
+{
+unsigned int     data:32;
+}AIO_O_I2S_LDATA0;
+
+typedef struct 
+{
+unsigned int     data:32;
+}AIO_O_I2S_RDATA0;
+
+typedef struct 
+{
+unsigned int     data:32;
+}AIO_O_SPF_LDATA;
+
+typedef struct 
+{
+unsigned int     data:32;
+}AIO_O_SPF_RDATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     empty11:1;
+unsigned int     empty10:1;
+unsigned int     empty9:1;
+unsigned int     empty8:1;
+unsigned int     empty7:1;
+unsigned int     empty6:1;
+unsigned int     empty5:1;
+unsigned int     empty4:1;
+unsigned int     empty3:1;
+unsigned int     empty2:1;
+unsigned int     empty1:1;
+unsigned int     empty0:1;
+}AIO_O_FIFO_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     addr:28;
+unsigned int     reserved_1:3;
+}AIO_I_SA;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     addr:28;
+unsigned int     reserved_1:3;
+}AIO_I_EA;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     addr:28;
+unsigned int     reserved_1:3;
+}AIO_I_RP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     addr:28;
+unsigned int     reserved_1:3;
+}AIO_I_WP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     addr:28;
+unsigned int     reserved_1:3;
+}AIO_O_SA;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     addr:28;
+unsigned int     reserved_1:3;
+}AIO_O_EA;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     addr:28;
+unsigned int     reserved_1:3;
+}AIO_O_RP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     addr:28;
+unsigned int     reserved_1:3;
+}AIO_O_WP;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     dmago:1;
+}AIO_O_DMA_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     go0:1;
+unsigned int     reserved_1:1;
+}AIO_I_GO;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     goacdac:1;
+unsigned int     gohdmi:1;
+unsigned int     goi2s:1;
+unsigned int     gospf:1;
+}AIO_O_GO;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     pause0:1;
+}AIO_I_PAUSE;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     pause2:1;
+unsigned int     pause1:1;
+unsigned int     pause0:1;
+}AIO_O_PAUSE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     thd:28;
+unsigned int     reserved_1:3;
+}AIO_I_I2S_DDRTHD;
+
+typedef struct 
+{
+unsigned int     count:32;
+}AIO_I_I2S_TIMCNT;
+
+typedef struct 
+{
+unsigned int     thd:32;
+}AIO_I_I2S_TIMTHD;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     timi2sinte:1;
+unsigned int     reserved_1:3;
+unsigned int     thdinte0:1;
+unsigned int     reserved_2:10;
+unsigned int     fifointe1:1;
+unsigned int     fifointe0:1;
+unsigned int     reserved_3:6;
+unsigned int     draminte1:1;
+unsigned int     draminte0:1;
+unsigned int     write_data:1;
+}AIO_I_INTE;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     timi2sints:1;
+unsigned int     reserved_1:3;
+unsigned int     thdints0:1;
+unsigned int     reserved_2:10;
+unsigned int     fifoints1:1;
+unsigned int     fifoints0:1;
+unsigned int     reserved_3:6;
+unsigned int     dramints1:1;
+unsigned int     dramints0:1;
+unsigned int     write_data:1;
+}AIO_I_INTS;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     thd:28;
+unsigned int     reserved_1:3;
+}AIO_O_PCM_DDRTHD;
+
+typedef struct 
+{
+unsigned int     count:32;
+}AIO_O_PCM_TIMCNT;
+
+typedef struct 
+{
+unsigned int     thd:32;
+}AIO_O_PCM_TIMTHD;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     thd:28;
+unsigned int     reserved_1:3;
+}AIO_O_RAW_DDRTHD;
+
+typedef struct 
+{
+unsigned int     count:32;
+}AIO_O_RAW_TIMCNT;
+
+typedef struct 
+{
+unsigned int     thd:32;
+}AIO_O_RAW_TIMTHD;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     thd:28;
+unsigned int     reserved_1:3;
+}AIO_O_HDMI_DDRTHD;
+
+typedef struct 
+{
+unsigned int     count:32;
+}AIO_O_HDMI_TIMCNT;
+
+typedef struct 
+{
+unsigned int     thd:32;
+}AIO_O_HDMI_TIMTHD;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     draminte11:1;
+unsigned int     draminte10:1;
+unsigned int     draminte9:1;
+unsigned int     draminte8:1;
+unsigned int     draminte7:1;
+unsigned int     draminte6:1;
+unsigned int     draminte5:1;
+unsigned int     draminte4:1;
+unsigned int     fifointe11:1;
+unsigned int     fifointe10:1;
+unsigned int     fifointe9:1;
+unsigned int     fifointe8:1;
+unsigned int     fifointe7:1;
+unsigned int     fifointe6:1;
+unsigned int     fifointe5:1;
+unsigned int     fifointe4:1;
+unsigned int     pcmtiminte:1;
+unsigned int     rawtiminte:1;
+unsigned int     hdmitiminte:1;
+unsigned int     pcmthdinte:1;
+unsigned int     rawthdinte:1;
+unsigned int     hdmithdinte:1;
+unsigned int     draminte3:1;
+unsigned int     draminte2:1;
+unsigned int     draminte1:1;
+unsigned int     draminte0:1;
+unsigned int     fifointe3:1;
+unsigned int     fifointe2:1;
+unsigned int     fifointe1:1;
+unsigned int     fifointe0:1;
+unsigned int     write_data:1;
+}AIO_O_INTE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     dramints11:1;
+unsigned int     dramints10:1;
+unsigned int     dramints9:1;
+unsigned int     dramints8:1;
+unsigned int     dramints7:1;
+unsigned int     dramints6:1;
+unsigned int     dramints5:1;
+unsigned int     dramints4:1;
+unsigned int     fifoints11:1;
+unsigned int     fifoints10:1;
+unsigned int     fifoints9:1;
+unsigned int     fifoints8:1;
+unsigned int     fifoints7:1;
+unsigned int     fifoints6:1;
+unsigned int     fifoints5:1;
+unsigned int     fifoints4:1;
+unsigned int     pcmtimints:1;
+unsigned int     rawtimints:1;
+unsigned int     hdmitimints:1;
+unsigned int     pcmthdints:1;
+unsigned int     rawthdints:1;
+unsigned int     hdmithdints:1;
+unsigned int     dramints3:1;
+unsigned int     dramints2:1;
+unsigned int     dramints1:1;
+unsigned int     dramints0:1;
+unsigned int     fifoints3:1;
+unsigned int     fifoints2:1;
+unsigned int     fifoints1:1;
+unsigned int     fifoints0:1;
+unsigned int     write_data:1;
+}AIO_O_INTS;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     codec_tmode2:1;
+unsigned int     loopbacken:1;
+unsigned int     codec_tmode:1;
+unsigned int     dbgen:1;
+unsigned int     sel0:3;
+unsigned int     sel1:3;
+}AIO_DBG;
+
+typedef struct 
+{
+unsigned int     spare:32;
+}AIO_SPARE;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     spf_fs_autoswitch:1;
+unsigned int     multireq_en:1;
+unsigned int     gating_enable:1;
+}AIO_GLOBAL;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     drf_test_resume_con2:1;
+unsigned int     drf_en_con2:1;
+unsigned int     en_con2:1;
+unsigned int     drf_test_resume_con1:1;
+unsigned int     drf_en_con1:1;
+unsigned int     en_con1:1;
+}AIO_BIST1;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     drf_start_pause_con2:1;
+unsigned int     drf_fail_2_con2:1;
+unsigned int     drf_fail_1_con2:1;
+unsigned int     drf_fail_0_con2:1;
+unsigned int     drf_done_con2:1;
+unsigned int     fail_2_con2:1;
+unsigned int     fail_1_con2:1;
+unsigned int     fail_0_con2:1;
+unsigned int     done_con2:1;
+unsigned int     drf_start_pause_con1:1;
+unsigned int     drf_fail_1_con1:1;
+unsigned int     drf_fail_0_con1:1;
+unsigned int     drf_done_con1:1;
+unsigned int     fail_1_con1:1;
+unsigned int     fail_0_con1:1;
+unsigned int     done_con1:1;
+}AIO_BIST2;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     rme:1;
+unsigned int     rm:4;
+}AIO_BIST3;
+
+#endif
+
+#define AIO_I_I2S_GCTL                                                               0x18006000
+#define AIO_I_I2S_GCTL_reg_addr                                                      "0xB8006000"
+#define AIO_I_I2S_GCTL_reg                                                           0xB8006000
+#define set_AIO_I_I2S_GCTL_reg(data)   (*((volatile unsigned int*) AIO_I_I2S_GCTL_reg)=data)
+#define get_AIO_I_I2S_GCTL_reg   (*((volatile unsigned int*) AIO_I_I2S_GCTL_reg))
+#define AIO_I_I2S_GCTL_inst_adr                                                      "0x0000"
+#define AIO_I_I2S_GCTL_inst                                                          0x0000
+#define AIO_I_I2S_GCTL_hdmirx_shift                                                  (18)
+#define AIO_I_I2S_GCTL_hdmirx_mask                                                   (0x00040000)
+#define AIO_I_I2S_GCTL_hdmirx(data)                                                  (0x00040000&((data)<<18))
+#define AIO_I_I2S_GCTL_hdmirx_src(data)                                              ((0x00040000&(data))>>18)
+#define AIO_I_I2S_GCTL_get_hdmirx(data)                                              ((0x00040000&(data))>>18)
+#define AIO_I_I2S_GCTL_edgeneg_shift                                                 (17)
+#define AIO_I_I2S_GCTL_edgeneg_mask                                                  (0x00020000)
+#define AIO_I_I2S_GCTL_edgeneg(data)                                                 (0x00020000&((data)<<17))
+#define AIO_I_I2S_GCTL_edgeneg_src(data)                                             ((0x00020000&(data))>>17)
+#define AIO_I_I2S_GCTL_get_edgeneg(data)                                             ((0x00020000&(data))>>17)
+#define AIO_I_I2S_GCTL_wsdelay_shift                                                 (16)
+#define AIO_I_I2S_GCTL_wsdelay_mask                                                  (0x00010000)
+#define AIO_I_I2S_GCTL_wsdelay(data)                                                 (0x00010000&((data)<<16))
+#define AIO_I_I2S_GCTL_wsdelay_src(data)                                             ((0x00010000&(data))>>16)
+#define AIO_I_I2S_GCTL_get_wsdelay(data)                                             ((0x00010000&(data))>>16)
+#define AIO_I_I2S_GCTL_slave_shift                                                   (15)
+#define AIO_I_I2S_GCTL_slave_mask                                                    (0x00008000)
+#define AIO_I_I2S_GCTL_slave(data)                                                   (0x00008000&((data)<<15))
+#define AIO_I_I2S_GCTL_slave_src(data)                                               ((0x00008000&(data))>>15)
+#define AIO_I_I2S_GCTL_get_slave(data)                                               ((0x00008000&(data))>>15)
+#define AIO_I_I2S_GCTL_bit_shift                                                     (12)
+#define AIO_I_I2S_GCTL_bit_mask                                                      (0x00007000)
+#define AIO_I_I2S_GCTL_bit(data)                                                     (0x00007000&((data)<<12))
+#define AIO_I_I2S_GCTL_bit_src(data)                                                 ((0x00007000&(data))>>12)
+#define AIO_I_I2S_GCTL_get_bit(data)                                                 ((0x00007000&(data))>>12)
+#define AIO_I_I2S_GCTL_rmute0_shift                                                  (2)
+#define AIO_I_I2S_GCTL_rmute0_mask                                                   (0x00000004)
+#define AIO_I_I2S_GCTL_rmute0(data)                                                  (0x00000004&((data)<<2))
+#define AIO_I_I2S_GCTL_rmute0_src(data)                                              ((0x00000004&(data))>>2)
+#define AIO_I_I2S_GCTL_get_rmute0(data)                                              ((0x00000004&(data))>>2)
+#define AIO_I_I2S_GCTL_lmute0_shift                                                  (1)
+#define AIO_I_I2S_GCTL_lmute0_mask                                                   (0x00000002)
+#define AIO_I_I2S_GCTL_lmute0(data)                                                  (0x00000002&((data)<<1))
+#define AIO_I_I2S_GCTL_lmute0_src(data)                                              ((0x00000002&(data))>>1)
+#define AIO_I_I2S_GCTL_get_lmute0(data)                                              ((0x00000002&(data))>>1)
+#define AIO_I_I2S_GCTL_en0_shift                                                     (0)
+#define AIO_I_I2S_GCTL_en0_mask                                                      (0x00000001)
+#define AIO_I_I2S_GCTL_en0(data)                                                     (0x00000001&((data)<<0))
+#define AIO_I_I2S_GCTL_en0_src(data)                                                 ((0x00000001&(data))>>0)
+#define AIO_I_I2S_GCTL_get_en0(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define AIO_I_I2S_LBMIX                                                              0x18006014
+#define AIO_I_I2S_LBMIX_reg_addr                                                     "0xB8006014"
+#define AIO_I_I2S_LBMIX_reg                                                          0xB8006014
+#define set_AIO_I_I2S_LBMIX_reg(data)   (*((volatile unsigned int*) AIO_I_I2S_LBMIX_reg)=data)
+#define get_AIO_I_I2S_LBMIX_reg   (*((volatile unsigned int*) AIO_I_I2S_LBMIX_reg))
+#define AIO_I_I2S_LBMIX_inst_adr                                                     "0x0005"
+#define AIO_I_I2S_LBMIX_inst                                                         0x0005
+#define AIO_I_I2S_LBMIX_rgain_shift                                                  (11)
+#define AIO_I_I2S_LBMIX_rgain_mask                                                   (0x0003F800)
+#define AIO_I_I2S_LBMIX_rgain(data)                                                  (0x0003F800&((data)<<11))
+#define AIO_I_I2S_LBMIX_rgain_src(data)                                              ((0x0003F800&(data))>>11)
+#define AIO_I_I2S_LBMIX_get_rgain(data)                                              ((0x0003F800&(data))>>11)
+#define AIO_I_I2S_LBMIX_lgain_shift                                                  (4)
+#define AIO_I_I2S_LBMIX_lgain_mask                                                   (0x000007F0)
+#define AIO_I_I2S_LBMIX_lgain(data)                                                  (0x000007F0&((data)<<4))
+#define AIO_I_I2S_LBMIX_lgain_src(data)                                              ((0x000007F0&(data))>>4)
+#define AIO_I_I2S_LBMIX_get_lgain(data)                                              ((0x000007F0&(data))>>4)
+#define AIO_I_I2S_LBMIX_r2ren_shift                                                  (3)
+#define AIO_I_I2S_LBMIX_r2ren_mask                                                   (0x00000008)
+#define AIO_I_I2S_LBMIX_r2ren(data)                                                  (0x00000008&((data)<<3))
+#define AIO_I_I2S_LBMIX_r2ren_src(data)                                              ((0x00000008&(data))>>3)
+#define AIO_I_I2S_LBMIX_get_r2ren(data)                                              ((0x00000008&(data))>>3)
+#define AIO_I_I2S_LBMIX_r2len_shift                                                  (2)
+#define AIO_I_I2S_LBMIX_r2len_mask                                                   (0x00000004)
+#define AIO_I_I2S_LBMIX_r2len(data)                                                  (0x00000004&((data)<<2))
+#define AIO_I_I2S_LBMIX_r2len_src(data)                                              ((0x00000004&(data))>>2)
+#define AIO_I_I2S_LBMIX_get_r2len(data)                                              ((0x00000004&(data))>>2)
+#define AIO_I_I2S_LBMIX_l2ren_shift                                                  (1)
+#define AIO_I_I2S_LBMIX_l2ren_mask                                                   (0x00000002)
+#define AIO_I_I2S_LBMIX_l2ren(data)                                                  (0x00000002&((data)<<1))
+#define AIO_I_I2S_LBMIX_l2ren_src(data)                                              ((0x00000002&(data))>>1)
+#define AIO_I_I2S_LBMIX_get_l2ren(data)                                              ((0x00000002&(data))>>1)
+#define AIO_I_I2S_LBMIX_l2len_shift                                                  (0)
+#define AIO_I_I2S_LBMIX_l2len_mask                                                   (0x00000001)
+#define AIO_I_I2S_LBMIX_l2len(data)                                                  (0x00000001&((data)<<0))
+#define AIO_I_I2S_LBMIX_l2len_src(data)                                              ((0x00000001&(data))>>0)
+#define AIO_I_I2S_LBMIX_get_l2len(data)                                              ((0x00000001&(data))>>0)
+
+
+#define AIO_O_I2S_GCTL                                                               0x18006004
+#define AIO_O_I2S_GCTL_reg_addr                                                      "0xB8006004"
+#define AIO_O_I2S_GCTL_reg                                                           0xB8006004
+#define set_AIO_O_I2S_GCTL_reg(data)   (*((volatile unsigned int*) AIO_O_I2S_GCTL_reg)=data)
+#define get_AIO_O_I2S_GCTL_reg   (*((volatile unsigned int*) AIO_O_I2S_GCTL_reg))
+#define AIO_O_I2S_GCTL_inst_adr                                                      "0x0001"
+#define AIO_O_I2S_GCTL_inst                                                          0x0001
+#define AIO_O_I2S_GCTL_pcm2chsel_shift                                               (28)
+#define AIO_O_I2S_GCTL_pcm2chsel_mask                                                (0x10000000)
+#define AIO_O_I2S_GCTL_pcm2chsel(data)                                               (0x10000000&((data)<<28))
+#define AIO_O_I2S_GCTL_pcm2chsel_src(data)                                           ((0x10000000&(data))>>28)
+#define AIO_O_I2S_GCTL_get_pcm2chsel(data)                                           ((0x10000000&(data))>>28)
+#define AIO_O_I2S_GCTL_wsperiod_shift                                                (22)
+#define AIO_O_I2S_GCTL_wsperiod_mask                                                 (0x0FC00000)
+#define AIO_O_I2S_GCTL_wsperiod(data)                                                (0x0FC00000&((data)<<22))
+#define AIO_O_I2S_GCTL_wsperiod_src(data)                                            ((0x0FC00000&(data))>>22)
+#define AIO_O_I2S_GCTL_get_wsperiod(data)                                            ((0x0FC00000&(data))>>22)
+#define AIO_O_I2S_GCTL_protocol_shift                                                (20)
+#define AIO_O_I2S_GCTL_protocol_mask                                                 (0x00300000)
+#define AIO_O_I2S_GCTL_protocol(data)                                                (0x00300000&((data)<<20))
+#define AIO_O_I2S_GCTL_protocol_src(data)                                            ((0x00300000&(data))>>20)
+#define AIO_O_I2S_GCTL_get_protocol(data)                                            ((0x00300000&(data))>>20)
+#define AIO_O_I2S_GCTL_wsdelay_shift                                                 (19)
+#define AIO_O_I2S_GCTL_wsdelay_mask                                                  (0x00080000)
+#define AIO_O_I2S_GCTL_wsdelay(data)                                                 (0x00080000&((data)<<19))
+#define AIO_O_I2S_GCTL_wsdelay_src(data)                                             ((0x00080000&(data))>>19)
+#define AIO_O_I2S_GCTL_get_wsdelay(data)                                             ((0x00080000&(data))>>19)
+#define AIO_O_I2S_GCTL_slave_shift                                                   (18)
+#define AIO_O_I2S_GCTL_slave_mask                                                    (0x00040000)
+#define AIO_O_I2S_GCTL_slave(data)                                                   (0x00040000&((data)<<18))
+#define AIO_O_I2S_GCTL_slave_src(data)                                               ((0x00040000&(data))>>18)
+#define AIO_O_I2S_GCTL_get_slave(data)                                               ((0x00040000&(data))>>18)
+#define AIO_O_I2S_GCTL_bit_shift                                                     (15)
+#define AIO_O_I2S_GCTL_bit_mask                                                      (0x00038000)
+#define AIO_O_I2S_GCTL_bit(data)                                                     (0x00038000&((data)<<15))
+#define AIO_O_I2S_GCTL_bit_src(data)                                                 ((0x00038000&(data))>>15)
+#define AIO_O_I2S_GCTL_get_bit(data)                                                 ((0x00038000&(data))>>15)
+#define AIO_O_I2S_GCTL_rmute0_shift                                                  (2)
+#define AIO_O_I2S_GCTL_rmute0_mask                                                   (0x00000004)
+#define AIO_O_I2S_GCTL_rmute0(data)                                                  (0x00000004&((data)<<2))
+#define AIO_O_I2S_GCTL_rmute0_src(data)                                              ((0x00000004&(data))>>2)
+#define AIO_O_I2S_GCTL_get_rmute0(data)                                              ((0x00000004&(data))>>2)
+#define AIO_O_I2S_GCTL_lmute0_shift                                                  (1)
+#define AIO_O_I2S_GCTL_lmute0_mask                                                   (0x00000002)
+#define AIO_O_I2S_GCTL_lmute0(data)                                                  (0x00000002&((data)<<1))
+#define AIO_O_I2S_GCTL_lmute0_src(data)                                              ((0x00000002&(data))>>1)
+#define AIO_O_I2S_GCTL_get_lmute0(data)                                              ((0x00000002&(data))>>1)
+#define AIO_O_I2S_GCTL_en0_shift                                                     (0)
+#define AIO_O_I2S_GCTL_en0_mask                                                      (0x00000001)
+#define AIO_O_I2S_GCTL_en0(data)                                                     (0x00000001&((data)<<0))
+#define AIO_O_I2S_GCTL_en0_src(data)                                                 ((0x00000001&(data))>>0)
+#define AIO_O_I2S_GCTL_get_en0(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define AIO_O_PCM_CS1                                                                0x1800600c
+#define AIO_O_PCM_CS1_reg_addr                                                       "0xB800600C"
+#define AIO_O_PCM_CS1_reg                                                            0xB800600C
+#define set_AIO_O_PCM_CS1_reg(data)   (*((volatile unsigned int*) AIO_O_PCM_CS1_reg)=data)
+#define get_AIO_O_PCM_CS1_reg   (*((volatile unsigned int*) AIO_O_PCM_CS1_reg))
+#define AIO_O_PCM_CS1_inst_adr                                                       "0x0003"
+#define AIO_O_PCM_CS1_inst                                                           0x0003
+#define AIO_O_PCM_CS1_cs1_shift                                                      (0)
+#define AIO_O_PCM_CS1_cs1_mask                                                       (0xFFFFFFFF)
+#define AIO_O_PCM_CS1_cs1(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define AIO_O_PCM_CS1_cs1_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_PCM_CS1_get_cs1(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_PCM_CS2                                                                0x18006010
+#define AIO_O_PCM_CS2_reg_addr                                                       "0xB8006010"
+#define AIO_O_PCM_CS2_reg                                                            0xB8006010
+#define set_AIO_O_PCM_CS2_reg(data)   (*((volatile unsigned int*) AIO_O_PCM_CS2_reg)=data)
+#define get_AIO_O_PCM_CS2_reg   (*((volatile unsigned int*) AIO_O_PCM_CS2_reg))
+#define AIO_O_PCM_CS2_inst_adr                                                       "0x0004"
+#define AIO_O_PCM_CS2_inst                                                           0x0004
+#define AIO_O_PCM_CS2_cs2_shift                                                      (0)
+#define AIO_O_PCM_CS2_cs2_mask                                                       (0x000000FF)
+#define AIO_O_PCM_CS2_cs2(data)                                                      (0x000000FF&((data)<<0))
+#define AIO_O_PCM_CS2_cs2_src(data)                                                  ((0x000000FF&(data))>>0)
+#define AIO_O_PCM_CS2_get_cs2(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define AIO_O_SPF_GCTL                                                               0x18006050
+#define AIO_O_SPF_GCTL_reg_addr                                                      "0xB8006050"
+#define AIO_O_SPF_GCTL_reg                                                           0xB8006050
+#define set_AIO_O_SPF_GCTL_reg(data)   (*((volatile unsigned int*) AIO_O_SPF_GCTL_reg)=data)
+#define get_AIO_O_SPF_GCTL_reg   (*((volatile unsigned int*) AIO_O_SPF_GCTL_reg))
+#define AIO_O_SPF_GCTL_inst_adr                                                      "0x0014"
+#define AIO_O_SPF_GCTL_inst                                                          0x0014
+#define AIO_O_SPF_GCTL_pcm2chsel_shift                                               (9)
+#define AIO_O_SPF_GCTL_pcm2chsel_mask                                                (0x00000200)
+#define AIO_O_SPF_GCTL_pcm2chsel(data)                                               (0x00000200&((data)<<9))
+#define AIO_O_SPF_GCTL_pcm2chsel_src(data)                                           ((0x00000200&(data))>>9)
+#define AIO_O_SPF_GCTL_get_pcm2chsel(data)                                           ((0x00000200&(data))>>9)
+#define AIO_O_SPF_GCTL_bit_shift                                                     (6)
+#define AIO_O_SPF_GCTL_bit_mask                                                      (0x000001C0)
+#define AIO_O_SPF_GCTL_bit(data)                                                     (0x000001C0&((data)<<6))
+#define AIO_O_SPF_GCTL_bit_src(data)                                                 ((0x000001C0&(data))>>6)
+#define AIO_O_SPF_GCTL_get_bit(data)                                                 ((0x000001C0&(data))>>6)
+#define AIO_O_SPF_GCTL_wait_en_shift                                                 (5)
+#define AIO_O_SPF_GCTL_wait_en_mask                                                  (0x00000020)
+#define AIO_O_SPF_GCTL_wait_en(data)                                                 (0x00000020&((data)<<5))
+#define AIO_O_SPF_GCTL_wait_en_src(data)                                             ((0x00000020&(data))>>5)
+#define AIO_O_SPF_GCTL_get_wait_en(data)                                             ((0x00000020&(data))>>5)
+#define AIO_O_SPF_GCTL_valid_shift                                                   (4)
+#define AIO_O_SPF_GCTL_valid_mask                                                    (0x00000010)
+#define AIO_O_SPF_GCTL_valid(data)                                                   (0x00000010&((data)<<4))
+#define AIO_O_SPF_GCTL_valid_src(data)                                               ((0x00000010&(data))>>4)
+#define AIO_O_SPF_GCTL_get_valid(data)                                               ((0x00000010&(data))>>4)
+#define AIO_O_SPF_GCTL_format_shift                                                  (3)
+#define AIO_O_SPF_GCTL_format_mask                                                   (0x00000008)
+#define AIO_O_SPF_GCTL_format(data)                                                  (0x00000008&((data)<<3))
+#define AIO_O_SPF_GCTL_format_src(data)                                              ((0x00000008&(data))>>3)
+#define AIO_O_SPF_GCTL_get_format(data)                                              ((0x00000008&(data))>>3)
+#define AIO_O_SPF_GCTL_rmute_shift                                                   (2)
+#define AIO_O_SPF_GCTL_rmute_mask                                                    (0x00000004)
+#define AIO_O_SPF_GCTL_rmute(data)                                                   (0x00000004&((data)<<2))
+#define AIO_O_SPF_GCTL_rmute_src(data)                                               ((0x00000004&(data))>>2)
+#define AIO_O_SPF_GCTL_get_rmute(data)                                               ((0x00000004&(data))>>2)
+#define AIO_O_SPF_GCTL_lmute_shift                                                   (1)
+#define AIO_O_SPF_GCTL_lmute_mask                                                    (0x00000002)
+#define AIO_O_SPF_GCTL_lmute(data)                                                   (0x00000002&((data)<<1))
+#define AIO_O_SPF_GCTL_lmute_src(data)                                               ((0x00000002&(data))>>1)
+#define AIO_O_SPF_GCTL_get_lmute(data)                                               ((0x00000002&(data))>>1)
+#define AIO_O_SPF_GCTL_en_shift                                                      (0)
+#define AIO_O_SPF_GCTL_en_mask                                                       (0x00000001)
+#define AIO_O_SPF_GCTL_en(data)                                                      (0x00000001&((data)<<0))
+#define AIO_O_SPF_GCTL_en_src(data)                                                  ((0x00000001&(data))>>0)
+#define AIO_O_SPF_GCTL_get_en(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define AIO_O_RAW_CS1                                                                0x18006058
+#define AIO_O_RAW_CS1_reg_addr                                                       "0xB8006058"
+#define AIO_O_RAW_CS1_reg                                                            0xB8006058
+#define set_AIO_O_RAW_CS1_reg(data)   (*((volatile unsigned int*) AIO_O_RAW_CS1_reg)=data)
+#define get_AIO_O_RAW_CS1_reg   (*((volatile unsigned int*) AIO_O_RAW_CS1_reg))
+#define AIO_O_RAW_CS1_inst_adr                                                       "0x0016"
+#define AIO_O_RAW_CS1_inst                                                           0x0016
+#define AIO_O_RAW_CS1_cs1_shift                                                      (0)
+#define AIO_O_RAW_CS1_cs1_mask                                                       (0xFFFFFFFF)
+#define AIO_O_RAW_CS1_cs1(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define AIO_O_RAW_CS1_cs1_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_RAW_CS1_get_cs1(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_RAW_CS2                                                                0x1800605c
+#define AIO_O_RAW_CS2_reg_addr                                                       "0xB800605C"
+#define AIO_O_RAW_CS2_reg                                                            0xB800605C
+#define set_AIO_O_RAW_CS2_reg(data)   (*((volatile unsigned int*) AIO_O_RAW_CS2_reg)=data)
+#define get_AIO_O_RAW_CS2_reg   (*((volatile unsigned int*) AIO_O_RAW_CS2_reg))
+#define AIO_O_RAW_CS2_inst_adr                                                       "0x0017"
+#define AIO_O_RAW_CS2_inst                                                           0x0017
+#define AIO_O_RAW_CS2_cs2_shift                                                      (0)
+#define AIO_O_RAW_CS2_cs2_mask                                                       (0x000000FF)
+#define AIO_O_RAW_CS2_cs2(data)                                                      (0x000000FF&((data)<<0))
+#define AIO_O_RAW_CS2_cs2_src(data)                                                  ((0x000000FF&(data))>>0)
+#define AIO_O_RAW_CS2_get_cs2(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define AIO_O_SPF_FCNT                                                               0x18006060
+#define AIO_O_SPF_FCNT_reg_addr                                                      "0xB8006060"
+#define AIO_O_SPF_FCNT_reg                                                           0xB8006060
+#define set_AIO_O_SPF_FCNT_reg(data)   (*((volatile unsigned int*) AIO_O_SPF_FCNT_reg)=data)
+#define get_AIO_O_SPF_FCNT_reg   (*((volatile unsigned int*) AIO_O_SPF_FCNT_reg))
+#define AIO_O_SPF_FCNT_inst_adr                                                      "0x0018"
+#define AIO_O_SPF_FCNT_inst                                                          0x0018
+#define AIO_O_SPF_FCNT_realgo_shift                                                  (15)
+#define AIO_O_SPF_FCNT_realgo_mask                                                   (0x00008000)
+#define AIO_O_SPF_FCNT_realgo(data)                                                  (0x00008000&((data)<<15))
+#define AIO_O_SPF_FCNT_realgo_src(data)                                              ((0x00008000&(data))>>15)
+#define AIO_O_SPF_FCNT_get_realgo(data)                                              ((0x00008000&(data))>>15)
+#define AIO_O_SPF_FCNT_spcnt_shift                                                   (8)
+#define AIO_O_SPF_FCNT_spcnt_mask                                                    (0x00007F00)
+#define AIO_O_SPF_FCNT_spcnt(data)                                                   (0x00007F00&((data)<<8))
+#define AIO_O_SPF_FCNT_spcnt_src(data)                                               ((0x00007F00&(data))>>8)
+#define AIO_O_SPF_FCNT_get_spcnt(data)                                               ((0x00007F00&(data))>>8)
+#define AIO_O_SPF_FCNT_fcnt_shift                                                    (0)
+#define AIO_O_SPF_FCNT_fcnt_mask                                                     (0x000000FF)
+#define AIO_O_SPF_FCNT_fcnt(data)                                                    (0x000000FF&((data)<<0))
+#define AIO_O_SPF_FCNT_fcnt_src(data)                                                ((0x000000FF&(data))>>0)
+#define AIO_O_SPF_FCNT_get_fcnt(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define AIO_O_HDMI_GCTL                                                              0x18006070
+#define AIO_O_HDMI_GCTL_reg_addr                                                     "0xB8006070"
+#define AIO_O_HDMI_GCTL_reg                                                          0xB8006070
+#define set_AIO_O_HDMI_GCTL_reg(data)   (*((volatile unsigned int*) AIO_O_HDMI_GCTL_reg)=data)
+#define get_AIO_O_HDMI_GCTL_reg   (*((volatile unsigned int*) AIO_O_HDMI_GCTL_reg))
+#define AIO_O_HDMI_GCTL_inst_adr                                                     "0x001C"
+#define AIO_O_HDMI_GCTL_inst                                                         0x001C
+#define AIO_O_HDMI_GCTL_pcm8chlben_shift                                             (30)
+#define AIO_O_HDMI_GCTL_pcm8chlben_mask                                              (0x40000000)
+#define AIO_O_HDMI_GCTL_pcm8chlben(data)                                             (0x40000000&((data)<<30))
+#define AIO_O_HDMI_GCTL_pcm8chlben_src(data)                                         ((0x40000000&(data))>>30)
+#define AIO_O_HDMI_GCTL_get_pcm8chlben(data)                                         ((0x40000000&(data))>>30)
+#define AIO_O_HDMI_GCTL_pcm8chlbsel_shift                                            (28)
+#define AIO_O_HDMI_GCTL_pcm8chlbsel_mask                                             (0x30000000)
+#define AIO_O_HDMI_GCTL_pcm8chlbsel(data)                                            (0x30000000&((data)<<28))
+#define AIO_O_HDMI_GCTL_pcm8chlbsel_src(data)                                        ((0x30000000&(data))>>28)
+#define AIO_O_HDMI_GCTL_get_pcm8chlbsel(data)                                        ((0x30000000&(data))>>28)
+#define AIO_O_HDMI_GCTL_pcm2chsel_shift                                              (27)
+#define AIO_O_HDMI_GCTL_pcm2chsel_mask                                               (0x08000000)
+#define AIO_O_HDMI_GCTL_pcm2chsel(data)                                              (0x08000000&((data)<<27))
+#define AIO_O_HDMI_GCTL_pcm2chsel_src(data)                                          ((0x08000000&(data))>>27)
+#define AIO_O_HDMI_GCTL_get_pcm2chsel(data)                                          ((0x08000000&(data))>>27)
+#define AIO_O_HDMI_GCTL_clk_sel_shift                                                (24)
+#define AIO_O_HDMI_GCTL_clk_sel_mask                                                 (0x07000000)
+#define AIO_O_HDMI_GCTL_clk_sel(data)                                                (0x07000000&((data)<<24))
+#define AIO_O_HDMI_GCTL_clk_sel_src(data)                                            ((0x07000000&(data))>>24)
+#define AIO_O_HDMI_GCTL_get_clk_sel(data)                                            ((0x07000000&(data))>>24)
+#define AIO_O_HDMI_GCTL_pcmsync_shift                                                (23)
+#define AIO_O_HDMI_GCTL_pcmsync_mask                                                 (0x00800000)
+#define AIO_O_HDMI_GCTL_pcmsync(data)                                                (0x00800000&((data)<<23))
+#define AIO_O_HDMI_GCTL_pcmsync_src(data)                                            ((0x00800000&(data))>>23)
+#define AIO_O_HDMI_GCTL_get_pcmsync(data)                                            ((0x00800000&(data))>>23)
+#define AIO_O_HDMI_GCTL_pkt_shift                                                    (22)
+#define AIO_O_HDMI_GCTL_pkt_mask                                                     (0x00400000)
+#define AIO_O_HDMI_GCTL_pkt(data)                                                    (0x00400000&((data)<<22))
+#define AIO_O_HDMI_GCTL_pkt_src(data)                                                ((0x00400000&(data))>>22)
+#define AIO_O_HDMI_GCTL_get_pkt(data)                                                ((0x00400000&(data))>>22)
+#define AIO_O_HDMI_GCTL_sample_flat_shift                                            (18)
+#define AIO_O_HDMI_GCTL_sample_flat_mask                                             (0x003C0000)
+#define AIO_O_HDMI_GCTL_sample_flat(data)                                            (0x003C0000&((data)<<18))
+#define AIO_O_HDMI_GCTL_sample_flat_src(data)                                        ((0x003C0000&(data))>>18)
+#define AIO_O_HDMI_GCTL_get_sample_flat(data)                                        ((0x003C0000&(data))>>18)
+#define AIO_O_HDMI_GCTL_rmute3_shift                                                 (17)
+#define AIO_O_HDMI_GCTL_rmute3_mask                                                  (0x00020000)
+#define AIO_O_HDMI_GCTL_rmute3(data)                                                 (0x00020000&((data)<<17))
+#define AIO_O_HDMI_GCTL_rmute3_src(data)                                             ((0x00020000&(data))>>17)
+#define AIO_O_HDMI_GCTL_get_rmute3(data)                                             ((0x00020000&(data))>>17)
+#define AIO_O_HDMI_GCTL_lmute3_shift                                                 (16)
+#define AIO_O_HDMI_GCTL_lmute3_mask                                                  (0x00010000)
+#define AIO_O_HDMI_GCTL_lmute3(data)                                                 (0x00010000&((data)<<16))
+#define AIO_O_HDMI_GCTL_lmute3_src(data)                                             ((0x00010000&(data))>>16)
+#define AIO_O_HDMI_GCTL_get_lmute3(data)                                             ((0x00010000&(data))>>16)
+#define AIO_O_HDMI_GCTL_rmute2_shift                                                 (15)
+#define AIO_O_HDMI_GCTL_rmute2_mask                                                  (0x00008000)
+#define AIO_O_HDMI_GCTL_rmute2(data)                                                 (0x00008000&((data)<<15))
+#define AIO_O_HDMI_GCTL_rmute2_src(data)                                             ((0x00008000&(data))>>15)
+#define AIO_O_HDMI_GCTL_get_rmute2(data)                                             ((0x00008000&(data))>>15)
+#define AIO_O_HDMI_GCTL_lmute2_shift                                                 (14)
+#define AIO_O_HDMI_GCTL_lmute2_mask                                                  (0x00004000)
+#define AIO_O_HDMI_GCTL_lmute2(data)                                                 (0x00004000&((data)<<14))
+#define AIO_O_HDMI_GCTL_lmute2_src(data)                                             ((0x00004000&(data))>>14)
+#define AIO_O_HDMI_GCTL_get_lmute2(data)                                             ((0x00004000&(data))>>14)
+#define AIO_O_HDMI_GCTL_rmute1_shift                                                 (13)
+#define AIO_O_HDMI_GCTL_rmute1_mask                                                  (0x00002000)
+#define AIO_O_HDMI_GCTL_rmute1(data)                                                 (0x00002000&((data)<<13))
+#define AIO_O_HDMI_GCTL_rmute1_src(data)                                             ((0x00002000&(data))>>13)
+#define AIO_O_HDMI_GCTL_get_rmute1(data)                                             ((0x00002000&(data))>>13)
+#define AIO_O_HDMI_GCTL_lmute1_shift                                                 (12)
+#define AIO_O_HDMI_GCTL_lmute1_mask                                                  (0x00001000)
+#define AIO_O_HDMI_GCTL_lmute1(data)                                                 (0x00001000&((data)<<12))
+#define AIO_O_HDMI_GCTL_lmute1_src(data)                                             ((0x00001000&(data))>>12)
+#define AIO_O_HDMI_GCTL_get_lmute1(data)                                             ((0x00001000&(data))>>12)
+#define AIO_O_HDMI_GCTL_8ch_shift                                                    (11)
+#define AIO_O_HDMI_GCTL_8ch_mask                                                     (0x00000800)
+#define AIO_O_HDMI_GCTL_8ch(data)                                                    (0x00000800&((data)<<11))
+#define AIO_O_HDMI_GCTL_8ch_src(data)                                                ((0x00000800&(data))>>11)
+#define AIO_O_HDMI_GCTL_get_8ch(data)                                                ((0x00000800&(data))>>11)
+#define AIO_O_HDMI_GCTL_bit_shift                                                    (8)
+#define AIO_O_HDMI_GCTL_bit_mask                                                     (0x00000700)
+#define AIO_O_HDMI_GCTL_bit(data)                                                    (0x00000700&((data)<<8))
+#define AIO_O_HDMI_GCTL_bit_src(data)                                                ((0x00000700&(data))>>8)
+#define AIO_O_HDMI_GCTL_get_bit(data)                                                ((0x00000700&(data))>>8)
+#define AIO_O_HDMI_GCTL_wait_en_shift                                                (7)
+#define AIO_O_HDMI_GCTL_wait_en_mask                                                 (0x00000080)
+#define AIO_O_HDMI_GCTL_wait_en(data)                                                (0x00000080&((data)<<7))
+#define AIO_O_HDMI_GCTL_wait_en_src(data)                                            ((0x00000080&(data))>>7)
+#define AIO_O_HDMI_GCTL_get_wait_en(data)                                            ((0x00000080&(data))>>7)
+#define AIO_O_HDMI_GCTL_rmute_shift                                                  (5)
+#define AIO_O_HDMI_GCTL_rmute_mask                                                   (0x00000020)
+#define AIO_O_HDMI_GCTL_rmute(data)                                                  (0x00000020&((data)<<5))
+#define AIO_O_HDMI_GCTL_rmute_src(data)                                              ((0x00000020&(data))>>5)
+#define AIO_O_HDMI_GCTL_get_rmute(data)                                              ((0x00000020&(data))>>5)
+#define AIO_O_HDMI_GCTL_lmute_shift                                                  (4)
+#define AIO_O_HDMI_GCTL_lmute_mask                                                   (0x00000010)
+#define AIO_O_HDMI_GCTL_lmute(data)                                                  (0x00000010&((data)<<4))
+#define AIO_O_HDMI_GCTL_lmute_src(data)                                              ((0x00000010&(data))>>4)
+#define AIO_O_HDMI_GCTL_get_lmute(data)                                              ((0x00000010&(data))>>4)
+#define AIO_O_HDMI_GCTL_switch_wait_en_shift                                         (3)
+#define AIO_O_HDMI_GCTL_switch_wait_en_mask                                          (0x00000008)
+#define AIO_O_HDMI_GCTL_switch_wait_en(data)                                         (0x00000008&((data)<<3))
+#define AIO_O_HDMI_GCTL_switch_wait_en_src(data)                                     ((0x00000008&(data))>>3)
+#define AIO_O_HDMI_GCTL_get_switch_wait_en(data)                                     ((0x00000008&(data))>>3)
+#define AIO_O_HDMI_GCTL_sel_shift                                                    (1)
+#define AIO_O_HDMI_GCTL_sel_mask                                                     (0x00000006)
+#define AIO_O_HDMI_GCTL_sel(data)                                                    (0x00000006&((data)<<1))
+#define AIO_O_HDMI_GCTL_sel_src(data)                                                ((0x00000006&(data))>>1)
+#define AIO_O_HDMI_GCTL_get_sel(data)                                                ((0x00000006&(data))>>1)
+#define AIO_O_HDMI_GCTL_en_shift                                                     (0)
+#define AIO_O_HDMI_GCTL_en_mask                                                      (0x00000001)
+#define AIO_O_HDMI_GCTL_en(data)                                                     (0x00000001&((data)<<0))
+#define AIO_O_HDMI_GCTL_en_src(data)                                                 ((0x00000001&(data))>>0)
+#define AIO_O_HDMI_GCTL_get_en(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define AIO_O_HDMI_FCNT                                                              0x18006074
+#define AIO_O_HDMI_FCNT_reg_addr                                                     "0xB8006074"
+#define AIO_O_HDMI_FCNT_reg                                                          0xB8006074
+#define set_AIO_O_HDMI_FCNT_reg(data)   (*((volatile unsigned int*) AIO_O_HDMI_FCNT_reg)=data)
+#define get_AIO_O_HDMI_FCNT_reg   (*((volatile unsigned int*) AIO_O_HDMI_FCNT_reg))
+#define AIO_O_HDMI_FCNT_inst_adr                                                     "0x001D"
+#define AIO_O_HDMI_FCNT_inst                                                         0x001D
+#define AIO_O_HDMI_FCNT_realgo_shift                                                 (8)
+#define AIO_O_HDMI_FCNT_realgo_mask                                                  (0x00000100)
+#define AIO_O_HDMI_FCNT_realgo(data)                                                 (0x00000100&((data)<<8))
+#define AIO_O_HDMI_FCNT_realgo_src(data)                                             ((0x00000100&(data))>>8)
+#define AIO_O_HDMI_FCNT_get_realgo(data)                                             ((0x00000100&(data))>>8)
+#define AIO_O_HDMI_FCNT_fcnt_shift                                                   (0)
+#define AIO_O_HDMI_FCNT_fcnt_mask                                                    (0x000000FF)
+#define AIO_O_HDMI_FCNT_fcnt(data)                                                   (0x000000FF&((data)<<0))
+#define AIO_O_HDMI_FCNT_fcnt_src(data)                                               ((0x000000FF&(data))>>0)
+#define AIO_O_HDMI_FCNT_get_fcnt(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define AIO_O_HDMI_CS1                                                               0x18006078
+#define AIO_O_HDMI_CS1_reg_addr                                                      "0xB8006078"
+#define AIO_O_HDMI_CS1_reg                                                           0xB8006078
+#define set_AIO_O_HDMI_CS1_reg(data)   (*((volatile unsigned int*) AIO_O_HDMI_CS1_reg)=data)
+#define get_AIO_O_HDMI_CS1_reg   (*((volatile unsigned int*) AIO_O_HDMI_CS1_reg))
+#define AIO_O_HDMI_CS1_inst_adr                                                      "0x001E"
+#define AIO_O_HDMI_CS1_inst                                                          0x001E
+#define AIO_O_HDMI_CS1_cs1_shift                                                     (0)
+#define AIO_O_HDMI_CS1_cs1_mask                                                      (0xFFFFFFFF)
+#define AIO_O_HDMI_CS1_cs1(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define AIO_O_HDMI_CS1_cs1_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_HDMI_CS1_get_cs1(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_HDMI_CS2                                                               0x1800607c
+#define AIO_O_HDMI_CS2_reg_addr                                                      "0xB800607C"
+#define AIO_O_HDMI_CS2_reg                                                           0xB800607C
+#define set_AIO_O_HDMI_CS2_reg(data)   (*((volatile unsigned int*) AIO_O_HDMI_CS2_reg)=data)
+#define get_AIO_O_HDMI_CS2_reg   (*((volatile unsigned int*) AIO_O_HDMI_CS2_reg))
+#define AIO_O_HDMI_CS2_inst_adr                                                      "0x001F"
+#define AIO_O_HDMI_CS2_inst                                                          0x001F
+#define AIO_O_HDMI_CS2_cs2_shift                                                     (0)
+#define AIO_O_HDMI_CS2_cs2_mask                                                      (0x000000FF)
+#define AIO_O_HDMI_CS2_cs2(data)                                                     (0x000000FF&((data)<<0))
+#define AIO_O_HDMI_CS2_cs2_src(data)                                                 ((0x000000FF&(data))>>0)
+#define AIO_O_HDMI_CS2_get_cs2(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define AIO_O_HDMI_INFO                                                              0x180060d0
+#define AIO_O_HDMI_INFO_reg_addr                                                     "0xB80060D0"
+#define AIO_O_HDMI_INFO_reg                                                          0xB80060D0
+#define set_AIO_O_HDMI_INFO_reg(data)   (*((volatile unsigned int*) AIO_O_HDMI_INFO_reg)=data)
+#define get_AIO_O_HDMI_INFO_reg   (*((volatile unsigned int*) AIO_O_HDMI_INFO_reg))
+#define AIO_O_HDMI_INFO_inst_adr                                                     "0x0034"
+#define AIO_O_HDMI_INFO_inst                                                         0x0034
+#define AIO_O_HDMI_INFO_userdata_shift                                               (8)
+#define AIO_O_HDMI_INFO_userdata_mask                                                (0x0000FF00)
+#define AIO_O_HDMI_INFO_userdata(data)                                               (0x0000FF00&((data)<<8))
+#define AIO_O_HDMI_INFO_userdata_src(data)                                           ((0x0000FF00&(data))>>8)
+#define AIO_O_HDMI_INFO_get_userdata(data)                                           ((0x0000FF00&(data))>>8)
+#define AIO_O_HDMI_INFO_valid_shift                                                  (0)
+#define AIO_O_HDMI_INFO_valid_mask                                                   (0x000000FF)
+#define AIO_O_HDMI_INFO_valid(data)                                                  (0x000000FF&((data)<<0))
+#define AIO_O_HDMI_INFO_valid_src(data)                                              ((0x000000FF&(data))>>0)
+#define AIO_O_HDMI_INFO_get_valid(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define AIO_O_ACDAC_GCTL                                                             0x18006600
+#define AIO_O_ACDAC_GCTL_reg_addr                                                    "0xB8006600"
+#define AIO_O_ACDAC_GCTL_reg                                                         0xB8006600
+#define set_AIO_O_ACDAC_GCTL_reg(data)   (*((volatile unsigned int*) AIO_O_ACDAC_GCTL_reg)=data)
+#define get_AIO_O_ACDAC_GCTL_reg   (*((volatile unsigned int*) AIO_O_ACDAC_GCTL_reg))
+#define AIO_O_ACDAC_GCTL_inst_adr                                                    "0x0080"
+#define AIO_O_ACDAC_GCTL_inst                                                        0x0080
+#define AIO_O_ACDAC_GCTL_pcm2chsel_shift                                             (21)
+#define AIO_O_ACDAC_GCTL_pcm2chsel_mask                                              (0x00200000)
+#define AIO_O_ACDAC_GCTL_pcm2chsel(data)                                             (0x00200000&((data)<<21))
+#define AIO_O_ACDAC_GCTL_pcm2chsel_src(data)                                         ((0x00200000&(data))>>21)
+#define AIO_O_ACDAC_GCTL_get_pcm2chsel(data)                                         ((0x00200000&(data))>>21)
+#define AIO_O_ACDAC_GCTL_rgain_shift                                                 (14)
+#define AIO_O_ACDAC_GCTL_rgain_mask                                                  (0x001FC000)
+#define AIO_O_ACDAC_GCTL_rgain(data)                                                 (0x001FC000&((data)<<14))
+#define AIO_O_ACDAC_GCTL_rgain_src(data)                                             ((0x001FC000&(data))>>14)
+#define AIO_O_ACDAC_GCTL_get_rgain(data)                                             ((0x001FC000&(data))>>14)
+#define AIO_O_ACDAC_GCTL_lgain_shift                                                 (7)
+#define AIO_O_ACDAC_GCTL_lgain_mask                                                  (0x00003F80)
+#define AIO_O_ACDAC_GCTL_lgain(data)                                                 (0x00003F80&((data)<<7))
+#define AIO_O_ACDAC_GCTL_lgain_src(data)                                             ((0x00003F80&(data))>>7)
+#define AIO_O_ACDAC_GCTL_get_lgain(data)                                             ((0x00003F80&(data))>>7)
+#define AIO_O_ACDAC_GCTL_bit_shift                                                   (4)
+#define AIO_O_ACDAC_GCTL_bit_mask                                                    (0x00000070)
+#define AIO_O_ACDAC_GCTL_bit(data)                                                   (0x00000070&((data)<<4))
+#define AIO_O_ACDAC_GCTL_bit_src(data)                                               ((0x00000070&(data))>>4)
+#define AIO_O_ACDAC_GCTL_get_bit(data)                                               ((0x00000070&(data))>>4)
+#define AIO_O_ACDAC_GCTL_hpfen_shift                                                 (3)
+#define AIO_O_ACDAC_GCTL_hpfen_mask                                                  (0x00000008)
+#define AIO_O_ACDAC_GCTL_hpfen(data)                                                 (0x00000008&((data)<<3))
+#define AIO_O_ACDAC_GCTL_hpfen_src(data)                                             ((0x00000008&(data))>>3)
+#define AIO_O_ACDAC_GCTL_get_hpfen(data)                                             ((0x00000008&(data))>>3)
+#define AIO_O_ACDAC_GCTL_rmute_shift                                                 (2)
+#define AIO_O_ACDAC_GCTL_rmute_mask                                                  (0x00000004)
+#define AIO_O_ACDAC_GCTL_rmute(data)                                                 (0x00000004&((data)<<2))
+#define AIO_O_ACDAC_GCTL_rmute_src(data)                                             ((0x00000004&(data))>>2)
+#define AIO_O_ACDAC_GCTL_get_rmute(data)                                             ((0x00000004&(data))>>2)
+#define AIO_O_ACDAC_GCTL_lmute_shift                                                 (1)
+#define AIO_O_ACDAC_GCTL_lmute_mask                                                  (0x00000002)
+#define AIO_O_ACDAC_GCTL_lmute(data)                                                 (0x00000002&((data)<<1))
+#define AIO_O_ACDAC_GCTL_lmute_src(data)                                             ((0x00000002&(data))>>1)
+#define AIO_O_ACDAC_GCTL_get_lmute(data)                                             ((0x00000002&(data))>>1)
+#define AIO_O_ACDAC_GCTL_en_shift                                                    (0)
+#define AIO_O_ACDAC_GCTL_en_mask                                                     (0x00000001)
+#define AIO_O_ACDAC_GCTL_en(data)                                                    (0x00000001&((data)<<0))
+#define AIO_O_ACDAC_GCTL_en_src(data)                                                ((0x00000001&(data))>>0)
+#define AIO_O_ACDAC_GCTL_get_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define AIO_O_ACANA_GCTL1                                                            0x18006604
+#define AIO_O_ACANA_GCTL1_reg_addr                                                   "0xB8006604"
+#define AIO_O_ACANA_GCTL1_reg                                                        0xB8006604
+#define set_AIO_O_ACANA_GCTL1_reg(data)   (*((volatile unsigned int*) AIO_O_ACANA_GCTL1_reg)=data)
+#define get_AIO_O_ACANA_GCTL1_reg   (*((volatile unsigned int*) AIO_O_ACANA_GCTL1_reg))
+#define AIO_O_ACANA_GCTL1_inst_adr                                                   "0x0081"
+#define AIO_O_ACANA_GCTL1_inst                                                       0x0081
+#define AIO_O_ACANA_GCTL1_write_en14_shift                                           (31)
+#define AIO_O_ACANA_GCTL1_write_en14_mask                                            (0x80000000)
+#define AIO_O_ACANA_GCTL1_write_en14(data)                                           (0x80000000&((data)<<31))
+#define AIO_O_ACANA_GCTL1_write_en14_src(data)                                       ((0x80000000&(data))>>31)
+#define AIO_O_ACANA_GCTL1_get_write_en14(data)                                       ((0x80000000&(data))>>31)
+#define AIO_O_ACANA_GCTL1_isel_df2se_shift                                           (29)
+#define AIO_O_ACANA_GCTL1_isel_df2se_mask                                            (0x60000000)
+#define AIO_O_ACANA_GCTL1_isel_df2se(data)                                           (0x60000000&((data)<<29))
+#define AIO_O_ACANA_GCTL1_isel_df2se_src(data)                                       ((0x60000000&(data))>>29)
+#define AIO_O_ACANA_GCTL1_get_isel_df2se(data)                                       ((0x60000000&(data))>>29)
+#define AIO_O_ACANA_GCTL1_write_en13_shift                                           (28)
+#define AIO_O_ACANA_GCTL1_write_en13_mask                                            (0x10000000)
+#define AIO_O_ACANA_GCTL1_write_en13(data)                                           (0x10000000&((data)<<28))
+#define AIO_O_ACANA_GCTL1_write_en13_src(data)                                       ((0x10000000&(data))>>28)
+#define AIO_O_ACANA_GCTL1_get_write_en13(data)                                       ((0x10000000&(data))>>28)
+#define AIO_O_ACANA_GCTL1_isel_depop_shift                                           (26)
+#define AIO_O_ACANA_GCTL1_isel_depop_mask                                            (0x0C000000)
+#define AIO_O_ACANA_GCTL1_isel_depop(data)                                           (0x0C000000&((data)<<26))
+#define AIO_O_ACANA_GCTL1_isel_depop_src(data)                                       ((0x0C000000&(data))>>26)
+#define AIO_O_ACANA_GCTL1_get_isel_depop(data)                                       ((0x0C000000&(data))>>26)
+#define AIO_O_ACANA_GCTL1_write_en12_shift                                           (25)
+#define AIO_O_ACANA_GCTL1_write_en12_mask                                            (0x02000000)
+#define AIO_O_ACANA_GCTL1_write_en12(data)                                           (0x02000000&((data)<<25))
+#define AIO_O_ACANA_GCTL1_write_en12_src(data)                                       ((0x02000000&(data))>>25)
+#define AIO_O_ACANA_GCTL1_get_write_en12(data)                                       ((0x02000000&(data))>>25)
+#define AIO_O_ACANA_GCTL1_isel_dacvcm_shift                                          (23)
+#define AIO_O_ACANA_GCTL1_isel_dacvcm_mask                                           (0x01800000)
+#define AIO_O_ACANA_GCTL1_isel_dacvcm(data)                                          (0x01800000&((data)<<23))
+#define AIO_O_ACANA_GCTL1_isel_dacvcm_src(data)                                      ((0x01800000&(data))>>23)
+#define AIO_O_ACANA_GCTL1_get_isel_dacvcm(data)                                      ((0x01800000&(data))>>23)
+#define AIO_O_ACANA_GCTL1_write_en11_shift                                           (22)
+#define AIO_O_ACANA_GCTL1_write_en11_mask                                            (0x00400000)
+#define AIO_O_ACANA_GCTL1_write_en11(data)                                           (0x00400000&((data)<<22))
+#define AIO_O_ACANA_GCTL1_write_en11_src(data)                                       ((0x00400000&(data))>>22)
+#define AIO_O_ACANA_GCTL1_get_write_en11(data)                                       ((0x00400000&(data))>>22)
+#define AIO_O_ACANA_GCTL1_isel_dacop_shift                                           (20)
+#define AIO_O_ACANA_GCTL1_isel_dacop_mask                                            (0x00300000)
+#define AIO_O_ACANA_GCTL1_isel_dacop(data)                                           (0x00300000&((data)<<20))
+#define AIO_O_ACANA_GCTL1_isel_dacop_src(data)                                       ((0x00300000&(data))>>20)
+#define AIO_O_ACANA_GCTL1_get_isel_dacop(data)                                       ((0x00300000&(data))>>20)
+#define AIO_O_ACANA_GCTL1_write_en10_shift                                           (19)
+#define AIO_O_ACANA_GCTL1_write_en10_mask                                            (0x00080000)
+#define AIO_O_ACANA_GCTL1_write_en10(data)                                           (0x00080000&((data)<<19))
+#define AIO_O_ACANA_GCTL1_write_en10_src(data)                                       ((0x00080000&(data))>>19)
+#define AIO_O_ACANA_GCTL1_get_write_en10(data)                                       ((0x00080000&(data))>>19)
+#define AIO_O_ACANA_GCTL1_powvref_shift                                              (18)
+#define AIO_O_ACANA_GCTL1_powvref_mask                                               (0x00040000)
+#define AIO_O_ACANA_GCTL1_powvref(data)                                              (0x00040000&((data)<<18))
+#define AIO_O_ACANA_GCTL1_powvref_src(data)                                          ((0x00040000&(data))>>18)
+#define AIO_O_ACANA_GCTL1_get_powvref(data)                                          ((0x00040000&(data))>>18)
+#define AIO_O_ACANA_GCTL1_write_en9_shift                                            (17)
+#define AIO_O_ACANA_GCTL1_write_en9_mask                                             (0x00020000)
+#define AIO_O_ACANA_GCTL1_write_en9(data)                                            (0x00020000&((data)<<17))
+#define AIO_O_ACANA_GCTL1_write_en9_src(data)                                        ((0x00020000&(data))>>17)
+#define AIO_O_ACANA_GCTL1_get_write_en9(data)                                        ((0x00020000&(data))>>17)
+#define AIO_O_ACANA_GCTL1_powmbias_shift                                             (16)
+#define AIO_O_ACANA_GCTL1_powmbias_mask                                              (0x00010000)
+#define AIO_O_ACANA_GCTL1_powmbias(data)                                             (0x00010000&((data)<<16))
+#define AIO_O_ACANA_GCTL1_powmbias_src(data)                                         ((0x00010000&(data))>>16)
+#define AIO_O_ACANA_GCTL1_get_powmbias(data)                                         ((0x00010000&(data))>>16)
+#define AIO_O_ACANA_GCTL1_write_en8_shift                                            (15)
+#define AIO_O_ACANA_GCTL1_write_en8_mask                                             (0x00008000)
+#define AIO_O_ACANA_GCTL1_write_en8(data)                                            (0x00008000&((data)<<15))
+#define AIO_O_ACANA_GCTL1_write_en8_src(data)                                        ((0x00008000&(data))>>15)
+#define AIO_O_ACANA_GCTL1_get_write_en8(data)                                        ((0x00008000&(data))>>15)
+#define AIO_O_ACANA_GCTL1_powhpo_shift                                               (14)
+#define AIO_O_ACANA_GCTL1_powhpo_mask                                                (0x00004000)
+#define AIO_O_ACANA_GCTL1_powhpo(data)                                               (0x00004000&((data)<<14))
+#define AIO_O_ACANA_GCTL1_powhpo_src(data)                                           ((0x00004000&(data))>>14)
+#define AIO_O_ACANA_GCTL1_get_powhpo(data)                                           ((0x00004000&(data))>>14)
+#define AIO_O_ACANA_GCTL1_write_en7_shift                                            (13)
+#define AIO_O_ACANA_GCTL1_write_en7_mask                                             (0x00002000)
+#define AIO_O_ACANA_GCTL1_write_en7(data)                                            (0x00002000&((data)<<13))
+#define AIO_O_ACANA_GCTL1_write_en7_src(data)                                        ((0x00002000&(data))>>13)
+#define AIO_O_ACANA_GCTL1_get_write_en7(data)                                        ((0x00002000&(data))>>13)
+#define AIO_O_ACANA_GCTL1_powdf2se_shift                                             (12)
+#define AIO_O_ACANA_GCTL1_powdf2se_mask                                              (0x00001000)
+#define AIO_O_ACANA_GCTL1_powdf2se(data)                                             (0x00001000&((data)<<12))
+#define AIO_O_ACANA_GCTL1_powdf2se_src(data)                                         ((0x00001000&(data))>>12)
+#define AIO_O_ACANA_GCTL1_get_powdf2se(data)                                         ((0x00001000&(data))>>12)
+#define AIO_O_ACANA_GCTL1_write_en6_shift                                            (11)
+#define AIO_O_ACANA_GCTL1_write_en6_mask                                             (0x00000800)
+#define AIO_O_ACANA_GCTL1_write_en6(data)                                            (0x00000800&((data)<<11))
+#define AIO_O_ACANA_GCTL1_write_en6_src(data)                                        ((0x00000800&(data))>>11)
+#define AIO_O_ACANA_GCTL1_get_write_en6(data)                                        ((0x00000800&(data))>>11)
+#define AIO_O_ACANA_GCTL1_powdepop_shift                                             (10)
+#define AIO_O_ACANA_GCTL1_powdepop_mask                                              (0x00000400)
+#define AIO_O_ACANA_GCTL1_powdepop(data)                                             (0x00000400&((data)<<10))
+#define AIO_O_ACANA_GCTL1_powdepop_src(data)                                         ((0x00000400&(data))>>10)
+#define AIO_O_ACANA_GCTL1_get_powdepop(data)                                         ((0x00000400&(data))>>10)
+#define AIO_O_ACANA_GCTL1_write_en5_shift                                            (9)
+#define AIO_O_ACANA_GCTL1_write_en5_mask                                             (0x00000200)
+#define AIO_O_ACANA_GCTL1_write_en5(data)                                            (0x00000200&((data)<<9))
+#define AIO_O_ACANA_GCTL1_write_en5_src(data)                                        ((0x00000200&(data))>>9)
+#define AIO_O_ACANA_GCTL1_get_write_en5(data)                                        ((0x00000200&(data))>>9)
+#define AIO_O_ACANA_GCTL1_powdac_shift                                               (8)
+#define AIO_O_ACANA_GCTL1_powdac_mask                                                (0x00000100)
+#define AIO_O_ACANA_GCTL1_powdac(data)                                               (0x00000100&((data)<<8))
+#define AIO_O_ACANA_GCTL1_powdac_src(data)                                           ((0x00000100&(data))>>8)
+#define AIO_O_ACANA_GCTL1_get_powdac(data)                                           ((0x00000100&(data))>>8)
+#define AIO_O_ACANA_GCTL1_write_en4_shift                                            (7)
+#define AIO_O_ACANA_GCTL1_write_en4_mask                                             (0x00000080)
+#define AIO_O_ACANA_GCTL1_write_en4(data)                                            (0x00000080&((data)<<7))
+#define AIO_O_ACANA_GCTL1_write_en4_src(data)                                        ((0x00000080&(data))>>7)
+#define AIO_O_ACANA_GCTL1_get_write_en4(data)                                        ((0x00000080&(data))>>7)
+#define AIO_O_ACANA_GCTL1_hpo_normal_shift                                           (6)
+#define AIO_O_ACANA_GCTL1_hpo_normal_mask                                            (0x00000040)
+#define AIO_O_ACANA_GCTL1_hpo_normal(data)                                           (0x00000040&((data)<<6))
+#define AIO_O_ACANA_GCTL1_hpo_normal_src(data)                                       ((0x00000040&(data))>>6)
+#define AIO_O_ACANA_GCTL1_get_hpo_normal(data)                                       ((0x00000040&(data))>>6)
+#define AIO_O_ACANA_GCTL1_write_en3_shift                                            (5)
+#define AIO_O_ACANA_GCTL1_write_en3_mask                                             (0x00000020)
+#define AIO_O_ACANA_GCTL1_write_en3(data)                                            (0x00000020&((data)<<5))
+#define AIO_O_ACANA_GCTL1_write_en3_src(data)                                        ((0x00000020&(data))>>5)
+#define AIO_O_ACANA_GCTL1_get_write_en3(data)                                        ((0x00000020&(data))>>5)
+#define AIO_O_ACANA_GCTL1_hpo_hpmode_shift                                           (4)
+#define AIO_O_ACANA_GCTL1_hpo_hpmode_mask                                            (0x00000010)
+#define AIO_O_ACANA_GCTL1_hpo_hpmode(data)                                           (0x00000010&((data)<<4))
+#define AIO_O_ACANA_GCTL1_hpo_hpmode_src(data)                                       ((0x00000010&(data))>>4)
+#define AIO_O_ACANA_GCTL1_get_hpo_hpmode(data)                                       ((0x00000010&(data))>>4)
+#define AIO_O_ACANA_GCTL1_write_en2_shift                                            (3)
+#define AIO_O_ACANA_GCTL1_write_en2_mask                                             (0x00000008)
+#define AIO_O_ACANA_GCTL1_write_en2(data)                                            (0x00000008&((data)<<3))
+#define AIO_O_ACANA_GCTL1_write_en2_src(data)                                        ((0x00000008&(data))>>3)
+#define AIO_O_ACANA_GCTL1_get_write_en2(data)                                        ((0x00000008&(data))>>3)
+#define AIO_O_ACANA_GCTL1_hpo_mr_shift                                               (2)
+#define AIO_O_ACANA_GCTL1_hpo_mr_mask                                                (0x00000004)
+#define AIO_O_ACANA_GCTL1_hpo_mr(data)                                               (0x00000004&((data)<<2))
+#define AIO_O_ACANA_GCTL1_hpo_mr_src(data)                                           ((0x00000004&(data))>>2)
+#define AIO_O_ACANA_GCTL1_get_hpo_mr(data)                                           ((0x00000004&(data))>>2)
+#define AIO_O_ACANA_GCTL1_write_en1_shift                                            (1)
+#define AIO_O_ACANA_GCTL1_write_en1_mask                                             (0x00000002)
+#define AIO_O_ACANA_GCTL1_write_en1(data)                                            (0x00000002&((data)<<1))
+#define AIO_O_ACANA_GCTL1_write_en1_src(data)                                        ((0x00000002&(data))>>1)
+#define AIO_O_ACANA_GCTL1_get_write_en1(data)                                        ((0x00000002&(data))>>1)
+#define AIO_O_ACANA_GCTL1_hpo_ml_shift                                               (0)
+#define AIO_O_ACANA_GCTL1_hpo_ml_mask                                                (0x00000001)
+#define AIO_O_ACANA_GCTL1_hpo_ml(data)                                               (0x00000001&((data)<<0))
+#define AIO_O_ACANA_GCTL1_hpo_ml_src(data)                                           ((0x00000001&(data))>>0)
+#define AIO_O_ACANA_GCTL1_get_hpo_ml(data)                                           ((0x00000001&(data))>>0)
+
+
+#define AIO_O_ACANA_GCTL2                                                            0x18006608
+#define AIO_O_ACANA_GCTL2_reg_addr                                                   "0xB8006608"
+#define AIO_O_ACANA_GCTL2_reg                                                        0xB8006608
+#define set_AIO_O_ACANA_GCTL2_reg(data)   (*((volatile unsigned int*) AIO_O_ACANA_GCTL2_reg)=data)
+#define get_AIO_O_ACANA_GCTL2_reg   (*((volatile unsigned int*) AIO_O_ACANA_GCTL2_reg))
+#define AIO_O_ACANA_GCTL2_inst_adr                                                   "0x0082"
+#define AIO_O_ACANA_GCTL2_inst                                                       0x0082
+#define AIO_O_ACANA_GCTL2_write_en11_shift                                           (29)
+#define AIO_O_ACANA_GCTL2_write_en11_mask                                            (0x20000000)
+#define AIO_O_ACANA_GCTL2_write_en11(data)                                           (0x20000000&((data)<<29))
+#define AIO_O_ACANA_GCTL2_write_en11_src(data)                                       ((0x20000000&(data))>>29)
+#define AIO_O_ACANA_GCTL2_get_write_en11(data)                                       ((0x20000000&(data))>>29)
+#define AIO_O_ACANA_GCTL2_crt_depop_clk_sel_shift                                    (27)
+#define AIO_O_ACANA_GCTL2_crt_depop_clk_sel_mask                                     (0x18000000)
+#define AIO_O_ACANA_GCTL2_crt_depop_clk_sel(data)                                    (0x18000000&((data)<<27))
+#define AIO_O_ACANA_GCTL2_crt_depop_clk_sel_src(data)                                ((0x18000000&(data))>>27)
+#define AIO_O_ACANA_GCTL2_get_crt_depop_clk_sel(data)                                ((0x18000000&(data))>>27)
+#define AIO_O_ACANA_GCTL2_write_en10_shift                                           (26)
+#define AIO_O_ACANA_GCTL2_write_en10_mask                                            (0x04000000)
+#define AIO_O_ACANA_GCTL2_write_en10(data)                                           (0x04000000&((data)<<26))
+#define AIO_O_ACANA_GCTL2_write_en10_src(data)                                       ((0x04000000&(data))>>26)
+#define AIO_O_ACANA_GCTL2_get_write_en10(data)                                       ((0x04000000&(data))>>26)
+#define AIO_O_ACANA_GCTL2_depop_csel_shift                                           (24)
+#define AIO_O_ACANA_GCTL2_depop_csel_mask                                            (0x03000000)
+#define AIO_O_ACANA_GCTL2_depop_csel(data)                                           (0x03000000&((data)<<24))
+#define AIO_O_ACANA_GCTL2_depop_csel_src(data)                                       ((0x03000000&(data))>>24)
+#define AIO_O_ACANA_GCTL2_get_depop_csel(data)                                       ((0x03000000&(data))>>24)
+#define AIO_O_ACANA_GCTL2_write_en9_shift                                            (23)
+#define AIO_O_ACANA_GCTL2_write_en9_mask                                             (0x00800000)
+#define AIO_O_ACANA_GCTL2_write_en9(data)                                            (0x00800000&((data)<<23))
+#define AIO_O_ACANA_GCTL2_write_en9_src(data)                                        ((0x00800000&(data))>>23)
+#define AIO_O_ACANA_GCTL2_get_write_en9(data)                                        ((0x00800000&(data))>>23)
+#define AIO_O_ACANA_GCTL2_depop_enramp_shift                                         (22)
+#define AIO_O_ACANA_GCTL2_depop_enramp_mask                                          (0x00400000)
+#define AIO_O_ACANA_GCTL2_depop_enramp(data)                                         (0x00400000&((data)<<22))
+#define AIO_O_ACANA_GCTL2_depop_enramp_src(data)                                     ((0x00400000&(data))>>22)
+#define AIO_O_ACANA_GCTL2_get_depop_enramp(data)                                     ((0x00400000&(data))>>22)
+#define AIO_O_ACANA_GCTL2_write_en8_shift                                            (21)
+#define AIO_O_ACANA_GCTL2_write_en8_mask                                             (0x00200000)
+#define AIO_O_ACANA_GCTL2_write_en8(data)                                            (0x00200000&((data)<<21))
+#define AIO_O_ACANA_GCTL2_write_en8_src(data)                                        ((0x00200000&(data))>>21)
+#define AIO_O_ACANA_GCTL2_get_write_en8(data)                                        ((0x00200000&(data))>>21)
+#define AIO_O_ACANA_GCTL2_hpo_gr_shift                                               (19)
+#define AIO_O_ACANA_GCTL2_hpo_gr_mask                                                (0x00180000)
+#define AIO_O_ACANA_GCTL2_hpo_gr(data)                                               (0x00180000&((data)<<19))
+#define AIO_O_ACANA_GCTL2_hpo_gr_src(data)                                           ((0x00180000&(data))>>19)
+#define AIO_O_ACANA_GCTL2_get_hpo_gr(data)                                           ((0x00180000&(data))>>19)
+#define AIO_O_ACANA_GCTL2_write_en7_shift                                            (18)
+#define AIO_O_ACANA_GCTL2_write_en7_mask                                             (0x00040000)
+#define AIO_O_ACANA_GCTL2_write_en7(data)                                            (0x00040000&((data)<<18))
+#define AIO_O_ACANA_GCTL2_write_en7_src(data)                                        ((0x00040000&(data))>>18)
+#define AIO_O_ACANA_GCTL2_get_write_en7(data)                                        ((0x00040000&(data))>>18)
+#define AIO_O_ACANA_GCTL2_hpo_gl_shift                                               (16)
+#define AIO_O_ACANA_GCTL2_hpo_gl_mask                                                (0x00030000)
+#define AIO_O_ACANA_GCTL2_hpo_gl(data)                                               (0x00030000&((data)<<16))
+#define AIO_O_ACANA_GCTL2_hpo_gl_src(data)                                           ((0x00030000&(data))>>16)
+#define AIO_O_ACANA_GCTL2_get_hpo_gl(data)                                           ((0x00030000&(data))>>16)
+#define AIO_O_ACANA_GCTL2_write_en6_shift                                            (15)
+#define AIO_O_ACANA_GCTL2_write_en6_mask                                             (0x00008000)
+#define AIO_O_ACANA_GCTL2_write_en6(data)                                            (0x00008000&((data)<<15))
+#define AIO_O_ACANA_GCTL2_write_en6_src(data)                                        ((0x00008000&(data))>>15)
+#define AIO_O_ACANA_GCTL2_get_write_en6(data)                                        ((0x00008000&(data))>>15)
+#define AIO_O_ACANA_GCTL2_hpo_encopy_shift                                           (13)
+#define AIO_O_ACANA_GCTL2_hpo_encopy_mask                                            (0x00006000)
+#define AIO_O_ACANA_GCTL2_hpo_encopy(data)                                           (0x00006000&((data)<<13))
+#define AIO_O_ACANA_GCTL2_hpo_encopy_src(data)                                       ((0x00006000&(data))>>13)
+#define AIO_O_ACANA_GCTL2_get_hpo_encopy(data)                                       ((0x00006000&(data))>>13)
+#define AIO_O_ACANA_GCTL2_write_en5_shift                                            (12)
+#define AIO_O_ACANA_GCTL2_write_en5_mask                                             (0x00001000)
+#define AIO_O_ACANA_GCTL2_write_en5(data)                                            (0x00001000&((data)<<12))
+#define AIO_O_ACANA_GCTL2_write_en5_src(data)                                        ((0x00001000&(data))>>12)
+#define AIO_O_ACANA_GCTL2_get_write_en5(data)                                        ((0x00001000&(data))>>12)
+#define AIO_O_ACANA_GCTL2_vref_vrefsel_shift                                         (10)
+#define AIO_O_ACANA_GCTL2_vref_vrefsel_mask                                          (0x00000C00)
+#define AIO_O_ACANA_GCTL2_vref_vrefsel(data)                                         (0x00000C00&((data)<<10))
+#define AIO_O_ACANA_GCTL2_vref_vrefsel_src(data)                                     ((0x00000C00&(data))>>10)
+#define AIO_O_ACANA_GCTL2_get_vref_vrefsel(data)                                     ((0x00000C00&(data))>>10)
+#define AIO_O_ACANA_GCTL2_write_en4_shift                                            (9)
+#define AIO_O_ACANA_GCTL2_write_en4_mask                                             (0x00000200)
+#define AIO_O_ACANA_GCTL2_write_en4(data)                                            (0x00000200&((data)<<9))
+#define AIO_O_ACANA_GCTL2_write_en4_src(data)                                        ((0x00000200&(data))>>9)
+#define AIO_O_ACANA_GCTL2_get_write_en4(data)                                        ((0x00000200&(data))>>9)
+#define AIO_O_ACANA_GCTL2_hpo_engr_shift                                             (8)
+#define AIO_O_ACANA_GCTL2_hpo_engr_mask                                              (0x00000100)
+#define AIO_O_ACANA_GCTL2_hpo_engr(data)                                             (0x00000100&((data)<<8))
+#define AIO_O_ACANA_GCTL2_hpo_engr_src(data)                                         ((0x00000100&(data))>>8)
+#define AIO_O_ACANA_GCTL2_get_hpo_engr(data)                                         ((0x00000100&(data))>>8)
+#define AIO_O_ACANA_GCTL2_write_en3_shift                                            (7)
+#define AIO_O_ACANA_GCTL2_write_en3_mask                                             (0x00000080)
+#define AIO_O_ACANA_GCTL2_write_en3(data)                                            (0x00000080&((data)<<7))
+#define AIO_O_ACANA_GCTL2_write_en3_src(data)                                        ((0x00000080&(data))>>7)
+#define AIO_O_ACANA_GCTL2_get_write_en3(data)                                        ((0x00000080&(data))>>7)
+#define AIO_O_ACANA_GCTL2_hpo_engl_shift                                             (6)
+#define AIO_O_ACANA_GCTL2_hpo_engl_mask                                              (0x00000040)
+#define AIO_O_ACANA_GCTL2_hpo_engl(data)                                             (0x00000040&((data)<<6))
+#define AIO_O_ACANA_GCTL2_hpo_engl_src(data)                                         ((0x00000040&(data))>>6)
+#define AIO_O_ACANA_GCTL2_get_hpo_engl(data)                                         ((0x00000040&(data))>>6)
+#define AIO_O_ACANA_GCTL2_write_en2_shift                                            (5)
+#define AIO_O_ACANA_GCTL2_write_en2_mask                                             (0x00000020)
+#define AIO_O_ACANA_GCTL2_write_en2(data)                                            (0x00000020&((data)<<5))
+#define AIO_O_ACANA_GCTL2_write_en2_src(data)                                        ((0x00000020&(data))>>5)
+#define AIO_O_ACANA_GCTL2_get_write_en2(data)                                        ((0x00000020&(data))>>5)
+#define AIO_O_ACANA_GCTL2_isel_vref_shift                                            (3)
+#define AIO_O_ACANA_GCTL2_isel_vref_mask                                             (0x00000018)
+#define AIO_O_ACANA_GCTL2_isel_vref(data)                                            (0x00000018&((data)<<3))
+#define AIO_O_ACANA_GCTL2_isel_vref_src(data)                                        ((0x00000018&(data))>>3)
+#define AIO_O_ACANA_GCTL2_get_isel_vref(data)                                        ((0x00000018&(data))>>3)
+#define AIO_O_ACANA_GCTL2_write_en1_shift                                            (2)
+#define AIO_O_ACANA_GCTL2_write_en1_mask                                             (0x00000004)
+#define AIO_O_ACANA_GCTL2_write_en1(data)                                            (0x00000004&((data)<<2))
+#define AIO_O_ACANA_GCTL2_write_en1_src(data)                                        ((0x00000004&(data))>>2)
+#define AIO_O_ACANA_GCTL2_get_write_en1(data)                                        ((0x00000004&(data))>>2)
+#define AIO_O_ACANA_GCTL2_isel_hpo_shift                                             (0)
+#define AIO_O_ACANA_GCTL2_isel_hpo_mask                                              (0x00000003)
+#define AIO_O_ACANA_GCTL2_isel_hpo(data)                                             (0x00000003&((data)<<0))
+#define AIO_O_ACANA_GCTL2_isel_hpo_src(data)                                         ((0x00000003&(data))>>0)
+#define AIO_O_ACANA_GCTL2_get_isel_hpo(data)                                         ((0x00000003&(data))>>0)
+
+
+#define AIO_I_FIFOCTL0                                                               0x18006080
+#define AIO_I_FIFOCTL0_reg_addr                                                      "0xB8006080"
+#define AIO_I_FIFOCTL0_reg                                                           0xB8006080
+#define set_AIO_I_FIFOCTL0_reg(data)   (*((volatile unsigned int*) AIO_I_FIFOCTL0_reg)=data)
+#define get_AIO_I_FIFOCTL0_reg   (*((volatile unsigned int*) AIO_I_FIFOCTL0_reg))
+#define AIO_I_FIFOCTL0_inst_adr                                                      "0x0020"
+#define AIO_I_FIFOCTL0_inst                                                          0x0020
+#define AIO_I_FIFOCTL0_thd_shift                                                     (1)
+#define AIO_I_FIFOCTL0_thd_mask                                                      (0x0000003E)
+#define AIO_I_FIFOCTL0_thd(data)                                                     (0x0000003E&((data)<<1))
+#define AIO_I_FIFOCTL0_thd_src(data)                                                 ((0x0000003E&(data))>>1)
+#define AIO_I_FIFOCTL0_get_thd(data)                                                 ((0x0000003E&(data))>>1)
+#define AIO_I_FIFOCTL0_en_shift                                                      (0)
+#define AIO_I_FIFOCTL0_en_mask                                                       (0x00000001)
+#define AIO_I_FIFOCTL0_en(data)                                                      (0x00000001&((data)<<0))
+#define AIO_I_FIFOCTL0_en_src(data)                                                  ((0x00000001&(data))>>0)
+#define AIO_I_FIFOCTL0_get_en(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define AIO_O_FIFOCTL                                                                0x18006090
+#define AIO_O_FIFOCTL_reg_addr                                                       "0xB8006090"
+#define AIO_O_FIFOCTL_reg                                                            0xB8006090
+#define set_AIO_O_FIFOCTL_reg(data)   (*((volatile unsigned int*) AIO_O_FIFOCTL_reg)=data)
+#define get_AIO_O_FIFOCTL_reg   (*((volatile unsigned int*) AIO_O_FIFOCTL_reg))
+#define AIO_O_FIFOCTL_inst_adr                                                       "0x0024"
+#define AIO_O_FIFOCTL_inst                                                           0x0024
+#define AIO_O_FIFOCTL_en10_shift                                                     (16)
+#define AIO_O_FIFOCTL_en10_mask                                                      (0x00010000)
+#define AIO_O_FIFOCTL_en10(data)                                                     (0x00010000&((data)<<16))
+#define AIO_O_FIFOCTL_en10_src(data)                                                 ((0x00010000&(data))>>16)
+#define AIO_O_FIFOCTL_get_en10(data)                                                 ((0x00010000&(data))>>16)
+#define AIO_O_FIFOCTL_en9_shift                                                      (15)
+#define AIO_O_FIFOCTL_en9_mask                                                       (0x00008000)
+#define AIO_O_FIFOCTL_en9(data)                                                      (0x00008000&((data)<<15))
+#define AIO_O_FIFOCTL_en9_src(data)                                                  ((0x00008000&(data))>>15)
+#define AIO_O_FIFOCTL_get_en9(data)                                                  ((0x00008000&(data))>>15)
+#define AIO_O_FIFOCTL_en8_shift                                                      (14)
+#define AIO_O_FIFOCTL_en8_mask                                                       (0x00004000)
+#define AIO_O_FIFOCTL_en8(data)                                                      (0x00004000&((data)<<14))
+#define AIO_O_FIFOCTL_en8_src(data)                                                  ((0x00004000&(data))>>14)
+#define AIO_O_FIFOCTL_get_en8(data)                                                  ((0x00004000&(data))>>14)
+#define AIO_O_FIFOCTL_en7_shift                                                      (13)
+#define AIO_O_FIFOCTL_en7_mask                                                       (0x00002000)
+#define AIO_O_FIFOCTL_en7(data)                                                      (0x00002000&((data)<<13))
+#define AIO_O_FIFOCTL_en7_src(data)                                                  ((0x00002000&(data))>>13)
+#define AIO_O_FIFOCTL_get_en7(data)                                                  ((0x00002000&(data))>>13)
+#define AIO_O_FIFOCTL_en6_shift                                                      (12)
+#define AIO_O_FIFOCTL_en6_mask                                                       (0x00001000)
+#define AIO_O_FIFOCTL_en6(data)                                                      (0x00001000&((data)<<12))
+#define AIO_O_FIFOCTL_en6_src(data)                                                  ((0x00001000&(data))>>12)
+#define AIO_O_FIFOCTL_get_en6(data)                                                  ((0x00001000&(data))>>12)
+#define AIO_O_FIFOCTL_emptystopen_shift                                              (11)
+#define AIO_O_FIFOCTL_emptystopen_mask                                               (0x00000800)
+#define AIO_O_FIFOCTL_emptystopen(data)                                              (0x00000800&((data)<<11))
+#define AIO_O_FIFOCTL_emptystopen_src(data)                                          ((0x00000800&(data))>>11)
+#define AIO_O_FIFOCTL_get_emptystopen(data)                                          ((0x00000800&(data))>>11)
+#define AIO_O_FIFOCTL_thd_shift                                                      (6)
+#define AIO_O_FIFOCTL_thd_mask                                                       (0x000007C0)
+#define AIO_O_FIFOCTL_thd(data)                                                      (0x000007C0&((data)<<6))
+#define AIO_O_FIFOCTL_thd_src(data)                                                  ((0x000007C0&(data))>>6)
+#define AIO_O_FIFOCTL_get_thd(data)                                                  ((0x000007C0&(data))>>6)
+#define AIO_O_FIFOCTL_en5_shift                                                      (5)
+#define AIO_O_FIFOCTL_en5_mask                                                       (0x00000020)
+#define AIO_O_FIFOCTL_en5(data)                                                      (0x00000020&((data)<<5))
+#define AIO_O_FIFOCTL_en5_src(data)                                                  ((0x00000020&(data))>>5)
+#define AIO_O_FIFOCTL_get_en5(data)                                                  ((0x00000020&(data))>>5)
+#define AIO_O_FIFOCTL_en4_shift                                                      (4)
+#define AIO_O_FIFOCTL_en4_mask                                                       (0x00000010)
+#define AIO_O_FIFOCTL_en4(data)                                                      (0x00000010&((data)<<4))
+#define AIO_O_FIFOCTL_en4_src(data)                                                  ((0x00000010&(data))>>4)
+#define AIO_O_FIFOCTL_get_en4(data)                                                  ((0x00000010&(data))>>4)
+#define AIO_O_FIFOCTL_en3_shift                                                      (3)
+#define AIO_O_FIFOCTL_en3_mask                                                       (0x00000008)
+#define AIO_O_FIFOCTL_en3(data)                                                      (0x00000008&((data)<<3))
+#define AIO_O_FIFOCTL_en3_src(data)                                                  ((0x00000008&(data))>>3)
+#define AIO_O_FIFOCTL_get_en3(data)                                                  ((0x00000008&(data))>>3)
+#define AIO_O_FIFOCTL_en2_shift                                                      (2)
+#define AIO_O_FIFOCTL_en2_mask                                                       (0x00000004)
+#define AIO_O_FIFOCTL_en2(data)                                                      (0x00000004&((data)<<2))
+#define AIO_O_FIFOCTL_en2_src(data)                                                  ((0x00000004&(data))>>2)
+#define AIO_O_FIFOCTL_get_en2(data)                                                  ((0x00000004&(data))>>2)
+#define AIO_O_FIFOCTL_en1_shift                                                      (1)
+#define AIO_O_FIFOCTL_en1_mask                                                       (0x00000002)
+#define AIO_O_FIFOCTL_en1(data)                                                      (0x00000002&((data)<<1))
+#define AIO_O_FIFOCTL_en1_src(data)                                                  ((0x00000002&(data))>>1)
+#define AIO_O_FIFOCTL_get_en1(data)                                                  ((0x00000002&(data))>>1)
+#define AIO_O_FIFOCTL_en0_shift                                                      (0)
+#define AIO_O_FIFOCTL_en0_mask                                                       (0x00000001)
+#define AIO_O_FIFOCTL_en0(data)                                                      (0x00000001&((data)<<0))
+#define AIO_O_FIFOCTL_en0_src(data)                                                  ((0x00000001&(data))>>0)
+#define AIO_O_FIFOCTL_get_en0(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define AIO_O_I2S_LDATA0                                                             0x18006094
+#define AIO_O_I2S_LDATA0_reg_addr                                                    "0xB8006094"
+#define AIO_O_I2S_LDATA0_reg                                                         0xB8006094
+#define set_AIO_O_I2S_LDATA0_reg(data)   (*((volatile unsigned int*) AIO_O_I2S_LDATA0_reg)=data)
+#define get_AIO_O_I2S_LDATA0_reg   (*((volatile unsigned int*) AIO_O_I2S_LDATA0_reg))
+#define AIO_O_I2S_LDATA0_inst_adr                                                    "0x0025"
+#define AIO_O_I2S_LDATA0_inst                                                        0x0025
+#define AIO_O_I2S_LDATA0_data_shift                                                  (0)
+#define AIO_O_I2S_LDATA0_data_mask                                                   (0xFFFFFFFF)
+#define AIO_O_I2S_LDATA0_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define AIO_O_I2S_LDATA0_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_I2S_LDATA0_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_I2S_RDATA0                                                             0x18006098
+#define AIO_O_I2S_RDATA0_reg_addr                                                    "0xB8006098"
+#define AIO_O_I2S_RDATA0_reg                                                         0xB8006098
+#define set_AIO_O_I2S_RDATA0_reg(data)   (*((volatile unsigned int*) AIO_O_I2S_RDATA0_reg)=data)
+#define get_AIO_O_I2S_RDATA0_reg   (*((volatile unsigned int*) AIO_O_I2S_RDATA0_reg))
+#define AIO_O_I2S_RDATA0_inst_adr                                                    "0x0026"
+#define AIO_O_I2S_RDATA0_inst                                                        0x0026
+#define AIO_O_I2S_RDATA0_data_shift                                                  (0)
+#define AIO_O_I2S_RDATA0_data_mask                                                   (0xFFFFFFFF)
+#define AIO_O_I2S_RDATA0_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define AIO_O_I2S_RDATA0_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_I2S_RDATA0_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_SPF_LDATA                                                              0x180060bc
+#define AIO_O_SPF_LDATA_reg_addr                                                     "0xB80060BC"
+#define AIO_O_SPF_LDATA_reg                                                          0xB80060BC
+#define set_AIO_O_SPF_LDATA_reg(data)   (*((volatile unsigned int*) AIO_O_SPF_LDATA_reg)=data)
+#define get_AIO_O_SPF_LDATA_reg   (*((volatile unsigned int*) AIO_O_SPF_LDATA_reg))
+#define AIO_O_SPF_LDATA_inst_adr                                                     "0x002F"
+#define AIO_O_SPF_LDATA_inst                                                         0x002F
+#define AIO_O_SPF_LDATA_data_shift                                                   (0)
+#define AIO_O_SPF_LDATA_data_mask                                                    (0xFFFFFFFF)
+#define AIO_O_SPF_LDATA_data(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define AIO_O_SPF_LDATA_data_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_SPF_LDATA_get_data(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_SPF_RDATA                                                              0x180060c0
+#define AIO_O_SPF_RDATA_reg_addr                                                     "0xB80060C0"
+#define AIO_O_SPF_RDATA_reg                                                          0xB80060C0
+#define set_AIO_O_SPF_RDATA_reg(data)   (*((volatile unsigned int*) AIO_O_SPF_RDATA_reg)=data)
+#define get_AIO_O_SPF_RDATA_reg   (*((volatile unsigned int*) AIO_O_SPF_RDATA_reg))
+#define AIO_O_SPF_RDATA_inst_adr                                                     "0x0030"
+#define AIO_O_SPF_RDATA_inst                                                         0x0030
+#define AIO_O_SPF_RDATA_data_shift                                                   (0)
+#define AIO_O_SPF_RDATA_data_mask                                                    (0xFFFFFFFF)
+#define AIO_O_SPF_RDATA_data(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define AIO_O_SPF_RDATA_data_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_SPF_RDATA_get_data(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_FIFO_STATUS                                                            0x180060c4
+#define AIO_O_FIFO_STATUS_reg_addr                                                   "0xB80060C4"
+#define AIO_O_FIFO_STATUS_reg                                                        0xB80060C4
+#define set_AIO_O_FIFO_STATUS_reg(data)   (*((volatile unsigned int*) AIO_O_FIFO_STATUS_reg)=data)
+#define get_AIO_O_FIFO_STATUS_reg   (*((volatile unsigned int*) AIO_O_FIFO_STATUS_reg))
+#define AIO_O_FIFO_STATUS_inst_adr                                                   "0x0031"
+#define AIO_O_FIFO_STATUS_inst                                                       0x0031
+#define AIO_O_FIFO_STATUS_empty11_shift                                              (11)
+#define AIO_O_FIFO_STATUS_empty11_mask                                               (0x00000800)
+#define AIO_O_FIFO_STATUS_empty11(data)                                              (0x00000800&((data)<<11))
+#define AIO_O_FIFO_STATUS_empty11_src(data)                                          ((0x00000800&(data))>>11)
+#define AIO_O_FIFO_STATUS_get_empty11(data)                                          ((0x00000800&(data))>>11)
+#define AIO_O_FIFO_STATUS_empty10_shift                                              (10)
+#define AIO_O_FIFO_STATUS_empty10_mask                                               (0x00000400)
+#define AIO_O_FIFO_STATUS_empty10(data)                                              (0x00000400&((data)<<10))
+#define AIO_O_FIFO_STATUS_empty10_src(data)                                          ((0x00000400&(data))>>10)
+#define AIO_O_FIFO_STATUS_get_empty10(data)                                          ((0x00000400&(data))>>10)
+#define AIO_O_FIFO_STATUS_empty9_shift                                               (9)
+#define AIO_O_FIFO_STATUS_empty9_mask                                                (0x00000200)
+#define AIO_O_FIFO_STATUS_empty9(data)                                               (0x00000200&((data)<<9))
+#define AIO_O_FIFO_STATUS_empty9_src(data)                                           ((0x00000200&(data))>>9)
+#define AIO_O_FIFO_STATUS_get_empty9(data)                                           ((0x00000200&(data))>>9)
+#define AIO_O_FIFO_STATUS_empty8_shift                                               (8)
+#define AIO_O_FIFO_STATUS_empty8_mask                                                (0x00000100)
+#define AIO_O_FIFO_STATUS_empty8(data)                                               (0x00000100&((data)<<8))
+#define AIO_O_FIFO_STATUS_empty8_src(data)                                           ((0x00000100&(data))>>8)
+#define AIO_O_FIFO_STATUS_get_empty8(data)                                           ((0x00000100&(data))>>8)
+#define AIO_O_FIFO_STATUS_empty7_shift                                               (7)
+#define AIO_O_FIFO_STATUS_empty7_mask                                                (0x00000080)
+#define AIO_O_FIFO_STATUS_empty7(data)                                               (0x00000080&((data)<<7))
+#define AIO_O_FIFO_STATUS_empty7_src(data)                                           ((0x00000080&(data))>>7)
+#define AIO_O_FIFO_STATUS_get_empty7(data)                                           ((0x00000080&(data))>>7)
+#define AIO_O_FIFO_STATUS_empty6_shift                                               (6)
+#define AIO_O_FIFO_STATUS_empty6_mask                                                (0x00000040)
+#define AIO_O_FIFO_STATUS_empty6(data)                                               (0x00000040&((data)<<6))
+#define AIO_O_FIFO_STATUS_empty6_src(data)                                           ((0x00000040&(data))>>6)
+#define AIO_O_FIFO_STATUS_get_empty6(data)                                           ((0x00000040&(data))>>6)
+#define AIO_O_FIFO_STATUS_empty5_shift                                               (5)
+#define AIO_O_FIFO_STATUS_empty5_mask                                                (0x00000020)
+#define AIO_O_FIFO_STATUS_empty5(data)                                               (0x00000020&((data)<<5))
+#define AIO_O_FIFO_STATUS_empty5_src(data)                                           ((0x00000020&(data))>>5)
+#define AIO_O_FIFO_STATUS_get_empty5(data)                                           ((0x00000020&(data))>>5)
+#define AIO_O_FIFO_STATUS_empty4_shift                                               (4)
+#define AIO_O_FIFO_STATUS_empty4_mask                                                (0x00000010)
+#define AIO_O_FIFO_STATUS_empty4(data)                                               (0x00000010&((data)<<4))
+#define AIO_O_FIFO_STATUS_empty4_src(data)                                           ((0x00000010&(data))>>4)
+#define AIO_O_FIFO_STATUS_get_empty4(data)                                           ((0x00000010&(data))>>4)
+#define AIO_O_FIFO_STATUS_empty3_shift                                               (3)
+#define AIO_O_FIFO_STATUS_empty3_mask                                                (0x00000008)
+#define AIO_O_FIFO_STATUS_empty3(data)                                               (0x00000008&((data)<<3))
+#define AIO_O_FIFO_STATUS_empty3_src(data)                                           ((0x00000008&(data))>>3)
+#define AIO_O_FIFO_STATUS_get_empty3(data)                                           ((0x00000008&(data))>>3)
+#define AIO_O_FIFO_STATUS_empty2_shift                                               (2)
+#define AIO_O_FIFO_STATUS_empty2_mask                                                (0x00000004)
+#define AIO_O_FIFO_STATUS_empty2(data)                                               (0x00000004&((data)<<2))
+#define AIO_O_FIFO_STATUS_empty2_src(data)                                           ((0x00000004&(data))>>2)
+#define AIO_O_FIFO_STATUS_get_empty2(data)                                           ((0x00000004&(data))>>2)
+#define AIO_O_FIFO_STATUS_empty1_shift                                               (1)
+#define AIO_O_FIFO_STATUS_empty1_mask                                                (0x00000002)
+#define AIO_O_FIFO_STATUS_empty1(data)                                               (0x00000002&((data)<<1))
+#define AIO_O_FIFO_STATUS_empty1_src(data)                                           ((0x00000002&(data))>>1)
+#define AIO_O_FIFO_STATUS_get_empty1(data)                                           ((0x00000002&(data))>>1)
+#define AIO_O_FIFO_STATUS_empty0_shift                                               (0)
+#define AIO_O_FIFO_STATUS_empty0_mask                                                (0x00000001)
+#define AIO_O_FIFO_STATUS_empty0(data)                                               (0x00000001&((data)<<0))
+#define AIO_O_FIFO_STATUS_empty0_src(data)                                           ((0x00000001&(data))>>0)
+#define AIO_O_FIFO_STATUS_get_empty0(data)                                           ((0x00000001&(data))>>0)
+
+
+#define AIO_I_SA_0                                                                   0x18006100
+#define AIO_I_SA_1                                                                   0x18006104
+#define AIO_I_SA_0_reg_addr                                                          "0xB8006100"
+#define AIO_I_SA_1_reg_addr                                                          "0xB8006104"
+#define AIO_I_SA_0_reg                                                               0xB8006100
+#define AIO_I_SA_1_reg                                                               0xB8006104
+#define set_AIO_I_SA_0_reg(data)   (*((volatile unsigned int*) AIO_I_SA_0_reg)=data)
+#define set_AIO_I_SA_1_reg(data)   (*((volatile unsigned int*) AIO_I_SA_1_reg)=data)
+#define get_AIO_I_SA_0_reg   (*((volatile unsigned int*) AIO_I_SA_0_reg))
+#define get_AIO_I_SA_1_reg   (*((volatile unsigned int*) AIO_I_SA_1_reg))
+#define AIO_I_SA_0_inst_adr                                                          "0x0040"
+#define AIO_I_SA_1_inst_adr                                                          "0x0041"
+#define AIO_I_SA_0_inst                                                              0x0040
+#define AIO_I_SA_1_inst                                                              0x0041
+#define AIO_I_SA_addr_shift                                                          (3)
+#define AIO_I_SA_addr_mask                                                           (0x7FFFFFF8)
+#define AIO_I_SA_addr(data)                                                          (0x7FFFFFF8&((data)<<3))
+#define AIO_I_SA_addr_src(data)                                                      ((0x7FFFFFF8&(data))>>3)
+#define AIO_I_SA_get_addr(data)                                                      ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_I_EA_0                                                                   0x18006120
+#define AIO_I_EA_1                                                                   0x18006124
+#define AIO_I_EA_0_reg_addr                                                          "0xB8006120"
+#define AIO_I_EA_1_reg_addr                                                          "0xB8006124"
+#define AIO_I_EA_0_reg                                                               0xB8006120
+#define AIO_I_EA_1_reg                                                               0xB8006124
+#define set_AIO_I_EA_0_reg(data)   (*((volatile unsigned int*) AIO_I_EA_0_reg)=data)
+#define set_AIO_I_EA_1_reg(data)   (*((volatile unsigned int*) AIO_I_EA_1_reg)=data)
+#define get_AIO_I_EA_0_reg   (*((volatile unsigned int*) AIO_I_EA_0_reg))
+#define get_AIO_I_EA_1_reg   (*((volatile unsigned int*) AIO_I_EA_1_reg))
+#define AIO_I_EA_0_inst_adr                                                          "0x0048"
+#define AIO_I_EA_1_inst_adr                                                          "0x0049"
+#define AIO_I_EA_0_inst                                                              0x0048
+#define AIO_I_EA_1_inst                                                              0x0049
+#define AIO_I_EA_addr_shift                                                          (3)
+#define AIO_I_EA_addr_mask                                                           (0x7FFFFFF8)
+#define AIO_I_EA_addr(data)                                                          (0x7FFFFFF8&((data)<<3))
+#define AIO_I_EA_addr_src(data)                                                      ((0x7FFFFFF8&(data))>>3)
+#define AIO_I_EA_get_addr(data)                                                      ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_I_RP_0                                                                   0x18006140
+#define AIO_I_RP_1                                                                   0x18006144
+#define AIO_I_RP_0_reg_addr                                                          "0xB8006140"
+#define AIO_I_RP_1_reg_addr                                                          "0xB8006144"
+#define AIO_I_RP_0_reg                                                               0xB8006140
+#define AIO_I_RP_1_reg                                                               0xB8006144
+#define set_AIO_I_RP_0_reg(data)   (*((volatile unsigned int*) AIO_I_RP_0_reg)=data)
+#define set_AIO_I_RP_1_reg(data)   (*((volatile unsigned int*) AIO_I_RP_1_reg)=data)
+#define get_AIO_I_RP_0_reg   (*((volatile unsigned int*) AIO_I_RP_0_reg))
+#define get_AIO_I_RP_1_reg   (*((volatile unsigned int*) AIO_I_RP_1_reg))
+#define AIO_I_RP_0_inst_adr                                                          "0x0050"
+#define AIO_I_RP_1_inst_adr                                                          "0x0051"
+#define AIO_I_RP_0_inst                                                              0x0050
+#define AIO_I_RP_1_inst                                                              0x0051
+#define AIO_I_RP_addr_shift                                                          (3)
+#define AIO_I_RP_addr_mask                                                           (0x7FFFFFF8)
+#define AIO_I_RP_addr(data)                                                          (0x7FFFFFF8&((data)<<3))
+#define AIO_I_RP_addr_src(data)                                                      ((0x7FFFFFF8&(data))>>3)
+#define AIO_I_RP_get_addr(data)                                                      ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_I_WP_0                                                                   0x18006160
+#define AIO_I_WP_1                                                                   0x18006164
+#define AIO_I_WP_0_reg_addr                                                          "0xB8006160"
+#define AIO_I_WP_1_reg_addr                                                          "0xB8006164"
+#define AIO_I_WP_0_reg                                                               0xB8006160
+#define AIO_I_WP_1_reg                                                               0xB8006164
+#define set_AIO_I_WP_0_reg(data)   (*((volatile unsigned int*) AIO_I_WP_0_reg)=data)
+#define set_AIO_I_WP_1_reg(data)   (*((volatile unsigned int*) AIO_I_WP_1_reg)=data)
+#define get_AIO_I_WP_0_reg   (*((volatile unsigned int*) AIO_I_WP_0_reg))
+#define get_AIO_I_WP_1_reg   (*((volatile unsigned int*) AIO_I_WP_1_reg))
+#define AIO_I_WP_0_inst_adr                                                          "0x0058"
+#define AIO_I_WP_1_inst_adr                                                          "0x0059"
+#define AIO_I_WP_0_inst                                                              0x0058
+#define AIO_I_WP_1_inst                                                              0x0059
+#define AIO_I_WP_addr_shift                                                          (3)
+#define AIO_I_WP_addr_mask                                                           (0x7FFFFFF8)
+#define AIO_I_WP_addr(data)                                                          (0x7FFFFFF8&((data)<<3))
+#define AIO_I_WP_addr_src(data)                                                      ((0x7FFFFFF8&(data))>>3)
+#define AIO_I_WP_get_addr(data)                                                      ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_O_SA_0                                                                   0x18006180
+#define AIO_O_SA_1                                                                   0x18006184
+#define AIO_O_SA_2                                                                   0x18006188
+#define AIO_O_SA_3                                                                   0x1800618C
+#define AIO_O_SA_4                                                                   0x18006190
+#define AIO_O_SA_5                                                                   0x18006194
+#define AIO_O_SA_6                                                                   0x18006198
+#define AIO_O_SA_7                                                                   0x1800619C
+#define AIO_O_SA_8                                                                   0x180061A0
+#define AIO_O_SA_9                                                                   0x180061A4
+#define AIO_O_SA_10                                                                   0x180061A8
+#define AIO_O_SA_11                                                                   0x180061AC
+#define AIO_O_SA_0_reg_addr                                                          "0xB8006180"
+#define AIO_O_SA_1_reg_addr                                                          "0xB8006184"
+#define AIO_O_SA_2_reg_addr                                                          "0xB8006188"
+#define AIO_O_SA_3_reg_addr                                                          "0xB800618C"
+#define AIO_O_SA_4_reg_addr                                                          "0xB8006190"
+#define AIO_O_SA_5_reg_addr                                                          "0xB8006194"
+#define AIO_O_SA_6_reg_addr                                                          "0xB8006198"
+#define AIO_O_SA_7_reg_addr                                                          "0xB800619C"
+#define AIO_O_SA_8_reg_addr                                                          "0xB80061A0"
+#define AIO_O_SA_9_reg_addr                                                          "0xB80061A4"
+#define AIO_O_SA_10_reg_addr                                                          "0xB80061A8"
+#define AIO_O_SA_11_reg_addr                                                          "0xB80061AC"
+#define AIO_O_SA_0_reg                                                               0xB8006180
+#define AIO_O_SA_1_reg                                                               0xB8006184
+#define AIO_O_SA_2_reg                                                               0xB8006188
+#define AIO_O_SA_3_reg                                                               0xB800618C
+#define AIO_O_SA_4_reg                                                               0xB8006190
+#define AIO_O_SA_5_reg                                                               0xB8006194
+#define AIO_O_SA_6_reg                                                               0xB8006198
+#define AIO_O_SA_7_reg                                                               0xB800619C
+#define AIO_O_SA_8_reg                                                               0xB80061A0
+#define AIO_O_SA_9_reg                                                               0xB80061A4
+#define AIO_O_SA_10_reg                                                               0xB80061A8
+#define AIO_O_SA_11_reg                                                               0xB80061AC
+#define set_AIO_O_SA_0_reg(data)   (*((volatile unsigned int*) AIO_O_SA_0_reg)=data)
+#define set_AIO_O_SA_1_reg(data)   (*((volatile unsigned int*) AIO_O_SA_1_reg)=data)
+#define set_AIO_O_SA_2_reg(data)   (*((volatile unsigned int*) AIO_O_SA_2_reg)=data)
+#define set_AIO_O_SA_3_reg(data)   (*((volatile unsigned int*) AIO_O_SA_3_reg)=data)
+#define set_AIO_O_SA_4_reg(data)   (*((volatile unsigned int*) AIO_O_SA_4_reg)=data)
+#define set_AIO_O_SA_5_reg(data)   (*((volatile unsigned int*) AIO_O_SA_5_reg)=data)
+#define set_AIO_O_SA_6_reg(data)   (*((volatile unsigned int*) AIO_O_SA_6_reg)=data)
+#define set_AIO_O_SA_7_reg(data)   (*((volatile unsigned int*) AIO_O_SA_7_reg)=data)
+#define set_AIO_O_SA_8_reg(data)   (*((volatile unsigned int*) AIO_O_SA_8_reg)=data)
+#define set_AIO_O_SA_9_reg(data)   (*((volatile unsigned int*) AIO_O_SA_9_reg)=data)
+#define set_AIO_O_SA_10_reg(data)   (*((volatile unsigned int*) AIO_O_SA_10_reg)=data)
+#define set_AIO_O_SA_11_reg(data)   (*((volatile unsigned int*) AIO_O_SA_11_reg)=data)
+#define get_AIO_O_SA_0_reg   (*((volatile unsigned int*) AIO_O_SA_0_reg))
+#define get_AIO_O_SA_1_reg   (*((volatile unsigned int*) AIO_O_SA_1_reg))
+#define get_AIO_O_SA_2_reg   (*((volatile unsigned int*) AIO_O_SA_2_reg))
+#define get_AIO_O_SA_3_reg   (*((volatile unsigned int*) AIO_O_SA_3_reg))
+#define get_AIO_O_SA_4_reg   (*((volatile unsigned int*) AIO_O_SA_4_reg))
+#define get_AIO_O_SA_5_reg   (*((volatile unsigned int*) AIO_O_SA_5_reg))
+#define get_AIO_O_SA_6_reg   (*((volatile unsigned int*) AIO_O_SA_6_reg))
+#define get_AIO_O_SA_7_reg   (*((volatile unsigned int*) AIO_O_SA_7_reg))
+#define get_AIO_O_SA_8_reg   (*((volatile unsigned int*) AIO_O_SA_8_reg))
+#define get_AIO_O_SA_9_reg   (*((volatile unsigned int*) AIO_O_SA_9_reg))
+#define get_AIO_O_SA_10_reg   (*((volatile unsigned int*) AIO_O_SA_10_reg))
+#define get_AIO_O_SA_11_reg   (*((volatile unsigned int*) AIO_O_SA_11_reg))
+#define AIO_O_SA_0_inst_adr                                                          "0x0060"
+#define AIO_O_SA_1_inst_adr                                                          "0x0061"
+#define AIO_O_SA_2_inst_adr                                                          "0x0062"
+#define AIO_O_SA_3_inst_adr                                                          "0x0063"
+#define AIO_O_SA_4_inst_adr                                                          "0x0064"
+#define AIO_O_SA_5_inst_adr                                                          "0x0065"
+#define AIO_O_SA_6_inst_adr                                                          "0x0066"
+#define AIO_O_SA_7_inst_adr                                                          "0x0067"
+#define AIO_O_SA_8_inst_adr                                                          "0x0068"
+#define AIO_O_SA_9_inst_adr                                                          "0x0069"
+#define AIO_O_SA_10_inst_adr                                                          "0x006A"
+#define AIO_O_SA_11_inst_adr                                                          "0x006B"
+#define AIO_O_SA_0_inst                                                              0x0060
+#define AIO_O_SA_1_inst                                                              0x0061
+#define AIO_O_SA_2_inst                                                              0x0062
+#define AIO_O_SA_3_inst                                                              0x0063
+#define AIO_O_SA_4_inst                                                              0x0064
+#define AIO_O_SA_5_inst                                                              0x0065
+#define AIO_O_SA_6_inst                                                              0x0066
+#define AIO_O_SA_7_inst                                                              0x0067
+#define AIO_O_SA_8_inst                                                              0x0068
+#define AIO_O_SA_9_inst                                                              0x0069
+#define AIO_O_SA_10_inst                                                              0x006A
+#define AIO_O_SA_11_inst                                                              0x006B
+#define AIO_O_SA_addr_shift                                                          (3)
+#define AIO_O_SA_addr_mask                                                           (0x7FFFFFF8)
+#define AIO_O_SA_addr(data)                                                          (0x7FFFFFF8&((data)<<3))
+#define AIO_O_SA_addr_src(data)                                                      ((0x7FFFFFF8&(data))>>3)
+#define AIO_O_SA_get_addr(data)                                                      ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_O_EA_0                                                                   0x180061B0
+#define AIO_O_EA_1                                                                   0x180061B4
+#define AIO_O_EA_2                                                                   0x180061B8
+#define AIO_O_EA_3                                                                   0x180061BC
+#define AIO_O_EA_4                                                                   0x180061C0
+#define AIO_O_EA_5                                                                   0x180061C4
+#define AIO_O_EA_6                                                                   0x180061C8
+#define AIO_O_EA_7                                                                   0x180061CC
+#define AIO_O_EA_8                                                                   0x180061D0
+#define AIO_O_EA_9                                                                   0x180061D4
+#define AIO_O_EA_10                                                                   0x180061D8
+#define AIO_O_EA_11                                                                   0x180061DC
+#define AIO_O_EA_0_reg_addr                                                          "0xB80061B0"
+#define AIO_O_EA_1_reg_addr                                                          "0xB80061B4"
+#define AIO_O_EA_2_reg_addr                                                          "0xB80061B8"
+#define AIO_O_EA_3_reg_addr                                                          "0xB80061BC"
+#define AIO_O_EA_4_reg_addr                                                          "0xB80061C0"
+#define AIO_O_EA_5_reg_addr                                                          "0xB80061C4"
+#define AIO_O_EA_6_reg_addr                                                          "0xB80061C8"
+#define AIO_O_EA_7_reg_addr                                                          "0xB80061CC"
+#define AIO_O_EA_8_reg_addr                                                          "0xB80061D0"
+#define AIO_O_EA_9_reg_addr                                                          "0xB80061D4"
+#define AIO_O_EA_10_reg_addr                                                          "0xB80061D8"
+#define AIO_O_EA_11_reg_addr                                                          "0xB80061DC"
+#define AIO_O_EA_0_reg                                                               0xB80061B0
+#define AIO_O_EA_1_reg                                                               0xB80061B4
+#define AIO_O_EA_2_reg                                                               0xB80061B8
+#define AIO_O_EA_3_reg                                                               0xB80061BC
+#define AIO_O_EA_4_reg                                                               0xB80061C0
+#define AIO_O_EA_5_reg                                                               0xB80061C4
+#define AIO_O_EA_6_reg                                                               0xB80061C8
+#define AIO_O_EA_7_reg                                                               0xB80061CC
+#define AIO_O_EA_8_reg                                                               0xB80061D0
+#define AIO_O_EA_9_reg                                                               0xB80061D4
+#define AIO_O_EA_10_reg                                                               0xB80061D8
+#define AIO_O_EA_11_reg                                                               0xB80061DC
+#define set_AIO_O_EA_0_reg(data)   (*((volatile unsigned int*) AIO_O_EA_0_reg)=data)
+#define set_AIO_O_EA_1_reg(data)   (*((volatile unsigned int*) AIO_O_EA_1_reg)=data)
+#define set_AIO_O_EA_2_reg(data)   (*((volatile unsigned int*) AIO_O_EA_2_reg)=data)
+#define set_AIO_O_EA_3_reg(data)   (*((volatile unsigned int*) AIO_O_EA_3_reg)=data)
+#define set_AIO_O_EA_4_reg(data)   (*((volatile unsigned int*) AIO_O_EA_4_reg)=data)
+#define set_AIO_O_EA_5_reg(data)   (*((volatile unsigned int*) AIO_O_EA_5_reg)=data)
+#define set_AIO_O_EA_6_reg(data)   (*((volatile unsigned int*) AIO_O_EA_6_reg)=data)
+#define set_AIO_O_EA_7_reg(data)   (*((volatile unsigned int*) AIO_O_EA_7_reg)=data)
+#define set_AIO_O_EA_8_reg(data)   (*((volatile unsigned int*) AIO_O_EA_8_reg)=data)
+#define set_AIO_O_EA_9_reg(data)   (*((volatile unsigned int*) AIO_O_EA_9_reg)=data)
+#define set_AIO_O_EA_10_reg(data)   (*((volatile unsigned int*) AIO_O_EA_10_reg)=data)
+#define set_AIO_O_EA_11_reg(data)   (*((volatile unsigned int*) AIO_O_EA_11_reg)=data)
+#define get_AIO_O_EA_0_reg   (*((volatile unsigned int*) AIO_O_EA_0_reg))
+#define get_AIO_O_EA_1_reg   (*((volatile unsigned int*) AIO_O_EA_1_reg))
+#define get_AIO_O_EA_2_reg   (*((volatile unsigned int*) AIO_O_EA_2_reg))
+#define get_AIO_O_EA_3_reg   (*((volatile unsigned int*) AIO_O_EA_3_reg))
+#define get_AIO_O_EA_4_reg   (*((volatile unsigned int*) AIO_O_EA_4_reg))
+#define get_AIO_O_EA_5_reg   (*((volatile unsigned int*) AIO_O_EA_5_reg))
+#define get_AIO_O_EA_6_reg   (*((volatile unsigned int*) AIO_O_EA_6_reg))
+#define get_AIO_O_EA_7_reg   (*((volatile unsigned int*) AIO_O_EA_7_reg))
+#define get_AIO_O_EA_8_reg   (*((volatile unsigned int*) AIO_O_EA_8_reg))
+#define get_AIO_O_EA_9_reg   (*((volatile unsigned int*) AIO_O_EA_9_reg))
+#define get_AIO_O_EA_10_reg   (*((volatile unsigned int*) AIO_O_EA_10_reg))
+#define get_AIO_O_EA_11_reg   (*((volatile unsigned int*) AIO_O_EA_11_reg))
+#define AIO_O_EA_0_inst_adr                                                          "0x006C"
+#define AIO_O_EA_1_inst_adr                                                          "0x006D"
+#define AIO_O_EA_2_inst_adr                                                          "0x006E"
+#define AIO_O_EA_3_inst_adr                                                          "0x006F"
+#define AIO_O_EA_4_inst_adr                                                          "0x0070"
+#define AIO_O_EA_5_inst_adr                                                          "0x0071"
+#define AIO_O_EA_6_inst_adr                                                          "0x0072"
+#define AIO_O_EA_7_inst_adr                                                          "0x0073"
+#define AIO_O_EA_8_inst_adr                                                          "0x0074"
+#define AIO_O_EA_9_inst_adr                                                          "0x0075"
+#define AIO_O_EA_10_inst_adr                                                          "0x0076"
+#define AIO_O_EA_11_inst_adr                                                          "0x0077"
+#define AIO_O_EA_0_inst                                                              0x006C
+#define AIO_O_EA_1_inst                                                              0x006D
+#define AIO_O_EA_2_inst                                                              0x006E
+#define AIO_O_EA_3_inst                                                              0x006F
+#define AIO_O_EA_4_inst                                                              0x0070
+#define AIO_O_EA_5_inst                                                              0x0071
+#define AIO_O_EA_6_inst                                                              0x0072
+#define AIO_O_EA_7_inst                                                              0x0073
+#define AIO_O_EA_8_inst                                                              0x0074
+#define AIO_O_EA_9_inst                                                              0x0075
+#define AIO_O_EA_10_inst                                                              0x0076
+#define AIO_O_EA_11_inst                                                              0x0077
+#define AIO_O_EA_addr_shift                                                          (3)
+#define AIO_O_EA_addr_mask                                                           (0x7FFFFFF8)
+#define AIO_O_EA_addr(data)                                                          (0x7FFFFFF8&((data)<<3))
+#define AIO_O_EA_addr_src(data)                                                      ((0x7FFFFFF8&(data))>>3)
+#define AIO_O_EA_get_addr(data)                                                      ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_O_RP_0                                                                   0x180061E0
+#define AIO_O_RP_1                                                                   0x180061E4
+#define AIO_O_RP_2                                                                   0x180061E8
+#define AIO_O_RP_3                                                                   0x180061EC
+#define AIO_O_RP_4                                                                   0x180061F0
+#define AIO_O_RP_5                                                                   0x180061F4
+#define AIO_O_RP_6                                                                   0x180061F8
+#define AIO_O_RP_7                                                                   0x180061FC
+#define AIO_O_RP_8                                                                   0x18006200
+#define AIO_O_RP_9                                                                   0x18006204
+#define AIO_O_RP_10                                                                   0x18006208
+#define AIO_O_RP_11                                                                   0x1800620C
+#define AIO_O_RP_0_reg_addr                                                          "0xB80061E0"
+#define AIO_O_RP_1_reg_addr                                                          "0xB80061E4"
+#define AIO_O_RP_2_reg_addr                                                          "0xB80061E8"
+#define AIO_O_RP_3_reg_addr                                                          "0xB80061EC"
+#define AIO_O_RP_4_reg_addr                                                          "0xB80061F0"
+#define AIO_O_RP_5_reg_addr                                                          "0xB80061F4"
+#define AIO_O_RP_6_reg_addr                                                          "0xB80061F8"
+#define AIO_O_RP_7_reg_addr                                                          "0xB80061FC"
+#define AIO_O_RP_8_reg_addr                                                          "0xB8006200"
+#define AIO_O_RP_9_reg_addr                                                          "0xB8006204"
+#define AIO_O_RP_10_reg_addr                                                          "0xB8006208"
+#define AIO_O_RP_11_reg_addr                                                          "0xB800620C"
+#define AIO_O_RP_0_reg                                                               0xB80061E0
+#define AIO_O_RP_1_reg                                                               0xB80061E4
+#define AIO_O_RP_2_reg                                                               0xB80061E8
+#define AIO_O_RP_3_reg                                                               0xB80061EC
+#define AIO_O_RP_4_reg                                                               0xB80061F0
+#define AIO_O_RP_5_reg                                                               0xB80061F4
+#define AIO_O_RP_6_reg                                                               0xB80061F8
+#define AIO_O_RP_7_reg                                                               0xB80061FC
+#define AIO_O_RP_8_reg                                                               0xB8006200
+#define AIO_O_RP_9_reg                                                               0xB8006204
+#define AIO_O_RP_10_reg                                                               0xB8006208
+#define AIO_O_RP_11_reg                                                               0xB800620C
+#define set_AIO_O_RP_0_reg(data)   (*((volatile unsigned int*) AIO_O_RP_0_reg)=data)
+#define set_AIO_O_RP_1_reg(data)   (*((volatile unsigned int*) AIO_O_RP_1_reg)=data)
+#define set_AIO_O_RP_2_reg(data)   (*((volatile unsigned int*) AIO_O_RP_2_reg)=data)
+#define set_AIO_O_RP_3_reg(data)   (*((volatile unsigned int*) AIO_O_RP_3_reg)=data)
+#define set_AIO_O_RP_4_reg(data)   (*((volatile unsigned int*) AIO_O_RP_4_reg)=data)
+#define set_AIO_O_RP_5_reg(data)   (*((volatile unsigned int*) AIO_O_RP_5_reg)=data)
+#define set_AIO_O_RP_6_reg(data)   (*((volatile unsigned int*) AIO_O_RP_6_reg)=data)
+#define set_AIO_O_RP_7_reg(data)   (*((volatile unsigned int*) AIO_O_RP_7_reg)=data)
+#define set_AIO_O_RP_8_reg(data)   (*((volatile unsigned int*) AIO_O_RP_8_reg)=data)
+#define set_AIO_O_RP_9_reg(data)   (*((volatile unsigned int*) AIO_O_RP_9_reg)=data)
+#define set_AIO_O_RP_10_reg(data)   (*((volatile unsigned int*) AIO_O_RP_10_reg)=data)
+#define set_AIO_O_RP_11_reg(data)   (*((volatile unsigned int*) AIO_O_RP_11_reg)=data)
+#define get_AIO_O_RP_0_reg   (*((volatile unsigned int*) AIO_O_RP_0_reg))
+#define get_AIO_O_RP_1_reg   (*((volatile unsigned int*) AIO_O_RP_1_reg))
+#define get_AIO_O_RP_2_reg   (*((volatile unsigned int*) AIO_O_RP_2_reg))
+#define get_AIO_O_RP_3_reg   (*((volatile unsigned int*) AIO_O_RP_3_reg))
+#define get_AIO_O_RP_4_reg   (*((volatile unsigned int*) AIO_O_RP_4_reg))
+#define get_AIO_O_RP_5_reg   (*((volatile unsigned int*) AIO_O_RP_5_reg))
+#define get_AIO_O_RP_6_reg   (*((volatile unsigned int*) AIO_O_RP_6_reg))
+#define get_AIO_O_RP_7_reg   (*((volatile unsigned int*) AIO_O_RP_7_reg))
+#define get_AIO_O_RP_8_reg   (*((volatile unsigned int*) AIO_O_RP_8_reg))
+#define get_AIO_O_RP_9_reg   (*((volatile unsigned int*) AIO_O_RP_9_reg))
+#define get_AIO_O_RP_10_reg   (*((volatile unsigned int*) AIO_O_RP_10_reg))
+#define get_AIO_O_RP_11_reg   (*((volatile unsigned int*) AIO_O_RP_11_reg))
+#define AIO_O_RP_0_inst_adr                                                          "0x0078"
+#define AIO_O_RP_1_inst_adr                                                          "0x0079"
+#define AIO_O_RP_2_inst_adr                                                          "0x007A"
+#define AIO_O_RP_3_inst_adr                                                          "0x007B"
+#define AIO_O_RP_4_inst_adr                                                          "0x007C"
+#define AIO_O_RP_5_inst_adr                                                          "0x007D"
+#define AIO_O_RP_6_inst_adr                                                          "0x007E"
+#define AIO_O_RP_7_inst_adr                                                          "0x007F"
+#define AIO_O_RP_8_inst_adr                                                          "0x0080"
+#define AIO_O_RP_9_inst_adr                                                          "0x0081"
+#define AIO_O_RP_10_inst_adr                                                          "0x0082"
+#define AIO_O_RP_11_inst_adr                                                          "0x0083"
+#define AIO_O_RP_0_inst                                                              0x0078
+#define AIO_O_RP_1_inst                                                              0x0079
+#define AIO_O_RP_2_inst                                                              0x007A
+#define AIO_O_RP_3_inst                                                              0x007B
+#define AIO_O_RP_4_inst                                                              0x007C
+#define AIO_O_RP_5_inst                                                              0x007D
+#define AIO_O_RP_6_inst                                                              0x007E
+#define AIO_O_RP_7_inst                                                              0x007F
+#define AIO_O_RP_8_inst                                                              0x0080
+#define AIO_O_RP_9_inst                                                              0x0081
+#define AIO_O_RP_10_inst                                                              0x0082
+#define AIO_O_RP_11_inst                                                              0x0083
+#define AIO_O_RP_addr_shift                                                          (3)
+#define AIO_O_RP_addr_mask                                                           (0x7FFFFFF8)
+#define AIO_O_RP_addr(data)                                                          (0x7FFFFFF8&((data)<<3))
+#define AIO_O_RP_addr_src(data)                                                      ((0x7FFFFFF8&(data))>>3)
+#define AIO_O_RP_get_addr(data)                                                      ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_O_WP_0                                                                   0x18006220
+#define AIO_O_WP_1                                                                   0x18006224
+#define AIO_O_WP_2                                                                   0x18006228
+#define AIO_O_WP_3                                                                   0x1800622C
+#define AIO_O_WP_4                                                                   0x18006230
+#define AIO_O_WP_5                                                                   0x18006234
+#define AIO_O_WP_6                                                                   0x18006238
+#define AIO_O_WP_7                                                                   0x1800623C
+#define AIO_O_WP_8                                                                   0x18006240
+#define AIO_O_WP_9                                                                   0x18006244
+#define AIO_O_WP_10                                                                   0x18006248
+#define AIO_O_WP_11                                                                   0x1800624C
+#define AIO_O_WP_0_reg_addr                                                          "0xB8006220"
+#define AIO_O_WP_1_reg_addr                                                          "0xB8006224"
+#define AIO_O_WP_2_reg_addr                                                          "0xB8006228"
+#define AIO_O_WP_3_reg_addr                                                          "0xB800622C"
+#define AIO_O_WP_4_reg_addr                                                          "0xB8006230"
+#define AIO_O_WP_5_reg_addr                                                          "0xB8006234"
+#define AIO_O_WP_6_reg_addr                                                          "0xB8006238"
+#define AIO_O_WP_7_reg_addr                                                          "0xB800623C"
+#define AIO_O_WP_8_reg_addr                                                          "0xB8006240"
+#define AIO_O_WP_9_reg_addr                                                          "0xB8006244"
+#define AIO_O_WP_10_reg_addr                                                          "0xB8006248"
+#define AIO_O_WP_11_reg_addr                                                          "0xB800624C"
+#define AIO_O_WP_0_reg                                                               0xB8006220
+#define AIO_O_WP_1_reg                                                               0xB8006224
+#define AIO_O_WP_2_reg                                                               0xB8006228
+#define AIO_O_WP_3_reg                                                               0xB800622C
+#define AIO_O_WP_4_reg                                                               0xB8006230
+#define AIO_O_WP_5_reg                                                               0xB8006234
+#define AIO_O_WP_6_reg                                                               0xB8006238
+#define AIO_O_WP_7_reg                                                               0xB800623C
+#define AIO_O_WP_8_reg                                                               0xB8006240
+#define AIO_O_WP_9_reg                                                               0xB8006244
+#define AIO_O_WP_10_reg                                                               0xB8006248
+#define AIO_O_WP_11_reg                                                               0xB800624C
+#define set_AIO_O_WP_0_reg(data)   (*((volatile unsigned int*) AIO_O_WP_0_reg)=data)
+#define set_AIO_O_WP_1_reg(data)   (*((volatile unsigned int*) AIO_O_WP_1_reg)=data)
+#define set_AIO_O_WP_2_reg(data)   (*((volatile unsigned int*) AIO_O_WP_2_reg)=data)
+#define set_AIO_O_WP_3_reg(data)   (*((volatile unsigned int*) AIO_O_WP_3_reg)=data)
+#define set_AIO_O_WP_4_reg(data)   (*((volatile unsigned int*) AIO_O_WP_4_reg)=data)
+#define set_AIO_O_WP_5_reg(data)   (*((volatile unsigned int*) AIO_O_WP_5_reg)=data)
+#define set_AIO_O_WP_6_reg(data)   (*((volatile unsigned int*) AIO_O_WP_6_reg)=data)
+#define set_AIO_O_WP_7_reg(data)   (*((volatile unsigned int*) AIO_O_WP_7_reg)=data)
+#define set_AIO_O_WP_8_reg(data)   (*((volatile unsigned int*) AIO_O_WP_8_reg)=data)
+#define set_AIO_O_WP_9_reg(data)   (*((volatile unsigned int*) AIO_O_WP_9_reg)=data)
+#define set_AIO_O_WP_10_reg(data)   (*((volatile unsigned int*) AIO_O_WP_10_reg)=data)
+#define set_AIO_O_WP_11_reg(data)   (*((volatile unsigned int*) AIO_O_WP_11_reg)=data)
+#define get_AIO_O_WP_0_reg   (*((volatile unsigned int*) AIO_O_WP_0_reg))
+#define get_AIO_O_WP_1_reg   (*((volatile unsigned int*) AIO_O_WP_1_reg))
+#define get_AIO_O_WP_2_reg   (*((volatile unsigned int*) AIO_O_WP_2_reg))
+#define get_AIO_O_WP_3_reg   (*((volatile unsigned int*) AIO_O_WP_3_reg))
+#define get_AIO_O_WP_4_reg   (*((volatile unsigned int*) AIO_O_WP_4_reg))
+#define get_AIO_O_WP_5_reg   (*((volatile unsigned int*) AIO_O_WP_5_reg))
+#define get_AIO_O_WP_6_reg   (*((volatile unsigned int*) AIO_O_WP_6_reg))
+#define get_AIO_O_WP_7_reg   (*((volatile unsigned int*) AIO_O_WP_7_reg))
+#define get_AIO_O_WP_8_reg   (*((volatile unsigned int*) AIO_O_WP_8_reg))
+#define get_AIO_O_WP_9_reg   (*((volatile unsigned int*) AIO_O_WP_9_reg))
+#define get_AIO_O_WP_10_reg   (*((volatile unsigned int*) AIO_O_WP_10_reg))
+#define get_AIO_O_WP_11_reg   (*((volatile unsigned int*) AIO_O_WP_11_reg))
+#define AIO_O_WP_0_inst_adr                                                          "0x0088"
+#define AIO_O_WP_1_inst_adr                                                          "0x0089"
+#define AIO_O_WP_2_inst_adr                                                          "0x008A"
+#define AIO_O_WP_3_inst_adr                                                          "0x008B"
+#define AIO_O_WP_4_inst_adr                                                          "0x008C"
+#define AIO_O_WP_5_inst_adr                                                          "0x008D"
+#define AIO_O_WP_6_inst_adr                                                          "0x008E"
+#define AIO_O_WP_7_inst_adr                                                          "0x008F"
+#define AIO_O_WP_8_inst_adr                                                          "0x0090"
+#define AIO_O_WP_9_inst_adr                                                          "0x0091"
+#define AIO_O_WP_10_inst_adr                                                          "0x0092"
+#define AIO_O_WP_11_inst_adr                                                          "0x0093"
+#define AIO_O_WP_0_inst                                                              0x0088
+#define AIO_O_WP_1_inst                                                              0x0089
+#define AIO_O_WP_2_inst                                                              0x008A
+#define AIO_O_WP_3_inst                                                              0x008B
+#define AIO_O_WP_4_inst                                                              0x008C
+#define AIO_O_WP_5_inst                                                              0x008D
+#define AIO_O_WP_6_inst                                                              0x008E
+#define AIO_O_WP_7_inst                                                              0x008F
+#define AIO_O_WP_8_inst                                                              0x0090
+#define AIO_O_WP_9_inst                                                              0x0091
+#define AIO_O_WP_10_inst                                                              0x0092
+#define AIO_O_WP_11_inst                                                              0x0093
+#define AIO_O_WP_addr_shift                                                          (3)
+#define AIO_O_WP_addr_mask                                                           (0x7FFFFFF8)
+#define AIO_O_WP_addr(data)                                                          (0x7FFFFFF8&((data)<<3))
+#define AIO_O_WP_addr_src(data)                                                      ((0x7FFFFFF8&(data))>>3)
+#define AIO_O_WP_get_addr(data)                                                      ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_O_DMA_STATUS                                                             0x18006250
+#define AIO_O_DMA_STATUS_reg_addr                                                    "0xB8006250"
+#define AIO_O_DMA_STATUS_reg                                                         0xB8006250
+#define set_AIO_O_DMA_STATUS_reg(data)   (*((volatile unsigned int*) AIO_O_DMA_STATUS_reg)=data)
+#define get_AIO_O_DMA_STATUS_reg   (*((volatile unsigned int*) AIO_O_DMA_STATUS_reg))
+#define AIO_O_DMA_STATUS_inst_adr                                                    "0x0094"
+#define AIO_O_DMA_STATUS_inst                                                        0x0094
+#define AIO_O_DMA_STATUS_dmago_shift                                                 (0)
+#define AIO_O_DMA_STATUS_dmago_mask                                                  (0x00000001)
+#define AIO_O_DMA_STATUS_dmago(data)                                                 (0x00000001&((data)<<0))
+#define AIO_O_DMA_STATUS_dmago_src(data)                                             ((0x00000001&(data))>>0)
+#define AIO_O_DMA_STATUS_get_dmago(data)                                             ((0x00000001&(data))>>0)
+
+
+#define AIO_I_GO                                                                     0x18006300
+#define AIO_I_GO_reg_addr                                                            "0xB8006300"
+#define AIO_I_GO_reg                                                                 0xB8006300
+#define set_AIO_I_GO_reg(data)   (*((volatile unsigned int*) AIO_I_GO_reg)=data)
+#define get_AIO_I_GO_reg   (*((volatile unsigned int*) AIO_I_GO_reg))
+#define AIO_I_GO_inst_adr                                                            "0x00C0"
+#define AIO_I_GO_inst                                                                0x00C0
+#define AIO_I_GO_go0_shift                                                           (1)
+#define AIO_I_GO_go0_mask                                                            (0x00000002)
+#define AIO_I_GO_go0(data)                                                           (0x00000002&((data)<<1))
+#define AIO_I_GO_go0_src(data)                                                       ((0x00000002&(data))>>1)
+#define AIO_I_GO_get_go0(data)                                                       ((0x00000002&(data))>>1)
+
+
+#define AIO_O_GO                                                                     0x18006304
+#define AIO_O_GO_reg_addr                                                            "0xB8006304"
+#define AIO_O_GO_reg                                                                 0xB8006304
+#define set_AIO_O_GO_reg(data)   (*((volatile unsigned int*) AIO_O_GO_reg)=data)
+#define get_AIO_O_GO_reg   (*((volatile unsigned int*) AIO_O_GO_reg))
+#define AIO_O_GO_inst_adr                                                            "0x00C1"
+#define AIO_O_GO_inst                                                                0x00C1
+#define AIO_O_GO_goacdac_shift                                                       (3)
+#define AIO_O_GO_goacdac_mask                                                        (0x00000008)
+#define AIO_O_GO_goacdac(data)                                                       (0x00000008&((data)<<3))
+#define AIO_O_GO_goacdac_src(data)                                                   ((0x00000008&(data))>>3)
+#define AIO_O_GO_get_goacdac(data)                                                   ((0x00000008&(data))>>3)
+#define AIO_O_GO_gohdmi_shift                                                        (2)
+#define AIO_O_GO_gohdmi_mask                                                         (0x00000004)
+#define AIO_O_GO_gohdmi(data)                                                        (0x00000004&((data)<<2))
+#define AIO_O_GO_gohdmi_src(data)                                                    ((0x00000004&(data))>>2)
+#define AIO_O_GO_get_gohdmi(data)                                                    ((0x00000004&(data))>>2)
+#define AIO_O_GO_goi2s_shift                                                         (1)
+#define AIO_O_GO_goi2s_mask                                                          (0x00000002)
+#define AIO_O_GO_goi2s(data)                                                         (0x00000002&((data)<<1))
+#define AIO_O_GO_goi2s_src(data)                                                     ((0x00000002&(data))>>1)
+#define AIO_O_GO_get_goi2s(data)                                                     ((0x00000002&(data))>>1)
+#define AIO_O_GO_gospf_shift                                                         (0)
+#define AIO_O_GO_gospf_mask                                                          (0x00000001)
+#define AIO_O_GO_gospf(data)                                                         (0x00000001&((data)<<0))
+#define AIO_O_GO_gospf_src(data)                                                     ((0x00000001&(data))>>0)
+#define AIO_O_GO_get_gospf(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define AIO_I_PAUSE                                                                  0x18006308
+#define AIO_I_PAUSE_reg_addr                                                         "0xB8006308"
+#define AIO_I_PAUSE_reg                                                              0xB8006308
+#define set_AIO_I_PAUSE_reg(data)   (*((volatile unsigned int*) AIO_I_PAUSE_reg)=data)
+#define get_AIO_I_PAUSE_reg   (*((volatile unsigned int*) AIO_I_PAUSE_reg))
+#define AIO_I_PAUSE_inst_adr                                                         "0x00C2"
+#define AIO_I_PAUSE_inst                                                             0x00C2
+#define AIO_I_PAUSE_pause0_shift                                                     (0)
+#define AIO_I_PAUSE_pause0_mask                                                      (0x00000001)
+#define AIO_I_PAUSE_pause0(data)                                                     (0x00000001&((data)<<0))
+#define AIO_I_PAUSE_pause0_src(data)                                                 ((0x00000001&(data))>>0)
+#define AIO_I_PAUSE_get_pause0(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define AIO_O_PAUSE                                                                  0x1800630c
+#define AIO_O_PAUSE_reg_addr                                                         "0xB800630C"
+#define AIO_O_PAUSE_reg                                                              0xB800630C
+#define set_AIO_O_PAUSE_reg(data)   (*((volatile unsigned int*) AIO_O_PAUSE_reg)=data)
+#define get_AIO_O_PAUSE_reg   (*((volatile unsigned int*) AIO_O_PAUSE_reg))
+#define AIO_O_PAUSE_inst_adr                                                         "0x00C3"
+#define AIO_O_PAUSE_inst                                                             0x00C3
+#define AIO_O_PAUSE_pause2_shift                                                     (2)
+#define AIO_O_PAUSE_pause2_mask                                                      (0x00000004)
+#define AIO_O_PAUSE_pause2(data)                                                     (0x00000004&((data)<<2))
+#define AIO_O_PAUSE_pause2_src(data)                                                 ((0x00000004&(data))>>2)
+#define AIO_O_PAUSE_get_pause2(data)                                                 ((0x00000004&(data))>>2)
+#define AIO_O_PAUSE_pause1_shift                                                     (1)
+#define AIO_O_PAUSE_pause1_mask                                                      (0x00000002)
+#define AIO_O_PAUSE_pause1(data)                                                     (0x00000002&((data)<<1))
+#define AIO_O_PAUSE_pause1_src(data)                                                 ((0x00000002&(data))>>1)
+#define AIO_O_PAUSE_get_pause1(data)                                                 ((0x00000002&(data))>>1)
+#define AIO_O_PAUSE_pause0_shift                                                     (0)
+#define AIO_O_PAUSE_pause0_mask                                                      (0x00000001)
+#define AIO_O_PAUSE_pause0(data)                                                     (0x00000001&((data)<<0))
+#define AIO_O_PAUSE_pause0_src(data)                                                 ((0x00000001&(data))>>0)
+#define AIO_O_PAUSE_get_pause0(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define AIO_I_I2S_DDRTHD                                                             0x18006310
+#define AIO_I_I2S_DDRTHD_reg_addr                                                    "0xB8006310"
+#define AIO_I_I2S_DDRTHD_reg                                                         0xB8006310
+#define set_AIO_I_I2S_DDRTHD_reg(data)   (*((volatile unsigned int*) AIO_I_I2S_DDRTHD_reg)=data)
+#define get_AIO_I_I2S_DDRTHD_reg   (*((volatile unsigned int*) AIO_I_I2S_DDRTHD_reg))
+#define AIO_I_I2S_DDRTHD_inst_adr                                                    "0x00C4"
+#define AIO_I_I2S_DDRTHD_inst                                                        0x00C4
+#define AIO_I_I2S_DDRTHD_thd_shift                                                   (3)
+#define AIO_I_I2S_DDRTHD_thd_mask                                                    (0x7FFFFFF8)
+#define AIO_I_I2S_DDRTHD_thd(data)                                                   (0x7FFFFFF8&((data)<<3))
+#define AIO_I_I2S_DDRTHD_thd_src(data)                                               ((0x7FFFFFF8&(data))>>3)
+#define AIO_I_I2S_DDRTHD_get_thd(data)                                               ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_I_I2S_TIMCNT                                                             0x18006318
+#define AIO_I_I2S_TIMCNT_reg_addr                                                    "0xB8006318"
+#define AIO_I_I2S_TIMCNT_reg                                                         0xB8006318
+#define set_AIO_I_I2S_TIMCNT_reg(data)   (*((volatile unsigned int*) AIO_I_I2S_TIMCNT_reg)=data)
+#define get_AIO_I_I2S_TIMCNT_reg   (*((volatile unsigned int*) AIO_I_I2S_TIMCNT_reg))
+#define AIO_I_I2S_TIMCNT_inst_adr                                                    "0x00C6"
+#define AIO_I_I2S_TIMCNT_inst                                                        0x00C6
+#define AIO_I_I2S_TIMCNT_count_shift                                                 (0)
+#define AIO_I_I2S_TIMCNT_count_mask                                                  (0xFFFFFFFF)
+#define AIO_I_I2S_TIMCNT_count(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define AIO_I_I2S_TIMCNT_count_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define AIO_I_I2S_TIMCNT_get_count(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_I_I2S_TIMTHD                                                             0x18006320
+#define AIO_I_I2S_TIMTHD_reg_addr                                                    "0xB8006320"
+#define AIO_I_I2S_TIMTHD_reg                                                         0xB8006320
+#define set_AIO_I_I2S_TIMTHD_reg(data)   (*((volatile unsigned int*) AIO_I_I2S_TIMTHD_reg)=data)
+#define get_AIO_I_I2S_TIMTHD_reg   (*((volatile unsigned int*) AIO_I_I2S_TIMTHD_reg))
+#define AIO_I_I2S_TIMTHD_inst_adr                                                    "0x00C8"
+#define AIO_I_I2S_TIMTHD_inst                                                        0x00C8
+#define AIO_I_I2S_TIMTHD_thd_shift                                                   (0)
+#define AIO_I_I2S_TIMTHD_thd_mask                                                    (0xFFFFFFFF)
+#define AIO_I_I2S_TIMTHD_thd(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define AIO_I_I2S_TIMTHD_thd_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define AIO_I_I2S_TIMTHD_get_thd(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_I_INTE                                                                   0x18006330
+#define AIO_I_INTE_reg_addr                                                          "0xB8006330"
+#define AIO_I_INTE_reg                                                               0xB8006330
+#define set_AIO_I_INTE_reg(data)   (*((volatile unsigned int*) AIO_I_INTE_reg)=data)
+#define get_AIO_I_INTE_reg   (*((volatile unsigned int*) AIO_I_INTE_reg))
+#define AIO_I_INTE_inst_adr                                                          "0x00CC"
+#define AIO_I_INTE_inst                                                              0x00CC
+#define AIO_I_INTE_timi2sinte_shift                                                  (25)
+#define AIO_I_INTE_timi2sinte_mask                                                   (0x02000000)
+#define AIO_I_INTE_timi2sinte(data)                                                  (0x02000000&((data)<<25))
+#define AIO_I_INTE_timi2sinte_src(data)                                              ((0x02000000&(data))>>25)
+#define AIO_I_INTE_get_timi2sinte(data)                                              ((0x02000000&(data))>>25)
+#define AIO_I_INTE_thdinte0_shift                                                    (21)
+#define AIO_I_INTE_thdinte0_mask                                                     (0x00200000)
+#define AIO_I_INTE_thdinte0(data)                                                    (0x00200000&((data)<<21))
+#define AIO_I_INTE_thdinte0_src(data)                                                ((0x00200000&(data))>>21)
+#define AIO_I_INTE_get_thdinte0(data)                                                ((0x00200000&(data))>>21)
+#define AIO_I_INTE_fifointe1_shift                                                   (10)
+#define AIO_I_INTE_fifointe1_mask                                                    (0x00000400)
+#define AIO_I_INTE_fifointe1(data)                                                   (0x00000400&((data)<<10))
+#define AIO_I_INTE_fifointe1_src(data)                                               ((0x00000400&(data))>>10)
+#define AIO_I_INTE_get_fifointe1(data)                                               ((0x00000400&(data))>>10)
+#define AIO_I_INTE_fifointe0_shift                                                   (9)
+#define AIO_I_INTE_fifointe0_mask                                                    (0x00000200)
+#define AIO_I_INTE_fifointe0(data)                                                   (0x00000200&((data)<<9))
+#define AIO_I_INTE_fifointe0_src(data)                                               ((0x00000200&(data))>>9)
+#define AIO_I_INTE_get_fifointe0(data)                                               ((0x00000200&(data))>>9)
+#define AIO_I_INTE_draminte1_shift                                                   (2)
+#define AIO_I_INTE_draminte1_mask                                                    (0x00000004)
+#define AIO_I_INTE_draminte1(data)                                                   (0x00000004&((data)<<2))
+#define AIO_I_INTE_draminte1_src(data)                                               ((0x00000004&(data))>>2)
+#define AIO_I_INTE_get_draminte1(data)                                               ((0x00000004&(data))>>2)
+#define AIO_I_INTE_draminte0_shift                                                   (1)
+#define AIO_I_INTE_draminte0_mask                                                    (0x00000002)
+#define AIO_I_INTE_draminte0(data)                                                   (0x00000002&((data)<<1))
+#define AIO_I_INTE_draminte0_src(data)                                               ((0x00000002&(data))>>1)
+#define AIO_I_INTE_get_draminte0(data)                                               ((0x00000002&(data))>>1)
+#define AIO_I_INTE_write_data_shift                                                  (0)
+#define AIO_I_INTE_write_data_mask                                                   (0x00000001)
+#define AIO_I_INTE_write_data(data)                                                  (0x00000001&((data)<<0))
+#define AIO_I_INTE_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define AIO_I_INTE_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define AIO_I_INTS                                                                   0x18006334
+#define AIO_I_INTS_reg_addr                                                          "0xB8006334"
+#define AIO_I_INTS_reg                                                               0xB8006334
+#define set_AIO_I_INTS_reg(data)   (*((volatile unsigned int*) AIO_I_INTS_reg)=data)
+#define get_AIO_I_INTS_reg   (*((volatile unsigned int*) AIO_I_INTS_reg))
+#define AIO_I_INTS_inst_adr                                                          "0x00CD"
+#define AIO_I_INTS_inst                                                              0x00CD
+#define AIO_I_INTS_timi2sints_shift                                                  (25)
+#define AIO_I_INTS_timi2sints_mask                                                   (0x02000000)
+#define AIO_I_INTS_timi2sints(data)                                                  (0x02000000&((data)<<25))
+#define AIO_I_INTS_timi2sints_src(data)                                              ((0x02000000&(data))>>25)
+#define AIO_I_INTS_get_timi2sints(data)                                              ((0x02000000&(data))>>25)
+#define AIO_I_INTS_thdints0_shift                                                    (21)
+#define AIO_I_INTS_thdints0_mask                                                     (0x00200000)
+#define AIO_I_INTS_thdints0(data)                                                    (0x00200000&((data)<<21))
+#define AIO_I_INTS_thdints0_src(data)                                                ((0x00200000&(data))>>21)
+#define AIO_I_INTS_get_thdints0(data)                                                ((0x00200000&(data))>>21)
+#define AIO_I_INTS_fifoints1_shift                                                   (10)
+#define AIO_I_INTS_fifoints1_mask                                                    (0x00000400)
+#define AIO_I_INTS_fifoints1(data)                                                   (0x00000400&((data)<<10))
+#define AIO_I_INTS_fifoints1_src(data)                                               ((0x00000400&(data))>>10)
+#define AIO_I_INTS_get_fifoints1(data)                                               ((0x00000400&(data))>>10)
+#define AIO_I_INTS_fifoints0_shift                                                   (9)
+#define AIO_I_INTS_fifoints0_mask                                                    (0x00000200)
+#define AIO_I_INTS_fifoints0(data)                                                   (0x00000200&((data)<<9))
+#define AIO_I_INTS_fifoints0_src(data)                                               ((0x00000200&(data))>>9)
+#define AIO_I_INTS_get_fifoints0(data)                                               ((0x00000200&(data))>>9)
+#define AIO_I_INTS_dramints1_shift                                                   (2)
+#define AIO_I_INTS_dramints1_mask                                                    (0x00000004)
+#define AIO_I_INTS_dramints1(data)                                                   (0x00000004&((data)<<2))
+#define AIO_I_INTS_dramints1_src(data)                                               ((0x00000004&(data))>>2)
+#define AIO_I_INTS_get_dramints1(data)                                               ((0x00000004&(data))>>2)
+#define AIO_I_INTS_dramints0_shift                                                   (1)
+#define AIO_I_INTS_dramints0_mask                                                    (0x00000002)
+#define AIO_I_INTS_dramints0(data)                                                   (0x00000002&((data)<<1))
+#define AIO_I_INTS_dramints0_src(data)                                               ((0x00000002&(data))>>1)
+#define AIO_I_INTS_get_dramints0(data)                                               ((0x00000002&(data))>>1)
+#define AIO_I_INTS_write_data_shift                                                  (0)
+#define AIO_I_INTS_write_data_mask                                                   (0x00000001)
+#define AIO_I_INTS_write_data(data)                                                  (0x00000001&((data)<<0))
+#define AIO_I_INTS_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define AIO_I_INTS_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define AIO_O_PCM_DDRTHD                                                             0x18006400
+#define AIO_O_PCM_DDRTHD_reg_addr                                                    "0xB8006400"
+#define AIO_O_PCM_DDRTHD_reg                                                         0xB8006400
+#define set_AIO_O_PCM_DDRTHD_reg(data)   (*((volatile unsigned int*) AIO_O_PCM_DDRTHD_reg)=data)
+#define get_AIO_O_PCM_DDRTHD_reg   (*((volatile unsigned int*) AIO_O_PCM_DDRTHD_reg))
+#define AIO_O_PCM_DDRTHD_inst_adr                                                    "0x0000"
+#define AIO_O_PCM_DDRTHD_inst                                                        0x0000
+#define AIO_O_PCM_DDRTHD_thd_shift                                                   (3)
+#define AIO_O_PCM_DDRTHD_thd_mask                                                    (0x7FFFFFF8)
+#define AIO_O_PCM_DDRTHD_thd(data)                                                   (0x7FFFFFF8&((data)<<3))
+#define AIO_O_PCM_DDRTHD_thd_src(data)                                               ((0x7FFFFFF8&(data))>>3)
+#define AIO_O_PCM_DDRTHD_get_thd(data)                                               ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_O_PCM_TIMCNT                                                             0x18006404
+#define AIO_O_PCM_TIMCNT_reg_addr                                                    "0xB8006404"
+#define AIO_O_PCM_TIMCNT_reg                                                         0xB8006404
+#define set_AIO_O_PCM_TIMCNT_reg(data)   (*((volatile unsigned int*) AIO_O_PCM_TIMCNT_reg)=data)
+#define get_AIO_O_PCM_TIMCNT_reg   (*((volatile unsigned int*) AIO_O_PCM_TIMCNT_reg))
+#define AIO_O_PCM_TIMCNT_inst_adr                                                    "0x0001"
+#define AIO_O_PCM_TIMCNT_inst                                                        0x0001
+#define AIO_O_PCM_TIMCNT_count_shift                                                 (0)
+#define AIO_O_PCM_TIMCNT_count_mask                                                  (0xFFFFFFFF)
+#define AIO_O_PCM_TIMCNT_count(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define AIO_O_PCM_TIMCNT_count_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_PCM_TIMCNT_get_count(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_PCM_TIMTHD                                                             0x18006408
+#define AIO_O_PCM_TIMTHD_reg_addr                                                    "0xB8006408"
+#define AIO_O_PCM_TIMTHD_reg                                                         0xB8006408
+#define set_AIO_O_PCM_TIMTHD_reg(data)   (*((volatile unsigned int*) AIO_O_PCM_TIMTHD_reg)=data)
+#define get_AIO_O_PCM_TIMTHD_reg   (*((volatile unsigned int*) AIO_O_PCM_TIMTHD_reg))
+#define AIO_O_PCM_TIMTHD_inst_adr                                                    "0x0002"
+#define AIO_O_PCM_TIMTHD_inst                                                        0x0002
+#define AIO_O_PCM_TIMTHD_thd_shift                                                   (0)
+#define AIO_O_PCM_TIMTHD_thd_mask                                                    (0xFFFFFFFF)
+#define AIO_O_PCM_TIMTHD_thd(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define AIO_O_PCM_TIMTHD_thd_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_PCM_TIMTHD_get_thd(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_RAW_DDRTHD                                                             0x18006410
+#define AIO_O_RAW_DDRTHD_reg_addr                                                    "0xB8006410"
+#define AIO_O_RAW_DDRTHD_reg                                                         0xB8006410
+#define set_AIO_O_RAW_DDRTHD_reg(data)   (*((volatile unsigned int*) AIO_O_RAW_DDRTHD_reg)=data)
+#define get_AIO_O_RAW_DDRTHD_reg   (*((volatile unsigned int*) AIO_O_RAW_DDRTHD_reg))
+#define AIO_O_RAW_DDRTHD_inst_adr                                                    "0x0004"
+#define AIO_O_RAW_DDRTHD_inst                                                        0x0004
+#define AIO_O_RAW_DDRTHD_thd_shift                                                   (3)
+#define AIO_O_RAW_DDRTHD_thd_mask                                                    (0x7FFFFFF8)
+#define AIO_O_RAW_DDRTHD_thd(data)                                                   (0x7FFFFFF8&((data)<<3))
+#define AIO_O_RAW_DDRTHD_thd_src(data)                                               ((0x7FFFFFF8&(data))>>3)
+#define AIO_O_RAW_DDRTHD_get_thd(data)                                               ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_O_RAW_TIMCNT                                                             0x18006414
+#define AIO_O_RAW_TIMCNT_reg_addr                                                    "0xB8006414"
+#define AIO_O_RAW_TIMCNT_reg                                                         0xB8006414
+#define set_AIO_O_RAW_TIMCNT_reg(data)   (*((volatile unsigned int*) AIO_O_RAW_TIMCNT_reg)=data)
+#define get_AIO_O_RAW_TIMCNT_reg   (*((volatile unsigned int*) AIO_O_RAW_TIMCNT_reg))
+#define AIO_O_RAW_TIMCNT_inst_adr                                                    "0x0005"
+#define AIO_O_RAW_TIMCNT_inst                                                        0x0005
+#define AIO_O_RAW_TIMCNT_count_shift                                                 (0)
+#define AIO_O_RAW_TIMCNT_count_mask                                                  (0xFFFFFFFF)
+#define AIO_O_RAW_TIMCNT_count(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define AIO_O_RAW_TIMCNT_count_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_RAW_TIMCNT_get_count(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_RAW_TIMTHD                                                             0x18006418
+#define AIO_O_RAW_TIMTHD_reg_addr                                                    "0xB8006418"
+#define AIO_O_RAW_TIMTHD_reg                                                         0xB8006418
+#define set_AIO_O_RAW_TIMTHD_reg(data)   (*((volatile unsigned int*) AIO_O_RAW_TIMTHD_reg)=data)
+#define get_AIO_O_RAW_TIMTHD_reg   (*((volatile unsigned int*) AIO_O_RAW_TIMTHD_reg))
+#define AIO_O_RAW_TIMTHD_inst_adr                                                    "0x0006"
+#define AIO_O_RAW_TIMTHD_inst                                                        0x0006
+#define AIO_O_RAW_TIMTHD_thd_shift                                                   (0)
+#define AIO_O_RAW_TIMTHD_thd_mask                                                    (0xFFFFFFFF)
+#define AIO_O_RAW_TIMTHD_thd(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define AIO_O_RAW_TIMTHD_thd_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_RAW_TIMTHD_get_thd(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_HDMI_DDRTHD                                                            0x18006420
+#define AIO_O_HDMI_DDRTHD_reg_addr                                                   "0xB8006420"
+#define AIO_O_HDMI_DDRTHD_reg                                                        0xB8006420
+#define set_AIO_O_HDMI_DDRTHD_reg(data)   (*((volatile unsigned int*) AIO_O_HDMI_DDRTHD_reg)=data)
+#define get_AIO_O_HDMI_DDRTHD_reg   (*((volatile unsigned int*) AIO_O_HDMI_DDRTHD_reg))
+#define AIO_O_HDMI_DDRTHD_inst_adr                                                   "0x0008"
+#define AIO_O_HDMI_DDRTHD_inst                                                       0x0008
+#define AIO_O_HDMI_DDRTHD_thd_shift                                                  (3)
+#define AIO_O_HDMI_DDRTHD_thd_mask                                                   (0x7FFFFFF8)
+#define AIO_O_HDMI_DDRTHD_thd(data)                                                  (0x7FFFFFF8&((data)<<3))
+#define AIO_O_HDMI_DDRTHD_thd_src(data)                                              ((0x7FFFFFF8&(data))>>3)
+#define AIO_O_HDMI_DDRTHD_get_thd(data)                                              ((0x7FFFFFF8&(data))>>3)
+
+
+#define AIO_O_HDMI_TIMCNT                                                            0x18006424
+#define AIO_O_HDMI_TIMCNT_reg_addr                                                   "0xB8006424"
+#define AIO_O_HDMI_TIMCNT_reg                                                        0xB8006424
+#define set_AIO_O_HDMI_TIMCNT_reg(data)   (*((volatile unsigned int*) AIO_O_HDMI_TIMCNT_reg)=data)
+#define get_AIO_O_HDMI_TIMCNT_reg   (*((volatile unsigned int*) AIO_O_HDMI_TIMCNT_reg))
+#define AIO_O_HDMI_TIMCNT_inst_adr                                                   "0x0009"
+#define AIO_O_HDMI_TIMCNT_inst                                                       0x0009
+#define AIO_O_HDMI_TIMCNT_count_shift                                                (0)
+#define AIO_O_HDMI_TIMCNT_count_mask                                                 (0xFFFFFFFF)
+#define AIO_O_HDMI_TIMCNT_count(data)                                                (0xFFFFFFFF&((data)<<0))
+#define AIO_O_HDMI_TIMCNT_count_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_HDMI_TIMCNT_get_count(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_HDMI_TIMTHD                                                            0x18006428
+#define AIO_O_HDMI_TIMTHD_reg_addr                                                   "0xB8006428"
+#define AIO_O_HDMI_TIMTHD_reg                                                        0xB8006428
+#define set_AIO_O_HDMI_TIMTHD_reg(data)   (*((volatile unsigned int*) AIO_O_HDMI_TIMTHD_reg)=data)
+#define get_AIO_O_HDMI_TIMTHD_reg   (*((volatile unsigned int*) AIO_O_HDMI_TIMTHD_reg))
+#define AIO_O_HDMI_TIMTHD_inst_adr                                                   "0x000A"
+#define AIO_O_HDMI_TIMTHD_inst                                                       0x000A
+#define AIO_O_HDMI_TIMTHD_thd_shift                                                  (0)
+#define AIO_O_HDMI_TIMTHD_thd_mask                                                   (0xFFFFFFFF)
+#define AIO_O_HDMI_TIMTHD_thd(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define AIO_O_HDMI_TIMTHD_thd_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define AIO_O_HDMI_TIMTHD_get_thd(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_O_INTE                                                                   0x18006440
+#define AIO_O_INTE_reg_addr                                                          "0xB8006440"
+#define AIO_O_INTE_reg                                                               0xB8006440
+#define set_AIO_O_INTE_reg(data)   (*((volatile unsigned int*) AIO_O_INTE_reg)=data)
+#define get_AIO_O_INTE_reg   (*((volatile unsigned int*) AIO_O_INTE_reg))
+#define AIO_O_INTE_inst_adr                                                          "0x0010"
+#define AIO_O_INTE_inst                                                              0x0010
+#define AIO_O_INTE_draminte11_shift                                                  (30)
+#define AIO_O_INTE_draminte11_mask                                                   (0x40000000)
+#define AIO_O_INTE_draminte11(data)                                                  (0x40000000&((data)<<30))
+#define AIO_O_INTE_draminte11_src(data)                                              ((0x40000000&(data))>>30)
+#define AIO_O_INTE_get_draminte11(data)                                              ((0x40000000&(data))>>30)
+#define AIO_O_INTE_draminte10_shift                                                  (29)
+#define AIO_O_INTE_draminte10_mask                                                   (0x20000000)
+#define AIO_O_INTE_draminte10(data)                                                  (0x20000000&((data)<<29))
+#define AIO_O_INTE_draminte10_src(data)                                              ((0x20000000&(data))>>29)
+#define AIO_O_INTE_get_draminte10(data)                                              ((0x20000000&(data))>>29)
+#define AIO_O_INTE_draminte9_shift                                                   (28)
+#define AIO_O_INTE_draminte9_mask                                                    (0x10000000)
+#define AIO_O_INTE_draminte9(data)                                                   (0x10000000&((data)<<28))
+#define AIO_O_INTE_draminte9_src(data)                                               ((0x10000000&(data))>>28)
+#define AIO_O_INTE_get_draminte9(data)                                               ((0x10000000&(data))>>28)
+#define AIO_O_INTE_draminte8_shift                                                   (27)
+#define AIO_O_INTE_draminte8_mask                                                    (0x08000000)
+#define AIO_O_INTE_draminte8(data)                                                   (0x08000000&((data)<<27))
+#define AIO_O_INTE_draminte8_src(data)                                               ((0x08000000&(data))>>27)
+#define AIO_O_INTE_get_draminte8(data)                                               ((0x08000000&(data))>>27)
+#define AIO_O_INTE_draminte7_shift                                                   (26)
+#define AIO_O_INTE_draminte7_mask                                                    (0x04000000)
+#define AIO_O_INTE_draminte7(data)                                                   (0x04000000&((data)<<26))
+#define AIO_O_INTE_draminte7_src(data)                                               ((0x04000000&(data))>>26)
+#define AIO_O_INTE_get_draminte7(data)                                               ((0x04000000&(data))>>26)
+#define AIO_O_INTE_draminte6_shift                                                   (25)
+#define AIO_O_INTE_draminte6_mask                                                    (0x02000000)
+#define AIO_O_INTE_draminte6(data)                                                   (0x02000000&((data)<<25))
+#define AIO_O_INTE_draminte6_src(data)                                               ((0x02000000&(data))>>25)
+#define AIO_O_INTE_get_draminte6(data)                                               ((0x02000000&(data))>>25)
+#define AIO_O_INTE_draminte5_shift                                                   (24)
+#define AIO_O_INTE_draminte5_mask                                                    (0x01000000)
+#define AIO_O_INTE_draminte5(data)                                                   (0x01000000&((data)<<24))
+#define AIO_O_INTE_draminte5_src(data)                                               ((0x01000000&(data))>>24)
+#define AIO_O_INTE_get_draminte5(data)                                               ((0x01000000&(data))>>24)
+#define AIO_O_INTE_draminte4_shift                                                   (23)
+#define AIO_O_INTE_draminte4_mask                                                    (0x00800000)
+#define AIO_O_INTE_draminte4(data)                                                   (0x00800000&((data)<<23))
+#define AIO_O_INTE_draminte4_src(data)                                               ((0x00800000&(data))>>23)
+#define AIO_O_INTE_get_draminte4(data)                                               ((0x00800000&(data))>>23)
+#define AIO_O_INTE_fifointe11_shift                                                  (22)
+#define AIO_O_INTE_fifointe11_mask                                                   (0x00400000)
+#define AIO_O_INTE_fifointe11(data)                                                  (0x00400000&((data)<<22))
+#define AIO_O_INTE_fifointe11_src(data)                                              ((0x00400000&(data))>>22)
+#define AIO_O_INTE_get_fifointe11(data)                                              ((0x00400000&(data))>>22)
+#define AIO_O_INTE_fifointe10_shift                                                  (21)
+#define AIO_O_INTE_fifointe10_mask                                                   (0x00200000)
+#define AIO_O_INTE_fifointe10(data)                                                  (0x00200000&((data)<<21))
+#define AIO_O_INTE_fifointe10_src(data)                                              ((0x00200000&(data))>>21)
+#define AIO_O_INTE_get_fifointe10(data)                                              ((0x00200000&(data))>>21)
+#define AIO_O_INTE_fifointe9_shift                                                   (20)
+#define AIO_O_INTE_fifointe9_mask                                                    (0x00100000)
+#define AIO_O_INTE_fifointe9(data)                                                   (0x00100000&((data)<<20))
+#define AIO_O_INTE_fifointe9_src(data)                                               ((0x00100000&(data))>>20)
+#define AIO_O_INTE_get_fifointe9(data)                                               ((0x00100000&(data))>>20)
+#define AIO_O_INTE_fifointe8_shift                                                   (19)
+#define AIO_O_INTE_fifointe8_mask                                                    (0x00080000)
+#define AIO_O_INTE_fifointe8(data)                                                   (0x00080000&((data)<<19))
+#define AIO_O_INTE_fifointe8_src(data)                                               ((0x00080000&(data))>>19)
+#define AIO_O_INTE_get_fifointe8(data)                                               ((0x00080000&(data))>>19)
+#define AIO_O_INTE_fifointe7_shift                                                   (18)
+#define AIO_O_INTE_fifointe7_mask                                                    (0x00040000)
+#define AIO_O_INTE_fifointe7(data)                                                   (0x00040000&((data)<<18))
+#define AIO_O_INTE_fifointe7_src(data)                                               ((0x00040000&(data))>>18)
+#define AIO_O_INTE_get_fifointe7(data)                                               ((0x00040000&(data))>>18)
+#define AIO_O_INTE_fifointe6_shift                                                   (17)
+#define AIO_O_INTE_fifointe6_mask                                                    (0x00020000)
+#define AIO_O_INTE_fifointe6(data)                                                   (0x00020000&((data)<<17))
+#define AIO_O_INTE_fifointe6_src(data)                                               ((0x00020000&(data))>>17)
+#define AIO_O_INTE_get_fifointe6(data)                                               ((0x00020000&(data))>>17)
+#define AIO_O_INTE_fifointe5_shift                                                   (16)
+#define AIO_O_INTE_fifointe5_mask                                                    (0x00010000)
+#define AIO_O_INTE_fifointe5(data)                                                   (0x00010000&((data)<<16))
+#define AIO_O_INTE_fifointe5_src(data)                                               ((0x00010000&(data))>>16)
+#define AIO_O_INTE_get_fifointe5(data)                                               ((0x00010000&(data))>>16)
+#define AIO_O_INTE_fifointe4_shift                                                   (15)
+#define AIO_O_INTE_fifointe4_mask                                                    (0x00008000)
+#define AIO_O_INTE_fifointe4(data)                                                   (0x00008000&((data)<<15))
+#define AIO_O_INTE_fifointe4_src(data)                                               ((0x00008000&(data))>>15)
+#define AIO_O_INTE_get_fifointe4(data)                                               ((0x00008000&(data))>>15)
+#define AIO_O_INTE_pcmtiminte_shift                                                  (14)
+#define AIO_O_INTE_pcmtiminte_mask                                                   (0x00004000)
+#define AIO_O_INTE_pcmtiminte(data)                                                  (0x00004000&((data)<<14))
+#define AIO_O_INTE_pcmtiminte_src(data)                                              ((0x00004000&(data))>>14)
+#define AIO_O_INTE_get_pcmtiminte(data)                                              ((0x00004000&(data))>>14)
+#define AIO_O_INTE_rawtiminte_shift                                                  (13)
+#define AIO_O_INTE_rawtiminte_mask                                                   (0x00002000)
+#define AIO_O_INTE_rawtiminte(data)                                                  (0x00002000&((data)<<13))
+#define AIO_O_INTE_rawtiminte_src(data)                                              ((0x00002000&(data))>>13)
+#define AIO_O_INTE_get_rawtiminte(data)                                              ((0x00002000&(data))>>13)
+#define AIO_O_INTE_hdmitiminte_shift                                                 (12)
+#define AIO_O_INTE_hdmitiminte_mask                                                  (0x00001000)
+#define AIO_O_INTE_hdmitiminte(data)                                                 (0x00001000&((data)<<12))
+#define AIO_O_INTE_hdmitiminte_src(data)                                             ((0x00001000&(data))>>12)
+#define AIO_O_INTE_get_hdmitiminte(data)                                             ((0x00001000&(data))>>12)
+#define AIO_O_INTE_pcmthdinte_shift                                                  (11)
+#define AIO_O_INTE_pcmthdinte_mask                                                   (0x00000800)
+#define AIO_O_INTE_pcmthdinte(data)                                                  (0x00000800&((data)<<11))
+#define AIO_O_INTE_pcmthdinte_src(data)                                              ((0x00000800&(data))>>11)
+#define AIO_O_INTE_get_pcmthdinte(data)                                              ((0x00000800&(data))>>11)
+#define AIO_O_INTE_rawthdinte_shift                                                  (10)
+#define AIO_O_INTE_rawthdinte_mask                                                   (0x00000400)
+#define AIO_O_INTE_rawthdinte(data)                                                  (0x00000400&((data)<<10))
+#define AIO_O_INTE_rawthdinte_src(data)                                              ((0x00000400&(data))>>10)
+#define AIO_O_INTE_get_rawthdinte(data)                                              ((0x00000400&(data))>>10)
+#define AIO_O_INTE_hdmithdinte_shift                                                 (9)
+#define AIO_O_INTE_hdmithdinte_mask                                                  (0x00000200)
+#define AIO_O_INTE_hdmithdinte(data)                                                 (0x00000200&((data)<<9))
+#define AIO_O_INTE_hdmithdinte_src(data)                                             ((0x00000200&(data))>>9)
+#define AIO_O_INTE_get_hdmithdinte(data)                                             ((0x00000200&(data))>>9)
+#define AIO_O_INTE_draminte3_shift                                                   (8)
+#define AIO_O_INTE_draminte3_mask                                                    (0x00000100)
+#define AIO_O_INTE_draminte3(data)                                                   (0x00000100&((data)<<8))
+#define AIO_O_INTE_draminte3_src(data)                                               ((0x00000100&(data))>>8)
+#define AIO_O_INTE_get_draminte3(data)                                               ((0x00000100&(data))>>8)
+#define AIO_O_INTE_draminte2_shift                                                   (7)
+#define AIO_O_INTE_draminte2_mask                                                    (0x00000080)
+#define AIO_O_INTE_draminte2(data)                                                   (0x00000080&((data)<<7))
+#define AIO_O_INTE_draminte2_src(data)                                               ((0x00000080&(data))>>7)
+#define AIO_O_INTE_get_draminte2(data)                                               ((0x00000080&(data))>>7)
+#define AIO_O_INTE_draminte1_shift                                                   (6)
+#define AIO_O_INTE_draminte1_mask                                                    (0x00000040)
+#define AIO_O_INTE_draminte1(data)                                                   (0x00000040&((data)<<6))
+#define AIO_O_INTE_draminte1_src(data)                                               ((0x00000040&(data))>>6)
+#define AIO_O_INTE_get_draminte1(data)                                               ((0x00000040&(data))>>6)
+#define AIO_O_INTE_draminte0_shift                                                   (5)
+#define AIO_O_INTE_draminte0_mask                                                    (0x00000020)
+#define AIO_O_INTE_draminte0(data)                                                   (0x00000020&((data)<<5))
+#define AIO_O_INTE_draminte0_src(data)                                               ((0x00000020&(data))>>5)
+#define AIO_O_INTE_get_draminte0(data)                                               ((0x00000020&(data))>>5)
+#define AIO_O_INTE_fifointe3_shift                                                   (4)
+#define AIO_O_INTE_fifointe3_mask                                                    (0x00000010)
+#define AIO_O_INTE_fifointe3(data)                                                   (0x00000010&((data)<<4))
+#define AIO_O_INTE_fifointe3_src(data)                                               ((0x00000010&(data))>>4)
+#define AIO_O_INTE_get_fifointe3(data)                                               ((0x00000010&(data))>>4)
+#define AIO_O_INTE_fifointe2_shift                                                   (3)
+#define AIO_O_INTE_fifointe2_mask                                                    (0x00000008)
+#define AIO_O_INTE_fifointe2(data)                                                   (0x00000008&((data)<<3))
+#define AIO_O_INTE_fifointe2_src(data)                                               ((0x00000008&(data))>>3)
+#define AIO_O_INTE_get_fifointe2(data)                                               ((0x00000008&(data))>>3)
+#define AIO_O_INTE_fifointe1_shift                                                   (2)
+#define AIO_O_INTE_fifointe1_mask                                                    (0x00000004)
+#define AIO_O_INTE_fifointe1(data)                                                   (0x00000004&((data)<<2))
+#define AIO_O_INTE_fifointe1_src(data)                                               ((0x00000004&(data))>>2)
+#define AIO_O_INTE_get_fifointe1(data)                                               ((0x00000004&(data))>>2)
+#define AIO_O_INTE_fifointe0_shift                                                   (1)
+#define AIO_O_INTE_fifointe0_mask                                                    (0x00000002)
+#define AIO_O_INTE_fifointe0(data)                                                   (0x00000002&((data)<<1))
+#define AIO_O_INTE_fifointe0_src(data)                                               ((0x00000002&(data))>>1)
+#define AIO_O_INTE_get_fifointe0(data)                                               ((0x00000002&(data))>>1)
+#define AIO_O_INTE_write_data_shift                                                  (0)
+#define AIO_O_INTE_write_data_mask                                                   (0x00000001)
+#define AIO_O_INTE_write_data(data)                                                  (0x00000001&((data)<<0))
+#define AIO_O_INTE_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define AIO_O_INTE_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define AIO_O_INTS                                                                   0x18006444
+#define AIO_O_INTS_reg_addr                                                          "0xB8006444"
+#define AIO_O_INTS_reg                                                               0xB8006444
+#define set_AIO_O_INTS_reg(data)   (*((volatile unsigned int*) AIO_O_INTS_reg)=data)
+#define get_AIO_O_INTS_reg   (*((volatile unsigned int*) AIO_O_INTS_reg))
+#define AIO_O_INTS_inst_adr                                                          "0x0011"
+#define AIO_O_INTS_inst                                                              0x0011
+#define AIO_O_INTS_dramints11_shift                                                  (30)
+#define AIO_O_INTS_dramints11_mask                                                   (0x40000000)
+#define AIO_O_INTS_dramints11(data)                                                  (0x40000000&((data)<<30))
+#define AIO_O_INTS_dramints11_src(data)                                              ((0x40000000&(data))>>30)
+#define AIO_O_INTS_get_dramints11(data)                                              ((0x40000000&(data))>>30)
+#define AIO_O_INTS_dramints10_shift                                                  (29)
+#define AIO_O_INTS_dramints10_mask                                                   (0x20000000)
+#define AIO_O_INTS_dramints10(data)                                                  (0x20000000&((data)<<29))
+#define AIO_O_INTS_dramints10_src(data)                                              ((0x20000000&(data))>>29)
+#define AIO_O_INTS_get_dramints10(data)                                              ((0x20000000&(data))>>29)
+#define AIO_O_INTS_dramints9_shift                                                   (28)
+#define AIO_O_INTS_dramints9_mask                                                    (0x10000000)
+#define AIO_O_INTS_dramints9(data)                                                   (0x10000000&((data)<<28))
+#define AIO_O_INTS_dramints9_src(data)                                               ((0x10000000&(data))>>28)
+#define AIO_O_INTS_get_dramints9(data)                                               ((0x10000000&(data))>>28)
+#define AIO_O_INTS_dramints8_shift                                                   (27)
+#define AIO_O_INTS_dramints8_mask                                                    (0x08000000)
+#define AIO_O_INTS_dramints8(data)                                                   (0x08000000&((data)<<27))
+#define AIO_O_INTS_dramints8_src(data)                                               ((0x08000000&(data))>>27)
+#define AIO_O_INTS_get_dramints8(data)                                               ((0x08000000&(data))>>27)
+#define AIO_O_INTS_dramints7_shift                                                   (26)
+#define AIO_O_INTS_dramints7_mask                                                    (0x04000000)
+#define AIO_O_INTS_dramints7(data)                                                   (0x04000000&((data)<<26))
+#define AIO_O_INTS_dramints7_src(data)                                               ((0x04000000&(data))>>26)
+#define AIO_O_INTS_get_dramints7(data)                                               ((0x04000000&(data))>>26)
+#define AIO_O_INTS_dramints6_shift                                                   (25)
+#define AIO_O_INTS_dramints6_mask                                                    (0x02000000)
+#define AIO_O_INTS_dramints6(data)                                                   (0x02000000&((data)<<25))
+#define AIO_O_INTS_dramints6_src(data)                                               ((0x02000000&(data))>>25)
+#define AIO_O_INTS_get_dramints6(data)                                               ((0x02000000&(data))>>25)
+#define AIO_O_INTS_dramints5_shift                                                   (24)
+#define AIO_O_INTS_dramints5_mask                                                    (0x01000000)
+#define AIO_O_INTS_dramints5(data)                                                   (0x01000000&((data)<<24))
+#define AIO_O_INTS_dramints5_src(data)                                               ((0x01000000&(data))>>24)
+#define AIO_O_INTS_get_dramints5(data)                                               ((0x01000000&(data))>>24)
+#define AIO_O_INTS_dramints4_shift                                                   (23)
+#define AIO_O_INTS_dramints4_mask                                                    (0x00800000)
+#define AIO_O_INTS_dramints4(data)                                                   (0x00800000&((data)<<23))
+#define AIO_O_INTS_dramints4_src(data)                                               ((0x00800000&(data))>>23)
+#define AIO_O_INTS_get_dramints4(data)                                               ((0x00800000&(data))>>23)
+#define AIO_O_INTS_fifoints11_shift                                                  (22)
+#define AIO_O_INTS_fifoints11_mask                                                   (0x00400000)
+#define AIO_O_INTS_fifoints11(data)                                                  (0x00400000&((data)<<22))
+#define AIO_O_INTS_fifoints11_src(data)                                              ((0x00400000&(data))>>22)
+#define AIO_O_INTS_get_fifoints11(data)                                              ((0x00400000&(data))>>22)
+#define AIO_O_INTS_fifoints10_shift                                                  (21)
+#define AIO_O_INTS_fifoints10_mask                                                   (0x00200000)
+#define AIO_O_INTS_fifoints10(data)                                                  (0x00200000&((data)<<21))
+#define AIO_O_INTS_fifoints10_src(data)                                              ((0x00200000&(data))>>21)
+#define AIO_O_INTS_get_fifoints10(data)                                              ((0x00200000&(data))>>21)
+#define AIO_O_INTS_fifoints9_shift                                                   (20)
+#define AIO_O_INTS_fifoints9_mask                                                    (0x00100000)
+#define AIO_O_INTS_fifoints9(data)                                                   (0x00100000&((data)<<20))
+#define AIO_O_INTS_fifoints9_src(data)                                               ((0x00100000&(data))>>20)
+#define AIO_O_INTS_get_fifoints9(data)                                               ((0x00100000&(data))>>20)
+#define AIO_O_INTS_fifoints8_shift                                                   (19)
+#define AIO_O_INTS_fifoints8_mask                                                    (0x00080000)
+#define AIO_O_INTS_fifoints8(data)                                                   (0x00080000&((data)<<19))
+#define AIO_O_INTS_fifoints8_src(data)                                               ((0x00080000&(data))>>19)
+#define AIO_O_INTS_get_fifoints8(data)                                               ((0x00080000&(data))>>19)
+#define AIO_O_INTS_fifoints7_shift                                                   (18)
+#define AIO_O_INTS_fifoints7_mask                                                    (0x00040000)
+#define AIO_O_INTS_fifoints7(data)                                                   (0x00040000&((data)<<18))
+#define AIO_O_INTS_fifoints7_src(data)                                               ((0x00040000&(data))>>18)
+#define AIO_O_INTS_get_fifoints7(data)                                               ((0x00040000&(data))>>18)
+#define AIO_O_INTS_fifoints6_shift                                                   (17)
+#define AIO_O_INTS_fifoints6_mask                                                    (0x00020000)
+#define AIO_O_INTS_fifoints6(data)                                                   (0x00020000&((data)<<17))
+#define AIO_O_INTS_fifoints6_src(data)                                               ((0x00020000&(data))>>17)
+#define AIO_O_INTS_get_fifoints6(data)                                               ((0x00020000&(data))>>17)
+#define AIO_O_INTS_fifoints5_shift                                                   (16)
+#define AIO_O_INTS_fifoints5_mask                                                    (0x00010000)
+#define AIO_O_INTS_fifoints5(data)                                                   (0x00010000&((data)<<16))
+#define AIO_O_INTS_fifoints5_src(data)                                               ((0x00010000&(data))>>16)
+#define AIO_O_INTS_get_fifoints5(data)                                               ((0x00010000&(data))>>16)
+#define AIO_O_INTS_fifoints4_shift                                                   (15)
+#define AIO_O_INTS_fifoints4_mask                                                    (0x00008000)
+#define AIO_O_INTS_fifoints4(data)                                                   (0x00008000&((data)<<15))
+#define AIO_O_INTS_fifoints4_src(data)                                               ((0x00008000&(data))>>15)
+#define AIO_O_INTS_get_fifoints4(data)                                               ((0x00008000&(data))>>15)
+#define AIO_O_INTS_pcmtimints_shift                                                  (14)
+#define AIO_O_INTS_pcmtimints_mask                                                   (0x00004000)
+#define AIO_O_INTS_pcmtimints(data)                                                  (0x00004000&((data)<<14))
+#define AIO_O_INTS_pcmtimints_src(data)                                              ((0x00004000&(data))>>14)
+#define AIO_O_INTS_get_pcmtimints(data)                                              ((0x00004000&(data))>>14)
+#define AIO_O_INTS_rawtimints_shift                                                  (13)
+#define AIO_O_INTS_rawtimints_mask                                                   (0x00002000)
+#define AIO_O_INTS_rawtimints(data)                                                  (0x00002000&((data)<<13))
+#define AIO_O_INTS_rawtimints_src(data)                                              ((0x00002000&(data))>>13)
+#define AIO_O_INTS_get_rawtimints(data)                                              ((0x00002000&(data))>>13)
+#define AIO_O_INTS_hdmitimints_shift                                                 (12)
+#define AIO_O_INTS_hdmitimints_mask                                                  (0x00001000)
+#define AIO_O_INTS_hdmitimints(data)                                                 (0x00001000&((data)<<12))
+#define AIO_O_INTS_hdmitimints_src(data)                                             ((0x00001000&(data))>>12)
+#define AIO_O_INTS_get_hdmitimints(data)                                             ((0x00001000&(data))>>12)
+#define AIO_O_INTS_pcmthdints_shift                                                  (11)
+#define AIO_O_INTS_pcmthdints_mask                                                   (0x00000800)
+#define AIO_O_INTS_pcmthdints(data)                                                  (0x00000800&((data)<<11))
+#define AIO_O_INTS_pcmthdints_src(data)                                              ((0x00000800&(data))>>11)
+#define AIO_O_INTS_get_pcmthdints(data)                                              ((0x00000800&(data))>>11)
+#define AIO_O_INTS_rawthdints_shift                                                  (10)
+#define AIO_O_INTS_rawthdints_mask                                                   (0x00000400)
+#define AIO_O_INTS_rawthdints(data)                                                  (0x00000400&((data)<<10))
+#define AIO_O_INTS_rawthdints_src(data)                                              ((0x00000400&(data))>>10)
+#define AIO_O_INTS_get_rawthdints(data)                                              ((0x00000400&(data))>>10)
+#define AIO_O_INTS_hdmithdints_shift                                                 (9)
+#define AIO_O_INTS_hdmithdints_mask                                                  (0x00000200)
+#define AIO_O_INTS_hdmithdints(data)                                                 (0x00000200&((data)<<9))
+#define AIO_O_INTS_hdmithdints_src(data)                                             ((0x00000200&(data))>>9)
+#define AIO_O_INTS_get_hdmithdints(data)                                             ((0x00000200&(data))>>9)
+#define AIO_O_INTS_dramints3_shift                                                   (8)
+#define AIO_O_INTS_dramints3_mask                                                    (0x00000100)
+#define AIO_O_INTS_dramints3(data)                                                   (0x00000100&((data)<<8))
+#define AIO_O_INTS_dramints3_src(data)                                               ((0x00000100&(data))>>8)
+#define AIO_O_INTS_get_dramints3(data)                                               ((0x00000100&(data))>>8)
+#define AIO_O_INTS_dramints2_shift                                                   (7)
+#define AIO_O_INTS_dramints2_mask                                                    (0x00000080)
+#define AIO_O_INTS_dramints2(data)                                                   (0x00000080&((data)<<7))
+#define AIO_O_INTS_dramints2_src(data)                                               ((0x00000080&(data))>>7)
+#define AIO_O_INTS_get_dramints2(data)                                               ((0x00000080&(data))>>7)
+#define AIO_O_INTS_dramints1_shift                                                   (6)
+#define AIO_O_INTS_dramints1_mask                                                    (0x00000040)
+#define AIO_O_INTS_dramints1(data)                                                   (0x00000040&((data)<<6))
+#define AIO_O_INTS_dramints1_src(data)                                               ((0x00000040&(data))>>6)
+#define AIO_O_INTS_get_dramints1(data)                                               ((0x00000040&(data))>>6)
+#define AIO_O_INTS_dramints0_shift                                                   (5)
+#define AIO_O_INTS_dramints0_mask                                                    (0x00000020)
+#define AIO_O_INTS_dramints0(data)                                                   (0x00000020&((data)<<5))
+#define AIO_O_INTS_dramints0_src(data)                                               ((0x00000020&(data))>>5)
+#define AIO_O_INTS_get_dramints0(data)                                               ((0x00000020&(data))>>5)
+#define AIO_O_INTS_fifoints3_shift                                                   (4)
+#define AIO_O_INTS_fifoints3_mask                                                    (0x00000010)
+#define AIO_O_INTS_fifoints3(data)                                                   (0x00000010&((data)<<4))
+#define AIO_O_INTS_fifoints3_src(data)                                               ((0x00000010&(data))>>4)
+#define AIO_O_INTS_get_fifoints3(data)                                               ((0x00000010&(data))>>4)
+#define AIO_O_INTS_fifoints2_shift                                                   (3)
+#define AIO_O_INTS_fifoints2_mask                                                    (0x00000008)
+#define AIO_O_INTS_fifoints2(data)                                                   (0x00000008&((data)<<3))
+#define AIO_O_INTS_fifoints2_src(data)                                               ((0x00000008&(data))>>3)
+#define AIO_O_INTS_get_fifoints2(data)                                               ((0x00000008&(data))>>3)
+#define AIO_O_INTS_fifoints1_shift                                                   (2)
+#define AIO_O_INTS_fifoints1_mask                                                    (0x00000004)
+#define AIO_O_INTS_fifoints1(data)                                                   (0x00000004&((data)<<2))
+#define AIO_O_INTS_fifoints1_src(data)                                               ((0x00000004&(data))>>2)
+#define AIO_O_INTS_get_fifoints1(data)                                               ((0x00000004&(data))>>2)
+#define AIO_O_INTS_fifoints0_shift                                                   (1)
+#define AIO_O_INTS_fifoints0_mask                                                    (0x00000002)
+#define AIO_O_INTS_fifoints0(data)                                                   (0x00000002&((data)<<1))
+#define AIO_O_INTS_fifoints0_src(data)                                               ((0x00000002&(data))>>1)
+#define AIO_O_INTS_get_fifoints0(data)                                               ((0x00000002&(data))>>1)
+#define AIO_O_INTS_write_data_shift                                                  (0)
+#define AIO_O_INTS_write_data_mask                                                   (0x00000001)
+#define AIO_O_INTS_write_data(data)                                                  (0x00000001&((data)<<0))
+#define AIO_O_INTS_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define AIO_O_INTS_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define AIO_DBG                                                                      0x18006500
+#define AIO_DBG_reg_addr                                                             "0xB8006500"
+#define AIO_DBG_reg                                                                  0xB8006500
+#define set_AIO_DBG_reg(data)   (*((volatile unsigned int*) AIO_DBG_reg)=data)
+#define get_AIO_DBG_reg   (*((volatile unsigned int*) AIO_DBG_reg))
+#define AIO_DBG_inst_adr                                                             "0x0040"
+#define AIO_DBG_inst                                                                 0x0040
+#define AIO_DBG_codec_tmode2_shift                                                   (9)
+#define AIO_DBG_codec_tmode2_mask                                                    (0x00000200)
+#define AIO_DBG_codec_tmode2(data)                                                   (0x00000200&((data)<<9))
+#define AIO_DBG_codec_tmode2_src(data)                                               ((0x00000200&(data))>>9)
+#define AIO_DBG_get_codec_tmode2(data)                                               ((0x00000200&(data))>>9)
+#define AIO_DBG_loopbacken_shift                                                     (8)
+#define AIO_DBG_loopbacken_mask                                                      (0x00000100)
+#define AIO_DBG_loopbacken(data)                                                     (0x00000100&((data)<<8))
+#define AIO_DBG_loopbacken_src(data)                                                 ((0x00000100&(data))>>8)
+#define AIO_DBG_get_loopbacken(data)                                                 ((0x00000100&(data))>>8)
+#define AIO_DBG_codec_tmode_shift                                                    (7)
+#define AIO_DBG_codec_tmode_mask                                                     (0x00000080)
+#define AIO_DBG_codec_tmode(data)                                                    (0x00000080&((data)<<7))
+#define AIO_DBG_codec_tmode_src(data)                                                ((0x00000080&(data))>>7)
+#define AIO_DBG_get_codec_tmode(data)                                                ((0x00000080&(data))>>7)
+#define AIO_DBG_dbgen_shift                                                          (6)
+#define AIO_DBG_dbgen_mask                                                           (0x00000040)
+#define AIO_DBG_dbgen(data)                                                          (0x00000040&((data)<<6))
+#define AIO_DBG_dbgen_src(data)                                                      ((0x00000040&(data))>>6)
+#define AIO_DBG_get_dbgen(data)                                                      ((0x00000040&(data))>>6)
+#define AIO_DBG_sel0_shift                                                           (3)
+#define AIO_DBG_sel0_mask                                                            (0x00000038)
+#define AIO_DBG_sel0(data)                                                           (0x00000038&((data)<<3))
+#define AIO_DBG_sel0_src(data)                                                       ((0x00000038&(data))>>3)
+#define AIO_DBG_get_sel0(data)                                                       ((0x00000038&(data))>>3)
+#define AIO_DBG_sel1_shift                                                           (0)
+#define AIO_DBG_sel1_mask                                                            (0x00000007)
+#define AIO_DBG_sel1(data)                                                           (0x00000007&((data)<<0))
+#define AIO_DBG_sel1_src(data)                                                       ((0x00000007&(data))>>0)
+#define AIO_DBG_get_sel1(data)                                                       ((0x00000007&(data))>>0)
+
+
+#define AIO_SPARE                                                                    0x18006504
+#define AIO_SPARE_reg_addr                                                           "0xB8006504"
+#define AIO_SPARE_reg                                                                0xB8006504
+#define set_AIO_SPARE_reg(data)   (*((volatile unsigned int*) AIO_SPARE_reg)=data)
+#define get_AIO_SPARE_reg   (*((volatile unsigned int*) AIO_SPARE_reg))
+#define AIO_SPARE_inst_adr                                                           "0x0041"
+#define AIO_SPARE_inst                                                               0x0041
+#define AIO_SPARE_spare_shift                                                        (0)
+#define AIO_SPARE_spare_mask                                                         (0xFFFFFFFF)
+#define AIO_SPARE_spare(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define AIO_SPARE_spare_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define AIO_SPARE_get_spare(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIO_GLOBAL                                                                   0x18006508
+#define AIO_GLOBAL_reg_addr                                                          "0xB8006508"
+#define AIO_GLOBAL_reg                                                               0xB8006508
+#define set_AIO_GLOBAL_reg(data)   (*((volatile unsigned int*) AIO_GLOBAL_reg)=data)
+#define get_AIO_GLOBAL_reg   (*((volatile unsigned int*) AIO_GLOBAL_reg))
+#define AIO_GLOBAL_inst_adr                                                          "0x0042"
+#define AIO_GLOBAL_inst                                                              0x0042
+#define AIO_GLOBAL_spf_fs_autoswitch_shift                                           (2)
+#define AIO_GLOBAL_spf_fs_autoswitch_mask                                            (0x00000004)
+#define AIO_GLOBAL_spf_fs_autoswitch(data)                                           (0x00000004&((data)<<2))
+#define AIO_GLOBAL_spf_fs_autoswitch_src(data)                                       ((0x00000004&(data))>>2)
+#define AIO_GLOBAL_get_spf_fs_autoswitch(data)                                       ((0x00000004&(data))>>2)
+#define AIO_GLOBAL_multireq_en_shift                                                 (1)
+#define AIO_GLOBAL_multireq_en_mask                                                  (0x00000002)
+#define AIO_GLOBAL_multireq_en(data)                                                 (0x00000002&((data)<<1))
+#define AIO_GLOBAL_multireq_en_src(data)                                             ((0x00000002&(data))>>1)
+#define AIO_GLOBAL_get_multireq_en(data)                                             ((0x00000002&(data))>>1)
+#define AIO_GLOBAL_gating_enable_shift                                               (0)
+#define AIO_GLOBAL_gating_enable_mask                                                (0x00000001)
+#define AIO_GLOBAL_gating_enable(data)                                               (0x00000001&((data)<<0))
+#define AIO_GLOBAL_gating_enable_src(data)                                           ((0x00000001&(data))>>0)
+#define AIO_GLOBAL_get_gating_enable(data)                                           ((0x00000001&(data))>>0)
+
+
+#define AIO_BIST1                                                                    0x1800650c
+#define AIO_BIST1_reg_addr                                                           "0xB800650C"
+#define AIO_BIST1_reg                                                                0xB800650C
+#define set_AIO_BIST1_reg(data)   (*((volatile unsigned int*) AIO_BIST1_reg)=data)
+#define get_AIO_BIST1_reg   (*((volatile unsigned int*) AIO_BIST1_reg))
+#define AIO_BIST1_inst_adr                                                           "0x0043"
+#define AIO_BIST1_inst                                                               0x0043
+#define AIO_BIST1_drf_test_resume_con2_shift                                         (5)
+#define AIO_BIST1_drf_test_resume_con2_mask                                          (0x00000020)
+#define AIO_BIST1_drf_test_resume_con2(data)                                         (0x00000020&((data)<<5))
+#define AIO_BIST1_drf_test_resume_con2_src(data)                                     ((0x00000020&(data))>>5)
+#define AIO_BIST1_get_drf_test_resume_con2(data)                                     ((0x00000020&(data))>>5)
+#define AIO_BIST1_drf_en_con2_shift                                                  (4)
+#define AIO_BIST1_drf_en_con2_mask                                                   (0x00000010)
+#define AIO_BIST1_drf_en_con2(data)                                                  (0x00000010&((data)<<4))
+#define AIO_BIST1_drf_en_con2_src(data)                                              ((0x00000010&(data))>>4)
+#define AIO_BIST1_get_drf_en_con2(data)                                              ((0x00000010&(data))>>4)
+#define AIO_BIST1_en_con2_shift                                                      (3)
+#define AIO_BIST1_en_con2_mask                                                       (0x00000008)
+#define AIO_BIST1_en_con2(data)                                                      (0x00000008&((data)<<3))
+#define AIO_BIST1_en_con2_src(data)                                                  ((0x00000008&(data))>>3)
+#define AIO_BIST1_get_en_con2(data)                                                  ((0x00000008&(data))>>3)
+#define AIO_BIST1_drf_test_resume_con1_shift                                         (2)
+#define AIO_BIST1_drf_test_resume_con1_mask                                          (0x00000004)
+#define AIO_BIST1_drf_test_resume_con1(data)                                         (0x00000004&((data)<<2))
+#define AIO_BIST1_drf_test_resume_con1_src(data)                                     ((0x00000004&(data))>>2)
+#define AIO_BIST1_get_drf_test_resume_con1(data)                                     ((0x00000004&(data))>>2)
+#define AIO_BIST1_drf_en_con1_shift                                                  (1)
+#define AIO_BIST1_drf_en_con1_mask                                                   (0x00000002)
+#define AIO_BIST1_drf_en_con1(data)                                                  (0x00000002&((data)<<1))
+#define AIO_BIST1_drf_en_con1_src(data)                                              ((0x00000002&(data))>>1)
+#define AIO_BIST1_get_drf_en_con1(data)                                              ((0x00000002&(data))>>1)
+#define AIO_BIST1_en_con1_shift                                                      (0)
+#define AIO_BIST1_en_con1_mask                                                       (0x00000001)
+#define AIO_BIST1_en_con1(data)                                                      (0x00000001&((data)<<0))
+#define AIO_BIST1_en_con1_src(data)                                                  ((0x00000001&(data))>>0)
+#define AIO_BIST1_get_en_con1(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define AIO_BIST2                                                                    0x18006510
+#define AIO_BIST2_reg_addr                                                           "0xB8006510"
+#define AIO_BIST2_reg                                                                0xB8006510
+#define set_AIO_BIST2_reg(data)   (*((volatile unsigned int*) AIO_BIST2_reg)=data)
+#define get_AIO_BIST2_reg   (*((volatile unsigned int*) AIO_BIST2_reg))
+#define AIO_BIST2_inst_adr                                                           "0x0044"
+#define AIO_BIST2_inst                                                               0x0044
+#define AIO_BIST2_drf_start_pause_con2_shift                                         (15)
+#define AIO_BIST2_drf_start_pause_con2_mask                                          (0x00008000)
+#define AIO_BIST2_drf_start_pause_con2(data)                                         (0x00008000&((data)<<15))
+#define AIO_BIST2_drf_start_pause_con2_src(data)                                     ((0x00008000&(data))>>15)
+#define AIO_BIST2_get_drf_start_pause_con2(data)                                     ((0x00008000&(data))>>15)
+#define AIO_BIST2_drf_fail_2_con2_shift                                              (14)
+#define AIO_BIST2_drf_fail_2_con2_mask                                               (0x00004000)
+#define AIO_BIST2_drf_fail_2_con2(data)                                              (0x00004000&((data)<<14))
+#define AIO_BIST2_drf_fail_2_con2_src(data)                                          ((0x00004000&(data))>>14)
+#define AIO_BIST2_get_drf_fail_2_con2(data)                                          ((0x00004000&(data))>>14)
+#define AIO_BIST2_drf_fail_1_con2_shift                                              (13)
+#define AIO_BIST2_drf_fail_1_con2_mask                                               (0x00002000)
+#define AIO_BIST2_drf_fail_1_con2(data)                                              (0x00002000&((data)<<13))
+#define AIO_BIST2_drf_fail_1_con2_src(data)                                          ((0x00002000&(data))>>13)
+#define AIO_BIST2_get_drf_fail_1_con2(data)                                          ((0x00002000&(data))>>13)
+#define AIO_BIST2_drf_fail_0_con2_shift                                              (12)
+#define AIO_BIST2_drf_fail_0_con2_mask                                               (0x00001000)
+#define AIO_BIST2_drf_fail_0_con2(data)                                              (0x00001000&((data)<<12))
+#define AIO_BIST2_drf_fail_0_con2_src(data)                                          ((0x00001000&(data))>>12)
+#define AIO_BIST2_get_drf_fail_0_con2(data)                                          ((0x00001000&(data))>>12)
+#define AIO_BIST2_drf_done_con2_shift                                                (11)
+#define AIO_BIST2_drf_done_con2_mask                                                 (0x00000800)
+#define AIO_BIST2_drf_done_con2(data)                                                (0x00000800&((data)<<11))
+#define AIO_BIST2_drf_done_con2_src(data)                                            ((0x00000800&(data))>>11)
+#define AIO_BIST2_get_drf_done_con2(data)                                            ((0x00000800&(data))>>11)
+#define AIO_BIST2_fail_2_con2_shift                                                  (10)
+#define AIO_BIST2_fail_2_con2_mask                                                   (0x00000400)
+#define AIO_BIST2_fail_2_con2(data)                                                  (0x00000400&((data)<<10))
+#define AIO_BIST2_fail_2_con2_src(data)                                              ((0x00000400&(data))>>10)
+#define AIO_BIST2_get_fail_2_con2(data)                                              ((0x00000400&(data))>>10)
+#define AIO_BIST2_fail_1_con2_shift                                                  (9)
+#define AIO_BIST2_fail_1_con2_mask                                                   (0x00000200)
+#define AIO_BIST2_fail_1_con2(data)                                                  (0x00000200&((data)<<9))
+#define AIO_BIST2_fail_1_con2_src(data)                                              ((0x00000200&(data))>>9)
+#define AIO_BIST2_get_fail_1_con2(data)                                              ((0x00000200&(data))>>9)
+#define AIO_BIST2_fail_0_con2_shift                                                  (8)
+#define AIO_BIST2_fail_0_con2_mask                                                   (0x00000100)
+#define AIO_BIST2_fail_0_con2(data)                                                  (0x00000100&((data)<<8))
+#define AIO_BIST2_fail_0_con2_src(data)                                              ((0x00000100&(data))>>8)
+#define AIO_BIST2_get_fail_0_con2(data)                                              ((0x00000100&(data))>>8)
+#define AIO_BIST2_done_con2_shift                                                    (7)
+#define AIO_BIST2_done_con2_mask                                                     (0x00000080)
+#define AIO_BIST2_done_con2(data)                                                    (0x00000080&((data)<<7))
+#define AIO_BIST2_done_con2_src(data)                                                ((0x00000080&(data))>>7)
+#define AIO_BIST2_get_done_con2(data)                                                ((0x00000080&(data))>>7)
+#define AIO_BIST2_drf_start_pause_con1_shift                                         (6)
+#define AIO_BIST2_drf_start_pause_con1_mask                                          (0x00000040)
+#define AIO_BIST2_drf_start_pause_con1(data)                                         (0x00000040&((data)<<6))
+#define AIO_BIST2_drf_start_pause_con1_src(data)                                     ((0x00000040&(data))>>6)
+#define AIO_BIST2_get_drf_start_pause_con1(data)                                     ((0x00000040&(data))>>6)
+#define AIO_BIST2_drf_fail_1_con1_shift                                              (5)
+#define AIO_BIST2_drf_fail_1_con1_mask                                               (0x00000020)
+#define AIO_BIST2_drf_fail_1_con1(data)                                              (0x00000020&((data)<<5))
+#define AIO_BIST2_drf_fail_1_con1_src(data)                                          ((0x00000020&(data))>>5)
+#define AIO_BIST2_get_drf_fail_1_con1(data)                                          ((0x00000020&(data))>>5)
+#define AIO_BIST2_drf_fail_0_con1_shift                                              (4)
+#define AIO_BIST2_drf_fail_0_con1_mask                                               (0x00000010)
+#define AIO_BIST2_drf_fail_0_con1(data)                                              (0x00000010&((data)<<4))
+#define AIO_BIST2_drf_fail_0_con1_src(data)                                          ((0x00000010&(data))>>4)
+#define AIO_BIST2_get_drf_fail_0_con1(data)                                          ((0x00000010&(data))>>4)
+#define AIO_BIST2_drf_done_con1_shift                                                (3)
+#define AIO_BIST2_drf_done_con1_mask                                                 (0x00000008)
+#define AIO_BIST2_drf_done_con1(data)                                                (0x00000008&((data)<<3))
+#define AIO_BIST2_drf_done_con1_src(data)                                            ((0x00000008&(data))>>3)
+#define AIO_BIST2_get_drf_done_con1(data)                                            ((0x00000008&(data))>>3)
+#define AIO_BIST2_fail_1_con1_shift                                                  (2)
+#define AIO_BIST2_fail_1_con1_mask                                                   (0x00000004)
+#define AIO_BIST2_fail_1_con1(data)                                                  (0x00000004&((data)<<2))
+#define AIO_BIST2_fail_1_con1_src(data)                                              ((0x00000004&(data))>>2)
+#define AIO_BIST2_get_fail_1_con1(data)                                              ((0x00000004&(data))>>2)
+#define AIO_BIST2_fail_0_con1_shift                                                  (1)
+#define AIO_BIST2_fail_0_con1_mask                                                   (0x00000002)
+#define AIO_BIST2_fail_0_con1(data)                                                  (0x00000002&((data)<<1))
+#define AIO_BIST2_fail_0_con1_src(data)                                              ((0x00000002&(data))>>1)
+#define AIO_BIST2_get_fail_0_con1(data)                                              ((0x00000002&(data))>>1)
+#define AIO_BIST2_done_con1_shift                                                    (0)
+#define AIO_BIST2_done_con1_mask                                                     (0x00000001)
+#define AIO_BIST2_done_con1(data)                                                    (0x00000001&((data)<<0))
+#define AIO_BIST2_done_con1_src(data)                                                ((0x00000001&(data))>>0)
+#define AIO_BIST2_get_done_con1(data)                                                ((0x00000001&(data))>>0)
+
+
+#define AIO_BIST3                                                                    0x18006514
+#define AIO_BIST3_reg_addr                                                           "0xB8006514"
+#define AIO_BIST3_reg                                                                0xB8006514
+#define set_AIO_BIST3_reg(data)   (*((volatile unsigned int*) AIO_BIST3_reg)=data)
+#define get_AIO_BIST3_reg   (*((volatile unsigned int*) AIO_BIST3_reg))
+#define AIO_BIST3_inst_adr                                                           "0x0045"
+#define AIO_BIST3_inst                                                               0x0045
+#define AIO_BIST3_rme_shift                                                          (4)
+#define AIO_BIST3_rme_mask                                                           (0x00000010)
+#define AIO_BIST3_rme(data)                                                          (0x00000010&((data)<<4))
+#define AIO_BIST3_rme_src(data)                                                      ((0x00000010&(data))>>4)
+#define AIO_BIST3_get_rme(data)                                                      ((0x00000010&(data))>>4)
+#define AIO_BIST3_rm_shift                                                           (0)
+#define AIO_BIST3_rm_mask                                                            (0x0000000F)
+#define AIO_BIST3_rm(data)                                                           (0x0000000F&((data)<<0))
+#define AIO_BIST3_rm_src(data)                                                       ((0x0000000F&(data))>>0)
+#define AIO_BIST3_get_rm(data)                                                       ((0x0000000F&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/arm_asm_macro.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/arm_asm_macro.h
new file mode 100644
index 00000000..ed8ac08
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/arm_asm_macro.h
@@ -0,0 +1,122 @@
+#ifndef _ARM_ASM_MACRO_H_
+#define _ARM_ASM_MACRO_H_
+
+//===== Register Write =====
+#define ARM_REG_WR(addr, addr_reg, data, data_reg) \
+        LDR     addr_reg, =addr; \
+        LDR     data_reg, =data; \
+        STR     data_reg, [addr_reg]; \
+
+//===== Register Read Without Check =====
+#define ARM_REG_RD(addr, addr_reg, data_reg) \
+        LDR     addr_reg, =addr; \
+        LDR     data_reg, [addr_reg]; \
+
+//===== Register Read With Check =====
+#define ARM_CHECK_RD_REG(addr, rd_val, mask, addr_reg, rd_reg, chk_reg) \
+        LDR     addr_reg, =addr; \
+        LDR     rd_reg, [addr_reg]; \
+        LDR     chk_reg,  =mask; \
+        AND     rd_reg, rd_reg, chk_reg; \
+        LDR     addr_reg, =rd_val; \
+        AND     addr_reg, addr_reg, chk_reg; \
+        CMP     addr_reg, rd_reg; \
+        BNE     DIAG_FAIL; \
+
+//===== Register Write With Read Check =====
+#define ARM_CHECK_WR_REG(addr, wr_val, rd_val, mask, reg1, reg2, reg3) \
+	LDR     reg1, =addr; \
+	LDR     reg2, =wr_val; \
+        STR     reg2, [reg1]; \
+        LDR     reg3, [reg1]; \
+	LDR     reg2, =rd_val; \
+        LDR     reg1, =mask; \
+        AND     reg3, reg3, reg1; \
+        CMP     reg2, reg3; \
+        BNE     DIAG_FAIL; \
+
+//===== Delay Loop =====
+#define ARM_DELAY(count,reg)  \
+        LDR     reg, =count; \
+9:      SUB     reg, reg, #1; \
+        CMP     reg, #0; \
+        BNE     9b;
+
+//===== Push R0-R12 & R14 to STACK =====
+#define ARM_PUSH_STACK() \
+       STMFD   r13!, {r0-r12,r14}; # r13 is Stack Point \
+
+//===== Pop R0-R12 & R14 to STACK =====
+#define ARM_POP_STACK() \
+        LDMFD   r13!, {r0-r12,r14}; # r13 is Stack Point \
+
+//===== If Read Value == 00000001~7FFFFFFFF(>0), Jump =====
+#define ARM_CHECK_RD_REG_JB(addr, mask, reg1, reg2, jump_label) \
+	LDR     reg1, =addr; \
+        LDR     reg2, [reg1]; \
+        LDR     reg1, =mask; \
+        AND     reg2, reg2, reg1; \
+        CMP     reg2, #0; \
+        BGT     jump_label; \
+
+//===== If Read Value == 80000000~FFFFFFFE(<0), Jump =====
+#define ARM_CHECK_RD_REG_JNB(addr, mask, reg1, reg2, jump_label) \
+	LDR     reg1, =addr; \
+        LDR     reg2, [reg1]; \
+        LDR     reg1, =mask; \
+	MVN     reg2, reg2; \
+        AND     reg2, reg2, reg1; \
+        CMP     reg2, #0; \
+        BGT     jump_label; \
+
+//===== If Read Value == rd_val, Jump =====
+#define ARM_CHECK_RD_REG_JE(addr, rd_val, mask, reg1, reg2, jump_label) \
+	LDR     reg1, =addr; \
+        LDR     reg2, [reg1]; \
+        LDR     reg1, =mask; \
+        AND     reg2, reg2, reg1; \
+        LDR     reg1, =rd_val; \
+        CMP     reg2, reg1; \
+        BEQ     jump_label; \
+
+//===== If Read Value !== rd_val, Jump =====
+#define ARM_CHECK_RD_REG_JNE(addr, rd_val, mask, reg1, reg2, jump_label) \
+        LDR     reg1, =addr; \
+        LDR     reg2, [reg1]; \
+        LDR     reg1, =mask; \
+        AND     reg2, reg2, reg1; \
+        LDR     reg1, =rd_val; \
+        CMP     reg2, reg1; \
+        BNE     jump_label; \
+
+//===== WAIT =====
+#define ARM_WAIT(addr,mask,value,reg1,reg2) \
+	NOP; \
+	NOP; \
+	NOP; \
+	NOP; \
+8:	LDR     reg1, =addr; \
+	LDR     reg2, [reg1]; \
+	LDR     reg1, =mask; \
+        AND     reg2, reg2, reg1; \
+        LDR     reg1, =value; \
+        CMP     reg2, reg1; \
+	BNE     8b; \
+
+// Kevin Add
+#define ARM_GET_PERIPH_BASE(reg1) \
+    MRC     p15, 4, reg1, c15, c0, 0; \
+    ORR     reg1, reg1, #(0xa << 28);
+
+#define ARM_ADR(reg1, value) \
+    movw    reg1, ((value & 0x0000ffff) >> 0 ); \
+    movt    reg1, ((value & 0xffff0000) >> 16);
+
+#define DELAY(count,reg) \
+    mov reg, #(count);   \
+9:  sub reg, #1;         \
+    cmp reg, #0;         \
+    bne 9b               
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/arm_misc.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/arm_misc.h
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/ata0_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/ata0_reg.h
new file mode 100644
index 00000000..f19dc26
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/ata0_reg.h
@@ -0,0 +1,603 @@
+// This file is generated using the spec version 2.1.0, firmware template version 1.39and DVR_Parser_0.43
+#ifndef _ATA0_REG_H_INCLUDED_
+#define _ATA0_REG_H_INCLUDED_
+
+//#define  _ATA0_USE_STRUCT
+#ifdef _ATA0_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data:16;
+}ata0_CMD0;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata0_CMD1;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata0_CMD2;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata0_CMD3;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata0_CMD4;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata0_CMD5;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata0_CMD6;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata0_CMD7;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata0_CTL6;
+
+typedef struct
+{
+    unsigned int    trp:6;
+    unsigned int    tmli:3;
+    unsigned int    tss:4;
+    unsigned int    udmahold:3;
+    unsigned int    cyc:4;
+    unsigned int    toutcyc:9;
+    unsigned int    sample:1;
+    unsigned int    mode:2;
+}ata0_DEV0;
+
+typedef struct
+{
+    unsigned int    trp:6;
+    unsigned int    tmli:3;
+    unsigned int    tss:4;
+    unsigned int    udmahold:3;
+    unsigned int    cyc:4;
+    unsigned int    toutcyc:9;
+    unsigned int    sample:1;
+    unsigned int    mode:2;
+}ata0_DEV1;
+
+typedef struct
+{
+    unsigned int    t3d:5;
+    unsigned int    t2d:6;
+    unsigned int    t1d:5;
+    unsigned int    t3r:5;
+    unsigned int    t2r:6;
+    unsigned int    t1r:5;
+}ata0_PIO0;
+
+typedef struct
+{
+    unsigned int    t3d:5;
+    unsigned int    t2d:6;
+    unsigned int    t1d:5;
+    unsigned int    t3r:5;
+    unsigned int    t2r:6;
+    unsigned int    t1r:5;
+}ata0_PIO1;
+
+typedef struct
+{
+    unsigned int    t9:5;
+    unsigned int    t8:6;
+    unsigned int    t7:5;
+    unsigned int    t6:5;
+    unsigned int    t5:6;
+    unsigned int    t4:5;
+}ata0_DMA0;
+
+typedef struct
+{
+    unsigned int    t9:5;
+    unsigned int    t8:6;
+    unsigned int    t7:5;
+    unsigned int    t6:5;
+    unsigned int    t5:6;
+    unsigned int    t4:5;
+}ata0_DMA1;
+
+typedef struct
+{
+    unsigned int    cnt:32;
+}ata0_DLEN;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    cpen:1;
+    unsigned int    swap:1;
+    unsigned int    write:1;
+    unsigned int    device:1;
+    unsigned int    reserved_1:1;
+}ata0_CTL;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    go:1;
+}ata0_GO;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    timeout:1;
+    unsigned int    intrq:1;
+    unsigned int    reserved_1:1;
+    unsigned int    data_done:1;
+    unsigned int    write_data:1;
+}ata0_STATUS;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    timeout_en:1;
+    unsigned int    intrq_en:1;
+    unsigned int    reserved_1:1;
+    unsigned int    data_done_en:1;
+    unsigned int    write_data:1;
+}ata0_EN;
+
+typedef struct
+{
+    unsigned int    reserved_0:6;
+    unsigned int    adr:26;
+}ata0_INADR;
+
+typedef struct
+{
+    unsigned int    reserved_0:6;
+    unsigned int    adr:26;
+}ata0_OUTADR;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    crc_ini:16;
+}ata0_CRC;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    dev_rstn:1;
+}ata0_RST;
+#endif
+
+#define ATA0_CMD0                                                     0x18012000
+#define ATA0_CMD0_reg_addr                                            "0xB8012000"
+#define ATA0_CMD0_reg                                                 0xB8012000
+#define ATA0_CMD0_inst_addr                                           "0x0000"
+#define ATA0_CMD0_inst                                                0x0000
+#define ATA0_CMD0_data_shift                                          (0)
+#define ATA0_CMD0_data_mask                                           (0x0000FFFF)
+#define ATA0_CMD0_data(data)                                          (0x0000FFFF&(data))
+#define ATA0_CMD0_get_data(data)                                      (0x0000FFFF&(data))
+
+#define ATA0_CMD1                                                     0x18012004
+#define ATA0_CMD1_reg_addr                                            "0xB8012004"
+#define ATA0_CMD1_reg                                                 0xB8012004
+#define ATA0_CMD1_inst_addr                                           "0x0001"
+#define ATA0_CMD1_inst                                                0x0001
+#define ATA0_CMD1_data_shift                                          (0)
+#define ATA0_CMD1_data_mask                                           (0x000000FF)
+#define ATA0_CMD1_data(data)                                          (0x000000FF&(data))
+#define ATA0_CMD1_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA0_CMD2                                                     0x18012008
+#define ATA0_CMD2_reg_addr                                            "0xB8012008"
+#define ATA0_CMD2_reg                                                 0xB8012008
+#define ATA0_CMD2_inst_addr                                           "0x0002"
+#define ATA0_CMD2_inst                                                0x0002
+#define ATA0_CMD2_data_shift                                          (0)
+#define ATA0_CMD2_data_mask                                           (0x000000FF)
+#define ATA0_CMD2_data(data)                                          (0x000000FF&(data))
+#define ATA0_CMD2_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA0_CMD3                                                     0x1801200C
+#define ATA0_CMD3_reg_addr                                            "0xB801200C"
+#define ATA0_CMD3_reg                                                 0xB801200C
+#define ATA0_CMD3_inst_addr                                           "0x0003"
+#define ATA0_CMD3_inst                                                0x0003
+#define ATA0_CMD3_data_shift                                          (0)
+#define ATA0_CMD3_data_mask                                           (0x000000FF)
+#define ATA0_CMD3_data(data)                                          (0x000000FF&(data))
+#define ATA0_CMD3_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA0_CMD4                                                     0x18012010
+#define ATA0_CMD4_reg_addr                                            "0xB8012010"
+#define ATA0_CMD4_reg                                                 0xB8012010
+#define ATA0_CMD4_inst_addr                                           "0x0004"
+#define ATA0_CMD4_inst                                                0x0004
+#define ATA0_CMD4_data_shift                                          (0)
+#define ATA0_CMD4_data_mask                                           (0x000000FF)
+#define ATA0_CMD4_data(data)                                          (0x000000FF&(data))
+#define ATA0_CMD4_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA0_CMD5                                                     0x18012014
+#define ATA0_CMD5_reg_addr                                            "0xB8012014"
+#define ATA0_CMD5_reg                                                 0xB8012014
+#define ATA0_CMD5_inst_addr                                           "0x0005"
+#define ATA0_CMD5_inst                                                0x0005
+#define ATA0_CMD5_data_shift                                          (0)
+#define ATA0_CMD5_data_mask                                           (0x000000FF)
+#define ATA0_CMD5_data(data)                                          (0x000000FF&(data))
+#define ATA0_CMD5_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA0_CMD6                                                     0x18012018
+#define ATA0_CMD6_reg_addr                                            "0xB8012018"
+#define ATA0_CMD6_reg                                                 0xB8012018
+#define ATA0_CMD6_inst_addr                                           "0x0006"
+#define ATA0_CMD6_inst                                                0x0006
+#define ATA0_CMD6_data_shift                                          (0)
+#define ATA0_CMD6_data_mask                                           (0x000000FF)
+#define ATA0_CMD6_data(data)                                          (0x000000FF&(data))
+#define ATA0_CMD6_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA0_CMD7                                                     0x1801201C
+#define ATA0_CMD7_reg_addr                                            "0xB801201C"
+#define ATA0_CMD7_reg                                                 0xB801201C
+#define ATA0_CMD7_inst_addr                                           "0x0007"
+#define ATA0_CMD7_inst                                                0x0007
+#define ATA0_CMD7_data_shift                                          (0)
+#define ATA0_CMD7_data_mask                                           (0x000000FF)
+#define ATA0_CMD7_data(data)                                          (0x000000FF&(data))
+#define ATA0_CMD7_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA0_CTL6                                                     0x18012020
+#define ATA0_CTL6_reg_addr                                            "0xB8012020"
+#define ATA0_CTL6_reg                                                 0xB8012020
+#define ATA0_CTL6_inst_addr                                           "0x0008"
+#define ATA0_CTL6_inst                                                0x0008
+#define ATA0_CTL6_data_shift                                          (0)
+#define ATA0_CTL6_data_mask                                           (0x000000FF)
+#define ATA0_CTL6_data(data)                                          (0x000000FF&(data))
+#define ATA0_CTL6_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA0_DEV0                                                     0x18012024
+#define ATA0_DEV0_reg_addr                                            "0xB8012024"
+#define ATA0_DEV0_reg                                                 0xB8012024
+#define ATA0_DEV0_inst_addr                                           "0x0009"
+#define ATA0_DEV0_inst                                                0x0009
+#define ATA0_DEV0_trp_shift                                           (26)
+#define ATA0_DEV0_tmli_shift                                          (23)
+#define ATA0_DEV0_tss_shift                                           (19)
+#define ATA0_DEV0_udmahold_shift                                      (16)
+#define ATA0_DEV0_cyc_shift                                           (12)
+#define ATA0_DEV0_toutcyc_shift                                       (3)
+#define ATA0_DEV0_sample_shift                                        (2)
+#define ATA0_DEV0_mode_shift                                          (0)
+#define ATA0_DEV0_trp_mask                                            (0xFC000000)
+#define ATA0_DEV0_tmli_mask                                           (0x03800000)
+#define ATA0_DEV0_tss_mask                                            (0x00780000)
+#define ATA0_DEV0_udmahold_mask                                       (0x00070000)
+#define ATA0_DEV0_cyc_mask                                            (0x0000F000)
+#define ATA0_DEV0_toutcyc_mask                                        (0x00000FF8)
+#define ATA0_DEV0_sample_mask                                         (0x00000004)
+#define ATA0_DEV0_mode_mask                                           (0x00000003)
+#define ATA0_DEV0_trp(data)                                           (0xFC000000&((data)<<26))
+#define ATA0_DEV0_tmli(data)                                          (0x03800000&((data)<<23))
+#define ATA0_DEV0_tss(data)                                           (0x00780000&((data)<<19))
+#define ATA0_DEV0_udmahold(data)                                      (0x00070000&((data)<<16))
+#define ATA0_DEV0_cyc(data)                                           (0x0000F000&((data)<<12))
+#define ATA0_DEV0_toutcyc(data)                                       (0x00000FF8&((data)<<3))
+#define ATA0_DEV0_sample(data)                                        (0x00000004&((data)<<2))
+#define ATA0_DEV0_mode(data)                                          (0x00000003&(data))
+#define ATA0_DEV0_get_trp(data)                                       ((0xFC000000&(data))>>26)
+#define ATA0_DEV0_get_tmli(data)                                      ((0x03800000&(data))>>23)
+#define ATA0_DEV0_get_tss(data)                                       ((0x00780000&(data))>>19)
+#define ATA0_DEV0_get_udmahold(data)                                  ((0x00070000&(data))>>16)
+#define ATA0_DEV0_get_cyc(data)                                       ((0x0000F000&(data))>>12)
+#define ATA0_DEV0_get_toutcyc(data)                                   ((0x00000FF8&(data))>>3)
+#define ATA0_DEV0_get_sample(data)                                    ((0x00000004&(data))>>2)
+#define ATA0_DEV0_get_mode(data)                                      (0x00000003&(data))
+
+#define ATA0_DEV1                                                     0x18012028
+#define ATA0_DEV1_reg_addr                                            "0xB8012028"
+#define ATA0_DEV1_reg                                                 0xB8012028
+#define ATA0_DEV1_inst_addr                                           "0x000A"
+#define ATA0_DEV1_inst                                                0x000A
+#define ATA0_DEV1_trp_shift                                           (26)
+#define ATA0_DEV1_tmli_shift                                          (23)
+#define ATA0_DEV1_tss_shift                                           (19)
+#define ATA0_DEV1_udmahold_shift                                      (16)
+#define ATA0_DEV1_cyc_shift                                           (12)
+#define ATA0_DEV1_toutcyc_shift                                       (3)
+#define ATA0_DEV1_sample_shift                                        (2)
+#define ATA0_DEV1_mode_shift                                          (0)
+#define ATA0_DEV1_trp_mask                                            (0xFC000000)
+#define ATA0_DEV1_tmli_mask                                           (0x03800000)
+#define ATA0_DEV1_tss_mask                                            (0x00780000)
+#define ATA0_DEV1_udmahold_mask                                       (0x00070000)
+#define ATA0_DEV1_cyc_mask                                            (0x0000F000)
+#define ATA0_DEV1_toutcyc_mask                                        (0x00000FF8)
+#define ATA0_DEV1_sample_mask                                         (0x00000004)
+#define ATA0_DEV1_mode_mask                                           (0x00000003)
+#define ATA0_DEV1_trp(data)                                           (0xFC000000&((data)<<26))
+#define ATA0_DEV1_tmli(data)                                          (0x03800000&((data)<<23))
+#define ATA0_DEV1_tss(data)                                           (0x00780000&((data)<<19))
+#define ATA0_DEV1_udmahold(data)                                      (0x00070000&((data)<<16))
+#define ATA0_DEV1_cyc(data)                                           (0x0000F000&((data)<<12))
+#define ATA0_DEV1_toutcyc(data)                                       (0x00000FF8&((data)<<3))
+#define ATA0_DEV1_sample(data)                                        (0x00000004&((data)<<2))
+#define ATA0_DEV1_mode(data)                                          (0x00000003&(data))
+#define ATA0_DEV1_get_trp(data)                                       ((0xFC000000&(data))>>26)
+#define ATA0_DEV1_get_tmli(data)                                      ((0x03800000&(data))>>23)
+#define ATA0_DEV1_get_tss(data)                                       ((0x00780000&(data))>>19)
+#define ATA0_DEV1_get_udmahold(data)                                  ((0x00070000&(data))>>16)
+#define ATA0_DEV1_get_cyc(data)                                       ((0x0000F000&(data))>>12)
+#define ATA0_DEV1_get_toutcyc(data)                                   ((0x00000FF8&(data))>>3)
+#define ATA0_DEV1_get_sample(data)                                    ((0x00000004&(data))>>2)
+#define ATA0_DEV1_get_mode(data)                                      (0x00000003&(data))
+
+#define ATA0_PIO0                                                     0x1801202C
+#define ATA0_PIO0_reg_addr                                            "0xB801202C"
+#define ATA0_PIO0_reg                                                 0xB801202C
+#define ATA0_PIO0_inst_addr                                           "0x000B"
+#define ATA0_PIO0_inst                                                0x000B
+#define ATA0_PIO0_t3d_shift                                           (27)
+#define ATA0_PIO0_t2d_shift                                           (21)
+#define ATA0_PIO0_t1d_shift                                           (16)
+#define ATA0_PIO0_t3r_shift                                           (11)
+#define ATA0_PIO0_t2r_shift                                           (5)
+#define ATA0_PIO0_t1r_shift                                           (0)
+#define ATA0_PIO0_t3d_mask                                            (0xF8000000)
+#define ATA0_PIO0_t2d_mask                                            (0x07E00000)
+#define ATA0_PIO0_t1d_mask                                            (0x001F0000)
+#define ATA0_PIO0_t3r_mask                                            (0x0000F800)
+#define ATA0_PIO0_t2r_mask                                            (0x000007E0)
+#define ATA0_PIO0_t1r_mask                                            (0x0000001F)
+#define ATA0_PIO0_t3d(data)                                           (0xF8000000&((data)<<27))
+#define ATA0_PIO0_t2d(data)                                           (0x07E00000&((data)<<21))
+#define ATA0_PIO0_t1d(data)                                           (0x001F0000&((data)<<16))
+#define ATA0_PIO0_t3r(data)                                           (0x0000F800&((data)<<11))
+#define ATA0_PIO0_t2r(data)                                           (0x000007E0&((data)<<5))
+#define ATA0_PIO0_t1r(data)                                           (0x0000001F&(data))
+#define ATA0_PIO0_get_t3d(data)                                       ((0xF8000000&(data))>>27)
+#define ATA0_PIO0_get_t2d(data)                                       ((0x07E00000&(data))>>21)
+#define ATA0_PIO0_get_t1d(data)                                       ((0x001F0000&(data))>>16)
+#define ATA0_PIO0_get_t3r(data)                                       ((0x0000F800&(data))>>11)
+#define ATA0_PIO0_get_t2r(data)                                       ((0x000007E0&(data))>>5)
+#define ATA0_PIO0_get_t1r(data)                                       (0x0000001F&(data))
+
+#define ATA0_PIO1                                                     0x18012030
+#define ATA0_PIO1_reg_addr                                            "0xB8012030"
+#define ATA0_PIO1_reg                                                 0xB8012030
+#define ATA0_PIO1_inst_addr                                           "0x000C"
+#define ATA0_PIO1_inst                                                0x000C
+#define ATA0_PIO1_t3d_shift                                           (27)
+#define ATA0_PIO1_t2d_shift                                           (21)
+#define ATA0_PIO1_t1d_shift                                           (16)
+#define ATA0_PIO1_t3r_shift                                           (11)
+#define ATA0_PIO1_t2r_shift                                           (5)
+#define ATA0_PIO1_t1r_shift                                           (0)
+#define ATA0_PIO1_t3d_mask                                            (0xF8000000)
+#define ATA0_PIO1_t2d_mask                                            (0x07E00000)
+#define ATA0_PIO1_t1d_mask                                            (0x001F0000)
+#define ATA0_PIO1_t3r_mask                                            (0x0000F800)
+#define ATA0_PIO1_t2r_mask                                            (0x000007E0)
+#define ATA0_PIO1_t1r_mask                                            (0x0000001F)
+#define ATA0_PIO1_t3d(data)                                           (0xF8000000&((data)<<27))
+#define ATA0_PIO1_t2d(data)                                           (0x07E00000&((data)<<21))
+#define ATA0_PIO1_t1d(data)                                           (0x001F0000&((data)<<16))
+#define ATA0_PIO1_t3r(data)                                           (0x0000F800&((data)<<11))
+#define ATA0_PIO1_t2r(data)                                           (0x000007E0&((data)<<5))
+#define ATA0_PIO1_t1r(data)                                           (0x0000001F&(data))
+#define ATA0_PIO1_get_t3d(data)                                       ((0xF8000000&(data))>>27)
+#define ATA0_PIO1_get_t2d(data)                                       ((0x07E00000&(data))>>21)
+#define ATA0_PIO1_get_t1d(data)                                       ((0x001F0000&(data))>>16)
+#define ATA0_PIO1_get_t3r(data)                                       ((0x0000F800&(data))>>11)
+#define ATA0_PIO1_get_t2r(data)                                       ((0x000007E0&(data))>>5)
+#define ATA0_PIO1_get_t1r(data)                                       (0x0000001F&(data))
+
+#define ATA0_DMA0                                                     0x18012034
+#define ATA0_DMA0_reg_addr                                            "0xB8012034"
+#define ATA0_DMA0_reg                                                 0xB8012034
+#define ATA0_DMA0_inst_addr                                           "0x000D"
+#define ATA0_DMA0_inst                                                0x000D
+#define ATA0_DMA0_t9_shift                                            (27)
+#define ATA0_DMA0_t8_shift                                            (21)
+#define ATA0_DMA0_t7_shift                                            (16)
+#define ATA0_DMA0_t6_shift                                            (11)
+#define ATA0_DMA0_t5_shift                                            (5)
+#define ATA0_DMA0_t4_shift                                            (0)
+#define ATA0_DMA0_t9_mask                                             (0xF8000000)
+#define ATA0_DMA0_t8_mask                                             (0x07E00000)
+#define ATA0_DMA0_t7_mask                                             (0x001F0000)
+#define ATA0_DMA0_t6_mask                                             (0x0000F800)
+#define ATA0_DMA0_t5_mask                                             (0x000007E0)
+#define ATA0_DMA0_t4_mask                                             (0x0000001F)
+#define ATA0_DMA0_t9(data)                                            (0xF8000000&((data)<<27))
+#define ATA0_DMA0_t8(data)                                            (0x07E00000&((data)<<21))
+#define ATA0_DMA0_t7(data)                                            (0x001F0000&((data)<<16))
+#define ATA0_DMA0_t6(data)                                            (0x0000F800&((data)<<11))
+#define ATA0_DMA0_t5(data)                                            (0x000007E0&((data)<<5))
+#define ATA0_DMA0_t4(data)                                            (0x0000001F&(data))
+#define ATA0_DMA0_get_t9(data)                                        ((0xF8000000&(data))>>27)
+#define ATA0_DMA0_get_t8(data)                                        ((0x07E00000&(data))>>21)
+#define ATA0_DMA0_get_t7(data)                                        ((0x001F0000&(data))>>16)
+#define ATA0_DMA0_get_t6(data)                                        ((0x0000F800&(data))>>11)
+#define ATA0_DMA0_get_t5(data)                                        ((0x000007E0&(data))>>5)
+#define ATA0_DMA0_get_t4(data)                                        (0x0000001F&(data))
+
+#define ATA0_DMA1                                                     0x18012038
+#define ATA0_DMA1_reg_addr                                            "0xB8012038"
+#define ATA0_DMA1_reg                                                 0xB8012038
+#define ATA0_DMA1_inst_addr                                           "0x000E"
+#define ATA0_DMA1_inst                                                0x000E
+#define ATA0_DMA1_t9_shift                                            (27)
+#define ATA0_DMA1_t8_shift                                            (21)
+#define ATA0_DMA1_t7_shift                                            (16)
+#define ATA0_DMA1_t6_shift                                            (11)
+#define ATA0_DMA1_t5_shift                                            (5)
+#define ATA0_DMA1_t4_shift                                            (0)
+#define ATA0_DMA1_t9_mask                                             (0xF8000000)
+#define ATA0_DMA1_t8_mask                                             (0x07E00000)
+#define ATA0_DMA1_t7_mask                                             (0x001F0000)
+#define ATA0_DMA1_t6_mask                                             (0x0000F800)
+#define ATA0_DMA1_t5_mask                                             (0x000007E0)
+#define ATA0_DMA1_t4_mask                                             (0x0000001F)
+#define ATA0_DMA1_t9(data)                                            (0xF8000000&((data)<<27))
+#define ATA0_DMA1_t8(data)                                            (0x07E00000&((data)<<21))
+#define ATA0_DMA1_t7(data)                                            (0x001F0000&((data)<<16))
+#define ATA0_DMA1_t6(data)                                            (0x0000F800&((data)<<11))
+#define ATA0_DMA1_t5(data)                                            (0x000007E0&((data)<<5))
+#define ATA0_DMA1_t4(data)                                            (0x0000001F&(data))
+#define ATA0_DMA1_get_t9(data)                                        ((0xF8000000&(data))>>27)
+#define ATA0_DMA1_get_t8(data)                                        ((0x07E00000&(data))>>21)
+#define ATA0_DMA1_get_t7(data)                                        ((0x001F0000&(data))>>16)
+#define ATA0_DMA1_get_t6(data)                                        ((0x0000F800&(data))>>11)
+#define ATA0_DMA1_get_t5(data)                                        ((0x000007E0&(data))>>5)
+#define ATA0_DMA1_get_t4(data)                                        (0x0000001F&(data))
+
+#define ATA0_DLEN                                                     0x1801203C
+#define ATA0_DLEN_reg_addr                                            "0xB801203C"
+#define ATA0_DLEN_reg                                                 0xB801203C
+#define ATA0_DLEN_inst_addr                                           "0x000F"
+#define ATA0_DLEN_inst                                                0x000F
+#define ATA0_DLEN_cnt_shift                                           (0)
+#define ATA0_DLEN_cnt_mask                                            (0xFFFFFFFF)
+#define ATA0_DLEN_cnt(data)                                           (0xFFFFFFFF&(data))
+#define ATA0_DLEN_get_cnt(data)                                       (0xFFFFFFFF&(data))
+
+#define ATA0_CTL                                                      0x18012040
+#define ATA0_CTL_reg_addr                                             "0xB8012040"
+#define ATA0_CTL_reg                                                  0xB8012040
+#define ATA0_CTL_inst_addr                                            "0x0010"
+#define ATA0_CTL_inst                                                 0x0010
+#define ATA0_CTL_cpen_shift                                           (4)
+#define ATA0_CTL_swap_shift                                           (3)
+#define ATA0_CTL_write_shift                                          (2)
+#define ATA0_CTL_device_shift                                         (1)
+#define ATA0_CTL_cpen_mask                                            (0x00000010)
+#define ATA0_CTL_swap_mask                                            (0x00000008)
+#define ATA0_CTL_write_mask                                           (0x00000004)
+#define ATA0_CTL_device_mask                                          (0x00000002)
+#define ATA0_CTL_cpen(data)                                           (0x00000010&((data)<<4))
+#define ATA0_CTL_swap(data)                                           (0x00000008&((data)<<3))
+#define ATA0_CTL_write(data)                                          (0x00000004&((data)<<2))
+#define ATA0_CTL_device(data)                                         (0x00000002&((data)<<1))
+#define ATA0_CTL_get_cpen(data)                                       ((0x00000010&(data))>>4)
+#define ATA0_CTL_get_swap(data)                                       ((0x00000008&(data))>>3)
+#define ATA0_CTL_get_write(data)                                      ((0x00000004&(data))>>2)
+#define ATA0_CTL_get_device(data)                                     ((0x00000002&(data))>>1)
+
+#define ATA0_GO                                                       0x18012044
+#define ATA0_GO_reg_addr                                              "0xB8012044"
+#define ATA0_GO_reg                                                   0xB8012044
+#define ATA0_GO_inst_addr                                             "0x0011"
+#define ATA0_GO_inst                                                  0x0011
+#define ATA0_GO_go_shift                                              (0)
+#define ATA0_GO_go_mask                                               (0x00000001)
+#define ATA0_GO_go(data)                                              (0x00000001&(data))
+#define ATA0_GO_get_go(data)                                          (0x00000001&(data))
+
+#define ATA0_STATUS                                                   0x18012048
+#define ATA0_STATUS_reg_addr                                          "0xB8012048"
+#define ATA0_STATUS_reg                                               0xB8012048
+#define ATA0_STATUS_inst_addr                                         "0x0012"
+#define ATA0_STATUS_inst                                              0x0012
+#define ATA0_STATUS_timeout_shift                                     (4)
+#define ATA0_STATUS_intrq_shift                                       (3)
+#define ATA0_STATUS_data_done_shift                                   (1)
+#define ATA0_STATUS_write_data_shift                                  (0)
+#define ATA0_STATUS_timeout_mask                                      (0x00000010)
+#define ATA0_STATUS_intrq_mask                                        (0x00000008)
+#define ATA0_STATUS_data_done_mask                                    (0x00000002)
+#define ATA0_STATUS_write_data_mask                                   (0x00000001)
+#define ATA0_STATUS_timeout(data)                                     (0x00000010&((data)<<4))
+#define ATA0_STATUS_intrq(data)                                       (0x00000008&((data)<<3))
+#define ATA0_STATUS_data_done(data)                                   (0x00000002&((data)<<1))
+#define ATA0_STATUS_write_data(data)                                  (0x00000001&(data))
+#define ATA0_STATUS_get_timeout(data)                                 ((0x00000010&(data))>>4)
+#define ATA0_STATUS_get_intrq(data)                                   ((0x00000008&(data))>>3)
+#define ATA0_STATUS_get_data_done(data)                               ((0x00000002&(data))>>1)
+#define ATA0_STATUS_get_write_data(data)                              (0x00000001&(data))
+
+#define ATA0_EN                                                       0x1801204C
+#define ATA0_EN_reg_addr                                              "0xB801204C"
+#define ATA0_EN_reg                                                   0xB801204C
+#define ATA0_EN_inst_addr                                             "0x0013"
+#define ATA0_EN_inst                                                  0x0013
+#define ATA0_EN_timeout_en_shift                                      (4)
+#define ATA0_EN_intrq_en_shift                                        (3)
+#define ATA0_EN_data_done_en_shift                                    (1)
+#define ATA0_EN_write_data_shift                                      (0)
+#define ATA0_EN_timeout_en_mask                                       (0x00000010)
+#define ATA0_EN_intrq_en_mask                                         (0x00000008)
+#define ATA0_EN_data_done_en_mask                                     (0x00000002)
+#define ATA0_EN_write_data_mask                                       (0x00000001)
+#define ATA0_EN_timeout_en(data)                                      (0x00000010&((data)<<4))
+#define ATA0_EN_intrq_en(data)                                        (0x00000008&((data)<<3))
+#define ATA0_EN_data_done_en(data)                                    (0x00000002&((data)<<1))
+#define ATA0_EN_write_data(data)                                      (0x00000001&(data))
+#define ATA0_EN_get_timeout_en(data)                                  ((0x00000010&(data))>>4)
+#define ATA0_EN_get_intrq_en(data)                                    ((0x00000008&(data))>>3)
+#define ATA0_EN_get_data_done_en(data)                                ((0x00000002&(data))>>1)
+#define ATA0_EN_get_write_data(data)                                  (0x00000001&(data))
+
+#define ATA0_INADR                                                    0x18012050
+#define ATA0_INADR_reg_addr                                           "0xB8012050"
+#define ATA0_INADR_reg                                                0xB8012050
+#define ATA0_INADR_inst_addr                                          "0x0014"
+#define ATA0_INADR_inst                                               0x0014
+#define ATA0_INADR_adr_shift                                          (0)
+#define ATA0_INADR_adr_mask                                           (0x03FFFFFF)
+#define ATA0_INADR_adr(data)                                          (0x03FFFFFF&(data))
+#define ATA0_INADR_get_adr(data)                                      (0x03FFFFFF&(data))
+
+#define ATA0_OUTADR                                                   0x18012054
+#define ATA0_OUTADR_reg_addr                                          "0xB8012054"
+#define ATA0_OUTADR_reg                                               0xB8012054
+#define ATA0_OUTADR_inst_addr                                         "0x0015"
+#define ATA0_OUTADR_inst                                              0x0015
+#define ATA0_OUTADR_adr_shift                                         (0)
+#define ATA0_OUTADR_adr_mask                                          (0x03FFFFFF)
+#define ATA0_OUTADR_adr(data)                                         (0x03FFFFFF&(data))
+#define ATA0_OUTADR_get_adr(data)                                     (0x03FFFFFF&(data))
+
+#define ATA0_CRC                                                      0x18012058
+#define ATA0_CRC_reg_addr                                             "0xB8012058"
+#define ATA0_CRC_reg                                                  0xB8012058
+#define ATA0_CRC_inst_addr                                            "0x0016"
+#define ATA0_CRC_inst                                                 0x0016
+#define ATA0_CRC_crc_ini_shift                                        (0)
+#define ATA0_CRC_crc_ini_mask                                         (0x0000FFFF)
+#define ATA0_CRC_crc_ini(data)                                        (0x0000FFFF&(data))
+#define ATA0_CRC_get_crc_ini(data)                                    (0x0000FFFF&(data))
+
+#define ATA0_RST                                                      0x1801205C
+#define ATA0_RST_reg_addr                                             "0xB801205C"
+#define ATA0_RST_reg                                                  0xB801205C
+#define ATA0_RST_inst_addr                                            "0x0017"
+#define ATA0_RST_inst                                                 0x0017
+#define ATA0_RST_dev_rstn_shift                                       (0)
+#define ATA0_RST_dev_rstn_mask                                        (0x00000001)
+#define ATA0_RST_dev_rstn(data)                                       (0x00000001&(data))
+#define ATA0_RST_get_dev_rstn(data)                                   (0x00000001&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/ata1_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/ata1_reg.h
new file mode 100644
index 00000000..1fb1b61
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/ata1_reg.h
@@ -0,0 +1,603 @@
+// This file is generated using the spec version 2.1.0, firmware template version 1.39and DVR_Parser_0.43
+#ifndef _ATA1_REG_H_INCLUDED_
+#define _ATA1_REG_H_INCLUDED_
+
+//#define  _ATA1_USE_STRUCT
+#ifdef _ATA1_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data:16;
+}ata1_CMD0;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata1_CMD1;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata1_CMD2;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata1_CMD3;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata1_CMD4;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata1_CMD5;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata1_CMD6;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata1_CMD7;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}ata1_CTL6;
+
+typedef struct
+{
+    unsigned int    trp:6;
+    unsigned int    tmli:3;
+    unsigned int    tss:4;
+    unsigned int    udmahold:3;
+    unsigned int    cyc:4;
+    unsigned int    toutcyc:9;
+    unsigned int    sample:1;
+    unsigned int    mode:2;
+}ata1_DEV0;
+
+typedef struct
+{
+    unsigned int    trp:6;
+    unsigned int    tmli:3;
+    unsigned int    tss:4;
+    unsigned int    udmahold:3;
+    unsigned int    cyc:4;
+    unsigned int    toutcyc:9;
+    unsigned int    sample:1;
+    unsigned int    mode:2;
+}ata1_DEV1;
+
+typedef struct
+{
+    unsigned int    t3d:5;
+    unsigned int    t2d:6;
+    unsigned int    t1d:5;
+    unsigned int    t3r:5;
+    unsigned int    t2r:6;
+    unsigned int    t1r:5;
+}ata1_PIO0;
+
+typedef struct
+{
+    unsigned int    t3d:5;
+    unsigned int    t2d:6;
+    unsigned int    t1d:5;
+    unsigned int    t3r:5;
+    unsigned int    t2r:6;
+    unsigned int    t1r:5;
+}ata1_PIO1;
+
+typedef struct
+{
+    unsigned int    t9:5;
+    unsigned int    t8:6;
+    unsigned int    t7:5;
+    unsigned int    t6:5;
+    unsigned int    t5:6;
+    unsigned int    t4:5;
+}ata1_DMA0;
+
+typedef struct
+{
+    unsigned int    t9:5;
+    unsigned int    t8:6;
+    unsigned int    t7:5;
+    unsigned int    t6:5;
+    unsigned int    t5:6;
+    unsigned int    t4:5;
+}ata1_DMA1;
+
+typedef struct
+{
+    unsigned int    cnt:32;
+}ata1_DLEN;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    cpen:1;
+    unsigned int    swap:1;
+    unsigned int    write:1;
+    unsigned int    device:1;
+    unsigned int    reserved_1:1;
+}ata1_CTL;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    go:1;
+}ata1_GO;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    timeout:1;
+    unsigned int    intrq:1;
+    unsigned int    reserved_1:1;
+    unsigned int    data_done:1;
+    unsigned int    write_data:1;
+}ata1_STATUS;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    timeout_en:1;
+    unsigned int    intrq_en:1;
+    unsigned int    reserved_1:1;
+    unsigned int    data_done_en:1;
+    unsigned int    write_data:1;
+}ata1_EN;
+
+typedef struct
+{
+    unsigned int    reserved_0:6;
+    unsigned int    adr:26;
+}ata1_INADR;
+
+typedef struct
+{
+    unsigned int    reserved_0:6;
+    unsigned int    adr:26;
+}ata1_OUTADR;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    crc_ini:16;
+}ata1_CRC;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    dev_rstn:1;
+}ata1_RST;
+#endif
+
+#define ATA1_CMD0                                                     0x18012100
+#define ATA1_CMD0_reg_addr                                            "0xB8012100"
+#define ATA1_CMD0_reg                                                 0xB8012100
+#define ATA1_CMD0_inst_addr                                           "0x0040"
+#define ATA1_CMD0_inst                                                0x0040
+#define ATA1_CMD0_data_shift                                          (0)
+#define ATA1_CMD0_data_mask                                           (0x0000FFFF)
+#define ATA1_CMD0_data(data)                                          (0x0000FFFF&(data))
+#define ATA1_CMD0_get_data(data)                                      (0x0000FFFF&(data))
+
+#define ATA1_CMD1                                                     0x18012104
+#define ATA1_CMD1_reg_addr                                            "0xB8012104"
+#define ATA1_CMD1_reg                                                 0xB8012104
+#define ATA1_CMD1_inst_addr                                           "0x0041"
+#define ATA1_CMD1_inst                                                0x0041
+#define ATA1_CMD1_data_shift                                          (0)
+#define ATA1_CMD1_data_mask                                           (0x000000FF)
+#define ATA1_CMD1_data(data)                                          (0x000000FF&(data))
+#define ATA1_CMD1_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA1_CMD2                                                     0x18012108
+#define ATA1_CMD2_reg_addr                                            "0xB8012108"
+#define ATA1_CMD2_reg                                                 0xB8012108
+#define ATA1_CMD2_inst_addr                                           "0x0042"
+#define ATA1_CMD2_inst                                                0x0042
+#define ATA1_CMD2_data_shift                                          (0)
+#define ATA1_CMD2_data_mask                                           (0x000000FF)
+#define ATA1_CMD2_data(data)                                          (0x000000FF&(data))
+#define ATA1_CMD2_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA1_CMD3                                                     0x1801210C
+#define ATA1_CMD3_reg_addr                                            "0xB801210C"
+#define ATA1_CMD3_reg                                                 0xB801210C
+#define ATA1_CMD3_inst_addr                                           "0x0043"
+#define ATA1_CMD3_inst                                                0x0043
+#define ATA1_CMD3_data_shift                                          (0)
+#define ATA1_CMD3_data_mask                                           (0x000000FF)
+#define ATA1_CMD3_data(data)                                          (0x000000FF&(data))
+#define ATA1_CMD3_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA1_CMD4                                                     0x18012110
+#define ATA1_CMD4_reg_addr                                            "0xB8012110"
+#define ATA1_CMD4_reg                                                 0xB8012110
+#define ATA1_CMD4_inst_addr                                           "0x0044"
+#define ATA1_CMD4_inst                                                0x0044
+#define ATA1_CMD4_data_shift                                          (0)
+#define ATA1_CMD4_data_mask                                           (0x000000FF)
+#define ATA1_CMD4_data(data)                                          (0x000000FF&(data))
+#define ATA1_CMD4_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA1_CMD5                                                     0x18012114
+#define ATA1_CMD5_reg_addr                                            "0xB8012114"
+#define ATA1_CMD5_reg                                                 0xB8012114
+#define ATA1_CMD5_inst_addr                                           "0x0045"
+#define ATA1_CMD5_inst                                                0x0045
+#define ATA1_CMD5_data_shift                                          (0)
+#define ATA1_CMD5_data_mask                                           (0x000000FF)
+#define ATA1_CMD5_data(data)                                          (0x000000FF&(data))
+#define ATA1_CMD5_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA1_CMD6                                                     0x18012118
+#define ATA1_CMD6_reg_addr                                            "0xB8012118"
+#define ATA1_CMD6_reg                                                 0xB8012118
+#define ATA1_CMD6_inst_addr                                           "0x0046"
+#define ATA1_CMD6_inst                                                0x0046
+#define ATA1_CMD6_data_shift                                          (0)
+#define ATA1_CMD6_data_mask                                           (0x000000FF)
+#define ATA1_CMD6_data(data)                                          (0x000000FF&(data))
+#define ATA1_CMD6_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA1_CMD7                                                     0x1801211C
+#define ATA1_CMD7_reg_addr                                            "0xB801211C"
+#define ATA1_CMD7_reg                                                 0xB801211C
+#define ATA1_CMD7_inst_addr                                           "0x0047"
+#define ATA1_CMD7_inst                                                0x0047
+#define ATA1_CMD7_data_shift                                          (0)
+#define ATA1_CMD7_data_mask                                           (0x000000FF)
+#define ATA1_CMD7_data(data)                                          (0x000000FF&(data))
+#define ATA1_CMD7_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA1_CTL6                                                     0x18012120
+#define ATA1_CTL6_reg_addr                                            "0xB8012120"
+#define ATA1_CTL6_reg                                                 0xB8012120
+#define ATA1_CTL6_inst_addr                                           "0x0048"
+#define ATA1_CTL6_inst                                                0x0048
+#define ATA1_CTL6_data_shift                                          (0)
+#define ATA1_CTL6_data_mask                                           (0x000000FF)
+#define ATA1_CTL6_data(data)                                          (0x000000FF&(data))
+#define ATA1_CTL6_get_data(data)                                      (0x000000FF&(data))
+
+#define ATA1_DEV0                                                     0x18012124
+#define ATA1_DEV0_reg_addr                                            "0xB8012124"
+#define ATA1_DEV0_reg                                                 0xB8012124
+#define ATA1_DEV0_inst_addr                                           "0x0049"
+#define ATA1_DEV0_inst                                                0x0049
+#define ATA1_DEV0_trp_shift                                           (26)
+#define ATA1_DEV0_tmli_shift                                          (23)
+#define ATA1_DEV0_tss_shift                                           (19)
+#define ATA1_DEV0_udmahold_shift                                      (16)
+#define ATA1_DEV0_cyc_shift                                           (12)
+#define ATA1_DEV0_toutcyc_shift                                       (3)
+#define ATA1_DEV0_sample_shift                                        (2)
+#define ATA1_DEV0_mode_shift                                          (0)
+#define ATA1_DEV0_trp_mask                                            (0xFC000000)
+#define ATA1_DEV0_tmli_mask                                           (0x03800000)
+#define ATA1_DEV0_tss_mask                                            (0x00780000)
+#define ATA1_DEV0_udmahold_mask                                       (0x00070000)
+#define ATA1_DEV0_cyc_mask                                            (0x0000F000)
+#define ATA1_DEV0_toutcyc_mask                                        (0x00000FF8)
+#define ATA1_DEV0_sample_mask                                         (0x00000004)
+#define ATA1_DEV0_mode_mask                                           (0x00000003)
+#define ATA1_DEV0_trp(data)                                           (0xFC000000&((data)<<26))
+#define ATA1_DEV0_tmli(data)                                          (0x03800000&((data)<<23))
+#define ATA1_DEV0_tss(data)                                           (0x00780000&((data)<<19))
+#define ATA1_DEV0_udmahold(data)                                      (0x00070000&((data)<<16))
+#define ATA1_DEV0_cyc(data)                                           (0x0000F000&((data)<<12))
+#define ATA1_DEV0_toutcyc(data)                                       (0x00000FF8&((data)<<3))
+#define ATA1_DEV0_sample(data)                                        (0x00000004&((data)<<2))
+#define ATA1_DEV0_mode(data)                                          (0x00000003&(data))
+#define ATA1_DEV0_get_trp(data)                                       ((0xFC000000&(data))>>26)
+#define ATA1_DEV0_get_tmli(data)                                      ((0x03800000&(data))>>23)
+#define ATA1_DEV0_get_tss(data)                                       ((0x00780000&(data))>>19)
+#define ATA1_DEV0_get_udmahold(data)                                  ((0x00070000&(data))>>16)
+#define ATA1_DEV0_get_cyc(data)                                       ((0x0000F000&(data))>>12)
+#define ATA1_DEV0_get_toutcyc(data)                                   ((0x00000FF8&(data))>>3)
+#define ATA1_DEV0_get_sample(data)                                    ((0x00000004&(data))>>2)
+#define ATA1_DEV0_get_mode(data)                                      (0x00000003&(data))
+
+#define ATA1_DEV1                                                     0x18012128
+#define ATA1_DEV1_reg_addr                                            "0xB8012128"
+#define ATA1_DEV1_reg                                                 0xB8012128
+#define ATA1_DEV1_inst_addr                                           "0x004A"
+#define ATA1_DEV1_inst                                                0x004A
+#define ATA1_DEV1_trp_shift                                           (26)
+#define ATA1_DEV1_tmli_shift                                          (23)
+#define ATA1_DEV1_tss_shift                                           (19)
+#define ATA1_DEV1_udmahold_shift                                      (16)
+#define ATA1_DEV1_cyc_shift                                           (12)
+#define ATA1_DEV1_toutcyc_shift                                       (3)
+#define ATA1_DEV1_sample_shift                                        (2)
+#define ATA1_DEV1_mode_shift                                          (0)
+#define ATA1_DEV1_trp_mask                                            (0xFC000000)
+#define ATA1_DEV1_tmli_mask                                           (0x03800000)
+#define ATA1_DEV1_tss_mask                                            (0x00780000)
+#define ATA1_DEV1_udmahold_mask                                       (0x00070000)
+#define ATA1_DEV1_cyc_mask                                            (0x0000F000)
+#define ATA1_DEV1_toutcyc_mask                                        (0x00000FF8)
+#define ATA1_DEV1_sample_mask                                         (0x00000004)
+#define ATA1_DEV1_mode_mask                                           (0x00000003)
+#define ATA1_DEV1_trp(data)                                           (0xFC000000&((data)<<26))
+#define ATA1_DEV1_tmli(data)                                          (0x03800000&((data)<<23))
+#define ATA1_DEV1_tss(data)                                           (0x00780000&((data)<<19))
+#define ATA1_DEV1_udmahold(data)                                      (0x00070000&((data)<<16))
+#define ATA1_DEV1_cyc(data)                                           (0x0000F000&((data)<<12))
+#define ATA1_DEV1_toutcyc(data)                                       (0x00000FF8&((data)<<3))
+#define ATA1_DEV1_sample(data)                                        (0x00000004&((data)<<2))
+#define ATA1_DEV1_mode(data)                                          (0x00000003&(data))
+#define ATA1_DEV1_get_trp(data)                                       ((0xFC000000&(data))>>26)
+#define ATA1_DEV1_get_tmli(data)                                      ((0x03800000&(data))>>23)
+#define ATA1_DEV1_get_tss(data)                                       ((0x00780000&(data))>>19)
+#define ATA1_DEV1_get_udmahold(data)                                  ((0x00070000&(data))>>16)
+#define ATA1_DEV1_get_cyc(data)                                       ((0x0000F000&(data))>>12)
+#define ATA1_DEV1_get_toutcyc(data)                                   ((0x00000FF8&(data))>>3)
+#define ATA1_DEV1_get_sample(data)                                    ((0x00000004&(data))>>2)
+#define ATA1_DEV1_get_mode(data)                                      (0x00000003&(data))
+
+#define ATA1_PIO0                                                     0x1801212C
+#define ATA1_PIO0_reg_addr                                            "0xB801212C"
+#define ATA1_PIO0_reg                                                 0xB801212C
+#define ATA1_PIO0_inst_addr                                           "0x004B"
+#define ATA1_PIO0_inst                                                0x004B
+#define ATA1_PIO0_t3d_shift                                           (27)
+#define ATA1_PIO0_t2d_shift                                           (21)
+#define ATA1_PIO0_t1d_shift                                           (16)
+#define ATA1_PIO0_t3r_shift                                           (11)
+#define ATA1_PIO0_t2r_shift                                           (5)
+#define ATA1_PIO0_t1r_shift                                           (0)
+#define ATA1_PIO0_t3d_mask                                            (0xF8000000)
+#define ATA1_PIO0_t2d_mask                                            (0x07E00000)
+#define ATA1_PIO0_t1d_mask                                            (0x001F0000)
+#define ATA1_PIO0_t3r_mask                                            (0x0000F800)
+#define ATA1_PIO0_t2r_mask                                            (0x000007E0)
+#define ATA1_PIO0_t1r_mask                                            (0x0000001F)
+#define ATA1_PIO0_t3d(data)                                           (0xF8000000&((data)<<27))
+#define ATA1_PIO0_t2d(data)                                           (0x07E00000&((data)<<21))
+#define ATA1_PIO0_t1d(data)                                           (0x001F0000&((data)<<16))
+#define ATA1_PIO0_t3r(data)                                           (0x0000F800&((data)<<11))
+#define ATA1_PIO0_t2r(data)                                           (0x000007E0&((data)<<5))
+#define ATA1_PIO0_t1r(data)                                           (0x0000001F&(data))
+#define ATA1_PIO0_get_t3d(data)                                       ((0xF8000000&(data))>>27)
+#define ATA1_PIO0_get_t2d(data)                                       ((0x07E00000&(data))>>21)
+#define ATA1_PIO0_get_t1d(data)                                       ((0x001F0000&(data))>>16)
+#define ATA1_PIO0_get_t3r(data)                                       ((0x0000F800&(data))>>11)
+#define ATA1_PIO0_get_t2r(data)                                       ((0x000007E0&(data))>>5)
+#define ATA1_PIO0_get_t1r(data)                                       (0x0000001F&(data))
+
+#define ATA1_PIO1                                                     0x18012130
+#define ATA1_PIO1_reg_addr                                            "0xB8012130"
+#define ATA1_PIO1_reg                                                 0xB8012130
+#define ATA1_PIO1_inst_addr                                           "0x004C"
+#define ATA1_PIO1_inst                                                0x004C
+#define ATA1_PIO1_t3d_shift                                           (27)
+#define ATA1_PIO1_t2d_shift                                           (21)
+#define ATA1_PIO1_t1d_shift                                           (16)
+#define ATA1_PIO1_t3r_shift                                           (11)
+#define ATA1_PIO1_t2r_shift                                           (5)
+#define ATA1_PIO1_t1r_shift                                           (0)
+#define ATA1_PIO1_t3d_mask                                            (0xF8000000)
+#define ATA1_PIO1_t2d_mask                                            (0x07E00000)
+#define ATA1_PIO1_t1d_mask                                            (0x001F0000)
+#define ATA1_PIO1_t3r_mask                                            (0x0000F800)
+#define ATA1_PIO1_t2r_mask                                            (0x000007E0)
+#define ATA1_PIO1_t1r_mask                                            (0x0000001F)
+#define ATA1_PIO1_t3d(data)                                           (0xF8000000&((data)<<27))
+#define ATA1_PIO1_t2d(data)                                           (0x07E00000&((data)<<21))
+#define ATA1_PIO1_t1d(data)                                           (0x001F0000&((data)<<16))
+#define ATA1_PIO1_t3r(data)                                           (0x0000F800&((data)<<11))
+#define ATA1_PIO1_t2r(data)                                           (0x000007E0&((data)<<5))
+#define ATA1_PIO1_t1r(data)                                           (0x0000001F&(data))
+#define ATA1_PIO1_get_t3d(data)                                       ((0xF8000000&(data))>>27)
+#define ATA1_PIO1_get_t2d(data)                                       ((0x07E00000&(data))>>21)
+#define ATA1_PIO1_get_t1d(data)                                       ((0x001F0000&(data))>>16)
+#define ATA1_PIO1_get_t3r(data)                                       ((0x0000F800&(data))>>11)
+#define ATA1_PIO1_get_t2r(data)                                       ((0x000007E0&(data))>>5)
+#define ATA1_PIO1_get_t1r(data)                                       (0x0000001F&(data))
+
+#define ATA1_DMA0                                                     0x18012134
+#define ATA1_DMA0_reg_addr                                            "0xB8012134"
+#define ATA1_DMA0_reg                                                 0xB8012134
+#define ATA1_DMA0_inst_addr                                           "0x004D"
+#define ATA1_DMA0_inst                                                0x004D
+#define ATA1_DMA0_t9_shift                                            (27)
+#define ATA1_DMA0_t8_shift                                            (21)
+#define ATA1_DMA0_t7_shift                                            (16)
+#define ATA1_DMA0_t6_shift                                            (11)
+#define ATA1_DMA0_t5_shift                                            (5)
+#define ATA1_DMA0_t4_shift                                            (0)
+#define ATA1_DMA0_t9_mask                                             (0xF8000000)
+#define ATA1_DMA0_t8_mask                                             (0x07E00000)
+#define ATA1_DMA0_t7_mask                                             (0x001F0000)
+#define ATA1_DMA0_t6_mask                                             (0x0000F800)
+#define ATA1_DMA0_t5_mask                                             (0x000007E0)
+#define ATA1_DMA0_t4_mask                                             (0x0000001F)
+#define ATA1_DMA0_t9(data)                                            (0xF8000000&((data)<<27))
+#define ATA1_DMA0_t8(data)                                            (0x07E00000&((data)<<21))
+#define ATA1_DMA0_t7(data)                                            (0x001F0000&((data)<<16))
+#define ATA1_DMA0_t6(data)                                            (0x0000F800&((data)<<11))
+#define ATA1_DMA0_t5(data)                                            (0x000007E0&((data)<<5))
+#define ATA1_DMA0_t4(data)                                            (0x0000001F&(data))
+#define ATA1_DMA0_get_t9(data)                                        ((0xF8000000&(data))>>27)
+#define ATA1_DMA0_get_t8(data)                                        ((0x07E00000&(data))>>21)
+#define ATA1_DMA0_get_t7(data)                                        ((0x001F0000&(data))>>16)
+#define ATA1_DMA0_get_t6(data)                                        ((0x0000F800&(data))>>11)
+#define ATA1_DMA0_get_t5(data)                                        ((0x000007E0&(data))>>5)
+#define ATA1_DMA0_get_t4(data)                                        (0x0000001F&(data))
+
+#define ATA1_DMA1                                                     0x18012138
+#define ATA1_DMA1_reg_addr                                            "0xB8012138"
+#define ATA1_DMA1_reg                                                 0xB8012138
+#define ATA1_DMA1_inst_addr                                           "0x004E"
+#define ATA1_DMA1_inst                                                0x004E
+#define ATA1_DMA1_t9_shift                                            (27)
+#define ATA1_DMA1_t8_shift                                            (21)
+#define ATA1_DMA1_t7_shift                                            (16)
+#define ATA1_DMA1_t6_shift                                            (11)
+#define ATA1_DMA1_t5_shift                                            (5)
+#define ATA1_DMA1_t4_shift                                            (0)
+#define ATA1_DMA1_t9_mask                                             (0xF8000000)
+#define ATA1_DMA1_t8_mask                                             (0x07E00000)
+#define ATA1_DMA1_t7_mask                                             (0x001F0000)
+#define ATA1_DMA1_t6_mask                                             (0x0000F800)
+#define ATA1_DMA1_t5_mask                                             (0x000007E0)
+#define ATA1_DMA1_t4_mask                                             (0x0000001F)
+#define ATA1_DMA1_t9(data)                                            (0xF8000000&((data)<<27))
+#define ATA1_DMA1_t8(data)                                            (0x07E00000&((data)<<21))
+#define ATA1_DMA1_t7(data)                                            (0x001F0000&((data)<<16))
+#define ATA1_DMA1_t6(data)                                            (0x0000F800&((data)<<11))
+#define ATA1_DMA1_t5(data)                                            (0x000007E0&((data)<<5))
+#define ATA1_DMA1_t4(data)                                            (0x0000001F&(data))
+#define ATA1_DMA1_get_t9(data)                                        ((0xF8000000&(data))>>27)
+#define ATA1_DMA1_get_t8(data)                                        ((0x07E00000&(data))>>21)
+#define ATA1_DMA1_get_t7(data)                                        ((0x001F0000&(data))>>16)
+#define ATA1_DMA1_get_t6(data)                                        ((0x0000F800&(data))>>11)
+#define ATA1_DMA1_get_t5(data)                                        ((0x000007E0&(data))>>5)
+#define ATA1_DMA1_get_t4(data)                                        (0x0000001F&(data))
+
+#define ATA1_DLEN                                                     0x1801213C
+#define ATA1_DLEN_reg_addr                                            "0xB801213C"
+#define ATA1_DLEN_reg                                                 0xB801213C
+#define ATA1_DLEN_inst_addr                                           "0x004F"
+#define ATA1_DLEN_inst                                                0x004F
+#define ATA1_DLEN_cnt_shift                                           (0)
+#define ATA1_DLEN_cnt_mask                                            (0xFFFFFFFF)
+#define ATA1_DLEN_cnt(data)                                           (0xFFFFFFFF&(data))
+#define ATA1_DLEN_get_cnt(data)                                       (0xFFFFFFFF&(data))
+
+#define ATA1_CTL                                                      0x18012140
+#define ATA1_CTL_reg_addr                                             "0xB8012140"
+#define ATA1_CTL_reg                                                  0xB8012140
+#define ATA1_CTL_inst_addr                                            "0x0050"
+#define ATA1_CTL_inst                                                 0x0050
+#define ATA1_CTL_cpen_shift                                           (4)
+#define ATA1_CTL_swap_shift                                           (3)
+#define ATA1_CTL_write_shift                                          (2)
+#define ATA1_CTL_device_shift                                         (1)
+#define ATA1_CTL_cpen_mask                                            (0x00000010)
+#define ATA1_CTL_swap_mask                                            (0x00000008)
+#define ATA1_CTL_write_mask                                           (0x00000004)
+#define ATA1_CTL_device_mask                                          (0x00000002)
+#define ATA1_CTL_cpen(data)                                           (0x00000010&((data)<<4))
+#define ATA1_CTL_swap(data)                                           (0x00000008&((data)<<3))
+#define ATA1_CTL_write(data)                                          (0x00000004&((data)<<2))
+#define ATA1_CTL_device(data)                                         (0x00000002&((data)<<1))
+#define ATA1_CTL_get_cpen(data)                                       ((0x00000010&(data))>>4)
+#define ATA1_CTL_get_swap(data)                                       ((0x00000008&(data))>>3)
+#define ATA1_CTL_get_write(data)                                      ((0x00000004&(data))>>2)
+#define ATA1_CTL_get_device(data)                                     ((0x00000002&(data))>>1)
+
+#define ATA1_GO                                                       0x18012144
+#define ATA1_GO_reg_addr                                              "0xB8012144"
+#define ATA1_GO_reg                                                   0xB8012144
+#define ATA1_GO_inst_addr                                             "0x0051"
+#define ATA1_GO_inst                                                  0x0051
+#define ATA1_GO_go_shift                                              (0)
+#define ATA1_GO_go_mask                                               (0x00000001)
+#define ATA1_GO_go(data)                                              (0x00000001&(data))
+#define ATA1_GO_get_go(data)                                          (0x00000001&(data))
+
+#define ATA1_STATUS                                                   0x18012148
+#define ATA1_STATUS_reg_addr                                          "0xB8012148"
+#define ATA1_STATUS_reg                                               0xB8012148
+#define ATA1_STATUS_inst_addr                                         "0x0052"
+#define ATA1_STATUS_inst                                              0x0052
+#define ATA1_STATUS_timeout_shift                                     (4)
+#define ATA1_STATUS_intrq_shift                                       (3)
+#define ATA1_STATUS_data_done_shift                                   (1)
+#define ATA1_STATUS_write_data_shift                                  (0)
+#define ATA1_STATUS_timeout_mask                                      (0x00000010)
+#define ATA1_STATUS_intrq_mask                                        (0x00000008)
+#define ATA1_STATUS_data_done_mask                                    (0x00000002)
+#define ATA1_STATUS_write_data_mask                                   (0x00000001)
+#define ATA1_STATUS_timeout(data)                                     (0x00000010&((data)<<4))
+#define ATA1_STATUS_intrq(data)                                       (0x00000008&((data)<<3))
+#define ATA1_STATUS_data_done(data)                                   (0x00000002&((data)<<1))
+#define ATA1_STATUS_write_data(data)                                  (0x00000001&(data))
+#define ATA1_STATUS_get_timeout(data)                                 ((0x00000010&(data))>>4)
+#define ATA1_STATUS_get_intrq(data)                                   ((0x00000008&(data))>>3)
+#define ATA1_STATUS_get_data_done(data)                               ((0x00000002&(data))>>1)
+#define ATA1_STATUS_get_write_data(data)                              (0x00000001&(data))
+
+#define ATA1_EN                                                       0x1801214C
+#define ATA1_EN_reg_addr                                              "0xB801214C"
+#define ATA1_EN_reg                                                   0xB801214C
+#define ATA1_EN_inst_addr                                             "0x0053"
+#define ATA1_EN_inst                                                  0x0053
+#define ATA1_EN_timeout_en_shift                                      (4)
+#define ATA1_EN_intrq_en_shift                                        (3)
+#define ATA1_EN_data_done_en_shift                                    (1)
+#define ATA1_EN_write_data_shift                                      (0)
+#define ATA1_EN_timeout_en_mask                                       (0x00000010)
+#define ATA1_EN_intrq_en_mask                                         (0x00000008)
+#define ATA1_EN_data_done_en_mask                                     (0x00000002)
+#define ATA1_EN_write_data_mask                                       (0x00000001)
+#define ATA1_EN_timeout_en(data)                                      (0x00000010&((data)<<4))
+#define ATA1_EN_intrq_en(data)                                        (0x00000008&((data)<<3))
+#define ATA1_EN_data_done_en(data)                                    (0x00000002&((data)<<1))
+#define ATA1_EN_write_data(data)                                      (0x00000001&(data))
+#define ATA1_EN_get_timeout_en(data)                                  ((0x00000010&(data))>>4)
+#define ATA1_EN_get_intrq_en(data)                                    ((0x00000008&(data))>>3)
+#define ATA1_EN_get_data_done_en(data)                                ((0x00000002&(data))>>1)
+#define ATA1_EN_get_write_data(data)                                  (0x00000001&(data))
+
+#define ATA1_INADR                                                    0x18012150
+#define ATA1_INADR_reg_addr                                           "0xB8012150"
+#define ATA1_INADR_reg                                                0xB8012150
+#define ATA1_INADR_inst_addr                                          "0x0054"
+#define ATA1_INADR_inst                                               0x0054
+#define ATA1_INADR_adr_shift                                          (0)
+#define ATA1_INADR_adr_mask                                           (0x03FFFFFF)
+#define ATA1_INADR_adr(data)                                          (0x03FFFFFF&(data))
+#define ATA1_INADR_get_adr(data)                                      (0x03FFFFFF&(data))
+
+#define ATA1_OUTADR                                                   0x18012154
+#define ATA1_OUTADR_reg_addr                                          "0xB8012154"
+#define ATA1_OUTADR_reg                                               0xB8012154
+#define ATA1_OUTADR_inst_addr                                         "0x0055"
+#define ATA1_OUTADR_inst                                              0x0055
+#define ATA1_OUTADR_adr_shift                                         (0)
+#define ATA1_OUTADR_adr_mask                                          (0x03FFFFFF)
+#define ATA1_OUTADR_adr(data)                                         (0x03FFFFFF&(data))
+#define ATA1_OUTADR_get_adr(data)                                     (0x03FFFFFF&(data))
+
+#define ATA1_CRC                                                      0x18012158
+#define ATA1_CRC_reg_addr                                             "0xB8012158"
+#define ATA1_CRC_reg                                                  0xB8012158
+#define ATA1_CRC_inst_addr                                            "0x0056"
+#define ATA1_CRC_inst                                                 0x0056
+#define ATA1_CRC_crc_ini_shift                                        (0)
+#define ATA1_CRC_crc_ini_mask                                         (0x0000FFFF)
+#define ATA1_CRC_crc_ini(data)                                        (0x0000FFFF&(data))
+#define ATA1_CRC_get_crc_ini(data)                                    (0x0000FFFF&(data))
+
+#define ATA1_RST                                                      0x1801215C
+#define ATA1_RST_reg_addr                                             "0xB801215C"
+#define ATA1_RST_reg                                                  0xB801215C
+#define ATA1_RST_inst_addr                                            "0x0057"
+#define ATA1_RST_inst                                                 0x0057
+#define ATA1_RST_dev_rstn_shift                                       (0)
+#define ATA1_RST_dev_rstn_mask                                        (0x00000001)
+#define ATA1_RST_dev_rstn(data)                                       (0x00000001&(data))
+#define ATA1_RST_get_dev_rstn(data)                                   (0x00000001&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/cabac_p2_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cabac_p2_reg.h
new file mode 100644
index 00000000..3609006
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cabac_p2_reg.h
@@ -0,0 +1,1053 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/6/22 11:40:33
+***************************************************************/
+
+
+#ifndef _CABAC_P2_REG_H_INCLUDED_
+#define _CABAC_P2_REG_H_INCLUDED_
+#ifdef  _CABAC_P2_USE_STRUCT
+typedef struct 
+{
+unsigned int     left_top:32;
+}CABAC_P2_CABAC_LEFTTOP;
+
+typedef struct 
+{
+unsigned int     left_bot:32;
+}CABAC_P2_CABAC_LEFTBOT;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     high:9;
+unsigned int     bits:4;
+unsigned int     code_word:16;
+}CABAC_P2_VP6_BAC;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_enable7:1;
+unsigned int     reset_cabacp2_bsfifo:1;
+unsigned int     write_enable6:1;
+unsigned int     decode_en_cabacp2:1;
+unsigned int     write_enable5:1;
+unsigned int     cabac_1p_mode:1;
+unsigned int     write_enable4:1;
+unsigned int     cabac_p2_p3:1;
+unsigned int     write_enable3:1;
+unsigned int     cabac_p2_go:1;
+unsigned int     write_enable2:1;
+unsigned int     latch_enable:1;
+unsigned int     write_enable1:1;
+unsigned int     codioffset:9;
+unsigned int     codirange:9;
+}CABAC_P2_CABAC_P2_CNTL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_enable5:1;
+unsigned int     arb_wait_value:5;
+unsigned int     write_enable4:1;
+unsigned int     HaltCabacp2_done:1;
+unsigned int     write_enable3:1;
+unsigned int     HaltCabacp2:1;
+unsigned int     write_enable2:1;
+unsigned int     Cabacp2_idle:1;
+unsigned int     write_enable1:1;
+unsigned int     cabacp2_header_byte_cnt:18;
+}CABAC_P2_CABAC_P2_CNTL4;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     cabac_p2_wfifo_err:1;
+unsigned int     cabac_p2_bsfifo_err:1;
+unsigned int     cabac_p2_dec_err:1;
+unsigned int     cabac_p2_done:1;
+unsigned int     write_data:1;
+}CABAC_P2_CABACP2_INT_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     cabac_p2_wfifo_err_ie:1;
+unsigned int     cabac_p2_bsfifo_err_ie:1;
+unsigned int     cabac_p2_dec_err_ie:1;
+unsigned int     cabac_p2_done_ie:1;
+unsigned int     write_data:1;
+}CABAC_P2_CABACP2_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable3:1;
+unsigned int     coding_type:4;
+unsigned int     write_enable2:1;
+unsigned int     cabacp2_pred_counter:10;
+unsigned int     write_enable1:1;
+unsigned int     cabacp2_curmb_addr:10;
+}CABAC_P2_CABAC_P2_CNTL5;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     write_enable3:1;
+unsigned int     p2_startcode_prevnt_en:1;
+unsigned int     write_enable2:1;
+unsigned int     detect_startcode_error:1;
+unsigned int     write_enable1:1;
+unsigned int     min_xfer_size:2;
+}CABAC_P2_P2_BSCNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     min_thre:7;
+}CABAC_P2_P2_BS_MIN_THR;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     timer_value:24;
+}CABAC_P2_P2_BSTIMER;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     base_addr:31;
+}CABAC_P2_P2_RFIFO_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     limit_addr:31;
+}CABAC_P2_P2_RFIFO_LIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     wr_ptr:31;
+}CABAC_P2_P2_RFIFO_WPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rd_ptr:31;
+}CABAC_P2_P2_RFIFO_RPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     base_addr:31;
+}CABAC_P2_P2_WFIFO_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     limit_addr:31;
+}CABAC_P2_P2_WFIFO_LIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     wr_ptr:31;
+}CABAC_P2_P2_WFIFO_WPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rd_ptr:31;
+}CABAC_P2_P2_WFIFO_RPTR;
+
+typedef struct 
+{
+unsigned int     dec_bit_ptr:32;
+}CABAC_P2_P2_RFIFO_DECBSPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     dec_bit_ptr_msb:2;
+}CABAC_P2_P2_RFIFO_DECBSPTR_MSB;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     entropy_coding_mode:1;
+unsigned int     pic_init_qp:6;
+unsigned int     chroma_qp_offset:5;
+unsigned int     second_chroma_qp_offset:5;
+unsigned int     direct_8x8_inferflg:1;
+unsigned int     transform_8x8_mode_flg:1;
+unsigned int     num_ref_idx_l0_active_minus1:5;
+unsigned int     num_ref_idx_l1_active_minus1:5;
+}CABAC_P2_CABAC_P2_CNTL;
+
+typedef struct 
+{
+unsigned int     write_enable7:1;
+unsigned int     mb_adaptive_frame_field_flag:1;
+unsigned int     write_enable6:1;
+unsigned int     picmb_w:10;
+unsigned int     write_enable5:1;
+unsigned int     monochrome:1;
+unsigned int     write_enable4:1;
+unsigned int     field_pic_flag:1;
+unsigned int     write_enable3:1;
+unsigned int     pic_type:3;
+unsigned int     write_enable2:1;
+unsigned int     slice_qp_delta:7;
+unsigned int     write_enable1:1;
+unsigned int     cabac_init_idc:2;
+}CABAC_P2_CABAC_P2_CNTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     write_enable3:1;
+unsigned int     cabac_halt_done:1;
+unsigned int     write_enable2:1;
+unsigned int     cabac_halt:1;
+unsigned int     write_enable1:1;
+unsigned int     postwrite_en:1;
+}CABAC_P2_P2_NDB_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     base_addr:31;
+}CABAC_P2_NDB_CABAC_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     limit_addr:31;
+}CABAC_P2_NDB_CABAC_LIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     wr_ptr:31;
+}CABAC_P2_NDB_CABAC_WPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rd_ptr:31;
+}CABAC_P2_NDB_CABAC_RPTR;
+
+#endif
+
+#define CABAC_P2_CABAC_LEFTTOP_0                                                     0x1800E030
+#define CABAC_P2_CABAC_LEFTTOP_1                                                     0x1800E034
+#define CABAC_P2_CABAC_LEFTTOP_2                                                     0x1800E038
+#define CABAC_P2_CABAC_LEFTTOP_3                                                     0x1800E03C
+#define CABAC_P2_CABAC_LEFTTOP_4                                                     0x1800E040
+#define CABAC_P2_CABAC_LEFTTOP_5                                                     0x1800E044
+#define CABAC_P2_CABAC_LEFTTOP_0_reg_addr                                            "0xB800E030"
+#define CABAC_P2_CABAC_LEFTTOP_1_reg_addr                                            "0xB800E034"
+#define CABAC_P2_CABAC_LEFTTOP_2_reg_addr                                            "0xB800E038"
+#define CABAC_P2_CABAC_LEFTTOP_3_reg_addr                                            "0xB800E03C"
+#define CABAC_P2_CABAC_LEFTTOP_4_reg_addr                                            "0xB800E040"
+#define CABAC_P2_CABAC_LEFTTOP_5_reg_addr                                            "0xB800E044"
+#define CABAC_P2_CABAC_LEFTTOP_0_reg                                                 0xB800E030
+#define CABAC_P2_CABAC_LEFTTOP_1_reg                                                 0xB800E034
+#define CABAC_P2_CABAC_LEFTTOP_2_reg                                                 0xB800E038
+#define CABAC_P2_CABAC_LEFTTOP_3_reg                                                 0xB800E03C
+#define CABAC_P2_CABAC_LEFTTOP_4_reg                                                 0xB800E040
+#define CABAC_P2_CABAC_LEFTTOP_5_reg                                                 0xB800E044
+#define set_CABAC_P2_CABAC_LEFTTOP_0_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_0_reg)=data)
+#define set_CABAC_P2_CABAC_LEFTTOP_1_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_1_reg)=data)
+#define set_CABAC_P2_CABAC_LEFTTOP_2_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_2_reg)=data)
+#define set_CABAC_P2_CABAC_LEFTTOP_3_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_3_reg)=data)
+#define set_CABAC_P2_CABAC_LEFTTOP_4_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_4_reg)=data)
+#define set_CABAC_P2_CABAC_LEFTTOP_5_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_5_reg)=data)
+#define get_CABAC_P2_CABAC_LEFTTOP_0_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_0_reg))
+#define get_CABAC_P2_CABAC_LEFTTOP_1_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_1_reg))
+#define get_CABAC_P2_CABAC_LEFTTOP_2_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_2_reg))
+#define get_CABAC_P2_CABAC_LEFTTOP_3_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_3_reg))
+#define get_CABAC_P2_CABAC_LEFTTOP_4_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_4_reg))
+#define get_CABAC_P2_CABAC_LEFTTOP_5_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTTOP_5_reg))
+#define CABAC_P2_CABAC_LEFTTOP_0_inst_adr                                            "0x000C"
+#define CABAC_P2_CABAC_LEFTTOP_1_inst_adr                                            "0x000D"
+#define CABAC_P2_CABAC_LEFTTOP_2_inst_adr                                            "0x000E"
+#define CABAC_P2_CABAC_LEFTTOP_3_inst_adr                                            "0x000F"
+#define CABAC_P2_CABAC_LEFTTOP_4_inst_adr                                            "0x0010"
+#define CABAC_P2_CABAC_LEFTTOP_5_inst_adr                                            "0x0011"
+#define CABAC_P2_CABAC_LEFTTOP_0_inst                                                0x000C
+#define CABAC_P2_CABAC_LEFTTOP_1_inst                                                0x000D
+#define CABAC_P2_CABAC_LEFTTOP_2_inst                                                0x000E
+#define CABAC_P2_CABAC_LEFTTOP_3_inst                                                0x000F
+#define CABAC_P2_CABAC_LEFTTOP_4_inst                                                0x0010
+#define CABAC_P2_CABAC_LEFTTOP_5_inst                                                0x0011
+#define CABAC_P2_CABAC_LEFTTOP_left_top_shift                                        (0)
+#define CABAC_P2_CABAC_LEFTTOP_left_top_mask                                         (0xFFFFFFFF)
+#define CABAC_P2_CABAC_LEFTTOP_left_top(data)                                        (0xFFFFFFFF&((data)<<0))
+#define CABAC_P2_CABAC_LEFTTOP_left_top_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define CABAC_P2_CABAC_LEFTTOP_get_left_top(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_CABAC_LEFTBOT_0                                                     0x1800E050
+#define CABAC_P2_CABAC_LEFTBOT_1                                                     0x1800E054
+#define CABAC_P2_CABAC_LEFTBOT_2                                                     0x1800E058
+#define CABAC_P2_CABAC_LEFTBOT_3                                                     0x1800E05C
+#define CABAC_P2_CABAC_LEFTBOT_4                                                     0x1800E060
+#define CABAC_P2_CABAC_LEFTBOT_5                                                     0x1800E064
+#define CABAC_P2_CABAC_LEFTBOT_0_reg_addr                                            "0xB800E050"
+#define CABAC_P2_CABAC_LEFTBOT_1_reg_addr                                            "0xB800E054"
+#define CABAC_P2_CABAC_LEFTBOT_2_reg_addr                                            "0xB800E058"
+#define CABAC_P2_CABAC_LEFTBOT_3_reg_addr                                            "0xB800E05C"
+#define CABAC_P2_CABAC_LEFTBOT_4_reg_addr                                            "0xB800E060"
+#define CABAC_P2_CABAC_LEFTBOT_5_reg_addr                                            "0xB800E064"
+#define CABAC_P2_CABAC_LEFTBOT_0_reg                                                 0xB800E050
+#define CABAC_P2_CABAC_LEFTBOT_1_reg                                                 0xB800E054
+#define CABAC_P2_CABAC_LEFTBOT_2_reg                                                 0xB800E058
+#define CABAC_P2_CABAC_LEFTBOT_3_reg                                                 0xB800E05C
+#define CABAC_P2_CABAC_LEFTBOT_4_reg                                                 0xB800E060
+#define CABAC_P2_CABAC_LEFTBOT_5_reg                                                 0xB800E064
+#define set_CABAC_P2_CABAC_LEFTBOT_0_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_0_reg)=data)
+#define set_CABAC_P2_CABAC_LEFTBOT_1_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_1_reg)=data)
+#define set_CABAC_P2_CABAC_LEFTBOT_2_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_2_reg)=data)
+#define set_CABAC_P2_CABAC_LEFTBOT_3_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_3_reg)=data)
+#define set_CABAC_P2_CABAC_LEFTBOT_4_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_4_reg)=data)
+#define set_CABAC_P2_CABAC_LEFTBOT_5_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_5_reg)=data)
+#define get_CABAC_P2_CABAC_LEFTBOT_0_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_0_reg))
+#define get_CABAC_P2_CABAC_LEFTBOT_1_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_1_reg))
+#define get_CABAC_P2_CABAC_LEFTBOT_2_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_2_reg))
+#define get_CABAC_P2_CABAC_LEFTBOT_3_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_3_reg))
+#define get_CABAC_P2_CABAC_LEFTBOT_4_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_4_reg))
+#define get_CABAC_P2_CABAC_LEFTBOT_5_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_LEFTBOT_5_reg))
+#define CABAC_P2_CABAC_LEFTBOT_0_inst_adr                                            "0x0014"
+#define CABAC_P2_CABAC_LEFTBOT_1_inst_adr                                            "0x0015"
+#define CABAC_P2_CABAC_LEFTBOT_2_inst_adr                                            "0x0016"
+#define CABAC_P2_CABAC_LEFTBOT_3_inst_adr                                            "0x0017"
+#define CABAC_P2_CABAC_LEFTBOT_4_inst_adr                                            "0x0018"
+#define CABAC_P2_CABAC_LEFTBOT_5_inst_adr                                            "0x0019"
+#define CABAC_P2_CABAC_LEFTBOT_0_inst                                                0x0014
+#define CABAC_P2_CABAC_LEFTBOT_1_inst                                                0x0015
+#define CABAC_P2_CABAC_LEFTBOT_2_inst                                                0x0016
+#define CABAC_P2_CABAC_LEFTBOT_3_inst                                                0x0017
+#define CABAC_P2_CABAC_LEFTBOT_4_inst                                                0x0018
+#define CABAC_P2_CABAC_LEFTBOT_5_inst                                                0x0019
+#define CABAC_P2_CABAC_LEFTBOT_left_bot_shift                                        (0)
+#define CABAC_P2_CABAC_LEFTBOT_left_bot_mask                                         (0xFFFFFFFF)
+#define CABAC_P2_CABAC_LEFTBOT_left_bot(data)                                        (0xFFFFFFFF&((data)<<0))
+#define CABAC_P2_CABAC_LEFTBOT_left_bot_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define CABAC_P2_CABAC_LEFTBOT_get_left_bot(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_VP6_BAC                                                             0x1800E070
+#define CABAC_P2_VP6_BAC_reg_addr                                                    "0xB800E070"
+#define CABAC_P2_VP6_BAC_reg                                                         0xB800E070
+#define set_CABAC_P2_VP6_BAC_reg(data)   (*((volatile unsigned int*) CABAC_P2_VP6_BAC_reg)=data)
+#define get_CABAC_P2_VP6_BAC_reg   (*((volatile unsigned int*) CABAC_P2_VP6_BAC_reg))
+#define CABAC_P2_VP6_BAC_inst_adr                                                    "0x001C"
+#define CABAC_P2_VP6_BAC_inst                                                        0x001C
+#define CABAC_P2_VP6_BAC_high_shift                                                  (20)
+#define CABAC_P2_VP6_BAC_high_mask                                                   (0x1FF00000)
+#define CABAC_P2_VP6_BAC_high(data)                                                  (0x1FF00000&((data)<<20))
+#define CABAC_P2_VP6_BAC_high_src(data)                                              ((0x1FF00000&(data))>>20)
+#define CABAC_P2_VP6_BAC_get_high(data)                                              ((0x1FF00000&(data))>>20)
+#define CABAC_P2_VP6_BAC_bits_shift                                                  (16)
+#define CABAC_P2_VP6_BAC_bits_mask                                                   (0x000F0000)
+#define CABAC_P2_VP6_BAC_bits(data)                                                  (0x000F0000&((data)<<16))
+#define CABAC_P2_VP6_BAC_bits_src(data)                                              ((0x000F0000&(data))>>16)
+#define CABAC_P2_VP6_BAC_get_bits(data)                                              ((0x000F0000&(data))>>16)
+#define CABAC_P2_VP6_BAC_code_word_shift                                             (0)
+#define CABAC_P2_VP6_BAC_code_word_mask                                              (0x0000FFFF)
+#define CABAC_P2_VP6_BAC_code_word(data)                                             (0x0000FFFF&((data)<<0))
+#define CABAC_P2_VP6_BAC_code_word_src(data)                                         ((0x0000FFFF&(data))>>0)
+#define CABAC_P2_VP6_BAC_get_code_word(data)                                         ((0x0000FFFF&(data))>>0)
+
+
+#define CABAC_P2_CABAC_P2_CNTL3                                                      0x1800E360
+#define CABAC_P2_CABAC_P2_CNTL3_reg_addr                                             "0xB800E360"
+#define CABAC_P2_CABAC_P2_CNTL3_reg                                                  0xB800E360
+#define set_CABAC_P2_CABAC_P2_CNTL3_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_P2_CNTL3_reg)=data)
+#define get_CABAC_P2_CABAC_P2_CNTL3_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_P2_CNTL3_reg))
+#define CABAC_P2_CABAC_P2_CNTL3_inst_adr                                             "0x00D8"
+#define CABAC_P2_CABAC_P2_CNTL3_inst                                                 0x00D8
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable7_shift                                  (30)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable7_mask                                   (0x40000000)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable7(data)                                  (0x40000000&((data)<<30))
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable7_src(data)                              ((0x40000000&(data))>>30)
+#define CABAC_P2_CABAC_P2_CNTL3_get_write_enable7(data)                              ((0x40000000&(data))>>30)
+#define CABAC_P2_CABAC_P2_CNTL3_reset_cabacp2_bsfifo_shift                           (29)
+#define CABAC_P2_CABAC_P2_CNTL3_reset_cabacp2_bsfifo_mask                            (0x20000000)
+#define CABAC_P2_CABAC_P2_CNTL3_reset_cabacp2_bsfifo(data)                           (0x20000000&((data)<<29))
+#define CABAC_P2_CABAC_P2_CNTL3_reset_cabacp2_bsfifo_src(data)                       ((0x20000000&(data))>>29)
+#define CABAC_P2_CABAC_P2_CNTL3_get_reset_cabacp2_bsfifo(data)                       ((0x20000000&(data))>>29)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable6_shift                                  (28)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable6_mask                                   (0x10000000)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable6(data)                                  (0x10000000&((data)<<28))
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable6_src(data)                              ((0x10000000&(data))>>28)
+#define CABAC_P2_CABAC_P2_CNTL3_get_write_enable6(data)                              ((0x10000000&(data))>>28)
+#define CABAC_P2_CABAC_P2_CNTL3_decode_en_cabacp2_shift                              (27)
+#define CABAC_P2_CABAC_P2_CNTL3_decode_en_cabacp2_mask                               (0x08000000)
+#define CABAC_P2_CABAC_P2_CNTL3_decode_en_cabacp2(data)                              (0x08000000&((data)<<27))
+#define CABAC_P2_CABAC_P2_CNTL3_decode_en_cabacp2_src(data)                          ((0x08000000&(data))>>27)
+#define CABAC_P2_CABAC_P2_CNTL3_get_decode_en_cabacp2(data)                          ((0x08000000&(data))>>27)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable5_shift                                  (26)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable5_mask                                   (0x04000000)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable5(data)                                  (0x04000000&((data)<<26))
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable5_src(data)                              ((0x04000000&(data))>>26)
+#define CABAC_P2_CABAC_P2_CNTL3_get_write_enable5(data)                              ((0x04000000&(data))>>26)
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_1p_mode_shift                                  (25)
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_1p_mode_mask                                   (0x02000000)
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_1p_mode(data)                                  (0x02000000&((data)<<25))
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_1p_mode_src(data)                              ((0x02000000&(data))>>25)
+#define CABAC_P2_CABAC_P2_CNTL3_get_cabac_1p_mode(data)                              ((0x02000000&(data))>>25)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable4_shift                                  (24)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable4_mask                                   (0x01000000)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable4(data)                                  (0x01000000&((data)<<24))
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable4_src(data)                              ((0x01000000&(data))>>24)
+#define CABAC_P2_CABAC_P2_CNTL3_get_write_enable4(data)                              ((0x01000000&(data))>>24)
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_p2_p3_shift                                    (23)
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_p2_p3_mask                                     (0x00800000)
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_p2_p3(data)                                    (0x00800000&((data)<<23))
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_p2_p3_src(data)                                ((0x00800000&(data))>>23)
+#define CABAC_P2_CABAC_P2_CNTL3_get_cabac_p2_p3(data)                                ((0x00800000&(data))>>23)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable3_shift                                  (22)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable3_mask                                   (0x00400000)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable3(data)                                  (0x00400000&((data)<<22))
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable3_src(data)                              ((0x00400000&(data))>>22)
+#define CABAC_P2_CABAC_P2_CNTL3_get_write_enable3(data)                              ((0x00400000&(data))>>22)
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_p2_go_shift                                    (21)
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_p2_go_mask                                     (0x00200000)
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_p2_go(data)                                    (0x00200000&((data)<<21))
+#define CABAC_P2_CABAC_P2_CNTL3_cabac_p2_go_src(data)                                ((0x00200000&(data))>>21)
+#define CABAC_P2_CABAC_P2_CNTL3_get_cabac_p2_go(data)                                ((0x00200000&(data))>>21)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable2_shift                                  (20)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable2_mask                                   (0x00100000)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable2(data)                                  (0x00100000&((data)<<20))
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable2_src(data)                              ((0x00100000&(data))>>20)
+#define CABAC_P2_CABAC_P2_CNTL3_get_write_enable2(data)                              ((0x00100000&(data))>>20)
+#define CABAC_P2_CABAC_P2_CNTL3_latch_enable_shift                                   (19)
+#define CABAC_P2_CABAC_P2_CNTL3_latch_enable_mask                                    (0x00080000)
+#define CABAC_P2_CABAC_P2_CNTL3_latch_enable(data)                                   (0x00080000&((data)<<19))
+#define CABAC_P2_CABAC_P2_CNTL3_latch_enable_src(data)                               ((0x00080000&(data))>>19)
+#define CABAC_P2_CABAC_P2_CNTL3_get_latch_enable(data)                               ((0x00080000&(data))>>19)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable1_shift                                  (18)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable1_mask                                   (0x00040000)
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable1(data)                                  (0x00040000&((data)<<18))
+#define CABAC_P2_CABAC_P2_CNTL3_write_enable1_src(data)                              ((0x00040000&(data))>>18)
+#define CABAC_P2_CABAC_P2_CNTL3_get_write_enable1(data)                              ((0x00040000&(data))>>18)
+#define CABAC_P2_CABAC_P2_CNTL3_codioffset_shift                                     (9)
+#define CABAC_P2_CABAC_P2_CNTL3_codioffset_mask                                      (0x0003FE00)
+#define CABAC_P2_CABAC_P2_CNTL3_codioffset(data)                                     (0x0003FE00&((data)<<9))
+#define CABAC_P2_CABAC_P2_CNTL3_codioffset_src(data)                                 ((0x0003FE00&(data))>>9)
+#define CABAC_P2_CABAC_P2_CNTL3_get_codioffset(data)                                 ((0x0003FE00&(data))>>9)
+#define CABAC_P2_CABAC_P2_CNTL3_codirange_shift                                      (0)
+#define CABAC_P2_CABAC_P2_CNTL3_codirange_mask                                       (0x000001FF)
+#define CABAC_P2_CABAC_P2_CNTL3_codirange(data)                                      (0x000001FF&((data)<<0))
+#define CABAC_P2_CABAC_P2_CNTL3_codirange_src(data)                                  ((0x000001FF&(data))>>0)
+#define CABAC_P2_CABAC_P2_CNTL3_get_codirange(data)                                  ((0x000001FF&(data))>>0)
+
+
+#define CABAC_P2_CABAC_P2_CNTL4                                                      0x1800E3D0
+#define CABAC_P2_CABAC_P2_CNTL4_reg_addr                                             "0xB800E3D0"
+#define CABAC_P2_CABAC_P2_CNTL4_reg                                                  0xB800E3D0
+#define set_CABAC_P2_CABAC_P2_CNTL4_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_P2_CNTL4_reg)=data)
+#define get_CABAC_P2_CABAC_P2_CNTL4_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_P2_CNTL4_reg))
+#define CABAC_P2_CABAC_P2_CNTL4_inst_adr                                             "0x00F4"
+#define CABAC_P2_CABAC_P2_CNTL4_inst                                                 0x00F4
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable5_shift                                  (30)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable5_mask                                   (0x40000000)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable5(data)                                  (0x40000000&((data)<<30))
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable5_src(data)                              ((0x40000000&(data))>>30)
+#define CABAC_P2_CABAC_P2_CNTL4_get_write_enable5(data)                              ((0x40000000&(data))>>30)
+#define CABAC_P2_CABAC_P2_CNTL4_arb_wait_value_shift                                 (25)
+#define CABAC_P2_CABAC_P2_CNTL4_arb_wait_value_mask                                  (0x3E000000)
+#define CABAC_P2_CABAC_P2_CNTL4_arb_wait_value(data)                                 (0x3E000000&((data)<<25))
+#define CABAC_P2_CABAC_P2_CNTL4_arb_wait_value_src(data)                             ((0x3E000000&(data))>>25)
+#define CABAC_P2_CABAC_P2_CNTL4_get_arb_wait_value(data)                             ((0x3E000000&(data))>>25)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable4_shift                                  (24)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable4_mask                                   (0x01000000)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable4(data)                                  (0x01000000&((data)<<24))
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable4_src(data)                              ((0x01000000&(data))>>24)
+#define CABAC_P2_CABAC_P2_CNTL4_get_write_enable4(data)                              ((0x01000000&(data))>>24)
+#define CABAC_P2_CABAC_P2_CNTL4_HaltCabacp2_done_shift                               (23)
+#define CABAC_P2_CABAC_P2_CNTL4_HaltCabacp2_done_mask                                (0x00800000)
+#define CABAC_P2_CABAC_P2_CNTL4_HaltCabacp2_done(data)                               (0x00800000&((data)<<23))
+#define CABAC_P2_CABAC_P2_CNTL4_HaltCabacp2_done_src(data)                           ((0x00800000&(data))>>23)
+#define CABAC_P2_CABAC_P2_CNTL4_get_HaltCabacp2_done(data)                           ((0x00800000&(data))>>23)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable3_shift                                  (22)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable3_mask                                   (0x00400000)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable3(data)                                  (0x00400000&((data)<<22))
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable3_src(data)                              ((0x00400000&(data))>>22)
+#define CABAC_P2_CABAC_P2_CNTL4_get_write_enable3(data)                              ((0x00400000&(data))>>22)
+#define CABAC_P2_CABAC_P2_CNTL4_HaltCabacp2_shift                                    (21)
+#define CABAC_P2_CABAC_P2_CNTL4_HaltCabacp2_mask                                     (0x00200000)
+#define CABAC_P2_CABAC_P2_CNTL4_HaltCabacp2(data)                                    (0x00200000&((data)<<21))
+#define CABAC_P2_CABAC_P2_CNTL4_HaltCabacp2_src(data)                                ((0x00200000&(data))>>21)
+#define CABAC_P2_CABAC_P2_CNTL4_get_HaltCabacp2(data)                                ((0x00200000&(data))>>21)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable2_shift                                  (20)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable2_mask                                   (0x00100000)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable2(data)                                  (0x00100000&((data)<<20))
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable2_src(data)                              ((0x00100000&(data))>>20)
+#define CABAC_P2_CABAC_P2_CNTL4_get_write_enable2(data)                              ((0x00100000&(data))>>20)
+#define CABAC_P2_CABAC_P2_CNTL4_Cabacp2_idle_shift                                   (19)
+#define CABAC_P2_CABAC_P2_CNTL4_Cabacp2_idle_mask                                    (0x00080000)
+#define CABAC_P2_CABAC_P2_CNTL4_Cabacp2_idle(data)                                   (0x00080000&((data)<<19))
+#define CABAC_P2_CABAC_P2_CNTL4_Cabacp2_idle_src(data)                               ((0x00080000&(data))>>19)
+#define CABAC_P2_CABAC_P2_CNTL4_get_Cabacp2_idle(data)                               ((0x00080000&(data))>>19)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable1_shift                                  (18)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable1_mask                                   (0x00040000)
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable1(data)                                  (0x00040000&((data)<<18))
+#define CABAC_P2_CABAC_P2_CNTL4_write_enable1_src(data)                              ((0x00040000&(data))>>18)
+#define CABAC_P2_CABAC_P2_CNTL4_get_write_enable1(data)                              ((0x00040000&(data))>>18)
+#define CABAC_P2_CABAC_P2_CNTL4_cabacp2_header_byte_cnt_shift                        (0)
+#define CABAC_P2_CABAC_P2_CNTL4_cabacp2_header_byte_cnt_mask                         (0x0003FFFF)
+#define CABAC_P2_CABAC_P2_CNTL4_cabacp2_header_byte_cnt(data)                        (0x0003FFFF&((data)<<0))
+#define CABAC_P2_CABAC_P2_CNTL4_cabacp2_header_byte_cnt_src(data)                    ((0x0003FFFF&(data))>>0)
+#define CABAC_P2_CABAC_P2_CNTL4_get_cabacp2_header_byte_cnt(data)                    ((0x0003FFFF&(data))>>0)
+
+
+#define CABAC_P2_CABACP2_INT_STATUS                                                  0x1800E3D4
+#define CABAC_P2_CABACP2_INT_STATUS_reg_addr                                         "0xB800E3D4"
+#define CABAC_P2_CABACP2_INT_STATUS_reg                                              0xB800E3D4
+#define set_CABAC_P2_CABACP2_INT_STATUS_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABACP2_INT_STATUS_reg)=data)
+#define get_CABAC_P2_CABACP2_INT_STATUS_reg   (*((volatile unsigned int*) CABAC_P2_CABACP2_INT_STATUS_reg))
+#define CABAC_P2_CABACP2_INT_STATUS_inst_adr                                         "0x00F5"
+#define CABAC_P2_CABACP2_INT_STATUS_inst                                             0x00F5
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_wfifo_err_shift                         (4)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_wfifo_err_mask                          (0x00000010)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_wfifo_err(data)                         (0x00000010&((data)<<4))
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_wfifo_err_src(data)                     ((0x00000010&(data))>>4)
+#define CABAC_P2_CABACP2_INT_STATUS_get_cabac_p2_wfifo_err(data)                     ((0x00000010&(data))>>4)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_bsfifo_err_shift                        (3)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_bsfifo_err_mask                         (0x00000008)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_bsfifo_err(data)                        (0x00000008&((data)<<3))
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_bsfifo_err_src(data)                    ((0x00000008&(data))>>3)
+#define CABAC_P2_CABACP2_INT_STATUS_get_cabac_p2_bsfifo_err(data)                    ((0x00000008&(data))>>3)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_dec_err_shift                           (2)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_dec_err_mask                            (0x00000004)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_dec_err(data)                           (0x00000004&((data)<<2))
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_dec_err_src(data)                       ((0x00000004&(data))>>2)
+#define CABAC_P2_CABACP2_INT_STATUS_get_cabac_p2_dec_err(data)                       ((0x00000004&(data))>>2)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_done_shift                              (1)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_done_mask                               (0x00000002)
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_done(data)                              (0x00000002&((data)<<1))
+#define CABAC_P2_CABACP2_INT_STATUS_cabac_p2_done_src(data)                          ((0x00000002&(data))>>1)
+#define CABAC_P2_CABACP2_INT_STATUS_get_cabac_p2_done(data)                          ((0x00000002&(data))>>1)
+#define CABAC_P2_CABACP2_INT_STATUS_write_data_shift                                 (0)
+#define CABAC_P2_CABACP2_INT_STATUS_write_data_mask                                  (0x00000001)
+#define CABAC_P2_CABACP2_INT_STATUS_write_data(data)                                 (0x00000001&((data)<<0))
+#define CABAC_P2_CABACP2_INT_STATUS_write_data_src(data)                             ((0x00000001&(data))>>0)
+#define CABAC_P2_CABACP2_INT_STATUS_get_write_data(data)                             ((0x00000001&(data))>>0)
+
+
+#define CABAC_P2_CABACP2_INT_EN                                                      0x1800E3D8
+#define CABAC_P2_CABACP2_INT_EN_reg_addr                                             "0xB800E3D8"
+#define CABAC_P2_CABACP2_INT_EN_reg                                                  0xB800E3D8
+#define set_CABAC_P2_CABACP2_INT_EN_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABACP2_INT_EN_reg)=data)
+#define get_CABAC_P2_CABACP2_INT_EN_reg   (*((volatile unsigned int*) CABAC_P2_CABACP2_INT_EN_reg))
+#define CABAC_P2_CABACP2_INT_EN_inst_adr                                             "0x00F6"
+#define CABAC_P2_CABACP2_INT_EN_inst                                                 0x00F6
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_wfifo_err_ie_shift                          (4)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_wfifo_err_ie_mask                           (0x00000010)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_wfifo_err_ie(data)                          (0x00000010&((data)<<4))
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_wfifo_err_ie_src(data)                      ((0x00000010&(data))>>4)
+#define CABAC_P2_CABACP2_INT_EN_get_cabac_p2_wfifo_err_ie(data)                      ((0x00000010&(data))>>4)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_bsfifo_err_ie_shift                         (3)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_bsfifo_err_ie_mask                          (0x00000008)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_bsfifo_err_ie(data)                         (0x00000008&((data)<<3))
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_bsfifo_err_ie_src(data)                     ((0x00000008&(data))>>3)
+#define CABAC_P2_CABACP2_INT_EN_get_cabac_p2_bsfifo_err_ie(data)                     ((0x00000008&(data))>>3)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_dec_err_ie_shift                            (2)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_dec_err_ie_mask                             (0x00000004)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_dec_err_ie(data)                            (0x00000004&((data)<<2))
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_dec_err_ie_src(data)                        ((0x00000004&(data))>>2)
+#define CABAC_P2_CABACP2_INT_EN_get_cabac_p2_dec_err_ie(data)                        ((0x00000004&(data))>>2)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_done_ie_shift                               (1)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_done_ie_mask                                (0x00000002)
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_done_ie(data)                               (0x00000002&((data)<<1))
+#define CABAC_P2_CABACP2_INT_EN_cabac_p2_done_ie_src(data)                           ((0x00000002&(data))>>1)
+#define CABAC_P2_CABACP2_INT_EN_get_cabac_p2_done_ie(data)                           ((0x00000002&(data))>>1)
+#define CABAC_P2_CABACP2_INT_EN_write_data_shift                                     (0)
+#define CABAC_P2_CABACP2_INT_EN_write_data_mask                                      (0x00000001)
+#define CABAC_P2_CABACP2_INT_EN_write_data(data)                                     (0x00000001&((data)<<0))
+#define CABAC_P2_CABACP2_INT_EN_write_data_src(data)                                 ((0x00000001&(data))>>0)
+#define CABAC_P2_CABACP2_INT_EN_get_write_data(data)                                 ((0x00000001&(data))>>0)
+
+
+#define CABAC_P2_CABAC_P2_CNTL5                                                      0x1800E3DC
+#define CABAC_P2_CABAC_P2_CNTL5_reg_addr                                             "0xB800E3DC"
+#define CABAC_P2_CABAC_P2_CNTL5_reg                                                  0xB800E3DC
+#define set_CABAC_P2_CABAC_P2_CNTL5_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_P2_CNTL5_reg)=data)
+#define get_CABAC_P2_CABAC_P2_CNTL5_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_P2_CNTL5_reg))
+#define CABAC_P2_CABAC_P2_CNTL5_inst_adr                                             "0x00F7"
+#define CABAC_P2_CABAC_P2_CNTL5_inst                                                 0x00F7
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable3_shift                                  (26)
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable3_mask                                   (0x04000000)
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable3(data)                                  (0x04000000&((data)<<26))
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable3_src(data)                              ((0x04000000&(data))>>26)
+#define CABAC_P2_CABAC_P2_CNTL5_get_write_enable3(data)                              ((0x04000000&(data))>>26)
+#define CABAC_P2_CABAC_P2_CNTL5_coding_type_shift                                    (22)
+#define CABAC_P2_CABAC_P2_CNTL5_coding_type_mask                                     (0x03C00000)
+#define CABAC_P2_CABAC_P2_CNTL5_coding_type(data)                                    (0x03C00000&((data)<<22))
+#define CABAC_P2_CABAC_P2_CNTL5_coding_type_src(data)                                ((0x03C00000&(data))>>22)
+#define CABAC_P2_CABAC_P2_CNTL5_get_coding_type(data)                                ((0x03C00000&(data))>>22)
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable2_shift                                  (21)
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable2_mask                                   (0x00200000)
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable2(data)                                  (0x00200000&((data)<<21))
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable2_src(data)                              ((0x00200000&(data))>>21)
+#define CABAC_P2_CABAC_P2_CNTL5_get_write_enable2(data)                              ((0x00200000&(data))>>21)
+#define CABAC_P2_CABAC_P2_CNTL5_cabacp2_pred_counter_shift                           (11)
+#define CABAC_P2_CABAC_P2_CNTL5_cabacp2_pred_counter_mask                            (0x001FF800)
+#define CABAC_P2_CABAC_P2_CNTL5_cabacp2_pred_counter(data)                           (0x001FF800&((data)<<11))
+#define CABAC_P2_CABAC_P2_CNTL5_cabacp2_pred_counter_src(data)                       ((0x001FF800&(data))>>11)
+#define CABAC_P2_CABAC_P2_CNTL5_get_cabacp2_pred_counter(data)                       ((0x001FF800&(data))>>11)
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable1_shift                                  (10)
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable1_mask                                   (0x00000400)
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable1(data)                                  (0x00000400&((data)<<10))
+#define CABAC_P2_CABAC_P2_CNTL5_write_enable1_src(data)                              ((0x00000400&(data))>>10)
+#define CABAC_P2_CABAC_P2_CNTL5_get_write_enable1(data)                              ((0x00000400&(data))>>10)
+#define CABAC_P2_CABAC_P2_CNTL5_cabacp2_curmb_addr_shift                             (0)
+#define CABAC_P2_CABAC_P2_CNTL5_cabacp2_curmb_addr_mask                              (0x000003FF)
+#define CABAC_P2_CABAC_P2_CNTL5_cabacp2_curmb_addr(data)                             (0x000003FF&((data)<<0))
+#define CABAC_P2_CABAC_P2_CNTL5_cabacp2_curmb_addr_src(data)                         ((0x000003FF&(data))>>0)
+#define CABAC_P2_CABAC_P2_CNTL5_get_cabacp2_curmb_addr(data)                         ((0x000003FF&(data))>>0)
+
+
+#define CABAC_P2_P2_BSCNTL                                                           0x1800E3E0
+#define CABAC_P2_P2_BSCNTL_reg_addr                                                  "0xB800E3E0"
+#define CABAC_P2_P2_BSCNTL_reg                                                       0xB800E3E0
+#define set_CABAC_P2_P2_BSCNTL_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_BSCNTL_reg)=data)
+#define get_CABAC_P2_P2_BSCNTL_reg   (*((volatile unsigned int*) CABAC_P2_P2_BSCNTL_reg))
+#define CABAC_P2_P2_BSCNTL_inst_adr                                                  "0x00F8"
+#define CABAC_P2_P2_BSCNTL_inst                                                      0x00F8
+#define CABAC_P2_P2_BSCNTL_write_enable3_shift                                       (6)
+#define CABAC_P2_P2_BSCNTL_write_enable3_mask                                        (0x00000040)
+#define CABAC_P2_P2_BSCNTL_write_enable3(data)                                       (0x00000040&((data)<<6))
+#define CABAC_P2_P2_BSCNTL_write_enable3_src(data)                                   ((0x00000040&(data))>>6)
+#define CABAC_P2_P2_BSCNTL_get_write_enable3(data)                                   ((0x00000040&(data))>>6)
+#define CABAC_P2_P2_BSCNTL_p2_startcode_prevnt_en_shift                              (5)
+#define CABAC_P2_P2_BSCNTL_p2_startcode_prevnt_en_mask                               (0x00000020)
+#define CABAC_P2_P2_BSCNTL_p2_startcode_prevnt_en(data)                              (0x00000020&((data)<<5))
+#define CABAC_P2_P2_BSCNTL_p2_startcode_prevnt_en_src(data)                          ((0x00000020&(data))>>5)
+#define CABAC_P2_P2_BSCNTL_get_p2_startcode_prevnt_en(data)                          ((0x00000020&(data))>>5)
+#define CABAC_P2_P2_BSCNTL_write_enable2_shift                                       (4)
+#define CABAC_P2_P2_BSCNTL_write_enable2_mask                                        (0x00000010)
+#define CABAC_P2_P2_BSCNTL_write_enable2(data)                                       (0x00000010&((data)<<4))
+#define CABAC_P2_P2_BSCNTL_write_enable2_src(data)                                   ((0x00000010&(data))>>4)
+#define CABAC_P2_P2_BSCNTL_get_write_enable2(data)                                   ((0x00000010&(data))>>4)
+#define CABAC_P2_P2_BSCNTL_detect_startcode_error_shift                              (3)
+#define CABAC_P2_P2_BSCNTL_detect_startcode_error_mask                               (0x00000008)
+#define CABAC_P2_P2_BSCNTL_detect_startcode_error(data)                              (0x00000008&((data)<<3))
+#define CABAC_P2_P2_BSCNTL_detect_startcode_error_src(data)                          ((0x00000008&(data))>>3)
+#define CABAC_P2_P2_BSCNTL_get_detect_startcode_error(data)                          ((0x00000008&(data))>>3)
+#define CABAC_P2_P2_BSCNTL_write_enable1_shift                                       (2)
+#define CABAC_P2_P2_BSCNTL_write_enable1_mask                                        (0x00000004)
+#define CABAC_P2_P2_BSCNTL_write_enable1(data)                                       (0x00000004&((data)<<2))
+#define CABAC_P2_P2_BSCNTL_write_enable1_src(data)                                   ((0x00000004&(data))>>2)
+#define CABAC_P2_P2_BSCNTL_get_write_enable1(data)                                   ((0x00000004&(data))>>2)
+#define CABAC_P2_P2_BSCNTL_min_xfer_size_shift                                       (0)
+#define CABAC_P2_P2_BSCNTL_min_xfer_size_mask                                        (0x00000003)
+#define CABAC_P2_P2_BSCNTL_min_xfer_size(data)                                       (0x00000003&((data)<<0))
+#define CABAC_P2_P2_BSCNTL_min_xfer_size_src(data)                                   ((0x00000003&(data))>>0)
+#define CABAC_P2_P2_BSCNTL_get_min_xfer_size(data)                                   ((0x00000003&(data))>>0)
+
+
+#define CABAC_P2_P2_BS_MIN_THR                                                       0x1800E3E4
+#define CABAC_P2_P2_BS_MIN_THR_reg_addr                                              "0xB800E3E4"
+#define CABAC_P2_P2_BS_MIN_THR_reg                                                   0xB800E3E4
+#define set_CABAC_P2_P2_BS_MIN_THR_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_BS_MIN_THR_reg)=data)
+#define get_CABAC_P2_P2_BS_MIN_THR_reg   (*((volatile unsigned int*) CABAC_P2_P2_BS_MIN_THR_reg))
+#define CABAC_P2_P2_BS_MIN_THR_inst_adr                                              "0x00F9"
+#define CABAC_P2_P2_BS_MIN_THR_inst                                                  0x00F9
+#define CABAC_P2_P2_BS_MIN_THR_min_thre_shift                                        (0)
+#define CABAC_P2_P2_BS_MIN_THR_min_thre_mask                                         (0x0000007F)
+#define CABAC_P2_P2_BS_MIN_THR_min_thre(data)                                        (0x0000007F&((data)<<0))
+#define CABAC_P2_P2_BS_MIN_THR_min_thre_src(data)                                    ((0x0000007F&(data))>>0)
+#define CABAC_P2_P2_BS_MIN_THR_get_min_thre(data)                                    ((0x0000007F&(data))>>0)
+
+
+#define CABAC_P2_P2_BSTIMER                                                          0x1800E3E8
+#define CABAC_P2_P2_BSTIMER_reg_addr                                                 "0xB800E3E8"
+#define CABAC_P2_P2_BSTIMER_reg                                                      0xB800E3E8
+#define set_CABAC_P2_P2_BSTIMER_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_BSTIMER_reg)=data)
+#define get_CABAC_P2_P2_BSTIMER_reg   (*((volatile unsigned int*) CABAC_P2_P2_BSTIMER_reg))
+#define CABAC_P2_P2_BSTIMER_inst_adr                                                 "0x00FA"
+#define CABAC_P2_P2_BSTIMER_inst                                                     0x00FA
+#define CABAC_P2_P2_BSTIMER_timer_value_shift                                        (0)
+#define CABAC_P2_P2_BSTIMER_timer_value_mask                                         (0x00FFFFFF)
+#define CABAC_P2_P2_BSTIMER_timer_value(data)                                        (0x00FFFFFF&((data)<<0))
+#define CABAC_P2_P2_BSTIMER_timer_value_src(data)                                    ((0x00FFFFFF&(data))>>0)
+#define CABAC_P2_P2_BSTIMER_get_timer_value(data)                                    ((0x00FFFFFF&(data))>>0)
+
+
+#define CABAC_P2_P2_RFIFO_BASE                                                       0x1800E364
+#define CABAC_P2_P2_RFIFO_BASE_reg_addr                                              "0xB800E364"
+#define CABAC_P2_P2_RFIFO_BASE_reg                                                   0xB800E364
+#define set_CABAC_P2_P2_RFIFO_BASE_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_BASE_reg)=data)
+#define get_CABAC_P2_P2_RFIFO_BASE_reg   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_BASE_reg))
+#define CABAC_P2_P2_RFIFO_BASE_inst_adr                                              "0x00D9"
+#define CABAC_P2_P2_RFIFO_BASE_inst                                                  0x00D9
+#define CABAC_P2_P2_RFIFO_BASE_base_addr_shift                                       (0)
+#define CABAC_P2_P2_RFIFO_BASE_base_addr_mask                                        (0x7FFFFFFF)
+#define CABAC_P2_P2_RFIFO_BASE_base_addr(data)                                       (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_P2_RFIFO_BASE_base_addr_src(data)                                   ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_P2_RFIFO_BASE_get_base_addr(data)                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_P2_RFIFO_LIMIT                                                      0x1800E368
+#define CABAC_P2_P2_RFIFO_LIMIT_reg_addr                                             "0xB800E368"
+#define CABAC_P2_P2_RFIFO_LIMIT_reg                                                  0xB800E368
+#define set_CABAC_P2_P2_RFIFO_LIMIT_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_LIMIT_reg)=data)
+#define get_CABAC_P2_P2_RFIFO_LIMIT_reg   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_LIMIT_reg))
+#define CABAC_P2_P2_RFIFO_LIMIT_inst_adr                                             "0x00DA"
+#define CABAC_P2_P2_RFIFO_LIMIT_inst                                                 0x00DA
+#define CABAC_P2_P2_RFIFO_LIMIT_limit_addr_shift                                     (0)
+#define CABAC_P2_P2_RFIFO_LIMIT_limit_addr_mask                                      (0x7FFFFFFF)
+#define CABAC_P2_P2_RFIFO_LIMIT_limit_addr(data)                                     (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_P2_RFIFO_LIMIT_limit_addr_src(data)                                 ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_P2_RFIFO_LIMIT_get_limit_addr(data)                                 ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_P2_RFIFO_WPTR                                                       0x1800E36C
+#define CABAC_P2_P2_RFIFO_WPTR_reg_addr                                              "0xB800E36C"
+#define CABAC_P2_P2_RFIFO_WPTR_reg                                                   0xB800E36C
+#define set_CABAC_P2_P2_RFIFO_WPTR_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_WPTR_reg)=data)
+#define get_CABAC_P2_P2_RFIFO_WPTR_reg   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_WPTR_reg))
+#define CABAC_P2_P2_RFIFO_WPTR_inst_adr                                              "0x00DB"
+#define CABAC_P2_P2_RFIFO_WPTR_inst                                                  0x00DB
+#define CABAC_P2_P2_RFIFO_WPTR_wr_ptr_shift                                          (0)
+#define CABAC_P2_P2_RFIFO_WPTR_wr_ptr_mask                                           (0x7FFFFFFF)
+#define CABAC_P2_P2_RFIFO_WPTR_wr_ptr(data)                                          (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_P2_RFIFO_WPTR_wr_ptr_src(data)                                      ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_P2_RFIFO_WPTR_get_wr_ptr(data)                                      ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_P2_RFIFO_RPTR                                                       0x1800E370
+#define CABAC_P2_P2_RFIFO_RPTR_reg_addr                                              "0xB800E370"
+#define CABAC_P2_P2_RFIFO_RPTR_reg                                                   0xB800E370
+#define set_CABAC_P2_P2_RFIFO_RPTR_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_RPTR_reg)=data)
+#define get_CABAC_P2_P2_RFIFO_RPTR_reg   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_RPTR_reg))
+#define CABAC_P2_P2_RFIFO_RPTR_inst_adr                                              "0x00DC"
+#define CABAC_P2_P2_RFIFO_RPTR_inst                                                  0x00DC
+#define CABAC_P2_P2_RFIFO_RPTR_rd_ptr_shift                                          (0)
+#define CABAC_P2_P2_RFIFO_RPTR_rd_ptr_mask                                           (0x7FFFFFFF)
+#define CABAC_P2_P2_RFIFO_RPTR_rd_ptr(data)                                          (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_P2_RFIFO_RPTR_rd_ptr_src(data)                                      ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_P2_RFIFO_RPTR_get_rd_ptr(data)                                      ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_P2_WFIFO_BASE                                                       0x1800E374
+#define CABAC_P2_P2_WFIFO_BASE_reg_addr                                              "0xB800E374"
+#define CABAC_P2_P2_WFIFO_BASE_reg                                                   0xB800E374
+#define set_CABAC_P2_P2_WFIFO_BASE_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_WFIFO_BASE_reg)=data)
+#define get_CABAC_P2_P2_WFIFO_BASE_reg   (*((volatile unsigned int*) CABAC_P2_P2_WFIFO_BASE_reg))
+#define CABAC_P2_P2_WFIFO_BASE_inst_adr                                              "0x00DD"
+#define CABAC_P2_P2_WFIFO_BASE_inst                                                  0x00DD
+#define CABAC_P2_P2_WFIFO_BASE_base_addr_shift                                       (0)
+#define CABAC_P2_P2_WFIFO_BASE_base_addr_mask                                        (0x7FFFFFFF)
+#define CABAC_P2_P2_WFIFO_BASE_base_addr(data)                                       (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_P2_WFIFO_BASE_base_addr_src(data)                                   ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_P2_WFIFO_BASE_get_base_addr(data)                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_P2_WFIFO_LIMIT                                                      0x1800E378
+#define CABAC_P2_P2_WFIFO_LIMIT_reg_addr                                             "0xB800E378"
+#define CABAC_P2_P2_WFIFO_LIMIT_reg                                                  0xB800E378
+#define set_CABAC_P2_P2_WFIFO_LIMIT_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_WFIFO_LIMIT_reg)=data)
+#define get_CABAC_P2_P2_WFIFO_LIMIT_reg   (*((volatile unsigned int*) CABAC_P2_P2_WFIFO_LIMIT_reg))
+#define CABAC_P2_P2_WFIFO_LIMIT_inst_adr                                             "0x00DE"
+#define CABAC_P2_P2_WFIFO_LIMIT_inst                                                 0x00DE
+#define CABAC_P2_P2_WFIFO_LIMIT_limit_addr_shift                                     (0)
+#define CABAC_P2_P2_WFIFO_LIMIT_limit_addr_mask                                      (0x7FFFFFFF)
+#define CABAC_P2_P2_WFIFO_LIMIT_limit_addr(data)                                     (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_P2_WFIFO_LIMIT_limit_addr_src(data)                                 ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_P2_WFIFO_LIMIT_get_limit_addr(data)                                 ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_P2_WFIFO_WPTR                                                       0x1800E37C
+#define CABAC_P2_P2_WFIFO_WPTR_reg_addr                                              "0xB800E37C"
+#define CABAC_P2_P2_WFIFO_WPTR_reg                                                   0xB800E37C
+#define set_CABAC_P2_P2_WFIFO_WPTR_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_WFIFO_WPTR_reg)=data)
+#define get_CABAC_P2_P2_WFIFO_WPTR_reg   (*((volatile unsigned int*) CABAC_P2_P2_WFIFO_WPTR_reg))
+#define CABAC_P2_P2_WFIFO_WPTR_inst_adr                                              "0x00DF"
+#define CABAC_P2_P2_WFIFO_WPTR_inst                                                  0x00DF
+#define CABAC_P2_P2_WFIFO_WPTR_wr_ptr_shift                                          (0)
+#define CABAC_P2_P2_WFIFO_WPTR_wr_ptr_mask                                           (0x7FFFFFFF)
+#define CABAC_P2_P2_WFIFO_WPTR_wr_ptr(data)                                          (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_P2_WFIFO_WPTR_wr_ptr_src(data)                                      ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_P2_WFIFO_WPTR_get_wr_ptr(data)                                      ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_P2_WFIFO_RPTR                                                       0x1800E380
+#define CABAC_P2_P2_WFIFO_RPTR_reg_addr                                              "0xB800E380"
+#define CABAC_P2_P2_WFIFO_RPTR_reg                                                   0xB800E380
+#define set_CABAC_P2_P2_WFIFO_RPTR_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_WFIFO_RPTR_reg)=data)
+#define get_CABAC_P2_P2_WFIFO_RPTR_reg   (*((volatile unsigned int*) CABAC_P2_P2_WFIFO_RPTR_reg))
+#define CABAC_P2_P2_WFIFO_RPTR_inst_adr                                              "0x00E0"
+#define CABAC_P2_P2_WFIFO_RPTR_inst                                                  0x00E0
+#define CABAC_P2_P2_WFIFO_RPTR_rd_ptr_shift                                          (0)
+#define CABAC_P2_P2_WFIFO_RPTR_rd_ptr_mask                                           (0x7FFFFFFF)
+#define CABAC_P2_P2_WFIFO_RPTR_rd_ptr(data)                                          (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_P2_WFIFO_RPTR_rd_ptr_src(data)                                      ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_P2_WFIFO_RPTR_get_rd_ptr(data)                                      ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_P2_RFIFO_DECBSPTR                                                   0x1800E384
+#define CABAC_P2_P2_RFIFO_DECBSPTR_reg_addr                                          "0xB800E384"
+#define CABAC_P2_P2_RFIFO_DECBSPTR_reg                                               0xB800E384
+#define set_CABAC_P2_P2_RFIFO_DECBSPTR_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_DECBSPTR_reg)=data)
+#define get_CABAC_P2_P2_RFIFO_DECBSPTR_reg   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_DECBSPTR_reg))
+#define CABAC_P2_P2_RFIFO_DECBSPTR_inst_adr                                          "0x00E1"
+#define CABAC_P2_P2_RFIFO_DECBSPTR_inst                                              0x00E1
+#define CABAC_P2_P2_RFIFO_DECBSPTR_dec_bit_ptr_shift                                 (0)
+#define CABAC_P2_P2_RFIFO_DECBSPTR_dec_bit_ptr_mask                                  (0xFFFFFFFF)
+#define CABAC_P2_P2_RFIFO_DECBSPTR_dec_bit_ptr(data)                                 (0xFFFFFFFF&((data)<<0))
+#define CABAC_P2_P2_RFIFO_DECBSPTR_dec_bit_ptr_src(data)                             ((0xFFFFFFFF&(data))>>0)
+#define CABAC_P2_P2_RFIFO_DECBSPTR_get_dec_bit_ptr(data)                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_P2_RFIFO_DECBSPTR_MSB                                               0x1800E24C
+#define CABAC_P2_P2_RFIFO_DECBSPTR_MSB_reg_addr                                      "0xB800E24C"
+#define CABAC_P2_P2_RFIFO_DECBSPTR_MSB_reg                                           0xB800E24C
+#define set_CABAC_P2_P2_RFIFO_DECBSPTR_MSB_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_DECBSPTR_MSB_reg)=data)
+#define get_CABAC_P2_P2_RFIFO_DECBSPTR_MSB_reg   (*((volatile unsigned int*) CABAC_P2_P2_RFIFO_DECBSPTR_MSB_reg))
+#define CABAC_P2_P2_RFIFO_DECBSPTR_MSB_inst_adr                                      "0x0093"
+#define CABAC_P2_P2_RFIFO_DECBSPTR_MSB_inst                                          0x0093
+#define CABAC_P2_P2_RFIFO_DECBSPTR_MSB_dec_bit_ptr_msb_shift                         (0)
+#define CABAC_P2_P2_RFIFO_DECBSPTR_MSB_dec_bit_ptr_msb_mask                          (0x00000003)
+#define CABAC_P2_P2_RFIFO_DECBSPTR_MSB_dec_bit_ptr_msb(data)                         (0x00000003&((data)<<0))
+#define CABAC_P2_P2_RFIFO_DECBSPTR_MSB_dec_bit_ptr_msb_src(data)                     ((0x00000003&(data))>>0)
+#define CABAC_P2_P2_RFIFO_DECBSPTR_MSB_get_dec_bit_ptr_msb(data)                     ((0x00000003&(data))>>0)
+
+
+#define CABAC_P2_CABAC_P2_CNTL                                                       0x1800E388
+#define CABAC_P2_CABAC_P2_CNTL_reg_addr                                              "0xB800E388"
+#define CABAC_P2_CABAC_P2_CNTL_reg                                                   0xB800E388
+#define set_CABAC_P2_CABAC_P2_CNTL_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_P2_CNTL_reg)=data)
+#define get_CABAC_P2_CABAC_P2_CNTL_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_P2_CNTL_reg))
+#define CABAC_P2_CABAC_P2_CNTL_inst_adr                                              "0x00E2"
+#define CABAC_P2_CABAC_P2_CNTL_inst                                                  0x00E2
+#define CABAC_P2_CABAC_P2_CNTL_entropy_coding_mode_shift                             (28)
+#define CABAC_P2_CABAC_P2_CNTL_entropy_coding_mode_mask                              (0x10000000)
+#define CABAC_P2_CABAC_P2_CNTL_entropy_coding_mode(data)                             (0x10000000&((data)<<28))
+#define CABAC_P2_CABAC_P2_CNTL_entropy_coding_mode_src(data)                         ((0x10000000&(data))>>28)
+#define CABAC_P2_CABAC_P2_CNTL_get_entropy_coding_mode(data)                         ((0x10000000&(data))>>28)
+#define CABAC_P2_CABAC_P2_CNTL_pic_init_qp_shift                                     (22)
+#define CABAC_P2_CABAC_P2_CNTL_pic_init_qp_mask                                      (0x0FC00000)
+#define CABAC_P2_CABAC_P2_CNTL_pic_init_qp(data)                                     (0x0FC00000&((data)<<22))
+#define CABAC_P2_CABAC_P2_CNTL_pic_init_qp_src(data)                                 ((0x0FC00000&(data))>>22)
+#define CABAC_P2_CABAC_P2_CNTL_get_pic_init_qp(data)                                 ((0x0FC00000&(data))>>22)
+#define CABAC_P2_CABAC_P2_CNTL_chroma_qp_offset_shift                                (17)
+#define CABAC_P2_CABAC_P2_CNTL_chroma_qp_offset_mask                                 (0x003E0000)
+#define CABAC_P2_CABAC_P2_CNTL_chroma_qp_offset(data)                                (0x003E0000&((data)<<17))
+#define CABAC_P2_CABAC_P2_CNTL_chroma_qp_offset_src(data)                            ((0x003E0000&(data))>>17)
+#define CABAC_P2_CABAC_P2_CNTL_get_chroma_qp_offset(data)                            ((0x003E0000&(data))>>17)
+#define CABAC_P2_CABAC_P2_CNTL_second_chroma_qp_offset_shift                         (12)
+#define CABAC_P2_CABAC_P2_CNTL_second_chroma_qp_offset_mask                          (0x0001F000)
+#define CABAC_P2_CABAC_P2_CNTL_second_chroma_qp_offset(data)                         (0x0001F000&((data)<<12))
+#define CABAC_P2_CABAC_P2_CNTL_second_chroma_qp_offset_src(data)                     ((0x0001F000&(data))>>12)
+#define CABAC_P2_CABAC_P2_CNTL_get_second_chroma_qp_offset(data)                     ((0x0001F000&(data))>>12)
+#define CABAC_P2_CABAC_P2_CNTL_direct_8x8_inferflg_shift                             (11)
+#define CABAC_P2_CABAC_P2_CNTL_direct_8x8_inferflg_mask                              (0x00000800)
+#define CABAC_P2_CABAC_P2_CNTL_direct_8x8_inferflg(data)                             (0x00000800&((data)<<11))
+#define CABAC_P2_CABAC_P2_CNTL_direct_8x8_inferflg_src(data)                         ((0x00000800&(data))>>11)
+#define CABAC_P2_CABAC_P2_CNTL_get_direct_8x8_inferflg(data)                         ((0x00000800&(data))>>11)
+#define CABAC_P2_CABAC_P2_CNTL_transform_8x8_mode_flg_shift                          (10)
+#define CABAC_P2_CABAC_P2_CNTL_transform_8x8_mode_flg_mask                           (0x00000400)
+#define CABAC_P2_CABAC_P2_CNTL_transform_8x8_mode_flg(data)                          (0x00000400&((data)<<10))
+#define CABAC_P2_CABAC_P2_CNTL_transform_8x8_mode_flg_src(data)                      ((0x00000400&(data))>>10)
+#define CABAC_P2_CABAC_P2_CNTL_get_transform_8x8_mode_flg(data)                      ((0x00000400&(data))>>10)
+#define CABAC_P2_CABAC_P2_CNTL_num_ref_idx_l0_active_minus1_shift                    (5)
+#define CABAC_P2_CABAC_P2_CNTL_num_ref_idx_l0_active_minus1_mask                     (0x000003E0)
+#define CABAC_P2_CABAC_P2_CNTL_num_ref_idx_l0_active_minus1(data)                    (0x000003E0&((data)<<5))
+#define CABAC_P2_CABAC_P2_CNTL_num_ref_idx_l0_active_minus1_src(data)                ((0x000003E0&(data))>>5)
+#define CABAC_P2_CABAC_P2_CNTL_get_num_ref_idx_l0_active_minus1(data)                ((0x000003E0&(data))>>5)
+#define CABAC_P2_CABAC_P2_CNTL_num_ref_idx_l1_active_minus1_shift                    (0)
+#define CABAC_P2_CABAC_P2_CNTL_num_ref_idx_l1_active_minus1_mask                     (0x0000001F)
+#define CABAC_P2_CABAC_P2_CNTL_num_ref_idx_l1_active_minus1(data)                    (0x0000001F&((data)<<0))
+#define CABAC_P2_CABAC_P2_CNTL_num_ref_idx_l1_active_minus1_src(data)                ((0x0000001F&(data))>>0)
+#define CABAC_P2_CABAC_P2_CNTL_get_num_ref_idx_l1_active_minus1(data)                ((0x0000001F&(data))>>0)
+
+
+#define CABAC_P2_CABAC_P2_CNTL2                                                      0x1800E38C
+#define CABAC_P2_CABAC_P2_CNTL2_reg_addr                                             "0xB800E38C"
+#define CABAC_P2_CABAC_P2_CNTL2_reg                                                  0xB800E38C
+#define set_CABAC_P2_CABAC_P2_CNTL2_reg(data)   (*((volatile unsigned int*) CABAC_P2_CABAC_P2_CNTL2_reg)=data)
+#define get_CABAC_P2_CABAC_P2_CNTL2_reg   (*((volatile unsigned int*) CABAC_P2_CABAC_P2_CNTL2_reg))
+#define CABAC_P2_CABAC_P2_CNTL2_inst_adr                                             "0x00E3"
+#define CABAC_P2_CABAC_P2_CNTL2_inst                                                 0x00E3
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable7_shift                                  (31)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable7_mask                                   (0x80000000)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable7(data)                                  (0x80000000&((data)<<31))
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable7_src(data)                              ((0x80000000&(data))>>31)
+#define CABAC_P2_CABAC_P2_CNTL2_get_write_enable7(data)                              ((0x80000000&(data))>>31)
+#define CABAC_P2_CABAC_P2_CNTL2_mb_adaptive_frame_field_flag_shift                   (30)
+#define CABAC_P2_CABAC_P2_CNTL2_mb_adaptive_frame_field_flag_mask                    (0x40000000)
+#define CABAC_P2_CABAC_P2_CNTL2_mb_adaptive_frame_field_flag(data)                   (0x40000000&((data)<<30))
+#define CABAC_P2_CABAC_P2_CNTL2_mb_adaptive_frame_field_flag_src(data)               ((0x40000000&(data))>>30)
+#define CABAC_P2_CABAC_P2_CNTL2_get_mb_adaptive_frame_field_flag(data)               ((0x40000000&(data))>>30)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable6_shift                                  (29)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable6_mask                                   (0x20000000)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable6(data)                                  (0x20000000&((data)<<29))
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable6_src(data)                              ((0x20000000&(data))>>29)
+#define CABAC_P2_CABAC_P2_CNTL2_get_write_enable6(data)                              ((0x20000000&(data))>>29)
+#define CABAC_P2_CABAC_P2_CNTL2_picmb_w_shift                                        (19)
+#define CABAC_P2_CABAC_P2_CNTL2_picmb_w_mask                                         (0x1FF80000)
+#define CABAC_P2_CABAC_P2_CNTL2_picmb_w(data)                                        (0x1FF80000&((data)<<19))
+#define CABAC_P2_CABAC_P2_CNTL2_picmb_w_src(data)                                    ((0x1FF80000&(data))>>19)
+#define CABAC_P2_CABAC_P2_CNTL2_get_picmb_w(data)                                    ((0x1FF80000&(data))>>19)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable5_shift                                  (18)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable5_mask                                   (0x00040000)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable5(data)                                  (0x00040000&((data)<<18))
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable5_src(data)                              ((0x00040000&(data))>>18)
+#define CABAC_P2_CABAC_P2_CNTL2_get_write_enable5(data)                              ((0x00040000&(data))>>18)
+#define CABAC_P2_CABAC_P2_CNTL2_monochrome_shift                                     (17)
+#define CABAC_P2_CABAC_P2_CNTL2_monochrome_mask                                      (0x00020000)
+#define CABAC_P2_CABAC_P2_CNTL2_monochrome(data)                                     (0x00020000&((data)<<17))
+#define CABAC_P2_CABAC_P2_CNTL2_monochrome_src(data)                                 ((0x00020000&(data))>>17)
+#define CABAC_P2_CABAC_P2_CNTL2_get_monochrome(data)                                 ((0x00020000&(data))>>17)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable4_shift                                  (16)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable4_mask                                   (0x00010000)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable4(data)                                  (0x00010000&((data)<<16))
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable4_src(data)                              ((0x00010000&(data))>>16)
+#define CABAC_P2_CABAC_P2_CNTL2_get_write_enable4(data)                              ((0x00010000&(data))>>16)
+#define CABAC_P2_CABAC_P2_CNTL2_field_pic_flag_shift                                 (15)
+#define CABAC_P2_CABAC_P2_CNTL2_field_pic_flag_mask                                  (0x00008000)
+#define CABAC_P2_CABAC_P2_CNTL2_field_pic_flag(data)                                 (0x00008000&((data)<<15))
+#define CABAC_P2_CABAC_P2_CNTL2_field_pic_flag_src(data)                             ((0x00008000&(data))>>15)
+#define CABAC_P2_CABAC_P2_CNTL2_get_field_pic_flag(data)                             ((0x00008000&(data))>>15)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable3_shift                                  (14)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable3_mask                                   (0x00004000)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable3(data)                                  (0x00004000&((data)<<14))
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable3_src(data)                              ((0x00004000&(data))>>14)
+#define CABAC_P2_CABAC_P2_CNTL2_get_write_enable3(data)                              ((0x00004000&(data))>>14)
+#define CABAC_P2_CABAC_P2_CNTL2_pic_type_shift                                       (11)
+#define CABAC_P2_CABAC_P2_CNTL2_pic_type_mask                                        (0x00003800)
+#define CABAC_P2_CABAC_P2_CNTL2_pic_type(data)                                       (0x00003800&((data)<<11))
+#define CABAC_P2_CABAC_P2_CNTL2_pic_type_src(data)                                   ((0x00003800&(data))>>11)
+#define CABAC_P2_CABAC_P2_CNTL2_get_pic_type(data)                                   ((0x00003800&(data))>>11)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable2_shift                                  (10)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable2_mask                                   (0x00000400)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable2(data)                                  (0x00000400&((data)<<10))
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable2_src(data)                              ((0x00000400&(data))>>10)
+#define CABAC_P2_CABAC_P2_CNTL2_get_write_enable2(data)                              ((0x00000400&(data))>>10)
+#define CABAC_P2_CABAC_P2_CNTL2_slice_qp_delta_shift                                 (3)
+#define CABAC_P2_CABAC_P2_CNTL2_slice_qp_delta_mask                                  (0x000003F8)
+#define CABAC_P2_CABAC_P2_CNTL2_slice_qp_delta(data)                                 (0x000003F8&((data)<<3))
+#define CABAC_P2_CABAC_P2_CNTL2_slice_qp_delta_src(data)                             ((0x000003F8&(data))>>3)
+#define CABAC_P2_CABAC_P2_CNTL2_get_slice_qp_delta(data)                             ((0x000003F8&(data))>>3)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable1_shift                                  (2)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable1_mask                                   (0x00000004)
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable1(data)                                  (0x00000004&((data)<<2))
+#define CABAC_P2_CABAC_P2_CNTL2_write_enable1_src(data)                              ((0x00000004&(data))>>2)
+#define CABAC_P2_CABAC_P2_CNTL2_get_write_enable1(data)                              ((0x00000004&(data))>>2)
+#define CABAC_P2_CABAC_P2_CNTL2_cabac_init_idc_shift                                 (0)
+#define CABAC_P2_CABAC_P2_CNTL2_cabac_init_idc_mask                                  (0x00000003)
+#define CABAC_P2_CABAC_P2_CNTL2_cabac_init_idc(data)                                 (0x00000003&((data)<<0))
+#define CABAC_P2_CABAC_P2_CNTL2_cabac_init_idc_src(data)                             ((0x00000003&(data))>>0)
+#define CABAC_P2_CABAC_P2_CNTL2_get_cabac_init_idc(data)                             ((0x00000003&(data))>>0)
+
+
+#define CABAC_P2_P2_NDB_CTL                                                          0x1800E3B8
+#define CABAC_P2_P2_NDB_CTL_reg_addr                                                 "0xB800E3B8"
+#define CABAC_P2_P2_NDB_CTL_reg                                                      0xB800E3B8
+#define set_CABAC_P2_P2_NDB_CTL_reg(data)   (*((volatile unsigned int*) CABAC_P2_P2_NDB_CTL_reg)=data)
+#define get_CABAC_P2_P2_NDB_CTL_reg   (*((volatile unsigned int*) CABAC_P2_P2_NDB_CTL_reg))
+#define CABAC_P2_P2_NDB_CTL_inst_adr                                                 "0x00EE"
+#define CABAC_P2_P2_NDB_CTL_inst                                                     0x00EE
+#define CABAC_P2_P2_NDB_CTL_write_enable3_shift                                      (5)
+#define CABAC_P2_P2_NDB_CTL_write_enable3_mask                                       (0x00000020)
+#define CABAC_P2_P2_NDB_CTL_write_enable3(data)                                      (0x00000020&((data)<<5))
+#define CABAC_P2_P2_NDB_CTL_write_enable3_src(data)                                  ((0x00000020&(data))>>5)
+#define CABAC_P2_P2_NDB_CTL_get_write_enable3(data)                                  ((0x00000020&(data))>>5)
+#define CABAC_P2_P2_NDB_CTL_cabac_halt_done_shift                                    (4)
+#define CABAC_P2_P2_NDB_CTL_cabac_halt_done_mask                                     (0x00000010)
+#define CABAC_P2_P2_NDB_CTL_cabac_halt_done(data)                                    (0x00000010&((data)<<4))
+#define CABAC_P2_P2_NDB_CTL_cabac_halt_done_src(data)                                ((0x00000010&(data))>>4)
+#define CABAC_P2_P2_NDB_CTL_get_cabac_halt_done(data)                                ((0x00000010&(data))>>4)
+#define CABAC_P2_P2_NDB_CTL_write_enable2_shift                                      (3)
+#define CABAC_P2_P2_NDB_CTL_write_enable2_mask                                       (0x00000008)
+#define CABAC_P2_P2_NDB_CTL_write_enable2(data)                                      (0x00000008&((data)<<3))
+#define CABAC_P2_P2_NDB_CTL_write_enable2_src(data)                                  ((0x00000008&(data))>>3)
+#define CABAC_P2_P2_NDB_CTL_get_write_enable2(data)                                  ((0x00000008&(data))>>3)
+#define CABAC_P2_P2_NDB_CTL_cabac_halt_shift                                         (2)
+#define CABAC_P2_P2_NDB_CTL_cabac_halt_mask                                          (0x00000004)
+#define CABAC_P2_P2_NDB_CTL_cabac_halt(data)                                         (0x00000004&((data)<<2))
+#define CABAC_P2_P2_NDB_CTL_cabac_halt_src(data)                                     ((0x00000004&(data))>>2)
+#define CABAC_P2_P2_NDB_CTL_get_cabac_halt(data)                                     ((0x00000004&(data))>>2)
+#define CABAC_P2_P2_NDB_CTL_write_enable1_shift                                      (1)
+#define CABAC_P2_P2_NDB_CTL_write_enable1_mask                                       (0x00000002)
+#define CABAC_P2_P2_NDB_CTL_write_enable1(data)                                      (0x00000002&((data)<<1))
+#define CABAC_P2_P2_NDB_CTL_write_enable1_src(data)                                  ((0x00000002&(data))>>1)
+#define CABAC_P2_P2_NDB_CTL_get_write_enable1(data)                                  ((0x00000002&(data))>>1)
+#define CABAC_P2_P2_NDB_CTL_postwrite_en_shift                                       (0)
+#define CABAC_P2_P2_NDB_CTL_postwrite_en_mask                                        (0x00000001)
+#define CABAC_P2_P2_NDB_CTL_postwrite_en(data)                                       (0x00000001&((data)<<0))
+#define CABAC_P2_P2_NDB_CTL_postwrite_en_src(data)                                   ((0x00000001&(data))>>0)
+#define CABAC_P2_P2_NDB_CTL_get_postwrite_en(data)                                   ((0x00000001&(data))>>0)
+
+
+#define CABAC_P2_NDB_CABAC_BASE                                                      0x1800E394
+#define CABAC_P2_NDB_CABAC_BASE_reg_addr                                             "0xB800E394"
+#define CABAC_P2_NDB_CABAC_BASE_reg                                                  0xB800E394
+#define set_CABAC_P2_NDB_CABAC_BASE_reg(data)   (*((volatile unsigned int*) CABAC_P2_NDB_CABAC_BASE_reg)=data)
+#define get_CABAC_P2_NDB_CABAC_BASE_reg   (*((volatile unsigned int*) CABAC_P2_NDB_CABAC_BASE_reg))
+#define CABAC_P2_NDB_CABAC_BASE_inst_adr                                             "0x00E5"
+#define CABAC_P2_NDB_CABAC_BASE_inst                                                 0x00E5
+#define CABAC_P2_NDB_CABAC_BASE_base_addr_shift                                      (0)
+#define CABAC_P2_NDB_CABAC_BASE_base_addr_mask                                       (0x7FFFFFFF)
+#define CABAC_P2_NDB_CABAC_BASE_base_addr(data)                                      (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_NDB_CABAC_BASE_base_addr_src(data)                                  ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_NDB_CABAC_BASE_get_base_addr(data)                                  ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_NDB_CABAC_LIMIT                                                     0x1800E39C
+#define CABAC_P2_NDB_CABAC_LIMIT_reg_addr                                            "0xB800E39C"
+#define CABAC_P2_NDB_CABAC_LIMIT_reg                                                 0xB800E39C
+#define set_CABAC_P2_NDB_CABAC_LIMIT_reg(data)   (*((volatile unsigned int*) CABAC_P2_NDB_CABAC_LIMIT_reg)=data)
+#define get_CABAC_P2_NDB_CABAC_LIMIT_reg   (*((volatile unsigned int*) CABAC_P2_NDB_CABAC_LIMIT_reg))
+#define CABAC_P2_NDB_CABAC_LIMIT_inst_adr                                            "0x00E7"
+#define CABAC_P2_NDB_CABAC_LIMIT_inst                                                0x00E7
+#define CABAC_P2_NDB_CABAC_LIMIT_limit_addr_shift                                    (0)
+#define CABAC_P2_NDB_CABAC_LIMIT_limit_addr_mask                                     (0x7FFFFFFF)
+#define CABAC_P2_NDB_CABAC_LIMIT_limit_addr(data)                                    (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_NDB_CABAC_LIMIT_limit_addr_src(data)                                ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_NDB_CABAC_LIMIT_get_limit_addr(data)                                ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_NDB_CABAC_WPTR                                                      0x1800E3A0
+#define CABAC_P2_NDB_CABAC_WPTR_reg_addr                                             "0xB800E3A0"
+#define CABAC_P2_NDB_CABAC_WPTR_reg                                                  0xB800E3A0
+#define set_CABAC_P2_NDB_CABAC_WPTR_reg(data)   (*((volatile unsigned int*) CABAC_P2_NDB_CABAC_WPTR_reg)=data)
+#define get_CABAC_P2_NDB_CABAC_WPTR_reg   (*((volatile unsigned int*) CABAC_P2_NDB_CABAC_WPTR_reg))
+#define CABAC_P2_NDB_CABAC_WPTR_inst_adr                                             "0x00E8"
+#define CABAC_P2_NDB_CABAC_WPTR_inst                                                 0x00E8
+#define CABAC_P2_NDB_CABAC_WPTR_wr_ptr_shift                                         (0)
+#define CABAC_P2_NDB_CABAC_WPTR_wr_ptr_mask                                          (0x7FFFFFFF)
+#define CABAC_P2_NDB_CABAC_WPTR_wr_ptr(data)                                         (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_NDB_CABAC_WPTR_wr_ptr_src(data)                                     ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_NDB_CABAC_WPTR_get_wr_ptr(data)                                     ((0x7FFFFFFF&(data))>>0)
+
+
+#define CABAC_P2_NDB_CABAC_RPTR                                                      0x1800E3A4
+#define CABAC_P2_NDB_CABAC_RPTR_reg_addr                                             "0xB800E3A4"
+#define CABAC_P2_NDB_CABAC_RPTR_reg                                                  0xB800E3A4
+#define set_CABAC_P2_NDB_CABAC_RPTR_reg(data)   (*((volatile unsigned int*) CABAC_P2_NDB_CABAC_RPTR_reg)=data)
+#define get_CABAC_P2_NDB_CABAC_RPTR_reg   (*((volatile unsigned int*) CABAC_P2_NDB_CABAC_RPTR_reg))
+#define CABAC_P2_NDB_CABAC_RPTR_inst_adr                                             "0x00E9"
+#define CABAC_P2_NDB_CABAC_RPTR_inst                                                 0x00E9
+#define CABAC_P2_NDB_CABAC_RPTR_rd_ptr_shift                                         (0)
+#define CABAC_P2_NDB_CABAC_RPTR_rd_ptr_mask                                          (0x7FFFFFFF)
+#define CABAC_P2_NDB_CABAC_RPTR_rd_ptr(data)                                         (0x7FFFFFFF&((data)<<0))
+#define CABAC_P2_NDB_CABAC_RPTR_rd_ptr_src(data)                                     ((0x7FFFFFFF&(data))>>0)
+#define CABAC_P2_NDB_CABAC_RPTR_get_rd_ptr(data)                                     ((0x7FFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/cam_emm_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cam_emm_reg.h
new file mode 100644
index 00000000..e4e3d16
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cam_emm_reg.h
@@ -0,0 +1,4971 @@
+/**************************************************************
+// Spec Version                  : 0.0.2
+// Parser Version                : DVR_Parser_6.8(110516)
+// CModelGen Version             : 5.0 2009.04.09
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2011/12/14 10:3:38
+***************************************************************/
+
+
+#ifndef _CAM_EMM_REG_H_INCLUDED_
+#define _CAM_EMM_REG_H_INCLUDED_
+#ifdef  _CAM_EMM_USE_STRUCT
+typedef struct 
+{
+unsigned int     msb_03:8;
+unsigned int     msb_02:8;
+unsigned int     lsb_01:8;
+unsigned int     lsb_00:8;
+}CAM_EMM_TID_MODE;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CAM_EMM_DATA_ID1;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CAM_EMM_DATA_ID2;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CAM_EMM_DATA_ID3;
+
+typedef struct 
+{
+unsigned int     mask:32;
+}CAM_EMM_MASK_ID1;
+
+typedef struct 
+{
+unsigned int     mask:32;
+}CAM_EMM_MASK_ID2;
+
+typedef struct 
+{
+unsigned int     mask:32;
+}CAM_EMM_MASK_ID3;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     emm_en:1;
+unsigned int     tid_en:1;
+unsigned int     reserved_1:1;
+unsigned int     pid:13;
+}CAM_EMM_PID;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tid_msb:4;
+unsigned int     dmy:4;
+}CAM_EMM_TID;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     emm:8;
+}CAM_EMM_CA_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     int_sts:8;
+}CAM_EMM_INT_STAT;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CAM_EMM_DATA_ID4;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CAM_EMM_DATA_ID5;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CAM_EMM_DATA_ID6;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CAM_EMM_DATA_ID7;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CAM_EMM_DATA_ID8;
+
+typedef struct 
+{
+unsigned int     mask:32;
+}CAM_EMM_MASK_ID4;
+
+typedef struct 
+{
+unsigned int     mask:32;
+}CAM_EMM_MASK_ID5;
+
+typedef struct 
+{
+unsigned int     mask:32;
+}CAM_EMM_MASK_ID6;
+
+typedef struct 
+{
+unsigned int     mask:32;
+}CAM_EMM_MASK_ID7;
+
+typedef struct 
+{
+unsigned int     mask:32;
+}CAM_EMM_MASK_ID8;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     num_lbl:16;
+}CAM_EMM_CTRL_ID;
+
+typedef struct 
+{
+unsigned int     pkt_data:32;
+}CAM_EMM_EMM_BUF;
+
+#endif
+
+#define CAM_EMM_TID_MODE                                                             0x18011000
+#define CAM_EMM_TID_MODE_reg_addr                                                    "0xB8011000"
+#define CAM_EMM_TID_MODE_reg                                                         0xB8011000
+#define set_CAM_EMM_TID_MODE_reg(data)   (*((volatile unsigned int*) CAM_EMM_TID_MODE_reg)=data)
+#define get_CAM_EMM_TID_MODE_reg   (*((volatile unsigned int*) CAM_EMM_TID_MODE_reg))
+#define CAM_EMM_TID_MODE_inst_adr                                                    "0x0000"
+#define CAM_EMM_TID_MODE_inst                                                        0x0000
+#define CAM_EMM_TID_MODE_msb_03_shift                                                (24)
+#define CAM_EMM_TID_MODE_msb_03_mask                                                 (0xFF000000)
+#define CAM_EMM_TID_MODE_msb_03(data)                                                (0xFF000000&((data)<<24))
+#define CAM_EMM_TID_MODE_msb_03_src(data)                                            ((0xFF000000&(data))>>24)
+#define CAM_EMM_TID_MODE_get_msb_03(data)                                            ((0xFF000000&(data))>>24)
+#define CAM_EMM_TID_MODE_msb_02_shift                                                (16)
+#define CAM_EMM_TID_MODE_msb_02_mask                                                 (0x00FF0000)
+#define CAM_EMM_TID_MODE_msb_02(data)                                                (0x00FF0000&((data)<<16))
+#define CAM_EMM_TID_MODE_msb_02_src(data)                                            ((0x00FF0000&(data))>>16)
+#define CAM_EMM_TID_MODE_get_msb_02(data)                                            ((0x00FF0000&(data))>>16)
+#define CAM_EMM_TID_MODE_lsb_01_shift                                                (8)
+#define CAM_EMM_TID_MODE_lsb_01_mask                                                 (0x0000FF00)
+#define CAM_EMM_TID_MODE_lsb_01(data)                                                (0x0000FF00&((data)<<8))
+#define CAM_EMM_TID_MODE_lsb_01_src(data)                                            ((0x0000FF00&(data))>>8)
+#define CAM_EMM_TID_MODE_get_lsb_01(data)                                            ((0x0000FF00&(data))>>8)
+#define CAM_EMM_TID_MODE_lsb_00_shift                                                (0)
+#define CAM_EMM_TID_MODE_lsb_00_mask                                                 (0x000000FF)
+#define CAM_EMM_TID_MODE_lsb_00(data)                                                (0x000000FF&((data)<<0))
+#define CAM_EMM_TID_MODE_lsb_00_src(data)                                            ((0x000000FF&(data))>>0)
+#define CAM_EMM_TID_MODE_get_lsb_00(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define CAM_EMM_DATA_ID1                                                             0x18011004
+#define CAM_EMM_DATA_ID1_reg_addr                                                    "0xB8011004"
+#define CAM_EMM_DATA_ID1_reg                                                         0xB8011004
+#define set_CAM_EMM_DATA_ID1_reg(data)   (*((volatile unsigned int*) CAM_EMM_DATA_ID1_reg)=data)
+#define get_CAM_EMM_DATA_ID1_reg   (*((volatile unsigned int*) CAM_EMM_DATA_ID1_reg))
+#define CAM_EMM_DATA_ID1_inst_adr                                                    "0x0001"
+#define CAM_EMM_DATA_ID1_inst                                                        0x0001
+#define CAM_EMM_DATA_ID1_data_shift                                                  (0)
+#define CAM_EMM_DATA_ID1_data_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_DATA_ID1_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_DATA_ID1_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_DATA_ID1_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_DATA_ID2                                                             0x18011008
+#define CAM_EMM_DATA_ID2_reg_addr                                                    "0xB8011008"
+#define CAM_EMM_DATA_ID2_reg                                                         0xB8011008
+#define set_CAM_EMM_DATA_ID2_reg(data)   (*((volatile unsigned int*) CAM_EMM_DATA_ID2_reg)=data)
+#define get_CAM_EMM_DATA_ID2_reg   (*((volatile unsigned int*) CAM_EMM_DATA_ID2_reg))
+#define CAM_EMM_DATA_ID2_inst_adr                                                    "0x0002"
+#define CAM_EMM_DATA_ID2_inst                                                        0x0002
+#define CAM_EMM_DATA_ID2_data_shift                                                  (0)
+#define CAM_EMM_DATA_ID2_data_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_DATA_ID2_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_DATA_ID2_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_DATA_ID2_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_DATA_ID3                                                             0x1801100C
+#define CAM_EMM_DATA_ID3_reg_addr                                                    "0xB801100C"
+#define CAM_EMM_DATA_ID3_reg                                                         0xB801100C
+#define set_CAM_EMM_DATA_ID3_reg(data)   (*((volatile unsigned int*) CAM_EMM_DATA_ID3_reg)=data)
+#define get_CAM_EMM_DATA_ID3_reg   (*((volatile unsigned int*) CAM_EMM_DATA_ID3_reg))
+#define CAM_EMM_DATA_ID3_inst_adr                                                    "0x0003"
+#define CAM_EMM_DATA_ID3_inst                                                        0x0003
+#define CAM_EMM_DATA_ID3_data_shift                                                  (0)
+#define CAM_EMM_DATA_ID3_data_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_DATA_ID3_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_DATA_ID3_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_DATA_ID3_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_MASK_ID1                                                             0x18011014
+#define CAM_EMM_MASK_ID1_reg_addr                                                    "0xB8011014"
+#define CAM_EMM_MASK_ID1_reg                                                         0xB8011014
+#define set_CAM_EMM_MASK_ID1_reg(data)   (*((volatile unsigned int*) CAM_EMM_MASK_ID1_reg)=data)
+#define get_CAM_EMM_MASK_ID1_reg   (*((volatile unsigned int*) CAM_EMM_MASK_ID1_reg))
+#define CAM_EMM_MASK_ID1_inst_adr                                                    "0x0005"
+#define CAM_EMM_MASK_ID1_inst                                                        0x0005
+#define CAM_EMM_MASK_ID1_mask_shift                                                  (0)
+#define CAM_EMM_MASK_ID1_mask_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_MASK_ID1_mask(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_MASK_ID1_mask_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_MASK_ID1_get_mask(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_MASK_ID2                                                             0x18011018
+#define CAM_EMM_MASK_ID2_reg_addr                                                    "0xB8011018"
+#define CAM_EMM_MASK_ID2_reg                                                         0xB8011018
+#define set_CAM_EMM_MASK_ID2_reg(data)   (*((volatile unsigned int*) CAM_EMM_MASK_ID2_reg)=data)
+#define get_CAM_EMM_MASK_ID2_reg   (*((volatile unsigned int*) CAM_EMM_MASK_ID2_reg))
+#define CAM_EMM_MASK_ID2_inst_adr                                                    "0x0006"
+#define CAM_EMM_MASK_ID2_inst                                                        0x0006
+#define CAM_EMM_MASK_ID2_mask_shift                                                  (0)
+#define CAM_EMM_MASK_ID2_mask_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_MASK_ID2_mask(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_MASK_ID2_mask_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_MASK_ID2_get_mask(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_MASK_ID3                                                             0x1801101C
+#define CAM_EMM_MASK_ID3_reg_addr                                                    "0xB801101C"
+#define CAM_EMM_MASK_ID3_reg                                                         0xB801101C
+#define set_CAM_EMM_MASK_ID3_reg(data)   (*((volatile unsigned int*) CAM_EMM_MASK_ID3_reg)=data)
+#define get_CAM_EMM_MASK_ID3_reg   (*((volatile unsigned int*) CAM_EMM_MASK_ID3_reg))
+#define CAM_EMM_MASK_ID3_inst_adr                                                    "0x0007"
+#define CAM_EMM_MASK_ID3_inst                                                        0x0007
+#define CAM_EMM_MASK_ID3_mask_shift                                                  (0)
+#define CAM_EMM_MASK_ID3_mask_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_MASK_ID3_mask(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_MASK_ID3_mask_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_MASK_ID3_get_mask(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_PID                                                                  0x18011020
+#define CAM_EMM_PID_reg_addr                                                         "0xB8011020"
+#define CAM_EMM_PID_reg                                                              0xB8011020
+#define set_CAM_EMM_PID_reg(data)   (*((volatile unsigned int*) CAM_EMM_PID_reg)=data)
+#define get_CAM_EMM_PID_reg   (*((volatile unsigned int*) CAM_EMM_PID_reg))
+#define CAM_EMM_PID_inst_adr                                                         "0x0008"
+#define CAM_EMM_PID_inst                                                             0x0008
+#define CAM_EMM_PID_emm_en_shift                                                     (15)
+#define CAM_EMM_PID_emm_en_mask                                                      (0x00008000)
+#define CAM_EMM_PID_emm_en(data)                                                     (0x00008000&((data)<<15))
+#define CAM_EMM_PID_emm_en_src(data)                                                 ((0x00008000&(data))>>15)
+#define CAM_EMM_PID_get_emm_en(data)                                                 ((0x00008000&(data))>>15)
+#define CAM_EMM_PID_tid_en_shift                                                     (14)
+#define CAM_EMM_PID_tid_en_mask                                                      (0x00004000)
+#define CAM_EMM_PID_tid_en(data)                                                     (0x00004000&((data)<<14))
+#define CAM_EMM_PID_tid_en_src(data)                                                 ((0x00004000&(data))>>14)
+#define CAM_EMM_PID_get_tid_en(data)                                                 ((0x00004000&(data))>>14)
+#define CAM_EMM_PID_pid_shift                                                        (0)
+#define CAM_EMM_PID_pid_mask                                                         (0x00001FFF)
+#define CAM_EMM_PID_pid(data)                                                        (0x00001FFF&((data)<<0))
+#define CAM_EMM_PID_pid_src(data)                                                    ((0x00001FFF&(data))>>0)
+#define CAM_EMM_PID_get_pid(data)                                                    ((0x00001FFF&(data))>>0)
+
+
+#define CAM_EMM_TID                                                                  0x18011024
+#define CAM_EMM_TID_reg_addr                                                         "0xB8011024"
+#define CAM_EMM_TID_reg                                                              0xB8011024
+#define set_CAM_EMM_TID_reg(data)   (*((volatile unsigned int*) CAM_EMM_TID_reg)=data)
+#define get_CAM_EMM_TID_reg   (*((volatile unsigned int*) CAM_EMM_TID_reg))
+#define CAM_EMM_TID_inst_adr                                                         "0x0009"
+#define CAM_EMM_TID_inst                                                             0x0009
+#define CAM_EMM_TID_tid_msb_shift                                                    (4)
+#define CAM_EMM_TID_tid_msb_mask                                                     (0x000000F0)
+#define CAM_EMM_TID_tid_msb(data)                                                    (0x000000F0&((data)<<4))
+#define CAM_EMM_TID_tid_msb_src(data)                                                ((0x000000F0&(data))>>4)
+#define CAM_EMM_TID_get_tid_msb(data)                                                ((0x000000F0&(data))>>4)
+#define CAM_EMM_TID_dmy_shift                                                        (0)
+#define CAM_EMM_TID_dmy_mask                                                         (0x0000000F)
+#define CAM_EMM_TID_dmy(data)                                                        (0x0000000F&((data)<<0))
+#define CAM_EMM_TID_dmy_src(data)                                                    ((0x0000000F&(data))>>0)
+#define CAM_EMM_TID_get_dmy(data)                                                    ((0x0000000F&(data))>>0)
+
+
+#define CAM_EMM_CA_INT                                                               0x18011030
+#define CAM_EMM_CA_INT_reg_addr                                                      "0xB8011030"
+#define CAM_EMM_CA_INT_reg                                                           0xB8011030
+#define set_CAM_EMM_CA_INT_reg(data)   (*((volatile unsigned int*) CAM_EMM_CA_INT_reg)=data)
+#define get_CAM_EMM_CA_INT_reg   (*((volatile unsigned int*) CAM_EMM_CA_INT_reg))
+#define CAM_EMM_CA_INT_inst_adr                                                      "0x000C"
+#define CAM_EMM_CA_INT_inst                                                          0x000C
+#define CAM_EMM_CA_INT_emm_shift                                                     (0)
+#define CAM_EMM_CA_INT_emm_mask                                                      (0x000000FF)
+#define CAM_EMM_CA_INT_emm(data)                                                     (0x000000FF&((data)<<0))
+#define CAM_EMM_CA_INT_emm_src(data)                                                 ((0x000000FF&(data))>>0)
+#define CAM_EMM_CA_INT_get_emm(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define CAM_EMM_INT_STAT                                                             0x18011034
+#define CAM_EMM_INT_STAT_reg_addr                                                    "0xB8011034"
+#define CAM_EMM_INT_STAT_reg                                                         0xB8011034
+#define set_CAM_EMM_INT_STAT_reg(data)   (*((volatile unsigned int*) CAM_EMM_INT_STAT_reg)=data)
+#define get_CAM_EMM_INT_STAT_reg   (*((volatile unsigned int*) CAM_EMM_INT_STAT_reg))
+#define CAM_EMM_INT_STAT_inst_adr                                                    "0x000D"
+#define CAM_EMM_INT_STAT_inst                                                        0x000D
+#define CAM_EMM_INT_STAT_int_sts_shift                                               (0)
+#define CAM_EMM_INT_STAT_int_sts_mask                                                (0x000000FF)
+#define CAM_EMM_INT_STAT_int_sts(data)                                               (0x000000FF&((data)<<0))
+#define CAM_EMM_INT_STAT_int_sts_src(data)                                           ((0x000000FF&(data))>>0)
+#define CAM_EMM_INT_STAT_get_int_sts(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define CAM_EMM_DATA_ID4                                                             0x18011070
+#define CAM_EMM_DATA_ID4_reg_addr                                                    "0xB8011070"
+#define CAM_EMM_DATA_ID4_reg                                                         0xB8011070
+#define set_CAM_EMM_DATA_ID4_reg(data)   (*((volatile unsigned int*) CAM_EMM_DATA_ID4_reg)=data)
+#define get_CAM_EMM_DATA_ID4_reg   (*((volatile unsigned int*) CAM_EMM_DATA_ID4_reg))
+#define CAM_EMM_DATA_ID4_inst_adr                                                    "0x001C"
+#define CAM_EMM_DATA_ID4_inst                                                        0x001C
+#define CAM_EMM_DATA_ID4_data_shift                                                  (0)
+#define CAM_EMM_DATA_ID4_data_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_DATA_ID4_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_DATA_ID4_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_DATA_ID4_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_DATA_ID5                                                             0x18011074
+#define CAM_EMM_DATA_ID5_reg_addr                                                    "0xB8011074"
+#define CAM_EMM_DATA_ID5_reg                                                         0xB8011074
+#define set_CAM_EMM_DATA_ID5_reg(data)   (*((volatile unsigned int*) CAM_EMM_DATA_ID5_reg)=data)
+#define get_CAM_EMM_DATA_ID5_reg   (*((volatile unsigned int*) CAM_EMM_DATA_ID5_reg))
+#define CAM_EMM_DATA_ID5_inst_adr                                                    "0x001D"
+#define CAM_EMM_DATA_ID5_inst                                                        0x001D
+#define CAM_EMM_DATA_ID5_data_shift                                                  (0)
+#define CAM_EMM_DATA_ID5_data_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_DATA_ID5_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_DATA_ID5_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_DATA_ID5_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_DATA_ID6                                                             0x18011078
+#define CAM_EMM_DATA_ID6_reg_addr                                                    "0xB8011078"
+#define CAM_EMM_DATA_ID6_reg                                                         0xB8011078
+#define set_CAM_EMM_DATA_ID6_reg(data)   (*((volatile unsigned int*) CAM_EMM_DATA_ID6_reg)=data)
+#define get_CAM_EMM_DATA_ID6_reg   (*((volatile unsigned int*) CAM_EMM_DATA_ID6_reg))
+#define CAM_EMM_DATA_ID6_inst_adr                                                    "0x001E"
+#define CAM_EMM_DATA_ID6_inst                                                        0x001E
+#define CAM_EMM_DATA_ID6_data_shift                                                  (0)
+#define CAM_EMM_DATA_ID6_data_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_DATA_ID6_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_DATA_ID6_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_DATA_ID6_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_DATA_ID7                                                             0x1801107C
+#define CAM_EMM_DATA_ID7_reg_addr                                                    "0xB801107C"
+#define CAM_EMM_DATA_ID7_reg                                                         0xB801107C
+#define set_CAM_EMM_DATA_ID7_reg(data)   (*((volatile unsigned int*) CAM_EMM_DATA_ID7_reg)=data)
+#define get_CAM_EMM_DATA_ID7_reg   (*((volatile unsigned int*) CAM_EMM_DATA_ID7_reg))
+#define CAM_EMM_DATA_ID7_inst_adr                                                    "0x001F"
+#define CAM_EMM_DATA_ID7_inst                                                        0x001F
+#define CAM_EMM_DATA_ID7_data_shift                                                  (0)
+#define CAM_EMM_DATA_ID7_data_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_DATA_ID7_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_DATA_ID7_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_DATA_ID7_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_DATA_ID8                                                             0x18011080
+#define CAM_EMM_DATA_ID8_reg_addr                                                    "0xB8011080"
+#define CAM_EMM_DATA_ID8_reg                                                         0xB8011080
+#define set_CAM_EMM_DATA_ID8_reg(data)   (*((volatile unsigned int*) CAM_EMM_DATA_ID8_reg)=data)
+#define get_CAM_EMM_DATA_ID8_reg   (*((volatile unsigned int*) CAM_EMM_DATA_ID8_reg))
+#define CAM_EMM_DATA_ID8_inst_adr                                                    "0x0020"
+#define CAM_EMM_DATA_ID8_inst                                                        0x0020
+#define CAM_EMM_DATA_ID8_data_shift                                                  (0)
+#define CAM_EMM_DATA_ID8_data_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_DATA_ID8_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_DATA_ID8_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_DATA_ID8_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_MASK_ID4                                                             0x18011084
+#define CAM_EMM_MASK_ID4_reg_addr                                                    "0xB8011084"
+#define CAM_EMM_MASK_ID4_reg                                                         0xB8011084
+#define set_CAM_EMM_MASK_ID4_reg(data)   (*((volatile unsigned int*) CAM_EMM_MASK_ID4_reg)=data)
+#define get_CAM_EMM_MASK_ID4_reg   (*((volatile unsigned int*) CAM_EMM_MASK_ID4_reg))
+#define CAM_EMM_MASK_ID4_inst_adr                                                    "0x0021"
+#define CAM_EMM_MASK_ID4_inst                                                        0x0021
+#define CAM_EMM_MASK_ID4_mask_shift                                                  (0)
+#define CAM_EMM_MASK_ID4_mask_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_MASK_ID4_mask(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_MASK_ID4_mask_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_MASK_ID4_get_mask(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_MASK_ID5                                                             0x18011088
+#define CAM_EMM_MASK_ID5_reg_addr                                                    "0xB8011088"
+#define CAM_EMM_MASK_ID5_reg                                                         0xB8011088
+#define set_CAM_EMM_MASK_ID5_reg(data)   (*((volatile unsigned int*) CAM_EMM_MASK_ID5_reg)=data)
+#define get_CAM_EMM_MASK_ID5_reg   (*((volatile unsigned int*) CAM_EMM_MASK_ID5_reg))
+#define CAM_EMM_MASK_ID5_inst_adr                                                    "0x0022"
+#define CAM_EMM_MASK_ID5_inst                                                        0x0022
+#define CAM_EMM_MASK_ID5_mask_shift                                                  (0)
+#define CAM_EMM_MASK_ID5_mask_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_MASK_ID5_mask(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_MASK_ID5_mask_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_MASK_ID5_get_mask(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_MASK_ID6                                                             0x1801108C
+#define CAM_EMM_MASK_ID6_reg_addr                                                    "0xB801108C"
+#define CAM_EMM_MASK_ID6_reg                                                         0xB801108C
+#define set_CAM_EMM_MASK_ID6_reg(data)   (*((volatile unsigned int*) CAM_EMM_MASK_ID6_reg)=data)
+#define get_CAM_EMM_MASK_ID6_reg   (*((volatile unsigned int*) CAM_EMM_MASK_ID6_reg))
+#define CAM_EMM_MASK_ID6_inst_adr                                                    "0x0023"
+#define CAM_EMM_MASK_ID6_inst                                                        0x0023
+#define CAM_EMM_MASK_ID6_mask_shift                                                  (0)
+#define CAM_EMM_MASK_ID6_mask_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_MASK_ID6_mask(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_MASK_ID6_mask_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_MASK_ID6_get_mask(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_MASK_ID7                                                             0x18011090
+#define CAM_EMM_MASK_ID7_reg_addr                                                    "0xB8011090"
+#define CAM_EMM_MASK_ID7_reg                                                         0xB8011090
+#define set_CAM_EMM_MASK_ID7_reg(data)   (*((volatile unsigned int*) CAM_EMM_MASK_ID7_reg)=data)
+#define get_CAM_EMM_MASK_ID7_reg   (*((volatile unsigned int*) CAM_EMM_MASK_ID7_reg))
+#define CAM_EMM_MASK_ID7_inst_adr                                                    "0x0024"
+#define CAM_EMM_MASK_ID7_inst                                                        0x0024
+#define CAM_EMM_MASK_ID7_mask_shift                                                  (0)
+#define CAM_EMM_MASK_ID7_mask_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_MASK_ID7_mask(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_MASK_ID7_mask_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_MASK_ID7_get_mask(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_MASK_ID8                                                             0x18011094
+#define CAM_EMM_MASK_ID8_reg_addr                                                    "0xB8011094"
+#define CAM_EMM_MASK_ID8_reg                                                         0xB8011094
+#define set_CAM_EMM_MASK_ID8_reg(data)   (*((volatile unsigned int*) CAM_EMM_MASK_ID8_reg)=data)
+#define get_CAM_EMM_MASK_ID8_reg   (*((volatile unsigned int*) CAM_EMM_MASK_ID8_reg))
+#define CAM_EMM_MASK_ID8_inst_adr                                                    "0x0025"
+#define CAM_EMM_MASK_ID8_inst                                                        0x0025
+#define CAM_EMM_MASK_ID8_mask_shift                                                  (0)
+#define CAM_EMM_MASK_ID8_mask_mask                                                   (0xFFFFFFFF)
+#define CAM_EMM_MASK_ID8_mask(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_MASK_ID8_mask_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_MASK_ID8_get_mask(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define CAM_EMM_CTRL_ID                                                              0x18011098
+#define CAM_EMM_CTRL_ID_reg_addr                                                     "0xB8011098"
+#define CAM_EMM_CTRL_ID_reg                                                          0xB8011098
+#define set_CAM_EMM_CTRL_ID_reg(data)   (*((volatile unsigned int*) CAM_EMM_CTRL_ID_reg)=data)
+#define get_CAM_EMM_CTRL_ID_reg   (*((volatile unsigned int*) CAM_EMM_CTRL_ID_reg))
+#define CAM_EMM_CTRL_ID_inst_adr                                                     "0x0026"
+#define CAM_EMM_CTRL_ID_inst                                                         0x0026
+#define CAM_EMM_CTRL_ID_num_lbl_shift                                                (0)
+#define CAM_EMM_CTRL_ID_num_lbl_mask                                                 (0x0000FFFF)
+#define CAM_EMM_CTRL_ID_num_lbl(data)                                                (0x0000FFFF&((data)<<0))
+#define CAM_EMM_CTRL_ID_num_lbl_src(data)                                            ((0x0000FFFF&(data))>>0)
+#define CAM_EMM_CTRL_ID_get_num_lbl(data)                                            ((0x0000FFFF&(data))>>0)
+
+
+#define CAM_EMM_EMM_BUF_0                                                            0x18011600
+#define CAM_EMM_EMM_BUF_1                                                            0x18011604
+#define CAM_EMM_EMM_BUF_2                                                            0x18011608
+#define CAM_EMM_EMM_BUF_3                                                            0x1801160C
+#define CAM_EMM_EMM_BUF_4                                                            0x18011610
+#define CAM_EMM_EMM_BUF_5                                                            0x18011614
+#define CAM_EMM_EMM_BUF_6                                                            0x18011618
+#define CAM_EMM_EMM_BUF_7                                                            0x1801161C
+#define CAM_EMM_EMM_BUF_8                                                            0x18011620
+#define CAM_EMM_EMM_BUF_9                                                            0x18011624
+#define CAM_EMM_EMM_BUF_10                                                            0x18011628
+#define CAM_EMM_EMM_BUF_11                                                            0x1801162C
+#define CAM_EMM_EMM_BUF_12                                                            0x18011630
+#define CAM_EMM_EMM_BUF_13                                                            0x18011634
+#define CAM_EMM_EMM_BUF_14                                                            0x18011638
+#define CAM_EMM_EMM_BUF_15                                                            0x1801163C
+#define CAM_EMM_EMM_BUF_16                                                            0x18011640
+#define CAM_EMM_EMM_BUF_17                                                            0x18011644
+#define CAM_EMM_EMM_BUF_18                                                            0x18011648
+#define CAM_EMM_EMM_BUF_19                                                            0x1801164C
+#define CAM_EMM_EMM_BUF_20                                                            0x18011650
+#define CAM_EMM_EMM_BUF_21                                                            0x18011654
+#define CAM_EMM_EMM_BUF_22                                                            0x18011658
+#define CAM_EMM_EMM_BUF_23                                                            0x1801165C
+#define CAM_EMM_EMM_BUF_24                                                            0x18011660
+#define CAM_EMM_EMM_BUF_25                                                            0x18011664
+#define CAM_EMM_EMM_BUF_26                                                            0x18011668
+#define CAM_EMM_EMM_BUF_27                                                            0x1801166C
+#define CAM_EMM_EMM_BUF_28                                                            0x18011670
+#define CAM_EMM_EMM_BUF_29                                                            0x18011674
+#define CAM_EMM_EMM_BUF_30                                                            0x18011678
+#define CAM_EMM_EMM_BUF_31                                                            0x1801167C
+#define CAM_EMM_EMM_BUF_32                                                            0x18011680
+#define CAM_EMM_EMM_BUF_33                                                            0x18011684
+#define CAM_EMM_EMM_BUF_34                                                            0x18011688
+#define CAM_EMM_EMM_BUF_35                                                            0x1801168C
+#define CAM_EMM_EMM_BUF_36                                                            0x18011690
+#define CAM_EMM_EMM_BUF_37                                                            0x18011694
+#define CAM_EMM_EMM_BUF_38                                                            0x18011698
+#define CAM_EMM_EMM_BUF_39                                                            0x1801169C
+#define CAM_EMM_EMM_BUF_40                                                            0x180116A0
+#define CAM_EMM_EMM_BUF_41                                                            0x180116A4
+#define CAM_EMM_EMM_BUF_42                                                            0x180116A8
+#define CAM_EMM_EMM_BUF_43                                                            0x180116AC
+#define CAM_EMM_EMM_BUF_44                                                            0x180116B0
+#define CAM_EMM_EMM_BUF_45                                                            0x180116B4
+#define CAM_EMM_EMM_BUF_46                                                            0x180116B8
+#define CAM_EMM_EMM_BUF_47                                                            0x180116BC
+#define CAM_EMM_EMM_BUF_48                                                            0x180116C0
+#define CAM_EMM_EMM_BUF_49                                                            0x180116C4
+#define CAM_EMM_EMM_BUF_50                                                            0x180116C8
+#define CAM_EMM_EMM_BUF_51                                                            0x180116CC
+#define CAM_EMM_EMM_BUF_52                                                            0x180116D0
+#define CAM_EMM_EMM_BUF_53                                                            0x180116D4
+#define CAM_EMM_EMM_BUF_54                                                            0x180116D8
+#define CAM_EMM_EMM_BUF_55                                                            0x180116DC
+#define CAM_EMM_EMM_BUF_56                                                            0x180116E0
+#define CAM_EMM_EMM_BUF_57                                                            0x180116E4
+#define CAM_EMM_EMM_BUF_58                                                            0x180116E8
+#define CAM_EMM_EMM_BUF_59                                                            0x180116EC
+#define CAM_EMM_EMM_BUF_60                                                            0x180116F0
+#define CAM_EMM_EMM_BUF_61                                                            0x180116F4
+#define CAM_EMM_EMM_BUF_62                                                            0x180116F8
+#define CAM_EMM_EMM_BUF_63                                                            0x180116FC
+#define CAM_EMM_EMM_BUF_64                                                            0x18011700
+#define CAM_EMM_EMM_BUF_65                                                            0x18011704
+#define CAM_EMM_EMM_BUF_66                                                            0x18011708
+#define CAM_EMM_EMM_BUF_67                                                            0x1801170C
+#define CAM_EMM_EMM_BUF_68                                                            0x18011710
+#define CAM_EMM_EMM_BUF_69                                                            0x18011714
+#define CAM_EMM_EMM_BUF_70                                                            0x18011718
+#define CAM_EMM_EMM_BUF_71                                                            0x1801171C
+#define CAM_EMM_EMM_BUF_72                                                            0x18011720
+#define CAM_EMM_EMM_BUF_73                                                            0x18011724
+#define CAM_EMM_EMM_BUF_74                                                            0x18011728
+#define CAM_EMM_EMM_BUF_75                                                            0x1801172C
+#define CAM_EMM_EMM_BUF_76                                                            0x18011730
+#define CAM_EMM_EMM_BUF_77                                                            0x18011734
+#define CAM_EMM_EMM_BUF_78                                                            0x18011738
+#define CAM_EMM_EMM_BUF_79                                                            0x1801173C
+#define CAM_EMM_EMM_BUF_80                                                            0x18011740
+#define CAM_EMM_EMM_BUF_81                                                            0x18011744
+#define CAM_EMM_EMM_BUF_82                                                            0x18011748
+#define CAM_EMM_EMM_BUF_83                                                            0x1801174C
+#define CAM_EMM_EMM_BUF_84                                                            0x18011750
+#define CAM_EMM_EMM_BUF_85                                                            0x18011754
+#define CAM_EMM_EMM_BUF_86                                                            0x18011758
+#define CAM_EMM_EMM_BUF_87                                                            0x1801175C
+#define CAM_EMM_EMM_BUF_88                                                            0x18011760
+#define CAM_EMM_EMM_BUF_89                                                            0x18011764
+#define CAM_EMM_EMM_BUF_90                                                            0x18011768
+#define CAM_EMM_EMM_BUF_91                                                            0x1801176C
+#define CAM_EMM_EMM_BUF_92                                                            0x18011770
+#define CAM_EMM_EMM_BUF_93                                                            0x18011774
+#define CAM_EMM_EMM_BUF_94                                                            0x18011778
+#define CAM_EMM_EMM_BUF_95                                                            0x1801177C
+#define CAM_EMM_EMM_BUF_96                                                            0x18011780
+#define CAM_EMM_EMM_BUF_97                                                            0x18011784
+#define CAM_EMM_EMM_BUF_98                                                            0x18011788
+#define CAM_EMM_EMM_BUF_99                                                            0x1801178C
+#define CAM_EMM_EMM_BUF_100                                                            0x18011790
+#define CAM_EMM_EMM_BUF_101                                                            0x18011794
+#define CAM_EMM_EMM_BUF_102                                                            0x18011798
+#define CAM_EMM_EMM_BUF_103                                                            0x1801179C
+#define CAM_EMM_EMM_BUF_104                                                            0x180117A0
+#define CAM_EMM_EMM_BUF_105                                                            0x180117A4
+#define CAM_EMM_EMM_BUF_106                                                            0x180117A8
+#define CAM_EMM_EMM_BUF_107                                                            0x180117AC
+#define CAM_EMM_EMM_BUF_108                                                            0x180117B0
+#define CAM_EMM_EMM_BUF_109                                                            0x180117B4
+#define CAM_EMM_EMM_BUF_110                                                            0x180117B8
+#define CAM_EMM_EMM_BUF_111                                                            0x180117BC
+#define CAM_EMM_EMM_BUF_112                                                            0x180117C0
+#define CAM_EMM_EMM_BUF_113                                                            0x180117C4
+#define CAM_EMM_EMM_BUF_114                                                            0x180117C8
+#define CAM_EMM_EMM_BUF_115                                                            0x180117CC
+#define CAM_EMM_EMM_BUF_116                                                            0x180117D0
+#define CAM_EMM_EMM_BUF_117                                                            0x180117D4
+#define CAM_EMM_EMM_BUF_118                                                            0x180117D8
+#define CAM_EMM_EMM_BUF_119                                                            0x180117DC
+#define CAM_EMM_EMM_BUF_120                                                            0x180117E0
+#define CAM_EMM_EMM_BUF_121                                                            0x180117E4
+#define CAM_EMM_EMM_BUF_122                                                            0x180117E8
+#define CAM_EMM_EMM_BUF_123                                                            0x180117EC
+#define CAM_EMM_EMM_BUF_124                                                            0x180117F0
+#define CAM_EMM_EMM_BUF_125                                                            0x180117F4
+#define CAM_EMM_EMM_BUF_126                                                            0x180117F8
+#define CAM_EMM_EMM_BUF_127                                                            0x180117FC
+#define CAM_EMM_EMM_BUF_128                                                            0x18011800
+#define CAM_EMM_EMM_BUF_129                                                            0x18011804
+#define CAM_EMM_EMM_BUF_130                                                            0x18011808
+#define CAM_EMM_EMM_BUF_131                                                            0x1801180C
+#define CAM_EMM_EMM_BUF_132                                                            0x18011810
+#define CAM_EMM_EMM_BUF_133                                                            0x18011814
+#define CAM_EMM_EMM_BUF_134                                                            0x18011818
+#define CAM_EMM_EMM_BUF_135                                                            0x1801181C
+#define CAM_EMM_EMM_BUF_136                                                            0x18011820
+#define CAM_EMM_EMM_BUF_137                                                            0x18011824
+#define CAM_EMM_EMM_BUF_138                                                            0x18011828
+#define CAM_EMM_EMM_BUF_139                                                            0x1801182C
+#define CAM_EMM_EMM_BUF_140                                                            0x18011830
+#define CAM_EMM_EMM_BUF_141                                                            0x18011834
+#define CAM_EMM_EMM_BUF_142                                                            0x18011838
+#define CAM_EMM_EMM_BUF_143                                                            0x1801183C
+#define CAM_EMM_EMM_BUF_144                                                            0x18011840
+#define CAM_EMM_EMM_BUF_145                                                            0x18011844
+#define CAM_EMM_EMM_BUF_146                                                            0x18011848
+#define CAM_EMM_EMM_BUF_147                                                            0x1801184C
+#define CAM_EMM_EMM_BUF_148                                                            0x18011850
+#define CAM_EMM_EMM_BUF_149                                                            0x18011854
+#define CAM_EMM_EMM_BUF_150                                                            0x18011858
+#define CAM_EMM_EMM_BUF_151                                                            0x1801185C
+#define CAM_EMM_EMM_BUF_152                                                            0x18011860
+#define CAM_EMM_EMM_BUF_153                                                            0x18011864
+#define CAM_EMM_EMM_BUF_154                                                            0x18011868
+#define CAM_EMM_EMM_BUF_155                                                            0x1801186C
+#define CAM_EMM_EMM_BUF_156                                                            0x18011870
+#define CAM_EMM_EMM_BUF_157                                                            0x18011874
+#define CAM_EMM_EMM_BUF_158                                                            0x18011878
+#define CAM_EMM_EMM_BUF_159                                                            0x1801187C
+#define CAM_EMM_EMM_BUF_160                                                            0x18011880
+#define CAM_EMM_EMM_BUF_161                                                            0x18011884
+#define CAM_EMM_EMM_BUF_162                                                            0x18011888
+#define CAM_EMM_EMM_BUF_163                                                            0x1801188C
+#define CAM_EMM_EMM_BUF_164                                                            0x18011890
+#define CAM_EMM_EMM_BUF_165                                                            0x18011894
+#define CAM_EMM_EMM_BUF_166                                                            0x18011898
+#define CAM_EMM_EMM_BUF_167                                                            0x1801189C
+#define CAM_EMM_EMM_BUF_168                                                            0x180118A0
+#define CAM_EMM_EMM_BUF_169                                                            0x180118A4
+#define CAM_EMM_EMM_BUF_170                                                            0x180118A8
+#define CAM_EMM_EMM_BUF_171                                                            0x180118AC
+#define CAM_EMM_EMM_BUF_172                                                            0x180118B0
+#define CAM_EMM_EMM_BUF_173                                                            0x180118B4
+#define CAM_EMM_EMM_BUF_174                                                            0x180118B8
+#define CAM_EMM_EMM_BUF_175                                                            0x180118BC
+#define CAM_EMM_EMM_BUF_176                                                            0x180118C0
+#define CAM_EMM_EMM_BUF_177                                                            0x180118C4
+#define CAM_EMM_EMM_BUF_178                                                            0x180118C8
+#define CAM_EMM_EMM_BUF_179                                                            0x180118CC
+#define CAM_EMM_EMM_BUF_180                                                            0x180118D0
+#define CAM_EMM_EMM_BUF_181                                                            0x180118D4
+#define CAM_EMM_EMM_BUF_182                                                            0x180118D8
+#define CAM_EMM_EMM_BUF_183                                                            0x180118DC
+#define CAM_EMM_EMM_BUF_184                                                            0x180118E0
+#define CAM_EMM_EMM_BUF_185                                                            0x180118E4
+#define CAM_EMM_EMM_BUF_186                                                            0x180118E8
+#define CAM_EMM_EMM_BUF_187                                                            0x180118EC
+#define CAM_EMM_EMM_BUF_188                                                            0x180118F0
+#define CAM_EMM_EMM_BUF_189                                                            0x180118F4
+#define CAM_EMM_EMM_BUF_190                                                            0x180118F8
+#define CAM_EMM_EMM_BUF_191                                                            0x180118FC
+#define CAM_EMM_EMM_BUF_192                                                            0x18011900
+#define CAM_EMM_EMM_BUF_193                                                            0x18011904
+#define CAM_EMM_EMM_BUF_194                                                            0x18011908
+#define CAM_EMM_EMM_BUF_195                                                            0x1801190C
+#define CAM_EMM_EMM_BUF_196                                                            0x18011910
+#define CAM_EMM_EMM_BUF_197                                                            0x18011914
+#define CAM_EMM_EMM_BUF_198                                                            0x18011918
+#define CAM_EMM_EMM_BUF_199                                                            0x1801191C
+#define CAM_EMM_EMM_BUF_200                                                            0x18011920
+#define CAM_EMM_EMM_BUF_201                                                            0x18011924
+#define CAM_EMM_EMM_BUF_202                                                            0x18011928
+#define CAM_EMM_EMM_BUF_203                                                            0x1801192C
+#define CAM_EMM_EMM_BUF_204                                                            0x18011930
+#define CAM_EMM_EMM_BUF_205                                                            0x18011934
+#define CAM_EMM_EMM_BUF_206                                                            0x18011938
+#define CAM_EMM_EMM_BUF_207                                                            0x1801193C
+#define CAM_EMM_EMM_BUF_208                                                            0x18011940
+#define CAM_EMM_EMM_BUF_209                                                            0x18011944
+#define CAM_EMM_EMM_BUF_210                                                            0x18011948
+#define CAM_EMM_EMM_BUF_211                                                            0x1801194C
+#define CAM_EMM_EMM_BUF_212                                                            0x18011950
+#define CAM_EMM_EMM_BUF_213                                                            0x18011954
+#define CAM_EMM_EMM_BUF_214                                                            0x18011958
+#define CAM_EMM_EMM_BUF_215                                                            0x1801195C
+#define CAM_EMM_EMM_BUF_216                                                            0x18011960
+#define CAM_EMM_EMM_BUF_217                                                            0x18011964
+#define CAM_EMM_EMM_BUF_218                                                            0x18011968
+#define CAM_EMM_EMM_BUF_219                                                            0x1801196C
+#define CAM_EMM_EMM_BUF_220                                                            0x18011970
+#define CAM_EMM_EMM_BUF_221                                                            0x18011974
+#define CAM_EMM_EMM_BUF_222                                                            0x18011978
+#define CAM_EMM_EMM_BUF_223                                                            0x1801197C
+#define CAM_EMM_EMM_BUF_224                                                            0x18011980
+#define CAM_EMM_EMM_BUF_225                                                            0x18011984
+#define CAM_EMM_EMM_BUF_226                                                            0x18011988
+#define CAM_EMM_EMM_BUF_227                                                            0x1801198C
+#define CAM_EMM_EMM_BUF_228                                                            0x18011990
+#define CAM_EMM_EMM_BUF_229                                                            0x18011994
+#define CAM_EMM_EMM_BUF_230                                                            0x18011998
+#define CAM_EMM_EMM_BUF_231                                                            0x1801199C
+#define CAM_EMM_EMM_BUF_232                                                            0x180119A0
+#define CAM_EMM_EMM_BUF_233                                                            0x180119A4
+#define CAM_EMM_EMM_BUF_234                                                            0x180119A8
+#define CAM_EMM_EMM_BUF_235                                                            0x180119AC
+#define CAM_EMM_EMM_BUF_236                                                            0x180119B0
+#define CAM_EMM_EMM_BUF_237                                                            0x180119B4
+#define CAM_EMM_EMM_BUF_238                                                            0x180119B8
+#define CAM_EMM_EMM_BUF_239                                                            0x180119BC
+#define CAM_EMM_EMM_BUF_240                                                            0x180119C0
+#define CAM_EMM_EMM_BUF_241                                                            0x180119C4
+#define CAM_EMM_EMM_BUF_242                                                            0x180119C8
+#define CAM_EMM_EMM_BUF_243                                                            0x180119CC
+#define CAM_EMM_EMM_BUF_244                                                            0x180119D0
+#define CAM_EMM_EMM_BUF_245                                                            0x180119D4
+#define CAM_EMM_EMM_BUF_246                                                            0x180119D8
+#define CAM_EMM_EMM_BUF_247                                                            0x180119DC
+#define CAM_EMM_EMM_BUF_248                                                            0x180119E0
+#define CAM_EMM_EMM_BUF_249                                                            0x180119E4
+#define CAM_EMM_EMM_BUF_250                                                            0x180119E8
+#define CAM_EMM_EMM_BUF_251                                                            0x180119EC
+#define CAM_EMM_EMM_BUF_252                                                            0x180119F0
+#define CAM_EMM_EMM_BUF_253                                                            0x180119F4
+#define CAM_EMM_EMM_BUF_254                                                            0x180119F8
+#define CAM_EMM_EMM_BUF_255                                                            0x180119FC
+#define CAM_EMM_EMM_BUF_256                                                            0x18011A00
+#define CAM_EMM_EMM_BUF_257                                                            0x18011A04
+#define CAM_EMM_EMM_BUF_258                                                            0x18011A08
+#define CAM_EMM_EMM_BUF_259                                                            0x18011A0C
+#define CAM_EMM_EMM_BUF_260                                                            0x18011A10
+#define CAM_EMM_EMM_BUF_261                                                            0x18011A14
+#define CAM_EMM_EMM_BUF_262                                                            0x18011A18
+#define CAM_EMM_EMM_BUF_263                                                            0x18011A1C
+#define CAM_EMM_EMM_BUF_264                                                            0x18011A20
+#define CAM_EMM_EMM_BUF_265                                                            0x18011A24
+#define CAM_EMM_EMM_BUF_266                                                            0x18011A28
+#define CAM_EMM_EMM_BUF_267                                                            0x18011A2C
+#define CAM_EMM_EMM_BUF_268                                                            0x18011A30
+#define CAM_EMM_EMM_BUF_269                                                            0x18011A34
+#define CAM_EMM_EMM_BUF_270                                                            0x18011A38
+#define CAM_EMM_EMM_BUF_271                                                            0x18011A3C
+#define CAM_EMM_EMM_BUF_272                                                            0x18011A40
+#define CAM_EMM_EMM_BUF_273                                                            0x18011A44
+#define CAM_EMM_EMM_BUF_274                                                            0x18011A48
+#define CAM_EMM_EMM_BUF_275                                                            0x18011A4C
+#define CAM_EMM_EMM_BUF_276                                                            0x18011A50
+#define CAM_EMM_EMM_BUF_277                                                            0x18011A54
+#define CAM_EMM_EMM_BUF_278                                                            0x18011A58
+#define CAM_EMM_EMM_BUF_279                                                            0x18011A5C
+#define CAM_EMM_EMM_BUF_280                                                            0x18011A60
+#define CAM_EMM_EMM_BUF_281                                                            0x18011A64
+#define CAM_EMM_EMM_BUF_282                                                            0x18011A68
+#define CAM_EMM_EMM_BUF_283                                                            0x18011A6C
+#define CAM_EMM_EMM_BUF_284                                                            0x18011A70
+#define CAM_EMM_EMM_BUF_285                                                            0x18011A74
+#define CAM_EMM_EMM_BUF_286                                                            0x18011A78
+#define CAM_EMM_EMM_BUF_287                                                            0x18011A7C
+#define CAM_EMM_EMM_BUF_288                                                            0x18011A80
+#define CAM_EMM_EMM_BUF_289                                                            0x18011A84
+#define CAM_EMM_EMM_BUF_290                                                            0x18011A88
+#define CAM_EMM_EMM_BUF_291                                                            0x18011A8C
+#define CAM_EMM_EMM_BUF_292                                                            0x18011A90
+#define CAM_EMM_EMM_BUF_293                                                            0x18011A94
+#define CAM_EMM_EMM_BUF_294                                                            0x18011A98
+#define CAM_EMM_EMM_BUF_295                                                            0x18011A9C
+#define CAM_EMM_EMM_BUF_296                                                            0x18011AA0
+#define CAM_EMM_EMM_BUF_297                                                            0x18011AA4
+#define CAM_EMM_EMM_BUF_298                                                            0x18011AA8
+#define CAM_EMM_EMM_BUF_299                                                            0x18011AAC
+#define CAM_EMM_EMM_BUF_300                                                            0x18011AB0
+#define CAM_EMM_EMM_BUF_301                                                            0x18011AB4
+#define CAM_EMM_EMM_BUF_302                                                            0x18011AB8
+#define CAM_EMM_EMM_BUF_303                                                            0x18011ABC
+#define CAM_EMM_EMM_BUF_304                                                            0x18011AC0
+#define CAM_EMM_EMM_BUF_305                                                            0x18011AC4
+#define CAM_EMM_EMM_BUF_306                                                            0x18011AC8
+#define CAM_EMM_EMM_BUF_307                                                            0x18011ACC
+#define CAM_EMM_EMM_BUF_308                                                            0x18011AD0
+#define CAM_EMM_EMM_BUF_309                                                            0x18011AD4
+#define CAM_EMM_EMM_BUF_310                                                            0x18011AD8
+#define CAM_EMM_EMM_BUF_311                                                            0x18011ADC
+#define CAM_EMM_EMM_BUF_312                                                            0x18011AE0
+#define CAM_EMM_EMM_BUF_313                                                            0x18011AE4
+#define CAM_EMM_EMM_BUF_314                                                            0x18011AE8
+#define CAM_EMM_EMM_BUF_315                                                            0x18011AEC
+#define CAM_EMM_EMM_BUF_316                                                            0x18011AF0
+#define CAM_EMM_EMM_BUF_317                                                            0x18011AF4
+#define CAM_EMM_EMM_BUF_318                                                            0x18011AF8
+#define CAM_EMM_EMM_BUF_319                                                            0x18011AFC
+#define CAM_EMM_EMM_BUF_320                                                            0x18011B00
+#define CAM_EMM_EMM_BUF_321                                                            0x18011B04
+#define CAM_EMM_EMM_BUF_322                                                            0x18011B08
+#define CAM_EMM_EMM_BUF_323                                                            0x18011B0C
+#define CAM_EMM_EMM_BUF_324                                                            0x18011B10
+#define CAM_EMM_EMM_BUF_325                                                            0x18011B14
+#define CAM_EMM_EMM_BUF_326                                                            0x18011B18
+#define CAM_EMM_EMM_BUF_327                                                            0x18011B1C
+#define CAM_EMM_EMM_BUF_328                                                            0x18011B20
+#define CAM_EMM_EMM_BUF_329                                                            0x18011B24
+#define CAM_EMM_EMM_BUF_330                                                            0x18011B28
+#define CAM_EMM_EMM_BUF_331                                                            0x18011B2C
+#define CAM_EMM_EMM_BUF_332                                                            0x18011B30
+#define CAM_EMM_EMM_BUF_333                                                            0x18011B34
+#define CAM_EMM_EMM_BUF_334                                                            0x18011B38
+#define CAM_EMM_EMM_BUF_335                                                            0x18011B3C
+#define CAM_EMM_EMM_BUF_336                                                            0x18011B40
+#define CAM_EMM_EMM_BUF_337                                                            0x18011B44
+#define CAM_EMM_EMM_BUF_338                                                            0x18011B48
+#define CAM_EMM_EMM_BUF_339                                                            0x18011B4C
+#define CAM_EMM_EMM_BUF_340                                                            0x18011B50
+#define CAM_EMM_EMM_BUF_341                                                            0x18011B54
+#define CAM_EMM_EMM_BUF_342                                                            0x18011B58
+#define CAM_EMM_EMM_BUF_343                                                            0x18011B5C
+#define CAM_EMM_EMM_BUF_344                                                            0x18011B60
+#define CAM_EMM_EMM_BUF_345                                                            0x18011B64
+#define CAM_EMM_EMM_BUF_346                                                            0x18011B68
+#define CAM_EMM_EMM_BUF_347                                                            0x18011B6C
+#define CAM_EMM_EMM_BUF_348                                                            0x18011B70
+#define CAM_EMM_EMM_BUF_349                                                            0x18011B74
+#define CAM_EMM_EMM_BUF_350                                                            0x18011B78
+#define CAM_EMM_EMM_BUF_351                                                            0x18011B7C
+#define CAM_EMM_EMM_BUF_352                                                            0x18011B80
+#define CAM_EMM_EMM_BUF_353                                                            0x18011B84
+#define CAM_EMM_EMM_BUF_354                                                            0x18011B88
+#define CAM_EMM_EMM_BUF_355                                                            0x18011B8C
+#define CAM_EMM_EMM_BUF_356                                                            0x18011B90
+#define CAM_EMM_EMM_BUF_357                                                            0x18011B94
+#define CAM_EMM_EMM_BUF_358                                                            0x18011B98
+#define CAM_EMM_EMM_BUF_359                                                            0x18011B9C
+#define CAM_EMM_EMM_BUF_360                                                            0x18011BA0
+#define CAM_EMM_EMM_BUF_361                                                            0x18011BA4
+#define CAM_EMM_EMM_BUF_362                                                            0x18011BA8
+#define CAM_EMM_EMM_BUF_363                                                            0x18011BAC
+#define CAM_EMM_EMM_BUF_364                                                            0x18011BB0
+#define CAM_EMM_EMM_BUF_365                                                            0x18011BB4
+#define CAM_EMM_EMM_BUF_366                                                            0x18011BB8
+#define CAM_EMM_EMM_BUF_367                                                            0x18011BBC
+#define CAM_EMM_EMM_BUF_368                                                            0x18011BC0
+#define CAM_EMM_EMM_BUF_369                                                            0x18011BC4
+#define CAM_EMM_EMM_BUF_370                                                            0x18011BC8
+#define CAM_EMM_EMM_BUF_371                                                            0x18011BCC
+#define CAM_EMM_EMM_BUF_372                                                            0x18011BD0
+#define CAM_EMM_EMM_BUF_373                                                            0x18011BD4
+#define CAM_EMM_EMM_BUF_374                                                            0x18011BD8
+#define CAM_EMM_EMM_BUF_375                                                            0x18011BDC
+#define CAM_EMM_EMM_BUF_376                                                            0x18011BE0
+#define CAM_EMM_EMM_BUF_377                                                            0x18011BE4
+#define CAM_EMM_EMM_BUF_378                                                            0x18011BE8
+#define CAM_EMM_EMM_BUF_379                                                            0x18011BEC
+#define CAM_EMM_EMM_BUF_380                                                            0x18011BF0
+#define CAM_EMM_EMM_BUF_381                                                            0x18011BF4
+#define CAM_EMM_EMM_BUF_382                                                            0x18011BF8
+#define CAM_EMM_EMM_BUF_383                                                            0x18011BFC
+#define CAM_EMM_EMM_BUF_384                                                            0x18011C00
+#define CAM_EMM_EMM_BUF_385                                                            0x18011C04
+#define CAM_EMM_EMM_BUF_386                                                            0x18011C08
+#define CAM_EMM_EMM_BUF_387                                                            0x18011C0C
+#define CAM_EMM_EMM_BUF_388                                                            0x18011C10
+#define CAM_EMM_EMM_BUF_389                                                            0x18011C14
+#define CAM_EMM_EMM_BUF_390                                                            0x18011C18
+#define CAM_EMM_EMM_BUF_391                                                            0x18011C1C
+#define CAM_EMM_EMM_BUF_392                                                            0x18011C20
+#define CAM_EMM_EMM_BUF_393                                                            0x18011C24
+#define CAM_EMM_EMM_BUF_394                                                            0x18011C28
+#define CAM_EMM_EMM_BUF_395                                                            0x18011C2C
+#define CAM_EMM_EMM_BUF_396                                                            0x18011C30
+#define CAM_EMM_EMM_BUF_397                                                            0x18011C34
+#define CAM_EMM_EMM_BUF_398                                                            0x18011C38
+#define CAM_EMM_EMM_BUF_399                                                            0x18011C3C
+#define CAM_EMM_EMM_BUF_400                                                            0x18011C40
+#define CAM_EMM_EMM_BUF_401                                                            0x18011C44
+#define CAM_EMM_EMM_BUF_402                                                            0x18011C48
+#define CAM_EMM_EMM_BUF_403                                                            0x18011C4C
+#define CAM_EMM_EMM_BUF_404                                                            0x18011C50
+#define CAM_EMM_EMM_BUF_405                                                            0x18011C54
+#define CAM_EMM_EMM_BUF_406                                                            0x18011C58
+#define CAM_EMM_EMM_BUF_407                                                            0x18011C5C
+#define CAM_EMM_EMM_BUF_408                                                            0x18011C60
+#define CAM_EMM_EMM_BUF_409                                                            0x18011C64
+#define CAM_EMM_EMM_BUF_410                                                            0x18011C68
+#define CAM_EMM_EMM_BUF_411                                                            0x18011C6C
+#define CAM_EMM_EMM_BUF_412                                                            0x18011C70
+#define CAM_EMM_EMM_BUF_413                                                            0x18011C74
+#define CAM_EMM_EMM_BUF_414                                                            0x18011C78
+#define CAM_EMM_EMM_BUF_415                                                            0x18011C7C
+#define CAM_EMM_EMM_BUF_416                                                            0x18011C80
+#define CAM_EMM_EMM_BUF_417                                                            0x18011C84
+#define CAM_EMM_EMM_BUF_418                                                            0x18011C88
+#define CAM_EMM_EMM_BUF_419                                                            0x18011C8C
+#define CAM_EMM_EMM_BUF_420                                                            0x18011C90
+#define CAM_EMM_EMM_BUF_421                                                            0x18011C94
+#define CAM_EMM_EMM_BUF_422                                                            0x18011C98
+#define CAM_EMM_EMM_BUF_423                                                            0x18011C9C
+#define CAM_EMM_EMM_BUF_424                                                            0x18011CA0
+#define CAM_EMM_EMM_BUF_425                                                            0x18011CA4
+#define CAM_EMM_EMM_BUF_426                                                            0x18011CA8
+#define CAM_EMM_EMM_BUF_427                                                            0x18011CAC
+#define CAM_EMM_EMM_BUF_428                                                            0x18011CB0
+#define CAM_EMM_EMM_BUF_429                                                            0x18011CB4
+#define CAM_EMM_EMM_BUF_430                                                            0x18011CB8
+#define CAM_EMM_EMM_BUF_431                                                            0x18011CBC
+#define CAM_EMM_EMM_BUF_432                                                            0x18011CC0
+#define CAM_EMM_EMM_BUF_433                                                            0x18011CC4
+#define CAM_EMM_EMM_BUF_434                                                            0x18011CC8
+#define CAM_EMM_EMM_BUF_435                                                            0x18011CCC
+#define CAM_EMM_EMM_BUF_436                                                            0x18011CD0
+#define CAM_EMM_EMM_BUF_437                                                            0x18011CD4
+#define CAM_EMM_EMM_BUF_438                                                            0x18011CD8
+#define CAM_EMM_EMM_BUF_439                                                            0x18011CDC
+#define CAM_EMM_EMM_BUF_440                                                            0x18011CE0
+#define CAM_EMM_EMM_BUF_441                                                            0x18011CE4
+#define CAM_EMM_EMM_BUF_442                                                            0x18011CE8
+#define CAM_EMM_EMM_BUF_443                                                            0x18011CEC
+#define CAM_EMM_EMM_BUF_444                                                            0x18011CF0
+#define CAM_EMM_EMM_BUF_445                                                            0x18011CF4
+#define CAM_EMM_EMM_BUF_446                                                            0x18011CF8
+#define CAM_EMM_EMM_BUF_447                                                            0x18011CFC
+#define CAM_EMM_EMM_BUF_448                                                            0x18011D00
+#define CAM_EMM_EMM_BUF_449                                                            0x18011D04
+#define CAM_EMM_EMM_BUF_450                                                            0x18011D08
+#define CAM_EMM_EMM_BUF_451                                                            0x18011D0C
+#define CAM_EMM_EMM_BUF_452                                                            0x18011D10
+#define CAM_EMM_EMM_BUF_453                                                            0x18011D14
+#define CAM_EMM_EMM_BUF_454                                                            0x18011D18
+#define CAM_EMM_EMM_BUF_455                                                            0x18011D1C
+#define CAM_EMM_EMM_BUF_456                                                            0x18011D20
+#define CAM_EMM_EMM_BUF_457                                                            0x18011D24
+#define CAM_EMM_EMM_BUF_458                                                            0x18011D28
+#define CAM_EMM_EMM_BUF_459                                                            0x18011D2C
+#define CAM_EMM_EMM_BUF_460                                                            0x18011D30
+#define CAM_EMM_EMM_BUF_461                                                            0x18011D34
+#define CAM_EMM_EMM_BUF_462                                                            0x18011D38
+#define CAM_EMM_EMM_BUF_463                                                            0x18011D3C
+#define CAM_EMM_EMM_BUF_464                                                            0x18011D40
+#define CAM_EMM_EMM_BUF_465                                                            0x18011D44
+#define CAM_EMM_EMM_BUF_466                                                            0x18011D48
+#define CAM_EMM_EMM_BUF_467                                                            0x18011D4C
+#define CAM_EMM_EMM_BUF_468                                                            0x18011D50
+#define CAM_EMM_EMM_BUF_469                                                            0x18011D54
+#define CAM_EMM_EMM_BUF_470                                                            0x18011D58
+#define CAM_EMM_EMM_BUF_471                                                            0x18011D5C
+#define CAM_EMM_EMM_BUF_472                                                            0x18011D60
+#define CAM_EMM_EMM_BUF_473                                                            0x18011D64
+#define CAM_EMM_EMM_BUF_474                                                            0x18011D68
+#define CAM_EMM_EMM_BUF_475                                                            0x18011D6C
+#define CAM_EMM_EMM_BUF_476                                                            0x18011D70
+#define CAM_EMM_EMM_BUF_477                                                            0x18011D74
+#define CAM_EMM_EMM_BUF_478                                                            0x18011D78
+#define CAM_EMM_EMM_BUF_479                                                            0x18011D7C
+#define CAM_EMM_EMM_BUF_480                                                            0x18011D80
+#define CAM_EMM_EMM_BUF_481                                                            0x18011D84
+#define CAM_EMM_EMM_BUF_482                                                            0x18011D88
+#define CAM_EMM_EMM_BUF_483                                                            0x18011D8C
+#define CAM_EMM_EMM_BUF_484                                                            0x18011D90
+#define CAM_EMM_EMM_BUF_485                                                            0x18011D94
+#define CAM_EMM_EMM_BUF_486                                                            0x18011D98
+#define CAM_EMM_EMM_BUF_487                                                            0x18011D9C
+#define CAM_EMM_EMM_BUF_488                                                            0x18011DA0
+#define CAM_EMM_EMM_BUF_489                                                            0x18011DA4
+#define CAM_EMM_EMM_BUF_490                                                            0x18011DA8
+#define CAM_EMM_EMM_BUF_491                                                            0x18011DAC
+#define CAM_EMM_EMM_BUF_492                                                            0x18011DB0
+#define CAM_EMM_EMM_BUF_493                                                            0x18011DB4
+#define CAM_EMM_EMM_BUF_494                                                            0x18011DB8
+#define CAM_EMM_EMM_BUF_495                                                            0x18011DBC
+#define CAM_EMM_EMM_BUF_496                                                            0x18011DC0
+#define CAM_EMM_EMM_BUF_497                                                            0x18011DC4
+#define CAM_EMM_EMM_BUF_498                                                            0x18011DC8
+#define CAM_EMM_EMM_BUF_499                                                            0x18011DCC
+#define CAM_EMM_EMM_BUF_500                                                            0x18011DD0
+#define CAM_EMM_EMM_BUF_501                                                            0x18011DD4
+#define CAM_EMM_EMM_BUF_502                                                            0x18011DD8
+#define CAM_EMM_EMM_BUF_503                                                            0x18011DDC
+#define CAM_EMM_EMM_BUF_504                                                            0x18011DE0
+#define CAM_EMM_EMM_BUF_505                                                            0x18011DE4
+#define CAM_EMM_EMM_BUF_506                                                            0x18011DE8
+#define CAM_EMM_EMM_BUF_507                                                            0x18011DEC
+#define CAM_EMM_EMM_BUF_508                                                            0x18011DF0
+#define CAM_EMM_EMM_BUF_509                                                            0x18011DF4
+#define CAM_EMM_EMM_BUF_510                                                            0x18011DF8
+#define CAM_EMM_EMM_BUF_511                                                            0x18011DFC
+#define CAM_EMM_EMM_BUF_512                                                            0x18011E00
+#define CAM_EMM_EMM_BUF_513                                                            0x18011E04
+#define CAM_EMM_EMM_BUF_514                                                            0x18011E08
+#define CAM_EMM_EMM_BUF_515                                                            0x18011E0C
+#define CAM_EMM_EMM_BUF_516                                                            0x18011E10
+#define CAM_EMM_EMM_BUF_517                                                            0x18011E14
+#define CAM_EMM_EMM_BUF_518                                                            0x18011E18
+#define CAM_EMM_EMM_BUF_519                                                            0x18011E1C
+#define CAM_EMM_EMM_BUF_520                                                            0x18011E20
+#define CAM_EMM_EMM_BUF_521                                                            0x18011E24
+#define CAM_EMM_EMM_BUF_522                                                            0x18011E28
+#define CAM_EMM_EMM_BUF_523                                                            0x18011E2C
+#define CAM_EMM_EMM_BUF_524                                                            0x18011E30
+#define CAM_EMM_EMM_BUF_525                                                            0x18011E34
+#define CAM_EMM_EMM_BUF_526                                                            0x18011E38
+#define CAM_EMM_EMM_BUF_527                                                            0x18011E3C
+#define CAM_EMM_EMM_BUF_528                                                            0x18011E40
+#define CAM_EMM_EMM_BUF_529                                                            0x18011E44
+#define CAM_EMM_EMM_BUF_530                                                            0x18011E48
+#define CAM_EMM_EMM_BUF_531                                                            0x18011E4C
+#define CAM_EMM_EMM_BUF_532                                                            0x18011E50
+#define CAM_EMM_EMM_BUF_533                                                            0x18011E54
+#define CAM_EMM_EMM_BUF_534                                                            0x18011E58
+#define CAM_EMM_EMM_BUF_535                                                            0x18011E5C
+#define CAM_EMM_EMM_BUF_536                                                            0x18011E60
+#define CAM_EMM_EMM_BUF_537                                                            0x18011E64
+#define CAM_EMM_EMM_BUF_538                                                            0x18011E68
+#define CAM_EMM_EMM_BUF_539                                                            0x18011E6C
+#define CAM_EMM_EMM_BUF_540                                                            0x18011E70
+#define CAM_EMM_EMM_BUF_541                                                            0x18011E74
+#define CAM_EMM_EMM_BUF_542                                                            0x18011E78
+#define CAM_EMM_EMM_BUF_543                                                            0x18011E7C
+#define CAM_EMM_EMM_BUF_544                                                            0x18011E80
+#define CAM_EMM_EMM_BUF_545                                                            0x18011E84
+#define CAM_EMM_EMM_BUF_546                                                            0x18011E88
+#define CAM_EMM_EMM_BUF_547                                                            0x18011E8C
+#define CAM_EMM_EMM_BUF_548                                                            0x18011E90
+#define CAM_EMM_EMM_BUF_549                                                            0x18011E94
+#define CAM_EMM_EMM_BUF_550                                                            0x18011E98
+#define CAM_EMM_EMM_BUF_551                                                            0x18011E9C
+#define CAM_EMM_EMM_BUF_552                                                            0x18011EA0
+#define CAM_EMM_EMM_BUF_553                                                            0x18011EA4
+#define CAM_EMM_EMM_BUF_554                                                            0x18011EA8
+#define CAM_EMM_EMM_BUF_555                                                            0x18011EAC
+#define CAM_EMM_EMM_BUF_556                                                            0x18011EB0
+#define CAM_EMM_EMM_BUF_557                                                            0x18011EB4
+#define CAM_EMM_EMM_BUF_558                                                            0x18011EB8
+#define CAM_EMM_EMM_BUF_559                                                            0x18011EBC
+#define CAM_EMM_EMM_BUF_560                                                            0x18011EC0
+#define CAM_EMM_EMM_BUF_561                                                            0x18011EC4
+#define CAM_EMM_EMM_BUF_562                                                            0x18011EC8
+#define CAM_EMM_EMM_BUF_563                                                            0x18011ECC
+#define CAM_EMM_EMM_BUF_564                                                            0x18011ED0
+#define CAM_EMM_EMM_BUF_565                                                            0x18011ED4
+#define CAM_EMM_EMM_BUF_566                                                            0x18011ED8
+#define CAM_EMM_EMM_BUF_567                                                            0x18011EDC
+#define CAM_EMM_EMM_BUF_568                                                            0x18011EE0
+#define CAM_EMM_EMM_BUF_569                                                            0x18011EE4
+#define CAM_EMM_EMM_BUF_570                                                            0x18011EE8
+#define CAM_EMM_EMM_BUF_571                                                            0x18011EEC
+#define CAM_EMM_EMM_BUF_572                                                            0x18011EF0
+#define CAM_EMM_EMM_BUF_573                                                            0x18011EF4
+#define CAM_EMM_EMM_BUF_574                                                            0x18011EF8
+#define CAM_EMM_EMM_BUF_575                                                            0x18011EFC
+#define CAM_EMM_EMM_BUF_576                                                            0x18011F00
+#define CAM_EMM_EMM_BUF_577                                                            0x18011F04
+#define CAM_EMM_EMM_BUF_578                                                            0x18011F08
+#define CAM_EMM_EMM_BUF_579                                                            0x18011F0C
+#define CAM_EMM_EMM_BUF_580                                                            0x18011F10
+#define CAM_EMM_EMM_BUF_581                                                            0x18011F14
+#define CAM_EMM_EMM_BUF_582                                                            0x18011F18
+#define CAM_EMM_EMM_BUF_583                                                            0x18011F1C
+#define CAM_EMM_EMM_BUF_584                                                            0x18011F20
+#define CAM_EMM_EMM_BUF_585                                                            0x18011F24
+#define CAM_EMM_EMM_BUF_586                                                            0x18011F28
+#define CAM_EMM_EMM_BUF_587                                                            0x18011F2C
+#define CAM_EMM_EMM_BUF_588                                                            0x18011F30
+#define CAM_EMM_EMM_BUF_589                                                            0x18011F34
+#define CAM_EMM_EMM_BUF_590                                                            0x18011F38
+#define CAM_EMM_EMM_BUF_591                                                            0x18011F3C
+#define CAM_EMM_EMM_BUF_592                                                            0x18011F40
+#define CAM_EMM_EMM_BUF_593                                                            0x18011F44
+#define CAM_EMM_EMM_BUF_594                                                            0x18011F48
+#define CAM_EMM_EMM_BUF_595                                                            0x18011F4C
+#define CAM_EMM_EMM_BUF_596                                                            0x18011F50
+#define CAM_EMM_EMM_BUF_597                                                            0x18011F54
+#define CAM_EMM_EMM_BUF_598                                                            0x18011F58
+#define CAM_EMM_EMM_BUF_599                                                            0x18011F5C
+#define CAM_EMM_EMM_BUF_600                                                            0x18011F60
+#define CAM_EMM_EMM_BUF_601                                                            0x18011F64
+#define CAM_EMM_EMM_BUF_602                                                            0x18011F68
+#define CAM_EMM_EMM_BUF_603                                                            0x18011F6C
+#define CAM_EMM_EMM_BUF_604                                                            0x18011F70
+#define CAM_EMM_EMM_BUF_605                                                            0x18011F74
+#define CAM_EMM_EMM_BUF_606                                                            0x18011F78
+#define CAM_EMM_EMM_BUF_607                                                            0x18011F7C
+#define CAM_EMM_EMM_BUF_608                                                            0x18011F80
+#define CAM_EMM_EMM_BUF_609                                                            0x18011F84
+#define CAM_EMM_EMM_BUF_610                                                            0x18011F88
+#define CAM_EMM_EMM_BUF_611                                                            0x18011F8C
+#define CAM_EMM_EMM_BUF_612                                                            0x18011F90
+#define CAM_EMM_EMM_BUF_613                                                            0x18011F94
+#define CAM_EMM_EMM_BUF_614                                                            0x18011F98
+#define CAM_EMM_EMM_BUF_615                                                            0x18011F9C
+#define CAM_EMM_EMM_BUF_616                                                            0x18011FA0
+#define CAM_EMM_EMM_BUF_617                                                            0x18011FA4
+#define CAM_EMM_EMM_BUF_618                                                            0x18011FA8
+#define CAM_EMM_EMM_BUF_619                                                            0x18011FAC
+#define CAM_EMM_EMM_BUF_620                                                            0x18011FB0
+#define CAM_EMM_EMM_BUF_621                                                            0x18011FB4
+#define CAM_EMM_EMM_BUF_622                                                            0x18011FB8
+#define CAM_EMM_EMM_BUF_623                                                            0x18011FBC
+#define CAM_EMM_EMM_BUF_624                                                            0x18011FC0
+#define CAM_EMM_EMM_BUF_625                                                            0x18011FC4
+#define CAM_EMM_EMM_BUF_626                                                            0x18011FC8
+#define CAM_EMM_EMM_BUF_627                                                            0x18011FCC
+#define CAM_EMM_EMM_BUF_628                                                            0x18011FD0
+#define CAM_EMM_EMM_BUF_629                                                            0x18011FD4
+#define CAM_EMM_EMM_BUF_630                                                            0x18011FD8
+#define CAM_EMM_EMM_BUF_631                                                            0x18011FDC
+#define CAM_EMM_EMM_BUF_632                                                            0x18011FE0
+#define CAM_EMM_EMM_BUF_633                                                            0x18011FE4
+#define CAM_EMM_EMM_BUF_634                                                            0x18011FE8
+#define CAM_EMM_EMM_BUF_635                                                            0x18011FEC
+#define CAM_EMM_EMM_BUF_636                                                            0x18011FF0
+#define CAM_EMM_EMM_BUF_637                                                            0x18011FF4
+#define CAM_EMM_EMM_BUF_638                                                            0x18011FF8
+#define CAM_EMM_EMM_BUF_639                                                            0x18011FFC
+#define CAM_EMM_EMM_BUF_0_reg_addr                                                   "0xB8011600"
+#define CAM_EMM_EMM_BUF_1_reg_addr                                                   "0xB8011604"
+#define CAM_EMM_EMM_BUF_2_reg_addr                                                   "0xB8011608"
+#define CAM_EMM_EMM_BUF_3_reg_addr                                                   "0xB801160C"
+#define CAM_EMM_EMM_BUF_4_reg_addr                                                   "0xB8011610"
+#define CAM_EMM_EMM_BUF_5_reg_addr                                                   "0xB8011614"
+#define CAM_EMM_EMM_BUF_6_reg_addr                                                   "0xB8011618"
+#define CAM_EMM_EMM_BUF_7_reg_addr                                                   "0xB801161C"
+#define CAM_EMM_EMM_BUF_8_reg_addr                                                   "0xB8011620"
+#define CAM_EMM_EMM_BUF_9_reg_addr                                                   "0xB8011624"
+#define CAM_EMM_EMM_BUF_10_reg_addr                                                   "0xB8011628"
+#define CAM_EMM_EMM_BUF_11_reg_addr                                                   "0xB801162C"
+#define CAM_EMM_EMM_BUF_12_reg_addr                                                   "0xB8011630"
+#define CAM_EMM_EMM_BUF_13_reg_addr                                                   "0xB8011634"
+#define CAM_EMM_EMM_BUF_14_reg_addr                                                   "0xB8011638"
+#define CAM_EMM_EMM_BUF_15_reg_addr                                                   "0xB801163C"
+#define CAM_EMM_EMM_BUF_16_reg_addr                                                   "0xB8011640"
+#define CAM_EMM_EMM_BUF_17_reg_addr                                                   "0xB8011644"
+#define CAM_EMM_EMM_BUF_18_reg_addr                                                   "0xB8011648"
+#define CAM_EMM_EMM_BUF_19_reg_addr                                                   "0xB801164C"
+#define CAM_EMM_EMM_BUF_20_reg_addr                                                   "0xB8011650"
+#define CAM_EMM_EMM_BUF_21_reg_addr                                                   "0xB8011654"
+#define CAM_EMM_EMM_BUF_22_reg_addr                                                   "0xB8011658"
+#define CAM_EMM_EMM_BUF_23_reg_addr                                                   "0xB801165C"
+#define CAM_EMM_EMM_BUF_24_reg_addr                                                   "0xB8011660"
+#define CAM_EMM_EMM_BUF_25_reg_addr                                                   "0xB8011664"
+#define CAM_EMM_EMM_BUF_26_reg_addr                                                   "0xB8011668"
+#define CAM_EMM_EMM_BUF_27_reg_addr                                                   "0xB801166C"
+#define CAM_EMM_EMM_BUF_28_reg_addr                                                   "0xB8011670"
+#define CAM_EMM_EMM_BUF_29_reg_addr                                                   "0xB8011674"
+#define CAM_EMM_EMM_BUF_30_reg_addr                                                   "0xB8011678"
+#define CAM_EMM_EMM_BUF_31_reg_addr                                                   "0xB801167C"
+#define CAM_EMM_EMM_BUF_32_reg_addr                                                   "0xB8011680"
+#define CAM_EMM_EMM_BUF_33_reg_addr                                                   "0xB8011684"
+#define CAM_EMM_EMM_BUF_34_reg_addr                                                   "0xB8011688"
+#define CAM_EMM_EMM_BUF_35_reg_addr                                                   "0xB801168C"
+#define CAM_EMM_EMM_BUF_36_reg_addr                                                   "0xB8011690"
+#define CAM_EMM_EMM_BUF_37_reg_addr                                                   "0xB8011694"
+#define CAM_EMM_EMM_BUF_38_reg_addr                                                   "0xB8011698"
+#define CAM_EMM_EMM_BUF_39_reg_addr                                                   "0xB801169C"
+#define CAM_EMM_EMM_BUF_40_reg_addr                                                   "0xB80116A0"
+#define CAM_EMM_EMM_BUF_41_reg_addr                                                   "0xB80116A4"
+#define CAM_EMM_EMM_BUF_42_reg_addr                                                   "0xB80116A8"
+#define CAM_EMM_EMM_BUF_43_reg_addr                                                   "0xB80116AC"
+#define CAM_EMM_EMM_BUF_44_reg_addr                                                   "0xB80116B0"
+#define CAM_EMM_EMM_BUF_45_reg_addr                                                   "0xB80116B4"
+#define CAM_EMM_EMM_BUF_46_reg_addr                                                   "0xB80116B8"
+#define CAM_EMM_EMM_BUF_47_reg_addr                                                   "0xB80116BC"
+#define CAM_EMM_EMM_BUF_48_reg_addr                                                   "0xB80116C0"
+#define CAM_EMM_EMM_BUF_49_reg_addr                                                   "0xB80116C4"
+#define CAM_EMM_EMM_BUF_50_reg_addr                                                   "0xB80116C8"
+#define CAM_EMM_EMM_BUF_51_reg_addr                                                   "0xB80116CC"
+#define CAM_EMM_EMM_BUF_52_reg_addr                                                   "0xB80116D0"
+#define CAM_EMM_EMM_BUF_53_reg_addr                                                   "0xB80116D4"
+#define CAM_EMM_EMM_BUF_54_reg_addr                                                   "0xB80116D8"
+#define CAM_EMM_EMM_BUF_55_reg_addr                                                   "0xB80116DC"
+#define CAM_EMM_EMM_BUF_56_reg_addr                                                   "0xB80116E0"
+#define CAM_EMM_EMM_BUF_57_reg_addr                                                   "0xB80116E4"
+#define CAM_EMM_EMM_BUF_58_reg_addr                                                   "0xB80116E8"
+#define CAM_EMM_EMM_BUF_59_reg_addr                                                   "0xB80116EC"
+#define CAM_EMM_EMM_BUF_60_reg_addr                                                   "0xB80116F0"
+#define CAM_EMM_EMM_BUF_61_reg_addr                                                   "0xB80116F4"
+#define CAM_EMM_EMM_BUF_62_reg_addr                                                   "0xB80116F8"
+#define CAM_EMM_EMM_BUF_63_reg_addr                                                   "0xB80116FC"
+#define CAM_EMM_EMM_BUF_64_reg_addr                                                   "0xB8011700"
+#define CAM_EMM_EMM_BUF_65_reg_addr                                                   "0xB8011704"
+#define CAM_EMM_EMM_BUF_66_reg_addr                                                   "0xB8011708"
+#define CAM_EMM_EMM_BUF_67_reg_addr                                                   "0xB801170C"
+#define CAM_EMM_EMM_BUF_68_reg_addr                                                   "0xB8011710"
+#define CAM_EMM_EMM_BUF_69_reg_addr                                                   "0xB8011714"
+#define CAM_EMM_EMM_BUF_70_reg_addr                                                   "0xB8011718"
+#define CAM_EMM_EMM_BUF_71_reg_addr                                                   "0xB801171C"
+#define CAM_EMM_EMM_BUF_72_reg_addr                                                   "0xB8011720"
+#define CAM_EMM_EMM_BUF_73_reg_addr                                                   "0xB8011724"
+#define CAM_EMM_EMM_BUF_74_reg_addr                                                   "0xB8011728"
+#define CAM_EMM_EMM_BUF_75_reg_addr                                                   "0xB801172C"
+#define CAM_EMM_EMM_BUF_76_reg_addr                                                   "0xB8011730"
+#define CAM_EMM_EMM_BUF_77_reg_addr                                                   "0xB8011734"
+#define CAM_EMM_EMM_BUF_78_reg_addr                                                   "0xB8011738"
+#define CAM_EMM_EMM_BUF_79_reg_addr                                                   "0xB801173C"
+#define CAM_EMM_EMM_BUF_80_reg_addr                                                   "0xB8011740"
+#define CAM_EMM_EMM_BUF_81_reg_addr                                                   "0xB8011744"
+#define CAM_EMM_EMM_BUF_82_reg_addr                                                   "0xB8011748"
+#define CAM_EMM_EMM_BUF_83_reg_addr                                                   "0xB801174C"
+#define CAM_EMM_EMM_BUF_84_reg_addr                                                   "0xB8011750"
+#define CAM_EMM_EMM_BUF_85_reg_addr                                                   "0xB8011754"
+#define CAM_EMM_EMM_BUF_86_reg_addr                                                   "0xB8011758"
+#define CAM_EMM_EMM_BUF_87_reg_addr                                                   "0xB801175C"
+#define CAM_EMM_EMM_BUF_88_reg_addr                                                   "0xB8011760"
+#define CAM_EMM_EMM_BUF_89_reg_addr                                                   "0xB8011764"
+#define CAM_EMM_EMM_BUF_90_reg_addr                                                   "0xB8011768"
+#define CAM_EMM_EMM_BUF_91_reg_addr                                                   "0xB801176C"
+#define CAM_EMM_EMM_BUF_92_reg_addr                                                   "0xB8011770"
+#define CAM_EMM_EMM_BUF_93_reg_addr                                                   "0xB8011774"
+#define CAM_EMM_EMM_BUF_94_reg_addr                                                   "0xB8011778"
+#define CAM_EMM_EMM_BUF_95_reg_addr                                                   "0xB801177C"
+#define CAM_EMM_EMM_BUF_96_reg_addr                                                   "0xB8011780"
+#define CAM_EMM_EMM_BUF_97_reg_addr                                                   "0xB8011784"
+#define CAM_EMM_EMM_BUF_98_reg_addr                                                   "0xB8011788"
+#define CAM_EMM_EMM_BUF_99_reg_addr                                                   "0xB801178C"
+#define CAM_EMM_EMM_BUF_100_reg_addr                                                   "0xB8011790"
+#define CAM_EMM_EMM_BUF_101_reg_addr                                                   "0xB8011794"
+#define CAM_EMM_EMM_BUF_102_reg_addr                                                   "0xB8011798"
+#define CAM_EMM_EMM_BUF_103_reg_addr                                                   "0xB801179C"
+#define CAM_EMM_EMM_BUF_104_reg_addr                                                   "0xB80117A0"
+#define CAM_EMM_EMM_BUF_105_reg_addr                                                   "0xB80117A4"
+#define CAM_EMM_EMM_BUF_106_reg_addr                                                   "0xB80117A8"
+#define CAM_EMM_EMM_BUF_107_reg_addr                                                   "0xB80117AC"
+#define CAM_EMM_EMM_BUF_108_reg_addr                                                   "0xB80117B0"
+#define CAM_EMM_EMM_BUF_109_reg_addr                                                   "0xB80117B4"
+#define CAM_EMM_EMM_BUF_110_reg_addr                                                   "0xB80117B8"
+#define CAM_EMM_EMM_BUF_111_reg_addr                                                   "0xB80117BC"
+#define CAM_EMM_EMM_BUF_112_reg_addr                                                   "0xB80117C0"
+#define CAM_EMM_EMM_BUF_113_reg_addr                                                   "0xB80117C4"
+#define CAM_EMM_EMM_BUF_114_reg_addr                                                   "0xB80117C8"
+#define CAM_EMM_EMM_BUF_115_reg_addr                                                   "0xB80117CC"
+#define CAM_EMM_EMM_BUF_116_reg_addr                                                   "0xB80117D0"
+#define CAM_EMM_EMM_BUF_117_reg_addr                                                   "0xB80117D4"
+#define CAM_EMM_EMM_BUF_118_reg_addr                                                   "0xB80117D8"
+#define CAM_EMM_EMM_BUF_119_reg_addr                                                   "0xB80117DC"
+#define CAM_EMM_EMM_BUF_120_reg_addr                                                   "0xB80117E0"
+#define CAM_EMM_EMM_BUF_121_reg_addr                                                   "0xB80117E4"
+#define CAM_EMM_EMM_BUF_122_reg_addr                                                   "0xB80117E8"
+#define CAM_EMM_EMM_BUF_123_reg_addr                                                   "0xB80117EC"
+#define CAM_EMM_EMM_BUF_124_reg_addr                                                   "0xB80117F0"
+#define CAM_EMM_EMM_BUF_125_reg_addr                                                   "0xB80117F4"
+#define CAM_EMM_EMM_BUF_126_reg_addr                                                   "0xB80117F8"
+#define CAM_EMM_EMM_BUF_127_reg_addr                                                   "0xB80117FC"
+#define CAM_EMM_EMM_BUF_128_reg_addr                                                   "0xB8011800"
+#define CAM_EMM_EMM_BUF_129_reg_addr                                                   "0xB8011804"
+#define CAM_EMM_EMM_BUF_130_reg_addr                                                   "0xB8011808"
+#define CAM_EMM_EMM_BUF_131_reg_addr                                                   "0xB801180C"
+#define CAM_EMM_EMM_BUF_132_reg_addr                                                   "0xB8011810"
+#define CAM_EMM_EMM_BUF_133_reg_addr                                                   "0xB8011814"
+#define CAM_EMM_EMM_BUF_134_reg_addr                                                   "0xB8011818"
+#define CAM_EMM_EMM_BUF_135_reg_addr                                                   "0xB801181C"
+#define CAM_EMM_EMM_BUF_136_reg_addr                                                   "0xB8011820"
+#define CAM_EMM_EMM_BUF_137_reg_addr                                                   "0xB8011824"
+#define CAM_EMM_EMM_BUF_138_reg_addr                                                   "0xB8011828"
+#define CAM_EMM_EMM_BUF_139_reg_addr                                                   "0xB801182C"
+#define CAM_EMM_EMM_BUF_140_reg_addr                                                   "0xB8011830"
+#define CAM_EMM_EMM_BUF_141_reg_addr                                                   "0xB8011834"
+#define CAM_EMM_EMM_BUF_142_reg_addr                                                   "0xB8011838"
+#define CAM_EMM_EMM_BUF_143_reg_addr                                                   "0xB801183C"
+#define CAM_EMM_EMM_BUF_144_reg_addr                                                   "0xB8011840"
+#define CAM_EMM_EMM_BUF_145_reg_addr                                                   "0xB8011844"
+#define CAM_EMM_EMM_BUF_146_reg_addr                                                   "0xB8011848"
+#define CAM_EMM_EMM_BUF_147_reg_addr                                                   "0xB801184C"
+#define CAM_EMM_EMM_BUF_148_reg_addr                                                   "0xB8011850"
+#define CAM_EMM_EMM_BUF_149_reg_addr                                                   "0xB8011854"
+#define CAM_EMM_EMM_BUF_150_reg_addr                                                   "0xB8011858"
+#define CAM_EMM_EMM_BUF_151_reg_addr                                                   "0xB801185C"
+#define CAM_EMM_EMM_BUF_152_reg_addr                                                   "0xB8011860"
+#define CAM_EMM_EMM_BUF_153_reg_addr                                                   "0xB8011864"
+#define CAM_EMM_EMM_BUF_154_reg_addr                                                   "0xB8011868"
+#define CAM_EMM_EMM_BUF_155_reg_addr                                                   "0xB801186C"
+#define CAM_EMM_EMM_BUF_156_reg_addr                                                   "0xB8011870"
+#define CAM_EMM_EMM_BUF_157_reg_addr                                                   "0xB8011874"
+#define CAM_EMM_EMM_BUF_158_reg_addr                                                   "0xB8011878"
+#define CAM_EMM_EMM_BUF_159_reg_addr                                                   "0xB801187C"
+#define CAM_EMM_EMM_BUF_160_reg_addr                                                   "0xB8011880"
+#define CAM_EMM_EMM_BUF_161_reg_addr                                                   "0xB8011884"
+#define CAM_EMM_EMM_BUF_162_reg_addr                                                   "0xB8011888"
+#define CAM_EMM_EMM_BUF_163_reg_addr                                                   "0xB801188C"
+#define CAM_EMM_EMM_BUF_164_reg_addr                                                   "0xB8011890"
+#define CAM_EMM_EMM_BUF_165_reg_addr                                                   "0xB8011894"
+#define CAM_EMM_EMM_BUF_166_reg_addr                                                   "0xB8011898"
+#define CAM_EMM_EMM_BUF_167_reg_addr                                                   "0xB801189C"
+#define CAM_EMM_EMM_BUF_168_reg_addr                                                   "0xB80118A0"
+#define CAM_EMM_EMM_BUF_169_reg_addr                                                   "0xB80118A4"
+#define CAM_EMM_EMM_BUF_170_reg_addr                                                   "0xB80118A8"
+#define CAM_EMM_EMM_BUF_171_reg_addr                                                   "0xB80118AC"
+#define CAM_EMM_EMM_BUF_172_reg_addr                                                   "0xB80118B0"
+#define CAM_EMM_EMM_BUF_173_reg_addr                                                   "0xB80118B4"
+#define CAM_EMM_EMM_BUF_174_reg_addr                                                   "0xB80118B8"
+#define CAM_EMM_EMM_BUF_175_reg_addr                                                   "0xB80118BC"
+#define CAM_EMM_EMM_BUF_176_reg_addr                                                   "0xB80118C0"
+#define CAM_EMM_EMM_BUF_177_reg_addr                                                   "0xB80118C4"
+#define CAM_EMM_EMM_BUF_178_reg_addr                                                   "0xB80118C8"
+#define CAM_EMM_EMM_BUF_179_reg_addr                                                   "0xB80118CC"
+#define CAM_EMM_EMM_BUF_180_reg_addr                                                   "0xB80118D0"
+#define CAM_EMM_EMM_BUF_181_reg_addr                                                   "0xB80118D4"
+#define CAM_EMM_EMM_BUF_182_reg_addr                                                   "0xB80118D8"
+#define CAM_EMM_EMM_BUF_183_reg_addr                                                   "0xB80118DC"
+#define CAM_EMM_EMM_BUF_184_reg_addr                                                   "0xB80118E0"
+#define CAM_EMM_EMM_BUF_185_reg_addr                                                   "0xB80118E4"
+#define CAM_EMM_EMM_BUF_186_reg_addr                                                   "0xB80118E8"
+#define CAM_EMM_EMM_BUF_187_reg_addr                                                   "0xB80118EC"
+#define CAM_EMM_EMM_BUF_188_reg_addr                                                   "0xB80118F0"
+#define CAM_EMM_EMM_BUF_189_reg_addr                                                   "0xB80118F4"
+#define CAM_EMM_EMM_BUF_190_reg_addr                                                   "0xB80118F8"
+#define CAM_EMM_EMM_BUF_191_reg_addr                                                   "0xB80118FC"
+#define CAM_EMM_EMM_BUF_192_reg_addr                                                   "0xB8011900"
+#define CAM_EMM_EMM_BUF_193_reg_addr                                                   "0xB8011904"
+#define CAM_EMM_EMM_BUF_194_reg_addr                                                   "0xB8011908"
+#define CAM_EMM_EMM_BUF_195_reg_addr                                                   "0xB801190C"
+#define CAM_EMM_EMM_BUF_196_reg_addr                                                   "0xB8011910"
+#define CAM_EMM_EMM_BUF_197_reg_addr                                                   "0xB8011914"
+#define CAM_EMM_EMM_BUF_198_reg_addr                                                   "0xB8011918"
+#define CAM_EMM_EMM_BUF_199_reg_addr                                                   "0xB801191C"
+#define CAM_EMM_EMM_BUF_200_reg_addr                                                   "0xB8011920"
+#define CAM_EMM_EMM_BUF_201_reg_addr                                                   "0xB8011924"
+#define CAM_EMM_EMM_BUF_202_reg_addr                                                   "0xB8011928"
+#define CAM_EMM_EMM_BUF_203_reg_addr                                                   "0xB801192C"
+#define CAM_EMM_EMM_BUF_204_reg_addr                                                   "0xB8011930"
+#define CAM_EMM_EMM_BUF_205_reg_addr                                                   "0xB8011934"
+#define CAM_EMM_EMM_BUF_206_reg_addr                                                   "0xB8011938"
+#define CAM_EMM_EMM_BUF_207_reg_addr                                                   "0xB801193C"
+#define CAM_EMM_EMM_BUF_208_reg_addr                                                   "0xB8011940"
+#define CAM_EMM_EMM_BUF_209_reg_addr                                                   "0xB8011944"
+#define CAM_EMM_EMM_BUF_210_reg_addr                                                   "0xB8011948"
+#define CAM_EMM_EMM_BUF_211_reg_addr                                                   "0xB801194C"
+#define CAM_EMM_EMM_BUF_212_reg_addr                                                   "0xB8011950"
+#define CAM_EMM_EMM_BUF_213_reg_addr                                                   "0xB8011954"
+#define CAM_EMM_EMM_BUF_214_reg_addr                                                   "0xB8011958"
+#define CAM_EMM_EMM_BUF_215_reg_addr                                                   "0xB801195C"
+#define CAM_EMM_EMM_BUF_216_reg_addr                                                   "0xB8011960"
+#define CAM_EMM_EMM_BUF_217_reg_addr                                                   "0xB8011964"
+#define CAM_EMM_EMM_BUF_218_reg_addr                                                   "0xB8011968"
+#define CAM_EMM_EMM_BUF_219_reg_addr                                                   "0xB801196C"
+#define CAM_EMM_EMM_BUF_220_reg_addr                                                   "0xB8011970"
+#define CAM_EMM_EMM_BUF_221_reg_addr                                                   "0xB8011974"
+#define CAM_EMM_EMM_BUF_222_reg_addr                                                   "0xB8011978"
+#define CAM_EMM_EMM_BUF_223_reg_addr                                                   "0xB801197C"
+#define CAM_EMM_EMM_BUF_224_reg_addr                                                   "0xB8011980"
+#define CAM_EMM_EMM_BUF_225_reg_addr                                                   "0xB8011984"
+#define CAM_EMM_EMM_BUF_226_reg_addr                                                   "0xB8011988"
+#define CAM_EMM_EMM_BUF_227_reg_addr                                                   "0xB801198C"
+#define CAM_EMM_EMM_BUF_228_reg_addr                                                   "0xB8011990"
+#define CAM_EMM_EMM_BUF_229_reg_addr                                                   "0xB8011994"
+#define CAM_EMM_EMM_BUF_230_reg_addr                                                   "0xB8011998"
+#define CAM_EMM_EMM_BUF_231_reg_addr                                                   "0xB801199C"
+#define CAM_EMM_EMM_BUF_232_reg_addr                                                   "0xB80119A0"
+#define CAM_EMM_EMM_BUF_233_reg_addr                                                   "0xB80119A4"
+#define CAM_EMM_EMM_BUF_234_reg_addr                                                   "0xB80119A8"
+#define CAM_EMM_EMM_BUF_235_reg_addr                                                   "0xB80119AC"
+#define CAM_EMM_EMM_BUF_236_reg_addr                                                   "0xB80119B0"
+#define CAM_EMM_EMM_BUF_237_reg_addr                                                   "0xB80119B4"
+#define CAM_EMM_EMM_BUF_238_reg_addr                                                   "0xB80119B8"
+#define CAM_EMM_EMM_BUF_239_reg_addr                                                   "0xB80119BC"
+#define CAM_EMM_EMM_BUF_240_reg_addr                                                   "0xB80119C0"
+#define CAM_EMM_EMM_BUF_241_reg_addr                                                   "0xB80119C4"
+#define CAM_EMM_EMM_BUF_242_reg_addr                                                   "0xB80119C8"
+#define CAM_EMM_EMM_BUF_243_reg_addr                                                   "0xB80119CC"
+#define CAM_EMM_EMM_BUF_244_reg_addr                                                   "0xB80119D0"
+#define CAM_EMM_EMM_BUF_245_reg_addr                                                   "0xB80119D4"
+#define CAM_EMM_EMM_BUF_246_reg_addr                                                   "0xB80119D8"
+#define CAM_EMM_EMM_BUF_247_reg_addr                                                   "0xB80119DC"
+#define CAM_EMM_EMM_BUF_248_reg_addr                                                   "0xB80119E0"
+#define CAM_EMM_EMM_BUF_249_reg_addr                                                   "0xB80119E4"
+#define CAM_EMM_EMM_BUF_250_reg_addr                                                   "0xB80119E8"
+#define CAM_EMM_EMM_BUF_251_reg_addr                                                   "0xB80119EC"
+#define CAM_EMM_EMM_BUF_252_reg_addr                                                   "0xB80119F0"
+#define CAM_EMM_EMM_BUF_253_reg_addr                                                   "0xB80119F4"
+#define CAM_EMM_EMM_BUF_254_reg_addr                                                   "0xB80119F8"
+#define CAM_EMM_EMM_BUF_255_reg_addr                                                   "0xB80119FC"
+#define CAM_EMM_EMM_BUF_256_reg_addr                                                   "0xB8011A00"
+#define CAM_EMM_EMM_BUF_257_reg_addr                                                   "0xB8011A04"
+#define CAM_EMM_EMM_BUF_258_reg_addr                                                   "0xB8011A08"
+#define CAM_EMM_EMM_BUF_259_reg_addr                                                   "0xB8011A0C"
+#define CAM_EMM_EMM_BUF_260_reg_addr                                                   "0xB8011A10"
+#define CAM_EMM_EMM_BUF_261_reg_addr                                                   "0xB8011A14"
+#define CAM_EMM_EMM_BUF_262_reg_addr                                                   "0xB8011A18"
+#define CAM_EMM_EMM_BUF_263_reg_addr                                                   "0xB8011A1C"
+#define CAM_EMM_EMM_BUF_264_reg_addr                                                   "0xB8011A20"
+#define CAM_EMM_EMM_BUF_265_reg_addr                                                   "0xB8011A24"
+#define CAM_EMM_EMM_BUF_266_reg_addr                                                   "0xB8011A28"
+#define CAM_EMM_EMM_BUF_267_reg_addr                                                   "0xB8011A2C"
+#define CAM_EMM_EMM_BUF_268_reg_addr                                                   "0xB8011A30"
+#define CAM_EMM_EMM_BUF_269_reg_addr                                                   "0xB8011A34"
+#define CAM_EMM_EMM_BUF_270_reg_addr                                                   "0xB8011A38"
+#define CAM_EMM_EMM_BUF_271_reg_addr                                                   "0xB8011A3C"
+#define CAM_EMM_EMM_BUF_272_reg_addr                                                   "0xB8011A40"
+#define CAM_EMM_EMM_BUF_273_reg_addr                                                   "0xB8011A44"
+#define CAM_EMM_EMM_BUF_274_reg_addr                                                   "0xB8011A48"
+#define CAM_EMM_EMM_BUF_275_reg_addr                                                   "0xB8011A4C"
+#define CAM_EMM_EMM_BUF_276_reg_addr                                                   "0xB8011A50"
+#define CAM_EMM_EMM_BUF_277_reg_addr                                                   "0xB8011A54"
+#define CAM_EMM_EMM_BUF_278_reg_addr                                                   "0xB8011A58"
+#define CAM_EMM_EMM_BUF_279_reg_addr                                                   "0xB8011A5C"
+#define CAM_EMM_EMM_BUF_280_reg_addr                                                   "0xB8011A60"
+#define CAM_EMM_EMM_BUF_281_reg_addr                                                   "0xB8011A64"
+#define CAM_EMM_EMM_BUF_282_reg_addr                                                   "0xB8011A68"
+#define CAM_EMM_EMM_BUF_283_reg_addr                                                   "0xB8011A6C"
+#define CAM_EMM_EMM_BUF_284_reg_addr                                                   "0xB8011A70"
+#define CAM_EMM_EMM_BUF_285_reg_addr                                                   "0xB8011A74"
+#define CAM_EMM_EMM_BUF_286_reg_addr                                                   "0xB8011A78"
+#define CAM_EMM_EMM_BUF_287_reg_addr                                                   "0xB8011A7C"
+#define CAM_EMM_EMM_BUF_288_reg_addr                                                   "0xB8011A80"
+#define CAM_EMM_EMM_BUF_289_reg_addr                                                   "0xB8011A84"
+#define CAM_EMM_EMM_BUF_290_reg_addr                                                   "0xB8011A88"
+#define CAM_EMM_EMM_BUF_291_reg_addr                                                   "0xB8011A8C"
+#define CAM_EMM_EMM_BUF_292_reg_addr                                                   "0xB8011A90"
+#define CAM_EMM_EMM_BUF_293_reg_addr                                                   "0xB8011A94"
+#define CAM_EMM_EMM_BUF_294_reg_addr                                                   "0xB8011A98"
+#define CAM_EMM_EMM_BUF_295_reg_addr                                                   "0xB8011A9C"
+#define CAM_EMM_EMM_BUF_296_reg_addr                                                   "0xB8011AA0"
+#define CAM_EMM_EMM_BUF_297_reg_addr                                                   "0xB8011AA4"
+#define CAM_EMM_EMM_BUF_298_reg_addr                                                   "0xB8011AA8"
+#define CAM_EMM_EMM_BUF_299_reg_addr                                                   "0xB8011AAC"
+#define CAM_EMM_EMM_BUF_300_reg_addr                                                   "0xB8011AB0"
+#define CAM_EMM_EMM_BUF_301_reg_addr                                                   "0xB8011AB4"
+#define CAM_EMM_EMM_BUF_302_reg_addr                                                   "0xB8011AB8"
+#define CAM_EMM_EMM_BUF_303_reg_addr                                                   "0xB8011ABC"
+#define CAM_EMM_EMM_BUF_304_reg_addr                                                   "0xB8011AC0"
+#define CAM_EMM_EMM_BUF_305_reg_addr                                                   "0xB8011AC4"
+#define CAM_EMM_EMM_BUF_306_reg_addr                                                   "0xB8011AC8"
+#define CAM_EMM_EMM_BUF_307_reg_addr                                                   "0xB8011ACC"
+#define CAM_EMM_EMM_BUF_308_reg_addr                                                   "0xB8011AD0"
+#define CAM_EMM_EMM_BUF_309_reg_addr                                                   "0xB8011AD4"
+#define CAM_EMM_EMM_BUF_310_reg_addr                                                   "0xB8011AD8"
+#define CAM_EMM_EMM_BUF_311_reg_addr                                                   "0xB8011ADC"
+#define CAM_EMM_EMM_BUF_312_reg_addr                                                   "0xB8011AE0"
+#define CAM_EMM_EMM_BUF_313_reg_addr                                                   "0xB8011AE4"
+#define CAM_EMM_EMM_BUF_314_reg_addr                                                   "0xB8011AE8"
+#define CAM_EMM_EMM_BUF_315_reg_addr                                                   "0xB8011AEC"
+#define CAM_EMM_EMM_BUF_316_reg_addr                                                   "0xB8011AF0"
+#define CAM_EMM_EMM_BUF_317_reg_addr                                                   "0xB8011AF4"
+#define CAM_EMM_EMM_BUF_318_reg_addr                                                   "0xB8011AF8"
+#define CAM_EMM_EMM_BUF_319_reg_addr                                                   "0xB8011AFC"
+#define CAM_EMM_EMM_BUF_320_reg_addr                                                   "0xB8011B00"
+#define CAM_EMM_EMM_BUF_321_reg_addr                                                   "0xB8011B04"
+#define CAM_EMM_EMM_BUF_322_reg_addr                                                   "0xB8011B08"
+#define CAM_EMM_EMM_BUF_323_reg_addr                                                   "0xB8011B0C"
+#define CAM_EMM_EMM_BUF_324_reg_addr                                                   "0xB8011B10"
+#define CAM_EMM_EMM_BUF_325_reg_addr                                                   "0xB8011B14"
+#define CAM_EMM_EMM_BUF_326_reg_addr                                                   "0xB8011B18"
+#define CAM_EMM_EMM_BUF_327_reg_addr                                                   "0xB8011B1C"
+#define CAM_EMM_EMM_BUF_328_reg_addr                                                   "0xB8011B20"
+#define CAM_EMM_EMM_BUF_329_reg_addr                                                   "0xB8011B24"
+#define CAM_EMM_EMM_BUF_330_reg_addr                                                   "0xB8011B28"
+#define CAM_EMM_EMM_BUF_331_reg_addr                                                   "0xB8011B2C"
+#define CAM_EMM_EMM_BUF_332_reg_addr                                                   "0xB8011B30"
+#define CAM_EMM_EMM_BUF_333_reg_addr                                                   "0xB8011B34"
+#define CAM_EMM_EMM_BUF_334_reg_addr                                                   "0xB8011B38"
+#define CAM_EMM_EMM_BUF_335_reg_addr                                                   "0xB8011B3C"
+#define CAM_EMM_EMM_BUF_336_reg_addr                                                   "0xB8011B40"
+#define CAM_EMM_EMM_BUF_337_reg_addr                                                   "0xB8011B44"
+#define CAM_EMM_EMM_BUF_338_reg_addr                                                   "0xB8011B48"
+#define CAM_EMM_EMM_BUF_339_reg_addr                                                   "0xB8011B4C"
+#define CAM_EMM_EMM_BUF_340_reg_addr                                                   "0xB8011B50"
+#define CAM_EMM_EMM_BUF_341_reg_addr                                                   "0xB8011B54"
+#define CAM_EMM_EMM_BUF_342_reg_addr                                                   "0xB8011B58"
+#define CAM_EMM_EMM_BUF_343_reg_addr                                                   "0xB8011B5C"
+#define CAM_EMM_EMM_BUF_344_reg_addr                                                   "0xB8011B60"
+#define CAM_EMM_EMM_BUF_345_reg_addr                                                   "0xB8011B64"
+#define CAM_EMM_EMM_BUF_346_reg_addr                                                   "0xB8011B68"
+#define CAM_EMM_EMM_BUF_347_reg_addr                                                   "0xB8011B6C"
+#define CAM_EMM_EMM_BUF_348_reg_addr                                                   "0xB8011B70"
+#define CAM_EMM_EMM_BUF_349_reg_addr                                                   "0xB8011B74"
+#define CAM_EMM_EMM_BUF_350_reg_addr                                                   "0xB8011B78"
+#define CAM_EMM_EMM_BUF_351_reg_addr                                                   "0xB8011B7C"
+#define CAM_EMM_EMM_BUF_352_reg_addr                                                   "0xB8011B80"
+#define CAM_EMM_EMM_BUF_353_reg_addr                                                   "0xB8011B84"
+#define CAM_EMM_EMM_BUF_354_reg_addr                                                   "0xB8011B88"
+#define CAM_EMM_EMM_BUF_355_reg_addr                                                   "0xB8011B8C"
+#define CAM_EMM_EMM_BUF_356_reg_addr                                                   "0xB8011B90"
+#define CAM_EMM_EMM_BUF_357_reg_addr                                                   "0xB8011B94"
+#define CAM_EMM_EMM_BUF_358_reg_addr                                                   "0xB8011B98"
+#define CAM_EMM_EMM_BUF_359_reg_addr                                                   "0xB8011B9C"
+#define CAM_EMM_EMM_BUF_360_reg_addr                                                   "0xB8011BA0"
+#define CAM_EMM_EMM_BUF_361_reg_addr                                                   "0xB8011BA4"
+#define CAM_EMM_EMM_BUF_362_reg_addr                                                   "0xB8011BA8"
+#define CAM_EMM_EMM_BUF_363_reg_addr                                                   "0xB8011BAC"
+#define CAM_EMM_EMM_BUF_364_reg_addr                                                   "0xB8011BB0"
+#define CAM_EMM_EMM_BUF_365_reg_addr                                                   "0xB8011BB4"
+#define CAM_EMM_EMM_BUF_366_reg_addr                                                   "0xB8011BB8"
+#define CAM_EMM_EMM_BUF_367_reg_addr                                                   "0xB8011BBC"
+#define CAM_EMM_EMM_BUF_368_reg_addr                                                   "0xB8011BC0"
+#define CAM_EMM_EMM_BUF_369_reg_addr                                                   "0xB8011BC4"
+#define CAM_EMM_EMM_BUF_370_reg_addr                                                   "0xB8011BC8"
+#define CAM_EMM_EMM_BUF_371_reg_addr                                                   "0xB8011BCC"
+#define CAM_EMM_EMM_BUF_372_reg_addr                                                   "0xB8011BD0"
+#define CAM_EMM_EMM_BUF_373_reg_addr                                                   "0xB8011BD4"
+#define CAM_EMM_EMM_BUF_374_reg_addr                                                   "0xB8011BD8"
+#define CAM_EMM_EMM_BUF_375_reg_addr                                                   "0xB8011BDC"
+#define CAM_EMM_EMM_BUF_376_reg_addr                                                   "0xB8011BE0"
+#define CAM_EMM_EMM_BUF_377_reg_addr                                                   "0xB8011BE4"
+#define CAM_EMM_EMM_BUF_378_reg_addr                                                   "0xB8011BE8"
+#define CAM_EMM_EMM_BUF_379_reg_addr                                                   "0xB8011BEC"
+#define CAM_EMM_EMM_BUF_380_reg_addr                                                   "0xB8011BF0"
+#define CAM_EMM_EMM_BUF_381_reg_addr                                                   "0xB8011BF4"
+#define CAM_EMM_EMM_BUF_382_reg_addr                                                   "0xB8011BF8"
+#define CAM_EMM_EMM_BUF_383_reg_addr                                                   "0xB8011BFC"
+#define CAM_EMM_EMM_BUF_384_reg_addr                                                   "0xB8011C00"
+#define CAM_EMM_EMM_BUF_385_reg_addr                                                   "0xB8011C04"
+#define CAM_EMM_EMM_BUF_386_reg_addr                                                   "0xB8011C08"
+#define CAM_EMM_EMM_BUF_387_reg_addr                                                   "0xB8011C0C"
+#define CAM_EMM_EMM_BUF_388_reg_addr                                                   "0xB8011C10"
+#define CAM_EMM_EMM_BUF_389_reg_addr                                                   "0xB8011C14"
+#define CAM_EMM_EMM_BUF_390_reg_addr                                                   "0xB8011C18"
+#define CAM_EMM_EMM_BUF_391_reg_addr                                                   "0xB8011C1C"
+#define CAM_EMM_EMM_BUF_392_reg_addr                                                   "0xB8011C20"
+#define CAM_EMM_EMM_BUF_393_reg_addr                                                   "0xB8011C24"
+#define CAM_EMM_EMM_BUF_394_reg_addr                                                   "0xB8011C28"
+#define CAM_EMM_EMM_BUF_395_reg_addr                                                   "0xB8011C2C"
+#define CAM_EMM_EMM_BUF_396_reg_addr                                                   "0xB8011C30"
+#define CAM_EMM_EMM_BUF_397_reg_addr                                                   "0xB8011C34"
+#define CAM_EMM_EMM_BUF_398_reg_addr                                                   "0xB8011C38"
+#define CAM_EMM_EMM_BUF_399_reg_addr                                                   "0xB8011C3C"
+#define CAM_EMM_EMM_BUF_400_reg_addr                                                   "0xB8011C40"
+#define CAM_EMM_EMM_BUF_401_reg_addr                                                   "0xB8011C44"
+#define CAM_EMM_EMM_BUF_402_reg_addr                                                   "0xB8011C48"
+#define CAM_EMM_EMM_BUF_403_reg_addr                                                   "0xB8011C4C"
+#define CAM_EMM_EMM_BUF_404_reg_addr                                                   "0xB8011C50"
+#define CAM_EMM_EMM_BUF_405_reg_addr                                                   "0xB8011C54"
+#define CAM_EMM_EMM_BUF_406_reg_addr                                                   "0xB8011C58"
+#define CAM_EMM_EMM_BUF_407_reg_addr                                                   "0xB8011C5C"
+#define CAM_EMM_EMM_BUF_408_reg_addr                                                   "0xB8011C60"
+#define CAM_EMM_EMM_BUF_409_reg_addr                                                   "0xB8011C64"
+#define CAM_EMM_EMM_BUF_410_reg_addr                                                   "0xB8011C68"
+#define CAM_EMM_EMM_BUF_411_reg_addr                                                   "0xB8011C6C"
+#define CAM_EMM_EMM_BUF_412_reg_addr                                                   "0xB8011C70"
+#define CAM_EMM_EMM_BUF_413_reg_addr                                                   "0xB8011C74"
+#define CAM_EMM_EMM_BUF_414_reg_addr                                                   "0xB8011C78"
+#define CAM_EMM_EMM_BUF_415_reg_addr                                                   "0xB8011C7C"
+#define CAM_EMM_EMM_BUF_416_reg_addr                                                   "0xB8011C80"
+#define CAM_EMM_EMM_BUF_417_reg_addr                                                   "0xB8011C84"
+#define CAM_EMM_EMM_BUF_418_reg_addr                                                   "0xB8011C88"
+#define CAM_EMM_EMM_BUF_419_reg_addr                                                   "0xB8011C8C"
+#define CAM_EMM_EMM_BUF_420_reg_addr                                                   "0xB8011C90"
+#define CAM_EMM_EMM_BUF_421_reg_addr                                                   "0xB8011C94"
+#define CAM_EMM_EMM_BUF_422_reg_addr                                                   "0xB8011C98"
+#define CAM_EMM_EMM_BUF_423_reg_addr                                                   "0xB8011C9C"
+#define CAM_EMM_EMM_BUF_424_reg_addr                                                   "0xB8011CA0"
+#define CAM_EMM_EMM_BUF_425_reg_addr                                                   "0xB8011CA4"
+#define CAM_EMM_EMM_BUF_426_reg_addr                                                   "0xB8011CA8"
+#define CAM_EMM_EMM_BUF_427_reg_addr                                                   "0xB8011CAC"
+#define CAM_EMM_EMM_BUF_428_reg_addr                                                   "0xB8011CB0"
+#define CAM_EMM_EMM_BUF_429_reg_addr                                                   "0xB8011CB4"
+#define CAM_EMM_EMM_BUF_430_reg_addr                                                   "0xB8011CB8"
+#define CAM_EMM_EMM_BUF_431_reg_addr                                                   "0xB8011CBC"
+#define CAM_EMM_EMM_BUF_432_reg_addr                                                   "0xB8011CC0"
+#define CAM_EMM_EMM_BUF_433_reg_addr                                                   "0xB8011CC4"
+#define CAM_EMM_EMM_BUF_434_reg_addr                                                   "0xB8011CC8"
+#define CAM_EMM_EMM_BUF_435_reg_addr                                                   "0xB8011CCC"
+#define CAM_EMM_EMM_BUF_436_reg_addr                                                   "0xB8011CD0"
+#define CAM_EMM_EMM_BUF_437_reg_addr                                                   "0xB8011CD4"
+#define CAM_EMM_EMM_BUF_438_reg_addr                                                   "0xB8011CD8"
+#define CAM_EMM_EMM_BUF_439_reg_addr                                                   "0xB8011CDC"
+#define CAM_EMM_EMM_BUF_440_reg_addr                                                   "0xB8011CE0"
+#define CAM_EMM_EMM_BUF_441_reg_addr                                                   "0xB8011CE4"
+#define CAM_EMM_EMM_BUF_442_reg_addr                                                   "0xB8011CE8"
+#define CAM_EMM_EMM_BUF_443_reg_addr                                                   "0xB8011CEC"
+#define CAM_EMM_EMM_BUF_444_reg_addr                                                   "0xB8011CF0"
+#define CAM_EMM_EMM_BUF_445_reg_addr                                                   "0xB8011CF4"
+#define CAM_EMM_EMM_BUF_446_reg_addr                                                   "0xB8011CF8"
+#define CAM_EMM_EMM_BUF_447_reg_addr                                                   "0xB8011CFC"
+#define CAM_EMM_EMM_BUF_448_reg_addr                                                   "0xB8011D00"
+#define CAM_EMM_EMM_BUF_449_reg_addr                                                   "0xB8011D04"
+#define CAM_EMM_EMM_BUF_450_reg_addr                                                   "0xB8011D08"
+#define CAM_EMM_EMM_BUF_451_reg_addr                                                   "0xB8011D0C"
+#define CAM_EMM_EMM_BUF_452_reg_addr                                                   "0xB8011D10"
+#define CAM_EMM_EMM_BUF_453_reg_addr                                                   "0xB8011D14"
+#define CAM_EMM_EMM_BUF_454_reg_addr                                                   "0xB8011D18"
+#define CAM_EMM_EMM_BUF_455_reg_addr                                                   "0xB8011D1C"
+#define CAM_EMM_EMM_BUF_456_reg_addr                                                   "0xB8011D20"
+#define CAM_EMM_EMM_BUF_457_reg_addr                                                   "0xB8011D24"
+#define CAM_EMM_EMM_BUF_458_reg_addr                                                   "0xB8011D28"
+#define CAM_EMM_EMM_BUF_459_reg_addr                                                   "0xB8011D2C"
+#define CAM_EMM_EMM_BUF_460_reg_addr                                                   "0xB8011D30"
+#define CAM_EMM_EMM_BUF_461_reg_addr                                                   "0xB8011D34"
+#define CAM_EMM_EMM_BUF_462_reg_addr                                                   "0xB8011D38"
+#define CAM_EMM_EMM_BUF_463_reg_addr                                                   "0xB8011D3C"
+#define CAM_EMM_EMM_BUF_464_reg_addr                                                   "0xB8011D40"
+#define CAM_EMM_EMM_BUF_465_reg_addr                                                   "0xB8011D44"
+#define CAM_EMM_EMM_BUF_466_reg_addr                                                   "0xB8011D48"
+#define CAM_EMM_EMM_BUF_467_reg_addr                                                   "0xB8011D4C"
+#define CAM_EMM_EMM_BUF_468_reg_addr                                                   "0xB8011D50"
+#define CAM_EMM_EMM_BUF_469_reg_addr                                                   "0xB8011D54"
+#define CAM_EMM_EMM_BUF_470_reg_addr                                                   "0xB8011D58"
+#define CAM_EMM_EMM_BUF_471_reg_addr                                                   "0xB8011D5C"
+#define CAM_EMM_EMM_BUF_472_reg_addr                                                   "0xB8011D60"
+#define CAM_EMM_EMM_BUF_473_reg_addr                                                   "0xB8011D64"
+#define CAM_EMM_EMM_BUF_474_reg_addr                                                   "0xB8011D68"
+#define CAM_EMM_EMM_BUF_475_reg_addr                                                   "0xB8011D6C"
+#define CAM_EMM_EMM_BUF_476_reg_addr                                                   "0xB8011D70"
+#define CAM_EMM_EMM_BUF_477_reg_addr                                                   "0xB8011D74"
+#define CAM_EMM_EMM_BUF_478_reg_addr                                                   "0xB8011D78"
+#define CAM_EMM_EMM_BUF_479_reg_addr                                                   "0xB8011D7C"
+#define CAM_EMM_EMM_BUF_480_reg_addr                                                   "0xB8011D80"
+#define CAM_EMM_EMM_BUF_481_reg_addr                                                   "0xB8011D84"
+#define CAM_EMM_EMM_BUF_482_reg_addr                                                   "0xB8011D88"
+#define CAM_EMM_EMM_BUF_483_reg_addr                                                   "0xB8011D8C"
+#define CAM_EMM_EMM_BUF_484_reg_addr                                                   "0xB8011D90"
+#define CAM_EMM_EMM_BUF_485_reg_addr                                                   "0xB8011D94"
+#define CAM_EMM_EMM_BUF_486_reg_addr                                                   "0xB8011D98"
+#define CAM_EMM_EMM_BUF_487_reg_addr                                                   "0xB8011D9C"
+#define CAM_EMM_EMM_BUF_488_reg_addr                                                   "0xB8011DA0"
+#define CAM_EMM_EMM_BUF_489_reg_addr                                                   "0xB8011DA4"
+#define CAM_EMM_EMM_BUF_490_reg_addr                                                   "0xB8011DA8"
+#define CAM_EMM_EMM_BUF_491_reg_addr                                                   "0xB8011DAC"
+#define CAM_EMM_EMM_BUF_492_reg_addr                                                   "0xB8011DB0"
+#define CAM_EMM_EMM_BUF_493_reg_addr                                                   "0xB8011DB4"
+#define CAM_EMM_EMM_BUF_494_reg_addr                                                   "0xB8011DB8"
+#define CAM_EMM_EMM_BUF_495_reg_addr                                                   "0xB8011DBC"
+#define CAM_EMM_EMM_BUF_496_reg_addr                                                   "0xB8011DC0"
+#define CAM_EMM_EMM_BUF_497_reg_addr                                                   "0xB8011DC4"
+#define CAM_EMM_EMM_BUF_498_reg_addr                                                   "0xB8011DC8"
+#define CAM_EMM_EMM_BUF_499_reg_addr                                                   "0xB8011DCC"
+#define CAM_EMM_EMM_BUF_500_reg_addr                                                   "0xB8011DD0"
+#define CAM_EMM_EMM_BUF_501_reg_addr                                                   "0xB8011DD4"
+#define CAM_EMM_EMM_BUF_502_reg_addr                                                   "0xB8011DD8"
+#define CAM_EMM_EMM_BUF_503_reg_addr                                                   "0xB8011DDC"
+#define CAM_EMM_EMM_BUF_504_reg_addr                                                   "0xB8011DE0"
+#define CAM_EMM_EMM_BUF_505_reg_addr                                                   "0xB8011DE4"
+#define CAM_EMM_EMM_BUF_506_reg_addr                                                   "0xB8011DE8"
+#define CAM_EMM_EMM_BUF_507_reg_addr                                                   "0xB8011DEC"
+#define CAM_EMM_EMM_BUF_508_reg_addr                                                   "0xB8011DF0"
+#define CAM_EMM_EMM_BUF_509_reg_addr                                                   "0xB8011DF4"
+#define CAM_EMM_EMM_BUF_510_reg_addr                                                   "0xB8011DF8"
+#define CAM_EMM_EMM_BUF_511_reg_addr                                                   "0xB8011DFC"
+#define CAM_EMM_EMM_BUF_512_reg_addr                                                   "0xB8011E00"
+#define CAM_EMM_EMM_BUF_513_reg_addr                                                   "0xB8011E04"
+#define CAM_EMM_EMM_BUF_514_reg_addr                                                   "0xB8011E08"
+#define CAM_EMM_EMM_BUF_515_reg_addr                                                   "0xB8011E0C"
+#define CAM_EMM_EMM_BUF_516_reg_addr                                                   "0xB8011E10"
+#define CAM_EMM_EMM_BUF_517_reg_addr                                                   "0xB8011E14"
+#define CAM_EMM_EMM_BUF_518_reg_addr                                                   "0xB8011E18"
+#define CAM_EMM_EMM_BUF_519_reg_addr                                                   "0xB8011E1C"
+#define CAM_EMM_EMM_BUF_520_reg_addr                                                   "0xB8011E20"
+#define CAM_EMM_EMM_BUF_521_reg_addr                                                   "0xB8011E24"
+#define CAM_EMM_EMM_BUF_522_reg_addr                                                   "0xB8011E28"
+#define CAM_EMM_EMM_BUF_523_reg_addr                                                   "0xB8011E2C"
+#define CAM_EMM_EMM_BUF_524_reg_addr                                                   "0xB8011E30"
+#define CAM_EMM_EMM_BUF_525_reg_addr                                                   "0xB8011E34"
+#define CAM_EMM_EMM_BUF_526_reg_addr                                                   "0xB8011E38"
+#define CAM_EMM_EMM_BUF_527_reg_addr                                                   "0xB8011E3C"
+#define CAM_EMM_EMM_BUF_528_reg_addr                                                   "0xB8011E40"
+#define CAM_EMM_EMM_BUF_529_reg_addr                                                   "0xB8011E44"
+#define CAM_EMM_EMM_BUF_530_reg_addr                                                   "0xB8011E48"
+#define CAM_EMM_EMM_BUF_531_reg_addr                                                   "0xB8011E4C"
+#define CAM_EMM_EMM_BUF_532_reg_addr                                                   "0xB8011E50"
+#define CAM_EMM_EMM_BUF_533_reg_addr                                                   "0xB8011E54"
+#define CAM_EMM_EMM_BUF_534_reg_addr                                                   "0xB8011E58"
+#define CAM_EMM_EMM_BUF_535_reg_addr                                                   "0xB8011E5C"
+#define CAM_EMM_EMM_BUF_536_reg_addr                                                   "0xB8011E60"
+#define CAM_EMM_EMM_BUF_537_reg_addr                                                   "0xB8011E64"
+#define CAM_EMM_EMM_BUF_538_reg_addr                                                   "0xB8011E68"
+#define CAM_EMM_EMM_BUF_539_reg_addr                                                   "0xB8011E6C"
+#define CAM_EMM_EMM_BUF_540_reg_addr                                                   "0xB8011E70"
+#define CAM_EMM_EMM_BUF_541_reg_addr                                                   "0xB8011E74"
+#define CAM_EMM_EMM_BUF_542_reg_addr                                                   "0xB8011E78"
+#define CAM_EMM_EMM_BUF_543_reg_addr                                                   "0xB8011E7C"
+#define CAM_EMM_EMM_BUF_544_reg_addr                                                   "0xB8011E80"
+#define CAM_EMM_EMM_BUF_545_reg_addr                                                   "0xB8011E84"
+#define CAM_EMM_EMM_BUF_546_reg_addr                                                   "0xB8011E88"
+#define CAM_EMM_EMM_BUF_547_reg_addr                                                   "0xB8011E8C"
+#define CAM_EMM_EMM_BUF_548_reg_addr                                                   "0xB8011E90"
+#define CAM_EMM_EMM_BUF_549_reg_addr                                                   "0xB8011E94"
+#define CAM_EMM_EMM_BUF_550_reg_addr                                                   "0xB8011E98"
+#define CAM_EMM_EMM_BUF_551_reg_addr                                                   "0xB8011E9C"
+#define CAM_EMM_EMM_BUF_552_reg_addr                                                   "0xB8011EA0"
+#define CAM_EMM_EMM_BUF_553_reg_addr                                                   "0xB8011EA4"
+#define CAM_EMM_EMM_BUF_554_reg_addr                                                   "0xB8011EA8"
+#define CAM_EMM_EMM_BUF_555_reg_addr                                                   "0xB8011EAC"
+#define CAM_EMM_EMM_BUF_556_reg_addr                                                   "0xB8011EB0"
+#define CAM_EMM_EMM_BUF_557_reg_addr                                                   "0xB8011EB4"
+#define CAM_EMM_EMM_BUF_558_reg_addr                                                   "0xB8011EB8"
+#define CAM_EMM_EMM_BUF_559_reg_addr                                                   "0xB8011EBC"
+#define CAM_EMM_EMM_BUF_560_reg_addr                                                   "0xB8011EC0"
+#define CAM_EMM_EMM_BUF_561_reg_addr                                                   "0xB8011EC4"
+#define CAM_EMM_EMM_BUF_562_reg_addr                                                   "0xB8011EC8"
+#define CAM_EMM_EMM_BUF_563_reg_addr                                                   "0xB8011ECC"
+#define CAM_EMM_EMM_BUF_564_reg_addr                                                   "0xB8011ED0"
+#define CAM_EMM_EMM_BUF_565_reg_addr                                                   "0xB8011ED4"
+#define CAM_EMM_EMM_BUF_566_reg_addr                                                   "0xB8011ED8"
+#define CAM_EMM_EMM_BUF_567_reg_addr                                                   "0xB8011EDC"
+#define CAM_EMM_EMM_BUF_568_reg_addr                                                   "0xB8011EE0"
+#define CAM_EMM_EMM_BUF_569_reg_addr                                                   "0xB8011EE4"
+#define CAM_EMM_EMM_BUF_570_reg_addr                                                   "0xB8011EE8"
+#define CAM_EMM_EMM_BUF_571_reg_addr                                                   "0xB8011EEC"
+#define CAM_EMM_EMM_BUF_572_reg_addr                                                   "0xB8011EF0"
+#define CAM_EMM_EMM_BUF_573_reg_addr                                                   "0xB8011EF4"
+#define CAM_EMM_EMM_BUF_574_reg_addr                                                   "0xB8011EF8"
+#define CAM_EMM_EMM_BUF_575_reg_addr                                                   "0xB8011EFC"
+#define CAM_EMM_EMM_BUF_576_reg_addr                                                   "0xB8011F00"
+#define CAM_EMM_EMM_BUF_577_reg_addr                                                   "0xB8011F04"
+#define CAM_EMM_EMM_BUF_578_reg_addr                                                   "0xB8011F08"
+#define CAM_EMM_EMM_BUF_579_reg_addr                                                   "0xB8011F0C"
+#define CAM_EMM_EMM_BUF_580_reg_addr                                                   "0xB8011F10"
+#define CAM_EMM_EMM_BUF_581_reg_addr                                                   "0xB8011F14"
+#define CAM_EMM_EMM_BUF_582_reg_addr                                                   "0xB8011F18"
+#define CAM_EMM_EMM_BUF_583_reg_addr                                                   "0xB8011F1C"
+#define CAM_EMM_EMM_BUF_584_reg_addr                                                   "0xB8011F20"
+#define CAM_EMM_EMM_BUF_585_reg_addr                                                   "0xB8011F24"
+#define CAM_EMM_EMM_BUF_586_reg_addr                                                   "0xB8011F28"
+#define CAM_EMM_EMM_BUF_587_reg_addr                                                   "0xB8011F2C"
+#define CAM_EMM_EMM_BUF_588_reg_addr                                                   "0xB8011F30"
+#define CAM_EMM_EMM_BUF_589_reg_addr                                                   "0xB8011F34"
+#define CAM_EMM_EMM_BUF_590_reg_addr                                                   "0xB8011F38"
+#define CAM_EMM_EMM_BUF_591_reg_addr                                                   "0xB8011F3C"
+#define CAM_EMM_EMM_BUF_592_reg_addr                                                   "0xB8011F40"
+#define CAM_EMM_EMM_BUF_593_reg_addr                                                   "0xB8011F44"
+#define CAM_EMM_EMM_BUF_594_reg_addr                                                   "0xB8011F48"
+#define CAM_EMM_EMM_BUF_595_reg_addr                                                   "0xB8011F4C"
+#define CAM_EMM_EMM_BUF_596_reg_addr                                                   "0xB8011F50"
+#define CAM_EMM_EMM_BUF_597_reg_addr                                                   "0xB8011F54"
+#define CAM_EMM_EMM_BUF_598_reg_addr                                                   "0xB8011F58"
+#define CAM_EMM_EMM_BUF_599_reg_addr                                                   "0xB8011F5C"
+#define CAM_EMM_EMM_BUF_600_reg_addr                                                   "0xB8011F60"
+#define CAM_EMM_EMM_BUF_601_reg_addr                                                   "0xB8011F64"
+#define CAM_EMM_EMM_BUF_602_reg_addr                                                   "0xB8011F68"
+#define CAM_EMM_EMM_BUF_603_reg_addr                                                   "0xB8011F6C"
+#define CAM_EMM_EMM_BUF_604_reg_addr                                                   "0xB8011F70"
+#define CAM_EMM_EMM_BUF_605_reg_addr                                                   "0xB8011F74"
+#define CAM_EMM_EMM_BUF_606_reg_addr                                                   "0xB8011F78"
+#define CAM_EMM_EMM_BUF_607_reg_addr                                                   "0xB8011F7C"
+#define CAM_EMM_EMM_BUF_608_reg_addr                                                   "0xB8011F80"
+#define CAM_EMM_EMM_BUF_609_reg_addr                                                   "0xB8011F84"
+#define CAM_EMM_EMM_BUF_610_reg_addr                                                   "0xB8011F88"
+#define CAM_EMM_EMM_BUF_611_reg_addr                                                   "0xB8011F8C"
+#define CAM_EMM_EMM_BUF_612_reg_addr                                                   "0xB8011F90"
+#define CAM_EMM_EMM_BUF_613_reg_addr                                                   "0xB8011F94"
+#define CAM_EMM_EMM_BUF_614_reg_addr                                                   "0xB8011F98"
+#define CAM_EMM_EMM_BUF_615_reg_addr                                                   "0xB8011F9C"
+#define CAM_EMM_EMM_BUF_616_reg_addr                                                   "0xB8011FA0"
+#define CAM_EMM_EMM_BUF_617_reg_addr                                                   "0xB8011FA4"
+#define CAM_EMM_EMM_BUF_618_reg_addr                                                   "0xB8011FA8"
+#define CAM_EMM_EMM_BUF_619_reg_addr                                                   "0xB8011FAC"
+#define CAM_EMM_EMM_BUF_620_reg_addr                                                   "0xB8011FB0"
+#define CAM_EMM_EMM_BUF_621_reg_addr                                                   "0xB8011FB4"
+#define CAM_EMM_EMM_BUF_622_reg_addr                                                   "0xB8011FB8"
+#define CAM_EMM_EMM_BUF_623_reg_addr                                                   "0xB8011FBC"
+#define CAM_EMM_EMM_BUF_624_reg_addr                                                   "0xB8011FC0"
+#define CAM_EMM_EMM_BUF_625_reg_addr                                                   "0xB8011FC4"
+#define CAM_EMM_EMM_BUF_626_reg_addr                                                   "0xB8011FC8"
+#define CAM_EMM_EMM_BUF_627_reg_addr                                                   "0xB8011FCC"
+#define CAM_EMM_EMM_BUF_628_reg_addr                                                   "0xB8011FD0"
+#define CAM_EMM_EMM_BUF_629_reg_addr                                                   "0xB8011FD4"
+#define CAM_EMM_EMM_BUF_630_reg_addr                                                   "0xB8011FD8"
+#define CAM_EMM_EMM_BUF_631_reg_addr                                                   "0xB8011FDC"
+#define CAM_EMM_EMM_BUF_632_reg_addr                                                   "0xB8011FE0"
+#define CAM_EMM_EMM_BUF_633_reg_addr                                                   "0xB8011FE4"
+#define CAM_EMM_EMM_BUF_634_reg_addr                                                   "0xB8011FE8"
+#define CAM_EMM_EMM_BUF_635_reg_addr                                                   "0xB8011FEC"
+#define CAM_EMM_EMM_BUF_636_reg_addr                                                   "0xB8011FF0"
+#define CAM_EMM_EMM_BUF_637_reg_addr                                                   "0xB8011FF4"
+#define CAM_EMM_EMM_BUF_638_reg_addr                                                   "0xB8011FF8"
+#define CAM_EMM_EMM_BUF_639_reg_addr                                                   "0xB8011FFC"
+#define CAM_EMM_EMM_BUF_0_reg                                                        0xB8011600
+#define CAM_EMM_EMM_BUF_1_reg                                                        0xB8011604
+#define CAM_EMM_EMM_BUF_2_reg                                                        0xB8011608
+#define CAM_EMM_EMM_BUF_3_reg                                                        0xB801160C
+#define CAM_EMM_EMM_BUF_4_reg                                                        0xB8011610
+#define CAM_EMM_EMM_BUF_5_reg                                                        0xB8011614
+#define CAM_EMM_EMM_BUF_6_reg                                                        0xB8011618
+#define CAM_EMM_EMM_BUF_7_reg                                                        0xB801161C
+#define CAM_EMM_EMM_BUF_8_reg                                                        0xB8011620
+#define CAM_EMM_EMM_BUF_9_reg                                                        0xB8011624
+#define CAM_EMM_EMM_BUF_10_reg                                                        0xB8011628
+#define CAM_EMM_EMM_BUF_11_reg                                                        0xB801162C
+#define CAM_EMM_EMM_BUF_12_reg                                                        0xB8011630
+#define CAM_EMM_EMM_BUF_13_reg                                                        0xB8011634
+#define CAM_EMM_EMM_BUF_14_reg                                                        0xB8011638
+#define CAM_EMM_EMM_BUF_15_reg                                                        0xB801163C
+#define CAM_EMM_EMM_BUF_16_reg                                                        0xB8011640
+#define CAM_EMM_EMM_BUF_17_reg                                                        0xB8011644
+#define CAM_EMM_EMM_BUF_18_reg                                                        0xB8011648
+#define CAM_EMM_EMM_BUF_19_reg                                                        0xB801164C
+#define CAM_EMM_EMM_BUF_20_reg                                                        0xB8011650
+#define CAM_EMM_EMM_BUF_21_reg                                                        0xB8011654
+#define CAM_EMM_EMM_BUF_22_reg                                                        0xB8011658
+#define CAM_EMM_EMM_BUF_23_reg                                                        0xB801165C
+#define CAM_EMM_EMM_BUF_24_reg                                                        0xB8011660
+#define CAM_EMM_EMM_BUF_25_reg                                                        0xB8011664
+#define CAM_EMM_EMM_BUF_26_reg                                                        0xB8011668
+#define CAM_EMM_EMM_BUF_27_reg                                                        0xB801166C
+#define CAM_EMM_EMM_BUF_28_reg                                                        0xB8011670
+#define CAM_EMM_EMM_BUF_29_reg                                                        0xB8011674
+#define CAM_EMM_EMM_BUF_30_reg                                                        0xB8011678
+#define CAM_EMM_EMM_BUF_31_reg                                                        0xB801167C
+#define CAM_EMM_EMM_BUF_32_reg                                                        0xB8011680
+#define CAM_EMM_EMM_BUF_33_reg                                                        0xB8011684
+#define CAM_EMM_EMM_BUF_34_reg                                                        0xB8011688
+#define CAM_EMM_EMM_BUF_35_reg                                                        0xB801168C
+#define CAM_EMM_EMM_BUF_36_reg                                                        0xB8011690
+#define CAM_EMM_EMM_BUF_37_reg                                                        0xB8011694
+#define CAM_EMM_EMM_BUF_38_reg                                                        0xB8011698
+#define CAM_EMM_EMM_BUF_39_reg                                                        0xB801169C
+#define CAM_EMM_EMM_BUF_40_reg                                                        0xB80116A0
+#define CAM_EMM_EMM_BUF_41_reg                                                        0xB80116A4
+#define CAM_EMM_EMM_BUF_42_reg                                                        0xB80116A8
+#define CAM_EMM_EMM_BUF_43_reg                                                        0xB80116AC
+#define CAM_EMM_EMM_BUF_44_reg                                                        0xB80116B0
+#define CAM_EMM_EMM_BUF_45_reg                                                        0xB80116B4
+#define CAM_EMM_EMM_BUF_46_reg                                                        0xB80116B8
+#define CAM_EMM_EMM_BUF_47_reg                                                        0xB80116BC
+#define CAM_EMM_EMM_BUF_48_reg                                                        0xB80116C0
+#define CAM_EMM_EMM_BUF_49_reg                                                        0xB80116C4
+#define CAM_EMM_EMM_BUF_50_reg                                                        0xB80116C8
+#define CAM_EMM_EMM_BUF_51_reg                                                        0xB80116CC
+#define CAM_EMM_EMM_BUF_52_reg                                                        0xB80116D0
+#define CAM_EMM_EMM_BUF_53_reg                                                        0xB80116D4
+#define CAM_EMM_EMM_BUF_54_reg                                                        0xB80116D8
+#define CAM_EMM_EMM_BUF_55_reg                                                        0xB80116DC
+#define CAM_EMM_EMM_BUF_56_reg                                                        0xB80116E0
+#define CAM_EMM_EMM_BUF_57_reg                                                        0xB80116E4
+#define CAM_EMM_EMM_BUF_58_reg                                                        0xB80116E8
+#define CAM_EMM_EMM_BUF_59_reg                                                        0xB80116EC
+#define CAM_EMM_EMM_BUF_60_reg                                                        0xB80116F0
+#define CAM_EMM_EMM_BUF_61_reg                                                        0xB80116F4
+#define CAM_EMM_EMM_BUF_62_reg                                                        0xB80116F8
+#define CAM_EMM_EMM_BUF_63_reg                                                        0xB80116FC
+#define CAM_EMM_EMM_BUF_64_reg                                                        0xB8011700
+#define CAM_EMM_EMM_BUF_65_reg                                                        0xB8011704
+#define CAM_EMM_EMM_BUF_66_reg                                                        0xB8011708
+#define CAM_EMM_EMM_BUF_67_reg                                                        0xB801170C
+#define CAM_EMM_EMM_BUF_68_reg                                                        0xB8011710
+#define CAM_EMM_EMM_BUF_69_reg                                                        0xB8011714
+#define CAM_EMM_EMM_BUF_70_reg                                                        0xB8011718
+#define CAM_EMM_EMM_BUF_71_reg                                                        0xB801171C
+#define CAM_EMM_EMM_BUF_72_reg                                                        0xB8011720
+#define CAM_EMM_EMM_BUF_73_reg                                                        0xB8011724
+#define CAM_EMM_EMM_BUF_74_reg                                                        0xB8011728
+#define CAM_EMM_EMM_BUF_75_reg                                                        0xB801172C
+#define CAM_EMM_EMM_BUF_76_reg                                                        0xB8011730
+#define CAM_EMM_EMM_BUF_77_reg                                                        0xB8011734
+#define CAM_EMM_EMM_BUF_78_reg                                                        0xB8011738
+#define CAM_EMM_EMM_BUF_79_reg                                                        0xB801173C
+#define CAM_EMM_EMM_BUF_80_reg                                                        0xB8011740
+#define CAM_EMM_EMM_BUF_81_reg                                                        0xB8011744
+#define CAM_EMM_EMM_BUF_82_reg                                                        0xB8011748
+#define CAM_EMM_EMM_BUF_83_reg                                                        0xB801174C
+#define CAM_EMM_EMM_BUF_84_reg                                                        0xB8011750
+#define CAM_EMM_EMM_BUF_85_reg                                                        0xB8011754
+#define CAM_EMM_EMM_BUF_86_reg                                                        0xB8011758
+#define CAM_EMM_EMM_BUF_87_reg                                                        0xB801175C
+#define CAM_EMM_EMM_BUF_88_reg                                                        0xB8011760
+#define CAM_EMM_EMM_BUF_89_reg                                                        0xB8011764
+#define CAM_EMM_EMM_BUF_90_reg                                                        0xB8011768
+#define CAM_EMM_EMM_BUF_91_reg                                                        0xB801176C
+#define CAM_EMM_EMM_BUF_92_reg                                                        0xB8011770
+#define CAM_EMM_EMM_BUF_93_reg                                                        0xB8011774
+#define CAM_EMM_EMM_BUF_94_reg                                                        0xB8011778
+#define CAM_EMM_EMM_BUF_95_reg                                                        0xB801177C
+#define CAM_EMM_EMM_BUF_96_reg                                                        0xB8011780
+#define CAM_EMM_EMM_BUF_97_reg                                                        0xB8011784
+#define CAM_EMM_EMM_BUF_98_reg                                                        0xB8011788
+#define CAM_EMM_EMM_BUF_99_reg                                                        0xB801178C
+#define CAM_EMM_EMM_BUF_100_reg                                                        0xB8011790
+#define CAM_EMM_EMM_BUF_101_reg                                                        0xB8011794
+#define CAM_EMM_EMM_BUF_102_reg                                                        0xB8011798
+#define CAM_EMM_EMM_BUF_103_reg                                                        0xB801179C
+#define CAM_EMM_EMM_BUF_104_reg                                                        0xB80117A0
+#define CAM_EMM_EMM_BUF_105_reg                                                        0xB80117A4
+#define CAM_EMM_EMM_BUF_106_reg                                                        0xB80117A8
+#define CAM_EMM_EMM_BUF_107_reg                                                        0xB80117AC
+#define CAM_EMM_EMM_BUF_108_reg                                                        0xB80117B0
+#define CAM_EMM_EMM_BUF_109_reg                                                        0xB80117B4
+#define CAM_EMM_EMM_BUF_110_reg                                                        0xB80117B8
+#define CAM_EMM_EMM_BUF_111_reg                                                        0xB80117BC
+#define CAM_EMM_EMM_BUF_112_reg                                                        0xB80117C0
+#define CAM_EMM_EMM_BUF_113_reg                                                        0xB80117C4
+#define CAM_EMM_EMM_BUF_114_reg                                                        0xB80117C8
+#define CAM_EMM_EMM_BUF_115_reg                                                        0xB80117CC
+#define CAM_EMM_EMM_BUF_116_reg                                                        0xB80117D0
+#define CAM_EMM_EMM_BUF_117_reg                                                        0xB80117D4
+#define CAM_EMM_EMM_BUF_118_reg                                                        0xB80117D8
+#define CAM_EMM_EMM_BUF_119_reg                                                        0xB80117DC
+#define CAM_EMM_EMM_BUF_120_reg                                                        0xB80117E0
+#define CAM_EMM_EMM_BUF_121_reg                                                        0xB80117E4
+#define CAM_EMM_EMM_BUF_122_reg                                                        0xB80117E8
+#define CAM_EMM_EMM_BUF_123_reg                                                        0xB80117EC
+#define CAM_EMM_EMM_BUF_124_reg                                                        0xB80117F0
+#define CAM_EMM_EMM_BUF_125_reg                                                        0xB80117F4
+#define CAM_EMM_EMM_BUF_126_reg                                                        0xB80117F8
+#define CAM_EMM_EMM_BUF_127_reg                                                        0xB80117FC
+#define CAM_EMM_EMM_BUF_128_reg                                                        0xB8011800
+#define CAM_EMM_EMM_BUF_129_reg                                                        0xB8011804
+#define CAM_EMM_EMM_BUF_130_reg                                                        0xB8011808
+#define CAM_EMM_EMM_BUF_131_reg                                                        0xB801180C
+#define CAM_EMM_EMM_BUF_132_reg                                                        0xB8011810
+#define CAM_EMM_EMM_BUF_133_reg                                                        0xB8011814
+#define CAM_EMM_EMM_BUF_134_reg                                                        0xB8011818
+#define CAM_EMM_EMM_BUF_135_reg                                                        0xB801181C
+#define CAM_EMM_EMM_BUF_136_reg                                                        0xB8011820
+#define CAM_EMM_EMM_BUF_137_reg                                                        0xB8011824
+#define CAM_EMM_EMM_BUF_138_reg                                                        0xB8011828
+#define CAM_EMM_EMM_BUF_139_reg                                                        0xB801182C
+#define CAM_EMM_EMM_BUF_140_reg                                                        0xB8011830
+#define CAM_EMM_EMM_BUF_141_reg                                                        0xB8011834
+#define CAM_EMM_EMM_BUF_142_reg                                                        0xB8011838
+#define CAM_EMM_EMM_BUF_143_reg                                                        0xB801183C
+#define CAM_EMM_EMM_BUF_144_reg                                                        0xB8011840
+#define CAM_EMM_EMM_BUF_145_reg                                                        0xB8011844
+#define CAM_EMM_EMM_BUF_146_reg                                                        0xB8011848
+#define CAM_EMM_EMM_BUF_147_reg                                                        0xB801184C
+#define CAM_EMM_EMM_BUF_148_reg                                                        0xB8011850
+#define CAM_EMM_EMM_BUF_149_reg                                                        0xB8011854
+#define CAM_EMM_EMM_BUF_150_reg                                                        0xB8011858
+#define CAM_EMM_EMM_BUF_151_reg                                                        0xB801185C
+#define CAM_EMM_EMM_BUF_152_reg                                                        0xB8011860
+#define CAM_EMM_EMM_BUF_153_reg                                                        0xB8011864
+#define CAM_EMM_EMM_BUF_154_reg                                                        0xB8011868
+#define CAM_EMM_EMM_BUF_155_reg                                                        0xB801186C
+#define CAM_EMM_EMM_BUF_156_reg                                                        0xB8011870
+#define CAM_EMM_EMM_BUF_157_reg                                                        0xB8011874
+#define CAM_EMM_EMM_BUF_158_reg                                                        0xB8011878
+#define CAM_EMM_EMM_BUF_159_reg                                                        0xB801187C
+#define CAM_EMM_EMM_BUF_160_reg                                                        0xB8011880
+#define CAM_EMM_EMM_BUF_161_reg                                                        0xB8011884
+#define CAM_EMM_EMM_BUF_162_reg                                                        0xB8011888
+#define CAM_EMM_EMM_BUF_163_reg                                                        0xB801188C
+#define CAM_EMM_EMM_BUF_164_reg                                                        0xB8011890
+#define CAM_EMM_EMM_BUF_165_reg                                                        0xB8011894
+#define CAM_EMM_EMM_BUF_166_reg                                                        0xB8011898
+#define CAM_EMM_EMM_BUF_167_reg                                                        0xB801189C
+#define CAM_EMM_EMM_BUF_168_reg                                                        0xB80118A0
+#define CAM_EMM_EMM_BUF_169_reg                                                        0xB80118A4
+#define CAM_EMM_EMM_BUF_170_reg                                                        0xB80118A8
+#define CAM_EMM_EMM_BUF_171_reg                                                        0xB80118AC
+#define CAM_EMM_EMM_BUF_172_reg                                                        0xB80118B0
+#define CAM_EMM_EMM_BUF_173_reg                                                        0xB80118B4
+#define CAM_EMM_EMM_BUF_174_reg                                                        0xB80118B8
+#define CAM_EMM_EMM_BUF_175_reg                                                        0xB80118BC
+#define CAM_EMM_EMM_BUF_176_reg                                                        0xB80118C0
+#define CAM_EMM_EMM_BUF_177_reg                                                        0xB80118C4
+#define CAM_EMM_EMM_BUF_178_reg                                                        0xB80118C8
+#define CAM_EMM_EMM_BUF_179_reg                                                        0xB80118CC
+#define CAM_EMM_EMM_BUF_180_reg                                                        0xB80118D0
+#define CAM_EMM_EMM_BUF_181_reg                                                        0xB80118D4
+#define CAM_EMM_EMM_BUF_182_reg                                                        0xB80118D8
+#define CAM_EMM_EMM_BUF_183_reg                                                        0xB80118DC
+#define CAM_EMM_EMM_BUF_184_reg                                                        0xB80118E0
+#define CAM_EMM_EMM_BUF_185_reg                                                        0xB80118E4
+#define CAM_EMM_EMM_BUF_186_reg                                                        0xB80118E8
+#define CAM_EMM_EMM_BUF_187_reg                                                        0xB80118EC
+#define CAM_EMM_EMM_BUF_188_reg                                                        0xB80118F0
+#define CAM_EMM_EMM_BUF_189_reg                                                        0xB80118F4
+#define CAM_EMM_EMM_BUF_190_reg                                                        0xB80118F8
+#define CAM_EMM_EMM_BUF_191_reg                                                        0xB80118FC
+#define CAM_EMM_EMM_BUF_192_reg                                                        0xB8011900
+#define CAM_EMM_EMM_BUF_193_reg                                                        0xB8011904
+#define CAM_EMM_EMM_BUF_194_reg                                                        0xB8011908
+#define CAM_EMM_EMM_BUF_195_reg                                                        0xB801190C
+#define CAM_EMM_EMM_BUF_196_reg                                                        0xB8011910
+#define CAM_EMM_EMM_BUF_197_reg                                                        0xB8011914
+#define CAM_EMM_EMM_BUF_198_reg                                                        0xB8011918
+#define CAM_EMM_EMM_BUF_199_reg                                                        0xB801191C
+#define CAM_EMM_EMM_BUF_200_reg                                                        0xB8011920
+#define CAM_EMM_EMM_BUF_201_reg                                                        0xB8011924
+#define CAM_EMM_EMM_BUF_202_reg                                                        0xB8011928
+#define CAM_EMM_EMM_BUF_203_reg                                                        0xB801192C
+#define CAM_EMM_EMM_BUF_204_reg                                                        0xB8011930
+#define CAM_EMM_EMM_BUF_205_reg                                                        0xB8011934
+#define CAM_EMM_EMM_BUF_206_reg                                                        0xB8011938
+#define CAM_EMM_EMM_BUF_207_reg                                                        0xB801193C
+#define CAM_EMM_EMM_BUF_208_reg                                                        0xB8011940
+#define CAM_EMM_EMM_BUF_209_reg                                                        0xB8011944
+#define CAM_EMM_EMM_BUF_210_reg                                                        0xB8011948
+#define CAM_EMM_EMM_BUF_211_reg                                                        0xB801194C
+#define CAM_EMM_EMM_BUF_212_reg                                                        0xB8011950
+#define CAM_EMM_EMM_BUF_213_reg                                                        0xB8011954
+#define CAM_EMM_EMM_BUF_214_reg                                                        0xB8011958
+#define CAM_EMM_EMM_BUF_215_reg                                                        0xB801195C
+#define CAM_EMM_EMM_BUF_216_reg                                                        0xB8011960
+#define CAM_EMM_EMM_BUF_217_reg                                                        0xB8011964
+#define CAM_EMM_EMM_BUF_218_reg                                                        0xB8011968
+#define CAM_EMM_EMM_BUF_219_reg                                                        0xB801196C
+#define CAM_EMM_EMM_BUF_220_reg                                                        0xB8011970
+#define CAM_EMM_EMM_BUF_221_reg                                                        0xB8011974
+#define CAM_EMM_EMM_BUF_222_reg                                                        0xB8011978
+#define CAM_EMM_EMM_BUF_223_reg                                                        0xB801197C
+#define CAM_EMM_EMM_BUF_224_reg                                                        0xB8011980
+#define CAM_EMM_EMM_BUF_225_reg                                                        0xB8011984
+#define CAM_EMM_EMM_BUF_226_reg                                                        0xB8011988
+#define CAM_EMM_EMM_BUF_227_reg                                                        0xB801198C
+#define CAM_EMM_EMM_BUF_228_reg                                                        0xB8011990
+#define CAM_EMM_EMM_BUF_229_reg                                                        0xB8011994
+#define CAM_EMM_EMM_BUF_230_reg                                                        0xB8011998
+#define CAM_EMM_EMM_BUF_231_reg                                                        0xB801199C
+#define CAM_EMM_EMM_BUF_232_reg                                                        0xB80119A0
+#define CAM_EMM_EMM_BUF_233_reg                                                        0xB80119A4
+#define CAM_EMM_EMM_BUF_234_reg                                                        0xB80119A8
+#define CAM_EMM_EMM_BUF_235_reg                                                        0xB80119AC
+#define CAM_EMM_EMM_BUF_236_reg                                                        0xB80119B0
+#define CAM_EMM_EMM_BUF_237_reg                                                        0xB80119B4
+#define CAM_EMM_EMM_BUF_238_reg                                                        0xB80119B8
+#define CAM_EMM_EMM_BUF_239_reg                                                        0xB80119BC
+#define CAM_EMM_EMM_BUF_240_reg                                                        0xB80119C0
+#define CAM_EMM_EMM_BUF_241_reg                                                        0xB80119C4
+#define CAM_EMM_EMM_BUF_242_reg                                                        0xB80119C8
+#define CAM_EMM_EMM_BUF_243_reg                                                        0xB80119CC
+#define CAM_EMM_EMM_BUF_244_reg                                                        0xB80119D0
+#define CAM_EMM_EMM_BUF_245_reg                                                        0xB80119D4
+#define CAM_EMM_EMM_BUF_246_reg                                                        0xB80119D8
+#define CAM_EMM_EMM_BUF_247_reg                                                        0xB80119DC
+#define CAM_EMM_EMM_BUF_248_reg                                                        0xB80119E0
+#define CAM_EMM_EMM_BUF_249_reg                                                        0xB80119E4
+#define CAM_EMM_EMM_BUF_250_reg                                                        0xB80119E8
+#define CAM_EMM_EMM_BUF_251_reg                                                        0xB80119EC
+#define CAM_EMM_EMM_BUF_252_reg                                                        0xB80119F0
+#define CAM_EMM_EMM_BUF_253_reg                                                        0xB80119F4
+#define CAM_EMM_EMM_BUF_254_reg                                                        0xB80119F8
+#define CAM_EMM_EMM_BUF_255_reg                                                        0xB80119FC
+#define CAM_EMM_EMM_BUF_256_reg                                                        0xB8011A00
+#define CAM_EMM_EMM_BUF_257_reg                                                        0xB8011A04
+#define CAM_EMM_EMM_BUF_258_reg                                                        0xB8011A08
+#define CAM_EMM_EMM_BUF_259_reg                                                        0xB8011A0C
+#define CAM_EMM_EMM_BUF_260_reg                                                        0xB8011A10
+#define CAM_EMM_EMM_BUF_261_reg                                                        0xB8011A14
+#define CAM_EMM_EMM_BUF_262_reg                                                        0xB8011A18
+#define CAM_EMM_EMM_BUF_263_reg                                                        0xB8011A1C
+#define CAM_EMM_EMM_BUF_264_reg                                                        0xB8011A20
+#define CAM_EMM_EMM_BUF_265_reg                                                        0xB8011A24
+#define CAM_EMM_EMM_BUF_266_reg                                                        0xB8011A28
+#define CAM_EMM_EMM_BUF_267_reg                                                        0xB8011A2C
+#define CAM_EMM_EMM_BUF_268_reg                                                        0xB8011A30
+#define CAM_EMM_EMM_BUF_269_reg                                                        0xB8011A34
+#define CAM_EMM_EMM_BUF_270_reg                                                        0xB8011A38
+#define CAM_EMM_EMM_BUF_271_reg                                                        0xB8011A3C
+#define CAM_EMM_EMM_BUF_272_reg                                                        0xB8011A40
+#define CAM_EMM_EMM_BUF_273_reg                                                        0xB8011A44
+#define CAM_EMM_EMM_BUF_274_reg                                                        0xB8011A48
+#define CAM_EMM_EMM_BUF_275_reg                                                        0xB8011A4C
+#define CAM_EMM_EMM_BUF_276_reg                                                        0xB8011A50
+#define CAM_EMM_EMM_BUF_277_reg                                                        0xB8011A54
+#define CAM_EMM_EMM_BUF_278_reg                                                        0xB8011A58
+#define CAM_EMM_EMM_BUF_279_reg                                                        0xB8011A5C
+#define CAM_EMM_EMM_BUF_280_reg                                                        0xB8011A60
+#define CAM_EMM_EMM_BUF_281_reg                                                        0xB8011A64
+#define CAM_EMM_EMM_BUF_282_reg                                                        0xB8011A68
+#define CAM_EMM_EMM_BUF_283_reg                                                        0xB8011A6C
+#define CAM_EMM_EMM_BUF_284_reg                                                        0xB8011A70
+#define CAM_EMM_EMM_BUF_285_reg                                                        0xB8011A74
+#define CAM_EMM_EMM_BUF_286_reg                                                        0xB8011A78
+#define CAM_EMM_EMM_BUF_287_reg                                                        0xB8011A7C
+#define CAM_EMM_EMM_BUF_288_reg                                                        0xB8011A80
+#define CAM_EMM_EMM_BUF_289_reg                                                        0xB8011A84
+#define CAM_EMM_EMM_BUF_290_reg                                                        0xB8011A88
+#define CAM_EMM_EMM_BUF_291_reg                                                        0xB8011A8C
+#define CAM_EMM_EMM_BUF_292_reg                                                        0xB8011A90
+#define CAM_EMM_EMM_BUF_293_reg                                                        0xB8011A94
+#define CAM_EMM_EMM_BUF_294_reg                                                        0xB8011A98
+#define CAM_EMM_EMM_BUF_295_reg                                                        0xB8011A9C
+#define CAM_EMM_EMM_BUF_296_reg                                                        0xB8011AA0
+#define CAM_EMM_EMM_BUF_297_reg                                                        0xB8011AA4
+#define CAM_EMM_EMM_BUF_298_reg                                                        0xB8011AA8
+#define CAM_EMM_EMM_BUF_299_reg                                                        0xB8011AAC
+#define CAM_EMM_EMM_BUF_300_reg                                                        0xB8011AB0
+#define CAM_EMM_EMM_BUF_301_reg                                                        0xB8011AB4
+#define CAM_EMM_EMM_BUF_302_reg                                                        0xB8011AB8
+#define CAM_EMM_EMM_BUF_303_reg                                                        0xB8011ABC
+#define CAM_EMM_EMM_BUF_304_reg                                                        0xB8011AC0
+#define CAM_EMM_EMM_BUF_305_reg                                                        0xB8011AC4
+#define CAM_EMM_EMM_BUF_306_reg                                                        0xB8011AC8
+#define CAM_EMM_EMM_BUF_307_reg                                                        0xB8011ACC
+#define CAM_EMM_EMM_BUF_308_reg                                                        0xB8011AD0
+#define CAM_EMM_EMM_BUF_309_reg                                                        0xB8011AD4
+#define CAM_EMM_EMM_BUF_310_reg                                                        0xB8011AD8
+#define CAM_EMM_EMM_BUF_311_reg                                                        0xB8011ADC
+#define CAM_EMM_EMM_BUF_312_reg                                                        0xB8011AE0
+#define CAM_EMM_EMM_BUF_313_reg                                                        0xB8011AE4
+#define CAM_EMM_EMM_BUF_314_reg                                                        0xB8011AE8
+#define CAM_EMM_EMM_BUF_315_reg                                                        0xB8011AEC
+#define CAM_EMM_EMM_BUF_316_reg                                                        0xB8011AF0
+#define CAM_EMM_EMM_BUF_317_reg                                                        0xB8011AF4
+#define CAM_EMM_EMM_BUF_318_reg                                                        0xB8011AF8
+#define CAM_EMM_EMM_BUF_319_reg                                                        0xB8011AFC
+#define CAM_EMM_EMM_BUF_320_reg                                                        0xB8011B00
+#define CAM_EMM_EMM_BUF_321_reg                                                        0xB8011B04
+#define CAM_EMM_EMM_BUF_322_reg                                                        0xB8011B08
+#define CAM_EMM_EMM_BUF_323_reg                                                        0xB8011B0C
+#define CAM_EMM_EMM_BUF_324_reg                                                        0xB8011B10
+#define CAM_EMM_EMM_BUF_325_reg                                                        0xB8011B14
+#define CAM_EMM_EMM_BUF_326_reg                                                        0xB8011B18
+#define CAM_EMM_EMM_BUF_327_reg                                                        0xB8011B1C
+#define CAM_EMM_EMM_BUF_328_reg                                                        0xB8011B20
+#define CAM_EMM_EMM_BUF_329_reg                                                        0xB8011B24
+#define CAM_EMM_EMM_BUF_330_reg                                                        0xB8011B28
+#define CAM_EMM_EMM_BUF_331_reg                                                        0xB8011B2C
+#define CAM_EMM_EMM_BUF_332_reg                                                        0xB8011B30
+#define CAM_EMM_EMM_BUF_333_reg                                                        0xB8011B34
+#define CAM_EMM_EMM_BUF_334_reg                                                        0xB8011B38
+#define CAM_EMM_EMM_BUF_335_reg                                                        0xB8011B3C
+#define CAM_EMM_EMM_BUF_336_reg                                                        0xB8011B40
+#define CAM_EMM_EMM_BUF_337_reg                                                        0xB8011B44
+#define CAM_EMM_EMM_BUF_338_reg                                                        0xB8011B48
+#define CAM_EMM_EMM_BUF_339_reg                                                        0xB8011B4C
+#define CAM_EMM_EMM_BUF_340_reg                                                        0xB8011B50
+#define CAM_EMM_EMM_BUF_341_reg                                                        0xB8011B54
+#define CAM_EMM_EMM_BUF_342_reg                                                        0xB8011B58
+#define CAM_EMM_EMM_BUF_343_reg                                                        0xB8011B5C
+#define CAM_EMM_EMM_BUF_344_reg                                                        0xB8011B60
+#define CAM_EMM_EMM_BUF_345_reg                                                        0xB8011B64
+#define CAM_EMM_EMM_BUF_346_reg                                                        0xB8011B68
+#define CAM_EMM_EMM_BUF_347_reg                                                        0xB8011B6C
+#define CAM_EMM_EMM_BUF_348_reg                                                        0xB8011B70
+#define CAM_EMM_EMM_BUF_349_reg                                                        0xB8011B74
+#define CAM_EMM_EMM_BUF_350_reg                                                        0xB8011B78
+#define CAM_EMM_EMM_BUF_351_reg                                                        0xB8011B7C
+#define CAM_EMM_EMM_BUF_352_reg                                                        0xB8011B80
+#define CAM_EMM_EMM_BUF_353_reg                                                        0xB8011B84
+#define CAM_EMM_EMM_BUF_354_reg                                                        0xB8011B88
+#define CAM_EMM_EMM_BUF_355_reg                                                        0xB8011B8C
+#define CAM_EMM_EMM_BUF_356_reg                                                        0xB8011B90
+#define CAM_EMM_EMM_BUF_357_reg                                                        0xB8011B94
+#define CAM_EMM_EMM_BUF_358_reg                                                        0xB8011B98
+#define CAM_EMM_EMM_BUF_359_reg                                                        0xB8011B9C
+#define CAM_EMM_EMM_BUF_360_reg                                                        0xB8011BA0
+#define CAM_EMM_EMM_BUF_361_reg                                                        0xB8011BA4
+#define CAM_EMM_EMM_BUF_362_reg                                                        0xB8011BA8
+#define CAM_EMM_EMM_BUF_363_reg                                                        0xB8011BAC
+#define CAM_EMM_EMM_BUF_364_reg                                                        0xB8011BB0
+#define CAM_EMM_EMM_BUF_365_reg                                                        0xB8011BB4
+#define CAM_EMM_EMM_BUF_366_reg                                                        0xB8011BB8
+#define CAM_EMM_EMM_BUF_367_reg                                                        0xB8011BBC
+#define CAM_EMM_EMM_BUF_368_reg                                                        0xB8011BC0
+#define CAM_EMM_EMM_BUF_369_reg                                                        0xB8011BC4
+#define CAM_EMM_EMM_BUF_370_reg                                                        0xB8011BC8
+#define CAM_EMM_EMM_BUF_371_reg                                                        0xB8011BCC
+#define CAM_EMM_EMM_BUF_372_reg                                                        0xB8011BD0
+#define CAM_EMM_EMM_BUF_373_reg                                                        0xB8011BD4
+#define CAM_EMM_EMM_BUF_374_reg                                                        0xB8011BD8
+#define CAM_EMM_EMM_BUF_375_reg                                                        0xB8011BDC
+#define CAM_EMM_EMM_BUF_376_reg                                                        0xB8011BE0
+#define CAM_EMM_EMM_BUF_377_reg                                                        0xB8011BE4
+#define CAM_EMM_EMM_BUF_378_reg                                                        0xB8011BE8
+#define CAM_EMM_EMM_BUF_379_reg                                                        0xB8011BEC
+#define CAM_EMM_EMM_BUF_380_reg                                                        0xB8011BF0
+#define CAM_EMM_EMM_BUF_381_reg                                                        0xB8011BF4
+#define CAM_EMM_EMM_BUF_382_reg                                                        0xB8011BF8
+#define CAM_EMM_EMM_BUF_383_reg                                                        0xB8011BFC
+#define CAM_EMM_EMM_BUF_384_reg                                                        0xB8011C00
+#define CAM_EMM_EMM_BUF_385_reg                                                        0xB8011C04
+#define CAM_EMM_EMM_BUF_386_reg                                                        0xB8011C08
+#define CAM_EMM_EMM_BUF_387_reg                                                        0xB8011C0C
+#define CAM_EMM_EMM_BUF_388_reg                                                        0xB8011C10
+#define CAM_EMM_EMM_BUF_389_reg                                                        0xB8011C14
+#define CAM_EMM_EMM_BUF_390_reg                                                        0xB8011C18
+#define CAM_EMM_EMM_BUF_391_reg                                                        0xB8011C1C
+#define CAM_EMM_EMM_BUF_392_reg                                                        0xB8011C20
+#define CAM_EMM_EMM_BUF_393_reg                                                        0xB8011C24
+#define CAM_EMM_EMM_BUF_394_reg                                                        0xB8011C28
+#define CAM_EMM_EMM_BUF_395_reg                                                        0xB8011C2C
+#define CAM_EMM_EMM_BUF_396_reg                                                        0xB8011C30
+#define CAM_EMM_EMM_BUF_397_reg                                                        0xB8011C34
+#define CAM_EMM_EMM_BUF_398_reg                                                        0xB8011C38
+#define CAM_EMM_EMM_BUF_399_reg                                                        0xB8011C3C
+#define CAM_EMM_EMM_BUF_400_reg                                                        0xB8011C40
+#define CAM_EMM_EMM_BUF_401_reg                                                        0xB8011C44
+#define CAM_EMM_EMM_BUF_402_reg                                                        0xB8011C48
+#define CAM_EMM_EMM_BUF_403_reg                                                        0xB8011C4C
+#define CAM_EMM_EMM_BUF_404_reg                                                        0xB8011C50
+#define CAM_EMM_EMM_BUF_405_reg                                                        0xB8011C54
+#define CAM_EMM_EMM_BUF_406_reg                                                        0xB8011C58
+#define CAM_EMM_EMM_BUF_407_reg                                                        0xB8011C5C
+#define CAM_EMM_EMM_BUF_408_reg                                                        0xB8011C60
+#define CAM_EMM_EMM_BUF_409_reg                                                        0xB8011C64
+#define CAM_EMM_EMM_BUF_410_reg                                                        0xB8011C68
+#define CAM_EMM_EMM_BUF_411_reg                                                        0xB8011C6C
+#define CAM_EMM_EMM_BUF_412_reg                                                        0xB8011C70
+#define CAM_EMM_EMM_BUF_413_reg                                                        0xB8011C74
+#define CAM_EMM_EMM_BUF_414_reg                                                        0xB8011C78
+#define CAM_EMM_EMM_BUF_415_reg                                                        0xB8011C7C
+#define CAM_EMM_EMM_BUF_416_reg                                                        0xB8011C80
+#define CAM_EMM_EMM_BUF_417_reg                                                        0xB8011C84
+#define CAM_EMM_EMM_BUF_418_reg                                                        0xB8011C88
+#define CAM_EMM_EMM_BUF_419_reg                                                        0xB8011C8C
+#define CAM_EMM_EMM_BUF_420_reg                                                        0xB8011C90
+#define CAM_EMM_EMM_BUF_421_reg                                                        0xB8011C94
+#define CAM_EMM_EMM_BUF_422_reg                                                        0xB8011C98
+#define CAM_EMM_EMM_BUF_423_reg                                                        0xB8011C9C
+#define CAM_EMM_EMM_BUF_424_reg                                                        0xB8011CA0
+#define CAM_EMM_EMM_BUF_425_reg                                                        0xB8011CA4
+#define CAM_EMM_EMM_BUF_426_reg                                                        0xB8011CA8
+#define CAM_EMM_EMM_BUF_427_reg                                                        0xB8011CAC
+#define CAM_EMM_EMM_BUF_428_reg                                                        0xB8011CB0
+#define CAM_EMM_EMM_BUF_429_reg                                                        0xB8011CB4
+#define CAM_EMM_EMM_BUF_430_reg                                                        0xB8011CB8
+#define CAM_EMM_EMM_BUF_431_reg                                                        0xB8011CBC
+#define CAM_EMM_EMM_BUF_432_reg                                                        0xB8011CC0
+#define CAM_EMM_EMM_BUF_433_reg                                                        0xB8011CC4
+#define CAM_EMM_EMM_BUF_434_reg                                                        0xB8011CC8
+#define CAM_EMM_EMM_BUF_435_reg                                                        0xB8011CCC
+#define CAM_EMM_EMM_BUF_436_reg                                                        0xB8011CD0
+#define CAM_EMM_EMM_BUF_437_reg                                                        0xB8011CD4
+#define CAM_EMM_EMM_BUF_438_reg                                                        0xB8011CD8
+#define CAM_EMM_EMM_BUF_439_reg                                                        0xB8011CDC
+#define CAM_EMM_EMM_BUF_440_reg                                                        0xB8011CE0
+#define CAM_EMM_EMM_BUF_441_reg                                                        0xB8011CE4
+#define CAM_EMM_EMM_BUF_442_reg                                                        0xB8011CE8
+#define CAM_EMM_EMM_BUF_443_reg                                                        0xB8011CEC
+#define CAM_EMM_EMM_BUF_444_reg                                                        0xB8011CF0
+#define CAM_EMM_EMM_BUF_445_reg                                                        0xB8011CF4
+#define CAM_EMM_EMM_BUF_446_reg                                                        0xB8011CF8
+#define CAM_EMM_EMM_BUF_447_reg                                                        0xB8011CFC
+#define CAM_EMM_EMM_BUF_448_reg                                                        0xB8011D00
+#define CAM_EMM_EMM_BUF_449_reg                                                        0xB8011D04
+#define CAM_EMM_EMM_BUF_450_reg                                                        0xB8011D08
+#define CAM_EMM_EMM_BUF_451_reg                                                        0xB8011D0C
+#define CAM_EMM_EMM_BUF_452_reg                                                        0xB8011D10
+#define CAM_EMM_EMM_BUF_453_reg                                                        0xB8011D14
+#define CAM_EMM_EMM_BUF_454_reg                                                        0xB8011D18
+#define CAM_EMM_EMM_BUF_455_reg                                                        0xB8011D1C
+#define CAM_EMM_EMM_BUF_456_reg                                                        0xB8011D20
+#define CAM_EMM_EMM_BUF_457_reg                                                        0xB8011D24
+#define CAM_EMM_EMM_BUF_458_reg                                                        0xB8011D28
+#define CAM_EMM_EMM_BUF_459_reg                                                        0xB8011D2C
+#define CAM_EMM_EMM_BUF_460_reg                                                        0xB8011D30
+#define CAM_EMM_EMM_BUF_461_reg                                                        0xB8011D34
+#define CAM_EMM_EMM_BUF_462_reg                                                        0xB8011D38
+#define CAM_EMM_EMM_BUF_463_reg                                                        0xB8011D3C
+#define CAM_EMM_EMM_BUF_464_reg                                                        0xB8011D40
+#define CAM_EMM_EMM_BUF_465_reg                                                        0xB8011D44
+#define CAM_EMM_EMM_BUF_466_reg                                                        0xB8011D48
+#define CAM_EMM_EMM_BUF_467_reg                                                        0xB8011D4C
+#define CAM_EMM_EMM_BUF_468_reg                                                        0xB8011D50
+#define CAM_EMM_EMM_BUF_469_reg                                                        0xB8011D54
+#define CAM_EMM_EMM_BUF_470_reg                                                        0xB8011D58
+#define CAM_EMM_EMM_BUF_471_reg                                                        0xB8011D5C
+#define CAM_EMM_EMM_BUF_472_reg                                                        0xB8011D60
+#define CAM_EMM_EMM_BUF_473_reg                                                        0xB8011D64
+#define CAM_EMM_EMM_BUF_474_reg                                                        0xB8011D68
+#define CAM_EMM_EMM_BUF_475_reg                                                        0xB8011D6C
+#define CAM_EMM_EMM_BUF_476_reg                                                        0xB8011D70
+#define CAM_EMM_EMM_BUF_477_reg                                                        0xB8011D74
+#define CAM_EMM_EMM_BUF_478_reg                                                        0xB8011D78
+#define CAM_EMM_EMM_BUF_479_reg                                                        0xB8011D7C
+#define CAM_EMM_EMM_BUF_480_reg                                                        0xB8011D80
+#define CAM_EMM_EMM_BUF_481_reg                                                        0xB8011D84
+#define CAM_EMM_EMM_BUF_482_reg                                                        0xB8011D88
+#define CAM_EMM_EMM_BUF_483_reg                                                        0xB8011D8C
+#define CAM_EMM_EMM_BUF_484_reg                                                        0xB8011D90
+#define CAM_EMM_EMM_BUF_485_reg                                                        0xB8011D94
+#define CAM_EMM_EMM_BUF_486_reg                                                        0xB8011D98
+#define CAM_EMM_EMM_BUF_487_reg                                                        0xB8011D9C
+#define CAM_EMM_EMM_BUF_488_reg                                                        0xB8011DA0
+#define CAM_EMM_EMM_BUF_489_reg                                                        0xB8011DA4
+#define CAM_EMM_EMM_BUF_490_reg                                                        0xB8011DA8
+#define CAM_EMM_EMM_BUF_491_reg                                                        0xB8011DAC
+#define CAM_EMM_EMM_BUF_492_reg                                                        0xB8011DB0
+#define CAM_EMM_EMM_BUF_493_reg                                                        0xB8011DB4
+#define CAM_EMM_EMM_BUF_494_reg                                                        0xB8011DB8
+#define CAM_EMM_EMM_BUF_495_reg                                                        0xB8011DBC
+#define CAM_EMM_EMM_BUF_496_reg                                                        0xB8011DC0
+#define CAM_EMM_EMM_BUF_497_reg                                                        0xB8011DC4
+#define CAM_EMM_EMM_BUF_498_reg                                                        0xB8011DC8
+#define CAM_EMM_EMM_BUF_499_reg                                                        0xB8011DCC
+#define CAM_EMM_EMM_BUF_500_reg                                                        0xB8011DD0
+#define CAM_EMM_EMM_BUF_501_reg                                                        0xB8011DD4
+#define CAM_EMM_EMM_BUF_502_reg                                                        0xB8011DD8
+#define CAM_EMM_EMM_BUF_503_reg                                                        0xB8011DDC
+#define CAM_EMM_EMM_BUF_504_reg                                                        0xB8011DE0
+#define CAM_EMM_EMM_BUF_505_reg                                                        0xB8011DE4
+#define CAM_EMM_EMM_BUF_506_reg                                                        0xB8011DE8
+#define CAM_EMM_EMM_BUF_507_reg                                                        0xB8011DEC
+#define CAM_EMM_EMM_BUF_508_reg                                                        0xB8011DF0
+#define CAM_EMM_EMM_BUF_509_reg                                                        0xB8011DF4
+#define CAM_EMM_EMM_BUF_510_reg                                                        0xB8011DF8
+#define CAM_EMM_EMM_BUF_511_reg                                                        0xB8011DFC
+#define CAM_EMM_EMM_BUF_512_reg                                                        0xB8011E00
+#define CAM_EMM_EMM_BUF_513_reg                                                        0xB8011E04
+#define CAM_EMM_EMM_BUF_514_reg                                                        0xB8011E08
+#define CAM_EMM_EMM_BUF_515_reg                                                        0xB8011E0C
+#define CAM_EMM_EMM_BUF_516_reg                                                        0xB8011E10
+#define CAM_EMM_EMM_BUF_517_reg                                                        0xB8011E14
+#define CAM_EMM_EMM_BUF_518_reg                                                        0xB8011E18
+#define CAM_EMM_EMM_BUF_519_reg                                                        0xB8011E1C
+#define CAM_EMM_EMM_BUF_520_reg                                                        0xB8011E20
+#define CAM_EMM_EMM_BUF_521_reg                                                        0xB8011E24
+#define CAM_EMM_EMM_BUF_522_reg                                                        0xB8011E28
+#define CAM_EMM_EMM_BUF_523_reg                                                        0xB8011E2C
+#define CAM_EMM_EMM_BUF_524_reg                                                        0xB8011E30
+#define CAM_EMM_EMM_BUF_525_reg                                                        0xB8011E34
+#define CAM_EMM_EMM_BUF_526_reg                                                        0xB8011E38
+#define CAM_EMM_EMM_BUF_527_reg                                                        0xB8011E3C
+#define CAM_EMM_EMM_BUF_528_reg                                                        0xB8011E40
+#define CAM_EMM_EMM_BUF_529_reg                                                        0xB8011E44
+#define CAM_EMM_EMM_BUF_530_reg                                                        0xB8011E48
+#define CAM_EMM_EMM_BUF_531_reg                                                        0xB8011E4C
+#define CAM_EMM_EMM_BUF_532_reg                                                        0xB8011E50
+#define CAM_EMM_EMM_BUF_533_reg                                                        0xB8011E54
+#define CAM_EMM_EMM_BUF_534_reg                                                        0xB8011E58
+#define CAM_EMM_EMM_BUF_535_reg                                                        0xB8011E5C
+#define CAM_EMM_EMM_BUF_536_reg                                                        0xB8011E60
+#define CAM_EMM_EMM_BUF_537_reg                                                        0xB8011E64
+#define CAM_EMM_EMM_BUF_538_reg                                                        0xB8011E68
+#define CAM_EMM_EMM_BUF_539_reg                                                        0xB8011E6C
+#define CAM_EMM_EMM_BUF_540_reg                                                        0xB8011E70
+#define CAM_EMM_EMM_BUF_541_reg                                                        0xB8011E74
+#define CAM_EMM_EMM_BUF_542_reg                                                        0xB8011E78
+#define CAM_EMM_EMM_BUF_543_reg                                                        0xB8011E7C
+#define CAM_EMM_EMM_BUF_544_reg                                                        0xB8011E80
+#define CAM_EMM_EMM_BUF_545_reg                                                        0xB8011E84
+#define CAM_EMM_EMM_BUF_546_reg                                                        0xB8011E88
+#define CAM_EMM_EMM_BUF_547_reg                                                        0xB8011E8C
+#define CAM_EMM_EMM_BUF_548_reg                                                        0xB8011E90
+#define CAM_EMM_EMM_BUF_549_reg                                                        0xB8011E94
+#define CAM_EMM_EMM_BUF_550_reg                                                        0xB8011E98
+#define CAM_EMM_EMM_BUF_551_reg                                                        0xB8011E9C
+#define CAM_EMM_EMM_BUF_552_reg                                                        0xB8011EA0
+#define CAM_EMM_EMM_BUF_553_reg                                                        0xB8011EA4
+#define CAM_EMM_EMM_BUF_554_reg                                                        0xB8011EA8
+#define CAM_EMM_EMM_BUF_555_reg                                                        0xB8011EAC
+#define CAM_EMM_EMM_BUF_556_reg                                                        0xB8011EB0
+#define CAM_EMM_EMM_BUF_557_reg                                                        0xB8011EB4
+#define CAM_EMM_EMM_BUF_558_reg                                                        0xB8011EB8
+#define CAM_EMM_EMM_BUF_559_reg                                                        0xB8011EBC
+#define CAM_EMM_EMM_BUF_560_reg                                                        0xB8011EC0
+#define CAM_EMM_EMM_BUF_561_reg                                                        0xB8011EC4
+#define CAM_EMM_EMM_BUF_562_reg                                                        0xB8011EC8
+#define CAM_EMM_EMM_BUF_563_reg                                                        0xB8011ECC
+#define CAM_EMM_EMM_BUF_564_reg                                                        0xB8011ED0
+#define CAM_EMM_EMM_BUF_565_reg                                                        0xB8011ED4
+#define CAM_EMM_EMM_BUF_566_reg                                                        0xB8011ED8
+#define CAM_EMM_EMM_BUF_567_reg                                                        0xB8011EDC
+#define CAM_EMM_EMM_BUF_568_reg                                                        0xB8011EE0
+#define CAM_EMM_EMM_BUF_569_reg                                                        0xB8011EE4
+#define CAM_EMM_EMM_BUF_570_reg                                                        0xB8011EE8
+#define CAM_EMM_EMM_BUF_571_reg                                                        0xB8011EEC
+#define CAM_EMM_EMM_BUF_572_reg                                                        0xB8011EF0
+#define CAM_EMM_EMM_BUF_573_reg                                                        0xB8011EF4
+#define CAM_EMM_EMM_BUF_574_reg                                                        0xB8011EF8
+#define CAM_EMM_EMM_BUF_575_reg                                                        0xB8011EFC
+#define CAM_EMM_EMM_BUF_576_reg                                                        0xB8011F00
+#define CAM_EMM_EMM_BUF_577_reg                                                        0xB8011F04
+#define CAM_EMM_EMM_BUF_578_reg                                                        0xB8011F08
+#define CAM_EMM_EMM_BUF_579_reg                                                        0xB8011F0C
+#define CAM_EMM_EMM_BUF_580_reg                                                        0xB8011F10
+#define CAM_EMM_EMM_BUF_581_reg                                                        0xB8011F14
+#define CAM_EMM_EMM_BUF_582_reg                                                        0xB8011F18
+#define CAM_EMM_EMM_BUF_583_reg                                                        0xB8011F1C
+#define CAM_EMM_EMM_BUF_584_reg                                                        0xB8011F20
+#define CAM_EMM_EMM_BUF_585_reg                                                        0xB8011F24
+#define CAM_EMM_EMM_BUF_586_reg                                                        0xB8011F28
+#define CAM_EMM_EMM_BUF_587_reg                                                        0xB8011F2C
+#define CAM_EMM_EMM_BUF_588_reg                                                        0xB8011F30
+#define CAM_EMM_EMM_BUF_589_reg                                                        0xB8011F34
+#define CAM_EMM_EMM_BUF_590_reg                                                        0xB8011F38
+#define CAM_EMM_EMM_BUF_591_reg                                                        0xB8011F3C
+#define CAM_EMM_EMM_BUF_592_reg                                                        0xB8011F40
+#define CAM_EMM_EMM_BUF_593_reg                                                        0xB8011F44
+#define CAM_EMM_EMM_BUF_594_reg                                                        0xB8011F48
+#define CAM_EMM_EMM_BUF_595_reg                                                        0xB8011F4C
+#define CAM_EMM_EMM_BUF_596_reg                                                        0xB8011F50
+#define CAM_EMM_EMM_BUF_597_reg                                                        0xB8011F54
+#define CAM_EMM_EMM_BUF_598_reg                                                        0xB8011F58
+#define CAM_EMM_EMM_BUF_599_reg                                                        0xB8011F5C
+#define CAM_EMM_EMM_BUF_600_reg                                                        0xB8011F60
+#define CAM_EMM_EMM_BUF_601_reg                                                        0xB8011F64
+#define CAM_EMM_EMM_BUF_602_reg                                                        0xB8011F68
+#define CAM_EMM_EMM_BUF_603_reg                                                        0xB8011F6C
+#define CAM_EMM_EMM_BUF_604_reg                                                        0xB8011F70
+#define CAM_EMM_EMM_BUF_605_reg                                                        0xB8011F74
+#define CAM_EMM_EMM_BUF_606_reg                                                        0xB8011F78
+#define CAM_EMM_EMM_BUF_607_reg                                                        0xB8011F7C
+#define CAM_EMM_EMM_BUF_608_reg                                                        0xB8011F80
+#define CAM_EMM_EMM_BUF_609_reg                                                        0xB8011F84
+#define CAM_EMM_EMM_BUF_610_reg                                                        0xB8011F88
+#define CAM_EMM_EMM_BUF_611_reg                                                        0xB8011F8C
+#define CAM_EMM_EMM_BUF_612_reg                                                        0xB8011F90
+#define CAM_EMM_EMM_BUF_613_reg                                                        0xB8011F94
+#define CAM_EMM_EMM_BUF_614_reg                                                        0xB8011F98
+#define CAM_EMM_EMM_BUF_615_reg                                                        0xB8011F9C
+#define CAM_EMM_EMM_BUF_616_reg                                                        0xB8011FA0
+#define CAM_EMM_EMM_BUF_617_reg                                                        0xB8011FA4
+#define CAM_EMM_EMM_BUF_618_reg                                                        0xB8011FA8
+#define CAM_EMM_EMM_BUF_619_reg                                                        0xB8011FAC
+#define CAM_EMM_EMM_BUF_620_reg                                                        0xB8011FB0
+#define CAM_EMM_EMM_BUF_621_reg                                                        0xB8011FB4
+#define CAM_EMM_EMM_BUF_622_reg                                                        0xB8011FB8
+#define CAM_EMM_EMM_BUF_623_reg                                                        0xB8011FBC
+#define CAM_EMM_EMM_BUF_624_reg                                                        0xB8011FC0
+#define CAM_EMM_EMM_BUF_625_reg                                                        0xB8011FC4
+#define CAM_EMM_EMM_BUF_626_reg                                                        0xB8011FC8
+#define CAM_EMM_EMM_BUF_627_reg                                                        0xB8011FCC
+#define CAM_EMM_EMM_BUF_628_reg                                                        0xB8011FD0
+#define CAM_EMM_EMM_BUF_629_reg                                                        0xB8011FD4
+#define CAM_EMM_EMM_BUF_630_reg                                                        0xB8011FD8
+#define CAM_EMM_EMM_BUF_631_reg                                                        0xB8011FDC
+#define CAM_EMM_EMM_BUF_632_reg                                                        0xB8011FE0
+#define CAM_EMM_EMM_BUF_633_reg                                                        0xB8011FE4
+#define CAM_EMM_EMM_BUF_634_reg                                                        0xB8011FE8
+#define CAM_EMM_EMM_BUF_635_reg                                                        0xB8011FEC
+#define CAM_EMM_EMM_BUF_636_reg                                                        0xB8011FF0
+#define CAM_EMM_EMM_BUF_637_reg                                                        0xB8011FF4
+#define CAM_EMM_EMM_BUF_638_reg                                                        0xB8011FF8
+#define CAM_EMM_EMM_BUF_639_reg                                                        0xB8011FFC
+#define set_CAM_EMM_EMM_BUF_0_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_0_reg)=data)
+#define set_CAM_EMM_EMM_BUF_1_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_1_reg)=data)
+#define set_CAM_EMM_EMM_BUF_2_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_2_reg)=data)
+#define set_CAM_EMM_EMM_BUF_3_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_3_reg)=data)
+#define set_CAM_EMM_EMM_BUF_4_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_4_reg)=data)
+#define set_CAM_EMM_EMM_BUF_5_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_5_reg)=data)
+#define set_CAM_EMM_EMM_BUF_6_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_6_reg)=data)
+#define set_CAM_EMM_EMM_BUF_7_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_7_reg)=data)
+#define set_CAM_EMM_EMM_BUF_8_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_8_reg)=data)
+#define set_CAM_EMM_EMM_BUF_9_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_9_reg)=data)
+#define set_CAM_EMM_EMM_BUF_10_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_10_reg)=data)
+#define set_CAM_EMM_EMM_BUF_11_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_11_reg)=data)
+#define set_CAM_EMM_EMM_BUF_12_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_12_reg)=data)
+#define set_CAM_EMM_EMM_BUF_13_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_13_reg)=data)
+#define set_CAM_EMM_EMM_BUF_14_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_14_reg)=data)
+#define set_CAM_EMM_EMM_BUF_15_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_15_reg)=data)
+#define set_CAM_EMM_EMM_BUF_16_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_16_reg)=data)
+#define set_CAM_EMM_EMM_BUF_17_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_17_reg)=data)
+#define set_CAM_EMM_EMM_BUF_18_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_18_reg)=data)
+#define set_CAM_EMM_EMM_BUF_19_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_19_reg)=data)
+#define set_CAM_EMM_EMM_BUF_20_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_20_reg)=data)
+#define set_CAM_EMM_EMM_BUF_21_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_21_reg)=data)
+#define set_CAM_EMM_EMM_BUF_22_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_22_reg)=data)
+#define set_CAM_EMM_EMM_BUF_23_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_23_reg)=data)
+#define set_CAM_EMM_EMM_BUF_24_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_24_reg)=data)
+#define set_CAM_EMM_EMM_BUF_25_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_25_reg)=data)
+#define set_CAM_EMM_EMM_BUF_26_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_26_reg)=data)
+#define set_CAM_EMM_EMM_BUF_27_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_27_reg)=data)
+#define set_CAM_EMM_EMM_BUF_28_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_28_reg)=data)
+#define set_CAM_EMM_EMM_BUF_29_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_29_reg)=data)
+#define set_CAM_EMM_EMM_BUF_30_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_30_reg)=data)
+#define set_CAM_EMM_EMM_BUF_31_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_31_reg)=data)
+#define set_CAM_EMM_EMM_BUF_32_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_32_reg)=data)
+#define set_CAM_EMM_EMM_BUF_33_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_33_reg)=data)
+#define set_CAM_EMM_EMM_BUF_34_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_34_reg)=data)
+#define set_CAM_EMM_EMM_BUF_35_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_35_reg)=data)
+#define set_CAM_EMM_EMM_BUF_36_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_36_reg)=data)
+#define set_CAM_EMM_EMM_BUF_37_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_37_reg)=data)
+#define set_CAM_EMM_EMM_BUF_38_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_38_reg)=data)
+#define set_CAM_EMM_EMM_BUF_39_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_39_reg)=data)
+#define set_CAM_EMM_EMM_BUF_40_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_40_reg)=data)
+#define set_CAM_EMM_EMM_BUF_41_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_41_reg)=data)
+#define set_CAM_EMM_EMM_BUF_42_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_42_reg)=data)
+#define set_CAM_EMM_EMM_BUF_43_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_43_reg)=data)
+#define set_CAM_EMM_EMM_BUF_44_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_44_reg)=data)
+#define set_CAM_EMM_EMM_BUF_45_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_45_reg)=data)
+#define set_CAM_EMM_EMM_BUF_46_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_46_reg)=data)
+#define set_CAM_EMM_EMM_BUF_47_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_47_reg)=data)
+#define set_CAM_EMM_EMM_BUF_48_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_48_reg)=data)
+#define set_CAM_EMM_EMM_BUF_49_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_49_reg)=data)
+#define set_CAM_EMM_EMM_BUF_50_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_50_reg)=data)
+#define set_CAM_EMM_EMM_BUF_51_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_51_reg)=data)
+#define set_CAM_EMM_EMM_BUF_52_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_52_reg)=data)
+#define set_CAM_EMM_EMM_BUF_53_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_53_reg)=data)
+#define set_CAM_EMM_EMM_BUF_54_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_54_reg)=data)
+#define set_CAM_EMM_EMM_BUF_55_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_55_reg)=data)
+#define set_CAM_EMM_EMM_BUF_56_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_56_reg)=data)
+#define set_CAM_EMM_EMM_BUF_57_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_57_reg)=data)
+#define set_CAM_EMM_EMM_BUF_58_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_58_reg)=data)
+#define set_CAM_EMM_EMM_BUF_59_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_59_reg)=data)
+#define set_CAM_EMM_EMM_BUF_60_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_60_reg)=data)
+#define set_CAM_EMM_EMM_BUF_61_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_61_reg)=data)
+#define set_CAM_EMM_EMM_BUF_62_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_62_reg)=data)
+#define set_CAM_EMM_EMM_BUF_63_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_63_reg)=data)
+#define set_CAM_EMM_EMM_BUF_64_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_64_reg)=data)
+#define set_CAM_EMM_EMM_BUF_65_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_65_reg)=data)
+#define set_CAM_EMM_EMM_BUF_66_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_66_reg)=data)
+#define set_CAM_EMM_EMM_BUF_67_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_67_reg)=data)
+#define set_CAM_EMM_EMM_BUF_68_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_68_reg)=data)
+#define set_CAM_EMM_EMM_BUF_69_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_69_reg)=data)
+#define set_CAM_EMM_EMM_BUF_70_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_70_reg)=data)
+#define set_CAM_EMM_EMM_BUF_71_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_71_reg)=data)
+#define set_CAM_EMM_EMM_BUF_72_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_72_reg)=data)
+#define set_CAM_EMM_EMM_BUF_73_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_73_reg)=data)
+#define set_CAM_EMM_EMM_BUF_74_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_74_reg)=data)
+#define set_CAM_EMM_EMM_BUF_75_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_75_reg)=data)
+#define set_CAM_EMM_EMM_BUF_76_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_76_reg)=data)
+#define set_CAM_EMM_EMM_BUF_77_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_77_reg)=data)
+#define set_CAM_EMM_EMM_BUF_78_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_78_reg)=data)
+#define set_CAM_EMM_EMM_BUF_79_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_79_reg)=data)
+#define set_CAM_EMM_EMM_BUF_80_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_80_reg)=data)
+#define set_CAM_EMM_EMM_BUF_81_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_81_reg)=data)
+#define set_CAM_EMM_EMM_BUF_82_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_82_reg)=data)
+#define set_CAM_EMM_EMM_BUF_83_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_83_reg)=data)
+#define set_CAM_EMM_EMM_BUF_84_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_84_reg)=data)
+#define set_CAM_EMM_EMM_BUF_85_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_85_reg)=data)
+#define set_CAM_EMM_EMM_BUF_86_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_86_reg)=data)
+#define set_CAM_EMM_EMM_BUF_87_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_87_reg)=data)
+#define set_CAM_EMM_EMM_BUF_88_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_88_reg)=data)
+#define set_CAM_EMM_EMM_BUF_89_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_89_reg)=data)
+#define set_CAM_EMM_EMM_BUF_90_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_90_reg)=data)
+#define set_CAM_EMM_EMM_BUF_91_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_91_reg)=data)
+#define set_CAM_EMM_EMM_BUF_92_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_92_reg)=data)
+#define set_CAM_EMM_EMM_BUF_93_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_93_reg)=data)
+#define set_CAM_EMM_EMM_BUF_94_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_94_reg)=data)
+#define set_CAM_EMM_EMM_BUF_95_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_95_reg)=data)
+#define set_CAM_EMM_EMM_BUF_96_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_96_reg)=data)
+#define set_CAM_EMM_EMM_BUF_97_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_97_reg)=data)
+#define set_CAM_EMM_EMM_BUF_98_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_98_reg)=data)
+#define set_CAM_EMM_EMM_BUF_99_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_99_reg)=data)
+#define set_CAM_EMM_EMM_BUF_100_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_100_reg)=data)
+#define set_CAM_EMM_EMM_BUF_101_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_101_reg)=data)
+#define set_CAM_EMM_EMM_BUF_102_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_102_reg)=data)
+#define set_CAM_EMM_EMM_BUF_103_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_103_reg)=data)
+#define set_CAM_EMM_EMM_BUF_104_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_104_reg)=data)
+#define set_CAM_EMM_EMM_BUF_105_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_105_reg)=data)
+#define set_CAM_EMM_EMM_BUF_106_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_106_reg)=data)
+#define set_CAM_EMM_EMM_BUF_107_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_107_reg)=data)
+#define set_CAM_EMM_EMM_BUF_108_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_108_reg)=data)
+#define set_CAM_EMM_EMM_BUF_109_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_109_reg)=data)
+#define set_CAM_EMM_EMM_BUF_110_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_110_reg)=data)
+#define set_CAM_EMM_EMM_BUF_111_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_111_reg)=data)
+#define set_CAM_EMM_EMM_BUF_112_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_112_reg)=data)
+#define set_CAM_EMM_EMM_BUF_113_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_113_reg)=data)
+#define set_CAM_EMM_EMM_BUF_114_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_114_reg)=data)
+#define set_CAM_EMM_EMM_BUF_115_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_115_reg)=data)
+#define set_CAM_EMM_EMM_BUF_116_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_116_reg)=data)
+#define set_CAM_EMM_EMM_BUF_117_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_117_reg)=data)
+#define set_CAM_EMM_EMM_BUF_118_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_118_reg)=data)
+#define set_CAM_EMM_EMM_BUF_119_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_119_reg)=data)
+#define set_CAM_EMM_EMM_BUF_120_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_120_reg)=data)
+#define set_CAM_EMM_EMM_BUF_121_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_121_reg)=data)
+#define set_CAM_EMM_EMM_BUF_122_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_122_reg)=data)
+#define set_CAM_EMM_EMM_BUF_123_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_123_reg)=data)
+#define set_CAM_EMM_EMM_BUF_124_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_124_reg)=data)
+#define set_CAM_EMM_EMM_BUF_125_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_125_reg)=data)
+#define set_CAM_EMM_EMM_BUF_126_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_126_reg)=data)
+#define set_CAM_EMM_EMM_BUF_127_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_127_reg)=data)
+#define set_CAM_EMM_EMM_BUF_128_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_128_reg)=data)
+#define set_CAM_EMM_EMM_BUF_129_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_129_reg)=data)
+#define set_CAM_EMM_EMM_BUF_130_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_130_reg)=data)
+#define set_CAM_EMM_EMM_BUF_131_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_131_reg)=data)
+#define set_CAM_EMM_EMM_BUF_132_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_132_reg)=data)
+#define set_CAM_EMM_EMM_BUF_133_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_133_reg)=data)
+#define set_CAM_EMM_EMM_BUF_134_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_134_reg)=data)
+#define set_CAM_EMM_EMM_BUF_135_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_135_reg)=data)
+#define set_CAM_EMM_EMM_BUF_136_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_136_reg)=data)
+#define set_CAM_EMM_EMM_BUF_137_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_137_reg)=data)
+#define set_CAM_EMM_EMM_BUF_138_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_138_reg)=data)
+#define set_CAM_EMM_EMM_BUF_139_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_139_reg)=data)
+#define set_CAM_EMM_EMM_BUF_140_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_140_reg)=data)
+#define set_CAM_EMM_EMM_BUF_141_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_141_reg)=data)
+#define set_CAM_EMM_EMM_BUF_142_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_142_reg)=data)
+#define set_CAM_EMM_EMM_BUF_143_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_143_reg)=data)
+#define set_CAM_EMM_EMM_BUF_144_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_144_reg)=data)
+#define set_CAM_EMM_EMM_BUF_145_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_145_reg)=data)
+#define set_CAM_EMM_EMM_BUF_146_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_146_reg)=data)
+#define set_CAM_EMM_EMM_BUF_147_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_147_reg)=data)
+#define set_CAM_EMM_EMM_BUF_148_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_148_reg)=data)
+#define set_CAM_EMM_EMM_BUF_149_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_149_reg)=data)
+#define set_CAM_EMM_EMM_BUF_150_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_150_reg)=data)
+#define set_CAM_EMM_EMM_BUF_151_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_151_reg)=data)
+#define set_CAM_EMM_EMM_BUF_152_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_152_reg)=data)
+#define set_CAM_EMM_EMM_BUF_153_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_153_reg)=data)
+#define set_CAM_EMM_EMM_BUF_154_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_154_reg)=data)
+#define set_CAM_EMM_EMM_BUF_155_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_155_reg)=data)
+#define set_CAM_EMM_EMM_BUF_156_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_156_reg)=data)
+#define set_CAM_EMM_EMM_BUF_157_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_157_reg)=data)
+#define set_CAM_EMM_EMM_BUF_158_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_158_reg)=data)
+#define set_CAM_EMM_EMM_BUF_159_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_159_reg)=data)
+#define set_CAM_EMM_EMM_BUF_160_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_160_reg)=data)
+#define set_CAM_EMM_EMM_BUF_161_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_161_reg)=data)
+#define set_CAM_EMM_EMM_BUF_162_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_162_reg)=data)
+#define set_CAM_EMM_EMM_BUF_163_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_163_reg)=data)
+#define set_CAM_EMM_EMM_BUF_164_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_164_reg)=data)
+#define set_CAM_EMM_EMM_BUF_165_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_165_reg)=data)
+#define set_CAM_EMM_EMM_BUF_166_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_166_reg)=data)
+#define set_CAM_EMM_EMM_BUF_167_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_167_reg)=data)
+#define set_CAM_EMM_EMM_BUF_168_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_168_reg)=data)
+#define set_CAM_EMM_EMM_BUF_169_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_169_reg)=data)
+#define set_CAM_EMM_EMM_BUF_170_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_170_reg)=data)
+#define set_CAM_EMM_EMM_BUF_171_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_171_reg)=data)
+#define set_CAM_EMM_EMM_BUF_172_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_172_reg)=data)
+#define set_CAM_EMM_EMM_BUF_173_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_173_reg)=data)
+#define set_CAM_EMM_EMM_BUF_174_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_174_reg)=data)
+#define set_CAM_EMM_EMM_BUF_175_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_175_reg)=data)
+#define set_CAM_EMM_EMM_BUF_176_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_176_reg)=data)
+#define set_CAM_EMM_EMM_BUF_177_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_177_reg)=data)
+#define set_CAM_EMM_EMM_BUF_178_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_178_reg)=data)
+#define set_CAM_EMM_EMM_BUF_179_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_179_reg)=data)
+#define set_CAM_EMM_EMM_BUF_180_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_180_reg)=data)
+#define set_CAM_EMM_EMM_BUF_181_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_181_reg)=data)
+#define set_CAM_EMM_EMM_BUF_182_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_182_reg)=data)
+#define set_CAM_EMM_EMM_BUF_183_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_183_reg)=data)
+#define set_CAM_EMM_EMM_BUF_184_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_184_reg)=data)
+#define set_CAM_EMM_EMM_BUF_185_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_185_reg)=data)
+#define set_CAM_EMM_EMM_BUF_186_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_186_reg)=data)
+#define set_CAM_EMM_EMM_BUF_187_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_187_reg)=data)
+#define set_CAM_EMM_EMM_BUF_188_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_188_reg)=data)
+#define set_CAM_EMM_EMM_BUF_189_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_189_reg)=data)
+#define set_CAM_EMM_EMM_BUF_190_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_190_reg)=data)
+#define set_CAM_EMM_EMM_BUF_191_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_191_reg)=data)
+#define set_CAM_EMM_EMM_BUF_192_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_192_reg)=data)
+#define set_CAM_EMM_EMM_BUF_193_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_193_reg)=data)
+#define set_CAM_EMM_EMM_BUF_194_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_194_reg)=data)
+#define set_CAM_EMM_EMM_BUF_195_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_195_reg)=data)
+#define set_CAM_EMM_EMM_BUF_196_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_196_reg)=data)
+#define set_CAM_EMM_EMM_BUF_197_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_197_reg)=data)
+#define set_CAM_EMM_EMM_BUF_198_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_198_reg)=data)
+#define set_CAM_EMM_EMM_BUF_199_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_199_reg)=data)
+#define set_CAM_EMM_EMM_BUF_200_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_200_reg)=data)
+#define set_CAM_EMM_EMM_BUF_201_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_201_reg)=data)
+#define set_CAM_EMM_EMM_BUF_202_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_202_reg)=data)
+#define set_CAM_EMM_EMM_BUF_203_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_203_reg)=data)
+#define set_CAM_EMM_EMM_BUF_204_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_204_reg)=data)
+#define set_CAM_EMM_EMM_BUF_205_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_205_reg)=data)
+#define set_CAM_EMM_EMM_BUF_206_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_206_reg)=data)
+#define set_CAM_EMM_EMM_BUF_207_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_207_reg)=data)
+#define set_CAM_EMM_EMM_BUF_208_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_208_reg)=data)
+#define set_CAM_EMM_EMM_BUF_209_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_209_reg)=data)
+#define set_CAM_EMM_EMM_BUF_210_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_210_reg)=data)
+#define set_CAM_EMM_EMM_BUF_211_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_211_reg)=data)
+#define set_CAM_EMM_EMM_BUF_212_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_212_reg)=data)
+#define set_CAM_EMM_EMM_BUF_213_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_213_reg)=data)
+#define set_CAM_EMM_EMM_BUF_214_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_214_reg)=data)
+#define set_CAM_EMM_EMM_BUF_215_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_215_reg)=data)
+#define set_CAM_EMM_EMM_BUF_216_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_216_reg)=data)
+#define set_CAM_EMM_EMM_BUF_217_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_217_reg)=data)
+#define set_CAM_EMM_EMM_BUF_218_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_218_reg)=data)
+#define set_CAM_EMM_EMM_BUF_219_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_219_reg)=data)
+#define set_CAM_EMM_EMM_BUF_220_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_220_reg)=data)
+#define set_CAM_EMM_EMM_BUF_221_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_221_reg)=data)
+#define set_CAM_EMM_EMM_BUF_222_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_222_reg)=data)
+#define set_CAM_EMM_EMM_BUF_223_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_223_reg)=data)
+#define set_CAM_EMM_EMM_BUF_224_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_224_reg)=data)
+#define set_CAM_EMM_EMM_BUF_225_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_225_reg)=data)
+#define set_CAM_EMM_EMM_BUF_226_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_226_reg)=data)
+#define set_CAM_EMM_EMM_BUF_227_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_227_reg)=data)
+#define set_CAM_EMM_EMM_BUF_228_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_228_reg)=data)
+#define set_CAM_EMM_EMM_BUF_229_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_229_reg)=data)
+#define set_CAM_EMM_EMM_BUF_230_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_230_reg)=data)
+#define set_CAM_EMM_EMM_BUF_231_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_231_reg)=data)
+#define set_CAM_EMM_EMM_BUF_232_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_232_reg)=data)
+#define set_CAM_EMM_EMM_BUF_233_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_233_reg)=data)
+#define set_CAM_EMM_EMM_BUF_234_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_234_reg)=data)
+#define set_CAM_EMM_EMM_BUF_235_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_235_reg)=data)
+#define set_CAM_EMM_EMM_BUF_236_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_236_reg)=data)
+#define set_CAM_EMM_EMM_BUF_237_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_237_reg)=data)
+#define set_CAM_EMM_EMM_BUF_238_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_238_reg)=data)
+#define set_CAM_EMM_EMM_BUF_239_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_239_reg)=data)
+#define set_CAM_EMM_EMM_BUF_240_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_240_reg)=data)
+#define set_CAM_EMM_EMM_BUF_241_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_241_reg)=data)
+#define set_CAM_EMM_EMM_BUF_242_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_242_reg)=data)
+#define set_CAM_EMM_EMM_BUF_243_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_243_reg)=data)
+#define set_CAM_EMM_EMM_BUF_244_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_244_reg)=data)
+#define set_CAM_EMM_EMM_BUF_245_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_245_reg)=data)
+#define set_CAM_EMM_EMM_BUF_246_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_246_reg)=data)
+#define set_CAM_EMM_EMM_BUF_247_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_247_reg)=data)
+#define set_CAM_EMM_EMM_BUF_248_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_248_reg)=data)
+#define set_CAM_EMM_EMM_BUF_249_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_249_reg)=data)
+#define set_CAM_EMM_EMM_BUF_250_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_250_reg)=data)
+#define set_CAM_EMM_EMM_BUF_251_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_251_reg)=data)
+#define set_CAM_EMM_EMM_BUF_252_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_252_reg)=data)
+#define set_CAM_EMM_EMM_BUF_253_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_253_reg)=data)
+#define set_CAM_EMM_EMM_BUF_254_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_254_reg)=data)
+#define set_CAM_EMM_EMM_BUF_255_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_255_reg)=data)
+#define set_CAM_EMM_EMM_BUF_256_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_256_reg)=data)
+#define set_CAM_EMM_EMM_BUF_257_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_257_reg)=data)
+#define set_CAM_EMM_EMM_BUF_258_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_258_reg)=data)
+#define set_CAM_EMM_EMM_BUF_259_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_259_reg)=data)
+#define set_CAM_EMM_EMM_BUF_260_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_260_reg)=data)
+#define set_CAM_EMM_EMM_BUF_261_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_261_reg)=data)
+#define set_CAM_EMM_EMM_BUF_262_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_262_reg)=data)
+#define set_CAM_EMM_EMM_BUF_263_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_263_reg)=data)
+#define set_CAM_EMM_EMM_BUF_264_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_264_reg)=data)
+#define set_CAM_EMM_EMM_BUF_265_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_265_reg)=data)
+#define set_CAM_EMM_EMM_BUF_266_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_266_reg)=data)
+#define set_CAM_EMM_EMM_BUF_267_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_267_reg)=data)
+#define set_CAM_EMM_EMM_BUF_268_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_268_reg)=data)
+#define set_CAM_EMM_EMM_BUF_269_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_269_reg)=data)
+#define set_CAM_EMM_EMM_BUF_270_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_270_reg)=data)
+#define set_CAM_EMM_EMM_BUF_271_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_271_reg)=data)
+#define set_CAM_EMM_EMM_BUF_272_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_272_reg)=data)
+#define set_CAM_EMM_EMM_BUF_273_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_273_reg)=data)
+#define set_CAM_EMM_EMM_BUF_274_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_274_reg)=data)
+#define set_CAM_EMM_EMM_BUF_275_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_275_reg)=data)
+#define set_CAM_EMM_EMM_BUF_276_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_276_reg)=data)
+#define set_CAM_EMM_EMM_BUF_277_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_277_reg)=data)
+#define set_CAM_EMM_EMM_BUF_278_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_278_reg)=data)
+#define set_CAM_EMM_EMM_BUF_279_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_279_reg)=data)
+#define set_CAM_EMM_EMM_BUF_280_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_280_reg)=data)
+#define set_CAM_EMM_EMM_BUF_281_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_281_reg)=data)
+#define set_CAM_EMM_EMM_BUF_282_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_282_reg)=data)
+#define set_CAM_EMM_EMM_BUF_283_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_283_reg)=data)
+#define set_CAM_EMM_EMM_BUF_284_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_284_reg)=data)
+#define set_CAM_EMM_EMM_BUF_285_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_285_reg)=data)
+#define set_CAM_EMM_EMM_BUF_286_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_286_reg)=data)
+#define set_CAM_EMM_EMM_BUF_287_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_287_reg)=data)
+#define set_CAM_EMM_EMM_BUF_288_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_288_reg)=data)
+#define set_CAM_EMM_EMM_BUF_289_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_289_reg)=data)
+#define set_CAM_EMM_EMM_BUF_290_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_290_reg)=data)
+#define set_CAM_EMM_EMM_BUF_291_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_291_reg)=data)
+#define set_CAM_EMM_EMM_BUF_292_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_292_reg)=data)
+#define set_CAM_EMM_EMM_BUF_293_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_293_reg)=data)
+#define set_CAM_EMM_EMM_BUF_294_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_294_reg)=data)
+#define set_CAM_EMM_EMM_BUF_295_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_295_reg)=data)
+#define set_CAM_EMM_EMM_BUF_296_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_296_reg)=data)
+#define set_CAM_EMM_EMM_BUF_297_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_297_reg)=data)
+#define set_CAM_EMM_EMM_BUF_298_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_298_reg)=data)
+#define set_CAM_EMM_EMM_BUF_299_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_299_reg)=data)
+#define set_CAM_EMM_EMM_BUF_300_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_300_reg)=data)
+#define set_CAM_EMM_EMM_BUF_301_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_301_reg)=data)
+#define set_CAM_EMM_EMM_BUF_302_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_302_reg)=data)
+#define set_CAM_EMM_EMM_BUF_303_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_303_reg)=data)
+#define set_CAM_EMM_EMM_BUF_304_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_304_reg)=data)
+#define set_CAM_EMM_EMM_BUF_305_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_305_reg)=data)
+#define set_CAM_EMM_EMM_BUF_306_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_306_reg)=data)
+#define set_CAM_EMM_EMM_BUF_307_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_307_reg)=data)
+#define set_CAM_EMM_EMM_BUF_308_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_308_reg)=data)
+#define set_CAM_EMM_EMM_BUF_309_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_309_reg)=data)
+#define set_CAM_EMM_EMM_BUF_310_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_310_reg)=data)
+#define set_CAM_EMM_EMM_BUF_311_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_311_reg)=data)
+#define set_CAM_EMM_EMM_BUF_312_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_312_reg)=data)
+#define set_CAM_EMM_EMM_BUF_313_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_313_reg)=data)
+#define set_CAM_EMM_EMM_BUF_314_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_314_reg)=data)
+#define set_CAM_EMM_EMM_BUF_315_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_315_reg)=data)
+#define set_CAM_EMM_EMM_BUF_316_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_316_reg)=data)
+#define set_CAM_EMM_EMM_BUF_317_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_317_reg)=data)
+#define set_CAM_EMM_EMM_BUF_318_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_318_reg)=data)
+#define set_CAM_EMM_EMM_BUF_319_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_319_reg)=data)
+#define set_CAM_EMM_EMM_BUF_320_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_320_reg)=data)
+#define set_CAM_EMM_EMM_BUF_321_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_321_reg)=data)
+#define set_CAM_EMM_EMM_BUF_322_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_322_reg)=data)
+#define set_CAM_EMM_EMM_BUF_323_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_323_reg)=data)
+#define set_CAM_EMM_EMM_BUF_324_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_324_reg)=data)
+#define set_CAM_EMM_EMM_BUF_325_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_325_reg)=data)
+#define set_CAM_EMM_EMM_BUF_326_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_326_reg)=data)
+#define set_CAM_EMM_EMM_BUF_327_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_327_reg)=data)
+#define set_CAM_EMM_EMM_BUF_328_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_328_reg)=data)
+#define set_CAM_EMM_EMM_BUF_329_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_329_reg)=data)
+#define set_CAM_EMM_EMM_BUF_330_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_330_reg)=data)
+#define set_CAM_EMM_EMM_BUF_331_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_331_reg)=data)
+#define set_CAM_EMM_EMM_BUF_332_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_332_reg)=data)
+#define set_CAM_EMM_EMM_BUF_333_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_333_reg)=data)
+#define set_CAM_EMM_EMM_BUF_334_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_334_reg)=data)
+#define set_CAM_EMM_EMM_BUF_335_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_335_reg)=data)
+#define set_CAM_EMM_EMM_BUF_336_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_336_reg)=data)
+#define set_CAM_EMM_EMM_BUF_337_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_337_reg)=data)
+#define set_CAM_EMM_EMM_BUF_338_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_338_reg)=data)
+#define set_CAM_EMM_EMM_BUF_339_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_339_reg)=data)
+#define set_CAM_EMM_EMM_BUF_340_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_340_reg)=data)
+#define set_CAM_EMM_EMM_BUF_341_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_341_reg)=data)
+#define set_CAM_EMM_EMM_BUF_342_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_342_reg)=data)
+#define set_CAM_EMM_EMM_BUF_343_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_343_reg)=data)
+#define set_CAM_EMM_EMM_BUF_344_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_344_reg)=data)
+#define set_CAM_EMM_EMM_BUF_345_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_345_reg)=data)
+#define set_CAM_EMM_EMM_BUF_346_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_346_reg)=data)
+#define set_CAM_EMM_EMM_BUF_347_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_347_reg)=data)
+#define set_CAM_EMM_EMM_BUF_348_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_348_reg)=data)
+#define set_CAM_EMM_EMM_BUF_349_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_349_reg)=data)
+#define set_CAM_EMM_EMM_BUF_350_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_350_reg)=data)
+#define set_CAM_EMM_EMM_BUF_351_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_351_reg)=data)
+#define set_CAM_EMM_EMM_BUF_352_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_352_reg)=data)
+#define set_CAM_EMM_EMM_BUF_353_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_353_reg)=data)
+#define set_CAM_EMM_EMM_BUF_354_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_354_reg)=data)
+#define set_CAM_EMM_EMM_BUF_355_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_355_reg)=data)
+#define set_CAM_EMM_EMM_BUF_356_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_356_reg)=data)
+#define set_CAM_EMM_EMM_BUF_357_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_357_reg)=data)
+#define set_CAM_EMM_EMM_BUF_358_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_358_reg)=data)
+#define set_CAM_EMM_EMM_BUF_359_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_359_reg)=data)
+#define set_CAM_EMM_EMM_BUF_360_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_360_reg)=data)
+#define set_CAM_EMM_EMM_BUF_361_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_361_reg)=data)
+#define set_CAM_EMM_EMM_BUF_362_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_362_reg)=data)
+#define set_CAM_EMM_EMM_BUF_363_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_363_reg)=data)
+#define set_CAM_EMM_EMM_BUF_364_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_364_reg)=data)
+#define set_CAM_EMM_EMM_BUF_365_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_365_reg)=data)
+#define set_CAM_EMM_EMM_BUF_366_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_366_reg)=data)
+#define set_CAM_EMM_EMM_BUF_367_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_367_reg)=data)
+#define set_CAM_EMM_EMM_BUF_368_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_368_reg)=data)
+#define set_CAM_EMM_EMM_BUF_369_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_369_reg)=data)
+#define set_CAM_EMM_EMM_BUF_370_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_370_reg)=data)
+#define set_CAM_EMM_EMM_BUF_371_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_371_reg)=data)
+#define set_CAM_EMM_EMM_BUF_372_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_372_reg)=data)
+#define set_CAM_EMM_EMM_BUF_373_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_373_reg)=data)
+#define set_CAM_EMM_EMM_BUF_374_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_374_reg)=data)
+#define set_CAM_EMM_EMM_BUF_375_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_375_reg)=data)
+#define set_CAM_EMM_EMM_BUF_376_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_376_reg)=data)
+#define set_CAM_EMM_EMM_BUF_377_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_377_reg)=data)
+#define set_CAM_EMM_EMM_BUF_378_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_378_reg)=data)
+#define set_CAM_EMM_EMM_BUF_379_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_379_reg)=data)
+#define set_CAM_EMM_EMM_BUF_380_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_380_reg)=data)
+#define set_CAM_EMM_EMM_BUF_381_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_381_reg)=data)
+#define set_CAM_EMM_EMM_BUF_382_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_382_reg)=data)
+#define set_CAM_EMM_EMM_BUF_383_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_383_reg)=data)
+#define set_CAM_EMM_EMM_BUF_384_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_384_reg)=data)
+#define set_CAM_EMM_EMM_BUF_385_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_385_reg)=data)
+#define set_CAM_EMM_EMM_BUF_386_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_386_reg)=data)
+#define set_CAM_EMM_EMM_BUF_387_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_387_reg)=data)
+#define set_CAM_EMM_EMM_BUF_388_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_388_reg)=data)
+#define set_CAM_EMM_EMM_BUF_389_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_389_reg)=data)
+#define set_CAM_EMM_EMM_BUF_390_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_390_reg)=data)
+#define set_CAM_EMM_EMM_BUF_391_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_391_reg)=data)
+#define set_CAM_EMM_EMM_BUF_392_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_392_reg)=data)
+#define set_CAM_EMM_EMM_BUF_393_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_393_reg)=data)
+#define set_CAM_EMM_EMM_BUF_394_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_394_reg)=data)
+#define set_CAM_EMM_EMM_BUF_395_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_395_reg)=data)
+#define set_CAM_EMM_EMM_BUF_396_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_396_reg)=data)
+#define set_CAM_EMM_EMM_BUF_397_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_397_reg)=data)
+#define set_CAM_EMM_EMM_BUF_398_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_398_reg)=data)
+#define set_CAM_EMM_EMM_BUF_399_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_399_reg)=data)
+#define set_CAM_EMM_EMM_BUF_400_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_400_reg)=data)
+#define set_CAM_EMM_EMM_BUF_401_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_401_reg)=data)
+#define set_CAM_EMM_EMM_BUF_402_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_402_reg)=data)
+#define set_CAM_EMM_EMM_BUF_403_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_403_reg)=data)
+#define set_CAM_EMM_EMM_BUF_404_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_404_reg)=data)
+#define set_CAM_EMM_EMM_BUF_405_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_405_reg)=data)
+#define set_CAM_EMM_EMM_BUF_406_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_406_reg)=data)
+#define set_CAM_EMM_EMM_BUF_407_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_407_reg)=data)
+#define set_CAM_EMM_EMM_BUF_408_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_408_reg)=data)
+#define set_CAM_EMM_EMM_BUF_409_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_409_reg)=data)
+#define set_CAM_EMM_EMM_BUF_410_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_410_reg)=data)
+#define set_CAM_EMM_EMM_BUF_411_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_411_reg)=data)
+#define set_CAM_EMM_EMM_BUF_412_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_412_reg)=data)
+#define set_CAM_EMM_EMM_BUF_413_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_413_reg)=data)
+#define set_CAM_EMM_EMM_BUF_414_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_414_reg)=data)
+#define set_CAM_EMM_EMM_BUF_415_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_415_reg)=data)
+#define set_CAM_EMM_EMM_BUF_416_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_416_reg)=data)
+#define set_CAM_EMM_EMM_BUF_417_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_417_reg)=data)
+#define set_CAM_EMM_EMM_BUF_418_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_418_reg)=data)
+#define set_CAM_EMM_EMM_BUF_419_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_419_reg)=data)
+#define set_CAM_EMM_EMM_BUF_420_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_420_reg)=data)
+#define set_CAM_EMM_EMM_BUF_421_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_421_reg)=data)
+#define set_CAM_EMM_EMM_BUF_422_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_422_reg)=data)
+#define set_CAM_EMM_EMM_BUF_423_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_423_reg)=data)
+#define set_CAM_EMM_EMM_BUF_424_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_424_reg)=data)
+#define set_CAM_EMM_EMM_BUF_425_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_425_reg)=data)
+#define set_CAM_EMM_EMM_BUF_426_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_426_reg)=data)
+#define set_CAM_EMM_EMM_BUF_427_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_427_reg)=data)
+#define set_CAM_EMM_EMM_BUF_428_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_428_reg)=data)
+#define set_CAM_EMM_EMM_BUF_429_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_429_reg)=data)
+#define set_CAM_EMM_EMM_BUF_430_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_430_reg)=data)
+#define set_CAM_EMM_EMM_BUF_431_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_431_reg)=data)
+#define set_CAM_EMM_EMM_BUF_432_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_432_reg)=data)
+#define set_CAM_EMM_EMM_BUF_433_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_433_reg)=data)
+#define set_CAM_EMM_EMM_BUF_434_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_434_reg)=data)
+#define set_CAM_EMM_EMM_BUF_435_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_435_reg)=data)
+#define set_CAM_EMM_EMM_BUF_436_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_436_reg)=data)
+#define set_CAM_EMM_EMM_BUF_437_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_437_reg)=data)
+#define set_CAM_EMM_EMM_BUF_438_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_438_reg)=data)
+#define set_CAM_EMM_EMM_BUF_439_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_439_reg)=data)
+#define set_CAM_EMM_EMM_BUF_440_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_440_reg)=data)
+#define set_CAM_EMM_EMM_BUF_441_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_441_reg)=data)
+#define set_CAM_EMM_EMM_BUF_442_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_442_reg)=data)
+#define set_CAM_EMM_EMM_BUF_443_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_443_reg)=data)
+#define set_CAM_EMM_EMM_BUF_444_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_444_reg)=data)
+#define set_CAM_EMM_EMM_BUF_445_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_445_reg)=data)
+#define set_CAM_EMM_EMM_BUF_446_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_446_reg)=data)
+#define set_CAM_EMM_EMM_BUF_447_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_447_reg)=data)
+#define set_CAM_EMM_EMM_BUF_448_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_448_reg)=data)
+#define set_CAM_EMM_EMM_BUF_449_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_449_reg)=data)
+#define set_CAM_EMM_EMM_BUF_450_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_450_reg)=data)
+#define set_CAM_EMM_EMM_BUF_451_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_451_reg)=data)
+#define set_CAM_EMM_EMM_BUF_452_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_452_reg)=data)
+#define set_CAM_EMM_EMM_BUF_453_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_453_reg)=data)
+#define set_CAM_EMM_EMM_BUF_454_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_454_reg)=data)
+#define set_CAM_EMM_EMM_BUF_455_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_455_reg)=data)
+#define set_CAM_EMM_EMM_BUF_456_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_456_reg)=data)
+#define set_CAM_EMM_EMM_BUF_457_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_457_reg)=data)
+#define set_CAM_EMM_EMM_BUF_458_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_458_reg)=data)
+#define set_CAM_EMM_EMM_BUF_459_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_459_reg)=data)
+#define set_CAM_EMM_EMM_BUF_460_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_460_reg)=data)
+#define set_CAM_EMM_EMM_BUF_461_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_461_reg)=data)
+#define set_CAM_EMM_EMM_BUF_462_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_462_reg)=data)
+#define set_CAM_EMM_EMM_BUF_463_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_463_reg)=data)
+#define set_CAM_EMM_EMM_BUF_464_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_464_reg)=data)
+#define set_CAM_EMM_EMM_BUF_465_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_465_reg)=data)
+#define set_CAM_EMM_EMM_BUF_466_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_466_reg)=data)
+#define set_CAM_EMM_EMM_BUF_467_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_467_reg)=data)
+#define set_CAM_EMM_EMM_BUF_468_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_468_reg)=data)
+#define set_CAM_EMM_EMM_BUF_469_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_469_reg)=data)
+#define set_CAM_EMM_EMM_BUF_470_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_470_reg)=data)
+#define set_CAM_EMM_EMM_BUF_471_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_471_reg)=data)
+#define set_CAM_EMM_EMM_BUF_472_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_472_reg)=data)
+#define set_CAM_EMM_EMM_BUF_473_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_473_reg)=data)
+#define set_CAM_EMM_EMM_BUF_474_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_474_reg)=data)
+#define set_CAM_EMM_EMM_BUF_475_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_475_reg)=data)
+#define set_CAM_EMM_EMM_BUF_476_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_476_reg)=data)
+#define set_CAM_EMM_EMM_BUF_477_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_477_reg)=data)
+#define set_CAM_EMM_EMM_BUF_478_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_478_reg)=data)
+#define set_CAM_EMM_EMM_BUF_479_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_479_reg)=data)
+#define set_CAM_EMM_EMM_BUF_480_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_480_reg)=data)
+#define set_CAM_EMM_EMM_BUF_481_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_481_reg)=data)
+#define set_CAM_EMM_EMM_BUF_482_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_482_reg)=data)
+#define set_CAM_EMM_EMM_BUF_483_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_483_reg)=data)
+#define set_CAM_EMM_EMM_BUF_484_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_484_reg)=data)
+#define set_CAM_EMM_EMM_BUF_485_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_485_reg)=data)
+#define set_CAM_EMM_EMM_BUF_486_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_486_reg)=data)
+#define set_CAM_EMM_EMM_BUF_487_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_487_reg)=data)
+#define set_CAM_EMM_EMM_BUF_488_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_488_reg)=data)
+#define set_CAM_EMM_EMM_BUF_489_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_489_reg)=data)
+#define set_CAM_EMM_EMM_BUF_490_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_490_reg)=data)
+#define set_CAM_EMM_EMM_BUF_491_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_491_reg)=data)
+#define set_CAM_EMM_EMM_BUF_492_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_492_reg)=data)
+#define set_CAM_EMM_EMM_BUF_493_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_493_reg)=data)
+#define set_CAM_EMM_EMM_BUF_494_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_494_reg)=data)
+#define set_CAM_EMM_EMM_BUF_495_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_495_reg)=data)
+#define set_CAM_EMM_EMM_BUF_496_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_496_reg)=data)
+#define set_CAM_EMM_EMM_BUF_497_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_497_reg)=data)
+#define set_CAM_EMM_EMM_BUF_498_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_498_reg)=data)
+#define set_CAM_EMM_EMM_BUF_499_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_499_reg)=data)
+#define set_CAM_EMM_EMM_BUF_500_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_500_reg)=data)
+#define set_CAM_EMM_EMM_BUF_501_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_501_reg)=data)
+#define set_CAM_EMM_EMM_BUF_502_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_502_reg)=data)
+#define set_CAM_EMM_EMM_BUF_503_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_503_reg)=data)
+#define set_CAM_EMM_EMM_BUF_504_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_504_reg)=data)
+#define set_CAM_EMM_EMM_BUF_505_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_505_reg)=data)
+#define set_CAM_EMM_EMM_BUF_506_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_506_reg)=data)
+#define set_CAM_EMM_EMM_BUF_507_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_507_reg)=data)
+#define set_CAM_EMM_EMM_BUF_508_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_508_reg)=data)
+#define set_CAM_EMM_EMM_BUF_509_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_509_reg)=data)
+#define set_CAM_EMM_EMM_BUF_510_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_510_reg)=data)
+#define set_CAM_EMM_EMM_BUF_511_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_511_reg)=data)
+#define set_CAM_EMM_EMM_BUF_512_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_512_reg)=data)
+#define set_CAM_EMM_EMM_BUF_513_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_513_reg)=data)
+#define set_CAM_EMM_EMM_BUF_514_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_514_reg)=data)
+#define set_CAM_EMM_EMM_BUF_515_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_515_reg)=data)
+#define set_CAM_EMM_EMM_BUF_516_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_516_reg)=data)
+#define set_CAM_EMM_EMM_BUF_517_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_517_reg)=data)
+#define set_CAM_EMM_EMM_BUF_518_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_518_reg)=data)
+#define set_CAM_EMM_EMM_BUF_519_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_519_reg)=data)
+#define set_CAM_EMM_EMM_BUF_520_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_520_reg)=data)
+#define set_CAM_EMM_EMM_BUF_521_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_521_reg)=data)
+#define set_CAM_EMM_EMM_BUF_522_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_522_reg)=data)
+#define set_CAM_EMM_EMM_BUF_523_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_523_reg)=data)
+#define set_CAM_EMM_EMM_BUF_524_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_524_reg)=data)
+#define set_CAM_EMM_EMM_BUF_525_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_525_reg)=data)
+#define set_CAM_EMM_EMM_BUF_526_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_526_reg)=data)
+#define set_CAM_EMM_EMM_BUF_527_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_527_reg)=data)
+#define set_CAM_EMM_EMM_BUF_528_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_528_reg)=data)
+#define set_CAM_EMM_EMM_BUF_529_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_529_reg)=data)
+#define set_CAM_EMM_EMM_BUF_530_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_530_reg)=data)
+#define set_CAM_EMM_EMM_BUF_531_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_531_reg)=data)
+#define set_CAM_EMM_EMM_BUF_532_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_532_reg)=data)
+#define set_CAM_EMM_EMM_BUF_533_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_533_reg)=data)
+#define set_CAM_EMM_EMM_BUF_534_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_534_reg)=data)
+#define set_CAM_EMM_EMM_BUF_535_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_535_reg)=data)
+#define set_CAM_EMM_EMM_BUF_536_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_536_reg)=data)
+#define set_CAM_EMM_EMM_BUF_537_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_537_reg)=data)
+#define set_CAM_EMM_EMM_BUF_538_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_538_reg)=data)
+#define set_CAM_EMM_EMM_BUF_539_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_539_reg)=data)
+#define set_CAM_EMM_EMM_BUF_540_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_540_reg)=data)
+#define set_CAM_EMM_EMM_BUF_541_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_541_reg)=data)
+#define set_CAM_EMM_EMM_BUF_542_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_542_reg)=data)
+#define set_CAM_EMM_EMM_BUF_543_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_543_reg)=data)
+#define set_CAM_EMM_EMM_BUF_544_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_544_reg)=data)
+#define set_CAM_EMM_EMM_BUF_545_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_545_reg)=data)
+#define set_CAM_EMM_EMM_BUF_546_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_546_reg)=data)
+#define set_CAM_EMM_EMM_BUF_547_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_547_reg)=data)
+#define set_CAM_EMM_EMM_BUF_548_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_548_reg)=data)
+#define set_CAM_EMM_EMM_BUF_549_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_549_reg)=data)
+#define set_CAM_EMM_EMM_BUF_550_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_550_reg)=data)
+#define set_CAM_EMM_EMM_BUF_551_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_551_reg)=data)
+#define set_CAM_EMM_EMM_BUF_552_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_552_reg)=data)
+#define set_CAM_EMM_EMM_BUF_553_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_553_reg)=data)
+#define set_CAM_EMM_EMM_BUF_554_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_554_reg)=data)
+#define set_CAM_EMM_EMM_BUF_555_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_555_reg)=data)
+#define set_CAM_EMM_EMM_BUF_556_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_556_reg)=data)
+#define set_CAM_EMM_EMM_BUF_557_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_557_reg)=data)
+#define set_CAM_EMM_EMM_BUF_558_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_558_reg)=data)
+#define set_CAM_EMM_EMM_BUF_559_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_559_reg)=data)
+#define set_CAM_EMM_EMM_BUF_560_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_560_reg)=data)
+#define set_CAM_EMM_EMM_BUF_561_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_561_reg)=data)
+#define set_CAM_EMM_EMM_BUF_562_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_562_reg)=data)
+#define set_CAM_EMM_EMM_BUF_563_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_563_reg)=data)
+#define set_CAM_EMM_EMM_BUF_564_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_564_reg)=data)
+#define set_CAM_EMM_EMM_BUF_565_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_565_reg)=data)
+#define set_CAM_EMM_EMM_BUF_566_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_566_reg)=data)
+#define set_CAM_EMM_EMM_BUF_567_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_567_reg)=data)
+#define set_CAM_EMM_EMM_BUF_568_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_568_reg)=data)
+#define set_CAM_EMM_EMM_BUF_569_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_569_reg)=data)
+#define set_CAM_EMM_EMM_BUF_570_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_570_reg)=data)
+#define set_CAM_EMM_EMM_BUF_571_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_571_reg)=data)
+#define set_CAM_EMM_EMM_BUF_572_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_572_reg)=data)
+#define set_CAM_EMM_EMM_BUF_573_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_573_reg)=data)
+#define set_CAM_EMM_EMM_BUF_574_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_574_reg)=data)
+#define set_CAM_EMM_EMM_BUF_575_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_575_reg)=data)
+#define set_CAM_EMM_EMM_BUF_576_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_576_reg)=data)
+#define set_CAM_EMM_EMM_BUF_577_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_577_reg)=data)
+#define set_CAM_EMM_EMM_BUF_578_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_578_reg)=data)
+#define set_CAM_EMM_EMM_BUF_579_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_579_reg)=data)
+#define set_CAM_EMM_EMM_BUF_580_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_580_reg)=data)
+#define set_CAM_EMM_EMM_BUF_581_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_581_reg)=data)
+#define set_CAM_EMM_EMM_BUF_582_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_582_reg)=data)
+#define set_CAM_EMM_EMM_BUF_583_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_583_reg)=data)
+#define set_CAM_EMM_EMM_BUF_584_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_584_reg)=data)
+#define set_CAM_EMM_EMM_BUF_585_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_585_reg)=data)
+#define set_CAM_EMM_EMM_BUF_586_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_586_reg)=data)
+#define set_CAM_EMM_EMM_BUF_587_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_587_reg)=data)
+#define set_CAM_EMM_EMM_BUF_588_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_588_reg)=data)
+#define set_CAM_EMM_EMM_BUF_589_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_589_reg)=data)
+#define set_CAM_EMM_EMM_BUF_590_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_590_reg)=data)
+#define set_CAM_EMM_EMM_BUF_591_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_591_reg)=data)
+#define set_CAM_EMM_EMM_BUF_592_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_592_reg)=data)
+#define set_CAM_EMM_EMM_BUF_593_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_593_reg)=data)
+#define set_CAM_EMM_EMM_BUF_594_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_594_reg)=data)
+#define set_CAM_EMM_EMM_BUF_595_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_595_reg)=data)
+#define set_CAM_EMM_EMM_BUF_596_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_596_reg)=data)
+#define set_CAM_EMM_EMM_BUF_597_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_597_reg)=data)
+#define set_CAM_EMM_EMM_BUF_598_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_598_reg)=data)
+#define set_CAM_EMM_EMM_BUF_599_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_599_reg)=data)
+#define set_CAM_EMM_EMM_BUF_600_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_600_reg)=data)
+#define set_CAM_EMM_EMM_BUF_601_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_601_reg)=data)
+#define set_CAM_EMM_EMM_BUF_602_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_602_reg)=data)
+#define set_CAM_EMM_EMM_BUF_603_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_603_reg)=data)
+#define set_CAM_EMM_EMM_BUF_604_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_604_reg)=data)
+#define set_CAM_EMM_EMM_BUF_605_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_605_reg)=data)
+#define set_CAM_EMM_EMM_BUF_606_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_606_reg)=data)
+#define set_CAM_EMM_EMM_BUF_607_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_607_reg)=data)
+#define set_CAM_EMM_EMM_BUF_608_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_608_reg)=data)
+#define set_CAM_EMM_EMM_BUF_609_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_609_reg)=data)
+#define set_CAM_EMM_EMM_BUF_610_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_610_reg)=data)
+#define set_CAM_EMM_EMM_BUF_611_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_611_reg)=data)
+#define set_CAM_EMM_EMM_BUF_612_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_612_reg)=data)
+#define set_CAM_EMM_EMM_BUF_613_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_613_reg)=data)
+#define set_CAM_EMM_EMM_BUF_614_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_614_reg)=data)
+#define set_CAM_EMM_EMM_BUF_615_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_615_reg)=data)
+#define set_CAM_EMM_EMM_BUF_616_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_616_reg)=data)
+#define set_CAM_EMM_EMM_BUF_617_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_617_reg)=data)
+#define set_CAM_EMM_EMM_BUF_618_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_618_reg)=data)
+#define set_CAM_EMM_EMM_BUF_619_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_619_reg)=data)
+#define set_CAM_EMM_EMM_BUF_620_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_620_reg)=data)
+#define set_CAM_EMM_EMM_BUF_621_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_621_reg)=data)
+#define set_CAM_EMM_EMM_BUF_622_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_622_reg)=data)
+#define set_CAM_EMM_EMM_BUF_623_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_623_reg)=data)
+#define set_CAM_EMM_EMM_BUF_624_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_624_reg)=data)
+#define set_CAM_EMM_EMM_BUF_625_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_625_reg)=data)
+#define set_CAM_EMM_EMM_BUF_626_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_626_reg)=data)
+#define set_CAM_EMM_EMM_BUF_627_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_627_reg)=data)
+#define set_CAM_EMM_EMM_BUF_628_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_628_reg)=data)
+#define set_CAM_EMM_EMM_BUF_629_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_629_reg)=data)
+#define set_CAM_EMM_EMM_BUF_630_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_630_reg)=data)
+#define set_CAM_EMM_EMM_BUF_631_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_631_reg)=data)
+#define set_CAM_EMM_EMM_BUF_632_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_632_reg)=data)
+#define set_CAM_EMM_EMM_BUF_633_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_633_reg)=data)
+#define set_CAM_EMM_EMM_BUF_634_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_634_reg)=data)
+#define set_CAM_EMM_EMM_BUF_635_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_635_reg)=data)
+#define set_CAM_EMM_EMM_BUF_636_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_636_reg)=data)
+#define set_CAM_EMM_EMM_BUF_637_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_637_reg)=data)
+#define set_CAM_EMM_EMM_BUF_638_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_638_reg)=data)
+#define set_CAM_EMM_EMM_BUF_639_reg(data)   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_639_reg)=data)
+#define get_CAM_EMM_EMM_BUF_0_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_0_reg))
+#define get_CAM_EMM_EMM_BUF_1_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_1_reg))
+#define get_CAM_EMM_EMM_BUF_2_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_2_reg))
+#define get_CAM_EMM_EMM_BUF_3_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_3_reg))
+#define get_CAM_EMM_EMM_BUF_4_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_4_reg))
+#define get_CAM_EMM_EMM_BUF_5_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_5_reg))
+#define get_CAM_EMM_EMM_BUF_6_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_6_reg))
+#define get_CAM_EMM_EMM_BUF_7_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_7_reg))
+#define get_CAM_EMM_EMM_BUF_8_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_8_reg))
+#define get_CAM_EMM_EMM_BUF_9_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_9_reg))
+#define get_CAM_EMM_EMM_BUF_10_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_10_reg))
+#define get_CAM_EMM_EMM_BUF_11_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_11_reg))
+#define get_CAM_EMM_EMM_BUF_12_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_12_reg))
+#define get_CAM_EMM_EMM_BUF_13_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_13_reg))
+#define get_CAM_EMM_EMM_BUF_14_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_14_reg))
+#define get_CAM_EMM_EMM_BUF_15_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_15_reg))
+#define get_CAM_EMM_EMM_BUF_16_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_16_reg))
+#define get_CAM_EMM_EMM_BUF_17_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_17_reg))
+#define get_CAM_EMM_EMM_BUF_18_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_18_reg))
+#define get_CAM_EMM_EMM_BUF_19_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_19_reg))
+#define get_CAM_EMM_EMM_BUF_20_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_20_reg))
+#define get_CAM_EMM_EMM_BUF_21_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_21_reg))
+#define get_CAM_EMM_EMM_BUF_22_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_22_reg))
+#define get_CAM_EMM_EMM_BUF_23_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_23_reg))
+#define get_CAM_EMM_EMM_BUF_24_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_24_reg))
+#define get_CAM_EMM_EMM_BUF_25_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_25_reg))
+#define get_CAM_EMM_EMM_BUF_26_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_26_reg))
+#define get_CAM_EMM_EMM_BUF_27_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_27_reg))
+#define get_CAM_EMM_EMM_BUF_28_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_28_reg))
+#define get_CAM_EMM_EMM_BUF_29_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_29_reg))
+#define get_CAM_EMM_EMM_BUF_30_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_30_reg))
+#define get_CAM_EMM_EMM_BUF_31_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_31_reg))
+#define get_CAM_EMM_EMM_BUF_32_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_32_reg))
+#define get_CAM_EMM_EMM_BUF_33_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_33_reg))
+#define get_CAM_EMM_EMM_BUF_34_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_34_reg))
+#define get_CAM_EMM_EMM_BUF_35_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_35_reg))
+#define get_CAM_EMM_EMM_BUF_36_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_36_reg))
+#define get_CAM_EMM_EMM_BUF_37_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_37_reg))
+#define get_CAM_EMM_EMM_BUF_38_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_38_reg))
+#define get_CAM_EMM_EMM_BUF_39_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_39_reg))
+#define get_CAM_EMM_EMM_BUF_40_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_40_reg))
+#define get_CAM_EMM_EMM_BUF_41_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_41_reg))
+#define get_CAM_EMM_EMM_BUF_42_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_42_reg))
+#define get_CAM_EMM_EMM_BUF_43_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_43_reg))
+#define get_CAM_EMM_EMM_BUF_44_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_44_reg))
+#define get_CAM_EMM_EMM_BUF_45_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_45_reg))
+#define get_CAM_EMM_EMM_BUF_46_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_46_reg))
+#define get_CAM_EMM_EMM_BUF_47_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_47_reg))
+#define get_CAM_EMM_EMM_BUF_48_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_48_reg))
+#define get_CAM_EMM_EMM_BUF_49_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_49_reg))
+#define get_CAM_EMM_EMM_BUF_50_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_50_reg))
+#define get_CAM_EMM_EMM_BUF_51_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_51_reg))
+#define get_CAM_EMM_EMM_BUF_52_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_52_reg))
+#define get_CAM_EMM_EMM_BUF_53_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_53_reg))
+#define get_CAM_EMM_EMM_BUF_54_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_54_reg))
+#define get_CAM_EMM_EMM_BUF_55_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_55_reg))
+#define get_CAM_EMM_EMM_BUF_56_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_56_reg))
+#define get_CAM_EMM_EMM_BUF_57_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_57_reg))
+#define get_CAM_EMM_EMM_BUF_58_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_58_reg))
+#define get_CAM_EMM_EMM_BUF_59_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_59_reg))
+#define get_CAM_EMM_EMM_BUF_60_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_60_reg))
+#define get_CAM_EMM_EMM_BUF_61_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_61_reg))
+#define get_CAM_EMM_EMM_BUF_62_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_62_reg))
+#define get_CAM_EMM_EMM_BUF_63_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_63_reg))
+#define get_CAM_EMM_EMM_BUF_64_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_64_reg))
+#define get_CAM_EMM_EMM_BUF_65_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_65_reg))
+#define get_CAM_EMM_EMM_BUF_66_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_66_reg))
+#define get_CAM_EMM_EMM_BUF_67_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_67_reg))
+#define get_CAM_EMM_EMM_BUF_68_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_68_reg))
+#define get_CAM_EMM_EMM_BUF_69_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_69_reg))
+#define get_CAM_EMM_EMM_BUF_70_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_70_reg))
+#define get_CAM_EMM_EMM_BUF_71_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_71_reg))
+#define get_CAM_EMM_EMM_BUF_72_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_72_reg))
+#define get_CAM_EMM_EMM_BUF_73_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_73_reg))
+#define get_CAM_EMM_EMM_BUF_74_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_74_reg))
+#define get_CAM_EMM_EMM_BUF_75_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_75_reg))
+#define get_CAM_EMM_EMM_BUF_76_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_76_reg))
+#define get_CAM_EMM_EMM_BUF_77_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_77_reg))
+#define get_CAM_EMM_EMM_BUF_78_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_78_reg))
+#define get_CAM_EMM_EMM_BUF_79_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_79_reg))
+#define get_CAM_EMM_EMM_BUF_80_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_80_reg))
+#define get_CAM_EMM_EMM_BUF_81_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_81_reg))
+#define get_CAM_EMM_EMM_BUF_82_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_82_reg))
+#define get_CAM_EMM_EMM_BUF_83_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_83_reg))
+#define get_CAM_EMM_EMM_BUF_84_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_84_reg))
+#define get_CAM_EMM_EMM_BUF_85_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_85_reg))
+#define get_CAM_EMM_EMM_BUF_86_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_86_reg))
+#define get_CAM_EMM_EMM_BUF_87_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_87_reg))
+#define get_CAM_EMM_EMM_BUF_88_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_88_reg))
+#define get_CAM_EMM_EMM_BUF_89_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_89_reg))
+#define get_CAM_EMM_EMM_BUF_90_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_90_reg))
+#define get_CAM_EMM_EMM_BUF_91_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_91_reg))
+#define get_CAM_EMM_EMM_BUF_92_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_92_reg))
+#define get_CAM_EMM_EMM_BUF_93_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_93_reg))
+#define get_CAM_EMM_EMM_BUF_94_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_94_reg))
+#define get_CAM_EMM_EMM_BUF_95_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_95_reg))
+#define get_CAM_EMM_EMM_BUF_96_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_96_reg))
+#define get_CAM_EMM_EMM_BUF_97_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_97_reg))
+#define get_CAM_EMM_EMM_BUF_98_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_98_reg))
+#define get_CAM_EMM_EMM_BUF_99_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_99_reg))
+#define get_CAM_EMM_EMM_BUF_100_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_100_reg))
+#define get_CAM_EMM_EMM_BUF_101_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_101_reg))
+#define get_CAM_EMM_EMM_BUF_102_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_102_reg))
+#define get_CAM_EMM_EMM_BUF_103_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_103_reg))
+#define get_CAM_EMM_EMM_BUF_104_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_104_reg))
+#define get_CAM_EMM_EMM_BUF_105_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_105_reg))
+#define get_CAM_EMM_EMM_BUF_106_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_106_reg))
+#define get_CAM_EMM_EMM_BUF_107_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_107_reg))
+#define get_CAM_EMM_EMM_BUF_108_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_108_reg))
+#define get_CAM_EMM_EMM_BUF_109_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_109_reg))
+#define get_CAM_EMM_EMM_BUF_110_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_110_reg))
+#define get_CAM_EMM_EMM_BUF_111_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_111_reg))
+#define get_CAM_EMM_EMM_BUF_112_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_112_reg))
+#define get_CAM_EMM_EMM_BUF_113_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_113_reg))
+#define get_CAM_EMM_EMM_BUF_114_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_114_reg))
+#define get_CAM_EMM_EMM_BUF_115_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_115_reg))
+#define get_CAM_EMM_EMM_BUF_116_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_116_reg))
+#define get_CAM_EMM_EMM_BUF_117_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_117_reg))
+#define get_CAM_EMM_EMM_BUF_118_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_118_reg))
+#define get_CAM_EMM_EMM_BUF_119_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_119_reg))
+#define get_CAM_EMM_EMM_BUF_120_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_120_reg))
+#define get_CAM_EMM_EMM_BUF_121_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_121_reg))
+#define get_CAM_EMM_EMM_BUF_122_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_122_reg))
+#define get_CAM_EMM_EMM_BUF_123_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_123_reg))
+#define get_CAM_EMM_EMM_BUF_124_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_124_reg))
+#define get_CAM_EMM_EMM_BUF_125_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_125_reg))
+#define get_CAM_EMM_EMM_BUF_126_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_126_reg))
+#define get_CAM_EMM_EMM_BUF_127_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_127_reg))
+#define get_CAM_EMM_EMM_BUF_128_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_128_reg))
+#define get_CAM_EMM_EMM_BUF_129_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_129_reg))
+#define get_CAM_EMM_EMM_BUF_130_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_130_reg))
+#define get_CAM_EMM_EMM_BUF_131_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_131_reg))
+#define get_CAM_EMM_EMM_BUF_132_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_132_reg))
+#define get_CAM_EMM_EMM_BUF_133_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_133_reg))
+#define get_CAM_EMM_EMM_BUF_134_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_134_reg))
+#define get_CAM_EMM_EMM_BUF_135_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_135_reg))
+#define get_CAM_EMM_EMM_BUF_136_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_136_reg))
+#define get_CAM_EMM_EMM_BUF_137_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_137_reg))
+#define get_CAM_EMM_EMM_BUF_138_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_138_reg))
+#define get_CAM_EMM_EMM_BUF_139_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_139_reg))
+#define get_CAM_EMM_EMM_BUF_140_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_140_reg))
+#define get_CAM_EMM_EMM_BUF_141_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_141_reg))
+#define get_CAM_EMM_EMM_BUF_142_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_142_reg))
+#define get_CAM_EMM_EMM_BUF_143_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_143_reg))
+#define get_CAM_EMM_EMM_BUF_144_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_144_reg))
+#define get_CAM_EMM_EMM_BUF_145_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_145_reg))
+#define get_CAM_EMM_EMM_BUF_146_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_146_reg))
+#define get_CAM_EMM_EMM_BUF_147_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_147_reg))
+#define get_CAM_EMM_EMM_BUF_148_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_148_reg))
+#define get_CAM_EMM_EMM_BUF_149_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_149_reg))
+#define get_CAM_EMM_EMM_BUF_150_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_150_reg))
+#define get_CAM_EMM_EMM_BUF_151_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_151_reg))
+#define get_CAM_EMM_EMM_BUF_152_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_152_reg))
+#define get_CAM_EMM_EMM_BUF_153_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_153_reg))
+#define get_CAM_EMM_EMM_BUF_154_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_154_reg))
+#define get_CAM_EMM_EMM_BUF_155_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_155_reg))
+#define get_CAM_EMM_EMM_BUF_156_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_156_reg))
+#define get_CAM_EMM_EMM_BUF_157_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_157_reg))
+#define get_CAM_EMM_EMM_BUF_158_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_158_reg))
+#define get_CAM_EMM_EMM_BUF_159_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_159_reg))
+#define get_CAM_EMM_EMM_BUF_160_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_160_reg))
+#define get_CAM_EMM_EMM_BUF_161_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_161_reg))
+#define get_CAM_EMM_EMM_BUF_162_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_162_reg))
+#define get_CAM_EMM_EMM_BUF_163_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_163_reg))
+#define get_CAM_EMM_EMM_BUF_164_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_164_reg))
+#define get_CAM_EMM_EMM_BUF_165_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_165_reg))
+#define get_CAM_EMM_EMM_BUF_166_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_166_reg))
+#define get_CAM_EMM_EMM_BUF_167_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_167_reg))
+#define get_CAM_EMM_EMM_BUF_168_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_168_reg))
+#define get_CAM_EMM_EMM_BUF_169_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_169_reg))
+#define get_CAM_EMM_EMM_BUF_170_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_170_reg))
+#define get_CAM_EMM_EMM_BUF_171_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_171_reg))
+#define get_CAM_EMM_EMM_BUF_172_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_172_reg))
+#define get_CAM_EMM_EMM_BUF_173_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_173_reg))
+#define get_CAM_EMM_EMM_BUF_174_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_174_reg))
+#define get_CAM_EMM_EMM_BUF_175_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_175_reg))
+#define get_CAM_EMM_EMM_BUF_176_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_176_reg))
+#define get_CAM_EMM_EMM_BUF_177_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_177_reg))
+#define get_CAM_EMM_EMM_BUF_178_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_178_reg))
+#define get_CAM_EMM_EMM_BUF_179_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_179_reg))
+#define get_CAM_EMM_EMM_BUF_180_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_180_reg))
+#define get_CAM_EMM_EMM_BUF_181_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_181_reg))
+#define get_CAM_EMM_EMM_BUF_182_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_182_reg))
+#define get_CAM_EMM_EMM_BUF_183_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_183_reg))
+#define get_CAM_EMM_EMM_BUF_184_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_184_reg))
+#define get_CAM_EMM_EMM_BUF_185_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_185_reg))
+#define get_CAM_EMM_EMM_BUF_186_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_186_reg))
+#define get_CAM_EMM_EMM_BUF_187_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_187_reg))
+#define get_CAM_EMM_EMM_BUF_188_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_188_reg))
+#define get_CAM_EMM_EMM_BUF_189_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_189_reg))
+#define get_CAM_EMM_EMM_BUF_190_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_190_reg))
+#define get_CAM_EMM_EMM_BUF_191_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_191_reg))
+#define get_CAM_EMM_EMM_BUF_192_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_192_reg))
+#define get_CAM_EMM_EMM_BUF_193_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_193_reg))
+#define get_CAM_EMM_EMM_BUF_194_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_194_reg))
+#define get_CAM_EMM_EMM_BUF_195_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_195_reg))
+#define get_CAM_EMM_EMM_BUF_196_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_196_reg))
+#define get_CAM_EMM_EMM_BUF_197_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_197_reg))
+#define get_CAM_EMM_EMM_BUF_198_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_198_reg))
+#define get_CAM_EMM_EMM_BUF_199_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_199_reg))
+#define get_CAM_EMM_EMM_BUF_200_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_200_reg))
+#define get_CAM_EMM_EMM_BUF_201_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_201_reg))
+#define get_CAM_EMM_EMM_BUF_202_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_202_reg))
+#define get_CAM_EMM_EMM_BUF_203_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_203_reg))
+#define get_CAM_EMM_EMM_BUF_204_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_204_reg))
+#define get_CAM_EMM_EMM_BUF_205_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_205_reg))
+#define get_CAM_EMM_EMM_BUF_206_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_206_reg))
+#define get_CAM_EMM_EMM_BUF_207_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_207_reg))
+#define get_CAM_EMM_EMM_BUF_208_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_208_reg))
+#define get_CAM_EMM_EMM_BUF_209_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_209_reg))
+#define get_CAM_EMM_EMM_BUF_210_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_210_reg))
+#define get_CAM_EMM_EMM_BUF_211_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_211_reg))
+#define get_CAM_EMM_EMM_BUF_212_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_212_reg))
+#define get_CAM_EMM_EMM_BUF_213_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_213_reg))
+#define get_CAM_EMM_EMM_BUF_214_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_214_reg))
+#define get_CAM_EMM_EMM_BUF_215_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_215_reg))
+#define get_CAM_EMM_EMM_BUF_216_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_216_reg))
+#define get_CAM_EMM_EMM_BUF_217_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_217_reg))
+#define get_CAM_EMM_EMM_BUF_218_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_218_reg))
+#define get_CAM_EMM_EMM_BUF_219_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_219_reg))
+#define get_CAM_EMM_EMM_BUF_220_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_220_reg))
+#define get_CAM_EMM_EMM_BUF_221_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_221_reg))
+#define get_CAM_EMM_EMM_BUF_222_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_222_reg))
+#define get_CAM_EMM_EMM_BUF_223_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_223_reg))
+#define get_CAM_EMM_EMM_BUF_224_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_224_reg))
+#define get_CAM_EMM_EMM_BUF_225_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_225_reg))
+#define get_CAM_EMM_EMM_BUF_226_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_226_reg))
+#define get_CAM_EMM_EMM_BUF_227_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_227_reg))
+#define get_CAM_EMM_EMM_BUF_228_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_228_reg))
+#define get_CAM_EMM_EMM_BUF_229_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_229_reg))
+#define get_CAM_EMM_EMM_BUF_230_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_230_reg))
+#define get_CAM_EMM_EMM_BUF_231_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_231_reg))
+#define get_CAM_EMM_EMM_BUF_232_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_232_reg))
+#define get_CAM_EMM_EMM_BUF_233_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_233_reg))
+#define get_CAM_EMM_EMM_BUF_234_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_234_reg))
+#define get_CAM_EMM_EMM_BUF_235_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_235_reg))
+#define get_CAM_EMM_EMM_BUF_236_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_236_reg))
+#define get_CAM_EMM_EMM_BUF_237_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_237_reg))
+#define get_CAM_EMM_EMM_BUF_238_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_238_reg))
+#define get_CAM_EMM_EMM_BUF_239_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_239_reg))
+#define get_CAM_EMM_EMM_BUF_240_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_240_reg))
+#define get_CAM_EMM_EMM_BUF_241_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_241_reg))
+#define get_CAM_EMM_EMM_BUF_242_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_242_reg))
+#define get_CAM_EMM_EMM_BUF_243_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_243_reg))
+#define get_CAM_EMM_EMM_BUF_244_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_244_reg))
+#define get_CAM_EMM_EMM_BUF_245_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_245_reg))
+#define get_CAM_EMM_EMM_BUF_246_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_246_reg))
+#define get_CAM_EMM_EMM_BUF_247_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_247_reg))
+#define get_CAM_EMM_EMM_BUF_248_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_248_reg))
+#define get_CAM_EMM_EMM_BUF_249_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_249_reg))
+#define get_CAM_EMM_EMM_BUF_250_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_250_reg))
+#define get_CAM_EMM_EMM_BUF_251_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_251_reg))
+#define get_CAM_EMM_EMM_BUF_252_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_252_reg))
+#define get_CAM_EMM_EMM_BUF_253_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_253_reg))
+#define get_CAM_EMM_EMM_BUF_254_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_254_reg))
+#define get_CAM_EMM_EMM_BUF_255_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_255_reg))
+#define get_CAM_EMM_EMM_BUF_256_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_256_reg))
+#define get_CAM_EMM_EMM_BUF_257_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_257_reg))
+#define get_CAM_EMM_EMM_BUF_258_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_258_reg))
+#define get_CAM_EMM_EMM_BUF_259_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_259_reg))
+#define get_CAM_EMM_EMM_BUF_260_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_260_reg))
+#define get_CAM_EMM_EMM_BUF_261_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_261_reg))
+#define get_CAM_EMM_EMM_BUF_262_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_262_reg))
+#define get_CAM_EMM_EMM_BUF_263_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_263_reg))
+#define get_CAM_EMM_EMM_BUF_264_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_264_reg))
+#define get_CAM_EMM_EMM_BUF_265_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_265_reg))
+#define get_CAM_EMM_EMM_BUF_266_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_266_reg))
+#define get_CAM_EMM_EMM_BUF_267_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_267_reg))
+#define get_CAM_EMM_EMM_BUF_268_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_268_reg))
+#define get_CAM_EMM_EMM_BUF_269_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_269_reg))
+#define get_CAM_EMM_EMM_BUF_270_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_270_reg))
+#define get_CAM_EMM_EMM_BUF_271_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_271_reg))
+#define get_CAM_EMM_EMM_BUF_272_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_272_reg))
+#define get_CAM_EMM_EMM_BUF_273_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_273_reg))
+#define get_CAM_EMM_EMM_BUF_274_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_274_reg))
+#define get_CAM_EMM_EMM_BUF_275_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_275_reg))
+#define get_CAM_EMM_EMM_BUF_276_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_276_reg))
+#define get_CAM_EMM_EMM_BUF_277_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_277_reg))
+#define get_CAM_EMM_EMM_BUF_278_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_278_reg))
+#define get_CAM_EMM_EMM_BUF_279_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_279_reg))
+#define get_CAM_EMM_EMM_BUF_280_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_280_reg))
+#define get_CAM_EMM_EMM_BUF_281_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_281_reg))
+#define get_CAM_EMM_EMM_BUF_282_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_282_reg))
+#define get_CAM_EMM_EMM_BUF_283_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_283_reg))
+#define get_CAM_EMM_EMM_BUF_284_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_284_reg))
+#define get_CAM_EMM_EMM_BUF_285_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_285_reg))
+#define get_CAM_EMM_EMM_BUF_286_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_286_reg))
+#define get_CAM_EMM_EMM_BUF_287_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_287_reg))
+#define get_CAM_EMM_EMM_BUF_288_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_288_reg))
+#define get_CAM_EMM_EMM_BUF_289_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_289_reg))
+#define get_CAM_EMM_EMM_BUF_290_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_290_reg))
+#define get_CAM_EMM_EMM_BUF_291_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_291_reg))
+#define get_CAM_EMM_EMM_BUF_292_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_292_reg))
+#define get_CAM_EMM_EMM_BUF_293_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_293_reg))
+#define get_CAM_EMM_EMM_BUF_294_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_294_reg))
+#define get_CAM_EMM_EMM_BUF_295_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_295_reg))
+#define get_CAM_EMM_EMM_BUF_296_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_296_reg))
+#define get_CAM_EMM_EMM_BUF_297_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_297_reg))
+#define get_CAM_EMM_EMM_BUF_298_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_298_reg))
+#define get_CAM_EMM_EMM_BUF_299_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_299_reg))
+#define get_CAM_EMM_EMM_BUF_300_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_300_reg))
+#define get_CAM_EMM_EMM_BUF_301_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_301_reg))
+#define get_CAM_EMM_EMM_BUF_302_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_302_reg))
+#define get_CAM_EMM_EMM_BUF_303_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_303_reg))
+#define get_CAM_EMM_EMM_BUF_304_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_304_reg))
+#define get_CAM_EMM_EMM_BUF_305_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_305_reg))
+#define get_CAM_EMM_EMM_BUF_306_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_306_reg))
+#define get_CAM_EMM_EMM_BUF_307_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_307_reg))
+#define get_CAM_EMM_EMM_BUF_308_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_308_reg))
+#define get_CAM_EMM_EMM_BUF_309_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_309_reg))
+#define get_CAM_EMM_EMM_BUF_310_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_310_reg))
+#define get_CAM_EMM_EMM_BUF_311_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_311_reg))
+#define get_CAM_EMM_EMM_BUF_312_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_312_reg))
+#define get_CAM_EMM_EMM_BUF_313_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_313_reg))
+#define get_CAM_EMM_EMM_BUF_314_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_314_reg))
+#define get_CAM_EMM_EMM_BUF_315_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_315_reg))
+#define get_CAM_EMM_EMM_BUF_316_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_316_reg))
+#define get_CAM_EMM_EMM_BUF_317_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_317_reg))
+#define get_CAM_EMM_EMM_BUF_318_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_318_reg))
+#define get_CAM_EMM_EMM_BUF_319_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_319_reg))
+#define get_CAM_EMM_EMM_BUF_320_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_320_reg))
+#define get_CAM_EMM_EMM_BUF_321_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_321_reg))
+#define get_CAM_EMM_EMM_BUF_322_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_322_reg))
+#define get_CAM_EMM_EMM_BUF_323_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_323_reg))
+#define get_CAM_EMM_EMM_BUF_324_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_324_reg))
+#define get_CAM_EMM_EMM_BUF_325_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_325_reg))
+#define get_CAM_EMM_EMM_BUF_326_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_326_reg))
+#define get_CAM_EMM_EMM_BUF_327_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_327_reg))
+#define get_CAM_EMM_EMM_BUF_328_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_328_reg))
+#define get_CAM_EMM_EMM_BUF_329_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_329_reg))
+#define get_CAM_EMM_EMM_BUF_330_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_330_reg))
+#define get_CAM_EMM_EMM_BUF_331_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_331_reg))
+#define get_CAM_EMM_EMM_BUF_332_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_332_reg))
+#define get_CAM_EMM_EMM_BUF_333_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_333_reg))
+#define get_CAM_EMM_EMM_BUF_334_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_334_reg))
+#define get_CAM_EMM_EMM_BUF_335_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_335_reg))
+#define get_CAM_EMM_EMM_BUF_336_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_336_reg))
+#define get_CAM_EMM_EMM_BUF_337_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_337_reg))
+#define get_CAM_EMM_EMM_BUF_338_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_338_reg))
+#define get_CAM_EMM_EMM_BUF_339_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_339_reg))
+#define get_CAM_EMM_EMM_BUF_340_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_340_reg))
+#define get_CAM_EMM_EMM_BUF_341_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_341_reg))
+#define get_CAM_EMM_EMM_BUF_342_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_342_reg))
+#define get_CAM_EMM_EMM_BUF_343_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_343_reg))
+#define get_CAM_EMM_EMM_BUF_344_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_344_reg))
+#define get_CAM_EMM_EMM_BUF_345_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_345_reg))
+#define get_CAM_EMM_EMM_BUF_346_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_346_reg))
+#define get_CAM_EMM_EMM_BUF_347_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_347_reg))
+#define get_CAM_EMM_EMM_BUF_348_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_348_reg))
+#define get_CAM_EMM_EMM_BUF_349_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_349_reg))
+#define get_CAM_EMM_EMM_BUF_350_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_350_reg))
+#define get_CAM_EMM_EMM_BUF_351_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_351_reg))
+#define get_CAM_EMM_EMM_BUF_352_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_352_reg))
+#define get_CAM_EMM_EMM_BUF_353_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_353_reg))
+#define get_CAM_EMM_EMM_BUF_354_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_354_reg))
+#define get_CAM_EMM_EMM_BUF_355_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_355_reg))
+#define get_CAM_EMM_EMM_BUF_356_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_356_reg))
+#define get_CAM_EMM_EMM_BUF_357_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_357_reg))
+#define get_CAM_EMM_EMM_BUF_358_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_358_reg))
+#define get_CAM_EMM_EMM_BUF_359_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_359_reg))
+#define get_CAM_EMM_EMM_BUF_360_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_360_reg))
+#define get_CAM_EMM_EMM_BUF_361_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_361_reg))
+#define get_CAM_EMM_EMM_BUF_362_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_362_reg))
+#define get_CAM_EMM_EMM_BUF_363_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_363_reg))
+#define get_CAM_EMM_EMM_BUF_364_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_364_reg))
+#define get_CAM_EMM_EMM_BUF_365_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_365_reg))
+#define get_CAM_EMM_EMM_BUF_366_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_366_reg))
+#define get_CAM_EMM_EMM_BUF_367_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_367_reg))
+#define get_CAM_EMM_EMM_BUF_368_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_368_reg))
+#define get_CAM_EMM_EMM_BUF_369_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_369_reg))
+#define get_CAM_EMM_EMM_BUF_370_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_370_reg))
+#define get_CAM_EMM_EMM_BUF_371_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_371_reg))
+#define get_CAM_EMM_EMM_BUF_372_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_372_reg))
+#define get_CAM_EMM_EMM_BUF_373_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_373_reg))
+#define get_CAM_EMM_EMM_BUF_374_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_374_reg))
+#define get_CAM_EMM_EMM_BUF_375_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_375_reg))
+#define get_CAM_EMM_EMM_BUF_376_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_376_reg))
+#define get_CAM_EMM_EMM_BUF_377_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_377_reg))
+#define get_CAM_EMM_EMM_BUF_378_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_378_reg))
+#define get_CAM_EMM_EMM_BUF_379_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_379_reg))
+#define get_CAM_EMM_EMM_BUF_380_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_380_reg))
+#define get_CAM_EMM_EMM_BUF_381_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_381_reg))
+#define get_CAM_EMM_EMM_BUF_382_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_382_reg))
+#define get_CAM_EMM_EMM_BUF_383_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_383_reg))
+#define get_CAM_EMM_EMM_BUF_384_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_384_reg))
+#define get_CAM_EMM_EMM_BUF_385_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_385_reg))
+#define get_CAM_EMM_EMM_BUF_386_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_386_reg))
+#define get_CAM_EMM_EMM_BUF_387_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_387_reg))
+#define get_CAM_EMM_EMM_BUF_388_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_388_reg))
+#define get_CAM_EMM_EMM_BUF_389_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_389_reg))
+#define get_CAM_EMM_EMM_BUF_390_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_390_reg))
+#define get_CAM_EMM_EMM_BUF_391_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_391_reg))
+#define get_CAM_EMM_EMM_BUF_392_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_392_reg))
+#define get_CAM_EMM_EMM_BUF_393_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_393_reg))
+#define get_CAM_EMM_EMM_BUF_394_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_394_reg))
+#define get_CAM_EMM_EMM_BUF_395_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_395_reg))
+#define get_CAM_EMM_EMM_BUF_396_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_396_reg))
+#define get_CAM_EMM_EMM_BUF_397_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_397_reg))
+#define get_CAM_EMM_EMM_BUF_398_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_398_reg))
+#define get_CAM_EMM_EMM_BUF_399_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_399_reg))
+#define get_CAM_EMM_EMM_BUF_400_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_400_reg))
+#define get_CAM_EMM_EMM_BUF_401_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_401_reg))
+#define get_CAM_EMM_EMM_BUF_402_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_402_reg))
+#define get_CAM_EMM_EMM_BUF_403_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_403_reg))
+#define get_CAM_EMM_EMM_BUF_404_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_404_reg))
+#define get_CAM_EMM_EMM_BUF_405_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_405_reg))
+#define get_CAM_EMM_EMM_BUF_406_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_406_reg))
+#define get_CAM_EMM_EMM_BUF_407_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_407_reg))
+#define get_CAM_EMM_EMM_BUF_408_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_408_reg))
+#define get_CAM_EMM_EMM_BUF_409_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_409_reg))
+#define get_CAM_EMM_EMM_BUF_410_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_410_reg))
+#define get_CAM_EMM_EMM_BUF_411_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_411_reg))
+#define get_CAM_EMM_EMM_BUF_412_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_412_reg))
+#define get_CAM_EMM_EMM_BUF_413_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_413_reg))
+#define get_CAM_EMM_EMM_BUF_414_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_414_reg))
+#define get_CAM_EMM_EMM_BUF_415_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_415_reg))
+#define get_CAM_EMM_EMM_BUF_416_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_416_reg))
+#define get_CAM_EMM_EMM_BUF_417_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_417_reg))
+#define get_CAM_EMM_EMM_BUF_418_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_418_reg))
+#define get_CAM_EMM_EMM_BUF_419_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_419_reg))
+#define get_CAM_EMM_EMM_BUF_420_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_420_reg))
+#define get_CAM_EMM_EMM_BUF_421_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_421_reg))
+#define get_CAM_EMM_EMM_BUF_422_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_422_reg))
+#define get_CAM_EMM_EMM_BUF_423_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_423_reg))
+#define get_CAM_EMM_EMM_BUF_424_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_424_reg))
+#define get_CAM_EMM_EMM_BUF_425_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_425_reg))
+#define get_CAM_EMM_EMM_BUF_426_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_426_reg))
+#define get_CAM_EMM_EMM_BUF_427_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_427_reg))
+#define get_CAM_EMM_EMM_BUF_428_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_428_reg))
+#define get_CAM_EMM_EMM_BUF_429_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_429_reg))
+#define get_CAM_EMM_EMM_BUF_430_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_430_reg))
+#define get_CAM_EMM_EMM_BUF_431_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_431_reg))
+#define get_CAM_EMM_EMM_BUF_432_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_432_reg))
+#define get_CAM_EMM_EMM_BUF_433_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_433_reg))
+#define get_CAM_EMM_EMM_BUF_434_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_434_reg))
+#define get_CAM_EMM_EMM_BUF_435_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_435_reg))
+#define get_CAM_EMM_EMM_BUF_436_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_436_reg))
+#define get_CAM_EMM_EMM_BUF_437_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_437_reg))
+#define get_CAM_EMM_EMM_BUF_438_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_438_reg))
+#define get_CAM_EMM_EMM_BUF_439_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_439_reg))
+#define get_CAM_EMM_EMM_BUF_440_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_440_reg))
+#define get_CAM_EMM_EMM_BUF_441_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_441_reg))
+#define get_CAM_EMM_EMM_BUF_442_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_442_reg))
+#define get_CAM_EMM_EMM_BUF_443_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_443_reg))
+#define get_CAM_EMM_EMM_BUF_444_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_444_reg))
+#define get_CAM_EMM_EMM_BUF_445_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_445_reg))
+#define get_CAM_EMM_EMM_BUF_446_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_446_reg))
+#define get_CAM_EMM_EMM_BUF_447_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_447_reg))
+#define get_CAM_EMM_EMM_BUF_448_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_448_reg))
+#define get_CAM_EMM_EMM_BUF_449_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_449_reg))
+#define get_CAM_EMM_EMM_BUF_450_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_450_reg))
+#define get_CAM_EMM_EMM_BUF_451_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_451_reg))
+#define get_CAM_EMM_EMM_BUF_452_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_452_reg))
+#define get_CAM_EMM_EMM_BUF_453_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_453_reg))
+#define get_CAM_EMM_EMM_BUF_454_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_454_reg))
+#define get_CAM_EMM_EMM_BUF_455_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_455_reg))
+#define get_CAM_EMM_EMM_BUF_456_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_456_reg))
+#define get_CAM_EMM_EMM_BUF_457_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_457_reg))
+#define get_CAM_EMM_EMM_BUF_458_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_458_reg))
+#define get_CAM_EMM_EMM_BUF_459_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_459_reg))
+#define get_CAM_EMM_EMM_BUF_460_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_460_reg))
+#define get_CAM_EMM_EMM_BUF_461_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_461_reg))
+#define get_CAM_EMM_EMM_BUF_462_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_462_reg))
+#define get_CAM_EMM_EMM_BUF_463_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_463_reg))
+#define get_CAM_EMM_EMM_BUF_464_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_464_reg))
+#define get_CAM_EMM_EMM_BUF_465_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_465_reg))
+#define get_CAM_EMM_EMM_BUF_466_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_466_reg))
+#define get_CAM_EMM_EMM_BUF_467_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_467_reg))
+#define get_CAM_EMM_EMM_BUF_468_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_468_reg))
+#define get_CAM_EMM_EMM_BUF_469_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_469_reg))
+#define get_CAM_EMM_EMM_BUF_470_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_470_reg))
+#define get_CAM_EMM_EMM_BUF_471_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_471_reg))
+#define get_CAM_EMM_EMM_BUF_472_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_472_reg))
+#define get_CAM_EMM_EMM_BUF_473_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_473_reg))
+#define get_CAM_EMM_EMM_BUF_474_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_474_reg))
+#define get_CAM_EMM_EMM_BUF_475_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_475_reg))
+#define get_CAM_EMM_EMM_BUF_476_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_476_reg))
+#define get_CAM_EMM_EMM_BUF_477_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_477_reg))
+#define get_CAM_EMM_EMM_BUF_478_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_478_reg))
+#define get_CAM_EMM_EMM_BUF_479_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_479_reg))
+#define get_CAM_EMM_EMM_BUF_480_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_480_reg))
+#define get_CAM_EMM_EMM_BUF_481_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_481_reg))
+#define get_CAM_EMM_EMM_BUF_482_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_482_reg))
+#define get_CAM_EMM_EMM_BUF_483_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_483_reg))
+#define get_CAM_EMM_EMM_BUF_484_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_484_reg))
+#define get_CAM_EMM_EMM_BUF_485_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_485_reg))
+#define get_CAM_EMM_EMM_BUF_486_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_486_reg))
+#define get_CAM_EMM_EMM_BUF_487_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_487_reg))
+#define get_CAM_EMM_EMM_BUF_488_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_488_reg))
+#define get_CAM_EMM_EMM_BUF_489_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_489_reg))
+#define get_CAM_EMM_EMM_BUF_490_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_490_reg))
+#define get_CAM_EMM_EMM_BUF_491_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_491_reg))
+#define get_CAM_EMM_EMM_BUF_492_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_492_reg))
+#define get_CAM_EMM_EMM_BUF_493_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_493_reg))
+#define get_CAM_EMM_EMM_BUF_494_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_494_reg))
+#define get_CAM_EMM_EMM_BUF_495_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_495_reg))
+#define get_CAM_EMM_EMM_BUF_496_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_496_reg))
+#define get_CAM_EMM_EMM_BUF_497_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_497_reg))
+#define get_CAM_EMM_EMM_BUF_498_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_498_reg))
+#define get_CAM_EMM_EMM_BUF_499_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_499_reg))
+#define get_CAM_EMM_EMM_BUF_500_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_500_reg))
+#define get_CAM_EMM_EMM_BUF_501_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_501_reg))
+#define get_CAM_EMM_EMM_BUF_502_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_502_reg))
+#define get_CAM_EMM_EMM_BUF_503_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_503_reg))
+#define get_CAM_EMM_EMM_BUF_504_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_504_reg))
+#define get_CAM_EMM_EMM_BUF_505_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_505_reg))
+#define get_CAM_EMM_EMM_BUF_506_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_506_reg))
+#define get_CAM_EMM_EMM_BUF_507_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_507_reg))
+#define get_CAM_EMM_EMM_BUF_508_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_508_reg))
+#define get_CAM_EMM_EMM_BUF_509_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_509_reg))
+#define get_CAM_EMM_EMM_BUF_510_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_510_reg))
+#define get_CAM_EMM_EMM_BUF_511_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_511_reg))
+#define get_CAM_EMM_EMM_BUF_512_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_512_reg))
+#define get_CAM_EMM_EMM_BUF_513_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_513_reg))
+#define get_CAM_EMM_EMM_BUF_514_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_514_reg))
+#define get_CAM_EMM_EMM_BUF_515_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_515_reg))
+#define get_CAM_EMM_EMM_BUF_516_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_516_reg))
+#define get_CAM_EMM_EMM_BUF_517_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_517_reg))
+#define get_CAM_EMM_EMM_BUF_518_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_518_reg))
+#define get_CAM_EMM_EMM_BUF_519_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_519_reg))
+#define get_CAM_EMM_EMM_BUF_520_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_520_reg))
+#define get_CAM_EMM_EMM_BUF_521_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_521_reg))
+#define get_CAM_EMM_EMM_BUF_522_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_522_reg))
+#define get_CAM_EMM_EMM_BUF_523_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_523_reg))
+#define get_CAM_EMM_EMM_BUF_524_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_524_reg))
+#define get_CAM_EMM_EMM_BUF_525_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_525_reg))
+#define get_CAM_EMM_EMM_BUF_526_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_526_reg))
+#define get_CAM_EMM_EMM_BUF_527_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_527_reg))
+#define get_CAM_EMM_EMM_BUF_528_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_528_reg))
+#define get_CAM_EMM_EMM_BUF_529_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_529_reg))
+#define get_CAM_EMM_EMM_BUF_530_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_530_reg))
+#define get_CAM_EMM_EMM_BUF_531_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_531_reg))
+#define get_CAM_EMM_EMM_BUF_532_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_532_reg))
+#define get_CAM_EMM_EMM_BUF_533_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_533_reg))
+#define get_CAM_EMM_EMM_BUF_534_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_534_reg))
+#define get_CAM_EMM_EMM_BUF_535_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_535_reg))
+#define get_CAM_EMM_EMM_BUF_536_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_536_reg))
+#define get_CAM_EMM_EMM_BUF_537_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_537_reg))
+#define get_CAM_EMM_EMM_BUF_538_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_538_reg))
+#define get_CAM_EMM_EMM_BUF_539_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_539_reg))
+#define get_CAM_EMM_EMM_BUF_540_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_540_reg))
+#define get_CAM_EMM_EMM_BUF_541_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_541_reg))
+#define get_CAM_EMM_EMM_BUF_542_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_542_reg))
+#define get_CAM_EMM_EMM_BUF_543_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_543_reg))
+#define get_CAM_EMM_EMM_BUF_544_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_544_reg))
+#define get_CAM_EMM_EMM_BUF_545_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_545_reg))
+#define get_CAM_EMM_EMM_BUF_546_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_546_reg))
+#define get_CAM_EMM_EMM_BUF_547_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_547_reg))
+#define get_CAM_EMM_EMM_BUF_548_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_548_reg))
+#define get_CAM_EMM_EMM_BUF_549_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_549_reg))
+#define get_CAM_EMM_EMM_BUF_550_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_550_reg))
+#define get_CAM_EMM_EMM_BUF_551_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_551_reg))
+#define get_CAM_EMM_EMM_BUF_552_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_552_reg))
+#define get_CAM_EMM_EMM_BUF_553_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_553_reg))
+#define get_CAM_EMM_EMM_BUF_554_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_554_reg))
+#define get_CAM_EMM_EMM_BUF_555_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_555_reg))
+#define get_CAM_EMM_EMM_BUF_556_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_556_reg))
+#define get_CAM_EMM_EMM_BUF_557_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_557_reg))
+#define get_CAM_EMM_EMM_BUF_558_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_558_reg))
+#define get_CAM_EMM_EMM_BUF_559_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_559_reg))
+#define get_CAM_EMM_EMM_BUF_560_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_560_reg))
+#define get_CAM_EMM_EMM_BUF_561_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_561_reg))
+#define get_CAM_EMM_EMM_BUF_562_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_562_reg))
+#define get_CAM_EMM_EMM_BUF_563_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_563_reg))
+#define get_CAM_EMM_EMM_BUF_564_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_564_reg))
+#define get_CAM_EMM_EMM_BUF_565_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_565_reg))
+#define get_CAM_EMM_EMM_BUF_566_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_566_reg))
+#define get_CAM_EMM_EMM_BUF_567_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_567_reg))
+#define get_CAM_EMM_EMM_BUF_568_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_568_reg))
+#define get_CAM_EMM_EMM_BUF_569_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_569_reg))
+#define get_CAM_EMM_EMM_BUF_570_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_570_reg))
+#define get_CAM_EMM_EMM_BUF_571_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_571_reg))
+#define get_CAM_EMM_EMM_BUF_572_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_572_reg))
+#define get_CAM_EMM_EMM_BUF_573_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_573_reg))
+#define get_CAM_EMM_EMM_BUF_574_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_574_reg))
+#define get_CAM_EMM_EMM_BUF_575_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_575_reg))
+#define get_CAM_EMM_EMM_BUF_576_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_576_reg))
+#define get_CAM_EMM_EMM_BUF_577_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_577_reg))
+#define get_CAM_EMM_EMM_BUF_578_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_578_reg))
+#define get_CAM_EMM_EMM_BUF_579_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_579_reg))
+#define get_CAM_EMM_EMM_BUF_580_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_580_reg))
+#define get_CAM_EMM_EMM_BUF_581_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_581_reg))
+#define get_CAM_EMM_EMM_BUF_582_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_582_reg))
+#define get_CAM_EMM_EMM_BUF_583_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_583_reg))
+#define get_CAM_EMM_EMM_BUF_584_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_584_reg))
+#define get_CAM_EMM_EMM_BUF_585_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_585_reg))
+#define get_CAM_EMM_EMM_BUF_586_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_586_reg))
+#define get_CAM_EMM_EMM_BUF_587_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_587_reg))
+#define get_CAM_EMM_EMM_BUF_588_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_588_reg))
+#define get_CAM_EMM_EMM_BUF_589_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_589_reg))
+#define get_CAM_EMM_EMM_BUF_590_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_590_reg))
+#define get_CAM_EMM_EMM_BUF_591_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_591_reg))
+#define get_CAM_EMM_EMM_BUF_592_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_592_reg))
+#define get_CAM_EMM_EMM_BUF_593_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_593_reg))
+#define get_CAM_EMM_EMM_BUF_594_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_594_reg))
+#define get_CAM_EMM_EMM_BUF_595_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_595_reg))
+#define get_CAM_EMM_EMM_BUF_596_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_596_reg))
+#define get_CAM_EMM_EMM_BUF_597_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_597_reg))
+#define get_CAM_EMM_EMM_BUF_598_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_598_reg))
+#define get_CAM_EMM_EMM_BUF_599_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_599_reg))
+#define get_CAM_EMM_EMM_BUF_600_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_600_reg))
+#define get_CAM_EMM_EMM_BUF_601_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_601_reg))
+#define get_CAM_EMM_EMM_BUF_602_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_602_reg))
+#define get_CAM_EMM_EMM_BUF_603_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_603_reg))
+#define get_CAM_EMM_EMM_BUF_604_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_604_reg))
+#define get_CAM_EMM_EMM_BUF_605_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_605_reg))
+#define get_CAM_EMM_EMM_BUF_606_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_606_reg))
+#define get_CAM_EMM_EMM_BUF_607_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_607_reg))
+#define get_CAM_EMM_EMM_BUF_608_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_608_reg))
+#define get_CAM_EMM_EMM_BUF_609_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_609_reg))
+#define get_CAM_EMM_EMM_BUF_610_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_610_reg))
+#define get_CAM_EMM_EMM_BUF_611_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_611_reg))
+#define get_CAM_EMM_EMM_BUF_612_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_612_reg))
+#define get_CAM_EMM_EMM_BUF_613_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_613_reg))
+#define get_CAM_EMM_EMM_BUF_614_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_614_reg))
+#define get_CAM_EMM_EMM_BUF_615_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_615_reg))
+#define get_CAM_EMM_EMM_BUF_616_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_616_reg))
+#define get_CAM_EMM_EMM_BUF_617_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_617_reg))
+#define get_CAM_EMM_EMM_BUF_618_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_618_reg))
+#define get_CAM_EMM_EMM_BUF_619_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_619_reg))
+#define get_CAM_EMM_EMM_BUF_620_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_620_reg))
+#define get_CAM_EMM_EMM_BUF_621_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_621_reg))
+#define get_CAM_EMM_EMM_BUF_622_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_622_reg))
+#define get_CAM_EMM_EMM_BUF_623_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_623_reg))
+#define get_CAM_EMM_EMM_BUF_624_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_624_reg))
+#define get_CAM_EMM_EMM_BUF_625_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_625_reg))
+#define get_CAM_EMM_EMM_BUF_626_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_626_reg))
+#define get_CAM_EMM_EMM_BUF_627_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_627_reg))
+#define get_CAM_EMM_EMM_BUF_628_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_628_reg))
+#define get_CAM_EMM_EMM_BUF_629_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_629_reg))
+#define get_CAM_EMM_EMM_BUF_630_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_630_reg))
+#define get_CAM_EMM_EMM_BUF_631_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_631_reg))
+#define get_CAM_EMM_EMM_BUF_632_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_632_reg))
+#define get_CAM_EMM_EMM_BUF_633_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_633_reg))
+#define get_CAM_EMM_EMM_BUF_634_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_634_reg))
+#define get_CAM_EMM_EMM_BUF_635_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_635_reg))
+#define get_CAM_EMM_EMM_BUF_636_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_636_reg))
+#define get_CAM_EMM_EMM_BUF_637_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_637_reg))
+#define get_CAM_EMM_EMM_BUF_638_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_638_reg))
+#define get_CAM_EMM_EMM_BUF_639_reg   (*((volatile unsigned int*) CAM_EMM_EMM_BUF_639_reg))
+#define CAM_EMM_EMM_BUF_0_inst_adr                                                   "0x0080"
+#define CAM_EMM_EMM_BUF_1_inst_adr                                                   "0x0081"
+#define CAM_EMM_EMM_BUF_2_inst_adr                                                   "0x0082"
+#define CAM_EMM_EMM_BUF_3_inst_adr                                                   "0x0083"
+#define CAM_EMM_EMM_BUF_4_inst_adr                                                   "0x0084"
+#define CAM_EMM_EMM_BUF_5_inst_adr                                                   "0x0085"
+#define CAM_EMM_EMM_BUF_6_inst_adr                                                   "0x0086"
+#define CAM_EMM_EMM_BUF_7_inst_adr                                                   "0x0087"
+#define CAM_EMM_EMM_BUF_8_inst_adr                                                   "0x0088"
+#define CAM_EMM_EMM_BUF_9_inst_adr                                                   "0x0089"
+#define CAM_EMM_EMM_BUF_10_inst_adr                                                   "0x008A"
+#define CAM_EMM_EMM_BUF_11_inst_adr                                                   "0x008B"
+#define CAM_EMM_EMM_BUF_12_inst_adr                                                   "0x008C"
+#define CAM_EMM_EMM_BUF_13_inst_adr                                                   "0x008D"
+#define CAM_EMM_EMM_BUF_14_inst_adr                                                   "0x008E"
+#define CAM_EMM_EMM_BUF_15_inst_adr                                                   "0x008F"
+#define CAM_EMM_EMM_BUF_16_inst_adr                                                   "0x0090"
+#define CAM_EMM_EMM_BUF_17_inst_adr                                                   "0x0091"
+#define CAM_EMM_EMM_BUF_18_inst_adr                                                   "0x0092"
+#define CAM_EMM_EMM_BUF_19_inst_adr                                                   "0x0093"
+#define CAM_EMM_EMM_BUF_20_inst_adr                                                   "0x0094"
+#define CAM_EMM_EMM_BUF_21_inst_adr                                                   "0x0095"
+#define CAM_EMM_EMM_BUF_22_inst_adr                                                   "0x0096"
+#define CAM_EMM_EMM_BUF_23_inst_adr                                                   "0x0097"
+#define CAM_EMM_EMM_BUF_24_inst_adr                                                   "0x0098"
+#define CAM_EMM_EMM_BUF_25_inst_adr                                                   "0x0099"
+#define CAM_EMM_EMM_BUF_26_inst_adr                                                   "0x009A"
+#define CAM_EMM_EMM_BUF_27_inst_adr                                                   "0x009B"
+#define CAM_EMM_EMM_BUF_28_inst_adr                                                   "0x009C"
+#define CAM_EMM_EMM_BUF_29_inst_adr                                                   "0x009D"
+#define CAM_EMM_EMM_BUF_30_inst_adr                                                   "0x009E"
+#define CAM_EMM_EMM_BUF_31_inst_adr                                                   "0x009F"
+#define CAM_EMM_EMM_BUF_32_inst_adr                                                   "0x00A0"
+#define CAM_EMM_EMM_BUF_33_inst_adr                                                   "0x00A1"
+#define CAM_EMM_EMM_BUF_34_inst_adr                                                   "0x00A2"
+#define CAM_EMM_EMM_BUF_35_inst_adr                                                   "0x00A3"
+#define CAM_EMM_EMM_BUF_36_inst_adr                                                   "0x00A4"
+#define CAM_EMM_EMM_BUF_37_inst_adr                                                   "0x00A5"
+#define CAM_EMM_EMM_BUF_38_inst_adr                                                   "0x00A6"
+#define CAM_EMM_EMM_BUF_39_inst_adr                                                   "0x00A7"
+#define CAM_EMM_EMM_BUF_40_inst_adr                                                   "0x00A8"
+#define CAM_EMM_EMM_BUF_41_inst_adr                                                   "0x00A9"
+#define CAM_EMM_EMM_BUF_42_inst_adr                                                   "0x00AA"
+#define CAM_EMM_EMM_BUF_43_inst_adr                                                   "0x00AB"
+#define CAM_EMM_EMM_BUF_44_inst_adr                                                   "0x00AC"
+#define CAM_EMM_EMM_BUF_45_inst_adr                                                   "0x00AD"
+#define CAM_EMM_EMM_BUF_46_inst_adr                                                   "0x00AE"
+#define CAM_EMM_EMM_BUF_47_inst_adr                                                   "0x00AF"
+#define CAM_EMM_EMM_BUF_48_inst_adr                                                   "0x00B0"
+#define CAM_EMM_EMM_BUF_49_inst_adr                                                   "0x00B1"
+#define CAM_EMM_EMM_BUF_50_inst_adr                                                   "0x00B2"
+#define CAM_EMM_EMM_BUF_51_inst_adr                                                   "0x00B3"
+#define CAM_EMM_EMM_BUF_52_inst_adr                                                   "0x00B4"
+#define CAM_EMM_EMM_BUF_53_inst_adr                                                   "0x00B5"
+#define CAM_EMM_EMM_BUF_54_inst_adr                                                   "0x00B6"
+#define CAM_EMM_EMM_BUF_55_inst_adr                                                   "0x00B7"
+#define CAM_EMM_EMM_BUF_56_inst_adr                                                   "0x00B8"
+#define CAM_EMM_EMM_BUF_57_inst_adr                                                   "0x00B9"
+#define CAM_EMM_EMM_BUF_58_inst_adr                                                   "0x00BA"
+#define CAM_EMM_EMM_BUF_59_inst_adr                                                   "0x00BB"
+#define CAM_EMM_EMM_BUF_60_inst_adr                                                   "0x00BC"
+#define CAM_EMM_EMM_BUF_61_inst_adr                                                   "0x00BD"
+#define CAM_EMM_EMM_BUF_62_inst_adr                                                   "0x00BE"
+#define CAM_EMM_EMM_BUF_63_inst_adr                                                   "0x00BF"
+#define CAM_EMM_EMM_BUF_64_inst_adr                                                   "0x00C0"
+#define CAM_EMM_EMM_BUF_65_inst_adr                                                   "0x00C1"
+#define CAM_EMM_EMM_BUF_66_inst_adr                                                   "0x00C2"
+#define CAM_EMM_EMM_BUF_67_inst_adr                                                   "0x00C3"
+#define CAM_EMM_EMM_BUF_68_inst_adr                                                   "0x00C4"
+#define CAM_EMM_EMM_BUF_69_inst_adr                                                   "0x00C5"
+#define CAM_EMM_EMM_BUF_70_inst_adr                                                   "0x00C6"
+#define CAM_EMM_EMM_BUF_71_inst_adr                                                   "0x00C7"
+#define CAM_EMM_EMM_BUF_72_inst_adr                                                   "0x00C8"
+#define CAM_EMM_EMM_BUF_73_inst_adr                                                   "0x00C9"
+#define CAM_EMM_EMM_BUF_74_inst_adr                                                   "0x00CA"
+#define CAM_EMM_EMM_BUF_75_inst_adr                                                   "0x00CB"
+#define CAM_EMM_EMM_BUF_76_inst_adr                                                   "0x00CC"
+#define CAM_EMM_EMM_BUF_77_inst_adr                                                   "0x00CD"
+#define CAM_EMM_EMM_BUF_78_inst_adr                                                   "0x00CE"
+#define CAM_EMM_EMM_BUF_79_inst_adr                                                   "0x00CF"
+#define CAM_EMM_EMM_BUF_80_inst_adr                                                   "0x00D0"
+#define CAM_EMM_EMM_BUF_81_inst_adr                                                   "0x00D1"
+#define CAM_EMM_EMM_BUF_82_inst_adr                                                   "0x00D2"
+#define CAM_EMM_EMM_BUF_83_inst_adr                                                   "0x00D3"
+#define CAM_EMM_EMM_BUF_84_inst_adr                                                   "0x00D4"
+#define CAM_EMM_EMM_BUF_85_inst_adr                                                   "0x00D5"
+#define CAM_EMM_EMM_BUF_86_inst_adr                                                   "0x00D6"
+#define CAM_EMM_EMM_BUF_87_inst_adr                                                   "0x00D7"
+#define CAM_EMM_EMM_BUF_88_inst_adr                                                   "0x00D8"
+#define CAM_EMM_EMM_BUF_89_inst_adr                                                   "0x00D9"
+#define CAM_EMM_EMM_BUF_90_inst_adr                                                   "0x00DA"
+#define CAM_EMM_EMM_BUF_91_inst_adr                                                   "0x00DB"
+#define CAM_EMM_EMM_BUF_92_inst_adr                                                   "0x00DC"
+#define CAM_EMM_EMM_BUF_93_inst_adr                                                   "0x00DD"
+#define CAM_EMM_EMM_BUF_94_inst_adr                                                   "0x00DE"
+#define CAM_EMM_EMM_BUF_95_inst_adr                                                   "0x00DF"
+#define CAM_EMM_EMM_BUF_96_inst_adr                                                   "0x00E0"
+#define CAM_EMM_EMM_BUF_97_inst_adr                                                   "0x00E1"
+#define CAM_EMM_EMM_BUF_98_inst_adr                                                   "0x00E2"
+#define CAM_EMM_EMM_BUF_99_inst_adr                                                   "0x00E3"
+#define CAM_EMM_EMM_BUF_100_inst_adr                                                   "0x00E4"
+#define CAM_EMM_EMM_BUF_101_inst_adr                                                   "0x00E5"
+#define CAM_EMM_EMM_BUF_102_inst_adr                                                   "0x00E6"
+#define CAM_EMM_EMM_BUF_103_inst_adr                                                   "0x00E7"
+#define CAM_EMM_EMM_BUF_104_inst_adr                                                   "0x00E8"
+#define CAM_EMM_EMM_BUF_105_inst_adr                                                   "0x00E9"
+#define CAM_EMM_EMM_BUF_106_inst_adr                                                   "0x00EA"
+#define CAM_EMM_EMM_BUF_107_inst_adr                                                   "0x00EB"
+#define CAM_EMM_EMM_BUF_108_inst_adr                                                   "0x00EC"
+#define CAM_EMM_EMM_BUF_109_inst_adr                                                   "0x00ED"
+#define CAM_EMM_EMM_BUF_110_inst_adr                                                   "0x00EE"
+#define CAM_EMM_EMM_BUF_111_inst_adr                                                   "0x00EF"
+#define CAM_EMM_EMM_BUF_112_inst_adr                                                   "0x00F0"
+#define CAM_EMM_EMM_BUF_113_inst_adr                                                   "0x00F1"
+#define CAM_EMM_EMM_BUF_114_inst_adr                                                   "0x00F2"
+#define CAM_EMM_EMM_BUF_115_inst_adr                                                   "0x00F3"
+#define CAM_EMM_EMM_BUF_116_inst_adr                                                   "0x00F4"
+#define CAM_EMM_EMM_BUF_117_inst_adr                                                   "0x00F5"
+#define CAM_EMM_EMM_BUF_118_inst_adr                                                   "0x00F6"
+#define CAM_EMM_EMM_BUF_119_inst_adr                                                   "0x00F7"
+#define CAM_EMM_EMM_BUF_120_inst_adr                                                   "0x00F8"
+#define CAM_EMM_EMM_BUF_121_inst_adr                                                   "0x00F9"
+#define CAM_EMM_EMM_BUF_122_inst_adr                                                   "0x00FA"
+#define CAM_EMM_EMM_BUF_123_inst_adr                                                   "0x00FB"
+#define CAM_EMM_EMM_BUF_124_inst_adr                                                   "0x00FC"
+#define CAM_EMM_EMM_BUF_125_inst_adr                                                   "0x00FD"
+#define CAM_EMM_EMM_BUF_126_inst_adr                                                   "0x00FE"
+#define CAM_EMM_EMM_BUF_127_inst_adr                                                   "0x00FF"
+#define CAM_EMM_EMM_BUF_128_inst_adr                                                   "0x0100"
+#define CAM_EMM_EMM_BUF_129_inst_adr                                                   "0x0101"
+#define CAM_EMM_EMM_BUF_130_inst_adr                                                   "0x0102"
+#define CAM_EMM_EMM_BUF_131_inst_adr                                                   "0x0103"
+#define CAM_EMM_EMM_BUF_132_inst_adr                                                   "0x0104"
+#define CAM_EMM_EMM_BUF_133_inst_adr                                                   "0x0105"
+#define CAM_EMM_EMM_BUF_134_inst_adr                                                   "0x0106"
+#define CAM_EMM_EMM_BUF_135_inst_adr                                                   "0x0107"
+#define CAM_EMM_EMM_BUF_136_inst_adr                                                   "0x0108"
+#define CAM_EMM_EMM_BUF_137_inst_adr                                                   "0x0109"
+#define CAM_EMM_EMM_BUF_138_inst_adr                                                   "0x010A"
+#define CAM_EMM_EMM_BUF_139_inst_adr                                                   "0x010B"
+#define CAM_EMM_EMM_BUF_140_inst_adr                                                   "0x010C"
+#define CAM_EMM_EMM_BUF_141_inst_adr                                                   "0x010D"
+#define CAM_EMM_EMM_BUF_142_inst_adr                                                   "0x010E"
+#define CAM_EMM_EMM_BUF_143_inst_adr                                                   "0x010F"
+#define CAM_EMM_EMM_BUF_144_inst_adr                                                   "0x0110"
+#define CAM_EMM_EMM_BUF_145_inst_adr                                                   "0x0111"
+#define CAM_EMM_EMM_BUF_146_inst_adr                                                   "0x0112"
+#define CAM_EMM_EMM_BUF_147_inst_adr                                                   "0x0113"
+#define CAM_EMM_EMM_BUF_148_inst_adr                                                   "0x0114"
+#define CAM_EMM_EMM_BUF_149_inst_adr                                                   "0x0115"
+#define CAM_EMM_EMM_BUF_150_inst_adr                                                   "0x0116"
+#define CAM_EMM_EMM_BUF_151_inst_adr                                                   "0x0117"
+#define CAM_EMM_EMM_BUF_152_inst_adr                                                   "0x0118"
+#define CAM_EMM_EMM_BUF_153_inst_adr                                                   "0x0119"
+#define CAM_EMM_EMM_BUF_154_inst_adr                                                   "0x011A"
+#define CAM_EMM_EMM_BUF_155_inst_adr                                                   "0x011B"
+#define CAM_EMM_EMM_BUF_156_inst_adr                                                   "0x011C"
+#define CAM_EMM_EMM_BUF_157_inst_adr                                                   "0x011D"
+#define CAM_EMM_EMM_BUF_158_inst_adr                                                   "0x011E"
+#define CAM_EMM_EMM_BUF_159_inst_adr                                                   "0x011F"
+#define CAM_EMM_EMM_BUF_160_inst_adr                                                   "0x0120"
+#define CAM_EMM_EMM_BUF_161_inst_adr                                                   "0x0121"
+#define CAM_EMM_EMM_BUF_162_inst_adr                                                   "0x0122"
+#define CAM_EMM_EMM_BUF_163_inst_adr                                                   "0x0123"
+#define CAM_EMM_EMM_BUF_164_inst_adr                                                   "0x0124"
+#define CAM_EMM_EMM_BUF_165_inst_adr                                                   "0x0125"
+#define CAM_EMM_EMM_BUF_166_inst_adr                                                   "0x0126"
+#define CAM_EMM_EMM_BUF_167_inst_adr                                                   "0x0127"
+#define CAM_EMM_EMM_BUF_168_inst_adr                                                   "0x0128"
+#define CAM_EMM_EMM_BUF_169_inst_adr                                                   "0x0129"
+#define CAM_EMM_EMM_BUF_170_inst_adr                                                   "0x012A"
+#define CAM_EMM_EMM_BUF_171_inst_adr                                                   "0x012B"
+#define CAM_EMM_EMM_BUF_172_inst_adr                                                   "0x012C"
+#define CAM_EMM_EMM_BUF_173_inst_adr                                                   "0x012D"
+#define CAM_EMM_EMM_BUF_174_inst_adr                                                   "0x012E"
+#define CAM_EMM_EMM_BUF_175_inst_adr                                                   "0x012F"
+#define CAM_EMM_EMM_BUF_176_inst_adr                                                   "0x0130"
+#define CAM_EMM_EMM_BUF_177_inst_adr                                                   "0x0131"
+#define CAM_EMM_EMM_BUF_178_inst_adr                                                   "0x0132"
+#define CAM_EMM_EMM_BUF_179_inst_adr                                                   "0x0133"
+#define CAM_EMM_EMM_BUF_180_inst_adr                                                   "0x0134"
+#define CAM_EMM_EMM_BUF_181_inst_adr                                                   "0x0135"
+#define CAM_EMM_EMM_BUF_182_inst_adr                                                   "0x0136"
+#define CAM_EMM_EMM_BUF_183_inst_adr                                                   "0x0137"
+#define CAM_EMM_EMM_BUF_184_inst_adr                                                   "0x0138"
+#define CAM_EMM_EMM_BUF_185_inst_adr                                                   "0x0139"
+#define CAM_EMM_EMM_BUF_186_inst_adr                                                   "0x013A"
+#define CAM_EMM_EMM_BUF_187_inst_adr                                                   "0x013B"
+#define CAM_EMM_EMM_BUF_188_inst_adr                                                   "0x013C"
+#define CAM_EMM_EMM_BUF_189_inst_adr                                                   "0x013D"
+#define CAM_EMM_EMM_BUF_190_inst_adr                                                   "0x013E"
+#define CAM_EMM_EMM_BUF_191_inst_adr                                                   "0x013F"
+#define CAM_EMM_EMM_BUF_192_inst_adr                                                   "0x0140"
+#define CAM_EMM_EMM_BUF_193_inst_adr                                                   "0x0141"
+#define CAM_EMM_EMM_BUF_194_inst_adr                                                   "0x0142"
+#define CAM_EMM_EMM_BUF_195_inst_adr                                                   "0x0143"
+#define CAM_EMM_EMM_BUF_196_inst_adr                                                   "0x0144"
+#define CAM_EMM_EMM_BUF_197_inst_adr                                                   "0x0145"
+#define CAM_EMM_EMM_BUF_198_inst_adr                                                   "0x0146"
+#define CAM_EMM_EMM_BUF_199_inst_adr                                                   "0x0147"
+#define CAM_EMM_EMM_BUF_200_inst_adr                                                   "0x0148"
+#define CAM_EMM_EMM_BUF_201_inst_adr                                                   "0x0149"
+#define CAM_EMM_EMM_BUF_202_inst_adr                                                   "0x014A"
+#define CAM_EMM_EMM_BUF_203_inst_adr                                                   "0x014B"
+#define CAM_EMM_EMM_BUF_204_inst_adr                                                   "0x014C"
+#define CAM_EMM_EMM_BUF_205_inst_adr                                                   "0x014D"
+#define CAM_EMM_EMM_BUF_206_inst_adr                                                   "0x014E"
+#define CAM_EMM_EMM_BUF_207_inst_adr                                                   "0x014F"
+#define CAM_EMM_EMM_BUF_208_inst_adr                                                   "0x0150"
+#define CAM_EMM_EMM_BUF_209_inst_adr                                                   "0x0151"
+#define CAM_EMM_EMM_BUF_210_inst_adr                                                   "0x0152"
+#define CAM_EMM_EMM_BUF_211_inst_adr                                                   "0x0153"
+#define CAM_EMM_EMM_BUF_212_inst_adr                                                   "0x0154"
+#define CAM_EMM_EMM_BUF_213_inst_adr                                                   "0x0155"
+#define CAM_EMM_EMM_BUF_214_inst_adr                                                   "0x0156"
+#define CAM_EMM_EMM_BUF_215_inst_adr                                                   "0x0157"
+#define CAM_EMM_EMM_BUF_216_inst_adr                                                   "0x0158"
+#define CAM_EMM_EMM_BUF_217_inst_adr                                                   "0x0159"
+#define CAM_EMM_EMM_BUF_218_inst_adr                                                   "0x015A"
+#define CAM_EMM_EMM_BUF_219_inst_adr                                                   "0x015B"
+#define CAM_EMM_EMM_BUF_220_inst_adr                                                   "0x015C"
+#define CAM_EMM_EMM_BUF_221_inst_adr                                                   "0x015D"
+#define CAM_EMM_EMM_BUF_222_inst_adr                                                   "0x015E"
+#define CAM_EMM_EMM_BUF_223_inst_adr                                                   "0x015F"
+#define CAM_EMM_EMM_BUF_224_inst_adr                                                   "0x0160"
+#define CAM_EMM_EMM_BUF_225_inst_adr                                                   "0x0161"
+#define CAM_EMM_EMM_BUF_226_inst_adr                                                   "0x0162"
+#define CAM_EMM_EMM_BUF_227_inst_adr                                                   "0x0163"
+#define CAM_EMM_EMM_BUF_228_inst_adr                                                   "0x0164"
+#define CAM_EMM_EMM_BUF_229_inst_adr                                                   "0x0165"
+#define CAM_EMM_EMM_BUF_230_inst_adr                                                   "0x0166"
+#define CAM_EMM_EMM_BUF_231_inst_adr                                                   "0x0167"
+#define CAM_EMM_EMM_BUF_232_inst_adr                                                   "0x0168"
+#define CAM_EMM_EMM_BUF_233_inst_adr                                                   "0x0169"
+#define CAM_EMM_EMM_BUF_234_inst_adr                                                   "0x016A"
+#define CAM_EMM_EMM_BUF_235_inst_adr                                                   "0x016B"
+#define CAM_EMM_EMM_BUF_236_inst_adr                                                   "0x016C"
+#define CAM_EMM_EMM_BUF_237_inst_adr                                                   "0x016D"
+#define CAM_EMM_EMM_BUF_238_inst_adr                                                   "0x016E"
+#define CAM_EMM_EMM_BUF_239_inst_adr                                                   "0x016F"
+#define CAM_EMM_EMM_BUF_240_inst_adr                                                   "0x0170"
+#define CAM_EMM_EMM_BUF_241_inst_adr                                                   "0x0171"
+#define CAM_EMM_EMM_BUF_242_inst_adr                                                   "0x0172"
+#define CAM_EMM_EMM_BUF_243_inst_adr                                                   "0x0173"
+#define CAM_EMM_EMM_BUF_244_inst_adr                                                   "0x0174"
+#define CAM_EMM_EMM_BUF_245_inst_adr                                                   "0x0175"
+#define CAM_EMM_EMM_BUF_246_inst_adr                                                   "0x0176"
+#define CAM_EMM_EMM_BUF_247_inst_adr                                                   "0x0177"
+#define CAM_EMM_EMM_BUF_248_inst_adr                                                   "0x0178"
+#define CAM_EMM_EMM_BUF_249_inst_adr                                                   "0x0179"
+#define CAM_EMM_EMM_BUF_250_inst_adr                                                   "0x017A"
+#define CAM_EMM_EMM_BUF_251_inst_adr                                                   "0x017B"
+#define CAM_EMM_EMM_BUF_252_inst_adr                                                   "0x017C"
+#define CAM_EMM_EMM_BUF_253_inst_adr                                                   "0x017D"
+#define CAM_EMM_EMM_BUF_254_inst_adr                                                   "0x017E"
+#define CAM_EMM_EMM_BUF_255_inst_adr                                                   "0x017F"
+#define CAM_EMM_EMM_BUF_256_inst_adr                                                   "0x0180"
+#define CAM_EMM_EMM_BUF_257_inst_adr                                                   "0x0181"
+#define CAM_EMM_EMM_BUF_258_inst_adr                                                   "0x0182"
+#define CAM_EMM_EMM_BUF_259_inst_adr                                                   "0x0183"
+#define CAM_EMM_EMM_BUF_260_inst_adr                                                   "0x0184"
+#define CAM_EMM_EMM_BUF_261_inst_adr                                                   "0x0185"
+#define CAM_EMM_EMM_BUF_262_inst_adr                                                   "0x0186"
+#define CAM_EMM_EMM_BUF_263_inst_adr                                                   "0x0187"
+#define CAM_EMM_EMM_BUF_264_inst_adr                                                   "0x0188"
+#define CAM_EMM_EMM_BUF_265_inst_adr                                                   "0x0189"
+#define CAM_EMM_EMM_BUF_266_inst_adr                                                   "0x018A"
+#define CAM_EMM_EMM_BUF_267_inst_adr                                                   "0x018B"
+#define CAM_EMM_EMM_BUF_268_inst_adr                                                   "0x018C"
+#define CAM_EMM_EMM_BUF_269_inst_adr                                                   "0x018D"
+#define CAM_EMM_EMM_BUF_270_inst_adr                                                   "0x018E"
+#define CAM_EMM_EMM_BUF_271_inst_adr                                                   "0x018F"
+#define CAM_EMM_EMM_BUF_272_inst_adr                                                   "0x0190"
+#define CAM_EMM_EMM_BUF_273_inst_adr                                                   "0x0191"
+#define CAM_EMM_EMM_BUF_274_inst_adr                                                   "0x0192"
+#define CAM_EMM_EMM_BUF_275_inst_adr                                                   "0x0193"
+#define CAM_EMM_EMM_BUF_276_inst_adr                                                   "0x0194"
+#define CAM_EMM_EMM_BUF_277_inst_adr                                                   "0x0195"
+#define CAM_EMM_EMM_BUF_278_inst_adr                                                   "0x0196"
+#define CAM_EMM_EMM_BUF_279_inst_adr                                                   "0x0197"
+#define CAM_EMM_EMM_BUF_280_inst_adr                                                   "0x0198"
+#define CAM_EMM_EMM_BUF_281_inst_adr                                                   "0x0199"
+#define CAM_EMM_EMM_BUF_282_inst_adr                                                   "0x019A"
+#define CAM_EMM_EMM_BUF_283_inst_adr                                                   "0x019B"
+#define CAM_EMM_EMM_BUF_284_inst_adr                                                   "0x019C"
+#define CAM_EMM_EMM_BUF_285_inst_adr                                                   "0x019D"
+#define CAM_EMM_EMM_BUF_286_inst_adr                                                   "0x019E"
+#define CAM_EMM_EMM_BUF_287_inst_adr                                                   "0x019F"
+#define CAM_EMM_EMM_BUF_288_inst_adr                                                   "0x01A0"
+#define CAM_EMM_EMM_BUF_289_inst_adr                                                   "0x01A1"
+#define CAM_EMM_EMM_BUF_290_inst_adr                                                   "0x01A2"
+#define CAM_EMM_EMM_BUF_291_inst_adr                                                   "0x01A3"
+#define CAM_EMM_EMM_BUF_292_inst_adr                                                   "0x01A4"
+#define CAM_EMM_EMM_BUF_293_inst_adr                                                   "0x01A5"
+#define CAM_EMM_EMM_BUF_294_inst_adr                                                   "0x01A6"
+#define CAM_EMM_EMM_BUF_295_inst_adr                                                   "0x01A7"
+#define CAM_EMM_EMM_BUF_296_inst_adr                                                   "0x01A8"
+#define CAM_EMM_EMM_BUF_297_inst_adr                                                   "0x01A9"
+#define CAM_EMM_EMM_BUF_298_inst_adr                                                   "0x01AA"
+#define CAM_EMM_EMM_BUF_299_inst_adr                                                   "0x01AB"
+#define CAM_EMM_EMM_BUF_300_inst_adr                                                   "0x01AC"
+#define CAM_EMM_EMM_BUF_301_inst_adr                                                   "0x01AD"
+#define CAM_EMM_EMM_BUF_302_inst_adr                                                   "0x01AE"
+#define CAM_EMM_EMM_BUF_303_inst_adr                                                   "0x01AF"
+#define CAM_EMM_EMM_BUF_304_inst_adr                                                   "0x01B0"
+#define CAM_EMM_EMM_BUF_305_inst_adr                                                   "0x01B1"
+#define CAM_EMM_EMM_BUF_306_inst_adr                                                   "0x01B2"
+#define CAM_EMM_EMM_BUF_307_inst_adr                                                   "0x01B3"
+#define CAM_EMM_EMM_BUF_308_inst_adr                                                   "0x01B4"
+#define CAM_EMM_EMM_BUF_309_inst_adr                                                   "0x01B5"
+#define CAM_EMM_EMM_BUF_310_inst_adr                                                   "0x01B6"
+#define CAM_EMM_EMM_BUF_311_inst_adr                                                   "0x01B7"
+#define CAM_EMM_EMM_BUF_312_inst_adr                                                   "0x01B8"
+#define CAM_EMM_EMM_BUF_313_inst_adr                                                   "0x01B9"
+#define CAM_EMM_EMM_BUF_314_inst_adr                                                   "0x01BA"
+#define CAM_EMM_EMM_BUF_315_inst_adr                                                   "0x01BB"
+#define CAM_EMM_EMM_BUF_316_inst_adr                                                   "0x01BC"
+#define CAM_EMM_EMM_BUF_317_inst_adr                                                   "0x01BD"
+#define CAM_EMM_EMM_BUF_318_inst_adr                                                   "0x01BE"
+#define CAM_EMM_EMM_BUF_319_inst_adr                                                   "0x01BF"
+#define CAM_EMM_EMM_BUF_320_inst_adr                                                   "0x01C0"
+#define CAM_EMM_EMM_BUF_321_inst_adr                                                   "0x01C1"
+#define CAM_EMM_EMM_BUF_322_inst_adr                                                   "0x01C2"
+#define CAM_EMM_EMM_BUF_323_inst_adr                                                   "0x01C3"
+#define CAM_EMM_EMM_BUF_324_inst_adr                                                   "0x01C4"
+#define CAM_EMM_EMM_BUF_325_inst_adr                                                   "0x01C5"
+#define CAM_EMM_EMM_BUF_326_inst_adr                                                   "0x01C6"
+#define CAM_EMM_EMM_BUF_327_inst_adr                                                   "0x01C7"
+#define CAM_EMM_EMM_BUF_328_inst_adr                                                   "0x01C8"
+#define CAM_EMM_EMM_BUF_329_inst_adr                                                   "0x01C9"
+#define CAM_EMM_EMM_BUF_330_inst_adr                                                   "0x01CA"
+#define CAM_EMM_EMM_BUF_331_inst_adr                                                   "0x01CB"
+#define CAM_EMM_EMM_BUF_332_inst_adr                                                   "0x01CC"
+#define CAM_EMM_EMM_BUF_333_inst_adr                                                   "0x01CD"
+#define CAM_EMM_EMM_BUF_334_inst_adr                                                   "0x01CE"
+#define CAM_EMM_EMM_BUF_335_inst_adr                                                   "0x01CF"
+#define CAM_EMM_EMM_BUF_336_inst_adr                                                   "0x01D0"
+#define CAM_EMM_EMM_BUF_337_inst_adr                                                   "0x01D1"
+#define CAM_EMM_EMM_BUF_338_inst_adr                                                   "0x01D2"
+#define CAM_EMM_EMM_BUF_339_inst_adr                                                   "0x01D3"
+#define CAM_EMM_EMM_BUF_340_inst_adr                                                   "0x01D4"
+#define CAM_EMM_EMM_BUF_341_inst_adr                                                   "0x01D5"
+#define CAM_EMM_EMM_BUF_342_inst_adr                                                   "0x01D6"
+#define CAM_EMM_EMM_BUF_343_inst_adr                                                   "0x01D7"
+#define CAM_EMM_EMM_BUF_344_inst_adr                                                   "0x01D8"
+#define CAM_EMM_EMM_BUF_345_inst_adr                                                   "0x01D9"
+#define CAM_EMM_EMM_BUF_346_inst_adr                                                   "0x01DA"
+#define CAM_EMM_EMM_BUF_347_inst_adr                                                   "0x01DB"
+#define CAM_EMM_EMM_BUF_348_inst_adr                                                   "0x01DC"
+#define CAM_EMM_EMM_BUF_349_inst_adr                                                   "0x01DD"
+#define CAM_EMM_EMM_BUF_350_inst_adr                                                   "0x01DE"
+#define CAM_EMM_EMM_BUF_351_inst_adr                                                   "0x01DF"
+#define CAM_EMM_EMM_BUF_352_inst_adr                                                   "0x01E0"
+#define CAM_EMM_EMM_BUF_353_inst_adr                                                   "0x01E1"
+#define CAM_EMM_EMM_BUF_354_inst_adr                                                   "0x01E2"
+#define CAM_EMM_EMM_BUF_355_inst_adr                                                   "0x01E3"
+#define CAM_EMM_EMM_BUF_356_inst_adr                                                   "0x01E4"
+#define CAM_EMM_EMM_BUF_357_inst_adr                                                   "0x01E5"
+#define CAM_EMM_EMM_BUF_358_inst_adr                                                   "0x01E6"
+#define CAM_EMM_EMM_BUF_359_inst_adr                                                   "0x01E7"
+#define CAM_EMM_EMM_BUF_360_inst_adr                                                   "0x01E8"
+#define CAM_EMM_EMM_BUF_361_inst_adr                                                   "0x01E9"
+#define CAM_EMM_EMM_BUF_362_inst_adr                                                   "0x01EA"
+#define CAM_EMM_EMM_BUF_363_inst_adr                                                   "0x01EB"
+#define CAM_EMM_EMM_BUF_364_inst_adr                                                   "0x01EC"
+#define CAM_EMM_EMM_BUF_365_inst_adr                                                   "0x01ED"
+#define CAM_EMM_EMM_BUF_366_inst_adr                                                   "0x01EE"
+#define CAM_EMM_EMM_BUF_367_inst_adr                                                   "0x01EF"
+#define CAM_EMM_EMM_BUF_368_inst_adr                                                   "0x01F0"
+#define CAM_EMM_EMM_BUF_369_inst_adr                                                   "0x01F1"
+#define CAM_EMM_EMM_BUF_370_inst_adr                                                   "0x01F2"
+#define CAM_EMM_EMM_BUF_371_inst_adr                                                   "0x01F3"
+#define CAM_EMM_EMM_BUF_372_inst_adr                                                   "0x01F4"
+#define CAM_EMM_EMM_BUF_373_inst_adr                                                   "0x01F5"
+#define CAM_EMM_EMM_BUF_374_inst_adr                                                   "0x01F6"
+#define CAM_EMM_EMM_BUF_375_inst_adr                                                   "0x01F7"
+#define CAM_EMM_EMM_BUF_376_inst_adr                                                   "0x01F8"
+#define CAM_EMM_EMM_BUF_377_inst_adr                                                   "0x01F9"
+#define CAM_EMM_EMM_BUF_378_inst_adr                                                   "0x01FA"
+#define CAM_EMM_EMM_BUF_379_inst_adr                                                   "0x01FB"
+#define CAM_EMM_EMM_BUF_380_inst_adr                                                   "0x01FC"
+#define CAM_EMM_EMM_BUF_381_inst_adr                                                   "0x01FD"
+#define CAM_EMM_EMM_BUF_382_inst_adr                                                   "0x01FE"
+#define CAM_EMM_EMM_BUF_383_inst_adr                                                   "0x01FF"
+#define CAM_EMM_EMM_BUF_384_inst_adr                                                   "0x0200"
+#define CAM_EMM_EMM_BUF_385_inst_adr                                                   "0x0201"
+#define CAM_EMM_EMM_BUF_386_inst_adr                                                   "0x0202"
+#define CAM_EMM_EMM_BUF_387_inst_adr                                                   "0x0203"
+#define CAM_EMM_EMM_BUF_388_inst_adr                                                   "0x0204"
+#define CAM_EMM_EMM_BUF_389_inst_adr                                                   "0x0205"
+#define CAM_EMM_EMM_BUF_390_inst_adr                                                   "0x0206"
+#define CAM_EMM_EMM_BUF_391_inst_adr                                                   "0x0207"
+#define CAM_EMM_EMM_BUF_392_inst_adr                                                   "0x0208"
+#define CAM_EMM_EMM_BUF_393_inst_adr                                                   "0x0209"
+#define CAM_EMM_EMM_BUF_394_inst_adr                                                   "0x020A"
+#define CAM_EMM_EMM_BUF_395_inst_adr                                                   "0x020B"
+#define CAM_EMM_EMM_BUF_396_inst_adr                                                   "0x020C"
+#define CAM_EMM_EMM_BUF_397_inst_adr                                                   "0x020D"
+#define CAM_EMM_EMM_BUF_398_inst_adr                                                   "0x020E"
+#define CAM_EMM_EMM_BUF_399_inst_adr                                                   "0x020F"
+#define CAM_EMM_EMM_BUF_400_inst_adr                                                   "0x0210"
+#define CAM_EMM_EMM_BUF_401_inst_adr                                                   "0x0211"
+#define CAM_EMM_EMM_BUF_402_inst_adr                                                   "0x0212"
+#define CAM_EMM_EMM_BUF_403_inst_adr                                                   "0x0213"
+#define CAM_EMM_EMM_BUF_404_inst_adr                                                   "0x0214"
+#define CAM_EMM_EMM_BUF_405_inst_adr                                                   "0x0215"
+#define CAM_EMM_EMM_BUF_406_inst_adr                                                   "0x0216"
+#define CAM_EMM_EMM_BUF_407_inst_adr                                                   "0x0217"
+#define CAM_EMM_EMM_BUF_408_inst_adr                                                   "0x0218"
+#define CAM_EMM_EMM_BUF_409_inst_adr                                                   "0x0219"
+#define CAM_EMM_EMM_BUF_410_inst_adr                                                   "0x021A"
+#define CAM_EMM_EMM_BUF_411_inst_adr                                                   "0x021B"
+#define CAM_EMM_EMM_BUF_412_inst_adr                                                   "0x021C"
+#define CAM_EMM_EMM_BUF_413_inst_adr                                                   "0x021D"
+#define CAM_EMM_EMM_BUF_414_inst_adr                                                   "0x021E"
+#define CAM_EMM_EMM_BUF_415_inst_adr                                                   "0x021F"
+#define CAM_EMM_EMM_BUF_416_inst_adr                                                   "0x0220"
+#define CAM_EMM_EMM_BUF_417_inst_adr                                                   "0x0221"
+#define CAM_EMM_EMM_BUF_418_inst_adr                                                   "0x0222"
+#define CAM_EMM_EMM_BUF_419_inst_adr                                                   "0x0223"
+#define CAM_EMM_EMM_BUF_420_inst_adr                                                   "0x0224"
+#define CAM_EMM_EMM_BUF_421_inst_adr                                                   "0x0225"
+#define CAM_EMM_EMM_BUF_422_inst_adr                                                   "0x0226"
+#define CAM_EMM_EMM_BUF_423_inst_adr                                                   "0x0227"
+#define CAM_EMM_EMM_BUF_424_inst_adr                                                   "0x0228"
+#define CAM_EMM_EMM_BUF_425_inst_adr                                                   "0x0229"
+#define CAM_EMM_EMM_BUF_426_inst_adr                                                   "0x022A"
+#define CAM_EMM_EMM_BUF_427_inst_adr                                                   "0x022B"
+#define CAM_EMM_EMM_BUF_428_inst_adr                                                   "0x022C"
+#define CAM_EMM_EMM_BUF_429_inst_adr                                                   "0x022D"
+#define CAM_EMM_EMM_BUF_430_inst_adr                                                   "0x022E"
+#define CAM_EMM_EMM_BUF_431_inst_adr                                                   "0x022F"
+#define CAM_EMM_EMM_BUF_432_inst_adr                                                   "0x0230"
+#define CAM_EMM_EMM_BUF_433_inst_adr                                                   "0x0231"
+#define CAM_EMM_EMM_BUF_434_inst_adr                                                   "0x0232"
+#define CAM_EMM_EMM_BUF_435_inst_adr                                                   "0x0233"
+#define CAM_EMM_EMM_BUF_436_inst_adr                                                   "0x0234"
+#define CAM_EMM_EMM_BUF_437_inst_adr                                                   "0x0235"
+#define CAM_EMM_EMM_BUF_438_inst_adr                                                   "0x0236"
+#define CAM_EMM_EMM_BUF_439_inst_adr                                                   "0x0237"
+#define CAM_EMM_EMM_BUF_440_inst_adr                                                   "0x0238"
+#define CAM_EMM_EMM_BUF_441_inst_adr                                                   "0x0239"
+#define CAM_EMM_EMM_BUF_442_inst_adr                                                   "0x023A"
+#define CAM_EMM_EMM_BUF_443_inst_adr                                                   "0x023B"
+#define CAM_EMM_EMM_BUF_444_inst_adr                                                   "0x023C"
+#define CAM_EMM_EMM_BUF_445_inst_adr                                                   "0x023D"
+#define CAM_EMM_EMM_BUF_446_inst_adr                                                   "0x023E"
+#define CAM_EMM_EMM_BUF_447_inst_adr                                                   "0x023F"
+#define CAM_EMM_EMM_BUF_448_inst_adr                                                   "0x0240"
+#define CAM_EMM_EMM_BUF_449_inst_adr                                                   "0x0241"
+#define CAM_EMM_EMM_BUF_450_inst_adr                                                   "0x0242"
+#define CAM_EMM_EMM_BUF_451_inst_adr                                                   "0x0243"
+#define CAM_EMM_EMM_BUF_452_inst_adr                                                   "0x0244"
+#define CAM_EMM_EMM_BUF_453_inst_adr                                                   "0x0245"
+#define CAM_EMM_EMM_BUF_454_inst_adr                                                   "0x0246"
+#define CAM_EMM_EMM_BUF_455_inst_adr                                                   "0x0247"
+#define CAM_EMM_EMM_BUF_456_inst_adr                                                   "0x0248"
+#define CAM_EMM_EMM_BUF_457_inst_adr                                                   "0x0249"
+#define CAM_EMM_EMM_BUF_458_inst_adr                                                   "0x024A"
+#define CAM_EMM_EMM_BUF_459_inst_adr                                                   "0x024B"
+#define CAM_EMM_EMM_BUF_460_inst_adr                                                   "0x024C"
+#define CAM_EMM_EMM_BUF_461_inst_adr                                                   "0x024D"
+#define CAM_EMM_EMM_BUF_462_inst_adr                                                   "0x024E"
+#define CAM_EMM_EMM_BUF_463_inst_adr                                                   "0x024F"
+#define CAM_EMM_EMM_BUF_464_inst_adr                                                   "0x0250"
+#define CAM_EMM_EMM_BUF_465_inst_adr                                                   "0x0251"
+#define CAM_EMM_EMM_BUF_466_inst_adr                                                   "0x0252"
+#define CAM_EMM_EMM_BUF_467_inst_adr                                                   "0x0253"
+#define CAM_EMM_EMM_BUF_468_inst_adr                                                   "0x0254"
+#define CAM_EMM_EMM_BUF_469_inst_adr                                                   "0x0255"
+#define CAM_EMM_EMM_BUF_470_inst_adr                                                   "0x0256"
+#define CAM_EMM_EMM_BUF_471_inst_adr                                                   "0x0257"
+#define CAM_EMM_EMM_BUF_472_inst_adr                                                   "0x0258"
+#define CAM_EMM_EMM_BUF_473_inst_adr                                                   "0x0259"
+#define CAM_EMM_EMM_BUF_474_inst_adr                                                   "0x025A"
+#define CAM_EMM_EMM_BUF_475_inst_adr                                                   "0x025B"
+#define CAM_EMM_EMM_BUF_476_inst_adr                                                   "0x025C"
+#define CAM_EMM_EMM_BUF_477_inst_adr                                                   "0x025D"
+#define CAM_EMM_EMM_BUF_478_inst_adr                                                   "0x025E"
+#define CAM_EMM_EMM_BUF_479_inst_adr                                                   "0x025F"
+#define CAM_EMM_EMM_BUF_480_inst_adr                                                   "0x0260"
+#define CAM_EMM_EMM_BUF_481_inst_adr                                                   "0x0261"
+#define CAM_EMM_EMM_BUF_482_inst_adr                                                   "0x0262"
+#define CAM_EMM_EMM_BUF_483_inst_adr                                                   "0x0263"
+#define CAM_EMM_EMM_BUF_484_inst_adr                                                   "0x0264"
+#define CAM_EMM_EMM_BUF_485_inst_adr                                                   "0x0265"
+#define CAM_EMM_EMM_BUF_486_inst_adr                                                   "0x0266"
+#define CAM_EMM_EMM_BUF_487_inst_adr                                                   "0x0267"
+#define CAM_EMM_EMM_BUF_488_inst_adr                                                   "0x0268"
+#define CAM_EMM_EMM_BUF_489_inst_adr                                                   "0x0269"
+#define CAM_EMM_EMM_BUF_490_inst_adr                                                   "0x026A"
+#define CAM_EMM_EMM_BUF_491_inst_adr                                                   "0x026B"
+#define CAM_EMM_EMM_BUF_492_inst_adr                                                   "0x026C"
+#define CAM_EMM_EMM_BUF_493_inst_adr                                                   "0x026D"
+#define CAM_EMM_EMM_BUF_494_inst_adr                                                   "0x026E"
+#define CAM_EMM_EMM_BUF_495_inst_adr                                                   "0x026F"
+#define CAM_EMM_EMM_BUF_496_inst_adr                                                   "0x0270"
+#define CAM_EMM_EMM_BUF_497_inst_adr                                                   "0x0271"
+#define CAM_EMM_EMM_BUF_498_inst_adr                                                   "0x0272"
+#define CAM_EMM_EMM_BUF_499_inst_adr                                                   "0x0273"
+#define CAM_EMM_EMM_BUF_500_inst_adr                                                   "0x0274"
+#define CAM_EMM_EMM_BUF_501_inst_adr                                                   "0x0275"
+#define CAM_EMM_EMM_BUF_502_inst_adr                                                   "0x0276"
+#define CAM_EMM_EMM_BUF_503_inst_adr                                                   "0x0277"
+#define CAM_EMM_EMM_BUF_504_inst_adr                                                   "0x0278"
+#define CAM_EMM_EMM_BUF_505_inst_adr                                                   "0x0279"
+#define CAM_EMM_EMM_BUF_506_inst_adr                                                   "0x027A"
+#define CAM_EMM_EMM_BUF_507_inst_adr                                                   "0x027B"
+#define CAM_EMM_EMM_BUF_508_inst_adr                                                   "0x027C"
+#define CAM_EMM_EMM_BUF_509_inst_adr                                                   "0x027D"
+#define CAM_EMM_EMM_BUF_510_inst_adr                                                   "0x027E"
+#define CAM_EMM_EMM_BUF_511_inst_adr                                                   "0x027F"
+#define CAM_EMM_EMM_BUF_512_inst_adr                                                   "0x0280"
+#define CAM_EMM_EMM_BUF_513_inst_adr                                                   "0x0281"
+#define CAM_EMM_EMM_BUF_514_inst_adr                                                   "0x0282"
+#define CAM_EMM_EMM_BUF_515_inst_adr                                                   "0x0283"
+#define CAM_EMM_EMM_BUF_516_inst_adr                                                   "0x0284"
+#define CAM_EMM_EMM_BUF_517_inst_adr                                                   "0x0285"
+#define CAM_EMM_EMM_BUF_518_inst_adr                                                   "0x0286"
+#define CAM_EMM_EMM_BUF_519_inst_adr                                                   "0x0287"
+#define CAM_EMM_EMM_BUF_520_inst_adr                                                   "0x0288"
+#define CAM_EMM_EMM_BUF_521_inst_adr                                                   "0x0289"
+#define CAM_EMM_EMM_BUF_522_inst_adr                                                   "0x028A"
+#define CAM_EMM_EMM_BUF_523_inst_adr                                                   "0x028B"
+#define CAM_EMM_EMM_BUF_524_inst_adr                                                   "0x028C"
+#define CAM_EMM_EMM_BUF_525_inst_adr                                                   "0x028D"
+#define CAM_EMM_EMM_BUF_526_inst_adr                                                   "0x028E"
+#define CAM_EMM_EMM_BUF_527_inst_adr                                                   "0x028F"
+#define CAM_EMM_EMM_BUF_528_inst_adr                                                   "0x0290"
+#define CAM_EMM_EMM_BUF_529_inst_adr                                                   "0x0291"
+#define CAM_EMM_EMM_BUF_530_inst_adr                                                   "0x0292"
+#define CAM_EMM_EMM_BUF_531_inst_adr                                                   "0x0293"
+#define CAM_EMM_EMM_BUF_532_inst_adr                                                   "0x0294"
+#define CAM_EMM_EMM_BUF_533_inst_adr                                                   "0x0295"
+#define CAM_EMM_EMM_BUF_534_inst_adr                                                   "0x0296"
+#define CAM_EMM_EMM_BUF_535_inst_adr                                                   "0x0297"
+#define CAM_EMM_EMM_BUF_536_inst_adr                                                   "0x0298"
+#define CAM_EMM_EMM_BUF_537_inst_adr                                                   "0x0299"
+#define CAM_EMM_EMM_BUF_538_inst_adr                                                   "0x029A"
+#define CAM_EMM_EMM_BUF_539_inst_adr                                                   "0x029B"
+#define CAM_EMM_EMM_BUF_540_inst_adr                                                   "0x029C"
+#define CAM_EMM_EMM_BUF_541_inst_adr                                                   "0x029D"
+#define CAM_EMM_EMM_BUF_542_inst_adr                                                   "0x029E"
+#define CAM_EMM_EMM_BUF_543_inst_adr                                                   "0x029F"
+#define CAM_EMM_EMM_BUF_544_inst_adr                                                   "0x02A0"
+#define CAM_EMM_EMM_BUF_545_inst_adr                                                   "0x02A1"
+#define CAM_EMM_EMM_BUF_546_inst_adr                                                   "0x02A2"
+#define CAM_EMM_EMM_BUF_547_inst_adr                                                   "0x02A3"
+#define CAM_EMM_EMM_BUF_548_inst_adr                                                   "0x02A4"
+#define CAM_EMM_EMM_BUF_549_inst_adr                                                   "0x02A5"
+#define CAM_EMM_EMM_BUF_550_inst_adr                                                   "0x02A6"
+#define CAM_EMM_EMM_BUF_551_inst_adr                                                   "0x02A7"
+#define CAM_EMM_EMM_BUF_552_inst_adr                                                   "0x02A8"
+#define CAM_EMM_EMM_BUF_553_inst_adr                                                   "0x02A9"
+#define CAM_EMM_EMM_BUF_554_inst_adr                                                   "0x02AA"
+#define CAM_EMM_EMM_BUF_555_inst_adr                                                   "0x02AB"
+#define CAM_EMM_EMM_BUF_556_inst_adr                                                   "0x02AC"
+#define CAM_EMM_EMM_BUF_557_inst_adr                                                   "0x02AD"
+#define CAM_EMM_EMM_BUF_558_inst_adr                                                   "0x02AE"
+#define CAM_EMM_EMM_BUF_559_inst_adr                                                   "0x02AF"
+#define CAM_EMM_EMM_BUF_560_inst_adr                                                   "0x02B0"
+#define CAM_EMM_EMM_BUF_561_inst_adr                                                   "0x02B1"
+#define CAM_EMM_EMM_BUF_562_inst_adr                                                   "0x02B2"
+#define CAM_EMM_EMM_BUF_563_inst_adr                                                   "0x02B3"
+#define CAM_EMM_EMM_BUF_564_inst_adr                                                   "0x02B4"
+#define CAM_EMM_EMM_BUF_565_inst_adr                                                   "0x02B5"
+#define CAM_EMM_EMM_BUF_566_inst_adr                                                   "0x02B6"
+#define CAM_EMM_EMM_BUF_567_inst_adr                                                   "0x02B7"
+#define CAM_EMM_EMM_BUF_568_inst_adr                                                   "0x02B8"
+#define CAM_EMM_EMM_BUF_569_inst_adr                                                   "0x02B9"
+#define CAM_EMM_EMM_BUF_570_inst_adr                                                   "0x02BA"
+#define CAM_EMM_EMM_BUF_571_inst_adr                                                   "0x02BB"
+#define CAM_EMM_EMM_BUF_572_inst_adr                                                   "0x02BC"
+#define CAM_EMM_EMM_BUF_573_inst_adr                                                   "0x02BD"
+#define CAM_EMM_EMM_BUF_574_inst_adr                                                   "0x02BE"
+#define CAM_EMM_EMM_BUF_575_inst_adr                                                   "0x02BF"
+#define CAM_EMM_EMM_BUF_576_inst_adr                                                   "0x02C0"
+#define CAM_EMM_EMM_BUF_577_inst_adr                                                   "0x02C1"
+#define CAM_EMM_EMM_BUF_578_inst_adr                                                   "0x02C2"
+#define CAM_EMM_EMM_BUF_579_inst_adr                                                   "0x02C3"
+#define CAM_EMM_EMM_BUF_580_inst_adr                                                   "0x02C4"
+#define CAM_EMM_EMM_BUF_581_inst_adr                                                   "0x02C5"
+#define CAM_EMM_EMM_BUF_582_inst_adr                                                   "0x02C6"
+#define CAM_EMM_EMM_BUF_583_inst_adr                                                   "0x02C7"
+#define CAM_EMM_EMM_BUF_584_inst_adr                                                   "0x02C8"
+#define CAM_EMM_EMM_BUF_585_inst_adr                                                   "0x02C9"
+#define CAM_EMM_EMM_BUF_586_inst_adr                                                   "0x02CA"
+#define CAM_EMM_EMM_BUF_587_inst_adr                                                   "0x02CB"
+#define CAM_EMM_EMM_BUF_588_inst_adr                                                   "0x02CC"
+#define CAM_EMM_EMM_BUF_589_inst_adr                                                   "0x02CD"
+#define CAM_EMM_EMM_BUF_590_inst_adr                                                   "0x02CE"
+#define CAM_EMM_EMM_BUF_591_inst_adr                                                   "0x02CF"
+#define CAM_EMM_EMM_BUF_592_inst_adr                                                   "0x02D0"
+#define CAM_EMM_EMM_BUF_593_inst_adr                                                   "0x02D1"
+#define CAM_EMM_EMM_BUF_594_inst_adr                                                   "0x02D2"
+#define CAM_EMM_EMM_BUF_595_inst_adr                                                   "0x02D3"
+#define CAM_EMM_EMM_BUF_596_inst_adr                                                   "0x02D4"
+#define CAM_EMM_EMM_BUF_597_inst_adr                                                   "0x02D5"
+#define CAM_EMM_EMM_BUF_598_inst_adr                                                   "0x02D6"
+#define CAM_EMM_EMM_BUF_599_inst_adr                                                   "0x02D7"
+#define CAM_EMM_EMM_BUF_600_inst_adr                                                   "0x02D8"
+#define CAM_EMM_EMM_BUF_601_inst_adr                                                   "0x02D9"
+#define CAM_EMM_EMM_BUF_602_inst_adr                                                   "0x02DA"
+#define CAM_EMM_EMM_BUF_603_inst_adr                                                   "0x02DB"
+#define CAM_EMM_EMM_BUF_604_inst_adr                                                   "0x02DC"
+#define CAM_EMM_EMM_BUF_605_inst_adr                                                   "0x02DD"
+#define CAM_EMM_EMM_BUF_606_inst_adr                                                   "0x02DE"
+#define CAM_EMM_EMM_BUF_607_inst_adr                                                   "0x02DF"
+#define CAM_EMM_EMM_BUF_608_inst_adr                                                   "0x02E0"
+#define CAM_EMM_EMM_BUF_609_inst_adr                                                   "0x02E1"
+#define CAM_EMM_EMM_BUF_610_inst_adr                                                   "0x02E2"
+#define CAM_EMM_EMM_BUF_611_inst_adr                                                   "0x02E3"
+#define CAM_EMM_EMM_BUF_612_inst_adr                                                   "0x02E4"
+#define CAM_EMM_EMM_BUF_613_inst_adr                                                   "0x02E5"
+#define CAM_EMM_EMM_BUF_614_inst_adr                                                   "0x02E6"
+#define CAM_EMM_EMM_BUF_615_inst_adr                                                   "0x02E7"
+#define CAM_EMM_EMM_BUF_616_inst_adr                                                   "0x02E8"
+#define CAM_EMM_EMM_BUF_617_inst_adr                                                   "0x02E9"
+#define CAM_EMM_EMM_BUF_618_inst_adr                                                   "0x02EA"
+#define CAM_EMM_EMM_BUF_619_inst_adr                                                   "0x02EB"
+#define CAM_EMM_EMM_BUF_620_inst_adr                                                   "0x02EC"
+#define CAM_EMM_EMM_BUF_621_inst_adr                                                   "0x02ED"
+#define CAM_EMM_EMM_BUF_622_inst_adr                                                   "0x02EE"
+#define CAM_EMM_EMM_BUF_623_inst_adr                                                   "0x02EF"
+#define CAM_EMM_EMM_BUF_624_inst_adr                                                   "0x02F0"
+#define CAM_EMM_EMM_BUF_625_inst_adr                                                   "0x02F1"
+#define CAM_EMM_EMM_BUF_626_inst_adr                                                   "0x02F2"
+#define CAM_EMM_EMM_BUF_627_inst_adr                                                   "0x02F3"
+#define CAM_EMM_EMM_BUF_628_inst_adr                                                   "0x02F4"
+#define CAM_EMM_EMM_BUF_629_inst_adr                                                   "0x02F5"
+#define CAM_EMM_EMM_BUF_630_inst_adr                                                   "0x02F6"
+#define CAM_EMM_EMM_BUF_631_inst_adr                                                   "0x02F7"
+#define CAM_EMM_EMM_BUF_632_inst_adr                                                   "0x02F8"
+#define CAM_EMM_EMM_BUF_633_inst_adr                                                   "0x02F9"
+#define CAM_EMM_EMM_BUF_634_inst_adr                                                   "0x02FA"
+#define CAM_EMM_EMM_BUF_635_inst_adr                                                   "0x02FB"
+#define CAM_EMM_EMM_BUF_636_inst_adr                                                   "0x02FC"
+#define CAM_EMM_EMM_BUF_637_inst_adr                                                   "0x02FD"
+#define CAM_EMM_EMM_BUF_638_inst_adr                                                   "0x02FE"
+#define CAM_EMM_EMM_BUF_639_inst_adr                                                   "0x02FF"
+#define CAM_EMM_EMM_BUF_0_inst                                                       0x0080
+#define CAM_EMM_EMM_BUF_1_inst                                                       0x0081
+#define CAM_EMM_EMM_BUF_2_inst                                                       0x0082
+#define CAM_EMM_EMM_BUF_3_inst                                                       0x0083
+#define CAM_EMM_EMM_BUF_4_inst                                                       0x0084
+#define CAM_EMM_EMM_BUF_5_inst                                                       0x0085
+#define CAM_EMM_EMM_BUF_6_inst                                                       0x0086
+#define CAM_EMM_EMM_BUF_7_inst                                                       0x0087
+#define CAM_EMM_EMM_BUF_8_inst                                                       0x0088
+#define CAM_EMM_EMM_BUF_9_inst                                                       0x0089
+#define CAM_EMM_EMM_BUF_10_inst                                                       0x008A
+#define CAM_EMM_EMM_BUF_11_inst                                                       0x008B
+#define CAM_EMM_EMM_BUF_12_inst                                                       0x008C
+#define CAM_EMM_EMM_BUF_13_inst                                                       0x008D
+#define CAM_EMM_EMM_BUF_14_inst                                                       0x008E
+#define CAM_EMM_EMM_BUF_15_inst                                                       0x008F
+#define CAM_EMM_EMM_BUF_16_inst                                                       0x0090
+#define CAM_EMM_EMM_BUF_17_inst                                                       0x0091
+#define CAM_EMM_EMM_BUF_18_inst                                                       0x0092
+#define CAM_EMM_EMM_BUF_19_inst                                                       0x0093
+#define CAM_EMM_EMM_BUF_20_inst                                                       0x0094
+#define CAM_EMM_EMM_BUF_21_inst                                                       0x0095
+#define CAM_EMM_EMM_BUF_22_inst                                                       0x0096
+#define CAM_EMM_EMM_BUF_23_inst                                                       0x0097
+#define CAM_EMM_EMM_BUF_24_inst                                                       0x0098
+#define CAM_EMM_EMM_BUF_25_inst                                                       0x0099
+#define CAM_EMM_EMM_BUF_26_inst                                                       0x009A
+#define CAM_EMM_EMM_BUF_27_inst                                                       0x009B
+#define CAM_EMM_EMM_BUF_28_inst                                                       0x009C
+#define CAM_EMM_EMM_BUF_29_inst                                                       0x009D
+#define CAM_EMM_EMM_BUF_30_inst                                                       0x009E
+#define CAM_EMM_EMM_BUF_31_inst                                                       0x009F
+#define CAM_EMM_EMM_BUF_32_inst                                                       0x00A0
+#define CAM_EMM_EMM_BUF_33_inst                                                       0x00A1
+#define CAM_EMM_EMM_BUF_34_inst                                                       0x00A2
+#define CAM_EMM_EMM_BUF_35_inst                                                       0x00A3
+#define CAM_EMM_EMM_BUF_36_inst                                                       0x00A4
+#define CAM_EMM_EMM_BUF_37_inst                                                       0x00A5
+#define CAM_EMM_EMM_BUF_38_inst                                                       0x00A6
+#define CAM_EMM_EMM_BUF_39_inst                                                       0x00A7
+#define CAM_EMM_EMM_BUF_40_inst                                                       0x00A8
+#define CAM_EMM_EMM_BUF_41_inst                                                       0x00A9
+#define CAM_EMM_EMM_BUF_42_inst                                                       0x00AA
+#define CAM_EMM_EMM_BUF_43_inst                                                       0x00AB
+#define CAM_EMM_EMM_BUF_44_inst                                                       0x00AC
+#define CAM_EMM_EMM_BUF_45_inst                                                       0x00AD
+#define CAM_EMM_EMM_BUF_46_inst                                                       0x00AE
+#define CAM_EMM_EMM_BUF_47_inst                                                       0x00AF
+#define CAM_EMM_EMM_BUF_48_inst                                                       0x00B0
+#define CAM_EMM_EMM_BUF_49_inst                                                       0x00B1
+#define CAM_EMM_EMM_BUF_50_inst                                                       0x00B2
+#define CAM_EMM_EMM_BUF_51_inst                                                       0x00B3
+#define CAM_EMM_EMM_BUF_52_inst                                                       0x00B4
+#define CAM_EMM_EMM_BUF_53_inst                                                       0x00B5
+#define CAM_EMM_EMM_BUF_54_inst                                                       0x00B6
+#define CAM_EMM_EMM_BUF_55_inst                                                       0x00B7
+#define CAM_EMM_EMM_BUF_56_inst                                                       0x00B8
+#define CAM_EMM_EMM_BUF_57_inst                                                       0x00B9
+#define CAM_EMM_EMM_BUF_58_inst                                                       0x00BA
+#define CAM_EMM_EMM_BUF_59_inst                                                       0x00BB
+#define CAM_EMM_EMM_BUF_60_inst                                                       0x00BC
+#define CAM_EMM_EMM_BUF_61_inst                                                       0x00BD
+#define CAM_EMM_EMM_BUF_62_inst                                                       0x00BE
+#define CAM_EMM_EMM_BUF_63_inst                                                       0x00BF
+#define CAM_EMM_EMM_BUF_64_inst                                                       0x00C0
+#define CAM_EMM_EMM_BUF_65_inst                                                       0x00C1
+#define CAM_EMM_EMM_BUF_66_inst                                                       0x00C2
+#define CAM_EMM_EMM_BUF_67_inst                                                       0x00C3
+#define CAM_EMM_EMM_BUF_68_inst                                                       0x00C4
+#define CAM_EMM_EMM_BUF_69_inst                                                       0x00C5
+#define CAM_EMM_EMM_BUF_70_inst                                                       0x00C6
+#define CAM_EMM_EMM_BUF_71_inst                                                       0x00C7
+#define CAM_EMM_EMM_BUF_72_inst                                                       0x00C8
+#define CAM_EMM_EMM_BUF_73_inst                                                       0x00C9
+#define CAM_EMM_EMM_BUF_74_inst                                                       0x00CA
+#define CAM_EMM_EMM_BUF_75_inst                                                       0x00CB
+#define CAM_EMM_EMM_BUF_76_inst                                                       0x00CC
+#define CAM_EMM_EMM_BUF_77_inst                                                       0x00CD
+#define CAM_EMM_EMM_BUF_78_inst                                                       0x00CE
+#define CAM_EMM_EMM_BUF_79_inst                                                       0x00CF
+#define CAM_EMM_EMM_BUF_80_inst                                                       0x00D0
+#define CAM_EMM_EMM_BUF_81_inst                                                       0x00D1
+#define CAM_EMM_EMM_BUF_82_inst                                                       0x00D2
+#define CAM_EMM_EMM_BUF_83_inst                                                       0x00D3
+#define CAM_EMM_EMM_BUF_84_inst                                                       0x00D4
+#define CAM_EMM_EMM_BUF_85_inst                                                       0x00D5
+#define CAM_EMM_EMM_BUF_86_inst                                                       0x00D6
+#define CAM_EMM_EMM_BUF_87_inst                                                       0x00D7
+#define CAM_EMM_EMM_BUF_88_inst                                                       0x00D8
+#define CAM_EMM_EMM_BUF_89_inst                                                       0x00D9
+#define CAM_EMM_EMM_BUF_90_inst                                                       0x00DA
+#define CAM_EMM_EMM_BUF_91_inst                                                       0x00DB
+#define CAM_EMM_EMM_BUF_92_inst                                                       0x00DC
+#define CAM_EMM_EMM_BUF_93_inst                                                       0x00DD
+#define CAM_EMM_EMM_BUF_94_inst                                                       0x00DE
+#define CAM_EMM_EMM_BUF_95_inst                                                       0x00DF
+#define CAM_EMM_EMM_BUF_96_inst                                                       0x00E0
+#define CAM_EMM_EMM_BUF_97_inst                                                       0x00E1
+#define CAM_EMM_EMM_BUF_98_inst                                                       0x00E2
+#define CAM_EMM_EMM_BUF_99_inst                                                       0x00E3
+#define CAM_EMM_EMM_BUF_100_inst                                                       0x00E4
+#define CAM_EMM_EMM_BUF_101_inst                                                       0x00E5
+#define CAM_EMM_EMM_BUF_102_inst                                                       0x00E6
+#define CAM_EMM_EMM_BUF_103_inst                                                       0x00E7
+#define CAM_EMM_EMM_BUF_104_inst                                                       0x00E8
+#define CAM_EMM_EMM_BUF_105_inst                                                       0x00E9
+#define CAM_EMM_EMM_BUF_106_inst                                                       0x00EA
+#define CAM_EMM_EMM_BUF_107_inst                                                       0x00EB
+#define CAM_EMM_EMM_BUF_108_inst                                                       0x00EC
+#define CAM_EMM_EMM_BUF_109_inst                                                       0x00ED
+#define CAM_EMM_EMM_BUF_110_inst                                                       0x00EE
+#define CAM_EMM_EMM_BUF_111_inst                                                       0x00EF
+#define CAM_EMM_EMM_BUF_112_inst                                                       0x00F0
+#define CAM_EMM_EMM_BUF_113_inst                                                       0x00F1
+#define CAM_EMM_EMM_BUF_114_inst                                                       0x00F2
+#define CAM_EMM_EMM_BUF_115_inst                                                       0x00F3
+#define CAM_EMM_EMM_BUF_116_inst                                                       0x00F4
+#define CAM_EMM_EMM_BUF_117_inst                                                       0x00F5
+#define CAM_EMM_EMM_BUF_118_inst                                                       0x00F6
+#define CAM_EMM_EMM_BUF_119_inst                                                       0x00F7
+#define CAM_EMM_EMM_BUF_120_inst                                                       0x00F8
+#define CAM_EMM_EMM_BUF_121_inst                                                       0x00F9
+#define CAM_EMM_EMM_BUF_122_inst                                                       0x00FA
+#define CAM_EMM_EMM_BUF_123_inst                                                       0x00FB
+#define CAM_EMM_EMM_BUF_124_inst                                                       0x00FC
+#define CAM_EMM_EMM_BUF_125_inst                                                       0x00FD
+#define CAM_EMM_EMM_BUF_126_inst                                                       0x00FE
+#define CAM_EMM_EMM_BUF_127_inst                                                       0x00FF
+#define CAM_EMM_EMM_BUF_128_inst                                                       0x0100
+#define CAM_EMM_EMM_BUF_129_inst                                                       0x0101
+#define CAM_EMM_EMM_BUF_130_inst                                                       0x0102
+#define CAM_EMM_EMM_BUF_131_inst                                                       0x0103
+#define CAM_EMM_EMM_BUF_132_inst                                                       0x0104
+#define CAM_EMM_EMM_BUF_133_inst                                                       0x0105
+#define CAM_EMM_EMM_BUF_134_inst                                                       0x0106
+#define CAM_EMM_EMM_BUF_135_inst                                                       0x0107
+#define CAM_EMM_EMM_BUF_136_inst                                                       0x0108
+#define CAM_EMM_EMM_BUF_137_inst                                                       0x0109
+#define CAM_EMM_EMM_BUF_138_inst                                                       0x010A
+#define CAM_EMM_EMM_BUF_139_inst                                                       0x010B
+#define CAM_EMM_EMM_BUF_140_inst                                                       0x010C
+#define CAM_EMM_EMM_BUF_141_inst                                                       0x010D
+#define CAM_EMM_EMM_BUF_142_inst                                                       0x010E
+#define CAM_EMM_EMM_BUF_143_inst                                                       0x010F
+#define CAM_EMM_EMM_BUF_144_inst                                                       0x0110
+#define CAM_EMM_EMM_BUF_145_inst                                                       0x0111
+#define CAM_EMM_EMM_BUF_146_inst                                                       0x0112
+#define CAM_EMM_EMM_BUF_147_inst                                                       0x0113
+#define CAM_EMM_EMM_BUF_148_inst                                                       0x0114
+#define CAM_EMM_EMM_BUF_149_inst                                                       0x0115
+#define CAM_EMM_EMM_BUF_150_inst                                                       0x0116
+#define CAM_EMM_EMM_BUF_151_inst                                                       0x0117
+#define CAM_EMM_EMM_BUF_152_inst                                                       0x0118
+#define CAM_EMM_EMM_BUF_153_inst                                                       0x0119
+#define CAM_EMM_EMM_BUF_154_inst                                                       0x011A
+#define CAM_EMM_EMM_BUF_155_inst                                                       0x011B
+#define CAM_EMM_EMM_BUF_156_inst                                                       0x011C
+#define CAM_EMM_EMM_BUF_157_inst                                                       0x011D
+#define CAM_EMM_EMM_BUF_158_inst                                                       0x011E
+#define CAM_EMM_EMM_BUF_159_inst                                                       0x011F
+#define CAM_EMM_EMM_BUF_160_inst                                                       0x0120
+#define CAM_EMM_EMM_BUF_161_inst                                                       0x0121
+#define CAM_EMM_EMM_BUF_162_inst                                                       0x0122
+#define CAM_EMM_EMM_BUF_163_inst                                                       0x0123
+#define CAM_EMM_EMM_BUF_164_inst                                                       0x0124
+#define CAM_EMM_EMM_BUF_165_inst                                                       0x0125
+#define CAM_EMM_EMM_BUF_166_inst                                                       0x0126
+#define CAM_EMM_EMM_BUF_167_inst                                                       0x0127
+#define CAM_EMM_EMM_BUF_168_inst                                                       0x0128
+#define CAM_EMM_EMM_BUF_169_inst                                                       0x0129
+#define CAM_EMM_EMM_BUF_170_inst                                                       0x012A
+#define CAM_EMM_EMM_BUF_171_inst                                                       0x012B
+#define CAM_EMM_EMM_BUF_172_inst                                                       0x012C
+#define CAM_EMM_EMM_BUF_173_inst                                                       0x012D
+#define CAM_EMM_EMM_BUF_174_inst                                                       0x012E
+#define CAM_EMM_EMM_BUF_175_inst                                                       0x012F
+#define CAM_EMM_EMM_BUF_176_inst                                                       0x0130
+#define CAM_EMM_EMM_BUF_177_inst                                                       0x0131
+#define CAM_EMM_EMM_BUF_178_inst                                                       0x0132
+#define CAM_EMM_EMM_BUF_179_inst                                                       0x0133
+#define CAM_EMM_EMM_BUF_180_inst                                                       0x0134
+#define CAM_EMM_EMM_BUF_181_inst                                                       0x0135
+#define CAM_EMM_EMM_BUF_182_inst                                                       0x0136
+#define CAM_EMM_EMM_BUF_183_inst                                                       0x0137
+#define CAM_EMM_EMM_BUF_184_inst                                                       0x0138
+#define CAM_EMM_EMM_BUF_185_inst                                                       0x0139
+#define CAM_EMM_EMM_BUF_186_inst                                                       0x013A
+#define CAM_EMM_EMM_BUF_187_inst                                                       0x013B
+#define CAM_EMM_EMM_BUF_188_inst                                                       0x013C
+#define CAM_EMM_EMM_BUF_189_inst                                                       0x013D
+#define CAM_EMM_EMM_BUF_190_inst                                                       0x013E
+#define CAM_EMM_EMM_BUF_191_inst                                                       0x013F
+#define CAM_EMM_EMM_BUF_192_inst                                                       0x0140
+#define CAM_EMM_EMM_BUF_193_inst                                                       0x0141
+#define CAM_EMM_EMM_BUF_194_inst                                                       0x0142
+#define CAM_EMM_EMM_BUF_195_inst                                                       0x0143
+#define CAM_EMM_EMM_BUF_196_inst                                                       0x0144
+#define CAM_EMM_EMM_BUF_197_inst                                                       0x0145
+#define CAM_EMM_EMM_BUF_198_inst                                                       0x0146
+#define CAM_EMM_EMM_BUF_199_inst                                                       0x0147
+#define CAM_EMM_EMM_BUF_200_inst                                                       0x0148
+#define CAM_EMM_EMM_BUF_201_inst                                                       0x0149
+#define CAM_EMM_EMM_BUF_202_inst                                                       0x014A
+#define CAM_EMM_EMM_BUF_203_inst                                                       0x014B
+#define CAM_EMM_EMM_BUF_204_inst                                                       0x014C
+#define CAM_EMM_EMM_BUF_205_inst                                                       0x014D
+#define CAM_EMM_EMM_BUF_206_inst                                                       0x014E
+#define CAM_EMM_EMM_BUF_207_inst                                                       0x014F
+#define CAM_EMM_EMM_BUF_208_inst                                                       0x0150
+#define CAM_EMM_EMM_BUF_209_inst                                                       0x0151
+#define CAM_EMM_EMM_BUF_210_inst                                                       0x0152
+#define CAM_EMM_EMM_BUF_211_inst                                                       0x0153
+#define CAM_EMM_EMM_BUF_212_inst                                                       0x0154
+#define CAM_EMM_EMM_BUF_213_inst                                                       0x0155
+#define CAM_EMM_EMM_BUF_214_inst                                                       0x0156
+#define CAM_EMM_EMM_BUF_215_inst                                                       0x0157
+#define CAM_EMM_EMM_BUF_216_inst                                                       0x0158
+#define CAM_EMM_EMM_BUF_217_inst                                                       0x0159
+#define CAM_EMM_EMM_BUF_218_inst                                                       0x015A
+#define CAM_EMM_EMM_BUF_219_inst                                                       0x015B
+#define CAM_EMM_EMM_BUF_220_inst                                                       0x015C
+#define CAM_EMM_EMM_BUF_221_inst                                                       0x015D
+#define CAM_EMM_EMM_BUF_222_inst                                                       0x015E
+#define CAM_EMM_EMM_BUF_223_inst                                                       0x015F
+#define CAM_EMM_EMM_BUF_224_inst                                                       0x0160
+#define CAM_EMM_EMM_BUF_225_inst                                                       0x0161
+#define CAM_EMM_EMM_BUF_226_inst                                                       0x0162
+#define CAM_EMM_EMM_BUF_227_inst                                                       0x0163
+#define CAM_EMM_EMM_BUF_228_inst                                                       0x0164
+#define CAM_EMM_EMM_BUF_229_inst                                                       0x0165
+#define CAM_EMM_EMM_BUF_230_inst                                                       0x0166
+#define CAM_EMM_EMM_BUF_231_inst                                                       0x0167
+#define CAM_EMM_EMM_BUF_232_inst                                                       0x0168
+#define CAM_EMM_EMM_BUF_233_inst                                                       0x0169
+#define CAM_EMM_EMM_BUF_234_inst                                                       0x016A
+#define CAM_EMM_EMM_BUF_235_inst                                                       0x016B
+#define CAM_EMM_EMM_BUF_236_inst                                                       0x016C
+#define CAM_EMM_EMM_BUF_237_inst                                                       0x016D
+#define CAM_EMM_EMM_BUF_238_inst                                                       0x016E
+#define CAM_EMM_EMM_BUF_239_inst                                                       0x016F
+#define CAM_EMM_EMM_BUF_240_inst                                                       0x0170
+#define CAM_EMM_EMM_BUF_241_inst                                                       0x0171
+#define CAM_EMM_EMM_BUF_242_inst                                                       0x0172
+#define CAM_EMM_EMM_BUF_243_inst                                                       0x0173
+#define CAM_EMM_EMM_BUF_244_inst                                                       0x0174
+#define CAM_EMM_EMM_BUF_245_inst                                                       0x0175
+#define CAM_EMM_EMM_BUF_246_inst                                                       0x0176
+#define CAM_EMM_EMM_BUF_247_inst                                                       0x0177
+#define CAM_EMM_EMM_BUF_248_inst                                                       0x0178
+#define CAM_EMM_EMM_BUF_249_inst                                                       0x0179
+#define CAM_EMM_EMM_BUF_250_inst                                                       0x017A
+#define CAM_EMM_EMM_BUF_251_inst                                                       0x017B
+#define CAM_EMM_EMM_BUF_252_inst                                                       0x017C
+#define CAM_EMM_EMM_BUF_253_inst                                                       0x017D
+#define CAM_EMM_EMM_BUF_254_inst                                                       0x017E
+#define CAM_EMM_EMM_BUF_255_inst                                                       0x017F
+#define CAM_EMM_EMM_BUF_256_inst                                                       0x0180
+#define CAM_EMM_EMM_BUF_257_inst                                                       0x0181
+#define CAM_EMM_EMM_BUF_258_inst                                                       0x0182
+#define CAM_EMM_EMM_BUF_259_inst                                                       0x0183
+#define CAM_EMM_EMM_BUF_260_inst                                                       0x0184
+#define CAM_EMM_EMM_BUF_261_inst                                                       0x0185
+#define CAM_EMM_EMM_BUF_262_inst                                                       0x0186
+#define CAM_EMM_EMM_BUF_263_inst                                                       0x0187
+#define CAM_EMM_EMM_BUF_264_inst                                                       0x0188
+#define CAM_EMM_EMM_BUF_265_inst                                                       0x0189
+#define CAM_EMM_EMM_BUF_266_inst                                                       0x018A
+#define CAM_EMM_EMM_BUF_267_inst                                                       0x018B
+#define CAM_EMM_EMM_BUF_268_inst                                                       0x018C
+#define CAM_EMM_EMM_BUF_269_inst                                                       0x018D
+#define CAM_EMM_EMM_BUF_270_inst                                                       0x018E
+#define CAM_EMM_EMM_BUF_271_inst                                                       0x018F
+#define CAM_EMM_EMM_BUF_272_inst                                                       0x0190
+#define CAM_EMM_EMM_BUF_273_inst                                                       0x0191
+#define CAM_EMM_EMM_BUF_274_inst                                                       0x0192
+#define CAM_EMM_EMM_BUF_275_inst                                                       0x0193
+#define CAM_EMM_EMM_BUF_276_inst                                                       0x0194
+#define CAM_EMM_EMM_BUF_277_inst                                                       0x0195
+#define CAM_EMM_EMM_BUF_278_inst                                                       0x0196
+#define CAM_EMM_EMM_BUF_279_inst                                                       0x0197
+#define CAM_EMM_EMM_BUF_280_inst                                                       0x0198
+#define CAM_EMM_EMM_BUF_281_inst                                                       0x0199
+#define CAM_EMM_EMM_BUF_282_inst                                                       0x019A
+#define CAM_EMM_EMM_BUF_283_inst                                                       0x019B
+#define CAM_EMM_EMM_BUF_284_inst                                                       0x019C
+#define CAM_EMM_EMM_BUF_285_inst                                                       0x019D
+#define CAM_EMM_EMM_BUF_286_inst                                                       0x019E
+#define CAM_EMM_EMM_BUF_287_inst                                                       0x019F
+#define CAM_EMM_EMM_BUF_288_inst                                                       0x01A0
+#define CAM_EMM_EMM_BUF_289_inst                                                       0x01A1
+#define CAM_EMM_EMM_BUF_290_inst                                                       0x01A2
+#define CAM_EMM_EMM_BUF_291_inst                                                       0x01A3
+#define CAM_EMM_EMM_BUF_292_inst                                                       0x01A4
+#define CAM_EMM_EMM_BUF_293_inst                                                       0x01A5
+#define CAM_EMM_EMM_BUF_294_inst                                                       0x01A6
+#define CAM_EMM_EMM_BUF_295_inst                                                       0x01A7
+#define CAM_EMM_EMM_BUF_296_inst                                                       0x01A8
+#define CAM_EMM_EMM_BUF_297_inst                                                       0x01A9
+#define CAM_EMM_EMM_BUF_298_inst                                                       0x01AA
+#define CAM_EMM_EMM_BUF_299_inst                                                       0x01AB
+#define CAM_EMM_EMM_BUF_300_inst                                                       0x01AC
+#define CAM_EMM_EMM_BUF_301_inst                                                       0x01AD
+#define CAM_EMM_EMM_BUF_302_inst                                                       0x01AE
+#define CAM_EMM_EMM_BUF_303_inst                                                       0x01AF
+#define CAM_EMM_EMM_BUF_304_inst                                                       0x01B0
+#define CAM_EMM_EMM_BUF_305_inst                                                       0x01B1
+#define CAM_EMM_EMM_BUF_306_inst                                                       0x01B2
+#define CAM_EMM_EMM_BUF_307_inst                                                       0x01B3
+#define CAM_EMM_EMM_BUF_308_inst                                                       0x01B4
+#define CAM_EMM_EMM_BUF_309_inst                                                       0x01B5
+#define CAM_EMM_EMM_BUF_310_inst                                                       0x01B6
+#define CAM_EMM_EMM_BUF_311_inst                                                       0x01B7
+#define CAM_EMM_EMM_BUF_312_inst                                                       0x01B8
+#define CAM_EMM_EMM_BUF_313_inst                                                       0x01B9
+#define CAM_EMM_EMM_BUF_314_inst                                                       0x01BA
+#define CAM_EMM_EMM_BUF_315_inst                                                       0x01BB
+#define CAM_EMM_EMM_BUF_316_inst                                                       0x01BC
+#define CAM_EMM_EMM_BUF_317_inst                                                       0x01BD
+#define CAM_EMM_EMM_BUF_318_inst                                                       0x01BE
+#define CAM_EMM_EMM_BUF_319_inst                                                       0x01BF
+#define CAM_EMM_EMM_BUF_320_inst                                                       0x01C0
+#define CAM_EMM_EMM_BUF_321_inst                                                       0x01C1
+#define CAM_EMM_EMM_BUF_322_inst                                                       0x01C2
+#define CAM_EMM_EMM_BUF_323_inst                                                       0x01C3
+#define CAM_EMM_EMM_BUF_324_inst                                                       0x01C4
+#define CAM_EMM_EMM_BUF_325_inst                                                       0x01C5
+#define CAM_EMM_EMM_BUF_326_inst                                                       0x01C6
+#define CAM_EMM_EMM_BUF_327_inst                                                       0x01C7
+#define CAM_EMM_EMM_BUF_328_inst                                                       0x01C8
+#define CAM_EMM_EMM_BUF_329_inst                                                       0x01C9
+#define CAM_EMM_EMM_BUF_330_inst                                                       0x01CA
+#define CAM_EMM_EMM_BUF_331_inst                                                       0x01CB
+#define CAM_EMM_EMM_BUF_332_inst                                                       0x01CC
+#define CAM_EMM_EMM_BUF_333_inst                                                       0x01CD
+#define CAM_EMM_EMM_BUF_334_inst                                                       0x01CE
+#define CAM_EMM_EMM_BUF_335_inst                                                       0x01CF
+#define CAM_EMM_EMM_BUF_336_inst                                                       0x01D0
+#define CAM_EMM_EMM_BUF_337_inst                                                       0x01D1
+#define CAM_EMM_EMM_BUF_338_inst                                                       0x01D2
+#define CAM_EMM_EMM_BUF_339_inst                                                       0x01D3
+#define CAM_EMM_EMM_BUF_340_inst                                                       0x01D4
+#define CAM_EMM_EMM_BUF_341_inst                                                       0x01D5
+#define CAM_EMM_EMM_BUF_342_inst                                                       0x01D6
+#define CAM_EMM_EMM_BUF_343_inst                                                       0x01D7
+#define CAM_EMM_EMM_BUF_344_inst                                                       0x01D8
+#define CAM_EMM_EMM_BUF_345_inst                                                       0x01D9
+#define CAM_EMM_EMM_BUF_346_inst                                                       0x01DA
+#define CAM_EMM_EMM_BUF_347_inst                                                       0x01DB
+#define CAM_EMM_EMM_BUF_348_inst                                                       0x01DC
+#define CAM_EMM_EMM_BUF_349_inst                                                       0x01DD
+#define CAM_EMM_EMM_BUF_350_inst                                                       0x01DE
+#define CAM_EMM_EMM_BUF_351_inst                                                       0x01DF
+#define CAM_EMM_EMM_BUF_352_inst                                                       0x01E0
+#define CAM_EMM_EMM_BUF_353_inst                                                       0x01E1
+#define CAM_EMM_EMM_BUF_354_inst                                                       0x01E2
+#define CAM_EMM_EMM_BUF_355_inst                                                       0x01E3
+#define CAM_EMM_EMM_BUF_356_inst                                                       0x01E4
+#define CAM_EMM_EMM_BUF_357_inst                                                       0x01E5
+#define CAM_EMM_EMM_BUF_358_inst                                                       0x01E6
+#define CAM_EMM_EMM_BUF_359_inst                                                       0x01E7
+#define CAM_EMM_EMM_BUF_360_inst                                                       0x01E8
+#define CAM_EMM_EMM_BUF_361_inst                                                       0x01E9
+#define CAM_EMM_EMM_BUF_362_inst                                                       0x01EA
+#define CAM_EMM_EMM_BUF_363_inst                                                       0x01EB
+#define CAM_EMM_EMM_BUF_364_inst                                                       0x01EC
+#define CAM_EMM_EMM_BUF_365_inst                                                       0x01ED
+#define CAM_EMM_EMM_BUF_366_inst                                                       0x01EE
+#define CAM_EMM_EMM_BUF_367_inst                                                       0x01EF
+#define CAM_EMM_EMM_BUF_368_inst                                                       0x01F0
+#define CAM_EMM_EMM_BUF_369_inst                                                       0x01F1
+#define CAM_EMM_EMM_BUF_370_inst                                                       0x01F2
+#define CAM_EMM_EMM_BUF_371_inst                                                       0x01F3
+#define CAM_EMM_EMM_BUF_372_inst                                                       0x01F4
+#define CAM_EMM_EMM_BUF_373_inst                                                       0x01F5
+#define CAM_EMM_EMM_BUF_374_inst                                                       0x01F6
+#define CAM_EMM_EMM_BUF_375_inst                                                       0x01F7
+#define CAM_EMM_EMM_BUF_376_inst                                                       0x01F8
+#define CAM_EMM_EMM_BUF_377_inst                                                       0x01F9
+#define CAM_EMM_EMM_BUF_378_inst                                                       0x01FA
+#define CAM_EMM_EMM_BUF_379_inst                                                       0x01FB
+#define CAM_EMM_EMM_BUF_380_inst                                                       0x01FC
+#define CAM_EMM_EMM_BUF_381_inst                                                       0x01FD
+#define CAM_EMM_EMM_BUF_382_inst                                                       0x01FE
+#define CAM_EMM_EMM_BUF_383_inst                                                       0x01FF
+#define CAM_EMM_EMM_BUF_384_inst                                                       0x0200
+#define CAM_EMM_EMM_BUF_385_inst                                                       0x0201
+#define CAM_EMM_EMM_BUF_386_inst                                                       0x0202
+#define CAM_EMM_EMM_BUF_387_inst                                                       0x0203
+#define CAM_EMM_EMM_BUF_388_inst                                                       0x0204
+#define CAM_EMM_EMM_BUF_389_inst                                                       0x0205
+#define CAM_EMM_EMM_BUF_390_inst                                                       0x0206
+#define CAM_EMM_EMM_BUF_391_inst                                                       0x0207
+#define CAM_EMM_EMM_BUF_392_inst                                                       0x0208
+#define CAM_EMM_EMM_BUF_393_inst                                                       0x0209
+#define CAM_EMM_EMM_BUF_394_inst                                                       0x020A
+#define CAM_EMM_EMM_BUF_395_inst                                                       0x020B
+#define CAM_EMM_EMM_BUF_396_inst                                                       0x020C
+#define CAM_EMM_EMM_BUF_397_inst                                                       0x020D
+#define CAM_EMM_EMM_BUF_398_inst                                                       0x020E
+#define CAM_EMM_EMM_BUF_399_inst                                                       0x020F
+#define CAM_EMM_EMM_BUF_400_inst                                                       0x0210
+#define CAM_EMM_EMM_BUF_401_inst                                                       0x0211
+#define CAM_EMM_EMM_BUF_402_inst                                                       0x0212
+#define CAM_EMM_EMM_BUF_403_inst                                                       0x0213
+#define CAM_EMM_EMM_BUF_404_inst                                                       0x0214
+#define CAM_EMM_EMM_BUF_405_inst                                                       0x0215
+#define CAM_EMM_EMM_BUF_406_inst                                                       0x0216
+#define CAM_EMM_EMM_BUF_407_inst                                                       0x0217
+#define CAM_EMM_EMM_BUF_408_inst                                                       0x0218
+#define CAM_EMM_EMM_BUF_409_inst                                                       0x0219
+#define CAM_EMM_EMM_BUF_410_inst                                                       0x021A
+#define CAM_EMM_EMM_BUF_411_inst                                                       0x021B
+#define CAM_EMM_EMM_BUF_412_inst                                                       0x021C
+#define CAM_EMM_EMM_BUF_413_inst                                                       0x021D
+#define CAM_EMM_EMM_BUF_414_inst                                                       0x021E
+#define CAM_EMM_EMM_BUF_415_inst                                                       0x021F
+#define CAM_EMM_EMM_BUF_416_inst                                                       0x0220
+#define CAM_EMM_EMM_BUF_417_inst                                                       0x0221
+#define CAM_EMM_EMM_BUF_418_inst                                                       0x0222
+#define CAM_EMM_EMM_BUF_419_inst                                                       0x0223
+#define CAM_EMM_EMM_BUF_420_inst                                                       0x0224
+#define CAM_EMM_EMM_BUF_421_inst                                                       0x0225
+#define CAM_EMM_EMM_BUF_422_inst                                                       0x0226
+#define CAM_EMM_EMM_BUF_423_inst                                                       0x0227
+#define CAM_EMM_EMM_BUF_424_inst                                                       0x0228
+#define CAM_EMM_EMM_BUF_425_inst                                                       0x0229
+#define CAM_EMM_EMM_BUF_426_inst                                                       0x022A
+#define CAM_EMM_EMM_BUF_427_inst                                                       0x022B
+#define CAM_EMM_EMM_BUF_428_inst                                                       0x022C
+#define CAM_EMM_EMM_BUF_429_inst                                                       0x022D
+#define CAM_EMM_EMM_BUF_430_inst                                                       0x022E
+#define CAM_EMM_EMM_BUF_431_inst                                                       0x022F
+#define CAM_EMM_EMM_BUF_432_inst                                                       0x0230
+#define CAM_EMM_EMM_BUF_433_inst                                                       0x0231
+#define CAM_EMM_EMM_BUF_434_inst                                                       0x0232
+#define CAM_EMM_EMM_BUF_435_inst                                                       0x0233
+#define CAM_EMM_EMM_BUF_436_inst                                                       0x0234
+#define CAM_EMM_EMM_BUF_437_inst                                                       0x0235
+#define CAM_EMM_EMM_BUF_438_inst                                                       0x0236
+#define CAM_EMM_EMM_BUF_439_inst                                                       0x0237
+#define CAM_EMM_EMM_BUF_440_inst                                                       0x0238
+#define CAM_EMM_EMM_BUF_441_inst                                                       0x0239
+#define CAM_EMM_EMM_BUF_442_inst                                                       0x023A
+#define CAM_EMM_EMM_BUF_443_inst                                                       0x023B
+#define CAM_EMM_EMM_BUF_444_inst                                                       0x023C
+#define CAM_EMM_EMM_BUF_445_inst                                                       0x023D
+#define CAM_EMM_EMM_BUF_446_inst                                                       0x023E
+#define CAM_EMM_EMM_BUF_447_inst                                                       0x023F
+#define CAM_EMM_EMM_BUF_448_inst                                                       0x0240
+#define CAM_EMM_EMM_BUF_449_inst                                                       0x0241
+#define CAM_EMM_EMM_BUF_450_inst                                                       0x0242
+#define CAM_EMM_EMM_BUF_451_inst                                                       0x0243
+#define CAM_EMM_EMM_BUF_452_inst                                                       0x0244
+#define CAM_EMM_EMM_BUF_453_inst                                                       0x0245
+#define CAM_EMM_EMM_BUF_454_inst                                                       0x0246
+#define CAM_EMM_EMM_BUF_455_inst                                                       0x0247
+#define CAM_EMM_EMM_BUF_456_inst                                                       0x0248
+#define CAM_EMM_EMM_BUF_457_inst                                                       0x0249
+#define CAM_EMM_EMM_BUF_458_inst                                                       0x024A
+#define CAM_EMM_EMM_BUF_459_inst                                                       0x024B
+#define CAM_EMM_EMM_BUF_460_inst                                                       0x024C
+#define CAM_EMM_EMM_BUF_461_inst                                                       0x024D
+#define CAM_EMM_EMM_BUF_462_inst                                                       0x024E
+#define CAM_EMM_EMM_BUF_463_inst                                                       0x024F
+#define CAM_EMM_EMM_BUF_464_inst                                                       0x0250
+#define CAM_EMM_EMM_BUF_465_inst                                                       0x0251
+#define CAM_EMM_EMM_BUF_466_inst                                                       0x0252
+#define CAM_EMM_EMM_BUF_467_inst                                                       0x0253
+#define CAM_EMM_EMM_BUF_468_inst                                                       0x0254
+#define CAM_EMM_EMM_BUF_469_inst                                                       0x0255
+#define CAM_EMM_EMM_BUF_470_inst                                                       0x0256
+#define CAM_EMM_EMM_BUF_471_inst                                                       0x0257
+#define CAM_EMM_EMM_BUF_472_inst                                                       0x0258
+#define CAM_EMM_EMM_BUF_473_inst                                                       0x0259
+#define CAM_EMM_EMM_BUF_474_inst                                                       0x025A
+#define CAM_EMM_EMM_BUF_475_inst                                                       0x025B
+#define CAM_EMM_EMM_BUF_476_inst                                                       0x025C
+#define CAM_EMM_EMM_BUF_477_inst                                                       0x025D
+#define CAM_EMM_EMM_BUF_478_inst                                                       0x025E
+#define CAM_EMM_EMM_BUF_479_inst                                                       0x025F
+#define CAM_EMM_EMM_BUF_480_inst                                                       0x0260
+#define CAM_EMM_EMM_BUF_481_inst                                                       0x0261
+#define CAM_EMM_EMM_BUF_482_inst                                                       0x0262
+#define CAM_EMM_EMM_BUF_483_inst                                                       0x0263
+#define CAM_EMM_EMM_BUF_484_inst                                                       0x0264
+#define CAM_EMM_EMM_BUF_485_inst                                                       0x0265
+#define CAM_EMM_EMM_BUF_486_inst                                                       0x0266
+#define CAM_EMM_EMM_BUF_487_inst                                                       0x0267
+#define CAM_EMM_EMM_BUF_488_inst                                                       0x0268
+#define CAM_EMM_EMM_BUF_489_inst                                                       0x0269
+#define CAM_EMM_EMM_BUF_490_inst                                                       0x026A
+#define CAM_EMM_EMM_BUF_491_inst                                                       0x026B
+#define CAM_EMM_EMM_BUF_492_inst                                                       0x026C
+#define CAM_EMM_EMM_BUF_493_inst                                                       0x026D
+#define CAM_EMM_EMM_BUF_494_inst                                                       0x026E
+#define CAM_EMM_EMM_BUF_495_inst                                                       0x026F
+#define CAM_EMM_EMM_BUF_496_inst                                                       0x0270
+#define CAM_EMM_EMM_BUF_497_inst                                                       0x0271
+#define CAM_EMM_EMM_BUF_498_inst                                                       0x0272
+#define CAM_EMM_EMM_BUF_499_inst                                                       0x0273
+#define CAM_EMM_EMM_BUF_500_inst                                                       0x0274
+#define CAM_EMM_EMM_BUF_501_inst                                                       0x0275
+#define CAM_EMM_EMM_BUF_502_inst                                                       0x0276
+#define CAM_EMM_EMM_BUF_503_inst                                                       0x0277
+#define CAM_EMM_EMM_BUF_504_inst                                                       0x0278
+#define CAM_EMM_EMM_BUF_505_inst                                                       0x0279
+#define CAM_EMM_EMM_BUF_506_inst                                                       0x027A
+#define CAM_EMM_EMM_BUF_507_inst                                                       0x027B
+#define CAM_EMM_EMM_BUF_508_inst                                                       0x027C
+#define CAM_EMM_EMM_BUF_509_inst                                                       0x027D
+#define CAM_EMM_EMM_BUF_510_inst                                                       0x027E
+#define CAM_EMM_EMM_BUF_511_inst                                                       0x027F
+#define CAM_EMM_EMM_BUF_512_inst                                                       0x0280
+#define CAM_EMM_EMM_BUF_513_inst                                                       0x0281
+#define CAM_EMM_EMM_BUF_514_inst                                                       0x0282
+#define CAM_EMM_EMM_BUF_515_inst                                                       0x0283
+#define CAM_EMM_EMM_BUF_516_inst                                                       0x0284
+#define CAM_EMM_EMM_BUF_517_inst                                                       0x0285
+#define CAM_EMM_EMM_BUF_518_inst                                                       0x0286
+#define CAM_EMM_EMM_BUF_519_inst                                                       0x0287
+#define CAM_EMM_EMM_BUF_520_inst                                                       0x0288
+#define CAM_EMM_EMM_BUF_521_inst                                                       0x0289
+#define CAM_EMM_EMM_BUF_522_inst                                                       0x028A
+#define CAM_EMM_EMM_BUF_523_inst                                                       0x028B
+#define CAM_EMM_EMM_BUF_524_inst                                                       0x028C
+#define CAM_EMM_EMM_BUF_525_inst                                                       0x028D
+#define CAM_EMM_EMM_BUF_526_inst                                                       0x028E
+#define CAM_EMM_EMM_BUF_527_inst                                                       0x028F
+#define CAM_EMM_EMM_BUF_528_inst                                                       0x0290
+#define CAM_EMM_EMM_BUF_529_inst                                                       0x0291
+#define CAM_EMM_EMM_BUF_530_inst                                                       0x0292
+#define CAM_EMM_EMM_BUF_531_inst                                                       0x0293
+#define CAM_EMM_EMM_BUF_532_inst                                                       0x0294
+#define CAM_EMM_EMM_BUF_533_inst                                                       0x0295
+#define CAM_EMM_EMM_BUF_534_inst                                                       0x0296
+#define CAM_EMM_EMM_BUF_535_inst                                                       0x0297
+#define CAM_EMM_EMM_BUF_536_inst                                                       0x0298
+#define CAM_EMM_EMM_BUF_537_inst                                                       0x0299
+#define CAM_EMM_EMM_BUF_538_inst                                                       0x029A
+#define CAM_EMM_EMM_BUF_539_inst                                                       0x029B
+#define CAM_EMM_EMM_BUF_540_inst                                                       0x029C
+#define CAM_EMM_EMM_BUF_541_inst                                                       0x029D
+#define CAM_EMM_EMM_BUF_542_inst                                                       0x029E
+#define CAM_EMM_EMM_BUF_543_inst                                                       0x029F
+#define CAM_EMM_EMM_BUF_544_inst                                                       0x02A0
+#define CAM_EMM_EMM_BUF_545_inst                                                       0x02A1
+#define CAM_EMM_EMM_BUF_546_inst                                                       0x02A2
+#define CAM_EMM_EMM_BUF_547_inst                                                       0x02A3
+#define CAM_EMM_EMM_BUF_548_inst                                                       0x02A4
+#define CAM_EMM_EMM_BUF_549_inst                                                       0x02A5
+#define CAM_EMM_EMM_BUF_550_inst                                                       0x02A6
+#define CAM_EMM_EMM_BUF_551_inst                                                       0x02A7
+#define CAM_EMM_EMM_BUF_552_inst                                                       0x02A8
+#define CAM_EMM_EMM_BUF_553_inst                                                       0x02A9
+#define CAM_EMM_EMM_BUF_554_inst                                                       0x02AA
+#define CAM_EMM_EMM_BUF_555_inst                                                       0x02AB
+#define CAM_EMM_EMM_BUF_556_inst                                                       0x02AC
+#define CAM_EMM_EMM_BUF_557_inst                                                       0x02AD
+#define CAM_EMM_EMM_BUF_558_inst                                                       0x02AE
+#define CAM_EMM_EMM_BUF_559_inst                                                       0x02AF
+#define CAM_EMM_EMM_BUF_560_inst                                                       0x02B0
+#define CAM_EMM_EMM_BUF_561_inst                                                       0x02B1
+#define CAM_EMM_EMM_BUF_562_inst                                                       0x02B2
+#define CAM_EMM_EMM_BUF_563_inst                                                       0x02B3
+#define CAM_EMM_EMM_BUF_564_inst                                                       0x02B4
+#define CAM_EMM_EMM_BUF_565_inst                                                       0x02B5
+#define CAM_EMM_EMM_BUF_566_inst                                                       0x02B6
+#define CAM_EMM_EMM_BUF_567_inst                                                       0x02B7
+#define CAM_EMM_EMM_BUF_568_inst                                                       0x02B8
+#define CAM_EMM_EMM_BUF_569_inst                                                       0x02B9
+#define CAM_EMM_EMM_BUF_570_inst                                                       0x02BA
+#define CAM_EMM_EMM_BUF_571_inst                                                       0x02BB
+#define CAM_EMM_EMM_BUF_572_inst                                                       0x02BC
+#define CAM_EMM_EMM_BUF_573_inst                                                       0x02BD
+#define CAM_EMM_EMM_BUF_574_inst                                                       0x02BE
+#define CAM_EMM_EMM_BUF_575_inst                                                       0x02BF
+#define CAM_EMM_EMM_BUF_576_inst                                                       0x02C0
+#define CAM_EMM_EMM_BUF_577_inst                                                       0x02C1
+#define CAM_EMM_EMM_BUF_578_inst                                                       0x02C2
+#define CAM_EMM_EMM_BUF_579_inst                                                       0x02C3
+#define CAM_EMM_EMM_BUF_580_inst                                                       0x02C4
+#define CAM_EMM_EMM_BUF_581_inst                                                       0x02C5
+#define CAM_EMM_EMM_BUF_582_inst                                                       0x02C6
+#define CAM_EMM_EMM_BUF_583_inst                                                       0x02C7
+#define CAM_EMM_EMM_BUF_584_inst                                                       0x02C8
+#define CAM_EMM_EMM_BUF_585_inst                                                       0x02C9
+#define CAM_EMM_EMM_BUF_586_inst                                                       0x02CA
+#define CAM_EMM_EMM_BUF_587_inst                                                       0x02CB
+#define CAM_EMM_EMM_BUF_588_inst                                                       0x02CC
+#define CAM_EMM_EMM_BUF_589_inst                                                       0x02CD
+#define CAM_EMM_EMM_BUF_590_inst                                                       0x02CE
+#define CAM_EMM_EMM_BUF_591_inst                                                       0x02CF
+#define CAM_EMM_EMM_BUF_592_inst                                                       0x02D0
+#define CAM_EMM_EMM_BUF_593_inst                                                       0x02D1
+#define CAM_EMM_EMM_BUF_594_inst                                                       0x02D2
+#define CAM_EMM_EMM_BUF_595_inst                                                       0x02D3
+#define CAM_EMM_EMM_BUF_596_inst                                                       0x02D4
+#define CAM_EMM_EMM_BUF_597_inst                                                       0x02D5
+#define CAM_EMM_EMM_BUF_598_inst                                                       0x02D6
+#define CAM_EMM_EMM_BUF_599_inst                                                       0x02D7
+#define CAM_EMM_EMM_BUF_600_inst                                                       0x02D8
+#define CAM_EMM_EMM_BUF_601_inst                                                       0x02D9
+#define CAM_EMM_EMM_BUF_602_inst                                                       0x02DA
+#define CAM_EMM_EMM_BUF_603_inst                                                       0x02DB
+#define CAM_EMM_EMM_BUF_604_inst                                                       0x02DC
+#define CAM_EMM_EMM_BUF_605_inst                                                       0x02DD
+#define CAM_EMM_EMM_BUF_606_inst                                                       0x02DE
+#define CAM_EMM_EMM_BUF_607_inst                                                       0x02DF
+#define CAM_EMM_EMM_BUF_608_inst                                                       0x02E0
+#define CAM_EMM_EMM_BUF_609_inst                                                       0x02E1
+#define CAM_EMM_EMM_BUF_610_inst                                                       0x02E2
+#define CAM_EMM_EMM_BUF_611_inst                                                       0x02E3
+#define CAM_EMM_EMM_BUF_612_inst                                                       0x02E4
+#define CAM_EMM_EMM_BUF_613_inst                                                       0x02E5
+#define CAM_EMM_EMM_BUF_614_inst                                                       0x02E6
+#define CAM_EMM_EMM_BUF_615_inst                                                       0x02E7
+#define CAM_EMM_EMM_BUF_616_inst                                                       0x02E8
+#define CAM_EMM_EMM_BUF_617_inst                                                       0x02E9
+#define CAM_EMM_EMM_BUF_618_inst                                                       0x02EA
+#define CAM_EMM_EMM_BUF_619_inst                                                       0x02EB
+#define CAM_EMM_EMM_BUF_620_inst                                                       0x02EC
+#define CAM_EMM_EMM_BUF_621_inst                                                       0x02ED
+#define CAM_EMM_EMM_BUF_622_inst                                                       0x02EE
+#define CAM_EMM_EMM_BUF_623_inst                                                       0x02EF
+#define CAM_EMM_EMM_BUF_624_inst                                                       0x02F0
+#define CAM_EMM_EMM_BUF_625_inst                                                       0x02F1
+#define CAM_EMM_EMM_BUF_626_inst                                                       0x02F2
+#define CAM_EMM_EMM_BUF_627_inst                                                       0x02F3
+#define CAM_EMM_EMM_BUF_628_inst                                                       0x02F4
+#define CAM_EMM_EMM_BUF_629_inst                                                       0x02F5
+#define CAM_EMM_EMM_BUF_630_inst                                                       0x02F6
+#define CAM_EMM_EMM_BUF_631_inst                                                       0x02F7
+#define CAM_EMM_EMM_BUF_632_inst                                                       0x02F8
+#define CAM_EMM_EMM_BUF_633_inst                                                       0x02F9
+#define CAM_EMM_EMM_BUF_634_inst                                                       0x02FA
+#define CAM_EMM_EMM_BUF_635_inst                                                       0x02FB
+#define CAM_EMM_EMM_BUF_636_inst                                                       0x02FC
+#define CAM_EMM_EMM_BUF_637_inst                                                       0x02FD
+#define CAM_EMM_EMM_BUF_638_inst                                                       0x02FE
+#define CAM_EMM_EMM_BUF_639_inst                                                       0x02FF
+#define CAM_EMM_EMM_BUF_pkt_data_shift                                               (0)
+#define CAM_EMM_EMM_BUF_pkt_data_mask                                                (0xFFFFFFFF)
+#define CAM_EMM_EMM_BUF_pkt_data(data)                                               (0xFFFFFFFF&((data)<<0))
+#define CAM_EMM_EMM_BUF_pkt_data_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define CAM_EMM_EMM_BUF_get_pkt_data(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/cbus_tx_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cbus_tx_reg.h
new file mode 100644
index 00000000..4b40bfb
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cbus_tx_reg.h
@@ -0,0 +1,3024 @@
+/**************************************************************
+// Spec Version                  : 0.0.1
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/9/23 9:48:45
+***************************************************************/
+
+
+#ifndef _CBUS_TX_REG_H_INCLUDED_
+#define _CBUS_TX_REG_H_INCLUDED_
+#ifdef  _CBUS_TX_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sys_clk_div:3;
+unsigned int     clk_1m_div:8;
+unsigned int     abs_thres_en:1;
+unsigned int     reserved_1:1;
+unsigned int     sync0_hb:9;
+unsigned int     sync0_lb:9;
+}CBUS_TX_CBUS_CTRL0;
+
+typedef struct 
+{
+unsigned int     parity_time:8;
+unsigned int     abs_threshold:8;
+unsigned int     sync1_hb:8;
+unsigned int     sync1_lb:8;
+}CBUS_TX_CBUS_CTRL1;
+
+typedef struct 
+{
+unsigned int     vendor_id:8;
+unsigned int     reserved_0:1;
+unsigned int     ack_0:7;
+unsigned int     reserved_1:1;
+unsigned int     ack_fall:7;
+unsigned int     reserved_2:3;
+unsigned int     parity_limit:5;
+}CBUS_TX_CBUS_CTRL2;
+
+typedef struct 
+{
+unsigned int     tx_bit_time:8;
+unsigned int     reserved_0:1;
+unsigned int     tx_ack_fal:7;
+unsigned int     reserved_1:1;
+unsigned int     tx_ack_low_hb:7;
+unsigned int     reserved_2:1;
+unsigned int     tx_ack_low_lb:7;
+}CBUS_TX_CBUS_CTRL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     glob_time:2;
+unsigned int     link_time:5;
+unsigned int     req_hold:4;
+unsigned int     resp_hold:4;
+unsigned int     wait_time:4;
+unsigned int     fast_reply_en:1;
+unsigned int     drv_str:2;
+unsigned int     drv_hi_cbus:6;
+unsigned int     retry_lv:3;
+}CBUS_TX_CBUS_CTRL4;
+
+typedef struct 
+{
+unsigned int     burst_wait:4;
+unsigned int     fw_rxsense_en:1;
+unsigned int     mhl_conn:1;
+unsigned int     fw_path_en:1;
+unsigned int     send_path:1;
+unsigned int     req_opp_flt:8;
+unsigned int     req_opp_int:2;
+unsigned int     chk_point:6;
+unsigned int     reserved_0:3;
+unsigned int     avoid_conf:1;
+unsigned int     reserved_1:1;
+unsigned int     cbus_imp_fw_en:1;
+unsigned int     z_5k_on:1;
+unsigned int     z_10k_on:1;
+}CBUS_TX_CBUS_CTRL5;
+
+typedef struct 
+{
+unsigned int     wake_pulse_width1:2;
+unsigned int     dis_chk_high:3;
+unsigned int     reserved_0:1;
+unsigned int     wake_pulse_width2:4;
+unsigned int     src_cbus_float:4;
+unsigned int     src_pulse_width:7;
+unsigned int     src_conn:2;
+unsigned int     rxsense_deglitch:9;
+}CBUS_TX_CBUS_CTRL6;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     wake_to_discover:10;
+unsigned int     src_vbus_cbus_stable:10;
+unsigned int     vbus_out_to_stable:10;
+}CBUS_TX_CBUS_CTRL7;
+
+typedef struct 
+{
+unsigned int     req_cont:8;
+unsigned int     src_arbitrate:3;
+unsigned int     pulse_count:5;
+unsigned int     wait_sink_float:1;
+unsigned int     sink_cbus_float:2;
+unsigned int     reserved_0:3;
+unsigned int     rxsense_chk:10;
+}CBUS_TX_CBUS_CTRL8;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     retry_flag:1;
+unsigned int     link_err:1;
+unsigned int     conflict_err:1;
+unsigned int     sync_bit_time:8;
+unsigned int     reserved_1:4;
+unsigned int     discovery_st:3;
+unsigned int     write_data:1;
+}CBUS_TX_CBUS_STATUS;
+
+typedef struct 
+{
+unsigned int     fw0_req:1;
+unsigned int     fw0_tx_case:3;
+unsigned int     fw0_wait_case:2;
+unsigned int     fw0_head:2;
+unsigned int     fw0_fifo_clr:1;
+unsigned int     reserved_0:23;
+}CBUS_TX_FW0_CMD_INF;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     fw0_cmd2:8;
+unsigned int     fw0_offset:8;
+unsigned int     fw0_cmd1:8;
+}CBUS_TX_FW0_CMD;
+
+typedef struct 
+{
+unsigned int     fw0_cmd_rcv:8;
+unsigned int     fw0_data_rcv:8;
+unsigned int     fw0_rcv_err:1;
+unsigned int     fw0_fifo_full:1;
+unsigned int     fw0_fifo_empty:1;
+unsigned int     fw0_fifo_len:5;
+unsigned int     fw0_rty_ovr:1;
+unsigned int     msc_hpd:1;
+unsigned int     reserved_0:5;
+unsigned int     write_data:1;
+}CBUS_TX_FW0_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     fw0_data:8;
+}CBUS_TX_FW0_WDATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     fw0_rdata:8;
+}CBUS_TX_FW0_RDATA;
+
+typedef struct 
+{
+unsigned int     scr_offset:8;
+unsigned int     sta_offset:8;
+unsigned int     int_offset:8;
+unsigned int     cap_offset:8;
+}CBUS_TX_DEVCAP_OFFSET;
+
+typedef struct 
+{
+unsigned int     que_fsm:4;
+unsigned int     sch_fsm:4;
+unsigned int     burst_timeout:1;
+unsigned int     reserved_0:22;
+unsigned int     write_data:1;
+}CBUS_TX_MSC_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ucpk_rcv:8;
+unsigned int     ucp_rcv:8;
+unsigned int     ucpe_rcv:8;
+}CBUS_TX_MSG_STATUS1;
+
+typedef struct 
+{
+unsigned int     msge_rcv:8;
+unsigned int     rcpk_rcv:8;
+unsigned int     rcp_rcv:8;
+unsigned int     rcpe_rcv:8;
+}CBUS_TX_MSG_STATUS2;
+
+typedef struct 
+{
+unsigned int     rap_rcv:8;
+unsigned int     rapk_rcv:8;
+unsigned int     msg_dat:8;
+unsigned int     msg_cmd:8;
+}CBUS_TX_MSG_STATUS3;
+
+typedef struct 
+{
+unsigned int     wb_id_chk:1;
+unsigned int     rcp_reply_nack:1;
+unsigned int     rcp_reply_abort:1;
+unsigned int     reserved_0:5;
+unsigned int     fwdef_cmd_rev:8;
+unsigned int     reserved_1:16;
+}CBUS_TX_ADOPTERID_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     reserved_1:8;
+unsigned int     adop_idl_rcv:8;
+unsigned int     adop_idh_rcv:8;
+}CBUS_TX_RCV_ADOPTER_ID;
+
+typedef struct 
+{
+unsigned int     mcumsc_en:1;
+unsigned int     reserved_0:1;
+unsigned int     msc_wait_arb:1;
+unsigned int     rx_fifo_clr:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     que_fsm_clr:1;
+unsigned int     sch_fsm_clr:1;
+unsigned int     reserved_3:24;
+}CBUS_TX_MSC_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     msc_err_code:8;
+}CBUS_TX_MSC_BURST_DATA;
+
+typedef struct 
+{
+unsigned int     rx_fifo_full:1;
+unsigned int     rx_fifo_empty:1;
+unsigned int     reserved_0:1;
+unsigned int     na_rx_len:5;
+unsigned int     reserved_1:8;
+unsigned int     na_msc_offset:8;
+unsigned int     na_msc_cmd:8;
+}CBUS_TX_MSC_RCV_CMD;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rx_fifo_data:8;
+}CBUS_TX_MSC_RCV_DATA;
+
+typedef struct 
+{
+unsigned int     msc_err_force:1;
+unsigned int     reserved_0:23;
+unsigned int     msc_err_fw:8;
+}CBUS_TX_MSC_WRITE_ERR_CODE;
+
+typedef struct 
+{
+unsigned int     ddc_rdy:1;
+unsigned int     ddc_cmd_type:3;
+unsigned int     ddc_num:4;
+unsigned int     ddc_nack_limit:8;
+unsigned int     reserved_0:5;
+unsigned int     ddc_err_code_clr:1;
+unsigned int     ddc_prior_dis:1;
+unsigned int     ddc_fsm_clr:1;
+unsigned int     reserved_1:5;
+unsigned int     ddc_nack_retry:1;
+unsigned int     ddc_wait_case:1;
+unsigned int     ddc_fw_en:1;
+}CBUS_TX_DDC_CMD_INF;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ddc_segval:8;
+unsigned int     ddc_offset:8;
+unsigned int     ddc_devaddr:8;
+}CBUS_TX_DDC_CMD_DATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ddc_wdata:8;
+}CBUS_TX_DDC_WD;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     ddc_fsm:5;
+unsigned int     reserved_1:8;
+unsigned int     ddc_rdata:8;
+}CBUS_TX_DDC_RD;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     ddc_fifo_full:1;
+unsigned int     ddc_fifo_empty:1;
+unsigned int     ddc_err_code:8;
+unsigned int     reserved_1:8;
+unsigned int     ddc_wp:4;
+unsigned int     ddc_rp:4;
+}CBUS_TX_DDC_STATUS;
+
+typedef struct 
+{
+unsigned int     ddc_err_force:1;
+unsigned int     reserved_0:23;
+unsigned int     ddc_err_fw:8;
+}CBUS_TX_DDC_WRITE_ERR_CODE;
+
+typedef struct 
+{
+unsigned int     wr_stat_irq:1;
+unsigned int     rd_devcap_irq:1;
+unsigned int     get_stat_irq:1;
+unsigned int     get_id_irq:1;
+unsigned int     get_msg_irq:1;
+unsigned int     sc1_err_irq:1;
+unsigned int     ddc_err_irq:1;
+unsigned int     msc_err_irq:1;
+unsigned int     wr_burst_irq:1;
+unsigned int     sc3_err_irq:1;
+unsigned int     fwdef_cmd_irq:1;
+unsigned int     allmsc_cmd_irq:1;
+unsigned int     abort_res_irq:1;
+unsigned int     abort_req_irq:1;
+unsigned int     ddc_abort_irq:1;
+unsigned int     ddc_nack_irq:1;
+unsigned int     msge_irq:1;
+unsigned int     rcp_irq:1;
+unsigned int     rcpk_irq:1;
+unsigned int     rcpe_irq:1;
+unsigned int     rap_irq:1;
+unsigned int     rapk_irq:1;
+unsigned int     ucp_irq:1;
+unsigned int     ucpe_irq:1;
+unsigned int     ucpk_irq:1;
+unsigned int     msg_sub_irq:1;
+unsigned int     det_rxsense_irq:1;
+unsigned int     msc_hpd_irq:1;
+unsigned int     reserved_0:4;
+}CBUS_TX_MSC_IRQ;
+
+typedef struct 
+{
+unsigned int     wr_stat_irq_en:1;
+unsigned int     rd_devcap_irq_en:1;
+unsigned int     get_stat_irq_en:1;
+unsigned int     get_id_irq_en:1;
+unsigned int     get_msg_irq_en:1;
+unsigned int     sc1_err_irq_en:1;
+unsigned int     ddc_err_irq_en:1;
+unsigned int     msc_err_irq_en:1;
+unsigned int     wr_burst_irq_en:1;
+unsigned int     sc3_err_irq_en:1;
+unsigned int     fwdef_cmd_irq_en:1;
+unsigned int     allmsc_cmd_irq_en:1;
+unsigned int     abort_res_irq_en:1;
+unsigned int     abort_req_irq_en:1;
+unsigned int     ddc_abort_irq_en:1;
+unsigned int     ddc_nack_irq_en:1;
+unsigned int     msge_irq_en:1;
+unsigned int     rcp_irq_en:1;
+unsigned int     rcpk_irq_en:1;
+unsigned int     rcpe_irq_en:1;
+unsigned int     rap_irq_en:1;
+unsigned int     rapk_irq_en:1;
+unsigned int     ucp_irq_en:1;
+unsigned int     ucpe_irq_en:1;
+unsigned int     ucpk_irq_en:1;
+unsigned int     msg_sub_irq_en:1;
+unsigned int     det_rxsense_irq_en:1;
+unsigned int     msc_hpd_irq_en:1;
+unsigned int     reserved_0:4;
+}CBUS_TX_MSC_IRQ_EN;
+
+typedef struct 
+{
+unsigned int     fw0_fin_irq_en:1;
+unsigned int     fw0_cmd_irq_en:1;
+unsigned int     fw0_data_irq_en:1;
+unsigned int     reserved_0:5;
+unsigned int     ddc_fin_irq_en:1;
+unsigned int     reserved_1:7;
+unsigned int     clk_mode_irq_en:1;
+unsigned int     dcap_rdy_irq_en:1;
+unsigned int     muted_chg_irq_en:1;
+unsigned int     path_en_irq_en:1;
+unsigned int     det_z1k_irq_en:1;
+unsigned int     sink_det_irq_en:1;
+unsigned int     parity_err_irq_en:1;
+unsigned int     disconn_irq_en:1;
+unsigned int     det_hpd_irq_en:1;
+unsigned int     reserved_2:7;
+}CBUS_TX_CBUS_TX_INT;
+
+typedef struct 
+{
+unsigned int     fw0_fin_irq:1;
+unsigned int     fw0_cmd_irq:1;
+unsigned int     fw0_data_irq:1;
+unsigned int     reserved_0:5;
+unsigned int     ddc_fin_irq:1;
+unsigned int     reserved_1:7;
+unsigned int     clk_mode_chg:1;
+unsigned int     dcap_rdy_chg:1;
+unsigned int     muted_chg:1;
+unsigned int     path_en_chg:1;
+unsigned int     det_z1k_irq:1;
+unsigned int     sink_det_irq:1;
+unsigned int     parity_err_irq:1;
+unsigned int     disconn_irq:1;
+unsigned int     det_hpd_irq:1;
+unsigned int     reserved_2:7;
+}CBUS_TX_CBUS_TX_INT1;
+
+typedef struct 
+{
+unsigned int     chg23_irq_en:8;
+unsigned int     chg22_irq_en:8;
+unsigned int     dchg_bit7_irq_en:1;
+unsigned int     dchg_bit6_irq_en:1;
+unsigned int     dchg_bit5_irq_en:1;
+unsigned int     dchg_bit4_irq_en:1;
+unsigned int     dchg_bit3_irq_en:1;
+unsigned int     dchg_bit2_irq_en:1;
+unsigned int     edid_irq_en:1;
+unsigned int     dchg_bit0_irq_en:1;
+unsigned int     rchg_irq_en:3;
+unsigned int     req_3d_irq_en:1;
+unsigned int     grt_irq_en:1;
+unsigned int     req_irq_en:1;
+unsigned int     dscr_irq_en:1;
+unsigned int     dcap_irq_en:1;
+}CBUS_TX_DEVCAP_INT_EN;
+
+typedef struct 
+{
+unsigned int     chg27_irq_en:8;
+unsigned int     chg26_irq_en:8;
+unsigned int     chg25_irq_en:8;
+unsigned int     chg24_irq_en:8;
+}CBUS_TX_DEVCAP_INT_EN1;
+
+typedef struct 
+{
+unsigned int     cbus_test_md:2;
+unsigned int     fw_out:1;
+unsigned int     dbg_sel:3;
+unsigned int     reserved_0:26;
+}CBUS_TX_CBUS_TEST;
+
+typedef struct 
+{
+unsigned int     reg_mhl_bmos_en_tx:1;
+unsigned int     reg_mhl_hpd_det_tx:1;
+unsigned int     reg_mhl_r1k_det_tx:1;
+unsigned int     reg_r1k_vth_sel_tx:1;
+unsigned int     reg_mhl_tst_en_tx:1;
+unsigned int     reg_mhl_vsel_tx:3;
+unsigned int     reg_mhl_r10k_tx:3;
+unsigned int     reg_cbus_strc_tx:3;
+unsigned int     reg_en_bias_txrx:1;
+unsigned int     tst_sel_h_tx:2;
+unsigned int     reg_mhl_r10k_test_tx:1;
+unsigned int     reserved_0:14;
+}CBUS_TX_PHY_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     hdmi_hpd_out_tx:1;
+unsigned int     hdmi_hpd_en_tx:1;
+unsigned int     rego_mhl_hpd_det_tx:1;
+unsigned int     rego_mhl_r1k_det_tx:1;
+}CBUS_TX_PHY_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     deb_lv:3;
+unsigned int     reserved_1:4;
+unsigned int     det_r1k_cnt:4;
+unsigned int     reserved_2:6;
+unsigned int     clk_1k_div:10;
+}CBUS_TX_CBUS_CTRL9;
+
+typedef struct 
+{
+unsigned int     dummy_reg:32;
+}CBUS_TX_DUMMY_CTRL;
+
+typedef struct 
+{
+unsigned int     link_layer_st:4;
+unsigned int     reserved_0:2;
+unsigned int     hw_en_10k:1;
+unsigned int     hw_en_5k:1;
+unsigned int     reserved_1:6;
+unsigned int     det_r1k_st:2;
+unsigned int     reserved_2:4;
+unsigned int     hw_mhl_hpd_det:1;
+unsigned int     hw_mhl_r1k_det:1;
+unsigned int     hw_mhl_bmos_en:1;
+unsigned int     hw_mhl_vtl_sel:1;
+unsigned int     reserved_3:3;
+unsigned int     fw_rst_r1k_st:1;
+unsigned int     reserved_4:2;
+unsigned int     fw_r1k_det_en:1;
+unsigned int     fw_r1k_det:1;
+}CBUS_TX_CBUS_CTRL10;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     msc_offset_adr:7;
+unsigned int     devcap_rdata:8;
+unsigned int     reserved_1:7;
+unsigned int     devcap_write:1;
+unsigned int     msc_reg_data:8;
+}CBUS_TX_DEVCAP_WRITE;
+
+typedef struct 
+{
+unsigned int     adop_id_h:8;
+unsigned int     dev_cat:1;
+unsigned int     plim:2;
+unsigned int     pow:1;
+unsigned int     dev_type:4;
+unsigned int     mhl_ver:8;
+unsigned int     dev_state:8;
+}CBUS_TX_MSC_DEVCAP0;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     aud_link_md:6;
+unsigned int     aud_8ch:1;
+unsigned int     aud_2ch:1;
+unsigned int     vid_link_md:2;
+unsigned int     supp_vga:1;
+unsigned int     supp_islands:1;
+unsigned int     supp_ppixel:1;
+unsigned int     supp_yuv422:1;
+unsigned int     supp_yuv444:1;
+unsigned int     supp_rgb444:1;
+unsigned int     adop_id_l:8;
+}CBUS_TX_MSC_DEVCAP1;
+
+typedef struct 
+{
+unsigned int     device_id_h:8;
+unsigned int     feature_flag:3;
+unsigned int     ucp_recv_supp:1;
+unsigned int     ucp_send_supp:1;
+unsigned int     sp_supp:1;
+unsigned int     rap_supp:1;
+unsigned int     rcp_supp:1;
+unsigned int     reserved_0:8;
+unsigned int     ld_gui:1;
+unsigned int     ld_speaker:1;
+unsigned int     ld_record:1;
+unsigned int     ld_tuner:1;
+unsigned int     ld_media:1;
+unsigned int     ld_audio:1;
+unsigned int     ld_video:1;
+unsigned int     ld_display:1;
+}CBUS_TX_MSC_DEVCAP2;
+
+typedef struct 
+{
+unsigned int     cap_0f:8;
+unsigned int     stat_size:4;
+unsigned int     int_size:4;
+unsigned int     scratchpad_size:8;
+unsigned int     device_id_l:8;
+}CBUS_TX_MSC_DEVCAP3;
+
+typedef struct 
+{
+unsigned int     chg23_irq:8;
+unsigned int     chg22_irq:8;
+unsigned int     dchg_irq:6;
+unsigned int     edid_chg:1;
+unsigned int     dchg_irq_0:1;
+unsigned int     rchg_irq:3;
+unsigned int     3d_req:1;
+unsigned int     grt_wrt:1;
+unsigned int     req_wrt:1;
+unsigned int     dscr_chg:1;
+unsigned int     dcap_chg:1;
+}CBUS_TX_MSC_DEVCAP4;
+
+typedef struct 
+{
+unsigned int     chg27_irq:8;
+unsigned int     chg26_irq:8;
+unsigned int     chg25_irq:8;
+unsigned int     chg24_irq:8;
+}CBUS_TX_MSC_DEVCAP5;
+
+typedef struct 
+{
+unsigned int     reserved_0:32;
+}CBUS_TX_MSC_DEVCAP6;
+
+typedef struct 
+{
+unsigned int     reserved_0:32;
+}CBUS_TX_MSC_DEVCAP7;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     reserved_1:8;
+unsigned int     reserved_2:3;
+unsigned int     muted:1;
+unsigned int     path_en:1;
+unsigned int     clk_mode:3;
+unsigned int     reserved_3:7;
+unsigned int     dcap_rdy:1;
+}CBUS_TX_MSC_DEVCAP8;
+
+typedef struct 
+{
+unsigned int     reserved_0:32;
+}CBUS_TX_MSC_DEVCAP9;
+
+typedef struct 
+{
+unsigned int     reserved_0:32;
+}CBUS_TX_MSC_DEVCAP10;
+
+typedef struct 
+{
+unsigned int     reserved_0:32;
+}CBUS_TX_MSC_DEVCAP11;
+
+typedef struct 
+{
+unsigned int     scratchpad_reg0:32;
+}CBUS_TX_MSC_DEVCAP12;
+
+typedef struct 
+{
+unsigned int     scratchpad_reg1:32;
+}CBUS_TX_MSC_DEVCAP13;
+
+typedef struct 
+{
+unsigned int     scratchpad_reg2:32;
+}CBUS_TX_MSC_DEVCAP14;
+
+typedef struct 
+{
+unsigned int     scratchpad_reg3:32;
+}CBUS_TX_MSC_DEVCAP15;
+
+typedef struct 
+{
+unsigned int     scratchpad_reg4:32;
+}CBUS_TX_MSC_DEVCAP16;
+
+typedef struct 
+{
+unsigned int     scratchpad_reg5:32;
+}CBUS_TX_MSC_DEVCAP17;
+
+typedef struct 
+{
+unsigned int     scratchpad_reg6:32;
+}CBUS_TX_MSC_DEVCAP18;
+
+typedef struct 
+{
+unsigned int     scratchpad_reg7:32;
+}CBUS_TX_MSC_DEVCAP19;
+
+#endif
+
+#define CBUS_TX_CBUS_CTRL0                                                           0x18037000
+#define CBUS_TX_CBUS_CTRL0_reg_addr                                                  "0xB8037000"
+#define CBUS_TX_CBUS_CTRL0_reg                                                       0xB8037000
+#define set_CBUS_TX_CBUS_CTRL0_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL0_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL0_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL0_reg))
+#define CBUS_TX_CBUS_CTRL0_inst_adr                                                  "0x0000"
+#define CBUS_TX_CBUS_CTRL0_inst                                                      0x0000
+#define CBUS_TX_CBUS_CTRL0_sys_clk_div_shift                                         (28)
+#define CBUS_TX_CBUS_CTRL0_sys_clk_div_mask                                          (0x70000000)
+#define CBUS_TX_CBUS_CTRL0_sys_clk_div(data)                                         (0x70000000&((data)<<28))
+#define CBUS_TX_CBUS_CTRL0_sys_clk_div_src(data)                                     ((0x70000000&(data))>>28)
+#define CBUS_TX_CBUS_CTRL0_get_sys_clk_div(data)                                     ((0x70000000&(data))>>28)
+#define CBUS_TX_CBUS_CTRL0_clk_1m_div_shift                                          (20)
+#define CBUS_TX_CBUS_CTRL0_clk_1m_div_mask                                           (0x0FF00000)
+#define CBUS_TX_CBUS_CTRL0_clk_1m_div(data)                                          (0x0FF00000&((data)<<20))
+#define CBUS_TX_CBUS_CTRL0_clk_1m_div_src(data)                                      ((0x0FF00000&(data))>>20)
+#define CBUS_TX_CBUS_CTRL0_get_clk_1m_div(data)                                      ((0x0FF00000&(data))>>20)
+#define CBUS_TX_CBUS_CTRL0_abs_thres_en_shift                                        (19)
+#define CBUS_TX_CBUS_CTRL0_abs_thres_en_mask                                         (0x00080000)
+#define CBUS_TX_CBUS_CTRL0_abs_thres_en(data)                                        (0x00080000&((data)<<19))
+#define CBUS_TX_CBUS_CTRL0_abs_thres_en_src(data)                                    ((0x00080000&(data))>>19)
+#define CBUS_TX_CBUS_CTRL0_get_abs_thres_en(data)                                    ((0x00080000&(data))>>19)
+#define CBUS_TX_CBUS_CTRL0_sync0_hb_shift                                            (9)
+#define CBUS_TX_CBUS_CTRL0_sync0_hb_mask                                             (0x0003FE00)
+#define CBUS_TX_CBUS_CTRL0_sync0_hb(data)                                            (0x0003FE00&((data)<<9))
+#define CBUS_TX_CBUS_CTRL0_sync0_hb_src(data)                                        ((0x0003FE00&(data))>>9)
+#define CBUS_TX_CBUS_CTRL0_get_sync0_hb(data)                                        ((0x0003FE00&(data))>>9)
+#define CBUS_TX_CBUS_CTRL0_sync0_lb_shift                                            (0)
+#define CBUS_TX_CBUS_CTRL0_sync0_lb_mask                                             (0x000001FF)
+#define CBUS_TX_CBUS_CTRL0_sync0_lb(data)                                            (0x000001FF&((data)<<0))
+#define CBUS_TX_CBUS_CTRL0_sync0_lb_src(data)                                        ((0x000001FF&(data))>>0)
+#define CBUS_TX_CBUS_CTRL0_get_sync0_lb(data)                                        ((0x000001FF&(data))>>0)
+
+
+#define CBUS_TX_CBUS_CTRL1                                                           0x18037004
+#define CBUS_TX_CBUS_CTRL1_reg_addr                                                  "0xB8037004"
+#define CBUS_TX_CBUS_CTRL1_reg                                                       0xB8037004
+#define set_CBUS_TX_CBUS_CTRL1_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL1_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL1_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL1_reg))
+#define CBUS_TX_CBUS_CTRL1_inst_adr                                                  "0x0001"
+#define CBUS_TX_CBUS_CTRL1_inst                                                      0x0001
+#define CBUS_TX_CBUS_CTRL1_parity_time_shift                                         (24)
+#define CBUS_TX_CBUS_CTRL1_parity_time_mask                                          (0xFF000000)
+#define CBUS_TX_CBUS_CTRL1_parity_time(data)                                         (0xFF000000&((data)<<24))
+#define CBUS_TX_CBUS_CTRL1_parity_time_src(data)                                     ((0xFF000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL1_get_parity_time(data)                                     ((0xFF000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL1_abs_threshold_shift                                       (16)
+#define CBUS_TX_CBUS_CTRL1_abs_threshold_mask                                        (0x00FF0000)
+#define CBUS_TX_CBUS_CTRL1_abs_threshold(data)                                       (0x00FF0000&((data)<<16))
+#define CBUS_TX_CBUS_CTRL1_abs_threshold_src(data)                                   ((0x00FF0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL1_get_abs_threshold(data)                                   ((0x00FF0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL1_sync1_hb_shift                                            (8)
+#define CBUS_TX_CBUS_CTRL1_sync1_hb_mask                                             (0x0000FF00)
+#define CBUS_TX_CBUS_CTRL1_sync1_hb(data)                                            (0x0000FF00&((data)<<8))
+#define CBUS_TX_CBUS_CTRL1_sync1_hb_src(data)                                        ((0x0000FF00&(data))>>8)
+#define CBUS_TX_CBUS_CTRL1_get_sync1_hb(data)                                        ((0x0000FF00&(data))>>8)
+#define CBUS_TX_CBUS_CTRL1_sync1_lb_shift                                            (0)
+#define CBUS_TX_CBUS_CTRL1_sync1_lb_mask                                             (0x000000FF)
+#define CBUS_TX_CBUS_CTRL1_sync1_lb(data)                                            (0x000000FF&((data)<<0))
+#define CBUS_TX_CBUS_CTRL1_sync1_lb_src(data)                                        ((0x000000FF&(data))>>0)
+#define CBUS_TX_CBUS_CTRL1_get_sync1_lb(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_CBUS_CTRL2                                                           0x18037008
+#define CBUS_TX_CBUS_CTRL2_reg_addr                                                  "0xB8037008"
+#define CBUS_TX_CBUS_CTRL2_reg                                                       0xB8037008
+#define set_CBUS_TX_CBUS_CTRL2_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL2_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL2_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL2_reg))
+#define CBUS_TX_CBUS_CTRL2_inst_adr                                                  "0x0002"
+#define CBUS_TX_CBUS_CTRL2_inst                                                      0x0002
+#define CBUS_TX_CBUS_CTRL2_vendor_id_shift                                           (24)
+#define CBUS_TX_CBUS_CTRL2_vendor_id_mask                                            (0xFF000000)
+#define CBUS_TX_CBUS_CTRL2_vendor_id(data)                                           (0xFF000000&((data)<<24))
+#define CBUS_TX_CBUS_CTRL2_vendor_id_src(data)                                       ((0xFF000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL2_get_vendor_id(data)                                       ((0xFF000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL2_ack_0_shift                                               (16)
+#define CBUS_TX_CBUS_CTRL2_ack_0_mask                                                (0x007F0000)
+#define CBUS_TX_CBUS_CTRL2_ack_0(data)                                               (0x007F0000&((data)<<16))
+#define CBUS_TX_CBUS_CTRL2_ack_0_src(data)                                           ((0x007F0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL2_get_ack_0(data)                                           ((0x007F0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL2_ack_fall_shift                                            (8)
+#define CBUS_TX_CBUS_CTRL2_ack_fall_mask                                             (0x00007F00)
+#define CBUS_TX_CBUS_CTRL2_ack_fall(data)                                            (0x00007F00&((data)<<8))
+#define CBUS_TX_CBUS_CTRL2_ack_fall_src(data)                                        ((0x00007F00&(data))>>8)
+#define CBUS_TX_CBUS_CTRL2_get_ack_fall(data)                                        ((0x00007F00&(data))>>8)
+#define CBUS_TX_CBUS_CTRL2_parity_limit_shift                                        (0)
+#define CBUS_TX_CBUS_CTRL2_parity_limit_mask                                         (0x0000001F)
+#define CBUS_TX_CBUS_CTRL2_parity_limit(data)                                        (0x0000001F&((data)<<0))
+#define CBUS_TX_CBUS_CTRL2_parity_limit_src(data)                                    ((0x0000001F&(data))>>0)
+#define CBUS_TX_CBUS_CTRL2_get_parity_limit(data)                                    ((0x0000001F&(data))>>0)
+
+
+#define CBUS_TX_CBUS_CTRL3                                                           0x1803700C
+#define CBUS_TX_CBUS_CTRL3_reg_addr                                                  "0xB803700C"
+#define CBUS_TX_CBUS_CTRL3_reg                                                       0xB803700C
+#define set_CBUS_TX_CBUS_CTRL3_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL3_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL3_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL3_reg))
+#define CBUS_TX_CBUS_CTRL3_inst_adr                                                  "0x0003"
+#define CBUS_TX_CBUS_CTRL3_inst                                                      0x0003
+#define CBUS_TX_CBUS_CTRL3_tx_bit_time_shift                                         (24)
+#define CBUS_TX_CBUS_CTRL3_tx_bit_time_mask                                          (0xFF000000)
+#define CBUS_TX_CBUS_CTRL3_tx_bit_time(data)                                         (0xFF000000&((data)<<24))
+#define CBUS_TX_CBUS_CTRL3_tx_bit_time_src(data)                                     ((0xFF000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL3_get_tx_bit_time(data)                                     ((0xFF000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL3_tx_ack_fal_shift                                          (16)
+#define CBUS_TX_CBUS_CTRL3_tx_ack_fal_mask                                           (0x007F0000)
+#define CBUS_TX_CBUS_CTRL3_tx_ack_fal(data)                                          (0x007F0000&((data)<<16))
+#define CBUS_TX_CBUS_CTRL3_tx_ack_fal_src(data)                                      ((0x007F0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL3_get_tx_ack_fal(data)                                      ((0x007F0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL3_tx_ack_low_hb_shift                                       (8)
+#define CBUS_TX_CBUS_CTRL3_tx_ack_low_hb_mask                                        (0x00007F00)
+#define CBUS_TX_CBUS_CTRL3_tx_ack_low_hb(data)                                       (0x00007F00&((data)<<8))
+#define CBUS_TX_CBUS_CTRL3_tx_ack_low_hb_src(data)                                   ((0x00007F00&(data))>>8)
+#define CBUS_TX_CBUS_CTRL3_get_tx_ack_low_hb(data)                                   ((0x00007F00&(data))>>8)
+#define CBUS_TX_CBUS_CTRL3_tx_ack_low_lb_shift                                       (0)
+#define CBUS_TX_CBUS_CTRL3_tx_ack_low_lb_mask                                        (0x0000007F)
+#define CBUS_TX_CBUS_CTRL3_tx_ack_low_lb(data)                                       (0x0000007F&((data)<<0))
+#define CBUS_TX_CBUS_CTRL3_tx_ack_low_lb_src(data)                                   ((0x0000007F&(data))>>0)
+#define CBUS_TX_CBUS_CTRL3_get_tx_ack_low_lb(data)                                   ((0x0000007F&(data))>>0)
+
+
+#define CBUS_TX_CBUS_CTRL4                                                           0x18037010
+#define CBUS_TX_CBUS_CTRL4_reg_addr                                                  "0xB8037010"
+#define CBUS_TX_CBUS_CTRL4_reg                                                       0xB8037010
+#define set_CBUS_TX_CBUS_CTRL4_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL4_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL4_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL4_reg))
+#define CBUS_TX_CBUS_CTRL4_inst_adr                                                  "0x0004"
+#define CBUS_TX_CBUS_CTRL4_inst                                                      0x0004
+#define CBUS_TX_CBUS_CTRL4_glob_time_shift                                           (29)
+#define CBUS_TX_CBUS_CTRL4_glob_time_mask                                            (0x60000000)
+#define CBUS_TX_CBUS_CTRL4_glob_time(data)                                           (0x60000000&((data)<<29))
+#define CBUS_TX_CBUS_CTRL4_glob_time_src(data)                                       ((0x60000000&(data))>>29)
+#define CBUS_TX_CBUS_CTRL4_get_glob_time(data)                                       ((0x60000000&(data))>>29)
+#define CBUS_TX_CBUS_CTRL4_link_time_shift                                           (24)
+#define CBUS_TX_CBUS_CTRL4_link_time_mask                                            (0x1F000000)
+#define CBUS_TX_CBUS_CTRL4_link_time(data)                                           (0x1F000000&((data)<<24))
+#define CBUS_TX_CBUS_CTRL4_link_time_src(data)                                       ((0x1F000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL4_get_link_time(data)                                       ((0x1F000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL4_req_hold_shift                                            (20)
+#define CBUS_TX_CBUS_CTRL4_req_hold_mask                                             (0x00F00000)
+#define CBUS_TX_CBUS_CTRL4_req_hold(data)                                            (0x00F00000&((data)<<20))
+#define CBUS_TX_CBUS_CTRL4_req_hold_src(data)                                        ((0x00F00000&(data))>>20)
+#define CBUS_TX_CBUS_CTRL4_get_req_hold(data)                                        ((0x00F00000&(data))>>20)
+#define CBUS_TX_CBUS_CTRL4_resp_hold_shift                                           (16)
+#define CBUS_TX_CBUS_CTRL4_resp_hold_mask                                            (0x000F0000)
+#define CBUS_TX_CBUS_CTRL4_resp_hold(data)                                           (0x000F0000&((data)<<16))
+#define CBUS_TX_CBUS_CTRL4_resp_hold_src(data)                                       ((0x000F0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL4_get_resp_hold(data)                                       ((0x000F0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL4_wait_time_shift                                           (12)
+#define CBUS_TX_CBUS_CTRL4_wait_time_mask                                            (0x0000F000)
+#define CBUS_TX_CBUS_CTRL4_wait_time(data)                                           (0x0000F000&((data)<<12))
+#define CBUS_TX_CBUS_CTRL4_wait_time_src(data)                                       ((0x0000F000&(data))>>12)
+#define CBUS_TX_CBUS_CTRL4_get_wait_time(data)                                       ((0x0000F000&(data))>>12)
+#define CBUS_TX_CBUS_CTRL4_fast_reply_en_shift                                       (11)
+#define CBUS_TX_CBUS_CTRL4_fast_reply_en_mask                                        (0x00000800)
+#define CBUS_TX_CBUS_CTRL4_fast_reply_en(data)                                       (0x00000800&((data)<<11))
+#define CBUS_TX_CBUS_CTRL4_fast_reply_en_src(data)                                   ((0x00000800&(data))>>11)
+#define CBUS_TX_CBUS_CTRL4_get_fast_reply_en(data)                                   ((0x00000800&(data))>>11)
+#define CBUS_TX_CBUS_CTRL4_drv_str_shift                                             (9)
+#define CBUS_TX_CBUS_CTRL4_drv_str_mask                                              (0x00000600)
+#define CBUS_TX_CBUS_CTRL4_drv_str(data)                                             (0x00000600&((data)<<9))
+#define CBUS_TX_CBUS_CTRL4_drv_str_src(data)                                         ((0x00000600&(data))>>9)
+#define CBUS_TX_CBUS_CTRL4_get_drv_str(data)                                         ((0x00000600&(data))>>9)
+#define CBUS_TX_CBUS_CTRL4_drv_hi_cbus_shift                                         (3)
+#define CBUS_TX_CBUS_CTRL4_drv_hi_cbus_mask                                          (0x000001F8)
+#define CBUS_TX_CBUS_CTRL4_drv_hi_cbus(data)                                         (0x000001F8&((data)<<3))
+#define CBUS_TX_CBUS_CTRL4_drv_hi_cbus_src(data)                                     ((0x000001F8&(data))>>3)
+#define CBUS_TX_CBUS_CTRL4_get_drv_hi_cbus(data)                                     ((0x000001F8&(data))>>3)
+#define CBUS_TX_CBUS_CTRL4_retry_lv_shift                                            (0)
+#define CBUS_TX_CBUS_CTRL4_retry_lv_mask                                             (0x00000007)
+#define CBUS_TX_CBUS_CTRL4_retry_lv(data)                                            (0x00000007&((data)<<0))
+#define CBUS_TX_CBUS_CTRL4_retry_lv_src(data)                                        ((0x00000007&(data))>>0)
+#define CBUS_TX_CBUS_CTRL4_get_retry_lv(data)                                        ((0x00000007&(data))>>0)
+
+
+#define CBUS_TX_CBUS_CTRL5                                                           0x18037014
+#define CBUS_TX_CBUS_CTRL5_reg_addr                                                  "0xB8037014"
+#define CBUS_TX_CBUS_CTRL5_reg                                                       0xB8037014
+#define set_CBUS_TX_CBUS_CTRL5_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL5_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL5_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL5_reg))
+#define CBUS_TX_CBUS_CTRL5_inst_adr                                                  "0x0005"
+#define CBUS_TX_CBUS_CTRL5_inst                                                      0x0005
+#define CBUS_TX_CBUS_CTRL5_burst_wait_shift                                          (28)
+#define CBUS_TX_CBUS_CTRL5_burst_wait_mask                                           (0xF0000000)
+#define CBUS_TX_CBUS_CTRL5_burst_wait(data)                                          (0xF0000000&((data)<<28))
+#define CBUS_TX_CBUS_CTRL5_burst_wait_src(data)                                      ((0xF0000000&(data))>>28)
+#define CBUS_TX_CBUS_CTRL5_get_burst_wait(data)                                      ((0xF0000000&(data))>>28)
+#define CBUS_TX_CBUS_CTRL5_fw_rxsense_en_shift                                       (27)
+#define CBUS_TX_CBUS_CTRL5_fw_rxsense_en_mask                                        (0x08000000)
+#define CBUS_TX_CBUS_CTRL5_fw_rxsense_en(data)                                       (0x08000000&((data)<<27))
+#define CBUS_TX_CBUS_CTRL5_fw_rxsense_en_src(data)                                   ((0x08000000&(data))>>27)
+#define CBUS_TX_CBUS_CTRL5_get_fw_rxsense_en(data)                                   ((0x08000000&(data))>>27)
+#define CBUS_TX_CBUS_CTRL5_mhl_conn_shift                                            (26)
+#define CBUS_TX_CBUS_CTRL5_mhl_conn_mask                                             (0x04000000)
+#define CBUS_TX_CBUS_CTRL5_mhl_conn(data)                                            (0x04000000&((data)<<26))
+#define CBUS_TX_CBUS_CTRL5_mhl_conn_src(data)                                        ((0x04000000&(data))>>26)
+#define CBUS_TX_CBUS_CTRL5_get_mhl_conn(data)                                        ((0x04000000&(data))>>26)
+#define CBUS_TX_CBUS_CTRL5_fw_path_en_shift                                          (25)
+#define CBUS_TX_CBUS_CTRL5_fw_path_en_mask                                           (0x02000000)
+#define CBUS_TX_CBUS_CTRL5_fw_path_en(data)                                          (0x02000000&((data)<<25))
+#define CBUS_TX_CBUS_CTRL5_fw_path_en_src(data)                                      ((0x02000000&(data))>>25)
+#define CBUS_TX_CBUS_CTRL5_get_fw_path_en(data)                                      ((0x02000000&(data))>>25)
+#define CBUS_TX_CBUS_CTRL5_send_path_shift                                           (24)
+#define CBUS_TX_CBUS_CTRL5_send_path_mask                                            (0x01000000)
+#define CBUS_TX_CBUS_CTRL5_send_path(data)                                           (0x01000000&((data)<<24))
+#define CBUS_TX_CBUS_CTRL5_send_path_src(data)                                       ((0x01000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL5_get_send_path(data)                                       ((0x01000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL5_req_opp_flt_shift                                         (16)
+#define CBUS_TX_CBUS_CTRL5_req_opp_flt_mask                                          (0x00FF0000)
+#define CBUS_TX_CBUS_CTRL5_req_opp_flt(data)                                         (0x00FF0000&((data)<<16))
+#define CBUS_TX_CBUS_CTRL5_req_opp_flt_src(data)                                     ((0x00FF0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL5_get_req_opp_flt(data)                                     ((0x00FF0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL5_req_opp_int_shift                                         (14)
+#define CBUS_TX_CBUS_CTRL5_req_opp_int_mask                                          (0x0000C000)
+#define CBUS_TX_CBUS_CTRL5_req_opp_int(data)                                         (0x0000C000&((data)<<14))
+#define CBUS_TX_CBUS_CTRL5_req_opp_int_src(data)                                     ((0x0000C000&(data))>>14)
+#define CBUS_TX_CBUS_CTRL5_get_req_opp_int(data)                                     ((0x0000C000&(data))>>14)
+#define CBUS_TX_CBUS_CTRL5_chk_point_shift                                           (8)
+#define CBUS_TX_CBUS_CTRL5_chk_point_mask                                            (0x00003F00)
+#define CBUS_TX_CBUS_CTRL5_chk_point(data)                                           (0x00003F00&((data)<<8))
+#define CBUS_TX_CBUS_CTRL5_chk_point_src(data)                                       ((0x00003F00&(data))>>8)
+#define CBUS_TX_CBUS_CTRL5_get_chk_point(data)                                       ((0x00003F00&(data))>>8)
+#define CBUS_TX_CBUS_CTRL5_avoid_conf_shift                                          (4)
+#define CBUS_TX_CBUS_CTRL5_avoid_conf_mask                                           (0x00000010)
+#define CBUS_TX_CBUS_CTRL5_avoid_conf(data)                                          (0x00000010&((data)<<4))
+#define CBUS_TX_CBUS_CTRL5_avoid_conf_src(data)                                      ((0x00000010&(data))>>4)
+#define CBUS_TX_CBUS_CTRL5_get_avoid_conf(data)                                      ((0x00000010&(data))>>4)
+#define CBUS_TX_CBUS_CTRL5_cbus_imp_fw_en_shift                                      (2)
+#define CBUS_TX_CBUS_CTRL5_cbus_imp_fw_en_mask                                       (0x00000004)
+#define CBUS_TX_CBUS_CTRL5_cbus_imp_fw_en(data)                                      (0x00000004&((data)<<2))
+#define CBUS_TX_CBUS_CTRL5_cbus_imp_fw_en_src(data)                                  ((0x00000004&(data))>>2)
+#define CBUS_TX_CBUS_CTRL5_get_cbus_imp_fw_en(data)                                  ((0x00000004&(data))>>2)
+#define CBUS_TX_CBUS_CTRL5_z_5k_on_shift                                             (1)
+#define CBUS_TX_CBUS_CTRL5_z_5k_on_mask                                              (0x00000002)
+#define CBUS_TX_CBUS_CTRL5_z_5k_on(data)                                             (0x00000002&((data)<<1))
+#define CBUS_TX_CBUS_CTRL5_z_5k_on_src(data)                                         ((0x00000002&(data))>>1)
+#define CBUS_TX_CBUS_CTRL5_get_z_5k_on(data)                                         ((0x00000002&(data))>>1)
+#define CBUS_TX_CBUS_CTRL5_z_10k_on_shift                                            (0)
+#define CBUS_TX_CBUS_CTRL5_z_10k_on_mask                                             (0x00000001)
+#define CBUS_TX_CBUS_CTRL5_z_10k_on(data)                                            (0x00000001&((data)<<0))
+#define CBUS_TX_CBUS_CTRL5_z_10k_on_src(data)                                        ((0x00000001&(data))>>0)
+#define CBUS_TX_CBUS_CTRL5_get_z_10k_on(data)                                        ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_CBUS_CTRL6                                                           0x18037018
+#define CBUS_TX_CBUS_CTRL6_reg_addr                                                  "0xB8037018"
+#define CBUS_TX_CBUS_CTRL6_reg                                                       0xB8037018
+#define set_CBUS_TX_CBUS_CTRL6_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL6_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL6_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL6_reg))
+#define CBUS_TX_CBUS_CTRL6_inst_adr                                                  "0x0006"
+#define CBUS_TX_CBUS_CTRL6_inst                                                      0x0006
+#define CBUS_TX_CBUS_CTRL6_wake_pulse_width1_shift                                   (30)
+#define CBUS_TX_CBUS_CTRL6_wake_pulse_width1_mask                                    (0xC0000000)
+#define CBUS_TX_CBUS_CTRL6_wake_pulse_width1(data)                                   (0xC0000000&((data)<<30))
+#define CBUS_TX_CBUS_CTRL6_wake_pulse_width1_src(data)                               ((0xC0000000&(data))>>30)
+#define CBUS_TX_CBUS_CTRL6_get_wake_pulse_width1(data)                               ((0xC0000000&(data))>>30)
+#define CBUS_TX_CBUS_CTRL6_dis_chk_high_shift                                        (27)
+#define CBUS_TX_CBUS_CTRL6_dis_chk_high_mask                                         (0x38000000)
+#define CBUS_TX_CBUS_CTRL6_dis_chk_high(data)                                        (0x38000000&((data)<<27))
+#define CBUS_TX_CBUS_CTRL6_dis_chk_high_src(data)                                    ((0x38000000&(data))>>27)
+#define CBUS_TX_CBUS_CTRL6_get_dis_chk_high(data)                                    ((0x38000000&(data))>>27)
+#define CBUS_TX_CBUS_CTRL6_wake_pulse_width2_shift                                   (22)
+#define CBUS_TX_CBUS_CTRL6_wake_pulse_width2_mask                                    (0x03C00000)
+#define CBUS_TX_CBUS_CTRL6_wake_pulse_width2(data)                                   (0x03C00000&((data)<<22))
+#define CBUS_TX_CBUS_CTRL6_wake_pulse_width2_src(data)                               ((0x03C00000&(data))>>22)
+#define CBUS_TX_CBUS_CTRL6_get_wake_pulse_width2(data)                               ((0x03C00000&(data))>>22)
+#define CBUS_TX_CBUS_CTRL6_src_cbus_float_shift                                      (18)
+#define CBUS_TX_CBUS_CTRL6_src_cbus_float_mask                                       (0x003C0000)
+#define CBUS_TX_CBUS_CTRL6_src_cbus_float(data)                                      (0x003C0000&((data)<<18))
+#define CBUS_TX_CBUS_CTRL6_src_cbus_float_src(data)                                  ((0x003C0000&(data))>>18)
+#define CBUS_TX_CBUS_CTRL6_get_src_cbus_float(data)                                  ((0x003C0000&(data))>>18)
+#define CBUS_TX_CBUS_CTRL6_src_pulse_width_shift                                     (11)
+#define CBUS_TX_CBUS_CTRL6_src_pulse_width_mask                                      (0x0003F800)
+#define CBUS_TX_CBUS_CTRL6_src_pulse_width(data)                                     (0x0003F800&((data)<<11))
+#define CBUS_TX_CBUS_CTRL6_src_pulse_width_src(data)                                 ((0x0003F800&(data))>>11)
+#define CBUS_TX_CBUS_CTRL6_get_src_pulse_width(data)                                 ((0x0003F800&(data))>>11)
+#define CBUS_TX_CBUS_CTRL6_src_conn_shift                                            (9)
+#define CBUS_TX_CBUS_CTRL6_src_conn_mask                                             (0x00000600)
+#define CBUS_TX_CBUS_CTRL6_src_conn(data)                                            (0x00000600&((data)<<9))
+#define CBUS_TX_CBUS_CTRL6_src_conn_src(data)                                        ((0x00000600&(data))>>9)
+#define CBUS_TX_CBUS_CTRL6_get_src_conn(data)                                        ((0x00000600&(data))>>9)
+#define CBUS_TX_CBUS_CTRL6_rxsense_deglitch_shift                                    (0)
+#define CBUS_TX_CBUS_CTRL6_rxsense_deglitch_mask                                     (0x000001FF)
+#define CBUS_TX_CBUS_CTRL6_rxsense_deglitch(data)                                    (0x000001FF&((data)<<0))
+#define CBUS_TX_CBUS_CTRL6_rxsense_deglitch_src(data)                                ((0x000001FF&(data))>>0)
+#define CBUS_TX_CBUS_CTRL6_get_rxsense_deglitch(data)                                ((0x000001FF&(data))>>0)
+
+
+#define CBUS_TX_CBUS_CTRL7                                                           0x1803701C
+#define CBUS_TX_CBUS_CTRL7_reg_addr                                                  "0xB803701C"
+#define CBUS_TX_CBUS_CTRL7_reg                                                       0xB803701C
+#define set_CBUS_TX_CBUS_CTRL7_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL7_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL7_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL7_reg))
+#define CBUS_TX_CBUS_CTRL7_inst_adr                                                  "0x0007"
+#define CBUS_TX_CBUS_CTRL7_inst                                                      0x0007
+#define CBUS_TX_CBUS_CTRL7_wake_to_discover_shift                                    (20)
+#define CBUS_TX_CBUS_CTRL7_wake_to_discover_mask                                     (0x3FF00000)
+#define CBUS_TX_CBUS_CTRL7_wake_to_discover(data)                                    (0x3FF00000&((data)<<20))
+#define CBUS_TX_CBUS_CTRL7_wake_to_discover_src(data)                                ((0x3FF00000&(data))>>20)
+#define CBUS_TX_CBUS_CTRL7_get_wake_to_discover(data)                                ((0x3FF00000&(data))>>20)
+#define CBUS_TX_CBUS_CTRL7_src_vbus_cbus_stable_shift                                (10)
+#define CBUS_TX_CBUS_CTRL7_src_vbus_cbus_stable_mask                                 (0x000FFC00)
+#define CBUS_TX_CBUS_CTRL7_src_vbus_cbus_stable(data)                                (0x000FFC00&((data)<<10))
+#define CBUS_TX_CBUS_CTRL7_src_vbus_cbus_stable_src(data)                            ((0x000FFC00&(data))>>10)
+#define CBUS_TX_CBUS_CTRL7_get_src_vbus_cbus_stable(data)                            ((0x000FFC00&(data))>>10)
+#define CBUS_TX_CBUS_CTRL7_vbus_out_to_stable_shift                                  (0)
+#define CBUS_TX_CBUS_CTRL7_vbus_out_to_stable_mask                                   (0x000003FF)
+#define CBUS_TX_CBUS_CTRL7_vbus_out_to_stable(data)                                  (0x000003FF&((data)<<0))
+#define CBUS_TX_CBUS_CTRL7_vbus_out_to_stable_src(data)                              ((0x000003FF&(data))>>0)
+#define CBUS_TX_CBUS_CTRL7_get_vbus_out_to_stable(data)                              ((0x000003FF&(data))>>0)
+
+
+#define CBUS_TX_CBUS_CTRL8                                                           0x18037020
+#define CBUS_TX_CBUS_CTRL8_reg_addr                                                  "0xB8037020"
+#define CBUS_TX_CBUS_CTRL8_reg                                                       0xB8037020
+#define set_CBUS_TX_CBUS_CTRL8_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL8_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL8_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL8_reg))
+#define CBUS_TX_CBUS_CTRL8_inst_adr                                                  "0x0008"
+#define CBUS_TX_CBUS_CTRL8_inst                                                      0x0008
+#define CBUS_TX_CBUS_CTRL8_req_cont_shift                                            (24)
+#define CBUS_TX_CBUS_CTRL8_req_cont_mask                                             (0xFF000000)
+#define CBUS_TX_CBUS_CTRL8_req_cont(data)                                            (0xFF000000&((data)<<24))
+#define CBUS_TX_CBUS_CTRL8_req_cont_src(data)                                        ((0xFF000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL8_get_req_cont(data)                                        ((0xFF000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL8_src_arbitrate_shift                                       (21)
+#define CBUS_TX_CBUS_CTRL8_src_arbitrate_mask                                        (0x00E00000)
+#define CBUS_TX_CBUS_CTRL8_src_arbitrate(data)                                       (0x00E00000&((data)<<21))
+#define CBUS_TX_CBUS_CTRL8_src_arbitrate_src(data)                                   ((0x00E00000&(data))>>21)
+#define CBUS_TX_CBUS_CTRL8_get_src_arbitrate(data)                                   ((0x00E00000&(data))>>21)
+#define CBUS_TX_CBUS_CTRL8_pulse_count_shift                                         (16)
+#define CBUS_TX_CBUS_CTRL8_pulse_count_mask                                          (0x001F0000)
+#define CBUS_TX_CBUS_CTRL8_pulse_count(data)                                         (0x001F0000&((data)<<16))
+#define CBUS_TX_CBUS_CTRL8_pulse_count_src(data)                                     ((0x001F0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL8_get_pulse_count(data)                                     ((0x001F0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL8_wait_sink_float_shift                                     (15)
+#define CBUS_TX_CBUS_CTRL8_wait_sink_float_mask                                      (0x00008000)
+#define CBUS_TX_CBUS_CTRL8_wait_sink_float(data)                                     (0x00008000&((data)<<15))
+#define CBUS_TX_CBUS_CTRL8_wait_sink_float_src(data)                                 ((0x00008000&(data))>>15)
+#define CBUS_TX_CBUS_CTRL8_get_wait_sink_float(data)                                 ((0x00008000&(data))>>15)
+#define CBUS_TX_CBUS_CTRL8_sink_cbus_float_shift                                     (13)
+#define CBUS_TX_CBUS_CTRL8_sink_cbus_float_mask                                      (0x00006000)
+#define CBUS_TX_CBUS_CTRL8_sink_cbus_float(data)                                     (0x00006000&((data)<<13))
+#define CBUS_TX_CBUS_CTRL8_sink_cbus_float_src(data)                                 ((0x00006000&(data))>>13)
+#define CBUS_TX_CBUS_CTRL8_get_sink_cbus_float(data)                                 ((0x00006000&(data))>>13)
+#define CBUS_TX_CBUS_CTRL8_rxsense_chk_shift                                         (0)
+#define CBUS_TX_CBUS_CTRL8_rxsense_chk_mask                                          (0x000003FF)
+#define CBUS_TX_CBUS_CTRL8_rxsense_chk(data)                                         (0x000003FF&((data)<<0))
+#define CBUS_TX_CBUS_CTRL8_rxsense_chk_src(data)                                     ((0x000003FF&(data))>>0)
+#define CBUS_TX_CBUS_CTRL8_get_rxsense_chk(data)                                     ((0x000003FF&(data))>>0)
+
+
+#define CBUS_TX_CBUS_STATUS                                                          0x18037024
+#define CBUS_TX_CBUS_STATUS_reg_addr                                                 "0xB8037024"
+#define CBUS_TX_CBUS_STATUS_reg                                                      0xB8037024
+#define set_CBUS_TX_CBUS_STATUS_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_STATUS_reg)=data)
+#define get_CBUS_TX_CBUS_STATUS_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_STATUS_reg))
+#define CBUS_TX_CBUS_STATUS_inst_adr                                                 "0x0009"
+#define CBUS_TX_CBUS_STATUS_inst                                                     0x0009
+#define CBUS_TX_CBUS_STATUS_retry_flag_shift                                         (18)
+#define CBUS_TX_CBUS_STATUS_retry_flag_mask                                          (0x00040000)
+#define CBUS_TX_CBUS_STATUS_retry_flag(data)                                         (0x00040000&((data)<<18))
+#define CBUS_TX_CBUS_STATUS_retry_flag_src(data)                                     ((0x00040000&(data))>>18)
+#define CBUS_TX_CBUS_STATUS_get_retry_flag(data)                                     ((0x00040000&(data))>>18)
+#define CBUS_TX_CBUS_STATUS_link_err_shift                                           (17)
+#define CBUS_TX_CBUS_STATUS_link_err_mask                                            (0x00020000)
+#define CBUS_TX_CBUS_STATUS_link_err(data)                                           (0x00020000&((data)<<17))
+#define CBUS_TX_CBUS_STATUS_link_err_src(data)                                       ((0x00020000&(data))>>17)
+#define CBUS_TX_CBUS_STATUS_get_link_err(data)                                       ((0x00020000&(data))>>17)
+#define CBUS_TX_CBUS_STATUS_conflict_err_shift                                       (16)
+#define CBUS_TX_CBUS_STATUS_conflict_err_mask                                        (0x00010000)
+#define CBUS_TX_CBUS_STATUS_conflict_err(data)                                       (0x00010000&((data)<<16))
+#define CBUS_TX_CBUS_STATUS_conflict_err_src(data)                                   ((0x00010000&(data))>>16)
+#define CBUS_TX_CBUS_STATUS_get_conflict_err(data)                                   ((0x00010000&(data))>>16)
+#define CBUS_TX_CBUS_STATUS_sync_bit_time_shift                                      (8)
+#define CBUS_TX_CBUS_STATUS_sync_bit_time_mask                                       (0x0000FF00)
+#define CBUS_TX_CBUS_STATUS_sync_bit_time(data)                                      (0x0000FF00&((data)<<8))
+#define CBUS_TX_CBUS_STATUS_sync_bit_time_src(data)                                  ((0x0000FF00&(data))>>8)
+#define CBUS_TX_CBUS_STATUS_get_sync_bit_time(data)                                  ((0x0000FF00&(data))>>8)
+#define CBUS_TX_CBUS_STATUS_discovery_st_shift                                       (1)
+#define CBUS_TX_CBUS_STATUS_discovery_st_mask                                        (0x0000000E)
+#define CBUS_TX_CBUS_STATUS_discovery_st(data)                                       (0x0000000E&((data)<<1))
+#define CBUS_TX_CBUS_STATUS_discovery_st_src(data)                                   ((0x0000000E&(data))>>1)
+#define CBUS_TX_CBUS_STATUS_get_discovery_st(data)                                   ((0x0000000E&(data))>>1)
+#define CBUS_TX_CBUS_STATUS_write_data_shift                                         (0)
+#define CBUS_TX_CBUS_STATUS_write_data_mask                                          (0x00000001)
+#define CBUS_TX_CBUS_STATUS_write_data(data)                                         (0x00000001&((data)<<0))
+#define CBUS_TX_CBUS_STATUS_write_data_src(data)                                     ((0x00000001&(data))>>0)
+#define CBUS_TX_CBUS_STATUS_get_write_data(data)                                     ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_FW0_CMD_INF                                                          0x18037028
+#define CBUS_TX_FW0_CMD_INF_reg_addr                                                 "0xB8037028"
+#define CBUS_TX_FW0_CMD_INF_reg                                                      0xB8037028
+#define set_CBUS_TX_FW0_CMD_INF_reg(data)   (*((volatile unsigned int*) CBUS_TX_FW0_CMD_INF_reg)=data)
+#define get_CBUS_TX_FW0_CMD_INF_reg   (*((volatile unsigned int*) CBUS_TX_FW0_CMD_INF_reg))
+#define CBUS_TX_FW0_CMD_INF_inst_adr                                                 "0x000A"
+#define CBUS_TX_FW0_CMD_INF_inst                                                     0x000A
+#define CBUS_TX_FW0_CMD_INF_fw0_req_shift                                            (31)
+#define CBUS_TX_FW0_CMD_INF_fw0_req_mask                                             (0x80000000)
+#define CBUS_TX_FW0_CMD_INF_fw0_req(data)                                            (0x80000000&((data)<<31))
+#define CBUS_TX_FW0_CMD_INF_fw0_req_src(data)                                        ((0x80000000&(data))>>31)
+#define CBUS_TX_FW0_CMD_INF_get_fw0_req(data)                                        ((0x80000000&(data))>>31)
+#define CBUS_TX_FW0_CMD_INF_fw0_tx_case_shift                                        (28)
+#define CBUS_TX_FW0_CMD_INF_fw0_tx_case_mask                                         (0x70000000)
+#define CBUS_TX_FW0_CMD_INF_fw0_tx_case(data)                                        (0x70000000&((data)<<28))
+#define CBUS_TX_FW0_CMD_INF_fw0_tx_case_src(data)                                    ((0x70000000&(data))>>28)
+#define CBUS_TX_FW0_CMD_INF_get_fw0_tx_case(data)                                    ((0x70000000&(data))>>28)
+#define CBUS_TX_FW0_CMD_INF_fw0_wait_case_shift                                      (26)
+#define CBUS_TX_FW0_CMD_INF_fw0_wait_case_mask                                       (0x0C000000)
+#define CBUS_TX_FW0_CMD_INF_fw0_wait_case(data)                                      (0x0C000000&((data)<<26))
+#define CBUS_TX_FW0_CMD_INF_fw0_wait_case_src(data)                                  ((0x0C000000&(data))>>26)
+#define CBUS_TX_FW0_CMD_INF_get_fw0_wait_case(data)                                  ((0x0C000000&(data))>>26)
+#define CBUS_TX_FW0_CMD_INF_fw0_head_shift                                           (24)
+#define CBUS_TX_FW0_CMD_INF_fw0_head_mask                                            (0x03000000)
+#define CBUS_TX_FW0_CMD_INF_fw0_head(data)                                           (0x03000000&((data)<<24))
+#define CBUS_TX_FW0_CMD_INF_fw0_head_src(data)                                       ((0x03000000&(data))>>24)
+#define CBUS_TX_FW0_CMD_INF_get_fw0_head(data)                                       ((0x03000000&(data))>>24)
+#define CBUS_TX_FW0_CMD_INF_fw0_fifo_clr_shift                                       (23)
+#define CBUS_TX_FW0_CMD_INF_fw0_fifo_clr_mask                                        (0x00800000)
+#define CBUS_TX_FW0_CMD_INF_fw0_fifo_clr(data)                                       (0x00800000&((data)<<23))
+#define CBUS_TX_FW0_CMD_INF_fw0_fifo_clr_src(data)                                   ((0x00800000&(data))>>23)
+#define CBUS_TX_FW0_CMD_INF_get_fw0_fifo_clr(data)                                   ((0x00800000&(data))>>23)
+
+
+#define CBUS_TX_FW0_CMD                                                              0x1803702C
+#define CBUS_TX_FW0_CMD_reg_addr                                                     "0xB803702C"
+#define CBUS_TX_FW0_CMD_reg                                                          0xB803702C
+#define set_CBUS_TX_FW0_CMD_reg(data)   (*((volatile unsigned int*) CBUS_TX_FW0_CMD_reg)=data)
+#define get_CBUS_TX_FW0_CMD_reg   (*((volatile unsigned int*) CBUS_TX_FW0_CMD_reg))
+#define CBUS_TX_FW0_CMD_inst_adr                                                     "0x000B"
+#define CBUS_TX_FW0_CMD_inst                                                         0x000B
+#define CBUS_TX_FW0_CMD_fw0_cmd2_shift                                               (16)
+#define CBUS_TX_FW0_CMD_fw0_cmd2_mask                                                (0x00FF0000)
+#define CBUS_TX_FW0_CMD_fw0_cmd2(data)                                               (0x00FF0000&((data)<<16))
+#define CBUS_TX_FW0_CMD_fw0_cmd2_src(data)                                           ((0x00FF0000&(data))>>16)
+#define CBUS_TX_FW0_CMD_get_fw0_cmd2(data)                                           ((0x00FF0000&(data))>>16)
+#define CBUS_TX_FW0_CMD_fw0_offset_shift                                             (8)
+#define CBUS_TX_FW0_CMD_fw0_offset_mask                                              (0x0000FF00)
+#define CBUS_TX_FW0_CMD_fw0_offset(data)                                             (0x0000FF00&((data)<<8))
+#define CBUS_TX_FW0_CMD_fw0_offset_src(data)                                         ((0x0000FF00&(data))>>8)
+#define CBUS_TX_FW0_CMD_get_fw0_offset(data)                                         ((0x0000FF00&(data))>>8)
+#define CBUS_TX_FW0_CMD_fw0_cmd1_shift                                               (0)
+#define CBUS_TX_FW0_CMD_fw0_cmd1_mask                                                (0x000000FF)
+#define CBUS_TX_FW0_CMD_fw0_cmd1(data)                                               (0x000000FF&((data)<<0))
+#define CBUS_TX_FW0_CMD_fw0_cmd1_src(data)                                           ((0x000000FF&(data))>>0)
+#define CBUS_TX_FW0_CMD_get_fw0_cmd1(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_FW0_STATUS                                                           0x18037030
+#define CBUS_TX_FW0_STATUS_reg_addr                                                  "0xB8037030"
+#define CBUS_TX_FW0_STATUS_reg                                                       0xB8037030
+#define set_CBUS_TX_FW0_STATUS_reg(data)   (*((volatile unsigned int*) CBUS_TX_FW0_STATUS_reg)=data)
+#define get_CBUS_TX_FW0_STATUS_reg   (*((volatile unsigned int*) CBUS_TX_FW0_STATUS_reg))
+#define CBUS_TX_FW0_STATUS_inst_adr                                                  "0x000C"
+#define CBUS_TX_FW0_STATUS_inst                                                      0x000C
+#define CBUS_TX_FW0_STATUS_fw0_cmd_rcv_shift                                         (24)
+#define CBUS_TX_FW0_STATUS_fw0_cmd_rcv_mask                                          (0xFF000000)
+#define CBUS_TX_FW0_STATUS_fw0_cmd_rcv(data)                                         (0xFF000000&((data)<<24))
+#define CBUS_TX_FW0_STATUS_fw0_cmd_rcv_src(data)                                     ((0xFF000000&(data))>>24)
+#define CBUS_TX_FW0_STATUS_get_fw0_cmd_rcv(data)                                     ((0xFF000000&(data))>>24)
+#define CBUS_TX_FW0_STATUS_fw0_data_rcv_shift                                        (16)
+#define CBUS_TX_FW0_STATUS_fw0_data_rcv_mask                                         (0x00FF0000)
+#define CBUS_TX_FW0_STATUS_fw0_data_rcv(data)                                        (0x00FF0000&((data)<<16))
+#define CBUS_TX_FW0_STATUS_fw0_data_rcv_src(data)                                    ((0x00FF0000&(data))>>16)
+#define CBUS_TX_FW0_STATUS_get_fw0_data_rcv(data)                                    ((0x00FF0000&(data))>>16)
+#define CBUS_TX_FW0_STATUS_fw0_rcv_err_shift                                         (15)
+#define CBUS_TX_FW0_STATUS_fw0_rcv_err_mask                                          (0x00008000)
+#define CBUS_TX_FW0_STATUS_fw0_rcv_err(data)                                         (0x00008000&((data)<<15))
+#define CBUS_TX_FW0_STATUS_fw0_rcv_err_src(data)                                     ((0x00008000&(data))>>15)
+#define CBUS_TX_FW0_STATUS_get_fw0_rcv_err(data)                                     ((0x00008000&(data))>>15)
+#define CBUS_TX_FW0_STATUS_fw0_fifo_full_shift                                       (14)
+#define CBUS_TX_FW0_STATUS_fw0_fifo_full_mask                                        (0x00004000)
+#define CBUS_TX_FW0_STATUS_fw0_fifo_full(data)                                       (0x00004000&((data)<<14))
+#define CBUS_TX_FW0_STATUS_fw0_fifo_full_src(data)                                   ((0x00004000&(data))>>14)
+#define CBUS_TX_FW0_STATUS_get_fw0_fifo_full(data)                                   ((0x00004000&(data))>>14)
+#define CBUS_TX_FW0_STATUS_fw0_fifo_empty_shift                                      (13)
+#define CBUS_TX_FW0_STATUS_fw0_fifo_empty_mask                                       (0x00002000)
+#define CBUS_TX_FW0_STATUS_fw0_fifo_empty(data)                                      (0x00002000&((data)<<13))
+#define CBUS_TX_FW0_STATUS_fw0_fifo_empty_src(data)                                  ((0x00002000&(data))>>13)
+#define CBUS_TX_FW0_STATUS_get_fw0_fifo_empty(data)                                  ((0x00002000&(data))>>13)
+#define CBUS_TX_FW0_STATUS_fw0_fifo_len_shift                                        (8)
+#define CBUS_TX_FW0_STATUS_fw0_fifo_len_mask                                         (0x00001F00)
+#define CBUS_TX_FW0_STATUS_fw0_fifo_len(data)                                        (0x00001F00&((data)<<8))
+#define CBUS_TX_FW0_STATUS_fw0_fifo_len_src(data)                                    ((0x00001F00&(data))>>8)
+#define CBUS_TX_FW0_STATUS_get_fw0_fifo_len(data)                                    ((0x00001F00&(data))>>8)
+#define CBUS_TX_FW0_STATUS_fw0_rty_ovr_shift                                         (7)
+#define CBUS_TX_FW0_STATUS_fw0_rty_ovr_mask                                          (0x00000080)
+#define CBUS_TX_FW0_STATUS_fw0_rty_ovr(data)                                         (0x00000080&((data)<<7))
+#define CBUS_TX_FW0_STATUS_fw0_rty_ovr_src(data)                                     ((0x00000080&(data))>>7)
+#define CBUS_TX_FW0_STATUS_get_fw0_rty_ovr(data)                                     ((0x00000080&(data))>>7)
+#define CBUS_TX_FW0_STATUS_msc_hpd_shift                                             (6)
+#define CBUS_TX_FW0_STATUS_msc_hpd_mask                                              (0x00000040)
+#define CBUS_TX_FW0_STATUS_msc_hpd(data)                                             (0x00000040&((data)<<6))
+#define CBUS_TX_FW0_STATUS_msc_hpd_src(data)                                         ((0x00000040&(data))>>6)
+#define CBUS_TX_FW0_STATUS_get_msc_hpd(data)                                         ((0x00000040&(data))>>6)
+#define CBUS_TX_FW0_STATUS_write_data_shift                                          (0)
+#define CBUS_TX_FW0_STATUS_write_data_mask                                           (0x00000001)
+#define CBUS_TX_FW0_STATUS_write_data(data)                                          (0x00000001&((data)<<0))
+#define CBUS_TX_FW0_STATUS_write_data_src(data)                                      ((0x00000001&(data))>>0)
+#define CBUS_TX_FW0_STATUS_get_write_data(data)                                      ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_FW0_WDATA                                                            0x18037034
+#define CBUS_TX_FW0_WDATA_reg_addr                                                   "0xB8037034"
+#define CBUS_TX_FW0_WDATA_reg                                                        0xB8037034
+#define set_CBUS_TX_FW0_WDATA_reg(data)   (*((volatile unsigned int*) CBUS_TX_FW0_WDATA_reg)=data)
+#define get_CBUS_TX_FW0_WDATA_reg   (*((volatile unsigned int*) CBUS_TX_FW0_WDATA_reg))
+#define CBUS_TX_FW0_WDATA_inst_adr                                                   "0x000D"
+#define CBUS_TX_FW0_WDATA_inst                                                       0x000D
+#define CBUS_TX_FW0_WDATA_fw0_data_shift                                             (0)
+#define CBUS_TX_FW0_WDATA_fw0_data_mask                                              (0x000000FF)
+#define CBUS_TX_FW0_WDATA_fw0_data(data)                                             (0x000000FF&((data)<<0))
+#define CBUS_TX_FW0_WDATA_fw0_data_src(data)                                         ((0x000000FF&(data))>>0)
+#define CBUS_TX_FW0_WDATA_get_fw0_data(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_FW0_RDATA                                                            0x18037038
+#define CBUS_TX_FW0_RDATA_reg_addr                                                   "0xB8037038"
+#define CBUS_TX_FW0_RDATA_reg                                                        0xB8037038
+#define set_CBUS_TX_FW0_RDATA_reg(data)   (*((volatile unsigned int*) CBUS_TX_FW0_RDATA_reg)=data)
+#define get_CBUS_TX_FW0_RDATA_reg   (*((volatile unsigned int*) CBUS_TX_FW0_RDATA_reg))
+#define CBUS_TX_FW0_RDATA_inst_adr                                                   "0x000E"
+#define CBUS_TX_FW0_RDATA_inst                                                       0x000E
+#define CBUS_TX_FW0_RDATA_fw0_rdata_shift                                            (0)
+#define CBUS_TX_FW0_RDATA_fw0_rdata_mask                                             (0x000000FF)
+#define CBUS_TX_FW0_RDATA_fw0_rdata(data)                                            (0x000000FF&((data)<<0))
+#define CBUS_TX_FW0_RDATA_fw0_rdata_src(data)                                        ((0x000000FF&(data))>>0)
+#define CBUS_TX_FW0_RDATA_get_fw0_rdata(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_DEVCAP_OFFSET                                                        0x1803703C
+#define CBUS_TX_DEVCAP_OFFSET_reg_addr                                               "0xB803703C"
+#define CBUS_TX_DEVCAP_OFFSET_reg                                                    0xB803703C
+#define set_CBUS_TX_DEVCAP_OFFSET_reg(data)   (*((volatile unsigned int*) CBUS_TX_DEVCAP_OFFSET_reg)=data)
+#define get_CBUS_TX_DEVCAP_OFFSET_reg   (*((volatile unsigned int*) CBUS_TX_DEVCAP_OFFSET_reg))
+#define CBUS_TX_DEVCAP_OFFSET_inst_adr                                               "0x000F"
+#define CBUS_TX_DEVCAP_OFFSET_inst                                                   0x000F
+#define CBUS_TX_DEVCAP_OFFSET_scr_offset_shift                                       (24)
+#define CBUS_TX_DEVCAP_OFFSET_scr_offset_mask                                        (0xFF000000)
+#define CBUS_TX_DEVCAP_OFFSET_scr_offset(data)                                       (0xFF000000&((data)<<24))
+#define CBUS_TX_DEVCAP_OFFSET_scr_offset_src(data)                                   ((0xFF000000&(data))>>24)
+#define CBUS_TX_DEVCAP_OFFSET_get_scr_offset(data)                                   ((0xFF000000&(data))>>24)
+#define CBUS_TX_DEVCAP_OFFSET_sta_offset_shift                                       (16)
+#define CBUS_TX_DEVCAP_OFFSET_sta_offset_mask                                        (0x00FF0000)
+#define CBUS_TX_DEVCAP_OFFSET_sta_offset(data)                                       (0x00FF0000&((data)<<16))
+#define CBUS_TX_DEVCAP_OFFSET_sta_offset_src(data)                                   ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DEVCAP_OFFSET_get_sta_offset(data)                                   ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DEVCAP_OFFSET_int_offset_shift                                       (8)
+#define CBUS_TX_DEVCAP_OFFSET_int_offset_mask                                        (0x0000FF00)
+#define CBUS_TX_DEVCAP_OFFSET_int_offset(data)                                       (0x0000FF00&((data)<<8))
+#define CBUS_TX_DEVCAP_OFFSET_int_offset_src(data)                                   ((0x0000FF00&(data))>>8)
+#define CBUS_TX_DEVCAP_OFFSET_get_int_offset(data)                                   ((0x0000FF00&(data))>>8)
+#define CBUS_TX_DEVCAP_OFFSET_cap_offset_shift                                       (0)
+#define CBUS_TX_DEVCAP_OFFSET_cap_offset_mask                                        (0x000000FF)
+#define CBUS_TX_DEVCAP_OFFSET_cap_offset(data)                                       (0x000000FF&((data)<<0))
+#define CBUS_TX_DEVCAP_OFFSET_cap_offset_src(data)                                   ((0x000000FF&(data))>>0)
+#define CBUS_TX_DEVCAP_OFFSET_get_cap_offset(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_STATUS                                                           0x18037044
+#define CBUS_TX_MSC_STATUS_reg_addr                                                  "0xB8037044"
+#define CBUS_TX_MSC_STATUS_reg                                                       0xB8037044
+#define set_CBUS_TX_MSC_STATUS_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_STATUS_reg)=data)
+#define get_CBUS_TX_MSC_STATUS_reg   (*((volatile unsigned int*) CBUS_TX_MSC_STATUS_reg))
+#define CBUS_TX_MSC_STATUS_inst_adr                                                  "0x0011"
+#define CBUS_TX_MSC_STATUS_inst                                                      0x0011
+#define CBUS_TX_MSC_STATUS_que_fsm_shift                                             (28)
+#define CBUS_TX_MSC_STATUS_que_fsm_mask                                              (0xF0000000)
+#define CBUS_TX_MSC_STATUS_que_fsm(data)                                             (0xF0000000&((data)<<28))
+#define CBUS_TX_MSC_STATUS_que_fsm_src(data)                                         ((0xF0000000&(data))>>28)
+#define CBUS_TX_MSC_STATUS_get_que_fsm(data)                                         ((0xF0000000&(data))>>28)
+#define CBUS_TX_MSC_STATUS_sch_fsm_shift                                             (24)
+#define CBUS_TX_MSC_STATUS_sch_fsm_mask                                              (0x0F000000)
+#define CBUS_TX_MSC_STATUS_sch_fsm(data)                                             (0x0F000000&((data)<<24))
+#define CBUS_TX_MSC_STATUS_sch_fsm_src(data)                                         ((0x0F000000&(data))>>24)
+#define CBUS_TX_MSC_STATUS_get_sch_fsm(data)                                         ((0x0F000000&(data))>>24)
+#define CBUS_TX_MSC_STATUS_burst_timeout_shift                                       (23)
+#define CBUS_TX_MSC_STATUS_burst_timeout_mask                                        (0x00800000)
+#define CBUS_TX_MSC_STATUS_burst_timeout(data)                                       (0x00800000&((data)<<23))
+#define CBUS_TX_MSC_STATUS_burst_timeout_src(data)                                   ((0x00800000&(data))>>23)
+#define CBUS_TX_MSC_STATUS_get_burst_timeout(data)                                   ((0x00800000&(data))>>23)
+#define CBUS_TX_MSC_STATUS_write_data_shift                                          (0)
+#define CBUS_TX_MSC_STATUS_write_data_mask                                           (0x00000001)
+#define CBUS_TX_MSC_STATUS_write_data(data)                                          (0x00000001&((data)<<0))
+#define CBUS_TX_MSC_STATUS_write_data_src(data)                                      ((0x00000001&(data))>>0)
+#define CBUS_TX_MSC_STATUS_get_write_data(data)                                      ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_MSG_STATUS1                                                          0x18037048
+#define CBUS_TX_MSG_STATUS1_reg_addr                                                 "0xB8037048"
+#define CBUS_TX_MSG_STATUS1_reg                                                      0xB8037048
+#define set_CBUS_TX_MSG_STATUS1_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSG_STATUS1_reg)=data)
+#define get_CBUS_TX_MSG_STATUS1_reg   (*((volatile unsigned int*) CBUS_TX_MSG_STATUS1_reg))
+#define CBUS_TX_MSG_STATUS1_inst_adr                                                 "0x0012"
+#define CBUS_TX_MSG_STATUS1_inst                                                     0x0012
+#define CBUS_TX_MSG_STATUS1_ucpk_rcv_shift                                           (16)
+#define CBUS_TX_MSG_STATUS1_ucpk_rcv_mask                                            (0x00FF0000)
+#define CBUS_TX_MSG_STATUS1_ucpk_rcv(data)                                           (0x00FF0000&((data)<<16))
+#define CBUS_TX_MSG_STATUS1_ucpk_rcv_src(data)                                       ((0x00FF0000&(data))>>16)
+#define CBUS_TX_MSG_STATUS1_get_ucpk_rcv(data)                                       ((0x00FF0000&(data))>>16)
+#define CBUS_TX_MSG_STATUS1_ucp_rcv_shift                                            (8)
+#define CBUS_TX_MSG_STATUS1_ucp_rcv_mask                                             (0x0000FF00)
+#define CBUS_TX_MSG_STATUS1_ucp_rcv(data)                                            (0x0000FF00&((data)<<8))
+#define CBUS_TX_MSG_STATUS1_ucp_rcv_src(data)                                        ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSG_STATUS1_get_ucp_rcv(data)                                        ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSG_STATUS1_ucpe_rcv_shift                                           (0)
+#define CBUS_TX_MSG_STATUS1_ucpe_rcv_mask                                            (0x000000FF)
+#define CBUS_TX_MSG_STATUS1_ucpe_rcv(data)                                           (0x000000FF&((data)<<0))
+#define CBUS_TX_MSG_STATUS1_ucpe_rcv_src(data)                                       ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSG_STATUS1_get_ucpe_rcv(data)                                       ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSG_STATUS2                                                          0x18037050
+#define CBUS_TX_MSG_STATUS2_reg_addr                                                 "0xB8037050"
+#define CBUS_TX_MSG_STATUS2_reg                                                      0xB8037050
+#define set_CBUS_TX_MSG_STATUS2_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSG_STATUS2_reg)=data)
+#define get_CBUS_TX_MSG_STATUS2_reg   (*((volatile unsigned int*) CBUS_TX_MSG_STATUS2_reg))
+#define CBUS_TX_MSG_STATUS2_inst_adr                                                 "0x0014"
+#define CBUS_TX_MSG_STATUS2_inst                                                     0x0014
+#define CBUS_TX_MSG_STATUS2_msge_rcv_shift                                           (24)
+#define CBUS_TX_MSG_STATUS2_msge_rcv_mask                                            (0xFF000000)
+#define CBUS_TX_MSG_STATUS2_msge_rcv(data)                                           (0xFF000000&((data)<<24))
+#define CBUS_TX_MSG_STATUS2_msge_rcv_src(data)                                       ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSG_STATUS2_get_msge_rcv(data)                                       ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSG_STATUS2_rcpk_rcv_shift                                           (16)
+#define CBUS_TX_MSG_STATUS2_rcpk_rcv_mask                                            (0x00FF0000)
+#define CBUS_TX_MSG_STATUS2_rcpk_rcv(data)                                           (0x00FF0000&((data)<<16))
+#define CBUS_TX_MSG_STATUS2_rcpk_rcv_src(data)                                       ((0x00FF0000&(data))>>16)
+#define CBUS_TX_MSG_STATUS2_get_rcpk_rcv(data)                                       ((0x00FF0000&(data))>>16)
+#define CBUS_TX_MSG_STATUS2_rcp_rcv_shift                                            (8)
+#define CBUS_TX_MSG_STATUS2_rcp_rcv_mask                                             (0x0000FF00)
+#define CBUS_TX_MSG_STATUS2_rcp_rcv(data)                                            (0x0000FF00&((data)<<8))
+#define CBUS_TX_MSG_STATUS2_rcp_rcv_src(data)                                        ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSG_STATUS2_get_rcp_rcv(data)                                        ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSG_STATUS2_rcpe_rcv_shift                                           (0)
+#define CBUS_TX_MSG_STATUS2_rcpe_rcv_mask                                            (0x000000FF)
+#define CBUS_TX_MSG_STATUS2_rcpe_rcv(data)                                           (0x000000FF&((data)<<0))
+#define CBUS_TX_MSG_STATUS2_rcpe_rcv_src(data)                                       ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSG_STATUS2_get_rcpe_rcv(data)                                       ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSG_STATUS3                                                          0x18037054
+#define CBUS_TX_MSG_STATUS3_reg_addr                                                 "0xB8037054"
+#define CBUS_TX_MSG_STATUS3_reg                                                      0xB8037054
+#define set_CBUS_TX_MSG_STATUS3_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSG_STATUS3_reg)=data)
+#define get_CBUS_TX_MSG_STATUS3_reg   (*((volatile unsigned int*) CBUS_TX_MSG_STATUS3_reg))
+#define CBUS_TX_MSG_STATUS3_inst_adr                                                 "0x0015"
+#define CBUS_TX_MSG_STATUS3_inst                                                     0x0015
+#define CBUS_TX_MSG_STATUS3_rap_rcv_shift                                            (24)
+#define CBUS_TX_MSG_STATUS3_rap_rcv_mask                                             (0xFF000000)
+#define CBUS_TX_MSG_STATUS3_rap_rcv(data)                                            (0xFF000000&((data)<<24))
+#define CBUS_TX_MSG_STATUS3_rap_rcv_src(data)                                        ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSG_STATUS3_get_rap_rcv(data)                                        ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSG_STATUS3_rapk_rcv_shift                                           (16)
+#define CBUS_TX_MSG_STATUS3_rapk_rcv_mask                                            (0x00FF0000)
+#define CBUS_TX_MSG_STATUS3_rapk_rcv(data)                                           (0x00FF0000&((data)<<16))
+#define CBUS_TX_MSG_STATUS3_rapk_rcv_src(data)                                       ((0x00FF0000&(data))>>16)
+#define CBUS_TX_MSG_STATUS3_get_rapk_rcv(data)                                       ((0x00FF0000&(data))>>16)
+#define CBUS_TX_MSG_STATUS3_msg_dat_shift                                            (8)
+#define CBUS_TX_MSG_STATUS3_msg_dat_mask                                             (0x0000FF00)
+#define CBUS_TX_MSG_STATUS3_msg_dat(data)                                            (0x0000FF00&((data)<<8))
+#define CBUS_TX_MSG_STATUS3_msg_dat_src(data)                                        ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSG_STATUS3_get_msg_dat(data)                                        ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSG_STATUS3_msg_cmd_shift                                            (0)
+#define CBUS_TX_MSG_STATUS3_msg_cmd_mask                                             (0x000000FF)
+#define CBUS_TX_MSG_STATUS3_msg_cmd(data)                                            (0x000000FF&((data)<<0))
+#define CBUS_TX_MSG_STATUS3_msg_cmd_src(data)                                        ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSG_STATUS3_get_msg_cmd(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_ADOPTERID_CTRL                                                       0x18037060
+#define CBUS_TX_ADOPTERID_CTRL_reg_addr                                              "0xB8037060"
+#define CBUS_TX_ADOPTERID_CTRL_reg                                                   0xB8037060
+#define set_CBUS_TX_ADOPTERID_CTRL_reg(data)   (*((volatile unsigned int*) CBUS_TX_ADOPTERID_CTRL_reg)=data)
+#define get_CBUS_TX_ADOPTERID_CTRL_reg   (*((volatile unsigned int*) CBUS_TX_ADOPTERID_CTRL_reg))
+#define CBUS_TX_ADOPTERID_CTRL_inst_adr                                              "0x0018"
+#define CBUS_TX_ADOPTERID_CTRL_inst                                                  0x0018
+#define CBUS_TX_ADOPTERID_CTRL_wb_id_chk_shift                                       (31)
+#define CBUS_TX_ADOPTERID_CTRL_wb_id_chk_mask                                        (0x80000000)
+#define CBUS_TX_ADOPTERID_CTRL_wb_id_chk(data)                                       (0x80000000&((data)<<31))
+#define CBUS_TX_ADOPTERID_CTRL_wb_id_chk_src(data)                                   ((0x80000000&(data))>>31)
+#define CBUS_TX_ADOPTERID_CTRL_get_wb_id_chk(data)                                   ((0x80000000&(data))>>31)
+#define CBUS_TX_ADOPTERID_CTRL_rcp_reply_nack_shift                                  (30)
+#define CBUS_TX_ADOPTERID_CTRL_rcp_reply_nack_mask                                   (0x40000000)
+#define CBUS_TX_ADOPTERID_CTRL_rcp_reply_nack(data)                                  (0x40000000&((data)<<30))
+#define CBUS_TX_ADOPTERID_CTRL_rcp_reply_nack_src(data)                              ((0x40000000&(data))>>30)
+#define CBUS_TX_ADOPTERID_CTRL_get_rcp_reply_nack(data)                              ((0x40000000&(data))>>30)
+#define CBUS_TX_ADOPTERID_CTRL_rcp_reply_abort_shift                                 (29)
+#define CBUS_TX_ADOPTERID_CTRL_rcp_reply_abort_mask                                  (0x20000000)
+#define CBUS_TX_ADOPTERID_CTRL_rcp_reply_abort(data)                                 (0x20000000&((data)<<29))
+#define CBUS_TX_ADOPTERID_CTRL_rcp_reply_abort_src(data)                             ((0x20000000&(data))>>29)
+#define CBUS_TX_ADOPTERID_CTRL_get_rcp_reply_abort(data)                             ((0x20000000&(data))>>29)
+#define CBUS_TX_ADOPTERID_CTRL_fwdef_cmd_rev_shift                                   (16)
+#define CBUS_TX_ADOPTERID_CTRL_fwdef_cmd_rev_mask                                    (0x00FF0000)
+#define CBUS_TX_ADOPTERID_CTRL_fwdef_cmd_rev(data)                                   (0x00FF0000&((data)<<16))
+#define CBUS_TX_ADOPTERID_CTRL_fwdef_cmd_rev_src(data)                               ((0x00FF0000&(data))>>16)
+#define CBUS_TX_ADOPTERID_CTRL_get_fwdef_cmd_rev(data)                               ((0x00FF0000&(data))>>16)
+
+
+#define CBUS_TX_RCV_ADOPTER_ID                                                       0x18037064
+#define CBUS_TX_RCV_ADOPTER_ID_reg_addr                                              "0xB8037064"
+#define CBUS_TX_RCV_ADOPTER_ID_reg                                                   0xB8037064
+#define set_CBUS_TX_RCV_ADOPTER_ID_reg(data)   (*((volatile unsigned int*) CBUS_TX_RCV_ADOPTER_ID_reg)=data)
+#define get_CBUS_TX_RCV_ADOPTER_ID_reg   (*((volatile unsigned int*) CBUS_TX_RCV_ADOPTER_ID_reg))
+#define CBUS_TX_RCV_ADOPTER_ID_inst_adr                                              "0x0019"
+#define CBUS_TX_RCV_ADOPTER_ID_inst                                                  0x0019
+#define CBUS_TX_RCV_ADOPTER_ID_adop_idl_rcv_shift                                    (8)
+#define CBUS_TX_RCV_ADOPTER_ID_adop_idl_rcv_mask                                     (0x0000FF00)
+#define CBUS_TX_RCV_ADOPTER_ID_adop_idl_rcv(data)                                    (0x0000FF00&((data)<<8))
+#define CBUS_TX_RCV_ADOPTER_ID_adop_idl_rcv_src(data)                                ((0x0000FF00&(data))>>8)
+#define CBUS_TX_RCV_ADOPTER_ID_get_adop_idl_rcv(data)                                ((0x0000FF00&(data))>>8)
+#define CBUS_TX_RCV_ADOPTER_ID_adop_idh_rcv_shift                                    (0)
+#define CBUS_TX_RCV_ADOPTER_ID_adop_idh_rcv_mask                                     (0x000000FF)
+#define CBUS_TX_RCV_ADOPTER_ID_adop_idh_rcv(data)                                    (0x000000FF&((data)<<0))
+#define CBUS_TX_RCV_ADOPTER_ID_adop_idh_rcv_src(data)                                ((0x000000FF&(data))>>0)
+#define CBUS_TX_RCV_ADOPTER_ID_get_adop_idh_rcv(data)                                ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_CTRL                                                             0x18037068
+#define CBUS_TX_MSC_CTRL_reg_addr                                                    "0xB8037068"
+#define CBUS_TX_MSC_CTRL_reg                                                         0xB8037068
+#define set_CBUS_TX_MSC_CTRL_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_CTRL_reg)=data)
+#define get_CBUS_TX_MSC_CTRL_reg   (*((volatile unsigned int*) CBUS_TX_MSC_CTRL_reg))
+#define CBUS_TX_MSC_CTRL_inst_adr                                                    "0x001A"
+#define CBUS_TX_MSC_CTRL_inst                                                        0x001A
+#define CBUS_TX_MSC_CTRL_mcumsc_en_shift                                             (31)
+#define CBUS_TX_MSC_CTRL_mcumsc_en_mask                                              (0x80000000)
+#define CBUS_TX_MSC_CTRL_mcumsc_en(data)                                             (0x80000000&((data)<<31))
+#define CBUS_TX_MSC_CTRL_mcumsc_en_src(data)                                         ((0x80000000&(data))>>31)
+#define CBUS_TX_MSC_CTRL_get_mcumsc_en(data)                                         ((0x80000000&(data))>>31)
+#define CBUS_TX_MSC_CTRL_msc_wait_arb_shift                                          (29)
+#define CBUS_TX_MSC_CTRL_msc_wait_arb_mask                                           (0x20000000)
+#define CBUS_TX_MSC_CTRL_msc_wait_arb(data)                                          (0x20000000&((data)<<29))
+#define CBUS_TX_MSC_CTRL_msc_wait_arb_src(data)                                      ((0x20000000&(data))>>29)
+#define CBUS_TX_MSC_CTRL_get_msc_wait_arb(data)                                      ((0x20000000&(data))>>29)
+#define CBUS_TX_MSC_CTRL_rx_fifo_clr_shift                                           (28)
+#define CBUS_TX_MSC_CTRL_rx_fifo_clr_mask                                            (0x10000000)
+#define CBUS_TX_MSC_CTRL_rx_fifo_clr(data)                                           (0x10000000&((data)<<28))
+#define CBUS_TX_MSC_CTRL_rx_fifo_clr_src(data)                                       ((0x10000000&(data))>>28)
+#define CBUS_TX_MSC_CTRL_get_rx_fifo_clr(data)                                       ((0x10000000&(data))>>28)
+#define CBUS_TX_MSC_CTRL_que_fsm_clr_shift                                           (25)
+#define CBUS_TX_MSC_CTRL_que_fsm_clr_mask                                            (0x02000000)
+#define CBUS_TX_MSC_CTRL_que_fsm_clr(data)                                           (0x02000000&((data)<<25))
+#define CBUS_TX_MSC_CTRL_que_fsm_clr_src(data)                                       ((0x02000000&(data))>>25)
+#define CBUS_TX_MSC_CTRL_get_que_fsm_clr(data)                                       ((0x02000000&(data))>>25)
+#define CBUS_TX_MSC_CTRL_sch_fsm_clr_shift                                           (24)
+#define CBUS_TX_MSC_CTRL_sch_fsm_clr_mask                                            (0x01000000)
+#define CBUS_TX_MSC_CTRL_sch_fsm_clr(data)                                           (0x01000000&((data)<<24))
+#define CBUS_TX_MSC_CTRL_sch_fsm_clr_src(data)                                       ((0x01000000&(data))>>24)
+#define CBUS_TX_MSC_CTRL_get_sch_fsm_clr(data)                                       ((0x01000000&(data))>>24)
+
+
+#define CBUS_TX_MSC_BURST_DATA                                                       0x1803706C
+#define CBUS_TX_MSC_BURST_DATA_reg_addr                                              "0xB803706C"
+#define CBUS_TX_MSC_BURST_DATA_reg                                                   0xB803706C
+#define set_CBUS_TX_MSC_BURST_DATA_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_BURST_DATA_reg)=data)
+#define get_CBUS_TX_MSC_BURST_DATA_reg   (*((volatile unsigned int*) CBUS_TX_MSC_BURST_DATA_reg))
+#define CBUS_TX_MSC_BURST_DATA_inst_adr                                              "0x001B"
+#define CBUS_TX_MSC_BURST_DATA_inst                                                  0x001B
+#define CBUS_TX_MSC_BURST_DATA_msc_err_code_shift                                    (0)
+#define CBUS_TX_MSC_BURST_DATA_msc_err_code_mask                                     (0x000000FF)
+#define CBUS_TX_MSC_BURST_DATA_msc_err_code(data)                                    (0x000000FF&((data)<<0))
+#define CBUS_TX_MSC_BURST_DATA_msc_err_code_src(data)                                ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSC_BURST_DATA_get_msc_err_code(data)                                ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_RCV_CMD                                                          0x18037070
+#define CBUS_TX_MSC_RCV_CMD_reg_addr                                                 "0xB8037070"
+#define CBUS_TX_MSC_RCV_CMD_reg                                                      0xB8037070
+#define set_CBUS_TX_MSC_RCV_CMD_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_RCV_CMD_reg)=data)
+#define get_CBUS_TX_MSC_RCV_CMD_reg   (*((volatile unsigned int*) CBUS_TX_MSC_RCV_CMD_reg))
+#define CBUS_TX_MSC_RCV_CMD_inst_adr                                                 "0x001C"
+#define CBUS_TX_MSC_RCV_CMD_inst                                                     0x001C
+#define CBUS_TX_MSC_RCV_CMD_rx_fifo_full_shift                                       (31)
+#define CBUS_TX_MSC_RCV_CMD_rx_fifo_full_mask                                        (0x80000000)
+#define CBUS_TX_MSC_RCV_CMD_rx_fifo_full(data)                                       (0x80000000&((data)<<31))
+#define CBUS_TX_MSC_RCV_CMD_rx_fifo_full_src(data)                                   ((0x80000000&(data))>>31)
+#define CBUS_TX_MSC_RCV_CMD_get_rx_fifo_full(data)                                   ((0x80000000&(data))>>31)
+#define CBUS_TX_MSC_RCV_CMD_rx_fifo_empty_shift                                      (30)
+#define CBUS_TX_MSC_RCV_CMD_rx_fifo_empty_mask                                       (0x40000000)
+#define CBUS_TX_MSC_RCV_CMD_rx_fifo_empty(data)                                      (0x40000000&((data)<<30))
+#define CBUS_TX_MSC_RCV_CMD_rx_fifo_empty_src(data)                                  ((0x40000000&(data))>>30)
+#define CBUS_TX_MSC_RCV_CMD_get_rx_fifo_empty(data)                                  ((0x40000000&(data))>>30)
+#define CBUS_TX_MSC_RCV_CMD_na_rx_len_shift                                          (24)
+#define CBUS_TX_MSC_RCV_CMD_na_rx_len_mask                                           (0x1F000000)
+#define CBUS_TX_MSC_RCV_CMD_na_rx_len(data)                                          (0x1F000000&((data)<<24))
+#define CBUS_TX_MSC_RCV_CMD_na_rx_len_src(data)                                      ((0x1F000000&(data))>>24)
+#define CBUS_TX_MSC_RCV_CMD_get_na_rx_len(data)                                      ((0x1F000000&(data))>>24)
+#define CBUS_TX_MSC_RCV_CMD_na_msc_offset_shift                                      (8)
+#define CBUS_TX_MSC_RCV_CMD_na_msc_offset_mask                                       (0x0000FF00)
+#define CBUS_TX_MSC_RCV_CMD_na_msc_offset(data)                                      (0x0000FF00&((data)<<8))
+#define CBUS_TX_MSC_RCV_CMD_na_msc_offset_src(data)                                  ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSC_RCV_CMD_get_na_msc_offset(data)                                  ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSC_RCV_CMD_na_msc_cmd_shift                                         (0)
+#define CBUS_TX_MSC_RCV_CMD_na_msc_cmd_mask                                          (0x000000FF)
+#define CBUS_TX_MSC_RCV_CMD_na_msc_cmd(data)                                         (0x000000FF&((data)<<0))
+#define CBUS_TX_MSC_RCV_CMD_na_msc_cmd_src(data)                                     ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSC_RCV_CMD_get_na_msc_cmd(data)                                     ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_RCV_DATA                                                         0x18037074
+#define CBUS_TX_MSC_RCV_DATA_reg_addr                                                "0xB8037074"
+#define CBUS_TX_MSC_RCV_DATA_reg                                                     0xB8037074
+#define set_CBUS_TX_MSC_RCV_DATA_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_RCV_DATA_reg)=data)
+#define get_CBUS_TX_MSC_RCV_DATA_reg   (*((volatile unsigned int*) CBUS_TX_MSC_RCV_DATA_reg))
+#define CBUS_TX_MSC_RCV_DATA_inst_adr                                                "0x001D"
+#define CBUS_TX_MSC_RCV_DATA_inst                                                    0x001D
+#define CBUS_TX_MSC_RCV_DATA_rx_fifo_data_shift                                      (0)
+#define CBUS_TX_MSC_RCV_DATA_rx_fifo_data_mask                                       (0x000000FF)
+#define CBUS_TX_MSC_RCV_DATA_rx_fifo_data(data)                                      (0x000000FF&((data)<<0))
+#define CBUS_TX_MSC_RCV_DATA_rx_fifo_data_src(data)                                  ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSC_RCV_DATA_get_rx_fifo_data(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_WRITE_ERR_CODE                                                   0x180370A4
+#define CBUS_TX_MSC_WRITE_ERR_CODE_reg_addr                                          "0xB80370A4"
+#define CBUS_TX_MSC_WRITE_ERR_CODE_reg                                               0xB80370A4
+#define set_CBUS_TX_MSC_WRITE_ERR_CODE_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_WRITE_ERR_CODE_reg)=data)
+#define get_CBUS_TX_MSC_WRITE_ERR_CODE_reg   (*((volatile unsigned int*) CBUS_TX_MSC_WRITE_ERR_CODE_reg))
+#define CBUS_TX_MSC_WRITE_ERR_CODE_inst_adr                                          "0x0029"
+#define CBUS_TX_MSC_WRITE_ERR_CODE_inst                                              0x0029
+#define CBUS_TX_MSC_WRITE_ERR_CODE_msc_err_force_shift                               (31)
+#define CBUS_TX_MSC_WRITE_ERR_CODE_msc_err_force_mask                                (0x80000000)
+#define CBUS_TX_MSC_WRITE_ERR_CODE_msc_err_force(data)                               (0x80000000&((data)<<31))
+#define CBUS_TX_MSC_WRITE_ERR_CODE_msc_err_force_src(data)                           ((0x80000000&(data))>>31)
+#define CBUS_TX_MSC_WRITE_ERR_CODE_get_msc_err_force(data)                           ((0x80000000&(data))>>31)
+#define CBUS_TX_MSC_WRITE_ERR_CODE_msc_err_fw_shift                                  (0)
+#define CBUS_TX_MSC_WRITE_ERR_CODE_msc_err_fw_mask                                   (0x000000FF)
+#define CBUS_TX_MSC_WRITE_ERR_CODE_msc_err_fw(data)                                  (0x000000FF&((data)<<0))
+#define CBUS_TX_MSC_WRITE_ERR_CODE_msc_err_fw_src(data)                              ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSC_WRITE_ERR_CODE_get_msc_err_fw(data)                              ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_DDC_CMD_INF                                                          0x1803707C
+#define CBUS_TX_DDC_CMD_INF_reg_addr                                                 "0xB803707C"
+#define CBUS_TX_DDC_CMD_INF_reg                                                      0xB803707C
+#define set_CBUS_TX_DDC_CMD_INF_reg(data)   (*((volatile unsigned int*) CBUS_TX_DDC_CMD_INF_reg)=data)
+#define get_CBUS_TX_DDC_CMD_INF_reg   (*((volatile unsigned int*) CBUS_TX_DDC_CMD_INF_reg))
+#define CBUS_TX_DDC_CMD_INF_inst_adr                                                 "0x001F"
+#define CBUS_TX_DDC_CMD_INF_inst                                                     0x001F
+#define CBUS_TX_DDC_CMD_INF_ddc_rdy_shift                                            (31)
+#define CBUS_TX_DDC_CMD_INF_ddc_rdy_mask                                             (0x80000000)
+#define CBUS_TX_DDC_CMD_INF_ddc_rdy(data)                                            (0x80000000&((data)<<31))
+#define CBUS_TX_DDC_CMD_INF_ddc_rdy_src(data)                                        ((0x80000000&(data))>>31)
+#define CBUS_TX_DDC_CMD_INF_get_ddc_rdy(data)                                        ((0x80000000&(data))>>31)
+#define CBUS_TX_DDC_CMD_INF_ddc_cmd_type_shift                                       (28)
+#define CBUS_TX_DDC_CMD_INF_ddc_cmd_type_mask                                        (0x70000000)
+#define CBUS_TX_DDC_CMD_INF_ddc_cmd_type(data)                                       (0x70000000&((data)<<28))
+#define CBUS_TX_DDC_CMD_INF_ddc_cmd_type_src(data)                                   ((0x70000000&(data))>>28)
+#define CBUS_TX_DDC_CMD_INF_get_ddc_cmd_type(data)                                   ((0x70000000&(data))>>28)
+#define CBUS_TX_DDC_CMD_INF_ddc_num_shift                                            (24)
+#define CBUS_TX_DDC_CMD_INF_ddc_num_mask                                             (0x0F000000)
+#define CBUS_TX_DDC_CMD_INF_ddc_num(data)                                            (0x0F000000&((data)<<24))
+#define CBUS_TX_DDC_CMD_INF_ddc_num_src(data)                                        ((0x0F000000&(data))>>24)
+#define CBUS_TX_DDC_CMD_INF_get_ddc_num(data)                                        ((0x0F000000&(data))>>24)
+#define CBUS_TX_DDC_CMD_INF_ddc_nack_limit_shift                                     (16)
+#define CBUS_TX_DDC_CMD_INF_ddc_nack_limit_mask                                      (0x00FF0000)
+#define CBUS_TX_DDC_CMD_INF_ddc_nack_limit(data)                                     (0x00FF0000&((data)<<16))
+#define CBUS_TX_DDC_CMD_INF_ddc_nack_limit_src(data)                                 ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DDC_CMD_INF_get_ddc_nack_limit(data)                                 ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DDC_CMD_INF_ddc_err_code_clr_shift                                   (10)
+#define CBUS_TX_DDC_CMD_INF_ddc_err_code_clr_mask                                    (0x00000400)
+#define CBUS_TX_DDC_CMD_INF_ddc_err_code_clr(data)                                   (0x00000400&((data)<<10))
+#define CBUS_TX_DDC_CMD_INF_ddc_err_code_clr_src(data)                               ((0x00000400&(data))>>10)
+#define CBUS_TX_DDC_CMD_INF_get_ddc_err_code_clr(data)                               ((0x00000400&(data))>>10)
+#define CBUS_TX_DDC_CMD_INF_ddc_prior_dis_shift                                      (9)
+#define CBUS_TX_DDC_CMD_INF_ddc_prior_dis_mask                                       (0x00000200)
+#define CBUS_TX_DDC_CMD_INF_ddc_prior_dis(data)                                      (0x00000200&((data)<<9))
+#define CBUS_TX_DDC_CMD_INF_ddc_prior_dis_src(data)                                  ((0x00000200&(data))>>9)
+#define CBUS_TX_DDC_CMD_INF_get_ddc_prior_dis(data)                                  ((0x00000200&(data))>>9)
+#define CBUS_TX_DDC_CMD_INF_ddc_fsm_clr_shift                                        (8)
+#define CBUS_TX_DDC_CMD_INF_ddc_fsm_clr_mask                                         (0x00000100)
+#define CBUS_TX_DDC_CMD_INF_ddc_fsm_clr(data)                                        (0x00000100&((data)<<8))
+#define CBUS_TX_DDC_CMD_INF_ddc_fsm_clr_src(data)                                    ((0x00000100&(data))>>8)
+#define CBUS_TX_DDC_CMD_INF_get_ddc_fsm_clr(data)                                    ((0x00000100&(data))>>8)
+#define CBUS_TX_DDC_CMD_INF_ddc_nack_retry_shift                                     (2)
+#define CBUS_TX_DDC_CMD_INF_ddc_nack_retry_mask                                      (0x00000004)
+#define CBUS_TX_DDC_CMD_INF_ddc_nack_retry(data)                                     (0x00000004&((data)<<2))
+#define CBUS_TX_DDC_CMD_INF_ddc_nack_retry_src(data)                                 ((0x00000004&(data))>>2)
+#define CBUS_TX_DDC_CMD_INF_get_ddc_nack_retry(data)                                 ((0x00000004&(data))>>2)
+#define CBUS_TX_DDC_CMD_INF_ddc_wait_case_shift                                      (1)
+#define CBUS_TX_DDC_CMD_INF_ddc_wait_case_mask                                       (0x00000002)
+#define CBUS_TX_DDC_CMD_INF_ddc_wait_case(data)                                      (0x00000002&((data)<<1))
+#define CBUS_TX_DDC_CMD_INF_ddc_wait_case_src(data)                                  ((0x00000002&(data))>>1)
+#define CBUS_TX_DDC_CMD_INF_get_ddc_wait_case(data)                                  ((0x00000002&(data))>>1)
+#define CBUS_TX_DDC_CMD_INF_ddc_fw_en_shift                                          (0)
+#define CBUS_TX_DDC_CMD_INF_ddc_fw_en_mask                                           (0x00000001)
+#define CBUS_TX_DDC_CMD_INF_ddc_fw_en(data)                                          (0x00000001&((data)<<0))
+#define CBUS_TX_DDC_CMD_INF_ddc_fw_en_src(data)                                      ((0x00000001&(data))>>0)
+#define CBUS_TX_DDC_CMD_INF_get_ddc_fw_en(data)                                      ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_DDC_CMD_DATA                                                         0x18037080
+#define CBUS_TX_DDC_CMD_DATA_reg_addr                                                "0xB8037080"
+#define CBUS_TX_DDC_CMD_DATA_reg                                                     0xB8037080
+#define set_CBUS_TX_DDC_CMD_DATA_reg(data)   (*((volatile unsigned int*) CBUS_TX_DDC_CMD_DATA_reg)=data)
+#define get_CBUS_TX_DDC_CMD_DATA_reg   (*((volatile unsigned int*) CBUS_TX_DDC_CMD_DATA_reg))
+#define CBUS_TX_DDC_CMD_DATA_inst_adr                                                "0x0020"
+#define CBUS_TX_DDC_CMD_DATA_inst                                                    0x0020
+#define CBUS_TX_DDC_CMD_DATA_ddc_segval_shift                                        (16)
+#define CBUS_TX_DDC_CMD_DATA_ddc_segval_mask                                         (0x00FF0000)
+#define CBUS_TX_DDC_CMD_DATA_ddc_segval(data)                                        (0x00FF0000&((data)<<16))
+#define CBUS_TX_DDC_CMD_DATA_ddc_segval_src(data)                                    ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DDC_CMD_DATA_get_ddc_segval(data)                                    ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DDC_CMD_DATA_ddc_offset_shift                                        (8)
+#define CBUS_TX_DDC_CMD_DATA_ddc_offset_mask                                         (0x0000FF00)
+#define CBUS_TX_DDC_CMD_DATA_ddc_offset(data)                                        (0x0000FF00&((data)<<8))
+#define CBUS_TX_DDC_CMD_DATA_ddc_offset_src(data)                                    ((0x0000FF00&(data))>>8)
+#define CBUS_TX_DDC_CMD_DATA_get_ddc_offset(data)                                    ((0x0000FF00&(data))>>8)
+#define CBUS_TX_DDC_CMD_DATA_ddc_devaddr_shift                                       (0)
+#define CBUS_TX_DDC_CMD_DATA_ddc_devaddr_mask                                        (0x000000FF)
+#define CBUS_TX_DDC_CMD_DATA_ddc_devaddr(data)                                       (0x000000FF&((data)<<0))
+#define CBUS_TX_DDC_CMD_DATA_ddc_devaddr_src(data)                                   ((0x000000FF&(data))>>0)
+#define CBUS_TX_DDC_CMD_DATA_get_ddc_devaddr(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_DDC_WD                                                               0x18037084
+#define CBUS_TX_DDC_WD_reg_addr                                                      "0xB8037084"
+#define CBUS_TX_DDC_WD_reg                                                           0xB8037084
+#define set_CBUS_TX_DDC_WD_reg(data)   (*((volatile unsigned int*) CBUS_TX_DDC_WD_reg)=data)
+#define get_CBUS_TX_DDC_WD_reg   (*((volatile unsigned int*) CBUS_TX_DDC_WD_reg))
+#define CBUS_TX_DDC_WD_inst_adr                                                      "0x0021"
+#define CBUS_TX_DDC_WD_inst                                                          0x0021
+#define CBUS_TX_DDC_WD_ddc_wdata_shift                                               (0)
+#define CBUS_TX_DDC_WD_ddc_wdata_mask                                                (0x000000FF)
+#define CBUS_TX_DDC_WD_ddc_wdata(data)                                               (0x000000FF&((data)<<0))
+#define CBUS_TX_DDC_WD_ddc_wdata_src(data)                                           ((0x000000FF&(data))>>0)
+#define CBUS_TX_DDC_WD_get_ddc_wdata(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_DDC_RD                                                               0x18037088
+#define CBUS_TX_DDC_RD_reg_addr                                                      "0xB8037088"
+#define CBUS_TX_DDC_RD_reg                                                           0xB8037088
+#define set_CBUS_TX_DDC_RD_reg(data)   (*((volatile unsigned int*) CBUS_TX_DDC_RD_reg)=data)
+#define get_CBUS_TX_DDC_RD_reg   (*((volatile unsigned int*) CBUS_TX_DDC_RD_reg))
+#define CBUS_TX_DDC_RD_inst_adr                                                      "0x0022"
+#define CBUS_TX_DDC_RD_inst                                                          0x0022
+#define CBUS_TX_DDC_RD_ddc_fsm_shift                                                 (16)
+#define CBUS_TX_DDC_RD_ddc_fsm_mask                                                  (0x001F0000)
+#define CBUS_TX_DDC_RD_ddc_fsm(data)                                                 (0x001F0000&((data)<<16))
+#define CBUS_TX_DDC_RD_ddc_fsm_src(data)                                             ((0x001F0000&(data))>>16)
+#define CBUS_TX_DDC_RD_get_ddc_fsm(data)                                             ((0x001F0000&(data))>>16)
+#define CBUS_TX_DDC_RD_ddc_rdata_shift                                               (0)
+#define CBUS_TX_DDC_RD_ddc_rdata_mask                                                (0x000000FF)
+#define CBUS_TX_DDC_RD_ddc_rdata(data)                                               (0x000000FF&((data)<<0))
+#define CBUS_TX_DDC_RD_ddc_rdata_src(data)                                           ((0x000000FF&(data))>>0)
+#define CBUS_TX_DDC_RD_get_ddc_rdata(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_DDC_STATUS                                                           0x1803708C
+#define CBUS_TX_DDC_STATUS_reg_addr                                                  "0xB803708C"
+#define CBUS_TX_DDC_STATUS_reg                                                       0xB803708C
+#define set_CBUS_TX_DDC_STATUS_reg(data)   (*((volatile unsigned int*) CBUS_TX_DDC_STATUS_reg)=data)
+#define get_CBUS_TX_DDC_STATUS_reg   (*((volatile unsigned int*) CBUS_TX_DDC_STATUS_reg))
+#define CBUS_TX_DDC_STATUS_inst_adr                                                  "0x0023"
+#define CBUS_TX_DDC_STATUS_inst                                                      0x0023
+#define CBUS_TX_DDC_STATUS_ddc_fifo_full_shift                                       (25)
+#define CBUS_TX_DDC_STATUS_ddc_fifo_full_mask                                        (0x02000000)
+#define CBUS_TX_DDC_STATUS_ddc_fifo_full(data)                                       (0x02000000&((data)<<25))
+#define CBUS_TX_DDC_STATUS_ddc_fifo_full_src(data)                                   ((0x02000000&(data))>>25)
+#define CBUS_TX_DDC_STATUS_get_ddc_fifo_full(data)                                   ((0x02000000&(data))>>25)
+#define CBUS_TX_DDC_STATUS_ddc_fifo_empty_shift                                      (24)
+#define CBUS_TX_DDC_STATUS_ddc_fifo_empty_mask                                       (0x01000000)
+#define CBUS_TX_DDC_STATUS_ddc_fifo_empty(data)                                      (0x01000000&((data)<<24))
+#define CBUS_TX_DDC_STATUS_ddc_fifo_empty_src(data)                                  ((0x01000000&(data))>>24)
+#define CBUS_TX_DDC_STATUS_get_ddc_fifo_empty(data)                                  ((0x01000000&(data))>>24)
+#define CBUS_TX_DDC_STATUS_ddc_err_code_shift                                        (16)
+#define CBUS_TX_DDC_STATUS_ddc_err_code_mask                                         (0x00FF0000)
+#define CBUS_TX_DDC_STATUS_ddc_err_code(data)                                        (0x00FF0000&((data)<<16))
+#define CBUS_TX_DDC_STATUS_ddc_err_code_src(data)                                    ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DDC_STATUS_get_ddc_err_code(data)                                    ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DDC_STATUS_ddc_wp_shift                                              (4)
+#define CBUS_TX_DDC_STATUS_ddc_wp_mask                                               (0x000000F0)
+#define CBUS_TX_DDC_STATUS_ddc_wp(data)                                              (0x000000F0&((data)<<4))
+#define CBUS_TX_DDC_STATUS_ddc_wp_src(data)                                          ((0x000000F0&(data))>>4)
+#define CBUS_TX_DDC_STATUS_get_ddc_wp(data)                                          ((0x000000F0&(data))>>4)
+#define CBUS_TX_DDC_STATUS_ddc_rp_shift                                              (0)
+#define CBUS_TX_DDC_STATUS_ddc_rp_mask                                               (0x0000000F)
+#define CBUS_TX_DDC_STATUS_ddc_rp(data)                                              (0x0000000F&((data)<<0))
+#define CBUS_TX_DDC_STATUS_ddc_rp_src(data)                                          ((0x0000000F&(data))>>0)
+#define CBUS_TX_DDC_STATUS_get_ddc_rp(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define CBUS_TX_DDC_WRITE_ERR_CODE                                                   0x180370A0
+#define CBUS_TX_DDC_WRITE_ERR_CODE_reg_addr                                          "0xB80370A0"
+#define CBUS_TX_DDC_WRITE_ERR_CODE_reg                                               0xB80370A0
+#define set_CBUS_TX_DDC_WRITE_ERR_CODE_reg(data)   (*((volatile unsigned int*) CBUS_TX_DDC_WRITE_ERR_CODE_reg)=data)
+#define get_CBUS_TX_DDC_WRITE_ERR_CODE_reg   (*((volatile unsigned int*) CBUS_TX_DDC_WRITE_ERR_CODE_reg))
+#define CBUS_TX_DDC_WRITE_ERR_CODE_inst_adr                                          "0x0028"
+#define CBUS_TX_DDC_WRITE_ERR_CODE_inst                                              0x0028
+#define CBUS_TX_DDC_WRITE_ERR_CODE_ddc_err_force_shift                               (31)
+#define CBUS_TX_DDC_WRITE_ERR_CODE_ddc_err_force_mask                                (0x80000000)
+#define CBUS_TX_DDC_WRITE_ERR_CODE_ddc_err_force(data)                               (0x80000000&((data)<<31))
+#define CBUS_TX_DDC_WRITE_ERR_CODE_ddc_err_force_src(data)                           ((0x80000000&(data))>>31)
+#define CBUS_TX_DDC_WRITE_ERR_CODE_get_ddc_err_force(data)                           ((0x80000000&(data))>>31)
+#define CBUS_TX_DDC_WRITE_ERR_CODE_ddc_err_fw_shift                                  (0)
+#define CBUS_TX_DDC_WRITE_ERR_CODE_ddc_err_fw_mask                                   (0x000000FF)
+#define CBUS_TX_DDC_WRITE_ERR_CODE_ddc_err_fw(data)                                  (0x000000FF&((data)<<0))
+#define CBUS_TX_DDC_WRITE_ERR_CODE_ddc_err_fw_src(data)                              ((0x000000FF&(data))>>0)
+#define CBUS_TX_DDC_WRITE_ERR_CODE_get_ddc_err_fw(data)                              ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_IRQ                                                              0x18037058
+#define CBUS_TX_MSC_IRQ_reg_addr                                                     "0xB8037058"
+#define CBUS_TX_MSC_IRQ_reg                                                          0xB8037058
+#define set_CBUS_TX_MSC_IRQ_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_IRQ_reg)=data)
+#define get_CBUS_TX_MSC_IRQ_reg   (*((volatile unsigned int*) CBUS_TX_MSC_IRQ_reg))
+#define CBUS_TX_MSC_IRQ_inst_adr                                                     "0x0016"
+#define CBUS_TX_MSC_IRQ_inst                                                         0x0016
+#define CBUS_TX_MSC_IRQ_wr_stat_irq_shift                                            (31)
+#define CBUS_TX_MSC_IRQ_wr_stat_irq_mask                                             (0x80000000)
+#define CBUS_TX_MSC_IRQ_wr_stat_irq(data)                                            (0x80000000&((data)<<31))
+#define CBUS_TX_MSC_IRQ_wr_stat_irq_src(data)                                        ((0x80000000&(data))>>31)
+#define CBUS_TX_MSC_IRQ_get_wr_stat_irq(data)                                        ((0x80000000&(data))>>31)
+#define CBUS_TX_MSC_IRQ_rd_devcap_irq_shift                                          (30)
+#define CBUS_TX_MSC_IRQ_rd_devcap_irq_mask                                           (0x40000000)
+#define CBUS_TX_MSC_IRQ_rd_devcap_irq(data)                                          (0x40000000&((data)<<30))
+#define CBUS_TX_MSC_IRQ_rd_devcap_irq_src(data)                                      ((0x40000000&(data))>>30)
+#define CBUS_TX_MSC_IRQ_get_rd_devcap_irq(data)                                      ((0x40000000&(data))>>30)
+#define CBUS_TX_MSC_IRQ_get_stat_irq_shift                                           (29)
+#define CBUS_TX_MSC_IRQ_get_stat_irq_mask                                            (0x20000000)
+#define CBUS_TX_MSC_IRQ_get_stat_irq(data)                                           (0x20000000&((data)<<29))
+#define CBUS_TX_MSC_IRQ_get_stat_irq_src(data)                                       ((0x20000000&(data))>>29)
+#define CBUS_TX_MSC_IRQ_get_get_stat_irq(data)                                       ((0x20000000&(data))>>29)
+#define CBUS_TX_MSC_IRQ_get_id_irq_shift                                             (28)
+#define CBUS_TX_MSC_IRQ_get_id_irq_mask                                              (0x10000000)
+#define CBUS_TX_MSC_IRQ_get_id_irq(data)                                             (0x10000000&((data)<<28))
+#define CBUS_TX_MSC_IRQ_get_id_irq_src(data)                                         ((0x10000000&(data))>>28)
+#define CBUS_TX_MSC_IRQ_get_get_id_irq(data)                                         ((0x10000000&(data))>>28)
+#define CBUS_TX_MSC_IRQ_get_msg_irq_shift                                            (27)
+#define CBUS_TX_MSC_IRQ_get_msg_irq_mask                                             (0x08000000)
+#define CBUS_TX_MSC_IRQ_get_msg_irq(data)                                            (0x08000000&((data)<<27))
+#define CBUS_TX_MSC_IRQ_get_msg_irq_src(data)                                        ((0x08000000&(data))>>27)
+#define CBUS_TX_MSC_IRQ_get_get_msg_irq(data)                                        ((0x08000000&(data))>>27)
+#define CBUS_TX_MSC_IRQ_sc1_err_irq_shift                                            (26)
+#define CBUS_TX_MSC_IRQ_sc1_err_irq_mask                                             (0x04000000)
+#define CBUS_TX_MSC_IRQ_sc1_err_irq(data)                                            (0x04000000&((data)<<26))
+#define CBUS_TX_MSC_IRQ_sc1_err_irq_src(data)                                        ((0x04000000&(data))>>26)
+#define CBUS_TX_MSC_IRQ_get_sc1_err_irq(data)                                        ((0x04000000&(data))>>26)
+#define CBUS_TX_MSC_IRQ_ddc_err_irq_shift                                            (25)
+#define CBUS_TX_MSC_IRQ_ddc_err_irq_mask                                             (0x02000000)
+#define CBUS_TX_MSC_IRQ_ddc_err_irq(data)                                            (0x02000000&((data)<<25))
+#define CBUS_TX_MSC_IRQ_ddc_err_irq_src(data)                                        ((0x02000000&(data))>>25)
+#define CBUS_TX_MSC_IRQ_get_ddc_err_irq(data)                                        ((0x02000000&(data))>>25)
+#define CBUS_TX_MSC_IRQ_msc_err_irq_shift                                            (24)
+#define CBUS_TX_MSC_IRQ_msc_err_irq_mask                                             (0x01000000)
+#define CBUS_TX_MSC_IRQ_msc_err_irq(data)                                            (0x01000000&((data)<<24))
+#define CBUS_TX_MSC_IRQ_msc_err_irq_src(data)                                        ((0x01000000&(data))>>24)
+#define CBUS_TX_MSC_IRQ_get_msc_err_irq(data)                                        ((0x01000000&(data))>>24)
+#define CBUS_TX_MSC_IRQ_wr_burst_irq_shift                                           (23)
+#define CBUS_TX_MSC_IRQ_wr_burst_irq_mask                                            (0x00800000)
+#define CBUS_TX_MSC_IRQ_wr_burst_irq(data)                                           (0x00800000&((data)<<23))
+#define CBUS_TX_MSC_IRQ_wr_burst_irq_src(data)                                       ((0x00800000&(data))>>23)
+#define CBUS_TX_MSC_IRQ_get_wr_burst_irq(data)                                       ((0x00800000&(data))>>23)
+#define CBUS_TX_MSC_IRQ_sc3_err_irq_shift                                            (22)
+#define CBUS_TX_MSC_IRQ_sc3_err_irq_mask                                             (0x00400000)
+#define CBUS_TX_MSC_IRQ_sc3_err_irq(data)                                            (0x00400000&((data)<<22))
+#define CBUS_TX_MSC_IRQ_sc3_err_irq_src(data)                                        ((0x00400000&(data))>>22)
+#define CBUS_TX_MSC_IRQ_get_sc3_err_irq(data)                                        ((0x00400000&(data))>>22)
+#define CBUS_TX_MSC_IRQ_fwdef_cmd_irq_shift                                          (21)
+#define CBUS_TX_MSC_IRQ_fwdef_cmd_irq_mask                                           (0x00200000)
+#define CBUS_TX_MSC_IRQ_fwdef_cmd_irq(data)                                          (0x00200000&((data)<<21))
+#define CBUS_TX_MSC_IRQ_fwdef_cmd_irq_src(data)                                      ((0x00200000&(data))>>21)
+#define CBUS_TX_MSC_IRQ_get_fwdef_cmd_irq(data)                                      ((0x00200000&(data))>>21)
+#define CBUS_TX_MSC_IRQ_allmsc_cmd_irq_shift                                         (20)
+#define CBUS_TX_MSC_IRQ_allmsc_cmd_irq_mask                                          (0x00100000)
+#define CBUS_TX_MSC_IRQ_allmsc_cmd_irq(data)                                         (0x00100000&((data)<<20))
+#define CBUS_TX_MSC_IRQ_allmsc_cmd_irq_src(data)                                     ((0x00100000&(data))>>20)
+#define CBUS_TX_MSC_IRQ_get_allmsc_cmd_irq(data)                                     ((0x00100000&(data))>>20)
+#define CBUS_TX_MSC_IRQ_abort_res_irq_shift                                          (19)
+#define CBUS_TX_MSC_IRQ_abort_res_irq_mask                                           (0x00080000)
+#define CBUS_TX_MSC_IRQ_abort_res_irq(data)                                          (0x00080000&((data)<<19))
+#define CBUS_TX_MSC_IRQ_abort_res_irq_src(data)                                      ((0x00080000&(data))>>19)
+#define CBUS_TX_MSC_IRQ_get_abort_res_irq(data)                                      ((0x00080000&(data))>>19)
+#define CBUS_TX_MSC_IRQ_abort_req_irq_shift                                          (18)
+#define CBUS_TX_MSC_IRQ_abort_req_irq_mask                                           (0x00040000)
+#define CBUS_TX_MSC_IRQ_abort_req_irq(data)                                          (0x00040000&((data)<<18))
+#define CBUS_TX_MSC_IRQ_abort_req_irq_src(data)                                      ((0x00040000&(data))>>18)
+#define CBUS_TX_MSC_IRQ_get_abort_req_irq(data)                                      ((0x00040000&(data))>>18)
+#define CBUS_TX_MSC_IRQ_ddc_abort_irq_shift                                          (17)
+#define CBUS_TX_MSC_IRQ_ddc_abort_irq_mask                                           (0x00020000)
+#define CBUS_TX_MSC_IRQ_ddc_abort_irq(data)                                          (0x00020000&((data)<<17))
+#define CBUS_TX_MSC_IRQ_ddc_abort_irq_src(data)                                      ((0x00020000&(data))>>17)
+#define CBUS_TX_MSC_IRQ_get_ddc_abort_irq(data)                                      ((0x00020000&(data))>>17)
+#define CBUS_TX_MSC_IRQ_ddc_nack_irq_shift                                           (16)
+#define CBUS_TX_MSC_IRQ_ddc_nack_irq_mask                                            (0x00010000)
+#define CBUS_TX_MSC_IRQ_ddc_nack_irq(data)                                           (0x00010000&((data)<<16))
+#define CBUS_TX_MSC_IRQ_ddc_nack_irq_src(data)                                       ((0x00010000&(data))>>16)
+#define CBUS_TX_MSC_IRQ_get_ddc_nack_irq(data)                                       ((0x00010000&(data))>>16)
+#define CBUS_TX_MSC_IRQ_msge_irq_shift                                               (15)
+#define CBUS_TX_MSC_IRQ_msge_irq_mask                                                (0x00008000)
+#define CBUS_TX_MSC_IRQ_msge_irq(data)                                               (0x00008000&((data)<<15))
+#define CBUS_TX_MSC_IRQ_msge_irq_src(data)                                           ((0x00008000&(data))>>15)
+#define CBUS_TX_MSC_IRQ_get_msge_irq(data)                                           ((0x00008000&(data))>>15)
+#define CBUS_TX_MSC_IRQ_rcp_irq_shift                                                (14)
+#define CBUS_TX_MSC_IRQ_rcp_irq_mask                                                 (0x00004000)
+#define CBUS_TX_MSC_IRQ_rcp_irq(data)                                                (0x00004000&((data)<<14))
+#define CBUS_TX_MSC_IRQ_rcp_irq_src(data)                                            ((0x00004000&(data))>>14)
+#define CBUS_TX_MSC_IRQ_get_rcp_irq(data)                                            ((0x00004000&(data))>>14)
+#define CBUS_TX_MSC_IRQ_rcpk_irq_shift                                               (13)
+#define CBUS_TX_MSC_IRQ_rcpk_irq_mask                                                (0x00002000)
+#define CBUS_TX_MSC_IRQ_rcpk_irq(data)                                               (0x00002000&((data)<<13))
+#define CBUS_TX_MSC_IRQ_rcpk_irq_src(data)                                           ((0x00002000&(data))>>13)
+#define CBUS_TX_MSC_IRQ_get_rcpk_irq(data)                                           ((0x00002000&(data))>>13)
+#define CBUS_TX_MSC_IRQ_rcpe_irq_shift                                               (12)
+#define CBUS_TX_MSC_IRQ_rcpe_irq_mask                                                (0x00001000)
+#define CBUS_TX_MSC_IRQ_rcpe_irq(data)                                               (0x00001000&((data)<<12))
+#define CBUS_TX_MSC_IRQ_rcpe_irq_src(data)                                           ((0x00001000&(data))>>12)
+#define CBUS_TX_MSC_IRQ_get_rcpe_irq(data)                                           ((0x00001000&(data))>>12)
+#define CBUS_TX_MSC_IRQ_rap_irq_shift                                                (11)
+#define CBUS_TX_MSC_IRQ_rap_irq_mask                                                 (0x00000800)
+#define CBUS_TX_MSC_IRQ_rap_irq(data)                                                (0x00000800&((data)<<11))
+#define CBUS_TX_MSC_IRQ_rap_irq_src(data)                                            ((0x00000800&(data))>>11)
+#define CBUS_TX_MSC_IRQ_get_rap_irq(data)                                            ((0x00000800&(data))>>11)
+#define CBUS_TX_MSC_IRQ_rapk_irq_shift                                               (10)
+#define CBUS_TX_MSC_IRQ_rapk_irq_mask                                                (0x00000400)
+#define CBUS_TX_MSC_IRQ_rapk_irq(data)                                               (0x00000400&((data)<<10))
+#define CBUS_TX_MSC_IRQ_rapk_irq_src(data)                                           ((0x00000400&(data))>>10)
+#define CBUS_TX_MSC_IRQ_get_rapk_irq(data)                                           ((0x00000400&(data))>>10)
+#define CBUS_TX_MSC_IRQ_ucp_irq_shift                                                (9)
+#define CBUS_TX_MSC_IRQ_ucp_irq_mask                                                 (0x00000200)
+#define CBUS_TX_MSC_IRQ_ucp_irq(data)                                                (0x00000200&((data)<<9))
+#define CBUS_TX_MSC_IRQ_ucp_irq_src(data)                                            ((0x00000200&(data))>>9)
+#define CBUS_TX_MSC_IRQ_get_ucp_irq(data)                                            ((0x00000200&(data))>>9)
+#define CBUS_TX_MSC_IRQ_ucpe_irq_shift                                               (8)
+#define CBUS_TX_MSC_IRQ_ucpe_irq_mask                                                (0x00000100)
+#define CBUS_TX_MSC_IRQ_ucpe_irq(data)                                               (0x00000100&((data)<<8))
+#define CBUS_TX_MSC_IRQ_ucpe_irq_src(data)                                           ((0x00000100&(data))>>8)
+#define CBUS_TX_MSC_IRQ_get_ucpe_irq(data)                                           ((0x00000100&(data))>>8)
+#define CBUS_TX_MSC_IRQ_ucpk_irq_shift                                               (7)
+#define CBUS_TX_MSC_IRQ_ucpk_irq_mask                                                (0x00000080)
+#define CBUS_TX_MSC_IRQ_ucpk_irq(data)                                               (0x00000080&((data)<<7))
+#define CBUS_TX_MSC_IRQ_ucpk_irq_src(data)                                           ((0x00000080&(data))>>7)
+#define CBUS_TX_MSC_IRQ_get_ucpk_irq(data)                                           ((0x00000080&(data))>>7)
+#define CBUS_TX_MSC_IRQ_msg_sub_irq_shift                                            (6)
+#define CBUS_TX_MSC_IRQ_msg_sub_irq_mask                                             (0x00000040)
+#define CBUS_TX_MSC_IRQ_msg_sub_irq(data)                                            (0x00000040&((data)<<6))
+#define CBUS_TX_MSC_IRQ_msg_sub_irq_src(data)                                        ((0x00000040&(data))>>6)
+#define CBUS_TX_MSC_IRQ_get_msg_sub_irq(data)                                        ((0x00000040&(data))>>6)
+#define CBUS_TX_MSC_IRQ_det_rxsense_irq_shift                                        (5)
+#define CBUS_TX_MSC_IRQ_det_rxsense_irq_mask                                         (0x00000020)
+#define CBUS_TX_MSC_IRQ_det_rxsense_irq(data)                                        (0x00000020&((data)<<5))
+#define CBUS_TX_MSC_IRQ_det_rxsense_irq_src(data)                                    ((0x00000020&(data))>>5)
+#define CBUS_TX_MSC_IRQ_get_det_rxsense_irq(data)                                    ((0x00000020&(data))>>5)
+#define CBUS_TX_MSC_IRQ_msc_hpd_irq_shift                                            (4)
+#define CBUS_TX_MSC_IRQ_msc_hpd_irq_mask                                             (0x00000010)
+#define CBUS_TX_MSC_IRQ_msc_hpd_irq(data)                                            (0x00000010&((data)<<4))
+#define CBUS_TX_MSC_IRQ_msc_hpd_irq_src(data)                                        ((0x00000010&(data))>>4)
+#define CBUS_TX_MSC_IRQ_get_msc_hpd_irq(data)                                        ((0x00000010&(data))>>4)
+
+
+#define CBUS_TX_MSC_IRQ_EN                                                           0x1803705C
+#define CBUS_TX_MSC_IRQ_EN_reg_addr                                                  "0xB803705C"
+#define CBUS_TX_MSC_IRQ_EN_reg                                                       0xB803705C
+#define set_CBUS_TX_MSC_IRQ_EN_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_IRQ_EN_reg)=data)
+#define get_CBUS_TX_MSC_IRQ_EN_reg   (*((volatile unsigned int*) CBUS_TX_MSC_IRQ_EN_reg))
+#define CBUS_TX_MSC_IRQ_EN_inst_adr                                                  "0x0017"
+#define CBUS_TX_MSC_IRQ_EN_inst                                                      0x0017
+#define CBUS_TX_MSC_IRQ_EN_wr_stat_irq_en_shift                                      (31)
+#define CBUS_TX_MSC_IRQ_EN_wr_stat_irq_en_mask                                       (0x80000000)
+#define CBUS_TX_MSC_IRQ_EN_wr_stat_irq_en(data)                                      (0x80000000&((data)<<31))
+#define CBUS_TX_MSC_IRQ_EN_wr_stat_irq_en_src(data)                                  ((0x80000000&(data))>>31)
+#define CBUS_TX_MSC_IRQ_EN_get_wr_stat_irq_en(data)                                  ((0x80000000&(data))>>31)
+#define CBUS_TX_MSC_IRQ_EN_rd_devcap_irq_en_shift                                    (30)
+#define CBUS_TX_MSC_IRQ_EN_rd_devcap_irq_en_mask                                     (0x40000000)
+#define CBUS_TX_MSC_IRQ_EN_rd_devcap_irq_en(data)                                    (0x40000000&((data)<<30))
+#define CBUS_TX_MSC_IRQ_EN_rd_devcap_irq_en_src(data)                                ((0x40000000&(data))>>30)
+#define CBUS_TX_MSC_IRQ_EN_get_rd_devcap_irq_en(data)                                ((0x40000000&(data))>>30)
+#define CBUS_TX_MSC_IRQ_EN_get_stat_irq_en_shift                                     (29)
+#define CBUS_TX_MSC_IRQ_EN_get_stat_irq_en_mask                                      (0x20000000)
+#define CBUS_TX_MSC_IRQ_EN_get_stat_irq_en(data)                                     (0x20000000&((data)<<29))
+#define CBUS_TX_MSC_IRQ_EN_get_stat_irq_en_src(data)                                 ((0x20000000&(data))>>29)
+#define CBUS_TX_MSC_IRQ_EN_get_get_stat_irq_en(data)                                 ((0x20000000&(data))>>29)
+#define CBUS_TX_MSC_IRQ_EN_get_id_irq_en_shift                                       (28)
+#define CBUS_TX_MSC_IRQ_EN_get_id_irq_en_mask                                        (0x10000000)
+#define CBUS_TX_MSC_IRQ_EN_get_id_irq_en(data)                                       (0x10000000&((data)<<28))
+#define CBUS_TX_MSC_IRQ_EN_get_id_irq_en_src(data)                                   ((0x10000000&(data))>>28)
+#define CBUS_TX_MSC_IRQ_EN_get_get_id_irq_en(data)                                   ((0x10000000&(data))>>28)
+#define CBUS_TX_MSC_IRQ_EN_get_msg_irq_en_shift                                      (27)
+#define CBUS_TX_MSC_IRQ_EN_get_msg_irq_en_mask                                       (0x08000000)
+#define CBUS_TX_MSC_IRQ_EN_get_msg_irq_en(data)                                      (0x08000000&((data)<<27))
+#define CBUS_TX_MSC_IRQ_EN_get_msg_irq_en_src(data)                                  ((0x08000000&(data))>>27)
+#define CBUS_TX_MSC_IRQ_EN_get_get_msg_irq_en(data)                                  ((0x08000000&(data))>>27)
+#define CBUS_TX_MSC_IRQ_EN_sc1_err_irq_en_shift                                      (26)
+#define CBUS_TX_MSC_IRQ_EN_sc1_err_irq_en_mask                                       (0x04000000)
+#define CBUS_TX_MSC_IRQ_EN_sc1_err_irq_en(data)                                      (0x04000000&((data)<<26))
+#define CBUS_TX_MSC_IRQ_EN_sc1_err_irq_en_src(data)                                  ((0x04000000&(data))>>26)
+#define CBUS_TX_MSC_IRQ_EN_get_sc1_err_irq_en(data)                                  ((0x04000000&(data))>>26)
+#define CBUS_TX_MSC_IRQ_EN_ddc_err_irq_en_shift                                      (25)
+#define CBUS_TX_MSC_IRQ_EN_ddc_err_irq_en_mask                                       (0x02000000)
+#define CBUS_TX_MSC_IRQ_EN_ddc_err_irq_en(data)                                      (0x02000000&((data)<<25))
+#define CBUS_TX_MSC_IRQ_EN_ddc_err_irq_en_src(data)                                  ((0x02000000&(data))>>25)
+#define CBUS_TX_MSC_IRQ_EN_get_ddc_err_irq_en(data)                                  ((0x02000000&(data))>>25)
+#define CBUS_TX_MSC_IRQ_EN_msc_err_irq_en_shift                                      (24)
+#define CBUS_TX_MSC_IRQ_EN_msc_err_irq_en_mask                                       (0x01000000)
+#define CBUS_TX_MSC_IRQ_EN_msc_err_irq_en(data)                                      (0x01000000&((data)<<24))
+#define CBUS_TX_MSC_IRQ_EN_msc_err_irq_en_src(data)                                  ((0x01000000&(data))>>24)
+#define CBUS_TX_MSC_IRQ_EN_get_msc_err_irq_en(data)                                  ((0x01000000&(data))>>24)
+#define CBUS_TX_MSC_IRQ_EN_wr_burst_irq_en_shift                                     (23)
+#define CBUS_TX_MSC_IRQ_EN_wr_burst_irq_en_mask                                      (0x00800000)
+#define CBUS_TX_MSC_IRQ_EN_wr_burst_irq_en(data)                                     (0x00800000&((data)<<23))
+#define CBUS_TX_MSC_IRQ_EN_wr_burst_irq_en_src(data)                                 ((0x00800000&(data))>>23)
+#define CBUS_TX_MSC_IRQ_EN_get_wr_burst_irq_en(data)                                 ((0x00800000&(data))>>23)
+#define CBUS_TX_MSC_IRQ_EN_sc3_err_irq_en_shift                                      (22)
+#define CBUS_TX_MSC_IRQ_EN_sc3_err_irq_en_mask                                       (0x00400000)
+#define CBUS_TX_MSC_IRQ_EN_sc3_err_irq_en(data)                                      (0x00400000&((data)<<22))
+#define CBUS_TX_MSC_IRQ_EN_sc3_err_irq_en_src(data)                                  ((0x00400000&(data))>>22)
+#define CBUS_TX_MSC_IRQ_EN_get_sc3_err_irq_en(data)                                  ((0x00400000&(data))>>22)
+#define CBUS_TX_MSC_IRQ_EN_fwdef_cmd_irq_en_shift                                    (21)
+#define CBUS_TX_MSC_IRQ_EN_fwdef_cmd_irq_en_mask                                     (0x00200000)
+#define CBUS_TX_MSC_IRQ_EN_fwdef_cmd_irq_en(data)                                    (0x00200000&((data)<<21))
+#define CBUS_TX_MSC_IRQ_EN_fwdef_cmd_irq_en_src(data)                                ((0x00200000&(data))>>21)
+#define CBUS_TX_MSC_IRQ_EN_get_fwdef_cmd_irq_en(data)                                ((0x00200000&(data))>>21)
+#define CBUS_TX_MSC_IRQ_EN_allmsc_cmd_irq_en_shift                                   (20)
+#define CBUS_TX_MSC_IRQ_EN_allmsc_cmd_irq_en_mask                                    (0x00100000)
+#define CBUS_TX_MSC_IRQ_EN_allmsc_cmd_irq_en(data)                                   (0x00100000&((data)<<20))
+#define CBUS_TX_MSC_IRQ_EN_allmsc_cmd_irq_en_src(data)                               ((0x00100000&(data))>>20)
+#define CBUS_TX_MSC_IRQ_EN_get_allmsc_cmd_irq_en(data)                               ((0x00100000&(data))>>20)
+#define CBUS_TX_MSC_IRQ_EN_abort_res_irq_en_shift                                    (19)
+#define CBUS_TX_MSC_IRQ_EN_abort_res_irq_en_mask                                     (0x00080000)
+#define CBUS_TX_MSC_IRQ_EN_abort_res_irq_en(data)                                    (0x00080000&((data)<<19))
+#define CBUS_TX_MSC_IRQ_EN_abort_res_irq_en_src(data)                                ((0x00080000&(data))>>19)
+#define CBUS_TX_MSC_IRQ_EN_get_abort_res_irq_en(data)                                ((0x00080000&(data))>>19)
+#define CBUS_TX_MSC_IRQ_EN_abort_req_irq_en_shift                                    (18)
+#define CBUS_TX_MSC_IRQ_EN_abort_req_irq_en_mask                                     (0x00040000)
+#define CBUS_TX_MSC_IRQ_EN_abort_req_irq_en(data)                                    (0x00040000&((data)<<18))
+#define CBUS_TX_MSC_IRQ_EN_abort_req_irq_en_src(data)                                ((0x00040000&(data))>>18)
+#define CBUS_TX_MSC_IRQ_EN_get_abort_req_irq_en(data)                                ((0x00040000&(data))>>18)
+#define CBUS_TX_MSC_IRQ_EN_ddc_abort_irq_en_shift                                    (17)
+#define CBUS_TX_MSC_IRQ_EN_ddc_abort_irq_en_mask                                     (0x00020000)
+#define CBUS_TX_MSC_IRQ_EN_ddc_abort_irq_en(data)                                    (0x00020000&((data)<<17))
+#define CBUS_TX_MSC_IRQ_EN_ddc_abort_irq_en_src(data)                                ((0x00020000&(data))>>17)
+#define CBUS_TX_MSC_IRQ_EN_get_ddc_abort_irq_en(data)                                ((0x00020000&(data))>>17)
+#define CBUS_TX_MSC_IRQ_EN_ddc_nack_irq_en_shift                                     (16)
+#define CBUS_TX_MSC_IRQ_EN_ddc_nack_irq_en_mask                                      (0x00010000)
+#define CBUS_TX_MSC_IRQ_EN_ddc_nack_irq_en(data)                                     (0x00010000&((data)<<16))
+#define CBUS_TX_MSC_IRQ_EN_ddc_nack_irq_en_src(data)                                 ((0x00010000&(data))>>16)
+#define CBUS_TX_MSC_IRQ_EN_get_ddc_nack_irq_en(data)                                 ((0x00010000&(data))>>16)
+#define CBUS_TX_MSC_IRQ_EN_msge_irq_en_shift                                         (15)
+#define CBUS_TX_MSC_IRQ_EN_msge_irq_en_mask                                          (0x00008000)
+#define CBUS_TX_MSC_IRQ_EN_msge_irq_en(data)                                         (0x00008000&((data)<<15))
+#define CBUS_TX_MSC_IRQ_EN_msge_irq_en_src(data)                                     ((0x00008000&(data))>>15)
+#define CBUS_TX_MSC_IRQ_EN_get_msge_irq_en(data)                                     ((0x00008000&(data))>>15)
+#define CBUS_TX_MSC_IRQ_EN_rcp_irq_en_shift                                          (14)
+#define CBUS_TX_MSC_IRQ_EN_rcp_irq_en_mask                                           (0x00004000)
+#define CBUS_TX_MSC_IRQ_EN_rcp_irq_en(data)                                          (0x00004000&((data)<<14))
+#define CBUS_TX_MSC_IRQ_EN_rcp_irq_en_src(data)                                      ((0x00004000&(data))>>14)
+#define CBUS_TX_MSC_IRQ_EN_get_rcp_irq_en(data)                                      ((0x00004000&(data))>>14)
+#define CBUS_TX_MSC_IRQ_EN_rcpk_irq_en_shift                                         (13)
+#define CBUS_TX_MSC_IRQ_EN_rcpk_irq_en_mask                                          (0x00002000)
+#define CBUS_TX_MSC_IRQ_EN_rcpk_irq_en(data)                                         (0x00002000&((data)<<13))
+#define CBUS_TX_MSC_IRQ_EN_rcpk_irq_en_src(data)                                     ((0x00002000&(data))>>13)
+#define CBUS_TX_MSC_IRQ_EN_get_rcpk_irq_en(data)                                     ((0x00002000&(data))>>13)
+#define CBUS_TX_MSC_IRQ_EN_rcpe_irq_en_shift                                         (12)
+#define CBUS_TX_MSC_IRQ_EN_rcpe_irq_en_mask                                          (0x00001000)
+#define CBUS_TX_MSC_IRQ_EN_rcpe_irq_en(data)                                         (0x00001000&((data)<<12))
+#define CBUS_TX_MSC_IRQ_EN_rcpe_irq_en_src(data)                                     ((0x00001000&(data))>>12)
+#define CBUS_TX_MSC_IRQ_EN_get_rcpe_irq_en(data)                                     ((0x00001000&(data))>>12)
+#define CBUS_TX_MSC_IRQ_EN_rap_irq_en_shift                                          (11)
+#define CBUS_TX_MSC_IRQ_EN_rap_irq_en_mask                                           (0x00000800)
+#define CBUS_TX_MSC_IRQ_EN_rap_irq_en(data)                                          (0x00000800&((data)<<11))
+#define CBUS_TX_MSC_IRQ_EN_rap_irq_en_src(data)                                      ((0x00000800&(data))>>11)
+#define CBUS_TX_MSC_IRQ_EN_get_rap_irq_en(data)                                      ((0x00000800&(data))>>11)
+#define CBUS_TX_MSC_IRQ_EN_rapk_irq_en_shift                                         (10)
+#define CBUS_TX_MSC_IRQ_EN_rapk_irq_en_mask                                          (0x00000400)
+#define CBUS_TX_MSC_IRQ_EN_rapk_irq_en(data)                                         (0x00000400&((data)<<10))
+#define CBUS_TX_MSC_IRQ_EN_rapk_irq_en_src(data)                                     ((0x00000400&(data))>>10)
+#define CBUS_TX_MSC_IRQ_EN_get_rapk_irq_en(data)                                     ((0x00000400&(data))>>10)
+#define CBUS_TX_MSC_IRQ_EN_ucp_irq_en_shift                                          (9)
+#define CBUS_TX_MSC_IRQ_EN_ucp_irq_en_mask                                           (0x00000200)
+#define CBUS_TX_MSC_IRQ_EN_ucp_irq_en(data)                                          (0x00000200&((data)<<9))
+#define CBUS_TX_MSC_IRQ_EN_ucp_irq_en_src(data)                                      ((0x00000200&(data))>>9)
+#define CBUS_TX_MSC_IRQ_EN_get_ucp_irq_en(data)                                      ((0x00000200&(data))>>9)
+#define CBUS_TX_MSC_IRQ_EN_ucpe_irq_en_shift                                         (8)
+#define CBUS_TX_MSC_IRQ_EN_ucpe_irq_en_mask                                          (0x00000100)
+#define CBUS_TX_MSC_IRQ_EN_ucpe_irq_en(data)                                         (0x00000100&((data)<<8))
+#define CBUS_TX_MSC_IRQ_EN_ucpe_irq_en_src(data)                                     ((0x00000100&(data))>>8)
+#define CBUS_TX_MSC_IRQ_EN_get_ucpe_irq_en(data)                                     ((0x00000100&(data))>>8)
+#define CBUS_TX_MSC_IRQ_EN_ucpk_irq_en_shift                                         (7)
+#define CBUS_TX_MSC_IRQ_EN_ucpk_irq_en_mask                                          (0x00000080)
+#define CBUS_TX_MSC_IRQ_EN_ucpk_irq_en(data)                                         (0x00000080&((data)<<7))
+#define CBUS_TX_MSC_IRQ_EN_ucpk_irq_en_src(data)                                     ((0x00000080&(data))>>7)
+#define CBUS_TX_MSC_IRQ_EN_get_ucpk_irq_en(data)                                     ((0x00000080&(data))>>7)
+#define CBUS_TX_MSC_IRQ_EN_msg_sub_irq_en_shift                                      (6)
+#define CBUS_TX_MSC_IRQ_EN_msg_sub_irq_en_mask                                       (0x00000040)
+#define CBUS_TX_MSC_IRQ_EN_msg_sub_irq_en(data)                                      (0x00000040&((data)<<6))
+#define CBUS_TX_MSC_IRQ_EN_msg_sub_irq_en_src(data)                                  ((0x00000040&(data))>>6)
+#define CBUS_TX_MSC_IRQ_EN_get_msg_sub_irq_en(data)                                  ((0x00000040&(data))>>6)
+#define CBUS_TX_MSC_IRQ_EN_det_rxsense_irq_en_shift                                  (5)
+#define CBUS_TX_MSC_IRQ_EN_det_rxsense_irq_en_mask                                   (0x00000020)
+#define CBUS_TX_MSC_IRQ_EN_det_rxsense_irq_en(data)                                  (0x00000020&((data)<<5))
+#define CBUS_TX_MSC_IRQ_EN_det_rxsense_irq_en_src(data)                              ((0x00000020&(data))>>5)
+#define CBUS_TX_MSC_IRQ_EN_get_det_rxsense_irq_en(data)                              ((0x00000020&(data))>>5)
+#define CBUS_TX_MSC_IRQ_EN_msc_hpd_irq_en_shift                                      (4)
+#define CBUS_TX_MSC_IRQ_EN_msc_hpd_irq_en_mask                                       (0x00000010)
+#define CBUS_TX_MSC_IRQ_EN_msc_hpd_irq_en(data)                                      (0x00000010&((data)<<4))
+#define CBUS_TX_MSC_IRQ_EN_msc_hpd_irq_en_src(data)                                  ((0x00000010&(data))>>4)
+#define CBUS_TX_MSC_IRQ_EN_get_msc_hpd_irq_en(data)                                  ((0x00000010&(data))>>4)
+
+
+#define CBUS_TX_CBUS_TX_INT                                                          0x18037090
+#define CBUS_TX_CBUS_TX_INT_reg_addr                                                 "0xB8037090"
+#define CBUS_TX_CBUS_TX_INT_reg                                                      0xB8037090
+#define set_CBUS_TX_CBUS_TX_INT_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_TX_INT_reg)=data)
+#define get_CBUS_TX_CBUS_TX_INT_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_TX_INT_reg))
+#define CBUS_TX_CBUS_TX_INT_inst_adr                                                 "0x0024"
+#define CBUS_TX_CBUS_TX_INT_inst                                                     0x0024
+#define CBUS_TX_CBUS_TX_INT_fw0_fin_irq_en_shift                                     (31)
+#define CBUS_TX_CBUS_TX_INT_fw0_fin_irq_en_mask                                      (0x80000000)
+#define CBUS_TX_CBUS_TX_INT_fw0_fin_irq_en(data)                                     (0x80000000&((data)<<31))
+#define CBUS_TX_CBUS_TX_INT_fw0_fin_irq_en_src(data)                                 ((0x80000000&(data))>>31)
+#define CBUS_TX_CBUS_TX_INT_get_fw0_fin_irq_en(data)                                 ((0x80000000&(data))>>31)
+#define CBUS_TX_CBUS_TX_INT_fw0_cmd_irq_en_shift                                     (30)
+#define CBUS_TX_CBUS_TX_INT_fw0_cmd_irq_en_mask                                      (0x40000000)
+#define CBUS_TX_CBUS_TX_INT_fw0_cmd_irq_en(data)                                     (0x40000000&((data)<<30))
+#define CBUS_TX_CBUS_TX_INT_fw0_cmd_irq_en_src(data)                                 ((0x40000000&(data))>>30)
+#define CBUS_TX_CBUS_TX_INT_get_fw0_cmd_irq_en(data)                                 ((0x40000000&(data))>>30)
+#define CBUS_TX_CBUS_TX_INT_fw0_data_irq_en_shift                                    (29)
+#define CBUS_TX_CBUS_TX_INT_fw0_data_irq_en_mask                                     (0x20000000)
+#define CBUS_TX_CBUS_TX_INT_fw0_data_irq_en(data)                                    (0x20000000&((data)<<29))
+#define CBUS_TX_CBUS_TX_INT_fw0_data_irq_en_src(data)                                ((0x20000000&(data))>>29)
+#define CBUS_TX_CBUS_TX_INT_get_fw0_data_irq_en(data)                                ((0x20000000&(data))>>29)
+#define CBUS_TX_CBUS_TX_INT_ddc_fin_irq_en_shift                                     (23)
+#define CBUS_TX_CBUS_TX_INT_ddc_fin_irq_en_mask                                      (0x00800000)
+#define CBUS_TX_CBUS_TX_INT_ddc_fin_irq_en(data)                                     (0x00800000&((data)<<23))
+#define CBUS_TX_CBUS_TX_INT_ddc_fin_irq_en_src(data)                                 ((0x00800000&(data))>>23)
+#define CBUS_TX_CBUS_TX_INT_get_ddc_fin_irq_en(data)                                 ((0x00800000&(data))>>23)
+#define CBUS_TX_CBUS_TX_INT_clk_mode_irq_en_shift                                    (15)
+#define CBUS_TX_CBUS_TX_INT_clk_mode_irq_en_mask                                     (0x00008000)
+#define CBUS_TX_CBUS_TX_INT_clk_mode_irq_en(data)                                    (0x00008000&((data)<<15))
+#define CBUS_TX_CBUS_TX_INT_clk_mode_irq_en_src(data)                                ((0x00008000&(data))>>15)
+#define CBUS_TX_CBUS_TX_INT_get_clk_mode_irq_en(data)                                ((0x00008000&(data))>>15)
+#define CBUS_TX_CBUS_TX_INT_dcap_rdy_irq_en_shift                                    (14)
+#define CBUS_TX_CBUS_TX_INT_dcap_rdy_irq_en_mask                                     (0x00004000)
+#define CBUS_TX_CBUS_TX_INT_dcap_rdy_irq_en(data)                                    (0x00004000&((data)<<14))
+#define CBUS_TX_CBUS_TX_INT_dcap_rdy_irq_en_src(data)                                ((0x00004000&(data))>>14)
+#define CBUS_TX_CBUS_TX_INT_get_dcap_rdy_irq_en(data)                                ((0x00004000&(data))>>14)
+#define CBUS_TX_CBUS_TX_INT_muted_chg_irq_en_shift                                   (13)
+#define CBUS_TX_CBUS_TX_INT_muted_chg_irq_en_mask                                    (0x00002000)
+#define CBUS_TX_CBUS_TX_INT_muted_chg_irq_en(data)                                   (0x00002000&((data)<<13))
+#define CBUS_TX_CBUS_TX_INT_muted_chg_irq_en_src(data)                               ((0x00002000&(data))>>13)
+#define CBUS_TX_CBUS_TX_INT_get_muted_chg_irq_en(data)                               ((0x00002000&(data))>>13)
+#define CBUS_TX_CBUS_TX_INT_path_en_irq_en_shift                                     (12)
+#define CBUS_TX_CBUS_TX_INT_path_en_irq_en_mask                                      (0x00001000)
+#define CBUS_TX_CBUS_TX_INT_path_en_irq_en(data)                                     (0x00001000&((data)<<12))
+#define CBUS_TX_CBUS_TX_INT_path_en_irq_en_src(data)                                 ((0x00001000&(data))>>12)
+#define CBUS_TX_CBUS_TX_INT_get_path_en_irq_en(data)                                 ((0x00001000&(data))>>12)
+#define CBUS_TX_CBUS_TX_INT_det_z1k_irq_en_shift                                     (11)
+#define CBUS_TX_CBUS_TX_INT_det_z1k_irq_en_mask                                      (0x00000800)
+#define CBUS_TX_CBUS_TX_INT_det_z1k_irq_en(data)                                     (0x00000800&((data)<<11))
+#define CBUS_TX_CBUS_TX_INT_det_z1k_irq_en_src(data)                                 ((0x00000800&(data))>>11)
+#define CBUS_TX_CBUS_TX_INT_get_det_z1k_irq_en(data)                                 ((0x00000800&(data))>>11)
+#define CBUS_TX_CBUS_TX_INT_sink_det_irq_en_shift                                    (10)
+#define CBUS_TX_CBUS_TX_INT_sink_det_irq_en_mask                                     (0x00000400)
+#define CBUS_TX_CBUS_TX_INT_sink_det_irq_en(data)                                    (0x00000400&((data)<<10))
+#define CBUS_TX_CBUS_TX_INT_sink_det_irq_en_src(data)                                ((0x00000400&(data))>>10)
+#define CBUS_TX_CBUS_TX_INT_get_sink_det_irq_en(data)                                ((0x00000400&(data))>>10)
+#define CBUS_TX_CBUS_TX_INT_parity_err_irq_en_shift                                  (9)
+#define CBUS_TX_CBUS_TX_INT_parity_err_irq_en_mask                                   (0x00000200)
+#define CBUS_TX_CBUS_TX_INT_parity_err_irq_en(data)                                  (0x00000200&((data)<<9))
+#define CBUS_TX_CBUS_TX_INT_parity_err_irq_en_src(data)                              ((0x00000200&(data))>>9)
+#define CBUS_TX_CBUS_TX_INT_get_parity_err_irq_en(data)                              ((0x00000200&(data))>>9)
+#define CBUS_TX_CBUS_TX_INT_disconn_irq_en_shift                                     (8)
+#define CBUS_TX_CBUS_TX_INT_disconn_irq_en_mask                                      (0x00000100)
+#define CBUS_TX_CBUS_TX_INT_disconn_irq_en(data)                                     (0x00000100&((data)<<8))
+#define CBUS_TX_CBUS_TX_INT_disconn_irq_en_src(data)                                 ((0x00000100&(data))>>8)
+#define CBUS_TX_CBUS_TX_INT_get_disconn_irq_en(data)                                 ((0x00000100&(data))>>8)
+#define CBUS_TX_CBUS_TX_INT_det_hpd_irq_en_shift                                     (7)
+#define CBUS_TX_CBUS_TX_INT_det_hpd_irq_en_mask                                      (0x00000080)
+#define CBUS_TX_CBUS_TX_INT_det_hpd_irq_en(data)                                     (0x00000080&((data)<<7))
+#define CBUS_TX_CBUS_TX_INT_det_hpd_irq_en_src(data)                                 ((0x00000080&(data))>>7)
+#define CBUS_TX_CBUS_TX_INT_get_det_hpd_irq_en(data)                                 ((0x00000080&(data))>>7)
+
+
+#define CBUS_TX_CBUS_TX_INT1                                                         0x18037094
+#define CBUS_TX_CBUS_TX_INT1_reg_addr                                                "0xB8037094"
+#define CBUS_TX_CBUS_TX_INT1_reg                                                     0xB8037094
+#define set_CBUS_TX_CBUS_TX_INT1_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_TX_INT1_reg)=data)
+#define get_CBUS_TX_CBUS_TX_INT1_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_TX_INT1_reg))
+#define CBUS_TX_CBUS_TX_INT1_inst_adr                                                "0x0025"
+#define CBUS_TX_CBUS_TX_INT1_inst                                                    0x0025
+#define CBUS_TX_CBUS_TX_INT1_fw0_fin_irq_shift                                       (31)
+#define CBUS_TX_CBUS_TX_INT1_fw0_fin_irq_mask                                        (0x80000000)
+#define CBUS_TX_CBUS_TX_INT1_fw0_fin_irq(data)                                       (0x80000000&((data)<<31))
+#define CBUS_TX_CBUS_TX_INT1_fw0_fin_irq_src(data)                                   ((0x80000000&(data))>>31)
+#define CBUS_TX_CBUS_TX_INT1_get_fw0_fin_irq(data)                                   ((0x80000000&(data))>>31)
+#define CBUS_TX_CBUS_TX_INT1_fw0_cmd_irq_shift                                       (30)
+#define CBUS_TX_CBUS_TX_INT1_fw0_cmd_irq_mask                                        (0x40000000)
+#define CBUS_TX_CBUS_TX_INT1_fw0_cmd_irq(data)                                       (0x40000000&((data)<<30))
+#define CBUS_TX_CBUS_TX_INT1_fw0_cmd_irq_src(data)                                   ((0x40000000&(data))>>30)
+#define CBUS_TX_CBUS_TX_INT1_get_fw0_cmd_irq(data)                                   ((0x40000000&(data))>>30)
+#define CBUS_TX_CBUS_TX_INT1_fw0_data_irq_shift                                      (29)
+#define CBUS_TX_CBUS_TX_INT1_fw0_data_irq_mask                                       (0x20000000)
+#define CBUS_TX_CBUS_TX_INT1_fw0_data_irq(data)                                      (0x20000000&((data)<<29))
+#define CBUS_TX_CBUS_TX_INT1_fw0_data_irq_src(data)                                  ((0x20000000&(data))>>29)
+#define CBUS_TX_CBUS_TX_INT1_get_fw0_data_irq(data)                                  ((0x20000000&(data))>>29)
+#define CBUS_TX_CBUS_TX_INT1_ddc_fin_irq_shift                                       (23)
+#define CBUS_TX_CBUS_TX_INT1_ddc_fin_irq_mask                                        (0x00800000)
+#define CBUS_TX_CBUS_TX_INT1_ddc_fin_irq(data)                                       (0x00800000&((data)<<23))
+#define CBUS_TX_CBUS_TX_INT1_ddc_fin_irq_src(data)                                   ((0x00800000&(data))>>23)
+#define CBUS_TX_CBUS_TX_INT1_get_ddc_fin_irq(data)                                   ((0x00800000&(data))>>23)
+#define CBUS_TX_CBUS_TX_INT1_clk_mode_chg_shift                                      (15)
+#define CBUS_TX_CBUS_TX_INT1_clk_mode_chg_mask                                       (0x00008000)
+#define CBUS_TX_CBUS_TX_INT1_clk_mode_chg(data)                                      (0x00008000&((data)<<15))
+#define CBUS_TX_CBUS_TX_INT1_clk_mode_chg_src(data)                                  ((0x00008000&(data))>>15)
+#define CBUS_TX_CBUS_TX_INT1_get_clk_mode_chg(data)                                  ((0x00008000&(data))>>15)
+#define CBUS_TX_CBUS_TX_INT1_dcap_rdy_chg_shift                                      (14)
+#define CBUS_TX_CBUS_TX_INT1_dcap_rdy_chg_mask                                       (0x00004000)
+#define CBUS_TX_CBUS_TX_INT1_dcap_rdy_chg(data)                                      (0x00004000&((data)<<14))
+#define CBUS_TX_CBUS_TX_INT1_dcap_rdy_chg_src(data)                                  ((0x00004000&(data))>>14)
+#define CBUS_TX_CBUS_TX_INT1_get_dcap_rdy_chg(data)                                  ((0x00004000&(data))>>14)
+#define CBUS_TX_CBUS_TX_INT1_muted_chg_shift                                         (13)
+#define CBUS_TX_CBUS_TX_INT1_muted_chg_mask                                          (0x00002000)
+#define CBUS_TX_CBUS_TX_INT1_muted_chg(data)                                         (0x00002000&((data)<<13))
+#define CBUS_TX_CBUS_TX_INT1_muted_chg_src(data)                                     ((0x00002000&(data))>>13)
+#define CBUS_TX_CBUS_TX_INT1_get_muted_chg(data)                                     ((0x00002000&(data))>>13)
+#define CBUS_TX_CBUS_TX_INT1_path_en_chg_shift                                       (12)
+#define CBUS_TX_CBUS_TX_INT1_path_en_chg_mask                                        (0x00001000)
+#define CBUS_TX_CBUS_TX_INT1_path_en_chg(data)                                       (0x00001000&((data)<<12))
+#define CBUS_TX_CBUS_TX_INT1_path_en_chg_src(data)                                   ((0x00001000&(data))>>12)
+#define CBUS_TX_CBUS_TX_INT1_get_path_en_chg(data)                                   ((0x00001000&(data))>>12)
+#define CBUS_TX_CBUS_TX_INT1_det_z1k_irq_shift                                       (11)
+#define CBUS_TX_CBUS_TX_INT1_det_z1k_irq_mask                                        (0x00000800)
+#define CBUS_TX_CBUS_TX_INT1_det_z1k_irq(data)                                       (0x00000800&((data)<<11))
+#define CBUS_TX_CBUS_TX_INT1_det_z1k_irq_src(data)                                   ((0x00000800&(data))>>11)
+#define CBUS_TX_CBUS_TX_INT1_get_det_z1k_irq(data)                                   ((0x00000800&(data))>>11)
+#define CBUS_TX_CBUS_TX_INT1_sink_det_irq_shift                                      (10)
+#define CBUS_TX_CBUS_TX_INT1_sink_det_irq_mask                                       (0x00000400)
+#define CBUS_TX_CBUS_TX_INT1_sink_det_irq(data)                                      (0x00000400&((data)<<10))
+#define CBUS_TX_CBUS_TX_INT1_sink_det_irq_src(data)                                  ((0x00000400&(data))>>10)
+#define CBUS_TX_CBUS_TX_INT1_get_sink_det_irq(data)                                  ((0x00000400&(data))>>10)
+#define CBUS_TX_CBUS_TX_INT1_parity_err_irq_shift                                    (9)
+#define CBUS_TX_CBUS_TX_INT1_parity_err_irq_mask                                     (0x00000200)
+#define CBUS_TX_CBUS_TX_INT1_parity_err_irq(data)                                    (0x00000200&((data)<<9))
+#define CBUS_TX_CBUS_TX_INT1_parity_err_irq_src(data)                                ((0x00000200&(data))>>9)
+#define CBUS_TX_CBUS_TX_INT1_get_parity_err_irq(data)                                ((0x00000200&(data))>>9)
+#define CBUS_TX_CBUS_TX_INT1_disconn_irq_shift                                       (8)
+#define CBUS_TX_CBUS_TX_INT1_disconn_irq_mask                                        (0x00000100)
+#define CBUS_TX_CBUS_TX_INT1_disconn_irq(data)                                       (0x00000100&((data)<<8))
+#define CBUS_TX_CBUS_TX_INT1_disconn_irq_src(data)                                   ((0x00000100&(data))>>8)
+#define CBUS_TX_CBUS_TX_INT1_get_disconn_irq(data)                                   ((0x00000100&(data))>>8)
+#define CBUS_TX_CBUS_TX_INT1_det_hpd_irq_shift                                       (7)
+#define CBUS_TX_CBUS_TX_INT1_det_hpd_irq_mask                                        (0x00000080)
+#define CBUS_TX_CBUS_TX_INT1_det_hpd_irq(data)                                       (0x00000080&((data)<<7))
+#define CBUS_TX_CBUS_TX_INT1_det_hpd_irq_src(data)                                   ((0x00000080&(data))>>7)
+#define CBUS_TX_CBUS_TX_INT1_get_det_hpd_irq(data)                                   ((0x00000080&(data))>>7)
+
+
+#define CBUS_TX_DEVCAP_INT_EN                                                        0x180370A8
+#define CBUS_TX_DEVCAP_INT_EN_reg_addr                                               "0xB80370A8"
+#define CBUS_TX_DEVCAP_INT_EN_reg                                                    0xB80370A8
+#define set_CBUS_TX_DEVCAP_INT_EN_reg(data)   (*((volatile unsigned int*) CBUS_TX_DEVCAP_INT_EN_reg)=data)
+#define get_CBUS_TX_DEVCAP_INT_EN_reg   (*((volatile unsigned int*) CBUS_TX_DEVCAP_INT_EN_reg))
+#define CBUS_TX_DEVCAP_INT_EN_inst_adr                                               "0x002A"
+#define CBUS_TX_DEVCAP_INT_EN_inst                                                   0x002A
+#define CBUS_TX_DEVCAP_INT_EN_chg23_irq_en_shift                                     (24)
+#define CBUS_TX_DEVCAP_INT_EN_chg23_irq_en_mask                                      (0xFF000000)
+#define CBUS_TX_DEVCAP_INT_EN_chg23_irq_en(data)                                     (0xFF000000&((data)<<24))
+#define CBUS_TX_DEVCAP_INT_EN_chg23_irq_en_src(data)                                 ((0xFF000000&(data))>>24)
+#define CBUS_TX_DEVCAP_INT_EN_get_chg23_irq_en(data)                                 ((0xFF000000&(data))>>24)
+#define CBUS_TX_DEVCAP_INT_EN_chg22_irq_en_shift                                     (16)
+#define CBUS_TX_DEVCAP_INT_EN_chg22_irq_en_mask                                      (0x00FF0000)
+#define CBUS_TX_DEVCAP_INT_EN_chg22_irq_en(data)                                     (0x00FF0000&((data)<<16))
+#define CBUS_TX_DEVCAP_INT_EN_chg22_irq_en_src(data)                                 ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DEVCAP_INT_EN_get_chg22_irq_en(data)                                 ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit7_irq_en_shift                                 (15)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit7_irq_en_mask                                  (0x00008000)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit7_irq_en(data)                                 (0x00008000&((data)<<15))
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit7_irq_en_src(data)                             ((0x00008000&(data))>>15)
+#define CBUS_TX_DEVCAP_INT_EN_get_dchg_bit7_irq_en(data)                             ((0x00008000&(data))>>15)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit6_irq_en_shift                                 (14)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit6_irq_en_mask                                  (0x00004000)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit6_irq_en(data)                                 (0x00004000&((data)<<14))
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit6_irq_en_src(data)                             ((0x00004000&(data))>>14)
+#define CBUS_TX_DEVCAP_INT_EN_get_dchg_bit6_irq_en(data)                             ((0x00004000&(data))>>14)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit5_irq_en_shift                                 (13)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit5_irq_en_mask                                  (0x00002000)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit5_irq_en(data)                                 (0x00002000&((data)<<13))
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit5_irq_en_src(data)                             ((0x00002000&(data))>>13)
+#define CBUS_TX_DEVCAP_INT_EN_get_dchg_bit5_irq_en(data)                             ((0x00002000&(data))>>13)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit4_irq_en_shift                                 (12)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit4_irq_en_mask                                  (0x00001000)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit4_irq_en(data)                                 (0x00001000&((data)<<12))
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit4_irq_en_src(data)                             ((0x00001000&(data))>>12)
+#define CBUS_TX_DEVCAP_INT_EN_get_dchg_bit4_irq_en(data)                             ((0x00001000&(data))>>12)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit3_irq_en_shift                                 (11)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit3_irq_en_mask                                  (0x00000800)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit3_irq_en(data)                                 (0x00000800&((data)<<11))
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit3_irq_en_src(data)                             ((0x00000800&(data))>>11)
+#define CBUS_TX_DEVCAP_INT_EN_get_dchg_bit3_irq_en(data)                             ((0x00000800&(data))>>11)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit2_irq_en_shift                                 (10)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit2_irq_en_mask                                  (0x00000400)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit2_irq_en(data)                                 (0x00000400&((data)<<10))
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit2_irq_en_src(data)                             ((0x00000400&(data))>>10)
+#define CBUS_TX_DEVCAP_INT_EN_get_dchg_bit2_irq_en(data)                             ((0x00000400&(data))>>10)
+#define CBUS_TX_DEVCAP_INT_EN_edid_irq_en_shift                                      (9)
+#define CBUS_TX_DEVCAP_INT_EN_edid_irq_en_mask                                       (0x00000200)
+#define CBUS_TX_DEVCAP_INT_EN_edid_irq_en(data)                                      (0x00000200&((data)<<9))
+#define CBUS_TX_DEVCAP_INT_EN_edid_irq_en_src(data)                                  ((0x00000200&(data))>>9)
+#define CBUS_TX_DEVCAP_INT_EN_get_edid_irq_en(data)                                  ((0x00000200&(data))>>9)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit0_irq_en_shift                                 (8)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit0_irq_en_mask                                  (0x00000100)
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit0_irq_en(data)                                 (0x00000100&((data)<<8))
+#define CBUS_TX_DEVCAP_INT_EN_dchg_bit0_irq_en_src(data)                             ((0x00000100&(data))>>8)
+#define CBUS_TX_DEVCAP_INT_EN_get_dchg_bit0_irq_en(data)                             ((0x00000100&(data))>>8)
+#define CBUS_TX_DEVCAP_INT_EN_rchg_irq_en_shift                                      (5)
+#define CBUS_TX_DEVCAP_INT_EN_rchg_irq_en_mask                                       (0x000000E0)
+#define CBUS_TX_DEVCAP_INT_EN_rchg_irq_en(data)                                      (0x000000E0&((data)<<5))
+#define CBUS_TX_DEVCAP_INT_EN_rchg_irq_en_src(data)                                  ((0x000000E0&(data))>>5)
+#define CBUS_TX_DEVCAP_INT_EN_get_rchg_irq_en(data)                                  ((0x000000E0&(data))>>5)
+#define CBUS_TX_DEVCAP_INT_EN_req_3d_irq_en_shift                                    (4)
+#define CBUS_TX_DEVCAP_INT_EN_req_3d_irq_en_mask                                     (0x00000010)
+#define CBUS_TX_DEVCAP_INT_EN_req_3d_irq_en(data)                                    (0x00000010&((data)<<4))
+#define CBUS_TX_DEVCAP_INT_EN_req_3d_irq_en_src(data)                                ((0x00000010&(data))>>4)
+#define CBUS_TX_DEVCAP_INT_EN_get_req_3d_irq_en(data)                                ((0x00000010&(data))>>4)
+#define CBUS_TX_DEVCAP_INT_EN_grt_irq_en_shift                                       (3)
+#define CBUS_TX_DEVCAP_INT_EN_grt_irq_en_mask                                        (0x00000008)
+#define CBUS_TX_DEVCAP_INT_EN_grt_irq_en(data)                                       (0x00000008&((data)<<3))
+#define CBUS_TX_DEVCAP_INT_EN_grt_irq_en_src(data)                                   ((0x00000008&(data))>>3)
+#define CBUS_TX_DEVCAP_INT_EN_get_grt_irq_en(data)                                   ((0x00000008&(data))>>3)
+#define CBUS_TX_DEVCAP_INT_EN_req_irq_en_shift                                       (2)
+#define CBUS_TX_DEVCAP_INT_EN_req_irq_en_mask                                        (0x00000004)
+#define CBUS_TX_DEVCAP_INT_EN_req_irq_en(data)                                       (0x00000004&((data)<<2))
+#define CBUS_TX_DEVCAP_INT_EN_req_irq_en_src(data)                                   ((0x00000004&(data))>>2)
+#define CBUS_TX_DEVCAP_INT_EN_get_req_irq_en(data)                                   ((0x00000004&(data))>>2)
+#define CBUS_TX_DEVCAP_INT_EN_dscr_irq_en_shift                                      (1)
+#define CBUS_TX_DEVCAP_INT_EN_dscr_irq_en_mask                                       (0x00000002)
+#define CBUS_TX_DEVCAP_INT_EN_dscr_irq_en(data)                                      (0x00000002&((data)<<1))
+#define CBUS_TX_DEVCAP_INT_EN_dscr_irq_en_src(data)                                  ((0x00000002&(data))>>1)
+#define CBUS_TX_DEVCAP_INT_EN_get_dscr_irq_en(data)                                  ((0x00000002&(data))>>1)
+#define CBUS_TX_DEVCAP_INT_EN_dcap_irq_en_shift                                      (0)
+#define CBUS_TX_DEVCAP_INT_EN_dcap_irq_en_mask                                       (0x00000001)
+#define CBUS_TX_DEVCAP_INT_EN_dcap_irq_en(data)                                      (0x00000001&((data)<<0))
+#define CBUS_TX_DEVCAP_INT_EN_dcap_irq_en_src(data)                                  ((0x00000001&(data))>>0)
+#define CBUS_TX_DEVCAP_INT_EN_get_dcap_irq_en(data)                                  ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_DEVCAP_INT_EN1                                                       0x180370AC
+#define CBUS_TX_DEVCAP_INT_EN1_reg_addr                                              "0xB80370AC"
+#define CBUS_TX_DEVCAP_INT_EN1_reg                                                   0xB80370AC
+#define set_CBUS_TX_DEVCAP_INT_EN1_reg(data)   (*((volatile unsigned int*) CBUS_TX_DEVCAP_INT_EN1_reg)=data)
+#define get_CBUS_TX_DEVCAP_INT_EN1_reg   (*((volatile unsigned int*) CBUS_TX_DEVCAP_INT_EN1_reg))
+#define CBUS_TX_DEVCAP_INT_EN1_inst_adr                                              "0x002B"
+#define CBUS_TX_DEVCAP_INT_EN1_inst                                                  0x002B
+#define CBUS_TX_DEVCAP_INT_EN1_chg27_irq_en_shift                                    (24)
+#define CBUS_TX_DEVCAP_INT_EN1_chg27_irq_en_mask                                     (0xFF000000)
+#define CBUS_TX_DEVCAP_INT_EN1_chg27_irq_en(data)                                    (0xFF000000&((data)<<24))
+#define CBUS_TX_DEVCAP_INT_EN1_chg27_irq_en_src(data)                                ((0xFF000000&(data))>>24)
+#define CBUS_TX_DEVCAP_INT_EN1_get_chg27_irq_en(data)                                ((0xFF000000&(data))>>24)
+#define CBUS_TX_DEVCAP_INT_EN1_chg26_irq_en_shift                                    (16)
+#define CBUS_TX_DEVCAP_INT_EN1_chg26_irq_en_mask                                     (0x00FF0000)
+#define CBUS_TX_DEVCAP_INT_EN1_chg26_irq_en(data)                                    (0x00FF0000&((data)<<16))
+#define CBUS_TX_DEVCAP_INT_EN1_chg26_irq_en_src(data)                                ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DEVCAP_INT_EN1_get_chg26_irq_en(data)                                ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DEVCAP_INT_EN1_chg25_irq_en_shift                                    (8)
+#define CBUS_TX_DEVCAP_INT_EN1_chg25_irq_en_mask                                     (0x0000FF00)
+#define CBUS_TX_DEVCAP_INT_EN1_chg25_irq_en(data)                                    (0x0000FF00&((data)<<8))
+#define CBUS_TX_DEVCAP_INT_EN1_chg25_irq_en_src(data)                                ((0x0000FF00&(data))>>8)
+#define CBUS_TX_DEVCAP_INT_EN1_get_chg25_irq_en(data)                                ((0x0000FF00&(data))>>8)
+#define CBUS_TX_DEVCAP_INT_EN1_chg24_irq_en_shift                                    (0)
+#define CBUS_TX_DEVCAP_INT_EN1_chg24_irq_en_mask                                     (0x000000FF)
+#define CBUS_TX_DEVCAP_INT_EN1_chg24_irq_en(data)                                    (0x000000FF&((data)<<0))
+#define CBUS_TX_DEVCAP_INT_EN1_chg24_irq_en_src(data)                                ((0x000000FF&(data))>>0)
+#define CBUS_TX_DEVCAP_INT_EN1_get_chg24_irq_en(data)                                ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_CBUS_TEST                                                            0x1803709C
+#define CBUS_TX_CBUS_TEST_reg_addr                                                   "0xB803709C"
+#define CBUS_TX_CBUS_TEST_reg                                                        0xB803709C
+#define set_CBUS_TX_CBUS_TEST_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_TEST_reg)=data)
+#define get_CBUS_TX_CBUS_TEST_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_TEST_reg))
+#define CBUS_TX_CBUS_TEST_inst_adr                                                   "0x0027"
+#define CBUS_TX_CBUS_TEST_inst                                                       0x0027
+#define CBUS_TX_CBUS_TEST_cbus_test_md_shift                                         (30)
+#define CBUS_TX_CBUS_TEST_cbus_test_md_mask                                          (0xC0000000)
+#define CBUS_TX_CBUS_TEST_cbus_test_md(data)                                         (0xC0000000&((data)<<30))
+#define CBUS_TX_CBUS_TEST_cbus_test_md_src(data)                                     ((0xC0000000&(data))>>30)
+#define CBUS_TX_CBUS_TEST_get_cbus_test_md(data)                                     ((0xC0000000&(data))>>30)
+#define CBUS_TX_CBUS_TEST_fw_out_shift                                               (29)
+#define CBUS_TX_CBUS_TEST_fw_out_mask                                                (0x20000000)
+#define CBUS_TX_CBUS_TEST_fw_out(data)                                               (0x20000000&((data)<<29))
+#define CBUS_TX_CBUS_TEST_fw_out_src(data)                                           ((0x20000000&(data))>>29)
+#define CBUS_TX_CBUS_TEST_get_fw_out(data)                                           ((0x20000000&(data))>>29)
+#define CBUS_TX_CBUS_TEST_dbg_sel_shift                                              (26)
+#define CBUS_TX_CBUS_TEST_dbg_sel_mask                                               (0x1C000000)
+#define CBUS_TX_CBUS_TEST_dbg_sel(data)                                              (0x1C000000&((data)<<26))
+#define CBUS_TX_CBUS_TEST_dbg_sel_src(data)                                          ((0x1C000000&(data))>>26)
+#define CBUS_TX_CBUS_TEST_get_dbg_sel(data)                                          ((0x1C000000&(data))>>26)
+
+
+#define CBUS_TX_PHY_CTRL                                                             0x180370D0
+#define CBUS_TX_PHY_CTRL_reg_addr                                                    "0xB80370D0"
+#define CBUS_TX_PHY_CTRL_reg                                                         0xB80370D0
+#define set_CBUS_TX_PHY_CTRL_reg(data)   (*((volatile unsigned int*) CBUS_TX_PHY_CTRL_reg)=data)
+#define get_CBUS_TX_PHY_CTRL_reg   (*((volatile unsigned int*) CBUS_TX_PHY_CTRL_reg))
+#define CBUS_TX_PHY_CTRL_inst_adr                                                    "0x0034"
+#define CBUS_TX_PHY_CTRL_inst                                                        0x0034
+#define CBUS_TX_PHY_CTRL_reg_mhl_bmos_en_tx_shift                                    (31)
+#define CBUS_TX_PHY_CTRL_reg_mhl_bmos_en_tx_mask                                     (0x80000000)
+#define CBUS_TX_PHY_CTRL_reg_mhl_bmos_en_tx(data)                                    (0x80000000&((data)<<31))
+#define CBUS_TX_PHY_CTRL_reg_mhl_bmos_en_tx_src(data)                                ((0x80000000&(data))>>31)
+#define CBUS_TX_PHY_CTRL_get_reg_mhl_bmos_en_tx(data)                                ((0x80000000&(data))>>31)
+#define CBUS_TX_PHY_CTRL_reg_mhl_hpd_det_tx_shift                                    (30)
+#define CBUS_TX_PHY_CTRL_reg_mhl_hpd_det_tx_mask                                     (0x40000000)
+#define CBUS_TX_PHY_CTRL_reg_mhl_hpd_det_tx(data)                                    (0x40000000&((data)<<30))
+#define CBUS_TX_PHY_CTRL_reg_mhl_hpd_det_tx_src(data)                                ((0x40000000&(data))>>30)
+#define CBUS_TX_PHY_CTRL_get_reg_mhl_hpd_det_tx(data)                                ((0x40000000&(data))>>30)
+#define CBUS_TX_PHY_CTRL_reg_mhl_r1k_det_tx_shift                                    (29)
+#define CBUS_TX_PHY_CTRL_reg_mhl_r1k_det_tx_mask                                     (0x20000000)
+#define CBUS_TX_PHY_CTRL_reg_mhl_r1k_det_tx(data)                                    (0x20000000&((data)<<29))
+#define CBUS_TX_PHY_CTRL_reg_mhl_r1k_det_tx_src(data)                                ((0x20000000&(data))>>29)
+#define CBUS_TX_PHY_CTRL_get_reg_mhl_r1k_det_tx(data)                                ((0x20000000&(data))>>29)
+#define CBUS_TX_PHY_CTRL_reg_r1k_vth_sel_tx_shift                                    (28)
+#define CBUS_TX_PHY_CTRL_reg_r1k_vth_sel_tx_mask                                     (0x10000000)
+#define CBUS_TX_PHY_CTRL_reg_r1k_vth_sel_tx(data)                                    (0x10000000&((data)<<28))
+#define CBUS_TX_PHY_CTRL_reg_r1k_vth_sel_tx_src(data)                                ((0x10000000&(data))>>28)
+#define CBUS_TX_PHY_CTRL_get_reg_r1k_vth_sel_tx(data)                                ((0x10000000&(data))>>28)
+#define CBUS_TX_PHY_CTRL_reg_mhl_tst_en_tx_shift                                     (27)
+#define CBUS_TX_PHY_CTRL_reg_mhl_tst_en_tx_mask                                      (0x08000000)
+#define CBUS_TX_PHY_CTRL_reg_mhl_tst_en_tx(data)                                     (0x08000000&((data)<<27))
+#define CBUS_TX_PHY_CTRL_reg_mhl_tst_en_tx_src(data)                                 ((0x08000000&(data))>>27)
+#define CBUS_TX_PHY_CTRL_get_reg_mhl_tst_en_tx(data)                                 ((0x08000000&(data))>>27)
+#define CBUS_TX_PHY_CTRL_reg_mhl_vsel_tx_shift                                       (24)
+#define CBUS_TX_PHY_CTRL_reg_mhl_vsel_tx_mask                                        (0x07000000)
+#define CBUS_TX_PHY_CTRL_reg_mhl_vsel_tx(data)                                       (0x07000000&((data)<<24))
+#define CBUS_TX_PHY_CTRL_reg_mhl_vsel_tx_src(data)                                   ((0x07000000&(data))>>24)
+#define CBUS_TX_PHY_CTRL_get_reg_mhl_vsel_tx(data)                                   ((0x07000000&(data))>>24)
+#define CBUS_TX_PHY_CTRL_reg_mhl_r10k_tx_shift                                       (21)
+#define CBUS_TX_PHY_CTRL_reg_mhl_r10k_tx_mask                                        (0x00E00000)
+#define CBUS_TX_PHY_CTRL_reg_mhl_r10k_tx(data)                                       (0x00E00000&((data)<<21))
+#define CBUS_TX_PHY_CTRL_reg_mhl_r10k_tx_src(data)                                   ((0x00E00000&(data))>>21)
+#define CBUS_TX_PHY_CTRL_get_reg_mhl_r10k_tx(data)                                   ((0x00E00000&(data))>>21)
+#define CBUS_TX_PHY_CTRL_reg_cbus_strc_tx_shift                                      (18)
+#define CBUS_TX_PHY_CTRL_reg_cbus_strc_tx_mask                                       (0x001C0000)
+#define CBUS_TX_PHY_CTRL_reg_cbus_strc_tx(data)                                      (0x001C0000&((data)<<18))
+#define CBUS_TX_PHY_CTRL_reg_cbus_strc_tx_src(data)                                  ((0x001C0000&(data))>>18)
+#define CBUS_TX_PHY_CTRL_get_reg_cbus_strc_tx(data)                                  ((0x001C0000&(data))>>18)
+#define CBUS_TX_PHY_CTRL_reg_en_bias_txrx_shift                                      (17)
+#define CBUS_TX_PHY_CTRL_reg_en_bias_txrx_mask                                       (0x00020000)
+#define CBUS_TX_PHY_CTRL_reg_en_bias_txrx(data)                                      (0x00020000&((data)<<17))
+#define CBUS_TX_PHY_CTRL_reg_en_bias_txrx_src(data)                                  ((0x00020000&(data))>>17)
+#define CBUS_TX_PHY_CTRL_get_reg_en_bias_txrx(data)                                  ((0x00020000&(data))>>17)
+#define CBUS_TX_PHY_CTRL_tst_sel_h_tx_shift                                          (15)
+#define CBUS_TX_PHY_CTRL_tst_sel_h_tx_mask                                           (0x00018000)
+#define CBUS_TX_PHY_CTRL_tst_sel_h_tx(data)                                          (0x00018000&((data)<<15))
+#define CBUS_TX_PHY_CTRL_tst_sel_h_tx_src(data)                                      ((0x00018000&(data))>>15)
+#define CBUS_TX_PHY_CTRL_get_tst_sel_h_tx(data)                                      ((0x00018000&(data))>>15)
+#define CBUS_TX_PHY_CTRL_reg_mhl_r10k_test_tx_shift                                  (14)
+#define CBUS_TX_PHY_CTRL_reg_mhl_r10k_test_tx_mask                                   (0x00004000)
+#define CBUS_TX_PHY_CTRL_reg_mhl_r10k_test_tx(data)                                  (0x00004000&((data)<<14))
+#define CBUS_TX_PHY_CTRL_reg_mhl_r10k_test_tx_src(data)                              ((0x00004000&(data))>>14)
+#define CBUS_TX_PHY_CTRL_get_reg_mhl_r10k_test_tx(data)                              ((0x00004000&(data))>>14)
+
+
+#define CBUS_TX_PHY_STATUS                                                           0x180370D4
+#define CBUS_TX_PHY_STATUS_reg_addr                                                  "0xB80370D4"
+#define CBUS_TX_PHY_STATUS_reg                                                       0xB80370D4
+#define set_CBUS_TX_PHY_STATUS_reg(data)   (*((volatile unsigned int*) CBUS_TX_PHY_STATUS_reg)=data)
+#define get_CBUS_TX_PHY_STATUS_reg   (*((volatile unsigned int*) CBUS_TX_PHY_STATUS_reg))
+#define CBUS_TX_PHY_STATUS_inst_adr                                                  "0x0035"
+#define CBUS_TX_PHY_STATUS_inst                                                      0x0035
+#define CBUS_TX_PHY_STATUS_hdmi_hpd_out_tx_shift                                     (3)
+#define CBUS_TX_PHY_STATUS_hdmi_hpd_out_tx_mask                                      (0x00000008)
+#define CBUS_TX_PHY_STATUS_hdmi_hpd_out_tx(data)                                     (0x00000008&((data)<<3))
+#define CBUS_TX_PHY_STATUS_hdmi_hpd_out_tx_src(data)                                 ((0x00000008&(data))>>3)
+#define CBUS_TX_PHY_STATUS_get_hdmi_hpd_out_tx(data)                                 ((0x00000008&(data))>>3)
+#define CBUS_TX_PHY_STATUS_hdmi_hpd_en_tx_shift                                      (2)
+#define CBUS_TX_PHY_STATUS_hdmi_hpd_en_tx_mask                                       (0x00000004)
+#define CBUS_TX_PHY_STATUS_hdmi_hpd_en_tx(data)                                      (0x00000004&((data)<<2))
+#define CBUS_TX_PHY_STATUS_hdmi_hpd_en_tx_src(data)                                  ((0x00000004&(data))>>2)
+#define CBUS_TX_PHY_STATUS_get_hdmi_hpd_en_tx(data)                                  ((0x00000004&(data))>>2)
+#define CBUS_TX_PHY_STATUS_rego_mhl_hpd_det_tx_shift                                 (1)
+#define CBUS_TX_PHY_STATUS_rego_mhl_hpd_det_tx_mask                                  (0x00000002)
+#define CBUS_TX_PHY_STATUS_rego_mhl_hpd_det_tx(data)                                 (0x00000002&((data)<<1))
+#define CBUS_TX_PHY_STATUS_rego_mhl_hpd_det_tx_src(data)                             ((0x00000002&(data))>>1)
+#define CBUS_TX_PHY_STATUS_get_rego_mhl_hpd_det_tx(data)                             ((0x00000002&(data))>>1)
+#define CBUS_TX_PHY_STATUS_rego_mhl_r1k_det_tx_shift                                 (0)
+#define CBUS_TX_PHY_STATUS_rego_mhl_r1k_det_tx_mask                                  (0x00000001)
+#define CBUS_TX_PHY_STATUS_rego_mhl_r1k_det_tx(data)                                 (0x00000001&((data)<<0))
+#define CBUS_TX_PHY_STATUS_rego_mhl_r1k_det_tx_src(data)                             ((0x00000001&(data))>>0)
+#define CBUS_TX_PHY_STATUS_get_rego_mhl_r1k_det_tx(data)                             ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_CBUS_CTRL9                                                           0x180370D8
+#define CBUS_TX_CBUS_CTRL9_reg_addr                                                  "0xB80370D8"
+#define CBUS_TX_CBUS_CTRL9_reg                                                       0xB80370D8
+#define set_CBUS_TX_CBUS_CTRL9_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL9_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL9_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL9_reg))
+#define CBUS_TX_CBUS_CTRL9_inst_adr                                                  "0x0036"
+#define CBUS_TX_CBUS_CTRL9_inst                                                      0x0036
+#define CBUS_TX_CBUS_CTRL9_deb_lv_shift                                              (24)
+#define CBUS_TX_CBUS_CTRL9_deb_lv_mask                                               (0x07000000)
+#define CBUS_TX_CBUS_CTRL9_deb_lv(data)                                              (0x07000000&((data)<<24))
+#define CBUS_TX_CBUS_CTRL9_deb_lv_src(data)                                          ((0x07000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL9_get_deb_lv(data)                                          ((0x07000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL9_det_r1k_cnt_shift                                         (16)
+#define CBUS_TX_CBUS_CTRL9_det_r1k_cnt_mask                                          (0x000F0000)
+#define CBUS_TX_CBUS_CTRL9_det_r1k_cnt(data)                                         (0x000F0000&((data)<<16))
+#define CBUS_TX_CBUS_CTRL9_det_r1k_cnt_src(data)                                     ((0x000F0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL9_get_det_r1k_cnt(data)                                     ((0x000F0000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL9_clk_1k_div_shift                                          (0)
+#define CBUS_TX_CBUS_CTRL9_clk_1k_div_mask                                           (0x000003FF)
+#define CBUS_TX_CBUS_CTRL9_clk_1k_div(data)                                          (0x000003FF&((data)<<0))
+#define CBUS_TX_CBUS_CTRL9_clk_1k_div_src(data)                                      ((0x000003FF&(data))>>0)
+#define CBUS_TX_CBUS_CTRL9_get_clk_1k_div(data)                                      ((0x000003FF&(data))>>0)
+
+
+#define CBUS_TX_DUMMY_CTRL                                                           0x180370E0
+#define CBUS_TX_DUMMY_CTRL_reg_addr                                                  "0xB80370E0"
+#define CBUS_TX_DUMMY_CTRL_reg                                                       0xB80370E0
+#define set_CBUS_TX_DUMMY_CTRL_reg(data)   (*((volatile unsigned int*) CBUS_TX_DUMMY_CTRL_reg)=data)
+#define get_CBUS_TX_DUMMY_CTRL_reg   (*((volatile unsigned int*) CBUS_TX_DUMMY_CTRL_reg))
+#define CBUS_TX_DUMMY_CTRL_inst_adr                                                  "0x0038"
+#define CBUS_TX_DUMMY_CTRL_inst                                                      0x0038
+#define CBUS_TX_DUMMY_CTRL_dummy_reg_shift                                           (0)
+#define CBUS_TX_DUMMY_CTRL_dummy_reg_mask                                            (0xFFFFFFFF)
+#define CBUS_TX_DUMMY_CTRL_dummy_reg(data)                                           (0xFFFFFFFF&((data)<<0))
+#define CBUS_TX_DUMMY_CTRL_dummy_reg_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define CBUS_TX_DUMMY_CTRL_get_dummy_reg(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define CBUS_TX_CBUS_CTRL10                                                          0x180370DC
+#define CBUS_TX_CBUS_CTRL10_reg_addr                                                 "0xB80370DC"
+#define CBUS_TX_CBUS_CTRL10_reg                                                      0xB80370DC
+#define set_CBUS_TX_CBUS_CTRL10_reg(data)   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL10_reg)=data)
+#define get_CBUS_TX_CBUS_CTRL10_reg   (*((volatile unsigned int*) CBUS_TX_CBUS_CTRL10_reg))
+#define CBUS_TX_CBUS_CTRL10_inst_adr                                                 "0x0037"
+#define CBUS_TX_CBUS_CTRL10_inst                                                     0x0037
+#define CBUS_TX_CBUS_CTRL10_link_layer_st_shift                                      (28)
+#define CBUS_TX_CBUS_CTRL10_link_layer_st_mask                                       (0xF0000000)
+#define CBUS_TX_CBUS_CTRL10_link_layer_st(data)                                      (0xF0000000&((data)<<28))
+#define CBUS_TX_CBUS_CTRL10_link_layer_st_src(data)                                  ((0xF0000000&(data))>>28)
+#define CBUS_TX_CBUS_CTRL10_get_link_layer_st(data)                                  ((0xF0000000&(data))>>28)
+#define CBUS_TX_CBUS_CTRL10_hw_en_10k_shift                                          (25)
+#define CBUS_TX_CBUS_CTRL10_hw_en_10k_mask                                           (0x02000000)
+#define CBUS_TX_CBUS_CTRL10_hw_en_10k(data)                                          (0x02000000&((data)<<25))
+#define CBUS_TX_CBUS_CTRL10_hw_en_10k_src(data)                                      ((0x02000000&(data))>>25)
+#define CBUS_TX_CBUS_CTRL10_get_hw_en_10k(data)                                      ((0x02000000&(data))>>25)
+#define CBUS_TX_CBUS_CTRL10_hw_en_5k_shift                                           (24)
+#define CBUS_TX_CBUS_CTRL10_hw_en_5k_mask                                            (0x01000000)
+#define CBUS_TX_CBUS_CTRL10_hw_en_5k(data)                                           (0x01000000&((data)<<24))
+#define CBUS_TX_CBUS_CTRL10_hw_en_5k_src(data)                                       ((0x01000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL10_get_hw_en_5k(data)                                       ((0x01000000&(data))>>24)
+#define CBUS_TX_CBUS_CTRL10_det_r1k_st_shift                                         (16)
+#define CBUS_TX_CBUS_CTRL10_det_r1k_st_mask                                          (0x00030000)
+#define CBUS_TX_CBUS_CTRL10_det_r1k_st(data)                                         (0x00030000&((data)<<16))
+#define CBUS_TX_CBUS_CTRL10_det_r1k_st_src(data)                                     ((0x00030000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL10_get_det_r1k_st(data)                                     ((0x00030000&(data))>>16)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_hpd_det_shift                                     (11)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_hpd_det_mask                                      (0x00000800)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_hpd_det(data)                                     (0x00000800&((data)<<11))
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_hpd_det_src(data)                                 ((0x00000800&(data))>>11)
+#define CBUS_TX_CBUS_CTRL10_get_hw_mhl_hpd_det(data)                                 ((0x00000800&(data))>>11)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_r1k_det_shift                                     (10)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_r1k_det_mask                                      (0x00000400)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_r1k_det(data)                                     (0x00000400&((data)<<10))
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_r1k_det_src(data)                                 ((0x00000400&(data))>>10)
+#define CBUS_TX_CBUS_CTRL10_get_hw_mhl_r1k_det(data)                                 ((0x00000400&(data))>>10)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_bmos_en_shift                                     (9)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_bmos_en_mask                                      (0x00000200)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_bmos_en(data)                                     (0x00000200&((data)<<9))
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_bmos_en_src(data)                                 ((0x00000200&(data))>>9)
+#define CBUS_TX_CBUS_CTRL10_get_hw_mhl_bmos_en(data)                                 ((0x00000200&(data))>>9)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_vtl_sel_shift                                     (8)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_vtl_sel_mask                                      (0x00000100)
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_vtl_sel(data)                                     (0x00000100&((data)<<8))
+#define CBUS_TX_CBUS_CTRL10_hw_mhl_vtl_sel_src(data)                                 ((0x00000100&(data))>>8)
+#define CBUS_TX_CBUS_CTRL10_get_hw_mhl_vtl_sel(data)                                 ((0x00000100&(data))>>8)
+#define CBUS_TX_CBUS_CTRL10_fw_rst_r1k_st_shift                                      (4)
+#define CBUS_TX_CBUS_CTRL10_fw_rst_r1k_st_mask                                       (0x00000010)
+#define CBUS_TX_CBUS_CTRL10_fw_rst_r1k_st(data)                                      (0x00000010&((data)<<4))
+#define CBUS_TX_CBUS_CTRL10_fw_rst_r1k_st_src(data)                                  ((0x00000010&(data))>>4)
+#define CBUS_TX_CBUS_CTRL10_get_fw_rst_r1k_st(data)                                  ((0x00000010&(data))>>4)
+#define CBUS_TX_CBUS_CTRL10_fw_r1k_det_en_shift                                      (1)
+#define CBUS_TX_CBUS_CTRL10_fw_r1k_det_en_mask                                       (0x00000002)
+#define CBUS_TX_CBUS_CTRL10_fw_r1k_det_en(data)                                      (0x00000002&((data)<<1))
+#define CBUS_TX_CBUS_CTRL10_fw_r1k_det_en_src(data)                                  ((0x00000002&(data))>>1)
+#define CBUS_TX_CBUS_CTRL10_get_fw_r1k_det_en(data)                                  ((0x00000002&(data))>>1)
+#define CBUS_TX_CBUS_CTRL10_fw_r1k_det_shift                                         (0)
+#define CBUS_TX_CBUS_CTRL10_fw_r1k_det_mask                                          (0x00000001)
+#define CBUS_TX_CBUS_CTRL10_fw_r1k_det(data)                                         (0x00000001&((data)<<0))
+#define CBUS_TX_CBUS_CTRL10_fw_r1k_det_src(data)                                     ((0x00000001&(data))>>0)
+#define CBUS_TX_CBUS_CTRL10_get_fw_r1k_det(data)                                     ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_DEVCAP_WRITE                                                         0x18037098
+#define CBUS_TX_DEVCAP_WRITE_reg_addr                                                "0xB8037098"
+#define CBUS_TX_DEVCAP_WRITE_reg                                                     0xB8037098
+#define set_CBUS_TX_DEVCAP_WRITE_reg(data)   (*((volatile unsigned int*) CBUS_TX_DEVCAP_WRITE_reg)=data)
+#define get_CBUS_TX_DEVCAP_WRITE_reg   (*((volatile unsigned int*) CBUS_TX_DEVCAP_WRITE_reg))
+#define CBUS_TX_DEVCAP_WRITE_inst_adr                                                "0x0026"
+#define CBUS_TX_DEVCAP_WRITE_inst                                                    0x0026
+#define CBUS_TX_DEVCAP_WRITE_msc_offset_adr_shift                                    (24)
+#define CBUS_TX_DEVCAP_WRITE_msc_offset_adr_mask                                     (0x7F000000)
+#define CBUS_TX_DEVCAP_WRITE_msc_offset_adr(data)                                    (0x7F000000&((data)<<24))
+#define CBUS_TX_DEVCAP_WRITE_msc_offset_adr_src(data)                                ((0x7F000000&(data))>>24)
+#define CBUS_TX_DEVCAP_WRITE_get_msc_offset_adr(data)                                ((0x7F000000&(data))>>24)
+#define CBUS_TX_DEVCAP_WRITE_devcap_rdata_shift                                      (16)
+#define CBUS_TX_DEVCAP_WRITE_devcap_rdata_mask                                       (0x00FF0000)
+#define CBUS_TX_DEVCAP_WRITE_devcap_rdata(data)                                      (0x00FF0000&((data)<<16))
+#define CBUS_TX_DEVCAP_WRITE_devcap_rdata_src(data)                                  ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DEVCAP_WRITE_get_devcap_rdata(data)                                  ((0x00FF0000&(data))>>16)
+#define CBUS_TX_DEVCAP_WRITE_devcap_write_shift                                      (8)
+#define CBUS_TX_DEVCAP_WRITE_devcap_write_mask                                       (0x00000100)
+#define CBUS_TX_DEVCAP_WRITE_devcap_write(data)                                      (0x00000100&((data)<<8))
+#define CBUS_TX_DEVCAP_WRITE_devcap_write_src(data)                                  ((0x00000100&(data))>>8)
+#define CBUS_TX_DEVCAP_WRITE_get_devcap_write(data)                                  ((0x00000100&(data))>>8)
+#define CBUS_TX_DEVCAP_WRITE_msc_reg_data_shift                                      (0)
+#define CBUS_TX_DEVCAP_WRITE_msc_reg_data_mask                                       (0x000000FF)
+#define CBUS_TX_DEVCAP_WRITE_msc_reg_data(data)                                      (0x000000FF&((data)<<0))
+#define CBUS_TX_DEVCAP_WRITE_msc_reg_data_src(data)                                  ((0x000000FF&(data))>>0)
+#define CBUS_TX_DEVCAP_WRITE_get_msc_reg_data(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP0                                                          0x18037100
+#define CBUS_TX_MSC_DEVCAP0_reg_addr                                                 "0xB8037100"
+#define CBUS_TX_MSC_DEVCAP0_reg                                                      0xB8037100
+#define set_CBUS_TX_MSC_DEVCAP0_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP0_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP0_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP0_reg))
+#define CBUS_TX_MSC_DEVCAP0_inst_adr                                                 "0x0040"
+#define CBUS_TX_MSC_DEVCAP0_inst                                                     0x0040
+#define CBUS_TX_MSC_DEVCAP0_adop_id_h_shift                                          (24)
+#define CBUS_TX_MSC_DEVCAP0_adop_id_h_mask                                           (0xFF000000)
+#define CBUS_TX_MSC_DEVCAP0_adop_id_h(data)                                          (0xFF000000&((data)<<24))
+#define CBUS_TX_MSC_DEVCAP0_adop_id_h_src(data)                                      ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSC_DEVCAP0_get_adop_id_h(data)                                      ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSC_DEVCAP0_dev_cat_shift                                            (23)
+#define CBUS_TX_MSC_DEVCAP0_dev_cat_mask                                             (0x00800000)
+#define CBUS_TX_MSC_DEVCAP0_dev_cat(data)                                            (0x00800000&((data)<<23))
+#define CBUS_TX_MSC_DEVCAP0_dev_cat_src(data)                                        ((0x00800000&(data))>>23)
+#define CBUS_TX_MSC_DEVCAP0_get_dev_cat(data)                                        ((0x00800000&(data))>>23)
+#define CBUS_TX_MSC_DEVCAP0_plim_shift                                               (21)
+#define CBUS_TX_MSC_DEVCAP0_plim_mask                                                (0x00600000)
+#define CBUS_TX_MSC_DEVCAP0_plim(data)                                               (0x00600000&((data)<<21))
+#define CBUS_TX_MSC_DEVCAP0_plim_src(data)                                           ((0x00600000&(data))>>21)
+#define CBUS_TX_MSC_DEVCAP0_get_plim(data)                                           ((0x00600000&(data))>>21)
+#define CBUS_TX_MSC_DEVCAP0_pow_shift                                                (20)
+#define CBUS_TX_MSC_DEVCAP0_pow_mask                                                 (0x00100000)
+#define CBUS_TX_MSC_DEVCAP0_pow(data)                                                (0x00100000&((data)<<20))
+#define CBUS_TX_MSC_DEVCAP0_pow_src(data)                                            ((0x00100000&(data))>>20)
+#define CBUS_TX_MSC_DEVCAP0_get_pow(data)                                            ((0x00100000&(data))>>20)
+#define CBUS_TX_MSC_DEVCAP0_dev_type_shift                                           (16)
+#define CBUS_TX_MSC_DEVCAP0_dev_type_mask                                            (0x000F0000)
+#define CBUS_TX_MSC_DEVCAP0_dev_type(data)                                           (0x000F0000&((data)<<16))
+#define CBUS_TX_MSC_DEVCAP0_dev_type_src(data)                                       ((0x000F0000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP0_get_dev_type(data)                                       ((0x000F0000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP0_mhl_ver_shift                                            (8)
+#define CBUS_TX_MSC_DEVCAP0_mhl_ver_mask                                             (0x0000FF00)
+#define CBUS_TX_MSC_DEVCAP0_mhl_ver(data)                                            (0x0000FF00&((data)<<8))
+#define CBUS_TX_MSC_DEVCAP0_mhl_ver_src(data)                                        ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP0_get_mhl_ver(data)                                        ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP0_dev_state_shift                                          (0)
+#define CBUS_TX_MSC_DEVCAP0_dev_state_mask                                           (0x000000FF)
+#define CBUS_TX_MSC_DEVCAP0_dev_state(data)                                          (0x000000FF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP0_dev_state_src(data)                                      ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP0_get_dev_state(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP1                                                          0x18037104
+#define CBUS_TX_MSC_DEVCAP1_reg_addr                                                 "0xB8037104"
+#define CBUS_TX_MSC_DEVCAP1_reg                                                      0xB8037104
+#define set_CBUS_TX_MSC_DEVCAP1_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP1_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP1_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP1_reg))
+#define CBUS_TX_MSC_DEVCAP1_inst_adr                                                 "0x0041"
+#define CBUS_TX_MSC_DEVCAP1_inst                                                     0x0041
+#define CBUS_TX_MSC_DEVCAP1_aud_link_md_shift                                        (18)
+#define CBUS_TX_MSC_DEVCAP1_aud_link_md_mask                                         (0x00FC0000)
+#define CBUS_TX_MSC_DEVCAP1_aud_link_md(data)                                        (0x00FC0000&((data)<<18))
+#define CBUS_TX_MSC_DEVCAP1_aud_link_md_src(data)                                    ((0x00FC0000&(data))>>18)
+#define CBUS_TX_MSC_DEVCAP1_get_aud_link_md(data)                                    ((0x00FC0000&(data))>>18)
+#define CBUS_TX_MSC_DEVCAP1_aud_8ch_shift                                            (17)
+#define CBUS_TX_MSC_DEVCAP1_aud_8ch_mask                                             (0x00020000)
+#define CBUS_TX_MSC_DEVCAP1_aud_8ch(data)                                            (0x00020000&((data)<<17))
+#define CBUS_TX_MSC_DEVCAP1_aud_8ch_src(data)                                        ((0x00020000&(data))>>17)
+#define CBUS_TX_MSC_DEVCAP1_get_aud_8ch(data)                                        ((0x00020000&(data))>>17)
+#define CBUS_TX_MSC_DEVCAP1_aud_2ch_shift                                            (16)
+#define CBUS_TX_MSC_DEVCAP1_aud_2ch_mask                                             (0x00010000)
+#define CBUS_TX_MSC_DEVCAP1_aud_2ch(data)                                            (0x00010000&((data)<<16))
+#define CBUS_TX_MSC_DEVCAP1_aud_2ch_src(data)                                        ((0x00010000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP1_get_aud_2ch(data)                                        ((0x00010000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP1_vid_link_md_shift                                        (14)
+#define CBUS_TX_MSC_DEVCAP1_vid_link_md_mask                                         (0x0000C000)
+#define CBUS_TX_MSC_DEVCAP1_vid_link_md(data)                                        (0x0000C000&((data)<<14))
+#define CBUS_TX_MSC_DEVCAP1_vid_link_md_src(data)                                    ((0x0000C000&(data))>>14)
+#define CBUS_TX_MSC_DEVCAP1_get_vid_link_md(data)                                    ((0x0000C000&(data))>>14)
+#define CBUS_TX_MSC_DEVCAP1_supp_vga_shift                                           (13)
+#define CBUS_TX_MSC_DEVCAP1_supp_vga_mask                                            (0x00002000)
+#define CBUS_TX_MSC_DEVCAP1_supp_vga(data)                                           (0x00002000&((data)<<13))
+#define CBUS_TX_MSC_DEVCAP1_supp_vga_src(data)                                       ((0x00002000&(data))>>13)
+#define CBUS_TX_MSC_DEVCAP1_get_supp_vga(data)                                       ((0x00002000&(data))>>13)
+#define CBUS_TX_MSC_DEVCAP1_supp_islands_shift                                       (12)
+#define CBUS_TX_MSC_DEVCAP1_supp_islands_mask                                        (0x00001000)
+#define CBUS_TX_MSC_DEVCAP1_supp_islands(data)                                       (0x00001000&((data)<<12))
+#define CBUS_TX_MSC_DEVCAP1_supp_islands_src(data)                                   ((0x00001000&(data))>>12)
+#define CBUS_TX_MSC_DEVCAP1_get_supp_islands(data)                                   ((0x00001000&(data))>>12)
+#define CBUS_TX_MSC_DEVCAP1_supp_ppixel_shift                                        (11)
+#define CBUS_TX_MSC_DEVCAP1_supp_ppixel_mask                                         (0x00000800)
+#define CBUS_TX_MSC_DEVCAP1_supp_ppixel(data)                                        (0x00000800&((data)<<11))
+#define CBUS_TX_MSC_DEVCAP1_supp_ppixel_src(data)                                    ((0x00000800&(data))>>11)
+#define CBUS_TX_MSC_DEVCAP1_get_supp_ppixel(data)                                    ((0x00000800&(data))>>11)
+#define CBUS_TX_MSC_DEVCAP1_supp_yuv422_shift                                        (10)
+#define CBUS_TX_MSC_DEVCAP1_supp_yuv422_mask                                         (0x00000400)
+#define CBUS_TX_MSC_DEVCAP1_supp_yuv422(data)                                        (0x00000400&((data)<<10))
+#define CBUS_TX_MSC_DEVCAP1_supp_yuv422_src(data)                                    ((0x00000400&(data))>>10)
+#define CBUS_TX_MSC_DEVCAP1_get_supp_yuv422(data)                                    ((0x00000400&(data))>>10)
+#define CBUS_TX_MSC_DEVCAP1_supp_yuv444_shift                                        (9)
+#define CBUS_TX_MSC_DEVCAP1_supp_yuv444_mask                                         (0x00000200)
+#define CBUS_TX_MSC_DEVCAP1_supp_yuv444(data)                                        (0x00000200&((data)<<9))
+#define CBUS_TX_MSC_DEVCAP1_supp_yuv444_src(data)                                    ((0x00000200&(data))>>9)
+#define CBUS_TX_MSC_DEVCAP1_get_supp_yuv444(data)                                    ((0x00000200&(data))>>9)
+#define CBUS_TX_MSC_DEVCAP1_supp_rgb444_shift                                        (8)
+#define CBUS_TX_MSC_DEVCAP1_supp_rgb444_mask                                         (0x00000100)
+#define CBUS_TX_MSC_DEVCAP1_supp_rgb444(data)                                        (0x00000100&((data)<<8))
+#define CBUS_TX_MSC_DEVCAP1_supp_rgb444_src(data)                                    ((0x00000100&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP1_get_supp_rgb444(data)                                    ((0x00000100&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP1_adop_id_l_shift                                          (0)
+#define CBUS_TX_MSC_DEVCAP1_adop_id_l_mask                                           (0x000000FF)
+#define CBUS_TX_MSC_DEVCAP1_adop_id_l(data)                                          (0x000000FF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP1_adop_id_l_src(data)                                      ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP1_get_adop_id_l(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP2                                                          0x18037108
+#define CBUS_TX_MSC_DEVCAP2_reg_addr                                                 "0xB8037108"
+#define CBUS_TX_MSC_DEVCAP2_reg                                                      0xB8037108
+#define set_CBUS_TX_MSC_DEVCAP2_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP2_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP2_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP2_reg))
+#define CBUS_TX_MSC_DEVCAP2_inst_adr                                                 "0x0042"
+#define CBUS_TX_MSC_DEVCAP2_inst                                                     0x0042
+#define CBUS_TX_MSC_DEVCAP2_device_id_h_shift                                        (24)
+#define CBUS_TX_MSC_DEVCAP2_device_id_h_mask                                         (0xFF000000)
+#define CBUS_TX_MSC_DEVCAP2_device_id_h(data)                                        (0xFF000000&((data)<<24))
+#define CBUS_TX_MSC_DEVCAP2_device_id_h_src(data)                                    ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSC_DEVCAP2_get_device_id_h(data)                                    ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSC_DEVCAP2_feature_flag_shift                                       (21)
+#define CBUS_TX_MSC_DEVCAP2_feature_flag_mask                                        (0x00E00000)
+#define CBUS_TX_MSC_DEVCAP2_feature_flag(data)                                       (0x00E00000&((data)<<21))
+#define CBUS_TX_MSC_DEVCAP2_feature_flag_src(data)                                   ((0x00E00000&(data))>>21)
+#define CBUS_TX_MSC_DEVCAP2_get_feature_flag(data)                                   ((0x00E00000&(data))>>21)
+#define CBUS_TX_MSC_DEVCAP2_ucp_recv_supp_shift                                      (20)
+#define CBUS_TX_MSC_DEVCAP2_ucp_recv_supp_mask                                       (0x00100000)
+#define CBUS_TX_MSC_DEVCAP2_ucp_recv_supp(data)                                      (0x00100000&((data)<<20))
+#define CBUS_TX_MSC_DEVCAP2_ucp_recv_supp_src(data)                                  ((0x00100000&(data))>>20)
+#define CBUS_TX_MSC_DEVCAP2_get_ucp_recv_supp(data)                                  ((0x00100000&(data))>>20)
+#define CBUS_TX_MSC_DEVCAP2_ucp_send_supp_shift                                      (19)
+#define CBUS_TX_MSC_DEVCAP2_ucp_send_supp_mask                                       (0x00080000)
+#define CBUS_TX_MSC_DEVCAP2_ucp_send_supp(data)                                      (0x00080000&((data)<<19))
+#define CBUS_TX_MSC_DEVCAP2_ucp_send_supp_src(data)                                  ((0x00080000&(data))>>19)
+#define CBUS_TX_MSC_DEVCAP2_get_ucp_send_supp(data)                                  ((0x00080000&(data))>>19)
+#define CBUS_TX_MSC_DEVCAP2_sp_supp_shift                                            (18)
+#define CBUS_TX_MSC_DEVCAP2_sp_supp_mask                                             (0x00040000)
+#define CBUS_TX_MSC_DEVCAP2_sp_supp(data)                                            (0x00040000&((data)<<18))
+#define CBUS_TX_MSC_DEVCAP2_sp_supp_src(data)                                        ((0x00040000&(data))>>18)
+#define CBUS_TX_MSC_DEVCAP2_get_sp_supp(data)                                        ((0x00040000&(data))>>18)
+#define CBUS_TX_MSC_DEVCAP2_rap_supp_shift                                           (17)
+#define CBUS_TX_MSC_DEVCAP2_rap_supp_mask                                            (0x00020000)
+#define CBUS_TX_MSC_DEVCAP2_rap_supp(data)                                           (0x00020000&((data)<<17))
+#define CBUS_TX_MSC_DEVCAP2_rap_supp_src(data)                                       ((0x00020000&(data))>>17)
+#define CBUS_TX_MSC_DEVCAP2_get_rap_supp(data)                                       ((0x00020000&(data))>>17)
+#define CBUS_TX_MSC_DEVCAP2_rcp_supp_shift                                           (16)
+#define CBUS_TX_MSC_DEVCAP2_rcp_supp_mask                                            (0x00010000)
+#define CBUS_TX_MSC_DEVCAP2_rcp_supp(data)                                           (0x00010000&((data)<<16))
+#define CBUS_TX_MSC_DEVCAP2_rcp_supp_src(data)                                       ((0x00010000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP2_get_rcp_supp(data)                                       ((0x00010000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP2_ld_gui_shift                                             (7)
+#define CBUS_TX_MSC_DEVCAP2_ld_gui_mask                                              (0x00000080)
+#define CBUS_TX_MSC_DEVCAP2_ld_gui(data)                                             (0x00000080&((data)<<7))
+#define CBUS_TX_MSC_DEVCAP2_ld_gui_src(data)                                         ((0x00000080&(data))>>7)
+#define CBUS_TX_MSC_DEVCAP2_get_ld_gui(data)                                         ((0x00000080&(data))>>7)
+#define CBUS_TX_MSC_DEVCAP2_ld_speaker_shift                                         (6)
+#define CBUS_TX_MSC_DEVCAP2_ld_speaker_mask                                          (0x00000040)
+#define CBUS_TX_MSC_DEVCAP2_ld_speaker(data)                                         (0x00000040&((data)<<6))
+#define CBUS_TX_MSC_DEVCAP2_ld_speaker_src(data)                                     ((0x00000040&(data))>>6)
+#define CBUS_TX_MSC_DEVCAP2_get_ld_speaker(data)                                     ((0x00000040&(data))>>6)
+#define CBUS_TX_MSC_DEVCAP2_ld_record_shift                                          (5)
+#define CBUS_TX_MSC_DEVCAP2_ld_record_mask                                           (0x00000020)
+#define CBUS_TX_MSC_DEVCAP2_ld_record(data)                                          (0x00000020&((data)<<5))
+#define CBUS_TX_MSC_DEVCAP2_ld_record_src(data)                                      ((0x00000020&(data))>>5)
+#define CBUS_TX_MSC_DEVCAP2_get_ld_record(data)                                      ((0x00000020&(data))>>5)
+#define CBUS_TX_MSC_DEVCAP2_ld_tuner_shift                                           (4)
+#define CBUS_TX_MSC_DEVCAP2_ld_tuner_mask                                            (0x00000010)
+#define CBUS_TX_MSC_DEVCAP2_ld_tuner(data)                                           (0x00000010&((data)<<4))
+#define CBUS_TX_MSC_DEVCAP2_ld_tuner_src(data)                                       ((0x00000010&(data))>>4)
+#define CBUS_TX_MSC_DEVCAP2_get_ld_tuner(data)                                       ((0x00000010&(data))>>4)
+#define CBUS_TX_MSC_DEVCAP2_ld_media_shift                                           (3)
+#define CBUS_TX_MSC_DEVCAP2_ld_media_mask                                            (0x00000008)
+#define CBUS_TX_MSC_DEVCAP2_ld_media(data)                                           (0x00000008&((data)<<3))
+#define CBUS_TX_MSC_DEVCAP2_ld_media_src(data)                                       ((0x00000008&(data))>>3)
+#define CBUS_TX_MSC_DEVCAP2_get_ld_media(data)                                       ((0x00000008&(data))>>3)
+#define CBUS_TX_MSC_DEVCAP2_ld_audio_shift                                           (2)
+#define CBUS_TX_MSC_DEVCAP2_ld_audio_mask                                            (0x00000004)
+#define CBUS_TX_MSC_DEVCAP2_ld_audio(data)                                           (0x00000004&((data)<<2))
+#define CBUS_TX_MSC_DEVCAP2_ld_audio_src(data)                                       ((0x00000004&(data))>>2)
+#define CBUS_TX_MSC_DEVCAP2_get_ld_audio(data)                                       ((0x00000004&(data))>>2)
+#define CBUS_TX_MSC_DEVCAP2_ld_video_shift                                           (1)
+#define CBUS_TX_MSC_DEVCAP2_ld_video_mask                                            (0x00000002)
+#define CBUS_TX_MSC_DEVCAP2_ld_video(data)                                           (0x00000002&((data)<<1))
+#define CBUS_TX_MSC_DEVCAP2_ld_video_src(data)                                       ((0x00000002&(data))>>1)
+#define CBUS_TX_MSC_DEVCAP2_get_ld_video(data)                                       ((0x00000002&(data))>>1)
+#define CBUS_TX_MSC_DEVCAP2_ld_display_shift                                         (0)
+#define CBUS_TX_MSC_DEVCAP2_ld_display_mask                                          (0x00000001)
+#define CBUS_TX_MSC_DEVCAP2_ld_display(data)                                         (0x00000001&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP2_ld_display_src(data)                                     ((0x00000001&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP2_get_ld_display(data)                                     ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP3                                                          0x1803710C
+#define CBUS_TX_MSC_DEVCAP3_reg_addr                                                 "0xB803710C"
+#define CBUS_TX_MSC_DEVCAP3_reg                                                      0xB803710C
+#define set_CBUS_TX_MSC_DEVCAP3_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP3_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP3_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP3_reg))
+#define CBUS_TX_MSC_DEVCAP3_inst_adr                                                 "0x0043"
+#define CBUS_TX_MSC_DEVCAP3_inst                                                     0x0043
+#define CBUS_TX_MSC_DEVCAP3_cap_0f_shift                                             (24)
+#define CBUS_TX_MSC_DEVCAP3_cap_0f_mask                                              (0xFF000000)
+#define CBUS_TX_MSC_DEVCAP3_cap_0f(data)                                             (0xFF000000&((data)<<24))
+#define CBUS_TX_MSC_DEVCAP3_cap_0f_src(data)                                         ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSC_DEVCAP3_get_cap_0f(data)                                         ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSC_DEVCAP3_stat_size_shift                                          (20)
+#define CBUS_TX_MSC_DEVCAP3_stat_size_mask                                           (0x00F00000)
+#define CBUS_TX_MSC_DEVCAP3_stat_size(data)                                          (0x00F00000&((data)<<20))
+#define CBUS_TX_MSC_DEVCAP3_stat_size_src(data)                                      ((0x00F00000&(data))>>20)
+#define CBUS_TX_MSC_DEVCAP3_get_stat_size(data)                                      ((0x00F00000&(data))>>20)
+#define CBUS_TX_MSC_DEVCAP3_int_size_shift                                           (16)
+#define CBUS_TX_MSC_DEVCAP3_int_size_mask                                            (0x000F0000)
+#define CBUS_TX_MSC_DEVCAP3_int_size(data)                                           (0x000F0000&((data)<<16))
+#define CBUS_TX_MSC_DEVCAP3_int_size_src(data)                                       ((0x000F0000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP3_get_int_size(data)                                       ((0x000F0000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP3_scratchpad_size_shift                                    (8)
+#define CBUS_TX_MSC_DEVCAP3_scratchpad_size_mask                                     (0x0000FF00)
+#define CBUS_TX_MSC_DEVCAP3_scratchpad_size(data)                                    (0x0000FF00&((data)<<8))
+#define CBUS_TX_MSC_DEVCAP3_scratchpad_size_src(data)                                ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP3_get_scratchpad_size(data)                                ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP3_device_id_l_shift                                        (0)
+#define CBUS_TX_MSC_DEVCAP3_device_id_l_mask                                         (0x000000FF)
+#define CBUS_TX_MSC_DEVCAP3_device_id_l(data)                                        (0x000000FF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP3_device_id_l_src(data)                                    ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP3_get_device_id_l(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP4                                                          0x18037110
+#define CBUS_TX_MSC_DEVCAP4_reg_addr                                                 "0xB8037110"
+#define CBUS_TX_MSC_DEVCAP4_reg                                                      0xB8037110
+#define set_CBUS_TX_MSC_DEVCAP4_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP4_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP4_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP4_reg))
+#define CBUS_TX_MSC_DEVCAP4_inst_adr                                                 "0x0044"
+#define CBUS_TX_MSC_DEVCAP4_inst                                                     0x0044
+#define CBUS_TX_MSC_DEVCAP4_chg23_irq_shift                                          (24)
+#define CBUS_TX_MSC_DEVCAP4_chg23_irq_mask                                           (0xFF000000)
+#define CBUS_TX_MSC_DEVCAP4_chg23_irq(data)                                          (0xFF000000&((data)<<24))
+#define CBUS_TX_MSC_DEVCAP4_chg23_irq_src(data)                                      ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSC_DEVCAP4_get_chg23_irq(data)                                      ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSC_DEVCAP4_chg22_irq_shift                                          (16)
+#define CBUS_TX_MSC_DEVCAP4_chg22_irq_mask                                           (0x00FF0000)
+#define CBUS_TX_MSC_DEVCAP4_chg22_irq(data)                                          (0x00FF0000&((data)<<16))
+#define CBUS_TX_MSC_DEVCAP4_chg22_irq_src(data)                                      ((0x00FF0000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP4_get_chg22_irq(data)                                      ((0x00FF0000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP4_dchg_irq_shift                                           (10)
+#define CBUS_TX_MSC_DEVCAP4_dchg_irq_mask                                            (0x0000FC00)
+#define CBUS_TX_MSC_DEVCAP4_dchg_irq(data)                                           (0x0000FC00&((data)<<10))
+#define CBUS_TX_MSC_DEVCAP4_dchg_irq_src(data)                                       ((0x0000FC00&(data))>>10)
+#define CBUS_TX_MSC_DEVCAP4_get_dchg_irq(data)                                       ((0x0000FC00&(data))>>10)
+#define CBUS_TX_MSC_DEVCAP4_edid_chg_shift                                           (9)
+#define CBUS_TX_MSC_DEVCAP4_edid_chg_mask                                            (0x00000200)
+#define CBUS_TX_MSC_DEVCAP4_edid_chg(data)                                           (0x00000200&((data)<<9))
+#define CBUS_TX_MSC_DEVCAP4_edid_chg_src(data)                                       ((0x00000200&(data))>>9)
+#define CBUS_TX_MSC_DEVCAP4_get_edid_chg(data)                                       ((0x00000200&(data))>>9)
+#define CBUS_TX_MSC_DEVCAP4_dchg_irq_0_shift                                         (8)
+#define CBUS_TX_MSC_DEVCAP4_dchg_irq_0_mask                                          (0x00000100)
+#define CBUS_TX_MSC_DEVCAP4_dchg_irq_0(data)                                         (0x00000100&((data)<<8))
+#define CBUS_TX_MSC_DEVCAP4_dchg_irq_0_src(data)                                     ((0x00000100&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP4_get_dchg_irq_0(data)                                     ((0x00000100&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP4_rchg_irq_shift                                           (5)
+#define CBUS_TX_MSC_DEVCAP4_rchg_irq_mask                                            (0x000000E0)
+#define CBUS_TX_MSC_DEVCAP4_rchg_irq(data)                                           (0x000000E0&((data)<<5))
+#define CBUS_TX_MSC_DEVCAP4_rchg_irq_src(data)                                       ((0x000000E0&(data))>>5)
+#define CBUS_TX_MSC_DEVCAP4_get_rchg_irq(data)                                       ((0x000000E0&(data))>>5)
+#define CBUS_TX_MSC_DEVCAP4_3d_req_shift                                             (4)
+#define CBUS_TX_MSC_DEVCAP4_3d_req_mask                                              (0x00000010)
+#define CBUS_TX_MSC_DEVCAP4_3d_req(data)                                             (0x00000010&((data)<<4))
+#define CBUS_TX_MSC_DEVCAP4_3d_req_src(data)                                         ((0x00000010&(data))>>4)
+#define CBUS_TX_MSC_DEVCAP4_get_3d_req(data)                                         ((0x00000010&(data))>>4)
+#define CBUS_TX_MSC_DEVCAP4_grt_wrt_shift                                            (3)
+#define CBUS_TX_MSC_DEVCAP4_grt_wrt_mask                                             (0x00000008)
+#define CBUS_TX_MSC_DEVCAP4_grt_wrt(data)                                            (0x00000008&((data)<<3))
+#define CBUS_TX_MSC_DEVCAP4_grt_wrt_src(data)                                        ((0x00000008&(data))>>3)
+#define CBUS_TX_MSC_DEVCAP4_get_grt_wrt(data)                                        ((0x00000008&(data))>>3)
+#define CBUS_TX_MSC_DEVCAP4_req_wrt_shift                                            (2)
+#define CBUS_TX_MSC_DEVCAP4_req_wrt_mask                                             (0x00000004)
+#define CBUS_TX_MSC_DEVCAP4_req_wrt(data)                                            (0x00000004&((data)<<2))
+#define CBUS_TX_MSC_DEVCAP4_req_wrt_src(data)                                        ((0x00000004&(data))>>2)
+#define CBUS_TX_MSC_DEVCAP4_get_req_wrt(data)                                        ((0x00000004&(data))>>2)
+#define CBUS_TX_MSC_DEVCAP4_dscr_chg_shift                                           (1)
+#define CBUS_TX_MSC_DEVCAP4_dscr_chg_mask                                            (0x00000002)
+#define CBUS_TX_MSC_DEVCAP4_dscr_chg(data)                                           (0x00000002&((data)<<1))
+#define CBUS_TX_MSC_DEVCAP4_dscr_chg_src(data)                                       ((0x00000002&(data))>>1)
+#define CBUS_TX_MSC_DEVCAP4_get_dscr_chg(data)                                       ((0x00000002&(data))>>1)
+#define CBUS_TX_MSC_DEVCAP4_dcap_chg_shift                                           (0)
+#define CBUS_TX_MSC_DEVCAP4_dcap_chg_mask                                            (0x00000001)
+#define CBUS_TX_MSC_DEVCAP4_dcap_chg(data)                                           (0x00000001&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP4_dcap_chg_src(data)                                       ((0x00000001&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP4_get_dcap_chg(data)                                       ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP5                                                          0x18037114
+#define CBUS_TX_MSC_DEVCAP5_reg_addr                                                 "0xB8037114"
+#define CBUS_TX_MSC_DEVCAP5_reg                                                      0xB8037114
+#define set_CBUS_TX_MSC_DEVCAP5_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP5_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP5_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP5_reg))
+#define CBUS_TX_MSC_DEVCAP5_inst_adr                                                 "0x0045"
+#define CBUS_TX_MSC_DEVCAP5_inst                                                     0x0045
+#define CBUS_TX_MSC_DEVCAP5_chg27_irq_shift                                          (24)
+#define CBUS_TX_MSC_DEVCAP5_chg27_irq_mask                                           (0xFF000000)
+#define CBUS_TX_MSC_DEVCAP5_chg27_irq(data)                                          (0xFF000000&((data)<<24))
+#define CBUS_TX_MSC_DEVCAP5_chg27_irq_src(data)                                      ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSC_DEVCAP5_get_chg27_irq(data)                                      ((0xFF000000&(data))>>24)
+#define CBUS_TX_MSC_DEVCAP5_chg26_irq_shift                                          (16)
+#define CBUS_TX_MSC_DEVCAP5_chg26_irq_mask                                           (0x00FF0000)
+#define CBUS_TX_MSC_DEVCAP5_chg26_irq(data)                                          (0x00FF0000&((data)<<16))
+#define CBUS_TX_MSC_DEVCAP5_chg26_irq_src(data)                                      ((0x00FF0000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP5_get_chg26_irq(data)                                      ((0x00FF0000&(data))>>16)
+#define CBUS_TX_MSC_DEVCAP5_chg25_irq_shift                                          (8)
+#define CBUS_TX_MSC_DEVCAP5_chg25_irq_mask                                           (0x0000FF00)
+#define CBUS_TX_MSC_DEVCAP5_chg25_irq(data)                                          (0x0000FF00&((data)<<8))
+#define CBUS_TX_MSC_DEVCAP5_chg25_irq_src(data)                                      ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP5_get_chg25_irq(data)                                      ((0x0000FF00&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP5_chg24_irq_shift                                          (0)
+#define CBUS_TX_MSC_DEVCAP5_chg24_irq_mask                                           (0x000000FF)
+#define CBUS_TX_MSC_DEVCAP5_chg24_irq(data)                                          (0x000000FF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP5_chg24_irq_src(data)                                      ((0x000000FF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP5_get_chg24_irq(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP6                                                          0x18037118
+#define CBUS_TX_MSC_DEVCAP6_reg_addr                                                 "0xB8037118"
+#define CBUS_TX_MSC_DEVCAP6_reg                                                      0xB8037118
+#define set_CBUS_TX_MSC_DEVCAP6_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP6_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP6_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP6_reg))
+#define CBUS_TX_MSC_DEVCAP6_inst_adr                                                 "0x0046"
+#define CBUS_TX_MSC_DEVCAP6_inst                                                     0x0046
+
+
+#define CBUS_TX_MSC_DEVCAP7                                                          0x1803711C
+#define CBUS_TX_MSC_DEVCAP7_reg_addr                                                 "0xB803711C"
+#define CBUS_TX_MSC_DEVCAP7_reg                                                      0xB803711C
+#define set_CBUS_TX_MSC_DEVCAP7_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP7_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP7_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP7_reg))
+#define CBUS_TX_MSC_DEVCAP7_inst_adr                                                 "0x0047"
+#define CBUS_TX_MSC_DEVCAP7_inst                                                     0x0047
+
+
+#define CBUS_TX_MSC_DEVCAP8                                                          0x18037120
+#define CBUS_TX_MSC_DEVCAP8_reg_addr                                                 "0xB8037120"
+#define CBUS_TX_MSC_DEVCAP8_reg                                                      0xB8037120
+#define set_CBUS_TX_MSC_DEVCAP8_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP8_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP8_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP8_reg))
+#define CBUS_TX_MSC_DEVCAP8_inst_adr                                                 "0x0048"
+#define CBUS_TX_MSC_DEVCAP8_inst                                                     0x0048
+#define CBUS_TX_MSC_DEVCAP8_muted_shift                                              (12)
+#define CBUS_TX_MSC_DEVCAP8_muted_mask                                               (0x00001000)
+#define CBUS_TX_MSC_DEVCAP8_muted(data)                                              (0x00001000&((data)<<12))
+#define CBUS_TX_MSC_DEVCAP8_muted_src(data)                                          ((0x00001000&(data))>>12)
+#define CBUS_TX_MSC_DEVCAP8_get_muted(data)                                          ((0x00001000&(data))>>12)
+#define CBUS_TX_MSC_DEVCAP8_path_en_shift                                            (11)
+#define CBUS_TX_MSC_DEVCAP8_path_en_mask                                             (0x00000800)
+#define CBUS_TX_MSC_DEVCAP8_path_en(data)                                            (0x00000800&((data)<<11))
+#define CBUS_TX_MSC_DEVCAP8_path_en_src(data)                                        ((0x00000800&(data))>>11)
+#define CBUS_TX_MSC_DEVCAP8_get_path_en(data)                                        ((0x00000800&(data))>>11)
+#define CBUS_TX_MSC_DEVCAP8_clk_mode_shift                                           (8)
+#define CBUS_TX_MSC_DEVCAP8_clk_mode_mask                                            (0x00000700)
+#define CBUS_TX_MSC_DEVCAP8_clk_mode(data)                                           (0x00000700&((data)<<8))
+#define CBUS_TX_MSC_DEVCAP8_clk_mode_src(data)                                       ((0x00000700&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP8_get_clk_mode(data)                                       ((0x00000700&(data))>>8)
+#define CBUS_TX_MSC_DEVCAP8_dcap_rdy_shift                                           (0)
+#define CBUS_TX_MSC_DEVCAP8_dcap_rdy_mask                                            (0x00000001)
+#define CBUS_TX_MSC_DEVCAP8_dcap_rdy(data)                                           (0x00000001&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP8_dcap_rdy_src(data)                                       ((0x00000001&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP8_get_dcap_rdy(data)                                       ((0x00000001&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP9                                                          0x18037124
+#define CBUS_TX_MSC_DEVCAP9_reg_addr                                                 "0xB8037124"
+#define CBUS_TX_MSC_DEVCAP9_reg                                                      0xB8037124
+#define set_CBUS_TX_MSC_DEVCAP9_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP9_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP9_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP9_reg))
+#define CBUS_TX_MSC_DEVCAP9_inst_adr                                                 "0x0049"
+#define CBUS_TX_MSC_DEVCAP9_inst                                                     0x0049
+
+
+#define CBUS_TX_MSC_DEVCAP10                                                         0x18037128
+#define CBUS_TX_MSC_DEVCAP10_reg_addr                                                "0xB8037128"
+#define CBUS_TX_MSC_DEVCAP10_reg                                                     0xB8037128
+#define set_CBUS_TX_MSC_DEVCAP10_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP10_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP10_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP10_reg))
+#define CBUS_TX_MSC_DEVCAP10_inst_adr                                                "0x004A"
+#define CBUS_TX_MSC_DEVCAP10_inst                                                    0x004A
+
+
+#define CBUS_TX_MSC_DEVCAP11                                                         0x1803712c
+#define CBUS_TX_MSC_DEVCAP11_reg_addr                                                "0xB803712C"
+#define CBUS_TX_MSC_DEVCAP11_reg                                                     0xB803712C
+#define set_CBUS_TX_MSC_DEVCAP11_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP11_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP11_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP11_reg))
+#define CBUS_TX_MSC_DEVCAP11_inst_adr                                                "0x004B"
+#define CBUS_TX_MSC_DEVCAP11_inst                                                    0x004B
+
+
+#define CBUS_TX_MSC_DEVCAP12                                                         0x18037130
+#define CBUS_TX_MSC_DEVCAP12_reg_addr                                                "0xB8037130"
+#define CBUS_TX_MSC_DEVCAP12_reg                                                     0xB8037130
+#define set_CBUS_TX_MSC_DEVCAP12_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP12_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP12_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP12_reg))
+#define CBUS_TX_MSC_DEVCAP12_inst_adr                                                "0x004C"
+#define CBUS_TX_MSC_DEVCAP12_inst                                                    0x004C
+#define CBUS_TX_MSC_DEVCAP12_scratchpad_reg0_shift                                   (0)
+#define CBUS_TX_MSC_DEVCAP12_scratchpad_reg0_mask                                    (0xFFFFFFFF)
+#define CBUS_TX_MSC_DEVCAP12_scratchpad_reg0(data)                                   (0xFFFFFFFF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP12_scratchpad_reg0_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP12_get_scratchpad_reg0(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP13                                                         0x18037134
+#define CBUS_TX_MSC_DEVCAP13_reg_addr                                                "0xB8037134"
+#define CBUS_TX_MSC_DEVCAP13_reg                                                     0xB8037134
+#define set_CBUS_TX_MSC_DEVCAP13_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP13_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP13_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP13_reg))
+#define CBUS_TX_MSC_DEVCAP13_inst_adr                                                "0x004D"
+#define CBUS_TX_MSC_DEVCAP13_inst                                                    0x004D
+#define CBUS_TX_MSC_DEVCAP13_scratchpad_reg1_shift                                   (0)
+#define CBUS_TX_MSC_DEVCAP13_scratchpad_reg1_mask                                    (0xFFFFFFFF)
+#define CBUS_TX_MSC_DEVCAP13_scratchpad_reg1(data)                                   (0xFFFFFFFF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP13_scratchpad_reg1_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP13_get_scratchpad_reg1(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP14                                                         0x18037138
+#define CBUS_TX_MSC_DEVCAP14_reg_addr                                                "0xB8037138"
+#define CBUS_TX_MSC_DEVCAP14_reg                                                     0xB8037138
+#define set_CBUS_TX_MSC_DEVCAP14_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP14_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP14_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP14_reg))
+#define CBUS_TX_MSC_DEVCAP14_inst_adr                                                "0x004E"
+#define CBUS_TX_MSC_DEVCAP14_inst                                                    0x004E
+#define CBUS_TX_MSC_DEVCAP14_scratchpad_reg2_shift                                   (0)
+#define CBUS_TX_MSC_DEVCAP14_scratchpad_reg2_mask                                    (0xFFFFFFFF)
+#define CBUS_TX_MSC_DEVCAP14_scratchpad_reg2(data)                                   (0xFFFFFFFF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP14_scratchpad_reg2_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP14_get_scratchpad_reg2(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP15                                                         0x1803713C
+#define CBUS_TX_MSC_DEVCAP15_reg_addr                                                "0xB803713C"
+#define CBUS_TX_MSC_DEVCAP15_reg                                                     0xB803713C
+#define set_CBUS_TX_MSC_DEVCAP15_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP15_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP15_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP15_reg))
+#define CBUS_TX_MSC_DEVCAP15_inst_adr                                                "0x004F"
+#define CBUS_TX_MSC_DEVCAP15_inst                                                    0x004F
+#define CBUS_TX_MSC_DEVCAP15_scratchpad_reg3_shift                                   (0)
+#define CBUS_TX_MSC_DEVCAP15_scratchpad_reg3_mask                                    (0xFFFFFFFF)
+#define CBUS_TX_MSC_DEVCAP15_scratchpad_reg3(data)                                   (0xFFFFFFFF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP15_scratchpad_reg3_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP15_get_scratchpad_reg3(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP16                                                         0x18037140
+#define CBUS_TX_MSC_DEVCAP16_reg_addr                                                "0xB8037140"
+#define CBUS_TX_MSC_DEVCAP16_reg                                                     0xB8037140
+#define set_CBUS_TX_MSC_DEVCAP16_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP16_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP16_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP16_reg))
+#define CBUS_TX_MSC_DEVCAP16_inst_adr                                                "0x0050"
+#define CBUS_TX_MSC_DEVCAP16_inst                                                    0x0050
+#define CBUS_TX_MSC_DEVCAP16_scratchpad_reg4_shift                                   (0)
+#define CBUS_TX_MSC_DEVCAP16_scratchpad_reg4_mask                                    (0xFFFFFFFF)
+#define CBUS_TX_MSC_DEVCAP16_scratchpad_reg4(data)                                   (0xFFFFFFFF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP16_scratchpad_reg4_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP16_get_scratchpad_reg4(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP17                                                         0x18037144
+#define CBUS_TX_MSC_DEVCAP17_reg_addr                                                "0xB8037144"
+#define CBUS_TX_MSC_DEVCAP17_reg                                                     0xB8037144
+#define set_CBUS_TX_MSC_DEVCAP17_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP17_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP17_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP17_reg))
+#define CBUS_TX_MSC_DEVCAP17_inst_adr                                                "0x0051"
+#define CBUS_TX_MSC_DEVCAP17_inst                                                    0x0051
+#define CBUS_TX_MSC_DEVCAP17_scratchpad_reg5_shift                                   (0)
+#define CBUS_TX_MSC_DEVCAP17_scratchpad_reg5_mask                                    (0xFFFFFFFF)
+#define CBUS_TX_MSC_DEVCAP17_scratchpad_reg5(data)                                   (0xFFFFFFFF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP17_scratchpad_reg5_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP17_get_scratchpad_reg5(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP18                                                         0x18037148
+#define CBUS_TX_MSC_DEVCAP18_reg_addr                                                "0xB8037148"
+#define CBUS_TX_MSC_DEVCAP18_reg                                                     0xB8037148
+#define set_CBUS_TX_MSC_DEVCAP18_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP18_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP18_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP18_reg))
+#define CBUS_TX_MSC_DEVCAP18_inst_adr                                                "0x0052"
+#define CBUS_TX_MSC_DEVCAP18_inst                                                    0x0052
+#define CBUS_TX_MSC_DEVCAP18_scratchpad_reg6_shift                                   (0)
+#define CBUS_TX_MSC_DEVCAP18_scratchpad_reg6_mask                                    (0xFFFFFFFF)
+#define CBUS_TX_MSC_DEVCAP18_scratchpad_reg6(data)                                   (0xFFFFFFFF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP18_scratchpad_reg6_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP18_get_scratchpad_reg6(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define CBUS_TX_MSC_DEVCAP19                                                         0x1803714C
+#define CBUS_TX_MSC_DEVCAP19_reg_addr                                                "0xB803714C"
+#define CBUS_TX_MSC_DEVCAP19_reg                                                     0xB803714C
+#define set_CBUS_TX_MSC_DEVCAP19_reg(data)   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP19_reg)=data)
+#define get_CBUS_TX_MSC_DEVCAP19_reg   (*((volatile unsigned int*) CBUS_TX_MSC_DEVCAP19_reg))
+#define CBUS_TX_MSC_DEVCAP19_inst_adr                                                "0x0053"
+#define CBUS_TX_MSC_DEVCAP19_inst                                                    0x0053
+#define CBUS_TX_MSC_DEVCAP19_scratchpad_reg7_shift                                   (0)
+#define CBUS_TX_MSC_DEVCAP19_scratchpad_reg7_mask                                    (0xFFFFFFFF)
+#define CBUS_TX_MSC_DEVCAP19_scratchpad_reg7(data)                                   (0xFFFFFFFF&((data)<<0))
+#define CBUS_TX_MSC_DEVCAP19_scratchpad_reg7_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define CBUS_TX_MSC_DEVCAP19_get_scratchpad_reg7(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/cbus_wrapper_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cbus_wrapper_reg.h
new file mode 100644
index 00000000..d795c85
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cbus_wrapper_reg.h
@@ -0,0 +1,77 @@
+/**************************************************************
+// Spec Version                  : unknown
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/5/9 11:15:12
+***************************************************************/
+
+
+#ifndef _CBUS_WRAPPER_REG_H_INCLUDED_
+#define _CBUS_WRAPPER_REG_H_INCLUDED_
+#ifdef  _CBUS_WRAPPER_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     debug_sel:3;
+unsigned int     int_scpu_en:1;
+unsigned int     int_acpu_en:1;
+unsigned int     reserved_1:3;
+unsigned int     hdmirx_ddc_datain_detect:1;
+unsigned int     hdmirx_ddc_sda_delay:4;
+unsigned int     reserved_2:3;
+unsigned int     cbusrx_ddc_datain_detect:1;
+unsigned int     cbusrx_ddc_sda_delay:4;
+}CBUS_WRAPPER_CONTROL;
+
+#endif
+
+#define CBUS_WRAPPER_CONTROL                                                         0x18037500
+#define CBUS_WRAPPER_CONTROL_reg_addr                                                "0xB8037500"
+#define CBUS_WRAPPER_CONTROL_reg                                                     0xB8037500
+#define set_CBUS_WRAPPER_CONTROL_reg(data)   (*((volatile unsigned int*) CBUS_WRAPPER_CONTROL_reg)=data)
+#define get_CBUS_WRAPPER_CONTROL_reg   (*((volatile unsigned int*) CBUS_WRAPPER_CONTROL_reg))
+#define CBUS_WRAPPER_CONTROL_inst_adr                                                "0x0040"
+#define CBUS_WRAPPER_CONTROL_inst                                                    0x0040
+#define CBUS_WRAPPER_CONTROL_debug_sel_shift                                         (18)
+#define CBUS_WRAPPER_CONTROL_debug_sel_mask                                          (0x001C0000)
+#define CBUS_WRAPPER_CONTROL_debug_sel(data)                                         (0x001C0000&((data)<<18))
+#define CBUS_WRAPPER_CONTROL_debug_sel_src(data)                                     ((0x001C0000&(data))>>18)
+#define CBUS_WRAPPER_CONTROL_get_debug_sel(data)                                     ((0x001C0000&(data))>>18)
+#define CBUS_WRAPPER_CONTROL_int_scpu_en_shift                                       (17)
+#define CBUS_WRAPPER_CONTROL_int_scpu_en_mask                                        (0x00020000)
+#define CBUS_WRAPPER_CONTROL_int_scpu_en(data)                                       (0x00020000&((data)<<17))
+#define CBUS_WRAPPER_CONTROL_int_scpu_en_src(data)                                   ((0x00020000&(data))>>17)
+#define CBUS_WRAPPER_CONTROL_get_int_scpu_en(data)                                   ((0x00020000&(data))>>17)
+#define CBUS_WRAPPER_CONTROL_int_acpu_en_shift                                       (16)
+#define CBUS_WRAPPER_CONTROL_int_acpu_en_mask                                        (0x00010000)
+#define CBUS_WRAPPER_CONTROL_int_acpu_en(data)                                       (0x00010000&((data)<<16))
+#define CBUS_WRAPPER_CONTROL_int_acpu_en_src(data)                                   ((0x00010000&(data))>>16)
+#define CBUS_WRAPPER_CONTROL_get_int_acpu_en(data)                                   ((0x00010000&(data))>>16)
+#define CBUS_WRAPPER_CONTROL_hdmirx_ddc_datain_detect_shift                          (12)
+#define CBUS_WRAPPER_CONTROL_hdmirx_ddc_datain_detect_mask                           (0x00001000)
+#define CBUS_WRAPPER_CONTROL_hdmirx_ddc_datain_detect(data)                          (0x00001000&((data)<<12))
+#define CBUS_WRAPPER_CONTROL_hdmirx_ddc_datain_detect_src(data)                      ((0x00001000&(data))>>12)
+#define CBUS_WRAPPER_CONTROL_get_hdmirx_ddc_datain_detect(data)                      ((0x00001000&(data))>>12)
+#define CBUS_WRAPPER_CONTROL_hdmirx_ddc_sda_delay_shift                              (8)
+#define CBUS_WRAPPER_CONTROL_hdmirx_ddc_sda_delay_mask                               (0x00000F00)
+#define CBUS_WRAPPER_CONTROL_hdmirx_ddc_sda_delay(data)                              (0x00000F00&((data)<<8))
+#define CBUS_WRAPPER_CONTROL_hdmirx_ddc_sda_delay_src(data)                          ((0x00000F00&(data))>>8)
+#define CBUS_WRAPPER_CONTROL_get_hdmirx_ddc_sda_delay(data)                          ((0x00000F00&(data))>>8)
+#define CBUS_WRAPPER_CONTROL_cbusrx_ddc_datain_detect_shift                          (4)
+#define CBUS_WRAPPER_CONTROL_cbusrx_ddc_datain_detect_mask                           (0x00000010)
+#define CBUS_WRAPPER_CONTROL_cbusrx_ddc_datain_detect(data)                          (0x00000010&((data)<<4))
+#define CBUS_WRAPPER_CONTROL_cbusrx_ddc_datain_detect_src(data)                      ((0x00000010&(data))>>4)
+#define CBUS_WRAPPER_CONTROL_get_cbusrx_ddc_datain_detect(data)                      ((0x00000010&(data))>>4)
+#define CBUS_WRAPPER_CONTROL_cbusrx_ddc_sda_delay_shift                              (0)
+#define CBUS_WRAPPER_CONTROL_cbusrx_ddc_sda_delay_mask                               (0x0000000F)
+#define CBUS_WRAPPER_CONTROL_cbusrx_ddc_sda_delay(data)                              (0x0000000F&((data)<<0))
+#define CBUS_WRAPPER_CONTROL_cbusrx_ddc_sda_delay_src(data)                          ((0x0000000F&(data))>>0)
+#define CBUS_WRAPPER_CONTROL_get_cbusrx_ddc_sda_delay(data)                          ((0x0000000F&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/cec_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cec_reg.h
new file mode 100644
index 00000000..f8deb23
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cec_reg.h
@@ -0,0 +1,1325 @@
+// This file is generated using the spec version 1.39, firmware template version 1.39and SRIF Parser                                                                                source code SVN rev:793                    Version flow no.:1.1.44
+#ifndef _CEC_REG_H_INCLUDED_
+#define _CEC_REG_H_INCLUDED_
+
+//#define  _DEFAULT_USE_STRUCT
+#ifdef _DEFAULT_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    cec_mode:2;
+    unsigned int    reserved_0:1;
+    unsigned int    test_mode_pad_en:1;
+    unsigned int    logical_addr:4;
+    unsigned int    timer_div:8;
+    unsigned int    pre_div:8;
+    unsigned int    unreg_ack_en:1;
+    unsigned int    reserved_1:1;
+    unsigned int    cdc_arbitration_en:1;
+    unsigned int    test_mode_pad_data:5;
+}CEC_cr0;
+
+typedef struct
+{
+    unsigned int    cec_pad_in:1;
+    unsigned int    reserved_0:11;
+    unsigned int    dummy18007504_19_12:8;
+    unsigned int    clear_cec_int:1;
+    unsigned int    wt_cnt:6;
+    unsigned int    lattest:1;
+    unsigned int    retry_no:4;
+}CEC_rtcr0;
+
+typedef struct
+{
+    unsigned int    broadcast_addr:1;
+    unsigned int    reserved_0:15;
+    unsigned int    rx_en:1;
+    unsigned int    rx_rst:1;
+    unsigned int    rx_continuous:1;
+    unsigned int    rx_int_en:1;
+    unsigned int    init_addr:4;
+    unsigned int    rx_eom:1;
+    unsigned int    rx_int:1;
+    unsigned int    rx_fifo_ov:1;
+    unsigned int    rx_fifo_cnt:5;
+}CEC_rxcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:11;
+    unsigned int    tx_addr_en:1;
+    unsigned int    tx_addr:4;
+    unsigned int    tx_en:1;
+    unsigned int    tx_rst:1;
+    unsigned int    tx_continuous:1;
+    unsigned int    tx_int_en:1;
+    unsigned int    dest_addr:4;
+    unsigned int    tx_eom:1;
+    unsigned int    tx_int:1;
+    unsigned int    tx_fifo_ud:1;
+    unsigned int    tx_fifo_cnt:5;
+}CEC_txcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    tx_add_cnt:1;
+    unsigned int    rx_sub_cnt:1;
+    unsigned int    fifo_cnt:5;
+}CEC_txdr0;
+
+typedef struct
+{
+    unsigned int    tx_fifo_0:8;
+    unsigned int    tx_fifo_1:8;
+    unsigned int    tx_fifo_2:8;
+    unsigned int    tx_fifo_3:8;
+}CEC_txdr1;
+
+typedef struct
+{
+    unsigned int    tx_fifo_4:8;
+    unsigned int    tx_fifo_5:8;
+    unsigned int    tx_fifo_6:8;
+    unsigned int    tx_fifo_7:8;
+}CEC_txdr2;
+
+typedef struct
+{
+    unsigned int    tx_fifo_8:8;
+    unsigned int    tx_fifo_9:8;
+    unsigned int    tx_fifo_a:8;
+    unsigned int    tx_fifo_b:8;
+}CEC_txdr3;
+
+typedef struct
+{
+    unsigned int    tx_fifo_c:8;
+    unsigned int    tx_fifo_d:8;
+    unsigned int    tx_fifo_e:8;
+    unsigned int    tx_fifo_f:8;
+}CEC_txdr4;
+
+typedef struct
+{
+    unsigned int    rx_fifo_0:8;
+    unsigned int    rx_fifo_1:8;
+    unsigned int    rx_fifo_2:8;
+    unsigned int    rx_fifo_3:8;
+}CEC_rxdr1;
+
+typedef struct
+{
+    unsigned int    rx_fifo_4:8;
+    unsigned int    rx_fifo_5:8;
+    unsigned int    rx_fifo_6:8;
+    unsigned int    rx_fifo_7:8;
+}CEC_rxdr2;
+
+typedef struct
+{
+    unsigned int    rx_fifo_8:8;
+    unsigned int    rx_fifo_9:8;
+    unsigned int    rx_fifo_a:8;
+    unsigned int    rx_fifo_b:8;
+}CEC_rxdr3;
+
+typedef struct
+{
+    unsigned int    rx_fifo_c:8;
+    unsigned int    rx_fifo_d:8;
+    unsigned int    rx_fifo_e:8;
+    unsigned int    rx_fifo_f:8;
+}CEC_rxdr4;
+
+typedef struct
+{
+    unsigned int    rx_start_low:8;
+    unsigned int    rx_start_period:8;
+    unsigned int    rx_data_sample:8;
+    unsigned int    rx_data_period:8;
+}CEC_rxtcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    tx_start_low:8;
+    unsigned int    tx_start_high:8;
+}CEC_txtcr0;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    tx_data_low:8;
+    unsigned int    tx_data_01:8;
+    unsigned int    tx_data_high:8;
+}CEC_txtcr1;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_01:8;
+}GDI_cec_compare_opcode_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    send_opcode_01:8;
+}GDI_cec_send_opcode_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    reserved_1:6;
+    unsigned int    operand_number_01:2;
+}GDI_cec_send_operand_number_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_01:8;
+}GDI_cec_operand_01;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_02:8;
+}GDI_cec_operand_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_03:8;
+}GDI_cec_operand_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_02:8;
+}GDI_cec_compare_opcode_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    send_opcode_02:8;
+}GDI_cec_send_opcode_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    reserved_1:6;
+    unsigned int    operand_number_02:2;
+}GDI_cec_send_operand_number_02;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_04:8;
+}GDI_cec_operand_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_05:8;
+}GDI_cec_operand_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_06:8;
+}GDI_cec_operand_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_03:8;
+}GDI_cec_compare_opcode_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    send_opcode_03:8;
+}GDI_cec_send_opcode_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    reserved_1:6;
+    unsigned int    operand_number_03:2;
+}GDI_cec_send_operand_number_03;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_07:8;
+}GDI_cec_operand_07;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_08:8;
+}GDI_cec_operand_08;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_09:8;
+}GDI_cec_operand_09;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_04:8;
+}GDI_cec_compare_opcode_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    send_opcode_04:8;
+}GDI_cec_send_opcode_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    reserved_1:6;
+    unsigned int    operand_number_04:2;
+}GDI_cec_send_operand_number_04;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_10:8;
+}GDI_cec_operand_10;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_11:8;
+}GDI_cec_operand_11;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    operand_12:8;
+}GDI_cec_operand_12;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_05:8;
+}GDI_cec_compare_opcode_05;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_06:8;
+}GDI_cec_compare_opcode_06;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_07:8;
+}GDI_cec_compare_opcode_07;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_08:8;
+}GDI_cec_compare_opcode_08;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_09:8;
+}GDI_cec_compare_opcode_09;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_10:8;
+}GDI_cec_compare_opcode_10;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_11:8;
+}GDI_cec_compare_opcode_11;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_12:8;
+}GDI_cec_compare_opcode_12;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_13:8;
+}GDI_cec_compare_opcode_13;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_14:8;
+}GDI_cec_compare_opcode_14;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    compare_opcode_15:8;
+}GDI_cec_compare_opcode_15;
+
+typedef struct
+{
+    unsigned int    reserved_0:17;
+    unsigned int    en_compare_opcode_15:1;
+    unsigned int    en_compare_opcode_14:1;
+    unsigned int    en_compare_opcode_13:1;
+    unsigned int    en_compare_opcode_12:1;
+    unsigned int    en_compare_opcode_11:1;
+    unsigned int    en_compare_opcode_10:1;
+    unsigned int    en_compare_opcode_09:1;
+    unsigned int    en_compare_opcode_08:1;
+    unsigned int    en_compare_opcode_07:1;
+    unsigned int    en_compare_opcode_06:1;
+    unsigned int    en_compare_opcode_05:1;
+    unsigned int    en_compare_opcode_04:1;
+    unsigned int    en_compare_opcode_03:1;
+    unsigned int    en_compare_opcode_02:1;
+    unsigned int    en_compare_opcode_01:1;
+}GDI_cec_opcode_enable;
+
+typedef struct
+{
+    unsigned int    irq_pending:1;
+    unsigned int    reserved_0:5;
+    unsigned int    cec_msg_status_01:1;
+    unsigned int    cec_msg_status_02:1;
+    unsigned int    reserved_1:15;
+    unsigned int    irq_by_cec_receive_special_cmd:1;
+    unsigned int    reserved_2:4;
+    unsigned int    reserved_3:4;
+}GDI_power_saving_mode;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    vcckoff_33v:1;
+}CEC_analog_01;
+#endif
+
+
+#define CEC_CR0                                                       0x18007500
+#define CEC_CR0_reg_addr                                              "0xb8007500"
+#define CEC_CR0_reg                                                   0xb8007500
+#define CEC_CR0_inst_addr                                             "0x0380"
+#define CEC_CR0_inst                                                  0x0380
+#define CEC_CR0_cec_mode_shift                                        (30)
+#define CEC_CR0_test_mode_pad_en_shift                                (28)
+#define CEC_CR0_logical_addr_shift                                    (24)
+#define CEC_CR0_timer_div_shift                                       (16)
+#define CEC_CR0_pre_div_shift                                         (8)
+#define CEC_CR0_unreg_ack_en_shift                                    (7)
+#define CEC_CR0_cdc_arbitration_en_shift                              (5)
+#define CEC_CR0_test_mode_pad_data_shift                              (0)
+#define CEC_CR0_cec_mode_mask                                         (0xC0000000)
+#define CEC_CR0_test_mode_pad_en_mask                                 (0x10000000)
+#define CEC_CR0_logical_addr_mask                                     (0x0F000000)
+#define CEC_CR0_timer_div_mask                                        (0x00FF0000)
+#define CEC_CR0_pre_div_mask                                          (0x0000FF00)
+#define CEC_CR0_unreg_ack_en_mask                                     (0x00000080)
+#define CEC_CR0_cdc_arbitration_en_mask                               (0x00000020)
+#define CEC_CR0_test_mode_pad_data_mask                               (0x0000001F)
+#define CEC_CR0_cec_mode(data)                                        (0xC0000000&((data)<<30))
+#define CEC_CR0_test_mode_pad_en(data)                                (0x10000000&((data)<<28))
+#define CEC_CR0_logical_addr(data)                                    (0x0F000000&((data)<<24))
+#define CEC_CR0_timer_div(data)                                       (0x00FF0000&((data)<<16))
+#define CEC_CR0_pre_div(data)                                         (0x0000FF00&((data)<<8))
+#define CEC_CR0_unreg_ack_en(data)                                    (0x00000080&((data)<<7))
+#define CEC_CR0_cdc_arbitration_en(data)                              (0x00000020&((data)<<5))
+#define CEC_CR0_test_mode_pad_data(data)                              (0x0000001F&(data))
+#define CEC_CR0_get_cec_mode(data)                                    ((0xC0000000&(data))>>30)
+#define CEC_CR0_get_test_mode_pad_en(data)                            ((0x10000000&(data))>>28)
+#define CEC_CR0_get_logical_addr(data)                                ((0x0F000000&(data))>>24)
+#define CEC_CR0_get_timer_div(data)                                   ((0x00FF0000&(data))>>16)
+#define CEC_CR0_get_pre_div(data)                                     ((0x0000FF00&(data))>>8)
+#define CEC_CR0_get_unreg_ack_en(data)                                ((0x00000080&(data))>>7)
+#define CEC_CR0_get_cdc_arbitration_en(data)                          ((0x00000020&(data))>>5)
+#define CEC_CR0_get_test_mode_pad_data(data)                          (0x0000001F&(data))
+
+
+#define CEC_RTCR0                                                     0x18007504
+#define CEC_RTCR0_reg_addr                                            "0xb8007504"
+#define CEC_RTCR0_reg                                                 0xb8007504
+#define CEC_RTCR0_inst_addr                                           "0x0381"
+#define CEC_RTCR0_inst                                                0x0381
+#define CEC_RTCR0_cec_pad_in_shift                                    (31)
+#define CEC_RTCR0_dummy18007504_19_12_shift                           (12)
+#define CEC_RTCR0_clear_cec_int_shift                                 (11)
+#define CEC_RTCR0_wt_cnt_shift                                        (5)
+#define CEC_RTCR0_lattest_shift                                       (4)
+#define CEC_RTCR0_retry_no_shift                                      (0)
+#define CEC_RTCR0_cec_pad_in_mask                                     (0x80000000)
+#define CEC_RTCR0_dummy18007504_19_12_mask                            (0x000FF000)
+#define CEC_RTCR0_clear_cec_int_mask                                  (0x00000800)
+#define CEC_RTCR0_wt_cnt_mask                                         (0x000007E0)
+#define CEC_RTCR0_lattest_mask                                        (0x00000010)
+#define CEC_RTCR0_retry_no_mask                                       (0x0000000F)
+#define CEC_RTCR0_cec_pad_in(data)                                    (0x80000000&((data)<<31))
+#define CEC_RTCR0_dummy18007504_19_12(data)                           (0x000FF000&((data)<<12))
+#define CEC_RTCR0_clear_cec_int(data)                                 (0x00000800&((data)<<11))
+#define CEC_RTCR0_wt_cnt(data)                                        (0x000007E0&((data)<<5))
+#define CEC_RTCR0_lattest(data)                                       (0x00000010&((data)<<4))
+#define CEC_RTCR0_retry_no(data)                                      (0x0000000F&(data))
+#define CEC_RTCR0_get_cec_pad_in(data)                                ((0x80000000&(data))>>31)
+#define CEC_RTCR0_get_dummy18007504_19_12(data)                       ((0x000FF000&(data))>>12)
+#define CEC_RTCR0_get_clear_cec_int(data)                             ((0x00000800&(data))>>11)
+#define CEC_RTCR0_get_wt_cnt(data)                                    ((0x000007E0&(data))>>5)
+#define CEC_RTCR0_get_lattest(data)                                   ((0x00000010&(data))>>4)
+#define CEC_RTCR0_get_retry_no(data)                                  (0x0000000F&(data))
+
+
+#define CEC_RXCR0                                                     0x18007508
+#define CEC_RXCR0_reg_addr                                            "0xb8007508"
+#define CEC_RXCR0_reg                                                 0xb8007508
+#define CEC_RXCR0_inst_addr                                           "0x0382"
+#define CEC_RXCR0_inst                                                0x0382
+#define CEC_RXCR0_broadcast_addr_shift                                (31)
+#define CEC_RXCR0_rx_en_shift                                         (15)
+#define CEC_RXCR0_rx_rst_shift                                        (14)
+#define CEC_RXCR0_rx_continuous_shift                                 (13)
+#define CEC_RXCR0_rx_int_en_shift                                     (12)
+#define CEC_RXCR0_init_addr_shift                                     (8)
+#define CEC_RXCR0_rx_eom_shift                                        (7)
+#define CEC_RXCR0_rx_int_shift                                        (6)
+#define CEC_RXCR0_rx_fifo_ov_shift                                    (5)
+#define CEC_RXCR0_rx_fifo_cnt_shift                                   (0)
+#define CEC_RXCR0_broadcast_addr_mask                                 (0x80000000)
+#define CEC_RXCR0_rx_en_mask                                          (0x00008000)
+#define CEC_RXCR0_rx_rst_mask                                         (0x00004000)
+#define CEC_RXCR0_rx_continuous_mask                                  (0x00002000)
+#define CEC_RXCR0_rx_int_en_mask                                      (0x00001000)
+#define CEC_RXCR0_init_addr_mask                                      (0x00000F00)
+#define CEC_RXCR0_rx_eom_mask                                         (0x00000080)
+#define CEC_RXCR0_rx_int_mask                                         (0x00000040)
+#define CEC_RXCR0_rx_fifo_ov_mask                                     (0x00000020)
+#define CEC_RXCR0_rx_fifo_cnt_mask                                    (0x0000001F)
+#define CEC_RXCR0_broadcast_addr(data)                                (0x80000000&((data)<<31))
+#define CEC_RXCR0_rx_en(data)                                         (0x00008000&((data)<<15))
+#define CEC_RXCR0_rx_rst(data)                                        (0x00004000&((data)<<14))
+#define CEC_RXCR0_rx_continuous(data)                                 (0x00002000&((data)<<13))
+#define CEC_RXCR0_rx_int_en(data)                                     (0x00001000&((data)<<12))
+#define CEC_RXCR0_init_addr(data)                                     (0x00000F00&((data)<<8))
+#define CEC_RXCR0_rx_eom(data)                                        (0x00000080&((data)<<7))
+#define CEC_RXCR0_rx_int(data)                                        (0x00000040&((data)<<6))
+#define CEC_RXCR0_rx_fifo_ov(data)                                    (0x00000020&((data)<<5))
+#define CEC_RXCR0_rx_fifo_cnt(data)                                   (0x0000001F&(data))
+#define CEC_RXCR0_get_broadcast_addr(data)                            ((0x80000000&(data))>>31)
+#define CEC_RXCR0_get_rx_en(data)                                     ((0x00008000&(data))>>15)
+#define CEC_RXCR0_get_rx_rst(data)                                    ((0x00004000&(data))>>14)
+#define CEC_RXCR0_get_rx_continuous(data)                             ((0x00002000&(data))>>13)
+#define CEC_RXCR0_get_rx_int_en(data)                                 ((0x00001000&(data))>>12)
+#define CEC_RXCR0_get_init_addr(data)                                 ((0x00000F00&(data))>>8)
+#define CEC_RXCR0_get_rx_eom(data)                                    ((0x00000080&(data))>>7)
+#define CEC_RXCR0_get_rx_int(data)                                    ((0x00000040&(data))>>6)
+#define CEC_RXCR0_get_rx_fifo_ov(data)                                ((0x00000020&(data))>>5)
+#define CEC_RXCR0_get_rx_fifo_cnt(data)                               (0x0000001F&(data))
+
+
+#define CEC_TXCR0                                                     0x1800750c
+#define CEC_TXCR0_reg_addr                                            "0xb800750c"
+#define CEC_TXCR0_reg                                                 0xb800750c
+#define CEC_TXCR0_inst_addr                                           "0x0383"
+#define CEC_TXCR0_inst                                                0x0383
+#define CEC_TXCR0_tx_addr_en_shift                                    (20)
+#define CEC_TXCR0_tx_addr_shift                                       (16)
+#define CEC_TXCR0_tx_en_shift                                         (15)
+#define CEC_TXCR0_tx_rst_shift                                        (14)
+#define CEC_TXCR0_tx_continuous_shift                                 (13)
+#define CEC_TXCR0_tx_int_en_shift                                     (12)
+#define CEC_TXCR0_dest_addr_shift                                     (8)
+#define CEC_TXCR0_tx_eom_shift                                        (7)
+#define CEC_TXCR0_tx_int_shift                                        (6)
+#define CEC_TXCR0_tx_fifo_ud_shift                                    (5)
+#define CEC_TXCR0_tx_fifo_cnt_shift                                   (0)
+#define CEC_TXCR0_tx_addr_en_mask                                     (0x00100000)
+#define CEC_TXCR0_tx_addr_mask                                        (0x000F0000)
+#define CEC_TXCR0_tx_en_mask                                          (0x00008000)
+#define CEC_TXCR0_tx_rst_mask                                         (0x00004000)
+#define CEC_TXCR0_tx_continuous_mask                                  (0x00002000)
+#define CEC_TXCR0_tx_int_en_mask                                      (0x00001000)
+#define CEC_TXCR0_dest_addr_mask                                      (0x00000F00)
+#define CEC_TXCR0_tx_eom_mask                                         (0x00000080)
+#define CEC_TXCR0_tx_int_mask                                         (0x00000040)
+#define CEC_TXCR0_tx_fifo_ud_mask                                     (0x00000020)
+#define CEC_TXCR0_tx_fifo_cnt_mask                                    (0x0000001F)
+#define CEC_TXCR0_tx_addr_en(data)                                    (0x00100000&((data)<<20))
+#define CEC_TXCR0_tx_addr(data)                                       (0x000F0000&((data)<<16))
+#define CEC_TXCR0_tx_en(data)                                         (0x00008000&((data)<<15))
+#define CEC_TXCR0_tx_rst(data)                                        (0x00004000&((data)<<14))
+#define CEC_TXCR0_tx_continuous(data)                                 (0x00002000&((data)<<13))
+#define CEC_TXCR0_tx_int_en(data)                                     (0x00001000&((data)<<12))
+#define CEC_TXCR0_dest_addr(data)                                     (0x00000F00&((data)<<8))
+#define CEC_TXCR0_tx_eom(data)                                        (0x00000080&((data)<<7))
+#define CEC_TXCR0_tx_int(data)                                        (0x00000040&((data)<<6))
+#define CEC_TXCR0_tx_fifo_ud(data)                                    (0x00000020&((data)<<5))
+#define CEC_TXCR0_tx_fifo_cnt(data)                                   (0x0000001F&(data))
+#define CEC_TXCR0_get_tx_addr_en(data)                                ((0x00100000&(data))>>20)
+#define CEC_TXCR0_get_tx_addr(data)                                   ((0x000F0000&(data))>>16)
+#define CEC_TXCR0_get_tx_en(data)                                     ((0x00008000&(data))>>15)
+#define CEC_TXCR0_get_tx_rst(data)                                    ((0x00004000&(data))>>14)
+#define CEC_TXCR0_get_tx_continuous(data)                             ((0x00002000&(data))>>13)
+#define CEC_TXCR0_get_tx_int_en(data)                                 ((0x00001000&(data))>>12)
+#define CEC_TXCR0_get_dest_addr(data)                                 ((0x00000F00&(data))>>8)
+#define CEC_TXCR0_get_tx_eom(data)                                    ((0x00000080&(data))>>7)
+#define CEC_TXCR0_get_tx_int(data)                                    ((0x00000040&(data))>>6)
+#define CEC_TXCR0_get_tx_fifo_ud(data)                                ((0x00000020&(data))>>5)
+#define CEC_TXCR0_get_tx_fifo_cnt(data)                               (0x0000001F&(data))
+
+
+#define CEC_TXDR0                                                     0x18007510
+#define CEC_TXDR0_reg_addr                                            "0xb8007510"
+#define CEC_TXDR0_reg                                                 0xb8007510
+#define CEC_TXDR0_inst_addr                                           "0x0384"
+#define CEC_TXDR0_inst                                                0x0384
+#define CEC_TXDR0_tx_add_cnt_shift                                    (6)
+#define CEC_TXDR0_rx_sub_cnt_shift                                    (5)
+#define CEC_TXDR0_fifo_cnt_shift                                      (0)
+#define CEC_TXDR0_tx_add_cnt_mask                                     (0x00000040)
+#define CEC_TXDR0_rx_sub_cnt_mask                                     (0x00000020)
+#define CEC_TXDR0_fifo_cnt_mask                                       (0x0000001F)
+#define CEC_TXDR0_tx_add_cnt(data)                                    (0x00000040&((data)<<6))
+#define CEC_TXDR0_rx_sub_cnt(data)                                    (0x00000020&((data)<<5))
+#define CEC_TXDR0_fifo_cnt(data)                                      (0x0000001F&(data))
+#define CEC_TXDR0_get_tx_add_cnt(data)                                ((0x00000040&(data))>>6)
+#define CEC_TXDR0_get_rx_sub_cnt(data)                                ((0x00000020&(data))>>5)
+#define CEC_TXDR0_get_fifo_cnt(data)                                  (0x0000001F&(data))
+
+
+#define CEC_TXDR1                                                     0x18007514
+#define CEC_TXDR1_reg_addr                                            "0xb8007514"
+#define CEC_TXDR1_reg                                                 0xb8007514
+#define CEC_TXDR1_inst_addr                                           "0x0385"
+#define CEC_TXDR1_inst                                                0x0385
+#define CEC_TXDR1_tx_fifo_0_shift                                     (24)
+#define CEC_TXDR1_tx_fifo_1_shift                                     (16)
+#define CEC_TXDR1_tx_fifo_2_shift                                     (8)
+#define CEC_TXDR1_tx_fifo_3_shift                                     (0)
+#define CEC_TXDR1_tx_fifo_0_mask                                      (0xFF000000)
+#define CEC_TXDR1_tx_fifo_1_mask                                      (0x00FF0000)
+#define CEC_TXDR1_tx_fifo_2_mask                                      (0x0000FF00)
+#define CEC_TXDR1_tx_fifo_3_mask                                      (0x000000FF)
+#define CEC_TXDR1_tx_fifo_0(data)                                     (0xFF000000&((data)<<24))
+#define CEC_TXDR1_tx_fifo_1(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_TXDR1_tx_fifo_2(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_TXDR1_tx_fifo_3(data)                                     (0x000000FF&(data))
+#define CEC_TXDR1_get_tx_fifo_0(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_TXDR1_get_tx_fifo_1(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_TXDR1_get_tx_fifo_2(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_TXDR1_get_tx_fifo_3(data)                                 (0x000000FF&(data))
+
+
+#define CEC_TXDR2                                                     0x18007518
+#define CEC_TXDR2_reg_addr                                            "0xb8007518"
+#define CEC_TXDR2_reg                                                 0xb8007518
+#define CEC_TXDR2_inst_addr                                           "0x0386"
+#define CEC_TXDR2_inst                                                0x0386
+#define CEC_TXDR2_tx_fifo_4_shift                                     (24)
+#define CEC_TXDR2_tx_fifo_5_shift                                     (16)
+#define CEC_TXDR2_tx_fifo_6_shift                                     (8)
+#define CEC_TXDR2_tx_fifo_7_shift                                     (0)
+#define CEC_TXDR2_tx_fifo_4_mask                                      (0xFF000000)
+#define CEC_TXDR2_tx_fifo_5_mask                                      (0x00FF0000)
+#define CEC_TXDR2_tx_fifo_6_mask                                      (0x0000FF00)
+#define CEC_TXDR2_tx_fifo_7_mask                                      (0x000000FF)
+#define CEC_TXDR2_tx_fifo_4(data)                                     (0xFF000000&((data)<<24))
+#define CEC_TXDR2_tx_fifo_5(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_TXDR2_tx_fifo_6(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_TXDR2_tx_fifo_7(data)                                     (0x000000FF&(data))
+#define CEC_TXDR2_get_tx_fifo_4(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_TXDR2_get_tx_fifo_5(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_TXDR2_get_tx_fifo_6(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_TXDR2_get_tx_fifo_7(data)                                 (0x000000FF&(data))
+
+
+#define CEC_TXDR3                                                     0x1800751c
+#define CEC_TXDR3_reg_addr                                            "0xb800751c"
+#define CEC_TXDR3_reg                                                 0xb800751c
+#define CEC_TXDR3_inst_addr                                           "0x0387"
+#define CEC_TXDR3_inst                                                0x0387
+#define CEC_TXDR3_tx_fifo_8_shift                                     (24)
+#define CEC_TXDR3_tx_fifo_9_shift                                     (16)
+#define CEC_TXDR3_tx_fifo_a_shift                                     (8)
+#define CEC_TXDR3_tx_fifo_b_shift                                     (0)
+#define CEC_TXDR3_tx_fifo_8_mask                                      (0xFF000000)
+#define CEC_TXDR3_tx_fifo_9_mask                                      (0x00FF0000)
+#define CEC_TXDR3_tx_fifo_a_mask                                      (0x0000FF00)
+#define CEC_TXDR3_tx_fifo_b_mask                                      (0x000000FF)
+#define CEC_TXDR3_tx_fifo_8(data)                                     (0xFF000000&((data)<<24))
+#define CEC_TXDR3_tx_fifo_9(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_TXDR3_tx_fifo_a(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_TXDR3_tx_fifo_b(data)                                     (0x000000FF&(data))
+#define CEC_TXDR3_get_tx_fifo_8(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_TXDR3_get_tx_fifo_9(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_TXDR3_get_tx_fifo_a(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_TXDR3_get_tx_fifo_b(data)                                 (0x000000FF&(data))
+
+
+#define CEC_TXDR4                                                     0x18007520
+#define CEC_TXDR4_reg_addr                                            "0xb8007520"
+#define CEC_TXDR4_reg                                                 0xb8007520
+#define CEC_TXDR4_inst_addr                                           "0x0388"
+#define CEC_TXDR4_inst                                                0x0388
+#define CEC_TXDR4_tx_fifo_c_shift                                     (24)
+#define CEC_TXDR4_tx_fifo_d_shift                                     (16)
+#define CEC_TXDR4_tx_fifo_e_shift                                     (8)
+#define CEC_TXDR4_tx_fifo_f_shift                                     (0)
+#define CEC_TXDR4_tx_fifo_c_mask                                      (0xFF000000)
+#define CEC_TXDR4_tx_fifo_d_mask                                      (0x00FF0000)
+#define CEC_TXDR4_tx_fifo_e_mask                                      (0x0000FF00)
+#define CEC_TXDR4_tx_fifo_f_mask                                      (0x000000FF)
+#define CEC_TXDR4_tx_fifo_c(data)                                     (0xFF000000&((data)<<24))
+#define CEC_TXDR4_tx_fifo_d(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_TXDR4_tx_fifo_e(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_TXDR4_tx_fifo_f(data)                                     (0x000000FF&(data))
+#define CEC_TXDR4_get_tx_fifo_c(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_TXDR4_get_tx_fifo_d(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_TXDR4_get_tx_fifo_e(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_TXDR4_get_tx_fifo_f(data)                                 (0x000000FF&(data))
+
+
+#define CEC_RXDR1                                                     0x18007524
+#define CEC_RXDR1_reg_addr                                            "0xb8007524"
+#define CEC_RXDR1_reg                                                 0xb8007524
+#define CEC_RXDR1_inst_addr                                           "0x0389"
+#define CEC_RXDR1_inst                                                0x0389
+#define CEC_RXDR1_rx_fifo_0_shift                                     (24)
+#define CEC_RXDR1_rx_fifo_1_shift                                     (16)
+#define CEC_RXDR1_rx_fifo_2_shift                                     (8)
+#define CEC_RXDR1_rx_fifo_3_shift                                     (0)
+#define CEC_RXDR1_rx_fifo_0_mask                                      (0xFF000000)
+#define CEC_RXDR1_rx_fifo_1_mask                                      (0x00FF0000)
+#define CEC_RXDR1_rx_fifo_2_mask                                      (0x0000FF00)
+#define CEC_RXDR1_rx_fifo_3_mask                                      (0x000000FF)
+#define CEC_RXDR1_rx_fifo_0(data)                                     (0xFF000000&((data)<<24))
+#define CEC_RXDR1_rx_fifo_1(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_RXDR1_rx_fifo_2(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_RXDR1_rx_fifo_3(data)                                     (0x000000FF&(data))
+#define CEC_RXDR1_get_rx_fifo_0(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_RXDR1_get_rx_fifo_1(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_RXDR1_get_rx_fifo_2(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_RXDR1_get_rx_fifo_3(data)                                 (0x000000FF&(data))
+
+
+#define CEC_RXDR2                                                     0x18007528
+#define CEC_RXDR2_reg_addr                                            "0xb8007528"
+#define CEC_RXDR2_reg                                                 0xb8007528
+#define CEC_RXDR2_inst_addr                                           "0x038A"
+#define CEC_RXDR2_inst                                                0x038A
+#define CEC_RXDR2_rx_fifo_4_shift                                     (24)
+#define CEC_RXDR2_rx_fifo_5_shift                                     (16)
+#define CEC_RXDR2_rx_fifo_6_shift                                     (8)
+#define CEC_RXDR2_rx_fifo_7_shift                                     (0)
+#define CEC_RXDR2_rx_fifo_4_mask                                      (0xFF000000)
+#define CEC_RXDR2_rx_fifo_5_mask                                      (0x00FF0000)
+#define CEC_RXDR2_rx_fifo_6_mask                                      (0x0000FF00)
+#define CEC_RXDR2_rx_fifo_7_mask                                      (0x000000FF)
+#define CEC_RXDR2_rx_fifo_4(data)                                     (0xFF000000&((data)<<24))
+#define CEC_RXDR2_rx_fifo_5(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_RXDR2_rx_fifo_6(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_RXDR2_rx_fifo_7(data)                                     (0x000000FF&(data))
+#define CEC_RXDR2_get_rx_fifo_4(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_RXDR2_get_rx_fifo_5(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_RXDR2_get_rx_fifo_6(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_RXDR2_get_rx_fifo_7(data)                                 (0x000000FF&(data))
+
+
+#define CEC_RXDR3                                                     0x1800752c
+#define CEC_RXDR3_reg_addr                                            "0xb800752c"
+#define CEC_RXDR3_reg                                                 0xb800752c
+#define CEC_RXDR3_inst_addr                                           "0x038B"
+#define CEC_RXDR3_inst                                                0x038B
+#define CEC_RXDR3_rx_fifo_8_shift                                     (24)
+#define CEC_RXDR3_rx_fifo_9_shift                                     (16)
+#define CEC_RXDR3_rx_fifo_a_shift                                     (8)
+#define CEC_RXDR3_rx_fifo_b_shift                                     (0)
+#define CEC_RXDR3_rx_fifo_8_mask                                      (0xFF000000)
+#define CEC_RXDR3_rx_fifo_9_mask                                      (0x00FF0000)
+#define CEC_RXDR3_rx_fifo_a_mask                                      (0x0000FF00)
+#define CEC_RXDR3_rx_fifo_b_mask                                      (0x000000FF)
+#define CEC_RXDR3_rx_fifo_8(data)                                     (0xFF000000&((data)<<24))
+#define CEC_RXDR3_rx_fifo_9(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_RXDR3_rx_fifo_a(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_RXDR3_rx_fifo_b(data)                                     (0x000000FF&(data))
+#define CEC_RXDR3_get_rx_fifo_8(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_RXDR3_get_rx_fifo_9(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_RXDR3_get_rx_fifo_a(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_RXDR3_get_rx_fifo_b(data)                                 (0x000000FF&(data))
+
+
+#define CEC_RXDR4                                                     0x18007530
+#define CEC_RXDR4_reg_addr                                            "0xb8007530"
+#define CEC_RXDR4_reg                                                 0xb8007530
+#define CEC_RXDR4_inst_addr                                           "0x038C"
+#define CEC_RXDR4_inst                                                0x038C
+#define CEC_RXDR4_rx_fifo_c_shift                                     (24)
+#define CEC_RXDR4_rx_fifo_d_shift                                     (16)
+#define CEC_RXDR4_rx_fifo_e_shift                                     (8)
+#define CEC_RXDR4_rx_fifo_f_shift                                     (0)
+#define CEC_RXDR4_rx_fifo_c_mask                                      (0xFF000000)
+#define CEC_RXDR4_rx_fifo_d_mask                                      (0x00FF0000)
+#define CEC_RXDR4_rx_fifo_e_mask                                      (0x0000FF00)
+#define CEC_RXDR4_rx_fifo_f_mask                                      (0x000000FF)
+#define CEC_RXDR4_rx_fifo_c(data)                                     (0xFF000000&((data)<<24))
+#define CEC_RXDR4_rx_fifo_d(data)                                     (0x00FF0000&((data)<<16))
+#define CEC_RXDR4_rx_fifo_e(data)                                     (0x0000FF00&((data)<<8))
+#define CEC_RXDR4_rx_fifo_f(data)                                     (0x000000FF&(data))
+#define CEC_RXDR4_get_rx_fifo_c(data)                                 ((0xFF000000&(data))>>24)
+#define CEC_RXDR4_get_rx_fifo_d(data)                                 ((0x00FF0000&(data))>>16)
+#define CEC_RXDR4_get_rx_fifo_e(data)                                 ((0x0000FF00&(data))>>8)
+#define CEC_RXDR4_get_rx_fifo_f(data)                                 (0x000000FF&(data))
+
+
+#define CEC_RXTCR0                                                    0x18007534
+#define CEC_RXTCR0_reg_addr                                           "0xb8007534"
+#define CEC_RXTCR0_reg                                                0xb8007534
+#define CEC_RXTCR0_inst_addr                                          "0x038D"
+#define CEC_RXTCR0_inst                                               0x038D
+#define CEC_RXTCR0_rx_start_low_shift                                 (24)
+#define CEC_RXTCR0_rx_start_period_shift                              (16)
+#define CEC_RXTCR0_rx_data_sample_shift                               (8)
+#define CEC_RXTCR0_rx_data_period_shift                               (0)
+#define CEC_RXTCR0_rx_start_low_mask                                  (0xFF000000)
+#define CEC_RXTCR0_rx_start_period_mask                               (0x00FF0000)
+#define CEC_RXTCR0_rx_data_sample_mask                                (0x0000FF00)
+#define CEC_RXTCR0_rx_data_period_mask                                (0x000000FF)
+#define CEC_RXTCR0_rx_start_low(data)                                 (0xFF000000&((data)<<24))
+#define CEC_RXTCR0_rx_start_period(data)                              (0x00FF0000&((data)<<16))
+#define CEC_RXTCR0_rx_data_sample(data)                               (0x0000FF00&((data)<<8))
+#define CEC_RXTCR0_rx_data_period(data)                               (0x000000FF&(data))
+#define CEC_RXTCR0_get_rx_start_low(data)                             ((0xFF000000&(data))>>24)
+#define CEC_RXTCR0_get_rx_start_period(data)                          ((0x00FF0000&(data))>>16)
+#define CEC_RXTCR0_get_rx_data_sample(data)                           ((0x0000FF00&(data))>>8)
+#define CEC_RXTCR0_get_rx_data_period(data)                           (0x000000FF&(data))
+
+
+#define CEC_TXTCR0                                                    0x18007538
+#define CEC_TXTCR0_reg_addr                                           "0xb8007538"
+#define CEC_TXTCR0_reg                                                0xb8007538
+#define CEC_TXTCR0_inst_addr                                          "0x038E"
+#define CEC_TXTCR0_inst                                               0x038E
+#define CEC_TXTCR0_tx_start_low_shift                                 (8)
+#define CEC_TXTCR0_tx_start_high_shift                                (0)
+#define CEC_TXTCR0_tx_start_low_mask                                  (0x0000FF00)
+#define CEC_TXTCR0_tx_start_high_mask                                 (0x000000FF)
+#define CEC_TXTCR0_tx_start_low(data)                                 (0x0000FF00&((data)<<8))
+#define CEC_TXTCR0_tx_start_high(data)                                (0x000000FF&(data))
+#define CEC_TXTCR0_get_tx_start_low(data)                             ((0x0000FF00&(data))>>8)
+#define CEC_TXTCR0_get_tx_start_high(data)                            (0x000000FF&(data))
+
+
+#define CEC_TXTCR1                                                    0x1800753c
+#define CEC_TXTCR1_reg_addr                                           "0xb800753c"
+#define CEC_TXTCR1_reg                                                0xb800753c
+#define CEC_TXTCR1_inst_addr                                          "0x038F"
+#define CEC_TXTCR1_inst                                               0x038F
+#define CEC_TXTCR1_tx_data_low_shift                                  (16)
+#define CEC_TXTCR1_tx_data_01_shift                                   (8)
+#define CEC_TXTCR1_tx_data_high_shift                                 (0)
+#define CEC_TXTCR1_tx_data_low_mask                                   (0x00FF0000)
+#define CEC_TXTCR1_tx_data_01_mask                                    (0x0000FF00)
+#define CEC_TXTCR1_tx_data_high_mask                                  (0x000000FF)
+#define CEC_TXTCR1_tx_data_low(data)                                  (0x00FF0000&((data)<<16))
+#define CEC_TXTCR1_tx_data_01(data)                                   (0x0000FF00&((data)<<8))
+#define CEC_TXTCR1_tx_data_high(data)                                 (0x000000FF&(data))
+#define CEC_TXTCR1_get_tx_data_low(data)                              ((0x00FF0000&(data))>>16)
+#define CEC_TXTCR1_get_tx_data_01(data)                               ((0x0000FF00&(data))>>8)
+#define CEC_TXTCR1_get_tx_data_high(data)                             (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_01                                     0x18007540
+#define GDI_CEC_COMPARE_OPCODE_01_reg_addr                            "0xb8007540"
+#define GDI_CEC_COMPARE_OPCODE_01_reg                                 0xb8007540
+#define GDI_CEC_COMPARE_OPCODE_01_inst_addr                           "0x0390"
+#define GDI_CEC_COMPARE_OPCODE_01_inst                                0x0390
+#define GDI_CEC_COMPARE_OPCODE_01_compare_opcode_01_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_01_compare_opcode_01_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_01_compare_opcode_01(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_01_get_compare_opcode_01(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPCODE_01                                        0x18007544
+#define GDI_CEC_SEND_OPCODE_01_reg_addr                               "0xb8007544"
+#define GDI_CEC_SEND_OPCODE_01_reg                                    0xb8007544
+#define GDI_CEC_SEND_OPCODE_01_inst_addr                              "0x0391"
+#define GDI_CEC_SEND_OPCODE_01_inst                                   0x0391
+#define GDI_CEC_SEND_OPCODE_01_send_opcode_01_shift                   (0)
+#define GDI_CEC_SEND_OPCODE_01_send_opcode_01_mask                    (0x000000FF)
+#define GDI_CEC_SEND_OPCODE_01_send_opcode_01(data)                   (0x000000FF&(data))
+#define GDI_CEC_SEND_OPCODE_01_get_send_opcode_01(data)               (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPERAND_NUMBER_01                                0x18007548
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_reg_addr                       "0xb8007548"
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_reg                            0xb8007548
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_inst_addr                      "0x0392"
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_inst                           0x0392
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_operand_number_01_shift        (0)
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_operand_number_01_mask         (0x00000003)
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_operand_number_01(data)        (0x00000003&(data))
+#define GDI_CEC_SEND_OPERAND_NUMBER_01_get_operand_number_01(data)    (0x00000003&(data))
+
+
+#define GDI_CEC_OPERAND_01                                            0x1800754c
+#define GDI_CEC_OPERAND_01_reg_addr                                   "0xb800754c"
+#define GDI_CEC_OPERAND_01_reg                                        0xb800754c
+#define GDI_CEC_OPERAND_01_inst_addr                                  "0x0393"
+#define GDI_CEC_OPERAND_01_inst                                       0x0393
+#define GDI_CEC_OPERAND_01_operand_01_shift                           (0)
+#define GDI_CEC_OPERAND_01_operand_01_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_01_operand_01(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_01_get_operand_01(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_02                                            0x18007550
+#define GDI_CEC_OPERAND_02_reg_addr                                   "0xb8007550"
+#define GDI_CEC_OPERAND_02_reg                                        0xb8007550
+#define GDI_CEC_OPERAND_02_inst_addr                                  "0x0394"
+#define GDI_CEC_OPERAND_02_inst                                       0x0394
+#define GDI_CEC_OPERAND_02_operand_02_shift                           (0)
+#define GDI_CEC_OPERAND_02_operand_02_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_02_operand_02(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_02_get_operand_02(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_03                                            0x18007554
+#define GDI_CEC_OPERAND_03_reg_addr                                   "0xb8007554"
+#define GDI_CEC_OPERAND_03_reg                                        0xb8007554
+#define GDI_CEC_OPERAND_03_inst_addr                                  "0x0395"
+#define GDI_CEC_OPERAND_03_inst                                       0x0395
+#define GDI_CEC_OPERAND_03_operand_03_shift                           (0)
+#define GDI_CEC_OPERAND_03_operand_03_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_03_operand_03(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_03_get_operand_03(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_02                                     0x18007558
+#define GDI_CEC_COMPARE_OPCODE_02_reg_addr                            "0xb8007558"
+#define GDI_CEC_COMPARE_OPCODE_02_reg                                 0xb8007558
+#define GDI_CEC_COMPARE_OPCODE_02_inst_addr                           "0x0396"
+#define GDI_CEC_COMPARE_OPCODE_02_inst                                0x0396
+#define GDI_CEC_COMPARE_OPCODE_02_compare_opcode_02_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_02_compare_opcode_02_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_02_compare_opcode_02(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_02_get_compare_opcode_02(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPCODE_02                                        0x1800755c
+#define GDI_CEC_SEND_OPCODE_02_reg_addr                               "0xb800755c"
+#define GDI_CEC_SEND_OPCODE_02_reg                                    0xb800755c
+#define GDI_CEC_SEND_OPCODE_02_inst_addr                              "0x0397"
+#define GDI_CEC_SEND_OPCODE_02_inst                                   0x0397
+#define GDI_CEC_SEND_OPCODE_02_send_opcode_02_shift                   (0)
+#define GDI_CEC_SEND_OPCODE_02_send_opcode_02_mask                    (0x000000FF)
+#define GDI_CEC_SEND_OPCODE_02_send_opcode_02(data)                   (0x000000FF&(data))
+#define GDI_CEC_SEND_OPCODE_02_get_send_opcode_02(data)               (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPERAND_NUMBER_02                                0x18007560
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_reg_addr                       "0xb8007560"
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_reg                            0xb8007560
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_inst_addr                      "0x0398"
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_inst                           0x0398
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_operand_number_02_shift        (0)
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_operand_number_02_mask         (0x00000003)
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_operand_number_02(data)        (0x00000003&(data))
+#define GDI_CEC_SEND_OPERAND_NUMBER_02_get_operand_number_02(data)    (0x00000003&(data))
+
+
+#define GDI_CEC_OPERAND_04                                            0x18007564
+#define GDI_CEC_OPERAND_04_reg_addr                                   "0xb8007564"
+#define GDI_CEC_OPERAND_04_reg                                        0xb8007564
+#define GDI_CEC_OPERAND_04_inst_addr                                  "0x0399"
+#define GDI_CEC_OPERAND_04_inst                                       0x0399
+#define GDI_CEC_OPERAND_04_operand_04_shift                           (0)
+#define GDI_CEC_OPERAND_04_operand_04_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_04_operand_04(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_04_get_operand_04(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_05                                            0x18007568
+#define GDI_CEC_OPERAND_05_reg_addr                                   "0xb8007568"
+#define GDI_CEC_OPERAND_05_reg                                        0xb8007568
+#define GDI_CEC_OPERAND_05_inst_addr                                  "0x039A"
+#define GDI_CEC_OPERAND_05_inst                                       0x039A
+#define GDI_CEC_OPERAND_05_operand_05_shift                           (0)
+#define GDI_CEC_OPERAND_05_operand_05_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_05_operand_05(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_05_get_operand_05(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_06                                            0x1800756c
+#define GDI_CEC_OPERAND_06_reg_addr                                   "0xb800756c"
+#define GDI_CEC_OPERAND_06_reg                                        0xb800756c
+#define GDI_CEC_OPERAND_06_inst_addr                                  "0x039B"
+#define GDI_CEC_OPERAND_06_inst                                       0x039B
+#define GDI_CEC_OPERAND_06_operand_06_shift                           (0)
+#define GDI_CEC_OPERAND_06_operand_06_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_06_operand_06(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_06_get_operand_06(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_03                                     0x18007570
+#define GDI_CEC_COMPARE_OPCODE_03_reg_addr                            "0xb8007570"
+#define GDI_CEC_COMPARE_OPCODE_03_reg                                 0xb8007570
+#define GDI_CEC_COMPARE_OPCODE_03_inst_addr                           "0x039C"
+#define GDI_CEC_COMPARE_OPCODE_03_inst                                0x039C
+#define GDI_CEC_COMPARE_OPCODE_03_compare_opcode_03_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_03_compare_opcode_03_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_03_compare_opcode_03(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_03_get_compare_opcode_03(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPCODE_03                                        0x18007574
+#define GDI_CEC_SEND_OPCODE_03_reg_addr                               "0xb8007574"
+#define GDI_CEC_SEND_OPCODE_03_reg                                    0xb8007574
+#define GDI_CEC_SEND_OPCODE_03_inst_addr                              "0x039D"
+#define GDI_CEC_SEND_OPCODE_03_inst                                   0x039D
+#define GDI_CEC_SEND_OPCODE_03_send_opcode_03_shift                   (0)
+#define GDI_CEC_SEND_OPCODE_03_send_opcode_03_mask                    (0x000000FF)
+#define GDI_CEC_SEND_OPCODE_03_send_opcode_03(data)                   (0x000000FF&(data))
+#define GDI_CEC_SEND_OPCODE_03_get_send_opcode_03(data)               (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPERAND_NUMBER_03                                0x18007578
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_reg_addr                       "0xb8007578"
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_reg                            0xb8007578
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_inst_addr                      "0x039E"
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_inst                           0x039E
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_operand_number_03_shift        (0)
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_operand_number_03_mask         (0x00000003)
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_operand_number_03(data)        (0x00000003&(data))
+#define GDI_CEC_SEND_OPERAND_NUMBER_03_get_operand_number_03(data)    (0x00000003&(data))
+
+
+#define GDI_CEC_OPERAND_07                                            0x1800757c
+#define GDI_CEC_OPERAND_07_reg_addr                                   "0xb800757c"
+#define GDI_CEC_OPERAND_07_reg                                        0xb800757c
+#define GDI_CEC_OPERAND_07_inst_addr                                  "0x039F"
+#define GDI_CEC_OPERAND_07_inst                                       0x039F
+#define GDI_CEC_OPERAND_07_operand_07_shift                           (0)
+#define GDI_CEC_OPERAND_07_operand_07_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_07_operand_07(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_07_get_operand_07(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_08                                            0x18007580
+#define GDI_CEC_OPERAND_08_reg_addr                                   "0xb8007580"
+#define GDI_CEC_OPERAND_08_reg                                        0xb8007580
+#define GDI_CEC_OPERAND_08_inst_addr                                  "0x03A0"
+#define GDI_CEC_OPERAND_08_inst                                       0x03A0
+#define GDI_CEC_OPERAND_08_operand_08_shift                           (0)
+#define GDI_CEC_OPERAND_08_operand_08_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_08_operand_08(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_08_get_operand_08(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_09                                            0x18007584
+#define GDI_CEC_OPERAND_09_reg_addr                                   "0xb8007584"
+#define GDI_CEC_OPERAND_09_reg                                        0xb8007584
+#define GDI_CEC_OPERAND_09_inst_addr                                  "0x03A1"
+#define GDI_CEC_OPERAND_09_inst                                       0x03A1
+#define GDI_CEC_OPERAND_09_operand_09_shift                           (0)
+#define GDI_CEC_OPERAND_09_operand_09_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_09_operand_09(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_09_get_operand_09(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_04                                     0x18007588
+#define GDI_CEC_COMPARE_OPCODE_04_reg_addr                            "0xb8007588"
+#define GDI_CEC_COMPARE_OPCODE_04_reg                                 0xb8007588
+#define GDI_CEC_COMPARE_OPCODE_04_inst_addr                           "0x03A2"
+#define GDI_CEC_COMPARE_OPCODE_04_inst                                0x03A2
+#define GDI_CEC_COMPARE_OPCODE_04_compare_opcode_04_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_04_compare_opcode_04_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_04_compare_opcode_04(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_04_get_compare_opcode_04(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPCODE_04                                        0x1800758c
+#define GDI_CEC_SEND_OPCODE_04_reg_addr                               "0xb800758c"
+#define GDI_CEC_SEND_OPCODE_04_reg                                    0xb800758c
+#define GDI_CEC_SEND_OPCODE_04_inst_addr                              "0x03A3"
+#define GDI_CEC_SEND_OPCODE_04_inst                                   0x03A3
+#define GDI_CEC_SEND_OPCODE_04_send_opcode_04_shift                   (0)
+#define GDI_CEC_SEND_OPCODE_04_send_opcode_04_mask                    (0x000000FF)
+#define GDI_CEC_SEND_OPCODE_04_send_opcode_04(data)                   (0x000000FF&(data))
+#define GDI_CEC_SEND_OPCODE_04_get_send_opcode_04(data)               (0x000000FF&(data))
+
+
+#define GDI_CEC_SEND_OPERAND_NUMBER_04                                0x18007590
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_reg_addr                       "0xb8007590"
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_reg                            0xb8007590
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_inst_addr                      "0x03A4"
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_inst                           0x03A4
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_operand_number_04_shift        (0)
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_operand_number_04_mask         (0x00000003)
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_operand_number_04(data)        (0x00000003&(data))
+#define GDI_CEC_SEND_OPERAND_NUMBER_04_get_operand_number_04(data)    (0x00000003&(data))
+
+
+#define GDI_CEC_OPERAND_10                                            0x18007594
+#define GDI_CEC_OPERAND_10_reg_addr                                   "0xb8007594"
+#define GDI_CEC_OPERAND_10_reg                                        0xb8007594
+#define GDI_CEC_OPERAND_10_inst_addr                                  "0x03A5"
+#define GDI_CEC_OPERAND_10_inst                                       0x03A5
+#define GDI_CEC_OPERAND_10_operand_10_shift                           (0)
+#define GDI_CEC_OPERAND_10_operand_10_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_10_operand_10(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_10_get_operand_10(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_11                                            0x18007598
+#define GDI_CEC_OPERAND_11_reg_addr                                   "0xb8007598"
+#define GDI_CEC_OPERAND_11_reg                                        0xb8007598
+#define GDI_CEC_OPERAND_11_inst_addr                                  "0x03A6"
+#define GDI_CEC_OPERAND_11_inst                                       0x03A6
+#define GDI_CEC_OPERAND_11_operand_11_shift                           (0)
+#define GDI_CEC_OPERAND_11_operand_11_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_11_operand_11(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_11_get_operand_11(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_OPERAND_12                                            0x1800759c
+#define GDI_CEC_OPERAND_12_reg_addr                                   "0xb800759c"
+#define GDI_CEC_OPERAND_12_reg                                        0xb800759c
+#define GDI_CEC_OPERAND_12_inst_addr                                  "0x03A7"
+#define GDI_CEC_OPERAND_12_inst                                       0x03A7
+#define GDI_CEC_OPERAND_12_operand_12_shift                           (0)
+#define GDI_CEC_OPERAND_12_operand_12_mask                            (0x000000FF)
+#define GDI_CEC_OPERAND_12_operand_12(data)                           (0x000000FF&(data))
+#define GDI_CEC_OPERAND_12_get_operand_12(data)                       (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_05                                     0x180075a0
+#define GDI_CEC_COMPARE_OPCODE_05_reg_addr                            "0xb80075a0"
+#define GDI_CEC_COMPARE_OPCODE_05_reg                                 0xb80075a0
+#define GDI_CEC_COMPARE_OPCODE_05_inst_addr                           "0x03A8"
+#define GDI_CEC_COMPARE_OPCODE_05_inst                                0x03A8
+#define GDI_CEC_COMPARE_OPCODE_05_compare_opcode_05_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_05_compare_opcode_05_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_05_compare_opcode_05(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_05_get_compare_opcode_05(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_06                                     0x180075a4
+#define GDI_CEC_COMPARE_OPCODE_06_reg_addr                            "0xb80075a4"
+#define GDI_CEC_COMPARE_OPCODE_06_reg                                 0xb80075a4
+#define GDI_CEC_COMPARE_OPCODE_06_inst_addr                           "0x03A9"
+#define GDI_CEC_COMPARE_OPCODE_06_inst                                0x03A9
+#define GDI_CEC_COMPARE_OPCODE_06_compare_opcode_06_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_06_compare_opcode_06_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_06_compare_opcode_06(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_06_get_compare_opcode_06(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_07                                     0x180075a8
+#define GDI_CEC_COMPARE_OPCODE_07_reg_addr                            "0xb80075a8"
+#define GDI_CEC_COMPARE_OPCODE_07_reg                                 0xb80075a8
+#define GDI_CEC_COMPARE_OPCODE_07_inst_addr                           "0x03AA"
+#define GDI_CEC_COMPARE_OPCODE_07_inst                                0x03AA
+#define GDI_CEC_COMPARE_OPCODE_07_compare_opcode_07_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_07_compare_opcode_07_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_07_compare_opcode_07(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_07_get_compare_opcode_07(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_08                                     0x180075ac
+#define GDI_CEC_COMPARE_OPCODE_08_reg_addr                            "0xb80075ac"
+#define GDI_CEC_COMPARE_OPCODE_08_reg                                 0xb80075ac
+#define GDI_CEC_COMPARE_OPCODE_08_inst_addr                           "0x03AB"
+#define GDI_CEC_COMPARE_OPCODE_08_inst                                0x03AB
+#define GDI_CEC_COMPARE_OPCODE_08_compare_opcode_08_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_08_compare_opcode_08_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_08_compare_opcode_08(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_08_get_compare_opcode_08(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_09                                     0x180075b0
+#define GDI_CEC_COMPARE_OPCODE_09_reg_addr                            "0xb80075b0"
+#define GDI_CEC_COMPARE_OPCODE_09_reg                                 0xb80075b0
+#define GDI_CEC_COMPARE_OPCODE_09_inst_addr                           "0x03AC"
+#define GDI_CEC_COMPARE_OPCODE_09_inst                                0x03AC
+#define GDI_CEC_COMPARE_OPCODE_09_compare_opcode_09_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_09_compare_opcode_09_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_09_compare_opcode_09(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_09_get_compare_opcode_09(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_10                                     0x180075b4
+#define GDI_CEC_COMPARE_OPCODE_10_reg_addr                            "0xb80075b4"
+#define GDI_CEC_COMPARE_OPCODE_10_reg                                 0xb80075b4
+#define GDI_CEC_COMPARE_OPCODE_10_inst_addr                           "0x03AD"
+#define GDI_CEC_COMPARE_OPCODE_10_inst                                0x03AD
+#define GDI_CEC_COMPARE_OPCODE_10_compare_opcode_10_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_10_compare_opcode_10_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_10_compare_opcode_10(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_10_get_compare_opcode_10(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_11                                     0x180075b8
+#define GDI_CEC_COMPARE_OPCODE_11_reg_addr                            "0xb80075b8"
+#define GDI_CEC_COMPARE_OPCODE_11_reg                                 0xb80075b8
+#define GDI_CEC_COMPARE_OPCODE_11_inst_addr                           "0x03AE"
+#define GDI_CEC_COMPARE_OPCODE_11_inst                                0x03AE
+#define GDI_CEC_COMPARE_OPCODE_11_compare_opcode_11_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_11_compare_opcode_11_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_11_compare_opcode_11(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_11_get_compare_opcode_11(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_12                                     0x180075bc
+#define GDI_CEC_COMPARE_OPCODE_12_reg_addr                            "0xb80075bc"
+#define GDI_CEC_COMPARE_OPCODE_12_reg                                 0xb80075bc
+#define GDI_CEC_COMPARE_OPCODE_12_inst_addr                           "0x03AF"
+#define GDI_CEC_COMPARE_OPCODE_12_inst                                0x03AF
+#define GDI_CEC_COMPARE_OPCODE_12_compare_opcode_12_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_12_compare_opcode_12_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_12_compare_opcode_12(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_12_get_compare_opcode_12(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_13                                     0x180075c0
+#define GDI_CEC_COMPARE_OPCODE_13_reg_addr                            "0xb80075c0"
+#define GDI_CEC_COMPARE_OPCODE_13_reg                                 0xb80075c0
+#define GDI_CEC_COMPARE_OPCODE_13_inst_addr                           "0x03B0"
+#define GDI_CEC_COMPARE_OPCODE_13_inst                                0x03B0
+#define GDI_CEC_COMPARE_OPCODE_13_compare_opcode_13_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_13_compare_opcode_13_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_13_compare_opcode_13(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_13_get_compare_opcode_13(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_14                                     0x180075c4
+#define GDI_CEC_COMPARE_OPCODE_14_reg_addr                            "0xb80075c4"
+#define GDI_CEC_COMPARE_OPCODE_14_reg                                 0xb80075c4
+#define GDI_CEC_COMPARE_OPCODE_14_inst_addr                           "0x03B1"
+#define GDI_CEC_COMPARE_OPCODE_14_inst                                0x03B1
+#define GDI_CEC_COMPARE_OPCODE_14_compare_opcode_14_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_14_compare_opcode_14_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_14_compare_opcode_14(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_14_get_compare_opcode_14(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_COMPARE_OPCODE_15                                     0x180075c8
+#define GDI_CEC_COMPARE_OPCODE_15_reg_addr                            "0xb80075c8"
+#define GDI_CEC_COMPARE_OPCODE_15_reg                                 0xb80075c8
+#define GDI_CEC_COMPARE_OPCODE_15_inst_addr                           "0x03B2"
+#define GDI_CEC_COMPARE_OPCODE_15_inst                                0x03B2
+#define GDI_CEC_COMPARE_OPCODE_15_compare_opcode_15_shift             (0)
+#define GDI_CEC_COMPARE_OPCODE_15_compare_opcode_15_mask              (0x000000FF)
+#define GDI_CEC_COMPARE_OPCODE_15_compare_opcode_15(data)             (0x000000FF&(data))
+#define GDI_CEC_COMPARE_OPCODE_15_get_compare_opcode_15(data)         (0x000000FF&(data))
+
+
+#define GDI_CEC_OPCODE_ENABLE                                         0x180075cc
+#define GDI_CEC_OPCODE_ENABLE_reg_addr                                "0xb80075cc"
+#define GDI_CEC_OPCODE_ENABLE_reg                                     0xb80075cc
+#define GDI_CEC_OPCODE_ENABLE_inst_addr                               "0x03B3"
+#define GDI_CEC_OPCODE_ENABLE_inst                                    0x03B3
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_15_shift              (14)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_14_shift              (13)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_13_shift              (12)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_12_shift              (11)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_11_shift              (10)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_10_shift              (9)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_09_shift              (8)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_08_shift              (7)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_07_shift              (6)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_06_shift              (5)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_05_shift              (4)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_04_shift              (3)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_03_shift              (2)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_02_shift              (1)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_01_shift              (0)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_15_mask               (0x00004000)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_14_mask               (0x00002000)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_13_mask               (0x00001000)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_12_mask               (0x00000800)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_11_mask               (0x00000400)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_10_mask               (0x00000200)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_09_mask               (0x00000100)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_08_mask               (0x00000080)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_07_mask               (0x00000040)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_06_mask               (0x00000020)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_05_mask               (0x00000010)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_04_mask               (0x00000008)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_03_mask               (0x00000004)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_02_mask               (0x00000002)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_01_mask               (0x00000001)
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_15(data)              (0x00004000&((data)<<14))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_14(data)              (0x00002000&((data)<<13))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_13(data)              (0x00001000&((data)<<12))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_12(data)              (0x00000800&((data)<<11))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_11(data)              (0x00000400&((data)<<10))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_10(data)              (0x00000200&((data)<<9))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_09(data)              (0x00000100&((data)<<8))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_08(data)              (0x00000080&((data)<<7))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_07(data)              (0x00000040&((data)<<6))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_06(data)              (0x00000020&((data)<<5))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_05(data)              (0x00000010&((data)<<4))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_04(data)              (0x00000008&((data)<<3))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_03(data)              (0x00000004&((data)<<2))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_02(data)              (0x00000002&((data)<<1))
+#define GDI_CEC_OPCODE_ENABLE_en_compare_opcode_01(data)              (0x00000001&(data))
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_15(data)          ((0x00004000&(data))>>14)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_14(data)          ((0x00002000&(data))>>13)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_13(data)          ((0x00001000&(data))>>12)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_12(data)          ((0x00000800&(data))>>11)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_11(data)          ((0x00000400&(data))>>10)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_10(data)          ((0x00000200&(data))>>9)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_09(data)          ((0x00000100&(data))>>8)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_08(data)          ((0x00000080&(data))>>7)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_07(data)          ((0x00000040&(data))>>6)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_06(data)          ((0x00000020&(data))>>5)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_05(data)          ((0x00000010&(data))>>4)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_04(data)          ((0x00000008&(data))>>3)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_03(data)          ((0x00000004&(data))>>2)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_02(data)          ((0x00000002&(data))>>1)
+#define GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_01(data)          (0x00000001&(data))
+
+
+#define GDI_POWER_SAVING_MODE                                         0x180075d0
+#define GDI_POWER_SAVING_MODE_reg_addr                                "0xb80075d0"
+#define GDI_POWER_SAVING_MODE_reg                                     0xb80075d0
+#define GDI_POWER_SAVING_MODE_inst_addr                               "0x03B4"
+#define GDI_POWER_SAVING_MODE_inst                                    0x03B4
+#define GDI_POWER_SAVING_MODE_irq_pending_shift                       (31)
+#define GDI_POWER_SAVING_MODE_cec_msg_status_01_shift                 (25)
+#define GDI_POWER_SAVING_MODE_cec_msg_status_02_shift                 (24)
+#define GDI_POWER_SAVING_MODE_irq_by_cec_receive_special_cmd_shift    (8)
+#define GDI_POWER_SAVING_MODE_irq_pending_mask                        (0x80000000)
+#define GDI_POWER_SAVING_MODE_cec_msg_status_01_mask                  (0x02000000)
+#define GDI_POWER_SAVING_MODE_cec_msg_status_02_mask                  (0x01000000)
+#define GDI_POWER_SAVING_MODE_irq_by_cec_receive_special_cmd_mask     (0x00000100)
+#define GDI_POWER_SAVING_MODE_irq_pending(data)                       (0x80000000&((data)<<31))
+#define GDI_POWER_SAVING_MODE_cec_msg_status_01(data)                 (0x02000000&((data)<<25))
+#define GDI_POWER_SAVING_MODE_cec_msg_status_02(data)                 (0x01000000&((data)<<24))
+#define GDI_POWER_SAVING_MODE_irq_by_cec_receive_special_cmd(data)    (0x00000100&((data)<<8))
+#define GDI_POWER_SAVING_MODE_get_irq_pending(data)                   ((0x80000000&(data))>>31)
+#define GDI_POWER_SAVING_MODE_get_cec_msg_status_01(data)             ((0x02000000&(data))>>25)
+#define GDI_POWER_SAVING_MODE_get_cec_msg_status_02(data)             ((0x01000000&(data))>>24)
+#define GDI_POWER_SAVING_MODE_get_irq_by_cec_receive_special_cmd(data)  ((0x00000100&(data))>>8)
+
+
+#define CEC_ANALOG_01                                                 0x180075d4
+#define CEC_ANALOG_01_reg_addr                                        "0xb80075d4"
+#define CEC_ANALOG_01_reg                                             0xb80075d4
+#define CEC_ANALOG_01_inst_addr                                       "0x03B5"
+#define CEC_ANALOG_01_inst                                            0x03B5
+#define CEC_ANALOG_01_vcckoff_33v_shift                               (0)
+#define CEC_ANALOG_01_vcckoff_33v_mask                                (0x00000001)
+#define CEC_ANALOG_01_vcckoff_33v(data)                               (0x00000001&(data))
+#define CEC_ANALOG_01_get_vcckoff_33v(data)                           (0x00000001&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/codeblkreg_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/codeblkreg_reg.h
new file mode 100644
index 00000000..18d06ca
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/codeblkreg_reg.h
@@ -0,0 +1,2736 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/6/22 11:40:32
+***************************************************************/
+
+
+#ifndef _CODEBLKREG_REG_H_INCLUDED_
+#define _CODEBLKREG_REG_H_INCLUDED_
+#ifdef  _CODEBLKREG_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     write_enable4:1;
+unsigned int     ldstCmemCount:16;
+unsigned int     write_enable3:1;
+unsigned int     cabac_1p_mode:1;
+unsigned int     write_enable2:1;
+unsigned int     cabac_p2_p3:1;
+unsigned int     write_enable1:1;
+unsigned int     itblk_advmode:1;
+}CODEBLKREG_VE_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable4:1;
+unsigned int     h264_prev_qp:6;
+unsigned int     write_enable3:1;
+unsigned int     pred_bank:2;
+unsigned int     write_enable2:1;
+unsigned int     dec_bank:2;
+unsigned int     write_enable1:1;
+unsigned int     umem_mstr:4;
+}CODEBLKREG_UMEM_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     mbaddrb_na:1;
+unsigned int     mbaddra_na:1;
+unsigned int     slicegroup_en:1;
+}CODEBLKREG_VE_SLICEGROUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_enable3:1;
+unsigned int     cabac_curmb_addr:10;
+unsigned int     write_enable2:1;
+unsigned int     vld_curmb_addr:10;
+unsigned int     write_enable1:1;
+unsigned int     acdc_curmb_addr:8;
+}CODEBLKREG_CURADR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_enable3:1;
+unsigned int     cabac_pred_counter:10;
+unsigned int     write_enable2:1;
+unsigned int     vld_pred_counter:10;
+unsigned int     write_enable1:1;
+unsigned int     acdc_pred_counter:8;
+}CODEBLKREG_PREDCNTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     frame_field_mbpair:1;
+unsigned int     left_top_luma_d:5;
+unsigned int     left_top_luma_c:5;
+unsigned int     left_top_luma_b:5;
+unsigned int     left_top_luma_a:5;
+}CODEBLKREG_TOTAL_COEF1;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     left_top_cb_a:5;
+unsigned int     left_top_cb_b:5;
+unsigned int     left_top_cr_a:5;
+unsigned int     left_top_cr_b:5;
+}CODEBLKREG_TOTAL_COEF2;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     left_bot_luma_d:5;
+unsigned int     left_bot_luma_c:5;
+unsigned int     left_bot_luma_b:5;
+unsigned int     left_bot_luma_a:5;
+}CODEBLKREG_TOTAL_COEF3;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     left_bot_cb_a:5;
+unsigned int     left_bot_cb_b:5;
+unsigned int     left_bot_cr_a:5;
+unsigned int     left_bot_cr_b:5;
+}CODEBLKREG_TOTAL_COEF4;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     high:9;
+unsigned int     bits:4;
+unsigned int     code_word:16;
+}CODEBLKREG_VP6_BAC;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable8:1;
+unsigned int     ch_q_param_delta_v:6;
+unsigned int     write_enable7:1;
+unsigned int     ch_q_param_delta_u:6;
+unsigned int     write_enable6:1;
+unsigned int     pb_fld_enhanced_flg:1;
+unsigned int     write_enable5:1;
+unsigned int     frame_pic_type:2;
+unsigned int     write_enable4:1;
+unsigned int     skip_mode_flag:1;
+unsigned int     write_enable3:1;
+unsigned int     fixedQP:1;
+unsigned int     write_enable2:1;
+unsigned int     mbweightingflg:1;
+unsigned int     write_enable1:1;
+unsigned int     pic_ref_flg:1;
+}CODEBLKREG_VE_AVS_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     qpprime_y_zero_transform_bypass_flag:1;
+unsigned int     entropy_coding_mode:1;
+unsigned int     pic_init_qp:6;
+unsigned int     chroma_qp_offset:5;
+unsigned int     second_chroma_qp_offset:5;
+unsigned int     direct_8x8_inferflg:1;
+unsigned int     transform_8x8_mode_flg:1;
+unsigned int     num_ref_idx_l0_active_minus1:5;
+unsigned int     num_ref_idx_l1_active_minus1:5;
+}CODEBLKREG_VE_H264_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     write_enable3:1;
+unsigned int     pic_type:3;
+unsigned int     write_enable2:1;
+unsigned int     slice_qp_delta:7;
+unsigned int     write_enable1:1;
+unsigned int     cabac_init_idc:2;
+}CODEBLKREG_VE_H264_CNTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable8:1;
+unsigned int     quan_type:1;
+unsigned int     write_enable7:1;
+unsigned int     dquant:2;
+unsigned int     write_enable6:1;
+unsigned int     pqindex:5;
+unsigned int     write_enable5:1;
+unsigned int     halfqp:1;
+unsigned int     write_enable4:1;
+unsigned int     altpquant:5;
+unsigned int     write_enable3:1;
+unsigned int     dquantfrm:1;
+unsigned int     write_enable2:1;
+unsigned int     dqprofile:2;
+unsigned int     write_enable1:1;
+unsigned int     dqbilevel:1;
+}CODEBLKREG_VE_VC1QUANT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     ttmbf:1;
+}CODEBLKREG_VE_VC1TRANSFORM;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable5:1;
+unsigned int     vc1mvtab:3;
+unsigned int     write_enable4:1;
+unsigned int     mvrange_kx:4;
+unsigned int     mvrange_ky:4;
+unsigned int     write_enable3:1;
+unsigned int     dmv_extend_x:1;
+unsigned int     dmv_extend_y:1;
+unsigned int     write_enable2:1;
+unsigned int     tab2mvbp:2;
+unsigned int     tab4mvbp:2;
+unsigned int     write_enable1:1;
+unsigned int     bfraction:5;
+}CODEBLKREG_VE_VC1MV;
+
+typedef struct 
+{
+unsigned int     write_enable7:1;
+unsigned int     reserved_0:13;
+unsigned int     write_enable6:1;
+unsigned int     bk_x_fcode:4;
+unsigned int     bk_y_fcode:4;
+unsigned int     write_enable5:1;
+unsigned int     fo_x_fcode:4;
+unsigned int     fo_y_fcode:4;
+}CODEBLKREG_VE_MVFCODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     write_enable5:1;
+unsigned int     dctable_sel:1;
+unsigned int     write_enable4:1;
+unsigned int     transacfrm:2;
+unsigned int     transacfrm2:2;
+unsigned int     write_enable3:1;
+unsigned int     cbp_table:3;
+unsigned int     write_enable2:1;
+unsigned int     flg_4mvswitch:1;
+unsigned int     write_enable1:1;
+unsigned int     mbmodetab:3;
+}CODEBLKREG_VE_VC1TABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     write_enable1:1;
+unsigned int     escm3_rsize:3;
+unsigned int     escm3_lsize:4;
+}CODEBLKREG_VE_VC1ESC;
+
+typedef struct 
+{
+unsigned int     rowMB:8;
+unsigned int     colMB:7;
+unsigned int     rowmb_mod3:2;
+unsigned int     colmb_mod3:2;
+unsigned int     bitplane_len:13;
+}CODEBLKREG_VE_VC1BITPLN_CNTL;
+
+typedef struct 
+{
+unsigned int     bitplane_addr:32;
+}CODEBLKREG_VE_VC1BITPLN_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     ldst_addr:31;
+}CODEBLKREG_VE_LDSTADDR;
+
+typedef struct 
+{
+unsigned int     max_bit:32;
+}CODEBLKREG_VE_DECBITCNT;
+
+typedef struct 
+{
+unsigned int     dec_bitcnt:32;
+}CODEBLKREG_VLD_BITCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     write_enable3:1;
+unsigned int     detect_startcode_error:1;
+unsigned int     write_enable2:1;
+unsigned int     min_xfer_size:2;
+unsigned int     write_enable1:1;
+unsigned int     startcode_prevnt_en:1;
+}CODEBLKREG_VE_BSCNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     min_thre:7;
+}CODEBLKREG_VE_BS_MIN_THR;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     timer_value:24;
+}CODEBLKREG_VE_BSTIMER;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     base_addr:31;
+}CODEBLKREG_VE_BSBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     limit_addr:31;
+}CODEBLKREG_VE_BSLIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     wr_ptr:31;
+}CODEBLKREG_VE_BSWRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     cur_ptr:31;
+}CODEBLKREG_VE_BSCURPTR;
+
+typedef struct 
+{
+unsigned int     dec_bit_ptr:32;
+}CODEBLKREG_VE_DECBSPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     removal_counter:29;
+}CODEBLKREG_VE_JPG_EMU;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     dec_bit_ptr_msb:2;
+}CODEBLKREG_VE_DECBSPTR_MSB;
+
+typedef struct 
+{
+unsigned int     write_enable6:1;
+unsigned int     sad_en:1;
+unsigned int     write_enable5:1;
+unsigned int     sad_threshold:10;
+unsigned int     write_enable4:1;
+unsigned int     flat_qtable:1;
+unsigned int     write_enable3:1;
+unsigned int     transform_size_8x8:1;
+unsigned int     write_enable2:1;
+unsigned int     field_transform:1;
+unsigned int     write_enable1:1;
+unsigned int     mb_ttfrm:12;
+}CODEBLKREG_VE_TRANSFORM;
+
+typedef struct 
+{
+unsigned int     write_enable6:1;
+unsigned int     id_pred:2;
+unsigned int     write_enable5:1;
+unsigned int     quant_type:1;
+unsigned int     write_enable4:1;
+unsigned int     mquant:5;
+unsigned int     write_enable3:1;
+unsigned int     qpy:6;
+unsigned int     write_enable2:1;
+unsigned int     qpcb:6;
+unsigned int     write_enable1:1;
+unsigned int     qpcr:6;
+}CODEBLKREG_VE_QUANTIZER;
+
+typedef struct 
+{
+unsigned int     write_enable5:1;
+unsigned int     qdelta_y2ac:5;
+unsigned int     write_enable4:1;
+unsigned int     qdelta_uvdc:5;
+unsigned int     write_enable3:1;
+unsigned int     qdelta_y2dc:5;
+unsigned int     write_enable2:1;
+unsigned int     qdelta_y1dc:5;
+unsigned int     write_enable1:1;
+unsigned int     vp8_qp:7;
+}CODEBLKREG_VE_QUANTIZER2;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     blk_pic_idx:7;
+}CODEBLKREG_VE_ITDMA;
+
+typedef struct 
+{
+unsigned int     write_enable2:1;
+unsigned int     cbp6bits:6;
+unsigned int     write_enable1:1;
+unsigned int     subblkpat:24;
+}CODEBLKREG_VE_CBP;
+
+typedef struct 
+{
+unsigned int     write_enable2:1;
+unsigned int     lu_zero_ac_blk_num:15;
+unsigned int     write_enable1:1;
+unsigned int     lu_zero_dc_blk_num:15;
+}CODEBLKREG_VP6_LUMA;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable2:1;
+unsigned int     ch_zero_ac_blk_num:14;
+unsigned int     write_enable1:1;
+unsigned int     ch_zero_dc_blk_num:14;
+}CODEBLKREG_VP6_CHROMA;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     mbpartition:9;
+}CODEBLKREG_MB_PARTITION;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mb_pred_mode:8;
+}CODEBLKREG_MB_PREDMODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable8:1;
+unsigned int     vp6_ref_frame:2;
+unsigned int     write_enable7:1;
+unsigned int     mb_pattern:1;
+unsigned int     write_enable6:1;
+unsigned int     intrablks_flg:5;
+unsigned int     write_enable5:1;
+unsigned int     ac_pred:1;
+unsigned int     write_enable4:1;
+unsigned int     dc_pred_dir:6;
+unsigned int     write_enable3:1;
+unsigned int     mbtype:4;
+unsigned int     write_enable2:1;
+unsigned int     intra_c_pred_mode:2;
+unsigned int     write_enable1:1;
+unsigned int     field_mb:1;
+}CODEBLKREG_MB_INFO;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     h263_flv_lg1:1;
+unsigned int     ivf:1;
+unsigned int     as:1;
+unsigned int     intra_dc_vlc:1;
+unsigned int     short_hdr:1;
+unsigned int     write_data:1;
+}CODEBLKREG_MB_INFO2;
+
+typedef struct 
+{
+unsigned int     write_enable3:1;
+unsigned int     reserved_0:26;
+unsigned int     write_enable2:1;
+unsigned int     rv9_intramode_use_top:1;
+unsigned int     write_enable1:1;
+unsigned int     rv_osvquant:2;
+}CODEBLKREG_RV_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     struvlc_len:31;
+}CODEBLKREG_RV_STRUVLC;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     left_blocks:16;
+}CODEBLKREG_RV_INTRAMODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_enable2:1;
+unsigned int     first_tbl_bits:4;
+unsigned int     write_enable1:1;
+unsigned int     tbl_startaddr:10;
+}CODEBLKREG_VLDTBLPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     tbl_espptr_saddr:10;
+}CODEBLKREG_VLDESPPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     write_enable2:1;
+unsigned int     pre_ac1_tbl_startaddr:10;
+unsigned int     write_enable1:1;
+unsigned int     pre_ac0_tbl_startaddr:10;
+}CODEBLKREG_VLD_VP6TBLPTR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     write_enable3:1;
+unsigned int     ch_ac_first_tbl_bits:4;
+unsigned int     write_enable2:1;
+unsigned int     lu_ac_first_tbl_bits:4;
+unsigned int     write_enable1:1;
+unsigned int     pre_ac2_tbl_startaddr:10;
+}CODEBLKREG_VLD_VP6TBLPTR1;
+
+typedef struct 
+{
+unsigned int     write_enable4:1;
+unsigned int     zerorun1_first_tbl_bits:4;
+unsigned int     write_enable3:1;
+unsigned int     zerorun1_tbl_startaddr:10;
+unsigned int     write_enable2:1;
+unsigned int     zerorun0_first_tbl_bits:4;
+unsigned int     write_enable1:1;
+unsigned int     zerorun0_tbl_startaddr:10;
+}CODEBLKREG_VLD_VP6TBLPTR2;
+
+typedef struct 
+{
+unsigned int     lumadc_c:12;
+unsigned int     lumadc_c_intra:1;
+unsigned int     lumadc_d:12;
+unsigned int     lumadc_d_intra:1;
+unsigned int     dcstep_topmb:6;
+}CODEBLKREG_VE_ACDCP_LUMA;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     cbdc_g:12;
+unsigned int     crdc_g:12;
+unsigned int     cbcr_intra:1;
+unsigned int     ch_dcstep_topmb:5;
+}CODEBLKREG_VE_ACDCP_CHRO;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     write_enable3:1;
+unsigned int     cavlc_halt_done:1;
+unsigned int     write_enable2:1;
+unsigned int     cavlc_halt:1;
+unsigned int     write_enable1:1;
+unsigned int     postwrite_en:1;
+}CODEBLKREG_NDB_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     base_addr:31;
+}CODEBLKREG_NDB_CAVLC_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     limit_addr:31;
+}CODEBLKREG_NDB_CAVLC_LIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     wr_ptr:31;
+}CODEBLKREG_NDB_CAVLC_WPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rd_ptr:31;
+}CODEBLKREG_NDB_CAVLC_RPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable7:1;
+unsigned int     segmentation_enabled:1;
+unsigned int     write_enable6:1;
+unsigned int     slice_cnt:8;
+unsigned int     write_enable5:1;
+unsigned int     uv_mode:2;
+unsigned int     write_enable4:1;
+unsigned int     ref_frame:2;
+unsigned int     write_enable3:1;
+unsigned int     mode:4;
+unsigned int     write_enable2:1;
+unsigned int     need_to_clamp_mvs:1;
+unsigned int     write_enable1:1;
+unsigned int     mb_skip_coeff:1;
+}CODEBLKREG_VP8_P3_FRM_MB1;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     vp8_p3_curmb:9;
+}CODEBLKREG_VP8_P3_MB2;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     high:9;
+unsigned int     bits:4;
+unsigned int     code_word:16;
+}CODEBLKREG_VP8_BAC;
+
+#endif
+
+#define CODEBLKREG_VE_CNTL                                                           0x1800E000
+#define CODEBLKREG_VE_CNTL_reg_addr                                                  "0xB800E000"
+#define CODEBLKREG_VE_CNTL_reg                                                       0xB800E000
+#define set_CODEBLKREG_VE_CNTL_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_CNTL_reg)=data)
+#define get_CODEBLKREG_VE_CNTL_reg   (*((volatile unsigned int*) CODEBLKREG_VE_CNTL_reg))
+#define CODEBLKREG_VE_CNTL_inst_adr                                                  "0x0000"
+#define CODEBLKREG_VE_CNTL_inst                                                      0x0000
+#define CODEBLKREG_VE_CNTL_write_enable4_shift                                       (22)
+#define CODEBLKREG_VE_CNTL_write_enable4_mask                                        (0x00400000)
+#define CODEBLKREG_VE_CNTL_write_enable4(data)                                       (0x00400000&((data)<<22))
+#define CODEBLKREG_VE_CNTL_write_enable4_src(data)                                   ((0x00400000&(data))>>22)
+#define CODEBLKREG_VE_CNTL_get_write_enable4(data)                                   ((0x00400000&(data))>>22)
+#define CODEBLKREG_VE_CNTL_ldstCmemCount_shift                                       (6)
+#define CODEBLKREG_VE_CNTL_ldstCmemCount_mask                                        (0x003FFFC0)
+#define CODEBLKREG_VE_CNTL_ldstCmemCount(data)                                       (0x003FFFC0&((data)<<6))
+#define CODEBLKREG_VE_CNTL_ldstCmemCount_src(data)                                   ((0x003FFFC0&(data))>>6)
+#define CODEBLKREG_VE_CNTL_get_ldstCmemCount(data)                                   ((0x003FFFC0&(data))>>6)
+#define CODEBLKREG_VE_CNTL_write_enable3_shift                                       (5)
+#define CODEBLKREG_VE_CNTL_write_enable3_mask                                        (0x00000020)
+#define CODEBLKREG_VE_CNTL_write_enable3(data)                                       (0x00000020&((data)<<5))
+#define CODEBLKREG_VE_CNTL_write_enable3_src(data)                                   ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_CNTL_get_write_enable3(data)                                   ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_CNTL_cabac_1p_mode_shift                                       (4)
+#define CODEBLKREG_VE_CNTL_cabac_1p_mode_mask                                        (0x00000010)
+#define CODEBLKREG_VE_CNTL_cabac_1p_mode(data)                                       (0x00000010&((data)<<4))
+#define CODEBLKREG_VE_CNTL_cabac_1p_mode_src(data)                                   ((0x00000010&(data))>>4)
+#define CODEBLKREG_VE_CNTL_get_cabac_1p_mode(data)                                   ((0x00000010&(data))>>4)
+#define CODEBLKREG_VE_CNTL_write_enable2_shift                                       (3)
+#define CODEBLKREG_VE_CNTL_write_enable2_mask                                        (0x00000008)
+#define CODEBLKREG_VE_CNTL_write_enable2(data)                                       (0x00000008&((data)<<3))
+#define CODEBLKREG_VE_CNTL_write_enable2_src(data)                                   ((0x00000008&(data))>>3)
+#define CODEBLKREG_VE_CNTL_get_write_enable2(data)                                   ((0x00000008&(data))>>3)
+#define CODEBLKREG_VE_CNTL_cabac_p2_p3_shift                                         (2)
+#define CODEBLKREG_VE_CNTL_cabac_p2_p3_mask                                          (0x00000004)
+#define CODEBLKREG_VE_CNTL_cabac_p2_p3(data)                                         (0x00000004&((data)<<2))
+#define CODEBLKREG_VE_CNTL_cabac_p2_p3_src(data)                                     ((0x00000004&(data))>>2)
+#define CODEBLKREG_VE_CNTL_get_cabac_p2_p3(data)                                     ((0x00000004&(data))>>2)
+#define CODEBLKREG_VE_CNTL_write_enable1_shift                                       (1)
+#define CODEBLKREG_VE_CNTL_write_enable1_mask                                        (0x00000002)
+#define CODEBLKREG_VE_CNTL_write_enable1(data)                                       (0x00000002&((data)<<1))
+#define CODEBLKREG_VE_CNTL_write_enable1_src(data)                                   ((0x00000002&(data))>>1)
+#define CODEBLKREG_VE_CNTL_get_write_enable1(data)                                   ((0x00000002&(data))>>1)
+#define CODEBLKREG_VE_CNTL_itblk_advmode_shift                                       (0)
+#define CODEBLKREG_VE_CNTL_itblk_advmode_mask                                        (0x00000001)
+#define CODEBLKREG_VE_CNTL_itblk_advmode(data)                                       (0x00000001&((data)<<0))
+#define CODEBLKREG_VE_CNTL_itblk_advmode_src(data)                                   ((0x00000001&(data))>>0)
+#define CODEBLKREG_VE_CNTL_get_itblk_advmode(data)                                   ((0x00000001&(data))>>0)
+
+
+#define CODEBLKREG_UMEM_CTRL                                                         0x1800E004
+#define CODEBLKREG_UMEM_CTRL_reg_addr                                                "0xB800E004"
+#define CODEBLKREG_UMEM_CTRL_reg                                                     0xB800E004
+#define set_CODEBLKREG_UMEM_CTRL_reg(data)   (*((volatile unsigned int*) CODEBLKREG_UMEM_CTRL_reg)=data)
+#define get_CODEBLKREG_UMEM_CTRL_reg   (*((volatile unsigned int*) CODEBLKREG_UMEM_CTRL_reg))
+#define CODEBLKREG_UMEM_CTRL_inst_adr                                                "0x0001"
+#define CODEBLKREG_UMEM_CTRL_inst                                                    0x0001
+#define CODEBLKREG_UMEM_CTRL_write_enable4_shift                                     (17)
+#define CODEBLKREG_UMEM_CTRL_write_enable4_mask                                      (0x00020000)
+#define CODEBLKREG_UMEM_CTRL_write_enable4(data)                                     (0x00020000&((data)<<17))
+#define CODEBLKREG_UMEM_CTRL_write_enable4_src(data)                                 ((0x00020000&(data))>>17)
+#define CODEBLKREG_UMEM_CTRL_get_write_enable4(data)                                 ((0x00020000&(data))>>17)
+#define CODEBLKREG_UMEM_CTRL_h264_prev_qp_shift                                      (11)
+#define CODEBLKREG_UMEM_CTRL_h264_prev_qp_mask                                       (0x0001F800)
+#define CODEBLKREG_UMEM_CTRL_h264_prev_qp(data)                                      (0x0001F800&((data)<<11))
+#define CODEBLKREG_UMEM_CTRL_h264_prev_qp_src(data)                                  ((0x0001F800&(data))>>11)
+#define CODEBLKREG_UMEM_CTRL_get_h264_prev_qp(data)                                  ((0x0001F800&(data))>>11)
+#define CODEBLKREG_UMEM_CTRL_write_enable3_shift                                     (10)
+#define CODEBLKREG_UMEM_CTRL_write_enable3_mask                                      (0x00000400)
+#define CODEBLKREG_UMEM_CTRL_write_enable3(data)                                     (0x00000400&((data)<<10))
+#define CODEBLKREG_UMEM_CTRL_write_enable3_src(data)                                 ((0x00000400&(data))>>10)
+#define CODEBLKREG_UMEM_CTRL_get_write_enable3(data)                                 ((0x00000400&(data))>>10)
+#define CODEBLKREG_UMEM_CTRL_pred_bank_shift                                         (8)
+#define CODEBLKREG_UMEM_CTRL_pred_bank_mask                                          (0x00000300)
+#define CODEBLKREG_UMEM_CTRL_pred_bank(data)                                         (0x00000300&((data)<<8))
+#define CODEBLKREG_UMEM_CTRL_pred_bank_src(data)                                     ((0x00000300&(data))>>8)
+#define CODEBLKREG_UMEM_CTRL_get_pred_bank(data)                                     ((0x00000300&(data))>>8)
+#define CODEBLKREG_UMEM_CTRL_write_enable2_shift                                     (7)
+#define CODEBLKREG_UMEM_CTRL_write_enable2_mask                                      (0x00000080)
+#define CODEBLKREG_UMEM_CTRL_write_enable2(data)                                     (0x00000080&((data)<<7))
+#define CODEBLKREG_UMEM_CTRL_write_enable2_src(data)                                 ((0x00000080&(data))>>7)
+#define CODEBLKREG_UMEM_CTRL_get_write_enable2(data)                                 ((0x00000080&(data))>>7)
+#define CODEBLKREG_UMEM_CTRL_dec_bank_shift                                          (5)
+#define CODEBLKREG_UMEM_CTRL_dec_bank_mask                                           (0x00000060)
+#define CODEBLKREG_UMEM_CTRL_dec_bank(data)                                          (0x00000060&((data)<<5))
+#define CODEBLKREG_UMEM_CTRL_dec_bank_src(data)                                      ((0x00000060&(data))>>5)
+#define CODEBLKREG_UMEM_CTRL_get_dec_bank(data)                                      ((0x00000060&(data))>>5)
+#define CODEBLKREG_UMEM_CTRL_write_enable1_shift                                     (4)
+#define CODEBLKREG_UMEM_CTRL_write_enable1_mask                                      (0x00000010)
+#define CODEBLKREG_UMEM_CTRL_write_enable1(data)                                     (0x00000010&((data)<<4))
+#define CODEBLKREG_UMEM_CTRL_write_enable1_src(data)                                 ((0x00000010&(data))>>4)
+#define CODEBLKREG_UMEM_CTRL_get_write_enable1(data)                                 ((0x00000010&(data))>>4)
+#define CODEBLKREG_UMEM_CTRL_umem_mstr_shift                                         (0)
+#define CODEBLKREG_UMEM_CTRL_umem_mstr_mask                                          (0x0000000F)
+#define CODEBLKREG_UMEM_CTRL_umem_mstr(data)                                         (0x0000000F&((data)<<0))
+#define CODEBLKREG_UMEM_CTRL_umem_mstr_src(data)                                     ((0x0000000F&(data))>>0)
+#define CODEBLKREG_UMEM_CTRL_get_umem_mstr(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define CODEBLKREG_VE_SLICEGROUP                                                     0x1800E008
+#define CODEBLKREG_VE_SLICEGROUP_reg_addr                                            "0xB800E008"
+#define CODEBLKREG_VE_SLICEGROUP_reg                                                 0xB800E008
+#define set_CODEBLKREG_VE_SLICEGROUP_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_SLICEGROUP_reg)=data)
+#define get_CODEBLKREG_VE_SLICEGROUP_reg   (*((volatile unsigned int*) CODEBLKREG_VE_SLICEGROUP_reg))
+#define CODEBLKREG_VE_SLICEGROUP_inst_adr                                            "0x0002"
+#define CODEBLKREG_VE_SLICEGROUP_inst                                                0x0002
+#define CODEBLKREG_VE_SLICEGROUP_mbaddrb_na_shift                                    (2)
+#define CODEBLKREG_VE_SLICEGROUP_mbaddrb_na_mask                                     (0x00000004)
+#define CODEBLKREG_VE_SLICEGROUP_mbaddrb_na(data)                                    (0x00000004&((data)<<2))
+#define CODEBLKREG_VE_SLICEGROUP_mbaddrb_na_src(data)                                ((0x00000004&(data))>>2)
+#define CODEBLKREG_VE_SLICEGROUP_get_mbaddrb_na(data)                                ((0x00000004&(data))>>2)
+#define CODEBLKREG_VE_SLICEGROUP_mbaddra_na_shift                                    (1)
+#define CODEBLKREG_VE_SLICEGROUP_mbaddra_na_mask                                     (0x00000002)
+#define CODEBLKREG_VE_SLICEGROUP_mbaddra_na(data)                                    (0x00000002&((data)<<1))
+#define CODEBLKREG_VE_SLICEGROUP_mbaddra_na_src(data)                                ((0x00000002&(data))>>1)
+#define CODEBLKREG_VE_SLICEGROUP_get_mbaddra_na(data)                                ((0x00000002&(data))>>1)
+#define CODEBLKREG_VE_SLICEGROUP_slicegroup_en_shift                                 (0)
+#define CODEBLKREG_VE_SLICEGROUP_slicegroup_en_mask                                  (0x00000001)
+#define CODEBLKREG_VE_SLICEGROUP_slicegroup_en(data)                                 (0x00000001&((data)<<0))
+#define CODEBLKREG_VE_SLICEGROUP_slicegroup_en_src(data)                             ((0x00000001&(data))>>0)
+#define CODEBLKREG_VE_SLICEGROUP_get_slicegroup_en(data)                             ((0x00000001&(data))>>0)
+
+
+#define CODEBLKREG_CURADR                                                            0x1800E00C
+#define CODEBLKREG_CURADR_reg_addr                                                   "0xB800E00C"
+#define CODEBLKREG_CURADR_reg                                                        0xB800E00C
+#define set_CODEBLKREG_CURADR_reg(data)   (*((volatile unsigned int*) CODEBLKREG_CURADR_reg)=data)
+#define get_CODEBLKREG_CURADR_reg   (*((volatile unsigned int*) CODEBLKREG_CURADR_reg))
+#define CODEBLKREG_CURADR_inst_adr                                                   "0x0003"
+#define CODEBLKREG_CURADR_inst                                                       0x0003
+#define CODEBLKREG_CURADR_write_enable3_shift                                        (30)
+#define CODEBLKREG_CURADR_write_enable3_mask                                         (0x40000000)
+#define CODEBLKREG_CURADR_write_enable3(data)                                        (0x40000000&((data)<<30))
+#define CODEBLKREG_CURADR_write_enable3_src(data)                                    ((0x40000000&(data))>>30)
+#define CODEBLKREG_CURADR_get_write_enable3(data)                                    ((0x40000000&(data))>>30)
+#define CODEBLKREG_CURADR_cabac_curmb_addr_shift                                     (20)
+#define CODEBLKREG_CURADR_cabac_curmb_addr_mask                                      (0x3FF00000)
+#define CODEBLKREG_CURADR_cabac_curmb_addr(data)                                     (0x3FF00000&((data)<<20))
+#define CODEBLKREG_CURADR_cabac_curmb_addr_src(data)                                 ((0x3FF00000&(data))>>20)
+#define CODEBLKREG_CURADR_get_cabac_curmb_addr(data)                                 ((0x3FF00000&(data))>>20)
+#define CODEBLKREG_CURADR_write_enable2_shift                                        (19)
+#define CODEBLKREG_CURADR_write_enable2_mask                                         (0x00080000)
+#define CODEBLKREG_CURADR_write_enable2(data)                                        (0x00080000&((data)<<19))
+#define CODEBLKREG_CURADR_write_enable2_src(data)                                    ((0x00080000&(data))>>19)
+#define CODEBLKREG_CURADR_get_write_enable2(data)                                    ((0x00080000&(data))>>19)
+#define CODEBLKREG_CURADR_vld_curmb_addr_shift                                       (9)
+#define CODEBLKREG_CURADR_vld_curmb_addr_mask                                        (0x0007FE00)
+#define CODEBLKREG_CURADR_vld_curmb_addr(data)                                       (0x0007FE00&((data)<<9))
+#define CODEBLKREG_CURADR_vld_curmb_addr_src(data)                                   ((0x0007FE00&(data))>>9)
+#define CODEBLKREG_CURADR_get_vld_curmb_addr(data)                                   ((0x0007FE00&(data))>>9)
+#define CODEBLKREG_CURADR_write_enable1_shift                                        (8)
+#define CODEBLKREG_CURADR_write_enable1_mask                                         (0x00000100)
+#define CODEBLKREG_CURADR_write_enable1(data)                                        (0x00000100&((data)<<8))
+#define CODEBLKREG_CURADR_write_enable1_src(data)                                    ((0x00000100&(data))>>8)
+#define CODEBLKREG_CURADR_get_write_enable1(data)                                    ((0x00000100&(data))>>8)
+#define CODEBLKREG_CURADR_acdc_curmb_addr_shift                                      (0)
+#define CODEBLKREG_CURADR_acdc_curmb_addr_mask                                       (0x000000FF)
+#define CODEBLKREG_CURADR_acdc_curmb_addr(data)                                      (0x000000FF&((data)<<0))
+#define CODEBLKREG_CURADR_acdc_curmb_addr_src(data)                                  ((0x000000FF&(data))>>0)
+#define CODEBLKREG_CURADR_get_acdc_curmb_addr(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define CODEBLKREG_PREDCNTR                                                          0x1800E010
+#define CODEBLKREG_PREDCNTR_reg_addr                                                 "0xB800E010"
+#define CODEBLKREG_PREDCNTR_reg                                                      0xB800E010
+#define set_CODEBLKREG_PREDCNTR_reg(data)   (*((volatile unsigned int*) CODEBLKREG_PREDCNTR_reg)=data)
+#define get_CODEBLKREG_PREDCNTR_reg   (*((volatile unsigned int*) CODEBLKREG_PREDCNTR_reg))
+#define CODEBLKREG_PREDCNTR_inst_adr                                                 "0x0004"
+#define CODEBLKREG_PREDCNTR_inst                                                     0x0004
+#define CODEBLKREG_PREDCNTR_write_enable3_shift                                      (30)
+#define CODEBLKREG_PREDCNTR_write_enable3_mask                                       (0x40000000)
+#define CODEBLKREG_PREDCNTR_write_enable3(data)                                      (0x40000000&((data)<<30))
+#define CODEBLKREG_PREDCNTR_write_enable3_src(data)                                  ((0x40000000&(data))>>30)
+#define CODEBLKREG_PREDCNTR_get_write_enable3(data)                                  ((0x40000000&(data))>>30)
+#define CODEBLKREG_PREDCNTR_cabac_pred_counter_shift                                 (20)
+#define CODEBLKREG_PREDCNTR_cabac_pred_counter_mask                                  (0x3FF00000)
+#define CODEBLKREG_PREDCNTR_cabac_pred_counter(data)                                 (0x3FF00000&((data)<<20))
+#define CODEBLKREG_PREDCNTR_cabac_pred_counter_src(data)                             ((0x3FF00000&(data))>>20)
+#define CODEBLKREG_PREDCNTR_get_cabac_pred_counter(data)                             ((0x3FF00000&(data))>>20)
+#define CODEBLKREG_PREDCNTR_write_enable2_shift                                      (19)
+#define CODEBLKREG_PREDCNTR_write_enable2_mask                                       (0x00080000)
+#define CODEBLKREG_PREDCNTR_write_enable2(data)                                      (0x00080000&((data)<<19))
+#define CODEBLKREG_PREDCNTR_write_enable2_src(data)                                  ((0x00080000&(data))>>19)
+#define CODEBLKREG_PREDCNTR_get_write_enable2(data)                                  ((0x00080000&(data))>>19)
+#define CODEBLKREG_PREDCNTR_vld_pred_counter_shift                                   (9)
+#define CODEBLKREG_PREDCNTR_vld_pred_counter_mask                                    (0x0007FE00)
+#define CODEBLKREG_PREDCNTR_vld_pred_counter(data)                                   (0x0007FE00&((data)<<9))
+#define CODEBLKREG_PREDCNTR_vld_pred_counter_src(data)                               ((0x0007FE00&(data))>>9)
+#define CODEBLKREG_PREDCNTR_get_vld_pred_counter(data)                               ((0x0007FE00&(data))>>9)
+#define CODEBLKREG_PREDCNTR_write_enable1_shift                                      (8)
+#define CODEBLKREG_PREDCNTR_write_enable1_mask                                       (0x00000100)
+#define CODEBLKREG_PREDCNTR_write_enable1(data)                                      (0x00000100&((data)<<8))
+#define CODEBLKREG_PREDCNTR_write_enable1_src(data)                                  ((0x00000100&(data))>>8)
+#define CODEBLKREG_PREDCNTR_get_write_enable1(data)                                  ((0x00000100&(data))>>8)
+#define CODEBLKREG_PREDCNTR_acdc_pred_counter_shift                                  (0)
+#define CODEBLKREG_PREDCNTR_acdc_pred_counter_mask                                   (0x000000FF)
+#define CODEBLKREG_PREDCNTR_acdc_pred_counter(data)                                  (0x000000FF&((data)<<0))
+#define CODEBLKREG_PREDCNTR_acdc_pred_counter_src(data)                              ((0x000000FF&(data))>>0)
+#define CODEBLKREG_PREDCNTR_get_acdc_pred_counter(data)                              ((0x000000FF&(data))>>0)
+
+
+#define CODEBLKREG_TOTAL_COEF1                                                       0x1800E014
+#define CODEBLKREG_TOTAL_COEF1_reg_addr                                              "0xB800E014"
+#define CODEBLKREG_TOTAL_COEF1_reg                                                   0xB800E014
+#define set_CODEBLKREG_TOTAL_COEF1_reg(data)   (*((volatile unsigned int*) CODEBLKREG_TOTAL_COEF1_reg)=data)
+#define get_CODEBLKREG_TOTAL_COEF1_reg   (*((volatile unsigned int*) CODEBLKREG_TOTAL_COEF1_reg))
+#define CODEBLKREG_TOTAL_COEF1_inst_adr                                              "0x0005"
+#define CODEBLKREG_TOTAL_COEF1_inst                                                  0x0005
+#define CODEBLKREG_TOTAL_COEF1_frame_field_mbpair_shift                              (20)
+#define CODEBLKREG_TOTAL_COEF1_frame_field_mbpair_mask                               (0x00100000)
+#define CODEBLKREG_TOTAL_COEF1_frame_field_mbpair(data)                              (0x00100000&((data)<<20))
+#define CODEBLKREG_TOTAL_COEF1_frame_field_mbpair_src(data)                          ((0x00100000&(data))>>20)
+#define CODEBLKREG_TOTAL_COEF1_get_frame_field_mbpair(data)                          ((0x00100000&(data))>>20)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_d_shift                                 (15)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_d_mask                                  (0x000F8000)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_d(data)                                 (0x000F8000&((data)<<15))
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_d_src(data)                             ((0x000F8000&(data))>>15)
+#define CODEBLKREG_TOTAL_COEF1_get_left_top_luma_d(data)                             ((0x000F8000&(data))>>15)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_c_shift                                 (10)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_c_mask                                  (0x00007C00)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_c(data)                                 (0x00007C00&((data)<<10))
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_c_src(data)                             ((0x00007C00&(data))>>10)
+#define CODEBLKREG_TOTAL_COEF1_get_left_top_luma_c(data)                             ((0x00007C00&(data))>>10)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_b_shift                                 (5)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_b_mask                                  (0x000003E0)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_b(data)                                 (0x000003E0&((data)<<5))
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_b_src(data)                             ((0x000003E0&(data))>>5)
+#define CODEBLKREG_TOTAL_COEF1_get_left_top_luma_b(data)                             ((0x000003E0&(data))>>5)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_a_shift                                 (0)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_a_mask                                  (0x0000001F)
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_a(data)                                 (0x0000001F&((data)<<0))
+#define CODEBLKREG_TOTAL_COEF1_left_top_luma_a_src(data)                             ((0x0000001F&(data))>>0)
+#define CODEBLKREG_TOTAL_COEF1_get_left_top_luma_a(data)                             ((0x0000001F&(data))>>0)
+
+
+#define CODEBLKREG_TOTAL_COEF2                                                       0x1800E018
+#define CODEBLKREG_TOTAL_COEF2_reg_addr                                              "0xB800E018"
+#define CODEBLKREG_TOTAL_COEF2_reg                                                   0xB800E018
+#define set_CODEBLKREG_TOTAL_COEF2_reg(data)   (*((volatile unsigned int*) CODEBLKREG_TOTAL_COEF2_reg)=data)
+#define get_CODEBLKREG_TOTAL_COEF2_reg   (*((volatile unsigned int*) CODEBLKREG_TOTAL_COEF2_reg))
+#define CODEBLKREG_TOTAL_COEF2_inst_adr                                              "0x0006"
+#define CODEBLKREG_TOTAL_COEF2_inst                                                  0x0006
+#define CODEBLKREG_TOTAL_COEF2_left_top_cb_a_shift                                   (15)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cb_a_mask                                    (0x000F8000)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cb_a(data)                                   (0x000F8000&((data)<<15))
+#define CODEBLKREG_TOTAL_COEF2_left_top_cb_a_src(data)                               ((0x000F8000&(data))>>15)
+#define CODEBLKREG_TOTAL_COEF2_get_left_top_cb_a(data)                               ((0x000F8000&(data))>>15)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cb_b_shift                                   (10)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cb_b_mask                                    (0x00007C00)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cb_b(data)                                   (0x00007C00&((data)<<10))
+#define CODEBLKREG_TOTAL_COEF2_left_top_cb_b_src(data)                               ((0x00007C00&(data))>>10)
+#define CODEBLKREG_TOTAL_COEF2_get_left_top_cb_b(data)                               ((0x00007C00&(data))>>10)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cr_a_shift                                   (5)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cr_a_mask                                    (0x000003E0)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cr_a(data)                                   (0x000003E0&((data)<<5))
+#define CODEBLKREG_TOTAL_COEF2_left_top_cr_a_src(data)                               ((0x000003E0&(data))>>5)
+#define CODEBLKREG_TOTAL_COEF2_get_left_top_cr_a(data)                               ((0x000003E0&(data))>>5)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cr_b_shift                                   (0)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cr_b_mask                                    (0x0000001F)
+#define CODEBLKREG_TOTAL_COEF2_left_top_cr_b(data)                                   (0x0000001F&((data)<<0))
+#define CODEBLKREG_TOTAL_COEF2_left_top_cr_b_src(data)                               ((0x0000001F&(data))>>0)
+#define CODEBLKREG_TOTAL_COEF2_get_left_top_cr_b(data)                               ((0x0000001F&(data))>>0)
+
+
+#define CODEBLKREG_TOTAL_COEF3                                                       0x1800E01C
+#define CODEBLKREG_TOTAL_COEF3_reg_addr                                              "0xB800E01C"
+#define CODEBLKREG_TOTAL_COEF3_reg                                                   0xB800E01C
+#define set_CODEBLKREG_TOTAL_COEF3_reg(data)   (*((volatile unsigned int*) CODEBLKREG_TOTAL_COEF3_reg)=data)
+#define get_CODEBLKREG_TOTAL_COEF3_reg   (*((volatile unsigned int*) CODEBLKREG_TOTAL_COEF3_reg))
+#define CODEBLKREG_TOTAL_COEF3_inst_adr                                              "0x0007"
+#define CODEBLKREG_TOTAL_COEF3_inst                                                  0x0007
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_d_shift                                 (15)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_d_mask                                  (0x000F8000)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_d(data)                                 (0x000F8000&((data)<<15))
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_d_src(data)                             ((0x000F8000&(data))>>15)
+#define CODEBLKREG_TOTAL_COEF3_get_left_bot_luma_d(data)                             ((0x000F8000&(data))>>15)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_c_shift                                 (10)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_c_mask                                  (0x00007C00)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_c(data)                                 (0x00007C00&((data)<<10))
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_c_src(data)                             ((0x00007C00&(data))>>10)
+#define CODEBLKREG_TOTAL_COEF3_get_left_bot_luma_c(data)                             ((0x00007C00&(data))>>10)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_b_shift                                 (5)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_b_mask                                  (0x000003E0)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_b(data)                                 (0x000003E0&((data)<<5))
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_b_src(data)                             ((0x000003E0&(data))>>5)
+#define CODEBLKREG_TOTAL_COEF3_get_left_bot_luma_b(data)                             ((0x000003E0&(data))>>5)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_a_shift                                 (0)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_a_mask                                  (0x0000001F)
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_a(data)                                 (0x0000001F&((data)<<0))
+#define CODEBLKREG_TOTAL_COEF3_left_bot_luma_a_src(data)                             ((0x0000001F&(data))>>0)
+#define CODEBLKREG_TOTAL_COEF3_get_left_bot_luma_a(data)                             ((0x0000001F&(data))>>0)
+
+
+#define CODEBLKREG_TOTAL_COEF4                                                       0x1800E020
+#define CODEBLKREG_TOTAL_COEF4_reg_addr                                              "0xB800E020"
+#define CODEBLKREG_TOTAL_COEF4_reg                                                   0xB800E020
+#define set_CODEBLKREG_TOTAL_COEF4_reg(data)   (*((volatile unsigned int*) CODEBLKREG_TOTAL_COEF4_reg)=data)
+#define get_CODEBLKREG_TOTAL_COEF4_reg   (*((volatile unsigned int*) CODEBLKREG_TOTAL_COEF4_reg))
+#define CODEBLKREG_TOTAL_COEF4_inst_adr                                              "0x0008"
+#define CODEBLKREG_TOTAL_COEF4_inst                                                  0x0008
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cb_a_shift                                   (15)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cb_a_mask                                    (0x000F8000)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cb_a(data)                                   (0x000F8000&((data)<<15))
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cb_a_src(data)                               ((0x000F8000&(data))>>15)
+#define CODEBLKREG_TOTAL_COEF4_get_left_bot_cb_a(data)                               ((0x000F8000&(data))>>15)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cb_b_shift                                   (10)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cb_b_mask                                    (0x00007C00)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cb_b(data)                                   (0x00007C00&((data)<<10))
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cb_b_src(data)                               ((0x00007C00&(data))>>10)
+#define CODEBLKREG_TOTAL_COEF4_get_left_bot_cb_b(data)                               ((0x00007C00&(data))>>10)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cr_a_shift                                   (5)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cr_a_mask                                    (0x000003E0)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cr_a(data)                                   (0x000003E0&((data)<<5))
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cr_a_src(data)                               ((0x000003E0&(data))>>5)
+#define CODEBLKREG_TOTAL_COEF4_get_left_bot_cr_a(data)                               ((0x000003E0&(data))>>5)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cr_b_shift                                   (0)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cr_b_mask                                    (0x0000001F)
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cr_b(data)                                   (0x0000001F&((data)<<0))
+#define CODEBLKREG_TOTAL_COEF4_left_bot_cr_b_src(data)                               ((0x0000001F&(data))>>0)
+#define CODEBLKREG_TOTAL_COEF4_get_left_bot_cr_b(data)                               ((0x0000001F&(data))>>0)
+
+
+#define CODEBLKREG_VP6_BAC                                                           0x1800E074
+#define CODEBLKREG_VP6_BAC_reg_addr                                                  "0xB800E074"
+#define CODEBLKREG_VP6_BAC_reg                                                       0xB800E074
+#define set_CODEBLKREG_VP6_BAC_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VP6_BAC_reg)=data)
+#define get_CODEBLKREG_VP6_BAC_reg   (*((volatile unsigned int*) CODEBLKREG_VP6_BAC_reg))
+#define CODEBLKREG_VP6_BAC_inst_adr                                                  "0x001D"
+#define CODEBLKREG_VP6_BAC_inst                                                      0x001D
+#define CODEBLKREG_VP6_BAC_high_shift                                                (20)
+#define CODEBLKREG_VP6_BAC_high_mask                                                 (0x1FF00000)
+#define CODEBLKREG_VP6_BAC_high(data)                                                (0x1FF00000&((data)<<20))
+#define CODEBLKREG_VP6_BAC_high_src(data)                                            ((0x1FF00000&(data))>>20)
+#define CODEBLKREG_VP6_BAC_get_high(data)                                            ((0x1FF00000&(data))>>20)
+#define CODEBLKREG_VP6_BAC_bits_shift                                                (16)
+#define CODEBLKREG_VP6_BAC_bits_mask                                                 (0x000F0000)
+#define CODEBLKREG_VP6_BAC_bits(data)                                                (0x000F0000&((data)<<16))
+#define CODEBLKREG_VP6_BAC_bits_src(data)                                            ((0x000F0000&(data))>>16)
+#define CODEBLKREG_VP6_BAC_get_bits(data)                                            ((0x000F0000&(data))>>16)
+#define CODEBLKREG_VP6_BAC_code_word_shift                                           (0)
+#define CODEBLKREG_VP6_BAC_code_word_mask                                            (0x0000FFFF)
+#define CODEBLKREG_VP6_BAC_code_word(data)                                           (0x0000FFFF&((data)<<0))
+#define CODEBLKREG_VP6_BAC_code_word_src(data)                                       ((0x0000FFFF&(data))>>0)
+#define CODEBLKREG_VP6_BAC_get_code_word(data)                                       ((0x0000FFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_AVS_CNTL                                                       0x1800E080
+#define CODEBLKREG_VE_AVS_CNTL_reg_addr                                              "0xB800E080"
+#define CODEBLKREG_VE_AVS_CNTL_reg                                                   0xB800E080
+#define set_CODEBLKREG_VE_AVS_CNTL_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_AVS_CNTL_reg)=data)
+#define get_CODEBLKREG_VE_AVS_CNTL_reg   (*((volatile unsigned int*) CODEBLKREG_VE_AVS_CNTL_reg))
+#define CODEBLKREG_VE_AVS_CNTL_inst_adr                                              "0x0020"
+#define CODEBLKREG_VE_AVS_CNTL_inst                                                  0x0020
+#define CODEBLKREG_VE_AVS_CNTL_write_enable8_shift                                   (26)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable8_mask                                    (0x04000000)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable8(data)                                   (0x04000000&((data)<<26))
+#define CODEBLKREG_VE_AVS_CNTL_write_enable8_src(data)                               ((0x04000000&(data))>>26)
+#define CODEBLKREG_VE_AVS_CNTL_get_write_enable8(data)                               ((0x04000000&(data))>>26)
+#define CODEBLKREG_VE_AVS_CNTL_ch_q_param_delta_v_shift                              (20)
+#define CODEBLKREG_VE_AVS_CNTL_ch_q_param_delta_v_mask                               (0x03F00000)
+#define CODEBLKREG_VE_AVS_CNTL_ch_q_param_delta_v(data)                              (0x03F00000&((data)<<20))
+#define CODEBLKREG_VE_AVS_CNTL_ch_q_param_delta_v_src(data)                          ((0x03F00000&(data))>>20)
+#define CODEBLKREG_VE_AVS_CNTL_get_ch_q_param_delta_v(data)                          ((0x03F00000&(data))>>20)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable7_shift                                   (19)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable7_mask                                    (0x00080000)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable7(data)                                   (0x00080000&((data)<<19))
+#define CODEBLKREG_VE_AVS_CNTL_write_enable7_src(data)                               ((0x00080000&(data))>>19)
+#define CODEBLKREG_VE_AVS_CNTL_get_write_enable7(data)                               ((0x00080000&(data))>>19)
+#define CODEBLKREG_VE_AVS_CNTL_ch_q_param_delta_u_shift                              (13)
+#define CODEBLKREG_VE_AVS_CNTL_ch_q_param_delta_u_mask                               (0x0007E000)
+#define CODEBLKREG_VE_AVS_CNTL_ch_q_param_delta_u(data)                              (0x0007E000&((data)<<13))
+#define CODEBLKREG_VE_AVS_CNTL_ch_q_param_delta_u_src(data)                          ((0x0007E000&(data))>>13)
+#define CODEBLKREG_VE_AVS_CNTL_get_ch_q_param_delta_u(data)                          ((0x0007E000&(data))>>13)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable6_shift                                   (12)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable6_mask                                    (0x00001000)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable6(data)                                   (0x00001000&((data)<<12))
+#define CODEBLKREG_VE_AVS_CNTL_write_enable6_src(data)                               ((0x00001000&(data))>>12)
+#define CODEBLKREG_VE_AVS_CNTL_get_write_enable6(data)                               ((0x00001000&(data))>>12)
+#define CODEBLKREG_VE_AVS_CNTL_pb_fld_enhanced_flg_shift                             (11)
+#define CODEBLKREG_VE_AVS_CNTL_pb_fld_enhanced_flg_mask                              (0x00000800)
+#define CODEBLKREG_VE_AVS_CNTL_pb_fld_enhanced_flg(data)                             (0x00000800&((data)<<11))
+#define CODEBLKREG_VE_AVS_CNTL_pb_fld_enhanced_flg_src(data)                         ((0x00000800&(data))>>11)
+#define CODEBLKREG_VE_AVS_CNTL_get_pb_fld_enhanced_flg(data)                         ((0x00000800&(data))>>11)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable5_shift                                   (10)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable5_mask                                    (0x00000400)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable5(data)                                   (0x00000400&((data)<<10))
+#define CODEBLKREG_VE_AVS_CNTL_write_enable5_src(data)                               ((0x00000400&(data))>>10)
+#define CODEBLKREG_VE_AVS_CNTL_get_write_enable5(data)                               ((0x00000400&(data))>>10)
+#define CODEBLKREG_VE_AVS_CNTL_frame_pic_type_shift                                  (8)
+#define CODEBLKREG_VE_AVS_CNTL_frame_pic_type_mask                                   (0x00000300)
+#define CODEBLKREG_VE_AVS_CNTL_frame_pic_type(data)                                  (0x00000300&((data)<<8))
+#define CODEBLKREG_VE_AVS_CNTL_frame_pic_type_src(data)                              ((0x00000300&(data))>>8)
+#define CODEBLKREG_VE_AVS_CNTL_get_frame_pic_type(data)                              ((0x00000300&(data))>>8)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable4_shift                                   (7)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable4_mask                                    (0x00000080)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable4(data)                                   (0x00000080&((data)<<7))
+#define CODEBLKREG_VE_AVS_CNTL_write_enable4_src(data)                               ((0x00000080&(data))>>7)
+#define CODEBLKREG_VE_AVS_CNTL_get_write_enable4(data)                               ((0x00000080&(data))>>7)
+#define CODEBLKREG_VE_AVS_CNTL_skip_mode_flag_shift                                  (6)
+#define CODEBLKREG_VE_AVS_CNTL_skip_mode_flag_mask                                   (0x00000040)
+#define CODEBLKREG_VE_AVS_CNTL_skip_mode_flag(data)                                  (0x00000040&((data)<<6))
+#define CODEBLKREG_VE_AVS_CNTL_skip_mode_flag_src(data)                              ((0x00000040&(data))>>6)
+#define CODEBLKREG_VE_AVS_CNTL_get_skip_mode_flag(data)                              ((0x00000040&(data))>>6)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable3_shift                                   (5)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable3_mask                                    (0x00000020)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable3(data)                                   (0x00000020&((data)<<5))
+#define CODEBLKREG_VE_AVS_CNTL_write_enable3_src(data)                               ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_AVS_CNTL_get_write_enable3(data)                               ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_AVS_CNTL_fixedQP_shift                                         (4)
+#define CODEBLKREG_VE_AVS_CNTL_fixedQP_mask                                          (0x00000010)
+#define CODEBLKREG_VE_AVS_CNTL_fixedQP(data)                                         (0x00000010&((data)<<4))
+#define CODEBLKREG_VE_AVS_CNTL_fixedQP_src(data)                                     ((0x00000010&(data))>>4)
+#define CODEBLKREG_VE_AVS_CNTL_get_fixedQP(data)                                     ((0x00000010&(data))>>4)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable2_shift                                   (3)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable2_mask                                    (0x00000008)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable2(data)                                   (0x00000008&((data)<<3))
+#define CODEBLKREG_VE_AVS_CNTL_write_enable2_src(data)                               ((0x00000008&(data))>>3)
+#define CODEBLKREG_VE_AVS_CNTL_get_write_enable2(data)                               ((0x00000008&(data))>>3)
+#define CODEBLKREG_VE_AVS_CNTL_mbweightingflg_shift                                  (2)
+#define CODEBLKREG_VE_AVS_CNTL_mbweightingflg_mask                                   (0x00000004)
+#define CODEBLKREG_VE_AVS_CNTL_mbweightingflg(data)                                  (0x00000004&((data)<<2))
+#define CODEBLKREG_VE_AVS_CNTL_mbweightingflg_src(data)                              ((0x00000004&(data))>>2)
+#define CODEBLKREG_VE_AVS_CNTL_get_mbweightingflg(data)                              ((0x00000004&(data))>>2)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable1_shift                                   (1)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable1_mask                                    (0x00000002)
+#define CODEBLKREG_VE_AVS_CNTL_write_enable1(data)                                   (0x00000002&((data)<<1))
+#define CODEBLKREG_VE_AVS_CNTL_write_enable1_src(data)                               ((0x00000002&(data))>>1)
+#define CODEBLKREG_VE_AVS_CNTL_get_write_enable1(data)                               ((0x00000002&(data))>>1)
+#define CODEBLKREG_VE_AVS_CNTL_pic_ref_flg_shift                                     (0)
+#define CODEBLKREG_VE_AVS_CNTL_pic_ref_flg_mask                                      (0x00000001)
+#define CODEBLKREG_VE_AVS_CNTL_pic_ref_flg(data)                                     (0x00000001&((data)<<0))
+#define CODEBLKREG_VE_AVS_CNTL_pic_ref_flg_src(data)                                 ((0x00000001&(data))>>0)
+#define CODEBLKREG_VE_AVS_CNTL_get_pic_ref_flg(data)                                 ((0x00000001&(data))>>0)
+
+
+#define CODEBLKREG_VE_H264_CNTL                                                      0x1800E100
+#define CODEBLKREG_VE_H264_CNTL_reg_addr                                             "0xB800E100"
+#define CODEBLKREG_VE_H264_CNTL_reg                                                  0xB800E100
+#define set_CODEBLKREG_VE_H264_CNTL_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_H264_CNTL_reg)=data)
+#define get_CODEBLKREG_VE_H264_CNTL_reg   (*((volatile unsigned int*) CODEBLKREG_VE_H264_CNTL_reg))
+#define CODEBLKREG_VE_H264_CNTL_inst_adr                                             "0x0040"
+#define CODEBLKREG_VE_H264_CNTL_inst                                                 0x0040
+#define CODEBLKREG_VE_H264_CNTL_qpprime_y_zero_transform_bypass_flag_shift           (29)
+#define CODEBLKREG_VE_H264_CNTL_qpprime_y_zero_transform_bypass_flag_mask            (0x20000000)
+#define CODEBLKREG_VE_H264_CNTL_qpprime_y_zero_transform_bypass_flag(data)           (0x20000000&((data)<<29))
+#define CODEBLKREG_VE_H264_CNTL_qpprime_y_zero_transform_bypass_flag_src(data)       ((0x20000000&(data))>>29)
+#define CODEBLKREG_VE_H264_CNTL_get_qpprime_y_zero_transform_bypass_flag(data)       ((0x20000000&(data))>>29)
+#define CODEBLKREG_VE_H264_CNTL_entropy_coding_mode_shift                            (28)
+#define CODEBLKREG_VE_H264_CNTL_entropy_coding_mode_mask                             (0x10000000)
+#define CODEBLKREG_VE_H264_CNTL_entropy_coding_mode(data)                            (0x10000000&((data)<<28))
+#define CODEBLKREG_VE_H264_CNTL_entropy_coding_mode_src(data)                        ((0x10000000&(data))>>28)
+#define CODEBLKREG_VE_H264_CNTL_get_entropy_coding_mode(data)                        ((0x10000000&(data))>>28)
+#define CODEBLKREG_VE_H264_CNTL_pic_init_qp_shift                                    (22)
+#define CODEBLKREG_VE_H264_CNTL_pic_init_qp_mask                                     (0x0FC00000)
+#define CODEBLKREG_VE_H264_CNTL_pic_init_qp(data)                                    (0x0FC00000&((data)<<22))
+#define CODEBLKREG_VE_H264_CNTL_pic_init_qp_src(data)                                ((0x0FC00000&(data))>>22)
+#define CODEBLKREG_VE_H264_CNTL_get_pic_init_qp(data)                                ((0x0FC00000&(data))>>22)
+#define CODEBLKREG_VE_H264_CNTL_chroma_qp_offset_shift                               (17)
+#define CODEBLKREG_VE_H264_CNTL_chroma_qp_offset_mask                                (0x003E0000)
+#define CODEBLKREG_VE_H264_CNTL_chroma_qp_offset(data)                               (0x003E0000&((data)<<17))
+#define CODEBLKREG_VE_H264_CNTL_chroma_qp_offset_src(data)                           ((0x003E0000&(data))>>17)
+#define CODEBLKREG_VE_H264_CNTL_get_chroma_qp_offset(data)                           ((0x003E0000&(data))>>17)
+#define CODEBLKREG_VE_H264_CNTL_second_chroma_qp_offset_shift                        (12)
+#define CODEBLKREG_VE_H264_CNTL_second_chroma_qp_offset_mask                         (0x0001F000)
+#define CODEBLKREG_VE_H264_CNTL_second_chroma_qp_offset(data)                        (0x0001F000&((data)<<12))
+#define CODEBLKREG_VE_H264_CNTL_second_chroma_qp_offset_src(data)                    ((0x0001F000&(data))>>12)
+#define CODEBLKREG_VE_H264_CNTL_get_second_chroma_qp_offset(data)                    ((0x0001F000&(data))>>12)
+#define CODEBLKREG_VE_H264_CNTL_direct_8x8_inferflg_shift                            (11)
+#define CODEBLKREG_VE_H264_CNTL_direct_8x8_inferflg_mask                             (0x00000800)
+#define CODEBLKREG_VE_H264_CNTL_direct_8x8_inferflg(data)                            (0x00000800&((data)<<11))
+#define CODEBLKREG_VE_H264_CNTL_direct_8x8_inferflg_src(data)                        ((0x00000800&(data))>>11)
+#define CODEBLKREG_VE_H264_CNTL_get_direct_8x8_inferflg(data)                        ((0x00000800&(data))>>11)
+#define CODEBLKREG_VE_H264_CNTL_transform_8x8_mode_flg_shift                         (10)
+#define CODEBLKREG_VE_H264_CNTL_transform_8x8_mode_flg_mask                          (0x00000400)
+#define CODEBLKREG_VE_H264_CNTL_transform_8x8_mode_flg(data)                         (0x00000400&((data)<<10))
+#define CODEBLKREG_VE_H264_CNTL_transform_8x8_mode_flg_src(data)                     ((0x00000400&(data))>>10)
+#define CODEBLKREG_VE_H264_CNTL_get_transform_8x8_mode_flg(data)                     ((0x00000400&(data))>>10)
+#define CODEBLKREG_VE_H264_CNTL_num_ref_idx_l0_active_minus1_shift                   (5)
+#define CODEBLKREG_VE_H264_CNTL_num_ref_idx_l0_active_minus1_mask                    (0x000003E0)
+#define CODEBLKREG_VE_H264_CNTL_num_ref_idx_l0_active_minus1(data)                   (0x000003E0&((data)<<5))
+#define CODEBLKREG_VE_H264_CNTL_num_ref_idx_l0_active_minus1_src(data)               ((0x000003E0&(data))>>5)
+#define CODEBLKREG_VE_H264_CNTL_get_num_ref_idx_l0_active_minus1(data)               ((0x000003E0&(data))>>5)
+#define CODEBLKREG_VE_H264_CNTL_num_ref_idx_l1_active_minus1_shift                   (0)
+#define CODEBLKREG_VE_H264_CNTL_num_ref_idx_l1_active_minus1_mask                    (0x0000001F)
+#define CODEBLKREG_VE_H264_CNTL_num_ref_idx_l1_active_minus1(data)                   (0x0000001F&((data)<<0))
+#define CODEBLKREG_VE_H264_CNTL_num_ref_idx_l1_active_minus1_src(data)               ((0x0000001F&(data))>>0)
+#define CODEBLKREG_VE_H264_CNTL_get_num_ref_idx_l1_active_minus1(data)               ((0x0000001F&(data))>>0)
+
+
+#define CODEBLKREG_VE_H264_CNTL2                                                     0x1800E104
+#define CODEBLKREG_VE_H264_CNTL2_reg_addr                                            "0xB800E104"
+#define CODEBLKREG_VE_H264_CNTL2_reg                                                 0xB800E104
+#define set_CODEBLKREG_VE_H264_CNTL2_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_H264_CNTL2_reg)=data)
+#define get_CODEBLKREG_VE_H264_CNTL2_reg   (*((volatile unsigned int*) CODEBLKREG_VE_H264_CNTL2_reg))
+#define CODEBLKREG_VE_H264_CNTL2_inst_adr                                            "0x0041"
+#define CODEBLKREG_VE_H264_CNTL2_inst                                                0x0041
+#define CODEBLKREG_VE_H264_CNTL2_write_enable3_shift                                 (14)
+#define CODEBLKREG_VE_H264_CNTL2_write_enable3_mask                                  (0x00004000)
+#define CODEBLKREG_VE_H264_CNTL2_write_enable3(data)                                 (0x00004000&((data)<<14))
+#define CODEBLKREG_VE_H264_CNTL2_write_enable3_src(data)                             ((0x00004000&(data))>>14)
+#define CODEBLKREG_VE_H264_CNTL2_get_write_enable3(data)                             ((0x00004000&(data))>>14)
+#define CODEBLKREG_VE_H264_CNTL2_pic_type_shift                                      (11)
+#define CODEBLKREG_VE_H264_CNTL2_pic_type_mask                                       (0x00003800)
+#define CODEBLKREG_VE_H264_CNTL2_pic_type(data)                                      (0x00003800&((data)<<11))
+#define CODEBLKREG_VE_H264_CNTL2_pic_type_src(data)                                  ((0x00003800&(data))>>11)
+#define CODEBLKREG_VE_H264_CNTL2_get_pic_type(data)                                  ((0x00003800&(data))>>11)
+#define CODEBLKREG_VE_H264_CNTL2_write_enable2_shift                                 (10)
+#define CODEBLKREG_VE_H264_CNTL2_write_enable2_mask                                  (0x00000400)
+#define CODEBLKREG_VE_H264_CNTL2_write_enable2(data)                                 (0x00000400&((data)<<10))
+#define CODEBLKREG_VE_H264_CNTL2_write_enable2_src(data)                             ((0x00000400&(data))>>10)
+#define CODEBLKREG_VE_H264_CNTL2_get_write_enable2(data)                             ((0x00000400&(data))>>10)
+#define CODEBLKREG_VE_H264_CNTL2_slice_qp_delta_shift                                (3)
+#define CODEBLKREG_VE_H264_CNTL2_slice_qp_delta_mask                                 (0x000003F8)
+#define CODEBLKREG_VE_H264_CNTL2_slice_qp_delta(data)                                (0x000003F8&((data)<<3))
+#define CODEBLKREG_VE_H264_CNTL2_slice_qp_delta_src(data)                            ((0x000003F8&(data))>>3)
+#define CODEBLKREG_VE_H264_CNTL2_get_slice_qp_delta(data)                            ((0x000003F8&(data))>>3)
+#define CODEBLKREG_VE_H264_CNTL2_write_enable1_shift                                 (2)
+#define CODEBLKREG_VE_H264_CNTL2_write_enable1_mask                                  (0x00000004)
+#define CODEBLKREG_VE_H264_CNTL2_write_enable1(data)                                 (0x00000004&((data)<<2))
+#define CODEBLKREG_VE_H264_CNTL2_write_enable1_src(data)                             ((0x00000004&(data))>>2)
+#define CODEBLKREG_VE_H264_CNTL2_get_write_enable1(data)                             ((0x00000004&(data))>>2)
+#define CODEBLKREG_VE_H264_CNTL2_cabac_init_idc_shift                                (0)
+#define CODEBLKREG_VE_H264_CNTL2_cabac_init_idc_mask                                 (0x00000003)
+#define CODEBLKREG_VE_H264_CNTL2_cabac_init_idc(data)                                (0x00000003&((data)<<0))
+#define CODEBLKREG_VE_H264_CNTL2_cabac_init_idc_src(data)                            ((0x00000003&(data))>>0)
+#define CODEBLKREG_VE_H264_CNTL2_get_cabac_init_idc(data)                            ((0x00000003&(data))>>0)
+
+
+#define CODEBLKREG_VE_VC1QUANT                                                       0x1800E108
+#define CODEBLKREG_VE_VC1QUANT_reg_addr                                              "0xB800E108"
+#define CODEBLKREG_VE_VC1QUANT_reg                                                   0xB800E108
+#define set_CODEBLKREG_VE_VC1QUANT_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_VC1QUANT_reg)=data)
+#define get_CODEBLKREG_VE_VC1QUANT_reg   (*((volatile unsigned int*) CODEBLKREG_VE_VC1QUANT_reg))
+#define CODEBLKREG_VE_VC1QUANT_inst_adr                                              "0x0042"
+#define CODEBLKREG_VE_VC1QUANT_inst                                                  0x0042
+#define CODEBLKREG_VE_VC1QUANT_write_enable8_shift                                   (25)
+#define CODEBLKREG_VE_VC1QUANT_write_enable8_mask                                    (0x02000000)
+#define CODEBLKREG_VE_VC1QUANT_write_enable8(data)                                   (0x02000000&((data)<<25))
+#define CODEBLKREG_VE_VC1QUANT_write_enable8_src(data)                               ((0x02000000&(data))>>25)
+#define CODEBLKREG_VE_VC1QUANT_get_write_enable8(data)                               ((0x02000000&(data))>>25)
+#define CODEBLKREG_VE_VC1QUANT_quan_type_shift                                       (24)
+#define CODEBLKREG_VE_VC1QUANT_quan_type_mask                                        (0x01000000)
+#define CODEBLKREG_VE_VC1QUANT_quan_type(data)                                       (0x01000000&((data)<<24))
+#define CODEBLKREG_VE_VC1QUANT_quan_type_src(data)                                   ((0x01000000&(data))>>24)
+#define CODEBLKREG_VE_VC1QUANT_get_quan_type(data)                                   ((0x01000000&(data))>>24)
+#define CODEBLKREG_VE_VC1QUANT_write_enable7_shift                                   (23)
+#define CODEBLKREG_VE_VC1QUANT_write_enable7_mask                                    (0x00800000)
+#define CODEBLKREG_VE_VC1QUANT_write_enable7(data)                                   (0x00800000&((data)<<23))
+#define CODEBLKREG_VE_VC1QUANT_write_enable7_src(data)                               ((0x00800000&(data))>>23)
+#define CODEBLKREG_VE_VC1QUANT_get_write_enable7(data)                               ((0x00800000&(data))>>23)
+#define CODEBLKREG_VE_VC1QUANT_dquant_shift                                          (21)
+#define CODEBLKREG_VE_VC1QUANT_dquant_mask                                           (0x00600000)
+#define CODEBLKREG_VE_VC1QUANT_dquant(data)                                          (0x00600000&((data)<<21))
+#define CODEBLKREG_VE_VC1QUANT_dquant_src(data)                                      ((0x00600000&(data))>>21)
+#define CODEBLKREG_VE_VC1QUANT_get_dquant(data)                                      ((0x00600000&(data))>>21)
+#define CODEBLKREG_VE_VC1QUANT_write_enable6_shift                                   (20)
+#define CODEBLKREG_VE_VC1QUANT_write_enable6_mask                                    (0x00100000)
+#define CODEBLKREG_VE_VC1QUANT_write_enable6(data)                                   (0x00100000&((data)<<20))
+#define CODEBLKREG_VE_VC1QUANT_write_enable6_src(data)                               ((0x00100000&(data))>>20)
+#define CODEBLKREG_VE_VC1QUANT_get_write_enable6(data)                               ((0x00100000&(data))>>20)
+#define CODEBLKREG_VE_VC1QUANT_pqindex_shift                                         (15)
+#define CODEBLKREG_VE_VC1QUANT_pqindex_mask                                          (0x000F8000)
+#define CODEBLKREG_VE_VC1QUANT_pqindex(data)                                         (0x000F8000&((data)<<15))
+#define CODEBLKREG_VE_VC1QUANT_pqindex_src(data)                                     ((0x000F8000&(data))>>15)
+#define CODEBLKREG_VE_VC1QUANT_get_pqindex(data)                                     ((0x000F8000&(data))>>15)
+#define CODEBLKREG_VE_VC1QUANT_write_enable5_shift                                   (14)
+#define CODEBLKREG_VE_VC1QUANT_write_enable5_mask                                    (0x00004000)
+#define CODEBLKREG_VE_VC1QUANT_write_enable5(data)                                   (0x00004000&((data)<<14))
+#define CODEBLKREG_VE_VC1QUANT_write_enable5_src(data)                               ((0x00004000&(data))>>14)
+#define CODEBLKREG_VE_VC1QUANT_get_write_enable5(data)                               ((0x00004000&(data))>>14)
+#define CODEBLKREG_VE_VC1QUANT_halfqp_shift                                          (13)
+#define CODEBLKREG_VE_VC1QUANT_halfqp_mask                                           (0x00002000)
+#define CODEBLKREG_VE_VC1QUANT_halfqp(data)                                          (0x00002000&((data)<<13))
+#define CODEBLKREG_VE_VC1QUANT_halfqp_src(data)                                      ((0x00002000&(data))>>13)
+#define CODEBLKREG_VE_VC1QUANT_get_halfqp(data)                                      ((0x00002000&(data))>>13)
+#define CODEBLKREG_VE_VC1QUANT_write_enable4_shift                                   (12)
+#define CODEBLKREG_VE_VC1QUANT_write_enable4_mask                                    (0x00001000)
+#define CODEBLKREG_VE_VC1QUANT_write_enable4(data)                                   (0x00001000&((data)<<12))
+#define CODEBLKREG_VE_VC1QUANT_write_enable4_src(data)                               ((0x00001000&(data))>>12)
+#define CODEBLKREG_VE_VC1QUANT_get_write_enable4(data)                               ((0x00001000&(data))>>12)
+#define CODEBLKREG_VE_VC1QUANT_altpquant_shift                                       (7)
+#define CODEBLKREG_VE_VC1QUANT_altpquant_mask                                        (0x00000F80)
+#define CODEBLKREG_VE_VC1QUANT_altpquant(data)                                       (0x00000F80&((data)<<7))
+#define CODEBLKREG_VE_VC1QUANT_altpquant_src(data)                                   ((0x00000F80&(data))>>7)
+#define CODEBLKREG_VE_VC1QUANT_get_altpquant(data)                                   ((0x00000F80&(data))>>7)
+#define CODEBLKREG_VE_VC1QUANT_write_enable3_shift                                   (6)
+#define CODEBLKREG_VE_VC1QUANT_write_enable3_mask                                    (0x00000040)
+#define CODEBLKREG_VE_VC1QUANT_write_enable3(data)                                   (0x00000040&((data)<<6))
+#define CODEBLKREG_VE_VC1QUANT_write_enable3_src(data)                               ((0x00000040&(data))>>6)
+#define CODEBLKREG_VE_VC1QUANT_get_write_enable3(data)                               ((0x00000040&(data))>>6)
+#define CODEBLKREG_VE_VC1QUANT_dquantfrm_shift                                       (5)
+#define CODEBLKREG_VE_VC1QUANT_dquantfrm_mask                                        (0x00000020)
+#define CODEBLKREG_VE_VC1QUANT_dquantfrm(data)                                       (0x00000020&((data)<<5))
+#define CODEBLKREG_VE_VC1QUANT_dquantfrm_src(data)                                   ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_VC1QUANT_get_dquantfrm(data)                                   ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_VC1QUANT_write_enable2_shift                                   (4)
+#define CODEBLKREG_VE_VC1QUANT_write_enable2_mask                                    (0x00000010)
+#define CODEBLKREG_VE_VC1QUANT_write_enable2(data)                                   (0x00000010&((data)<<4))
+#define CODEBLKREG_VE_VC1QUANT_write_enable2_src(data)                               ((0x00000010&(data))>>4)
+#define CODEBLKREG_VE_VC1QUANT_get_write_enable2(data)                               ((0x00000010&(data))>>4)
+#define CODEBLKREG_VE_VC1QUANT_dqprofile_shift                                       (2)
+#define CODEBLKREG_VE_VC1QUANT_dqprofile_mask                                        (0x0000000C)
+#define CODEBLKREG_VE_VC1QUANT_dqprofile(data)                                       (0x0000000C&((data)<<2))
+#define CODEBLKREG_VE_VC1QUANT_dqprofile_src(data)                                   ((0x0000000C&(data))>>2)
+#define CODEBLKREG_VE_VC1QUANT_get_dqprofile(data)                                   ((0x0000000C&(data))>>2)
+#define CODEBLKREG_VE_VC1QUANT_write_enable1_shift                                   (1)
+#define CODEBLKREG_VE_VC1QUANT_write_enable1_mask                                    (0x00000002)
+#define CODEBLKREG_VE_VC1QUANT_write_enable1(data)                                   (0x00000002&((data)<<1))
+#define CODEBLKREG_VE_VC1QUANT_write_enable1_src(data)                               ((0x00000002&(data))>>1)
+#define CODEBLKREG_VE_VC1QUANT_get_write_enable1(data)                               ((0x00000002&(data))>>1)
+#define CODEBLKREG_VE_VC1QUANT_dqbilevel_shift                                       (0)
+#define CODEBLKREG_VE_VC1QUANT_dqbilevel_mask                                        (0x00000001)
+#define CODEBLKREG_VE_VC1QUANT_dqbilevel(data)                                       (0x00000001&((data)<<0))
+#define CODEBLKREG_VE_VC1QUANT_dqbilevel_src(data)                                   ((0x00000001&(data))>>0)
+#define CODEBLKREG_VE_VC1QUANT_get_dqbilevel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define CODEBLKREG_VE_VC1TRANSFORM                                                   0x1800E10C
+#define CODEBLKREG_VE_VC1TRANSFORM_reg_addr                                          "0xB800E10C"
+#define CODEBLKREG_VE_VC1TRANSFORM_reg                                               0xB800E10C
+#define set_CODEBLKREG_VE_VC1TRANSFORM_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_VC1TRANSFORM_reg)=data)
+#define get_CODEBLKREG_VE_VC1TRANSFORM_reg   (*((volatile unsigned int*) CODEBLKREG_VE_VC1TRANSFORM_reg))
+#define CODEBLKREG_VE_VC1TRANSFORM_inst_adr                                          "0x0043"
+#define CODEBLKREG_VE_VC1TRANSFORM_inst                                              0x0043
+#define CODEBLKREG_VE_VC1TRANSFORM_ttmbf_shift                                       (0)
+#define CODEBLKREG_VE_VC1TRANSFORM_ttmbf_mask                                        (0x00000001)
+#define CODEBLKREG_VE_VC1TRANSFORM_ttmbf(data)                                       (0x00000001&((data)<<0))
+#define CODEBLKREG_VE_VC1TRANSFORM_ttmbf_src(data)                                   ((0x00000001&(data))>>0)
+#define CODEBLKREG_VE_VC1TRANSFORM_get_ttmbf(data)                                   ((0x00000001&(data))>>0)
+
+
+#define CODEBLKREG_VE_VC1MV                                                          0x1800E110
+#define CODEBLKREG_VE_VC1MV_reg_addr                                                 "0xB800E110"
+#define CODEBLKREG_VE_VC1MV_reg                                                      0xB800E110
+#define set_CODEBLKREG_VE_VC1MV_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_VC1MV_reg)=data)
+#define get_CODEBLKREG_VE_VC1MV_reg   (*((volatile unsigned int*) CODEBLKREG_VE_VC1MV_reg))
+#define CODEBLKREG_VE_VC1MV_inst_adr                                                 "0x0044"
+#define CODEBLKREG_VE_VC1MV_inst                                                     0x0044
+#define CODEBLKREG_VE_VC1MV_write_enable5_shift                                      (26)
+#define CODEBLKREG_VE_VC1MV_write_enable5_mask                                       (0x04000000)
+#define CODEBLKREG_VE_VC1MV_write_enable5(data)                                      (0x04000000&((data)<<26))
+#define CODEBLKREG_VE_VC1MV_write_enable5_src(data)                                  ((0x04000000&(data))>>26)
+#define CODEBLKREG_VE_VC1MV_get_write_enable5(data)                                  ((0x04000000&(data))>>26)
+#define CODEBLKREG_VE_VC1MV_vc1mvtab_shift                                           (23)
+#define CODEBLKREG_VE_VC1MV_vc1mvtab_mask                                            (0x03800000)
+#define CODEBLKREG_VE_VC1MV_vc1mvtab(data)                                           (0x03800000&((data)<<23))
+#define CODEBLKREG_VE_VC1MV_vc1mvtab_src(data)                                       ((0x03800000&(data))>>23)
+#define CODEBLKREG_VE_VC1MV_get_vc1mvtab(data)                                       ((0x03800000&(data))>>23)
+#define CODEBLKREG_VE_VC1MV_write_enable4_shift                                      (22)
+#define CODEBLKREG_VE_VC1MV_write_enable4_mask                                       (0x00400000)
+#define CODEBLKREG_VE_VC1MV_write_enable4(data)                                      (0x00400000&((data)<<22))
+#define CODEBLKREG_VE_VC1MV_write_enable4_src(data)                                  ((0x00400000&(data))>>22)
+#define CODEBLKREG_VE_VC1MV_get_write_enable4(data)                                  ((0x00400000&(data))>>22)
+#define CODEBLKREG_VE_VC1MV_mvrange_kx_shift                                         (18)
+#define CODEBLKREG_VE_VC1MV_mvrange_kx_mask                                          (0x003C0000)
+#define CODEBLKREG_VE_VC1MV_mvrange_kx(data)                                         (0x003C0000&((data)<<18))
+#define CODEBLKREG_VE_VC1MV_mvrange_kx_src(data)                                     ((0x003C0000&(data))>>18)
+#define CODEBLKREG_VE_VC1MV_get_mvrange_kx(data)                                     ((0x003C0000&(data))>>18)
+#define CODEBLKREG_VE_VC1MV_mvrange_ky_shift                                         (14)
+#define CODEBLKREG_VE_VC1MV_mvrange_ky_mask                                          (0x0003C000)
+#define CODEBLKREG_VE_VC1MV_mvrange_ky(data)                                         (0x0003C000&((data)<<14))
+#define CODEBLKREG_VE_VC1MV_mvrange_ky_src(data)                                     ((0x0003C000&(data))>>14)
+#define CODEBLKREG_VE_VC1MV_get_mvrange_ky(data)                                     ((0x0003C000&(data))>>14)
+#define CODEBLKREG_VE_VC1MV_write_enable3_shift                                      (13)
+#define CODEBLKREG_VE_VC1MV_write_enable3_mask                                       (0x00002000)
+#define CODEBLKREG_VE_VC1MV_write_enable3(data)                                      (0x00002000&((data)<<13))
+#define CODEBLKREG_VE_VC1MV_write_enable3_src(data)                                  ((0x00002000&(data))>>13)
+#define CODEBLKREG_VE_VC1MV_get_write_enable3(data)                                  ((0x00002000&(data))>>13)
+#define CODEBLKREG_VE_VC1MV_dmv_extend_x_shift                                       (12)
+#define CODEBLKREG_VE_VC1MV_dmv_extend_x_mask                                        (0x00001000)
+#define CODEBLKREG_VE_VC1MV_dmv_extend_x(data)                                       (0x00001000&((data)<<12))
+#define CODEBLKREG_VE_VC1MV_dmv_extend_x_src(data)                                   ((0x00001000&(data))>>12)
+#define CODEBLKREG_VE_VC1MV_get_dmv_extend_x(data)                                   ((0x00001000&(data))>>12)
+#define CODEBLKREG_VE_VC1MV_dmv_extend_y_shift                                       (11)
+#define CODEBLKREG_VE_VC1MV_dmv_extend_y_mask                                        (0x00000800)
+#define CODEBLKREG_VE_VC1MV_dmv_extend_y(data)                                       (0x00000800&((data)<<11))
+#define CODEBLKREG_VE_VC1MV_dmv_extend_y_src(data)                                   ((0x00000800&(data))>>11)
+#define CODEBLKREG_VE_VC1MV_get_dmv_extend_y(data)                                   ((0x00000800&(data))>>11)
+#define CODEBLKREG_VE_VC1MV_write_enable2_shift                                      (10)
+#define CODEBLKREG_VE_VC1MV_write_enable2_mask                                       (0x00000400)
+#define CODEBLKREG_VE_VC1MV_write_enable2(data)                                      (0x00000400&((data)<<10))
+#define CODEBLKREG_VE_VC1MV_write_enable2_src(data)                                  ((0x00000400&(data))>>10)
+#define CODEBLKREG_VE_VC1MV_get_write_enable2(data)                                  ((0x00000400&(data))>>10)
+#define CODEBLKREG_VE_VC1MV_tab2mvbp_shift                                           (8)
+#define CODEBLKREG_VE_VC1MV_tab2mvbp_mask                                            (0x00000300)
+#define CODEBLKREG_VE_VC1MV_tab2mvbp(data)                                           (0x00000300&((data)<<8))
+#define CODEBLKREG_VE_VC1MV_tab2mvbp_src(data)                                       ((0x00000300&(data))>>8)
+#define CODEBLKREG_VE_VC1MV_get_tab2mvbp(data)                                       ((0x00000300&(data))>>8)
+#define CODEBLKREG_VE_VC1MV_tab4mvbp_shift                                           (6)
+#define CODEBLKREG_VE_VC1MV_tab4mvbp_mask                                            (0x000000C0)
+#define CODEBLKREG_VE_VC1MV_tab4mvbp(data)                                           (0x000000C0&((data)<<6))
+#define CODEBLKREG_VE_VC1MV_tab4mvbp_src(data)                                       ((0x000000C0&(data))>>6)
+#define CODEBLKREG_VE_VC1MV_get_tab4mvbp(data)                                       ((0x000000C0&(data))>>6)
+#define CODEBLKREG_VE_VC1MV_write_enable1_shift                                      (5)
+#define CODEBLKREG_VE_VC1MV_write_enable1_mask                                       (0x00000020)
+#define CODEBLKREG_VE_VC1MV_write_enable1(data)                                      (0x00000020&((data)<<5))
+#define CODEBLKREG_VE_VC1MV_write_enable1_src(data)                                  ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_VC1MV_get_write_enable1(data)                                  ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_VC1MV_bfraction_shift                                          (0)
+#define CODEBLKREG_VE_VC1MV_bfraction_mask                                           (0x0000001F)
+#define CODEBLKREG_VE_VC1MV_bfraction(data)                                          (0x0000001F&((data)<<0))
+#define CODEBLKREG_VE_VC1MV_bfraction_src(data)                                      ((0x0000001F&(data))>>0)
+#define CODEBLKREG_VE_VC1MV_get_bfraction(data)                                      ((0x0000001F&(data))>>0)
+
+
+#define CODEBLKREG_VE_MVFCODE                                                        0x1800E114
+#define CODEBLKREG_VE_MVFCODE_reg_addr                                               "0xB800E114"
+#define CODEBLKREG_VE_MVFCODE_reg                                                    0xB800E114
+#define set_CODEBLKREG_VE_MVFCODE_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_MVFCODE_reg)=data)
+#define get_CODEBLKREG_VE_MVFCODE_reg   (*((volatile unsigned int*) CODEBLKREG_VE_MVFCODE_reg))
+#define CODEBLKREG_VE_MVFCODE_inst_adr                                               "0x0045"
+#define CODEBLKREG_VE_MVFCODE_inst                                                   0x0045
+#define CODEBLKREG_VE_MVFCODE_write_enable7_shift                                    (31)
+#define CODEBLKREG_VE_MVFCODE_write_enable7_mask                                     (0x80000000)
+#define CODEBLKREG_VE_MVFCODE_write_enable7(data)                                    (0x80000000&((data)<<31))
+#define CODEBLKREG_VE_MVFCODE_write_enable7_src(data)                                ((0x80000000&(data))>>31)
+#define CODEBLKREG_VE_MVFCODE_get_write_enable7(data)                                ((0x80000000&(data))>>31)
+#define CODEBLKREG_VE_MVFCODE_write_enable6_shift                                    (17)
+#define CODEBLKREG_VE_MVFCODE_write_enable6_mask                                     (0x00020000)
+#define CODEBLKREG_VE_MVFCODE_write_enable6(data)                                    (0x00020000&((data)<<17))
+#define CODEBLKREG_VE_MVFCODE_write_enable6_src(data)                                ((0x00020000&(data))>>17)
+#define CODEBLKREG_VE_MVFCODE_get_write_enable6(data)                                ((0x00020000&(data))>>17)
+#define CODEBLKREG_VE_MVFCODE_bk_x_fcode_shift                                       (13)
+#define CODEBLKREG_VE_MVFCODE_bk_x_fcode_mask                                        (0x0001E000)
+#define CODEBLKREG_VE_MVFCODE_bk_x_fcode(data)                                       (0x0001E000&((data)<<13))
+#define CODEBLKREG_VE_MVFCODE_bk_x_fcode_src(data)                                   ((0x0001E000&(data))>>13)
+#define CODEBLKREG_VE_MVFCODE_get_bk_x_fcode(data)                                   ((0x0001E000&(data))>>13)
+#define CODEBLKREG_VE_MVFCODE_bk_y_fcode_shift                                       (9)
+#define CODEBLKREG_VE_MVFCODE_bk_y_fcode_mask                                        (0x00001E00)
+#define CODEBLKREG_VE_MVFCODE_bk_y_fcode(data)                                       (0x00001E00&((data)<<9))
+#define CODEBLKREG_VE_MVFCODE_bk_y_fcode_src(data)                                   ((0x00001E00&(data))>>9)
+#define CODEBLKREG_VE_MVFCODE_get_bk_y_fcode(data)                                   ((0x00001E00&(data))>>9)
+#define CODEBLKREG_VE_MVFCODE_write_enable5_shift                                    (8)
+#define CODEBLKREG_VE_MVFCODE_write_enable5_mask                                     (0x00000100)
+#define CODEBLKREG_VE_MVFCODE_write_enable5(data)                                    (0x00000100&((data)<<8))
+#define CODEBLKREG_VE_MVFCODE_write_enable5_src(data)                                ((0x00000100&(data))>>8)
+#define CODEBLKREG_VE_MVFCODE_get_write_enable5(data)                                ((0x00000100&(data))>>8)
+#define CODEBLKREG_VE_MVFCODE_fo_x_fcode_shift                                       (4)
+#define CODEBLKREG_VE_MVFCODE_fo_x_fcode_mask                                        (0x000000F0)
+#define CODEBLKREG_VE_MVFCODE_fo_x_fcode(data)                                       (0x000000F0&((data)<<4))
+#define CODEBLKREG_VE_MVFCODE_fo_x_fcode_src(data)                                   ((0x000000F0&(data))>>4)
+#define CODEBLKREG_VE_MVFCODE_get_fo_x_fcode(data)                                   ((0x000000F0&(data))>>4)
+#define CODEBLKREG_VE_MVFCODE_fo_y_fcode_shift                                       (0)
+#define CODEBLKREG_VE_MVFCODE_fo_y_fcode_mask                                        (0x0000000F)
+#define CODEBLKREG_VE_MVFCODE_fo_y_fcode(data)                                       (0x0000000F&((data)<<0))
+#define CODEBLKREG_VE_MVFCODE_fo_y_fcode_src(data)                                   ((0x0000000F&(data))>>0)
+#define CODEBLKREG_VE_MVFCODE_get_fo_y_fcode(data)                                   ((0x0000000F&(data))>>0)
+
+
+#define CODEBLKREG_VE_VC1TABLE                                                       0x1800E118
+#define CODEBLKREG_VE_VC1TABLE_reg_addr                                              "0xB800E118"
+#define CODEBLKREG_VE_VC1TABLE_reg                                                   0xB800E118
+#define set_CODEBLKREG_VE_VC1TABLE_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_VC1TABLE_reg)=data)
+#define get_CODEBLKREG_VE_VC1TABLE_reg   (*((volatile unsigned int*) CODEBLKREG_VE_VC1TABLE_reg))
+#define CODEBLKREG_VE_VC1TABLE_inst_adr                                              "0x0046"
+#define CODEBLKREG_VE_VC1TABLE_inst                                                  0x0046
+#define CODEBLKREG_VE_VC1TABLE_write_enable5_shift                                   (16)
+#define CODEBLKREG_VE_VC1TABLE_write_enable5_mask                                    (0x00010000)
+#define CODEBLKREG_VE_VC1TABLE_write_enable5(data)                                   (0x00010000&((data)<<16))
+#define CODEBLKREG_VE_VC1TABLE_write_enable5_src(data)                               ((0x00010000&(data))>>16)
+#define CODEBLKREG_VE_VC1TABLE_get_write_enable5(data)                               ((0x00010000&(data))>>16)
+#define CODEBLKREG_VE_VC1TABLE_dctable_sel_shift                                     (15)
+#define CODEBLKREG_VE_VC1TABLE_dctable_sel_mask                                      (0x00008000)
+#define CODEBLKREG_VE_VC1TABLE_dctable_sel(data)                                     (0x00008000&((data)<<15))
+#define CODEBLKREG_VE_VC1TABLE_dctable_sel_src(data)                                 ((0x00008000&(data))>>15)
+#define CODEBLKREG_VE_VC1TABLE_get_dctable_sel(data)                                 ((0x00008000&(data))>>15)
+#define CODEBLKREG_VE_VC1TABLE_write_enable4_shift                                   (14)
+#define CODEBLKREG_VE_VC1TABLE_write_enable4_mask                                    (0x00004000)
+#define CODEBLKREG_VE_VC1TABLE_write_enable4(data)                                   (0x00004000&((data)<<14))
+#define CODEBLKREG_VE_VC1TABLE_write_enable4_src(data)                               ((0x00004000&(data))>>14)
+#define CODEBLKREG_VE_VC1TABLE_get_write_enable4(data)                               ((0x00004000&(data))>>14)
+#define CODEBLKREG_VE_VC1TABLE_transacfrm_shift                                      (12)
+#define CODEBLKREG_VE_VC1TABLE_transacfrm_mask                                       (0x00003000)
+#define CODEBLKREG_VE_VC1TABLE_transacfrm(data)                                      (0x00003000&((data)<<12))
+#define CODEBLKREG_VE_VC1TABLE_transacfrm_src(data)                                  ((0x00003000&(data))>>12)
+#define CODEBLKREG_VE_VC1TABLE_get_transacfrm(data)                                  ((0x00003000&(data))>>12)
+#define CODEBLKREG_VE_VC1TABLE_transacfrm2_shift                                     (10)
+#define CODEBLKREG_VE_VC1TABLE_transacfrm2_mask                                      (0x00000C00)
+#define CODEBLKREG_VE_VC1TABLE_transacfrm2(data)                                     (0x00000C00&((data)<<10))
+#define CODEBLKREG_VE_VC1TABLE_transacfrm2_src(data)                                 ((0x00000C00&(data))>>10)
+#define CODEBLKREG_VE_VC1TABLE_get_transacfrm2(data)                                 ((0x00000C00&(data))>>10)
+#define CODEBLKREG_VE_VC1TABLE_write_enable3_shift                                   (9)
+#define CODEBLKREG_VE_VC1TABLE_write_enable3_mask                                    (0x00000200)
+#define CODEBLKREG_VE_VC1TABLE_write_enable3(data)                                   (0x00000200&((data)<<9))
+#define CODEBLKREG_VE_VC1TABLE_write_enable3_src(data)                               ((0x00000200&(data))>>9)
+#define CODEBLKREG_VE_VC1TABLE_get_write_enable3(data)                               ((0x00000200&(data))>>9)
+#define CODEBLKREG_VE_VC1TABLE_cbp_table_shift                                       (6)
+#define CODEBLKREG_VE_VC1TABLE_cbp_table_mask                                        (0x000001C0)
+#define CODEBLKREG_VE_VC1TABLE_cbp_table(data)                                       (0x000001C0&((data)<<6))
+#define CODEBLKREG_VE_VC1TABLE_cbp_table_src(data)                                   ((0x000001C0&(data))>>6)
+#define CODEBLKREG_VE_VC1TABLE_get_cbp_table(data)                                   ((0x000001C0&(data))>>6)
+#define CODEBLKREG_VE_VC1TABLE_write_enable2_shift                                   (5)
+#define CODEBLKREG_VE_VC1TABLE_write_enable2_mask                                    (0x00000020)
+#define CODEBLKREG_VE_VC1TABLE_write_enable2(data)                                   (0x00000020&((data)<<5))
+#define CODEBLKREG_VE_VC1TABLE_write_enable2_src(data)                               ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_VC1TABLE_get_write_enable2(data)                               ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_VC1TABLE_flg_4mvswitch_shift                                   (4)
+#define CODEBLKREG_VE_VC1TABLE_flg_4mvswitch_mask                                    (0x00000010)
+#define CODEBLKREG_VE_VC1TABLE_flg_4mvswitch(data)                                   (0x00000010&((data)<<4))
+#define CODEBLKREG_VE_VC1TABLE_flg_4mvswitch_src(data)                               ((0x00000010&(data))>>4)
+#define CODEBLKREG_VE_VC1TABLE_get_flg_4mvswitch(data)                               ((0x00000010&(data))>>4)
+#define CODEBLKREG_VE_VC1TABLE_write_enable1_shift                                   (3)
+#define CODEBLKREG_VE_VC1TABLE_write_enable1_mask                                    (0x00000008)
+#define CODEBLKREG_VE_VC1TABLE_write_enable1(data)                                   (0x00000008&((data)<<3))
+#define CODEBLKREG_VE_VC1TABLE_write_enable1_src(data)                               ((0x00000008&(data))>>3)
+#define CODEBLKREG_VE_VC1TABLE_get_write_enable1(data)                               ((0x00000008&(data))>>3)
+#define CODEBLKREG_VE_VC1TABLE_mbmodetab_shift                                       (0)
+#define CODEBLKREG_VE_VC1TABLE_mbmodetab_mask                                        (0x00000007)
+#define CODEBLKREG_VE_VC1TABLE_mbmodetab(data)                                       (0x00000007&((data)<<0))
+#define CODEBLKREG_VE_VC1TABLE_mbmodetab_src(data)                                   ((0x00000007&(data))>>0)
+#define CODEBLKREG_VE_VC1TABLE_get_mbmodetab(data)                                   ((0x00000007&(data))>>0)
+
+
+#define CODEBLKREG_VE_VC1ESC                                                         0x1800E11C
+#define CODEBLKREG_VE_VC1ESC_reg_addr                                                "0xB800E11C"
+#define CODEBLKREG_VE_VC1ESC_reg                                                     0xB800E11C
+#define set_CODEBLKREG_VE_VC1ESC_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_VC1ESC_reg)=data)
+#define get_CODEBLKREG_VE_VC1ESC_reg   (*((volatile unsigned int*) CODEBLKREG_VE_VC1ESC_reg))
+#define CODEBLKREG_VE_VC1ESC_inst_adr                                                "0x0047"
+#define CODEBLKREG_VE_VC1ESC_inst                                                    0x0047
+#define CODEBLKREG_VE_VC1ESC_write_enable1_shift                                     (7)
+#define CODEBLKREG_VE_VC1ESC_write_enable1_mask                                      (0x00000080)
+#define CODEBLKREG_VE_VC1ESC_write_enable1(data)                                     (0x00000080&((data)<<7))
+#define CODEBLKREG_VE_VC1ESC_write_enable1_src(data)                                 ((0x00000080&(data))>>7)
+#define CODEBLKREG_VE_VC1ESC_get_write_enable1(data)                                 ((0x00000080&(data))>>7)
+#define CODEBLKREG_VE_VC1ESC_escm3_rsize_shift                                       (4)
+#define CODEBLKREG_VE_VC1ESC_escm3_rsize_mask                                        (0x00000070)
+#define CODEBLKREG_VE_VC1ESC_escm3_rsize(data)                                       (0x00000070&((data)<<4))
+#define CODEBLKREG_VE_VC1ESC_escm3_rsize_src(data)                                   ((0x00000070&(data))>>4)
+#define CODEBLKREG_VE_VC1ESC_get_escm3_rsize(data)                                   ((0x00000070&(data))>>4)
+#define CODEBLKREG_VE_VC1ESC_escm3_lsize_shift                                       (0)
+#define CODEBLKREG_VE_VC1ESC_escm3_lsize_mask                                        (0x0000000F)
+#define CODEBLKREG_VE_VC1ESC_escm3_lsize(data)                                       (0x0000000F&((data)<<0))
+#define CODEBLKREG_VE_VC1ESC_escm3_lsize_src(data)                                   ((0x0000000F&(data))>>0)
+#define CODEBLKREG_VE_VC1ESC_get_escm3_lsize(data)                                   ((0x0000000F&(data))>>0)
+
+
+#define CODEBLKREG_VE_VC1BITPLN_CNTL                                                 0x1800E120
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_reg_addr                                        "0xB800E120"
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_reg                                             0xB800E120
+#define set_CODEBLKREG_VE_VC1BITPLN_CNTL_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_VC1BITPLN_CNTL_reg)=data)
+#define get_CODEBLKREG_VE_VC1BITPLN_CNTL_reg   (*((volatile unsigned int*) CODEBLKREG_VE_VC1BITPLN_CNTL_reg))
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_inst_adr                                        "0x0048"
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_inst                                            0x0048
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_rowMB_shift                                     (24)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_rowMB_mask                                      (0xFF000000)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_rowMB(data)                                     (0xFF000000&((data)<<24))
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_rowMB_src(data)                                 ((0xFF000000&(data))>>24)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_get_rowMB(data)                                 ((0xFF000000&(data))>>24)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_colMB_shift                                     (17)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_colMB_mask                                      (0x00FE0000)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_colMB(data)                                     (0x00FE0000&((data)<<17))
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_colMB_src(data)                                 ((0x00FE0000&(data))>>17)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_get_colMB(data)                                 ((0x00FE0000&(data))>>17)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_rowmb_mod3_shift                                (15)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_rowmb_mod3_mask                                 (0x00018000)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_rowmb_mod3(data)                                (0x00018000&((data)<<15))
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_rowmb_mod3_src(data)                            ((0x00018000&(data))>>15)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_get_rowmb_mod3(data)                            ((0x00018000&(data))>>15)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_colmb_mod3_shift                                (13)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_colmb_mod3_mask                                 (0x00006000)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_colmb_mod3(data)                                (0x00006000&((data)<<13))
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_colmb_mod3_src(data)                            ((0x00006000&(data))>>13)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_get_colmb_mod3(data)                            ((0x00006000&(data))>>13)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_bitplane_len_shift                              (0)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_bitplane_len_mask                               (0x00001FFF)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_bitplane_len(data)                              (0x00001FFF&((data)<<0))
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_bitplane_len_src(data)                          ((0x00001FFF&(data))>>0)
+#define CODEBLKREG_VE_VC1BITPLN_CNTL_get_bitplane_len(data)                          ((0x00001FFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_VC1BITPLN_BASE                                                 0x1800E124
+#define CODEBLKREG_VE_VC1BITPLN_BASE_reg_addr                                        "0xB800E124"
+#define CODEBLKREG_VE_VC1BITPLN_BASE_reg                                             0xB800E124
+#define set_CODEBLKREG_VE_VC1BITPLN_BASE_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_VC1BITPLN_BASE_reg)=data)
+#define get_CODEBLKREG_VE_VC1BITPLN_BASE_reg   (*((volatile unsigned int*) CODEBLKREG_VE_VC1BITPLN_BASE_reg))
+#define CODEBLKREG_VE_VC1BITPLN_BASE_inst_adr                                        "0x0049"
+#define CODEBLKREG_VE_VC1BITPLN_BASE_inst                                            0x0049
+#define CODEBLKREG_VE_VC1BITPLN_BASE_bitplane_addr_shift                             (0)
+#define CODEBLKREG_VE_VC1BITPLN_BASE_bitplane_addr_mask                              (0xFFFFFFFF)
+#define CODEBLKREG_VE_VC1BITPLN_BASE_bitplane_addr(data)                             (0xFFFFFFFF&((data)<<0))
+#define CODEBLKREG_VE_VC1BITPLN_BASE_bitplane_addr_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define CODEBLKREG_VE_VC1BITPLN_BASE_get_bitplane_addr(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_LDSTADDR                                                       0x1800E128
+#define CODEBLKREG_VE_LDSTADDR_reg_addr                                              "0xB800E128"
+#define CODEBLKREG_VE_LDSTADDR_reg                                                   0xB800E128
+#define set_CODEBLKREG_VE_LDSTADDR_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_LDSTADDR_reg)=data)
+#define get_CODEBLKREG_VE_LDSTADDR_reg   (*((volatile unsigned int*) CODEBLKREG_VE_LDSTADDR_reg))
+#define CODEBLKREG_VE_LDSTADDR_inst_adr                                              "0x004A"
+#define CODEBLKREG_VE_LDSTADDR_inst                                                  0x004A
+#define CODEBLKREG_VE_LDSTADDR_ldst_addr_shift                                       (0)
+#define CODEBLKREG_VE_LDSTADDR_ldst_addr_mask                                        (0x7FFFFFFF)
+#define CODEBLKREG_VE_LDSTADDR_ldst_addr(data)                                       (0x7FFFFFFF&((data)<<0))
+#define CODEBLKREG_VE_LDSTADDR_ldst_addr_src(data)                                   ((0x7FFFFFFF&(data))>>0)
+#define CODEBLKREG_VE_LDSTADDR_get_ldst_addr(data)                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_DECBITCNT                                                      0x1800E200
+#define CODEBLKREG_VE_DECBITCNT_reg_addr                                             "0xB800E200"
+#define CODEBLKREG_VE_DECBITCNT_reg                                                  0xB800E200
+#define set_CODEBLKREG_VE_DECBITCNT_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_DECBITCNT_reg)=data)
+#define get_CODEBLKREG_VE_DECBITCNT_reg   (*((volatile unsigned int*) CODEBLKREG_VE_DECBITCNT_reg))
+#define CODEBLKREG_VE_DECBITCNT_inst_adr                                             "0x0080"
+#define CODEBLKREG_VE_DECBITCNT_inst                                                 0x0080
+#define CODEBLKREG_VE_DECBITCNT_max_bit_shift                                        (0)
+#define CODEBLKREG_VE_DECBITCNT_max_bit_mask                                         (0xFFFFFFFF)
+#define CODEBLKREG_VE_DECBITCNT_max_bit(data)                                        (0xFFFFFFFF&((data)<<0))
+#define CODEBLKREG_VE_DECBITCNT_max_bit_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define CODEBLKREG_VE_DECBITCNT_get_max_bit(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VLD_BITCNT                                                        0x1800E204
+#define CODEBLKREG_VLD_BITCNT_reg_addr                                               "0xB800E204"
+#define CODEBLKREG_VLD_BITCNT_reg                                                    0xB800E204
+#define set_CODEBLKREG_VLD_BITCNT_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VLD_BITCNT_reg)=data)
+#define get_CODEBLKREG_VLD_BITCNT_reg   (*((volatile unsigned int*) CODEBLKREG_VLD_BITCNT_reg))
+#define CODEBLKREG_VLD_BITCNT_inst_adr                                               "0x0081"
+#define CODEBLKREG_VLD_BITCNT_inst                                                   0x0081
+#define CODEBLKREG_VLD_BITCNT_dec_bitcnt_shift                                       (0)
+#define CODEBLKREG_VLD_BITCNT_dec_bitcnt_mask                                        (0xFFFFFFFF)
+#define CODEBLKREG_VLD_BITCNT_dec_bitcnt(data)                                       (0xFFFFFFFF&((data)<<0))
+#define CODEBLKREG_VLD_BITCNT_dec_bitcnt_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define CODEBLKREG_VLD_BITCNT_get_dec_bitcnt(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_BSCNTL                                                         0x1800E208
+#define CODEBLKREG_VE_BSCNTL_reg_addr                                                "0xB800E208"
+#define CODEBLKREG_VE_BSCNTL_reg                                                     0xB800E208
+#define set_CODEBLKREG_VE_BSCNTL_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_BSCNTL_reg)=data)
+#define get_CODEBLKREG_VE_BSCNTL_reg   (*((volatile unsigned int*) CODEBLKREG_VE_BSCNTL_reg))
+#define CODEBLKREG_VE_BSCNTL_inst_adr                                                "0x0082"
+#define CODEBLKREG_VE_BSCNTL_inst                                                    0x0082
+#define CODEBLKREG_VE_BSCNTL_write_enable3_shift                                     (6)
+#define CODEBLKREG_VE_BSCNTL_write_enable3_mask                                      (0x00000040)
+#define CODEBLKREG_VE_BSCNTL_write_enable3(data)                                     (0x00000040&((data)<<6))
+#define CODEBLKREG_VE_BSCNTL_write_enable3_src(data)                                 ((0x00000040&(data))>>6)
+#define CODEBLKREG_VE_BSCNTL_get_write_enable3(data)                                 ((0x00000040&(data))>>6)
+#define CODEBLKREG_VE_BSCNTL_detect_startcode_error_shift                            (5)
+#define CODEBLKREG_VE_BSCNTL_detect_startcode_error_mask                             (0x00000020)
+#define CODEBLKREG_VE_BSCNTL_detect_startcode_error(data)                            (0x00000020&((data)<<5))
+#define CODEBLKREG_VE_BSCNTL_detect_startcode_error_src(data)                        ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_BSCNTL_get_detect_startcode_error(data)                        ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_BSCNTL_write_enable2_shift                                     (4)
+#define CODEBLKREG_VE_BSCNTL_write_enable2_mask                                      (0x00000010)
+#define CODEBLKREG_VE_BSCNTL_write_enable2(data)                                     (0x00000010&((data)<<4))
+#define CODEBLKREG_VE_BSCNTL_write_enable2_src(data)                                 ((0x00000010&(data))>>4)
+#define CODEBLKREG_VE_BSCNTL_get_write_enable2(data)                                 ((0x00000010&(data))>>4)
+#define CODEBLKREG_VE_BSCNTL_min_xfer_size_shift                                     (2)
+#define CODEBLKREG_VE_BSCNTL_min_xfer_size_mask                                      (0x0000000C)
+#define CODEBLKREG_VE_BSCNTL_min_xfer_size(data)                                     (0x0000000C&((data)<<2))
+#define CODEBLKREG_VE_BSCNTL_min_xfer_size_src(data)                                 ((0x0000000C&(data))>>2)
+#define CODEBLKREG_VE_BSCNTL_get_min_xfer_size(data)                                 ((0x0000000C&(data))>>2)
+#define CODEBLKREG_VE_BSCNTL_write_enable1_shift                                     (1)
+#define CODEBLKREG_VE_BSCNTL_write_enable1_mask                                      (0x00000002)
+#define CODEBLKREG_VE_BSCNTL_write_enable1(data)                                     (0x00000002&((data)<<1))
+#define CODEBLKREG_VE_BSCNTL_write_enable1_src(data)                                 ((0x00000002&(data))>>1)
+#define CODEBLKREG_VE_BSCNTL_get_write_enable1(data)                                 ((0x00000002&(data))>>1)
+#define CODEBLKREG_VE_BSCNTL_startcode_prevnt_en_shift                               (0)
+#define CODEBLKREG_VE_BSCNTL_startcode_prevnt_en_mask                                (0x00000001)
+#define CODEBLKREG_VE_BSCNTL_startcode_prevnt_en(data)                               (0x00000001&((data)<<0))
+#define CODEBLKREG_VE_BSCNTL_startcode_prevnt_en_src(data)                           ((0x00000001&(data))>>0)
+#define CODEBLKREG_VE_BSCNTL_get_startcode_prevnt_en(data)                           ((0x00000001&(data))>>0)
+
+
+#define CODEBLKREG_VE_BS_MIN_THR                                                     0x1800E20C
+#define CODEBLKREG_VE_BS_MIN_THR_reg_addr                                            "0xB800E20C"
+#define CODEBLKREG_VE_BS_MIN_THR_reg                                                 0xB800E20C
+#define set_CODEBLKREG_VE_BS_MIN_THR_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_BS_MIN_THR_reg)=data)
+#define get_CODEBLKREG_VE_BS_MIN_THR_reg   (*((volatile unsigned int*) CODEBLKREG_VE_BS_MIN_THR_reg))
+#define CODEBLKREG_VE_BS_MIN_THR_inst_adr                                            "0x0083"
+#define CODEBLKREG_VE_BS_MIN_THR_inst                                                0x0083
+#define CODEBLKREG_VE_BS_MIN_THR_min_thre_shift                                      (0)
+#define CODEBLKREG_VE_BS_MIN_THR_min_thre_mask                                       (0x0000007F)
+#define CODEBLKREG_VE_BS_MIN_THR_min_thre(data)                                      (0x0000007F&((data)<<0))
+#define CODEBLKREG_VE_BS_MIN_THR_min_thre_src(data)                                  ((0x0000007F&(data))>>0)
+#define CODEBLKREG_VE_BS_MIN_THR_get_min_thre(data)                                  ((0x0000007F&(data))>>0)
+
+
+#define CODEBLKREG_VE_BSTIMER                                                        0x1800E210
+#define CODEBLKREG_VE_BSTIMER_reg_addr                                               "0xB800E210"
+#define CODEBLKREG_VE_BSTIMER_reg                                                    0xB800E210
+#define set_CODEBLKREG_VE_BSTIMER_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_BSTIMER_reg)=data)
+#define get_CODEBLKREG_VE_BSTIMER_reg   (*((volatile unsigned int*) CODEBLKREG_VE_BSTIMER_reg))
+#define CODEBLKREG_VE_BSTIMER_inst_adr                                               "0x0084"
+#define CODEBLKREG_VE_BSTIMER_inst                                                   0x0084
+#define CODEBLKREG_VE_BSTIMER_timer_value_shift                                      (0)
+#define CODEBLKREG_VE_BSTIMER_timer_value_mask                                       (0x00FFFFFF)
+#define CODEBLKREG_VE_BSTIMER_timer_value(data)                                      (0x00FFFFFF&((data)<<0))
+#define CODEBLKREG_VE_BSTIMER_timer_value_src(data)                                  ((0x00FFFFFF&(data))>>0)
+#define CODEBLKREG_VE_BSTIMER_get_timer_value(data)                                  ((0x00FFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_BSBASE                                                         0x1800E214
+#define CODEBLKREG_VE_BSBASE_reg_addr                                                "0xB800E214"
+#define CODEBLKREG_VE_BSBASE_reg                                                     0xB800E214
+#define set_CODEBLKREG_VE_BSBASE_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_BSBASE_reg)=data)
+#define get_CODEBLKREG_VE_BSBASE_reg   (*((volatile unsigned int*) CODEBLKREG_VE_BSBASE_reg))
+#define CODEBLKREG_VE_BSBASE_inst_adr                                                "0x0085"
+#define CODEBLKREG_VE_BSBASE_inst                                                    0x0085
+#define CODEBLKREG_VE_BSBASE_base_addr_shift                                         (0)
+#define CODEBLKREG_VE_BSBASE_base_addr_mask                                          (0x7FFFFFFF)
+#define CODEBLKREG_VE_BSBASE_base_addr(data)                                         (0x7FFFFFFF&((data)<<0))
+#define CODEBLKREG_VE_BSBASE_base_addr_src(data)                                     ((0x7FFFFFFF&(data))>>0)
+#define CODEBLKREG_VE_BSBASE_get_base_addr(data)                                     ((0x7FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_BSLIMIT                                                        0x1800E218
+#define CODEBLKREG_VE_BSLIMIT_reg_addr                                               "0xB800E218"
+#define CODEBLKREG_VE_BSLIMIT_reg                                                    0xB800E218
+#define set_CODEBLKREG_VE_BSLIMIT_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_BSLIMIT_reg)=data)
+#define get_CODEBLKREG_VE_BSLIMIT_reg   (*((volatile unsigned int*) CODEBLKREG_VE_BSLIMIT_reg))
+#define CODEBLKREG_VE_BSLIMIT_inst_adr                                               "0x0086"
+#define CODEBLKREG_VE_BSLIMIT_inst                                                   0x0086
+#define CODEBLKREG_VE_BSLIMIT_limit_addr_shift                                       (0)
+#define CODEBLKREG_VE_BSLIMIT_limit_addr_mask                                        (0x7FFFFFFF)
+#define CODEBLKREG_VE_BSLIMIT_limit_addr(data)                                       (0x7FFFFFFF&((data)<<0))
+#define CODEBLKREG_VE_BSLIMIT_limit_addr_src(data)                                   ((0x7FFFFFFF&(data))>>0)
+#define CODEBLKREG_VE_BSLIMIT_get_limit_addr(data)                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_BSWRPTR                                                        0x1800E21C
+#define CODEBLKREG_VE_BSWRPTR_reg_addr                                               "0xB800E21C"
+#define CODEBLKREG_VE_BSWRPTR_reg                                                    0xB800E21C
+#define set_CODEBLKREG_VE_BSWRPTR_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_BSWRPTR_reg)=data)
+#define get_CODEBLKREG_VE_BSWRPTR_reg   (*((volatile unsigned int*) CODEBLKREG_VE_BSWRPTR_reg))
+#define CODEBLKREG_VE_BSWRPTR_inst_adr                                               "0x0087"
+#define CODEBLKREG_VE_BSWRPTR_inst                                                   0x0087
+#define CODEBLKREG_VE_BSWRPTR_wr_ptr_shift                                           (0)
+#define CODEBLKREG_VE_BSWRPTR_wr_ptr_mask                                            (0x7FFFFFFF)
+#define CODEBLKREG_VE_BSWRPTR_wr_ptr(data)                                           (0x7FFFFFFF&((data)<<0))
+#define CODEBLKREG_VE_BSWRPTR_wr_ptr_src(data)                                       ((0x7FFFFFFF&(data))>>0)
+#define CODEBLKREG_VE_BSWRPTR_get_wr_ptr(data)                                       ((0x7FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_BSCURPTR                                                       0x1800E220
+#define CODEBLKREG_VE_BSCURPTR_reg_addr                                              "0xB800E220"
+#define CODEBLKREG_VE_BSCURPTR_reg                                                   0xB800E220
+#define set_CODEBLKREG_VE_BSCURPTR_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_BSCURPTR_reg)=data)
+#define get_CODEBLKREG_VE_BSCURPTR_reg   (*((volatile unsigned int*) CODEBLKREG_VE_BSCURPTR_reg))
+#define CODEBLKREG_VE_BSCURPTR_inst_adr                                              "0x0088"
+#define CODEBLKREG_VE_BSCURPTR_inst                                                  0x0088
+#define CODEBLKREG_VE_BSCURPTR_cur_ptr_shift                                         (0)
+#define CODEBLKREG_VE_BSCURPTR_cur_ptr_mask                                          (0x7FFFFFFF)
+#define CODEBLKREG_VE_BSCURPTR_cur_ptr(data)                                         (0x7FFFFFFF&((data)<<0))
+#define CODEBLKREG_VE_BSCURPTR_cur_ptr_src(data)                                     ((0x7FFFFFFF&(data))>>0)
+#define CODEBLKREG_VE_BSCURPTR_get_cur_ptr(data)                                     ((0x7FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_DECBSPTR                                                       0x1800E224
+#define CODEBLKREG_VE_DECBSPTR_reg_addr                                              "0xB800E224"
+#define CODEBLKREG_VE_DECBSPTR_reg                                                   0xB800E224
+#define set_CODEBLKREG_VE_DECBSPTR_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_DECBSPTR_reg)=data)
+#define get_CODEBLKREG_VE_DECBSPTR_reg   (*((volatile unsigned int*) CODEBLKREG_VE_DECBSPTR_reg))
+#define CODEBLKREG_VE_DECBSPTR_inst_adr                                              "0x0089"
+#define CODEBLKREG_VE_DECBSPTR_inst                                                  0x0089
+#define CODEBLKREG_VE_DECBSPTR_dec_bit_ptr_shift                                     (0)
+#define CODEBLKREG_VE_DECBSPTR_dec_bit_ptr_mask                                      (0xFFFFFFFF)
+#define CODEBLKREG_VE_DECBSPTR_dec_bit_ptr(data)                                     (0xFFFFFFFF&((data)<<0))
+#define CODEBLKREG_VE_DECBSPTR_dec_bit_ptr_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define CODEBLKREG_VE_DECBSPTR_get_dec_bit_ptr(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_JPG_EMU_0                                                      0x1800E228
+#define CODEBLKREG_VE_JPG_EMU_1                                                      0x1800E22C
+#define CODEBLKREG_VE_JPG_EMU_2                                                      0x1800E230
+#define CODEBLKREG_VE_JPG_EMU_3                                                      0x1800E234
+#define CODEBLKREG_VE_JPG_EMU_4                                                      0x1800E238
+#define CODEBLKREG_VE_JPG_EMU_5                                                      0x1800E23C
+#define CODEBLKREG_VE_JPG_EMU_6                                                      0x1800E240
+#define CODEBLKREG_VE_JPG_EMU_7                                                      0x1800E244
+#define CODEBLKREG_VE_JPG_EMU_0_reg_addr                                             "0xB800E228"
+#define CODEBLKREG_VE_JPG_EMU_1_reg_addr                                             "0xB800E22C"
+#define CODEBLKREG_VE_JPG_EMU_2_reg_addr                                             "0xB800E230"
+#define CODEBLKREG_VE_JPG_EMU_3_reg_addr                                             "0xB800E234"
+#define CODEBLKREG_VE_JPG_EMU_4_reg_addr                                             "0xB800E238"
+#define CODEBLKREG_VE_JPG_EMU_5_reg_addr                                             "0xB800E23C"
+#define CODEBLKREG_VE_JPG_EMU_6_reg_addr                                             "0xB800E240"
+#define CODEBLKREG_VE_JPG_EMU_7_reg_addr                                             "0xB800E244"
+#define CODEBLKREG_VE_JPG_EMU_0_reg                                                  0xB800E228
+#define CODEBLKREG_VE_JPG_EMU_1_reg                                                  0xB800E22C
+#define CODEBLKREG_VE_JPG_EMU_2_reg                                                  0xB800E230
+#define CODEBLKREG_VE_JPG_EMU_3_reg                                                  0xB800E234
+#define CODEBLKREG_VE_JPG_EMU_4_reg                                                  0xB800E238
+#define CODEBLKREG_VE_JPG_EMU_5_reg                                                  0xB800E23C
+#define CODEBLKREG_VE_JPG_EMU_6_reg                                                  0xB800E240
+#define CODEBLKREG_VE_JPG_EMU_7_reg                                                  0xB800E244
+#define set_CODEBLKREG_VE_JPG_EMU_0_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_0_reg)=data)
+#define set_CODEBLKREG_VE_JPG_EMU_1_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_1_reg)=data)
+#define set_CODEBLKREG_VE_JPG_EMU_2_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_2_reg)=data)
+#define set_CODEBLKREG_VE_JPG_EMU_3_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_3_reg)=data)
+#define set_CODEBLKREG_VE_JPG_EMU_4_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_4_reg)=data)
+#define set_CODEBLKREG_VE_JPG_EMU_5_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_5_reg)=data)
+#define set_CODEBLKREG_VE_JPG_EMU_6_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_6_reg)=data)
+#define set_CODEBLKREG_VE_JPG_EMU_7_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_7_reg)=data)
+#define get_CODEBLKREG_VE_JPG_EMU_0_reg   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_0_reg))
+#define get_CODEBLKREG_VE_JPG_EMU_1_reg   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_1_reg))
+#define get_CODEBLKREG_VE_JPG_EMU_2_reg   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_2_reg))
+#define get_CODEBLKREG_VE_JPG_EMU_3_reg   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_3_reg))
+#define get_CODEBLKREG_VE_JPG_EMU_4_reg   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_4_reg))
+#define get_CODEBLKREG_VE_JPG_EMU_5_reg   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_5_reg))
+#define get_CODEBLKREG_VE_JPG_EMU_6_reg   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_6_reg))
+#define get_CODEBLKREG_VE_JPG_EMU_7_reg   (*((volatile unsigned int*) CODEBLKREG_VE_JPG_EMU_7_reg))
+#define CODEBLKREG_VE_JPG_EMU_0_inst_adr                                             "0x008A"
+#define CODEBLKREG_VE_JPG_EMU_1_inst_adr                                             "0x008B"
+#define CODEBLKREG_VE_JPG_EMU_2_inst_adr                                             "0x008C"
+#define CODEBLKREG_VE_JPG_EMU_3_inst_adr                                             "0x008D"
+#define CODEBLKREG_VE_JPG_EMU_4_inst_adr                                             "0x008E"
+#define CODEBLKREG_VE_JPG_EMU_5_inst_adr                                             "0x008F"
+#define CODEBLKREG_VE_JPG_EMU_6_inst_adr                                             "0x0090"
+#define CODEBLKREG_VE_JPG_EMU_7_inst_adr                                             "0x0091"
+#define CODEBLKREG_VE_JPG_EMU_0_inst                                                 0x008A
+#define CODEBLKREG_VE_JPG_EMU_1_inst                                                 0x008B
+#define CODEBLKREG_VE_JPG_EMU_2_inst                                                 0x008C
+#define CODEBLKREG_VE_JPG_EMU_3_inst                                                 0x008D
+#define CODEBLKREG_VE_JPG_EMU_4_inst                                                 0x008E
+#define CODEBLKREG_VE_JPG_EMU_5_inst                                                 0x008F
+#define CODEBLKREG_VE_JPG_EMU_6_inst                                                 0x0090
+#define CODEBLKREG_VE_JPG_EMU_7_inst                                                 0x0091
+#define CODEBLKREG_VE_JPG_EMU_removal_counter_shift                                  (0)
+#define CODEBLKREG_VE_JPG_EMU_removal_counter_mask                                   (0x1FFFFFFF)
+#define CODEBLKREG_VE_JPG_EMU_removal_counter(data)                                  (0x1FFFFFFF&((data)<<0))
+#define CODEBLKREG_VE_JPG_EMU_removal_counter_src(data)                              ((0x1FFFFFFF&(data))>>0)
+#define CODEBLKREG_VE_JPG_EMU_get_removal_counter(data)                              ((0x1FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_DECBSPTR_MSB                                                   0x1800E248
+#define CODEBLKREG_VE_DECBSPTR_MSB_reg_addr                                          "0xB800E248"
+#define CODEBLKREG_VE_DECBSPTR_MSB_reg                                               0xB800E248
+#define set_CODEBLKREG_VE_DECBSPTR_MSB_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_DECBSPTR_MSB_reg)=data)
+#define get_CODEBLKREG_VE_DECBSPTR_MSB_reg   (*((volatile unsigned int*) CODEBLKREG_VE_DECBSPTR_MSB_reg))
+#define CODEBLKREG_VE_DECBSPTR_MSB_inst_adr                                          "0x0092"
+#define CODEBLKREG_VE_DECBSPTR_MSB_inst                                              0x0092
+#define CODEBLKREG_VE_DECBSPTR_MSB_dec_bit_ptr_msb_shift                             (0)
+#define CODEBLKREG_VE_DECBSPTR_MSB_dec_bit_ptr_msb_mask                              (0x00000003)
+#define CODEBLKREG_VE_DECBSPTR_MSB_dec_bit_ptr_msb(data)                             (0x00000003&((data)<<0))
+#define CODEBLKREG_VE_DECBSPTR_MSB_dec_bit_ptr_msb_src(data)                         ((0x00000003&(data))>>0)
+#define CODEBLKREG_VE_DECBSPTR_MSB_get_dec_bit_ptr_msb(data)                         ((0x00000003&(data))>>0)
+
+
+#define CODEBLKREG_VE_TRANSFORM                                                      0x1800E300
+#define CODEBLKREG_VE_TRANSFORM_reg_addr                                             "0xB800E300"
+#define CODEBLKREG_VE_TRANSFORM_reg                                                  0xB800E300
+#define set_CODEBLKREG_VE_TRANSFORM_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_TRANSFORM_reg)=data)
+#define get_CODEBLKREG_VE_TRANSFORM_reg   (*((volatile unsigned int*) CODEBLKREG_VE_TRANSFORM_reg))
+#define CODEBLKREG_VE_TRANSFORM_inst_adr                                             "0x00C0"
+#define CODEBLKREG_VE_TRANSFORM_inst                                                 0x00C0
+#define CODEBLKREG_VE_TRANSFORM_write_enable6_shift                                  (31)
+#define CODEBLKREG_VE_TRANSFORM_write_enable6_mask                                   (0x80000000)
+#define CODEBLKREG_VE_TRANSFORM_write_enable6(data)                                  (0x80000000&((data)<<31))
+#define CODEBLKREG_VE_TRANSFORM_write_enable6_src(data)                              ((0x80000000&(data))>>31)
+#define CODEBLKREG_VE_TRANSFORM_get_write_enable6(data)                              ((0x80000000&(data))>>31)
+#define CODEBLKREG_VE_TRANSFORM_sad_en_shift                                         (30)
+#define CODEBLKREG_VE_TRANSFORM_sad_en_mask                                          (0x40000000)
+#define CODEBLKREG_VE_TRANSFORM_sad_en(data)                                         (0x40000000&((data)<<30))
+#define CODEBLKREG_VE_TRANSFORM_sad_en_src(data)                                     ((0x40000000&(data))>>30)
+#define CODEBLKREG_VE_TRANSFORM_get_sad_en(data)                                     ((0x40000000&(data))>>30)
+#define CODEBLKREG_VE_TRANSFORM_write_enable5_shift                                  (29)
+#define CODEBLKREG_VE_TRANSFORM_write_enable5_mask                                   (0x20000000)
+#define CODEBLKREG_VE_TRANSFORM_write_enable5(data)                                  (0x20000000&((data)<<29))
+#define CODEBLKREG_VE_TRANSFORM_write_enable5_src(data)                              ((0x20000000&(data))>>29)
+#define CODEBLKREG_VE_TRANSFORM_get_write_enable5(data)                              ((0x20000000&(data))>>29)
+#define CODEBLKREG_VE_TRANSFORM_sad_threshold_shift                                  (19)
+#define CODEBLKREG_VE_TRANSFORM_sad_threshold_mask                                   (0x1FF80000)
+#define CODEBLKREG_VE_TRANSFORM_sad_threshold(data)                                  (0x1FF80000&((data)<<19))
+#define CODEBLKREG_VE_TRANSFORM_sad_threshold_src(data)                              ((0x1FF80000&(data))>>19)
+#define CODEBLKREG_VE_TRANSFORM_get_sad_threshold(data)                              ((0x1FF80000&(data))>>19)
+#define CODEBLKREG_VE_TRANSFORM_write_enable4_shift                                  (18)
+#define CODEBLKREG_VE_TRANSFORM_write_enable4_mask                                   (0x00040000)
+#define CODEBLKREG_VE_TRANSFORM_write_enable4(data)                                  (0x00040000&((data)<<18))
+#define CODEBLKREG_VE_TRANSFORM_write_enable4_src(data)                              ((0x00040000&(data))>>18)
+#define CODEBLKREG_VE_TRANSFORM_get_write_enable4(data)                              ((0x00040000&(data))>>18)
+#define CODEBLKREG_VE_TRANSFORM_flat_qtable_shift                                    (17)
+#define CODEBLKREG_VE_TRANSFORM_flat_qtable_mask                                     (0x00020000)
+#define CODEBLKREG_VE_TRANSFORM_flat_qtable(data)                                    (0x00020000&((data)<<17))
+#define CODEBLKREG_VE_TRANSFORM_flat_qtable_src(data)                                ((0x00020000&(data))>>17)
+#define CODEBLKREG_VE_TRANSFORM_get_flat_qtable(data)                                ((0x00020000&(data))>>17)
+#define CODEBLKREG_VE_TRANSFORM_write_enable3_shift                                  (16)
+#define CODEBLKREG_VE_TRANSFORM_write_enable3_mask                                   (0x00010000)
+#define CODEBLKREG_VE_TRANSFORM_write_enable3(data)                                  (0x00010000&((data)<<16))
+#define CODEBLKREG_VE_TRANSFORM_write_enable3_src(data)                              ((0x00010000&(data))>>16)
+#define CODEBLKREG_VE_TRANSFORM_get_write_enable3(data)                              ((0x00010000&(data))>>16)
+#define CODEBLKREG_VE_TRANSFORM_transform_size_8x8_shift                             (15)
+#define CODEBLKREG_VE_TRANSFORM_transform_size_8x8_mask                              (0x00008000)
+#define CODEBLKREG_VE_TRANSFORM_transform_size_8x8(data)                             (0x00008000&((data)<<15))
+#define CODEBLKREG_VE_TRANSFORM_transform_size_8x8_src(data)                         ((0x00008000&(data))>>15)
+#define CODEBLKREG_VE_TRANSFORM_get_transform_size_8x8(data)                         ((0x00008000&(data))>>15)
+#define CODEBLKREG_VE_TRANSFORM_write_enable2_shift                                  (14)
+#define CODEBLKREG_VE_TRANSFORM_write_enable2_mask                                   (0x00004000)
+#define CODEBLKREG_VE_TRANSFORM_write_enable2(data)                                  (0x00004000&((data)<<14))
+#define CODEBLKREG_VE_TRANSFORM_write_enable2_src(data)                              ((0x00004000&(data))>>14)
+#define CODEBLKREG_VE_TRANSFORM_get_write_enable2(data)                              ((0x00004000&(data))>>14)
+#define CODEBLKREG_VE_TRANSFORM_field_transform_shift                                (13)
+#define CODEBLKREG_VE_TRANSFORM_field_transform_mask                                 (0x00002000)
+#define CODEBLKREG_VE_TRANSFORM_field_transform(data)                                (0x00002000&((data)<<13))
+#define CODEBLKREG_VE_TRANSFORM_field_transform_src(data)                            ((0x00002000&(data))>>13)
+#define CODEBLKREG_VE_TRANSFORM_get_field_transform(data)                            ((0x00002000&(data))>>13)
+#define CODEBLKREG_VE_TRANSFORM_write_enable1_shift                                  (12)
+#define CODEBLKREG_VE_TRANSFORM_write_enable1_mask                                   (0x00001000)
+#define CODEBLKREG_VE_TRANSFORM_write_enable1(data)                                  (0x00001000&((data)<<12))
+#define CODEBLKREG_VE_TRANSFORM_write_enable1_src(data)                              ((0x00001000&(data))>>12)
+#define CODEBLKREG_VE_TRANSFORM_get_write_enable1(data)                              ((0x00001000&(data))>>12)
+#define CODEBLKREG_VE_TRANSFORM_mb_ttfrm_shift                                       (0)
+#define CODEBLKREG_VE_TRANSFORM_mb_ttfrm_mask                                        (0x00000FFF)
+#define CODEBLKREG_VE_TRANSFORM_mb_ttfrm(data)                                       (0x00000FFF&((data)<<0))
+#define CODEBLKREG_VE_TRANSFORM_mb_ttfrm_src(data)                                   ((0x00000FFF&(data))>>0)
+#define CODEBLKREG_VE_TRANSFORM_get_mb_ttfrm(data)                                   ((0x00000FFF&(data))>>0)
+
+
+#define CODEBLKREG_VE_QUANTIZER                                                      0x1800E304
+#define CODEBLKREG_VE_QUANTIZER_reg_addr                                             "0xB800E304"
+#define CODEBLKREG_VE_QUANTIZER_reg                                                  0xB800E304
+#define set_CODEBLKREG_VE_QUANTIZER_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_QUANTIZER_reg)=data)
+#define get_CODEBLKREG_VE_QUANTIZER_reg   (*((volatile unsigned int*) CODEBLKREG_VE_QUANTIZER_reg))
+#define CODEBLKREG_VE_QUANTIZER_inst_adr                                             "0x00C1"
+#define CODEBLKREG_VE_QUANTIZER_inst                                                 0x00C1
+#define CODEBLKREG_VE_QUANTIZER_write_enable6_shift                                  (31)
+#define CODEBLKREG_VE_QUANTIZER_write_enable6_mask                                   (0x80000000)
+#define CODEBLKREG_VE_QUANTIZER_write_enable6(data)                                  (0x80000000&((data)<<31))
+#define CODEBLKREG_VE_QUANTIZER_write_enable6_src(data)                              ((0x80000000&(data))>>31)
+#define CODEBLKREG_VE_QUANTIZER_get_write_enable6(data)                              ((0x80000000&(data))>>31)
+#define CODEBLKREG_VE_QUANTIZER_id_pred_shift                                        (29)
+#define CODEBLKREG_VE_QUANTIZER_id_pred_mask                                         (0x60000000)
+#define CODEBLKREG_VE_QUANTIZER_id_pred(data)                                        (0x60000000&((data)<<29))
+#define CODEBLKREG_VE_QUANTIZER_id_pred_src(data)                                    ((0x60000000&(data))>>29)
+#define CODEBLKREG_VE_QUANTIZER_get_id_pred(data)                                    ((0x60000000&(data))>>29)
+#define CODEBLKREG_VE_QUANTIZER_write_enable5_shift                                  (28)
+#define CODEBLKREG_VE_QUANTIZER_write_enable5_mask                                   (0x10000000)
+#define CODEBLKREG_VE_QUANTIZER_write_enable5(data)                                  (0x10000000&((data)<<28))
+#define CODEBLKREG_VE_QUANTIZER_write_enable5_src(data)                              ((0x10000000&(data))>>28)
+#define CODEBLKREG_VE_QUANTIZER_get_write_enable5(data)                              ((0x10000000&(data))>>28)
+#define CODEBLKREG_VE_QUANTIZER_quant_type_shift                                     (27)
+#define CODEBLKREG_VE_QUANTIZER_quant_type_mask                                      (0x08000000)
+#define CODEBLKREG_VE_QUANTIZER_quant_type(data)                                     (0x08000000&((data)<<27))
+#define CODEBLKREG_VE_QUANTIZER_quant_type_src(data)                                 ((0x08000000&(data))>>27)
+#define CODEBLKREG_VE_QUANTIZER_get_quant_type(data)                                 ((0x08000000&(data))>>27)
+#define CODEBLKREG_VE_QUANTIZER_write_enable4_shift                                  (26)
+#define CODEBLKREG_VE_QUANTIZER_write_enable4_mask                                   (0x04000000)
+#define CODEBLKREG_VE_QUANTIZER_write_enable4(data)                                  (0x04000000&((data)<<26))
+#define CODEBLKREG_VE_QUANTIZER_write_enable4_src(data)                              ((0x04000000&(data))>>26)
+#define CODEBLKREG_VE_QUANTIZER_get_write_enable4(data)                              ((0x04000000&(data))>>26)
+#define CODEBLKREG_VE_QUANTIZER_mquant_shift                                         (21)
+#define CODEBLKREG_VE_QUANTIZER_mquant_mask                                          (0x03E00000)
+#define CODEBLKREG_VE_QUANTIZER_mquant(data)                                         (0x03E00000&((data)<<21))
+#define CODEBLKREG_VE_QUANTIZER_mquant_src(data)                                     ((0x03E00000&(data))>>21)
+#define CODEBLKREG_VE_QUANTIZER_get_mquant(data)                                     ((0x03E00000&(data))>>21)
+#define CODEBLKREG_VE_QUANTIZER_write_enable3_shift                                  (20)
+#define CODEBLKREG_VE_QUANTIZER_write_enable3_mask                                   (0x00100000)
+#define CODEBLKREG_VE_QUANTIZER_write_enable3(data)                                  (0x00100000&((data)<<20))
+#define CODEBLKREG_VE_QUANTIZER_write_enable3_src(data)                              ((0x00100000&(data))>>20)
+#define CODEBLKREG_VE_QUANTIZER_get_write_enable3(data)                              ((0x00100000&(data))>>20)
+#define CODEBLKREG_VE_QUANTIZER_qpy_shift                                            (14)
+#define CODEBLKREG_VE_QUANTIZER_qpy_mask                                             (0x000FC000)
+#define CODEBLKREG_VE_QUANTIZER_qpy(data)                                            (0x000FC000&((data)<<14))
+#define CODEBLKREG_VE_QUANTIZER_qpy_src(data)                                        ((0x000FC000&(data))>>14)
+#define CODEBLKREG_VE_QUANTIZER_get_qpy(data)                                        ((0x000FC000&(data))>>14)
+#define CODEBLKREG_VE_QUANTIZER_write_enable2_shift                                  (13)
+#define CODEBLKREG_VE_QUANTIZER_write_enable2_mask                                   (0x00002000)
+#define CODEBLKREG_VE_QUANTIZER_write_enable2(data)                                  (0x00002000&((data)<<13))
+#define CODEBLKREG_VE_QUANTIZER_write_enable2_src(data)                              ((0x00002000&(data))>>13)
+#define CODEBLKREG_VE_QUANTIZER_get_write_enable2(data)                              ((0x00002000&(data))>>13)
+#define CODEBLKREG_VE_QUANTIZER_qpcb_shift                                           (7)
+#define CODEBLKREG_VE_QUANTIZER_qpcb_mask                                            (0x00001F80)
+#define CODEBLKREG_VE_QUANTIZER_qpcb(data)                                           (0x00001F80&((data)<<7))
+#define CODEBLKREG_VE_QUANTIZER_qpcb_src(data)                                       ((0x00001F80&(data))>>7)
+#define CODEBLKREG_VE_QUANTIZER_get_qpcb(data)                                       ((0x00001F80&(data))>>7)
+#define CODEBLKREG_VE_QUANTIZER_write_enable1_shift                                  (6)
+#define CODEBLKREG_VE_QUANTIZER_write_enable1_mask                                   (0x00000040)
+#define CODEBLKREG_VE_QUANTIZER_write_enable1(data)                                  (0x00000040&((data)<<6))
+#define CODEBLKREG_VE_QUANTIZER_write_enable1_src(data)                              ((0x00000040&(data))>>6)
+#define CODEBLKREG_VE_QUANTIZER_get_write_enable1(data)                              ((0x00000040&(data))>>6)
+#define CODEBLKREG_VE_QUANTIZER_qpcr_shift                                           (0)
+#define CODEBLKREG_VE_QUANTIZER_qpcr_mask                                            (0x0000003F)
+#define CODEBLKREG_VE_QUANTIZER_qpcr(data)                                           (0x0000003F&((data)<<0))
+#define CODEBLKREG_VE_QUANTIZER_qpcr_src(data)                                       ((0x0000003F&(data))>>0)
+#define CODEBLKREG_VE_QUANTIZER_get_qpcr(data)                                       ((0x0000003F&(data))>>0)
+
+
+#define CODEBLKREG_VE_QUANTIZER2                                                     0x1800E3EC
+#define CODEBLKREG_VE_QUANTIZER2_reg_addr                                            "0xB800E3EC"
+#define CODEBLKREG_VE_QUANTIZER2_reg                                                 0xB800E3EC
+#define set_CODEBLKREG_VE_QUANTIZER2_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_QUANTIZER2_reg)=data)
+#define get_CODEBLKREG_VE_QUANTIZER2_reg   (*((volatile unsigned int*) CODEBLKREG_VE_QUANTIZER2_reg))
+#define CODEBLKREG_VE_QUANTIZER2_inst_adr                                            "0x00FB"
+#define CODEBLKREG_VE_QUANTIZER2_inst                                                0x00FB
+#define CODEBLKREG_VE_QUANTIZER2_write_enable5_shift                                 (31)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable5_mask                                  (0x80000000)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable5(data)                                 (0x80000000&((data)<<31))
+#define CODEBLKREG_VE_QUANTIZER2_write_enable5_src(data)                             ((0x80000000&(data))>>31)
+#define CODEBLKREG_VE_QUANTIZER2_get_write_enable5(data)                             ((0x80000000&(data))>>31)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y2ac_shift                                   (26)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y2ac_mask                                    (0x7C000000)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y2ac(data)                                   (0x7C000000&((data)<<26))
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y2ac_src(data)                               ((0x7C000000&(data))>>26)
+#define CODEBLKREG_VE_QUANTIZER2_get_qdelta_y2ac(data)                               ((0x7C000000&(data))>>26)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable4_shift                                 (25)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable4_mask                                  (0x02000000)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable4(data)                                 (0x02000000&((data)<<25))
+#define CODEBLKREG_VE_QUANTIZER2_write_enable4_src(data)                             ((0x02000000&(data))>>25)
+#define CODEBLKREG_VE_QUANTIZER2_get_write_enable4(data)                             ((0x02000000&(data))>>25)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_uvdc_shift                                   (20)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_uvdc_mask                                    (0x01F00000)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_uvdc(data)                                   (0x01F00000&((data)<<20))
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_uvdc_src(data)                               ((0x01F00000&(data))>>20)
+#define CODEBLKREG_VE_QUANTIZER2_get_qdelta_uvdc(data)                               ((0x01F00000&(data))>>20)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable3_shift                                 (19)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable3_mask                                  (0x00080000)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable3(data)                                 (0x00080000&((data)<<19))
+#define CODEBLKREG_VE_QUANTIZER2_write_enable3_src(data)                             ((0x00080000&(data))>>19)
+#define CODEBLKREG_VE_QUANTIZER2_get_write_enable3(data)                             ((0x00080000&(data))>>19)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y2dc_shift                                   (14)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y2dc_mask                                    (0x0007C000)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y2dc(data)                                   (0x0007C000&((data)<<14))
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y2dc_src(data)                               ((0x0007C000&(data))>>14)
+#define CODEBLKREG_VE_QUANTIZER2_get_qdelta_y2dc(data)                               ((0x0007C000&(data))>>14)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable2_shift                                 (13)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable2_mask                                  (0x00002000)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable2(data)                                 (0x00002000&((data)<<13))
+#define CODEBLKREG_VE_QUANTIZER2_write_enable2_src(data)                             ((0x00002000&(data))>>13)
+#define CODEBLKREG_VE_QUANTIZER2_get_write_enable2(data)                             ((0x00002000&(data))>>13)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y1dc_shift                                   (8)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y1dc_mask                                    (0x00001F00)
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y1dc(data)                                   (0x00001F00&((data)<<8))
+#define CODEBLKREG_VE_QUANTIZER2_qdelta_y1dc_src(data)                               ((0x00001F00&(data))>>8)
+#define CODEBLKREG_VE_QUANTIZER2_get_qdelta_y1dc(data)                               ((0x00001F00&(data))>>8)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable1_shift                                 (7)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable1_mask                                  (0x00000080)
+#define CODEBLKREG_VE_QUANTIZER2_write_enable1(data)                                 (0x00000080&((data)<<7))
+#define CODEBLKREG_VE_QUANTIZER2_write_enable1_src(data)                             ((0x00000080&(data))>>7)
+#define CODEBLKREG_VE_QUANTIZER2_get_write_enable1(data)                             ((0x00000080&(data))>>7)
+#define CODEBLKREG_VE_QUANTIZER2_vp8_qp_shift                                        (0)
+#define CODEBLKREG_VE_QUANTIZER2_vp8_qp_mask                                         (0x0000007F)
+#define CODEBLKREG_VE_QUANTIZER2_vp8_qp(data)                                        (0x0000007F&((data)<<0))
+#define CODEBLKREG_VE_QUANTIZER2_vp8_qp_src(data)                                    ((0x0000007F&(data))>>0)
+#define CODEBLKREG_VE_QUANTIZER2_get_vp8_qp(data)                                    ((0x0000007F&(data))>>0)
+
+
+#define CODEBLKREG_VE_ITDMA                                                          0x1800E3BC
+#define CODEBLKREG_VE_ITDMA_reg_addr                                                 "0xB800E3BC"
+#define CODEBLKREG_VE_ITDMA_reg                                                      0xB800E3BC
+#define set_CODEBLKREG_VE_ITDMA_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_ITDMA_reg)=data)
+#define get_CODEBLKREG_VE_ITDMA_reg   (*((volatile unsigned int*) CODEBLKREG_VE_ITDMA_reg))
+#define CODEBLKREG_VE_ITDMA_inst_adr                                                 "0x00EF"
+#define CODEBLKREG_VE_ITDMA_inst                                                     0x00EF
+#define CODEBLKREG_VE_ITDMA_blk_pic_idx_shift                                        (0)
+#define CODEBLKREG_VE_ITDMA_blk_pic_idx_mask                                         (0x0000007F)
+#define CODEBLKREG_VE_ITDMA_blk_pic_idx(data)                                        (0x0000007F&((data)<<0))
+#define CODEBLKREG_VE_ITDMA_blk_pic_idx_src(data)                                    ((0x0000007F&(data))>>0)
+#define CODEBLKREG_VE_ITDMA_get_blk_pic_idx(data)                                    ((0x0000007F&(data))>>0)
+
+
+#define CODEBLKREG_VE_CBP                                                            0x1800E308
+#define CODEBLKREG_VE_CBP_reg_addr                                                   "0xB800E308"
+#define CODEBLKREG_VE_CBP_reg                                                        0xB800E308
+#define set_CODEBLKREG_VE_CBP_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_CBP_reg)=data)
+#define get_CODEBLKREG_VE_CBP_reg   (*((volatile unsigned int*) CODEBLKREG_VE_CBP_reg))
+#define CODEBLKREG_VE_CBP_inst_adr                                                   "0x00C2"
+#define CODEBLKREG_VE_CBP_inst                                                       0x00C2
+#define CODEBLKREG_VE_CBP_write_enable2_shift                                        (31)
+#define CODEBLKREG_VE_CBP_write_enable2_mask                                         (0x80000000)
+#define CODEBLKREG_VE_CBP_write_enable2(data)                                        (0x80000000&((data)<<31))
+#define CODEBLKREG_VE_CBP_write_enable2_src(data)                                    ((0x80000000&(data))>>31)
+#define CODEBLKREG_VE_CBP_get_write_enable2(data)                                    ((0x80000000&(data))>>31)
+#define CODEBLKREG_VE_CBP_cbp6bits_shift                                             (25)
+#define CODEBLKREG_VE_CBP_cbp6bits_mask                                              (0x7E000000)
+#define CODEBLKREG_VE_CBP_cbp6bits(data)                                             (0x7E000000&((data)<<25))
+#define CODEBLKREG_VE_CBP_cbp6bits_src(data)                                         ((0x7E000000&(data))>>25)
+#define CODEBLKREG_VE_CBP_get_cbp6bits(data)                                         ((0x7E000000&(data))>>25)
+#define CODEBLKREG_VE_CBP_write_enable1_shift                                        (24)
+#define CODEBLKREG_VE_CBP_write_enable1_mask                                         (0x01000000)
+#define CODEBLKREG_VE_CBP_write_enable1(data)                                        (0x01000000&((data)<<24))
+#define CODEBLKREG_VE_CBP_write_enable1_src(data)                                    ((0x01000000&(data))>>24)
+#define CODEBLKREG_VE_CBP_get_write_enable1(data)                                    ((0x01000000&(data))>>24)
+#define CODEBLKREG_VE_CBP_subblkpat_shift                                            (0)
+#define CODEBLKREG_VE_CBP_subblkpat_mask                                             (0x00FFFFFF)
+#define CODEBLKREG_VE_CBP_subblkpat(data)                                            (0x00FFFFFF&((data)<<0))
+#define CODEBLKREG_VE_CBP_subblkpat_src(data)                                        ((0x00FFFFFF&(data))>>0)
+#define CODEBLKREG_VE_CBP_get_subblkpat(data)                                        ((0x00FFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VP6_LUMA                                                          0x1800E3C4
+#define CODEBLKREG_VP6_LUMA_reg_addr                                                 "0xB800E3C4"
+#define CODEBLKREG_VP6_LUMA_reg                                                      0xB800E3C4
+#define set_CODEBLKREG_VP6_LUMA_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VP6_LUMA_reg)=data)
+#define get_CODEBLKREG_VP6_LUMA_reg   (*((volatile unsigned int*) CODEBLKREG_VP6_LUMA_reg))
+#define CODEBLKREG_VP6_LUMA_inst_adr                                                 "0x00F1"
+#define CODEBLKREG_VP6_LUMA_inst                                                     0x00F1
+#define CODEBLKREG_VP6_LUMA_write_enable2_shift                                      (31)
+#define CODEBLKREG_VP6_LUMA_write_enable2_mask                                       (0x80000000)
+#define CODEBLKREG_VP6_LUMA_write_enable2(data)                                      (0x80000000&((data)<<31))
+#define CODEBLKREG_VP6_LUMA_write_enable2_src(data)                                  ((0x80000000&(data))>>31)
+#define CODEBLKREG_VP6_LUMA_get_write_enable2(data)                                  ((0x80000000&(data))>>31)
+#define CODEBLKREG_VP6_LUMA_lu_zero_ac_blk_num_shift                                 (16)
+#define CODEBLKREG_VP6_LUMA_lu_zero_ac_blk_num_mask                                  (0x7FFF0000)
+#define CODEBLKREG_VP6_LUMA_lu_zero_ac_blk_num(data)                                 (0x7FFF0000&((data)<<16))
+#define CODEBLKREG_VP6_LUMA_lu_zero_ac_blk_num_src(data)                             ((0x7FFF0000&(data))>>16)
+#define CODEBLKREG_VP6_LUMA_get_lu_zero_ac_blk_num(data)                             ((0x7FFF0000&(data))>>16)
+#define CODEBLKREG_VP6_LUMA_write_enable1_shift                                      (15)
+#define CODEBLKREG_VP6_LUMA_write_enable1_mask                                       (0x00008000)
+#define CODEBLKREG_VP6_LUMA_write_enable1(data)                                      (0x00008000&((data)<<15))
+#define CODEBLKREG_VP6_LUMA_write_enable1_src(data)                                  ((0x00008000&(data))>>15)
+#define CODEBLKREG_VP6_LUMA_get_write_enable1(data)                                  ((0x00008000&(data))>>15)
+#define CODEBLKREG_VP6_LUMA_lu_zero_dc_blk_num_shift                                 (0)
+#define CODEBLKREG_VP6_LUMA_lu_zero_dc_blk_num_mask                                  (0x00007FFF)
+#define CODEBLKREG_VP6_LUMA_lu_zero_dc_blk_num(data)                                 (0x00007FFF&((data)<<0))
+#define CODEBLKREG_VP6_LUMA_lu_zero_dc_blk_num_src(data)                             ((0x00007FFF&(data))>>0)
+#define CODEBLKREG_VP6_LUMA_get_lu_zero_dc_blk_num(data)                             ((0x00007FFF&(data))>>0)
+
+
+#define CODEBLKREG_VP6_CHROMA                                                        0x1800E3C8
+#define CODEBLKREG_VP6_CHROMA_reg_addr                                               "0xB800E3C8"
+#define CODEBLKREG_VP6_CHROMA_reg                                                    0xB800E3C8
+#define set_CODEBLKREG_VP6_CHROMA_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VP6_CHROMA_reg)=data)
+#define get_CODEBLKREG_VP6_CHROMA_reg   (*((volatile unsigned int*) CODEBLKREG_VP6_CHROMA_reg))
+#define CODEBLKREG_VP6_CHROMA_inst_adr                                               "0x00F2"
+#define CODEBLKREG_VP6_CHROMA_inst                                                   0x00F2
+#define CODEBLKREG_VP6_CHROMA_write_enable2_shift                                    (29)
+#define CODEBLKREG_VP6_CHROMA_write_enable2_mask                                     (0x20000000)
+#define CODEBLKREG_VP6_CHROMA_write_enable2(data)                                    (0x20000000&((data)<<29))
+#define CODEBLKREG_VP6_CHROMA_write_enable2_src(data)                                ((0x20000000&(data))>>29)
+#define CODEBLKREG_VP6_CHROMA_get_write_enable2(data)                                ((0x20000000&(data))>>29)
+#define CODEBLKREG_VP6_CHROMA_ch_zero_ac_blk_num_shift                               (15)
+#define CODEBLKREG_VP6_CHROMA_ch_zero_ac_blk_num_mask                                (0x1FFF8000)
+#define CODEBLKREG_VP6_CHROMA_ch_zero_ac_blk_num(data)                               (0x1FFF8000&((data)<<15))
+#define CODEBLKREG_VP6_CHROMA_ch_zero_ac_blk_num_src(data)                           ((0x1FFF8000&(data))>>15)
+#define CODEBLKREG_VP6_CHROMA_get_ch_zero_ac_blk_num(data)                           ((0x1FFF8000&(data))>>15)
+#define CODEBLKREG_VP6_CHROMA_write_enable1_shift                                    (14)
+#define CODEBLKREG_VP6_CHROMA_write_enable1_mask                                     (0x00004000)
+#define CODEBLKREG_VP6_CHROMA_write_enable1(data)                                    (0x00004000&((data)<<14))
+#define CODEBLKREG_VP6_CHROMA_write_enable1_src(data)                                ((0x00004000&(data))>>14)
+#define CODEBLKREG_VP6_CHROMA_get_write_enable1(data)                                ((0x00004000&(data))>>14)
+#define CODEBLKREG_VP6_CHROMA_ch_zero_dc_blk_num_shift                               (0)
+#define CODEBLKREG_VP6_CHROMA_ch_zero_dc_blk_num_mask                                (0x00003FFF)
+#define CODEBLKREG_VP6_CHROMA_ch_zero_dc_blk_num(data)                               (0x00003FFF&((data)<<0))
+#define CODEBLKREG_VP6_CHROMA_ch_zero_dc_blk_num_src(data)                           ((0x00003FFF&(data))>>0)
+#define CODEBLKREG_VP6_CHROMA_get_ch_zero_dc_blk_num(data)                           ((0x00003FFF&(data))>>0)
+
+
+#define CODEBLKREG_MB_PARTITION                                                      0x1800E30C
+#define CODEBLKREG_MB_PARTITION_reg_addr                                             "0xB800E30C"
+#define CODEBLKREG_MB_PARTITION_reg                                                  0xB800E30C
+#define set_CODEBLKREG_MB_PARTITION_reg(data)   (*((volatile unsigned int*) CODEBLKREG_MB_PARTITION_reg)=data)
+#define get_CODEBLKREG_MB_PARTITION_reg   (*((volatile unsigned int*) CODEBLKREG_MB_PARTITION_reg))
+#define CODEBLKREG_MB_PARTITION_inst_adr                                             "0x00C3"
+#define CODEBLKREG_MB_PARTITION_inst                                                 0x00C3
+#define CODEBLKREG_MB_PARTITION_mbpartition_shift                                    (0)
+#define CODEBLKREG_MB_PARTITION_mbpartition_mask                                     (0x000001FF)
+#define CODEBLKREG_MB_PARTITION_mbpartition(data)                                    (0x000001FF&((data)<<0))
+#define CODEBLKREG_MB_PARTITION_mbpartition_src(data)                                ((0x000001FF&(data))>>0)
+#define CODEBLKREG_MB_PARTITION_get_mbpartition(data)                                ((0x000001FF&(data))>>0)
+
+
+#define CODEBLKREG_MB_PREDMODE                                                       0x1800E310
+#define CODEBLKREG_MB_PREDMODE_reg_addr                                              "0xB800E310"
+#define CODEBLKREG_MB_PREDMODE_reg                                                   0xB800E310
+#define set_CODEBLKREG_MB_PREDMODE_reg(data)   (*((volatile unsigned int*) CODEBLKREG_MB_PREDMODE_reg)=data)
+#define get_CODEBLKREG_MB_PREDMODE_reg   (*((volatile unsigned int*) CODEBLKREG_MB_PREDMODE_reg))
+#define CODEBLKREG_MB_PREDMODE_inst_adr                                              "0x00C4"
+#define CODEBLKREG_MB_PREDMODE_inst                                                  0x00C4
+#define CODEBLKREG_MB_PREDMODE_mb_pred_mode_shift                                    (0)
+#define CODEBLKREG_MB_PREDMODE_mb_pred_mode_mask                                     (0x000000FF)
+#define CODEBLKREG_MB_PREDMODE_mb_pred_mode(data)                                    (0x000000FF&((data)<<0))
+#define CODEBLKREG_MB_PREDMODE_mb_pred_mode_src(data)                                ((0x000000FF&(data))>>0)
+#define CODEBLKREG_MB_PREDMODE_get_mb_pred_mode(data)                                ((0x000000FF&(data))>>0)
+
+
+#define CODEBLKREG_MB_INFO                                                           0x1800E314
+#define CODEBLKREG_MB_INFO_reg_addr                                                  "0xB800E314"
+#define CODEBLKREG_MB_INFO_reg                                                       0xB800E314
+#define set_CODEBLKREG_MB_INFO_reg(data)   (*((volatile unsigned int*) CODEBLKREG_MB_INFO_reg)=data)
+#define get_CODEBLKREG_MB_INFO_reg   (*((volatile unsigned int*) CODEBLKREG_MB_INFO_reg))
+#define CODEBLKREG_MB_INFO_inst_adr                                                  "0x00C5"
+#define CODEBLKREG_MB_INFO_inst                                                      0x00C5
+#define CODEBLKREG_MB_INFO_write_enable8_shift                                       (29)
+#define CODEBLKREG_MB_INFO_write_enable8_mask                                        (0x20000000)
+#define CODEBLKREG_MB_INFO_write_enable8(data)                                       (0x20000000&((data)<<29))
+#define CODEBLKREG_MB_INFO_write_enable8_src(data)                                   ((0x20000000&(data))>>29)
+#define CODEBLKREG_MB_INFO_get_write_enable8(data)                                   ((0x20000000&(data))>>29)
+#define CODEBLKREG_MB_INFO_vp6_ref_frame_shift                                       (27)
+#define CODEBLKREG_MB_INFO_vp6_ref_frame_mask                                        (0x18000000)
+#define CODEBLKREG_MB_INFO_vp6_ref_frame(data)                                       (0x18000000&((data)<<27))
+#define CODEBLKREG_MB_INFO_vp6_ref_frame_src(data)                                   ((0x18000000&(data))>>27)
+#define CODEBLKREG_MB_INFO_get_vp6_ref_frame(data)                                   ((0x18000000&(data))>>27)
+#define CODEBLKREG_MB_INFO_write_enable7_shift                                       (26)
+#define CODEBLKREG_MB_INFO_write_enable7_mask                                        (0x04000000)
+#define CODEBLKREG_MB_INFO_write_enable7(data)                                       (0x04000000&((data)<<26))
+#define CODEBLKREG_MB_INFO_write_enable7_src(data)                                   ((0x04000000&(data))>>26)
+#define CODEBLKREG_MB_INFO_get_write_enable7(data)                                   ((0x04000000&(data))>>26)
+#define CODEBLKREG_MB_INFO_mb_pattern_shift                                          (25)
+#define CODEBLKREG_MB_INFO_mb_pattern_mask                                           (0x02000000)
+#define CODEBLKREG_MB_INFO_mb_pattern(data)                                          (0x02000000&((data)<<25))
+#define CODEBLKREG_MB_INFO_mb_pattern_src(data)                                      ((0x02000000&(data))>>25)
+#define CODEBLKREG_MB_INFO_get_mb_pattern(data)                                      ((0x02000000&(data))>>25)
+#define CODEBLKREG_MB_INFO_write_enable6_shift                                       (24)
+#define CODEBLKREG_MB_INFO_write_enable6_mask                                        (0x01000000)
+#define CODEBLKREG_MB_INFO_write_enable6(data)                                       (0x01000000&((data)<<24))
+#define CODEBLKREG_MB_INFO_write_enable6_src(data)                                   ((0x01000000&(data))>>24)
+#define CODEBLKREG_MB_INFO_get_write_enable6(data)                                   ((0x01000000&(data))>>24)
+#define CODEBLKREG_MB_INFO_intrablks_flg_shift                                       (19)
+#define CODEBLKREG_MB_INFO_intrablks_flg_mask                                        (0x00F80000)
+#define CODEBLKREG_MB_INFO_intrablks_flg(data)                                       (0x00F80000&((data)<<19))
+#define CODEBLKREG_MB_INFO_intrablks_flg_src(data)                                   ((0x00F80000&(data))>>19)
+#define CODEBLKREG_MB_INFO_get_intrablks_flg(data)                                   ((0x00F80000&(data))>>19)
+#define CODEBLKREG_MB_INFO_write_enable5_shift                                       (18)
+#define CODEBLKREG_MB_INFO_write_enable5_mask                                        (0x00040000)
+#define CODEBLKREG_MB_INFO_write_enable5(data)                                       (0x00040000&((data)<<18))
+#define CODEBLKREG_MB_INFO_write_enable5_src(data)                                   ((0x00040000&(data))>>18)
+#define CODEBLKREG_MB_INFO_get_write_enable5(data)                                   ((0x00040000&(data))>>18)
+#define CODEBLKREG_MB_INFO_ac_pred_shift                                             (17)
+#define CODEBLKREG_MB_INFO_ac_pred_mask                                              (0x00020000)
+#define CODEBLKREG_MB_INFO_ac_pred(data)                                             (0x00020000&((data)<<17))
+#define CODEBLKREG_MB_INFO_ac_pred_src(data)                                         ((0x00020000&(data))>>17)
+#define CODEBLKREG_MB_INFO_get_ac_pred(data)                                         ((0x00020000&(data))>>17)
+#define CODEBLKREG_MB_INFO_write_enable4_shift                                       (16)
+#define CODEBLKREG_MB_INFO_write_enable4_mask                                        (0x00010000)
+#define CODEBLKREG_MB_INFO_write_enable4(data)                                       (0x00010000&((data)<<16))
+#define CODEBLKREG_MB_INFO_write_enable4_src(data)                                   ((0x00010000&(data))>>16)
+#define CODEBLKREG_MB_INFO_get_write_enable4(data)                                   ((0x00010000&(data))>>16)
+#define CODEBLKREG_MB_INFO_dc_pred_dir_shift                                         (10)
+#define CODEBLKREG_MB_INFO_dc_pred_dir_mask                                          (0x0000FC00)
+#define CODEBLKREG_MB_INFO_dc_pred_dir(data)                                         (0x0000FC00&((data)<<10))
+#define CODEBLKREG_MB_INFO_dc_pred_dir_src(data)                                     ((0x0000FC00&(data))>>10)
+#define CODEBLKREG_MB_INFO_get_dc_pred_dir(data)                                     ((0x0000FC00&(data))>>10)
+#define CODEBLKREG_MB_INFO_write_enable3_shift                                       (9)
+#define CODEBLKREG_MB_INFO_write_enable3_mask                                        (0x00000200)
+#define CODEBLKREG_MB_INFO_write_enable3(data)                                       (0x00000200&((data)<<9))
+#define CODEBLKREG_MB_INFO_write_enable3_src(data)                                   ((0x00000200&(data))>>9)
+#define CODEBLKREG_MB_INFO_get_write_enable3(data)                                   ((0x00000200&(data))>>9)
+#define CODEBLKREG_MB_INFO_mbtype_shift                                              (5)
+#define CODEBLKREG_MB_INFO_mbtype_mask                                               (0x000001E0)
+#define CODEBLKREG_MB_INFO_mbtype(data)                                              (0x000001E0&((data)<<5))
+#define CODEBLKREG_MB_INFO_mbtype_src(data)                                          ((0x000001E0&(data))>>5)
+#define CODEBLKREG_MB_INFO_get_mbtype(data)                                          ((0x000001E0&(data))>>5)
+#define CODEBLKREG_MB_INFO_write_enable2_shift                                       (4)
+#define CODEBLKREG_MB_INFO_write_enable2_mask                                        (0x00000010)
+#define CODEBLKREG_MB_INFO_write_enable2(data)                                       (0x00000010&((data)<<4))
+#define CODEBLKREG_MB_INFO_write_enable2_src(data)                                   ((0x00000010&(data))>>4)
+#define CODEBLKREG_MB_INFO_get_write_enable2(data)                                   ((0x00000010&(data))>>4)
+#define CODEBLKREG_MB_INFO_intra_c_pred_mode_shift                                   (2)
+#define CODEBLKREG_MB_INFO_intra_c_pred_mode_mask                                    (0x0000000C)
+#define CODEBLKREG_MB_INFO_intra_c_pred_mode(data)                                   (0x0000000C&((data)<<2))
+#define CODEBLKREG_MB_INFO_intra_c_pred_mode_src(data)                               ((0x0000000C&(data))>>2)
+#define CODEBLKREG_MB_INFO_get_intra_c_pred_mode(data)                               ((0x0000000C&(data))>>2)
+#define CODEBLKREG_MB_INFO_write_enable1_shift                                       (1)
+#define CODEBLKREG_MB_INFO_write_enable1_mask                                        (0x00000002)
+#define CODEBLKREG_MB_INFO_write_enable1(data)                                       (0x00000002&((data)<<1))
+#define CODEBLKREG_MB_INFO_write_enable1_src(data)                                   ((0x00000002&(data))>>1)
+#define CODEBLKREG_MB_INFO_get_write_enable1(data)                                   ((0x00000002&(data))>>1)
+#define CODEBLKREG_MB_INFO_field_mb_shift                                            (0)
+#define CODEBLKREG_MB_INFO_field_mb_mask                                             (0x00000001)
+#define CODEBLKREG_MB_INFO_field_mb(data)                                            (0x00000001&((data)<<0))
+#define CODEBLKREG_MB_INFO_field_mb_src(data)                                        ((0x00000001&(data))>>0)
+#define CODEBLKREG_MB_INFO_get_field_mb(data)                                        ((0x00000001&(data))>>0)
+
+
+#define CODEBLKREG_MB_INFO2                                                          0x1800E318
+#define CODEBLKREG_MB_INFO2_reg_addr                                                 "0xB800E318"
+#define CODEBLKREG_MB_INFO2_reg                                                      0xB800E318
+#define set_CODEBLKREG_MB_INFO2_reg(data)   (*((volatile unsigned int*) CODEBLKREG_MB_INFO2_reg)=data)
+#define get_CODEBLKREG_MB_INFO2_reg   (*((volatile unsigned int*) CODEBLKREG_MB_INFO2_reg))
+#define CODEBLKREG_MB_INFO2_inst_adr                                                 "0x00C6"
+#define CODEBLKREG_MB_INFO2_inst                                                     0x00C6
+#define CODEBLKREG_MB_INFO2_h263_flv_lg1_shift                                       (5)
+#define CODEBLKREG_MB_INFO2_h263_flv_lg1_mask                                        (0x00000020)
+#define CODEBLKREG_MB_INFO2_h263_flv_lg1(data)                                       (0x00000020&((data)<<5))
+#define CODEBLKREG_MB_INFO2_h263_flv_lg1_src(data)                                   ((0x00000020&(data))>>5)
+#define CODEBLKREG_MB_INFO2_get_h263_flv_lg1(data)                                   ((0x00000020&(data))>>5)
+#define CODEBLKREG_MB_INFO2_ivf_shift                                                (4)
+#define CODEBLKREG_MB_INFO2_ivf_mask                                                 (0x00000010)
+#define CODEBLKREG_MB_INFO2_ivf(data)                                                (0x00000010&((data)<<4))
+#define CODEBLKREG_MB_INFO2_ivf_src(data)                                            ((0x00000010&(data))>>4)
+#define CODEBLKREG_MB_INFO2_get_ivf(data)                                            ((0x00000010&(data))>>4)
+#define CODEBLKREG_MB_INFO2_as_shift                                                 (3)
+#define CODEBLKREG_MB_INFO2_as_mask                                                  (0x00000008)
+#define CODEBLKREG_MB_INFO2_as(data)                                                 (0x00000008&((data)<<3))
+#define CODEBLKREG_MB_INFO2_as_src(data)                                             ((0x00000008&(data))>>3)
+#define CODEBLKREG_MB_INFO2_get_as(data)                                             ((0x00000008&(data))>>3)
+#define CODEBLKREG_MB_INFO2_intra_dc_vlc_shift                                       (2)
+#define CODEBLKREG_MB_INFO2_intra_dc_vlc_mask                                        (0x00000004)
+#define CODEBLKREG_MB_INFO2_intra_dc_vlc(data)                                       (0x00000004&((data)<<2))
+#define CODEBLKREG_MB_INFO2_intra_dc_vlc_src(data)                                   ((0x00000004&(data))>>2)
+#define CODEBLKREG_MB_INFO2_get_intra_dc_vlc(data)                                   ((0x00000004&(data))>>2)
+#define CODEBLKREG_MB_INFO2_short_hdr_shift                                          (1)
+#define CODEBLKREG_MB_INFO2_short_hdr_mask                                           (0x00000002)
+#define CODEBLKREG_MB_INFO2_short_hdr(data)                                          (0x00000002&((data)<<1))
+#define CODEBLKREG_MB_INFO2_short_hdr_src(data)                                      ((0x00000002&(data))>>1)
+#define CODEBLKREG_MB_INFO2_get_short_hdr(data)                                      ((0x00000002&(data))>>1)
+#define CODEBLKREG_MB_INFO2_write_data_shift                                         (0)
+#define CODEBLKREG_MB_INFO2_write_data_mask                                          (0x00000001)
+#define CODEBLKREG_MB_INFO2_write_data(data)                                         (0x00000001&((data)<<0))
+#define CODEBLKREG_MB_INFO2_write_data_src(data)                                     ((0x00000001&(data))>>0)
+#define CODEBLKREG_MB_INFO2_get_write_data(data)                                     ((0x00000001&(data))>>0)
+
+
+#define CODEBLKREG_RV_CNTL                                                           0x1800E320
+#define CODEBLKREG_RV_CNTL_reg_addr                                                  "0xB800E320"
+#define CODEBLKREG_RV_CNTL_reg                                                       0xB800E320
+#define set_CODEBLKREG_RV_CNTL_reg(data)   (*((volatile unsigned int*) CODEBLKREG_RV_CNTL_reg)=data)
+#define get_CODEBLKREG_RV_CNTL_reg   (*((volatile unsigned int*) CODEBLKREG_RV_CNTL_reg))
+#define CODEBLKREG_RV_CNTL_inst_adr                                                  "0x00C8"
+#define CODEBLKREG_RV_CNTL_inst                                                      0x00C8
+#define CODEBLKREG_RV_CNTL_write_enable3_shift                                       (31)
+#define CODEBLKREG_RV_CNTL_write_enable3_mask                                        (0x80000000)
+#define CODEBLKREG_RV_CNTL_write_enable3(data)                                       (0x80000000&((data)<<31))
+#define CODEBLKREG_RV_CNTL_write_enable3_src(data)                                   ((0x80000000&(data))>>31)
+#define CODEBLKREG_RV_CNTL_get_write_enable3(data)                                   ((0x80000000&(data))>>31)
+#define CODEBLKREG_RV_CNTL_write_enable2_shift                                       (4)
+#define CODEBLKREG_RV_CNTL_write_enable2_mask                                        (0x00000010)
+#define CODEBLKREG_RV_CNTL_write_enable2(data)                                       (0x00000010&((data)<<4))
+#define CODEBLKREG_RV_CNTL_write_enable2_src(data)                                   ((0x00000010&(data))>>4)
+#define CODEBLKREG_RV_CNTL_get_write_enable2(data)                                   ((0x00000010&(data))>>4)
+#define CODEBLKREG_RV_CNTL_rv9_intramode_use_top_shift                               (3)
+#define CODEBLKREG_RV_CNTL_rv9_intramode_use_top_mask                                (0x00000008)
+#define CODEBLKREG_RV_CNTL_rv9_intramode_use_top(data)                               (0x00000008&((data)<<3))
+#define CODEBLKREG_RV_CNTL_rv9_intramode_use_top_src(data)                           ((0x00000008&(data))>>3)
+#define CODEBLKREG_RV_CNTL_get_rv9_intramode_use_top(data)                           ((0x00000008&(data))>>3)
+#define CODEBLKREG_RV_CNTL_write_enable1_shift                                       (2)
+#define CODEBLKREG_RV_CNTL_write_enable1_mask                                        (0x00000004)
+#define CODEBLKREG_RV_CNTL_write_enable1(data)                                       (0x00000004&((data)<<2))
+#define CODEBLKREG_RV_CNTL_write_enable1_src(data)                                   ((0x00000004&(data))>>2)
+#define CODEBLKREG_RV_CNTL_get_write_enable1(data)                                   ((0x00000004&(data))>>2)
+#define CODEBLKREG_RV_CNTL_rv_osvquant_shift                                         (0)
+#define CODEBLKREG_RV_CNTL_rv_osvquant_mask                                          (0x00000003)
+#define CODEBLKREG_RV_CNTL_rv_osvquant(data)                                         (0x00000003&((data)<<0))
+#define CODEBLKREG_RV_CNTL_rv_osvquant_src(data)                                     ((0x00000003&(data))>>0)
+#define CODEBLKREG_RV_CNTL_get_rv_osvquant(data)                                     ((0x00000003&(data))>>0)
+
+
+#define CODEBLKREG_RV_STRUVLC                                                        0x1800E324
+#define CODEBLKREG_RV_STRUVLC_reg_addr                                               "0xB800E324"
+#define CODEBLKREG_RV_STRUVLC_reg                                                    0xB800E324
+#define set_CODEBLKREG_RV_STRUVLC_reg(data)   (*((volatile unsigned int*) CODEBLKREG_RV_STRUVLC_reg)=data)
+#define get_CODEBLKREG_RV_STRUVLC_reg   (*((volatile unsigned int*) CODEBLKREG_RV_STRUVLC_reg))
+#define CODEBLKREG_RV_STRUVLC_inst_adr                                               "0x00C9"
+#define CODEBLKREG_RV_STRUVLC_inst                                                   0x00C9
+#define CODEBLKREG_RV_STRUVLC_struvlc_len_shift                                      (0)
+#define CODEBLKREG_RV_STRUVLC_struvlc_len_mask                                       (0x7FFFFFFF)
+#define CODEBLKREG_RV_STRUVLC_struvlc_len(data)                                      (0x7FFFFFFF&((data)<<0))
+#define CODEBLKREG_RV_STRUVLC_struvlc_len_src(data)                                  ((0x7FFFFFFF&(data))>>0)
+#define CODEBLKREG_RV_STRUVLC_get_struvlc_len(data)                                  ((0x7FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_RV_INTRAMODE                                                      0x1800E328
+#define CODEBLKREG_RV_INTRAMODE_reg_addr                                             "0xB800E328"
+#define CODEBLKREG_RV_INTRAMODE_reg                                                  0xB800E328
+#define set_CODEBLKREG_RV_INTRAMODE_reg(data)   (*((volatile unsigned int*) CODEBLKREG_RV_INTRAMODE_reg)=data)
+#define get_CODEBLKREG_RV_INTRAMODE_reg   (*((volatile unsigned int*) CODEBLKREG_RV_INTRAMODE_reg))
+#define CODEBLKREG_RV_INTRAMODE_inst_adr                                             "0x00CA"
+#define CODEBLKREG_RV_INTRAMODE_inst                                                 0x00CA
+#define CODEBLKREG_RV_INTRAMODE_left_blocks_shift                                    (0)
+#define CODEBLKREG_RV_INTRAMODE_left_blocks_mask                                     (0x0000FFFF)
+#define CODEBLKREG_RV_INTRAMODE_left_blocks(data)                                    (0x0000FFFF&((data)<<0))
+#define CODEBLKREG_RV_INTRAMODE_left_blocks_src(data)                                ((0x0000FFFF&(data))>>0)
+#define CODEBLKREG_RV_INTRAMODE_get_left_blocks(data)                                ((0x0000FFFF&(data))>>0)
+
+
+#define CODEBLKREG_VLDTBLPTR_0                                                       0x1800E330
+#define CODEBLKREG_VLDTBLPTR_1                                                       0x1800E334
+#define CODEBLKREG_VLDTBLPTR_0_reg_addr                                              "0xB800E330"
+#define CODEBLKREG_VLDTBLPTR_1_reg_addr                                              "0xB800E334"
+#define CODEBLKREG_VLDTBLPTR_0_reg                                                   0xB800E330
+#define CODEBLKREG_VLDTBLPTR_1_reg                                                   0xB800E334
+#define set_CODEBLKREG_VLDTBLPTR_0_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VLDTBLPTR_0_reg)=data)
+#define set_CODEBLKREG_VLDTBLPTR_1_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VLDTBLPTR_1_reg)=data)
+#define get_CODEBLKREG_VLDTBLPTR_0_reg   (*((volatile unsigned int*) CODEBLKREG_VLDTBLPTR_0_reg))
+#define get_CODEBLKREG_VLDTBLPTR_1_reg   (*((volatile unsigned int*) CODEBLKREG_VLDTBLPTR_1_reg))
+#define CODEBLKREG_VLDTBLPTR_0_inst_adr                                              "0x00CC"
+#define CODEBLKREG_VLDTBLPTR_1_inst_adr                                              "0x00CD"
+#define CODEBLKREG_VLDTBLPTR_0_inst                                                  0x00CC
+#define CODEBLKREG_VLDTBLPTR_1_inst                                                  0x00CD
+#define CODEBLKREG_VLDTBLPTR_write_enable2_shift                                     (15)
+#define CODEBLKREG_VLDTBLPTR_write_enable2_mask                                      (0x00008000)
+#define CODEBLKREG_VLDTBLPTR_write_enable2(data)                                     (0x00008000&((data)<<15))
+#define CODEBLKREG_VLDTBLPTR_write_enable2_src(data)                                 ((0x00008000&(data))>>15)
+#define CODEBLKREG_VLDTBLPTR_get_write_enable2(data)                                 ((0x00008000&(data))>>15)
+#define CODEBLKREG_VLDTBLPTR_first_tbl_bits_shift                                    (11)
+#define CODEBLKREG_VLDTBLPTR_first_tbl_bits_mask                                     (0x00007800)
+#define CODEBLKREG_VLDTBLPTR_first_tbl_bits(data)                                    (0x00007800&((data)<<11))
+#define CODEBLKREG_VLDTBLPTR_first_tbl_bits_src(data)                                ((0x00007800&(data))>>11)
+#define CODEBLKREG_VLDTBLPTR_get_first_tbl_bits(data)                                ((0x00007800&(data))>>11)
+#define CODEBLKREG_VLDTBLPTR_write_enable1_shift                                     (10)
+#define CODEBLKREG_VLDTBLPTR_write_enable1_mask                                      (0x00000400)
+#define CODEBLKREG_VLDTBLPTR_write_enable1(data)                                     (0x00000400&((data)<<10))
+#define CODEBLKREG_VLDTBLPTR_write_enable1_src(data)                                 ((0x00000400&(data))>>10)
+#define CODEBLKREG_VLDTBLPTR_get_write_enable1(data)                                 ((0x00000400&(data))>>10)
+#define CODEBLKREG_VLDTBLPTR_tbl_startaddr_shift                                     (0)
+#define CODEBLKREG_VLDTBLPTR_tbl_startaddr_mask                                      (0x000003FF)
+#define CODEBLKREG_VLDTBLPTR_tbl_startaddr(data)                                     (0x000003FF&((data)<<0))
+#define CODEBLKREG_VLDTBLPTR_tbl_startaddr_src(data)                                 ((0x000003FF&(data))>>0)
+#define CODEBLKREG_VLDTBLPTR_get_tbl_startaddr(data)                                 ((0x000003FF&(data))>>0)
+
+
+#define CODEBLKREG_VLDESPPTR_0                                                       0x1800E340
+#define CODEBLKREG_VLDESPPTR_1                                                       0x1800E344
+#define CODEBLKREG_VLDESPPTR_2                                                       0x1800E348
+#define CODEBLKREG_VLDESPPTR_3                                                       0x1800E34C
+#define CODEBLKREG_VLDESPPTR_0_reg_addr                                              "0xB800E340"
+#define CODEBLKREG_VLDESPPTR_1_reg_addr                                              "0xB800E344"
+#define CODEBLKREG_VLDESPPTR_2_reg_addr                                              "0xB800E348"
+#define CODEBLKREG_VLDESPPTR_3_reg_addr                                              "0xB800E34C"
+#define CODEBLKREG_VLDESPPTR_0_reg                                                   0xB800E340
+#define CODEBLKREG_VLDESPPTR_1_reg                                                   0xB800E344
+#define CODEBLKREG_VLDESPPTR_2_reg                                                   0xB800E348
+#define CODEBLKREG_VLDESPPTR_3_reg                                                   0xB800E34C
+#define set_CODEBLKREG_VLDESPPTR_0_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VLDESPPTR_0_reg)=data)
+#define set_CODEBLKREG_VLDESPPTR_1_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VLDESPPTR_1_reg)=data)
+#define set_CODEBLKREG_VLDESPPTR_2_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VLDESPPTR_2_reg)=data)
+#define set_CODEBLKREG_VLDESPPTR_3_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VLDESPPTR_3_reg)=data)
+#define get_CODEBLKREG_VLDESPPTR_0_reg   (*((volatile unsigned int*) CODEBLKREG_VLDESPPTR_0_reg))
+#define get_CODEBLKREG_VLDESPPTR_1_reg   (*((volatile unsigned int*) CODEBLKREG_VLDESPPTR_1_reg))
+#define get_CODEBLKREG_VLDESPPTR_2_reg   (*((volatile unsigned int*) CODEBLKREG_VLDESPPTR_2_reg))
+#define get_CODEBLKREG_VLDESPPTR_3_reg   (*((volatile unsigned int*) CODEBLKREG_VLDESPPTR_3_reg))
+#define CODEBLKREG_VLDESPPTR_0_inst_adr                                              "0x00D0"
+#define CODEBLKREG_VLDESPPTR_1_inst_adr                                              "0x00D1"
+#define CODEBLKREG_VLDESPPTR_2_inst_adr                                              "0x00D2"
+#define CODEBLKREG_VLDESPPTR_3_inst_adr                                              "0x00D3"
+#define CODEBLKREG_VLDESPPTR_0_inst                                                  0x00D0
+#define CODEBLKREG_VLDESPPTR_1_inst                                                  0x00D1
+#define CODEBLKREG_VLDESPPTR_2_inst                                                  0x00D2
+#define CODEBLKREG_VLDESPPTR_3_inst                                                  0x00D3
+#define CODEBLKREG_VLDESPPTR_tbl_espptr_saddr_shift                                  (0)
+#define CODEBLKREG_VLDESPPTR_tbl_espptr_saddr_mask                                   (0x000003FF)
+#define CODEBLKREG_VLDESPPTR_tbl_espptr_saddr(data)                                  (0x000003FF&((data)<<0))
+#define CODEBLKREG_VLDESPPTR_tbl_espptr_saddr_src(data)                              ((0x000003FF&(data))>>0)
+#define CODEBLKREG_VLDESPPTR_get_tbl_espptr_saddr(data)                              ((0x000003FF&(data))>>0)
+
+
+#define CODEBLKREG_VLD_VP6TBLPTR0                                                    0x1800E338
+#define CODEBLKREG_VLD_VP6TBLPTR0_reg_addr                                           "0xB800E338"
+#define CODEBLKREG_VLD_VP6TBLPTR0_reg                                                0xB800E338
+#define set_CODEBLKREG_VLD_VP6TBLPTR0_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VLD_VP6TBLPTR0_reg)=data)
+#define get_CODEBLKREG_VLD_VP6TBLPTR0_reg   (*((volatile unsigned int*) CODEBLKREG_VLD_VP6TBLPTR0_reg))
+#define CODEBLKREG_VLD_VP6TBLPTR0_inst_adr                                           "0x00CE"
+#define CODEBLKREG_VLD_VP6TBLPTR0_inst                                               0x00CE
+#define CODEBLKREG_VLD_VP6TBLPTR0_write_enable2_shift                                (21)
+#define CODEBLKREG_VLD_VP6TBLPTR0_write_enable2_mask                                 (0x00200000)
+#define CODEBLKREG_VLD_VP6TBLPTR0_write_enable2(data)                                (0x00200000&((data)<<21))
+#define CODEBLKREG_VLD_VP6TBLPTR0_write_enable2_src(data)                            ((0x00200000&(data))>>21)
+#define CODEBLKREG_VLD_VP6TBLPTR0_get_write_enable2(data)                            ((0x00200000&(data))>>21)
+#define CODEBLKREG_VLD_VP6TBLPTR0_pre_ac1_tbl_startaddr_shift                        (11)
+#define CODEBLKREG_VLD_VP6TBLPTR0_pre_ac1_tbl_startaddr_mask                         (0x001FF800)
+#define CODEBLKREG_VLD_VP6TBLPTR0_pre_ac1_tbl_startaddr(data)                        (0x001FF800&((data)<<11))
+#define CODEBLKREG_VLD_VP6TBLPTR0_pre_ac1_tbl_startaddr_src(data)                    ((0x001FF800&(data))>>11)
+#define CODEBLKREG_VLD_VP6TBLPTR0_get_pre_ac1_tbl_startaddr(data)                    ((0x001FF800&(data))>>11)
+#define CODEBLKREG_VLD_VP6TBLPTR0_write_enable1_shift                                (10)
+#define CODEBLKREG_VLD_VP6TBLPTR0_write_enable1_mask                                 (0x00000400)
+#define CODEBLKREG_VLD_VP6TBLPTR0_write_enable1(data)                                (0x00000400&((data)<<10))
+#define CODEBLKREG_VLD_VP6TBLPTR0_write_enable1_src(data)                            ((0x00000400&(data))>>10)
+#define CODEBLKREG_VLD_VP6TBLPTR0_get_write_enable1(data)                            ((0x00000400&(data))>>10)
+#define CODEBLKREG_VLD_VP6TBLPTR0_pre_ac0_tbl_startaddr_shift                        (0)
+#define CODEBLKREG_VLD_VP6TBLPTR0_pre_ac0_tbl_startaddr_mask                         (0x000003FF)
+#define CODEBLKREG_VLD_VP6TBLPTR0_pre_ac0_tbl_startaddr(data)                        (0x000003FF&((data)<<0))
+#define CODEBLKREG_VLD_VP6TBLPTR0_pre_ac0_tbl_startaddr_src(data)                    ((0x000003FF&(data))>>0)
+#define CODEBLKREG_VLD_VP6TBLPTR0_get_pre_ac0_tbl_startaddr(data)                    ((0x000003FF&(data))>>0)
+
+
+#define CODEBLKREG_VLD_VP6TBLPTR1                                                    0x1800E33C
+#define CODEBLKREG_VLD_VP6TBLPTR1_reg_addr                                           "0xB800E33C"
+#define CODEBLKREG_VLD_VP6TBLPTR1_reg                                                0xB800E33C
+#define set_CODEBLKREG_VLD_VP6TBLPTR1_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VLD_VP6TBLPTR1_reg)=data)
+#define get_CODEBLKREG_VLD_VP6TBLPTR1_reg   (*((volatile unsigned int*) CODEBLKREG_VLD_VP6TBLPTR1_reg))
+#define CODEBLKREG_VLD_VP6TBLPTR1_inst_adr                                           "0x00CF"
+#define CODEBLKREG_VLD_VP6TBLPTR1_inst                                               0x00CF
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable3_shift                                (20)
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable3_mask                                 (0x00100000)
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable3(data)                                (0x00100000&((data)<<20))
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable3_src(data)                            ((0x00100000&(data))>>20)
+#define CODEBLKREG_VLD_VP6TBLPTR1_get_write_enable3(data)                            ((0x00100000&(data))>>20)
+#define CODEBLKREG_VLD_VP6TBLPTR1_ch_ac_first_tbl_bits_shift                         (16)
+#define CODEBLKREG_VLD_VP6TBLPTR1_ch_ac_first_tbl_bits_mask                          (0x000F0000)
+#define CODEBLKREG_VLD_VP6TBLPTR1_ch_ac_first_tbl_bits(data)                         (0x000F0000&((data)<<16))
+#define CODEBLKREG_VLD_VP6TBLPTR1_ch_ac_first_tbl_bits_src(data)                     ((0x000F0000&(data))>>16)
+#define CODEBLKREG_VLD_VP6TBLPTR1_get_ch_ac_first_tbl_bits(data)                     ((0x000F0000&(data))>>16)
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable2_shift                                (15)
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable2_mask                                 (0x00008000)
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable2(data)                                (0x00008000&((data)<<15))
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable2_src(data)                            ((0x00008000&(data))>>15)
+#define CODEBLKREG_VLD_VP6TBLPTR1_get_write_enable2(data)                            ((0x00008000&(data))>>15)
+#define CODEBLKREG_VLD_VP6TBLPTR1_lu_ac_first_tbl_bits_shift                         (11)
+#define CODEBLKREG_VLD_VP6TBLPTR1_lu_ac_first_tbl_bits_mask                          (0x00007800)
+#define CODEBLKREG_VLD_VP6TBLPTR1_lu_ac_first_tbl_bits(data)                         (0x00007800&((data)<<11))
+#define CODEBLKREG_VLD_VP6TBLPTR1_lu_ac_first_tbl_bits_src(data)                     ((0x00007800&(data))>>11)
+#define CODEBLKREG_VLD_VP6TBLPTR1_get_lu_ac_first_tbl_bits(data)                     ((0x00007800&(data))>>11)
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable1_shift                                (10)
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable1_mask                                 (0x00000400)
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable1(data)                                (0x00000400&((data)<<10))
+#define CODEBLKREG_VLD_VP6TBLPTR1_write_enable1_src(data)                            ((0x00000400&(data))>>10)
+#define CODEBLKREG_VLD_VP6TBLPTR1_get_write_enable1(data)                            ((0x00000400&(data))>>10)
+#define CODEBLKREG_VLD_VP6TBLPTR1_pre_ac2_tbl_startaddr_shift                        (0)
+#define CODEBLKREG_VLD_VP6TBLPTR1_pre_ac2_tbl_startaddr_mask                         (0x000003FF)
+#define CODEBLKREG_VLD_VP6TBLPTR1_pre_ac2_tbl_startaddr(data)                        (0x000003FF&((data)<<0))
+#define CODEBLKREG_VLD_VP6TBLPTR1_pre_ac2_tbl_startaddr_src(data)                    ((0x000003FF&(data))>>0)
+#define CODEBLKREG_VLD_VP6TBLPTR1_get_pre_ac2_tbl_startaddr(data)                    ((0x000003FF&(data))>>0)
+
+
+#define CODEBLKREG_VLD_VP6TBLPTR2                                                    0x1800E3C0
+#define CODEBLKREG_VLD_VP6TBLPTR2_reg_addr                                           "0xB800E3C0"
+#define CODEBLKREG_VLD_VP6TBLPTR2_reg                                                0xB800E3C0
+#define set_CODEBLKREG_VLD_VP6TBLPTR2_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VLD_VP6TBLPTR2_reg)=data)
+#define get_CODEBLKREG_VLD_VP6TBLPTR2_reg   (*((volatile unsigned int*) CODEBLKREG_VLD_VP6TBLPTR2_reg))
+#define CODEBLKREG_VLD_VP6TBLPTR2_inst_adr                                           "0x00F0"
+#define CODEBLKREG_VLD_VP6TBLPTR2_inst                                               0x00F0
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable4_shift                                (31)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable4_mask                                 (0x80000000)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable4(data)                                (0x80000000&((data)<<31))
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable4_src(data)                            ((0x80000000&(data))>>31)
+#define CODEBLKREG_VLD_VP6TBLPTR2_get_write_enable4(data)                            ((0x80000000&(data))>>31)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun1_first_tbl_bits_shift                      (27)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun1_first_tbl_bits_mask                       (0x78000000)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun1_first_tbl_bits(data)                      (0x78000000&((data)<<27))
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun1_first_tbl_bits_src(data)                  ((0x78000000&(data))>>27)
+#define CODEBLKREG_VLD_VP6TBLPTR2_get_zerorun1_first_tbl_bits(data)                  ((0x78000000&(data))>>27)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable3_shift                                (26)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable3_mask                                 (0x04000000)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable3(data)                                (0x04000000&((data)<<26))
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable3_src(data)                            ((0x04000000&(data))>>26)
+#define CODEBLKREG_VLD_VP6TBLPTR2_get_write_enable3(data)                            ((0x04000000&(data))>>26)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun1_tbl_startaddr_shift                       (16)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun1_tbl_startaddr_mask                        (0x03FF0000)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun1_tbl_startaddr(data)                       (0x03FF0000&((data)<<16))
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun1_tbl_startaddr_src(data)                   ((0x03FF0000&(data))>>16)
+#define CODEBLKREG_VLD_VP6TBLPTR2_get_zerorun1_tbl_startaddr(data)                   ((0x03FF0000&(data))>>16)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable2_shift                                (15)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable2_mask                                 (0x00008000)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable2(data)                                (0x00008000&((data)<<15))
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable2_src(data)                            ((0x00008000&(data))>>15)
+#define CODEBLKREG_VLD_VP6TBLPTR2_get_write_enable2(data)                            ((0x00008000&(data))>>15)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun0_first_tbl_bits_shift                      (11)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun0_first_tbl_bits_mask                       (0x00007800)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun0_first_tbl_bits(data)                      (0x00007800&((data)<<11))
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun0_first_tbl_bits_src(data)                  ((0x00007800&(data))>>11)
+#define CODEBLKREG_VLD_VP6TBLPTR2_get_zerorun0_first_tbl_bits(data)                  ((0x00007800&(data))>>11)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable1_shift                                (10)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable1_mask                                 (0x00000400)
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable1(data)                                (0x00000400&((data)<<10))
+#define CODEBLKREG_VLD_VP6TBLPTR2_write_enable1_src(data)                            ((0x00000400&(data))>>10)
+#define CODEBLKREG_VLD_VP6TBLPTR2_get_write_enable1(data)                            ((0x00000400&(data))>>10)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun0_tbl_startaddr_shift                       (0)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun0_tbl_startaddr_mask                        (0x000003FF)
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun0_tbl_startaddr(data)                       (0x000003FF&((data)<<0))
+#define CODEBLKREG_VLD_VP6TBLPTR2_zerorun0_tbl_startaddr_src(data)                   ((0x000003FF&(data))>>0)
+#define CODEBLKREG_VLD_VP6TBLPTR2_get_zerorun0_tbl_startaddr(data)                   ((0x000003FF&(data))>>0)
+
+
+#define CODEBLKREG_VE_ACDCP_LUMA                                                     0x1800E350
+#define CODEBLKREG_VE_ACDCP_LUMA_reg_addr                                            "0xB800E350"
+#define CODEBLKREG_VE_ACDCP_LUMA_reg                                                 0xB800E350
+#define set_CODEBLKREG_VE_ACDCP_LUMA_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_ACDCP_LUMA_reg)=data)
+#define get_CODEBLKREG_VE_ACDCP_LUMA_reg   (*((volatile unsigned int*) CODEBLKREG_VE_ACDCP_LUMA_reg))
+#define CODEBLKREG_VE_ACDCP_LUMA_inst_adr                                            "0x00D4"
+#define CODEBLKREG_VE_ACDCP_LUMA_inst                                                0x00D4
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_c_shift                                      (20)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_c_mask                                       (0xFFF00000)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_c(data)                                      (0xFFF00000&((data)<<20))
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_c_src(data)                                  ((0xFFF00000&(data))>>20)
+#define CODEBLKREG_VE_ACDCP_LUMA_get_lumadc_c(data)                                  ((0xFFF00000&(data))>>20)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_c_intra_shift                                (19)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_c_intra_mask                                 (0x00080000)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_c_intra(data)                                (0x00080000&((data)<<19))
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_c_intra_src(data)                            ((0x00080000&(data))>>19)
+#define CODEBLKREG_VE_ACDCP_LUMA_get_lumadc_c_intra(data)                            ((0x00080000&(data))>>19)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_d_shift                                      (7)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_d_mask                                       (0x0007FF80)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_d(data)                                      (0x0007FF80&((data)<<7))
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_d_src(data)                                  ((0x0007FF80&(data))>>7)
+#define CODEBLKREG_VE_ACDCP_LUMA_get_lumadc_d(data)                                  ((0x0007FF80&(data))>>7)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_d_intra_shift                                (6)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_d_intra_mask                                 (0x00000040)
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_d_intra(data)                                (0x00000040&((data)<<6))
+#define CODEBLKREG_VE_ACDCP_LUMA_lumadc_d_intra_src(data)                            ((0x00000040&(data))>>6)
+#define CODEBLKREG_VE_ACDCP_LUMA_get_lumadc_d_intra(data)                            ((0x00000040&(data))>>6)
+#define CODEBLKREG_VE_ACDCP_LUMA_dcstep_topmb_shift                                  (0)
+#define CODEBLKREG_VE_ACDCP_LUMA_dcstep_topmb_mask                                   (0x0000003F)
+#define CODEBLKREG_VE_ACDCP_LUMA_dcstep_topmb(data)                                  (0x0000003F&((data)<<0))
+#define CODEBLKREG_VE_ACDCP_LUMA_dcstep_topmb_src(data)                              ((0x0000003F&(data))>>0)
+#define CODEBLKREG_VE_ACDCP_LUMA_get_dcstep_topmb(data)                              ((0x0000003F&(data))>>0)
+
+
+#define CODEBLKREG_VE_ACDCP_CHRO                                                     0x1800E354
+#define CODEBLKREG_VE_ACDCP_CHRO_reg_addr                                            "0xB800E354"
+#define CODEBLKREG_VE_ACDCP_CHRO_reg                                                 0xB800E354
+#define set_CODEBLKREG_VE_ACDCP_CHRO_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VE_ACDCP_CHRO_reg)=data)
+#define get_CODEBLKREG_VE_ACDCP_CHRO_reg   (*((volatile unsigned int*) CODEBLKREG_VE_ACDCP_CHRO_reg))
+#define CODEBLKREG_VE_ACDCP_CHRO_inst_adr                                            "0x00D5"
+#define CODEBLKREG_VE_ACDCP_CHRO_inst                                                0x00D5
+#define CODEBLKREG_VE_ACDCP_CHRO_cbdc_g_shift                                        (18)
+#define CODEBLKREG_VE_ACDCP_CHRO_cbdc_g_mask                                         (0x3FFC0000)
+#define CODEBLKREG_VE_ACDCP_CHRO_cbdc_g(data)                                        (0x3FFC0000&((data)<<18))
+#define CODEBLKREG_VE_ACDCP_CHRO_cbdc_g_src(data)                                    ((0x3FFC0000&(data))>>18)
+#define CODEBLKREG_VE_ACDCP_CHRO_get_cbdc_g(data)                                    ((0x3FFC0000&(data))>>18)
+#define CODEBLKREG_VE_ACDCP_CHRO_crdc_g_shift                                        (6)
+#define CODEBLKREG_VE_ACDCP_CHRO_crdc_g_mask                                         (0x0003FFC0)
+#define CODEBLKREG_VE_ACDCP_CHRO_crdc_g(data)                                        (0x0003FFC0&((data)<<6))
+#define CODEBLKREG_VE_ACDCP_CHRO_crdc_g_src(data)                                    ((0x0003FFC0&(data))>>6)
+#define CODEBLKREG_VE_ACDCP_CHRO_get_crdc_g(data)                                    ((0x0003FFC0&(data))>>6)
+#define CODEBLKREG_VE_ACDCP_CHRO_cbcr_intra_shift                                    (5)
+#define CODEBLKREG_VE_ACDCP_CHRO_cbcr_intra_mask                                     (0x00000020)
+#define CODEBLKREG_VE_ACDCP_CHRO_cbcr_intra(data)                                    (0x00000020&((data)<<5))
+#define CODEBLKREG_VE_ACDCP_CHRO_cbcr_intra_src(data)                                ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_ACDCP_CHRO_get_cbcr_intra(data)                                ((0x00000020&(data))>>5)
+#define CODEBLKREG_VE_ACDCP_CHRO_ch_dcstep_topmb_shift                               (0)
+#define CODEBLKREG_VE_ACDCP_CHRO_ch_dcstep_topmb_mask                                (0x0000001F)
+#define CODEBLKREG_VE_ACDCP_CHRO_ch_dcstep_topmb(data)                               (0x0000001F&((data)<<0))
+#define CODEBLKREG_VE_ACDCP_CHRO_ch_dcstep_topmb_src(data)                           ((0x0000001F&(data))>>0)
+#define CODEBLKREG_VE_ACDCP_CHRO_get_ch_dcstep_topmb(data)                           ((0x0000001F&(data))>>0)
+
+
+#define CODEBLKREG_NDB_CTL                                                           0x1800E390
+#define CODEBLKREG_NDB_CTL_reg_addr                                                  "0xB800E390"
+#define CODEBLKREG_NDB_CTL_reg                                                       0xB800E390
+#define set_CODEBLKREG_NDB_CTL_reg(data)   (*((volatile unsigned int*) CODEBLKREG_NDB_CTL_reg)=data)
+#define get_CODEBLKREG_NDB_CTL_reg   (*((volatile unsigned int*) CODEBLKREG_NDB_CTL_reg))
+#define CODEBLKREG_NDB_CTL_inst_adr                                                  "0x00E4"
+#define CODEBLKREG_NDB_CTL_inst                                                      0x00E4
+#define CODEBLKREG_NDB_CTL_write_enable3_shift                                       (5)
+#define CODEBLKREG_NDB_CTL_write_enable3_mask                                        (0x00000020)
+#define CODEBLKREG_NDB_CTL_write_enable3(data)                                       (0x00000020&((data)<<5))
+#define CODEBLKREG_NDB_CTL_write_enable3_src(data)                                   ((0x00000020&(data))>>5)
+#define CODEBLKREG_NDB_CTL_get_write_enable3(data)                                   ((0x00000020&(data))>>5)
+#define CODEBLKREG_NDB_CTL_cavlc_halt_done_shift                                     (4)
+#define CODEBLKREG_NDB_CTL_cavlc_halt_done_mask                                      (0x00000010)
+#define CODEBLKREG_NDB_CTL_cavlc_halt_done(data)                                     (0x00000010&((data)<<4))
+#define CODEBLKREG_NDB_CTL_cavlc_halt_done_src(data)                                 ((0x00000010&(data))>>4)
+#define CODEBLKREG_NDB_CTL_get_cavlc_halt_done(data)                                 ((0x00000010&(data))>>4)
+#define CODEBLKREG_NDB_CTL_write_enable2_shift                                       (3)
+#define CODEBLKREG_NDB_CTL_write_enable2_mask                                        (0x00000008)
+#define CODEBLKREG_NDB_CTL_write_enable2(data)                                       (0x00000008&((data)<<3))
+#define CODEBLKREG_NDB_CTL_write_enable2_src(data)                                   ((0x00000008&(data))>>3)
+#define CODEBLKREG_NDB_CTL_get_write_enable2(data)                                   ((0x00000008&(data))>>3)
+#define CODEBLKREG_NDB_CTL_cavlc_halt_shift                                          (2)
+#define CODEBLKREG_NDB_CTL_cavlc_halt_mask                                           (0x00000004)
+#define CODEBLKREG_NDB_CTL_cavlc_halt(data)                                          (0x00000004&((data)<<2))
+#define CODEBLKREG_NDB_CTL_cavlc_halt_src(data)                                      ((0x00000004&(data))>>2)
+#define CODEBLKREG_NDB_CTL_get_cavlc_halt(data)                                      ((0x00000004&(data))>>2)
+#define CODEBLKREG_NDB_CTL_write_enable1_shift                                       (1)
+#define CODEBLKREG_NDB_CTL_write_enable1_mask                                        (0x00000002)
+#define CODEBLKREG_NDB_CTL_write_enable1(data)                                       (0x00000002&((data)<<1))
+#define CODEBLKREG_NDB_CTL_write_enable1_src(data)                                   ((0x00000002&(data))>>1)
+#define CODEBLKREG_NDB_CTL_get_write_enable1(data)                                   ((0x00000002&(data))>>1)
+#define CODEBLKREG_NDB_CTL_postwrite_en_shift                                        (0)
+#define CODEBLKREG_NDB_CTL_postwrite_en_mask                                         (0x00000001)
+#define CODEBLKREG_NDB_CTL_postwrite_en(data)                                        (0x00000001&((data)<<0))
+#define CODEBLKREG_NDB_CTL_postwrite_en_src(data)                                    ((0x00000001&(data))>>0)
+#define CODEBLKREG_NDB_CTL_get_postwrite_en(data)                                    ((0x00000001&(data))>>0)
+
+
+#define CODEBLKREG_NDB_CAVLC_BASE                                                    0x1800E3A8
+#define CODEBLKREG_NDB_CAVLC_BASE_reg_addr                                           "0xB800E3A8"
+#define CODEBLKREG_NDB_CAVLC_BASE_reg                                                0xB800E3A8
+#define set_CODEBLKREG_NDB_CAVLC_BASE_reg(data)   (*((volatile unsigned int*) CODEBLKREG_NDB_CAVLC_BASE_reg)=data)
+#define get_CODEBLKREG_NDB_CAVLC_BASE_reg   (*((volatile unsigned int*) CODEBLKREG_NDB_CAVLC_BASE_reg))
+#define CODEBLKREG_NDB_CAVLC_BASE_inst_adr                                           "0x00EA"
+#define CODEBLKREG_NDB_CAVLC_BASE_inst                                               0x00EA
+#define CODEBLKREG_NDB_CAVLC_BASE_base_addr_shift                                    (0)
+#define CODEBLKREG_NDB_CAVLC_BASE_base_addr_mask                                     (0x7FFFFFFF)
+#define CODEBLKREG_NDB_CAVLC_BASE_base_addr(data)                                    (0x7FFFFFFF&((data)<<0))
+#define CODEBLKREG_NDB_CAVLC_BASE_base_addr_src(data)                                ((0x7FFFFFFF&(data))>>0)
+#define CODEBLKREG_NDB_CAVLC_BASE_get_base_addr(data)                                ((0x7FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_NDB_CAVLC_LIMIT                                                   0x1800E3AC
+#define CODEBLKREG_NDB_CAVLC_LIMIT_reg_addr                                          "0xB800E3AC"
+#define CODEBLKREG_NDB_CAVLC_LIMIT_reg                                               0xB800E3AC
+#define set_CODEBLKREG_NDB_CAVLC_LIMIT_reg(data)   (*((volatile unsigned int*) CODEBLKREG_NDB_CAVLC_LIMIT_reg)=data)
+#define get_CODEBLKREG_NDB_CAVLC_LIMIT_reg   (*((volatile unsigned int*) CODEBLKREG_NDB_CAVLC_LIMIT_reg))
+#define CODEBLKREG_NDB_CAVLC_LIMIT_inst_adr                                          "0x00EB"
+#define CODEBLKREG_NDB_CAVLC_LIMIT_inst                                              0x00EB
+#define CODEBLKREG_NDB_CAVLC_LIMIT_limit_addr_shift                                  (0)
+#define CODEBLKREG_NDB_CAVLC_LIMIT_limit_addr_mask                                   (0x7FFFFFFF)
+#define CODEBLKREG_NDB_CAVLC_LIMIT_limit_addr(data)                                  (0x7FFFFFFF&((data)<<0))
+#define CODEBLKREG_NDB_CAVLC_LIMIT_limit_addr_src(data)                              ((0x7FFFFFFF&(data))>>0)
+#define CODEBLKREG_NDB_CAVLC_LIMIT_get_limit_addr(data)                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_NDB_CAVLC_WPTR                                                    0x1800E3B0
+#define CODEBLKREG_NDB_CAVLC_WPTR_reg_addr                                           "0xB800E3B0"
+#define CODEBLKREG_NDB_CAVLC_WPTR_reg                                                0xB800E3B0
+#define set_CODEBLKREG_NDB_CAVLC_WPTR_reg(data)   (*((volatile unsigned int*) CODEBLKREG_NDB_CAVLC_WPTR_reg)=data)
+#define get_CODEBLKREG_NDB_CAVLC_WPTR_reg   (*((volatile unsigned int*) CODEBLKREG_NDB_CAVLC_WPTR_reg))
+#define CODEBLKREG_NDB_CAVLC_WPTR_inst_adr                                           "0x00EC"
+#define CODEBLKREG_NDB_CAVLC_WPTR_inst                                               0x00EC
+#define CODEBLKREG_NDB_CAVLC_WPTR_wr_ptr_shift                                       (0)
+#define CODEBLKREG_NDB_CAVLC_WPTR_wr_ptr_mask                                        (0x7FFFFFFF)
+#define CODEBLKREG_NDB_CAVLC_WPTR_wr_ptr(data)                                       (0x7FFFFFFF&((data)<<0))
+#define CODEBLKREG_NDB_CAVLC_WPTR_wr_ptr_src(data)                                   ((0x7FFFFFFF&(data))>>0)
+#define CODEBLKREG_NDB_CAVLC_WPTR_get_wr_ptr(data)                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_NDB_CAVLC_RPTR                                                    0x1800E3B4
+#define CODEBLKREG_NDB_CAVLC_RPTR_reg_addr                                           "0xB800E3B4"
+#define CODEBLKREG_NDB_CAVLC_RPTR_reg                                                0xB800E3B4
+#define set_CODEBLKREG_NDB_CAVLC_RPTR_reg(data)   (*((volatile unsigned int*) CODEBLKREG_NDB_CAVLC_RPTR_reg)=data)
+#define get_CODEBLKREG_NDB_CAVLC_RPTR_reg   (*((volatile unsigned int*) CODEBLKREG_NDB_CAVLC_RPTR_reg))
+#define CODEBLKREG_NDB_CAVLC_RPTR_inst_adr                                           "0x00ED"
+#define CODEBLKREG_NDB_CAVLC_RPTR_inst                                               0x00ED
+#define CODEBLKREG_NDB_CAVLC_RPTR_rd_ptr_shift                                       (0)
+#define CODEBLKREG_NDB_CAVLC_RPTR_rd_ptr_mask                                        (0x7FFFFFFF)
+#define CODEBLKREG_NDB_CAVLC_RPTR_rd_ptr(data)                                       (0x7FFFFFFF&((data)<<0))
+#define CODEBLKREG_NDB_CAVLC_RPTR_rd_ptr_src(data)                                   ((0x7FFFFFFF&(data))>>0)
+#define CODEBLKREG_NDB_CAVLC_RPTR_get_rd_ptr(data)                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define CODEBLKREG_VP8_P3_FRM_MB1                                                    0x1800E3F0
+#define CODEBLKREG_VP8_P3_FRM_MB1_reg_addr                                           "0xB800E3F0"
+#define CODEBLKREG_VP8_P3_FRM_MB1_reg                                                0xB800E3F0
+#define set_CODEBLKREG_VP8_P3_FRM_MB1_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VP8_P3_FRM_MB1_reg)=data)
+#define get_CODEBLKREG_VP8_P3_FRM_MB1_reg   (*((volatile unsigned int*) CODEBLKREG_VP8_P3_FRM_MB1_reg))
+#define CODEBLKREG_VP8_P3_FRM_MB1_inst_adr                                           "0x00FC"
+#define CODEBLKREG_VP8_P3_FRM_MB1_inst                                               0x00FC
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable7_shift                                (25)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable7_mask                                 (0x02000000)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable7(data)                                (0x02000000&((data)<<25))
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable7_src(data)                            ((0x02000000&(data))>>25)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_write_enable7(data)                            ((0x02000000&(data))>>25)
+#define CODEBLKREG_VP8_P3_FRM_MB1_segmentation_enabled_shift                         (24)
+#define CODEBLKREG_VP8_P3_FRM_MB1_segmentation_enabled_mask                          (0x01000000)
+#define CODEBLKREG_VP8_P3_FRM_MB1_segmentation_enabled(data)                         (0x01000000&((data)<<24))
+#define CODEBLKREG_VP8_P3_FRM_MB1_segmentation_enabled_src(data)                     ((0x01000000&(data))>>24)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_segmentation_enabled(data)                     ((0x01000000&(data))>>24)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable6_shift                                (23)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable6_mask                                 (0x00800000)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable6(data)                                (0x00800000&((data)<<23))
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable6_src(data)                            ((0x00800000&(data))>>23)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_write_enable6(data)                            ((0x00800000&(data))>>23)
+#define CODEBLKREG_VP8_P3_FRM_MB1_slice_cnt_shift                                    (15)
+#define CODEBLKREG_VP8_P3_FRM_MB1_slice_cnt_mask                                     (0x007F8000)
+#define CODEBLKREG_VP8_P3_FRM_MB1_slice_cnt(data)                                    (0x007F8000&((data)<<15))
+#define CODEBLKREG_VP8_P3_FRM_MB1_slice_cnt_src(data)                                ((0x007F8000&(data))>>15)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_slice_cnt(data)                                ((0x007F8000&(data))>>15)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable5_shift                                (14)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable5_mask                                 (0x00004000)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable5(data)                                (0x00004000&((data)<<14))
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable5_src(data)                            ((0x00004000&(data))>>14)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_write_enable5(data)                            ((0x00004000&(data))>>14)
+#define CODEBLKREG_VP8_P3_FRM_MB1_uv_mode_shift                                      (12)
+#define CODEBLKREG_VP8_P3_FRM_MB1_uv_mode_mask                                       (0x00003000)
+#define CODEBLKREG_VP8_P3_FRM_MB1_uv_mode(data)                                      (0x00003000&((data)<<12))
+#define CODEBLKREG_VP8_P3_FRM_MB1_uv_mode_src(data)                                  ((0x00003000&(data))>>12)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_uv_mode(data)                                  ((0x00003000&(data))>>12)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable4_shift                                (11)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable4_mask                                 (0x00000800)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable4(data)                                (0x00000800&((data)<<11))
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable4_src(data)                            ((0x00000800&(data))>>11)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_write_enable4(data)                            ((0x00000800&(data))>>11)
+#define CODEBLKREG_VP8_P3_FRM_MB1_ref_frame_shift                                    (9)
+#define CODEBLKREG_VP8_P3_FRM_MB1_ref_frame_mask                                     (0x00000600)
+#define CODEBLKREG_VP8_P3_FRM_MB1_ref_frame(data)                                    (0x00000600&((data)<<9))
+#define CODEBLKREG_VP8_P3_FRM_MB1_ref_frame_src(data)                                ((0x00000600&(data))>>9)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_ref_frame(data)                                ((0x00000600&(data))>>9)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable3_shift                                (8)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable3_mask                                 (0x00000100)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable3(data)                                (0x00000100&((data)<<8))
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable3_src(data)                            ((0x00000100&(data))>>8)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_write_enable3(data)                            ((0x00000100&(data))>>8)
+#define CODEBLKREG_VP8_P3_FRM_MB1_mode_shift                                         (4)
+#define CODEBLKREG_VP8_P3_FRM_MB1_mode_mask                                          (0x000000F0)
+#define CODEBLKREG_VP8_P3_FRM_MB1_mode(data)                                         (0x000000F0&((data)<<4))
+#define CODEBLKREG_VP8_P3_FRM_MB1_mode_src(data)                                     ((0x000000F0&(data))>>4)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_mode(data)                                     ((0x000000F0&(data))>>4)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable2_shift                                (3)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable2_mask                                 (0x00000008)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable2(data)                                (0x00000008&((data)<<3))
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable2_src(data)                            ((0x00000008&(data))>>3)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_write_enable2(data)                            ((0x00000008&(data))>>3)
+#define CODEBLKREG_VP8_P3_FRM_MB1_need_to_clamp_mvs_shift                            (2)
+#define CODEBLKREG_VP8_P3_FRM_MB1_need_to_clamp_mvs_mask                             (0x00000004)
+#define CODEBLKREG_VP8_P3_FRM_MB1_need_to_clamp_mvs(data)                            (0x00000004&((data)<<2))
+#define CODEBLKREG_VP8_P3_FRM_MB1_need_to_clamp_mvs_src(data)                        ((0x00000004&(data))>>2)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_need_to_clamp_mvs(data)                        ((0x00000004&(data))>>2)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable1_shift                                (1)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable1_mask                                 (0x00000002)
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable1(data)                                (0x00000002&((data)<<1))
+#define CODEBLKREG_VP8_P3_FRM_MB1_write_enable1_src(data)                            ((0x00000002&(data))>>1)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_write_enable1(data)                            ((0x00000002&(data))>>1)
+#define CODEBLKREG_VP8_P3_FRM_MB1_mb_skip_coeff_shift                                (0)
+#define CODEBLKREG_VP8_P3_FRM_MB1_mb_skip_coeff_mask                                 (0x00000001)
+#define CODEBLKREG_VP8_P3_FRM_MB1_mb_skip_coeff(data)                                (0x00000001&((data)<<0))
+#define CODEBLKREG_VP8_P3_FRM_MB1_mb_skip_coeff_src(data)                            ((0x00000001&(data))>>0)
+#define CODEBLKREG_VP8_P3_FRM_MB1_get_mb_skip_coeff(data)                            ((0x00000001&(data))>>0)
+
+
+#define CODEBLKREG_VP8_P3_MB2                                                        0x1800E3F4
+#define CODEBLKREG_VP8_P3_MB2_reg_addr                                               "0xB800E3F4"
+#define CODEBLKREG_VP8_P3_MB2_reg                                                    0xB800E3F4
+#define set_CODEBLKREG_VP8_P3_MB2_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VP8_P3_MB2_reg)=data)
+#define get_CODEBLKREG_VP8_P3_MB2_reg   (*((volatile unsigned int*) CODEBLKREG_VP8_P3_MB2_reg))
+#define CODEBLKREG_VP8_P3_MB2_inst_adr                                               "0x00FD"
+#define CODEBLKREG_VP8_P3_MB2_inst                                                   0x00FD
+#define CODEBLKREG_VP8_P3_MB2_vp8_p3_curmb_shift                                     (0)
+#define CODEBLKREG_VP8_P3_MB2_vp8_p3_curmb_mask                                      (0x000001FF)
+#define CODEBLKREG_VP8_P3_MB2_vp8_p3_curmb(data)                                     (0x000001FF&((data)<<0))
+#define CODEBLKREG_VP8_P3_MB2_vp8_p3_curmb_src(data)                                 ((0x000001FF&(data))>>0)
+#define CODEBLKREG_VP8_P3_MB2_get_vp8_p3_curmb(data)                                 ((0x000001FF&(data))>>0)
+
+
+#define CODEBLKREG_VP8_BAC                                                           0x1800E3F8
+#define CODEBLKREG_VP8_BAC_reg_addr                                                  "0xB800E3F8"
+#define CODEBLKREG_VP8_BAC_reg                                                       0xB800E3F8
+#define set_CODEBLKREG_VP8_BAC_reg(data)   (*((volatile unsigned int*) CODEBLKREG_VP8_BAC_reg)=data)
+#define get_CODEBLKREG_VP8_BAC_reg   (*((volatile unsigned int*) CODEBLKREG_VP8_BAC_reg))
+#define CODEBLKREG_VP8_BAC_inst_adr                                                  "0x00FE"
+#define CODEBLKREG_VP8_BAC_inst                                                      0x00FE
+#define CODEBLKREG_VP8_BAC_high_shift                                                (20)
+#define CODEBLKREG_VP8_BAC_high_mask                                                 (0x1FF00000)
+#define CODEBLKREG_VP8_BAC_high(data)                                                (0x1FF00000&((data)<<20))
+#define CODEBLKREG_VP8_BAC_high_src(data)                                            ((0x1FF00000&(data))>>20)
+#define CODEBLKREG_VP8_BAC_get_high(data)                                            ((0x1FF00000&(data))>>20)
+#define CODEBLKREG_VP8_BAC_bits_shift                                                (16)
+#define CODEBLKREG_VP8_BAC_bits_mask                                                 (0x000F0000)
+#define CODEBLKREG_VP8_BAC_bits(data)                                                (0x000F0000&((data)<<16))
+#define CODEBLKREG_VP8_BAC_bits_src(data)                                            ((0x000F0000&(data))>>16)
+#define CODEBLKREG_VP8_BAC_get_bits(data)                                            ((0x000F0000&(data))>>16)
+#define CODEBLKREG_VP8_BAC_code_word_shift                                           (0)
+#define CODEBLKREG_VP8_BAC_code_word_mask                                            (0x0000FFFF)
+#define CODEBLKREG_VP8_BAC_code_word(data)                                           (0x0000FFFF&((data)<<0))
+#define CODEBLKREG_VP8_BAC_code_word_src(data)                                       ((0x0000FFFF&(data))>>0)
+#define CODEBLKREG_VP8_BAC_get_code_word(data)                                       ((0x0000FFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/cp_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cp_reg.h
new file mode 100644
index 00000000..6100ab6
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/cp_reg.h
@@ -0,0 +1,1155 @@
+/**************************************************************
+// Spec Version                  : 0.3
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/4/1 14:32:35
+***************************************************************/
+
+
+#ifndef _CP_REG_H_INCLUDED_
+#define _CP_REG_H_INCLUDED_
+#ifdef  _CP_USE_STRUCT
+typedef struct 
+{
+unsigned int     data:32;
+}CP_REG_KEY;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CP_REG_DATAIN;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CP_REG_DATAOUT;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CP_REG_IV;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable3:1;
+unsigned int     mode:4;
+unsigned int     reserved_1:7;
+unsigned int     write_enable2:1;
+unsigned int     cbc:1;
+unsigned int     write_enable1:1;
+unsigned int     reg_first:1;
+unsigned int     write_enable0:1;
+unsigned int     reg_ende:1;
+}CP_REG_SET;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     dataout_byte_swap:1;
+unsigned int     datain_byte_swap:1;
+unsigned int     iv_byte_swap:1;
+unsigned int     key_byte_swap:1;
+unsigned int     des_key_order:1;
+unsigned int     reserved_1:1;
+unsigned int     key_mode:2;
+unsigned int     iv_mode:2;
+unsigned int     input_mode:2;
+unsigned int     output_mode:2;
+}CP_REG_SET1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     output_entry:7;
+unsigned int     reserved_1:1;
+unsigned int     input_entry:7;
+unsigned int     reserved_2:1;
+unsigned int     key_entry:7;
+unsigned int     reserved_3:1;
+unsigned int     iv_entry:7;
+}CP_REG_SET2;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CP_REG_KEY_1;
+
+typedef struct 
+{
+unsigned int     reg1:16;
+unsigned int     reg0:15;
+unsigned int     eco_des_iv:1;
+}CP_SCTCH;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CP_NF_KEY;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CP_NF_INI_KEY;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     otp_sel:2;
+unsigned int     aes_mode:2;
+unsigned int     bcm:2;
+unsigned int     cw_entry:7;
+unsigned int     sel:2;
+}CP_NF_SET;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CP_NF_KEY_1;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CP_MD_KEY;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CP_MD_INI_KEY;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     otp_sel:2;
+unsigned int     aes_mode:2;
+unsigned int     bcm:2;
+unsigned int     cw_entry:7;
+unsigned int     sel:2;
+}CP_MD_SET;
+
+typedef struct 
+{
+unsigned int     data:32;
+}CP_MD_KEY_1;
+
+typedef struct 
+{
+unsigned int     data:32;
+}K_CP_REG_KEY;
+
+typedef struct 
+{
+unsigned int     data:32;
+}K_CP_REG_DATAIN;
+
+typedef struct 
+{
+unsigned int     data:32;
+}K_CP_REG_DATAOUT;
+
+typedef struct 
+{
+unsigned int     data:32;
+}K_CP_REG_IV;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable3:1;
+unsigned int     mode:4;
+unsigned int     reserved_1:7;
+unsigned int     write_enable2:1;
+unsigned int     cbc:1;
+unsigned int     write_enable1:1;
+unsigned int     reg_first:1;
+unsigned int     write_enable0:1;
+unsigned int     reg_ende:1;
+}K_CP_REG_SET;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     dataout_byte_swap:1;
+unsigned int     datain_byte_swap:1;
+unsigned int     iv_byte_swap:1;
+unsigned int     key_byte_swap:1;
+unsigned int     des_key_order:1;
+unsigned int     key_mode:3;
+unsigned int     iv_mode:2;
+unsigned int     input_mode:2;
+unsigned int     output_mode:2;
+}K_CP_REG_SET1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     output_entry:7;
+unsigned int     reserved_1:1;
+unsigned int     input_entry:7;
+unsigned int     reserved_2:1;
+unsigned int     key_entry:7;
+unsigned int     reserved_3:1;
+unsigned int     iv_entry:7;
+}K_CP_REG_SET2;
+
+typedef struct 
+{
+unsigned int     data:32;
+}K_CP_REG_KEY_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     dbg_sel1:5;
+unsigned int     dbg_sel0:5;
+unsigned int     dbg_en:1;
+}CP_DBG;
+
+#endif
+
+#define CP_REG_KEY_0                                                                 0x18015034
+#define CP_REG_KEY_1                                                                 0x18015038
+#define CP_REG_KEY_2                                                                 0x1801503C
+#define CP_REG_KEY_3                                                                 0x18015040
+#define CP_REG_KEY_0_reg_addr                                                        "0xB8015034"
+#define CP_REG_KEY_1_reg_addr                                                        "0xB8015038"
+#define CP_REG_KEY_2_reg_addr                                                        "0xB801503C"
+#define CP_REG_KEY_3_reg_addr                                                        "0xB8015040"
+#define CP_REG_KEY_0_reg                                                             0xB8015034
+#define CP_REG_KEY_1_reg                                                             0xB8015038
+#define CP_REG_KEY_2_reg                                                             0xB801503C
+#define CP_REG_KEY_3_reg                                                             0xB8015040
+#define set_CP_REG_KEY_0_reg(data)   (*((volatile unsigned int*) CP_REG_KEY_0_reg)=data)
+#define set_CP_REG_KEY_1_reg(data)   (*((volatile unsigned int*) CP_REG_KEY_1_reg)=data)
+#define set_CP_REG_KEY_2_reg(data)   (*((volatile unsigned int*) CP_REG_KEY_2_reg)=data)
+#define set_CP_REG_KEY_3_reg(data)   (*((volatile unsigned int*) CP_REG_KEY_3_reg)=data)
+#define get_CP_REG_KEY_0_reg   (*((volatile unsigned int*) CP_REG_KEY_0_reg))
+#define get_CP_REG_KEY_1_reg   (*((volatile unsigned int*) CP_REG_KEY_1_reg))
+#define get_CP_REG_KEY_2_reg   (*((volatile unsigned int*) CP_REG_KEY_2_reg))
+#define get_CP_REG_KEY_3_reg   (*((volatile unsigned int*) CP_REG_KEY_3_reg))
+#define CP_REG_KEY_0_inst_adr                                                        "0x000D"
+#define CP_REG_KEY_1_inst_adr                                                        "0x000E"
+#define CP_REG_KEY_2_inst_adr                                                        "0x000F"
+#define CP_REG_KEY_3_inst_adr                                                        "0x0010"
+#define CP_REG_KEY_0_inst                                                            0x000D
+#define CP_REG_KEY_1_inst                                                            0x000E
+#define CP_REG_KEY_2_inst                                                            0x000F
+#define CP_REG_KEY_3_inst                                                            0x0010
+#define CP_REG_KEY_data_shift                                                        (0)
+#define CP_REG_KEY_data_mask                                                         (0xFFFFFFFF)
+#define CP_REG_KEY_data(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define CP_REG_KEY_data_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define CP_REG_KEY_get_data(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_REG_DATAIN_0                                                              0x18015044
+#define CP_REG_DATAIN_1                                                              0x18015048
+#define CP_REG_DATAIN_2                                                              0x1801504C
+#define CP_REG_DATAIN_3                                                              0x18015050
+#define CP_REG_DATAIN_0_reg_addr                                                     "0xB8015044"
+#define CP_REG_DATAIN_1_reg_addr                                                     "0xB8015048"
+#define CP_REG_DATAIN_2_reg_addr                                                     "0xB801504C"
+#define CP_REG_DATAIN_3_reg_addr                                                     "0xB8015050"
+#define CP_REG_DATAIN_0_reg                                                          0xB8015044
+#define CP_REG_DATAIN_1_reg                                                          0xB8015048
+#define CP_REG_DATAIN_2_reg                                                          0xB801504C
+#define CP_REG_DATAIN_3_reg                                                          0xB8015050
+#define set_CP_REG_DATAIN_0_reg(data)   (*((volatile unsigned int*) CP_REG_DATAIN_0_reg)=data)
+#define set_CP_REG_DATAIN_1_reg(data)   (*((volatile unsigned int*) CP_REG_DATAIN_1_reg)=data)
+#define set_CP_REG_DATAIN_2_reg(data)   (*((volatile unsigned int*) CP_REG_DATAIN_2_reg)=data)
+#define set_CP_REG_DATAIN_3_reg(data)   (*((volatile unsigned int*) CP_REG_DATAIN_3_reg)=data)
+#define get_CP_REG_DATAIN_0_reg   (*((volatile unsigned int*) CP_REG_DATAIN_0_reg))
+#define get_CP_REG_DATAIN_1_reg   (*((volatile unsigned int*) CP_REG_DATAIN_1_reg))
+#define get_CP_REG_DATAIN_2_reg   (*((volatile unsigned int*) CP_REG_DATAIN_2_reg))
+#define get_CP_REG_DATAIN_3_reg   (*((volatile unsigned int*) CP_REG_DATAIN_3_reg))
+#define CP_REG_DATAIN_0_inst_adr                                                     "0x0011"
+#define CP_REG_DATAIN_1_inst_adr                                                     "0x0012"
+#define CP_REG_DATAIN_2_inst_adr                                                     "0x0013"
+#define CP_REG_DATAIN_3_inst_adr                                                     "0x0014"
+#define CP_REG_DATAIN_0_inst                                                         0x0011
+#define CP_REG_DATAIN_1_inst                                                         0x0012
+#define CP_REG_DATAIN_2_inst                                                         0x0013
+#define CP_REG_DATAIN_3_inst                                                         0x0014
+#define CP_REG_DATAIN_data_shift                                                     (0)
+#define CP_REG_DATAIN_data_mask                                                      (0xFFFFFFFF)
+#define CP_REG_DATAIN_data(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define CP_REG_DATAIN_data_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define CP_REG_DATAIN_get_data(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_REG_DATAOUT_0                                                             0x18015054
+#define CP_REG_DATAOUT_1                                                             0x18015058
+#define CP_REG_DATAOUT_2                                                             0x1801505C
+#define CP_REG_DATAOUT_3                                                             0x18015060
+#define CP_REG_DATAOUT_0_reg_addr                                                    "0xB8015054"
+#define CP_REG_DATAOUT_1_reg_addr                                                    "0xB8015058"
+#define CP_REG_DATAOUT_2_reg_addr                                                    "0xB801505C"
+#define CP_REG_DATAOUT_3_reg_addr                                                    "0xB8015060"
+#define CP_REG_DATAOUT_0_reg                                                         0xB8015054
+#define CP_REG_DATAOUT_1_reg                                                         0xB8015058
+#define CP_REG_DATAOUT_2_reg                                                         0xB801505C
+#define CP_REG_DATAOUT_3_reg                                                         0xB8015060
+#define set_CP_REG_DATAOUT_0_reg(data)   (*((volatile unsigned int*) CP_REG_DATAOUT_0_reg)=data)
+#define set_CP_REG_DATAOUT_1_reg(data)   (*((volatile unsigned int*) CP_REG_DATAOUT_1_reg)=data)
+#define set_CP_REG_DATAOUT_2_reg(data)   (*((volatile unsigned int*) CP_REG_DATAOUT_2_reg)=data)
+#define set_CP_REG_DATAOUT_3_reg(data)   (*((volatile unsigned int*) CP_REG_DATAOUT_3_reg)=data)
+#define get_CP_REG_DATAOUT_0_reg   (*((volatile unsigned int*) CP_REG_DATAOUT_0_reg))
+#define get_CP_REG_DATAOUT_1_reg   (*((volatile unsigned int*) CP_REG_DATAOUT_1_reg))
+#define get_CP_REG_DATAOUT_2_reg   (*((volatile unsigned int*) CP_REG_DATAOUT_2_reg))
+#define get_CP_REG_DATAOUT_3_reg   (*((volatile unsigned int*) CP_REG_DATAOUT_3_reg))
+#define CP_REG_DATAOUT_0_inst_adr                                                    "0x0015"
+#define CP_REG_DATAOUT_1_inst_adr                                                    "0x0016"
+#define CP_REG_DATAOUT_2_inst_adr                                                    "0x0017"
+#define CP_REG_DATAOUT_3_inst_adr                                                    "0x0018"
+#define CP_REG_DATAOUT_0_inst                                                        0x0015
+#define CP_REG_DATAOUT_1_inst                                                        0x0016
+#define CP_REG_DATAOUT_2_inst                                                        0x0017
+#define CP_REG_DATAOUT_3_inst                                                        0x0018
+#define CP_REG_DATAOUT_data_shift                                                    (0)
+#define CP_REG_DATAOUT_data_mask                                                     (0xFFFFFFFF)
+#define CP_REG_DATAOUT_data(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define CP_REG_DATAOUT_data_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define CP_REG_DATAOUT_get_data(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_REG_IV_0                                                                  0x18015064
+#define CP_REG_IV_1                                                                  0x18015068
+#define CP_REG_IV_2                                                                  0x1801506C
+#define CP_REG_IV_3                                                                  0x18015070
+#define CP_REG_IV_0_reg_addr                                                         "0xB8015064"
+#define CP_REG_IV_1_reg_addr                                                         "0xB8015068"
+#define CP_REG_IV_2_reg_addr                                                         "0xB801506C"
+#define CP_REG_IV_3_reg_addr                                                         "0xB8015070"
+#define CP_REG_IV_0_reg                                                              0xB8015064
+#define CP_REG_IV_1_reg                                                              0xB8015068
+#define CP_REG_IV_2_reg                                                              0xB801506C
+#define CP_REG_IV_3_reg                                                              0xB8015070
+#define set_CP_REG_IV_0_reg(data)   (*((volatile unsigned int*) CP_REG_IV_0_reg)=data)
+#define set_CP_REG_IV_1_reg(data)   (*((volatile unsigned int*) CP_REG_IV_1_reg)=data)
+#define set_CP_REG_IV_2_reg(data)   (*((volatile unsigned int*) CP_REG_IV_2_reg)=data)
+#define set_CP_REG_IV_3_reg(data)   (*((volatile unsigned int*) CP_REG_IV_3_reg)=data)
+#define get_CP_REG_IV_0_reg   (*((volatile unsigned int*) CP_REG_IV_0_reg))
+#define get_CP_REG_IV_1_reg   (*((volatile unsigned int*) CP_REG_IV_1_reg))
+#define get_CP_REG_IV_2_reg   (*((volatile unsigned int*) CP_REG_IV_2_reg))
+#define get_CP_REG_IV_3_reg   (*((volatile unsigned int*) CP_REG_IV_3_reg))
+#define CP_REG_IV_0_inst_adr                                                         "0x0019"
+#define CP_REG_IV_1_inst_adr                                                         "0x001A"
+#define CP_REG_IV_2_inst_adr                                                         "0x001B"
+#define CP_REG_IV_3_inst_adr                                                         "0x001C"
+#define CP_REG_IV_0_inst                                                             0x0019
+#define CP_REG_IV_1_inst                                                             0x001A
+#define CP_REG_IV_2_inst                                                             0x001B
+#define CP_REG_IV_3_inst                                                             0x001C
+#define CP_REG_IV_data_shift                                                         (0)
+#define CP_REG_IV_data_mask                                                          (0xFFFFFFFF)
+#define CP_REG_IV_data(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define CP_REG_IV_data_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define CP_REG_IV_get_data(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_REG_SET                                                                   0x18015074
+#define CP_REG_SET_reg_addr                                                          "0xB8015074"
+#define CP_REG_SET_reg                                                               0xB8015074
+#define set_CP_REG_SET_reg(data)   (*((volatile unsigned int*) CP_REG_SET_reg)=data)
+#define get_CP_REG_SET_reg   (*((volatile unsigned int*) CP_REG_SET_reg))
+#define CP_REG_SET_inst_adr                                                          "0x001D"
+#define CP_REG_SET_inst                                                              0x001D
+#define CP_REG_SET_write_enable3_shift                                               (17)
+#define CP_REG_SET_write_enable3_mask                                                (0x00020000)
+#define CP_REG_SET_write_enable3(data)                                               (0x00020000&((data)<<17))
+#define CP_REG_SET_write_enable3_src(data)                                           ((0x00020000&(data))>>17)
+#define CP_REG_SET_get_write_enable3(data)                                           ((0x00020000&(data))>>17)
+#define CP_REG_SET_mode_shift                                                        (13)
+#define CP_REG_SET_mode_mask                                                         (0x0001E000)
+#define CP_REG_SET_mode(data)                                                        (0x0001E000&((data)<<13))
+#define CP_REG_SET_mode_src(data)                                                    ((0x0001E000&(data))>>13)
+#define CP_REG_SET_get_mode(data)                                                    ((0x0001E000&(data))>>13)
+#define CP_REG_SET_write_enable2_shift                                               (5)
+#define CP_REG_SET_write_enable2_mask                                                (0x00000020)
+#define CP_REG_SET_write_enable2(data)                                               (0x00000020&((data)<<5))
+#define CP_REG_SET_write_enable2_src(data)                                           ((0x00000020&(data))>>5)
+#define CP_REG_SET_get_write_enable2(data)                                           ((0x00000020&(data))>>5)
+#define CP_REG_SET_cbc_shift                                                         (4)
+#define CP_REG_SET_cbc_mask                                                          (0x00000010)
+#define CP_REG_SET_cbc(data)                                                         (0x00000010&((data)<<4))
+#define CP_REG_SET_cbc_src(data)                                                     ((0x00000010&(data))>>4)
+#define CP_REG_SET_get_cbc(data)                                                     ((0x00000010&(data))>>4)
+#define CP_REG_SET_write_enable1_shift                                               (3)
+#define CP_REG_SET_write_enable1_mask                                                (0x00000008)
+#define CP_REG_SET_write_enable1(data)                                               (0x00000008&((data)<<3))
+#define CP_REG_SET_write_enable1_src(data)                                           ((0x00000008&(data))>>3)
+#define CP_REG_SET_get_write_enable1(data)                                           ((0x00000008&(data))>>3)
+#define CP_REG_SET_reg_first_shift                                                   (2)
+#define CP_REG_SET_reg_first_mask                                                    (0x00000004)
+#define CP_REG_SET_reg_first(data)                                                   (0x00000004&((data)<<2))
+#define CP_REG_SET_reg_first_src(data)                                               ((0x00000004&(data))>>2)
+#define CP_REG_SET_get_reg_first(data)                                               ((0x00000004&(data))>>2)
+#define CP_REG_SET_write_enable0_shift                                               (1)
+#define CP_REG_SET_write_enable0_mask                                                (0x00000002)
+#define CP_REG_SET_write_enable0(data)                                               (0x00000002&((data)<<1))
+#define CP_REG_SET_write_enable0_src(data)                                           ((0x00000002&(data))>>1)
+#define CP_REG_SET_get_write_enable0(data)                                           ((0x00000002&(data))>>1)
+#define CP_REG_SET_reg_ende_shift                                                    (0)
+#define CP_REG_SET_reg_ende_mask                                                     (0x00000001)
+#define CP_REG_SET_reg_ende(data)                                                    (0x00000001&((data)<<0))
+#define CP_REG_SET_reg_ende_src(data)                                                ((0x00000001&(data))>>0)
+#define CP_REG_SET_get_reg_ende(data)                                                ((0x00000001&(data))>>0)
+
+
+#define CP_REG_SET1                                                                  0x18015078
+#define CP_REG_SET1_reg_addr                                                         "0xB8015078"
+#define CP_REG_SET1_reg                                                              0xB8015078
+#define set_CP_REG_SET1_reg(data)   (*((volatile unsigned int*) CP_REG_SET1_reg)=data)
+#define get_CP_REG_SET1_reg   (*((volatile unsigned int*) CP_REG_SET1_reg))
+#define CP_REG_SET1_inst_adr                                                         "0x001E"
+#define CP_REG_SET1_inst                                                             0x001E
+#define CP_REG_SET1_dataout_byte_swap_shift                                          (13)
+#define CP_REG_SET1_dataout_byte_swap_mask                                           (0x00002000)
+#define CP_REG_SET1_dataout_byte_swap(data)                                          (0x00002000&((data)<<13))
+#define CP_REG_SET1_dataout_byte_swap_src(data)                                      ((0x00002000&(data))>>13)
+#define CP_REG_SET1_get_dataout_byte_swap(data)                                      ((0x00002000&(data))>>13)
+#define CP_REG_SET1_datain_byte_swap_shift                                           (12)
+#define CP_REG_SET1_datain_byte_swap_mask                                            (0x00001000)
+#define CP_REG_SET1_datain_byte_swap(data)                                           (0x00001000&((data)<<12))
+#define CP_REG_SET1_datain_byte_swap_src(data)                                       ((0x00001000&(data))>>12)
+#define CP_REG_SET1_get_datain_byte_swap(data)                                       ((0x00001000&(data))>>12)
+#define CP_REG_SET1_iv_byte_swap_shift                                               (11)
+#define CP_REG_SET1_iv_byte_swap_mask                                                (0x00000800)
+#define CP_REG_SET1_iv_byte_swap(data)                                               (0x00000800&((data)<<11))
+#define CP_REG_SET1_iv_byte_swap_src(data)                                           ((0x00000800&(data))>>11)
+#define CP_REG_SET1_get_iv_byte_swap(data)                                           ((0x00000800&(data))>>11)
+#define CP_REG_SET1_key_byte_swap_shift                                              (10)
+#define CP_REG_SET1_key_byte_swap_mask                                               (0x00000400)
+#define CP_REG_SET1_key_byte_swap(data)                                              (0x00000400&((data)<<10))
+#define CP_REG_SET1_key_byte_swap_src(data)                                          ((0x00000400&(data))>>10)
+#define CP_REG_SET1_get_key_byte_swap(data)                                          ((0x00000400&(data))>>10)
+#define CP_REG_SET1_des_key_order_shift                                              (9)
+#define CP_REG_SET1_des_key_order_mask                                               (0x00000200)
+#define CP_REG_SET1_des_key_order(data)                                              (0x00000200&((data)<<9))
+#define CP_REG_SET1_des_key_order_src(data)                                          ((0x00000200&(data))>>9)
+#define CP_REG_SET1_get_des_key_order(data)                                          ((0x00000200&(data))>>9)
+#define CP_REG_SET1_key_mode_shift                                                   (6)
+#define CP_REG_SET1_key_mode_mask                                                    (0x000000C0)
+#define CP_REG_SET1_key_mode(data)                                                   (0x000000C0&((data)<<6))
+#define CP_REG_SET1_key_mode_src(data)                                               ((0x000000C0&(data))>>6)
+#define CP_REG_SET1_get_key_mode(data)                                               ((0x000000C0&(data))>>6)
+#define CP_REG_SET1_iv_mode_shift                                                    (4)
+#define CP_REG_SET1_iv_mode_mask                                                     (0x00000030)
+#define CP_REG_SET1_iv_mode(data)                                                    (0x00000030&((data)<<4))
+#define CP_REG_SET1_iv_mode_src(data)                                                ((0x00000030&(data))>>4)
+#define CP_REG_SET1_get_iv_mode(data)                                                ((0x00000030&(data))>>4)
+#define CP_REG_SET1_input_mode_shift                                                 (2)
+#define CP_REG_SET1_input_mode_mask                                                  (0x0000000C)
+#define CP_REG_SET1_input_mode(data)                                                 (0x0000000C&((data)<<2))
+#define CP_REG_SET1_input_mode_src(data)                                             ((0x0000000C&(data))>>2)
+#define CP_REG_SET1_get_input_mode(data)                                             ((0x0000000C&(data))>>2)
+#define CP_REG_SET1_output_mode_shift                                                (0)
+#define CP_REG_SET1_output_mode_mask                                                 (0x00000003)
+#define CP_REG_SET1_output_mode(data)                                                (0x00000003&((data)<<0))
+#define CP_REG_SET1_output_mode_src(data)                                            ((0x00000003&(data))>>0)
+#define CP_REG_SET1_get_output_mode(data)                                            ((0x00000003&(data))>>0)
+
+
+#define CP_REG_SET2                                                                  0x1801507c
+#define CP_REG_SET2_reg_addr                                                         "0xB801507C"
+#define CP_REG_SET2_reg                                                              0xB801507C
+#define set_CP_REG_SET2_reg(data)   (*((volatile unsigned int*) CP_REG_SET2_reg)=data)
+#define get_CP_REG_SET2_reg   (*((volatile unsigned int*) CP_REG_SET2_reg))
+#define CP_REG_SET2_inst_adr                                                         "0x001F"
+#define CP_REG_SET2_inst                                                             0x001F
+#define CP_REG_SET2_output_entry_shift                                               (24)
+#define CP_REG_SET2_output_entry_mask                                                (0x7F000000)
+#define CP_REG_SET2_output_entry(data)                                               (0x7F000000&((data)<<24))
+#define CP_REG_SET2_output_entry_src(data)                                           ((0x7F000000&(data))>>24)
+#define CP_REG_SET2_get_output_entry(data)                                           ((0x7F000000&(data))>>24)
+#define CP_REG_SET2_input_entry_shift                                                (16)
+#define CP_REG_SET2_input_entry_mask                                                 (0x007F0000)
+#define CP_REG_SET2_input_entry(data)                                                (0x007F0000&((data)<<16))
+#define CP_REG_SET2_input_entry_src(data)                                            ((0x007F0000&(data))>>16)
+#define CP_REG_SET2_get_input_entry(data)                                            ((0x007F0000&(data))>>16)
+#define CP_REG_SET2_key_entry_shift                                                  (8)
+#define CP_REG_SET2_key_entry_mask                                                   (0x00007F00)
+#define CP_REG_SET2_key_entry(data)                                                  (0x00007F00&((data)<<8))
+#define CP_REG_SET2_key_entry_src(data)                                              ((0x00007F00&(data))>>8)
+#define CP_REG_SET2_get_key_entry(data)                                              ((0x00007F00&(data))>>8)
+#define CP_REG_SET2_iv_entry_shift                                                   (0)
+#define CP_REG_SET2_iv_entry_mask                                                    (0x0000007F)
+#define CP_REG_SET2_iv_entry(data)                                                   (0x0000007F&((data)<<0))
+#define CP_REG_SET2_iv_entry_src(data)                                               ((0x0000007F&(data))>>0)
+#define CP_REG_SET2_get_iv_entry(data)                                               ((0x0000007F&(data))>>0)
+
+
+#define CP_REG_KEY_1_0                                                               0x180150F0
+#define CP_REG_KEY_1_1                                                               0x180150F4
+#define CP_REG_KEY_1_2                                                               0x180150F8
+#define CP_REG_KEY_1_3                                                               0x180150FC
+#define CP_REG_KEY_1_0_reg_addr                                                      "0xB80150F0"
+#define CP_REG_KEY_1_1_reg_addr                                                      "0xB80150F4"
+#define CP_REG_KEY_1_2_reg_addr                                                      "0xB80150F8"
+#define CP_REG_KEY_1_3_reg_addr                                                      "0xB80150FC"
+#define CP_REG_KEY_1_0_reg                                                           0xB80150F0
+#define CP_REG_KEY_1_1_reg                                                           0xB80150F4
+#define CP_REG_KEY_1_2_reg                                                           0xB80150F8
+#define CP_REG_KEY_1_3_reg                                                           0xB80150FC
+#define set_CP_REG_KEY_1_0_reg(data)   (*((volatile unsigned int*) CP_REG_KEY_1_0_reg)=data)
+#define set_CP_REG_KEY_1_1_reg(data)   (*((volatile unsigned int*) CP_REG_KEY_1_1_reg)=data)
+#define set_CP_REG_KEY_1_2_reg(data)   (*((volatile unsigned int*) CP_REG_KEY_1_2_reg)=data)
+#define set_CP_REG_KEY_1_3_reg(data)   (*((volatile unsigned int*) CP_REG_KEY_1_3_reg)=data)
+#define get_CP_REG_KEY_1_0_reg   (*((volatile unsigned int*) CP_REG_KEY_1_0_reg))
+#define get_CP_REG_KEY_1_1_reg   (*((volatile unsigned int*) CP_REG_KEY_1_1_reg))
+#define get_CP_REG_KEY_1_2_reg   (*((volatile unsigned int*) CP_REG_KEY_1_2_reg))
+#define get_CP_REG_KEY_1_3_reg   (*((volatile unsigned int*) CP_REG_KEY_1_3_reg))
+#define CP_REG_KEY_1_0_inst_adr                                                      "0x003C"
+#define CP_REG_KEY_1_1_inst_adr                                                      "0x003D"
+#define CP_REG_KEY_1_2_inst_adr                                                      "0x003E"
+#define CP_REG_KEY_1_3_inst_adr                                                      "0x003F"
+#define CP_REG_KEY_1_0_inst                                                          0x003C
+#define CP_REG_KEY_1_1_inst                                                          0x003D
+#define CP_REG_KEY_1_2_inst                                                          0x003E
+#define CP_REG_KEY_1_3_inst                                                          0x003F
+#define CP_REG_KEY_1_data_shift                                                      (0)
+#define CP_REG_KEY_1_data_mask                                                       (0xFFFFFFFF)
+#define CP_REG_KEY_1_data(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define CP_REG_KEY_1_data_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define CP_REG_KEY_1_get_data(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_SCTCH                                                                     0x18015080
+#define CP_SCTCH_reg_addr                                                            "0xB8015080"
+#define CP_SCTCH_reg                                                                 0xB8015080
+#define set_CP_SCTCH_reg(data)   (*((volatile unsigned int*) CP_SCTCH_reg)=data)
+#define get_CP_SCTCH_reg   (*((volatile unsigned int*) CP_SCTCH_reg))
+#define CP_SCTCH_inst_adr                                                            "0x0020"
+#define CP_SCTCH_inst                                                                0x0020
+#define CP_SCTCH_reg1_shift                                                          (16)
+#define CP_SCTCH_reg1_mask                                                           (0xFFFF0000)
+#define CP_SCTCH_reg1(data)                                                          (0xFFFF0000&((data)<<16))
+#define CP_SCTCH_reg1_src(data)                                                      ((0xFFFF0000&(data))>>16)
+#define CP_SCTCH_get_reg1(data)                                                      ((0xFFFF0000&(data))>>16)
+#define CP_SCTCH_reg0_shift                                                          (1)
+#define CP_SCTCH_reg0_mask                                                           (0x0000FFFE)
+#define CP_SCTCH_reg0(data)                                                          (0x0000FFFE&((data)<<1))
+#define CP_SCTCH_reg0_src(data)                                                      ((0x0000FFFE&(data))>>1)
+#define CP_SCTCH_get_reg0(data)                                                      ((0x0000FFFE&(data))>>1)
+#define CP_SCTCH_eco_des_iv_shift                                                    (0)
+#define CP_SCTCH_eco_des_iv_mask                                                     (0x00000001)
+#define CP_SCTCH_eco_des_iv(data)                                                    (0x00000001&((data)<<0))
+#define CP_SCTCH_eco_des_iv_src(data)                                                ((0x00000001&(data))>>0)
+#define CP_SCTCH_get_eco_des_iv(data)                                                ((0x00000001&(data))>>0)
+
+
+#define CP_NF_KEY_0                                                                  0x18015084
+#define CP_NF_KEY_1                                                                  0x18015088
+#define CP_NF_KEY_2                                                                  0x1801508C
+#define CP_NF_KEY_3                                                                  0x18015090
+#define CP_NF_KEY_0_reg_addr                                                         "0xB8015084"
+#define CP_NF_KEY_1_reg_addr                                                         "0xB8015088"
+#define CP_NF_KEY_2_reg_addr                                                         "0xB801508C"
+#define CP_NF_KEY_3_reg_addr                                                         "0xB8015090"
+#define CP_NF_KEY_0_reg                                                              0xB8015084
+#define CP_NF_KEY_1_reg                                                              0xB8015088
+#define CP_NF_KEY_2_reg                                                              0xB801508C
+#define CP_NF_KEY_3_reg                                                              0xB8015090
+#define set_CP_NF_KEY_0_reg(data)   (*((volatile unsigned int*) CP_NF_KEY_0_reg)=data)
+#define set_CP_NF_KEY_1_reg(data)   (*((volatile unsigned int*) CP_NF_KEY_1_reg)=data)
+#define set_CP_NF_KEY_2_reg(data)   (*((volatile unsigned int*) CP_NF_KEY_2_reg)=data)
+#define set_CP_NF_KEY_3_reg(data)   (*((volatile unsigned int*) CP_NF_KEY_3_reg)=data)
+#define get_CP_NF_KEY_0_reg   (*((volatile unsigned int*) CP_NF_KEY_0_reg))
+#define get_CP_NF_KEY_1_reg   (*((volatile unsigned int*) CP_NF_KEY_1_reg))
+#define get_CP_NF_KEY_2_reg   (*((volatile unsigned int*) CP_NF_KEY_2_reg))
+#define get_CP_NF_KEY_3_reg   (*((volatile unsigned int*) CP_NF_KEY_3_reg))
+#define CP_NF_KEY_0_inst_adr                                                         "0x0021"
+#define CP_NF_KEY_1_inst_adr                                                         "0x0022"
+#define CP_NF_KEY_2_inst_adr                                                         "0x0023"
+#define CP_NF_KEY_3_inst_adr                                                         "0x0024"
+#define CP_NF_KEY_0_inst                                                             0x0021
+#define CP_NF_KEY_1_inst                                                             0x0022
+#define CP_NF_KEY_2_inst                                                             0x0023
+#define CP_NF_KEY_3_inst                                                             0x0024
+#define CP_NF_KEY_data_shift                                                         (0)
+#define CP_NF_KEY_data_mask                                                          (0xFFFFFFFF)
+#define CP_NF_KEY_data(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define CP_NF_KEY_data_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define CP_NF_KEY_get_data(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_NF_INI_KEY_0                                                              0x18015094
+#define CP_NF_INI_KEY_1                                                              0x18015098
+#define CP_NF_INI_KEY_2                                                              0x1801509C
+#define CP_NF_INI_KEY_3                                                              0x180150A0
+#define CP_NF_INI_KEY_0_reg_addr                                                     "0xB8015094"
+#define CP_NF_INI_KEY_1_reg_addr                                                     "0xB8015098"
+#define CP_NF_INI_KEY_2_reg_addr                                                     "0xB801509C"
+#define CP_NF_INI_KEY_3_reg_addr                                                     "0xB80150A0"
+#define CP_NF_INI_KEY_0_reg                                                          0xB8015094
+#define CP_NF_INI_KEY_1_reg                                                          0xB8015098
+#define CP_NF_INI_KEY_2_reg                                                          0xB801509C
+#define CP_NF_INI_KEY_3_reg                                                          0xB80150A0
+#define set_CP_NF_INI_KEY_0_reg(data)   (*((volatile unsigned int*) CP_NF_INI_KEY_0_reg)=data)
+#define set_CP_NF_INI_KEY_1_reg(data)   (*((volatile unsigned int*) CP_NF_INI_KEY_1_reg)=data)
+#define set_CP_NF_INI_KEY_2_reg(data)   (*((volatile unsigned int*) CP_NF_INI_KEY_2_reg)=data)
+#define set_CP_NF_INI_KEY_3_reg(data)   (*((volatile unsigned int*) CP_NF_INI_KEY_3_reg)=data)
+#define get_CP_NF_INI_KEY_0_reg   (*((volatile unsigned int*) CP_NF_INI_KEY_0_reg))
+#define get_CP_NF_INI_KEY_1_reg   (*((volatile unsigned int*) CP_NF_INI_KEY_1_reg))
+#define get_CP_NF_INI_KEY_2_reg   (*((volatile unsigned int*) CP_NF_INI_KEY_2_reg))
+#define get_CP_NF_INI_KEY_3_reg   (*((volatile unsigned int*) CP_NF_INI_KEY_3_reg))
+#define CP_NF_INI_KEY_0_inst_adr                                                     "0x0025"
+#define CP_NF_INI_KEY_1_inst_adr                                                     "0x0026"
+#define CP_NF_INI_KEY_2_inst_adr                                                     "0x0027"
+#define CP_NF_INI_KEY_3_inst_adr                                                     "0x0028"
+#define CP_NF_INI_KEY_0_inst                                                         0x0025
+#define CP_NF_INI_KEY_1_inst                                                         0x0026
+#define CP_NF_INI_KEY_2_inst                                                         0x0027
+#define CP_NF_INI_KEY_3_inst                                                         0x0028
+#define CP_NF_INI_KEY_data_shift                                                     (0)
+#define CP_NF_INI_KEY_data_mask                                                      (0xFFFFFFFF)
+#define CP_NF_INI_KEY_data(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define CP_NF_INI_KEY_data_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define CP_NF_INI_KEY_get_data(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_NF_SET                                                                    0x180150a4
+#define CP_NF_SET_reg_addr                                                           "0xB80150A4"
+#define CP_NF_SET_reg                                                                0xB80150A4
+#define set_CP_NF_SET_reg(data)   (*((volatile unsigned int*) CP_NF_SET_reg)=data)
+#define get_CP_NF_SET_reg   (*((volatile unsigned int*) CP_NF_SET_reg))
+#define CP_NF_SET_inst_adr                                                           "0x0029"
+#define CP_NF_SET_inst                                                               0x0029
+#define CP_NF_SET_otp_sel_shift                                                      (13)
+#define CP_NF_SET_otp_sel_mask                                                       (0x00006000)
+#define CP_NF_SET_otp_sel(data)                                                      (0x00006000&((data)<<13))
+#define CP_NF_SET_otp_sel_src(data)                                                  ((0x00006000&(data))>>13)
+#define CP_NF_SET_get_otp_sel(data)                                                  ((0x00006000&(data))>>13)
+#define CP_NF_SET_aes_mode_shift                                                     (11)
+#define CP_NF_SET_aes_mode_mask                                                      (0x00001800)
+#define CP_NF_SET_aes_mode(data)                                                     (0x00001800&((data)<<11))
+#define CP_NF_SET_aes_mode_src(data)                                                 ((0x00001800&(data))>>11)
+#define CP_NF_SET_get_aes_mode(data)                                                 ((0x00001800&(data))>>11)
+#define CP_NF_SET_bcm_shift                                                          (9)
+#define CP_NF_SET_bcm_mask                                                           (0x00000600)
+#define CP_NF_SET_bcm(data)                                                          (0x00000600&((data)<<9))
+#define CP_NF_SET_bcm_src(data)                                                      ((0x00000600&(data))>>9)
+#define CP_NF_SET_get_bcm(data)                                                      ((0x00000600&(data))>>9)
+#define CP_NF_SET_cw_entry_shift                                                     (2)
+#define CP_NF_SET_cw_entry_mask                                                      (0x000001FC)
+#define CP_NF_SET_cw_entry(data)                                                     (0x000001FC&((data)<<2))
+#define CP_NF_SET_cw_entry_src(data)                                                 ((0x000001FC&(data))>>2)
+#define CP_NF_SET_get_cw_entry(data)                                                 ((0x000001FC&(data))>>2)
+#define CP_NF_SET_sel_shift                                                          (0)
+#define CP_NF_SET_sel_mask                                                           (0x00000003)
+#define CP_NF_SET_sel(data)                                                          (0x00000003&((data)<<0))
+#define CP_NF_SET_sel_src(data)                                                      ((0x00000003&(data))>>0)
+#define CP_NF_SET_get_sel(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define CP_NF_KEY_1_0                                                                0x180150E0
+#define CP_NF_KEY_1_1                                                                0x180150E4
+#define CP_NF_KEY_1_2                                                                0x180150E8
+#define CP_NF_KEY_1_3                                                                0x180150EC
+#define CP_NF_KEY_1_0_reg_addr                                                       "0xB80150E0"
+#define CP_NF_KEY_1_1_reg_addr                                                       "0xB80150E4"
+#define CP_NF_KEY_1_2_reg_addr                                                       "0xB80150E8"
+#define CP_NF_KEY_1_3_reg_addr                                                       "0xB80150EC"
+#define CP_NF_KEY_1_0_reg                                                            0xB80150E0
+#define CP_NF_KEY_1_1_reg                                                            0xB80150E4
+#define CP_NF_KEY_1_2_reg                                                            0xB80150E8
+#define CP_NF_KEY_1_3_reg                                                            0xB80150EC
+#define set_CP_NF_KEY_1_0_reg(data)   (*((volatile unsigned int*) CP_NF_KEY_1_0_reg)=data)
+#define set_CP_NF_KEY_1_1_reg(data)   (*((volatile unsigned int*) CP_NF_KEY_1_1_reg)=data)
+#define set_CP_NF_KEY_1_2_reg(data)   (*((volatile unsigned int*) CP_NF_KEY_1_2_reg)=data)
+#define set_CP_NF_KEY_1_3_reg(data)   (*((volatile unsigned int*) CP_NF_KEY_1_3_reg)=data)
+#define get_CP_NF_KEY_1_0_reg   (*((volatile unsigned int*) CP_NF_KEY_1_0_reg))
+#define get_CP_NF_KEY_1_1_reg   (*((volatile unsigned int*) CP_NF_KEY_1_1_reg))
+#define get_CP_NF_KEY_1_2_reg   (*((volatile unsigned int*) CP_NF_KEY_1_2_reg))
+#define get_CP_NF_KEY_1_3_reg   (*((volatile unsigned int*) CP_NF_KEY_1_3_reg))
+#define CP_NF_KEY_1_0_inst_adr                                                       "0x0038"
+#define CP_NF_KEY_1_1_inst_adr                                                       "0x0039"
+#define CP_NF_KEY_1_2_inst_adr                                                       "0x003A"
+#define CP_NF_KEY_1_3_inst_adr                                                       "0x003B"
+#define CP_NF_KEY_1_0_inst                                                           0x0038
+#define CP_NF_KEY_1_1_inst                                                           0x0039
+#define CP_NF_KEY_1_2_inst                                                           0x003A
+#define CP_NF_KEY_1_3_inst                                                           0x003B
+#define CP_NF_KEY_1_data_shift                                                       (0)
+#define CP_NF_KEY_1_data_mask                                                        (0xFFFFFFFF)
+#define CP_NF_KEY_1_data(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define CP_NF_KEY_1_data_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define CP_NF_KEY_1_get_data(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_MD_KEY_0                                                                  0x180150A8
+#define CP_MD_KEY_1                                                                  0x180150AC
+#define CP_MD_KEY_2                                                                  0x180150B0
+#define CP_MD_KEY_3                                                                  0x180150B4
+#define CP_MD_KEY_0_reg_addr                                                         "0xB80150A8"
+#define CP_MD_KEY_1_reg_addr                                                         "0xB80150AC"
+#define CP_MD_KEY_2_reg_addr                                                         "0xB80150B0"
+#define CP_MD_KEY_3_reg_addr                                                         "0xB80150B4"
+#define CP_MD_KEY_0_reg                                                              0xB80150A8
+#define CP_MD_KEY_1_reg                                                              0xB80150AC
+#define CP_MD_KEY_2_reg                                                              0xB80150B0
+#define CP_MD_KEY_3_reg                                                              0xB80150B4
+#define set_CP_MD_KEY_0_reg(data)   (*((volatile unsigned int*) CP_MD_KEY_0_reg)=data)
+#define set_CP_MD_KEY_1_reg(data)   (*((volatile unsigned int*) CP_MD_KEY_1_reg)=data)
+#define set_CP_MD_KEY_2_reg(data)   (*((volatile unsigned int*) CP_MD_KEY_2_reg)=data)
+#define set_CP_MD_KEY_3_reg(data)   (*((volatile unsigned int*) CP_MD_KEY_3_reg)=data)
+#define get_CP_MD_KEY_0_reg   (*((volatile unsigned int*) CP_MD_KEY_0_reg))
+#define get_CP_MD_KEY_1_reg   (*((volatile unsigned int*) CP_MD_KEY_1_reg))
+#define get_CP_MD_KEY_2_reg   (*((volatile unsigned int*) CP_MD_KEY_2_reg))
+#define get_CP_MD_KEY_3_reg   (*((volatile unsigned int*) CP_MD_KEY_3_reg))
+#define CP_MD_KEY_0_inst_adr                                                         "0x002A"
+#define CP_MD_KEY_1_inst_adr                                                         "0x002B"
+#define CP_MD_KEY_2_inst_adr                                                         "0x002C"
+#define CP_MD_KEY_3_inst_adr                                                         "0x002D"
+#define CP_MD_KEY_0_inst                                                             0x002A
+#define CP_MD_KEY_1_inst                                                             0x002B
+#define CP_MD_KEY_2_inst                                                             0x002C
+#define CP_MD_KEY_3_inst                                                             0x002D
+#define CP_MD_KEY_data_shift                                                         (0)
+#define CP_MD_KEY_data_mask                                                          (0xFFFFFFFF)
+#define CP_MD_KEY_data(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define CP_MD_KEY_data_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define CP_MD_KEY_get_data(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_MD_INI_KEY_0                                                              0x180150B8
+#define CP_MD_INI_KEY_1                                                              0x180150BC
+#define CP_MD_INI_KEY_2                                                              0x180150C0
+#define CP_MD_INI_KEY_3                                                              0x180150C4
+#define CP_MD_INI_KEY_0_reg_addr                                                     "0xB80150B8"
+#define CP_MD_INI_KEY_1_reg_addr                                                     "0xB80150BC"
+#define CP_MD_INI_KEY_2_reg_addr                                                     "0xB80150C0"
+#define CP_MD_INI_KEY_3_reg_addr                                                     "0xB80150C4"
+#define CP_MD_INI_KEY_0_reg                                                          0xB80150B8
+#define CP_MD_INI_KEY_1_reg                                                          0xB80150BC
+#define CP_MD_INI_KEY_2_reg                                                          0xB80150C0
+#define CP_MD_INI_KEY_3_reg                                                          0xB80150C4
+#define set_CP_MD_INI_KEY_0_reg(data)   (*((volatile unsigned int*) CP_MD_INI_KEY_0_reg)=data)
+#define set_CP_MD_INI_KEY_1_reg(data)   (*((volatile unsigned int*) CP_MD_INI_KEY_1_reg)=data)
+#define set_CP_MD_INI_KEY_2_reg(data)   (*((volatile unsigned int*) CP_MD_INI_KEY_2_reg)=data)
+#define set_CP_MD_INI_KEY_3_reg(data)   (*((volatile unsigned int*) CP_MD_INI_KEY_3_reg)=data)
+#define get_CP_MD_INI_KEY_0_reg   (*((volatile unsigned int*) CP_MD_INI_KEY_0_reg))
+#define get_CP_MD_INI_KEY_1_reg   (*((volatile unsigned int*) CP_MD_INI_KEY_1_reg))
+#define get_CP_MD_INI_KEY_2_reg   (*((volatile unsigned int*) CP_MD_INI_KEY_2_reg))
+#define get_CP_MD_INI_KEY_3_reg   (*((volatile unsigned int*) CP_MD_INI_KEY_3_reg))
+#define CP_MD_INI_KEY_0_inst_adr                                                     "0x002E"
+#define CP_MD_INI_KEY_1_inst_adr                                                     "0x002F"
+#define CP_MD_INI_KEY_2_inst_adr                                                     "0x0030"
+#define CP_MD_INI_KEY_3_inst_adr                                                     "0x0031"
+#define CP_MD_INI_KEY_0_inst                                                         0x002E
+#define CP_MD_INI_KEY_1_inst                                                         0x002F
+#define CP_MD_INI_KEY_2_inst                                                         0x0030
+#define CP_MD_INI_KEY_3_inst                                                         0x0031
+#define CP_MD_INI_KEY_data_shift                                                     (0)
+#define CP_MD_INI_KEY_data_mask                                                      (0xFFFFFFFF)
+#define CP_MD_INI_KEY_data(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define CP_MD_INI_KEY_data_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define CP_MD_INI_KEY_get_data(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_MD_SET                                                                    0x180150c8
+#define CP_MD_SET_reg_addr                                                           "0xB80150C8"
+#define CP_MD_SET_reg                                                                0xB80150C8
+#define set_CP_MD_SET_reg(data)   (*((volatile unsigned int*) CP_MD_SET_reg)=data)
+#define get_CP_MD_SET_reg   (*((volatile unsigned int*) CP_MD_SET_reg))
+#define CP_MD_SET_inst_adr                                                           "0x0032"
+#define CP_MD_SET_inst                                                               0x0032
+#define CP_MD_SET_otp_sel_shift                                                      (13)
+#define CP_MD_SET_otp_sel_mask                                                       (0x00006000)
+#define CP_MD_SET_otp_sel(data)                                                      (0x00006000&((data)<<13))
+#define CP_MD_SET_otp_sel_src(data)                                                  ((0x00006000&(data))>>13)
+#define CP_MD_SET_get_otp_sel(data)                                                  ((0x00006000&(data))>>13)
+#define CP_MD_SET_aes_mode_shift                                                     (11)
+#define CP_MD_SET_aes_mode_mask                                                      (0x00001800)
+#define CP_MD_SET_aes_mode(data)                                                     (0x00001800&((data)<<11))
+#define CP_MD_SET_aes_mode_src(data)                                                 ((0x00001800&(data))>>11)
+#define CP_MD_SET_get_aes_mode(data)                                                 ((0x00001800&(data))>>11)
+#define CP_MD_SET_bcm_shift                                                          (9)
+#define CP_MD_SET_bcm_mask                                                           (0x00000600)
+#define CP_MD_SET_bcm(data)                                                          (0x00000600&((data)<<9))
+#define CP_MD_SET_bcm_src(data)                                                      ((0x00000600&(data))>>9)
+#define CP_MD_SET_get_bcm(data)                                                      ((0x00000600&(data))>>9)
+#define CP_MD_SET_cw_entry_shift                                                     (2)
+#define CP_MD_SET_cw_entry_mask                                                      (0x000001FC)
+#define CP_MD_SET_cw_entry(data)                                                     (0x000001FC&((data)<<2))
+#define CP_MD_SET_cw_entry_src(data)                                                 ((0x000001FC&(data))>>2)
+#define CP_MD_SET_get_cw_entry(data)                                                 ((0x000001FC&(data))>>2)
+#define CP_MD_SET_sel_shift                                                          (0)
+#define CP_MD_SET_sel_mask                                                           (0x00000003)
+#define CP_MD_SET_sel(data)                                                          (0x00000003&((data)<<0))
+#define CP_MD_SET_sel_src(data)                                                      ((0x00000003&(data))>>0)
+#define CP_MD_SET_get_sel(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define CP_MD_KEY_1_0                                                                0x180150D0
+#define CP_MD_KEY_1_1                                                                0x180150D4
+#define CP_MD_KEY_1_2                                                                0x180150D8
+#define CP_MD_KEY_1_3                                                                0x180150DC
+#define CP_MD_KEY_1_0_reg_addr                                                       "0xB80150D0"
+#define CP_MD_KEY_1_1_reg_addr                                                       "0xB80150D4"
+#define CP_MD_KEY_1_2_reg_addr                                                       "0xB80150D8"
+#define CP_MD_KEY_1_3_reg_addr                                                       "0xB80150DC"
+#define CP_MD_KEY_1_0_reg                                                            0xB80150D0
+#define CP_MD_KEY_1_1_reg                                                            0xB80150D4
+#define CP_MD_KEY_1_2_reg                                                            0xB80150D8
+#define CP_MD_KEY_1_3_reg                                                            0xB80150DC
+#define set_CP_MD_KEY_1_0_reg(data)   (*((volatile unsigned int*) CP_MD_KEY_1_0_reg)=data)
+#define set_CP_MD_KEY_1_1_reg(data)   (*((volatile unsigned int*) CP_MD_KEY_1_1_reg)=data)
+#define set_CP_MD_KEY_1_2_reg(data)   (*((volatile unsigned int*) CP_MD_KEY_1_2_reg)=data)
+#define set_CP_MD_KEY_1_3_reg(data)   (*((volatile unsigned int*) CP_MD_KEY_1_3_reg)=data)
+#define get_CP_MD_KEY_1_0_reg   (*((volatile unsigned int*) CP_MD_KEY_1_0_reg))
+#define get_CP_MD_KEY_1_1_reg   (*((volatile unsigned int*) CP_MD_KEY_1_1_reg))
+#define get_CP_MD_KEY_1_2_reg   (*((volatile unsigned int*) CP_MD_KEY_1_2_reg))
+#define get_CP_MD_KEY_1_3_reg   (*((volatile unsigned int*) CP_MD_KEY_1_3_reg))
+#define CP_MD_KEY_1_0_inst_adr                                                       "0x0034"
+#define CP_MD_KEY_1_1_inst_adr                                                       "0x0035"
+#define CP_MD_KEY_1_2_inst_adr                                                       "0x0036"
+#define CP_MD_KEY_1_3_inst_adr                                                       "0x0037"
+#define CP_MD_KEY_1_0_inst                                                           0x0034
+#define CP_MD_KEY_1_1_inst                                                           0x0035
+#define CP_MD_KEY_1_2_inst                                                           0x0036
+#define CP_MD_KEY_1_3_inst                                                           0x0037
+#define CP_MD_KEY_1_data_shift                                                       (0)
+#define CP_MD_KEY_1_data_mask                                                        (0xFFFFFFFF)
+#define CP_MD_KEY_1_data(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define CP_MD_KEY_1_data_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define CP_MD_KEY_1_get_data(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_CP_REG_KEY_0                                                               0x18015834
+#define K_CP_REG_KEY_1                                                               0x18015838
+#define K_CP_REG_KEY_2                                                               0x1801583C
+#define K_CP_REG_KEY_3                                                               0x18015840
+#define K_CP_REG_KEY_0_reg_addr                                                      "0xB8015834"
+#define K_CP_REG_KEY_1_reg_addr                                                      "0xB8015838"
+#define K_CP_REG_KEY_2_reg_addr                                                      "0xB801583C"
+#define K_CP_REG_KEY_3_reg_addr                                                      "0xB8015840"
+#define K_CP_REG_KEY_0_reg                                                           0xB8015834
+#define K_CP_REG_KEY_1_reg                                                           0xB8015838
+#define K_CP_REG_KEY_2_reg                                                           0xB801583C
+#define K_CP_REG_KEY_3_reg                                                           0xB8015840
+#define set_K_CP_REG_KEY_0_reg(data)   (*((volatile unsigned int*) K_CP_REG_KEY_0_reg)=data)
+#define set_K_CP_REG_KEY_1_reg(data)   (*((volatile unsigned int*) K_CP_REG_KEY_1_reg)=data)
+#define set_K_CP_REG_KEY_2_reg(data)   (*((volatile unsigned int*) K_CP_REG_KEY_2_reg)=data)
+#define set_K_CP_REG_KEY_3_reg(data)   (*((volatile unsigned int*) K_CP_REG_KEY_3_reg)=data)
+#define get_K_CP_REG_KEY_0_reg   (*((volatile unsigned int*) K_CP_REG_KEY_0_reg))
+#define get_K_CP_REG_KEY_1_reg   (*((volatile unsigned int*) K_CP_REG_KEY_1_reg))
+#define get_K_CP_REG_KEY_2_reg   (*((volatile unsigned int*) K_CP_REG_KEY_2_reg))
+#define get_K_CP_REG_KEY_3_reg   (*((volatile unsigned int*) K_CP_REG_KEY_3_reg))
+#define K_CP_REG_KEY_0_inst_adr                                                      "0x000D"
+#define K_CP_REG_KEY_1_inst_adr                                                      "0x000E"
+#define K_CP_REG_KEY_2_inst_adr                                                      "0x000F"
+#define K_CP_REG_KEY_3_inst_adr                                                      "0x0010"
+#define K_CP_REG_KEY_0_inst                                                          0x000D
+#define K_CP_REG_KEY_1_inst                                                          0x000E
+#define K_CP_REG_KEY_2_inst                                                          0x000F
+#define K_CP_REG_KEY_3_inst                                                          0x0010
+#define K_CP_REG_KEY_data_shift                                                      (0)
+#define K_CP_REG_KEY_data_mask                                                       (0xFFFFFFFF)
+#define K_CP_REG_KEY_data(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define K_CP_REG_KEY_data_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define K_CP_REG_KEY_get_data(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_CP_REG_DATAIN_0                                                            0x18015844
+#define K_CP_REG_DATAIN_1                                                            0x18015848
+#define K_CP_REG_DATAIN_2                                                            0x1801584C
+#define K_CP_REG_DATAIN_3                                                            0x18015850
+#define K_CP_REG_DATAIN_0_reg_addr                                                   "0xB8015844"
+#define K_CP_REG_DATAIN_1_reg_addr                                                   "0xB8015848"
+#define K_CP_REG_DATAIN_2_reg_addr                                                   "0xB801584C"
+#define K_CP_REG_DATAIN_3_reg_addr                                                   "0xB8015850"
+#define K_CP_REG_DATAIN_0_reg                                                        0xB8015844
+#define K_CP_REG_DATAIN_1_reg                                                        0xB8015848
+#define K_CP_REG_DATAIN_2_reg                                                        0xB801584C
+#define K_CP_REG_DATAIN_3_reg                                                        0xB8015850
+#define set_K_CP_REG_DATAIN_0_reg(data)   (*((volatile unsigned int*) K_CP_REG_DATAIN_0_reg)=data)
+#define set_K_CP_REG_DATAIN_1_reg(data)   (*((volatile unsigned int*) K_CP_REG_DATAIN_1_reg)=data)
+#define set_K_CP_REG_DATAIN_2_reg(data)   (*((volatile unsigned int*) K_CP_REG_DATAIN_2_reg)=data)
+#define set_K_CP_REG_DATAIN_3_reg(data)   (*((volatile unsigned int*) K_CP_REG_DATAIN_3_reg)=data)
+#define get_K_CP_REG_DATAIN_0_reg   (*((volatile unsigned int*) K_CP_REG_DATAIN_0_reg))
+#define get_K_CP_REG_DATAIN_1_reg   (*((volatile unsigned int*) K_CP_REG_DATAIN_1_reg))
+#define get_K_CP_REG_DATAIN_2_reg   (*((volatile unsigned int*) K_CP_REG_DATAIN_2_reg))
+#define get_K_CP_REG_DATAIN_3_reg   (*((volatile unsigned int*) K_CP_REG_DATAIN_3_reg))
+#define K_CP_REG_DATAIN_0_inst_adr                                                   "0x0011"
+#define K_CP_REG_DATAIN_1_inst_adr                                                   "0x0012"
+#define K_CP_REG_DATAIN_2_inst_adr                                                   "0x0013"
+#define K_CP_REG_DATAIN_3_inst_adr                                                   "0x0014"
+#define K_CP_REG_DATAIN_0_inst                                                       0x0011
+#define K_CP_REG_DATAIN_1_inst                                                       0x0012
+#define K_CP_REG_DATAIN_2_inst                                                       0x0013
+#define K_CP_REG_DATAIN_3_inst                                                       0x0014
+#define K_CP_REG_DATAIN_data_shift                                                   (0)
+#define K_CP_REG_DATAIN_data_mask                                                    (0xFFFFFFFF)
+#define K_CP_REG_DATAIN_data(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define K_CP_REG_DATAIN_data_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define K_CP_REG_DATAIN_get_data(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_CP_REG_DATAOUT_0                                                           0x18015854
+#define K_CP_REG_DATAOUT_1                                                           0x18015858
+#define K_CP_REG_DATAOUT_2                                                           0x1801585C
+#define K_CP_REG_DATAOUT_3                                                           0x18015860
+#define K_CP_REG_DATAOUT_0_reg_addr                                                  "0xB8015854"
+#define K_CP_REG_DATAOUT_1_reg_addr                                                  "0xB8015858"
+#define K_CP_REG_DATAOUT_2_reg_addr                                                  "0xB801585C"
+#define K_CP_REG_DATAOUT_3_reg_addr                                                  "0xB8015860"
+#define K_CP_REG_DATAOUT_0_reg                                                       0xB8015854
+#define K_CP_REG_DATAOUT_1_reg                                                       0xB8015858
+#define K_CP_REG_DATAOUT_2_reg                                                       0xB801585C
+#define K_CP_REG_DATAOUT_3_reg                                                       0xB8015860
+#define set_K_CP_REG_DATAOUT_0_reg(data)   (*((volatile unsigned int*) K_CP_REG_DATAOUT_0_reg)=data)
+#define set_K_CP_REG_DATAOUT_1_reg(data)   (*((volatile unsigned int*) K_CP_REG_DATAOUT_1_reg)=data)
+#define set_K_CP_REG_DATAOUT_2_reg(data)   (*((volatile unsigned int*) K_CP_REG_DATAOUT_2_reg)=data)
+#define set_K_CP_REG_DATAOUT_3_reg(data)   (*((volatile unsigned int*) K_CP_REG_DATAOUT_3_reg)=data)
+#define get_K_CP_REG_DATAOUT_0_reg   (*((volatile unsigned int*) K_CP_REG_DATAOUT_0_reg))
+#define get_K_CP_REG_DATAOUT_1_reg   (*((volatile unsigned int*) K_CP_REG_DATAOUT_1_reg))
+#define get_K_CP_REG_DATAOUT_2_reg   (*((volatile unsigned int*) K_CP_REG_DATAOUT_2_reg))
+#define get_K_CP_REG_DATAOUT_3_reg   (*((volatile unsigned int*) K_CP_REG_DATAOUT_3_reg))
+#define K_CP_REG_DATAOUT_0_inst_adr                                                  "0x0015"
+#define K_CP_REG_DATAOUT_1_inst_adr                                                  "0x0016"
+#define K_CP_REG_DATAOUT_2_inst_adr                                                  "0x0017"
+#define K_CP_REG_DATAOUT_3_inst_adr                                                  "0x0018"
+#define K_CP_REG_DATAOUT_0_inst                                                      0x0015
+#define K_CP_REG_DATAOUT_1_inst                                                      0x0016
+#define K_CP_REG_DATAOUT_2_inst                                                      0x0017
+#define K_CP_REG_DATAOUT_3_inst                                                      0x0018
+#define K_CP_REG_DATAOUT_data_shift                                                  (0)
+#define K_CP_REG_DATAOUT_data_mask                                                   (0xFFFFFFFF)
+#define K_CP_REG_DATAOUT_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define K_CP_REG_DATAOUT_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define K_CP_REG_DATAOUT_get_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_CP_REG_IV_0                                                                0x18015864
+#define K_CP_REG_IV_1                                                                0x18015868
+#define K_CP_REG_IV_2                                                                0x1801586C
+#define K_CP_REG_IV_3                                                                0x18015870
+#define K_CP_REG_IV_0_reg_addr                                                       "0xB8015864"
+#define K_CP_REG_IV_1_reg_addr                                                       "0xB8015868"
+#define K_CP_REG_IV_2_reg_addr                                                       "0xB801586C"
+#define K_CP_REG_IV_3_reg_addr                                                       "0xB8015870"
+#define K_CP_REG_IV_0_reg                                                            0xB8015864
+#define K_CP_REG_IV_1_reg                                                            0xB8015868
+#define K_CP_REG_IV_2_reg                                                            0xB801586C
+#define K_CP_REG_IV_3_reg                                                            0xB8015870
+#define set_K_CP_REG_IV_0_reg(data)   (*((volatile unsigned int*) K_CP_REG_IV_0_reg)=data)
+#define set_K_CP_REG_IV_1_reg(data)   (*((volatile unsigned int*) K_CP_REG_IV_1_reg)=data)
+#define set_K_CP_REG_IV_2_reg(data)   (*((volatile unsigned int*) K_CP_REG_IV_2_reg)=data)
+#define set_K_CP_REG_IV_3_reg(data)   (*((volatile unsigned int*) K_CP_REG_IV_3_reg)=data)
+#define get_K_CP_REG_IV_0_reg   (*((volatile unsigned int*) K_CP_REG_IV_0_reg))
+#define get_K_CP_REG_IV_1_reg   (*((volatile unsigned int*) K_CP_REG_IV_1_reg))
+#define get_K_CP_REG_IV_2_reg   (*((volatile unsigned int*) K_CP_REG_IV_2_reg))
+#define get_K_CP_REG_IV_3_reg   (*((volatile unsigned int*) K_CP_REG_IV_3_reg))
+#define K_CP_REG_IV_0_inst_adr                                                       "0x0019"
+#define K_CP_REG_IV_1_inst_adr                                                       "0x001A"
+#define K_CP_REG_IV_2_inst_adr                                                       "0x001B"
+#define K_CP_REG_IV_3_inst_adr                                                       "0x001C"
+#define K_CP_REG_IV_0_inst                                                           0x0019
+#define K_CP_REG_IV_1_inst                                                           0x001A
+#define K_CP_REG_IV_2_inst                                                           0x001B
+#define K_CP_REG_IV_3_inst                                                           0x001C
+#define K_CP_REG_IV_data_shift                                                       (0)
+#define K_CP_REG_IV_data_mask                                                        (0xFFFFFFFF)
+#define K_CP_REG_IV_data(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define K_CP_REG_IV_data_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define K_CP_REG_IV_get_data(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_CP_REG_SET                                                                 0x18015874
+#define K_CP_REG_SET_reg_addr                                                        "0xB8015874"
+#define K_CP_REG_SET_reg                                                             0xB8015874
+#define set_K_CP_REG_SET_reg(data)   (*((volatile unsigned int*) K_CP_REG_SET_reg)=data)
+#define get_K_CP_REG_SET_reg   (*((volatile unsigned int*) K_CP_REG_SET_reg))
+#define K_CP_REG_SET_inst_adr                                                        "0x001D"
+#define K_CP_REG_SET_inst                                                            0x001D
+#define K_CP_REG_SET_write_enable3_shift                                             (17)
+#define K_CP_REG_SET_write_enable3_mask                                              (0x00020000)
+#define K_CP_REG_SET_write_enable3(data)                                             (0x00020000&((data)<<17))
+#define K_CP_REG_SET_write_enable3_src(data)                                         ((0x00020000&(data))>>17)
+#define K_CP_REG_SET_get_write_enable3(data)                                         ((0x00020000&(data))>>17)
+#define K_CP_REG_SET_mode_shift                                                      (13)
+#define K_CP_REG_SET_mode_mask                                                       (0x0001E000)
+#define K_CP_REG_SET_mode(data)                                                      (0x0001E000&((data)<<13))
+#define K_CP_REG_SET_mode_src(data)                                                  ((0x0001E000&(data))>>13)
+#define K_CP_REG_SET_get_mode(data)                                                  ((0x0001E000&(data))>>13)
+#define K_CP_REG_SET_write_enable2_shift                                             (5)
+#define K_CP_REG_SET_write_enable2_mask                                              (0x00000020)
+#define K_CP_REG_SET_write_enable2(data)                                             (0x00000020&((data)<<5))
+#define K_CP_REG_SET_write_enable2_src(data)                                         ((0x00000020&(data))>>5)
+#define K_CP_REG_SET_get_write_enable2(data)                                         ((0x00000020&(data))>>5)
+#define K_CP_REG_SET_cbc_shift                                                       (4)
+#define K_CP_REG_SET_cbc_mask                                                        (0x00000010)
+#define K_CP_REG_SET_cbc(data)                                                       (0x00000010&((data)<<4))
+#define K_CP_REG_SET_cbc_src(data)                                                   ((0x00000010&(data))>>4)
+#define K_CP_REG_SET_get_cbc(data)                                                   ((0x00000010&(data))>>4)
+#define K_CP_REG_SET_write_enable1_shift                                             (3)
+#define K_CP_REG_SET_write_enable1_mask                                              (0x00000008)
+#define K_CP_REG_SET_write_enable1(data)                                             (0x00000008&((data)<<3))
+#define K_CP_REG_SET_write_enable1_src(data)                                         ((0x00000008&(data))>>3)
+#define K_CP_REG_SET_get_write_enable1(data)                                         ((0x00000008&(data))>>3)
+#define K_CP_REG_SET_reg_first_shift                                                 (2)
+#define K_CP_REG_SET_reg_first_mask                                                  (0x00000004)
+#define K_CP_REG_SET_reg_first(data)                                                 (0x00000004&((data)<<2))
+#define K_CP_REG_SET_reg_first_src(data)                                             ((0x00000004&(data))>>2)
+#define K_CP_REG_SET_get_reg_first(data)                                             ((0x00000004&(data))>>2)
+#define K_CP_REG_SET_write_enable0_shift                                             (1)
+#define K_CP_REG_SET_write_enable0_mask                                              (0x00000002)
+#define K_CP_REG_SET_write_enable0(data)                                             (0x00000002&((data)<<1))
+#define K_CP_REG_SET_write_enable0_src(data)                                         ((0x00000002&(data))>>1)
+#define K_CP_REG_SET_get_write_enable0(data)                                         ((0x00000002&(data))>>1)
+#define K_CP_REG_SET_reg_ende_shift                                                  (0)
+#define K_CP_REG_SET_reg_ende_mask                                                   (0x00000001)
+#define K_CP_REG_SET_reg_ende(data)                                                  (0x00000001&((data)<<0))
+#define K_CP_REG_SET_reg_ende_src(data)                                              ((0x00000001&(data))>>0)
+#define K_CP_REG_SET_get_reg_ende(data)                                              ((0x00000001&(data))>>0)
+
+
+#define K_CP_REG_SET1                                                                0x18015878
+#define K_CP_REG_SET1_reg_addr                                                       "0xB8015878"
+#define K_CP_REG_SET1_reg                                                            0xB8015878
+#define set_K_CP_REG_SET1_reg(data)   (*((volatile unsigned int*) K_CP_REG_SET1_reg)=data)
+#define get_K_CP_REG_SET1_reg   (*((volatile unsigned int*) K_CP_REG_SET1_reg))
+#define K_CP_REG_SET1_inst_adr                                                       "0x001E"
+#define K_CP_REG_SET1_inst                                                           0x001E
+#define K_CP_REG_SET1_dataout_byte_swap_shift                                        (13)
+#define K_CP_REG_SET1_dataout_byte_swap_mask                                         (0x00002000)
+#define K_CP_REG_SET1_dataout_byte_swap(data)                                        (0x00002000&((data)<<13))
+#define K_CP_REG_SET1_dataout_byte_swap_src(data)                                    ((0x00002000&(data))>>13)
+#define K_CP_REG_SET1_get_dataout_byte_swap(data)                                    ((0x00002000&(data))>>13)
+#define K_CP_REG_SET1_datain_byte_swap_shift                                         (12)
+#define K_CP_REG_SET1_datain_byte_swap_mask                                          (0x00001000)
+#define K_CP_REG_SET1_datain_byte_swap(data)                                         (0x00001000&((data)<<12))
+#define K_CP_REG_SET1_datain_byte_swap_src(data)                                     ((0x00001000&(data))>>12)
+#define K_CP_REG_SET1_get_datain_byte_swap(data)                                     ((0x00001000&(data))>>12)
+#define K_CP_REG_SET1_iv_byte_swap_shift                                             (11)
+#define K_CP_REG_SET1_iv_byte_swap_mask                                              (0x00000800)
+#define K_CP_REG_SET1_iv_byte_swap(data)                                             (0x00000800&((data)<<11))
+#define K_CP_REG_SET1_iv_byte_swap_src(data)                                         ((0x00000800&(data))>>11)
+#define K_CP_REG_SET1_get_iv_byte_swap(data)                                         ((0x00000800&(data))>>11)
+#define K_CP_REG_SET1_key_byte_swap_shift                                            (10)
+#define K_CP_REG_SET1_key_byte_swap_mask                                             (0x00000400)
+#define K_CP_REG_SET1_key_byte_swap(data)                                            (0x00000400&((data)<<10))
+#define K_CP_REG_SET1_key_byte_swap_src(data)                                        ((0x00000400&(data))>>10)
+#define K_CP_REG_SET1_get_key_byte_swap(data)                                        ((0x00000400&(data))>>10)
+#define K_CP_REG_SET1_des_key_order_shift                                            (9)
+#define K_CP_REG_SET1_des_key_order_mask                                             (0x00000200)
+#define K_CP_REG_SET1_des_key_order(data)                                            (0x00000200&((data)<<9))
+#define K_CP_REG_SET1_des_key_order_src(data)                                        ((0x00000200&(data))>>9)
+#define K_CP_REG_SET1_get_des_key_order(data)                                        ((0x00000200&(data))>>9)
+#define K_CP_REG_SET1_key_mode_shift                                                 (6)
+#define K_CP_REG_SET1_key_mode_mask                                                  (0x000001C0)
+#define K_CP_REG_SET1_key_mode(data)                                                 (0x000001C0&((data)<<6))
+#define K_CP_REG_SET1_key_mode_src(data)                                             ((0x000001C0&(data))>>6)
+#define K_CP_REG_SET1_get_key_mode(data)                                             ((0x000001C0&(data))>>6)
+#define K_CP_REG_SET1_iv_mode_shift                                                  (4)
+#define K_CP_REG_SET1_iv_mode_mask                                                   (0x00000030)
+#define K_CP_REG_SET1_iv_mode(data)                                                  (0x00000030&((data)<<4))
+#define K_CP_REG_SET1_iv_mode_src(data)                                              ((0x00000030&(data))>>4)
+#define K_CP_REG_SET1_get_iv_mode(data)                                              ((0x00000030&(data))>>4)
+#define K_CP_REG_SET1_input_mode_shift                                               (2)
+#define K_CP_REG_SET1_input_mode_mask                                                (0x0000000C)
+#define K_CP_REG_SET1_input_mode(data)                                               (0x0000000C&((data)<<2))
+#define K_CP_REG_SET1_input_mode_src(data)                                           ((0x0000000C&(data))>>2)
+#define K_CP_REG_SET1_get_input_mode(data)                                           ((0x0000000C&(data))>>2)
+#define K_CP_REG_SET1_output_mode_shift                                              (0)
+#define K_CP_REG_SET1_output_mode_mask                                               (0x00000003)
+#define K_CP_REG_SET1_output_mode(data)                                              (0x00000003&((data)<<0))
+#define K_CP_REG_SET1_output_mode_src(data)                                          ((0x00000003&(data))>>0)
+#define K_CP_REG_SET1_get_output_mode(data)                                          ((0x00000003&(data))>>0)
+
+
+#define K_CP_REG_SET2                                                                0x1801587c
+#define K_CP_REG_SET2_reg_addr                                                       "0xB801587C"
+#define K_CP_REG_SET2_reg                                                            0xB801587C
+#define set_K_CP_REG_SET2_reg(data)   (*((volatile unsigned int*) K_CP_REG_SET2_reg)=data)
+#define get_K_CP_REG_SET2_reg   (*((volatile unsigned int*) K_CP_REG_SET2_reg))
+#define K_CP_REG_SET2_inst_adr                                                       "0x001F"
+#define K_CP_REG_SET2_inst                                                           0x001F
+#define K_CP_REG_SET2_output_entry_shift                                             (24)
+#define K_CP_REG_SET2_output_entry_mask                                              (0x7F000000)
+#define K_CP_REG_SET2_output_entry(data)                                             (0x7F000000&((data)<<24))
+#define K_CP_REG_SET2_output_entry_src(data)                                         ((0x7F000000&(data))>>24)
+#define K_CP_REG_SET2_get_output_entry(data)                                         ((0x7F000000&(data))>>24)
+#define K_CP_REG_SET2_input_entry_shift                                              (16)
+#define K_CP_REG_SET2_input_entry_mask                                               (0x007F0000)
+#define K_CP_REG_SET2_input_entry(data)                                              (0x007F0000&((data)<<16))
+#define K_CP_REG_SET2_input_entry_src(data)                                          ((0x007F0000&(data))>>16)
+#define K_CP_REG_SET2_get_input_entry(data)                                          ((0x007F0000&(data))>>16)
+#define K_CP_REG_SET2_key_entry_shift                                                (8)
+#define K_CP_REG_SET2_key_entry_mask                                                 (0x00007F00)
+#define K_CP_REG_SET2_key_entry(data)                                                (0x00007F00&((data)<<8))
+#define K_CP_REG_SET2_key_entry_src(data)                                            ((0x00007F00&(data))>>8)
+#define K_CP_REG_SET2_get_key_entry(data)                                            ((0x00007F00&(data))>>8)
+#define K_CP_REG_SET2_iv_entry_shift                                                 (0)
+#define K_CP_REG_SET2_iv_entry_mask                                                  (0x0000007F)
+#define K_CP_REG_SET2_iv_entry(data)                                                 (0x0000007F&((data)<<0))
+#define K_CP_REG_SET2_iv_entry_src(data)                                             ((0x0000007F&(data))>>0)
+#define K_CP_REG_SET2_get_iv_entry(data)                                             ((0x0000007F&(data))>>0)
+
+
+#define K_CP_REG_KEY_1_0                                                             0x18015880
+#define K_CP_REG_KEY_1_1                                                             0x18015884
+#define K_CP_REG_KEY_1_2                                                             0x18015888
+#define K_CP_REG_KEY_1_3                                                             0x1801588C
+#define K_CP_REG_KEY_1_0_reg_addr                                                    "0xB8015880"
+#define K_CP_REG_KEY_1_1_reg_addr                                                    "0xB8015884"
+#define K_CP_REG_KEY_1_2_reg_addr                                                    "0xB8015888"
+#define K_CP_REG_KEY_1_3_reg_addr                                                    "0xB801588C"
+#define K_CP_REG_KEY_1_0_reg                                                         0xB8015880
+#define K_CP_REG_KEY_1_1_reg                                                         0xB8015884
+#define K_CP_REG_KEY_1_2_reg                                                         0xB8015888
+#define K_CP_REG_KEY_1_3_reg                                                         0xB801588C
+#define set_K_CP_REG_KEY_1_0_reg(data)   (*((volatile unsigned int*) K_CP_REG_KEY_1_0_reg)=data)
+#define set_K_CP_REG_KEY_1_1_reg(data)   (*((volatile unsigned int*) K_CP_REG_KEY_1_1_reg)=data)
+#define set_K_CP_REG_KEY_1_2_reg(data)   (*((volatile unsigned int*) K_CP_REG_KEY_1_2_reg)=data)
+#define set_K_CP_REG_KEY_1_3_reg(data)   (*((volatile unsigned int*) K_CP_REG_KEY_1_3_reg)=data)
+#define get_K_CP_REG_KEY_1_0_reg   (*((volatile unsigned int*) K_CP_REG_KEY_1_0_reg))
+#define get_K_CP_REG_KEY_1_1_reg   (*((volatile unsigned int*) K_CP_REG_KEY_1_1_reg))
+#define get_K_CP_REG_KEY_1_2_reg   (*((volatile unsigned int*) K_CP_REG_KEY_1_2_reg))
+#define get_K_CP_REG_KEY_1_3_reg   (*((volatile unsigned int*) K_CP_REG_KEY_1_3_reg))
+#define K_CP_REG_KEY_1_0_inst_adr                                                    "0x0020"
+#define K_CP_REG_KEY_1_1_inst_adr                                                    "0x0021"
+#define K_CP_REG_KEY_1_2_inst_adr                                                    "0x0022"
+#define K_CP_REG_KEY_1_3_inst_adr                                                    "0x0023"
+#define K_CP_REG_KEY_1_0_inst                                                        0x0020
+#define K_CP_REG_KEY_1_1_inst                                                        0x0021
+#define K_CP_REG_KEY_1_2_inst                                                        0x0022
+#define K_CP_REG_KEY_1_3_inst                                                        0x0023
+#define K_CP_REG_KEY_1_data_shift                                                    (0)
+#define K_CP_REG_KEY_1_data_mask                                                     (0xFFFFFFFF)
+#define K_CP_REG_KEY_1_data(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define K_CP_REG_KEY_1_data_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define K_CP_REG_KEY_1_get_data(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_DBG                                                                       0x180150cc
+#define CP_DBG_reg_addr                                                              "0xB80150CC"
+#define CP_DBG_reg                                                                   0xB80150CC
+#define set_CP_DBG_reg(data)   (*((volatile unsigned int*) CP_DBG_reg)=data)
+#define get_CP_DBG_reg   (*((volatile unsigned int*) CP_DBG_reg))
+#define CP_DBG_inst_adr                                                              "0x0033"
+#define CP_DBG_inst                                                                  0x0033
+#define CP_DBG_dbg_sel1_shift                                                        (6)
+#define CP_DBG_dbg_sel1_mask                                                         (0x000007C0)
+#define CP_DBG_dbg_sel1(data)                                                        (0x000007C0&((data)<<6))
+#define CP_DBG_dbg_sel1_src(data)                                                    ((0x000007C0&(data))>>6)
+#define CP_DBG_get_dbg_sel1(data)                                                    ((0x000007C0&(data))>>6)
+#define CP_DBG_dbg_sel0_shift                                                        (1)
+#define CP_DBG_dbg_sel0_mask                                                         (0x0000003E)
+#define CP_DBG_dbg_sel0(data)                                                        (0x0000003E&((data)<<1))
+#define CP_DBG_dbg_sel0_src(data)                                                    ((0x0000003E&(data))>>1)
+#define CP_DBG_get_dbg_sel0(data)                                                    ((0x0000003E&(data))>>1)
+#define CP_DBG_dbg_en_shift                                                          (0)
+#define CP_DBG_dbg_en_mask                                                           (0x00000001)
+#define CP_DBG_dbg_en(data)                                                          (0x00000001&((data)<<0))
+#define CP_DBG_dbg_en_src(data)                                                      ((0x00000001&(data))>>0)
+#define CP_DBG_get_dbg_en(data)                                                      ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/crt_sys_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/crt_sys_reg.h
new file mode 100644
index 00000000..b313c60
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/crt_sys_reg.h
@@ -0,0 +1,7598 @@
+/**************************************************************
+// Spec Version                  : 1.9
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/8/8 20:16:7
+***************************************************************/
+
+
+#ifndef _SYS_REG_H_INCLUDED_
+#define _SYS_REG_H_INCLUDED_
+#ifdef  _SYS_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rstn_mipi:1;
+unsigned int     rstn_nf:1;
+unsigned int     rstn_ae:1;
+unsigned int     rstn_tp:1;
+unsigned int     rstn_md:1;
+unsigned int     rstn_cp:1;
+unsigned int     rstn_dc_phy:1;
+unsigned int     rstn_dcu:1;
+unsigned int     rstn_se:1;
+unsigned int     rstn_lvds:1;
+unsigned int     rstn_vo:1;
+unsigned int     rstn_tve:1;
+unsigned int     rstn_ve_jpeg:1;
+unsigned int     rstn_ve_h264:1;
+unsigned int     rstn_gpu:1;
+unsigned int     rstn_aio:1;
+unsigned int     rstn_etn:1;
+unsigned int     reserved_1:1;
+unsigned int     rstn_hdmi:1;
+unsigned int     rstn_hdmirx:1;
+unsigned int     reserved_2:1;
+unsigned int     rstn_usb_phy1:1;
+unsigned int     rstn_usb_phy0:1;
+unsigned int     reserved_3:1;
+unsigned int     rstn_usb:1;
+unsigned int     rstn_ve_h265:1;
+unsigned int     rstn_usb3_p0_mdio:1;
+unsigned int     rstn_gspi:1;
+unsigned int     rstn_usb3_pow:1;
+unsigned int     rstn_rng:1;
+unsigned int     rstn_misc:1;
+}SYS_SOFT_RESET1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     reserved_1:1;
+unsigned int     rstn_ur1:1;
+unsigned int     reserved_2:1;
+unsigned int     rstn_i2c_1:1;
+unsigned int     rstn_i2c_2:1;
+unsigned int     rstn_i2c_3:1;
+unsigned int     rstn_i2c_4:1;
+unsigned int     reserved_3:1;
+unsigned int     reserved_4:1;
+unsigned int     rstn_rtc:1;
+unsigned int     reserved_5:1;
+unsigned int     rstn_i2c_5:1;
+unsigned int     reserved_6:1;
+unsigned int     reserved_7:1;
+unsigned int     reserved_8:3;
+unsigned int     rstn_sdio:1;
+unsigned int     rstn_emmc:1;
+unsigned int     rstn_cr:1;
+unsigned int     rstn_pcr_cnt:1;
+unsigned int     reserved_9:5;
+unsigned int     reserved_10:1;
+unsigned int     reserved_11:1;
+unsigned int     rstn_vcpu:1;
+unsigned int     rstn_acpu:1;
+}SYS_SOFT_RESET2;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     rstn_sb2:1;
+}SYS_SOFT_RESET3;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     clk_en_sdio:1;
+unsigned int     clk_en_ve_h265:1;
+unsigned int     reserved_1:1;
+unsigned int     clk_en_mipi:1;
+unsigned int     reserved_2:1;
+unsigned int     clk_en_cr:1;
+unsigned int     clk_en_emmc:1;
+unsigned int     clk_en_nf:1;
+unsigned int     reserved_3:1;
+unsigned int     clk_en_tp:1;
+unsigned int     clk_en_md:1;
+unsigned int     clk_en_cp:1;
+unsigned int     clk_en_dcu:1;
+unsigned int     clk_en_se:1;
+unsigned int     clk_en_lvds:1;
+unsigned int     clk_en_vo:1;
+unsigned int     clk_en_tve:1;
+unsigned int     clk_en_ve_jpeg:1;
+unsigned int     clk_en_ve_h264:1;
+unsigned int     clk_en_gpu:1;
+unsigned int     clk_en_aio:1;
+unsigned int     clk_en_etn:1;
+unsigned int     clk_en_hdmi:1;
+unsigned int     reserved_4:1;
+unsigned int     clk_en_iso_misc:1;
+unsigned int     clk_en_pcr:1;
+unsigned int     clk_en_usb:1;
+unsigned int     clk_en_gspi:1;
+unsigned int     reserved_5:1;
+unsigned int     clk_en_hdmirx:1;
+unsigned int     clk_en_misc:1;
+}SYS_CLOCK_ENABLE1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     reserved_1:1;
+unsigned int     clk_en_ur1:1;
+unsigned int     reserved_2:3;
+unsigned int     reserved_3:1;
+unsigned int     clk_en_aio_mclk:1;
+unsigned int     clk_en_aio_i2s:1;
+unsigned int     clk_en_aio_spdif:1;
+unsigned int     clk_en_aio_hdmi:1;
+unsigned int     clk_en_aio_da:1;
+unsigned int     clk_en_aio_mod:1;
+unsigned int     clk_en_aio_au_codec:1;
+unsigned int     clk_en_misc_i2c_1:1;
+unsigned int     clk_en_misc_i2c_2:1;
+unsigned int     clk_en_misc_i2c_3:1;
+unsigned int     clk_en_misc_i2c_4:1;
+unsigned int     reserved_4:1;
+unsigned int     reserved_5:1;
+unsigned int     clk_en_misc_rtc:1;
+unsigned int     reserved_6:1;
+unsigned int     reserved_7:1;
+unsigned int     reserved_8:1;
+unsigned int     reserved_9:1;
+unsigned int     clk_en_vcpu:1;
+unsigned int     clk_en_acpu:1;
+unsigned int     reserved_10:1;
+unsigned int     clk_en_scpu:1;
+unsigned int     clk_en_misc_i2c_5:1;
+unsigned int     reserved_11:1;
+}SYS_CLOCK_ENABLE2;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     clk_en_kcpu:1;
+unsigned int     clk_en_sb2:1;
+}SYS_GROUP1_CK_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     voclk_sel:1;
+unsigned int     sclk_sel:1;
+}SYS_GROUP1_CK_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     write_en5:1;
+unsigned int     clk_tve_p_vo_clk_sel2:1;
+unsigned int     write_en4:1;
+unsigned int     clk_tve_p_vo_clk_sel:1;
+unsigned int     write_en3:1;
+unsigned int     hdmi_phy_ckinv:1;
+unsigned int     write_en2:1;
+unsigned int     reserved_1:2;
+unsigned int     dac2_ckinv:1;
+unsigned int     dac1_ckinv:1;
+unsigned int     write_en1:1;
+unsigned int     tveck_mix_sel:1;
+}SYS_TVE_CK_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en2:1;
+unsigned int     dac2_div:5;
+unsigned int     write_en1:1;
+unsigned int     dac1_div:5;
+}SYS_DISP_PLL_DIV;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     write_en10:1;
+unsigned int     sel_pllhdmi_mhl:1;
+unsigned int     write_en9:1;
+unsigned int     clk_lvds_sel:5;
+unsigned int     write_en8:1;
+unsigned int     sel_plldisp_clk2:1;
+unsigned int     write_en7:1;
+unsigned int     sel_pllhdmi_clk:1;
+unsigned int     write_en6:1;
+unsigned int     hdmi_pxl_repeat:1;
+unsigned int     write_en5:1;
+unsigned int     hdmi_phy_clk_sel:1;
+unsigned int     write_en4:1;
+unsigned int     hdmi_div:3;
+unsigned int     write_en3:1;
+unsigned int     tve_div:4;
+}SYS_DISP_PLL_DIV2;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     dds_clk_sel:1;
+}SYS_DDS_VIDEO_CK_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     audio_use_sysclk:1;
+}SYS_AUDIO_CLK_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     scpu_freq_sel:2;
+unsigned int     vcpu_freq_sel:2;
+unsigned int     acpu_freq_sel:2;
+unsigned int     reserved_1:2;
+unsigned int     bus_freq_sel:1;
+}SYS_PLL_DIV;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     nf_div:4;
+}SYS_NF_CKSEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     nds_sc_div:3;
+}SYS_NDS_SC_CKSEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     clk_camera1_sel:2;
+unsigned int     clk_camera0_sel:2;
+}SYS_MISC_CKSEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     CLKTRC_SEL:2;
+}SYS_SCPU_CKSEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     clk_ve2_bpu_sel:2;
+unsigned int     clk_ve2_core_sel:2;
+unsigned int     clk_ve1_sel:2;
+}SYS_VE_CKSEL;
+
+typedef struct 
+{
+unsigned int     bus_ssc_sse:1;
+unsigned int     bus_ssc_ckinv:1;
+unsigned int     bus_ssc_sss:6;
+unsigned int     reserved_0:1;
+unsigned int     bus_ssc_ssn:7;
+unsigned int     bus_ssc_ssfpv:8;
+unsigned int     reserved_1:6;
+unsigned int     bus_ssc_stms:2;
+}SYS_BUS_PLL_SSC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     SSCDDR_SEL_ORDER:1;
+unsigned int     SSCDDR_WEIGHTING_SEL:3;
+unsigned int     SSCDDR_STEP_IN:13;
+unsigned int     SSCDDR_TBASE:12;
+}SYS_PLL_DDR_SSC2;
+
+typedef struct 
+{
+unsigned int     dcsb_ssc_sse:1;
+unsigned int     dcsb_ssc_ckinv:1;
+unsigned int     dcsb_ssc_sss:6;
+unsigned int     reserved_0:1;
+unsigned int     dcsb_ssc_ssn:7;
+unsigned int     dcsb_ssc_ssfpv:8;
+unsigned int     reserved_1:6;
+unsigned int     dcsb_ssc_stms:2;
+}SYS_DCSB_PLL_SSC;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     lvds_offset:12;
+unsigned int     reserved_1:1;
+unsigned int     lvds_ss_test:1;
+unsigned int     lvds_ss_fmdiv:7;
+unsigned int     lvds_ss_rag:4;
+unsigned int     lvds_ss_fudpn_en:1;
+unsigned int     lvds_ss_shuffle_en:1;
+unsigned int     lvds_ss_en:1;
+}SYS_LVDS_PLL_SSC;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mclk_sel:3;
+unsigned int     fs:4;
+unsigned int     clken:1;
+}SYS_AIO_O_PCM_CK_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     fs:4;
+unsigned int     clken:1;
+}SYS_AIO_O_RAW_CK_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     fs:4;
+unsigned int     clken:1;
+}SYS_AIO_O_RAW2_CK_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     write_en2:1;
+unsigned int     dds_rstn:1;
+}SYS_APS_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mclk_sel:3;
+unsigned int     fs:4;
+unsigned int     clken:1;
+}SYS_AIO_I_PCM_CK_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     CLK_VO_SEL:1;
+}SYS_CLK_VO_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     lvds_Final_profile:13;
+}SYS_LVDS_PLL_SSC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     lvds_sscg_Profile_over_underflow_flag:1;
+unsigned int     lvds_ss_load:1;
+}SYS_LVDS_PLL_SSC3;
+
+typedef struct 
+{
+unsigned int     REG_PLLSCPU_RS:3;
+unsigned int     REG_PLLSCPU_LDO_VSEL:2;
+unsigned int     REG_PLLSCPU_CP:1;
+unsigned int     REG_PLLSCPU_DBUG_EN:1;
+unsigned int     REG_PLLSCPU_CPMODE:1;
+unsigned int     REG_PLLSCPU_HIGH_KVCO:1;
+unsigned int     REG_PLLSCPU_RESERVE:1;
+unsigned int     REG_PLLSCPU_CCO:1;
+unsigned int     reserved_0:12;
+unsigned int     PLLSCPU_N:2;
+unsigned int     REG_PLLSCPU_IP:4;
+unsigned int     REG_PLLSCPU_TST:1;
+unsigned int     PLLSCPU_RSTB:1;
+unsigned int     PLLSCPU_POW:1;
+}SYS_PLL_SCPU1;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     NCODE_T_SCPU:8;
+unsigned int     FCODE_T_SCPU:11;
+unsigned int     REG_OC_STEP_SET:10;
+}SYS_PLL_SCPU2;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     REG_SEL_OC_MODE:2;
+unsigned int     REG_HS_OC_STOP_DIFF:2;
+unsigned int     REG_OC_DONE_delay:6;
+unsigned int     REG_PI_CUR_SEL:2;
+unsigned int     REG_F390K:2;
+unsigned int     REG_TIME0_CK:3;
+unsigned int     REG_TIME_RDY_CKOUT:2;
+unsigned int     REG_TIME2_RST_WIDTH:2;
+unsigned int     REG_BYPASS_PI:1;
+unsigned int     REG_SDM_ORDER:1;
+unsigned int     REG_EN_WDOG:1;
+unsigned int     REG_EN_PI_DEBUG:1;
+unsigned int     RSTB:1;
+unsigned int     OC_EN:1;
+}SYS_PLL_SCPU3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     REG_PLLACPU_WDRST:1;
+unsigned int     REG_PLLACPU_WDSET:1;
+unsigned int     REG_PLLACPU_CS:2;
+unsigned int     REG_PLLACPU_O:2;
+unsigned int     REG_PLLACPU_RS:3;
+unsigned int     PLLACPU_N:2;
+unsigned int     PLLACPU_M:7;
+unsigned int     PLLACPU_IP:3;
+unsigned int     reserved_1:8;
+unsigned int     PLLACPU_TST:1;
+}SYS_PLL_ACPU1;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     PLLACPU_OEB:1;
+unsigned int     PLLACPU_RSTB:1;
+unsigned int     PLLACPU_POW:1;
+}SYS_PLL_ACPU2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     REG_PLLVCPU_WDRST:1;
+unsigned int     REG_PLLVCPU_WDSET:1;
+unsigned int     REG_PLLVCPU_CS:2;
+unsigned int     REG_PLLVCPU_O:2;
+unsigned int     REG_PLLVCPU_RS:3;
+unsigned int     reserved_1:1;
+unsigned int     PLLVCPU_N:2;
+unsigned int     PLLVCPU_M:7;
+unsigned int     PLLVCPU_IP:3;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:2;
+unsigned int     reserved_4:4;
+unsigned int     PLLVCPU_TST:1;
+}SYS_PLL_VCPU1;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     PLLVCPU_OEB:1;
+unsigned int     PLLVCPU_RSTB:1;
+unsigned int     PLLVCPU_POW:1;
+}SYS_PLL_VCPU2;
+
+typedef struct 
+{
+unsigned int     PLLDDSA_N:2;
+unsigned int     PLLDDSA_M:7;
+unsigned int     PLLDDSA_IP:3;
+unsigned int     PLLDDSA_RS:3;
+unsigned int     PLLDDSA_CS:2;
+unsigned int     PLLDDSA_CP:2;
+unsigned int     PLLDDSA_R3:3;
+unsigned int     PLLDDSA_C3:2;
+unsigned int     PLLDDSA_PI_RL:2;
+unsigned int     PLLDDSA_PI_RS:2;
+unsigned int     PLLDDSA_PI_BIAS:2;
+unsigned int     PLLDDSA_WDMODE:2;
+}SYS_PLL_DISP_SD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en11:1;
+unsigned int     psaud_1a_phase_sel:1;
+unsigned int     psaud_2a_phase_sel:1;
+unsigned int     write_en10:1;
+unsigned int     pcr_a_smooth_en:1;
+unsigned int     write_en9:1;
+unsigned int     pcr_a_phase_sel:1;
+unsigned int     write_en8:1;
+unsigned int     pcr_a_ctl_en:1;
+unsigned int     write_en7:1;
+unsigned int     PLLDDSA_FUPDN:1;
+unsigned int     write_en6:1;
+unsigned int     PLLDDSA_DDSEN:1;
+unsigned int     write_en5:1;
+unsigned int     PLLDDSA_VCORB:1;
+unsigned int     write_en4:1;
+unsigned int     PLLDDSA_TST:1;
+unsigned int     PLLDDSA_PSTST:1;
+unsigned int     write_en3:1;
+unsigned int     PSAUD1A_FUPDN:1;
+unsigned int     PSAUD1A_DIV:1;
+unsigned int     write_en2:1;
+unsigned int     PSAUD1A_TST:1;
+unsigned int     PSAUD1A_PSEN:1;
+unsigned int     write_en1:1;
+unsigned int     PSAUD2A_FUPDN:1;
+unsigned int     PSAUD2A_DIV:1;
+unsigned int     PSAUD2A_TST:1;
+unsigned int     PSAUD2A_PSEN:1;
+}SYS_PLL_DISP_SD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     PSAUD1A_OEB:1;
+unsigned int     PSAUD1A_RSTB:1;
+unsigned int     PSAUD2A_OEB:1;
+unsigned int     PSAUD2A_RSTB:1;
+}SYS_PLL_DISP_SD3;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     PLLDDSA_K:2;
+unsigned int     reserved_1:1;
+unsigned int     PLLDDSA_OEB:1;
+unsigned int     PLLDDSA_RSTB:1;
+unsigned int     PLLDDSA_POW:1;
+}SYS_PLL_DISP_SD4;
+
+typedef struct 
+{
+unsigned int     N:16;
+unsigned int     M:16;
+}SYS_PLL_DISP_SD5;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     N_nxt:16;
+}SYS_PLL_DISP_SD6;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     N_nxt_add:8;
+unsigned int     N_nxt_add_period:16;
+}SYS_PLL_DISP_SD7;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     PLLDISP_Q2:2;
+unsigned int     PLLDISP_BP:1;
+unsigned int     PLLDISP_N:3;
+unsigned int     PLLDISP_Q1:2;
+unsigned int     PLLDISP_M:7;
+unsigned int     PLLDISP_IP:2;
+unsigned int     PLLDISP_RS:3;
+unsigned int     PLLDISP_CS:2;
+unsigned int     reserved_1:1;
+unsigned int     PLLDISP_WDRST:1;
+unsigned int     PLLDISP_WDSET:1;
+unsigned int     PLLDISP_TST:1;
+}SYS_PLL_DISP_HD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     PLLDISP_OEB2:1;
+unsigned int     PLLDISP_OEB1:1;
+unsigned int     PLLDISP_RSTB:1;
+unsigned int     PLLDISP_POW:1;
+}SYS_PLL_DISP_HD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_PLLTST_POW:1;
+unsigned int     reserved_1:4;
+}SYS_PLL1_TEST;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_en4:1;
+unsigned int     PLLDDR_CCO_BAND:2;
+unsigned int     PLLDDR_CCO_KVCO:1;
+unsigned int     write_en3:1;
+unsigned int     PLLDISP_REG:2;
+unsigned int     PLLDISP_POWREG:1;
+unsigned int     write_en2:1;
+unsigned int     PLLDDS_REG:2;
+unsigned int     PLLDDS_POWREG:1;
+unsigned int     write_en1:1;
+unsigned int     PLLCPU_REG:2;
+unsigned int     PLLCPU_POWREG:1;
+}SYS_PLL_REG_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en4:1;
+unsigned int     PLLDDR_PDIV:2;
+unsigned int     write_en3:1;
+unsigned int     PLLDDR_ICP:4;
+unsigned int     PLLDDR_PLL_SEL_CPMODE:1;
+unsigned int     PLLDDR_LPF_SR:3;
+unsigned int     PLLDDR_LPF_CP:1;
+unsigned int     PLLDDR_LOOP_PI_ISEL:3;
+unsigned int     write_en2:1;
+unsigned int     PLLDDR_POST_PI_SEL6:5;
+unsigned int     PLLDDR_POST_PI_RL:2;
+unsigned int     PLLDDR_POST_PI_BIAS:2;
+unsigned int     PLLDDR_POST_PI_RS:1;
+unsigned int     write_en1:1;
+unsigned int     PLLDDR_CKREF_SEL:1;
+unsigned int     PLLDDR_PLL_LDO_VSEL:2;
+}SYS_PLL_DDR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     PLLDDR_POST_PI_SEL5:5;
+unsigned int     PLLDDR_POST_PI_SEL4:5;
+unsigned int     PLLDDR_POST_PI_SEL3:5;
+unsigned int     PLLDDR_POST_PI_SEL2:5;
+unsigned int     PLLDDR_POST_PI_SEL1:5;
+unsigned int     PLLDDR_POST_PI_SEL0:5;
+}SYS_PLL_DDR2;
+
+typedef struct 
+{
+unsigned int     write_en2:1;
+unsigned int     PLLDDR_DUM:8;
+unsigned int     PLLDDR_PLL_DBUG_EN:1;
+unsigned int     PLLDDR_OESYNC_OP_SEL:6;
+unsigned int     PLLDDR_EN_POST_PI:7;
+unsigned int     write_en1:1;
+unsigned int     PLLDDR_CLK_OE:6;
+unsigned int     PLLDDR_RSTB_IN:1;
+unsigned int     PLLDDR_PLL_EN:1;
+}SYS_PLL_DDR3;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     PLLDDR_WDOUT_CLR:1;
+unsigned int     PLLDDR_WD_EN:1;
+unsigned int     PLLDDR_F390K:2;
+unsigned int     PLLDDR_TIME0_CK:3;
+unsigned int     PLLDDR_TIME_RDY_CKOUT:2;
+unsigned int     PLLDDR_TIME2_RST_WIDTH:2;
+}SYS_PLL_DDR4;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     SSCDDR_N_CODE:8;
+unsigned int     SSCDDR_F_CODE:13;
+unsigned int     reserved_1:4;
+unsigned int     SSCDDR_BYPASS_PI:1;
+unsigned int     SSCDDR_SEL_MODE:1;
+unsigned int     SSCDDR_EN_CENTER_IN:1;
+unsigned int     SSCDDR_EN_SSC:1;
+}SYS_PLL_DDR_SSC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     PLLBUS_N:2;
+unsigned int     PLLBUS_M:7;
+unsigned int     PLLBUS_IP:3;
+unsigned int     reserved_1:1;
+unsigned int     PLLBUS_RS:3;
+unsigned int     reserved_2:1;
+unsigned int     PLLBUS_CS:2;
+unsigned int     reserved_3:1;
+unsigned int     PLLBUS_CP:2;
+unsigned int     PLLBUS_R3:3;
+unsigned int     PLLBUS_C3:2;
+}SYS_PLL_BUS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     write_en5:1;
+unsigned int     PLLBUS_PI_RL:2;
+unsigned int     PLLBUS_PI_RS:2;
+unsigned int     PLLBUS_PI_BIAS:2;
+unsigned int     write_en4:1;
+unsigned int     PLLBUS_WDMODE:2;
+unsigned int     reserved_1:2;
+unsigned int     write_en3:1;
+unsigned int     PLLBUS_FUPDN:1;
+unsigned int     PLLBUS_PSEN:1;
+unsigned int     PLLBUS_VCORB:1;
+unsigned int     write_en1:1;
+unsigned int     PLLBUS_TST:1;
+unsigned int     PLLBUS_PSTST:1;
+}SYS_PLL_BUS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     PLLBUS_O:2;
+unsigned int     PLLBUS_OEB:1;
+unsigned int     PLLBUS_RSTB:1;
+unsigned int     PLLBUS_POW:1;
+}SYS_PLL_BUS3;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     PLLGPU_WDOUT:1;
+unsigned int     PLLLVDS_WDOUT:1;
+unsigned int     PLLDCSB_WDOUT:1;
+unsigned int     PLLHDMI_WDOUT:1;
+unsigned int     reserved_1:1;
+unsigned int     PLLDDR_WDOUT:1;
+unsigned int     PLLBUS_WDOUT:1;
+unsigned int     PLLDISP_WDOUT:1;
+unsigned int     PLLDDSB_WDOUT:1;
+unsigned int     PLLDDSA_WDOUT:1;
+unsigned int     PLLVCPU_WDOUT:1;
+unsigned int     PLLACPU_WDOUT:1;
+unsigned int     PLLSCPU_WDOUT:1;
+}SYS_PLL_WDOUT;
+
+typedef struct 
+{
+unsigned int     PLLDDSB_N:2;
+unsigned int     PLLDDSB_M:7;
+unsigned int     PLLDDSB_IP:3;
+unsigned int     PLLDDSB_RS:3;
+unsigned int     PLLDDSB_CS:2;
+unsigned int     PLLDDSB_CP:2;
+unsigned int     PLLDDSB_R3:3;
+unsigned int     PLLDDSB_C3:2;
+unsigned int     PLLDDSB_PI_RL:2;
+unsigned int     PLLDDSB_PI_RS:2;
+unsigned int     PLLDDSB_PI_BIAS:2;
+unsigned int     PLLDDSB_WDMODE:2;
+}SYS_PLL_DISP_2_SD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en10:1;
+unsigned int     pcr_b_smooth_en:1;
+unsigned int     write_en9:1;
+unsigned int     pcr_b_phase_sel:1;
+unsigned int     write_en8:1;
+unsigned int     pcr_b_ctl_en:1;
+unsigned int     write_en7:1;
+unsigned int     PLLDDSB_FUPDN:1;
+unsigned int     write_en6:1;
+unsigned int     PLLDDSB_DDSEN:1;
+unsigned int     write_en5:1;
+unsigned int     PLLDDSB_VCORB:1;
+unsigned int     write_en4:1;
+unsigned int     PLLDDSB_TST:1;
+unsigned int     PLLDDSB_PSTST:1;
+unsigned int     write_en3:1;
+unsigned int     PSAUD1B_FUPDN:1;
+unsigned int     PSAUD1B_DIV:1;
+unsigned int     write_en2:1;
+unsigned int     PSAUD1B_TST:1;
+unsigned int     PSAUD1B_PSEN:1;
+unsigned int     write_en1:1;
+unsigned int     PSAUD2B_FUPDN:1;
+unsigned int     PSAUD2B_DIV:1;
+unsigned int     PSAUD2B_TST:1;
+unsigned int     PSAUD2B_PSEN:1;
+}SYS_PLL_DISP_2_SD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     PSAUD1B_OEB:1;
+unsigned int     PSAUD1B_RSTB:1;
+unsigned int     PSAUD2B_OEB:1;
+unsigned int     PSAUD2B_RSTB:1;
+}SYS_PLL_DISP_2_SD3;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     PLLDDSB_K:2;
+unsigned int     reserved_1:1;
+unsigned int     PLLDDSB_OEB:1;
+unsigned int     PLLDDSB_RSTB:1;
+unsigned int     PLLDDSB_POW:1;
+}SYS_PLL_DISP_2_SD4;
+
+typedef struct 
+{
+unsigned int     N:16;
+unsigned int     M:16;
+}SYS_PLL_DISP_2_SD5;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     N_nxt:16;
+}SYS_PLL_DISP_2_SD6;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     N_nxt_add:8;
+unsigned int     N_nxt_add_period:16;
+}SYS_PLL_DISP_2_SD7;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_LDO_PLL_PU:1;
+unsigned int     REG_LDO_CCO_PU:1;
+unsigned int     REG_LDO_TMDS_PU:1;
+unsigned int     REG_TV_PLL_PU:1;
+unsigned int     REG_HDMI_CK_EN:1;
+}SYS_PLL_HDMI;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     REG_TV_PRE_DIV:1;
+unsigned int     REG_TV_LDIV:6;
+unsigned int     REG_TV_PSTEP_EN:1;
+unsigned int     REG_TV_PSTEP:3;
+unsigned int     REG_PIXEL_DIV3:1;
+unsigned int     REG_PIXEL_DIV5:1;
+unsigned int     REG_PIXEL_DIV16:3;
+unsigned int     REG_TMDS_DIV5:1;
+unsigned int     REG_TMDS_DIV16:3;
+}SYS_PLL_HDMI2;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     PLLDCSB_N:2;
+unsigned int     PLLDCSB_M:7;
+unsigned int     PLLDCSB_IP:3;
+unsigned int     reserved_1:1;
+unsigned int     PLLDCSB_RS:3;
+unsigned int     reserved_2:1;
+unsigned int     PLLDCSB_CS:2;
+unsigned int     reserved_3:1;
+unsigned int     PLLDCSB_CP:2;
+unsigned int     PLLDCSB_R3:3;
+unsigned int     PLLDCSB_C3:2;
+}SYS_PLL_DCSB1;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     write_en5:1;
+unsigned int     PLLDCSB_PI_RL:2;
+unsigned int     PLLDCSB_PI_RS:2;
+unsigned int     PLLDCSB_PI_BIAS:2;
+unsigned int     write_en4:1;
+unsigned int     PLLDCSB_WDMODE:2;
+unsigned int     reserved_1:2;
+unsigned int     write_en3:1;
+unsigned int     PLLDCSB_FUPDN:1;
+unsigned int     PLLDCSB_PSEN:1;
+unsigned int     PLLDCSB_VCORB:1;
+unsigned int     write_en1:1;
+unsigned int     PLLDCSB_TST:1;
+unsigned int     PLLDCSB_PSTST:1;
+}SYS_PLL_DCSB2;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     REG_PLLDCSB_O:2;
+unsigned int     PLLDCSB_OEB:1;
+unsigned int     PLLDCSB_RSTB:1;
+unsigned int     PLLDCSB_POW:1;
+}SYS_PLL_DCSB3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     REG_PLLGPU_WDRST:1;
+unsigned int     REG_PLLGPU_WDSET:1;
+unsigned int     REG_PLLGPU_CS:2;
+unsigned int     REG_PLLGPU_O:2;
+unsigned int     REG_PLLGPU_RS:3;
+unsigned int     reserved_1:1;
+unsigned int     PLLGPU_N:2;
+unsigned int     PLLGPU_M:7;
+unsigned int     PLLGPU_IP:3;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:2;
+unsigned int     reserved_4:4;
+unsigned int     PLLGPU_TST:1;
+}SYS_PLL_GPU1;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     PLLGPU_OEB:1;
+unsigned int     PLLGPU_RSTB:1;
+unsigned int     PLLGPU_POW:1;
+}SYS_PLL_GPU2;
+
+typedef struct 
+{
+unsigned int     REG_PLLLVDS_BPN:1;
+unsigned int     REG_PLLLVDS_BPPHS:1;
+unsigned int     REG_PLLLVDS_FREEZE:1;
+unsigned int     REG_PLLLVDS_FUPDN:1;
+unsigned int     REG_PLLLVDS_POW:1;
+unsigned int     REG_PLLLVDS_RESERVE:1;
+unsigned int     REG_PLLLVDS_RSTB:1;
+unsigned int     REG_PLLLVDS_STOP:1;
+unsigned int     REG_PLLLVDS_VCORSTB:1;
+unsigned int     REG_PLLLVDS_WDRST:1;
+unsigned int     REG_PLLLVDS_WDSET:1;
+unsigned int     REG_PLLLVDS_CP:2;
+unsigned int     REG_PLLLVDS_CS:2;
+unsigned int     REG_PLLLVDS_O:2;
+unsigned int     REG_PLLLVDS_IP:3;
+unsigned int     REG_PLLLVDS_RS:3;
+unsigned int     reserved_0:7;
+unsigned int     PLLLVDS_RESER:1;
+unsigned int     REG_PLLLVDS_TST:1;
+}SYS_PLL_LVDS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     REG_PLLLVDS_M:8;
+unsigned int     REG_PLLLVDS_N:3;
+}SYS_PLL_LVDS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     PLLDDR_PLL_STABLE:1;
+unsigned int     POWDET_DDR:1;
+}SYS_PLL_DDR6;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     PLLTST_DIV32:1;
+unsigned int     POR_VSET:1;
+unsigned int     REG_PLLDDSB_SEL:1;
+unsigned int     PLLDISP_SEL:2;
+unsigned int     PLLHDMI_SEL:2;
+unsigned int     PLLTST_SEL:4;
+unsigned int     PLLTST_DIV:3;
+}SYS_PLL_OTHER;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     reg_tuned3318:3;
+unsigned int     reg_d3318pow:2;
+unsigned int     regpd_d3318:1;
+unsigned int     reserved_1:3;
+unsigned int     phsel1:5;
+unsigned int     phsel0:5;
+unsigned int     phrstb_dly_sel:1;
+unsigned int     phrt0:1;
+unsigned int     bias_en:1;
+}SYS_PLL_SD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     en_cpnew:1;
+unsigned int     ssc_div_ext_f:8;
+unsigned int     ssc_div_f_sel:1;
+unsigned int     ssc_8x_en:1;
+unsigned int     ssc_depth:3;
+unsigned int     sscpll_rs:3;
+unsigned int     sscpll_icp:5;
+unsigned int     sscpll_cs1:2;
+unsigned int     reg_tune11:2;
+unsigned int     sscldo_en:1;
+}SYS_PLL_SD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     ssc_div_n:10;
+unsigned int     reserved_1:1;
+unsigned int     ssc_step_in:7;
+unsigned int     ssc_tbase:8;
+}SYS_PLL_SD3;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ssc_pll_pow:1;
+unsigned int     ssc_pll_rstb:1;
+unsigned int     ssc_rstb:1;
+}SYS_PLL_SD4;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     reg_tuned3318:3;
+unsigned int     reg_d3318pow:2;
+unsigned int     regpd_d3318:1;
+unsigned int     reserved_1:3;
+unsigned int     phsel1:5;
+unsigned int     phsel0:5;
+unsigned int     phrstb_dly_sel:1;
+unsigned int     phrt0:1;
+unsigned int     bias_en:1;
+}SYS_PLL_EMMC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     en_cpnew:1;
+unsigned int     ssc_div_ext_f:8;
+unsigned int     ssc_div_f_sel:1;
+unsigned int     ssc_8x_en:1;
+unsigned int     ssc_depth:3;
+unsigned int     sscpll_rs:3;
+unsigned int     sscpll_icp:5;
+unsigned int     sscpll_cs1:2;
+unsigned int     reg_tune11:2;
+unsigned int     sscldo_en:1;
+}SYS_PLL_EMMC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     ssc_div_n:10;
+unsigned int     reserved_1:1;
+unsigned int     ssc_step_in:7;
+unsigned int     ssc_tbase:8;
+}SYS_PLL_EMMC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ssc_pll_pow:1;
+unsigned int     ssc_pll_rstb:1;
+unsigned int     ssc_rstb:1;
+}SYS_PLL_EMMC4;
+
+typedef struct 
+{
+unsigned int     REG_PLL_RESERVED:8;
+unsigned int     reserved_0:16;
+unsigned int     REG_LDO1_POW:1;
+unsigned int     REG_LDO1_SEL:2;
+unsigned int     REG_LDO2_POW:1;
+unsigned int     REG_LDO2_SEL:2;
+unsigned int     VDAC_BGR:2;
+}SYS_BG_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     testmode:1;
+unsigned int     nf_sel:1;
+unsigned int     boot_sel:1;
+}SYS_CHIP_INFO2;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     scpu_l2_bypass:1;
+}SYS_SCPU_L2;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     CMP_OUT1:1;
+unsigned int     PWDB1:1;
+unsigned int     SBG1:3;
+unsigned int     SDATA1:7;
+unsigned int     SINL1:2;
+unsigned int     SOS1:3;
+}SYS_THML_SNSR_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     CMP_OUT2:1;
+unsigned int     PWDB2:1;
+unsigned int     SBG2:3;
+unsigned int     SDATA2:7;
+unsigned int     SINL2:2;
+unsigned int     SOS2:3;
+}SYS_THML_SNSR_CTRL2;
+
+typedef struct 
+{
+unsigned int     scpu_boot_info:32;
+}SYS_PWDN_CTRL;
+
+typedef struct 
+{
+unsigned int     acpu_boot_info:32;
+}SYS_PWDN_CTRL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     write_en2:1;
+unsigned int     scpu_boot_info_valid:1;
+unsigned int     write_en1:1;
+unsigned int     scpu_sw_rst:1;
+}SYS_PWDN_CTRL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     acpu_boot_info_valid:1;
+}SYS_PWDN_CTRL4;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     write_en2:1;
+unsigned int     dac_test:1;
+unsigned int     write_en1:1;
+unsigned int     scpu_config_done:1;
+}SYS_AT_SPEED;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     write_en2:1;
+unsigned int     etn_phy_gpio_en:1;
+unsigned int     write_en1:1;
+unsigned int     etn_phy_125m_en:1;
+}SYS_ANA_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     demod_i2c_saddr:1;
+unsigned int     demod_i2c_sel:1;
+unsigned int     tp2_dm_sel:1;
+unsigned int     tp1_dm_sel:1;
+unsigned int     tp0_dm_sel:1;
+}SYS_TP_DEMOD_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     sata0_func_exist:1;
+}SYS_PHY_FUNC;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     analogy_mode_sel:2;
+}SYS_ANLG;
+
+typedef struct 
+{
+unsigned int     Rvd1:32;
+}SYS_DMY2;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     DP:3;
+unsigned int     reserved_1:1;
+unsigned int     DN:3;
+}SYS_RGMII_PAD;
+
+typedef struct 
+{
+unsigned int     nf_dd_7:2;
+unsigned int     nf_dd_6:2;
+unsigned int     nf_dd_5:2;
+unsigned int     nf_dd_4:2;
+unsigned int     nf_dd_3:2;
+unsigned int     nf_dd_2:2;
+unsigned int     nf_dd_1:2;
+unsigned int     nf_dd_0:2;
+unsigned int     nf_ce_n_1:2;
+unsigned int     nf_ce_n_0:2;
+unsigned int     nf_cle:2;
+unsigned int     nf_ale:2;
+unsigned int     nf_wr_n:2;
+unsigned int     nf_rd_n:2;
+unsigned int     nf_rdy:2;
+unsigned int     reserved_0:2;
+}SYS_MUXPAD0;
+
+typedef struct 
+{
+unsigned int     mmc_data_3:2;
+unsigned int     mmc_data_2:2;
+unsigned int     mmc_data_1:2;
+unsigned int     mmc_data_0:2;
+unsigned int     mmc_cd:2;
+unsigned int     mmc_wp:2;
+unsigned int     mmc_clk:2;
+unsigned int     mmc_cmd:2;
+unsigned int     reserved_0:4;
+unsigned int     sdio_data_3:2;
+unsigned int     sdio_data_2:2;
+unsigned int     sdio_data_1:2;
+unsigned int     sdio_data_0:2;
+unsigned int     sdio_clk:2;
+unsigned int     sdio_cmd:2;
+}SYS_MUXPAD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tp1_clk:2;
+unsigned int     tp1_valid:2;
+unsigned int     tp1_sync:2;
+unsigned int     tp1_data:2;
+unsigned int     reserved_1:8;
+unsigned int     tp0_clk:2;
+unsigned int     tp0_valid:2;
+unsigned int     tp0_sync:2;
+unsigned int     tp0_data:2;
+}SYS_MUXPAD2;
+
+typedef struct 
+{
+unsigned int     sensor_cko_0:2;
+unsigned int     sensor_cko_1:2;
+unsigned int     sensor_rst:2;
+unsigned int     sensor_stb_0:2;
+unsigned int     sensor_stb_1:2;
+unsigned int     ejtag_scpu_loc:2;
+unsigned int     hi_loc:2;
+unsigned int     usb_id:2;
+unsigned int     hdmi_hpd:2;
+unsigned int     spdif:2;
+unsigned int     i2c_scl_5:2;
+unsigned int     i2c_sda_5:2;
+unsigned int     i2c_scl_4:2;
+unsigned int     i2c_sda_4:2;
+unsigned int     i2c_scl_1:2;
+unsigned int     i2c_sda_1:2;
+}SYS_MUXPAD3;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     gpio_8:2;
+unsigned int     gpio_7:2;
+unsigned int     gpio_6:2;
+unsigned int     gpio_5:2;
+unsigned int     gpio_4:2;
+unsigned int     gpio_3:3;
+unsigned int     gpio_2:3;
+unsigned int     gpio_1:3;
+unsigned int     gpio_0:3;
+}SYS_MUXPAD4;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     ao_loc:2;
+unsigned int     arm_trace_dbg_en:1;
+unsigned int     sf_en:1;
+}SYS_MUXPAD5;
+
+typedef struct 
+{
+unsigned int     nf_cle_smt:1;
+unsigned int     nf_cle_e2:1;
+unsigned int     nf_cle_pud_en:1;
+unsigned int     nf_cle_pud_sel:1;
+unsigned int     nf_wr_n_smt:1;
+unsigned int     nf_wr_n_e2:1;
+unsigned int     nf_wr_n_pud_en:1;
+unsigned int     nf_wr_n_pud_sel:1;
+unsigned int     nf_rd_n_smt:1;
+unsigned int     nf_rd_n_e2:1;
+unsigned int     nf_rd_n_pud_en:1;
+unsigned int     nf_rd_n_pud_sel:1;
+unsigned int     nf_rdy_smt:1;
+unsigned int     nf_rdy_e2:1;
+unsigned int     nf_rdy_pud_en:1;
+unsigned int     nf_rdy_pud_sel:1;
+unsigned int     nf_ce_n_1_smt:1;
+unsigned int     nf_ce_n_1_e2:1;
+unsigned int     nf_ce_n_1_pud_en:1;
+unsigned int     nf_ce_n_1_pud_sel:1;
+unsigned int     nf_ce_n_0_smt:1;
+unsigned int     nf_ce_n_0_e2:1;
+unsigned int     nf_ce_n_0_pud_en:1;
+unsigned int     nf_ce_n_0_pud_sel:1;
+unsigned int     nf_ale_smt:1;
+unsigned int     nf_ale_e2:1;
+unsigned int     nf_ale_pud_en:1;
+unsigned int     nf_ale_pud_sel:1;
+unsigned int     reserved_0:4;
+}SYS_PFUNC_NF0;
+
+typedef struct 
+{
+unsigned int     nf_dd_7_smt:1;
+unsigned int     nf_dd_7_e2:1;
+unsigned int     nf_dd_7_pud_en:1;
+unsigned int     nf_dd_7_pud_sel:1;
+unsigned int     nf_dd_6_smt:1;
+unsigned int     nf_dd_6_e2:1;
+unsigned int     nf_dd_6_pud_en:1;
+unsigned int     nf_dd_6_pud_sel:1;
+unsigned int     nf_dd_5_smt:1;
+unsigned int     nf_dd_5_e2:1;
+unsigned int     nf_dd_5_pud_en:1;
+unsigned int     nf_dd_5_pud_sel:1;
+unsigned int     nf_dd_4_smt:1;
+unsigned int     nf_dd_4_e2:1;
+unsigned int     nf_dd_4_pud_en:1;
+unsigned int     nf_dd_4_pud_sel:1;
+unsigned int     nf_dd_3_smt:1;
+unsigned int     nf_dd_3_e2:1;
+unsigned int     nf_dd_3_pud_en:1;
+unsigned int     nf_dd_3_pud_sel:1;
+unsigned int     nf_dd_2_smt:1;
+unsigned int     nf_dd_2_e2:1;
+unsigned int     nf_dd_2_pud_en:1;
+unsigned int     nf_dd_2_pud_sel:1;
+unsigned int     nf_dd_1_smt:1;
+unsigned int     nf_dd_1_e2:1;
+unsigned int     nf_dd_1_pud_en:1;
+unsigned int     nf_dd_1_pud_sel:1;
+unsigned int     nf_dd_0_smt:1;
+unsigned int     nf_dd_0_e2:1;
+unsigned int     nf_dd_0_pud_en:1;
+unsigned int     nf_dd_0_pud_sel:1;
+}SYS_PFUNC_NF1;
+
+typedef struct 
+{
+unsigned int     mmc_data_3_smt:1;
+unsigned int     mmc_data_3_e2:1;
+unsigned int     mmc_data_3_pud_en:1;
+unsigned int     mmc_data_3_pud_sel:1;
+unsigned int     mmc_data_2_smt:1;
+unsigned int     mmc_data_2_e2:1;
+unsigned int     mmc_data_2_pud_en:1;
+unsigned int     mmc_data_2_pud_sel:1;
+unsigned int     mmc_data_1_smt:1;
+unsigned int     mmc_data_1_e2:1;
+unsigned int     mmc_data_1_pud_en:1;
+unsigned int     mmc_data_1_pud_sel:1;
+unsigned int     mmc_data_0_smt:1;
+unsigned int     mmc_data_0_e2:1;
+unsigned int     mmc_data_0_pud_en:1;
+unsigned int     mmc_data_0_pud_sel:1;
+unsigned int     mmc_cd_smt:1;
+unsigned int     mmc_cd_e2:1;
+unsigned int     mmc_cd_pud_en:1;
+unsigned int     mmc_cd_pud_sel:1;
+unsigned int     mmc_wp_smt:1;
+unsigned int     mmc_wp_e2:1;
+unsigned int     mmc_wp_pud_en:1;
+unsigned int     mmc_wp_pud_sel:1;
+unsigned int     mmc_clk_smt:1;
+unsigned int     mmc_clk_e2:1;
+unsigned int     mmc_clk_pud_en:1;
+unsigned int     mmc_clk_pud_sel:1;
+unsigned int     mmc_cmd_smt:1;
+unsigned int     mmc_cmd_e2:1;
+unsigned int     mmc_cmd_pud_en:1;
+unsigned int     mmc_cmd_pud_sel:1;
+}SYS_PFUNC_CR;
+
+typedef struct 
+{
+unsigned int     sdio_data_3_smt:1;
+unsigned int     sdio_data_3_e2:1;
+unsigned int     sdio_data_3_pud_en:1;
+unsigned int     sdio_data_3_pud_sel:1;
+unsigned int     sdio_data_2_smt:1;
+unsigned int     sdio_data_2_e2:1;
+unsigned int     sdio_data_2_pud_en:1;
+unsigned int     sdio_data_2_pud_sel:1;
+unsigned int     sdio_data_1_smt:1;
+unsigned int     sdio_data_1_e2:1;
+unsigned int     sdio_data_1_pud_en:1;
+unsigned int     sdio_data_1_pud_sel:1;
+unsigned int     sdio_data_0_smt:1;
+unsigned int     sdio_data_0_e2:1;
+unsigned int     sdio_data_0_pud_en:1;
+unsigned int     sdio_data_0_pud_sel:1;
+unsigned int     sdio_cd_smt:1;
+unsigned int     sdio_cd_e2:1;
+unsigned int     sdio_cd_pud_en:1;
+unsigned int     sdio_cd_pud_sel:1;
+unsigned int     sdio_wp_smt:1;
+unsigned int     sdio_wp_e2:1;
+unsigned int     sdio_wp_pud_en:1;
+unsigned int     sdio_wp_pud_sel:1;
+unsigned int     sdio_clk_smt:1;
+unsigned int     sdio_clk_e2:1;
+unsigned int     sdio_clk_pud_en:1;
+unsigned int     sdio_clk_pud_sel:1;
+unsigned int     sdio_cmd_smt:1;
+unsigned int     sdio_cmd_e2:1;
+unsigned int     sdio_cmd_pud_en:1;
+unsigned int     sdio_cmd_pud_sel:1;
+}SYS_PFUNC_SDIO;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     spdif_out_e2:1;
+unsigned int     spdif_out_pud_en:1;
+unsigned int     spdif_out_pud_sel:1;
+}SYS_PFUNC_AIO;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     tp0_data_smt:1;
+unsigned int     tp0_data_e2:1;
+unsigned int     tp0_data_pud_en:1;
+unsigned int     tp0_data_pud_sel:1;
+unsigned int     tp0_valid_smt:1;
+unsigned int     tp0_valid_e2:1;
+unsigned int     tp0_valid_pud_en:1;
+unsigned int     tp0_valid_pud_sel:1;
+unsigned int     tp0_sync_smt:1;
+unsigned int     tp0_sync_e2:1;
+unsigned int     tp0_sync_pud_en:1;
+unsigned int     tp0_sync_pud_sel:1;
+unsigned int     tp0_clk_smt:1;
+unsigned int     tp0_clk_e2:1;
+unsigned int     tp0_clk_pud_en:1;
+unsigned int     tp0_clk_pud_sel:1;
+}SYS_PFUNC_TP0;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     tp1_data_smt:1;
+unsigned int     tp1_data_e2:1;
+unsigned int     tp1_data_pud_en:1;
+unsigned int     tp1_data_pud_sel:1;
+unsigned int     tp1_valid_smt:1;
+unsigned int     tp1_valid_e2:1;
+unsigned int     tp1_valid_pud_en:1;
+unsigned int     tp1_valid_pud_sel:1;
+unsigned int     tp1_sync_smt:1;
+unsigned int     tp1_sync_e2:1;
+unsigned int     tp1_sync_pud_en:1;
+unsigned int     tp1_sync_pud_sel:1;
+unsigned int     tp1_clk_smt:1;
+unsigned int     tp1_clk_e2:1;
+unsigned int     tp1_clk_pud_en:1;
+unsigned int     tp1_clk_pud_sel:1;
+}SYS_PFUNC_TP1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     i2c_scl_5_smt:1;
+unsigned int     i2c_scl_5_e2:1;
+unsigned int     i2c_scl_5_pud_en:1;
+unsigned int     i2c_scl_5_pud_sel:1;
+unsigned int     i2c_sda_5_smt:1;
+unsigned int     i2c_sda_5_e2:1;
+unsigned int     i2c_sda_5_pud_en:1;
+unsigned int     i2c_sda_5_pud_sel:1;
+unsigned int     i2c_scl_4_smt:1;
+unsigned int     i2c_scl_4_e2:1;
+unsigned int     i2c_scl_4_pud_en:1;
+unsigned int     i2c_scl_4_pud_sel:1;
+unsigned int     i2c_sda_4_smt:1;
+unsigned int     i2c_sda_4_e2:1;
+unsigned int     i2c_sda_4_pud_en:1;
+unsigned int     i2c_sda_4_pud_sel:1;
+unsigned int     i2c_scl_1_smt:1;
+unsigned int     i2c_scl_1_e2:1;
+unsigned int     i2c_scl_1_pud_en:1;
+unsigned int     i2c_scl_1_pud_sel:1;
+unsigned int     i2c_sda_1_smt:1;
+unsigned int     i2c_sda_1_e2:1;
+unsigned int     i2c_sda_1_pud_en:1;
+unsigned int     i2c_sda_1_pud_sel:1;
+}SYS_PFUNC_MISC0;
+
+typedef struct 
+{
+unsigned int     gpio_7_smt:1;
+unsigned int     gpio_7_e2:1;
+unsigned int     gpio_7_pud_en:1;
+unsigned int     gpio_7_pud_sel:1;
+unsigned int     gpio_6_smt:1;
+unsigned int     gpio_6_e2:1;
+unsigned int     gpio_6_pud_en:1;
+unsigned int     gpio_6_pud_sel:1;
+unsigned int     gpio_5_smt:1;
+unsigned int     gpio_5_e2:1;
+unsigned int     gpio_5_pud_en:1;
+unsigned int     gpio_5_pud_sel:1;
+unsigned int     gpio_4_smt:1;
+unsigned int     gpio_4_e2:1;
+unsigned int     gpio_4_pud_en:1;
+unsigned int     gpio_4_pud_sel:1;
+unsigned int     gpio_3_smt:1;
+unsigned int     gpio_3_e2:1;
+unsigned int     gpio_3_pud_en:1;
+unsigned int     gpio_3_pud_sel:1;
+unsigned int     gpio_2_smt:1;
+unsigned int     gpio_2_e2:1;
+unsigned int     gpio_2_pud_en:1;
+unsigned int     gpio_2_pud_sel:1;
+unsigned int     gpio_1_smt:1;
+unsigned int     gpio_1_e2:1;
+unsigned int     gpio_1_pud_en:1;
+unsigned int     gpio_1_pud_sel:1;
+unsigned int     gpio_0_smt:1;
+unsigned int     gpio_0_e2:1;
+unsigned int     gpio_0_pud_en:1;
+unsigned int     gpio_0_pud_sel:1;
+}SYS_PFUNC_MISC1;
+
+typedef struct 
+{
+unsigned int     sensor_cko1_smt:1;
+unsigned int     sensor_cko1_e2:1;
+unsigned int     sensor_cko1_pud_en:1;
+unsigned int     sensor_cko1_pud_sel:1;
+unsigned int     sensor_cko0_smt:1;
+unsigned int     sensor_cko0_e2:1;
+unsigned int     sensor_cko0_pud_en:1;
+unsigned int     sensor_cko0_pud_sel:1;
+unsigned int     sensor_rst_smt:1;
+unsigned int     sensor_rst_e2:1;
+unsigned int     sensor_rst_pud_en:1;
+unsigned int     sensor_rst_pud_sel:1;
+unsigned int     sensor_stb1_smt:1;
+unsigned int     sensor_stb1_e2:1;
+unsigned int     sensor_stb1_pud_en:1;
+unsigned int     sensor_stb1_pud_sel:1;
+unsigned int     sensor_stb0_smt:1;
+unsigned int     sensor_stb0_e2:1;
+unsigned int     sensor_stb0_pud_en:1;
+unsigned int     sensor_stb0_pud_sel:1;
+unsigned int     usb_id_smt:1;
+unsigned int     usb_id_e2:1;
+unsigned int     usb_id_pud_en:1;
+unsigned int     usb_id_pud_sel:1;
+unsigned int     hdmi_hpd_smt:1;
+unsigned int     hdmi_hpd_e2:1;
+unsigned int     hdmi_hpd_pud_en:1;
+unsigned int     hdmi_hpd_pud_sel:1;
+unsigned int     gpio_8_smt:1;
+unsigned int     gpio_8_e2:1;
+unsigned int     gpio_8_pud_en:1;
+unsigned int     gpio_8_pud_sel:1;
+}SYS_PFUNC_MISC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     boption9_en:1;
+unsigned int     boption9_sel:1;
+unsigned int     boption8_en:1;
+unsigned int     boption8_sel:1;
+unsigned int     boption7_en:1;
+unsigned int     boption7_sel:1;
+unsigned int     boption6_en:1;
+unsigned int     boption6_sel:1;
+unsigned int     boption5_en:1;
+unsigned int     boption5_sel:1;
+unsigned int     boption4_en:1;
+unsigned int     boption4_sel:1;
+unsigned int     boption3_en:1;
+unsigned int     boption3_sel:1;
+unsigned int     boption1_en:1;
+unsigned int     boption1_sel:1;
+unsigned int     boption0_en:1;
+unsigned int     boption0_sel:1;
+}SYS_PFUNC_MISC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     crt_dbg_en:1;
+unsigned int     crt_dbg_sel0:4;
+unsigned int     crt_dbg_sel1:4;
+}SYS_CRT_DEBUG;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     dbg_en:1;
+unsigned int     dbg_loc:2;
+unsigned int     dbg_sel0:6;
+unsigned int     dbg_sel1:6;
+}SYS_DEBUG;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     mbist_ve2_st:1;
+unsigned int     mbist_ve1_st:1;
+unsigned int     mbist_scpu_st:1;
+unsigned int     mbist_mipi_st:1;
+unsigned int     mbist_usb_st:1;
+unsigned int     mbist_se_st:1;
+unsigned int     mbist_md_st:1;
+unsigned int     mbist_nf_st:1;
+unsigned int     mbist_cr_st:1;
+unsigned int     mbist_etn_st:1;
+unsigned int     mbist_dp_st:1;
+unsigned int     mbist_ae_st:1;
+unsigned int     mbist_acpu_st:1;
+unsigned int     mbist_gpu_st:1;
+unsigned int     mbist_tp_st:1;
+unsigned int     mbist_aio_st:1;
+unsigned int     mbist_pif_st:1;
+unsigned int     mbist_hdmi_st:1;
+unsigned int     mbist_vo_st:1;
+unsigned int     mbist_dc_phy_st:1;
+unsigned int     mbist_dc_sys_st:1;
+unsigned int     mbist_cp_st:1;
+}SYS_MBIST;
+
+typedef struct 
+{
+unsigned int     dummy_reg:32;
+}SYS_DUMMY;
+
+#endif
+
+#define SYS_SOFT_RESET1                                                              0x18000000
+#define SYS_SOFT_RESET1_reg_addr                                                     "0xB8000000"
+#define SYS_SOFT_RESET1_reg                                                          0xB8000000
+#define set_SYS_SOFT_RESET1_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET1_reg)=data)
+#define get_SYS_SOFT_RESET1_reg   (*((volatile unsigned int*) SYS_SOFT_RESET1_reg))
+#define SYS_SOFT_RESET1_inst_adr                                                     "0x0000"
+#define SYS_SOFT_RESET1_inst                                                         0x0000
+#define SYS_SOFT_RESET1_rstn_mipi_shift                                              (30)
+#define SYS_SOFT_RESET1_rstn_mipi_mask                                               (0x40000000)
+#define SYS_SOFT_RESET1_rstn_mipi(data)                                              (0x40000000&((data)<<30))
+#define SYS_SOFT_RESET1_rstn_mipi_src(data)                                          ((0x40000000&(data))>>30)
+#define SYS_SOFT_RESET1_get_rstn_mipi(data)                                          ((0x40000000&(data))>>30)
+#define SYS_SOFT_RESET1_rstn_nf_shift                                                (29)
+#define SYS_SOFT_RESET1_rstn_nf_mask                                                 (0x20000000)
+#define SYS_SOFT_RESET1_rstn_nf(data)                                                (0x20000000&((data)<<29))
+#define SYS_SOFT_RESET1_rstn_nf_src(data)                                            ((0x20000000&(data))>>29)
+#define SYS_SOFT_RESET1_get_rstn_nf(data)                                            ((0x20000000&(data))>>29)
+#define SYS_SOFT_RESET1_rstn_ae_shift                                                (28)
+#define SYS_SOFT_RESET1_rstn_ae_mask                                                 (0x10000000)
+#define SYS_SOFT_RESET1_rstn_ae(data)                                                (0x10000000&((data)<<28))
+#define SYS_SOFT_RESET1_rstn_ae_src(data)                                            ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET1_get_rstn_ae(data)                                            ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET1_rstn_tp_shift                                                (27)
+#define SYS_SOFT_RESET1_rstn_tp_mask                                                 (0x08000000)
+#define SYS_SOFT_RESET1_rstn_tp(data)                                                (0x08000000&((data)<<27))
+#define SYS_SOFT_RESET1_rstn_tp_src(data)                                            ((0x08000000&(data))>>27)
+#define SYS_SOFT_RESET1_get_rstn_tp(data)                                            ((0x08000000&(data))>>27)
+#define SYS_SOFT_RESET1_rstn_md_shift                                                (26)
+#define SYS_SOFT_RESET1_rstn_md_mask                                                 (0x04000000)
+#define SYS_SOFT_RESET1_rstn_md(data)                                                (0x04000000&((data)<<26))
+#define SYS_SOFT_RESET1_rstn_md_src(data)                                            ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET1_get_rstn_md(data)                                            ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET1_rstn_cp_shift                                                (25)
+#define SYS_SOFT_RESET1_rstn_cp_mask                                                 (0x02000000)
+#define SYS_SOFT_RESET1_rstn_cp(data)                                                (0x02000000&((data)<<25))
+#define SYS_SOFT_RESET1_rstn_cp_src(data)                                            ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET1_get_rstn_cp(data)                                            ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET1_rstn_dc_phy_shift                                            (24)
+#define SYS_SOFT_RESET1_rstn_dc_phy_mask                                             (0x01000000)
+#define SYS_SOFT_RESET1_rstn_dc_phy(data)                                            (0x01000000&((data)<<24))
+#define SYS_SOFT_RESET1_rstn_dc_phy_src(data)                                        ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET1_get_rstn_dc_phy(data)                                        ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET1_rstn_dcu_shift                                               (23)
+#define SYS_SOFT_RESET1_rstn_dcu_mask                                                (0x00800000)
+#define SYS_SOFT_RESET1_rstn_dcu(data)                                               (0x00800000&((data)<<23))
+#define SYS_SOFT_RESET1_rstn_dcu_src(data)                                           ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET1_get_rstn_dcu(data)                                           ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET1_rstn_se_shift                                                (22)
+#define SYS_SOFT_RESET1_rstn_se_mask                                                 (0x00400000)
+#define SYS_SOFT_RESET1_rstn_se(data)                                                (0x00400000&((data)<<22))
+#define SYS_SOFT_RESET1_rstn_se_src(data)                                            ((0x00400000&(data))>>22)
+#define SYS_SOFT_RESET1_get_rstn_se(data)                                            ((0x00400000&(data))>>22)
+#define SYS_SOFT_RESET1_rstn_lvds_shift                                              (21)
+#define SYS_SOFT_RESET1_rstn_lvds_mask                                               (0x00200000)
+#define SYS_SOFT_RESET1_rstn_lvds(data)                                              (0x00200000&((data)<<21))
+#define SYS_SOFT_RESET1_rstn_lvds_src(data)                                          ((0x00200000&(data))>>21)
+#define SYS_SOFT_RESET1_get_rstn_lvds(data)                                          ((0x00200000&(data))>>21)
+#define SYS_SOFT_RESET1_rstn_vo_shift                                                (20)
+#define SYS_SOFT_RESET1_rstn_vo_mask                                                 (0x00100000)
+#define SYS_SOFT_RESET1_rstn_vo(data)                                                (0x00100000&((data)<<20))
+#define SYS_SOFT_RESET1_rstn_vo_src(data)                                            ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET1_get_rstn_vo(data)                                            ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET1_rstn_tve_shift                                               (19)
+#define SYS_SOFT_RESET1_rstn_tve_mask                                                (0x00080000)
+#define SYS_SOFT_RESET1_rstn_tve(data)                                               (0x00080000&((data)<<19))
+#define SYS_SOFT_RESET1_rstn_tve_src(data)                                           ((0x00080000&(data))>>19)
+#define SYS_SOFT_RESET1_get_rstn_tve(data)                                           ((0x00080000&(data))>>19)
+#define SYS_SOFT_RESET1_rstn_ve_jpeg_shift                                           (18)
+#define SYS_SOFT_RESET1_rstn_ve_jpeg_mask                                            (0x00040000)
+#define SYS_SOFT_RESET1_rstn_ve_jpeg(data)                                           (0x00040000&((data)<<18))
+#define SYS_SOFT_RESET1_rstn_ve_jpeg_src(data)                                       ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET1_get_rstn_ve_jpeg(data)                                       ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET1_rstn_ve_h264_shift                                           (17)
+#define SYS_SOFT_RESET1_rstn_ve_h264_mask                                            (0x00020000)
+#define SYS_SOFT_RESET1_rstn_ve_h264(data)                                           (0x00020000&((data)<<17))
+#define SYS_SOFT_RESET1_rstn_ve_h264_src(data)                                       ((0x00020000&(data))>>17)
+#define SYS_SOFT_RESET1_get_rstn_ve_h264(data)                                       ((0x00020000&(data))>>17)
+#define SYS_SOFT_RESET1_rstn_gpu_shift                                               (16)
+#define SYS_SOFT_RESET1_rstn_gpu_mask                                                (0x00010000)
+#define SYS_SOFT_RESET1_rstn_gpu(data)                                               (0x00010000&((data)<<16))
+#define SYS_SOFT_RESET1_rstn_gpu_src(data)                                           ((0x00010000&(data))>>16)
+#define SYS_SOFT_RESET1_get_rstn_gpu(data)                                           ((0x00010000&(data))>>16)
+#define SYS_SOFT_RESET1_rstn_aio_shift                                               (15)
+#define SYS_SOFT_RESET1_rstn_aio_mask                                                (0x00008000)
+#define SYS_SOFT_RESET1_rstn_aio(data)                                               (0x00008000&((data)<<15))
+#define SYS_SOFT_RESET1_rstn_aio_src(data)                                           ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET1_get_rstn_aio(data)                                           ((0x00008000&(data))>>15)
+#define SYS_SOFT_RESET1_rstn_etn_shift                                               (14)
+#define SYS_SOFT_RESET1_rstn_etn_mask                                                (0x00004000)
+#define SYS_SOFT_RESET1_rstn_etn(data)                                               (0x00004000&((data)<<14))
+#define SYS_SOFT_RESET1_rstn_etn_src(data)                                           ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET1_get_rstn_etn(data)                                           ((0x00004000&(data))>>14)
+#define SYS_SOFT_RESET1_rstn_hdmi_shift                                              (12)
+#define SYS_SOFT_RESET1_rstn_hdmi_mask                                               (0x00001000)
+#define SYS_SOFT_RESET1_rstn_hdmi(data)                                              (0x00001000&((data)<<12))
+#define SYS_SOFT_RESET1_rstn_hdmi_src(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET1_get_rstn_hdmi(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET1_rstn_hdmirx_shift                                            (11)
+#define SYS_SOFT_RESET1_rstn_hdmirx_mask                                             (0x00000800)
+#define SYS_SOFT_RESET1_rstn_hdmirx(data)                                            (0x00000800&((data)<<11))
+#define SYS_SOFT_RESET1_rstn_hdmirx_src(data)                                        ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET1_get_rstn_hdmirx(data)                                        ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET1_rstn_usb_phy1_shift                                          (9)
+#define SYS_SOFT_RESET1_rstn_usb_phy1_mask                                           (0x00000200)
+#define SYS_SOFT_RESET1_rstn_usb_phy1(data)                                          (0x00000200&((data)<<9))
+#define SYS_SOFT_RESET1_rstn_usb_phy1_src(data)                                      ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET1_get_rstn_usb_phy1(data)                                      ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET1_rstn_usb_phy0_shift                                          (8)
+#define SYS_SOFT_RESET1_rstn_usb_phy0_mask                                           (0x00000100)
+#define SYS_SOFT_RESET1_rstn_usb_phy0(data)                                          (0x00000100&((data)<<8))
+#define SYS_SOFT_RESET1_rstn_usb_phy0_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET1_get_rstn_usb_phy0(data)                                      ((0x00000100&(data))>>8)
+#define SYS_SOFT_RESET1_rstn_usb_shift                                               (6)
+#define SYS_SOFT_RESET1_rstn_usb_mask                                                (0x00000040)
+#define SYS_SOFT_RESET1_rstn_usb(data)                                               (0x00000040&((data)<<6))
+#define SYS_SOFT_RESET1_rstn_usb_src(data)                                           ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET1_get_rstn_usb(data)                                           ((0x00000040&(data))>>6)
+#define SYS_SOFT_RESET1_rstn_ve_h265_shift                                           (5)
+#define SYS_SOFT_RESET1_rstn_ve_h265_mask                                            (0x00000020)
+#define SYS_SOFT_RESET1_rstn_ve_h265(data)                                           (0x00000020&((data)<<5))
+#define SYS_SOFT_RESET1_rstn_ve_h265_src(data)                                       ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET1_get_rstn_ve_h265(data)                                       ((0x00000020&(data))>>5)
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio_shift                                      (4)
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio_mask                                       (0x00000010)
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio(data)                                      (0x00000010&((data)<<4))
+#define SYS_SOFT_RESET1_rstn_usb3_p0_mdio_src(data)                                  ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET1_get_rstn_usb3_p0_mdio(data)                                  ((0x00000010&(data))>>4)
+#define SYS_SOFT_RESET1_rstn_gspi_shift                                              (3)
+#define SYS_SOFT_RESET1_rstn_gspi_mask                                               (0x00000008)
+#define SYS_SOFT_RESET1_rstn_gspi(data)                                              (0x00000008&((data)<<3))
+#define SYS_SOFT_RESET1_rstn_gspi_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET1_get_rstn_gspi(data)                                          ((0x00000008&(data))>>3)
+#define SYS_SOFT_RESET1_rstn_usb3_pow_shift                                          (2)
+#define SYS_SOFT_RESET1_rstn_usb3_pow_mask                                           (0x00000004)
+#define SYS_SOFT_RESET1_rstn_usb3_pow(data)                                          (0x00000004&((data)<<2))
+#define SYS_SOFT_RESET1_rstn_usb3_pow_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET1_get_rstn_usb3_pow(data)                                      ((0x00000004&(data))>>2)
+#define SYS_SOFT_RESET1_rstn_rng_shift                                               (1)
+#define SYS_SOFT_RESET1_rstn_rng_mask                                                (0x00000002)
+#define SYS_SOFT_RESET1_rstn_rng(data)                                               (0x00000002&((data)<<1))
+#define SYS_SOFT_RESET1_rstn_rng_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET1_get_rstn_rng(data)                                           ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET1_rstn_misc_shift                                              (0)
+#define SYS_SOFT_RESET1_rstn_misc_mask                                               (0x00000001)
+#define SYS_SOFT_RESET1_rstn_misc(data)                                              (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET1_rstn_misc_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET1_get_rstn_misc(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_SOFT_RESET2                                                              0x18000004
+#define SYS_SOFT_RESET2_reg_addr                                                     "0xB8000004"
+#define SYS_SOFT_RESET2_reg                                                          0xB8000004
+#define set_SYS_SOFT_RESET2_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET2_reg)=data)
+#define get_SYS_SOFT_RESET2_reg   (*((volatile unsigned int*) SYS_SOFT_RESET2_reg))
+#define SYS_SOFT_RESET2_inst_adr                                                     "0x0001"
+#define SYS_SOFT_RESET2_inst                                                         0x0001
+#define SYS_SOFT_RESET2_rstn_ur1_shift                                               (28)
+#define SYS_SOFT_RESET2_rstn_ur1_mask                                                (0x10000000)
+#define SYS_SOFT_RESET2_rstn_ur1(data)                                               (0x10000000&((data)<<28))
+#define SYS_SOFT_RESET2_rstn_ur1_src(data)                                           ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET2_get_rstn_ur1(data)                                           ((0x10000000&(data))>>28)
+#define SYS_SOFT_RESET2_rstn_i2c_1_shift                                             (26)
+#define SYS_SOFT_RESET2_rstn_i2c_1_mask                                              (0x04000000)
+#define SYS_SOFT_RESET2_rstn_i2c_1(data)                                             (0x04000000&((data)<<26))
+#define SYS_SOFT_RESET2_rstn_i2c_1_src(data)                                         ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET2_get_rstn_i2c_1(data)                                         ((0x04000000&(data))>>26)
+#define SYS_SOFT_RESET2_rstn_i2c_2_shift                                             (25)
+#define SYS_SOFT_RESET2_rstn_i2c_2_mask                                              (0x02000000)
+#define SYS_SOFT_RESET2_rstn_i2c_2(data)                                             (0x02000000&((data)<<25))
+#define SYS_SOFT_RESET2_rstn_i2c_2_src(data)                                         ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET2_get_rstn_i2c_2(data)                                         ((0x02000000&(data))>>25)
+#define SYS_SOFT_RESET2_rstn_i2c_3_shift                                             (24)
+#define SYS_SOFT_RESET2_rstn_i2c_3_mask                                              (0x01000000)
+#define SYS_SOFT_RESET2_rstn_i2c_3(data)                                             (0x01000000&((data)<<24))
+#define SYS_SOFT_RESET2_rstn_i2c_3_src(data)                                         ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET2_get_rstn_i2c_3(data)                                         ((0x01000000&(data))>>24)
+#define SYS_SOFT_RESET2_rstn_i2c_4_shift                                             (23)
+#define SYS_SOFT_RESET2_rstn_i2c_4_mask                                              (0x00800000)
+#define SYS_SOFT_RESET2_rstn_i2c_4(data)                                             (0x00800000&((data)<<23))
+#define SYS_SOFT_RESET2_rstn_i2c_4_src(data)                                         ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET2_get_rstn_i2c_4(data)                                         ((0x00800000&(data))>>23)
+#define SYS_SOFT_RESET2_rstn_rtc_shift                                               (20)
+#define SYS_SOFT_RESET2_rstn_rtc_mask                                                (0x00100000)
+#define SYS_SOFT_RESET2_rstn_rtc(data)                                               (0x00100000&((data)<<20))
+#define SYS_SOFT_RESET2_rstn_rtc_src(data)                                           ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET2_get_rstn_rtc(data)                                           ((0x00100000&(data))>>20)
+#define SYS_SOFT_RESET2_rstn_i2c_5_shift                                             (18)
+#define SYS_SOFT_RESET2_rstn_i2c_5_mask                                              (0x00040000)
+#define SYS_SOFT_RESET2_rstn_i2c_5(data)                                             (0x00040000&((data)<<18))
+#define SYS_SOFT_RESET2_rstn_i2c_5_src(data)                                         ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET2_get_rstn_i2c_5(data)                                         ((0x00040000&(data))>>18)
+#define SYS_SOFT_RESET2_rstn_sdio_shift                                              (12)
+#define SYS_SOFT_RESET2_rstn_sdio_mask                                               (0x00001000)
+#define SYS_SOFT_RESET2_rstn_sdio(data)                                              (0x00001000&((data)<<12))
+#define SYS_SOFT_RESET2_rstn_sdio_src(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET2_get_rstn_sdio(data)                                          ((0x00001000&(data))>>12)
+#define SYS_SOFT_RESET2_rstn_emmc_shift                                              (11)
+#define SYS_SOFT_RESET2_rstn_emmc_mask                                               (0x00000800)
+#define SYS_SOFT_RESET2_rstn_emmc(data)                                              (0x00000800&((data)<<11))
+#define SYS_SOFT_RESET2_rstn_emmc_src(data)                                          ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET2_get_rstn_emmc(data)                                          ((0x00000800&(data))>>11)
+#define SYS_SOFT_RESET2_rstn_cr_shift                                                (10)
+#define SYS_SOFT_RESET2_rstn_cr_mask                                                 (0x00000400)
+#define SYS_SOFT_RESET2_rstn_cr(data)                                                (0x00000400&((data)<<10))
+#define SYS_SOFT_RESET2_rstn_cr_src(data)                                            ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET2_get_rstn_cr(data)                                            ((0x00000400&(data))>>10)
+#define SYS_SOFT_RESET2_rstn_pcr_cnt_shift                                           (9)
+#define SYS_SOFT_RESET2_rstn_pcr_cnt_mask                                            (0x00000200)
+#define SYS_SOFT_RESET2_rstn_pcr_cnt(data)                                           (0x00000200&((data)<<9))
+#define SYS_SOFT_RESET2_rstn_pcr_cnt_src(data)                                       ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET2_get_rstn_pcr_cnt(data)                                       ((0x00000200&(data))>>9)
+#define SYS_SOFT_RESET2_rstn_vcpu_shift                                              (1)
+#define SYS_SOFT_RESET2_rstn_vcpu_mask                                               (0x00000002)
+#define SYS_SOFT_RESET2_rstn_vcpu(data)                                              (0x00000002&((data)<<1))
+#define SYS_SOFT_RESET2_rstn_vcpu_src(data)                                          ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET2_get_rstn_vcpu(data)                                          ((0x00000002&(data))>>1)
+#define SYS_SOFT_RESET2_rstn_acpu_shift                                              (0)
+#define SYS_SOFT_RESET2_rstn_acpu_mask                                               (0x00000001)
+#define SYS_SOFT_RESET2_rstn_acpu(data)                                              (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET2_rstn_acpu_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET2_get_rstn_acpu(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_SOFT_RESET3                                                              0x18000008
+#define SYS_SOFT_RESET3_reg_addr                                                     "0xB8000008"
+#define SYS_SOFT_RESET3_reg                                                          0xB8000008
+#define set_SYS_SOFT_RESET3_reg(data)   (*((volatile unsigned int*) SYS_SOFT_RESET3_reg)=data)
+#define get_SYS_SOFT_RESET3_reg   (*((volatile unsigned int*) SYS_SOFT_RESET3_reg))
+#define SYS_SOFT_RESET3_inst_adr                                                     "0x0002"
+#define SYS_SOFT_RESET3_inst                                                         0x0002
+#define SYS_SOFT_RESET3_rstn_sb2_shift                                               (0)
+#define SYS_SOFT_RESET3_rstn_sb2_mask                                                (0x00000001)
+#define SYS_SOFT_RESET3_rstn_sb2(data)                                               (0x00000001&((data)<<0))
+#define SYS_SOFT_RESET3_rstn_sb2_src(data)                                           ((0x00000001&(data))>>0)
+#define SYS_SOFT_RESET3_get_rstn_sb2(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SYS_CLOCK_ENABLE1                                                            0x1800000C
+#define SYS_CLOCK_ENABLE1_reg_addr                                                   "0xB800000C"
+#define SYS_CLOCK_ENABLE1_reg                                                        0xB800000C
+#define set_SYS_CLOCK_ENABLE1_reg(data)   (*((volatile unsigned int*) SYS_CLOCK_ENABLE1_reg)=data)
+#define get_SYS_CLOCK_ENABLE1_reg   (*((volatile unsigned int*) SYS_CLOCK_ENABLE1_reg))
+#define SYS_CLOCK_ENABLE1_inst_adr                                                   "0x0003"
+#define SYS_CLOCK_ENABLE1_inst                                                       0x0003
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_shift                                          (30)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_mask                                           (0x40000000)
+#define SYS_CLOCK_ENABLE1_clk_en_sdio(data)                                          (0x40000000&((data)<<30))
+#define SYS_CLOCK_ENABLE1_clk_en_sdio_src(data)                                      ((0x40000000&(data))>>30)
+#define SYS_CLOCK_ENABLE1_get_clk_en_sdio(data)                                      ((0x40000000&(data))>>30)
+#define SYS_CLOCK_ENABLE1_clk_en_ve_h265_shift                                       (29)
+#define SYS_CLOCK_ENABLE1_clk_en_ve_h265_mask                                        (0x20000000)
+#define SYS_CLOCK_ENABLE1_clk_en_ve_h265(data)                                       (0x20000000&((data)<<29))
+#define SYS_CLOCK_ENABLE1_clk_en_ve_h265_src(data)                                   ((0x20000000&(data))>>29)
+#define SYS_CLOCK_ENABLE1_get_clk_en_ve_h265(data)                                   ((0x20000000&(data))>>29)
+#define SYS_CLOCK_ENABLE1_clk_en_mipi_shift                                          (27)
+#define SYS_CLOCK_ENABLE1_clk_en_mipi_mask                                           (0x08000000)
+#define SYS_CLOCK_ENABLE1_clk_en_mipi(data)                                          (0x08000000&((data)<<27))
+#define SYS_CLOCK_ENABLE1_clk_en_mipi_src(data)                                      ((0x08000000&(data))>>27)
+#define SYS_CLOCK_ENABLE1_get_clk_en_mipi(data)                                      ((0x08000000&(data))>>27)
+#define SYS_CLOCK_ENABLE1_clk_en_cr_shift                                            (25)
+#define SYS_CLOCK_ENABLE1_clk_en_cr_mask                                             (0x02000000)
+#define SYS_CLOCK_ENABLE1_clk_en_cr(data)                                            (0x02000000&((data)<<25))
+#define SYS_CLOCK_ENABLE1_clk_en_cr_src(data)                                        ((0x02000000&(data))>>25)
+#define SYS_CLOCK_ENABLE1_get_clk_en_cr(data)                                        ((0x02000000&(data))>>25)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_shift                                          (24)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_mask                                           (0x01000000)
+#define SYS_CLOCK_ENABLE1_clk_en_emmc(data)                                          (0x01000000&((data)<<24))
+#define SYS_CLOCK_ENABLE1_clk_en_emmc_src(data)                                      ((0x01000000&(data))>>24)
+#define SYS_CLOCK_ENABLE1_get_clk_en_emmc(data)                                      ((0x01000000&(data))>>24)
+#define SYS_CLOCK_ENABLE1_clk_en_nf_shift                                            (23)
+#define SYS_CLOCK_ENABLE1_clk_en_nf_mask                                             (0x00800000)
+#define SYS_CLOCK_ENABLE1_clk_en_nf(data)                                            (0x00800000&((data)<<23))
+#define SYS_CLOCK_ENABLE1_clk_en_nf_src(data)                                        ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE1_get_clk_en_nf(data)                                        ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE1_clk_en_tp_shift                                            (21)
+#define SYS_CLOCK_ENABLE1_clk_en_tp_mask                                             (0x00200000)
+#define SYS_CLOCK_ENABLE1_clk_en_tp(data)                                            (0x00200000&((data)<<21))
+#define SYS_CLOCK_ENABLE1_clk_en_tp_src(data)                                        ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE1_get_clk_en_tp(data)                                        ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE1_clk_en_md_shift                                            (20)
+#define SYS_CLOCK_ENABLE1_clk_en_md_mask                                             (0x00100000)
+#define SYS_CLOCK_ENABLE1_clk_en_md(data)                                            (0x00100000&((data)<<20))
+#define SYS_CLOCK_ENABLE1_clk_en_md_src(data)                                        ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE1_get_clk_en_md(data)                                        ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE1_clk_en_cp_shift                                            (19)
+#define SYS_CLOCK_ENABLE1_clk_en_cp_mask                                             (0x00080000)
+#define SYS_CLOCK_ENABLE1_clk_en_cp(data)                                            (0x00080000&((data)<<19))
+#define SYS_CLOCK_ENABLE1_clk_en_cp_src(data)                                        ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE1_get_clk_en_cp(data)                                        ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE1_clk_en_dcu_shift                                           (18)
+#define SYS_CLOCK_ENABLE1_clk_en_dcu_mask                                            (0x00040000)
+#define SYS_CLOCK_ENABLE1_clk_en_dcu(data)                                           (0x00040000&((data)<<18))
+#define SYS_CLOCK_ENABLE1_clk_en_dcu_src(data)                                       ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE1_get_clk_en_dcu(data)                                       ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE1_clk_en_se_shift                                            (17)
+#define SYS_CLOCK_ENABLE1_clk_en_se_mask                                             (0x00020000)
+#define SYS_CLOCK_ENABLE1_clk_en_se(data)                                            (0x00020000&((data)<<17))
+#define SYS_CLOCK_ENABLE1_clk_en_se_src(data)                                        ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE1_get_clk_en_se(data)                                        ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE1_clk_en_lvds_shift                                          (16)
+#define SYS_CLOCK_ENABLE1_clk_en_lvds_mask                                           (0x00010000)
+#define SYS_CLOCK_ENABLE1_clk_en_lvds(data)                                          (0x00010000&((data)<<16))
+#define SYS_CLOCK_ENABLE1_clk_en_lvds_src(data)                                      ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE1_get_clk_en_lvds(data)                                      ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE1_clk_en_vo_shift                                            (15)
+#define SYS_CLOCK_ENABLE1_clk_en_vo_mask                                             (0x00008000)
+#define SYS_CLOCK_ENABLE1_clk_en_vo(data)                                            (0x00008000&((data)<<15))
+#define SYS_CLOCK_ENABLE1_clk_en_vo_src(data)                                        ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE1_get_clk_en_vo(data)                                        ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE1_clk_en_tve_shift                                           (14)
+#define SYS_CLOCK_ENABLE1_clk_en_tve_mask                                            (0x00004000)
+#define SYS_CLOCK_ENABLE1_clk_en_tve(data)                                           (0x00004000&((data)<<14))
+#define SYS_CLOCK_ENABLE1_clk_en_tve_src(data)                                       ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE1_get_clk_en_tve(data)                                       ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE1_clk_en_ve_jpeg_shift                                       (13)
+#define SYS_CLOCK_ENABLE1_clk_en_ve_jpeg_mask                                        (0x00002000)
+#define SYS_CLOCK_ENABLE1_clk_en_ve_jpeg(data)                                       (0x00002000&((data)<<13))
+#define SYS_CLOCK_ENABLE1_clk_en_ve_jpeg_src(data)                                   ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE1_get_clk_en_ve_jpeg(data)                                   ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE1_clk_en_ve_h264_shift                                       (12)
+#define SYS_CLOCK_ENABLE1_clk_en_ve_h264_mask                                        (0x00001000)
+#define SYS_CLOCK_ENABLE1_clk_en_ve_h264(data)                                       (0x00001000&((data)<<12))
+#define SYS_CLOCK_ENABLE1_clk_en_ve_h264_src(data)                                   ((0x00001000&(data))>>12)
+#define SYS_CLOCK_ENABLE1_get_clk_en_ve_h264(data)                                   ((0x00001000&(data))>>12)
+#define SYS_CLOCK_ENABLE1_clk_en_gpu_shift                                           (11)
+#define SYS_CLOCK_ENABLE1_clk_en_gpu_mask                                            (0x00000800)
+#define SYS_CLOCK_ENABLE1_clk_en_gpu(data)                                           (0x00000800&((data)<<11))
+#define SYS_CLOCK_ENABLE1_clk_en_gpu_src(data)                                       ((0x00000800&(data))>>11)
+#define SYS_CLOCK_ENABLE1_get_clk_en_gpu(data)                                       ((0x00000800&(data))>>11)
+#define SYS_CLOCK_ENABLE1_clk_en_aio_shift                                           (10)
+#define SYS_CLOCK_ENABLE1_clk_en_aio_mask                                            (0x00000400)
+#define SYS_CLOCK_ENABLE1_clk_en_aio(data)                                           (0x00000400&((data)<<10))
+#define SYS_CLOCK_ENABLE1_clk_en_aio_src(data)                                       ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE1_get_clk_en_aio(data)                                       ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE1_clk_en_etn_shift                                           (9)
+#define SYS_CLOCK_ENABLE1_clk_en_etn_mask                                            (0x00000200)
+#define SYS_CLOCK_ENABLE1_clk_en_etn(data)                                           (0x00000200&((data)<<9))
+#define SYS_CLOCK_ENABLE1_clk_en_etn_src(data)                                       ((0x00000200&(data))>>9)
+#define SYS_CLOCK_ENABLE1_get_clk_en_etn(data)                                       ((0x00000200&(data))>>9)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi_shift                                          (8)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi_mask                                           (0x00000100)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi(data)                                          (0x00000100&((data)<<8))
+#define SYS_CLOCK_ENABLE1_clk_en_hdmi_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_CLOCK_ENABLE1_get_clk_en_hdmi(data)                                      ((0x00000100&(data))>>8)
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc_shift                                      (6)
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc_mask                                       (0x00000040)
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc(data)                                      (0x00000040&((data)<<6))
+#define SYS_CLOCK_ENABLE1_clk_en_iso_misc_src(data)                                  ((0x00000040&(data))>>6)
+#define SYS_CLOCK_ENABLE1_get_clk_en_iso_misc(data)                                  ((0x00000040&(data))>>6)
+#define SYS_CLOCK_ENABLE1_clk_en_pcr_shift                                           (5)
+#define SYS_CLOCK_ENABLE1_clk_en_pcr_mask                                            (0x00000020)
+#define SYS_CLOCK_ENABLE1_clk_en_pcr(data)                                           (0x00000020&((data)<<5))
+#define SYS_CLOCK_ENABLE1_clk_en_pcr_src(data)                                       ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE1_get_clk_en_pcr(data)                                       ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE1_clk_en_usb_shift                                           (4)
+#define SYS_CLOCK_ENABLE1_clk_en_usb_mask                                            (0x00000010)
+#define SYS_CLOCK_ENABLE1_clk_en_usb(data)                                           (0x00000010&((data)<<4))
+#define SYS_CLOCK_ENABLE1_clk_en_usb_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE1_get_clk_en_usb(data)                                       ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE1_clk_en_gspi_shift                                          (3)
+#define SYS_CLOCK_ENABLE1_clk_en_gspi_mask                                           (0x00000008)
+#define SYS_CLOCK_ENABLE1_clk_en_gspi(data)                                          (0x00000008&((data)<<3))
+#define SYS_CLOCK_ENABLE1_clk_en_gspi_src(data)                                      ((0x00000008&(data))>>3)
+#define SYS_CLOCK_ENABLE1_get_clk_en_gspi(data)                                      ((0x00000008&(data))>>3)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmirx_shift                                        (1)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmirx_mask                                         (0x00000002)
+#define SYS_CLOCK_ENABLE1_clk_en_hdmirx(data)                                        (0x00000002&((data)<<1))
+#define SYS_CLOCK_ENABLE1_clk_en_hdmirx_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE1_get_clk_en_hdmirx(data)                                    ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE1_clk_en_misc_shift                                          (0)
+#define SYS_CLOCK_ENABLE1_clk_en_misc_mask                                           (0x00000001)
+#define SYS_CLOCK_ENABLE1_clk_en_misc(data)                                          (0x00000001&((data)<<0))
+#define SYS_CLOCK_ENABLE1_clk_en_misc_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_CLOCK_ENABLE1_get_clk_en_misc(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_CLOCK_ENABLE2                                                            0x18000010
+#define SYS_CLOCK_ENABLE2_reg_addr                                                   "0xB8000010"
+#define SYS_CLOCK_ENABLE2_reg                                                        0xB8000010
+#define set_SYS_CLOCK_ENABLE2_reg(data)   (*((volatile unsigned int*) SYS_CLOCK_ENABLE2_reg)=data)
+#define get_SYS_CLOCK_ENABLE2_reg   (*((volatile unsigned int*) SYS_CLOCK_ENABLE2_reg))
+#define SYS_CLOCK_ENABLE2_inst_adr                                                   "0x0004"
+#define SYS_CLOCK_ENABLE2_inst                                                       0x0004
+#define SYS_CLOCK_ENABLE2_clk_en_ur1_shift                                           (28)
+#define SYS_CLOCK_ENABLE2_clk_en_ur1_mask                                            (0x10000000)
+#define SYS_CLOCK_ENABLE2_clk_en_ur1(data)                                           (0x10000000&((data)<<28))
+#define SYS_CLOCK_ENABLE2_clk_en_ur1_src(data)                                       ((0x10000000&(data))>>28)
+#define SYS_CLOCK_ENABLE2_get_clk_en_ur1(data)                                       ((0x10000000&(data))>>28)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk_shift                                      (23)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk_mask                                       (0x00800000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk(data)                                      (0x00800000&((data)<<23))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mclk_src(data)                                  ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_mclk(data)                                  ((0x00800000&(data))>>23)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s_shift                                       (22)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s_mask                                        (0x00400000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s(data)                                       (0x00400000&((data)<<22))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_i2s_src(data)                                   ((0x00400000&(data))>>22)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_i2s(data)                                   ((0x00400000&(data))>>22)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif_shift                                     (21)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif_mask                                      (0x00200000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif(data)                                     (0x00200000&((data)<<21))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_spdif_src(data)                                 ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_spdif(data)                                 ((0x00200000&(data))>>21)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi_shift                                      (20)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi_mask                                       (0x00100000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi(data)                                      (0x00100000&((data)<<20))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_hdmi_src(data)                                  ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_hdmi(data)                                  ((0x00100000&(data))>>20)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da_shift                                        (19)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da_mask                                         (0x00080000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da(data)                                        (0x00080000&((data)<<19))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_da_src(data)                                    ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_da(data)                                    ((0x00080000&(data))>>19)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod_shift                                       (18)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod_mask                                        (0x00040000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod(data)                                       (0x00040000&((data)<<18))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_mod_src(data)                                   ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_mod(data)                                   ((0x00040000&(data))>>18)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec_shift                                  (17)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec_mask                                   (0x00020000)
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec(data)                                  (0x00020000&((data)<<17))
+#define SYS_CLOCK_ENABLE2_clk_en_aio_au_codec_src(data)                              ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE2_get_clk_en_aio_au_codec(data)                              ((0x00020000&(data))>>17)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1_shift                                    (16)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1_mask                                     (0x00010000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1(data)                                    (0x00010000&((data)<<16))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_1_src(data)                                ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_1(data)                                ((0x00010000&(data))>>16)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2_shift                                    (15)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2_mask                                     (0x00008000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2(data)                                    (0x00008000&((data)<<15))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_2_src(data)                                ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_2(data)                                ((0x00008000&(data))>>15)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3_shift                                    (14)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3_mask                                     (0x00004000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3(data)                                    (0x00004000&((data)<<14))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_3_src(data)                                ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_3(data)                                ((0x00004000&(data))>>14)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4_shift                                    (13)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4_mask                                     (0x00002000)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4(data)                                    (0x00002000&((data)<<13))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_4_src(data)                                ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_4(data)                                ((0x00002000&(data))>>13)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc_shift                                      (10)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc_mask                                       (0x00000400)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc(data)                                      (0x00000400&((data)<<10))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_rtc_src(data)                                  ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_rtc(data)                                  ((0x00000400&(data))>>10)
+#define SYS_CLOCK_ENABLE2_clk_en_vcpu_shift                                          (5)
+#define SYS_CLOCK_ENABLE2_clk_en_vcpu_mask                                           (0x00000020)
+#define SYS_CLOCK_ENABLE2_clk_en_vcpu(data)                                          (0x00000020&((data)<<5))
+#define SYS_CLOCK_ENABLE2_clk_en_vcpu_src(data)                                      ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE2_get_clk_en_vcpu(data)                                      ((0x00000020&(data))>>5)
+#define SYS_CLOCK_ENABLE2_clk_en_acpu_shift                                          (4)
+#define SYS_CLOCK_ENABLE2_clk_en_acpu_mask                                           (0x00000010)
+#define SYS_CLOCK_ENABLE2_clk_en_acpu(data)                                          (0x00000010&((data)<<4))
+#define SYS_CLOCK_ENABLE2_clk_en_acpu_src(data)                                      ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE2_get_clk_en_acpu(data)                                      ((0x00000010&(data))>>4)
+#define SYS_CLOCK_ENABLE2_clk_en_scpu_shift                                          (2)
+#define SYS_CLOCK_ENABLE2_clk_en_scpu_mask                                           (0x00000004)
+#define SYS_CLOCK_ENABLE2_clk_en_scpu(data)                                          (0x00000004&((data)<<2))
+#define SYS_CLOCK_ENABLE2_clk_en_scpu_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_CLOCK_ENABLE2_get_clk_en_scpu(data)                                      ((0x00000004&(data))>>2)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5_shift                                    (1)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5_mask                                     (0x00000002)
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5(data)                                    (0x00000002&((data)<<1))
+#define SYS_CLOCK_ENABLE2_clk_en_misc_i2c_5_src(data)                                ((0x00000002&(data))>>1)
+#define SYS_CLOCK_ENABLE2_get_clk_en_misc_i2c_5(data)                                ((0x00000002&(data))>>1)
+
+
+#define SYS_GROUP1_CK_EN                                                             0x18000014
+#define SYS_GROUP1_CK_EN_reg_addr                                                    "0xB8000014"
+#define SYS_GROUP1_CK_EN_reg                                                         0xB8000014
+#define set_SYS_GROUP1_CK_EN_reg(data)   (*((volatile unsigned int*) SYS_GROUP1_CK_EN_reg)=data)
+#define get_SYS_GROUP1_CK_EN_reg   (*((volatile unsigned int*) SYS_GROUP1_CK_EN_reg))
+#define SYS_GROUP1_CK_EN_inst_adr                                                    "0x0005"
+#define SYS_GROUP1_CK_EN_inst                                                        0x0005
+#define SYS_GROUP1_CK_EN_clk_en_kcpu_shift                                           (1)
+#define SYS_GROUP1_CK_EN_clk_en_kcpu_mask                                            (0x00000002)
+#define SYS_GROUP1_CK_EN_clk_en_kcpu(data)                                           (0x00000002&((data)<<1))
+#define SYS_GROUP1_CK_EN_clk_en_kcpu_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_GROUP1_CK_EN_get_clk_en_kcpu(data)                                       ((0x00000002&(data))>>1)
+#define SYS_GROUP1_CK_EN_clk_en_sb2_shift                                            (0)
+#define SYS_GROUP1_CK_EN_clk_en_sb2_mask                                             (0x00000001)
+#define SYS_GROUP1_CK_EN_clk_en_sb2(data)                                            (0x00000001&((data)<<0))
+#define SYS_GROUP1_CK_EN_clk_en_sb2_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_GROUP1_CK_EN_get_clk_en_sb2(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_GROUP1_CK_SEL                                                            0x18000018
+#define SYS_GROUP1_CK_SEL_reg_addr                                                   "0xB8000018"
+#define SYS_GROUP1_CK_SEL_reg                                                        0xB8000018
+#define set_SYS_GROUP1_CK_SEL_reg(data)   (*((volatile unsigned int*) SYS_GROUP1_CK_SEL_reg)=data)
+#define get_SYS_GROUP1_CK_SEL_reg   (*((volatile unsigned int*) SYS_GROUP1_CK_SEL_reg))
+#define SYS_GROUP1_CK_SEL_inst_adr                                                   "0x0006"
+#define SYS_GROUP1_CK_SEL_inst                                                       0x0006
+#define SYS_GROUP1_CK_SEL_voclk_sel_shift                                            (1)
+#define SYS_GROUP1_CK_SEL_voclk_sel_mask                                             (0x00000002)
+#define SYS_GROUP1_CK_SEL_voclk_sel(data)                                            (0x00000002&((data)<<1))
+#define SYS_GROUP1_CK_SEL_voclk_sel_src(data)                                        ((0x00000002&(data))>>1)
+#define SYS_GROUP1_CK_SEL_get_voclk_sel(data)                                        ((0x00000002&(data))>>1)
+#define SYS_GROUP1_CK_SEL_sclk_sel_shift                                             (0)
+#define SYS_GROUP1_CK_SEL_sclk_sel_mask                                              (0x00000001)
+#define SYS_GROUP1_CK_SEL_sclk_sel(data)                                             (0x00000001&((data)<<0))
+#define SYS_GROUP1_CK_SEL_sclk_sel_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_GROUP1_CK_SEL_get_sclk_sel(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_TVE_CK_SEL                                                               0x1800001C
+#define SYS_TVE_CK_SEL_reg_addr                                                      "0xB800001C"
+#define SYS_TVE_CK_SEL_reg                                                           0xB800001C
+#define set_SYS_TVE_CK_SEL_reg(data)   (*((volatile unsigned int*) SYS_TVE_CK_SEL_reg)=data)
+#define get_SYS_TVE_CK_SEL_reg   (*((volatile unsigned int*) SYS_TVE_CK_SEL_reg))
+#define SYS_TVE_CK_SEL_inst_adr                                                      "0x0007"
+#define SYS_TVE_CK_SEL_inst                                                          0x0007
+#define SYS_TVE_CK_SEL_write_en5_shift                                               (12)
+#define SYS_TVE_CK_SEL_write_en5_mask                                                (0x00001000)
+#define SYS_TVE_CK_SEL_write_en5(data)                                               (0x00001000&((data)<<12))
+#define SYS_TVE_CK_SEL_write_en5_src(data)                                           ((0x00001000&(data))>>12)
+#define SYS_TVE_CK_SEL_get_write_en5(data)                                           ((0x00001000&(data))>>12)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2_shift                                   (11)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2_mask                                    (0x00000800)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2(data)                                   (0x00000800&((data)<<11))
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel2_src(data)                               ((0x00000800&(data))>>11)
+#define SYS_TVE_CK_SEL_get_clk_tve_p_vo_clk_sel2(data)                               ((0x00000800&(data))>>11)
+#define SYS_TVE_CK_SEL_write_en4_shift                                               (10)
+#define SYS_TVE_CK_SEL_write_en4_mask                                                (0x00000400)
+#define SYS_TVE_CK_SEL_write_en4(data)                                               (0x00000400&((data)<<10))
+#define SYS_TVE_CK_SEL_write_en4_src(data)                                           ((0x00000400&(data))>>10)
+#define SYS_TVE_CK_SEL_get_write_en4(data)                                           ((0x00000400&(data))>>10)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel_shift                                    (9)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel_mask                                     (0x00000200)
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel(data)                                    (0x00000200&((data)<<9))
+#define SYS_TVE_CK_SEL_clk_tve_p_vo_clk_sel_src(data)                                ((0x00000200&(data))>>9)
+#define SYS_TVE_CK_SEL_get_clk_tve_p_vo_clk_sel(data)                                ((0x00000200&(data))>>9)
+#define SYS_TVE_CK_SEL_write_en3_shift                                               (8)
+#define SYS_TVE_CK_SEL_write_en3_mask                                                (0x00000100)
+#define SYS_TVE_CK_SEL_write_en3(data)                                               (0x00000100&((data)<<8))
+#define SYS_TVE_CK_SEL_write_en3_src(data)                                           ((0x00000100&(data))>>8)
+#define SYS_TVE_CK_SEL_get_write_en3(data)                                           ((0x00000100&(data))>>8)
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv_shift                                          (7)
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv_mask                                           (0x00000080)
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv(data)                                          (0x00000080&((data)<<7))
+#define SYS_TVE_CK_SEL_hdmi_phy_ckinv_src(data)                                      ((0x00000080&(data))>>7)
+#define SYS_TVE_CK_SEL_get_hdmi_phy_ckinv(data)                                      ((0x00000080&(data))>>7)
+#define SYS_TVE_CK_SEL_write_en2_shift                                               (6)
+#define SYS_TVE_CK_SEL_write_en2_mask                                                (0x00000040)
+#define SYS_TVE_CK_SEL_write_en2(data)                                               (0x00000040&((data)<<6))
+#define SYS_TVE_CK_SEL_write_en2_src(data)                                           ((0x00000040&(data))>>6)
+#define SYS_TVE_CK_SEL_get_write_en2(data)                                           ((0x00000040&(data))>>6)
+#define SYS_TVE_CK_SEL_dac2_ckinv_shift                                              (3)
+#define SYS_TVE_CK_SEL_dac2_ckinv_mask                                               (0x00000008)
+#define SYS_TVE_CK_SEL_dac2_ckinv(data)                                              (0x00000008&((data)<<3))
+#define SYS_TVE_CK_SEL_dac2_ckinv_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_TVE_CK_SEL_get_dac2_ckinv(data)                                          ((0x00000008&(data))>>3)
+#define SYS_TVE_CK_SEL_dac1_ckinv_shift                                              (2)
+#define SYS_TVE_CK_SEL_dac1_ckinv_mask                                               (0x00000004)
+#define SYS_TVE_CK_SEL_dac1_ckinv(data)                                              (0x00000004&((data)<<2))
+#define SYS_TVE_CK_SEL_dac1_ckinv_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_TVE_CK_SEL_get_dac1_ckinv(data)                                          ((0x00000004&(data))>>2)
+#define SYS_TVE_CK_SEL_write_en1_shift                                               (1)
+#define SYS_TVE_CK_SEL_write_en1_mask                                                (0x00000002)
+#define SYS_TVE_CK_SEL_write_en1(data)                                               (0x00000002&((data)<<1))
+#define SYS_TVE_CK_SEL_write_en1_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_TVE_CK_SEL_get_write_en1(data)                                           ((0x00000002&(data))>>1)
+#define SYS_TVE_CK_SEL_tveck_mix_sel_shift                                           (0)
+#define SYS_TVE_CK_SEL_tveck_mix_sel_mask                                            (0x00000001)
+#define SYS_TVE_CK_SEL_tveck_mix_sel(data)                                           (0x00000001&((data)<<0))
+#define SYS_TVE_CK_SEL_tveck_mix_sel_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_TVE_CK_SEL_get_tveck_mix_sel(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_DISP_PLL_DIV                                                             0x18000020
+#define SYS_DISP_PLL_DIV_reg_addr                                                    "0xB8000020"
+#define SYS_DISP_PLL_DIV_reg                                                         0xB8000020
+#define set_SYS_DISP_PLL_DIV_reg(data)   (*((volatile unsigned int*) SYS_DISP_PLL_DIV_reg)=data)
+#define get_SYS_DISP_PLL_DIV_reg   (*((volatile unsigned int*) SYS_DISP_PLL_DIV_reg))
+#define SYS_DISP_PLL_DIV_inst_adr                                                    "0x0008"
+#define SYS_DISP_PLL_DIV_inst                                                        0x0008
+#define SYS_DISP_PLL_DIV_write_en2_shift                                             (11)
+#define SYS_DISP_PLL_DIV_write_en2_mask                                              (0x00000800)
+#define SYS_DISP_PLL_DIV_write_en2(data)                                             (0x00000800&((data)<<11))
+#define SYS_DISP_PLL_DIV_write_en2_src(data)                                         ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV_get_write_en2(data)                                         ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV_dac2_div_shift                                              (6)
+#define SYS_DISP_PLL_DIV_dac2_div_mask                                               (0x000007C0)
+#define SYS_DISP_PLL_DIV_dac2_div(data)                                              (0x000007C0&((data)<<6))
+#define SYS_DISP_PLL_DIV_dac2_div_src(data)                                          ((0x000007C0&(data))>>6)
+#define SYS_DISP_PLL_DIV_get_dac2_div(data)                                          ((0x000007C0&(data))>>6)
+#define SYS_DISP_PLL_DIV_write_en1_shift                                             (5)
+#define SYS_DISP_PLL_DIV_write_en1_mask                                              (0x00000020)
+#define SYS_DISP_PLL_DIV_write_en1(data)                                             (0x00000020&((data)<<5))
+#define SYS_DISP_PLL_DIV_write_en1_src(data)                                         ((0x00000020&(data))>>5)
+#define SYS_DISP_PLL_DIV_get_write_en1(data)                                         ((0x00000020&(data))>>5)
+#define SYS_DISP_PLL_DIV_dac1_div_shift                                              (0)
+#define SYS_DISP_PLL_DIV_dac1_div_mask                                               (0x0000001F)
+#define SYS_DISP_PLL_DIV_dac1_div(data)                                              (0x0000001F&((data)<<0))
+#define SYS_DISP_PLL_DIV_dac1_div_src(data)                                          ((0x0000001F&(data))>>0)
+#define SYS_DISP_PLL_DIV_get_dac1_div(data)                                          ((0x0000001F&(data))>>0)
+
+
+#define SYS_DISP_PLL_DIV2                                                            0x18000024
+#define SYS_DISP_PLL_DIV2_reg_addr                                                   "0xB8000024"
+#define SYS_DISP_PLL_DIV2_reg                                                        0xB8000024
+#define set_SYS_DISP_PLL_DIV2_reg(data)   (*((volatile unsigned int*) SYS_DISP_PLL_DIV2_reg)=data)
+#define get_SYS_DISP_PLL_DIV2_reg   (*((volatile unsigned int*) SYS_DISP_PLL_DIV2_reg))
+#define SYS_DISP_PLL_DIV2_inst_adr                                                   "0x0009"
+#define SYS_DISP_PLL_DIV2_inst                                                       0x0009
+#define SYS_DISP_PLL_DIV2_write_en10_shift                                           (24)
+#define SYS_DISP_PLL_DIV2_write_en10_mask                                            (0x01000000)
+#define SYS_DISP_PLL_DIV2_write_en10(data)                                           (0x01000000&((data)<<24))
+#define SYS_DISP_PLL_DIV2_write_en10_src(data)                                       ((0x01000000&(data))>>24)
+#define SYS_DISP_PLL_DIV2_get_write_en10(data)                                       ((0x01000000&(data))>>24)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl_shift                                      (23)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl_mask                                       (0x00800000)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl(data)                                      (0x00800000&((data)<<23))
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_mhl_src(data)                                  ((0x00800000&(data))>>23)
+#define SYS_DISP_PLL_DIV2_get_sel_pllhdmi_mhl(data)                                  ((0x00800000&(data))>>23)
+#define SYS_DISP_PLL_DIV2_write_en9_shift                                            (22)
+#define SYS_DISP_PLL_DIV2_write_en9_mask                                             (0x00400000)
+#define SYS_DISP_PLL_DIV2_write_en9(data)                                            (0x00400000&((data)<<22))
+#define SYS_DISP_PLL_DIV2_write_en9_src(data)                                        ((0x00400000&(data))>>22)
+#define SYS_DISP_PLL_DIV2_get_write_en9(data)                                        ((0x00400000&(data))>>22)
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel_shift                                         (17)
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel_mask                                          (0x003E0000)
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel(data)                                         (0x003E0000&((data)<<17))
+#define SYS_DISP_PLL_DIV2_clk_lvds_sel_src(data)                                     ((0x003E0000&(data))>>17)
+#define SYS_DISP_PLL_DIV2_get_clk_lvds_sel(data)                                     ((0x003E0000&(data))>>17)
+#define SYS_DISP_PLL_DIV2_write_en8_shift                                            (16)
+#define SYS_DISP_PLL_DIV2_write_en8_mask                                             (0x00010000)
+#define SYS_DISP_PLL_DIV2_write_en8(data)                                            (0x00010000&((data)<<16))
+#define SYS_DISP_PLL_DIV2_write_en8_src(data)                                        ((0x00010000&(data))>>16)
+#define SYS_DISP_PLL_DIV2_get_write_en8(data)                                        ((0x00010000&(data))>>16)
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2_shift                                     (15)
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2_mask                                      (0x00008000)
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2(data)                                     (0x00008000&((data)<<15))
+#define SYS_DISP_PLL_DIV2_sel_plldisp_clk2_src(data)                                 ((0x00008000&(data))>>15)
+#define SYS_DISP_PLL_DIV2_get_sel_plldisp_clk2(data)                                 ((0x00008000&(data))>>15)
+#define SYS_DISP_PLL_DIV2_write_en7_shift                                            (14)
+#define SYS_DISP_PLL_DIV2_write_en7_mask                                             (0x00004000)
+#define SYS_DISP_PLL_DIV2_write_en7(data)                                            (0x00004000&((data)<<14))
+#define SYS_DISP_PLL_DIV2_write_en7_src(data)                                        ((0x00004000&(data))>>14)
+#define SYS_DISP_PLL_DIV2_get_write_en7(data)                                        ((0x00004000&(data))>>14)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk_shift                                      (13)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk_mask                                       (0x00002000)
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk(data)                                      (0x00002000&((data)<<13))
+#define SYS_DISP_PLL_DIV2_sel_pllhdmi_clk_src(data)                                  ((0x00002000&(data))>>13)
+#define SYS_DISP_PLL_DIV2_get_sel_pllhdmi_clk(data)                                  ((0x00002000&(data))>>13)
+#define SYS_DISP_PLL_DIV2_write_en6_shift                                            (12)
+#define SYS_DISP_PLL_DIV2_write_en6_mask                                             (0x00001000)
+#define SYS_DISP_PLL_DIV2_write_en6(data)                                            (0x00001000&((data)<<12))
+#define SYS_DISP_PLL_DIV2_write_en6_src(data)                                        ((0x00001000&(data))>>12)
+#define SYS_DISP_PLL_DIV2_get_write_en6(data)                                        ((0x00001000&(data))>>12)
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat_shift                                      (11)
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat_mask                                       (0x00000800)
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat(data)                                      (0x00000800&((data)<<11))
+#define SYS_DISP_PLL_DIV2_hdmi_pxl_repeat_src(data)                                  ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV2_get_hdmi_pxl_repeat(data)                                  ((0x00000800&(data))>>11)
+#define SYS_DISP_PLL_DIV2_write_en5_shift                                            (10)
+#define SYS_DISP_PLL_DIV2_write_en5_mask                                             (0x00000400)
+#define SYS_DISP_PLL_DIV2_write_en5(data)                                            (0x00000400&((data)<<10))
+#define SYS_DISP_PLL_DIV2_write_en5_src(data)                                        ((0x00000400&(data))>>10)
+#define SYS_DISP_PLL_DIV2_get_write_en5(data)                                        ((0x00000400&(data))>>10)
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel_shift                                     (9)
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel_mask                                      (0x00000200)
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel(data)                                     (0x00000200&((data)<<9))
+#define SYS_DISP_PLL_DIV2_hdmi_phy_clk_sel_src(data)                                 ((0x00000200&(data))>>9)
+#define SYS_DISP_PLL_DIV2_get_hdmi_phy_clk_sel(data)                                 ((0x00000200&(data))>>9)
+#define SYS_DISP_PLL_DIV2_write_en4_shift                                            (8)
+#define SYS_DISP_PLL_DIV2_write_en4_mask                                             (0x00000100)
+#define SYS_DISP_PLL_DIV2_write_en4(data)                                            (0x00000100&((data)<<8))
+#define SYS_DISP_PLL_DIV2_write_en4_src(data)                                        ((0x00000100&(data))>>8)
+#define SYS_DISP_PLL_DIV2_get_write_en4(data)                                        ((0x00000100&(data))>>8)
+#define SYS_DISP_PLL_DIV2_hdmi_div_shift                                             (5)
+#define SYS_DISP_PLL_DIV2_hdmi_div_mask                                              (0x000000E0)
+#define SYS_DISP_PLL_DIV2_hdmi_div(data)                                             (0x000000E0&((data)<<5))
+#define SYS_DISP_PLL_DIV2_hdmi_div_src(data)                                         ((0x000000E0&(data))>>5)
+#define SYS_DISP_PLL_DIV2_get_hdmi_div(data)                                         ((0x000000E0&(data))>>5)
+#define SYS_DISP_PLL_DIV2_write_en3_shift                                            (4)
+#define SYS_DISP_PLL_DIV2_write_en3_mask                                             (0x00000010)
+#define SYS_DISP_PLL_DIV2_write_en3(data)                                            (0x00000010&((data)<<4))
+#define SYS_DISP_PLL_DIV2_write_en3_src(data)                                        ((0x00000010&(data))>>4)
+#define SYS_DISP_PLL_DIV2_get_write_en3(data)                                        ((0x00000010&(data))>>4)
+#define SYS_DISP_PLL_DIV2_tve_div_shift                                              (0)
+#define SYS_DISP_PLL_DIV2_tve_div_mask                                               (0x0000000F)
+#define SYS_DISP_PLL_DIV2_tve_div(data)                                              (0x0000000F&((data)<<0))
+#define SYS_DISP_PLL_DIV2_tve_div_src(data)                                          ((0x0000000F&(data))>>0)
+#define SYS_DISP_PLL_DIV2_get_tve_div(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define SYS_DDS_VIDEO_CK_SEL                                                         0x18000028
+#define SYS_DDS_VIDEO_CK_SEL_reg_addr                                                "0xB8000028"
+#define SYS_DDS_VIDEO_CK_SEL_reg                                                     0xB8000028
+#define set_SYS_DDS_VIDEO_CK_SEL_reg(data)   (*((volatile unsigned int*) SYS_DDS_VIDEO_CK_SEL_reg)=data)
+#define get_SYS_DDS_VIDEO_CK_SEL_reg   (*((volatile unsigned int*) SYS_DDS_VIDEO_CK_SEL_reg))
+#define SYS_DDS_VIDEO_CK_SEL_inst_adr                                                "0x000A"
+#define SYS_DDS_VIDEO_CK_SEL_inst                                                    0x000A
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel_shift                                       (0)
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel_mask                                        (0x00000001)
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel(data)                                       (0x00000001&((data)<<0))
+#define SYS_DDS_VIDEO_CK_SEL_dds_clk_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define SYS_DDS_VIDEO_CK_SEL_get_dds_clk_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SYS_AUDIO_CLK_CTL                                                            0x1800002C
+#define SYS_AUDIO_CLK_CTL_reg_addr                                                   "0xB800002C"
+#define SYS_AUDIO_CLK_CTL_reg                                                        0xB800002C
+#define set_SYS_AUDIO_CLK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AUDIO_CLK_CTL_reg)=data)
+#define get_SYS_AUDIO_CLK_CTL_reg   (*((volatile unsigned int*) SYS_AUDIO_CLK_CTL_reg))
+#define SYS_AUDIO_CLK_CTL_inst_adr                                                   "0x000B"
+#define SYS_AUDIO_CLK_CTL_inst                                                       0x000B
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk_shift                                     (0)
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk_mask                                      (0x00000001)
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk(data)                                     (0x00000001&((data)<<0))
+#define SYS_AUDIO_CLK_CTL_audio_use_sysclk_src(data)                                 ((0x00000001&(data))>>0)
+#define SYS_AUDIO_CLK_CTL_get_audio_use_sysclk(data)                                 ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DIV                                                                  0x18000030
+#define SYS_PLL_DIV_reg_addr                                                         "0xB8000030"
+#define SYS_PLL_DIV_reg                                                              0xB8000030
+#define set_SYS_PLL_DIV_reg(data)   (*((volatile unsigned int*) SYS_PLL_DIV_reg)=data)
+#define get_SYS_PLL_DIV_reg   (*((volatile unsigned int*) SYS_PLL_DIV_reg))
+#define SYS_PLL_DIV_inst_adr                                                         "0x000C"
+#define SYS_PLL_DIV_inst                                                             0x000C
+#define SYS_PLL_DIV_scpu_freq_sel_shift                                              (7)
+#define SYS_PLL_DIV_scpu_freq_sel_mask                                               (0x00000180)
+#define SYS_PLL_DIV_scpu_freq_sel(data)                                              (0x00000180&((data)<<7))
+#define SYS_PLL_DIV_scpu_freq_sel_src(data)                                          ((0x00000180&(data))>>7)
+#define SYS_PLL_DIV_get_scpu_freq_sel(data)                                          ((0x00000180&(data))>>7)
+#define SYS_PLL_DIV_vcpu_freq_sel_shift                                              (5)
+#define SYS_PLL_DIV_vcpu_freq_sel_mask                                               (0x00000060)
+#define SYS_PLL_DIV_vcpu_freq_sel(data)                                              (0x00000060&((data)<<5))
+#define SYS_PLL_DIV_vcpu_freq_sel_src(data)                                          ((0x00000060&(data))>>5)
+#define SYS_PLL_DIV_get_vcpu_freq_sel(data)                                          ((0x00000060&(data))>>5)
+#define SYS_PLL_DIV_acpu_freq_sel_shift                                              (3)
+#define SYS_PLL_DIV_acpu_freq_sel_mask                                               (0x00000018)
+#define SYS_PLL_DIV_acpu_freq_sel(data)                                              (0x00000018&((data)<<3))
+#define SYS_PLL_DIV_acpu_freq_sel_src(data)                                          ((0x00000018&(data))>>3)
+#define SYS_PLL_DIV_get_acpu_freq_sel(data)                                          ((0x00000018&(data))>>3)
+#define SYS_PLL_DIV_bus_freq_sel_shift                                               (0)
+#define SYS_PLL_DIV_bus_freq_sel_mask                                                (0x00000001)
+#define SYS_PLL_DIV_bus_freq_sel(data)                                               (0x00000001&((data)<<0))
+#define SYS_PLL_DIV_bus_freq_sel_src(data)                                           ((0x00000001&(data))>>0)
+#define SYS_PLL_DIV_get_bus_freq_sel(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SYS_NF_CKSEL                                                                 0x18000038
+#define SYS_NF_CKSEL_reg_addr                                                        "0xB8000038"
+#define SYS_NF_CKSEL_reg                                                             0xB8000038
+#define set_SYS_NF_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_NF_CKSEL_reg)=data)
+#define get_SYS_NF_CKSEL_reg   (*((volatile unsigned int*) SYS_NF_CKSEL_reg))
+#define SYS_NF_CKSEL_inst_adr                                                        "0x000E"
+#define SYS_NF_CKSEL_inst                                                            0x000E
+#define SYS_NF_CKSEL_nf_div_shift                                                    (0)
+#define SYS_NF_CKSEL_nf_div_mask                                                     (0x0000000F)
+#define SYS_NF_CKSEL_nf_div(data)                                                    (0x0000000F&((data)<<0))
+#define SYS_NF_CKSEL_nf_div_src(data)                                                ((0x0000000F&(data))>>0)
+#define SYS_NF_CKSEL_get_nf_div(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define SYS_NDS_SC_CKSEL                                                             0x1800003C
+#define SYS_NDS_SC_CKSEL_reg_addr                                                    "0xB800003C"
+#define SYS_NDS_SC_CKSEL_reg                                                         0xB800003C
+#define set_SYS_NDS_SC_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_NDS_SC_CKSEL_reg)=data)
+#define get_SYS_NDS_SC_CKSEL_reg   (*((volatile unsigned int*) SYS_NDS_SC_CKSEL_reg))
+#define SYS_NDS_SC_CKSEL_inst_adr                                                    "0x000F"
+#define SYS_NDS_SC_CKSEL_inst                                                        0x000F
+#define SYS_NDS_SC_CKSEL_nds_sc_div_shift                                            (0)
+#define SYS_NDS_SC_CKSEL_nds_sc_div_mask                                             (0x00000007)
+#define SYS_NDS_SC_CKSEL_nds_sc_div(data)                                            (0x00000007&((data)<<0))
+#define SYS_NDS_SC_CKSEL_nds_sc_div_src(data)                                        ((0x00000007&(data))>>0)
+#define SYS_NDS_SC_CKSEL_get_nds_sc_div(data)                                        ((0x00000007&(data))>>0)
+
+
+#define SYS_MISC_CKSEL                                                               0x18000044
+#define SYS_MISC_CKSEL_reg_addr                                                      "0xB8000044"
+#define SYS_MISC_CKSEL_reg                                                           0xB8000044
+#define set_SYS_MISC_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_MISC_CKSEL_reg)=data)
+#define get_SYS_MISC_CKSEL_reg   (*((volatile unsigned int*) SYS_MISC_CKSEL_reg))
+#define SYS_MISC_CKSEL_inst_adr                                                      "0x0011"
+#define SYS_MISC_CKSEL_inst                                                          0x0011
+#define SYS_MISC_CKSEL_clk_camera1_sel_shift                                         (2)
+#define SYS_MISC_CKSEL_clk_camera1_sel_mask                                          (0x0000000C)
+#define SYS_MISC_CKSEL_clk_camera1_sel(data)                                         (0x0000000C&((data)<<2))
+#define SYS_MISC_CKSEL_clk_camera1_sel_src(data)                                     ((0x0000000C&(data))>>2)
+#define SYS_MISC_CKSEL_get_clk_camera1_sel(data)                                     ((0x0000000C&(data))>>2)
+#define SYS_MISC_CKSEL_clk_camera0_sel_shift                                         (0)
+#define SYS_MISC_CKSEL_clk_camera0_sel_mask                                          (0x00000003)
+#define SYS_MISC_CKSEL_clk_camera0_sel(data)                                         (0x00000003&((data)<<0))
+#define SYS_MISC_CKSEL_clk_camera0_sel_src(data)                                     ((0x00000003&(data))>>0)
+#define SYS_MISC_CKSEL_get_clk_camera0_sel(data)                                     ((0x00000003&(data))>>0)
+
+
+#define SYS_SCPU_CKSEL                                                               0x18000048
+#define SYS_SCPU_CKSEL_reg_addr                                                      "0xB8000048"
+#define SYS_SCPU_CKSEL_reg                                                           0xB8000048
+#define set_SYS_SCPU_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_SCPU_CKSEL_reg)=data)
+#define get_SYS_SCPU_CKSEL_reg   (*((volatile unsigned int*) SYS_SCPU_CKSEL_reg))
+#define SYS_SCPU_CKSEL_inst_adr                                                      "0x0012"
+#define SYS_SCPU_CKSEL_inst                                                          0x0012
+#define SYS_SCPU_CKSEL_CLKTRC_SEL_shift                                              (0)
+#define SYS_SCPU_CKSEL_CLKTRC_SEL_mask                                               (0x00000003)
+#define SYS_SCPU_CKSEL_CLKTRC_SEL(data)                                              (0x00000003&((data)<<0))
+#define SYS_SCPU_CKSEL_CLKTRC_SEL_src(data)                                          ((0x00000003&(data))>>0)
+#define SYS_SCPU_CKSEL_get_CLKTRC_SEL(data)                                          ((0x00000003&(data))>>0)
+
+
+#define SYS_VE_CKSEL                                                                 0x1800004C
+#define SYS_VE_CKSEL_reg_addr                                                        "0xB800004C"
+#define SYS_VE_CKSEL_reg                                                             0xB800004C
+#define set_SYS_VE_CKSEL_reg(data)   (*((volatile unsigned int*) SYS_VE_CKSEL_reg)=data)
+#define get_SYS_VE_CKSEL_reg   (*((volatile unsigned int*) SYS_VE_CKSEL_reg))
+#define SYS_VE_CKSEL_inst_adr                                                        "0x0013"
+#define SYS_VE_CKSEL_inst                                                            0x0013
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel_shift                                           (4)
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel_mask                                            (0x00000030)
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel(data)                                           (0x00000030&((data)<<4))
+#define SYS_VE_CKSEL_clk_ve2_bpu_sel_src(data)                                       ((0x00000030&(data))>>4)
+#define SYS_VE_CKSEL_get_clk_ve2_bpu_sel(data)                                       ((0x00000030&(data))>>4)
+#define SYS_VE_CKSEL_clk_ve2_core_sel_shift                                          (2)
+#define SYS_VE_CKSEL_clk_ve2_core_sel_mask                                           (0x0000000C)
+#define SYS_VE_CKSEL_clk_ve2_core_sel(data)                                          (0x0000000C&((data)<<2))
+#define SYS_VE_CKSEL_clk_ve2_core_sel_src(data)                                      ((0x0000000C&(data))>>2)
+#define SYS_VE_CKSEL_get_clk_ve2_core_sel(data)                                      ((0x0000000C&(data))>>2)
+#define SYS_VE_CKSEL_clk_ve1_sel_shift                                               (0)
+#define SYS_VE_CKSEL_clk_ve1_sel_mask                                                (0x00000003)
+#define SYS_VE_CKSEL_clk_ve1_sel(data)                                               (0x00000003&((data)<<0))
+#define SYS_VE_CKSEL_clk_ve1_sel_src(data)                                           ((0x00000003&(data))>>0)
+#define SYS_VE_CKSEL_get_clk_ve1_sel(data)                                           ((0x00000003&(data))>>0)
+
+
+#define SYS_BUS_PLL_SSC                                                              0x18000060
+#define SYS_BUS_PLL_SSC_reg_addr                                                     "0xB8000060"
+#define SYS_BUS_PLL_SSC_reg                                                          0xB8000060
+#define set_SYS_BUS_PLL_SSC_reg(data)   (*((volatile unsigned int*) SYS_BUS_PLL_SSC_reg)=data)
+#define get_SYS_BUS_PLL_SSC_reg   (*((volatile unsigned int*) SYS_BUS_PLL_SSC_reg))
+#define SYS_BUS_PLL_SSC_inst_adr                                                     "0x0018"
+#define SYS_BUS_PLL_SSC_inst                                                         0x0018
+#define SYS_BUS_PLL_SSC_bus_ssc_sse_shift                                            (31)
+#define SYS_BUS_PLL_SSC_bus_ssc_sse_mask                                             (0x80000000)
+#define SYS_BUS_PLL_SSC_bus_ssc_sse(data)                                            (0x80000000&((data)<<31))
+#define SYS_BUS_PLL_SSC_bus_ssc_sse_src(data)                                        ((0x80000000&(data))>>31)
+#define SYS_BUS_PLL_SSC_get_bus_ssc_sse(data)                                        ((0x80000000&(data))>>31)
+#define SYS_BUS_PLL_SSC_bus_ssc_ckinv_shift                                          (30)
+#define SYS_BUS_PLL_SSC_bus_ssc_ckinv_mask                                           (0x40000000)
+#define SYS_BUS_PLL_SSC_bus_ssc_ckinv(data)                                          (0x40000000&((data)<<30))
+#define SYS_BUS_PLL_SSC_bus_ssc_ckinv_src(data)                                      ((0x40000000&(data))>>30)
+#define SYS_BUS_PLL_SSC_get_bus_ssc_ckinv(data)                                      ((0x40000000&(data))>>30)
+#define SYS_BUS_PLL_SSC_bus_ssc_sss_shift                                            (24)
+#define SYS_BUS_PLL_SSC_bus_ssc_sss_mask                                             (0x3F000000)
+#define SYS_BUS_PLL_SSC_bus_ssc_sss(data)                                            (0x3F000000&((data)<<24))
+#define SYS_BUS_PLL_SSC_bus_ssc_sss_src(data)                                        ((0x3F000000&(data))>>24)
+#define SYS_BUS_PLL_SSC_get_bus_ssc_sss(data)                                        ((0x3F000000&(data))>>24)
+#define SYS_BUS_PLL_SSC_bus_ssc_ssn_shift                                            (16)
+#define SYS_BUS_PLL_SSC_bus_ssc_ssn_mask                                             (0x007F0000)
+#define SYS_BUS_PLL_SSC_bus_ssc_ssn(data)                                            (0x007F0000&((data)<<16))
+#define SYS_BUS_PLL_SSC_bus_ssc_ssn_src(data)                                        ((0x007F0000&(data))>>16)
+#define SYS_BUS_PLL_SSC_get_bus_ssc_ssn(data)                                        ((0x007F0000&(data))>>16)
+#define SYS_BUS_PLL_SSC_bus_ssc_ssfpv_shift                                          (8)
+#define SYS_BUS_PLL_SSC_bus_ssc_ssfpv_mask                                           (0x0000FF00)
+#define SYS_BUS_PLL_SSC_bus_ssc_ssfpv(data)                                          (0x0000FF00&((data)<<8))
+#define SYS_BUS_PLL_SSC_bus_ssc_ssfpv_src(data)                                      ((0x0000FF00&(data))>>8)
+#define SYS_BUS_PLL_SSC_get_bus_ssc_ssfpv(data)                                      ((0x0000FF00&(data))>>8)
+#define SYS_BUS_PLL_SSC_bus_ssc_stms_shift                                           (0)
+#define SYS_BUS_PLL_SSC_bus_ssc_stms_mask                                            (0x00000003)
+#define SYS_BUS_PLL_SSC_bus_ssc_stms(data)                                           (0x00000003&((data)<<0))
+#define SYS_BUS_PLL_SSC_bus_ssc_stms_src(data)                                       ((0x00000003&(data))>>0)
+#define SYS_BUS_PLL_SSC_get_bus_ssc_stms(data)                                       ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_DDR_SSC2                                                             0x18000064
+#define SYS_PLL_DDR_SSC2_reg_addr                                                    "0xB8000064"
+#define SYS_PLL_DDR_SSC2_reg                                                         0xB8000064
+#define set_SYS_PLL_DDR_SSC2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDR_SSC2_reg)=data)
+#define get_SYS_PLL_DDR_SSC2_reg   (*((volatile unsigned int*) SYS_PLL_DDR_SSC2_reg))
+#define SYS_PLL_DDR_SSC2_inst_adr                                                    "0x0019"
+#define SYS_PLL_DDR_SSC2_inst                                                        0x0019
+#define SYS_PLL_DDR_SSC2_SSCDDR_SEL_ORDER_shift                                      (28)
+#define SYS_PLL_DDR_SSC2_SSCDDR_SEL_ORDER_mask                                       (0x10000000)
+#define SYS_PLL_DDR_SSC2_SSCDDR_SEL_ORDER(data)                                      (0x10000000&((data)<<28))
+#define SYS_PLL_DDR_SSC2_SSCDDR_SEL_ORDER_src(data)                                  ((0x10000000&(data))>>28)
+#define SYS_PLL_DDR_SSC2_get_SSCDDR_SEL_ORDER(data)                                  ((0x10000000&(data))>>28)
+#define SYS_PLL_DDR_SSC2_SSCDDR_WEIGHTING_SEL_shift                                  (25)
+#define SYS_PLL_DDR_SSC2_SSCDDR_WEIGHTING_SEL_mask                                   (0x0E000000)
+#define SYS_PLL_DDR_SSC2_SSCDDR_WEIGHTING_SEL(data)                                  (0x0E000000&((data)<<25))
+#define SYS_PLL_DDR_SSC2_SSCDDR_WEIGHTING_SEL_src(data)                              ((0x0E000000&(data))>>25)
+#define SYS_PLL_DDR_SSC2_get_SSCDDR_WEIGHTING_SEL(data)                              ((0x0E000000&(data))>>25)
+#define SYS_PLL_DDR_SSC2_SSCDDR_STEP_IN_shift                                        (12)
+#define SYS_PLL_DDR_SSC2_SSCDDR_STEP_IN_mask                                         (0x01FFF000)
+#define SYS_PLL_DDR_SSC2_SSCDDR_STEP_IN(data)                                        (0x01FFF000&((data)<<12))
+#define SYS_PLL_DDR_SSC2_SSCDDR_STEP_IN_src(data)                                    ((0x01FFF000&(data))>>12)
+#define SYS_PLL_DDR_SSC2_get_SSCDDR_STEP_IN(data)                                    ((0x01FFF000&(data))>>12)
+#define SYS_PLL_DDR_SSC2_SSCDDR_TBASE_shift                                          (0)
+#define SYS_PLL_DDR_SSC2_SSCDDR_TBASE_mask                                           (0x00000FFF)
+#define SYS_PLL_DDR_SSC2_SSCDDR_TBASE(data)                                          (0x00000FFF&((data)<<0))
+#define SYS_PLL_DDR_SSC2_SSCDDR_TBASE_src(data)                                      ((0x00000FFF&(data))>>0)
+#define SYS_PLL_DDR_SSC2_get_SSCDDR_TBASE(data)                                      ((0x00000FFF&(data))>>0)
+
+
+#define SYS_DCSB_PLL_SSC                                                             0x18000068
+#define SYS_DCSB_PLL_SSC_reg_addr                                                    "0xB8000068"
+#define SYS_DCSB_PLL_SSC_reg                                                         0xB8000068
+#define set_SYS_DCSB_PLL_SSC_reg(data)   (*((volatile unsigned int*) SYS_DCSB_PLL_SSC_reg)=data)
+#define get_SYS_DCSB_PLL_SSC_reg   (*((volatile unsigned int*) SYS_DCSB_PLL_SSC_reg))
+#define SYS_DCSB_PLL_SSC_inst_adr                                                    "0x001A"
+#define SYS_DCSB_PLL_SSC_inst                                                        0x001A
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_sse_shift                                          (31)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_sse_mask                                           (0x80000000)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_sse(data)                                          (0x80000000&((data)<<31))
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_sse_src(data)                                      ((0x80000000&(data))>>31)
+#define SYS_DCSB_PLL_SSC_get_dcsb_ssc_sse(data)                                      ((0x80000000&(data))>>31)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ckinv_shift                                        (30)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ckinv_mask                                         (0x40000000)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ckinv(data)                                        (0x40000000&((data)<<30))
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ckinv_src(data)                                    ((0x40000000&(data))>>30)
+#define SYS_DCSB_PLL_SSC_get_dcsb_ssc_ckinv(data)                                    ((0x40000000&(data))>>30)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_sss_shift                                          (24)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_sss_mask                                           (0x3F000000)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_sss(data)                                          (0x3F000000&((data)<<24))
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_sss_src(data)                                      ((0x3F000000&(data))>>24)
+#define SYS_DCSB_PLL_SSC_get_dcsb_ssc_sss(data)                                      ((0x3F000000&(data))>>24)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ssn_shift                                          (16)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ssn_mask                                           (0x007F0000)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ssn(data)                                          (0x007F0000&((data)<<16))
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ssn_src(data)                                      ((0x007F0000&(data))>>16)
+#define SYS_DCSB_PLL_SSC_get_dcsb_ssc_ssn(data)                                      ((0x007F0000&(data))>>16)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ssfpv_shift                                        (8)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ssfpv_mask                                         (0x0000FF00)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ssfpv(data)                                        (0x0000FF00&((data)<<8))
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_ssfpv_src(data)                                    ((0x0000FF00&(data))>>8)
+#define SYS_DCSB_PLL_SSC_get_dcsb_ssc_ssfpv(data)                                    ((0x0000FF00&(data))>>8)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_stms_shift                                         (0)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_stms_mask                                          (0x00000003)
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_stms(data)                                         (0x00000003&((data)<<0))
+#define SYS_DCSB_PLL_SSC_dcsb_ssc_stms_src(data)                                     ((0x00000003&(data))>>0)
+#define SYS_DCSB_PLL_SSC_get_dcsb_ssc_stms(data)                                     ((0x00000003&(data))>>0)
+
+
+#define SYS_LVDS_PLL_SSC                                                             0x1800006c
+#define SYS_LVDS_PLL_SSC_reg_addr                                                    "0xB800006C"
+#define SYS_LVDS_PLL_SSC_reg                                                         0xB800006C
+#define set_SYS_LVDS_PLL_SSC_reg(data)   (*((volatile unsigned int*) SYS_LVDS_PLL_SSC_reg)=data)
+#define get_SYS_LVDS_PLL_SSC_reg   (*((volatile unsigned int*) SYS_LVDS_PLL_SSC_reg))
+#define SYS_LVDS_PLL_SSC_inst_adr                                                    "0x001B"
+#define SYS_LVDS_PLL_SSC_inst                                                        0x001B
+#define SYS_LVDS_PLL_SSC_lvds_offset_shift                                           (16)
+#define SYS_LVDS_PLL_SSC_lvds_offset_mask                                            (0x0FFF0000)
+#define SYS_LVDS_PLL_SSC_lvds_offset(data)                                           (0x0FFF0000&((data)<<16))
+#define SYS_LVDS_PLL_SSC_lvds_offset_src(data)                                       ((0x0FFF0000&(data))>>16)
+#define SYS_LVDS_PLL_SSC_get_lvds_offset(data)                                       ((0x0FFF0000&(data))>>16)
+#define SYS_LVDS_PLL_SSC_lvds_ss_test_shift                                          (14)
+#define SYS_LVDS_PLL_SSC_lvds_ss_test_mask                                           (0x00004000)
+#define SYS_LVDS_PLL_SSC_lvds_ss_test(data)                                          (0x00004000&((data)<<14))
+#define SYS_LVDS_PLL_SSC_lvds_ss_test_src(data)                                      ((0x00004000&(data))>>14)
+#define SYS_LVDS_PLL_SSC_get_lvds_ss_test(data)                                      ((0x00004000&(data))>>14)
+#define SYS_LVDS_PLL_SSC_lvds_ss_fmdiv_shift                                         (7)
+#define SYS_LVDS_PLL_SSC_lvds_ss_fmdiv_mask                                          (0x00003F80)
+#define SYS_LVDS_PLL_SSC_lvds_ss_fmdiv(data)                                         (0x00003F80&((data)<<7))
+#define SYS_LVDS_PLL_SSC_lvds_ss_fmdiv_src(data)                                     ((0x00003F80&(data))>>7)
+#define SYS_LVDS_PLL_SSC_get_lvds_ss_fmdiv(data)                                     ((0x00003F80&(data))>>7)
+#define SYS_LVDS_PLL_SSC_lvds_ss_rag_shift                                           (3)
+#define SYS_LVDS_PLL_SSC_lvds_ss_rag_mask                                            (0x00000078)
+#define SYS_LVDS_PLL_SSC_lvds_ss_rag(data)                                           (0x00000078&((data)<<3))
+#define SYS_LVDS_PLL_SSC_lvds_ss_rag_src(data)                                       ((0x00000078&(data))>>3)
+#define SYS_LVDS_PLL_SSC_get_lvds_ss_rag(data)                                       ((0x00000078&(data))>>3)
+#define SYS_LVDS_PLL_SSC_lvds_ss_fudpn_en_shift                                      (2)
+#define SYS_LVDS_PLL_SSC_lvds_ss_fudpn_en_mask                                       (0x00000004)
+#define SYS_LVDS_PLL_SSC_lvds_ss_fudpn_en(data)                                      (0x00000004&((data)<<2))
+#define SYS_LVDS_PLL_SSC_lvds_ss_fudpn_en_src(data)                                  ((0x00000004&(data))>>2)
+#define SYS_LVDS_PLL_SSC_get_lvds_ss_fudpn_en(data)                                  ((0x00000004&(data))>>2)
+#define SYS_LVDS_PLL_SSC_lvds_ss_shuffle_en_shift                                    (1)
+#define SYS_LVDS_PLL_SSC_lvds_ss_shuffle_en_mask                                     (0x00000002)
+#define SYS_LVDS_PLL_SSC_lvds_ss_shuffle_en(data)                                    (0x00000002&((data)<<1))
+#define SYS_LVDS_PLL_SSC_lvds_ss_shuffle_en_src(data)                                ((0x00000002&(data))>>1)
+#define SYS_LVDS_PLL_SSC_get_lvds_ss_shuffle_en(data)                                ((0x00000002&(data))>>1)
+#define SYS_LVDS_PLL_SSC_lvds_ss_en_shift                                            (0)
+#define SYS_LVDS_PLL_SSC_lvds_ss_en_mask                                             (0x00000001)
+#define SYS_LVDS_PLL_SSC_lvds_ss_en(data)                                            (0x00000001&((data)<<0))
+#define SYS_LVDS_PLL_SSC_lvds_ss_en_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_LVDS_PLL_SSC_get_lvds_ss_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_O_PCM_CK_CTL                                                         0x18000070
+#define SYS_AIO_O_PCM_CK_CTL_reg_addr                                                "0xB8000070"
+#define SYS_AIO_O_PCM_CK_CTL_reg                                                     0xB8000070
+#define set_SYS_AIO_O_PCM_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_O_PCM_CK_CTL_reg)=data)
+#define get_SYS_AIO_O_PCM_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_O_PCM_CK_CTL_reg))
+#define SYS_AIO_O_PCM_CK_CTL_inst_adr                                                "0x001C"
+#define SYS_AIO_O_PCM_CK_CTL_inst                                                    0x001C
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel_shift                                          (5)
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel_mask                                           (0x000000E0)
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel(data)                                          (0x000000E0&((data)<<5))
+#define SYS_AIO_O_PCM_CK_CTL_mclk_sel_src(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_O_PCM_CK_CTL_get_mclk_sel(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_O_PCM_CK_CTL_fs_shift                                                (1)
+#define SYS_AIO_O_PCM_CK_CTL_fs_mask                                                 (0x0000001E)
+#define SYS_AIO_O_PCM_CK_CTL_fs(data)                                                (0x0000001E&((data)<<1))
+#define SYS_AIO_O_PCM_CK_CTL_fs_src(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_PCM_CK_CTL_get_fs(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_PCM_CK_CTL_clken_shift                                             (0)
+#define SYS_AIO_O_PCM_CK_CTL_clken_mask                                              (0x00000001)
+#define SYS_AIO_O_PCM_CK_CTL_clken(data)                                             (0x00000001&((data)<<0))
+#define SYS_AIO_O_PCM_CK_CTL_clken_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_AIO_O_PCM_CK_CTL_get_clken(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_O_RAW_CK_CTL                                                         0x18000074
+#define SYS_AIO_O_RAW_CK_CTL_reg_addr                                                "0xB8000074"
+#define SYS_AIO_O_RAW_CK_CTL_reg                                                     0xB8000074
+#define set_SYS_AIO_O_RAW_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_O_RAW_CK_CTL_reg)=data)
+#define get_SYS_AIO_O_RAW_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_O_RAW_CK_CTL_reg))
+#define SYS_AIO_O_RAW_CK_CTL_inst_adr                                                "0x001D"
+#define SYS_AIO_O_RAW_CK_CTL_inst                                                    0x001D
+#define SYS_AIO_O_RAW_CK_CTL_fs_shift                                                (1)
+#define SYS_AIO_O_RAW_CK_CTL_fs_mask                                                 (0x0000001E)
+#define SYS_AIO_O_RAW_CK_CTL_fs(data)                                                (0x0000001E&((data)<<1))
+#define SYS_AIO_O_RAW_CK_CTL_fs_src(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW_CK_CTL_get_fs(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW_CK_CTL_clken_shift                                             (0)
+#define SYS_AIO_O_RAW_CK_CTL_clken_mask                                              (0x00000001)
+#define SYS_AIO_O_RAW_CK_CTL_clken(data)                                             (0x00000001&((data)<<0))
+#define SYS_AIO_O_RAW_CK_CTL_clken_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_AIO_O_RAW_CK_CTL_get_clken(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_O_RAW2_CK_CTL                                                        0x18000078
+#define SYS_AIO_O_RAW2_CK_CTL_reg_addr                                               "0xB8000078"
+#define SYS_AIO_O_RAW2_CK_CTL_reg                                                    0xB8000078
+#define set_SYS_AIO_O_RAW2_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_O_RAW2_CK_CTL_reg)=data)
+#define get_SYS_AIO_O_RAW2_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_O_RAW2_CK_CTL_reg))
+#define SYS_AIO_O_RAW2_CK_CTL_inst_adr                                               "0x001E"
+#define SYS_AIO_O_RAW2_CK_CTL_inst                                                   0x001E
+#define SYS_AIO_O_RAW2_CK_CTL_fs_shift                                               (1)
+#define SYS_AIO_O_RAW2_CK_CTL_fs_mask                                                (0x0000001E)
+#define SYS_AIO_O_RAW2_CK_CTL_fs(data)                                               (0x0000001E&((data)<<1))
+#define SYS_AIO_O_RAW2_CK_CTL_fs_src(data)                                           ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW2_CK_CTL_get_fs(data)                                           ((0x0000001E&(data))>>1)
+#define SYS_AIO_O_RAW2_CK_CTL_clken_shift                                            (0)
+#define SYS_AIO_O_RAW2_CK_CTL_clken_mask                                             (0x00000001)
+#define SYS_AIO_O_RAW2_CK_CTL_clken(data)                                            (0x00000001&((data)<<0))
+#define SYS_AIO_O_RAW2_CK_CTL_clken_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_AIO_O_RAW2_CK_CTL_get_clken(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_APS_CTL                                                                  0x1800007C
+#define SYS_APS_CTL_reg_addr                                                         "0xB800007C"
+#define SYS_APS_CTL_reg                                                              0xB800007C
+#define set_SYS_APS_CTL_reg(data)   (*((volatile unsigned int*) SYS_APS_CTL_reg)=data)
+#define get_SYS_APS_CTL_reg   (*((volatile unsigned int*) SYS_APS_CTL_reg))
+#define SYS_APS_CTL_inst_adr                                                         "0x001F"
+#define SYS_APS_CTL_inst                                                             0x001F
+#define SYS_APS_CTL_write_en2_shift                                                  (1)
+#define SYS_APS_CTL_write_en2_mask                                                   (0x00000002)
+#define SYS_APS_CTL_write_en2(data)                                                  (0x00000002&((data)<<1))
+#define SYS_APS_CTL_write_en2_src(data)                                              ((0x00000002&(data))>>1)
+#define SYS_APS_CTL_get_write_en2(data)                                              ((0x00000002&(data))>>1)
+#define SYS_APS_CTL_dds_rstn_shift                                                   (0)
+#define SYS_APS_CTL_dds_rstn_mask                                                    (0x00000001)
+#define SYS_APS_CTL_dds_rstn(data)                                                   (0x00000001&((data)<<0))
+#define SYS_APS_CTL_dds_rstn_src(data)                                               ((0x00000001&(data))>>0)
+#define SYS_APS_CTL_get_dds_rstn(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SYS_AIO_I_PCM_CK_CTL                                                         0x18000080
+#define SYS_AIO_I_PCM_CK_CTL_reg_addr                                                "0xB8000080"
+#define SYS_AIO_I_PCM_CK_CTL_reg                                                     0xB8000080
+#define set_SYS_AIO_I_PCM_CK_CTL_reg(data)   (*((volatile unsigned int*) SYS_AIO_I_PCM_CK_CTL_reg)=data)
+#define get_SYS_AIO_I_PCM_CK_CTL_reg   (*((volatile unsigned int*) SYS_AIO_I_PCM_CK_CTL_reg))
+#define SYS_AIO_I_PCM_CK_CTL_inst_adr                                                "0x0020"
+#define SYS_AIO_I_PCM_CK_CTL_inst                                                    0x0020
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel_shift                                          (5)
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel_mask                                           (0x000000E0)
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel(data)                                          (0x000000E0&((data)<<5))
+#define SYS_AIO_I_PCM_CK_CTL_mclk_sel_src(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_I_PCM_CK_CTL_get_mclk_sel(data)                                      ((0x000000E0&(data))>>5)
+#define SYS_AIO_I_PCM_CK_CTL_fs_shift                                                (1)
+#define SYS_AIO_I_PCM_CK_CTL_fs_mask                                                 (0x0000001E)
+#define SYS_AIO_I_PCM_CK_CTL_fs(data)                                                (0x0000001E&((data)<<1))
+#define SYS_AIO_I_PCM_CK_CTL_fs_src(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_I_PCM_CK_CTL_get_fs(data)                                            ((0x0000001E&(data))>>1)
+#define SYS_AIO_I_PCM_CK_CTL_clken_shift                                             (0)
+#define SYS_AIO_I_PCM_CK_CTL_clken_mask                                              (0x00000001)
+#define SYS_AIO_I_PCM_CK_CTL_clken(data)                                             (0x00000001&((data)<<0))
+#define SYS_AIO_I_PCM_CK_CTL_clken_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_AIO_I_PCM_CK_CTL_get_clken(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_CLK_VO_CTRL                                                              0x18000084
+#define SYS_CLK_VO_CTRL_reg_addr                                                     "0xB8000084"
+#define SYS_CLK_VO_CTRL_reg                                                          0xB8000084
+#define set_SYS_CLK_VO_CTRL_reg(data)   (*((volatile unsigned int*) SYS_CLK_VO_CTRL_reg)=data)
+#define get_SYS_CLK_VO_CTRL_reg   (*((volatile unsigned int*) SYS_CLK_VO_CTRL_reg))
+#define SYS_CLK_VO_CTRL_inst_adr                                                     "0x0021"
+#define SYS_CLK_VO_CTRL_inst                                                         0x0021
+#define SYS_CLK_VO_CTRL_CLK_VO_SEL_shift                                             (0)
+#define SYS_CLK_VO_CTRL_CLK_VO_SEL_mask                                              (0x00000001)
+#define SYS_CLK_VO_CTRL_CLK_VO_SEL(data)                                             (0x00000001&((data)<<0))
+#define SYS_CLK_VO_CTRL_CLK_VO_SEL_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_CLK_VO_CTRL_get_CLK_VO_SEL(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_LVDS_PLL_SSC2                                                            0x18000090
+#define SYS_LVDS_PLL_SSC2_reg_addr                                                   "0xB8000090"
+#define SYS_LVDS_PLL_SSC2_reg                                                        0xB8000090
+#define set_SYS_LVDS_PLL_SSC2_reg(data)   (*((volatile unsigned int*) SYS_LVDS_PLL_SSC2_reg)=data)
+#define get_SYS_LVDS_PLL_SSC2_reg   (*((volatile unsigned int*) SYS_LVDS_PLL_SSC2_reg))
+#define SYS_LVDS_PLL_SSC2_inst_adr                                                   "0x0024"
+#define SYS_LVDS_PLL_SSC2_inst                                                       0x0024
+#define SYS_LVDS_PLL_SSC2_lvds_Final_profile_shift                                   (0)
+#define SYS_LVDS_PLL_SSC2_lvds_Final_profile_mask                                    (0x00001FFF)
+#define SYS_LVDS_PLL_SSC2_lvds_Final_profile(data)                                   (0x00001FFF&((data)<<0))
+#define SYS_LVDS_PLL_SSC2_lvds_Final_profile_src(data)                               ((0x00001FFF&(data))>>0)
+#define SYS_LVDS_PLL_SSC2_get_lvds_Final_profile(data)                               ((0x00001FFF&(data))>>0)
+
+
+#define SYS_LVDS_PLL_SSC3                                                            0x18000094
+#define SYS_LVDS_PLL_SSC3_reg_addr                                                   "0xB8000094"
+#define SYS_LVDS_PLL_SSC3_reg                                                        0xB8000094
+#define set_SYS_LVDS_PLL_SSC3_reg(data)   (*((volatile unsigned int*) SYS_LVDS_PLL_SSC3_reg)=data)
+#define get_SYS_LVDS_PLL_SSC3_reg   (*((volatile unsigned int*) SYS_LVDS_PLL_SSC3_reg))
+#define SYS_LVDS_PLL_SSC3_inst_adr                                                   "0x0025"
+#define SYS_LVDS_PLL_SSC3_inst                                                       0x0025
+#define SYS_LVDS_PLL_SSC3_lvds_sscg_Profile_over_underflow_flag_shift                (1)
+#define SYS_LVDS_PLL_SSC3_lvds_sscg_Profile_over_underflow_flag_mask                 (0x00000002)
+#define SYS_LVDS_PLL_SSC3_lvds_sscg_Profile_over_underflow_flag(data)                (0x00000002&((data)<<1))
+#define SYS_LVDS_PLL_SSC3_lvds_sscg_Profile_over_underflow_flag_src(data)            ((0x00000002&(data))>>1)
+#define SYS_LVDS_PLL_SSC3_get_lvds_sscg_Profile_over_underflow_flag(data)            ((0x00000002&(data))>>1)
+#define SYS_LVDS_PLL_SSC3_lvds_ss_load_shift                                         (0)
+#define SYS_LVDS_PLL_SSC3_lvds_ss_load_mask                                          (0x00000001)
+#define SYS_LVDS_PLL_SSC3_lvds_ss_load(data)                                         (0x00000001&((data)<<0))
+#define SYS_LVDS_PLL_SSC3_lvds_ss_load_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_LVDS_PLL_SSC3_get_lvds_ss_load(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SCPU1                                                                0x18000100
+#define SYS_PLL_SCPU1_reg_addr                                                       "0xB8000100"
+#define SYS_PLL_SCPU1_reg                                                            0xB8000100
+#define set_SYS_PLL_SCPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SCPU1_reg)=data)
+#define get_SYS_PLL_SCPU1_reg   (*((volatile unsigned int*) SYS_PLL_SCPU1_reg))
+#define SYS_PLL_SCPU1_inst_adr                                                       "0x0040"
+#define SYS_PLL_SCPU1_inst                                                           0x0040
+#define SYS_PLL_SCPU1_REG_PLLSCPU_RS_shift                                           (29)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_RS_mask                                            (0xE0000000)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_RS(data)                                           (0xE0000000&((data)<<29))
+#define SYS_PLL_SCPU1_REG_PLLSCPU_RS_src(data)                                       ((0xE0000000&(data))>>29)
+#define SYS_PLL_SCPU1_get_REG_PLLSCPU_RS(data)                                       ((0xE0000000&(data))>>29)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_LDO_VSEL_shift                                     (27)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_LDO_VSEL_mask                                      (0x18000000)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_LDO_VSEL(data)                                     (0x18000000&((data)<<27))
+#define SYS_PLL_SCPU1_REG_PLLSCPU_LDO_VSEL_src(data)                                 ((0x18000000&(data))>>27)
+#define SYS_PLL_SCPU1_get_REG_PLLSCPU_LDO_VSEL(data)                                 ((0x18000000&(data))>>27)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CP_shift                                           (26)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CP_mask                                            (0x04000000)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CP(data)                                           (0x04000000&((data)<<26))
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CP_src(data)                                       ((0x04000000&(data))>>26)
+#define SYS_PLL_SCPU1_get_REG_PLLSCPU_CP(data)                                       ((0x04000000&(data))>>26)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_DBUG_EN_shift                                      (25)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_DBUG_EN_mask                                       (0x02000000)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_DBUG_EN(data)                                      (0x02000000&((data)<<25))
+#define SYS_PLL_SCPU1_REG_PLLSCPU_DBUG_EN_src(data)                                  ((0x02000000&(data))>>25)
+#define SYS_PLL_SCPU1_get_REG_PLLSCPU_DBUG_EN(data)                                  ((0x02000000&(data))>>25)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CPMODE_shift                                       (24)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CPMODE_mask                                        (0x01000000)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CPMODE(data)                                       (0x01000000&((data)<<24))
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CPMODE_src(data)                                   ((0x01000000&(data))>>24)
+#define SYS_PLL_SCPU1_get_REG_PLLSCPU_CPMODE(data)                                   ((0x01000000&(data))>>24)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_HIGH_KVCO_shift                                    (23)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_HIGH_KVCO_mask                                     (0x00800000)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_HIGH_KVCO(data)                                    (0x00800000&((data)<<23))
+#define SYS_PLL_SCPU1_REG_PLLSCPU_HIGH_KVCO_src(data)                                ((0x00800000&(data))>>23)
+#define SYS_PLL_SCPU1_get_REG_PLLSCPU_HIGH_KVCO(data)                                ((0x00800000&(data))>>23)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_RESERVE_shift                                      (22)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_RESERVE_mask                                       (0x00400000)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_RESERVE(data)                                      (0x00400000&((data)<<22))
+#define SYS_PLL_SCPU1_REG_PLLSCPU_RESERVE_src(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_SCPU1_get_REG_PLLSCPU_RESERVE(data)                                  ((0x00400000&(data))>>22)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CCO_shift                                          (21)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CCO_mask                                           (0x00200000)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CCO(data)                                          (0x00200000&((data)<<21))
+#define SYS_PLL_SCPU1_REG_PLLSCPU_CCO_src(data)                                      ((0x00200000&(data))>>21)
+#define SYS_PLL_SCPU1_get_REG_PLLSCPU_CCO(data)                                      ((0x00200000&(data))>>21)
+#define SYS_PLL_SCPU1_PLLSCPU_N_shift                                                (7)
+#define SYS_PLL_SCPU1_PLLSCPU_N_mask                                                 (0x00000180)
+#define SYS_PLL_SCPU1_PLLSCPU_N(data)                                                (0x00000180&((data)<<7))
+#define SYS_PLL_SCPU1_PLLSCPU_N_src(data)                                            ((0x00000180&(data))>>7)
+#define SYS_PLL_SCPU1_get_PLLSCPU_N(data)                                            ((0x00000180&(data))>>7)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_IP_shift                                           (3)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_IP_mask                                            (0x00000078)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_IP(data)                                           (0x00000078&((data)<<3))
+#define SYS_PLL_SCPU1_REG_PLLSCPU_IP_src(data)                                       ((0x00000078&(data))>>3)
+#define SYS_PLL_SCPU1_get_REG_PLLSCPU_IP(data)                                       ((0x00000078&(data))>>3)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_TST_shift                                          (2)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_TST_mask                                           (0x00000004)
+#define SYS_PLL_SCPU1_REG_PLLSCPU_TST(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_SCPU1_REG_PLLSCPU_TST_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU1_get_REG_PLLSCPU_TST(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU1_PLLSCPU_RSTB_shift                                             (1)
+#define SYS_PLL_SCPU1_PLLSCPU_RSTB_mask                                              (0x00000002)
+#define SYS_PLL_SCPU1_PLLSCPU_RSTB(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_SCPU1_PLLSCPU_RSTB_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SCPU1_get_PLLSCPU_RSTB(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_SCPU1_PLLSCPU_POW_shift                                              (0)
+#define SYS_PLL_SCPU1_PLLSCPU_POW_mask                                               (0x00000001)
+#define SYS_PLL_SCPU1_PLLSCPU_POW(data)                                              (0x00000001&((data)<<0))
+#define SYS_PLL_SCPU1_PLLSCPU_POW_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_PLL_SCPU1_get_PLLSCPU_POW(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SCPU2                                                                0x18000104
+#define SYS_PLL_SCPU2_reg_addr                                                       "0xB8000104"
+#define SYS_PLL_SCPU2_reg                                                            0xB8000104
+#define set_SYS_PLL_SCPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SCPU2_reg)=data)
+#define get_SYS_PLL_SCPU2_reg   (*((volatile unsigned int*) SYS_PLL_SCPU2_reg))
+#define SYS_PLL_SCPU2_inst_adr                                                       "0x0041"
+#define SYS_PLL_SCPU2_inst                                                           0x0041
+#define SYS_PLL_SCPU2_NCODE_T_SCPU_shift                                             (21)
+#define SYS_PLL_SCPU2_NCODE_T_SCPU_mask                                              (0x1FE00000)
+#define SYS_PLL_SCPU2_NCODE_T_SCPU(data)                                             (0x1FE00000&((data)<<21))
+#define SYS_PLL_SCPU2_NCODE_T_SCPU_src(data)                                         ((0x1FE00000&(data))>>21)
+#define SYS_PLL_SCPU2_get_NCODE_T_SCPU(data)                                         ((0x1FE00000&(data))>>21)
+#define SYS_PLL_SCPU2_FCODE_T_SCPU_shift                                             (10)
+#define SYS_PLL_SCPU2_FCODE_T_SCPU_mask                                              (0x001FFC00)
+#define SYS_PLL_SCPU2_FCODE_T_SCPU(data)                                             (0x001FFC00&((data)<<10))
+#define SYS_PLL_SCPU2_FCODE_T_SCPU_src(data)                                         ((0x001FFC00&(data))>>10)
+#define SYS_PLL_SCPU2_get_FCODE_T_SCPU(data)                                         ((0x001FFC00&(data))>>10)
+#define SYS_PLL_SCPU2_REG_OC_STEP_SET_shift                                          (0)
+#define SYS_PLL_SCPU2_REG_OC_STEP_SET_mask                                           (0x000003FF)
+#define SYS_PLL_SCPU2_REG_OC_STEP_SET(data)                                          (0x000003FF&((data)<<0))
+#define SYS_PLL_SCPU2_REG_OC_STEP_SET_src(data)                                      ((0x000003FF&(data))>>0)
+#define SYS_PLL_SCPU2_get_REG_OC_STEP_SET(data)                                      ((0x000003FF&(data))>>0)
+
+
+#define SYS_PLL_SCPU3                                                                0x18000108
+#define SYS_PLL_SCPU3_reg_addr                                                       "0xB8000108"
+#define SYS_PLL_SCPU3_reg                                                            0xB8000108
+#define set_SYS_PLL_SCPU3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SCPU3_reg)=data)
+#define get_SYS_PLL_SCPU3_reg   (*((volatile unsigned int*) SYS_PLL_SCPU3_reg))
+#define SYS_PLL_SCPU3_inst_adr                                                       "0x0042"
+#define SYS_PLL_SCPU3_inst                                                           0x0042
+#define SYS_PLL_SCPU3_REG_SEL_OC_MODE_shift                                          (25)
+#define SYS_PLL_SCPU3_REG_SEL_OC_MODE_mask                                           (0x06000000)
+#define SYS_PLL_SCPU3_REG_SEL_OC_MODE(data)                                          (0x06000000&((data)<<25))
+#define SYS_PLL_SCPU3_REG_SEL_OC_MODE_src(data)                                      ((0x06000000&(data))>>25)
+#define SYS_PLL_SCPU3_get_REG_SEL_OC_MODE(data)                                      ((0x06000000&(data))>>25)
+#define SYS_PLL_SCPU3_REG_HS_OC_STOP_DIFF_shift                                      (23)
+#define SYS_PLL_SCPU3_REG_HS_OC_STOP_DIFF_mask                                       (0x01800000)
+#define SYS_PLL_SCPU3_REG_HS_OC_STOP_DIFF(data)                                      (0x01800000&((data)<<23))
+#define SYS_PLL_SCPU3_REG_HS_OC_STOP_DIFF_src(data)                                  ((0x01800000&(data))>>23)
+#define SYS_PLL_SCPU3_get_REG_HS_OC_STOP_DIFF(data)                                  ((0x01800000&(data))>>23)
+#define SYS_PLL_SCPU3_REG_OC_DONE_delay_shift                                        (17)
+#define SYS_PLL_SCPU3_REG_OC_DONE_delay_mask                                         (0x007E0000)
+#define SYS_PLL_SCPU3_REG_OC_DONE_delay(data)                                        (0x007E0000&((data)<<17))
+#define SYS_PLL_SCPU3_REG_OC_DONE_delay_src(data)                                    ((0x007E0000&(data))>>17)
+#define SYS_PLL_SCPU3_get_REG_OC_DONE_delay(data)                                    ((0x007E0000&(data))>>17)
+#define SYS_PLL_SCPU3_REG_PI_CUR_SEL_shift                                           (15)
+#define SYS_PLL_SCPU3_REG_PI_CUR_SEL_mask                                            (0x00018000)
+#define SYS_PLL_SCPU3_REG_PI_CUR_SEL(data)                                           (0x00018000&((data)<<15))
+#define SYS_PLL_SCPU3_REG_PI_CUR_SEL_src(data)                                       ((0x00018000&(data))>>15)
+#define SYS_PLL_SCPU3_get_REG_PI_CUR_SEL(data)                                       ((0x00018000&(data))>>15)
+#define SYS_PLL_SCPU3_REG_F390K_shift                                                (13)
+#define SYS_PLL_SCPU3_REG_F390K_mask                                                 (0x00006000)
+#define SYS_PLL_SCPU3_REG_F390K(data)                                                (0x00006000&((data)<<13))
+#define SYS_PLL_SCPU3_REG_F390K_src(data)                                            ((0x00006000&(data))>>13)
+#define SYS_PLL_SCPU3_get_REG_F390K(data)                                            ((0x00006000&(data))>>13)
+#define SYS_PLL_SCPU3_REG_TIME0_CK_shift                                             (10)
+#define SYS_PLL_SCPU3_REG_TIME0_CK_mask                                              (0x00001C00)
+#define SYS_PLL_SCPU3_REG_TIME0_CK(data)                                             (0x00001C00&((data)<<10))
+#define SYS_PLL_SCPU3_REG_TIME0_CK_src(data)                                         ((0x00001C00&(data))>>10)
+#define SYS_PLL_SCPU3_get_REG_TIME0_CK(data)                                         ((0x00001C00&(data))>>10)
+#define SYS_PLL_SCPU3_REG_TIME_RDY_CKOUT_shift                                       (8)
+#define SYS_PLL_SCPU3_REG_TIME_RDY_CKOUT_mask                                        (0x00000300)
+#define SYS_PLL_SCPU3_REG_TIME_RDY_CKOUT(data)                                       (0x00000300&((data)<<8))
+#define SYS_PLL_SCPU3_REG_TIME_RDY_CKOUT_src(data)                                   ((0x00000300&(data))>>8)
+#define SYS_PLL_SCPU3_get_REG_TIME_RDY_CKOUT(data)                                   ((0x00000300&(data))>>8)
+#define SYS_PLL_SCPU3_REG_TIME2_RST_WIDTH_shift                                      (6)
+#define SYS_PLL_SCPU3_REG_TIME2_RST_WIDTH_mask                                       (0x000000C0)
+#define SYS_PLL_SCPU3_REG_TIME2_RST_WIDTH(data)                                      (0x000000C0&((data)<<6))
+#define SYS_PLL_SCPU3_REG_TIME2_RST_WIDTH_src(data)                                  ((0x000000C0&(data))>>6)
+#define SYS_PLL_SCPU3_get_REG_TIME2_RST_WIDTH(data)                                  ((0x000000C0&(data))>>6)
+#define SYS_PLL_SCPU3_REG_BYPASS_PI_shift                                            (5)
+#define SYS_PLL_SCPU3_REG_BYPASS_PI_mask                                             (0x00000020)
+#define SYS_PLL_SCPU3_REG_BYPASS_PI(data)                                            (0x00000020&((data)<<5))
+#define SYS_PLL_SCPU3_REG_BYPASS_PI_src(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PLL_SCPU3_get_REG_BYPASS_PI(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PLL_SCPU3_REG_SDM_ORDER_shift                                            (4)
+#define SYS_PLL_SCPU3_REG_SDM_ORDER_mask                                             (0x00000010)
+#define SYS_PLL_SCPU3_REG_SDM_ORDER(data)                                            (0x00000010&((data)<<4))
+#define SYS_PLL_SCPU3_REG_SDM_ORDER_src(data)                                        ((0x00000010&(data))>>4)
+#define SYS_PLL_SCPU3_get_REG_SDM_ORDER(data)                                        ((0x00000010&(data))>>4)
+#define SYS_PLL_SCPU3_REG_EN_WDOG_shift                                              (3)
+#define SYS_PLL_SCPU3_REG_EN_WDOG_mask                                               (0x00000008)
+#define SYS_PLL_SCPU3_REG_EN_WDOG(data)                                              (0x00000008&((data)<<3))
+#define SYS_PLL_SCPU3_REG_EN_WDOG_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PLL_SCPU3_get_REG_EN_WDOG(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PLL_SCPU3_REG_EN_PI_DEBUG_shift                                          (2)
+#define SYS_PLL_SCPU3_REG_EN_PI_DEBUG_mask                                           (0x00000004)
+#define SYS_PLL_SCPU3_REG_EN_PI_DEBUG(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_SCPU3_REG_EN_PI_DEBUG_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU3_get_REG_EN_PI_DEBUG(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_SCPU3_RSTB_shift                                                     (1)
+#define SYS_PLL_SCPU3_RSTB_mask                                                      (0x00000002)
+#define SYS_PLL_SCPU3_RSTB(data)                                                     (0x00000002&((data)<<1))
+#define SYS_PLL_SCPU3_RSTB_src(data)                                                 ((0x00000002&(data))>>1)
+#define SYS_PLL_SCPU3_get_RSTB(data)                                                 ((0x00000002&(data))>>1)
+#define SYS_PLL_SCPU3_OC_EN_shift                                                    (0)
+#define SYS_PLL_SCPU3_OC_EN_mask                                                     (0x00000001)
+#define SYS_PLL_SCPU3_OC_EN(data)                                                    (0x00000001&((data)<<0))
+#define SYS_PLL_SCPU3_OC_EN_src(data)                                                ((0x00000001&(data))>>0)
+#define SYS_PLL_SCPU3_get_OC_EN(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_ACPU1                                                                0x1800010c
+#define SYS_PLL_ACPU1_reg_addr                                                       "0xB800010C"
+#define SYS_PLL_ACPU1_reg                                                            0xB800010C
+#define set_SYS_PLL_ACPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_ACPU1_reg)=data)
+#define get_SYS_PLL_ACPU1_reg   (*((volatile unsigned int*) SYS_PLL_ACPU1_reg))
+#define SYS_PLL_ACPU1_inst_adr                                                       "0x0043"
+#define SYS_PLL_ACPU1_inst                                                           0x0043
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST_shift                                        (29)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST_mask                                         (0x20000000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST(data)                                        (0x20000000&((data)<<29))
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDRST_src(data)                                    ((0x20000000&(data))>>29)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_WDRST(data)                                    ((0x20000000&(data))>>29)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET_shift                                        (28)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET_mask                                         (0x10000000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET(data)                                        (0x10000000&((data)<<28))
+#define SYS_PLL_ACPU1_REG_PLLACPU_WDSET_src(data)                                    ((0x10000000&(data))>>28)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_WDSET(data)                                    ((0x10000000&(data))>>28)
+#define SYS_PLL_ACPU1_REG_PLLACPU_CS_shift                                           (26)
+#define SYS_PLL_ACPU1_REG_PLLACPU_CS_mask                                            (0x0C000000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_CS(data)                                           (0x0C000000&((data)<<26))
+#define SYS_PLL_ACPU1_REG_PLLACPU_CS_src(data)                                       ((0x0C000000&(data))>>26)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_CS(data)                                       ((0x0C000000&(data))>>26)
+#define SYS_PLL_ACPU1_REG_PLLACPU_O_shift                                            (24)
+#define SYS_PLL_ACPU1_REG_PLLACPU_O_mask                                             (0x03000000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_O(data)                                            (0x03000000&((data)<<24))
+#define SYS_PLL_ACPU1_REG_PLLACPU_O_src(data)                                        ((0x03000000&(data))>>24)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_O(data)                                        ((0x03000000&(data))>>24)
+#define SYS_PLL_ACPU1_REG_PLLACPU_RS_shift                                           (21)
+#define SYS_PLL_ACPU1_REG_PLLACPU_RS_mask                                            (0x00E00000)
+#define SYS_PLL_ACPU1_REG_PLLACPU_RS(data)                                           (0x00E00000&((data)<<21))
+#define SYS_PLL_ACPU1_REG_PLLACPU_RS_src(data)                                       ((0x00E00000&(data))>>21)
+#define SYS_PLL_ACPU1_get_REG_PLLACPU_RS(data)                                       ((0x00E00000&(data))>>21)
+#define SYS_PLL_ACPU1_PLLACPU_N_shift                                                (19)
+#define SYS_PLL_ACPU1_PLLACPU_N_mask                                                 (0x00180000)
+#define SYS_PLL_ACPU1_PLLACPU_N(data)                                                (0x00180000&((data)<<19))
+#define SYS_PLL_ACPU1_PLLACPU_N_src(data)                                            ((0x00180000&(data))>>19)
+#define SYS_PLL_ACPU1_get_PLLACPU_N(data)                                            ((0x00180000&(data))>>19)
+#define SYS_PLL_ACPU1_PLLACPU_M_shift                                                (12)
+#define SYS_PLL_ACPU1_PLLACPU_M_mask                                                 (0x0007F000)
+#define SYS_PLL_ACPU1_PLLACPU_M(data)                                                (0x0007F000&((data)<<12))
+#define SYS_PLL_ACPU1_PLLACPU_M_src(data)                                            ((0x0007F000&(data))>>12)
+#define SYS_PLL_ACPU1_get_PLLACPU_M(data)                                            ((0x0007F000&(data))>>12)
+#define SYS_PLL_ACPU1_PLLACPU_IP_shift                                               (9)
+#define SYS_PLL_ACPU1_PLLACPU_IP_mask                                                (0x00000E00)
+#define SYS_PLL_ACPU1_PLLACPU_IP(data)                                               (0x00000E00&((data)<<9))
+#define SYS_PLL_ACPU1_PLLACPU_IP_src(data)                                           ((0x00000E00&(data))>>9)
+#define SYS_PLL_ACPU1_get_PLLACPU_IP(data)                                           ((0x00000E00&(data))>>9)
+#define SYS_PLL_ACPU1_PLLACPU_TST_shift                                              (0)
+#define SYS_PLL_ACPU1_PLLACPU_TST_mask                                               (0x00000001)
+#define SYS_PLL_ACPU1_PLLACPU_TST(data)                                              (0x00000001&((data)<<0))
+#define SYS_PLL_ACPU1_PLLACPU_TST_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_PLL_ACPU1_get_PLLACPU_TST(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_ACPU2                                                                0x18000110
+#define SYS_PLL_ACPU2_reg_addr                                                       "0xB8000110"
+#define SYS_PLL_ACPU2_reg                                                            0xB8000110
+#define set_SYS_PLL_ACPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_ACPU2_reg)=data)
+#define get_SYS_PLL_ACPU2_reg   (*((volatile unsigned int*) SYS_PLL_ACPU2_reg))
+#define SYS_PLL_ACPU2_inst_adr                                                       "0x0044"
+#define SYS_PLL_ACPU2_inst                                                           0x0044
+#define SYS_PLL_ACPU2_PLLACPU_OEB_shift                                              (2)
+#define SYS_PLL_ACPU2_PLLACPU_OEB_mask                                               (0x00000004)
+#define SYS_PLL_ACPU2_PLLACPU_OEB(data)                                              (0x00000004&((data)<<2))
+#define SYS_PLL_ACPU2_PLLACPU_OEB_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_ACPU2_get_PLLACPU_OEB(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_ACPU2_PLLACPU_RSTB_shift                                             (1)
+#define SYS_PLL_ACPU2_PLLACPU_RSTB_mask                                              (0x00000002)
+#define SYS_PLL_ACPU2_PLLACPU_RSTB(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_ACPU2_PLLACPU_RSTB_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_ACPU2_get_PLLACPU_RSTB(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_ACPU2_PLLACPU_POW_shift                                              (0)
+#define SYS_PLL_ACPU2_PLLACPU_POW_mask                                               (0x00000001)
+#define SYS_PLL_ACPU2_PLLACPU_POW(data)                                              (0x00000001&((data)<<0))
+#define SYS_PLL_ACPU2_PLLACPU_POW_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_PLL_ACPU2_get_PLLACPU_POW(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VCPU1                                                                0x18000114
+#define SYS_PLL_VCPU1_reg_addr                                                       "0xB8000114"
+#define SYS_PLL_VCPU1_reg                                                            0xB8000114
+#define set_SYS_PLL_VCPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_VCPU1_reg)=data)
+#define get_SYS_PLL_VCPU1_reg   (*((volatile unsigned int*) SYS_PLL_VCPU1_reg))
+#define SYS_PLL_VCPU1_inst_adr                                                       "0x0045"
+#define SYS_PLL_VCPU1_inst                                                           0x0045
+#define SYS_PLL_VCPU1_REG_PLLVCPU_WDRST_shift                                        (29)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_WDRST_mask                                         (0x20000000)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_WDRST(data)                                        (0x20000000&((data)<<29))
+#define SYS_PLL_VCPU1_REG_PLLVCPU_WDRST_src(data)                                    ((0x20000000&(data))>>29)
+#define SYS_PLL_VCPU1_get_REG_PLLVCPU_WDRST(data)                                    ((0x20000000&(data))>>29)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_WDSET_shift                                        (28)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_WDSET_mask                                         (0x10000000)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_WDSET(data)                                        (0x10000000&((data)<<28))
+#define SYS_PLL_VCPU1_REG_PLLVCPU_WDSET_src(data)                                    ((0x10000000&(data))>>28)
+#define SYS_PLL_VCPU1_get_REG_PLLVCPU_WDSET(data)                                    ((0x10000000&(data))>>28)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_CS_shift                                           (26)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_CS_mask                                            (0x0C000000)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_CS(data)                                           (0x0C000000&((data)<<26))
+#define SYS_PLL_VCPU1_REG_PLLVCPU_CS_src(data)                                       ((0x0C000000&(data))>>26)
+#define SYS_PLL_VCPU1_get_REG_PLLVCPU_CS(data)                                       ((0x0C000000&(data))>>26)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_O_shift                                            (24)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_O_mask                                             (0x03000000)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_O(data)                                            (0x03000000&((data)<<24))
+#define SYS_PLL_VCPU1_REG_PLLVCPU_O_src(data)                                        ((0x03000000&(data))>>24)
+#define SYS_PLL_VCPU1_get_REG_PLLVCPU_O(data)                                        ((0x03000000&(data))>>24)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_RS_shift                                           (21)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_RS_mask                                            (0x00E00000)
+#define SYS_PLL_VCPU1_REG_PLLVCPU_RS(data)                                           (0x00E00000&((data)<<21))
+#define SYS_PLL_VCPU1_REG_PLLVCPU_RS_src(data)                                       ((0x00E00000&(data))>>21)
+#define SYS_PLL_VCPU1_get_REG_PLLVCPU_RS(data)                                       ((0x00E00000&(data))>>21)
+#define SYS_PLL_VCPU1_PLLVCPU_N_shift                                                (18)
+#define SYS_PLL_VCPU1_PLLVCPU_N_mask                                                 (0x000C0000)
+#define SYS_PLL_VCPU1_PLLVCPU_N(data)                                                (0x000C0000&((data)<<18))
+#define SYS_PLL_VCPU1_PLLVCPU_N_src(data)                                            ((0x000C0000&(data))>>18)
+#define SYS_PLL_VCPU1_get_PLLVCPU_N(data)                                            ((0x000C0000&(data))>>18)
+#define SYS_PLL_VCPU1_PLLVCPU_M_shift                                                (11)
+#define SYS_PLL_VCPU1_PLLVCPU_M_mask                                                 (0x0003F800)
+#define SYS_PLL_VCPU1_PLLVCPU_M(data)                                                (0x0003F800&((data)<<11))
+#define SYS_PLL_VCPU1_PLLVCPU_M_src(data)                                            ((0x0003F800&(data))>>11)
+#define SYS_PLL_VCPU1_get_PLLVCPU_M(data)                                            ((0x0003F800&(data))>>11)
+#define SYS_PLL_VCPU1_PLLVCPU_IP_shift                                               (8)
+#define SYS_PLL_VCPU1_PLLVCPU_IP_mask                                                (0x00000700)
+#define SYS_PLL_VCPU1_PLLVCPU_IP(data)                                               (0x00000700&((data)<<8))
+#define SYS_PLL_VCPU1_PLLVCPU_IP_src(data)                                           ((0x00000700&(data))>>8)
+#define SYS_PLL_VCPU1_get_PLLVCPU_IP(data)                                           ((0x00000700&(data))>>8)
+#define SYS_PLL_VCPU1_PLLVCPU_TST_shift                                              (0)
+#define SYS_PLL_VCPU1_PLLVCPU_TST_mask                                               (0x00000001)
+#define SYS_PLL_VCPU1_PLLVCPU_TST(data)                                              (0x00000001&((data)<<0))
+#define SYS_PLL_VCPU1_PLLVCPU_TST_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_PLL_VCPU1_get_PLLVCPU_TST(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_VCPU2                                                                0x18000118
+#define SYS_PLL_VCPU2_reg_addr                                                       "0xB8000118"
+#define SYS_PLL_VCPU2_reg                                                            0xB8000118
+#define set_SYS_PLL_VCPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_VCPU2_reg)=data)
+#define get_SYS_PLL_VCPU2_reg   (*((volatile unsigned int*) SYS_PLL_VCPU2_reg))
+#define SYS_PLL_VCPU2_inst_adr                                                       "0x0046"
+#define SYS_PLL_VCPU2_inst                                                           0x0046
+#define SYS_PLL_VCPU2_PLLVCPU_OEB_shift                                              (2)
+#define SYS_PLL_VCPU2_PLLVCPU_OEB_mask                                               (0x00000004)
+#define SYS_PLL_VCPU2_PLLVCPU_OEB(data)                                              (0x00000004&((data)<<2))
+#define SYS_PLL_VCPU2_PLLVCPU_OEB_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_VCPU2_get_PLLVCPU_OEB(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_VCPU2_PLLVCPU_RSTB_shift                                             (1)
+#define SYS_PLL_VCPU2_PLLVCPU_RSTB_mask                                              (0x00000002)
+#define SYS_PLL_VCPU2_PLLVCPU_RSTB(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_VCPU2_PLLVCPU_RSTB_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_VCPU2_get_PLLVCPU_RSTB(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_VCPU2_PLLVCPU_POW_shift                                              (0)
+#define SYS_PLL_VCPU2_PLLVCPU_POW_mask                                               (0x00000001)
+#define SYS_PLL_VCPU2_PLLVCPU_POW(data)                                              (0x00000001&((data)<<0))
+#define SYS_PLL_VCPU2_PLLVCPU_POW_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_PLL_VCPU2_get_PLLVCPU_POW(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_SD1                                                             0x1800011c
+#define SYS_PLL_DISP_SD1_reg_addr                                                    "0xB800011C"
+#define SYS_PLL_DISP_SD1_reg                                                         0xB800011C
+#define set_SYS_PLL_DISP_SD1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_SD1_reg)=data)
+#define get_SYS_PLL_DISP_SD1_reg   (*((volatile unsigned int*) SYS_PLL_DISP_SD1_reg))
+#define SYS_PLL_DISP_SD1_inst_adr                                                    "0x0047"
+#define SYS_PLL_DISP_SD1_inst                                                        0x0047
+#define SYS_PLL_DISP_SD1_PLLDDSA_N_shift                                             (30)
+#define SYS_PLL_DISP_SD1_PLLDDSA_N_mask                                              (0xC0000000)
+#define SYS_PLL_DISP_SD1_PLLDDSA_N(data)                                             (0xC0000000&((data)<<30))
+#define SYS_PLL_DISP_SD1_PLLDDSA_N_src(data)                                         ((0xC0000000&(data))>>30)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_N(data)                                         ((0xC0000000&(data))>>30)
+#define SYS_PLL_DISP_SD1_PLLDDSA_M_shift                                             (23)
+#define SYS_PLL_DISP_SD1_PLLDDSA_M_mask                                              (0x3F800000)
+#define SYS_PLL_DISP_SD1_PLLDDSA_M(data)                                             (0x3F800000&((data)<<23))
+#define SYS_PLL_DISP_SD1_PLLDDSA_M_src(data)                                         ((0x3F800000&(data))>>23)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_M(data)                                         ((0x3F800000&(data))>>23)
+#define SYS_PLL_DISP_SD1_PLLDDSA_IP_shift                                            (20)
+#define SYS_PLL_DISP_SD1_PLLDDSA_IP_mask                                             (0x00700000)
+#define SYS_PLL_DISP_SD1_PLLDDSA_IP(data)                                            (0x00700000&((data)<<20))
+#define SYS_PLL_DISP_SD1_PLLDDSA_IP_src(data)                                        ((0x00700000&(data))>>20)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_IP(data)                                        ((0x00700000&(data))>>20)
+#define SYS_PLL_DISP_SD1_PLLDDSA_RS_shift                                            (17)
+#define SYS_PLL_DISP_SD1_PLLDDSA_RS_mask                                             (0x000E0000)
+#define SYS_PLL_DISP_SD1_PLLDDSA_RS(data)                                            (0x000E0000&((data)<<17))
+#define SYS_PLL_DISP_SD1_PLLDDSA_RS_src(data)                                        ((0x000E0000&(data))>>17)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_RS(data)                                        ((0x000E0000&(data))>>17)
+#define SYS_PLL_DISP_SD1_PLLDDSA_CS_shift                                            (15)
+#define SYS_PLL_DISP_SD1_PLLDDSA_CS_mask                                             (0x00018000)
+#define SYS_PLL_DISP_SD1_PLLDDSA_CS(data)                                            (0x00018000&((data)<<15))
+#define SYS_PLL_DISP_SD1_PLLDDSA_CS_src(data)                                        ((0x00018000&(data))>>15)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_CS(data)                                        ((0x00018000&(data))>>15)
+#define SYS_PLL_DISP_SD1_PLLDDSA_CP_shift                                            (13)
+#define SYS_PLL_DISP_SD1_PLLDDSA_CP_mask                                             (0x00006000)
+#define SYS_PLL_DISP_SD1_PLLDDSA_CP(data)                                            (0x00006000&((data)<<13))
+#define SYS_PLL_DISP_SD1_PLLDDSA_CP_src(data)                                        ((0x00006000&(data))>>13)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_CP(data)                                        ((0x00006000&(data))>>13)
+#define SYS_PLL_DISP_SD1_PLLDDSA_R3_shift                                            (10)
+#define SYS_PLL_DISP_SD1_PLLDDSA_R3_mask                                             (0x00001C00)
+#define SYS_PLL_DISP_SD1_PLLDDSA_R3(data)                                            (0x00001C00&((data)<<10))
+#define SYS_PLL_DISP_SD1_PLLDDSA_R3_src(data)                                        ((0x00001C00&(data))>>10)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_R3(data)                                        ((0x00001C00&(data))>>10)
+#define SYS_PLL_DISP_SD1_PLLDDSA_C3_shift                                            (8)
+#define SYS_PLL_DISP_SD1_PLLDDSA_C3_mask                                             (0x00000300)
+#define SYS_PLL_DISP_SD1_PLLDDSA_C3(data)                                            (0x00000300&((data)<<8))
+#define SYS_PLL_DISP_SD1_PLLDDSA_C3_src(data)                                        ((0x00000300&(data))>>8)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_C3(data)                                        ((0x00000300&(data))>>8)
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_RL_shift                                         (6)
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_RL_mask                                          (0x000000C0)
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_RL(data)                                         (0x000000C0&((data)<<6))
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_RL_src(data)                                     ((0x000000C0&(data))>>6)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_PI_RL(data)                                     ((0x000000C0&(data))>>6)
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_RS_shift                                         (4)
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_RS_mask                                          (0x00000030)
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_RS(data)                                         (0x00000030&((data)<<4))
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_RS_src(data)                                     ((0x00000030&(data))>>4)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_PI_RS(data)                                     ((0x00000030&(data))>>4)
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_BIAS_shift                                       (2)
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_BIAS_mask                                        (0x0000000C)
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_BIAS(data)                                       (0x0000000C&((data)<<2))
+#define SYS_PLL_DISP_SD1_PLLDDSA_PI_BIAS_src(data)                                   ((0x0000000C&(data))>>2)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_PI_BIAS(data)                                   ((0x0000000C&(data))>>2)
+#define SYS_PLL_DISP_SD1_PLLDDSA_WDMODE_shift                                        (0)
+#define SYS_PLL_DISP_SD1_PLLDDSA_WDMODE_mask                                         (0x00000003)
+#define SYS_PLL_DISP_SD1_PLLDDSA_WDMODE(data)                                        (0x00000003&((data)<<0))
+#define SYS_PLL_DISP_SD1_PLLDDSA_WDMODE_src(data)                                    ((0x00000003&(data))>>0)
+#define SYS_PLL_DISP_SD1_get_PLLDDSA_WDMODE(data)                                    ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_DISP_SD2                                                             0x18000120
+#define SYS_PLL_DISP_SD2_reg_addr                                                    "0xB8000120"
+#define SYS_PLL_DISP_SD2_reg                                                         0xB8000120
+#define set_SYS_PLL_DISP_SD2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_SD2_reg)=data)
+#define get_SYS_PLL_DISP_SD2_reg   (*((volatile unsigned int*) SYS_PLL_DISP_SD2_reg))
+#define SYS_PLL_DISP_SD2_inst_adr                                                    "0x0048"
+#define SYS_PLL_DISP_SD2_inst                                                        0x0048
+#define SYS_PLL_DISP_SD2_write_en11_shift                                            (28)
+#define SYS_PLL_DISP_SD2_write_en11_mask                                             (0x10000000)
+#define SYS_PLL_DISP_SD2_write_en11(data)                                            (0x10000000&((data)<<28))
+#define SYS_PLL_DISP_SD2_write_en11_src(data)                                        ((0x10000000&(data))>>28)
+#define SYS_PLL_DISP_SD2_get_write_en11(data)                                        ((0x10000000&(data))>>28)
+#define SYS_PLL_DISP_SD2_psaud_1a_phase_sel_shift                                    (27)
+#define SYS_PLL_DISP_SD2_psaud_1a_phase_sel_mask                                     (0x08000000)
+#define SYS_PLL_DISP_SD2_psaud_1a_phase_sel(data)                                    (0x08000000&((data)<<27))
+#define SYS_PLL_DISP_SD2_psaud_1a_phase_sel_src(data)                                ((0x08000000&(data))>>27)
+#define SYS_PLL_DISP_SD2_get_psaud_1a_phase_sel(data)                                ((0x08000000&(data))>>27)
+#define SYS_PLL_DISP_SD2_psaud_2a_phase_sel_shift                                    (26)
+#define SYS_PLL_DISP_SD2_psaud_2a_phase_sel_mask                                     (0x04000000)
+#define SYS_PLL_DISP_SD2_psaud_2a_phase_sel(data)                                    (0x04000000&((data)<<26))
+#define SYS_PLL_DISP_SD2_psaud_2a_phase_sel_src(data)                                ((0x04000000&(data))>>26)
+#define SYS_PLL_DISP_SD2_get_psaud_2a_phase_sel(data)                                ((0x04000000&(data))>>26)
+#define SYS_PLL_DISP_SD2_write_en10_shift                                            (25)
+#define SYS_PLL_DISP_SD2_write_en10_mask                                             (0x02000000)
+#define SYS_PLL_DISP_SD2_write_en10(data)                                            (0x02000000&((data)<<25))
+#define SYS_PLL_DISP_SD2_write_en10_src(data)                                        ((0x02000000&(data))>>25)
+#define SYS_PLL_DISP_SD2_get_write_en10(data)                                        ((0x02000000&(data))>>25)
+#define SYS_PLL_DISP_SD2_pcr_a_smooth_en_shift                                       (24)
+#define SYS_PLL_DISP_SD2_pcr_a_smooth_en_mask                                        (0x01000000)
+#define SYS_PLL_DISP_SD2_pcr_a_smooth_en(data)                                       (0x01000000&((data)<<24))
+#define SYS_PLL_DISP_SD2_pcr_a_smooth_en_src(data)                                   ((0x01000000&(data))>>24)
+#define SYS_PLL_DISP_SD2_get_pcr_a_smooth_en(data)                                   ((0x01000000&(data))>>24)
+#define SYS_PLL_DISP_SD2_write_en9_shift                                             (23)
+#define SYS_PLL_DISP_SD2_write_en9_mask                                              (0x00800000)
+#define SYS_PLL_DISP_SD2_write_en9(data)                                             (0x00800000&((data)<<23))
+#define SYS_PLL_DISP_SD2_write_en9_src(data)                                         ((0x00800000&(data))>>23)
+#define SYS_PLL_DISP_SD2_get_write_en9(data)                                         ((0x00800000&(data))>>23)
+#define SYS_PLL_DISP_SD2_pcr_a_phase_sel_shift                                       (22)
+#define SYS_PLL_DISP_SD2_pcr_a_phase_sel_mask                                        (0x00400000)
+#define SYS_PLL_DISP_SD2_pcr_a_phase_sel(data)                                       (0x00400000&((data)<<22))
+#define SYS_PLL_DISP_SD2_pcr_a_phase_sel_src(data)                                   ((0x00400000&(data))>>22)
+#define SYS_PLL_DISP_SD2_get_pcr_a_phase_sel(data)                                   ((0x00400000&(data))>>22)
+#define SYS_PLL_DISP_SD2_write_en8_shift                                             (21)
+#define SYS_PLL_DISP_SD2_write_en8_mask                                              (0x00200000)
+#define SYS_PLL_DISP_SD2_write_en8(data)                                             (0x00200000&((data)<<21))
+#define SYS_PLL_DISP_SD2_write_en8_src(data)                                         ((0x00200000&(data))>>21)
+#define SYS_PLL_DISP_SD2_get_write_en8(data)                                         ((0x00200000&(data))>>21)
+#define SYS_PLL_DISP_SD2_pcr_a_ctl_en_shift                                          (20)
+#define SYS_PLL_DISP_SD2_pcr_a_ctl_en_mask                                           (0x00100000)
+#define SYS_PLL_DISP_SD2_pcr_a_ctl_en(data)                                          (0x00100000&((data)<<20))
+#define SYS_PLL_DISP_SD2_pcr_a_ctl_en_src(data)                                      ((0x00100000&(data))>>20)
+#define SYS_PLL_DISP_SD2_get_pcr_a_ctl_en(data)                                      ((0x00100000&(data))>>20)
+#define SYS_PLL_DISP_SD2_write_en7_shift                                             (19)
+#define SYS_PLL_DISP_SD2_write_en7_mask                                              (0x00080000)
+#define SYS_PLL_DISP_SD2_write_en7(data)                                             (0x00080000&((data)<<19))
+#define SYS_PLL_DISP_SD2_write_en7_src(data)                                         ((0x00080000&(data))>>19)
+#define SYS_PLL_DISP_SD2_get_write_en7(data)                                         ((0x00080000&(data))>>19)
+#define SYS_PLL_DISP_SD2_PLLDDSA_FUPDN_shift                                         (18)
+#define SYS_PLL_DISP_SD2_PLLDDSA_FUPDN_mask                                          (0x00040000)
+#define SYS_PLL_DISP_SD2_PLLDDSA_FUPDN(data)                                         (0x00040000&((data)<<18))
+#define SYS_PLL_DISP_SD2_PLLDDSA_FUPDN_src(data)                                     ((0x00040000&(data))>>18)
+#define SYS_PLL_DISP_SD2_get_PLLDDSA_FUPDN(data)                                     ((0x00040000&(data))>>18)
+#define SYS_PLL_DISP_SD2_write_en6_shift                                             (17)
+#define SYS_PLL_DISP_SD2_write_en6_mask                                              (0x00020000)
+#define SYS_PLL_DISP_SD2_write_en6(data)                                             (0x00020000&((data)<<17))
+#define SYS_PLL_DISP_SD2_write_en6_src(data)                                         ((0x00020000&(data))>>17)
+#define SYS_PLL_DISP_SD2_get_write_en6(data)                                         ((0x00020000&(data))>>17)
+#define SYS_PLL_DISP_SD2_PLLDDSA_DDSEN_shift                                         (16)
+#define SYS_PLL_DISP_SD2_PLLDDSA_DDSEN_mask                                          (0x00010000)
+#define SYS_PLL_DISP_SD2_PLLDDSA_DDSEN(data)                                         (0x00010000&((data)<<16))
+#define SYS_PLL_DISP_SD2_PLLDDSA_DDSEN_src(data)                                     ((0x00010000&(data))>>16)
+#define SYS_PLL_DISP_SD2_get_PLLDDSA_DDSEN(data)                                     ((0x00010000&(data))>>16)
+#define SYS_PLL_DISP_SD2_write_en5_shift                                             (15)
+#define SYS_PLL_DISP_SD2_write_en5_mask                                              (0x00008000)
+#define SYS_PLL_DISP_SD2_write_en5(data)                                             (0x00008000&((data)<<15))
+#define SYS_PLL_DISP_SD2_write_en5_src(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PLL_DISP_SD2_get_write_en5(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PLL_DISP_SD2_PLLDDSA_VCORB_shift                                         (14)
+#define SYS_PLL_DISP_SD2_PLLDDSA_VCORB_mask                                          (0x00004000)
+#define SYS_PLL_DISP_SD2_PLLDDSA_VCORB(data)                                         (0x00004000&((data)<<14))
+#define SYS_PLL_DISP_SD2_PLLDDSA_VCORB_src(data)                                     ((0x00004000&(data))>>14)
+#define SYS_PLL_DISP_SD2_get_PLLDDSA_VCORB(data)                                     ((0x00004000&(data))>>14)
+#define SYS_PLL_DISP_SD2_write_en4_shift                                             (13)
+#define SYS_PLL_DISP_SD2_write_en4_mask                                              (0x00002000)
+#define SYS_PLL_DISP_SD2_write_en4(data)                                             (0x00002000&((data)<<13))
+#define SYS_PLL_DISP_SD2_write_en4_src(data)                                         ((0x00002000&(data))>>13)
+#define SYS_PLL_DISP_SD2_get_write_en4(data)                                         ((0x00002000&(data))>>13)
+#define SYS_PLL_DISP_SD2_PLLDDSA_TST_shift                                           (12)
+#define SYS_PLL_DISP_SD2_PLLDDSA_TST_mask                                            (0x00001000)
+#define SYS_PLL_DISP_SD2_PLLDDSA_TST(data)                                           (0x00001000&((data)<<12))
+#define SYS_PLL_DISP_SD2_PLLDDSA_TST_src(data)                                       ((0x00001000&(data))>>12)
+#define SYS_PLL_DISP_SD2_get_PLLDDSA_TST(data)                                       ((0x00001000&(data))>>12)
+#define SYS_PLL_DISP_SD2_PLLDDSA_PSTST_shift                                         (11)
+#define SYS_PLL_DISP_SD2_PLLDDSA_PSTST_mask                                          (0x00000800)
+#define SYS_PLL_DISP_SD2_PLLDDSA_PSTST(data)                                         (0x00000800&((data)<<11))
+#define SYS_PLL_DISP_SD2_PLLDDSA_PSTST_src(data)                                     ((0x00000800&(data))>>11)
+#define SYS_PLL_DISP_SD2_get_PLLDDSA_PSTST(data)                                     ((0x00000800&(data))>>11)
+#define SYS_PLL_DISP_SD2_write_en3_shift                                             (10)
+#define SYS_PLL_DISP_SD2_write_en3_mask                                              (0x00000400)
+#define SYS_PLL_DISP_SD2_write_en3(data)                                             (0x00000400&((data)<<10))
+#define SYS_PLL_DISP_SD2_write_en3_src(data)                                         ((0x00000400&(data))>>10)
+#define SYS_PLL_DISP_SD2_get_write_en3(data)                                         ((0x00000400&(data))>>10)
+#define SYS_PLL_DISP_SD2_PSAUD1A_FUPDN_shift                                         (9)
+#define SYS_PLL_DISP_SD2_PSAUD1A_FUPDN_mask                                          (0x00000200)
+#define SYS_PLL_DISP_SD2_PSAUD1A_FUPDN(data)                                         (0x00000200&((data)<<9))
+#define SYS_PLL_DISP_SD2_PSAUD1A_FUPDN_src(data)                                     ((0x00000200&(data))>>9)
+#define SYS_PLL_DISP_SD2_get_PSAUD1A_FUPDN(data)                                     ((0x00000200&(data))>>9)
+#define SYS_PLL_DISP_SD2_PSAUD1A_DIV_shift                                           (8)
+#define SYS_PLL_DISP_SD2_PSAUD1A_DIV_mask                                            (0x00000100)
+#define SYS_PLL_DISP_SD2_PSAUD1A_DIV(data)                                           (0x00000100&((data)<<8))
+#define SYS_PLL_DISP_SD2_PSAUD1A_DIV_src(data)                                       ((0x00000100&(data))>>8)
+#define SYS_PLL_DISP_SD2_get_PSAUD1A_DIV(data)                                       ((0x00000100&(data))>>8)
+#define SYS_PLL_DISP_SD2_write_en2_shift                                             (7)
+#define SYS_PLL_DISP_SD2_write_en2_mask                                              (0x00000080)
+#define SYS_PLL_DISP_SD2_write_en2(data)                                             (0x00000080&((data)<<7))
+#define SYS_PLL_DISP_SD2_write_en2_src(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PLL_DISP_SD2_get_write_en2(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PLL_DISP_SD2_PSAUD1A_TST_shift                                           (6)
+#define SYS_PLL_DISP_SD2_PSAUD1A_TST_mask                                            (0x00000040)
+#define SYS_PLL_DISP_SD2_PSAUD1A_TST(data)                                           (0x00000040&((data)<<6))
+#define SYS_PLL_DISP_SD2_PSAUD1A_TST_src(data)                                       ((0x00000040&(data))>>6)
+#define SYS_PLL_DISP_SD2_get_PSAUD1A_TST(data)                                       ((0x00000040&(data))>>6)
+#define SYS_PLL_DISP_SD2_PSAUD1A_PSEN_shift                                          (5)
+#define SYS_PLL_DISP_SD2_PSAUD1A_PSEN_mask                                           (0x00000020)
+#define SYS_PLL_DISP_SD2_PSAUD1A_PSEN(data)                                          (0x00000020&((data)<<5))
+#define SYS_PLL_DISP_SD2_PSAUD1A_PSEN_src(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PLL_DISP_SD2_get_PSAUD1A_PSEN(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PLL_DISP_SD2_write_en1_shift                                             (4)
+#define SYS_PLL_DISP_SD2_write_en1_mask                                              (0x00000010)
+#define SYS_PLL_DISP_SD2_write_en1(data)                                             (0x00000010&((data)<<4))
+#define SYS_PLL_DISP_SD2_write_en1_src(data)                                         ((0x00000010&(data))>>4)
+#define SYS_PLL_DISP_SD2_get_write_en1(data)                                         ((0x00000010&(data))>>4)
+#define SYS_PLL_DISP_SD2_PSAUD2A_FUPDN_shift                                         (3)
+#define SYS_PLL_DISP_SD2_PSAUD2A_FUPDN_mask                                          (0x00000008)
+#define SYS_PLL_DISP_SD2_PSAUD2A_FUPDN(data)                                         (0x00000008&((data)<<3))
+#define SYS_PLL_DISP_SD2_PSAUD2A_FUPDN_src(data)                                     ((0x00000008&(data))>>3)
+#define SYS_PLL_DISP_SD2_get_PSAUD2A_FUPDN(data)                                     ((0x00000008&(data))>>3)
+#define SYS_PLL_DISP_SD2_PSAUD2A_DIV_shift                                           (2)
+#define SYS_PLL_DISP_SD2_PSAUD2A_DIV_mask                                            (0x00000004)
+#define SYS_PLL_DISP_SD2_PSAUD2A_DIV(data)                                           (0x00000004&((data)<<2))
+#define SYS_PLL_DISP_SD2_PSAUD2A_DIV_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_SD2_get_PSAUD2A_DIV(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_SD2_PSAUD2A_TST_shift                                           (1)
+#define SYS_PLL_DISP_SD2_PSAUD2A_TST_mask                                            (0x00000002)
+#define SYS_PLL_DISP_SD2_PSAUD2A_TST(data)                                           (0x00000002&((data)<<1))
+#define SYS_PLL_DISP_SD2_PSAUD2A_TST_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_SD2_get_PSAUD2A_TST(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_SD2_PSAUD2A_PSEN_shift                                          (0)
+#define SYS_PLL_DISP_SD2_PSAUD2A_PSEN_mask                                           (0x00000001)
+#define SYS_PLL_DISP_SD2_PSAUD2A_PSEN(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_SD2_PSAUD2A_PSEN_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_SD2_get_PSAUD2A_PSEN(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_SD3                                                             0x18000124
+#define SYS_PLL_DISP_SD3_reg_addr                                                    "0xB8000124"
+#define SYS_PLL_DISP_SD3_reg                                                         0xB8000124
+#define set_SYS_PLL_DISP_SD3_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_SD3_reg)=data)
+#define get_SYS_PLL_DISP_SD3_reg   (*((volatile unsigned int*) SYS_PLL_DISP_SD3_reg))
+#define SYS_PLL_DISP_SD3_inst_adr                                                    "0x0049"
+#define SYS_PLL_DISP_SD3_inst                                                        0x0049
+#define SYS_PLL_DISP_SD3_PSAUD1A_OEB_shift                                           (3)
+#define SYS_PLL_DISP_SD3_PSAUD1A_OEB_mask                                            (0x00000008)
+#define SYS_PLL_DISP_SD3_PSAUD1A_OEB(data)                                           (0x00000008&((data)<<3))
+#define SYS_PLL_DISP_SD3_PSAUD1A_OEB_src(data)                                       ((0x00000008&(data))>>3)
+#define SYS_PLL_DISP_SD3_get_PSAUD1A_OEB(data)                                       ((0x00000008&(data))>>3)
+#define SYS_PLL_DISP_SD3_PSAUD1A_RSTB_shift                                          (2)
+#define SYS_PLL_DISP_SD3_PSAUD1A_RSTB_mask                                           (0x00000004)
+#define SYS_PLL_DISP_SD3_PSAUD1A_RSTB(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_DISP_SD3_PSAUD1A_RSTB_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_SD3_get_PSAUD1A_RSTB(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_SD3_PSAUD2A_OEB_shift                                           (1)
+#define SYS_PLL_DISP_SD3_PSAUD2A_OEB_mask                                            (0x00000002)
+#define SYS_PLL_DISP_SD3_PSAUD2A_OEB(data)                                           (0x00000002&((data)<<1))
+#define SYS_PLL_DISP_SD3_PSAUD2A_OEB_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_SD3_get_PSAUD2A_OEB(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_SD3_PSAUD2A_RSTB_shift                                          (0)
+#define SYS_PLL_DISP_SD3_PSAUD2A_RSTB_mask                                           (0x00000001)
+#define SYS_PLL_DISP_SD3_PSAUD2A_RSTB(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_SD3_PSAUD2A_RSTB_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_SD3_get_PSAUD2A_RSTB(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_SD4                                                             0x18000128
+#define SYS_PLL_DISP_SD4_reg_addr                                                    "0xB8000128"
+#define SYS_PLL_DISP_SD4_reg                                                         0xB8000128
+#define set_SYS_PLL_DISP_SD4_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_SD4_reg)=data)
+#define get_SYS_PLL_DISP_SD4_reg   (*((volatile unsigned int*) SYS_PLL_DISP_SD4_reg))
+#define SYS_PLL_DISP_SD4_inst_adr                                                    "0x004A"
+#define SYS_PLL_DISP_SD4_inst                                                        0x004A
+#define SYS_PLL_DISP_SD4_PLLDDSA_K_shift                                             (4)
+#define SYS_PLL_DISP_SD4_PLLDDSA_K_mask                                              (0x00000030)
+#define SYS_PLL_DISP_SD4_PLLDDSA_K(data)                                             (0x00000030&((data)<<4))
+#define SYS_PLL_DISP_SD4_PLLDDSA_K_src(data)                                         ((0x00000030&(data))>>4)
+#define SYS_PLL_DISP_SD4_get_PLLDDSA_K(data)                                         ((0x00000030&(data))>>4)
+#define SYS_PLL_DISP_SD4_PLLDDSA_OEB_shift                                           (2)
+#define SYS_PLL_DISP_SD4_PLLDDSA_OEB_mask                                            (0x00000004)
+#define SYS_PLL_DISP_SD4_PLLDDSA_OEB(data)                                           (0x00000004&((data)<<2))
+#define SYS_PLL_DISP_SD4_PLLDDSA_OEB_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_SD4_get_PLLDDSA_OEB(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_SD4_PLLDDSA_RSTB_shift                                          (1)
+#define SYS_PLL_DISP_SD4_PLLDDSA_RSTB_mask                                           (0x00000002)
+#define SYS_PLL_DISP_SD4_PLLDDSA_RSTB(data)                                          (0x00000002&((data)<<1))
+#define SYS_PLL_DISP_SD4_PLLDDSA_RSTB_src(data)                                      ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_SD4_get_PLLDDSA_RSTB(data)                                      ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_SD4_PLLDDSA_POW_shift                                           (0)
+#define SYS_PLL_DISP_SD4_PLLDDSA_POW_mask                                            (0x00000001)
+#define SYS_PLL_DISP_SD4_PLLDDSA_POW(data)                                           (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_SD4_PLLDDSA_POW_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_SD4_get_PLLDDSA_POW(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_SD5                                                             0x1800012c
+#define SYS_PLL_DISP_SD5_reg_addr                                                    "0xB800012C"
+#define SYS_PLL_DISP_SD5_reg                                                         0xB800012C
+#define set_SYS_PLL_DISP_SD5_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_SD5_reg)=data)
+#define get_SYS_PLL_DISP_SD5_reg   (*((volatile unsigned int*) SYS_PLL_DISP_SD5_reg))
+#define SYS_PLL_DISP_SD5_inst_adr                                                    "0x004B"
+#define SYS_PLL_DISP_SD5_inst                                                        0x004B
+#define SYS_PLL_DISP_SD5_N_shift                                                     (16)
+#define SYS_PLL_DISP_SD5_N_mask                                                      (0xFFFF0000)
+#define SYS_PLL_DISP_SD5_N(data)                                                     (0xFFFF0000&((data)<<16))
+#define SYS_PLL_DISP_SD5_N_src(data)                                                 ((0xFFFF0000&(data))>>16)
+#define SYS_PLL_DISP_SD5_get_N(data)                                                 ((0xFFFF0000&(data))>>16)
+#define SYS_PLL_DISP_SD5_M_shift                                                     (0)
+#define SYS_PLL_DISP_SD5_M_mask                                                      (0x0000FFFF)
+#define SYS_PLL_DISP_SD5_M(data)                                                     (0x0000FFFF&((data)<<0))
+#define SYS_PLL_DISP_SD5_M_src(data)                                                 ((0x0000FFFF&(data))>>0)
+#define SYS_PLL_DISP_SD5_get_M(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define SYS_PLL_DISP_SD6                                                             0x18000130
+#define SYS_PLL_DISP_SD6_reg_addr                                                    "0xB8000130"
+#define SYS_PLL_DISP_SD6_reg                                                         0xB8000130
+#define set_SYS_PLL_DISP_SD6_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_SD6_reg)=data)
+#define get_SYS_PLL_DISP_SD6_reg   (*((volatile unsigned int*) SYS_PLL_DISP_SD6_reg))
+#define SYS_PLL_DISP_SD6_inst_adr                                                    "0x004C"
+#define SYS_PLL_DISP_SD6_inst                                                        0x004C
+#define SYS_PLL_DISP_SD6_N_nxt_shift                                                 (0)
+#define SYS_PLL_DISP_SD6_N_nxt_mask                                                  (0x0000FFFF)
+#define SYS_PLL_DISP_SD6_N_nxt(data)                                                 (0x0000FFFF&((data)<<0))
+#define SYS_PLL_DISP_SD6_N_nxt_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define SYS_PLL_DISP_SD6_get_N_nxt(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define SYS_PLL_DISP_SD7                                                             0x18000134
+#define SYS_PLL_DISP_SD7_reg_addr                                                    "0xB8000134"
+#define SYS_PLL_DISP_SD7_reg                                                         0xB8000134
+#define set_SYS_PLL_DISP_SD7_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_SD7_reg)=data)
+#define get_SYS_PLL_DISP_SD7_reg   (*((volatile unsigned int*) SYS_PLL_DISP_SD7_reg))
+#define SYS_PLL_DISP_SD7_inst_adr                                                    "0x004D"
+#define SYS_PLL_DISP_SD7_inst                                                        0x004D
+#define SYS_PLL_DISP_SD7_N_nxt_add_shift                                             (16)
+#define SYS_PLL_DISP_SD7_N_nxt_add_mask                                              (0x00FF0000)
+#define SYS_PLL_DISP_SD7_N_nxt_add(data)                                             (0x00FF0000&((data)<<16))
+#define SYS_PLL_DISP_SD7_N_nxt_add_src(data)                                         ((0x00FF0000&(data))>>16)
+#define SYS_PLL_DISP_SD7_get_N_nxt_add(data)                                         ((0x00FF0000&(data))>>16)
+#define SYS_PLL_DISP_SD7_N_nxt_add_period_shift                                      (0)
+#define SYS_PLL_DISP_SD7_N_nxt_add_period_mask                                       (0x0000FFFF)
+#define SYS_PLL_DISP_SD7_N_nxt_add_period(data)                                      (0x0000FFFF&((data)<<0))
+#define SYS_PLL_DISP_SD7_N_nxt_add_period_src(data)                                  ((0x0000FFFF&(data))>>0)
+#define SYS_PLL_DISP_SD7_get_N_nxt_add_period(data)                                  ((0x0000FFFF&(data))>>0)
+
+
+#define SYS_PLL_DISP_HD1                                                             0x18000138
+#define SYS_PLL_DISP_HD1_reg_addr                                                    "0xB8000138"
+#define SYS_PLL_DISP_HD1_reg                                                         0xB8000138
+#define set_SYS_PLL_DISP_HD1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_HD1_reg)=data)
+#define get_SYS_PLL_DISP_HD1_reg   (*((volatile unsigned int*) SYS_PLL_DISP_HD1_reg))
+#define SYS_PLL_DISP_HD1_inst_adr                                                    "0x004E"
+#define SYS_PLL_DISP_HD1_inst                                                        0x004E
+#define SYS_PLL_DISP_HD1_PLLDISP_Q2_shift                                            (24)
+#define SYS_PLL_DISP_HD1_PLLDISP_Q2_mask                                             (0x03000000)
+#define SYS_PLL_DISP_HD1_PLLDISP_Q2(data)                                            (0x03000000&((data)<<24))
+#define SYS_PLL_DISP_HD1_PLLDISP_Q2_src(data)                                        ((0x03000000&(data))>>24)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_Q2(data)                                        ((0x03000000&(data))>>24)
+#define SYS_PLL_DISP_HD1_PLLDISP_BP_shift                                            (23)
+#define SYS_PLL_DISP_HD1_PLLDISP_BP_mask                                             (0x00800000)
+#define SYS_PLL_DISP_HD1_PLLDISP_BP(data)                                            (0x00800000&((data)<<23))
+#define SYS_PLL_DISP_HD1_PLLDISP_BP_src(data)                                        ((0x00800000&(data))>>23)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_BP(data)                                        ((0x00800000&(data))>>23)
+#define SYS_PLL_DISP_HD1_PLLDISP_N_shift                                             (20)
+#define SYS_PLL_DISP_HD1_PLLDISP_N_mask                                              (0x00700000)
+#define SYS_PLL_DISP_HD1_PLLDISP_N(data)                                             (0x00700000&((data)<<20))
+#define SYS_PLL_DISP_HD1_PLLDISP_N_src(data)                                         ((0x00700000&(data))>>20)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_N(data)                                         ((0x00700000&(data))>>20)
+#define SYS_PLL_DISP_HD1_PLLDISP_Q1_shift                                            (18)
+#define SYS_PLL_DISP_HD1_PLLDISP_Q1_mask                                             (0x000C0000)
+#define SYS_PLL_DISP_HD1_PLLDISP_Q1(data)                                            (0x000C0000&((data)<<18))
+#define SYS_PLL_DISP_HD1_PLLDISP_Q1_src(data)                                        ((0x000C0000&(data))>>18)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_Q1(data)                                        ((0x000C0000&(data))>>18)
+#define SYS_PLL_DISP_HD1_PLLDISP_M_shift                                             (11)
+#define SYS_PLL_DISP_HD1_PLLDISP_M_mask                                              (0x0003F800)
+#define SYS_PLL_DISP_HD1_PLLDISP_M(data)                                             (0x0003F800&((data)<<11))
+#define SYS_PLL_DISP_HD1_PLLDISP_M_src(data)                                         ((0x0003F800&(data))>>11)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_M(data)                                         ((0x0003F800&(data))>>11)
+#define SYS_PLL_DISP_HD1_PLLDISP_IP_shift                                            (9)
+#define SYS_PLL_DISP_HD1_PLLDISP_IP_mask                                             (0x00000600)
+#define SYS_PLL_DISP_HD1_PLLDISP_IP(data)                                            (0x00000600&((data)<<9))
+#define SYS_PLL_DISP_HD1_PLLDISP_IP_src(data)                                        ((0x00000600&(data))>>9)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_IP(data)                                        ((0x00000600&(data))>>9)
+#define SYS_PLL_DISP_HD1_PLLDISP_RS_shift                                            (6)
+#define SYS_PLL_DISP_HD1_PLLDISP_RS_mask                                             (0x000001C0)
+#define SYS_PLL_DISP_HD1_PLLDISP_RS(data)                                            (0x000001C0&((data)<<6))
+#define SYS_PLL_DISP_HD1_PLLDISP_RS_src(data)                                        ((0x000001C0&(data))>>6)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_RS(data)                                        ((0x000001C0&(data))>>6)
+#define SYS_PLL_DISP_HD1_PLLDISP_CS_shift                                            (4)
+#define SYS_PLL_DISP_HD1_PLLDISP_CS_mask                                             (0x00000030)
+#define SYS_PLL_DISP_HD1_PLLDISP_CS(data)                                            (0x00000030&((data)<<4))
+#define SYS_PLL_DISP_HD1_PLLDISP_CS_src(data)                                        ((0x00000030&(data))>>4)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_CS(data)                                        ((0x00000030&(data))>>4)
+#define SYS_PLL_DISP_HD1_PLLDISP_WDRST_shift                                         (2)
+#define SYS_PLL_DISP_HD1_PLLDISP_WDRST_mask                                          (0x00000004)
+#define SYS_PLL_DISP_HD1_PLLDISP_WDRST(data)                                         (0x00000004&((data)<<2))
+#define SYS_PLL_DISP_HD1_PLLDISP_WDRST_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_WDRST(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_HD1_PLLDISP_WDSET_shift                                         (1)
+#define SYS_PLL_DISP_HD1_PLLDISP_WDSET_mask                                          (0x00000002)
+#define SYS_PLL_DISP_HD1_PLLDISP_WDSET(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_DISP_HD1_PLLDISP_WDSET_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_WDSET(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_HD1_PLLDISP_TST_shift                                           (0)
+#define SYS_PLL_DISP_HD1_PLLDISP_TST_mask                                            (0x00000001)
+#define SYS_PLL_DISP_HD1_PLLDISP_TST(data)                                           (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_HD1_PLLDISP_TST_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_HD1_get_PLLDISP_TST(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_HD2                                                             0x1800013c
+#define SYS_PLL_DISP_HD2_reg_addr                                                    "0xB800013C"
+#define SYS_PLL_DISP_HD2_reg                                                         0xB800013C
+#define set_SYS_PLL_DISP_HD2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_HD2_reg)=data)
+#define get_SYS_PLL_DISP_HD2_reg   (*((volatile unsigned int*) SYS_PLL_DISP_HD2_reg))
+#define SYS_PLL_DISP_HD2_inst_adr                                                    "0x004F"
+#define SYS_PLL_DISP_HD2_inst                                                        0x004F
+#define SYS_PLL_DISP_HD2_PLLDISP_OEB2_shift                                          (3)
+#define SYS_PLL_DISP_HD2_PLLDISP_OEB2_mask                                           (0x00000008)
+#define SYS_PLL_DISP_HD2_PLLDISP_OEB2(data)                                          (0x00000008&((data)<<3))
+#define SYS_PLL_DISP_HD2_PLLDISP_OEB2_src(data)                                      ((0x00000008&(data))>>3)
+#define SYS_PLL_DISP_HD2_get_PLLDISP_OEB2(data)                                      ((0x00000008&(data))>>3)
+#define SYS_PLL_DISP_HD2_PLLDISP_OEB1_shift                                          (2)
+#define SYS_PLL_DISP_HD2_PLLDISP_OEB1_mask                                           (0x00000004)
+#define SYS_PLL_DISP_HD2_PLLDISP_OEB1(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_DISP_HD2_PLLDISP_OEB1_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_HD2_get_PLLDISP_OEB1(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_HD2_PLLDISP_RSTB_shift                                          (1)
+#define SYS_PLL_DISP_HD2_PLLDISP_RSTB_mask                                           (0x00000002)
+#define SYS_PLL_DISP_HD2_PLLDISP_RSTB(data)                                          (0x00000002&((data)<<1))
+#define SYS_PLL_DISP_HD2_PLLDISP_RSTB_src(data)                                      ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_HD2_get_PLLDISP_RSTB(data)                                      ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_HD2_PLLDISP_POW_shift                                           (0)
+#define SYS_PLL_DISP_HD2_PLLDISP_POW_mask                                            (0x00000001)
+#define SYS_PLL_DISP_HD2_PLLDISP_POW(data)                                           (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_HD2_PLLDISP_POW_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_HD2_get_PLLDISP_POW(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL1_TEST                                                                0x18000140
+#define SYS_PLL1_TEST_reg_addr                                                       "0xB8000140"
+#define SYS_PLL1_TEST_reg                                                            0xB8000140
+#define set_SYS_PLL1_TEST_reg(data)   (*((volatile unsigned int*) SYS_PLL1_TEST_reg)=data)
+#define get_SYS_PLL1_TEST_reg   (*((volatile unsigned int*) SYS_PLL1_TEST_reg))
+#define SYS_PLL1_TEST_inst_adr                                                       "0x0050"
+#define SYS_PLL1_TEST_inst                                                           0x0050
+#define SYS_PLL1_TEST_REG_PLLTST_POW_shift                                           (4)
+#define SYS_PLL1_TEST_REG_PLLTST_POW_mask                                            (0x00000010)
+#define SYS_PLL1_TEST_REG_PLLTST_POW(data)                                           (0x00000010&((data)<<4))
+#define SYS_PLL1_TEST_REG_PLLTST_POW_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PLL1_TEST_get_REG_PLLTST_POW(data)                                       ((0x00000010&(data))>>4)
+
+
+#define SYS_PLL_REG_CTRL                                                             0x18000144
+#define SYS_PLL_REG_CTRL_reg_addr                                                    "0xB8000144"
+#define SYS_PLL_REG_CTRL_reg                                                         0xB8000144
+#define set_SYS_PLL_REG_CTRL_reg(data)   (*((volatile unsigned int*) SYS_PLL_REG_CTRL_reg)=data)
+#define get_SYS_PLL_REG_CTRL_reg   (*((volatile unsigned int*) SYS_PLL_REG_CTRL_reg))
+#define SYS_PLL_REG_CTRL_inst_adr                                                    "0x0051"
+#define SYS_PLL_REG_CTRL_inst                                                        0x0051
+#define SYS_PLL_REG_CTRL_write_en4_shift                                             (15)
+#define SYS_PLL_REG_CTRL_write_en4_mask                                              (0x00008000)
+#define SYS_PLL_REG_CTRL_write_en4(data)                                             (0x00008000&((data)<<15))
+#define SYS_PLL_REG_CTRL_write_en4_src(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PLL_REG_CTRL_get_write_en4(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PLL_REG_CTRL_PLLDDR_CCO_BAND_shift                                       (13)
+#define SYS_PLL_REG_CTRL_PLLDDR_CCO_BAND_mask                                        (0x00006000)
+#define SYS_PLL_REG_CTRL_PLLDDR_CCO_BAND(data)                                       (0x00006000&((data)<<13))
+#define SYS_PLL_REG_CTRL_PLLDDR_CCO_BAND_src(data)                                   ((0x00006000&(data))>>13)
+#define SYS_PLL_REG_CTRL_get_PLLDDR_CCO_BAND(data)                                   ((0x00006000&(data))>>13)
+#define SYS_PLL_REG_CTRL_PLLDDR_CCO_KVCO_shift                                       (12)
+#define SYS_PLL_REG_CTRL_PLLDDR_CCO_KVCO_mask                                        (0x00001000)
+#define SYS_PLL_REG_CTRL_PLLDDR_CCO_KVCO(data)                                       (0x00001000&((data)<<12))
+#define SYS_PLL_REG_CTRL_PLLDDR_CCO_KVCO_src(data)                                   ((0x00001000&(data))>>12)
+#define SYS_PLL_REG_CTRL_get_PLLDDR_CCO_KVCO(data)                                   ((0x00001000&(data))>>12)
+#define SYS_PLL_REG_CTRL_write_en3_shift                                             (11)
+#define SYS_PLL_REG_CTRL_write_en3_mask                                              (0x00000800)
+#define SYS_PLL_REG_CTRL_write_en3(data)                                             (0x00000800&((data)<<11))
+#define SYS_PLL_REG_CTRL_write_en3_src(data)                                         ((0x00000800&(data))>>11)
+#define SYS_PLL_REG_CTRL_get_write_en3(data)                                         ((0x00000800&(data))>>11)
+#define SYS_PLL_REG_CTRL_PLLDISP_REG_shift                                           (9)
+#define SYS_PLL_REG_CTRL_PLLDISP_REG_mask                                            (0x00000600)
+#define SYS_PLL_REG_CTRL_PLLDISP_REG(data)                                           (0x00000600&((data)<<9))
+#define SYS_PLL_REG_CTRL_PLLDISP_REG_src(data)                                       ((0x00000600&(data))>>9)
+#define SYS_PLL_REG_CTRL_get_PLLDISP_REG(data)                                       ((0x00000600&(data))>>9)
+#define SYS_PLL_REG_CTRL_PLLDISP_POWREG_shift                                        (8)
+#define SYS_PLL_REG_CTRL_PLLDISP_POWREG_mask                                         (0x00000100)
+#define SYS_PLL_REG_CTRL_PLLDISP_POWREG(data)                                        (0x00000100&((data)<<8))
+#define SYS_PLL_REG_CTRL_PLLDISP_POWREG_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_REG_CTRL_get_PLLDISP_POWREG(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PLL_REG_CTRL_write_en2_shift                                             (7)
+#define SYS_PLL_REG_CTRL_write_en2_mask                                              (0x00000080)
+#define SYS_PLL_REG_CTRL_write_en2(data)                                             (0x00000080&((data)<<7))
+#define SYS_PLL_REG_CTRL_write_en2_src(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PLL_REG_CTRL_get_write_en2(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PLL_REG_CTRL_PLLDDS_REG_shift                                            (5)
+#define SYS_PLL_REG_CTRL_PLLDDS_REG_mask                                             (0x00000060)
+#define SYS_PLL_REG_CTRL_PLLDDS_REG(data)                                            (0x00000060&((data)<<5))
+#define SYS_PLL_REG_CTRL_PLLDDS_REG_src(data)                                        ((0x00000060&(data))>>5)
+#define SYS_PLL_REG_CTRL_get_PLLDDS_REG(data)                                        ((0x00000060&(data))>>5)
+#define SYS_PLL_REG_CTRL_PLLDDS_POWREG_shift                                         (4)
+#define SYS_PLL_REG_CTRL_PLLDDS_POWREG_mask                                          (0x00000010)
+#define SYS_PLL_REG_CTRL_PLLDDS_POWREG(data)                                         (0x00000010&((data)<<4))
+#define SYS_PLL_REG_CTRL_PLLDDS_POWREG_src(data)                                     ((0x00000010&(data))>>4)
+#define SYS_PLL_REG_CTRL_get_PLLDDS_POWREG(data)                                     ((0x00000010&(data))>>4)
+#define SYS_PLL_REG_CTRL_write_en1_shift                                             (3)
+#define SYS_PLL_REG_CTRL_write_en1_mask                                              (0x00000008)
+#define SYS_PLL_REG_CTRL_write_en1(data)                                             (0x00000008&((data)<<3))
+#define SYS_PLL_REG_CTRL_write_en1_src(data)                                         ((0x00000008&(data))>>3)
+#define SYS_PLL_REG_CTRL_get_write_en1(data)                                         ((0x00000008&(data))>>3)
+#define SYS_PLL_REG_CTRL_PLLCPU_REG_shift                                            (1)
+#define SYS_PLL_REG_CTRL_PLLCPU_REG_mask                                             (0x00000006)
+#define SYS_PLL_REG_CTRL_PLLCPU_REG(data)                                            (0x00000006&((data)<<1))
+#define SYS_PLL_REG_CTRL_PLLCPU_REG_src(data)                                        ((0x00000006&(data))>>1)
+#define SYS_PLL_REG_CTRL_get_PLLCPU_REG(data)                                        ((0x00000006&(data))>>1)
+#define SYS_PLL_REG_CTRL_PLLCPU_POWREG_shift                                         (0)
+#define SYS_PLL_REG_CTRL_PLLCPU_POWREG_mask                                          (0x00000001)
+#define SYS_PLL_REG_CTRL_PLLCPU_POWREG(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_REG_CTRL_PLLCPU_POWREG_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_REG_CTRL_get_PLLCPU_POWREG(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DDR1                                                                 0x18000150
+#define SYS_PLL_DDR1_reg_addr                                                        "0xB8000150"
+#define SYS_PLL_DDR1_reg                                                             0xB8000150
+#define set_SYS_PLL_DDR1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDR1_reg)=data)
+#define get_SYS_PLL_DDR1_reg   (*((volatile unsigned int*) SYS_PLL_DDR1_reg))
+#define SYS_PLL_DDR1_inst_adr                                                        "0x0054"
+#define SYS_PLL_DDR1_inst                                                            0x0054
+#define SYS_PLL_DDR1_write_en4_shift                                                 (30)
+#define SYS_PLL_DDR1_write_en4_mask                                                  (0x40000000)
+#define SYS_PLL_DDR1_write_en4(data)                                                 (0x40000000&((data)<<30))
+#define SYS_PLL_DDR1_write_en4_src(data)                                             ((0x40000000&(data))>>30)
+#define SYS_PLL_DDR1_get_write_en4(data)                                             ((0x40000000&(data))>>30)
+#define SYS_PLL_DDR1_PLLDDR_PDIV_shift                                               (28)
+#define SYS_PLL_DDR1_PLLDDR_PDIV_mask                                                (0x30000000)
+#define SYS_PLL_DDR1_PLLDDR_PDIV(data)                                               (0x30000000&((data)<<28))
+#define SYS_PLL_DDR1_PLLDDR_PDIV_src(data)                                           ((0x30000000&(data))>>28)
+#define SYS_PLL_DDR1_get_PLLDDR_PDIV(data)                                           ((0x30000000&(data))>>28)
+#define SYS_PLL_DDR1_write_en3_shift                                                 (27)
+#define SYS_PLL_DDR1_write_en3_mask                                                  (0x08000000)
+#define SYS_PLL_DDR1_write_en3(data)                                                 (0x08000000&((data)<<27))
+#define SYS_PLL_DDR1_write_en3_src(data)                                             ((0x08000000&(data))>>27)
+#define SYS_PLL_DDR1_get_write_en3(data)                                             ((0x08000000&(data))>>27)
+#define SYS_PLL_DDR1_PLLDDR_ICP_shift                                                (23)
+#define SYS_PLL_DDR1_PLLDDR_ICP_mask                                                 (0x07800000)
+#define SYS_PLL_DDR1_PLLDDR_ICP(data)                                                (0x07800000&((data)<<23))
+#define SYS_PLL_DDR1_PLLDDR_ICP_src(data)                                            ((0x07800000&(data))>>23)
+#define SYS_PLL_DDR1_get_PLLDDR_ICP(data)                                            ((0x07800000&(data))>>23)
+#define SYS_PLL_DDR1_PLLDDR_PLL_SEL_CPMODE_shift                                     (22)
+#define SYS_PLL_DDR1_PLLDDR_PLL_SEL_CPMODE_mask                                      (0x00400000)
+#define SYS_PLL_DDR1_PLLDDR_PLL_SEL_CPMODE(data)                                     (0x00400000&((data)<<22))
+#define SYS_PLL_DDR1_PLLDDR_PLL_SEL_CPMODE_src(data)                                 ((0x00400000&(data))>>22)
+#define SYS_PLL_DDR1_get_PLLDDR_PLL_SEL_CPMODE(data)                                 ((0x00400000&(data))>>22)
+#define SYS_PLL_DDR1_PLLDDR_LPF_SR_shift                                             (19)
+#define SYS_PLL_DDR1_PLLDDR_LPF_SR_mask                                              (0x00380000)
+#define SYS_PLL_DDR1_PLLDDR_LPF_SR(data)                                             (0x00380000&((data)<<19))
+#define SYS_PLL_DDR1_PLLDDR_LPF_SR_src(data)                                         ((0x00380000&(data))>>19)
+#define SYS_PLL_DDR1_get_PLLDDR_LPF_SR(data)                                         ((0x00380000&(data))>>19)
+#define SYS_PLL_DDR1_PLLDDR_LPF_CP_shift                                             (18)
+#define SYS_PLL_DDR1_PLLDDR_LPF_CP_mask                                              (0x00040000)
+#define SYS_PLL_DDR1_PLLDDR_LPF_CP(data)                                             (0x00040000&((data)<<18))
+#define SYS_PLL_DDR1_PLLDDR_LPF_CP_src(data)                                         ((0x00040000&(data))>>18)
+#define SYS_PLL_DDR1_get_PLLDDR_LPF_CP(data)                                         ((0x00040000&(data))>>18)
+#define SYS_PLL_DDR1_PLLDDR_LOOP_PI_ISEL_shift                                       (15)
+#define SYS_PLL_DDR1_PLLDDR_LOOP_PI_ISEL_mask                                        (0x00038000)
+#define SYS_PLL_DDR1_PLLDDR_LOOP_PI_ISEL(data)                                       (0x00038000&((data)<<15))
+#define SYS_PLL_DDR1_PLLDDR_LOOP_PI_ISEL_src(data)                                   ((0x00038000&(data))>>15)
+#define SYS_PLL_DDR1_get_PLLDDR_LOOP_PI_ISEL(data)                                   ((0x00038000&(data))>>15)
+#define SYS_PLL_DDR1_write_en2_shift                                                 (14)
+#define SYS_PLL_DDR1_write_en2_mask                                                  (0x00004000)
+#define SYS_PLL_DDR1_write_en2(data)                                                 (0x00004000&((data)<<14))
+#define SYS_PLL_DDR1_write_en2_src(data)                                             ((0x00004000&(data))>>14)
+#define SYS_PLL_DDR1_get_write_en2(data)                                             ((0x00004000&(data))>>14)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_SEL6_shift                                       (9)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_SEL6_mask                                        (0x00003E00)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_SEL6(data)                                       (0x00003E00&((data)<<9))
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_SEL6_src(data)                                   ((0x00003E00&(data))>>9)
+#define SYS_PLL_DDR1_get_PLLDDR_POST_PI_SEL6(data)                                   ((0x00003E00&(data))>>9)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_RL_shift                                         (7)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_RL_mask                                          (0x00000180)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_RL(data)                                         (0x00000180&((data)<<7))
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_RL_src(data)                                     ((0x00000180&(data))>>7)
+#define SYS_PLL_DDR1_get_PLLDDR_POST_PI_RL(data)                                     ((0x00000180&(data))>>7)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_BIAS_shift                                       (5)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_BIAS_mask                                        (0x00000060)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_BIAS(data)                                       (0x00000060&((data)<<5))
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_BIAS_src(data)                                   ((0x00000060&(data))>>5)
+#define SYS_PLL_DDR1_get_PLLDDR_POST_PI_BIAS(data)                                   ((0x00000060&(data))>>5)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_RS_shift                                         (4)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_RS_mask                                          (0x00000010)
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_RS(data)                                         (0x00000010&((data)<<4))
+#define SYS_PLL_DDR1_PLLDDR_POST_PI_RS_src(data)                                     ((0x00000010&(data))>>4)
+#define SYS_PLL_DDR1_get_PLLDDR_POST_PI_RS(data)                                     ((0x00000010&(data))>>4)
+#define SYS_PLL_DDR1_write_en1_shift                                                 (3)
+#define SYS_PLL_DDR1_write_en1_mask                                                  (0x00000008)
+#define SYS_PLL_DDR1_write_en1(data)                                                 (0x00000008&((data)<<3))
+#define SYS_PLL_DDR1_write_en1_src(data)                                             ((0x00000008&(data))>>3)
+#define SYS_PLL_DDR1_get_write_en1(data)                                             ((0x00000008&(data))>>3)
+#define SYS_PLL_DDR1_PLLDDR_CKREF_SEL_shift                                          (2)
+#define SYS_PLL_DDR1_PLLDDR_CKREF_SEL_mask                                           (0x00000004)
+#define SYS_PLL_DDR1_PLLDDR_CKREF_SEL(data)                                          (0x00000004&((data)<<2))
+#define SYS_PLL_DDR1_PLLDDR_CKREF_SEL_src(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DDR1_get_PLLDDR_CKREF_SEL(data)                                      ((0x00000004&(data))>>2)
+#define SYS_PLL_DDR1_PLLDDR_PLL_LDO_VSEL_shift                                       (0)
+#define SYS_PLL_DDR1_PLLDDR_PLL_LDO_VSEL_mask                                        (0x00000003)
+#define SYS_PLL_DDR1_PLLDDR_PLL_LDO_VSEL(data)                                       (0x00000003&((data)<<0))
+#define SYS_PLL_DDR1_PLLDDR_PLL_LDO_VSEL_src(data)                                   ((0x00000003&(data))>>0)
+#define SYS_PLL_DDR1_get_PLLDDR_PLL_LDO_VSEL(data)                                   ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_DDR2                                                                 0x18000154
+#define SYS_PLL_DDR2_reg_addr                                                        "0xB8000154"
+#define SYS_PLL_DDR2_reg                                                             0xB8000154
+#define set_SYS_PLL_DDR2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDR2_reg)=data)
+#define get_SYS_PLL_DDR2_reg   (*((volatile unsigned int*) SYS_PLL_DDR2_reg))
+#define SYS_PLL_DDR2_inst_adr                                                        "0x0055"
+#define SYS_PLL_DDR2_inst                                                            0x0055
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL5_shift                                       (25)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL5_mask                                        (0x3E000000)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL5(data)                                       (0x3E000000&((data)<<25))
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL5_src(data)                                   ((0x3E000000&(data))>>25)
+#define SYS_PLL_DDR2_get_PLLDDR_POST_PI_SEL5(data)                                   ((0x3E000000&(data))>>25)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL4_shift                                       (20)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL4_mask                                        (0x01F00000)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL4(data)                                       (0x01F00000&((data)<<20))
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL4_src(data)                                   ((0x01F00000&(data))>>20)
+#define SYS_PLL_DDR2_get_PLLDDR_POST_PI_SEL4(data)                                   ((0x01F00000&(data))>>20)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL3_shift                                       (15)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL3_mask                                        (0x000F8000)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL3(data)                                       (0x000F8000&((data)<<15))
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL3_src(data)                                   ((0x000F8000&(data))>>15)
+#define SYS_PLL_DDR2_get_PLLDDR_POST_PI_SEL3(data)                                   ((0x000F8000&(data))>>15)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL2_shift                                       (10)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL2_mask                                        (0x00007C00)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL2(data)                                       (0x00007C00&((data)<<10))
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL2_src(data)                                   ((0x00007C00&(data))>>10)
+#define SYS_PLL_DDR2_get_PLLDDR_POST_PI_SEL2(data)                                   ((0x00007C00&(data))>>10)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL1_shift                                       (5)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL1_mask                                        (0x000003E0)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL1(data)                                       (0x000003E0&((data)<<5))
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL1_src(data)                                   ((0x000003E0&(data))>>5)
+#define SYS_PLL_DDR2_get_PLLDDR_POST_PI_SEL1(data)                                   ((0x000003E0&(data))>>5)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL0_shift                                       (0)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL0_mask                                        (0x0000001F)
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL0(data)                                       (0x0000001F&((data)<<0))
+#define SYS_PLL_DDR2_PLLDDR_POST_PI_SEL0_src(data)                                   ((0x0000001F&(data))>>0)
+#define SYS_PLL_DDR2_get_PLLDDR_POST_PI_SEL0(data)                                   ((0x0000001F&(data))>>0)
+
+
+#define SYS_PLL_DDR3                                                                 0x18000158
+#define SYS_PLL_DDR3_reg_addr                                                        "0xB8000158"
+#define SYS_PLL_DDR3_reg                                                             0xB8000158
+#define set_SYS_PLL_DDR3_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDR3_reg)=data)
+#define get_SYS_PLL_DDR3_reg   (*((volatile unsigned int*) SYS_PLL_DDR3_reg))
+#define SYS_PLL_DDR3_inst_adr                                                        "0x0056"
+#define SYS_PLL_DDR3_inst                                                            0x0056
+#define SYS_PLL_DDR3_write_en2_shift                                                 (31)
+#define SYS_PLL_DDR3_write_en2_mask                                                  (0x80000000)
+#define SYS_PLL_DDR3_write_en2(data)                                                 (0x80000000&((data)<<31))
+#define SYS_PLL_DDR3_write_en2_src(data)                                             ((0x80000000&(data))>>31)
+#define SYS_PLL_DDR3_get_write_en2(data)                                             ((0x80000000&(data))>>31)
+#define SYS_PLL_DDR3_PLLDDR_DUM_shift                                                (23)
+#define SYS_PLL_DDR3_PLLDDR_DUM_mask                                                 (0x7F800000)
+#define SYS_PLL_DDR3_PLLDDR_DUM(data)                                                (0x7F800000&((data)<<23))
+#define SYS_PLL_DDR3_PLLDDR_DUM_src(data)                                            ((0x7F800000&(data))>>23)
+#define SYS_PLL_DDR3_get_PLLDDR_DUM(data)                                            ((0x7F800000&(data))>>23)
+#define SYS_PLL_DDR3_PLLDDR_PLL_DBUG_EN_shift                                        (22)
+#define SYS_PLL_DDR3_PLLDDR_PLL_DBUG_EN_mask                                         (0x00400000)
+#define SYS_PLL_DDR3_PLLDDR_PLL_DBUG_EN(data)                                        (0x00400000&((data)<<22))
+#define SYS_PLL_DDR3_PLLDDR_PLL_DBUG_EN_src(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_DDR3_get_PLLDDR_PLL_DBUG_EN(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_DDR3_PLLDDR_OESYNC_OP_SEL_shift                                      (16)
+#define SYS_PLL_DDR3_PLLDDR_OESYNC_OP_SEL_mask                                       (0x003F0000)
+#define SYS_PLL_DDR3_PLLDDR_OESYNC_OP_SEL(data)                                      (0x003F0000&((data)<<16))
+#define SYS_PLL_DDR3_PLLDDR_OESYNC_OP_SEL_src(data)                                  ((0x003F0000&(data))>>16)
+#define SYS_PLL_DDR3_get_PLLDDR_OESYNC_OP_SEL(data)                                  ((0x003F0000&(data))>>16)
+#define SYS_PLL_DDR3_PLLDDR_EN_POST_PI_shift                                         (9)
+#define SYS_PLL_DDR3_PLLDDR_EN_POST_PI_mask                                          (0x0000FE00)
+#define SYS_PLL_DDR3_PLLDDR_EN_POST_PI(data)                                         (0x0000FE00&((data)<<9))
+#define SYS_PLL_DDR3_PLLDDR_EN_POST_PI_src(data)                                     ((0x0000FE00&(data))>>9)
+#define SYS_PLL_DDR3_get_PLLDDR_EN_POST_PI(data)                                     ((0x0000FE00&(data))>>9)
+#define SYS_PLL_DDR3_write_en1_shift                                                 (8)
+#define SYS_PLL_DDR3_write_en1_mask                                                  (0x00000100)
+#define SYS_PLL_DDR3_write_en1(data)                                                 (0x00000100&((data)<<8))
+#define SYS_PLL_DDR3_write_en1_src(data)                                             ((0x00000100&(data))>>8)
+#define SYS_PLL_DDR3_get_write_en1(data)                                             ((0x00000100&(data))>>8)
+#define SYS_PLL_DDR3_PLLDDR_CLK_OE_shift                                             (2)
+#define SYS_PLL_DDR3_PLLDDR_CLK_OE_mask                                              (0x000000FC)
+#define SYS_PLL_DDR3_PLLDDR_CLK_OE(data)                                             (0x000000FC&((data)<<2))
+#define SYS_PLL_DDR3_PLLDDR_CLK_OE_src(data)                                         ((0x000000FC&(data))>>2)
+#define SYS_PLL_DDR3_get_PLLDDR_CLK_OE(data)                                         ((0x000000FC&(data))>>2)
+#define SYS_PLL_DDR3_PLLDDR_RSTB_IN_shift                                            (1)
+#define SYS_PLL_DDR3_PLLDDR_RSTB_IN_mask                                             (0x00000002)
+#define SYS_PLL_DDR3_PLLDDR_RSTB_IN(data)                                            (0x00000002&((data)<<1))
+#define SYS_PLL_DDR3_PLLDDR_RSTB_IN_src(data)                                        ((0x00000002&(data))>>1)
+#define SYS_PLL_DDR3_get_PLLDDR_RSTB_IN(data)                                        ((0x00000002&(data))>>1)
+#define SYS_PLL_DDR3_PLLDDR_PLL_EN_shift                                             (0)
+#define SYS_PLL_DDR3_PLLDDR_PLL_EN_mask                                              (0x00000001)
+#define SYS_PLL_DDR3_PLLDDR_PLL_EN(data)                                             (0x00000001&((data)<<0))
+#define SYS_PLL_DDR3_PLLDDR_PLL_EN_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_PLL_DDR3_get_PLLDDR_PLL_EN(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DDR4                                                                 0x1800015C
+#define SYS_PLL_DDR4_reg_addr                                                        "0xB800015C"
+#define SYS_PLL_DDR4_reg                                                             0xB800015C
+#define set_SYS_PLL_DDR4_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDR4_reg)=data)
+#define get_SYS_PLL_DDR4_reg   (*((volatile unsigned int*) SYS_PLL_DDR4_reg))
+#define SYS_PLL_DDR4_inst_adr                                                        "0x0057"
+#define SYS_PLL_DDR4_inst                                                            0x0057
+#define SYS_PLL_DDR4_PLLDDR_WDOUT_CLR_shift                                          (10)
+#define SYS_PLL_DDR4_PLLDDR_WDOUT_CLR_mask                                           (0x00000400)
+#define SYS_PLL_DDR4_PLLDDR_WDOUT_CLR(data)                                          (0x00000400&((data)<<10))
+#define SYS_PLL_DDR4_PLLDDR_WDOUT_CLR_src(data)                                      ((0x00000400&(data))>>10)
+#define SYS_PLL_DDR4_get_PLLDDR_WDOUT_CLR(data)                                      ((0x00000400&(data))>>10)
+#define SYS_PLL_DDR4_PLLDDR_WD_EN_shift                                              (9)
+#define SYS_PLL_DDR4_PLLDDR_WD_EN_mask                                               (0x00000200)
+#define SYS_PLL_DDR4_PLLDDR_WD_EN(data)                                              (0x00000200&((data)<<9))
+#define SYS_PLL_DDR4_PLLDDR_WD_EN_src(data)                                          ((0x00000200&(data))>>9)
+#define SYS_PLL_DDR4_get_PLLDDR_WD_EN(data)                                          ((0x00000200&(data))>>9)
+#define SYS_PLL_DDR4_PLLDDR_F390K_shift                                              (7)
+#define SYS_PLL_DDR4_PLLDDR_F390K_mask                                               (0x00000180)
+#define SYS_PLL_DDR4_PLLDDR_F390K(data)                                              (0x00000180&((data)<<7))
+#define SYS_PLL_DDR4_PLLDDR_F390K_src(data)                                          ((0x00000180&(data))>>7)
+#define SYS_PLL_DDR4_get_PLLDDR_F390K(data)                                          ((0x00000180&(data))>>7)
+#define SYS_PLL_DDR4_PLLDDR_TIME0_CK_shift                                           (4)
+#define SYS_PLL_DDR4_PLLDDR_TIME0_CK_mask                                            (0x00000070)
+#define SYS_PLL_DDR4_PLLDDR_TIME0_CK(data)                                           (0x00000070&((data)<<4))
+#define SYS_PLL_DDR4_PLLDDR_TIME0_CK_src(data)                                       ((0x00000070&(data))>>4)
+#define SYS_PLL_DDR4_get_PLLDDR_TIME0_CK(data)                                       ((0x00000070&(data))>>4)
+#define SYS_PLL_DDR4_PLLDDR_TIME_RDY_CKOUT_shift                                     (2)
+#define SYS_PLL_DDR4_PLLDDR_TIME_RDY_CKOUT_mask                                      (0x0000000C)
+#define SYS_PLL_DDR4_PLLDDR_TIME_RDY_CKOUT(data)                                     (0x0000000C&((data)<<2))
+#define SYS_PLL_DDR4_PLLDDR_TIME_RDY_CKOUT_src(data)                                 ((0x0000000C&(data))>>2)
+#define SYS_PLL_DDR4_get_PLLDDR_TIME_RDY_CKOUT(data)                                 ((0x0000000C&(data))>>2)
+#define SYS_PLL_DDR4_PLLDDR_TIME2_RST_WIDTH_shift                                    (0)
+#define SYS_PLL_DDR4_PLLDDR_TIME2_RST_WIDTH_mask                                     (0x00000003)
+#define SYS_PLL_DDR4_PLLDDR_TIME2_RST_WIDTH(data)                                    (0x00000003&((data)<<0))
+#define SYS_PLL_DDR4_PLLDDR_TIME2_RST_WIDTH_src(data)                                ((0x00000003&(data))>>0)
+#define SYS_PLL_DDR4_get_PLLDDR_TIME2_RST_WIDTH(data)                                ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_DDR_SSC1                                                             0x18000160
+#define SYS_PLL_DDR_SSC1_reg_addr                                                    "0xB8000160"
+#define SYS_PLL_DDR_SSC1_reg                                                         0xB8000160
+#define set_SYS_PLL_DDR_SSC1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDR_SSC1_reg)=data)
+#define get_SYS_PLL_DDR_SSC1_reg   (*((volatile unsigned int*) SYS_PLL_DDR_SSC1_reg))
+#define SYS_PLL_DDR_SSC1_inst_adr                                                    "0x0058"
+#define SYS_PLL_DDR_SSC1_inst                                                        0x0058
+#define SYS_PLL_DDR_SSC1_SSCDDR_N_CODE_shift                                         (21)
+#define SYS_PLL_DDR_SSC1_SSCDDR_N_CODE_mask                                          (0x1FE00000)
+#define SYS_PLL_DDR_SSC1_SSCDDR_N_CODE(data)                                         (0x1FE00000&((data)<<21))
+#define SYS_PLL_DDR_SSC1_SSCDDR_N_CODE_src(data)                                     ((0x1FE00000&(data))>>21)
+#define SYS_PLL_DDR_SSC1_get_SSCDDR_N_CODE(data)                                     ((0x1FE00000&(data))>>21)
+#define SYS_PLL_DDR_SSC1_SSCDDR_F_CODE_shift                                         (8)
+#define SYS_PLL_DDR_SSC1_SSCDDR_F_CODE_mask                                          (0x001FFF00)
+#define SYS_PLL_DDR_SSC1_SSCDDR_F_CODE(data)                                         (0x001FFF00&((data)<<8))
+#define SYS_PLL_DDR_SSC1_SSCDDR_F_CODE_src(data)                                     ((0x001FFF00&(data))>>8)
+#define SYS_PLL_DDR_SSC1_get_SSCDDR_F_CODE(data)                                     ((0x001FFF00&(data))>>8)
+#define SYS_PLL_DDR_SSC1_SSCDDR_BYPASS_PI_shift                                      (3)
+#define SYS_PLL_DDR_SSC1_SSCDDR_BYPASS_PI_mask                                       (0x00000008)
+#define SYS_PLL_DDR_SSC1_SSCDDR_BYPASS_PI(data)                                      (0x00000008&((data)<<3))
+#define SYS_PLL_DDR_SSC1_SSCDDR_BYPASS_PI_src(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_DDR_SSC1_get_SSCDDR_BYPASS_PI(data)                                  ((0x00000008&(data))>>3)
+#define SYS_PLL_DDR_SSC1_SSCDDR_SEL_MODE_shift                                       (2)
+#define SYS_PLL_DDR_SSC1_SSCDDR_SEL_MODE_mask                                        (0x00000004)
+#define SYS_PLL_DDR_SSC1_SSCDDR_SEL_MODE(data)                                       (0x00000004&((data)<<2))
+#define SYS_PLL_DDR_SSC1_SSCDDR_SEL_MODE_src(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_DDR_SSC1_get_SSCDDR_SEL_MODE(data)                                   ((0x00000004&(data))>>2)
+#define SYS_PLL_DDR_SSC1_SSCDDR_EN_CENTER_IN_shift                                   (1)
+#define SYS_PLL_DDR_SSC1_SSCDDR_EN_CENTER_IN_mask                                    (0x00000002)
+#define SYS_PLL_DDR_SSC1_SSCDDR_EN_CENTER_IN(data)                                   (0x00000002&((data)<<1))
+#define SYS_PLL_DDR_SSC1_SSCDDR_EN_CENTER_IN_src(data)                               ((0x00000002&(data))>>1)
+#define SYS_PLL_DDR_SSC1_get_SSCDDR_EN_CENTER_IN(data)                               ((0x00000002&(data))>>1)
+#define SYS_PLL_DDR_SSC1_SSCDDR_EN_SSC_shift                                         (0)
+#define SYS_PLL_DDR_SSC1_SSCDDR_EN_SSC_mask                                          (0x00000001)
+#define SYS_PLL_DDR_SSC1_SSCDDR_EN_SSC(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_DDR_SSC1_SSCDDR_EN_SSC_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_DDR_SSC1_get_SSCDDR_EN_SSC(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_BUS1                                                                 0x18000164
+#define SYS_PLL_BUS1_reg_addr                                                        "0xB8000164"
+#define SYS_PLL_BUS1_reg                                                             0xB8000164
+#define set_SYS_PLL_BUS1_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUS1_reg)=data)
+#define get_SYS_PLL_BUS1_reg   (*((volatile unsigned int*) SYS_PLL_BUS1_reg))
+#define SYS_PLL_BUS1_inst_adr                                                        "0x0059"
+#define SYS_PLL_BUS1_inst                                                            0x0059
+#define SYS_PLL_BUS1_PLLBUS_N_shift                                                  (25)
+#define SYS_PLL_BUS1_PLLBUS_N_mask                                                   (0x06000000)
+#define SYS_PLL_BUS1_PLLBUS_N(data)                                                  (0x06000000&((data)<<25))
+#define SYS_PLL_BUS1_PLLBUS_N_src(data)                                              ((0x06000000&(data))>>25)
+#define SYS_PLL_BUS1_get_PLLBUS_N(data)                                              ((0x06000000&(data))>>25)
+#define SYS_PLL_BUS1_PLLBUS_M_shift                                                  (18)
+#define SYS_PLL_BUS1_PLLBUS_M_mask                                                   (0x01FC0000)
+#define SYS_PLL_BUS1_PLLBUS_M(data)                                                  (0x01FC0000&((data)<<18))
+#define SYS_PLL_BUS1_PLLBUS_M_src(data)                                              ((0x01FC0000&(data))>>18)
+#define SYS_PLL_BUS1_get_PLLBUS_M(data)                                              ((0x01FC0000&(data))>>18)
+#define SYS_PLL_BUS1_PLLBUS_IP_shift                                                 (15)
+#define SYS_PLL_BUS1_PLLBUS_IP_mask                                                  (0x00038000)
+#define SYS_PLL_BUS1_PLLBUS_IP(data)                                                 (0x00038000&((data)<<15))
+#define SYS_PLL_BUS1_PLLBUS_IP_src(data)                                             ((0x00038000&(data))>>15)
+#define SYS_PLL_BUS1_get_PLLBUS_IP(data)                                             ((0x00038000&(data))>>15)
+#define SYS_PLL_BUS1_PLLBUS_RS_shift                                                 (11)
+#define SYS_PLL_BUS1_PLLBUS_RS_mask                                                  (0x00003800)
+#define SYS_PLL_BUS1_PLLBUS_RS(data)                                                 (0x00003800&((data)<<11))
+#define SYS_PLL_BUS1_PLLBUS_RS_src(data)                                             ((0x00003800&(data))>>11)
+#define SYS_PLL_BUS1_get_PLLBUS_RS(data)                                             ((0x00003800&(data))>>11)
+#define SYS_PLL_BUS1_PLLBUS_CS_shift                                                 (8)
+#define SYS_PLL_BUS1_PLLBUS_CS_mask                                                  (0x00000300)
+#define SYS_PLL_BUS1_PLLBUS_CS(data)                                                 (0x00000300&((data)<<8))
+#define SYS_PLL_BUS1_PLLBUS_CS_src(data)                                             ((0x00000300&(data))>>8)
+#define SYS_PLL_BUS1_get_PLLBUS_CS(data)                                             ((0x00000300&(data))>>8)
+#define SYS_PLL_BUS1_PLLBUS_CP_shift                                                 (5)
+#define SYS_PLL_BUS1_PLLBUS_CP_mask                                                  (0x00000060)
+#define SYS_PLL_BUS1_PLLBUS_CP(data)                                                 (0x00000060&((data)<<5))
+#define SYS_PLL_BUS1_PLLBUS_CP_src(data)                                             ((0x00000060&(data))>>5)
+#define SYS_PLL_BUS1_get_PLLBUS_CP(data)                                             ((0x00000060&(data))>>5)
+#define SYS_PLL_BUS1_PLLBUS_R3_shift                                                 (2)
+#define SYS_PLL_BUS1_PLLBUS_R3_mask                                                  (0x0000001C)
+#define SYS_PLL_BUS1_PLLBUS_R3(data)                                                 (0x0000001C&((data)<<2))
+#define SYS_PLL_BUS1_PLLBUS_R3_src(data)                                             ((0x0000001C&(data))>>2)
+#define SYS_PLL_BUS1_get_PLLBUS_R3(data)                                             ((0x0000001C&(data))>>2)
+#define SYS_PLL_BUS1_PLLBUS_C3_shift                                                 (0)
+#define SYS_PLL_BUS1_PLLBUS_C3_mask                                                  (0x00000003)
+#define SYS_PLL_BUS1_PLLBUS_C3(data)                                                 (0x00000003&((data)<<0))
+#define SYS_PLL_BUS1_PLLBUS_C3_src(data)                                             ((0x00000003&(data))>>0)
+#define SYS_PLL_BUS1_get_PLLBUS_C3(data)                                             ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_BUS2                                                                 0x18000168
+#define SYS_PLL_BUS2_reg_addr                                                        "0xB8000168"
+#define SYS_PLL_BUS2_reg                                                             0xB8000168
+#define set_SYS_PLL_BUS2_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUS2_reg)=data)
+#define get_SYS_PLL_BUS2_reg   (*((volatile unsigned int*) SYS_PLL_BUS2_reg))
+#define SYS_PLL_BUS2_inst_adr                                                        "0x005A"
+#define SYS_PLL_BUS2_inst                                                            0x005A
+#define SYS_PLL_BUS2_write_en5_shift                                                 (18)
+#define SYS_PLL_BUS2_write_en5_mask                                                  (0x00040000)
+#define SYS_PLL_BUS2_write_en5(data)                                                 (0x00040000&((data)<<18))
+#define SYS_PLL_BUS2_write_en5_src(data)                                             ((0x00040000&(data))>>18)
+#define SYS_PLL_BUS2_get_write_en5(data)                                             ((0x00040000&(data))>>18)
+#define SYS_PLL_BUS2_PLLBUS_PI_RL_shift                                              (16)
+#define SYS_PLL_BUS2_PLLBUS_PI_RL_mask                                               (0x00030000)
+#define SYS_PLL_BUS2_PLLBUS_PI_RL(data)                                              (0x00030000&((data)<<16))
+#define SYS_PLL_BUS2_PLLBUS_PI_RL_src(data)                                          ((0x00030000&(data))>>16)
+#define SYS_PLL_BUS2_get_PLLBUS_PI_RL(data)                                          ((0x00030000&(data))>>16)
+#define SYS_PLL_BUS2_PLLBUS_PI_RS_shift                                              (14)
+#define SYS_PLL_BUS2_PLLBUS_PI_RS_mask                                               (0x0000C000)
+#define SYS_PLL_BUS2_PLLBUS_PI_RS(data)                                              (0x0000C000&((data)<<14))
+#define SYS_PLL_BUS2_PLLBUS_PI_RS_src(data)                                          ((0x0000C000&(data))>>14)
+#define SYS_PLL_BUS2_get_PLLBUS_PI_RS(data)                                          ((0x0000C000&(data))>>14)
+#define SYS_PLL_BUS2_PLLBUS_PI_BIAS_shift                                            (12)
+#define SYS_PLL_BUS2_PLLBUS_PI_BIAS_mask                                             (0x00003000)
+#define SYS_PLL_BUS2_PLLBUS_PI_BIAS(data)                                            (0x00003000&((data)<<12))
+#define SYS_PLL_BUS2_PLLBUS_PI_BIAS_src(data)                                        ((0x00003000&(data))>>12)
+#define SYS_PLL_BUS2_get_PLLBUS_PI_BIAS(data)                                        ((0x00003000&(data))>>12)
+#define SYS_PLL_BUS2_write_en4_shift                                                 (11)
+#define SYS_PLL_BUS2_write_en4_mask                                                  (0x00000800)
+#define SYS_PLL_BUS2_write_en4(data)                                                 (0x00000800&((data)<<11))
+#define SYS_PLL_BUS2_write_en4_src(data)                                             ((0x00000800&(data))>>11)
+#define SYS_PLL_BUS2_get_write_en4(data)                                             ((0x00000800&(data))>>11)
+#define SYS_PLL_BUS2_PLLBUS_WDMODE_shift                                             (9)
+#define SYS_PLL_BUS2_PLLBUS_WDMODE_mask                                              (0x00000600)
+#define SYS_PLL_BUS2_PLLBUS_WDMODE(data)                                             (0x00000600&((data)<<9))
+#define SYS_PLL_BUS2_PLLBUS_WDMODE_src(data)                                         ((0x00000600&(data))>>9)
+#define SYS_PLL_BUS2_get_PLLBUS_WDMODE(data)                                         ((0x00000600&(data))>>9)
+#define SYS_PLL_BUS2_write_en3_shift                                                 (6)
+#define SYS_PLL_BUS2_write_en3_mask                                                  (0x00000040)
+#define SYS_PLL_BUS2_write_en3(data)                                                 (0x00000040&((data)<<6))
+#define SYS_PLL_BUS2_write_en3_src(data)                                             ((0x00000040&(data))>>6)
+#define SYS_PLL_BUS2_get_write_en3(data)                                             ((0x00000040&(data))>>6)
+#define SYS_PLL_BUS2_PLLBUS_FUPDN_shift                                              (5)
+#define SYS_PLL_BUS2_PLLBUS_FUPDN_mask                                               (0x00000020)
+#define SYS_PLL_BUS2_PLLBUS_FUPDN(data)                                              (0x00000020&((data)<<5))
+#define SYS_PLL_BUS2_PLLBUS_FUPDN_src(data)                                          ((0x00000020&(data))>>5)
+#define SYS_PLL_BUS2_get_PLLBUS_FUPDN(data)                                          ((0x00000020&(data))>>5)
+#define SYS_PLL_BUS2_PLLBUS_PSEN_shift                                               (4)
+#define SYS_PLL_BUS2_PLLBUS_PSEN_mask                                                (0x00000010)
+#define SYS_PLL_BUS2_PLLBUS_PSEN(data)                                               (0x00000010&((data)<<4))
+#define SYS_PLL_BUS2_PLLBUS_PSEN_src(data)                                           ((0x00000010&(data))>>4)
+#define SYS_PLL_BUS2_get_PLLBUS_PSEN(data)                                           ((0x00000010&(data))>>4)
+#define SYS_PLL_BUS2_PLLBUS_VCORB_shift                                              (3)
+#define SYS_PLL_BUS2_PLLBUS_VCORB_mask                                               (0x00000008)
+#define SYS_PLL_BUS2_PLLBUS_VCORB(data)                                              (0x00000008&((data)<<3))
+#define SYS_PLL_BUS2_PLLBUS_VCORB_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PLL_BUS2_get_PLLBUS_VCORB(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PLL_BUS2_write_en1_shift                                                 (2)
+#define SYS_PLL_BUS2_write_en1_mask                                                  (0x00000004)
+#define SYS_PLL_BUS2_write_en1(data)                                                 (0x00000004&((data)<<2))
+#define SYS_PLL_BUS2_write_en1_src(data)                                             ((0x00000004&(data))>>2)
+#define SYS_PLL_BUS2_get_write_en1(data)                                             ((0x00000004&(data))>>2)
+#define SYS_PLL_BUS2_PLLBUS_TST_shift                                                (1)
+#define SYS_PLL_BUS2_PLLBUS_TST_mask                                                 (0x00000002)
+#define SYS_PLL_BUS2_PLLBUS_TST(data)                                                (0x00000002&((data)<<1))
+#define SYS_PLL_BUS2_PLLBUS_TST_src(data)                                            ((0x00000002&(data))>>1)
+#define SYS_PLL_BUS2_get_PLLBUS_TST(data)                                            ((0x00000002&(data))>>1)
+#define SYS_PLL_BUS2_PLLBUS_PSTST_shift                                              (0)
+#define SYS_PLL_BUS2_PLLBUS_PSTST_mask                                               (0x00000001)
+#define SYS_PLL_BUS2_PLLBUS_PSTST(data)                                              (0x00000001&((data)<<0))
+#define SYS_PLL_BUS2_PLLBUS_PSTST_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_PLL_BUS2_get_PLLBUS_PSTST(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_BUS3                                                                 0x1800016C
+#define SYS_PLL_BUS3_reg_addr                                                        "0xB800016C"
+#define SYS_PLL_BUS3_reg                                                             0xB800016C
+#define set_SYS_PLL_BUS3_reg(data)   (*((volatile unsigned int*) SYS_PLL_BUS3_reg)=data)
+#define get_SYS_PLL_BUS3_reg   (*((volatile unsigned int*) SYS_PLL_BUS3_reg))
+#define SYS_PLL_BUS3_inst_adr                                                        "0x005B"
+#define SYS_PLL_BUS3_inst                                                            0x005B
+#define SYS_PLL_BUS3_PLLBUS_O_shift                                                  (3)
+#define SYS_PLL_BUS3_PLLBUS_O_mask                                                   (0x00000018)
+#define SYS_PLL_BUS3_PLLBUS_O(data)                                                  (0x00000018&((data)<<3))
+#define SYS_PLL_BUS3_PLLBUS_O_src(data)                                              ((0x00000018&(data))>>3)
+#define SYS_PLL_BUS3_get_PLLBUS_O(data)                                              ((0x00000018&(data))>>3)
+#define SYS_PLL_BUS3_PLLBUS_OEB_shift                                                (2)
+#define SYS_PLL_BUS3_PLLBUS_OEB_mask                                                 (0x00000004)
+#define SYS_PLL_BUS3_PLLBUS_OEB(data)                                                (0x00000004&((data)<<2))
+#define SYS_PLL_BUS3_PLLBUS_OEB_src(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_BUS3_get_PLLBUS_OEB(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_BUS3_PLLBUS_RSTB_shift                                               (1)
+#define SYS_PLL_BUS3_PLLBUS_RSTB_mask                                                (0x00000002)
+#define SYS_PLL_BUS3_PLLBUS_RSTB(data)                                               (0x00000002&((data)<<1))
+#define SYS_PLL_BUS3_PLLBUS_RSTB_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_BUS3_get_PLLBUS_RSTB(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_BUS3_PLLBUS_POW_shift                                                (0)
+#define SYS_PLL_BUS3_PLLBUS_POW_mask                                                 (0x00000001)
+#define SYS_PLL_BUS3_PLLBUS_POW(data)                                                (0x00000001&((data)<<0))
+#define SYS_PLL_BUS3_PLLBUS_POW_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_PLL_BUS3_get_PLLBUS_POW(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_WDOUT                                                                0x18000170
+#define SYS_PLL_WDOUT_reg_addr                                                       "0xB8000170"
+#define SYS_PLL_WDOUT_reg                                                            0xB8000170
+#define set_SYS_PLL_WDOUT_reg(data)   (*((volatile unsigned int*) SYS_PLL_WDOUT_reg)=data)
+#define get_SYS_PLL_WDOUT_reg   (*((volatile unsigned int*) SYS_PLL_WDOUT_reg))
+#define SYS_PLL_WDOUT_inst_adr                                                       "0x005C"
+#define SYS_PLL_WDOUT_inst                                                           0x005C
+#define SYS_PLL_WDOUT_PLLGPU_WDOUT_shift                                             (12)
+#define SYS_PLL_WDOUT_PLLGPU_WDOUT_mask                                              (0x00001000)
+#define SYS_PLL_WDOUT_PLLGPU_WDOUT(data)                                             (0x00001000&((data)<<12))
+#define SYS_PLL_WDOUT_PLLGPU_WDOUT_src(data)                                         ((0x00001000&(data))>>12)
+#define SYS_PLL_WDOUT_get_PLLGPU_WDOUT(data)                                         ((0x00001000&(data))>>12)
+#define SYS_PLL_WDOUT_PLLLVDS_WDOUT_shift                                            (11)
+#define SYS_PLL_WDOUT_PLLLVDS_WDOUT_mask                                             (0x00000800)
+#define SYS_PLL_WDOUT_PLLLVDS_WDOUT(data)                                            (0x00000800&((data)<<11))
+#define SYS_PLL_WDOUT_PLLLVDS_WDOUT_src(data)                                        ((0x00000800&(data))>>11)
+#define SYS_PLL_WDOUT_get_PLLLVDS_WDOUT(data)                                        ((0x00000800&(data))>>11)
+#define SYS_PLL_WDOUT_PLLDCSB_WDOUT_shift                                            (10)
+#define SYS_PLL_WDOUT_PLLDCSB_WDOUT_mask                                             (0x00000400)
+#define SYS_PLL_WDOUT_PLLDCSB_WDOUT(data)                                            (0x00000400&((data)<<10))
+#define SYS_PLL_WDOUT_PLLDCSB_WDOUT_src(data)                                        ((0x00000400&(data))>>10)
+#define SYS_PLL_WDOUT_get_PLLDCSB_WDOUT(data)                                        ((0x00000400&(data))>>10)
+#define SYS_PLL_WDOUT_PLLHDMI_WDOUT_shift                                            (9)
+#define SYS_PLL_WDOUT_PLLHDMI_WDOUT_mask                                             (0x00000200)
+#define SYS_PLL_WDOUT_PLLHDMI_WDOUT(data)                                            (0x00000200&((data)<<9))
+#define SYS_PLL_WDOUT_PLLHDMI_WDOUT_src(data)                                        ((0x00000200&(data))>>9)
+#define SYS_PLL_WDOUT_get_PLLHDMI_WDOUT(data)                                        ((0x00000200&(data))>>9)
+#define SYS_PLL_WDOUT_PLLDDR_WDOUT_shift                                             (7)
+#define SYS_PLL_WDOUT_PLLDDR_WDOUT_mask                                              (0x00000080)
+#define SYS_PLL_WDOUT_PLLDDR_WDOUT(data)                                             (0x00000080&((data)<<7))
+#define SYS_PLL_WDOUT_PLLDDR_WDOUT_src(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PLL_WDOUT_get_PLLDDR_WDOUT(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PLL_WDOUT_PLLBUS_WDOUT_shift                                             (6)
+#define SYS_PLL_WDOUT_PLLBUS_WDOUT_mask                                              (0x00000040)
+#define SYS_PLL_WDOUT_PLLBUS_WDOUT(data)                                             (0x00000040&((data)<<6))
+#define SYS_PLL_WDOUT_PLLBUS_WDOUT_src(data)                                         ((0x00000040&(data))>>6)
+#define SYS_PLL_WDOUT_get_PLLBUS_WDOUT(data)                                         ((0x00000040&(data))>>6)
+#define SYS_PLL_WDOUT_PLLDISP_WDOUT_shift                                            (5)
+#define SYS_PLL_WDOUT_PLLDISP_WDOUT_mask                                             (0x00000020)
+#define SYS_PLL_WDOUT_PLLDISP_WDOUT(data)                                            (0x00000020&((data)<<5))
+#define SYS_PLL_WDOUT_PLLDISP_WDOUT_src(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PLL_WDOUT_get_PLLDISP_WDOUT(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PLL_WDOUT_PLLDDSB_WDOUT_shift                                            (4)
+#define SYS_PLL_WDOUT_PLLDDSB_WDOUT_mask                                             (0x00000010)
+#define SYS_PLL_WDOUT_PLLDDSB_WDOUT(data)                                            (0x00000010&((data)<<4))
+#define SYS_PLL_WDOUT_PLLDDSB_WDOUT_src(data)                                        ((0x00000010&(data))>>4)
+#define SYS_PLL_WDOUT_get_PLLDDSB_WDOUT(data)                                        ((0x00000010&(data))>>4)
+#define SYS_PLL_WDOUT_PLLDDSA_WDOUT_shift                                            (3)
+#define SYS_PLL_WDOUT_PLLDDSA_WDOUT_mask                                             (0x00000008)
+#define SYS_PLL_WDOUT_PLLDDSA_WDOUT(data)                                            (0x00000008&((data)<<3))
+#define SYS_PLL_WDOUT_PLLDDSA_WDOUT_src(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PLL_WDOUT_get_PLLDDSA_WDOUT(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PLL_WDOUT_PLLVCPU_WDOUT_shift                                            (2)
+#define SYS_PLL_WDOUT_PLLVCPU_WDOUT_mask                                             (0x00000004)
+#define SYS_PLL_WDOUT_PLLVCPU_WDOUT(data)                                            (0x00000004&((data)<<2))
+#define SYS_PLL_WDOUT_PLLVCPU_WDOUT_src(data)                                        ((0x00000004&(data))>>2)
+#define SYS_PLL_WDOUT_get_PLLVCPU_WDOUT(data)                                        ((0x00000004&(data))>>2)
+#define SYS_PLL_WDOUT_PLLACPU_WDOUT_shift                                            (1)
+#define SYS_PLL_WDOUT_PLLACPU_WDOUT_mask                                             (0x00000002)
+#define SYS_PLL_WDOUT_PLLACPU_WDOUT(data)                                            (0x00000002&((data)<<1))
+#define SYS_PLL_WDOUT_PLLACPU_WDOUT_src(data)                                        ((0x00000002&(data))>>1)
+#define SYS_PLL_WDOUT_get_PLLACPU_WDOUT(data)                                        ((0x00000002&(data))>>1)
+#define SYS_PLL_WDOUT_PLLSCPU_WDOUT_shift                                            (0)
+#define SYS_PLL_WDOUT_PLLSCPU_WDOUT_mask                                             (0x00000001)
+#define SYS_PLL_WDOUT_PLLSCPU_WDOUT(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_WDOUT_PLLSCPU_WDOUT_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_WDOUT_get_PLLSCPU_WDOUT(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_2_SD1                                                           0x18000174
+#define SYS_PLL_DISP_2_SD1_reg_addr                                                  "0xB8000174"
+#define SYS_PLL_DISP_2_SD1_reg                                                       0xB8000174
+#define set_SYS_PLL_DISP_2_SD1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD1_reg)=data)
+#define get_SYS_PLL_DISP_2_SD1_reg   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD1_reg))
+#define SYS_PLL_DISP_2_SD1_inst_adr                                                  "0x005D"
+#define SYS_PLL_DISP_2_SD1_inst                                                      0x005D
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_N_shift                                           (30)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_N_mask                                            (0xC0000000)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_N(data)                                           (0xC0000000&((data)<<30))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_N_src(data)                                       ((0xC0000000&(data))>>30)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_N(data)                                       ((0xC0000000&(data))>>30)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_M_shift                                           (23)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_M_mask                                            (0x3F800000)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_M(data)                                           (0x3F800000&((data)<<23))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_M_src(data)                                       ((0x3F800000&(data))>>23)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_M(data)                                       ((0x3F800000&(data))>>23)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_IP_shift                                          (20)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_IP_mask                                           (0x00700000)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_IP(data)                                          (0x00700000&((data)<<20))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_IP_src(data)                                      ((0x00700000&(data))>>20)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_IP(data)                                      ((0x00700000&(data))>>20)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_RS_shift                                          (17)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_RS_mask                                           (0x000E0000)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_RS(data)                                          (0x000E0000&((data)<<17))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_RS_src(data)                                      ((0x000E0000&(data))>>17)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_RS(data)                                      ((0x000E0000&(data))>>17)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_CS_shift                                          (15)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_CS_mask                                           (0x00018000)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_CS(data)                                          (0x00018000&((data)<<15))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_CS_src(data)                                      ((0x00018000&(data))>>15)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_CS(data)                                      ((0x00018000&(data))>>15)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_CP_shift                                          (13)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_CP_mask                                           (0x00006000)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_CP(data)                                          (0x00006000&((data)<<13))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_CP_src(data)                                      ((0x00006000&(data))>>13)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_CP(data)                                      ((0x00006000&(data))>>13)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_R3_shift                                          (10)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_R3_mask                                           (0x00001C00)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_R3(data)                                          (0x00001C00&((data)<<10))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_R3_src(data)                                      ((0x00001C00&(data))>>10)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_R3(data)                                      ((0x00001C00&(data))>>10)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_C3_shift                                          (8)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_C3_mask                                           (0x00000300)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_C3(data)                                          (0x00000300&((data)<<8))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_C3_src(data)                                      ((0x00000300&(data))>>8)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_C3(data)                                      ((0x00000300&(data))>>8)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_RL_shift                                       (6)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_RL_mask                                        (0x000000C0)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_RL(data)                                       (0x000000C0&((data)<<6))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_RL_src(data)                                   ((0x000000C0&(data))>>6)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_PI_RL(data)                                   ((0x000000C0&(data))>>6)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_RS_shift                                       (4)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_RS_mask                                        (0x00000030)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_RS(data)                                       (0x00000030&((data)<<4))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_RS_src(data)                                   ((0x00000030&(data))>>4)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_PI_RS(data)                                   ((0x00000030&(data))>>4)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_BIAS_shift                                     (2)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_BIAS_mask                                      (0x0000000C)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_BIAS(data)                                     (0x0000000C&((data)<<2))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_PI_BIAS_src(data)                                 ((0x0000000C&(data))>>2)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_PI_BIAS(data)                                 ((0x0000000C&(data))>>2)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_WDMODE_shift                                      (0)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_WDMODE_mask                                       (0x00000003)
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_WDMODE(data)                                      (0x00000003&((data)<<0))
+#define SYS_PLL_DISP_2_SD1_PLLDDSB_WDMODE_src(data)                                  ((0x00000003&(data))>>0)
+#define SYS_PLL_DISP_2_SD1_get_PLLDDSB_WDMODE(data)                                  ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_DISP_2_SD2                                                           0x18000178
+#define SYS_PLL_DISP_2_SD2_reg_addr                                                  "0xB8000178"
+#define SYS_PLL_DISP_2_SD2_reg                                                       0xB8000178
+#define set_SYS_PLL_DISP_2_SD2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD2_reg)=data)
+#define get_SYS_PLL_DISP_2_SD2_reg   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD2_reg))
+#define SYS_PLL_DISP_2_SD2_inst_adr                                                  "0x005E"
+#define SYS_PLL_DISP_2_SD2_inst                                                      0x005E
+#define SYS_PLL_DISP_2_SD2_write_en10_shift                                          (25)
+#define SYS_PLL_DISP_2_SD2_write_en10_mask                                           (0x02000000)
+#define SYS_PLL_DISP_2_SD2_write_en10(data)                                          (0x02000000&((data)<<25))
+#define SYS_PLL_DISP_2_SD2_write_en10_src(data)                                      ((0x02000000&(data))>>25)
+#define SYS_PLL_DISP_2_SD2_get_write_en10(data)                                      ((0x02000000&(data))>>25)
+#define SYS_PLL_DISP_2_SD2_pcr_b_smooth_en_shift                                     (24)
+#define SYS_PLL_DISP_2_SD2_pcr_b_smooth_en_mask                                      (0x01000000)
+#define SYS_PLL_DISP_2_SD2_pcr_b_smooth_en(data)                                     (0x01000000&((data)<<24))
+#define SYS_PLL_DISP_2_SD2_pcr_b_smooth_en_src(data)                                 ((0x01000000&(data))>>24)
+#define SYS_PLL_DISP_2_SD2_get_pcr_b_smooth_en(data)                                 ((0x01000000&(data))>>24)
+#define SYS_PLL_DISP_2_SD2_write_en9_shift                                           (23)
+#define SYS_PLL_DISP_2_SD2_write_en9_mask                                            (0x00800000)
+#define SYS_PLL_DISP_2_SD2_write_en9(data)                                           (0x00800000&((data)<<23))
+#define SYS_PLL_DISP_2_SD2_write_en9_src(data)                                       ((0x00800000&(data))>>23)
+#define SYS_PLL_DISP_2_SD2_get_write_en9(data)                                       ((0x00800000&(data))>>23)
+#define SYS_PLL_DISP_2_SD2_pcr_b_phase_sel_shift                                     (22)
+#define SYS_PLL_DISP_2_SD2_pcr_b_phase_sel_mask                                      (0x00400000)
+#define SYS_PLL_DISP_2_SD2_pcr_b_phase_sel(data)                                     (0x00400000&((data)<<22))
+#define SYS_PLL_DISP_2_SD2_pcr_b_phase_sel_src(data)                                 ((0x00400000&(data))>>22)
+#define SYS_PLL_DISP_2_SD2_get_pcr_b_phase_sel(data)                                 ((0x00400000&(data))>>22)
+#define SYS_PLL_DISP_2_SD2_write_en8_shift                                           (21)
+#define SYS_PLL_DISP_2_SD2_write_en8_mask                                            (0x00200000)
+#define SYS_PLL_DISP_2_SD2_write_en8(data)                                           (0x00200000&((data)<<21))
+#define SYS_PLL_DISP_2_SD2_write_en8_src(data)                                       ((0x00200000&(data))>>21)
+#define SYS_PLL_DISP_2_SD2_get_write_en8(data)                                       ((0x00200000&(data))>>21)
+#define SYS_PLL_DISP_2_SD2_pcr_b_ctl_en_shift                                        (20)
+#define SYS_PLL_DISP_2_SD2_pcr_b_ctl_en_mask                                         (0x00100000)
+#define SYS_PLL_DISP_2_SD2_pcr_b_ctl_en(data)                                        (0x00100000&((data)<<20))
+#define SYS_PLL_DISP_2_SD2_pcr_b_ctl_en_src(data)                                    ((0x00100000&(data))>>20)
+#define SYS_PLL_DISP_2_SD2_get_pcr_b_ctl_en(data)                                    ((0x00100000&(data))>>20)
+#define SYS_PLL_DISP_2_SD2_write_en7_shift                                           (19)
+#define SYS_PLL_DISP_2_SD2_write_en7_mask                                            (0x00080000)
+#define SYS_PLL_DISP_2_SD2_write_en7(data)                                           (0x00080000&((data)<<19))
+#define SYS_PLL_DISP_2_SD2_write_en7_src(data)                                       ((0x00080000&(data))>>19)
+#define SYS_PLL_DISP_2_SD2_get_write_en7(data)                                       ((0x00080000&(data))>>19)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_FUPDN_shift                                       (18)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_FUPDN_mask                                        (0x00040000)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_FUPDN(data)                                       (0x00040000&((data)<<18))
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_FUPDN_src(data)                                   ((0x00040000&(data))>>18)
+#define SYS_PLL_DISP_2_SD2_get_PLLDDSB_FUPDN(data)                                   ((0x00040000&(data))>>18)
+#define SYS_PLL_DISP_2_SD2_write_en6_shift                                           (17)
+#define SYS_PLL_DISP_2_SD2_write_en6_mask                                            (0x00020000)
+#define SYS_PLL_DISP_2_SD2_write_en6(data)                                           (0x00020000&((data)<<17))
+#define SYS_PLL_DISP_2_SD2_write_en6_src(data)                                       ((0x00020000&(data))>>17)
+#define SYS_PLL_DISP_2_SD2_get_write_en6(data)                                       ((0x00020000&(data))>>17)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_DDSEN_shift                                       (16)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_DDSEN_mask                                        (0x00010000)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_DDSEN(data)                                       (0x00010000&((data)<<16))
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_DDSEN_src(data)                                   ((0x00010000&(data))>>16)
+#define SYS_PLL_DISP_2_SD2_get_PLLDDSB_DDSEN(data)                                   ((0x00010000&(data))>>16)
+#define SYS_PLL_DISP_2_SD2_write_en5_shift                                           (15)
+#define SYS_PLL_DISP_2_SD2_write_en5_mask                                            (0x00008000)
+#define SYS_PLL_DISP_2_SD2_write_en5(data)                                           (0x00008000&((data)<<15))
+#define SYS_PLL_DISP_2_SD2_write_en5_src(data)                                       ((0x00008000&(data))>>15)
+#define SYS_PLL_DISP_2_SD2_get_write_en5(data)                                       ((0x00008000&(data))>>15)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_VCORB_shift                                       (14)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_VCORB_mask                                        (0x00004000)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_VCORB(data)                                       (0x00004000&((data)<<14))
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_VCORB_src(data)                                   ((0x00004000&(data))>>14)
+#define SYS_PLL_DISP_2_SD2_get_PLLDDSB_VCORB(data)                                   ((0x00004000&(data))>>14)
+#define SYS_PLL_DISP_2_SD2_write_en4_shift                                           (13)
+#define SYS_PLL_DISP_2_SD2_write_en4_mask                                            (0x00002000)
+#define SYS_PLL_DISP_2_SD2_write_en4(data)                                           (0x00002000&((data)<<13))
+#define SYS_PLL_DISP_2_SD2_write_en4_src(data)                                       ((0x00002000&(data))>>13)
+#define SYS_PLL_DISP_2_SD2_get_write_en4(data)                                       ((0x00002000&(data))>>13)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_TST_shift                                         (12)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_TST_mask                                          (0x00001000)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_TST(data)                                         (0x00001000&((data)<<12))
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_TST_src(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PLL_DISP_2_SD2_get_PLLDDSB_TST(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_PSTST_shift                                       (11)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_PSTST_mask                                        (0x00000800)
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_PSTST(data)                                       (0x00000800&((data)<<11))
+#define SYS_PLL_DISP_2_SD2_PLLDDSB_PSTST_src(data)                                   ((0x00000800&(data))>>11)
+#define SYS_PLL_DISP_2_SD2_get_PLLDDSB_PSTST(data)                                   ((0x00000800&(data))>>11)
+#define SYS_PLL_DISP_2_SD2_write_en3_shift                                           (10)
+#define SYS_PLL_DISP_2_SD2_write_en3_mask                                            (0x00000400)
+#define SYS_PLL_DISP_2_SD2_write_en3(data)                                           (0x00000400&((data)<<10))
+#define SYS_PLL_DISP_2_SD2_write_en3_src(data)                                       ((0x00000400&(data))>>10)
+#define SYS_PLL_DISP_2_SD2_get_write_en3(data)                                       ((0x00000400&(data))>>10)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_FUPDN_shift                                       (9)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_FUPDN_mask                                        (0x00000200)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_FUPDN(data)                                       (0x00000200&((data)<<9))
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_FUPDN_src(data)                                   ((0x00000200&(data))>>9)
+#define SYS_PLL_DISP_2_SD2_get_PSAUD1B_FUPDN(data)                                   ((0x00000200&(data))>>9)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_DIV_shift                                         (8)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_DIV_mask                                          (0x00000100)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_DIV(data)                                         (0x00000100&((data)<<8))
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_DIV_src(data)                                     ((0x00000100&(data))>>8)
+#define SYS_PLL_DISP_2_SD2_get_PSAUD1B_DIV(data)                                     ((0x00000100&(data))>>8)
+#define SYS_PLL_DISP_2_SD2_write_en2_shift                                           (7)
+#define SYS_PLL_DISP_2_SD2_write_en2_mask                                            (0x00000080)
+#define SYS_PLL_DISP_2_SD2_write_en2(data)                                           (0x00000080&((data)<<7))
+#define SYS_PLL_DISP_2_SD2_write_en2_src(data)                                       ((0x00000080&(data))>>7)
+#define SYS_PLL_DISP_2_SD2_get_write_en2(data)                                       ((0x00000080&(data))>>7)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_TST_shift                                         (6)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_TST_mask                                          (0x00000040)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_TST(data)                                         (0x00000040&((data)<<6))
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_TST_src(data)                                     ((0x00000040&(data))>>6)
+#define SYS_PLL_DISP_2_SD2_get_PSAUD1B_TST(data)                                     ((0x00000040&(data))>>6)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_PSEN_shift                                        (5)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_PSEN_mask                                         (0x00000020)
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_PSEN(data)                                        (0x00000020&((data)<<5))
+#define SYS_PLL_DISP_2_SD2_PSAUD1B_PSEN_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_DISP_2_SD2_get_PSAUD1B_PSEN(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PLL_DISP_2_SD2_write_en1_shift                                           (4)
+#define SYS_PLL_DISP_2_SD2_write_en1_mask                                            (0x00000010)
+#define SYS_PLL_DISP_2_SD2_write_en1(data)                                           (0x00000010&((data)<<4))
+#define SYS_PLL_DISP_2_SD2_write_en1_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PLL_DISP_2_SD2_get_write_en1(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_FUPDN_shift                                       (3)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_FUPDN_mask                                        (0x00000008)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_FUPDN(data)                                       (0x00000008&((data)<<3))
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_FUPDN_src(data)                                   ((0x00000008&(data))>>3)
+#define SYS_PLL_DISP_2_SD2_get_PSAUD2B_FUPDN(data)                                   ((0x00000008&(data))>>3)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_DIV_shift                                         (2)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_DIV_mask                                          (0x00000004)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_DIV(data)                                         (0x00000004&((data)<<2))
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_DIV_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_2_SD2_get_PSAUD2B_DIV(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_TST_shift                                         (1)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_TST_mask                                          (0x00000002)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_TST(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_TST_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_2_SD2_get_PSAUD2B_TST(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_PSEN_shift                                        (0)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_PSEN_mask                                         (0x00000001)
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_PSEN(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_2_SD2_PSAUD2B_PSEN_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_2_SD2_get_PSAUD2B_PSEN(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_2_SD3                                                           0x1800017C
+#define SYS_PLL_DISP_2_SD3_reg_addr                                                  "0xB800017C"
+#define SYS_PLL_DISP_2_SD3_reg                                                       0xB800017C
+#define set_SYS_PLL_DISP_2_SD3_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD3_reg)=data)
+#define get_SYS_PLL_DISP_2_SD3_reg   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD3_reg))
+#define SYS_PLL_DISP_2_SD3_inst_adr                                                  "0x005F"
+#define SYS_PLL_DISP_2_SD3_inst                                                      0x005F
+#define SYS_PLL_DISP_2_SD3_PSAUD1B_OEB_shift                                         (3)
+#define SYS_PLL_DISP_2_SD3_PSAUD1B_OEB_mask                                          (0x00000008)
+#define SYS_PLL_DISP_2_SD3_PSAUD1B_OEB(data)                                         (0x00000008&((data)<<3))
+#define SYS_PLL_DISP_2_SD3_PSAUD1B_OEB_src(data)                                     ((0x00000008&(data))>>3)
+#define SYS_PLL_DISP_2_SD3_get_PSAUD1B_OEB(data)                                     ((0x00000008&(data))>>3)
+#define SYS_PLL_DISP_2_SD3_PSAUD1B_RSTB_shift                                        (2)
+#define SYS_PLL_DISP_2_SD3_PSAUD1B_RSTB_mask                                         (0x00000004)
+#define SYS_PLL_DISP_2_SD3_PSAUD1B_RSTB(data)                                        (0x00000004&((data)<<2))
+#define SYS_PLL_DISP_2_SD3_PSAUD1B_RSTB_src(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_2_SD3_get_PSAUD1B_RSTB(data)                                    ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_2_SD3_PSAUD2B_OEB_shift                                         (1)
+#define SYS_PLL_DISP_2_SD3_PSAUD2B_OEB_mask                                          (0x00000002)
+#define SYS_PLL_DISP_2_SD3_PSAUD2B_OEB(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_DISP_2_SD3_PSAUD2B_OEB_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_2_SD3_get_PSAUD2B_OEB(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_2_SD3_PSAUD2B_RSTB_shift                                        (0)
+#define SYS_PLL_DISP_2_SD3_PSAUD2B_RSTB_mask                                         (0x00000001)
+#define SYS_PLL_DISP_2_SD3_PSAUD2B_RSTB(data)                                        (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_2_SD3_PSAUD2B_RSTB_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_2_SD3_get_PSAUD2B_RSTB(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_2_SD4                                                           0x18000180
+#define SYS_PLL_DISP_2_SD4_reg_addr                                                  "0xB8000180"
+#define SYS_PLL_DISP_2_SD4_reg                                                       0xB8000180
+#define set_SYS_PLL_DISP_2_SD4_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD4_reg)=data)
+#define get_SYS_PLL_DISP_2_SD4_reg   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD4_reg))
+#define SYS_PLL_DISP_2_SD4_inst_adr                                                  "0x0060"
+#define SYS_PLL_DISP_2_SD4_inst                                                      0x0060
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_K_shift                                           (4)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_K_mask                                            (0x00000030)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_K(data)                                           (0x00000030&((data)<<4))
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_K_src(data)                                       ((0x00000030&(data))>>4)
+#define SYS_PLL_DISP_2_SD4_get_PLLDDSB_K(data)                                       ((0x00000030&(data))>>4)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_OEB_shift                                         (2)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_OEB_mask                                          (0x00000004)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_OEB(data)                                         (0x00000004&((data)<<2))
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_OEB_src(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_2_SD4_get_PLLDDSB_OEB(data)                                     ((0x00000004&(data))>>2)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_RSTB_shift                                        (1)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_RSTB_mask                                         (0x00000002)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_RSTB(data)                                        (0x00000002&((data)<<1))
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_RSTB_src(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_2_SD4_get_PLLDDSB_RSTB(data)                                    ((0x00000002&(data))>>1)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_POW_shift                                         (0)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_POW_mask                                          (0x00000001)
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_POW(data)                                         (0x00000001&((data)<<0))
+#define SYS_PLL_DISP_2_SD4_PLLDDSB_POW_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PLL_DISP_2_SD4_get_PLLDDSB_POW(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DISP_2_SD5                                                           0x18000184
+#define SYS_PLL_DISP_2_SD5_reg_addr                                                  "0xB8000184"
+#define SYS_PLL_DISP_2_SD5_reg                                                       0xB8000184
+#define set_SYS_PLL_DISP_2_SD5_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD5_reg)=data)
+#define get_SYS_PLL_DISP_2_SD5_reg   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD5_reg))
+#define SYS_PLL_DISP_2_SD5_inst_adr                                                  "0x0061"
+#define SYS_PLL_DISP_2_SD5_inst                                                      0x0061
+#define SYS_PLL_DISP_2_SD5_N_shift                                                   (16)
+#define SYS_PLL_DISP_2_SD5_N_mask                                                    (0xFFFF0000)
+#define SYS_PLL_DISP_2_SD5_N(data)                                                   (0xFFFF0000&((data)<<16))
+#define SYS_PLL_DISP_2_SD5_N_src(data)                                               ((0xFFFF0000&(data))>>16)
+#define SYS_PLL_DISP_2_SD5_get_N(data)                                               ((0xFFFF0000&(data))>>16)
+#define SYS_PLL_DISP_2_SD5_M_shift                                                   (0)
+#define SYS_PLL_DISP_2_SD5_M_mask                                                    (0x0000FFFF)
+#define SYS_PLL_DISP_2_SD5_M(data)                                                   (0x0000FFFF&((data)<<0))
+#define SYS_PLL_DISP_2_SD5_M_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define SYS_PLL_DISP_2_SD5_get_M(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define SYS_PLL_DISP_2_SD6                                                           0x18000188
+#define SYS_PLL_DISP_2_SD6_reg_addr                                                  "0xB8000188"
+#define SYS_PLL_DISP_2_SD6_reg                                                       0xB8000188
+#define set_SYS_PLL_DISP_2_SD6_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD6_reg)=data)
+#define get_SYS_PLL_DISP_2_SD6_reg   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD6_reg))
+#define SYS_PLL_DISP_2_SD6_inst_adr                                                  "0x0062"
+#define SYS_PLL_DISP_2_SD6_inst                                                      0x0062
+#define SYS_PLL_DISP_2_SD6_N_nxt_shift                                               (0)
+#define SYS_PLL_DISP_2_SD6_N_nxt_mask                                                (0x0000FFFF)
+#define SYS_PLL_DISP_2_SD6_N_nxt(data)                                               (0x0000FFFF&((data)<<0))
+#define SYS_PLL_DISP_2_SD6_N_nxt_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define SYS_PLL_DISP_2_SD6_get_N_nxt(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define SYS_PLL_DISP_2_SD7                                                           0x1800018C
+#define SYS_PLL_DISP_2_SD7_reg_addr                                                  "0xB800018C"
+#define SYS_PLL_DISP_2_SD7_reg                                                       0xB800018C
+#define set_SYS_PLL_DISP_2_SD7_reg(data)   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD7_reg)=data)
+#define get_SYS_PLL_DISP_2_SD7_reg   (*((volatile unsigned int*) SYS_PLL_DISP_2_SD7_reg))
+#define SYS_PLL_DISP_2_SD7_inst_adr                                                  "0x0063"
+#define SYS_PLL_DISP_2_SD7_inst                                                      0x0063
+#define SYS_PLL_DISP_2_SD7_N_nxt_add_shift                                           (16)
+#define SYS_PLL_DISP_2_SD7_N_nxt_add_mask                                            (0x00FF0000)
+#define SYS_PLL_DISP_2_SD7_N_nxt_add(data)                                           (0x00FF0000&((data)<<16))
+#define SYS_PLL_DISP_2_SD7_N_nxt_add_src(data)                                       ((0x00FF0000&(data))>>16)
+#define SYS_PLL_DISP_2_SD7_get_N_nxt_add(data)                                       ((0x00FF0000&(data))>>16)
+#define SYS_PLL_DISP_2_SD7_N_nxt_add_period_shift                                    (0)
+#define SYS_PLL_DISP_2_SD7_N_nxt_add_period_mask                                     (0x0000FFFF)
+#define SYS_PLL_DISP_2_SD7_N_nxt_add_period(data)                                    (0x0000FFFF&((data)<<0))
+#define SYS_PLL_DISP_2_SD7_N_nxt_add_period_src(data)                                ((0x0000FFFF&(data))>>0)
+#define SYS_PLL_DISP_2_SD7_get_N_nxt_add_period(data)                                ((0x0000FFFF&(data))>>0)
+
+
+#define SYS_PLL_HDMI                                                                 0x18000190
+#define SYS_PLL_HDMI_reg_addr                                                        "0xB8000190"
+#define SYS_PLL_HDMI_reg                                                             0xB8000190
+#define set_SYS_PLL_HDMI_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI_reg)=data)
+#define get_SYS_PLL_HDMI_reg   (*((volatile unsigned int*) SYS_PLL_HDMI_reg))
+#define SYS_PLL_HDMI_inst_adr                                                        "0x0064"
+#define SYS_PLL_HDMI_inst                                                            0x0064
+#define SYS_PLL_HDMI_REG_LDO_PLL_PU_shift                                            (4)
+#define SYS_PLL_HDMI_REG_LDO_PLL_PU_mask                                             (0x00000010)
+#define SYS_PLL_HDMI_REG_LDO_PLL_PU(data)                                            (0x00000010&((data)<<4))
+#define SYS_PLL_HDMI_REG_LDO_PLL_PU_src(data)                                        ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_get_REG_LDO_PLL_PU(data)                                        ((0x00000010&(data))>>4)
+#define SYS_PLL_HDMI_REG_LDO_CCO_PU_shift                                            (3)
+#define SYS_PLL_HDMI_REG_LDO_CCO_PU_mask                                             (0x00000008)
+#define SYS_PLL_HDMI_REG_LDO_CCO_PU(data)                                            (0x00000008&((data)<<3))
+#define SYS_PLL_HDMI_REG_LDO_CCO_PU_src(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI_get_REG_LDO_CCO_PU(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI_REG_LDO_TMDS_PU_shift                                           (2)
+#define SYS_PLL_HDMI_REG_LDO_TMDS_PU_mask                                            (0x00000004)
+#define SYS_PLL_HDMI_REG_LDO_TMDS_PU(data)                                           (0x00000004&((data)<<2))
+#define SYS_PLL_HDMI_REG_LDO_TMDS_PU_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_HDMI_get_REG_LDO_TMDS_PU(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_HDMI_REG_TV_PLL_PU_shift                                             (1)
+#define SYS_PLL_HDMI_REG_TV_PLL_PU_mask                                              (0x00000002)
+#define SYS_PLL_HDMI_REG_TV_PLL_PU(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_HDMI_REG_TV_PLL_PU_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_get_REG_TV_PLL_PU(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN_shift                                            (0)
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN_mask                                             (0x00000001)
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_HDMI_REG_HDMI_CK_EN_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_HDMI_get_REG_HDMI_CK_EN(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_HDMI2                                                                0x18000194
+#define SYS_PLL_HDMI2_reg_addr                                                       "0xB8000194"
+#define SYS_PLL_HDMI2_reg                                                            0xB8000194
+#define set_SYS_PLL_HDMI2_reg(data)   (*((volatile unsigned int*) SYS_PLL_HDMI2_reg)=data)
+#define get_SYS_PLL_HDMI2_reg   (*((volatile unsigned int*) SYS_PLL_HDMI2_reg))
+#define SYS_PLL_HDMI2_inst_adr                                                       "0x0065"
+#define SYS_PLL_HDMI2_inst                                                           0x0065
+#define SYS_PLL_HDMI2_REG_TV_PRE_DIV_shift                                           (19)
+#define SYS_PLL_HDMI2_REG_TV_PRE_DIV_mask                                            (0x00080000)
+#define SYS_PLL_HDMI2_REG_TV_PRE_DIV(data)                                           (0x00080000&((data)<<19))
+#define SYS_PLL_HDMI2_REG_TV_PRE_DIV_src(data)                                       ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI2_get_REG_TV_PRE_DIV(data)                                       ((0x00080000&(data))>>19)
+#define SYS_PLL_HDMI2_REG_TV_LDIV_shift                                              (13)
+#define SYS_PLL_HDMI2_REG_TV_LDIV_mask                                               (0x0007E000)
+#define SYS_PLL_HDMI2_REG_TV_LDIV(data)                                              (0x0007E000&((data)<<13))
+#define SYS_PLL_HDMI2_REG_TV_LDIV_src(data)                                          ((0x0007E000&(data))>>13)
+#define SYS_PLL_HDMI2_get_REG_TV_LDIV(data)                                          ((0x0007E000&(data))>>13)
+#define SYS_PLL_HDMI2_REG_TV_PSTEP_EN_shift                                          (12)
+#define SYS_PLL_HDMI2_REG_TV_PSTEP_EN_mask                                           (0x00001000)
+#define SYS_PLL_HDMI2_REG_TV_PSTEP_EN(data)                                          (0x00001000&((data)<<12))
+#define SYS_PLL_HDMI2_REG_TV_PSTEP_EN_src(data)                                      ((0x00001000&(data))>>12)
+#define SYS_PLL_HDMI2_get_REG_TV_PSTEP_EN(data)                                      ((0x00001000&(data))>>12)
+#define SYS_PLL_HDMI2_REG_TV_PSTEP_shift                                             (9)
+#define SYS_PLL_HDMI2_REG_TV_PSTEP_mask                                              (0x00000E00)
+#define SYS_PLL_HDMI2_REG_TV_PSTEP(data)                                             (0x00000E00&((data)<<9))
+#define SYS_PLL_HDMI2_REG_TV_PSTEP_src(data)                                         ((0x00000E00&(data))>>9)
+#define SYS_PLL_HDMI2_get_REG_TV_PSTEP(data)                                         ((0x00000E00&(data))>>9)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV3_shift                                           (8)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV3_mask                                            (0x00000100)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV3(data)                                           (0x00000100&((data)<<8))
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV3_src(data)                                       ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI2_get_REG_PIXEL_DIV3(data)                                       ((0x00000100&(data))>>8)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV5_shift                                           (7)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV5_mask                                            (0x00000080)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV5(data)                                           (0x00000080&((data)<<7))
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV5_src(data)                                       ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI2_get_REG_PIXEL_DIV5(data)                                       ((0x00000080&(data))>>7)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV16_shift                                          (4)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV16_mask                                           (0x00000070)
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV16(data)                                          (0x00000070&((data)<<4))
+#define SYS_PLL_HDMI2_REG_PIXEL_DIV16_src(data)                                      ((0x00000070&(data))>>4)
+#define SYS_PLL_HDMI2_get_REG_PIXEL_DIV16(data)                                      ((0x00000070&(data))>>4)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV5_shift                                            (3)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV5_mask                                             (0x00000008)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV5(data)                                            (0x00000008&((data)<<3))
+#define SYS_PLL_HDMI2_REG_TMDS_DIV5_src(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI2_get_REG_TMDS_DIV5(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV16_shift                                           (0)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV16_mask                                            (0x00000007)
+#define SYS_PLL_HDMI2_REG_TMDS_DIV16(data)                                           (0x00000007&((data)<<0))
+#define SYS_PLL_HDMI2_REG_TMDS_DIV16_src(data)                                       ((0x00000007&(data))>>0)
+#define SYS_PLL_HDMI2_get_REG_TMDS_DIV16(data)                                       ((0x00000007&(data))>>0)
+
+
+#define SYS_PLL_DCSB1                                                                0x180001B0
+#define SYS_PLL_DCSB1_reg_addr                                                       "0xB80001B0"
+#define SYS_PLL_DCSB1_reg                                                            0xB80001B0
+#define set_SYS_PLL_DCSB1_reg(data)   (*((volatile unsigned int*) SYS_PLL_DCSB1_reg)=data)
+#define get_SYS_PLL_DCSB1_reg   (*((volatile unsigned int*) SYS_PLL_DCSB1_reg))
+#define SYS_PLL_DCSB1_inst_adr                                                       "0x006C"
+#define SYS_PLL_DCSB1_inst                                                           0x006C
+#define SYS_PLL_DCSB1_PLLDCSB_N_shift                                                (25)
+#define SYS_PLL_DCSB1_PLLDCSB_N_mask                                                 (0x06000000)
+#define SYS_PLL_DCSB1_PLLDCSB_N(data)                                                (0x06000000&((data)<<25))
+#define SYS_PLL_DCSB1_PLLDCSB_N_src(data)                                            ((0x06000000&(data))>>25)
+#define SYS_PLL_DCSB1_get_PLLDCSB_N(data)                                            ((0x06000000&(data))>>25)
+#define SYS_PLL_DCSB1_PLLDCSB_M_shift                                                (18)
+#define SYS_PLL_DCSB1_PLLDCSB_M_mask                                                 (0x01FC0000)
+#define SYS_PLL_DCSB1_PLLDCSB_M(data)                                                (0x01FC0000&((data)<<18))
+#define SYS_PLL_DCSB1_PLLDCSB_M_src(data)                                            ((0x01FC0000&(data))>>18)
+#define SYS_PLL_DCSB1_get_PLLDCSB_M(data)                                            ((0x01FC0000&(data))>>18)
+#define SYS_PLL_DCSB1_PLLDCSB_IP_shift                                               (15)
+#define SYS_PLL_DCSB1_PLLDCSB_IP_mask                                                (0x00038000)
+#define SYS_PLL_DCSB1_PLLDCSB_IP(data)                                               (0x00038000&((data)<<15))
+#define SYS_PLL_DCSB1_PLLDCSB_IP_src(data)                                           ((0x00038000&(data))>>15)
+#define SYS_PLL_DCSB1_get_PLLDCSB_IP(data)                                           ((0x00038000&(data))>>15)
+#define SYS_PLL_DCSB1_PLLDCSB_RS_shift                                               (11)
+#define SYS_PLL_DCSB1_PLLDCSB_RS_mask                                                (0x00003800)
+#define SYS_PLL_DCSB1_PLLDCSB_RS(data)                                               (0x00003800&((data)<<11))
+#define SYS_PLL_DCSB1_PLLDCSB_RS_src(data)                                           ((0x00003800&(data))>>11)
+#define SYS_PLL_DCSB1_get_PLLDCSB_RS(data)                                           ((0x00003800&(data))>>11)
+#define SYS_PLL_DCSB1_PLLDCSB_CS_shift                                               (8)
+#define SYS_PLL_DCSB1_PLLDCSB_CS_mask                                                (0x00000300)
+#define SYS_PLL_DCSB1_PLLDCSB_CS(data)                                               (0x00000300&((data)<<8))
+#define SYS_PLL_DCSB1_PLLDCSB_CS_src(data)                                           ((0x00000300&(data))>>8)
+#define SYS_PLL_DCSB1_get_PLLDCSB_CS(data)                                           ((0x00000300&(data))>>8)
+#define SYS_PLL_DCSB1_PLLDCSB_CP_shift                                               (5)
+#define SYS_PLL_DCSB1_PLLDCSB_CP_mask                                                (0x00000060)
+#define SYS_PLL_DCSB1_PLLDCSB_CP(data)                                               (0x00000060&((data)<<5))
+#define SYS_PLL_DCSB1_PLLDCSB_CP_src(data)                                           ((0x00000060&(data))>>5)
+#define SYS_PLL_DCSB1_get_PLLDCSB_CP(data)                                           ((0x00000060&(data))>>5)
+#define SYS_PLL_DCSB1_PLLDCSB_R3_shift                                               (2)
+#define SYS_PLL_DCSB1_PLLDCSB_R3_mask                                                (0x0000001C)
+#define SYS_PLL_DCSB1_PLLDCSB_R3(data)                                               (0x0000001C&((data)<<2))
+#define SYS_PLL_DCSB1_PLLDCSB_R3_src(data)                                           ((0x0000001C&(data))>>2)
+#define SYS_PLL_DCSB1_get_PLLDCSB_R3(data)                                           ((0x0000001C&(data))>>2)
+#define SYS_PLL_DCSB1_PLLDCSB_C3_shift                                               (0)
+#define SYS_PLL_DCSB1_PLLDCSB_C3_mask                                                (0x00000003)
+#define SYS_PLL_DCSB1_PLLDCSB_C3(data)                                               (0x00000003&((data)<<0))
+#define SYS_PLL_DCSB1_PLLDCSB_C3_src(data)                                           ((0x00000003&(data))>>0)
+#define SYS_PLL_DCSB1_get_PLLDCSB_C3(data)                                           ((0x00000003&(data))>>0)
+
+
+#define SYS_PLL_DCSB2                                                                0x180001B4
+#define SYS_PLL_DCSB2_reg_addr                                                       "0xB80001B4"
+#define SYS_PLL_DCSB2_reg                                                            0xB80001B4
+#define set_SYS_PLL_DCSB2_reg(data)   (*((volatile unsigned int*) SYS_PLL_DCSB2_reg)=data)
+#define get_SYS_PLL_DCSB2_reg   (*((volatile unsigned int*) SYS_PLL_DCSB2_reg))
+#define SYS_PLL_DCSB2_inst_adr                                                       "0x006D"
+#define SYS_PLL_DCSB2_inst                                                           0x006D
+#define SYS_PLL_DCSB2_write_en5_shift                                                (18)
+#define SYS_PLL_DCSB2_write_en5_mask                                                 (0x00040000)
+#define SYS_PLL_DCSB2_write_en5(data)                                                (0x00040000&((data)<<18))
+#define SYS_PLL_DCSB2_write_en5_src(data)                                            ((0x00040000&(data))>>18)
+#define SYS_PLL_DCSB2_get_write_en5(data)                                            ((0x00040000&(data))>>18)
+#define SYS_PLL_DCSB2_PLLDCSB_PI_RL_shift                                            (16)
+#define SYS_PLL_DCSB2_PLLDCSB_PI_RL_mask                                             (0x00030000)
+#define SYS_PLL_DCSB2_PLLDCSB_PI_RL(data)                                            (0x00030000&((data)<<16))
+#define SYS_PLL_DCSB2_PLLDCSB_PI_RL_src(data)                                        ((0x00030000&(data))>>16)
+#define SYS_PLL_DCSB2_get_PLLDCSB_PI_RL(data)                                        ((0x00030000&(data))>>16)
+#define SYS_PLL_DCSB2_PLLDCSB_PI_RS_shift                                            (14)
+#define SYS_PLL_DCSB2_PLLDCSB_PI_RS_mask                                             (0x0000C000)
+#define SYS_PLL_DCSB2_PLLDCSB_PI_RS(data)                                            (0x0000C000&((data)<<14))
+#define SYS_PLL_DCSB2_PLLDCSB_PI_RS_src(data)                                        ((0x0000C000&(data))>>14)
+#define SYS_PLL_DCSB2_get_PLLDCSB_PI_RS(data)                                        ((0x0000C000&(data))>>14)
+#define SYS_PLL_DCSB2_PLLDCSB_PI_BIAS_shift                                          (12)
+#define SYS_PLL_DCSB2_PLLDCSB_PI_BIAS_mask                                           (0x00003000)
+#define SYS_PLL_DCSB2_PLLDCSB_PI_BIAS(data)                                          (0x00003000&((data)<<12))
+#define SYS_PLL_DCSB2_PLLDCSB_PI_BIAS_src(data)                                      ((0x00003000&(data))>>12)
+#define SYS_PLL_DCSB2_get_PLLDCSB_PI_BIAS(data)                                      ((0x00003000&(data))>>12)
+#define SYS_PLL_DCSB2_write_en4_shift                                                (11)
+#define SYS_PLL_DCSB2_write_en4_mask                                                 (0x00000800)
+#define SYS_PLL_DCSB2_write_en4(data)                                                (0x00000800&((data)<<11))
+#define SYS_PLL_DCSB2_write_en4_src(data)                                            ((0x00000800&(data))>>11)
+#define SYS_PLL_DCSB2_get_write_en4(data)                                            ((0x00000800&(data))>>11)
+#define SYS_PLL_DCSB2_PLLDCSB_WDMODE_shift                                           (9)
+#define SYS_PLL_DCSB2_PLLDCSB_WDMODE_mask                                            (0x00000600)
+#define SYS_PLL_DCSB2_PLLDCSB_WDMODE(data)                                           (0x00000600&((data)<<9))
+#define SYS_PLL_DCSB2_PLLDCSB_WDMODE_src(data)                                       ((0x00000600&(data))>>9)
+#define SYS_PLL_DCSB2_get_PLLDCSB_WDMODE(data)                                       ((0x00000600&(data))>>9)
+#define SYS_PLL_DCSB2_write_en3_shift                                                (6)
+#define SYS_PLL_DCSB2_write_en3_mask                                                 (0x00000040)
+#define SYS_PLL_DCSB2_write_en3(data)                                                (0x00000040&((data)<<6))
+#define SYS_PLL_DCSB2_write_en3_src(data)                                            ((0x00000040&(data))>>6)
+#define SYS_PLL_DCSB2_get_write_en3(data)                                            ((0x00000040&(data))>>6)
+#define SYS_PLL_DCSB2_PLLDCSB_FUPDN_shift                                            (5)
+#define SYS_PLL_DCSB2_PLLDCSB_FUPDN_mask                                             (0x00000020)
+#define SYS_PLL_DCSB2_PLLDCSB_FUPDN(data)                                            (0x00000020&((data)<<5))
+#define SYS_PLL_DCSB2_PLLDCSB_FUPDN_src(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PLL_DCSB2_get_PLLDCSB_FUPDN(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PLL_DCSB2_PLLDCSB_PSEN_shift                                             (4)
+#define SYS_PLL_DCSB2_PLLDCSB_PSEN_mask                                              (0x00000010)
+#define SYS_PLL_DCSB2_PLLDCSB_PSEN(data)                                             (0x00000010&((data)<<4))
+#define SYS_PLL_DCSB2_PLLDCSB_PSEN_src(data)                                         ((0x00000010&(data))>>4)
+#define SYS_PLL_DCSB2_get_PLLDCSB_PSEN(data)                                         ((0x00000010&(data))>>4)
+#define SYS_PLL_DCSB2_PLLDCSB_VCORB_shift                                            (3)
+#define SYS_PLL_DCSB2_PLLDCSB_VCORB_mask                                             (0x00000008)
+#define SYS_PLL_DCSB2_PLLDCSB_VCORB(data)                                            (0x00000008&((data)<<3))
+#define SYS_PLL_DCSB2_PLLDCSB_VCORB_src(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PLL_DCSB2_get_PLLDCSB_VCORB(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PLL_DCSB2_write_en1_shift                                                (2)
+#define SYS_PLL_DCSB2_write_en1_mask                                                 (0x00000004)
+#define SYS_PLL_DCSB2_write_en1(data)                                                (0x00000004&((data)<<2))
+#define SYS_PLL_DCSB2_write_en1_src(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_DCSB2_get_write_en1(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_DCSB2_PLLDCSB_TST_shift                                              (1)
+#define SYS_PLL_DCSB2_PLLDCSB_TST_mask                                               (0x00000002)
+#define SYS_PLL_DCSB2_PLLDCSB_TST(data)                                              (0x00000002&((data)<<1))
+#define SYS_PLL_DCSB2_PLLDCSB_TST_src(data)                                          ((0x00000002&(data))>>1)
+#define SYS_PLL_DCSB2_get_PLLDCSB_TST(data)                                          ((0x00000002&(data))>>1)
+#define SYS_PLL_DCSB2_PLLDCSB_PSTST_shift                                            (0)
+#define SYS_PLL_DCSB2_PLLDCSB_PSTST_mask                                             (0x00000001)
+#define SYS_PLL_DCSB2_PLLDCSB_PSTST(data)                                            (0x00000001&((data)<<0))
+#define SYS_PLL_DCSB2_PLLDCSB_PSTST_src(data)                                        ((0x00000001&(data))>>0)
+#define SYS_PLL_DCSB2_get_PLLDCSB_PSTST(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_DCSB3                                                                0x180001B8
+#define SYS_PLL_DCSB3_reg_addr                                                       "0xB80001B8"
+#define SYS_PLL_DCSB3_reg                                                            0xB80001B8
+#define set_SYS_PLL_DCSB3_reg(data)   (*((volatile unsigned int*) SYS_PLL_DCSB3_reg)=data)
+#define get_SYS_PLL_DCSB3_reg   (*((volatile unsigned int*) SYS_PLL_DCSB3_reg))
+#define SYS_PLL_DCSB3_inst_adr                                                       "0x006E"
+#define SYS_PLL_DCSB3_inst                                                           0x006E
+#define SYS_PLL_DCSB3_REG_PLLDCSB_O_shift                                            (3)
+#define SYS_PLL_DCSB3_REG_PLLDCSB_O_mask                                             (0x00000018)
+#define SYS_PLL_DCSB3_REG_PLLDCSB_O(data)                                            (0x00000018&((data)<<3))
+#define SYS_PLL_DCSB3_REG_PLLDCSB_O_src(data)                                        ((0x00000018&(data))>>3)
+#define SYS_PLL_DCSB3_get_REG_PLLDCSB_O(data)                                        ((0x00000018&(data))>>3)
+#define SYS_PLL_DCSB3_PLLDCSB_OEB_shift                                              (2)
+#define SYS_PLL_DCSB3_PLLDCSB_OEB_mask                                               (0x00000004)
+#define SYS_PLL_DCSB3_PLLDCSB_OEB(data)                                              (0x00000004&((data)<<2))
+#define SYS_PLL_DCSB3_PLLDCSB_OEB_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_DCSB3_get_PLLDCSB_OEB(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_DCSB3_PLLDCSB_RSTB_shift                                             (1)
+#define SYS_PLL_DCSB3_PLLDCSB_RSTB_mask                                              (0x00000002)
+#define SYS_PLL_DCSB3_PLLDCSB_RSTB(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_DCSB3_PLLDCSB_RSTB_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_DCSB3_get_PLLDCSB_RSTB(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_DCSB3_PLLDCSB_POW_shift                                              (0)
+#define SYS_PLL_DCSB3_PLLDCSB_POW_mask                                               (0x00000001)
+#define SYS_PLL_DCSB3_PLLDCSB_POW(data)                                              (0x00000001&((data)<<0))
+#define SYS_PLL_DCSB3_PLLDCSB_POW_src(data)                                          ((0x00000001&(data))>>0)
+#define SYS_PLL_DCSB3_get_PLLDCSB_POW(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_GPU1                                                                 0x180001C0
+#define SYS_PLL_GPU1_reg_addr                                                        "0xB80001C0"
+#define SYS_PLL_GPU1_reg                                                             0xB80001C0
+#define set_SYS_PLL_GPU1_reg(data)   (*((volatile unsigned int*) SYS_PLL_GPU1_reg)=data)
+#define get_SYS_PLL_GPU1_reg   (*((volatile unsigned int*) SYS_PLL_GPU1_reg))
+#define SYS_PLL_GPU1_inst_adr                                                        "0x0070"
+#define SYS_PLL_GPU1_inst                                                            0x0070
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST_shift                                          (29)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST_mask                                           (0x20000000)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST(data)                                          (0x20000000&((data)<<29))
+#define SYS_PLL_GPU1_REG_PLLGPU_WDRST_src(data)                                      ((0x20000000&(data))>>29)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_WDRST(data)                                      ((0x20000000&(data))>>29)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET_shift                                          (28)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET_mask                                           (0x10000000)
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET(data)                                          (0x10000000&((data)<<28))
+#define SYS_PLL_GPU1_REG_PLLGPU_WDSET_src(data)                                      ((0x10000000&(data))>>28)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_WDSET(data)                                      ((0x10000000&(data))>>28)
+#define SYS_PLL_GPU1_REG_PLLGPU_CS_shift                                             (26)
+#define SYS_PLL_GPU1_REG_PLLGPU_CS_mask                                              (0x0C000000)
+#define SYS_PLL_GPU1_REG_PLLGPU_CS(data)                                             (0x0C000000&((data)<<26))
+#define SYS_PLL_GPU1_REG_PLLGPU_CS_src(data)                                         ((0x0C000000&(data))>>26)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_CS(data)                                         ((0x0C000000&(data))>>26)
+#define SYS_PLL_GPU1_REG_PLLGPU_O_shift                                              (24)
+#define SYS_PLL_GPU1_REG_PLLGPU_O_mask                                               (0x03000000)
+#define SYS_PLL_GPU1_REG_PLLGPU_O(data)                                              (0x03000000&((data)<<24))
+#define SYS_PLL_GPU1_REG_PLLGPU_O_src(data)                                          ((0x03000000&(data))>>24)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_O(data)                                          ((0x03000000&(data))>>24)
+#define SYS_PLL_GPU1_REG_PLLGPU_RS_shift                                             (21)
+#define SYS_PLL_GPU1_REG_PLLGPU_RS_mask                                              (0x00E00000)
+#define SYS_PLL_GPU1_REG_PLLGPU_RS(data)                                             (0x00E00000&((data)<<21))
+#define SYS_PLL_GPU1_REG_PLLGPU_RS_src(data)                                         ((0x00E00000&(data))>>21)
+#define SYS_PLL_GPU1_get_REG_PLLGPU_RS(data)                                         ((0x00E00000&(data))>>21)
+#define SYS_PLL_GPU1_PLLGPU_N_shift                                                  (18)
+#define SYS_PLL_GPU1_PLLGPU_N_mask                                                   (0x000C0000)
+#define SYS_PLL_GPU1_PLLGPU_N(data)                                                  (0x000C0000&((data)<<18))
+#define SYS_PLL_GPU1_PLLGPU_N_src(data)                                              ((0x000C0000&(data))>>18)
+#define SYS_PLL_GPU1_get_PLLGPU_N(data)                                              ((0x000C0000&(data))>>18)
+#define SYS_PLL_GPU1_PLLGPU_M_shift                                                  (11)
+#define SYS_PLL_GPU1_PLLGPU_M_mask                                                   (0x0003F800)
+#define SYS_PLL_GPU1_PLLGPU_M(data)                                                  (0x0003F800&((data)<<11))
+#define SYS_PLL_GPU1_PLLGPU_M_src(data)                                              ((0x0003F800&(data))>>11)
+#define SYS_PLL_GPU1_get_PLLGPU_M(data)                                              ((0x0003F800&(data))>>11)
+#define SYS_PLL_GPU1_PLLGPU_IP_shift                                                 (8)
+#define SYS_PLL_GPU1_PLLGPU_IP_mask                                                  (0x00000700)
+#define SYS_PLL_GPU1_PLLGPU_IP(data)                                                 (0x00000700&((data)<<8))
+#define SYS_PLL_GPU1_PLLGPU_IP_src(data)                                             ((0x00000700&(data))>>8)
+#define SYS_PLL_GPU1_get_PLLGPU_IP(data)                                             ((0x00000700&(data))>>8)
+#define SYS_PLL_GPU1_PLLGPU_TST_shift                                                (0)
+#define SYS_PLL_GPU1_PLLGPU_TST_mask                                                 (0x00000001)
+#define SYS_PLL_GPU1_PLLGPU_TST(data)                                                (0x00000001&((data)<<0))
+#define SYS_PLL_GPU1_PLLGPU_TST_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_PLL_GPU1_get_PLLGPU_TST(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_GPU2                                                                 0x180001C4
+#define SYS_PLL_GPU2_reg_addr                                                        "0xB80001C4"
+#define SYS_PLL_GPU2_reg                                                             0xB80001C4
+#define set_SYS_PLL_GPU2_reg(data)   (*((volatile unsigned int*) SYS_PLL_GPU2_reg)=data)
+#define get_SYS_PLL_GPU2_reg   (*((volatile unsigned int*) SYS_PLL_GPU2_reg))
+#define SYS_PLL_GPU2_inst_adr                                                        "0x0071"
+#define SYS_PLL_GPU2_inst                                                            0x0071
+#define SYS_PLL_GPU2_PLLGPU_OEB_shift                                                (2)
+#define SYS_PLL_GPU2_PLLGPU_OEB_mask                                                 (0x00000004)
+#define SYS_PLL_GPU2_PLLGPU_OEB(data)                                                (0x00000004&((data)<<2))
+#define SYS_PLL_GPU2_PLLGPU_OEB_src(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_GPU2_get_PLLGPU_OEB(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_GPU2_PLLGPU_RSTB_shift                                               (1)
+#define SYS_PLL_GPU2_PLLGPU_RSTB_mask                                                (0x00000002)
+#define SYS_PLL_GPU2_PLLGPU_RSTB(data)                                               (0x00000002&((data)<<1))
+#define SYS_PLL_GPU2_PLLGPU_RSTB_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_GPU2_get_PLLGPU_RSTB(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_GPU2_PLLGPU_POW_shift                                                (0)
+#define SYS_PLL_GPU2_PLLGPU_POW_mask                                                 (0x00000001)
+#define SYS_PLL_GPU2_PLLGPU_POW(data)                                                (0x00000001&((data)<<0))
+#define SYS_PLL_GPU2_PLLGPU_POW_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_PLL_GPU2_get_PLLGPU_POW(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_LVDS1                                                                0x180001D0
+#define SYS_PLL_LVDS1_reg_addr                                                       "0xB80001D0"
+#define SYS_PLL_LVDS1_reg                                                            0xB80001D0
+#define set_SYS_PLL_LVDS1_reg(data)   (*((volatile unsigned int*) SYS_PLL_LVDS1_reg)=data)
+#define get_SYS_PLL_LVDS1_reg   (*((volatile unsigned int*) SYS_PLL_LVDS1_reg))
+#define SYS_PLL_LVDS1_inst_adr                                                       "0x0074"
+#define SYS_PLL_LVDS1_inst                                                           0x0074
+#define SYS_PLL_LVDS1_REG_PLLLVDS_BPN_shift                                          (31)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_BPN_mask                                           (0x80000000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_BPN(data)                                          (0x80000000&((data)<<31))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_BPN_src(data)                                      ((0x80000000&(data))>>31)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_BPN(data)                                      ((0x80000000&(data))>>31)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_BPPHS_shift                                        (30)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_BPPHS_mask                                         (0x40000000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_BPPHS(data)                                        (0x40000000&((data)<<30))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_BPPHS_src(data)                                    ((0x40000000&(data))>>30)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_BPPHS(data)                                    ((0x40000000&(data))>>30)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_FREEZE_shift                                       (29)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_FREEZE_mask                                        (0x20000000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_FREEZE(data)                                       (0x20000000&((data)<<29))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_FREEZE_src(data)                                   ((0x20000000&(data))>>29)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_FREEZE(data)                                   ((0x20000000&(data))>>29)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_FUPDN_shift                                        (28)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_FUPDN_mask                                         (0x10000000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_FUPDN(data)                                        (0x10000000&((data)<<28))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_FUPDN_src(data)                                    ((0x10000000&(data))>>28)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_FUPDN(data)                                    ((0x10000000&(data))>>28)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_POW_shift                                          (27)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_POW_mask                                           (0x08000000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_POW(data)                                          (0x08000000&((data)<<27))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_POW_src(data)                                      ((0x08000000&(data))>>27)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_POW(data)                                      ((0x08000000&(data))>>27)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RESERVE_shift                                      (26)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RESERVE_mask                                       (0x04000000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RESERVE(data)                                      (0x04000000&((data)<<26))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RESERVE_src(data)                                  ((0x04000000&(data))>>26)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_RESERVE(data)                                  ((0x04000000&(data))>>26)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RSTB_shift                                         (25)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RSTB_mask                                          (0x02000000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RSTB(data)                                         (0x02000000&((data)<<25))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RSTB_src(data)                                     ((0x02000000&(data))>>25)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_RSTB(data)                                     ((0x02000000&(data))>>25)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_STOP_shift                                         (24)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_STOP_mask                                          (0x01000000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_STOP(data)                                         (0x01000000&((data)<<24))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_STOP_src(data)                                     ((0x01000000&(data))>>24)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_STOP(data)                                     ((0x01000000&(data))>>24)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_VCORSTB_shift                                      (23)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_VCORSTB_mask                                       (0x00800000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_VCORSTB(data)                                      (0x00800000&((data)<<23))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_VCORSTB_src(data)                                  ((0x00800000&(data))>>23)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_VCORSTB(data)                                  ((0x00800000&(data))>>23)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_WDRST_shift                                        (22)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_WDRST_mask                                         (0x00400000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_WDRST(data)                                        (0x00400000&((data)<<22))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_WDRST_src(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_WDRST(data)                                    ((0x00400000&(data))>>22)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_WDSET_shift                                        (21)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_WDSET_mask                                         (0x00200000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_WDSET(data)                                        (0x00200000&((data)<<21))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_WDSET_src(data)                                    ((0x00200000&(data))>>21)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_WDSET(data)                                    ((0x00200000&(data))>>21)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_CP_shift                                           (19)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_CP_mask                                            (0x00180000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_CP(data)                                           (0x00180000&((data)<<19))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_CP_src(data)                                       ((0x00180000&(data))>>19)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_CP(data)                                       ((0x00180000&(data))>>19)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_CS_shift                                           (17)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_CS_mask                                            (0x00060000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_CS(data)                                           (0x00060000&((data)<<17))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_CS_src(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_CS(data)                                       ((0x00060000&(data))>>17)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_O_shift                                            (15)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_O_mask                                             (0x00018000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_O(data)                                            (0x00018000&((data)<<15))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_O_src(data)                                        ((0x00018000&(data))>>15)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_O(data)                                        ((0x00018000&(data))>>15)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_IP_shift                                           (12)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_IP_mask                                            (0x00007000)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_IP(data)                                           (0x00007000&((data)<<12))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_IP_src(data)                                       ((0x00007000&(data))>>12)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_IP(data)                                       ((0x00007000&(data))>>12)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RS_shift                                           (9)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RS_mask                                            (0x00000E00)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RS(data)                                           (0x00000E00&((data)<<9))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_RS_src(data)                                       ((0x00000E00&(data))>>9)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_RS(data)                                       ((0x00000E00&(data))>>9)
+#define SYS_PLL_LVDS1_PLLLVDS_RESER_shift                                            (1)
+#define SYS_PLL_LVDS1_PLLLVDS_RESER_mask                                             (0x00000002)
+#define SYS_PLL_LVDS1_PLLLVDS_RESER(data)                                            (0x00000002&((data)<<1))
+#define SYS_PLL_LVDS1_PLLLVDS_RESER_src(data)                                        ((0x00000002&(data))>>1)
+#define SYS_PLL_LVDS1_get_PLLLVDS_RESER(data)                                        ((0x00000002&(data))>>1)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_TST_shift                                          (0)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_TST_mask                                           (0x00000001)
+#define SYS_PLL_LVDS1_REG_PLLLVDS_TST(data)                                          (0x00000001&((data)<<0))
+#define SYS_PLL_LVDS1_REG_PLLLVDS_TST_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PLL_LVDS1_get_REG_PLLLVDS_TST(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_LVDS2                                                                0x180001D4
+#define SYS_PLL_LVDS2_reg_addr                                                       "0xB80001D4"
+#define SYS_PLL_LVDS2_reg                                                            0xB80001D4
+#define set_SYS_PLL_LVDS2_reg(data)   (*((volatile unsigned int*) SYS_PLL_LVDS2_reg)=data)
+#define get_SYS_PLL_LVDS2_reg   (*((volatile unsigned int*) SYS_PLL_LVDS2_reg))
+#define SYS_PLL_LVDS2_inst_adr                                                       "0x0075"
+#define SYS_PLL_LVDS2_inst                                                           0x0075
+#define SYS_PLL_LVDS2_REG_PLLLVDS_M_shift                                            (3)
+#define SYS_PLL_LVDS2_REG_PLLLVDS_M_mask                                             (0x000007F8)
+#define SYS_PLL_LVDS2_REG_PLLLVDS_M(data)                                            (0x000007F8&((data)<<3))
+#define SYS_PLL_LVDS2_REG_PLLLVDS_M_src(data)                                        ((0x000007F8&(data))>>3)
+#define SYS_PLL_LVDS2_get_REG_PLLLVDS_M(data)                                        ((0x000007F8&(data))>>3)
+#define SYS_PLL_LVDS2_REG_PLLLVDS_N_shift                                            (0)
+#define SYS_PLL_LVDS2_REG_PLLLVDS_N_mask                                             (0x00000007)
+#define SYS_PLL_LVDS2_REG_PLLLVDS_N(data)                                            (0x00000007&((data)<<0))
+#define SYS_PLL_LVDS2_REG_PLLLVDS_N_src(data)                                        ((0x00000007&(data))>>0)
+#define SYS_PLL_LVDS2_get_REG_PLLLVDS_N(data)                                        ((0x00000007&(data))>>0)
+
+
+#define SYS_PLL_DDR6                                                                 0x180001DC
+#define SYS_PLL_DDR6_reg_addr                                                        "0xB80001DC"
+#define SYS_PLL_DDR6_reg                                                             0xB80001DC
+#define set_SYS_PLL_DDR6_reg(data)   (*((volatile unsigned int*) SYS_PLL_DDR6_reg)=data)
+#define get_SYS_PLL_DDR6_reg   (*((volatile unsigned int*) SYS_PLL_DDR6_reg))
+#define SYS_PLL_DDR6_inst_adr                                                        "0x0077"
+#define SYS_PLL_DDR6_inst                                                            0x0077
+#define SYS_PLL_DDR6_PLLDDR_PLL_STABLE_shift                                         (1)
+#define SYS_PLL_DDR6_PLLDDR_PLL_STABLE_mask                                          (0x00000002)
+#define SYS_PLL_DDR6_PLLDDR_PLL_STABLE(data)                                         (0x00000002&((data)<<1))
+#define SYS_PLL_DDR6_PLLDDR_PLL_STABLE_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DDR6_get_PLLDDR_PLL_STABLE(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PLL_DDR6_POWDET_DDR_shift                                                (0)
+#define SYS_PLL_DDR6_POWDET_DDR_mask                                                 (0x00000001)
+#define SYS_PLL_DDR6_POWDET_DDR(data)                                                (0x00000001&((data)<<0))
+#define SYS_PLL_DDR6_POWDET_DDR_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_PLL_DDR6_get_POWDET_DDR(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_OTHER                                                                0x18000200
+#define SYS_PLL_OTHER_reg_addr                                                       "0xB8000200"
+#define SYS_PLL_OTHER_reg                                                            0xB8000200
+#define set_SYS_PLL_OTHER_reg(data)   (*((volatile unsigned int*) SYS_PLL_OTHER_reg)=data)
+#define get_SYS_PLL_OTHER_reg   (*((volatile unsigned int*) SYS_PLL_OTHER_reg))
+#define SYS_PLL_OTHER_inst_adr                                                       "0x0080"
+#define SYS_PLL_OTHER_inst                                                           0x0080
+#define SYS_PLL_OTHER_PLLTST_DIV32_shift                                             (13)
+#define SYS_PLL_OTHER_PLLTST_DIV32_mask                                              (0x00002000)
+#define SYS_PLL_OTHER_PLLTST_DIV32(data)                                             (0x00002000&((data)<<13))
+#define SYS_PLL_OTHER_PLLTST_DIV32_src(data)                                         ((0x00002000&(data))>>13)
+#define SYS_PLL_OTHER_get_PLLTST_DIV32(data)                                         ((0x00002000&(data))>>13)
+#define SYS_PLL_OTHER_POR_VSET_shift                                                 (12)
+#define SYS_PLL_OTHER_POR_VSET_mask                                                  (0x00001000)
+#define SYS_PLL_OTHER_POR_VSET(data)                                                 (0x00001000&((data)<<12))
+#define SYS_PLL_OTHER_POR_VSET_src(data)                                             ((0x00001000&(data))>>12)
+#define SYS_PLL_OTHER_get_POR_VSET(data)                                             ((0x00001000&(data))>>12)
+#define SYS_PLL_OTHER_REG_PLLDDSB_SEL_shift                                          (11)
+#define SYS_PLL_OTHER_REG_PLLDDSB_SEL_mask                                           (0x00000800)
+#define SYS_PLL_OTHER_REG_PLLDDSB_SEL(data)                                          (0x00000800&((data)<<11))
+#define SYS_PLL_OTHER_REG_PLLDDSB_SEL_src(data)                                      ((0x00000800&(data))>>11)
+#define SYS_PLL_OTHER_get_REG_PLLDDSB_SEL(data)                                      ((0x00000800&(data))>>11)
+#define SYS_PLL_OTHER_PLLDISP_SEL_shift                                              (9)
+#define SYS_PLL_OTHER_PLLDISP_SEL_mask                                               (0x00000600)
+#define SYS_PLL_OTHER_PLLDISP_SEL(data)                                              (0x00000600&((data)<<9))
+#define SYS_PLL_OTHER_PLLDISP_SEL_src(data)                                          ((0x00000600&(data))>>9)
+#define SYS_PLL_OTHER_get_PLLDISP_SEL(data)                                          ((0x00000600&(data))>>9)
+#define SYS_PLL_OTHER_PLLHDMI_SEL_shift                                              (7)
+#define SYS_PLL_OTHER_PLLHDMI_SEL_mask                                               (0x00000180)
+#define SYS_PLL_OTHER_PLLHDMI_SEL(data)                                              (0x00000180&((data)<<7))
+#define SYS_PLL_OTHER_PLLHDMI_SEL_src(data)                                          ((0x00000180&(data))>>7)
+#define SYS_PLL_OTHER_get_PLLHDMI_SEL(data)                                          ((0x00000180&(data))>>7)
+#define SYS_PLL_OTHER_PLLTST_SEL_shift                                               (3)
+#define SYS_PLL_OTHER_PLLTST_SEL_mask                                                (0x00000078)
+#define SYS_PLL_OTHER_PLLTST_SEL(data)                                               (0x00000078&((data)<<3))
+#define SYS_PLL_OTHER_PLLTST_SEL_src(data)                                           ((0x00000078&(data))>>3)
+#define SYS_PLL_OTHER_get_PLLTST_SEL(data)                                           ((0x00000078&(data))>>3)
+#define SYS_PLL_OTHER_PLLTST_DIV_shift                                               (0)
+#define SYS_PLL_OTHER_PLLTST_DIV_mask                                                (0x00000007)
+#define SYS_PLL_OTHER_PLLTST_DIV(data)                                               (0x00000007&((data)<<0))
+#define SYS_PLL_OTHER_PLLTST_DIV_src(data)                                           ((0x00000007&(data))>>0)
+#define SYS_PLL_OTHER_get_PLLTST_DIV(data)                                           ((0x00000007&(data))>>0)
+
+
+#define SYS_PLL_SD1                                                                  0x180001E0
+#define SYS_PLL_SD1_reg_addr                                                         "0xB80001E0"
+#define SYS_PLL_SD1_reg                                                              0xB80001E0
+#define set_SYS_PLL_SD1_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD1_reg)=data)
+#define get_SYS_PLL_SD1_reg   (*((volatile unsigned int*) SYS_PLL_SD1_reg))
+#define SYS_PLL_SD1_inst_adr                                                         "0x0078"
+#define SYS_PLL_SD1_inst                                                             0x0078
+#define SYS_PLL_SD1_reg_tuned3318_shift                                              (19)
+#define SYS_PLL_SD1_reg_tuned3318_mask                                               (0x00380000)
+#define SYS_PLL_SD1_reg_tuned3318(data)                                              (0x00380000&((data)<<19))
+#define SYS_PLL_SD1_reg_tuned3318_src(data)                                          ((0x00380000&(data))>>19)
+#define SYS_PLL_SD1_get_reg_tuned3318(data)                                          ((0x00380000&(data))>>19)
+#define SYS_PLL_SD1_reg_d3318pow_shift                                               (17)
+#define SYS_PLL_SD1_reg_d3318pow_mask                                                (0x00060000)
+#define SYS_PLL_SD1_reg_d3318pow(data)                                               (0x00060000&((data)<<17))
+#define SYS_PLL_SD1_reg_d3318pow_src(data)                                           ((0x00060000&(data))>>17)
+#define SYS_PLL_SD1_get_reg_d3318pow(data)                                           ((0x00060000&(data))>>17)
+#define SYS_PLL_SD1_regpd_d3318_shift                                                (16)
+#define SYS_PLL_SD1_regpd_d3318_mask                                                 (0x00010000)
+#define SYS_PLL_SD1_regpd_d3318(data)                                                (0x00010000&((data)<<16))
+#define SYS_PLL_SD1_regpd_d3318_src(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_SD1_get_regpd_d3318(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_SD1_phsel1_shift                                                     (8)
+#define SYS_PLL_SD1_phsel1_mask                                                      (0x00001F00)
+#define SYS_PLL_SD1_phsel1(data)                                                     (0x00001F00&((data)<<8))
+#define SYS_PLL_SD1_phsel1_src(data)                                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SD1_get_phsel1(data)                                                 ((0x00001F00&(data))>>8)
+#define SYS_PLL_SD1_phsel0_shift                                                     (3)
+#define SYS_PLL_SD1_phsel0_mask                                                      (0x000000F8)
+#define SYS_PLL_SD1_phsel0(data)                                                     (0x000000F8&((data)<<3))
+#define SYS_PLL_SD1_phsel0_src(data)                                                 ((0x000000F8&(data))>>3)
+#define SYS_PLL_SD1_get_phsel0(data)                                                 ((0x000000F8&(data))>>3)
+#define SYS_PLL_SD1_phrstb_dly_sel_shift                                             (2)
+#define SYS_PLL_SD1_phrstb_dly_sel_mask                                              (0x00000004)
+#define SYS_PLL_SD1_phrstb_dly_sel(data)                                             (0x00000004&((data)<<2))
+#define SYS_PLL_SD1_phrstb_dly_sel_src(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SD1_get_phrstb_dly_sel(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PLL_SD1_phrt0_shift                                                      (1)
+#define SYS_PLL_SD1_phrt0_mask                                                       (0x00000002)
+#define SYS_PLL_SD1_phrt0(data)                                                      (0x00000002&((data)<<1))
+#define SYS_PLL_SD1_phrt0_src(data)                                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SD1_get_phrt0(data)                                                  ((0x00000002&(data))>>1)
+#define SYS_PLL_SD1_bias_en_shift                                                    (0)
+#define SYS_PLL_SD1_bias_en_mask                                                     (0x00000001)
+#define SYS_PLL_SD1_bias_en(data)                                                    (0x00000001&((data)<<0))
+#define SYS_PLL_SD1_bias_en_src(data)                                                ((0x00000001&(data))>>0)
+#define SYS_PLL_SD1_get_bias_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SD2                                                                  0x180001E4
+#define SYS_PLL_SD2_reg_addr                                                         "0xB80001E4"
+#define SYS_PLL_SD2_reg                                                              0xB80001E4
+#define set_SYS_PLL_SD2_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD2_reg)=data)
+#define get_SYS_PLL_SD2_reg   (*((volatile unsigned int*) SYS_PLL_SD2_reg))
+#define SYS_PLL_SD2_inst_adr                                                         "0x0079"
+#define SYS_PLL_SD2_inst                                                             0x0079
+#define SYS_PLL_SD2_en_cpnew_shift                                                   (26)
+#define SYS_PLL_SD2_en_cpnew_mask                                                    (0x04000000)
+#define SYS_PLL_SD2_en_cpnew(data)                                                   (0x04000000&((data)<<26))
+#define SYS_PLL_SD2_en_cpnew_src(data)                                               ((0x04000000&(data))>>26)
+#define SYS_PLL_SD2_get_en_cpnew(data)                                               ((0x04000000&(data))>>26)
+#define SYS_PLL_SD2_ssc_div_ext_f_shift                                              (18)
+#define SYS_PLL_SD2_ssc_div_ext_f_mask                                               (0x03FC0000)
+#define SYS_PLL_SD2_ssc_div_ext_f(data)                                              (0x03FC0000&((data)<<18))
+#define SYS_PLL_SD2_ssc_div_ext_f_src(data)                                          ((0x03FC0000&(data))>>18)
+#define SYS_PLL_SD2_get_ssc_div_ext_f(data)                                          ((0x03FC0000&(data))>>18)
+#define SYS_PLL_SD2_ssc_div_f_sel_shift                                              (17)
+#define SYS_PLL_SD2_ssc_div_f_sel_mask                                               (0x00020000)
+#define SYS_PLL_SD2_ssc_div_f_sel(data)                                              (0x00020000&((data)<<17))
+#define SYS_PLL_SD2_ssc_div_f_sel_src(data)                                          ((0x00020000&(data))>>17)
+#define SYS_PLL_SD2_get_ssc_div_f_sel(data)                                          ((0x00020000&(data))>>17)
+#define SYS_PLL_SD2_ssc_8x_en_shift                                                  (16)
+#define SYS_PLL_SD2_ssc_8x_en_mask                                                   (0x00010000)
+#define SYS_PLL_SD2_ssc_8x_en(data)                                                  (0x00010000&((data)<<16))
+#define SYS_PLL_SD2_ssc_8x_en_src(data)                                              ((0x00010000&(data))>>16)
+#define SYS_PLL_SD2_get_ssc_8x_en(data)                                              ((0x00010000&(data))>>16)
+#define SYS_PLL_SD2_ssc_depth_shift                                                  (13)
+#define SYS_PLL_SD2_ssc_depth_mask                                                   (0x0000E000)
+#define SYS_PLL_SD2_ssc_depth(data)                                                  (0x0000E000&((data)<<13))
+#define SYS_PLL_SD2_ssc_depth_src(data)                                              ((0x0000E000&(data))>>13)
+#define SYS_PLL_SD2_get_ssc_depth(data)                                              ((0x0000E000&(data))>>13)
+#define SYS_PLL_SD2_sscpll_rs_shift                                                  (10)
+#define SYS_PLL_SD2_sscpll_rs_mask                                                   (0x00001C00)
+#define SYS_PLL_SD2_sscpll_rs(data)                                                  (0x00001C00&((data)<<10))
+#define SYS_PLL_SD2_sscpll_rs_src(data)                                              ((0x00001C00&(data))>>10)
+#define SYS_PLL_SD2_get_sscpll_rs(data)                                              ((0x00001C00&(data))>>10)
+#define SYS_PLL_SD2_sscpll_icp_shift                                                 (5)
+#define SYS_PLL_SD2_sscpll_icp_mask                                                  (0x000003E0)
+#define SYS_PLL_SD2_sscpll_icp(data)                                                 (0x000003E0&((data)<<5))
+#define SYS_PLL_SD2_sscpll_icp_src(data)                                             ((0x000003E0&(data))>>5)
+#define SYS_PLL_SD2_get_sscpll_icp(data)                                             ((0x000003E0&(data))>>5)
+#define SYS_PLL_SD2_sscpll_cs1_shift                                                 (3)
+#define SYS_PLL_SD2_sscpll_cs1_mask                                                  (0x00000018)
+#define SYS_PLL_SD2_sscpll_cs1(data)                                                 (0x00000018&((data)<<3))
+#define SYS_PLL_SD2_sscpll_cs1_src(data)                                             ((0x00000018&(data))>>3)
+#define SYS_PLL_SD2_get_sscpll_cs1(data)                                             ((0x00000018&(data))>>3)
+#define SYS_PLL_SD2_reg_tune11_shift                                                 (1)
+#define SYS_PLL_SD2_reg_tune11_mask                                                  (0x00000006)
+#define SYS_PLL_SD2_reg_tune11(data)                                                 (0x00000006&((data)<<1))
+#define SYS_PLL_SD2_reg_tune11_src(data)                                             ((0x00000006&(data))>>1)
+#define SYS_PLL_SD2_get_reg_tune11(data)                                             ((0x00000006&(data))>>1)
+#define SYS_PLL_SD2_sscldo_en_shift                                                  (0)
+#define SYS_PLL_SD2_sscldo_en_mask                                                   (0x00000001)
+#define SYS_PLL_SD2_sscldo_en(data)                                                  (0x00000001&((data)<<0))
+#define SYS_PLL_SD2_sscldo_en_src(data)                                              ((0x00000001&(data))>>0)
+#define SYS_PLL_SD2_get_sscldo_en(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_SD3                                                                  0x180001E8
+#define SYS_PLL_SD3_reg_addr                                                         "0xB80001E8"
+#define SYS_PLL_SD3_reg                                                              0xB80001E8
+#define set_SYS_PLL_SD3_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD3_reg)=data)
+#define get_SYS_PLL_SD3_reg   (*((volatile unsigned int*) SYS_PLL_SD3_reg))
+#define SYS_PLL_SD3_inst_adr                                                         "0x007A"
+#define SYS_PLL_SD3_inst                                                             0x007A
+#define SYS_PLL_SD3_ssc_div_n_shift                                                  (16)
+#define SYS_PLL_SD3_ssc_div_n_mask                                                   (0x03FF0000)
+#define SYS_PLL_SD3_ssc_div_n(data)                                                  (0x03FF0000&((data)<<16))
+#define SYS_PLL_SD3_ssc_div_n_src(data)                                              ((0x03FF0000&(data))>>16)
+#define SYS_PLL_SD3_get_ssc_div_n(data)                                              ((0x03FF0000&(data))>>16)
+#define SYS_PLL_SD3_ssc_step_in_shift                                                (8)
+#define SYS_PLL_SD3_ssc_step_in_mask                                                 (0x00007F00)
+#define SYS_PLL_SD3_ssc_step_in(data)                                                (0x00007F00&((data)<<8))
+#define SYS_PLL_SD3_ssc_step_in_src(data)                                            ((0x00007F00&(data))>>8)
+#define SYS_PLL_SD3_get_ssc_step_in(data)                                            ((0x00007F00&(data))>>8)
+#define SYS_PLL_SD3_ssc_tbase_shift                                                  (0)
+#define SYS_PLL_SD3_ssc_tbase_mask                                                   (0x000000FF)
+#define SYS_PLL_SD3_ssc_tbase(data)                                                  (0x000000FF&((data)<<0))
+#define SYS_PLL_SD3_ssc_tbase_src(data)                                              ((0x000000FF&(data))>>0)
+#define SYS_PLL_SD3_get_ssc_tbase(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_SD4                                                                  0x180001EC
+#define SYS_PLL_SD4_reg_addr                                                         "0xB80001EC"
+#define SYS_PLL_SD4_reg                                                              0xB80001EC
+#define set_SYS_PLL_SD4_reg(data)   (*((volatile unsigned int*) SYS_PLL_SD4_reg)=data)
+#define get_SYS_PLL_SD4_reg   (*((volatile unsigned int*) SYS_PLL_SD4_reg))
+#define SYS_PLL_SD4_inst_adr                                                         "0x007B"
+#define SYS_PLL_SD4_inst                                                             0x007B
+#define SYS_PLL_SD4_ssc_pll_pow_shift                                                (2)
+#define SYS_PLL_SD4_ssc_pll_pow_mask                                                 (0x00000004)
+#define SYS_PLL_SD4_ssc_pll_pow(data)                                                (0x00000004&((data)<<2))
+#define SYS_PLL_SD4_ssc_pll_pow_src(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_SD4_get_ssc_pll_pow(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PLL_SD4_ssc_pll_rstb_shift                                               (1)
+#define SYS_PLL_SD4_ssc_pll_rstb_mask                                                (0x00000002)
+#define SYS_PLL_SD4_ssc_pll_rstb(data)                                               (0x00000002&((data)<<1))
+#define SYS_PLL_SD4_ssc_pll_rstb_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_SD4_get_ssc_pll_rstb(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PLL_SD4_ssc_rstb_shift                                                   (0)
+#define SYS_PLL_SD4_ssc_rstb_mask                                                    (0x00000001)
+#define SYS_PLL_SD4_ssc_rstb(data)                                                   (0x00000001&((data)<<0))
+#define SYS_PLL_SD4_ssc_rstb_src(data)                                               ((0x00000001&(data))>>0)
+#define SYS_PLL_SD4_get_ssc_rstb(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EMMC1                                                                0x180001F0
+#define SYS_PLL_EMMC1_reg_addr                                                       "0xB80001F0"
+#define SYS_PLL_EMMC1_reg                                                            0xB80001F0
+#define set_SYS_PLL_EMMC1_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC1_reg)=data)
+#define get_SYS_PLL_EMMC1_reg   (*((volatile unsigned int*) SYS_PLL_EMMC1_reg))
+#define SYS_PLL_EMMC1_inst_adr                                                       "0x007C"
+#define SYS_PLL_EMMC1_inst                                                           0x007C
+#define SYS_PLL_EMMC1_reg_tuned3318_shift                                            (19)
+#define SYS_PLL_EMMC1_reg_tuned3318_mask                                             (0x00380000)
+#define SYS_PLL_EMMC1_reg_tuned3318(data)                                            (0x00380000&((data)<<19))
+#define SYS_PLL_EMMC1_reg_tuned3318_src(data)                                        ((0x00380000&(data))>>19)
+#define SYS_PLL_EMMC1_get_reg_tuned3318(data)                                        ((0x00380000&(data))>>19)
+#define SYS_PLL_EMMC1_reg_d3318pow_shift                                             (17)
+#define SYS_PLL_EMMC1_reg_d3318pow_mask                                              (0x00060000)
+#define SYS_PLL_EMMC1_reg_d3318pow(data)                                             (0x00060000&((data)<<17))
+#define SYS_PLL_EMMC1_reg_d3318pow_src(data)                                         ((0x00060000&(data))>>17)
+#define SYS_PLL_EMMC1_get_reg_d3318pow(data)                                         ((0x00060000&(data))>>17)
+#define SYS_PLL_EMMC1_regpd_d3318_shift                                              (16)
+#define SYS_PLL_EMMC1_regpd_d3318_mask                                               (0x00010000)
+#define SYS_PLL_EMMC1_regpd_d3318(data)                                              (0x00010000&((data)<<16))
+#define SYS_PLL_EMMC1_regpd_d3318_src(data)                                          ((0x00010000&(data))>>16)
+#define SYS_PLL_EMMC1_get_regpd_d3318(data)                                          ((0x00010000&(data))>>16)
+#define SYS_PLL_EMMC1_phsel1_shift                                                   (8)
+#define SYS_PLL_EMMC1_phsel1_mask                                                    (0x00001F00)
+#define SYS_PLL_EMMC1_phsel1(data)                                                   (0x00001F00&((data)<<8))
+#define SYS_PLL_EMMC1_phsel1_src(data)                                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_EMMC1_get_phsel1(data)                                               ((0x00001F00&(data))>>8)
+#define SYS_PLL_EMMC1_phsel0_shift                                                   (3)
+#define SYS_PLL_EMMC1_phsel0_mask                                                    (0x000000F8)
+#define SYS_PLL_EMMC1_phsel0(data)                                                   (0x000000F8&((data)<<3))
+#define SYS_PLL_EMMC1_phsel0_src(data)                                               ((0x000000F8&(data))>>3)
+#define SYS_PLL_EMMC1_get_phsel0(data)                                               ((0x000000F8&(data))>>3)
+#define SYS_PLL_EMMC1_phrstb_dly_sel_shift                                           (2)
+#define SYS_PLL_EMMC1_phrstb_dly_sel_mask                                            (0x00000004)
+#define SYS_PLL_EMMC1_phrstb_dly_sel(data)                                           (0x00000004&((data)<<2))
+#define SYS_PLL_EMMC1_phrstb_dly_sel_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC1_get_phrstb_dly_sel(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC1_phrt0_shift                                                    (1)
+#define SYS_PLL_EMMC1_phrt0_mask                                                     (0x00000002)
+#define SYS_PLL_EMMC1_phrt0(data)                                                    (0x00000002&((data)<<1))
+#define SYS_PLL_EMMC1_phrt0_src(data)                                                ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC1_get_phrt0(data)                                                ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC1_bias_en_shift                                                  (0)
+#define SYS_PLL_EMMC1_bias_en_mask                                                   (0x00000001)
+#define SYS_PLL_EMMC1_bias_en(data)                                                  (0x00000001&((data)<<0))
+#define SYS_PLL_EMMC1_bias_en_src(data)                                              ((0x00000001&(data))>>0)
+#define SYS_PLL_EMMC1_get_bias_en(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EMMC2                                                                0x180001F4
+#define SYS_PLL_EMMC2_reg_addr                                                       "0xB80001F4"
+#define SYS_PLL_EMMC2_reg                                                            0xB80001F4
+#define set_SYS_PLL_EMMC2_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC2_reg)=data)
+#define get_SYS_PLL_EMMC2_reg   (*((volatile unsigned int*) SYS_PLL_EMMC2_reg))
+#define SYS_PLL_EMMC2_inst_adr                                                       "0x007D"
+#define SYS_PLL_EMMC2_inst                                                           0x007D
+#define SYS_PLL_EMMC2_en_cpnew_shift                                                 (26)
+#define SYS_PLL_EMMC2_en_cpnew_mask                                                  (0x04000000)
+#define SYS_PLL_EMMC2_en_cpnew(data)                                                 (0x04000000&((data)<<26))
+#define SYS_PLL_EMMC2_en_cpnew_src(data)                                             ((0x04000000&(data))>>26)
+#define SYS_PLL_EMMC2_get_en_cpnew(data)                                             ((0x04000000&(data))>>26)
+#define SYS_PLL_EMMC2_ssc_div_ext_f_shift                                            (18)
+#define SYS_PLL_EMMC2_ssc_div_ext_f_mask                                             (0x03FC0000)
+#define SYS_PLL_EMMC2_ssc_div_ext_f(data)                                            (0x03FC0000&((data)<<18))
+#define SYS_PLL_EMMC2_ssc_div_ext_f_src(data)                                        ((0x03FC0000&(data))>>18)
+#define SYS_PLL_EMMC2_get_ssc_div_ext_f(data)                                        ((0x03FC0000&(data))>>18)
+#define SYS_PLL_EMMC2_ssc_div_f_sel_shift                                            (17)
+#define SYS_PLL_EMMC2_ssc_div_f_sel_mask                                             (0x00020000)
+#define SYS_PLL_EMMC2_ssc_div_f_sel(data)                                            (0x00020000&((data)<<17))
+#define SYS_PLL_EMMC2_ssc_div_f_sel_src(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PLL_EMMC2_get_ssc_div_f_sel(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PLL_EMMC2_ssc_8x_en_shift                                                (16)
+#define SYS_PLL_EMMC2_ssc_8x_en_mask                                                 (0x00010000)
+#define SYS_PLL_EMMC2_ssc_8x_en(data)                                                (0x00010000&((data)<<16))
+#define SYS_PLL_EMMC2_ssc_8x_en_src(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_EMMC2_get_ssc_8x_en(data)                                            ((0x00010000&(data))>>16)
+#define SYS_PLL_EMMC2_ssc_depth_shift                                                (13)
+#define SYS_PLL_EMMC2_ssc_depth_mask                                                 (0x0000E000)
+#define SYS_PLL_EMMC2_ssc_depth(data)                                                (0x0000E000&((data)<<13))
+#define SYS_PLL_EMMC2_ssc_depth_src(data)                                            ((0x0000E000&(data))>>13)
+#define SYS_PLL_EMMC2_get_ssc_depth(data)                                            ((0x0000E000&(data))>>13)
+#define SYS_PLL_EMMC2_sscpll_rs_shift                                                (10)
+#define SYS_PLL_EMMC2_sscpll_rs_mask                                                 (0x00001C00)
+#define SYS_PLL_EMMC2_sscpll_rs(data)                                                (0x00001C00&((data)<<10))
+#define SYS_PLL_EMMC2_sscpll_rs_src(data)                                            ((0x00001C00&(data))>>10)
+#define SYS_PLL_EMMC2_get_sscpll_rs(data)                                            ((0x00001C00&(data))>>10)
+#define SYS_PLL_EMMC2_sscpll_icp_shift                                               (5)
+#define SYS_PLL_EMMC2_sscpll_icp_mask                                                (0x000003E0)
+#define SYS_PLL_EMMC2_sscpll_icp(data)                                               (0x000003E0&((data)<<5))
+#define SYS_PLL_EMMC2_sscpll_icp_src(data)                                           ((0x000003E0&(data))>>5)
+#define SYS_PLL_EMMC2_get_sscpll_icp(data)                                           ((0x000003E0&(data))>>5)
+#define SYS_PLL_EMMC2_sscpll_cs1_shift                                               (3)
+#define SYS_PLL_EMMC2_sscpll_cs1_mask                                                (0x00000018)
+#define SYS_PLL_EMMC2_sscpll_cs1(data)                                               (0x00000018&((data)<<3))
+#define SYS_PLL_EMMC2_sscpll_cs1_src(data)                                           ((0x00000018&(data))>>3)
+#define SYS_PLL_EMMC2_get_sscpll_cs1(data)                                           ((0x00000018&(data))>>3)
+#define SYS_PLL_EMMC2_reg_tune11_shift                                               (1)
+#define SYS_PLL_EMMC2_reg_tune11_mask                                                (0x00000006)
+#define SYS_PLL_EMMC2_reg_tune11(data)                                               (0x00000006&((data)<<1))
+#define SYS_PLL_EMMC2_reg_tune11_src(data)                                           ((0x00000006&(data))>>1)
+#define SYS_PLL_EMMC2_get_reg_tune11(data)                                           ((0x00000006&(data))>>1)
+#define SYS_PLL_EMMC2_sscldo_en_shift                                                (0)
+#define SYS_PLL_EMMC2_sscldo_en_mask                                                 (0x00000001)
+#define SYS_PLL_EMMC2_sscldo_en(data)                                                (0x00000001&((data)<<0))
+#define SYS_PLL_EMMC2_sscldo_en_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_PLL_EMMC2_get_sscldo_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_PLL_EMMC3                                                                0x180001F8
+#define SYS_PLL_EMMC3_reg_addr                                                       "0xB80001F8"
+#define SYS_PLL_EMMC3_reg                                                            0xB80001F8
+#define set_SYS_PLL_EMMC3_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC3_reg)=data)
+#define get_SYS_PLL_EMMC3_reg   (*((volatile unsigned int*) SYS_PLL_EMMC3_reg))
+#define SYS_PLL_EMMC3_inst_adr                                                       "0x007E"
+#define SYS_PLL_EMMC3_inst                                                           0x007E
+#define SYS_PLL_EMMC3_ssc_div_n_shift                                                (16)
+#define SYS_PLL_EMMC3_ssc_div_n_mask                                                 (0x03FF0000)
+#define SYS_PLL_EMMC3_ssc_div_n(data)                                                (0x03FF0000&((data)<<16))
+#define SYS_PLL_EMMC3_ssc_div_n_src(data)                                            ((0x03FF0000&(data))>>16)
+#define SYS_PLL_EMMC3_get_ssc_div_n(data)                                            ((0x03FF0000&(data))>>16)
+#define SYS_PLL_EMMC3_ssc_step_in_shift                                              (8)
+#define SYS_PLL_EMMC3_ssc_step_in_mask                                               (0x00007F00)
+#define SYS_PLL_EMMC3_ssc_step_in(data)                                              (0x00007F00&((data)<<8))
+#define SYS_PLL_EMMC3_ssc_step_in_src(data)                                          ((0x00007F00&(data))>>8)
+#define SYS_PLL_EMMC3_get_ssc_step_in(data)                                          ((0x00007F00&(data))>>8)
+#define SYS_PLL_EMMC3_ssc_tbase_shift                                                (0)
+#define SYS_PLL_EMMC3_ssc_tbase_mask                                                 (0x000000FF)
+#define SYS_PLL_EMMC3_ssc_tbase(data)                                                (0x000000FF&((data)<<0))
+#define SYS_PLL_EMMC3_ssc_tbase_src(data)                                            ((0x000000FF&(data))>>0)
+#define SYS_PLL_EMMC3_get_ssc_tbase(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define SYS_PLL_EMMC4                                                                0x180001FC
+#define SYS_PLL_EMMC4_reg_addr                                                       "0xB80001FC"
+#define SYS_PLL_EMMC4_reg                                                            0xB80001FC
+#define set_SYS_PLL_EMMC4_reg(data)   (*((volatile unsigned int*) SYS_PLL_EMMC4_reg)=data)
+#define get_SYS_PLL_EMMC4_reg   (*((volatile unsigned int*) SYS_PLL_EMMC4_reg))
+#define SYS_PLL_EMMC4_inst_adr                                                       "0x007F"
+#define SYS_PLL_EMMC4_inst                                                           0x007F
+#define SYS_PLL_EMMC4_ssc_pll_pow_shift                                              (2)
+#define SYS_PLL_EMMC4_ssc_pll_pow_mask                                               (0x00000004)
+#define SYS_PLL_EMMC4_ssc_pll_pow(data)                                              (0x00000004&((data)<<2))
+#define SYS_PLL_EMMC4_ssc_pll_pow_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC4_get_ssc_pll_pow(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PLL_EMMC4_ssc_pll_rstb_shift                                             (1)
+#define SYS_PLL_EMMC4_ssc_pll_rstb_mask                                              (0x00000002)
+#define SYS_PLL_EMMC4_ssc_pll_rstb(data)                                             (0x00000002&((data)<<1))
+#define SYS_PLL_EMMC4_ssc_pll_rstb_src(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC4_get_ssc_pll_rstb(data)                                         ((0x00000002&(data))>>1)
+#define SYS_PLL_EMMC4_ssc_rstb_shift                                                 (0)
+#define SYS_PLL_EMMC4_ssc_rstb_mask                                                  (0x00000001)
+#define SYS_PLL_EMMC4_ssc_rstb(data)                                                 (0x00000001&((data)<<0))
+#define SYS_PLL_EMMC4_ssc_rstb_src(data)                                             ((0x00000001&(data))>>0)
+#define SYS_PLL_EMMC4_get_ssc_rstb(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SYS_BG_CTL                                                                   0x18000204
+#define SYS_BG_CTL_reg_addr                                                          "0xB8000204"
+#define SYS_BG_CTL_reg                                                               0xB8000204
+#define set_SYS_BG_CTL_reg(data)   (*((volatile unsigned int*) SYS_BG_CTL_reg)=data)
+#define get_SYS_BG_CTL_reg   (*((volatile unsigned int*) SYS_BG_CTL_reg))
+#define SYS_BG_CTL_inst_adr                                                          "0x0081"
+#define SYS_BG_CTL_inst                                                              0x0081
+#define SYS_BG_CTL_REG_PLL_RESERVED_shift                                            (24)
+#define SYS_BG_CTL_REG_PLL_RESERVED_mask                                             (0xFF000000)
+#define SYS_BG_CTL_REG_PLL_RESERVED(data)                                            (0xFF000000&((data)<<24))
+#define SYS_BG_CTL_REG_PLL_RESERVED_src(data)                                        ((0xFF000000&(data))>>24)
+#define SYS_BG_CTL_get_REG_PLL_RESERVED(data)                                        ((0xFF000000&(data))>>24)
+#define SYS_BG_CTL_REG_LDO1_POW_shift                                                (7)
+#define SYS_BG_CTL_REG_LDO1_POW_mask                                                 (0x00000080)
+#define SYS_BG_CTL_REG_LDO1_POW(data)                                                (0x00000080&((data)<<7))
+#define SYS_BG_CTL_REG_LDO1_POW_src(data)                                            ((0x00000080&(data))>>7)
+#define SYS_BG_CTL_get_REG_LDO1_POW(data)                                            ((0x00000080&(data))>>7)
+#define SYS_BG_CTL_REG_LDO1_SEL_shift                                                (5)
+#define SYS_BG_CTL_REG_LDO1_SEL_mask                                                 (0x00000060)
+#define SYS_BG_CTL_REG_LDO1_SEL(data)                                                (0x00000060&((data)<<5))
+#define SYS_BG_CTL_REG_LDO1_SEL_src(data)                                            ((0x00000060&(data))>>5)
+#define SYS_BG_CTL_get_REG_LDO1_SEL(data)                                            ((0x00000060&(data))>>5)
+#define SYS_BG_CTL_REG_LDO2_POW_shift                                                (4)
+#define SYS_BG_CTL_REG_LDO2_POW_mask                                                 (0x00000010)
+#define SYS_BG_CTL_REG_LDO2_POW(data)                                                (0x00000010&((data)<<4))
+#define SYS_BG_CTL_REG_LDO2_POW_src(data)                                            ((0x00000010&(data))>>4)
+#define SYS_BG_CTL_get_REG_LDO2_POW(data)                                            ((0x00000010&(data))>>4)
+#define SYS_BG_CTL_REG_LDO2_SEL_shift                                                (2)
+#define SYS_BG_CTL_REG_LDO2_SEL_mask                                                 (0x0000000C)
+#define SYS_BG_CTL_REG_LDO2_SEL(data)                                                (0x0000000C&((data)<<2))
+#define SYS_BG_CTL_REG_LDO2_SEL_src(data)                                            ((0x0000000C&(data))>>2)
+#define SYS_BG_CTL_get_REG_LDO2_SEL(data)                                            ((0x0000000C&(data))>>2)
+#define SYS_BG_CTL_VDAC_BGR_shift                                                    (0)
+#define SYS_BG_CTL_VDAC_BGR_mask                                                     (0x00000003)
+#define SYS_BG_CTL_VDAC_BGR(data)                                                    (0x00000003&((data)<<0))
+#define SYS_BG_CTL_VDAC_BGR_src(data)                                                ((0x00000003&(data))>>0)
+#define SYS_BG_CTL_get_VDAC_BGR(data)                                                ((0x00000003&(data))>>0)
+
+
+#define SYS_CHIP_INFO2                                                               0x18000308
+#define SYS_CHIP_INFO2_reg_addr                                                      "0xB8000308"
+#define SYS_CHIP_INFO2_reg                                                           0xB8000308
+#define set_SYS_CHIP_INFO2_reg(data)   (*((volatile unsigned int*) SYS_CHIP_INFO2_reg)=data)
+#define get_SYS_CHIP_INFO2_reg   (*((volatile unsigned int*) SYS_CHIP_INFO2_reg))
+#define SYS_CHIP_INFO2_inst_adr                                                      "0x00C2"
+#define SYS_CHIP_INFO2_inst                                                          0x00C2
+#define SYS_CHIP_INFO2_testmode_shift                                                (2)
+#define SYS_CHIP_INFO2_testmode_mask                                                 (0x00000004)
+#define SYS_CHIP_INFO2_testmode(data)                                                (0x00000004&((data)<<2))
+#define SYS_CHIP_INFO2_testmode_src(data)                                            ((0x00000004&(data))>>2)
+#define SYS_CHIP_INFO2_get_testmode(data)                                            ((0x00000004&(data))>>2)
+#define SYS_CHIP_INFO2_nf_sel_shift                                                  (1)
+#define SYS_CHIP_INFO2_nf_sel_mask                                                   (0x00000002)
+#define SYS_CHIP_INFO2_nf_sel(data)                                                  (0x00000002&((data)<<1))
+#define SYS_CHIP_INFO2_nf_sel_src(data)                                              ((0x00000002&(data))>>1)
+#define SYS_CHIP_INFO2_get_nf_sel(data)                                              ((0x00000002&(data))>>1)
+#define SYS_CHIP_INFO2_boot_sel_shift                                                (0)
+#define SYS_CHIP_INFO2_boot_sel_mask                                                 (0x00000001)
+#define SYS_CHIP_INFO2_boot_sel(data)                                                (0x00000001&((data)<<0))
+#define SYS_CHIP_INFO2_boot_sel_src(data)                                            ((0x00000001&(data))>>0)
+#define SYS_CHIP_INFO2_get_boot_sel(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SYS_SCPU_L2                                                                  0x1800030C
+#define SYS_SCPU_L2_reg_addr                                                         "0xB800030C"
+#define SYS_SCPU_L2_reg                                                              0xB800030C
+#define set_SYS_SCPU_L2_reg(data)   (*((volatile unsigned int*) SYS_SCPU_L2_reg)=data)
+#define get_SYS_SCPU_L2_reg   (*((volatile unsigned int*) SYS_SCPU_L2_reg))
+#define SYS_SCPU_L2_inst_adr                                                         "0x00C3"
+#define SYS_SCPU_L2_inst                                                             0x00C3
+#define SYS_SCPU_L2_scpu_l2_bypass_shift                                             (0)
+#define SYS_SCPU_L2_scpu_l2_bypass_mask                                              (0x00000001)
+#define SYS_SCPU_L2_scpu_l2_bypass(data)                                             (0x00000001&((data)<<0))
+#define SYS_SCPU_L2_scpu_l2_bypass_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_SCPU_L2_get_scpu_l2_bypass(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_THML_SNSR_CTRL                                                           0x18000310
+#define SYS_THML_SNSR_CTRL_reg_addr                                                  "0xB8000310"
+#define SYS_THML_SNSR_CTRL_reg                                                       0xB8000310
+#define set_SYS_THML_SNSR_CTRL_reg(data)   (*((volatile unsigned int*) SYS_THML_SNSR_CTRL_reg)=data)
+#define get_SYS_THML_SNSR_CTRL_reg   (*((volatile unsigned int*) SYS_THML_SNSR_CTRL_reg))
+#define SYS_THML_SNSR_CTRL_inst_adr                                                  "0x00C4"
+#define SYS_THML_SNSR_CTRL_inst                                                      0x00C4
+#define SYS_THML_SNSR_CTRL_CMP_OUT1_shift                                            (16)
+#define SYS_THML_SNSR_CTRL_CMP_OUT1_mask                                             (0x00010000)
+#define SYS_THML_SNSR_CTRL_CMP_OUT1(data)                                            (0x00010000&((data)<<16))
+#define SYS_THML_SNSR_CTRL_CMP_OUT1_src(data)                                        ((0x00010000&(data))>>16)
+#define SYS_THML_SNSR_CTRL_get_CMP_OUT1(data)                                        ((0x00010000&(data))>>16)
+#define SYS_THML_SNSR_CTRL_PWDB1_shift                                               (15)
+#define SYS_THML_SNSR_CTRL_PWDB1_mask                                                (0x00008000)
+#define SYS_THML_SNSR_CTRL_PWDB1(data)                                               (0x00008000&((data)<<15))
+#define SYS_THML_SNSR_CTRL_PWDB1_src(data)                                           ((0x00008000&(data))>>15)
+#define SYS_THML_SNSR_CTRL_get_PWDB1(data)                                           ((0x00008000&(data))>>15)
+#define SYS_THML_SNSR_CTRL_SBG1_shift                                                (12)
+#define SYS_THML_SNSR_CTRL_SBG1_mask                                                 (0x00007000)
+#define SYS_THML_SNSR_CTRL_SBG1(data)                                                (0x00007000&((data)<<12))
+#define SYS_THML_SNSR_CTRL_SBG1_src(data)                                            ((0x00007000&(data))>>12)
+#define SYS_THML_SNSR_CTRL_get_SBG1(data)                                            ((0x00007000&(data))>>12)
+#define SYS_THML_SNSR_CTRL_SDATA1_shift                                              (5)
+#define SYS_THML_SNSR_CTRL_SDATA1_mask                                               (0x00000FE0)
+#define SYS_THML_SNSR_CTRL_SDATA1(data)                                              (0x00000FE0&((data)<<5))
+#define SYS_THML_SNSR_CTRL_SDATA1_src(data)                                          ((0x00000FE0&(data))>>5)
+#define SYS_THML_SNSR_CTRL_get_SDATA1(data)                                          ((0x00000FE0&(data))>>5)
+#define SYS_THML_SNSR_CTRL_SINL1_shift                                               (3)
+#define SYS_THML_SNSR_CTRL_SINL1_mask                                                (0x00000018)
+#define SYS_THML_SNSR_CTRL_SINL1(data)                                               (0x00000018&((data)<<3))
+#define SYS_THML_SNSR_CTRL_SINL1_src(data)                                           ((0x00000018&(data))>>3)
+#define SYS_THML_SNSR_CTRL_get_SINL1(data)                                           ((0x00000018&(data))>>3)
+#define SYS_THML_SNSR_CTRL_SOS1_shift                                                (0)
+#define SYS_THML_SNSR_CTRL_SOS1_mask                                                 (0x00000007)
+#define SYS_THML_SNSR_CTRL_SOS1(data)                                                (0x00000007&((data)<<0))
+#define SYS_THML_SNSR_CTRL_SOS1_src(data)                                            ((0x00000007&(data))>>0)
+#define SYS_THML_SNSR_CTRL_get_SOS1(data)                                            ((0x00000007&(data))>>0)
+
+
+#define SYS_THML_SNSR_CTRL2                                                          0x18000314
+#define SYS_THML_SNSR_CTRL2_reg_addr                                                 "0xB8000314"
+#define SYS_THML_SNSR_CTRL2_reg                                                      0xB8000314
+#define set_SYS_THML_SNSR_CTRL2_reg(data)   (*((volatile unsigned int*) SYS_THML_SNSR_CTRL2_reg)=data)
+#define get_SYS_THML_SNSR_CTRL2_reg   (*((volatile unsigned int*) SYS_THML_SNSR_CTRL2_reg))
+#define SYS_THML_SNSR_CTRL2_inst_adr                                                 "0x00C5"
+#define SYS_THML_SNSR_CTRL2_inst                                                     0x00C5
+#define SYS_THML_SNSR_CTRL2_CMP_OUT2_shift                                           (16)
+#define SYS_THML_SNSR_CTRL2_CMP_OUT2_mask                                            (0x00010000)
+#define SYS_THML_SNSR_CTRL2_CMP_OUT2(data)                                           (0x00010000&((data)<<16))
+#define SYS_THML_SNSR_CTRL2_CMP_OUT2_src(data)                                       ((0x00010000&(data))>>16)
+#define SYS_THML_SNSR_CTRL2_get_CMP_OUT2(data)                                       ((0x00010000&(data))>>16)
+#define SYS_THML_SNSR_CTRL2_PWDB2_shift                                              (15)
+#define SYS_THML_SNSR_CTRL2_PWDB2_mask                                               (0x00008000)
+#define SYS_THML_SNSR_CTRL2_PWDB2(data)                                              (0x00008000&((data)<<15))
+#define SYS_THML_SNSR_CTRL2_PWDB2_src(data)                                          ((0x00008000&(data))>>15)
+#define SYS_THML_SNSR_CTRL2_get_PWDB2(data)                                          ((0x00008000&(data))>>15)
+#define SYS_THML_SNSR_CTRL2_SBG2_shift                                               (12)
+#define SYS_THML_SNSR_CTRL2_SBG2_mask                                                (0x00007000)
+#define SYS_THML_SNSR_CTRL2_SBG2(data)                                               (0x00007000&((data)<<12))
+#define SYS_THML_SNSR_CTRL2_SBG2_src(data)                                           ((0x00007000&(data))>>12)
+#define SYS_THML_SNSR_CTRL2_get_SBG2(data)                                           ((0x00007000&(data))>>12)
+#define SYS_THML_SNSR_CTRL2_SDATA2_shift                                             (5)
+#define SYS_THML_SNSR_CTRL2_SDATA2_mask                                              (0x00000FE0)
+#define SYS_THML_SNSR_CTRL2_SDATA2(data)                                             (0x00000FE0&((data)<<5))
+#define SYS_THML_SNSR_CTRL2_SDATA2_src(data)                                         ((0x00000FE0&(data))>>5)
+#define SYS_THML_SNSR_CTRL2_get_SDATA2(data)                                         ((0x00000FE0&(data))>>5)
+#define SYS_THML_SNSR_CTRL2_SINL2_shift                                              (3)
+#define SYS_THML_SNSR_CTRL2_SINL2_mask                                               (0x00000018)
+#define SYS_THML_SNSR_CTRL2_SINL2(data)                                              (0x00000018&((data)<<3))
+#define SYS_THML_SNSR_CTRL2_SINL2_src(data)                                          ((0x00000018&(data))>>3)
+#define SYS_THML_SNSR_CTRL2_get_SINL2(data)                                          ((0x00000018&(data))>>3)
+#define SYS_THML_SNSR_CTRL2_SOS2_shift                                               (0)
+#define SYS_THML_SNSR_CTRL2_SOS2_mask                                                (0x00000007)
+#define SYS_THML_SNSR_CTRL2_SOS2(data)                                               (0x00000007&((data)<<0))
+#define SYS_THML_SNSR_CTRL2_SOS2_src(data)                                           ((0x00000007&(data))>>0)
+#define SYS_THML_SNSR_CTRL2_get_SOS2(data)                                           ((0x00000007&(data))>>0)
+
+
+#define SYS_PWDN_CTRL                                                                0x18000320
+#define SYS_PWDN_CTRL_reg_addr                                                       "0xB8000320"
+#define SYS_PWDN_CTRL_reg                                                            0xB8000320
+#define set_SYS_PWDN_CTRL_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL_reg)=data)
+#define get_SYS_PWDN_CTRL_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL_reg))
+#define SYS_PWDN_CTRL_inst_adr                                                       "0x00C8"
+#define SYS_PWDN_CTRL_inst                                                           0x00C8
+#define SYS_PWDN_CTRL_scpu_boot_info_shift                                           (0)
+#define SYS_PWDN_CTRL_scpu_boot_info_mask                                            (0xFFFFFFFF)
+#define SYS_PWDN_CTRL_scpu_boot_info(data)                                           (0xFFFFFFFF&((data)<<0))
+#define SYS_PWDN_CTRL_scpu_boot_info_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define SYS_PWDN_CTRL_get_scpu_boot_info(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_PWDN_CTRL2                                                               0x18000324
+#define SYS_PWDN_CTRL2_reg_addr                                                      "0xB8000324"
+#define SYS_PWDN_CTRL2_reg                                                           0xB8000324
+#define set_SYS_PWDN_CTRL2_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL2_reg)=data)
+#define get_SYS_PWDN_CTRL2_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL2_reg))
+#define SYS_PWDN_CTRL2_inst_adr                                                      "0x00C9"
+#define SYS_PWDN_CTRL2_inst                                                          0x00C9
+#define SYS_PWDN_CTRL2_acpu_boot_info_shift                                          (0)
+#define SYS_PWDN_CTRL2_acpu_boot_info_mask                                           (0xFFFFFFFF)
+#define SYS_PWDN_CTRL2_acpu_boot_info(data)                                          (0xFFFFFFFF&((data)<<0))
+#define SYS_PWDN_CTRL2_acpu_boot_info_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define SYS_PWDN_CTRL2_get_acpu_boot_info(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_PWDN_CTRL3                                                               0x18000328
+#define SYS_PWDN_CTRL3_reg_addr                                                      "0xB8000328"
+#define SYS_PWDN_CTRL3_reg                                                           0xB8000328
+#define set_SYS_PWDN_CTRL3_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL3_reg)=data)
+#define get_SYS_PWDN_CTRL3_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL3_reg))
+#define SYS_PWDN_CTRL3_inst_adr                                                      "0x00CA"
+#define SYS_PWDN_CTRL3_inst                                                          0x00CA
+#define SYS_PWDN_CTRL3_write_en2_shift                                               (3)
+#define SYS_PWDN_CTRL3_write_en2_mask                                                (0x00000008)
+#define SYS_PWDN_CTRL3_write_en2(data)                                               (0x00000008&((data)<<3))
+#define SYS_PWDN_CTRL3_write_en2_src(data)                                           ((0x00000008&(data))>>3)
+#define SYS_PWDN_CTRL3_get_write_en2(data)                                           ((0x00000008&(data))>>3)
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid_shift                                    (2)
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid_mask                                     (0x00000004)
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid(data)                                    (0x00000004&((data)<<2))
+#define SYS_PWDN_CTRL3_scpu_boot_info_valid_src(data)                                ((0x00000004&(data))>>2)
+#define SYS_PWDN_CTRL3_get_scpu_boot_info_valid(data)                                ((0x00000004&(data))>>2)
+#define SYS_PWDN_CTRL3_write_en1_shift                                               (1)
+#define SYS_PWDN_CTRL3_write_en1_mask                                                (0x00000002)
+#define SYS_PWDN_CTRL3_write_en1(data)                                               (0x00000002&((data)<<1))
+#define SYS_PWDN_CTRL3_write_en1_src(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PWDN_CTRL3_get_write_en1(data)                                           ((0x00000002&(data))>>1)
+#define SYS_PWDN_CTRL3_scpu_sw_rst_shift                                             (0)
+#define SYS_PWDN_CTRL3_scpu_sw_rst_mask                                              (0x00000001)
+#define SYS_PWDN_CTRL3_scpu_sw_rst(data)                                             (0x00000001&((data)<<0))
+#define SYS_PWDN_CTRL3_scpu_sw_rst_src(data)                                         ((0x00000001&(data))>>0)
+#define SYS_PWDN_CTRL3_get_scpu_sw_rst(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SYS_PWDN_CTRL4                                                               0x1800032C
+#define SYS_PWDN_CTRL4_reg_addr                                                      "0xB800032C"
+#define SYS_PWDN_CTRL4_reg                                                           0xB800032C
+#define set_SYS_PWDN_CTRL4_reg(data)   (*((volatile unsigned int*) SYS_PWDN_CTRL4_reg)=data)
+#define get_SYS_PWDN_CTRL4_reg   (*((volatile unsigned int*) SYS_PWDN_CTRL4_reg))
+#define SYS_PWDN_CTRL4_inst_adr                                                      "0x00CB"
+#define SYS_PWDN_CTRL4_inst                                                          0x00CB
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid_shift                                    (0)
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid_mask                                     (0x00000001)
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid(data)                                    (0x00000001&((data)<<0))
+#define SYS_PWDN_CTRL4_acpu_boot_info_valid_src(data)                                ((0x00000001&(data))>>0)
+#define SYS_PWDN_CTRL4_get_acpu_boot_info_valid(data)                                ((0x00000001&(data))>>0)
+
+
+#define SYS_AT_SPEED                                                                 0x18000330
+#define SYS_AT_SPEED_reg_addr                                                        "0xB8000330"
+#define SYS_AT_SPEED_reg                                                             0xB8000330
+#define set_SYS_AT_SPEED_reg(data)   (*((volatile unsigned int*) SYS_AT_SPEED_reg)=data)
+#define get_SYS_AT_SPEED_reg   (*((volatile unsigned int*) SYS_AT_SPEED_reg))
+#define SYS_AT_SPEED_inst_adr                                                        "0x00CC"
+#define SYS_AT_SPEED_inst                                                            0x00CC
+#define SYS_AT_SPEED_write_en2_shift                                                 (3)
+#define SYS_AT_SPEED_write_en2_mask                                                  (0x00000008)
+#define SYS_AT_SPEED_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define SYS_AT_SPEED_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define SYS_AT_SPEED_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define SYS_AT_SPEED_dac_test_shift                                                  (2)
+#define SYS_AT_SPEED_dac_test_mask                                                   (0x00000004)
+#define SYS_AT_SPEED_dac_test(data)                                                  (0x00000004&((data)<<2))
+#define SYS_AT_SPEED_dac_test_src(data)                                              ((0x00000004&(data))>>2)
+#define SYS_AT_SPEED_get_dac_test(data)                                              ((0x00000004&(data))>>2)
+#define SYS_AT_SPEED_write_en1_shift                                                 (1)
+#define SYS_AT_SPEED_write_en1_mask                                                  (0x00000002)
+#define SYS_AT_SPEED_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define SYS_AT_SPEED_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define SYS_AT_SPEED_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define SYS_AT_SPEED_scpu_config_done_shift                                          (0)
+#define SYS_AT_SPEED_scpu_config_done_mask                                           (0x00000001)
+#define SYS_AT_SPEED_scpu_config_done(data)                                          (0x00000001&((data)<<0))
+#define SYS_AT_SPEED_scpu_config_done_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_AT_SPEED_get_scpu_config_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_ANA_CTRL                                                                 0x18000334
+#define SYS_ANA_CTRL_reg_addr                                                        "0xB8000334"
+#define SYS_ANA_CTRL_reg                                                             0xB8000334
+#define set_SYS_ANA_CTRL_reg(data)   (*((volatile unsigned int*) SYS_ANA_CTRL_reg)=data)
+#define get_SYS_ANA_CTRL_reg   (*((volatile unsigned int*) SYS_ANA_CTRL_reg))
+#define SYS_ANA_CTRL_inst_adr                                                        "0x00CD"
+#define SYS_ANA_CTRL_inst                                                            0x00CD
+#define SYS_ANA_CTRL_write_en2_shift                                                 (3)
+#define SYS_ANA_CTRL_write_en2_mask                                                  (0x00000008)
+#define SYS_ANA_CTRL_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define SYS_ANA_CTRL_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define SYS_ANA_CTRL_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define SYS_ANA_CTRL_etn_phy_gpio_en_shift                                           (2)
+#define SYS_ANA_CTRL_etn_phy_gpio_en_mask                                            (0x00000004)
+#define SYS_ANA_CTRL_etn_phy_gpio_en(data)                                           (0x00000004&((data)<<2))
+#define SYS_ANA_CTRL_etn_phy_gpio_en_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_ANA_CTRL_get_etn_phy_gpio_en(data)                                       ((0x00000004&(data))>>2)
+#define SYS_ANA_CTRL_write_en1_shift                                                 (1)
+#define SYS_ANA_CTRL_write_en1_mask                                                  (0x00000002)
+#define SYS_ANA_CTRL_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define SYS_ANA_CTRL_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define SYS_ANA_CTRL_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define SYS_ANA_CTRL_etn_phy_125m_en_shift                                           (0)
+#define SYS_ANA_CTRL_etn_phy_125m_en_mask                                            (0x00000001)
+#define SYS_ANA_CTRL_etn_phy_125m_en(data)                                           (0x00000001&((data)<<0))
+#define SYS_ANA_CTRL_etn_phy_125m_en_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_ANA_CTRL_get_etn_phy_125m_en(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_TP_DEMOD_CTRL                                                            0x18000338
+#define SYS_TP_DEMOD_CTRL_reg_addr                                                   "0xB8000338"
+#define SYS_TP_DEMOD_CTRL_reg                                                        0xB8000338
+#define set_SYS_TP_DEMOD_CTRL_reg(data)   (*((volatile unsigned int*) SYS_TP_DEMOD_CTRL_reg)=data)
+#define get_SYS_TP_DEMOD_CTRL_reg   (*((volatile unsigned int*) SYS_TP_DEMOD_CTRL_reg))
+#define SYS_TP_DEMOD_CTRL_inst_adr                                                   "0x00CE"
+#define SYS_TP_DEMOD_CTRL_inst                                                       0x00CE
+#define SYS_TP_DEMOD_CTRL_demod_i2c_saddr_shift                                      (4)
+#define SYS_TP_DEMOD_CTRL_demod_i2c_saddr_mask                                       (0x00000010)
+#define SYS_TP_DEMOD_CTRL_demod_i2c_saddr(data)                                      (0x00000010&((data)<<4))
+#define SYS_TP_DEMOD_CTRL_demod_i2c_saddr_src(data)                                  ((0x00000010&(data))>>4)
+#define SYS_TP_DEMOD_CTRL_get_demod_i2c_saddr(data)                                  ((0x00000010&(data))>>4)
+#define SYS_TP_DEMOD_CTRL_demod_i2c_sel_shift                                        (3)
+#define SYS_TP_DEMOD_CTRL_demod_i2c_sel_mask                                         (0x00000008)
+#define SYS_TP_DEMOD_CTRL_demod_i2c_sel(data)                                        (0x00000008&((data)<<3))
+#define SYS_TP_DEMOD_CTRL_demod_i2c_sel_src(data)                                    ((0x00000008&(data))>>3)
+#define SYS_TP_DEMOD_CTRL_get_demod_i2c_sel(data)                                    ((0x00000008&(data))>>3)
+#define SYS_TP_DEMOD_CTRL_tp2_dm_sel_shift                                           (2)
+#define SYS_TP_DEMOD_CTRL_tp2_dm_sel_mask                                            (0x00000004)
+#define SYS_TP_DEMOD_CTRL_tp2_dm_sel(data)                                           (0x00000004&((data)<<2))
+#define SYS_TP_DEMOD_CTRL_tp2_dm_sel_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_TP_DEMOD_CTRL_get_tp2_dm_sel(data)                                       ((0x00000004&(data))>>2)
+#define SYS_TP_DEMOD_CTRL_tp1_dm_sel_shift                                           (1)
+#define SYS_TP_DEMOD_CTRL_tp1_dm_sel_mask                                            (0x00000002)
+#define SYS_TP_DEMOD_CTRL_tp1_dm_sel(data)                                           (0x00000002&((data)<<1))
+#define SYS_TP_DEMOD_CTRL_tp1_dm_sel_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_TP_DEMOD_CTRL_get_tp1_dm_sel(data)                                       ((0x00000002&(data))>>1)
+#define SYS_TP_DEMOD_CTRL_tp0_dm_sel_shift                                           (0)
+#define SYS_TP_DEMOD_CTRL_tp0_dm_sel_mask                                            (0x00000001)
+#define SYS_TP_DEMOD_CTRL_tp0_dm_sel(data)                                           (0x00000001&((data)<<0))
+#define SYS_TP_DEMOD_CTRL_tp0_dm_sel_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_TP_DEMOD_CTRL_get_tp0_dm_sel(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_PHY_FUNC                                                                 0x18000340
+#define SYS_PHY_FUNC_reg_addr                                                        "0xB8000340"
+#define SYS_PHY_FUNC_reg                                                             0xB8000340
+#define set_SYS_PHY_FUNC_reg(data)   (*((volatile unsigned int*) SYS_PHY_FUNC_reg)=data)
+#define get_SYS_PHY_FUNC_reg   (*((volatile unsigned int*) SYS_PHY_FUNC_reg))
+#define SYS_PHY_FUNC_inst_adr                                                        "0x00D0"
+#define SYS_PHY_FUNC_inst                                                            0x00D0
+#define SYS_PHY_FUNC_sata0_func_exist_shift                                          (0)
+#define SYS_PHY_FUNC_sata0_func_exist_mask                                           (0x00000001)
+#define SYS_PHY_FUNC_sata0_func_exist(data)                                          (0x00000001&((data)<<0))
+#define SYS_PHY_FUNC_sata0_func_exist_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PHY_FUNC_get_sata0_func_exist(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_ANLG                                                                     0x18000344
+#define SYS_ANLG_reg_addr                                                            "0xB8000344"
+#define SYS_ANLG_reg                                                                 0xB8000344
+#define set_SYS_ANLG_reg(data)   (*((volatile unsigned int*) SYS_ANLG_reg)=data)
+#define get_SYS_ANLG_reg   (*((volatile unsigned int*) SYS_ANLG_reg))
+#define SYS_ANLG_inst_adr                                                            "0x00D1"
+#define SYS_ANLG_inst                                                                0x00D1
+#define SYS_ANLG_analogy_mode_sel_shift                                              (0)
+#define SYS_ANLG_analogy_mode_sel_mask                                               (0x00000003)
+#define SYS_ANLG_analogy_mode_sel(data)                                              (0x00000003&((data)<<0))
+#define SYS_ANLG_analogy_mode_sel_src(data)                                          ((0x00000003&(data))>>0)
+#define SYS_ANLG_get_analogy_mode_sel(data)                                          ((0x00000003&(data))>>0)
+
+
+#define SYS_DMY2                                                                     0x18000348
+#define SYS_DMY2_reg_addr                                                            "0xB8000348"
+#define SYS_DMY2_reg                                                                 0xB8000348
+#define set_SYS_DMY2_reg(data)   (*((volatile unsigned int*) SYS_DMY2_reg)=data)
+#define get_SYS_DMY2_reg   (*((volatile unsigned int*) SYS_DMY2_reg))
+#define SYS_DMY2_inst_adr                                                            "0x00D2"
+#define SYS_DMY2_inst                                                                0x00D2
+#define SYS_DMY2_Rvd1_shift                                                          (0)
+#define SYS_DMY2_Rvd1_mask                                                           (0xFFFFFFFF)
+#define SYS_DMY2_Rvd1(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define SYS_DMY2_Rvd1_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define SYS_DMY2_get_Rvd1(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define SYS_RGMII_PAD                                                                0x1800034C
+#define SYS_RGMII_PAD_reg_addr                                                       "0xB800034C"
+#define SYS_RGMII_PAD_reg                                                            0xB800034C
+#define set_SYS_RGMII_PAD_reg(data)   (*((volatile unsigned int*) SYS_RGMII_PAD_reg)=data)
+#define get_SYS_RGMII_PAD_reg   (*((volatile unsigned int*) SYS_RGMII_PAD_reg))
+#define SYS_RGMII_PAD_inst_adr                                                       "0x00D3"
+#define SYS_RGMII_PAD_inst                                                           0x00D3
+#define SYS_RGMII_PAD_DP_shift                                                       (4)
+#define SYS_RGMII_PAD_DP_mask                                                        (0x00000070)
+#define SYS_RGMII_PAD_DP(data)                                                       (0x00000070&((data)<<4))
+#define SYS_RGMII_PAD_DP_src(data)                                                   ((0x00000070&(data))>>4)
+#define SYS_RGMII_PAD_get_DP(data)                                                   ((0x00000070&(data))>>4)
+#define SYS_RGMII_PAD_DN_shift                                                       (0)
+#define SYS_RGMII_PAD_DN_mask                                                        (0x00000007)
+#define SYS_RGMII_PAD_DN(data)                                                       (0x00000007&((data)<<0))
+#define SYS_RGMII_PAD_DN_src(data)                                                   ((0x00000007&(data))>>0)
+#define SYS_RGMII_PAD_get_DN(data)                                                   ((0x00000007&(data))>>0)
+
+
+#define SYS_MUXPAD0                                                                  0x18000360
+#define SYS_MUXPAD0_reg_addr                                                         "0xB8000360"
+#define SYS_MUXPAD0_reg                                                              0xB8000360
+#define set_SYS_MUXPAD0_reg(data)   (*((volatile unsigned int*) SYS_MUXPAD0_reg)=data)
+#define get_SYS_MUXPAD0_reg   (*((volatile unsigned int*) SYS_MUXPAD0_reg))
+#define SYS_MUXPAD0_inst_adr                                                         "0x00D8"
+#define SYS_MUXPAD0_inst                                                             0x00D8
+#define SYS_MUXPAD0_nf_dd_7_shift                                                    (30)
+#define SYS_MUXPAD0_nf_dd_7_mask                                                     (0xC0000000)
+#define SYS_MUXPAD0_nf_dd_7(data)                                                    (0xC0000000&((data)<<30))
+#define SYS_MUXPAD0_nf_dd_7_src(data)                                                ((0xC0000000&(data))>>30)
+#define SYS_MUXPAD0_get_nf_dd_7(data)                                                ((0xC0000000&(data))>>30)
+#define SYS_MUXPAD0_nf_dd_6_shift                                                    (28)
+#define SYS_MUXPAD0_nf_dd_6_mask                                                     (0x30000000)
+#define SYS_MUXPAD0_nf_dd_6(data)                                                    (0x30000000&((data)<<28))
+#define SYS_MUXPAD0_nf_dd_6_src(data)                                                ((0x30000000&(data))>>28)
+#define SYS_MUXPAD0_get_nf_dd_6(data)                                                ((0x30000000&(data))>>28)
+#define SYS_MUXPAD0_nf_dd_5_shift                                                    (26)
+#define SYS_MUXPAD0_nf_dd_5_mask                                                     (0x0C000000)
+#define SYS_MUXPAD0_nf_dd_5(data)                                                    (0x0C000000&((data)<<26))
+#define SYS_MUXPAD0_nf_dd_5_src(data)                                                ((0x0C000000&(data))>>26)
+#define SYS_MUXPAD0_get_nf_dd_5(data)                                                ((0x0C000000&(data))>>26)
+#define SYS_MUXPAD0_nf_dd_4_shift                                                    (24)
+#define SYS_MUXPAD0_nf_dd_4_mask                                                     (0x03000000)
+#define SYS_MUXPAD0_nf_dd_4(data)                                                    (0x03000000&((data)<<24))
+#define SYS_MUXPAD0_nf_dd_4_src(data)                                                ((0x03000000&(data))>>24)
+#define SYS_MUXPAD0_get_nf_dd_4(data)                                                ((0x03000000&(data))>>24)
+#define SYS_MUXPAD0_nf_dd_3_shift                                                    (22)
+#define SYS_MUXPAD0_nf_dd_3_mask                                                     (0x00C00000)
+#define SYS_MUXPAD0_nf_dd_3(data)                                                    (0x00C00000&((data)<<22))
+#define SYS_MUXPAD0_nf_dd_3_src(data)                                                ((0x00C00000&(data))>>22)
+#define SYS_MUXPAD0_get_nf_dd_3(data)                                                ((0x00C00000&(data))>>22)
+#define SYS_MUXPAD0_nf_dd_2_shift                                                    (20)
+#define SYS_MUXPAD0_nf_dd_2_mask                                                     (0x00300000)
+#define SYS_MUXPAD0_nf_dd_2(data)                                                    (0x00300000&((data)<<20))
+#define SYS_MUXPAD0_nf_dd_2_src(data)                                                ((0x00300000&(data))>>20)
+#define SYS_MUXPAD0_get_nf_dd_2(data)                                                ((0x00300000&(data))>>20)
+#define SYS_MUXPAD0_nf_dd_1_shift                                                    (18)
+#define SYS_MUXPAD0_nf_dd_1_mask                                                     (0x000C0000)
+#define SYS_MUXPAD0_nf_dd_1(data)                                                    (0x000C0000&((data)<<18))
+#define SYS_MUXPAD0_nf_dd_1_src(data)                                                ((0x000C0000&(data))>>18)
+#define SYS_MUXPAD0_get_nf_dd_1(data)                                                ((0x000C0000&(data))>>18)
+#define SYS_MUXPAD0_nf_dd_0_shift                                                    (16)
+#define SYS_MUXPAD0_nf_dd_0_mask                                                     (0x00030000)
+#define SYS_MUXPAD0_nf_dd_0(data)                                                    (0x00030000&((data)<<16))
+#define SYS_MUXPAD0_nf_dd_0_src(data)                                                ((0x00030000&(data))>>16)
+#define SYS_MUXPAD0_get_nf_dd_0(data)                                                ((0x00030000&(data))>>16)
+#define SYS_MUXPAD0_nf_ce_n_1_shift                                                  (14)
+#define SYS_MUXPAD0_nf_ce_n_1_mask                                                   (0x0000C000)
+#define SYS_MUXPAD0_nf_ce_n_1(data)                                                  (0x0000C000&((data)<<14))
+#define SYS_MUXPAD0_nf_ce_n_1_src(data)                                              ((0x0000C000&(data))>>14)
+#define SYS_MUXPAD0_get_nf_ce_n_1(data)                                              ((0x0000C000&(data))>>14)
+#define SYS_MUXPAD0_nf_ce_n_0_shift                                                  (12)
+#define SYS_MUXPAD0_nf_ce_n_0_mask                                                   (0x00003000)
+#define SYS_MUXPAD0_nf_ce_n_0(data)                                                  (0x00003000&((data)<<12))
+#define SYS_MUXPAD0_nf_ce_n_0_src(data)                                              ((0x00003000&(data))>>12)
+#define SYS_MUXPAD0_get_nf_ce_n_0(data)                                              ((0x00003000&(data))>>12)
+#define SYS_MUXPAD0_nf_cle_shift                                                     (10)
+#define SYS_MUXPAD0_nf_cle_mask                                                      (0x00000C00)
+#define SYS_MUXPAD0_nf_cle(data)                                                     (0x00000C00&((data)<<10))
+#define SYS_MUXPAD0_nf_cle_src(data)                                                 ((0x00000C00&(data))>>10)
+#define SYS_MUXPAD0_get_nf_cle(data)                                                 ((0x00000C00&(data))>>10)
+#define SYS_MUXPAD0_nf_ale_shift                                                     (8)
+#define SYS_MUXPAD0_nf_ale_mask                                                      (0x00000300)
+#define SYS_MUXPAD0_nf_ale(data)                                                     (0x00000300&((data)<<8))
+#define SYS_MUXPAD0_nf_ale_src(data)                                                 ((0x00000300&(data))>>8)
+#define SYS_MUXPAD0_get_nf_ale(data)                                                 ((0x00000300&(data))>>8)
+#define SYS_MUXPAD0_nf_wr_n_shift                                                    (6)
+#define SYS_MUXPAD0_nf_wr_n_mask                                                     (0x000000C0)
+#define SYS_MUXPAD0_nf_wr_n(data)                                                    (0x000000C0&((data)<<6))
+#define SYS_MUXPAD0_nf_wr_n_src(data)                                                ((0x000000C0&(data))>>6)
+#define SYS_MUXPAD0_get_nf_wr_n(data)                                                ((0x000000C0&(data))>>6)
+#define SYS_MUXPAD0_nf_rd_n_shift                                                    (4)
+#define SYS_MUXPAD0_nf_rd_n_mask                                                     (0x00000030)
+#define SYS_MUXPAD0_nf_rd_n(data)                                                    (0x00000030&((data)<<4))
+#define SYS_MUXPAD0_nf_rd_n_src(data)                                                ((0x00000030&(data))>>4)
+#define SYS_MUXPAD0_get_nf_rd_n(data)                                                ((0x00000030&(data))>>4)
+#define SYS_MUXPAD0_nf_rdy_shift                                                     (2)
+#define SYS_MUXPAD0_nf_rdy_mask                                                      (0x0000000C)
+#define SYS_MUXPAD0_nf_rdy(data)                                                     (0x0000000C&((data)<<2))
+#define SYS_MUXPAD0_nf_rdy_src(data)                                                 ((0x0000000C&(data))>>2)
+#define SYS_MUXPAD0_get_nf_rdy(data)                                                 ((0x0000000C&(data))>>2)
+
+
+#define SYS_MUXPAD1                                                                  0x18000364
+#define SYS_MUXPAD1_reg_addr                                                         "0xB8000364"
+#define SYS_MUXPAD1_reg                                                              0xB8000364
+#define set_SYS_MUXPAD1_reg(data)   (*((volatile unsigned int*) SYS_MUXPAD1_reg)=data)
+#define get_SYS_MUXPAD1_reg   (*((volatile unsigned int*) SYS_MUXPAD1_reg))
+#define SYS_MUXPAD1_inst_adr                                                         "0x00D9"
+#define SYS_MUXPAD1_inst                                                             0x00D9
+#define SYS_MUXPAD1_mmc_data_3_shift                                                 (30)
+#define SYS_MUXPAD1_mmc_data_3_mask                                                  (0xC0000000)
+#define SYS_MUXPAD1_mmc_data_3(data)                                                 (0xC0000000&((data)<<30))
+#define SYS_MUXPAD1_mmc_data_3_src(data)                                             ((0xC0000000&(data))>>30)
+#define SYS_MUXPAD1_get_mmc_data_3(data)                                             ((0xC0000000&(data))>>30)
+#define SYS_MUXPAD1_mmc_data_2_shift                                                 (28)
+#define SYS_MUXPAD1_mmc_data_2_mask                                                  (0x30000000)
+#define SYS_MUXPAD1_mmc_data_2(data)                                                 (0x30000000&((data)<<28))
+#define SYS_MUXPAD1_mmc_data_2_src(data)                                             ((0x30000000&(data))>>28)
+#define SYS_MUXPAD1_get_mmc_data_2(data)                                             ((0x30000000&(data))>>28)
+#define SYS_MUXPAD1_mmc_data_1_shift                                                 (26)
+#define SYS_MUXPAD1_mmc_data_1_mask                                                  (0x0C000000)
+#define SYS_MUXPAD1_mmc_data_1(data)                                                 (0x0C000000&((data)<<26))
+#define SYS_MUXPAD1_mmc_data_1_src(data)                                             ((0x0C000000&(data))>>26)
+#define SYS_MUXPAD1_get_mmc_data_1(data)                                             ((0x0C000000&(data))>>26)
+#define SYS_MUXPAD1_mmc_data_0_shift                                                 (24)
+#define SYS_MUXPAD1_mmc_data_0_mask                                                  (0x03000000)
+#define SYS_MUXPAD1_mmc_data_0(data)                                                 (0x03000000&((data)<<24))
+#define SYS_MUXPAD1_mmc_data_0_src(data)                                             ((0x03000000&(data))>>24)
+#define SYS_MUXPAD1_get_mmc_data_0(data)                                             ((0x03000000&(data))>>24)
+#define SYS_MUXPAD1_mmc_cd_shift                                                     (22)
+#define SYS_MUXPAD1_mmc_cd_mask                                                      (0x00C00000)
+#define SYS_MUXPAD1_mmc_cd(data)                                                     (0x00C00000&((data)<<22))
+#define SYS_MUXPAD1_mmc_cd_src(data)                                                 ((0x00C00000&(data))>>22)
+#define SYS_MUXPAD1_get_mmc_cd(data)                                                 ((0x00C00000&(data))>>22)
+#define SYS_MUXPAD1_mmc_wp_shift                                                     (20)
+#define SYS_MUXPAD1_mmc_wp_mask                                                      (0x00300000)
+#define SYS_MUXPAD1_mmc_wp(data)                                                     (0x00300000&((data)<<20))
+#define SYS_MUXPAD1_mmc_wp_src(data)                                                 ((0x00300000&(data))>>20)
+#define SYS_MUXPAD1_get_mmc_wp(data)                                                 ((0x00300000&(data))>>20)
+#define SYS_MUXPAD1_mmc_clk_shift                                                    (18)
+#define SYS_MUXPAD1_mmc_clk_mask                                                     (0x000C0000)
+#define SYS_MUXPAD1_mmc_clk(data)                                                    (0x000C0000&((data)<<18))
+#define SYS_MUXPAD1_mmc_clk_src(data)                                                ((0x000C0000&(data))>>18)
+#define SYS_MUXPAD1_get_mmc_clk(data)                                                ((0x000C0000&(data))>>18)
+#define SYS_MUXPAD1_mmc_cmd_shift                                                    (16)
+#define SYS_MUXPAD1_mmc_cmd_mask                                                     (0x00030000)
+#define SYS_MUXPAD1_mmc_cmd(data)                                                    (0x00030000&((data)<<16))
+#define SYS_MUXPAD1_mmc_cmd_src(data)                                                ((0x00030000&(data))>>16)
+#define SYS_MUXPAD1_get_mmc_cmd(data)                                                ((0x00030000&(data))>>16)
+#define SYS_MUXPAD1_sdio_data_3_shift                                                (10)
+#define SYS_MUXPAD1_sdio_data_3_mask                                                 (0x00000C00)
+#define SYS_MUXPAD1_sdio_data_3(data)                                                (0x00000C00&((data)<<10))
+#define SYS_MUXPAD1_sdio_data_3_src(data)                                            ((0x00000C00&(data))>>10)
+#define SYS_MUXPAD1_get_sdio_data_3(data)                                            ((0x00000C00&(data))>>10)
+#define SYS_MUXPAD1_sdio_data_2_shift                                                (8)
+#define SYS_MUXPAD1_sdio_data_2_mask                                                 (0x00000300)
+#define SYS_MUXPAD1_sdio_data_2(data)                                                (0x00000300&((data)<<8))
+#define SYS_MUXPAD1_sdio_data_2_src(data)                                            ((0x00000300&(data))>>8)
+#define SYS_MUXPAD1_get_sdio_data_2(data)                                            ((0x00000300&(data))>>8)
+#define SYS_MUXPAD1_sdio_data_1_shift                                                (6)
+#define SYS_MUXPAD1_sdio_data_1_mask                                                 (0x000000C0)
+#define SYS_MUXPAD1_sdio_data_1(data)                                                (0x000000C0&((data)<<6))
+#define SYS_MUXPAD1_sdio_data_1_src(data)                                            ((0x000000C0&(data))>>6)
+#define SYS_MUXPAD1_get_sdio_data_1(data)                                            ((0x000000C0&(data))>>6)
+#define SYS_MUXPAD1_sdio_data_0_shift                                                (4)
+#define SYS_MUXPAD1_sdio_data_0_mask                                                 (0x00000030)
+#define SYS_MUXPAD1_sdio_data_0(data)                                                (0x00000030&((data)<<4))
+#define SYS_MUXPAD1_sdio_data_0_src(data)                                            ((0x00000030&(data))>>4)
+#define SYS_MUXPAD1_get_sdio_data_0(data)                                            ((0x00000030&(data))>>4)
+#define SYS_MUXPAD1_sdio_clk_shift                                                   (2)
+#define SYS_MUXPAD1_sdio_clk_mask                                                    (0x0000000C)
+#define SYS_MUXPAD1_sdio_clk(data)                                                   (0x0000000C&((data)<<2))
+#define SYS_MUXPAD1_sdio_clk_src(data)                                               ((0x0000000C&(data))>>2)
+#define SYS_MUXPAD1_get_sdio_clk(data)                                               ((0x0000000C&(data))>>2)
+#define SYS_MUXPAD1_sdio_cmd_shift                                                   (0)
+#define SYS_MUXPAD1_sdio_cmd_mask                                                    (0x00000003)
+#define SYS_MUXPAD1_sdio_cmd(data)                                                   (0x00000003&((data)<<0))
+#define SYS_MUXPAD1_sdio_cmd_src(data)                                               ((0x00000003&(data))>>0)
+#define SYS_MUXPAD1_get_sdio_cmd(data)                                               ((0x00000003&(data))>>0)
+
+
+#define SYS_MUXPAD2                                                                  0x18000368
+#define SYS_MUXPAD2_reg_addr                                                         "0xB8000368"
+#define SYS_MUXPAD2_reg                                                              0xB8000368
+#define set_SYS_MUXPAD2_reg(data)   (*((volatile unsigned int*) SYS_MUXPAD2_reg)=data)
+#define get_SYS_MUXPAD2_reg   (*((volatile unsigned int*) SYS_MUXPAD2_reg))
+#define SYS_MUXPAD2_inst_adr                                                         "0x00DA"
+#define SYS_MUXPAD2_inst                                                             0x00DA
+#define SYS_MUXPAD2_tp1_clk_shift                                                    (22)
+#define SYS_MUXPAD2_tp1_clk_mask                                                     (0x00C00000)
+#define SYS_MUXPAD2_tp1_clk(data)                                                    (0x00C00000&((data)<<22))
+#define SYS_MUXPAD2_tp1_clk_src(data)                                                ((0x00C00000&(data))>>22)
+#define SYS_MUXPAD2_get_tp1_clk(data)                                                ((0x00C00000&(data))>>22)
+#define SYS_MUXPAD2_tp1_valid_shift                                                  (20)
+#define SYS_MUXPAD2_tp1_valid_mask                                                   (0x00300000)
+#define SYS_MUXPAD2_tp1_valid(data)                                                  (0x00300000&((data)<<20))
+#define SYS_MUXPAD2_tp1_valid_src(data)                                              ((0x00300000&(data))>>20)
+#define SYS_MUXPAD2_get_tp1_valid(data)                                              ((0x00300000&(data))>>20)
+#define SYS_MUXPAD2_tp1_sync_shift                                                   (18)
+#define SYS_MUXPAD2_tp1_sync_mask                                                    (0x000C0000)
+#define SYS_MUXPAD2_tp1_sync(data)                                                   (0x000C0000&((data)<<18))
+#define SYS_MUXPAD2_tp1_sync_src(data)                                               ((0x000C0000&(data))>>18)
+#define SYS_MUXPAD2_get_tp1_sync(data)                                               ((0x000C0000&(data))>>18)
+#define SYS_MUXPAD2_tp1_data_shift                                                   (16)
+#define SYS_MUXPAD2_tp1_data_mask                                                    (0x00030000)
+#define SYS_MUXPAD2_tp1_data(data)                                                   (0x00030000&((data)<<16))
+#define SYS_MUXPAD2_tp1_data_src(data)                                               ((0x00030000&(data))>>16)
+#define SYS_MUXPAD2_get_tp1_data(data)                                               ((0x00030000&(data))>>16)
+#define SYS_MUXPAD2_tp0_clk_shift                                                    (6)
+#define SYS_MUXPAD2_tp0_clk_mask                                                     (0x000000C0)
+#define SYS_MUXPAD2_tp0_clk(data)                                                    (0x000000C0&((data)<<6))
+#define SYS_MUXPAD2_tp0_clk_src(data)                                                ((0x000000C0&(data))>>6)
+#define SYS_MUXPAD2_get_tp0_clk(data)                                                ((0x000000C0&(data))>>6)
+#define SYS_MUXPAD2_tp0_valid_shift                                                  (4)
+#define SYS_MUXPAD2_tp0_valid_mask                                                   (0x00000030)
+#define SYS_MUXPAD2_tp0_valid(data)                                                  (0x00000030&((data)<<4))
+#define SYS_MUXPAD2_tp0_valid_src(data)                                              ((0x00000030&(data))>>4)
+#define SYS_MUXPAD2_get_tp0_valid(data)                                              ((0x00000030&(data))>>4)
+#define SYS_MUXPAD2_tp0_sync_shift                                                   (2)
+#define SYS_MUXPAD2_tp0_sync_mask                                                    (0x0000000C)
+#define SYS_MUXPAD2_tp0_sync(data)                                                   (0x0000000C&((data)<<2))
+#define SYS_MUXPAD2_tp0_sync_src(data)                                               ((0x0000000C&(data))>>2)
+#define SYS_MUXPAD2_get_tp0_sync(data)                                               ((0x0000000C&(data))>>2)
+#define SYS_MUXPAD2_tp0_data_shift                                                   (0)
+#define SYS_MUXPAD2_tp0_data_mask                                                    (0x00000003)
+#define SYS_MUXPAD2_tp0_data(data)                                                   (0x00000003&((data)<<0))
+#define SYS_MUXPAD2_tp0_data_src(data)                                               ((0x00000003&(data))>>0)
+#define SYS_MUXPAD2_get_tp0_data(data)                                               ((0x00000003&(data))>>0)
+
+
+#define SYS_MUXPAD3                                                                  0x1800036C
+#define SYS_MUXPAD3_reg_addr                                                         "0xB800036C"
+#define SYS_MUXPAD3_reg                                                              0xB800036C
+#define set_SYS_MUXPAD3_reg(data)   (*((volatile unsigned int*) SYS_MUXPAD3_reg)=data)
+#define get_SYS_MUXPAD3_reg   (*((volatile unsigned int*) SYS_MUXPAD3_reg))
+#define SYS_MUXPAD3_inst_adr                                                         "0x00DB"
+#define SYS_MUXPAD3_inst                                                             0x00DB
+#define SYS_MUXPAD3_sensor_cko_0_shift                                               (30)
+#define SYS_MUXPAD3_sensor_cko_0_mask                                                (0xC0000000)
+#define SYS_MUXPAD3_sensor_cko_0(data)                                               (0xC0000000&((data)<<30))
+#define SYS_MUXPAD3_sensor_cko_0_src(data)                                           ((0xC0000000&(data))>>30)
+#define SYS_MUXPAD3_get_sensor_cko_0(data)                                           ((0xC0000000&(data))>>30)
+#define SYS_MUXPAD3_sensor_cko_1_shift                                               (28)
+#define SYS_MUXPAD3_sensor_cko_1_mask                                                (0x30000000)
+#define SYS_MUXPAD3_sensor_cko_1(data)                                               (0x30000000&((data)<<28))
+#define SYS_MUXPAD3_sensor_cko_1_src(data)                                           ((0x30000000&(data))>>28)
+#define SYS_MUXPAD3_get_sensor_cko_1(data)                                           ((0x30000000&(data))>>28)
+#define SYS_MUXPAD3_sensor_rst_shift                                                 (26)
+#define SYS_MUXPAD3_sensor_rst_mask                                                  (0x0C000000)
+#define SYS_MUXPAD3_sensor_rst(data)                                                 (0x0C000000&((data)<<26))
+#define SYS_MUXPAD3_sensor_rst_src(data)                                             ((0x0C000000&(data))>>26)
+#define SYS_MUXPAD3_get_sensor_rst(data)                                             ((0x0C000000&(data))>>26)
+#define SYS_MUXPAD3_sensor_stb_0_shift                                               (24)
+#define SYS_MUXPAD3_sensor_stb_0_mask                                                (0x03000000)
+#define SYS_MUXPAD3_sensor_stb_0(data)                                               (0x03000000&((data)<<24))
+#define SYS_MUXPAD3_sensor_stb_0_src(data)                                           ((0x03000000&(data))>>24)
+#define SYS_MUXPAD3_get_sensor_stb_0(data)                                           ((0x03000000&(data))>>24)
+#define SYS_MUXPAD3_sensor_stb_1_shift                                               (22)
+#define SYS_MUXPAD3_sensor_stb_1_mask                                                (0x00C00000)
+#define SYS_MUXPAD3_sensor_stb_1(data)                                               (0x00C00000&((data)<<22))
+#define SYS_MUXPAD3_sensor_stb_1_src(data)                                           ((0x00C00000&(data))>>22)
+#define SYS_MUXPAD3_get_sensor_stb_1(data)                                           ((0x00C00000&(data))>>22)
+#define SYS_MUXPAD3_ejtag_scpu_loc_shift                                             (20)
+#define SYS_MUXPAD3_ejtag_scpu_loc_mask                                              (0x00300000)
+#define SYS_MUXPAD3_ejtag_scpu_loc(data)                                             (0x00300000&((data)<<20))
+#define SYS_MUXPAD3_ejtag_scpu_loc_src(data)                                         ((0x00300000&(data))>>20)
+#define SYS_MUXPAD3_get_ejtag_scpu_loc(data)                                         ((0x00300000&(data))>>20)
+#define SYS_MUXPAD3_hi_loc_shift                                                     (18)
+#define SYS_MUXPAD3_hi_loc_mask                                                      (0x000C0000)
+#define SYS_MUXPAD3_hi_loc(data)                                                     (0x000C0000&((data)<<18))
+#define SYS_MUXPAD3_hi_loc_src(data)                                                 ((0x000C0000&(data))>>18)
+#define SYS_MUXPAD3_get_hi_loc(data)                                                 ((0x000C0000&(data))>>18)
+#define SYS_MUXPAD3_usb_id_shift                                                     (16)
+#define SYS_MUXPAD3_usb_id_mask                                                      (0x00030000)
+#define SYS_MUXPAD3_usb_id(data)                                                     (0x00030000&((data)<<16))
+#define SYS_MUXPAD3_usb_id_src(data)                                                 ((0x00030000&(data))>>16)
+#define SYS_MUXPAD3_get_usb_id(data)                                                 ((0x00030000&(data))>>16)
+#define SYS_MUXPAD3_hdmi_hpd_shift                                                   (14)
+#define SYS_MUXPAD3_hdmi_hpd_mask                                                    (0x0000C000)
+#define SYS_MUXPAD3_hdmi_hpd(data)                                                   (0x0000C000&((data)<<14))
+#define SYS_MUXPAD3_hdmi_hpd_src(data)                                               ((0x0000C000&(data))>>14)
+#define SYS_MUXPAD3_get_hdmi_hpd(data)                                               ((0x0000C000&(data))>>14)
+#define SYS_MUXPAD3_spdif_shift                                                      (12)
+#define SYS_MUXPAD3_spdif_mask                                                       (0x00003000)
+#define SYS_MUXPAD3_spdif(data)                                                      (0x00003000&((data)<<12))
+#define SYS_MUXPAD3_spdif_src(data)                                                  ((0x00003000&(data))>>12)
+#define SYS_MUXPAD3_get_spdif(data)                                                  ((0x00003000&(data))>>12)
+#define SYS_MUXPAD3_i2c_scl_5_shift                                                  (10)
+#define SYS_MUXPAD3_i2c_scl_5_mask                                                   (0x00000C00)
+#define SYS_MUXPAD3_i2c_scl_5(data)                                                  (0x00000C00&((data)<<10))
+#define SYS_MUXPAD3_i2c_scl_5_src(data)                                              ((0x00000C00&(data))>>10)
+#define SYS_MUXPAD3_get_i2c_scl_5(data)                                              ((0x00000C00&(data))>>10)
+#define SYS_MUXPAD3_i2c_sda_5_shift                                                  (8)
+#define SYS_MUXPAD3_i2c_sda_5_mask                                                   (0x00000300)
+#define SYS_MUXPAD3_i2c_sda_5(data)                                                  (0x00000300&((data)<<8))
+#define SYS_MUXPAD3_i2c_sda_5_src(data)                                              ((0x00000300&(data))>>8)
+#define SYS_MUXPAD3_get_i2c_sda_5(data)                                              ((0x00000300&(data))>>8)
+#define SYS_MUXPAD3_i2c_scl_4_shift                                                  (6)
+#define SYS_MUXPAD3_i2c_scl_4_mask                                                   (0x000000C0)
+#define SYS_MUXPAD3_i2c_scl_4(data)                                                  (0x000000C0&((data)<<6))
+#define SYS_MUXPAD3_i2c_scl_4_src(data)                                              ((0x000000C0&(data))>>6)
+#define SYS_MUXPAD3_get_i2c_scl_4(data)                                              ((0x000000C0&(data))>>6)
+#define SYS_MUXPAD3_i2c_sda_4_shift                                                  (4)
+#define SYS_MUXPAD3_i2c_sda_4_mask                                                   (0x00000030)
+#define SYS_MUXPAD3_i2c_sda_4(data)                                                  (0x00000030&((data)<<4))
+#define SYS_MUXPAD3_i2c_sda_4_src(data)                                              ((0x00000030&(data))>>4)
+#define SYS_MUXPAD3_get_i2c_sda_4(data)                                              ((0x00000030&(data))>>4)
+#define SYS_MUXPAD3_i2c_scl_1_shift                                                  (2)
+#define SYS_MUXPAD3_i2c_scl_1_mask                                                   (0x0000000C)
+#define SYS_MUXPAD3_i2c_scl_1(data)                                                  (0x0000000C&((data)<<2))
+#define SYS_MUXPAD3_i2c_scl_1_src(data)                                              ((0x0000000C&(data))>>2)
+#define SYS_MUXPAD3_get_i2c_scl_1(data)                                              ((0x0000000C&(data))>>2)
+#define SYS_MUXPAD3_i2c_sda_1_shift                                                  (0)
+#define SYS_MUXPAD3_i2c_sda_1_mask                                                   (0x00000003)
+#define SYS_MUXPAD3_i2c_sda_1(data)                                                  (0x00000003&((data)<<0))
+#define SYS_MUXPAD3_i2c_sda_1_src(data)                                              ((0x00000003&(data))>>0)
+#define SYS_MUXPAD3_get_i2c_sda_1(data)                                              ((0x00000003&(data))>>0)
+
+
+#define SYS_MUXPAD4                                                                  0x18000370
+#define SYS_MUXPAD4_reg_addr                                                         "0xB8000370"
+#define SYS_MUXPAD4_reg                                                              0xB8000370
+#define set_SYS_MUXPAD4_reg(data)   (*((volatile unsigned int*) SYS_MUXPAD4_reg)=data)
+#define get_SYS_MUXPAD4_reg   (*((volatile unsigned int*) SYS_MUXPAD4_reg))
+#define SYS_MUXPAD4_inst_adr                                                         "0x00DC"
+#define SYS_MUXPAD4_inst                                                             0x00DC
+#define SYS_MUXPAD4_gpio_8_shift                                                     (20)
+#define SYS_MUXPAD4_gpio_8_mask                                                      (0x00300000)
+#define SYS_MUXPAD4_gpio_8(data)                                                     (0x00300000&((data)<<20))
+#define SYS_MUXPAD4_gpio_8_src(data)                                                 ((0x00300000&(data))>>20)
+#define SYS_MUXPAD4_get_gpio_8(data)                                                 ((0x00300000&(data))>>20)
+#define SYS_MUXPAD4_gpio_7_shift                                                     (18)
+#define SYS_MUXPAD4_gpio_7_mask                                                      (0x000C0000)
+#define SYS_MUXPAD4_gpio_7(data)                                                     (0x000C0000&((data)<<18))
+#define SYS_MUXPAD4_gpio_7_src(data)                                                 ((0x000C0000&(data))>>18)
+#define SYS_MUXPAD4_get_gpio_7(data)                                                 ((0x000C0000&(data))>>18)
+#define SYS_MUXPAD4_gpio_6_shift                                                     (16)
+#define SYS_MUXPAD4_gpio_6_mask                                                      (0x00030000)
+#define SYS_MUXPAD4_gpio_6(data)                                                     (0x00030000&((data)<<16))
+#define SYS_MUXPAD4_gpio_6_src(data)                                                 ((0x00030000&(data))>>16)
+#define SYS_MUXPAD4_get_gpio_6(data)                                                 ((0x00030000&(data))>>16)
+#define SYS_MUXPAD4_gpio_5_shift                                                     (14)
+#define SYS_MUXPAD4_gpio_5_mask                                                      (0x0000C000)
+#define SYS_MUXPAD4_gpio_5(data)                                                     (0x0000C000&((data)<<14))
+#define SYS_MUXPAD4_gpio_5_src(data)                                                 ((0x0000C000&(data))>>14)
+#define SYS_MUXPAD4_get_gpio_5(data)                                                 ((0x0000C000&(data))>>14)
+#define SYS_MUXPAD4_gpio_4_shift                                                     (12)
+#define SYS_MUXPAD4_gpio_4_mask                                                      (0x00003000)
+#define SYS_MUXPAD4_gpio_4(data)                                                     (0x00003000&((data)<<12))
+#define SYS_MUXPAD4_gpio_4_src(data)                                                 ((0x00003000&(data))>>12)
+#define SYS_MUXPAD4_get_gpio_4(data)                                                 ((0x00003000&(data))>>12)
+#define SYS_MUXPAD4_gpio_3_shift                                                     (9)
+#define SYS_MUXPAD4_gpio_3_mask                                                      (0x00000E00)
+#define SYS_MUXPAD4_gpio_3(data)                                                     (0x00000E00&((data)<<9))
+#define SYS_MUXPAD4_gpio_3_src(data)                                                 ((0x00000E00&(data))>>9)
+#define SYS_MUXPAD4_get_gpio_3(data)                                                 ((0x00000E00&(data))>>9)
+#define SYS_MUXPAD4_gpio_2_shift                                                     (6)
+#define SYS_MUXPAD4_gpio_2_mask                                                      (0x000001C0)
+#define SYS_MUXPAD4_gpio_2(data)                                                     (0x000001C0&((data)<<6))
+#define SYS_MUXPAD4_gpio_2_src(data)                                                 ((0x000001C0&(data))>>6)
+#define SYS_MUXPAD4_get_gpio_2(data)                                                 ((0x000001C0&(data))>>6)
+#define SYS_MUXPAD4_gpio_1_shift                                                     (3)
+#define SYS_MUXPAD4_gpio_1_mask                                                      (0x00000038)
+#define SYS_MUXPAD4_gpio_1(data)                                                     (0x00000038&((data)<<3))
+#define SYS_MUXPAD4_gpio_1_src(data)                                                 ((0x00000038&(data))>>3)
+#define SYS_MUXPAD4_get_gpio_1(data)                                                 ((0x00000038&(data))>>3)
+#define SYS_MUXPAD4_gpio_0_shift                                                     (0)
+#define SYS_MUXPAD4_gpio_0_mask                                                      (0x00000007)
+#define SYS_MUXPAD4_gpio_0(data)                                                     (0x00000007&((data)<<0))
+#define SYS_MUXPAD4_gpio_0_src(data)                                                 ((0x00000007&(data))>>0)
+#define SYS_MUXPAD4_get_gpio_0(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define SYS_MUXPAD5                                                                  0x18000374
+#define SYS_MUXPAD5_reg_addr                                                         "0xB8000374"
+#define SYS_MUXPAD5_reg                                                              0xB8000374
+#define set_SYS_MUXPAD5_reg(data)   (*((volatile unsigned int*) SYS_MUXPAD5_reg)=data)
+#define get_SYS_MUXPAD5_reg   (*((volatile unsigned int*) SYS_MUXPAD5_reg))
+#define SYS_MUXPAD5_inst_adr                                                         "0x00DD"
+#define SYS_MUXPAD5_inst                                                             0x00DD
+#define SYS_MUXPAD5_ao_loc_shift                                                     (2)
+#define SYS_MUXPAD5_ao_loc_mask                                                      (0x0000000C)
+#define SYS_MUXPAD5_ao_loc(data)                                                     (0x0000000C&((data)<<2))
+#define SYS_MUXPAD5_ao_loc_src(data)                                                 ((0x0000000C&(data))>>2)
+#define SYS_MUXPAD5_get_ao_loc(data)                                                 ((0x0000000C&(data))>>2)
+#define SYS_MUXPAD5_arm_trace_dbg_en_shift                                           (1)
+#define SYS_MUXPAD5_arm_trace_dbg_en_mask                                            (0x00000002)
+#define SYS_MUXPAD5_arm_trace_dbg_en(data)                                           (0x00000002&((data)<<1))
+#define SYS_MUXPAD5_arm_trace_dbg_en_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_MUXPAD5_get_arm_trace_dbg_en(data)                                       ((0x00000002&(data))>>1)
+#define SYS_MUXPAD5_sf_en_shift                                                      (0)
+#define SYS_MUXPAD5_sf_en_mask                                                       (0x00000001)
+#define SYS_MUXPAD5_sf_en(data)                                                      (0x00000001&((data)<<0))
+#define SYS_MUXPAD5_sf_en_src(data)                                                  ((0x00000001&(data))>>0)
+#define SYS_MUXPAD5_get_sf_en(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define SYS_PFUNC_NF0                                                                0x18000378
+#define SYS_PFUNC_NF0_reg_addr                                                       "0xB8000378"
+#define SYS_PFUNC_NF0_reg                                                            0xB8000378
+#define set_SYS_PFUNC_NF0_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_NF0_reg)=data)
+#define get_SYS_PFUNC_NF0_reg   (*((volatile unsigned int*) SYS_PFUNC_NF0_reg))
+#define SYS_PFUNC_NF0_inst_adr                                                       "0x00DE"
+#define SYS_PFUNC_NF0_inst                                                           0x00DE
+#define SYS_PFUNC_NF0_nf_cle_smt_shift                                               (31)
+#define SYS_PFUNC_NF0_nf_cle_smt_mask                                                (0x80000000)
+#define SYS_PFUNC_NF0_nf_cle_smt(data)                                               (0x80000000&((data)<<31))
+#define SYS_PFUNC_NF0_nf_cle_smt_src(data)                                           ((0x80000000&(data))>>31)
+#define SYS_PFUNC_NF0_get_nf_cle_smt(data)                                           ((0x80000000&(data))>>31)
+#define SYS_PFUNC_NF0_nf_cle_e2_shift                                                (30)
+#define SYS_PFUNC_NF0_nf_cle_e2_mask                                                 (0x40000000)
+#define SYS_PFUNC_NF0_nf_cle_e2(data)                                                (0x40000000&((data)<<30))
+#define SYS_PFUNC_NF0_nf_cle_e2_src(data)                                            ((0x40000000&(data))>>30)
+#define SYS_PFUNC_NF0_get_nf_cle_e2(data)                                            ((0x40000000&(data))>>30)
+#define SYS_PFUNC_NF0_nf_cle_pud_en_shift                                            (29)
+#define SYS_PFUNC_NF0_nf_cle_pud_en_mask                                             (0x20000000)
+#define SYS_PFUNC_NF0_nf_cle_pud_en(data)                                            (0x20000000&((data)<<29))
+#define SYS_PFUNC_NF0_nf_cle_pud_en_src(data)                                        ((0x20000000&(data))>>29)
+#define SYS_PFUNC_NF0_get_nf_cle_pud_en(data)                                        ((0x20000000&(data))>>29)
+#define SYS_PFUNC_NF0_nf_cle_pud_sel_shift                                           (28)
+#define SYS_PFUNC_NF0_nf_cle_pud_sel_mask                                            (0x10000000)
+#define SYS_PFUNC_NF0_nf_cle_pud_sel(data)                                           (0x10000000&((data)<<28))
+#define SYS_PFUNC_NF0_nf_cle_pud_sel_src(data)                                       ((0x10000000&(data))>>28)
+#define SYS_PFUNC_NF0_get_nf_cle_pud_sel(data)                                       ((0x10000000&(data))>>28)
+#define SYS_PFUNC_NF0_nf_wr_n_smt_shift                                              (27)
+#define SYS_PFUNC_NF0_nf_wr_n_smt_mask                                               (0x08000000)
+#define SYS_PFUNC_NF0_nf_wr_n_smt(data)                                              (0x08000000&((data)<<27))
+#define SYS_PFUNC_NF0_nf_wr_n_smt_src(data)                                          ((0x08000000&(data))>>27)
+#define SYS_PFUNC_NF0_get_nf_wr_n_smt(data)                                          ((0x08000000&(data))>>27)
+#define SYS_PFUNC_NF0_nf_wr_n_e2_shift                                               (26)
+#define SYS_PFUNC_NF0_nf_wr_n_e2_mask                                                (0x04000000)
+#define SYS_PFUNC_NF0_nf_wr_n_e2(data)                                               (0x04000000&((data)<<26))
+#define SYS_PFUNC_NF0_nf_wr_n_e2_src(data)                                           ((0x04000000&(data))>>26)
+#define SYS_PFUNC_NF0_get_nf_wr_n_e2(data)                                           ((0x04000000&(data))>>26)
+#define SYS_PFUNC_NF0_nf_wr_n_pud_en_shift                                           (25)
+#define SYS_PFUNC_NF0_nf_wr_n_pud_en_mask                                            (0x02000000)
+#define SYS_PFUNC_NF0_nf_wr_n_pud_en(data)                                           (0x02000000&((data)<<25))
+#define SYS_PFUNC_NF0_nf_wr_n_pud_en_src(data)                                       ((0x02000000&(data))>>25)
+#define SYS_PFUNC_NF0_get_nf_wr_n_pud_en(data)                                       ((0x02000000&(data))>>25)
+#define SYS_PFUNC_NF0_nf_wr_n_pud_sel_shift                                          (24)
+#define SYS_PFUNC_NF0_nf_wr_n_pud_sel_mask                                           (0x01000000)
+#define SYS_PFUNC_NF0_nf_wr_n_pud_sel(data)                                          (0x01000000&((data)<<24))
+#define SYS_PFUNC_NF0_nf_wr_n_pud_sel_src(data)                                      ((0x01000000&(data))>>24)
+#define SYS_PFUNC_NF0_get_nf_wr_n_pud_sel(data)                                      ((0x01000000&(data))>>24)
+#define SYS_PFUNC_NF0_nf_rd_n_smt_shift                                              (23)
+#define SYS_PFUNC_NF0_nf_rd_n_smt_mask                                               (0x00800000)
+#define SYS_PFUNC_NF0_nf_rd_n_smt(data)                                              (0x00800000&((data)<<23))
+#define SYS_PFUNC_NF0_nf_rd_n_smt_src(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PFUNC_NF0_get_nf_rd_n_smt(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PFUNC_NF0_nf_rd_n_e2_shift                                               (22)
+#define SYS_PFUNC_NF0_nf_rd_n_e2_mask                                                (0x00400000)
+#define SYS_PFUNC_NF0_nf_rd_n_e2(data)                                               (0x00400000&((data)<<22))
+#define SYS_PFUNC_NF0_nf_rd_n_e2_src(data)                                           ((0x00400000&(data))>>22)
+#define SYS_PFUNC_NF0_get_nf_rd_n_e2(data)                                           ((0x00400000&(data))>>22)
+#define SYS_PFUNC_NF0_nf_rd_n_pud_en_shift                                           (21)
+#define SYS_PFUNC_NF0_nf_rd_n_pud_en_mask                                            (0x00200000)
+#define SYS_PFUNC_NF0_nf_rd_n_pud_en(data)                                           (0x00200000&((data)<<21))
+#define SYS_PFUNC_NF0_nf_rd_n_pud_en_src(data)                                       ((0x00200000&(data))>>21)
+#define SYS_PFUNC_NF0_get_nf_rd_n_pud_en(data)                                       ((0x00200000&(data))>>21)
+#define SYS_PFUNC_NF0_nf_rd_n_pud_sel_shift                                          (20)
+#define SYS_PFUNC_NF0_nf_rd_n_pud_sel_mask                                           (0x00100000)
+#define SYS_PFUNC_NF0_nf_rd_n_pud_sel(data)                                          (0x00100000&((data)<<20))
+#define SYS_PFUNC_NF0_nf_rd_n_pud_sel_src(data)                                      ((0x00100000&(data))>>20)
+#define SYS_PFUNC_NF0_get_nf_rd_n_pud_sel(data)                                      ((0x00100000&(data))>>20)
+#define SYS_PFUNC_NF0_nf_rdy_smt_shift                                               (19)
+#define SYS_PFUNC_NF0_nf_rdy_smt_mask                                                (0x00080000)
+#define SYS_PFUNC_NF0_nf_rdy_smt(data)                                               (0x00080000&((data)<<19))
+#define SYS_PFUNC_NF0_nf_rdy_smt_src(data)                                           ((0x00080000&(data))>>19)
+#define SYS_PFUNC_NF0_get_nf_rdy_smt(data)                                           ((0x00080000&(data))>>19)
+#define SYS_PFUNC_NF0_nf_rdy_e2_shift                                                (18)
+#define SYS_PFUNC_NF0_nf_rdy_e2_mask                                                 (0x00040000)
+#define SYS_PFUNC_NF0_nf_rdy_e2(data)                                                (0x00040000&((data)<<18))
+#define SYS_PFUNC_NF0_nf_rdy_e2_src(data)                                            ((0x00040000&(data))>>18)
+#define SYS_PFUNC_NF0_get_nf_rdy_e2(data)                                            ((0x00040000&(data))>>18)
+#define SYS_PFUNC_NF0_nf_rdy_pud_en_shift                                            (17)
+#define SYS_PFUNC_NF0_nf_rdy_pud_en_mask                                             (0x00020000)
+#define SYS_PFUNC_NF0_nf_rdy_pud_en(data)                                            (0x00020000&((data)<<17))
+#define SYS_PFUNC_NF0_nf_rdy_pud_en_src(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PFUNC_NF0_get_nf_rdy_pud_en(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PFUNC_NF0_nf_rdy_pud_sel_shift                                           (16)
+#define SYS_PFUNC_NF0_nf_rdy_pud_sel_mask                                            (0x00010000)
+#define SYS_PFUNC_NF0_nf_rdy_pud_sel(data)                                           (0x00010000&((data)<<16))
+#define SYS_PFUNC_NF0_nf_rdy_pud_sel_src(data)                                       ((0x00010000&(data))>>16)
+#define SYS_PFUNC_NF0_get_nf_rdy_pud_sel(data)                                       ((0x00010000&(data))>>16)
+#define SYS_PFUNC_NF0_nf_ce_n_1_smt_shift                                            (15)
+#define SYS_PFUNC_NF0_nf_ce_n_1_smt_mask                                             (0x00008000)
+#define SYS_PFUNC_NF0_nf_ce_n_1_smt(data)                                            (0x00008000&((data)<<15))
+#define SYS_PFUNC_NF0_nf_ce_n_1_smt_src(data)                                        ((0x00008000&(data))>>15)
+#define SYS_PFUNC_NF0_get_nf_ce_n_1_smt(data)                                        ((0x00008000&(data))>>15)
+#define SYS_PFUNC_NF0_nf_ce_n_1_e2_shift                                             (14)
+#define SYS_PFUNC_NF0_nf_ce_n_1_e2_mask                                              (0x00004000)
+#define SYS_PFUNC_NF0_nf_ce_n_1_e2(data)                                             (0x00004000&((data)<<14))
+#define SYS_PFUNC_NF0_nf_ce_n_1_e2_src(data)                                         ((0x00004000&(data))>>14)
+#define SYS_PFUNC_NF0_get_nf_ce_n_1_e2(data)                                         ((0x00004000&(data))>>14)
+#define SYS_PFUNC_NF0_nf_ce_n_1_pud_en_shift                                         (13)
+#define SYS_PFUNC_NF0_nf_ce_n_1_pud_en_mask                                          (0x00002000)
+#define SYS_PFUNC_NF0_nf_ce_n_1_pud_en(data)                                         (0x00002000&((data)<<13))
+#define SYS_PFUNC_NF0_nf_ce_n_1_pud_en_src(data)                                     ((0x00002000&(data))>>13)
+#define SYS_PFUNC_NF0_get_nf_ce_n_1_pud_en(data)                                     ((0x00002000&(data))>>13)
+#define SYS_PFUNC_NF0_nf_ce_n_1_pud_sel_shift                                        (12)
+#define SYS_PFUNC_NF0_nf_ce_n_1_pud_sel_mask                                         (0x00001000)
+#define SYS_PFUNC_NF0_nf_ce_n_1_pud_sel(data)                                        (0x00001000&((data)<<12))
+#define SYS_PFUNC_NF0_nf_ce_n_1_pud_sel_src(data)                                    ((0x00001000&(data))>>12)
+#define SYS_PFUNC_NF0_get_nf_ce_n_1_pud_sel(data)                                    ((0x00001000&(data))>>12)
+#define SYS_PFUNC_NF0_nf_ce_n_0_smt_shift                                            (11)
+#define SYS_PFUNC_NF0_nf_ce_n_0_smt_mask                                             (0x00000800)
+#define SYS_PFUNC_NF0_nf_ce_n_0_smt(data)                                            (0x00000800&((data)<<11))
+#define SYS_PFUNC_NF0_nf_ce_n_0_smt_src(data)                                        ((0x00000800&(data))>>11)
+#define SYS_PFUNC_NF0_get_nf_ce_n_0_smt(data)                                        ((0x00000800&(data))>>11)
+#define SYS_PFUNC_NF0_nf_ce_n_0_e2_shift                                             (10)
+#define SYS_PFUNC_NF0_nf_ce_n_0_e2_mask                                              (0x00000400)
+#define SYS_PFUNC_NF0_nf_ce_n_0_e2(data)                                             (0x00000400&((data)<<10))
+#define SYS_PFUNC_NF0_nf_ce_n_0_e2_src(data)                                         ((0x00000400&(data))>>10)
+#define SYS_PFUNC_NF0_get_nf_ce_n_0_e2(data)                                         ((0x00000400&(data))>>10)
+#define SYS_PFUNC_NF0_nf_ce_n_0_pud_en_shift                                         (9)
+#define SYS_PFUNC_NF0_nf_ce_n_0_pud_en_mask                                          (0x00000200)
+#define SYS_PFUNC_NF0_nf_ce_n_0_pud_en(data)                                         (0x00000200&((data)<<9))
+#define SYS_PFUNC_NF0_nf_ce_n_0_pud_en_src(data)                                     ((0x00000200&(data))>>9)
+#define SYS_PFUNC_NF0_get_nf_ce_n_0_pud_en(data)                                     ((0x00000200&(data))>>9)
+#define SYS_PFUNC_NF0_nf_ce_n_0_pud_sel_shift                                        (8)
+#define SYS_PFUNC_NF0_nf_ce_n_0_pud_sel_mask                                         (0x00000100)
+#define SYS_PFUNC_NF0_nf_ce_n_0_pud_sel(data)                                        (0x00000100&((data)<<8))
+#define SYS_PFUNC_NF0_nf_ce_n_0_pud_sel_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PFUNC_NF0_get_nf_ce_n_0_pud_sel(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PFUNC_NF0_nf_ale_smt_shift                                               (7)
+#define SYS_PFUNC_NF0_nf_ale_smt_mask                                                (0x00000080)
+#define SYS_PFUNC_NF0_nf_ale_smt(data)                                               (0x00000080&((data)<<7))
+#define SYS_PFUNC_NF0_nf_ale_smt_src(data)                                           ((0x00000080&(data))>>7)
+#define SYS_PFUNC_NF0_get_nf_ale_smt(data)                                           ((0x00000080&(data))>>7)
+#define SYS_PFUNC_NF0_nf_ale_e2_shift                                                (6)
+#define SYS_PFUNC_NF0_nf_ale_e2_mask                                                 (0x00000040)
+#define SYS_PFUNC_NF0_nf_ale_e2(data)                                                (0x00000040&((data)<<6))
+#define SYS_PFUNC_NF0_nf_ale_e2_src(data)                                            ((0x00000040&(data))>>6)
+#define SYS_PFUNC_NF0_get_nf_ale_e2(data)                                            ((0x00000040&(data))>>6)
+#define SYS_PFUNC_NF0_nf_ale_pud_en_shift                                            (5)
+#define SYS_PFUNC_NF0_nf_ale_pud_en_mask                                             (0x00000020)
+#define SYS_PFUNC_NF0_nf_ale_pud_en(data)                                            (0x00000020&((data)<<5))
+#define SYS_PFUNC_NF0_nf_ale_pud_en_src(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PFUNC_NF0_get_nf_ale_pud_en(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PFUNC_NF0_nf_ale_pud_sel_shift                                           (4)
+#define SYS_PFUNC_NF0_nf_ale_pud_sel_mask                                            (0x00000010)
+#define SYS_PFUNC_NF0_nf_ale_pud_sel(data)                                           (0x00000010&((data)<<4))
+#define SYS_PFUNC_NF0_nf_ale_pud_sel_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PFUNC_NF0_get_nf_ale_pud_sel(data)                                       ((0x00000010&(data))>>4)
+
+
+#define SYS_PFUNC_NF1                                                                0x1800037C
+#define SYS_PFUNC_NF1_reg_addr                                                       "0xB800037C"
+#define SYS_PFUNC_NF1_reg                                                            0xB800037C
+#define set_SYS_PFUNC_NF1_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_NF1_reg)=data)
+#define get_SYS_PFUNC_NF1_reg   (*((volatile unsigned int*) SYS_PFUNC_NF1_reg))
+#define SYS_PFUNC_NF1_inst_adr                                                       "0x00DF"
+#define SYS_PFUNC_NF1_inst                                                           0x00DF
+#define SYS_PFUNC_NF1_nf_dd_7_smt_shift                                              (31)
+#define SYS_PFUNC_NF1_nf_dd_7_smt_mask                                               (0x80000000)
+#define SYS_PFUNC_NF1_nf_dd_7_smt(data)                                              (0x80000000&((data)<<31))
+#define SYS_PFUNC_NF1_nf_dd_7_smt_src(data)                                          ((0x80000000&(data))>>31)
+#define SYS_PFUNC_NF1_get_nf_dd_7_smt(data)                                          ((0x80000000&(data))>>31)
+#define SYS_PFUNC_NF1_nf_dd_7_e2_shift                                               (30)
+#define SYS_PFUNC_NF1_nf_dd_7_e2_mask                                                (0x40000000)
+#define SYS_PFUNC_NF1_nf_dd_7_e2(data)                                               (0x40000000&((data)<<30))
+#define SYS_PFUNC_NF1_nf_dd_7_e2_src(data)                                           ((0x40000000&(data))>>30)
+#define SYS_PFUNC_NF1_get_nf_dd_7_e2(data)                                           ((0x40000000&(data))>>30)
+#define SYS_PFUNC_NF1_nf_dd_7_pud_en_shift                                           (29)
+#define SYS_PFUNC_NF1_nf_dd_7_pud_en_mask                                            (0x20000000)
+#define SYS_PFUNC_NF1_nf_dd_7_pud_en(data)                                           (0x20000000&((data)<<29))
+#define SYS_PFUNC_NF1_nf_dd_7_pud_en_src(data)                                       ((0x20000000&(data))>>29)
+#define SYS_PFUNC_NF1_get_nf_dd_7_pud_en(data)                                       ((0x20000000&(data))>>29)
+#define SYS_PFUNC_NF1_nf_dd_7_pud_sel_shift                                          (28)
+#define SYS_PFUNC_NF1_nf_dd_7_pud_sel_mask                                           (0x10000000)
+#define SYS_PFUNC_NF1_nf_dd_7_pud_sel(data)                                          (0x10000000&((data)<<28))
+#define SYS_PFUNC_NF1_nf_dd_7_pud_sel_src(data)                                      ((0x10000000&(data))>>28)
+#define SYS_PFUNC_NF1_get_nf_dd_7_pud_sel(data)                                      ((0x10000000&(data))>>28)
+#define SYS_PFUNC_NF1_nf_dd_6_smt_shift                                              (27)
+#define SYS_PFUNC_NF1_nf_dd_6_smt_mask                                               (0x08000000)
+#define SYS_PFUNC_NF1_nf_dd_6_smt(data)                                              (0x08000000&((data)<<27))
+#define SYS_PFUNC_NF1_nf_dd_6_smt_src(data)                                          ((0x08000000&(data))>>27)
+#define SYS_PFUNC_NF1_get_nf_dd_6_smt(data)                                          ((0x08000000&(data))>>27)
+#define SYS_PFUNC_NF1_nf_dd_6_e2_shift                                               (26)
+#define SYS_PFUNC_NF1_nf_dd_6_e2_mask                                                (0x04000000)
+#define SYS_PFUNC_NF1_nf_dd_6_e2(data)                                               (0x04000000&((data)<<26))
+#define SYS_PFUNC_NF1_nf_dd_6_e2_src(data)                                           ((0x04000000&(data))>>26)
+#define SYS_PFUNC_NF1_get_nf_dd_6_e2(data)                                           ((0x04000000&(data))>>26)
+#define SYS_PFUNC_NF1_nf_dd_6_pud_en_shift                                           (25)
+#define SYS_PFUNC_NF1_nf_dd_6_pud_en_mask                                            (0x02000000)
+#define SYS_PFUNC_NF1_nf_dd_6_pud_en(data)                                           (0x02000000&((data)<<25))
+#define SYS_PFUNC_NF1_nf_dd_6_pud_en_src(data)                                       ((0x02000000&(data))>>25)
+#define SYS_PFUNC_NF1_get_nf_dd_6_pud_en(data)                                       ((0x02000000&(data))>>25)
+#define SYS_PFUNC_NF1_nf_dd_6_pud_sel_shift                                          (24)
+#define SYS_PFUNC_NF1_nf_dd_6_pud_sel_mask                                           (0x01000000)
+#define SYS_PFUNC_NF1_nf_dd_6_pud_sel(data)                                          (0x01000000&((data)<<24))
+#define SYS_PFUNC_NF1_nf_dd_6_pud_sel_src(data)                                      ((0x01000000&(data))>>24)
+#define SYS_PFUNC_NF1_get_nf_dd_6_pud_sel(data)                                      ((0x01000000&(data))>>24)
+#define SYS_PFUNC_NF1_nf_dd_5_smt_shift                                              (23)
+#define SYS_PFUNC_NF1_nf_dd_5_smt_mask                                               (0x00800000)
+#define SYS_PFUNC_NF1_nf_dd_5_smt(data)                                              (0x00800000&((data)<<23))
+#define SYS_PFUNC_NF1_nf_dd_5_smt_src(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PFUNC_NF1_get_nf_dd_5_smt(data)                                          ((0x00800000&(data))>>23)
+#define SYS_PFUNC_NF1_nf_dd_5_e2_shift                                               (22)
+#define SYS_PFUNC_NF1_nf_dd_5_e2_mask                                                (0x00400000)
+#define SYS_PFUNC_NF1_nf_dd_5_e2(data)                                               (0x00400000&((data)<<22))
+#define SYS_PFUNC_NF1_nf_dd_5_e2_src(data)                                           ((0x00400000&(data))>>22)
+#define SYS_PFUNC_NF1_get_nf_dd_5_e2(data)                                           ((0x00400000&(data))>>22)
+#define SYS_PFUNC_NF1_nf_dd_5_pud_en_shift                                           (21)
+#define SYS_PFUNC_NF1_nf_dd_5_pud_en_mask                                            (0x00200000)
+#define SYS_PFUNC_NF1_nf_dd_5_pud_en(data)                                           (0x00200000&((data)<<21))
+#define SYS_PFUNC_NF1_nf_dd_5_pud_en_src(data)                                       ((0x00200000&(data))>>21)
+#define SYS_PFUNC_NF1_get_nf_dd_5_pud_en(data)                                       ((0x00200000&(data))>>21)
+#define SYS_PFUNC_NF1_nf_dd_5_pud_sel_shift                                          (20)
+#define SYS_PFUNC_NF1_nf_dd_5_pud_sel_mask                                           (0x00100000)
+#define SYS_PFUNC_NF1_nf_dd_5_pud_sel(data)                                          (0x00100000&((data)<<20))
+#define SYS_PFUNC_NF1_nf_dd_5_pud_sel_src(data)                                      ((0x00100000&(data))>>20)
+#define SYS_PFUNC_NF1_get_nf_dd_5_pud_sel(data)                                      ((0x00100000&(data))>>20)
+#define SYS_PFUNC_NF1_nf_dd_4_smt_shift                                              (19)
+#define SYS_PFUNC_NF1_nf_dd_4_smt_mask                                               (0x00080000)
+#define SYS_PFUNC_NF1_nf_dd_4_smt(data)                                              (0x00080000&((data)<<19))
+#define SYS_PFUNC_NF1_nf_dd_4_smt_src(data)                                          ((0x00080000&(data))>>19)
+#define SYS_PFUNC_NF1_get_nf_dd_4_smt(data)                                          ((0x00080000&(data))>>19)
+#define SYS_PFUNC_NF1_nf_dd_4_e2_shift                                               (18)
+#define SYS_PFUNC_NF1_nf_dd_4_e2_mask                                                (0x00040000)
+#define SYS_PFUNC_NF1_nf_dd_4_e2(data)                                               (0x00040000&((data)<<18))
+#define SYS_PFUNC_NF1_nf_dd_4_e2_src(data)                                           ((0x00040000&(data))>>18)
+#define SYS_PFUNC_NF1_get_nf_dd_4_e2(data)                                           ((0x00040000&(data))>>18)
+#define SYS_PFUNC_NF1_nf_dd_4_pud_en_shift                                           (17)
+#define SYS_PFUNC_NF1_nf_dd_4_pud_en_mask                                            (0x00020000)
+#define SYS_PFUNC_NF1_nf_dd_4_pud_en(data)                                           (0x00020000&((data)<<17))
+#define SYS_PFUNC_NF1_nf_dd_4_pud_en_src(data)                                       ((0x00020000&(data))>>17)
+#define SYS_PFUNC_NF1_get_nf_dd_4_pud_en(data)                                       ((0x00020000&(data))>>17)
+#define SYS_PFUNC_NF1_nf_dd_4_pud_sel_shift                                          (16)
+#define SYS_PFUNC_NF1_nf_dd_4_pud_sel_mask                                           (0x00010000)
+#define SYS_PFUNC_NF1_nf_dd_4_pud_sel(data)                                          (0x00010000&((data)<<16))
+#define SYS_PFUNC_NF1_nf_dd_4_pud_sel_src(data)                                      ((0x00010000&(data))>>16)
+#define SYS_PFUNC_NF1_get_nf_dd_4_pud_sel(data)                                      ((0x00010000&(data))>>16)
+#define SYS_PFUNC_NF1_nf_dd_3_smt_shift                                              (15)
+#define SYS_PFUNC_NF1_nf_dd_3_smt_mask                                               (0x00008000)
+#define SYS_PFUNC_NF1_nf_dd_3_smt(data)                                              (0x00008000&((data)<<15))
+#define SYS_PFUNC_NF1_nf_dd_3_smt_src(data)                                          ((0x00008000&(data))>>15)
+#define SYS_PFUNC_NF1_get_nf_dd_3_smt(data)                                          ((0x00008000&(data))>>15)
+#define SYS_PFUNC_NF1_nf_dd_3_e2_shift                                               (14)
+#define SYS_PFUNC_NF1_nf_dd_3_e2_mask                                                (0x00004000)
+#define SYS_PFUNC_NF1_nf_dd_3_e2(data)                                               (0x00004000&((data)<<14))
+#define SYS_PFUNC_NF1_nf_dd_3_e2_src(data)                                           ((0x00004000&(data))>>14)
+#define SYS_PFUNC_NF1_get_nf_dd_3_e2(data)                                           ((0x00004000&(data))>>14)
+#define SYS_PFUNC_NF1_nf_dd_3_pud_en_shift                                           (13)
+#define SYS_PFUNC_NF1_nf_dd_3_pud_en_mask                                            (0x00002000)
+#define SYS_PFUNC_NF1_nf_dd_3_pud_en(data)                                           (0x00002000&((data)<<13))
+#define SYS_PFUNC_NF1_nf_dd_3_pud_en_src(data)                                       ((0x00002000&(data))>>13)
+#define SYS_PFUNC_NF1_get_nf_dd_3_pud_en(data)                                       ((0x00002000&(data))>>13)
+#define SYS_PFUNC_NF1_nf_dd_3_pud_sel_shift                                          (12)
+#define SYS_PFUNC_NF1_nf_dd_3_pud_sel_mask                                           (0x00001000)
+#define SYS_PFUNC_NF1_nf_dd_3_pud_sel(data)                                          (0x00001000&((data)<<12))
+#define SYS_PFUNC_NF1_nf_dd_3_pud_sel_src(data)                                      ((0x00001000&(data))>>12)
+#define SYS_PFUNC_NF1_get_nf_dd_3_pud_sel(data)                                      ((0x00001000&(data))>>12)
+#define SYS_PFUNC_NF1_nf_dd_2_smt_shift                                              (11)
+#define SYS_PFUNC_NF1_nf_dd_2_smt_mask                                               (0x00000800)
+#define SYS_PFUNC_NF1_nf_dd_2_smt(data)                                              (0x00000800&((data)<<11))
+#define SYS_PFUNC_NF1_nf_dd_2_smt_src(data)                                          ((0x00000800&(data))>>11)
+#define SYS_PFUNC_NF1_get_nf_dd_2_smt(data)                                          ((0x00000800&(data))>>11)
+#define SYS_PFUNC_NF1_nf_dd_2_e2_shift                                               (10)
+#define SYS_PFUNC_NF1_nf_dd_2_e2_mask                                                (0x00000400)
+#define SYS_PFUNC_NF1_nf_dd_2_e2(data)                                               (0x00000400&((data)<<10))
+#define SYS_PFUNC_NF1_nf_dd_2_e2_src(data)                                           ((0x00000400&(data))>>10)
+#define SYS_PFUNC_NF1_get_nf_dd_2_e2(data)                                           ((0x00000400&(data))>>10)
+#define SYS_PFUNC_NF1_nf_dd_2_pud_en_shift                                           (9)
+#define SYS_PFUNC_NF1_nf_dd_2_pud_en_mask                                            (0x00000200)
+#define SYS_PFUNC_NF1_nf_dd_2_pud_en(data)                                           (0x00000200&((data)<<9))
+#define SYS_PFUNC_NF1_nf_dd_2_pud_en_src(data)                                       ((0x00000200&(data))>>9)
+#define SYS_PFUNC_NF1_get_nf_dd_2_pud_en(data)                                       ((0x00000200&(data))>>9)
+#define SYS_PFUNC_NF1_nf_dd_2_pud_sel_shift                                          (8)
+#define SYS_PFUNC_NF1_nf_dd_2_pud_sel_mask                                           (0x00000100)
+#define SYS_PFUNC_NF1_nf_dd_2_pud_sel(data)                                          (0x00000100&((data)<<8))
+#define SYS_PFUNC_NF1_nf_dd_2_pud_sel_src(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PFUNC_NF1_get_nf_dd_2_pud_sel(data)                                      ((0x00000100&(data))>>8)
+#define SYS_PFUNC_NF1_nf_dd_1_smt_shift                                              (7)
+#define SYS_PFUNC_NF1_nf_dd_1_smt_mask                                               (0x00000080)
+#define SYS_PFUNC_NF1_nf_dd_1_smt(data)                                              (0x00000080&((data)<<7))
+#define SYS_PFUNC_NF1_nf_dd_1_smt_src(data)                                          ((0x00000080&(data))>>7)
+#define SYS_PFUNC_NF1_get_nf_dd_1_smt(data)                                          ((0x00000080&(data))>>7)
+#define SYS_PFUNC_NF1_nf_dd_1_e2_shift                                               (6)
+#define SYS_PFUNC_NF1_nf_dd_1_e2_mask                                                (0x00000040)
+#define SYS_PFUNC_NF1_nf_dd_1_e2(data)                                               (0x00000040&((data)<<6))
+#define SYS_PFUNC_NF1_nf_dd_1_e2_src(data)                                           ((0x00000040&(data))>>6)
+#define SYS_PFUNC_NF1_get_nf_dd_1_e2(data)                                           ((0x00000040&(data))>>6)
+#define SYS_PFUNC_NF1_nf_dd_1_pud_en_shift                                           (5)
+#define SYS_PFUNC_NF1_nf_dd_1_pud_en_mask                                            (0x00000020)
+#define SYS_PFUNC_NF1_nf_dd_1_pud_en(data)                                           (0x00000020&((data)<<5))
+#define SYS_PFUNC_NF1_nf_dd_1_pud_en_src(data)                                       ((0x00000020&(data))>>5)
+#define SYS_PFUNC_NF1_get_nf_dd_1_pud_en(data)                                       ((0x00000020&(data))>>5)
+#define SYS_PFUNC_NF1_nf_dd_1_pud_sel_shift                                          (4)
+#define SYS_PFUNC_NF1_nf_dd_1_pud_sel_mask                                           (0x00000010)
+#define SYS_PFUNC_NF1_nf_dd_1_pud_sel(data)                                          (0x00000010&((data)<<4))
+#define SYS_PFUNC_NF1_nf_dd_1_pud_sel_src(data)                                      ((0x00000010&(data))>>4)
+#define SYS_PFUNC_NF1_get_nf_dd_1_pud_sel(data)                                      ((0x00000010&(data))>>4)
+#define SYS_PFUNC_NF1_nf_dd_0_smt_shift                                              (3)
+#define SYS_PFUNC_NF1_nf_dd_0_smt_mask                                               (0x00000008)
+#define SYS_PFUNC_NF1_nf_dd_0_smt(data)                                              (0x00000008&((data)<<3))
+#define SYS_PFUNC_NF1_nf_dd_0_smt_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PFUNC_NF1_get_nf_dd_0_smt(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PFUNC_NF1_nf_dd_0_e2_shift                                               (2)
+#define SYS_PFUNC_NF1_nf_dd_0_e2_mask                                                (0x00000004)
+#define SYS_PFUNC_NF1_nf_dd_0_e2(data)                                               (0x00000004&((data)<<2))
+#define SYS_PFUNC_NF1_nf_dd_0_e2_src(data)                                           ((0x00000004&(data))>>2)
+#define SYS_PFUNC_NF1_get_nf_dd_0_e2(data)                                           ((0x00000004&(data))>>2)
+#define SYS_PFUNC_NF1_nf_dd_0_pud_en_shift                                           (1)
+#define SYS_PFUNC_NF1_nf_dd_0_pud_en_mask                                            (0x00000002)
+#define SYS_PFUNC_NF1_nf_dd_0_pud_en(data)                                           (0x00000002&((data)<<1))
+#define SYS_PFUNC_NF1_nf_dd_0_pud_en_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PFUNC_NF1_get_nf_dd_0_pud_en(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PFUNC_NF1_nf_dd_0_pud_sel_shift                                          (0)
+#define SYS_PFUNC_NF1_nf_dd_0_pud_sel_mask                                           (0x00000001)
+#define SYS_PFUNC_NF1_nf_dd_0_pud_sel(data)                                          (0x00000001&((data)<<0))
+#define SYS_PFUNC_NF1_nf_dd_0_pud_sel_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PFUNC_NF1_get_nf_dd_0_pud_sel(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PFUNC_CR                                                                 0x18000380
+#define SYS_PFUNC_CR_reg_addr                                                        "0xB8000380"
+#define SYS_PFUNC_CR_reg                                                             0xB8000380
+#define set_SYS_PFUNC_CR_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_CR_reg)=data)
+#define get_SYS_PFUNC_CR_reg   (*((volatile unsigned int*) SYS_PFUNC_CR_reg))
+#define SYS_PFUNC_CR_inst_adr                                                        "0x00E0"
+#define SYS_PFUNC_CR_inst                                                            0x00E0
+#define SYS_PFUNC_CR_mmc_data_3_smt_shift                                            (31)
+#define SYS_PFUNC_CR_mmc_data_3_smt_mask                                             (0x80000000)
+#define SYS_PFUNC_CR_mmc_data_3_smt(data)                                            (0x80000000&((data)<<31))
+#define SYS_PFUNC_CR_mmc_data_3_smt_src(data)                                        ((0x80000000&(data))>>31)
+#define SYS_PFUNC_CR_get_mmc_data_3_smt(data)                                        ((0x80000000&(data))>>31)
+#define SYS_PFUNC_CR_mmc_data_3_e2_shift                                             (30)
+#define SYS_PFUNC_CR_mmc_data_3_e2_mask                                              (0x40000000)
+#define SYS_PFUNC_CR_mmc_data_3_e2(data)                                             (0x40000000&((data)<<30))
+#define SYS_PFUNC_CR_mmc_data_3_e2_src(data)                                         ((0x40000000&(data))>>30)
+#define SYS_PFUNC_CR_get_mmc_data_3_e2(data)                                         ((0x40000000&(data))>>30)
+#define SYS_PFUNC_CR_mmc_data_3_pud_en_shift                                         (29)
+#define SYS_PFUNC_CR_mmc_data_3_pud_en_mask                                          (0x20000000)
+#define SYS_PFUNC_CR_mmc_data_3_pud_en(data)                                         (0x20000000&((data)<<29))
+#define SYS_PFUNC_CR_mmc_data_3_pud_en_src(data)                                     ((0x20000000&(data))>>29)
+#define SYS_PFUNC_CR_get_mmc_data_3_pud_en(data)                                     ((0x20000000&(data))>>29)
+#define SYS_PFUNC_CR_mmc_data_3_pud_sel_shift                                        (28)
+#define SYS_PFUNC_CR_mmc_data_3_pud_sel_mask                                         (0x10000000)
+#define SYS_PFUNC_CR_mmc_data_3_pud_sel(data)                                        (0x10000000&((data)<<28))
+#define SYS_PFUNC_CR_mmc_data_3_pud_sel_src(data)                                    ((0x10000000&(data))>>28)
+#define SYS_PFUNC_CR_get_mmc_data_3_pud_sel(data)                                    ((0x10000000&(data))>>28)
+#define SYS_PFUNC_CR_mmc_data_2_smt_shift                                            (27)
+#define SYS_PFUNC_CR_mmc_data_2_smt_mask                                             (0x08000000)
+#define SYS_PFUNC_CR_mmc_data_2_smt(data)                                            (0x08000000&((data)<<27))
+#define SYS_PFUNC_CR_mmc_data_2_smt_src(data)                                        ((0x08000000&(data))>>27)
+#define SYS_PFUNC_CR_get_mmc_data_2_smt(data)                                        ((0x08000000&(data))>>27)
+#define SYS_PFUNC_CR_mmc_data_2_e2_shift                                             (26)
+#define SYS_PFUNC_CR_mmc_data_2_e2_mask                                              (0x04000000)
+#define SYS_PFUNC_CR_mmc_data_2_e2(data)                                             (0x04000000&((data)<<26))
+#define SYS_PFUNC_CR_mmc_data_2_e2_src(data)                                         ((0x04000000&(data))>>26)
+#define SYS_PFUNC_CR_get_mmc_data_2_e2(data)                                         ((0x04000000&(data))>>26)
+#define SYS_PFUNC_CR_mmc_data_2_pud_en_shift                                         (25)
+#define SYS_PFUNC_CR_mmc_data_2_pud_en_mask                                          (0x02000000)
+#define SYS_PFUNC_CR_mmc_data_2_pud_en(data)                                         (0x02000000&((data)<<25))
+#define SYS_PFUNC_CR_mmc_data_2_pud_en_src(data)                                     ((0x02000000&(data))>>25)
+#define SYS_PFUNC_CR_get_mmc_data_2_pud_en(data)                                     ((0x02000000&(data))>>25)
+#define SYS_PFUNC_CR_mmc_data_2_pud_sel_shift                                        (24)
+#define SYS_PFUNC_CR_mmc_data_2_pud_sel_mask                                         (0x01000000)
+#define SYS_PFUNC_CR_mmc_data_2_pud_sel(data)                                        (0x01000000&((data)<<24))
+#define SYS_PFUNC_CR_mmc_data_2_pud_sel_src(data)                                    ((0x01000000&(data))>>24)
+#define SYS_PFUNC_CR_get_mmc_data_2_pud_sel(data)                                    ((0x01000000&(data))>>24)
+#define SYS_PFUNC_CR_mmc_data_1_smt_shift                                            (23)
+#define SYS_PFUNC_CR_mmc_data_1_smt_mask                                             (0x00800000)
+#define SYS_PFUNC_CR_mmc_data_1_smt(data)                                            (0x00800000&((data)<<23))
+#define SYS_PFUNC_CR_mmc_data_1_smt_src(data)                                        ((0x00800000&(data))>>23)
+#define SYS_PFUNC_CR_get_mmc_data_1_smt(data)                                        ((0x00800000&(data))>>23)
+#define SYS_PFUNC_CR_mmc_data_1_e2_shift                                             (22)
+#define SYS_PFUNC_CR_mmc_data_1_e2_mask                                              (0x00400000)
+#define SYS_PFUNC_CR_mmc_data_1_e2(data)                                             (0x00400000&((data)<<22))
+#define SYS_PFUNC_CR_mmc_data_1_e2_src(data)                                         ((0x00400000&(data))>>22)
+#define SYS_PFUNC_CR_get_mmc_data_1_e2(data)                                         ((0x00400000&(data))>>22)
+#define SYS_PFUNC_CR_mmc_data_1_pud_en_shift                                         (21)
+#define SYS_PFUNC_CR_mmc_data_1_pud_en_mask                                          (0x00200000)
+#define SYS_PFUNC_CR_mmc_data_1_pud_en(data)                                         (0x00200000&((data)<<21))
+#define SYS_PFUNC_CR_mmc_data_1_pud_en_src(data)                                     ((0x00200000&(data))>>21)
+#define SYS_PFUNC_CR_get_mmc_data_1_pud_en(data)                                     ((0x00200000&(data))>>21)
+#define SYS_PFUNC_CR_mmc_data_1_pud_sel_shift                                        (20)
+#define SYS_PFUNC_CR_mmc_data_1_pud_sel_mask                                         (0x00100000)
+#define SYS_PFUNC_CR_mmc_data_1_pud_sel(data)                                        (0x00100000&((data)<<20))
+#define SYS_PFUNC_CR_mmc_data_1_pud_sel_src(data)                                    ((0x00100000&(data))>>20)
+#define SYS_PFUNC_CR_get_mmc_data_1_pud_sel(data)                                    ((0x00100000&(data))>>20)
+#define SYS_PFUNC_CR_mmc_data_0_smt_shift                                            (19)
+#define SYS_PFUNC_CR_mmc_data_0_smt_mask                                             (0x00080000)
+#define SYS_PFUNC_CR_mmc_data_0_smt(data)                                            (0x00080000&((data)<<19))
+#define SYS_PFUNC_CR_mmc_data_0_smt_src(data)                                        ((0x00080000&(data))>>19)
+#define SYS_PFUNC_CR_get_mmc_data_0_smt(data)                                        ((0x00080000&(data))>>19)
+#define SYS_PFUNC_CR_mmc_data_0_e2_shift                                             (18)
+#define SYS_PFUNC_CR_mmc_data_0_e2_mask                                              (0x00040000)
+#define SYS_PFUNC_CR_mmc_data_0_e2(data)                                             (0x00040000&((data)<<18))
+#define SYS_PFUNC_CR_mmc_data_0_e2_src(data)                                         ((0x00040000&(data))>>18)
+#define SYS_PFUNC_CR_get_mmc_data_0_e2(data)                                         ((0x00040000&(data))>>18)
+#define SYS_PFUNC_CR_mmc_data_0_pud_en_shift                                         (17)
+#define SYS_PFUNC_CR_mmc_data_0_pud_en_mask                                          (0x00020000)
+#define SYS_PFUNC_CR_mmc_data_0_pud_en(data)                                         (0x00020000&((data)<<17))
+#define SYS_PFUNC_CR_mmc_data_0_pud_en_src(data)                                     ((0x00020000&(data))>>17)
+#define SYS_PFUNC_CR_get_mmc_data_0_pud_en(data)                                     ((0x00020000&(data))>>17)
+#define SYS_PFUNC_CR_mmc_data_0_pud_sel_shift                                        (16)
+#define SYS_PFUNC_CR_mmc_data_0_pud_sel_mask                                         (0x00010000)
+#define SYS_PFUNC_CR_mmc_data_0_pud_sel(data)                                        (0x00010000&((data)<<16))
+#define SYS_PFUNC_CR_mmc_data_0_pud_sel_src(data)                                    ((0x00010000&(data))>>16)
+#define SYS_PFUNC_CR_get_mmc_data_0_pud_sel(data)                                    ((0x00010000&(data))>>16)
+#define SYS_PFUNC_CR_mmc_cd_smt_shift                                                (15)
+#define SYS_PFUNC_CR_mmc_cd_smt_mask                                                 (0x00008000)
+#define SYS_PFUNC_CR_mmc_cd_smt(data)                                                (0x00008000&((data)<<15))
+#define SYS_PFUNC_CR_mmc_cd_smt_src(data)                                            ((0x00008000&(data))>>15)
+#define SYS_PFUNC_CR_get_mmc_cd_smt(data)                                            ((0x00008000&(data))>>15)
+#define SYS_PFUNC_CR_mmc_cd_e2_shift                                                 (14)
+#define SYS_PFUNC_CR_mmc_cd_e2_mask                                                  (0x00004000)
+#define SYS_PFUNC_CR_mmc_cd_e2(data)                                                 (0x00004000&((data)<<14))
+#define SYS_PFUNC_CR_mmc_cd_e2_src(data)                                             ((0x00004000&(data))>>14)
+#define SYS_PFUNC_CR_get_mmc_cd_e2(data)                                             ((0x00004000&(data))>>14)
+#define SYS_PFUNC_CR_mmc_cd_pud_en_shift                                             (13)
+#define SYS_PFUNC_CR_mmc_cd_pud_en_mask                                              (0x00002000)
+#define SYS_PFUNC_CR_mmc_cd_pud_en(data)                                             (0x00002000&((data)<<13))
+#define SYS_PFUNC_CR_mmc_cd_pud_en_src(data)                                         ((0x00002000&(data))>>13)
+#define SYS_PFUNC_CR_get_mmc_cd_pud_en(data)                                         ((0x00002000&(data))>>13)
+#define SYS_PFUNC_CR_mmc_cd_pud_sel_shift                                            (12)
+#define SYS_PFUNC_CR_mmc_cd_pud_sel_mask                                             (0x00001000)
+#define SYS_PFUNC_CR_mmc_cd_pud_sel(data)                                            (0x00001000&((data)<<12))
+#define SYS_PFUNC_CR_mmc_cd_pud_sel_src(data)                                        ((0x00001000&(data))>>12)
+#define SYS_PFUNC_CR_get_mmc_cd_pud_sel(data)                                        ((0x00001000&(data))>>12)
+#define SYS_PFUNC_CR_mmc_wp_smt_shift                                                (11)
+#define SYS_PFUNC_CR_mmc_wp_smt_mask                                                 (0x00000800)
+#define SYS_PFUNC_CR_mmc_wp_smt(data)                                                (0x00000800&((data)<<11))
+#define SYS_PFUNC_CR_mmc_wp_smt_src(data)                                            ((0x00000800&(data))>>11)
+#define SYS_PFUNC_CR_get_mmc_wp_smt(data)                                            ((0x00000800&(data))>>11)
+#define SYS_PFUNC_CR_mmc_wp_e2_shift                                                 (10)
+#define SYS_PFUNC_CR_mmc_wp_e2_mask                                                  (0x00000400)
+#define SYS_PFUNC_CR_mmc_wp_e2(data)                                                 (0x00000400&((data)<<10))
+#define SYS_PFUNC_CR_mmc_wp_e2_src(data)                                             ((0x00000400&(data))>>10)
+#define SYS_PFUNC_CR_get_mmc_wp_e2(data)                                             ((0x00000400&(data))>>10)
+#define SYS_PFUNC_CR_mmc_wp_pud_en_shift                                             (9)
+#define SYS_PFUNC_CR_mmc_wp_pud_en_mask                                              (0x00000200)
+#define SYS_PFUNC_CR_mmc_wp_pud_en(data)                                             (0x00000200&((data)<<9))
+#define SYS_PFUNC_CR_mmc_wp_pud_en_src(data)                                         ((0x00000200&(data))>>9)
+#define SYS_PFUNC_CR_get_mmc_wp_pud_en(data)                                         ((0x00000200&(data))>>9)
+#define SYS_PFUNC_CR_mmc_wp_pud_sel_shift                                            (8)
+#define SYS_PFUNC_CR_mmc_wp_pud_sel_mask                                             (0x00000100)
+#define SYS_PFUNC_CR_mmc_wp_pud_sel(data)                                            (0x00000100&((data)<<8))
+#define SYS_PFUNC_CR_mmc_wp_pud_sel_src(data)                                        ((0x00000100&(data))>>8)
+#define SYS_PFUNC_CR_get_mmc_wp_pud_sel(data)                                        ((0x00000100&(data))>>8)
+#define SYS_PFUNC_CR_mmc_clk_smt_shift                                               (7)
+#define SYS_PFUNC_CR_mmc_clk_smt_mask                                                (0x00000080)
+#define SYS_PFUNC_CR_mmc_clk_smt(data)                                               (0x00000080&((data)<<7))
+#define SYS_PFUNC_CR_mmc_clk_smt_src(data)                                           ((0x00000080&(data))>>7)
+#define SYS_PFUNC_CR_get_mmc_clk_smt(data)                                           ((0x00000080&(data))>>7)
+#define SYS_PFUNC_CR_mmc_clk_e2_shift                                                (6)
+#define SYS_PFUNC_CR_mmc_clk_e2_mask                                                 (0x00000040)
+#define SYS_PFUNC_CR_mmc_clk_e2(data)                                                (0x00000040&((data)<<6))
+#define SYS_PFUNC_CR_mmc_clk_e2_src(data)                                            ((0x00000040&(data))>>6)
+#define SYS_PFUNC_CR_get_mmc_clk_e2(data)                                            ((0x00000040&(data))>>6)
+#define SYS_PFUNC_CR_mmc_clk_pud_en_shift                                            (5)
+#define SYS_PFUNC_CR_mmc_clk_pud_en_mask                                             (0x00000020)
+#define SYS_PFUNC_CR_mmc_clk_pud_en(data)                                            (0x00000020&((data)<<5))
+#define SYS_PFUNC_CR_mmc_clk_pud_en_src(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PFUNC_CR_get_mmc_clk_pud_en(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PFUNC_CR_mmc_clk_pud_sel_shift                                           (4)
+#define SYS_PFUNC_CR_mmc_clk_pud_sel_mask                                            (0x00000010)
+#define SYS_PFUNC_CR_mmc_clk_pud_sel(data)                                           (0x00000010&((data)<<4))
+#define SYS_PFUNC_CR_mmc_clk_pud_sel_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PFUNC_CR_get_mmc_clk_pud_sel(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PFUNC_CR_mmc_cmd_smt_shift                                               (3)
+#define SYS_PFUNC_CR_mmc_cmd_smt_mask                                                (0x00000008)
+#define SYS_PFUNC_CR_mmc_cmd_smt(data)                                               (0x00000008&((data)<<3))
+#define SYS_PFUNC_CR_mmc_cmd_smt_src(data)                                           ((0x00000008&(data))>>3)
+#define SYS_PFUNC_CR_get_mmc_cmd_smt(data)                                           ((0x00000008&(data))>>3)
+#define SYS_PFUNC_CR_mmc_cmd_e2_shift                                                (2)
+#define SYS_PFUNC_CR_mmc_cmd_e2_mask                                                 (0x00000004)
+#define SYS_PFUNC_CR_mmc_cmd_e2(data)                                                (0x00000004&((data)<<2))
+#define SYS_PFUNC_CR_mmc_cmd_e2_src(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PFUNC_CR_get_mmc_cmd_e2(data)                                            ((0x00000004&(data))>>2)
+#define SYS_PFUNC_CR_mmc_cmd_pud_en_shift                                            (1)
+#define SYS_PFUNC_CR_mmc_cmd_pud_en_mask                                             (0x00000002)
+#define SYS_PFUNC_CR_mmc_cmd_pud_en(data)                                            (0x00000002&((data)<<1))
+#define SYS_PFUNC_CR_mmc_cmd_pud_en_src(data)                                        ((0x00000002&(data))>>1)
+#define SYS_PFUNC_CR_get_mmc_cmd_pud_en(data)                                        ((0x00000002&(data))>>1)
+#define SYS_PFUNC_CR_mmc_cmd_pud_sel_shift                                           (0)
+#define SYS_PFUNC_CR_mmc_cmd_pud_sel_mask                                            (0x00000001)
+#define SYS_PFUNC_CR_mmc_cmd_pud_sel(data)                                           (0x00000001&((data)<<0))
+#define SYS_PFUNC_CR_mmc_cmd_pud_sel_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_PFUNC_CR_get_mmc_cmd_pud_sel(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_PFUNC_SDIO                                                               0x18000384
+#define SYS_PFUNC_SDIO_reg_addr                                                      "0xB8000384"
+#define SYS_PFUNC_SDIO_reg                                                           0xB8000384
+#define set_SYS_PFUNC_SDIO_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_SDIO_reg)=data)
+#define get_SYS_PFUNC_SDIO_reg   (*((volatile unsigned int*) SYS_PFUNC_SDIO_reg))
+#define SYS_PFUNC_SDIO_inst_adr                                                      "0x00E1"
+#define SYS_PFUNC_SDIO_inst                                                          0x00E1
+#define SYS_PFUNC_SDIO_sdio_data_3_smt_shift                                         (31)
+#define SYS_PFUNC_SDIO_sdio_data_3_smt_mask                                          (0x80000000)
+#define SYS_PFUNC_SDIO_sdio_data_3_smt(data)                                         (0x80000000&((data)<<31))
+#define SYS_PFUNC_SDIO_sdio_data_3_smt_src(data)                                     ((0x80000000&(data))>>31)
+#define SYS_PFUNC_SDIO_get_sdio_data_3_smt(data)                                     ((0x80000000&(data))>>31)
+#define SYS_PFUNC_SDIO_sdio_data_3_e2_shift                                          (30)
+#define SYS_PFUNC_SDIO_sdio_data_3_e2_mask                                           (0x40000000)
+#define SYS_PFUNC_SDIO_sdio_data_3_e2(data)                                          (0x40000000&((data)<<30))
+#define SYS_PFUNC_SDIO_sdio_data_3_e2_src(data)                                      ((0x40000000&(data))>>30)
+#define SYS_PFUNC_SDIO_get_sdio_data_3_e2(data)                                      ((0x40000000&(data))>>30)
+#define SYS_PFUNC_SDIO_sdio_data_3_pud_en_shift                                      (29)
+#define SYS_PFUNC_SDIO_sdio_data_3_pud_en_mask                                       (0x20000000)
+#define SYS_PFUNC_SDIO_sdio_data_3_pud_en(data)                                      (0x20000000&((data)<<29))
+#define SYS_PFUNC_SDIO_sdio_data_3_pud_en_src(data)                                  ((0x20000000&(data))>>29)
+#define SYS_PFUNC_SDIO_get_sdio_data_3_pud_en(data)                                  ((0x20000000&(data))>>29)
+#define SYS_PFUNC_SDIO_sdio_data_3_pud_sel_shift                                     (28)
+#define SYS_PFUNC_SDIO_sdio_data_3_pud_sel_mask                                      (0x10000000)
+#define SYS_PFUNC_SDIO_sdio_data_3_pud_sel(data)                                     (0x10000000&((data)<<28))
+#define SYS_PFUNC_SDIO_sdio_data_3_pud_sel_src(data)                                 ((0x10000000&(data))>>28)
+#define SYS_PFUNC_SDIO_get_sdio_data_3_pud_sel(data)                                 ((0x10000000&(data))>>28)
+#define SYS_PFUNC_SDIO_sdio_data_2_smt_shift                                         (27)
+#define SYS_PFUNC_SDIO_sdio_data_2_smt_mask                                          (0x08000000)
+#define SYS_PFUNC_SDIO_sdio_data_2_smt(data)                                         (0x08000000&((data)<<27))
+#define SYS_PFUNC_SDIO_sdio_data_2_smt_src(data)                                     ((0x08000000&(data))>>27)
+#define SYS_PFUNC_SDIO_get_sdio_data_2_smt(data)                                     ((0x08000000&(data))>>27)
+#define SYS_PFUNC_SDIO_sdio_data_2_e2_shift                                          (26)
+#define SYS_PFUNC_SDIO_sdio_data_2_e2_mask                                           (0x04000000)
+#define SYS_PFUNC_SDIO_sdio_data_2_e2(data)                                          (0x04000000&((data)<<26))
+#define SYS_PFUNC_SDIO_sdio_data_2_e2_src(data)                                      ((0x04000000&(data))>>26)
+#define SYS_PFUNC_SDIO_get_sdio_data_2_e2(data)                                      ((0x04000000&(data))>>26)
+#define SYS_PFUNC_SDIO_sdio_data_2_pud_en_shift                                      (25)
+#define SYS_PFUNC_SDIO_sdio_data_2_pud_en_mask                                       (0x02000000)
+#define SYS_PFUNC_SDIO_sdio_data_2_pud_en(data)                                      (0x02000000&((data)<<25))
+#define SYS_PFUNC_SDIO_sdio_data_2_pud_en_src(data)                                  ((0x02000000&(data))>>25)
+#define SYS_PFUNC_SDIO_get_sdio_data_2_pud_en(data)                                  ((0x02000000&(data))>>25)
+#define SYS_PFUNC_SDIO_sdio_data_2_pud_sel_shift                                     (24)
+#define SYS_PFUNC_SDIO_sdio_data_2_pud_sel_mask                                      (0x01000000)
+#define SYS_PFUNC_SDIO_sdio_data_2_pud_sel(data)                                     (0x01000000&((data)<<24))
+#define SYS_PFUNC_SDIO_sdio_data_2_pud_sel_src(data)                                 ((0x01000000&(data))>>24)
+#define SYS_PFUNC_SDIO_get_sdio_data_2_pud_sel(data)                                 ((0x01000000&(data))>>24)
+#define SYS_PFUNC_SDIO_sdio_data_1_smt_shift                                         (23)
+#define SYS_PFUNC_SDIO_sdio_data_1_smt_mask                                          (0x00800000)
+#define SYS_PFUNC_SDIO_sdio_data_1_smt(data)                                         (0x00800000&((data)<<23))
+#define SYS_PFUNC_SDIO_sdio_data_1_smt_src(data)                                     ((0x00800000&(data))>>23)
+#define SYS_PFUNC_SDIO_get_sdio_data_1_smt(data)                                     ((0x00800000&(data))>>23)
+#define SYS_PFUNC_SDIO_sdio_data_1_e2_shift                                          (22)
+#define SYS_PFUNC_SDIO_sdio_data_1_e2_mask                                           (0x00400000)
+#define SYS_PFUNC_SDIO_sdio_data_1_e2(data)                                          (0x00400000&((data)<<22))
+#define SYS_PFUNC_SDIO_sdio_data_1_e2_src(data)                                      ((0x00400000&(data))>>22)
+#define SYS_PFUNC_SDIO_get_sdio_data_1_e2(data)                                      ((0x00400000&(data))>>22)
+#define SYS_PFUNC_SDIO_sdio_data_1_pud_en_shift                                      (21)
+#define SYS_PFUNC_SDIO_sdio_data_1_pud_en_mask                                       (0x00200000)
+#define SYS_PFUNC_SDIO_sdio_data_1_pud_en(data)                                      (0x00200000&((data)<<21))
+#define SYS_PFUNC_SDIO_sdio_data_1_pud_en_src(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PFUNC_SDIO_get_sdio_data_1_pud_en(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PFUNC_SDIO_sdio_data_1_pud_sel_shift                                     (20)
+#define SYS_PFUNC_SDIO_sdio_data_1_pud_sel_mask                                      (0x00100000)
+#define SYS_PFUNC_SDIO_sdio_data_1_pud_sel(data)                                     (0x00100000&((data)<<20))
+#define SYS_PFUNC_SDIO_sdio_data_1_pud_sel_src(data)                                 ((0x00100000&(data))>>20)
+#define SYS_PFUNC_SDIO_get_sdio_data_1_pud_sel(data)                                 ((0x00100000&(data))>>20)
+#define SYS_PFUNC_SDIO_sdio_data_0_smt_shift                                         (19)
+#define SYS_PFUNC_SDIO_sdio_data_0_smt_mask                                          (0x00080000)
+#define SYS_PFUNC_SDIO_sdio_data_0_smt(data)                                         (0x00080000&((data)<<19))
+#define SYS_PFUNC_SDIO_sdio_data_0_smt_src(data)                                     ((0x00080000&(data))>>19)
+#define SYS_PFUNC_SDIO_get_sdio_data_0_smt(data)                                     ((0x00080000&(data))>>19)
+#define SYS_PFUNC_SDIO_sdio_data_0_e2_shift                                          (18)
+#define SYS_PFUNC_SDIO_sdio_data_0_e2_mask                                           (0x00040000)
+#define SYS_PFUNC_SDIO_sdio_data_0_e2(data)                                          (0x00040000&((data)<<18))
+#define SYS_PFUNC_SDIO_sdio_data_0_e2_src(data)                                      ((0x00040000&(data))>>18)
+#define SYS_PFUNC_SDIO_get_sdio_data_0_e2(data)                                      ((0x00040000&(data))>>18)
+#define SYS_PFUNC_SDIO_sdio_data_0_pud_en_shift                                      (17)
+#define SYS_PFUNC_SDIO_sdio_data_0_pud_en_mask                                       (0x00020000)
+#define SYS_PFUNC_SDIO_sdio_data_0_pud_en(data)                                      (0x00020000&((data)<<17))
+#define SYS_PFUNC_SDIO_sdio_data_0_pud_en_src(data)                                  ((0x00020000&(data))>>17)
+#define SYS_PFUNC_SDIO_get_sdio_data_0_pud_en(data)                                  ((0x00020000&(data))>>17)
+#define SYS_PFUNC_SDIO_sdio_data_0_pud_sel_shift                                     (16)
+#define SYS_PFUNC_SDIO_sdio_data_0_pud_sel_mask                                      (0x00010000)
+#define SYS_PFUNC_SDIO_sdio_data_0_pud_sel(data)                                     (0x00010000&((data)<<16))
+#define SYS_PFUNC_SDIO_sdio_data_0_pud_sel_src(data)                                 ((0x00010000&(data))>>16)
+#define SYS_PFUNC_SDIO_get_sdio_data_0_pud_sel(data)                                 ((0x00010000&(data))>>16)
+#define SYS_PFUNC_SDIO_sdio_cd_smt_shift                                             (15)
+#define SYS_PFUNC_SDIO_sdio_cd_smt_mask                                              (0x00008000)
+#define SYS_PFUNC_SDIO_sdio_cd_smt(data)                                             (0x00008000&((data)<<15))
+#define SYS_PFUNC_SDIO_sdio_cd_smt_src(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PFUNC_SDIO_get_sdio_cd_smt(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PFUNC_SDIO_sdio_cd_e2_shift                                              (14)
+#define SYS_PFUNC_SDIO_sdio_cd_e2_mask                                               (0x00004000)
+#define SYS_PFUNC_SDIO_sdio_cd_e2(data)                                              (0x00004000&((data)<<14))
+#define SYS_PFUNC_SDIO_sdio_cd_e2_src(data)                                          ((0x00004000&(data))>>14)
+#define SYS_PFUNC_SDIO_get_sdio_cd_e2(data)                                          ((0x00004000&(data))>>14)
+#define SYS_PFUNC_SDIO_sdio_cd_pud_en_shift                                          (13)
+#define SYS_PFUNC_SDIO_sdio_cd_pud_en_mask                                           (0x00002000)
+#define SYS_PFUNC_SDIO_sdio_cd_pud_en(data)                                          (0x00002000&((data)<<13))
+#define SYS_PFUNC_SDIO_sdio_cd_pud_en_src(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PFUNC_SDIO_get_sdio_cd_pud_en(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PFUNC_SDIO_sdio_cd_pud_sel_shift                                         (12)
+#define SYS_PFUNC_SDIO_sdio_cd_pud_sel_mask                                          (0x00001000)
+#define SYS_PFUNC_SDIO_sdio_cd_pud_sel(data)                                         (0x00001000&((data)<<12))
+#define SYS_PFUNC_SDIO_sdio_cd_pud_sel_src(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PFUNC_SDIO_get_sdio_cd_pud_sel(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PFUNC_SDIO_sdio_wp_smt_shift                                             (11)
+#define SYS_PFUNC_SDIO_sdio_wp_smt_mask                                              (0x00000800)
+#define SYS_PFUNC_SDIO_sdio_wp_smt(data)                                             (0x00000800&((data)<<11))
+#define SYS_PFUNC_SDIO_sdio_wp_smt_src(data)                                         ((0x00000800&(data))>>11)
+#define SYS_PFUNC_SDIO_get_sdio_wp_smt(data)                                         ((0x00000800&(data))>>11)
+#define SYS_PFUNC_SDIO_sdio_wp_e2_shift                                              (10)
+#define SYS_PFUNC_SDIO_sdio_wp_e2_mask                                               (0x00000400)
+#define SYS_PFUNC_SDIO_sdio_wp_e2(data)                                              (0x00000400&((data)<<10))
+#define SYS_PFUNC_SDIO_sdio_wp_e2_src(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PFUNC_SDIO_get_sdio_wp_e2(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PFUNC_SDIO_sdio_wp_pud_en_shift                                          (9)
+#define SYS_PFUNC_SDIO_sdio_wp_pud_en_mask                                           (0x00000200)
+#define SYS_PFUNC_SDIO_sdio_wp_pud_en(data)                                          (0x00000200&((data)<<9))
+#define SYS_PFUNC_SDIO_sdio_wp_pud_en_src(data)                                      ((0x00000200&(data))>>9)
+#define SYS_PFUNC_SDIO_get_sdio_wp_pud_en(data)                                      ((0x00000200&(data))>>9)
+#define SYS_PFUNC_SDIO_sdio_wp_pud_sel_shift                                         (8)
+#define SYS_PFUNC_SDIO_sdio_wp_pud_sel_mask                                          (0x00000100)
+#define SYS_PFUNC_SDIO_sdio_wp_pud_sel(data)                                         (0x00000100&((data)<<8))
+#define SYS_PFUNC_SDIO_sdio_wp_pud_sel_src(data)                                     ((0x00000100&(data))>>8)
+#define SYS_PFUNC_SDIO_get_sdio_wp_pud_sel(data)                                     ((0x00000100&(data))>>8)
+#define SYS_PFUNC_SDIO_sdio_clk_smt_shift                                            (7)
+#define SYS_PFUNC_SDIO_sdio_clk_smt_mask                                             (0x00000080)
+#define SYS_PFUNC_SDIO_sdio_clk_smt(data)                                            (0x00000080&((data)<<7))
+#define SYS_PFUNC_SDIO_sdio_clk_smt_src(data)                                        ((0x00000080&(data))>>7)
+#define SYS_PFUNC_SDIO_get_sdio_clk_smt(data)                                        ((0x00000080&(data))>>7)
+#define SYS_PFUNC_SDIO_sdio_clk_e2_shift                                             (6)
+#define SYS_PFUNC_SDIO_sdio_clk_e2_mask                                              (0x00000040)
+#define SYS_PFUNC_SDIO_sdio_clk_e2(data)                                             (0x00000040&((data)<<6))
+#define SYS_PFUNC_SDIO_sdio_clk_e2_src(data)                                         ((0x00000040&(data))>>6)
+#define SYS_PFUNC_SDIO_get_sdio_clk_e2(data)                                         ((0x00000040&(data))>>6)
+#define SYS_PFUNC_SDIO_sdio_clk_pud_en_shift                                         (5)
+#define SYS_PFUNC_SDIO_sdio_clk_pud_en_mask                                          (0x00000020)
+#define SYS_PFUNC_SDIO_sdio_clk_pud_en(data)                                         (0x00000020&((data)<<5))
+#define SYS_PFUNC_SDIO_sdio_clk_pud_en_src(data)                                     ((0x00000020&(data))>>5)
+#define SYS_PFUNC_SDIO_get_sdio_clk_pud_en(data)                                     ((0x00000020&(data))>>5)
+#define SYS_PFUNC_SDIO_sdio_clk_pud_sel_shift                                        (4)
+#define SYS_PFUNC_SDIO_sdio_clk_pud_sel_mask                                         (0x00000010)
+#define SYS_PFUNC_SDIO_sdio_clk_pud_sel(data)                                        (0x00000010&((data)<<4))
+#define SYS_PFUNC_SDIO_sdio_clk_pud_sel_src(data)                                    ((0x00000010&(data))>>4)
+#define SYS_PFUNC_SDIO_get_sdio_clk_pud_sel(data)                                    ((0x00000010&(data))>>4)
+#define SYS_PFUNC_SDIO_sdio_cmd_smt_shift                                            (3)
+#define SYS_PFUNC_SDIO_sdio_cmd_smt_mask                                             (0x00000008)
+#define SYS_PFUNC_SDIO_sdio_cmd_smt(data)                                            (0x00000008&((data)<<3))
+#define SYS_PFUNC_SDIO_sdio_cmd_smt_src(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PFUNC_SDIO_get_sdio_cmd_smt(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PFUNC_SDIO_sdio_cmd_e2_shift                                             (2)
+#define SYS_PFUNC_SDIO_sdio_cmd_e2_mask                                              (0x00000004)
+#define SYS_PFUNC_SDIO_sdio_cmd_e2(data)                                             (0x00000004&((data)<<2))
+#define SYS_PFUNC_SDIO_sdio_cmd_e2_src(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PFUNC_SDIO_get_sdio_cmd_e2(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PFUNC_SDIO_sdio_cmd_pud_en_shift                                         (1)
+#define SYS_PFUNC_SDIO_sdio_cmd_pud_en_mask                                          (0x00000002)
+#define SYS_PFUNC_SDIO_sdio_cmd_pud_en(data)                                         (0x00000002&((data)<<1))
+#define SYS_PFUNC_SDIO_sdio_cmd_pud_en_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PFUNC_SDIO_get_sdio_cmd_pud_en(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PFUNC_SDIO_sdio_cmd_pud_sel_shift                                        (0)
+#define SYS_PFUNC_SDIO_sdio_cmd_pud_sel_mask                                         (0x00000001)
+#define SYS_PFUNC_SDIO_sdio_cmd_pud_sel(data)                                        (0x00000001&((data)<<0))
+#define SYS_PFUNC_SDIO_sdio_cmd_pud_sel_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PFUNC_SDIO_get_sdio_cmd_pud_sel(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PFUNC_AIO                                                                0x18000388
+#define SYS_PFUNC_AIO_reg_addr                                                       "0xB8000388"
+#define SYS_PFUNC_AIO_reg                                                            0xB8000388
+#define set_SYS_PFUNC_AIO_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_AIO_reg)=data)
+#define get_SYS_PFUNC_AIO_reg   (*((volatile unsigned int*) SYS_PFUNC_AIO_reg))
+#define SYS_PFUNC_AIO_inst_adr                                                       "0x00E2"
+#define SYS_PFUNC_AIO_inst                                                           0x00E2
+#define SYS_PFUNC_AIO_spdif_out_e2_shift                                             (2)
+#define SYS_PFUNC_AIO_spdif_out_e2_mask                                              (0x00000004)
+#define SYS_PFUNC_AIO_spdif_out_e2(data)                                             (0x00000004&((data)<<2))
+#define SYS_PFUNC_AIO_spdif_out_e2_src(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PFUNC_AIO_get_spdif_out_e2(data)                                         ((0x00000004&(data))>>2)
+#define SYS_PFUNC_AIO_spdif_out_pud_en_shift                                         (1)
+#define SYS_PFUNC_AIO_spdif_out_pud_en_mask                                          (0x00000002)
+#define SYS_PFUNC_AIO_spdif_out_pud_en(data)                                         (0x00000002&((data)<<1))
+#define SYS_PFUNC_AIO_spdif_out_pud_en_src(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PFUNC_AIO_get_spdif_out_pud_en(data)                                     ((0x00000002&(data))>>1)
+#define SYS_PFUNC_AIO_spdif_out_pud_sel_shift                                        (0)
+#define SYS_PFUNC_AIO_spdif_out_pud_sel_mask                                         (0x00000001)
+#define SYS_PFUNC_AIO_spdif_out_pud_sel(data)                                        (0x00000001&((data)<<0))
+#define SYS_PFUNC_AIO_spdif_out_pud_sel_src(data)                                    ((0x00000001&(data))>>0)
+#define SYS_PFUNC_AIO_get_spdif_out_pud_sel(data)                                    ((0x00000001&(data))>>0)
+
+
+#define SYS_PFUNC_TP0                                                                0x1800038C
+#define SYS_PFUNC_TP0_reg_addr                                                       "0xB800038C"
+#define SYS_PFUNC_TP0_reg                                                            0xB800038C
+#define set_SYS_PFUNC_TP0_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_TP0_reg)=data)
+#define get_SYS_PFUNC_TP0_reg   (*((volatile unsigned int*) SYS_PFUNC_TP0_reg))
+#define SYS_PFUNC_TP0_inst_adr                                                       "0x00E3"
+#define SYS_PFUNC_TP0_inst                                                           0x00E3
+#define SYS_PFUNC_TP0_tp0_data_smt_shift                                             (15)
+#define SYS_PFUNC_TP0_tp0_data_smt_mask                                              (0x00008000)
+#define SYS_PFUNC_TP0_tp0_data_smt(data)                                             (0x00008000&((data)<<15))
+#define SYS_PFUNC_TP0_tp0_data_smt_src(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PFUNC_TP0_get_tp0_data_smt(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PFUNC_TP0_tp0_data_e2_shift                                              (14)
+#define SYS_PFUNC_TP0_tp0_data_e2_mask                                               (0x00004000)
+#define SYS_PFUNC_TP0_tp0_data_e2(data)                                              (0x00004000&((data)<<14))
+#define SYS_PFUNC_TP0_tp0_data_e2_src(data)                                          ((0x00004000&(data))>>14)
+#define SYS_PFUNC_TP0_get_tp0_data_e2(data)                                          ((0x00004000&(data))>>14)
+#define SYS_PFUNC_TP0_tp0_data_pud_en_shift                                          (13)
+#define SYS_PFUNC_TP0_tp0_data_pud_en_mask                                           (0x00002000)
+#define SYS_PFUNC_TP0_tp0_data_pud_en(data)                                          (0x00002000&((data)<<13))
+#define SYS_PFUNC_TP0_tp0_data_pud_en_src(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PFUNC_TP0_get_tp0_data_pud_en(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PFUNC_TP0_tp0_data_pud_sel_shift                                         (12)
+#define SYS_PFUNC_TP0_tp0_data_pud_sel_mask                                          (0x00001000)
+#define SYS_PFUNC_TP0_tp0_data_pud_sel(data)                                         (0x00001000&((data)<<12))
+#define SYS_PFUNC_TP0_tp0_data_pud_sel_src(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PFUNC_TP0_get_tp0_data_pud_sel(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PFUNC_TP0_tp0_valid_smt_shift                                            (11)
+#define SYS_PFUNC_TP0_tp0_valid_smt_mask                                             (0x00000800)
+#define SYS_PFUNC_TP0_tp0_valid_smt(data)                                            (0x00000800&((data)<<11))
+#define SYS_PFUNC_TP0_tp0_valid_smt_src(data)                                        ((0x00000800&(data))>>11)
+#define SYS_PFUNC_TP0_get_tp0_valid_smt(data)                                        ((0x00000800&(data))>>11)
+#define SYS_PFUNC_TP0_tp0_valid_e2_shift                                             (10)
+#define SYS_PFUNC_TP0_tp0_valid_e2_mask                                              (0x00000400)
+#define SYS_PFUNC_TP0_tp0_valid_e2(data)                                             (0x00000400&((data)<<10))
+#define SYS_PFUNC_TP0_tp0_valid_e2_src(data)                                         ((0x00000400&(data))>>10)
+#define SYS_PFUNC_TP0_get_tp0_valid_e2(data)                                         ((0x00000400&(data))>>10)
+#define SYS_PFUNC_TP0_tp0_valid_pud_en_shift                                         (9)
+#define SYS_PFUNC_TP0_tp0_valid_pud_en_mask                                          (0x00000200)
+#define SYS_PFUNC_TP0_tp0_valid_pud_en(data)                                         (0x00000200&((data)<<9))
+#define SYS_PFUNC_TP0_tp0_valid_pud_en_src(data)                                     ((0x00000200&(data))>>9)
+#define SYS_PFUNC_TP0_get_tp0_valid_pud_en(data)                                     ((0x00000200&(data))>>9)
+#define SYS_PFUNC_TP0_tp0_valid_pud_sel_shift                                        (8)
+#define SYS_PFUNC_TP0_tp0_valid_pud_sel_mask                                         (0x00000100)
+#define SYS_PFUNC_TP0_tp0_valid_pud_sel(data)                                        (0x00000100&((data)<<8))
+#define SYS_PFUNC_TP0_tp0_valid_pud_sel_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PFUNC_TP0_get_tp0_valid_pud_sel(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PFUNC_TP0_tp0_sync_smt_shift                                             (7)
+#define SYS_PFUNC_TP0_tp0_sync_smt_mask                                              (0x00000080)
+#define SYS_PFUNC_TP0_tp0_sync_smt(data)                                             (0x00000080&((data)<<7))
+#define SYS_PFUNC_TP0_tp0_sync_smt_src(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PFUNC_TP0_get_tp0_sync_smt(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PFUNC_TP0_tp0_sync_e2_shift                                              (6)
+#define SYS_PFUNC_TP0_tp0_sync_e2_mask                                               (0x00000040)
+#define SYS_PFUNC_TP0_tp0_sync_e2(data)                                              (0x00000040&((data)<<6))
+#define SYS_PFUNC_TP0_tp0_sync_e2_src(data)                                          ((0x00000040&(data))>>6)
+#define SYS_PFUNC_TP0_get_tp0_sync_e2(data)                                          ((0x00000040&(data))>>6)
+#define SYS_PFUNC_TP0_tp0_sync_pud_en_shift                                          (5)
+#define SYS_PFUNC_TP0_tp0_sync_pud_en_mask                                           (0x00000020)
+#define SYS_PFUNC_TP0_tp0_sync_pud_en(data)                                          (0x00000020&((data)<<5))
+#define SYS_PFUNC_TP0_tp0_sync_pud_en_src(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PFUNC_TP0_get_tp0_sync_pud_en(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PFUNC_TP0_tp0_sync_pud_sel_shift                                         (4)
+#define SYS_PFUNC_TP0_tp0_sync_pud_sel_mask                                          (0x00000010)
+#define SYS_PFUNC_TP0_tp0_sync_pud_sel(data)                                         (0x00000010&((data)<<4))
+#define SYS_PFUNC_TP0_tp0_sync_pud_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define SYS_PFUNC_TP0_get_tp0_sync_pud_sel(data)                                     ((0x00000010&(data))>>4)
+#define SYS_PFUNC_TP0_tp0_clk_smt_shift                                              (3)
+#define SYS_PFUNC_TP0_tp0_clk_smt_mask                                               (0x00000008)
+#define SYS_PFUNC_TP0_tp0_clk_smt(data)                                              (0x00000008&((data)<<3))
+#define SYS_PFUNC_TP0_tp0_clk_smt_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PFUNC_TP0_get_tp0_clk_smt(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PFUNC_TP0_tp0_clk_e2_shift                                               (2)
+#define SYS_PFUNC_TP0_tp0_clk_e2_mask                                                (0x00000004)
+#define SYS_PFUNC_TP0_tp0_clk_e2(data)                                               (0x00000004&((data)<<2))
+#define SYS_PFUNC_TP0_tp0_clk_e2_src(data)                                           ((0x00000004&(data))>>2)
+#define SYS_PFUNC_TP0_get_tp0_clk_e2(data)                                           ((0x00000004&(data))>>2)
+#define SYS_PFUNC_TP0_tp0_clk_pud_en_shift                                           (1)
+#define SYS_PFUNC_TP0_tp0_clk_pud_en_mask                                            (0x00000002)
+#define SYS_PFUNC_TP0_tp0_clk_pud_en(data)                                           (0x00000002&((data)<<1))
+#define SYS_PFUNC_TP0_tp0_clk_pud_en_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PFUNC_TP0_get_tp0_clk_pud_en(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PFUNC_TP0_tp0_clk_pud_sel_shift                                          (0)
+#define SYS_PFUNC_TP0_tp0_clk_pud_sel_mask                                           (0x00000001)
+#define SYS_PFUNC_TP0_tp0_clk_pud_sel(data)                                          (0x00000001&((data)<<0))
+#define SYS_PFUNC_TP0_tp0_clk_pud_sel_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PFUNC_TP0_get_tp0_clk_pud_sel(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PFUNC_TP1                                                                0x18000390
+#define SYS_PFUNC_TP1_reg_addr                                                       "0xB8000390"
+#define SYS_PFUNC_TP1_reg                                                            0xB8000390
+#define set_SYS_PFUNC_TP1_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_TP1_reg)=data)
+#define get_SYS_PFUNC_TP1_reg   (*((volatile unsigned int*) SYS_PFUNC_TP1_reg))
+#define SYS_PFUNC_TP1_inst_adr                                                       "0x00E4"
+#define SYS_PFUNC_TP1_inst                                                           0x00E4
+#define SYS_PFUNC_TP1_tp1_data_smt_shift                                             (15)
+#define SYS_PFUNC_TP1_tp1_data_smt_mask                                              (0x00008000)
+#define SYS_PFUNC_TP1_tp1_data_smt(data)                                             (0x00008000&((data)<<15))
+#define SYS_PFUNC_TP1_tp1_data_smt_src(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PFUNC_TP1_get_tp1_data_smt(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PFUNC_TP1_tp1_data_e2_shift                                              (14)
+#define SYS_PFUNC_TP1_tp1_data_e2_mask                                               (0x00004000)
+#define SYS_PFUNC_TP1_tp1_data_e2(data)                                              (0x00004000&((data)<<14))
+#define SYS_PFUNC_TP1_tp1_data_e2_src(data)                                          ((0x00004000&(data))>>14)
+#define SYS_PFUNC_TP1_get_tp1_data_e2(data)                                          ((0x00004000&(data))>>14)
+#define SYS_PFUNC_TP1_tp1_data_pud_en_shift                                          (13)
+#define SYS_PFUNC_TP1_tp1_data_pud_en_mask                                           (0x00002000)
+#define SYS_PFUNC_TP1_tp1_data_pud_en(data)                                          (0x00002000&((data)<<13))
+#define SYS_PFUNC_TP1_tp1_data_pud_en_src(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PFUNC_TP1_get_tp1_data_pud_en(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PFUNC_TP1_tp1_data_pud_sel_shift                                         (12)
+#define SYS_PFUNC_TP1_tp1_data_pud_sel_mask                                          (0x00001000)
+#define SYS_PFUNC_TP1_tp1_data_pud_sel(data)                                         (0x00001000&((data)<<12))
+#define SYS_PFUNC_TP1_tp1_data_pud_sel_src(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PFUNC_TP1_get_tp1_data_pud_sel(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PFUNC_TP1_tp1_valid_smt_shift                                            (11)
+#define SYS_PFUNC_TP1_tp1_valid_smt_mask                                             (0x00000800)
+#define SYS_PFUNC_TP1_tp1_valid_smt(data)                                            (0x00000800&((data)<<11))
+#define SYS_PFUNC_TP1_tp1_valid_smt_src(data)                                        ((0x00000800&(data))>>11)
+#define SYS_PFUNC_TP1_get_tp1_valid_smt(data)                                        ((0x00000800&(data))>>11)
+#define SYS_PFUNC_TP1_tp1_valid_e2_shift                                             (10)
+#define SYS_PFUNC_TP1_tp1_valid_e2_mask                                              (0x00000400)
+#define SYS_PFUNC_TP1_tp1_valid_e2(data)                                             (0x00000400&((data)<<10))
+#define SYS_PFUNC_TP1_tp1_valid_e2_src(data)                                         ((0x00000400&(data))>>10)
+#define SYS_PFUNC_TP1_get_tp1_valid_e2(data)                                         ((0x00000400&(data))>>10)
+#define SYS_PFUNC_TP1_tp1_valid_pud_en_shift                                         (9)
+#define SYS_PFUNC_TP1_tp1_valid_pud_en_mask                                          (0x00000200)
+#define SYS_PFUNC_TP1_tp1_valid_pud_en(data)                                         (0x00000200&((data)<<9))
+#define SYS_PFUNC_TP1_tp1_valid_pud_en_src(data)                                     ((0x00000200&(data))>>9)
+#define SYS_PFUNC_TP1_get_tp1_valid_pud_en(data)                                     ((0x00000200&(data))>>9)
+#define SYS_PFUNC_TP1_tp1_valid_pud_sel_shift                                        (8)
+#define SYS_PFUNC_TP1_tp1_valid_pud_sel_mask                                         (0x00000100)
+#define SYS_PFUNC_TP1_tp1_valid_pud_sel(data)                                        (0x00000100&((data)<<8))
+#define SYS_PFUNC_TP1_tp1_valid_pud_sel_src(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PFUNC_TP1_get_tp1_valid_pud_sel(data)                                    ((0x00000100&(data))>>8)
+#define SYS_PFUNC_TP1_tp1_sync_smt_shift                                             (7)
+#define SYS_PFUNC_TP1_tp1_sync_smt_mask                                              (0x00000080)
+#define SYS_PFUNC_TP1_tp1_sync_smt(data)                                             (0x00000080&((data)<<7))
+#define SYS_PFUNC_TP1_tp1_sync_smt_src(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PFUNC_TP1_get_tp1_sync_smt(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PFUNC_TP1_tp1_sync_e2_shift                                              (6)
+#define SYS_PFUNC_TP1_tp1_sync_e2_mask                                               (0x00000040)
+#define SYS_PFUNC_TP1_tp1_sync_e2(data)                                              (0x00000040&((data)<<6))
+#define SYS_PFUNC_TP1_tp1_sync_e2_src(data)                                          ((0x00000040&(data))>>6)
+#define SYS_PFUNC_TP1_get_tp1_sync_e2(data)                                          ((0x00000040&(data))>>6)
+#define SYS_PFUNC_TP1_tp1_sync_pud_en_shift                                          (5)
+#define SYS_PFUNC_TP1_tp1_sync_pud_en_mask                                           (0x00000020)
+#define SYS_PFUNC_TP1_tp1_sync_pud_en(data)                                          (0x00000020&((data)<<5))
+#define SYS_PFUNC_TP1_tp1_sync_pud_en_src(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PFUNC_TP1_get_tp1_sync_pud_en(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PFUNC_TP1_tp1_sync_pud_sel_shift                                         (4)
+#define SYS_PFUNC_TP1_tp1_sync_pud_sel_mask                                          (0x00000010)
+#define SYS_PFUNC_TP1_tp1_sync_pud_sel(data)                                         (0x00000010&((data)<<4))
+#define SYS_PFUNC_TP1_tp1_sync_pud_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define SYS_PFUNC_TP1_get_tp1_sync_pud_sel(data)                                     ((0x00000010&(data))>>4)
+#define SYS_PFUNC_TP1_tp1_clk_smt_shift                                              (3)
+#define SYS_PFUNC_TP1_tp1_clk_smt_mask                                               (0x00000008)
+#define SYS_PFUNC_TP1_tp1_clk_smt(data)                                              (0x00000008&((data)<<3))
+#define SYS_PFUNC_TP1_tp1_clk_smt_src(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PFUNC_TP1_get_tp1_clk_smt(data)                                          ((0x00000008&(data))>>3)
+#define SYS_PFUNC_TP1_tp1_clk_e2_shift                                               (2)
+#define SYS_PFUNC_TP1_tp1_clk_e2_mask                                                (0x00000004)
+#define SYS_PFUNC_TP1_tp1_clk_e2(data)                                               (0x00000004&((data)<<2))
+#define SYS_PFUNC_TP1_tp1_clk_e2_src(data)                                           ((0x00000004&(data))>>2)
+#define SYS_PFUNC_TP1_get_tp1_clk_e2(data)                                           ((0x00000004&(data))>>2)
+#define SYS_PFUNC_TP1_tp1_clk_pud_en_shift                                           (1)
+#define SYS_PFUNC_TP1_tp1_clk_pud_en_mask                                            (0x00000002)
+#define SYS_PFUNC_TP1_tp1_clk_pud_en(data)                                           (0x00000002&((data)<<1))
+#define SYS_PFUNC_TP1_tp1_clk_pud_en_src(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PFUNC_TP1_get_tp1_clk_pud_en(data)                                       ((0x00000002&(data))>>1)
+#define SYS_PFUNC_TP1_tp1_clk_pud_sel_shift                                          (0)
+#define SYS_PFUNC_TP1_tp1_clk_pud_sel_mask                                           (0x00000001)
+#define SYS_PFUNC_TP1_tp1_clk_pud_sel(data)                                          (0x00000001&((data)<<0))
+#define SYS_PFUNC_TP1_tp1_clk_pud_sel_src(data)                                      ((0x00000001&(data))>>0)
+#define SYS_PFUNC_TP1_get_tp1_clk_pud_sel(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SYS_PFUNC_MISC0                                                              0x18000394
+#define SYS_PFUNC_MISC0_reg_addr                                                     "0xB8000394"
+#define SYS_PFUNC_MISC0_reg                                                          0xB8000394
+#define set_SYS_PFUNC_MISC0_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_MISC0_reg)=data)
+#define get_SYS_PFUNC_MISC0_reg   (*((volatile unsigned int*) SYS_PFUNC_MISC0_reg))
+#define SYS_PFUNC_MISC0_inst_adr                                                     "0x00E5"
+#define SYS_PFUNC_MISC0_inst                                                         0x00E5
+#define SYS_PFUNC_MISC0_i2c_scl_5_smt_shift                                          (23)
+#define SYS_PFUNC_MISC0_i2c_scl_5_smt_mask                                           (0x00800000)
+#define SYS_PFUNC_MISC0_i2c_scl_5_smt(data)                                          (0x00800000&((data)<<23))
+#define SYS_PFUNC_MISC0_i2c_scl_5_smt_src(data)                                      ((0x00800000&(data))>>23)
+#define SYS_PFUNC_MISC0_get_i2c_scl_5_smt(data)                                      ((0x00800000&(data))>>23)
+#define SYS_PFUNC_MISC0_i2c_scl_5_e2_shift                                           (22)
+#define SYS_PFUNC_MISC0_i2c_scl_5_e2_mask                                            (0x00400000)
+#define SYS_PFUNC_MISC0_i2c_scl_5_e2(data)                                           (0x00400000&((data)<<22))
+#define SYS_PFUNC_MISC0_i2c_scl_5_e2_src(data)                                       ((0x00400000&(data))>>22)
+#define SYS_PFUNC_MISC0_get_i2c_scl_5_e2(data)                                       ((0x00400000&(data))>>22)
+#define SYS_PFUNC_MISC0_i2c_scl_5_pud_en_shift                                       (21)
+#define SYS_PFUNC_MISC0_i2c_scl_5_pud_en_mask                                        (0x00200000)
+#define SYS_PFUNC_MISC0_i2c_scl_5_pud_en(data)                                       (0x00200000&((data)<<21))
+#define SYS_PFUNC_MISC0_i2c_scl_5_pud_en_src(data)                                   ((0x00200000&(data))>>21)
+#define SYS_PFUNC_MISC0_get_i2c_scl_5_pud_en(data)                                   ((0x00200000&(data))>>21)
+#define SYS_PFUNC_MISC0_i2c_scl_5_pud_sel_shift                                      (20)
+#define SYS_PFUNC_MISC0_i2c_scl_5_pud_sel_mask                                       (0x00100000)
+#define SYS_PFUNC_MISC0_i2c_scl_5_pud_sel(data)                                      (0x00100000&((data)<<20))
+#define SYS_PFUNC_MISC0_i2c_scl_5_pud_sel_src(data)                                  ((0x00100000&(data))>>20)
+#define SYS_PFUNC_MISC0_get_i2c_scl_5_pud_sel(data)                                  ((0x00100000&(data))>>20)
+#define SYS_PFUNC_MISC0_i2c_sda_5_smt_shift                                          (19)
+#define SYS_PFUNC_MISC0_i2c_sda_5_smt_mask                                           (0x00080000)
+#define SYS_PFUNC_MISC0_i2c_sda_5_smt(data)                                          (0x00080000&((data)<<19))
+#define SYS_PFUNC_MISC0_i2c_sda_5_smt_src(data)                                      ((0x00080000&(data))>>19)
+#define SYS_PFUNC_MISC0_get_i2c_sda_5_smt(data)                                      ((0x00080000&(data))>>19)
+#define SYS_PFUNC_MISC0_i2c_sda_5_e2_shift                                           (18)
+#define SYS_PFUNC_MISC0_i2c_sda_5_e2_mask                                            (0x00040000)
+#define SYS_PFUNC_MISC0_i2c_sda_5_e2(data)                                           (0x00040000&((data)<<18))
+#define SYS_PFUNC_MISC0_i2c_sda_5_e2_src(data)                                       ((0x00040000&(data))>>18)
+#define SYS_PFUNC_MISC0_get_i2c_sda_5_e2(data)                                       ((0x00040000&(data))>>18)
+#define SYS_PFUNC_MISC0_i2c_sda_5_pud_en_shift                                       (17)
+#define SYS_PFUNC_MISC0_i2c_sda_5_pud_en_mask                                        (0x00020000)
+#define SYS_PFUNC_MISC0_i2c_sda_5_pud_en(data)                                       (0x00020000&((data)<<17))
+#define SYS_PFUNC_MISC0_i2c_sda_5_pud_en_src(data)                                   ((0x00020000&(data))>>17)
+#define SYS_PFUNC_MISC0_get_i2c_sda_5_pud_en(data)                                   ((0x00020000&(data))>>17)
+#define SYS_PFUNC_MISC0_i2c_sda_5_pud_sel_shift                                      (16)
+#define SYS_PFUNC_MISC0_i2c_sda_5_pud_sel_mask                                       (0x00010000)
+#define SYS_PFUNC_MISC0_i2c_sda_5_pud_sel(data)                                      (0x00010000&((data)<<16))
+#define SYS_PFUNC_MISC0_i2c_sda_5_pud_sel_src(data)                                  ((0x00010000&(data))>>16)
+#define SYS_PFUNC_MISC0_get_i2c_sda_5_pud_sel(data)                                  ((0x00010000&(data))>>16)
+#define SYS_PFUNC_MISC0_i2c_scl_4_smt_shift                                          (15)
+#define SYS_PFUNC_MISC0_i2c_scl_4_smt_mask                                           (0x00008000)
+#define SYS_PFUNC_MISC0_i2c_scl_4_smt(data)                                          (0x00008000&((data)<<15))
+#define SYS_PFUNC_MISC0_i2c_scl_4_smt_src(data)                                      ((0x00008000&(data))>>15)
+#define SYS_PFUNC_MISC0_get_i2c_scl_4_smt(data)                                      ((0x00008000&(data))>>15)
+#define SYS_PFUNC_MISC0_i2c_scl_4_e2_shift                                           (14)
+#define SYS_PFUNC_MISC0_i2c_scl_4_e2_mask                                            (0x00004000)
+#define SYS_PFUNC_MISC0_i2c_scl_4_e2(data)                                           (0x00004000&((data)<<14))
+#define SYS_PFUNC_MISC0_i2c_scl_4_e2_src(data)                                       ((0x00004000&(data))>>14)
+#define SYS_PFUNC_MISC0_get_i2c_scl_4_e2(data)                                       ((0x00004000&(data))>>14)
+#define SYS_PFUNC_MISC0_i2c_scl_4_pud_en_shift                                       (13)
+#define SYS_PFUNC_MISC0_i2c_scl_4_pud_en_mask                                        (0x00002000)
+#define SYS_PFUNC_MISC0_i2c_scl_4_pud_en(data)                                       (0x00002000&((data)<<13))
+#define SYS_PFUNC_MISC0_i2c_scl_4_pud_en_src(data)                                   ((0x00002000&(data))>>13)
+#define SYS_PFUNC_MISC0_get_i2c_scl_4_pud_en(data)                                   ((0x00002000&(data))>>13)
+#define SYS_PFUNC_MISC0_i2c_scl_4_pud_sel_shift                                      (12)
+#define SYS_PFUNC_MISC0_i2c_scl_4_pud_sel_mask                                       (0x00001000)
+#define SYS_PFUNC_MISC0_i2c_scl_4_pud_sel(data)                                      (0x00001000&((data)<<12))
+#define SYS_PFUNC_MISC0_i2c_scl_4_pud_sel_src(data)                                  ((0x00001000&(data))>>12)
+#define SYS_PFUNC_MISC0_get_i2c_scl_4_pud_sel(data)                                  ((0x00001000&(data))>>12)
+#define SYS_PFUNC_MISC0_i2c_sda_4_smt_shift                                          (11)
+#define SYS_PFUNC_MISC0_i2c_sda_4_smt_mask                                           (0x00000800)
+#define SYS_PFUNC_MISC0_i2c_sda_4_smt(data)                                          (0x00000800&((data)<<11))
+#define SYS_PFUNC_MISC0_i2c_sda_4_smt_src(data)                                      ((0x00000800&(data))>>11)
+#define SYS_PFUNC_MISC0_get_i2c_sda_4_smt(data)                                      ((0x00000800&(data))>>11)
+#define SYS_PFUNC_MISC0_i2c_sda_4_e2_shift                                           (10)
+#define SYS_PFUNC_MISC0_i2c_sda_4_e2_mask                                            (0x00000400)
+#define SYS_PFUNC_MISC0_i2c_sda_4_e2(data)                                           (0x00000400&((data)<<10))
+#define SYS_PFUNC_MISC0_i2c_sda_4_e2_src(data)                                       ((0x00000400&(data))>>10)
+#define SYS_PFUNC_MISC0_get_i2c_sda_4_e2(data)                                       ((0x00000400&(data))>>10)
+#define SYS_PFUNC_MISC0_i2c_sda_4_pud_en_shift                                       (9)
+#define SYS_PFUNC_MISC0_i2c_sda_4_pud_en_mask                                        (0x00000200)
+#define SYS_PFUNC_MISC0_i2c_sda_4_pud_en(data)                                       (0x00000200&((data)<<9))
+#define SYS_PFUNC_MISC0_i2c_sda_4_pud_en_src(data)                                   ((0x00000200&(data))>>9)
+#define SYS_PFUNC_MISC0_get_i2c_sda_4_pud_en(data)                                   ((0x00000200&(data))>>9)
+#define SYS_PFUNC_MISC0_i2c_sda_4_pud_sel_shift                                      (8)
+#define SYS_PFUNC_MISC0_i2c_sda_4_pud_sel_mask                                       (0x00000100)
+#define SYS_PFUNC_MISC0_i2c_sda_4_pud_sel(data)                                      (0x00000100&((data)<<8))
+#define SYS_PFUNC_MISC0_i2c_sda_4_pud_sel_src(data)                                  ((0x00000100&(data))>>8)
+#define SYS_PFUNC_MISC0_get_i2c_sda_4_pud_sel(data)                                  ((0x00000100&(data))>>8)
+#define SYS_PFUNC_MISC0_i2c_scl_1_smt_shift                                          (7)
+#define SYS_PFUNC_MISC0_i2c_scl_1_smt_mask                                           (0x00000080)
+#define SYS_PFUNC_MISC0_i2c_scl_1_smt(data)                                          (0x00000080&((data)<<7))
+#define SYS_PFUNC_MISC0_i2c_scl_1_smt_src(data)                                      ((0x00000080&(data))>>7)
+#define SYS_PFUNC_MISC0_get_i2c_scl_1_smt(data)                                      ((0x00000080&(data))>>7)
+#define SYS_PFUNC_MISC0_i2c_scl_1_e2_shift                                           (6)
+#define SYS_PFUNC_MISC0_i2c_scl_1_e2_mask                                            (0x00000040)
+#define SYS_PFUNC_MISC0_i2c_scl_1_e2(data)                                           (0x00000040&((data)<<6))
+#define SYS_PFUNC_MISC0_i2c_scl_1_e2_src(data)                                       ((0x00000040&(data))>>6)
+#define SYS_PFUNC_MISC0_get_i2c_scl_1_e2(data)                                       ((0x00000040&(data))>>6)
+#define SYS_PFUNC_MISC0_i2c_scl_1_pud_en_shift                                       (5)
+#define SYS_PFUNC_MISC0_i2c_scl_1_pud_en_mask                                        (0x00000020)
+#define SYS_PFUNC_MISC0_i2c_scl_1_pud_en(data)                                       (0x00000020&((data)<<5))
+#define SYS_PFUNC_MISC0_i2c_scl_1_pud_en_src(data)                                   ((0x00000020&(data))>>5)
+#define SYS_PFUNC_MISC0_get_i2c_scl_1_pud_en(data)                                   ((0x00000020&(data))>>5)
+#define SYS_PFUNC_MISC0_i2c_scl_1_pud_sel_shift                                      (4)
+#define SYS_PFUNC_MISC0_i2c_scl_1_pud_sel_mask                                       (0x00000010)
+#define SYS_PFUNC_MISC0_i2c_scl_1_pud_sel(data)                                      (0x00000010&((data)<<4))
+#define SYS_PFUNC_MISC0_i2c_scl_1_pud_sel_src(data)                                  ((0x00000010&(data))>>4)
+#define SYS_PFUNC_MISC0_get_i2c_scl_1_pud_sel(data)                                  ((0x00000010&(data))>>4)
+#define SYS_PFUNC_MISC0_i2c_sda_1_smt_shift                                          (3)
+#define SYS_PFUNC_MISC0_i2c_sda_1_smt_mask                                           (0x00000008)
+#define SYS_PFUNC_MISC0_i2c_sda_1_smt(data)                                          (0x00000008&((data)<<3))
+#define SYS_PFUNC_MISC0_i2c_sda_1_smt_src(data)                                      ((0x00000008&(data))>>3)
+#define SYS_PFUNC_MISC0_get_i2c_sda_1_smt(data)                                      ((0x00000008&(data))>>3)
+#define SYS_PFUNC_MISC0_i2c_sda_1_e2_shift                                           (2)
+#define SYS_PFUNC_MISC0_i2c_sda_1_e2_mask                                            (0x00000004)
+#define SYS_PFUNC_MISC0_i2c_sda_1_e2(data)                                           (0x00000004&((data)<<2))
+#define SYS_PFUNC_MISC0_i2c_sda_1_e2_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PFUNC_MISC0_get_i2c_sda_1_e2(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PFUNC_MISC0_i2c_sda_1_pud_en_shift                                       (1)
+#define SYS_PFUNC_MISC0_i2c_sda_1_pud_en_mask                                        (0x00000002)
+#define SYS_PFUNC_MISC0_i2c_sda_1_pud_en(data)                                       (0x00000002&((data)<<1))
+#define SYS_PFUNC_MISC0_i2c_sda_1_pud_en_src(data)                                   ((0x00000002&(data))>>1)
+#define SYS_PFUNC_MISC0_get_i2c_sda_1_pud_en(data)                                   ((0x00000002&(data))>>1)
+#define SYS_PFUNC_MISC0_i2c_sda_1_pud_sel_shift                                      (0)
+#define SYS_PFUNC_MISC0_i2c_sda_1_pud_sel_mask                                       (0x00000001)
+#define SYS_PFUNC_MISC0_i2c_sda_1_pud_sel(data)                                      (0x00000001&((data)<<0))
+#define SYS_PFUNC_MISC0_i2c_sda_1_pud_sel_src(data)                                  ((0x00000001&(data))>>0)
+#define SYS_PFUNC_MISC0_get_i2c_sda_1_pud_sel(data)                                  ((0x00000001&(data))>>0)
+
+
+#define SYS_PFUNC_MISC1                                                              0x18000398
+#define SYS_PFUNC_MISC1_reg_addr                                                     "0xB8000398"
+#define SYS_PFUNC_MISC1_reg                                                          0xB8000398
+#define set_SYS_PFUNC_MISC1_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_MISC1_reg)=data)
+#define get_SYS_PFUNC_MISC1_reg   (*((volatile unsigned int*) SYS_PFUNC_MISC1_reg))
+#define SYS_PFUNC_MISC1_inst_adr                                                     "0x00E6"
+#define SYS_PFUNC_MISC1_inst                                                         0x00E6
+#define SYS_PFUNC_MISC1_gpio_7_smt_shift                                             (31)
+#define SYS_PFUNC_MISC1_gpio_7_smt_mask                                              (0x80000000)
+#define SYS_PFUNC_MISC1_gpio_7_smt(data)                                             (0x80000000&((data)<<31))
+#define SYS_PFUNC_MISC1_gpio_7_smt_src(data)                                         ((0x80000000&(data))>>31)
+#define SYS_PFUNC_MISC1_get_gpio_7_smt(data)                                         ((0x80000000&(data))>>31)
+#define SYS_PFUNC_MISC1_gpio_7_e2_shift                                              (30)
+#define SYS_PFUNC_MISC1_gpio_7_e2_mask                                               (0x40000000)
+#define SYS_PFUNC_MISC1_gpio_7_e2(data)                                              (0x40000000&((data)<<30))
+#define SYS_PFUNC_MISC1_gpio_7_e2_src(data)                                          ((0x40000000&(data))>>30)
+#define SYS_PFUNC_MISC1_get_gpio_7_e2(data)                                          ((0x40000000&(data))>>30)
+#define SYS_PFUNC_MISC1_gpio_7_pud_en_shift                                          (29)
+#define SYS_PFUNC_MISC1_gpio_7_pud_en_mask                                           (0x20000000)
+#define SYS_PFUNC_MISC1_gpio_7_pud_en(data)                                          (0x20000000&((data)<<29))
+#define SYS_PFUNC_MISC1_gpio_7_pud_en_src(data)                                      ((0x20000000&(data))>>29)
+#define SYS_PFUNC_MISC1_get_gpio_7_pud_en(data)                                      ((0x20000000&(data))>>29)
+#define SYS_PFUNC_MISC1_gpio_7_pud_sel_shift                                         (28)
+#define SYS_PFUNC_MISC1_gpio_7_pud_sel_mask                                          (0x10000000)
+#define SYS_PFUNC_MISC1_gpio_7_pud_sel(data)                                         (0x10000000&((data)<<28))
+#define SYS_PFUNC_MISC1_gpio_7_pud_sel_src(data)                                     ((0x10000000&(data))>>28)
+#define SYS_PFUNC_MISC1_get_gpio_7_pud_sel(data)                                     ((0x10000000&(data))>>28)
+#define SYS_PFUNC_MISC1_gpio_6_smt_shift                                             (27)
+#define SYS_PFUNC_MISC1_gpio_6_smt_mask                                              (0x08000000)
+#define SYS_PFUNC_MISC1_gpio_6_smt(data)                                             (0x08000000&((data)<<27))
+#define SYS_PFUNC_MISC1_gpio_6_smt_src(data)                                         ((0x08000000&(data))>>27)
+#define SYS_PFUNC_MISC1_get_gpio_6_smt(data)                                         ((0x08000000&(data))>>27)
+#define SYS_PFUNC_MISC1_gpio_6_e2_shift                                              (26)
+#define SYS_PFUNC_MISC1_gpio_6_e2_mask                                               (0x04000000)
+#define SYS_PFUNC_MISC1_gpio_6_e2(data)                                              (0x04000000&((data)<<26))
+#define SYS_PFUNC_MISC1_gpio_6_e2_src(data)                                          ((0x04000000&(data))>>26)
+#define SYS_PFUNC_MISC1_get_gpio_6_e2(data)                                          ((0x04000000&(data))>>26)
+#define SYS_PFUNC_MISC1_gpio_6_pud_en_shift                                          (25)
+#define SYS_PFUNC_MISC1_gpio_6_pud_en_mask                                           (0x02000000)
+#define SYS_PFUNC_MISC1_gpio_6_pud_en(data)                                          (0x02000000&((data)<<25))
+#define SYS_PFUNC_MISC1_gpio_6_pud_en_src(data)                                      ((0x02000000&(data))>>25)
+#define SYS_PFUNC_MISC1_get_gpio_6_pud_en(data)                                      ((0x02000000&(data))>>25)
+#define SYS_PFUNC_MISC1_gpio_6_pud_sel_shift                                         (24)
+#define SYS_PFUNC_MISC1_gpio_6_pud_sel_mask                                          (0x01000000)
+#define SYS_PFUNC_MISC1_gpio_6_pud_sel(data)                                         (0x01000000&((data)<<24))
+#define SYS_PFUNC_MISC1_gpio_6_pud_sel_src(data)                                     ((0x01000000&(data))>>24)
+#define SYS_PFUNC_MISC1_get_gpio_6_pud_sel(data)                                     ((0x01000000&(data))>>24)
+#define SYS_PFUNC_MISC1_gpio_5_smt_shift                                             (23)
+#define SYS_PFUNC_MISC1_gpio_5_smt_mask                                              (0x00800000)
+#define SYS_PFUNC_MISC1_gpio_5_smt(data)                                             (0x00800000&((data)<<23))
+#define SYS_PFUNC_MISC1_gpio_5_smt_src(data)                                         ((0x00800000&(data))>>23)
+#define SYS_PFUNC_MISC1_get_gpio_5_smt(data)                                         ((0x00800000&(data))>>23)
+#define SYS_PFUNC_MISC1_gpio_5_e2_shift                                              (22)
+#define SYS_PFUNC_MISC1_gpio_5_e2_mask                                               (0x00400000)
+#define SYS_PFUNC_MISC1_gpio_5_e2(data)                                              (0x00400000&((data)<<22))
+#define SYS_PFUNC_MISC1_gpio_5_e2_src(data)                                          ((0x00400000&(data))>>22)
+#define SYS_PFUNC_MISC1_get_gpio_5_e2(data)                                          ((0x00400000&(data))>>22)
+#define SYS_PFUNC_MISC1_gpio_5_pud_en_shift                                          (21)
+#define SYS_PFUNC_MISC1_gpio_5_pud_en_mask                                           (0x00200000)
+#define SYS_PFUNC_MISC1_gpio_5_pud_en(data)                                          (0x00200000&((data)<<21))
+#define SYS_PFUNC_MISC1_gpio_5_pud_en_src(data)                                      ((0x00200000&(data))>>21)
+#define SYS_PFUNC_MISC1_get_gpio_5_pud_en(data)                                      ((0x00200000&(data))>>21)
+#define SYS_PFUNC_MISC1_gpio_5_pud_sel_shift                                         (20)
+#define SYS_PFUNC_MISC1_gpio_5_pud_sel_mask                                          (0x00100000)
+#define SYS_PFUNC_MISC1_gpio_5_pud_sel(data)                                         (0x00100000&((data)<<20))
+#define SYS_PFUNC_MISC1_gpio_5_pud_sel_src(data)                                     ((0x00100000&(data))>>20)
+#define SYS_PFUNC_MISC1_get_gpio_5_pud_sel(data)                                     ((0x00100000&(data))>>20)
+#define SYS_PFUNC_MISC1_gpio_4_smt_shift                                             (19)
+#define SYS_PFUNC_MISC1_gpio_4_smt_mask                                              (0x00080000)
+#define SYS_PFUNC_MISC1_gpio_4_smt(data)                                             (0x00080000&((data)<<19))
+#define SYS_PFUNC_MISC1_gpio_4_smt_src(data)                                         ((0x00080000&(data))>>19)
+#define SYS_PFUNC_MISC1_get_gpio_4_smt(data)                                         ((0x00080000&(data))>>19)
+#define SYS_PFUNC_MISC1_gpio_4_e2_shift                                              (18)
+#define SYS_PFUNC_MISC1_gpio_4_e2_mask                                               (0x00040000)
+#define SYS_PFUNC_MISC1_gpio_4_e2(data)                                              (0x00040000&((data)<<18))
+#define SYS_PFUNC_MISC1_gpio_4_e2_src(data)                                          ((0x00040000&(data))>>18)
+#define SYS_PFUNC_MISC1_get_gpio_4_e2(data)                                          ((0x00040000&(data))>>18)
+#define SYS_PFUNC_MISC1_gpio_4_pud_en_shift                                          (17)
+#define SYS_PFUNC_MISC1_gpio_4_pud_en_mask                                           (0x00020000)
+#define SYS_PFUNC_MISC1_gpio_4_pud_en(data)                                          (0x00020000&((data)<<17))
+#define SYS_PFUNC_MISC1_gpio_4_pud_en_src(data)                                      ((0x00020000&(data))>>17)
+#define SYS_PFUNC_MISC1_get_gpio_4_pud_en(data)                                      ((0x00020000&(data))>>17)
+#define SYS_PFUNC_MISC1_gpio_4_pud_sel_shift                                         (16)
+#define SYS_PFUNC_MISC1_gpio_4_pud_sel_mask                                          (0x00010000)
+#define SYS_PFUNC_MISC1_gpio_4_pud_sel(data)                                         (0x00010000&((data)<<16))
+#define SYS_PFUNC_MISC1_gpio_4_pud_sel_src(data)                                     ((0x00010000&(data))>>16)
+#define SYS_PFUNC_MISC1_get_gpio_4_pud_sel(data)                                     ((0x00010000&(data))>>16)
+#define SYS_PFUNC_MISC1_gpio_3_smt_shift                                             (15)
+#define SYS_PFUNC_MISC1_gpio_3_smt_mask                                              (0x00008000)
+#define SYS_PFUNC_MISC1_gpio_3_smt(data)                                             (0x00008000&((data)<<15))
+#define SYS_PFUNC_MISC1_gpio_3_smt_src(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PFUNC_MISC1_get_gpio_3_smt(data)                                         ((0x00008000&(data))>>15)
+#define SYS_PFUNC_MISC1_gpio_3_e2_shift                                              (14)
+#define SYS_PFUNC_MISC1_gpio_3_e2_mask                                               (0x00004000)
+#define SYS_PFUNC_MISC1_gpio_3_e2(data)                                              (0x00004000&((data)<<14))
+#define SYS_PFUNC_MISC1_gpio_3_e2_src(data)                                          ((0x00004000&(data))>>14)
+#define SYS_PFUNC_MISC1_get_gpio_3_e2(data)                                          ((0x00004000&(data))>>14)
+#define SYS_PFUNC_MISC1_gpio_3_pud_en_shift                                          (13)
+#define SYS_PFUNC_MISC1_gpio_3_pud_en_mask                                           (0x00002000)
+#define SYS_PFUNC_MISC1_gpio_3_pud_en(data)                                          (0x00002000&((data)<<13))
+#define SYS_PFUNC_MISC1_gpio_3_pud_en_src(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PFUNC_MISC1_get_gpio_3_pud_en(data)                                      ((0x00002000&(data))>>13)
+#define SYS_PFUNC_MISC1_gpio_3_pud_sel_shift                                         (12)
+#define SYS_PFUNC_MISC1_gpio_3_pud_sel_mask                                          (0x00001000)
+#define SYS_PFUNC_MISC1_gpio_3_pud_sel(data)                                         (0x00001000&((data)<<12))
+#define SYS_PFUNC_MISC1_gpio_3_pud_sel_src(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PFUNC_MISC1_get_gpio_3_pud_sel(data)                                     ((0x00001000&(data))>>12)
+#define SYS_PFUNC_MISC1_gpio_2_smt_shift                                             (11)
+#define SYS_PFUNC_MISC1_gpio_2_smt_mask                                              (0x00000800)
+#define SYS_PFUNC_MISC1_gpio_2_smt(data)                                             (0x00000800&((data)<<11))
+#define SYS_PFUNC_MISC1_gpio_2_smt_src(data)                                         ((0x00000800&(data))>>11)
+#define SYS_PFUNC_MISC1_get_gpio_2_smt(data)                                         ((0x00000800&(data))>>11)
+#define SYS_PFUNC_MISC1_gpio_2_e2_shift                                              (10)
+#define SYS_PFUNC_MISC1_gpio_2_e2_mask                                               (0x00000400)
+#define SYS_PFUNC_MISC1_gpio_2_e2(data)                                              (0x00000400&((data)<<10))
+#define SYS_PFUNC_MISC1_gpio_2_e2_src(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PFUNC_MISC1_get_gpio_2_e2(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PFUNC_MISC1_gpio_2_pud_en_shift                                          (9)
+#define SYS_PFUNC_MISC1_gpio_2_pud_en_mask                                           (0x00000200)
+#define SYS_PFUNC_MISC1_gpio_2_pud_en(data)                                          (0x00000200&((data)<<9))
+#define SYS_PFUNC_MISC1_gpio_2_pud_en_src(data)                                      ((0x00000200&(data))>>9)
+#define SYS_PFUNC_MISC1_get_gpio_2_pud_en(data)                                      ((0x00000200&(data))>>9)
+#define SYS_PFUNC_MISC1_gpio_2_pud_sel_shift                                         (8)
+#define SYS_PFUNC_MISC1_gpio_2_pud_sel_mask                                          (0x00000100)
+#define SYS_PFUNC_MISC1_gpio_2_pud_sel(data)                                         (0x00000100&((data)<<8))
+#define SYS_PFUNC_MISC1_gpio_2_pud_sel_src(data)                                     ((0x00000100&(data))>>8)
+#define SYS_PFUNC_MISC1_get_gpio_2_pud_sel(data)                                     ((0x00000100&(data))>>8)
+#define SYS_PFUNC_MISC1_gpio_1_smt_shift                                             (7)
+#define SYS_PFUNC_MISC1_gpio_1_smt_mask                                              (0x00000080)
+#define SYS_PFUNC_MISC1_gpio_1_smt(data)                                             (0x00000080&((data)<<7))
+#define SYS_PFUNC_MISC1_gpio_1_smt_src(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PFUNC_MISC1_get_gpio_1_smt(data)                                         ((0x00000080&(data))>>7)
+#define SYS_PFUNC_MISC1_gpio_1_e2_shift                                              (6)
+#define SYS_PFUNC_MISC1_gpio_1_e2_mask                                               (0x00000040)
+#define SYS_PFUNC_MISC1_gpio_1_e2(data)                                              (0x00000040&((data)<<6))
+#define SYS_PFUNC_MISC1_gpio_1_e2_src(data)                                          ((0x00000040&(data))>>6)
+#define SYS_PFUNC_MISC1_get_gpio_1_e2(data)                                          ((0x00000040&(data))>>6)
+#define SYS_PFUNC_MISC1_gpio_1_pud_en_shift                                          (5)
+#define SYS_PFUNC_MISC1_gpio_1_pud_en_mask                                           (0x00000020)
+#define SYS_PFUNC_MISC1_gpio_1_pud_en(data)                                          (0x00000020&((data)<<5))
+#define SYS_PFUNC_MISC1_gpio_1_pud_en_src(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PFUNC_MISC1_get_gpio_1_pud_en(data)                                      ((0x00000020&(data))>>5)
+#define SYS_PFUNC_MISC1_gpio_1_pud_sel_shift                                         (4)
+#define SYS_PFUNC_MISC1_gpio_1_pud_sel_mask                                          (0x00000010)
+#define SYS_PFUNC_MISC1_gpio_1_pud_sel(data)                                         (0x00000010&((data)<<4))
+#define SYS_PFUNC_MISC1_gpio_1_pud_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define SYS_PFUNC_MISC1_get_gpio_1_pud_sel(data)                                     ((0x00000010&(data))>>4)
+#define SYS_PFUNC_MISC1_gpio_0_smt_shift                                             (3)
+#define SYS_PFUNC_MISC1_gpio_0_smt_mask                                              (0x00000008)
+#define SYS_PFUNC_MISC1_gpio_0_smt(data)                                             (0x00000008&((data)<<3))
+#define SYS_PFUNC_MISC1_gpio_0_smt_src(data)                                         ((0x00000008&(data))>>3)
+#define SYS_PFUNC_MISC1_get_gpio_0_smt(data)                                         ((0x00000008&(data))>>3)
+#define SYS_PFUNC_MISC1_gpio_0_e2_shift                                              (2)
+#define SYS_PFUNC_MISC1_gpio_0_e2_mask                                               (0x00000004)
+#define SYS_PFUNC_MISC1_gpio_0_e2(data)                                              (0x00000004&((data)<<2))
+#define SYS_PFUNC_MISC1_gpio_0_e2_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PFUNC_MISC1_get_gpio_0_e2(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PFUNC_MISC1_gpio_0_pud_en_shift                                          (1)
+#define SYS_PFUNC_MISC1_gpio_0_pud_en_mask                                           (0x00000002)
+#define SYS_PFUNC_MISC1_gpio_0_pud_en(data)                                          (0x00000002&((data)<<1))
+#define SYS_PFUNC_MISC1_gpio_0_pud_en_src(data)                                      ((0x00000002&(data))>>1)
+#define SYS_PFUNC_MISC1_get_gpio_0_pud_en(data)                                      ((0x00000002&(data))>>1)
+#define SYS_PFUNC_MISC1_gpio_0_pud_sel_shift                                         (0)
+#define SYS_PFUNC_MISC1_gpio_0_pud_sel_mask                                          (0x00000001)
+#define SYS_PFUNC_MISC1_gpio_0_pud_sel(data)                                         (0x00000001&((data)<<0))
+#define SYS_PFUNC_MISC1_gpio_0_pud_sel_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PFUNC_MISC1_get_gpio_0_pud_sel(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PFUNC_MISC2                                                              0x1800039C
+#define SYS_PFUNC_MISC2_reg_addr                                                     "0xB800039C"
+#define SYS_PFUNC_MISC2_reg                                                          0xB800039C
+#define set_SYS_PFUNC_MISC2_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_MISC2_reg)=data)
+#define get_SYS_PFUNC_MISC2_reg   (*((volatile unsigned int*) SYS_PFUNC_MISC2_reg))
+#define SYS_PFUNC_MISC2_inst_adr                                                     "0x00E7"
+#define SYS_PFUNC_MISC2_inst                                                         0x00E7
+#define SYS_PFUNC_MISC2_sensor_cko1_smt_shift                                        (31)
+#define SYS_PFUNC_MISC2_sensor_cko1_smt_mask                                         (0x80000000)
+#define SYS_PFUNC_MISC2_sensor_cko1_smt(data)                                        (0x80000000&((data)<<31))
+#define SYS_PFUNC_MISC2_sensor_cko1_smt_src(data)                                    ((0x80000000&(data))>>31)
+#define SYS_PFUNC_MISC2_get_sensor_cko1_smt(data)                                    ((0x80000000&(data))>>31)
+#define SYS_PFUNC_MISC2_sensor_cko1_e2_shift                                         (30)
+#define SYS_PFUNC_MISC2_sensor_cko1_e2_mask                                          (0x40000000)
+#define SYS_PFUNC_MISC2_sensor_cko1_e2(data)                                         (0x40000000&((data)<<30))
+#define SYS_PFUNC_MISC2_sensor_cko1_e2_src(data)                                     ((0x40000000&(data))>>30)
+#define SYS_PFUNC_MISC2_get_sensor_cko1_e2(data)                                     ((0x40000000&(data))>>30)
+#define SYS_PFUNC_MISC2_sensor_cko1_pud_en_shift                                     (29)
+#define SYS_PFUNC_MISC2_sensor_cko1_pud_en_mask                                      (0x20000000)
+#define SYS_PFUNC_MISC2_sensor_cko1_pud_en(data)                                     (0x20000000&((data)<<29))
+#define SYS_PFUNC_MISC2_sensor_cko1_pud_en_src(data)                                 ((0x20000000&(data))>>29)
+#define SYS_PFUNC_MISC2_get_sensor_cko1_pud_en(data)                                 ((0x20000000&(data))>>29)
+#define SYS_PFUNC_MISC2_sensor_cko1_pud_sel_shift                                    (28)
+#define SYS_PFUNC_MISC2_sensor_cko1_pud_sel_mask                                     (0x10000000)
+#define SYS_PFUNC_MISC2_sensor_cko1_pud_sel(data)                                    (0x10000000&((data)<<28))
+#define SYS_PFUNC_MISC2_sensor_cko1_pud_sel_src(data)                                ((0x10000000&(data))>>28)
+#define SYS_PFUNC_MISC2_get_sensor_cko1_pud_sel(data)                                ((0x10000000&(data))>>28)
+#define SYS_PFUNC_MISC2_sensor_cko0_smt_shift                                        (27)
+#define SYS_PFUNC_MISC2_sensor_cko0_smt_mask                                         (0x08000000)
+#define SYS_PFUNC_MISC2_sensor_cko0_smt(data)                                        (0x08000000&((data)<<27))
+#define SYS_PFUNC_MISC2_sensor_cko0_smt_src(data)                                    ((0x08000000&(data))>>27)
+#define SYS_PFUNC_MISC2_get_sensor_cko0_smt(data)                                    ((0x08000000&(data))>>27)
+#define SYS_PFUNC_MISC2_sensor_cko0_e2_shift                                         (26)
+#define SYS_PFUNC_MISC2_sensor_cko0_e2_mask                                          (0x04000000)
+#define SYS_PFUNC_MISC2_sensor_cko0_e2(data)                                         (0x04000000&((data)<<26))
+#define SYS_PFUNC_MISC2_sensor_cko0_e2_src(data)                                     ((0x04000000&(data))>>26)
+#define SYS_PFUNC_MISC2_get_sensor_cko0_e2(data)                                     ((0x04000000&(data))>>26)
+#define SYS_PFUNC_MISC2_sensor_cko0_pud_en_shift                                     (25)
+#define SYS_PFUNC_MISC2_sensor_cko0_pud_en_mask                                      (0x02000000)
+#define SYS_PFUNC_MISC2_sensor_cko0_pud_en(data)                                     (0x02000000&((data)<<25))
+#define SYS_PFUNC_MISC2_sensor_cko0_pud_en_src(data)                                 ((0x02000000&(data))>>25)
+#define SYS_PFUNC_MISC2_get_sensor_cko0_pud_en(data)                                 ((0x02000000&(data))>>25)
+#define SYS_PFUNC_MISC2_sensor_cko0_pud_sel_shift                                    (24)
+#define SYS_PFUNC_MISC2_sensor_cko0_pud_sel_mask                                     (0x01000000)
+#define SYS_PFUNC_MISC2_sensor_cko0_pud_sel(data)                                    (0x01000000&((data)<<24))
+#define SYS_PFUNC_MISC2_sensor_cko0_pud_sel_src(data)                                ((0x01000000&(data))>>24)
+#define SYS_PFUNC_MISC2_get_sensor_cko0_pud_sel(data)                                ((0x01000000&(data))>>24)
+#define SYS_PFUNC_MISC2_sensor_rst_smt_shift                                         (23)
+#define SYS_PFUNC_MISC2_sensor_rst_smt_mask                                          (0x00800000)
+#define SYS_PFUNC_MISC2_sensor_rst_smt(data)                                         (0x00800000&((data)<<23))
+#define SYS_PFUNC_MISC2_sensor_rst_smt_src(data)                                     ((0x00800000&(data))>>23)
+#define SYS_PFUNC_MISC2_get_sensor_rst_smt(data)                                     ((0x00800000&(data))>>23)
+#define SYS_PFUNC_MISC2_sensor_rst_e2_shift                                          (22)
+#define SYS_PFUNC_MISC2_sensor_rst_e2_mask                                           (0x00400000)
+#define SYS_PFUNC_MISC2_sensor_rst_e2(data)                                          (0x00400000&((data)<<22))
+#define SYS_PFUNC_MISC2_sensor_rst_e2_src(data)                                      ((0x00400000&(data))>>22)
+#define SYS_PFUNC_MISC2_get_sensor_rst_e2(data)                                      ((0x00400000&(data))>>22)
+#define SYS_PFUNC_MISC2_sensor_rst_pud_en_shift                                      (21)
+#define SYS_PFUNC_MISC2_sensor_rst_pud_en_mask                                       (0x00200000)
+#define SYS_PFUNC_MISC2_sensor_rst_pud_en(data)                                      (0x00200000&((data)<<21))
+#define SYS_PFUNC_MISC2_sensor_rst_pud_en_src(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PFUNC_MISC2_get_sensor_rst_pud_en(data)                                  ((0x00200000&(data))>>21)
+#define SYS_PFUNC_MISC2_sensor_rst_pud_sel_shift                                     (20)
+#define SYS_PFUNC_MISC2_sensor_rst_pud_sel_mask                                      (0x00100000)
+#define SYS_PFUNC_MISC2_sensor_rst_pud_sel(data)                                     (0x00100000&((data)<<20))
+#define SYS_PFUNC_MISC2_sensor_rst_pud_sel_src(data)                                 ((0x00100000&(data))>>20)
+#define SYS_PFUNC_MISC2_get_sensor_rst_pud_sel(data)                                 ((0x00100000&(data))>>20)
+#define SYS_PFUNC_MISC2_sensor_stb1_smt_shift                                        (19)
+#define SYS_PFUNC_MISC2_sensor_stb1_smt_mask                                         (0x00080000)
+#define SYS_PFUNC_MISC2_sensor_stb1_smt(data)                                        (0x00080000&((data)<<19))
+#define SYS_PFUNC_MISC2_sensor_stb1_smt_src(data)                                    ((0x00080000&(data))>>19)
+#define SYS_PFUNC_MISC2_get_sensor_stb1_smt(data)                                    ((0x00080000&(data))>>19)
+#define SYS_PFUNC_MISC2_sensor_stb1_e2_shift                                         (18)
+#define SYS_PFUNC_MISC2_sensor_stb1_e2_mask                                          (0x00040000)
+#define SYS_PFUNC_MISC2_sensor_stb1_e2(data)                                         (0x00040000&((data)<<18))
+#define SYS_PFUNC_MISC2_sensor_stb1_e2_src(data)                                     ((0x00040000&(data))>>18)
+#define SYS_PFUNC_MISC2_get_sensor_stb1_e2(data)                                     ((0x00040000&(data))>>18)
+#define SYS_PFUNC_MISC2_sensor_stb1_pud_en_shift                                     (17)
+#define SYS_PFUNC_MISC2_sensor_stb1_pud_en_mask                                      (0x00020000)
+#define SYS_PFUNC_MISC2_sensor_stb1_pud_en(data)                                     (0x00020000&((data)<<17))
+#define SYS_PFUNC_MISC2_sensor_stb1_pud_en_src(data)                                 ((0x00020000&(data))>>17)
+#define SYS_PFUNC_MISC2_get_sensor_stb1_pud_en(data)                                 ((0x00020000&(data))>>17)
+#define SYS_PFUNC_MISC2_sensor_stb1_pud_sel_shift                                    (16)
+#define SYS_PFUNC_MISC2_sensor_stb1_pud_sel_mask                                     (0x00010000)
+#define SYS_PFUNC_MISC2_sensor_stb1_pud_sel(data)                                    (0x00010000&((data)<<16))
+#define SYS_PFUNC_MISC2_sensor_stb1_pud_sel_src(data)                                ((0x00010000&(data))>>16)
+#define SYS_PFUNC_MISC2_get_sensor_stb1_pud_sel(data)                                ((0x00010000&(data))>>16)
+#define SYS_PFUNC_MISC2_sensor_stb0_smt_shift                                        (15)
+#define SYS_PFUNC_MISC2_sensor_stb0_smt_mask                                         (0x00008000)
+#define SYS_PFUNC_MISC2_sensor_stb0_smt(data)                                        (0x00008000&((data)<<15))
+#define SYS_PFUNC_MISC2_sensor_stb0_smt_src(data)                                    ((0x00008000&(data))>>15)
+#define SYS_PFUNC_MISC2_get_sensor_stb0_smt(data)                                    ((0x00008000&(data))>>15)
+#define SYS_PFUNC_MISC2_sensor_stb0_e2_shift                                         (14)
+#define SYS_PFUNC_MISC2_sensor_stb0_e2_mask                                          (0x00004000)
+#define SYS_PFUNC_MISC2_sensor_stb0_e2(data)                                         (0x00004000&((data)<<14))
+#define SYS_PFUNC_MISC2_sensor_stb0_e2_src(data)                                     ((0x00004000&(data))>>14)
+#define SYS_PFUNC_MISC2_get_sensor_stb0_e2(data)                                     ((0x00004000&(data))>>14)
+#define SYS_PFUNC_MISC2_sensor_stb0_pud_en_shift                                     (13)
+#define SYS_PFUNC_MISC2_sensor_stb0_pud_en_mask                                      (0x00002000)
+#define SYS_PFUNC_MISC2_sensor_stb0_pud_en(data)                                     (0x00002000&((data)<<13))
+#define SYS_PFUNC_MISC2_sensor_stb0_pud_en_src(data)                                 ((0x00002000&(data))>>13)
+#define SYS_PFUNC_MISC2_get_sensor_stb0_pud_en(data)                                 ((0x00002000&(data))>>13)
+#define SYS_PFUNC_MISC2_sensor_stb0_pud_sel_shift                                    (12)
+#define SYS_PFUNC_MISC2_sensor_stb0_pud_sel_mask                                     (0x00001000)
+#define SYS_PFUNC_MISC2_sensor_stb0_pud_sel(data)                                    (0x00001000&((data)<<12))
+#define SYS_PFUNC_MISC2_sensor_stb0_pud_sel_src(data)                                ((0x00001000&(data))>>12)
+#define SYS_PFUNC_MISC2_get_sensor_stb0_pud_sel(data)                                ((0x00001000&(data))>>12)
+#define SYS_PFUNC_MISC2_usb_id_smt_shift                                             (11)
+#define SYS_PFUNC_MISC2_usb_id_smt_mask                                              (0x00000800)
+#define SYS_PFUNC_MISC2_usb_id_smt(data)                                             (0x00000800&((data)<<11))
+#define SYS_PFUNC_MISC2_usb_id_smt_src(data)                                         ((0x00000800&(data))>>11)
+#define SYS_PFUNC_MISC2_get_usb_id_smt(data)                                         ((0x00000800&(data))>>11)
+#define SYS_PFUNC_MISC2_usb_id_e2_shift                                              (10)
+#define SYS_PFUNC_MISC2_usb_id_e2_mask                                               (0x00000400)
+#define SYS_PFUNC_MISC2_usb_id_e2(data)                                              (0x00000400&((data)<<10))
+#define SYS_PFUNC_MISC2_usb_id_e2_src(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PFUNC_MISC2_get_usb_id_e2(data)                                          ((0x00000400&(data))>>10)
+#define SYS_PFUNC_MISC2_usb_id_pud_en_shift                                          (9)
+#define SYS_PFUNC_MISC2_usb_id_pud_en_mask                                           (0x00000200)
+#define SYS_PFUNC_MISC2_usb_id_pud_en(data)                                          (0x00000200&((data)<<9))
+#define SYS_PFUNC_MISC2_usb_id_pud_en_src(data)                                      ((0x00000200&(data))>>9)
+#define SYS_PFUNC_MISC2_get_usb_id_pud_en(data)                                      ((0x00000200&(data))>>9)
+#define SYS_PFUNC_MISC2_usb_id_pud_sel_shift                                         (8)
+#define SYS_PFUNC_MISC2_usb_id_pud_sel_mask                                          (0x00000100)
+#define SYS_PFUNC_MISC2_usb_id_pud_sel(data)                                         (0x00000100&((data)<<8))
+#define SYS_PFUNC_MISC2_usb_id_pud_sel_src(data)                                     ((0x00000100&(data))>>8)
+#define SYS_PFUNC_MISC2_get_usb_id_pud_sel(data)                                     ((0x00000100&(data))>>8)
+#define SYS_PFUNC_MISC2_hdmi_hpd_smt_shift                                           (7)
+#define SYS_PFUNC_MISC2_hdmi_hpd_smt_mask                                            (0x00000080)
+#define SYS_PFUNC_MISC2_hdmi_hpd_smt(data)                                           (0x00000080&((data)<<7))
+#define SYS_PFUNC_MISC2_hdmi_hpd_smt_src(data)                                       ((0x00000080&(data))>>7)
+#define SYS_PFUNC_MISC2_get_hdmi_hpd_smt(data)                                       ((0x00000080&(data))>>7)
+#define SYS_PFUNC_MISC2_hdmi_hpd_e2_shift                                            (6)
+#define SYS_PFUNC_MISC2_hdmi_hpd_e2_mask                                             (0x00000040)
+#define SYS_PFUNC_MISC2_hdmi_hpd_e2(data)                                            (0x00000040&((data)<<6))
+#define SYS_PFUNC_MISC2_hdmi_hpd_e2_src(data)                                        ((0x00000040&(data))>>6)
+#define SYS_PFUNC_MISC2_get_hdmi_hpd_e2(data)                                        ((0x00000040&(data))>>6)
+#define SYS_PFUNC_MISC2_hdmi_hpd_pud_en_shift                                        (5)
+#define SYS_PFUNC_MISC2_hdmi_hpd_pud_en_mask                                         (0x00000020)
+#define SYS_PFUNC_MISC2_hdmi_hpd_pud_en(data)                                        (0x00000020&((data)<<5))
+#define SYS_PFUNC_MISC2_hdmi_hpd_pud_en_src(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PFUNC_MISC2_get_hdmi_hpd_pud_en(data)                                    ((0x00000020&(data))>>5)
+#define SYS_PFUNC_MISC2_hdmi_hpd_pud_sel_shift                                       (4)
+#define SYS_PFUNC_MISC2_hdmi_hpd_pud_sel_mask                                        (0x00000010)
+#define SYS_PFUNC_MISC2_hdmi_hpd_pud_sel(data)                                       (0x00000010&((data)<<4))
+#define SYS_PFUNC_MISC2_hdmi_hpd_pud_sel_src(data)                                   ((0x00000010&(data))>>4)
+#define SYS_PFUNC_MISC2_get_hdmi_hpd_pud_sel(data)                                   ((0x00000010&(data))>>4)
+#define SYS_PFUNC_MISC2_gpio_8_smt_shift                                             (3)
+#define SYS_PFUNC_MISC2_gpio_8_smt_mask                                              (0x00000008)
+#define SYS_PFUNC_MISC2_gpio_8_smt(data)                                             (0x00000008&((data)<<3))
+#define SYS_PFUNC_MISC2_gpio_8_smt_src(data)                                         ((0x00000008&(data))>>3)
+#define SYS_PFUNC_MISC2_get_gpio_8_smt(data)                                         ((0x00000008&(data))>>3)
+#define SYS_PFUNC_MISC2_gpio_8_e2_shift                                              (2)
+#define SYS_PFUNC_MISC2_gpio_8_e2_mask                                               (0x00000004)
+#define SYS_PFUNC_MISC2_gpio_8_e2(data)                                              (0x00000004&((data)<<2))
+#define SYS_PFUNC_MISC2_gpio_8_e2_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PFUNC_MISC2_get_gpio_8_e2(data)                                          ((0x00000004&(data))>>2)
+#define SYS_PFUNC_MISC2_gpio_8_pud_en_shift                                          (1)
+#define SYS_PFUNC_MISC2_gpio_8_pud_en_mask                                           (0x00000002)
+#define SYS_PFUNC_MISC2_gpio_8_pud_en(data)                                          (0x00000002&((data)<<1))
+#define SYS_PFUNC_MISC2_gpio_8_pud_en_src(data)                                      ((0x00000002&(data))>>1)
+#define SYS_PFUNC_MISC2_get_gpio_8_pud_en(data)                                      ((0x00000002&(data))>>1)
+#define SYS_PFUNC_MISC2_gpio_8_pud_sel_shift                                         (0)
+#define SYS_PFUNC_MISC2_gpio_8_pud_sel_mask                                          (0x00000001)
+#define SYS_PFUNC_MISC2_gpio_8_pud_sel(data)                                         (0x00000001&((data)<<0))
+#define SYS_PFUNC_MISC2_gpio_8_pud_sel_src(data)                                     ((0x00000001&(data))>>0)
+#define SYS_PFUNC_MISC2_get_gpio_8_pud_sel(data)                                     ((0x00000001&(data))>>0)
+
+
+#define SYS_PFUNC_MISC3                                                              0x180003A0
+#define SYS_PFUNC_MISC3_reg_addr                                                     "0xB80003A0"
+#define SYS_PFUNC_MISC3_reg                                                          0xB80003A0
+#define set_SYS_PFUNC_MISC3_reg(data)   (*((volatile unsigned int*) SYS_PFUNC_MISC3_reg)=data)
+#define get_SYS_PFUNC_MISC3_reg   (*((volatile unsigned int*) SYS_PFUNC_MISC3_reg))
+#define SYS_PFUNC_MISC3_inst_adr                                                     "0x00E8"
+#define SYS_PFUNC_MISC3_inst                                                         0x00E8
+#define SYS_PFUNC_MISC3_boption9_en_shift                                            (17)
+#define SYS_PFUNC_MISC3_boption9_en_mask                                             (0x00020000)
+#define SYS_PFUNC_MISC3_boption9_en(data)                                            (0x00020000&((data)<<17))
+#define SYS_PFUNC_MISC3_boption9_en_src(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PFUNC_MISC3_get_boption9_en(data)                                        ((0x00020000&(data))>>17)
+#define SYS_PFUNC_MISC3_boption9_sel_shift                                           (16)
+#define SYS_PFUNC_MISC3_boption9_sel_mask                                            (0x00010000)
+#define SYS_PFUNC_MISC3_boption9_sel(data)                                           (0x00010000&((data)<<16))
+#define SYS_PFUNC_MISC3_boption9_sel_src(data)                                       ((0x00010000&(data))>>16)
+#define SYS_PFUNC_MISC3_get_boption9_sel(data)                                       ((0x00010000&(data))>>16)
+#define SYS_PFUNC_MISC3_boption8_en_shift                                            (15)
+#define SYS_PFUNC_MISC3_boption8_en_mask                                             (0x00008000)
+#define SYS_PFUNC_MISC3_boption8_en(data)                                            (0x00008000&((data)<<15))
+#define SYS_PFUNC_MISC3_boption8_en_src(data)                                        ((0x00008000&(data))>>15)
+#define SYS_PFUNC_MISC3_get_boption8_en(data)                                        ((0x00008000&(data))>>15)
+#define SYS_PFUNC_MISC3_boption8_sel_shift                                           (14)
+#define SYS_PFUNC_MISC3_boption8_sel_mask                                            (0x00004000)
+#define SYS_PFUNC_MISC3_boption8_sel(data)                                           (0x00004000&((data)<<14))
+#define SYS_PFUNC_MISC3_boption8_sel_src(data)                                       ((0x00004000&(data))>>14)
+#define SYS_PFUNC_MISC3_get_boption8_sel(data)                                       ((0x00004000&(data))>>14)
+#define SYS_PFUNC_MISC3_boption7_en_shift                                            (13)
+#define SYS_PFUNC_MISC3_boption7_en_mask                                             (0x00002000)
+#define SYS_PFUNC_MISC3_boption7_en(data)                                            (0x00002000&((data)<<13))
+#define SYS_PFUNC_MISC3_boption7_en_src(data)                                        ((0x00002000&(data))>>13)
+#define SYS_PFUNC_MISC3_get_boption7_en(data)                                        ((0x00002000&(data))>>13)
+#define SYS_PFUNC_MISC3_boption7_sel_shift                                           (12)
+#define SYS_PFUNC_MISC3_boption7_sel_mask                                            (0x00001000)
+#define SYS_PFUNC_MISC3_boption7_sel(data)                                           (0x00001000&((data)<<12))
+#define SYS_PFUNC_MISC3_boption7_sel_src(data)                                       ((0x00001000&(data))>>12)
+#define SYS_PFUNC_MISC3_get_boption7_sel(data)                                       ((0x00001000&(data))>>12)
+#define SYS_PFUNC_MISC3_boption6_en_shift                                            (11)
+#define SYS_PFUNC_MISC3_boption6_en_mask                                             (0x00000800)
+#define SYS_PFUNC_MISC3_boption6_en(data)                                            (0x00000800&((data)<<11))
+#define SYS_PFUNC_MISC3_boption6_en_src(data)                                        ((0x00000800&(data))>>11)
+#define SYS_PFUNC_MISC3_get_boption6_en(data)                                        ((0x00000800&(data))>>11)
+#define SYS_PFUNC_MISC3_boption6_sel_shift                                           (10)
+#define SYS_PFUNC_MISC3_boption6_sel_mask                                            (0x00000400)
+#define SYS_PFUNC_MISC3_boption6_sel(data)                                           (0x00000400&((data)<<10))
+#define SYS_PFUNC_MISC3_boption6_sel_src(data)                                       ((0x00000400&(data))>>10)
+#define SYS_PFUNC_MISC3_get_boption6_sel(data)                                       ((0x00000400&(data))>>10)
+#define SYS_PFUNC_MISC3_boption5_en_shift                                            (9)
+#define SYS_PFUNC_MISC3_boption5_en_mask                                             (0x00000200)
+#define SYS_PFUNC_MISC3_boption5_en(data)                                            (0x00000200&((data)<<9))
+#define SYS_PFUNC_MISC3_boption5_en_src(data)                                        ((0x00000200&(data))>>9)
+#define SYS_PFUNC_MISC3_get_boption5_en(data)                                        ((0x00000200&(data))>>9)
+#define SYS_PFUNC_MISC3_boption5_sel_shift                                           (8)
+#define SYS_PFUNC_MISC3_boption5_sel_mask                                            (0x00000100)
+#define SYS_PFUNC_MISC3_boption5_sel(data)                                           (0x00000100&((data)<<8))
+#define SYS_PFUNC_MISC3_boption5_sel_src(data)                                       ((0x00000100&(data))>>8)
+#define SYS_PFUNC_MISC3_get_boption5_sel(data)                                       ((0x00000100&(data))>>8)
+#define SYS_PFUNC_MISC3_boption4_en_shift                                            (7)
+#define SYS_PFUNC_MISC3_boption4_en_mask                                             (0x00000080)
+#define SYS_PFUNC_MISC3_boption4_en(data)                                            (0x00000080&((data)<<7))
+#define SYS_PFUNC_MISC3_boption4_en_src(data)                                        ((0x00000080&(data))>>7)
+#define SYS_PFUNC_MISC3_get_boption4_en(data)                                        ((0x00000080&(data))>>7)
+#define SYS_PFUNC_MISC3_boption4_sel_shift                                           (6)
+#define SYS_PFUNC_MISC3_boption4_sel_mask                                            (0x00000040)
+#define SYS_PFUNC_MISC3_boption4_sel(data)                                           (0x00000040&((data)<<6))
+#define SYS_PFUNC_MISC3_boption4_sel_src(data)                                       ((0x00000040&(data))>>6)
+#define SYS_PFUNC_MISC3_get_boption4_sel(data)                                       ((0x00000040&(data))>>6)
+#define SYS_PFUNC_MISC3_boption3_en_shift                                            (5)
+#define SYS_PFUNC_MISC3_boption3_en_mask                                             (0x00000020)
+#define SYS_PFUNC_MISC3_boption3_en(data)                                            (0x00000020&((data)<<5))
+#define SYS_PFUNC_MISC3_boption3_en_src(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PFUNC_MISC3_get_boption3_en(data)                                        ((0x00000020&(data))>>5)
+#define SYS_PFUNC_MISC3_boption3_sel_shift                                           (4)
+#define SYS_PFUNC_MISC3_boption3_sel_mask                                            (0x00000010)
+#define SYS_PFUNC_MISC3_boption3_sel(data)                                           (0x00000010&((data)<<4))
+#define SYS_PFUNC_MISC3_boption3_sel_src(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PFUNC_MISC3_get_boption3_sel(data)                                       ((0x00000010&(data))>>4)
+#define SYS_PFUNC_MISC3_boption1_en_shift                                            (3)
+#define SYS_PFUNC_MISC3_boption1_en_mask                                             (0x00000008)
+#define SYS_PFUNC_MISC3_boption1_en(data)                                            (0x00000008&((data)<<3))
+#define SYS_PFUNC_MISC3_boption1_en_src(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PFUNC_MISC3_get_boption1_en(data)                                        ((0x00000008&(data))>>3)
+#define SYS_PFUNC_MISC3_boption1_sel_shift                                           (2)
+#define SYS_PFUNC_MISC3_boption1_sel_mask                                            (0x00000004)
+#define SYS_PFUNC_MISC3_boption1_sel(data)                                           (0x00000004&((data)<<2))
+#define SYS_PFUNC_MISC3_boption1_sel_src(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PFUNC_MISC3_get_boption1_sel(data)                                       ((0x00000004&(data))>>2)
+#define SYS_PFUNC_MISC3_boption0_en_shift                                            (1)
+#define SYS_PFUNC_MISC3_boption0_en_mask                                             (0x00000002)
+#define SYS_PFUNC_MISC3_boption0_en(data)                                            (0x00000002&((data)<<1))
+#define SYS_PFUNC_MISC3_boption0_en_src(data)                                        ((0x00000002&(data))>>1)
+#define SYS_PFUNC_MISC3_get_boption0_en(data)                                        ((0x00000002&(data))>>1)
+#define SYS_PFUNC_MISC3_boption0_sel_shift                                           (0)
+#define SYS_PFUNC_MISC3_boption0_sel_mask                                            (0x00000001)
+#define SYS_PFUNC_MISC3_boption0_sel(data)                                           (0x00000001&((data)<<0))
+#define SYS_PFUNC_MISC3_boption0_sel_src(data)                                       ((0x00000001&(data))>>0)
+#define SYS_PFUNC_MISC3_get_boption0_sel(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SYS_CRT_DEBUG                                                                0x18000400
+#define SYS_CRT_DEBUG_reg_addr                                                       "0xB8000400"
+#define SYS_CRT_DEBUG_reg                                                            0xB8000400
+#define set_SYS_CRT_DEBUG_reg(data)   (*((volatile unsigned int*) SYS_CRT_DEBUG_reg)=data)
+#define get_SYS_CRT_DEBUG_reg   (*((volatile unsigned int*) SYS_CRT_DEBUG_reg))
+#define SYS_CRT_DEBUG_inst_adr                                                       "0x0000"
+#define SYS_CRT_DEBUG_inst                                                           0x0000
+#define SYS_CRT_DEBUG_crt_dbg_en_shift                                               (8)
+#define SYS_CRT_DEBUG_crt_dbg_en_mask                                                (0x00000100)
+#define SYS_CRT_DEBUG_crt_dbg_en(data)                                               (0x00000100&((data)<<8))
+#define SYS_CRT_DEBUG_crt_dbg_en_src(data)                                           ((0x00000100&(data))>>8)
+#define SYS_CRT_DEBUG_get_crt_dbg_en(data)                                           ((0x00000100&(data))>>8)
+#define SYS_CRT_DEBUG_crt_dbg_sel0_shift                                             (4)
+#define SYS_CRT_DEBUG_crt_dbg_sel0_mask                                              (0x000000F0)
+#define SYS_CRT_DEBUG_crt_dbg_sel0(data)                                             (0x000000F0&((data)<<4))
+#define SYS_CRT_DEBUG_crt_dbg_sel0_src(data)                                         ((0x000000F0&(data))>>4)
+#define SYS_CRT_DEBUG_get_crt_dbg_sel0(data)                                         ((0x000000F0&(data))>>4)
+#define SYS_CRT_DEBUG_crt_dbg_sel1_shift                                             (0)
+#define SYS_CRT_DEBUG_crt_dbg_sel1_mask                                              (0x0000000F)
+#define SYS_CRT_DEBUG_crt_dbg_sel1(data)                                             (0x0000000F&((data)<<0))
+#define SYS_CRT_DEBUG_crt_dbg_sel1_src(data)                                         ((0x0000000F&(data))>>0)
+#define SYS_CRT_DEBUG_get_crt_dbg_sel1(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define SYS_DEBUG                                                                    0x18000404
+#define SYS_DEBUG_reg_addr                                                           "0xB8000404"
+#define SYS_DEBUG_reg                                                                0xB8000404
+#define set_SYS_DEBUG_reg(data)   (*((volatile unsigned int*) SYS_DEBUG_reg)=data)
+#define get_SYS_DEBUG_reg   (*((volatile unsigned int*) SYS_DEBUG_reg))
+#define SYS_DEBUG_inst_adr                                                           "0x0001"
+#define SYS_DEBUG_inst                                                               0x0001
+#define SYS_DEBUG_dbg_en_shift                                                       (14)
+#define SYS_DEBUG_dbg_en_mask                                                        (0x00004000)
+#define SYS_DEBUG_dbg_en(data)                                                       (0x00004000&((data)<<14))
+#define SYS_DEBUG_dbg_en_src(data)                                                   ((0x00004000&(data))>>14)
+#define SYS_DEBUG_get_dbg_en(data)                                                   ((0x00004000&(data))>>14)
+#define SYS_DEBUG_dbg_loc_shift                                                      (12)
+#define SYS_DEBUG_dbg_loc_mask                                                       (0x00003000)
+#define SYS_DEBUG_dbg_loc(data)                                                      (0x00003000&((data)<<12))
+#define SYS_DEBUG_dbg_loc_src(data)                                                  ((0x00003000&(data))>>12)
+#define SYS_DEBUG_get_dbg_loc(data)                                                  ((0x00003000&(data))>>12)
+#define SYS_DEBUG_dbg_sel0_shift                                                     (6)
+#define SYS_DEBUG_dbg_sel0_mask                                                      (0x00000FC0)
+#define SYS_DEBUG_dbg_sel0(data)                                                     (0x00000FC0&((data)<<6))
+#define SYS_DEBUG_dbg_sel0_src(data)                                                 ((0x00000FC0&(data))>>6)
+#define SYS_DEBUG_get_dbg_sel0(data)                                                 ((0x00000FC0&(data))>>6)
+#define SYS_DEBUG_dbg_sel1_shift                                                     (0)
+#define SYS_DEBUG_dbg_sel1_mask                                                      (0x0000003F)
+#define SYS_DEBUG_dbg_sel1(data)                                                     (0x0000003F&((data)<<0))
+#define SYS_DEBUG_dbg_sel1_src(data)                                                 ((0x0000003F&(data))>>0)
+#define SYS_DEBUG_get_dbg_sel1(data)                                                 ((0x0000003F&(data))>>0)
+
+
+#define SYS_MBIST                                                                    0x18000408
+#define SYS_MBIST_reg_addr                                                           "0xB8000408"
+#define SYS_MBIST_reg                                                                0xB8000408
+#define set_SYS_MBIST_reg(data)   (*((volatile unsigned int*) SYS_MBIST_reg)=data)
+#define get_SYS_MBIST_reg   (*((volatile unsigned int*) SYS_MBIST_reg))
+#define SYS_MBIST_inst_adr                                                           "0x0002"
+#define SYS_MBIST_inst                                                               0x0002
+#define SYS_MBIST_mbist_ve2_st_shift                                                 (21)
+#define SYS_MBIST_mbist_ve2_st_mask                                                  (0x00200000)
+#define SYS_MBIST_mbist_ve2_st(data)                                                 (0x00200000&((data)<<21))
+#define SYS_MBIST_mbist_ve2_st_src(data)                                             ((0x00200000&(data))>>21)
+#define SYS_MBIST_get_mbist_ve2_st(data)                                             ((0x00200000&(data))>>21)
+#define SYS_MBIST_mbist_ve1_st_shift                                                 (20)
+#define SYS_MBIST_mbist_ve1_st_mask                                                  (0x00100000)
+#define SYS_MBIST_mbist_ve1_st(data)                                                 (0x00100000&((data)<<20))
+#define SYS_MBIST_mbist_ve1_st_src(data)                                             ((0x00100000&(data))>>20)
+#define SYS_MBIST_get_mbist_ve1_st(data)                                             ((0x00100000&(data))>>20)
+#define SYS_MBIST_mbist_scpu_st_shift                                                (19)
+#define SYS_MBIST_mbist_scpu_st_mask                                                 (0x00080000)
+#define SYS_MBIST_mbist_scpu_st(data)                                                (0x00080000&((data)<<19))
+#define SYS_MBIST_mbist_scpu_st_src(data)                                            ((0x00080000&(data))>>19)
+#define SYS_MBIST_get_mbist_scpu_st(data)                                            ((0x00080000&(data))>>19)
+#define SYS_MBIST_mbist_mipi_st_shift                                                (18)
+#define SYS_MBIST_mbist_mipi_st_mask                                                 (0x00040000)
+#define SYS_MBIST_mbist_mipi_st(data)                                                (0x00040000&((data)<<18))
+#define SYS_MBIST_mbist_mipi_st_src(data)                                            ((0x00040000&(data))>>18)
+#define SYS_MBIST_get_mbist_mipi_st(data)                                            ((0x00040000&(data))>>18)
+#define SYS_MBIST_mbist_usb_st_shift                                                 (17)
+#define SYS_MBIST_mbist_usb_st_mask                                                  (0x00020000)
+#define SYS_MBIST_mbist_usb_st(data)                                                 (0x00020000&((data)<<17))
+#define SYS_MBIST_mbist_usb_st_src(data)                                             ((0x00020000&(data))>>17)
+#define SYS_MBIST_get_mbist_usb_st(data)                                             ((0x00020000&(data))>>17)
+#define SYS_MBIST_mbist_se_st_shift                                                  (16)
+#define SYS_MBIST_mbist_se_st_mask                                                   (0x00010000)
+#define SYS_MBIST_mbist_se_st(data)                                                  (0x00010000&((data)<<16))
+#define SYS_MBIST_mbist_se_st_src(data)                                              ((0x00010000&(data))>>16)
+#define SYS_MBIST_get_mbist_se_st(data)                                              ((0x00010000&(data))>>16)
+#define SYS_MBIST_mbist_md_st_shift                                                  (15)
+#define SYS_MBIST_mbist_md_st_mask                                                   (0x00008000)
+#define SYS_MBIST_mbist_md_st(data)                                                  (0x00008000&((data)<<15))
+#define SYS_MBIST_mbist_md_st_src(data)                                              ((0x00008000&(data))>>15)
+#define SYS_MBIST_get_mbist_md_st(data)                                              ((0x00008000&(data))>>15)
+#define SYS_MBIST_mbist_nf_st_shift                                                  (14)
+#define SYS_MBIST_mbist_nf_st_mask                                                   (0x00004000)
+#define SYS_MBIST_mbist_nf_st(data)                                                  (0x00004000&((data)<<14))
+#define SYS_MBIST_mbist_nf_st_src(data)                                              ((0x00004000&(data))>>14)
+#define SYS_MBIST_get_mbist_nf_st(data)                                              ((0x00004000&(data))>>14)
+#define SYS_MBIST_mbist_cr_st_shift                                                  (13)
+#define SYS_MBIST_mbist_cr_st_mask                                                   (0x00002000)
+#define SYS_MBIST_mbist_cr_st(data)                                                  (0x00002000&((data)<<13))
+#define SYS_MBIST_mbist_cr_st_src(data)                                              ((0x00002000&(data))>>13)
+#define SYS_MBIST_get_mbist_cr_st(data)                                              ((0x00002000&(data))>>13)
+#define SYS_MBIST_mbist_etn_st_shift                                                 (12)
+#define SYS_MBIST_mbist_etn_st_mask                                                  (0x00001000)
+#define SYS_MBIST_mbist_etn_st(data)                                                 (0x00001000&((data)<<12))
+#define SYS_MBIST_mbist_etn_st_src(data)                                             ((0x00001000&(data))>>12)
+#define SYS_MBIST_get_mbist_etn_st(data)                                             ((0x00001000&(data))>>12)
+#define SYS_MBIST_mbist_dp_st_shift                                                  (11)
+#define SYS_MBIST_mbist_dp_st_mask                                                   (0x00000800)
+#define SYS_MBIST_mbist_dp_st(data)                                                  (0x00000800&((data)<<11))
+#define SYS_MBIST_mbist_dp_st_src(data)                                              ((0x00000800&(data))>>11)
+#define SYS_MBIST_get_mbist_dp_st(data)                                              ((0x00000800&(data))>>11)
+#define SYS_MBIST_mbist_ae_st_shift                                                  (10)
+#define SYS_MBIST_mbist_ae_st_mask                                                   (0x00000400)
+#define SYS_MBIST_mbist_ae_st(data)                                                  (0x00000400&((data)<<10))
+#define SYS_MBIST_mbist_ae_st_src(data)                                              ((0x00000400&(data))>>10)
+#define SYS_MBIST_get_mbist_ae_st(data)                                              ((0x00000400&(data))>>10)
+#define SYS_MBIST_mbist_acpu_st_shift                                                (9)
+#define SYS_MBIST_mbist_acpu_st_mask                                                 (0x00000200)
+#define SYS_MBIST_mbist_acpu_st(data)                                                (0x00000200&((data)<<9))
+#define SYS_MBIST_mbist_acpu_st_src(data)                                            ((0x00000200&(data))>>9)
+#define SYS_MBIST_get_mbist_acpu_st(data)                                            ((0x00000200&(data))>>9)
+#define SYS_MBIST_mbist_gpu_st_shift                                                 (8)
+#define SYS_MBIST_mbist_gpu_st_mask                                                  (0x00000100)
+#define SYS_MBIST_mbist_gpu_st(data)                                                 (0x00000100&((data)<<8))
+#define SYS_MBIST_mbist_gpu_st_src(data)                                             ((0x00000100&(data))>>8)
+#define SYS_MBIST_get_mbist_gpu_st(data)                                             ((0x00000100&(data))>>8)
+#define SYS_MBIST_mbist_tp_st_shift                                                  (7)
+#define SYS_MBIST_mbist_tp_st_mask                                                   (0x00000080)
+#define SYS_MBIST_mbist_tp_st(data)                                                  (0x00000080&((data)<<7))
+#define SYS_MBIST_mbist_tp_st_src(data)                                              ((0x00000080&(data))>>7)
+#define SYS_MBIST_get_mbist_tp_st(data)                                              ((0x00000080&(data))>>7)
+#define SYS_MBIST_mbist_aio_st_shift                                                 (6)
+#define SYS_MBIST_mbist_aio_st_mask                                                  (0x00000040)
+#define SYS_MBIST_mbist_aio_st(data)                                                 (0x00000040&((data)<<6))
+#define SYS_MBIST_mbist_aio_st_src(data)                                             ((0x00000040&(data))>>6)
+#define SYS_MBIST_get_mbist_aio_st(data)                                             ((0x00000040&(data))>>6)
+#define SYS_MBIST_mbist_pif_st_shift                                                 (5)
+#define SYS_MBIST_mbist_pif_st_mask                                                  (0x00000020)
+#define SYS_MBIST_mbist_pif_st(data)                                                 (0x00000020&((data)<<5))
+#define SYS_MBIST_mbist_pif_st_src(data)                                             ((0x00000020&(data))>>5)
+#define SYS_MBIST_get_mbist_pif_st(data)                                             ((0x00000020&(data))>>5)
+#define SYS_MBIST_mbist_hdmi_st_shift                                                (4)
+#define SYS_MBIST_mbist_hdmi_st_mask                                                 (0x00000010)
+#define SYS_MBIST_mbist_hdmi_st(data)                                                (0x00000010&((data)<<4))
+#define SYS_MBIST_mbist_hdmi_st_src(data)                                            ((0x00000010&(data))>>4)
+#define SYS_MBIST_get_mbist_hdmi_st(data)                                            ((0x00000010&(data))>>4)
+#define SYS_MBIST_mbist_vo_st_shift                                                  (3)
+#define SYS_MBIST_mbist_vo_st_mask                                                   (0x00000008)
+#define SYS_MBIST_mbist_vo_st(data)                                                  (0x00000008&((data)<<3))
+#define SYS_MBIST_mbist_vo_st_src(data)                                              ((0x00000008&(data))>>3)
+#define SYS_MBIST_get_mbist_vo_st(data)                                              ((0x00000008&(data))>>3)
+#define SYS_MBIST_mbist_dc_phy_st_shift                                              (2)
+#define SYS_MBIST_mbist_dc_phy_st_mask                                               (0x00000004)
+#define SYS_MBIST_mbist_dc_phy_st(data)                                              (0x00000004&((data)<<2))
+#define SYS_MBIST_mbist_dc_phy_st_src(data)                                          ((0x00000004&(data))>>2)
+#define SYS_MBIST_get_mbist_dc_phy_st(data)                                          ((0x00000004&(data))>>2)
+#define SYS_MBIST_mbist_dc_sys_st_shift                                              (1)
+#define SYS_MBIST_mbist_dc_sys_st_mask                                               (0x00000002)
+#define SYS_MBIST_mbist_dc_sys_st(data)                                              (0x00000002&((data)<<1))
+#define SYS_MBIST_mbist_dc_sys_st_src(data)                                          ((0x00000002&(data))>>1)
+#define SYS_MBIST_get_mbist_dc_sys_st(data)                                          ((0x00000002&(data))>>1)
+#define SYS_MBIST_mbist_cp_st_shift                                                  (0)
+#define SYS_MBIST_mbist_cp_st_mask                                                   (0x00000001)
+#define SYS_MBIST_mbist_cp_st(data)                                                  (0x00000001&((data)<<0))
+#define SYS_MBIST_mbist_cp_st_src(data)                                              ((0x00000001&(data))>>0)
+#define SYS_MBIST_get_mbist_cp_st(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SYS_DUMMY                                                                    0x18000450
+#define SYS_DUMMY_reg_addr                                                           "0xB8000450"
+#define SYS_DUMMY_reg                                                                0xB8000450
+#define set_SYS_DUMMY_reg(data)   (*((volatile unsigned int*) SYS_DUMMY_reg)=data)
+#define get_SYS_DUMMY_reg   (*((volatile unsigned int*) SYS_DUMMY_reg))
+#define SYS_DUMMY_inst_adr                                                           "0x0014"
+#define SYS_DUMMY_inst                                                               0x0014
+#define SYS_DUMMY_dummy_reg_shift                                                    (0)
+#define SYS_DUMMY_dummy_reg_mask                                                     (0xFFFFFFFF)
+#define SYS_DUMMY_dummy_reg(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define SYS_DUMMY_dummy_reg_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define SYS_DUMMY_get_dummy_reg(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/dc_phy_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/dc_phy_reg.h
new file mode 100644
index 00000000..b5aecfe
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/dc_phy_reg.h
@@ -0,0 +1,8384 @@
+/**************************************************************
+// Spec Version                  : 0.0.1
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/7/18 20:29:9
+***************************************************************/
+
+
+#ifndef _DC_PHY_REG_H_INCLUDED_
+#define _DC_PHY_REG_H_INCLUDED_
+#ifdef  _DC_PHY_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     tmras:9;
+unsigned int     tmrcl:4;
+unsigned int     tmcl:4;
+unsigned int     reserved_1:1;
+unsigned int     tmcl_rd:7;
+}DC_PHY_TMCTRL0;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     tmrrd:5;
+unsigned int     reserved_1:2;
+unsigned int     tmrp:6;
+unsigned int     reserved_2:2;
+unsigned int     tmrcd:6;
+unsigned int     tmrc:8;
+}DC_PHY_TMCTRL1;
+
+typedef struct 
+{
+unsigned int     tmrtw:2;
+unsigned int     reserved_0:1;
+unsigned int     tmccd:5;
+unsigned int     reserved_1:1;
+unsigned int     trtp:7;
+unsigned int     reserved_2:3;
+unsigned int     tmwtr:5;
+unsigned int     reserved_3:2;
+unsigned int     tmwr:6;
+}DC_PHY_TMCTRL2;
+
+typedef struct 
+{
+unsigned int     tmFAW:8;
+unsigned int     reserved_0:2;
+unsigned int     refcycle:10;
+unsigned int     reserved_1:1;
+unsigned int     tmrfc:11;
+}DC_PHY_TMCTRL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     tAOND:6;
+unsigned int     reserved_1:2;
+unsigned int     tAOFD:6;
+unsigned int     tmmod:8;
+unsigned int     reserved_2:3;
+unsigned int     tmmrd:5;
+}DC_PHY_TMCTRL4;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tzqoper:12;
+unsigned int     tzqinit:12;
+}DC_PHY_TMCTRL5;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tdllk:12;
+unsigned int     tzqcs:12;
+}DC_PHY_TMCTRL6;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     ddr3_odt_dly_1T:1;
+unsigned int     ddr3_odt_ext_1T:1;
+unsigned int     ctrl_odt_en:1;
+unsigned int     mars_odt_force_sel:1;
+unsigned int     mars_odt_force_sig:1;
+unsigned int     odt_force_sel:1;
+unsigned int     odt_force_sig:1;
+unsigned int     odt_en:1;
+unsigned int     odt_dis:1;
+unsigned int     reserved_1:5;
+unsigned int     odt_en_lat:15;
+}DC_PHY_ODT_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     cal_rang:6;
+unsigned int     cal_per:8;
+}DC_PHY_CAL_CTRL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     exe_cal:1;
+unsigned int     init:1;
+unsigned int     sren:1;
+unsigned int     srex:1;
+unsigned int     exe_emr:1;
+unsigned int     exe_mr:1;
+}DC_PHY_DC_MIS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     rcd_not_eq:1;
+unsigned int     tmrcdwr:4;
+unsigned int     tmrp_all_add:2;
+unsigned int     ap_wo_min_dly:1;
+unsigned int     add_ht:1;
+unsigned int     reserved_1:11;
+unsigned int     ddr3:1;
+}DC_PHY_DC_MIS;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     pre_dis:1;
+unsigned int     reserved_1:9;
+unsigned int     lbk_en:1;
+unsigned int     reserved_2:2;
+}DC_PHY_DC_MISA;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     tmrc_sel:1;
+unsigned int     reserved_1:13;
+unsigned int     cpu_rd_pri:2;
+unsigned int     cpu_wr_pri:2;
+unsigned int     en_rw_reord:1;
+unsigned int     en_cpu_wro:1;
+unsigned int     en_conflict_reord:1;
+unsigned int     en_cpu_reord:1;
+unsigned int     cpu_reord_thr:3;
+unsigned int     en_low_reord:1;
+unsigned int     dis_ap_cpu:1;
+unsigned int     dis_ap_cti:1;
+unsigned int     dis_ap_nor:1;
+}DC_PHY_DC_MISB;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     tap_2group:1;
+unsigned int     tap_mask:1;
+unsigned int     fw_set:1;
+unsigned int     tap_sel:1;
+unsigned int     reserved_1:24;
+}DC_PHY_DC_MISC;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     clear_set_sys:1;
+unsigned int     clear_trig:1;
+unsigned int     test_mode_sel:1;
+}DC_PHY_DC_TEST_MODE_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en_14:1;
+unsigned int     ddr3_swap:1;
+unsigned int     write_en_13:1;
+unsigned int     end_500us:1;
+unsigned int     write_en_12:1;
+unsigned int     end_200us:1;
+unsigned int     write_en_11:1;
+unsigned int     fast_prechg:1;
+unsigned int     write_en_10:1;
+unsigned int     dis_cti:1;
+unsigned int     write_en_9:1;
+unsigned int     dis_8bank:1;
+unsigned int     write_en_8:1;
+unsigned int     use_tmmrd:1;
+unsigned int     write_en_7:1;
+unsigned int     dis_pre_all:1;
+unsigned int     write_en_6:1;
+unsigned int     ddr3_zqcl_short:1;
+unsigned int     write_en_5:1;
+unsigned int     ddr3_exe_zqcl:1;
+unsigned int     write_en_4:1;
+unsigned int     ddr3_exe_mr3:1;
+unsigned int     write_en_3:1;
+unsigned int     ddr3_exe_mr2:1;
+unsigned int     write_en_2:1;
+unsigned int     ddr3_exe_mr1:1;
+unsigned int     write_en_1:1;
+unsigned int     ddr3_exe_mr0:1;
+unsigned int     write_en_0:1;
+unsigned int     ddr3_init:1;
+}DC_PHY_DC_DDR3_CTL;
+
+typedef struct 
+{
+unsigned int     exmod_reg:16;
+unsigned int     mod_reg:16;
+}DC_PHY_MOD_REG;
+
+typedef struct 
+{
+unsigned int     mod3_reg:16;
+unsigned int     mod2_reg:16;
+}DC_PHY_MOD23_REG;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     wfifo_rdy_gated:1;
+unsigned int     reserved_1:3;
+unsigned int     rdwr_use_full:1;
+unsigned int     full_gated:1;
+unsigned int     rfifo_thred:7;
+}DC_PHY_RFIFO_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     err_cti_cmd:1;
+unsigned int     err_active:1;
+}DC_PHY_ERR_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     exe_prea:1;
+unsigned int     dis_refresh:1;
+unsigned int     trig_wr_level:1;
+unsigned int     wr_level_rdy:1;
+}DC_PHY_DC_WRITE_LEVEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     int_err_cticmd_en:1;
+unsigned int     int_err_active_en:1;
+unsigned int     int_vcpu_en:1;
+unsigned int     int_acpu_en:1;
+unsigned int     int_scpu_en:1;
+}DC_PHY_INT_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     non_valid_maxcnt:1;
+unsigned int     rfifo_cnt_max:7;
+}DC_PHY_RFIFO_MAXCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     par_st_1:5;
+unsigned int     bank_act:8;
+unsigned int     cmd_cnt:3;
+unsigned int     par_st:10;
+}DC_PHY_SM_STATUS;
+
+typedef struct 
+{
+unsigned int     wfifo_sys_req_statistic_en:1;
+unsigned int     wfifo_ddr_req_statistic_en:1;
+unsigned int     clear_wfifo_record:1;
+unsigned int     reserved_0:5;
+unsigned int     wfifo_rd_cnt_et:8;
+unsigned int     wfifo_rd_cnt_rl:8;
+unsigned int     wfifo_wr_cnt_rl:8;
+}DC_PHY_WFIFO_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     io_blk_dbg_mode:3;
+unsigned int     reserved_1:1;
+unsigned int     dbg_out_mod:3;
+unsigned int     pad_tie_value:4;
+unsigned int     shift_trig_mode:7;
+unsigned int     rd_dbg_mod:3;
+unsigned int     dbg_mod:6;
+}DC_PHY_DC_DEBUG;
+
+typedef struct 
+{
+unsigned int     post_trig_cnt:16;
+unsigned int     pre_trig_cnt:16;
+}DC_PHY_PRE_CNT;
+
+typedef struct 
+{
+unsigned int     wfifo_sys_req_wait_total:32;
+}DC_PHY_WFIFO_SYS_REQ_WAIT;
+
+typedef struct 
+{
+unsigned int     wfifo_ddr_req_wait_total:32;
+}DC_PHY_WFIFO_DDR_REQ_WAIT;
+
+typedef struct 
+{
+unsigned int     wfifo_ddr_req_wait_max:16;
+unsigned int     wfifo_sys_req_wait_max:16;
+}DC_PHY_WFIFO_MAX_REQ_WAIT;
+
+typedef struct 
+{
+unsigned int     wr_level_rdata:32;
+}DC_PHY_DC_WRITE_LEVEL_DQ;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_1_0:6;
+unsigned int     ph_sel_dq_pos_1_0:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_0_0:6;
+unsigned int     ph_sel_dq_pos_0_0:6;
+}DC_PHY_DQ0_1_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_3_0:6;
+unsigned int     ph_sel_dq_pos_3_0:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_2_0:6;
+unsigned int     ph_sel_dq_pos_2_0:6;
+}DC_PHY_DQ2_3_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_5_0:6;
+unsigned int     ph_sel_dq_pos_5_0:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_4_0:6;
+unsigned int     ph_sel_dq_pos_4_0:6;
+}DC_PHY_DQ4_5_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_7_0:6;
+unsigned int     ph_sel_dq_pos_7_0:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_6_0:6;
+unsigned int     ph_sel_dq_pos_6_0:6;
+}DC_PHY_DQ6_7_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_1_1:6;
+unsigned int     ph_sel_dq_pos_1_1:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_0_1:6;
+unsigned int     ph_sel_dq_pos_0_1:6;
+}DC_PHY_DQ8_9_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_3_1:6;
+unsigned int     ph_sel_dq_pos_3_1:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_2_1:6;
+unsigned int     ph_sel_dq_pos_2_1:6;
+}DC_PHY_DQ10_11_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_5_1:6;
+unsigned int     ph_sel_dq_pos_5_1:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_4_1:6;
+unsigned int     ph_sel_dq_pos_4_1:6;
+}DC_PHY_DQ12_13_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_7_1:6;
+unsigned int     ph_sel_dq_pos_7_1:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_6_1:6;
+unsigned int     ph_sel_dq_pos_6_1:6;
+}DC_PHY_DQ14_15_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_1_2:6;
+unsigned int     ph_sel_dq_pos_1_2:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_0_2:6;
+unsigned int     ph_sel_dq_pos_0_2:6;
+}DC_PHY_DQ16_17_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_3_2:6;
+unsigned int     ph_sel_dq_pos_3_2:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_2_2:6;
+unsigned int     ph_sel_dq_pos_2_2:6;
+}DC_PHY_DQ18_19_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_5_2:6;
+unsigned int     ph_sel_dq_pos_5_2:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_4_2:6;
+unsigned int     ph_sel_dq_pos_4_2:6;
+}DC_PHY_DQ20_21_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_7_2:6;
+unsigned int     ph_sel_dq_pos_7_2:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_6_2:6;
+unsigned int     ph_sel_dq_pos_6_2:6;
+}DC_PHY_DQ22_23_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_1_3:6;
+unsigned int     ph_sel_dq_pos_1_3:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_0_3:6;
+unsigned int     ph_sel_dq_pos_0_3:6;
+}DC_PHY_DQ24_25_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_3_3:6;
+unsigned int     ph_sel_dq_pos_3_3:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_2_3:6;
+unsigned int     ph_sel_dq_pos_2_3:6;
+}DC_PHY_DQ26_27_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_5_3:6;
+unsigned int     ph_sel_dq_pos_5_3:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_4_3:6;
+unsigned int     ph_sel_dq_pos_4_3:6;
+}DC_PHY_DQ28_29_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ph_sel_dq_neg_7_3:6;
+unsigned int     ph_sel_dq_pos_7_3:6;
+unsigned int     reserved_1:4;
+unsigned int     ph_sel_dq_neg_6_3:6;
+unsigned int     ph_sel_dq_pos_6_3:6;
+}DC_PHY_DQ30_31_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq1_neg_dlyn_0:6;
+unsigned int     cal_dq1_pos_dlyn_0:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq0_neg_dlyn_0:6;
+unsigned int     cal_dq0_pos_dlyn_0:6;
+}DC_PHY_CAL0_1_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq3_neg_dlyn_0:6;
+unsigned int     cal_dq3_pos_dlyn_0:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq2_neg_dlyn_0:6;
+unsigned int     cal_dq2_pos_dlyn_0:6;
+}DC_PHY_CAL2_3_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq5_neg_dlyn_0:6;
+unsigned int     cal_dq5_pos_dlyn_0:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq4_neg_dlyn_0:6;
+unsigned int     cal_dq4_pos_dlyn_0:6;
+}DC_PHY_CAL4_5_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq7_neg_dlyn_0:6;
+unsigned int     cal_dq7_pos_dlyn_0:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq6_neg_dlyn_0:6;
+unsigned int     cal_dq6_pos_dlyn_0:6;
+}DC_PHY_CAL6_7_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq1_neg_dlyn_1:6;
+unsigned int     cal_dq1_pos_dlyn_1:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq0_neg_dlyn_1:6;
+unsigned int     cal_dq0_pos_dlyn_1:6;
+}DC_PHY_CAL8_9_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq3_neg_dlyn_1:6;
+unsigned int     cal_dq3_pos_dlyn_1:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq2_neg_dlyn_1:6;
+unsigned int     cal_dq2_pos_dlyn_1:6;
+}DC_PHY_CAL10_11_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq5_neg_dlyn_1:6;
+unsigned int     cal_dq5_pos_dlyn_1:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq4_neg_dlyn_1:6;
+unsigned int     cal_dq4_pos_dlyn_1:6;
+}DC_PHY_CAL12_13_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq7_neg_dlyn_1:6;
+unsigned int     cal_dq7_pos_dlyn_1:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq6_neg_dlyn_1:6;
+unsigned int     cal_dq6_pos_dlyn_1:6;
+}DC_PHY_CAL14_15_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq1_neg_dlyn_2:6;
+unsigned int     cal_dq1_pos_dlyn_2:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq0_neg_dlyn_2:6;
+unsigned int     cal_dq0_pos_dlyn_2:6;
+}DC_PHY_CAL16_17_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq3_neg_dlyn_2:6;
+unsigned int     cal_dq3_pos_dlyn_2:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq2_neg_dlyn_2:6;
+unsigned int     cal_dq2_pos_dlyn_2:6;
+}DC_PHY_CAL18_19_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq5_neg_dlyn_2:6;
+unsigned int     cal_dq5_pos_dlyn_2:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq4_neg_dlyn_2:6;
+unsigned int     cal_dq4_pos_dlyn_2:6;
+}DC_PHY_CAL20_21_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq7_neg_dlyn_2:6;
+unsigned int     cal_dq7_pos_dlyn_2:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq6_neg_dlyn_2:6;
+unsigned int     cal_dq6_pos_dlyn_2:6;
+}DC_PHY_CAL22_23_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq1_neg_dlyn_3:6;
+unsigned int     cal_dq1_pos_dlyn_3:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq0_neg_dlyn_3:6;
+unsigned int     cal_dq0_pos_dlyn_3:6;
+}DC_PHY_CAL24_25_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq3_neg_dlyn_3:6;
+unsigned int     cal_dq3_pos_dlyn_3:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq2_neg_dlyn_3:6;
+unsigned int     cal_dq2_pos_dlyn_3:6;
+}DC_PHY_CAL26_27_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq5_neg_dlyn_3:6;
+unsigned int     cal_dq5_pos_dlyn_3:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq4_neg_dlyn_3:6;
+unsigned int     cal_dq4_pos_dlyn_3:6;
+}DC_PHY_CAL28_29_DLYN;
+
+typedef struct 
+{
+unsigned int     non_valid:1;
+unsigned int     reserved_0:3;
+unsigned int     cal_dq7_neg_dlyn_3:6;
+unsigned int     cal_dq7_pos_dlyn_3:6;
+unsigned int     reserved_1:4;
+unsigned int     cal_dq6_neg_dlyn_3:6;
+unsigned int     cal_dq6_pos_dlyn_3:6;
+}DC_PHY_CAL30_31_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     read_lat_sel:1;
+unsigned int     read_lat:2;
+unsigned int     ph_sel_read23:4;
+unsigned int     ph_sel_read01:4;
+unsigned int     reserved_1:3;
+unsigned int     read_com_sel:1;
+}DC_PHY_READ_COM_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     pos_trig_sel:3;
+unsigned int     reserved_1:1;
+unsigned int     pre_trig_sel:3;
+unsigned int     reserved_2:2;
+unsigned int     sync_cal_dlyn:1;
+unsigned int     auto_cal:1;
+}DC_PHY_CAL_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     gated_latch_sel:1;
+unsigned int     clk_ddr_phy_mux_div2_0_ph_sel:1;
+unsigned int     clk_ddr_div2_odd_1_ph_sel:1;
+unsigned int     clk_ddr_div2_odd_0_ph_sel:1;
+unsigned int     clk_ddr_div2_1_ph_sel:1;
+unsigned int     clk_ddr_div2_0_ph_sel:1;
+unsigned int     Tx_dlc_sel_dck_1:4;
+unsigned int     reserved_1:2;
+unsigned int     dqsf_dlyn:2;
+unsigned int     Tx_dlc_sel_dck:4;
+}DC_PHY_FIFO_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     grp1_bk_oe:1;
+unsigned int     grp1_addr1_oe:1;
+unsigned int     grp1_addr_oe:1;
+unsigned int     grp1_cke_oe:1;
+unsigned int     grp1_ck_oe:1;
+unsigned int     grp1_addr1_15_oe:1;
+unsigned int     grp1_addr1_14_oe:1;
+unsigned int     grp1_addr1_13_oe:1;
+unsigned int     grp1_addr_15_oe:1;
+unsigned int     grp1_addr_14_oe:1;
+unsigned int     grp1_addr_13_oe:1;
+unsigned int     reserved_1:1;
+}DC_PHY_PAD_OE_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     iddq_0:13;
+}DC_PHY_PAD_IDDQ0;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     refctrl_pdref:1;
+unsigned int     reserved_1:1;
+unsigned int     zctrl_ovrd_en:1;
+unsigned int     zctrl_ovrd_data:22;
+}DC_PHY_PAD_ZCTRL_OVRD;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ocd_mode:1;
+unsigned int     dzq_up_sel:3;
+unsigned int     dzq_auto_up:1;
+unsigned int     zctrl_clk_sel:2;
+unsigned int     zctrl_start:1;
+unsigned int     dzq_ref_up:1;
+unsigned int     ext_r240_sel:1;
+unsigned int     rzq_zcomp_inv:1;
+unsigned int     rzq_cal_en:1;
+unsigned int     reserved_1:2;
+unsigned int     zprog:14;
+}DC_PHY_PAD_CTRL_PROG;
+
+typedef struct 
+{
+unsigned int     zctrl_status:32;
+}DC_PHY_PAD_ZCTRL_STATUS;
+
+typedef struct 
+{
+unsigned int     dq_dly_sel0:32;
+}DC_PHY_DQ_DLY_SEL0;
+
+typedef struct 
+{
+unsigned int     dq_dly_sel1:32;
+}DC_PHY_DQ_DLY_SEL1;
+
+typedef struct 
+{
+unsigned int     dq_dly_sel2:32;
+}DC_PHY_DQ_DLY_SEL2;
+
+typedef struct 
+{
+unsigned int     dq_dly_sel3:32;
+}DC_PHY_DQ_DLY_SEL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     dqs_oe_dly_sel:12;
+}DC_PHY_DQS_OE_DLY_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     half_cycle_cal_sel:1;
+unsigned int     half_cycle_ref_thr:8;
+unsigned int     half_cycle_res_thr:6;
+unsigned int     half_cycle_res_mod:2;
+unsigned int     half_cycle_cal_en:1;
+}DC_PHY_HALF_CYCLE_CAL_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     half_cycle_cal_setting_3:6;
+unsigned int     half_cycle_cal_setting_2:6;
+unsigned int     half_cycle_cal_setting_1:6;
+unsigned int     half_cycle_cal_setting_0:6;
+}DC_PHY_HALF_CYCLE_CAL_SET;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     pupd_dly_mux_sel:2;
+unsigned int     pupd_dly_num_sel:2;
+unsigned int     pupd_dly_num_3:5;
+unsigned int     pupd_dly_num_2:5;
+unsigned int     pupd_dly_num_1:5;
+unsigned int     pupd_dly_num_0:5;
+}DC_PHY_PUPD_DLY_NUM;
+
+typedef struct 
+{
+unsigned int     dqs3_det_0_dlyn:4;
+unsigned int     dqs2_det_0_dlyn:4;
+unsigned int     dqs1_det_0_dlyn:4;
+unsigned int     dqs0_det_0_dlyn:4;
+unsigned int     dqs3_en_0_dlyn:4;
+unsigned int     dqs2_en_0_dlyn:4;
+unsigned int     dqs1_en_0_dlyn:4;
+unsigned int     dqs0_en_0_dlyn:4;
+}DC_PHY_DQS_DLYN;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     pupd_mode:2;
+unsigned int     cal_order:1;
+unsigned int     cal_mode_split:1;
+unsigned int     cal_zq_only:1;
+unsigned int     cal_zq:1;
+unsigned int     cal_all_rang_noml:1;
+unsigned int     cal_all_rang_init:1;
+unsigned int     auto_cal_en_noml:1;
+unsigned int     auto_cal_en_init:1;
+unsigned int     dqs_val_sel:1;
+unsigned int     cal_mode:3;
+unsigned int     dq_sel:1;
+}DC_PHY_CAL_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     cal_ba:3;
+unsigned int     cal_col:10;
+unsigned int     cal_row:13;
+}DC_PHY_CAL_ADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     end_done_01_p:1;
+unsigned int     start_done_01_p:1;
+unsigned int     best_dly_01_p:6;
+unsigned int     end_pt_01_p:6;
+unsigned int     start_pt_01_p:6;
+}DC_PHY_RESULT_CAL_TAP_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     end_done_01_n:1;
+unsigned int     start_done_01_n:1;
+unsigned int     best_dly_01_n:6;
+unsigned int     end_pt_01_n:6;
+unsigned int     start_pt_01_n:6;
+}DC_PHY_RESULT_CAL_TAP_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     end_done_23_p:1;
+unsigned int     start_done_23_p:1;
+unsigned int     best_dly_23_p:6;
+unsigned int     end_pt_23_p:6;
+unsigned int     start_pt_23_p:6;
+}DC_PHY_RESULT_CAL_TAP_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     end_done_23_n:1;
+unsigned int     start_done_23_n:1;
+unsigned int     best_dly_23_n:6;
+unsigned int     end_pt_23_n:6;
+unsigned int     start_pt_23_n:6;
+}DC_PHY_RESULT_CAL_TAP_3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     wk_big_thr_23_n_odt:1;
+unsigned int     wk_big_thr_23_p_odt:1;
+unsigned int     wk_big_thr_01_n_odt:1;
+unsigned int     wk_big_thr_01_p_odt:1;
+unsigned int     wk_big_thr_23_n_dt:1;
+unsigned int     wk_big_thr_23_p_dt:1;
+unsigned int     wk_big_thr_01_n_dt:1;
+unsigned int     wk_big_thr_01_p_dt:1;
+}DC_PHY_RESULT_CAL_TAP_4;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     best_wk_01_n_odt:6;
+unsigned int     reserved_1:2;
+unsigned int     best_wk_01_p_odt:6;
+unsigned int     reserved_2:2;
+unsigned int     best_wk_01_n_dt:6;
+unsigned int     reserved_3:2;
+unsigned int     best_wk_01_p_dt:6;
+}DC_PHY_RESULT_CAL_TAP_5;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     best_wk_23_n_odt:6;
+unsigned int     reserved_1:2;
+unsigned int     best_wk_23_p_odt:6;
+unsigned int     reserved_2:2;
+unsigned int     best_wk_23_n_dt:6;
+unsigned int     reserved_3:2;
+unsigned int     best_wk_23_p_dt:6;
+}DC_PHY_RESULT_CAL_TAP_6;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     odt_diff_threshold:6;
+unsigned int     reserved_1:2;
+unsigned int     duty_diff_threshold:6;
+unsigned int     cal_proc_done:1;
+unsigned int     wk_threshold:6;
+unsigned int     sync_rst_wk_thr:1;
+}DC_PHY_SYNC_RST_WK;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     sync_rst_fifo_pt:1;
+}DC_PHY_SYNC_RST_FIFO_PT;
+
+typedef struct 
+{
+unsigned int     cal_out_data_1:16;
+unsigned int     cal_out_data_0:16;
+}DC_PHY_CAL_OUT_DATA_A;
+
+typedef struct 
+{
+unsigned int     cal_out_data_3:16;
+unsigned int     cal_out_data_2:16;
+}DC_PHY_CAL_OUT_DATA_B;
+
+typedef struct 
+{
+unsigned int     cal_gld_data_1:16;
+unsigned int     cal_gld_data_0:16;
+}DC_PHY_CAL_GLD_DATA_A;
+
+typedef struct 
+{
+unsigned int     cal_gld_data_3:16;
+unsigned int     cal_gld_data_2:16;
+}DC_PHY_CAL_GLD_DATA_B;
+
+typedef struct 
+{
+unsigned int     id_cal_cnt_p_end:4;
+unsigned int     id_cal_cnt_p_srt:4;
+unsigned int     id_cal_cnt_n_end:4;
+unsigned int     id_cal_cnt_n_srt:4;
+unsigned int     odt_cal_cnt_p_end:4;
+unsigned int     odt_cal_cnt_p_srt:4;
+unsigned int     odt_cal_cnt_n_end:4;
+unsigned int     odt_cal_cnt_n_srt:4;
+}DC_PHY_CAL_CNT_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     ddr_clk_1_mux_sel:1;
+unsigned int     ddr_clk_0_mux_sel:1;
+unsigned int     ddr_clk_1_2x_div2_ph_sel:1;
+unsigned int     ddr_clk_0_2x_div2_ph_sel:1;
+unsigned int     mck_dqs3_mux_sel:1;
+unsigned int     mck_dqs2_mux_sel:1;
+unsigned int     mck_dqs1_mux_sel:1;
+unsigned int     mck_dqs0_mux_sel:1;
+unsigned int     mck_dqs3_2x_div2_ph_sel:1;
+unsigned int     mck_dqs2_2x_div2_ph_sel:1;
+unsigned int     mck_dqs1_2x_div2_ph_sel:1;
+unsigned int     mck_dqs0_2x_div2_ph_sel:1;
+}DC_PHY_MUX2TO1_CTRL;
+
+typedef struct 
+{
+unsigned int     dummy_reg:32;
+}DC_PHY_DUMMY_REG;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     dt_set_0:16;
+}DC_PHY_DT_SET0;
+
+typedef struct 
+{
+unsigned int     dt_set_1:32;
+}DC_PHY_DT_SET1;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     update_dqs:1;
+unsigned int     update_dq:1;
+}DC_PHY_DT_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     odt_23_n:3;
+unsigned int     odt_23_p:3;
+unsigned int     odt_01_n:3;
+unsigned int     odt_01_p:3;
+unsigned int     indt_23_n:2;
+unsigned int     indt_23_p:2;
+unsigned int     indt_01_n:2;
+unsigned int     indt_01_p:2;
+}DC_PHY_CAL_DT_RESULT;
+
+typedef struct 
+{
+unsigned int     odt_ttcp_set_7_pre:4;
+unsigned int     odt_ttcp_set_6_pre:4;
+unsigned int     odt_ttcp_set_5_pre:4;
+unsigned int     odt_ttcp_set_4_pre:4;
+unsigned int     odt_ttcp_set_3_pre:4;
+unsigned int     odt_ttcp_set_2_pre:4;
+unsigned int     odt_ttcp_set_1_pre:4;
+unsigned int     odt_ttcp_set_0_pre:4;
+}DC_PHY_ODT_TTCP_SET_PRE;
+
+typedef struct 
+{
+unsigned int     odt_ttcn_set_7_pre:4;
+unsigned int     odt_ttcn_set_6_pre:4;
+unsigned int     odt_ttcn_set_5_pre:4;
+unsigned int     odt_ttcn_set_4_pre:4;
+unsigned int     odt_ttcn_set_3_pre:4;
+unsigned int     odt_ttcn_set_2_pre:4;
+unsigned int     odt_ttcn_set_1_pre:4;
+unsigned int     odt_ttcn_set_0_pre:4;
+}DC_PHY_ODT_TTCN_SET_PRE;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     odt_ttfp_set_7_pre:3;
+unsigned int     odt_ttfp_set_6_pre:3;
+unsigned int     odt_ttfp_set_5_pre:3;
+unsigned int     odt_ttfp_set_4_pre:3;
+unsigned int     odt_ttfp_set_3_pre:3;
+unsigned int     odt_ttfp_set_2_pre:3;
+unsigned int     odt_ttfp_set_1_pre:3;
+unsigned int     odt_ttfp_set_0_pre:3;
+}DC_PHY_ODT_TTFP_SET_PRE;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     odt_ttfn_set_7_pre:3;
+unsigned int     odt_ttfn_set_6_pre:3;
+unsigned int     odt_ttfn_set_5_pre:3;
+unsigned int     odt_ttfn_set_4_pre:3;
+unsigned int     odt_ttfn_set_3_pre:3;
+unsigned int     odt_ttfn_set_2_pre:3;
+unsigned int     odt_ttfn_set_1_pre:3;
+unsigned int     odt_ttfn_set_0_pre:3;
+}DC_PHY_ODT_TTFN_SET_PRE;
+
+typedef struct 
+{
+unsigned int     ocdp_set_7_pre:4;
+unsigned int     ocdp_set_6_pre:4;
+unsigned int     ocdp_set_5_pre:4;
+unsigned int     ocdp_set_4_pre:4;
+unsigned int     ocdp_set_3_pre:4;
+unsigned int     ocdp_set_2_pre:4;
+unsigned int     ocdp_set_1_pre:4;
+unsigned int     ocdp_set_0_pre:4;
+}DC_PHY_OCDP_SET_PRE;
+
+typedef struct 
+{
+unsigned int     ocdn_set_7_pre:4;
+unsigned int     ocdn_set_6_pre:4;
+unsigned int     ocdn_set_5_pre:4;
+unsigned int     ocdn_set_4_pre:4;
+unsigned int     ocdn_set_3_pre:4;
+unsigned int     ocdn_set_2_pre:4;
+unsigned int     ocdn_set_1_pre:4;
+unsigned int     ocdn_set_0_pre:4;
+}DC_PHY_OCDN_SET_PRE;
+
+typedef struct 
+{
+unsigned int     odt_ttcp_set_7:4;
+unsigned int     odt_ttcp_set_6:4;
+unsigned int     odt_ttcp_set_5:4;
+unsigned int     odt_ttcp_set_4:4;
+unsigned int     odt_ttcp_set_3:4;
+unsigned int     odt_ttcp_set_2:4;
+unsigned int     odt_ttcp_set_1:4;
+unsigned int     odt_ttcp_set_0:4;
+}DC_PHY_ODT_TTCP_SET;
+
+typedef struct 
+{
+unsigned int     odt_ttcn_set_7:4;
+unsigned int     odt_ttcn_set_6:4;
+unsigned int     odt_ttcn_set_5:4;
+unsigned int     odt_ttcn_set_4:4;
+unsigned int     odt_ttcn_set_3:4;
+unsigned int     odt_ttcn_set_2:4;
+unsigned int     odt_ttcn_set_1:4;
+unsigned int     odt_ttcn_set_0:4;
+}DC_PHY_ODT_TTCN_SET;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     odt_ttfp_set_7:3;
+unsigned int     odt_ttfp_set_6:3;
+unsigned int     odt_ttfp_set_5:3;
+unsigned int     odt_ttfp_set_4:3;
+unsigned int     odt_ttfp_set_3:3;
+unsigned int     odt_ttfp_set_2:3;
+unsigned int     odt_ttfp_set_1:3;
+unsigned int     odt_ttfp_set_0:3;
+}DC_PHY_ODT_TTFP_SET;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     odt_ttfn_set_7:3;
+unsigned int     odt_ttfn_set_6:3;
+unsigned int     odt_ttfn_set_5:3;
+unsigned int     odt_ttfn_set_4:3;
+unsigned int     odt_ttfn_set_3:3;
+unsigned int     odt_ttfn_set_2:3;
+unsigned int     odt_ttfn_set_1:3;
+unsigned int     odt_ttfn_set_0:3;
+}DC_PHY_ODT_TTFN_SET;
+
+typedef struct 
+{
+unsigned int     ocdp_set_7:4;
+unsigned int     ocdp_set_6:4;
+unsigned int     ocdp_set_5:4;
+unsigned int     ocdp_set_4:4;
+unsigned int     ocdp_set_3:4;
+unsigned int     ocdp_set_2:4;
+unsigned int     ocdp_set_1:4;
+unsigned int     ocdp_set_0:4;
+}DC_PHY_OCDP_SET;
+
+typedef struct 
+{
+unsigned int     ocdn_set_7:4;
+unsigned int     ocdn_set_6:4;
+unsigned int     ocdn_set_5:4;
+unsigned int     ocdn_set_4:4;
+unsigned int     ocdn_set_3:4;
+unsigned int     ocdn_set_2:4;
+unsigned int     ocdn_set_1:4;
+unsigned int     ocdn_set_0:4;
+}DC_PHY_OCDN_SET;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dq_3_ttcn_sel:3;
+unsigned int     dq_2_ttcn_sel:3;
+unsigned int     dq_1_ttcn_sel:3;
+unsigned int     dq_0_ttcn_sel:3;
+unsigned int     dq_3_ttcp_sel:3;
+unsigned int     dq_2_ttcp_sel:3;
+unsigned int     dq_1_ttcp_sel:3;
+unsigned int     dq_0_ttcp_sel:3;
+}DC_PHY_DQ_TTC_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dq_3_ttfn_sel:3;
+unsigned int     dq_2_ttfn_sel:3;
+unsigned int     dq_1_ttfn_sel:3;
+unsigned int     dq_0_ttfn_sel:3;
+unsigned int     dq_3_ttfp_sel:3;
+unsigned int     dq_2_ttfp_sel:3;
+unsigned int     dq_1_ttfp_sel:3;
+unsigned int     dq_0_ttfp_sel:3;
+}DC_PHY_DQ_TTF_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dq_3_ocdn_sel:3;
+unsigned int     dq_2_ocdn_sel:3;
+unsigned int     dq_1_ocdn_sel:3;
+unsigned int     dq_0_ocdn_sel:3;
+unsigned int     dq_3_ocdp_sel:3;
+unsigned int     dq_2_ocdp_sel:3;
+unsigned int     dq_1_ocdp_sel:3;
+unsigned int     dq_0_ocdp_sel:3;
+}DC_PHY_DQ_OCD_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dqs_p_3_ttcn_sel:3;
+unsigned int     dqs_p_2_ttcn_sel:3;
+unsigned int     dqs_p_1_ttcn_sel:3;
+unsigned int     dqs_p_0_ttcn_sel:3;
+unsigned int     dqs_p_3_ttcp_sel:3;
+unsigned int     dqs_p_2_ttcp_sel:3;
+unsigned int     dqs_p_1_ttcp_sel:3;
+unsigned int     dqs_p_0_ttcp_sel:3;
+}DC_PHY_DQS_P_TTC_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dqs_n_3_ttcn_sel:3;
+unsigned int     dqs_n_2_ttcn_sel:3;
+unsigned int     dqs_n_1_ttcn_sel:3;
+unsigned int     dqs_n_0_ttcn_sel:3;
+unsigned int     dqs_n_3_ttcp_sel:3;
+unsigned int     dqs_n_2_ttcp_sel:3;
+unsigned int     dqs_n_1_ttcp_sel:3;
+unsigned int     dqs_n_0_ttcp_sel:3;
+}DC_PHY_DQS_N_TTC_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dqs_p_3_ttfn_sel:3;
+unsigned int     dqs_p_2_ttfn_sel:3;
+unsigned int     dqs_p_1_ttfn_sel:3;
+unsigned int     dqs_p_0_ttfn_sel:3;
+unsigned int     dqs_p_3_ttfp_sel:3;
+unsigned int     dqs_p_2_ttfp_sel:3;
+unsigned int     dqs_p_1_ttfp_sel:3;
+unsigned int     dqs_p_0_ttfp_sel:3;
+}DC_PHY_DQS_P_TTF_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dqs_n_3_ttfn_sel:3;
+unsigned int     dqs_n_2_ttfn_sel:3;
+unsigned int     dqs_n_1_ttfn_sel:3;
+unsigned int     dqs_n_0_ttfn_sel:3;
+unsigned int     dqs_n_3_ttfp_sel:3;
+unsigned int     dqs_n_2_ttfp_sel:3;
+unsigned int     dqs_n_1_ttfp_sel:3;
+unsigned int     dqs_n_0_ttfp_sel:3;
+}DC_PHY_DQS_N_TTF_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dqs_p_3_ocdn_sel:3;
+unsigned int     dqs_p_2_ocdn_sel:3;
+unsigned int     dqs_p_1_ocdn_sel:3;
+unsigned int     dqs_p_0_ocdn_sel:3;
+unsigned int     dqs_p_3_ocdp_sel:3;
+unsigned int     dqs_p_2_ocdp_sel:3;
+unsigned int     dqs_p_1_ocdp_sel:3;
+unsigned int     dqs_p_0_ocdp_sel:3;
+}DC_PHY_DQS_P_OCD_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dqs_n_3_ocdn_sel:3;
+unsigned int     dqs_n_2_ocdn_sel:3;
+unsigned int     dqs_n_1_ocdn_sel:3;
+unsigned int     dqs_n_0_ocdn_sel:3;
+unsigned int     dqs_n_3_ocdp_sel:3;
+unsigned int     dqs_n_2_ocdp_sel:3;
+unsigned int     dqs_n_1_ocdp_sel:3;
+unsigned int     dqs_n_0_ocdp_sel:3;
+}DC_PHY_DQS_N_OCD_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     adr_1_ocdn_sel:3;
+unsigned int     adr_0_ocdn_sel:3;
+unsigned int     cmd_1_ocdn_sel:3;
+unsigned int     cmd_0_ocdn_sel:3;
+unsigned int     adr_1_ocdp_sel:3;
+unsigned int     adr_0_ocdp_sel:3;
+unsigned int     cmd_1_ocdp_sel:3;
+unsigned int     cmd_0_ocdp_sel:3;
+}DC_PHY_ADR_OCD_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ck_n_1_ocdn_sel:3;
+unsigned int     ck_n_0_ocdn_sel:3;
+unsigned int     ck_n_1_ocdp_sel:3;
+unsigned int     ck_n_0_ocdp_sel:3;
+unsigned int     ck_p_1_ocdn_sel:3;
+unsigned int     ck_p_0_ocdn_sel:3;
+unsigned int     ck_p_1_ocdp_sel:3;
+unsigned int     ck_p_0_ocdp_sel:3;
+}DC_PHY_CK_OCD_SEL;
+
+typedef struct 
+{
+unsigned int     pad_bus_0:32;
+}DC_PHY_PAD_BUS_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     pad_bus_1:4;
+}DC_PHY_PAD_BUS_1;
+
+typedef struct 
+{
+unsigned int     dll_en_test:1;
+unsigned int     dll_sc:3;
+unsigned int     dll_sel_ipump:4;
+unsigned int     dll_pfd_div:6;
+unsigned int     dll_pre_divn:2;
+unsigned int     dll_en_newpump:1;
+unsigned int     dll_bin_dl2_ph_sel:5;
+unsigned int     dll_bin_dl1_ph_sel:5;
+unsigned int     dll_bin_dl0_ph_sel:5;
+}DC_PHY_ANA_DLL_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     dll_en_3:1;
+unsigned int     dll_en_2:1;
+unsigned int     dll_en_1:1;
+unsigned int     dll_en_0:1;
+unsigned int     dll_dl_ph_sel:1;
+unsigned int     dll_rdy_3:1;
+unsigned int     dll_rdy_2:1;
+unsigned int     dll_rdy_1:1;
+unsigned int     dll_rdy_0:1;
+unsigned int     dll_div_sel:2;
+unsigned int     dll_ck_sel:1;
+unsigned int     ana_dly_sel:1;
+}DC_PHY_ANA_DLL_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     write_en_2:1;
+unsigned int     lpddr_ck_en:1;
+unsigned int     write_en_1:1;
+unsigned int     mod_reg_read:1;
+unsigned int     write_en_0:1;
+unsigned int     mod_reg_write:1;
+}DC_PHY_LPDDR_CTRL;
+
+typedef struct 
+{
+unsigned int     mode_reg_rdata:8;
+unsigned int     reserved_0:24;
+}DC_PHY_LPDDR_RDAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     mode_reg_wdata:8;
+unsigned int     mode_reg_addr:8;
+unsigned int     reserved_1:1;
+unsigned int     lpddr:1;
+unsigned int     reserved_2:6;
+}DC_PHY_LPDDR_MODE;
+
+typedef struct 
+{
+unsigned int     ref_update_dly:6;
+unsigned int     reserved_0:22;
+unsigned int     zcomp_ctrl:4;
+}DC_PHY_ZQCMP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     zq_done:1;
+unsigned int     rzq_done:1;
+unsigned int     rzq_480code:5;
+unsigned int     rzq_cal_done:1;
+}DC_PHY_RZCTRL_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     bist_en_0:1;
+unsigned int     drf_bist_en_0:1;
+unsigned int     drf_test_resume_0:1;
+unsigned int     reserved_1:1;
+unsigned int     RMEA:1;
+unsigned int     RMA_3:1;
+unsigned int     RMA_2:1;
+unsigned int     RMA_1:1;
+unsigned int     RMA_0:1;
+unsigned int     reserved_2:3;
+unsigned int     RMEB:1;
+unsigned int     RMB_3:1;
+unsigned int     RMB_2:1;
+unsigned int     RMB_1:1;
+unsigned int     RMB_0:1;
+}DC_PHY_PHY_BIST_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     mbist_st:1;
+unsigned int     bist_fail:1;
+unsigned int     bist_done:1;
+}DC_PHY_PHY_BIST0_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_fail:1;
+unsigned int     drf_done:1;
+}DC_PHY_PHY_DRF0_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     mbist_st:1;
+unsigned int     bist_fail:1;
+unsigned int     bist_done:1;
+}DC_PHY_PHY_BIST1_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_fail:1;
+unsigned int     drf_done:1;
+}DC_PHY_PHY_DRF1_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     wl_dqs3_oe_mux_sel:2;
+unsigned int     wl_dqs2_oe_mux_sel:2;
+unsigned int     wl_dqs1_oe_mux_sel:2;
+unsigned int     wl_dqs0_oe_mux_sel:2;
+unsigned int     wl_dqs3_mux_sel:2;
+unsigned int     wl_dqs2_mux_sel:2;
+unsigned int     wl_dqs1_mux_sel:2;
+unsigned int     wl_dqs0_mux_sel:2;
+}DC_PHY_WL_CTRL_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     wl_dq31to24_oe_mux_sel:2;
+unsigned int     wl_dq23to16_oe_mux_sel:2;
+unsigned int     wl_dq15to8_oe_mux_sel:2;
+unsigned int     wl_dq7to0_oe_mux_sel:2;
+unsigned int     wl_dq31to24_mux_sel:2;
+unsigned int     wl_dq23to16_mux_sel:2;
+unsigned int     wl_dq15to8_mux_sel:2;
+unsigned int     wl_dq7to0_mux_sel:2;
+}DC_PHY_WL_CTRL_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     fifo_arb_sel:1;
+unsigned int     reserved_1:1;
+unsigned int     cmdq_ch_fifo_cnt:3;
+unsigned int     reserved_2:2;
+unsigned int     cmdq_ch_fifo_rd_ptr:2;
+unsigned int     reserved_3:2;
+unsigned int     cmdq_ch_fifo_wr_ptr:2;
+unsigned int     cmdq_ch_fifo_overflow:1;
+unsigned int     cmdq_ch_fifo_underflow:1;
+unsigned int     cmdq_ch_fifo_full:1;
+unsigned int     cmdq_ch_fifo_empty:1;
+unsigned int     cmdq_ch_fifo_thr:4;
+unsigned int     cmdq_ch_fifo_overflow_clr:1;
+unsigned int     cmdq_ch_fifo_underflow_clr:1;
+unsigned int     cmdq_ch_clk_gated_en:1;
+unsigned int     fifo_arb_dis:1;
+}DC_PHY_FIFO_ARB_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     cmdq_ch_gnt_mst1_cmd_dis:1;
+unsigned int     cmdq_ch_gnt_mst1_cti_dis:1;
+unsigned int     reserved_1:2;
+unsigned int     cmdq_ch_gnt_mst0_cmd_dis:1;
+unsigned int     cmdq_ch_gnt_mst0_cti_dis:1;
+}DC_PHY_FIFO_ARB_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cmdq_ch_dbg_mod:8;
+}DC_PHY_FIFO_ARB_2;
+
+typedef struct 
+{
+unsigned int     cmdq_ch_dummy_0:32;
+}DC_PHY_FIFO_ARB_3;
+
+typedef struct 
+{
+unsigned int     cmdq_ch_gnt_st0:32;
+}DC_PHY_FIFO_ARB_4;
+
+typedef struct 
+{
+unsigned int     cmdq_ch_gnt_st1:32;
+}DC_PHY_FIFO_ARB_5;
+
+typedef struct 
+{
+unsigned int     cmdq_ch_gnt_st2:32;
+}DC_PHY_FIFO_ARB_6;
+
+typedef struct 
+{
+unsigned int     cmdq_ch_gnt_st3:32;
+}DC_PHY_FIFO_ARB_7;
+
+typedef struct 
+{
+unsigned int     cmdq_ch_gnt_st4:32;
+}DC_PHY_FIFO_ARB_8;
+
+typedef struct 
+{
+unsigned int     cmdq_ch_gnt_st5:32;
+}DC_PHY_FIFO_ARB_9;
+
+typedef struct 
+{
+unsigned int     cmdq_ch_gnt_st6:32;
+}DC_PHY_FIFO_ARB_10;
+
+typedef struct 
+{
+unsigned int     cmdq_ch_gnt_st7:32;
+}DC_PHY_FIFO_ARB_11;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     wq_ch_fifo_rd_ptr:5;
+unsigned int     reserved_1:3;
+unsigned int     wq_ch_fifo_wr_ptr:5;
+unsigned int     wq_ch_fifo_overflow:1;
+unsigned int     wq_ch_fifo_underflow:1;
+unsigned int     wq_ch_fifo_full:1;
+unsigned int     wq_ch_fifo_empty:1;
+unsigned int     reserved_2:2;
+unsigned int     wq_ch_fifo_thr:6;
+unsigned int     wq_ch_fifo_overflow_clr:1;
+unsigned int     wq_ch_fifo_underflow_clr:1;
+unsigned int     wq_ch_clk_gated_en:1;
+unsigned int     reserved_3:1;
+}DC_PHY_FIFO_ARB_12;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     wq_ch_dbg_mod:8;
+unsigned int     reserved_1:2;
+unsigned int     wq_ch_fifo_cnt:6;
+}DC_PHY_FIFO_ARB_13;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     wq_ch_fifo_par_rd_ptr:5;
+unsigned int     reserved_1:3;
+unsigned int     wq_ch_fifo_par_wr_ptr:5;
+unsigned int     wq_ch_fifo_par_overflow:1;
+unsigned int     wq_ch_fifo_par_underflow:1;
+unsigned int     wq_ch_fifo_par_full:1;
+unsigned int     wq_ch_fifo_par_empty:1;
+unsigned int     reserved_2:2;
+unsigned int     wq_ch_fifo_par_thr:6;
+unsigned int     wq_ch_fifo_par_overflow_clr:1;
+unsigned int     wq_ch_fifo_par_underflow_clr:1;
+unsigned int     reserved_3:2;
+}DC_PHY_FIFO_ARB_14;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     wq_ch_fifo_par_cnt:6;
+}DC_PHY_FIFO_ARB_15;
+
+typedef struct 
+{
+unsigned int     wq_ch_dummy_0:32;
+}DC_PHY_FIFO_ARB_16;
+
+typedef struct 
+{
+unsigned int     wq_ch_st0:32;
+}DC_PHY_FIFO_ARB_17;
+
+typedef struct 
+{
+unsigned int     wq_ch_st1:32;
+}DC_PHY_FIFO_ARB_18;
+
+typedef struct 
+{
+unsigned int     wq_ch_st2:32;
+}DC_PHY_FIFO_ARB_19;
+
+typedef struct 
+{
+unsigned int     wq_ch_st3:32;
+}DC_PHY_FIFO_ARB_20;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     rq_ch_fifo_rd_ptr:4;
+unsigned int     reserved_1:4;
+unsigned int     rq_ch_fifo_wr_ptr:4;
+unsigned int     rq_ch_fifo_overflow:1;
+unsigned int     rq_ch_fifo_underflow:1;
+unsigned int     rq_ch_fifo_full:1;
+unsigned int     rq_ch_fifo_empty:1;
+unsigned int     reserved_2:3;
+unsigned int     rq_ch_fifo_thr:5;
+unsigned int     rq_ch_fifo_overflow_clr:1;
+unsigned int     rq_ch_fifo_underflow_clr:1;
+unsigned int     rq_ch_clk_gated_en:1;
+unsigned int     reserved_3:1;
+}DC_PHY_FIFO_ARB_21;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     rq_ch_fifo_cnt:5;
+}DC_PHY_FIFO_ARB_22;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     wcol_adr_q_thr:5;
+unsigned int     rq_ch_dbg_mod:8;
+}DC_PHY_FIFO_ARB_23;
+
+typedef struct 
+{
+unsigned int     rq_ch_dummy_0:32;
+}DC_PHY_FIFO_ARB_24;
+
+typedef struct 
+{
+unsigned int     rq_ch_st0:32;
+}DC_PHY_FIFO_ARB_25;
+
+typedef struct 
+{
+unsigned int     rq_ch_st1:32;
+}DC_PHY_FIFO_ARB_26;
+
+typedef struct 
+{
+unsigned int     rq_ch_st2:32;
+}DC_PHY_FIFO_ARB_27;
+
+typedef struct 
+{
+unsigned int     rq_ch_st3:32;
+}DC_PHY_FIFO_ARB_28;
+
+typedef struct 
+{
+unsigned int     dummy_0:32;
+}DC_PHY_DUMMY_0;
+
+typedef struct 
+{
+unsigned int     dummy_1:32;
+}DC_PHY_DUMMY_1;
+
+typedef struct 
+{
+unsigned int     dummy_2:32;
+}DC_PHY_DUMMY_2;
+
+typedef struct 
+{
+unsigned int     dummy_3:32;
+}DC_PHY_DUMMY_3;
+
+typedef struct 
+{
+unsigned int     dummy_4:32;
+}DC_PHY_DUMMY_4;
+
+typedef struct 
+{
+unsigned int     dummy_5:32;
+}DC_PHY_DUMMY_5;
+
+typedef struct 
+{
+unsigned int     dummy_6:32;
+}DC_PHY_DUMMY_6;
+
+typedef struct 
+{
+unsigned int     dummy_7:32;
+}DC_PHY_DUMMY_7;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     sc_en:1;
+}DC_PHY_SC_CTRL;
+
+typedef struct 
+{
+unsigned int     sc_key_1:16;
+unsigned int     sc_key_0:16;
+}DC_PHY_SC_KEY01;
+
+typedef struct 
+{
+unsigned int     sc_key_3:16;
+unsigned int     sc_key_2:16;
+}DC_PHY_SC_KEY23;
+
+typedef struct 
+{
+unsigned int     sc_key_5:16;
+unsigned int     sc_key_4:16;
+}DC_PHY_SC_KEY45;
+
+typedef struct 
+{
+unsigned int     sc_key_7:16;
+unsigned int     sc_key_6:16;
+}DC_PHY_SC_KEY67;
+
+typedef struct 
+{
+unsigned int     sc_key_9:16;
+unsigned int     sc_key_8:16;
+}DC_PHY_SC_KEY89;
+
+typedef struct 
+{
+unsigned int     sc_key_b:16;
+unsigned int     sc_key_a:16;
+}DC_PHY_SC_KEYAB;
+
+typedef struct 
+{
+unsigned int     sc_key_d:16;
+unsigned int     sc_key_c:16;
+}DC_PHY_SC_KEYCD;
+
+typedef struct 
+{
+unsigned int     sc_key_f:16;
+unsigned int     sc_key_e:16;
+}DC_PHY_SC_KEYEF;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     issue_cmd_dly_1T:1;
+}DC_PHY_CMD_DLY_1T;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     write_merge_en:1;
+unsigned int     read_bypass_en:1;
+}DC_PHY_EXP_LANE_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     bank2_dlyn:3;
+unsigned int     bank1_dlyn:3;
+unsigned int     bank0_dlyn:3;
+unsigned int     odt_dlyn:3;
+unsigned int     cke_dlyn:3;
+unsigned int     we_n_dlyn:3;
+unsigned int     cas_n_dlyn:3;
+unsigned int     ras_n_dlyn:3;
+unsigned int     cs_n_dlyn:3;
+}DC_PHY_CMD_DLYN_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     adr09_dlyn:3;
+unsigned int     adr08_dlyn:3;
+unsigned int     adr07_dlyn:3;
+unsigned int     adr06_dlyn:3;
+unsigned int     adr05_dlyn:3;
+unsigned int     adr04_dlyn:3;
+unsigned int     adr03_dlyn:3;
+unsigned int     adr02_dlyn:3;
+unsigned int     adr01_dlyn:3;
+unsigned int     adr00_dlyn:3;
+}DC_PHY_ADR_DLYN_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     adr5_ext_dlyn:3;
+unsigned int     adr4_ext_dlyn:3;
+unsigned int     adr15_dlyn:3;
+unsigned int     adr14_dlyn:3;
+unsigned int     adr13_dlyn:3;
+unsigned int     adr12_dlyn:3;
+unsigned int     adr11_dlyn:3;
+unsigned int     adr10_dlyn:3;
+}DC_PHY_ADR_DLYN_1;
+
+typedef struct 
+{
+unsigned int     tota_mon_num:32;
+}DC_PHY_SCPU_PC_TOTA_MON_NUM;
+
+typedef struct 
+{
+unsigned int     tota_ack_num:32;
+}DC_PHY_SCPU_PC_TOTA_ACK_NUM;
+
+typedef struct 
+{
+unsigned int     tota_idl_num:32;
+}DC_PHY_SCPU_PC_TOTA_IDL_NUM;
+
+typedef struct 
+{
+unsigned int     acc_lat:32;
+}DC_PHY_SCPU_PC_ACC_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     max_lat:16;
+}DC_PHY_SCPU_PC_MAX_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     req_num:24;
+}DC_PHY_SCPU_PC_REQ_NUM;
+
+typedef struct 
+{
+unsigned int     ack_num:32;
+}DC_PHY_SCPU_PC_ACK_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     pc_go:1;
+}DC_PHY_SCPU_PC_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     gck_ext_cyc:6;
+unsigned int     reserved_1:5;
+unsigned int     par_gck_en:1;
+unsigned int     fsm_gck_en:1;
+unsigned int     ioblk_gck_en:1;
+}DC_PHY_GCK_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0;
+
+typedef struct 
+{
+unsigned int     timer_threshold:32;
+}DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     count_threshold:24;
+}DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     merge_num:24;
+}DC_PHY_SCPU_PC_MERGE_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     wr_req_num:24;
+}DC_PHY_SCPU_PC_WR_REQ_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     data_in:20;
+unsigned int     reserved_1:2;
+unsigned int     data_in_ready:1;
+unsigned int     wire_sel:1;
+unsigned int     ro_sel:3;
+unsigned int     dss_rst_n:1;
+}DC_PHY_SPEED_SENSOR_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     count_out:20;
+unsigned int     reserved_1:2;
+unsigned int     wsort_go:1;
+unsigned int     ready:1;
+}DC_PHY_SPEED_SENSOR_STATUS;
+
+typedef struct 
+{
+unsigned int     ctrl_misc:32;
+}DC_PHY_EXPRESS_LANE_CTRL_MISC;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     data_in:20;
+unsigned int     reserved_1:2;
+unsigned int     speed_en:1;
+unsigned int     wire_sel:1;
+unsigned int     ro_sel:3;
+unsigned int     dss_rst_n:1;
+}DC_PHY_DSS_C35_MISC;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     count_out:20;
+unsigned int     reserved_1:2;
+unsigned int     wsort_go:1;
+unsigned int     ready:1;
+}DC_PHY_DSS_C35_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     data_in:20;
+unsigned int     reserved_1:2;
+unsigned int     speed_en:1;
+unsigned int     wire_sel:1;
+unsigned int     ro_sel:3;
+unsigned int     dss_rst_n:1;
+}DC_PHY_DSS_C35D5_MISC;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     count_out:20;
+unsigned int     reserved_1:2;
+unsigned int     wsort_go:1;
+unsigned int     ready:1;
+}DC_PHY_DSS_C35D5_ST;
+
+typedef struct 
+{
+unsigned int     dbgo_c35d5:16;
+unsigned int     dbgo_c35:16;
+}DC_PHY_DSS_DBG;
+
+#endif
+
+#define DC_PHY_TMCTRL0                                                               0x18008800
+#define DC_PHY_TMCTRL0_reg_addr                                                      "0xB8008800"
+#define DC_PHY_TMCTRL0_reg                                                           0xB8008800
+#define set_DC_PHY_TMCTRL0_reg(data)   (*((volatile unsigned int*) DC_PHY_TMCTRL0_reg)=data)
+#define get_DC_PHY_TMCTRL0_reg   (*((volatile unsigned int*) DC_PHY_TMCTRL0_reg))
+#define DC_PHY_TMCTRL0_inst_adr                                                      "0x0000"
+#define DC_PHY_TMCTRL0_inst                                                          0x0000
+#define DC_PHY_TMCTRL0_tmras_shift                                                   (16)
+#define DC_PHY_TMCTRL0_tmras_mask                                                    (0x01FF0000)
+#define DC_PHY_TMCTRL0_tmras(data)                                                   (0x01FF0000&((data)<<16))
+#define DC_PHY_TMCTRL0_tmras_src(data)                                               ((0x01FF0000&(data))>>16)
+#define DC_PHY_TMCTRL0_get_tmras(data)                                               ((0x01FF0000&(data))>>16)
+#define DC_PHY_TMCTRL0_tmrcl_shift                                                   (12)
+#define DC_PHY_TMCTRL0_tmrcl_mask                                                    (0x0000F000)
+#define DC_PHY_TMCTRL0_tmrcl(data)                                                   (0x0000F000&((data)<<12))
+#define DC_PHY_TMCTRL0_tmrcl_src(data)                                               ((0x0000F000&(data))>>12)
+#define DC_PHY_TMCTRL0_get_tmrcl(data)                                               ((0x0000F000&(data))>>12)
+#define DC_PHY_TMCTRL0_tmcl_shift                                                    (8)
+#define DC_PHY_TMCTRL0_tmcl_mask                                                     (0x00000F00)
+#define DC_PHY_TMCTRL0_tmcl(data)                                                    (0x00000F00&((data)<<8))
+#define DC_PHY_TMCTRL0_tmcl_src(data)                                                ((0x00000F00&(data))>>8)
+#define DC_PHY_TMCTRL0_get_tmcl(data)                                                ((0x00000F00&(data))>>8)
+#define DC_PHY_TMCTRL0_tmcl_rd_shift                                                 (0)
+#define DC_PHY_TMCTRL0_tmcl_rd_mask                                                  (0x0000007F)
+#define DC_PHY_TMCTRL0_tmcl_rd(data)                                                 (0x0000007F&((data)<<0))
+#define DC_PHY_TMCTRL0_tmcl_rd_src(data)                                             ((0x0000007F&(data))>>0)
+#define DC_PHY_TMCTRL0_get_tmcl_rd(data)                                             ((0x0000007F&(data))>>0)
+
+
+#define DC_PHY_TMCTRL1                                                               0x18008804
+#define DC_PHY_TMCTRL1_reg_addr                                                      "0xB8008804"
+#define DC_PHY_TMCTRL1_reg                                                           0xB8008804
+#define set_DC_PHY_TMCTRL1_reg(data)   (*((volatile unsigned int*) DC_PHY_TMCTRL1_reg)=data)
+#define get_DC_PHY_TMCTRL1_reg   (*((volatile unsigned int*) DC_PHY_TMCTRL1_reg))
+#define DC_PHY_TMCTRL1_inst_adr                                                      "0x0001"
+#define DC_PHY_TMCTRL1_inst                                                          0x0001
+#define DC_PHY_TMCTRL1_tmrrd_shift                                                   (24)
+#define DC_PHY_TMCTRL1_tmrrd_mask                                                    (0x1F000000)
+#define DC_PHY_TMCTRL1_tmrrd(data)                                                   (0x1F000000&((data)<<24))
+#define DC_PHY_TMCTRL1_tmrrd_src(data)                                               ((0x1F000000&(data))>>24)
+#define DC_PHY_TMCTRL1_get_tmrrd(data)                                               ((0x1F000000&(data))>>24)
+#define DC_PHY_TMCTRL1_tmrp_shift                                                    (16)
+#define DC_PHY_TMCTRL1_tmrp_mask                                                     (0x003F0000)
+#define DC_PHY_TMCTRL1_tmrp(data)                                                    (0x003F0000&((data)<<16))
+#define DC_PHY_TMCTRL1_tmrp_src(data)                                                ((0x003F0000&(data))>>16)
+#define DC_PHY_TMCTRL1_get_tmrp(data)                                                ((0x003F0000&(data))>>16)
+#define DC_PHY_TMCTRL1_tmrcd_shift                                                   (8)
+#define DC_PHY_TMCTRL1_tmrcd_mask                                                    (0x00003F00)
+#define DC_PHY_TMCTRL1_tmrcd(data)                                                   (0x00003F00&((data)<<8))
+#define DC_PHY_TMCTRL1_tmrcd_src(data)                                               ((0x00003F00&(data))>>8)
+#define DC_PHY_TMCTRL1_get_tmrcd(data)                                               ((0x00003F00&(data))>>8)
+#define DC_PHY_TMCTRL1_tmrc_shift                                                    (0)
+#define DC_PHY_TMCTRL1_tmrc_mask                                                     (0x000000FF)
+#define DC_PHY_TMCTRL1_tmrc(data)                                                    (0x000000FF&((data)<<0))
+#define DC_PHY_TMCTRL1_tmrc_src(data)                                                ((0x000000FF&(data))>>0)
+#define DC_PHY_TMCTRL1_get_tmrc(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define DC_PHY_TMCTRL2                                                               0x18008808
+#define DC_PHY_TMCTRL2_reg_addr                                                      "0xB8008808"
+#define DC_PHY_TMCTRL2_reg                                                           0xB8008808
+#define set_DC_PHY_TMCTRL2_reg(data)   (*((volatile unsigned int*) DC_PHY_TMCTRL2_reg)=data)
+#define get_DC_PHY_TMCTRL2_reg   (*((volatile unsigned int*) DC_PHY_TMCTRL2_reg))
+#define DC_PHY_TMCTRL2_inst_adr                                                      "0x0002"
+#define DC_PHY_TMCTRL2_inst                                                          0x0002
+#define DC_PHY_TMCTRL2_tmrtw_shift                                                   (30)
+#define DC_PHY_TMCTRL2_tmrtw_mask                                                    (0xC0000000)
+#define DC_PHY_TMCTRL2_tmrtw(data)                                                   (0xC0000000&((data)<<30))
+#define DC_PHY_TMCTRL2_tmrtw_src(data)                                               ((0xC0000000&(data))>>30)
+#define DC_PHY_TMCTRL2_get_tmrtw(data)                                               ((0xC0000000&(data))>>30)
+#define DC_PHY_TMCTRL2_tmccd_shift                                                   (24)
+#define DC_PHY_TMCTRL2_tmccd_mask                                                    (0x1F000000)
+#define DC_PHY_TMCTRL2_tmccd(data)                                                   (0x1F000000&((data)<<24))
+#define DC_PHY_TMCTRL2_tmccd_src(data)                                               ((0x1F000000&(data))>>24)
+#define DC_PHY_TMCTRL2_get_tmccd(data)                                               ((0x1F000000&(data))>>24)
+#define DC_PHY_TMCTRL2_trtp_shift                                                    (16)
+#define DC_PHY_TMCTRL2_trtp_mask                                                     (0x007F0000)
+#define DC_PHY_TMCTRL2_trtp(data)                                                    (0x007F0000&((data)<<16))
+#define DC_PHY_TMCTRL2_trtp_src(data)                                                ((0x007F0000&(data))>>16)
+#define DC_PHY_TMCTRL2_get_trtp(data)                                                ((0x007F0000&(data))>>16)
+#define DC_PHY_TMCTRL2_tmwtr_shift                                                   (8)
+#define DC_PHY_TMCTRL2_tmwtr_mask                                                    (0x00001F00)
+#define DC_PHY_TMCTRL2_tmwtr(data)                                                   (0x00001F00&((data)<<8))
+#define DC_PHY_TMCTRL2_tmwtr_src(data)                                               ((0x00001F00&(data))>>8)
+#define DC_PHY_TMCTRL2_get_tmwtr(data)                                               ((0x00001F00&(data))>>8)
+#define DC_PHY_TMCTRL2_tmwr_shift                                                    (0)
+#define DC_PHY_TMCTRL2_tmwr_mask                                                     (0x0000003F)
+#define DC_PHY_TMCTRL2_tmwr(data)                                                    (0x0000003F&((data)<<0))
+#define DC_PHY_TMCTRL2_tmwr_src(data)                                                ((0x0000003F&(data))>>0)
+#define DC_PHY_TMCTRL2_get_tmwr(data)                                                ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_TMCTRL3                                                               0x1800880c
+#define DC_PHY_TMCTRL3_reg_addr                                                      "0xB800880C"
+#define DC_PHY_TMCTRL3_reg                                                           0xB800880C
+#define set_DC_PHY_TMCTRL3_reg(data)   (*((volatile unsigned int*) DC_PHY_TMCTRL3_reg)=data)
+#define get_DC_PHY_TMCTRL3_reg   (*((volatile unsigned int*) DC_PHY_TMCTRL3_reg))
+#define DC_PHY_TMCTRL3_inst_adr                                                      "0x0003"
+#define DC_PHY_TMCTRL3_inst                                                          0x0003
+#define DC_PHY_TMCTRL3_tmFAW_shift                                                   (24)
+#define DC_PHY_TMCTRL3_tmFAW_mask                                                    (0xFF000000)
+#define DC_PHY_TMCTRL3_tmFAW(data)                                                   (0xFF000000&((data)<<24))
+#define DC_PHY_TMCTRL3_tmFAW_src(data)                                               ((0xFF000000&(data))>>24)
+#define DC_PHY_TMCTRL3_get_tmFAW(data)                                               ((0xFF000000&(data))>>24)
+#define DC_PHY_TMCTRL3_refcycle_shift                                                (12)
+#define DC_PHY_TMCTRL3_refcycle_mask                                                 (0x003FF000)
+#define DC_PHY_TMCTRL3_refcycle(data)                                                (0x003FF000&((data)<<12))
+#define DC_PHY_TMCTRL3_refcycle_src(data)                                            ((0x003FF000&(data))>>12)
+#define DC_PHY_TMCTRL3_get_refcycle(data)                                            ((0x003FF000&(data))>>12)
+#define DC_PHY_TMCTRL3_tmrfc_shift                                                   (0)
+#define DC_PHY_TMCTRL3_tmrfc_mask                                                    (0x000007FF)
+#define DC_PHY_TMCTRL3_tmrfc(data)                                                   (0x000007FF&((data)<<0))
+#define DC_PHY_TMCTRL3_tmrfc_src(data)                                               ((0x000007FF&(data))>>0)
+#define DC_PHY_TMCTRL3_get_tmrfc(data)                                               ((0x000007FF&(data))>>0)
+
+
+#define DC_PHY_TMCTRL4                                                               0x18008810
+#define DC_PHY_TMCTRL4_reg_addr                                                      "0xB8008810"
+#define DC_PHY_TMCTRL4_reg                                                           0xB8008810
+#define set_DC_PHY_TMCTRL4_reg(data)   (*((volatile unsigned int*) DC_PHY_TMCTRL4_reg)=data)
+#define get_DC_PHY_TMCTRL4_reg   (*((volatile unsigned int*) DC_PHY_TMCTRL4_reg))
+#define DC_PHY_TMCTRL4_inst_adr                                                      "0x0004"
+#define DC_PHY_TMCTRL4_inst                                                          0x0004
+#define DC_PHY_TMCTRL4_tAOND_shift                                                   (24)
+#define DC_PHY_TMCTRL4_tAOND_mask                                                    (0x3F000000)
+#define DC_PHY_TMCTRL4_tAOND(data)                                                   (0x3F000000&((data)<<24))
+#define DC_PHY_TMCTRL4_tAOND_src(data)                                               ((0x3F000000&(data))>>24)
+#define DC_PHY_TMCTRL4_get_tAOND(data)                                               ((0x3F000000&(data))>>24)
+#define DC_PHY_TMCTRL4_tAOFD_shift                                                   (16)
+#define DC_PHY_TMCTRL4_tAOFD_mask                                                    (0x003F0000)
+#define DC_PHY_TMCTRL4_tAOFD(data)                                                   (0x003F0000&((data)<<16))
+#define DC_PHY_TMCTRL4_tAOFD_src(data)                                               ((0x003F0000&(data))>>16)
+#define DC_PHY_TMCTRL4_get_tAOFD(data)                                               ((0x003F0000&(data))>>16)
+#define DC_PHY_TMCTRL4_tmmod_shift                                                   (8)
+#define DC_PHY_TMCTRL4_tmmod_mask                                                    (0x0000FF00)
+#define DC_PHY_TMCTRL4_tmmod(data)                                                   (0x0000FF00&((data)<<8))
+#define DC_PHY_TMCTRL4_tmmod_src(data)                                               ((0x0000FF00&(data))>>8)
+#define DC_PHY_TMCTRL4_get_tmmod(data)                                               ((0x0000FF00&(data))>>8)
+#define DC_PHY_TMCTRL4_tmmrd_shift                                                   (0)
+#define DC_PHY_TMCTRL4_tmmrd_mask                                                    (0x0000001F)
+#define DC_PHY_TMCTRL4_tmmrd(data)                                                   (0x0000001F&((data)<<0))
+#define DC_PHY_TMCTRL4_tmmrd_src(data)                                               ((0x0000001F&(data))>>0)
+#define DC_PHY_TMCTRL4_get_tmmrd(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define DC_PHY_TMCTRL5                                                               0x18008814
+#define DC_PHY_TMCTRL5_reg_addr                                                      "0xB8008814"
+#define DC_PHY_TMCTRL5_reg                                                           0xB8008814
+#define set_DC_PHY_TMCTRL5_reg(data)   (*((volatile unsigned int*) DC_PHY_TMCTRL5_reg)=data)
+#define get_DC_PHY_TMCTRL5_reg   (*((volatile unsigned int*) DC_PHY_TMCTRL5_reg))
+#define DC_PHY_TMCTRL5_inst_adr                                                      "0x0005"
+#define DC_PHY_TMCTRL5_inst                                                          0x0005
+#define DC_PHY_TMCTRL5_tzqoper_shift                                                 (12)
+#define DC_PHY_TMCTRL5_tzqoper_mask                                                  (0x00FFF000)
+#define DC_PHY_TMCTRL5_tzqoper(data)                                                 (0x00FFF000&((data)<<12))
+#define DC_PHY_TMCTRL5_tzqoper_src(data)                                             ((0x00FFF000&(data))>>12)
+#define DC_PHY_TMCTRL5_get_tzqoper(data)                                             ((0x00FFF000&(data))>>12)
+#define DC_PHY_TMCTRL5_tzqinit_shift                                                 (0)
+#define DC_PHY_TMCTRL5_tzqinit_mask                                                  (0x00000FFF)
+#define DC_PHY_TMCTRL5_tzqinit(data)                                                 (0x00000FFF&((data)<<0))
+#define DC_PHY_TMCTRL5_tzqinit_src(data)                                             ((0x00000FFF&(data))>>0)
+#define DC_PHY_TMCTRL5_get_tzqinit(data)                                             ((0x00000FFF&(data))>>0)
+
+
+#define DC_PHY_TMCTRL6                                                               0x18008818
+#define DC_PHY_TMCTRL6_reg_addr                                                      "0xB8008818"
+#define DC_PHY_TMCTRL6_reg                                                           0xB8008818
+#define set_DC_PHY_TMCTRL6_reg(data)   (*((volatile unsigned int*) DC_PHY_TMCTRL6_reg)=data)
+#define get_DC_PHY_TMCTRL6_reg   (*((volatile unsigned int*) DC_PHY_TMCTRL6_reg))
+#define DC_PHY_TMCTRL6_inst_adr                                                      "0x0006"
+#define DC_PHY_TMCTRL6_inst                                                          0x0006
+#define DC_PHY_TMCTRL6_tdllk_shift                                                   (12)
+#define DC_PHY_TMCTRL6_tdllk_mask                                                    (0x00FFF000)
+#define DC_PHY_TMCTRL6_tdllk(data)                                                   (0x00FFF000&((data)<<12))
+#define DC_PHY_TMCTRL6_tdllk_src(data)                                               ((0x00FFF000&(data))>>12)
+#define DC_PHY_TMCTRL6_get_tdllk(data)                                               ((0x00FFF000&(data))>>12)
+#define DC_PHY_TMCTRL6_tzqcs_shift                                                   (0)
+#define DC_PHY_TMCTRL6_tzqcs_mask                                                    (0x00000FFF)
+#define DC_PHY_TMCTRL6_tzqcs(data)                                                   (0x00000FFF&((data)<<0))
+#define DC_PHY_TMCTRL6_tzqcs_src(data)                                               ((0x00000FFF&(data))>>0)
+#define DC_PHY_TMCTRL6_get_tzqcs(data)                                               ((0x00000FFF&(data))>>0)
+
+
+#define DC_PHY_ODT_CTRL                                                              0x18008820
+#define DC_PHY_ODT_CTRL_reg_addr                                                     "0xB8008820"
+#define DC_PHY_ODT_CTRL_reg                                                          0xB8008820
+#define set_DC_PHY_ODT_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_ODT_CTRL_reg)=data)
+#define get_DC_PHY_ODT_CTRL_reg   (*((volatile unsigned int*) DC_PHY_ODT_CTRL_reg))
+#define DC_PHY_ODT_CTRL_inst_adr                                                     "0x0008"
+#define DC_PHY_ODT_CTRL_inst                                                         0x0008
+#define DC_PHY_ODT_CTRL_ddr3_odt_dly_1T_shift                                        (28)
+#define DC_PHY_ODT_CTRL_ddr3_odt_dly_1T_mask                                         (0x10000000)
+#define DC_PHY_ODT_CTRL_ddr3_odt_dly_1T(data)                                        (0x10000000&((data)<<28))
+#define DC_PHY_ODT_CTRL_ddr3_odt_dly_1T_src(data)                                    ((0x10000000&(data))>>28)
+#define DC_PHY_ODT_CTRL_get_ddr3_odt_dly_1T(data)                                    ((0x10000000&(data))>>28)
+#define DC_PHY_ODT_CTRL_ddr3_odt_ext_1T_shift                                        (27)
+#define DC_PHY_ODT_CTRL_ddr3_odt_ext_1T_mask                                         (0x08000000)
+#define DC_PHY_ODT_CTRL_ddr3_odt_ext_1T(data)                                        (0x08000000&((data)<<27))
+#define DC_PHY_ODT_CTRL_ddr3_odt_ext_1T_src(data)                                    ((0x08000000&(data))>>27)
+#define DC_PHY_ODT_CTRL_get_ddr3_odt_ext_1T(data)                                    ((0x08000000&(data))>>27)
+#define DC_PHY_ODT_CTRL_ctrl_odt_en_shift                                            (26)
+#define DC_PHY_ODT_CTRL_ctrl_odt_en_mask                                             (0x04000000)
+#define DC_PHY_ODT_CTRL_ctrl_odt_en(data)                                            (0x04000000&((data)<<26))
+#define DC_PHY_ODT_CTRL_ctrl_odt_en_src(data)                                        ((0x04000000&(data))>>26)
+#define DC_PHY_ODT_CTRL_get_ctrl_odt_en(data)                                        ((0x04000000&(data))>>26)
+#define DC_PHY_ODT_CTRL_mars_odt_force_sel_shift                                     (25)
+#define DC_PHY_ODT_CTRL_mars_odt_force_sel_mask                                      (0x02000000)
+#define DC_PHY_ODT_CTRL_mars_odt_force_sel(data)                                     (0x02000000&((data)<<25))
+#define DC_PHY_ODT_CTRL_mars_odt_force_sel_src(data)                                 ((0x02000000&(data))>>25)
+#define DC_PHY_ODT_CTRL_get_mars_odt_force_sel(data)                                 ((0x02000000&(data))>>25)
+#define DC_PHY_ODT_CTRL_mars_odt_force_sig_shift                                     (24)
+#define DC_PHY_ODT_CTRL_mars_odt_force_sig_mask                                      (0x01000000)
+#define DC_PHY_ODT_CTRL_mars_odt_force_sig(data)                                     (0x01000000&((data)<<24))
+#define DC_PHY_ODT_CTRL_mars_odt_force_sig_src(data)                                 ((0x01000000&(data))>>24)
+#define DC_PHY_ODT_CTRL_get_mars_odt_force_sig(data)                                 ((0x01000000&(data))>>24)
+#define DC_PHY_ODT_CTRL_odt_force_sel_shift                                          (23)
+#define DC_PHY_ODT_CTRL_odt_force_sel_mask                                           (0x00800000)
+#define DC_PHY_ODT_CTRL_odt_force_sel(data)                                          (0x00800000&((data)<<23))
+#define DC_PHY_ODT_CTRL_odt_force_sel_src(data)                                      ((0x00800000&(data))>>23)
+#define DC_PHY_ODT_CTRL_get_odt_force_sel(data)                                      ((0x00800000&(data))>>23)
+#define DC_PHY_ODT_CTRL_odt_force_sig_shift                                          (22)
+#define DC_PHY_ODT_CTRL_odt_force_sig_mask                                           (0x00400000)
+#define DC_PHY_ODT_CTRL_odt_force_sig(data)                                          (0x00400000&((data)<<22))
+#define DC_PHY_ODT_CTRL_odt_force_sig_src(data)                                      ((0x00400000&(data))>>22)
+#define DC_PHY_ODT_CTRL_get_odt_force_sig(data)                                      ((0x00400000&(data))>>22)
+#define DC_PHY_ODT_CTRL_odt_en_shift                                                 (21)
+#define DC_PHY_ODT_CTRL_odt_en_mask                                                  (0x00200000)
+#define DC_PHY_ODT_CTRL_odt_en(data)                                                 (0x00200000&((data)<<21))
+#define DC_PHY_ODT_CTRL_odt_en_src(data)                                             ((0x00200000&(data))>>21)
+#define DC_PHY_ODT_CTRL_get_odt_en(data)                                             ((0x00200000&(data))>>21)
+#define DC_PHY_ODT_CTRL_odt_dis_shift                                                (20)
+#define DC_PHY_ODT_CTRL_odt_dis_mask                                                 (0x00100000)
+#define DC_PHY_ODT_CTRL_odt_dis(data)                                                (0x00100000&((data)<<20))
+#define DC_PHY_ODT_CTRL_odt_dis_src(data)                                            ((0x00100000&(data))>>20)
+#define DC_PHY_ODT_CTRL_get_odt_dis(data)                                            ((0x00100000&(data))>>20)
+#define DC_PHY_ODT_CTRL_odt_en_lat_shift                                             (0)
+#define DC_PHY_ODT_CTRL_odt_en_lat_mask                                              (0x00007FFF)
+#define DC_PHY_ODT_CTRL_odt_en_lat(data)                                             (0x00007FFF&((data)<<0))
+#define DC_PHY_ODT_CTRL_odt_en_lat_src(data)                                         ((0x00007FFF&(data))>>0)
+#define DC_PHY_ODT_CTRL_get_odt_en_lat(data)                                         ((0x00007FFF&(data))>>0)
+
+
+#define DC_PHY_CAL_CTRL2                                                             0x18008824
+#define DC_PHY_CAL_CTRL2_reg_addr                                                    "0xB8008824"
+#define DC_PHY_CAL_CTRL2_reg                                                         0xB8008824
+#define set_DC_PHY_CAL_CTRL2_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL_CTRL2_reg)=data)
+#define get_DC_PHY_CAL_CTRL2_reg   (*((volatile unsigned int*) DC_PHY_CAL_CTRL2_reg))
+#define DC_PHY_CAL_CTRL2_inst_adr                                                    "0x0009"
+#define DC_PHY_CAL_CTRL2_inst                                                        0x0009
+#define DC_PHY_CAL_CTRL2_cal_rang_shift                                              (8)
+#define DC_PHY_CAL_CTRL2_cal_rang_mask                                               (0x00003F00)
+#define DC_PHY_CAL_CTRL2_cal_rang(data)                                              (0x00003F00&((data)<<8))
+#define DC_PHY_CAL_CTRL2_cal_rang_src(data)                                          ((0x00003F00&(data))>>8)
+#define DC_PHY_CAL_CTRL2_get_cal_rang(data)                                          ((0x00003F00&(data))>>8)
+#define DC_PHY_CAL_CTRL2_cal_per_shift                                               (0)
+#define DC_PHY_CAL_CTRL2_cal_per_mask                                                (0x000000FF)
+#define DC_PHY_CAL_CTRL2_cal_per(data)                                               (0x000000FF&((data)<<0))
+#define DC_PHY_CAL_CTRL2_cal_per_src(data)                                           ((0x000000FF&(data))>>0)
+#define DC_PHY_CAL_CTRL2_get_cal_per(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define DC_PHY_DC_MIS2                                                               0x18008828
+#define DC_PHY_DC_MIS2_reg_addr                                                      "0xB8008828"
+#define DC_PHY_DC_MIS2_reg                                                           0xB8008828
+#define set_DC_PHY_DC_MIS2_reg(data)   (*((volatile unsigned int*) DC_PHY_DC_MIS2_reg)=data)
+#define get_DC_PHY_DC_MIS2_reg   (*((volatile unsigned int*) DC_PHY_DC_MIS2_reg))
+#define DC_PHY_DC_MIS2_inst_adr                                                      "0x000A"
+#define DC_PHY_DC_MIS2_inst                                                          0x000A
+#define DC_PHY_DC_MIS2_exe_cal_shift                                                 (5)
+#define DC_PHY_DC_MIS2_exe_cal_mask                                                  (0x00000020)
+#define DC_PHY_DC_MIS2_exe_cal(data)                                                 (0x00000020&((data)<<5))
+#define DC_PHY_DC_MIS2_exe_cal_src(data)                                             ((0x00000020&(data))>>5)
+#define DC_PHY_DC_MIS2_get_exe_cal(data)                                             ((0x00000020&(data))>>5)
+#define DC_PHY_DC_MIS2_init_shift                                                    (4)
+#define DC_PHY_DC_MIS2_init_mask                                                     (0x00000010)
+#define DC_PHY_DC_MIS2_init(data)                                                    (0x00000010&((data)<<4))
+#define DC_PHY_DC_MIS2_init_src(data)                                                ((0x00000010&(data))>>4)
+#define DC_PHY_DC_MIS2_get_init(data)                                                ((0x00000010&(data))>>4)
+#define DC_PHY_DC_MIS2_sren_shift                                                    (3)
+#define DC_PHY_DC_MIS2_sren_mask                                                     (0x00000008)
+#define DC_PHY_DC_MIS2_sren(data)                                                    (0x00000008&((data)<<3))
+#define DC_PHY_DC_MIS2_sren_src(data)                                                ((0x00000008&(data))>>3)
+#define DC_PHY_DC_MIS2_get_sren(data)                                                ((0x00000008&(data))>>3)
+#define DC_PHY_DC_MIS2_srex_shift                                                    (2)
+#define DC_PHY_DC_MIS2_srex_mask                                                     (0x00000004)
+#define DC_PHY_DC_MIS2_srex(data)                                                    (0x00000004&((data)<<2))
+#define DC_PHY_DC_MIS2_srex_src(data)                                                ((0x00000004&(data))>>2)
+#define DC_PHY_DC_MIS2_get_srex(data)                                                ((0x00000004&(data))>>2)
+#define DC_PHY_DC_MIS2_exe_emr_shift                                                 (1)
+#define DC_PHY_DC_MIS2_exe_emr_mask                                                  (0x00000002)
+#define DC_PHY_DC_MIS2_exe_emr(data)                                                 (0x00000002&((data)<<1))
+#define DC_PHY_DC_MIS2_exe_emr_src(data)                                             ((0x00000002&(data))>>1)
+#define DC_PHY_DC_MIS2_get_exe_emr(data)                                             ((0x00000002&(data))>>1)
+#define DC_PHY_DC_MIS2_exe_mr_shift                                                  (0)
+#define DC_PHY_DC_MIS2_exe_mr_mask                                                   (0x00000001)
+#define DC_PHY_DC_MIS2_exe_mr(data)                                                  (0x00000001&((data)<<0))
+#define DC_PHY_DC_MIS2_exe_mr_src(data)                                              ((0x00000001&(data))>>0)
+#define DC_PHY_DC_MIS2_get_exe_mr(data)                                              ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_DC_MIS                                                                0x1800882c
+#define DC_PHY_DC_MIS_reg_addr                                                       "0xB800882C"
+#define DC_PHY_DC_MIS_reg                                                            0xB800882C
+#define set_DC_PHY_DC_MIS_reg(data)   (*((volatile unsigned int*) DC_PHY_DC_MIS_reg)=data)
+#define get_DC_PHY_DC_MIS_reg   (*((volatile unsigned int*) DC_PHY_DC_MIS_reg))
+#define DC_PHY_DC_MIS_inst_adr                                                       "0x000B"
+#define DC_PHY_DC_MIS_inst                                                           0x000B
+#define DC_PHY_DC_MIS_rcd_not_eq_shift                                               (20)
+#define DC_PHY_DC_MIS_rcd_not_eq_mask                                                (0x00100000)
+#define DC_PHY_DC_MIS_rcd_not_eq(data)                                               (0x00100000&((data)<<20))
+#define DC_PHY_DC_MIS_rcd_not_eq_src(data)                                           ((0x00100000&(data))>>20)
+#define DC_PHY_DC_MIS_get_rcd_not_eq(data)                                           ((0x00100000&(data))>>20)
+#define DC_PHY_DC_MIS_tmrcdwr_shift                                                  (16)
+#define DC_PHY_DC_MIS_tmrcdwr_mask                                                   (0x000F0000)
+#define DC_PHY_DC_MIS_tmrcdwr(data)                                                  (0x000F0000&((data)<<16))
+#define DC_PHY_DC_MIS_tmrcdwr_src(data)                                              ((0x000F0000&(data))>>16)
+#define DC_PHY_DC_MIS_get_tmrcdwr(data)                                              ((0x000F0000&(data))>>16)
+#define DC_PHY_DC_MIS_tmrp_all_add_shift                                             (14)
+#define DC_PHY_DC_MIS_tmrp_all_add_mask                                              (0x0000C000)
+#define DC_PHY_DC_MIS_tmrp_all_add(data)                                             (0x0000C000&((data)<<14))
+#define DC_PHY_DC_MIS_tmrp_all_add_src(data)                                         ((0x0000C000&(data))>>14)
+#define DC_PHY_DC_MIS_get_tmrp_all_add(data)                                         ((0x0000C000&(data))>>14)
+#define DC_PHY_DC_MIS_ap_wo_min_dly_shift                                            (13)
+#define DC_PHY_DC_MIS_ap_wo_min_dly_mask                                             (0x00002000)
+#define DC_PHY_DC_MIS_ap_wo_min_dly(data)                                            (0x00002000&((data)<<13))
+#define DC_PHY_DC_MIS_ap_wo_min_dly_src(data)                                        ((0x00002000&(data))>>13)
+#define DC_PHY_DC_MIS_get_ap_wo_min_dly(data)                                        ((0x00002000&(data))>>13)
+#define DC_PHY_DC_MIS_add_ht_shift                                                   (12)
+#define DC_PHY_DC_MIS_add_ht_mask                                                    (0x00001000)
+#define DC_PHY_DC_MIS_add_ht(data)                                                   (0x00001000&((data)<<12))
+#define DC_PHY_DC_MIS_add_ht_src(data)                                               ((0x00001000&(data))>>12)
+#define DC_PHY_DC_MIS_get_add_ht(data)                                               ((0x00001000&(data))>>12)
+#define DC_PHY_DC_MIS_ddr3_shift                                                     (0)
+#define DC_PHY_DC_MIS_ddr3_mask                                                      (0x00000001)
+#define DC_PHY_DC_MIS_ddr3(data)                                                     (0x00000001&((data)<<0))
+#define DC_PHY_DC_MIS_ddr3_src(data)                                                 ((0x00000001&(data))>>0)
+#define DC_PHY_DC_MIS_get_ddr3(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_DC_MISA                                                               0x18008830
+#define DC_PHY_DC_MISA_reg_addr                                                      "0xB8008830"
+#define DC_PHY_DC_MISA_reg                                                           0xB8008830
+#define set_DC_PHY_DC_MISA_reg(data)   (*((volatile unsigned int*) DC_PHY_DC_MISA_reg)=data)
+#define get_DC_PHY_DC_MISA_reg   (*((volatile unsigned int*) DC_PHY_DC_MISA_reg))
+#define DC_PHY_DC_MISA_inst_adr                                                      "0x000C"
+#define DC_PHY_DC_MISA_inst                                                          0x000C
+#define DC_PHY_DC_MISA_pre_dis_shift                                                 (12)
+#define DC_PHY_DC_MISA_pre_dis_mask                                                  (0x00001000)
+#define DC_PHY_DC_MISA_pre_dis(data)                                                 (0x00001000&((data)<<12))
+#define DC_PHY_DC_MISA_pre_dis_src(data)                                             ((0x00001000&(data))>>12)
+#define DC_PHY_DC_MISA_get_pre_dis(data)                                             ((0x00001000&(data))>>12)
+#define DC_PHY_DC_MISA_lbk_en_shift                                                  (2)
+#define DC_PHY_DC_MISA_lbk_en_mask                                                   (0x00000004)
+#define DC_PHY_DC_MISA_lbk_en(data)                                                  (0x00000004&((data)<<2))
+#define DC_PHY_DC_MISA_lbk_en_src(data)                                              ((0x00000004&(data))>>2)
+#define DC_PHY_DC_MISA_get_lbk_en(data)                                              ((0x00000004&(data))>>2)
+
+
+#define DC_PHY_DC_MISB                                                               0x18008834
+#define DC_PHY_DC_MISB_reg_addr                                                      "0xB8008834"
+#define DC_PHY_DC_MISB_reg                                                           0xB8008834
+#define set_DC_PHY_DC_MISB_reg(data)   (*((volatile unsigned int*) DC_PHY_DC_MISB_reg)=data)
+#define get_DC_PHY_DC_MISB_reg   (*((volatile unsigned int*) DC_PHY_DC_MISB_reg))
+#define DC_PHY_DC_MISB_inst_adr                                                      "0x000D"
+#define DC_PHY_DC_MISB_inst                                                          0x000D
+#define DC_PHY_DC_MISB_tmrc_sel_shift                                                (28)
+#define DC_PHY_DC_MISB_tmrc_sel_mask                                                 (0x10000000)
+#define DC_PHY_DC_MISB_tmrc_sel(data)                                                (0x10000000&((data)<<28))
+#define DC_PHY_DC_MISB_tmrc_sel_src(data)                                            ((0x10000000&(data))>>28)
+#define DC_PHY_DC_MISB_get_tmrc_sel(data)                                            ((0x10000000&(data))>>28)
+#define DC_PHY_DC_MISB_cpu_rd_pri_shift                                              (13)
+#define DC_PHY_DC_MISB_cpu_rd_pri_mask                                               (0x00006000)
+#define DC_PHY_DC_MISB_cpu_rd_pri(data)                                              (0x00006000&((data)<<13))
+#define DC_PHY_DC_MISB_cpu_rd_pri_src(data)                                          ((0x00006000&(data))>>13)
+#define DC_PHY_DC_MISB_get_cpu_rd_pri(data)                                          ((0x00006000&(data))>>13)
+#define DC_PHY_DC_MISB_cpu_wr_pri_shift                                              (11)
+#define DC_PHY_DC_MISB_cpu_wr_pri_mask                                               (0x00001800)
+#define DC_PHY_DC_MISB_cpu_wr_pri(data)                                              (0x00001800&((data)<<11))
+#define DC_PHY_DC_MISB_cpu_wr_pri_src(data)                                          ((0x00001800&(data))>>11)
+#define DC_PHY_DC_MISB_get_cpu_wr_pri(data)                                          ((0x00001800&(data))>>11)
+#define DC_PHY_DC_MISB_en_rw_reord_shift                                             (10)
+#define DC_PHY_DC_MISB_en_rw_reord_mask                                              (0x00000400)
+#define DC_PHY_DC_MISB_en_rw_reord(data)                                             (0x00000400&((data)<<10))
+#define DC_PHY_DC_MISB_en_rw_reord_src(data)                                         ((0x00000400&(data))>>10)
+#define DC_PHY_DC_MISB_get_en_rw_reord(data)                                         ((0x00000400&(data))>>10)
+#define DC_PHY_DC_MISB_en_cpu_wro_shift                                              (9)
+#define DC_PHY_DC_MISB_en_cpu_wro_mask                                               (0x00000200)
+#define DC_PHY_DC_MISB_en_cpu_wro(data)                                              (0x00000200&((data)<<9))
+#define DC_PHY_DC_MISB_en_cpu_wro_src(data)                                          ((0x00000200&(data))>>9)
+#define DC_PHY_DC_MISB_get_en_cpu_wro(data)                                          ((0x00000200&(data))>>9)
+#define DC_PHY_DC_MISB_en_conflict_reord_shift                                       (8)
+#define DC_PHY_DC_MISB_en_conflict_reord_mask                                        (0x00000100)
+#define DC_PHY_DC_MISB_en_conflict_reord(data)                                       (0x00000100&((data)<<8))
+#define DC_PHY_DC_MISB_en_conflict_reord_src(data)                                   ((0x00000100&(data))>>8)
+#define DC_PHY_DC_MISB_get_en_conflict_reord(data)                                   ((0x00000100&(data))>>8)
+#define DC_PHY_DC_MISB_en_cpu_reord_shift                                            (7)
+#define DC_PHY_DC_MISB_en_cpu_reord_mask                                             (0x00000080)
+#define DC_PHY_DC_MISB_en_cpu_reord(data)                                            (0x00000080&((data)<<7))
+#define DC_PHY_DC_MISB_en_cpu_reord_src(data)                                        ((0x00000080&(data))>>7)
+#define DC_PHY_DC_MISB_get_en_cpu_reord(data)                                        ((0x00000080&(data))>>7)
+#define DC_PHY_DC_MISB_cpu_reord_thr_shift                                           (4)
+#define DC_PHY_DC_MISB_cpu_reord_thr_mask                                            (0x00000070)
+#define DC_PHY_DC_MISB_cpu_reord_thr(data)                                           (0x00000070&((data)<<4))
+#define DC_PHY_DC_MISB_cpu_reord_thr_src(data)                                       ((0x00000070&(data))>>4)
+#define DC_PHY_DC_MISB_get_cpu_reord_thr(data)                                       ((0x00000070&(data))>>4)
+#define DC_PHY_DC_MISB_en_low_reord_shift                                            (3)
+#define DC_PHY_DC_MISB_en_low_reord_mask                                             (0x00000008)
+#define DC_PHY_DC_MISB_en_low_reord(data)                                            (0x00000008&((data)<<3))
+#define DC_PHY_DC_MISB_en_low_reord_src(data)                                        ((0x00000008&(data))>>3)
+#define DC_PHY_DC_MISB_get_en_low_reord(data)                                        ((0x00000008&(data))>>3)
+#define DC_PHY_DC_MISB_dis_ap_cpu_shift                                              (2)
+#define DC_PHY_DC_MISB_dis_ap_cpu_mask                                               (0x00000004)
+#define DC_PHY_DC_MISB_dis_ap_cpu(data)                                              (0x00000004&((data)<<2))
+#define DC_PHY_DC_MISB_dis_ap_cpu_src(data)                                          ((0x00000004&(data))>>2)
+#define DC_PHY_DC_MISB_get_dis_ap_cpu(data)                                          ((0x00000004&(data))>>2)
+#define DC_PHY_DC_MISB_dis_ap_cti_shift                                              (1)
+#define DC_PHY_DC_MISB_dis_ap_cti_mask                                               (0x00000002)
+#define DC_PHY_DC_MISB_dis_ap_cti(data)                                              (0x00000002&((data)<<1))
+#define DC_PHY_DC_MISB_dis_ap_cti_src(data)                                          ((0x00000002&(data))>>1)
+#define DC_PHY_DC_MISB_get_dis_ap_cti(data)                                          ((0x00000002&(data))>>1)
+#define DC_PHY_DC_MISB_dis_ap_nor_shift                                              (0)
+#define DC_PHY_DC_MISB_dis_ap_nor_mask                                               (0x00000001)
+#define DC_PHY_DC_MISB_dis_ap_nor(data)                                              (0x00000001&((data)<<0))
+#define DC_PHY_DC_MISB_dis_ap_nor_src(data)                                          ((0x00000001&(data))>>0)
+#define DC_PHY_DC_MISB_get_dis_ap_nor(data)                                          ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_DC_MISC                                                               0x18008838
+#define DC_PHY_DC_MISC_reg_addr                                                      "0xB8008838"
+#define DC_PHY_DC_MISC_reg                                                           0xB8008838
+#define set_DC_PHY_DC_MISC_reg(data)   (*((volatile unsigned int*) DC_PHY_DC_MISC_reg)=data)
+#define get_DC_PHY_DC_MISC_reg   (*((volatile unsigned int*) DC_PHY_DC_MISC_reg))
+#define DC_PHY_DC_MISC_inst_adr                                                      "0x000E"
+#define DC_PHY_DC_MISC_inst                                                          0x000E
+#define DC_PHY_DC_MISC_tap_2group_shift                                              (27)
+#define DC_PHY_DC_MISC_tap_2group_mask                                               (0x08000000)
+#define DC_PHY_DC_MISC_tap_2group(data)                                              (0x08000000&((data)<<27))
+#define DC_PHY_DC_MISC_tap_2group_src(data)                                          ((0x08000000&(data))>>27)
+#define DC_PHY_DC_MISC_get_tap_2group(data)                                          ((0x08000000&(data))>>27)
+#define DC_PHY_DC_MISC_tap_mask_shift                                                (26)
+#define DC_PHY_DC_MISC_tap_mask_mask                                                 (0x04000000)
+#define DC_PHY_DC_MISC_tap_mask(data)                                                (0x04000000&((data)<<26))
+#define DC_PHY_DC_MISC_tap_mask_src(data)                                            ((0x04000000&(data))>>26)
+#define DC_PHY_DC_MISC_get_tap_mask(data)                                            ((0x04000000&(data))>>26)
+#define DC_PHY_DC_MISC_fw_set_shift                                                  (25)
+#define DC_PHY_DC_MISC_fw_set_mask                                                   (0x02000000)
+#define DC_PHY_DC_MISC_fw_set(data)                                                  (0x02000000&((data)<<25))
+#define DC_PHY_DC_MISC_fw_set_src(data)                                              ((0x02000000&(data))>>25)
+#define DC_PHY_DC_MISC_get_fw_set(data)                                              ((0x02000000&(data))>>25)
+#define DC_PHY_DC_MISC_tap_sel_shift                                                 (24)
+#define DC_PHY_DC_MISC_tap_sel_mask                                                  (0x01000000)
+#define DC_PHY_DC_MISC_tap_sel(data)                                                 (0x01000000&((data)<<24))
+#define DC_PHY_DC_MISC_tap_sel_src(data)                                             ((0x01000000&(data))>>24)
+#define DC_PHY_DC_MISC_get_tap_sel(data)                                             ((0x01000000&(data))>>24)
+
+
+#define DC_PHY_DC_TEST_MODE_SEL                                                      0x1800883c
+#define DC_PHY_DC_TEST_MODE_SEL_reg_addr                                             "0xB800883C"
+#define DC_PHY_DC_TEST_MODE_SEL_reg                                                  0xB800883C
+#define set_DC_PHY_DC_TEST_MODE_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DC_TEST_MODE_SEL_reg)=data)
+#define get_DC_PHY_DC_TEST_MODE_SEL_reg   (*((volatile unsigned int*) DC_PHY_DC_TEST_MODE_SEL_reg))
+#define DC_PHY_DC_TEST_MODE_SEL_inst_adr                                             "0x000F"
+#define DC_PHY_DC_TEST_MODE_SEL_inst                                                 0x000F
+#define DC_PHY_DC_TEST_MODE_SEL_clear_set_sys_shift                                  (2)
+#define DC_PHY_DC_TEST_MODE_SEL_clear_set_sys_mask                                   (0x00000004)
+#define DC_PHY_DC_TEST_MODE_SEL_clear_set_sys(data)                                  (0x00000004&((data)<<2))
+#define DC_PHY_DC_TEST_MODE_SEL_clear_set_sys_src(data)                              ((0x00000004&(data))>>2)
+#define DC_PHY_DC_TEST_MODE_SEL_get_clear_set_sys(data)                              ((0x00000004&(data))>>2)
+#define DC_PHY_DC_TEST_MODE_SEL_clear_trig_shift                                     (1)
+#define DC_PHY_DC_TEST_MODE_SEL_clear_trig_mask                                      (0x00000002)
+#define DC_PHY_DC_TEST_MODE_SEL_clear_trig(data)                                     (0x00000002&((data)<<1))
+#define DC_PHY_DC_TEST_MODE_SEL_clear_trig_src(data)                                 ((0x00000002&(data))>>1)
+#define DC_PHY_DC_TEST_MODE_SEL_get_clear_trig(data)                                 ((0x00000002&(data))>>1)
+#define DC_PHY_DC_TEST_MODE_SEL_test_mode_sel_shift                                  (0)
+#define DC_PHY_DC_TEST_MODE_SEL_test_mode_sel_mask                                   (0x00000001)
+#define DC_PHY_DC_TEST_MODE_SEL_test_mode_sel(data)                                  (0x00000001&((data)<<0))
+#define DC_PHY_DC_TEST_MODE_SEL_test_mode_sel_src(data)                              ((0x00000001&(data))>>0)
+#define DC_PHY_DC_TEST_MODE_SEL_get_test_mode_sel(data)                              ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_DC_DDR3_CTL                                                           0x18008840
+#define DC_PHY_DC_DDR3_CTL_reg_addr                                                  "0xB8008840"
+#define DC_PHY_DC_DDR3_CTL_reg                                                       0xB8008840
+#define set_DC_PHY_DC_DDR3_CTL_reg(data)   (*((volatile unsigned int*) DC_PHY_DC_DDR3_CTL_reg)=data)
+#define get_DC_PHY_DC_DDR3_CTL_reg   (*((volatile unsigned int*) DC_PHY_DC_DDR3_CTL_reg))
+#define DC_PHY_DC_DDR3_CTL_inst_adr                                                  "0x0010"
+#define DC_PHY_DC_DDR3_CTL_inst                                                      0x0010
+#define DC_PHY_DC_DDR3_CTL_write_en_14_shift                                         (29)
+#define DC_PHY_DC_DDR3_CTL_write_en_14_mask                                          (0x20000000)
+#define DC_PHY_DC_DDR3_CTL_write_en_14(data)                                         (0x20000000&((data)<<29))
+#define DC_PHY_DC_DDR3_CTL_write_en_14_src(data)                                     ((0x20000000&(data))>>29)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_14(data)                                     ((0x20000000&(data))>>29)
+#define DC_PHY_DC_DDR3_CTL_ddr3_swap_shift                                           (28)
+#define DC_PHY_DC_DDR3_CTL_ddr3_swap_mask                                            (0x10000000)
+#define DC_PHY_DC_DDR3_CTL_ddr3_swap(data)                                           (0x10000000&((data)<<28))
+#define DC_PHY_DC_DDR3_CTL_ddr3_swap_src(data)                                       ((0x10000000&(data))>>28)
+#define DC_PHY_DC_DDR3_CTL_get_ddr3_swap(data)                                       ((0x10000000&(data))>>28)
+#define DC_PHY_DC_DDR3_CTL_write_en_13_shift                                         (27)
+#define DC_PHY_DC_DDR3_CTL_write_en_13_mask                                          (0x08000000)
+#define DC_PHY_DC_DDR3_CTL_write_en_13(data)                                         (0x08000000&((data)<<27))
+#define DC_PHY_DC_DDR3_CTL_write_en_13_src(data)                                     ((0x08000000&(data))>>27)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_13(data)                                     ((0x08000000&(data))>>27)
+#define DC_PHY_DC_DDR3_CTL_end_500us_shift                                           (26)
+#define DC_PHY_DC_DDR3_CTL_end_500us_mask                                            (0x04000000)
+#define DC_PHY_DC_DDR3_CTL_end_500us(data)                                           (0x04000000&((data)<<26))
+#define DC_PHY_DC_DDR3_CTL_end_500us_src(data)                                       ((0x04000000&(data))>>26)
+#define DC_PHY_DC_DDR3_CTL_get_end_500us(data)                                       ((0x04000000&(data))>>26)
+#define DC_PHY_DC_DDR3_CTL_write_en_12_shift                                         (25)
+#define DC_PHY_DC_DDR3_CTL_write_en_12_mask                                          (0x02000000)
+#define DC_PHY_DC_DDR3_CTL_write_en_12(data)                                         (0x02000000&((data)<<25))
+#define DC_PHY_DC_DDR3_CTL_write_en_12_src(data)                                     ((0x02000000&(data))>>25)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_12(data)                                     ((0x02000000&(data))>>25)
+#define DC_PHY_DC_DDR3_CTL_end_200us_shift                                           (24)
+#define DC_PHY_DC_DDR3_CTL_end_200us_mask                                            (0x01000000)
+#define DC_PHY_DC_DDR3_CTL_end_200us(data)                                           (0x01000000&((data)<<24))
+#define DC_PHY_DC_DDR3_CTL_end_200us_src(data)                                       ((0x01000000&(data))>>24)
+#define DC_PHY_DC_DDR3_CTL_get_end_200us(data)                                       ((0x01000000&(data))>>24)
+#define DC_PHY_DC_DDR3_CTL_write_en_11_shift                                         (23)
+#define DC_PHY_DC_DDR3_CTL_write_en_11_mask                                          (0x00800000)
+#define DC_PHY_DC_DDR3_CTL_write_en_11(data)                                         (0x00800000&((data)<<23))
+#define DC_PHY_DC_DDR3_CTL_write_en_11_src(data)                                     ((0x00800000&(data))>>23)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_11(data)                                     ((0x00800000&(data))>>23)
+#define DC_PHY_DC_DDR3_CTL_fast_prechg_shift                                         (22)
+#define DC_PHY_DC_DDR3_CTL_fast_prechg_mask                                          (0x00400000)
+#define DC_PHY_DC_DDR3_CTL_fast_prechg(data)                                         (0x00400000&((data)<<22))
+#define DC_PHY_DC_DDR3_CTL_fast_prechg_src(data)                                     ((0x00400000&(data))>>22)
+#define DC_PHY_DC_DDR3_CTL_get_fast_prechg(data)                                     ((0x00400000&(data))>>22)
+#define DC_PHY_DC_DDR3_CTL_write_en_10_shift                                         (21)
+#define DC_PHY_DC_DDR3_CTL_write_en_10_mask                                          (0x00200000)
+#define DC_PHY_DC_DDR3_CTL_write_en_10(data)                                         (0x00200000&((data)<<21))
+#define DC_PHY_DC_DDR3_CTL_write_en_10_src(data)                                     ((0x00200000&(data))>>21)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_10(data)                                     ((0x00200000&(data))>>21)
+#define DC_PHY_DC_DDR3_CTL_dis_cti_shift                                             (20)
+#define DC_PHY_DC_DDR3_CTL_dis_cti_mask                                              (0x00100000)
+#define DC_PHY_DC_DDR3_CTL_dis_cti(data)                                             (0x00100000&((data)<<20))
+#define DC_PHY_DC_DDR3_CTL_dis_cti_src(data)                                         ((0x00100000&(data))>>20)
+#define DC_PHY_DC_DDR3_CTL_get_dis_cti(data)                                         ((0x00100000&(data))>>20)
+#define DC_PHY_DC_DDR3_CTL_write_en_9_shift                                          (19)
+#define DC_PHY_DC_DDR3_CTL_write_en_9_mask                                           (0x00080000)
+#define DC_PHY_DC_DDR3_CTL_write_en_9(data)                                          (0x00080000&((data)<<19))
+#define DC_PHY_DC_DDR3_CTL_write_en_9_src(data)                                      ((0x00080000&(data))>>19)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_9(data)                                      ((0x00080000&(data))>>19)
+#define DC_PHY_DC_DDR3_CTL_dis_8bank_shift                                           (18)
+#define DC_PHY_DC_DDR3_CTL_dis_8bank_mask                                            (0x00040000)
+#define DC_PHY_DC_DDR3_CTL_dis_8bank(data)                                           (0x00040000&((data)<<18))
+#define DC_PHY_DC_DDR3_CTL_dis_8bank_src(data)                                       ((0x00040000&(data))>>18)
+#define DC_PHY_DC_DDR3_CTL_get_dis_8bank(data)                                       ((0x00040000&(data))>>18)
+#define DC_PHY_DC_DDR3_CTL_write_en_8_shift                                          (17)
+#define DC_PHY_DC_DDR3_CTL_write_en_8_mask                                           (0x00020000)
+#define DC_PHY_DC_DDR3_CTL_write_en_8(data)                                          (0x00020000&((data)<<17))
+#define DC_PHY_DC_DDR3_CTL_write_en_8_src(data)                                      ((0x00020000&(data))>>17)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_8(data)                                      ((0x00020000&(data))>>17)
+#define DC_PHY_DC_DDR3_CTL_use_tmmrd_shift                                           (16)
+#define DC_PHY_DC_DDR3_CTL_use_tmmrd_mask                                            (0x00010000)
+#define DC_PHY_DC_DDR3_CTL_use_tmmrd(data)                                           (0x00010000&((data)<<16))
+#define DC_PHY_DC_DDR3_CTL_use_tmmrd_src(data)                                       ((0x00010000&(data))>>16)
+#define DC_PHY_DC_DDR3_CTL_get_use_tmmrd(data)                                       ((0x00010000&(data))>>16)
+#define DC_PHY_DC_DDR3_CTL_write_en_7_shift                                          (15)
+#define DC_PHY_DC_DDR3_CTL_write_en_7_mask                                           (0x00008000)
+#define DC_PHY_DC_DDR3_CTL_write_en_7(data)                                          (0x00008000&((data)<<15))
+#define DC_PHY_DC_DDR3_CTL_write_en_7_src(data)                                      ((0x00008000&(data))>>15)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_7(data)                                      ((0x00008000&(data))>>15)
+#define DC_PHY_DC_DDR3_CTL_dis_pre_all_shift                                         (14)
+#define DC_PHY_DC_DDR3_CTL_dis_pre_all_mask                                          (0x00004000)
+#define DC_PHY_DC_DDR3_CTL_dis_pre_all(data)                                         (0x00004000&((data)<<14))
+#define DC_PHY_DC_DDR3_CTL_dis_pre_all_src(data)                                     ((0x00004000&(data))>>14)
+#define DC_PHY_DC_DDR3_CTL_get_dis_pre_all(data)                                     ((0x00004000&(data))>>14)
+#define DC_PHY_DC_DDR3_CTL_write_en_6_shift                                          (13)
+#define DC_PHY_DC_DDR3_CTL_write_en_6_mask                                           (0x00002000)
+#define DC_PHY_DC_DDR3_CTL_write_en_6(data)                                          (0x00002000&((data)<<13))
+#define DC_PHY_DC_DDR3_CTL_write_en_6_src(data)                                      ((0x00002000&(data))>>13)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_6(data)                                      ((0x00002000&(data))>>13)
+#define DC_PHY_DC_DDR3_CTL_ddr3_zqcl_short_shift                                     (12)
+#define DC_PHY_DC_DDR3_CTL_ddr3_zqcl_short_mask                                      (0x00001000)
+#define DC_PHY_DC_DDR3_CTL_ddr3_zqcl_short(data)                                     (0x00001000&((data)<<12))
+#define DC_PHY_DC_DDR3_CTL_ddr3_zqcl_short_src(data)                                 ((0x00001000&(data))>>12)
+#define DC_PHY_DC_DDR3_CTL_get_ddr3_zqcl_short(data)                                 ((0x00001000&(data))>>12)
+#define DC_PHY_DC_DDR3_CTL_write_en_5_shift                                          (11)
+#define DC_PHY_DC_DDR3_CTL_write_en_5_mask                                           (0x00000800)
+#define DC_PHY_DC_DDR3_CTL_write_en_5(data)                                          (0x00000800&((data)<<11))
+#define DC_PHY_DC_DDR3_CTL_write_en_5_src(data)                                      ((0x00000800&(data))>>11)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_5(data)                                      ((0x00000800&(data))>>11)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_zqcl_shift                                       (10)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_zqcl_mask                                        (0x00000400)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_zqcl(data)                                       (0x00000400&((data)<<10))
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_zqcl_src(data)                                   ((0x00000400&(data))>>10)
+#define DC_PHY_DC_DDR3_CTL_get_ddr3_exe_zqcl(data)                                   ((0x00000400&(data))>>10)
+#define DC_PHY_DC_DDR3_CTL_write_en_4_shift                                          (9)
+#define DC_PHY_DC_DDR3_CTL_write_en_4_mask                                           (0x00000200)
+#define DC_PHY_DC_DDR3_CTL_write_en_4(data)                                          (0x00000200&((data)<<9))
+#define DC_PHY_DC_DDR3_CTL_write_en_4_src(data)                                      ((0x00000200&(data))>>9)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_4(data)                                      ((0x00000200&(data))>>9)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr3_shift                                        (8)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr3_mask                                         (0x00000100)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr3(data)                                        (0x00000100&((data)<<8))
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr3_src(data)                                    ((0x00000100&(data))>>8)
+#define DC_PHY_DC_DDR3_CTL_get_ddr3_exe_mr3(data)                                    ((0x00000100&(data))>>8)
+#define DC_PHY_DC_DDR3_CTL_write_en_3_shift                                          (7)
+#define DC_PHY_DC_DDR3_CTL_write_en_3_mask                                           (0x00000080)
+#define DC_PHY_DC_DDR3_CTL_write_en_3(data)                                          (0x00000080&((data)<<7))
+#define DC_PHY_DC_DDR3_CTL_write_en_3_src(data)                                      ((0x00000080&(data))>>7)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_3(data)                                      ((0x00000080&(data))>>7)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr2_shift                                        (6)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr2_mask                                         (0x00000040)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr2(data)                                        (0x00000040&((data)<<6))
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr2_src(data)                                    ((0x00000040&(data))>>6)
+#define DC_PHY_DC_DDR3_CTL_get_ddr3_exe_mr2(data)                                    ((0x00000040&(data))>>6)
+#define DC_PHY_DC_DDR3_CTL_write_en_2_shift                                          (5)
+#define DC_PHY_DC_DDR3_CTL_write_en_2_mask                                           (0x00000020)
+#define DC_PHY_DC_DDR3_CTL_write_en_2(data)                                          (0x00000020&((data)<<5))
+#define DC_PHY_DC_DDR3_CTL_write_en_2_src(data)                                      ((0x00000020&(data))>>5)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_2(data)                                      ((0x00000020&(data))>>5)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr1_shift                                        (4)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr1_mask                                         (0x00000010)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr1(data)                                        (0x00000010&((data)<<4))
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr1_src(data)                                    ((0x00000010&(data))>>4)
+#define DC_PHY_DC_DDR3_CTL_get_ddr3_exe_mr1(data)                                    ((0x00000010&(data))>>4)
+#define DC_PHY_DC_DDR3_CTL_write_en_1_shift                                          (3)
+#define DC_PHY_DC_DDR3_CTL_write_en_1_mask                                           (0x00000008)
+#define DC_PHY_DC_DDR3_CTL_write_en_1(data)                                          (0x00000008&((data)<<3))
+#define DC_PHY_DC_DDR3_CTL_write_en_1_src(data)                                      ((0x00000008&(data))>>3)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_1(data)                                      ((0x00000008&(data))>>3)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr0_shift                                        (2)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr0_mask                                         (0x00000004)
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr0(data)                                        (0x00000004&((data)<<2))
+#define DC_PHY_DC_DDR3_CTL_ddr3_exe_mr0_src(data)                                    ((0x00000004&(data))>>2)
+#define DC_PHY_DC_DDR3_CTL_get_ddr3_exe_mr0(data)                                    ((0x00000004&(data))>>2)
+#define DC_PHY_DC_DDR3_CTL_write_en_0_shift                                          (1)
+#define DC_PHY_DC_DDR3_CTL_write_en_0_mask                                           (0x00000002)
+#define DC_PHY_DC_DDR3_CTL_write_en_0(data)                                          (0x00000002&((data)<<1))
+#define DC_PHY_DC_DDR3_CTL_write_en_0_src(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_DC_DDR3_CTL_get_write_en_0(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_DC_DDR3_CTL_ddr3_init_shift                                           (0)
+#define DC_PHY_DC_DDR3_CTL_ddr3_init_mask                                            (0x00000001)
+#define DC_PHY_DC_DDR3_CTL_ddr3_init(data)                                           (0x00000001&((data)<<0))
+#define DC_PHY_DC_DDR3_CTL_ddr3_init_src(data)                                       ((0x00000001&(data))>>0)
+#define DC_PHY_DC_DDR3_CTL_get_ddr3_init(data)                                       ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_MOD_REG                                                               0x18008844
+#define DC_PHY_MOD_REG_reg_addr                                                      "0xB8008844"
+#define DC_PHY_MOD_REG_reg                                                           0xB8008844
+#define set_DC_PHY_MOD_REG_reg(data)   (*((volatile unsigned int*) DC_PHY_MOD_REG_reg)=data)
+#define get_DC_PHY_MOD_REG_reg   (*((volatile unsigned int*) DC_PHY_MOD_REG_reg))
+#define DC_PHY_MOD_REG_inst_adr                                                      "0x0011"
+#define DC_PHY_MOD_REG_inst                                                          0x0011
+#define DC_PHY_MOD_REG_exmod_reg_shift                                               (16)
+#define DC_PHY_MOD_REG_exmod_reg_mask                                                (0xFFFF0000)
+#define DC_PHY_MOD_REG_exmod_reg(data)                                               (0xFFFF0000&((data)<<16))
+#define DC_PHY_MOD_REG_exmod_reg_src(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_MOD_REG_get_exmod_reg(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_MOD_REG_mod_reg_shift                                                 (0)
+#define DC_PHY_MOD_REG_mod_reg_mask                                                  (0x0000FFFF)
+#define DC_PHY_MOD_REG_mod_reg(data)                                                 (0x0000FFFF&((data)<<0))
+#define DC_PHY_MOD_REG_mod_reg_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define DC_PHY_MOD_REG_get_mod_reg(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_MOD23_REG                                                             0x18008848
+#define DC_PHY_MOD23_REG_reg_addr                                                    "0xB8008848"
+#define DC_PHY_MOD23_REG_reg                                                         0xB8008848
+#define set_DC_PHY_MOD23_REG_reg(data)   (*((volatile unsigned int*) DC_PHY_MOD23_REG_reg)=data)
+#define get_DC_PHY_MOD23_REG_reg   (*((volatile unsigned int*) DC_PHY_MOD23_REG_reg))
+#define DC_PHY_MOD23_REG_inst_adr                                                    "0x0012"
+#define DC_PHY_MOD23_REG_inst                                                        0x0012
+#define DC_PHY_MOD23_REG_mod3_reg_shift                                              (16)
+#define DC_PHY_MOD23_REG_mod3_reg_mask                                               (0xFFFF0000)
+#define DC_PHY_MOD23_REG_mod3_reg(data)                                              (0xFFFF0000&((data)<<16))
+#define DC_PHY_MOD23_REG_mod3_reg_src(data)                                          ((0xFFFF0000&(data))>>16)
+#define DC_PHY_MOD23_REG_get_mod3_reg(data)                                          ((0xFFFF0000&(data))>>16)
+#define DC_PHY_MOD23_REG_mod2_reg_shift                                              (0)
+#define DC_PHY_MOD23_REG_mod2_reg_mask                                               (0x0000FFFF)
+#define DC_PHY_MOD23_REG_mod2_reg(data)                                              (0x0000FFFF&((data)<<0))
+#define DC_PHY_MOD23_REG_mod2_reg_src(data)                                          ((0x0000FFFF&(data))>>0)
+#define DC_PHY_MOD23_REG_get_mod2_reg(data)                                          ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_RFIFO_CTL                                                             0x1800884c
+#define DC_PHY_RFIFO_CTL_reg_addr                                                    "0xB800884C"
+#define DC_PHY_RFIFO_CTL_reg                                                         0xB800884C
+#define set_DC_PHY_RFIFO_CTL_reg(data)   (*((volatile unsigned int*) DC_PHY_RFIFO_CTL_reg)=data)
+#define get_DC_PHY_RFIFO_CTL_reg   (*((volatile unsigned int*) DC_PHY_RFIFO_CTL_reg))
+#define DC_PHY_RFIFO_CTL_inst_adr                                                    "0x0013"
+#define DC_PHY_RFIFO_CTL_inst                                                        0x0013
+#define DC_PHY_RFIFO_CTL_wfifo_rdy_gated_shift                                       (12)
+#define DC_PHY_RFIFO_CTL_wfifo_rdy_gated_mask                                        (0x00001000)
+#define DC_PHY_RFIFO_CTL_wfifo_rdy_gated(data)                                       (0x00001000&((data)<<12))
+#define DC_PHY_RFIFO_CTL_wfifo_rdy_gated_src(data)                                   ((0x00001000&(data))>>12)
+#define DC_PHY_RFIFO_CTL_get_wfifo_rdy_gated(data)                                   ((0x00001000&(data))>>12)
+#define DC_PHY_RFIFO_CTL_rdwr_use_full_shift                                         (8)
+#define DC_PHY_RFIFO_CTL_rdwr_use_full_mask                                          (0x00000100)
+#define DC_PHY_RFIFO_CTL_rdwr_use_full(data)                                         (0x00000100&((data)<<8))
+#define DC_PHY_RFIFO_CTL_rdwr_use_full_src(data)                                     ((0x00000100&(data))>>8)
+#define DC_PHY_RFIFO_CTL_get_rdwr_use_full(data)                                     ((0x00000100&(data))>>8)
+#define DC_PHY_RFIFO_CTL_full_gated_shift                                            (7)
+#define DC_PHY_RFIFO_CTL_full_gated_mask                                             (0x00000080)
+#define DC_PHY_RFIFO_CTL_full_gated(data)                                            (0x00000080&((data)<<7))
+#define DC_PHY_RFIFO_CTL_full_gated_src(data)                                        ((0x00000080&(data))>>7)
+#define DC_PHY_RFIFO_CTL_get_full_gated(data)                                        ((0x00000080&(data))>>7)
+#define DC_PHY_RFIFO_CTL_rfifo_thred_shift                                           (0)
+#define DC_PHY_RFIFO_CTL_rfifo_thred_mask                                            (0x0000007F)
+#define DC_PHY_RFIFO_CTL_rfifo_thred(data)                                           (0x0000007F&((data)<<0))
+#define DC_PHY_RFIFO_CTL_rfifo_thred_src(data)                                       ((0x0000007F&(data))>>0)
+#define DC_PHY_RFIFO_CTL_get_rfifo_thred(data)                                       ((0x0000007F&(data))>>0)
+
+
+#define DC_PHY_ERR_STATUS                                                            0x18008850
+#define DC_PHY_ERR_STATUS_reg_addr                                                   "0xB8008850"
+#define DC_PHY_ERR_STATUS_reg                                                        0xB8008850
+#define set_DC_PHY_ERR_STATUS_reg(data)   (*((volatile unsigned int*) DC_PHY_ERR_STATUS_reg)=data)
+#define get_DC_PHY_ERR_STATUS_reg   (*((volatile unsigned int*) DC_PHY_ERR_STATUS_reg))
+#define DC_PHY_ERR_STATUS_inst_adr                                                   "0x0014"
+#define DC_PHY_ERR_STATUS_inst                                                       0x0014
+#define DC_PHY_ERR_STATUS_err_cti_cmd_shift                                          (1)
+#define DC_PHY_ERR_STATUS_err_cti_cmd_mask                                           (0x00000002)
+#define DC_PHY_ERR_STATUS_err_cti_cmd(data)                                          (0x00000002&((data)<<1))
+#define DC_PHY_ERR_STATUS_err_cti_cmd_src(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_ERR_STATUS_get_err_cti_cmd(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_ERR_STATUS_err_active_shift                                           (0)
+#define DC_PHY_ERR_STATUS_err_active_mask                                            (0x00000001)
+#define DC_PHY_ERR_STATUS_err_active(data)                                           (0x00000001&((data)<<0))
+#define DC_PHY_ERR_STATUS_err_active_src(data)                                       ((0x00000001&(data))>>0)
+#define DC_PHY_ERR_STATUS_get_err_active(data)                                       ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_DC_WRITE_LEVEL                                                        0x18008854
+#define DC_PHY_DC_WRITE_LEVEL_reg_addr                                               "0xB8008854"
+#define DC_PHY_DC_WRITE_LEVEL_reg                                                    0xB8008854
+#define set_DC_PHY_DC_WRITE_LEVEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DC_WRITE_LEVEL_reg)=data)
+#define get_DC_PHY_DC_WRITE_LEVEL_reg   (*((volatile unsigned int*) DC_PHY_DC_WRITE_LEVEL_reg))
+#define DC_PHY_DC_WRITE_LEVEL_inst_adr                                               "0x0015"
+#define DC_PHY_DC_WRITE_LEVEL_inst                                                   0x0015
+#define DC_PHY_DC_WRITE_LEVEL_exe_prea_shift                                         (3)
+#define DC_PHY_DC_WRITE_LEVEL_exe_prea_mask                                          (0x00000008)
+#define DC_PHY_DC_WRITE_LEVEL_exe_prea(data)                                         (0x00000008&((data)<<3))
+#define DC_PHY_DC_WRITE_LEVEL_exe_prea_src(data)                                     ((0x00000008&(data))>>3)
+#define DC_PHY_DC_WRITE_LEVEL_get_exe_prea(data)                                     ((0x00000008&(data))>>3)
+#define DC_PHY_DC_WRITE_LEVEL_dis_refresh_shift                                      (2)
+#define DC_PHY_DC_WRITE_LEVEL_dis_refresh_mask                                       (0x00000004)
+#define DC_PHY_DC_WRITE_LEVEL_dis_refresh(data)                                      (0x00000004&((data)<<2))
+#define DC_PHY_DC_WRITE_LEVEL_dis_refresh_src(data)                                  ((0x00000004&(data))>>2)
+#define DC_PHY_DC_WRITE_LEVEL_get_dis_refresh(data)                                  ((0x00000004&(data))>>2)
+#define DC_PHY_DC_WRITE_LEVEL_trig_wr_level_shift                                    (1)
+#define DC_PHY_DC_WRITE_LEVEL_trig_wr_level_mask                                     (0x00000002)
+#define DC_PHY_DC_WRITE_LEVEL_trig_wr_level(data)                                    (0x00000002&((data)<<1))
+#define DC_PHY_DC_WRITE_LEVEL_trig_wr_level_src(data)                                ((0x00000002&(data))>>1)
+#define DC_PHY_DC_WRITE_LEVEL_get_trig_wr_level(data)                                ((0x00000002&(data))>>1)
+#define DC_PHY_DC_WRITE_LEVEL_wr_level_rdy_shift                                     (0)
+#define DC_PHY_DC_WRITE_LEVEL_wr_level_rdy_mask                                      (0x00000001)
+#define DC_PHY_DC_WRITE_LEVEL_wr_level_rdy(data)                                     (0x00000001&((data)<<0))
+#define DC_PHY_DC_WRITE_LEVEL_wr_level_rdy_src(data)                                 ((0x00000001&(data))>>0)
+#define DC_PHY_DC_WRITE_LEVEL_get_wr_level_rdy(data)                                 ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_INT_ENABLE                                                            0x18008858
+#define DC_PHY_INT_ENABLE_reg_addr                                                   "0xB8008858"
+#define DC_PHY_INT_ENABLE_reg                                                        0xB8008858
+#define set_DC_PHY_INT_ENABLE_reg(data)   (*((volatile unsigned int*) DC_PHY_INT_ENABLE_reg)=data)
+#define get_DC_PHY_INT_ENABLE_reg   (*((volatile unsigned int*) DC_PHY_INT_ENABLE_reg))
+#define DC_PHY_INT_ENABLE_inst_adr                                                   "0x0016"
+#define DC_PHY_INT_ENABLE_inst                                                       0x0016
+#define DC_PHY_INT_ENABLE_int_err_cticmd_en_shift                                    (4)
+#define DC_PHY_INT_ENABLE_int_err_cticmd_en_mask                                     (0x00000010)
+#define DC_PHY_INT_ENABLE_int_err_cticmd_en(data)                                    (0x00000010&((data)<<4))
+#define DC_PHY_INT_ENABLE_int_err_cticmd_en_src(data)                                ((0x00000010&(data))>>4)
+#define DC_PHY_INT_ENABLE_get_int_err_cticmd_en(data)                                ((0x00000010&(data))>>4)
+#define DC_PHY_INT_ENABLE_int_err_active_en_shift                                    (3)
+#define DC_PHY_INT_ENABLE_int_err_active_en_mask                                     (0x00000008)
+#define DC_PHY_INT_ENABLE_int_err_active_en(data)                                    (0x00000008&((data)<<3))
+#define DC_PHY_INT_ENABLE_int_err_active_en_src(data)                                ((0x00000008&(data))>>3)
+#define DC_PHY_INT_ENABLE_get_int_err_active_en(data)                                ((0x00000008&(data))>>3)
+#define DC_PHY_INT_ENABLE_int_vcpu_en_shift                                          (2)
+#define DC_PHY_INT_ENABLE_int_vcpu_en_mask                                           (0x00000004)
+#define DC_PHY_INT_ENABLE_int_vcpu_en(data)                                          (0x00000004&((data)<<2))
+#define DC_PHY_INT_ENABLE_int_vcpu_en_src(data)                                      ((0x00000004&(data))>>2)
+#define DC_PHY_INT_ENABLE_get_int_vcpu_en(data)                                      ((0x00000004&(data))>>2)
+#define DC_PHY_INT_ENABLE_int_acpu_en_shift                                          (1)
+#define DC_PHY_INT_ENABLE_int_acpu_en_mask                                           (0x00000002)
+#define DC_PHY_INT_ENABLE_int_acpu_en(data)                                          (0x00000002&((data)<<1))
+#define DC_PHY_INT_ENABLE_int_acpu_en_src(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_INT_ENABLE_get_int_acpu_en(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_INT_ENABLE_int_scpu_en_shift                                          (0)
+#define DC_PHY_INT_ENABLE_int_scpu_en_mask                                           (0x00000001)
+#define DC_PHY_INT_ENABLE_int_scpu_en(data)                                          (0x00000001&((data)<<0))
+#define DC_PHY_INT_ENABLE_int_scpu_en_src(data)                                      ((0x00000001&(data))>>0)
+#define DC_PHY_INT_ENABLE_get_int_scpu_en(data)                                      ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_RFIFO_MAXCNT                                                          0x1800885c
+#define DC_PHY_RFIFO_MAXCNT_reg_addr                                                 "0xB800885C"
+#define DC_PHY_RFIFO_MAXCNT_reg                                                      0xB800885C
+#define set_DC_PHY_RFIFO_MAXCNT_reg(data)   (*((volatile unsigned int*) DC_PHY_RFIFO_MAXCNT_reg)=data)
+#define get_DC_PHY_RFIFO_MAXCNT_reg   (*((volatile unsigned int*) DC_PHY_RFIFO_MAXCNT_reg))
+#define DC_PHY_RFIFO_MAXCNT_inst_adr                                                 "0x0017"
+#define DC_PHY_RFIFO_MAXCNT_inst                                                     0x0017
+#define DC_PHY_RFIFO_MAXCNT_non_valid_maxcnt_shift                                   (7)
+#define DC_PHY_RFIFO_MAXCNT_non_valid_maxcnt_mask                                    (0x00000080)
+#define DC_PHY_RFIFO_MAXCNT_non_valid_maxcnt(data)                                   (0x00000080&((data)<<7))
+#define DC_PHY_RFIFO_MAXCNT_non_valid_maxcnt_src(data)                               ((0x00000080&(data))>>7)
+#define DC_PHY_RFIFO_MAXCNT_get_non_valid_maxcnt(data)                               ((0x00000080&(data))>>7)
+#define DC_PHY_RFIFO_MAXCNT_rfifo_cnt_max_shift                                      (0)
+#define DC_PHY_RFIFO_MAXCNT_rfifo_cnt_max_mask                                       (0x0000007F)
+#define DC_PHY_RFIFO_MAXCNT_rfifo_cnt_max(data)                                      (0x0000007F&((data)<<0))
+#define DC_PHY_RFIFO_MAXCNT_rfifo_cnt_max_src(data)                                  ((0x0000007F&(data))>>0)
+#define DC_PHY_RFIFO_MAXCNT_get_rfifo_cnt_max(data)                                  ((0x0000007F&(data))>>0)
+
+
+#define DC_PHY_SM_STATUS                                                             0x18008860
+#define DC_PHY_SM_STATUS_reg_addr                                                    "0xB8008860"
+#define DC_PHY_SM_STATUS_reg                                                         0xB8008860
+#define set_DC_PHY_SM_STATUS_reg(data)   (*((volatile unsigned int*) DC_PHY_SM_STATUS_reg)=data)
+#define get_DC_PHY_SM_STATUS_reg   (*((volatile unsigned int*) DC_PHY_SM_STATUS_reg))
+#define DC_PHY_SM_STATUS_inst_adr                                                    "0x0018"
+#define DC_PHY_SM_STATUS_inst                                                        0x0018
+#define DC_PHY_SM_STATUS_par_st_1_shift                                              (21)
+#define DC_PHY_SM_STATUS_par_st_1_mask                                               (0x03E00000)
+#define DC_PHY_SM_STATUS_par_st_1(data)                                              (0x03E00000&((data)<<21))
+#define DC_PHY_SM_STATUS_par_st_1_src(data)                                          ((0x03E00000&(data))>>21)
+#define DC_PHY_SM_STATUS_get_par_st_1(data)                                          ((0x03E00000&(data))>>21)
+#define DC_PHY_SM_STATUS_bank_act_shift                                              (13)
+#define DC_PHY_SM_STATUS_bank_act_mask                                               (0x001FE000)
+#define DC_PHY_SM_STATUS_bank_act(data)                                              (0x001FE000&((data)<<13))
+#define DC_PHY_SM_STATUS_bank_act_src(data)                                          ((0x001FE000&(data))>>13)
+#define DC_PHY_SM_STATUS_get_bank_act(data)                                          ((0x001FE000&(data))>>13)
+#define DC_PHY_SM_STATUS_cmd_cnt_shift                                               (10)
+#define DC_PHY_SM_STATUS_cmd_cnt_mask                                                (0x00001C00)
+#define DC_PHY_SM_STATUS_cmd_cnt(data)                                               (0x00001C00&((data)<<10))
+#define DC_PHY_SM_STATUS_cmd_cnt_src(data)                                           ((0x00001C00&(data))>>10)
+#define DC_PHY_SM_STATUS_get_cmd_cnt(data)                                           ((0x00001C00&(data))>>10)
+#define DC_PHY_SM_STATUS_par_st_shift                                                (0)
+#define DC_PHY_SM_STATUS_par_st_mask                                                 (0x000003FF)
+#define DC_PHY_SM_STATUS_par_st(data)                                                (0x000003FF&((data)<<0))
+#define DC_PHY_SM_STATUS_par_st_src(data)                                            ((0x000003FF&(data))>>0)
+#define DC_PHY_SM_STATUS_get_par_st(data)                                            ((0x000003FF&(data))>>0)
+
+
+#define DC_PHY_WFIFO_CNT                                                             0x18008864
+#define DC_PHY_WFIFO_CNT_reg_addr                                                    "0xB8008864"
+#define DC_PHY_WFIFO_CNT_reg                                                         0xB8008864
+#define set_DC_PHY_WFIFO_CNT_reg(data)   (*((volatile unsigned int*) DC_PHY_WFIFO_CNT_reg)=data)
+#define get_DC_PHY_WFIFO_CNT_reg   (*((volatile unsigned int*) DC_PHY_WFIFO_CNT_reg))
+#define DC_PHY_WFIFO_CNT_inst_adr                                                    "0x0019"
+#define DC_PHY_WFIFO_CNT_inst                                                        0x0019
+#define DC_PHY_WFIFO_CNT_wfifo_sys_req_statistic_en_shift                            (31)
+#define DC_PHY_WFIFO_CNT_wfifo_sys_req_statistic_en_mask                             (0x80000000)
+#define DC_PHY_WFIFO_CNT_wfifo_sys_req_statistic_en(data)                            (0x80000000&((data)<<31))
+#define DC_PHY_WFIFO_CNT_wfifo_sys_req_statistic_en_src(data)                        ((0x80000000&(data))>>31)
+#define DC_PHY_WFIFO_CNT_get_wfifo_sys_req_statistic_en(data)                        ((0x80000000&(data))>>31)
+#define DC_PHY_WFIFO_CNT_wfifo_ddr_req_statistic_en_shift                            (30)
+#define DC_PHY_WFIFO_CNT_wfifo_ddr_req_statistic_en_mask                             (0x40000000)
+#define DC_PHY_WFIFO_CNT_wfifo_ddr_req_statistic_en(data)                            (0x40000000&((data)<<30))
+#define DC_PHY_WFIFO_CNT_wfifo_ddr_req_statistic_en_src(data)                        ((0x40000000&(data))>>30)
+#define DC_PHY_WFIFO_CNT_get_wfifo_ddr_req_statistic_en(data)                        ((0x40000000&(data))>>30)
+#define DC_PHY_WFIFO_CNT_clear_wfifo_record_shift                                    (29)
+#define DC_PHY_WFIFO_CNT_clear_wfifo_record_mask                                     (0x20000000)
+#define DC_PHY_WFIFO_CNT_clear_wfifo_record(data)                                    (0x20000000&((data)<<29))
+#define DC_PHY_WFIFO_CNT_clear_wfifo_record_src(data)                                ((0x20000000&(data))>>29)
+#define DC_PHY_WFIFO_CNT_get_clear_wfifo_record(data)                                ((0x20000000&(data))>>29)
+#define DC_PHY_WFIFO_CNT_wfifo_rd_cnt_et_shift                                       (16)
+#define DC_PHY_WFIFO_CNT_wfifo_rd_cnt_et_mask                                        (0x00FF0000)
+#define DC_PHY_WFIFO_CNT_wfifo_rd_cnt_et(data)                                       (0x00FF0000&((data)<<16))
+#define DC_PHY_WFIFO_CNT_wfifo_rd_cnt_et_src(data)                                   ((0x00FF0000&(data))>>16)
+#define DC_PHY_WFIFO_CNT_get_wfifo_rd_cnt_et(data)                                   ((0x00FF0000&(data))>>16)
+#define DC_PHY_WFIFO_CNT_wfifo_rd_cnt_rl_shift                                       (8)
+#define DC_PHY_WFIFO_CNT_wfifo_rd_cnt_rl_mask                                        (0x0000FF00)
+#define DC_PHY_WFIFO_CNT_wfifo_rd_cnt_rl(data)                                       (0x0000FF00&((data)<<8))
+#define DC_PHY_WFIFO_CNT_wfifo_rd_cnt_rl_src(data)                                   ((0x0000FF00&(data))>>8)
+#define DC_PHY_WFIFO_CNT_get_wfifo_rd_cnt_rl(data)                                   ((0x0000FF00&(data))>>8)
+#define DC_PHY_WFIFO_CNT_wfifo_wr_cnt_rl_shift                                       (0)
+#define DC_PHY_WFIFO_CNT_wfifo_wr_cnt_rl_mask                                        (0x000000FF)
+#define DC_PHY_WFIFO_CNT_wfifo_wr_cnt_rl(data)                                       (0x000000FF&((data)<<0))
+#define DC_PHY_WFIFO_CNT_wfifo_wr_cnt_rl_src(data)                                   ((0x000000FF&(data))>>0)
+#define DC_PHY_WFIFO_CNT_get_wfifo_wr_cnt_rl(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define DC_PHY_DC_DEBUG                                                              0x18008868
+#define DC_PHY_DC_DEBUG_reg_addr                                                     "0xB8008868"
+#define DC_PHY_DC_DEBUG_reg                                                          0xB8008868
+#define set_DC_PHY_DC_DEBUG_reg(data)   (*((volatile unsigned int*) DC_PHY_DC_DEBUG_reg)=data)
+#define get_DC_PHY_DC_DEBUG_reg   (*((volatile unsigned int*) DC_PHY_DC_DEBUG_reg))
+#define DC_PHY_DC_DEBUG_inst_adr                                                     "0x001A"
+#define DC_PHY_DC_DEBUG_inst                                                         0x001A
+#define DC_PHY_DC_DEBUG_io_blk_dbg_mode_shift                                        (24)
+#define DC_PHY_DC_DEBUG_io_blk_dbg_mode_mask                                         (0x07000000)
+#define DC_PHY_DC_DEBUG_io_blk_dbg_mode(data)                                        (0x07000000&((data)<<24))
+#define DC_PHY_DC_DEBUG_io_blk_dbg_mode_src(data)                                    ((0x07000000&(data))>>24)
+#define DC_PHY_DC_DEBUG_get_io_blk_dbg_mode(data)                                    ((0x07000000&(data))>>24)
+#define DC_PHY_DC_DEBUG_dbg_out_mod_shift                                            (20)
+#define DC_PHY_DC_DEBUG_dbg_out_mod_mask                                             (0x00700000)
+#define DC_PHY_DC_DEBUG_dbg_out_mod(data)                                            (0x00700000&((data)<<20))
+#define DC_PHY_DC_DEBUG_dbg_out_mod_src(data)                                        ((0x00700000&(data))>>20)
+#define DC_PHY_DC_DEBUG_get_dbg_out_mod(data)                                        ((0x00700000&(data))>>20)
+#define DC_PHY_DC_DEBUG_pad_tie_value_shift                                          (16)
+#define DC_PHY_DC_DEBUG_pad_tie_value_mask                                           (0x000F0000)
+#define DC_PHY_DC_DEBUG_pad_tie_value(data)                                          (0x000F0000&((data)<<16))
+#define DC_PHY_DC_DEBUG_pad_tie_value_src(data)                                      ((0x000F0000&(data))>>16)
+#define DC_PHY_DC_DEBUG_get_pad_tie_value(data)                                      ((0x000F0000&(data))>>16)
+#define DC_PHY_DC_DEBUG_shift_trig_mode_shift                                        (9)
+#define DC_PHY_DC_DEBUG_shift_trig_mode_mask                                         (0x0000FE00)
+#define DC_PHY_DC_DEBUG_shift_trig_mode(data)                                        (0x0000FE00&((data)<<9))
+#define DC_PHY_DC_DEBUG_shift_trig_mode_src(data)                                    ((0x0000FE00&(data))>>9)
+#define DC_PHY_DC_DEBUG_get_shift_trig_mode(data)                                    ((0x0000FE00&(data))>>9)
+#define DC_PHY_DC_DEBUG_rd_dbg_mod_shift                                             (6)
+#define DC_PHY_DC_DEBUG_rd_dbg_mod_mask                                              (0x000001C0)
+#define DC_PHY_DC_DEBUG_rd_dbg_mod(data)                                             (0x000001C0&((data)<<6))
+#define DC_PHY_DC_DEBUG_rd_dbg_mod_src(data)                                         ((0x000001C0&(data))>>6)
+#define DC_PHY_DC_DEBUG_get_rd_dbg_mod(data)                                         ((0x000001C0&(data))>>6)
+#define DC_PHY_DC_DEBUG_dbg_mod_shift                                                (0)
+#define DC_PHY_DC_DEBUG_dbg_mod_mask                                                 (0x0000003F)
+#define DC_PHY_DC_DEBUG_dbg_mod(data)                                                (0x0000003F&((data)<<0))
+#define DC_PHY_DC_DEBUG_dbg_mod_src(data)                                            ((0x0000003F&(data))>>0)
+#define DC_PHY_DC_DEBUG_get_dbg_mod(data)                                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_PRE_CNT                                                               0x1800886C
+#define DC_PHY_PRE_CNT_reg_addr                                                      "0xB800886C"
+#define DC_PHY_PRE_CNT_reg                                                           0xB800886C
+#define set_DC_PHY_PRE_CNT_reg(data)   (*((volatile unsigned int*) DC_PHY_PRE_CNT_reg)=data)
+#define get_DC_PHY_PRE_CNT_reg   (*((volatile unsigned int*) DC_PHY_PRE_CNT_reg))
+#define DC_PHY_PRE_CNT_inst_adr                                                      "0x001B"
+#define DC_PHY_PRE_CNT_inst                                                          0x001B
+#define DC_PHY_PRE_CNT_post_trig_cnt_shift                                           (16)
+#define DC_PHY_PRE_CNT_post_trig_cnt_mask                                            (0xFFFF0000)
+#define DC_PHY_PRE_CNT_post_trig_cnt(data)                                           (0xFFFF0000&((data)<<16))
+#define DC_PHY_PRE_CNT_post_trig_cnt_src(data)                                       ((0xFFFF0000&(data))>>16)
+#define DC_PHY_PRE_CNT_get_post_trig_cnt(data)                                       ((0xFFFF0000&(data))>>16)
+#define DC_PHY_PRE_CNT_pre_trig_cnt_shift                                            (0)
+#define DC_PHY_PRE_CNT_pre_trig_cnt_mask                                             (0x0000FFFF)
+#define DC_PHY_PRE_CNT_pre_trig_cnt(data)                                            (0x0000FFFF&((data)<<0))
+#define DC_PHY_PRE_CNT_pre_trig_cnt_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define DC_PHY_PRE_CNT_get_pre_trig_cnt(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_WFIFO_SYS_REQ_WAIT                                                    0x18008870
+#define DC_PHY_WFIFO_SYS_REQ_WAIT_reg_addr                                           "0xB8008870"
+#define DC_PHY_WFIFO_SYS_REQ_WAIT_reg                                                0xB8008870
+#define set_DC_PHY_WFIFO_SYS_REQ_WAIT_reg(data)   (*((volatile unsigned int*) DC_PHY_WFIFO_SYS_REQ_WAIT_reg)=data)
+#define get_DC_PHY_WFIFO_SYS_REQ_WAIT_reg   (*((volatile unsigned int*) DC_PHY_WFIFO_SYS_REQ_WAIT_reg))
+#define DC_PHY_WFIFO_SYS_REQ_WAIT_inst_adr                                           "0x001C"
+#define DC_PHY_WFIFO_SYS_REQ_WAIT_inst                                               0x001C
+#define DC_PHY_WFIFO_SYS_REQ_WAIT_wfifo_sys_req_wait_total_shift                     (0)
+#define DC_PHY_WFIFO_SYS_REQ_WAIT_wfifo_sys_req_wait_total_mask                      (0xFFFFFFFF)
+#define DC_PHY_WFIFO_SYS_REQ_WAIT_wfifo_sys_req_wait_total(data)                     (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_WFIFO_SYS_REQ_WAIT_wfifo_sys_req_wait_total_src(data)                 ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_WFIFO_SYS_REQ_WAIT_get_wfifo_sys_req_wait_total(data)                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_WFIFO_DDR_REQ_WAIT                                                    0x18008874
+#define DC_PHY_WFIFO_DDR_REQ_WAIT_reg_addr                                           "0xB8008874"
+#define DC_PHY_WFIFO_DDR_REQ_WAIT_reg                                                0xB8008874
+#define set_DC_PHY_WFIFO_DDR_REQ_WAIT_reg(data)   (*((volatile unsigned int*) DC_PHY_WFIFO_DDR_REQ_WAIT_reg)=data)
+#define get_DC_PHY_WFIFO_DDR_REQ_WAIT_reg   (*((volatile unsigned int*) DC_PHY_WFIFO_DDR_REQ_WAIT_reg))
+#define DC_PHY_WFIFO_DDR_REQ_WAIT_inst_adr                                           "0x001D"
+#define DC_PHY_WFIFO_DDR_REQ_WAIT_inst                                               0x001D
+#define DC_PHY_WFIFO_DDR_REQ_WAIT_wfifo_ddr_req_wait_total_shift                     (0)
+#define DC_PHY_WFIFO_DDR_REQ_WAIT_wfifo_ddr_req_wait_total_mask                      (0xFFFFFFFF)
+#define DC_PHY_WFIFO_DDR_REQ_WAIT_wfifo_ddr_req_wait_total(data)                     (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_WFIFO_DDR_REQ_WAIT_wfifo_ddr_req_wait_total_src(data)                 ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_WFIFO_DDR_REQ_WAIT_get_wfifo_ddr_req_wait_total(data)                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_WFIFO_MAX_REQ_WAIT                                                    0x18008878
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_reg_addr                                           "0xB8008878"
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_reg                                                0xB8008878
+#define set_DC_PHY_WFIFO_MAX_REQ_WAIT_reg(data)   (*((volatile unsigned int*) DC_PHY_WFIFO_MAX_REQ_WAIT_reg)=data)
+#define get_DC_PHY_WFIFO_MAX_REQ_WAIT_reg   (*((volatile unsigned int*) DC_PHY_WFIFO_MAX_REQ_WAIT_reg))
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_inst_adr                                           "0x001E"
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_inst                                               0x001E
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_wfifo_ddr_req_wait_max_shift                       (16)
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_wfifo_ddr_req_wait_max_mask                        (0xFFFF0000)
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_wfifo_ddr_req_wait_max(data)                       (0xFFFF0000&((data)<<16))
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_wfifo_ddr_req_wait_max_src(data)                   ((0xFFFF0000&(data))>>16)
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_get_wfifo_ddr_req_wait_max(data)                   ((0xFFFF0000&(data))>>16)
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_wfifo_sys_req_wait_max_shift                       (0)
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_wfifo_sys_req_wait_max_mask                        (0x0000FFFF)
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_wfifo_sys_req_wait_max(data)                       (0x0000FFFF&((data)<<0))
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_wfifo_sys_req_wait_max_src(data)                   ((0x0000FFFF&(data))>>0)
+#define DC_PHY_WFIFO_MAX_REQ_WAIT_get_wfifo_sys_req_wait_max(data)                   ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_DC_WRITE_LEVEL_DQ                                                     0x1800887c
+#define DC_PHY_DC_WRITE_LEVEL_DQ_reg_addr                                            "0xB800887C"
+#define DC_PHY_DC_WRITE_LEVEL_DQ_reg                                                 0xB800887C
+#define set_DC_PHY_DC_WRITE_LEVEL_DQ_reg(data)   (*((volatile unsigned int*) DC_PHY_DC_WRITE_LEVEL_DQ_reg)=data)
+#define get_DC_PHY_DC_WRITE_LEVEL_DQ_reg   (*((volatile unsigned int*) DC_PHY_DC_WRITE_LEVEL_DQ_reg))
+#define DC_PHY_DC_WRITE_LEVEL_DQ_inst_adr                                            "0x001F"
+#define DC_PHY_DC_WRITE_LEVEL_DQ_inst                                                0x001F
+#define DC_PHY_DC_WRITE_LEVEL_DQ_wr_level_rdata_shift                                (0)
+#define DC_PHY_DC_WRITE_LEVEL_DQ_wr_level_rdata_mask                                 (0xFFFFFFFF)
+#define DC_PHY_DC_WRITE_LEVEL_DQ_wr_level_rdata(data)                                (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DC_WRITE_LEVEL_DQ_wr_level_rdata_src(data)                            ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DC_WRITE_LEVEL_DQ_get_wr_level_rdata(data)                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DQ0_1_DLYN                                                            0x18008880
+#define DC_PHY_DQ0_1_DLYN_reg_addr                                                   "0xB8008880"
+#define DC_PHY_DQ0_1_DLYN_reg                                                        0xB8008880
+#define set_DC_PHY_DQ0_1_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ0_1_DLYN_reg)=data)
+#define get_DC_PHY_DQ0_1_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ0_1_DLYN_reg))
+#define DC_PHY_DQ0_1_DLYN_inst_adr                                                   "0x0020"
+#define DC_PHY_DQ0_1_DLYN_inst                                                       0x0020
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_neg_1_0_shift                                    (22)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_neg_1_0_mask                                     (0x0FC00000)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_neg_1_0(data)                                    (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_neg_1_0_src(data)                                ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ0_1_DLYN_get_ph_sel_dq_neg_1_0(data)                                ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_pos_1_0_shift                                    (16)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_pos_1_0_mask                                     (0x003F0000)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_pos_1_0(data)                                    (0x003F0000&((data)<<16))
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_pos_1_0_src(data)                                ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ0_1_DLYN_get_ph_sel_dq_pos_1_0(data)                                ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_neg_0_0_shift                                    (6)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_neg_0_0_mask                                     (0x00000FC0)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_neg_0_0(data)                                    (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_neg_0_0_src(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ0_1_DLYN_get_ph_sel_dq_neg_0_0(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_pos_0_0_shift                                    (0)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_pos_0_0_mask                                     (0x0000003F)
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_pos_0_0(data)                                    (0x0000003F&((data)<<0))
+#define DC_PHY_DQ0_1_DLYN_ph_sel_dq_pos_0_0_src(data)                                ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ0_1_DLYN_get_ph_sel_dq_pos_0_0(data)                                ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ2_3_DLYN                                                            0x18008884
+#define DC_PHY_DQ2_3_DLYN_reg_addr                                                   "0xB8008884"
+#define DC_PHY_DQ2_3_DLYN_reg                                                        0xB8008884
+#define set_DC_PHY_DQ2_3_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ2_3_DLYN_reg)=data)
+#define get_DC_PHY_DQ2_3_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ2_3_DLYN_reg))
+#define DC_PHY_DQ2_3_DLYN_inst_adr                                                   "0x0021"
+#define DC_PHY_DQ2_3_DLYN_inst                                                       0x0021
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_neg_3_0_shift                                    (22)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_neg_3_0_mask                                     (0x0FC00000)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_neg_3_0(data)                                    (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_neg_3_0_src(data)                                ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ2_3_DLYN_get_ph_sel_dq_neg_3_0(data)                                ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_pos_3_0_shift                                    (16)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_pos_3_0_mask                                     (0x003F0000)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_pos_3_0(data)                                    (0x003F0000&((data)<<16))
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_pos_3_0_src(data)                                ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ2_3_DLYN_get_ph_sel_dq_pos_3_0(data)                                ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_neg_2_0_shift                                    (6)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_neg_2_0_mask                                     (0x00000FC0)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_neg_2_0(data)                                    (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_neg_2_0_src(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ2_3_DLYN_get_ph_sel_dq_neg_2_0(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_pos_2_0_shift                                    (0)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_pos_2_0_mask                                     (0x0000003F)
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_pos_2_0(data)                                    (0x0000003F&((data)<<0))
+#define DC_PHY_DQ2_3_DLYN_ph_sel_dq_pos_2_0_src(data)                                ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ2_3_DLYN_get_ph_sel_dq_pos_2_0(data)                                ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ4_5_DLYN                                                            0x18008888
+#define DC_PHY_DQ4_5_DLYN_reg_addr                                                   "0xB8008888"
+#define DC_PHY_DQ4_5_DLYN_reg                                                        0xB8008888
+#define set_DC_PHY_DQ4_5_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ4_5_DLYN_reg)=data)
+#define get_DC_PHY_DQ4_5_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ4_5_DLYN_reg))
+#define DC_PHY_DQ4_5_DLYN_inst_adr                                                   "0x0022"
+#define DC_PHY_DQ4_5_DLYN_inst                                                       0x0022
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_neg_5_0_shift                                    (22)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_neg_5_0_mask                                     (0x0FC00000)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_neg_5_0(data)                                    (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_neg_5_0_src(data)                                ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ4_5_DLYN_get_ph_sel_dq_neg_5_0(data)                                ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_pos_5_0_shift                                    (16)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_pos_5_0_mask                                     (0x003F0000)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_pos_5_0(data)                                    (0x003F0000&((data)<<16))
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_pos_5_0_src(data)                                ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ4_5_DLYN_get_ph_sel_dq_pos_5_0(data)                                ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_neg_4_0_shift                                    (6)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_neg_4_0_mask                                     (0x00000FC0)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_neg_4_0(data)                                    (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_neg_4_0_src(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ4_5_DLYN_get_ph_sel_dq_neg_4_0(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_pos_4_0_shift                                    (0)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_pos_4_0_mask                                     (0x0000003F)
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_pos_4_0(data)                                    (0x0000003F&((data)<<0))
+#define DC_PHY_DQ4_5_DLYN_ph_sel_dq_pos_4_0_src(data)                                ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ4_5_DLYN_get_ph_sel_dq_pos_4_0(data)                                ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ6_7_DLYN                                                            0x1800888C
+#define DC_PHY_DQ6_7_DLYN_reg_addr                                                   "0xB800888C"
+#define DC_PHY_DQ6_7_DLYN_reg                                                        0xB800888C
+#define set_DC_PHY_DQ6_7_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ6_7_DLYN_reg)=data)
+#define get_DC_PHY_DQ6_7_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ6_7_DLYN_reg))
+#define DC_PHY_DQ6_7_DLYN_inst_adr                                                   "0x0023"
+#define DC_PHY_DQ6_7_DLYN_inst                                                       0x0023
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_neg_7_0_shift                                    (22)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_neg_7_0_mask                                     (0x0FC00000)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_neg_7_0(data)                                    (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_neg_7_0_src(data)                                ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ6_7_DLYN_get_ph_sel_dq_neg_7_0(data)                                ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_pos_7_0_shift                                    (16)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_pos_7_0_mask                                     (0x003F0000)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_pos_7_0(data)                                    (0x003F0000&((data)<<16))
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_pos_7_0_src(data)                                ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ6_7_DLYN_get_ph_sel_dq_pos_7_0(data)                                ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_neg_6_0_shift                                    (6)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_neg_6_0_mask                                     (0x00000FC0)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_neg_6_0(data)                                    (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_neg_6_0_src(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ6_7_DLYN_get_ph_sel_dq_neg_6_0(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_pos_6_0_shift                                    (0)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_pos_6_0_mask                                     (0x0000003F)
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_pos_6_0(data)                                    (0x0000003F&((data)<<0))
+#define DC_PHY_DQ6_7_DLYN_ph_sel_dq_pos_6_0_src(data)                                ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ6_7_DLYN_get_ph_sel_dq_pos_6_0(data)                                ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ8_9_DLYN                                                            0x18008890
+#define DC_PHY_DQ8_9_DLYN_reg_addr                                                   "0xB8008890"
+#define DC_PHY_DQ8_9_DLYN_reg                                                        0xB8008890
+#define set_DC_PHY_DQ8_9_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ8_9_DLYN_reg)=data)
+#define get_DC_PHY_DQ8_9_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ8_9_DLYN_reg))
+#define DC_PHY_DQ8_9_DLYN_inst_adr                                                   "0x0024"
+#define DC_PHY_DQ8_9_DLYN_inst                                                       0x0024
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_neg_1_1_shift                                    (22)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_neg_1_1_mask                                     (0x0FC00000)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_neg_1_1(data)                                    (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_neg_1_1_src(data)                                ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ8_9_DLYN_get_ph_sel_dq_neg_1_1(data)                                ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_pos_1_1_shift                                    (16)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_pos_1_1_mask                                     (0x003F0000)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_pos_1_1(data)                                    (0x003F0000&((data)<<16))
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_pos_1_1_src(data)                                ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ8_9_DLYN_get_ph_sel_dq_pos_1_1(data)                                ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_neg_0_1_shift                                    (6)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_neg_0_1_mask                                     (0x00000FC0)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_neg_0_1(data)                                    (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_neg_0_1_src(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ8_9_DLYN_get_ph_sel_dq_neg_0_1(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_pos_0_1_shift                                    (0)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_pos_0_1_mask                                     (0x0000003F)
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_pos_0_1(data)                                    (0x0000003F&((data)<<0))
+#define DC_PHY_DQ8_9_DLYN_ph_sel_dq_pos_0_1_src(data)                                ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ8_9_DLYN_get_ph_sel_dq_pos_0_1(data)                                ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ10_11_DLYN                                                          0x18008894
+#define DC_PHY_DQ10_11_DLYN_reg_addr                                                 "0xB8008894"
+#define DC_PHY_DQ10_11_DLYN_reg                                                      0xB8008894
+#define set_DC_PHY_DQ10_11_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ10_11_DLYN_reg)=data)
+#define get_DC_PHY_DQ10_11_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ10_11_DLYN_reg))
+#define DC_PHY_DQ10_11_DLYN_inst_adr                                                 "0x0025"
+#define DC_PHY_DQ10_11_DLYN_inst                                                     0x0025
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_neg_3_1_shift                                  (22)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_neg_3_1_mask                                   (0x0FC00000)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_neg_3_1(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_neg_3_1_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ10_11_DLYN_get_ph_sel_dq_neg_3_1(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_pos_3_1_shift                                  (16)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_pos_3_1_mask                                   (0x003F0000)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_pos_3_1(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_pos_3_1_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ10_11_DLYN_get_ph_sel_dq_pos_3_1(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_neg_2_1_shift                                  (6)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_neg_2_1_mask                                   (0x00000FC0)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_neg_2_1(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_neg_2_1_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ10_11_DLYN_get_ph_sel_dq_neg_2_1(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_pos_2_1_shift                                  (0)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_pos_2_1_mask                                   (0x0000003F)
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_pos_2_1(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ10_11_DLYN_ph_sel_dq_pos_2_1_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ10_11_DLYN_get_ph_sel_dq_pos_2_1(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ12_13_DLYN                                                          0x1800889C
+#define DC_PHY_DQ12_13_DLYN_reg_addr                                                 "0xB800889C"
+#define DC_PHY_DQ12_13_DLYN_reg                                                      0xB800889C
+#define set_DC_PHY_DQ12_13_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ12_13_DLYN_reg)=data)
+#define get_DC_PHY_DQ12_13_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ12_13_DLYN_reg))
+#define DC_PHY_DQ12_13_DLYN_inst_adr                                                 "0x0027"
+#define DC_PHY_DQ12_13_DLYN_inst                                                     0x0027
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_neg_5_1_shift                                  (22)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_neg_5_1_mask                                   (0x0FC00000)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_neg_5_1(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_neg_5_1_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ12_13_DLYN_get_ph_sel_dq_neg_5_1(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_pos_5_1_shift                                  (16)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_pos_5_1_mask                                   (0x003F0000)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_pos_5_1(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_pos_5_1_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ12_13_DLYN_get_ph_sel_dq_pos_5_1(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_neg_4_1_shift                                  (6)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_neg_4_1_mask                                   (0x00000FC0)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_neg_4_1(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_neg_4_1_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ12_13_DLYN_get_ph_sel_dq_neg_4_1(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_pos_4_1_shift                                  (0)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_pos_4_1_mask                                   (0x0000003F)
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_pos_4_1(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ12_13_DLYN_ph_sel_dq_pos_4_1_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ12_13_DLYN_get_ph_sel_dq_pos_4_1(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ14_15_DLYN                                                          0x180088A0
+#define DC_PHY_DQ14_15_DLYN_reg_addr                                                 "0xB80088A0"
+#define DC_PHY_DQ14_15_DLYN_reg                                                      0xB80088A0
+#define set_DC_PHY_DQ14_15_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ14_15_DLYN_reg)=data)
+#define get_DC_PHY_DQ14_15_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ14_15_DLYN_reg))
+#define DC_PHY_DQ14_15_DLYN_inst_adr                                                 "0x0028"
+#define DC_PHY_DQ14_15_DLYN_inst                                                     0x0028
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_neg_7_1_shift                                  (22)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_neg_7_1_mask                                   (0x0FC00000)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_neg_7_1(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_neg_7_1_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ14_15_DLYN_get_ph_sel_dq_neg_7_1(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_pos_7_1_shift                                  (16)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_pos_7_1_mask                                   (0x003F0000)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_pos_7_1(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_pos_7_1_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ14_15_DLYN_get_ph_sel_dq_pos_7_1(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_neg_6_1_shift                                  (6)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_neg_6_1_mask                                   (0x00000FC0)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_neg_6_1(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_neg_6_1_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ14_15_DLYN_get_ph_sel_dq_neg_6_1(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_pos_6_1_shift                                  (0)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_pos_6_1_mask                                   (0x0000003F)
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_pos_6_1(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ14_15_DLYN_ph_sel_dq_pos_6_1_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ14_15_DLYN_get_ph_sel_dq_pos_6_1(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ16_17_DLYN                                                          0x180088A4
+#define DC_PHY_DQ16_17_DLYN_reg_addr                                                 "0xB80088A4"
+#define DC_PHY_DQ16_17_DLYN_reg                                                      0xB80088A4
+#define set_DC_PHY_DQ16_17_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ16_17_DLYN_reg)=data)
+#define get_DC_PHY_DQ16_17_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ16_17_DLYN_reg))
+#define DC_PHY_DQ16_17_DLYN_inst_adr                                                 "0x0029"
+#define DC_PHY_DQ16_17_DLYN_inst                                                     0x0029
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_neg_1_2_shift                                  (22)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_neg_1_2_mask                                   (0x0FC00000)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_neg_1_2(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_neg_1_2_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ16_17_DLYN_get_ph_sel_dq_neg_1_2(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_pos_1_2_shift                                  (16)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_pos_1_2_mask                                   (0x003F0000)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_pos_1_2(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_pos_1_2_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ16_17_DLYN_get_ph_sel_dq_pos_1_2(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_neg_0_2_shift                                  (6)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_neg_0_2_mask                                   (0x00000FC0)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_neg_0_2(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_neg_0_2_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ16_17_DLYN_get_ph_sel_dq_neg_0_2(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_pos_0_2_shift                                  (0)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_pos_0_2_mask                                   (0x0000003F)
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_pos_0_2(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ16_17_DLYN_ph_sel_dq_pos_0_2_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ16_17_DLYN_get_ph_sel_dq_pos_0_2(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ18_19_DLYN                                                          0x180088A8
+#define DC_PHY_DQ18_19_DLYN_reg_addr                                                 "0xB80088A8"
+#define DC_PHY_DQ18_19_DLYN_reg                                                      0xB80088A8
+#define set_DC_PHY_DQ18_19_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ18_19_DLYN_reg)=data)
+#define get_DC_PHY_DQ18_19_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ18_19_DLYN_reg))
+#define DC_PHY_DQ18_19_DLYN_inst_adr                                                 "0x002A"
+#define DC_PHY_DQ18_19_DLYN_inst                                                     0x002A
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_neg_3_2_shift                                  (22)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_neg_3_2_mask                                   (0x0FC00000)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_neg_3_2(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_neg_3_2_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ18_19_DLYN_get_ph_sel_dq_neg_3_2(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_pos_3_2_shift                                  (16)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_pos_3_2_mask                                   (0x003F0000)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_pos_3_2(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_pos_3_2_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ18_19_DLYN_get_ph_sel_dq_pos_3_2(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_neg_2_2_shift                                  (6)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_neg_2_2_mask                                   (0x00000FC0)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_neg_2_2(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_neg_2_2_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ18_19_DLYN_get_ph_sel_dq_neg_2_2(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_pos_2_2_shift                                  (0)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_pos_2_2_mask                                   (0x0000003F)
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_pos_2_2(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ18_19_DLYN_ph_sel_dq_pos_2_2_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ18_19_DLYN_get_ph_sel_dq_pos_2_2(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ20_21_DLYN                                                          0x180088AC
+#define DC_PHY_DQ20_21_DLYN_reg_addr                                                 "0xB80088AC"
+#define DC_PHY_DQ20_21_DLYN_reg                                                      0xB80088AC
+#define set_DC_PHY_DQ20_21_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ20_21_DLYN_reg)=data)
+#define get_DC_PHY_DQ20_21_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ20_21_DLYN_reg))
+#define DC_PHY_DQ20_21_DLYN_inst_adr                                                 "0x002B"
+#define DC_PHY_DQ20_21_DLYN_inst                                                     0x002B
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_neg_5_2_shift                                  (22)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_neg_5_2_mask                                   (0x0FC00000)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_neg_5_2(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_neg_5_2_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ20_21_DLYN_get_ph_sel_dq_neg_5_2(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_pos_5_2_shift                                  (16)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_pos_5_2_mask                                   (0x003F0000)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_pos_5_2(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_pos_5_2_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ20_21_DLYN_get_ph_sel_dq_pos_5_2(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_neg_4_2_shift                                  (6)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_neg_4_2_mask                                   (0x00000FC0)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_neg_4_2(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_neg_4_2_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ20_21_DLYN_get_ph_sel_dq_neg_4_2(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_pos_4_2_shift                                  (0)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_pos_4_2_mask                                   (0x0000003F)
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_pos_4_2(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ20_21_DLYN_ph_sel_dq_pos_4_2_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ20_21_DLYN_get_ph_sel_dq_pos_4_2(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ22_23_DLYN                                                          0x180088B0
+#define DC_PHY_DQ22_23_DLYN_reg_addr                                                 "0xB80088B0"
+#define DC_PHY_DQ22_23_DLYN_reg                                                      0xB80088B0
+#define set_DC_PHY_DQ22_23_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ22_23_DLYN_reg)=data)
+#define get_DC_PHY_DQ22_23_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ22_23_DLYN_reg))
+#define DC_PHY_DQ22_23_DLYN_inst_adr                                                 "0x002C"
+#define DC_PHY_DQ22_23_DLYN_inst                                                     0x002C
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_neg_7_2_shift                                  (22)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_neg_7_2_mask                                   (0x0FC00000)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_neg_7_2(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_neg_7_2_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ22_23_DLYN_get_ph_sel_dq_neg_7_2(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_pos_7_2_shift                                  (16)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_pos_7_2_mask                                   (0x003F0000)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_pos_7_2(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_pos_7_2_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ22_23_DLYN_get_ph_sel_dq_pos_7_2(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_neg_6_2_shift                                  (6)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_neg_6_2_mask                                   (0x00000FC0)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_neg_6_2(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_neg_6_2_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ22_23_DLYN_get_ph_sel_dq_neg_6_2(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_pos_6_2_shift                                  (0)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_pos_6_2_mask                                   (0x0000003F)
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_pos_6_2(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ22_23_DLYN_ph_sel_dq_pos_6_2_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ22_23_DLYN_get_ph_sel_dq_pos_6_2(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ24_25_DLYN                                                          0x180088B4
+#define DC_PHY_DQ24_25_DLYN_reg_addr                                                 "0xB80088B4"
+#define DC_PHY_DQ24_25_DLYN_reg                                                      0xB80088B4
+#define set_DC_PHY_DQ24_25_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ24_25_DLYN_reg)=data)
+#define get_DC_PHY_DQ24_25_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ24_25_DLYN_reg))
+#define DC_PHY_DQ24_25_DLYN_inst_adr                                                 "0x002D"
+#define DC_PHY_DQ24_25_DLYN_inst                                                     0x002D
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_neg_1_3_shift                                  (22)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_neg_1_3_mask                                   (0x0FC00000)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_neg_1_3(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_neg_1_3_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ24_25_DLYN_get_ph_sel_dq_neg_1_3(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_pos_1_3_shift                                  (16)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_pos_1_3_mask                                   (0x003F0000)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_pos_1_3(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_pos_1_3_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ24_25_DLYN_get_ph_sel_dq_pos_1_3(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_neg_0_3_shift                                  (6)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_neg_0_3_mask                                   (0x00000FC0)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_neg_0_3(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_neg_0_3_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ24_25_DLYN_get_ph_sel_dq_neg_0_3(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_pos_0_3_shift                                  (0)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_pos_0_3_mask                                   (0x0000003F)
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_pos_0_3(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ24_25_DLYN_ph_sel_dq_pos_0_3_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ24_25_DLYN_get_ph_sel_dq_pos_0_3(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ26_27_DLYN                                                          0x180088B8
+#define DC_PHY_DQ26_27_DLYN_reg_addr                                                 "0xB80088B8"
+#define DC_PHY_DQ26_27_DLYN_reg                                                      0xB80088B8
+#define set_DC_PHY_DQ26_27_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ26_27_DLYN_reg)=data)
+#define get_DC_PHY_DQ26_27_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ26_27_DLYN_reg))
+#define DC_PHY_DQ26_27_DLYN_inst_adr                                                 "0x002E"
+#define DC_PHY_DQ26_27_DLYN_inst                                                     0x002E
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_neg_3_3_shift                                  (22)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_neg_3_3_mask                                   (0x0FC00000)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_neg_3_3(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_neg_3_3_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ26_27_DLYN_get_ph_sel_dq_neg_3_3(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_pos_3_3_shift                                  (16)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_pos_3_3_mask                                   (0x003F0000)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_pos_3_3(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_pos_3_3_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ26_27_DLYN_get_ph_sel_dq_pos_3_3(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_neg_2_3_shift                                  (6)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_neg_2_3_mask                                   (0x00000FC0)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_neg_2_3(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_neg_2_3_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ26_27_DLYN_get_ph_sel_dq_neg_2_3(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_pos_2_3_shift                                  (0)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_pos_2_3_mask                                   (0x0000003F)
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_pos_2_3(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ26_27_DLYN_ph_sel_dq_pos_2_3_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ26_27_DLYN_get_ph_sel_dq_pos_2_3(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ28_29_DLYN                                                          0x180088BC
+#define DC_PHY_DQ28_29_DLYN_reg_addr                                                 "0xB80088BC"
+#define DC_PHY_DQ28_29_DLYN_reg                                                      0xB80088BC
+#define set_DC_PHY_DQ28_29_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ28_29_DLYN_reg)=data)
+#define get_DC_PHY_DQ28_29_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ28_29_DLYN_reg))
+#define DC_PHY_DQ28_29_DLYN_inst_adr                                                 "0x002F"
+#define DC_PHY_DQ28_29_DLYN_inst                                                     0x002F
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_neg_5_3_shift                                  (22)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_neg_5_3_mask                                   (0x0FC00000)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_neg_5_3(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_neg_5_3_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ28_29_DLYN_get_ph_sel_dq_neg_5_3(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_pos_5_3_shift                                  (16)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_pos_5_3_mask                                   (0x003F0000)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_pos_5_3(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_pos_5_3_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ28_29_DLYN_get_ph_sel_dq_pos_5_3(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_neg_4_3_shift                                  (6)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_neg_4_3_mask                                   (0x00000FC0)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_neg_4_3(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_neg_4_3_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ28_29_DLYN_get_ph_sel_dq_neg_4_3(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_pos_4_3_shift                                  (0)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_pos_4_3_mask                                   (0x0000003F)
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_pos_4_3(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ28_29_DLYN_ph_sel_dq_pos_4_3_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ28_29_DLYN_get_ph_sel_dq_pos_4_3(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_DQ30_31_DLYN                                                          0x180088C0
+#define DC_PHY_DQ30_31_DLYN_reg_addr                                                 "0xB80088C0"
+#define DC_PHY_DQ30_31_DLYN_reg                                                      0xB80088C0
+#define set_DC_PHY_DQ30_31_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ30_31_DLYN_reg)=data)
+#define get_DC_PHY_DQ30_31_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQ30_31_DLYN_reg))
+#define DC_PHY_DQ30_31_DLYN_inst_adr                                                 "0x0030"
+#define DC_PHY_DQ30_31_DLYN_inst                                                     0x0030
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_neg_7_3_shift                                  (22)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_neg_7_3_mask                                   (0x0FC00000)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_neg_7_3(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_neg_7_3_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ30_31_DLYN_get_ph_sel_dq_neg_7_3(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_pos_7_3_shift                                  (16)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_pos_7_3_mask                                   (0x003F0000)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_pos_7_3(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_pos_7_3_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ30_31_DLYN_get_ph_sel_dq_pos_7_3(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_neg_6_3_shift                                  (6)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_neg_6_3_mask                                   (0x00000FC0)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_neg_6_3(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_neg_6_3_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ30_31_DLYN_get_ph_sel_dq_neg_6_3(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_pos_6_3_shift                                  (0)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_pos_6_3_mask                                   (0x0000003F)
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_pos_6_3(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_DQ30_31_DLYN_ph_sel_dq_pos_6_3_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_DQ30_31_DLYN_get_ph_sel_dq_pos_6_3(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL0_1_DLYN                                                           0x180088C4
+#define DC_PHY_CAL0_1_DLYN_reg_addr                                                  "0xB80088C4"
+#define DC_PHY_CAL0_1_DLYN_reg                                                       0xB80088C4
+#define set_DC_PHY_CAL0_1_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL0_1_DLYN_reg)=data)
+#define get_DC_PHY_CAL0_1_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL0_1_DLYN_reg))
+#define DC_PHY_CAL0_1_DLYN_inst_adr                                                  "0x0031"
+#define DC_PHY_CAL0_1_DLYN_inst                                                      0x0031
+#define DC_PHY_CAL0_1_DLYN_non_valid_shift                                           (31)
+#define DC_PHY_CAL0_1_DLYN_non_valid_mask                                            (0x80000000)
+#define DC_PHY_CAL0_1_DLYN_non_valid(data)                                           (0x80000000&((data)<<31))
+#define DC_PHY_CAL0_1_DLYN_non_valid_src(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_CAL0_1_DLYN_get_non_valid(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_CAL0_1_DLYN_cal_dq1_neg_dlyn_0_shift                                  (22)
+#define DC_PHY_CAL0_1_DLYN_cal_dq1_neg_dlyn_0_mask                                   (0x0FC00000)
+#define DC_PHY_CAL0_1_DLYN_cal_dq1_neg_dlyn_0(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL0_1_DLYN_cal_dq1_neg_dlyn_0_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL0_1_DLYN_get_cal_dq1_neg_dlyn_0(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL0_1_DLYN_cal_dq1_pos_dlyn_0_shift                                  (16)
+#define DC_PHY_CAL0_1_DLYN_cal_dq1_pos_dlyn_0_mask                                   (0x003F0000)
+#define DC_PHY_CAL0_1_DLYN_cal_dq1_pos_dlyn_0(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_CAL0_1_DLYN_cal_dq1_pos_dlyn_0_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL0_1_DLYN_get_cal_dq1_pos_dlyn_0(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL0_1_DLYN_cal_dq0_neg_dlyn_0_shift                                  (6)
+#define DC_PHY_CAL0_1_DLYN_cal_dq0_neg_dlyn_0_mask                                   (0x00000FC0)
+#define DC_PHY_CAL0_1_DLYN_cal_dq0_neg_dlyn_0(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL0_1_DLYN_cal_dq0_neg_dlyn_0_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL0_1_DLYN_get_cal_dq0_neg_dlyn_0(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL0_1_DLYN_cal_dq0_pos_dlyn_0_shift                                  (0)
+#define DC_PHY_CAL0_1_DLYN_cal_dq0_pos_dlyn_0_mask                                   (0x0000003F)
+#define DC_PHY_CAL0_1_DLYN_cal_dq0_pos_dlyn_0(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_CAL0_1_DLYN_cal_dq0_pos_dlyn_0_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL0_1_DLYN_get_cal_dq0_pos_dlyn_0(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL2_3_DLYN                                                           0x180088C8
+#define DC_PHY_CAL2_3_DLYN_reg_addr                                                  "0xB80088C8"
+#define DC_PHY_CAL2_3_DLYN_reg                                                       0xB80088C8
+#define set_DC_PHY_CAL2_3_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL2_3_DLYN_reg)=data)
+#define get_DC_PHY_CAL2_3_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL2_3_DLYN_reg))
+#define DC_PHY_CAL2_3_DLYN_inst_adr                                                  "0x0032"
+#define DC_PHY_CAL2_3_DLYN_inst                                                      0x0032
+#define DC_PHY_CAL2_3_DLYN_non_valid_shift                                           (31)
+#define DC_PHY_CAL2_3_DLYN_non_valid_mask                                            (0x80000000)
+#define DC_PHY_CAL2_3_DLYN_non_valid(data)                                           (0x80000000&((data)<<31))
+#define DC_PHY_CAL2_3_DLYN_non_valid_src(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_CAL2_3_DLYN_get_non_valid(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_CAL2_3_DLYN_cal_dq3_neg_dlyn_0_shift                                  (22)
+#define DC_PHY_CAL2_3_DLYN_cal_dq3_neg_dlyn_0_mask                                   (0x0FC00000)
+#define DC_PHY_CAL2_3_DLYN_cal_dq3_neg_dlyn_0(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL2_3_DLYN_cal_dq3_neg_dlyn_0_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL2_3_DLYN_get_cal_dq3_neg_dlyn_0(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL2_3_DLYN_cal_dq3_pos_dlyn_0_shift                                  (16)
+#define DC_PHY_CAL2_3_DLYN_cal_dq3_pos_dlyn_0_mask                                   (0x003F0000)
+#define DC_PHY_CAL2_3_DLYN_cal_dq3_pos_dlyn_0(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_CAL2_3_DLYN_cal_dq3_pos_dlyn_0_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL2_3_DLYN_get_cal_dq3_pos_dlyn_0(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL2_3_DLYN_cal_dq2_neg_dlyn_0_shift                                  (6)
+#define DC_PHY_CAL2_3_DLYN_cal_dq2_neg_dlyn_0_mask                                   (0x00000FC0)
+#define DC_PHY_CAL2_3_DLYN_cal_dq2_neg_dlyn_0(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL2_3_DLYN_cal_dq2_neg_dlyn_0_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL2_3_DLYN_get_cal_dq2_neg_dlyn_0(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL2_3_DLYN_cal_dq2_pos_dlyn_0_shift                                  (0)
+#define DC_PHY_CAL2_3_DLYN_cal_dq2_pos_dlyn_0_mask                                   (0x0000003F)
+#define DC_PHY_CAL2_3_DLYN_cal_dq2_pos_dlyn_0(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_CAL2_3_DLYN_cal_dq2_pos_dlyn_0_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL2_3_DLYN_get_cal_dq2_pos_dlyn_0(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL4_5_DLYN                                                           0x180088CC
+#define DC_PHY_CAL4_5_DLYN_reg_addr                                                  "0xB80088CC"
+#define DC_PHY_CAL4_5_DLYN_reg                                                       0xB80088CC
+#define set_DC_PHY_CAL4_5_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL4_5_DLYN_reg)=data)
+#define get_DC_PHY_CAL4_5_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL4_5_DLYN_reg))
+#define DC_PHY_CAL4_5_DLYN_inst_adr                                                  "0x0033"
+#define DC_PHY_CAL4_5_DLYN_inst                                                      0x0033
+#define DC_PHY_CAL4_5_DLYN_non_valid_shift                                           (31)
+#define DC_PHY_CAL4_5_DLYN_non_valid_mask                                            (0x80000000)
+#define DC_PHY_CAL4_5_DLYN_non_valid(data)                                           (0x80000000&((data)<<31))
+#define DC_PHY_CAL4_5_DLYN_non_valid_src(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_CAL4_5_DLYN_get_non_valid(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_CAL4_5_DLYN_cal_dq5_neg_dlyn_0_shift                                  (22)
+#define DC_PHY_CAL4_5_DLYN_cal_dq5_neg_dlyn_0_mask                                   (0x0FC00000)
+#define DC_PHY_CAL4_5_DLYN_cal_dq5_neg_dlyn_0(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL4_5_DLYN_cal_dq5_neg_dlyn_0_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL4_5_DLYN_get_cal_dq5_neg_dlyn_0(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL4_5_DLYN_cal_dq5_pos_dlyn_0_shift                                  (16)
+#define DC_PHY_CAL4_5_DLYN_cal_dq5_pos_dlyn_0_mask                                   (0x003F0000)
+#define DC_PHY_CAL4_5_DLYN_cal_dq5_pos_dlyn_0(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_CAL4_5_DLYN_cal_dq5_pos_dlyn_0_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL4_5_DLYN_get_cal_dq5_pos_dlyn_0(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL4_5_DLYN_cal_dq4_neg_dlyn_0_shift                                  (6)
+#define DC_PHY_CAL4_5_DLYN_cal_dq4_neg_dlyn_0_mask                                   (0x00000FC0)
+#define DC_PHY_CAL4_5_DLYN_cal_dq4_neg_dlyn_0(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL4_5_DLYN_cal_dq4_neg_dlyn_0_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL4_5_DLYN_get_cal_dq4_neg_dlyn_0(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL4_5_DLYN_cal_dq4_pos_dlyn_0_shift                                  (0)
+#define DC_PHY_CAL4_5_DLYN_cal_dq4_pos_dlyn_0_mask                                   (0x0000003F)
+#define DC_PHY_CAL4_5_DLYN_cal_dq4_pos_dlyn_0(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_CAL4_5_DLYN_cal_dq4_pos_dlyn_0_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL4_5_DLYN_get_cal_dq4_pos_dlyn_0(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL6_7_DLYN                                                           0x180088D0
+#define DC_PHY_CAL6_7_DLYN_reg_addr                                                  "0xB80088D0"
+#define DC_PHY_CAL6_7_DLYN_reg                                                       0xB80088D0
+#define set_DC_PHY_CAL6_7_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL6_7_DLYN_reg)=data)
+#define get_DC_PHY_CAL6_7_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL6_7_DLYN_reg))
+#define DC_PHY_CAL6_7_DLYN_inst_adr                                                  "0x0034"
+#define DC_PHY_CAL6_7_DLYN_inst                                                      0x0034
+#define DC_PHY_CAL6_7_DLYN_non_valid_shift                                           (31)
+#define DC_PHY_CAL6_7_DLYN_non_valid_mask                                            (0x80000000)
+#define DC_PHY_CAL6_7_DLYN_non_valid(data)                                           (0x80000000&((data)<<31))
+#define DC_PHY_CAL6_7_DLYN_non_valid_src(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_CAL6_7_DLYN_get_non_valid(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_CAL6_7_DLYN_cal_dq7_neg_dlyn_0_shift                                  (22)
+#define DC_PHY_CAL6_7_DLYN_cal_dq7_neg_dlyn_0_mask                                   (0x0FC00000)
+#define DC_PHY_CAL6_7_DLYN_cal_dq7_neg_dlyn_0(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL6_7_DLYN_cal_dq7_neg_dlyn_0_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL6_7_DLYN_get_cal_dq7_neg_dlyn_0(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL6_7_DLYN_cal_dq7_pos_dlyn_0_shift                                  (16)
+#define DC_PHY_CAL6_7_DLYN_cal_dq7_pos_dlyn_0_mask                                   (0x003F0000)
+#define DC_PHY_CAL6_7_DLYN_cal_dq7_pos_dlyn_0(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_CAL6_7_DLYN_cal_dq7_pos_dlyn_0_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL6_7_DLYN_get_cal_dq7_pos_dlyn_0(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL6_7_DLYN_cal_dq6_neg_dlyn_0_shift                                  (6)
+#define DC_PHY_CAL6_7_DLYN_cal_dq6_neg_dlyn_0_mask                                   (0x00000FC0)
+#define DC_PHY_CAL6_7_DLYN_cal_dq6_neg_dlyn_0(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL6_7_DLYN_cal_dq6_neg_dlyn_0_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL6_7_DLYN_get_cal_dq6_neg_dlyn_0(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL6_7_DLYN_cal_dq6_pos_dlyn_0_shift                                  (0)
+#define DC_PHY_CAL6_7_DLYN_cal_dq6_pos_dlyn_0_mask                                   (0x0000003F)
+#define DC_PHY_CAL6_7_DLYN_cal_dq6_pos_dlyn_0(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_CAL6_7_DLYN_cal_dq6_pos_dlyn_0_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL6_7_DLYN_get_cal_dq6_pos_dlyn_0(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL8_9_DLYN                                                           0x180088D4
+#define DC_PHY_CAL8_9_DLYN_reg_addr                                                  "0xB80088D4"
+#define DC_PHY_CAL8_9_DLYN_reg                                                       0xB80088D4
+#define set_DC_PHY_CAL8_9_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL8_9_DLYN_reg)=data)
+#define get_DC_PHY_CAL8_9_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL8_9_DLYN_reg))
+#define DC_PHY_CAL8_9_DLYN_inst_adr                                                  "0x0035"
+#define DC_PHY_CAL8_9_DLYN_inst                                                      0x0035
+#define DC_PHY_CAL8_9_DLYN_non_valid_shift                                           (31)
+#define DC_PHY_CAL8_9_DLYN_non_valid_mask                                            (0x80000000)
+#define DC_PHY_CAL8_9_DLYN_non_valid(data)                                           (0x80000000&((data)<<31))
+#define DC_PHY_CAL8_9_DLYN_non_valid_src(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_CAL8_9_DLYN_get_non_valid(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_CAL8_9_DLYN_cal_dq1_neg_dlyn_1_shift                                  (22)
+#define DC_PHY_CAL8_9_DLYN_cal_dq1_neg_dlyn_1_mask                                   (0x0FC00000)
+#define DC_PHY_CAL8_9_DLYN_cal_dq1_neg_dlyn_1(data)                                  (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL8_9_DLYN_cal_dq1_neg_dlyn_1_src(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL8_9_DLYN_get_cal_dq1_neg_dlyn_1(data)                              ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL8_9_DLYN_cal_dq1_pos_dlyn_1_shift                                  (16)
+#define DC_PHY_CAL8_9_DLYN_cal_dq1_pos_dlyn_1_mask                                   (0x003F0000)
+#define DC_PHY_CAL8_9_DLYN_cal_dq1_pos_dlyn_1(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_CAL8_9_DLYN_cal_dq1_pos_dlyn_1_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL8_9_DLYN_get_cal_dq1_pos_dlyn_1(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL8_9_DLYN_cal_dq0_neg_dlyn_1_shift                                  (6)
+#define DC_PHY_CAL8_9_DLYN_cal_dq0_neg_dlyn_1_mask                                   (0x00000FC0)
+#define DC_PHY_CAL8_9_DLYN_cal_dq0_neg_dlyn_1(data)                                  (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL8_9_DLYN_cal_dq0_neg_dlyn_1_src(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL8_9_DLYN_get_cal_dq0_neg_dlyn_1(data)                              ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL8_9_DLYN_cal_dq0_pos_dlyn_1_shift                                  (0)
+#define DC_PHY_CAL8_9_DLYN_cal_dq0_pos_dlyn_1_mask                                   (0x0000003F)
+#define DC_PHY_CAL8_9_DLYN_cal_dq0_pos_dlyn_1(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_CAL8_9_DLYN_cal_dq0_pos_dlyn_1_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL8_9_DLYN_get_cal_dq0_pos_dlyn_1(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL10_11_DLYN                                                         0x180088D8
+#define DC_PHY_CAL10_11_DLYN_reg_addr                                                "0xB80088D8"
+#define DC_PHY_CAL10_11_DLYN_reg                                                     0xB80088D8
+#define set_DC_PHY_CAL10_11_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL10_11_DLYN_reg)=data)
+#define get_DC_PHY_CAL10_11_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL10_11_DLYN_reg))
+#define DC_PHY_CAL10_11_DLYN_inst_adr                                                "0x0036"
+#define DC_PHY_CAL10_11_DLYN_inst                                                    0x0036
+#define DC_PHY_CAL10_11_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL10_11_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL10_11_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL10_11_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL10_11_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL10_11_DLYN_cal_dq3_neg_dlyn_1_shift                                (22)
+#define DC_PHY_CAL10_11_DLYN_cal_dq3_neg_dlyn_1_mask                                 (0x0FC00000)
+#define DC_PHY_CAL10_11_DLYN_cal_dq3_neg_dlyn_1(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL10_11_DLYN_cal_dq3_neg_dlyn_1_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL10_11_DLYN_get_cal_dq3_neg_dlyn_1(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL10_11_DLYN_cal_dq3_pos_dlyn_1_shift                                (16)
+#define DC_PHY_CAL10_11_DLYN_cal_dq3_pos_dlyn_1_mask                                 (0x003F0000)
+#define DC_PHY_CAL10_11_DLYN_cal_dq3_pos_dlyn_1(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL10_11_DLYN_cal_dq3_pos_dlyn_1_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL10_11_DLYN_get_cal_dq3_pos_dlyn_1(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL10_11_DLYN_cal_dq2_neg_dlyn_1_shift                                (6)
+#define DC_PHY_CAL10_11_DLYN_cal_dq2_neg_dlyn_1_mask                                 (0x00000FC0)
+#define DC_PHY_CAL10_11_DLYN_cal_dq2_neg_dlyn_1(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL10_11_DLYN_cal_dq2_neg_dlyn_1_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL10_11_DLYN_get_cal_dq2_neg_dlyn_1(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL10_11_DLYN_cal_dq2_pos_dlyn_1_shift                                (0)
+#define DC_PHY_CAL10_11_DLYN_cal_dq2_pos_dlyn_1_mask                                 (0x0000003F)
+#define DC_PHY_CAL10_11_DLYN_cal_dq2_pos_dlyn_1(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL10_11_DLYN_cal_dq2_pos_dlyn_1_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL10_11_DLYN_get_cal_dq2_pos_dlyn_1(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL12_13_DLYN                                                         0x180088DC
+#define DC_PHY_CAL12_13_DLYN_reg_addr                                                "0xB80088DC"
+#define DC_PHY_CAL12_13_DLYN_reg                                                     0xB80088DC
+#define set_DC_PHY_CAL12_13_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL12_13_DLYN_reg)=data)
+#define get_DC_PHY_CAL12_13_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL12_13_DLYN_reg))
+#define DC_PHY_CAL12_13_DLYN_inst_adr                                                "0x0037"
+#define DC_PHY_CAL12_13_DLYN_inst                                                    0x0037
+#define DC_PHY_CAL12_13_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL12_13_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL12_13_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL12_13_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL12_13_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL12_13_DLYN_cal_dq5_neg_dlyn_1_shift                                (22)
+#define DC_PHY_CAL12_13_DLYN_cal_dq5_neg_dlyn_1_mask                                 (0x0FC00000)
+#define DC_PHY_CAL12_13_DLYN_cal_dq5_neg_dlyn_1(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL12_13_DLYN_cal_dq5_neg_dlyn_1_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL12_13_DLYN_get_cal_dq5_neg_dlyn_1(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL12_13_DLYN_cal_dq5_pos_dlyn_1_shift                                (16)
+#define DC_PHY_CAL12_13_DLYN_cal_dq5_pos_dlyn_1_mask                                 (0x003F0000)
+#define DC_PHY_CAL12_13_DLYN_cal_dq5_pos_dlyn_1(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL12_13_DLYN_cal_dq5_pos_dlyn_1_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL12_13_DLYN_get_cal_dq5_pos_dlyn_1(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL12_13_DLYN_cal_dq4_neg_dlyn_1_shift                                (6)
+#define DC_PHY_CAL12_13_DLYN_cal_dq4_neg_dlyn_1_mask                                 (0x00000FC0)
+#define DC_PHY_CAL12_13_DLYN_cal_dq4_neg_dlyn_1(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL12_13_DLYN_cal_dq4_neg_dlyn_1_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL12_13_DLYN_get_cal_dq4_neg_dlyn_1(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL12_13_DLYN_cal_dq4_pos_dlyn_1_shift                                (0)
+#define DC_PHY_CAL12_13_DLYN_cal_dq4_pos_dlyn_1_mask                                 (0x0000003F)
+#define DC_PHY_CAL12_13_DLYN_cal_dq4_pos_dlyn_1(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL12_13_DLYN_cal_dq4_pos_dlyn_1_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL12_13_DLYN_get_cal_dq4_pos_dlyn_1(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL14_15_DLYN                                                         0x180088E0
+#define DC_PHY_CAL14_15_DLYN_reg_addr                                                "0xB80088E0"
+#define DC_PHY_CAL14_15_DLYN_reg                                                     0xB80088E0
+#define set_DC_PHY_CAL14_15_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL14_15_DLYN_reg)=data)
+#define get_DC_PHY_CAL14_15_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL14_15_DLYN_reg))
+#define DC_PHY_CAL14_15_DLYN_inst_adr                                                "0x0038"
+#define DC_PHY_CAL14_15_DLYN_inst                                                    0x0038
+#define DC_PHY_CAL14_15_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL14_15_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL14_15_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL14_15_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL14_15_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL14_15_DLYN_cal_dq7_neg_dlyn_1_shift                                (22)
+#define DC_PHY_CAL14_15_DLYN_cal_dq7_neg_dlyn_1_mask                                 (0x0FC00000)
+#define DC_PHY_CAL14_15_DLYN_cal_dq7_neg_dlyn_1(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL14_15_DLYN_cal_dq7_neg_dlyn_1_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL14_15_DLYN_get_cal_dq7_neg_dlyn_1(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL14_15_DLYN_cal_dq7_pos_dlyn_1_shift                                (16)
+#define DC_PHY_CAL14_15_DLYN_cal_dq7_pos_dlyn_1_mask                                 (0x003F0000)
+#define DC_PHY_CAL14_15_DLYN_cal_dq7_pos_dlyn_1(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL14_15_DLYN_cal_dq7_pos_dlyn_1_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL14_15_DLYN_get_cal_dq7_pos_dlyn_1(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL14_15_DLYN_cal_dq6_neg_dlyn_1_shift                                (6)
+#define DC_PHY_CAL14_15_DLYN_cal_dq6_neg_dlyn_1_mask                                 (0x00000FC0)
+#define DC_PHY_CAL14_15_DLYN_cal_dq6_neg_dlyn_1(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL14_15_DLYN_cal_dq6_neg_dlyn_1_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL14_15_DLYN_get_cal_dq6_neg_dlyn_1(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL14_15_DLYN_cal_dq6_pos_dlyn_1_shift                                (0)
+#define DC_PHY_CAL14_15_DLYN_cal_dq6_pos_dlyn_1_mask                                 (0x0000003F)
+#define DC_PHY_CAL14_15_DLYN_cal_dq6_pos_dlyn_1(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL14_15_DLYN_cal_dq6_pos_dlyn_1_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL14_15_DLYN_get_cal_dq6_pos_dlyn_1(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL16_17_DLYN                                                         0x180088E4
+#define DC_PHY_CAL16_17_DLYN_reg_addr                                                "0xB80088E4"
+#define DC_PHY_CAL16_17_DLYN_reg                                                     0xB80088E4
+#define set_DC_PHY_CAL16_17_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL16_17_DLYN_reg)=data)
+#define get_DC_PHY_CAL16_17_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL16_17_DLYN_reg))
+#define DC_PHY_CAL16_17_DLYN_inst_adr                                                "0x0039"
+#define DC_PHY_CAL16_17_DLYN_inst                                                    0x0039
+#define DC_PHY_CAL16_17_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL16_17_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL16_17_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL16_17_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL16_17_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL16_17_DLYN_cal_dq1_neg_dlyn_2_shift                                (22)
+#define DC_PHY_CAL16_17_DLYN_cal_dq1_neg_dlyn_2_mask                                 (0x0FC00000)
+#define DC_PHY_CAL16_17_DLYN_cal_dq1_neg_dlyn_2(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL16_17_DLYN_cal_dq1_neg_dlyn_2_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL16_17_DLYN_get_cal_dq1_neg_dlyn_2(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL16_17_DLYN_cal_dq1_pos_dlyn_2_shift                                (16)
+#define DC_PHY_CAL16_17_DLYN_cal_dq1_pos_dlyn_2_mask                                 (0x003F0000)
+#define DC_PHY_CAL16_17_DLYN_cal_dq1_pos_dlyn_2(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL16_17_DLYN_cal_dq1_pos_dlyn_2_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL16_17_DLYN_get_cal_dq1_pos_dlyn_2(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL16_17_DLYN_cal_dq0_neg_dlyn_2_shift                                (6)
+#define DC_PHY_CAL16_17_DLYN_cal_dq0_neg_dlyn_2_mask                                 (0x00000FC0)
+#define DC_PHY_CAL16_17_DLYN_cal_dq0_neg_dlyn_2(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL16_17_DLYN_cal_dq0_neg_dlyn_2_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL16_17_DLYN_get_cal_dq0_neg_dlyn_2(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL16_17_DLYN_cal_dq0_pos_dlyn_2_shift                                (0)
+#define DC_PHY_CAL16_17_DLYN_cal_dq0_pos_dlyn_2_mask                                 (0x0000003F)
+#define DC_PHY_CAL16_17_DLYN_cal_dq0_pos_dlyn_2(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL16_17_DLYN_cal_dq0_pos_dlyn_2_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL16_17_DLYN_get_cal_dq0_pos_dlyn_2(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL18_19_DLYN                                                         0x180088E8
+#define DC_PHY_CAL18_19_DLYN_reg_addr                                                "0xB80088E8"
+#define DC_PHY_CAL18_19_DLYN_reg                                                     0xB80088E8
+#define set_DC_PHY_CAL18_19_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL18_19_DLYN_reg)=data)
+#define get_DC_PHY_CAL18_19_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL18_19_DLYN_reg))
+#define DC_PHY_CAL18_19_DLYN_inst_adr                                                "0x003A"
+#define DC_PHY_CAL18_19_DLYN_inst                                                    0x003A
+#define DC_PHY_CAL18_19_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL18_19_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL18_19_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL18_19_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL18_19_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL18_19_DLYN_cal_dq3_neg_dlyn_2_shift                                (22)
+#define DC_PHY_CAL18_19_DLYN_cal_dq3_neg_dlyn_2_mask                                 (0x0FC00000)
+#define DC_PHY_CAL18_19_DLYN_cal_dq3_neg_dlyn_2(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL18_19_DLYN_cal_dq3_neg_dlyn_2_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL18_19_DLYN_get_cal_dq3_neg_dlyn_2(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL18_19_DLYN_cal_dq3_pos_dlyn_2_shift                                (16)
+#define DC_PHY_CAL18_19_DLYN_cal_dq3_pos_dlyn_2_mask                                 (0x003F0000)
+#define DC_PHY_CAL18_19_DLYN_cal_dq3_pos_dlyn_2(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL18_19_DLYN_cal_dq3_pos_dlyn_2_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL18_19_DLYN_get_cal_dq3_pos_dlyn_2(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL18_19_DLYN_cal_dq2_neg_dlyn_2_shift                                (6)
+#define DC_PHY_CAL18_19_DLYN_cal_dq2_neg_dlyn_2_mask                                 (0x00000FC0)
+#define DC_PHY_CAL18_19_DLYN_cal_dq2_neg_dlyn_2(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL18_19_DLYN_cal_dq2_neg_dlyn_2_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL18_19_DLYN_get_cal_dq2_neg_dlyn_2(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL18_19_DLYN_cal_dq2_pos_dlyn_2_shift                                (0)
+#define DC_PHY_CAL18_19_DLYN_cal_dq2_pos_dlyn_2_mask                                 (0x0000003F)
+#define DC_PHY_CAL18_19_DLYN_cal_dq2_pos_dlyn_2(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL18_19_DLYN_cal_dq2_pos_dlyn_2_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL18_19_DLYN_get_cal_dq2_pos_dlyn_2(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL20_21_DLYN                                                         0x180088EC
+#define DC_PHY_CAL20_21_DLYN_reg_addr                                                "0xB80088EC"
+#define DC_PHY_CAL20_21_DLYN_reg                                                     0xB80088EC
+#define set_DC_PHY_CAL20_21_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL20_21_DLYN_reg)=data)
+#define get_DC_PHY_CAL20_21_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL20_21_DLYN_reg))
+#define DC_PHY_CAL20_21_DLYN_inst_adr                                                "0x003B"
+#define DC_PHY_CAL20_21_DLYN_inst                                                    0x003B
+#define DC_PHY_CAL20_21_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL20_21_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL20_21_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL20_21_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL20_21_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL20_21_DLYN_cal_dq5_neg_dlyn_2_shift                                (22)
+#define DC_PHY_CAL20_21_DLYN_cal_dq5_neg_dlyn_2_mask                                 (0x0FC00000)
+#define DC_PHY_CAL20_21_DLYN_cal_dq5_neg_dlyn_2(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL20_21_DLYN_cal_dq5_neg_dlyn_2_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL20_21_DLYN_get_cal_dq5_neg_dlyn_2(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL20_21_DLYN_cal_dq5_pos_dlyn_2_shift                                (16)
+#define DC_PHY_CAL20_21_DLYN_cal_dq5_pos_dlyn_2_mask                                 (0x003F0000)
+#define DC_PHY_CAL20_21_DLYN_cal_dq5_pos_dlyn_2(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL20_21_DLYN_cal_dq5_pos_dlyn_2_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL20_21_DLYN_get_cal_dq5_pos_dlyn_2(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL20_21_DLYN_cal_dq4_neg_dlyn_2_shift                                (6)
+#define DC_PHY_CAL20_21_DLYN_cal_dq4_neg_dlyn_2_mask                                 (0x00000FC0)
+#define DC_PHY_CAL20_21_DLYN_cal_dq4_neg_dlyn_2(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL20_21_DLYN_cal_dq4_neg_dlyn_2_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL20_21_DLYN_get_cal_dq4_neg_dlyn_2(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL20_21_DLYN_cal_dq4_pos_dlyn_2_shift                                (0)
+#define DC_PHY_CAL20_21_DLYN_cal_dq4_pos_dlyn_2_mask                                 (0x0000003F)
+#define DC_PHY_CAL20_21_DLYN_cal_dq4_pos_dlyn_2(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL20_21_DLYN_cal_dq4_pos_dlyn_2_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL20_21_DLYN_get_cal_dq4_pos_dlyn_2(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL22_23_DLYN                                                         0x180088F0
+#define DC_PHY_CAL22_23_DLYN_reg_addr                                                "0xB80088F0"
+#define DC_PHY_CAL22_23_DLYN_reg                                                     0xB80088F0
+#define set_DC_PHY_CAL22_23_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL22_23_DLYN_reg)=data)
+#define get_DC_PHY_CAL22_23_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL22_23_DLYN_reg))
+#define DC_PHY_CAL22_23_DLYN_inst_adr                                                "0x003C"
+#define DC_PHY_CAL22_23_DLYN_inst                                                    0x003C
+#define DC_PHY_CAL22_23_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL22_23_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL22_23_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL22_23_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL22_23_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL22_23_DLYN_cal_dq7_neg_dlyn_2_shift                                (22)
+#define DC_PHY_CAL22_23_DLYN_cal_dq7_neg_dlyn_2_mask                                 (0x0FC00000)
+#define DC_PHY_CAL22_23_DLYN_cal_dq7_neg_dlyn_2(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL22_23_DLYN_cal_dq7_neg_dlyn_2_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL22_23_DLYN_get_cal_dq7_neg_dlyn_2(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL22_23_DLYN_cal_dq7_pos_dlyn_2_shift                                (16)
+#define DC_PHY_CAL22_23_DLYN_cal_dq7_pos_dlyn_2_mask                                 (0x003F0000)
+#define DC_PHY_CAL22_23_DLYN_cal_dq7_pos_dlyn_2(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL22_23_DLYN_cal_dq7_pos_dlyn_2_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL22_23_DLYN_get_cal_dq7_pos_dlyn_2(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL22_23_DLYN_cal_dq6_neg_dlyn_2_shift                                (6)
+#define DC_PHY_CAL22_23_DLYN_cal_dq6_neg_dlyn_2_mask                                 (0x00000FC0)
+#define DC_PHY_CAL22_23_DLYN_cal_dq6_neg_dlyn_2(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL22_23_DLYN_cal_dq6_neg_dlyn_2_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL22_23_DLYN_get_cal_dq6_neg_dlyn_2(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL22_23_DLYN_cal_dq6_pos_dlyn_2_shift                                (0)
+#define DC_PHY_CAL22_23_DLYN_cal_dq6_pos_dlyn_2_mask                                 (0x0000003F)
+#define DC_PHY_CAL22_23_DLYN_cal_dq6_pos_dlyn_2(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL22_23_DLYN_cal_dq6_pos_dlyn_2_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL22_23_DLYN_get_cal_dq6_pos_dlyn_2(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL24_25_DLYN                                                         0x180088F4
+#define DC_PHY_CAL24_25_DLYN_reg_addr                                                "0xB80088F4"
+#define DC_PHY_CAL24_25_DLYN_reg                                                     0xB80088F4
+#define set_DC_PHY_CAL24_25_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL24_25_DLYN_reg)=data)
+#define get_DC_PHY_CAL24_25_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL24_25_DLYN_reg))
+#define DC_PHY_CAL24_25_DLYN_inst_adr                                                "0x003D"
+#define DC_PHY_CAL24_25_DLYN_inst                                                    0x003D
+#define DC_PHY_CAL24_25_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL24_25_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL24_25_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL24_25_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL24_25_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL24_25_DLYN_cal_dq1_neg_dlyn_3_shift                                (22)
+#define DC_PHY_CAL24_25_DLYN_cal_dq1_neg_dlyn_3_mask                                 (0x0FC00000)
+#define DC_PHY_CAL24_25_DLYN_cal_dq1_neg_dlyn_3(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL24_25_DLYN_cal_dq1_neg_dlyn_3_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL24_25_DLYN_get_cal_dq1_neg_dlyn_3(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL24_25_DLYN_cal_dq1_pos_dlyn_3_shift                                (16)
+#define DC_PHY_CAL24_25_DLYN_cal_dq1_pos_dlyn_3_mask                                 (0x003F0000)
+#define DC_PHY_CAL24_25_DLYN_cal_dq1_pos_dlyn_3(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL24_25_DLYN_cal_dq1_pos_dlyn_3_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL24_25_DLYN_get_cal_dq1_pos_dlyn_3(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL24_25_DLYN_cal_dq0_neg_dlyn_3_shift                                (6)
+#define DC_PHY_CAL24_25_DLYN_cal_dq0_neg_dlyn_3_mask                                 (0x00000FC0)
+#define DC_PHY_CAL24_25_DLYN_cal_dq0_neg_dlyn_3(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL24_25_DLYN_cal_dq0_neg_dlyn_3_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL24_25_DLYN_get_cal_dq0_neg_dlyn_3(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL24_25_DLYN_cal_dq0_pos_dlyn_3_shift                                (0)
+#define DC_PHY_CAL24_25_DLYN_cal_dq0_pos_dlyn_3_mask                                 (0x0000003F)
+#define DC_PHY_CAL24_25_DLYN_cal_dq0_pos_dlyn_3(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL24_25_DLYN_cal_dq0_pos_dlyn_3_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL24_25_DLYN_get_cal_dq0_pos_dlyn_3(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL26_27_DLYN                                                         0x180088F8
+#define DC_PHY_CAL26_27_DLYN_reg_addr                                                "0xB80088F8"
+#define DC_PHY_CAL26_27_DLYN_reg                                                     0xB80088F8
+#define set_DC_PHY_CAL26_27_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL26_27_DLYN_reg)=data)
+#define get_DC_PHY_CAL26_27_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL26_27_DLYN_reg))
+#define DC_PHY_CAL26_27_DLYN_inst_adr                                                "0x003E"
+#define DC_PHY_CAL26_27_DLYN_inst                                                    0x003E
+#define DC_PHY_CAL26_27_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL26_27_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL26_27_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL26_27_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL26_27_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL26_27_DLYN_cal_dq3_neg_dlyn_3_shift                                (22)
+#define DC_PHY_CAL26_27_DLYN_cal_dq3_neg_dlyn_3_mask                                 (0x0FC00000)
+#define DC_PHY_CAL26_27_DLYN_cal_dq3_neg_dlyn_3(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL26_27_DLYN_cal_dq3_neg_dlyn_3_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL26_27_DLYN_get_cal_dq3_neg_dlyn_3(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL26_27_DLYN_cal_dq3_pos_dlyn_3_shift                                (16)
+#define DC_PHY_CAL26_27_DLYN_cal_dq3_pos_dlyn_3_mask                                 (0x003F0000)
+#define DC_PHY_CAL26_27_DLYN_cal_dq3_pos_dlyn_3(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL26_27_DLYN_cal_dq3_pos_dlyn_3_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL26_27_DLYN_get_cal_dq3_pos_dlyn_3(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL26_27_DLYN_cal_dq2_neg_dlyn_3_shift                                (6)
+#define DC_PHY_CAL26_27_DLYN_cal_dq2_neg_dlyn_3_mask                                 (0x00000FC0)
+#define DC_PHY_CAL26_27_DLYN_cal_dq2_neg_dlyn_3(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL26_27_DLYN_cal_dq2_neg_dlyn_3_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL26_27_DLYN_get_cal_dq2_neg_dlyn_3(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL26_27_DLYN_cal_dq2_pos_dlyn_3_shift                                (0)
+#define DC_PHY_CAL26_27_DLYN_cal_dq2_pos_dlyn_3_mask                                 (0x0000003F)
+#define DC_PHY_CAL26_27_DLYN_cal_dq2_pos_dlyn_3(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL26_27_DLYN_cal_dq2_pos_dlyn_3_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL26_27_DLYN_get_cal_dq2_pos_dlyn_3(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL28_29_DLYN                                                         0x180088FC
+#define DC_PHY_CAL28_29_DLYN_reg_addr                                                "0xB80088FC"
+#define DC_PHY_CAL28_29_DLYN_reg                                                     0xB80088FC
+#define set_DC_PHY_CAL28_29_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL28_29_DLYN_reg)=data)
+#define get_DC_PHY_CAL28_29_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL28_29_DLYN_reg))
+#define DC_PHY_CAL28_29_DLYN_inst_adr                                                "0x003F"
+#define DC_PHY_CAL28_29_DLYN_inst                                                    0x003F
+#define DC_PHY_CAL28_29_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL28_29_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL28_29_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL28_29_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL28_29_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL28_29_DLYN_cal_dq5_neg_dlyn_3_shift                                (22)
+#define DC_PHY_CAL28_29_DLYN_cal_dq5_neg_dlyn_3_mask                                 (0x0FC00000)
+#define DC_PHY_CAL28_29_DLYN_cal_dq5_neg_dlyn_3(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL28_29_DLYN_cal_dq5_neg_dlyn_3_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL28_29_DLYN_get_cal_dq5_neg_dlyn_3(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL28_29_DLYN_cal_dq5_pos_dlyn_3_shift                                (16)
+#define DC_PHY_CAL28_29_DLYN_cal_dq5_pos_dlyn_3_mask                                 (0x003F0000)
+#define DC_PHY_CAL28_29_DLYN_cal_dq5_pos_dlyn_3(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL28_29_DLYN_cal_dq5_pos_dlyn_3_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL28_29_DLYN_get_cal_dq5_pos_dlyn_3(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL28_29_DLYN_cal_dq4_neg_dlyn_3_shift                                (6)
+#define DC_PHY_CAL28_29_DLYN_cal_dq4_neg_dlyn_3_mask                                 (0x00000FC0)
+#define DC_PHY_CAL28_29_DLYN_cal_dq4_neg_dlyn_3(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL28_29_DLYN_cal_dq4_neg_dlyn_3_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL28_29_DLYN_get_cal_dq4_neg_dlyn_3(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL28_29_DLYN_cal_dq4_pos_dlyn_3_shift                                (0)
+#define DC_PHY_CAL28_29_DLYN_cal_dq4_pos_dlyn_3_mask                                 (0x0000003F)
+#define DC_PHY_CAL28_29_DLYN_cal_dq4_pos_dlyn_3(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL28_29_DLYN_cal_dq4_pos_dlyn_3_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL28_29_DLYN_get_cal_dq4_pos_dlyn_3(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_CAL30_31_DLYN                                                         0x18008900
+#define DC_PHY_CAL30_31_DLYN_reg_addr                                                "0xB8008900"
+#define DC_PHY_CAL30_31_DLYN_reg                                                     0xB8008900
+#define set_DC_PHY_CAL30_31_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL30_31_DLYN_reg)=data)
+#define get_DC_PHY_CAL30_31_DLYN_reg   (*((volatile unsigned int*) DC_PHY_CAL30_31_DLYN_reg))
+#define DC_PHY_CAL30_31_DLYN_inst_adr                                                "0x0040"
+#define DC_PHY_CAL30_31_DLYN_inst                                                    0x0040
+#define DC_PHY_CAL30_31_DLYN_non_valid_shift                                         (31)
+#define DC_PHY_CAL30_31_DLYN_non_valid_mask                                          (0x80000000)
+#define DC_PHY_CAL30_31_DLYN_non_valid(data)                                         (0x80000000&((data)<<31))
+#define DC_PHY_CAL30_31_DLYN_non_valid_src(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL30_31_DLYN_get_non_valid(data)                                     ((0x80000000&(data))>>31)
+#define DC_PHY_CAL30_31_DLYN_cal_dq7_neg_dlyn_3_shift                                (22)
+#define DC_PHY_CAL30_31_DLYN_cal_dq7_neg_dlyn_3_mask                                 (0x0FC00000)
+#define DC_PHY_CAL30_31_DLYN_cal_dq7_neg_dlyn_3(data)                                (0x0FC00000&((data)<<22))
+#define DC_PHY_CAL30_31_DLYN_cal_dq7_neg_dlyn_3_src(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL30_31_DLYN_get_cal_dq7_neg_dlyn_3(data)                            ((0x0FC00000&(data))>>22)
+#define DC_PHY_CAL30_31_DLYN_cal_dq7_pos_dlyn_3_shift                                (16)
+#define DC_PHY_CAL30_31_DLYN_cal_dq7_pos_dlyn_3_mask                                 (0x003F0000)
+#define DC_PHY_CAL30_31_DLYN_cal_dq7_pos_dlyn_3(data)                                (0x003F0000&((data)<<16))
+#define DC_PHY_CAL30_31_DLYN_cal_dq7_pos_dlyn_3_src(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL30_31_DLYN_get_cal_dq7_pos_dlyn_3(data)                            ((0x003F0000&(data))>>16)
+#define DC_PHY_CAL30_31_DLYN_cal_dq6_neg_dlyn_3_shift                                (6)
+#define DC_PHY_CAL30_31_DLYN_cal_dq6_neg_dlyn_3_mask                                 (0x00000FC0)
+#define DC_PHY_CAL30_31_DLYN_cal_dq6_neg_dlyn_3(data)                                (0x00000FC0&((data)<<6))
+#define DC_PHY_CAL30_31_DLYN_cal_dq6_neg_dlyn_3_src(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL30_31_DLYN_get_cal_dq6_neg_dlyn_3(data)                            ((0x00000FC0&(data))>>6)
+#define DC_PHY_CAL30_31_DLYN_cal_dq6_pos_dlyn_3_shift                                (0)
+#define DC_PHY_CAL30_31_DLYN_cal_dq6_pos_dlyn_3_mask                                 (0x0000003F)
+#define DC_PHY_CAL30_31_DLYN_cal_dq6_pos_dlyn_3(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_CAL30_31_DLYN_cal_dq6_pos_dlyn_3_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_CAL30_31_DLYN_get_cal_dq6_pos_dlyn_3(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_READ_COM_CTRL                                                         0x18008904
+#define DC_PHY_READ_COM_CTRL_reg_addr                                                "0xB8008904"
+#define DC_PHY_READ_COM_CTRL_reg                                                     0xB8008904
+#define set_DC_PHY_READ_COM_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_READ_COM_CTRL_reg)=data)
+#define get_DC_PHY_READ_COM_CTRL_reg   (*((volatile unsigned int*) DC_PHY_READ_COM_CTRL_reg))
+#define DC_PHY_READ_COM_CTRL_inst_adr                                                "0x0041"
+#define DC_PHY_READ_COM_CTRL_inst                                                    0x0041
+#define DC_PHY_READ_COM_CTRL_read_lat_sel_shift                                      (14)
+#define DC_PHY_READ_COM_CTRL_read_lat_sel_mask                                       (0x00004000)
+#define DC_PHY_READ_COM_CTRL_read_lat_sel(data)                                      (0x00004000&((data)<<14))
+#define DC_PHY_READ_COM_CTRL_read_lat_sel_src(data)                                  ((0x00004000&(data))>>14)
+#define DC_PHY_READ_COM_CTRL_get_read_lat_sel(data)                                  ((0x00004000&(data))>>14)
+#define DC_PHY_READ_COM_CTRL_read_lat_shift                                          (12)
+#define DC_PHY_READ_COM_CTRL_read_lat_mask                                           (0x00003000)
+#define DC_PHY_READ_COM_CTRL_read_lat(data)                                          (0x00003000&((data)<<12))
+#define DC_PHY_READ_COM_CTRL_read_lat_src(data)                                      ((0x00003000&(data))>>12)
+#define DC_PHY_READ_COM_CTRL_get_read_lat(data)                                      ((0x00003000&(data))>>12)
+#define DC_PHY_READ_COM_CTRL_ph_sel_read23_shift                                     (8)
+#define DC_PHY_READ_COM_CTRL_ph_sel_read23_mask                                      (0x00000F00)
+#define DC_PHY_READ_COM_CTRL_ph_sel_read23(data)                                     (0x00000F00&((data)<<8))
+#define DC_PHY_READ_COM_CTRL_ph_sel_read23_src(data)                                 ((0x00000F00&(data))>>8)
+#define DC_PHY_READ_COM_CTRL_get_ph_sel_read23(data)                                 ((0x00000F00&(data))>>8)
+#define DC_PHY_READ_COM_CTRL_ph_sel_read01_shift                                     (4)
+#define DC_PHY_READ_COM_CTRL_ph_sel_read01_mask                                      (0x000000F0)
+#define DC_PHY_READ_COM_CTRL_ph_sel_read01(data)                                     (0x000000F0&((data)<<4))
+#define DC_PHY_READ_COM_CTRL_ph_sel_read01_src(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_READ_COM_CTRL_get_ph_sel_read01(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_READ_COM_CTRL_read_com_sel_shift                                      (0)
+#define DC_PHY_READ_COM_CTRL_read_com_sel_mask                                       (0x00000001)
+#define DC_PHY_READ_COM_CTRL_read_com_sel(data)                                      (0x00000001&((data)<<0))
+#define DC_PHY_READ_COM_CTRL_read_com_sel_src(data)                                  ((0x00000001&(data))>>0)
+#define DC_PHY_READ_COM_CTRL_get_read_com_sel(data)                                  ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_CAL_CTRL                                                              0x18008908
+#define DC_PHY_CAL_CTRL_reg_addr                                                     "0xB8008908"
+#define DC_PHY_CAL_CTRL_reg                                                          0xB8008908
+#define set_DC_PHY_CAL_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL_CTRL_reg)=data)
+#define get_DC_PHY_CAL_CTRL_reg   (*((volatile unsigned int*) DC_PHY_CAL_CTRL_reg))
+#define DC_PHY_CAL_CTRL_inst_adr                                                     "0x0042"
+#define DC_PHY_CAL_CTRL_inst                                                         0x0042
+#define DC_PHY_CAL_CTRL_pos_trig_sel_shift                                           (8)
+#define DC_PHY_CAL_CTRL_pos_trig_sel_mask                                            (0x00000700)
+#define DC_PHY_CAL_CTRL_pos_trig_sel(data)                                           (0x00000700&((data)<<8))
+#define DC_PHY_CAL_CTRL_pos_trig_sel_src(data)                                       ((0x00000700&(data))>>8)
+#define DC_PHY_CAL_CTRL_get_pos_trig_sel(data)                                       ((0x00000700&(data))>>8)
+#define DC_PHY_CAL_CTRL_pre_trig_sel_shift                                           (4)
+#define DC_PHY_CAL_CTRL_pre_trig_sel_mask                                            (0x00000070)
+#define DC_PHY_CAL_CTRL_pre_trig_sel(data)                                           (0x00000070&((data)<<4))
+#define DC_PHY_CAL_CTRL_pre_trig_sel_src(data)                                       ((0x00000070&(data))>>4)
+#define DC_PHY_CAL_CTRL_get_pre_trig_sel(data)                                       ((0x00000070&(data))>>4)
+#define DC_PHY_CAL_CTRL_sync_cal_dlyn_shift                                          (1)
+#define DC_PHY_CAL_CTRL_sync_cal_dlyn_mask                                           (0x00000002)
+#define DC_PHY_CAL_CTRL_sync_cal_dlyn(data)                                          (0x00000002&((data)<<1))
+#define DC_PHY_CAL_CTRL_sync_cal_dlyn_src(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_CAL_CTRL_get_sync_cal_dlyn(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_CAL_CTRL_auto_cal_shift                                               (0)
+#define DC_PHY_CAL_CTRL_auto_cal_mask                                                (0x00000001)
+#define DC_PHY_CAL_CTRL_auto_cal(data)                                               (0x00000001&((data)<<0))
+#define DC_PHY_CAL_CTRL_auto_cal_src(data)                                           ((0x00000001&(data))>>0)
+#define DC_PHY_CAL_CTRL_get_auto_cal(data)                                           ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_FIFO_DLYN                                                             0x1800890C
+#define DC_PHY_FIFO_DLYN_reg_addr                                                    "0xB800890C"
+#define DC_PHY_FIFO_DLYN_reg                                                         0xB800890C
+#define set_DC_PHY_FIFO_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_DLYN_reg)=data)
+#define get_DC_PHY_FIFO_DLYN_reg   (*((volatile unsigned int*) DC_PHY_FIFO_DLYN_reg))
+#define DC_PHY_FIFO_DLYN_inst_adr                                                    "0x0043"
+#define DC_PHY_FIFO_DLYN_inst                                                        0x0043
+#define DC_PHY_FIFO_DLYN_gated_latch_sel_shift                                       (17)
+#define DC_PHY_FIFO_DLYN_gated_latch_sel_mask                                        (0x00020000)
+#define DC_PHY_FIFO_DLYN_gated_latch_sel(data)                                       (0x00020000&((data)<<17))
+#define DC_PHY_FIFO_DLYN_gated_latch_sel_src(data)                                   ((0x00020000&(data))>>17)
+#define DC_PHY_FIFO_DLYN_get_gated_latch_sel(data)                                   ((0x00020000&(data))>>17)
+#define DC_PHY_FIFO_DLYN_clk_ddr_phy_mux_div2_0_ph_sel_shift                         (16)
+#define DC_PHY_FIFO_DLYN_clk_ddr_phy_mux_div2_0_ph_sel_mask                          (0x00010000)
+#define DC_PHY_FIFO_DLYN_clk_ddr_phy_mux_div2_0_ph_sel(data)                         (0x00010000&((data)<<16))
+#define DC_PHY_FIFO_DLYN_clk_ddr_phy_mux_div2_0_ph_sel_src(data)                     ((0x00010000&(data))>>16)
+#define DC_PHY_FIFO_DLYN_get_clk_ddr_phy_mux_div2_0_ph_sel(data)                     ((0x00010000&(data))>>16)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_odd_1_ph_sel_shift                             (15)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_odd_1_ph_sel_mask                              (0x00008000)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_odd_1_ph_sel(data)                             (0x00008000&((data)<<15))
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_odd_1_ph_sel_src(data)                         ((0x00008000&(data))>>15)
+#define DC_PHY_FIFO_DLYN_get_clk_ddr_div2_odd_1_ph_sel(data)                         ((0x00008000&(data))>>15)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_odd_0_ph_sel_shift                             (14)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_odd_0_ph_sel_mask                              (0x00004000)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_odd_0_ph_sel(data)                             (0x00004000&((data)<<14))
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_odd_0_ph_sel_src(data)                         ((0x00004000&(data))>>14)
+#define DC_PHY_FIFO_DLYN_get_clk_ddr_div2_odd_0_ph_sel(data)                         ((0x00004000&(data))>>14)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_1_ph_sel_shift                                 (13)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_1_ph_sel_mask                                  (0x00002000)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_1_ph_sel(data)                                 (0x00002000&((data)<<13))
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_1_ph_sel_src(data)                             ((0x00002000&(data))>>13)
+#define DC_PHY_FIFO_DLYN_get_clk_ddr_div2_1_ph_sel(data)                             ((0x00002000&(data))>>13)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_0_ph_sel_shift                                 (12)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_0_ph_sel_mask                                  (0x00001000)
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_0_ph_sel(data)                                 (0x00001000&((data)<<12))
+#define DC_PHY_FIFO_DLYN_clk_ddr_div2_0_ph_sel_src(data)                             ((0x00001000&(data))>>12)
+#define DC_PHY_FIFO_DLYN_get_clk_ddr_div2_0_ph_sel(data)                             ((0x00001000&(data))>>12)
+#define DC_PHY_FIFO_DLYN_Tx_dlc_sel_dck_1_shift                                      (8)
+#define DC_PHY_FIFO_DLYN_Tx_dlc_sel_dck_1_mask                                       (0x00000F00)
+#define DC_PHY_FIFO_DLYN_Tx_dlc_sel_dck_1(data)                                      (0x00000F00&((data)<<8))
+#define DC_PHY_FIFO_DLYN_Tx_dlc_sel_dck_1_src(data)                                  ((0x00000F00&(data))>>8)
+#define DC_PHY_FIFO_DLYN_get_Tx_dlc_sel_dck_1(data)                                  ((0x00000F00&(data))>>8)
+#define DC_PHY_FIFO_DLYN_dqsf_dlyn_shift                                             (4)
+#define DC_PHY_FIFO_DLYN_dqsf_dlyn_mask                                              (0x00000030)
+#define DC_PHY_FIFO_DLYN_dqsf_dlyn(data)                                             (0x00000030&((data)<<4))
+#define DC_PHY_FIFO_DLYN_dqsf_dlyn_src(data)                                         ((0x00000030&(data))>>4)
+#define DC_PHY_FIFO_DLYN_get_dqsf_dlyn(data)                                         ((0x00000030&(data))>>4)
+#define DC_PHY_FIFO_DLYN_Tx_dlc_sel_dck_shift                                        (0)
+#define DC_PHY_FIFO_DLYN_Tx_dlc_sel_dck_mask                                         (0x0000000F)
+#define DC_PHY_FIFO_DLYN_Tx_dlc_sel_dck(data)                                        (0x0000000F&((data)<<0))
+#define DC_PHY_FIFO_DLYN_Tx_dlc_sel_dck_src(data)                                    ((0x0000000F&(data))>>0)
+#define DC_PHY_FIFO_DLYN_get_Tx_dlc_sel_dck(data)                                    ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_PAD_OE_CTL                                                            0x18008910
+#define DC_PHY_PAD_OE_CTL_reg_addr                                                   "0xB8008910"
+#define DC_PHY_PAD_OE_CTL_reg                                                        0xB8008910
+#define set_DC_PHY_PAD_OE_CTL_reg(data)   (*((volatile unsigned int*) DC_PHY_PAD_OE_CTL_reg)=data)
+#define get_DC_PHY_PAD_OE_CTL_reg   (*((volatile unsigned int*) DC_PHY_PAD_OE_CTL_reg))
+#define DC_PHY_PAD_OE_CTL_inst_adr                                                   "0x0044"
+#define DC_PHY_PAD_OE_CTL_inst                                                       0x0044
+#define DC_PHY_PAD_OE_CTL_grp1_bk_oe_shift                                           (11)
+#define DC_PHY_PAD_OE_CTL_grp1_bk_oe_mask                                            (0x00000800)
+#define DC_PHY_PAD_OE_CTL_grp1_bk_oe(data)                                           (0x00000800&((data)<<11))
+#define DC_PHY_PAD_OE_CTL_grp1_bk_oe_src(data)                                       ((0x00000800&(data))>>11)
+#define DC_PHY_PAD_OE_CTL_get_grp1_bk_oe(data)                                       ((0x00000800&(data))>>11)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_oe_shift                                        (10)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_oe_mask                                         (0x00000400)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_oe(data)                                        (0x00000400&((data)<<10))
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_oe_src(data)                                    ((0x00000400&(data))>>10)
+#define DC_PHY_PAD_OE_CTL_get_grp1_addr1_oe(data)                                    ((0x00000400&(data))>>10)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_oe_shift                                         (9)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_oe_mask                                          (0x00000200)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_oe(data)                                         (0x00000200&((data)<<9))
+#define DC_PHY_PAD_OE_CTL_grp1_addr_oe_src(data)                                     ((0x00000200&(data))>>9)
+#define DC_PHY_PAD_OE_CTL_get_grp1_addr_oe(data)                                     ((0x00000200&(data))>>9)
+#define DC_PHY_PAD_OE_CTL_grp1_cke_oe_shift                                          (8)
+#define DC_PHY_PAD_OE_CTL_grp1_cke_oe_mask                                           (0x00000100)
+#define DC_PHY_PAD_OE_CTL_grp1_cke_oe(data)                                          (0x00000100&((data)<<8))
+#define DC_PHY_PAD_OE_CTL_grp1_cke_oe_src(data)                                      ((0x00000100&(data))>>8)
+#define DC_PHY_PAD_OE_CTL_get_grp1_cke_oe(data)                                      ((0x00000100&(data))>>8)
+#define DC_PHY_PAD_OE_CTL_grp1_ck_oe_shift                                           (7)
+#define DC_PHY_PAD_OE_CTL_grp1_ck_oe_mask                                            (0x00000080)
+#define DC_PHY_PAD_OE_CTL_grp1_ck_oe(data)                                           (0x00000080&((data)<<7))
+#define DC_PHY_PAD_OE_CTL_grp1_ck_oe_src(data)                                       ((0x00000080&(data))>>7)
+#define DC_PHY_PAD_OE_CTL_get_grp1_ck_oe(data)                                       ((0x00000080&(data))>>7)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_15_oe_shift                                     (6)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_15_oe_mask                                      (0x00000040)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_15_oe(data)                                     (0x00000040&((data)<<6))
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_15_oe_src(data)                                 ((0x00000040&(data))>>6)
+#define DC_PHY_PAD_OE_CTL_get_grp1_addr1_15_oe(data)                                 ((0x00000040&(data))>>6)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_14_oe_shift                                     (5)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_14_oe_mask                                      (0x00000020)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_14_oe(data)                                     (0x00000020&((data)<<5))
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_14_oe_src(data)                                 ((0x00000020&(data))>>5)
+#define DC_PHY_PAD_OE_CTL_get_grp1_addr1_14_oe(data)                                 ((0x00000020&(data))>>5)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_13_oe_shift                                     (4)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_13_oe_mask                                      (0x00000010)
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_13_oe(data)                                     (0x00000010&((data)<<4))
+#define DC_PHY_PAD_OE_CTL_grp1_addr1_13_oe_src(data)                                 ((0x00000010&(data))>>4)
+#define DC_PHY_PAD_OE_CTL_get_grp1_addr1_13_oe(data)                                 ((0x00000010&(data))>>4)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_15_oe_shift                                      (3)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_15_oe_mask                                       (0x00000008)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_15_oe(data)                                      (0x00000008&((data)<<3))
+#define DC_PHY_PAD_OE_CTL_grp1_addr_15_oe_src(data)                                  ((0x00000008&(data))>>3)
+#define DC_PHY_PAD_OE_CTL_get_grp1_addr_15_oe(data)                                  ((0x00000008&(data))>>3)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_14_oe_shift                                      (2)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_14_oe_mask                                       (0x00000004)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_14_oe(data)                                      (0x00000004&((data)<<2))
+#define DC_PHY_PAD_OE_CTL_grp1_addr_14_oe_src(data)                                  ((0x00000004&(data))>>2)
+#define DC_PHY_PAD_OE_CTL_get_grp1_addr_14_oe(data)                                  ((0x00000004&(data))>>2)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_13_oe_shift                                      (1)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_13_oe_mask                                       (0x00000002)
+#define DC_PHY_PAD_OE_CTL_grp1_addr_13_oe(data)                                      (0x00000002&((data)<<1))
+#define DC_PHY_PAD_OE_CTL_grp1_addr_13_oe_src(data)                                  ((0x00000002&(data))>>1)
+#define DC_PHY_PAD_OE_CTL_get_grp1_addr_13_oe(data)                                  ((0x00000002&(data))>>1)
+
+
+#define DC_PHY_PAD_IDDQ0                                                             0x18008918
+#define DC_PHY_PAD_IDDQ0_reg_addr                                                    "0xB8008918"
+#define DC_PHY_PAD_IDDQ0_reg                                                         0xB8008918
+#define set_DC_PHY_PAD_IDDQ0_reg(data)   (*((volatile unsigned int*) DC_PHY_PAD_IDDQ0_reg)=data)
+#define get_DC_PHY_PAD_IDDQ0_reg   (*((volatile unsigned int*) DC_PHY_PAD_IDDQ0_reg))
+#define DC_PHY_PAD_IDDQ0_inst_adr                                                    "0x0046"
+#define DC_PHY_PAD_IDDQ0_inst                                                        0x0046
+#define DC_PHY_PAD_IDDQ0_iddq_0_shift                                                (0)
+#define DC_PHY_PAD_IDDQ0_iddq_0_mask                                                 (0x00001FFF)
+#define DC_PHY_PAD_IDDQ0_iddq_0(data)                                                (0x00001FFF&((data)<<0))
+#define DC_PHY_PAD_IDDQ0_iddq_0_src(data)                                            ((0x00001FFF&(data))>>0)
+#define DC_PHY_PAD_IDDQ0_get_iddq_0(data)                                            ((0x00001FFF&(data))>>0)
+
+
+#define DC_PHY_PAD_ZCTRL_OVRD                                                        0x18008924
+#define DC_PHY_PAD_ZCTRL_OVRD_reg_addr                                               "0xB8008924"
+#define DC_PHY_PAD_ZCTRL_OVRD_reg                                                    0xB8008924
+#define set_DC_PHY_PAD_ZCTRL_OVRD_reg(data)   (*((volatile unsigned int*) DC_PHY_PAD_ZCTRL_OVRD_reg)=data)
+#define get_DC_PHY_PAD_ZCTRL_OVRD_reg   (*((volatile unsigned int*) DC_PHY_PAD_ZCTRL_OVRD_reg))
+#define DC_PHY_PAD_ZCTRL_OVRD_inst_adr                                               "0x0049"
+#define DC_PHY_PAD_ZCTRL_OVRD_inst                                                   0x0049
+#define DC_PHY_PAD_ZCTRL_OVRD_refctrl_pdref_shift                                    (24)
+#define DC_PHY_PAD_ZCTRL_OVRD_refctrl_pdref_mask                                     (0x01000000)
+#define DC_PHY_PAD_ZCTRL_OVRD_refctrl_pdref(data)                                    (0x01000000&((data)<<24))
+#define DC_PHY_PAD_ZCTRL_OVRD_refctrl_pdref_src(data)                                ((0x01000000&(data))>>24)
+#define DC_PHY_PAD_ZCTRL_OVRD_get_refctrl_pdref(data)                                ((0x01000000&(data))>>24)
+#define DC_PHY_PAD_ZCTRL_OVRD_zctrl_ovrd_en_shift                                    (22)
+#define DC_PHY_PAD_ZCTRL_OVRD_zctrl_ovrd_en_mask                                     (0x00400000)
+#define DC_PHY_PAD_ZCTRL_OVRD_zctrl_ovrd_en(data)                                    (0x00400000&((data)<<22))
+#define DC_PHY_PAD_ZCTRL_OVRD_zctrl_ovrd_en_src(data)                                ((0x00400000&(data))>>22)
+#define DC_PHY_PAD_ZCTRL_OVRD_get_zctrl_ovrd_en(data)                                ((0x00400000&(data))>>22)
+#define DC_PHY_PAD_ZCTRL_OVRD_zctrl_ovrd_data_shift                                  (0)
+#define DC_PHY_PAD_ZCTRL_OVRD_zctrl_ovrd_data_mask                                   (0x003FFFFF)
+#define DC_PHY_PAD_ZCTRL_OVRD_zctrl_ovrd_data(data)                                  (0x003FFFFF&((data)<<0))
+#define DC_PHY_PAD_ZCTRL_OVRD_zctrl_ovrd_data_src(data)                              ((0x003FFFFF&(data))>>0)
+#define DC_PHY_PAD_ZCTRL_OVRD_get_zctrl_ovrd_data(data)                              ((0x003FFFFF&(data))>>0)
+
+
+#define DC_PHY_PAD_CTRL_PROG                                                         0x18008928
+#define DC_PHY_PAD_CTRL_PROG_reg_addr                                                "0xB8008928"
+#define DC_PHY_PAD_CTRL_PROG_reg                                                     0xB8008928
+#define set_DC_PHY_PAD_CTRL_PROG_reg(data)   (*((volatile unsigned int*) DC_PHY_PAD_CTRL_PROG_reg)=data)
+#define get_DC_PHY_PAD_CTRL_PROG_reg   (*((volatile unsigned int*) DC_PHY_PAD_CTRL_PROG_reg))
+#define DC_PHY_PAD_CTRL_PROG_inst_adr                                                "0x004A"
+#define DC_PHY_PAD_CTRL_PROG_inst                                                    0x004A
+#define DC_PHY_PAD_CTRL_PROG_ocd_mode_shift                                          (27)
+#define DC_PHY_PAD_CTRL_PROG_ocd_mode_mask                                           (0x08000000)
+#define DC_PHY_PAD_CTRL_PROG_ocd_mode(data)                                          (0x08000000&((data)<<27))
+#define DC_PHY_PAD_CTRL_PROG_ocd_mode_src(data)                                      ((0x08000000&(data))>>27)
+#define DC_PHY_PAD_CTRL_PROG_get_ocd_mode(data)                                      ((0x08000000&(data))>>27)
+#define DC_PHY_PAD_CTRL_PROG_dzq_up_sel_shift                                        (24)
+#define DC_PHY_PAD_CTRL_PROG_dzq_up_sel_mask                                         (0x07000000)
+#define DC_PHY_PAD_CTRL_PROG_dzq_up_sel(data)                                        (0x07000000&((data)<<24))
+#define DC_PHY_PAD_CTRL_PROG_dzq_up_sel_src(data)                                    ((0x07000000&(data))>>24)
+#define DC_PHY_PAD_CTRL_PROG_get_dzq_up_sel(data)                                    ((0x07000000&(data))>>24)
+#define DC_PHY_PAD_CTRL_PROG_dzq_auto_up_shift                                       (23)
+#define DC_PHY_PAD_CTRL_PROG_dzq_auto_up_mask                                        (0x00800000)
+#define DC_PHY_PAD_CTRL_PROG_dzq_auto_up(data)                                       (0x00800000&((data)<<23))
+#define DC_PHY_PAD_CTRL_PROG_dzq_auto_up_src(data)                                   ((0x00800000&(data))>>23)
+#define DC_PHY_PAD_CTRL_PROG_get_dzq_auto_up(data)                                   ((0x00800000&(data))>>23)
+#define DC_PHY_PAD_CTRL_PROG_zctrl_clk_sel_shift                                     (21)
+#define DC_PHY_PAD_CTRL_PROG_zctrl_clk_sel_mask                                      (0x00600000)
+#define DC_PHY_PAD_CTRL_PROG_zctrl_clk_sel(data)                                     (0x00600000&((data)<<21))
+#define DC_PHY_PAD_CTRL_PROG_zctrl_clk_sel_src(data)                                 ((0x00600000&(data))>>21)
+#define DC_PHY_PAD_CTRL_PROG_get_zctrl_clk_sel(data)                                 ((0x00600000&(data))>>21)
+#define DC_PHY_PAD_CTRL_PROG_zctrl_start_shift                                       (20)
+#define DC_PHY_PAD_CTRL_PROG_zctrl_start_mask                                        (0x00100000)
+#define DC_PHY_PAD_CTRL_PROG_zctrl_start(data)                                       (0x00100000&((data)<<20))
+#define DC_PHY_PAD_CTRL_PROG_zctrl_start_src(data)                                   ((0x00100000&(data))>>20)
+#define DC_PHY_PAD_CTRL_PROG_get_zctrl_start(data)                                   ((0x00100000&(data))>>20)
+#define DC_PHY_PAD_CTRL_PROG_dzq_ref_up_shift                                        (19)
+#define DC_PHY_PAD_CTRL_PROG_dzq_ref_up_mask                                         (0x00080000)
+#define DC_PHY_PAD_CTRL_PROG_dzq_ref_up(data)                                        (0x00080000&((data)<<19))
+#define DC_PHY_PAD_CTRL_PROG_dzq_ref_up_src(data)                                    ((0x00080000&(data))>>19)
+#define DC_PHY_PAD_CTRL_PROG_get_dzq_ref_up(data)                                    ((0x00080000&(data))>>19)
+#define DC_PHY_PAD_CTRL_PROG_ext_r240_sel_shift                                      (18)
+#define DC_PHY_PAD_CTRL_PROG_ext_r240_sel_mask                                       (0x00040000)
+#define DC_PHY_PAD_CTRL_PROG_ext_r240_sel(data)                                      (0x00040000&((data)<<18))
+#define DC_PHY_PAD_CTRL_PROG_ext_r240_sel_src(data)                                  ((0x00040000&(data))>>18)
+#define DC_PHY_PAD_CTRL_PROG_get_ext_r240_sel(data)                                  ((0x00040000&(data))>>18)
+#define DC_PHY_PAD_CTRL_PROG_rzq_zcomp_inv_shift                                     (17)
+#define DC_PHY_PAD_CTRL_PROG_rzq_zcomp_inv_mask                                      (0x00020000)
+#define DC_PHY_PAD_CTRL_PROG_rzq_zcomp_inv(data)                                     (0x00020000&((data)<<17))
+#define DC_PHY_PAD_CTRL_PROG_rzq_zcomp_inv_src(data)                                 ((0x00020000&(data))>>17)
+#define DC_PHY_PAD_CTRL_PROG_get_rzq_zcomp_inv(data)                                 ((0x00020000&(data))>>17)
+#define DC_PHY_PAD_CTRL_PROG_rzq_cal_en_shift                                        (16)
+#define DC_PHY_PAD_CTRL_PROG_rzq_cal_en_mask                                         (0x00010000)
+#define DC_PHY_PAD_CTRL_PROG_rzq_cal_en(data)                                        (0x00010000&((data)<<16))
+#define DC_PHY_PAD_CTRL_PROG_rzq_cal_en_src(data)                                    ((0x00010000&(data))>>16)
+#define DC_PHY_PAD_CTRL_PROG_get_rzq_cal_en(data)                                    ((0x00010000&(data))>>16)
+#define DC_PHY_PAD_CTRL_PROG_zprog_shift                                             (0)
+#define DC_PHY_PAD_CTRL_PROG_zprog_mask                                              (0x00003FFF)
+#define DC_PHY_PAD_CTRL_PROG_zprog(data)                                             (0x00003FFF&((data)<<0))
+#define DC_PHY_PAD_CTRL_PROG_zprog_src(data)                                         ((0x00003FFF&(data))>>0)
+#define DC_PHY_PAD_CTRL_PROG_get_zprog(data)                                         ((0x00003FFF&(data))>>0)
+
+
+#define DC_PHY_PAD_ZCTRL_STATUS                                                      0x1800892C
+#define DC_PHY_PAD_ZCTRL_STATUS_reg_addr                                             "0xB800892C"
+#define DC_PHY_PAD_ZCTRL_STATUS_reg                                                  0xB800892C
+#define set_DC_PHY_PAD_ZCTRL_STATUS_reg(data)   (*((volatile unsigned int*) DC_PHY_PAD_ZCTRL_STATUS_reg)=data)
+#define get_DC_PHY_PAD_ZCTRL_STATUS_reg   (*((volatile unsigned int*) DC_PHY_PAD_ZCTRL_STATUS_reg))
+#define DC_PHY_PAD_ZCTRL_STATUS_inst_adr                                             "0x004B"
+#define DC_PHY_PAD_ZCTRL_STATUS_inst                                                 0x004B
+#define DC_PHY_PAD_ZCTRL_STATUS_zctrl_status_shift                                   (0)
+#define DC_PHY_PAD_ZCTRL_STATUS_zctrl_status_mask                                    (0xFFFFFFFF)
+#define DC_PHY_PAD_ZCTRL_STATUS_zctrl_status(data)                                   (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_PAD_ZCTRL_STATUS_zctrl_status_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_PAD_ZCTRL_STATUS_get_zctrl_status(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DQ_DLY_SEL0                                                           0x18008930
+#define DC_PHY_DQ_DLY_SEL0_reg_addr                                                  "0xB8008930"
+#define DC_PHY_DQ_DLY_SEL0_reg                                                       0xB8008930
+#define set_DC_PHY_DQ_DLY_SEL0_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ_DLY_SEL0_reg)=data)
+#define get_DC_PHY_DQ_DLY_SEL0_reg   (*((volatile unsigned int*) DC_PHY_DQ_DLY_SEL0_reg))
+#define DC_PHY_DQ_DLY_SEL0_inst_adr                                                  "0x004C"
+#define DC_PHY_DQ_DLY_SEL0_inst                                                      0x004C
+#define DC_PHY_DQ_DLY_SEL0_dq_dly_sel0_shift                                         (0)
+#define DC_PHY_DQ_DLY_SEL0_dq_dly_sel0_mask                                          (0xFFFFFFFF)
+#define DC_PHY_DQ_DLY_SEL0_dq_dly_sel0(data)                                         (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DQ_DLY_SEL0_dq_dly_sel0_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DQ_DLY_SEL0_get_dq_dly_sel0(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DQ_DLY_SEL1                                                           0x18008934
+#define DC_PHY_DQ_DLY_SEL1_reg_addr                                                  "0xB8008934"
+#define DC_PHY_DQ_DLY_SEL1_reg                                                       0xB8008934
+#define set_DC_PHY_DQ_DLY_SEL1_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ_DLY_SEL1_reg)=data)
+#define get_DC_PHY_DQ_DLY_SEL1_reg   (*((volatile unsigned int*) DC_PHY_DQ_DLY_SEL1_reg))
+#define DC_PHY_DQ_DLY_SEL1_inst_adr                                                  "0x004D"
+#define DC_PHY_DQ_DLY_SEL1_inst                                                      0x004D
+#define DC_PHY_DQ_DLY_SEL1_dq_dly_sel1_shift                                         (0)
+#define DC_PHY_DQ_DLY_SEL1_dq_dly_sel1_mask                                          (0xFFFFFFFF)
+#define DC_PHY_DQ_DLY_SEL1_dq_dly_sel1(data)                                         (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DQ_DLY_SEL1_dq_dly_sel1_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DQ_DLY_SEL1_get_dq_dly_sel1(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DQ_DLY_SEL2                                                           0x18008938
+#define DC_PHY_DQ_DLY_SEL2_reg_addr                                                  "0xB8008938"
+#define DC_PHY_DQ_DLY_SEL2_reg                                                       0xB8008938
+#define set_DC_PHY_DQ_DLY_SEL2_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ_DLY_SEL2_reg)=data)
+#define get_DC_PHY_DQ_DLY_SEL2_reg   (*((volatile unsigned int*) DC_PHY_DQ_DLY_SEL2_reg))
+#define DC_PHY_DQ_DLY_SEL2_inst_adr                                                  "0x004E"
+#define DC_PHY_DQ_DLY_SEL2_inst                                                      0x004E
+#define DC_PHY_DQ_DLY_SEL2_dq_dly_sel2_shift                                         (0)
+#define DC_PHY_DQ_DLY_SEL2_dq_dly_sel2_mask                                          (0xFFFFFFFF)
+#define DC_PHY_DQ_DLY_SEL2_dq_dly_sel2(data)                                         (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DQ_DLY_SEL2_dq_dly_sel2_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DQ_DLY_SEL2_get_dq_dly_sel2(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DQ_DLY_SEL3                                                           0x1800893C
+#define DC_PHY_DQ_DLY_SEL3_reg_addr                                                  "0xB800893C"
+#define DC_PHY_DQ_DLY_SEL3_reg                                                       0xB800893C
+#define set_DC_PHY_DQ_DLY_SEL3_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ_DLY_SEL3_reg)=data)
+#define get_DC_PHY_DQ_DLY_SEL3_reg   (*((volatile unsigned int*) DC_PHY_DQ_DLY_SEL3_reg))
+#define DC_PHY_DQ_DLY_SEL3_inst_adr                                                  "0x004F"
+#define DC_PHY_DQ_DLY_SEL3_inst                                                      0x004F
+#define DC_PHY_DQ_DLY_SEL3_dq_dly_sel3_shift                                         (0)
+#define DC_PHY_DQ_DLY_SEL3_dq_dly_sel3_mask                                          (0xFFFFFFFF)
+#define DC_PHY_DQ_DLY_SEL3_dq_dly_sel3(data)                                         (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DQ_DLY_SEL3_dq_dly_sel3_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DQ_DLY_SEL3_get_dq_dly_sel3(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DQS_OE_DLY_SEL                                                        0x18008940
+#define DC_PHY_DQS_OE_DLY_SEL_reg_addr                                               "0xB8008940"
+#define DC_PHY_DQS_OE_DLY_SEL_reg                                                    0xB8008940
+#define set_DC_PHY_DQS_OE_DLY_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DQS_OE_DLY_SEL_reg)=data)
+#define get_DC_PHY_DQS_OE_DLY_SEL_reg   (*((volatile unsigned int*) DC_PHY_DQS_OE_DLY_SEL_reg))
+#define DC_PHY_DQS_OE_DLY_SEL_inst_adr                                               "0x0050"
+#define DC_PHY_DQS_OE_DLY_SEL_inst                                                   0x0050
+#define DC_PHY_DQS_OE_DLY_SEL_dqs_oe_dly_sel_shift                                   (0)
+#define DC_PHY_DQS_OE_DLY_SEL_dqs_oe_dly_sel_mask                                    (0x00000FFF)
+#define DC_PHY_DQS_OE_DLY_SEL_dqs_oe_dly_sel(data)                                   (0x00000FFF&((data)<<0))
+#define DC_PHY_DQS_OE_DLY_SEL_dqs_oe_dly_sel_src(data)                               ((0x00000FFF&(data))>>0)
+#define DC_PHY_DQS_OE_DLY_SEL_get_dqs_oe_dly_sel(data)                               ((0x00000FFF&(data))>>0)
+
+
+#define DC_PHY_HALF_CYCLE_CAL_EN                                                     0x18008944
+#define DC_PHY_HALF_CYCLE_CAL_EN_reg_addr                                            "0xB8008944"
+#define DC_PHY_HALF_CYCLE_CAL_EN_reg                                                 0xB8008944
+#define set_DC_PHY_HALF_CYCLE_CAL_EN_reg(data)   (*((volatile unsigned int*) DC_PHY_HALF_CYCLE_CAL_EN_reg)=data)
+#define get_DC_PHY_HALF_CYCLE_CAL_EN_reg   (*((volatile unsigned int*) DC_PHY_HALF_CYCLE_CAL_EN_reg))
+#define DC_PHY_HALF_CYCLE_CAL_EN_inst_adr                                            "0x0051"
+#define DC_PHY_HALF_CYCLE_CAL_EN_inst                                                0x0051
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_cal_sel_shift                            (17)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_cal_sel_mask                             (0x00020000)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_cal_sel(data)                            (0x00020000&((data)<<17))
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_cal_sel_src(data)                        ((0x00020000&(data))>>17)
+#define DC_PHY_HALF_CYCLE_CAL_EN_get_half_cycle_cal_sel(data)                        ((0x00020000&(data))>>17)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_ref_thr_shift                            (9)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_ref_thr_mask                             (0x0001FE00)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_ref_thr(data)                            (0x0001FE00&((data)<<9))
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_ref_thr_src(data)                        ((0x0001FE00&(data))>>9)
+#define DC_PHY_HALF_CYCLE_CAL_EN_get_half_cycle_ref_thr(data)                        ((0x0001FE00&(data))>>9)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_res_thr_shift                            (3)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_res_thr_mask                             (0x000001F8)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_res_thr(data)                            (0x000001F8&((data)<<3))
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_res_thr_src(data)                        ((0x000001F8&(data))>>3)
+#define DC_PHY_HALF_CYCLE_CAL_EN_get_half_cycle_res_thr(data)                        ((0x000001F8&(data))>>3)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_res_mod_shift                            (1)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_res_mod_mask                             (0x00000006)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_res_mod(data)                            (0x00000006&((data)<<1))
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_res_mod_src(data)                        ((0x00000006&(data))>>1)
+#define DC_PHY_HALF_CYCLE_CAL_EN_get_half_cycle_res_mod(data)                        ((0x00000006&(data))>>1)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_cal_en_shift                             (0)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_cal_en_mask                              (0x00000001)
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_cal_en(data)                             (0x00000001&((data)<<0))
+#define DC_PHY_HALF_CYCLE_CAL_EN_half_cycle_cal_en_src(data)                         ((0x00000001&(data))>>0)
+#define DC_PHY_HALF_CYCLE_CAL_EN_get_half_cycle_cal_en(data)                         ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_HALF_CYCLE_CAL_SET                                                    0x18008948
+#define DC_PHY_HALF_CYCLE_CAL_SET_reg_addr                                           "0xB8008948"
+#define DC_PHY_HALF_CYCLE_CAL_SET_reg                                                0xB8008948
+#define set_DC_PHY_HALF_CYCLE_CAL_SET_reg(data)   (*((volatile unsigned int*) DC_PHY_HALF_CYCLE_CAL_SET_reg)=data)
+#define get_DC_PHY_HALF_CYCLE_CAL_SET_reg   (*((volatile unsigned int*) DC_PHY_HALF_CYCLE_CAL_SET_reg))
+#define DC_PHY_HALF_CYCLE_CAL_SET_inst_adr                                           "0x0052"
+#define DC_PHY_HALF_CYCLE_CAL_SET_inst                                               0x0052
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_3_shift                     (18)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_3_mask                      (0x00FC0000)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_3(data)                     (0x00FC0000&((data)<<18))
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_3_src(data)                 ((0x00FC0000&(data))>>18)
+#define DC_PHY_HALF_CYCLE_CAL_SET_get_half_cycle_cal_setting_3(data)                 ((0x00FC0000&(data))>>18)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_2_shift                     (12)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_2_mask                      (0x0003F000)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_2(data)                     (0x0003F000&((data)<<12))
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_2_src(data)                 ((0x0003F000&(data))>>12)
+#define DC_PHY_HALF_CYCLE_CAL_SET_get_half_cycle_cal_setting_2(data)                 ((0x0003F000&(data))>>12)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_1_shift                     (6)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_1_mask                      (0x00000FC0)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_1(data)                     (0x00000FC0&((data)<<6))
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_1_src(data)                 ((0x00000FC0&(data))>>6)
+#define DC_PHY_HALF_CYCLE_CAL_SET_get_half_cycle_cal_setting_1(data)                 ((0x00000FC0&(data))>>6)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_0_shift                     (0)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_0_mask                      (0x0000003F)
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_0(data)                     (0x0000003F&((data)<<0))
+#define DC_PHY_HALF_CYCLE_CAL_SET_half_cycle_cal_setting_0_src(data)                 ((0x0000003F&(data))>>0)
+#define DC_PHY_HALF_CYCLE_CAL_SET_get_half_cycle_cal_setting_0(data)                 ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_PUPD_DLY_NUM                                                          0x1800894C
+#define DC_PHY_PUPD_DLY_NUM_reg_addr                                                 "0xB800894C"
+#define DC_PHY_PUPD_DLY_NUM_reg                                                      0xB800894C
+#define set_DC_PHY_PUPD_DLY_NUM_reg(data)   (*((volatile unsigned int*) DC_PHY_PUPD_DLY_NUM_reg)=data)
+#define get_DC_PHY_PUPD_DLY_NUM_reg   (*((volatile unsigned int*) DC_PHY_PUPD_DLY_NUM_reg))
+#define DC_PHY_PUPD_DLY_NUM_inst_adr                                                 "0x0053"
+#define DC_PHY_PUPD_DLY_NUM_inst                                                     0x0053
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_mux_sel_shift                                   (22)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_mux_sel_mask                                    (0x00C00000)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_mux_sel(data)                                   (0x00C00000&((data)<<22))
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_mux_sel_src(data)                               ((0x00C00000&(data))>>22)
+#define DC_PHY_PUPD_DLY_NUM_get_pupd_dly_mux_sel(data)                               ((0x00C00000&(data))>>22)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_sel_shift                                   (20)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_sel_mask                                    (0x00300000)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_sel(data)                                   (0x00300000&((data)<<20))
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_sel_src(data)                               ((0x00300000&(data))>>20)
+#define DC_PHY_PUPD_DLY_NUM_get_pupd_dly_num_sel(data)                               ((0x00300000&(data))>>20)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_3_shift                                     (15)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_3_mask                                      (0x000F8000)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_3(data)                                     (0x000F8000&((data)<<15))
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_3_src(data)                                 ((0x000F8000&(data))>>15)
+#define DC_PHY_PUPD_DLY_NUM_get_pupd_dly_num_3(data)                                 ((0x000F8000&(data))>>15)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_2_shift                                     (10)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_2_mask                                      (0x00007C00)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_2(data)                                     (0x00007C00&((data)<<10))
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_2_src(data)                                 ((0x00007C00&(data))>>10)
+#define DC_PHY_PUPD_DLY_NUM_get_pupd_dly_num_2(data)                                 ((0x00007C00&(data))>>10)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_1_shift                                     (5)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_1_mask                                      (0x000003E0)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_1(data)                                     (0x000003E0&((data)<<5))
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_1_src(data)                                 ((0x000003E0&(data))>>5)
+#define DC_PHY_PUPD_DLY_NUM_get_pupd_dly_num_1(data)                                 ((0x000003E0&(data))>>5)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_0_shift                                     (0)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_0_mask                                      (0x0000001F)
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_0(data)                                     (0x0000001F&((data)<<0))
+#define DC_PHY_PUPD_DLY_NUM_pupd_dly_num_0_src(data)                                 ((0x0000001F&(data))>>0)
+#define DC_PHY_PUPD_DLY_NUM_get_pupd_dly_num_0(data)                                 ((0x0000001F&(data))>>0)
+
+
+#define DC_PHY_DQS_DLYN                                                              0x18008950
+#define DC_PHY_DQS_DLYN_reg_addr                                                     "0xB8008950"
+#define DC_PHY_DQS_DLYN_reg                                                          0xB8008950
+#define set_DC_PHY_DQS_DLYN_reg(data)   (*((volatile unsigned int*) DC_PHY_DQS_DLYN_reg)=data)
+#define get_DC_PHY_DQS_DLYN_reg   (*((volatile unsigned int*) DC_PHY_DQS_DLYN_reg))
+#define DC_PHY_DQS_DLYN_inst_adr                                                     "0x0054"
+#define DC_PHY_DQS_DLYN_inst                                                         0x0054
+#define DC_PHY_DQS_DLYN_dqs3_det_0_dlyn_shift                                        (28)
+#define DC_PHY_DQS_DLYN_dqs3_det_0_dlyn_mask                                         (0xF0000000)
+#define DC_PHY_DQS_DLYN_dqs3_det_0_dlyn(data)                                        (0xF0000000&((data)<<28))
+#define DC_PHY_DQS_DLYN_dqs3_det_0_dlyn_src(data)                                    ((0xF0000000&(data))>>28)
+#define DC_PHY_DQS_DLYN_get_dqs3_det_0_dlyn(data)                                    ((0xF0000000&(data))>>28)
+#define DC_PHY_DQS_DLYN_dqs2_det_0_dlyn_shift                                        (24)
+#define DC_PHY_DQS_DLYN_dqs2_det_0_dlyn_mask                                         (0x0F000000)
+#define DC_PHY_DQS_DLYN_dqs2_det_0_dlyn(data)                                        (0x0F000000&((data)<<24))
+#define DC_PHY_DQS_DLYN_dqs2_det_0_dlyn_src(data)                                    ((0x0F000000&(data))>>24)
+#define DC_PHY_DQS_DLYN_get_dqs2_det_0_dlyn(data)                                    ((0x0F000000&(data))>>24)
+#define DC_PHY_DQS_DLYN_dqs1_det_0_dlyn_shift                                        (20)
+#define DC_PHY_DQS_DLYN_dqs1_det_0_dlyn_mask                                         (0x00F00000)
+#define DC_PHY_DQS_DLYN_dqs1_det_0_dlyn(data)                                        (0x00F00000&((data)<<20))
+#define DC_PHY_DQS_DLYN_dqs1_det_0_dlyn_src(data)                                    ((0x00F00000&(data))>>20)
+#define DC_PHY_DQS_DLYN_get_dqs1_det_0_dlyn(data)                                    ((0x00F00000&(data))>>20)
+#define DC_PHY_DQS_DLYN_dqs0_det_0_dlyn_shift                                        (16)
+#define DC_PHY_DQS_DLYN_dqs0_det_0_dlyn_mask                                         (0x000F0000)
+#define DC_PHY_DQS_DLYN_dqs0_det_0_dlyn(data)                                        (0x000F0000&((data)<<16))
+#define DC_PHY_DQS_DLYN_dqs0_det_0_dlyn_src(data)                                    ((0x000F0000&(data))>>16)
+#define DC_PHY_DQS_DLYN_get_dqs0_det_0_dlyn(data)                                    ((0x000F0000&(data))>>16)
+#define DC_PHY_DQS_DLYN_dqs3_en_0_dlyn_shift                                         (12)
+#define DC_PHY_DQS_DLYN_dqs3_en_0_dlyn_mask                                          (0x0000F000)
+#define DC_PHY_DQS_DLYN_dqs3_en_0_dlyn(data)                                         (0x0000F000&((data)<<12))
+#define DC_PHY_DQS_DLYN_dqs3_en_0_dlyn_src(data)                                     ((0x0000F000&(data))>>12)
+#define DC_PHY_DQS_DLYN_get_dqs3_en_0_dlyn(data)                                     ((0x0000F000&(data))>>12)
+#define DC_PHY_DQS_DLYN_dqs2_en_0_dlyn_shift                                         (8)
+#define DC_PHY_DQS_DLYN_dqs2_en_0_dlyn_mask                                          (0x00000F00)
+#define DC_PHY_DQS_DLYN_dqs2_en_0_dlyn(data)                                         (0x00000F00&((data)<<8))
+#define DC_PHY_DQS_DLYN_dqs2_en_0_dlyn_src(data)                                     ((0x00000F00&(data))>>8)
+#define DC_PHY_DQS_DLYN_get_dqs2_en_0_dlyn(data)                                     ((0x00000F00&(data))>>8)
+#define DC_PHY_DQS_DLYN_dqs1_en_0_dlyn_shift                                         (4)
+#define DC_PHY_DQS_DLYN_dqs1_en_0_dlyn_mask                                          (0x000000F0)
+#define DC_PHY_DQS_DLYN_dqs1_en_0_dlyn(data)                                         (0x000000F0&((data)<<4))
+#define DC_PHY_DQS_DLYN_dqs1_en_0_dlyn_src(data)                                     ((0x000000F0&(data))>>4)
+#define DC_PHY_DQS_DLYN_get_dqs1_en_0_dlyn(data)                                     ((0x000000F0&(data))>>4)
+#define DC_PHY_DQS_DLYN_dqs0_en_0_dlyn_shift                                         (0)
+#define DC_PHY_DQS_DLYN_dqs0_en_0_dlyn_mask                                          (0x0000000F)
+#define DC_PHY_DQS_DLYN_dqs0_en_0_dlyn(data)                                         (0x0000000F&((data)<<0))
+#define DC_PHY_DQS_DLYN_dqs0_en_0_dlyn_src(data)                                     ((0x0000000F&(data))>>0)
+#define DC_PHY_DQS_DLYN_get_dqs0_en_0_dlyn(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_CAL_MODE                                                              0x18008954
+#define DC_PHY_CAL_MODE_reg_addr                                                     "0xB8008954"
+#define DC_PHY_CAL_MODE_reg                                                          0xB8008954
+#define set_DC_PHY_CAL_MODE_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL_MODE_reg)=data)
+#define get_DC_PHY_CAL_MODE_reg   (*((volatile unsigned int*) DC_PHY_CAL_MODE_reg))
+#define DC_PHY_CAL_MODE_inst_adr                                                     "0x0055"
+#define DC_PHY_CAL_MODE_inst                                                         0x0055
+#define DC_PHY_CAL_MODE_pupd_mode_shift                                              (13)
+#define DC_PHY_CAL_MODE_pupd_mode_mask                                               (0x00006000)
+#define DC_PHY_CAL_MODE_pupd_mode(data)                                              (0x00006000&((data)<<13))
+#define DC_PHY_CAL_MODE_pupd_mode_src(data)                                          ((0x00006000&(data))>>13)
+#define DC_PHY_CAL_MODE_get_pupd_mode(data)                                          ((0x00006000&(data))>>13)
+#define DC_PHY_CAL_MODE_cal_order_shift                                              (12)
+#define DC_PHY_CAL_MODE_cal_order_mask                                               (0x00001000)
+#define DC_PHY_CAL_MODE_cal_order(data)                                              (0x00001000&((data)<<12))
+#define DC_PHY_CAL_MODE_cal_order_src(data)                                          ((0x00001000&(data))>>12)
+#define DC_PHY_CAL_MODE_get_cal_order(data)                                          ((0x00001000&(data))>>12)
+#define DC_PHY_CAL_MODE_cal_mode_split_shift                                         (11)
+#define DC_PHY_CAL_MODE_cal_mode_split_mask                                          (0x00000800)
+#define DC_PHY_CAL_MODE_cal_mode_split(data)                                         (0x00000800&((data)<<11))
+#define DC_PHY_CAL_MODE_cal_mode_split_src(data)                                     ((0x00000800&(data))>>11)
+#define DC_PHY_CAL_MODE_get_cal_mode_split(data)                                     ((0x00000800&(data))>>11)
+#define DC_PHY_CAL_MODE_cal_zq_only_shift                                            (10)
+#define DC_PHY_CAL_MODE_cal_zq_only_mask                                             (0x00000400)
+#define DC_PHY_CAL_MODE_cal_zq_only(data)                                            (0x00000400&((data)<<10))
+#define DC_PHY_CAL_MODE_cal_zq_only_src(data)                                        ((0x00000400&(data))>>10)
+#define DC_PHY_CAL_MODE_get_cal_zq_only(data)                                        ((0x00000400&(data))>>10)
+#define DC_PHY_CAL_MODE_cal_zq_shift                                                 (9)
+#define DC_PHY_CAL_MODE_cal_zq_mask                                                  (0x00000200)
+#define DC_PHY_CAL_MODE_cal_zq(data)                                                 (0x00000200&((data)<<9))
+#define DC_PHY_CAL_MODE_cal_zq_src(data)                                             ((0x00000200&(data))>>9)
+#define DC_PHY_CAL_MODE_get_cal_zq(data)                                             ((0x00000200&(data))>>9)
+#define DC_PHY_CAL_MODE_cal_all_rang_noml_shift                                      (8)
+#define DC_PHY_CAL_MODE_cal_all_rang_noml_mask                                       (0x00000100)
+#define DC_PHY_CAL_MODE_cal_all_rang_noml(data)                                      (0x00000100&((data)<<8))
+#define DC_PHY_CAL_MODE_cal_all_rang_noml_src(data)                                  ((0x00000100&(data))>>8)
+#define DC_PHY_CAL_MODE_get_cal_all_rang_noml(data)                                  ((0x00000100&(data))>>8)
+#define DC_PHY_CAL_MODE_cal_all_rang_init_shift                                      (7)
+#define DC_PHY_CAL_MODE_cal_all_rang_init_mask                                       (0x00000080)
+#define DC_PHY_CAL_MODE_cal_all_rang_init(data)                                      (0x00000080&((data)<<7))
+#define DC_PHY_CAL_MODE_cal_all_rang_init_src(data)                                  ((0x00000080&(data))>>7)
+#define DC_PHY_CAL_MODE_get_cal_all_rang_init(data)                                  ((0x00000080&(data))>>7)
+#define DC_PHY_CAL_MODE_auto_cal_en_noml_shift                                       (6)
+#define DC_PHY_CAL_MODE_auto_cal_en_noml_mask                                        (0x00000040)
+#define DC_PHY_CAL_MODE_auto_cal_en_noml(data)                                       (0x00000040&((data)<<6))
+#define DC_PHY_CAL_MODE_auto_cal_en_noml_src(data)                                   ((0x00000040&(data))>>6)
+#define DC_PHY_CAL_MODE_get_auto_cal_en_noml(data)                                   ((0x00000040&(data))>>6)
+#define DC_PHY_CAL_MODE_auto_cal_en_init_shift                                       (5)
+#define DC_PHY_CAL_MODE_auto_cal_en_init_mask                                        (0x00000020)
+#define DC_PHY_CAL_MODE_auto_cal_en_init(data)                                       (0x00000020&((data)<<5))
+#define DC_PHY_CAL_MODE_auto_cal_en_init_src(data)                                   ((0x00000020&(data))>>5)
+#define DC_PHY_CAL_MODE_get_auto_cal_en_init(data)                                   ((0x00000020&(data))>>5)
+#define DC_PHY_CAL_MODE_dqs_val_sel_shift                                            (4)
+#define DC_PHY_CAL_MODE_dqs_val_sel_mask                                             (0x00000010)
+#define DC_PHY_CAL_MODE_dqs_val_sel(data)                                            (0x00000010&((data)<<4))
+#define DC_PHY_CAL_MODE_dqs_val_sel_src(data)                                        ((0x00000010&(data))>>4)
+#define DC_PHY_CAL_MODE_get_dqs_val_sel(data)                                        ((0x00000010&(data))>>4)
+#define DC_PHY_CAL_MODE_cal_mode_shift                                               (1)
+#define DC_PHY_CAL_MODE_cal_mode_mask                                                (0x0000000E)
+#define DC_PHY_CAL_MODE_cal_mode(data)                                               (0x0000000E&((data)<<1))
+#define DC_PHY_CAL_MODE_cal_mode_src(data)                                           ((0x0000000E&(data))>>1)
+#define DC_PHY_CAL_MODE_get_cal_mode(data)                                           ((0x0000000E&(data))>>1)
+#define DC_PHY_CAL_MODE_dq_sel_shift                                                 (0)
+#define DC_PHY_CAL_MODE_dq_sel_mask                                                  (0x00000001)
+#define DC_PHY_CAL_MODE_dq_sel(data)                                                 (0x00000001&((data)<<0))
+#define DC_PHY_CAL_MODE_dq_sel_src(data)                                             ((0x00000001&(data))>>0)
+#define DC_PHY_CAL_MODE_get_dq_sel(data)                                             ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_CAL_ADDR                                                              0x18008958
+#define DC_PHY_CAL_ADDR_reg_addr                                                     "0xB8008958"
+#define DC_PHY_CAL_ADDR_reg                                                          0xB8008958
+#define set_DC_PHY_CAL_ADDR_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL_ADDR_reg)=data)
+#define get_DC_PHY_CAL_ADDR_reg   (*((volatile unsigned int*) DC_PHY_CAL_ADDR_reg))
+#define DC_PHY_CAL_ADDR_inst_adr                                                     "0x0056"
+#define DC_PHY_CAL_ADDR_inst                                                         0x0056
+#define DC_PHY_CAL_ADDR_cal_ba_shift                                                 (23)
+#define DC_PHY_CAL_ADDR_cal_ba_mask                                                  (0x03800000)
+#define DC_PHY_CAL_ADDR_cal_ba(data)                                                 (0x03800000&((data)<<23))
+#define DC_PHY_CAL_ADDR_cal_ba_src(data)                                             ((0x03800000&(data))>>23)
+#define DC_PHY_CAL_ADDR_get_cal_ba(data)                                             ((0x03800000&(data))>>23)
+#define DC_PHY_CAL_ADDR_cal_col_shift                                                (13)
+#define DC_PHY_CAL_ADDR_cal_col_mask                                                 (0x007FE000)
+#define DC_PHY_CAL_ADDR_cal_col(data)                                                (0x007FE000&((data)<<13))
+#define DC_PHY_CAL_ADDR_cal_col_src(data)                                            ((0x007FE000&(data))>>13)
+#define DC_PHY_CAL_ADDR_get_cal_col(data)                                            ((0x007FE000&(data))>>13)
+#define DC_PHY_CAL_ADDR_cal_row_shift                                                (0)
+#define DC_PHY_CAL_ADDR_cal_row_mask                                                 (0x00001FFF)
+#define DC_PHY_CAL_ADDR_cal_row(data)                                                (0x00001FFF&((data)<<0))
+#define DC_PHY_CAL_ADDR_cal_row_src(data)                                            ((0x00001FFF&(data))>>0)
+#define DC_PHY_CAL_ADDR_get_cal_row(data)                                            ((0x00001FFF&(data))>>0)
+
+
+#define DC_PHY_RESULT_CAL_TAP_0                                                      0x1800895c
+#define DC_PHY_RESULT_CAL_TAP_0_reg_addr                                             "0xB800895C"
+#define DC_PHY_RESULT_CAL_TAP_0_reg                                                  0xB800895C
+#define set_DC_PHY_RESULT_CAL_TAP_0_reg(data)   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_0_reg)=data)
+#define get_DC_PHY_RESULT_CAL_TAP_0_reg   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_0_reg))
+#define DC_PHY_RESULT_CAL_TAP_0_inst_adr                                             "0x0057"
+#define DC_PHY_RESULT_CAL_TAP_0_inst                                                 0x0057
+#define DC_PHY_RESULT_CAL_TAP_0_end_done_01_p_shift                                  (19)
+#define DC_PHY_RESULT_CAL_TAP_0_end_done_01_p_mask                                   (0x00080000)
+#define DC_PHY_RESULT_CAL_TAP_0_end_done_01_p(data)                                  (0x00080000&((data)<<19))
+#define DC_PHY_RESULT_CAL_TAP_0_end_done_01_p_src(data)                              ((0x00080000&(data))>>19)
+#define DC_PHY_RESULT_CAL_TAP_0_get_end_done_01_p(data)                              ((0x00080000&(data))>>19)
+#define DC_PHY_RESULT_CAL_TAP_0_start_done_01_p_shift                                (18)
+#define DC_PHY_RESULT_CAL_TAP_0_start_done_01_p_mask                                 (0x00040000)
+#define DC_PHY_RESULT_CAL_TAP_0_start_done_01_p(data)                                (0x00040000&((data)<<18))
+#define DC_PHY_RESULT_CAL_TAP_0_start_done_01_p_src(data)                            ((0x00040000&(data))>>18)
+#define DC_PHY_RESULT_CAL_TAP_0_get_start_done_01_p(data)                            ((0x00040000&(data))>>18)
+#define DC_PHY_RESULT_CAL_TAP_0_best_dly_01_p_shift                                  (12)
+#define DC_PHY_RESULT_CAL_TAP_0_best_dly_01_p_mask                                   (0x0003F000)
+#define DC_PHY_RESULT_CAL_TAP_0_best_dly_01_p(data)                                  (0x0003F000&((data)<<12))
+#define DC_PHY_RESULT_CAL_TAP_0_best_dly_01_p_src(data)                              ((0x0003F000&(data))>>12)
+#define DC_PHY_RESULT_CAL_TAP_0_get_best_dly_01_p(data)                              ((0x0003F000&(data))>>12)
+#define DC_PHY_RESULT_CAL_TAP_0_end_pt_01_p_shift                                    (6)
+#define DC_PHY_RESULT_CAL_TAP_0_end_pt_01_p_mask                                     (0x00000FC0)
+#define DC_PHY_RESULT_CAL_TAP_0_end_pt_01_p(data)                                    (0x00000FC0&((data)<<6))
+#define DC_PHY_RESULT_CAL_TAP_0_end_pt_01_p_src(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_RESULT_CAL_TAP_0_get_end_pt_01_p(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_RESULT_CAL_TAP_0_start_pt_01_p_shift                                  (0)
+#define DC_PHY_RESULT_CAL_TAP_0_start_pt_01_p_mask                                   (0x0000003F)
+#define DC_PHY_RESULT_CAL_TAP_0_start_pt_01_p(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_RESULT_CAL_TAP_0_start_pt_01_p_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_RESULT_CAL_TAP_0_get_start_pt_01_p(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_RESULT_CAL_TAP_1                                                      0x18008960
+#define DC_PHY_RESULT_CAL_TAP_1_reg_addr                                             "0xB8008960"
+#define DC_PHY_RESULT_CAL_TAP_1_reg                                                  0xB8008960
+#define set_DC_PHY_RESULT_CAL_TAP_1_reg(data)   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_1_reg)=data)
+#define get_DC_PHY_RESULT_CAL_TAP_1_reg   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_1_reg))
+#define DC_PHY_RESULT_CAL_TAP_1_inst_adr                                             "0x0058"
+#define DC_PHY_RESULT_CAL_TAP_1_inst                                                 0x0058
+#define DC_PHY_RESULT_CAL_TAP_1_end_done_01_n_shift                                  (19)
+#define DC_PHY_RESULT_CAL_TAP_1_end_done_01_n_mask                                   (0x00080000)
+#define DC_PHY_RESULT_CAL_TAP_1_end_done_01_n(data)                                  (0x00080000&((data)<<19))
+#define DC_PHY_RESULT_CAL_TAP_1_end_done_01_n_src(data)                              ((0x00080000&(data))>>19)
+#define DC_PHY_RESULT_CAL_TAP_1_get_end_done_01_n(data)                              ((0x00080000&(data))>>19)
+#define DC_PHY_RESULT_CAL_TAP_1_start_done_01_n_shift                                (18)
+#define DC_PHY_RESULT_CAL_TAP_1_start_done_01_n_mask                                 (0x00040000)
+#define DC_PHY_RESULT_CAL_TAP_1_start_done_01_n(data)                                (0x00040000&((data)<<18))
+#define DC_PHY_RESULT_CAL_TAP_1_start_done_01_n_src(data)                            ((0x00040000&(data))>>18)
+#define DC_PHY_RESULT_CAL_TAP_1_get_start_done_01_n(data)                            ((0x00040000&(data))>>18)
+#define DC_PHY_RESULT_CAL_TAP_1_best_dly_01_n_shift                                  (12)
+#define DC_PHY_RESULT_CAL_TAP_1_best_dly_01_n_mask                                   (0x0003F000)
+#define DC_PHY_RESULT_CAL_TAP_1_best_dly_01_n(data)                                  (0x0003F000&((data)<<12))
+#define DC_PHY_RESULT_CAL_TAP_1_best_dly_01_n_src(data)                              ((0x0003F000&(data))>>12)
+#define DC_PHY_RESULT_CAL_TAP_1_get_best_dly_01_n(data)                              ((0x0003F000&(data))>>12)
+#define DC_PHY_RESULT_CAL_TAP_1_end_pt_01_n_shift                                    (6)
+#define DC_PHY_RESULT_CAL_TAP_1_end_pt_01_n_mask                                     (0x00000FC0)
+#define DC_PHY_RESULT_CAL_TAP_1_end_pt_01_n(data)                                    (0x00000FC0&((data)<<6))
+#define DC_PHY_RESULT_CAL_TAP_1_end_pt_01_n_src(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_RESULT_CAL_TAP_1_get_end_pt_01_n(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_RESULT_CAL_TAP_1_start_pt_01_n_shift                                  (0)
+#define DC_PHY_RESULT_CAL_TAP_1_start_pt_01_n_mask                                   (0x0000003F)
+#define DC_PHY_RESULT_CAL_TAP_1_start_pt_01_n(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_RESULT_CAL_TAP_1_start_pt_01_n_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_RESULT_CAL_TAP_1_get_start_pt_01_n(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_RESULT_CAL_TAP_2                                                      0x18008964
+#define DC_PHY_RESULT_CAL_TAP_2_reg_addr                                             "0xB8008964"
+#define DC_PHY_RESULT_CAL_TAP_2_reg                                                  0xB8008964
+#define set_DC_PHY_RESULT_CAL_TAP_2_reg(data)   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_2_reg)=data)
+#define get_DC_PHY_RESULT_CAL_TAP_2_reg   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_2_reg))
+#define DC_PHY_RESULT_CAL_TAP_2_inst_adr                                             "0x0059"
+#define DC_PHY_RESULT_CAL_TAP_2_inst                                                 0x0059
+#define DC_PHY_RESULT_CAL_TAP_2_end_done_23_p_shift                                  (19)
+#define DC_PHY_RESULT_CAL_TAP_2_end_done_23_p_mask                                   (0x00080000)
+#define DC_PHY_RESULT_CAL_TAP_2_end_done_23_p(data)                                  (0x00080000&((data)<<19))
+#define DC_PHY_RESULT_CAL_TAP_2_end_done_23_p_src(data)                              ((0x00080000&(data))>>19)
+#define DC_PHY_RESULT_CAL_TAP_2_get_end_done_23_p(data)                              ((0x00080000&(data))>>19)
+#define DC_PHY_RESULT_CAL_TAP_2_start_done_23_p_shift                                (18)
+#define DC_PHY_RESULT_CAL_TAP_2_start_done_23_p_mask                                 (0x00040000)
+#define DC_PHY_RESULT_CAL_TAP_2_start_done_23_p(data)                                (0x00040000&((data)<<18))
+#define DC_PHY_RESULT_CAL_TAP_2_start_done_23_p_src(data)                            ((0x00040000&(data))>>18)
+#define DC_PHY_RESULT_CAL_TAP_2_get_start_done_23_p(data)                            ((0x00040000&(data))>>18)
+#define DC_PHY_RESULT_CAL_TAP_2_best_dly_23_p_shift                                  (12)
+#define DC_PHY_RESULT_CAL_TAP_2_best_dly_23_p_mask                                   (0x0003F000)
+#define DC_PHY_RESULT_CAL_TAP_2_best_dly_23_p(data)                                  (0x0003F000&((data)<<12))
+#define DC_PHY_RESULT_CAL_TAP_2_best_dly_23_p_src(data)                              ((0x0003F000&(data))>>12)
+#define DC_PHY_RESULT_CAL_TAP_2_get_best_dly_23_p(data)                              ((0x0003F000&(data))>>12)
+#define DC_PHY_RESULT_CAL_TAP_2_end_pt_23_p_shift                                    (6)
+#define DC_PHY_RESULT_CAL_TAP_2_end_pt_23_p_mask                                     (0x00000FC0)
+#define DC_PHY_RESULT_CAL_TAP_2_end_pt_23_p(data)                                    (0x00000FC0&((data)<<6))
+#define DC_PHY_RESULT_CAL_TAP_2_end_pt_23_p_src(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_RESULT_CAL_TAP_2_get_end_pt_23_p(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_RESULT_CAL_TAP_2_start_pt_23_p_shift                                  (0)
+#define DC_PHY_RESULT_CAL_TAP_2_start_pt_23_p_mask                                   (0x0000003F)
+#define DC_PHY_RESULT_CAL_TAP_2_start_pt_23_p(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_RESULT_CAL_TAP_2_start_pt_23_p_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_RESULT_CAL_TAP_2_get_start_pt_23_p(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_RESULT_CAL_TAP_3                                                      0x18008968
+#define DC_PHY_RESULT_CAL_TAP_3_reg_addr                                             "0xB8008968"
+#define DC_PHY_RESULT_CAL_TAP_3_reg                                                  0xB8008968
+#define set_DC_PHY_RESULT_CAL_TAP_3_reg(data)   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_3_reg)=data)
+#define get_DC_PHY_RESULT_CAL_TAP_3_reg   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_3_reg))
+#define DC_PHY_RESULT_CAL_TAP_3_inst_adr                                             "0x005A"
+#define DC_PHY_RESULT_CAL_TAP_3_inst                                                 0x005A
+#define DC_PHY_RESULT_CAL_TAP_3_end_done_23_n_shift                                  (19)
+#define DC_PHY_RESULT_CAL_TAP_3_end_done_23_n_mask                                   (0x00080000)
+#define DC_PHY_RESULT_CAL_TAP_3_end_done_23_n(data)                                  (0x00080000&((data)<<19))
+#define DC_PHY_RESULT_CAL_TAP_3_end_done_23_n_src(data)                              ((0x00080000&(data))>>19)
+#define DC_PHY_RESULT_CAL_TAP_3_get_end_done_23_n(data)                              ((0x00080000&(data))>>19)
+#define DC_PHY_RESULT_CAL_TAP_3_start_done_23_n_shift                                (18)
+#define DC_PHY_RESULT_CAL_TAP_3_start_done_23_n_mask                                 (0x00040000)
+#define DC_PHY_RESULT_CAL_TAP_3_start_done_23_n(data)                                (0x00040000&((data)<<18))
+#define DC_PHY_RESULT_CAL_TAP_3_start_done_23_n_src(data)                            ((0x00040000&(data))>>18)
+#define DC_PHY_RESULT_CAL_TAP_3_get_start_done_23_n(data)                            ((0x00040000&(data))>>18)
+#define DC_PHY_RESULT_CAL_TAP_3_best_dly_23_n_shift                                  (12)
+#define DC_PHY_RESULT_CAL_TAP_3_best_dly_23_n_mask                                   (0x0003F000)
+#define DC_PHY_RESULT_CAL_TAP_3_best_dly_23_n(data)                                  (0x0003F000&((data)<<12))
+#define DC_PHY_RESULT_CAL_TAP_3_best_dly_23_n_src(data)                              ((0x0003F000&(data))>>12)
+#define DC_PHY_RESULT_CAL_TAP_3_get_best_dly_23_n(data)                              ((0x0003F000&(data))>>12)
+#define DC_PHY_RESULT_CAL_TAP_3_end_pt_23_n_shift                                    (6)
+#define DC_PHY_RESULT_CAL_TAP_3_end_pt_23_n_mask                                     (0x00000FC0)
+#define DC_PHY_RESULT_CAL_TAP_3_end_pt_23_n(data)                                    (0x00000FC0&((data)<<6))
+#define DC_PHY_RESULT_CAL_TAP_3_end_pt_23_n_src(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_RESULT_CAL_TAP_3_get_end_pt_23_n(data)                                ((0x00000FC0&(data))>>6)
+#define DC_PHY_RESULT_CAL_TAP_3_start_pt_23_n_shift                                  (0)
+#define DC_PHY_RESULT_CAL_TAP_3_start_pt_23_n_mask                                   (0x0000003F)
+#define DC_PHY_RESULT_CAL_TAP_3_start_pt_23_n(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_RESULT_CAL_TAP_3_start_pt_23_n_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_RESULT_CAL_TAP_3_get_start_pt_23_n(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_RESULT_CAL_TAP_4                                                      0x1800896c
+#define DC_PHY_RESULT_CAL_TAP_4_reg_addr                                             "0xB800896C"
+#define DC_PHY_RESULT_CAL_TAP_4_reg                                                  0xB800896C
+#define set_DC_PHY_RESULT_CAL_TAP_4_reg(data)   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_4_reg)=data)
+#define get_DC_PHY_RESULT_CAL_TAP_4_reg   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_4_reg))
+#define DC_PHY_RESULT_CAL_TAP_4_inst_adr                                             "0x005B"
+#define DC_PHY_RESULT_CAL_TAP_4_inst                                                 0x005B
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_n_odt_shift                            (7)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_n_odt_mask                             (0x00000080)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_n_odt(data)                            (0x00000080&((data)<<7))
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_n_odt_src(data)                        ((0x00000080&(data))>>7)
+#define DC_PHY_RESULT_CAL_TAP_4_get_wk_big_thr_23_n_odt(data)                        ((0x00000080&(data))>>7)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_p_odt_shift                            (6)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_p_odt_mask                             (0x00000040)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_p_odt(data)                            (0x00000040&((data)<<6))
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_p_odt_src(data)                        ((0x00000040&(data))>>6)
+#define DC_PHY_RESULT_CAL_TAP_4_get_wk_big_thr_23_p_odt(data)                        ((0x00000040&(data))>>6)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_n_odt_shift                            (5)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_n_odt_mask                             (0x00000020)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_n_odt(data)                            (0x00000020&((data)<<5))
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_n_odt_src(data)                        ((0x00000020&(data))>>5)
+#define DC_PHY_RESULT_CAL_TAP_4_get_wk_big_thr_01_n_odt(data)                        ((0x00000020&(data))>>5)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_p_odt_shift                            (4)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_p_odt_mask                             (0x00000010)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_p_odt(data)                            (0x00000010&((data)<<4))
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_p_odt_src(data)                        ((0x00000010&(data))>>4)
+#define DC_PHY_RESULT_CAL_TAP_4_get_wk_big_thr_01_p_odt(data)                        ((0x00000010&(data))>>4)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_n_dt_shift                             (3)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_n_dt_mask                              (0x00000008)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_n_dt(data)                             (0x00000008&((data)<<3))
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_n_dt_src(data)                         ((0x00000008&(data))>>3)
+#define DC_PHY_RESULT_CAL_TAP_4_get_wk_big_thr_23_n_dt(data)                         ((0x00000008&(data))>>3)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_p_dt_shift                             (2)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_p_dt_mask                              (0x00000004)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_p_dt(data)                             (0x00000004&((data)<<2))
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_23_p_dt_src(data)                         ((0x00000004&(data))>>2)
+#define DC_PHY_RESULT_CAL_TAP_4_get_wk_big_thr_23_p_dt(data)                         ((0x00000004&(data))>>2)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_n_dt_shift                             (1)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_n_dt_mask                              (0x00000002)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_n_dt(data)                             (0x00000002&((data)<<1))
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_n_dt_src(data)                         ((0x00000002&(data))>>1)
+#define DC_PHY_RESULT_CAL_TAP_4_get_wk_big_thr_01_n_dt(data)                         ((0x00000002&(data))>>1)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_p_dt_shift                             (0)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_p_dt_mask                              (0x00000001)
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_p_dt(data)                             (0x00000001&((data)<<0))
+#define DC_PHY_RESULT_CAL_TAP_4_wk_big_thr_01_p_dt_src(data)                         ((0x00000001&(data))>>0)
+#define DC_PHY_RESULT_CAL_TAP_4_get_wk_big_thr_01_p_dt(data)                         ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_RESULT_CAL_TAP_5                                                      0x18008970
+#define DC_PHY_RESULT_CAL_TAP_5_reg_addr                                             "0xB8008970"
+#define DC_PHY_RESULT_CAL_TAP_5_reg                                                  0xB8008970
+#define set_DC_PHY_RESULT_CAL_TAP_5_reg(data)   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_5_reg)=data)
+#define get_DC_PHY_RESULT_CAL_TAP_5_reg   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_5_reg))
+#define DC_PHY_RESULT_CAL_TAP_5_inst_adr                                             "0x005C"
+#define DC_PHY_RESULT_CAL_TAP_5_inst                                                 0x005C
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_n_odt_shift                               (24)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_n_odt_mask                                (0x3F000000)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_n_odt(data)                               (0x3F000000&((data)<<24))
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_n_odt_src(data)                           ((0x3F000000&(data))>>24)
+#define DC_PHY_RESULT_CAL_TAP_5_get_best_wk_01_n_odt(data)                           ((0x3F000000&(data))>>24)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_p_odt_shift                               (16)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_p_odt_mask                                (0x003F0000)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_p_odt(data)                               (0x003F0000&((data)<<16))
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_p_odt_src(data)                           ((0x003F0000&(data))>>16)
+#define DC_PHY_RESULT_CAL_TAP_5_get_best_wk_01_p_odt(data)                           ((0x003F0000&(data))>>16)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_n_dt_shift                                (8)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_n_dt_mask                                 (0x00003F00)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_n_dt(data)                                (0x00003F00&((data)<<8))
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_n_dt_src(data)                            ((0x00003F00&(data))>>8)
+#define DC_PHY_RESULT_CAL_TAP_5_get_best_wk_01_n_dt(data)                            ((0x00003F00&(data))>>8)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_p_dt_shift                                (0)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_p_dt_mask                                 (0x0000003F)
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_p_dt(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_RESULT_CAL_TAP_5_best_wk_01_p_dt_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_RESULT_CAL_TAP_5_get_best_wk_01_p_dt(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_RESULT_CAL_TAP_6                                                      0x18008974
+#define DC_PHY_RESULT_CAL_TAP_6_reg_addr                                             "0xB8008974"
+#define DC_PHY_RESULT_CAL_TAP_6_reg                                                  0xB8008974
+#define set_DC_PHY_RESULT_CAL_TAP_6_reg(data)   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_6_reg)=data)
+#define get_DC_PHY_RESULT_CAL_TAP_6_reg   (*((volatile unsigned int*) DC_PHY_RESULT_CAL_TAP_6_reg))
+#define DC_PHY_RESULT_CAL_TAP_6_inst_adr                                             "0x005D"
+#define DC_PHY_RESULT_CAL_TAP_6_inst                                                 0x005D
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_n_odt_shift                               (24)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_n_odt_mask                                (0x3F000000)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_n_odt(data)                               (0x3F000000&((data)<<24))
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_n_odt_src(data)                           ((0x3F000000&(data))>>24)
+#define DC_PHY_RESULT_CAL_TAP_6_get_best_wk_23_n_odt(data)                           ((0x3F000000&(data))>>24)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_p_odt_shift                               (16)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_p_odt_mask                                (0x003F0000)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_p_odt(data)                               (0x003F0000&((data)<<16))
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_p_odt_src(data)                           ((0x003F0000&(data))>>16)
+#define DC_PHY_RESULT_CAL_TAP_6_get_best_wk_23_p_odt(data)                           ((0x003F0000&(data))>>16)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_n_dt_shift                                (8)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_n_dt_mask                                 (0x00003F00)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_n_dt(data)                                (0x00003F00&((data)<<8))
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_n_dt_src(data)                            ((0x00003F00&(data))>>8)
+#define DC_PHY_RESULT_CAL_TAP_6_get_best_wk_23_n_dt(data)                            ((0x00003F00&(data))>>8)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_p_dt_shift                                (0)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_p_dt_mask                                 (0x0000003F)
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_p_dt(data)                                (0x0000003F&((data)<<0))
+#define DC_PHY_RESULT_CAL_TAP_6_best_wk_23_p_dt_src(data)                            ((0x0000003F&(data))>>0)
+#define DC_PHY_RESULT_CAL_TAP_6_get_best_wk_23_p_dt(data)                            ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_SYNC_RST_WK                                                           0x18008978
+#define DC_PHY_SYNC_RST_WK_reg_addr                                                  "0xB8008978"
+#define DC_PHY_SYNC_RST_WK_reg                                                       0xB8008978
+#define set_DC_PHY_SYNC_RST_WK_reg(data)   (*((volatile unsigned int*) DC_PHY_SYNC_RST_WK_reg)=data)
+#define get_DC_PHY_SYNC_RST_WK_reg   (*((volatile unsigned int*) DC_PHY_SYNC_RST_WK_reg))
+#define DC_PHY_SYNC_RST_WK_inst_adr                                                  "0x005E"
+#define DC_PHY_SYNC_RST_WK_inst                                                      0x005E
+#define DC_PHY_SYNC_RST_WK_odt_diff_threshold_shift                                  (16)
+#define DC_PHY_SYNC_RST_WK_odt_diff_threshold_mask                                   (0x003F0000)
+#define DC_PHY_SYNC_RST_WK_odt_diff_threshold(data)                                  (0x003F0000&((data)<<16))
+#define DC_PHY_SYNC_RST_WK_odt_diff_threshold_src(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_SYNC_RST_WK_get_odt_diff_threshold(data)                              ((0x003F0000&(data))>>16)
+#define DC_PHY_SYNC_RST_WK_duty_diff_threshold_shift                                 (8)
+#define DC_PHY_SYNC_RST_WK_duty_diff_threshold_mask                                  (0x00003F00)
+#define DC_PHY_SYNC_RST_WK_duty_diff_threshold(data)                                 (0x00003F00&((data)<<8))
+#define DC_PHY_SYNC_RST_WK_duty_diff_threshold_src(data)                             ((0x00003F00&(data))>>8)
+#define DC_PHY_SYNC_RST_WK_get_duty_diff_threshold(data)                             ((0x00003F00&(data))>>8)
+#define DC_PHY_SYNC_RST_WK_cal_proc_done_shift                                       (7)
+#define DC_PHY_SYNC_RST_WK_cal_proc_done_mask                                        (0x00000080)
+#define DC_PHY_SYNC_RST_WK_cal_proc_done(data)                                       (0x00000080&((data)<<7))
+#define DC_PHY_SYNC_RST_WK_cal_proc_done_src(data)                                   ((0x00000080&(data))>>7)
+#define DC_PHY_SYNC_RST_WK_get_cal_proc_done(data)                                   ((0x00000080&(data))>>7)
+#define DC_PHY_SYNC_RST_WK_wk_threshold_shift                                        (1)
+#define DC_PHY_SYNC_RST_WK_wk_threshold_mask                                         (0x0000007E)
+#define DC_PHY_SYNC_RST_WK_wk_threshold(data)                                        (0x0000007E&((data)<<1))
+#define DC_PHY_SYNC_RST_WK_wk_threshold_src(data)                                    ((0x0000007E&(data))>>1)
+#define DC_PHY_SYNC_RST_WK_get_wk_threshold(data)                                    ((0x0000007E&(data))>>1)
+#define DC_PHY_SYNC_RST_WK_sync_rst_wk_thr_shift                                     (0)
+#define DC_PHY_SYNC_RST_WK_sync_rst_wk_thr_mask                                      (0x00000001)
+#define DC_PHY_SYNC_RST_WK_sync_rst_wk_thr(data)                                     (0x00000001&((data)<<0))
+#define DC_PHY_SYNC_RST_WK_sync_rst_wk_thr_src(data)                                 ((0x00000001&(data))>>0)
+#define DC_PHY_SYNC_RST_WK_get_sync_rst_wk_thr(data)                                 ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_SYNC_RST_FIFO_PT                                                      0x1800897C
+#define DC_PHY_SYNC_RST_FIFO_PT_reg_addr                                             "0xB800897C"
+#define DC_PHY_SYNC_RST_FIFO_PT_reg                                                  0xB800897C
+#define set_DC_PHY_SYNC_RST_FIFO_PT_reg(data)   (*((volatile unsigned int*) DC_PHY_SYNC_RST_FIFO_PT_reg)=data)
+#define get_DC_PHY_SYNC_RST_FIFO_PT_reg   (*((volatile unsigned int*) DC_PHY_SYNC_RST_FIFO_PT_reg))
+#define DC_PHY_SYNC_RST_FIFO_PT_inst_adr                                             "0x005F"
+#define DC_PHY_SYNC_RST_FIFO_PT_inst                                                 0x005F
+#define DC_PHY_SYNC_RST_FIFO_PT_sync_rst_fifo_pt_shift                               (0)
+#define DC_PHY_SYNC_RST_FIFO_PT_sync_rst_fifo_pt_mask                                (0x00000001)
+#define DC_PHY_SYNC_RST_FIFO_PT_sync_rst_fifo_pt(data)                               (0x00000001&((data)<<0))
+#define DC_PHY_SYNC_RST_FIFO_PT_sync_rst_fifo_pt_src(data)                           ((0x00000001&(data))>>0)
+#define DC_PHY_SYNC_RST_FIFO_PT_get_sync_rst_fifo_pt(data)                           ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_CAL_OUT_DATA_A                                                        0x18008980
+#define DC_PHY_CAL_OUT_DATA_A_reg_addr                                               "0xB8008980"
+#define DC_PHY_CAL_OUT_DATA_A_reg                                                    0xB8008980
+#define set_DC_PHY_CAL_OUT_DATA_A_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL_OUT_DATA_A_reg)=data)
+#define get_DC_PHY_CAL_OUT_DATA_A_reg   (*((volatile unsigned int*) DC_PHY_CAL_OUT_DATA_A_reg))
+#define DC_PHY_CAL_OUT_DATA_A_inst_adr                                               "0x0060"
+#define DC_PHY_CAL_OUT_DATA_A_inst                                                   0x0060
+#define DC_PHY_CAL_OUT_DATA_A_cal_out_data_1_shift                                   (16)
+#define DC_PHY_CAL_OUT_DATA_A_cal_out_data_1_mask                                    (0xFFFF0000)
+#define DC_PHY_CAL_OUT_DATA_A_cal_out_data_1(data)                                   (0xFFFF0000&((data)<<16))
+#define DC_PHY_CAL_OUT_DATA_A_cal_out_data_1_src(data)                               ((0xFFFF0000&(data))>>16)
+#define DC_PHY_CAL_OUT_DATA_A_get_cal_out_data_1(data)                               ((0xFFFF0000&(data))>>16)
+#define DC_PHY_CAL_OUT_DATA_A_cal_out_data_0_shift                                   (0)
+#define DC_PHY_CAL_OUT_DATA_A_cal_out_data_0_mask                                    (0x0000FFFF)
+#define DC_PHY_CAL_OUT_DATA_A_cal_out_data_0(data)                                   (0x0000FFFF&((data)<<0))
+#define DC_PHY_CAL_OUT_DATA_A_cal_out_data_0_src(data)                               ((0x0000FFFF&(data))>>0)
+#define DC_PHY_CAL_OUT_DATA_A_get_cal_out_data_0(data)                               ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_CAL_OUT_DATA_B                                                        0x18008984
+#define DC_PHY_CAL_OUT_DATA_B_reg_addr                                               "0xB8008984"
+#define DC_PHY_CAL_OUT_DATA_B_reg                                                    0xB8008984
+#define set_DC_PHY_CAL_OUT_DATA_B_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL_OUT_DATA_B_reg)=data)
+#define get_DC_PHY_CAL_OUT_DATA_B_reg   (*((volatile unsigned int*) DC_PHY_CAL_OUT_DATA_B_reg))
+#define DC_PHY_CAL_OUT_DATA_B_inst_adr                                               "0x0061"
+#define DC_PHY_CAL_OUT_DATA_B_inst                                                   0x0061
+#define DC_PHY_CAL_OUT_DATA_B_cal_out_data_3_shift                                   (16)
+#define DC_PHY_CAL_OUT_DATA_B_cal_out_data_3_mask                                    (0xFFFF0000)
+#define DC_PHY_CAL_OUT_DATA_B_cal_out_data_3(data)                                   (0xFFFF0000&((data)<<16))
+#define DC_PHY_CAL_OUT_DATA_B_cal_out_data_3_src(data)                               ((0xFFFF0000&(data))>>16)
+#define DC_PHY_CAL_OUT_DATA_B_get_cal_out_data_3(data)                               ((0xFFFF0000&(data))>>16)
+#define DC_PHY_CAL_OUT_DATA_B_cal_out_data_2_shift                                   (0)
+#define DC_PHY_CAL_OUT_DATA_B_cal_out_data_2_mask                                    (0x0000FFFF)
+#define DC_PHY_CAL_OUT_DATA_B_cal_out_data_2(data)                                   (0x0000FFFF&((data)<<0))
+#define DC_PHY_CAL_OUT_DATA_B_cal_out_data_2_src(data)                               ((0x0000FFFF&(data))>>0)
+#define DC_PHY_CAL_OUT_DATA_B_get_cal_out_data_2(data)                               ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_CAL_GLD_DATA_A                                                        0x18008988
+#define DC_PHY_CAL_GLD_DATA_A_reg_addr                                               "0xB8008988"
+#define DC_PHY_CAL_GLD_DATA_A_reg                                                    0xB8008988
+#define set_DC_PHY_CAL_GLD_DATA_A_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL_GLD_DATA_A_reg)=data)
+#define get_DC_PHY_CAL_GLD_DATA_A_reg   (*((volatile unsigned int*) DC_PHY_CAL_GLD_DATA_A_reg))
+#define DC_PHY_CAL_GLD_DATA_A_inst_adr                                               "0x0062"
+#define DC_PHY_CAL_GLD_DATA_A_inst                                                   0x0062
+#define DC_PHY_CAL_GLD_DATA_A_cal_gld_data_1_shift                                   (16)
+#define DC_PHY_CAL_GLD_DATA_A_cal_gld_data_1_mask                                    (0xFFFF0000)
+#define DC_PHY_CAL_GLD_DATA_A_cal_gld_data_1(data)                                   (0xFFFF0000&((data)<<16))
+#define DC_PHY_CAL_GLD_DATA_A_cal_gld_data_1_src(data)                               ((0xFFFF0000&(data))>>16)
+#define DC_PHY_CAL_GLD_DATA_A_get_cal_gld_data_1(data)                               ((0xFFFF0000&(data))>>16)
+#define DC_PHY_CAL_GLD_DATA_A_cal_gld_data_0_shift                                   (0)
+#define DC_PHY_CAL_GLD_DATA_A_cal_gld_data_0_mask                                    (0x0000FFFF)
+#define DC_PHY_CAL_GLD_DATA_A_cal_gld_data_0(data)                                   (0x0000FFFF&((data)<<0))
+#define DC_PHY_CAL_GLD_DATA_A_cal_gld_data_0_src(data)                               ((0x0000FFFF&(data))>>0)
+#define DC_PHY_CAL_GLD_DATA_A_get_cal_gld_data_0(data)                               ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_CAL_GLD_DATA_B                                                        0x1800898C
+#define DC_PHY_CAL_GLD_DATA_B_reg_addr                                               "0xB800898C"
+#define DC_PHY_CAL_GLD_DATA_B_reg                                                    0xB800898C
+#define set_DC_PHY_CAL_GLD_DATA_B_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL_GLD_DATA_B_reg)=data)
+#define get_DC_PHY_CAL_GLD_DATA_B_reg   (*((volatile unsigned int*) DC_PHY_CAL_GLD_DATA_B_reg))
+#define DC_PHY_CAL_GLD_DATA_B_inst_adr                                               "0x0063"
+#define DC_PHY_CAL_GLD_DATA_B_inst                                                   0x0063
+#define DC_PHY_CAL_GLD_DATA_B_cal_gld_data_3_shift                                   (16)
+#define DC_PHY_CAL_GLD_DATA_B_cal_gld_data_3_mask                                    (0xFFFF0000)
+#define DC_PHY_CAL_GLD_DATA_B_cal_gld_data_3(data)                                   (0xFFFF0000&((data)<<16))
+#define DC_PHY_CAL_GLD_DATA_B_cal_gld_data_3_src(data)                               ((0xFFFF0000&(data))>>16)
+#define DC_PHY_CAL_GLD_DATA_B_get_cal_gld_data_3(data)                               ((0xFFFF0000&(data))>>16)
+#define DC_PHY_CAL_GLD_DATA_B_cal_gld_data_2_shift                                   (0)
+#define DC_PHY_CAL_GLD_DATA_B_cal_gld_data_2_mask                                    (0x0000FFFF)
+#define DC_PHY_CAL_GLD_DATA_B_cal_gld_data_2(data)                                   (0x0000FFFF&((data)<<0))
+#define DC_PHY_CAL_GLD_DATA_B_cal_gld_data_2_src(data)                               ((0x0000FFFF&(data))>>0)
+#define DC_PHY_CAL_GLD_DATA_B_get_cal_gld_data_2(data)                               ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_CAL_CNT_CTRL                                                          0x18008990
+#define DC_PHY_CAL_CNT_CTRL_reg_addr                                                 "0xB8008990"
+#define DC_PHY_CAL_CNT_CTRL_reg                                                      0xB8008990
+#define set_DC_PHY_CAL_CNT_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL_CNT_CTRL_reg)=data)
+#define get_DC_PHY_CAL_CNT_CTRL_reg   (*((volatile unsigned int*) DC_PHY_CAL_CNT_CTRL_reg))
+#define DC_PHY_CAL_CNT_CTRL_inst_adr                                                 "0x0064"
+#define DC_PHY_CAL_CNT_CTRL_inst                                                     0x0064
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_p_end_shift                                   (28)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_p_end_mask                                    (0xF0000000)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_p_end(data)                                   (0xF0000000&((data)<<28))
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_p_end_src(data)                               ((0xF0000000&(data))>>28)
+#define DC_PHY_CAL_CNT_CTRL_get_id_cal_cnt_p_end(data)                               ((0xF0000000&(data))>>28)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_p_srt_shift                                   (24)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_p_srt_mask                                    (0x0F000000)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_p_srt(data)                                   (0x0F000000&((data)<<24))
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_p_srt_src(data)                               ((0x0F000000&(data))>>24)
+#define DC_PHY_CAL_CNT_CTRL_get_id_cal_cnt_p_srt(data)                               ((0x0F000000&(data))>>24)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_n_end_shift                                   (20)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_n_end_mask                                    (0x00F00000)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_n_end(data)                                   (0x00F00000&((data)<<20))
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_n_end_src(data)                               ((0x00F00000&(data))>>20)
+#define DC_PHY_CAL_CNT_CTRL_get_id_cal_cnt_n_end(data)                               ((0x00F00000&(data))>>20)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_n_srt_shift                                   (16)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_n_srt_mask                                    (0x000F0000)
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_n_srt(data)                                   (0x000F0000&((data)<<16))
+#define DC_PHY_CAL_CNT_CTRL_id_cal_cnt_n_srt_src(data)                               ((0x000F0000&(data))>>16)
+#define DC_PHY_CAL_CNT_CTRL_get_id_cal_cnt_n_srt(data)                               ((0x000F0000&(data))>>16)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_p_end_shift                                  (12)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_p_end_mask                                   (0x0000F000)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_p_end(data)                                  (0x0000F000&((data)<<12))
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_p_end_src(data)                              ((0x0000F000&(data))>>12)
+#define DC_PHY_CAL_CNT_CTRL_get_odt_cal_cnt_p_end(data)                              ((0x0000F000&(data))>>12)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_p_srt_shift                                  (8)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_p_srt_mask                                   (0x00000F00)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_p_srt(data)                                  (0x00000F00&((data)<<8))
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_p_srt_src(data)                              ((0x00000F00&(data))>>8)
+#define DC_PHY_CAL_CNT_CTRL_get_odt_cal_cnt_p_srt(data)                              ((0x00000F00&(data))>>8)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_n_end_shift                                  (4)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_n_end_mask                                   (0x000000F0)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_n_end(data)                                  (0x000000F0&((data)<<4))
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_n_end_src(data)                              ((0x000000F0&(data))>>4)
+#define DC_PHY_CAL_CNT_CTRL_get_odt_cal_cnt_n_end(data)                              ((0x000000F0&(data))>>4)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_n_srt_shift                                  (0)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_n_srt_mask                                   (0x0000000F)
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_n_srt(data)                                  (0x0000000F&((data)<<0))
+#define DC_PHY_CAL_CNT_CTRL_odt_cal_cnt_n_srt_src(data)                              ((0x0000000F&(data))>>0)
+#define DC_PHY_CAL_CNT_CTRL_get_odt_cal_cnt_n_srt(data)                              ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_MUX2TO1_CTRL                                                          0x18008994
+#define DC_PHY_MUX2TO1_CTRL_reg_addr                                                 "0xB8008994"
+#define DC_PHY_MUX2TO1_CTRL_reg                                                      0xB8008994
+#define set_DC_PHY_MUX2TO1_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_MUX2TO1_CTRL_reg)=data)
+#define get_DC_PHY_MUX2TO1_CTRL_reg   (*((volatile unsigned int*) DC_PHY_MUX2TO1_CTRL_reg))
+#define DC_PHY_MUX2TO1_CTRL_inst_adr                                                 "0x0065"
+#define DC_PHY_MUX2TO1_CTRL_inst                                                     0x0065
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_1_mux_sel_shift                                  (11)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_1_mux_sel_mask                                   (0x00000800)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_1_mux_sel(data)                                  (0x00000800&((data)<<11))
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_1_mux_sel_src(data)                              ((0x00000800&(data))>>11)
+#define DC_PHY_MUX2TO1_CTRL_get_ddr_clk_1_mux_sel(data)                              ((0x00000800&(data))>>11)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_0_mux_sel_shift                                  (10)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_0_mux_sel_mask                                   (0x00000400)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_0_mux_sel(data)                                  (0x00000400&((data)<<10))
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_0_mux_sel_src(data)                              ((0x00000400&(data))>>10)
+#define DC_PHY_MUX2TO1_CTRL_get_ddr_clk_0_mux_sel(data)                              ((0x00000400&(data))>>10)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_1_2x_div2_ph_sel_shift                           (9)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_1_2x_div2_ph_sel_mask                            (0x00000200)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_1_2x_div2_ph_sel(data)                           (0x00000200&((data)<<9))
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_1_2x_div2_ph_sel_src(data)                       ((0x00000200&(data))>>9)
+#define DC_PHY_MUX2TO1_CTRL_get_ddr_clk_1_2x_div2_ph_sel(data)                       ((0x00000200&(data))>>9)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_0_2x_div2_ph_sel_shift                           (8)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_0_2x_div2_ph_sel_mask                            (0x00000100)
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_0_2x_div2_ph_sel(data)                           (0x00000100&((data)<<8))
+#define DC_PHY_MUX2TO1_CTRL_ddr_clk_0_2x_div2_ph_sel_src(data)                       ((0x00000100&(data))>>8)
+#define DC_PHY_MUX2TO1_CTRL_get_ddr_clk_0_2x_div2_ph_sel(data)                       ((0x00000100&(data))>>8)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs3_mux_sel_shift                                   (7)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs3_mux_sel_mask                                    (0x00000080)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs3_mux_sel(data)                                   (0x00000080&((data)<<7))
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs3_mux_sel_src(data)                               ((0x00000080&(data))>>7)
+#define DC_PHY_MUX2TO1_CTRL_get_mck_dqs3_mux_sel(data)                               ((0x00000080&(data))>>7)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs2_mux_sel_shift                                   (6)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs2_mux_sel_mask                                    (0x00000040)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs2_mux_sel(data)                                   (0x00000040&((data)<<6))
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs2_mux_sel_src(data)                               ((0x00000040&(data))>>6)
+#define DC_PHY_MUX2TO1_CTRL_get_mck_dqs2_mux_sel(data)                               ((0x00000040&(data))>>6)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs1_mux_sel_shift                                   (5)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs1_mux_sel_mask                                    (0x00000020)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs1_mux_sel(data)                                   (0x00000020&((data)<<5))
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs1_mux_sel_src(data)                               ((0x00000020&(data))>>5)
+#define DC_PHY_MUX2TO1_CTRL_get_mck_dqs1_mux_sel(data)                               ((0x00000020&(data))>>5)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs0_mux_sel_shift                                   (4)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs0_mux_sel_mask                                    (0x00000010)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs0_mux_sel(data)                                   (0x00000010&((data)<<4))
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs0_mux_sel_src(data)                               ((0x00000010&(data))>>4)
+#define DC_PHY_MUX2TO1_CTRL_get_mck_dqs0_mux_sel(data)                               ((0x00000010&(data))>>4)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs3_2x_div2_ph_sel_shift                            (3)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs3_2x_div2_ph_sel_mask                             (0x00000008)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs3_2x_div2_ph_sel(data)                            (0x00000008&((data)<<3))
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs3_2x_div2_ph_sel_src(data)                        ((0x00000008&(data))>>3)
+#define DC_PHY_MUX2TO1_CTRL_get_mck_dqs3_2x_div2_ph_sel(data)                        ((0x00000008&(data))>>3)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs2_2x_div2_ph_sel_shift                            (2)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs2_2x_div2_ph_sel_mask                             (0x00000004)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs2_2x_div2_ph_sel(data)                            (0x00000004&((data)<<2))
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs2_2x_div2_ph_sel_src(data)                        ((0x00000004&(data))>>2)
+#define DC_PHY_MUX2TO1_CTRL_get_mck_dqs2_2x_div2_ph_sel(data)                        ((0x00000004&(data))>>2)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs1_2x_div2_ph_sel_shift                            (1)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs1_2x_div2_ph_sel_mask                             (0x00000002)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs1_2x_div2_ph_sel(data)                            (0x00000002&((data)<<1))
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs1_2x_div2_ph_sel_src(data)                        ((0x00000002&(data))>>1)
+#define DC_PHY_MUX2TO1_CTRL_get_mck_dqs1_2x_div2_ph_sel(data)                        ((0x00000002&(data))>>1)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs0_2x_div2_ph_sel_shift                            (0)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs0_2x_div2_ph_sel_mask                             (0x00000001)
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs0_2x_div2_ph_sel(data)                            (0x00000001&((data)<<0))
+#define DC_PHY_MUX2TO1_CTRL_mck_dqs0_2x_div2_ph_sel_src(data)                        ((0x00000001&(data))>>0)
+#define DC_PHY_MUX2TO1_CTRL_get_mck_dqs0_2x_div2_ph_sel(data)                        ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_DUMMY_REG                                                             0x1800899C
+#define DC_PHY_DUMMY_REG_reg_addr                                                    "0xB800899C"
+#define DC_PHY_DUMMY_REG_reg                                                         0xB800899C
+#define set_DC_PHY_DUMMY_REG_reg(data)   (*((volatile unsigned int*) DC_PHY_DUMMY_REG_reg)=data)
+#define get_DC_PHY_DUMMY_REG_reg   (*((volatile unsigned int*) DC_PHY_DUMMY_REG_reg))
+#define DC_PHY_DUMMY_REG_inst_adr                                                    "0x0067"
+#define DC_PHY_DUMMY_REG_inst                                                        0x0067
+#define DC_PHY_DUMMY_REG_dummy_reg_shift                                             (0)
+#define DC_PHY_DUMMY_REG_dummy_reg_mask                                              (0xFFFFFFFF)
+#define DC_PHY_DUMMY_REG_dummy_reg(data)                                             (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DUMMY_REG_dummy_reg_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DUMMY_REG_get_dummy_reg(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DT_SET0                                                               0x18008a00
+#define DC_PHY_DT_SET0_reg_addr                                                      "0xB8008A00"
+#define DC_PHY_DT_SET0_reg                                                           0xB8008A00
+#define set_DC_PHY_DT_SET0_reg(data)   (*((volatile unsigned int*) DC_PHY_DT_SET0_reg)=data)
+#define get_DC_PHY_DT_SET0_reg   (*((volatile unsigned int*) DC_PHY_DT_SET0_reg))
+#define DC_PHY_DT_SET0_inst_adr                                                      "0x0080"
+#define DC_PHY_DT_SET0_inst                                                          0x0080
+#define DC_PHY_DT_SET0_dt_set_0_shift                                                (0)
+#define DC_PHY_DT_SET0_dt_set_0_mask                                                 (0x0000FFFF)
+#define DC_PHY_DT_SET0_dt_set_0(data)                                                (0x0000FFFF&((data)<<0))
+#define DC_PHY_DT_SET0_dt_set_0_src(data)                                            ((0x0000FFFF&(data))>>0)
+#define DC_PHY_DT_SET0_get_dt_set_0(data)                                            ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_DT_SET1                                                               0x18008a04
+#define DC_PHY_DT_SET1_reg_addr                                                      "0xB8008A04"
+#define DC_PHY_DT_SET1_reg                                                           0xB8008A04
+#define set_DC_PHY_DT_SET1_reg(data)   (*((volatile unsigned int*) DC_PHY_DT_SET1_reg)=data)
+#define get_DC_PHY_DT_SET1_reg   (*((volatile unsigned int*) DC_PHY_DT_SET1_reg))
+#define DC_PHY_DT_SET1_inst_adr                                                      "0x0081"
+#define DC_PHY_DT_SET1_inst                                                          0x0081
+#define DC_PHY_DT_SET1_dt_set_1_shift                                                (0)
+#define DC_PHY_DT_SET1_dt_set_1_mask                                                 (0xFFFFFFFF)
+#define DC_PHY_DT_SET1_dt_set_1(data)                                                (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DT_SET1_dt_set_1_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DT_SET1_get_dt_set_1(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DT_CTL                                                                0x18008a08
+#define DC_PHY_DT_CTL_reg_addr                                                       "0xB8008A08"
+#define DC_PHY_DT_CTL_reg                                                            0xB8008A08
+#define set_DC_PHY_DT_CTL_reg(data)   (*((volatile unsigned int*) DC_PHY_DT_CTL_reg)=data)
+#define get_DC_PHY_DT_CTL_reg   (*((volatile unsigned int*) DC_PHY_DT_CTL_reg))
+#define DC_PHY_DT_CTL_inst_adr                                                       "0x0082"
+#define DC_PHY_DT_CTL_inst                                                           0x0082
+#define DC_PHY_DT_CTL_update_dqs_shift                                               (1)
+#define DC_PHY_DT_CTL_update_dqs_mask                                                (0x00000002)
+#define DC_PHY_DT_CTL_update_dqs(data)                                               (0x00000002&((data)<<1))
+#define DC_PHY_DT_CTL_update_dqs_src(data)                                           ((0x00000002&(data))>>1)
+#define DC_PHY_DT_CTL_get_update_dqs(data)                                           ((0x00000002&(data))>>1)
+#define DC_PHY_DT_CTL_update_dq_shift                                                (0)
+#define DC_PHY_DT_CTL_update_dq_mask                                                 (0x00000001)
+#define DC_PHY_DT_CTL_update_dq(data)                                                (0x00000001&((data)<<0))
+#define DC_PHY_DT_CTL_update_dq_src(data)                                            ((0x00000001&(data))>>0)
+#define DC_PHY_DT_CTL_get_update_dq(data)                                            ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_CAL_DT_RESULT                                                         0x18008a0c
+#define DC_PHY_CAL_DT_RESULT_reg_addr                                                "0xB8008A0C"
+#define DC_PHY_CAL_DT_RESULT_reg                                                     0xB8008A0C
+#define set_DC_PHY_CAL_DT_RESULT_reg(data)   (*((volatile unsigned int*) DC_PHY_CAL_DT_RESULT_reg)=data)
+#define get_DC_PHY_CAL_DT_RESULT_reg   (*((volatile unsigned int*) DC_PHY_CAL_DT_RESULT_reg))
+#define DC_PHY_CAL_DT_RESULT_inst_adr                                                "0x0083"
+#define DC_PHY_CAL_DT_RESULT_inst                                                    0x0083
+#define DC_PHY_CAL_DT_RESULT_odt_23_n_shift                                          (17)
+#define DC_PHY_CAL_DT_RESULT_odt_23_n_mask                                           (0x000E0000)
+#define DC_PHY_CAL_DT_RESULT_odt_23_n(data)                                          (0x000E0000&((data)<<17))
+#define DC_PHY_CAL_DT_RESULT_odt_23_n_src(data)                                      ((0x000E0000&(data))>>17)
+#define DC_PHY_CAL_DT_RESULT_get_odt_23_n(data)                                      ((0x000E0000&(data))>>17)
+#define DC_PHY_CAL_DT_RESULT_odt_23_p_shift                                          (14)
+#define DC_PHY_CAL_DT_RESULT_odt_23_p_mask                                           (0x0001C000)
+#define DC_PHY_CAL_DT_RESULT_odt_23_p(data)                                          (0x0001C000&((data)<<14))
+#define DC_PHY_CAL_DT_RESULT_odt_23_p_src(data)                                      ((0x0001C000&(data))>>14)
+#define DC_PHY_CAL_DT_RESULT_get_odt_23_p(data)                                      ((0x0001C000&(data))>>14)
+#define DC_PHY_CAL_DT_RESULT_odt_01_n_shift                                          (11)
+#define DC_PHY_CAL_DT_RESULT_odt_01_n_mask                                           (0x00003800)
+#define DC_PHY_CAL_DT_RESULT_odt_01_n(data)                                          (0x00003800&((data)<<11))
+#define DC_PHY_CAL_DT_RESULT_odt_01_n_src(data)                                      ((0x00003800&(data))>>11)
+#define DC_PHY_CAL_DT_RESULT_get_odt_01_n(data)                                      ((0x00003800&(data))>>11)
+#define DC_PHY_CAL_DT_RESULT_odt_01_p_shift                                          (8)
+#define DC_PHY_CAL_DT_RESULT_odt_01_p_mask                                           (0x00000700)
+#define DC_PHY_CAL_DT_RESULT_odt_01_p(data)                                          (0x00000700&((data)<<8))
+#define DC_PHY_CAL_DT_RESULT_odt_01_p_src(data)                                      ((0x00000700&(data))>>8)
+#define DC_PHY_CAL_DT_RESULT_get_odt_01_p(data)                                      ((0x00000700&(data))>>8)
+#define DC_PHY_CAL_DT_RESULT_indt_23_n_shift                                         (6)
+#define DC_PHY_CAL_DT_RESULT_indt_23_n_mask                                          (0x000000C0)
+#define DC_PHY_CAL_DT_RESULT_indt_23_n(data)                                         (0x000000C0&((data)<<6))
+#define DC_PHY_CAL_DT_RESULT_indt_23_n_src(data)                                     ((0x000000C0&(data))>>6)
+#define DC_PHY_CAL_DT_RESULT_get_indt_23_n(data)                                     ((0x000000C0&(data))>>6)
+#define DC_PHY_CAL_DT_RESULT_indt_23_p_shift                                         (4)
+#define DC_PHY_CAL_DT_RESULT_indt_23_p_mask                                          (0x00000030)
+#define DC_PHY_CAL_DT_RESULT_indt_23_p(data)                                         (0x00000030&((data)<<4))
+#define DC_PHY_CAL_DT_RESULT_indt_23_p_src(data)                                     ((0x00000030&(data))>>4)
+#define DC_PHY_CAL_DT_RESULT_get_indt_23_p(data)                                     ((0x00000030&(data))>>4)
+#define DC_PHY_CAL_DT_RESULT_indt_01_n_shift                                         (2)
+#define DC_PHY_CAL_DT_RESULT_indt_01_n_mask                                          (0x0000000C)
+#define DC_PHY_CAL_DT_RESULT_indt_01_n(data)                                         (0x0000000C&((data)<<2))
+#define DC_PHY_CAL_DT_RESULT_indt_01_n_src(data)                                     ((0x0000000C&(data))>>2)
+#define DC_PHY_CAL_DT_RESULT_get_indt_01_n(data)                                     ((0x0000000C&(data))>>2)
+#define DC_PHY_CAL_DT_RESULT_indt_01_p_shift                                         (0)
+#define DC_PHY_CAL_DT_RESULT_indt_01_p_mask                                          (0x00000003)
+#define DC_PHY_CAL_DT_RESULT_indt_01_p(data)                                         (0x00000003&((data)<<0))
+#define DC_PHY_CAL_DT_RESULT_indt_01_p_src(data)                                     ((0x00000003&(data))>>0)
+#define DC_PHY_CAL_DT_RESULT_get_indt_01_p(data)                                     ((0x00000003&(data))>>0)
+
+
+#define DC_PHY_ODT_TTCP_SET_PRE                                                      0x18008a10
+#define DC_PHY_ODT_TTCP_SET_PRE_reg_addr                                             "0xB8008A10"
+#define DC_PHY_ODT_TTCP_SET_PRE_reg                                                  0xB8008A10
+#define set_DC_PHY_ODT_TTCP_SET_PRE_reg(data)   (*((volatile unsigned int*) DC_PHY_ODT_TTCP_SET_PRE_reg)=data)
+#define get_DC_PHY_ODT_TTCP_SET_PRE_reg   (*((volatile unsigned int*) DC_PHY_ODT_TTCP_SET_PRE_reg))
+#define DC_PHY_ODT_TTCP_SET_PRE_inst_adr                                             "0x0084"
+#define DC_PHY_ODT_TTCP_SET_PRE_inst                                                 0x0084
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_7_pre_shift                             (28)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_7_pre_mask                              (0xF0000000)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_7_pre(data)                             (0xF0000000&((data)<<28))
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_7_pre_src(data)                         ((0xF0000000&(data))>>28)
+#define DC_PHY_ODT_TTCP_SET_PRE_get_odt_ttcp_set_7_pre(data)                         ((0xF0000000&(data))>>28)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_6_pre_shift                             (24)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_6_pre_mask                              (0x0F000000)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_6_pre(data)                             (0x0F000000&((data)<<24))
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_6_pre_src(data)                         ((0x0F000000&(data))>>24)
+#define DC_PHY_ODT_TTCP_SET_PRE_get_odt_ttcp_set_6_pre(data)                         ((0x0F000000&(data))>>24)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_5_pre_shift                             (20)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_5_pre_mask                              (0x00F00000)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_5_pre(data)                             (0x00F00000&((data)<<20))
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_5_pre_src(data)                         ((0x00F00000&(data))>>20)
+#define DC_PHY_ODT_TTCP_SET_PRE_get_odt_ttcp_set_5_pre(data)                         ((0x00F00000&(data))>>20)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_4_pre_shift                             (16)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_4_pre_mask                              (0x000F0000)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_4_pre(data)                             (0x000F0000&((data)<<16))
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_4_pre_src(data)                         ((0x000F0000&(data))>>16)
+#define DC_PHY_ODT_TTCP_SET_PRE_get_odt_ttcp_set_4_pre(data)                         ((0x000F0000&(data))>>16)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_3_pre_shift                             (12)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_3_pre_mask                              (0x0000F000)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_3_pre(data)                             (0x0000F000&((data)<<12))
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_3_pre_src(data)                         ((0x0000F000&(data))>>12)
+#define DC_PHY_ODT_TTCP_SET_PRE_get_odt_ttcp_set_3_pre(data)                         ((0x0000F000&(data))>>12)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_2_pre_shift                             (8)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_2_pre_mask                              (0x00000F00)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_2_pre(data)                             (0x00000F00&((data)<<8))
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_2_pre_src(data)                         ((0x00000F00&(data))>>8)
+#define DC_PHY_ODT_TTCP_SET_PRE_get_odt_ttcp_set_2_pre(data)                         ((0x00000F00&(data))>>8)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_1_pre_shift                             (4)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_1_pre_mask                              (0x000000F0)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_1_pre(data)                             (0x000000F0&((data)<<4))
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_1_pre_src(data)                         ((0x000000F0&(data))>>4)
+#define DC_PHY_ODT_TTCP_SET_PRE_get_odt_ttcp_set_1_pre(data)                         ((0x000000F0&(data))>>4)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_0_pre_shift                             (0)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_0_pre_mask                              (0x0000000F)
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_0_pre(data)                             (0x0000000F&((data)<<0))
+#define DC_PHY_ODT_TTCP_SET_PRE_odt_ttcp_set_0_pre_src(data)                         ((0x0000000F&(data))>>0)
+#define DC_PHY_ODT_TTCP_SET_PRE_get_odt_ttcp_set_0_pre(data)                         ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_ODT_TTCN_SET_PRE                                                      0x18008a14
+#define DC_PHY_ODT_TTCN_SET_PRE_reg_addr                                             "0xB8008A14"
+#define DC_PHY_ODT_TTCN_SET_PRE_reg                                                  0xB8008A14
+#define set_DC_PHY_ODT_TTCN_SET_PRE_reg(data)   (*((volatile unsigned int*) DC_PHY_ODT_TTCN_SET_PRE_reg)=data)
+#define get_DC_PHY_ODT_TTCN_SET_PRE_reg   (*((volatile unsigned int*) DC_PHY_ODT_TTCN_SET_PRE_reg))
+#define DC_PHY_ODT_TTCN_SET_PRE_inst_adr                                             "0x0085"
+#define DC_PHY_ODT_TTCN_SET_PRE_inst                                                 0x0085
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_7_pre_shift                             (28)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_7_pre_mask                              (0xF0000000)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_7_pre(data)                             (0xF0000000&((data)<<28))
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_7_pre_src(data)                         ((0xF0000000&(data))>>28)
+#define DC_PHY_ODT_TTCN_SET_PRE_get_odt_ttcn_set_7_pre(data)                         ((0xF0000000&(data))>>28)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_6_pre_shift                             (24)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_6_pre_mask                              (0x0F000000)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_6_pre(data)                             (0x0F000000&((data)<<24))
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_6_pre_src(data)                         ((0x0F000000&(data))>>24)
+#define DC_PHY_ODT_TTCN_SET_PRE_get_odt_ttcn_set_6_pre(data)                         ((0x0F000000&(data))>>24)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_5_pre_shift                             (20)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_5_pre_mask                              (0x00F00000)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_5_pre(data)                             (0x00F00000&((data)<<20))
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_5_pre_src(data)                         ((0x00F00000&(data))>>20)
+#define DC_PHY_ODT_TTCN_SET_PRE_get_odt_ttcn_set_5_pre(data)                         ((0x00F00000&(data))>>20)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_4_pre_shift                             (16)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_4_pre_mask                              (0x000F0000)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_4_pre(data)                             (0x000F0000&((data)<<16))
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_4_pre_src(data)                         ((0x000F0000&(data))>>16)
+#define DC_PHY_ODT_TTCN_SET_PRE_get_odt_ttcn_set_4_pre(data)                         ((0x000F0000&(data))>>16)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_3_pre_shift                             (12)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_3_pre_mask                              (0x0000F000)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_3_pre(data)                             (0x0000F000&((data)<<12))
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_3_pre_src(data)                         ((0x0000F000&(data))>>12)
+#define DC_PHY_ODT_TTCN_SET_PRE_get_odt_ttcn_set_3_pre(data)                         ((0x0000F000&(data))>>12)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_2_pre_shift                             (8)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_2_pre_mask                              (0x00000F00)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_2_pre(data)                             (0x00000F00&((data)<<8))
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_2_pre_src(data)                         ((0x00000F00&(data))>>8)
+#define DC_PHY_ODT_TTCN_SET_PRE_get_odt_ttcn_set_2_pre(data)                         ((0x00000F00&(data))>>8)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_1_pre_shift                             (4)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_1_pre_mask                              (0x000000F0)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_1_pre(data)                             (0x000000F0&((data)<<4))
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_1_pre_src(data)                         ((0x000000F0&(data))>>4)
+#define DC_PHY_ODT_TTCN_SET_PRE_get_odt_ttcn_set_1_pre(data)                         ((0x000000F0&(data))>>4)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_0_pre_shift                             (0)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_0_pre_mask                              (0x0000000F)
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_0_pre(data)                             (0x0000000F&((data)<<0))
+#define DC_PHY_ODT_TTCN_SET_PRE_odt_ttcn_set_0_pre_src(data)                         ((0x0000000F&(data))>>0)
+#define DC_PHY_ODT_TTCN_SET_PRE_get_odt_ttcn_set_0_pre(data)                         ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_ODT_TTFP_SET_PRE                                                      0x18008a18
+#define DC_PHY_ODT_TTFP_SET_PRE_reg_addr                                             "0xB8008A18"
+#define DC_PHY_ODT_TTFP_SET_PRE_reg                                                  0xB8008A18
+#define set_DC_PHY_ODT_TTFP_SET_PRE_reg(data)   (*((volatile unsigned int*) DC_PHY_ODT_TTFP_SET_PRE_reg)=data)
+#define get_DC_PHY_ODT_TTFP_SET_PRE_reg   (*((volatile unsigned int*) DC_PHY_ODT_TTFP_SET_PRE_reg))
+#define DC_PHY_ODT_TTFP_SET_PRE_inst_adr                                             "0x0086"
+#define DC_PHY_ODT_TTFP_SET_PRE_inst                                                 0x0086
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_7_pre_shift                             (21)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_7_pre_mask                              (0x00E00000)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_7_pre(data)                             (0x00E00000&((data)<<21))
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_7_pre_src(data)                         ((0x00E00000&(data))>>21)
+#define DC_PHY_ODT_TTFP_SET_PRE_get_odt_ttfp_set_7_pre(data)                         ((0x00E00000&(data))>>21)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_6_pre_shift                             (18)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_6_pre_mask                              (0x001C0000)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_6_pre(data)                             (0x001C0000&((data)<<18))
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_6_pre_src(data)                         ((0x001C0000&(data))>>18)
+#define DC_PHY_ODT_TTFP_SET_PRE_get_odt_ttfp_set_6_pre(data)                         ((0x001C0000&(data))>>18)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_5_pre_shift                             (15)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_5_pre_mask                              (0x00038000)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_5_pre(data)                             (0x00038000&((data)<<15))
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_5_pre_src(data)                         ((0x00038000&(data))>>15)
+#define DC_PHY_ODT_TTFP_SET_PRE_get_odt_ttfp_set_5_pre(data)                         ((0x00038000&(data))>>15)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_4_pre_shift                             (12)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_4_pre_mask                              (0x00007000)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_4_pre(data)                             (0x00007000&((data)<<12))
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_4_pre_src(data)                         ((0x00007000&(data))>>12)
+#define DC_PHY_ODT_TTFP_SET_PRE_get_odt_ttfp_set_4_pre(data)                         ((0x00007000&(data))>>12)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_3_pre_shift                             (9)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_3_pre_mask                              (0x00000E00)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_3_pre(data)                             (0x00000E00&((data)<<9))
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_3_pre_src(data)                         ((0x00000E00&(data))>>9)
+#define DC_PHY_ODT_TTFP_SET_PRE_get_odt_ttfp_set_3_pre(data)                         ((0x00000E00&(data))>>9)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_2_pre_shift                             (6)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_2_pre_mask                              (0x000001C0)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_2_pre(data)                             (0x000001C0&((data)<<6))
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_2_pre_src(data)                         ((0x000001C0&(data))>>6)
+#define DC_PHY_ODT_TTFP_SET_PRE_get_odt_ttfp_set_2_pre(data)                         ((0x000001C0&(data))>>6)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_1_pre_shift                             (3)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_1_pre_mask                              (0x00000038)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_1_pre(data)                             (0x00000038&((data)<<3))
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_1_pre_src(data)                         ((0x00000038&(data))>>3)
+#define DC_PHY_ODT_TTFP_SET_PRE_get_odt_ttfp_set_1_pre(data)                         ((0x00000038&(data))>>3)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_0_pre_shift                             (0)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_0_pre_mask                              (0x00000007)
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_0_pre(data)                             (0x00000007&((data)<<0))
+#define DC_PHY_ODT_TTFP_SET_PRE_odt_ttfp_set_0_pre_src(data)                         ((0x00000007&(data))>>0)
+#define DC_PHY_ODT_TTFP_SET_PRE_get_odt_ttfp_set_0_pre(data)                         ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_ODT_TTFN_SET_PRE                                                      0x18008a1c
+#define DC_PHY_ODT_TTFN_SET_PRE_reg_addr                                             "0xB8008A1C"
+#define DC_PHY_ODT_TTFN_SET_PRE_reg                                                  0xB8008A1C
+#define set_DC_PHY_ODT_TTFN_SET_PRE_reg(data)   (*((volatile unsigned int*) DC_PHY_ODT_TTFN_SET_PRE_reg)=data)
+#define get_DC_PHY_ODT_TTFN_SET_PRE_reg   (*((volatile unsigned int*) DC_PHY_ODT_TTFN_SET_PRE_reg))
+#define DC_PHY_ODT_TTFN_SET_PRE_inst_adr                                             "0x0087"
+#define DC_PHY_ODT_TTFN_SET_PRE_inst                                                 0x0087
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_7_pre_shift                             (21)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_7_pre_mask                              (0x00E00000)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_7_pre(data)                             (0x00E00000&((data)<<21))
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_7_pre_src(data)                         ((0x00E00000&(data))>>21)
+#define DC_PHY_ODT_TTFN_SET_PRE_get_odt_ttfn_set_7_pre(data)                         ((0x00E00000&(data))>>21)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_6_pre_shift                             (18)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_6_pre_mask                              (0x001C0000)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_6_pre(data)                             (0x001C0000&((data)<<18))
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_6_pre_src(data)                         ((0x001C0000&(data))>>18)
+#define DC_PHY_ODT_TTFN_SET_PRE_get_odt_ttfn_set_6_pre(data)                         ((0x001C0000&(data))>>18)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_5_pre_shift                             (15)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_5_pre_mask                              (0x00038000)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_5_pre(data)                             (0x00038000&((data)<<15))
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_5_pre_src(data)                         ((0x00038000&(data))>>15)
+#define DC_PHY_ODT_TTFN_SET_PRE_get_odt_ttfn_set_5_pre(data)                         ((0x00038000&(data))>>15)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_4_pre_shift                             (12)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_4_pre_mask                              (0x00007000)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_4_pre(data)                             (0x00007000&((data)<<12))
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_4_pre_src(data)                         ((0x00007000&(data))>>12)
+#define DC_PHY_ODT_TTFN_SET_PRE_get_odt_ttfn_set_4_pre(data)                         ((0x00007000&(data))>>12)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_3_pre_shift                             (9)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_3_pre_mask                              (0x00000E00)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_3_pre(data)                             (0x00000E00&((data)<<9))
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_3_pre_src(data)                         ((0x00000E00&(data))>>9)
+#define DC_PHY_ODT_TTFN_SET_PRE_get_odt_ttfn_set_3_pre(data)                         ((0x00000E00&(data))>>9)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_2_pre_shift                             (6)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_2_pre_mask                              (0x000001C0)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_2_pre(data)                             (0x000001C0&((data)<<6))
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_2_pre_src(data)                         ((0x000001C0&(data))>>6)
+#define DC_PHY_ODT_TTFN_SET_PRE_get_odt_ttfn_set_2_pre(data)                         ((0x000001C0&(data))>>6)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_1_pre_shift                             (3)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_1_pre_mask                              (0x00000038)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_1_pre(data)                             (0x00000038&((data)<<3))
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_1_pre_src(data)                         ((0x00000038&(data))>>3)
+#define DC_PHY_ODT_TTFN_SET_PRE_get_odt_ttfn_set_1_pre(data)                         ((0x00000038&(data))>>3)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_0_pre_shift                             (0)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_0_pre_mask                              (0x00000007)
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_0_pre(data)                             (0x00000007&((data)<<0))
+#define DC_PHY_ODT_TTFN_SET_PRE_odt_ttfn_set_0_pre_src(data)                         ((0x00000007&(data))>>0)
+#define DC_PHY_ODT_TTFN_SET_PRE_get_odt_ttfn_set_0_pre(data)                         ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_OCDP_SET_PRE                                                          0x18008a20
+#define DC_PHY_OCDP_SET_PRE_reg_addr                                                 "0xB8008A20"
+#define DC_PHY_OCDP_SET_PRE_reg                                                      0xB8008A20
+#define set_DC_PHY_OCDP_SET_PRE_reg(data)   (*((volatile unsigned int*) DC_PHY_OCDP_SET_PRE_reg)=data)
+#define get_DC_PHY_OCDP_SET_PRE_reg   (*((volatile unsigned int*) DC_PHY_OCDP_SET_PRE_reg))
+#define DC_PHY_OCDP_SET_PRE_inst_adr                                                 "0x0088"
+#define DC_PHY_OCDP_SET_PRE_inst                                                     0x0088
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_7_pre_shift                                     (28)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_7_pre_mask                                      (0xF0000000)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_7_pre(data)                                     (0xF0000000&((data)<<28))
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_7_pre_src(data)                                 ((0xF0000000&(data))>>28)
+#define DC_PHY_OCDP_SET_PRE_get_ocdp_set_7_pre(data)                                 ((0xF0000000&(data))>>28)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_6_pre_shift                                     (24)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_6_pre_mask                                      (0x0F000000)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_6_pre(data)                                     (0x0F000000&((data)<<24))
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_6_pre_src(data)                                 ((0x0F000000&(data))>>24)
+#define DC_PHY_OCDP_SET_PRE_get_ocdp_set_6_pre(data)                                 ((0x0F000000&(data))>>24)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_5_pre_shift                                     (20)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_5_pre_mask                                      (0x00F00000)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_5_pre(data)                                     (0x00F00000&((data)<<20))
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_5_pre_src(data)                                 ((0x00F00000&(data))>>20)
+#define DC_PHY_OCDP_SET_PRE_get_ocdp_set_5_pre(data)                                 ((0x00F00000&(data))>>20)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_4_pre_shift                                     (16)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_4_pre_mask                                      (0x000F0000)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_4_pre(data)                                     (0x000F0000&((data)<<16))
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_4_pre_src(data)                                 ((0x000F0000&(data))>>16)
+#define DC_PHY_OCDP_SET_PRE_get_ocdp_set_4_pre(data)                                 ((0x000F0000&(data))>>16)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_3_pre_shift                                     (12)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_3_pre_mask                                      (0x0000F000)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_3_pre(data)                                     (0x0000F000&((data)<<12))
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_3_pre_src(data)                                 ((0x0000F000&(data))>>12)
+#define DC_PHY_OCDP_SET_PRE_get_ocdp_set_3_pre(data)                                 ((0x0000F000&(data))>>12)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_2_pre_shift                                     (8)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_2_pre_mask                                      (0x00000F00)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_2_pre(data)                                     (0x00000F00&((data)<<8))
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_2_pre_src(data)                                 ((0x00000F00&(data))>>8)
+#define DC_PHY_OCDP_SET_PRE_get_ocdp_set_2_pre(data)                                 ((0x00000F00&(data))>>8)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_1_pre_shift                                     (4)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_1_pre_mask                                      (0x000000F0)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_1_pre(data)                                     (0x000000F0&((data)<<4))
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_1_pre_src(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_OCDP_SET_PRE_get_ocdp_set_1_pre(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_0_pre_shift                                     (0)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_0_pre_mask                                      (0x0000000F)
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_0_pre(data)                                     (0x0000000F&((data)<<0))
+#define DC_PHY_OCDP_SET_PRE_ocdp_set_0_pre_src(data)                                 ((0x0000000F&(data))>>0)
+#define DC_PHY_OCDP_SET_PRE_get_ocdp_set_0_pre(data)                                 ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_OCDN_SET_PRE                                                          0x18008a24
+#define DC_PHY_OCDN_SET_PRE_reg_addr                                                 "0xB8008A24"
+#define DC_PHY_OCDN_SET_PRE_reg                                                      0xB8008A24
+#define set_DC_PHY_OCDN_SET_PRE_reg(data)   (*((volatile unsigned int*) DC_PHY_OCDN_SET_PRE_reg)=data)
+#define get_DC_PHY_OCDN_SET_PRE_reg   (*((volatile unsigned int*) DC_PHY_OCDN_SET_PRE_reg))
+#define DC_PHY_OCDN_SET_PRE_inst_adr                                                 "0x0089"
+#define DC_PHY_OCDN_SET_PRE_inst                                                     0x0089
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_7_pre_shift                                     (28)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_7_pre_mask                                      (0xF0000000)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_7_pre(data)                                     (0xF0000000&((data)<<28))
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_7_pre_src(data)                                 ((0xF0000000&(data))>>28)
+#define DC_PHY_OCDN_SET_PRE_get_ocdn_set_7_pre(data)                                 ((0xF0000000&(data))>>28)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_6_pre_shift                                     (24)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_6_pre_mask                                      (0x0F000000)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_6_pre(data)                                     (0x0F000000&((data)<<24))
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_6_pre_src(data)                                 ((0x0F000000&(data))>>24)
+#define DC_PHY_OCDN_SET_PRE_get_ocdn_set_6_pre(data)                                 ((0x0F000000&(data))>>24)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_5_pre_shift                                     (20)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_5_pre_mask                                      (0x00F00000)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_5_pre(data)                                     (0x00F00000&((data)<<20))
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_5_pre_src(data)                                 ((0x00F00000&(data))>>20)
+#define DC_PHY_OCDN_SET_PRE_get_ocdn_set_5_pre(data)                                 ((0x00F00000&(data))>>20)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_4_pre_shift                                     (16)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_4_pre_mask                                      (0x000F0000)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_4_pre(data)                                     (0x000F0000&((data)<<16))
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_4_pre_src(data)                                 ((0x000F0000&(data))>>16)
+#define DC_PHY_OCDN_SET_PRE_get_ocdn_set_4_pre(data)                                 ((0x000F0000&(data))>>16)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_3_pre_shift                                     (12)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_3_pre_mask                                      (0x0000F000)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_3_pre(data)                                     (0x0000F000&((data)<<12))
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_3_pre_src(data)                                 ((0x0000F000&(data))>>12)
+#define DC_PHY_OCDN_SET_PRE_get_ocdn_set_3_pre(data)                                 ((0x0000F000&(data))>>12)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_2_pre_shift                                     (8)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_2_pre_mask                                      (0x00000F00)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_2_pre(data)                                     (0x00000F00&((data)<<8))
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_2_pre_src(data)                                 ((0x00000F00&(data))>>8)
+#define DC_PHY_OCDN_SET_PRE_get_ocdn_set_2_pre(data)                                 ((0x00000F00&(data))>>8)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_1_pre_shift                                     (4)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_1_pre_mask                                      (0x000000F0)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_1_pre(data)                                     (0x000000F0&((data)<<4))
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_1_pre_src(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_OCDN_SET_PRE_get_ocdn_set_1_pre(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_0_pre_shift                                     (0)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_0_pre_mask                                      (0x0000000F)
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_0_pre(data)                                     (0x0000000F&((data)<<0))
+#define DC_PHY_OCDN_SET_PRE_ocdn_set_0_pre_src(data)                                 ((0x0000000F&(data))>>0)
+#define DC_PHY_OCDN_SET_PRE_get_ocdn_set_0_pre(data)                                 ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_ODT_TTCP_SET                                                          0x18008a28
+#define DC_PHY_ODT_TTCP_SET_reg_addr                                                 "0xB8008A28"
+#define DC_PHY_ODT_TTCP_SET_reg                                                      0xB8008A28
+#define set_DC_PHY_ODT_TTCP_SET_reg(data)   (*((volatile unsigned int*) DC_PHY_ODT_TTCP_SET_reg)=data)
+#define get_DC_PHY_ODT_TTCP_SET_reg   (*((volatile unsigned int*) DC_PHY_ODT_TTCP_SET_reg))
+#define DC_PHY_ODT_TTCP_SET_inst_adr                                                 "0x008A"
+#define DC_PHY_ODT_TTCP_SET_inst                                                     0x008A
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_7_shift                                     (28)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_7_mask                                      (0xF0000000)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_7(data)                                     (0xF0000000&((data)<<28))
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_7_src(data)                                 ((0xF0000000&(data))>>28)
+#define DC_PHY_ODT_TTCP_SET_get_odt_ttcp_set_7(data)                                 ((0xF0000000&(data))>>28)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_6_shift                                     (24)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_6_mask                                      (0x0F000000)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_6(data)                                     (0x0F000000&((data)<<24))
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_6_src(data)                                 ((0x0F000000&(data))>>24)
+#define DC_PHY_ODT_TTCP_SET_get_odt_ttcp_set_6(data)                                 ((0x0F000000&(data))>>24)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_5_shift                                     (20)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_5_mask                                      (0x00F00000)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_5(data)                                     (0x00F00000&((data)<<20))
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_5_src(data)                                 ((0x00F00000&(data))>>20)
+#define DC_PHY_ODT_TTCP_SET_get_odt_ttcp_set_5(data)                                 ((0x00F00000&(data))>>20)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_4_shift                                     (16)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_4_mask                                      (0x000F0000)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_4(data)                                     (0x000F0000&((data)<<16))
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_4_src(data)                                 ((0x000F0000&(data))>>16)
+#define DC_PHY_ODT_TTCP_SET_get_odt_ttcp_set_4(data)                                 ((0x000F0000&(data))>>16)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_3_shift                                     (12)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_3_mask                                      (0x0000F000)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_3(data)                                     (0x0000F000&((data)<<12))
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_3_src(data)                                 ((0x0000F000&(data))>>12)
+#define DC_PHY_ODT_TTCP_SET_get_odt_ttcp_set_3(data)                                 ((0x0000F000&(data))>>12)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_2_shift                                     (8)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_2_mask                                      (0x00000F00)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_2(data)                                     (0x00000F00&((data)<<8))
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_2_src(data)                                 ((0x00000F00&(data))>>8)
+#define DC_PHY_ODT_TTCP_SET_get_odt_ttcp_set_2(data)                                 ((0x00000F00&(data))>>8)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_1_shift                                     (4)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_1_mask                                      (0x000000F0)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_1(data)                                     (0x000000F0&((data)<<4))
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_1_src(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_ODT_TTCP_SET_get_odt_ttcp_set_1(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_0_shift                                     (0)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_0_mask                                      (0x0000000F)
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_0(data)                                     (0x0000000F&((data)<<0))
+#define DC_PHY_ODT_TTCP_SET_odt_ttcp_set_0_src(data)                                 ((0x0000000F&(data))>>0)
+#define DC_PHY_ODT_TTCP_SET_get_odt_ttcp_set_0(data)                                 ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_ODT_TTCN_SET                                                          0x18008a2c
+#define DC_PHY_ODT_TTCN_SET_reg_addr                                                 "0xB8008A2C"
+#define DC_PHY_ODT_TTCN_SET_reg                                                      0xB8008A2C
+#define set_DC_PHY_ODT_TTCN_SET_reg(data)   (*((volatile unsigned int*) DC_PHY_ODT_TTCN_SET_reg)=data)
+#define get_DC_PHY_ODT_TTCN_SET_reg   (*((volatile unsigned int*) DC_PHY_ODT_TTCN_SET_reg))
+#define DC_PHY_ODT_TTCN_SET_inst_adr                                                 "0x008B"
+#define DC_PHY_ODT_TTCN_SET_inst                                                     0x008B
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_7_shift                                     (28)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_7_mask                                      (0xF0000000)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_7(data)                                     (0xF0000000&((data)<<28))
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_7_src(data)                                 ((0xF0000000&(data))>>28)
+#define DC_PHY_ODT_TTCN_SET_get_odt_ttcn_set_7(data)                                 ((0xF0000000&(data))>>28)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_6_shift                                     (24)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_6_mask                                      (0x0F000000)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_6(data)                                     (0x0F000000&((data)<<24))
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_6_src(data)                                 ((0x0F000000&(data))>>24)
+#define DC_PHY_ODT_TTCN_SET_get_odt_ttcn_set_6(data)                                 ((0x0F000000&(data))>>24)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_5_shift                                     (20)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_5_mask                                      (0x00F00000)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_5(data)                                     (0x00F00000&((data)<<20))
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_5_src(data)                                 ((0x00F00000&(data))>>20)
+#define DC_PHY_ODT_TTCN_SET_get_odt_ttcn_set_5(data)                                 ((0x00F00000&(data))>>20)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_4_shift                                     (16)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_4_mask                                      (0x000F0000)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_4(data)                                     (0x000F0000&((data)<<16))
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_4_src(data)                                 ((0x000F0000&(data))>>16)
+#define DC_PHY_ODT_TTCN_SET_get_odt_ttcn_set_4(data)                                 ((0x000F0000&(data))>>16)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_3_shift                                     (12)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_3_mask                                      (0x0000F000)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_3(data)                                     (0x0000F000&((data)<<12))
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_3_src(data)                                 ((0x0000F000&(data))>>12)
+#define DC_PHY_ODT_TTCN_SET_get_odt_ttcn_set_3(data)                                 ((0x0000F000&(data))>>12)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_2_shift                                     (8)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_2_mask                                      (0x00000F00)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_2(data)                                     (0x00000F00&((data)<<8))
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_2_src(data)                                 ((0x00000F00&(data))>>8)
+#define DC_PHY_ODT_TTCN_SET_get_odt_ttcn_set_2(data)                                 ((0x00000F00&(data))>>8)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_1_shift                                     (4)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_1_mask                                      (0x000000F0)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_1(data)                                     (0x000000F0&((data)<<4))
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_1_src(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_ODT_TTCN_SET_get_odt_ttcn_set_1(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_0_shift                                     (0)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_0_mask                                      (0x0000000F)
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_0(data)                                     (0x0000000F&((data)<<0))
+#define DC_PHY_ODT_TTCN_SET_odt_ttcn_set_0_src(data)                                 ((0x0000000F&(data))>>0)
+#define DC_PHY_ODT_TTCN_SET_get_odt_ttcn_set_0(data)                                 ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_ODT_TTFP_SET                                                          0x18008a30
+#define DC_PHY_ODT_TTFP_SET_reg_addr                                                 "0xB8008A30"
+#define DC_PHY_ODT_TTFP_SET_reg                                                      0xB8008A30
+#define set_DC_PHY_ODT_TTFP_SET_reg(data)   (*((volatile unsigned int*) DC_PHY_ODT_TTFP_SET_reg)=data)
+#define get_DC_PHY_ODT_TTFP_SET_reg   (*((volatile unsigned int*) DC_PHY_ODT_TTFP_SET_reg))
+#define DC_PHY_ODT_TTFP_SET_inst_adr                                                 "0x008C"
+#define DC_PHY_ODT_TTFP_SET_inst                                                     0x008C
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_7_shift                                     (21)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_7_mask                                      (0x00E00000)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_7(data)                                     (0x00E00000&((data)<<21))
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_7_src(data)                                 ((0x00E00000&(data))>>21)
+#define DC_PHY_ODT_TTFP_SET_get_odt_ttfp_set_7(data)                                 ((0x00E00000&(data))>>21)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_6_shift                                     (18)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_6_mask                                      (0x001C0000)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_6(data)                                     (0x001C0000&((data)<<18))
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_6_src(data)                                 ((0x001C0000&(data))>>18)
+#define DC_PHY_ODT_TTFP_SET_get_odt_ttfp_set_6(data)                                 ((0x001C0000&(data))>>18)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_5_shift                                     (15)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_5_mask                                      (0x00038000)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_5(data)                                     (0x00038000&((data)<<15))
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_5_src(data)                                 ((0x00038000&(data))>>15)
+#define DC_PHY_ODT_TTFP_SET_get_odt_ttfp_set_5(data)                                 ((0x00038000&(data))>>15)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_4_shift                                     (12)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_4_mask                                      (0x00007000)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_4(data)                                     (0x00007000&((data)<<12))
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_4_src(data)                                 ((0x00007000&(data))>>12)
+#define DC_PHY_ODT_TTFP_SET_get_odt_ttfp_set_4(data)                                 ((0x00007000&(data))>>12)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_3_shift                                     (9)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_3_mask                                      (0x00000E00)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_3(data)                                     (0x00000E00&((data)<<9))
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_3_src(data)                                 ((0x00000E00&(data))>>9)
+#define DC_PHY_ODT_TTFP_SET_get_odt_ttfp_set_3(data)                                 ((0x00000E00&(data))>>9)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_2_shift                                     (6)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_2_mask                                      (0x000001C0)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_2(data)                                     (0x000001C0&((data)<<6))
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_2_src(data)                                 ((0x000001C0&(data))>>6)
+#define DC_PHY_ODT_TTFP_SET_get_odt_ttfp_set_2(data)                                 ((0x000001C0&(data))>>6)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_1_shift                                     (3)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_1_mask                                      (0x00000038)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_1(data)                                     (0x00000038&((data)<<3))
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_1_src(data)                                 ((0x00000038&(data))>>3)
+#define DC_PHY_ODT_TTFP_SET_get_odt_ttfp_set_1(data)                                 ((0x00000038&(data))>>3)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_0_shift                                     (0)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_0_mask                                      (0x00000007)
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_0(data)                                     (0x00000007&((data)<<0))
+#define DC_PHY_ODT_TTFP_SET_odt_ttfp_set_0_src(data)                                 ((0x00000007&(data))>>0)
+#define DC_PHY_ODT_TTFP_SET_get_odt_ttfp_set_0(data)                                 ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_ODT_TTFN_SET                                                          0x18008a34
+#define DC_PHY_ODT_TTFN_SET_reg_addr                                                 "0xB8008A34"
+#define DC_PHY_ODT_TTFN_SET_reg                                                      0xB8008A34
+#define set_DC_PHY_ODT_TTFN_SET_reg(data)   (*((volatile unsigned int*) DC_PHY_ODT_TTFN_SET_reg)=data)
+#define get_DC_PHY_ODT_TTFN_SET_reg   (*((volatile unsigned int*) DC_PHY_ODT_TTFN_SET_reg))
+#define DC_PHY_ODT_TTFN_SET_inst_adr                                                 "0x008D"
+#define DC_PHY_ODT_TTFN_SET_inst                                                     0x008D
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_7_shift                                     (21)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_7_mask                                      (0x00E00000)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_7(data)                                     (0x00E00000&((data)<<21))
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_7_src(data)                                 ((0x00E00000&(data))>>21)
+#define DC_PHY_ODT_TTFN_SET_get_odt_ttfn_set_7(data)                                 ((0x00E00000&(data))>>21)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_6_shift                                     (18)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_6_mask                                      (0x001C0000)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_6(data)                                     (0x001C0000&((data)<<18))
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_6_src(data)                                 ((0x001C0000&(data))>>18)
+#define DC_PHY_ODT_TTFN_SET_get_odt_ttfn_set_6(data)                                 ((0x001C0000&(data))>>18)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_5_shift                                     (15)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_5_mask                                      (0x00038000)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_5(data)                                     (0x00038000&((data)<<15))
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_5_src(data)                                 ((0x00038000&(data))>>15)
+#define DC_PHY_ODT_TTFN_SET_get_odt_ttfn_set_5(data)                                 ((0x00038000&(data))>>15)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_4_shift                                     (12)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_4_mask                                      (0x00007000)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_4(data)                                     (0x00007000&((data)<<12))
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_4_src(data)                                 ((0x00007000&(data))>>12)
+#define DC_PHY_ODT_TTFN_SET_get_odt_ttfn_set_4(data)                                 ((0x00007000&(data))>>12)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_3_shift                                     (9)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_3_mask                                      (0x00000E00)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_3(data)                                     (0x00000E00&((data)<<9))
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_3_src(data)                                 ((0x00000E00&(data))>>9)
+#define DC_PHY_ODT_TTFN_SET_get_odt_ttfn_set_3(data)                                 ((0x00000E00&(data))>>9)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_2_shift                                     (6)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_2_mask                                      (0x000001C0)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_2(data)                                     (0x000001C0&((data)<<6))
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_2_src(data)                                 ((0x000001C0&(data))>>6)
+#define DC_PHY_ODT_TTFN_SET_get_odt_ttfn_set_2(data)                                 ((0x000001C0&(data))>>6)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_1_shift                                     (3)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_1_mask                                      (0x00000038)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_1(data)                                     (0x00000038&((data)<<3))
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_1_src(data)                                 ((0x00000038&(data))>>3)
+#define DC_PHY_ODT_TTFN_SET_get_odt_ttfn_set_1(data)                                 ((0x00000038&(data))>>3)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_0_shift                                     (0)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_0_mask                                      (0x00000007)
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_0(data)                                     (0x00000007&((data)<<0))
+#define DC_PHY_ODT_TTFN_SET_odt_ttfn_set_0_src(data)                                 ((0x00000007&(data))>>0)
+#define DC_PHY_ODT_TTFN_SET_get_odt_ttfn_set_0(data)                                 ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_OCDP_SET                                                              0x18008a38
+#define DC_PHY_OCDP_SET_reg_addr                                                     "0xB8008A38"
+#define DC_PHY_OCDP_SET_reg                                                          0xB8008A38
+#define set_DC_PHY_OCDP_SET_reg(data)   (*((volatile unsigned int*) DC_PHY_OCDP_SET_reg)=data)
+#define get_DC_PHY_OCDP_SET_reg   (*((volatile unsigned int*) DC_PHY_OCDP_SET_reg))
+#define DC_PHY_OCDP_SET_inst_adr                                                     "0x008E"
+#define DC_PHY_OCDP_SET_inst                                                         0x008E
+#define DC_PHY_OCDP_SET_ocdp_set_7_shift                                             (28)
+#define DC_PHY_OCDP_SET_ocdp_set_7_mask                                              (0xF0000000)
+#define DC_PHY_OCDP_SET_ocdp_set_7(data)                                             (0xF0000000&((data)<<28))
+#define DC_PHY_OCDP_SET_ocdp_set_7_src(data)                                         ((0xF0000000&(data))>>28)
+#define DC_PHY_OCDP_SET_get_ocdp_set_7(data)                                         ((0xF0000000&(data))>>28)
+#define DC_PHY_OCDP_SET_ocdp_set_6_shift                                             (24)
+#define DC_PHY_OCDP_SET_ocdp_set_6_mask                                              (0x0F000000)
+#define DC_PHY_OCDP_SET_ocdp_set_6(data)                                             (0x0F000000&((data)<<24))
+#define DC_PHY_OCDP_SET_ocdp_set_6_src(data)                                         ((0x0F000000&(data))>>24)
+#define DC_PHY_OCDP_SET_get_ocdp_set_6(data)                                         ((0x0F000000&(data))>>24)
+#define DC_PHY_OCDP_SET_ocdp_set_5_shift                                             (20)
+#define DC_PHY_OCDP_SET_ocdp_set_5_mask                                              (0x00F00000)
+#define DC_PHY_OCDP_SET_ocdp_set_5(data)                                             (0x00F00000&((data)<<20))
+#define DC_PHY_OCDP_SET_ocdp_set_5_src(data)                                         ((0x00F00000&(data))>>20)
+#define DC_PHY_OCDP_SET_get_ocdp_set_5(data)                                         ((0x00F00000&(data))>>20)
+#define DC_PHY_OCDP_SET_ocdp_set_4_shift                                             (16)
+#define DC_PHY_OCDP_SET_ocdp_set_4_mask                                              (0x000F0000)
+#define DC_PHY_OCDP_SET_ocdp_set_4(data)                                             (0x000F0000&((data)<<16))
+#define DC_PHY_OCDP_SET_ocdp_set_4_src(data)                                         ((0x000F0000&(data))>>16)
+#define DC_PHY_OCDP_SET_get_ocdp_set_4(data)                                         ((0x000F0000&(data))>>16)
+#define DC_PHY_OCDP_SET_ocdp_set_3_shift                                             (12)
+#define DC_PHY_OCDP_SET_ocdp_set_3_mask                                              (0x0000F000)
+#define DC_PHY_OCDP_SET_ocdp_set_3(data)                                             (0x0000F000&((data)<<12))
+#define DC_PHY_OCDP_SET_ocdp_set_3_src(data)                                         ((0x0000F000&(data))>>12)
+#define DC_PHY_OCDP_SET_get_ocdp_set_3(data)                                         ((0x0000F000&(data))>>12)
+#define DC_PHY_OCDP_SET_ocdp_set_2_shift                                             (8)
+#define DC_PHY_OCDP_SET_ocdp_set_2_mask                                              (0x00000F00)
+#define DC_PHY_OCDP_SET_ocdp_set_2(data)                                             (0x00000F00&((data)<<8))
+#define DC_PHY_OCDP_SET_ocdp_set_2_src(data)                                         ((0x00000F00&(data))>>8)
+#define DC_PHY_OCDP_SET_get_ocdp_set_2(data)                                         ((0x00000F00&(data))>>8)
+#define DC_PHY_OCDP_SET_ocdp_set_1_shift                                             (4)
+#define DC_PHY_OCDP_SET_ocdp_set_1_mask                                              (0x000000F0)
+#define DC_PHY_OCDP_SET_ocdp_set_1(data)                                             (0x000000F0&((data)<<4))
+#define DC_PHY_OCDP_SET_ocdp_set_1_src(data)                                         ((0x000000F0&(data))>>4)
+#define DC_PHY_OCDP_SET_get_ocdp_set_1(data)                                         ((0x000000F0&(data))>>4)
+#define DC_PHY_OCDP_SET_ocdp_set_0_shift                                             (0)
+#define DC_PHY_OCDP_SET_ocdp_set_0_mask                                              (0x0000000F)
+#define DC_PHY_OCDP_SET_ocdp_set_0(data)                                             (0x0000000F&((data)<<0))
+#define DC_PHY_OCDP_SET_ocdp_set_0_src(data)                                         ((0x0000000F&(data))>>0)
+#define DC_PHY_OCDP_SET_get_ocdp_set_0(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_OCDN_SET                                                              0x18008a3c
+#define DC_PHY_OCDN_SET_reg_addr                                                     "0xB8008A3C"
+#define DC_PHY_OCDN_SET_reg                                                          0xB8008A3C
+#define set_DC_PHY_OCDN_SET_reg(data)   (*((volatile unsigned int*) DC_PHY_OCDN_SET_reg)=data)
+#define get_DC_PHY_OCDN_SET_reg   (*((volatile unsigned int*) DC_PHY_OCDN_SET_reg))
+#define DC_PHY_OCDN_SET_inst_adr                                                     "0x008F"
+#define DC_PHY_OCDN_SET_inst                                                         0x008F
+#define DC_PHY_OCDN_SET_ocdn_set_7_shift                                             (28)
+#define DC_PHY_OCDN_SET_ocdn_set_7_mask                                              (0xF0000000)
+#define DC_PHY_OCDN_SET_ocdn_set_7(data)                                             (0xF0000000&((data)<<28))
+#define DC_PHY_OCDN_SET_ocdn_set_7_src(data)                                         ((0xF0000000&(data))>>28)
+#define DC_PHY_OCDN_SET_get_ocdn_set_7(data)                                         ((0xF0000000&(data))>>28)
+#define DC_PHY_OCDN_SET_ocdn_set_6_shift                                             (24)
+#define DC_PHY_OCDN_SET_ocdn_set_6_mask                                              (0x0F000000)
+#define DC_PHY_OCDN_SET_ocdn_set_6(data)                                             (0x0F000000&((data)<<24))
+#define DC_PHY_OCDN_SET_ocdn_set_6_src(data)                                         ((0x0F000000&(data))>>24)
+#define DC_PHY_OCDN_SET_get_ocdn_set_6(data)                                         ((0x0F000000&(data))>>24)
+#define DC_PHY_OCDN_SET_ocdn_set_5_shift                                             (20)
+#define DC_PHY_OCDN_SET_ocdn_set_5_mask                                              (0x00F00000)
+#define DC_PHY_OCDN_SET_ocdn_set_5(data)                                             (0x00F00000&((data)<<20))
+#define DC_PHY_OCDN_SET_ocdn_set_5_src(data)                                         ((0x00F00000&(data))>>20)
+#define DC_PHY_OCDN_SET_get_ocdn_set_5(data)                                         ((0x00F00000&(data))>>20)
+#define DC_PHY_OCDN_SET_ocdn_set_4_shift                                             (16)
+#define DC_PHY_OCDN_SET_ocdn_set_4_mask                                              (0x000F0000)
+#define DC_PHY_OCDN_SET_ocdn_set_4(data)                                             (0x000F0000&((data)<<16))
+#define DC_PHY_OCDN_SET_ocdn_set_4_src(data)                                         ((0x000F0000&(data))>>16)
+#define DC_PHY_OCDN_SET_get_ocdn_set_4(data)                                         ((0x000F0000&(data))>>16)
+#define DC_PHY_OCDN_SET_ocdn_set_3_shift                                             (12)
+#define DC_PHY_OCDN_SET_ocdn_set_3_mask                                              (0x0000F000)
+#define DC_PHY_OCDN_SET_ocdn_set_3(data)                                             (0x0000F000&((data)<<12))
+#define DC_PHY_OCDN_SET_ocdn_set_3_src(data)                                         ((0x0000F000&(data))>>12)
+#define DC_PHY_OCDN_SET_get_ocdn_set_3(data)                                         ((0x0000F000&(data))>>12)
+#define DC_PHY_OCDN_SET_ocdn_set_2_shift                                             (8)
+#define DC_PHY_OCDN_SET_ocdn_set_2_mask                                              (0x00000F00)
+#define DC_PHY_OCDN_SET_ocdn_set_2(data)                                             (0x00000F00&((data)<<8))
+#define DC_PHY_OCDN_SET_ocdn_set_2_src(data)                                         ((0x00000F00&(data))>>8)
+#define DC_PHY_OCDN_SET_get_ocdn_set_2(data)                                         ((0x00000F00&(data))>>8)
+#define DC_PHY_OCDN_SET_ocdn_set_1_shift                                             (4)
+#define DC_PHY_OCDN_SET_ocdn_set_1_mask                                              (0x000000F0)
+#define DC_PHY_OCDN_SET_ocdn_set_1(data)                                             (0x000000F0&((data)<<4))
+#define DC_PHY_OCDN_SET_ocdn_set_1_src(data)                                         ((0x000000F0&(data))>>4)
+#define DC_PHY_OCDN_SET_get_ocdn_set_1(data)                                         ((0x000000F0&(data))>>4)
+#define DC_PHY_OCDN_SET_ocdn_set_0_shift                                             (0)
+#define DC_PHY_OCDN_SET_ocdn_set_0_mask                                              (0x0000000F)
+#define DC_PHY_OCDN_SET_ocdn_set_0(data)                                             (0x0000000F&((data)<<0))
+#define DC_PHY_OCDN_SET_ocdn_set_0_src(data)                                         ((0x0000000F&(data))>>0)
+#define DC_PHY_OCDN_SET_get_ocdn_set_0(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_DQ_TTC_SEL                                                            0x18008a40
+#define DC_PHY_DQ_TTC_SEL_reg_addr                                                   "0xB8008A40"
+#define DC_PHY_DQ_TTC_SEL_reg                                                        0xB8008A40
+#define set_DC_PHY_DQ_TTC_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ_TTC_SEL_reg)=data)
+#define get_DC_PHY_DQ_TTC_SEL_reg   (*((volatile unsigned int*) DC_PHY_DQ_TTC_SEL_reg))
+#define DC_PHY_DQ_TTC_SEL_inst_adr                                                   "0x0090"
+#define DC_PHY_DQ_TTC_SEL_inst                                                       0x0090
+#define DC_PHY_DQ_TTC_SEL_dq_3_ttcn_sel_shift                                        (21)
+#define DC_PHY_DQ_TTC_SEL_dq_3_ttcn_sel_mask                                         (0x00E00000)
+#define DC_PHY_DQ_TTC_SEL_dq_3_ttcn_sel(data)                                        (0x00E00000&((data)<<21))
+#define DC_PHY_DQ_TTC_SEL_dq_3_ttcn_sel_src(data)                                    ((0x00E00000&(data))>>21)
+#define DC_PHY_DQ_TTC_SEL_get_dq_3_ttcn_sel(data)                                    ((0x00E00000&(data))>>21)
+#define DC_PHY_DQ_TTC_SEL_dq_2_ttcn_sel_shift                                        (18)
+#define DC_PHY_DQ_TTC_SEL_dq_2_ttcn_sel_mask                                         (0x001C0000)
+#define DC_PHY_DQ_TTC_SEL_dq_2_ttcn_sel(data)                                        (0x001C0000&((data)<<18))
+#define DC_PHY_DQ_TTC_SEL_dq_2_ttcn_sel_src(data)                                    ((0x001C0000&(data))>>18)
+#define DC_PHY_DQ_TTC_SEL_get_dq_2_ttcn_sel(data)                                    ((0x001C0000&(data))>>18)
+#define DC_PHY_DQ_TTC_SEL_dq_1_ttcn_sel_shift                                        (15)
+#define DC_PHY_DQ_TTC_SEL_dq_1_ttcn_sel_mask                                         (0x00038000)
+#define DC_PHY_DQ_TTC_SEL_dq_1_ttcn_sel(data)                                        (0x00038000&((data)<<15))
+#define DC_PHY_DQ_TTC_SEL_dq_1_ttcn_sel_src(data)                                    ((0x00038000&(data))>>15)
+#define DC_PHY_DQ_TTC_SEL_get_dq_1_ttcn_sel(data)                                    ((0x00038000&(data))>>15)
+#define DC_PHY_DQ_TTC_SEL_dq_0_ttcn_sel_shift                                        (12)
+#define DC_PHY_DQ_TTC_SEL_dq_0_ttcn_sel_mask                                         (0x00007000)
+#define DC_PHY_DQ_TTC_SEL_dq_0_ttcn_sel(data)                                        (0x00007000&((data)<<12))
+#define DC_PHY_DQ_TTC_SEL_dq_0_ttcn_sel_src(data)                                    ((0x00007000&(data))>>12)
+#define DC_PHY_DQ_TTC_SEL_get_dq_0_ttcn_sel(data)                                    ((0x00007000&(data))>>12)
+#define DC_PHY_DQ_TTC_SEL_dq_3_ttcp_sel_shift                                        (9)
+#define DC_PHY_DQ_TTC_SEL_dq_3_ttcp_sel_mask                                         (0x00000E00)
+#define DC_PHY_DQ_TTC_SEL_dq_3_ttcp_sel(data)                                        (0x00000E00&((data)<<9))
+#define DC_PHY_DQ_TTC_SEL_dq_3_ttcp_sel_src(data)                                    ((0x00000E00&(data))>>9)
+#define DC_PHY_DQ_TTC_SEL_get_dq_3_ttcp_sel(data)                                    ((0x00000E00&(data))>>9)
+#define DC_PHY_DQ_TTC_SEL_dq_2_ttcp_sel_shift                                        (6)
+#define DC_PHY_DQ_TTC_SEL_dq_2_ttcp_sel_mask                                         (0x000001C0)
+#define DC_PHY_DQ_TTC_SEL_dq_2_ttcp_sel(data)                                        (0x000001C0&((data)<<6))
+#define DC_PHY_DQ_TTC_SEL_dq_2_ttcp_sel_src(data)                                    ((0x000001C0&(data))>>6)
+#define DC_PHY_DQ_TTC_SEL_get_dq_2_ttcp_sel(data)                                    ((0x000001C0&(data))>>6)
+#define DC_PHY_DQ_TTC_SEL_dq_1_ttcp_sel_shift                                        (3)
+#define DC_PHY_DQ_TTC_SEL_dq_1_ttcp_sel_mask                                         (0x00000038)
+#define DC_PHY_DQ_TTC_SEL_dq_1_ttcp_sel(data)                                        (0x00000038&((data)<<3))
+#define DC_PHY_DQ_TTC_SEL_dq_1_ttcp_sel_src(data)                                    ((0x00000038&(data))>>3)
+#define DC_PHY_DQ_TTC_SEL_get_dq_1_ttcp_sel(data)                                    ((0x00000038&(data))>>3)
+#define DC_PHY_DQ_TTC_SEL_dq_0_ttcp_sel_shift                                        (0)
+#define DC_PHY_DQ_TTC_SEL_dq_0_ttcp_sel_mask                                         (0x00000007)
+#define DC_PHY_DQ_TTC_SEL_dq_0_ttcp_sel(data)                                        (0x00000007&((data)<<0))
+#define DC_PHY_DQ_TTC_SEL_dq_0_ttcp_sel_src(data)                                    ((0x00000007&(data))>>0)
+#define DC_PHY_DQ_TTC_SEL_get_dq_0_ttcp_sel(data)                                    ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_DQ_TTF_SEL                                                            0x18008a44
+#define DC_PHY_DQ_TTF_SEL_reg_addr                                                   "0xB8008A44"
+#define DC_PHY_DQ_TTF_SEL_reg                                                        0xB8008A44
+#define set_DC_PHY_DQ_TTF_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ_TTF_SEL_reg)=data)
+#define get_DC_PHY_DQ_TTF_SEL_reg   (*((volatile unsigned int*) DC_PHY_DQ_TTF_SEL_reg))
+#define DC_PHY_DQ_TTF_SEL_inst_adr                                                   "0x0091"
+#define DC_PHY_DQ_TTF_SEL_inst                                                       0x0091
+#define DC_PHY_DQ_TTF_SEL_dq_3_ttfn_sel_shift                                        (21)
+#define DC_PHY_DQ_TTF_SEL_dq_3_ttfn_sel_mask                                         (0x00E00000)
+#define DC_PHY_DQ_TTF_SEL_dq_3_ttfn_sel(data)                                        (0x00E00000&((data)<<21))
+#define DC_PHY_DQ_TTF_SEL_dq_3_ttfn_sel_src(data)                                    ((0x00E00000&(data))>>21)
+#define DC_PHY_DQ_TTF_SEL_get_dq_3_ttfn_sel(data)                                    ((0x00E00000&(data))>>21)
+#define DC_PHY_DQ_TTF_SEL_dq_2_ttfn_sel_shift                                        (18)
+#define DC_PHY_DQ_TTF_SEL_dq_2_ttfn_sel_mask                                         (0x001C0000)
+#define DC_PHY_DQ_TTF_SEL_dq_2_ttfn_sel(data)                                        (0x001C0000&((data)<<18))
+#define DC_PHY_DQ_TTF_SEL_dq_2_ttfn_sel_src(data)                                    ((0x001C0000&(data))>>18)
+#define DC_PHY_DQ_TTF_SEL_get_dq_2_ttfn_sel(data)                                    ((0x001C0000&(data))>>18)
+#define DC_PHY_DQ_TTF_SEL_dq_1_ttfn_sel_shift                                        (15)
+#define DC_PHY_DQ_TTF_SEL_dq_1_ttfn_sel_mask                                         (0x00038000)
+#define DC_PHY_DQ_TTF_SEL_dq_1_ttfn_sel(data)                                        (0x00038000&((data)<<15))
+#define DC_PHY_DQ_TTF_SEL_dq_1_ttfn_sel_src(data)                                    ((0x00038000&(data))>>15)
+#define DC_PHY_DQ_TTF_SEL_get_dq_1_ttfn_sel(data)                                    ((0x00038000&(data))>>15)
+#define DC_PHY_DQ_TTF_SEL_dq_0_ttfn_sel_shift                                        (12)
+#define DC_PHY_DQ_TTF_SEL_dq_0_ttfn_sel_mask                                         (0x00007000)
+#define DC_PHY_DQ_TTF_SEL_dq_0_ttfn_sel(data)                                        (0x00007000&((data)<<12))
+#define DC_PHY_DQ_TTF_SEL_dq_0_ttfn_sel_src(data)                                    ((0x00007000&(data))>>12)
+#define DC_PHY_DQ_TTF_SEL_get_dq_0_ttfn_sel(data)                                    ((0x00007000&(data))>>12)
+#define DC_PHY_DQ_TTF_SEL_dq_3_ttfp_sel_shift                                        (9)
+#define DC_PHY_DQ_TTF_SEL_dq_3_ttfp_sel_mask                                         (0x00000E00)
+#define DC_PHY_DQ_TTF_SEL_dq_3_ttfp_sel(data)                                        (0x00000E00&((data)<<9))
+#define DC_PHY_DQ_TTF_SEL_dq_3_ttfp_sel_src(data)                                    ((0x00000E00&(data))>>9)
+#define DC_PHY_DQ_TTF_SEL_get_dq_3_ttfp_sel(data)                                    ((0x00000E00&(data))>>9)
+#define DC_PHY_DQ_TTF_SEL_dq_2_ttfp_sel_shift                                        (6)
+#define DC_PHY_DQ_TTF_SEL_dq_2_ttfp_sel_mask                                         (0x000001C0)
+#define DC_PHY_DQ_TTF_SEL_dq_2_ttfp_sel(data)                                        (0x000001C0&((data)<<6))
+#define DC_PHY_DQ_TTF_SEL_dq_2_ttfp_sel_src(data)                                    ((0x000001C0&(data))>>6)
+#define DC_PHY_DQ_TTF_SEL_get_dq_2_ttfp_sel(data)                                    ((0x000001C0&(data))>>6)
+#define DC_PHY_DQ_TTF_SEL_dq_1_ttfp_sel_shift                                        (3)
+#define DC_PHY_DQ_TTF_SEL_dq_1_ttfp_sel_mask                                         (0x00000038)
+#define DC_PHY_DQ_TTF_SEL_dq_1_ttfp_sel(data)                                        (0x00000038&((data)<<3))
+#define DC_PHY_DQ_TTF_SEL_dq_1_ttfp_sel_src(data)                                    ((0x00000038&(data))>>3)
+#define DC_PHY_DQ_TTF_SEL_get_dq_1_ttfp_sel(data)                                    ((0x00000038&(data))>>3)
+#define DC_PHY_DQ_TTF_SEL_dq_0_ttfp_sel_shift                                        (0)
+#define DC_PHY_DQ_TTF_SEL_dq_0_ttfp_sel_mask                                         (0x00000007)
+#define DC_PHY_DQ_TTF_SEL_dq_0_ttfp_sel(data)                                        (0x00000007&((data)<<0))
+#define DC_PHY_DQ_TTF_SEL_dq_0_ttfp_sel_src(data)                                    ((0x00000007&(data))>>0)
+#define DC_PHY_DQ_TTF_SEL_get_dq_0_ttfp_sel(data)                                    ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_DQ_OCD_SEL                                                            0x18008a48
+#define DC_PHY_DQ_OCD_SEL_reg_addr                                                   "0xB8008A48"
+#define DC_PHY_DQ_OCD_SEL_reg                                                        0xB8008A48
+#define set_DC_PHY_DQ_OCD_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DQ_OCD_SEL_reg)=data)
+#define get_DC_PHY_DQ_OCD_SEL_reg   (*((volatile unsigned int*) DC_PHY_DQ_OCD_SEL_reg))
+#define DC_PHY_DQ_OCD_SEL_inst_adr                                                   "0x0092"
+#define DC_PHY_DQ_OCD_SEL_inst                                                       0x0092
+#define DC_PHY_DQ_OCD_SEL_dq_3_ocdn_sel_shift                                        (21)
+#define DC_PHY_DQ_OCD_SEL_dq_3_ocdn_sel_mask                                         (0x00E00000)
+#define DC_PHY_DQ_OCD_SEL_dq_3_ocdn_sel(data)                                        (0x00E00000&((data)<<21))
+#define DC_PHY_DQ_OCD_SEL_dq_3_ocdn_sel_src(data)                                    ((0x00E00000&(data))>>21)
+#define DC_PHY_DQ_OCD_SEL_get_dq_3_ocdn_sel(data)                                    ((0x00E00000&(data))>>21)
+#define DC_PHY_DQ_OCD_SEL_dq_2_ocdn_sel_shift                                        (18)
+#define DC_PHY_DQ_OCD_SEL_dq_2_ocdn_sel_mask                                         (0x001C0000)
+#define DC_PHY_DQ_OCD_SEL_dq_2_ocdn_sel(data)                                        (0x001C0000&((data)<<18))
+#define DC_PHY_DQ_OCD_SEL_dq_2_ocdn_sel_src(data)                                    ((0x001C0000&(data))>>18)
+#define DC_PHY_DQ_OCD_SEL_get_dq_2_ocdn_sel(data)                                    ((0x001C0000&(data))>>18)
+#define DC_PHY_DQ_OCD_SEL_dq_1_ocdn_sel_shift                                        (15)
+#define DC_PHY_DQ_OCD_SEL_dq_1_ocdn_sel_mask                                         (0x00038000)
+#define DC_PHY_DQ_OCD_SEL_dq_1_ocdn_sel(data)                                        (0x00038000&((data)<<15))
+#define DC_PHY_DQ_OCD_SEL_dq_1_ocdn_sel_src(data)                                    ((0x00038000&(data))>>15)
+#define DC_PHY_DQ_OCD_SEL_get_dq_1_ocdn_sel(data)                                    ((0x00038000&(data))>>15)
+#define DC_PHY_DQ_OCD_SEL_dq_0_ocdn_sel_shift                                        (12)
+#define DC_PHY_DQ_OCD_SEL_dq_0_ocdn_sel_mask                                         (0x00007000)
+#define DC_PHY_DQ_OCD_SEL_dq_0_ocdn_sel(data)                                        (0x00007000&((data)<<12))
+#define DC_PHY_DQ_OCD_SEL_dq_0_ocdn_sel_src(data)                                    ((0x00007000&(data))>>12)
+#define DC_PHY_DQ_OCD_SEL_get_dq_0_ocdn_sel(data)                                    ((0x00007000&(data))>>12)
+#define DC_PHY_DQ_OCD_SEL_dq_3_ocdp_sel_shift                                        (9)
+#define DC_PHY_DQ_OCD_SEL_dq_3_ocdp_sel_mask                                         (0x00000E00)
+#define DC_PHY_DQ_OCD_SEL_dq_3_ocdp_sel(data)                                        (0x00000E00&((data)<<9))
+#define DC_PHY_DQ_OCD_SEL_dq_3_ocdp_sel_src(data)                                    ((0x00000E00&(data))>>9)
+#define DC_PHY_DQ_OCD_SEL_get_dq_3_ocdp_sel(data)                                    ((0x00000E00&(data))>>9)
+#define DC_PHY_DQ_OCD_SEL_dq_2_ocdp_sel_shift                                        (6)
+#define DC_PHY_DQ_OCD_SEL_dq_2_ocdp_sel_mask                                         (0x000001C0)
+#define DC_PHY_DQ_OCD_SEL_dq_2_ocdp_sel(data)                                        (0x000001C0&((data)<<6))
+#define DC_PHY_DQ_OCD_SEL_dq_2_ocdp_sel_src(data)                                    ((0x000001C0&(data))>>6)
+#define DC_PHY_DQ_OCD_SEL_get_dq_2_ocdp_sel(data)                                    ((0x000001C0&(data))>>6)
+#define DC_PHY_DQ_OCD_SEL_dq_1_ocdp_sel_shift                                        (3)
+#define DC_PHY_DQ_OCD_SEL_dq_1_ocdp_sel_mask                                         (0x00000038)
+#define DC_PHY_DQ_OCD_SEL_dq_1_ocdp_sel(data)                                        (0x00000038&((data)<<3))
+#define DC_PHY_DQ_OCD_SEL_dq_1_ocdp_sel_src(data)                                    ((0x00000038&(data))>>3)
+#define DC_PHY_DQ_OCD_SEL_get_dq_1_ocdp_sel(data)                                    ((0x00000038&(data))>>3)
+#define DC_PHY_DQ_OCD_SEL_dq_0_ocdp_sel_shift                                        (0)
+#define DC_PHY_DQ_OCD_SEL_dq_0_ocdp_sel_mask                                         (0x00000007)
+#define DC_PHY_DQ_OCD_SEL_dq_0_ocdp_sel(data)                                        (0x00000007&((data)<<0))
+#define DC_PHY_DQ_OCD_SEL_dq_0_ocdp_sel_src(data)                                    ((0x00000007&(data))>>0)
+#define DC_PHY_DQ_OCD_SEL_get_dq_0_ocdp_sel(data)                                    ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_DQS_P_TTC_SEL                                                         0x18008a4c
+#define DC_PHY_DQS_P_TTC_SEL_reg_addr                                                "0xB8008A4C"
+#define DC_PHY_DQS_P_TTC_SEL_reg                                                     0xB8008A4C
+#define set_DC_PHY_DQS_P_TTC_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DQS_P_TTC_SEL_reg)=data)
+#define get_DC_PHY_DQS_P_TTC_SEL_reg   (*((volatile unsigned int*) DC_PHY_DQS_P_TTC_SEL_reg))
+#define DC_PHY_DQS_P_TTC_SEL_inst_adr                                                "0x0093"
+#define DC_PHY_DQS_P_TTC_SEL_inst                                                    0x0093
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_3_ttcn_sel_shift                                  (21)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_3_ttcn_sel_mask                                   (0x00E00000)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_3_ttcn_sel(data)                                  (0x00E00000&((data)<<21))
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_3_ttcn_sel_src(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_P_TTC_SEL_get_dqs_p_3_ttcn_sel(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_2_ttcn_sel_shift                                  (18)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_2_ttcn_sel_mask                                   (0x001C0000)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_2_ttcn_sel(data)                                  (0x001C0000&((data)<<18))
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_2_ttcn_sel_src(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_P_TTC_SEL_get_dqs_p_2_ttcn_sel(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_1_ttcn_sel_shift                                  (15)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_1_ttcn_sel_mask                                   (0x00038000)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_1_ttcn_sel(data)                                  (0x00038000&((data)<<15))
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_1_ttcn_sel_src(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_P_TTC_SEL_get_dqs_p_1_ttcn_sel(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_0_ttcn_sel_shift                                  (12)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_0_ttcn_sel_mask                                   (0x00007000)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_0_ttcn_sel(data)                                  (0x00007000&((data)<<12))
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_0_ttcn_sel_src(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_P_TTC_SEL_get_dqs_p_0_ttcn_sel(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_3_ttcp_sel_shift                                  (9)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_3_ttcp_sel_mask                                   (0x00000E00)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_3_ttcp_sel(data)                                  (0x00000E00&((data)<<9))
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_3_ttcp_sel_src(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_P_TTC_SEL_get_dqs_p_3_ttcp_sel(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_2_ttcp_sel_shift                                  (6)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_2_ttcp_sel_mask                                   (0x000001C0)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_2_ttcp_sel(data)                                  (0x000001C0&((data)<<6))
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_2_ttcp_sel_src(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_P_TTC_SEL_get_dqs_p_2_ttcp_sel(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_1_ttcp_sel_shift                                  (3)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_1_ttcp_sel_mask                                   (0x00000038)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_1_ttcp_sel(data)                                  (0x00000038&((data)<<3))
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_1_ttcp_sel_src(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_P_TTC_SEL_get_dqs_p_1_ttcp_sel(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_0_ttcp_sel_shift                                  (0)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_0_ttcp_sel_mask                                   (0x00000007)
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_0_ttcp_sel(data)                                  (0x00000007&((data)<<0))
+#define DC_PHY_DQS_P_TTC_SEL_dqs_p_0_ttcp_sel_src(data)                              ((0x00000007&(data))>>0)
+#define DC_PHY_DQS_P_TTC_SEL_get_dqs_p_0_ttcp_sel(data)                              ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_DQS_N_TTC_SEL                                                         0x18008a50
+#define DC_PHY_DQS_N_TTC_SEL_reg_addr                                                "0xB8008A50"
+#define DC_PHY_DQS_N_TTC_SEL_reg                                                     0xB8008A50
+#define set_DC_PHY_DQS_N_TTC_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DQS_N_TTC_SEL_reg)=data)
+#define get_DC_PHY_DQS_N_TTC_SEL_reg   (*((volatile unsigned int*) DC_PHY_DQS_N_TTC_SEL_reg))
+#define DC_PHY_DQS_N_TTC_SEL_inst_adr                                                "0x0094"
+#define DC_PHY_DQS_N_TTC_SEL_inst                                                    0x0094
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_3_ttcn_sel_shift                                  (21)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_3_ttcn_sel_mask                                   (0x00E00000)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_3_ttcn_sel(data)                                  (0x00E00000&((data)<<21))
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_3_ttcn_sel_src(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_N_TTC_SEL_get_dqs_n_3_ttcn_sel(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_2_ttcn_sel_shift                                  (18)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_2_ttcn_sel_mask                                   (0x001C0000)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_2_ttcn_sel(data)                                  (0x001C0000&((data)<<18))
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_2_ttcn_sel_src(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_N_TTC_SEL_get_dqs_n_2_ttcn_sel(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_1_ttcn_sel_shift                                  (15)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_1_ttcn_sel_mask                                   (0x00038000)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_1_ttcn_sel(data)                                  (0x00038000&((data)<<15))
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_1_ttcn_sel_src(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_N_TTC_SEL_get_dqs_n_1_ttcn_sel(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_0_ttcn_sel_shift                                  (12)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_0_ttcn_sel_mask                                   (0x00007000)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_0_ttcn_sel(data)                                  (0x00007000&((data)<<12))
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_0_ttcn_sel_src(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_N_TTC_SEL_get_dqs_n_0_ttcn_sel(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_3_ttcp_sel_shift                                  (9)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_3_ttcp_sel_mask                                   (0x00000E00)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_3_ttcp_sel(data)                                  (0x00000E00&((data)<<9))
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_3_ttcp_sel_src(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_N_TTC_SEL_get_dqs_n_3_ttcp_sel(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_2_ttcp_sel_shift                                  (6)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_2_ttcp_sel_mask                                   (0x000001C0)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_2_ttcp_sel(data)                                  (0x000001C0&((data)<<6))
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_2_ttcp_sel_src(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_N_TTC_SEL_get_dqs_n_2_ttcp_sel(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_1_ttcp_sel_shift                                  (3)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_1_ttcp_sel_mask                                   (0x00000038)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_1_ttcp_sel(data)                                  (0x00000038&((data)<<3))
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_1_ttcp_sel_src(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_N_TTC_SEL_get_dqs_n_1_ttcp_sel(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_0_ttcp_sel_shift                                  (0)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_0_ttcp_sel_mask                                   (0x00000007)
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_0_ttcp_sel(data)                                  (0x00000007&((data)<<0))
+#define DC_PHY_DQS_N_TTC_SEL_dqs_n_0_ttcp_sel_src(data)                              ((0x00000007&(data))>>0)
+#define DC_PHY_DQS_N_TTC_SEL_get_dqs_n_0_ttcp_sel(data)                              ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_DQS_P_TTF_SEL                                                         0x18008a54
+#define DC_PHY_DQS_P_TTF_SEL_reg_addr                                                "0xB8008A54"
+#define DC_PHY_DQS_P_TTF_SEL_reg                                                     0xB8008A54
+#define set_DC_PHY_DQS_P_TTF_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DQS_P_TTF_SEL_reg)=data)
+#define get_DC_PHY_DQS_P_TTF_SEL_reg   (*((volatile unsigned int*) DC_PHY_DQS_P_TTF_SEL_reg))
+#define DC_PHY_DQS_P_TTF_SEL_inst_adr                                                "0x0095"
+#define DC_PHY_DQS_P_TTF_SEL_inst                                                    0x0095
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_3_ttfn_sel_shift                                  (21)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_3_ttfn_sel_mask                                   (0x00E00000)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_3_ttfn_sel(data)                                  (0x00E00000&((data)<<21))
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_3_ttfn_sel_src(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_P_TTF_SEL_get_dqs_p_3_ttfn_sel(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_2_ttfn_sel_shift                                  (18)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_2_ttfn_sel_mask                                   (0x001C0000)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_2_ttfn_sel(data)                                  (0x001C0000&((data)<<18))
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_2_ttfn_sel_src(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_P_TTF_SEL_get_dqs_p_2_ttfn_sel(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_1_ttfn_sel_shift                                  (15)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_1_ttfn_sel_mask                                   (0x00038000)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_1_ttfn_sel(data)                                  (0x00038000&((data)<<15))
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_1_ttfn_sel_src(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_P_TTF_SEL_get_dqs_p_1_ttfn_sel(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_0_ttfn_sel_shift                                  (12)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_0_ttfn_sel_mask                                   (0x00007000)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_0_ttfn_sel(data)                                  (0x00007000&((data)<<12))
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_0_ttfn_sel_src(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_P_TTF_SEL_get_dqs_p_0_ttfn_sel(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_3_ttfp_sel_shift                                  (9)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_3_ttfp_sel_mask                                   (0x00000E00)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_3_ttfp_sel(data)                                  (0x00000E00&((data)<<9))
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_3_ttfp_sel_src(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_P_TTF_SEL_get_dqs_p_3_ttfp_sel(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_2_ttfp_sel_shift                                  (6)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_2_ttfp_sel_mask                                   (0x000001C0)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_2_ttfp_sel(data)                                  (0x000001C0&((data)<<6))
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_2_ttfp_sel_src(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_P_TTF_SEL_get_dqs_p_2_ttfp_sel(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_1_ttfp_sel_shift                                  (3)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_1_ttfp_sel_mask                                   (0x00000038)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_1_ttfp_sel(data)                                  (0x00000038&((data)<<3))
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_1_ttfp_sel_src(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_P_TTF_SEL_get_dqs_p_1_ttfp_sel(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_0_ttfp_sel_shift                                  (0)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_0_ttfp_sel_mask                                   (0x00000007)
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_0_ttfp_sel(data)                                  (0x00000007&((data)<<0))
+#define DC_PHY_DQS_P_TTF_SEL_dqs_p_0_ttfp_sel_src(data)                              ((0x00000007&(data))>>0)
+#define DC_PHY_DQS_P_TTF_SEL_get_dqs_p_0_ttfp_sel(data)                              ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_DQS_N_TTF_SEL                                                         0x18008a58
+#define DC_PHY_DQS_N_TTF_SEL_reg_addr                                                "0xB8008A58"
+#define DC_PHY_DQS_N_TTF_SEL_reg                                                     0xB8008A58
+#define set_DC_PHY_DQS_N_TTF_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DQS_N_TTF_SEL_reg)=data)
+#define get_DC_PHY_DQS_N_TTF_SEL_reg   (*((volatile unsigned int*) DC_PHY_DQS_N_TTF_SEL_reg))
+#define DC_PHY_DQS_N_TTF_SEL_inst_adr                                                "0x0096"
+#define DC_PHY_DQS_N_TTF_SEL_inst                                                    0x0096
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_3_ttfn_sel_shift                                  (21)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_3_ttfn_sel_mask                                   (0x00E00000)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_3_ttfn_sel(data)                                  (0x00E00000&((data)<<21))
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_3_ttfn_sel_src(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_N_TTF_SEL_get_dqs_n_3_ttfn_sel(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_2_ttfn_sel_shift                                  (18)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_2_ttfn_sel_mask                                   (0x001C0000)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_2_ttfn_sel(data)                                  (0x001C0000&((data)<<18))
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_2_ttfn_sel_src(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_N_TTF_SEL_get_dqs_n_2_ttfn_sel(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_1_ttfn_sel_shift                                  (15)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_1_ttfn_sel_mask                                   (0x00038000)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_1_ttfn_sel(data)                                  (0x00038000&((data)<<15))
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_1_ttfn_sel_src(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_N_TTF_SEL_get_dqs_n_1_ttfn_sel(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_0_ttfn_sel_shift                                  (12)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_0_ttfn_sel_mask                                   (0x00007000)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_0_ttfn_sel(data)                                  (0x00007000&((data)<<12))
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_0_ttfn_sel_src(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_N_TTF_SEL_get_dqs_n_0_ttfn_sel(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_3_ttfp_sel_shift                                  (9)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_3_ttfp_sel_mask                                   (0x00000E00)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_3_ttfp_sel(data)                                  (0x00000E00&((data)<<9))
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_3_ttfp_sel_src(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_N_TTF_SEL_get_dqs_n_3_ttfp_sel(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_2_ttfp_sel_shift                                  (6)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_2_ttfp_sel_mask                                   (0x000001C0)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_2_ttfp_sel(data)                                  (0x000001C0&((data)<<6))
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_2_ttfp_sel_src(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_N_TTF_SEL_get_dqs_n_2_ttfp_sel(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_1_ttfp_sel_shift                                  (3)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_1_ttfp_sel_mask                                   (0x00000038)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_1_ttfp_sel(data)                                  (0x00000038&((data)<<3))
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_1_ttfp_sel_src(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_N_TTF_SEL_get_dqs_n_1_ttfp_sel(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_0_ttfp_sel_shift                                  (0)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_0_ttfp_sel_mask                                   (0x00000007)
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_0_ttfp_sel(data)                                  (0x00000007&((data)<<0))
+#define DC_PHY_DQS_N_TTF_SEL_dqs_n_0_ttfp_sel_src(data)                              ((0x00000007&(data))>>0)
+#define DC_PHY_DQS_N_TTF_SEL_get_dqs_n_0_ttfp_sel(data)                              ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_DQS_P_OCD_SEL                                                         0x18008a5c
+#define DC_PHY_DQS_P_OCD_SEL_reg_addr                                                "0xB8008A5C"
+#define DC_PHY_DQS_P_OCD_SEL_reg                                                     0xB8008A5C
+#define set_DC_PHY_DQS_P_OCD_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DQS_P_OCD_SEL_reg)=data)
+#define get_DC_PHY_DQS_P_OCD_SEL_reg   (*((volatile unsigned int*) DC_PHY_DQS_P_OCD_SEL_reg))
+#define DC_PHY_DQS_P_OCD_SEL_inst_adr                                                "0x0097"
+#define DC_PHY_DQS_P_OCD_SEL_inst                                                    0x0097
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_3_ocdn_sel_shift                                  (21)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_3_ocdn_sel_mask                                   (0x00E00000)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_3_ocdn_sel(data)                                  (0x00E00000&((data)<<21))
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_3_ocdn_sel_src(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_P_OCD_SEL_get_dqs_p_3_ocdn_sel(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_2_ocdn_sel_shift                                  (18)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_2_ocdn_sel_mask                                   (0x001C0000)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_2_ocdn_sel(data)                                  (0x001C0000&((data)<<18))
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_2_ocdn_sel_src(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_P_OCD_SEL_get_dqs_p_2_ocdn_sel(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_1_ocdn_sel_shift                                  (15)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_1_ocdn_sel_mask                                   (0x00038000)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_1_ocdn_sel(data)                                  (0x00038000&((data)<<15))
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_1_ocdn_sel_src(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_P_OCD_SEL_get_dqs_p_1_ocdn_sel(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_0_ocdn_sel_shift                                  (12)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_0_ocdn_sel_mask                                   (0x00007000)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_0_ocdn_sel(data)                                  (0x00007000&((data)<<12))
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_0_ocdn_sel_src(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_P_OCD_SEL_get_dqs_p_0_ocdn_sel(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_3_ocdp_sel_shift                                  (9)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_3_ocdp_sel_mask                                   (0x00000E00)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_3_ocdp_sel(data)                                  (0x00000E00&((data)<<9))
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_3_ocdp_sel_src(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_P_OCD_SEL_get_dqs_p_3_ocdp_sel(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_2_ocdp_sel_shift                                  (6)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_2_ocdp_sel_mask                                   (0x000001C0)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_2_ocdp_sel(data)                                  (0x000001C0&((data)<<6))
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_2_ocdp_sel_src(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_P_OCD_SEL_get_dqs_p_2_ocdp_sel(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_1_ocdp_sel_shift                                  (3)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_1_ocdp_sel_mask                                   (0x00000038)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_1_ocdp_sel(data)                                  (0x00000038&((data)<<3))
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_1_ocdp_sel_src(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_P_OCD_SEL_get_dqs_p_1_ocdp_sel(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_0_ocdp_sel_shift                                  (0)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_0_ocdp_sel_mask                                   (0x00000007)
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_0_ocdp_sel(data)                                  (0x00000007&((data)<<0))
+#define DC_PHY_DQS_P_OCD_SEL_dqs_p_0_ocdp_sel_src(data)                              ((0x00000007&(data))>>0)
+#define DC_PHY_DQS_P_OCD_SEL_get_dqs_p_0_ocdp_sel(data)                              ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_DQS_N_OCD_SEL                                                         0x18008a60
+#define DC_PHY_DQS_N_OCD_SEL_reg_addr                                                "0xB8008A60"
+#define DC_PHY_DQS_N_OCD_SEL_reg                                                     0xB8008A60
+#define set_DC_PHY_DQS_N_OCD_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_DQS_N_OCD_SEL_reg)=data)
+#define get_DC_PHY_DQS_N_OCD_SEL_reg   (*((volatile unsigned int*) DC_PHY_DQS_N_OCD_SEL_reg))
+#define DC_PHY_DQS_N_OCD_SEL_inst_adr                                                "0x0098"
+#define DC_PHY_DQS_N_OCD_SEL_inst                                                    0x0098
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_3_ocdn_sel_shift                                  (21)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_3_ocdn_sel_mask                                   (0x00E00000)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_3_ocdn_sel(data)                                  (0x00E00000&((data)<<21))
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_3_ocdn_sel_src(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_N_OCD_SEL_get_dqs_n_3_ocdn_sel(data)                              ((0x00E00000&(data))>>21)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_2_ocdn_sel_shift                                  (18)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_2_ocdn_sel_mask                                   (0x001C0000)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_2_ocdn_sel(data)                                  (0x001C0000&((data)<<18))
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_2_ocdn_sel_src(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_N_OCD_SEL_get_dqs_n_2_ocdn_sel(data)                              ((0x001C0000&(data))>>18)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_1_ocdn_sel_shift                                  (15)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_1_ocdn_sel_mask                                   (0x00038000)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_1_ocdn_sel(data)                                  (0x00038000&((data)<<15))
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_1_ocdn_sel_src(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_N_OCD_SEL_get_dqs_n_1_ocdn_sel(data)                              ((0x00038000&(data))>>15)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_0_ocdn_sel_shift                                  (12)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_0_ocdn_sel_mask                                   (0x00007000)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_0_ocdn_sel(data)                                  (0x00007000&((data)<<12))
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_0_ocdn_sel_src(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_N_OCD_SEL_get_dqs_n_0_ocdn_sel(data)                              ((0x00007000&(data))>>12)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_3_ocdp_sel_shift                                  (9)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_3_ocdp_sel_mask                                   (0x00000E00)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_3_ocdp_sel(data)                                  (0x00000E00&((data)<<9))
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_3_ocdp_sel_src(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_N_OCD_SEL_get_dqs_n_3_ocdp_sel(data)                              ((0x00000E00&(data))>>9)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_2_ocdp_sel_shift                                  (6)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_2_ocdp_sel_mask                                   (0x000001C0)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_2_ocdp_sel(data)                                  (0x000001C0&((data)<<6))
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_2_ocdp_sel_src(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_N_OCD_SEL_get_dqs_n_2_ocdp_sel(data)                              ((0x000001C0&(data))>>6)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_1_ocdp_sel_shift                                  (3)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_1_ocdp_sel_mask                                   (0x00000038)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_1_ocdp_sel(data)                                  (0x00000038&((data)<<3))
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_1_ocdp_sel_src(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_N_OCD_SEL_get_dqs_n_1_ocdp_sel(data)                              ((0x00000038&(data))>>3)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_0_ocdp_sel_shift                                  (0)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_0_ocdp_sel_mask                                   (0x00000007)
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_0_ocdp_sel(data)                                  (0x00000007&((data)<<0))
+#define DC_PHY_DQS_N_OCD_SEL_dqs_n_0_ocdp_sel_src(data)                              ((0x00000007&(data))>>0)
+#define DC_PHY_DQS_N_OCD_SEL_get_dqs_n_0_ocdp_sel(data)                              ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_ADR_OCD_SEL                                                           0x18008a64
+#define DC_PHY_ADR_OCD_SEL_reg_addr                                                  "0xB8008A64"
+#define DC_PHY_ADR_OCD_SEL_reg                                                       0xB8008A64
+#define set_DC_PHY_ADR_OCD_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_ADR_OCD_SEL_reg)=data)
+#define get_DC_PHY_ADR_OCD_SEL_reg   (*((volatile unsigned int*) DC_PHY_ADR_OCD_SEL_reg))
+#define DC_PHY_ADR_OCD_SEL_inst_adr                                                  "0x0099"
+#define DC_PHY_ADR_OCD_SEL_inst                                                      0x0099
+#define DC_PHY_ADR_OCD_SEL_adr_1_ocdn_sel_shift                                      (21)
+#define DC_PHY_ADR_OCD_SEL_adr_1_ocdn_sel_mask                                       (0x00E00000)
+#define DC_PHY_ADR_OCD_SEL_adr_1_ocdn_sel(data)                                      (0x00E00000&((data)<<21))
+#define DC_PHY_ADR_OCD_SEL_adr_1_ocdn_sel_src(data)                                  ((0x00E00000&(data))>>21)
+#define DC_PHY_ADR_OCD_SEL_get_adr_1_ocdn_sel(data)                                  ((0x00E00000&(data))>>21)
+#define DC_PHY_ADR_OCD_SEL_adr_0_ocdn_sel_shift                                      (18)
+#define DC_PHY_ADR_OCD_SEL_adr_0_ocdn_sel_mask                                       (0x001C0000)
+#define DC_PHY_ADR_OCD_SEL_adr_0_ocdn_sel(data)                                      (0x001C0000&((data)<<18))
+#define DC_PHY_ADR_OCD_SEL_adr_0_ocdn_sel_src(data)                                  ((0x001C0000&(data))>>18)
+#define DC_PHY_ADR_OCD_SEL_get_adr_0_ocdn_sel(data)                                  ((0x001C0000&(data))>>18)
+#define DC_PHY_ADR_OCD_SEL_cmd_1_ocdn_sel_shift                                      (15)
+#define DC_PHY_ADR_OCD_SEL_cmd_1_ocdn_sel_mask                                       (0x00038000)
+#define DC_PHY_ADR_OCD_SEL_cmd_1_ocdn_sel(data)                                      (0x00038000&((data)<<15))
+#define DC_PHY_ADR_OCD_SEL_cmd_1_ocdn_sel_src(data)                                  ((0x00038000&(data))>>15)
+#define DC_PHY_ADR_OCD_SEL_get_cmd_1_ocdn_sel(data)                                  ((0x00038000&(data))>>15)
+#define DC_PHY_ADR_OCD_SEL_cmd_0_ocdn_sel_shift                                      (12)
+#define DC_PHY_ADR_OCD_SEL_cmd_0_ocdn_sel_mask                                       (0x00007000)
+#define DC_PHY_ADR_OCD_SEL_cmd_0_ocdn_sel(data)                                      (0x00007000&((data)<<12))
+#define DC_PHY_ADR_OCD_SEL_cmd_0_ocdn_sel_src(data)                                  ((0x00007000&(data))>>12)
+#define DC_PHY_ADR_OCD_SEL_get_cmd_0_ocdn_sel(data)                                  ((0x00007000&(data))>>12)
+#define DC_PHY_ADR_OCD_SEL_adr_1_ocdp_sel_shift                                      (9)
+#define DC_PHY_ADR_OCD_SEL_adr_1_ocdp_sel_mask                                       (0x00000E00)
+#define DC_PHY_ADR_OCD_SEL_adr_1_ocdp_sel(data)                                      (0x00000E00&((data)<<9))
+#define DC_PHY_ADR_OCD_SEL_adr_1_ocdp_sel_src(data)                                  ((0x00000E00&(data))>>9)
+#define DC_PHY_ADR_OCD_SEL_get_adr_1_ocdp_sel(data)                                  ((0x00000E00&(data))>>9)
+#define DC_PHY_ADR_OCD_SEL_adr_0_ocdp_sel_shift                                      (6)
+#define DC_PHY_ADR_OCD_SEL_adr_0_ocdp_sel_mask                                       (0x000001C0)
+#define DC_PHY_ADR_OCD_SEL_adr_0_ocdp_sel(data)                                      (0x000001C0&((data)<<6))
+#define DC_PHY_ADR_OCD_SEL_adr_0_ocdp_sel_src(data)                                  ((0x000001C0&(data))>>6)
+#define DC_PHY_ADR_OCD_SEL_get_adr_0_ocdp_sel(data)                                  ((0x000001C0&(data))>>6)
+#define DC_PHY_ADR_OCD_SEL_cmd_1_ocdp_sel_shift                                      (3)
+#define DC_PHY_ADR_OCD_SEL_cmd_1_ocdp_sel_mask                                       (0x00000038)
+#define DC_PHY_ADR_OCD_SEL_cmd_1_ocdp_sel(data)                                      (0x00000038&((data)<<3))
+#define DC_PHY_ADR_OCD_SEL_cmd_1_ocdp_sel_src(data)                                  ((0x00000038&(data))>>3)
+#define DC_PHY_ADR_OCD_SEL_get_cmd_1_ocdp_sel(data)                                  ((0x00000038&(data))>>3)
+#define DC_PHY_ADR_OCD_SEL_cmd_0_ocdp_sel_shift                                      (0)
+#define DC_PHY_ADR_OCD_SEL_cmd_0_ocdp_sel_mask                                       (0x00000007)
+#define DC_PHY_ADR_OCD_SEL_cmd_0_ocdp_sel(data)                                      (0x00000007&((data)<<0))
+#define DC_PHY_ADR_OCD_SEL_cmd_0_ocdp_sel_src(data)                                  ((0x00000007&(data))>>0)
+#define DC_PHY_ADR_OCD_SEL_get_cmd_0_ocdp_sel(data)                                  ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_CK_OCD_SEL                                                            0x18008a68
+#define DC_PHY_CK_OCD_SEL_reg_addr                                                   "0xB8008A68"
+#define DC_PHY_CK_OCD_SEL_reg                                                        0xB8008A68
+#define set_DC_PHY_CK_OCD_SEL_reg(data)   (*((volatile unsigned int*) DC_PHY_CK_OCD_SEL_reg)=data)
+#define get_DC_PHY_CK_OCD_SEL_reg   (*((volatile unsigned int*) DC_PHY_CK_OCD_SEL_reg))
+#define DC_PHY_CK_OCD_SEL_inst_adr                                                   "0x009A"
+#define DC_PHY_CK_OCD_SEL_inst                                                       0x009A
+#define DC_PHY_CK_OCD_SEL_ck_n_1_ocdn_sel_shift                                      (21)
+#define DC_PHY_CK_OCD_SEL_ck_n_1_ocdn_sel_mask                                       (0x00E00000)
+#define DC_PHY_CK_OCD_SEL_ck_n_1_ocdn_sel(data)                                      (0x00E00000&((data)<<21))
+#define DC_PHY_CK_OCD_SEL_ck_n_1_ocdn_sel_src(data)                                  ((0x00E00000&(data))>>21)
+#define DC_PHY_CK_OCD_SEL_get_ck_n_1_ocdn_sel(data)                                  ((0x00E00000&(data))>>21)
+#define DC_PHY_CK_OCD_SEL_ck_n_0_ocdn_sel_shift                                      (18)
+#define DC_PHY_CK_OCD_SEL_ck_n_0_ocdn_sel_mask                                       (0x001C0000)
+#define DC_PHY_CK_OCD_SEL_ck_n_0_ocdn_sel(data)                                      (0x001C0000&((data)<<18))
+#define DC_PHY_CK_OCD_SEL_ck_n_0_ocdn_sel_src(data)                                  ((0x001C0000&(data))>>18)
+#define DC_PHY_CK_OCD_SEL_get_ck_n_0_ocdn_sel(data)                                  ((0x001C0000&(data))>>18)
+#define DC_PHY_CK_OCD_SEL_ck_n_1_ocdp_sel_shift                                      (15)
+#define DC_PHY_CK_OCD_SEL_ck_n_1_ocdp_sel_mask                                       (0x00038000)
+#define DC_PHY_CK_OCD_SEL_ck_n_1_ocdp_sel(data)                                      (0x00038000&((data)<<15))
+#define DC_PHY_CK_OCD_SEL_ck_n_1_ocdp_sel_src(data)                                  ((0x00038000&(data))>>15)
+#define DC_PHY_CK_OCD_SEL_get_ck_n_1_ocdp_sel(data)                                  ((0x00038000&(data))>>15)
+#define DC_PHY_CK_OCD_SEL_ck_n_0_ocdp_sel_shift                                      (12)
+#define DC_PHY_CK_OCD_SEL_ck_n_0_ocdp_sel_mask                                       (0x00007000)
+#define DC_PHY_CK_OCD_SEL_ck_n_0_ocdp_sel(data)                                      (0x00007000&((data)<<12))
+#define DC_PHY_CK_OCD_SEL_ck_n_0_ocdp_sel_src(data)                                  ((0x00007000&(data))>>12)
+#define DC_PHY_CK_OCD_SEL_get_ck_n_0_ocdp_sel(data)                                  ((0x00007000&(data))>>12)
+#define DC_PHY_CK_OCD_SEL_ck_p_1_ocdn_sel_shift                                      (9)
+#define DC_PHY_CK_OCD_SEL_ck_p_1_ocdn_sel_mask                                       (0x00000E00)
+#define DC_PHY_CK_OCD_SEL_ck_p_1_ocdn_sel(data)                                      (0x00000E00&((data)<<9))
+#define DC_PHY_CK_OCD_SEL_ck_p_1_ocdn_sel_src(data)                                  ((0x00000E00&(data))>>9)
+#define DC_PHY_CK_OCD_SEL_get_ck_p_1_ocdn_sel(data)                                  ((0x00000E00&(data))>>9)
+#define DC_PHY_CK_OCD_SEL_ck_p_0_ocdn_sel_shift                                      (6)
+#define DC_PHY_CK_OCD_SEL_ck_p_0_ocdn_sel_mask                                       (0x000001C0)
+#define DC_PHY_CK_OCD_SEL_ck_p_0_ocdn_sel(data)                                      (0x000001C0&((data)<<6))
+#define DC_PHY_CK_OCD_SEL_ck_p_0_ocdn_sel_src(data)                                  ((0x000001C0&(data))>>6)
+#define DC_PHY_CK_OCD_SEL_get_ck_p_0_ocdn_sel(data)                                  ((0x000001C0&(data))>>6)
+#define DC_PHY_CK_OCD_SEL_ck_p_1_ocdp_sel_shift                                      (3)
+#define DC_PHY_CK_OCD_SEL_ck_p_1_ocdp_sel_mask                                       (0x00000038)
+#define DC_PHY_CK_OCD_SEL_ck_p_1_ocdp_sel(data)                                      (0x00000038&((data)<<3))
+#define DC_PHY_CK_OCD_SEL_ck_p_1_ocdp_sel_src(data)                                  ((0x00000038&(data))>>3)
+#define DC_PHY_CK_OCD_SEL_get_ck_p_1_ocdp_sel(data)                                  ((0x00000038&(data))>>3)
+#define DC_PHY_CK_OCD_SEL_ck_p_0_ocdp_sel_shift                                      (0)
+#define DC_PHY_CK_OCD_SEL_ck_p_0_ocdp_sel_mask                                       (0x00000007)
+#define DC_PHY_CK_OCD_SEL_ck_p_0_ocdp_sel(data)                                      (0x00000007&((data)<<0))
+#define DC_PHY_CK_OCD_SEL_ck_p_0_ocdp_sel_src(data)                                  ((0x00000007&(data))>>0)
+#define DC_PHY_CK_OCD_SEL_get_ck_p_0_ocdp_sel(data)                                  ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_PAD_BUS_0                                                             0x18008b00
+#define DC_PHY_PAD_BUS_0_reg_addr                                                    "0xB8008B00"
+#define DC_PHY_PAD_BUS_0_reg                                                         0xB8008B00
+#define set_DC_PHY_PAD_BUS_0_reg(data)   (*((volatile unsigned int*) DC_PHY_PAD_BUS_0_reg)=data)
+#define get_DC_PHY_PAD_BUS_0_reg   (*((volatile unsigned int*) DC_PHY_PAD_BUS_0_reg))
+#define DC_PHY_PAD_BUS_0_inst_adr                                                    "0x00C0"
+#define DC_PHY_PAD_BUS_0_inst                                                        0x00C0
+#define DC_PHY_PAD_BUS_0_pad_bus_0_shift                                             (0)
+#define DC_PHY_PAD_BUS_0_pad_bus_0_mask                                              (0xFFFFFFFF)
+#define DC_PHY_PAD_BUS_0_pad_bus_0(data)                                             (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_PAD_BUS_0_pad_bus_0_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_PAD_BUS_0_get_pad_bus_0(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_PAD_BUS_1                                                             0x18008b04
+#define DC_PHY_PAD_BUS_1_reg_addr                                                    "0xB8008B04"
+#define DC_PHY_PAD_BUS_1_reg                                                         0xB8008B04
+#define set_DC_PHY_PAD_BUS_1_reg(data)   (*((volatile unsigned int*) DC_PHY_PAD_BUS_1_reg)=data)
+#define get_DC_PHY_PAD_BUS_1_reg   (*((volatile unsigned int*) DC_PHY_PAD_BUS_1_reg))
+#define DC_PHY_PAD_BUS_1_inst_adr                                                    "0x00C1"
+#define DC_PHY_PAD_BUS_1_inst                                                        0x00C1
+#define DC_PHY_PAD_BUS_1_pad_bus_1_shift                                             (0)
+#define DC_PHY_PAD_BUS_1_pad_bus_1_mask                                              (0x0000000F)
+#define DC_PHY_PAD_BUS_1_pad_bus_1(data)                                             (0x0000000F&((data)<<0))
+#define DC_PHY_PAD_BUS_1_pad_bus_1_src(data)                                         ((0x0000000F&(data))>>0)
+#define DC_PHY_PAD_BUS_1_get_pad_bus_1(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_ANA_DLL_1                                                             0x18008b20
+#define DC_PHY_ANA_DLL_1_reg_addr                                                    "0xB8008B20"
+#define DC_PHY_ANA_DLL_1_reg                                                         0xB8008B20
+#define set_DC_PHY_ANA_DLL_1_reg(data)   (*((volatile unsigned int*) DC_PHY_ANA_DLL_1_reg)=data)
+#define get_DC_PHY_ANA_DLL_1_reg   (*((volatile unsigned int*) DC_PHY_ANA_DLL_1_reg))
+#define DC_PHY_ANA_DLL_1_inst_adr                                                    "0x00C8"
+#define DC_PHY_ANA_DLL_1_inst                                                        0x00C8
+#define DC_PHY_ANA_DLL_1_dll_en_test_shift                                           (31)
+#define DC_PHY_ANA_DLL_1_dll_en_test_mask                                            (0x80000000)
+#define DC_PHY_ANA_DLL_1_dll_en_test(data)                                           (0x80000000&((data)<<31))
+#define DC_PHY_ANA_DLL_1_dll_en_test_src(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_ANA_DLL_1_get_dll_en_test(data)                                       ((0x80000000&(data))>>31)
+#define DC_PHY_ANA_DLL_1_dll_sc_shift                                                (28)
+#define DC_PHY_ANA_DLL_1_dll_sc_mask                                                 (0x70000000)
+#define DC_PHY_ANA_DLL_1_dll_sc(data)                                                (0x70000000&((data)<<28))
+#define DC_PHY_ANA_DLL_1_dll_sc_src(data)                                            ((0x70000000&(data))>>28)
+#define DC_PHY_ANA_DLL_1_get_dll_sc(data)                                            ((0x70000000&(data))>>28)
+#define DC_PHY_ANA_DLL_1_dll_sel_ipump_shift                                         (24)
+#define DC_PHY_ANA_DLL_1_dll_sel_ipump_mask                                          (0x0F000000)
+#define DC_PHY_ANA_DLL_1_dll_sel_ipump(data)                                         (0x0F000000&((data)<<24))
+#define DC_PHY_ANA_DLL_1_dll_sel_ipump_src(data)                                     ((0x0F000000&(data))>>24)
+#define DC_PHY_ANA_DLL_1_get_dll_sel_ipump(data)                                     ((0x0F000000&(data))>>24)
+#define DC_PHY_ANA_DLL_1_dll_pfd_div_shift                                           (18)
+#define DC_PHY_ANA_DLL_1_dll_pfd_div_mask                                            (0x00FC0000)
+#define DC_PHY_ANA_DLL_1_dll_pfd_div(data)                                           (0x00FC0000&((data)<<18))
+#define DC_PHY_ANA_DLL_1_dll_pfd_div_src(data)                                       ((0x00FC0000&(data))>>18)
+#define DC_PHY_ANA_DLL_1_get_dll_pfd_div(data)                                       ((0x00FC0000&(data))>>18)
+#define DC_PHY_ANA_DLL_1_dll_pre_divn_shift                                          (16)
+#define DC_PHY_ANA_DLL_1_dll_pre_divn_mask                                           (0x00030000)
+#define DC_PHY_ANA_DLL_1_dll_pre_divn(data)                                          (0x00030000&((data)<<16))
+#define DC_PHY_ANA_DLL_1_dll_pre_divn_src(data)                                      ((0x00030000&(data))>>16)
+#define DC_PHY_ANA_DLL_1_get_dll_pre_divn(data)                                      ((0x00030000&(data))>>16)
+#define DC_PHY_ANA_DLL_1_dll_en_newpump_shift                                        (15)
+#define DC_PHY_ANA_DLL_1_dll_en_newpump_mask                                         (0x00008000)
+#define DC_PHY_ANA_DLL_1_dll_en_newpump(data)                                        (0x00008000&((data)<<15))
+#define DC_PHY_ANA_DLL_1_dll_en_newpump_src(data)                                    ((0x00008000&(data))>>15)
+#define DC_PHY_ANA_DLL_1_get_dll_en_newpump(data)                                    ((0x00008000&(data))>>15)
+#define DC_PHY_ANA_DLL_1_dll_bin_dl2_ph_sel_shift                                    (10)
+#define DC_PHY_ANA_DLL_1_dll_bin_dl2_ph_sel_mask                                     (0x00007C00)
+#define DC_PHY_ANA_DLL_1_dll_bin_dl2_ph_sel(data)                                    (0x00007C00&((data)<<10))
+#define DC_PHY_ANA_DLL_1_dll_bin_dl2_ph_sel_src(data)                                ((0x00007C00&(data))>>10)
+#define DC_PHY_ANA_DLL_1_get_dll_bin_dl2_ph_sel(data)                                ((0x00007C00&(data))>>10)
+#define DC_PHY_ANA_DLL_1_dll_bin_dl1_ph_sel_shift                                    (5)
+#define DC_PHY_ANA_DLL_1_dll_bin_dl1_ph_sel_mask                                     (0x000003E0)
+#define DC_PHY_ANA_DLL_1_dll_bin_dl1_ph_sel(data)                                    (0x000003E0&((data)<<5))
+#define DC_PHY_ANA_DLL_1_dll_bin_dl1_ph_sel_src(data)                                ((0x000003E0&(data))>>5)
+#define DC_PHY_ANA_DLL_1_get_dll_bin_dl1_ph_sel(data)                                ((0x000003E0&(data))>>5)
+#define DC_PHY_ANA_DLL_1_dll_bin_dl0_ph_sel_shift                                    (0)
+#define DC_PHY_ANA_DLL_1_dll_bin_dl0_ph_sel_mask                                     (0x0000001F)
+#define DC_PHY_ANA_DLL_1_dll_bin_dl0_ph_sel(data)                                    (0x0000001F&((data)<<0))
+#define DC_PHY_ANA_DLL_1_dll_bin_dl0_ph_sel_src(data)                                ((0x0000001F&(data))>>0)
+#define DC_PHY_ANA_DLL_1_get_dll_bin_dl0_ph_sel(data)                                ((0x0000001F&(data))>>0)
+
+
+#define DC_PHY_ANA_DLL_2                                                             0x18008b24
+#define DC_PHY_ANA_DLL_2_reg_addr                                                    "0xB8008B24"
+#define DC_PHY_ANA_DLL_2_reg                                                         0xB8008B24
+#define set_DC_PHY_ANA_DLL_2_reg(data)   (*((volatile unsigned int*) DC_PHY_ANA_DLL_2_reg)=data)
+#define get_DC_PHY_ANA_DLL_2_reg   (*((volatile unsigned int*) DC_PHY_ANA_DLL_2_reg))
+#define DC_PHY_ANA_DLL_2_inst_adr                                                    "0x00C9"
+#define DC_PHY_ANA_DLL_2_inst                                                        0x00C9
+#define DC_PHY_ANA_DLL_2_dll_en_3_shift                                              (12)
+#define DC_PHY_ANA_DLL_2_dll_en_3_mask                                               (0x00001000)
+#define DC_PHY_ANA_DLL_2_dll_en_3(data)                                              (0x00001000&((data)<<12))
+#define DC_PHY_ANA_DLL_2_dll_en_3_src(data)                                          ((0x00001000&(data))>>12)
+#define DC_PHY_ANA_DLL_2_get_dll_en_3(data)                                          ((0x00001000&(data))>>12)
+#define DC_PHY_ANA_DLL_2_dll_en_2_shift                                              (11)
+#define DC_PHY_ANA_DLL_2_dll_en_2_mask                                               (0x00000800)
+#define DC_PHY_ANA_DLL_2_dll_en_2(data)                                              (0x00000800&((data)<<11))
+#define DC_PHY_ANA_DLL_2_dll_en_2_src(data)                                          ((0x00000800&(data))>>11)
+#define DC_PHY_ANA_DLL_2_get_dll_en_2(data)                                          ((0x00000800&(data))>>11)
+#define DC_PHY_ANA_DLL_2_dll_en_1_shift                                              (10)
+#define DC_PHY_ANA_DLL_2_dll_en_1_mask                                               (0x00000400)
+#define DC_PHY_ANA_DLL_2_dll_en_1(data)                                              (0x00000400&((data)<<10))
+#define DC_PHY_ANA_DLL_2_dll_en_1_src(data)                                          ((0x00000400&(data))>>10)
+#define DC_PHY_ANA_DLL_2_get_dll_en_1(data)                                          ((0x00000400&(data))>>10)
+#define DC_PHY_ANA_DLL_2_dll_en_0_shift                                              (9)
+#define DC_PHY_ANA_DLL_2_dll_en_0_mask                                               (0x00000200)
+#define DC_PHY_ANA_DLL_2_dll_en_0(data)                                              (0x00000200&((data)<<9))
+#define DC_PHY_ANA_DLL_2_dll_en_0_src(data)                                          ((0x00000200&(data))>>9)
+#define DC_PHY_ANA_DLL_2_get_dll_en_0(data)                                          ((0x00000200&(data))>>9)
+#define DC_PHY_ANA_DLL_2_dll_dl_ph_sel_shift                                         (8)
+#define DC_PHY_ANA_DLL_2_dll_dl_ph_sel_mask                                          (0x00000100)
+#define DC_PHY_ANA_DLL_2_dll_dl_ph_sel(data)                                         (0x00000100&((data)<<8))
+#define DC_PHY_ANA_DLL_2_dll_dl_ph_sel_src(data)                                     ((0x00000100&(data))>>8)
+#define DC_PHY_ANA_DLL_2_get_dll_dl_ph_sel(data)                                     ((0x00000100&(data))>>8)
+#define DC_PHY_ANA_DLL_2_dll_rdy_3_shift                                             (7)
+#define DC_PHY_ANA_DLL_2_dll_rdy_3_mask                                              (0x00000080)
+#define DC_PHY_ANA_DLL_2_dll_rdy_3(data)                                             (0x00000080&((data)<<7))
+#define DC_PHY_ANA_DLL_2_dll_rdy_3_src(data)                                         ((0x00000080&(data))>>7)
+#define DC_PHY_ANA_DLL_2_get_dll_rdy_3(data)                                         ((0x00000080&(data))>>7)
+#define DC_PHY_ANA_DLL_2_dll_rdy_2_shift                                             (6)
+#define DC_PHY_ANA_DLL_2_dll_rdy_2_mask                                              (0x00000040)
+#define DC_PHY_ANA_DLL_2_dll_rdy_2(data)                                             (0x00000040&((data)<<6))
+#define DC_PHY_ANA_DLL_2_dll_rdy_2_src(data)                                         ((0x00000040&(data))>>6)
+#define DC_PHY_ANA_DLL_2_get_dll_rdy_2(data)                                         ((0x00000040&(data))>>6)
+#define DC_PHY_ANA_DLL_2_dll_rdy_1_shift                                             (5)
+#define DC_PHY_ANA_DLL_2_dll_rdy_1_mask                                              (0x00000020)
+#define DC_PHY_ANA_DLL_2_dll_rdy_1(data)                                             (0x00000020&((data)<<5))
+#define DC_PHY_ANA_DLL_2_dll_rdy_1_src(data)                                         ((0x00000020&(data))>>5)
+#define DC_PHY_ANA_DLL_2_get_dll_rdy_1(data)                                         ((0x00000020&(data))>>5)
+#define DC_PHY_ANA_DLL_2_dll_rdy_0_shift                                             (4)
+#define DC_PHY_ANA_DLL_2_dll_rdy_0_mask                                              (0x00000010)
+#define DC_PHY_ANA_DLL_2_dll_rdy_0(data)                                             (0x00000010&((data)<<4))
+#define DC_PHY_ANA_DLL_2_dll_rdy_0_src(data)                                         ((0x00000010&(data))>>4)
+#define DC_PHY_ANA_DLL_2_get_dll_rdy_0(data)                                         ((0x00000010&(data))>>4)
+#define DC_PHY_ANA_DLL_2_dll_div_sel_shift                                           (2)
+#define DC_PHY_ANA_DLL_2_dll_div_sel_mask                                            (0x0000000C)
+#define DC_PHY_ANA_DLL_2_dll_div_sel(data)                                           (0x0000000C&((data)<<2))
+#define DC_PHY_ANA_DLL_2_dll_div_sel_src(data)                                       ((0x0000000C&(data))>>2)
+#define DC_PHY_ANA_DLL_2_get_dll_div_sel(data)                                       ((0x0000000C&(data))>>2)
+#define DC_PHY_ANA_DLL_2_dll_ck_sel_shift                                            (1)
+#define DC_PHY_ANA_DLL_2_dll_ck_sel_mask                                             (0x00000002)
+#define DC_PHY_ANA_DLL_2_dll_ck_sel(data)                                            (0x00000002&((data)<<1))
+#define DC_PHY_ANA_DLL_2_dll_ck_sel_src(data)                                        ((0x00000002&(data))>>1)
+#define DC_PHY_ANA_DLL_2_get_dll_ck_sel(data)                                        ((0x00000002&(data))>>1)
+#define DC_PHY_ANA_DLL_2_ana_dly_sel_shift                                           (0)
+#define DC_PHY_ANA_DLL_2_ana_dly_sel_mask                                            (0x00000001)
+#define DC_PHY_ANA_DLL_2_ana_dly_sel(data)                                           (0x00000001&((data)<<0))
+#define DC_PHY_ANA_DLL_2_ana_dly_sel_src(data)                                       ((0x00000001&(data))>>0)
+#define DC_PHY_ANA_DLL_2_get_ana_dly_sel(data)                                       ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_LPDDR_CTRL                                                            0x18008b28
+#define DC_PHY_LPDDR_CTRL_reg_addr                                                   "0xB8008B28"
+#define DC_PHY_LPDDR_CTRL_reg                                                        0xB8008B28
+#define set_DC_PHY_LPDDR_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_LPDDR_CTRL_reg)=data)
+#define get_DC_PHY_LPDDR_CTRL_reg   (*((volatile unsigned int*) DC_PHY_LPDDR_CTRL_reg))
+#define DC_PHY_LPDDR_CTRL_inst_adr                                                   "0x00CA"
+#define DC_PHY_LPDDR_CTRL_inst                                                       0x00CA
+#define DC_PHY_LPDDR_CTRL_write_en_2_shift                                           (5)
+#define DC_PHY_LPDDR_CTRL_write_en_2_mask                                            (0x00000020)
+#define DC_PHY_LPDDR_CTRL_write_en_2(data)                                           (0x00000020&((data)<<5))
+#define DC_PHY_LPDDR_CTRL_write_en_2_src(data)                                       ((0x00000020&(data))>>5)
+#define DC_PHY_LPDDR_CTRL_get_write_en_2(data)                                       ((0x00000020&(data))>>5)
+#define DC_PHY_LPDDR_CTRL_lpddr_ck_en_shift                                          (4)
+#define DC_PHY_LPDDR_CTRL_lpddr_ck_en_mask                                           (0x00000010)
+#define DC_PHY_LPDDR_CTRL_lpddr_ck_en(data)                                          (0x00000010&((data)<<4))
+#define DC_PHY_LPDDR_CTRL_lpddr_ck_en_src(data)                                      ((0x00000010&(data))>>4)
+#define DC_PHY_LPDDR_CTRL_get_lpddr_ck_en(data)                                      ((0x00000010&(data))>>4)
+#define DC_PHY_LPDDR_CTRL_write_en_1_shift                                           (3)
+#define DC_PHY_LPDDR_CTRL_write_en_1_mask                                            (0x00000008)
+#define DC_PHY_LPDDR_CTRL_write_en_1(data)                                           (0x00000008&((data)<<3))
+#define DC_PHY_LPDDR_CTRL_write_en_1_src(data)                                       ((0x00000008&(data))>>3)
+#define DC_PHY_LPDDR_CTRL_get_write_en_1(data)                                       ((0x00000008&(data))>>3)
+#define DC_PHY_LPDDR_CTRL_mod_reg_read_shift                                         (2)
+#define DC_PHY_LPDDR_CTRL_mod_reg_read_mask                                          (0x00000004)
+#define DC_PHY_LPDDR_CTRL_mod_reg_read(data)                                         (0x00000004&((data)<<2))
+#define DC_PHY_LPDDR_CTRL_mod_reg_read_src(data)                                     ((0x00000004&(data))>>2)
+#define DC_PHY_LPDDR_CTRL_get_mod_reg_read(data)                                     ((0x00000004&(data))>>2)
+#define DC_PHY_LPDDR_CTRL_write_en_0_shift                                           (1)
+#define DC_PHY_LPDDR_CTRL_write_en_0_mask                                            (0x00000002)
+#define DC_PHY_LPDDR_CTRL_write_en_0(data)                                           (0x00000002&((data)<<1))
+#define DC_PHY_LPDDR_CTRL_write_en_0_src(data)                                       ((0x00000002&(data))>>1)
+#define DC_PHY_LPDDR_CTRL_get_write_en_0(data)                                       ((0x00000002&(data))>>1)
+#define DC_PHY_LPDDR_CTRL_mod_reg_write_shift                                        (0)
+#define DC_PHY_LPDDR_CTRL_mod_reg_write_mask                                         (0x00000001)
+#define DC_PHY_LPDDR_CTRL_mod_reg_write(data)                                        (0x00000001&((data)<<0))
+#define DC_PHY_LPDDR_CTRL_mod_reg_write_src(data)                                    ((0x00000001&(data))>>0)
+#define DC_PHY_LPDDR_CTRL_get_mod_reg_write(data)                                    ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_LPDDR_RDAT                                                            0x18008b2C
+#define DC_PHY_LPDDR_RDAT_reg_addr                                                   "0xB8008B2C"
+#define DC_PHY_LPDDR_RDAT_reg                                                        0xB8008B2C
+#define set_DC_PHY_LPDDR_RDAT_reg(data)   (*((volatile unsigned int*) DC_PHY_LPDDR_RDAT_reg)=data)
+#define get_DC_PHY_LPDDR_RDAT_reg   (*((volatile unsigned int*) DC_PHY_LPDDR_RDAT_reg))
+#define DC_PHY_LPDDR_RDAT_inst_adr                                                   "0x00CB"
+#define DC_PHY_LPDDR_RDAT_inst                                                       0x00CB
+#define DC_PHY_LPDDR_RDAT_mode_reg_rdata_shift                                       (24)
+#define DC_PHY_LPDDR_RDAT_mode_reg_rdata_mask                                        (0xFF000000)
+#define DC_PHY_LPDDR_RDAT_mode_reg_rdata(data)                                       (0xFF000000&((data)<<24))
+#define DC_PHY_LPDDR_RDAT_mode_reg_rdata_src(data)                                   ((0xFF000000&(data))>>24)
+#define DC_PHY_LPDDR_RDAT_get_mode_reg_rdata(data)                                   ((0xFF000000&(data))>>24)
+
+
+#define DC_PHY_LPDDR_MODE                                                            0x18008b30
+#define DC_PHY_LPDDR_MODE_reg_addr                                                   "0xB8008B30"
+#define DC_PHY_LPDDR_MODE_reg                                                        0xB8008B30
+#define set_DC_PHY_LPDDR_MODE_reg(data)   (*((volatile unsigned int*) DC_PHY_LPDDR_MODE_reg)=data)
+#define get_DC_PHY_LPDDR_MODE_reg   (*((volatile unsigned int*) DC_PHY_LPDDR_MODE_reg))
+#define DC_PHY_LPDDR_MODE_inst_adr                                                   "0x00CC"
+#define DC_PHY_LPDDR_MODE_inst                                                       0x00CC
+#define DC_PHY_LPDDR_MODE_mode_reg_wdata_shift                                       (16)
+#define DC_PHY_LPDDR_MODE_mode_reg_wdata_mask                                        (0x00FF0000)
+#define DC_PHY_LPDDR_MODE_mode_reg_wdata(data)                                       (0x00FF0000&((data)<<16))
+#define DC_PHY_LPDDR_MODE_mode_reg_wdata_src(data)                                   ((0x00FF0000&(data))>>16)
+#define DC_PHY_LPDDR_MODE_get_mode_reg_wdata(data)                                   ((0x00FF0000&(data))>>16)
+#define DC_PHY_LPDDR_MODE_mode_reg_addr_shift                                        (8)
+#define DC_PHY_LPDDR_MODE_mode_reg_addr_mask                                         (0x0000FF00)
+#define DC_PHY_LPDDR_MODE_mode_reg_addr(data)                                        (0x0000FF00&((data)<<8))
+#define DC_PHY_LPDDR_MODE_mode_reg_addr_src(data)                                    ((0x0000FF00&(data))>>8)
+#define DC_PHY_LPDDR_MODE_get_mode_reg_addr(data)                                    ((0x0000FF00&(data))>>8)
+#define DC_PHY_LPDDR_MODE_lpddr_shift                                                (6)
+#define DC_PHY_LPDDR_MODE_lpddr_mask                                                 (0x00000040)
+#define DC_PHY_LPDDR_MODE_lpddr(data)                                                (0x00000040&((data)<<6))
+#define DC_PHY_LPDDR_MODE_lpddr_src(data)                                            ((0x00000040&(data))>>6)
+#define DC_PHY_LPDDR_MODE_get_lpddr(data)                                            ((0x00000040&(data))>>6)
+
+
+#define DC_PHY_ZQCMP                                                                 0x18008b34
+#define DC_PHY_ZQCMP_reg_addr                                                        "0xB8008B34"
+#define DC_PHY_ZQCMP_reg                                                             0xB8008B34
+#define set_DC_PHY_ZQCMP_reg(data)   (*((volatile unsigned int*) DC_PHY_ZQCMP_reg)=data)
+#define get_DC_PHY_ZQCMP_reg   (*((volatile unsigned int*) DC_PHY_ZQCMP_reg))
+#define DC_PHY_ZQCMP_inst_adr                                                        "0x00CD"
+#define DC_PHY_ZQCMP_inst                                                            0x00CD
+#define DC_PHY_ZQCMP_ref_update_dly_shift                                            (26)
+#define DC_PHY_ZQCMP_ref_update_dly_mask                                             (0xFC000000)
+#define DC_PHY_ZQCMP_ref_update_dly(data)                                            (0xFC000000&((data)<<26))
+#define DC_PHY_ZQCMP_ref_update_dly_src(data)                                        ((0xFC000000&(data))>>26)
+#define DC_PHY_ZQCMP_get_ref_update_dly(data)                                        ((0xFC000000&(data))>>26)
+#define DC_PHY_ZQCMP_zcomp_ctrl_shift                                                (0)
+#define DC_PHY_ZQCMP_zcomp_ctrl_mask                                                 (0x0000000F)
+#define DC_PHY_ZQCMP_zcomp_ctrl(data)                                                (0x0000000F&((data)<<0))
+#define DC_PHY_ZQCMP_zcomp_ctrl_src(data)                                            ((0x0000000F&(data))>>0)
+#define DC_PHY_ZQCMP_get_zcomp_ctrl(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define DC_PHY_RZCTRL_STATUS                                                         0x18008b38
+#define DC_PHY_RZCTRL_STATUS_reg_addr                                                "0xB8008B38"
+#define DC_PHY_RZCTRL_STATUS_reg                                                     0xB8008B38
+#define set_DC_PHY_RZCTRL_STATUS_reg(data)   (*((volatile unsigned int*) DC_PHY_RZCTRL_STATUS_reg)=data)
+#define get_DC_PHY_RZCTRL_STATUS_reg   (*((volatile unsigned int*) DC_PHY_RZCTRL_STATUS_reg))
+#define DC_PHY_RZCTRL_STATUS_inst_adr                                                "0x00CE"
+#define DC_PHY_RZCTRL_STATUS_inst                                                    0x00CE
+#define DC_PHY_RZCTRL_STATUS_zq_done_shift                                           (7)
+#define DC_PHY_RZCTRL_STATUS_zq_done_mask                                            (0x00000080)
+#define DC_PHY_RZCTRL_STATUS_zq_done(data)                                           (0x00000080&((data)<<7))
+#define DC_PHY_RZCTRL_STATUS_zq_done_src(data)                                       ((0x00000080&(data))>>7)
+#define DC_PHY_RZCTRL_STATUS_get_zq_done(data)                                       ((0x00000080&(data))>>7)
+#define DC_PHY_RZCTRL_STATUS_rzq_done_shift                                          (6)
+#define DC_PHY_RZCTRL_STATUS_rzq_done_mask                                           (0x00000040)
+#define DC_PHY_RZCTRL_STATUS_rzq_done(data)                                          (0x00000040&((data)<<6))
+#define DC_PHY_RZCTRL_STATUS_rzq_done_src(data)                                      ((0x00000040&(data))>>6)
+#define DC_PHY_RZCTRL_STATUS_get_rzq_done(data)                                      ((0x00000040&(data))>>6)
+#define DC_PHY_RZCTRL_STATUS_rzq_480code_shift                                       (1)
+#define DC_PHY_RZCTRL_STATUS_rzq_480code_mask                                        (0x0000003E)
+#define DC_PHY_RZCTRL_STATUS_rzq_480code(data)                                       (0x0000003E&((data)<<1))
+#define DC_PHY_RZCTRL_STATUS_rzq_480code_src(data)                                   ((0x0000003E&(data))>>1)
+#define DC_PHY_RZCTRL_STATUS_get_rzq_480code(data)                                   ((0x0000003E&(data))>>1)
+#define DC_PHY_RZCTRL_STATUS_rzq_cal_done_shift                                      (0)
+#define DC_PHY_RZCTRL_STATUS_rzq_cal_done_mask                                       (0x00000001)
+#define DC_PHY_RZCTRL_STATUS_rzq_cal_done(data)                                      (0x00000001&((data)<<0))
+#define DC_PHY_RZCTRL_STATUS_rzq_cal_done_src(data)                                  ((0x00000001&(data))>>0)
+#define DC_PHY_RZCTRL_STATUS_get_rzq_cal_done(data)                                  ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_PHY_BIST_RM                                                           0x18008be0
+#define DC_PHY_PHY_BIST_RM_reg_addr                                                  "0xB8008BE0"
+#define DC_PHY_PHY_BIST_RM_reg                                                       0xB8008BE0
+#define set_DC_PHY_PHY_BIST_RM_reg(data)   (*((volatile unsigned int*) DC_PHY_PHY_BIST_RM_reg)=data)
+#define get_DC_PHY_PHY_BIST_RM_reg   (*((volatile unsigned int*) DC_PHY_PHY_BIST_RM_reg))
+#define DC_PHY_PHY_BIST_RM_inst_adr                                                  "0x00F8"
+#define DC_PHY_PHY_BIST_RM_inst                                                      0x00F8
+#define DC_PHY_PHY_BIST_RM_bist_en_0_shift                                           (16)
+#define DC_PHY_PHY_BIST_RM_bist_en_0_mask                                            (0x00010000)
+#define DC_PHY_PHY_BIST_RM_bist_en_0(data)                                           (0x00010000&((data)<<16))
+#define DC_PHY_PHY_BIST_RM_bist_en_0_src(data)                                       ((0x00010000&(data))>>16)
+#define DC_PHY_PHY_BIST_RM_get_bist_en_0(data)                                       ((0x00010000&(data))>>16)
+#define DC_PHY_PHY_BIST_RM_drf_bist_en_0_shift                                       (15)
+#define DC_PHY_PHY_BIST_RM_drf_bist_en_0_mask                                        (0x00008000)
+#define DC_PHY_PHY_BIST_RM_drf_bist_en_0(data)                                       (0x00008000&((data)<<15))
+#define DC_PHY_PHY_BIST_RM_drf_bist_en_0_src(data)                                   ((0x00008000&(data))>>15)
+#define DC_PHY_PHY_BIST_RM_get_drf_bist_en_0(data)                                   ((0x00008000&(data))>>15)
+#define DC_PHY_PHY_BIST_RM_drf_test_resume_0_shift                                   (14)
+#define DC_PHY_PHY_BIST_RM_drf_test_resume_0_mask                                    (0x00004000)
+#define DC_PHY_PHY_BIST_RM_drf_test_resume_0(data)                                   (0x00004000&((data)<<14))
+#define DC_PHY_PHY_BIST_RM_drf_test_resume_0_src(data)                               ((0x00004000&(data))>>14)
+#define DC_PHY_PHY_BIST_RM_get_drf_test_resume_0(data)                               ((0x00004000&(data))>>14)
+#define DC_PHY_PHY_BIST_RM_RMEA_shift                                                (12)
+#define DC_PHY_PHY_BIST_RM_RMEA_mask                                                 (0x00001000)
+#define DC_PHY_PHY_BIST_RM_RMEA(data)                                                (0x00001000&((data)<<12))
+#define DC_PHY_PHY_BIST_RM_RMEA_src(data)                                            ((0x00001000&(data))>>12)
+#define DC_PHY_PHY_BIST_RM_get_RMEA(data)                                            ((0x00001000&(data))>>12)
+#define DC_PHY_PHY_BIST_RM_RMA_3_shift                                               (11)
+#define DC_PHY_PHY_BIST_RM_RMA_3_mask                                                (0x00000800)
+#define DC_PHY_PHY_BIST_RM_RMA_3(data)                                               (0x00000800&((data)<<11))
+#define DC_PHY_PHY_BIST_RM_RMA_3_src(data)                                           ((0x00000800&(data))>>11)
+#define DC_PHY_PHY_BIST_RM_get_RMA_3(data)                                           ((0x00000800&(data))>>11)
+#define DC_PHY_PHY_BIST_RM_RMA_2_shift                                               (10)
+#define DC_PHY_PHY_BIST_RM_RMA_2_mask                                                (0x00000400)
+#define DC_PHY_PHY_BIST_RM_RMA_2(data)                                               (0x00000400&((data)<<10))
+#define DC_PHY_PHY_BIST_RM_RMA_2_src(data)                                           ((0x00000400&(data))>>10)
+#define DC_PHY_PHY_BIST_RM_get_RMA_2(data)                                           ((0x00000400&(data))>>10)
+#define DC_PHY_PHY_BIST_RM_RMA_1_shift                                               (9)
+#define DC_PHY_PHY_BIST_RM_RMA_1_mask                                                (0x00000200)
+#define DC_PHY_PHY_BIST_RM_RMA_1(data)                                               (0x00000200&((data)<<9))
+#define DC_PHY_PHY_BIST_RM_RMA_1_src(data)                                           ((0x00000200&(data))>>9)
+#define DC_PHY_PHY_BIST_RM_get_RMA_1(data)                                           ((0x00000200&(data))>>9)
+#define DC_PHY_PHY_BIST_RM_RMA_0_shift                                               (8)
+#define DC_PHY_PHY_BIST_RM_RMA_0_mask                                                (0x00000100)
+#define DC_PHY_PHY_BIST_RM_RMA_0(data)                                               (0x00000100&((data)<<8))
+#define DC_PHY_PHY_BIST_RM_RMA_0_src(data)                                           ((0x00000100&(data))>>8)
+#define DC_PHY_PHY_BIST_RM_get_RMA_0(data)                                           ((0x00000100&(data))>>8)
+#define DC_PHY_PHY_BIST_RM_RMEB_shift                                                (4)
+#define DC_PHY_PHY_BIST_RM_RMEB_mask                                                 (0x00000010)
+#define DC_PHY_PHY_BIST_RM_RMEB(data)                                                (0x00000010&((data)<<4))
+#define DC_PHY_PHY_BIST_RM_RMEB_src(data)                                            ((0x00000010&(data))>>4)
+#define DC_PHY_PHY_BIST_RM_get_RMEB(data)                                            ((0x00000010&(data))>>4)
+#define DC_PHY_PHY_BIST_RM_RMB_3_shift                                               (3)
+#define DC_PHY_PHY_BIST_RM_RMB_3_mask                                                (0x00000008)
+#define DC_PHY_PHY_BIST_RM_RMB_3(data)                                               (0x00000008&((data)<<3))
+#define DC_PHY_PHY_BIST_RM_RMB_3_src(data)                                           ((0x00000008&(data))>>3)
+#define DC_PHY_PHY_BIST_RM_get_RMB_3(data)                                           ((0x00000008&(data))>>3)
+#define DC_PHY_PHY_BIST_RM_RMB_2_shift                                               (2)
+#define DC_PHY_PHY_BIST_RM_RMB_2_mask                                                (0x00000004)
+#define DC_PHY_PHY_BIST_RM_RMB_2(data)                                               (0x00000004&((data)<<2))
+#define DC_PHY_PHY_BIST_RM_RMB_2_src(data)                                           ((0x00000004&(data))>>2)
+#define DC_PHY_PHY_BIST_RM_get_RMB_2(data)                                           ((0x00000004&(data))>>2)
+#define DC_PHY_PHY_BIST_RM_RMB_1_shift                                               (1)
+#define DC_PHY_PHY_BIST_RM_RMB_1_mask                                                (0x00000002)
+#define DC_PHY_PHY_BIST_RM_RMB_1(data)                                               (0x00000002&((data)<<1))
+#define DC_PHY_PHY_BIST_RM_RMB_1_src(data)                                           ((0x00000002&(data))>>1)
+#define DC_PHY_PHY_BIST_RM_get_RMB_1(data)                                           ((0x00000002&(data))>>1)
+#define DC_PHY_PHY_BIST_RM_RMB_0_shift                                               (0)
+#define DC_PHY_PHY_BIST_RM_RMB_0_mask                                                (0x00000001)
+#define DC_PHY_PHY_BIST_RM_RMB_0(data)                                               (0x00000001&((data)<<0))
+#define DC_PHY_PHY_BIST_RM_RMB_0_src(data)                                           ((0x00000001&(data))>>0)
+#define DC_PHY_PHY_BIST_RM_get_RMB_0(data)                                           ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_PHY_BIST0_ST                                                          0x18008be4
+#define DC_PHY_PHY_BIST0_ST_reg_addr                                                 "0xB8008BE4"
+#define DC_PHY_PHY_BIST0_ST_reg                                                      0xB8008BE4
+#define set_DC_PHY_PHY_BIST0_ST_reg(data)   (*((volatile unsigned int*) DC_PHY_PHY_BIST0_ST_reg)=data)
+#define get_DC_PHY_PHY_BIST0_ST_reg   (*((volatile unsigned int*) DC_PHY_PHY_BIST0_ST_reg))
+#define DC_PHY_PHY_BIST0_ST_inst_adr                                                 "0x00F9"
+#define DC_PHY_PHY_BIST0_ST_inst                                                     0x00F9
+#define DC_PHY_PHY_BIST0_ST_mbist_st_shift                                           (2)
+#define DC_PHY_PHY_BIST0_ST_mbist_st_mask                                            (0x00000004)
+#define DC_PHY_PHY_BIST0_ST_mbist_st(data)                                           (0x00000004&((data)<<2))
+#define DC_PHY_PHY_BIST0_ST_mbist_st_src(data)                                       ((0x00000004&(data))>>2)
+#define DC_PHY_PHY_BIST0_ST_get_mbist_st(data)                                       ((0x00000004&(data))>>2)
+#define DC_PHY_PHY_BIST0_ST_bist_fail_shift                                          (1)
+#define DC_PHY_PHY_BIST0_ST_bist_fail_mask                                           (0x00000002)
+#define DC_PHY_PHY_BIST0_ST_bist_fail(data)                                          (0x00000002&((data)<<1))
+#define DC_PHY_PHY_BIST0_ST_bist_fail_src(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_PHY_BIST0_ST_get_bist_fail(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_PHY_BIST0_ST_bist_done_shift                                          (0)
+#define DC_PHY_PHY_BIST0_ST_bist_done_mask                                           (0x00000001)
+#define DC_PHY_PHY_BIST0_ST_bist_done(data)                                          (0x00000001&((data)<<0))
+#define DC_PHY_PHY_BIST0_ST_bist_done_src(data)                                      ((0x00000001&(data))>>0)
+#define DC_PHY_PHY_BIST0_ST_get_bist_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_PHY_DRF0_ST                                                           0x18008be8
+#define DC_PHY_PHY_DRF0_ST_reg_addr                                                  "0xB8008BE8"
+#define DC_PHY_PHY_DRF0_ST_reg                                                       0xB8008BE8
+#define set_DC_PHY_PHY_DRF0_ST_reg(data)   (*((volatile unsigned int*) DC_PHY_PHY_DRF0_ST_reg)=data)
+#define get_DC_PHY_PHY_DRF0_ST_reg   (*((volatile unsigned int*) DC_PHY_PHY_DRF0_ST_reg))
+#define DC_PHY_PHY_DRF0_ST_inst_adr                                                  "0x00FA"
+#define DC_PHY_PHY_DRF0_ST_inst                                                      0x00FA
+#define DC_PHY_PHY_DRF0_ST_drf_start_pause_shift                                     (16)
+#define DC_PHY_PHY_DRF0_ST_drf_start_pause_mask                                      (0x00010000)
+#define DC_PHY_PHY_DRF0_ST_drf_start_pause(data)                                     (0x00010000&((data)<<16))
+#define DC_PHY_PHY_DRF0_ST_drf_start_pause_src(data)                                 ((0x00010000&(data))>>16)
+#define DC_PHY_PHY_DRF0_ST_get_drf_start_pause(data)                                 ((0x00010000&(data))>>16)
+#define DC_PHY_PHY_DRF0_ST_drf_fail_shift                                            (1)
+#define DC_PHY_PHY_DRF0_ST_drf_fail_mask                                             (0x00000002)
+#define DC_PHY_PHY_DRF0_ST_drf_fail(data)                                            (0x00000002&((data)<<1))
+#define DC_PHY_PHY_DRF0_ST_drf_fail_src(data)                                        ((0x00000002&(data))>>1)
+#define DC_PHY_PHY_DRF0_ST_get_drf_fail(data)                                        ((0x00000002&(data))>>1)
+#define DC_PHY_PHY_DRF0_ST_drf_done_shift                                            (0)
+#define DC_PHY_PHY_DRF0_ST_drf_done_mask                                             (0x00000001)
+#define DC_PHY_PHY_DRF0_ST_drf_done(data)                                            (0x00000001&((data)<<0))
+#define DC_PHY_PHY_DRF0_ST_drf_done_src(data)                                        ((0x00000001&(data))>>0)
+#define DC_PHY_PHY_DRF0_ST_get_drf_done(data)                                        ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_PHY_BIST1_ST                                                          0x18008bec
+#define DC_PHY_PHY_BIST1_ST_reg_addr                                                 "0xB8008BEC"
+#define DC_PHY_PHY_BIST1_ST_reg                                                      0xB8008BEC
+#define set_DC_PHY_PHY_BIST1_ST_reg(data)   (*((volatile unsigned int*) DC_PHY_PHY_BIST1_ST_reg)=data)
+#define get_DC_PHY_PHY_BIST1_ST_reg   (*((volatile unsigned int*) DC_PHY_PHY_BIST1_ST_reg))
+#define DC_PHY_PHY_BIST1_ST_inst_adr                                                 "0x00FB"
+#define DC_PHY_PHY_BIST1_ST_inst                                                     0x00FB
+#define DC_PHY_PHY_BIST1_ST_mbist_st_shift                                           (2)
+#define DC_PHY_PHY_BIST1_ST_mbist_st_mask                                            (0x00000004)
+#define DC_PHY_PHY_BIST1_ST_mbist_st(data)                                           (0x00000004&((data)<<2))
+#define DC_PHY_PHY_BIST1_ST_mbist_st_src(data)                                       ((0x00000004&(data))>>2)
+#define DC_PHY_PHY_BIST1_ST_get_mbist_st(data)                                       ((0x00000004&(data))>>2)
+#define DC_PHY_PHY_BIST1_ST_bist_fail_shift                                          (1)
+#define DC_PHY_PHY_BIST1_ST_bist_fail_mask                                           (0x00000002)
+#define DC_PHY_PHY_BIST1_ST_bist_fail(data)                                          (0x00000002&((data)<<1))
+#define DC_PHY_PHY_BIST1_ST_bist_fail_src(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_PHY_BIST1_ST_get_bist_fail(data)                                      ((0x00000002&(data))>>1)
+#define DC_PHY_PHY_BIST1_ST_bist_done_shift                                          (0)
+#define DC_PHY_PHY_BIST1_ST_bist_done_mask                                           (0x00000001)
+#define DC_PHY_PHY_BIST1_ST_bist_done(data)                                          (0x00000001&((data)<<0))
+#define DC_PHY_PHY_BIST1_ST_bist_done_src(data)                                      ((0x00000001&(data))>>0)
+#define DC_PHY_PHY_BIST1_ST_get_bist_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_PHY_DRF1_ST                                                           0x18008bf0
+#define DC_PHY_PHY_DRF1_ST_reg_addr                                                  "0xB8008BF0"
+#define DC_PHY_PHY_DRF1_ST_reg                                                       0xB8008BF0
+#define set_DC_PHY_PHY_DRF1_ST_reg(data)   (*((volatile unsigned int*) DC_PHY_PHY_DRF1_ST_reg)=data)
+#define get_DC_PHY_PHY_DRF1_ST_reg   (*((volatile unsigned int*) DC_PHY_PHY_DRF1_ST_reg))
+#define DC_PHY_PHY_DRF1_ST_inst_adr                                                  "0x00FC"
+#define DC_PHY_PHY_DRF1_ST_inst                                                      0x00FC
+#define DC_PHY_PHY_DRF1_ST_drf_start_pause_shift                                     (16)
+#define DC_PHY_PHY_DRF1_ST_drf_start_pause_mask                                      (0x00010000)
+#define DC_PHY_PHY_DRF1_ST_drf_start_pause(data)                                     (0x00010000&((data)<<16))
+#define DC_PHY_PHY_DRF1_ST_drf_start_pause_src(data)                                 ((0x00010000&(data))>>16)
+#define DC_PHY_PHY_DRF1_ST_get_drf_start_pause(data)                                 ((0x00010000&(data))>>16)
+#define DC_PHY_PHY_DRF1_ST_drf_fail_shift                                            (1)
+#define DC_PHY_PHY_DRF1_ST_drf_fail_mask                                             (0x00000002)
+#define DC_PHY_PHY_DRF1_ST_drf_fail(data)                                            (0x00000002&((data)<<1))
+#define DC_PHY_PHY_DRF1_ST_drf_fail_src(data)                                        ((0x00000002&(data))>>1)
+#define DC_PHY_PHY_DRF1_ST_get_drf_fail(data)                                        ((0x00000002&(data))>>1)
+#define DC_PHY_PHY_DRF1_ST_drf_done_shift                                            (0)
+#define DC_PHY_PHY_DRF1_ST_drf_done_mask                                             (0x00000001)
+#define DC_PHY_PHY_DRF1_ST_drf_done(data)                                            (0x00000001&((data)<<0))
+#define DC_PHY_PHY_DRF1_ST_drf_done_src(data)                                        ((0x00000001&(data))>>0)
+#define DC_PHY_PHY_DRF1_ST_get_drf_done(data)                                        ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_WL_CTRL_0                                                             0x18008c00
+#define DC_PHY_WL_CTRL_0_reg_addr                                                    "0xB8008C00"
+#define DC_PHY_WL_CTRL_0_reg                                                         0xB8008C00
+#define set_DC_PHY_WL_CTRL_0_reg(data)   (*((volatile unsigned int*) DC_PHY_WL_CTRL_0_reg)=data)
+#define get_DC_PHY_WL_CTRL_0_reg   (*((volatile unsigned int*) DC_PHY_WL_CTRL_0_reg))
+#define DC_PHY_WL_CTRL_0_inst_adr                                                    "0x0000"
+#define DC_PHY_WL_CTRL_0_inst                                                        0x0000
+#define DC_PHY_WL_CTRL_0_wl_dqs3_oe_mux_sel_shift                                    (14)
+#define DC_PHY_WL_CTRL_0_wl_dqs3_oe_mux_sel_mask                                     (0x0000C000)
+#define DC_PHY_WL_CTRL_0_wl_dqs3_oe_mux_sel(data)                                    (0x0000C000&((data)<<14))
+#define DC_PHY_WL_CTRL_0_wl_dqs3_oe_mux_sel_src(data)                                ((0x0000C000&(data))>>14)
+#define DC_PHY_WL_CTRL_0_get_wl_dqs3_oe_mux_sel(data)                                ((0x0000C000&(data))>>14)
+#define DC_PHY_WL_CTRL_0_wl_dqs2_oe_mux_sel_shift                                    (12)
+#define DC_PHY_WL_CTRL_0_wl_dqs2_oe_mux_sel_mask                                     (0x00003000)
+#define DC_PHY_WL_CTRL_0_wl_dqs2_oe_mux_sel(data)                                    (0x00003000&((data)<<12))
+#define DC_PHY_WL_CTRL_0_wl_dqs2_oe_mux_sel_src(data)                                ((0x00003000&(data))>>12)
+#define DC_PHY_WL_CTRL_0_get_wl_dqs2_oe_mux_sel(data)                                ((0x00003000&(data))>>12)
+#define DC_PHY_WL_CTRL_0_wl_dqs1_oe_mux_sel_shift                                    (10)
+#define DC_PHY_WL_CTRL_0_wl_dqs1_oe_mux_sel_mask                                     (0x00000C00)
+#define DC_PHY_WL_CTRL_0_wl_dqs1_oe_mux_sel(data)                                    (0x00000C00&((data)<<10))
+#define DC_PHY_WL_CTRL_0_wl_dqs1_oe_mux_sel_src(data)                                ((0x00000C00&(data))>>10)
+#define DC_PHY_WL_CTRL_0_get_wl_dqs1_oe_mux_sel(data)                                ((0x00000C00&(data))>>10)
+#define DC_PHY_WL_CTRL_0_wl_dqs0_oe_mux_sel_shift                                    (8)
+#define DC_PHY_WL_CTRL_0_wl_dqs0_oe_mux_sel_mask                                     (0x00000300)
+#define DC_PHY_WL_CTRL_0_wl_dqs0_oe_mux_sel(data)                                    (0x00000300&((data)<<8))
+#define DC_PHY_WL_CTRL_0_wl_dqs0_oe_mux_sel_src(data)                                ((0x00000300&(data))>>8)
+#define DC_PHY_WL_CTRL_0_get_wl_dqs0_oe_mux_sel(data)                                ((0x00000300&(data))>>8)
+#define DC_PHY_WL_CTRL_0_wl_dqs3_mux_sel_shift                                       (6)
+#define DC_PHY_WL_CTRL_0_wl_dqs3_mux_sel_mask                                        (0x000000C0)
+#define DC_PHY_WL_CTRL_0_wl_dqs3_mux_sel(data)                                       (0x000000C0&((data)<<6))
+#define DC_PHY_WL_CTRL_0_wl_dqs3_mux_sel_src(data)                                   ((0x000000C0&(data))>>6)
+#define DC_PHY_WL_CTRL_0_get_wl_dqs3_mux_sel(data)                                   ((0x000000C0&(data))>>6)
+#define DC_PHY_WL_CTRL_0_wl_dqs2_mux_sel_shift                                       (4)
+#define DC_PHY_WL_CTRL_0_wl_dqs2_mux_sel_mask                                        (0x00000030)
+#define DC_PHY_WL_CTRL_0_wl_dqs2_mux_sel(data)                                       (0x00000030&((data)<<4))
+#define DC_PHY_WL_CTRL_0_wl_dqs2_mux_sel_src(data)                                   ((0x00000030&(data))>>4)
+#define DC_PHY_WL_CTRL_0_get_wl_dqs2_mux_sel(data)                                   ((0x00000030&(data))>>4)
+#define DC_PHY_WL_CTRL_0_wl_dqs1_mux_sel_shift                                       (2)
+#define DC_PHY_WL_CTRL_0_wl_dqs1_mux_sel_mask                                        (0x0000000C)
+#define DC_PHY_WL_CTRL_0_wl_dqs1_mux_sel(data)                                       (0x0000000C&((data)<<2))
+#define DC_PHY_WL_CTRL_0_wl_dqs1_mux_sel_src(data)                                   ((0x0000000C&(data))>>2)
+#define DC_PHY_WL_CTRL_0_get_wl_dqs1_mux_sel(data)                                   ((0x0000000C&(data))>>2)
+#define DC_PHY_WL_CTRL_0_wl_dqs0_mux_sel_shift                                       (0)
+#define DC_PHY_WL_CTRL_0_wl_dqs0_mux_sel_mask                                        (0x00000003)
+#define DC_PHY_WL_CTRL_0_wl_dqs0_mux_sel(data)                                       (0x00000003&((data)<<0))
+#define DC_PHY_WL_CTRL_0_wl_dqs0_mux_sel_src(data)                                   ((0x00000003&(data))>>0)
+#define DC_PHY_WL_CTRL_0_get_wl_dqs0_mux_sel(data)                                   ((0x00000003&(data))>>0)
+
+
+#define DC_PHY_WL_CTRL_1                                                             0x18008c04
+#define DC_PHY_WL_CTRL_1_reg_addr                                                    "0xB8008C04"
+#define DC_PHY_WL_CTRL_1_reg                                                         0xB8008C04
+#define set_DC_PHY_WL_CTRL_1_reg(data)   (*((volatile unsigned int*) DC_PHY_WL_CTRL_1_reg)=data)
+#define get_DC_PHY_WL_CTRL_1_reg   (*((volatile unsigned int*) DC_PHY_WL_CTRL_1_reg))
+#define DC_PHY_WL_CTRL_1_inst_adr                                                    "0x0001"
+#define DC_PHY_WL_CTRL_1_inst                                                        0x0001
+#define DC_PHY_WL_CTRL_1_wl_dq31to24_oe_mux_sel_shift                                (14)
+#define DC_PHY_WL_CTRL_1_wl_dq31to24_oe_mux_sel_mask                                 (0x0000C000)
+#define DC_PHY_WL_CTRL_1_wl_dq31to24_oe_mux_sel(data)                                (0x0000C000&((data)<<14))
+#define DC_PHY_WL_CTRL_1_wl_dq31to24_oe_mux_sel_src(data)                            ((0x0000C000&(data))>>14)
+#define DC_PHY_WL_CTRL_1_get_wl_dq31to24_oe_mux_sel(data)                            ((0x0000C000&(data))>>14)
+#define DC_PHY_WL_CTRL_1_wl_dq23to16_oe_mux_sel_shift                                (12)
+#define DC_PHY_WL_CTRL_1_wl_dq23to16_oe_mux_sel_mask                                 (0x00003000)
+#define DC_PHY_WL_CTRL_1_wl_dq23to16_oe_mux_sel(data)                                (0x00003000&((data)<<12))
+#define DC_PHY_WL_CTRL_1_wl_dq23to16_oe_mux_sel_src(data)                            ((0x00003000&(data))>>12)
+#define DC_PHY_WL_CTRL_1_get_wl_dq23to16_oe_mux_sel(data)                            ((0x00003000&(data))>>12)
+#define DC_PHY_WL_CTRL_1_wl_dq15to8_oe_mux_sel_shift                                 (10)
+#define DC_PHY_WL_CTRL_1_wl_dq15to8_oe_mux_sel_mask                                  (0x00000C00)
+#define DC_PHY_WL_CTRL_1_wl_dq15to8_oe_mux_sel(data)                                 (0x00000C00&((data)<<10))
+#define DC_PHY_WL_CTRL_1_wl_dq15to8_oe_mux_sel_src(data)                             ((0x00000C00&(data))>>10)
+#define DC_PHY_WL_CTRL_1_get_wl_dq15to8_oe_mux_sel(data)                             ((0x00000C00&(data))>>10)
+#define DC_PHY_WL_CTRL_1_wl_dq7to0_oe_mux_sel_shift                                  (8)
+#define DC_PHY_WL_CTRL_1_wl_dq7to0_oe_mux_sel_mask                                   (0x00000300)
+#define DC_PHY_WL_CTRL_1_wl_dq7to0_oe_mux_sel(data)                                  (0x00000300&((data)<<8))
+#define DC_PHY_WL_CTRL_1_wl_dq7to0_oe_mux_sel_src(data)                              ((0x00000300&(data))>>8)
+#define DC_PHY_WL_CTRL_1_get_wl_dq7to0_oe_mux_sel(data)                              ((0x00000300&(data))>>8)
+#define DC_PHY_WL_CTRL_1_wl_dq31to24_mux_sel_shift                                   (6)
+#define DC_PHY_WL_CTRL_1_wl_dq31to24_mux_sel_mask                                    (0x000000C0)
+#define DC_PHY_WL_CTRL_1_wl_dq31to24_mux_sel(data)                                   (0x000000C0&((data)<<6))
+#define DC_PHY_WL_CTRL_1_wl_dq31to24_mux_sel_src(data)                               ((0x000000C0&(data))>>6)
+#define DC_PHY_WL_CTRL_1_get_wl_dq31to24_mux_sel(data)                               ((0x000000C0&(data))>>6)
+#define DC_PHY_WL_CTRL_1_wl_dq23to16_mux_sel_shift                                   (4)
+#define DC_PHY_WL_CTRL_1_wl_dq23to16_mux_sel_mask                                    (0x00000030)
+#define DC_PHY_WL_CTRL_1_wl_dq23to16_mux_sel(data)                                   (0x00000030&((data)<<4))
+#define DC_PHY_WL_CTRL_1_wl_dq23to16_mux_sel_src(data)                               ((0x00000030&(data))>>4)
+#define DC_PHY_WL_CTRL_1_get_wl_dq23to16_mux_sel(data)                               ((0x00000030&(data))>>4)
+#define DC_PHY_WL_CTRL_1_wl_dq15to8_mux_sel_shift                                    (2)
+#define DC_PHY_WL_CTRL_1_wl_dq15to8_mux_sel_mask                                     (0x0000000C)
+#define DC_PHY_WL_CTRL_1_wl_dq15to8_mux_sel(data)                                    (0x0000000C&((data)<<2))
+#define DC_PHY_WL_CTRL_1_wl_dq15to8_mux_sel_src(data)                                ((0x0000000C&(data))>>2)
+#define DC_PHY_WL_CTRL_1_get_wl_dq15to8_mux_sel(data)                                ((0x0000000C&(data))>>2)
+#define DC_PHY_WL_CTRL_1_wl_dq7to0_mux_sel_shift                                     (0)
+#define DC_PHY_WL_CTRL_1_wl_dq7to0_mux_sel_mask                                      (0x00000003)
+#define DC_PHY_WL_CTRL_1_wl_dq7to0_mux_sel(data)                                     (0x00000003&((data)<<0))
+#define DC_PHY_WL_CTRL_1_wl_dq7to0_mux_sel_src(data)                                 ((0x00000003&(data))>>0)
+#define DC_PHY_WL_CTRL_1_get_wl_dq7to0_mux_sel(data)                                 ((0x00000003&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_0                                                            0x18008e00
+#define DC_PHY_FIFO_ARB_0_reg_addr                                                   "0xB8008E00"
+#define DC_PHY_FIFO_ARB_0_reg                                                        0xB8008E00
+#define set_DC_PHY_FIFO_ARB_0_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_0_reg)=data)
+#define get_DC_PHY_FIFO_ARB_0_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_0_reg))
+#define DC_PHY_FIFO_ARB_0_inst_adr                                                   "0x0080"
+#define DC_PHY_FIFO_ARB_0_inst                                                       0x0080
+#define DC_PHY_FIFO_ARB_0_fifo_arb_sel_shift                                         (24)
+#define DC_PHY_FIFO_ARB_0_fifo_arb_sel_mask                                          (0x01000000)
+#define DC_PHY_FIFO_ARB_0_fifo_arb_sel(data)                                         (0x01000000&((data)<<24))
+#define DC_PHY_FIFO_ARB_0_fifo_arb_sel_src(data)                                     ((0x01000000&(data))>>24)
+#define DC_PHY_FIFO_ARB_0_get_fifo_arb_sel(data)                                     ((0x01000000&(data))>>24)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_cnt_shift                                     (20)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_cnt_mask                                      (0x00700000)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_cnt(data)                                     (0x00700000&((data)<<20))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_cnt_src(data)                                 ((0x00700000&(data))>>20)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_fifo_cnt(data)                                 ((0x00700000&(data))>>20)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_rd_ptr_shift                                  (16)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_rd_ptr_mask                                   (0x00030000)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_rd_ptr(data)                                  (0x00030000&((data)<<16))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_rd_ptr_src(data)                              ((0x00030000&(data))>>16)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_fifo_rd_ptr(data)                              ((0x00030000&(data))>>16)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_wr_ptr_shift                                  (12)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_wr_ptr_mask                                   (0x00003000)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_wr_ptr(data)                                  (0x00003000&((data)<<12))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_wr_ptr_src(data)                              ((0x00003000&(data))>>12)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_fifo_wr_ptr(data)                              ((0x00003000&(data))>>12)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_overflow_shift                                (11)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_overflow_mask                                 (0x00000800)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_overflow(data)                                (0x00000800&((data)<<11))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_overflow_src(data)                            ((0x00000800&(data))>>11)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_fifo_overflow(data)                            ((0x00000800&(data))>>11)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_underflow_shift                               (10)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_underflow_mask                                (0x00000400)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_underflow(data)                               (0x00000400&((data)<<10))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_underflow_src(data)                           ((0x00000400&(data))>>10)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_fifo_underflow(data)                           ((0x00000400&(data))>>10)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_full_shift                                    (9)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_full_mask                                     (0x00000200)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_full(data)                                    (0x00000200&((data)<<9))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_full_src(data)                                ((0x00000200&(data))>>9)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_fifo_full(data)                                ((0x00000200&(data))>>9)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_empty_shift                                   (8)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_empty_mask                                    (0x00000100)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_empty(data)                                   (0x00000100&((data)<<8))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_empty_src(data)                               ((0x00000100&(data))>>8)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_fifo_empty(data)                               ((0x00000100&(data))>>8)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_thr_shift                                     (4)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_thr_mask                                      (0x000000F0)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_thr(data)                                     (0x000000F0&((data)<<4))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_thr_src(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_fifo_thr(data)                                 ((0x000000F0&(data))>>4)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_overflow_clr_shift                            (3)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_overflow_clr_mask                             (0x00000008)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_overflow_clr(data)                            (0x00000008&((data)<<3))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_overflow_clr_src(data)                        ((0x00000008&(data))>>3)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_fifo_overflow_clr(data)                        ((0x00000008&(data))>>3)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_underflow_clr_shift                           (2)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_underflow_clr_mask                            (0x00000004)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_underflow_clr(data)                           (0x00000004&((data)<<2))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_fifo_underflow_clr_src(data)                       ((0x00000004&(data))>>2)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_fifo_underflow_clr(data)                       ((0x00000004&(data))>>2)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_clk_gated_en_shift                                 (1)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_clk_gated_en_mask                                  (0x00000002)
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_clk_gated_en(data)                                 (0x00000002&((data)<<1))
+#define DC_PHY_FIFO_ARB_0_cmdq_ch_clk_gated_en_src(data)                             ((0x00000002&(data))>>1)
+#define DC_PHY_FIFO_ARB_0_get_cmdq_ch_clk_gated_en(data)                             ((0x00000002&(data))>>1)
+#define DC_PHY_FIFO_ARB_0_fifo_arb_dis_shift                                         (0)
+#define DC_PHY_FIFO_ARB_0_fifo_arb_dis_mask                                          (0x00000001)
+#define DC_PHY_FIFO_ARB_0_fifo_arb_dis(data)                                         (0x00000001&((data)<<0))
+#define DC_PHY_FIFO_ARB_0_fifo_arb_dis_src(data)                                     ((0x00000001&(data))>>0)
+#define DC_PHY_FIFO_ARB_0_get_fifo_arb_dis(data)                                     ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_1                                                            0x18008e04
+#define DC_PHY_FIFO_ARB_1_reg_addr                                                   "0xB8008E04"
+#define DC_PHY_FIFO_ARB_1_reg                                                        0xB8008E04
+#define set_DC_PHY_FIFO_ARB_1_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_1_reg)=data)
+#define get_DC_PHY_FIFO_ARB_1_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_1_reg))
+#define DC_PHY_FIFO_ARB_1_inst_adr                                                   "0x0081"
+#define DC_PHY_FIFO_ARB_1_inst                                                       0x0081
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst1_cmd_dis_shift                             (5)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst1_cmd_dis_mask                              (0x00000020)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst1_cmd_dis(data)                             (0x00000020&((data)<<5))
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst1_cmd_dis_src(data)                         ((0x00000020&(data))>>5)
+#define DC_PHY_FIFO_ARB_1_get_cmdq_ch_gnt_mst1_cmd_dis(data)                         ((0x00000020&(data))>>5)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst1_cti_dis_shift                             (4)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst1_cti_dis_mask                              (0x00000010)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst1_cti_dis(data)                             (0x00000010&((data)<<4))
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst1_cti_dis_src(data)                         ((0x00000010&(data))>>4)
+#define DC_PHY_FIFO_ARB_1_get_cmdq_ch_gnt_mst1_cti_dis(data)                         ((0x00000010&(data))>>4)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst0_cmd_dis_shift                             (1)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst0_cmd_dis_mask                              (0x00000002)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst0_cmd_dis(data)                             (0x00000002&((data)<<1))
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst0_cmd_dis_src(data)                         ((0x00000002&(data))>>1)
+#define DC_PHY_FIFO_ARB_1_get_cmdq_ch_gnt_mst0_cmd_dis(data)                         ((0x00000002&(data))>>1)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst0_cti_dis_shift                             (0)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst0_cti_dis_mask                              (0x00000001)
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst0_cti_dis(data)                             (0x00000001&((data)<<0))
+#define DC_PHY_FIFO_ARB_1_cmdq_ch_gnt_mst0_cti_dis_src(data)                         ((0x00000001&(data))>>0)
+#define DC_PHY_FIFO_ARB_1_get_cmdq_ch_gnt_mst0_cti_dis(data)                         ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_2                                                            0x18008e08
+#define DC_PHY_FIFO_ARB_2_reg_addr                                                   "0xB8008E08"
+#define DC_PHY_FIFO_ARB_2_reg                                                        0xB8008E08
+#define set_DC_PHY_FIFO_ARB_2_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_2_reg)=data)
+#define get_DC_PHY_FIFO_ARB_2_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_2_reg))
+#define DC_PHY_FIFO_ARB_2_inst_adr                                                   "0x0082"
+#define DC_PHY_FIFO_ARB_2_inst                                                       0x0082
+#define DC_PHY_FIFO_ARB_2_cmdq_ch_dbg_mod_shift                                      (0)
+#define DC_PHY_FIFO_ARB_2_cmdq_ch_dbg_mod_mask                                       (0x000000FF)
+#define DC_PHY_FIFO_ARB_2_cmdq_ch_dbg_mod(data)                                      (0x000000FF&((data)<<0))
+#define DC_PHY_FIFO_ARB_2_cmdq_ch_dbg_mod_src(data)                                  ((0x000000FF&(data))>>0)
+#define DC_PHY_FIFO_ARB_2_get_cmdq_ch_dbg_mod(data)                                  ((0x000000FF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_3                                                            0x18008e0c
+#define DC_PHY_FIFO_ARB_3_reg_addr                                                   "0xB8008E0C"
+#define DC_PHY_FIFO_ARB_3_reg                                                        0xB8008E0C
+#define set_DC_PHY_FIFO_ARB_3_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_3_reg)=data)
+#define get_DC_PHY_FIFO_ARB_3_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_3_reg))
+#define DC_PHY_FIFO_ARB_3_inst_adr                                                   "0x0083"
+#define DC_PHY_FIFO_ARB_3_inst                                                       0x0083
+#define DC_PHY_FIFO_ARB_3_cmdq_ch_dummy_0_shift                                      (0)
+#define DC_PHY_FIFO_ARB_3_cmdq_ch_dummy_0_mask                                       (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_3_cmdq_ch_dummy_0(data)                                      (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_3_cmdq_ch_dummy_0_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_3_get_cmdq_ch_dummy_0(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_4                                                            0x18008e10
+#define DC_PHY_FIFO_ARB_4_reg_addr                                                   "0xB8008E10"
+#define DC_PHY_FIFO_ARB_4_reg                                                        0xB8008E10
+#define set_DC_PHY_FIFO_ARB_4_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_4_reg)=data)
+#define get_DC_PHY_FIFO_ARB_4_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_4_reg))
+#define DC_PHY_FIFO_ARB_4_inst_adr                                                   "0x0084"
+#define DC_PHY_FIFO_ARB_4_inst                                                       0x0084
+#define DC_PHY_FIFO_ARB_4_cmdq_ch_gnt_st0_shift                                      (0)
+#define DC_PHY_FIFO_ARB_4_cmdq_ch_gnt_st0_mask                                       (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_4_cmdq_ch_gnt_st0(data)                                      (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_4_cmdq_ch_gnt_st0_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_4_get_cmdq_ch_gnt_st0(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_5                                                            0x18008e14
+#define DC_PHY_FIFO_ARB_5_reg_addr                                                   "0xB8008E14"
+#define DC_PHY_FIFO_ARB_5_reg                                                        0xB8008E14
+#define set_DC_PHY_FIFO_ARB_5_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_5_reg)=data)
+#define get_DC_PHY_FIFO_ARB_5_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_5_reg))
+#define DC_PHY_FIFO_ARB_5_inst_adr                                                   "0x0085"
+#define DC_PHY_FIFO_ARB_5_inst                                                       0x0085
+#define DC_PHY_FIFO_ARB_5_cmdq_ch_gnt_st1_shift                                      (0)
+#define DC_PHY_FIFO_ARB_5_cmdq_ch_gnt_st1_mask                                       (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_5_cmdq_ch_gnt_st1(data)                                      (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_5_cmdq_ch_gnt_st1_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_5_get_cmdq_ch_gnt_st1(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_6                                                            0x18008e18
+#define DC_PHY_FIFO_ARB_6_reg_addr                                                   "0xB8008E18"
+#define DC_PHY_FIFO_ARB_6_reg                                                        0xB8008E18
+#define set_DC_PHY_FIFO_ARB_6_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_6_reg)=data)
+#define get_DC_PHY_FIFO_ARB_6_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_6_reg))
+#define DC_PHY_FIFO_ARB_6_inst_adr                                                   "0x0086"
+#define DC_PHY_FIFO_ARB_6_inst                                                       0x0086
+#define DC_PHY_FIFO_ARB_6_cmdq_ch_gnt_st2_shift                                      (0)
+#define DC_PHY_FIFO_ARB_6_cmdq_ch_gnt_st2_mask                                       (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_6_cmdq_ch_gnt_st2(data)                                      (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_6_cmdq_ch_gnt_st2_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_6_get_cmdq_ch_gnt_st2(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_7                                                            0x18008e1c
+#define DC_PHY_FIFO_ARB_7_reg_addr                                                   "0xB8008E1C"
+#define DC_PHY_FIFO_ARB_7_reg                                                        0xB8008E1C
+#define set_DC_PHY_FIFO_ARB_7_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_7_reg)=data)
+#define get_DC_PHY_FIFO_ARB_7_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_7_reg))
+#define DC_PHY_FIFO_ARB_7_inst_adr                                                   "0x0087"
+#define DC_PHY_FIFO_ARB_7_inst                                                       0x0087
+#define DC_PHY_FIFO_ARB_7_cmdq_ch_gnt_st3_shift                                      (0)
+#define DC_PHY_FIFO_ARB_7_cmdq_ch_gnt_st3_mask                                       (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_7_cmdq_ch_gnt_st3(data)                                      (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_7_cmdq_ch_gnt_st3_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_7_get_cmdq_ch_gnt_st3(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_8                                                            0x18008e20
+#define DC_PHY_FIFO_ARB_8_reg_addr                                                   "0xB8008E20"
+#define DC_PHY_FIFO_ARB_8_reg                                                        0xB8008E20
+#define set_DC_PHY_FIFO_ARB_8_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_8_reg)=data)
+#define get_DC_PHY_FIFO_ARB_8_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_8_reg))
+#define DC_PHY_FIFO_ARB_8_inst_adr                                                   "0x0088"
+#define DC_PHY_FIFO_ARB_8_inst                                                       0x0088
+#define DC_PHY_FIFO_ARB_8_cmdq_ch_gnt_st4_shift                                      (0)
+#define DC_PHY_FIFO_ARB_8_cmdq_ch_gnt_st4_mask                                       (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_8_cmdq_ch_gnt_st4(data)                                      (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_8_cmdq_ch_gnt_st4_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_8_get_cmdq_ch_gnt_st4(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_9                                                            0x18008e24
+#define DC_PHY_FIFO_ARB_9_reg_addr                                                   "0xB8008E24"
+#define DC_PHY_FIFO_ARB_9_reg                                                        0xB8008E24
+#define set_DC_PHY_FIFO_ARB_9_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_9_reg)=data)
+#define get_DC_PHY_FIFO_ARB_9_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_9_reg))
+#define DC_PHY_FIFO_ARB_9_inst_adr                                                   "0x0089"
+#define DC_PHY_FIFO_ARB_9_inst                                                       0x0089
+#define DC_PHY_FIFO_ARB_9_cmdq_ch_gnt_st5_shift                                      (0)
+#define DC_PHY_FIFO_ARB_9_cmdq_ch_gnt_st5_mask                                       (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_9_cmdq_ch_gnt_st5(data)                                      (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_9_cmdq_ch_gnt_st5_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_9_get_cmdq_ch_gnt_st5(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_10                                                           0x18008e28
+#define DC_PHY_FIFO_ARB_10_reg_addr                                                  "0xB8008E28"
+#define DC_PHY_FIFO_ARB_10_reg                                                       0xB8008E28
+#define set_DC_PHY_FIFO_ARB_10_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_10_reg)=data)
+#define get_DC_PHY_FIFO_ARB_10_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_10_reg))
+#define DC_PHY_FIFO_ARB_10_inst_adr                                                  "0x008A"
+#define DC_PHY_FIFO_ARB_10_inst                                                      0x008A
+#define DC_PHY_FIFO_ARB_10_cmdq_ch_gnt_st6_shift                                     (0)
+#define DC_PHY_FIFO_ARB_10_cmdq_ch_gnt_st6_mask                                      (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_10_cmdq_ch_gnt_st6(data)                                     (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_10_cmdq_ch_gnt_st6_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_10_get_cmdq_ch_gnt_st6(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_11                                                           0x18008e2c
+#define DC_PHY_FIFO_ARB_11_reg_addr                                                  "0xB8008E2C"
+#define DC_PHY_FIFO_ARB_11_reg                                                       0xB8008E2C
+#define set_DC_PHY_FIFO_ARB_11_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_11_reg)=data)
+#define get_DC_PHY_FIFO_ARB_11_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_11_reg))
+#define DC_PHY_FIFO_ARB_11_inst_adr                                                  "0x008B"
+#define DC_PHY_FIFO_ARB_11_inst                                                      0x008B
+#define DC_PHY_FIFO_ARB_11_cmdq_ch_gnt_st7_shift                                     (0)
+#define DC_PHY_FIFO_ARB_11_cmdq_ch_gnt_st7_mask                                      (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_11_cmdq_ch_gnt_st7(data)                                     (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_11_cmdq_ch_gnt_st7_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_11_get_cmdq_ch_gnt_st7(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_12                                                           0x18008e30
+#define DC_PHY_FIFO_ARB_12_reg_addr                                                  "0xB8008E30"
+#define DC_PHY_FIFO_ARB_12_reg                                                       0xB8008E30
+#define set_DC_PHY_FIFO_ARB_12_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_12_reg)=data)
+#define get_DC_PHY_FIFO_ARB_12_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_12_reg))
+#define DC_PHY_FIFO_ARB_12_inst_adr                                                  "0x008C"
+#define DC_PHY_FIFO_ARB_12_inst                                                      0x008C
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_rd_ptr_shift                                   (24)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_rd_ptr_mask                                    (0x1F000000)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_rd_ptr(data)                                   (0x1F000000&((data)<<24))
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_rd_ptr_src(data)                               ((0x1F000000&(data))>>24)
+#define DC_PHY_FIFO_ARB_12_get_wq_ch_fifo_rd_ptr(data)                               ((0x1F000000&(data))>>24)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_wr_ptr_shift                                   (16)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_wr_ptr_mask                                    (0x001F0000)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_wr_ptr(data)                                   (0x001F0000&((data)<<16))
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_wr_ptr_src(data)                               ((0x001F0000&(data))>>16)
+#define DC_PHY_FIFO_ARB_12_get_wq_ch_fifo_wr_ptr(data)                               ((0x001F0000&(data))>>16)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_overflow_shift                                 (15)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_overflow_mask                                  (0x00008000)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_overflow(data)                                 (0x00008000&((data)<<15))
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_overflow_src(data)                             ((0x00008000&(data))>>15)
+#define DC_PHY_FIFO_ARB_12_get_wq_ch_fifo_overflow(data)                             ((0x00008000&(data))>>15)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_underflow_shift                                (14)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_underflow_mask                                 (0x00004000)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_underflow(data)                                (0x00004000&((data)<<14))
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_underflow_src(data)                            ((0x00004000&(data))>>14)
+#define DC_PHY_FIFO_ARB_12_get_wq_ch_fifo_underflow(data)                            ((0x00004000&(data))>>14)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_full_shift                                     (13)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_full_mask                                      (0x00002000)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_full(data)                                     (0x00002000&((data)<<13))
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_full_src(data)                                 ((0x00002000&(data))>>13)
+#define DC_PHY_FIFO_ARB_12_get_wq_ch_fifo_full(data)                                 ((0x00002000&(data))>>13)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_empty_shift                                    (12)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_empty_mask                                     (0x00001000)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_empty(data)                                    (0x00001000&((data)<<12))
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_empty_src(data)                                ((0x00001000&(data))>>12)
+#define DC_PHY_FIFO_ARB_12_get_wq_ch_fifo_empty(data)                                ((0x00001000&(data))>>12)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_thr_shift                                      (4)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_thr_mask                                       (0x000003F0)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_thr(data)                                      (0x000003F0&((data)<<4))
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_thr_src(data)                                  ((0x000003F0&(data))>>4)
+#define DC_PHY_FIFO_ARB_12_get_wq_ch_fifo_thr(data)                                  ((0x000003F0&(data))>>4)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_overflow_clr_shift                             (3)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_overflow_clr_mask                              (0x00000008)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_overflow_clr(data)                             (0x00000008&((data)<<3))
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_overflow_clr_src(data)                         ((0x00000008&(data))>>3)
+#define DC_PHY_FIFO_ARB_12_get_wq_ch_fifo_overflow_clr(data)                         ((0x00000008&(data))>>3)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_underflow_clr_shift                            (2)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_underflow_clr_mask                             (0x00000004)
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_underflow_clr(data)                            (0x00000004&((data)<<2))
+#define DC_PHY_FIFO_ARB_12_wq_ch_fifo_underflow_clr_src(data)                        ((0x00000004&(data))>>2)
+#define DC_PHY_FIFO_ARB_12_get_wq_ch_fifo_underflow_clr(data)                        ((0x00000004&(data))>>2)
+#define DC_PHY_FIFO_ARB_12_wq_ch_clk_gated_en_shift                                  (1)
+#define DC_PHY_FIFO_ARB_12_wq_ch_clk_gated_en_mask                                   (0x00000002)
+#define DC_PHY_FIFO_ARB_12_wq_ch_clk_gated_en(data)                                  (0x00000002&((data)<<1))
+#define DC_PHY_FIFO_ARB_12_wq_ch_clk_gated_en_src(data)                              ((0x00000002&(data))>>1)
+#define DC_PHY_FIFO_ARB_12_get_wq_ch_clk_gated_en(data)                              ((0x00000002&(data))>>1)
+
+
+#define DC_PHY_FIFO_ARB_13                                                           0x18008e34
+#define DC_PHY_FIFO_ARB_13_reg_addr                                                  "0xB8008E34"
+#define DC_PHY_FIFO_ARB_13_reg                                                       0xB8008E34
+#define set_DC_PHY_FIFO_ARB_13_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_13_reg)=data)
+#define get_DC_PHY_FIFO_ARB_13_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_13_reg))
+#define DC_PHY_FIFO_ARB_13_inst_adr                                                  "0x008D"
+#define DC_PHY_FIFO_ARB_13_inst                                                      0x008D
+#define DC_PHY_FIFO_ARB_13_wq_ch_dbg_mod_shift                                       (8)
+#define DC_PHY_FIFO_ARB_13_wq_ch_dbg_mod_mask                                        (0x0000FF00)
+#define DC_PHY_FIFO_ARB_13_wq_ch_dbg_mod(data)                                       (0x0000FF00&((data)<<8))
+#define DC_PHY_FIFO_ARB_13_wq_ch_dbg_mod_src(data)                                   ((0x0000FF00&(data))>>8)
+#define DC_PHY_FIFO_ARB_13_get_wq_ch_dbg_mod(data)                                   ((0x0000FF00&(data))>>8)
+#define DC_PHY_FIFO_ARB_13_wq_ch_fifo_cnt_shift                                      (0)
+#define DC_PHY_FIFO_ARB_13_wq_ch_fifo_cnt_mask                                       (0x0000003F)
+#define DC_PHY_FIFO_ARB_13_wq_ch_fifo_cnt(data)                                      (0x0000003F&((data)<<0))
+#define DC_PHY_FIFO_ARB_13_wq_ch_fifo_cnt_src(data)                                  ((0x0000003F&(data))>>0)
+#define DC_PHY_FIFO_ARB_13_get_wq_ch_fifo_cnt(data)                                  ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_14                                                           0x18008e38
+#define DC_PHY_FIFO_ARB_14_reg_addr                                                  "0xB8008E38"
+#define DC_PHY_FIFO_ARB_14_reg                                                       0xB8008E38
+#define set_DC_PHY_FIFO_ARB_14_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_14_reg)=data)
+#define get_DC_PHY_FIFO_ARB_14_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_14_reg))
+#define DC_PHY_FIFO_ARB_14_inst_adr                                                  "0x008E"
+#define DC_PHY_FIFO_ARB_14_inst                                                      0x008E
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_rd_ptr_shift                               (24)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_rd_ptr_mask                                (0x1F000000)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_rd_ptr(data)                               (0x1F000000&((data)<<24))
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_rd_ptr_src(data)                           ((0x1F000000&(data))>>24)
+#define DC_PHY_FIFO_ARB_14_get_wq_ch_fifo_par_rd_ptr(data)                           ((0x1F000000&(data))>>24)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_wr_ptr_shift                               (16)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_wr_ptr_mask                                (0x001F0000)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_wr_ptr(data)                               (0x001F0000&((data)<<16))
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_wr_ptr_src(data)                           ((0x001F0000&(data))>>16)
+#define DC_PHY_FIFO_ARB_14_get_wq_ch_fifo_par_wr_ptr(data)                           ((0x001F0000&(data))>>16)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_overflow_shift                             (15)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_overflow_mask                              (0x00008000)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_overflow(data)                             (0x00008000&((data)<<15))
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_overflow_src(data)                         ((0x00008000&(data))>>15)
+#define DC_PHY_FIFO_ARB_14_get_wq_ch_fifo_par_overflow(data)                         ((0x00008000&(data))>>15)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_underflow_shift                            (14)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_underflow_mask                             (0x00004000)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_underflow(data)                            (0x00004000&((data)<<14))
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_underflow_src(data)                        ((0x00004000&(data))>>14)
+#define DC_PHY_FIFO_ARB_14_get_wq_ch_fifo_par_underflow(data)                        ((0x00004000&(data))>>14)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_full_shift                                 (13)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_full_mask                                  (0x00002000)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_full(data)                                 (0x00002000&((data)<<13))
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_full_src(data)                             ((0x00002000&(data))>>13)
+#define DC_PHY_FIFO_ARB_14_get_wq_ch_fifo_par_full(data)                             ((0x00002000&(data))>>13)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_empty_shift                                (12)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_empty_mask                                 (0x00001000)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_empty(data)                                (0x00001000&((data)<<12))
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_empty_src(data)                            ((0x00001000&(data))>>12)
+#define DC_PHY_FIFO_ARB_14_get_wq_ch_fifo_par_empty(data)                            ((0x00001000&(data))>>12)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_thr_shift                                  (4)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_thr_mask                                   (0x000003F0)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_thr(data)                                  (0x000003F0&((data)<<4))
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_thr_src(data)                              ((0x000003F0&(data))>>4)
+#define DC_PHY_FIFO_ARB_14_get_wq_ch_fifo_par_thr(data)                              ((0x000003F0&(data))>>4)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_overflow_clr_shift                         (3)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_overflow_clr_mask                          (0x00000008)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_overflow_clr(data)                         (0x00000008&((data)<<3))
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_overflow_clr_src(data)                     ((0x00000008&(data))>>3)
+#define DC_PHY_FIFO_ARB_14_get_wq_ch_fifo_par_overflow_clr(data)                     ((0x00000008&(data))>>3)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_underflow_clr_shift                        (2)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_underflow_clr_mask                         (0x00000004)
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_underflow_clr(data)                        (0x00000004&((data)<<2))
+#define DC_PHY_FIFO_ARB_14_wq_ch_fifo_par_underflow_clr_src(data)                    ((0x00000004&(data))>>2)
+#define DC_PHY_FIFO_ARB_14_get_wq_ch_fifo_par_underflow_clr(data)                    ((0x00000004&(data))>>2)
+
+
+#define DC_PHY_FIFO_ARB_15                                                           0x18008e3c
+#define DC_PHY_FIFO_ARB_15_reg_addr                                                  "0xB8008E3C"
+#define DC_PHY_FIFO_ARB_15_reg                                                       0xB8008E3C
+#define set_DC_PHY_FIFO_ARB_15_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_15_reg)=data)
+#define get_DC_PHY_FIFO_ARB_15_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_15_reg))
+#define DC_PHY_FIFO_ARB_15_inst_adr                                                  "0x008F"
+#define DC_PHY_FIFO_ARB_15_inst                                                      0x008F
+#define DC_PHY_FIFO_ARB_15_wq_ch_fifo_par_cnt_shift                                  (0)
+#define DC_PHY_FIFO_ARB_15_wq_ch_fifo_par_cnt_mask                                   (0x0000003F)
+#define DC_PHY_FIFO_ARB_15_wq_ch_fifo_par_cnt(data)                                  (0x0000003F&((data)<<0))
+#define DC_PHY_FIFO_ARB_15_wq_ch_fifo_par_cnt_src(data)                              ((0x0000003F&(data))>>0)
+#define DC_PHY_FIFO_ARB_15_get_wq_ch_fifo_par_cnt(data)                              ((0x0000003F&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_16                                                           0x18008e40
+#define DC_PHY_FIFO_ARB_16_reg_addr                                                  "0xB8008E40"
+#define DC_PHY_FIFO_ARB_16_reg                                                       0xB8008E40
+#define set_DC_PHY_FIFO_ARB_16_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_16_reg)=data)
+#define get_DC_PHY_FIFO_ARB_16_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_16_reg))
+#define DC_PHY_FIFO_ARB_16_inst_adr                                                  "0x0090"
+#define DC_PHY_FIFO_ARB_16_inst                                                      0x0090
+#define DC_PHY_FIFO_ARB_16_wq_ch_dummy_0_shift                                       (0)
+#define DC_PHY_FIFO_ARB_16_wq_ch_dummy_0_mask                                        (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_16_wq_ch_dummy_0(data)                                       (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_16_wq_ch_dummy_0_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_16_get_wq_ch_dummy_0(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_17                                                           0x18008e44
+#define DC_PHY_FIFO_ARB_17_reg_addr                                                  "0xB8008E44"
+#define DC_PHY_FIFO_ARB_17_reg                                                       0xB8008E44
+#define set_DC_PHY_FIFO_ARB_17_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_17_reg)=data)
+#define get_DC_PHY_FIFO_ARB_17_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_17_reg))
+#define DC_PHY_FIFO_ARB_17_inst_adr                                                  "0x0091"
+#define DC_PHY_FIFO_ARB_17_inst                                                      0x0091
+#define DC_PHY_FIFO_ARB_17_wq_ch_st0_shift                                           (0)
+#define DC_PHY_FIFO_ARB_17_wq_ch_st0_mask                                            (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_17_wq_ch_st0(data)                                           (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_17_wq_ch_st0_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_17_get_wq_ch_st0(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_18                                                           0x18008e48
+#define DC_PHY_FIFO_ARB_18_reg_addr                                                  "0xB8008E48"
+#define DC_PHY_FIFO_ARB_18_reg                                                       0xB8008E48
+#define set_DC_PHY_FIFO_ARB_18_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_18_reg)=data)
+#define get_DC_PHY_FIFO_ARB_18_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_18_reg))
+#define DC_PHY_FIFO_ARB_18_inst_adr                                                  "0x0092"
+#define DC_PHY_FIFO_ARB_18_inst                                                      0x0092
+#define DC_PHY_FIFO_ARB_18_wq_ch_st1_shift                                           (0)
+#define DC_PHY_FIFO_ARB_18_wq_ch_st1_mask                                            (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_18_wq_ch_st1(data)                                           (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_18_wq_ch_st1_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_18_get_wq_ch_st1(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_19                                                           0x18008e4c
+#define DC_PHY_FIFO_ARB_19_reg_addr                                                  "0xB8008E4C"
+#define DC_PHY_FIFO_ARB_19_reg                                                       0xB8008E4C
+#define set_DC_PHY_FIFO_ARB_19_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_19_reg)=data)
+#define get_DC_PHY_FIFO_ARB_19_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_19_reg))
+#define DC_PHY_FIFO_ARB_19_inst_adr                                                  "0x0093"
+#define DC_PHY_FIFO_ARB_19_inst                                                      0x0093
+#define DC_PHY_FIFO_ARB_19_wq_ch_st2_shift                                           (0)
+#define DC_PHY_FIFO_ARB_19_wq_ch_st2_mask                                            (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_19_wq_ch_st2(data)                                           (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_19_wq_ch_st2_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_19_get_wq_ch_st2(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_20                                                           0x18008e50
+#define DC_PHY_FIFO_ARB_20_reg_addr                                                  "0xB8008E50"
+#define DC_PHY_FIFO_ARB_20_reg                                                       0xB8008E50
+#define set_DC_PHY_FIFO_ARB_20_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_20_reg)=data)
+#define get_DC_PHY_FIFO_ARB_20_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_20_reg))
+#define DC_PHY_FIFO_ARB_20_inst_adr                                                  "0x0094"
+#define DC_PHY_FIFO_ARB_20_inst                                                      0x0094
+#define DC_PHY_FIFO_ARB_20_wq_ch_st3_shift                                           (0)
+#define DC_PHY_FIFO_ARB_20_wq_ch_st3_mask                                            (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_20_wq_ch_st3(data)                                           (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_20_wq_ch_st3_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_20_get_wq_ch_st3(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_21                                                           0x18008e54
+#define DC_PHY_FIFO_ARB_21_reg_addr                                                  "0xB8008E54"
+#define DC_PHY_FIFO_ARB_21_reg                                                       0xB8008E54
+#define set_DC_PHY_FIFO_ARB_21_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_21_reg)=data)
+#define get_DC_PHY_FIFO_ARB_21_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_21_reg))
+#define DC_PHY_FIFO_ARB_21_inst_adr                                                  "0x0095"
+#define DC_PHY_FIFO_ARB_21_inst                                                      0x0095
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_rd_ptr_shift                                   (24)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_rd_ptr_mask                                    (0x0F000000)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_rd_ptr(data)                                   (0x0F000000&((data)<<24))
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_rd_ptr_src(data)                               ((0x0F000000&(data))>>24)
+#define DC_PHY_FIFO_ARB_21_get_rq_ch_fifo_rd_ptr(data)                               ((0x0F000000&(data))>>24)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_wr_ptr_shift                                   (16)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_wr_ptr_mask                                    (0x000F0000)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_wr_ptr(data)                                   (0x000F0000&((data)<<16))
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_wr_ptr_src(data)                               ((0x000F0000&(data))>>16)
+#define DC_PHY_FIFO_ARB_21_get_rq_ch_fifo_wr_ptr(data)                               ((0x000F0000&(data))>>16)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_overflow_shift                                 (15)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_overflow_mask                                  (0x00008000)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_overflow(data)                                 (0x00008000&((data)<<15))
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_overflow_src(data)                             ((0x00008000&(data))>>15)
+#define DC_PHY_FIFO_ARB_21_get_rq_ch_fifo_overflow(data)                             ((0x00008000&(data))>>15)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_underflow_shift                                (14)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_underflow_mask                                 (0x00004000)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_underflow(data)                                (0x00004000&((data)<<14))
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_underflow_src(data)                            ((0x00004000&(data))>>14)
+#define DC_PHY_FIFO_ARB_21_get_rq_ch_fifo_underflow(data)                            ((0x00004000&(data))>>14)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_full_shift                                     (13)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_full_mask                                      (0x00002000)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_full(data)                                     (0x00002000&((data)<<13))
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_full_src(data)                                 ((0x00002000&(data))>>13)
+#define DC_PHY_FIFO_ARB_21_get_rq_ch_fifo_full(data)                                 ((0x00002000&(data))>>13)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_empty_shift                                    (12)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_empty_mask                                     (0x00001000)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_empty(data)                                    (0x00001000&((data)<<12))
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_empty_src(data)                                ((0x00001000&(data))>>12)
+#define DC_PHY_FIFO_ARB_21_get_rq_ch_fifo_empty(data)                                ((0x00001000&(data))>>12)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_thr_shift                                      (4)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_thr_mask                                       (0x000001F0)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_thr(data)                                      (0x000001F0&((data)<<4))
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_thr_src(data)                                  ((0x000001F0&(data))>>4)
+#define DC_PHY_FIFO_ARB_21_get_rq_ch_fifo_thr(data)                                  ((0x000001F0&(data))>>4)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_overflow_clr_shift                             (3)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_overflow_clr_mask                              (0x00000008)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_overflow_clr(data)                             (0x00000008&((data)<<3))
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_overflow_clr_src(data)                         ((0x00000008&(data))>>3)
+#define DC_PHY_FIFO_ARB_21_get_rq_ch_fifo_overflow_clr(data)                         ((0x00000008&(data))>>3)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_underflow_clr_shift                            (2)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_underflow_clr_mask                             (0x00000004)
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_underflow_clr(data)                            (0x00000004&((data)<<2))
+#define DC_PHY_FIFO_ARB_21_rq_ch_fifo_underflow_clr_src(data)                        ((0x00000004&(data))>>2)
+#define DC_PHY_FIFO_ARB_21_get_rq_ch_fifo_underflow_clr(data)                        ((0x00000004&(data))>>2)
+#define DC_PHY_FIFO_ARB_21_rq_ch_clk_gated_en_shift                                  (1)
+#define DC_PHY_FIFO_ARB_21_rq_ch_clk_gated_en_mask                                   (0x00000002)
+#define DC_PHY_FIFO_ARB_21_rq_ch_clk_gated_en(data)                                  (0x00000002&((data)<<1))
+#define DC_PHY_FIFO_ARB_21_rq_ch_clk_gated_en_src(data)                              ((0x00000002&(data))>>1)
+#define DC_PHY_FIFO_ARB_21_get_rq_ch_clk_gated_en(data)                              ((0x00000002&(data))>>1)
+
+
+#define DC_PHY_FIFO_ARB_22                                                           0x18008e58
+#define DC_PHY_FIFO_ARB_22_reg_addr                                                  "0xB8008E58"
+#define DC_PHY_FIFO_ARB_22_reg                                                       0xB8008E58
+#define set_DC_PHY_FIFO_ARB_22_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_22_reg)=data)
+#define get_DC_PHY_FIFO_ARB_22_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_22_reg))
+#define DC_PHY_FIFO_ARB_22_inst_adr                                                  "0x0096"
+#define DC_PHY_FIFO_ARB_22_inst                                                      0x0096
+#define DC_PHY_FIFO_ARB_22_rq_ch_fifo_cnt_shift                                      (0)
+#define DC_PHY_FIFO_ARB_22_rq_ch_fifo_cnt_mask                                       (0x0000001F)
+#define DC_PHY_FIFO_ARB_22_rq_ch_fifo_cnt(data)                                      (0x0000001F&((data)<<0))
+#define DC_PHY_FIFO_ARB_22_rq_ch_fifo_cnt_src(data)                                  ((0x0000001F&(data))>>0)
+#define DC_PHY_FIFO_ARB_22_get_rq_ch_fifo_cnt(data)                                  ((0x0000001F&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_23                                                           0x18008e5c
+#define DC_PHY_FIFO_ARB_23_reg_addr                                                  "0xB8008E5C"
+#define DC_PHY_FIFO_ARB_23_reg                                                       0xB8008E5C
+#define set_DC_PHY_FIFO_ARB_23_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_23_reg)=data)
+#define get_DC_PHY_FIFO_ARB_23_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_23_reg))
+#define DC_PHY_FIFO_ARB_23_inst_adr                                                  "0x0097"
+#define DC_PHY_FIFO_ARB_23_inst                                                      0x0097
+#define DC_PHY_FIFO_ARB_23_wcol_adr_q_thr_shift                                      (8)
+#define DC_PHY_FIFO_ARB_23_wcol_adr_q_thr_mask                                       (0x00001F00)
+#define DC_PHY_FIFO_ARB_23_wcol_adr_q_thr(data)                                      (0x00001F00&((data)<<8))
+#define DC_PHY_FIFO_ARB_23_wcol_adr_q_thr_src(data)                                  ((0x00001F00&(data))>>8)
+#define DC_PHY_FIFO_ARB_23_get_wcol_adr_q_thr(data)                                  ((0x00001F00&(data))>>8)
+#define DC_PHY_FIFO_ARB_23_rq_ch_dbg_mod_shift                                       (0)
+#define DC_PHY_FIFO_ARB_23_rq_ch_dbg_mod_mask                                        (0x000000FF)
+#define DC_PHY_FIFO_ARB_23_rq_ch_dbg_mod(data)                                       (0x000000FF&((data)<<0))
+#define DC_PHY_FIFO_ARB_23_rq_ch_dbg_mod_src(data)                                   ((0x000000FF&(data))>>0)
+#define DC_PHY_FIFO_ARB_23_get_rq_ch_dbg_mod(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_24                                                           0x18008e60
+#define DC_PHY_FIFO_ARB_24_reg_addr                                                  "0xB8008E60"
+#define DC_PHY_FIFO_ARB_24_reg                                                       0xB8008E60
+#define set_DC_PHY_FIFO_ARB_24_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_24_reg)=data)
+#define get_DC_PHY_FIFO_ARB_24_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_24_reg))
+#define DC_PHY_FIFO_ARB_24_inst_adr                                                  "0x0098"
+#define DC_PHY_FIFO_ARB_24_inst                                                      0x0098
+#define DC_PHY_FIFO_ARB_24_rq_ch_dummy_0_shift                                       (0)
+#define DC_PHY_FIFO_ARB_24_rq_ch_dummy_0_mask                                        (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_24_rq_ch_dummy_0(data)                                       (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_24_rq_ch_dummy_0_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_24_get_rq_ch_dummy_0(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_25                                                           0x18008e64
+#define DC_PHY_FIFO_ARB_25_reg_addr                                                  "0xB8008E64"
+#define DC_PHY_FIFO_ARB_25_reg                                                       0xB8008E64
+#define set_DC_PHY_FIFO_ARB_25_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_25_reg)=data)
+#define get_DC_PHY_FIFO_ARB_25_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_25_reg))
+#define DC_PHY_FIFO_ARB_25_inst_adr                                                  "0x0099"
+#define DC_PHY_FIFO_ARB_25_inst                                                      0x0099
+#define DC_PHY_FIFO_ARB_25_rq_ch_st0_shift                                           (0)
+#define DC_PHY_FIFO_ARB_25_rq_ch_st0_mask                                            (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_25_rq_ch_st0(data)                                           (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_25_rq_ch_st0_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_25_get_rq_ch_st0(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_26                                                           0x18008e68
+#define DC_PHY_FIFO_ARB_26_reg_addr                                                  "0xB8008E68"
+#define DC_PHY_FIFO_ARB_26_reg                                                       0xB8008E68
+#define set_DC_PHY_FIFO_ARB_26_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_26_reg)=data)
+#define get_DC_PHY_FIFO_ARB_26_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_26_reg))
+#define DC_PHY_FIFO_ARB_26_inst_adr                                                  "0x009A"
+#define DC_PHY_FIFO_ARB_26_inst                                                      0x009A
+#define DC_PHY_FIFO_ARB_26_rq_ch_st1_shift                                           (0)
+#define DC_PHY_FIFO_ARB_26_rq_ch_st1_mask                                            (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_26_rq_ch_st1(data)                                           (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_26_rq_ch_st1_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_26_get_rq_ch_st1(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_27                                                           0x18008e6c
+#define DC_PHY_FIFO_ARB_27_reg_addr                                                  "0xB8008E6C"
+#define DC_PHY_FIFO_ARB_27_reg                                                       0xB8008E6C
+#define set_DC_PHY_FIFO_ARB_27_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_27_reg)=data)
+#define get_DC_PHY_FIFO_ARB_27_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_27_reg))
+#define DC_PHY_FIFO_ARB_27_inst_adr                                                  "0x009B"
+#define DC_PHY_FIFO_ARB_27_inst                                                      0x009B
+#define DC_PHY_FIFO_ARB_27_rq_ch_st2_shift                                           (0)
+#define DC_PHY_FIFO_ARB_27_rq_ch_st2_mask                                            (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_27_rq_ch_st2(data)                                           (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_27_rq_ch_st2_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_27_get_rq_ch_st2(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_FIFO_ARB_28                                                           0x18008e70
+#define DC_PHY_FIFO_ARB_28_reg_addr                                                  "0xB8008E70"
+#define DC_PHY_FIFO_ARB_28_reg                                                       0xB8008E70
+#define set_DC_PHY_FIFO_ARB_28_reg(data)   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_28_reg)=data)
+#define get_DC_PHY_FIFO_ARB_28_reg   (*((volatile unsigned int*) DC_PHY_FIFO_ARB_28_reg))
+#define DC_PHY_FIFO_ARB_28_inst_adr                                                  "0x009C"
+#define DC_PHY_FIFO_ARB_28_inst                                                      0x009C
+#define DC_PHY_FIFO_ARB_28_rq_ch_st3_shift                                           (0)
+#define DC_PHY_FIFO_ARB_28_rq_ch_st3_mask                                            (0xFFFFFFFF)
+#define DC_PHY_FIFO_ARB_28_rq_ch_st3(data)                                           (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_FIFO_ARB_28_rq_ch_st3_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_FIFO_ARB_28_get_rq_ch_st3(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DUMMY_0                                                               0x18008ee0
+#define DC_PHY_DUMMY_0_reg_addr                                                      "0xB8008EE0"
+#define DC_PHY_DUMMY_0_reg                                                           0xB8008EE0
+#define set_DC_PHY_DUMMY_0_reg(data)   (*((volatile unsigned int*) DC_PHY_DUMMY_0_reg)=data)
+#define get_DC_PHY_DUMMY_0_reg   (*((volatile unsigned int*) DC_PHY_DUMMY_0_reg))
+#define DC_PHY_DUMMY_0_inst_adr                                                      "0x00B8"
+#define DC_PHY_DUMMY_0_inst                                                          0x00B8
+#define DC_PHY_DUMMY_0_dummy_0_shift                                                 (0)
+#define DC_PHY_DUMMY_0_dummy_0_mask                                                  (0xFFFFFFFF)
+#define DC_PHY_DUMMY_0_dummy_0(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DUMMY_0_dummy_0_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DUMMY_0_get_dummy_0(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DUMMY_1                                                               0x18008ee4
+#define DC_PHY_DUMMY_1_reg_addr                                                      "0xB8008EE4"
+#define DC_PHY_DUMMY_1_reg                                                           0xB8008EE4
+#define set_DC_PHY_DUMMY_1_reg(data)   (*((volatile unsigned int*) DC_PHY_DUMMY_1_reg)=data)
+#define get_DC_PHY_DUMMY_1_reg   (*((volatile unsigned int*) DC_PHY_DUMMY_1_reg))
+#define DC_PHY_DUMMY_1_inst_adr                                                      "0x00B9"
+#define DC_PHY_DUMMY_1_inst                                                          0x00B9
+#define DC_PHY_DUMMY_1_dummy_1_shift                                                 (0)
+#define DC_PHY_DUMMY_1_dummy_1_mask                                                  (0xFFFFFFFF)
+#define DC_PHY_DUMMY_1_dummy_1(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DUMMY_1_dummy_1_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DUMMY_1_get_dummy_1(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DUMMY_2                                                               0x18008ee8
+#define DC_PHY_DUMMY_2_reg_addr                                                      "0xB8008EE8"
+#define DC_PHY_DUMMY_2_reg                                                           0xB8008EE8
+#define set_DC_PHY_DUMMY_2_reg(data)   (*((volatile unsigned int*) DC_PHY_DUMMY_2_reg)=data)
+#define get_DC_PHY_DUMMY_2_reg   (*((volatile unsigned int*) DC_PHY_DUMMY_2_reg))
+#define DC_PHY_DUMMY_2_inst_adr                                                      "0x00BA"
+#define DC_PHY_DUMMY_2_inst                                                          0x00BA
+#define DC_PHY_DUMMY_2_dummy_2_shift                                                 (0)
+#define DC_PHY_DUMMY_2_dummy_2_mask                                                  (0xFFFFFFFF)
+#define DC_PHY_DUMMY_2_dummy_2(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DUMMY_2_dummy_2_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DUMMY_2_get_dummy_2(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DUMMY_3                                                               0x18008eec
+#define DC_PHY_DUMMY_3_reg_addr                                                      "0xB8008EEC"
+#define DC_PHY_DUMMY_3_reg                                                           0xB8008EEC
+#define set_DC_PHY_DUMMY_3_reg(data)   (*((volatile unsigned int*) DC_PHY_DUMMY_3_reg)=data)
+#define get_DC_PHY_DUMMY_3_reg   (*((volatile unsigned int*) DC_PHY_DUMMY_3_reg))
+#define DC_PHY_DUMMY_3_inst_adr                                                      "0x00BB"
+#define DC_PHY_DUMMY_3_inst                                                          0x00BB
+#define DC_PHY_DUMMY_3_dummy_3_shift                                                 (0)
+#define DC_PHY_DUMMY_3_dummy_3_mask                                                  (0xFFFFFFFF)
+#define DC_PHY_DUMMY_3_dummy_3(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DUMMY_3_dummy_3_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DUMMY_3_get_dummy_3(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DUMMY_4                                                               0x18008ef0
+#define DC_PHY_DUMMY_4_reg_addr                                                      "0xB8008EF0"
+#define DC_PHY_DUMMY_4_reg                                                           0xB8008EF0
+#define set_DC_PHY_DUMMY_4_reg(data)   (*((volatile unsigned int*) DC_PHY_DUMMY_4_reg)=data)
+#define get_DC_PHY_DUMMY_4_reg   (*((volatile unsigned int*) DC_PHY_DUMMY_4_reg))
+#define DC_PHY_DUMMY_4_inst_adr                                                      "0x00BC"
+#define DC_PHY_DUMMY_4_inst                                                          0x00BC
+#define DC_PHY_DUMMY_4_dummy_4_shift                                                 (0)
+#define DC_PHY_DUMMY_4_dummy_4_mask                                                  (0xFFFFFFFF)
+#define DC_PHY_DUMMY_4_dummy_4(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DUMMY_4_dummy_4_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DUMMY_4_get_dummy_4(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DUMMY_5                                                               0x18008ef4
+#define DC_PHY_DUMMY_5_reg_addr                                                      "0xB8008EF4"
+#define DC_PHY_DUMMY_5_reg                                                           0xB8008EF4
+#define set_DC_PHY_DUMMY_5_reg(data)   (*((volatile unsigned int*) DC_PHY_DUMMY_5_reg)=data)
+#define get_DC_PHY_DUMMY_5_reg   (*((volatile unsigned int*) DC_PHY_DUMMY_5_reg))
+#define DC_PHY_DUMMY_5_inst_adr                                                      "0x00BD"
+#define DC_PHY_DUMMY_5_inst                                                          0x00BD
+#define DC_PHY_DUMMY_5_dummy_5_shift                                                 (0)
+#define DC_PHY_DUMMY_5_dummy_5_mask                                                  (0xFFFFFFFF)
+#define DC_PHY_DUMMY_5_dummy_5(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DUMMY_5_dummy_5_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DUMMY_5_get_dummy_5(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DUMMY_6                                                               0x18008ef8
+#define DC_PHY_DUMMY_6_reg_addr                                                      "0xB8008EF8"
+#define DC_PHY_DUMMY_6_reg                                                           0xB8008EF8
+#define set_DC_PHY_DUMMY_6_reg(data)   (*((volatile unsigned int*) DC_PHY_DUMMY_6_reg)=data)
+#define get_DC_PHY_DUMMY_6_reg   (*((volatile unsigned int*) DC_PHY_DUMMY_6_reg))
+#define DC_PHY_DUMMY_6_inst_adr                                                      "0x00BE"
+#define DC_PHY_DUMMY_6_inst                                                          0x00BE
+#define DC_PHY_DUMMY_6_dummy_6_shift                                                 (0)
+#define DC_PHY_DUMMY_6_dummy_6_mask                                                  (0xFFFFFFFF)
+#define DC_PHY_DUMMY_6_dummy_6(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DUMMY_6_dummy_6_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DUMMY_6_get_dummy_6(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DUMMY_7                                                               0x18008efc
+#define DC_PHY_DUMMY_7_reg_addr                                                      "0xB8008EFC"
+#define DC_PHY_DUMMY_7_reg                                                           0xB8008EFC
+#define set_DC_PHY_DUMMY_7_reg(data)   (*((volatile unsigned int*) DC_PHY_DUMMY_7_reg)=data)
+#define get_DC_PHY_DUMMY_7_reg   (*((volatile unsigned int*) DC_PHY_DUMMY_7_reg))
+#define DC_PHY_DUMMY_7_inst_adr                                                      "0x00BF"
+#define DC_PHY_DUMMY_7_inst                                                          0x00BF
+#define DC_PHY_DUMMY_7_dummy_7_shift                                                 (0)
+#define DC_PHY_DUMMY_7_dummy_7_mask                                                  (0xFFFFFFFF)
+#define DC_PHY_DUMMY_7_dummy_7(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_DUMMY_7_dummy_7_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_DUMMY_7_get_dummy_7(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_SC_CTRL                                                               0x18008f60
+#define DC_PHY_SC_CTRL_reg_addr                                                      "0xB8008F60"
+#define DC_PHY_SC_CTRL_reg                                                           0xB8008F60
+#define set_DC_PHY_SC_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_SC_CTRL_reg)=data)
+#define get_DC_PHY_SC_CTRL_reg   (*((volatile unsigned int*) DC_PHY_SC_CTRL_reg))
+#define DC_PHY_SC_CTRL_inst_adr                                                      "0x00D8"
+#define DC_PHY_SC_CTRL_inst                                                          0x00D8
+#define DC_PHY_SC_CTRL_sc_en_shift                                                   (0)
+#define DC_PHY_SC_CTRL_sc_en_mask                                                    (0x00000001)
+#define DC_PHY_SC_CTRL_sc_en(data)                                                   (0x00000001&((data)<<0))
+#define DC_PHY_SC_CTRL_sc_en_src(data)                                               ((0x00000001&(data))>>0)
+#define DC_PHY_SC_CTRL_get_sc_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_SC_KEY01                                                              0x18008f64
+#define DC_PHY_SC_KEY01_reg_addr                                                     "0xB8008F64"
+#define DC_PHY_SC_KEY01_reg                                                          0xB8008F64
+#define set_DC_PHY_SC_KEY01_reg(data)   (*((volatile unsigned int*) DC_PHY_SC_KEY01_reg)=data)
+#define get_DC_PHY_SC_KEY01_reg   (*((volatile unsigned int*) DC_PHY_SC_KEY01_reg))
+#define DC_PHY_SC_KEY01_inst_adr                                                     "0x00D9"
+#define DC_PHY_SC_KEY01_inst                                                         0x00D9
+#define DC_PHY_SC_KEY01_sc_key_1_shift                                               (16)
+#define DC_PHY_SC_KEY01_sc_key_1_mask                                                (0xFFFF0000)
+#define DC_PHY_SC_KEY01_sc_key_1(data)                                               (0xFFFF0000&((data)<<16))
+#define DC_PHY_SC_KEY01_sc_key_1_src(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEY01_get_sc_key_1(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEY01_sc_key_0_shift                                               (0)
+#define DC_PHY_SC_KEY01_sc_key_0_mask                                                (0x0000FFFF)
+#define DC_PHY_SC_KEY01_sc_key_0(data)                                               (0x0000FFFF&((data)<<0))
+#define DC_PHY_SC_KEY01_sc_key_0_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define DC_PHY_SC_KEY01_get_sc_key_0(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_SC_KEY23                                                              0x18008f68
+#define DC_PHY_SC_KEY23_reg_addr                                                     "0xB8008F68"
+#define DC_PHY_SC_KEY23_reg                                                          0xB8008F68
+#define set_DC_PHY_SC_KEY23_reg(data)   (*((volatile unsigned int*) DC_PHY_SC_KEY23_reg)=data)
+#define get_DC_PHY_SC_KEY23_reg   (*((volatile unsigned int*) DC_PHY_SC_KEY23_reg))
+#define DC_PHY_SC_KEY23_inst_adr                                                     "0x00DA"
+#define DC_PHY_SC_KEY23_inst                                                         0x00DA
+#define DC_PHY_SC_KEY23_sc_key_3_shift                                               (16)
+#define DC_PHY_SC_KEY23_sc_key_3_mask                                                (0xFFFF0000)
+#define DC_PHY_SC_KEY23_sc_key_3(data)                                               (0xFFFF0000&((data)<<16))
+#define DC_PHY_SC_KEY23_sc_key_3_src(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEY23_get_sc_key_3(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEY23_sc_key_2_shift                                               (0)
+#define DC_PHY_SC_KEY23_sc_key_2_mask                                                (0x0000FFFF)
+#define DC_PHY_SC_KEY23_sc_key_2(data)                                               (0x0000FFFF&((data)<<0))
+#define DC_PHY_SC_KEY23_sc_key_2_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define DC_PHY_SC_KEY23_get_sc_key_2(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_SC_KEY45                                                              0x18008f6c
+#define DC_PHY_SC_KEY45_reg_addr                                                     "0xB8008F6C"
+#define DC_PHY_SC_KEY45_reg                                                          0xB8008F6C
+#define set_DC_PHY_SC_KEY45_reg(data)   (*((volatile unsigned int*) DC_PHY_SC_KEY45_reg)=data)
+#define get_DC_PHY_SC_KEY45_reg   (*((volatile unsigned int*) DC_PHY_SC_KEY45_reg))
+#define DC_PHY_SC_KEY45_inst_adr                                                     "0x00DB"
+#define DC_PHY_SC_KEY45_inst                                                         0x00DB
+#define DC_PHY_SC_KEY45_sc_key_5_shift                                               (16)
+#define DC_PHY_SC_KEY45_sc_key_5_mask                                                (0xFFFF0000)
+#define DC_PHY_SC_KEY45_sc_key_5(data)                                               (0xFFFF0000&((data)<<16))
+#define DC_PHY_SC_KEY45_sc_key_5_src(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEY45_get_sc_key_5(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEY45_sc_key_4_shift                                               (0)
+#define DC_PHY_SC_KEY45_sc_key_4_mask                                                (0x0000FFFF)
+#define DC_PHY_SC_KEY45_sc_key_4(data)                                               (0x0000FFFF&((data)<<0))
+#define DC_PHY_SC_KEY45_sc_key_4_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define DC_PHY_SC_KEY45_get_sc_key_4(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_SC_KEY67                                                              0x18008f70
+#define DC_PHY_SC_KEY67_reg_addr                                                     "0xB8008F70"
+#define DC_PHY_SC_KEY67_reg                                                          0xB8008F70
+#define set_DC_PHY_SC_KEY67_reg(data)   (*((volatile unsigned int*) DC_PHY_SC_KEY67_reg)=data)
+#define get_DC_PHY_SC_KEY67_reg   (*((volatile unsigned int*) DC_PHY_SC_KEY67_reg))
+#define DC_PHY_SC_KEY67_inst_adr                                                     "0x00DC"
+#define DC_PHY_SC_KEY67_inst                                                         0x00DC
+#define DC_PHY_SC_KEY67_sc_key_7_shift                                               (16)
+#define DC_PHY_SC_KEY67_sc_key_7_mask                                                (0xFFFF0000)
+#define DC_PHY_SC_KEY67_sc_key_7(data)                                               (0xFFFF0000&((data)<<16))
+#define DC_PHY_SC_KEY67_sc_key_7_src(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEY67_get_sc_key_7(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEY67_sc_key_6_shift                                               (0)
+#define DC_PHY_SC_KEY67_sc_key_6_mask                                                (0x0000FFFF)
+#define DC_PHY_SC_KEY67_sc_key_6(data)                                               (0x0000FFFF&((data)<<0))
+#define DC_PHY_SC_KEY67_sc_key_6_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define DC_PHY_SC_KEY67_get_sc_key_6(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_SC_KEY89                                                              0x18008f74
+#define DC_PHY_SC_KEY89_reg_addr                                                     "0xB8008F74"
+#define DC_PHY_SC_KEY89_reg                                                          0xB8008F74
+#define set_DC_PHY_SC_KEY89_reg(data)   (*((volatile unsigned int*) DC_PHY_SC_KEY89_reg)=data)
+#define get_DC_PHY_SC_KEY89_reg   (*((volatile unsigned int*) DC_PHY_SC_KEY89_reg))
+#define DC_PHY_SC_KEY89_inst_adr                                                     "0x00DD"
+#define DC_PHY_SC_KEY89_inst                                                         0x00DD
+#define DC_PHY_SC_KEY89_sc_key_9_shift                                               (16)
+#define DC_PHY_SC_KEY89_sc_key_9_mask                                                (0xFFFF0000)
+#define DC_PHY_SC_KEY89_sc_key_9(data)                                               (0xFFFF0000&((data)<<16))
+#define DC_PHY_SC_KEY89_sc_key_9_src(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEY89_get_sc_key_9(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEY89_sc_key_8_shift                                               (0)
+#define DC_PHY_SC_KEY89_sc_key_8_mask                                                (0x0000FFFF)
+#define DC_PHY_SC_KEY89_sc_key_8(data)                                               (0x0000FFFF&((data)<<0))
+#define DC_PHY_SC_KEY89_sc_key_8_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define DC_PHY_SC_KEY89_get_sc_key_8(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_SC_KEYAB                                                              0x18008f78
+#define DC_PHY_SC_KEYAB_reg_addr                                                     "0xB8008F78"
+#define DC_PHY_SC_KEYAB_reg                                                          0xB8008F78
+#define set_DC_PHY_SC_KEYAB_reg(data)   (*((volatile unsigned int*) DC_PHY_SC_KEYAB_reg)=data)
+#define get_DC_PHY_SC_KEYAB_reg   (*((volatile unsigned int*) DC_PHY_SC_KEYAB_reg))
+#define DC_PHY_SC_KEYAB_inst_adr                                                     "0x00DE"
+#define DC_PHY_SC_KEYAB_inst                                                         0x00DE
+#define DC_PHY_SC_KEYAB_sc_key_b_shift                                               (16)
+#define DC_PHY_SC_KEYAB_sc_key_b_mask                                                (0xFFFF0000)
+#define DC_PHY_SC_KEYAB_sc_key_b(data)                                               (0xFFFF0000&((data)<<16))
+#define DC_PHY_SC_KEYAB_sc_key_b_src(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEYAB_get_sc_key_b(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEYAB_sc_key_a_shift                                               (0)
+#define DC_PHY_SC_KEYAB_sc_key_a_mask                                                (0x0000FFFF)
+#define DC_PHY_SC_KEYAB_sc_key_a(data)                                               (0x0000FFFF&((data)<<0))
+#define DC_PHY_SC_KEYAB_sc_key_a_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define DC_PHY_SC_KEYAB_get_sc_key_a(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_SC_KEYCD                                                              0x18008f7c
+#define DC_PHY_SC_KEYCD_reg_addr                                                     "0xB8008F7C"
+#define DC_PHY_SC_KEYCD_reg                                                          0xB8008F7C
+#define set_DC_PHY_SC_KEYCD_reg(data)   (*((volatile unsigned int*) DC_PHY_SC_KEYCD_reg)=data)
+#define get_DC_PHY_SC_KEYCD_reg   (*((volatile unsigned int*) DC_PHY_SC_KEYCD_reg))
+#define DC_PHY_SC_KEYCD_inst_adr                                                     "0x00DF"
+#define DC_PHY_SC_KEYCD_inst                                                         0x00DF
+#define DC_PHY_SC_KEYCD_sc_key_d_shift                                               (16)
+#define DC_PHY_SC_KEYCD_sc_key_d_mask                                                (0xFFFF0000)
+#define DC_PHY_SC_KEYCD_sc_key_d(data)                                               (0xFFFF0000&((data)<<16))
+#define DC_PHY_SC_KEYCD_sc_key_d_src(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEYCD_get_sc_key_d(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEYCD_sc_key_c_shift                                               (0)
+#define DC_PHY_SC_KEYCD_sc_key_c_mask                                                (0x0000FFFF)
+#define DC_PHY_SC_KEYCD_sc_key_c(data)                                               (0x0000FFFF&((data)<<0))
+#define DC_PHY_SC_KEYCD_sc_key_c_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define DC_PHY_SC_KEYCD_get_sc_key_c(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_SC_KEYEF                                                              0x18008f80
+#define DC_PHY_SC_KEYEF_reg_addr                                                     "0xB8008F80"
+#define DC_PHY_SC_KEYEF_reg                                                          0xB8008F80
+#define set_DC_PHY_SC_KEYEF_reg(data)   (*((volatile unsigned int*) DC_PHY_SC_KEYEF_reg)=data)
+#define get_DC_PHY_SC_KEYEF_reg   (*((volatile unsigned int*) DC_PHY_SC_KEYEF_reg))
+#define DC_PHY_SC_KEYEF_inst_adr                                                     "0x00E0"
+#define DC_PHY_SC_KEYEF_inst                                                         0x00E0
+#define DC_PHY_SC_KEYEF_sc_key_f_shift                                               (16)
+#define DC_PHY_SC_KEYEF_sc_key_f_mask                                                (0xFFFF0000)
+#define DC_PHY_SC_KEYEF_sc_key_f(data)                                               (0xFFFF0000&((data)<<16))
+#define DC_PHY_SC_KEYEF_sc_key_f_src(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEYEF_get_sc_key_f(data)                                           ((0xFFFF0000&(data))>>16)
+#define DC_PHY_SC_KEYEF_sc_key_e_shift                                               (0)
+#define DC_PHY_SC_KEYEF_sc_key_e_mask                                                (0x0000FFFF)
+#define DC_PHY_SC_KEYEF_sc_key_e(data)                                               (0x0000FFFF&((data)<<0))
+#define DC_PHY_SC_KEYEF_sc_key_e_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define DC_PHY_SC_KEYEF_get_sc_key_e(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_CMD_DLY_1T                                                            0x18008f00
+#define DC_PHY_CMD_DLY_1T_reg_addr                                                   "0xB8008F00"
+#define DC_PHY_CMD_DLY_1T_reg                                                        0xB8008F00
+#define set_DC_PHY_CMD_DLY_1T_reg(data)   (*((volatile unsigned int*) DC_PHY_CMD_DLY_1T_reg)=data)
+#define get_DC_PHY_CMD_DLY_1T_reg   (*((volatile unsigned int*) DC_PHY_CMD_DLY_1T_reg))
+#define DC_PHY_CMD_DLY_1T_inst_adr                                                   "0x00C0"
+#define DC_PHY_CMD_DLY_1T_inst                                                       0x00C0
+#define DC_PHY_CMD_DLY_1T_issue_cmd_dly_1T_shift                                     (0)
+#define DC_PHY_CMD_DLY_1T_issue_cmd_dly_1T_mask                                      (0x00000001)
+#define DC_PHY_CMD_DLY_1T_issue_cmd_dly_1T(data)                                     (0x00000001&((data)<<0))
+#define DC_PHY_CMD_DLY_1T_issue_cmd_dly_1T_src(data)                                 ((0x00000001&(data))>>0)
+#define DC_PHY_CMD_DLY_1T_get_issue_cmd_dly_1T(data)                                 ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_EXP_LANE_CTRL                                                         0x18008f04
+#define DC_PHY_EXP_LANE_CTRL_reg_addr                                                "0xB8008F04"
+#define DC_PHY_EXP_LANE_CTRL_reg                                                     0xB8008F04
+#define set_DC_PHY_EXP_LANE_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_EXP_LANE_CTRL_reg)=data)
+#define get_DC_PHY_EXP_LANE_CTRL_reg   (*((volatile unsigned int*) DC_PHY_EXP_LANE_CTRL_reg))
+#define DC_PHY_EXP_LANE_CTRL_inst_adr                                                "0x00C1"
+#define DC_PHY_EXP_LANE_CTRL_inst                                                    0x00C1
+#define DC_PHY_EXP_LANE_CTRL_write_merge_en_shift                                    (1)
+#define DC_PHY_EXP_LANE_CTRL_write_merge_en_mask                                     (0x00000002)
+#define DC_PHY_EXP_LANE_CTRL_write_merge_en(data)                                    (0x00000002&((data)<<1))
+#define DC_PHY_EXP_LANE_CTRL_write_merge_en_src(data)                                ((0x00000002&(data))>>1)
+#define DC_PHY_EXP_LANE_CTRL_get_write_merge_en(data)                                ((0x00000002&(data))>>1)
+#define DC_PHY_EXP_LANE_CTRL_read_bypass_en_shift                                    (0)
+#define DC_PHY_EXP_LANE_CTRL_read_bypass_en_mask                                     (0x00000001)
+#define DC_PHY_EXP_LANE_CTRL_read_bypass_en(data)                                    (0x00000001&((data)<<0))
+#define DC_PHY_EXP_LANE_CTRL_read_bypass_en_src(data)                                ((0x00000001&(data))>>0)
+#define DC_PHY_EXP_LANE_CTRL_get_read_bypass_en(data)                                ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_CMD_DLYN_0                                                            0x18008F08
+#define DC_PHY_CMD_DLYN_0_reg_addr                                                   "0xB8008F08"
+#define DC_PHY_CMD_DLYN_0_reg                                                        0xB8008F08
+#define set_DC_PHY_CMD_DLYN_0_reg(data)   (*((volatile unsigned int*) DC_PHY_CMD_DLYN_0_reg)=data)
+#define get_DC_PHY_CMD_DLYN_0_reg   (*((volatile unsigned int*) DC_PHY_CMD_DLYN_0_reg))
+#define DC_PHY_CMD_DLYN_0_inst_adr                                                   "0x00C2"
+#define DC_PHY_CMD_DLYN_0_inst                                                       0x00C2
+#define DC_PHY_CMD_DLYN_0_bank2_dlyn_shift                                           (24)
+#define DC_PHY_CMD_DLYN_0_bank2_dlyn_mask                                            (0x07000000)
+#define DC_PHY_CMD_DLYN_0_bank2_dlyn(data)                                           (0x07000000&((data)<<24))
+#define DC_PHY_CMD_DLYN_0_bank2_dlyn_src(data)                                       ((0x07000000&(data))>>24)
+#define DC_PHY_CMD_DLYN_0_get_bank2_dlyn(data)                                       ((0x07000000&(data))>>24)
+#define DC_PHY_CMD_DLYN_0_bank1_dlyn_shift                                           (21)
+#define DC_PHY_CMD_DLYN_0_bank1_dlyn_mask                                            (0x00E00000)
+#define DC_PHY_CMD_DLYN_0_bank1_dlyn(data)                                           (0x00E00000&((data)<<21))
+#define DC_PHY_CMD_DLYN_0_bank1_dlyn_src(data)                                       ((0x00E00000&(data))>>21)
+#define DC_PHY_CMD_DLYN_0_get_bank1_dlyn(data)                                       ((0x00E00000&(data))>>21)
+#define DC_PHY_CMD_DLYN_0_bank0_dlyn_shift                                           (18)
+#define DC_PHY_CMD_DLYN_0_bank0_dlyn_mask                                            (0x001C0000)
+#define DC_PHY_CMD_DLYN_0_bank0_dlyn(data)                                           (0x001C0000&((data)<<18))
+#define DC_PHY_CMD_DLYN_0_bank0_dlyn_src(data)                                       ((0x001C0000&(data))>>18)
+#define DC_PHY_CMD_DLYN_0_get_bank0_dlyn(data)                                       ((0x001C0000&(data))>>18)
+#define DC_PHY_CMD_DLYN_0_odt_dlyn_shift                                             (15)
+#define DC_PHY_CMD_DLYN_0_odt_dlyn_mask                                              (0x00038000)
+#define DC_PHY_CMD_DLYN_0_odt_dlyn(data)                                             (0x00038000&((data)<<15))
+#define DC_PHY_CMD_DLYN_0_odt_dlyn_src(data)                                         ((0x00038000&(data))>>15)
+#define DC_PHY_CMD_DLYN_0_get_odt_dlyn(data)                                         ((0x00038000&(data))>>15)
+#define DC_PHY_CMD_DLYN_0_cke_dlyn_shift                                             (12)
+#define DC_PHY_CMD_DLYN_0_cke_dlyn_mask                                              (0x00007000)
+#define DC_PHY_CMD_DLYN_0_cke_dlyn(data)                                             (0x00007000&((data)<<12))
+#define DC_PHY_CMD_DLYN_0_cke_dlyn_src(data)                                         ((0x00007000&(data))>>12)
+#define DC_PHY_CMD_DLYN_0_get_cke_dlyn(data)                                         ((0x00007000&(data))>>12)
+#define DC_PHY_CMD_DLYN_0_we_n_dlyn_shift                                            (9)
+#define DC_PHY_CMD_DLYN_0_we_n_dlyn_mask                                             (0x00000E00)
+#define DC_PHY_CMD_DLYN_0_we_n_dlyn(data)                                            (0x00000E00&((data)<<9))
+#define DC_PHY_CMD_DLYN_0_we_n_dlyn_src(data)                                        ((0x00000E00&(data))>>9)
+#define DC_PHY_CMD_DLYN_0_get_we_n_dlyn(data)                                        ((0x00000E00&(data))>>9)
+#define DC_PHY_CMD_DLYN_0_cas_n_dlyn_shift                                           (6)
+#define DC_PHY_CMD_DLYN_0_cas_n_dlyn_mask                                            (0x000001C0)
+#define DC_PHY_CMD_DLYN_0_cas_n_dlyn(data)                                           (0x000001C0&((data)<<6))
+#define DC_PHY_CMD_DLYN_0_cas_n_dlyn_src(data)                                       ((0x000001C0&(data))>>6)
+#define DC_PHY_CMD_DLYN_0_get_cas_n_dlyn(data)                                       ((0x000001C0&(data))>>6)
+#define DC_PHY_CMD_DLYN_0_ras_n_dlyn_shift                                           (3)
+#define DC_PHY_CMD_DLYN_0_ras_n_dlyn_mask                                            (0x00000038)
+#define DC_PHY_CMD_DLYN_0_ras_n_dlyn(data)                                           (0x00000038&((data)<<3))
+#define DC_PHY_CMD_DLYN_0_ras_n_dlyn_src(data)                                       ((0x00000038&(data))>>3)
+#define DC_PHY_CMD_DLYN_0_get_ras_n_dlyn(data)                                       ((0x00000038&(data))>>3)
+#define DC_PHY_CMD_DLYN_0_cs_n_dlyn_shift                                            (0)
+#define DC_PHY_CMD_DLYN_0_cs_n_dlyn_mask                                             (0x00000007)
+#define DC_PHY_CMD_DLYN_0_cs_n_dlyn(data)                                            (0x00000007&((data)<<0))
+#define DC_PHY_CMD_DLYN_0_cs_n_dlyn_src(data)                                        ((0x00000007&(data))>>0)
+#define DC_PHY_CMD_DLYN_0_get_cs_n_dlyn(data)                                        ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_ADR_DLYN_0                                                            0x18008F10
+#define DC_PHY_ADR_DLYN_0_reg_addr                                                   "0xB8008F10"
+#define DC_PHY_ADR_DLYN_0_reg                                                        0xB8008F10
+#define set_DC_PHY_ADR_DLYN_0_reg(data)   (*((volatile unsigned int*) DC_PHY_ADR_DLYN_0_reg)=data)
+#define get_DC_PHY_ADR_DLYN_0_reg   (*((volatile unsigned int*) DC_PHY_ADR_DLYN_0_reg))
+#define DC_PHY_ADR_DLYN_0_inst_adr                                                   "0x00C4"
+#define DC_PHY_ADR_DLYN_0_inst                                                       0x00C4
+#define DC_PHY_ADR_DLYN_0_adr09_dlyn_shift                                           (27)
+#define DC_PHY_ADR_DLYN_0_adr09_dlyn_mask                                            (0x38000000)
+#define DC_PHY_ADR_DLYN_0_adr09_dlyn(data)                                           (0x38000000&((data)<<27))
+#define DC_PHY_ADR_DLYN_0_adr09_dlyn_src(data)                                       ((0x38000000&(data))>>27)
+#define DC_PHY_ADR_DLYN_0_get_adr09_dlyn(data)                                       ((0x38000000&(data))>>27)
+#define DC_PHY_ADR_DLYN_0_adr08_dlyn_shift                                           (24)
+#define DC_PHY_ADR_DLYN_0_adr08_dlyn_mask                                            (0x07000000)
+#define DC_PHY_ADR_DLYN_0_adr08_dlyn(data)                                           (0x07000000&((data)<<24))
+#define DC_PHY_ADR_DLYN_0_adr08_dlyn_src(data)                                       ((0x07000000&(data))>>24)
+#define DC_PHY_ADR_DLYN_0_get_adr08_dlyn(data)                                       ((0x07000000&(data))>>24)
+#define DC_PHY_ADR_DLYN_0_adr07_dlyn_shift                                           (21)
+#define DC_PHY_ADR_DLYN_0_adr07_dlyn_mask                                            (0x00E00000)
+#define DC_PHY_ADR_DLYN_0_adr07_dlyn(data)                                           (0x00E00000&((data)<<21))
+#define DC_PHY_ADR_DLYN_0_adr07_dlyn_src(data)                                       ((0x00E00000&(data))>>21)
+#define DC_PHY_ADR_DLYN_0_get_adr07_dlyn(data)                                       ((0x00E00000&(data))>>21)
+#define DC_PHY_ADR_DLYN_0_adr06_dlyn_shift                                           (18)
+#define DC_PHY_ADR_DLYN_0_adr06_dlyn_mask                                            (0x001C0000)
+#define DC_PHY_ADR_DLYN_0_adr06_dlyn(data)                                           (0x001C0000&((data)<<18))
+#define DC_PHY_ADR_DLYN_0_adr06_dlyn_src(data)                                       ((0x001C0000&(data))>>18)
+#define DC_PHY_ADR_DLYN_0_get_adr06_dlyn(data)                                       ((0x001C0000&(data))>>18)
+#define DC_PHY_ADR_DLYN_0_adr05_dlyn_shift                                           (15)
+#define DC_PHY_ADR_DLYN_0_adr05_dlyn_mask                                            (0x00038000)
+#define DC_PHY_ADR_DLYN_0_adr05_dlyn(data)                                           (0x00038000&((data)<<15))
+#define DC_PHY_ADR_DLYN_0_adr05_dlyn_src(data)                                       ((0x00038000&(data))>>15)
+#define DC_PHY_ADR_DLYN_0_get_adr05_dlyn(data)                                       ((0x00038000&(data))>>15)
+#define DC_PHY_ADR_DLYN_0_adr04_dlyn_shift                                           (12)
+#define DC_PHY_ADR_DLYN_0_adr04_dlyn_mask                                            (0x00007000)
+#define DC_PHY_ADR_DLYN_0_adr04_dlyn(data)                                           (0x00007000&((data)<<12))
+#define DC_PHY_ADR_DLYN_0_adr04_dlyn_src(data)                                       ((0x00007000&(data))>>12)
+#define DC_PHY_ADR_DLYN_0_get_adr04_dlyn(data)                                       ((0x00007000&(data))>>12)
+#define DC_PHY_ADR_DLYN_0_adr03_dlyn_shift                                           (9)
+#define DC_PHY_ADR_DLYN_0_adr03_dlyn_mask                                            (0x00000E00)
+#define DC_PHY_ADR_DLYN_0_adr03_dlyn(data)                                           (0x00000E00&((data)<<9))
+#define DC_PHY_ADR_DLYN_0_adr03_dlyn_src(data)                                       ((0x00000E00&(data))>>9)
+#define DC_PHY_ADR_DLYN_0_get_adr03_dlyn(data)                                       ((0x00000E00&(data))>>9)
+#define DC_PHY_ADR_DLYN_0_adr02_dlyn_shift                                           (6)
+#define DC_PHY_ADR_DLYN_0_adr02_dlyn_mask                                            (0x000001C0)
+#define DC_PHY_ADR_DLYN_0_adr02_dlyn(data)                                           (0x000001C0&((data)<<6))
+#define DC_PHY_ADR_DLYN_0_adr02_dlyn_src(data)                                       ((0x000001C0&(data))>>6)
+#define DC_PHY_ADR_DLYN_0_get_adr02_dlyn(data)                                       ((0x000001C0&(data))>>6)
+#define DC_PHY_ADR_DLYN_0_adr01_dlyn_shift                                           (3)
+#define DC_PHY_ADR_DLYN_0_adr01_dlyn_mask                                            (0x00000038)
+#define DC_PHY_ADR_DLYN_0_adr01_dlyn(data)                                           (0x00000038&((data)<<3))
+#define DC_PHY_ADR_DLYN_0_adr01_dlyn_src(data)                                       ((0x00000038&(data))>>3)
+#define DC_PHY_ADR_DLYN_0_get_adr01_dlyn(data)                                       ((0x00000038&(data))>>3)
+#define DC_PHY_ADR_DLYN_0_adr00_dlyn_shift                                           (0)
+#define DC_PHY_ADR_DLYN_0_adr00_dlyn_mask                                            (0x00000007)
+#define DC_PHY_ADR_DLYN_0_adr00_dlyn(data)                                           (0x00000007&((data)<<0))
+#define DC_PHY_ADR_DLYN_0_adr00_dlyn_src(data)                                       ((0x00000007&(data))>>0)
+#define DC_PHY_ADR_DLYN_0_get_adr00_dlyn(data)                                       ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_ADR_DLYN_1                                                            0x18008F14
+#define DC_PHY_ADR_DLYN_1_reg_addr                                                   "0xB8008F14"
+#define DC_PHY_ADR_DLYN_1_reg                                                        0xB8008F14
+#define set_DC_PHY_ADR_DLYN_1_reg(data)   (*((volatile unsigned int*) DC_PHY_ADR_DLYN_1_reg)=data)
+#define get_DC_PHY_ADR_DLYN_1_reg   (*((volatile unsigned int*) DC_PHY_ADR_DLYN_1_reg))
+#define DC_PHY_ADR_DLYN_1_inst_adr                                                   "0x00C5"
+#define DC_PHY_ADR_DLYN_1_inst                                                       0x00C5
+#define DC_PHY_ADR_DLYN_1_adr5_ext_dlyn_shift                                        (21)
+#define DC_PHY_ADR_DLYN_1_adr5_ext_dlyn_mask                                         (0x00E00000)
+#define DC_PHY_ADR_DLYN_1_adr5_ext_dlyn(data)                                        (0x00E00000&((data)<<21))
+#define DC_PHY_ADR_DLYN_1_adr5_ext_dlyn_src(data)                                    ((0x00E00000&(data))>>21)
+#define DC_PHY_ADR_DLYN_1_get_adr5_ext_dlyn(data)                                    ((0x00E00000&(data))>>21)
+#define DC_PHY_ADR_DLYN_1_adr4_ext_dlyn_shift                                        (18)
+#define DC_PHY_ADR_DLYN_1_adr4_ext_dlyn_mask                                         (0x001C0000)
+#define DC_PHY_ADR_DLYN_1_adr4_ext_dlyn(data)                                        (0x001C0000&((data)<<18))
+#define DC_PHY_ADR_DLYN_1_adr4_ext_dlyn_src(data)                                    ((0x001C0000&(data))>>18)
+#define DC_PHY_ADR_DLYN_1_get_adr4_ext_dlyn(data)                                    ((0x001C0000&(data))>>18)
+#define DC_PHY_ADR_DLYN_1_adr15_dlyn_shift                                           (15)
+#define DC_PHY_ADR_DLYN_1_adr15_dlyn_mask                                            (0x00038000)
+#define DC_PHY_ADR_DLYN_1_adr15_dlyn(data)                                           (0x00038000&((data)<<15))
+#define DC_PHY_ADR_DLYN_1_adr15_dlyn_src(data)                                       ((0x00038000&(data))>>15)
+#define DC_PHY_ADR_DLYN_1_get_adr15_dlyn(data)                                       ((0x00038000&(data))>>15)
+#define DC_PHY_ADR_DLYN_1_adr14_dlyn_shift                                           (12)
+#define DC_PHY_ADR_DLYN_1_adr14_dlyn_mask                                            (0x00007000)
+#define DC_PHY_ADR_DLYN_1_adr14_dlyn(data)                                           (0x00007000&((data)<<12))
+#define DC_PHY_ADR_DLYN_1_adr14_dlyn_src(data)                                       ((0x00007000&(data))>>12)
+#define DC_PHY_ADR_DLYN_1_get_adr14_dlyn(data)                                       ((0x00007000&(data))>>12)
+#define DC_PHY_ADR_DLYN_1_adr13_dlyn_shift                                           (9)
+#define DC_PHY_ADR_DLYN_1_adr13_dlyn_mask                                            (0x00000E00)
+#define DC_PHY_ADR_DLYN_1_adr13_dlyn(data)                                           (0x00000E00&((data)<<9))
+#define DC_PHY_ADR_DLYN_1_adr13_dlyn_src(data)                                       ((0x00000E00&(data))>>9)
+#define DC_PHY_ADR_DLYN_1_get_adr13_dlyn(data)                                       ((0x00000E00&(data))>>9)
+#define DC_PHY_ADR_DLYN_1_adr12_dlyn_shift                                           (6)
+#define DC_PHY_ADR_DLYN_1_adr12_dlyn_mask                                            (0x000001C0)
+#define DC_PHY_ADR_DLYN_1_adr12_dlyn(data)                                           (0x000001C0&((data)<<6))
+#define DC_PHY_ADR_DLYN_1_adr12_dlyn_src(data)                                       ((0x000001C0&(data))>>6)
+#define DC_PHY_ADR_DLYN_1_get_adr12_dlyn(data)                                       ((0x000001C0&(data))>>6)
+#define DC_PHY_ADR_DLYN_1_adr11_dlyn_shift                                           (3)
+#define DC_PHY_ADR_DLYN_1_adr11_dlyn_mask                                            (0x00000038)
+#define DC_PHY_ADR_DLYN_1_adr11_dlyn(data)                                           (0x00000038&((data)<<3))
+#define DC_PHY_ADR_DLYN_1_adr11_dlyn_src(data)                                       ((0x00000038&(data))>>3)
+#define DC_PHY_ADR_DLYN_1_get_adr11_dlyn(data)                                       ((0x00000038&(data))>>3)
+#define DC_PHY_ADR_DLYN_1_adr10_dlyn_shift                                           (0)
+#define DC_PHY_ADR_DLYN_1_adr10_dlyn_mask                                            (0x00000007)
+#define DC_PHY_ADR_DLYN_1_adr10_dlyn(data)                                           (0x00000007&((data)<<0))
+#define DC_PHY_ADR_DLYN_1_adr10_dlyn_src(data)                                       ((0x00000007&(data))>>0)
+#define DC_PHY_ADR_DLYN_1_get_adr10_dlyn(data)                                       ((0x00000007&(data))>>0)
+
+
+#define DC_PHY_SCPU_PC_TOTA_MON_NUM                                                  0x18008f18
+#define DC_PHY_SCPU_PC_TOTA_MON_NUM_reg_addr                                         "0xB8008F18"
+#define DC_PHY_SCPU_PC_TOTA_MON_NUM_reg                                              0xB8008F18
+#define set_DC_PHY_SCPU_PC_TOTA_MON_NUM_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_PC_TOTA_MON_NUM_reg)=data)
+#define get_DC_PHY_SCPU_PC_TOTA_MON_NUM_reg   (*((volatile unsigned int*) DC_PHY_SCPU_PC_TOTA_MON_NUM_reg))
+#define DC_PHY_SCPU_PC_TOTA_MON_NUM_inst_adr                                         "0x00C6"
+#define DC_PHY_SCPU_PC_TOTA_MON_NUM_inst                                             0x00C6
+#define DC_PHY_SCPU_PC_TOTA_MON_NUM_tota_mon_num_shift                               (0)
+#define DC_PHY_SCPU_PC_TOTA_MON_NUM_tota_mon_num_mask                                (0xFFFFFFFF)
+#define DC_PHY_SCPU_PC_TOTA_MON_NUM_tota_mon_num(data)                               (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_SCPU_PC_TOTA_MON_NUM_tota_mon_num_src(data)                           ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_SCPU_PC_TOTA_MON_NUM_get_tota_mon_num(data)                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_SCPU_PC_TOTA_ACK_NUM                                                  0x18008f1c
+#define DC_PHY_SCPU_PC_TOTA_ACK_NUM_reg_addr                                         "0xB8008F1C"
+#define DC_PHY_SCPU_PC_TOTA_ACK_NUM_reg                                              0xB8008F1C
+#define set_DC_PHY_SCPU_PC_TOTA_ACK_NUM_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_PC_TOTA_ACK_NUM_reg)=data)
+#define get_DC_PHY_SCPU_PC_TOTA_ACK_NUM_reg   (*((volatile unsigned int*) DC_PHY_SCPU_PC_TOTA_ACK_NUM_reg))
+#define DC_PHY_SCPU_PC_TOTA_ACK_NUM_inst_adr                                         "0x00C7"
+#define DC_PHY_SCPU_PC_TOTA_ACK_NUM_inst                                             0x00C7
+#define DC_PHY_SCPU_PC_TOTA_ACK_NUM_tota_ack_num_shift                               (0)
+#define DC_PHY_SCPU_PC_TOTA_ACK_NUM_tota_ack_num_mask                                (0xFFFFFFFF)
+#define DC_PHY_SCPU_PC_TOTA_ACK_NUM_tota_ack_num(data)                               (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_SCPU_PC_TOTA_ACK_NUM_tota_ack_num_src(data)                           ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_SCPU_PC_TOTA_ACK_NUM_get_tota_ack_num(data)                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_SCPU_PC_TOTA_IDL_NUM                                                  0x18008f20
+#define DC_PHY_SCPU_PC_TOTA_IDL_NUM_reg_addr                                         "0xB8008F20"
+#define DC_PHY_SCPU_PC_TOTA_IDL_NUM_reg                                              0xB8008F20
+#define set_DC_PHY_SCPU_PC_TOTA_IDL_NUM_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_PC_TOTA_IDL_NUM_reg)=data)
+#define get_DC_PHY_SCPU_PC_TOTA_IDL_NUM_reg   (*((volatile unsigned int*) DC_PHY_SCPU_PC_TOTA_IDL_NUM_reg))
+#define DC_PHY_SCPU_PC_TOTA_IDL_NUM_inst_adr                                         "0x00C8"
+#define DC_PHY_SCPU_PC_TOTA_IDL_NUM_inst                                             0x00C8
+#define DC_PHY_SCPU_PC_TOTA_IDL_NUM_tota_idl_num_shift                               (0)
+#define DC_PHY_SCPU_PC_TOTA_IDL_NUM_tota_idl_num_mask                                (0xFFFFFFFF)
+#define DC_PHY_SCPU_PC_TOTA_IDL_NUM_tota_idl_num(data)                               (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_SCPU_PC_TOTA_IDL_NUM_tota_idl_num_src(data)                           ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_SCPU_PC_TOTA_IDL_NUM_get_tota_idl_num(data)                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_SCPU_PC_ACC_LAT                                                       0x18008f24
+#define DC_PHY_SCPU_PC_ACC_LAT_reg_addr                                              "0xB8008F24"
+#define DC_PHY_SCPU_PC_ACC_LAT_reg                                                   0xB8008F24
+#define set_DC_PHY_SCPU_PC_ACC_LAT_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_PC_ACC_LAT_reg)=data)
+#define get_DC_PHY_SCPU_PC_ACC_LAT_reg   (*((volatile unsigned int*) DC_PHY_SCPU_PC_ACC_LAT_reg))
+#define DC_PHY_SCPU_PC_ACC_LAT_inst_adr                                              "0x00C9"
+#define DC_PHY_SCPU_PC_ACC_LAT_inst                                                  0x00C9
+#define DC_PHY_SCPU_PC_ACC_LAT_acc_lat_shift                                         (0)
+#define DC_PHY_SCPU_PC_ACC_LAT_acc_lat_mask                                          (0xFFFFFFFF)
+#define DC_PHY_SCPU_PC_ACC_LAT_acc_lat(data)                                         (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_SCPU_PC_ACC_LAT_acc_lat_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_SCPU_PC_ACC_LAT_get_acc_lat(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_SCPU_PC_MAX_LAT                                                       0x18008f28
+#define DC_PHY_SCPU_PC_MAX_LAT_reg_addr                                              "0xB8008F28"
+#define DC_PHY_SCPU_PC_MAX_LAT_reg                                                   0xB8008F28
+#define set_DC_PHY_SCPU_PC_MAX_LAT_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_PC_MAX_LAT_reg)=data)
+#define get_DC_PHY_SCPU_PC_MAX_LAT_reg   (*((volatile unsigned int*) DC_PHY_SCPU_PC_MAX_LAT_reg))
+#define DC_PHY_SCPU_PC_MAX_LAT_inst_adr                                              "0x00CA"
+#define DC_PHY_SCPU_PC_MAX_LAT_inst                                                  0x00CA
+#define DC_PHY_SCPU_PC_MAX_LAT_max_lat_shift                                         (0)
+#define DC_PHY_SCPU_PC_MAX_LAT_max_lat_mask                                          (0x0000FFFF)
+#define DC_PHY_SCPU_PC_MAX_LAT_max_lat(data)                                         (0x0000FFFF&((data)<<0))
+#define DC_PHY_SCPU_PC_MAX_LAT_max_lat_src(data)                                     ((0x0000FFFF&(data))>>0)
+#define DC_PHY_SCPU_PC_MAX_LAT_get_max_lat(data)                                     ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PHY_SCPU_PC_REQ_NUM                                                       0x18008f2c
+#define DC_PHY_SCPU_PC_REQ_NUM_reg_addr                                              "0xB8008F2C"
+#define DC_PHY_SCPU_PC_REQ_NUM_reg                                                   0xB8008F2C
+#define set_DC_PHY_SCPU_PC_REQ_NUM_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_PC_REQ_NUM_reg)=data)
+#define get_DC_PHY_SCPU_PC_REQ_NUM_reg   (*((volatile unsigned int*) DC_PHY_SCPU_PC_REQ_NUM_reg))
+#define DC_PHY_SCPU_PC_REQ_NUM_inst_adr                                              "0x00CB"
+#define DC_PHY_SCPU_PC_REQ_NUM_inst                                                  0x00CB
+#define DC_PHY_SCPU_PC_REQ_NUM_req_num_shift                                         (0)
+#define DC_PHY_SCPU_PC_REQ_NUM_req_num_mask                                          (0x00FFFFFF)
+#define DC_PHY_SCPU_PC_REQ_NUM_req_num(data)                                         (0x00FFFFFF&((data)<<0))
+#define DC_PHY_SCPU_PC_REQ_NUM_req_num_src(data)                                     ((0x00FFFFFF&(data))>>0)
+#define DC_PHY_SCPU_PC_REQ_NUM_get_req_num(data)                                     ((0x00FFFFFF&(data))>>0)
+
+
+#define DC_PHY_SCPU_PC_ACK_NUM                                                       0x18008f30
+#define DC_PHY_SCPU_PC_ACK_NUM_reg_addr                                              "0xB8008F30"
+#define DC_PHY_SCPU_PC_ACK_NUM_reg                                                   0xB8008F30
+#define set_DC_PHY_SCPU_PC_ACK_NUM_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_PC_ACK_NUM_reg)=data)
+#define get_DC_PHY_SCPU_PC_ACK_NUM_reg   (*((volatile unsigned int*) DC_PHY_SCPU_PC_ACK_NUM_reg))
+#define DC_PHY_SCPU_PC_ACK_NUM_inst_adr                                              "0x00CC"
+#define DC_PHY_SCPU_PC_ACK_NUM_inst                                                  0x00CC
+#define DC_PHY_SCPU_PC_ACK_NUM_ack_num_shift                                         (0)
+#define DC_PHY_SCPU_PC_ACK_NUM_ack_num_mask                                          (0xFFFFFFFF)
+#define DC_PHY_SCPU_PC_ACK_NUM_ack_num(data)                                         (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_SCPU_PC_ACK_NUM_ack_num_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_SCPU_PC_ACK_NUM_get_ack_num(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_SCPU_PC_CTRL                                                          0x18008f34
+#define DC_PHY_SCPU_PC_CTRL_reg_addr                                                 "0xB8008F34"
+#define DC_PHY_SCPU_PC_CTRL_reg                                                      0xB8008F34
+#define set_DC_PHY_SCPU_PC_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_PC_CTRL_reg)=data)
+#define get_DC_PHY_SCPU_PC_CTRL_reg   (*((volatile unsigned int*) DC_PHY_SCPU_PC_CTRL_reg))
+#define DC_PHY_SCPU_PC_CTRL_inst_adr                                                 "0x00CD"
+#define DC_PHY_SCPU_PC_CTRL_inst                                                     0x00CD
+#define DC_PHY_SCPU_PC_CTRL_pc_go_shift                                              (0)
+#define DC_PHY_SCPU_PC_CTRL_pc_go_mask                                               (0x00000001)
+#define DC_PHY_SCPU_PC_CTRL_pc_go(data)                                              (0x00000001&((data)<<0))
+#define DC_PHY_SCPU_PC_CTRL_pc_go_src(data)                                          ((0x00000001&(data))>>0)
+#define DC_PHY_SCPU_PC_CTRL_get_pc_go(data)                                          ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_GCK_CTRL                                                              0x18008f38
+#define DC_PHY_GCK_CTRL_reg_addr                                                     "0xB8008F38"
+#define DC_PHY_GCK_CTRL_reg                                                          0xB8008F38
+#define set_DC_PHY_GCK_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_GCK_CTRL_reg)=data)
+#define get_DC_PHY_GCK_CTRL_reg   (*((volatile unsigned int*) DC_PHY_GCK_CTRL_reg))
+#define DC_PHY_GCK_CTRL_inst_adr                                                     "0x00CE"
+#define DC_PHY_GCK_CTRL_inst                                                         0x00CE
+#define DC_PHY_GCK_CTRL_gck_ext_cyc_shift                                            (8)
+#define DC_PHY_GCK_CTRL_gck_ext_cyc_mask                                             (0x00003F00)
+#define DC_PHY_GCK_CTRL_gck_ext_cyc(data)                                            (0x00003F00&((data)<<8))
+#define DC_PHY_GCK_CTRL_gck_ext_cyc_src(data)                                        ((0x00003F00&(data))>>8)
+#define DC_PHY_GCK_CTRL_get_gck_ext_cyc(data)                                        ((0x00003F00&(data))>>8)
+#define DC_PHY_GCK_CTRL_par_gck_en_shift                                             (2)
+#define DC_PHY_GCK_CTRL_par_gck_en_mask                                              (0x00000004)
+#define DC_PHY_GCK_CTRL_par_gck_en(data)                                             (0x00000004&((data)<<2))
+#define DC_PHY_GCK_CTRL_par_gck_en_src(data)                                         ((0x00000004&(data))>>2)
+#define DC_PHY_GCK_CTRL_get_par_gck_en(data)                                         ((0x00000004&(data))>>2)
+#define DC_PHY_GCK_CTRL_fsm_gck_en_shift                                             (1)
+#define DC_PHY_GCK_CTRL_fsm_gck_en_mask                                              (0x00000002)
+#define DC_PHY_GCK_CTRL_fsm_gck_en(data)                                             (0x00000002&((data)<<1))
+#define DC_PHY_GCK_CTRL_fsm_gck_en_src(data)                                         ((0x00000002&(data))>>1)
+#define DC_PHY_GCK_CTRL_get_fsm_gck_en(data)                                         ((0x00000002&(data))>>1)
+#define DC_PHY_GCK_CTRL_ioblk_gck_en_shift                                           (0)
+#define DC_PHY_GCK_CTRL_ioblk_gck_en_mask                                            (0x00000001)
+#define DC_PHY_GCK_CTRL_ioblk_gck_en(data)                                           (0x00000001&((data)<<0))
+#define DC_PHY_GCK_CTRL_ioblk_gck_en_src(data)                                       ((0x00000001&(data))>>0)
+#define DC_PHY_GCK_CTRL_get_ioblk_gck_en(data)                                       ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0                                              0x18008f3c
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_reg_addr                                     "0xB8008F3C"
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_reg                                          0xB8008F3C
+#define set_DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_reg)=data)
+#define get_DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_reg   (*((volatile unsigned int*) DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_reg))
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_inst_adr                                     "0x00CF"
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_inst                                         0x00CF
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_enable_shift                                 (0)
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_enable_mask                                  (0x00000001)
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_enable(data)                                 (0x00000001&((data)<<0))
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_enable_src(data)                             ((0x00000001&(data))>>0)
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_0_get_enable(data)                             ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1                                              0x18008f40
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_reg_addr                                     "0xB8008F40"
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_reg                                          0xB8008F40
+#define set_DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_reg)=data)
+#define get_DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_reg   (*((volatile unsigned int*) DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_reg))
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_inst_adr                                     "0x00D0"
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_inst                                         0x00D0
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_timer_threshold_shift                        (0)
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_timer_threshold_mask                         (0xFFFFFFFF)
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_timer_threshold(data)                        (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_timer_threshold_src(data)                    ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_1_get_timer_threshold(data)                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2                                              0x18008f44
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_reg_addr                                     "0xB8008F44"
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_reg                                          0xB8008F44
+#define set_DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_reg)=data)
+#define get_DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_reg   (*((volatile unsigned int*) DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_reg))
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_inst_adr                                     "0x00D1"
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_inst                                         0x00D1
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_count_threshold_shift                        (0)
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_count_threshold_mask                         (0x00FFFFFF)
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_count_threshold(data)                        (0x00FFFFFF&((data)<<0))
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_count_threshold_src(data)                    ((0x00FFFFFF&(data))>>0)
+#define DC_PHY_SCPU_LEAKY_BUCKET_CTRL_2_get_count_threshold(data)                    ((0x00FFFFFF&(data))>>0)
+
+
+#define DC_PHY_SCPU_PC_MERGE_NUM                                                     0x18008f48
+#define DC_PHY_SCPU_PC_MERGE_NUM_reg_addr                                            "0xB8008F48"
+#define DC_PHY_SCPU_PC_MERGE_NUM_reg                                                 0xB8008F48
+#define set_DC_PHY_SCPU_PC_MERGE_NUM_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_PC_MERGE_NUM_reg)=data)
+#define get_DC_PHY_SCPU_PC_MERGE_NUM_reg   (*((volatile unsigned int*) DC_PHY_SCPU_PC_MERGE_NUM_reg))
+#define DC_PHY_SCPU_PC_MERGE_NUM_inst_adr                                            "0x00D2"
+#define DC_PHY_SCPU_PC_MERGE_NUM_inst                                                0x00D2
+#define DC_PHY_SCPU_PC_MERGE_NUM_merge_num_shift                                     (0)
+#define DC_PHY_SCPU_PC_MERGE_NUM_merge_num_mask                                      (0x00FFFFFF)
+#define DC_PHY_SCPU_PC_MERGE_NUM_merge_num(data)                                     (0x00FFFFFF&((data)<<0))
+#define DC_PHY_SCPU_PC_MERGE_NUM_merge_num_src(data)                                 ((0x00FFFFFF&(data))>>0)
+#define DC_PHY_SCPU_PC_MERGE_NUM_get_merge_num(data)                                 ((0x00FFFFFF&(data))>>0)
+
+
+#define DC_PHY_SCPU_PC_WR_REQ_NUM                                                    0x18008f4c
+#define DC_PHY_SCPU_PC_WR_REQ_NUM_reg_addr                                           "0xB8008F4C"
+#define DC_PHY_SCPU_PC_WR_REQ_NUM_reg                                                0xB8008F4C
+#define set_DC_PHY_SCPU_PC_WR_REQ_NUM_reg(data)   (*((volatile unsigned int*) DC_PHY_SCPU_PC_WR_REQ_NUM_reg)=data)
+#define get_DC_PHY_SCPU_PC_WR_REQ_NUM_reg   (*((volatile unsigned int*) DC_PHY_SCPU_PC_WR_REQ_NUM_reg))
+#define DC_PHY_SCPU_PC_WR_REQ_NUM_inst_adr                                           "0x00D3"
+#define DC_PHY_SCPU_PC_WR_REQ_NUM_inst                                               0x00D3
+#define DC_PHY_SCPU_PC_WR_REQ_NUM_wr_req_num_shift                                   (0)
+#define DC_PHY_SCPU_PC_WR_REQ_NUM_wr_req_num_mask                                    (0x00FFFFFF)
+#define DC_PHY_SCPU_PC_WR_REQ_NUM_wr_req_num(data)                                   (0x00FFFFFF&((data)<<0))
+#define DC_PHY_SCPU_PC_WR_REQ_NUM_wr_req_num_src(data)                               ((0x00FFFFFF&(data))>>0)
+#define DC_PHY_SCPU_PC_WR_REQ_NUM_get_wr_req_num(data)                               ((0x00FFFFFF&(data))>>0)
+
+
+#define DC_PHY_SPEED_SENSOR_CTRL                                                     0x18008f50
+#define DC_PHY_SPEED_SENSOR_CTRL_reg_addr                                            "0xB8008F50"
+#define DC_PHY_SPEED_SENSOR_CTRL_reg                                                 0xB8008F50
+#define set_DC_PHY_SPEED_SENSOR_CTRL_reg(data)   (*((volatile unsigned int*) DC_PHY_SPEED_SENSOR_CTRL_reg)=data)
+#define get_DC_PHY_SPEED_SENSOR_CTRL_reg   (*((volatile unsigned int*) DC_PHY_SPEED_SENSOR_CTRL_reg))
+#define DC_PHY_SPEED_SENSOR_CTRL_inst_adr                                            "0x00D4"
+#define DC_PHY_SPEED_SENSOR_CTRL_inst                                                0x00D4
+#define DC_PHY_SPEED_SENSOR_CTRL_data_in_shift                                       (8)
+#define DC_PHY_SPEED_SENSOR_CTRL_data_in_mask                                        (0x0FFFFF00)
+#define DC_PHY_SPEED_SENSOR_CTRL_data_in(data)                                       (0x0FFFFF00&((data)<<8))
+#define DC_PHY_SPEED_SENSOR_CTRL_data_in_src(data)                                   ((0x0FFFFF00&(data))>>8)
+#define DC_PHY_SPEED_SENSOR_CTRL_get_data_in(data)                                   ((0x0FFFFF00&(data))>>8)
+#define DC_PHY_SPEED_SENSOR_CTRL_data_in_ready_shift                                 (5)
+#define DC_PHY_SPEED_SENSOR_CTRL_data_in_ready_mask                                  (0x00000020)
+#define DC_PHY_SPEED_SENSOR_CTRL_data_in_ready(data)                                 (0x00000020&((data)<<5))
+#define DC_PHY_SPEED_SENSOR_CTRL_data_in_ready_src(data)                             ((0x00000020&(data))>>5)
+#define DC_PHY_SPEED_SENSOR_CTRL_get_data_in_ready(data)                             ((0x00000020&(data))>>5)
+#define DC_PHY_SPEED_SENSOR_CTRL_wire_sel_shift                                      (4)
+#define DC_PHY_SPEED_SENSOR_CTRL_wire_sel_mask                                       (0x00000010)
+#define DC_PHY_SPEED_SENSOR_CTRL_wire_sel(data)                                      (0x00000010&((data)<<4))
+#define DC_PHY_SPEED_SENSOR_CTRL_wire_sel_src(data)                                  ((0x00000010&(data))>>4)
+#define DC_PHY_SPEED_SENSOR_CTRL_get_wire_sel(data)                                  ((0x00000010&(data))>>4)
+#define DC_PHY_SPEED_SENSOR_CTRL_ro_sel_shift                                        (1)
+#define DC_PHY_SPEED_SENSOR_CTRL_ro_sel_mask                                         (0x0000000E)
+#define DC_PHY_SPEED_SENSOR_CTRL_ro_sel(data)                                        (0x0000000E&((data)<<1))
+#define DC_PHY_SPEED_SENSOR_CTRL_ro_sel_src(data)                                    ((0x0000000E&(data))>>1)
+#define DC_PHY_SPEED_SENSOR_CTRL_get_ro_sel(data)                                    ((0x0000000E&(data))>>1)
+#define DC_PHY_SPEED_SENSOR_CTRL_dss_rst_n_shift                                     (0)
+#define DC_PHY_SPEED_SENSOR_CTRL_dss_rst_n_mask                                      (0x00000001)
+#define DC_PHY_SPEED_SENSOR_CTRL_dss_rst_n(data)                                     (0x00000001&((data)<<0))
+#define DC_PHY_SPEED_SENSOR_CTRL_dss_rst_n_src(data)                                 ((0x00000001&(data))>>0)
+#define DC_PHY_SPEED_SENSOR_CTRL_get_dss_rst_n(data)                                 ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_SPEED_SENSOR_STATUS                                                   0x18008f54
+#define DC_PHY_SPEED_SENSOR_STATUS_reg_addr                                          "0xB8008F54"
+#define DC_PHY_SPEED_SENSOR_STATUS_reg                                               0xB8008F54
+#define set_DC_PHY_SPEED_SENSOR_STATUS_reg(data)   (*((volatile unsigned int*) DC_PHY_SPEED_SENSOR_STATUS_reg)=data)
+#define get_DC_PHY_SPEED_SENSOR_STATUS_reg   (*((volatile unsigned int*) DC_PHY_SPEED_SENSOR_STATUS_reg))
+#define DC_PHY_SPEED_SENSOR_STATUS_inst_adr                                          "0x00D5"
+#define DC_PHY_SPEED_SENSOR_STATUS_inst                                              0x00D5
+#define DC_PHY_SPEED_SENSOR_STATUS_count_out_shift                                   (4)
+#define DC_PHY_SPEED_SENSOR_STATUS_count_out_mask                                    (0x00FFFFF0)
+#define DC_PHY_SPEED_SENSOR_STATUS_count_out(data)                                   (0x00FFFFF0&((data)<<4))
+#define DC_PHY_SPEED_SENSOR_STATUS_count_out_src(data)                               ((0x00FFFFF0&(data))>>4)
+#define DC_PHY_SPEED_SENSOR_STATUS_get_count_out(data)                               ((0x00FFFFF0&(data))>>4)
+#define DC_PHY_SPEED_SENSOR_STATUS_wsort_go_shift                                    (1)
+#define DC_PHY_SPEED_SENSOR_STATUS_wsort_go_mask                                     (0x00000002)
+#define DC_PHY_SPEED_SENSOR_STATUS_wsort_go(data)                                    (0x00000002&((data)<<1))
+#define DC_PHY_SPEED_SENSOR_STATUS_wsort_go_src(data)                                ((0x00000002&(data))>>1)
+#define DC_PHY_SPEED_SENSOR_STATUS_get_wsort_go(data)                                ((0x00000002&(data))>>1)
+#define DC_PHY_SPEED_SENSOR_STATUS_ready_shift                                       (0)
+#define DC_PHY_SPEED_SENSOR_STATUS_ready_mask                                        (0x00000001)
+#define DC_PHY_SPEED_SENSOR_STATUS_ready(data)                                       (0x00000001&((data)<<0))
+#define DC_PHY_SPEED_SENSOR_STATUS_ready_src(data)                                   ((0x00000001&(data))>>0)
+#define DC_PHY_SPEED_SENSOR_STATUS_get_ready(data)                                   ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_EXPRESS_LANE_CTRL_MISC                                                0x18008f58
+#define DC_PHY_EXPRESS_LANE_CTRL_MISC_reg_addr                                       "0xB8008F58"
+#define DC_PHY_EXPRESS_LANE_CTRL_MISC_reg                                            0xB8008F58
+#define set_DC_PHY_EXPRESS_LANE_CTRL_MISC_reg(data)   (*((volatile unsigned int*) DC_PHY_EXPRESS_LANE_CTRL_MISC_reg)=data)
+#define get_DC_PHY_EXPRESS_LANE_CTRL_MISC_reg   (*((volatile unsigned int*) DC_PHY_EXPRESS_LANE_CTRL_MISC_reg))
+#define DC_PHY_EXPRESS_LANE_CTRL_MISC_inst_adr                                       "0x00D6"
+#define DC_PHY_EXPRESS_LANE_CTRL_MISC_inst                                           0x00D6
+#define DC_PHY_EXPRESS_LANE_CTRL_MISC_ctrl_misc_shift                                (0)
+#define DC_PHY_EXPRESS_LANE_CTRL_MISC_ctrl_misc_mask                                 (0xFFFFFFFF)
+#define DC_PHY_EXPRESS_LANE_CTRL_MISC_ctrl_misc(data)                                (0xFFFFFFFF&((data)<<0))
+#define DC_PHY_EXPRESS_LANE_CTRL_MISC_ctrl_misc_src(data)                            ((0xFFFFFFFF&(data))>>0)
+#define DC_PHY_EXPRESS_LANE_CTRL_MISC_get_ctrl_misc(data)                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PHY_DSS_C35_MISC                                                          0x18008f90
+#define DC_PHY_DSS_C35_MISC_reg_addr                                                 "0xB8008F90"
+#define DC_PHY_DSS_C35_MISC_reg                                                      0xB8008F90
+#define set_DC_PHY_DSS_C35_MISC_reg(data)   (*((volatile unsigned int*) DC_PHY_DSS_C35_MISC_reg)=data)
+#define get_DC_PHY_DSS_C35_MISC_reg   (*((volatile unsigned int*) DC_PHY_DSS_C35_MISC_reg))
+#define DC_PHY_DSS_C35_MISC_inst_adr                                                 "0x00E4"
+#define DC_PHY_DSS_C35_MISC_inst                                                     0x00E4
+#define DC_PHY_DSS_C35_MISC_data_in_shift                                            (8)
+#define DC_PHY_DSS_C35_MISC_data_in_mask                                             (0x0FFFFF00)
+#define DC_PHY_DSS_C35_MISC_data_in(data)                                            (0x0FFFFF00&((data)<<8))
+#define DC_PHY_DSS_C35_MISC_data_in_src(data)                                        ((0x0FFFFF00&(data))>>8)
+#define DC_PHY_DSS_C35_MISC_get_data_in(data)                                        ((0x0FFFFF00&(data))>>8)
+#define DC_PHY_DSS_C35_MISC_speed_en_shift                                           (5)
+#define DC_PHY_DSS_C35_MISC_speed_en_mask                                            (0x00000020)
+#define DC_PHY_DSS_C35_MISC_speed_en(data)                                           (0x00000020&((data)<<5))
+#define DC_PHY_DSS_C35_MISC_speed_en_src(data)                                       ((0x00000020&(data))>>5)
+#define DC_PHY_DSS_C35_MISC_get_speed_en(data)                                       ((0x00000020&(data))>>5)
+#define DC_PHY_DSS_C35_MISC_wire_sel_shift                                           (4)
+#define DC_PHY_DSS_C35_MISC_wire_sel_mask                                            (0x00000010)
+#define DC_PHY_DSS_C35_MISC_wire_sel(data)                                           (0x00000010&((data)<<4))
+#define DC_PHY_DSS_C35_MISC_wire_sel_src(data)                                       ((0x00000010&(data))>>4)
+#define DC_PHY_DSS_C35_MISC_get_wire_sel(data)                                       ((0x00000010&(data))>>4)
+#define DC_PHY_DSS_C35_MISC_ro_sel_shift                                             (1)
+#define DC_PHY_DSS_C35_MISC_ro_sel_mask                                              (0x0000000E)
+#define DC_PHY_DSS_C35_MISC_ro_sel(data)                                             (0x0000000E&((data)<<1))
+#define DC_PHY_DSS_C35_MISC_ro_sel_src(data)                                         ((0x0000000E&(data))>>1)
+#define DC_PHY_DSS_C35_MISC_get_ro_sel(data)                                         ((0x0000000E&(data))>>1)
+#define DC_PHY_DSS_C35_MISC_dss_rst_n_shift                                          (0)
+#define DC_PHY_DSS_C35_MISC_dss_rst_n_mask                                           (0x00000001)
+#define DC_PHY_DSS_C35_MISC_dss_rst_n(data)                                          (0x00000001&((data)<<0))
+#define DC_PHY_DSS_C35_MISC_dss_rst_n_src(data)                                      ((0x00000001&(data))>>0)
+#define DC_PHY_DSS_C35_MISC_get_dss_rst_n(data)                                      ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_DSS_C35_ST                                                            0x18008f94
+#define DC_PHY_DSS_C35_ST_reg_addr                                                   "0xB8008F94"
+#define DC_PHY_DSS_C35_ST_reg                                                        0xB8008F94
+#define set_DC_PHY_DSS_C35_ST_reg(data)   (*((volatile unsigned int*) DC_PHY_DSS_C35_ST_reg)=data)
+#define get_DC_PHY_DSS_C35_ST_reg   (*((volatile unsigned int*) DC_PHY_DSS_C35_ST_reg))
+#define DC_PHY_DSS_C35_ST_inst_adr                                                   "0x00E5"
+#define DC_PHY_DSS_C35_ST_inst                                                       0x00E5
+#define DC_PHY_DSS_C35_ST_count_out_shift                                            (4)
+#define DC_PHY_DSS_C35_ST_count_out_mask                                             (0x00FFFFF0)
+#define DC_PHY_DSS_C35_ST_count_out(data)                                            (0x00FFFFF0&((data)<<4))
+#define DC_PHY_DSS_C35_ST_count_out_src(data)                                        ((0x00FFFFF0&(data))>>4)
+#define DC_PHY_DSS_C35_ST_get_count_out(data)                                        ((0x00FFFFF0&(data))>>4)
+#define DC_PHY_DSS_C35_ST_wsort_go_shift                                             (1)
+#define DC_PHY_DSS_C35_ST_wsort_go_mask                                              (0x00000002)
+#define DC_PHY_DSS_C35_ST_wsort_go(data)                                             (0x00000002&((data)<<1))
+#define DC_PHY_DSS_C35_ST_wsort_go_src(data)                                         ((0x00000002&(data))>>1)
+#define DC_PHY_DSS_C35_ST_get_wsort_go(data)                                         ((0x00000002&(data))>>1)
+#define DC_PHY_DSS_C35_ST_ready_shift                                                (0)
+#define DC_PHY_DSS_C35_ST_ready_mask                                                 (0x00000001)
+#define DC_PHY_DSS_C35_ST_ready(data)                                                (0x00000001&((data)<<0))
+#define DC_PHY_DSS_C35_ST_ready_src(data)                                            ((0x00000001&(data))>>0)
+#define DC_PHY_DSS_C35_ST_get_ready(data)                                            ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_DSS_C35D5_MISC                                                        0x18008f98
+#define DC_PHY_DSS_C35D5_MISC_reg_addr                                               "0xB8008F98"
+#define DC_PHY_DSS_C35D5_MISC_reg                                                    0xB8008F98
+#define set_DC_PHY_DSS_C35D5_MISC_reg(data)   (*((volatile unsigned int*) DC_PHY_DSS_C35D5_MISC_reg)=data)
+#define get_DC_PHY_DSS_C35D5_MISC_reg   (*((volatile unsigned int*) DC_PHY_DSS_C35D5_MISC_reg))
+#define DC_PHY_DSS_C35D5_MISC_inst_adr                                               "0x00E6"
+#define DC_PHY_DSS_C35D5_MISC_inst                                                   0x00E6
+#define DC_PHY_DSS_C35D5_MISC_data_in_shift                                          (8)
+#define DC_PHY_DSS_C35D5_MISC_data_in_mask                                           (0x0FFFFF00)
+#define DC_PHY_DSS_C35D5_MISC_data_in(data)                                          (0x0FFFFF00&((data)<<8))
+#define DC_PHY_DSS_C35D5_MISC_data_in_src(data)                                      ((0x0FFFFF00&(data))>>8)
+#define DC_PHY_DSS_C35D5_MISC_get_data_in(data)                                      ((0x0FFFFF00&(data))>>8)
+#define DC_PHY_DSS_C35D5_MISC_speed_en_shift                                         (5)
+#define DC_PHY_DSS_C35D5_MISC_speed_en_mask                                          (0x00000020)
+#define DC_PHY_DSS_C35D5_MISC_speed_en(data)                                         (0x00000020&((data)<<5))
+#define DC_PHY_DSS_C35D5_MISC_speed_en_src(data)                                     ((0x00000020&(data))>>5)
+#define DC_PHY_DSS_C35D5_MISC_get_speed_en(data)                                     ((0x00000020&(data))>>5)
+#define DC_PHY_DSS_C35D5_MISC_wire_sel_shift                                         (4)
+#define DC_PHY_DSS_C35D5_MISC_wire_sel_mask                                          (0x00000010)
+#define DC_PHY_DSS_C35D5_MISC_wire_sel(data)                                         (0x00000010&((data)<<4))
+#define DC_PHY_DSS_C35D5_MISC_wire_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define DC_PHY_DSS_C35D5_MISC_get_wire_sel(data)                                     ((0x00000010&(data))>>4)
+#define DC_PHY_DSS_C35D5_MISC_ro_sel_shift                                           (1)
+#define DC_PHY_DSS_C35D5_MISC_ro_sel_mask                                            (0x0000000E)
+#define DC_PHY_DSS_C35D5_MISC_ro_sel(data)                                           (0x0000000E&((data)<<1))
+#define DC_PHY_DSS_C35D5_MISC_ro_sel_src(data)                                       ((0x0000000E&(data))>>1)
+#define DC_PHY_DSS_C35D5_MISC_get_ro_sel(data)                                       ((0x0000000E&(data))>>1)
+#define DC_PHY_DSS_C35D5_MISC_dss_rst_n_shift                                        (0)
+#define DC_PHY_DSS_C35D5_MISC_dss_rst_n_mask                                         (0x00000001)
+#define DC_PHY_DSS_C35D5_MISC_dss_rst_n(data)                                        (0x00000001&((data)<<0))
+#define DC_PHY_DSS_C35D5_MISC_dss_rst_n_src(data)                                    ((0x00000001&(data))>>0)
+#define DC_PHY_DSS_C35D5_MISC_get_dss_rst_n(data)                                    ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_DSS_C35D5_ST                                                          0x18008f9c
+#define DC_PHY_DSS_C35D5_ST_reg_addr                                                 "0xB8008F9C"
+#define DC_PHY_DSS_C35D5_ST_reg                                                      0xB8008F9C
+#define set_DC_PHY_DSS_C35D5_ST_reg(data)   (*((volatile unsigned int*) DC_PHY_DSS_C35D5_ST_reg)=data)
+#define get_DC_PHY_DSS_C35D5_ST_reg   (*((volatile unsigned int*) DC_PHY_DSS_C35D5_ST_reg))
+#define DC_PHY_DSS_C35D5_ST_inst_adr                                                 "0x00E7"
+#define DC_PHY_DSS_C35D5_ST_inst                                                     0x00E7
+#define DC_PHY_DSS_C35D5_ST_count_out_shift                                          (4)
+#define DC_PHY_DSS_C35D5_ST_count_out_mask                                           (0x00FFFFF0)
+#define DC_PHY_DSS_C35D5_ST_count_out(data)                                          (0x00FFFFF0&((data)<<4))
+#define DC_PHY_DSS_C35D5_ST_count_out_src(data)                                      ((0x00FFFFF0&(data))>>4)
+#define DC_PHY_DSS_C35D5_ST_get_count_out(data)                                      ((0x00FFFFF0&(data))>>4)
+#define DC_PHY_DSS_C35D5_ST_wsort_go_shift                                           (1)
+#define DC_PHY_DSS_C35D5_ST_wsort_go_mask                                            (0x00000002)
+#define DC_PHY_DSS_C35D5_ST_wsort_go(data)                                           (0x00000002&((data)<<1))
+#define DC_PHY_DSS_C35D5_ST_wsort_go_src(data)                                       ((0x00000002&(data))>>1)
+#define DC_PHY_DSS_C35D5_ST_get_wsort_go(data)                                       ((0x00000002&(data))>>1)
+#define DC_PHY_DSS_C35D5_ST_ready_shift                                              (0)
+#define DC_PHY_DSS_C35D5_ST_ready_mask                                               (0x00000001)
+#define DC_PHY_DSS_C35D5_ST_ready(data)                                              (0x00000001&((data)<<0))
+#define DC_PHY_DSS_C35D5_ST_ready_src(data)                                          ((0x00000001&(data))>>0)
+#define DC_PHY_DSS_C35D5_ST_get_ready(data)                                          ((0x00000001&(data))>>0)
+
+
+#define DC_PHY_DSS_DBG                                                               0x18008fa0
+#define DC_PHY_DSS_DBG_reg_addr                                                      "0xB8008FA0"
+#define DC_PHY_DSS_DBG_reg                                                           0xB8008FA0
+#define set_DC_PHY_DSS_DBG_reg(data)   (*((volatile unsigned int*) DC_PHY_DSS_DBG_reg)=data)
+#define get_DC_PHY_DSS_DBG_reg   (*((volatile unsigned int*) DC_PHY_DSS_DBG_reg))
+#define DC_PHY_DSS_DBG_inst_adr                                                      "0x00E8"
+#define DC_PHY_DSS_DBG_inst                                                          0x00E8
+#define DC_PHY_DSS_DBG_dbgo_c35d5_shift                                              (16)
+#define DC_PHY_DSS_DBG_dbgo_c35d5_mask                                               (0xFFFF0000)
+#define DC_PHY_DSS_DBG_dbgo_c35d5(data)                                              (0xFFFF0000&((data)<<16))
+#define DC_PHY_DSS_DBG_dbgo_c35d5_src(data)                                          ((0xFFFF0000&(data))>>16)
+#define DC_PHY_DSS_DBG_get_dbgo_c35d5(data)                                          ((0xFFFF0000&(data))>>16)
+#define DC_PHY_DSS_DBG_dbgo_c35_shift                                                (0)
+#define DC_PHY_DSS_DBG_dbgo_c35_mask                                                 (0x0000FFFF)
+#define DC_PHY_DSS_DBG_dbgo_c35(data)                                                (0x0000FFFF&((data)<<0))
+#define DC_PHY_DSS_DBG_dbgo_c35_src(data)                                            ((0x0000FFFF&(data))>>0)
+#define DC_PHY_DSS_DBG_get_dbgo_c35(data)                                            ((0x0000FFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/dc_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/dc_reg.h
new file mode 100644
index 00000000..b887d63
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/dc_reg.h
@@ -0,0 +1,4589 @@
+/**************************************************************
+// Spec Version                  : 0.08
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/6/5 15:7:51
+***************************************************************/
+
+
+#ifndef _DC_SYS_REG_H_INCLUDED_
+#define _DC_SYS_REG_H_INCLUDED_
+#ifdef  _DC_SYS_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     pict_width_scale:6;
+unsigned int     pict_init_page:17;
+}DC_PICT_SET;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     dram_8g_used:1;
+unsigned int     dram_4g_used:1;
+unsigned int     ddr3_512_used:1;
+unsigned int     dram_2g_used:1;
+unsigned int     pre_arb_scheme_sel:1;
+unsigned int     ve_cmd_grp_disable:1;
+unsigned int     ddr3_mapping_en:1;
+unsigned int     reserved_1:1;
+unsigned int     self_lookback_mode:1;
+unsigned int     mem_num:1;
+unsigned int     reserved_2:1;
+unsigned int     page_size:2;
+unsigned int     pre_arb_rd_cnt:8;
+unsigned int     pre_arb_wr_cnt:8;
+}DC_SYS_MISC;
+
+typedef struct 
+{
+unsigned int     scpu_pri:4;
+unsigned int     mipi_pri:4;
+unsigned int     reserved_0:4;
+unsigned int     vo_high_pri:4;
+unsigned int     reserved_1:4;
+unsigned int     sb1_high_pri:4;
+unsigned int     reserved_2:4;
+unsigned int     sb0_pri:4;
+}PRIORITY_CTRL_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     sb3_high_pri:4;
+unsigned int     reserved_1:4;
+unsigned int     vo_low_pri:4;
+unsigned int     reserved_2:4;
+unsigned int     sb1_low_pri:4;
+unsigned int     reserved_3:4;
+unsigned int     avk_cpu_pri:4;
+}PRIORITY_CTRL_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     gde_pri:4;
+unsigned int     reserved_1:4;
+unsigned int     se_pri:4;
+unsigned int     reserved_2:4;
+unsigned int     sb3_low_pri:4;
+unsigned int     reserved_3:4;
+unsigned int     ve_pri:4;
+}PRIORITY_CTRL_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     vo_low_tag:2;
+unsigned int     reserved_1:2;
+unsigned int     sb1_low_tag:2;
+unsigned int     reserved_2:2;
+unsigned int     se_tag:2;
+unsigned int     reserved_3:2;
+unsigned int     avk_cpu_tag:2;
+unsigned int     reserved_4:2;
+unsigned int     ve_tag:2;
+}REORDER_CTRL_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     sb0_tag:2;
+unsigned int     reserved_1:2;
+unsigned int     sb1_high_tag:2;
+unsigned int     reserved_2:2;
+unsigned int     vo_high_tag:2;
+unsigned int     reserved_3:2;
+unsigned int     sb3_high_tag:2;
+unsigned int     reserved_4:2;
+unsigned int     sb3_low_tag:2;
+}REORDER_CTRL_1;
+
+typedef struct 
+{
+unsigned int     split_wait:4;
+unsigned int     arbit_los:4;
+unsigned int     reserved_0:1;
+unsigned int     short_lxy:7;
+unsigned int     live_split:8;
+unsigned int     reserved_1:6;
+unsigned int     live_cflit:1;
+unsigned int     queue_flush:1;
+}DC_PROS_CTRL;
+
+typedef struct 
+{
+unsigned int     pict_set_num:8;
+unsigned int     pict_offset_rd:1;
+unsigned int     reserved_0:3;
+unsigned int     pict_set_offset_y:10;
+unsigned int     pict_set_offset_x:10;
+}DC_PICT_SET_OFFSET;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     req_pending:1;
+unsigned int     req_id:11;
+}DC_REQ_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     qfifo_cnt_full_threshold:5;
+unsigned int     full_cmd_count:4;
+unsigned int     pre_tra_rd_cnt:10;
+unsigned int     pre_tra_wr_cnt:10;
+}DC_SYS_MISC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     gpu_wdata_queue_flush:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:1;
+unsigned int     enable_arb_delay_by_tv_sb1_grant:1;
+unsigned int     gpu_cmd_queue_flush:1;
+unsigned int     gde_cmd_grp_disable:1;
+}DC_SYS_MISC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     pc_go:1;
+}DC_PC_CTRL;
+
+typedef struct 
+{
+unsigned int     pc_tota_mon_num:32;
+}DC_PC_TOTA_MON_NUM;
+
+typedef struct 
+{
+unsigned int     pc_tota_ack_num:32;
+}DC_PC_TOTA_ACK_NUM;
+
+typedef struct 
+{
+unsigned int     pc_tota_idl_num:32;
+}DC_PC_TOTA_IDL_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en_3:1;
+unsigned int     pc_sysh_prog2_sel:7;
+unsigned int     reserved_1:1;
+unsigned int     write_en_2:1;
+unsigned int     pc_sysh_prog1_sel:7;
+unsigned int     reserved_2:1;
+unsigned int     write_en_1:1;
+unsigned int     pc_sysh_prog0_sel:7;
+}DC_PC_SYSH_PROG_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en_3:1;
+unsigned int     pc_sys_prog2_sel:7;
+unsigned int     reserved_1:1;
+unsigned int     write_en_2:1;
+unsigned int     pc_sys_prog1_sel:7;
+unsigned int     reserved_2:1;
+unsigned int     write_en_1:1;
+unsigned int     pc_sys_prog0_sel:7;
+}DC_PC_SYS_PROG_CTRL;
+
+typedef struct 
+{
+unsigned int     sysh_prog0_acc_lat:32;
+}DC_PC_SYSH_PROG_0_ACC_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sysh_prog0_max_lat:16;
+}DC_PC_SYSH_PROG_0_MAX_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     sysh_prog0_req_num:24;
+}DC_PC_SYSH_PROG_0_REQ_NUM;
+
+typedef struct 
+{
+unsigned int     sysh_prog0_ack_num:32;
+}DC_PC_SYSH_PROG_0_ACK_NUM;
+
+typedef struct 
+{
+unsigned int     sysh_prog1_acc_lat:32;
+}DC_PC_SYSH_PROG_1_ACC_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sysh_prog1_max_lat:16;
+}DC_PC_SYSH_PROG_1_MAX_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     sysh_prog1_req_num:24;
+}DC_PC_SYSH_PROG_1_REQ_NUM;
+
+typedef struct 
+{
+unsigned int     sysh_prog1_ack_num:32;
+}DC_PC_SYSH_PROG_1_ACK_NUM;
+
+typedef struct 
+{
+unsigned int     sysh_prog2_acc_lat:32;
+}DC_PC_SYSH_PROG_2_ACC_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sysh_prog2_max_lat:16;
+}DC_PC_SYSH_PROG_2_MAX_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     sysh_prog2_req_num:24;
+}DC_PC_SYSH_PROG_2_REQ_NUM;
+
+typedef struct 
+{
+unsigned int     sysh_prog2_ack_num:32;
+}DC_PC_SYSH_PROG_2_ACK_NUM;
+
+typedef struct 
+{
+unsigned int     sys_prog0_acc_lat:32;
+}DC_PC_SYS_PROG_0_ACC_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sys_prog0_max_lat:16;
+}DC_PC_SYS_PROG_0_MAX_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     sys_prog0_req_num:24;
+}DC_PC_SYS_PROG_0_REQ_NUM;
+
+typedef struct 
+{
+unsigned int     sys_prog0_ack_num:32;
+}DC_PC_SYS_PROG_0_ACK_NUM;
+
+typedef struct 
+{
+unsigned int     sys_prog1_acc_lat:32;
+}DC_PC_SYS_PROG_1_ACC_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sys_prog1_max_lat:16;
+}DC_PC_SYS_PROG_1_MAX_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     sys_prog1_req_num:24;
+}DC_PC_SYS_PROG_1_REQ_NUM;
+
+typedef struct 
+{
+unsigned int     sys_prog1_ack_num:32;
+}DC_PC_SYS_PROG_1_ACK_NUM;
+
+typedef struct 
+{
+unsigned int     sys_prog2_acc_lat:32;
+}DC_PC_SYS_PROG_2_ACC_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sys_prog2_max_lat:16;
+}DC_PC_SYS_PROG_2_MAX_LAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     sys_prog2_req_num:24;
+}DC_PC_SYS_PROG_2_REQ_NUM;
+
+typedef struct 
+{
+unsigned int     sys_prog2_ack_num:32;
+}DC_PC_SYS_PROG_2_ACK_NUM;
+
+typedef struct 
+{
+unsigned int     sfmode_pattern0:32;
+}SFMODE_PATTERN0;
+
+typedef struct 
+{
+unsigned int     sfmode_pattern1:32;
+}SFMODE_PATTERN1;
+
+typedef struct 
+{
+unsigned int     sfmode_pattern2:32;
+}SFMODE_PATTERN2;
+
+typedef struct 
+{
+unsigned int     sfmode_pattern3:32;
+}SFMODE_PATTERN3;
+
+typedef struct 
+{
+unsigned int     sfmode_cmp_rlt0:32;
+}SFMODE_CMP_RLT0;
+
+typedef struct 
+{
+unsigned int     sfmode_cmp_rlt1:32;
+}SFMODE_CMP_RLT1;
+
+typedef struct 
+{
+unsigned int     sfmode_cmp_rlt2:32;
+}SFMODE_CMP_RLT2;
+
+typedef struct 
+{
+unsigned int     sfmode_cmp_rlt3:32;
+}SFMODE_CMP_RLT3;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     disable_2nd_channel:1;
+unsigned int     full_transfer:1;
+}DC_64_WRITE_BUF_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     sync_cmd_cnt_threshold:3;
+unsigned int     cmd_buf_threshold:4;
+unsigned int     disable_2nd_channel:1;
+unsigned int     ever_full:1;
+unsigned int     ever_reach_threshold:1;
+unsigned int     max_buf_level:7;
+unsigned int     grant_stop_level:7;
+}DC_64_READ_BUF_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     pict_set_int_cpu:2;
+unsigned int     int_enable:1;
+unsigned int     ever_set_as_odd:1;
+unsigned int     enable:1;
+}DC_PIC_OFFSET_X_DETECTION;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     bist_en_0:1;
+unsigned int     drf_bist_en_0:1;
+unsigned int     drf_test_resume_0:1;
+unsigned int     reserved_1:1;
+unsigned int     RMEA:1;
+unsigned int     RMA_3:1;
+unsigned int     RMA_2:1;
+unsigned int     RMA_1:1;
+unsigned int     RMA_0:1;
+unsigned int     reserved_2:3;
+unsigned int     RMEB:1;
+unsigned int     RMB_3:1;
+unsigned int     RMB_2:1;
+unsigned int     RMB_1:1;
+unsigned int     RMB_0:1;
+}PHY_BIST_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     mbist_st:1;
+unsigned int     bist_fail:1;
+unsigned int     bist_done:1;
+}PHY_BIST0_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_fail:1;
+unsigned int     drf_done:1;
+}PHY_DRF0_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     mbist_st:1;
+unsigned int     bist_fail:1;
+unsigned int     bist_done:1;
+}PHY_BIST1_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_fail:1;
+unsigned int     drf_done:1;
+}PHY_DRF1_ST;
+
+typedef struct 
+{
+unsigned int     bist_en_0:1;
+unsigned int     drf_bist_en_0:1;
+unsigned int     drf_test_resume_0:1;
+unsigned int     bist_en_1:1;
+unsigned int     drf_bist_en_1:1;
+unsigned int     drf_test_resume_1:1;
+unsigned int     reserved_0:5;
+unsigned int     DVSE_A:1;
+unsigned int     DVS_A_3:1;
+unsigned int     DVS_A_2:1;
+unsigned int     DVS_A_1:1;
+unsigned int     DVS_A_0:1;
+unsigned int     reserved_1:8;
+unsigned int     reserved_2:3;
+unsigned int     DVSE:1;
+unsigned int     DVS_3:1;
+unsigned int     DVS_2:1;
+unsigned int     DVS_1:1;
+unsigned int     DVS_0:1;
+}BIST_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     mbist_st:1;
+unsigned int     bist_fail1:1;
+unsigned int     bist_fail0:1;
+unsigned int     bist_done:1;
+}BIST0_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:13;
+unsigned int     drf_fail1:1;
+unsigned int     drf_fail0:1;
+unsigned int     drf_done:1;
+}DRF0_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     mbist_st:1;
+unsigned int     bist_fail0:1;
+unsigned int     bist_done:1;
+}BIST1_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_fail0:1;
+unsigned int     drf_done:1;
+}DRF1_ST;
+
+typedef struct 
+{
+unsigned int     dummy_reg0:32;
+}DUMMY_REG0;
+
+typedef struct 
+{
+unsigned int     dummy_reg1:32;
+}DUMMY_REG1;
+
+typedef struct 
+{
+unsigned int     dummy_reg2:32;
+}DUMMY_REG2;
+
+typedef struct 
+{
+unsigned int     dummy_reg3:32;
+}DUMMY_REG3;
+
+typedef struct 
+{
+unsigned int     mem_type:2;
+unsigned int     saddr:26;
+unsigned int     reserved_0:4;
+}DC_MT_SADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     eaddr:26;
+unsigned int     reserved_1:5;
+}DC_MT_EADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable0:1;
+unsigned int     access_type_0:2;
+unsigned int     access_type_1:2;
+unsigned int     access_type_2:2;
+unsigned int     access_type_3:2;
+unsigned int     write_enable1:1;
+unsigned int     int1:1;
+unsigned int     write_enable2:1;
+unsigned int     int2:1;
+unsigned int     write_enable3:1;
+unsigned int     int3:1;
+unsigned int     write_enable4:1;
+unsigned int     cpu:2;
+unsigned int     int1_en:1;
+unsigned int     int2_en:1;
+unsigned int     int3_en:1;
+unsigned int     write_enable5:1;
+unsigned int     mode:2;
+}DC_MT_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     module_ID_0:7;
+unsigned int     module_ID_1:7;
+unsigned int     module_ID_2:7;
+unsigned int     module_ID_3:7;
+}DC_MT_TABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     ever_trap:1;
+unsigned int     module_ID:7;
+unsigned int     addcmd:14;
+}DC_MT_ADDCMD_HI;
+
+typedef struct 
+{
+unsigned int     addcmd:32;
+}DC_MT_ADDCMD_LO;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     enable_block_info:1;
+unsigned int     disable_cross_range_check:1;
+}DC_MT_MISC;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     write_enable4:1;
+unsigned int     error_cmd_int_cpu:2;
+unsigned int     write_enable3:1;
+unsigned int     error_cmd_int_en:1;
+unsigned int     write_enable2:1;
+unsigned int     error_cmd_swap_en:1;
+unsigned int     write_enable1:1;
+unsigned int     error_cmd_detection_en:1;
+}DC_EC_CTRL;
+
+typedef struct 
+{
+unsigned int     error_cmd_int:1;
+unsigned int     error_cmd_ever_trap:1;
+unsigned int     trap_case:8;
+unsigned int     Addcmd_hi:22;
+}DC_EC_ADDCMD_HI;
+
+typedef struct 
+{
+unsigned int     Addcmd_lo:32;
+}DC_EC_ADDCMD_LO;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     write_enable3:1;
+unsigned int     tag_check_int_cpu:2;
+unsigned int     write_enable2:1;
+unsigned int     tag_check_int_en:1;
+unsigned int     write_enable1:1;
+unsigned int     tag_check_en:1;
+}DC_RD_TAG_CHECK;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     rd_tag_mismatch_ever:1;
+unsigned int     rd_tag_mismatch_int:1;
+}DC_RD_TAG_CHECK_ST;
+
+typedef struct 
+{
+unsigned int     write_enable0:1;
+unsigned int     rd_only_0_sel:1;
+unsigned int     blk_protect_0_sel:1;
+unsigned int     protect_0_sel:1;
+unsigned int     write_enable1:1;
+unsigned int     rd_only_3_en:1;
+unsigned int     rd_only_2_en:1;
+unsigned int     rd_only_1_en:1;
+unsigned int     rd_only_0_en:1;
+unsigned int     write_enable2:1;
+unsigned int     blk_protect_1_wpro_en:1;
+unsigned int     blk_protect_0_wpro_en:1;
+unsigned int     blk_protect_1_en:1;
+unsigned int     blk_protect_0_en:1;
+unsigned int     write_enable3:1;
+unsigned int     protect_7_wpro_en:1;
+unsigned int     protect_6_wpro_en:1;
+unsigned int     protect_5_wpro_en:1;
+unsigned int     protect_4_wpro_en:1;
+unsigned int     protect_3_wpro_en:1;
+unsigned int     protect_2_wpro_en:1;
+unsigned int     protect_1_wpro_en:1;
+unsigned int     protect_0_wpro_en:1;
+unsigned int     write_enable4:1;
+unsigned int     protect_7_en:1;
+unsigned int     protect_6_en:1;
+unsigned int     protect_5_en:1;
+unsigned int     protect_4_en:1;
+unsigned int     protect_3_en:1;
+unsigned int     protect_2_en:1;
+unsigned int     protect_1_en:1;
+unsigned int     protect_0_en:1;
+}DC_MEM_PROTECT_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     y_limit:1;
+unsigned int     bank_remap_enable:1;
+unsigned int     tp_scramble_en:1;
+unsigned int     video_dec_scramble_en:1;
+unsigned int     audio_scramble_en:1;
+unsigned int     scpu_scramble_en:1;
+unsigned int     scramble_all_en:1;
+unsigned int     scramble_7_en:1;
+unsigned int     scramble_6_en:1;
+unsigned int     scramble_5_en:1;
+unsigned int     scramble_4_en:1;
+unsigned int     scramble_3_en:1;
+unsigned int     scramble_2_en:1;
+unsigned int     scramble_1_en:1;
+unsigned int     scramble_0_en:1;
+}DC_MEM_SCRAMBLE_CTRL;
+
+typedef struct 
+{
+unsigned int     saddr0:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_SADDR0;
+
+typedef struct 
+{
+unsigned int     eaddr0:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_EADDR0;
+
+typedef struct 
+{
+unsigned int     saddr1:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_SADDR1;
+
+typedef struct 
+{
+unsigned int     eaddr1:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_EADDR1;
+
+typedef struct 
+{
+unsigned int     saddr2:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_SADDR2;
+
+typedef struct 
+{
+unsigned int     eaddr2:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_EADDR2;
+
+typedef struct 
+{
+unsigned int     saddr3:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_SADDR3;
+
+typedef struct 
+{
+unsigned int     eaddr3:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_EADDR3;
+
+typedef struct 
+{
+unsigned int     saddr4:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_SADDR4;
+
+typedef struct 
+{
+unsigned int     eaddr4:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_EADDR4;
+
+typedef struct 
+{
+unsigned int     saddr5:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_SADDR5;
+
+typedef struct 
+{
+unsigned int     eaddr5:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_EADDR5;
+
+typedef struct 
+{
+unsigned int     saddr6:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_SADDR6;
+
+typedef struct 
+{
+unsigned int     eaddr6:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_EADDR6;
+
+typedef struct 
+{
+unsigned int     saddr7:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_SADDR7;
+
+typedef struct 
+{
+unsigned int     eaddr7:20;
+unsigned int     reserved_0:12;
+}DC_MEM_PROTECT_EADDR7;
+
+typedef struct 
+{
+unsigned int     saddr0:20;
+unsigned int     reserved_0:12;
+}DC_BLK_PROTECT_SADDR0;
+
+typedef struct 
+{
+unsigned int     eaddr0:20;
+unsigned int     reserved_0:12;
+}DC_BLK_PROTECT_EADDR0;
+
+typedef struct 
+{
+unsigned int     saddr1:20;
+unsigned int     reserved_0:12;
+}DC_BLK_PROTECT_SADDR1;
+
+typedef struct 
+{
+unsigned int     eaddr1:20;
+unsigned int     reserved_0:12;
+}DC_BLK_PROTECT_EADDR1;
+
+typedef struct 
+{
+unsigned int     saddr0:20;
+unsigned int     reserved_0:12;
+}DC_RO_PROTECT_SADDR0;
+
+typedef struct 
+{
+unsigned int     eaddr0:20;
+unsigned int     reserved_0:12;
+}DC_RO_PROTECT_EADDR0;
+
+typedef struct 
+{
+unsigned int     saddr1:20;
+unsigned int     reserved_0:12;
+}DC_RO_PROTECT_SADDR1;
+
+typedef struct 
+{
+unsigned int     eaddr1:20;
+unsigned int     reserved_0:12;
+}DC_RO_PROTECT_EADDR1;
+
+typedef struct 
+{
+unsigned int     saddr2:20;
+unsigned int     reserved_0:12;
+}DC_RO_PROTECT_SADDR2;
+
+typedef struct 
+{
+unsigned int     eaddr2:20;
+unsigned int     reserved_0:12;
+}DC_RO_PROTECT_EADDR2;
+
+typedef struct 
+{
+unsigned int     saddr3:20;
+unsigned int     reserved_0:12;
+}DC_RO_PROTECT_SADDR3;
+
+typedef struct 
+{
+unsigned int     eaddr3:20;
+unsigned int     reserved_0:12;
+}DC_RO_PROTECT_EADDR3;
+
+typedef struct 
+{
+unsigned int     saddr0:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_SADDR0;
+
+typedef struct 
+{
+unsigned int     eaddr0:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_EADDR0;
+
+typedef struct 
+{
+unsigned int     saddr1:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_SADDR1;
+
+typedef struct 
+{
+unsigned int     eaddr1:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_EADDR1;
+
+typedef struct 
+{
+unsigned int     saddr2:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_SADDR2;
+
+typedef struct 
+{
+unsigned int     eaddr2:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_EADDR2;
+
+typedef struct 
+{
+unsigned int     saddr3:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_SADDR3;
+
+typedef struct 
+{
+unsigned int     eaddr3:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_EADDR3;
+
+typedef struct 
+{
+unsigned int     saddr4:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_SADDR4;
+
+typedef struct 
+{
+unsigned int     eaddr4:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_EADDR4;
+
+typedef struct 
+{
+unsigned int     saddr5:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_SADDR5;
+
+typedef struct 
+{
+unsigned int     eaddr5:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_EADDR5;
+
+typedef struct 
+{
+unsigned int     saddr6:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_SADDR6;
+
+typedef struct 
+{
+unsigned int     eaddr6:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_EADDR6;
+
+typedef struct 
+{
+unsigned int     saddr7:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_SADDR7;
+
+typedef struct 
+{
+unsigned int     eaddr7:20;
+unsigned int     reserved_0:12;
+}DC_MEM_SCRAMBLE_EADDR7;
+
+typedef struct 
+{
+unsigned int     md_tee_protect_en:8;
+unsigned int     cp_tee_protect_en:8;
+unsigned int     vo_protect_en:8;
+unsigned int     nf_tee_protect_en:8;
+}DC_MEM_PROTECT_ID_CTRL_0;
+
+typedef struct 
+{
+unsigned int     scpu_tee_protect_en:8;
+unsigned int     acpu_protect_en:8;
+unsigned int     video_protect_en:8;
+unsigned int     audio_protect_en:8;
+}DC_MEM_PROTECT_ID_CTRL_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     scpu_tee_blk_protect_en:2;
+unsigned int     acpu_blk_protect_en:2;
+unsigned int     video_blk_protect_en:2;
+unsigned int     audio_blk_protect_en:2;
+unsigned int     md_tee_blk_protect_en:2;
+unsigned int     cp_tee_blk_protect_en:2;
+unsigned int     vo_blk_protect_en:2;
+unsigned int     nf_tee_blk_protect_en:2;
+}DC_MEM_PROTECT_ID_CTRL_2;
+
+typedef struct 
+{
+unsigned int     scpu_tee_ro_protect_en:4;
+unsigned int     acpu_ro_protect_en:4;
+unsigned int     video_ro_protect_en:4;
+unsigned int     audio_ro_protect_en:4;
+unsigned int     md_tee_ro_protect_en:4;
+unsigned int     cp_tee_ro_protect_en:4;
+unsigned int     vo_ro_protect_en:4;
+unsigned int     nf_tee_ro_protect_en:4;
+}DC_MEM_PROTECT_ID_CTRL_3;
+
+typedef struct 
+{
+unsigned int     blk_pict_set_chk_en_0:32;
+}DC_MEM_PROTECT_PICT_CTRL_0;
+
+typedef struct 
+{
+unsigned int     blk_pict_set_chk_en_1:32;
+}DC_MEM_PROTECT_PICT_CTRL_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     dram_16g_used:1;
+unsigned int     dram_8g_used:1;
+unsigned int     dram_4g_used:1;
+unsigned int     dram_2g_used:1;
+unsigned int     dram_1g_used:1;
+unsigned int     dram_512_used:1;
+}DC_SECURE_MISC;
+
+typedef struct 
+{
+unsigned int     write_enable9:1;
+unsigned int     int_kcpu_key_up_en:1;
+unsigned int     write_enable8:1;
+unsigned int     int_kcpu_key_up:1;
+unsigned int     write_enable7:1;
+unsigned int     key_up_status:3;
+unsigned int     write_enable6:1;
+unsigned int     scramble_int_en:1;
+unsigned int     write_enable5:1;
+unsigned int     scramble_int:1;
+unsigned int     write_enable4:1;
+unsigned int     scramble_id:7;
+unsigned int     write_enable3:1;
+unsigned int     protect_int_en:1;
+unsigned int     write_enable2:1;
+unsigned int     protect_int:1;
+unsigned int     write_enable1:1;
+unsigned int     protect_id:7;
+}DC_MEM_INT;
+
+typedef struct 
+{
+unsigned int     write_enable10:1;
+unsigned int     x_overflow_int_en:1;
+unsigned int     write_enable9:1;
+unsigned int     x_overflow_int:1;
+unsigned int     write_enable8:1;
+unsigned int     y_overflow_int_en:1;
+unsigned int     write_enable7:1;
+unsigned int     y_overflow_int:1;
+unsigned int     write_enable6:1;
+unsigned int     scramble_align_int_en:1;
+unsigned int     write_enable5:1;
+unsigned int     scramble_align_int:1;
+unsigned int     write_enable4:1;
+unsigned int     blk_picset_int_en:1;
+unsigned int     write_enable3:1;
+unsigned int     blk_picset_int:1;
+unsigned int     reserved_0:3;
+unsigned int     write_enable2:1;
+unsigned int     region:3;
+unsigned int     write_enable1:1;
+unsigned int     pict_set_num:8;
+}DC_MEM_OTHER_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     blk_overflow_k_en:1;
+unsigned int     blk_overflow_s_en:1;
+unsigned int     blk_protect_k_en:1;
+unsigned int     blk_protect_s_en:1;
+unsigned int     error_k_en:1;
+unsigned int     error_s_en:1;
+unsigned int     mem_trash_k_en:1;
+unsigned int     mem_trash_s_en:1;
+}DC_INT_SEL;
+
+#endif
+
+#define DC_PICT_SET                                                                  0x18008000
+#define DC_PICT_SET_reg_addr                                                         "0xB8008000"
+#define DC_PICT_SET_reg                                                              0xB8008000
+#define set_DC_PICT_SET_reg(data)   (*((volatile unsigned int*) DC_PICT_SET_reg)=data)
+#define get_DC_PICT_SET_reg   (*((volatile unsigned int*) DC_PICT_SET_reg))
+#define DC_PICT_SET_inst_adr                                                         "0x0000"
+#define DC_PICT_SET_inst                                                             0x0000
+#define DC_PICT_SET_pict_width_scale_shift                                           (17)
+#define DC_PICT_SET_pict_width_scale_mask                                            (0x007E0000)
+#define DC_PICT_SET_pict_width_scale(data)                                           (0x007E0000&((data)<<17))
+#define DC_PICT_SET_pict_width_scale_src(data)                                       ((0x007E0000&(data))>>17)
+#define DC_PICT_SET_get_pict_width_scale(data)                                       ((0x007E0000&(data))>>17)
+#define DC_PICT_SET_pict_init_page_shift                                             (0)
+#define DC_PICT_SET_pict_init_page_mask                                              (0x0001FFFF)
+#define DC_PICT_SET_pict_init_page(data)                                             (0x0001FFFF&((data)<<0))
+#define DC_PICT_SET_pict_init_page_src(data)                                         ((0x0001FFFF&(data))>>0)
+#define DC_PICT_SET_get_pict_init_page(data)                                         ((0x0001FFFF&(data))>>0)
+
+
+#define DC_SYS_MISC                                                                  0x18008004
+#define DC_SYS_MISC_reg_addr                                                         "0xB8008004"
+#define DC_SYS_MISC_reg                                                              0xB8008004
+#define set_DC_SYS_MISC_reg(data)   (*((volatile unsigned int*) DC_SYS_MISC_reg)=data)
+#define get_DC_SYS_MISC_reg   (*((volatile unsigned int*) DC_SYS_MISC_reg))
+#define DC_SYS_MISC_inst_adr                                                         "0x0001"
+#define DC_SYS_MISC_inst                                                             0x0001
+#define DC_SYS_MISC_dram_8g_used_shift                                               (28)
+#define DC_SYS_MISC_dram_8g_used_mask                                                (0x10000000)
+#define DC_SYS_MISC_dram_8g_used(data)                                               (0x10000000&((data)<<28))
+#define DC_SYS_MISC_dram_8g_used_src(data)                                           ((0x10000000&(data))>>28)
+#define DC_SYS_MISC_get_dram_8g_used(data)                                           ((0x10000000&(data))>>28)
+#define DC_SYS_MISC_dram_4g_used_shift                                               (27)
+#define DC_SYS_MISC_dram_4g_used_mask                                                (0x08000000)
+#define DC_SYS_MISC_dram_4g_used(data)                                               (0x08000000&((data)<<27))
+#define DC_SYS_MISC_dram_4g_used_src(data)                                           ((0x08000000&(data))>>27)
+#define DC_SYS_MISC_get_dram_4g_used(data)                                           ((0x08000000&(data))>>27)
+#define DC_SYS_MISC_ddr3_512_used_shift                                              (26)
+#define DC_SYS_MISC_ddr3_512_used_mask                                               (0x04000000)
+#define DC_SYS_MISC_ddr3_512_used(data)                                              (0x04000000&((data)<<26))
+#define DC_SYS_MISC_ddr3_512_used_src(data)                                          ((0x04000000&(data))>>26)
+#define DC_SYS_MISC_get_ddr3_512_used(data)                                          ((0x04000000&(data))>>26)
+#define DC_SYS_MISC_dram_2g_used_shift                                               (25)
+#define DC_SYS_MISC_dram_2g_used_mask                                                (0x02000000)
+#define DC_SYS_MISC_dram_2g_used(data)                                               (0x02000000&((data)<<25))
+#define DC_SYS_MISC_dram_2g_used_src(data)                                           ((0x02000000&(data))>>25)
+#define DC_SYS_MISC_get_dram_2g_used(data)                                           ((0x02000000&(data))>>25)
+#define DC_SYS_MISC_pre_arb_scheme_sel_shift                                         (24)
+#define DC_SYS_MISC_pre_arb_scheme_sel_mask                                          (0x01000000)
+#define DC_SYS_MISC_pre_arb_scheme_sel(data)                                         (0x01000000&((data)<<24))
+#define DC_SYS_MISC_pre_arb_scheme_sel_src(data)                                     ((0x01000000&(data))>>24)
+#define DC_SYS_MISC_get_pre_arb_scheme_sel(data)                                     ((0x01000000&(data))>>24)
+#define DC_SYS_MISC_ve_cmd_grp_disable_shift                                         (23)
+#define DC_SYS_MISC_ve_cmd_grp_disable_mask                                          (0x00800000)
+#define DC_SYS_MISC_ve_cmd_grp_disable(data)                                         (0x00800000&((data)<<23))
+#define DC_SYS_MISC_ve_cmd_grp_disable_src(data)                                     ((0x00800000&(data))>>23)
+#define DC_SYS_MISC_get_ve_cmd_grp_disable(data)                                     ((0x00800000&(data))>>23)
+#define DC_SYS_MISC_ddr3_mapping_en_shift                                            (22)
+#define DC_SYS_MISC_ddr3_mapping_en_mask                                             (0x00400000)
+#define DC_SYS_MISC_ddr3_mapping_en(data)                                            (0x00400000&((data)<<22))
+#define DC_SYS_MISC_ddr3_mapping_en_src(data)                                        ((0x00400000&(data))>>22)
+#define DC_SYS_MISC_get_ddr3_mapping_en(data)                                        ((0x00400000&(data))>>22)
+#define DC_SYS_MISC_self_lookback_mode_shift                                         (20)
+#define DC_SYS_MISC_self_lookback_mode_mask                                          (0x00100000)
+#define DC_SYS_MISC_self_lookback_mode(data)                                         (0x00100000&((data)<<20))
+#define DC_SYS_MISC_self_lookback_mode_src(data)                                     ((0x00100000&(data))>>20)
+#define DC_SYS_MISC_get_self_lookback_mode(data)                                     ((0x00100000&(data))>>20)
+#define DC_SYS_MISC_mem_num_shift                                                    (19)
+#define DC_SYS_MISC_mem_num_mask                                                     (0x00080000)
+#define DC_SYS_MISC_mem_num(data)                                                    (0x00080000&((data)<<19))
+#define DC_SYS_MISC_mem_num_src(data)                                                ((0x00080000&(data))>>19)
+#define DC_SYS_MISC_get_mem_num(data)                                                ((0x00080000&(data))>>19)
+#define DC_SYS_MISC_page_size_shift                                                  (16)
+#define DC_SYS_MISC_page_size_mask                                                   (0x00030000)
+#define DC_SYS_MISC_page_size(data)                                                  (0x00030000&((data)<<16))
+#define DC_SYS_MISC_page_size_src(data)                                              ((0x00030000&(data))>>16)
+#define DC_SYS_MISC_get_page_size(data)                                              ((0x00030000&(data))>>16)
+#define DC_SYS_MISC_pre_arb_rd_cnt_shift                                             (8)
+#define DC_SYS_MISC_pre_arb_rd_cnt_mask                                              (0x0000FF00)
+#define DC_SYS_MISC_pre_arb_rd_cnt(data)                                             (0x0000FF00&((data)<<8))
+#define DC_SYS_MISC_pre_arb_rd_cnt_src(data)                                         ((0x0000FF00&(data))>>8)
+#define DC_SYS_MISC_get_pre_arb_rd_cnt(data)                                         ((0x0000FF00&(data))>>8)
+#define DC_SYS_MISC_pre_arb_wr_cnt_shift                                             (0)
+#define DC_SYS_MISC_pre_arb_wr_cnt_mask                                              (0x000000FF)
+#define DC_SYS_MISC_pre_arb_wr_cnt(data)                                             (0x000000FF&((data)<<0))
+#define DC_SYS_MISC_pre_arb_wr_cnt_src(data)                                         ((0x000000FF&(data))>>0)
+#define DC_SYS_MISC_get_pre_arb_wr_cnt(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define PRIORITY_CTRL_0                                                              0x18008008
+#define PRIORITY_CTRL_0_reg_addr                                                     "0xB8008008"
+#define PRIORITY_CTRL_0_reg                                                          0xB8008008
+#define set_PRIORITY_CTRL_0_reg(data)   (*((volatile unsigned int*) PRIORITY_CTRL_0_reg)=data)
+#define get_PRIORITY_CTRL_0_reg   (*((volatile unsigned int*) PRIORITY_CTRL_0_reg))
+#define PRIORITY_CTRL_0_inst_adr                                                     "0x0002"
+#define PRIORITY_CTRL_0_inst                                                         0x0002
+#define PRIORITY_CTRL_0_scpu_pri_shift                                               (28)
+#define PRIORITY_CTRL_0_scpu_pri_mask                                                (0xF0000000)
+#define PRIORITY_CTRL_0_scpu_pri(data)                                               (0xF0000000&((data)<<28))
+#define PRIORITY_CTRL_0_scpu_pri_src(data)                                           ((0xF0000000&(data))>>28)
+#define PRIORITY_CTRL_0_get_scpu_pri(data)                                           ((0xF0000000&(data))>>28)
+#define PRIORITY_CTRL_0_mipi_pri_shift                                               (24)
+#define PRIORITY_CTRL_0_mipi_pri_mask                                                (0x0F000000)
+#define PRIORITY_CTRL_0_mipi_pri(data)                                               (0x0F000000&((data)<<24))
+#define PRIORITY_CTRL_0_mipi_pri_src(data)                                           ((0x0F000000&(data))>>24)
+#define PRIORITY_CTRL_0_get_mipi_pri(data)                                           ((0x0F000000&(data))>>24)
+#define PRIORITY_CTRL_0_vo_high_pri_shift                                            (16)
+#define PRIORITY_CTRL_0_vo_high_pri_mask                                             (0x000F0000)
+#define PRIORITY_CTRL_0_vo_high_pri(data)                                            (0x000F0000&((data)<<16))
+#define PRIORITY_CTRL_0_vo_high_pri_src(data)                                        ((0x000F0000&(data))>>16)
+#define PRIORITY_CTRL_0_get_vo_high_pri(data)                                        ((0x000F0000&(data))>>16)
+#define PRIORITY_CTRL_0_sb1_high_pri_shift                                           (8)
+#define PRIORITY_CTRL_0_sb1_high_pri_mask                                            (0x00000F00)
+#define PRIORITY_CTRL_0_sb1_high_pri(data)                                           (0x00000F00&((data)<<8))
+#define PRIORITY_CTRL_0_sb1_high_pri_src(data)                                       ((0x00000F00&(data))>>8)
+#define PRIORITY_CTRL_0_get_sb1_high_pri(data)                                       ((0x00000F00&(data))>>8)
+#define PRIORITY_CTRL_0_sb0_pri_shift                                                (0)
+#define PRIORITY_CTRL_0_sb0_pri_mask                                                 (0x0000000F)
+#define PRIORITY_CTRL_0_sb0_pri(data)                                                (0x0000000F&((data)<<0))
+#define PRIORITY_CTRL_0_sb0_pri_src(data)                                            ((0x0000000F&(data))>>0)
+#define PRIORITY_CTRL_0_get_sb0_pri(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define PRIORITY_CTRL_1                                                              0x1800800C
+#define PRIORITY_CTRL_1_reg_addr                                                     "0xB800800C"
+#define PRIORITY_CTRL_1_reg                                                          0xB800800C
+#define set_PRIORITY_CTRL_1_reg(data)   (*((volatile unsigned int*) PRIORITY_CTRL_1_reg)=data)
+#define get_PRIORITY_CTRL_1_reg   (*((volatile unsigned int*) PRIORITY_CTRL_1_reg))
+#define PRIORITY_CTRL_1_inst_adr                                                     "0x0003"
+#define PRIORITY_CTRL_1_inst                                                         0x0003
+#define PRIORITY_CTRL_1_sb3_high_pri_shift                                           (24)
+#define PRIORITY_CTRL_1_sb3_high_pri_mask                                            (0x0F000000)
+#define PRIORITY_CTRL_1_sb3_high_pri(data)                                           (0x0F000000&((data)<<24))
+#define PRIORITY_CTRL_1_sb3_high_pri_src(data)                                       ((0x0F000000&(data))>>24)
+#define PRIORITY_CTRL_1_get_sb3_high_pri(data)                                       ((0x0F000000&(data))>>24)
+#define PRIORITY_CTRL_1_vo_low_pri_shift                                             (16)
+#define PRIORITY_CTRL_1_vo_low_pri_mask                                              (0x000F0000)
+#define PRIORITY_CTRL_1_vo_low_pri(data)                                             (0x000F0000&((data)<<16))
+#define PRIORITY_CTRL_1_vo_low_pri_src(data)                                         ((0x000F0000&(data))>>16)
+#define PRIORITY_CTRL_1_get_vo_low_pri(data)                                         ((0x000F0000&(data))>>16)
+#define PRIORITY_CTRL_1_sb1_low_pri_shift                                            (8)
+#define PRIORITY_CTRL_1_sb1_low_pri_mask                                             (0x00000F00)
+#define PRIORITY_CTRL_1_sb1_low_pri(data)                                            (0x00000F00&((data)<<8))
+#define PRIORITY_CTRL_1_sb1_low_pri_src(data)                                        ((0x00000F00&(data))>>8)
+#define PRIORITY_CTRL_1_get_sb1_low_pri(data)                                        ((0x00000F00&(data))>>8)
+#define PRIORITY_CTRL_1_avk_cpu_pri_shift                                            (0)
+#define PRIORITY_CTRL_1_avk_cpu_pri_mask                                             (0x0000000F)
+#define PRIORITY_CTRL_1_avk_cpu_pri(data)                                            (0x0000000F&((data)<<0))
+#define PRIORITY_CTRL_1_avk_cpu_pri_src(data)                                        ((0x0000000F&(data))>>0)
+#define PRIORITY_CTRL_1_get_avk_cpu_pri(data)                                        ((0x0000000F&(data))>>0)
+
+
+#define PRIORITY_CTRL_2                                                              0x18008010
+#define PRIORITY_CTRL_2_reg_addr                                                     "0xB8008010"
+#define PRIORITY_CTRL_2_reg                                                          0xB8008010
+#define set_PRIORITY_CTRL_2_reg(data)   (*((volatile unsigned int*) PRIORITY_CTRL_2_reg)=data)
+#define get_PRIORITY_CTRL_2_reg   (*((volatile unsigned int*) PRIORITY_CTRL_2_reg))
+#define PRIORITY_CTRL_2_inst_adr                                                     "0x0004"
+#define PRIORITY_CTRL_2_inst                                                         0x0004
+#define PRIORITY_CTRL_2_gde_pri_shift                                                (24)
+#define PRIORITY_CTRL_2_gde_pri_mask                                                 (0x0F000000)
+#define PRIORITY_CTRL_2_gde_pri(data)                                                (0x0F000000&((data)<<24))
+#define PRIORITY_CTRL_2_gde_pri_src(data)                                            ((0x0F000000&(data))>>24)
+#define PRIORITY_CTRL_2_get_gde_pri(data)                                            ((0x0F000000&(data))>>24)
+#define PRIORITY_CTRL_2_se_pri_shift                                                 (16)
+#define PRIORITY_CTRL_2_se_pri_mask                                                  (0x000F0000)
+#define PRIORITY_CTRL_2_se_pri(data)                                                 (0x000F0000&((data)<<16))
+#define PRIORITY_CTRL_2_se_pri_src(data)                                             ((0x000F0000&(data))>>16)
+#define PRIORITY_CTRL_2_get_se_pri(data)                                             ((0x000F0000&(data))>>16)
+#define PRIORITY_CTRL_2_sb3_low_pri_shift                                            (8)
+#define PRIORITY_CTRL_2_sb3_low_pri_mask                                             (0x00000F00)
+#define PRIORITY_CTRL_2_sb3_low_pri(data)                                            (0x00000F00&((data)<<8))
+#define PRIORITY_CTRL_2_sb3_low_pri_src(data)                                        ((0x00000F00&(data))>>8)
+#define PRIORITY_CTRL_2_get_sb3_low_pri(data)                                        ((0x00000F00&(data))>>8)
+#define PRIORITY_CTRL_2_ve_pri_shift                                                 (0)
+#define PRIORITY_CTRL_2_ve_pri_mask                                                  (0x0000000F)
+#define PRIORITY_CTRL_2_ve_pri(data)                                                 (0x0000000F&((data)<<0))
+#define PRIORITY_CTRL_2_ve_pri_src(data)                                             ((0x0000000F&(data))>>0)
+#define PRIORITY_CTRL_2_get_ve_pri(data)                                             ((0x0000000F&(data))>>0)
+
+
+#define REORDER_CTRL_0                                                               0x18008014
+#define REORDER_CTRL_0_reg_addr                                                      "0xB8008014"
+#define REORDER_CTRL_0_reg                                                           0xB8008014
+#define set_REORDER_CTRL_0_reg(data)   (*((volatile unsigned int*) REORDER_CTRL_0_reg)=data)
+#define get_REORDER_CTRL_0_reg   (*((volatile unsigned int*) REORDER_CTRL_0_reg))
+#define REORDER_CTRL_0_inst_adr                                                      "0x0005"
+#define REORDER_CTRL_0_inst                                                          0x0005
+#define REORDER_CTRL_0_vo_low_tag_shift                                              (16)
+#define REORDER_CTRL_0_vo_low_tag_mask                                               (0x00030000)
+#define REORDER_CTRL_0_vo_low_tag(data)                                              (0x00030000&((data)<<16))
+#define REORDER_CTRL_0_vo_low_tag_src(data)                                          ((0x00030000&(data))>>16)
+#define REORDER_CTRL_0_get_vo_low_tag(data)                                          ((0x00030000&(data))>>16)
+#define REORDER_CTRL_0_sb1_low_tag_shift                                             (12)
+#define REORDER_CTRL_0_sb1_low_tag_mask                                              (0x00003000)
+#define REORDER_CTRL_0_sb1_low_tag(data)                                             (0x00003000&((data)<<12))
+#define REORDER_CTRL_0_sb1_low_tag_src(data)                                         ((0x00003000&(data))>>12)
+#define REORDER_CTRL_0_get_sb1_low_tag(data)                                         ((0x00003000&(data))>>12)
+#define REORDER_CTRL_0_se_tag_shift                                                  (8)
+#define REORDER_CTRL_0_se_tag_mask                                                   (0x00000300)
+#define REORDER_CTRL_0_se_tag(data)                                                  (0x00000300&((data)<<8))
+#define REORDER_CTRL_0_se_tag_src(data)                                              ((0x00000300&(data))>>8)
+#define REORDER_CTRL_0_get_se_tag(data)                                              ((0x00000300&(data))>>8)
+#define REORDER_CTRL_0_avk_cpu_tag_shift                                             (4)
+#define REORDER_CTRL_0_avk_cpu_tag_mask                                              (0x00000030)
+#define REORDER_CTRL_0_avk_cpu_tag(data)                                             (0x00000030&((data)<<4))
+#define REORDER_CTRL_0_avk_cpu_tag_src(data)                                         ((0x00000030&(data))>>4)
+#define REORDER_CTRL_0_get_avk_cpu_tag(data)                                         ((0x00000030&(data))>>4)
+#define REORDER_CTRL_0_ve_tag_shift                                                  (0)
+#define REORDER_CTRL_0_ve_tag_mask                                                   (0x00000003)
+#define REORDER_CTRL_0_ve_tag(data)                                                  (0x00000003&((data)<<0))
+#define REORDER_CTRL_0_ve_tag_src(data)                                              ((0x00000003&(data))>>0)
+#define REORDER_CTRL_0_get_ve_tag(data)                                              ((0x00000003&(data))>>0)
+
+
+#define REORDER_CTRL_1                                                               0x18008018
+#define REORDER_CTRL_1_reg_addr                                                      "0xB8008018"
+#define REORDER_CTRL_1_reg                                                           0xB8008018
+#define set_REORDER_CTRL_1_reg(data)   (*((volatile unsigned int*) REORDER_CTRL_1_reg)=data)
+#define get_REORDER_CTRL_1_reg   (*((volatile unsigned int*) REORDER_CTRL_1_reg))
+#define REORDER_CTRL_1_inst_adr                                                      "0x0006"
+#define REORDER_CTRL_1_inst                                                          0x0006
+#define REORDER_CTRL_1_sb0_tag_shift                                                 (16)
+#define REORDER_CTRL_1_sb0_tag_mask                                                  (0x00030000)
+#define REORDER_CTRL_1_sb0_tag(data)                                                 (0x00030000&((data)<<16))
+#define REORDER_CTRL_1_sb0_tag_src(data)                                             ((0x00030000&(data))>>16)
+#define REORDER_CTRL_1_get_sb0_tag(data)                                             ((0x00030000&(data))>>16)
+#define REORDER_CTRL_1_sb1_high_tag_shift                                            (12)
+#define REORDER_CTRL_1_sb1_high_tag_mask                                             (0x00003000)
+#define REORDER_CTRL_1_sb1_high_tag(data)                                            (0x00003000&((data)<<12))
+#define REORDER_CTRL_1_sb1_high_tag_src(data)                                        ((0x00003000&(data))>>12)
+#define REORDER_CTRL_1_get_sb1_high_tag(data)                                        ((0x00003000&(data))>>12)
+#define REORDER_CTRL_1_vo_high_tag_shift                                             (8)
+#define REORDER_CTRL_1_vo_high_tag_mask                                              (0x00000300)
+#define REORDER_CTRL_1_vo_high_tag(data)                                             (0x00000300&((data)<<8))
+#define REORDER_CTRL_1_vo_high_tag_src(data)                                         ((0x00000300&(data))>>8)
+#define REORDER_CTRL_1_get_vo_high_tag(data)                                         ((0x00000300&(data))>>8)
+#define REORDER_CTRL_1_sb3_high_tag_shift                                            (4)
+#define REORDER_CTRL_1_sb3_high_tag_mask                                             (0x00000030)
+#define REORDER_CTRL_1_sb3_high_tag(data)                                            (0x00000030&((data)<<4))
+#define REORDER_CTRL_1_sb3_high_tag_src(data)                                        ((0x00000030&(data))>>4)
+#define REORDER_CTRL_1_get_sb3_high_tag(data)                                        ((0x00000030&(data))>>4)
+#define REORDER_CTRL_1_sb3_low_tag_shift                                             (0)
+#define REORDER_CTRL_1_sb3_low_tag_mask                                              (0x00000003)
+#define REORDER_CTRL_1_sb3_low_tag(data)                                             (0x00000003&((data)<<0))
+#define REORDER_CTRL_1_sb3_low_tag_src(data)                                         ((0x00000003&(data))>>0)
+#define REORDER_CTRL_1_get_sb3_low_tag(data)                                         ((0x00000003&(data))>>0)
+
+
+#define DC_PROS_CTRL                                                                 0x1800801C
+#define DC_PROS_CTRL_reg_addr                                                        "0xB800801C"
+#define DC_PROS_CTRL_reg                                                             0xB800801C
+#define set_DC_PROS_CTRL_reg(data)   (*((volatile unsigned int*) DC_PROS_CTRL_reg)=data)
+#define get_DC_PROS_CTRL_reg   (*((volatile unsigned int*) DC_PROS_CTRL_reg))
+#define DC_PROS_CTRL_inst_adr                                                        "0x0007"
+#define DC_PROS_CTRL_inst                                                            0x0007
+#define DC_PROS_CTRL_split_wait_shift                                                (28)
+#define DC_PROS_CTRL_split_wait_mask                                                 (0xF0000000)
+#define DC_PROS_CTRL_split_wait(data)                                                (0xF0000000&((data)<<28))
+#define DC_PROS_CTRL_split_wait_src(data)                                            ((0xF0000000&(data))>>28)
+#define DC_PROS_CTRL_get_split_wait(data)                                            ((0xF0000000&(data))>>28)
+#define DC_PROS_CTRL_arbit_los_shift                                                 (24)
+#define DC_PROS_CTRL_arbit_los_mask                                                  (0x0F000000)
+#define DC_PROS_CTRL_arbit_los(data)                                                 (0x0F000000&((data)<<24))
+#define DC_PROS_CTRL_arbit_los_src(data)                                             ((0x0F000000&(data))>>24)
+#define DC_PROS_CTRL_get_arbit_los(data)                                             ((0x0F000000&(data))>>24)
+#define DC_PROS_CTRL_short_lxy_shift                                                 (16)
+#define DC_PROS_CTRL_short_lxy_mask                                                  (0x007F0000)
+#define DC_PROS_CTRL_short_lxy(data)                                                 (0x007F0000&((data)<<16))
+#define DC_PROS_CTRL_short_lxy_src(data)                                             ((0x007F0000&(data))>>16)
+#define DC_PROS_CTRL_get_short_lxy(data)                                             ((0x007F0000&(data))>>16)
+#define DC_PROS_CTRL_live_split_shift                                                (8)
+#define DC_PROS_CTRL_live_split_mask                                                 (0x0000FF00)
+#define DC_PROS_CTRL_live_split(data)                                                (0x0000FF00&((data)<<8))
+#define DC_PROS_CTRL_live_split_src(data)                                            ((0x0000FF00&(data))>>8)
+#define DC_PROS_CTRL_get_live_split(data)                                            ((0x0000FF00&(data))>>8)
+#define DC_PROS_CTRL_live_cflit_shift                                                (1)
+#define DC_PROS_CTRL_live_cflit_mask                                                 (0x00000002)
+#define DC_PROS_CTRL_live_cflit(data)                                                (0x00000002&((data)<<1))
+#define DC_PROS_CTRL_live_cflit_src(data)                                            ((0x00000002&(data))>>1)
+#define DC_PROS_CTRL_get_live_cflit(data)                                            ((0x00000002&(data))>>1)
+#define DC_PROS_CTRL_queue_flush_shift                                               (0)
+#define DC_PROS_CTRL_queue_flush_mask                                                (0x00000001)
+#define DC_PROS_CTRL_queue_flush(data)                                               (0x00000001&((data)<<0))
+#define DC_PROS_CTRL_queue_flush_src(data)                                           ((0x00000001&(data))>>0)
+#define DC_PROS_CTRL_get_queue_flush(data)                                           ((0x00000001&(data))>>0)
+
+
+#define DC_PICT_SET_OFFSET                                                           0x18008020
+#define DC_PICT_SET_OFFSET_reg_addr                                                  "0xB8008020"
+#define DC_PICT_SET_OFFSET_reg                                                       0xB8008020
+#define set_DC_PICT_SET_OFFSET_reg(data)   (*((volatile unsigned int*) DC_PICT_SET_OFFSET_reg)=data)
+#define get_DC_PICT_SET_OFFSET_reg   (*((volatile unsigned int*) DC_PICT_SET_OFFSET_reg))
+#define DC_PICT_SET_OFFSET_inst_adr                                                  "0x0008"
+#define DC_PICT_SET_OFFSET_inst                                                      0x0008
+#define DC_PICT_SET_OFFSET_pict_set_num_shift                                        (24)
+#define DC_PICT_SET_OFFSET_pict_set_num_mask                                         (0xFF000000)
+#define DC_PICT_SET_OFFSET_pict_set_num(data)                                        (0xFF000000&((data)<<24))
+#define DC_PICT_SET_OFFSET_pict_set_num_src(data)                                    ((0xFF000000&(data))>>24)
+#define DC_PICT_SET_OFFSET_get_pict_set_num(data)                                    ((0xFF000000&(data))>>24)
+#define DC_PICT_SET_OFFSET_pict_offset_rd_shift                                      (23)
+#define DC_PICT_SET_OFFSET_pict_offset_rd_mask                                       (0x00800000)
+#define DC_PICT_SET_OFFSET_pict_offset_rd(data)                                      (0x00800000&((data)<<23))
+#define DC_PICT_SET_OFFSET_pict_offset_rd_src(data)                                  ((0x00800000&(data))>>23)
+#define DC_PICT_SET_OFFSET_get_pict_offset_rd(data)                                  ((0x00800000&(data))>>23)
+#define DC_PICT_SET_OFFSET_pict_set_offset_y_shift                                   (10)
+#define DC_PICT_SET_OFFSET_pict_set_offset_y_mask                                    (0x000FFC00)
+#define DC_PICT_SET_OFFSET_pict_set_offset_y(data)                                   (0x000FFC00&((data)<<10))
+#define DC_PICT_SET_OFFSET_pict_set_offset_y_src(data)                               ((0x000FFC00&(data))>>10)
+#define DC_PICT_SET_OFFSET_get_pict_set_offset_y(data)                               ((0x000FFC00&(data))>>10)
+#define DC_PICT_SET_OFFSET_pict_set_offset_x_shift                                   (0)
+#define DC_PICT_SET_OFFSET_pict_set_offset_x_mask                                    (0x000003FF)
+#define DC_PICT_SET_OFFSET_pict_set_offset_x(data)                                   (0x000003FF&((data)<<0))
+#define DC_PICT_SET_OFFSET_pict_set_offset_x_src(data)                               ((0x000003FF&(data))>>0)
+#define DC_PICT_SET_OFFSET_get_pict_set_offset_x(data)                               ((0x000003FF&(data))>>0)
+
+
+#define DC_REQ_STATUS                                                                0x18008024
+#define DC_REQ_STATUS_reg_addr                                                       "0xB8008024"
+#define DC_REQ_STATUS_reg                                                            0xB8008024
+#define set_DC_REQ_STATUS_reg(data)   (*((volatile unsigned int*) DC_REQ_STATUS_reg)=data)
+#define get_DC_REQ_STATUS_reg   (*((volatile unsigned int*) DC_REQ_STATUS_reg))
+#define DC_REQ_STATUS_inst_adr                                                       "0x0009"
+#define DC_REQ_STATUS_inst                                                           0x0009
+#define DC_REQ_STATUS_req_pending_shift                                              (11)
+#define DC_REQ_STATUS_req_pending_mask                                               (0x00000800)
+#define DC_REQ_STATUS_req_pending(data)                                              (0x00000800&((data)<<11))
+#define DC_REQ_STATUS_req_pending_src(data)                                          ((0x00000800&(data))>>11)
+#define DC_REQ_STATUS_get_req_pending(data)                                          ((0x00000800&(data))>>11)
+#define DC_REQ_STATUS_req_id_shift                                                   (0)
+#define DC_REQ_STATUS_req_id_mask                                                    (0x000007FF)
+#define DC_REQ_STATUS_req_id(data)                                                   (0x000007FF&((data)<<0))
+#define DC_REQ_STATUS_req_id_src(data)                                               ((0x000007FF&(data))>>0)
+#define DC_REQ_STATUS_get_req_id(data)                                               ((0x000007FF&(data))>>0)
+
+
+#define DC_SYS_MISC2                                                                 0x18008028
+#define DC_SYS_MISC2_reg_addr                                                        "0xB8008028"
+#define DC_SYS_MISC2_reg                                                             0xB8008028
+#define set_DC_SYS_MISC2_reg(data)   (*((volatile unsigned int*) DC_SYS_MISC2_reg)=data)
+#define get_DC_SYS_MISC2_reg   (*((volatile unsigned int*) DC_SYS_MISC2_reg))
+#define DC_SYS_MISC2_inst_adr                                                        "0x000A"
+#define DC_SYS_MISC2_inst                                                            0x000A
+#define DC_SYS_MISC2_qfifo_cnt_full_threshold_shift                                  (24)
+#define DC_SYS_MISC2_qfifo_cnt_full_threshold_mask                                   (0x1F000000)
+#define DC_SYS_MISC2_qfifo_cnt_full_threshold(data)                                  (0x1F000000&((data)<<24))
+#define DC_SYS_MISC2_qfifo_cnt_full_threshold_src(data)                              ((0x1F000000&(data))>>24)
+#define DC_SYS_MISC2_get_qfifo_cnt_full_threshold(data)                              ((0x1F000000&(data))>>24)
+#define DC_SYS_MISC2_full_cmd_count_shift                                            (20)
+#define DC_SYS_MISC2_full_cmd_count_mask                                             (0x00F00000)
+#define DC_SYS_MISC2_full_cmd_count(data)                                            (0x00F00000&((data)<<20))
+#define DC_SYS_MISC2_full_cmd_count_src(data)                                        ((0x00F00000&(data))>>20)
+#define DC_SYS_MISC2_get_full_cmd_count(data)                                        ((0x00F00000&(data))>>20)
+#define DC_SYS_MISC2_pre_tra_rd_cnt_shift                                            (10)
+#define DC_SYS_MISC2_pre_tra_rd_cnt_mask                                             (0x000FFC00)
+#define DC_SYS_MISC2_pre_tra_rd_cnt(data)                                            (0x000FFC00&((data)<<10))
+#define DC_SYS_MISC2_pre_tra_rd_cnt_src(data)                                        ((0x000FFC00&(data))>>10)
+#define DC_SYS_MISC2_get_pre_tra_rd_cnt(data)                                        ((0x000FFC00&(data))>>10)
+#define DC_SYS_MISC2_pre_tra_wr_cnt_shift                                            (0)
+#define DC_SYS_MISC2_pre_tra_wr_cnt_mask                                             (0x000003FF)
+#define DC_SYS_MISC2_pre_tra_wr_cnt(data)                                            (0x000003FF&((data)<<0))
+#define DC_SYS_MISC2_pre_tra_wr_cnt_src(data)                                        ((0x000003FF&(data))>>0)
+#define DC_SYS_MISC2_get_pre_tra_wr_cnt(data)                                        ((0x000003FF&(data))>>0)
+
+
+#define DC_SYS_MISC3                                                                 0x1800802C
+#define DC_SYS_MISC3_reg_addr                                                        "0xB800802C"
+#define DC_SYS_MISC3_reg                                                             0xB800802C
+#define set_DC_SYS_MISC3_reg(data)   (*((volatile unsigned int*) DC_SYS_MISC3_reg)=data)
+#define get_DC_SYS_MISC3_reg   (*((volatile unsigned int*) DC_SYS_MISC3_reg))
+#define DC_SYS_MISC3_inst_adr                                                        "0x000B"
+#define DC_SYS_MISC3_inst                                                            0x000B
+#define DC_SYS_MISC3_gpu_wdata_queue_flush_shift                                     (6)
+#define DC_SYS_MISC3_gpu_wdata_queue_flush_mask                                      (0x00000040)
+#define DC_SYS_MISC3_gpu_wdata_queue_flush(data)                                     (0x00000040&((data)<<6))
+#define DC_SYS_MISC3_gpu_wdata_queue_flush_src(data)                                 ((0x00000040&(data))>>6)
+#define DC_SYS_MISC3_get_gpu_wdata_queue_flush(data)                                 ((0x00000040&(data))>>6)
+#define DC_SYS_MISC3_enable_arb_delay_by_tv_sb1_grant_shift                          (2)
+#define DC_SYS_MISC3_enable_arb_delay_by_tv_sb1_grant_mask                           (0x00000004)
+#define DC_SYS_MISC3_enable_arb_delay_by_tv_sb1_grant(data)                          (0x00000004&((data)<<2))
+#define DC_SYS_MISC3_enable_arb_delay_by_tv_sb1_grant_src(data)                      ((0x00000004&(data))>>2)
+#define DC_SYS_MISC3_get_enable_arb_delay_by_tv_sb1_grant(data)                      ((0x00000004&(data))>>2)
+#define DC_SYS_MISC3_gpu_cmd_queue_flush_shift                                       (1)
+#define DC_SYS_MISC3_gpu_cmd_queue_flush_mask                                        (0x00000002)
+#define DC_SYS_MISC3_gpu_cmd_queue_flush(data)                                       (0x00000002&((data)<<1))
+#define DC_SYS_MISC3_gpu_cmd_queue_flush_src(data)                                   ((0x00000002&(data))>>1)
+#define DC_SYS_MISC3_get_gpu_cmd_queue_flush(data)                                   ((0x00000002&(data))>>1)
+#define DC_SYS_MISC3_gde_cmd_grp_disable_shift                                       (0)
+#define DC_SYS_MISC3_gde_cmd_grp_disable_mask                                        (0x00000001)
+#define DC_SYS_MISC3_gde_cmd_grp_disable(data)                                       (0x00000001&((data)<<0))
+#define DC_SYS_MISC3_gde_cmd_grp_disable_src(data)                                   ((0x00000001&(data))>>0)
+#define DC_SYS_MISC3_get_gde_cmd_grp_disable(data)                                   ((0x00000001&(data))>>0)
+
+
+#define DC_PC_CTRL                                                                   0x18008030
+#define DC_PC_CTRL_reg_addr                                                          "0xB8008030"
+#define DC_PC_CTRL_reg                                                               0xB8008030
+#define set_DC_PC_CTRL_reg(data)   (*((volatile unsigned int*) DC_PC_CTRL_reg)=data)
+#define get_DC_PC_CTRL_reg   (*((volatile unsigned int*) DC_PC_CTRL_reg))
+#define DC_PC_CTRL_inst_adr                                                          "0x000C"
+#define DC_PC_CTRL_inst                                                              0x000C
+#define DC_PC_CTRL_pc_go_shift                                                       (0)
+#define DC_PC_CTRL_pc_go_mask                                                        (0x00000001)
+#define DC_PC_CTRL_pc_go(data)                                                       (0x00000001&((data)<<0))
+#define DC_PC_CTRL_pc_go_src(data)                                                   ((0x00000001&(data))>>0)
+#define DC_PC_CTRL_get_pc_go(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define DC_PC_TOTA_MON_NUM                                                           0x18008034
+#define DC_PC_TOTA_MON_NUM_reg_addr                                                  "0xB8008034"
+#define DC_PC_TOTA_MON_NUM_reg                                                       0xB8008034
+#define set_DC_PC_TOTA_MON_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_TOTA_MON_NUM_reg)=data)
+#define get_DC_PC_TOTA_MON_NUM_reg   (*((volatile unsigned int*) DC_PC_TOTA_MON_NUM_reg))
+#define DC_PC_TOTA_MON_NUM_inst_adr                                                  "0x000D"
+#define DC_PC_TOTA_MON_NUM_inst                                                      0x000D
+#define DC_PC_TOTA_MON_NUM_pc_tota_mon_num_shift                                     (0)
+#define DC_PC_TOTA_MON_NUM_pc_tota_mon_num_mask                                      (0xFFFFFFFF)
+#define DC_PC_TOTA_MON_NUM_pc_tota_mon_num(data)                                     (0xFFFFFFFF&((data)<<0))
+#define DC_PC_TOTA_MON_NUM_pc_tota_mon_num_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_TOTA_MON_NUM_get_pc_tota_mon_num(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_TOTA_ACK_NUM                                                           0x18008038
+#define DC_PC_TOTA_ACK_NUM_reg_addr                                                  "0xB8008038"
+#define DC_PC_TOTA_ACK_NUM_reg                                                       0xB8008038
+#define set_DC_PC_TOTA_ACK_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_TOTA_ACK_NUM_reg)=data)
+#define get_DC_PC_TOTA_ACK_NUM_reg   (*((volatile unsigned int*) DC_PC_TOTA_ACK_NUM_reg))
+#define DC_PC_TOTA_ACK_NUM_inst_adr                                                  "0x000E"
+#define DC_PC_TOTA_ACK_NUM_inst                                                      0x000E
+#define DC_PC_TOTA_ACK_NUM_pc_tota_ack_num_shift                                     (0)
+#define DC_PC_TOTA_ACK_NUM_pc_tota_ack_num_mask                                      (0xFFFFFFFF)
+#define DC_PC_TOTA_ACK_NUM_pc_tota_ack_num(data)                                     (0xFFFFFFFF&((data)<<0))
+#define DC_PC_TOTA_ACK_NUM_pc_tota_ack_num_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_TOTA_ACK_NUM_get_pc_tota_ack_num(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_TOTA_IDL_NUM                                                           0x1800803C
+#define DC_PC_TOTA_IDL_NUM_reg_addr                                                  "0xB800803C"
+#define DC_PC_TOTA_IDL_NUM_reg                                                       0xB800803C
+#define set_DC_PC_TOTA_IDL_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_TOTA_IDL_NUM_reg)=data)
+#define get_DC_PC_TOTA_IDL_NUM_reg   (*((volatile unsigned int*) DC_PC_TOTA_IDL_NUM_reg))
+#define DC_PC_TOTA_IDL_NUM_inst_adr                                                  "0x000F"
+#define DC_PC_TOTA_IDL_NUM_inst                                                      0x000F
+#define DC_PC_TOTA_IDL_NUM_pc_tota_idl_num_shift                                     (0)
+#define DC_PC_TOTA_IDL_NUM_pc_tota_idl_num_mask                                      (0xFFFFFFFF)
+#define DC_PC_TOTA_IDL_NUM_pc_tota_idl_num(data)                                     (0xFFFFFFFF&((data)<<0))
+#define DC_PC_TOTA_IDL_NUM_pc_tota_idl_num_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_TOTA_IDL_NUM_get_pc_tota_idl_num(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_CTRL                                                         0x18008040
+#define DC_PC_SYSH_PROG_CTRL_reg_addr                                                "0xB8008040"
+#define DC_PC_SYSH_PROG_CTRL_reg                                                     0xB8008040
+#define set_DC_PC_SYSH_PROG_CTRL_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_CTRL_reg)=data)
+#define get_DC_PC_SYSH_PROG_CTRL_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_CTRL_reg))
+#define DC_PC_SYSH_PROG_CTRL_inst_adr                                                "0x0010"
+#define DC_PC_SYSH_PROG_CTRL_inst                                                    0x0010
+#define DC_PC_SYSH_PROG_CTRL_write_en_3_shift                                        (25)
+#define DC_PC_SYSH_PROG_CTRL_write_en_3_mask                                         (0x02000000)
+#define DC_PC_SYSH_PROG_CTRL_write_en_3(data)                                        (0x02000000&((data)<<25))
+#define DC_PC_SYSH_PROG_CTRL_write_en_3_src(data)                                    ((0x02000000&(data))>>25)
+#define DC_PC_SYSH_PROG_CTRL_get_write_en_3(data)                                    ((0x02000000&(data))>>25)
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog2_sel_shift                                 (18)
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog2_sel_mask                                  (0x01FC0000)
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog2_sel(data)                                 (0x01FC0000&((data)<<18))
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog2_sel_src(data)                             ((0x01FC0000&(data))>>18)
+#define DC_PC_SYSH_PROG_CTRL_get_pc_sysh_prog2_sel(data)                             ((0x01FC0000&(data))>>18)
+#define DC_PC_SYSH_PROG_CTRL_write_en_2_shift                                        (16)
+#define DC_PC_SYSH_PROG_CTRL_write_en_2_mask                                         (0x00010000)
+#define DC_PC_SYSH_PROG_CTRL_write_en_2(data)                                        (0x00010000&((data)<<16))
+#define DC_PC_SYSH_PROG_CTRL_write_en_2_src(data)                                    ((0x00010000&(data))>>16)
+#define DC_PC_SYSH_PROG_CTRL_get_write_en_2(data)                                    ((0x00010000&(data))>>16)
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog1_sel_shift                                 (9)
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog1_sel_mask                                  (0x0000FE00)
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog1_sel(data)                                 (0x0000FE00&((data)<<9))
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog1_sel_src(data)                             ((0x0000FE00&(data))>>9)
+#define DC_PC_SYSH_PROG_CTRL_get_pc_sysh_prog1_sel(data)                             ((0x0000FE00&(data))>>9)
+#define DC_PC_SYSH_PROG_CTRL_write_en_1_shift                                        (7)
+#define DC_PC_SYSH_PROG_CTRL_write_en_1_mask                                         (0x00000080)
+#define DC_PC_SYSH_PROG_CTRL_write_en_1(data)                                        (0x00000080&((data)<<7))
+#define DC_PC_SYSH_PROG_CTRL_write_en_1_src(data)                                    ((0x00000080&(data))>>7)
+#define DC_PC_SYSH_PROG_CTRL_get_write_en_1(data)                                    ((0x00000080&(data))>>7)
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog0_sel_shift                                 (0)
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog0_sel_mask                                  (0x0000007F)
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog0_sel(data)                                 (0x0000007F&((data)<<0))
+#define DC_PC_SYSH_PROG_CTRL_pc_sysh_prog0_sel_src(data)                             ((0x0000007F&(data))>>0)
+#define DC_PC_SYSH_PROG_CTRL_get_pc_sysh_prog0_sel(data)                             ((0x0000007F&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_CTRL                                                          0x18008044
+#define DC_PC_SYS_PROG_CTRL_reg_addr                                                 "0xB8008044"
+#define DC_PC_SYS_PROG_CTRL_reg                                                      0xB8008044
+#define set_DC_PC_SYS_PROG_CTRL_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_CTRL_reg)=data)
+#define get_DC_PC_SYS_PROG_CTRL_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_CTRL_reg))
+#define DC_PC_SYS_PROG_CTRL_inst_adr                                                 "0x0011"
+#define DC_PC_SYS_PROG_CTRL_inst                                                     0x0011
+#define DC_PC_SYS_PROG_CTRL_write_en_3_shift                                         (25)
+#define DC_PC_SYS_PROG_CTRL_write_en_3_mask                                          (0x02000000)
+#define DC_PC_SYS_PROG_CTRL_write_en_3(data)                                         (0x02000000&((data)<<25))
+#define DC_PC_SYS_PROG_CTRL_write_en_3_src(data)                                     ((0x02000000&(data))>>25)
+#define DC_PC_SYS_PROG_CTRL_get_write_en_3(data)                                     ((0x02000000&(data))>>25)
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog2_sel_shift                                   (18)
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog2_sel_mask                                    (0x01FC0000)
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog2_sel(data)                                   (0x01FC0000&((data)<<18))
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog2_sel_src(data)                               ((0x01FC0000&(data))>>18)
+#define DC_PC_SYS_PROG_CTRL_get_pc_sys_prog2_sel(data)                               ((0x01FC0000&(data))>>18)
+#define DC_PC_SYS_PROG_CTRL_write_en_2_shift                                         (16)
+#define DC_PC_SYS_PROG_CTRL_write_en_2_mask                                          (0x00010000)
+#define DC_PC_SYS_PROG_CTRL_write_en_2(data)                                         (0x00010000&((data)<<16))
+#define DC_PC_SYS_PROG_CTRL_write_en_2_src(data)                                     ((0x00010000&(data))>>16)
+#define DC_PC_SYS_PROG_CTRL_get_write_en_2(data)                                     ((0x00010000&(data))>>16)
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog1_sel_shift                                   (9)
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog1_sel_mask                                    (0x0000FE00)
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog1_sel(data)                                   (0x0000FE00&((data)<<9))
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog1_sel_src(data)                               ((0x0000FE00&(data))>>9)
+#define DC_PC_SYS_PROG_CTRL_get_pc_sys_prog1_sel(data)                               ((0x0000FE00&(data))>>9)
+#define DC_PC_SYS_PROG_CTRL_write_en_1_shift                                         (7)
+#define DC_PC_SYS_PROG_CTRL_write_en_1_mask                                          (0x00000080)
+#define DC_PC_SYS_PROG_CTRL_write_en_1(data)                                         (0x00000080&((data)<<7))
+#define DC_PC_SYS_PROG_CTRL_write_en_1_src(data)                                     ((0x00000080&(data))>>7)
+#define DC_PC_SYS_PROG_CTRL_get_write_en_1(data)                                     ((0x00000080&(data))>>7)
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog0_sel_shift                                   (0)
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog0_sel_mask                                    (0x0000007F)
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog0_sel(data)                                   (0x0000007F&((data)<<0))
+#define DC_PC_SYS_PROG_CTRL_pc_sys_prog0_sel_src(data)                               ((0x0000007F&(data))>>0)
+#define DC_PC_SYS_PROG_CTRL_get_pc_sys_prog0_sel(data)                               ((0x0000007F&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_0_ACC_LAT                                                    0x18008050
+#define DC_PC_SYSH_PROG_0_ACC_LAT_reg_addr                                           "0xB8008050"
+#define DC_PC_SYSH_PROG_0_ACC_LAT_reg                                                0xB8008050
+#define set_DC_PC_SYSH_PROG_0_ACC_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_0_ACC_LAT_reg)=data)
+#define get_DC_PC_SYSH_PROG_0_ACC_LAT_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_0_ACC_LAT_reg))
+#define DC_PC_SYSH_PROG_0_ACC_LAT_inst_adr                                           "0x0014"
+#define DC_PC_SYSH_PROG_0_ACC_LAT_inst                                               0x0014
+#define DC_PC_SYSH_PROG_0_ACC_LAT_sysh_prog0_acc_lat_shift                           (0)
+#define DC_PC_SYSH_PROG_0_ACC_LAT_sysh_prog0_acc_lat_mask                            (0xFFFFFFFF)
+#define DC_PC_SYSH_PROG_0_ACC_LAT_sysh_prog0_acc_lat(data)                           (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_0_ACC_LAT_sysh_prog0_acc_lat_src(data)                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_0_ACC_LAT_get_sysh_prog0_acc_lat(data)                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_0_MAX_LAT                                                    0x18008054
+#define DC_PC_SYSH_PROG_0_MAX_LAT_reg_addr                                           "0xB8008054"
+#define DC_PC_SYSH_PROG_0_MAX_LAT_reg                                                0xB8008054
+#define set_DC_PC_SYSH_PROG_0_MAX_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_0_MAX_LAT_reg)=data)
+#define get_DC_PC_SYSH_PROG_0_MAX_LAT_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_0_MAX_LAT_reg))
+#define DC_PC_SYSH_PROG_0_MAX_LAT_inst_adr                                           "0x0015"
+#define DC_PC_SYSH_PROG_0_MAX_LAT_inst                                               0x0015
+#define DC_PC_SYSH_PROG_0_MAX_LAT_sysh_prog0_max_lat_shift                           (0)
+#define DC_PC_SYSH_PROG_0_MAX_LAT_sysh_prog0_max_lat_mask                            (0x0000FFFF)
+#define DC_PC_SYSH_PROG_0_MAX_LAT_sysh_prog0_max_lat(data)                           (0x0000FFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_0_MAX_LAT_sysh_prog0_max_lat_src(data)                       ((0x0000FFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_0_MAX_LAT_get_sysh_prog0_max_lat(data)                       ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_0_REQ_NUM                                                    0x18008058
+#define DC_PC_SYSH_PROG_0_REQ_NUM_reg_addr                                           "0xB8008058"
+#define DC_PC_SYSH_PROG_0_REQ_NUM_reg                                                0xB8008058
+#define set_DC_PC_SYSH_PROG_0_REQ_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_0_REQ_NUM_reg)=data)
+#define get_DC_PC_SYSH_PROG_0_REQ_NUM_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_0_REQ_NUM_reg))
+#define DC_PC_SYSH_PROG_0_REQ_NUM_inst_adr                                           "0x0016"
+#define DC_PC_SYSH_PROG_0_REQ_NUM_inst                                               0x0016
+#define DC_PC_SYSH_PROG_0_REQ_NUM_sysh_prog0_req_num_shift                           (0)
+#define DC_PC_SYSH_PROG_0_REQ_NUM_sysh_prog0_req_num_mask                            (0x00FFFFFF)
+#define DC_PC_SYSH_PROG_0_REQ_NUM_sysh_prog0_req_num(data)                           (0x00FFFFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_0_REQ_NUM_sysh_prog0_req_num_src(data)                       ((0x00FFFFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_0_REQ_NUM_get_sysh_prog0_req_num(data)                       ((0x00FFFFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_0_ACK_NUM                                                    0x1800805C
+#define DC_PC_SYSH_PROG_0_ACK_NUM_reg_addr                                           "0xB800805C"
+#define DC_PC_SYSH_PROG_0_ACK_NUM_reg                                                0xB800805C
+#define set_DC_PC_SYSH_PROG_0_ACK_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_0_ACK_NUM_reg)=data)
+#define get_DC_PC_SYSH_PROG_0_ACK_NUM_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_0_ACK_NUM_reg))
+#define DC_PC_SYSH_PROG_0_ACK_NUM_inst_adr                                           "0x0017"
+#define DC_PC_SYSH_PROG_0_ACK_NUM_inst                                               0x0017
+#define DC_PC_SYSH_PROG_0_ACK_NUM_sysh_prog0_ack_num_shift                           (0)
+#define DC_PC_SYSH_PROG_0_ACK_NUM_sysh_prog0_ack_num_mask                            (0xFFFFFFFF)
+#define DC_PC_SYSH_PROG_0_ACK_NUM_sysh_prog0_ack_num(data)                           (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_0_ACK_NUM_sysh_prog0_ack_num_src(data)                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_0_ACK_NUM_get_sysh_prog0_ack_num(data)                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_1_ACC_LAT                                                    0x18008060
+#define DC_PC_SYSH_PROG_1_ACC_LAT_reg_addr                                           "0xB8008060"
+#define DC_PC_SYSH_PROG_1_ACC_LAT_reg                                                0xB8008060
+#define set_DC_PC_SYSH_PROG_1_ACC_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_1_ACC_LAT_reg)=data)
+#define get_DC_PC_SYSH_PROG_1_ACC_LAT_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_1_ACC_LAT_reg))
+#define DC_PC_SYSH_PROG_1_ACC_LAT_inst_adr                                           "0x0018"
+#define DC_PC_SYSH_PROG_1_ACC_LAT_inst                                               0x0018
+#define DC_PC_SYSH_PROG_1_ACC_LAT_sysh_prog1_acc_lat_shift                           (0)
+#define DC_PC_SYSH_PROG_1_ACC_LAT_sysh_prog1_acc_lat_mask                            (0xFFFFFFFF)
+#define DC_PC_SYSH_PROG_1_ACC_LAT_sysh_prog1_acc_lat(data)                           (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_1_ACC_LAT_sysh_prog1_acc_lat_src(data)                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_1_ACC_LAT_get_sysh_prog1_acc_lat(data)                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_1_MAX_LAT                                                    0x18008064
+#define DC_PC_SYSH_PROG_1_MAX_LAT_reg_addr                                           "0xB8008064"
+#define DC_PC_SYSH_PROG_1_MAX_LAT_reg                                                0xB8008064
+#define set_DC_PC_SYSH_PROG_1_MAX_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_1_MAX_LAT_reg)=data)
+#define get_DC_PC_SYSH_PROG_1_MAX_LAT_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_1_MAX_LAT_reg))
+#define DC_PC_SYSH_PROG_1_MAX_LAT_inst_adr                                           "0x0019"
+#define DC_PC_SYSH_PROG_1_MAX_LAT_inst                                               0x0019
+#define DC_PC_SYSH_PROG_1_MAX_LAT_sysh_prog1_max_lat_shift                           (0)
+#define DC_PC_SYSH_PROG_1_MAX_LAT_sysh_prog1_max_lat_mask                            (0x0000FFFF)
+#define DC_PC_SYSH_PROG_1_MAX_LAT_sysh_prog1_max_lat(data)                           (0x0000FFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_1_MAX_LAT_sysh_prog1_max_lat_src(data)                       ((0x0000FFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_1_MAX_LAT_get_sysh_prog1_max_lat(data)                       ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_1_REQ_NUM                                                    0x18008068
+#define DC_PC_SYSH_PROG_1_REQ_NUM_reg_addr                                           "0xB8008068"
+#define DC_PC_SYSH_PROG_1_REQ_NUM_reg                                                0xB8008068
+#define set_DC_PC_SYSH_PROG_1_REQ_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_1_REQ_NUM_reg)=data)
+#define get_DC_PC_SYSH_PROG_1_REQ_NUM_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_1_REQ_NUM_reg))
+#define DC_PC_SYSH_PROG_1_REQ_NUM_inst_adr                                           "0x001A"
+#define DC_PC_SYSH_PROG_1_REQ_NUM_inst                                               0x001A
+#define DC_PC_SYSH_PROG_1_REQ_NUM_sysh_prog1_req_num_shift                           (0)
+#define DC_PC_SYSH_PROG_1_REQ_NUM_sysh_prog1_req_num_mask                            (0x00FFFFFF)
+#define DC_PC_SYSH_PROG_1_REQ_NUM_sysh_prog1_req_num(data)                           (0x00FFFFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_1_REQ_NUM_sysh_prog1_req_num_src(data)                       ((0x00FFFFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_1_REQ_NUM_get_sysh_prog1_req_num(data)                       ((0x00FFFFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_1_ACK_NUM                                                    0x1800806C
+#define DC_PC_SYSH_PROG_1_ACK_NUM_reg_addr                                           "0xB800806C"
+#define DC_PC_SYSH_PROG_1_ACK_NUM_reg                                                0xB800806C
+#define set_DC_PC_SYSH_PROG_1_ACK_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_1_ACK_NUM_reg)=data)
+#define get_DC_PC_SYSH_PROG_1_ACK_NUM_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_1_ACK_NUM_reg))
+#define DC_PC_SYSH_PROG_1_ACK_NUM_inst_adr                                           "0x001B"
+#define DC_PC_SYSH_PROG_1_ACK_NUM_inst                                               0x001B
+#define DC_PC_SYSH_PROG_1_ACK_NUM_sysh_prog1_ack_num_shift                           (0)
+#define DC_PC_SYSH_PROG_1_ACK_NUM_sysh_prog1_ack_num_mask                            (0xFFFFFFFF)
+#define DC_PC_SYSH_PROG_1_ACK_NUM_sysh_prog1_ack_num(data)                           (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_1_ACK_NUM_sysh_prog1_ack_num_src(data)                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_1_ACK_NUM_get_sysh_prog1_ack_num(data)                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_2_ACC_LAT                                                    0x18008070
+#define DC_PC_SYSH_PROG_2_ACC_LAT_reg_addr                                           "0xB8008070"
+#define DC_PC_SYSH_PROG_2_ACC_LAT_reg                                                0xB8008070
+#define set_DC_PC_SYSH_PROG_2_ACC_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_2_ACC_LAT_reg)=data)
+#define get_DC_PC_SYSH_PROG_2_ACC_LAT_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_2_ACC_LAT_reg))
+#define DC_PC_SYSH_PROG_2_ACC_LAT_inst_adr                                           "0x001C"
+#define DC_PC_SYSH_PROG_2_ACC_LAT_inst                                               0x001C
+#define DC_PC_SYSH_PROG_2_ACC_LAT_sysh_prog2_acc_lat_shift                           (0)
+#define DC_PC_SYSH_PROG_2_ACC_LAT_sysh_prog2_acc_lat_mask                            (0xFFFFFFFF)
+#define DC_PC_SYSH_PROG_2_ACC_LAT_sysh_prog2_acc_lat(data)                           (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_2_ACC_LAT_sysh_prog2_acc_lat_src(data)                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_2_ACC_LAT_get_sysh_prog2_acc_lat(data)                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_2_MAX_LAT                                                    0x18008074
+#define DC_PC_SYSH_PROG_2_MAX_LAT_reg_addr                                           "0xB8008074"
+#define DC_PC_SYSH_PROG_2_MAX_LAT_reg                                                0xB8008074
+#define set_DC_PC_SYSH_PROG_2_MAX_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_2_MAX_LAT_reg)=data)
+#define get_DC_PC_SYSH_PROG_2_MAX_LAT_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_2_MAX_LAT_reg))
+#define DC_PC_SYSH_PROG_2_MAX_LAT_inst_adr                                           "0x001D"
+#define DC_PC_SYSH_PROG_2_MAX_LAT_inst                                               0x001D
+#define DC_PC_SYSH_PROG_2_MAX_LAT_sysh_prog2_max_lat_shift                           (0)
+#define DC_PC_SYSH_PROG_2_MAX_LAT_sysh_prog2_max_lat_mask                            (0x0000FFFF)
+#define DC_PC_SYSH_PROG_2_MAX_LAT_sysh_prog2_max_lat(data)                           (0x0000FFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_2_MAX_LAT_sysh_prog2_max_lat_src(data)                       ((0x0000FFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_2_MAX_LAT_get_sysh_prog2_max_lat(data)                       ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_2_REQ_NUM                                                    0x18008078
+#define DC_PC_SYSH_PROG_2_REQ_NUM_reg_addr                                           "0xB8008078"
+#define DC_PC_SYSH_PROG_2_REQ_NUM_reg                                                0xB8008078
+#define set_DC_PC_SYSH_PROG_2_REQ_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_2_REQ_NUM_reg)=data)
+#define get_DC_PC_SYSH_PROG_2_REQ_NUM_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_2_REQ_NUM_reg))
+#define DC_PC_SYSH_PROG_2_REQ_NUM_inst_adr                                           "0x001E"
+#define DC_PC_SYSH_PROG_2_REQ_NUM_inst                                               0x001E
+#define DC_PC_SYSH_PROG_2_REQ_NUM_sysh_prog2_req_num_shift                           (0)
+#define DC_PC_SYSH_PROG_2_REQ_NUM_sysh_prog2_req_num_mask                            (0x00FFFFFF)
+#define DC_PC_SYSH_PROG_2_REQ_NUM_sysh_prog2_req_num(data)                           (0x00FFFFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_2_REQ_NUM_sysh_prog2_req_num_src(data)                       ((0x00FFFFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_2_REQ_NUM_get_sysh_prog2_req_num(data)                       ((0x00FFFFFF&(data))>>0)
+
+
+#define DC_PC_SYSH_PROG_2_ACK_NUM                                                    0x1800807C
+#define DC_PC_SYSH_PROG_2_ACK_NUM_reg_addr                                           "0xB800807C"
+#define DC_PC_SYSH_PROG_2_ACK_NUM_reg                                                0xB800807C
+#define set_DC_PC_SYSH_PROG_2_ACK_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYSH_PROG_2_ACK_NUM_reg)=data)
+#define get_DC_PC_SYSH_PROG_2_ACK_NUM_reg   (*((volatile unsigned int*) DC_PC_SYSH_PROG_2_ACK_NUM_reg))
+#define DC_PC_SYSH_PROG_2_ACK_NUM_inst_adr                                           "0x001F"
+#define DC_PC_SYSH_PROG_2_ACK_NUM_inst                                               0x001F
+#define DC_PC_SYSH_PROG_2_ACK_NUM_sysh_prog2_ack_num_shift                           (0)
+#define DC_PC_SYSH_PROG_2_ACK_NUM_sysh_prog2_ack_num_mask                            (0xFFFFFFFF)
+#define DC_PC_SYSH_PROG_2_ACK_NUM_sysh_prog2_ack_num(data)                           (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYSH_PROG_2_ACK_NUM_sysh_prog2_ack_num_src(data)                       ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYSH_PROG_2_ACK_NUM_get_sysh_prog2_ack_num(data)                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_0_ACC_LAT                                                     0x18008090
+#define DC_PC_SYS_PROG_0_ACC_LAT_reg_addr                                            "0xB8008090"
+#define DC_PC_SYS_PROG_0_ACC_LAT_reg                                                 0xB8008090
+#define set_DC_PC_SYS_PROG_0_ACC_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_0_ACC_LAT_reg)=data)
+#define get_DC_PC_SYS_PROG_0_ACC_LAT_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_0_ACC_LAT_reg))
+#define DC_PC_SYS_PROG_0_ACC_LAT_inst_adr                                            "0x0024"
+#define DC_PC_SYS_PROG_0_ACC_LAT_inst                                                0x0024
+#define DC_PC_SYS_PROG_0_ACC_LAT_sys_prog0_acc_lat_shift                             (0)
+#define DC_PC_SYS_PROG_0_ACC_LAT_sys_prog0_acc_lat_mask                              (0xFFFFFFFF)
+#define DC_PC_SYS_PROG_0_ACC_LAT_sys_prog0_acc_lat(data)                             (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYS_PROG_0_ACC_LAT_sys_prog0_acc_lat_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYS_PROG_0_ACC_LAT_get_sys_prog0_acc_lat(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_0_MAX_LAT                                                     0x18008094
+#define DC_PC_SYS_PROG_0_MAX_LAT_reg_addr                                            "0xB8008094"
+#define DC_PC_SYS_PROG_0_MAX_LAT_reg                                                 0xB8008094
+#define set_DC_PC_SYS_PROG_0_MAX_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_0_MAX_LAT_reg)=data)
+#define get_DC_PC_SYS_PROG_0_MAX_LAT_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_0_MAX_LAT_reg))
+#define DC_PC_SYS_PROG_0_MAX_LAT_inst_adr                                            "0x0025"
+#define DC_PC_SYS_PROG_0_MAX_LAT_inst                                                0x0025
+#define DC_PC_SYS_PROG_0_MAX_LAT_sys_prog0_max_lat_shift                             (0)
+#define DC_PC_SYS_PROG_0_MAX_LAT_sys_prog0_max_lat_mask                              (0x0000FFFF)
+#define DC_PC_SYS_PROG_0_MAX_LAT_sys_prog0_max_lat(data)                             (0x0000FFFF&((data)<<0))
+#define DC_PC_SYS_PROG_0_MAX_LAT_sys_prog0_max_lat_src(data)                         ((0x0000FFFF&(data))>>0)
+#define DC_PC_SYS_PROG_0_MAX_LAT_get_sys_prog0_max_lat(data)                         ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_0_REQ_NUM                                                     0x18008098
+#define DC_PC_SYS_PROG_0_REQ_NUM_reg_addr                                            "0xB8008098"
+#define DC_PC_SYS_PROG_0_REQ_NUM_reg                                                 0xB8008098
+#define set_DC_PC_SYS_PROG_0_REQ_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_0_REQ_NUM_reg)=data)
+#define get_DC_PC_SYS_PROG_0_REQ_NUM_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_0_REQ_NUM_reg))
+#define DC_PC_SYS_PROG_0_REQ_NUM_inst_adr                                            "0x0026"
+#define DC_PC_SYS_PROG_0_REQ_NUM_inst                                                0x0026
+#define DC_PC_SYS_PROG_0_REQ_NUM_sys_prog0_req_num_shift                             (0)
+#define DC_PC_SYS_PROG_0_REQ_NUM_sys_prog0_req_num_mask                              (0x00FFFFFF)
+#define DC_PC_SYS_PROG_0_REQ_NUM_sys_prog0_req_num(data)                             (0x00FFFFFF&((data)<<0))
+#define DC_PC_SYS_PROG_0_REQ_NUM_sys_prog0_req_num_src(data)                         ((0x00FFFFFF&(data))>>0)
+#define DC_PC_SYS_PROG_0_REQ_NUM_get_sys_prog0_req_num(data)                         ((0x00FFFFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_0_ACK_NUM                                                     0x1800809C
+#define DC_PC_SYS_PROG_0_ACK_NUM_reg_addr                                            "0xB800809C"
+#define DC_PC_SYS_PROG_0_ACK_NUM_reg                                                 0xB800809C
+#define set_DC_PC_SYS_PROG_0_ACK_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_0_ACK_NUM_reg)=data)
+#define get_DC_PC_SYS_PROG_0_ACK_NUM_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_0_ACK_NUM_reg))
+#define DC_PC_SYS_PROG_0_ACK_NUM_inst_adr                                            "0x0027"
+#define DC_PC_SYS_PROG_0_ACK_NUM_inst                                                0x0027
+#define DC_PC_SYS_PROG_0_ACK_NUM_sys_prog0_ack_num_shift                             (0)
+#define DC_PC_SYS_PROG_0_ACK_NUM_sys_prog0_ack_num_mask                              (0xFFFFFFFF)
+#define DC_PC_SYS_PROG_0_ACK_NUM_sys_prog0_ack_num(data)                             (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYS_PROG_0_ACK_NUM_sys_prog0_ack_num_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYS_PROG_0_ACK_NUM_get_sys_prog0_ack_num(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_1_ACC_LAT                                                     0x180080A0
+#define DC_PC_SYS_PROG_1_ACC_LAT_reg_addr                                            "0xB80080A0"
+#define DC_PC_SYS_PROG_1_ACC_LAT_reg                                                 0xB80080A0
+#define set_DC_PC_SYS_PROG_1_ACC_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_1_ACC_LAT_reg)=data)
+#define get_DC_PC_SYS_PROG_1_ACC_LAT_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_1_ACC_LAT_reg))
+#define DC_PC_SYS_PROG_1_ACC_LAT_inst_adr                                            "0x0028"
+#define DC_PC_SYS_PROG_1_ACC_LAT_inst                                                0x0028
+#define DC_PC_SYS_PROG_1_ACC_LAT_sys_prog1_acc_lat_shift                             (0)
+#define DC_PC_SYS_PROG_1_ACC_LAT_sys_prog1_acc_lat_mask                              (0xFFFFFFFF)
+#define DC_PC_SYS_PROG_1_ACC_LAT_sys_prog1_acc_lat(data)                             (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYS_PROG_1_ACC_LAT_sys_prog1_acc_lat_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYS_PROG_1_ACC_LAT_get_sys_prog1_acc_lat(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_1_MAX_LAT                                                     0x180080A4
+#define DC_PC_SYS_PROG_1_MAX_LAT_reg_addr                                            "0xB80080A4"
+#define DC_PC_SYS_PROG_1_MAX_LAT_reg                                                 0xB80080A4
+#define set_DC_PC_SYS_PROG_1_MAX_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_1_MAX_LAT_reg)=data)
+#define get_DC_PC_SYS_PROG_1_MAX_LAT_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_1_MAX_LAT_reg))
+#define DC_PC_SYS_PROG_1_MAX_LAT_inst_adr                                            "0x0029"
+#define DC_PC_SYS_PROG_1_MAX_LAT_inst                                                0x0029
+#define DC_PC_SYS_PROG_1_MAX_LAT_sys_prog1_max_lat_shift                             (0)
+#define DC_PC_SYS_PROG_1_MAX_LAT_sys_prog1_max_lat_mask                              (0x0000FFFF)
+#define DC_PC_SYS_PROG_1_MAX_LAT_sys_prog1_max_lat(data)                             (0x0000FFFF&((data)<<0))
+#define DC_PC_SYS_PROG_1_MAX_LAT_sys_prog1_max_lat_src(data)                         ((0x0000FFFF&(data))>>0)
+#define DC_PC_SYS_PROG_1_MAX_LAT_get_sys_prog1_max_lat(data)                         ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_1_REQ_NUM                                                     0x180080A8
+#define DC_PC_SYS_PROG_1_REQ_NUM_reg_addr                                            "0xB80080A8"
+#define DC_PC_SYS_PROG_1_REQ_NUM_reg                                                 0xB80080A8
+#define set_DC_PC_SYS_PROG_1_REQ_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_1_REQ_NUM_reg)=data)
+#define get_DC_PC_SYS_PROG_1_REQ_NUM_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_1_REQ_NUM_reg))
+#define DC_PC_SYS_PROG_1_REQ_NUM_inst_adr                                            "0x002A"
+#define DC_PC_SYS_PROG_1_REQ_NUM_inst                                                0x002A
+#define DC_PC_SYS_PROG_1_REQ_NUM_sys_prog1_req_num_shift                             (0)
+#define DC_PC_SYS_PROG_1_REQ_NUM_sys_prog1_req_num_mask                              (0x00FFFFFF)
+#define DC_PC_SYS_PROG_1_REQ_NUM_sys_prog1_req_num(data)                             (0x00FFFFFF&((data)<<0))
+#define DC_PC_SYS_PROG_1_REQ_NUM_sys_prog1_req_num_src(data)                         ((0x00FFFFFF&(data))>>0)
+#define DC_PC_SYS_PROG_1_REQ_NUM_get_sys_prog1_req_num(data)                         ((0x00FFFFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_1_ACK_NUM                                                     0x180080AC
+#define DC_PC_SYS_PROG_1_ACK_NUM_reg_addr                                            "0xB80080AC"
+#define DC_PC_SYS_PROG_1_ACK_NUM_reg                                                 0xB80080AC
+#define set_DC_PC_SYS_PROG_1_ACK_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_1_ACK_NUM_reg)=data)
+#define get_DC_PC_SYS_PROG_1_ACK_NUM_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_1_ACK_NUM_reg))
+#define DC_PC_SYS_PROG_1_ACK_NUM_inst_adr                                            "0x002B"
+#define DC_PC_SYS_PROG_1_ACK_NUM_inst                                                0x002B
+#define DC_PC_SYS_PROG_1_ACK_NUM_sys_prog1_ack_num_shift                             (0)
+#define DC_PC_SYS_PROG_1_ACK_NUM_sys_prog1_ack_num_mask                              (0xFFFFFFFF)
+#define DC_PC_SYS_PROG_1_ACK_NUM_sys_prog1_ack_num(data)                             (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYS_PROG_1_ACK_NUM_sys_prog1_ack_num_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYS_PROG_1_ACK_NUM_get_sys_prog1_ack_num(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_2_ACC_LAT                                                     0x180080B0
+#define DC_PC_SYS_PROG_2_ACC_LAT_reg_addr                                            "0xB80080B0"
+#define DC_PC_SYS_PROG_2_ACC_LAT_reg                                                 0xB80080B0
+#define set_DC_PC_SYS_PROG_2_ACC_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_2_ACC_LAT_reg)=data)
+#define get_DC_PC_SYS_PROG_2_ACC_LAT_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_2_ACC_LAT_reg))
+#define DC_PC_SYS_PROG_2_ACC_LAT_inst_adr                                            "0x002C"
+#define DC_PC_SYS_PROG_2_ACC_LAT_inst                                                0x002C
+#define DC_PC_SYS_PROG_2_ACC_LAT_sys_prog2_acc_lat_shift                             (0)
+#define DC_PC_SYS_PROG_2_ACC_LAT_sys_prog2_acc_lat_mask                              (0xFFFFFFFF)
+#define DC_PC_SYS_PROG_2_ACC_LAT_sys_prog2_acc_lat(data)                             (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYS_PROG_2_ACC_LAT_sys_prog2_acc_lat_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYS_PROG_2_ACC_LAT_get_sys_prog2_acc_lat(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_2_MAX_LAT                                                     0x180080B4
+#define DC_PC_SYS_PROG_2_MAX_LAT_reg_addr                                            "0xB80080B4"
+#define DC_PC_SYS_PROG_2_MAX_LAT_reg                                                 0xB80080B4
+#define set_DC_PC_SYS_PROG_2_MAX_LAT_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_2_MAX_LAT_reg)=data)
+#define get_DC_PC_SYS_PROG_2_MAX_LAT_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_2_MAX_LAT_reg))
+#define DC_PC_SYS_PROG_2_MAX_LAT_inst_adr                                            "0x002D"
+#define DC_PC_SYS_PROG_2_MAX_LAT_inst                                                0x002D
+#define DC_PC_SYS_PROG_2_MAX_LAT_sys_prog2_max_lat_shift                             (0)
+#define DC_PC_SYS_PROG_2_MAX_LAT_sys_prog2_max_lat_mask                              (0x0000FFFF)
+#define DC_PC_SYS_PROG_2_MAX_LAT_sys_prog2_max_lat(data)                             (0x0000FFFF&((data)<<0))
+#define DC_PC_SYS_PROG_2_MAX_LAT_sys_prog2_max_lat_src(data)                         ((0x0000FFFF&(data))>>0)
+#define DC_PC_SYS_PROG_2_MAX_LAT_get_sys_prog2_max_lat(data)                         ((0x0000FFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_2_REQ_NUM                                                     0x180080B8
+#define DC_PC_SYS_PROG_2_REQ_NUM_reg_addr                                            "0xB80080B8"
+#define DC_PC_SYS_PROG_2_REQ_NUM_reg                                                 0xB80080B8
+#define set_DC_PC_SYS_PROG_2_REQ_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_2_REQ_NUM_reg)=data)
+#define get_DC_PC_SYS_PROG_2_REQ_NUM_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_2_REQ_NUM_reg))
+#define DC_PC_SYS_PROG_2_REQ_NUM_inst_adr                                            "0x002E"
+#define DC_PC_SYS_PROG_2_REQ_NUM_inst                                                0x002E
+#define DC_PC_SYS_PROG_2_REQ_NUM_sys_prog2_req_num_shift                             (0)
+#define DC_PC_SYS_PROG_2_REQ_NUM_sys_prog2_req_num_mask                              (0x00FFFFFF)
+#define DC_PC_SYS_PROG_2_REQ_NUM_sys_prog2_req_num(data)                             (0x00FFFFFF&((data)<<0))
+#define DC_PC_SYS_PROG_2_REQ_NUM_sys_prog2_req_num_src(data)                         ((0x00FFFFFF&(data))>>0)
+#define DC_PC_SYS_PROG_2_REQ_NUM_get_sys_prog2_req_num(data)                         ((0x00FFFFFF&(data))>>0)
+
+
+#define DC_PC_SYS_PROG_2_ACK_NUM                                                     0x180080BC
+#define DC_PC_SYS_PROG_2_ACK_NUM_reg_addr                                            "0xB80080BC"
+#define DC_PC_SYS_PROG_2_ACK_NUM_reg                                                 0xB80080BC
+#define set_DC_PC_SYS_PROG_2_ACK_NUM_reg(data)   (*((volatile unsigned int*) DC_PC_SYS_PROG_2_ACK_NUM_reg)=data)
+#define get_DC_PC_SYS_PROG_2_ACK_NUM_reg   (*((volatile unsigned int*) DC_PC_SYS_PROG_2_ACK_NUM_reg))
+#define DC_PC_SYS_PROG_2_ACK_NUM_inst_adr                                            "0x002F"
+#define DC_PC_SYS_PROG_2_ACK_NUM_inst                                                0x002F
+#define DC_PC_SYS_PROG_2_ACK_NUM_sys_prog2_ack_num_shift                             (0)
+#define DC_PC_SYS_PROG_2_ACK_NUM_sys_prog2_ack_num_mask                              (0xFFFFFFFF)
+#define DC_PC_SYS_PROG_2_ACK_NUM_sys_prog2_ack_num(data)                             (0xFFFFFFFF&((data)<<0))
+#define DC_PC_SYS_PROG_2_ACK_NUM_sys_prog2_ack_num_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define DC_PC_SYS_PROG_2_ACK_NUM_get_sys_prog2_ack_num(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define SFMODE_PATTERN0                                                              0x180080C0
+#define SFMODE_PATTERN0_reg_addr                                                     "0xB80080C0"
+#define SFMODE_PATTERN0_reg                                                          0xB80080C0
+#define set_SFMODE_PATTERN0_reg(data)   (*((volatile unsigned int*) SFMODE_PATTERN0_reg)=data)
+#define get_SFMODE_PATTERN0_reg   (*((volatile unsigned int*) SFMODE_PATTERN0_reg))
+#define SFMODE_PATTERN0_inst_adr                                                     "0x0030"
+#define SFMODE_PATTERN0_inst                                                         0x0030
+#define SFMODE_PATTERN0_sfmode_pattern0_shift                                        (0)
+#define SFMODE_PATTERN0_sfmode_pattern0_mask                                         (0xFFFFFFFF)
+#define SFMODE_PATTERN0_sfmode_pattern0(data)                                        (0xFFFFFFFF&((data)<<0))
+#define SFMODE_PATTERN0_sfmode_pattern0_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define SFMODE_PATTERN0_get_sfmode_pattern0(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SFMODE_PATTERN1                                                              0x180080C4
+#define SFMODE_PATTERN1_reg_addr                                                     "0xB80080C4"
+#define SFMODE_PATTERN1_reg                                                          0xB80080C4
+#define set_SFMODE_PATTERN1_reg(data)   (*((volatile unsigned int*) SFMODE_PATTERN1_reg)=data)
+#define get_SFMODE_PATTERN1_reg   (*((volatile unsigned int*) SFMODE_PATTERN1_reg))
+#define SFMODE_PATTERN1_inst_adr                                                     "0x0031"
+#define SFMODE_PATTERN1_inst                                                         0x0031
+#define SFMODE_PATTERN1_sfmode_pattern1_shift                                        (0)
+#define SFMODE_PATTERN1_sfmode_pattern1_mask                                         (0xFFFFFFFF)
+#define SFMODE_PATTERN1_sfmode_pattern1(data)                                        (0xFFFFFFFF&((data)<<0))
+#define SFMODE_PATTERN1_sfmode_pattern1_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define SFMODE_PATTERN1_get_sfmode_pattern1(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SFMODE_PATTERN2                                                              0x180080C8
+#define SFMODE_PATTERN2_reg_addr                                                     "0xB80080C8"
+#define SFMODE_PATTERN2_reg                                                          0xB80080C8
+#define set_SFMODE_PATTERN2_reg(data)   (*((volatile unsigned int*) SFMODE_PATTERN2_reg)=data)
+#define get_SFMODE_PATTERN2_reg   (*((volatile unsigned int*) SFMODE_PATTERN2_reg))
+#define SFMODE_PATTERN2_inst_adr                                                     "0x0032"
+#define SFMODE_PATTERN2_inst                                                         0x0032
+#define SFMODE_PATTERN2_sfmode_pattern2_shift                                        (0)
+#define SFMODE_PATTERN2_sfmode_pattern2_mask                                         (0xFFFFFFFF)
+#define SFMODE_PATTERN2_sfmode_pattern2(data)                                        (0xFFFFFFFF&((data)<<0))
+#define SFMODE_PATTERN2_sfmode_pattern2_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define SFMODE_PATTERN2_get_sfmode_pattern2(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SFMODE_PATTERN3                                                              0x180080CC
+#define SFMODE_PATTERN3_reg_addr                                                     "0xB80080CC"
+#define SFMODE_PATTERN3_reg                                                          0xB80080CC
+#define set_SFMODE_PATTERN3_reg(data)   (*((volatile unsigned int*) SFMODE_PATTERN3_reg)=data)
+#define get_SFMODE_PATTERN3_reg   (*((volatile unsigned int*) SFMODE_PATTERN3_reg))
+#define SFMODE_PATTERN3_inst_adr                                                     "0x0033"
+#define SFMODE_PATTERN3_inst                                                         0x0033
+#define SFMODE_PATTERN3_sfmode_pattern3_shift                                        (0)
+#define SFMODE_PATTERN3_sfmode_pattern3_mask                                         (0xFFFFFFFF)
+#define SFMODE_PATTERN3_sfmode_pattern3(data)                                        (0xFFFFFFFF&((data)<<0))
+#define SFMODE_PATTERN3_sfmode_pattern3_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define SFMODE_PATTERN3_get_sfmode_pattern3(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SFMODE_CMP_RLT0                                                              0x180080D0
+#define SFMODE_CMP_RLT0_reg_addr                                                     "0xB80080D0"
+#define SFMODE_CMP_RLT0_reg                                                          0xB80080D0
+#define set_SFMODE_CMP_RLT0_reg(data)   (*((volatile unsigned int*) SFMODE_CMP_RLT0_reg)=data)
+#define get_SFMODE_CMP_RLT0_reg   (*((volatile unsigned int*) SFMODE_CMP_RLT0_reg))
+#define SFMODE_CMP_RLT0_inst_adr                                                     "0x0034"
+#define SFMODE_CMP_RLT0_inst                                                         0x0034
+#define SFMODE_CMP_RLT0_sfmode_cmp_rlt0_shift                                        (0)
+#define SFMODE_CMP_RLT0_sfmode_cmp_rlt0_mask                                         (0xFFFFFFFF)
+#define SFMODE_CMP_RLT0_sfmode_cmp_rlt0(data)                                        (0xFFFFFFFF&((data)<<0))
+#define SFMODE_CMP_RLT0_sfmode_cmp_rlt0_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define SFMODE_CMP_RLT0_get_sfmode_cmp_rlt0(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SFMODE_CMP_RLT1                                                              0x180080D4
+#define SFMODE_CMP_RLT1_reg_addr                                                     "0xB80080D4"
+#define SFMODE_CMP_RLT1_reg                                                          0xB80080D4
+#define set_SFMODE_CMP_RLT1_reg(data)   (*((volatile unsigned int*) SFMODE_CMP_RLT1_reg)=data)
+#define get_SFMODE_CMP_RLT1_reg   (*((volatile unsigned int*) SFMODE_CMP_RLT1_reg))
+#define SFMODE_CMP_RLT1_inst_adr                                                     "0x0035"
+#define SFMODE_CMP_RLT1_inst                                                         0x0035
+#define SFMODE_CMP_RLT1_sfmode_cmp_rlt1_shift                                        (0)
+#define SFMODE_CMP_RLT1_sfmode_cmp_rlt1_mask                                         (0xFFFFFFFF)
+#define SFMODE_CMP_RLT1_sfmode_cmp_rlt1(data)                                        (0xFFFFFFFF&((data)<<0))
+#define SFMODE_CMP_RLT1_sfmode_cmp_rlt1_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define SFMODE_CMP_RLT1_get_sfmode_cmp_rlt1(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SFMODE_CMP_RLT2                                                              0x180080D8
+#define SFMODE_CMP_RLT2_reg_addr                                                     "0xB80080D8"
+#define SFMODE_CMP_RLT2_reg                                                          0xB80080D8
+#define set_SFMODE_CMP_RLT2_reg(data)   (*((volatile unsigned int*) SFMODE_CMP_RLT2_reg)=data)
+#define get_SFMODE_CMP_RLT2_reg   (*((volatile unsigned int*) SFMODE_CMP_RLT2_reg))
+#define SFMODE_CMP_RLT2_inst_adr                                                     "0x0036"
+#define SFMODE_CMP_RLT2_inst                                                         0x0036
+#define SFMODE_CMP_RLT2_sfmode_cmp_rlt2_shift                                        (0)
+#define SFMODE_CMP_RLT2_sfmode_cmp_rlt2_mask                                         (0xFFFFFFFF)
+#define SFMODE_CMP_RLT2_sfmode_cmp_rlt2(data)                                        (0xFFFFFFFF&((data)<<0))
+#define SFMODE_CMP_RLT2_sfmode_cmp_rlt2_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define SFMODE_CMP_RLT2_get_sfmode_cmp_rlt2(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SFMODE_CMP_RLT3                                                              0x180080DC
+#define SFMODE_CMP_RLT3_reg_addr                                                     "0xB80080DC"
+#define SFMODE_CMP_RLT3_reg                                                          0xB80080DC
+#define set_SFMODE_CMP_RLT3_reg(data)   (*((volatile unsigned int*) SFMODE_CMP_RLT3_reg)=data)
+#define get_SFMODE_CMP_RLT3_reg   (*((volatile unsigned int*) SFMODE_CMP_RLT3_reg))
+#define SFMODE_CMP_RLT3_inst_adr                                                     "0x0037"
+#define SFMODE_CMP_RLT3_inst                                                         0x0037
+#define SFMODE_CMP_RLT3_sfmode_cmp_rlt3_shift                                        (0)
+#define SFMODE_CMP_RLT3_sfmode_cmp_rlt3_mask                                         (0xFFFFFFFF)
+#define SFMODE_CMP_RLT3_sfmode_cmp_rlt3(data)                                        (0xFFFFFFFF&((data)<<0))
+#define SFMODE_CMP_RLT3_sfmode_cmp_rlt3_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define SFMODE_CMP_RLT3_get_sfmode_cmp_rlt3(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_64_WRITE_BUF_CTRL                                                         0x180080E0
+#define DC_64_WRITE_BUF_CTRL_reg_addr                                                "0xB80080E0"
+#define DC_64_WRITE_BUF_CTRL_reg                                                     0xB80080E0
+#define set_DC_64_WRITE_BUF_CTRL_reg(data)   (*((volatile unsigned int*) DC_64_WRITE_BUF_CTRL_reg)=data)
+#define get_DC_64_WRITE_BUF_CTRL_reg   (*((volatile unsigned int*) DC_64_WRITE_BUF_CTRL_reg))
+#define DC_64_WRITE_BUF_CTRL_inst_adr                                                "0x0038"
+#define DC_64_WRITE_BUF_CTRL_inst                                                    0x0038
+#define DC_64_WRITE_BUF_CTRL_disable_2nd_channel_shift                               (1)
+#define DC_64_WRITE_BUF_CTRL_disable_2nd_channel_mask                                (0x00000002)
+#define DC_64_WRITE_BUF_CTRL_disable_2nd_channel(data)                               (0x00000002&((data)<<1))
+#define DC_64_WRITE_BUF_CTRL_disable_2nd_channel_src(data)                           ((0x00000002&(data))>>1)
+#define DC_64_WRITE_BUF_CTRL_get_disable_2nd_channel(data)                           ((0x00000002&(data))>>1)
+#define DC_64_WRITE_BUF_CTRL_full_transfer_shift                                     (0)
+#define DC_64_WRITE_BUF_CTRL_full_transfer_mask                                      (0x00000001)
+#define DC_64_WRITE_BUF_CTRL_full_transfer(data)                                     (0x00000001&((data)<<0))
+#define DC_64_WRITE_BUF_CTRL_full_transfer_src(data)                                 ((0x00000001&(data))>>0)
+#define DC_64_WRITE_BUF_CTRL_get_full_transfer(data)                                 ((0x00000001&(data))>>0)
+
+
+#define DC_64_READ_BUF_CTRL                                                          0x180080E4
+#define DC_64_READ_BUF_CTRL_reg_addr                                                 "0xB80080E4"
+#define DC_64_READ_BUF_CTRL_reg                                                      0xB80080E4
+#define set_DC_64_READ_BUF_CTRL_reg(data)   (*((volatile unsigned int*) DC_64_READ_BUF_CTRL_reg)=data)
+#define get_DC_64_READ_BUF_CTRL_reg   (*((volatile unsigned int*) DC_64_READ_BUF_CTRL_reg))
+#define DC_64_READ_BUF_CTRL_inst_adr                                                 "0x0039"
+#define DC_64_READ_BUF_CTRL_inst                                                     0x0039
+#define DC_64_READ_BUF_CTRL_sync_cmd_cnt_threshold_shift                             (21)
+#define DC_64_READ_BUF_CTRL_sync_cmd_cnt_threshold_mask                              (0x00E00000)
+#define DC_64_READ_BUF_CTRL_sync_cmd_cnt_threshold(data)                             (0x00E00000&((data)<<21))
+#define DC_64_READ_BUF_CTRL_sync_cmd_cnt_threshold_src(data)                         ((0x00E00000&(data))>>21)
+#define DC_64_READ_BUF_CTRL_get_sync_cmd_cnt_threshold(data)                         ((0x00E00000&(data))>>21)
+#define DC_64_READ_BUF_CTRL_cmd_buf_threshold_shift                                  (17)
+#define DC_64_READ_BUF_CTRL_cmd_buf_threshold_mask                                   (0x001E0000)
+#define DC_64_READ_BUF_CTRL_cmd_buf_threshold(data)                                  (0x001E0000&((data)<<17))
+#define DC_64_READ_BUF_CTRL_cmd_buf_threshold_src(data)                              ((0x001E0000&(data))>>17)
+#define DC_64_READ_BUF_CTRL_get_cmd_buf_threshold(data)                              ((0x001E0000&(data))>>17)
+#define DC_64_READ_BUF_CTRL_disable_2nd_channel_shift                                (16)
+#define DC_64_READ_BUF_CTRL_disable_2nd_channel_mask                                 (0x00010000)
+#define DC_64_READ_BUF_CTRL_disable_2nd_channel(data)                                (0x00010000&((data)<<16))
+#define DC_64_READ_BUF_CTRL_disable_2nd_channel_src(data)                            ((0x00010000&(data))>>16)
+#define DC_64_READ_BUF_CTRL_get_disable_2nd_channel(data)                            ((0x00010000&(data))>>16)
+#define DC_64_READ_BUF_CTRL_ever_full_shift                                          (15)
+#define DC_64_READ_BUF_CTRL_ever_full_mask                                           (0x00008000)
+#define DC_64_READ_BUF_CTRL_ever_full(data)                                          (0x00008000&((data)<<15))
+#define DC_64_READ_BUF_CTRL_ever_full_src(data)                                      ((0x00008000&(data))>>15)
+#define DC_64_READ_BUF_CTRL_get_ever_full(data)                                      ((0x00008000&(data))>>15)
+#define DC_64_READ_BUF_CTRL_ever_reach_threshold_shift                               (14)
+#define DC_64_READ_BUF_CTRL_ever_reach_threshold_mask                                (0x00004000)
+#define DC_64_READ_BUF_CTRL_ever_reach_threshold(data)                               (0x00004000&((data)<<14))
+#define DC_64_READ_BUF_CTRL_ever_reach_threshold_src(data)                           ((0x00004000&(data))>>14)
+#define DC_64_READ_BUF_CTRL_get_ever_reach_threshold(data)                           ((0x00004000&(data))>>14)
+#define DC_64_READ_BUF_CTRL_max_buf_level_shift                                      (7)
+#define DC_64_READ_BUF_CTRL_max_buf_level_mask                                       (0x00003F80)
+#define DC_64_READ_BUF_CTRL_max_buf_level(data)                                      (0x00003F80&((data)<<7))
+#define DC_64_READ_BUF_CTRL_max_buf_level_src(data)                                  ((0x00003F80&(data))>>7)
+#define DC_64_READ_BUF_CTRL_get_max_buf_level(data)                                  ((0x00003F80&(data))>>7)
+#define DC_64_READ_BUF_CTRL_grant_stop_level_shift                                   (0)
+#define DC_64_READ_BUF_CTRL_grant_stop_level_mask                                    (0x0000007F)
+#define DC_64_READ_BUF_CTRL_grant_stop_level(data)                                   (0x0000007F&((data)<<0))
+#define DC_64_READ_BUF_CTRL_grant_stop_level_src(data)                               ((0x0000007F&(data))>>0)
+#define DC_64_READ_BUF_CTRL_get_grant_stop_level(data)                               ((0x0000007F&(data))>>0)
+
+
+#define DC_PIC_OFFSET_X_DETECTION                                                    0x18008110
+#define DC_PIC_OFFSET_X_DETECTION_reg_addr                                           "0xB8008110"
+#define DC_PIC_OFFSET_X_DETECTION_reg                                                0xB8008110
+#define set_DC_PIC_OFFSET_X_DETECTION_reg(data)   (*((volatile unsigned int*) DC_PIC_OFFSET_X_DETECTION_reg)=data)
+#define get_DC_PIC_OFFSET_X_DETECTION_reg   (*((volatile unsigned int*) DC_PIC_OFFSET_X_DETECTION_reg))
+#define DC_PIC_OFFSET_X_DETECTION_inst_adr                                           "0x0044"
+#define DC_PIC_OFFSET_X_DETECTION_inst                                               0x0044
+#define DC_PIC_OFFSET_X_DETECTION_pict_set_int_cpu_shift                             (3)
+#define DC_PIC_OFFSET_X_DETECTION_pict_set_int_cpu_mask                              (0x00000018)
+#define DC_PIC_OFFSET_X_DETECTION_pict_set_int_cpu(data)                             (0x00000018&((data)<<3))
+#define DC_PIC_OFFSET_X_DETECTION_pict_set_int_cpu_src(data)                         ((0x00000018&(data))>>3)
+#define DC_PIC_OFFSET_X_DETECTION_get_pict_set_int_cpu(data)                         ((0x00000018&(data))>>3)
+#define DC_PIC_OFFSET_X_DETECTION_int_enable_shift                                   (2)
+#define DC_PIC_OFFSET_X_DETECTION_int_enable_mask                                    (0x00000004)
+#define DC_PIC_OFFSET_X_DETECTION_int_enable(data)                                   (0x00000004&((data)<<2))
+#define DC_PIC_OFFSET_X_DETECTION_int_enable_src(data)                               ((0x00000004&(data))>>2)
+#define DC_PIC_OFFSET_X_DETECTION_get_int_enable(data)                               ((0x00000004&(data))>>2)
+#define DC_PIC_OFFSET_X_DETECTION_ever_set_as_odd_shift                              (1)
+#define DC_PIC_OFFSET_X_DETECTION_ever_set_as_odd_mask                               (0x00000002)
+#define DC_PIC_OFFSET_X_DETECTION_ever_set_as_odd(data)                              (0x00000002&((data)<<1))
+#define DC_PIC_OFFSET_X_DETECTION_ever_set_as_odd_src(data)                          ((0x00000002&(data))>>1)
+#define DC_PIC_OFFSET_X_DETECTION_get_ever_set_as_odd(data)                          ((0x00000002&(data))>>1)
+#define DC_PIC_OFFSET_X_DETECTION_enable_shift                                       (0)
+#define DC_PIC_OFFSET_X_DETECTION_enable_mask                                        (0x00000001)
+#define DC_PIC_OFFSET_X_DETECTION_enable(data)                                       (0x00000001&((data)<<0))
+#define DC_PIC_OFFSET_X_DETECTION_enable_src(data)                                   ((0x00000001&(data))>>0)
+#define DC_PIC_OFFSET_X_DETECTION_get_enable(data)                                   ((0x00000001&(data))>>0)
+
+
+#define PHY_BIST_RM                                                                  0x180081B0
+#define PHY_BIST_RM_reg_addr                                                         "0xB80081B0"
+#define PHY_BIST_RM_reg                                                              0xB80081B0
+#define set_PHY_BIST_RM_reg(data)   (*((volatile unsigned int*) PHY_BIST_RM_reg)=data)
+#define get_PHY_BIST_RM_reg   (*((volatile unsigned int*) PHY_BIST_RM_reg))
+#define PHY_BIST_RM_inst_adr                                                         "0x006C"
+#define PHY_BIST_RM_inst                                                             0x006C
+#define PHY_BIST_RM_bist_en_0_shift                                                  (16)
+#define PHY_BIST_RM_bist_en_0_mask                                                   (0x00010000)
+#define PHY_BIST_RM_bist_en_0(data)                                                  (0x00010000&((data)<<16))
+#define PHY_BIST_RM_bist_en_0_src(data)                                              ((0x00010000&(data))>>16)
+#define PHY_BIST_RM_get_bist_en_0(data)                                              ((0x00010000&(data))>>16)
+#define PHY_BIST_RM_drf_bist_en_0_shift                                              (15)
+#define PHY_BIST_RM_drf_bist_en_0_mask                                               (0x00008000)
+#define PHY_BIST_RM_drf_bist_en_0(data)                                              (0x00008000&((data)<<15))
+#define PHY_BIST_RM_drf_bist_en_0_src(data)                                          ((0x00008000&(data))>>15)
+#define PHY_BIST_RM_get_drf_bist_en_0(data)                                          ((0x00008000&(data))>>15)
+#define PHY_BIST_RM_drf_test_resume_0_shift                                          (14)
+#define PHY_BIST_RM_drf_test_resume_0_mask                                           (0x00004000)
+#define PHY_BIST_RM_drf_test_resume_0(data)                                          (0x00004000&((data)<<14))
+#define PHY_BIST_RM_drf_test_resume_0_src(data)                                      ((0x00004000&(data))>>14)
+#define PHY_BIST_RM_get_drf_test_resume_0(data)                                      ((0x00004000&(data))>>14)
+#define PHY_BIST_RM_RMEA_shift                                                       (12)
+#define PHY_BIST_RM_RMEA_mask                                                        (0x00001000)
+#define PHY_BIST_RM_RMEA(data)                                                       (0x00001000&((data)<<12))
+#define PHY_BIST_RM_RMEA_src(data)                                                   ((0x00001000&(data))>>12)
+#define PHY_BIST_RM_get_RMEA(data)                                                   ((0x00001000&(data))>>12)
+#define PHY_BIST_RM_RMA_3_shift                                                      (11)
+#define PHY_BIST_RM_RMA_3_mask                                                       (0x00000800)
+#define PHY_BIST_RM_RMA_3(data)                                                      (0x00000800&((data)<<11))
+#define PHY_BIST_RM_RMA_3_src(data)                                                  ((0x00000800&(data))>>11)
+#define PHY_BIST_RM_get_RMA_3(data)                                                  ((0x00000800&(data))>>11)
+#define PHY_BIST_RM_RMA_2_shift                                                      (10)
+#define PHY_BIST_RM_RMA_2_mask                                                       (0x00000400)
+#define PHY_BIST_RM_RMA_2(data)                                                      (0x00000400&((data)<<10))
+#define PHY_BIST_RM_RMA_2_src(data)                                                  ((0x00000400&(data))>>10)
+#define PHY_BIST_RM_get_RMA_2(data)                                                  ((0x00000400&(data))>>10)
+#define PHY_BIST_RM_RMA_1_shift                                                      (9)
+#define PHY_BIST_RM_RMA_1_mask                                                       (0x00000200)
+#define PHY_BIST_RM_RMA_1(data)                                                      (0x00000200&((data)<<9))
+#define PHY_BIST_RM_RMA_1_src(data)                                                  ((0x00000200&(data))>>9)
+#define PHY_BIST_RM_get_RMA_1(data)                                                  ((0x00000200&(data))>>9)
+#define PHY_BIST_RM_RMA_0_shift                                                      (8)
+#define PHY_BIST_RM_RMA_0_mask                                                       (0x00000100)
+#define PHY_BIST_RM_RMA_0(data)                                                      (0x00000100&((data)<<8))
+#define PHY_BIST_RM_RMA_0_src(data)                                                  ((0x00000100&(data))>>8)
+#define PHY_BIST_RM_get_RMA_0(data)                                                  ((0x00000100&(data))>>8)
+#define PHY_BIST_RM_RMEB_shift                                                       (4)
+#define PHY_BIST_RM_RMEB_mask                                                        (0x00000010)
+#define PHY_BIST_RM_RMEB(data)                                                       (0x00000010&((data)<<4))
+#define PHY_BIST_RM_RMEB_src(data)                                                   ((0x00000010&(data))>>4)
+#define PHY_BIST_RM_get_RMEB(data)                                                   ((0x00000010&(data))>>4)
+#define PHY_BIST_RM_RMB_3_shift                                                      (3)
+#define PHY_BIST_RM_RMB_3_mask                                                       (0x00000008)
+#define PHY_BIST_RM_RMB_3(data)                                                      (0x00000008&((data)<<3))
+#define PHY_BIST_RM_RMB_3_src(data)                                                  ((0x00000008&(data))>>3)
+#define PHY_BIST_RM_get_RMB_3(data)                                                  ((0x00000008&(data))>>3)
+#define PHY_BIST_RM_RMB_2_shift                                                      (2)
+#define PHY_BIST_RM_RMB_2_mask                                                       (0x00000004)
+#define PHY_BIST_RM_RMB_2(data)                                                      (0x00000004&((data)<<2))
+#define PHY_BIST_RM_RMB_2_src(data)                                                  ((0x00000004&(data))>>2)
+#define PHY_BIST_RM_get_RMB_2(data)                                                  ((0x00000004&(data))>>2)
+#define PHY_BIST_RM_RMB_1_shift                                                      (1)
+#define PHY_BIST_RM_RMB_1_mask                                                       (0x00000002)
+#define PHY_BIST_RM_RMB_1(data)                                                      (0x00000002&((data)<<1))
+#define PHY_BIST_RM_RMB_1_src(data)                                                  ((0x00000002&(data))>>1)
+#define PHY_BIST_RM_get_RMB_1(data)                                                  ((0x00000002&(data))>>1)
+#define PHY_BIST_RM_RMB_0_shift                                                      (0)
+#define PHY_BIST_RM_RMB_0_mask                                                       (0x00000001)
+#define PHY_BIST_RM_RMB_0(data)                                                      (0x00000001&((data)<<0))
+#define PHY_BIST_RM_RMB_0_src(data)                                                  ((0x00000001&(data))>>0)
+#define PHY_BIST_RM_get_RMB_0(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define PHY_BIST0_ST                                                                 0x180081B4
+#define PHY_BIST0_ST_reg_addr                                                        "0xB80081B4"
+#define PHY_BIST0_ST_reg                                                             0xB80081B4
+#define set_PHY_BIST0_ST_reg(data)   (*((volatile unsigned int*) PHY_BIST0_ST_reg)=data)
+#define get_PHY_BIST0_ST_reg   (*((volatile unsigned int*) PHY_BIST0_ST_reg))
+#define PHY_BIST0_ST_inst_adr                                                        "0x006D"
+#define PHY_BIST0_ST_inst                                                            0x006D
+#define PHY_BIST0_ST_mbist_st_shift                                                  (2)
+#define PHY_BIST0_ST_mbist_st_mask                                                   (0x00000004)
+#define PHY_BIST0_ST_mbist_st(data)                                                  (0x00000004&((data)<<2))
+#define PHY_BIST0_ST_mbist_st_src(data)                                              ((0x00000004&(data))>>2)
+#define PHY_BIST0_ST_get_mbist_st(data)                                              ((0x00000004&(data))>>2)
+#define PHY_BIST0_ST_bist_fail_shift                                                 (1)
+#define PHY_BIST0_ST_bist_fail_mask                                                  (0x00000002)
+#define PHY_BIST0_ST_bist_fail(data)                                                 (0x00000002&((data)<<1))
+#define PHY_BIST0_ST_bist_fail_src(data)                                             ((0x00000002&(data))>>1)
+#define PHY_BIST0_ST_get_bist_fail(data)                                             ((0x00000002&(data))>>1)
+#define PHY_BIST0_ST_bist_done_shift                                                 (0)
+#define PHY_BIST0_ST_bist_done_mask                                                  (0x00000001)
+#define PHY_BIST0_ST_bist_done(data)                                                 (0x00000001&((data)<<0))
+#define PHY_BIST0_ST_bist_done_src(data)                                             ((0x00000001&(data))>>0)
+#define PHY_BIST0_ST_get_bist_done(data)                                             ((0x00000001&(data))>>0)
+
+
+#define PHY_DRF0_ST                                                                  0x180081B8
+#define PHY_DRF0_ST_reg_addr                                                         "0xB80081B8"
+#define PHY_DRF0_ST_reg                                                              0xB80081B8
+#define set_PHY_DRF0_ST_reg(data)   (*((volatile unsigned int*) PHY_DRF0_ST_reg)=data)
+#define get_PHY_DRF0_ST_reg   (*((volatile unsigned int*) PHY_DRF0_ST_reg))
+#define PHY_DRF0_ST_inst_adr                                                         "0x006E"
+#define PHY_DRF0_ST_inst                                                             0x006E
+#define PHY_DRF0_ST_drf_start_pause_shift                                            (16)
+#define PHY_DRF0_ST_drf_start_pause_mask                                             (0x00010000)
+#define PHY_DRF0_ST_drf_start_pause(data)                                            (0x00010000&((data)<<16))
+#define PHY_DRF0_ST_drf_start_pause_src(data)                                        ((0x00010000&(data))>>16)
+#define PHY_DRF0_ST_get_drf_start_pause(data)                                        ((0x00010000&(data))>>16)
+#define PHY_DRF0_ST_drf_fail_shift                                                   (1)
+#define PHY_DRF0_ST_drf_fail_mask                                                    (0x00000002)
+#define PHY_DRF0_ST_drf_fail(data)                                                   (0x00000002&((data)<<1))
+#define PHY_DRF0_ST_drf_fail_src(data)                                               ((0x00000002&(data))>>1)
+#define PHY_DRF0_ST_get_drf_fail(data)                                               ((0x00000002&(data))>>1)
+#define PHY_DRF0_ST_drf_done_shift                                                   (0)
+#define PHY_DRF0_ST_drf_done_mask                                                    (0x00000001)
+#define PHY_DRF0_ST_drf_done(data)                                                   (0x00000001&((data)<<0))
+#define PHY_DRF0_ST_drf_done_src(data)                                               ((0x00000001&(data))>>0)
+#define PHY_DRF0_ST_get_drf_done(data)                                               ((0x00000001&(data))>>0)
+
+
+#define PHY_BIST1_ST                                                                 0x180081BC
+#define PHY_BIST1_ST_reg_addr                                                        "0xB80081BC"
+#define PHY_BIST1_ST_reg                                                             0xB80081BC
+#define set_PHY_BIST1_ST_reg(data)   (*((volatile unsigned int*) PHY_BIST1_ST_reg)=data)
+#define get_PHY_BIST1_ST_reg   (*((volatile unsigned int*) PHY_BIST1_ST_reg))
+#define PHY_BIST1_ST_inst_adr                                                        "0x006F"
+#define PHY_BIST1_ST_inst                                                            0x006F
+#define PHY_BIST1_ST_mbist_st_shift                                                  (2)
+#define PHY_BIST1_ST_mbist_st_mask                                                   (0x00000004)
+#define PHY_BIST1_ST_mbist_st(data)                                                  (0x00000004&((data)<<2))
+#define PHY_BIST1_ST_mbist_st_src(data)                                              ((0x00000004&(data))>>2)
+#define PHY_BIST1_ST_get_mbist_st(data)                                              ((0x00000004&(data))>>2)
+#define PHY_BIST1_ST_bist_fail_shift                                                 (1)
+#define PHY_BIST1_ST_bist_fail_mask                                                  (0x00000002)
+#define PHY_BIST1_ST_bist_fail(data)                                                 (0x00000002&((data)<<1))
+#define PHY_BIST1_ST_bist_fail_src(data)                                             ((0x00000002&(data))>>1)
+#define PHY_BIST1_ST_get_bist_fail(data)                                             ((0x00000002&(data))>>1)
+#define PHY_BIST1_ST_bist_done_shift                                                 (0)
+#define PHY_BIST1_ST_bist_done_mask                                                  (0x00000001)
+#define PHY_BIST1_ST_bist_done(data)                                                 (0x00000001&((data)<<0))
+#define PHY_BIST1_ST_bist_done_src(data)                                             ((0x00000001&(data))>>0)
+#define PHY_BIST1_ST_get_bist_done(data)                                             ((0x00000001&(data))>>0)
+
+
+#define PHY_DRF1_ST                                                                  0x180081C0
+#define PHY_DRF1_ST_reg_addr                                                         "0xB80081C0"
+#define PHY_DRF1_ST_reg                                                              0xB80081C0
+#define set_PHY_DRF1_ST_reg(data)   (*((volatile unsigned int*) PHY_DRF1_ST_reg)=data)
+#define get_PHY_DRF1_ST_reg   (*((volatile unsigned int*) PHY_DRF1_ST_reg))
+#define PHY_DRF1_ST_inst_adr                                                         "0x0070"
+#define PHY_DRF1_ST_inst                                                             0x0070
+#define PHY_DRF1_ST_drf_start_pause_shift                                            (16)
+#define PHY_DRF1_ST_drf_start_pause_mask                                             (0x00010000)
+#define PHY_DRF1_ST_drf_start_pause(data)                                            (0x00010000&((data)<<16))
+#define PHY_DRF1_ST_drf_start_pause_src(data)                                        ((0x00010000&(data))>>16)
+#define PHY_DRF1_ST_get_drf_start_pause(data)                                        ((0x00010000&(data))>>16)
+#define PHY_DRF1_ST_drf_fail_shift                                                   (1)
+#define PHY_DRF1_ST_drf_fail_mask                                                    (0x00000002)
+#define PHY_DRF1_ST_drf_fail(data)                                                   (0x00000002&((data)<<1))
+#define PHY_DRF1_ST_drf_fail_src(data)                                               ((0x00000002&(data))>>1)
+#define PHY_DRF1_ST_get_drf_fail(data)                                               ((0x00000002&(data))>>1)
+#define PHY_DRF1_ST_drf_done_shift                                                   (0)
+#define PHY_DRF1_ST_drf_done_mask                                                    (0x00000001)
+#define PHY_DRF1_ST_drf_done(data)                                                   (0x00000001&((data)<<0))
+#define PHY_DRF1_ST_drf_done_src(data)                                               ((0x00000001&(data))>>0)
+#define PHY_DRF1_ST_get_drf_done(data)                                               ((0x00000001&(data))>>0)
+
+
+#define BIST_RM                                                                      0x180081D0
+#define BIST_RM_reg_addr                                                             "0xB80081D0"
+#define BIST_RM_reg                                                                  0xB80081D0
+#define set_BIST_RM_reg(data)   (*((volatile unsigned int*) BIST_RM_reg)=data)
+#define get_BIST_RM_reg   (*((volatile unsigned int*) BIST_RM_reg))
+#define BIST_RM_inst_adr                                                             "0x0074"
+#define BIST_RM_inst                                                                 0x0074
+#define BIST_RM_bist_en_0_shift                                                      (31)
+#define BIST_RM_bist_en_0_mask                                                       (0x80000000)
+#define BIST_RM_bist_en_0(data)                                                      (0x80000000&((data)<<31))
+#define BIST_RM_bist_en_0_src(data)                                                  ((0x80000000&(data))>>31)
+#define BIST_RM_get_bist_en_0(data)                                                  ((0x80000000&(data))>>31)
+#define BIST_RM_drf_bist_en_0_shift                                                  (30)
+#define BIST_RM_drf_bist_en_0_mask                                                   (0x40000000)
+#define BIST_RM_drf_bist_en_0(data)                                                  (0x40000000&((data)<<30))
+#define BIST_RM_drf_bist_en_0_src(data)                                              ((0x40000000&(data))>>30)
+#define BIST_RM_get_drf_bist_en_0(data)                                              ((0x40000000&(data))>>30)
+#define BIST_RM_drf_test_resume_0_shift                                              (29)
+#define BIST_RM_drf_test_resume_0_mask                                               (0x20000000)
+#define BIST_RM_drf_test_resume_0(data)                                              (0x20000000&((data)<<29))
+#define BIST_RM_drf_test_resume_0_src(data)                                          ((0x20000000&(data))>>29)
+#define BIST_RM_get_drf_test_resume_0(data)                                          ((0x20000000&(data))>>29)
+#define BIST_RM_bist_en_1_shift                                                      (28)
+#define BIST_RM_bist_en_1_mask                                                       (0x10000000)
+#define BIST_RM_bist_en_1(data)                                                      (0x10000000&((data)<<28))
+#define BIST_RM_bist_en_1_src(data)                                                  ((0x10000000&(data))>>28)
+#define BIST_RM_get_bist_en_1(data)                                                  ((0x10000000&(data))>>28)
+#define BIST_RM_drf_bist_en_1_shift                                                  (27)
+#define BIST_RM_drf_bist_en_1_mask                                                   (0x08000000)
+#define BIST_RM_drf_bist_en_1(data)                                                  (0x08000000&((data)<<27))
+#define BIST_RM_drf_bist_en_1_src(data)                                              ((0x08000000&(data))>>27)
+#define BIST_RM_get_drf_bist_en_1(data)                                              ((0x08000000&(data))>>27)
+#define BIST_RM_drf_test_resume_1_shift                                              (26)
+#define BIST_RM_drf_test_resume_1_mask                                               (0x04000000)
+#define BIST_RM_drf_test_resume_1(data)                                              (0x04000000&((data)<<26))
+#define BIST_RM_drf_test_resume_1_src(data)                                          ((0x04000000&(data))>>26)
+#define BIST_RM_get_drf_test_resume_1(data)                                          ((0x04000000&(data))>>26)
+#define BIST_RM_DVSE_A_shift                                                         (20)
+#define BIST_RM_DVSE_A_mask                                                          (0x00100000)
+#define BIST_RM_DVSE_A(data)                                                         (0x00100000&((data)<<20))
+#define BIST_RM_DVSE_A_src(data)                                                     ((0x00100000&(data))>>20)
+#define BIST_RM_get_DVSE_A(data)                                                     ((0x00100000&(data))>>20)
+#define BIST_RM_DVS_A_3_shift                                                        (19)
+#define BIST_RM_DVS_A_3_mask                                                         (0x00080000)
+#define BIST_RM_DVS_A_3(data)                                                        (0x00080000&((data)<<19))
+#define BIST_RM_DVS_A_3_src(data)                                                    ((0x00080000&(data))>>19)
+#define BIST_RM_get_DVS_A_3(data)                                                    ((0x00080000&(data))>>19)
+#define BIST_RM_DVS_A_2_shift                                                        (18)
+#define BIST_RM_DVS_A_2_mask                                                         (0x00040000)
+#define BIST_RM_DVS_A_2(data)                                                        (0x00040000&((data)<<18))
+#define BIST_RM_DVS_A_2_src(data)                                                    ((0x00040000&(data))>>18)
+#define BIST_RM_get_DVS_A_2(data)                                                    ((0x00040000&(data))>>18)
+#define BIST_RM_DVS_A_1_shift                                                        (17)
+#define BIST_RM_DVS_A_1_mask                                                         (0x00020000)
+#define BIST_RM_DVS_A_1(data)                                                        (0x00020000&((data)<<17))
+#define BIST_RM_DVS_A_1_src(data)                                                    ((0x00020000&(data))>>17)
+#define BIST_RM_get_DVS_A_1(data)                                                    ((0x00020000&(data))>>17)
+#define BIST_RM_DVS_A_0_shift                                                        (16)
+#define BIST_RM_DVS_A_0_mask                                                         (0x00010000)
+#define BIST_RM_DVS_A_0(data)                                                        (0x00010000&((data)<<16))
+#define BIST_RM_DVS_A_0_src(data)                                                    ((0x00010000&(data))>>16)
+#define BIST_RM_get_DVS_A_0(data)                                                    ((0x00010000&(data))>>16)
+#define BIST_RM_DVSE_shift                                                           (4)
+#define BIST_RM_DVSE_mask                                                            (0x00000010)
+#define BIST_RM_DVSE(data)                                                           (0x00000010&((data)<<4))
+#define BIST_RM_DVSE_src(data)                                                       ((0x00000010&(data))>>4)
+#define BIST_RM_get_DVSE(data)                                                       ((0x00000010&(data))>>4)
+#define BIST_RM_DVS_3_shift                                                          (3)
+#define BIST_RM_DVS_3_mask                                                           (0x00000008)
+#define BIST_RM_DVS_3(data)                                                          (0x00000008&((data)<<3))
+#define BIST_RM_DVS_3_src(data)                                                      ((0x00000008&(data))>>3)
+#define BIST_RM_get_DVS_3(data)                                                      ((0x00000008&(data))>>3)
+#define BIST_RM_DVS_2_shift                                                          (2)
+#define BIST_RM_DVS_2_mask                                                           (0x00000004)
+#define BIST_RM_DVS_2(data)                                                          (0x00000004&((data)<<2))
+#define BIST_RM_DVS_2_src(data)                                                      ((0x00000004&(data))>>2)
+#define BIST_RM_get_DVS_2(data)                                                      ((0x00000004&(data))>>2)
+#define BIST_RM_DVS_1_shift                                                          (1)
+#define BIST_RM_DVS_1_mask                                                           (0x00000002)
+#define BIST_RM_DVS_1(data)                                                          (0x00000002&((data)<<1))
+#define BIST_RM_DVS_1_src(data)                                                      ((0x00000002&(data))>>1)
+#define BIST_RM_get_DVS_1(data)                                                      ((0x00000002&(data))>>1)
+#define BIST_RM_DVS_0_shift                                                          (0)
+#define BIST_RM_DVS_0_mask                                                           (0x00000001)
+#define BIST_RM_DVS_0(data)                                                          (0x00000001&((data)<<0))
+#define BIST_RM_DVS_0_src(data)                                                      ((0x00000001&(data))>>0)
+#define BIST_RM_get_DVS_0(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define BIST0_ST                                                                     0x180081D4
+#define BIST0_ST_reg_addr                                                            "0xB80081D4"
+#define BIST0_ST_reg                                                                 0xB80081D4
+#define set_BIST0_ST_reg(data)   (*((volatile unsigned int*) BIST0_ST_reg)=data)
+#define get_BIST0_ST_reg   (*((volatile unsigned int*) BIST0_ST_reg))
+#define BIST0_ST_inst_adr                                                            "0x0075"
+#define BIST0_ST_inst                                                                0x0075
+#define BIST0_ST_mbist_st_shift                                                      (3)
+#define BIST0_ST_mbist_st_mask                                                       (0x00000008)
+#define BIST0_ST_mbist_st(data)                                                      (0x00000008&((data)<<3))
+#define BIST0_ST_mbist_st_src(data)                                                  ((0x00000008&(data))>>3)
+#define BIST0_ST_get_mbist_st(data)                                                  ((0x00000008&(data))>>3)
+#define BIST0_ST_bist_fail1_shift                                                    (2)
+#define BIST0_ST_bist_fail1_mask                                                     (0x00000004)
+#define BIST0_ST_bist_fail1(data)                                                    (0x00000004&((data)<<2))
+#define BIST0_ST_bist_fail1_src(data)                                                ((0x00000004&(data))>>2)
+#define BIST0_ST_get_bist_fail1(data)                                                ((0x00000004&(data))>>2)
+#define BIST0_ST_bist_fail0_shift                                                    (1)
+#define BIST0_ST_bist_fail0_mask                                                     (0x00000002)
+#define BIST0_ST_bist_fail0(data)                                                    (0x00000002&((data)<<1))
+#define BIST0_ST_bist_fail0_src(data)                                                ((0x00000002&(data))>>1)
+#define BIST0_ST_get_bist_fail0(data)                                                ((0x00000002&(data))>>1)
+#define BIST0_ST_bist_done_shift                                                     (0)
+#define BIST0_ST_bist_done_mask                                                      (0x00000001)
+#define BIST0_ST_bist_done(data)                                                     (0x00000001&((data)<<0))
+#define BIST0_ST_bist_done_src(data)                                                 ((0x00000001&(data))>>0)
+#define BIST0_ST_get_bist_done(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define DRF0_ST                                                                      0x180081D8
+#define DRF0_ST_reg_addr                                                             "0xB80081D8"
+#define DRF0_ST_reg                                                                  0xB80081D8
+#define set_DRF0_ST_reg(data)   (*((volatile unsigned int*) DRF0_ST_reg)=data)
+#define get_DRF0_ST_reg   (*((volatile unsigned int*) DRF0_ST_reg))
+#define DRF0_ST_inst_adr                                                             "0x0076"
+#define DRF0_ST_inst                                                                 0x0076
+#define DRF0_ST_drf_start_pause_shift                                                (16)
+#define DRF0_ST_drf_start_pause_mask                                                 (0x00010000)
+#define DRF0_ST_drf_start_pause(data)                                                (0x00010000&((data)<<16))
+#define DRF0_ST_drf_start_pause_src(data)                                            ((0x00010000&(data))>>16)
+#define DRF0_ST_get_drf_start_pause(data)                                            ((0x00010000&(data))>>16)
+#define DRF0_ST_drf_fail1_shift                                                      (2)
+#define DRF0_ST_drf_fail1_mask                                                       (0x00000004)
+#define DRF0_ST_drf_fail1(data)                                                      (0x00000004&((data)<<2))
+#define DRF0_ST_drf_fail1_src(data)                                                  ((0x00000004&(data))>>2)
+#define DRF0_ST_get_drf_fail1(data)                                                  ((0x00000004&(data))>>2)
+#define DRF0_ST_drf_fail0_shift                                                      (1)
+#define DRF0_ST_drf_fail0_mask                                                       (0x00000002)
+#define DRF0_ST_drf_fail0(data)                                                      (0x00000002&((data)<<1))
+#define DRF0_ST_drf_fail0_src(data)                                                  ((0x00000002&(data))>>1)
+#define DRF0_ST_get_drf_fail0(data)                                                  ((0x00000002&(data))>>1)
+#define DRF0_ST_drf_done_shift                                                       (0)
+#define DRF0_ST_drf_done_mask                                                        (0x00000001)
+#define DRF0_ST_drf_done(data)                                                       (0x00000001&((data)<<0))
+#define DRF0_ST_drf_done_src(data)                                                   ((0x00000001&(data))>>0)
+#define DRF0_ST_get_drf_done(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define BIST1_ST                                                                     0x180081DC
+#define BIST1_ST_reg_addr                                                            "0xB80081DC"
+#define BIST1_ST_reg                                                                 0xB80081DC
+#define set_BIST1_ST_reg(data)   (*((volatile unsigned int*) BIST1_ST_reg)=data)
+#define get_BIST1_ST_reg   (*((volatile unsigned int*) BIST1_ST_reg))
+#define BIST1_ST_inst_adr                                                            "0x0077"
+#define BIST1_ST_inst                                                                0x0077
+#define BIST1_ST_mbist_st_shift                                                      (2)
+#define BIST1_ST_mbist_st_mask                                                       (0x00000004)
+#define BIST1_ST_mbist_st(data)                                                      (0x00000004&((data)<<2))
+#define BIST1_ST_mbist_st_src(data)                                                  ((0x00000004&(data))>>2)
+#define BIST1_ST_get_mbist_st(data)                                                  ((0x00000004&(data))>>2)
+#define BIST1_ST_bist_fail0_shift                                                    (1)
+#define BIST1_ST_bist_fail0_mask                                                     (0x00000002)
+#define BIST1_ST_bist_fail0(data)                                                    (0x00000002&((data)<<1))
+#define BIST1_ST_bist_fail0_src(data)                                                ((0x00000002&(data))>>1)
+#define BIST1_ST_get_bist_fail0(data)                                                ((0x00000002&(data))>>1)
+#define BIST1_ST_bist_done_shift                                                     (0)
+#define BIST1_ST_bist_done_mask                                                      (0x00000001)
+#define BIST1_ST_bist_done(data)                                                     (0x00000001&((data)<<0))
+#define BIST1_ST_bist_done_src(data)                                                 ((0x00000001&(data))>>0)
+#define BIST1_ST_get_bist_done(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define DRF1_ST                                                                      0x180081E0
+#define DRF1_ST_reg_addr                                                             "0xB80081E0"
+#define DRF1_ST_reg                                                                  0xB80081E0
+#define set_DRF1_ST_reg(data)   (*((volatile unsigned int*) DRF1_ST_reg)=data)
+#define get_DRF1_ST_reg   (*((volatile unsigned int*) DRF1_ST_reg))
+#define DRF1_ST_inst_adr                                                             "0x0078"
+#define DRF1_ST_inst                                                                 0x0078
+#define DRF1_ST_drf_start_pause_shift                                                (16)
+#define DRF1_ST_drf_start_pause_mask                                                 (0x00010000)
+#define DRF1_ST_drf_start_pause(data)                                                (0x00010000&((data)<<16))
+#define DRF1_ST_drf_start_pause_src(data)                                            ((0x00010000&(data))>>16)
+#define DRF1_ST_get_drf_start_pause(data)                                            ((0x00010000&(data))>>16)
+#define DRF1_ST_drf_fail0_shift                                                      (1)
+#define DRF1_ST_drf_fail0_mask                                                       (0x00000002)
+#define DRF1_ST_drf_fail0(data)                                                      (0x00000002&((data)<<1))
+#define DRF1_ST_drf_fail0_src(data)                                                  ((0x00000002&(data))>>1)
+#define DRF1_ST_get_drf_fail0(data)                                                  ((0x00000002&(data))>>1)
+#define DRF1_ST_drf_done_shift                                                       (0)
+#define DRF1_ST_drf_done_mask                                                        (0x00000001)
+#define DRF1_ST_drf_done(data)                                                       (0x00000001&((data)<<0))
+#define DRF1_ST_drf_done_src(data)                                                   ((0x00000001&(data))>>0)
+#define DRF1_ST_get_drf_done(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define DUMMY_REG0                                                                   0x180081F0
+#define DUMMY_REG0_reg_addr                                                          "0xB80081F0"
+#define DUMMY_REG0_reg                                                               0xB80081F0
+#define set_DUMMY_REG0_reg(data)   (*((volatile unsigned int*) DUMMY_REG0_reg)=data)
+#define get_DUMMY_REG0_reg   (*((volatile unsigned int*) DUMMY_REG0_reg))
+#define DUMMY_REG0_inst_adr                                                          "0x007C"
+#define DUMMY_REG0_inst                                                              0x007C
+#define DUMMY_REG0_dummy_reg0_shift                                                  (0)
+#define DUMMY_REG0_dummy_reg0_mask                                                   (0xFFFFFFFF)
+#define DUMMY_REG0_dummy_reg0(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define DUMMY_REG0_dummy_reg0_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define DUMMY_REG0_get_dummy_reg0(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define DUMMY_REG1                                                                   0x180081F4
+#define DUMMY_REG1_reg_addr                                                          "0xB80081F4"
+#define DUMMY_REG1_reg                                                               0xB80081F4
+#define set_DUMMY_REG1_reg(data)   (*((volatile unsigned int*) DUMMY_REG1_reg)=data)
+#define get_DUMMY_REG1_reg   (*((volatile unsigned int*) DUMMY_REG1_reg))
+#define DUMMY_REG1_inst_adr                                                          "0x007D"
+#define DUMMY_REG1_inst                                                              0x007D
+#define DUMMY_REG1_dummy_reg1_shift                                                  (0)
+#define DUMMY_REG1_dummy_reg1_mask                                                   (0xFFFFFFFF)
+#define DUMMY_REG1_dummy_reg1(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define DUMMY_REG1_dummy_reg1_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define DUMMY_REG1_get_dummy_reg1(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define DUMMY_REG2                                                                   0x180081F8
+#define DUMMY_REG2_reg_addr                                                          "0xB80081F8"
+#define DUMMY_REG2_reg                                                               0xB80081F8
+#define set_DUMMY_REG2_reg(data)   (*((volatile unsigned int*) DUMMY_REG2_reg)=data)
+#define get_DUMMY_REG2_reg   (*((volatile unsigned int*) DUMMY_REG2_reg))
+#define DUMMY_REG2_inst_adr                                                          "0x007E"
+#define DUMMY_REG2_inst                                                              0x007E
+#define DUMMY_REG2_dummy_reg2_shift                                                  (0)
+#define DUMMY_REG2_dummy_reg2_mask                                                   (0xFFFFFFFF)
+#define DUMMY_REG2_dummy_reg2(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define DUMMY_REG2_dummy_reg2_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define DUMMY_REG2_get_dummy_reg2(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define DUMMY_REG3                                                                   0x180081FC
+#define DUMMY_REG3_reg_addr                                                          "0xB80081FC"
+#define DUMMY_REG3_reg                                                               0xB80081FC
+#define set_DUMMY_REG3_reg(data)   (*((volatile unsigned int*) DUMMY_REG3_reg)=data)
+#define get_DUMMY_REG3_reg   (*((volatile unsigned int*) DUMMY_REG3_reg))
+#define DUMMY_REG3_inst_adr                                                          "0x007F"
+#define DUMMY_REG3_inst                                                              0x007F
+#define DUMMY_REG3_dummy_reg3_shift                                                  (0)
+#define DUMMY_REG3_dummy_reg3_mask                                                   (0xFFFFFFFF)
+#define DUMMY_REG3_dummy_reg3(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define DUMMY_REG3_dummy_reg3_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define DUMMY_REG3_get_dummy_reg3(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_MT_SADDR_0                                                                0x18008200
+#define DC_MT_SADDR_1                                                                0x18008204
+#define DC_MT_SADDR_2                                                                0x18008208
+#define DC_MT_SADDR_3                                                                0x1800820C
+#define DC_MT_SADDR_4                                                                0x18008210
+#define DC_MT_SADDR_5                                                                0x18008214
+#define DC_MT_SADDR_6                                                                0x18008218
+#define DC_MT_SADDR_7                                                                0x1800821C
+#define DC_MT_SADDR_0_reg_addr                                                       "0xB8008200"
+#define DC_MT_SADDR_1_reg_addr                                                       "0xB8008204"
+#define DC_MT_SADDR_2_reg_addr                                                       "0xB8008208"
+#define DC_MT_SADDR_3_reg_addr                                                       "0xB800820C"
+#define DC_MT_SADDR_4_reg_addr                                                       "0xB8008210"
+#define DC_MT_SADDR_5_reg_addr                                                       "0xB8008214"
+#define DC_MT_SADDR_6_reg_addr                                                       "0xB8008218"
+#define DC_MT_SADDR_7_reg_addr                                                       "0xB800821C"
+#define DC_MT_SADDR_0_reg                                                            0xB8008200
+#define DC_MT_SADDR_1_reg                                                            0xB8008204
+#define DC_MT_SADDR_2_reg                                                            0xB8008208
+#define DC_MT_SADDR_3_reg                                                            0xB800820C
+#define DC_MT_SADDR_4_reg                                                            0xB8008210
+#define DC_MT_SADDR_5_reg                                                            0xB8008214
+#define DC_MT_SADDR_6_reg                                                            0xB8008218
+#define DC_MT_SADDR_7_reg                                                            0xB800821C
+#define set_DC_MT_SADDR_0_reg(data)   (*((volatile unsigned int*) DC_MT_SADDR_0_reg)=data)
+#define set_DC_MT_SADDR_1_reg(data)   (*((volatile unsigned int*) DC_MT_SADDR_1_reg)=data)
+#define set_DC_MT_SADDR_2_reg(data)   (*((volatile unsigned int*) DC_MT_SADDR_2_reg)=data)
+#define set_DC_MT_SADDR_3_reg(data)   (*((volatile unsigned int*) DC_MT_SADDR_3_reg)=data)
+#define set_DC_MT_SADDR_4_reg(data)   (*((volatile unsigned int*) DC_MT_SADDR_4_reg)=data)
+#define set_DC_MT_SADDR_5_reg(data)   (*((volatile unsigned int*) DC_MT_SADDR_5_reg)=data)
+#define set_DC_MT_SADDR_6_reg(data)   (*((volatile unsigned int*) DC_MT_SADDR_6_reg)=data)
+#define set_DC_MT_SADDR_7_reg(data)   (*((volatile unsigned int*) DC_MT_SADDR_7_reg)=data)
+#define get_DC_MT_SADDR_0_reg   (*((volatile unsigned int*) DC_MT_SADDR_0_reg))
+#define get_DC_MT_SADDR_1_reg   (*((volatile unsigned int*) DC_MT_SADDR_1_reg))
+#define get_DC_MT_SADDR_2_reg   (*((volatile unsigned int*) DC_MT_SADDR_2_reg))
+#define get_DC_MT_SADDR_3_reg   (*((volatile unsigned int*) DC_MT_SADDR_3_reg))
+#define get_DC_MT_SADDR_4_reg   (*((volatile unsigned int*) DC_MT_SADDR_4_reg))
+#define get_DC_MT_SADDR_5_reg   (*((volatile unsigned int*) DC_MT_SADDR_5_reg))
+#define get_DC_MT_SADDR_6_reg   (*((volatile unsigned int*) DC_MT_SADDR_6_reg))
+#define get_DC_MT_SADDR_7_reg   (*((volatile unsigned int*) DC_MT_SADDR_7_reg))
+#define DC_MT_SADDR_0_inst_adr                                                       "0x0080"
+#define DC_MT_SADDR_1_inst_adr                                                       "0x0081"
+#define DC_MT_SADDR_2_inst_adr                                                       "0x0082"
+#define DC_MT_SADDR_3_inst_adr                                                       "0x0083"
+#define DC_MT_SADDR_4_inst_adr                                                       "0x0084"
+#define DC_MT_SADDR_5_inst_adr                                                       "0x0085"
+#define DC_MT_SADDR_6_inst_adr                                                       "0x0086"
+#define DC_MT_SADDR_7_inst_adr                                                       "0x0087"
+#define DC_MT_SADDR_0_inst                                                           0x0080
+#define DC_MT_SADDR_1_inst                                                           0x0081
+#define DC_MT_SADDR_2_inst                                                           0x0082
+#define DC_MT_SADDR_3_inst                                                           0x0083
+#define DC_MT_SADDR_4_inst                                                           0x0084
+#define DC_MT_SADDR_5_inst                                                           0x0085
+#define DC_MT_SADDR_6_inst                                                           0x0086
+#define DC_MT_SADDR_7_inst                                                           0x0087
+#define DC_MT_SADDR_mem_type_shift                                                   (30)
+#define DC_MT_SADDR_mem_type_mask                                                    (0xC0000000)
+#define DC_MT_SADDR_mem_type(data)                                                   (0xC0000000&((data)<<30))
+#define DC_MT_SADDR_mem_type_src(data)                                               ((0xC0000000&(data))>>30)
+#define DC_MT_SADDR_get_mem_type(data)                                               ((0xC0000000&(data))>>30)
+#define DC_MT_SADDR_saddr_shift                                                      (4)
+#define DC_MT_SADDR_saddr_mask                                                       (0x3FFFFFF0)
+#define DC_MT_SADDR_saddr(data)                                                      (0x3FFFFFF0&((data)<<4))
+#define DC_MT_SADDR_saddr_src(data)                                                  ((0x3FFFFFF0&(data))>>4)
+#define DC_MT_SADDR_get_saddr(data)                                                  ((0x3FFFFFF0&(data))>>4)
+
+
+#define DC_MT_EADDR_0                                                                0x18008220
+#define DC_MT_EADDR_1                                                                0x18008224
+#define DC_MT_EADDR_2                                                                0x18008228
+#define DC_MT_EADDR_3                                                                0x1800822C
+#define DC_MT_EADDR_4                                                                0x18008230
+#define DC_MT_EADDR_5                                                                0x18008234
+#define DC_MT_EADDR_6                                                                0x18008238
+#define DC_MT_EADDR_7                                                                0x1800823C
+#define DC_MT_EADDR_0_reg_addr                                                       "0xB8008220"
+#define DC_MT_EADDR_1_reg_addr                                                       "0xB8008224"
+#define DC_MT_EADDR_2_reg_addr                                                       "0xB8008228"
+#define DC_MT_EADDR_3_reg_addr                                                       "0xB800822C"
+#define DC_MT_EADDR_4_reg_addr                                                       "0xB8008230"
+#define DC_MT_EADDR_5_reg_addr                                                       "0xB8008234"
+#define DC_MT_EADDR_6_reg_addr                                                       "0xB8008238"
+#define DC_MT_EADDR_7_reg_addr                                                       "0xB800823C"
+#define DC_MT_EADDR_0_reg                                                            0xB8008220
+#define DC_MT_EADDR_1_reg                                                            0xB8008224
+#define DC_MT_EADDR_2_reg                                                            0xB8008228
+#define DC_MT_EADDR_3_reg                                                            0xB800822C
+#define DC_MT_EADDR_4_reg                                                            0xB8008230
+#define DC_MT_EADDR_5_reg                                                            0xB8008234
+#define DC_MT_EADDR_6_reg                                                            0xB8008238
+#define DC_MT_EADDR_7_reg                                                            0xB800823C
+#define set_DC_MT_EADDR_0_reg(data)   (*((volatile unsigned int*) DC_MT_EADDR_0_reg)=data)
+#define set_DC_MT_EADDR_1_reg(data)   (*((volatile unsigned int*) DC_MT_EADDR_1_reg)=data)
+#define set_DC_MT_EADDR_2_reg(data)   (*((volatile unsigned int*) DC_MT_EADDR_2_reg)=data)
+#define set_DC_MT_EADDR_3_reg(data)   (*((volatile unsigned int*) DC_MT_EADDR_3_reg)=data)
+#define set_DC_MT_EADDR_4_reg(data)   (*((volatile unsigned int*) DC_MT_EADDR_4_reg)=data)
+#define set_DC_MT_EADDR_5_reg(data)   (*((volatile unsigned int*) DC_MT_EADDR_5_reg)=data)
+#define set_DC_MT_EADDR_6_reg(data)   (*((volatile unsigned int*) DC_MT_EADDR_6_reg)=data)
+#define set_DC_MT_EADDR_7_reg(data)   (*((volatile unsigned int*) DC_MT_EADDR_7_reg)=data)
+#define get_DC_MT_EADDR_0_reg   (*((volatile unsigned int*) DC_MT_EADDR_0_reg))
+#define get_DC_MT_EADDR_1_reg   (*((volatile unsigned int*) DC_MT_EADDR_1_reg))
+#define get_DC_MT_EADDR_2_reg   (*((volatile unsigned int*) DC_MT_EADDR_2_reg))
+#define get_DC_MT_EADDR_3_reg   (*((volatile unsigned int*) DC_MT_EADDR_3_reg))
+#define get_DC_MT_EADDR_4_reg   (*((volatile unsigned int*) DC_MT_EADDR_4_reg))
+#define get_DC_MT_EADDR_5_reg   (*((volatile unsigned int*) DC_MT_EADDR_5_reg))
+#define get_DC_MT_EADDR_6_reg   (*((volatile unsigned int*) DC_MT_EADDR_6_reg))
+#define get_DC_MT_EADDR_7_reg   (*((volatile unsigned int*) DC_MT_EADDR_7_reg))
+#define DC_MT_EADDR_0_inst_adr                                                       "0x0088"
+#define DC_MT_EADDR_1_inst_adr                                                       "0x0089"
+#define DC_MT_EADDR_2_inst_adr                                                       "0x008A"
+#define DC_MT_EADDR_3_inst_adr                                                       "0x008B"
+#define DC_MT_EADDR_4_inst_adr                                                       "0x008C"
+#define DC_MT_EADDR_5_inst_adr                                                       "0x008D"
+#define DC_MT_EADDR_6_inst_adr                                                       "0x008E"
+#define DC_MT_EADDR_7_inst_adr                                                       "0x008F"
+#define DC_MT_EADDR_0_inst                                                           0x0088
+#define DC_MT_EADDR_1_inst                                                           0x0089
+#define DC_MT_EADDR_2_inst                                                           0x008A
+#define DC_MT_EADDR_3_inst                                                           0x008B
+#define DC_MT_EADDR_4_inst                                                           0x008C
+#define DC_MT_EADDR_5_inst                                                           0x008D
+#define DC_MT_EADDR_6_inst                                                           0x008E
+#define DC_MT_EADDR_7_inst                                                           0x008F
+#define DC_MT_EADDR_eaddr_shift                                                      (5)
+#define DC_MT_EADDR_eaddr_mask                                                       (0x7FFFFFE0)
+#define DC_MT_EADDR_eaddr(data)                                                      (0x7FFFFFE0&((data)<<5))
+#define DC_MT_EADDR_eaddr_src(data)                                                  ((0x7FFFFFE0&(data))>>5)
+#define DC_MT_EADDR_get_eaddr(data)                                                  ((0x7FFFFFE0&(data))>>5)
+
+
+#define DC_MT_MODE_0                                                                 0x18008240
+#define DC_MT_MODE_1                                                                 0x18008244
+#define DC_MT_MODE_2                                                                 0x18008248
+#define DC_MT_MODE_3                                                                 0x1800824C
+#define DC_MT_MODE_4                                                                 0x18008250
+#define DC_MT_MODE_5                                                                 0x18008254
+#define DC_MT_MODE_6                                                                 0x18008258
+#define DC_MT_MODE_7                                                                 0x1800825C
+#define DC_MT_MODE_0_reg_addr                                                        "0xB8008240"
+#define DC_MT_MODE_1_reg_addr                                                        "0xB8008244"
+#define DC_MT_MODE_2_reg_addr                                                        "0xB8008248"
+#define DC_MT_MODE_3_reg_addr                                                        "0xB800824C"
+#define DC_MT_MODE_4_reg_addr                                                        "0xB8008250"
+#define DC_MT_MODE_5_reg_addr                                                        "0xB8008254"
+#define DC_MT_MODE_6_reg_addr                                                        "0xB8008258"
+#define DC_MT_MODE_7_reg_addr                                                        "0xB800825C"
+#define DC_MT_MODE_0_reg                                                             0xB8008240
+#define DC_MT_MODE_1_reg                                                             0xB8008244
+#define DC_MT_MODE_2_reg                                                             0xB8008248
+#define DC_MT_MODE_3_reg                                                             0xB800824C
+#define DC_MT_MODE_4_reg                                                             0xB8008250
+#define DC_MT_MODE_5_reg                                                             0xB8008254
+#define DC_MT_MODE_6_reg                                                             0xB8008258
+#define DC_MT_MODE_7_reg                                                             0xB800825C
+#define set_DC_MT_MODE_0_reg(data)   (*((volatile unsigned int*) DC_MT_MODE_0_reg)=data)
+#define set_DC_MT_MODE_1_reg(data)   (*((volatile unsigned int*) DC_MT_MODE_1_reg)=data)
+#define set_DC_MT_MODE_2_reg(data)   (*((volatile unsigned int*) DC_MT_MODE_2_reg)=data)
+#define set_DC_MT_MODE_3_reg(data)   (*((volatile unsigned int*) DC_MT_MODE_3_reg)=data)
+#define set_DC_MT_MODE_4_reg(data)   (*((volatile unsigned int*) DC_MT_MODE_4_reg)=data)
+#define set_DC_MT_MODE_5_reg(data)   (*((volatile unsigned int*) DC_MT_MODE_5_reg)=data)
+#define set_DC_MT_MODE_6_reg(data)   (*((volatile unsigned int*) DC_MT_MODE_6_reg)=data)
+#define set_DC_MT_MODE_7_reg(data)   (*((volatile unsigned int*) DC_MT_MODE_7_reg)=data)
+#define get_DC_MT_MODE_0_reg   (*((volatile unsigned int*) DC_MT_MODE_0_reg))
+#define get_DC_MT_MODE_1_reg   (*((volatile unsigned int*) DC_MT_MODE_1_reg))
+#define get_DC_MT_MODE_2_reg   (*((volatile unsigned int*) DC_MT_MODE_2_reg))
+#define get_DC_MT_MODE_3_reg   (*((volatile unsigned int*) DC_MT_MODE_3_reg))
+#define get_DC_MT_MODE_4_reg   (*((volatile unsigned int*) DC_MT_MODE_4_reg))
+#define get_DC_MT_MODE_5_reg   (*((volatile unsigned int*) DC_MT_MODE_5_reg))
+#define get_DC_MT_MODE_6_reg   (*((volatile unsigned int*) DC_MT_MODE_6_reg))
+#define get_DC_MT_MODE_7_reg   (*((volatile unsigned int*) DC_MT_MODE_7_reg))
+#define DC_MT_MODE_0_inst_adr                                                        "0x0090"
+#define DC_MT_MODE_1_inst_adr                                                        "0x0091"
+#define DC_MT_MODE_2_inst_adr                                                        "0x0092"
+#define DC_MT_MODE_3_inst_adr                                                        "0x0093"
+#define DC_MT_MODE_4_inst_adr                                                        "0x0094"
+#define DC_MT_MODE_5_inst_adr                                                        "0x0095"
+#define DC_MT_MODE_6_inst_adr                                                        "0x0096"
+#define DC_MT_MODE_7_inst_adr                                                        "0x0097"
+#define DC_MT_MODE_0_inst                                                            0x0090
+#define DC_MT_MODE_1_inst                                                            0x0091
+#define DC_MT_MODE_2_inst                                                            0x0092
+#define DC_MT_MODE_3_inst                                                            0x0093
+#define DC_MT_MODE_4_inst                                                            0x0094
+#define DC_MT_MODE_5_inst                                                            0x0095
+#define DC_MT_MODE_6_inst                                                            0x0096
+#define DC_MT_MODE_7_inst                                                            0x0097
+#define DC_MT_MODE_write_enable0_shift                                               (23)
+#define DC_MT_MODE_write_enable0_mask                                                (0x00800000)
+#define DC_MT_MODE_write_enable0(data)                                               (0x00800000&((data)<<23))
+#define DC_MT_MODE_write_enable0_src(data)                                           ((0x00800000&(data))>>23)
+#define DC_MT_MODE_get_write_enable0(data)                                           ((0x00800000&(data))>>23)
+#define DC_MT_MODE_access_type_0_shift                                               (21)
+#define DC_MT_MODE_access_type_0_mask                                                (0x00600000)
+#define DC_MT_MODE_access_type_0(data)                                               (0x00600000&((data)<<21))
+#define DC_MT_MODE_access_type_0_src(data)                                           ((0x00600000&(data))>>21)
+#define DC_MT_MODE_get_access_type_0(data)                                           ((0x00600000&(data))>>21)
+#define DC_MT_MODE_access_type_1_shift                                               (19)
+#define DC_MT_MODE_access_type_1_mask                                                (0x00180000)
+#define DC_MT_MODE_access_type_1(data)                                               (0x00180000&((data)<<19))
+#define DC_MT_MODE_access_type_1_src(data)                                           ((0x00180000&(data))>>19)
+#define DC_MT_MODE_get_access_type_1(data)                                           ((0x00180000&(data))>>19)
+#define DC_MT_MODE_access_type_2_shift                                               (17)
+#define DC_MT_MODE_access_type_2_mask                                                (0x00060000)
+#define DC_MT_MODE_access_type_2(data)                                               (0x00060000&((data)<<17))
+#define DC_MT_MODE_access_type_2_src(data)                                           ((0x00060000&(data))>>17)
+#define DC_MT_MODE_get_access_type_2(data)                                           ((0x00060000&(data))>>17)
+#define DC_MT_MODE_access_type_3_shift                                               (15)
+#define DC_MT_MODE_access_type_3_mask                                                (0x00018000)
+#define DC_MT_MODE_access_type_3(data)                                               (0x00018000&((data)<<15))
+#define DC_MT_MODE_access_type_3_src(data)                                           ((0x00018000&(data))>>15)
+#define DC_MT_MODE_get_access_type_3(data)                                           ((0x00018000&(data))>>15)
+#define DC_MT_MODE_write_enable1_shift                                               (14)
+#define DC_MT_MODE_write_enable1_mask                                                (0x00004000)
+#define DC_MT_MODE_write_enable1(data)                                               (0x00004000&((data)<<14))
+#define DC_MT_MODE_write_enable1_src(data)                                           ((0x00004000&(data))>>14)
+#define DC_MT_MODE_get_write_enable1(data)                                           ((0x00004000&(data))>>14)
+#define DC_MT_MODE_int1_shift                                                        (13)
+#define DC_MT_MODE_int1_mask                                                         (0x00002000)
+#define DC_MT_MODE_int1(data)                                                        (0x00002000&((data)<<13))
+#define DC_MT_MODE_int1_src(data)                                                    ((0x00002000&(data))>>13)
+#define DC_MT_MODE_get_int1(data)                                                    ((0x00002000&(data))>>13)
+#define DC_MT_MODE_write_enable2_shift                                               (12)
+#define DC_MT_MODE_write_enable2_mask                                                (0x00001000)
+#define DC_MT_MODE_write_enable2(data)                                               (0x00001000&((data)<<12))
+#define DC_MT_MODE_write_enable2_src(data)                                           ((0x00001000&(data))>>12)
+#define DC_MT_MODE_get_write_enable2(data)                                           ((0x00001000&(data))>>12)
+#define DC_MT_MODE_int2_shift                                                        (11)
+#define DC_MT_MODE_int2_mask                                                         (0x00000800)
+#define DC_MT_MODE_int2(data)                                                        (0x00000800&((data)<<11))
+#define DC_MT_MODE_int2_src(data)                                                    ((0x00000800&(data))>>11)
+#define DC_MT_MODE_get_int2(data)                                                    ((0x00000800&(data))>>11)
+#define DC_MT_MODE_write_enable3_shift                                               (10)
+#define DC_MT_MODE_write_enable3_mask                                                (0x00000400)
+#define DC_MT_MODE_write_enable3(data)                                               (0x00000400&((data)<<10))
+#define DC_MT_MODE_write_enable3_src(data)                                           ((0x00000400&(data))>>10)
+#define DC_MT_MODE_get_write_enable3(data)                                           ((0x00000400&(data))>>10)
+#define DC_MT_MODE_int3_shift                                                        (9)
+#define DC_MT_MODE_int3_mask                                                         (0x00000200)
+#define DC_MT_MODE_int3(data)                                                        (0x00000200&((data)<<9))
+#define DC_MT_MODE_int3_src(data)                                                    ((0x00000200&(data))>>9)
+#define DC_MT_MODE_get_int3(data)                                                    ((0x00000200&(data))>>9)
+#define DC_MT_MODE_write_enable4_shift                                               (8)
+#define DC_MT_MODE_write_enable4_mask                                                (0x00000100)
+#define DC_MT_MODE_write_enable4(data)                                               (0x00000100&((data)<<8))
+#define DC_MT_MODE_write_enable4_src(data)                                           ((0x00000100&(data))>>8)
+#define DC_MT_MODE_get_write_enable4(data)                                           ((0x00000100&(data))>>8)
+#define DC_MT_MODE_cpu_shift                                                         (6)
+#define DC_MT_MODE_cpu_mask                                                          (0x000000C0)
+#define DC_MT_MODE_cpu(data)                                                         (0x000000C0&((data)<<6))
+#define DC_MT_MODE_cpu_src(data)                                                     ((0x000000C0&(data))>>6)
+#define DC_MT_MODE_get_cpu(data)                                                     ((0x000000C0&(data))>>6)
+#define DC_MT_MODE_int1_en_shift                                                     (5)
+#define DC_MT_MODE_int1_en_mask                                                      (0x00000020)
+#define DC_MT_MODE_int1_en(data)                                                     (0x00000020&((data)<<5))
+#define DC_MT_MODE_int1_en_src(data)                                                 ((0x00000020&(data))>>5)
+#define DC_MT_MODE_get_int1_en(data)                                                 ((0x00000020&(data))>>5)
+#define DC_MT_MODE_int2_en_shift                                                     (4)
+#define DC_MT_MODE_int2_en_mask                                                      (0x00000010)
+#define DC_MT_MODE_int2_en(data)                                                     (0x00000010&((data)<<4))
+#define DC_MT_MODE_int2_en_src(data)                                                 ((0x00000010&(data))>>4)
+#define DC_MT_MODE_get_int2_en(data)                                                 ((0x00000010&(data))>>4)
+#define DC_MT_MODE_int3_en_shift                                                     (3)
+#define DC_MT_MODE_int3_en_mask                                                      (0x00000008)
+#define DC_MT_MODE_int3_en(data)                                                     (0x00000008&((data)<<3))
+#define DC_MT_MODE_int3_en_src(data)                                                 ((0x00000008&(data))>>3)
+#define DC_MT_MODE_get_int3_en(data)                                                 ((0x00000008&(data))>>3)
+#define DC_MT_MODE_write_enable5_shift                                               (2)
+#define DC_MT_MODE_write_enable5_mask                                                (0x00000004)
+#define DC_MT_MODE_write_enable5(data)                                               (0x00000004&((data)<<2))
+#define DC_MT_MODE_write_enable5_src(data)                                           ((0x00000004&(data))>>2)
+#define DC_MT_MODE_get_write_enable5(data)                                           ((0x00000004&(data))>>2)
+#define DC_MT_MODE_mode_shift                                                        (0)
+#define DC_MT_MODE_mode_mask                                                         (0x00000003)
+#define DC_MT_MODE_mode(data)                                                        (0x00000003&((data)<<0))
+#define DC_MT_MODE_mode_src(data)                                                    ((0x00000003&(data))>>0)
+#define DC_MT_MODE_get_mode(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define DC_MT_TABLE_0                                                                0x18008260
+#define DC_MT_TABLE_1                                                                0x18008264
+#define DC_MT_TABLE_2                                                                0x18008268
+#define DC_MT_TABLE_3                                                                0x1800826C
+#define DC_MT_TABLE_4                                                                0x18008270
+#define DC_MT_TABLE_5                                                                0x18008274
+#define DC_MT_TABLE_6                                                                0x18008278
+#define DC_MT_TABLE_7                                                                0x1800827C
+#define DC_MT_TABLE_0_reg_addr                                                       "0xB8008260"
+#define DC_MT_TABLE_1_reg_addr                                                       "0xB8008264"
+#define DC_MT_TABLE_2_reg_addr                                                       "0xB8008268"
+#define DC_MT_TABLE_3_reg_addr                                                       "0xB800826C"
+#define DC_MT_TABLE_4_reg_addr                                                       "0xB8008270"
+#define DC_MT_TABLE_5_reg_addr                                                       "0xB8008274"
+#define DC_MT_TABLE_6_reg_addr                                                       "0xB8008278"
+#define DC_MT_TABLE_7_reg_addr                                                       "0xB800827C"
+#define DC_MT_TABLE_0_reg                                                            0xB8008260
+#define DC_MT_TABLE_1_reg                                                            0xB8008264
+#define DC_MT_TABLE_2_reg                                                            0xB8008268
+#define DC_MT_TABLE_3_reg                                                            0xB800826C
+#define DC_MT_TABLE_4_reg                                                            0xB8008270
+#define DC_MT_TABLE_5_reg                                                            0xB8008274
+#define DC_MT_TABLE_6_reg                                                            0xB8008278
+#define DC_MT_TABLE_7_reg                                                            0xB800827C
+#define set_DC_MT_TABLE_0_reg(data)   (*((volatile unsigned int*) DC_MT_TABLE_0_reg)=data)
+#define set_DC_MT_TABLE_1_reg(data)   (*((volatile unsigned int*) DC_MT_TABLE_1_reg)=data)
+#define set_DC_MT_TABLE_2_reg(data)   (*((volatile unsigned int*) DC_MT_TABLE_2_reg)=data)
+#define set_DC_MT_TABLE_3_reg(data)   (*((volatile unsigned int*) DC_MT_TABLE_3_reg)=data)
+#define set_DC_MT_TABLE_4_reg(data)   (*((volatile unsigned int*) DC_MT_TABLE_4_reg)=data)
+#define set_DC_MT_TABLE_5_reg(data)   (*((volatile unsigned int*) DC_MT_TABLE_5_reg)=data)
+#define set_DC_MT_TABLE_6_reg(data)   (*((volatile unsigned int*) DC_MT_TABLE_6_reg)=data)
+#define set_DC_MT_TABLE_7_reg(data)   (*((volatile unsigned int*) DC_MT_TABLE_7_reg)=data)
+#define get_DC_MT_TABLE_0_reg   (*((volatile unsigned int*) DC_MT_TABLE_0_reg))
+#define get_DC_MT_TABLE_1_reg   (*((volatile unsigned int*) DC_MT_TABLE_1_reg))
+#define get_DC_MT_TABLE_2_reg   (*((volatile unsigned int*) DC_MT_TABLE_2_reg))
+#define get_DC_MT_TABLE_3_reg   (*((volatile unsigned int*) DC_MT_TABLE_3_reg))
+#define get_DC_MT_TABLE_4_reg   (*((volatile unsigned int*) DC_MT_TABLE_4_reg))
+#define get_DC_MT_TABLE_5_reg   (*((volatile unsigned int*) DC_MT_TABLE_5_reg))
+#define get_DC_MT_TABLE_6_reg   (*((volatile unsigned int*) DC_MT_TABLE_6_reg))
+#define get_DC_MT_TABLE_7_reg   (*((volatile unsigned int*) DC_MT_TABLE_7_reg))
+#define DC_MT_TABLE_0_inst_adr                                                       "0x0098"
+#define DC_MT_TABLE_1_inst_adr                                                       "0x0099"
+#define DC_MT_TABLE_2_inst_adr                                                       "0x009A"
+#define DC_MT_TABLE_3_inst_adr                                                       "0x009B"
+#define DC_MT_TABLE_4_inst_adr                                                       "0x009C"
+#define DC_MT_TABLE_5_inst_adr                                                       "0x009D"
+#define DC_MT_TABLE_6_inst_adr                                                       "0x009E"
+#define DC_MT_TABLE_7_inst_adr                                                       "0x009F"
+#define DC_MT_TABLE_0_inst                                                           0x0098
+#define DC_MT_TABLE_1_inst                                                           0x0099
+#define DC_MT_TABLE_2_inst                                                           0x009A
+#define DC_MT_TABLE_3_inst                                                           0x009B
+#define DC_MT_TABLE_4_inst                                                           0x009C
+#define DC_MT_TABLE_5_inst                                                           0x009D
+#define DC_MT_TABLE_6_inst                                                           0x009E
+#define DC_MT_TABLE_7_inst                                                           0x009F
+#define DC_MT_TABLE_module_ID_0_shift                                                (21)
+#define DC_MT_TABLE_module_ID_0_mask                                                 (0x0FE00000)
+#define DC_MT_TABLE_module_ID_0(data)                                                (0x0FE00000&((data)<<21))
+#define DC_MT_TABLE_module_ID_0_src(data)                                            ((0x0FE00000&(data))>>21)
+#define DC_MT_TABLE_get_module_ID_0(data)                                            ((0x0FE00000&(data))>>21)
+#define DC_MT_TABLE_module_ID_1_shift                                                (14)
+#define DC_MT_TABLE_module_ID_1_mask                                                 (0x001FC000)
+#define DC_MT_TABLE_module_ID_1(data)                                                (0x001FC000&((data)<<14))
+#define DC_MT_TABLE_module_ID_1_src(data)                                            ((0x001FC000&(data))>>14)
+#define DC_MT_TABLE_get_module_ID_1(data)                                            ((0x001FC000&(data))>>14)
+#define DC_MT_TABLE_module_ID_2_shift                                                (7)
+#define DC_MT_TABLE_module_ID_2_mask                                                 (0x00003F80)
+#define DC_MT_TABLE_module_ID_2(data)                                                (0x00003F80&((data)<<7))
+#define DC_MT_TABLE_module_ID_2_src(data)                                            ((0x00003F80&(data))>>7)
+#define DC_MT_TABLE_get_module_ID_2(data)                                            ((0x00003F80&(data))>>7)
+#define DC_MT_TABLE_module_ID_3_shift                                                (0)
+#define DC_MT_TABLE_module_ID_3_mask                                                 (0x0000007F)
+#define DC_MT_TABLE_module_ID_3(data)                                                (0x0000007F&((data)<<0))
+#define DC_MT_TABLE_module_ID_3_src(data)                                            ((0x0000007F&(data))>>0)
+#define DC_MT_TABLE_get_module_ID_3(data)                                            ((0x0000007F&(data))>>0)
+
+
+#define DC_MT_ADDCMD_HI_0                                                            0x18008280
+#define DC_MT_ADDCMD_HI_1                                                            0x18008284
+#define DC_MT_ADDCMD_HI_2                                                            0x18008288
+#define DC_MT_ADDCMD_HI_3                                                            0x1800828C
+#define DC_MT_ADDCMD_HI_4                                                            0x18008290
+#define DC_MT_ADDCMD_HI_5                                                            0x18008294
+#define DC_MT_ADDCMD_HI_6                                                            0x18008298
+#define DC_MT_ADDCMD_HI_7                                                            0x1800829C
+#define DC_MT_ADDCMD_HI_0_reg_addr                                                   "0xB8008280"
+#define DC_MT_ADDCMD_HI_1_reg_addr                                                   "0xB8008284"
+#define DC_MT_ADDCMD_HI_2_reg_addr                                                   "0xB8008288"
+#define DC_MT_ADDCMD_HI_3_reg_addr                                                   "0xB800828C"
+#define DC_MT_ADDCMD_HI_4_reg_addr                                                   "0xB8008290"
+#define DC_MT_ADDCMD_HI_5_reg_addr                                                   "0xB8008294"
+#define DC_MT_ADDCMD_HI_6_reg_addr                                                   "0xB8008298"
+#define DC_MT_ADDCMD_HI_7_reg_addr                                                   "0xB800829C"
+#define DC_MT_ADDCMD_HI_0_reg                                                        0xB8008280
+#define DC_MT_ADDCMD_HI_1_reg                                                        0xB8008284
+#define DC_MT_ADDCMD_HI_2_reg                                                        0xB8008288
+#define DC_MT_ADDCMD_HI_3_reg                                                        0xB800828C
+#define DC_MT_ADDCMD_HI_4_reg                                                        0xB8008290
+#define DC_MT_ADDCMD_HI_5_reg                                                        0xB8008294
+#define DC_MT_ADDCMD_HI_6_reg                                                        0xB8008298
+#define DC_MT_ADDCMD_HI_7_reg                                                        0xB800829C
+#define set_DC_MT_ADDCMD_HI_0_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_0_reg)=data)
+#define set_DC_MT_ADDCMD_HI_1_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_1_reg)=data)
+#define set_DC_MT_ADDCMD_HI_2_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_2_reg)=data)
+#define set_DC_MT_ADDCMD_HI_3_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_3_reg)=data)
+#define set_DC_MT_ADDCMD_HI_4_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_4_reg)=data)
+#define set_DC_MT_ADDCMD_HI_5_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_5_reg)=data)
+#define set_DC_MT_ADDCMD_HI_6_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_6_reg)=data)
+#define set_DC_MT_ADDCMD_HI_7_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_7_reg)=data)
+#define get_DC_MT_ADDCMD_HI_0_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_0_reg))
+#define get_DC_MT_ADDCMD_HI_1_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_1_reg))
+#define get_DC_MT_ADDCMD_HI_2_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_2_reg))
+#define get_DC_MT_ADDCMD_HI_3_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_3_reg))
+#define get_DC_MT_ADDCMD_HI_4_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_4_reg))
+#define get_DC_MT_ADDCMD_HI_5_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_5_reg))
+#define get_DC_MT_ADDCMD_HI_6_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_6_reg))
+#define get_DC_MT_ADDCMD_HI_7_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_HI_7_reg))
+#define DC_MT_ADDCMD_HI_0_inst_adr                                                   "0x00A0"
+#define DC_MT_ADDCMD_HI_1_inst_adr                                                   "0x00A1"
+#define DC_MT_ADDCMD_HI_2_inst_adr                                                   "0x00A2"
+#define DC_MT_ADDCMD_HI_3_inst_adr                                                   "0x00A3"
+#define DC_MT_ADDCMD_HI_4_inst_adr                                                   "0x00A4"
+#define DC_MT_ADDCMD_HI_5_inst_adr                                                   "0x00A5"
+#define DC_MT_ADDCMD_HI_6_inst_adr                                                   "0x00A6"
+#define DC_MT_ADDCMD_HI_7_inst_adr                                                   "0x00A7"
+#define DC_MT_ADDCMD_HI_0_inst                                                       0x00A0
+#define DC_MT_ADDCMD_HI_1_inst                                                       0x00A1
+#define DC_MT_ADDCMD_HI_2_inst                                                       0x00A2
+#define DC_MT_ADDCMD_HI_3_inst                                                       0x00A3
+#define DC_MT_ADDCMD_HI_4_inst                                                       0x00A4
+#define DC_MT_ADDCMD_HI_5_inst                                                       0x00A5
+#define DC_MT_ADDCMD_HI_6_inst                                                       0x00A6
+#define DC_MT_ADDCMD_HI_7_inst                                                       0x00A7
+#define DC_MT_ADDCMD_HI_ever_trap_shift                                              (21)
+#define DC_MT_ADDCMD_HI_ever_trap_mask                                               (0x00200000)
+#define DC_MT_ADDCMD_HI_ever_trap(data)                                              (0x00200000&((data)<<21))
+#define DC_MT_ADDCMD_HI_ever_trap_src(data)                                          ((0x00200000&(data))>>21)
+#define DC_MT_ADDCMD_HI_get_ever_trap(data)                                          ((0x00200000&(data))>>21)
+#define DC_MT_ADDCMD_HI_module_ID_shift                                              (14)
+#define DC_MT_ADDCMD_HI_module_ID_mask                                               (0x001FC000)
+#define DC_MT_ADDCMD_HI_module_ID(data)                                              (0x001FC000&((data)<<14))
+#define DC_MT_ADDCMD_HI_module_ID_src(data)                                          ((0x001FC000&(data))>>14)
+#define DC_MT_ADDCMD_HI_get_module_ID(data)                                          ((0x001FC000&(data))>>14)
+#define DC_MT_ADDCMD_HI_addcmd_shift                                                 (0)
+#define DC_MT_ADDCMD_HI_addcmd_mask                                                  (0x00003FFF)
+#define DC_MT_ADDCMD_HI_addcmd(data)                                                 (0x00003FFF&((data)<<0))
+#define DC_MT_ADDCMD_HI_addcmd_src(data)                                             ((0x00003FFF&(data))>>0)
+#define DC_MT_ADDCMD_HI_get_addcmd(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define DC_MT_ADDCMD_LO_0                                                            0x180082A0
+#define DC_MT_ADDCMD_LO_1                                                            0x180082A4
+#define DC_MT_ADDCMD_LO_2                                                            0x180082A8
+#define DC_MT_ADDCMD_LO_3                                                            0x180082AC
+#define DC_MT_ADDCMD_LO_4                                                            0x180082B0
+#define DC_MT_ADDCMD_LO_5                                                            0x180082B4
+#define DC_MT_ADDCMD_LO_6                                                            0x180082B8
+#define DC_MT_ADDCMD_LO_7                                                            0x180082BC
+#define DC_MT_ADDCMD_LO_0_reg_addr                                                   "0xB80082A0"
+#define DC_MT_ADDCMD_LO_1_reg_addr                                                   "0xB80082A4"
+#define DC_MT_ADDCMD_LO_2_reg_addr                                                   "0xB80082A8"
+#define DC_MT_ADDCMD_LO_3_reg_addr                                                   "0xB80082AC"
+#define DC_MT_ADDCMD_LO_4_reg_addr                                                   "0xB80082B0"
+#define DC_MT_ADDCMD_LO_5_reg_addr                                                   "0xB80082B4"
+#define DC_MT_ADDCMD_LO_6_reg_addr                                                   "0xB80082B8"
+#define DC_MT_ADDCMD_LO_7_reg_addr                                                   "0xB80082BC"
+#define DC_MT_ADDCMD_LO_0_reg                                                        0xB80082A0
+#define DC_MT_ADDCMD_LO_1_reg                                                        0xB80082A4
+#define DC_MT_ADDCMD_LO_2_reg                                                        0xB80082A8
+#define DC_MT_ADDCMD_LO_3_reg                                                        0xB80082AC
+#define DC_MT_ADDCMD_LO_4_reg                                                        0xB80082B0
+#define DC_MT_ADDCMD_LO_5_reg                                                        0xB80082B4
+#define DC_MT_ADDCMD_LO_6_reg                                                        0xB80082B8
+#define DC_MT_ADDCMD_LO_7_reg                                                        0xB80082BC
+#define set_DC_MT_ADDCMD_LO_0_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_0_reg)=data)
+#define set_DC_MT_ADDCMD_LO_1_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_1_reg)=data)
+#define set_DC_MT_ADDCMD_LO_2_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_2_reg)=data)
+#define set_DC_MT_ADDCMD_LO_3_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_3_reg)=data)
+#define set_DC_MT_ADDCMD_LO_4_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_4_reg)=data)
+#define set_DC_MT_ADDCMD_LO_5_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_5_reg)=data)
+#define set_DC_MT_ADDCMD_LO_6_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_6_reg)=data)
+#define set_DC_MT_ADDCMD_LO_7_reg(data)   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_7_reg)=data)
+#define get_DC_MT_ADDCMD_LO_0_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_0_reg))
+#define get_DC_MT_ADDCMD_LO_1_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_1_reg))
+#define get_DC_MT_ADDCMD_LO_2_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_2_reg))
+#define get_DC_MT_ADDCMD_LO_3_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_3_reg))
+#define get_DC_MT_ADDCMD_LO_4_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_4_reg))
+#define get_DC_MT_ADDCMD_LO_5_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_5_reg))
+#define get_DC_MT_ADDCMD_LO_6_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_6_reg))
+#define get_DC_MT_ADDCMD_LO_7_reg   (*((volatile unsigned int*) DC_MT_ADDCMD_LO_7_reg))
+#define DC_MT_ADDCMD_LO_0_inst_adr                                                   "0x00A8"
+#define DC_MT_ADDCMD_LO_1_inst_adr                                                   "0x00A9"
+#define DC_MT_ADDCMD_LO_2_inst_adr                                                   "0x00AA"
+#define DC_MT_ADDCMD_LO_3_inst_adr                                                   "0x00AB"
+#define DC_MT_ADDCMD_LO_4_inst_adr                                                   "0x00AC"
+#define DC_MT_ADDCMD_LO_5_inst_adr                                                   "0x00AD"
+#define DC_MT_ADDCMD_LO_6_inst_adr                                                   "0x00AE"
+#define DC_MT_ADDCMD_LO_7_inst_adr                                                   "0x00AF"
+#define DC_MT_ADDCMD_LO_0_inst                                                       0x00A8
+#define DC_MT_ADDCMD_LO_1_inst                                                       0x00A9
+#define DC_MT_ADDCMD_LO_2_inst                                                       0x00AA
+#define DC_MT_ADDCMD_LO_3_inst                                                       0x00AB
+#define DC_MT_ADDCMD_LO_4_inst                                                       0x00AC
+#define DC_MT_ADDCMD_LO_5_inst                                                       0x00AD
+#define DC_MT_ADDCMD_LO_6_inst                                                       0x00AE
+#define DC_MT_ADDCMD_LO_7_inst                                                       0x00AF
+#define DC_MT_ADDCMD_LO_addcmd_shift                                                 (0)
+#define DC_MT_ADDCMD_LO_addcmd_mask                                                  (0xFFFFFFFF)
+#define DC_MT_ADDCMD_LO_addcmd(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define DC_MT_ADDCMD_LO_addcmd_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define DC_MT_ADDCMD_LO_get_addcmd(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_MT_MISC                                                                   0x180082C0
+#define DC_MT_MISC_reg_addr                                                          "0xB80082C0"
+#define DC_MT_MISC_reg                                                               0xB80082C0
+#define set_DC_MT_MISC_reg(data)   (*((volatile unsigned int*) DC_MT_MISC_reg)=data)
+#define get_DC_MT_MISC_reg   (*((volatile unsigned int*) DC_MT_MISC_reg))
+#define DC_MT_MISC_inst_adr                                                          "0x00B0"
+#define DC_MT_MISC_inst                                                              0x00B0
+#define DC_MT_MISC_enable_block_info_shift                                           (1)
+#define DC_MT_MISC_enable_block_info_mask                                            (0x00000002)
+#define DC_MT_MISC_enable_block_info(data)                                           (0x00000002&((data)<<1))
+#define DC_MT_MISC_enable_block_info_src(data)                                       ((0x00000002&(data))>>1)
+#define DC_MT_MISC_get_enable_block_info(data)                                       ((0x00000002&(data))>>1)
+#define DC_MT_MISC_disable_cross_range_check_shift                                   (0)
+#define DC_MT_MISC_disable_cross_range_check_mask                                    (0x00000001)
+#define DC_MT_MISC_disable_cross_range_check(data)                                   (0x00000001&((data)<<0))
+#define DC_MT_MISC_disable_cross_range_check_src(data)                               ((0x00000001&(data))>>0)
+#define DC_MT_MISC_get_disable_cross_range_check(data)                               ((0x00000001&(data))>>0)
+
+
+#define DC_EC_CTRL                                                                   0x18008300
+#define DC_EC_CTRL_reg_addr                                                          "0xB8008300"
+#define DC_EC_CTRL_reg                                                               0xB8008300
+#define set_DC_EC_CTRL_reg(data)   (*((volatile unsigned int*) DC_EC_CTRL_reg)=data)
+#define get_DC_EC_CTRL_reg   (*((volatile unsigned int*) DC_EC_CTRL_reg))
+#define DC_EC_CTRL_inst_adr                                                          "0x00C0"
+#define DC_EC_CTRL_inst                                                              0x00C0
+#define DC_EC_CTRL_write_enable4_shift                                               (8)
+#define DC_EC_CTRL_write_enable4_mask                                                (0x00000100)
+#define DC_EC_CTRL_write_enable4(data)                                               (0x00000100&((data)<<8))
+#define DC_EC_CTRL_write_enable4_src(data)                                           ((0x00000100&(data))>>8)
+#define DC_EC_CTRL_get_write_enable4(data)                                           ((0x00000100&(data))>>8)
+#define DC_EC_CTRL_error_cmd_int_cpu_shift                                           (6)
+#define DC_EC_CTRL_error_cmd_int_cpu_mask                                            (0x000000C0)
+#define DC_EC_CTRL_error_cmd_int_cpu(data)                                           (0x000000C0&((data)<<6))
+#define DC_EC_CTRL_error_cmd_int_cpu_src(data)                                       ((0x000000C0&(data))>>6)
+#define DC_EC_CTRL_get_error_cmd_int_cpu(data)                                       ((0x000000C0&(data))>>6)
+#define DC_EC_CTRL_write_enable3_shift                                               (5)
+#define DC_EC_CTRL_write_enable3_mask                                                (0x00000020)
+#define DC_EC_CTRL_write_enable3(data)                                               (0x00000020&((data)<<5))
+#define DC_EC_CTRL_write_enable3_src(data)                                           ((0x00000020&(data))>>5)
+#define DC_EC_CTRL_get_write_enable3(data)                                           ((0x00000020&(data))>>5)
+#define DC_EC_CTRL_error_cmd_int_en_shift                                            (4)
+#define DC_EC_CTRL_error_cmd_int_en_mask                                             (0x00000010)
+#define DC_EC_CTRL_error_cmd_int_en(data)                                            (0x00000010&((data)<<4))
+#define DC_EC_CTRL_error_cmd_int_en_src(data)                                        ((0x00000010&(data))>>4)
+#define DC_EC_CTRL_get_error_cmd_int_en(data)                                        ((0x00000010&(data))>>4)
+#define DC_EC_CTRL_write_enable2_shift                                               (3)
+#define DC_EC_CTRL_write_enable2_mask                                                (0x00000008)
+#define DC_EC_CTRL_write_enable2(data)                                               (0x00000008&((data)<<3))
+#define DC_EC_CTRL_write_enable2_src(data)                                           ((0x00000008&(data))>>3)
+#define DC_EC_CTRL_get_write_enable2(data)                                           ((0x00000008&(data))>>3)
+#define DC_EC_CTRL_error_cmd_swap_en_shift                                           (2)
+#define DC_EC_CTRL_error_cmd_swap_en_mask                                            (0x00000004)
+#define DC_EC_CTRL_error_cmd_swap_en(data)                                           (0x00000004&((data)<<2))
+#define DC_EC_CTRL_error_cmd_swap_en_src(data)                                       ((0x00000004&(data))>>2)
+#define DC_EC_CTRL_get_error_cmd_swap_en(data)                                       ((0x00000004&(data))>>2)
+#define DC_EC_CTRL_write_enable1_shift                                               (1)
+#define DC_EC_CTRL_write_enable1_mask                                                (0x00000002)
+#define DC_EC_CTRL_write_enable1(data)                                               (0x00000002&((data)<<1))
+#define DC_EC_CTRL_write_enable1_src(data)                                           ((0x00000002&(data))>>1)
+#define DC_EC_CTRL_get_write_enable1(data)                                           ((0x00000002&(data))>>1)
+#define DC_EC_CTRL_error_cmd_detection_en_shift                                      (0)
+#define DC_EC_CTRL_error_cmd_detection_en_mask                                       (0x00000001)
+#define DC_EC_CTRL_error_cmd_detection_en(data)                                      (0x00000001&((data)<<0))
+#define DC_EC_CTRL_error_cmd_detection_en_src(data)                                  ((0x00000001&(data))>>0)
+#define DC_EC_CTRL_get_error_cmd_detection_en(data)                                  ((0x00000001&(data))>>0)
+
+
+#define DC_EC_ADDCMD_HI                                                              0x18008304
+#define DC_EC_ADDCMD_HI_reg_addr                                                     "0xB8008304"
+#define DC_EC_ADDCMD_HI_reg                                                          0xB8008304
+#define set_DC_EC_ADDCMD_HI_reg(data)   (*((volatile unsigned int*) DC_EC_ADDCMD_HI_reg)=data)
+#define get_DC_EC_ADDCMD_HI_reg   (*((volatile unsigned int*) DC_EC_ADDCMD_HI_reg))
+#define DC_EC_ADDCMD_HI_inst_adr                                                     "0x00C1"
+#define DC_EC_ADDCMD_HI_inst                                                         0x00C1
+#define DC_EC_ADDCMD_HI_error_cmd_int_shift                                          (31)
+#define DC_EC_ADDCMD_HI_error_cmd_int_mask                                           (0x80000000)
+#define DC_EC_ADDCMD_HI_error_cmd_int(data)                                          (0x80000000&((data)<<31))
+#define DC_EC_ADDCMD_HI_error_cmd_int_src(data)                                      ((0x80000000&(data))>>31)
+#define DC_EC_ADDCMD_HI_get_error_cmd_int(data)                                      ((0x80000000&(data))>>31)
+#define DC_EC_ADDCMD_HI_error_cmd_ever_trap_shift                                    (30)
+#define DC_EC_ADDCMD_HI_error_cmd_ever_trap_mask                                     (0x40000000)
+#define DC_EC_ADDCMD_HI_error_cmd_ever_trap(data)                                    (0x40000000&((data)<<30))
+#define DC_EC_ADDCMD_HI_error_cmd_ever_trap_src(data)                                ((0x40000000&(data))>>30)
+#define DC_EC_ADDCMD_HI_get_error_cmd_ever_trap(data)                                ((0x40000000&(data))>>30)
+#define DC_EC_ADDCMD_HI_trap_case_shift                                              (22)
+#define DC_EC_ADDCMD_HI_trap_case_mask                                               (0x3FC00000)
+#define DC_EC_ADDCMD_HI_trap_case(data)                                              (0x3FC00000&((data)<<22))
+#define DC_EC_ADDCMD_HI_trap_case_src(data)                                          ((0x3FC00000&(data))>>22)
+#define DC_EC_ADDCMD_HI_get_trap_case(data)                                          ((0x3FC00000&(data))>>22)
+#define DC_EC_ADDCMD_HI_Addcmd_hi_shift                                              (0)
+#define DC_EC_ADDCMD_HI_Addcmd_hi_mask                                               (0x003FFFFF)
+#define DC_EC_ADDCMD_HI_Addcmd_hi(data)                                              (0x003FFFFF&((data)<<0))
+#define DC_EC_ADDCMD_HI_Addcmd_hi_src(data)                                          ((0x003FFFFF&(data))>>0)
+#define DC_EC_ADDCMD_HI_get_Addcmd_hi(data)                                          ((0x003FFFFF&(data))>>0)
+
+
+#define DC_EC_ADDCMD_LO                                                              0x18008308
+#define DC_EC_ADDCMD_LO_reg_addr                                                     "0xB8008308"
+#define DC_EC_ADDCMD_LO_reg                                                          0xB8008308
+#define set_DC_EC_ADDCMD_LO_reg(data)   (*((volatile unsigned int*) DC_EC_ADDCMD_LO_reg)=data)
+#define get_DC_EC_ADDCMD_LO_reg   (*((volatile unsigned int*) DC_EC_ADDCMD_LO_reg))
+#define DC_EC_ADDCMD_LO_inst_adr                                                     "0x00C2"
+#define DC_EC_ADDCMD_LO_inst                                                         0x00C2
+#define DC_EC_ADDCMD_LO_Addcmd_lo_shift                                              (0)
+#define DC_EC_ADDCMD_LO_Addcmd_lo_mask                                               (0xFFFFFFFF)
+#define DC_EC_ADDCMD_LO_Addcmd_lo(data)                                              (0xFFFFFFFF&((data)<<0))
+#define DC_EC_ADDCMD_LO_Addcmd_lo_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define DC_EC_ADDCMD_LO_get_Addcmd_lo(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_RD_TAG_CHECK                                                              0x1800830C
+#define DC_RD_TAG_CHECK_reg_addr                                                     "0xB800830C"
+#define DC_RD_TAG_CHECK_reg                                                          0xB800830C
+#define set_DC_RD_TAG_CHECK_reg(data)   (*((volatile unsigned int*) DC_RD_TAG_CHECK_reg)=data)
+#define get_DC_RD_TAG_CHECK_reg   (*((volatile unsigned int*) DC_RD_TAG_CHECK_reg))
+#define DC_RD_TAG_CHECK_inst_adr                                                     "0x00C3"
+#define DC_RD_TAG_CHECK_inst                                                         0x00C3
+#define DC_RD_TAG_CHECK_write_enable3_shift                                          (6)
+#define DC_RD_TAG_CHECK_write_enable3_mask                                           (0x00000040)
+#define DC_RD_TAG_CHECK_write_enable3(data)                                          (0x00000040&((data)<<6))
+#define DC_RD_TAG_CHECK_write_enable3_src(data)                                      ((0x00000040&(data))>>6)
+#define DC_RD_TAG_CHECK_get_write_enable3(data)                                      ((0x00000040&(data))>>6)
+#define DC_RD_TAG_CHECK_tag_check_int_cpu_shift                                      (4)
+#define DC_RD_TAG_CHECK_tag_check_int_cpu_mask                                       (0x00000030)
+#define DC_RD_TAG_CHECK_tag_check_int_cpu(data)                                      (0x00000030&((data)<<4))
+#define DC_RD_TAG_CHECK_tag_check_int_cpu_src(data)                                  ((0x00000030&(data))>>4)
+#define DC_RD_TAG_CHECK_get_tag_check_int_cpu(data)                                  ((0x00000030&(data))>>4)
+#define DC_RD_TAG_CHECK_write_enable2_shift                                          (3)
+#define DC_RD_TAG_CHECK_write_enable2_mask                                           (0x00000008)
+#define DC_RD_TAG_CHECK_write_enable2(data)                                          (0x00000008&((data)<<3))
+#define DC_RD_TAG_CHECK_write_enable2_src(data)                                      ((0x00000008&(data))>>3)
+#define DC_RD_TAG_CHECK_get_write_enable2(data)                                      ((0x00000008&(data))>>3)
+#define DC_RD_TAG_CHECK_tag_check_int_en_shift                                       (2)
+#define DC_RD_TAG_CHECK_tag_check_int_en_mask                                        (0x00000004)
+#define DC_RD_TAG_CHECK_tag_check_int_en(data)                                       (0x00000004&((data)<<2))
+#define DC_RD_TAG_CHECK_tag_check_int_en_src(data)                                   ((0x00000004&(data))>>2)
+#define DC_RD_TAG_CHECK_get_tag_check_int_en(data)                                   ((0x00000004&(data))>>2)
+#define DC_RD_TAG_CHECK_write_enable1_shift                                          (1)
+#define DC_RD_TAG_CHECK_write_enable1_mask                                           (0x00000002)
+#define DC_RD_TAG_CHECK_write_enable1(data)                                          (0x00000002&((data)<<1))
+#define DC_RD_TAG_CHECK_write_enable1_src(data)                                      ((0x00000002&(data))>>1)
+#define DC_RD_TAG_CHECK_get_write_enable1(data)                                      ((0x00000002&(data))>>1)
+#define DC_RD_TAG_CHECK_tag_check_en_shift                                           (0)
+#define DC_RD_TAG_CHECK_tag_check_en_mask                                            (0x00000001)
+#define DC_RD_TAG_CHECK_tag_check_en(data)                                           (0x00000001&((data)<<0))
+#define DC_RD_TAG_CHECK_tag_check_en_src(data)                                       ((0x00000001&(data))>>0)
+#define DC_RD_TAG_CHECK_get_tag_check_en(data)                                       ((0x00000001&(data))>>0)
+
+
+#define DC_RD_TAG_CHECK_ST                                                           0x18008310
+#define DC_RD_TAG_CHECK_ST_reg_addr                                                  "0xB8008310"
+#define DC_RD_TAG_CHECK_ST_reg                                                       0xB8008310
+#define set_DC_RD_TAG_CHECK_ST_reg(data)   (*((volatile unsigned int*) DC_RD_TAG_CHECK_ST_reg)=data)
+#define get_DC_RD_TAG_CHECK_ST_reg   (*((volatile unsigned int*) DC_RD_TAG_CHECK_ST_reg))
+#define DC_RD_TAG_CHECK_ST_inst_adr                                                  "0x00C4"
+#define DC_RD_TAG_CHECK_ST_inst                                                      0x00C4
+#define DC_RD_TAG_CHECK_ST_rd_tag_mismatch_ever_shift                                (1)
+#define DC_RD_TAG_CHECK_ST_rd_tag_mismatch_ever_mask                                 (0x00000002)
+#define DC_RD_TAG_CHECK_ST_rd_tag_mismatch_ever(data)                                (0x00000002&((data)<<1))
+#define DC_RD_TAG_CHECK_ST_rd_tag_mismatch_ever_src(data)                            ((0x00000002&(data))>>1)
+#define DC_RD_TAG_CHECK_ST_get_rd_tag_mismatch_ever(data)                            ((0x00000002&(data))>>1)
+#define DC_RD_TAG_CHECK_ST_rd_tag_mismatch_int_shift                                 (0)
+#define DC_RD_TAG_CHECK_ST_rd_tag_mismatch_int_mask                                  (0x00000001)
+#define DC_RD_TAG_CHECK_ST_rd_tag_mismatch_int(data)                                 (0x00000001&((data)<<0))
+#define DC_RD_TAG_CHECK_ST_rd_tag_mismatch_int_src(data)                             ((0x00000001&(data))>>0)
+#define DC_RD_TAG_CHECK_ST_get_rd_tag_mismatch_int(data)                             ((0x00000001&(data))>>0)
+
+
+#define DC_MEM_PROTECT_CTRL                                                          0x18008400
+#define DC_MEM_PROTECT_CTRL_reg_addr                                                 "0xB8008400"
+#define DC_MEM_PROTECT_CTRL_reg                                                      0xB8008400
+#define set_DC_MEM_PROTECT_CTRL_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_CTRL_reg)=data)
+#define get_DC_MEM_PROTECT_CTRL_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_CTRL_reg))
+#define DC_MEM_PROTECT_CTRL_inst_adr                                                 "0x0000"
+#define DC_MEM_PROTECT_CTRL_inst                                                     0x0000
+#define DC_MEM_PROTECT_CTRL_write_enable0_shift                                      (31)
+#define DC_MEM_PROTECT_CTRL_write_enable0_mask                                       (0x80000000)
+#define DC_MEM_PROTECT_CTRL_write_enable0(data)                                      (0x80000000&((data)<<31))
+#define DC_MEM_PROTECT_CTRL_write_enable0_src(data)                                  ((0x80000000&(data))>>31)
+#define DC_MEM_PROTECT_CTRL_get_write_enable0(data)                                  ((0x80000000&(data))>>31)
+#define DC_MEM_PROTECT_CTRL_rd_only_0_sel_shift                                      (30)
+#define DC_MEM_PROTECT_CTRL_rd_only_0_sel_mask                                       (0x40000000)
+#define DC_MEM_PROTECT_CTRL_rd_only_0_sel(data)                                      (0x40000000&((data)<<30))
+#define DC_MEM_PROTECT_CTRL_rd_only_0_sel_src(data)                                  ((0x40000000&(data))>>30)
+#define DC_MEM_PROTECT_CTRL_get_rd_only_0_sel(data)                                  ((0x40000000&(data))>>30)
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_sel_shift                                  (29)
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_sel_mask                                   (0x20000000)
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_sel(data)                                  (0x20000000&((data)<<29))
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_sel_src(data)                              ((0x20000000&(data))>>29)
+#define DC_MEM_PROTECT_CTRL_get_blk_protect_0_sel(data)                              ((0x20000000&(data))>>29)
+#define DC_MEM_PROTECT_CTRL_protect_0_sel_shift                                      (28)
+#define DC_MEM_PROTECT_CTRL_protect_0_sel_mask                                       (0x10000000)
+#define DC_MEM_PROTECT_CTRL_protect_0_sel(data)                                      (0x10000000&((data)<<28))
+#define DC_MEM_PROTECT_CTRL_protect_0_sel_src(data)                                  ((0x10000000&(data))>>28)
+#define DC_MEM_PROTECT_CTRL_get_protect_0_sel(data)                                  ((0x10000000&(data))>>28)
+#define DC_MEM_PROTECT_CTRL_write_enable1_shift                                      (27)
+#define DC_MEM_PROTECT_CTRL_write_enable1_mask                                       (0x08000000)
+#define DC_MEM_PROTECT_CTRL_write_enable1(data)                                      (0x08000000&((data)<<27))
+#define DC_MEM_PROTECT_CTRL_write_enable1_src(data)                                  ((0x08000000&(data))>>27)
+#define DC_MEM_PROTECT_CTRL_get_write_enable1(data)                                  ((0x08000000&(data))>>27)
+#define DC_MEM_PROTECT_CTRL_rd_only_3_en_shift                                       (26)
+#define DC_MEM_PROTECT_CTRL_rd_only_3_en_mask                                        (0x04000000)
+#define DC_MEM_PROTECT_CTRL_rd_only_3_en(data)                                       (0x04000000&((data)<<26))
+#define DC_MEM_PROTECT_CTRL_rd_only_3_en_src(data)                                   ((0x04000000&(data))>>26)
+#define DC_MEM_PROTECT_CTRL_get_rd_only_3_en(data)                                   ((0x04000000&(data))>>26)
+#define DC_MEM_PROTECT_CTRL_rd_only_2_en_shift                                       (25)
+#define DC_MEM_PROTECT_CTRL_rd_only_2_en_mask                                        (0x02000000)
+#define DC_MEM_PROTECT_CTRL_rd_only_2_en(data)                                       (0x02000000&((data)<<25))
+#define DC_MEM_PROTECT_CTRL_rd_only_2_en_src(data)                                   ((0x02000000&(data))>>25)
+#define DC_MEM_PROTECT_CTRL_get_rd_only_2_en(data)                                   ((0x02000000&(data))>>25)
+#define DC_MEM_PROTECT_CTRL_rd_only_1_en_shift                                       (24)
+#define DC_MEM_PROTECT_CTRL_rd_only_1_en_mask                                        (0x01000000)
+#define DC_MEM_PROTECT_CTRL_rd_only_1_en(data)                                       (0x01000000&((data)<<24))
+#define DC_MEM_PROTECT_CTRL_rd_only_1_en_src(data)                                   ((0x01000000&(data))>>24)
+#define DC_MEM_PROTECT_CTRL_get_rd_only_1_en(data)                                   ((0x01000000&(data))>>24)
+#define DC_MEM_PROTECT_CTRL_rd_only_0_en_shift                                       (23)
+#define DC_MEM_PROTECT_CTRL_rd_only_0_en_mask                                        (0x00800000)
+#define DC_MEM_PROTECT_CTRL_rd_only_0_en(data)                                       (0x00800000&((data)<<23))
+#define DC_MEM_PROTECT_CTRL_rd_only_0_en_src(data)                                   ((0x00800000&(data))>>23)
+#define DC_MEM_PROTECT_CTRL_get_rd_only_0_en(data)                                   ((0x00800000&(data))>>23)
+#define DC_MEM_PROTECT_CTRL_write_enable2_shift                                      (22)
+#define DC_MEM_PROTECT_CTRL_write_enable2_mask                                       (0x00400000)
+#define DC_MEM_PROTECT_CTRL_write_enable2(data)                                      (0x00400000&((data)<<22))
+#define DC_MEM_PROTECT_CTRL_write_enable2_src(data)                                  ((0x00400000&(data))>>22)
+#define DC_MEM_PROTECT_CTRL_get_write_enable2(data)                                  ((0x00400000&(data))>>22)
+#define DC_MEM_PROTECT_CTRL_blk_protect_1_wpro_en_shift                              (21)
+#define DC_MEM_PROTECT_CTRL_blk_protect_1_wpro_en_mask                               (0x00200000)
+#define DC_MEM_PROTECT_CTRL_blk_protect_1_wpro_en(data)                              (0x00200000&((data)<<21))
+#define DC_MEM_PROTECT_CTRL_blk_protect_1_wpro_en_src(data)                          ((0x00200000&(data))>>21)
+#define DC_MEM_PROTECT_CTRL_get_blk_protect_1_wpro_en(data)                          ((0x00200000&(data))>>21)
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_wpro_en_shift                              (20)
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_wpro_en_mask                               (0x00100000)
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_wpro_en(data)                              (0x00100000&((data)<<20))
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_wpro_en_src(data)                          ((0x00100000&(data))>>20)
+#define DC_MEM_PROTECT_CTRL_get_blk_protect_0_wpro_en(data)                          ((0x00100000&(data))>>20)
+#define DC_MEM_PROTECT_CTRL_blk_protect_1_en_shift                                   (19)
+#define DC_MEM_PROTECT_CTRL_blk_protect_1_en_mask                                    (0x00080000)
+#define DC_MEM_PROTECT_CTRL_blk_protect_1_en(data)                                   (0x00080000&((data)<<19))
+#define DC_MEM_PROTECT_CTRL_blk_protect_1_en_src(data)                               ((0x00080000&(data))>>19)
+#define DC_MEM_PROTECT_CTRL_get_blk_protect_1_en(data)                               ((0x00080000&(data))>>19)
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_en_shift                                   (18)
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_en_mask                                    (0x00040000)
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_en(data)                                   (0x00040000&((data)<<18))
+#define DC_MEM_PROTECT_CTRL_blk_protect_0_en_src(data)                               ((0x00040000&(data))>>18)
+#define DC_MEM_PROTECT_CTRL_get_blk_protect_0_en(data)                               ((0x00040000&(data))>>18)
+#define DC_MEM_PROTECT_CTRL_write_enable3_shift                                      (17)
+#define DC_MEM_PROTECT_CTRL_write_enable3_mask                                       (0x00020000)
+#define DC_MEM_PROTECT_CTRL_write_enable3(data)                                      (0x00020000&((data)<<17))
+#define DC_MEM_PROTECT_CTRL_write_enable3_src(data)                                  ((0x00020000&(data))>>17)
+#define DC_MEM_PROTECT_CTRL_get_write_enable3(data)                                  ((0x00020000&(data))>>17)
+#define DC_MEM_PROTECT_CTRL_protect_7_wpro_en_shift                                  (16)
+#define DC_MEM_PROTECT_CTRL_protect_7_wpro_en_mask                                   (0x00010000)
+#define DC_MEM_PROTECT_CTRL_protect_7_wpro_en(data)                                  (0x00010000&((data)<<16))
+#define DC_MEM_PROTECT_CTRL_protect_7_wpro_en_src(data)                              ((0x00010000&(data))>>16)
+#define DC_MEM_PROTECT_CTRL_get_protect_7_wpro_en(data)                              ((0x00010000&(data))>>16)
+#define DC_MEM_PROTECT_CTRL_protect_6_wpro_en_shift                                  (15)
+#define DC_MEM_PROTECT_CTRL_protect_6_wpro_en_mask                                   (0x00008000)
+#define DC_MEM_PROTECT_CTRL_protect_6_wpro_en(data)                                  (0x00008000&((data)<<15))
+#define DC_MEM_PROTECT_CTRL_protect_6_wpro_en_src(data)                              ((0x00008000&(data))>>15)
+#define DC_MEM_PROTECT_CTRL_get_protect_6_wpro_en(data)                              ((0x00008000&(data))>>15)
+#define DC_MEM_PROTECT_CTRL_protect_5_wpro_en_shift                                  (14)
+#define DC_MEM_PROTECT_CTRL_protect_5_wpro_en_mask                                   (0x00004000)
+#define DC_MEM_PROTECT_CTRL_protect_5_wpro_en(data)                                  (0x00004000&((data)<<14))
+#define DC_MEM_PROTECT_CTRL_protect_5_wpro_en_src(data)                              ((0x00004000&(data))>>14)
+#define DC_MEM_PROTECT_CTRL_get_protect_5_wpro_en(data)                              ((0x00004000&(data))>>14)
+#define DC_MEM_PROTECT_CTRL_protect_4_wpro_en_shift                                  (13)
+#define DC_MEM_PROTECT_CTRL_protect_4_wpro_en_mask                                   (0x00002000)
+#define DC_MEM_PROTECT_CTRL_protect_4_wpro_en(data)                                  (0x00002000&((data)<<13))
+#define DC_MEM_PROTECT_CTRL_protect_4_wpro_en_src(data)                              ((0x00002000&(data))>>13)
+#define DC_MEM_PROTECT_CTRL_get_protect_4_wpro_en(data)                              ((0x00002000&(data))>>13)
+#define DC_MEM_PROTECT_CTRL_protect_3_wpro_en_shift                                  (12)
+#define DC_MEM_PROTECT_CTRL_protect_3_wpro_en_mask                                   (0x00001000)
+#define DC_MEM_PROTECT_CTRL_protect_3_wpro_en(data)                                  (0x00001000&((data)<<12))
+#define DC_MEM_PROTECT_CTRL_protect_3_wpro_en_src(data)                              ((0x00001000&(data))>>12)
+#define DC_MEM_PROTECT_CTRL_get_protect_3_wpro_en(data)                              ((0x00001000&(data))>>12)
+#define DC_MEM_PROTECT_CTRL_protect_2_wpro_en_shift                                  (11)
+#define DC_MEM_PROTECT_CTRL_protect_2_wpro_en_mask                                   (0x00000800)
+#define DC_MEM_PROTECT_CTRL_protect_2_wpro_en(data)                                  (0x00000800&((data)<<11))
+#define DC_MEM_PROTECT_CTRL_protect_2_wpro_en_src(data)                              ((0x00000800&(data))>>11)
+#define DC_MEM_PROTECT_CTRL_get_protect_2_wpro_en(data)                              ((0x00000800&(data))>>11)
+#define DC_MEM_PROTECT_CTRL_protect_1_wpro_en_shift                                  (10)
+#define DC_MEM_PROTECT_CTRL_protect_1_wpro_en_mask                                   (0x00000400)
+#define DC_MEM_PROTECT_CTRL_protect_1_wpro_en(data)                                  (0x00000400&((data)<<10))
+#define DC_MEM_PROTECT_CTRL_protect_1_wpro_en_src(data)                              ((0x00000400&(data))>>10)
+#define DC_MEM_PROTECT_CTRL_get_protect_1_wpro_en(data)                              ((0x00000400&(data))>>10)
+#define DC_MEM_PROTECT_CTRL_protect_0_wpro_en_shift                                  (9)
+#define DC_MEM_PROTECT_CTRL_protect_0_wpro_en_mask                                   (0x00000200)
+#define DC_MEM_PROTECT_CTRL_protect_0_wpro_en(data)                                  (0x00000200&((data)<<9))
+#define DC_MEM_PROTECT_CTRL_protect_0_wpro_en_src(data)                              ((0x00000200&(data))>>9)
+#define DC_MEM_PROTECT_CTRL_get_protect_0_wpro_en(data)                              ((0x00000200&(data))>>9)
+#define DC_MEM_PROTECT_CTRL_write_enable4_shift                                      (8)
+#define DC_MEM_PROTECT_CTRL_write_enable4_mask                                       (0x00000100)
+#define DC_MEM_PROTECT_CTRL_write_enable4(data)                                      (0x00000100&((data)<<8))
+#define DC_MEM_PROTECT_CTRL_write_enable4_src(data)                                  ((0x00000100&(data))>>8)
+#define DC_MEM_PROTECT_CTRL_get_write_enable4(data)                                  ((0x00000100&(data))>>8)
+#define DC_MEM_PROTECT_CTRL_protect_7_en_shift                                       (7)
+#define DC_MEM_PROTECT_CTRL_protect_7_en_mask                                        (0x00000080)
+#define DC_MEM_PROTECT_CTRL_protect_7_en(data)                                       (0x00000080&((data)<<7))
+#define DC_MEM_PROTECT_CTRL_protect_7_en_src(data)                                   ((0x00000080&(data))>>7)
+#define DC_MEM_PROTECT_CTRL_get_protect_7_en(data)                                   ((0x00000080&(data))>>7)
+#define DC_MEM_PROTECT_CTRL_protect_6_en_shift                                       (6)
+#define DC_MEM_PROTECT_CTRL_protect_6_en_mask                                        (0x00000040)
+#define DC_MEM_PROTECT_CTRL_protect_6_en(data)                                       (0x00000040&((data)<<6))
+#define DC_MEM_PROTECT_CTRL_protect_6_en_src(data)                                   ((0x00000040&(data))>>6)
+#define DC_MEM_PROTECT_CTRL_get_protect_6_en(data)                                   ((0x00000040&(data))>>6)
+#define DC_MEM_PROTECT_CTRL_protect_5_en_shift                                       (5)
+#define DC_MEM_PROTECT_CTRL_protect_5_en_mask                                        (0x00000020)
+#define DC_MEM_PROTECT_CTRL_protect_5_en(data)                                       (0x00000020&((data)<<5))
+#define DC_MEM_PROTECT_CTRL_protect_5_en_src(data)                                   ((0x00000020&(data))>>5)
+#define DC_MEM_PROTECT_CTRL_get_protect_5_en(data)                                   ((0x00000020&(data))>>5)
+#define DC_MEM_PROTECT_CTRL_protect_4_en_shift                                       (4)
+#define DC_MEM_PROTECT_CTRL_protect_4_en_mask                                        (0x00000010)
+#define DC_MEM_PROTECT_CTRL_protect_4_en(data)                                       (0x00000010&((data)<<4))
+#define DC_MEM_PROTECT_CTRL_protect_4_en_src(data)                                   ((0x00000010&(data))>>4)
+#define DC_MEM_PROTECT_CTRL_get_protect_4_en(data)                                   ((0x00000010&(data))>>4)
+#define DC_MEM_PROTECT_CTRL_protect_3_en_shift                                       (3)
+#define DC_MEM_PROTECT_CTRL_protect_3_en_mask                                        (0x00000008)
+#define DC_MEM_PROTECT_CTRL_protect_3_en(data)                                       (0x00000008&((data)<<3))
+#define DC_MEM_PROTECT_CTRL_protect_3_en_src(data)                                   ((0x00000008&(data))>>3)
+#define DC_MEM_PROTECT_CTRL_get_protect_3_en(data)                                   ((0x00000008&(data))>>3)
+#define DC_MEM_PROTECT_CTRL_protect_2_en_shift                                       (2)
+#define DC_MEM_PROTECT_CTRL_protect_2_en_mask                                        (0x00000004)
+#define DC_MEM_PROTECT_CTRL_protect_2_en(data)                                       (0x00000004&((data)<<2))
+#define DC_MEM_PROTECT_CTRL_protect_2_en_src(data)                                   ((0x00000004&(data))>>2)
+#define DC_MEM_PROTECT_CTRL_get_protect_2_en(data)                                   ((0x00000004&(data))>>2)
+#define DC_MEM_PROTECT_CTRL_protect_1_en_shift                                       (1)
+#define DC_MEM_PROTECT_CTRL_protect_1_en_mask                                        (0x00000002)
+#define DC_MEM_PROTECT_CTRL_protect_1_en(data)                                       (0x00000002&((data)<<1))
+#define DC_MEM_PROTECT_CTRL_protect_1_en_src(data)                                   ((0x00000002&(data))>>1)
+#define DC_MEM_PROTECT_CTRL_get_protect_1_en(data)                                   ((0x00000002&(data))>>1)
+#define DC_MEM_PROTECT_CTRL_protect_0_en_shift                                       (0)
+#define DC_MEM_PROTECT_CTRL_protect_0_en_mask                                        (0x00000001)
+#define DC_MEM_PROTECT_CTRL_protect_0_en(data)                                       (0x00000001&((data)<<0))
+#define DC_MEM_PROTECT_CTRL_protect_0_en_src(data)                                   ((0x00000001&(data))>>0)
+#define DC_MEM_PROTECT_CTRL_get_protect_0_en(data)                                   ((0x00000001&(data))>>0)
+
+
+#define DC_MEM_SCRAMBLE_CTRL                                                         0x18008404
+#define DC_MEM_SCRAMBLE_CTRL_reg_addr                                                "0xB8008404"
+#define DC_MEM_SCRAMBLE_CTRL_reg                                                     0xB8008404
+#define set_DC_MEM_SCRAMBLE_CTRL_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_CTRL_reg)=data)
+#define get_DC_MEM_SCRAMBLE_CTRL_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_CTRL_reg))
+#define DC_MEM_SCRAMBLE_CTRL_inst_adr                                                "0x0001"
+#define DC_MEM_SCRAMBLE_CTRL_inst                                                    0x0001
+#define DC_MEM_SCRAMBLE_CTRL_y_limit_shift                                           (14)
+#define DC_MEM_SCRAMBLE_CTRL_y_limit_mask                                            (0x00004000)
+#define DC_MEM_SCRAMBLE_CTRL_y_limit(data)                                           (0x00004000&((data)<<14))
+#define DC_MEM_SCRAMBLE_CTRL_y_limit_src(data)                                       ((0x00004000&(data))>>14)
+#define DC_MEM_SCRAMBLE_CTRL_get_y_limit(data)                                       ((0x00004000&(data))>>14)
+#define DC_MEM_SCRAMBLE_CTRL_bank_remap_enable_shift                                 (13)
+#define DC_MEM_SCRAMBLE_CTRL_bank_remap_enable_mask                                  (0x00002000)
+#define DC_MEM_SCRAMBLE_CTRL_bank_remap_enable(data)                                 (0x00002000&((data)<<13))
+#define DC_MEM_SCRAMBLE_CTRL_bank_remap_enable_src(data)                             ((0x00002000&(data))>>13)
+#define DC_MEM_SCRAMBLE_CTRL_get_bank_remap_enable(data)                             ((0x00002000&(data))>>13)
+#define DC_MEM_SCRAMBLE_CTRL_tp_scramble_en_shift                                    (12)
+#define DC_MEM_SCRAMBLE_CTRL_tp_scramble_en_mask                                     (0x00001000)
+#define DC_MEM_SCRAMBLE_CTRL_tp_scramble_en(data)                                    (0x00001000&((data)<<12))
+#define DC_MEM_SCRAMBLE_CTRL_tp_scramble_en_src(data)                                ((0x00001000&(data))>>12)
+#define DC_MEM_SCRAMBLE_CTRL_get_tp_scramble_en(data)                                ((0x00001000&(data))>>12)
+#define DC_MEM_SCRAMBLE_CTRL_video_dec_scramble_en_shift                             (11)
+#define DC_MEM_SCRAMBLE_CTRL_video_dec_scramble_en_mask                              (0x00000800)
+#define DC_MEM_SCRAMBLE_CTRL_video_dec_scramble_en(data)                             (0x00000800&((data)<<11))
+#define DC_MEM_SCRAMBLE_CTRL_video_dec_scramble_en_src(data)                         ((0x00000800&(data))>>11)
+#define DC_MEM_SCRAMBLE_CTRL_get_video_dec_scramble_en(data)                         ((0x00000800&(data))>>11)
+#define DC_MEM_SCRAMBLE_CTRL_audio_scramble_en_shift                                 (10)
+#define DC_MEM_SCRAMBLE_CTRL_audio_scramble_en_mask                                  (0x00000400)
+#define DC_MEM_SCRAMBLE_CTRL_audio_scramble_en(data)                                 (0x00000400&((data)<<10))
+#define DC_MEM_SCRAMBLE_CTRL_audio_scramble_en_src(data)                             ((0x00000400&(data))>>10)
+#define DC_MEM_SCRAMBLE_CTRL_get_audio_scramble_en(data)                             ((0x00000400&(data))>>10)
+#define DC_MEM_SCRAMBLE_CTRL_scpu_scramble_en_shift                                  (9)
+#define DC_MEM_SCRAMBLE_CTRL_scpu_scramble_en_mask                                   (0x00000200)
+#define DC_MEM_SCRAMBLE_CTRL_scpu_scramble_en(data)                                  (0x00000200&((data)<<9))
+#define DC_MEM_SCRAMBLE_CTRL_scpu_scramble_en_src(data)                              ((0x00000200&(data))>>9)
+#define DC_MEM_SCRAMBLE_CTRL_get_scpu_scramble_en(data)                              ((0x00000200&(data))>>9)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_all_en_shift                                   (8)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_all_en_mask                                    (0x00000100)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_all_en(data)                                   (0x00000100&((data)<<8))
+#define DC_MEM_SCRAMBLE_CTRL_scramble_all_en_src(data)                               ((0x00000100&(data))>>8)
+#define DC_MEM_SCRAMBLE_CTRL_get_scramble_all_en(data)                               ((0x00000100&(data))>>8)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_7_en_shift                                     (7)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_7_en_mask                                      (0x00000080)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_7_en(data)                                     (0x00000080&((data)<<7))
+#define DC_MEM_SCRAMBLE_CTRL_scramble_7_en_src(data)                                 ((0x00000080&(data))>>7)
+#define DC_MEM_SCRAMBLE_CTRL_get_scramble_7_en(data)                                 ((0x00000080&(data))>>7)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_6_en_shift                                     (6)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_6_en_mask                                      (0x00000040)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_6_en(data)                                     (0x00000040&((data)<<6))
+#define DC_MEM_SCRAMBLE_CTRL_scramble_6_en_src(data)                                 ((0x00000040&(data))>>6)
+#define DC_MEM_SCRAMBLE_CTRL_get_scramble_6_en(data)                                 ((0x00000040&(data))>>6)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_5_en_shift                                     (5)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_5_en_mask                                      (0x00000020)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_5_en(data)                                     (0x00000020&((data)<<5))
+#define DC_MEM_SCRAMBLE_CTRL_scramble_5_en_src(data)                                 ((0x00000020&(data))>>5)
+#define DC_MEM_SCRAMBLE_CTRL_get_scramble_5_en(data)                                 ((0x00000020&(data))>>5)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_4_en_shift                                     (4)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_4_en_mask                                      (0x00000010)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_4_en(data)                                     (0x00000010&((data)<<4))
+#define DC_MEM_SCRAMBLE_CTRL_scramble_4_en_src(data)                                 ((0x00000010&(data))>>4)
+#define DC_MEM_SCRAMBLE_CTRL_get_scramble_4_en(data)                                 ((0x00000010&(data))>>4)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_3_en_shift                                     (3)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_3_en_mask                                      (0x00000008)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_3_en(data)                                     (0x00000008&((data)<<3))
+#define DC_MEM_SCRAMBLE_CTRL_scramble_3_en_src(data)                                 ((0x00000008&(data))>>3)
+#define DC_MEM_SCRAMBLE_CTRL_get_scramble_3_en(data)                                 ((0x00000008&(data))>>3)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_2_en_shift                                     (2)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_2_en_mask                                      (0x00000004)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_2_en(data)                                     (0x00000004&((data)<<2))
+#define DC_MEM_SCRAMBLE_CTRL_scramble_2_en_src(data)                                 ((0x00000004&(data))>>2)
+#define DC_MEM_SCRAMBLE_CTRL_get_scramble_2_en(data)                                 ((0x00000004&(data))>>2)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_1_en_shift                                     (1)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_1_en_mask                                      (0x00000002)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_1_en(data)                                     (0x00000002&((data)<<1))
+#define DC_MEM_SCRAMBLE_CTRL_scramble_1_en_src(data)                                 ((0x00000002&(data))>>1)
+#define DC_MEM_SCRAMBLE_CTRL_get_scramble_1_en(data)                                 ((0x00000002&(data))>>1)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_0_en_shift                                     (0)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_0_en_mask                                      (0x00000001)
+#define DC_MEM_SCRAMBLE_CTRL_scramble_0_en(data)                                     (0x00000001&((data)<<0))
+#define DC_MEM_SCRAMBLE_CTRL_scramble_0_en_src(data)                                 ((0x00000001&(data))>>0)
+#define DC_MEM_SCRAMBLE_CTRL_get_scramble_0_en(data)                                 ((0x00000001&(data))>>0)
+
+
+#define DC_MEM_PROTECT_SADDR0                                                        0x18008408
+#define DC_MEM_PROTECT_SADDR0_reg_addr                                               "0xB8008408"
+#define DC_MEM_PROTECT_SADDR0_reg                                                    0xB8008408
+#define set_DC_MEM_PROTECT_SADDR0_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR0_reg)=data)
+#define get_DC_MEM_PROTECT_SADDR0_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR0_reg))
+#define DC_MEM_PROTECT_SADDR0_inst_adr                                               "0x0002"
+#define DC_MEM_PROTECT_SADDR0_inst                                                   0x0002
+#define DC_MEM_PROTECT_SADDR0_saddr0_shift                                           (12)
+#define DC_MEM_PROTECT_SADDR0_saddr0_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_SADDR0_saddr0(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_SADDR0_saddr0_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_SADDR0_get_saddr0(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_EADDR0                                                        0x1800840C
+#define DC_MEM_PROTECT_EADDR0_reg_addr                                               "0xB800840C"
+#define DC_MEM_PROTECT_EADDR0_reg                                                    0xB800840C
+#define set_DC_MEM_PROTECT_EADDR0_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR0_reg)=data)
+#define get_DC_MEM_PROTECT_EADDR0_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR0_reg))
+#define DC_MEM_PROTECT_EADDR0_inst_adr                                               "0x0003"
+#define DC_MEM_PROTECT_EADDR0_inst                                                   0x0003
+#define DC_MEM_PROTECT_EADDR0_eaddr0_shift                                           (12)
+#define DC_MEM_PROTECT_EADDR0_eaddr0_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_EADDR0_eaddr0(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_EADDR0_eaddr0_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_EADDR0_get_eaddr0(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_SADDR1                                                        0x18008410
+#define DC_MEM_PROTECT_SADDR1_reg_addr                                               "0xB8008410"
+#define DC_MEM_PROTECT_SADDR1_reg                                                    0xB8008410
+#define set_DC_MEM_PROTECT_SADDR1_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR1_reg)=data)
+#define get_DC_MEM_PROTECT_SADDR1_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR1_reg))
+#define DC_MEM_PROTECT_SADDR1_inst_adr                                               "0x0004"
+#define DC_MEM_PROTECT_SADDR1_inst                                                   0x0004
+#define DC_MEM_PROTECT_SADDR1_saddr1_shift                                           (12)
+#define DC_MEM_PROTECT_SADDR1_saddr1_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_SADDR1_saddr1(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_SADDR1_saddr1_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_SADDR1_get_saddr1(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_EADDR1                                                        0x18008414
+#define DC_MEM_PROTECT_EADDR1_reg_addr                                               "0xB8008414"
+#define DC_MEM_PROTECT_EADDR1_reg                                                    0xB8008414
+#define set_DC_MEM_PROTECT_EADDR1_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR1_reg)=data)
+#define get_DC_MEM_PROTECT_EADDR1_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR1_reg))
+#define DC_MEM_PROTECT_EADDR1_inst_adr                                               "0x0005"
+#define DC_MEM_PROTECT_EADDR1_inst                                                   0x0005
+#define DC_MEM_PROTECT_EADDR1_eaddr1_shift                                           (12)
+#define DC_MEM_PROTECT_EADDR1_eaddr1_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_EADDR1_eaddr1(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_EADDR1_eaddr1_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_EADDR1_get_eaddr1(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_SADDR2                                                        0x18008418
+#define DC_MEM_PROTECT_SADDR2_reg_addr                                               "0xB8008418"
+#define DC_MEM_PROTECT_SADDR2_reg                                                    0xB8008418
+#define set_DC_MEM_PROTECT_SADDR2_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR2_reg)=data)
+#define get_DC_MEM_PROTECT_SADDR2_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR2_reg))
+#define DC_MEM_PROTECT_SADDR2_inst_adr                                               "0x0006"
+#define DC_MEM_PROTECT_SADDR2_inst                                                   0x0006
+#define DC_MEM_PROTECT_SADDR2_saddr2_shift                                           (12)
+#define DC_MEM_PROTECT_SADDR2_saddr2_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_SADDR2_saddr2(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_SADDR2_saddr2_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_SADDR2_get_saddr2(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_EADDR2                                                        0x1800841C
+#define DC_MEM_PROTECT_EADDR2_reg_addr                                               "0xB800841C"
+#define DC_MEM_PROTECT_EADDR2_reg                                                    0xB800841C
+#define set_DC_MEM_PROTECT_EADDR2_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR2_reg)=data)
+#define get_DC_MEM_PROTECT_EADDR2_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR2_reg))
+#define DC_MEM_PROTECT_EADDR2_inst_adr                                               "0x0007"
+#define DC_MEM_PROTECT_EADDR2_inst                                                   0x0007
+#define DC_MEM_PROTECT_EADDR2_eaddr2_shift                                           (12)
+#define DC_MEM_PROTECT_EADDR2_eaddr2_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_EADDR2_eaddr2(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_EADDR2_eaddr2_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_EADDR2_get_eaddr2(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_SADDR3                                                        0x18008420
+#define DC_MEM_PROTECT_SADDR3_reg_addr                                               "0xB8008420"
+#define DC_MEM_PROTECT_SADDR3_reg                                                    0xB8008420
+#define set_DC_MEM_PROTECT_SADDR3_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR3_reg)=data)
+#define get_DC_MEM_PROTECT_SADDR3_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR3_reg))
+#define DC_MEM_PROTECT_SADDR3_inst_adr                                               "0x0008"
+#define DC_MEM_PROTECT_SADDR3_inst                                                   0x0008
+#define DC_MEM_PROTECT_SADDR3_saddr3_shift                                           (12)
+#define DC_MEM_PROTECT_SADDR3_saddr3_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_SADDR3_saddr3(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_SADDR3_saddr3_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_SADDR3_get_saddr3(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_EADDR3                                                        0x18008424
+#define DC_MEM_PROTECT_EADDR3_reg_addr                                               "0xB8008424"
+#define DC_MEM_PROTECT_EADDR3_reg                                                    0xB8008424
+#define set_DC_MEM_PROTECT_EADDR3_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR3_reg)=data)
+#define get_DC_MEM_PROTECT_EADDR3_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR3_reg))
+#define DC_MEM_PROTECT_EADDR3_inst_adr                                               "0x0009"
+#define DC_MEM_PROTECT_EADDR3_inst                                                   0x0009
+#define DC_MEM_PROTECT_EADDR3_eaddr3_shift                                           (12)
+#define DC_MEM_PROTECT_EADDR3_eaddr3_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_EADDR3_eaddr3(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_EADDR3_eaddr3_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_EADDR3_get_eaddr3(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_SADDR4                                                        0x18008428
+#define DC_MEM_PROTECT_SADDR4_reg_addr                                               "0xB8008428"
+#define DC_MEM_PROTECT_SADDR4_reg                                                    0xB8008428
+#define set_DC_MEM_PROTECT_SADDR4_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR4_reg)=data)
+#define get_DC_MEM_PROTECT_SADDR4_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR4_reg))
+#define DC_MEM_PROTECT_SADDR4_inst_adr                                               "0x000A"
+#define DC_MEM_PROTECT_SADDR4_inst                                                   0x000A
+#define DC_MEM_PROTECT_SADDR4_saddr4_shift                                           (12)
+#define DC_MEM_PROTECT_SADDR4_saddr4_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_SADDR4_saddr4(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_SADDR4_saddr4_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_SADDR4_get_saddr4(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_EADDR4                                                        0x1800842C
+#define DC_MEM_PROTECT_EADDR4_reg_addr                                               "0xB800842C"
+#define DC_MEM_PROTECT_EADDR4_reg                                                    0xB800842C
+#define set_DC_MEM_PROTECT_EADDR4_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR4_reg)=data)
+#define get_DC_MEM_PROTECT_EADDR4_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR4_reg))
+#define DC_MEM_PROTECT_EADDR4_inst_adr                                               "0x000B"
+#define DC_MEM_PROTECT_EADDR4_inst                                                   0x000B
+#define DC_MEM_PROTECT_EADDR4_eaddr4_shift                                           (12)
+#define DC_MEM_PROTECT_EADDR4_eaddr4_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_EADDR4_eaddr4(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_EADDR4_eaddr4_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_EADDR4_get_eaddr4(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_SADDR5                                                        0x18008430
+#define DC_MEM_PROTECT_SADDR5_reg_addr                                               "0xB8008430"
+#define DC_MEM_PROTECT_SADDR5_reg                                                    0xB8008430
+#define set_DC_MEM_PROTECT_SADDR5_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR5_reg)=data)
+#define get_DC_MEM_PROTECT_SADDR5_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR5_reg))
+#define DC_MEM_PROTECT_SADDR5_inst_adr                                               "0x000C"
+#define DC_MEM_PROTECT_SADDR5_inst                                                   0x000C
+#define DC_MEM_PROTECT_SADDR5_saddr5_shift                                           (12)
+#define DC_MEM_PROTECT_SADDR5_saddr5_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_SADDR5_saddr5(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_SADDR5_saddr5_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_SADDR5_get_saddr5(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_EADDR5                                                        0x18008434
+#define DC_MEM_PROTECT_EADDR5_reg_addr                                               "0xB8008434"
+#define DC_MEM_PROTECT_EADDR5_reg                                                    0xB8008434
+#define set_DC_MEM_PROTECT_EADDR5_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR5_reg)=data)
+#define get_DC_MEM_PROTECT_EADDR5_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR5_reg))
+#define DC_MEM_PROTECT_EADDR5_inst_adr                                               "0x000D"
+#define DC_MEM_PROTECT_EADDR5_inst                                                   0x000D
+#define DC_MEM_PROTECT_EADDR5_eaddr5_shift                                           (12)
+#define DC_MEM_PROTECT_EADDR5_eaddr5_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_EADDR5_eaddr5(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_EADDR5_eaddr5_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_EADDR5_get_eaddr5(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_SADDR6                                                        0x18008438
+#define DC_MEM_PROTECT_SADDR6_reg_addr                                               "0xB8008438"
+#define DC_MEM_PROTECT_SADDR6_reg                                                    0xB8008438
+#define set_DC_MEM_PROTECT_SADDR6_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR6_reg)=data)
+#define get_DC_MEM_PROTECT_SADDR6_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR6_reg))
+#define DC_MEM_PROTECT_SADDR6_inst_adr                                               "0x000E"
+#define DC_MEM_PROTECT_SADDR6_inst                                                   0x000E
+#define DC_MEM_PROTECT_SADDR6_saddr6_shift                                           (12)
+#define DC_MEM_PROTECT_SADDR6_saddr6_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_SADDR6_saddr6(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_SADDR6_saddr6_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_SADDR6_get_saddr6(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_EADDR6                                                        0x1800843C
+#define DC_MEM_PROTECT_EADDR6_reg_addr                                               "0xB800843C"
+#define DC_MEM_PROTECT_EADDR6_reg                                                    0xB800843C
+#define set_DC_MEM_PROTECT_EADDR6_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR6_reg)=data)
+#define get_DC_MEM_PROTECT_EADDR6_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR6_reg))
+#define DC_MEM_PROTECT_EADDR6_inst_adr                                               "0x000F"
+#define DC_MEM_PROTECT_EADDR6_inst                                                   0x000F
+#define DC_MEM_PROTECT_EADDR6_eaddr6_shift                                           (12)
+#define DC_MEM_PROTECT_EADDR6_eaddr6_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_EADDR6_eaddr6(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_EADDR6_eaddr6_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_EADDR6_get_eaddr6(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_SADDR7                                                        0x18008440
+#define DC_MEM_PROTECT_SADDR7_reg_addr                                               "0xB8008440"
+#define DC_MEM_PROTECT_SADDR7_reg                                                    0xB8008440
+#define set_DC_MEM_PROTECT_SADDR7_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR7_reg)=data)
+#define get_DC_MEM_PROTECT_SADDR7_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_SADDR7_reg))
+#define DC_MEM_PROTECT_SADDR7_inst_adr                                               "0x0010"
+#define DC_MEM_PROTECT_SADDR7_inst                                                   0x0010
+#define DC_MEM_PROTECT_SADDR7_saddr7_shift                                           (12)
+#define DC_MEM_PROTECT_SADDR7_saddr7_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_SADDR7_saddr7(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_SADDR7_saddr7_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_SADDR7_get_saddr7(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_EADDR7                                                        0x18008444
+#define DC_MEM_PROTECT_EADDR7_reg_addr                                               "0xB8008444"
+#define DC_MEM_PROTECT_EADDR7_reg                                                    0xB8008444
+#define set_DC_MEM_PROTECT_EADDR7_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR7_reg)=data)
+#define get_DC_MEM_PROTECT_EADDR7_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_EADDR7_reg))
+#define DC_MEM_PROTECT_EADDR7_inst_adr                                               "0x0011"
+#define DC_MEM_PROTECT_EADDR7_inst                                                   0x0011
+#define DC_MEM_PROTECT_EADDR7_eaddr7_shift                                           (12)
+#define DC_MEM_PROTECT_EADDR7_eaddr7_mask                                            (0xFFFFF000)
+#define DC_MEM_PROTECT_EADDR7_eaddr7(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_MEM_PROTECT_EADDR7_eaddr7_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_MEM_PROTECT_EADDR7_get_eaddr7(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_BLK_PROTECT_SADDR0                                                        0x18008448
+#define DC_BLK_PROTECT_SADDR0_reg_addr                                               "0xB8008448"
+#define DC_BLK_PROTECT_SADDR0_reg                                                    0xB8008448
+#define set_DC_BLK_PROTECT_SADDR0_reg(data)   (*((volatile unsigned int*) DC_BLK_PROTECT_SADDR0_reg)=data)
+#define get_DC_BLK_PROTECT_SADDR0_reg   (*((volatile unsigned int*) DC_BLK_PROTECT_SADDR0_reg))
+#define DC_BLK_PROTECT_SADDR0_inst_adr                                               "0x0012"
+#define DC_BLK_PROTECT_SADDR0_inst                                                   0x0012
+#define DC_BLK_PROTECT_SADDR0_saddr0_shift                                           (12)
+#define DC_BLK_PROTECT_SADDR0_saddr0_mask                                            (0xFFFFF000)
+#define DC_BLK_PROTECT_SADDR0_saddr0(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_BLK_PROTECT_SADDR0_saddr0_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_BLK_PROTECT_SADDR0_get_saddr0(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_BLK_PROTECT_EADDR0                                                        0x1800844C
+#define DC_BLK_PROTECT_EADDR0_reg_addr                                               "0xB800844C"
+#define DC_BLK_PROTECT_EADDR0_reg                                                    0xB800844C
+#define set_DC_BLK_PROTECT_EADDR0_reg(data)   (*((volatile unsigned int*) DC_BLK_PROTECT_EADDR0_reg)=data)
+#define get_DC_BLK_PROTECT_EADDR0_reg   (*((volatile unsigned int*) DC_BLK_PROTECT_EADDR0_reg))
+#define DC_BLK_PROTECT_EADDR0_inst_adr                                               "0x0013"
+#define DC_BLK_PROTECT_EADDR0_inst                                                   0x0013
+#define DC_BLK_PROTECT_EADDR0_eaddr0_shift                                           (12)
+#define DC_BLK_PROTECT_EADDR0_eaddr0_mask                                            (0xFFFFF000)
+#define DC_BLK_PROTECT_EADDR0_eaddr0(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_BLK_PROTECT_EADDR0_eaddr0_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_BLK_PROTECT_EADDR0_get_eaddr0(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_BLK_PROTECT_SADDR1                                                        0x18008450
+#define DC_BLK_PROTECT_SADDR1_reg_addr                                               "0xB8008450"
+#define DC_BLK_PROTECT_SADDR1_reg                                                    0xB8008450
+#define set_DC_BLK_PROTECT_SADDR1_reg(data)   (*((volatile unsigned int*) DC_BLK_PROTECT_SADDR1_reg)=data)
+#define get_DC_BLK_PROTECT_SADDR1_reg   (*((volatile unsigned int*) DC_BLK_PROTECT_SADDR1_reg))
+#define DC_BLK_PROTECT_SADDR1_inst_adr                                               "0x0014"
+#define DC_BLK_PROTECT_SADDR1_inst                                                   0x0014
+#define DC_BLK_PROTECT_SADDR1_saddr1_shift                                           (12)
+#define DC_BLK_PROTECT_SADDR1_saddr1_mask                                            (0xFFFFF000)
+#define DC_BLK_PROTECT_SADDR1_saddr1(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_BLK_PROTECT_SADDR1_saddr1_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_BLK_PROTECT_SADDR1_get_saddr1(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_BLK_PROTECT_EADDR1                                                        0x18008454
+#define DC_BLK_PROTECT_EADDR1_reg_addr                                               "0xB8008454"
+#define DC_BLK_PROTECT_EADDR1_reg                                                    0xB8008454
+#define set_DC_BLK_PROTECT_EADDR1_reg(data)   (*((volatile unsigned int*) DC_BLK_PROTECT_EADDR1_reg)=data)
+#define get_DC_BLK_PROTECT_EADDR1_reg   (*((volatile unsigned int*) DC_BLK_PROTECT_EADDR1_reg))
+#define DC_BLK_PROTECT_EADDR1_inst_adr                                               "0x0015"
+#define DC_BLK_PROTECT_EADDR1_inst                                                   0x0015
+#define DC_BLK_PROTECT_EADDR1_eaddr1_shift                                           (12)
+#define DC_BLK_PROTECT_EADDR1_eaddr1_mask                                            (0xFFFFF000)
+#define DC_BLK_PROTECT_EADDR1_eaddr1(data)                                           (0xFFFFF000&((data)<<12))
+#define DC_BLK_PROTECT_EADDR1_eaddr1_src(data)                                       ((0xFFFFF000&(data))>>12)
+#define DC_BLK_PROTECT_EADDR1_get_eaddr1(data)                                       ((0xFFFFF000&(data))>>12)
+
+
+#define DC_RO_PROTECT_SADDR0                                                         0x18008458
+#define DC_RO_PROTECT_SADDR0_reg_addr                                                "0xB8008458"
+#define DC_RO_PROTECT_SADDR0_reg                                                     0xB8008458
+#define set_DC_RO_PROTECT_SADDR0_reg(data)   (*((volatile unsigned int*) DC_RO_PROTECT_SADDR0_reg)=data)
+#define get_DC_RO_PROTECT_SADDR0_reg   (*((volatile unsigned int*) DC_RO_PROTECT_SADDR0_reg))
+#define DC_RO_PROTECT_SADDR0_inst_adr                                                "0x0016"
+#define DC_RO_PROTECT_SADDR0_inst                                                    0x0016
+#define DC_RO_PROTECT_SADDR0_saddr0_shift                                            (12)
+#define DC_RO_PROTECT_SADDR0_saddr0_mask                                             (0xFFFFF000)
+#define DC_RO_PROTECT_SADDR0_saddr0(data)                                            (0xFFFFF000&((data)<<12))
+#define DC_RO_PROTECT_SADDR0_saddr0_src(data)                                        ((0xFFFFF000&(data))>>12)
+#define DC_RO_PROTECT_SADDR0_get_saddr0(data)                                        ((0xFFFFF000&(data))>>12)
+
+
+#define DC_RO_PROTECT_EADDR0                                                         0x1800845C
+#define DC_RO_PROTECT_EADDR0_reg_addr                                                "0xB800845C"
+#define DC_RO_PROTECT_EADDR0_reg                                                     0xB800845C
+#define set_DC_RO_PROTECT_EADDR0_reg(data)   (*((volatile unsigned int*) DC_RO_PROTECT_EADDR0_reg)=data)
+#define get_DC_RO_PROTECT_EADDR0_reg   (*((volatile unsigned int*) DC_RO_PROTECT_EADDR0_reg))
+#define DC_RO_PROTECT_EADDR0_inst_adr                                                "0x0017"
+#define DC_RO_PROTECT_EADDR0_inst                                                    0x0017
+#define DC_RO_PROTECT_EADDR0_eaddr0_shift                                            (12)
+#define DC_RO_PROTECT_EADDR0_eaddr0_mask                                             (0xFFFFF000)
+#define DC_RO_PROTECT_EADDR0_eaddr0(data)                                            (0xFFFFF000&((data)<<12))
+#define DC_RO_PROTECT_EADDR0_eaddr0_src(data)                                        ((0xFFFFF000&(data))>>12)
+#define DC_RO_PROTECT_EADDR0_get_eaddr0(data)                                        ((0xFFFFF000&(data))>>12)
+
+
+#define DC_RO_PROTECT_SADDR1                                                         0x18008460
+#define DC_RO_PROTECT_SADDR1_reg_addr                                                "0xB8008460"
+#define DC_RO_PROTECT_SADDR1_reg                                                     0xB8008460
+#define set_DC_RO_PROTECT_SADDR1_reg(data)   (*((volatile unsigned int*) DC_RO_PROTECT_SADDR1_reg)=data)
+#define get_DC_RO_PROTECT_SADDR1_reg   (*((volatile unsigned int*) DC_RO_PROTECT_SADDR1_reg))
+#define DC_RO_PROTECT_SADDR1_inst_adr                                                "0x0018"
+#define DC_RO_PROTECT_SADDR1_inst                                                    0x0018
+#define DC_RO_PROTECT_SADDR1_saddr1_shift                                            (12)
+#define DC_RO_PROTECT_SADDR1_saddr1_mask                                             (0xFFFFF000)
+#define DC_RO_PROTECT_SADDR1_saddr1(data)                                            (0xFFFFF000&((data)<<12))
+#define DC_RO_PROTECT_SADDR1_saddr1_src(data)                                        ((0xFFFFF000&(data))>>12)
+#define DC_RO_PROTECT_SADDR1_get_saddr1(data)                                        ((0xFFFFF000&(data))>>12)
+
+
+#define DC_RO_PROTECT_EADDR1                                                         0x18008464
+#define DC_RO_PROTECT_EADDR1_reg_addr                                                "0xB8008464"
+#define DC_RO_PROTECT_EADDR1_reg                                                     0xB8008464
+#define set_DC_RO_PROTECT_EADDR1_reg(data)   (*((volatile unsigned int*) DC_RO_PROTECT_EADDR1_reg)=data)
+#define get_DC_RO_PROTECT_EADDR1_reg   (*((volatile unsigned int*) DC_RO_PROTECT_EADDR1_reg))
+#define DC_RO_PROTECT_EADDR1_inst_adr                                                "0x0019"
+#define DC_RO_PROTECT_EADDR1_inst                                                    0x0019
+#define DC_RO_PROTECT_EADDR1_eaddr1_shift                                            (12)
+#define DC_RO_PROTECT_EADDR1_eaddr1_mask                                             (0xFFFFF000)
+#define DC_RO_PROTECT_EADDR1_eaddr1(data)                                            (0xFFFFF000&((data)<<12))
+#define DC_RO_PROTECT_EADDR1_eaddr1_src(data)                                        ((0xFFFFF000&(data))>>12)
+#define DC_RO_PROTECT_EADDR1_get_eaddr1(data)                                        ((0xFFFFF000&(data))>>12)
+
+
+#define DC_RO_PROTECT_SADDR2                                                         0x18008468
+#define DC_RO_PROTECT_SADDR2_reg_addr                                                "0xB8008468"
+#define DC_RO_PROTECT_SADDR2_reg                                                     0xB8008468
+#define set_DC_RO_PROTECT_SADDR2_reg(data)   (*((volatile unsigned int*) DC_RO_PROTECT_SADDR2_reg)=data)
+#define get_DC_RO_PROTECT_SADDR2_reg   (*((volatile unsigned int*) DC_RO_PROTECT_SADDR2_reg))
+#define DC_RO_PROTECT_SADDR2_inst_adr                                                "0x001A"
+#define DC_RO_PROTECT_SADDR2_inst                                                    0x001A
+#define DC_RO_PROTECT_SADDR2_saddr2_shift                                            (12)
+#define DC_RO_PROTECT_SADDR2_saddr2_mask                                             (0xFFFFF000)
+#define DC_RO_PROTECT_SADDR2_saddr2(data)                                            (0xFFFFF000&((data)<<12))
+#define DC_RO_PROTECT_SADDR2_saddr2_src(data)                                        ((0xFFFFF000&(data))>>12)
+#define DC_RO_PROTECT_SADDR2_get_saddr2(data)                                        ((0xFFFFF000&(data))>>12)
+
+
+#define DC_RO_PROTECT_EADDR2                                                         0x1800846C
+#define DC_RO_PROTECT_EADDR2_reg_addr                                                "0xB800846C"
+#define DC_RO_PROTECT_EADDR2_reg                                                     0xB800846C
+#define set_DC_RO_PROTECT_EADDR2_reg(data)   (*((volatile unsigned int*) DC_RO_PROTECT_EADDR2_reg)=data)
+#define get_DC_RO_PROTECT_EADDR2_reg   (*((volatile unsigned int*) DC_RO_PROTECT_EADDR2_reg))
+#define DC_RO_PROTECT_EADDR2_inst_adr                                                "0x001B"
+#define DC_RO_PROTECT_EADDR2_inst                                                    0x001B
+#define DC_RO_PROTECT_EADDR2_eaddr2_shift                                            (12)
+#define DC_RO_PROTECT_EADDR2_eaddr2_mask                                             (0xFFFFF000)
+#define DC_RO_PROTECT_EADDR2_eaddr2(data)                                            (0xFFFFF000&((data)<<12))
+#define DC_RO_PROTECT_EADDR2_eaddr2_src(data)                                        ((0xFFFFF000&(data))>>12)
+#define DC_RO_PROTECT_EADDR2_get_eaddr2(data)                                        ((0xFFFFF000&(data))>>12)
+
+
+#define DC_RO_PROTECT_SADDR3                                                         0x18008470
+#define DC_RO_PROTECT_SADDR3_reg_addr                                                "0xB8008470"
+#define DC_RO_PROTECT_SADDR3_reg                                                     0xB8008470
+#define set_DC_RO_PROTECT_SADDR3_reg(data)   (*((volatile unsigned int*) DC_RO_PROTECT_SADDR3_reg)=data)
+#define get_DC_RO_PROTECT_SADDR3_reg   (*((volatile unsigned int*) DC_RO_PROTECT_SADDR3_reg))
+#define DC_RO_PROTECT_SADDR3_inst_adr                                                "0x001C"
+#define DC_RO_PROTECT_SADDR3_inst                                                    0x001C
+#define DC_RO_PROTECT_SADDR3_saddr3_shift                                            (12)
+#define DC_RO_PROTECT_SADDR3_saddr3_mask                                             (0xFFFFF000)
+#define DC_RO_PROTECT_SADDR3_saddr3(data)                                            (0xFFFFF000&((data)<<12))
+#define DC_RO_PROTECT_SADDR3_saddr3_src(data)                                        ((0xFFFFF000&(data))>>12)
+#define DC_RO_PROTECT_SADDR3_get_saddr3(data)                                        ((0xFFFFF000&(data))>>12)
+
+
+#define DC_RO_PROTECT_EADDR3                                                         0x18008474
+#define DC_RO_PROTECT_EADDR3_reg_addr                                                "0xB8008474"
+#define DC_RO_PROTECT_EADDR3_reg                                                     0xB8008474
+#define set_DC_RO_PROTECT_EADDR3_reg(data)   (*((volatile unsigned int*) DC_RO_PROTECT_EADDR3_reg)=data)
+#define get_DC_RO_PROTECT_EADDR3_reg   (*((volatile unsigned int*) DC_RO_PROTECT_EADDR3_reg))
+#define DC_RO_PROTECT_EADDR3_inst_adr                                                "0x001D"
+#define DC_RO_PROTECT_EADDR3_inst                                                    0x001D
+#define DC_RO_PROTECT_EADDR3_eaddr3_shift                                            (12)
+#define DC_RO_PROTECT_EADDR3_eaddr3_mask                                             (0xFFFFF000)
+#define DC_RO_PROTECT_EADDR3_eaddr3(data)                                            (0xFFFFF000&((data)<<12))
+#define DC_RO_PROTECT_EADDR3_eaddr3_src(data)                                        ((0xFFFFF000&(data))>>12)
+#define DC_RO_PROTECT_EADDR3_get_eaddr3(data)                                        ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_SADDR0                                                       0x18008478
+#define DC_MEM_SCRAMBLE_SADDR0_reg_addr                                              "0xB8008478"
+#define DC_MEM_SCRAMBLE_SADDR0_reg                                                   0xB8008478
+#define set_DC_MEM_SCRAMBLE_SADDR0_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR0_reg)=data)
+#define get_DC_MEM_SCRAMBLE_SADDR0_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR0_reg))
+#define DC_MEM_SCRAMBLE_SADDR0_inst_adr                                              "0x001E"
+#define DC_MEM_SCRAMBLE_SADDR0_inst                                                  0x001E
+#define DC_MEM_SCRAMBLE_SADDR0_saddr0_shift                                          (12)
+#define DC_MEM_SCRAMBLE_SADDR0_saddr0_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_SADDR0_saddr0(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_SADDR0_saddr0_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_SADDR0_get_saddr0(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_EADDR0                                                       0x1800847C
+#define DC_MEM_SCRAMBLE_EADDR0_reg_addr                                              "0xB800847C"
+#define DC_MEM_SCRAMBLE_EADDR0_reg                                                   0xB800847C
+#define set_DC_MEM_SCRAMBLE_EADDR0_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR0_reg)=data)
+#define get_DC_MEM_SCRAMBLE_EADDR0_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR0_reg))
+#define DC_MEM_SCRAMBLE_EADDR0_inst_adr                                              "0x001F"
+#define DC_MEM_SCRAMBLE_EADDR0_inst                                                  0x001F
+#define DC_MEM_SCRAMBLE_EADDR0_eaddr0_shift                                          (12)
+#define DC_MEM_SCRAMBLE_EADDR0_eaddr0_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_EADDR0_eaddr0(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_EADDR0_eaddr0_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_EADDR0_get_eaddr0(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_SADDR1                                                       0x18008480
+#define DC_MEM_SCRAMBLE_SADDR1_reg_addr                                              "0xB8008480"
+#define DC_MEM_SCRAMBLE_SADDR1_reg                                                   0xB8008480
+#define set_DC_MEM_SCRAMBLE_SADDR1_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR1_reg)=data)
+#define get_DC_MEM_SCRAMBLE_SADDR1_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR1_reg))
+#define DC_MEM_SCRAMBLE_SADDR1_inst_adr                                              "0x0020"
+#define DC_MEM_SCRAMBLE_SADDR1_inst                                                  0x0020
+#define DC_MEM_SCRAMBLE_SADDR1_saddr1_shift                                          (12)
+#define DC_MEM_SCRAMBLE_SADDR1_saddr1_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_SADDR1_saddr1(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_SADDR1_saddr1_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_SADDR1_get_saddr1(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_EADDR1                                                       0x18008484
+#define DC_MEM_SCRAMBLE_EADDR1_reg_addr                                              "0xB8008484"
+#define DC_MEM_SCRAMBLE_EADDR1_reg                                                   0xB8008484
+#define set_DC_MEM_SCRAMBLE_EADDR1_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR1_reg)=data)
+#define get_DC_MEM_SCRAMBLE_EADDR1_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR1_reg))
+#define DC_MEM_SCRAMBLE_EADDR1_inst_adr                                              "0x0021"
+#define DC_MEM_SCRAMBLE_EADDR1_inst                                                  0x0021
+#define DC_MEM_SCRAMBLE_EADDR1_eaddr1_shift                                          (12)
+#define DC_MEM_SCRAMBLE_EADDR1_eaddr1_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_EADDR1_eaddr1(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_EADDR1_eaddr1_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_EADDR1_get_eaddr1(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_SADDR2                                                       0x18008488
+#define DC_MEM_SCRAMBLE_SADDR2_reg_addr                                              "0xB8008488"
+#define DC_MEM_SCRAMBLE_SADDR2_reg                                                   0xB8008488
+#define set_DC_MEM_SCRAMBLE_SADDR2_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR2_reg)=data)
+#define get_DC_MEM_SCRAMBLE_SADDR2_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR2_reg))
+#define DC_MEM_SCRAMBLE_SADDR2_inst_adr                                              "0x0022"
+#define DC_MEM_SCRAMBLE_SADDR2_inst                                                  0x0022
+#define DC_MEM_SCRAMBLE_SADDR2_saddr2_shift                                          (12)
+#define DC_MEM_SCRAMBLE_SADDR2_saddr2_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_SADDR2_saddr2(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_SADDR2_saddr2_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_SADDR2_get_saddr2(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_EADDR2                                                       0x1800848C
+#define DC_MEM_SCRAMBLE_EADDR2_reg_addr                                              "0xB800848C"
+#define DC_MEM_SCRAMBLE_EADDR2_reg                                                   0xB800848C
+#define set_DC_MEM_SCRAMBLE_EADDR2_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR2_reg)=data)
+#define get_DC_MEM_SCRAMBLE_EADDR2_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR2_reg))
+#define DC_MEM_SCRAMBLE_EADDR2_inst_adr                                              "0x0023"
+#define DC_MEM_SCRAMBLE_EADDR2_inst                                                  0x0023
+#define DC_MEM_SCRAMBLE_EADDR2_eaddr2_shift                                          (12)
+#define DC_MEM_SCRAMBLE_EADDR2_eaddr2_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_EADDR2_eaddr2(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_EADDR2_eaddr2_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_EADDR2_get_eaddr2(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_SADDR3                                                       0x18008490
+#define DC_MEM_SCRAMBLE_SADDR3_reg_addr                                              "0xB8008490"
+#define DC_MEM_SCRAMBLE_SADDR3_reg                                                   0xB8008490
+#define set_DC_MEM_SCRAMBLE_SADDR3_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR3_reg)=data)
+#define get_DC_MEM_SCRAMBLE_SADDR3_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR3_reg))
+#define DC_MEM_SCRAMBLE_SADDR3_inst_adr                                              "0x0024"
+#define DC_MEM_SCRAMBLE_SADDR3_inst                                                  0x0024
+#define DC_MEM_SCRAMBLE_SADDR3_saddr3_shift                                          (12)
+#define DC_MEM_SCRAMBLE_SADDR3_saddr3_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_SADDR3_saddr3(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_SADDR3_saddr3_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_SADDR3_get_saddr3(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_EADDR3                                                       0x18008494
+#define DC_MEM_SCRAMBLE_EADDR3_reg_addr                                              "0xB8008494"
+#define DC_MEM_SCRAMBLE_EADDR3_reg                                                   0xB8008494
+#define set_DC_MEM_SCRAMBLE_EADDR3_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR3_reg)=data)
+#define get_DC_MEM_SCRAMBLE_EADDR3_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR3_reg))
+#define DC_MEM_SCRAMBLE_EADDR3_inst_adr                                              "0x0025"
+#define DC_MEM_SCRAMBLE_EADDR3_inst                                                  0x0025
+#define DC_MEM_SCRAMBLE_EADDR3_eaddr3_shift                                          (12)
+#define DC_MEM_SCRAMBLE_EADDR3_eaddr3_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_EADDR3_eaddr3(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_EADDR3_eaddr3_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_EADDR3_get_eaddr3(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_SADDR4                                                       0x18008498
+#define DC_MEM_SCRAMBLE_SADDR4_reg_addr                                              "0xB8008498"
+#define DC_MEM_SCRAMBLE_SADDR4_reg                                                   0xB8008498
+#define set_DC_MEM_SCRAMBLE_SADDR4_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR4_reg)=data)
+#define get_DC_MEM_SCRAMBLE_SADDR4_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR4_reg))
+#define DC_MEM_SCRAMBLE_SADDR4_inst_adr                                              "0x0026"
+#define DC_MEM_SCRAMBLE_SADDR4_inst                                                  0x0026
+#define DC_MEM_SCRAMBLE_SADDR4_saddr4_shift                                          (12)
+#define DC_MEM_SCRAMBLE_SADDR4_saddr4_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_SADDR4_saddr4(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_SADDR4_saddr4_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_SADDR4_get_saddr4(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_EADDR4                                                       0x1800849C
+#define DC_MEM_SCRAMBLE_EADDR4_reg_addr                                              "0xB800849C"
+#define DC_MEM_SCRAMBLE_EADDR4_reg                                                   0xB800849C
+#define set_DC_MEM_SCRAMBLE_EADDR4_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR4_reg)=data)
+#define get_DC_MEM_SCRAMBLE_EADDR4_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR4_reg))
+#define DC_MEM_SCRAMBLE_EADDR4_inst_adr                                              "0x0027"
+#define DC_MEM_SCRAMBLE_EADDR4_inst                                                  0x0027
+#define DC_MEM_SCRAMBLE_EADDR4_eaddr4_shift                                          (12)
+#define DC_MEM_SCRAMBLE_EADDR4_eaddr4_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_EADDR4_eaddr4(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_EADDR4_eaddr4_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_EADDR4_get_eaddr4(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_SADDR5                                                       0x180084A0
+#define DC_MEM_SCRAMBLE_SADDR5_reg_addr                                              "0xB80084A0"
+#define DC_MEM_SCRAMBLE_SADDR5_reg                                                   0xB80084A0
+#define set_DC_MEM_SCRAMBLE_SADDR5_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR5_reg)=data)
+#define get_DC_MEM_SCRAMBLE_SADDR5_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR5_reg))
+#define DC_MEM_SCRAMBLE_SADDR5_inst_adr                                              "0x0028"
+#define DC_MEM_SCRAMBLE_SADDR5_inst                                                  0x0028
+#define DC_MEM_SCRAMBLE_SADDR5_saddr5_shift                                          (12)
+#define DC_MEM_SCRAMBLE_SADDR5_saddr5_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_SADDR5_saddr5(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_SADDR5_saddr5_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_SADDR5_get_saddr5(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_EADDR5                                                       0x180084A4
+#define DC_MEM_SCRAMBLE_EADDR5_reg_addr                                              "0xB80084A4"
+#define DC_MEM_SCRAMBLE_EADDR5_reg                                                   0xB80084A4
+#define set_DC_MEM_SCRAMBLE_EADDR5_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR5_reg)=data)
+#define get_DC_MEM_SCRAMBLE_EADDR5_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR5_reg))
+#define DC_MEM_SCRAMBLE_EADDR5_inst_adr                                              "0x0029"
+#define DC_MEM_SCRAMBLE_EADDR5_inst                                                  0x0029
+#define DC_MEM_SCRAMBLE_EADDR5_eaddr5_shift                                          (12)
+#define DC_MEM_SCRAMBLE_EADDR5_eaddr5_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_EADDR5_eaddr5(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_EADDR5_eaddr5_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_EADDR5_get_eaddr5(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_SADDR6                                                       0x180084A8
+#define DC_MEM_SCRAMBLE_SADDR6_reg_addr                                              "0xB80084A8"
+#define DC_MEM_SCRAMBLE_SADDR6_reg                                                   0xB80084A8
+#define set_DC_MEM_SCRAMBLE_SADDR6_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR6_reg)=data)
+#define get_DC_MEM_SCRAMBLE_SADDR6_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR6_reg))
+#define DC_MEM_SCRAMBLE_SADDR6_inst_adr                                              "0x002A"
+#define DC_MEM_SCRAMBLE_SADDR6_inst                                                  0x002A
+#define DC_MEM_SCRAMBLE_SADDR6_saddr6_shift                                          (12)
+#define DC_MEM_SCRAMBLE_SADDR6_saddr6_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_SADDR6_saddr6(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_SADDR6_saddr6_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_SADDR6_get_saddr6(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_EADDR6                                                       0x180084AC
+#define DC_MEM_SCRAMBLE_EADDR6_reg_addr                                              "0xB80084AC"
+#define DC_MEM_SCRAMBLE_EADDR6_reg                                                   0xB80084AC
+#define set_DC_MEM_SCRAMBLE_EADDR6_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR6_reg)=data)
+#define get_DC_MEM_SCRAMBLE_EADDR6_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR6_reg))
+#define DC_MEM_SCRAMBLE_EADDR6_inst_adr                                              "0x002B"
+#define DC_MEM_SCRAMBLE_EADDR6_inst                                                  0x002B
+#define DC_MEM_SCRAMBLE_EADDR6_eaddr6_shift                                          (12)
+#define DC_MEM_SCRAMBLE_EADDR6_eaddr6_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_EADDR6_eaddr6(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_EADDR6_eaddr6_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_EADDR6_get_eaddr6(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_SADDR7                                                       0x180084B0
+#define DC_MEM_SCRAMBLE_SADDR7_reg_addr                                              "0xB80084B0"
+#define DC_MEM_SCRAMBLE_SADDR7_reg                                                   0xB80084B0
+#define set_DC_MEM_SCRAMBLE_SADDR7_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR7_reg)=data)
+#define get_DC_MEM_SCRAMBLE_SADDR7_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_SADDR7_reg))
+#define DC_MEM_SCRAMBLE_SADDR7_inst_adr                                              "0x002C"
+#define DC_MEM_SCRAMBLE_SADDR7_inst                                                  0x002C
+#define DC_MEM_SCRAMBLE_SADDR7_saddr7_shift                                          (12)
+#define DC_MEM_SCRAMBLE_SADDR7_saddr7_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_SADDR7_saddr7(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_SADDR7_saddr7_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_SADDR7_get_saddr7(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_SCRAMBLE_EADDR7                                                       0x180084B4
+#define DC_MEM_SCRAMBLE_EADDR7_reg_addr                                              "0xB80084B4"
+#define DC_MEM_SCRAMBLE_EADDR7_reg                                                   0xB80084B4
+#define set_DC_MEM_SCRAMBLE_EADDR7_reg(data)   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR7_reg)=data)
+#define get_DC_MEM_SCRAMBLE_EADDR7_reg   (*((volatile unsigned int*) DC_MEM_SCRAMBLE_EADDR7_reg))
+#define DC_MEM_SCRAMBLE_EADDR7_inst_adr                                              "0x002D"
+#define DC_MEM_SCRAMBLE_EADDR7_inst                                                  0x002D
+#define DC_MEM_SCRAMBLE_EADDR7_eaddr7_shift                                          (12)
+#define DC_MEM_SCRAMBLE_EADDR7_eaddr7_mask                                           (0xFFFFF000)
+#define DC_MEM_SCRAMBLE_EADDR7_eaddr7(data)                                          (0xFFFFF000&((data)<<12))
+#define DC_MEM_SCRAMBLE_EADDR7_eaddr7_src(data)                                      ((0xFFFFF000&(data))>>12)
+#define DC_MEM_SCRAMBLE_EADDR7_get_eaddr7(data)                                      ((0xFFFFF000&(data))>>12)
+
+
+#define DC_MEM_PROTECT_ID_CTRL_0                                                     0x180084B8
+#define DC_MEM_PROTECT_ID_CTRL_0_reg_addr                                            "0xB80084B8"
+#define DC_MEM_PROTECT_ID_CTRL_0_reg                                                 0xB80084B8
+#define set_DC_MEM_PROTECT_ID_CTRL_0_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_ID_CTRL_0_reg)=data)
+#define get_DC_MEM_PROTECT_ID_CTRL_0_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_ID_CTRL_0_reg))
+#define DC_MEM_PROTECT_ID_CTRL_0_inst_adr                                            "0x002E"
+#define DC_MEM_PROTECT_ID_CTRL_0_inst                                                0x002E
+#define DC_MEM_PROTECT_ID_CTRL_0_md_tee_protect_en_shift                             (24)
+#define DC_MEM_PROTECT_ID_CTRL_0_md_tee_protect_en_mask                              (0xFF000000)
+#define DC_MEM_PROTECT_ID_CTRL_0_md_tee_protect_en(data)                             (0xFF000000&((data)<<24))
+#define DC_MEM_PROTECT_ID_CTRL_0_md_tee_protect_en_src(data)                         ((0xFF000000&(data))>>24)
+#define DC_MEM_PROTECT_ID_CTRL_0_get_md_tee_protect_en(data)                         ((0xFF000000&(data))>>24)
+#define DC_MEM_PROTECT_ID_CTRL_0_cp_tee_protect_en_shift                             (16)
+#define DC_MEM_PROTECT_ID_CTRL_0_cp_tee_protect_en_mask                              (0x00FF0000)
+#define DC_MEM_PROTECT_ID_CTRL_0_cp_tee_protect_en(data)                             (0x00FF0000&((data)<<16))
+#define DC_MEM_PROTECT_ID_CTRL_0_cp_tee_protect_en_src(data)                         ((0x00FF0000&(data))>>16)
+#define DC_MEM_PROTECT_ID_CTRL_0_get_cp_tee_protect_en(data)                         ((0x00FF0000&(data))>>16)
+#define DC_MEM_PROTECT_ID_CTRL_0_vo_protect_en_shift                                 (8)
+#define DC_MEM_PROTECT_ID_CTRL_0_vo_protect_en_mask                                  (0x0000FF00)
+#define DC_MEM_PROTECT_ID_CTRL_0_vo_protect_en(data)                                 (0x0000FF00&((data)<<8))
+#define DC_MEM_PROTECT_ID_CTRL_0_vo_protect_en_src(data)                             ((0x0000FF00&(data))>>8)
+#define DC_MEM_PROTECT_ID_CTRL_0_get_vo_protect_en(data)                             ((0x0000FF00&(data))>>8)
+#define DC_MEM_PROTECT_ID_CTRL_0_nf_tee_protect_en_shift                             (0)
+#define DC_MEM_PROTECT_ID_CTRL_0_nf_tee_protect_en_mask                              (0x000000FF)
+#define DC_MEM_PROTECT_ID_CTRL_0_nf_tee_protect_en(data)                             (0x000000FF&((data)<<0))
+#define DC_MEM_PROTECT_ID_CTRL_0_nf_tee_protect_en_src(data)                         ((0x000000FF&(data))>>0)
+#define DC_MEM_PROTECT_ID_CTRL_0_get_nf_tee_protect_en(data)                         ((0x000000FF&(data))>>0)
+
+
+#define DC_MEM_PROTECT_ID_CTRL_1                                                     0x180084BC
+#define DC_MEM_PROTECT_ID_CTRL_1_reg_addr                                            "0xB80084BC"
+#define DC_MEM_PROTECT_ID_CTRL_1_reg                                                 0xB80084BC
+#define set_DC_MEM_PROTECT_ID_CTRL_1_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_ID_CTRL_1_reg)=data)
+#define get_DC_MEM_PROTECT_ID_CTRL_1_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_ID_CTRL_1_reg))
+#define DC_MEM_PROTECT_ID_CTRL_1_inst_adr                                            "0x002F"
+#define DC_MEM_PROTECT_ID_CTRL_1_inst                                                0x002F
+#define DC_MEM_PROTECT_ID_CTRL_1_scpu_tee_protect_en_shift                           (24)
+#define DC_MEM_PROTECT_ID_CTRL_1_scpu_tee_protect_en_mask                            (0xFF000000)
+#define DC_MEM_PROTECT_ID_CTRL_1_scpu_tee_protect_en(data)                           (0xFF000000&((data)<<24))
+#define DC_MEM_PROTECT_ID_CTRL_1_scpu_tee_protect_en_src(data)                       ((0xFF000000&(data))>>24)
+#define DC_MEM_PROTECT_ID_CTRL_1_get_scpu_tee_protect_en(data)                       ((0xFF000000&(data))>>24)
+#define DC_MEM_PROTECT_ID_CTRL_1_acpu_protect_en_shift                               (16)
+#define DC_MEM_PROTECT_ID_CTRL_1_acpu_protect_en_mask                                (0x00FF0000)
+#define DC_MEM_PROTECT_ID_CTRL_1_acpu_protect_en(data)                               (0x00FF0000&((data)<<16))
+#define DC_MEM_PROTECT_ID_CTRL_1_acpu_protect_en_src(data)                           ((0x00FF0000&(data))>>16)
+#define DC_MEM_PROTECT_ID_CTRL_1_get_acpu_protect_en(data)                           ((0x00FF0000&(data))>>16)
+#define DC_MEM_PROTECT_ID_CTRL_1_video_protect_en_shift                              (8)
+#define DC_MEM_PROTECT_ID_CTRL_1_video_protect_en_mask                               (0x0000FF00)
+#define DC_MEM_PROTECT_ID_CTRL_1_video_protect_en(data)                              (0x0000FF00&((data)<<8))
+#define DC_MEM_PROTECT_ID_CTRL_1_video_protect_en_src(data)                          ((0x0000FF00&(data))>>8)
+#define DC_MEM_PROTECT_ID_CTRL_1_get_video_protect_en(data)                          ((0x0000FF00&(data))>>8)
+#define DC_MEM_PROTECT_ID_CTRL_1_audio_protect_en_shift                              (0)
+#define DC_MEM_PROTECT_ID_CTRL_1_audio_protect_en_mask                               (0x000000FF)
+#define DC_MEM_PROTECT_ID_CTRL_1_audio_protect_en(data)                              (0x000000FF&((data)<<0))
+#define DC_MEM_PROTECT_ID_CTRL_1_audio_protect_en_src(data)                          ((0x000000FF&(data))>>0)
+#define DC_MEM_PROTECT_ID_CTRL_1_get_audio_protect_en(data)                          ((0x000000FF&(data))>>0)
+
+
+#define DC_MEM_PROTECT_ID_CTRL_2                                                     0x180084C0
+#define DC_MEM_PROTECT_ID_CTRL_2_reg_addr                                            "0xB80084C0"
+#define DC_MEM_PROTECT_ID_CTRL_2_reg                                                 0xB80084C0
+#define set_DC_MEM_PROTECT_ID_CTRL_2_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_ID_CTRL_2_reg)=data)
+#define get_DC_MEM_PROTECT_ID_CTRL_2_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_ID_CTRL_2_reg))
+#define DC_MEM_PROTECT_ID_CTRL_2_inst_adr                                            "0x0030"
+#define DC_MEM_PROTECT_ID_CTRL_2_inst                                                0x0030
+#define DC_MEM_PROTECT_ID_CTRL_2_scpu_tee_blk_protect_en_shift                       (14)
+#define DC_MEM_PROTECT_ID_CTRL_2_scpu_tee_blk_protect_en_mask                        (0x0000C000)
+#define DC_MEM_PROTECT_ID_CTRL_2_scpu_tee_blk_protect_en(data)                       (0x0000C000&((data)<<14))
+#define DC_MEM_PROTECT_ID_CTRL_2_scpu_tee_blk_protect_en_src(data)                   ((0x0000C000&(data))>>14)
+#define DC_MEM_PROTECT_ID_CTRL_2_get_scpu_tee_blk_protect_en(data)                   ((0x0000C000&(data))>>14)
+#define DC_MEM_PROTECT_ID_CTRL_2_acpu_blk_protect_en_shift                           (12)
+#define DC_MEM_PROTECT_ID_CTRL_2_acpu_blk_protect_en_mask                            (0x00003000)
+#define DC_MEM_PROTECT_ID_CTRL_2_acpu_blk_protect_en(data)                           (0x00003000&((data)<<12))
+#define DC_MEM_PROTECT_ID_CTRL_2_acpu_blk_protect_en_src(data)                       ((0x00003000&(data))>>12)
+#define DC_MEM_PROTECT_ID_CTRL_2_get_acpu_blk_protect_en(data)                       ((0x00003000&(data))>>12)
+#define DC_MEM_PROTECT_ID_CTRL_2_video_blk_protect_en_shift                          (10)
+#define DC_MEM_PROTECT_ID_CTRL_2_video_blk_protect_en_mask                           (0x00000C00)
+#define DC_MEM_PROTECT_ID_CTRL_2_video_blk_protect_en(data)                          (0x00000C00&((data)<<10))
+#define DC_MEM_PROTECT_ID_CTRL_2_video_blk_protect_en_src(data)                      ((0x00000C00&(data))>>10)
+#define DC_MEM_PROTECT_ID_CTRL_2_get_video_blk_protect_en(data)                      ((0x00000C00&(data))>>10)
+#define DC_MEM_PROTECT_ID_CTRL_2_audio_blk_protect_en_shift                          (8)
+#define DC_MEM_PROTECT_ID_CTRL_2_audio_blk_protect_en_mask                           (0x00000300)
+#define DC_MEM_PROTECT_ID_CTRL_2_audio_blk_protect_en(data)                          (0x00000300&((data)<<8))
+#define DC_MEM_PROTECT_ID_CTRL_2_audio_blk_protect_en_src(data)                      ((0x00000300&(data))>>8)
+#define DC_MEM_PROTECT_ID_CTRL_2_get_audio_blk_protect_en(data)                      ((0x00000300&(data))>>8)
+#define DC_MEM_PROTECT_ID_CTRL_2_md_tee_blk_protect_en_shift                         (6)
+#define DC_MEM_PROTECT_ID_CTRL_2_md_tee_blk_protect_en_mask                          (0x000000C0)
+#define DC_MEM_PROTECT_ID_CTRL_2_md_tee_blk_protect_en(data)                         (0x000000C0&((data)<<6))
+#define DC_MEM_PROTECT_ID_CTRL_2_md_tee_blk_protect_en_src(data)                     ((0x000000C0&(data))>>6)
+#define DC_MEM_PROTECT_ID_CTRL_2_get_md_tee_blk_protect_en(data)                     ((0x000000C0&(data))>>6)
+#define DC_MEM_PROTECT_ID_CTRL_2_cp_tee_blk_protect_en_shift                         (4)
+#define DC_MEM_PROTECT_ID_CTRL_2_cp_tee_blk_protect_en_mask                          (0x00000030)
+#define DC_MEM_PROTECT_ID_CTRL_2_cp_tee_blk_protect_en(data)                         (0x00000030&((data)<<4))
+#define DC_MEM_PROTECT_ID_CTRL_2_cp_tee_blk_protect_en_src(data)                     ((0x00000030&(data))>>4)
+#define DC_MEM_PROTECT_ID_CTRL_2_get_cp_tee_blk_protect_en(data)                     ((0x00000030&(data))>>4)
+#define DC_MEM_PROTECT_ID_CTRL_2_vo_blk_protect_en_shift                             (2)
+#define DC_MEM_PROTECT_ID_CTRL_2_vo_blk_protect_en_mask                              (0x0000000C)
+#define DC_MEM_PROTECT_ID_CTRL_2_vo_blk_protect_en(data)                             (0x0000000C&((data)<<2))
+#define DC_MEM_PROTECT_ID_CTRL_2_vo_blk_protect_en_src(data)                         ((0x0000000C&(data))>>2)
+#define DC_MEM_PROTECT_ID_CTRL_2_get_vo_blk_protect_en(data)                         ((0x0000000C&(data))>>2)
+#define DC_MEM_PROTECT_ID_CTRL_2_nf_tee_blk_protect_en_shift                         (0)
+#define DC_MEM_PROTECT_ID_CTRL_2_nf_tee_blk_protect_en_mask                          (0x00000003)
+#define DC_MEM_PROTECT_ID_CTRL_2_nf_tee_blk_protect_en(data)                         (0x00000003&((data)<<0))
+#define DC_MEM_PROTECT_ID_CTRL_2_nf_tee_blk_protect_en_src(data)                     ((0x00000003&(data))>>0)
+#define DC_MEM_PROTECT_ID_CTRL_2_get_nf_tee_blk_protect_en(data)                     ((0x00000003&(data))>>0)
+
+
+#define DC_MEM_PROTECT_ID_CTRL_3                                                     0x180084C4
+#define DC_MEM_PROTECT_ID_CTRL_3_reg_addr                                            "0xB80084C4"
+#define DC_MEM_PROTECT_ID_CTRL_3_reg                                                 0xB80084C4
+#define set_DC_MEM_PROTECT_ID_CTRL_3_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_ID_CTRL_3_reg)=data)
+#define get_DC_MEM_PROTECT_ID_CTRL_3_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_ID_CTRL_3_reg))
+#define DC_MEM_PROTECT_ID_CTRL_3_inst_adr                                            "0x0031"
+#define DC_MEM_PROTECT_ID_CTRL_3_inst                                                0x0031
+#define DC_MEM_PROTECT_ID_CTRL_3_scpu_tee_ro_protect_en_shift                        (28)
+#define DC_MEM_PROTECT_ID_CTRL_3_scpu_tee_ro_protect_en_mask                         (0xF0000000)
+#define DC_MEM_PROTECT_ID_CTRL_3_scpu_tee_ro_protect_en(data)                        (0xF0000000&((data)<<28))
+#define DC_MEM_PROTECT_ID_CTRL_3_scpu_tee_ro_protect_en_src(data)                    ((0xF0000000&(data))>>28)
+#define DC_MEM_PROTECT_ID_CTRL_3_get_scpu_tee_ro_protect_en(data)                    ((0xF0000000&(data))>>28)
+#define DC_MEM_PROTECT_ID_CTRL_3_acpu_ro_protect_en_shift                            (24)
+#define DC_MEM_PROTECT_ID_CTRL_3_acpu_ro_protect_en_mask                             (0x0F000000)
+#define DC_MEM_PROTECT_ID_CTRL_3_acpu_ro_protect_en(data)                            (0x0F000000&((data)<<24))
+#define DC_MEM_PROTECT_ID_CTRL_3_acpu_ro_protect_en_src(data)                        ((0x0F000000&(data))>>24)
+#define DC_MEM_PROTECT_ID_CTRL_3_get_acpu_ro_protect_en(data)                        ((0x0F000000&(data))>>24)
+#define DC_MEM_PROTECT_ID_CTRL_3_video_ro_protect_en_shift                           (20)
+#define DC_MEM_PROTECT_ID_CTRL_3_video_ro_protect_en_mask                            (0x00F00000)
+#define DC_MEM_PROTECT_ID_CTRL_3_video_ro_protect_en(data)                           (0x00F00000&((data)<<20))
+#define DC_MEM_PROTECT_ID_CTRL_3_video_ro_protect_en_src(data)                       ((0x00F00000&(data))>>20)
+#define DC_MEM_PROTECT_ID_CTRL_3_get_video_ro_protect_en(data)                       ((0x00F00000&(data))>>20)
+#define DC_MEM_PROTECT_ID_CTRL_3_audio_ro_protect_en_shift                           (16)
+#define DC_MEM_PROTECT_ID_CTRL_3_audio_ro_protect_en_mask                            (0x000F0000)
+#define DC_MEM_PROTECT_ID_CTRL_3_audio_ro_protect_en(data)                           (0x000F0000&((data)<<16))
+#define DC_MEM_PROTECT_ID_CTRL_3_audio_ro_protect_en_src(data)                       ((0x000F0000&(data))>>16)
+#define DC_MEM_PROTECT_ID_CTRL_3_get_audio_ro_protect_en(data)                       ((0x000F0000&(data))>>16)
+#define DC_MEM_PROTECT_ID_CTRL_3_md_tee_ro_protect_en_shift                          (12)
+#define DC_MEM_PROTECT_ID_CTRL_3_md_tee_ro_protect_en_mask                           (0x0000F000)
+#define DC_MEM_PROTECT_ID_CTRL_3_md_tee_ro_protect_en(data)                          (0x0000F000&((data)<<12))
+#define DC_MEM_PROTECT_ID_CTRL_3_md_tee_ro_protect_en_src(data)                      ((0x0000F000&(data))>>12)
+#define DC_MEM_PROTECT_ID_CTRL_3_get_md_tee_ro_protect_en(data)                      ((0x0000F000&(data))>>12)
+#define DC_MEM_PROTECT_ID_CTRL_3_cp_tee_ro_protect_en_shift                          (8)
+#define DC_MEM_PROTECT_ID_CTRL_3_cp_tee_ro_protect_en_mask                           (0x00000F00)
+#define DC_MEM_PROTECT_ID_CTRL_3_cp_tee_ro_protect_en(data)                          (0x00000F00&((data)<<8))
+#define DC_MEM_PROTECT_ID_CTRL_3_cp_tee_ro_protect_en_src(data)                      ((0x00000F00&(data))>>8)
+#define DC_MEM_PROTECT_ID_CTRL_3_get_cp_tee_ro_protect_en(data)                      ((0x00000F00&(data))>>8)
+#define DC_MEM_PROTECT_ID_CTRL_3_vo_ro_protect_en_shift                              (4)
+#define DC_MEM_PROTECT_ID_CTRL_3_vo_ro_protect_en_mask                               (0x000000F0)
+#define DC_MEM_PROTECT_ID_CTRL_3_vo_ro_protect_en(data)                              (0x000000F0&((data)<<4))
+#define DC_MEM_PROTECT_ID_CTRL_3_vo_ro_protect_en_src(data)                          ((0x000000F0&(data))>>4)
+#define DC_MEM_PROTECT_ID_CTRL_3_get_vo_ro_protect_en(data)                          ((0x000000F0&(data))>>4)
+#define DC_MEM_PROTECT_ID_CTRL_3_nf_tee_ro_protect_en_shift                          (0)
+#define DC_MEM_PROTECT_ID_CTRL_3_nf_tee_ro_protect_en_mask                           (0x0000000F)
+#define DC_MEM_PROTECT_ID_CTRL_3_nf_tee_ro_protect_en(data)                          (0x0000000F&((data)<<0))
+#define DC_MEM_PROTECT_ID_CTRL_3_nf_tee_ro_protect_en_src(data)                      ((0x0000000F&(data))>>0)
+#define DC_MEM_PROTECT_ID_CTRL_3_get_nf_tee_ro_protect_en(data)                      ((0x0000000F&(data))>>0)
+
+
+#define DC_MEM_PROTECT_PICT_CTRL_0                                                   0x180084C8
+#define DC_MEM_PROTECT_PICT_CTRL_0_reg_addr                                          "0xB80084C8"
+#define DC_MEM_PROTECT_PICT_CTRL_0_reg                                               0xB80084C8
+#define set_DC_MEM_PROTECT_PICT_CTRL_0_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_PICT_CTRL_0_reg)=data)
+#define get_DC_MEM_PROTECT_PICT_CTRL_0_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_PICT_CTRL_0_reg))
+#define DC_MEM_PROTECT_PICT_CTRL_0_inst_adr                                          "0x0032"
+#define DC_MEM_PROTECT_PICT_CTRL_0_inst                                              0x0032
+#define DC_MEM_PROTECT_PICT_CTRL_0_blk_pict_set_chk_en_0_shift                       (0)
+#define DC_MEM_PROTECT_PICT_CTRL_0_blk_pict_set_chk_en_0_mask                        (0xFFFFFFFF)
+#define DC_MEM_PROTECT_PICT_CTRL_0_blk_pict_set_chk_en_0(data)                       (0xFFFFFFFF&((data)<<0))
+#define DC_MEM_PROTECT_PICT_CTRL_0_blk_pict_set_chk_en_0_src(data)                   ((0xFFFFFFFF&(data))>>0)
+#define DC_MEM_PROTECT_PICT_CTRL_0_get_blk_pict_set_chk_en_0(data)                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_MEM_PROTECT_PICT_CTRL_1                                                   0x180084CC
+#define DC_MEM_PROTECT_PICT_CTRL_1_reg_addr                                          "0xB80084CC"
+#define DC_MEM_PROTECT_PICT_CTRL_1_reg                                               0xB80084CC
+#define set_DC_MEM_PROTECT_PICT_CTRL_1_reg(data)   (*((volatile unsigned int*) DC_MEM_PROTECT_PICT_CTRL_1_reg)=data)
+#define get_DC_MEM_PROTECT_PICT_CTRL_1_reg   (*((volatile unsigned int*) DC_MEM_PROTECT_PICT_CTRL_1_reg))
+#define DC_MEM_PROTECT_PICT_CTRL_1_inst_adr                                          "0x0033"
+#define DC_MEM_PROTECT_PICT_CTRL_1_inst                                              0x0033
+#define DC_MEM_PROTECT_PICT_CTRL_1_blk_pict_set_chk_en_1_shift                       (0)
+#define DC_MEM_PROTECT_PICT_CTRL_1_blk_pict_set_chk_en_1_mask                        (0xFFFFFFFF)
+#define DC_MEM_PROTECT_PICT_CTRL_1_blk_pict_set_chk_en_1(data)                       (0xFFFFFFFF&((data)<<0))
+#define DC_MEM_PROTECT_PICT_CTRL_1_blk_pict_set_chk_en_1_src(data)                   ((0xFFFFFFFF&(data))>>0)
+#define DC_MEM_PROTECT_PICT_CTRL_1_get_blk_pict_set_chk_en_1(data)                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define DC_SECURE_MISC                                                               0x18008740
+#define DC_SECURE_MISC_reg_addr                                                      "0xB8008740"
+#define DC_SECURE_MISC_reg                                                           0xB8008740
+#define set_DC_SECURE_MISC_reg(data)   (*((volatile unsigned int*) DC_SECURE_MISC_reg)=data)
+#define get_DC_SECURE_MISC_reg   (*((volatile unsigned int*) DC_SECURE_MISC_reg))
+#define DC_SECURE_MISC_inst_adr                                                      "0x00D0"
+#define DC_SECURE_MISC_inst                                                          0x00D0
+#define DC_SECURE_MISC_dram_16g_used_shift                                           (5)
+#define DC_SECURE_MISC_dram_16g_used_mask                                            (0x00000020)
+#define DC_SECURE_MISC_dram_16g_used(data)                                           (0x00000020&((data)<<5))
+#define DC_SECURE_MISC_dram_16g_used_src(data)                                       ((0x00000020&(data))>>5)
+#define DC_SECURE_MISC_get_dram_16g_used(data)                                       ((0x00000020&(data))>>5)
+#define DC_SECURE_MISC_dram_8g_used_shift                                            (4)
+#define DC_SECURE_MISC_dram_8g_used_mask                                             (0x00000010)
+#define DC_SECURE_MISC_dram_8g_used(data)                                            (0x00000010&((data)<<4))
+#define DC_SECURE_MISC_dram_8g_used_src(data)                                        ((0x00000010&(data))>>4)
+#define DC_SECURE_MISC_get_dram_8g_used(data)                                        ((0x00000010&(data))>>4)
+#define DC_SECURE_MISC_dram_4g_used_shift                                            (3)
+#define DC_SECURE_MISC_dram_4g_used_mask                                             (0x00000008)
+#define DC_SECURE_MISC_dram_4g_used(data)                                            (0x00000008&((data)<<3))
+#define DC_SECURE_MISC_dram_4g_used_src(data)                                        ((0x00000008&(data))>>3)
+#define DC_SECURE_MISC_get_dram_4g_used(data)                                        ((0x00000008&(data))>>3)
+#define DC_SECURE_MISC_dram_2g_used_shift                                            (2)
+#define DC_SECURE_MISC_dram_2g_used_mask                                             (0x00000004)
+#define DC_SECURE_MISC_dram_2g_used(data)                                            (0x00000004&((data)<<2))
+#define DC_SECURE_MISC_dram_2g_used_src(data)                                        ((0x00000004&(data))>>2)
+#define DC_SECURE_MISC_get_dram_2g_used(data)                                        ((0x00000004&(data))>>2)
+#define DC_SECURE_MISC_dram_1g_used_shift                                            (1)
+#define DC_SECURE_MISC_dram_1g_used_mask                                             (0x00000002)
+#define DC_SECURE_MISC_dram_1g_used(data)                                            (0x00000002&((data)<<1))
+#define DC_SECURE_MISC_dram_1g_used_src(data)                                        ((0x00000002&(data))>>1)
+#define DC_SECURE_MISC_get_dram_1g_used(data)                                        ((0x00000002&(data))>>1)
+#define DC_SECURE_MISC_dram_512_used_shift                                           (0)
+#define DC_SECURE_MISC_dram_512_used_mask                                            (0x00000001)
+#define DC_SECURE_MISC_dram_512_used(data)                                           (0x00000001&((data)<<0))
+#define DC_SECURE_MISC_dram_512_used_src(data)                                       ((0x00000001&(data))>>0)
+#define DC_SECURE_MISC_get_dram_512_used(data)                                       ((0x00000001&(data))>>0)
+
+
+#define DC_MEM_INT                                                                   0x18008750
+#define DC_MEM_INT_reg_addr                                                          "0xB8008750"
+#define DC_MEM_INT_reg                                                               0xB8008750
+#define set_DC_MEM_INT_reg(data)   (*((volatile unsigned int*) DC_MEM_INT_reg)=data)
+#define get_DC_MEM_INT_reg   (*((volatile unsigned int*) DC_MEM_INT_reg))
+#define DC_MEM_INT_inst_adr                                                          "0x00D4"
+#define DC_MEM_INT_inst                                                              0x00D4
+#define DC_MEM_INT_write_enable9_shift                                               (31)
+#define DC_MEM_INT_write_enable9_mask                                                (0x80000000)
+#define DC_MEM_INT_write_enable9(data)                                               (0x80000000&((data)<<31))
+#define DC_MEM_INT_write_enable9_src(data)                                           ((0x80000000&(data))>>31)
+#define DC_MEM_INT_get_write_enable9(data)                                           ((0x80000000&(data))>>31)
+#define DC_MEM_INT_int_kcpu_key_up_en_shift                                          (30)
+#define DC_MEM_INT_int_kcpu_key_up_en_mask                                           (0x40000000)
+#define DC_MEM_INT_int_kcpu_key_up_en(data)                                          (0x40000000&((data)<<30))
+#define DC_MEM_INT_int_kcpu_key_up_en_src(data)                                      ((0x40000000&(data))>>30)
+#define DC_MEM_INT_get_int_kcpu_key_up_en(data)                                      ((0x40000000&(data))>>30)
+#define DC_MEM_INT_write_enable8_shift                                               (29)
+#define DC_MEM_INT_write_enable8_mask                                                (0x20000000)
+#define DC_MEM_INT_write_enable8(data)                                               (0x20000000&((data)<<29))
+#define DC_MEM_INT_write_enable8_src(data)                                           ((0x20000000&(data))>>29)
+#define DC_MEM_INT_get_write_enable8(data)                                           ((0x20000000&(data))>>29)
+#define DC_MEM_INT_int_kcpu_key_up_shift                                             (28)
+#define DC_MEM_INT_int_kcpu_key_up_mask                                              (0x10000000)
+#define DC_MEM_INT_int_kcpu_key_up(data)                                             (0x10000000&((data)<<28))
+#define DC_MEM_INT_int_kcpu_key_up_src(data)                                         ((0x10000000&(data))>>28)
+#define DC_MEM_INT_get_int_kcpu_key_up(data)                                         ((0x10000000&(data))>>28)
+#define DC_MEM_INT_write_enable7_shift                                               (27)
+#define DC_MEM_INT_write_enable7_mask                                                (0x08000000)
+#define DC_MEM_INT_write_enable7(data)                                               (0x08000000&((data)<<27))
+#define DC_MEM_INT_write_enable7_src(data)                                           ((0x08000000&(data))>>27)
+#define DC_MEM_INT_get_write_enable7(data)                                           ((0x08000000&(data))>>27)
+#define DC_MEM_INT_key_up_status_shift                                               (24)
+#define DC_MEM_INT_key_up_status_mask                                                (0x07000000)
+#define DC_MEM_INT_key_up_status(data)                                               (0x07000000&((data)<<24))
+#define DC_MEM_INT_key_up_status_src(data)                                           ((0x07000000&(data))>>24)
+#define DC_MEM_INT_get_key_up_status(data)                                           ((0x07000000&(data))>>24)
+#define DC_MEM_INT_write_enable6_shift                                               (23)
+#define DC_MEM_INT_write_enable6_mask                                                (0x00800000)
+#define DC_MEM_INT_write_enable6(data)                                               (0x00800000&((data)<<23))
+#define DC_MEM_INT_write_enable6_src(data)                                           ((0x00800000&(data))>>23)
+#define DC_MEM_INT_get_write_enable6(data)                                           ((0x00800000&(data))>>23)
+#define DC_MEM_INT_scramble_int_en_shift                                             (22)
+#define DC_MEM_INT_scramble_int_en_mask                                              (0x00400000)
+#define DC_MEM_INT_scramble_int_en(data)                                             (0x00400000&((data)<<22))
+#define DC_MEM_INT_scramble_int_en_src(data)                                         ((0x00400000&(data))>>22)
+#define DC_MEM_INT_get_scramble_int_en(data)                                         ((0x00400000&(data))>>22)
+#define DC_MEM_INT_write_enable5_shift                                               (21)
+#define DC_MEM_INT_write_enable5_mask                                                (0x00200000)
+#define DC_MEM_INT_write_enable5(data)                                               (0x00200000&((data)<<21))
+#define DC_MEM_INT_write_enable5_src(data)                                           ((0x00200000&(data))>>21)
+#define DC_MEM_INT_get_write_enable5(data)                                           ((0x00200000&(data))>>21)
+#define DC_MEM_INT_scramble_int_shift                                                (20)
+#define DC_MEM_INT_scramble_int_mask                                                 (0x00100000)
+#define DC_MEM_INT_scramble_int(data)                                                (0x00100000&((data)<<20))
+#define DC_MEM_INT_scramble_int_src(data)                                            ((0x00100000&(data))>>20)
+#define DC_MEM_INT_get_scramble_int(data)                                            ((0x00100000&(data))>>20)
+#define DC_MEM_INT_write_enable4_shift                                               (19)
+#define DC_MEM_INT_write_enable4_mask                                                (0x00080000)
+#define DC_MEM_INT_write_enable4(data)                                               (0x00080000&((data)<<19))
+#define DC_MEM_INT_write_enable4_src(data)                                           ((0x00080000&(data))>>19)
+#define DC_MEM_INT_get_write_enable4(data)                                           ((0x00080000&(data))>>19)
+#define DC_MEM_INT_scramble_id_shift                                                 (12)
+#define DC_MEM_INT_scramble_id_mask                                                  (0x0007F000)
+#define DC_MEM_INT_scramble_id(data)                                                 (0x0007F000&((data)<<12))
+#define DC_MEM_INT_scramble_id_src(data)                                             ((0x0007F000&(data))>>12)
+#define DC_MEM_INT_get_scramble_id(data)                                             ((0x0007F000&(data))>>12)
+#define DC_MEM_INT_write_enable3_shift                                               (11)
+#define DC_MEM_INT_write_enable3_mask                                                (0x00000800)
+#define DC_MEM_INT_write_enable3(data)                                               (0x00000800&((data)<<11))
+#define DC_MEM_INT_write_enable3_src(data)                                           ((0x00000800&(data))>>11)
+#define DC_MEM_INT_get_write_enable3(data)                                           ((0x00000800&(data))>>11)
+#define DC_MEM_INT_protect_int_en_shift                                              (10)
+#define DC_MEM_INT_protect_int_en_mask                                               (0x00000400)
+#define DC_MEM_INT_protect_int_en(data)                                              (0x00000400&((data)<<10))
+#define DC_MEM_INT_protect_int_en_src(data)                                          ((0x00000400&(data))>>10)
+#define DC_MEM_INT_get_protect_int_en(data)                                          ((0x00000400&(data))>>10)
+#define DC_MEM_INT_write_enable2_shift                                               (9)
+#define DC_MEM_INT_write_enable2_mask                                                (0x00000200)
+#define DC_MEM_INT_write_enable2(data)                                               (0x00000200&((data)<<9))
+#define DC_MEM_INT_write_enable2_src(data)                                           ((0x00000200&(data))>>9)
+#define DC_MEM_INT_get_write_enable2(data)                                           ((0x00000200&(data))>>9)
+#define DC_MEM_INT_protect_int_shift                                                 (8)
+#define DC_MEM_INT_protect_int_mask                                                  (0x00000100)
+#define DC_MEM_INT_protect_int(data)                                                 (0x00000100&((data)<<8))
+#define DC_MEM_INT_protect_int_src(data)                                             ((0x00000100&(data))>>8)
+#define DC_MEM_INT_get_protect_int(data)                                             ((0x00000100&(data))>>8)
+#define DC_MEM_INT_write_enable1_shift                                               (7)
+#define DC_MEM_INT_write_enable1_mask                                                (0x00000080)
+#define DC_MEM_INT_write_enable1(data)                                               (0x00000080&((data)<<7))
+#define DC_MEM_INT_write_enable1_src(data)                                           ((0x00000080&(data))>>7)
+#define DC_MEM_INT_get_write_enable1(data)                                           ((0x00000080&(data))>>7)
+#define DC_MEM_INT_protect_id_shift                                                  (0)
+#define DC_MEM_INT_protect_id_mask                                                   (0x0000007F)
+#define DC_MEM_INT_protect_id(data)                                                  (0x0000007F&((data)<<0))
+#define DC_MEM_INT_protect_id_src(data)                                              ((0x0000007F&(data))>>0)
+#define DC_MEM_INT_get_protect_id(data)                                              ((0x0000007F&(data))>>0)
+
+
+#define DC_MEM_OTHER_INT                                                             0x18008754
+#define DC_MEM_OTHER_INT_reg_addr                                                    "0xB8008754"
+#define DC_MEM_OTHER_INT_reg                                                         0xB8008754
+#define set_DC_MEM_OTHER_INT_reg(data)   (*((volatile unsigned int*) DC_MEM_OTHER_INT_reg)=data)
+#define get_DC_MEM_OTHER_INT_reg   (*((volatile unsigned int*) DC_MEM_OTHER_INT_reg))
+#define DC_MEM_OTHER_INT_inst_adr                                                    "0x00D5"
+#define DC_MEM_OTHER_INT_inst                                                        0x00D5
+#define DC_MEM_OTHER_INT_write_enable10_shift                                        (31)
+#define DC_MEM_OTHER_INT_write_enable10_mask                                         (0x80000000)
+#define DC_MEM_OTHER_INT_write_enable10(data)                                        (0x80000000&((data)<<31))
+#define DC_MEM_OTHER_INT_write_enable10_src(data)                                    ((0x80000000&(data))>>31)
+#define DC_MEM_OTHER_INT_get_write_enable10(data)                                    ((0x80000000&(data))>>31)
+#define DC_MEM_OTHER_INT_x_overflow_int_en_shift                                     (30)
+#define DC_MEM_OTHER_INT_x_overflow_int_en_mask                                      (0x40000000)
+#define DC_MEM_OTHER_INT_x_overflow_int_en(data)                                     (0x40000000&((data)<<30))
+#define DC_MEM_OTHER_INT_x_overflow_int_en_src(data)                                 ((0x40000000&(data))>>30)
+#define DC_MEM_OTHER_INT_get_x_overflow_int_en(data)                                 ((0x40000000&(data))>>30)
+#define DC_MEM_OTHER_INT_write_enable9_shift                                         (29)
+#define DC_MEM_OTHER_INT_write_enable9_mask                                          (0x20000000)
+#define DC_MEM_OTHER_INT_write_enable9(data)                                         (0x20000000&((data)<<29))
+#define DC_MEM_OTHER_INT_write_enable9_src(data)                                     ((0x20000000&(data))>>29)
+#define DC_MEM_OTHER_INT_get_write_enable9(data)                                     ((0x20000000&(data))>>29)
+#define DC_MEM_OTHER_INT_x_overflow_int_shift                                        (28)
+#define DC_MEM_OTHER_INT_x_overflow_int_mask                                         (0x10000000)
+#define DC_MEM_OTHER_INT_x_overflow_int(data)                                        (0x10000000&((data)<<28))
+#define DC_MEM_OTHER_INT_x_overflow_int_src(data)                                    ((0x10000000&(data))>>28)
+#define DC_MEM_OTHER_INT_get_x_overflow_int(data)                                    ((0x10000000&(data))>>28)
+#define DC_MEM_OTHER_INT_write_enable8_shift                                         (27)
+#define DC_MEM_OTHER_INT_write_enable8_mask                                          (0x08000000)
+#define DC_MEM_OTHER_INT_write_enable8(data)                                         (0x08000000&((data)<<27))
+#define DC_MEM_OTHER_INT_write_enable8_src(data)                                     ((0x08000000&(data))>>27)
+#define DC_MEM_OTHER_INT_get_write_enable8(data)                                     ((0x08000000&(data))>>27)
+#define DC_MEM_OTHER_INT_y_overflow_int_en_shift                                     (26)
+#define DC_MEM_OTHER_INT_y_overflow_int_en_mask                                      (0x04000000)
+#define DC_MEM_OTHER_INT_y_overflow_int_en(data)                                     (0x04000000&((data)<<26))
+#define DC_MEM_OTHER_INT_y_overflow_int_en_src(data)                                 ((0x04000000&(data))>>26)
+#define DC_MEM_OTHER_INT_get_y_overflow_int_en(data)                                 ((0x04000000&(data))>>26)
+#define DC_MEM_OTHER_INT_write_enable7_shift                                         (25)
+#define DC_MEM_OTHER_INT_write_enable7_mask                                          (0x02000000)
+#define DC_MEM_OTHER_INT_write_enable7(data)                                         (0x02000000&((data)<<25))
+#define DC_MEM_OTHER_INT_write_enable7_src(data)                                     ((0x02000000&(data))>>25)
+#define DC_MEM_OTHER_INT_get_write_enable7(data)                                     ((0x02000000&(data))>>25)
+#define DC_MEM_OTHER_INT_y_overflow_int_shift                                        (24)
+#define DC_MEM_OTHER_INT_y_overflow_int_mask                                         (0x01000000)
+#define DC_MEM_OTHER_INT_y_overflow_int(data)                                        (0x01000000&((data)<<24))
+#define DC_MEM_OTHER_INT_y_overflow_int_src(data)                                    ((0x01000000&(data))>>24)
+#define DC_MEM_OTHER_INT_get_y_overflow_int(data)                                    ((0x01000000&(data))>>24)
+#define DC_MEM_OTHER_INT_write_enable6_shift                                         (23)
+#define DC_MEM_OTHER_INT_write_enable6_mask                                          (0x00800000)
+#define DC_MEM_OTHER_INT_write_enable6(data)                                         (0x00800000&((data)<<23))
+#define DC_MEM_OTHER_INT_write_enable6_src(data)                                     ((0x00800000&(data))>>23)
+#define DC_MEM_OTHER_INT_get_write_enable6(data)                                     ((0x00800000&(data))>>23)
+#define DC_MEM_OTHER_INT_scramble_align_int_en_shift                                 (22)
+#define DC_MEM_OTHER_INT_scramble_align_int_en_mask                                  (0x00400000)
+#define DC_MEM_OTHER_INT_scramble_align_int_en(data)                                 (0x00400000&((data)<<22))
+#define DC_MEM_OTHER_INT_scramble_align_int_en_src(data)                             ((0x00400000&(data))>>22)
+#define DC_MEM_OTHER_INT_get_scramble_align_int_en(data)                             ((0x00400000&(data))>>22)
+#define DC_MEM_OTHER_INT_write_enable5_shift                                         (21)
+#define DC_MEM_OTHER_INT_write_enable5_mask                                          (0x00200000)
+#define DC_MEM_OTHER_INT_write_enable5(data)                                         (0x00200000&((data)<<21))
+#define DC_MEM_OTHER_INT_write_enable5_src(data)                                     ((0x00200000&(data))>>21)
+#define DC_MEM_OTHER_INT_get_write_enable5(data)                                     ((0x00200000&(data))>>21)
+#define DC_MEM_OTHER_INT_scramble_align_int_shift                                    (20)
+#define DC_MEM_OTHER_INT_scramble_align_int_mask                                     (0x00100000)
+#define DC_MEM_OTHER_INT_scramble_align_int(data)                                    (0x00100000&((data)<<20))
+#define DC_MEM_OTHER_INT_scramble_align_int_src(data)                                ((0x00100000&(data))>>20)
+#define DC_MEM_OTHER_INT_get_scramble_align_int(data)                                ((0x00100000&(data))>>20)
+#define DC_MEM_OTHER_INT_write_enable4_shift                                         (19)
+#define DC_MEM_OTHER_INT_write_enable4_mask                                          (0x00080000)
+#define DC_MEM_OTHER_INT_write_enable4(data)                                         (0x00080000&((data)<<19))
+#define DC_MEM_OTHER_INT_write_enable4_src(data)                                     ((0x00080000&(data))>>19)
+#define DC_MEM_OTHER_INT_get_write_enable4(data)                                     ((0x00080000&(data))>>19)
+#define DC_MEM_OTHER_INT_blk_picset_int_en_shift                                     (18)
+#define DC_MEM_OTHER_INT_blk_picset_int_en_mask                                      (0x00040000)
+#define DC_MEM_OTHER_INT_blk_picset_int_en(data)                                     (0x00040000&((data)<<18))
+#define DC_MEM_OTHER_INT_blk_picset_int_en_src(data)                                 ((0x00040000&(data))>>18)
+#define DC_MEM_OTHER_INT_get_blk_picset_int_en(data)                                 ((0x00040000&(data))>>18)
+#define DC_MEM_OTHER_INT_write_enable3_shift                                         (17)
+#define DC_MEM_OTHER_INT_write_enable3_mask                                          (0x00020000)
+#define DC_MEM_OTHER_INT_write_enable3(data)                                         (0x00020000&((data)<<17))
+#define DC_MEM_OTHER_INT_write_enable3_src(data)                                     ((0x00020000&(data))>>17)
+#define DC_MEM_OTHER_INT_get_write_enable3(data)                                     ((0x00020000&(data))>>17)
+#define DC_MEM_OTHER_INT_blk_picset_int_shift                                        (16)
+#define DC_MEM_OTHER_INT_blk_picset_int_mask                                         (0x00010000)
+#define DC_MEM_OTHER_INT_blk_picset_int(data)                                        (0x00010000&((data)<<16))
+#define DC_MEM_OTHER_INT_blk_picset_int_src(data)                                    ((0x00010000&(data))>>16)
+#define DC_MEM_OTHER_INT_get_blk_picset_int(data)                                    ((0x00010000&(data))>>16)
+#define DC_MEM_OTHER_INT_write_enable2_shift                                         (12)
+#define DC_MEM_OTHER_INT_write_enable2_mask                                          (0x00001000)
+#define DC_MEM_OTHER_INT_write_enable2(data)                                         (0x00001000&((data)<<12))
+#define DC_MEM_OTHER_INT_write_enable2_src(data)                                     ((0x00001000&(data))>>12)
+#define DC_MEM_OTHER_INT_get_write_enable2(data)                                     ((0x00001000&(data))>>12)
+#define DC_MEM_OTHER_INT_region_shift                                                (9)
+#define DC_MEM_OTHER_INT_region_mask                                                 (0x00000E00)
+#define DC_MEM_OTHER_INT_region(data)                                                (0x00000E00&((data)<<9))
+#define DC_MEM_OTHER_INT_region_src(data)                                            ((0x00000E00&(data))>>9)
+#define DC_MEM_OTHER_INT_get_region(data)                                            ((0x00000E00&(data))>>9)
+#define DC_MEM_OTHER_INT_write_enable1_shift                                         (8)
+#define DC_MEM_OTHER_INT_write_enable1_mask                                          (0x00000100)
+#define DC_MEM_OTHER_INT_write_enable1(data)                                         (0x00000100&((data)<<8))
+#define DC_MEM_OTHER_INT_write_enable1_src(data)                                     ((0x00000100&(data))>>8)
+#define DC_MEM_OTHER_INT_get_write_enable1(data)                                     ((0x00000100&(data))>>8)
+#define DC_MEM_OTHER_INT_pict_set_num_shift                                          (0)
+#define DC_MEM_OTHER_INT_pict_set_num_mask                                           (0x000000FF)
+#define DC_MEM_OTHER_INT_pict_set_num(data)                                          (0x000000FF&((data)<<0))
+#define DC_MEM_OTHER_INT_pict_set_num_src(data)                                      ((0x000000FF&(data))>>0)
+#define DC_MEM_OTHER_INT_get_pict_set_num(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define DC_INT_SEL                                                                   0x18008758
+#define DC_INT_SEL_reg_addr                                                          "0xB8008758"
+#define DC_INT_SEL_reg                                                               0xB8008758
+#define set_DC_INT_SEL_reg(data)   (*((volatile unsigned int*) DC_INT_SEL_reg)=data)
+#define get_DC_INT_SEL_reg   (*((volatile unsigned int*) DC_INT_SEL_reg))
+#define DC_INT_SEL_inst_adr                                                          "0x00D6"
+#define DC_INT_SEL_inst                                                              0x00D6
+#define DC_INT_SEL_blk_overflow_k_en_shift                                           (7)
+#define DC_INT_SEL_blk_overflow_k_en_mask                                            (0x00000080)
+#define DC_INT_SEL_blk_overflow_k_en(data)                                           (0x00000080&((data)<<7))
+#define DC_INT_SEL_blk_overflow_k_en_src(data)                                       ((0x00000080&(data))>>7)
+#define DC_INT_SEL_get_blk_overflow_k_en(data)                                       ((0x00000080&(data))>>7)
+#define DC_INT_SEL_blk_overflow_s_en_shift                                           (6)
+#define DC_INT_SEL_blk_overflow_s_en_mask                                            (0x00000040)
+#define DC_INT_SEL_blk_overflow_s_en(data)                                           (0x00000040&((data)<<6))
+#define DC_INT_SEL_blk_overflow_s_en_src(data)                                       ((0x00000040&(data))>>6)
+#define DC_INT_SEL_get_blk_overflow_s_en(data)                                       ((0x00000040&(data))>>6)
+#define DC_INT_SEL_blk_protect_k_en_shift                                            (5)
+#define DC_INT_SEL_blk_protect_k_en_mask                                             (0x00000020)
+#define DC_INT_SEL_blk_protect_k_en(data)                                            (0x00000020&((data)<<5))
+#define DC_INT_SEL_blk_protect_k_en_src(data)                                        ((0x00000020&(data))>>5)
+#define DC_INT_SEL_get_blk_protect_k_en(data)                                        ((0x00000020&(data))>>5)
+#define DC_INT_SEL_blk_protect_s_en_shift                                            (4)
+#define DC_INT_SEL_blk_protect_s_en_mask                                             (0x00000010)
+#define DC_INT_SEL_blk_protect_s_en(data)                                            (0x00000010&((data)<<4))
+#define DC_INT_SEL_blk_protect_s_en_src(data)                                        ((0x00000010&(data))>>4)
+#define DC_INT_SEL_get_blk_protect_s_en(data)                                        ((0x00000010&(data))>>4)
+#define DC_INT_SEL_error_k_en_shift                                                  (3)
+#define DC_INT_SEL_error_k_en_mask                                                   (0x00000008)
+#define DC_INT_SEL_error_k_en(data)                                                  (0x00000008&((data)<<3))
+#define DC_INT_SEL_error_k_en_src(data)                                              ((0x00000008&(data))>>3)
+#define DC_INT_SEL_get_error_k_en(data)                                              ((0x00000008&(data))>>3)
+#define DC_INT_SEL_error_s_en_shift                                                  (2)
+#define DC_INT_SEL_error_s_en_mask                                                   (0x00000004)
+#define DC_INT_SEL_error_s_en(data)                                                  (0x00000004&((data)<<2))
+#define DC_INT_SEL_error_s_en_src(data)                                              ((0x00000004&(data))>>2)
+#define DC_INT_SEL_get_error_s_en(data)                                              ((0x00000004&(data))>>2)
+#define DC_INT_SEL_mem_trash_k_en_shift                                              (1)
+#define DC_INT_SEL_mem_trash_k_en_mask                                               (0x00000002)
+#define DC_INT_SEL_mem_trash_k_en(data)                                              (0x00000002&((data)<<1))
+#define DC_INT_SEL_mem_trash_k_en_src(data)                                          ((0x00000002&(data))>>1)
+#define DC_INT_SEL_get_mem_trash_k_en(data)                                          ((0x00000002&(data))>>1)
+#define DC_INT_SEL_mem_trash_s_en_shift                                              (0)
+#define DC_INT_SEL_mem_trash_s_en_mask                                               (0x00000001)
+#define DC_INT_SEL_mem_trash_s_en(data)                                              (0x00000001&((data)<<0))
+#define DC_INT_SEL_mem_trash_s_en_src(data)                                          ((0x00000001&(data))>>0)
+#define DC_INT_SEL_get_mem_trash_s_en(data)                                          ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/deblk_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/deblk_reg.h
new file mode 100644
index 00000000..7ceb49a
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/deblk_reg.h
@@ -0,0 +1,1408 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/6/22 11:40:33
+***************************************************************/
+
+
+#ifndef _DEBLK_REG_H_INCLUDED_
+#define _DEBLK_REG_H_INCLUDED_
+#ifdef  _DEBLK_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     PicType:3;
+unsigned int     First_mb:1;
+unsigned int     Cur_mb_x:7;
+unsigned int     reserved_1:1;
+unsigned int     Cur_mb_y:7;
+}DEBLK_CCPAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     IntraMB_flag:1;
+unsigned int     Intra_flag:5;
+unsigned int     SubMB_partition:12;
+unsigned int     mvtype:2;
+unsigned int     FIELDTX:1;
+unsigned int     OVERFLAG:1;
+}DEBLK_VC1CCPAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     ParCom_StartA:13;
+}DEBLK_PARSA;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:5;
+unsigned int     write_enable1:1;
+unsigned int     New_slice_row:1;
+unsigned int     New_slice_mb_x:7;
+unsigned int     write_enable0:1;
+unsigned int     Sw_neighbor_enable:1;
+unsigned int     MbAddrA_available:1;
+unsigned int     MbAddrB_available:1;
+unsigned int     reserved_3:1;
+unsigned int     MbAddrD_available:1;
+}DEBLK_NEIGHBOR;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     avs_alpha_c_offset:5;
+unsigned int     avs_beta_offset:5;
+unsigned int     slice_alpha_c0_offset_div2:4;
+unsigned int     slice_beta_offset_div2:4;
+unsigned int     disable_deblocking_filter_idc:2;
+}DEBLK_DEBCNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     lambda_mode:1;
+unsigned int     thr_3:4;
+unsigned int     thr_2:4;
+unsigned int     thr_1:4;
+}DEBLK_DEBCNTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Intra_flag:1;
+unsigned int     transform_size_8x8_flag:1;
+unsigned int     QPy:6;
+unsigned int     QPcb:6;
+unsigned int     QPcr:6;
+unsigned int     MB_field_decoding_flag:1;
+unsigned int     Mb_partition:9;
+}DEBLK_H264DBPAR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     BS1_valid_ext:4;
+unsigned int     Subblkpat:24;
+}DEBLK_H264DBPAR1;
+
+typedef struct 
+{
+unsigned int     BS1_valid:32;
+}DEBLK_H264DBPAR2;
+
+typedef struct 
+{
+unsigned int     Lu_Mv_equal:32;
+}DEBLK_VC1DBPAR0;
+
+typedef struct 
+{
+unsigned int     Subblkpat:24;
+unsigned int     ch_mv_equal:8;
+}DEBLK_VC1DBPAR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_enable3:1;
+unsigned int     RefQP:5;
+unsigned int     Beta2Sel:1;
+unsigned int     write_enable2:1;
+unsigned int     is_key_frame:1;
+unsigned int     chroma_only:1;
+unsigned int     write_enable1:1;
+unsigned int     Sel_s_chroma_deblock:1;
+unsigned int     write_enable0:1;
+unsigned int     STR9_initQP:5;
+unsigned int     STR8_initQP:5;
+unsigned int     STR7_initQP:5;
+}DEBLK_RVCTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     STR6_initQP:5;
+unsigned int     STR5_initQP:5;
+unsigned int     STR4_initQP:5;
+unsigned int     STR3_initQP:5;
+unsigned int     STR2_initQP:5;
+unsigned int     STR1_initQP:5;
+}DEBLK_RV8CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     mvd:16;
+unsigned int     QP:5;
+}DEBLK_RVDBPAR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     up_mvd_mod:4;
+unsigned int     left_mvd_mod:4;
+unsigned int     Ul_str_eq2:1;
+unsigned int     Up_str_eq2:1;
+unsigned int     Left_str_eq2:1;
+unsigned int     Cur_str_eq2:1;
+unsigned int     up_ul_refdiff:1;
+unsigned int     left_ul_refdiff:1;
+unsigned int     cur_l_refdiff:1;
+unsigned int     cur_up_refdiff:1;
+unsigned int     up_cur_refdiff:1;
+}DEBLK_RVDBPAR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     Subblk2Clip_ch:1;
+unsigned int     Subblk12Clip_lu:1;
+}DEBLK_RV9CLIP;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     is_skip:1;
+unsigned int     Qpch:5;
+unsigned int     Qpy:5;
+}DEBLK_WMV8DBPAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     BaseA0:7;
+unsigned int     BaseA1:7;
+}DEBLK_VMADRBA;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     OffsetA0:7;
+unsigned int     OffsetA1:7;
+unsigned int     OffsetA2:7;
+}DEBLK_VMADROA;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     Sb_load_disable:3;
+}DEBLK_DEBSBCTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     bot_sb_st_disable:1;
+unsigned int     post_write_disable:1;
+unsigned int     dma_idle:1;
+unsigned int     go:1;
+unsigned int     klm_addr_update:1;
+unsigned int     km_addr_update:1;
+}DEBLK_DMACTRL;
+
+typedef struct 
+{
+unsigned int     lu_addr_idx:7;
+unsigned int     klm_lu_x_sel:1;
+unsigned int     klm_lu_top_row_inc:6;
+unsigned int     klm_lu_inc:6;
+unsigned int     km_lu_mb_offset:6;
+unsigned int     km_lu_row_offset:6;
+}DEBLK_DMALU;
+
+typedef struct 
+{
+unsigned int     ch_addr_idx:7;
+unsigned int     klm_ch_x_sel:1;
+unsigned int     klm_ch_top_row_inc:6;
+unsigned int     klm_ch_inc:6;
+unsigned int     km_ch_mb_offset:6;
+unsigned int     km_ch_row_offset:6;
+}DEBLK_DMACH;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     klm_ch_h:5;
+unsigned int     klm_ch_w:1;
+unsigned int     klm_lu_h:6;
+unsigned int     klm_lu_w:1;
+unsigned int     km_ch_h:4;
+unsigned int     km_ch_w:1;
+unsigned int     km_lu_h:5;
+unsigned int     km_lu_w:1;
+}DEBLK_DMAWH;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     x:13;
+unsigned int     y:14;
+}DEBLK_DMAADR;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     write_enable3:1;
+unsigned int     last_filter_type:1;
+unsigned int     last_sharp_level:3;
+unsigned int     last_frame_type:1;
+unsigned int     write_enable2:1;
+unsigned int     filter_type:1;
+unsigned int     sharp_level:3;
+unsigned int     write_enable1:1;
+unsigned int     lf_delta_enable:1;
+unsigned int     write_enable0:1;
+unsigned int     segment_enable:1;
+}DEBLK_VP8CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     base_filt_lvl_3:7;
+unsigned int     reserved_1:1;
+unsigned int     base_filt_lvl_2:7;
+unsigned int     reserved_2:1;
+unsigned int     base_filt_lvl_1:7;
+unsigned int     reserved_3:1;
+unsigned int     base_filt_lvl_0:7;
+}DEBLK_VP8FILTLVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     ref_lf_deltas_3:7;
+unsigned int     reserved_1:1;
+unsigned int     ref_lf_deltas_2:7;
+unsigned int     reserved_2:1;
+unsigned int     ref_lf_deltas_1:7;
+unsigned int     reserved_3:1;
+unsigned int     ref_lf_deltas_0:7;
+}DEBLK_VP8REFDELTA;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     mode_lf_deltas_3:7;
+unsigned int     reserved_1:1;
+unsigned int     mode_lf_deltas_2:7;
+unsigned int     reserved_2:1;
+unsigned int     mode_lf_deltas_1:7;
+unsigned int     reserved_3:1;
+unsigned int     mode_lf_deltas_0:7;
+}DEBLK_VP8MODEDELTA;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     intra_mb:1;
+unsigned int     eob_total:1;
+unsigned int     ref_frame:2;
+unsigned int     mb_mode:3;
+}DEBLK_VP8DBPAR;
+
+#endif
+
+#define DEBLK_CCPAR                                                                  0x1800EA00
+#define DEBLK_CCPAR_reg_addr                                                         "0xB800EA00"
+#define DEBLK_CCPAR_reg                                                              0xB800EA00
+#define set_DEBLK_CCPAR_reg(data)   (*((volatile unsigned int*) DEBLK_CCPAR_reg)=data)
+#define get_DEBLK_CCPAR_reg   (*((volatile unsigned int*) DEBLK_CCPAR_reg))
+#define DEBLK_CCPAR_inst_adr                                                         "0x0080"
+#define DEBLK_CCPAR_inst                                                             0x0080
+#define DEBLK_CCPAR_PicType_shift                                                    (16)
+#define DEBLK_CCPAR_PicType_mask                                                     (0x00070000)
+#define DEBLK_CCPAR_PicType(data)                                                    (0x00070000&((data)<<16))
+#define DEBLK_CCPAR_PicType_src(data)                                                ((0x00070000&(data))>>16)
+#define DEBLK_CCPAR_get_PicType(data)                                                ((0x00070000&(data))>>16)
+#define DEBLK_CCPAR_First_mb_shift                                                   (15)
+#define DEBLK_CCPAR_First_mb_mask                                                    (0x00008000)
+#define DEBLK_CCPAR_First_mb(data)                                                   (0x00008000&((data)<<15))
+#define DEBLK_CCPAR_First_mb_src(data)                                               ((0x00008000&(data))>>15)
+#define DEBLK_CCPAR_get_First_mb(data)                                               ((0x00008000&(data))>>15)
+#define DEBLK_CCPAR_Cur_mb_x_shift                                                   (8)
+#define DEBLK_CCPAR_Cur_mb_x_mask                                                    (0x00007F00)
+#define DEBLK_CCPAR_Cur_mb_x(data)                                                   (0x00007F00&((data)<<8))
+#define DEBLK_CCPAR_Cur_mb_x_src(data)                                               ((0x00007F00&(data))>>8)
+#define DEBLK_CCPAR_get_Cur_mb_x(data)                                               ((0x00007F00&(data))>>8)
+#define DEBLK_CCPAR_Cur_mb_y_shift                                                   (0)
+#define DEBLK_CCPAR_Cur_mb_y_mask                                                    (0x0000007F)
+#define DEBLK_CCPAR_Cur_mb_y(data)                                                   (0x0000007F&((data)<<0))
+#define DEBLK_CCPAR_Cur_mb_y_src(data)                                               ((0x0000007F&(data))>>0)
+#define DEBLK_CCPAR_get_Cur_mb_y(data)                                               ((0x0000007F&(data))>>0)
+
+
+#define DEBLK_VC1CCPAR_0                                                             0x1800EA04
+#define DEBLK_VC1CCPAR_1                                                             0x1800EA08
+#define DEBLK_VC1CCPAR_0_reg_addr                                                    "0xB800EA04"
+#define DEBLK_VC1CCPAR_1_reg_addr                                                    "0xB800EA08"
+#define DEBLK_VC1CCPAR_0_reg                                                         0xB800EA04
+#define DEBLK_VC1CCPAR_1_reg                                                         0xB800EA08
+#define set_DEBLK_VC1CCPAR_0_reg(data)   (*((volatile unsigned int*) DEBLK_VC1CCPAR_0_reg)=data)
+#define set_DEBLK_VC1CCPAR_1_reg(data)   (*((volatile unsigned int*) DEBLK_VC1CCPAR_1_reg)=data)
+#define get_DEBLK_VC1CCPAR_0_reg   (*((volatile unsigned int*) DEBLK_VC1CCPAR_0_reg))
+#define get_DEBLK_VC1CCPAR_1_reg   (*((volatile unsigned int*) DEBLK_VC1CCPAR_1_reg))
+#define DEBLK_VC1CCPAR_0_inst_adr                                                    "0x0081"
+#define DEBLK_VC1CCPAR_1_inst_adr                                                    "0x0082"
+#define DEBLK_VC1CCPAR_0_inst                                                        0x0081
+#define DEBLK_VC1CCPAR_1_inst                                                        0x0082
+#define DEBLK_VC1CCPAR_IntraMB_flag_shift                                            (21)
+#define DEBLK_VC1CCPAR_IntraMB_flag_mask                                             (0x00200000)
+#define DEBLK_VC1CCPAR_IntraMB_flag(data)                                            (0x00200000&((data)<<21))
+#define DEBLK_VC1CCPAR_IntraMB_flag_src(data)                                        ((0x00200000&(data))>>21)
+#define DEBLK_VC1CCPAR_get_IntraMB_flag(data)                                        ((0x00200000&(data))>>21)
+#define DEBLK_VC1CCPAR_Intra_flag_shift                                              (16)
+#define DEBLK_VC1CCPAR_Intra_flag_mask                                               (0x001F0000)
+#define DEBLK_VC1CCPAR_Intra_flag(data)                                              (0x001F0000&((data)<<16))
+#define DEBLK_VC1CCPAR_Intra_flag_src(data)                                          ((0x001F0000&(data))>>16)
+#define DEBLK_VC1CCPAR_get_Intra_flag(data)                                          ((0x001F0000&(data))>>16)
+#define DEBLK_VC1CCPAR_SubMB_partition_shift                                         (4)
+#define DEBLK_VC1CCPAR_SubMB_partition_mask                                          (0x0000FFF0)
+#define DEBLK_VC1CCPAR_SubMB_partition(data)                                         (0x0000FFF0&((data)<<4))
+#define DEBLK_VC1CCPAR_SubMB_partition_src(data)                                     ((0x0000FFF0&(data))>>4)
+#define DEBLK_VC1CCPAR_get_SubMB_partition(data)                                     ((0x0000FFF0&(data))>>4)
+#define DEBLK_VC1CCPAR_mvtype_shift                                                  (2)
+#define DEBLK_VC1CCPAR_mvtype_mask                                                   (0x0000000C)
+#define DEBLK_VC1CCPAR_mvtype(data)                                                  (0x0000000C&((data)<<2))
+#define DEBLK_VC1CCPAR_mvtype_src(data)                                              ((0x0000000C&(data))>>2)
+#define DEBLK_VC1CCPAR_get_mvtype(data)                                              ((0x0000000C&(data))>>2)
+#define DEBLK_VC1CCPAR_FIELDTX_shift                                                 (1)
+#define DEBLK_VC1CCPAR_FIELDTX_mask                                                  (0x00000002)
+#define DEBLK_VC1CCPAR_FIELDTX(data)                                                 (0x00000002&((data)<<1))
+#define DEBLK_VC1CCPAR_FIELDTX_src(data)                                             ((0x00000002&(data))>>1)
+#define DEBLK_VC1CCPAR_get_FIELDTX(data)                                             ((0x00000002&(data))>>1)
+#define DEBLK_VC1CCPAR_OVERFLAG_shift                                                (0)
+#define DEBLK_VC1CCPAR_OVERFLAG_mask                                                 (0x00000001)
+#define DEBLK_VC1CCPAR_OVERFLAG(data)                                                (0x00000001&((data)<<0))
+#define DEBLK_VC1CCPAR_OVERFLAG_src(data)                                            ((0x00000001&(data))>>0)
+#define DEBLK_VC1CCPAR_get_OVERFLAG(data)                                            ((0x00000001&(data))>>0)
+
+
+#define DEBLK_PARSA                                                                  0x1800EA0C
+#define DEBLK_PARSA_reg_addr                                                         "0xB800EA0C"
+#define DEBLK_PARSA_reg                                                              0xB800EA0C
+#define set_DEBLK_PARSA_reg(data)   (*((volatile unsigned int*) DEBLK_PARSA_reg)=data)
+#define get_DEBLK_PARSA_reg   (*((volatile unsigned int*) DEBLK_PARSA_reg))
+#define DEBLK_PARSA_inst_adr                                                         "0x0083"
+#define DEBLK_PARSA_inst                                                             0x0083
+#define DEBLK_PARSA_ParCom_StartA_shift                                              (0)
+#define DEBLK_PARSA_ParCom_StartA_mask                                               (0x00001FFF)
+#define DEBLK_PARSA_ParCom_StartA(data)                                              (0x00001FFF&((data)<<0))
+#define DEBLK_PARSA_ParCom_StartA_src(data)                                          ((0x00001FFF&(data))>>0)
+#define DEBLK_PARSA_get_ParCom_StartA(data)                                          ((0x00001FFF&(data))>>0)
+
+
+#define DEBLK_NEIGHBOR                                                               0x1800EA10
+#define DEBLK_NEIGHBOR_reg_addr                                                      "0xB800EA10"
+#define DEBLK_NEIGHBOR_reg                                                           0xB800EA10
+#define set_DEBLK_NEIGHBOR_reg(data)   (*((volatile unsigned int*) DEBLK_NEIGHBOR_reg)=data)
+#define get_DEBLK_NEIGHBOR_reg   (*((volatile unsigned int*) DEBLK_NEIGHBOR_reg))
+#define DEBLK_NEIGHBOR_inst_adr                                                      "0x0084"
+#define DEBLK_NEIGHBOR_inst                                                          0x0084
+#define DEBLK_NEIGHBOR_write_enable1_shift                                           (14)
+#define DEBLK_NEIGHBOR_write_enable1_mask                                            (0x00004000)
+#define DEBLK_NEIGHBOR_write_enable1(data)                                           (0x00004000&((data)<<14))
+#define DEBLK_NEIGHBOR_write_enable1_src(data)                                       ((0x00004000&(data))>>14)
+#define DEBLK_NEIGHBOR_get_write_enable1(data)                                       ((0x00004000&(data))>>14)
+#define DEBLK_NEIGHBOR_New_slice_row_shift                                           (13)
+#define DEBLK_NEIGHBOR_New_slice_row_mask                                            (0x00002000)
+#define DEBLK_NEIGHBOR_New_slice_row(data)                                           (0x00002000&((data)<<13))
+#define DEBLK_NEIGHBOR_New_slice_row_src(data)                                       ((0x00002000&(data))>>13)
+#define DEBLK_NEIGHBOR_get_New_slice_row(data)                                       ((0x00002000&(data))>>13)
+#define DEBLK_NEIGHBOR_New_slice_mb_x_shift                                          (6)
+#define DEBLK_NEIGHBOR_New_slice_mb_x_mask                                           (0x00001FC0)
+#define DEBLK_NEIGHBOR_New_slice_mb_x(data)                                          (0x00001FC0&((data)<<6))
+#define DEBLK_NEIGHBOR_New_slice_mb_x_src(data)                                      ((0x00001FC0&(data))>>6)
+#define DEBLK_NEIGHBOR_get_New_slice_mb_x(data)                                      ((0x00001FC0&(data))>>6)
+#define DEBLK_NEIGHBOR_write_enable0_shift                                           (5)
+#define DEBLK_NEIGHBOR_write_enable0_mask                                            (0x00000020)
+#define DEBLK_NEIGHBOR_write_enable0(data)                                           (0x00000020&((data)<<5))
+#define DEBLK_NEIGHBOR_write_enable0_src(data)                                       ((0x00000020&(data))>>5)
+#define DEBLK_NEIGHBOR_get_write_enable0(data)                                       ((0x00000020&(data))>>5)
+#define DEBLK_NEIGHBOR_Sw_neighbor_enable_shift                                      (4)
+#define DEBLK_NEIGHBOR_Sw_neighbor_enable_mask                                       (0x00000010)
+#define DEBLK_NEIGHBOR_Sw_neighbor_enable(data)                                      (0x00000010&((data)<<4))
+#define DEBLK_NEIGHBOR_Sw_neighbor_enable_src(data)                                  ((0x00000010&(data))>>4)
+#define DEBLK_NEIGHBOR_get_Sw_neighbor_enable(data)                                  ((0x00000010&(data))>>4)
+#define DEBLK_NEIGHBOR_MbAddrA_available_shift                                       (3)
+#define DEBLK_NEIGHBOR_MbAddrA_available_mask                                        (0x00000008)
+#define DEBLK_NEIGHBOR_MbAddrA_available(data)                                       (0x00000008&((data)<<3))
+#define DEBLK_NEIGHBOR_MbAddrA_available_src(data)                                   ((0x00000008&(data))>>3)
+#define DEBLK_NEIGHBOR_get_MbAddrA_available(data)                                   ((0x00000008&(data))>>3)
+#define DEBLK_NEIGHBOR_MbAddrB_available_shift                                       (2)
+#define DEBLK_NEIGHBOR_MbAddrB_available_mask                                        (0x00000004)
+#define DEBLK_NEIGHBOR_MbAddrB_available(data)                                       (0x00000004&((data)<<2))
+#define DEBLK_NEIGHBOR_MbAddrB_available_src(data)                                   ((0x00000004&(data))>>2)
+#define DEBLK_NEIGHBOR_get_MbAddrB_available(data)                                   ((0x00000004&(data))>>2)
+#define DEBLK_NEIGHBOR_MbAddrD_available_shift                                       (0)
+#define DEBLK_NEIGHBOR_MbAddrD_available_mask                                        (0x00000001)
+#define DEBLK_NEIGHBOR_MbAddrD_available(data)                                       (0x00000001&((data)<<0))
+#define DEBLK_NEIGHBOR_MbAddrD_available_src(data)                                   ((0x00000001&(data))>>0)
+#define DEBLK_NEIGHBOR_get_MbAddrD_available(data)                                   ((0x00000001&(data))>>0)
+
+
+#define DEBLK_DEBCNTL                                                                0x1800EA14
+#define DEBLK_DEBCNTL_reg_addr                                                       "0xB800EA14"
+#define DEBLK_DEBCNTL_reg                                                            0xB800EA14
+#define set_DEBLK_DEBCNTL_reg(data)   (*((volatile unsigned int*) DEBLK_DEBCNTL_reg)=data)
+#define get_DEBLK_DEBCNTL_reg   (*((volatile unsigned int*) DEBLK_DEBCNTL_reg))
+#define DEBLK_DEBCNTL_inst_adr                                                       "0x0085"
+#define DEBLK_DEBCNTL_inst                                                           0x0085
+#define DEBLK_DEBCNTL_avs_alpha_c_offset_shift                                       (15)
+#define DEBLK_DEBCNTL_avs_alpha_c_offset_mask                                        (0x000F8000)
+#define DEBLK_DEBCNTL_avs_alpha_c_offset(data)                                       (0x000F8000&((data)<<15))
+#define DEBLK_DEBCNTL_avs_alpha_c_offset_src(data)                                   ((0x000F8000&(data))>>15)
+#define DEBLK_DEBCNTL_get_avs_alpha_c_offset(data)                                   ((0x000F8000&(data))>>15)
+#define DEBLK_DEBCNTL_avs_beta_offset_shift                                          (10)
+#define DEBLK_DEBCNTL_avs_beta_offset_mask                                           (0x00007C00)
+#define DEBLK_DEBCNTL_avs_beta_offset(data)                                          (0x00007C00&((data)<<10))
+#define DEBLK_DEBCNTL_avs_beta_offset_src(data)                                      ((0x00007C00&(data))>>10)
+#define DEBLK_DEBCNTL_get_avs_beta_offset(data)                                      ((0x00007C00&(data))>>10)
+#define DEBLK_DEBCNTL_slice_alpha_c0_offset_div2_shift                               (6)
+#define DEBLK_DEBCNTL_slice_alpha_c0_offset_div2_mask                                (0x000003C0)
+#define DEBLK_DEBCNTL_slice_alpha_c0_offset_div2(data)                               (0x000003C0&((data)<<6))
+#define DEBLK_DEBCNTL_slice_alpha_c0_offset_div2_src(data)                           ((0x000003C0&(data))>>6)
+#define DEBLK_DEBCNTL_get_slice_alpha_c0_offset_div2(data)                           ((0x000003C0&(data))>>6)
+#define DEBLK_DEBCNTL_slice_beta_offset_div2_shift                                   (2)
+#define DEBLK_DEBCNTL_slice_beta_offset_div2_mask                                    (0x0000003C)
+#define DEBLK_DEBCNTL_slice_beta_offset_div2(data)                                   (0x0000003C&((data)<<2))
+#define DEBLK_DEBCNTL_slice_beta_offset_div2_src(data)                               ((0x0000003C&(data))>>2)
+#define DEBLK_DEBCNTL_get_slice_beta_offset_div2(data)                               ((0x0000003C&(data))>>2)
+#define DEBLK_DEBCNTL_disable_deblocking_filter_idc_shift                            (0)
+#define DEBLK_DEBCNTL_disable_deblocking_filter_idc_mask                             (0x00000003)
+#define DEBLK_DEBCNTL_disable_deblocking_filter_idc(data)                            (0x00000003&((data)<<0))
+#define DEBLK_DEBCNTL_disable_deblocking_filter_idc_src(data)                        ((0x00000003&(data))>>0)
+#define DEBLK_DEBCNTL_get_disable_deblocking_filter_idc(data)                        ((0x00000003&(data))>>0)
+
+
+#define DEBLK_DEBCNTL2                                                               0x1800EA18
+#define DEBLK_DEBCNTL2_reg_addr                                                      "0xB800EA18"
+#define DEBLK_DEBCNTL2_reg                                                           0xB800EA18
+#define set_DEBLK_DEBCNTL2_reg(data)   (*((volatile unsigned int*) DEBLK_DEBCNTL2_reg)=data)
+#define get_DEBLK_DEBCNTL2_reg   (*((volatile unsigned int*) DEBLK_DEBCNTL2_reg))
+#define DEBLK_DEBCNTL2_inst_adr                                                      "0x0086"
+#define DEBLK_DEBCNTL2_inst                                                          0x0086
+#define DEBLK_DEBCNTL2_lambda_mode_shift                                             (12)
+#define DEBLK_DEBCNTL2_lambda_mode_mask                                              (0x00001000)
+#define DEBLK_DEBCNTL2_lambda_mode(data)                                             (0x00001000&((data)<<12))
+#define DEBLK_DEBCNTL2_lambda_mode_src(data)                                         ((0x00001000&(data))>>12)
+#define DEBLK_DEBCNTL2_get_lambda_mode(data)                                         ((0x00001000&(data))>>12)
+#define DEBLK_DEBCNTL2_thr_3_shift                                                   (8)
+#define DEBLK_DEBCNTL2_thr_3_mask                                                    (0x00000F00)
+#define DEBLK_DEBCNTL2_thr_3(data)                                                   (0x00000F00&((data)<<8))
+#define DEBLK_DEBCNTL2_thr_3_src(data)                                               ((0x00000F00&(data))>>8)
+#define DEBLK_DEBCNTL2_get_thr_3(data)                                               ((0x00000F00&(data))>>8)
+#define DEBLK_DEBCNTL2_thr_2_shift                                                   (4)
+#define DEBLK_DEBCNTL2_thr_2_mask                                                    (0x000000F0)
+#define DEBLK_DEBCNTL2_thr_2(data)                                                   (0x000000F0&((data)<<4))
+#define DEBLK_DEBCNTL2_thr_2_src(data)                                               ((0x000000F0&(data))>>4)
+#define DEBLK_DEBCNTL2_get_thr_2(data)                                               ((0x000000F0&(data))>>4)
+#define DEBLK_DEBCNTL2_thr_1_shift                                                   (0)
+#define DEBLK_DEBCNTL2_thr_1_mask                                                    (0x0000000F)
+#define DEBLK_DEBCNTL2_thr_1(data)                                                   (0x0000000F&((data)<<0))
+#define DEBLK_DEBCNTL2_thr_1_src(data)                                               ((0x0000000F&(data))>>0)
+#define DEBLK_DEBCNTL2_get_thr_1(data)                                               ((0x0000000F&(data))>>0)
+
+
+#define DEBLK_H264DBPAR0_0                                                           0x1800EA20
+#define DEBLK_H264DBPAR0_1                                                           0x1800EA24
+#define DEBLK_H264DBPAR0_2                                                           0x1800EA28
+#define DEBLK_H264DBPAR0_3                                                           0x1800EA2C
+#define DEBLK_H264DBPAR0_0_reg_addr                                                  "0xB800EA20"
+#define DEBLK_H264DBPAR0_1_reg_addr                                                  "0xB800EA24"
+#define DEBLK_H264DBPAR0_2_reg_addr                                                  "0xB800EA28"
+#define DEBLK_H264DBPAR0_3_reg_addr                                                  "0xB800EA2C"
+#define DEBLK_H264DBPAR0_0_reg                                                       0xB800EA20
+#define DEBLK_H264DBPAR0_1_reg                                                       0xB800EA24
+#define DEBLK_H264DBPAR0_2_reg                                                       0xB800EA28
+#define DEBLK_H264DBPAR0_3_reg                                                       0xB800EA2C
+#define set_DEBLK_H264DBPAR0_0_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR0_0_reg)=data)
+#define set_DEBLK_H264DBPAR0_1_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR0_1_reg)=data)
+#define set_DEBLK_H264DBPAR0_2_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR0_2_reg)=data)
+#define set_DEBLK_H264DBPAR0_3_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR0_3_reg)=data)
+#define get_DEBLK_H264DBPAR0_0_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR0_0_reg))
+#define get_DEBLK_H264DBPAR0_1_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR0_1_reg))
+#define get_DEBLK_H264DBPAR0_2_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR0_2_reg))
+#define get_DEBLK_H264DBPAR0_3_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR0_3_reg))
+#define DEBLK_H264DBPAR0_0_inst_adr                                                  "0x0088"
+#define DEBLK_H264DBPAR0_1_inst_adr                                                  "0x0089"
+#define DEBLK_H264DBPAR0_2_inst_adr                                                  "0x008A"
+#define DEBLK_H264DBPAR0_3_inst_adr                                                  "0x008B"
+#define DEBLK_H264DBPAR0_0_inst                                                      0x0088
+#define DEBLK_H264DBPAR0_1_inst                                                      0x0089
+#define DEBLK_H264DBPAR0_2_inst                                                      0x008A
+#define DEBLK_H264DBPAR0_3_inst                                                      0x008B
+#define DEBLK_H264DBPAR0_Intra_flag_shift                                            (29)
+#define DEBLK_H264DBPAR0_Intra_flag_mask                                             (0x20000000)
+#define DEBLK_H264DBPAR0_Intra_flag(data)                                            (0x20000000&((data)<<29))
+#define DEBLK_H264DBPAR0_Intra_flag_src(data)                                        ((0x20000000&(data))>>29)
+#define DEBLK_H264DBPAR0_get_Intra_flag(data)                                        ((0x20000000&(data))>>29)
+#define DEBLK_H264DBPAR0_transform_size_8x8_flag_shift                               (28)
+#define DEBLK_H264DBPAR0_transform_size_8x8_flag_mask                                (0x10000000)
+#define DEBLK_H264DBPAR0_transform_size_8x8_flag(data)                               (0x10000000&((data)<<28))
+#define DEBLK_H264DBPAR0_transform_size_8x8_flag_src(data)                           ((0x10000000&(data))>>28)
+#define DEBLK_H264DBPAR0_get_transform_size_8x8_flag(data)                           ((0x10000000&(data))>>28)
+#define DEBLK_H264DBPAR0_QPy_shift                                                   (22)
+#define DEBLK_H264DBPAR0_QPy_mask                                                    (0x0FC00000)
+#define DEBLK_H264DBPAR0_QPy(data)                                                   (0x0FC00000&((data)<<22))
+#define DEBLK_H264DBPAR0_QPy_src(data)                                               ((0x0FC00000&(data))>>22)
+#define DEBLK_H264DBPAR0_get_QPy(data)                                               ((0x0FC00000&(data))>>22)
+#define DEBLK_H264DBPAR0_QPcb_shift                                                  (16)
+#define DEBLK_H264DBPAR0_QPcb_mask                                                   (0x003F0000)
+#define DEBLK_H264DBPAR0_QPcb(data)                                                  (0x003F0000&((data)<<16))
+#define DEBLK_H264DBPAR0_QPcb_src(data)                                              ((0x003F0000&(data))>>16)
+#define DEBLK_H264DBPAR0_get_QPcb(data)                                              ((0x003F0000&(data))>>16)
+#define DEBLK_H264DBPAR0_QPcr_shift                                                  (10)
+#define DEBLK_H264DBPAR0_QPcr_mask                                                   (0x0000FC00)
+#define DEBLK_H264DBPAR0_QPcr(data)                                                  (0x0000FC00&((data)<<10))
+#define DEBLK_H264DBPAR0_QPcr_src(data)                                              ((0x0000FC00&(data))>>10)
+#define DEBLK_H264DBPAR0_get_QPcr(data)                                              ((0x0000FC00&(data))>>10)
+#define DEBLK_H264DBPAR0_MB_field_decoding_flag_shift                                (9)
+#define DEBLK_H264DBPAR0_MB_field_decoding_flag_mask                                 (0x00000200)
+#define DEBLK_H264DBPAR0_MB_field_decoding_flag(data)                                (0x00000200&((data)<<9))
+#define DEBLK_H264DBPAR0_MB_field_decoding_flag_src(data)                            ((0x00000200&(data))>>9)
+#define DEBLK_H264DBPAR0_get_MB_field_decoding_flag(data)                            ((0x00000200&(data))>>9)
+#define DEBLK_H264DBPAR0_Mb_partition_shift                                          (0)
+#define DEBLK_H264DBPAR0_Mb_partition_mask                                           (0x000001FF)
+#define DEBLK_H264DBPAR0_Mb_partition(data)                                          (0x000001FF&((data)<<0))
+#define DEBLK_H264DBPAR0_Mb_partition_src(data)                                      ((0x000001FF&(data))>>0)
+#define DEBLK_H264DBPAR0_get_Mb_partition(data)                                      ((0x000001FF&(data))>>0)
+
+
+#define DEBLK_H264DBPAR1_0                                                           0x1800EA30
+#define DEBLK_H264DBPAR1_1                                                           0x1800EA34
+#define DEBLK_H264DBPAR1_2                                                           0x1800EA38
+#define DEBLK_H264DBPAR1_3                                                           0x1800EA3C
+#define DEBLK_H264DBPAR1_0_reg_addr                                                  "0xB800EA30"
+#define DEBLK_H264DBPAR1_1_reg_addr                                                  "0xB800EA34"
+#define DEBLK_H264DBPAR1_2_reg_addr                                                  "0xB800EA38"
+#define DEBLK_H264DBPAR1_3_reg_addr                                                  "0xB800EA3C"
+#define DEBLK_H264DBPAR1_0_reg                                                       0xB800EA30
+#define DEBLK_H264DBPAR1_1_reg                                                       0xB800EA34
+#define DEBLK_H264DBPAR1_2_reg                                                       0xB800EA38
+#define DEBLK_H264DBPAR1_3_reg                                                       0xB800EA3C
+#define set_DEBLK_H264DBPAR1_0_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR1_0_reg)=data)
+#define set_DEBLK_H264DBPAR1_1_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR1_1_reg)=data)
+#define set_DEBLK_H264DBPAR1_2_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR1_2_reg)=data)
+#define set_DEBLK_H264DBPAR1_3_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR1_3_reg)=data)
+#define get_DEBLK_H264DBPAR1_0_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR1_0_reg))
+#define get_DEBLK_H264DBPAR1_1_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR1_1_reg))
+#define get_DEBLK_H264DBPAR1_2_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR1_2_reg))
+#define get_DEBLK_H264DBPAR1_3_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR1_3_reg))
+#define DEBLK_H264DBPAR1_0_inst_adr                                                  "0x008C"
+#define DEBLK_H264DBPAR1_1_inst_adr                                                  "0x008D"
+#define DEBLK_H264DBPAR1_2_inst_adr                                                  "0x008E"
+#define DEBLK_H264DBPAR1_3_inst_adr                                                  "0x008F"
+#define DEBLK_H264DBPAR1_0_inst                                                      0x008C
+#define DEBLK_H264DBPAR1_1_inst                                                      0x008D
+#define DEBLK_H264DBPAR1_2_inst                                                      0x008E
+#define DEBLK_H264DBPAR1_3_inst                                                      0x008F
+#define DEBLK_H264DBPAR1_BS1_valid_ext_shift                                         (24)
+#define DEBLK_H264DBPAR1_BS1_valid_ext_mask                                          (0x0F000000)
+#define DEBLK_H264DBPAR1_BS1_valid_ext(data)                                         (0x0F000000&((data)<<24))
+#define DEBLK_H264DBPAR1_BS1_valid_ext_src(data)                                     ((0x0F000000&(data))>>24)
+#define DEBLK_H264DBPAR1_get_BS1_valid_ext(data)                                     ((0x0F000000&(data))>>24)
+#define DEBLK_H264DBPAR1_Subblkpat_shift                                             (0)
+#define DEBLK_H264DBPAR1_Subblkpat_mask                                              (0x00FFFFFF)
+#define DEBLK_H264DBPAR1_Subblkpat(data)                                             (0x00FFFFFF&((data)<<0))
+#define DEBLK_H264DBPAR1_Subblkpat_src(data)                                         ((0x00FFFFFF&(data))>>0)
+#define DEBLK_H264DBPAR1_get_Subblkpat(data)                                         ((0x00FFFFFF&(data))>>0)
+
+
+#define DEBLK_H264DBPAR2_0                                                           0x1800EA40
+#define DEBLK_H264DBPAR2_1                                                           0x1800EA44
+#define DEBLK_H264DBPAR2_2                                                           0x1800EA48
+#define DEBLK_H264DBPAR2_3                                                           0x1800EA4C
+#define DEBLK_H264DBPAR2_0_reg_addr                                                  "0xB800EA40"
+#define DEBLK_H264DBPAR2_1_reg_addr                                                  "0xB800EA44"
+#define DEBLK_H264DBPAR2_2_reg_addr                                                  "0xB800EA48"
+#define DEBLK_H264DBPAR2_3_reg_addr                                                  "0xB800EA4C"
+#define DEBLK_H264DBPAR2_0_reg                                                       0xB800EA40
+#define DEBLK_H264DBPAR2_1_reg                                                       0xB800EA44
+#define DEBLK_H264DBPAR2_2_reg                                                       0xB800EA48
+#define DEBLK_H264DBPAR2_3_reg                                                       0xB800EA4C
+#define set_DEBLK_H264DBPAR2_0_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR2_0_reg)=data)
+#define set_DEBLK_H264DBPAR2_1_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR2_1_reg)=data)
+#define set_DEBLK_H264DBPAR2_2_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR2_2_reg)=data)
+#define set_DEBLK_H264DBPAR2_3_reg(data)   (*((volatile unsigned int*) DEBLK_H264DBPAR2_3_reg)=data)
+#define get_DEBLK_H264DBPAR2_0_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR2_0_reg))
+#define get_DEBLK_H264DBPAR2_1_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR2_1_reg))
+#define get_DEBLK_H264DBPAR2_2_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR2_2_reg))
+#define get_DEBLK_H264DBPAR2_3_reg   (*((volatile unsigned int*) DEBLK_H264DBPAR2_3_reg))
+#define DEBLK_H264DBPAR2_0_inst_adr                                                  "0x0090"
+#define DEBLK_H264DBPAR2_1_inst_adr                                                  "0x0091"
+#define DEBLK_H264DBPAR2_2_inst_adr                                                  "0x0092"
+#define DEBLK_H264DBPAR2_3_inst_adr                                                  "0x0093"
+#define DEBLK_H264DBPAR2_0_inst                                                      0x0090
+#define DEBLK_H264DBPAR2_1_inst                                                      0x0091
+#define DEBLK_H264DBPAR2_2_inst                                                      0x0092
+#define DEBLK_H264DBPAR2_3_inst                                                      0x0093
+#define DEBLK_H264DBPAR2_BS1_valid_shift                                             (0)
+#define DEBLK_H264DBPAR2_BS1_valid_mask                                              (0xFFFFFFFF)
+#define DEBLK_H264DBPAR2_BS1_valid(data)                                             (0xFFFFFFFF&((data)<<0))
+#define DEBLK_H264DBPAR2_BS1_valid_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define DEBLK_H264DBPAR2_get_BS1_valid(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define DEBLK_VC1DBPAR0_0                                                            0x1800EA50
+#define DEBLK_VC1DBPAR0_1                                                            0x1800EA54
+#define DEBLK_VC1DBPAR0_0_reg_addr                                                   "0xB800EA50"
+#define DEBLK_VC1DBPAR0_1_reg_addr                                                   "0xB800EA54"
+#define DEBLK_VC1DBPAR0_0_reg                                                        0xB800EA50
+#define DEBLK_VC1DBPAR0_1_reg                                                        0xB800EA54
+#define set_DEBLK_VC1DBPAR0_0_reg(data)   (*((volatile unsigned int*) DEBLK_VC1DBPAR0_0_reg)=data)
+#define set_DEBLK_VC1DBPAR0_1_reg(data)   (*((volatile unsigned int*) DEBLK_VC1DBPAR0_1_reg)=data)
+#define get_DEBLK_VC1DBPAR0_0_reg   (*((volatile unsigned int*) DEBLK_VC1DBPAR0_0_reg))
+#define get_DEBLK_VC1DBPAR0_1_reg   (*((volatile unsigned int*) DEBLK_VC1DBPAR0_1_reg))
+#define DEBLK_VC1DBPAR0_0_inst_adr                                                   "0x0094"
+#define DEBLK_VC1DBPAR0_1_inst_adr                                                   "0x0095"
+#define DEBLK_VC1DBPAR0_0_inst                                                       0x0094
+#define DEBLK_VC1DBPAR0_1_inst                                                       0x0095
+#define DEBLK_VC1DBPAR0_Lu_Mv_equal_shift                                            (0)
+#define DEBLK_VC1DBPAR0_Lu_Mv_equal_mask                                             (0xFFFFFFFF)
+#define DEBLK_VC1DBPAR0_Lu_Mv_equal(data)                                            (0xFFFFFFFF&((data)<<0))
+#define DEBLK_VC1DBPAR0_Lu_Mv_equal_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define DEBLK_VC1DBPAR0_get_Lu_Mv_equal(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define DEBLK_VC1DBPAR1_0                                                            0x1800EA58
+#define DEBLK_VC1DBPAR1_1                                                            0x1800EA5C
+#define DEBLK_VC1DBPAR1_0_reg_addr                                                   "0xB800EA58"
+#define DEBLK_VC1DBPAR1_1_reg_addr                                                   "0xB800EA5C"
+#define DEBLK_VC1DBPAR1_0_reg                                                        0xB800EA58
+#define DEBLK_VC1DBPAR1_1_reg                                                        0xB800EA5C
+#define set_DEBLK_VC1DBPAR1_0_reg(data)   (*((volatile unsigned int*) DEBLK_VC1DBPAR1_0_reg)=data)
+#define set_DEBLK_VC1DBPAR1_1_reg(data)   (*((volatile unsigned int*) DEBLK_VC1DBPAR1_1_reg)=data)
+#define get_DEBLK_VC1DBPAR1_0_reg   (*((volatile unsigned int*) DEBLK_VC1DBPAR1_0_reg))
+#define get_DEBLK_VC1DBPAR1_1_reg   (*((volatile unsigned int*) DEBLK_VC1DBPAR1_1_reg))
+#define DEBLK_VC1DBPAR1_0_inst_adr                                                   "0x0096"
+#define DEBLK_VC1DBPAR1_1_inst_adr                                                   "0x0097"
+#define DEBLK_VC1DBPAR1_0_inst                                                       0x0096
+#define DEBLK_VC1DBPAR1_1_inst                                                       0x0097
+#define DEBLK_VC1DBPAR1_Subblkpat_shift                                              (8)
+#define DEBLK_VC1DBPAR1_Subblkpat_mask                                               (0xFFFFFF00)
+#define DEBLK_VC1DBPAR1_Subblkpat(data)                                              (0xFFFFFF00&((data)<<8))
+#define DEBLK_VC1DBPAR1_Subblkpat_src(data)                                          ((0xFFFFFF00&(data))>>8)
+#define DEBLK_VC1DBPAR1_get_Subblkpat(data)                                          ((0xFFFFFF00&(data))>>8)
+#define DEBLK_VC1DBPAR1_ch_mv_equal_shift                                            (0)
+#define DEBLK_VC1DBPAR1_ch_mv_equal_mask                                             (0x000000FF)
+#define DEBLK_VC1DBPAR1_ch_mv_equal(data)                                            (0x000000FF&((data)<<0))
+#define DEBLK_VC1DBPAR1_ch_mv_equal_src(data)                                        ((0x000000FF&(data))>>0)
+#define DEBLK_VC1DBPAR1_get_ch_mv_equal(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define DEBLK_RVCTRL                                                                 0x1800EA60
+#define DEBLK_RVCTRL_reg_addr                                                        "0xB800EA60"
+#define DEBLK_RVCTRL_reg                                                             0xB800EA60
+#define set_DEBLK_RVCTRL_reg(data)   (*((volatile unsigned int*) DEBLK_RVCTRL_reg)=data)
+#define get_DEBLK_RVCTRL_reg   (*((volatile unsigned int*) DEBLK_RVCTRL_reg))
+#define DEBLK_RVCTRL_inst_adr                                                        "0x0098"
+#define DEBLK_RVCTRL_inst                                                            0x0098
+#define DEBLK_RVCTRL_write_enable3_shift                                             (27)
+#define DEBLK_RVCTRL_write_enable3_mask                                              (0x08000000)
+#define DEBLK_RVCTRL_write_enable3(data)                                             (0x08000000&((data)<<27))
+#define DEBLK_RVCTRL_write_enable3_src(data)                                         ((0x08000000&(data))>>27)
+#define DEBLK_RVCTRL_get_write_enable3(data)                                         ((0x08000000&(data))>>27)
+#define DEBLK_RVCTRL_RefQP_shift                                                     (22)
+#define DEBLK_RVCTRL_RefQP_mask                                                      (0x07C00000)
+#define DEBLK_RVCTRL_RefQP(data)                                                     (0x07C00000&((data)<<22))
+#define DEBLK_RVCTRL_RefQP_src(data)                                                 ((0x07C00000&(data))>>22)
+#define DEBLK_RVCTRL_get_RefQP(data)                                                 ((0x07C00000&(data))>>22)
+#define DEBLK_RVCTRL_Beta2Sel_shift                                                  (21)
+#define DEBLK_RVCTRL_Beta2Sel_mask                                                   (0x00200000)
+#define DEBLK_RVCTRL_Beta2Sel(data)                                                  (0x00200000&((data)<<21))
+#define DEBLK_RVCTRL_Beta2Sel_src(data)                                              ((0x00200000&(data))>>21)
+#define DEBLK_RVCTRL_get_Beta2Sel(data)                                              ((0x00200000&(data))>>21)
+#define DEBLK_RVCTRL_write_enable2_shift                                             (20)
+#define DEBLK_RVCTRL_write_enable2_mask                                              (0x00100000)
+#define DEBLK_RVCTRL_write_enable2(data)                                             (0x00100000&((data)<<20))
+#define DEBLK_RVCTRL_write_enable2_src(data)                                         ((0x00100000&(data))>>20)
+#define DEBLK_RVCTRL_get_write_enable2(data)                                         ((0x00100000&(data))>>20)
+#define DEBLK_RVCTRL_is_key_frame_shift                                              (19)
+#define DEBLK_RVCTRL_is_key_frame_mask                                               (0x00080000)
+#define DEBLK_RVCTRL_is_key_frame(data)                                              (0x00080000&((data)<<19))
+#define DEBLK_RVCTRL_is_key_frame_src(data)                                          ((0x00080000&(data))>>19)
+#define DEBLK_RVCTRL_get_is_key_frame(data)                                          ((0x00080000&(data))>>19)
+#define DEBLK_RVCTRL_chroma_only_shift                                               (18)
+#define DEBLK_RVCTRL_chroma_only_mask                                                (0x00040000)
+#define DEBLK_RVCTRL_chroma_only(data)                                               (0x00040000&((data)<<18))
+#define DEBLK_RVCTRL_chroma_only_src(data)                                           ((0x00040000&(data))>>18)
+#define DEBLK_RVCTRL_get_chroma_only(data)                                           ((0x00040000&(data))>>18)
+#define DEBLK_RVCTRL_write_enable1_shift                                             (17)
+#define DEBLK_RVCTRL_write_enable1_mask                                              (0x00020000)
+#define DEBLK_RVCTRL_write_enable1(data)                                             (0x00020000&((data)<<17))
+#define DEBLK_RVCTRL_write_enable1_src(data)                                         ((0x00020000&(data))>>17)
+#define DEBLK_RVCTRL_get_write_enable1(data)                                         ((0x00020000&(data))>>17)
+#define DEBLK_RVCTRL_Sel_s_chroma_deblock_shift                                      (16)
+#define DEBLK_RVCTRL_Sel_s_chroma_deblock_mask                                       (0x00010000)
+#define DEBLK_RVCTRL_Sel_s_chroma_deblock(data)                                      (0x00010000&((data)<<16))
+#define DEBLK_RVCTRL_Sel_s_chroma_deblock_src(data)                                  ((0x00010000&(data))>>16)
+#define DEBLK_RVCTRL_get_Sel_s_chroma_deblock(data)                                  ((0x00010000&(data))>>16)
+#define DEBLK_RVCTRL_write_enable0_shift                                             (15)
+#define DEBLK_RVCTRL_write_enable0_mask                                              (0x00008000)
+#define DEBLK_RVCTRL_write_enable0(data)                                             (0x00008000&((data)<<15))
+#define DEBLK_RVCTRL_write_enable0_src(data)                                         ((0x00008000&(data))>>15)
+#define DEBLK_RVCTRL_get_write_enable0(data)                                         ((0x00008000&(data))>>15)
+#define DEBLK_RVCTRL_STR9_initQP_shift                                               (10)
+#define DEBLK_RVCTRL_STR9_initQP_mask                                                (0x00007C00)
+#define DEBLK_RVCTRL_STR9_initQP(data)                                               (0x00007C00&((data)<<10))
+#define DEBLK_RVCTRL_STR9_initQP_src(data)                                           ((0x00007C00&(data))>>10)
+#define DEBLK_RVCTRL_get_STR9_initQP(data)                                           ((0x00007C00&(data))>>10)
+#define DEBLK_RVCTRL_STR8_initQP_shift                                               (5)
+#define DEBLK_RVCTRL_STR8_initQP_mask                                                (0x000003E0)
+#define DEBLK_RVCTRL_STR8_initQP(data)                                               (0x000003E0&((data)<<5))
+#define DEBLK_RVCTRL_STR8_initQP_src(data)                                           ((0x000003E0&(data))>>5)
+#define DEBLK_RVCTRL_get_STR8_initQP(data)                                           ((0x000003E0&(data))>>5)
+#define DEBLK_RVCTRL_STR7_initQP_shift                                               (0)
+#define DEBLK_RVCTRL_STR7_initQP_mask                                                (0x0000001F)
+#define DEBLK_RVCTRL_STR7_initQP(data)                                               (0x0000001F&((data)<<0))
+#define DEBLK_RVCTRL_STR7_initQP_src(data)                                           ((0x0000001F&(data))>>0)
+#define DEBLK_RVCTRL_get_STR7_initQP(data)                                           ((0x0000001F&(data))>>0)
+
+
+#define DEBLK_RV8CTRL                                                                0x1800EA64
+#define DEBLK_RV8CTRL_reg_addr                                                       "0xB800EA64"
+#define DEBLK_RV8CTRL_reg                                                            0xB800EA64
+#define set_DEBLK_RV8CTRL_reg(data)   (*((volatile unsigned int*) DEBLK_RV8CTRL_reg)=data)
+#define get_DEBLK_RV8CTRL_reg   (*((volatile unsigned int*) DEBLK_RV8CTRL_reg))
+#define DEBLK_RV8CTRL_inst_adr                                                       "0x0099"
+#define DEBLK_RV8CTRL_inst                                                           0x0099
+#define DEBLK_RV8CTRL_STR6_initQP_shift                                              (25)
+#define DEBLK_RV8CTRL_STR6_initQP_mask                                               (0x3E000000)
+#define DEBLK_RV8CTRL_STR6_initQP(data)                                              (0x3E000000&((data)<<25))
+#define DEBLK_RV8CTRL_STR6_initQP_src(data)                                          ((0x3E000000&(data))>>25)
+#define DEBLK_RV8CTRL_get_STR6_initQP(data)                                          ((0x3E000000&(data))>>25)
+#define DEBLK_RV8CTRL_STR5_initQP_shift                                              (20)
+#define DEBLK_RV8CTRL_STR5_initQP_mask                                               (0x01F00000)
+#define DEBLK_RV8CTRL_STR5_initQP(data)                                              (0x01F00000&((data)<<20))
+#define DEBLK_RV8CTRL_STR5_initQP_src(data)                                          ((0x01F00000&(data))>>20)
+#define DEBLK_RV8CTRL_get_STR5_initQP(data)                                          ((0x01F00000&(data))>>20)
+#define DEBLK_RV8CTRL_STR4_initQP_shift                                              (15)
+#define DEBLK_RV8CTRL_STR4_initQP_mask                                               (0x000F8000)
+#define DEBLK_RV8CTRL_STR4_initQP(data)                                              (0x000F8000&((data)<<15))
+#define DEBLK_RV8CTRL_STR4_initQP_src(data)                                          ((0x000F8000&(data))>>15)
+#define DEBLK_RV8CTRL_get_STR4_initQP(data)                                          ((0x000F8000&(data))>>15)
+#define DEBLK_RV8CTRL_STR3_initQP_shift                                              (10)
+#define DEBLK_RV8CTRL_STR3_initQP_mask                                               (0x00007C00)
+#define DEBLK_RV8CTRL_STR3_initQP(data)                                              (0x00007C00&((data)<<10))
+#define DEBLK_RV8CTRL_STR3_initQP_src(data)                                          ((0x00007C00&(data))>>10)
+#define DEBLK_RV8CTRL_get_STR3_initQP(data)                                          ((0x00007C00&(data))>>10)
+#define DEBLK_RV8CTRL_STR2_initQP_shift                                              (5)
+#define DEBLK_RV8CTRL_STR2_initQP_mask                                               (0x000003E0)
+#define DEBLK_RV8CTRL_STR2_initQP(data)                                              (0x000003E0&((data)<<5))
+#define DEBLK_RV8CTRL_STR2_initQP_src(data)                                          ((0x000003E0&(data))>>5)
+#define DEBLK_RV8CTRL_get_STR2_initQP(data)                                          ((0x000003E0&(data))>>5)
+#define DEBLK_RV8CTRL_STR1_initQP_shift                                              (0)
+#define DEBLK_RV8CTRL_STR1_initQP_mask                                               (0x0000001F)
+#define DEBLK_RV8CTRL_STR1_initQP(data)                                              (0x0000001F&((data)<<0))
+#define DEBLK_RV8CTRL_STR1_initQP_src(data)                                          ((0x0000001F&(data))>>0)
+#define DEBLK_RV8CTRL_get_STR1_initQP(data)                                          ((0x0000001F&(data))>>0)
+
+
+#define DEBLK_RVDBPAR0_0                                                             0x1800EA68
+#define DEBLK_RVDBPAR0_1                                                             0x1800EA6C
+#define DEBLK_RVDBPAR0_0_reg_addr                                                    "0xB800EA68"
+#define DEBLK_RVDBPAR0_1_reg_addr                                                    "0xB800EA6C"
+#define DEBLK_RVDBPAR0_0_reg                                                         0xB800EA68
+#define DEBLK_RVDBPAR0_1_reg                                                         0xB800EA6C
+#define set_DEBLK_RVDBPAR0_0_reg(data)   (*((volatile unsigned int*) DEBLK_RVDBPAR0_0_reg)=data)
+#define set_DEBLK_RVDBPAR0_1_reg(data)   (*((volatile unsigned int*) DEBLK_RVDBPAR0_1_reg)=data)
+#define get_DEBLK_RVDBPAR0_0_reg   (*((volatile unsigned int*) DEBLK_RVDBPAR0_0_reg))
+#define get_DEBLK_RVDBPAR0_1_reg   (*((volatile unsigned int*) DEBLK_RVDBPAR0_1_reg))
+#define DEBLK_RVDBPAR0_0_inst_adr                                                    "0x009A"
+#define DEBLK_RVDBPAR0_1_inst_adr                                                    "0x009B"
+#define DEBLK_RVDBPAR0_0_inst                                                        0x009A
+#define DEBLK_RVDBPAR0_1_inst                                                        0x009B
+#define DEBLK_RVDBPAR0_mvd_shift                                                     (5)
+#define DEBLK_RVDBPAR0_mvd_mask                                                      (0x001FFFE0)
+#define DEBLK_RVDBPAR0_mvd(data)                                                     (0x001FFFE0&((data)<<5))
+#define DEBLK_RVDBPAR0_mvd_src(data)                                                 ((0x001FFFE0&(data))>>5)
+#define DEBLK_RVDBPAR0_get_mvd(data)                                                 ((0x001FFFE0&(data))>>5)
+#define DEBLK_RVDBPAR0_QP_shift                                                      (0)
+#define DEBLK_RVDBPAR0_QP_mask                                                       (0x0000001F)
+#define DEBLK_RVDBPAR0_QP(data)                                                      (0x0000001F&((data)<<0))
+#define DEBLK_RVDBPAR0_QP_src(data)                                                  ((0x0000001F&(data))>>0)
+#define DEBLK_RVDBPAR0_get_QP(data)                                                  ((0x0000001F&(data))>>0)
+
+
+#define DEBLK_RVDBPAR1                                                               0x1800EA70
+#define DEBLK_RVDBPAR1_reg_addr                                                      "0xB800EA70"
+#define DEBLK_RVDBPAR1_reg                                                           0xB800EA70
+#define set_DEBLK_RVDBPAR1_reg(data)   (*((volatile unsigned int*) DEBLK_RVDBPAR1_reg)=data)
+#define get_DEBLK_RVDBPAR1_reg   (*((volatile unsigned int*) DEBLK_RVDBPAR1_reg))
+#define DEBLK_RVDBPAR1_inst_adr                                                      "0x009C"
+#define DEBLK_RVDBPAR1_inst                                                          0x009C
+#define DEBLK_RVDBPAR1_up_mvd_mod_shift                                              (13)
+#define DEBLK_RVDBPAR1_up_mvd_mod_mask                                               (0x0001E000)
+#define DEBLK_RVDBPAR1_up_mvd_mod(data)                                              (0x0001E000&((data)<<13))
+#define DEBLK_RVDBPAR1_up_mvd_mod_src(data)                                          ((0x0001E000&(data))>>13)
+#define DEBLK_RVDBPAR1_get_up_mvd_mod(data)                                          ((0x0001E000&(data))>>13)
+#define DEBLK_RVDBPAR1_left_mvd_mod_shift                                            (9)
+#define DEBLK_RVDBPAR1_left_mvd_mod_mask                                             (0x00001E00)
+#define DEBLK_RVDBPAR1_left_mvd_mod(data)                                            (0x00001E00&((data)<<9))
+#define DEBLK_RVDBPAR1_left_mvd_mod_src(data)                                        ((0x00001E00&(data))>>9)
+#define DEBLK_RVDBPAR1_get_left_mvd_mod(data)                                        ((0x00001E00&(data))>>9)
+#define DEBLK_RVDBPAR1_Ul_str_eq2_shift                                              (8)
+#define DEBLK_RVDBPAR1_Ul_str_eq2_mask                                               (0x00000100)
+#define DEBLK_RVDBPAR1_Ul_str_eq2(data)                                              (0x00000100&((data)<<8))
+#define DEBLK_RVDBPAR1_Ul_str_eq2_src(data)                                          ((0x00000100&(data))>>8)
+#define DEBLK_RVDBPAR1_get_Ul_str_eq2(data)                                          ((0x00000100&(data))>>8)
+#define DEBLK_RVDBPAR1_Up_str_eq2_shift                                              (7)
+#define DEBLK_RVDBPAR1_Up_str_eq2_mask                                               (0x00000080)
+#define DEBLK_RVDBPAR1_Up_str_eq2(data)                                              (0x00000080&((data)<<7))
+#define DEBLK_RVDBPAR1_Up_str_eq2_src(data)                                          ((0x00000080&(data))>>7)
+#define DEBLK_RVDBPAR1_get_Up_str_eq2(data)                                          ((0x00000080&(data))>>7)
+#define DEBLK_RVDBPAR1_Left_str_eq2_shift                                            (6)
+#define DEBLK_RVDBPAR1_Left_str_eq2_mask                                             (0x00000040)
+#define DEBLK_RVDBPAR1_Left_str_eq2(data)                                            (0x00000040&((data)<<6))
+#define DEBLK_RVDBPAR1_Left_str_eq2_src(data)                                        ((0x00000040&(data))>>6)
+#define DEBLK_RVDBPAR1_get_Left_str_eq2(data)                                        ((0x00000040&(data))>>6)
+#define DEBLK_RVDBPAR1_Cur_str_eq2_shift                                             (5)
+#define DEBLK_RVDBPAR1_Cur_str_eq2_mask                                              (0x00000020)
+#define DEBLK_RVDBPAR1_Cur_str_eq2(data)                                             (0x00000020&((data)<<5))
+#define DEBLK_RVDBPAR1_Cur_str_eq2_src(data)                                         ((0x00000020&(data))>>5)
+#define DEBLK_RVDBPAR1_get_Cur_str_eq2(data)                                         ((0x00000020&(data))>>5)
+#define DEBLK_RVDBPAR1_up_ul_refdiff_shift                                           (4)
+#define DEBLK_RVDBPAR1_up_ul_refdiff_mask                                            (0x00000010)
+#define DEBLK_RVDBPAR1_up_ul_refdiff(data)                                           (0x00000010&((data)<<4))
+#define DEBLK_RVDBPAR1_up_ul_refdiff_src(data)                                       ((0x00000010&(data))>>4)
+#define DEBLK_RVDBPAR1_get_up_ul_refdiff(data)                                       ((0x00000010&(data))>>4)
+#define DEBLK_RVDBPAR1_left_ul_refdiff_shift                                         (3)
+#define DEBLK_RVDBPAR1_left_ul_refdiff_mask                                          (0x00000008)
+#define DEBLK_RVDBPAR1_left_ul_refdiff(data)                                         (0x00000008&((data)<<3))
+#define DEBLK_RVDBPAR1_left_ul_refdiff_src(data)                                     ((0x00000008&(data))>>3)
+#define DEBLK_RVDBPAR1_get_left_ul_refdiff(data)                                     ((0x00000008&(data))>>3)
+#define DEBLK_RVDBPAR1_cur_l_refdiff_shift                                           (2)
+#define DEBLK_RVDBPAR1_cur_l_refdiff_mask                                            (0x00000004)
+#define DEBLK_RVDBPAR1_cur_l_refdiff(data)                                           (0x00000004&((data)<<2))
+#define DEBLK_RVDBPAR1_cur_l_refdiff_src(data)                                       ((0x00000004&(data))>>2)
+#define DEBLK_RVDBPAR1_get_cur_l_refdiff(data)                                       ((0x00000004&(data))>>2)
+#define DEBLK_RVDBPAR1_cur_up_refdiff_shift                                          (1)
+#define DEBLK_RVDBPAR1_cur_up_refdiff_mask                                           (0x00000002)
+#define DEBLK_RVDBPAR1_cur_up_refdiff(data)                                          (0x00000002&((data)<<1))
+#define DEBLK_RVDBPAR1_cur_up_refdiff_src(data)                                      ((0x00000002&(data))>>1)
+#define DEBLK_RVDBPAR1_get_cur_up_refdiff(data)                                      ((0x00000002&(data))>>1)
+#define DEBLK_RVDBPAR1_up_cur_refdiff_shift                                          (0)
+#define DEBLK_RVDBPAR1_up_cur_refdiff_mask                                           (0x00000001)
+#define DEBLK_RVDBPAR1_up_cur_refdiff(data)                                          (0x00000001&((data)<<0))
+#define DEBLK_RVDBPAR1_up_cur_refdiff_src(data)                                      ((0x00000001&(data))>>0)
+#define DEBLK_RVDBPAR1_get_up_cur_refdiff(data)                                      ((0x00000001&(data))>>0)
+
+
+#define DEBLK_RV9CLIP                                                                0x1800EA74
+#define DEBLK_RV9CLIP_reg_addr                                                       "0xB800EA74"
+#define DEBLK_RV9CLIP_reg                                                            0xB800EA74
+#define set_DEBLK_RV9CLIP_reg(data)   (*((volatile unsigned int*) DEBLK_RV9CLIP_reg)=data)
+#define get_DEBLK_RV9CLIP_reg   (*((volatile unsigned int*) DEBLK_RV9CLIP_reg))
+#define DEBLK_RV9CLIP_inst_adr                                                       "0x009D"
+#define DEBLK_RV9CLIP_inst                                                           0x009D
+#define DEBLK_RV9CLIP_Subblk2Clip_ch_shift                                           (1)
+#define DEBLK_RV9CLIP_Subblk2Clip_ch_mask                                            (0x00000002)
+#define DEBLK_RV9CLIP_Subblk2Clip_ch(data)                                           (0x00000002&((data)<<1))
+#define DEBLK_RV9CLIP_Subblk2Clip_ch_src(data)                                       ((0x00000002&(data))>>1)
+#define DEBLK_RV9CLIP_get_Subblk2Clip_ch(data)                                       ((0x00000002&(data))>>1)
+#define DEBLK_RV9CLIP_Subblk12Clip_lu_shift                                          (0)
+#define DEBLK_RV9CLIP_Subblk12Clip_lu_mask                                           (0x00000001)
+#define DEBLK_RV9CLIP_Subblk12Clip_lu(data)                                          (0x00000001&((data)<<0))
+#define DEBLK_RV9CLIP_Subblk12Clip_lu_src(data)                                      ((0x00000001&(data))>>0)
+#define DEBLK_RV9CLIP_get_Subblk12Clip_lu(data)                                      ((0x00000001&(data))>>0)
+
+
+#define DEBLK_WMV8DBPAR_0                                                            0x1800EA78
+#define DEBLK_WMV8DBPAR_1                                                            0x1800EA7C
+#define DEBLK_WMV8DBPAR_0_reg_addr                                                   "0xB800EA78"
+#define DEBLK_WMV8DBPAR_1_reg_addr                                                   "0xB800EA7C"
+#define DEBLK_WMV8DBPAR_0_reg                                                        0xB800EA78
+#define DEBLK_WMV8DBPAR_1_reg                                                        0xB800EA7C
+#define set_DEBLK_WMV8DBPAR_0_reg(data)   (*((volatile unsigned int*) DEBLK_WMV8DBPAR_0_reg)=data)
+#define set_DEBLK_WMV8DBPAR_1_reg(data)   (*((volatile unsigned int*) DEBLK_WMV8DBPAR_1_reg)=data)
+#define get_DEBLK_WMV8DBPAR_0_reg   (*((volatile unsigned int*) DEBLK_WMV8DBPAR_0_reg))
+#define get_DEBLK_WMV8DBPAR_1_reg   (*((volatile unsigned int*) DEBLK_WMV8DBPAR_1_reg))
+#define DEBLK_WMV8DBPAR_0_inst_adr                                                   "0x009E"
+#define DEBLK_WMV8DBPAR_1_inst_adr                                                   "0x009F"
+#define DEBLK_WMV8DBPAR_0_inst                                                       0x009E
+#define DEBLK_WMV8DBPAR_1_inst                                                       0x009F
+#define DEBLK_WMV8DBPAR_is_skip_shift                                                (10)
+#define DEBLK_WMV8DBPAR_is_skip_mask                                                 (0x00000400)
+#define DEBLK_WMV8DBPAR_is_skip(data)                                                (0x00000400&((data)<<10))
+#define DEBLK_WMV8DBPAR_is_skip_src(data)                                            ((0x00000400&(data))>>10)
+#define DEBLK_WMV8DBPAR_get_is_skip(data)                                            ((0x00000400&(data))>>10)
+#define DEBLK_WMV8DBPAR_Qpch_shift                                                   (5)
+#define DEBLK_WMV8DBPAR_Qpch_mask                                                    (0x000003E0)
+#define DEBLK_WMV8DBPAR_Qpch(data)                                                   (0x000003E0&((data)<<5))
+#define DEBLK_WMV8DBPAR_Qpch_src(data)                                               ((0x000003E0&(data))>>5)
+#define DEBLK_WMV8DBPAR_get_Qpch(data)                                               ((0x000003E0&(data))>>5)
+#define DEBLK_WMV8DBPAR_Qpy_shift                                                    (0)
+#define DEBLK_WMV8DBPAR_Qpy_mask                                                     (0x0000001F)
+#define DEBLK_WMV8DBPAR_Qpy(data)                                                    (0x0000001F&((data)<<0))
+#define DEBLK_WMV8DBPAR_Qpy_src(data)                                                ((0x0000001F&(data))>>0)
+#define DEBLK_WMV8DBPAR_get_Qpy(data)                                                ((0x0000001F&(data))>>0)
+
+
+#define DEBLK_VMADRBA                                                                0x1800EA80
+#define DEBLK_VMADRBA_reg_addr                                                       "0xB800EA80"
+#define DEBLK_VMADRBA_reg                                                            0xB800EA80
+#define set_DEBLK_VMADRBA_reg(data)   (*((volatile unsigned int*) DEBLK_VMADRBA_reg)=data)
+#define get_DEBLK_VMADRBA_reg   (*((volatile unsigned int*) DEBLK_VMADRBA_reg))
+#define DEBLK_VMADRBA_inst_adr                                                       "0x00A0"
+#define DEBLK_VMADRBA_inst                                                           0x00A0
+#define DEBLK_VMADRBA_BaseA0_shift                                                   (7)
+#define DEBLK_VMADRBA_BaseA0_mask                                                    (0x00003F80)
+#define DEBLK_VMADRBA_BaseA0(data)                                                   (0x00003F80&((data)<<7))
+#define DEBLK_VMADRBA_BaseA0_src(data)                                               ((0x00003F80&(data))>>7)
+#define DEBLK_VMADRBA_get_BaseA0(data)                                               ((0x00003F80&(data))>>7)
+#define DEBLK_VMADRBA_BaseA1_shift                                                   (0)
+#define DEBLK_VMADRBA_BaseA1_mask                                                    (0x0000007F)
+#define DEBLK_VMADRBA_BaseA1(data)                                                   (0x0000007F&((data)<<0))
+#define DEBLK_VMADRBA_BaseA1_src(data)                                               ((0x0000007F&(data))>>0)
+#define DEBLK_VMADRBA_get_BaseA1(data)                                               ((0x0000007F&(data))>>0)
+
+
+#define DEBLK_VMADROA                                                                0x1800EA84
+#define DEBLK_VMADROA_reg_addr                                                       "0xB800EA84"
+#define DEBLK_VMADROA_reg                                                            0xB800EA84
+#define set_DEBLK_VMADROA_reg(data)   (*((volatile unsigned int*) DEBLK_VMADROA_reg)=data)
+#define get_DEBLK_VMADROA_reg   (*((volatile unsigned int*) DEBLK_VMADROA_reg))
+#define DEBLK_VMADROA_inst_adr                                                       "0x00A1"
+#define DEBLK_VMADROA_inst                                                           0x00A1
+#define DEBLK_VMADROA_OffsetA0_shift                                                 (14)
+#define DEBLK_VMADROA_OffsetA0_mask                                                  (0x001FC000)
+#define DEBLK_VMADROA_OffsetA0(data)                                                 (0x001FC000&((data)<<14))
+#define DEBLK_VMADROA_OffsetA0_src(data)                                             ((0x001FC000&(data))>>14)
+#define DEBLK_VMADROA_get_OffsetA0(data)                                             ((0x001FC000&(data))>>14)
+#define DEBLK_VMADROA_OffsetA1_shift                                                 (7)
+#define DEBLK_VMADROA_OffsetA1_mask                                                  (0x00003F80)
+#define DEBLK_VMADROA_OffsetA1(data)                                                 (0x00003F80&((data)<<7))
+#define DEBLK_VMADROA_OffsetA1_src(data)                                             ((0x00003F80&(data))>>7)
+#define DEBLK_VMADROA_get_OffsetA1(data)                                             ((0x00003F80&(data))>>7)
+#define DEBLK_VMADROA_OffsetA2_shift                                                 (0)
+#define DEBLK_VMADROA_OffsetA2_mask                                                  (0x0000007F)
+#define DEBLK_VMADROA_OffsetA2(data)                                                 (0x0000007F&((data)<<0))
+#define DEBLK_VMADROA_OffsetA2_src(data)                                             ((0x0000007F&(data))>>0)
+#define DEBLK_VMADROA_get_OffsetA2(data)                                             ((0x0000007F&(data))>>0)
+
+
+#define DEBLK_DEBSBCTL                                                               0x1800EA88
+#define DEBLK_DEBSBCTL_reg_addr                                                      "0xB800EA88"
+#define DEBLK_DEBSBCTL_reg                                                           0xB800EA88
+#define set_DEBLK_DEBSBCTL_reg(data)   (*((volatile unsigned int*) DEBLK_DEBSBCTL_reg)=data)
+#define get_DEBLK_DEBSBCTL_reg   (*((volatile unsigned int*) DEBLK_DEBSBCTL_reg))
+#define DEBLK_DEBSBCTL_inst_adr                                                      "0x00A2"
+#define DEBLK_DEBSBCTL_inst                                                          0x00A2
+#define DEBLK_DEBSBCTL_Sb_load_disable_shift                                         (0)
+#define DEBLK_DEBSBCTL_Sb_load_disable_mask                                          (0x00000007)
+#define DEBLK_DEBSBCTL_Sb_load_disable(data)                                         (0x00000007&((data)<<0))
+#define DEBLK_DEBSBCTL_Sb_load_disable_src(data)                                     ((0x00000007&(data))>>0)
+#define DEBLK_DEBSBCTL_get_Sb_load_disable(data)                                     ((0x00000007&(data))>>0)
+
+
+#define DEBLK_DMACTRL                                                                0x1800EA8C
+#define DEBLK_DMACTRL_reg_addr                                                       "0xB800EA8C"
+#define DEBLK_DMACTRL_reg                                                            0xB800EA8C
+#define set_DEBLK_DMACTRL_reg(data)   (*((volatile unsigned int*) DEBLK_DMACTRL_reg)=data)
+#define get_DEBLK_DMACTRL_reg   (*((volatile unsigned int*) DEBLK_DMACTRL_reg))
+#define DEBLK_DMACTRL_inst_adr                                                       "0x00A3"
+#define DEBLK_DMACTRL_inst                                                           0x00A3
+#define DEBLK_DMACTRL_bot_sb_st_disable_shift                                        (5)
+#define DEBLK_DMACTRL_bot_sb_st_disable_mask                                         (0x00000020)
+#define DEBLK_DMACTRL_bot_sb_st_disable(data)                                        (0x00000020&((data)<<5))
+#define DEBLK_DMACTRL_bot_sb_st_disable_src(data)                                    ((0x00000020&(data))>>5)
+#define DEBLK_DMACTRL_get_bot_sb_st_disable(data)                                    ((0x00000020&(data))>>5)
+#define DEBLK_DMACTRL_post_write_disable_shift                                       (4)
+#define DEBLK_DMACTRL_post_write_disable_mask                                        (0x00000010)
+#define DEBLK_DMACTRL_post_write_disable(data)                                       (0x00000010&((data)<<4))
+#define DEBLK_DMACTRL_post_write_disable_src(data)                                   ((0x00000010&(data))>>4)
+#define DEBLK_DMACTRL_get_post_write_disable(data)                                   ((0x00000010&(data))>>4)
+#define DEBLK_DMACTRL_dma_idle_shift                                                 (3)
+#define DEBLK_DMACTRL_dma_idle_mask                                                  (0x00000008)
+#define DEBLK_DMACTRL_dma_idle(data)                                                 (0x00000008&((data)<<3))
+#define DEBLK_DMACTRL_dma_idle_src(data)                                             ((0x00000008&(data))>>3)
+#define DEBLK_DMACTRL_get_dma_idle(data)                                             ((0x00000008&(data))>>3)
+#define DEBLK_DMACTRL_go_shift                                                       (2)
+#define DEBLK_DMACTRL_go_mask                                                        (0x00000004)
+#define DEBLK_DMACTRL_go(data)                                                       (0x00000004&((data)<<2))
+#define DEBLK_DMACTRL_go_src(data)                                                   ((0x00000004&(data))>>2)
+#define DEBLK_DMACTRL_get_go(data)                                                   ((0x00000004&(data))>>2)
+#define DEBLK_DMACTRL_klm_addr_update_shift                                          (1)
+#define DEBLK_DMACTRL_klm_addr_update_mask                                           (0x00000002)
+#define DEBLK_DMACTRL_klm_addr_update(data)                                          (0x00000002&((data)<<1))
+#define DEBLK_DMACTRL_klm_addr_update_src(data)                                      ((0x00000002&(data))>>1)
+#define DEBLK_DMACTRL_get_klm_addr_update(data)                                      ((0x00000002&(data))>>1)
+#define DEBLK_DMACTRL_km_addr_update_shift                                           (0)
+#define DEBLK_DMACTRL_km_addr_update_mask                                            (0x00000001)
+#define DEBLK_DMACTRL_km_addr_update(data)                                           (0x00000001&((data)<<0))
+#define DEBLK_DMACTRL_km_addr_update_src(data)                                       ((0x00000001&(data))>>0)
+#define DEBLK_DMACTRL_get_km_addr_update(data)                                       ((0x00000001&(data))>>0)
+
+
+#define DEBLK_DMALU                                                                  0x1800EA90
+#define DEBLK_DMALU_reg_addr                                                         "0xB800EA90"
+#define DEBLK_DMALU_reg                                                              0xB800EA90
+#define set_DEBLK_DMALU_reg(data)   (*((volatile unsigned int*) DEBLK_DMALU_reg)=data)
+#define get_DEBLK_DMALU_reg   (*((volatile unsigned int*) DEBLK_DMALU_reg))
+#define DEBLK_DMALU_inst_adr                                                         "0x00A4"
+#define DEBLK_DMALU_inst                                                             0x00A4
+#define DEBLK_DMALU_lu_addr_idx_shift                                                (25)
+#define DEBLK_DMALU_lu_addr_idx_mask                                                 (0xFE000000)
+#define DEBLK_DMALU_lu_addr_idx(data)                                                (0xFE000000&((data)<<25))
+#define DEBLK_DMALU_lu_addr_idx_src(data)                                            ((0xFE000000&(data))>>25)
+#define DEBLK_DMALU_get_lu_addr_idx(data)                                            ((0xFE000000&(data))>>25)
+#define DEBLK_DMALU_klm_lu_x_sel_shift                                               (24)
+#define DEBLK_DMALU_klm_lu_x_sel_mask                                                (0x01000000)
+#define DEBLK_DMALU_klm_lu_x_sel(data)                                               (0x01000000&((data)<<24))
+#define DEBLK_DMALU_klm_lu_x_sel_src(data)                                           ((0x01000000&(data))>>24)
+#define DEBLK_DMALU_get_klm_lu_x_sel(data)                                           ((0x01000000&(data))>>24)
+#define DEBLK_DMALU_klm_lu_top_row_inc_shift                                         (18)
+#define DEBLK_DMALU_klm_lu_top_row_inc_mask                                          (0x00FC0000)
+#define DEBLK_DMALU_klm_lu_top_row_inc(data)                                         (0x00FC0000&((data)<<18))
+#define DEBLK_DMALU_klm_lu_top_row_inc_src(data)                                     ((0x00FC0000&(data))>>18)
+#define DEBLK_DMALU_get_klm_lu_top_row_inc(data)                                     ((0x00FC0000&(data))>>18)
+#define DEBLK_DMALU_klm_lu_inc_shift                                                 (12)
+#define DEBLK_DMALU_klm_lu_inc_mask                                                  (0x0003F000)
+#define DEBLK_DMALU_klm_lu_inc(data)                                                 (0x0003F000&((data)<<12))
+#define DEBLK_DMALU_klm_lu_inc_src(data)                                             ((0x0003F000&(data))>>12)
+#define DEBLK_DMALU_get_klm_lu_inc(data)                                             ((0x0003F000&(data))>>12)
+#define DEBLK_DMALU_km_lu_mb_offset_shift                                            (6)
+#define DEBLK_DMALU_km_lu_mb_offset_mask                                             (0x00000FC0)
+#define DEBLK_DMALU_km_lu_mb_offset(data)                                            (0x00000FC0&((data)<<6))
+#define DEBLK_DMALU_km_lu_mb_offset_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DEBLK_DMALU_get_km_lu_mb_offset(data)                                        ((0x00000FC0&(data))>>6)
+#define DEBLK_DMALU_km_lu_row_offset_shift                                           (0)
+#define DEBLK_DMALU_km_lu_row_offset_mask                                            (0x0000003F)
+#define DEBLK_DMALU_km_lu_row_offset(data)                                           (0x0000003F&((data)<<0))
+#define DEBLK_DMALU_km_lu_row_offset_src(data)                                       ((0x0000003F&(data))>>0)
+#define DEBLK_DMALU_get_km_lu_row_offset(data)                                       ((0x0000003F&(data))>>0)
+
+
+#define DEBLK_DMACH                                                                  0x1800EA94
+#define DEBLK_DMACH_reg_addr                                                         "0xB800EA94"
+#define DEBLK_DMACH_reg                                                              0xB800EA94
+#define set_DEBLK_DMACH_reg(data)   (*((volatile unsigned int*) DEBLK_DMACH_reg)=data)
+#define get_DEBLK_DMACH_reg   (*((volatile unsigned int*) DEBLK_DMACH_reg))
+#define DEBLK_DMACH_inst_adr                                                         "0x00A5"
+#define DEBLK_DMACH_inst                                                             0x00A5
+#define DEBLK_DMACH_ch_addr_idx_shift                                                (25)
+#define DEBLK_DMACH_ch_addr_idx_mask                                                 (0xFE000000)
+#define DEBLK_DMACH_ch_addr_idx(data)                                                (0xFE000000&((data)<<25))
+#define DEBLK_DMACH_ch_addr_idx_src(data)                                            ((0xFE000000&(data))>>25)
+#define DEBLK_DMACH_get_ch_addr_idx(data)                                            ((0xFE000000&(data))>>25)
+#define DEBLK_DMACH_klm_ch_x_sel_shift                                               (24)
+#define DEBLK_DMACH_klm_ch_x_sel_mask                                                (0x01000000)
+#define DEBLK_DMACH_klm_ch_x_sel(data)                                               (0x01000000&((data)<<24))
+#define DEBLK_DMACH_klm_ch_x_sel_src(data)                                           ((0x01000000&(data))>>24)
+#define DEBLK_DMACH_get_klm_ch_x_sel(data)                                           ((0x01000000&(data))>>24)
+#define DEBLK_DMACH_klm_ch_top_row_inc_shift                                         (18)
+#define DEBLK_DMACH_klm_ch_top_row_inc_mask                                          (0x00FC0000)
+#define DEBLK_DMACH_klm_ch_top_row_inc(data)                                         (0x00FC0000&((data)<<18))
+#define DEBLK_DMACH_klm_ch_top_row_inc_src(data)                                     ((0x00FC0000&(data))>>18)
+#define DEBLK_DMACH_get_klm_ch_top_row_inc(data)                                     ((0x00FC0000&(data))>>18)
+#define DEBLK_DMACH_klm_ch_inc_shift                                                 (12)
+#define DEBLK_DMACH_klm_ch_inc_mask                                                  (0x0003F000)
+#define DEBLK_DMACH_klm_ch_inc(data)                                                 (0x0003F000&((data)<<12))
+#define DEBLK_DMACH_klm_ch_inc_src(data)                                             ((0x0003F000&(data))>>12)
+#define DEBLK_DMACH_get_klm_ch_inc(data)                                             ((0x0003F000&(data))>>12)
+#define DEBLK_DMACH_km_ch_mb_offset_shift                                            (6)
+#define DEBLK_DMACH_km_ch_mb_offset_mask                                             (0x00000FC0)
+#define DEBLK_DMACH_km_ch_mb_offset(data)                                            (0x00000FC0&((data)<<6))
+#define DEBLK_DMACH_km_ch_mb_offset_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DEBLK_DMACH_get_km_ch_mb_offset(data)                                        ((0x00000FC0&(data))>>6)
+#define DEBLK_DMACH_km_ch_row_offset_shift                                           (0)
+#define DEBLK_DMACH_km_ch_row_offset_mask                                            (0x0000003F)
+#define DEBLK_DMACH_km_ch_row_offset(data)                                           (0x0000003F&((data)<<0))
+#define DEBLK_DMACH_km_ch_row_offset_src(data)                                       ((0x0000003F&(data))>>0)
+#define DEBLK_DMACH_get_km_ch_row_offset(data)                                       ((0x0000003F&(data))>>0)
+
+
+#define DEBLK_DMAWH                                                                  0x1800EA98
+#define DEBLK_DMAWH_reg_addr                                                         "0xB800EA98"
+#define DEBLK_DMAWH_reg                                                              0xB800EA98
+#define set_DEBLK_DMAWH_reg(data)   (*((volatile unsigned int*) DEBLK_DMAWH_reg)=data)
+#define get_DEBLK_DMAWH_reg   (*((volatile unsigned int*) DEBLK_DMAWH_reg))
+#define DEBLK_DMAWH_inst_adr                                                         "0x00A6"
+#define DEBLK_DMAWH_inst                                                             0x00A6
+#define DEBLK_DMAWH_klm_ch_h_shift                                                   (19)
+#define DEBLK_DMAWH_klm_ch_h_mask                                                    (0x00F80000)
+#define DEBLK_DMAWH_klm_ch_h(data)                                                   (0x00F80000&((data)<<19))
+#define DEBLK_DMAWH_klm_ch_h_src(data)                                               ((0x00F80000&(data))>>19)
+#define DEBLK_DMAWH_get_klm_ch_h(data)                                               ((0x00F80000&(data))>>19)
+#define DEBLK_DMAWH_klm_ch_w_shift                                                   (18)
+#define DEBLK_DMAWH_klm_ch_w_mask                                                    (0x00040000)
+#define DEBLK_DMAWH_klm_ch_w(data)                                                   (0x00040000&((data)<<18))
+#define DEBLK_DMAWH_klm_ch_w_src(data)                                               ((0x00040000&(data))>>18)
+#define DEBLK_DMAWH_get_klm_ch_w(data)                                               ((0x00040000&(data))>>18)
+#define DEBLK_DMAWH_klm_lu_h_shift                                                   (12)
+#define DEBLK_DMAWH_klm_lu_h_mask                                                    (0x0003F000)
+#define DEBLK_DMAWH_klm_lu_h(data)                                                   (0x0003F000&((data)<<12))
+#define DEBLK_DMAWH_klm_lu_h_src(data)                                               ((0x0003F000&(data))>>12)
+#define DEBLK_DMAWH_get_klm_lu_h(data)                                               ((0x0003F000&(data))>>12)
+#define DEBLK_DMAWH_klm_lu_w_shift                                                   (11)
+#define DEBLK_DMAWH_klm_lu_w_mask                                                    (0x00000800)
+#define DEBLK_DMAWH_klm_lu_w(data)                                                   (0x00000800&((data)<<11))
+#define DEBLK_DMAWH_klm_lu_w_src(data)                                               ((0x00000800&(data))>>11)
+#define DEBLK_DMAWH_get_klm_lu_w(data)                                               ((0x00000800&(data))>>11)
+#define DEBLK_DMAWH_km_ch_h_shift                                                    (7)
+#define DEBLK_DMAWH_km_ch_h_mask                                                     (0x00000780)
+#define DEBLK_DMAWH_km_ch_h(data)                                                    (0x00000780&((data)<<7))
+#define DEBLK_DMAWH_km_ch_h_src(data)                                                ((0x00000780&(data))>>7)
+#define DEBLK_DMAWH_get_km_ch_h(data)                                                ((0x00000780&(data))>>7)
+#define DEBLK_DMAWH_km_ch_w_shift                                                    (6)
+#define DEBLK_DMAWH_km_ch_w_mask                                                     (0x00000040)
+#define DEBLK_DMAWH_km_ch_w(data)                                                    (0x00000040&((data)<<6))
+#define DEBLK_DMAWH_km_ch_w_src(data)                                                ((0x00000040&(data))>>6)
+#define DEBLK_DMAWH_get_km_ch_w(data)                                                ((0x00000040&(data))>>6)
+#define DEBLK_DMAWH_km_lu_h_shift                                                    (1)
+#define DEBLK_DMAWH_km_lu_h_mask                                                     (0x0000003E)
+#define DEBLK_DMAWH_km_lu_h(data)                                                    (0x0000003E&((data)<<1))
+#define DEBLK_DMAWH_km_lu_h_src(data)                                                ((0x0000003E&(data))>>1)
+#define DEBLK_DMAWH_get_km_lu_h(data)                                                ((0x0000003E&(data))>>1)
+#define DEBLK_DMAWH_km_lu_w_shift                                                    (0)
+#define DEBLK_DMAWH_km_lu_w_mask                                                     (0x00000001)
+#define DEBLK_DMAWH_km_lu_w(data)                                                    (0x00000001&((data)<<0))
+#define DEBLK_DMAWH_km_lu_w_src(data)                                                ((0x00000001&(data))>>0)
+#define DEBLK_DMAWH_get_km_lu_w(data)                                                ((0x00000001&(data))>>0)
+
+
+#define DEBLK_DMAADR_0                                                               0x1800EA9C
+#define DEBLK_DMAADR_1                                                               0x1800EAA0
+#define DEBLK_DMAADR_2                                                               0x1800EAA4
+#define DEBLK_DMAADR_3                                                               0x1800EAA8
+#define DEBLK_DMAADR_4                                                               0x1800EAAC
+#define DEBLK_DMAADR_5                                                               0x1800EAB0
+#define DEBLK_DMAADR_0_reg_addr                                                      "0xB800EA9C"
+#define DEBLK_DMAADR_1_reg_addr                                                      "0xB800EAA0"
+#define DEBLK_DMAADR_2_reg_addr                                                      "0xB800EAA4"
+#define DEBLK_DMAADR_3_reg_addr                                                      "0xB800EAA8"
+#define DEBLK_DMAADR_4_reg_addr                                                      "0xB800EAAC"
+#define DEBLK_DMAADR_5_reg_addr                                                      "0xB800EAB0"
+#define DEBLK_DMAADR_0_reg                                                           0xB800EA9C
+#define DEBLK_DMAADR_1_reg                                                           0xB800EAA0
+#define DEBLK_DMAADR_2_reg                                                           0xB800EAA4
+#define DEBLK_DMAADR_3_reg                                                           0xB800EAA8
+#define DEBLK_DMAADR_4_reg                                                           0xB800EAAC
+#define DEBLK_DMAADR_5_reg                                                           0xB800EAB0
+#define set_DEBLK_DMAADR_0_reg(data)   (*((volatile unsigned int*) DEBLK_DMAADR_0_reg)=data)
+#define set_DEBLK_DMAADR_1_reg(data)   (*((volatile unsigned int*) DEBLK_DMAADR_1_reg)=data)
+#define set_DEBLK_DMAADR_2_reg(data)   (*((volatile unsigned int*) DEBLK_DMAADR_2_reg)=data)
+#define set_DEBLK_DMAADR_3_reg(data)   (*((volatile unsigned int*) DEBLK_DMAADR_3_reg)=data)
+#define set_DEBLK_DMAADR_4_reg(data)   (*((volatile unsigned int*) DEBLK_DMAADR_4_reg)=data)
+#define set_DEBLK_DMAADR_5_reg(data)   (*((volatile unsigned int*) DEBLK_DMAADR_5_reg)=data)
+#define get_DEBLK_DMAADR_0_reg   (*((volatile unsigned int*) DEBLK_DMAADR_0_reg))
+#define get_DEBLK_DMAADR_1_reg   (*((volatile unsigned int*) DEBLK_DMAADR_1_reg))
+#define get_DEBLK_DMAADR_2_reg   (*((volatile unsigned int*) DEBLK_DMAADR_2_reg))
+#define get_DEBLK_DMAADR_3_reg   (*((volatile unsigned int*) DEBLK_DMAADR_3_reg))
+#define get_DEBLK_DMAADR_4_reg   (*((volatile unsigned int*) DEBLK_DMAADR_4_reg))
+#define get_DEBLK_DMAADR_5_reg   (*((volatile unsigned int*) DEBLK_DMAADR_5_reg))
+#define DEBLK_DMAADR_0_inst_adr                                                      "0x00A7"
+#define DEBLK_DMAADR_1_inst_adr                                                      "0x00A8"
+#define DEBLK_DMAADR_2_inst_adr                                                      "0x00A9"
+#define DEBLK_DMAADR_3_inst_adr                                                      "0x00AA"
+#define DEBLK_DMAADR_4_inst_adr                                                      "0x00AB"
+#define DEBLK_DMAADR_5_inst_adr                                                      "0x00AC"
+#define DEBLK_DMAADR_0_inst                                                          0x00A7
+#define DEBLK_DMAADR_1_inst                                                          0x00A8
+#define DEBLK_DMAADR_2_inst                                                          0x00A9
+#define DEBLK_DMAADR_3_inst                                                          0x00AA
+#define DEBLK_DMAADR_4_inst                                                          0x00AB
+#define DEBLK_DMAADR_5_inst                                                          0x00AC
+#define DEBLK_DMAADR_x_shift                                                         (14)
+#define DEBLK_DMAADR_x_mask                                                          (0x07FFC000)
+#define DEBLK_DMAADR_x(data)                                                         (0x07FFC000&((data)<<14))
+#define DEBLK_DMAADR_x_src(data)                                                     ((0x07FFC000&(data))>>14)
+#define DEBLK_DMAADR_get_x(data)                                                     ((0x07FFC000&(data))>>14)
+#define DEBLK_DMAADR_y_shift                                                         (0)
+#define DEBLK_DMAADR_y_mask                                                          (0x00003FFF)
+#define DEBLK_DMAADR_y(data)                                                         (0x00003FFF&((data)<<0))
+#define DEBLK_DMAADR_y_src(data)                                                     ((0x00003FFF&(data))>>0)
+#define DEBLK_DMAADR_get_y(data)                                                     ((0x00003FFF&(data))>>0)
+
+
+#define DEBLK_VP8CTRL                                                                0x1800EAC0
+#define DEBLK_VP8CTRL_reg_addr                                                       "0xB800EAC0"
+#define DEBLK_VP8CTRL_reg                                                            0xB800EAC0
+#define set_DEBLK_VP8CTRL_reg(data)   (*((volatile unsigned int*) DEBLK_VP8CTRL_reg)=data)
+#define get_DEBLK_VP8CTRL_reg   (*((volatile unsigned int*) DEBLK_VP8CTRL_reg))
+#define DEBLK_VP8CTRL_inst_adr                                                       "0x00B0"
+#define DEBLK_VP8CTRL_inst                                                           0x00B0
+#define DEBLK_VP8CTRL_write_enable3_shift                                            (14)
+#define DEBLK_VP8CTRL_write_enable3_mask                                             (0x00004000)
+#define DEBLK_VP8CTRL_write_enable3(data)                                            (0x00004000&((data)<<14))
+#define DEBLK_VP8CTRL_write_enable3_src(data)                                        ((0x00004000&(data))>>14)
+#define DEBLK_VP8CTRL_get_write_enable3(data)                                        ((0x00004000&(data))>>14)
+#define DEBLK_VP8CTRL_last_filter_type_shift                                         (13)
+#define DEBLK_VP8CTRL_last_filter_type_mask                                          (0x00002000)
+#define DEBLK_VP8CTRL_last_filter_type(data)                                         (0x00002000&((data)<<13))
+#define DEBLK_VP8CTRL_last_filter_type_src(data)                                     ((0x00002000&(data))>>13)
+#define DEBLK_VP8CTRL_get_last_filter_type(data)                                     ((0x00002000&(data))>>13)
+#define DEBLK_VP8CTRL_last_sharp_level_shift                                         (10)
+#define DEBLK_VP8CTRL_last_sharp_level_mask                                          (0x00001C00)
+#define DEBLK_VP8CTRL_last_sharp_level(data)                                         (0x00001C00&((data)<<10))
+#define DEBLK_VP8CTRL_last_sharp_level_src(data)                                     ((0x00001C00&(data))>>10)
+#define DEBLK_VP8CTRL_get_last_sharp_level(data)                                     ((0x00001C00&(data))>>10)
+#define DEBLK_VP8CTRL_last_frame_type_shift                                          (9)
+#define DEBLK_VP8CTRL_last_frame_type_mask                                           (0x00000200)
+#define DEBLK_VP8CTRL_last_frame_type(data)                                          (0x00000200&((data)<<9))
+#define DEBLK_VP8CTRL_last_frame_type_src(data)                                      ((0x00000200&(data))>>9)
+#define DEBLK_VP8CTRL_get_last_frame_type(data)                                      ((0x00000200&(data))>>9)
+#define DEBLK_VP8CTRL_write_enable2_shift                                            (8)
+#define DEBLK_VP8CTRL_write_enable2_mask                                             (0x00000100)
+#define DEBLK_VP8CTRL_write_enable2(data)                                            (0x00000100&((data)<<8))
+#define DEBLK_VP8CTRL_write_enable2_src(data)                                        ((0x00000100&(data))>>8)
+#define DEBLK_VP8CTRL_get_write_enable2(data)                                        ((0x00000100&(data))>>8)
+#define DEBLK_VP8CTRL_filter_type_shift                                              (7)
+#define DEBLK_VP8CTRL_filter_type_mask                                               (0x00000080)
+#define DEBLK_VP8CTRL_filter_type(data)                                              (0x00000080&((data)<<7))
+#define DEBLK_VP8CTRL_filter_type_src(data)                                          ((0x00000080&(data))>>7)
+#define DEBLK_VP8CTRL_get_filter_type(data)                                          ((0x00000080&(data))>>7)
+#define DEBLK_VP8CTRL_sharp_level_shift                                              (4)
+#define DEBLK_VP8CTRL_sharp_level_mask                                               (0x00000070)
+#define DEBLK_VP8CTRL_sharp_level(data)                                              (0x00000070&((data)<<4))
+#define DEBLK_VP8CTRL_sharp_level_src(data)                                          ((0x00000070&(data))>>4)
+#define DEBLK_VP8CTRL_get_sharp_level(data)                                          ((0x00000070&(data))>>4)
+#define DEBLK_VP8CTRL_write_enable1_shift                                            (3)
+#define DEBLK_VP8CTRL_write_enable1_mask                                             (0x00000008)
+#define DEBLK_VP8CTRL_write_enable1(data)                                            (0x00000008&((data)<<3))
+#define DEBLK_VP8CTRL_write_enable1_src(data)                                        ((0x00000008&(data))>>3)
+#define DEBLK_VP8CTRL_get_write_enable1(data)                                        ((0x00000008&(data))>>3)
+#define DEBLK_VP8CTRL_lf_delta_enable_shift                                          (2)
+#define DEBLK_VP8CTRL_lf_delta_enable_mask                                           (0x00000004)
+#define DEBLK_VP8CTRL_lf_delta_enable(data)                                          (0x00000004&((data)<<2))
+#define DEBLK_VP8CTRL_lf_delta_enable_src(data)                                      ((0x00000004&(data))>>2)
+#define DEBLK_VP8CTRL_get_lf_delta_enable(data)                                      ((0x00000004&(data))>>2)
+#define DEBLK_VP8CTRL_write_enable0_shift                                            (1)
+#define DEBLK_VP8CTRL_write_enable0_mask                                             (0x00000002)
+#define DEBLK_VP8CTRL_write_enable0(data)                                            (0x00000002&((data)<<1))
+#define DEBLK_VP8CTRL_write_enable0_src(data)                                        ((0x00000002&(data))>>1)
+#define DEBLK_VP8CTRL_get_write_enable0(data)                                        ((0x00000002&(data))>>1)
+#define DEBLK_VP8CTRL_segment_enable_shift                                           (0)
+#define DEBLK_VP8CTRL_segment_enable_mask                                            (0x00000001)
+#define DEBLK_VP8CTRL_segment_enable(data)                                           (0x00000001&((data)<<0))
+#define DEBLK_VP8CTRL_segment_enable_src(data)                                       ((0x00000001&(data))>>0)
+#define DEBLK_VP8CTRL_get_segment_enable(data)                                       ((0x00000001&(data))>>0)
+
+
+#define DEBLK_VP8FILTLVL                                                             0x1800EAC4
+#define DEBLK_VP8FILTLVL_reg_addr                                                    "0xB800EAC4"
+#define DEBLK_VP8FILTLVL_reg                                                         0xB800EAC4
+#define set_DEBLK_VP8FILTLVL_reg(data)   (*((volatile unsigned int*) DEBLK_VP8FILTLVL_reg)=data)
+#define get_DEBLK_VP8FILTLVL_reg   (*((volatile unsigned int*) DEBLK_VP8FILTLVL_reg))
+#define DEBLK_VP8FILTLVL_inst_adr                                                    "0x00B1"
+#define DEBLK_VP8FILTLVL_inst                                                        0x00B1
+#define DEBLK_VP8FILTLVL_base_filt_lvl_3_shift                                       (24)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_3_mask                                        (0x7F000000)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_3(data)                                       (0x7F000000&((data)<<24))
+#define DEBLK_VP8FILTLVL_base_filt_lvl_3_src(data)                                   ((0x7F000000&(data))>>24)
+#define DEBLK_VP8FILTLVL_get_base_filt_lvl_3(data)                                   ((0x7F000000&(data))>>24)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_2_shift                                       (16)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_2_mask                                        (0x007F0000)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_2(data)                                       (0x007F0000&((data)<<16))
+#define DEBLK_VP8FILTLVL_base_filt_lvl_2_src(data)                                   ((0x007F0000&(data))>>16)
+#define DEBLK_VP8FILTLVL_get_base_filt_lvl_2(data)                                   ((0x007F0000&(data))>>16)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_1_shift                                       (8)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_1_mask                                        (0x00007F00)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_1(data)                                       (0x00007F00&((data)<<8))
+#define DEBLK_VP8FILTLVL_base_filt_lvl_1_src(data)                                   ((0x00007F00&(data))>>8)
+#define DEBLK_VP8FILTLVL_get_base_filt_lvl_1(data)                                   ((0x00007F00&(data))>>8)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_0_shift                                       (0)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_0_mask                                        (0x0000007F)
+#define DEBLK_VP8FILTLVL_base_filt_lvl_0(data)                                       (0x0000007F&((data)<<0))
+#define DEBLK_VP8FILTLVL_base_filt_lvl_0_src(data)                                   ((0x0000007F&(data))>>0)
+#define DEBLK_VP8FILTLVL_get_base_filt_lvl_0(data)                                   ((0x0000007F&(data))>>0)
+
+
+#define DEBLK_VP8REFDELTA                                                            0x1800EAC8
+#define DEBLK_VP8REFDELTA_reg_addr                                                   "0xB800EAC8"
+#define DEBLK_VP8REFDELTA_reg                                                        0xB800EAC8
+#define set_DEBLK_VP8REFDELTA_reg(data)   (*((volatile unsigned int*) DEBLK_VP8REFDELTA_reg)=data)
+#define get_DEBLK_VP8REFDELTA_reg   (*((volatile unsigned int*) DEBLK_VP8REFDELTA_reg))
+#define DEBLK_VP8REFDELTA_inst_adr                                                   "0x00B2"
+#define DEBLK_VP8REFDELTA_inst                                                       0x00B2
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_3_shift                                      (24)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_3_mask                                       (0x7F000000)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_3(data)                                      (0x7F000000&((data)<<24))
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_3_src(data)                                  ((0x7F000000&(data))>>24)
+#define DEBLK_VP8REFDELTA_get_ref_lf_deltas_3(data)                                  ((0x7F000000&(data))>>24)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_2_shift                                      (16)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_2_mask                                       (0x007F0000)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_2(data)                                      (0x007F0000&((data)<<16))
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_2_src(data)                                  ((0x007F0000&(data))>>16)
+#define DEBLK_VP8REFDELTA_get_ref_lf_deltas_2(data)                                  ((0x007F0000&(data))>>16)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_1_shift                                      (8)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_1_mask                                       (0x00007F00)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_1(data)                                      (0x00007F00&((data)<<8))
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_1_src(data)                                  ((0x00007F00&(data))>>8)
+#define DEBLK_VP8REFDELTA_get_ref_lf_deltas_1(data)                                  ((0x00007F00&(data))>>8)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_0_shift                                      (0)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_0_mask                                       (0x0000007F)
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_0(data)                                      (0x0000007F&((data)<<0))
+#define DEBLK_VP8REFDELTA_ref_lf_deltas_0_src(data)                                  ((0x0000007F&(data))>>0)
+#define DEBLK_VP8REFDELTA_get_ref_lf_deltas_0(data)                                  ((0x0000007F&(data))>>0)
+
+
+#define DEBLK_VP8MODEDELTA                                                           0x1800EACC
+#define DEBLK_VP8MODEDELTA_reg_addr                                                  "0xB800EACC"
+#define DEBLK_VP8MODEDELTA_reg                                                       0xB800EACC
+#define set_DEBLK_VP8MODEDELTA_reg(data)   (*((volatile unsigned int*) DEBLK_VP8MODEDELTA_reg)=data)
+#define get_DEBLK_VP8MODEDELTA_reg   (*((volatile unsigned int*) DEBLK_VP8MODEDELTA_reg))
+#define DEBLK_VP8MODEDELTA_inst_adr                                                  "0x00B3"
+#define DEBLK_VP8MODEDELTA_inst                                                      0x00B3
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_3_shift                                    (24)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_3_mask                                     (0x7F000000)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_3(data)                                    (0x7F000000&((data)<<24))
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_3_src(data)                                ((0x7F000000&(data))>>24)
+#define DEBLK_VP8MODEDELTA_get_mode_lf_deltas_3(data)                                ((0x7F000000&(data))>>24)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_2_shift                                    (16)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_2_mask                                     (0x007F0000)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_2(data)                                    (0x007F0000&((data)<<16))
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_2_src(data)                                ((0x007F0000&(data))>>16)
+#define DEBLK_VP8MODEDELTA_get_mode_lf_deltas_2(data)                                ((0x007F0000&(data))>>16)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_1_shift                                    (8)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_1_mask                                     (0x00007F00)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_1(data)                                    (0x00007F00&((data)<<8))
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_1_src(data)                                ((0x00007F00&(data))>>8)
+#define DEBLK_VP8MODEDELTA_get_mode_lf_deltas_1(data)                                ((0x00007F00&(data))>>8)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_0_shift                                    (0)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_0_mask                                     (0x0000007F)
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_0(data)                                    (0x0000007F&((data)<<0))
+#define DEBLK_VP8MODEDELTA_mode_lf_deltas_0_src(data)                                ((0x0000007F&(data))>>0)
+#define DEBLK_VP8MODEDELTA_get_mode_lf_deltas_0(data)                                ((0x0000007F&(data))>>0)
+
+
+#define DEBLK_VP8DBPAR                                                               0x1800EAD0
+#define DEBLK_VP8DBPAR_reg_addr                                                      "0xB800EAD0"
+#define DEBLK_VP8DBPAR_reg                                                           0xB800EAD0
+#define set_DEBLK_VP8DBPAR_reg(data)   (*((volatile unsigned int*) DEBLK_VP8DBPAR_reg)=data)
+#define get_DEBLK_VP8DBPAR_reg   (*((volatile unsigned int*) DEBLK_VP8DBPAR_reg))
+#define DEBLK_VP8DBPAR_inst_adr                                                      "0x00B4"
+#define DEBLK_VP8DBPAR_inst                                                          0x00B4
+#define DEBLK_VP8DBPAR_intra_mb_shift                                                (6)
+#define DEBLK_VP8DBPAR_intra_mb_mask                                                 (0x00000040)
+#define DEBLK_VP8DBPAR_intra_mb(data)                                                (0x00000040&((data)<<6))
+#define DEBLK_VP8DBPAR_intra_mb_src(data)                                            ((0x00000040&(data))>>6)
+#define DEBLK_VP8DBPAR_get_intra_mb(data)                                            ((0x00000040&(data))>>6)
+#define DEBLK_VP8DBPAR_eob_total_shift                                               (5)
+#define DEBLK_VP8DBPAR_eob_total_mask                                                (0x00000020)
+#define DEBLK_VP8DBPAR_eob_total(data)                                               (0x00000020&((data)<<5))
+#define DEBLK_VP8DBPAR_eob_total_src(data)                                           ((0x00000020&(data))>>5)
+#define DEBLK_VP8DBPAR_get_eob_total(data)                                           ((0x00000020&(data))>>5)
+#define DEBLK_VP8DBPAR_ref_frame_shift                                               (3)
+#define DEBLK_VP8DBPAR_ref_frame_mask                                                (0x00000018)
+#define DEBLK_VP8DBPAR_ref_frame(data)                                               (0x00000018&((data)<<3))
+#define DEBLK_VP8DBPAR_ref_frame_src(data)                                           ((0x00000018&(data))>>3)
+#define DEBLK_VP8DBPAR_get_ref_frame(data)                                           ((0x00000018&(data))>>3)
+#define DEBLK_VP8DBPAR_mb_mode_shift                                                 (0)
+#define DEBLK_VP8DBPAR_mb_mode_mask                                                  (0x00000007)
+#define DEBLK_VP8DBPAR_mb_mode(data)                                                 (0x00000007&((data)<<0))
+#define DEBLK_VP8DBPAR_mb_mode_src(data)                                             ((0x00000007&(data))>>0)
+#define DEBLK_VP8DBPAR_get_mb_mode(data)                                             ((0x00000007&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/diag.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/diag.h
new file mode 100644
index 00000000..b42046a
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/diag.h
@@ -0,0 +1,20 @@
+#ifndef _DIAG_H_20121212_LUCAS
+#define _DIAG_H_20121212_LUCAS
+#ifdef SCPU_ARM
+
+void diag_fail();
+void diag_pass();
+#else
+void diag_pass() {
+	asm("la   $8, 0x80003000");
+	asm("jr   $8");
+	asm(".align 5; nop");
+}
+
+void diag_fail() {
+	asm("la   $8, 0x80003020");
+	asm("jr   $8");
+	asm(".align 5; nop");
+}
+#endif
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/dp_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/dp_reg.h
new file mode 100644
index 00000000..181b14e
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/dp_reg.h
@@ -0,0 +1,300 @@
+/**************************************************************
+// Spec Version                  : 1.1
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/7/8 10:34:40
+***************************************************************/
+
+
+#ifndef _DP_REG_H_INCLUDED_
+#define _DP_REG_H_INCLUDED_
+#ifdef  _DP_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     secure_state:3;
+}DP_STATE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     cmp_en:1;
+}DP_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     equal:1;
+}DP_PW_STATUS;
+
+typedef struct 
+{
+unsigned int     dat:32;
+}DP_PW;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     uart_tx_disable:1;
+unsigned int     uart_rx_disable:1;
+unsigned int     hif_disable:1;
+unsigned int     jtag_lx_disable:1;
+}DP_DBG_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     bist_drf_test_resume:1;
+unsigned int     bist_drf_en:1;
+unsigned int     bist_en:1;
+}DP_BIST_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     rme:1;
+unsigned int     rm:4;
+}DP_BIST_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     bist_fail0:1;
+unsigned int     bist_done:1;
+}DP_BIST_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_bist_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_bist_fail0:1;
+unsigned int     drf_bist_done:1;
+}DP_DRF_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     rx_off:1;
+unsigned int     tx_off:1;
+}DP_UART_CTL;
+
+#endif
+
+#define DP_STATE                                                                     0x18017800
+#define DP_STATE_reg_addr                                                            "0xB8017800"
+#define DP_STATE_reg                                                                 0xB8017800
+#define set_DP_STATE_reg(data)   (*((volatile unsigned int*) DP_STATE_reg)=data)
+#define get_DP_STATE_reg   (*((volatile unsigned int*) DP_STATE_reg))
+#define DP_STATE_inst_adr                                                            "0x0000"
+#define DP_STATE_inst                                                                0x0000
+#define DP_STATE_secure_state_shift                                                  (0)
+#define DP_STATE_secure_state_mask                                                   (0x00000007)
+#define DP_STATE_secure_state(data)                                                  (0x00000007&((data)<<0))
+#define DP_STATE_secure_state_src(data)                                              ((0x00000007&(data))>>0)
+#define DP_STATE_get_secure_state(data)                                              ((0x00000007&(data))>>0)
+
+
+#define DP_CTRL                                                                      0x18017804
+#define DP_CTRL_reg_addr                                                             "0xB8017804"
+#define DP_CTRL_reg                                                                  0xB8017804
+#define set_DP_CTRL_reg(data)   (*((volatile unsigned int*) DP_CTRL_reg)=data)
+#define get_DP_CTRL_reg   (*((volatile unsigned int*) DP_CTRL_reg))
+#define DP_CTRL_inst_adr                                                             "0x0001"
+#define DP_CTRL_inst                                                                 0x0001
+#define DP_CTRL_cmp_en_shift                                                         (0)
+#define DP_CTRL_cmp_en_mask                                                          (0x00000001)
+#define DP_CTRL_cmp_en(data)                                                         (0x00000001&((data)<<0))
+#define DP_CTRL_cmp_en_src(data)                                                     ((0x00000001&(data))>>0)
+#define DP_CTRL_get_cmp_en(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define DP_PW_STATUS                                                                 0x18017808
+#define DP_PW_STATUS_reg_addr                                                        "0xB8017808"
+#define DP_PW_STATUS_reg                                                             0xB8017808
+#define set_DP_PW_STATUS_reg(data)   (*((volatile unsigned int*) DP_PW_STATUS_reg)=data)
+#define get_DP_PW_STATUS_reg   (*((volatile unsigned int*) DP_PW_STATUS_reg))
+#define DP_PW_STATUS_inst_adr                                                        "0x0002"
+#define DP_PW_STATUS_inst                                                            0x0002
+#define DP_PW_STATUS_equal_shift                                                     (0)
+#define DP_PW_STATUS_equal_mask                                                      (0x00000001)
+#define DP_PW_STATUS_equal(data)                                                     (0x00000001&((data)<<0))
+#define DP_PW_STATUS_equal_src(data)                                                 ((0x00000001&(data))>>0)
+#define DP_PW_STATUS_get_equal(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define DP_PW_0                                                                      0x18017810
+#define DP_PW_1                                                                      0x18017814
+#define DP_PW_2                                                                      0x18017818
+#define DP_PW_3                                                                      0x1801781C
+#define DP_PW_0_reg_addr                                                             "0xB8017810"
+#define DP_PW_1_reg_addr                                                             "0xB8017814"
+#define DP_PW_2_reg_addr                                                             "0xB8017818"
+#define DP_PW_3_reg_addr                                                             "0xB801781C"
+#define DP_PW_0_reg                                                                  0xB8017810
+#define DP_PW_1_reg                                                                  0xB8017814
+#define DP_PW_2_reg                                                                  0xB8017818
+#define DP_PW_3_reg                                                                  0xB801781C
+#define set_DP_PW_0_reg(data)   (*((volatile unsigned int*) DP_PW_0_reg)=data)
+#define set_DP_PW_1_reg(data)   (*((volatile unsigned int*) DP_PW_1_reg)=data)
+#define set_DP_PW_2_reg(data)   (*((volatile unsigned int*) DP_PW_2_reg)=data)
+#define set_DP_PW_3_reg(data)   (*((volatile unsigned int*) DP_PW_3_reg)=data)
+#define get_DP_PW_0_reg   (*((volatile unsigned int*) DP_PW_0_reg))
+#define get_DP_PW_1_reg   (*((volatile unsigned int*) DP_PW_1_reg))
+#define get_DP_PW_2_reg   (*((volatile unsigned int*) DP_PW_2_reg))
+#define get_DP_PW_3_reg   (*((volatile unsigned int*) DP_PW_3_reg))
+#define DP_PW_0_inst_adr                                                             "0x0004"
+#define DP_PW_1_inst_adr                                                             "0x0005"
+#define DP_PW_2_inst_adr                                                             "0x0006"
+#define DP_PW_3_inst_adr                                                             "0x0007"
+#define DP_PW_0_inst                                                                 0x0004
+#define DP_PW_1_inst                                                                 0x0005
+#define DP_PW_2_inst                                                                 0x0006
+#define DP_PW_3_inst                                                                 0x0007
+#define DP_PW_dat_shift                                                              (0)
+#define DP_PW_dat_mask                                                               (0xFFFFFFFF)
+#define DP_PW_dat(data)                                                              (0xFFFFFFFF&((data)<<0))
+#define DP_PW_dat_src(data)                                                          ((0xFFFFFFFF&(data))>>0)
+#define DP_PW_get_dat(data)                                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define DP_DBG_STATUS                                                                0x18017820
+#define DP_DBG_STATUS_reg_addr                                                       "0xB8017820"
+#define DP_DBG_STATUS_reg                                                            0xB8017820
+#define set_DP_DBG_STATUS_reg(data)   (*((volatile unsigned int*) DP_DBG_STATUS_reg)=data)
+#define get_DP_DBG_STATUS_reg   (*((volatile unsigned int*) DP_DBG_STATUS_reg))
+#define DP_DBG_STATUS_inst_adr                                                       "0x0008"
+#define DP_DBG_STATUS_inst                                                           0x0008
+#define DP_DBG_STATUS_uart_tx_disable_shift                                          (3)
+#define DP_DBG_STATUS_uart_tx_disable_mask                                           (0x00000008)
+#define DP_DBG_STATUS_uart_tx_disable(data)                                          (0x00000008&((data)<<3))
+#define DP_DBG_STATUS_uart_tx_disable_src(data)                                      ((0x00000008&(data))>>3)
+#define DP_DBG_STATUS_get_uart_tx_disable(data)                                      ((0x00000008&(data))>>3)
+#define DP_DBG_STATUS_uart_rx_disable_shift                                          (2)
+#define DP_DBG_STATUS_uart_rx_disable_mask                                           (0x00000004)
+#define DP_DBG_STATUS_uart_rx_disable(data)                                          (0x00000004&((data)<<2))
+#define DP_DBG_STATUS_uart_rx_disable_src(data)                                      ((0x00000004&(data))>>2)
+#define DP_DBG_STATUS_get_uart_rx_disable(data)                                      ((0x00000004&(data))>>2)
+#define DP_DBG_STATUS_hif_disable_shift                                              (1)
+#define DP_DBG_STATUS_hif_disable_mask                                               (0x00000002)
+#define DP_DBG_STATUS_hif_disable(data)                                              (0x00000002&((data)<<1))
+#define DP_DBG_STATUS_hif_disable_src(data)                                          ((0x00000002&(data))>>1)
+#define DP_DBG_STATUS_get_hif_disable(data)                                          ((0x00000002&(data))>>1)
+#define DP_DBG_STATUS_jtag_lx_disable_shift                                          (0)
+#define DP_DBG_STATUS_jtag_lx_disable_mask                                           (0x00000001)
+#define DP_DBG_STATUS_jtag_lx_disable(data)                                          (0x00000001&((data)<<0))
+#define DP_DBG_STATUS_jtag_lx_disable_src(data)                                      ((0x00000001&(data))>>0)
+#define DP_DBG_STATUS_get_jtag_lx_disable(data)                                      ((0x00000001&(data))>>0)
+
+
+#define DP_BIST_CTRL                                                                 0x18017824
+#define DP_BIST_CTRL_reg_addr                                                        "0xB8017824"
+#define DP_BIST_CTRL_reg                                                             0xB8017824
+#define set_DP_BIST_CTRL_reg(data)   (*((volatile unsigned int*) DP_BIST_CTRL_reg)=data)
+#define get_DP_BIST_CTRL_reg   (*((volatile unsigned int*) DP_BIST_CTRL_reg))
+#define DP_BIST_CTRL_inst_adr                                                        "0x0009"
+#define DP_BIST_CTRL_inst                                                            0x0009
+#define DP_BIST_CTRL_bist_drf_test_resume_shift                                      (2)
+#define DP_BIST_CTRL_bist_drf_test_resume_mask                                       (0x00000004)
+#define DP_BIST_CTRL_bist_drf_test_resume(data)                                      (0x00000004&((data)<<2))
+#define DP_BIST_CTRL_bist_drf_test_resume_src(data)                                  ((0x00000004&(data))>>2)
+#define DP_BIST_CTRL_get_bist_drf_test_resume(data)                                  ((0x00000004&(data))>>2)
+#define DP_BIST_CTRL_bist_drf_en_shift                                               (1)
+#define DP_BIST_CTRL_bist_drf_en_mask                                                (0x00000002)
+#define DP_BIST_CTRL_bist_drf_en(data)                                               (0x00000002&((data)<<1))
+#define DP_BIST_CTRL_bist_drf_en_src(data)                                           ((0x00000002&(data))>>1)
+#define DP_BIST_CTRL_get_bist_drf_en(data)                                           ((0x00000002&(data))>>1)
+#define DP_BIST_CTRL_bist_en_shift                                                   (0)
+#define DP_BIST_CTRL_bist_en_mask                                                    (0x00000001)
+#define DP_BIST_CTRL_bist_en(data)                                                   (0x00000001&((data)<<0))
+#define DP_BIST_CTRL_bist_en_src(data)                                               ((0x00000001&(data))>>0)
+#define DP_BIST_CTRL_get_bist_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define DP_BIST_RM                                                                   0x18017828
+#define DP_BIST_RM_reg_addr                                                          "0xB8017828"
+#define DP_BIST_RM_reg                                                               0xB8017828
+#define set_DP_BIST_RM_reg(data)   (*((volatile unsigned int*) DP_BIST_RM_reg)=data)
+#define get_DP_BIST_RM_reg   (*((volatile unsigned int*) DP_BIST_RM_reg))
+#define DP_BIST_RM_inst_adr                                                          "0x000A"
+#define DP_BIST_RM_inst                                                              0x000A
+#define DP_BIST_RM_rme_shift                                                         (4)
+#define DP_BIST_RM_rme_mask                                                          (0x00000010)
+#define DP_BIST_RM_rme(data)                                                         (0x00000010&((data)<<4))
+#define DP_BIST_RM_rme_src(data)                                                     ((0x00000010&(data))>>4)
+#define DP_BIST_RM_get_rme(data)                                                     ((0x00000010&(data))>>4)
+#define DP_BIST_RM_rm_shift                                                          (0)
+#define DP_BIST_RM_rm_mask                                                           (0x0000000F)
+#define DP_BIST_RM_rm(data)                                                          (0x0000000F&((data)<<0))
+#define DP_BIST_RM_rm_src(data)                                                      ((0x0000000F&(data))>>0)
+#define DP_BIST_RM_get_rm(data)                                                      ((0x0000000F&(data))>>0)
+
+
+#define DP_BIST_ST                                                                   0x1801782c
+#define DP_BIST_ST_reg_addr                                                          "0xB801782C"
+#define DP_BIST_ST_reg                                                               0xB801782C
+#define set_DP_BIST_ST_reg(data)   (*((volatile unsigned int*) DP_BIST_ST_reg)=data)
+#define get_DP_BIST_ST_reg   (*((volatile unsigned int*) DP_BIST_ST_reg))
+#define DP_BIST_ST_inst_adr                                                          "0x000B"
+#define DP_BIST_ST_inst                                                              0x000B
+#define DP_BIST_ST_bist_fail0_shift                                                  (1)
+#define DP_BIST_ST_bist_fail0_mask                                                   (0x00000002)
+#define DP_BIST_ST_bist_fail0(data)                                                  (0x00000002&((data)<<1))
+#define DP_BIST_ST_bist_fail0_src(data)                                              ((0x00000002&(data))>>1)
+#define DP_BIST_ST_get_bist_fail0(data)                                              ((0x00000002&(data))>>1)
+#define DP_BIST_ST_bist_done_shift                                                   (0)
+#define DP_BIST_ST_bist_done_mask                                                    (0x00000001)
+#define DP_BIST_ST_bist_done(data)                                                   (0x00000001&((data)<<0))
+#define DP_BIST_ST_bist_done_src(data)                                               ((0x00000001&(data))>>0)
+#define DP_BIST_ST_get_bist_done(data)                                               ((0x00000001&(data))>>0)
+
+
+#define DP_DRF_ST                                                                    0x18017830
+#define DP_DRF_ST_reg_addr                                                           "0xB8017830"
+#define DP_DRF_ST_reg                                                                0xB8017830
+#define set_DP_DRF_ST_reg(data)   (*((volatile unsigned int*) DP_DRF_ST_reg)=data)
+#define get_DP_DRF_ST_reg   (*((volatile unsigned int*) DP_DRF_ST_reg))
+#define DP_DRF_ST_inst_adr                                                           "0x000C"
+#define DP_DRF_ST_inst                                                               0x000C
+#define DP_DRF_ST_drf_bist_start_pause_shift                                         (16)
+#define DP_DRF_ST_drf_bist_start_pause_mask                                          (0x00010000)
+#define DP_DRF_ST_drf_bist_start_pause(data)                                         (0x00010000&((data)<<16))
+#define DP_DRF_ST_drf_bist_start_pause_src(data)                                     ((0x00010000&(data))>>16)
+#define DP_DRF_ST_get_drf_bist_start_pause(data)                                     ((0x00010000&(data))>>16)
+#define DP_DRF_ST_drf_bist_fail0_shift                                               (1)
+#define DP_DRF_ST_drf_bist_fail0_mask                                                (0x00000002)
+#define DP_DRF_ST_drf_bist_fail0(data)                                               (0x00000002&((data)<<1))
+#define DP_DRF_ST_drf_bist_fail0_src(data)                                           ((0x00000002&(data))>>1)
+#define DP_DRF_ST_get_drf_bist_fail0(data)                                           ((0x00000002&(data))>>1)
+#define DP_DRF_ST_drf_bist_done_shift                                                (0)
+#define DP_DRF_ST_drf_bist_done_mask                                                 (0x00000001)
+#define DP_DRF_ST_drf_bist_done(data)                                                (0x00000001&((data)<<0))
+#define DP_DRF_ST_drf_bist_done_src(data)                                            ((0x00000001&(data))>>0)
+#define DP_DRF_ST_get_drf_bist_done(data)                                            ((0x00000001&(data))>>0)
+
+
+#define DP_UART_CTL                                                                  0x18017840
+#define DP_UART_CTL_reg_addr                                                         "0xB8017840"
+#define DP_UART_CTL_reg                                                              0xB8017840
+#define set_DP_UART_CTL_reg(data)   (*((volatile unsigned int*) DP_UART_CTL_reg)=data)
+#define get_DP_UART_CTL_reg   (*((volatile unsigned int*) DP_UART_CTL_reg))
+#define DP_UART_CTL_inst_adr                                                         "0x0010"
+#define DP_UART_CTL_inst                                                             0x0010
+#define DP_UART_CTL_rx_off_shift                                                     (1)
+#define DP_UART_CTL_rx_off_mask                                                      (0x00000002)
+#define DP_UART_CTL_rx_off(data)                                                     (0x00000002&((data)<<1))
+#define DP_UART_CTL_rx_off_src(data)                                                 ((0x00000002&(data))>>1)
+#define DP_UART_CTL_get_rx_off(data)                                                 ((0x00000002&(data))>>1)
+#define DP_UART_CTL_tx_off_shift                                                     (0)
+#define DP_UART_CTL_tx_off_mask                                                      (0x00000001)
+#define DP_UART_CTL_tx_off(data)                                                     (0x00000001&((data)<<0))
+#define DP_UART_CTL_tx_off_src(data)                                                 ((0x00000001&(data))>>0)
+#define DP_UART_CTL_get_tx_off(data)                                                 ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/efuse_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/efuse_reg.h
new file mode 100644
index 00000000..d976111
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/efuse_reg.h
@@ -0,0 +1,1109 @@
+/**************************************************************
+// Spec Version                  : 0.0.5
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/5/8 20:7:34
+***************************************************************/
+
+
+#ifndef _EFUSE_REG_H_INCLUDED_
+#define _EFUSE_REG_H_INCLUDED_
+#ifdef  _EFUSE_USE_STRUCT
+typedef struct 
+{
+unsigned int     datao:32;
+}EFUSE_DATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable4:1;
+unsigned int     en_pro_efuse:1;
+unsigned int     write_enable3:1;
+unsigned int     auto_rd_req:1;
+unsigned int     reserved_1:4;
+unsigned int     write_enable2:1;
+unsigned int     strobe:1;
+unsigned int     write_enable1:1;
+unsigned int     a:13;
+}EFUSE_EF_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     pro_efuse_act:1;
+unsigned int     reserved_1:15;
+unsigned int     crc_en:1;
+}EFUSE_EF_CTRL_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     crc_ini:8;
+unsigned int     reserved_1:8;
+unsigned int     crc_out:8;
+}EFUSE_EF_CRC;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     write_enable2:1;
+unsigned int     mr_mode:1;
+unsigned int     reserved_1:1;
+unsigned int     write_enable1:1;
+unsigned int     prog_strobe_pulse_width:4;
+}EFUSE_EF_CTRL_NEW;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     Rd_done:1;
+unsigned int     write_data:1;
+}EFUSE_EF_RD_DONE;
+
+#endif
+
+#define EFUSE_DATA_0                                                                 0x18017000
+#define EFUSE_DATA_1                                                                 0x18017004
+#define EFUSE_DATA_2                                                                 0x18017008
+#define EFUSE_DATA_3                                                                 0x1801700C
+#define EFUSE_DATA_4                                                                 0x18017010
+#define EFUSE_DATA_5                                                                 0x18017014
+#define EFUSE_DATA_6                                                                 0x18017018
+#define EFUSE_DATA_7                                                                 0x1801701C
+#define EFUSE_DATA_8                                                                 0x18017020
+#define EFUSE_DATA_9                                                                 0x18017024
+#define EFUSE_DATA_10                                                                 0x18017028
+#define EFUSE_DATA_11                                                                 0x1801702C
+#define EFUSE_DATA_12                                                                 0x18017030
+#define EFUSE_DATA_13                                                                 0x18017034
+#define EFUSE_DATA_14                                                                 0x18017038
+#define EFUSE_DATA_15                                                                 0x1801703C
+#define EFUSE_DATA_16                                                                 0x18017040
+#define EFUSE_DATA_17                                                                 0x18017044
+#define EFUSE_DATA_18                                                                 0x18017048
+#define EFUSE_DATA_19                                                                 0x1801704C
+#define EFUSE_DATA_20                                                                 0x18017050
+#define EFUSE_DATA_21                                                                 0x18017054
+#define EFUSE_DATA_22                                                                 0x18017058
+#define EFUSE_DATA_23                                                                 0x1801705C
+#define EFUSE_DATA_24                                                                 0x18017060
+#define EFUSE_DATA_25                                                                 0x18017064
+#define EFUSE_DATA_26                                                                 0x18017068
+#define EFUSE_DATA_27                                                                 0x1801706C
+#define EFUSE_DATA_28                                                                 0x18017070
+#define EFUSE_DATA_29                                                                 0x18017074
+#define EFUSE_DATA_30                                                                 0x18017078
+#define EFUSE_DATA_31                                                                 0x1801707C
+#define EFUSE_DATA_32                                                                 0x18017080
+#define EFUSE_DATA_33                                                                 0x18017084
+#define EFUSE_DATA_34                                                                 0x18017088
+#define EFUSE_DATA_35                                                                 0x1801708C
+#define EFUSE_DATA_36                                                                 0x18017090
+#define EFUSE_DATA_37                                                                 0x18017094
+#define EFUSE_DATA_38                                                                 0x18017098
+#define EFUSE_DATA_39                                                                 0x1801709C
+#define EFUSE_DATA_40                                                                 0x180170A0
+#define EFUSE_DATA_41                                                                 0x180170A4
+#define EFUSE_DATA_42                                                                 0x180170A8
+#define EFUSE_DATA_43                                                                 0x180170AC
+#define EFUSE_DATA_44                                                                 0x180170B0
+#define EFUSE_DATA_45                                                                 0x180170B4
+#define EFUSE_DATA_46                                                                 0x180170B8
+#define EFUSE_DATA_47                                                                 0x180170BC
+#define EFUSE_DATA_48                                                                 0x180170C0
+#define EFUSE_DATA_49                                                                 0x180170C4
+#define EFUSE_DATA_50                                                                 0x180170C8
+#define EFUSE_DATA_51                                                                 0x180170CC
+#define EFUSE_DATA_52                                                                 0x180170D0
+#define EFUSE_DATA_53                                                                 0x180170D4
+#define EFUSE_DATA_54                                                                 0x180170D8
+#define EFUSE_DATA_55                                                                 0x180170DC
+#define EFUSE_DATA_56                                                                 0x180170E0
+#define EFUSE_DATA_57                                                                 0x180170E4
+#define EFUSE_DATA_58                                                                 0x180170E8
+#define EFUSE_DATA_59                                                                 0x180170EC
+#define EFUSE_DATA_60                                                                 0x180170F0
+#define EFUSE_DATA_61                                                                 0x180170F4
+#define EFUSE_DATA_62                                                                 0x180170F8
+#define EFUSE_DATA_63                                                                 0x180170FC
+#define EFUSE_DATA_64                                                                 0x18017100
+#define EFUSE_DATA_65                                                                 0x18017104
+#define EFUSE_DATA_66                                                                 0x18017108
+#define EFUSE_DATA_67                                                                 0x1801710C
+#define EFUSE_DATA_68                                                                 0x18017110
+#define EFUSE_DATA_69                                                                 0x18017114
+#define EFUSE_DATA_70                                                                 0x18017118
+#define EFUSE_DATA_71                                                                 0x1801711C
+#define EFUSE_DATA_72                                                                 0x18017120
+#define EFUSE_DATA_73                                                                 0x18017124
+#define EFUSE_DATA_74                                                                 0x18017128
+#define EFUSE_DATA_75                                                                 0x1801712C
+#define EFUSE_DATA_76                                                                 0x18017130
+#define EFUSE_DATA_77                                                                 0x18017134
+#define EFUSE_DATA_78                                                                 0x18017138
+#define EFUSE_DATA_79                                                                 0x1801713C
+#define EFUSE_DATA_80                                                                 0x18017140
+#define EFUSE_DATA_81                                                                 0x18017144
+#define EFUSE_DATA_82                                                                 0x18017148
+#define EFUSE_DATA_83                                                                 0x1801714C
+#define EFUSE_DATA_84                                                                 0x18017150
+#define EFUSE_DATA_85                                                                 0x18017154
+#define EFUSE_DATA_86                                                                 0x18017158
+#define EFUSE_DATA_87                                                                 0x1801715C
+#define EFUSE_DATA_88                                                                 0x18017160
+#define EFUSE_DATA_89                                                                 0x18017164
+#define EFUSE_DATA_90                                                                 0x18017168
+#define EFUSE_DATA_91                                                                 0x1801716C
+#define EFUSE_DATA_92                                                                 0x18017170
+#define EFUSE_DATA_93                                                                 0x18017174
+#define EFUSE_DATA_94                                                                 0x18017178
+#define EFUSE_DATA_95                                                                 0x1801717C
+#define EFUSE_DATA_96                                                                 0x18017180
+#define EFUSE_DATA_97                                                                 0x18017184
+#define EFUSE_DATA_98                                                                 0x18017188
+#define EFUSE_DATA_99                                                                 0x1801718C
+#define EFUSE_DATA_100                                                                 0x18017190
+#define EFUSE_DATA_101                                                                 0x18017194
+#define EFUSE_DATA_102                                                                 0x18017198
+#define EFUSE_DATA_103                                                                 0x1801719C
+#define EFUSE_DATA_104                                                                 0x180171A0
+#define EFUSE_DATA_105                                                                 0x180171A4
+#define EFUSE_DATA_106                                                                 0x180171A8
+#define EFUSE_DATA_107                                                                 0x180171AC
+#define EFUSE_DATA_108                                                                 0x180171B0
+#define EFUSE_DATA_109                                                                 0x180171B4
+#define EFUSE_DATA_110                                                                 0x180171B8
+#define EFUSE_DATA_111                                                                 0x180171BC
+#define EFUSE_DATA_112                                                                 0x180171C0
+#define EFUSE_DATA_113                                                                 0x180171C4
+#define EFUSE_DATA_114                                                                 0x180171C8
+#define EFUSE_DATA_115                                                                 0x180171CC
+#define EFUSE_DATA_116                                                                 0x180171D0
+#define EFUSE_DATA_117                                                                 0x180171D4
+#define EFUSE_DATA_118                                                                 0x180171D8
+#define EFUSE_DATA_119                                                                 0x180171DC
+#define EFUSE_DATA_120                                                                 0x180171E0
+#define EFUSE_DATA_121                                                                 0x180171E4
+#define EFUSE_DATA_122                                                                 0x180171E8
+#define EFUSE_DATA_123                                                                 0x180171EC
+#define EFUSE_DATA_124                                                                 0x180171F0
+#define EFUSE_DATA_125                                                                 0x180171F4
+#define EFUSE_DATA_126                                                                 0x180171F8
+#define EFUSE_DATA_127                                                                 0x180171FC
+#define EFUSE_DATA_0_reg_addr                                                        "0xB8017000"
+#define EFUSE_DATA_1_reg_addr                                                        "0xB8017004"
+#define EFUSE_DATA_2_reg_addr                                                        "0xB8017008"
+#define EFUSE_DATA_3_reg_addr                                                        "0xB801700C"
+#define EFUSE_DATA_4_reg_addr                                                        "0xB8017010"
+#define EFUSE_DATA_5_reg_addr                                                        "0xB8017014"
+#define EFUSE_DATA_6_reg_addr                                                        "0xB8017018"
+#define EFUSE_DATA_7_reg_addr                                                        "0xB801701C"
+#define EFUSE_DATA_8_reg_addr                                                        "0xB8017020"
+#define EFUSE_DATA_9_reg_addr                                                        "0xB8017024"
+#define EFUSE_DATA_10_reg_addr                                                        "0xB8017028"
+#define EFUSE_DATA_11_reg_addr                                                        "0xB801702C"
+#define EFUSE_DATA_12_reg_addr                                                        "0xB8017030"
+#define EFUSE_DATA_13_reg_addr                                                        "0xB8017034"
+#define EFUSE_DATA_14_reg_addr                                                        "0xB8017038"
+#define EFUSE_DATA_15_reg_addr                                                        "0xB801703C"
+#define EFUSE_DATA_16_reg_addr                                                        "0xB8017040"
+#define EFUSE_DATA_17_reg_addr                                                        "0xB8017044"
+#define EFUSE_DATA_18_reg_addr                                                        "0xB8017048"
+#define EFUSE_DATA_19_reg_addr                                                        "0xB801704C"
+#define EFUSE_DATA_20_reg_addr                                                        "0xB8017050"
+#define EFUSE_DATA_21_reg_addr                                                        "0xB8017054"
+#define EFUSE_DATA_22_reg_addr                                                        "0xB8017058"
+#define EFUSE_DATA_23_reg_addr                                                        "0xB801705C"
+#define EFUSE_DATA_24_reg_addr                                                        "0xB8017060"
+#define EFUSE_DATA_25_reg_addr                                                        "0xB8017064"
+#define EFUSE_DATA_26_reg_addr                                                        "0xB8017068"
+#define EFUSE_DATA_27_reg_addr                                                        "0xB801706C"
+#define EFUSE_DATA_28_reg_addr                                                        "0xB8017070"
+#define EFUSE_DATA_29_reg_addr                                                        "0xB8017074"
+#define EFUSE_DATA_30_reg_addr                                                        "0xB8017078"
+#define EFUSE_DATA_31_reg_addr                                                        "0xB801707C"
+#define EFUSE_DATA_32_reg_addr                                                        "0xB8017080"
+#define EFUSE_DATA_33_reg_addr                                                        "0xB8017084"
+#define EFUSE_DATA_34_reg_addr                                                        "0xB8017088"
+#define EFUSE_DATA_35_reg_addr                                                        "0xB801708C"
+#define EFUSE_DATA_36_reg_addr                                                        "0xB8017090"
+#define EFUSE_DATA_37_reg_addr                                                        "0xB8017094"
+#define EFUSE_DATA_38_reg_addr                                                        "0xB8017098"
+#define EFUSE_DATA_39_reg_addr                                                        "0xB801709C"
+#define EFUSE_DATA_40_reg_addr                                                        "0xB80170A0"
+#define EFUSE_DATA_41_reg_addr                                                        "0xB80170A4"
+#define EFUSE_DATA_42_reg_addr                                                        "0xB80170A8"
+#define EFUSE_DATA_43_reg_addr                                                        "0xB80170AC"
+#define EFUSE_DATA_44_reg_addr                                                        "0xB80170B0"
+#define EFUSE_DATA_45_reg_addr                                                        "0xB80170B4"
+#define EFUSE_DATA_46_reg_addr                                                        "0xB80170B8"
+#define EFUSE_DATA_47_reg_addr                                                        "0xB80170BC"
+#define EFUSE_DATA_48_reg_addr                                                        "0xB80170C0"
+#define EFUSE_DATA_49_reg_addr                                                        "0xB80170C4"
+#define EFUSE_DATA_50_reg_addr                                                        "0xB80170C8"
+#define EFUSE_DATA_51_reg_addr                                                        "0xB80170CC"
+#define EFUSE_DATA_52_reg_addr                                                        "0xB80170D0"
+#define EFUSE_DATA_53_reg_addr                                                        "0xB80170D4"
+#define EFUSE_DATA_54_reg_addr                                                        "0xB80170D8"
+#define EFUSE_DATA_55_reg_addr                                                        "0xB80170DC"
+#define EFUSE_DATA_56_reg_addr                                                        "0xB80170E0"
+#define EFUSE_DATA_57_reg_addr                                                        "0xB80170E4"
+#define EFUSE_DATA_58_reg_addr                                                        "0xB80170E8"
+#define EFUSE_DATA_59_reg_addr                                                        "0xB80170EC"
+#define EFUSE_DATA_60_reg_addr                                                        "0xB80170F0"
+#define EFUSE_DATA_61_reg_addr                                                        "0xB80170F4"
+#define EFUSE_DATA_62_reg_addr                                                        "0xB80170F8"
+#define EFUSE_DATA_63_reg_addr                                                        "0xB80170FC"
+#define EFUSE_DATA_64_reg_addr                                                        "0xB8017100"
+#define EFUSE_DATA_65_reg_addr                                                        "0xB8017104"
+#define EFUSE_DATA_66_reg_addr                                                        "0xB8017108"
+#define EFUSE_DATA_67_reg_addr                                                        "0xB801710C"
+#define EFUSE_DATA_68_reg_addr                                                        "0xB8017110"
+#define EFUSE_DATA_69_reg_addr                                                        "0xB8017114"
+#define EFUSE_DATA_70_reg_addr                                                        "0xB8017118"
+#define EFUSE_DATA_71_reg_addr                                                        "0xB801711C"
+#define EFUSE_DATA_72_reg_addr                                                        "0xB8017120"
+#define EFUSE_DATA_73_reg_addr                                                        "0xB8017124"
+#define EFUSE_DATA_74_reg_addr                                                        "0xB8017128"
+#define EFUSE_DATA_75_reg_addr                                                        "0xB801712C"
+#define EFUSE_DATA_76_reg_addr                                                        "0xB8017130"
+#define EFUSE_DATA_77_reg_addr                                                        "0xB8017134"
+#define EFUSE_DATA_78_reg_addr                                                        "0xB8017138"
+#define EFUSE_DATA_79_reg_addr                                                        "0xB801713C"
+#define EFUSE_DATA_80_reg_addr                                                        "0xB8017140"
+#define EFUSE_DATA_81_reg_addr                                                        "0xB8017144"
+#define EFUSE_DATA_82_reg_addr                                                        "0xB8017148"
+#define EFUSE_DATA_83_reg_addr                                                        "0xB801714C"
+#define EFUSE_DATA_84_reg_addr                                                        "0xB8017150"
+#define EFUSE_DATA_85_reg_addr                                                        "0xB8017154"
+#define EFUSE_DATA_86_reg_addr                                                        "0xB8017158"
+#define EFUSE_DATA_87_reg_addr                                                        "0xB801715C"
+#define EFUSE_DATA_88_reg_addr                                                        "0xB8017160"
+#define EFUSE_DATA_89_reg_addr                                                        "0xB8017164"
+#define EFUSE_DATA_90_reg_addr                                                        "0xB8017168"
+#define EFUSE_DATA_91_reg_addr                                                        "0xB801716C"
+#define EFUSE_DATA_92_reg_addr                                                        "0xB8017170"
+#define EFUSE_DATA_93_reg_addr                                                        "0xB8017174"
+#define EFUSE_DATA_94_reg_addr                                                        "0xB8017178"
+#define EFUSE_DATA_95_reg_addr                                                        "0xB801717C"
+#define EFUSE_DATA_96_reg_addr                                                        "0xB8017180"
+#define EFUSE_DATA_97_reg_addr                                                        "0xB8017184"
+#define EFUSE_DATA_98_reg_addr                                                        "0xB8017188"
+#define EFUSE_DATA_99_reg_addr                                                        "0xB801718C"
+#define EFUSE_DATA_100_reg_addr                                                        "0xB8017190"
+#define EFUSE_DATA_101_reg_addr                                                        "0xB8017194"
+#define EFUSE_DATA_102_reg_addr                                                        "0xB8017198"
+#define EFUSE_DATA_103_reg_addr                                                        "0xB801719C"
+#define EFUSE_DATA_104_reg_addr                                                        "0xB80171A0"
+#define EFUSE_DATA_105_reg_addr                                                        "0xB80171A4"
+#define EFUSE_DATA_106_reg_addr                                                        "0xB80171A8"
+#define EFUSE_DATA_107_reg_addr                                                        "0xB80171AC"
+#define EFUSE_DATA_108_reg_addr                                                        "0xB80171B0"
+#define EFUSE_DATA_109_reg_addr                                                        "0xB80171B4"
+#define EFUSE_DATA_110_reg_addr                                                        "0xB80171B8"
+#define EFUSE_DATA_111_reg_addr                                                        "0xB80171BC"
+#define EFUSE_DATA_112_reg_addr                                                        "0xB80171C0"
+#define EFUSE_DATA_113_reg_addr                                                        "0xB80171C4"
+#define EFUSE_DATA_114_reg_addr                                                        "0xB80171C8"
+#define EFUSE_DATA_115_reg_addr                                                        "0xB80171CC"
+#define EFUSE_DATA_116_reg_addr                                                        "0xB80171D0"
+#define EFUSE_DATA_117_reg_addr                                                        "0xB80171D4"
+#define EFUSE_DATA_118_reg_addr                                                        "0xB80171D8"
+#define EFUSE_DATA_119_reg_addr                                                        "0xB80171DC"
+#define EFUSE_DATA_120_reg_addr                                                        "0xB80171E0"
+#define EFUSE_DATA_121_reg_addr                                                        "0xB80171E4"
+#define EFUSE_DATA_122_reg_addr                                                        "0xB80171E8"
+#define EFUSE_DATA_123_reg_addr                                                        "0xB80171EC"
+#define EFUSE_DATA_124_reg_addr                                                        "0xB80171F0"
+#define EFUSE_DATA_125_reg_addr                                                        "0xB80171F4"
+#define EFUSE_DATA_126_reg_addr                                                        "0xB80171F8"
+#define EFUSE_DATA_127_reg_addr                                                        "0xB80171FC"
+#define EFUSE_DATA_0_reg                                                             0xB8017000
+#define EFUSE_DATA_1_reg                                                             0xB8017004
+#define EFUSE_DATA_2_reg                                                             0xB8017008
+#define EFUSE_DATA_3_reg                                                             0xB801700C
+#define EFUSE_DATA_4_reg                                                             0xB8017010
+#define EFUSE_DATA_5_reg                                                             0xB8017014
+#define EFUSE_DATA_6_reg                                                             0xB8017018
+#define EFUSE_DATA_7_reg                                                             0xB801701C
+#define EFUSE_DATA_8_reg                                                             0xB8017020
+#define EFUSE_DATA_9_reg                                                             0xB8017024
+#define EFUSE_DATA_10_reg                                                             0xB8017028
+#define EFUSE_DATA_11_reg                                                             0xB801702C
+#define EFUSE_DATA_12_reg                                                             0xB8017030
+#define EFUSE_DATA_13_reg                                                             0xB8017034
+#define EFUSE_DATA_14_reg                                                             0xB8017038
+#define EFUSE_DATA_15_reg                                                             0xB801703C
+#define EFUSE_DATA_16_reg                                                             0xB8017040
+#define EFUSE_DATA_17_reg                                                             0xB8017044
+#define EFUSE_DATA_18_reg                                                             0xB8017048
+#define EFUSE_DATA_19_reg                                                             0xB801704C
+#define EFUSE_DATA_20_reg                                                             0xB8017050
+#define EFUSE_DATA_21_reg                                                             0xB8017054
+#define EFUSE_DATA_22_reg                                                             0xB8017058
+#define EFUSE_DATA_23_reg                                                             0xB801705C
+#define EFUSE_DATA_24_reg                                                             0xB8017060
+#define EFUSE_DATA_25_reg                                                             0xB8017064
+#define EFUSE_DATA_26_reg                                                             0xB8017068
+#define EFUSE_DATA_27_reg                                                             0xB801706C
+#define EFUSE_DATA_28_reg                                                             0xB8017070
+#define EFUSE_DATA_29_reg                                                             0xB8017074
+#define EFUSE_DATA_30_reg                                                             0xB8017078
+#define EFUSE_DATA_31_reg                                                             0xB801707C
+#define EFUSE_DATA_32_reg                                                             0xB8017080
+#define EFUSE_DATA_33_reg                                                             0xB8017084
+#define EFUSE_DATA_34_reg                                                             0xB8017088
+#define EFUSE_DATA_35_reg                                                             0xB801708C
+#define EFUSE_DATA_36_reg                                                             0xB8017090
+#define EFUSE_DATA_37_reg                                                             0xB8017094
+#define EFUSE_DATA_38_reg                                                             0xB8017098
+#define EFUSE_DATA_39_reg                                                             0xB801709C
+#define EFUSE_DATA_40_reg                                                             0xB80170A0
+#define EFUSE_DATA_41_reg                                                             0xB80170A4
+#define EFUSE_DATA_42_reg                                                             0xB80170A8
+#define EFUSE_DATA_43_reg                                                             0xB80170AC
+#define EFUSE_DATA_44_reg                                                             0xB80170B0
+#define EFUSE_DATA_45_reg                                                             0xB80170B4
+#define EFUSE_DATA_46_reg                                                             0xB80170B8
+#define EFUSE_DATA_47_reg                                                             0xB80170BC
+#define EFUSE_DATA_48_reg                                                             0xB80170C0
+#define EFUSE_DATA_49_reg                                                             0xB80170C4
+#define EFUSE_DATA_50_reg                                                             0xB80170C8
+#define EFUSE_DATA_51_reg                                                             0xB80170CC
+#define EFUSE_DATA_52_reg                                                             0xB80170D0
+#define EFUSE_DATA_53_reg                                                             0xB80170D4
+#define EFUSE_DATA_54_reg                                                             0xB80170D8
+#define EFUSE_DATA_55_reg                                                             0xB80170DC
+#define EFUSE_DATA_56_reg                                                             0xB80170E0
+#define EFUSE_DATA_57_reg                                                             0xB80170E4
+#define EFUSE_DATA_58_reg                                                             0xB80170E8
+#define EFUSE_DATA_59_reg                                                             0xB80170EC
+#define EFUSE_DATA_60_reg                                                             0xB80170F0
+#define EFUSE_DATA_61_reg                                                             0xB80170F4
+#define EFUSE_DATA_62_reg                                                             0xB80170F8
+#define EFUSE_DATA_63_reg                                                             0xB80170FC
+#define EFUSE_DATA_64_reg                                                             0xB8017100
+#define EFUSE_DATA_65_reg                                                             0xB8017104
+#define EFUSE_DATA_66_reg                                                             0xB8017108
+#define EFUSE_DATA_67_reg                                                             0xB801710C
+#define EFUSE_DATA_68_reg                                                             0xB8017110
+#define EFUSE_DATA_69_reg                                                             0xB8017114
+#define EFUSE_DATA_70_reg                                                             0xB8017118
+#define EFUSE_DATA_71_reg                                                             0xB801711C
+#define EFUSE_DATA_72_reg                                                             0xB8017120
+#define EFUSE_DATA_73_reg                                                             0xB8017124
+#define EFUSE_DATA_74_reg                                                             0xB8017128
+#define EFUSE_DATA_75_reg                                                             0xB801712C
+#define EFUSE_DATA_76_reg                                                             0xB8017130
+#define EFUSE_DATA_77_reg                                                             0xB8017134
+#define EFUSE_DATA_78_reg                                                             0xB8017138
+#define EFUSE_DATA_79_reg                                                             0xB801713C
+#define EFUSE_DATA_80_reg                                                             0xB8017140
+#define EFUSE_DATA_81_reg                                                             0xB8017144
+#define EFUSE_DATA_82_reg                                                             0xB8017148
+#define EFUSE_DATA_83_reg                                                             0xB801714C
+#define EFUSE_DATA_84_reg                                                             0xB8017150
+#define EFUSE_DATA_85_reg                                                             0xB8017154
+#define EFUSE_DATA_86_reg                                                             0xB8017158
+#define EFUSE_DATA_87_reg                                                             0xB801715C
+#define EFUSE_DATA_88_reg                                                             0xB8017160
+#define EFUSE_DATA_89_reg                                                             0xB8017164
+#define EFUSE_DATA_90_reg                                                             0xB8017168
+#define EFUSE_DATA_91_reg                                                             0xB801716C
+#define EFUSE_DATA_92_reg                                                             0xB8017170
+#define EFUSE_DATA_93_reg                                                             0xB8017174
+#define EFUSE_DATA_94_reg                                                             0xB8017178
+#define EFUSE_DATA_95_reg                                                             0xB801717C
+#define EFUSE_DATA_96_reg                                                             0xB8017180
+#define EFUSE_DATA_97_reg                                                             0xB8017184
+#define EFUSE_DATA_98_reg                                                             0xB8017188
+#define EFUSE_DATA_99_reg                                                             0xB801718C
+#define EFUSE_DATA_100_reg                                                             0xB8017190
+#define EFUSE_DATA_101_reg                                                             0xB8017194
+#define EFUSE_DATA_102_reg                                                             0xB8017198
+#define EFUSE_DATA_103_reg                                                             0xB801719C
+#define EFUSE_DATA_104_reg                                                             0xB80171A0
+#define EFUSE_DATA_105_reg                                                             0xB80171A4
+#define EFUSE_DATA_106_reg                                                             0xB80171A8
+#define EFUSE_DATA_107_reg                                                             0xB80171AC
+#define EFUSE_DATA_108_reg                                                             0xB80171B0
+#define EFUSE_DATA_109_reg                                                             0xB80171B4
+#define EFUSE_DATA_110_reg                                                             0xB80171B8
+#define EFUSE_DATA_111_reg                                                             0xB80171BC
+#define EFUSE_DATA_112_reg                                                             0xB80171C0
+#define EFUSE_DATA_113_reg                                                             0xB80171C4
+#define EFUSE_DATA_114_reg                                                             0xB80171C8
+#define EFUSE_DATA_115_reg                                                             0xB80171CC
+#define EFUSE_DATA_116_reg                                                             0xB80171D0
+#define EFUSE_DATA_117_reg                                                             0xB80171D4
+#define EFUSE_DATA_118_reg                                                             0xB80171D8
+#define EFUSE_DATA_119_reg                                                             0xB80171DC
+#define EFUSE_DATA_120_reg                                                             0xB80171E0
+#define EFUSE_DATA_121_reg                                                             0xB80171E4
+#define EFUSE_DATA_122_reg                                                             0xB80171E8
+#define EFUSE_DATA_123_reg                                                             0xB80171EC
+#define EFUSE_DATA_124_reg                                                             0xB80171F0
+#define EFUSE_DATA_125_reg                                                             0xB80171F4
+#define EFUSE_DATA_126_reg                                                             0xB80171F8
+#define EFUSE_DATA_127_reg                                                             0xB80171FC
+#define set_EFUSE_DATA_0_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_0_reg)=data)
+#define set_EFUSE_DATA_1_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_1_reg)=data)
+#define set_EFUSE_DATA_2_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_2_reg)=data)
+#define set_EFUSE_DATA_3_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_3_reg)=data)
+#define set_EFUSE_DATA_4_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_4_reg)=data)
+#define set_EFUSE_DATA_5_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_5_reg)=data)
+#define set_EFUSE_DATA_6_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_6_reg)=data)
+#define set_EFUSE_DATA_7_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_7_reg)=data)
+#define set_EFUSE_DATA_8_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_8_reg)=data)
+#define set_EFUSE_DATA_9_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_9_reg)=data)
+#define set_EFUSE_DATA_10_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_10_reg)=data)
+#define set_EFUSE_DATA_11_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_11_reg)=data)
+#define set_EFUSE_DATA_12_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_12_reg)=data)
+#define set_EFUSE_DATA_13_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_13_reg)=data)
+#define set_EFUSE_DATA_14_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_14_reg)=data)
+#define set_EFUSE_DATA_15_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_15_reg)=data)
+#define set_EFUSE_DATA_16_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_16_reg)=data)
+#define set_EFUSE_DATA_17_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_17_reg)=data)
+#define set_EFUSE_DATA_18_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_18_reg)=data)
+#define set_EFUSE_DATA_19_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_19_reg)=data)
+#define set_EFUSE_DATA_20_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_20_reg)=data)
+#define set_EFUSE_DATA_21_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_21_reg)=data)
+#define set_EFUSE_DATA_22_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_22_reg)=data)
+#define set_EFUSE_DATA_23_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_23_reg)=data)
+#define set_EFUSE_DATA_24_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_24_reg)=data)
+#define set_EFUSE_DATA_25_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_25_reg)=data)
+#define set_EFUSE_DATA_26_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_26_reg)=data)
+#define set_EFUSE_DATA_27_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_27_reg)=data)
+#define set_EFUSE_DATA_28_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_28_reg)=data)
+#define set_EFUSE_DATA_29_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_29_reg)=data)
+#define set_EFUSE_DATA_30_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_30_reg)=data)
+#define set_EFUSE_DATA_31_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_31_reg)=data)
+#define set_EFUSE_DATA_32_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_32_reg)=data)
+#define set_EFUSE_DATA_33_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_33_reg)=data)
+#define set_EFUSE_DATA_34_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_34_reg)=data)
+#define set_EFUSE_DATA_35_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_35_reg)=data)
+#define set_EFUSE_DATA_36_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_36_reg)=data)
+#define set_EFUSE_DATA_37_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_37_reg)=data)
+#define set_EFUSE_DATA_38_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_38_reg)=data)
+#define set_EFUSE_DATA_39_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_39_reg)=data)
+#define set_EFUSE_DATA_40_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_40_reg)=data)
+#define set_EFUSE_DATA_41_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_41_reg)=data)
+#define set_EFUSE_DATA_42_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_42_reg)=data)
+#define set_EFUSE_DATA_43_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_43_reg)=data)
+#define set_EFUSE_DATA_44_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_44_reg)=data)
+#define set_EFUSE_DATA_45_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_45_reg)=data)
+#define set_EFUSE_DATA_46_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_46_reg)=data)
+#define set_EFUSE_DATA_47_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_47_reg)=data)
+#define set_EFUSE_DATA_48_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_48_reg)=data)
+#define set_EFUSE_DATA_49_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_49_reg)=data)
+#define set_EFUSE_DATA_50_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_50_reg)=data)
+#define set_EFUSE_DATA_51_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_51_reg)=data)
+#define set_EFUSE_DATA_52_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_52_reg)=data)
+#define set_EFUSE_DATA_53_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_53_reg)=data)
+#define set_EFUSE_DATA_54_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_54_reg)=data)
+#define set_EFUSE_DATA_55_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_55_reg)=data)
+#define set_EFUSE_DATA_56_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_56_reg)=data)
+#define set_EFUSE_DATA_57_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_57_reg)=data)
+#define set_EFUSE_DATA_58_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_58_reg)=data)
+#define set_EFUSE_DATA_59_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_59_reg)=data)
+#define set_EFUSE_DATA_60_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_60_reg)=data)
+#define set_EFUSE_DATA_61_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_61_reg)=data)
+#define set_EFUSE_DATA_62_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_62_reg)=data)
+#define set_EFUSE_DATA_63_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_63_reg)=data)
+#define set_EFUSE_DATA_64_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_64_reg)=data)
+#define set_EFUSE_DATA_65_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_65_reg)=data)
+#define set_EFUSE_DATA_66_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_66_reg)=data)
+#define set_EFUSE_DATA_67_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_67_reg)=data)
+#define set_EFUSE_DATA_68_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_68_reg)=data)
+#define set_EFUSE_DATA_69_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_69_reg)=data)
+#define set_EFUSE_DATA_70_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_70_reg)=data)
+#define set_EFUSE_DATA_71_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_71_reg)=data)
+#define set_EFUSE_DATA_72_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_72_reg)=data)
+#define set_EFUSE_DATA_73_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_73_reg)=data)
+#define set_EFUSE_DATA_74_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_74_reg)=data)
+#define set_EFUSE_DATA_75_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_75_reg)=data)
+#define set_EFUSE_DATA_76_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_76_reg)=data)
+#define set_EFUSE_DATA_77_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_77_reg)=data)
+#define set_EFUSE_DATA_78_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_78_reg)=data)
+#define set_EFUSE_DATA_79_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_79_reg)=data)
+#define set_EFUSE_DATA_80_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_80_reg)=data)
+#define set_EFUSE_DATA_81_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_81_reg)=data)
+#define set_EFUSE_DATA_82_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_82_reg)=data)
+#define set_EFUSE_DATA_83_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_83_reg)=data)
+#define set_EFUSE_DATA_84_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_84_reg)=data)
+#define set_EFUSE_DATA_85_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_85_reg)=data)
+#define set_EFUSE_DATA_86_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_86_reg)=data)
+#define set_EFUSE_DATA_87_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_87_reg)=data)
+#define set_EFUSE_DATA_88_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_88_reg)=data)
+#define set_EFUSE_DATA_89_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_89_reg)=data)
+#define set_EFUSE_DATA_90_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_90_reg)=data)
+#define set_EFUSE_DATA_91_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_91_reg)=data)
+#define set_EFUSE_DATA_92_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_92_reg)=data)
+#define set_EFUSE_DATA_93_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_93_reg)=data)
+#define set_EFUSE_DATA_94_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_94_reg)=data)
+#define set_EFUSE_DATA_95_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_95_reg)=data)
+#define set_EFUSE_DATA_96_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_96_reg)=data)
+#define set_EFUSE_DATA_97_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_97_reg)=data)
+#define set_EFUSE_DATA_98_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_98_reg)=data)
+#define set_EFUSE_DATA_99_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_99_reg)=data)
+#define set_EFUSE_DATA_100_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_100_reg)=data)
+#define set_EFUSE_DATA_101_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_101_reg)=data)
+#define set_EFUSE_DATA_102_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_102_reg)=data)
+#define set_EFUSE_DATA_103_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_103_reg)=data)
+#define set_EFUSE_DATA_104_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_104_reg)=data)
+#define set_EFUSE_DATA_105_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_105_reg)=data)
+#define set_EFUSE_DATA_106_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_106_reg)=data)
+#define set_EFUSE_DATA_107_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_107_reg)=data)
+#define set_EFUSE_DATA_108_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_108_reg)=data)
+#define set_EFUSE_DATA_109_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_109_reg)=data)
+#define set_EFUSE_DATA_110_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_110_reg)=data)
+#define set_EFUSE_DATA_111_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_111_reg)=data)
+#define set_EFUSE_DATA_112_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_112_reg)=data)
+#define set_EFUSE_DATA_113_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_113_reg)=data)
+#define set_EFUSE_DATA_114_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_114_reg)=data)
+#define set_EFUSE_DATA_115_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_115_reg)=data)
+#define set_EFUSE_DATA_116_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_116_reg)=data)
+#define set_EFUSE_DATA_117_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_117_reg)=data)
+#define set_EFUSE_DATA_118_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_118_reg)=data)
+#define set_EFUSE_DATA_119_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_119_reg)=data)
+#define set_EFUSE_DATA_120_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_120_reg)=data)
+#define set_EFUSE_DATA_121_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_121_reg)=data)
+#define set_EFUSE_DATA_122_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_122_reg)=data)
+#define set_EFUSE_DATA_123_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_123_reg)=data)
+#define set_EFUSE_DATA_124_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_124_reg)=data)
+#define set_EFUSE_DATA_125_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_125_reg)=data)
+#define set_EFUSE_DATA_126_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_126_reg)=data)
+#define set_EFUSE_DATA_127_reg(data)   (*((volatile unsigned int*) EFUSE_DATA_127_reg)=data)
+#define get_EFUSE_DATA_0_reg   (*((volatile unsigned int*) EFUSE_DATA_0_reg))
+#define get_EFUSE_DATA_1_reg   (*((volatile unsigned int*) EFUSE_DATA_1_reg))
+#define get_EFUSE_DATA_2_reg   (*((volatile unsigned int*) EFUSE_DATA_2_reg))
+#define get_EFUSE_DATA_3_reg   (*((volatile unsigned int*) EFUSE_DATA_3_reg))
+#define get_EFUSE_DATA_4_reg   (*((volatile unsigned int*) EFUSE_DATA_4_reg))
+#define get_EFUSE_DATA_5_reg   (*((volatile unsigned int*) EFUSE_DATA_5_reg))
+#define get_EFUSE_DATA_6_reg   (*((volatile unsigned int*) EFUSE_DATA_6_reg))
+#define get_EFUSE_DATA_7_reg   (*((volatile unsigned int*) EFUSE_DATA_7_reg))
+#define get_EFUSE_DATA_8_reg   (*((volatile unsigned int*) EFUSE_DATA_8_reg))
+#define get_EFUSE_DATA_9_reg   (*((volatile unsigned int*) EFUSE_DATA_9_reg))
+#define get_EFUSE_DATA_10_reg   (*((volatile unsigned int*) EFUSE_DATA_10_reg))
+#define get_EFUSE_DATA_11_reg   (*((volatile unsigned int*) EFUSE_DATA_11_reg))
+#define get_EFUSE_DATA_12_reg   (*((volatile unsigned int*) EFUSE_DATA_12_reg))
+#define get_EFUSE_DATA_13_reg   (*((volatile unsigned int*) EFUSE_DATA_13_reg))
+#define get_EFUSE_DATA_14_reg   (*((volatile unsigned int*) EFUSE_DATA_14_reg))
+#define get_EFUSE_DATA_15_reg   (*((volatile unsigned int*) EFUSE_DATA_15_reg))
+#define get_EFUSE_DATA_16_reg   (*((volatile unsigned int*) EFUSE_DATA_16_reg))
+#define get_EFUSE_DATA_17_reg   (*((volatile unsigned int*) EFUSE_DATA_17_reg))
+#define get_EFUSE_DATA_18_reg   (*((volatile unsigned int*) EFUSE_DATA_18_reg))
+#define get_EFUSE_DATA_19_reg   (*((volatile unsigned int*) EFUSE_DATA_19_reg))
+#define get_EFUSE_DATA_20_reg   (*((volatile unsigned int*) EFUSE_DATA_20_reg))
+#define get_EFUSE_DATA_21_reg   (*((volatile unsigned int*) EFUSE_DATA_21_reg))
+#define get_EFUSE_DATA_22_reg   (*((volatile unsigned int*) EFUSE_DATA_22_reg))
+#define get_EFUSE_DATA_23_reg   (*((volatile unsigned int*) EFUSE_DATA_23_reg))
+#define get_EFUSE_DATA_24_reg   (*((volatile unsigned int*) EFUSE_DATA_24_reg))
+#define get_EFUSE_DATA_25_reg   (*((volatile unsigned int*) EFUSE_DATA_25_reg))
+#define get_EFUSE_DATA_26_reg   (*((volatile unsigned int*) EFUSE_DATA_26_reg))
+#define get_EFUSE_DATA_27_reg   (*((volatile unsigned int*) EFUSE_DATA_27_reg))
+#define get_EFUSE_DATA_28_reg   (*((volatile unsigned int*) EFUSE_DATA_28_reg))
+#define get_EFUSE_DATA_29_reg   (*((volatile unsigned int*) EFUSE_DATA_29_reg))
+#define get_EFUSE_DATA_30_reg   (*((volatile unsigned int*) EFUSE_DATA_30_reg))
+#define get_EFUSE_DATA_31_reg   (*((volatile unsigned int*) EFUSE_DATA_31_reg))
+#define get_EFUSE_DATA_32_reg   (*((volatile unsigned int*) EFUSE_DATA_32_reg))
+#define get_EFUSE_DATA_33_reg   (*((volatile unsigned int*) EFUSE_DATA_33_reg))
+#define get_EFUSE_DATA_34_reg   (*((volatile unsigned int*) EFUSE_DATA_34_reg))
+#define get_EFUSE_DATA_35_reg   (*((volatile unsigned int*) EFUSE_DATA_35_reg))
+#define get_EFUSE_DATA_36_reg   (*((volatile unsigned int*) EFUSE_DATA_36_reg))
+#define get_EFUSE_DATA_37_reg   (*((volatile unsigned int*) EFUSE_DATA_37_reg))
+#define get_EFUSE_DATA_38_reg   (*((volatile unsigned int*) EFUSE_DATA_38_reg))
+#define get_EFUSE_DATA_39_reg   (*((volatile unsigned int*) EFUSE_DATA_39_reg))
+#define get_EFUSE_DATA_40_reg   (*((volatile unsigned int*) EFUSE_DATA_40_reg))
+#define get_EFUSE_DATA_41_reg   (*((volatile unsigned int*) EFUSE_DATA_41_reg))
+#define get_EFUSE_DATA_42_reg   (*((volatile unsigned int*) EFUSE_DATA_42_reg))
+#define get_EFUSE_DATA_43_reg   (*((volatile unsigned int*) EFUSE_DATA_43_reg))
+#define get_EFUSE_DATA_44_reg   (*((volatile unsigned int*) EFUSE_DATA_44_reg))
+#define get_EFUSE_DATA_45_reg   (*((volatile unsigned int*) EFUSE_DATA_45_reg))
+#define get_EFUSE_DATA_46_reg   (*((volatile unsigned int*) EFUSE_DATA_46_reg))
+#define get_EFUSE_DATA_47_reg   (*((volatile unsigned int*) EFUSE_DATA_47_reg))
+#define get_EFUSE_DATA_48_reg   (*((volatile unsigned int*) EFUSE_DATA_48_reg))
+#define get_EFUSE_DATA_49_reg   (*((volatile unsigned int*) EFUSE_DATA_49_reg))
+#define get_EFUSE_DATA_50_reg   (*((volatile unsigned int*) EFUSE_DATA_50_reg))
+#define get_EFUSE_DATA_51_reg   (*((volatile unsigned int*) EFUSE_DATA_51_reg))
+#define get_EFUSE_DATA_52_reg   (*((volatile unsigned int*) EFUSE_DATA_52_reg))
+#define get_EFUSE_DATA_53_reg   (*((volatile unsigned int*) EFUSE_DATA_53_reg))
+#define get_EFUSE_DATA_54_reg   (*((volatile unsigned int*) EFUSE_DATA_54_reg))
+#define get_EFUSE_DATA_55_reg   (*((volatile unsigned int*) EFUSE_DATA_55_reg))
+#define get_EFUSE_DATA_56_reg   (*((volatile unsigned int*) EFUSE_DATA_56_reg))
+#define get_EFUSE_DATA_57_reg   (*((volatile unsigned int*) EFUSE_DATA_57_reg))
+#define get_EFUSE_DATA_58_reg   (*((volatile unsigned int*) EFUSE_DATA_58_reg))
+#define get_EFUSE_DATA_59_reg   (*((volatile unsigned int*) EFUSE_DATA_59_reg))
+#define get_EFUSE_DATA_60_reg   (*((volatile unsigned int*) EFUSE_DATA_60_reg))
+#define get_EFUSE_DATA_61_reg   (*((volatile unsigned int*) EFUSE_DATA_61_reg))
+#define get_EFUSE_DATA_62_reg   (*((volatile unsigned int*) EFUSE_DATA_62_reg))
+#define get_EFUSE_DATA_63_reg   (*((volatile unsigned int*) EFUSE_DATA_63_reg))
+#define get_EFUSE_DATA_64_reg   (*((volatile unsigned int*) EFUSE_DATA_64_reg))
+#define get_EFUSE_DATA_65_reg   (*((volatile unsigned int*) EFUSE_DATA_65_reg))
+#define get_EFUSE_DATA_66_reg   (*((volatile unsigned int*) EFUSE_DATA_66_reg))
+#define get_EFUSE_DATA_67_reg   (*((volatile unsigned int*) EFUSE_DATA_67_reg))
+#define get_EFUSE_DATA_68_reg   (*((volatile unsigned int*) EFUSE_DATA_68_reg))
+#define get_EFUSE_DATA_69_reg   (*((volatile unsigned int*) EFUSE_DATA_69_reg))
+#define get_EFUSE_DATA_70_reg   (*((volatile unsigned int*) EFUSE_DATA_70_reg))
+#define get_EFUSE_DATA_71_reg   (*((volatile unsigned int*) EFUSE_DATA_71_reg))
+#define get_EFUSE_DATA_72_reg   (*((volatile unsigned int*) EFUSE_DATA_72_reg))
+#define get_EFUSE_DATA_73_reg   (*((volatile unsigned int*) EFUSE_DATA_73_reg))
+#define get_EFUSE_DATA_74_reg   (*((volatile unsigned int*) EFUSE_DATA_74_reg))
+#define get_EFUSE_DATA_75_reg   (*((volatile unsigned int*) EFUSE_DATA_75_reg))
+#define get_EFUSE_DATA_76_reg   (*((volatile unsigned int*) EFUSE_DATA_76_reg))
+#define get_EFUSE_DATA_77_reg   (*((volatile unsigned int*) EFUSE_DATA_77_reg))
+#define get_EFUSE_DATA_78_reg   (*((volatile unsigned int*) EFUSE_DATA_78_reg))
+#define get_EFUSE_DATA_79_reg   (*((volatile unsigned int*) EFUSE_DATA_79_reg))
+#define get_EFUSE_DATA_80_reg   (*((volatile unsigned int*) EFUSE_DATA_80_reg))
+#define get_EFUSE_DATA_81_reg   (*((volatile unsigned int*) EFUSE_DATA_81_reg))
+#define get_EFUSE_DATA_82_reg   (*((volatile unsigned int*) EFUSE_DATA_82_reg))
+#define get_EFUSE_DATA_83_reg   (*((volatile unsigned int*) EFUSE_DATA_83_reg))
+#define get_EFUSE_DATA_84_reg   (*((volatile unsigned int*) EFUSE_DATA_84_reg))
+#define get_EFUSE_DATA_85_reg   (*((volatile unsigned int*) EFUSE_DATA_85_reg))
+#define get_EFUSE_DATA_86_reg   (*((volatile unsigned int*) EFUSE_DATA_86_reg))
+#define get_EFUSE_DATA_87_reg   (*((volatile unsigned int*) EFUSE_DATA_87_reg))
+#define get_EFUSE_DATA_88_reg   (*((volatile unsigned int*) EFUSE_DATA_88_reg))
+#define get_EFUSE_DATA_89_reg   (*((volatile unsigned int*) EFUSE_DATA_89_reg))
+#define get_EFUSE_DATA_90_reg   (*((volatile unsigned int*) EFUSE_DATA_90_reg))
+#define get_EFUSE_DATA_91_reg   (*((volatile unsigned int*) EFUSE_DATA_91_reg))
+#define get_EFUSE_DATA_92_reg   (*((volatile unsigned int*) EFUSE_DATA_92_reg))
+#define get_EFUSE_DATA_93_reg   (*((volatile unsigned int*) EFUSE_DATA_93_reg))
+#define get_EFUSE_DATA_94_reg   (*((volatile unsigned int*) EFUSE_DATA_94_reg))
+#define get_EFUSE_DATA_95_reg   (*((volatile unsigned int*) EFUSE_DATA_95_reg))
+#define get_EFUSE_DATA_96_reg   (*((volatile unsigned int*) EFUSE_DATA_96_reg))
+#define get_EFUSE_DATA_97_reg   (*((volatile unsigned int*) EFUSE_DATA_97_reg))
+#define get_EFUSE_DATA_98_reg   (*((volatile unsigned int*) EFUSE_DATA_98_reg))
+#define get_EFUSE_DATA_99_reg   (*((volatile unsigned int*) EFUSE_DATA_99_reg))
+#define get_EFUSE_DATA_100_reg   (*((volatile unsigned int*) EFUSE_DATA_100_reg))
+#define get_EFUSE_DATA_101_reg   (*((volatile unsigned int*) EFUSE_DATA_101_reg))
+#define get_EFUSE_DATA_102_reg   (*((volatile unsigned int*) EFUSE_DATA_102_reg))
+#define get_EFUSE_DATA_103_reg   (*((volatile unsigned int*) EFUSE_DATA_103_reg))
+#define get_EFUSE_DATA_104_reg   (*((volatile unsigned int*) EFUSE_DATA_104_reg))
+#define get_EFUSE_DATA_105_reg   (*((volatile unsigned int*) EFUSE_DATA_105_reg))
+#define get_EFUSE_DATA_106_reg   (*((volatile unsigned int*) EFUSE_DATA_106_reg))
+#define get_EFUSE_DATA_107_reg   (*((volatile unsigned int*) EFUSE_DATA_107_reg))
+#define get_EFUSE_DATA_108_reg   (*((volatile unsigned int*) EFUSE_DATA_108_reg))
+#define get_EFUSE_DATA_109_reg   (*((volatile unsigned int*) EFUSE_DATA_109_reg))
+#define get_EFUSE_DATA_110_reg   (*((volatile unsigned int*) EFUSE_DATA_110_reg))
+#define get_EFUSE_DATA_111_reg   (*((volatile unsigned int*) EFUSE_DATA_111_reg))
+#define get_EFUSE_DATA_112_reg   (*((volatile unsigned int*) EFUSE_DATA_112_reg))
+#define get_EFUSE_DATA_113_reg   (*((volatile unsigned int*) EFUSE_DATA_113_reg))
+#define get_EFUSE_DATA_114_reg   (*((volatile unsigned int*) EFUSE_DATA_114_reg))
+#define get_EFUSE_DATA_115_reg   (*((volatile unsigned int*) EFUSE_DATA_115_reg))
+#define get_EFUSE_DATA_116_reg   (*((volatile unsigned int*) EFUSE_DATA_116_reg))
+#define get_EFUSE_DATA_117_reg   (*((volatile unsigned int*) EFUSE_DATA_117_reg))
+#define get_EFUSE_DATA_118_reg   (*((volatile unsigned int*) EFUSE_DATA_118_reg))
+#define get_EFUSE_DATA_119_reg   (*((volatile unsigned int*) EFUSE_DATA_119_reg))
+#define get_EFUSE_DATA_120_reg   (*((volatile unsigned int*) EFUSE_DATA_120_reg))
+#define get_EFUSE_DATA_121_reg   (*((volatile unsigned int*) EFUSE_DATA_121_reg))
+#define get_EFUSE_DATA_122_reg   (*((volatile unsigned int*) EFUSE_DATA_122_reg))
+#define get_EFUSE_DATA_123_reg   (*((volatile unsigned int*) EFUSE_DATA_123_reg))
+#define get_EFUSE_DATA_124_reg   (*((volatile unsigned int*) EFUSE_DATA_124_reg))
+#define get_EFUSE_DATA_125_reg   (*((volatile unsigned int*) EFUSE_DATA_125_reg))
+#define get_EFUSE_DATA_126_reg   (*((volatile unsigned int*) EFUSE_DATA_126_reg))
+#define get_EFUSE_DATA_127_reg   (*((volatile unsigned int*) EFUSE_DATA_127_reg))
+#define EFUSE_DATA_0_inst_adr                                                        "0x0000"
+#define EFUSE_DATA_1_inst_adr                                                        "0x0001"
+#define EFUSE_DATA_2_inst_adr                                                        "0x0002"
+#define EFUSE_DATA_3_inst_adr                                                        "0x0003"
+#define EFUSE_DATA_4_inst_adr                                                        "0x0004"
+#define EFUSE_DATA_5_inst_adr                                                        "0x0005"
+#define EFUSE_DATA_6_inst_adr                                                        "0x0006"
+#define EFUSE_DATA_7_inst_adr                                                        "0x0007"
+#define EFUSE_DATA_8_inst_adr                                                        "0x0008"
+#define EFUSE_DATA_9_inst_adr                                                        "0x0009"
+#define EFUSE_DATA_10_inst_adr                                                        "0x000A"
+#define EFUSE_DATA_11_inst_adr                                                        "0x000B"
+#define EFUSE_DATA_12_inst_adr                                                        "0x000C"
+#define EFUSE_DATA_13_inst_adr                                                        "0x000D"
+#define EFUSE_DATA_14_inst_adr                                                        "0x000E"
+#define EFUSE_DATA_15_inst_adr                                                        "0x000F"
+#define EFUSE_DATA_16_inst_adr                                                        "0x0010"
+#define EFUSE_DATA_17_inst_adr                                                        "0x0011"
+#define EFUSE_DATA_18_inst_adr                                                        "0x0012"
+#define EFUSE_DATA_19_inst_adr                                                        "0x0013"
+#define EFUSE_DATA_20_inst_adr                                                        "0x0014"
+#define EFUSE_DATA_21_inst_adr                                                        "0x0015"
+#define EFUSE_DATA_22_inst_adr                                                        "0x0016"
+#define EFUSE_DATA_23_inst_adr                                                        "0x0017"
+#define EFUSE_DATA_24_inst_adr                                                        "0x0018"
+#define EFUSE_DATA_25_inst_adr                                                        "0x0019"
+#define EFUSE_DATA_26_inst_adr                                                        "0x001A"
+#define EFUSE_DATA_27_inst_adr                                                        "0x001B"
+#define EFUSE_DATA_28_inst_adr                                                        "0x001C"
+#define EFUSE_DATA_29_inst_adr                                                        "0x001D"
+#define EFUSE_DATA_30_inst_adr                                                        "0x001E"
+#define EFUSE_DATA_31_inst_adr                                                        "0x001F"
+#define EFUSE_DATA_32_inst_adr                                                        "0x0020"
+#define EFUSE_DATA_33_inst_adr                                                        "0x0021"
+#define EFUSE_DATA_34_inst_adr                                                        "0x0022"
+#define EFUSE_DATA_35_inst_adr                                                        "0x0023"
+#define EFUSE_DATA_36_inst_adr                                                        "0x0024"
+#define EFUSE_DATA_37_inst_adr                                                        "0x0025"
+#define EFUSE_DATA_38_inst_adr                                                        "0x0026"
+#define EFUSE_DATA_39_inst_adr                                                        "0x0027"
+#define EFUSE_DATA_40_inst_adr                                                        "0x0028"
+#define EFUSE_DATA_41_inst_adr                                                        "0x0029"
+#define EFUSE_DATA_42_inst_adr                                                        "0x002A"
+#define EFUSE_DATA_43_inst_adr                                                        "0x002B"
+#define EFUSE_DATA_44_inst_adr                                                        "0x002C"
+#define EFUSE_DATA_45_inst_adr                                                        "0x002D"
+#define EFUSE_DATA_46_inst_adr                                                        "0x002E"
+#define EFUSE_DATA_47_inst_adr                                                        "0x002F"
+#define EFUSE_DATA_48_inst_adr                                                        "0x0030"
+#define EFUSE_DATA_49_inst_adr                                                        "0x0031"
+#define EFUSE_DATA_50_inst_adr                                                        "0x0032"
+#define EFUSE_DATA_51_inst_adr                                                        "0x0033"
+#define EFUSE_DATA_52_inst_adr                                                        "0x0034"
+#define EFUSE_DATA_53_inst_adr                                                        "0x0035"
+#define EFUSE_DATA_54_inst_adr                                                        "0x0036"
+#define EFUSE_DATA_55_inst_adr                                                        "0x0037"
+#define EFUSE_DATA_56_inst_adr                                                        "0x0038"
+#define EFUSE_DATA_57_inst_adr                                                        "0x0039"
+#define EFUSE_DATA_58_inst_adr                                                        "0x003A"
+#define EFUSE_DATA_59_inst_adr                                                        "0x003B"
+#define EFUSE_DATA_60_inst_adr                                                        "0x003C"
+#define EFUSE_DATA_61_inst_adr                                                        "0x003D"
+#define EFUSE_DATA_62_inst_adr                                                        "0x003E"
+#define EFUSE_DATA_63_inst_adr                                                        "0x003F"
+#define EFUSE_DATA_64_inst_adr                                                        "0x0040"
+#define EFUSE_DATA_65_inst_adr                                                        "0x0041"
+#define EFUSE_DATA_66_inst_adr                                                        "0x0042"
+#define EFUSE_DATA_67_inst_adr                                                        "0x0043"
+#define EFUSE_DATA_68_inst_adr                                                        "0x0044"
+#define EFUSE_DATA_69_inst_adr                                                        "0x0045"
+#define EFUSE_DATA_70_inst_adr                                                        "0x0046"
+#define EFUSE_DATA_71_inst_adr                                                        "0x0047"
+#define EFUSE_DATA_72_inst_adr                                                        "0x0048"
+#define EFUSE_DATA_73_inst_adr                                                        "0x0049"
+#define EFUSE_DATA_74_inst_adr                                                        "0x004A"
+#define EFUSE_DATA_75_inst_adr                                                        "0x004B"
+#define EFUSE_DATA_76_inst_adr                                                        "0x004C"
+#define EFUSE_DATA_77_inst_adr                                                        "0x004D"
+#define EFUSE_DATA_78_inst_adr                                                        "0x004E"
+#define EFUSE_DATA_79_inst_adr                                                        "0x004F"
+#define EFUSE_DATA_80_inst_adr                                                        "0x0050"
+#define EFUSE_DATA_81_inst_adr                                                        "0x0051"
+#define EFUSE_DATA_82_inst_adr                                                        "0x0052"
+#define EFUSE_DATA_83_inst_adr                                                        "0x0053"
+#define EFUSE_DATA_84_inst_adr                                                        "0x0054"
+#define EFUSE_DATA_85_inst_adr                                                        "0x0055"
+#define EFUSE_DATA_86_inst_adr                                                        "0x0056"
+#define EFUSE_DATA_87_inst_adr                                                        "0x0057"
+#define EFUSE_DATA_88_inst_adr                                                        "0x0058"
+#define EFUSE_DATA_89_inst_adr                                                        "0x0059"
+#define EFUSE_DATA_90_inst_adr                                                        "0x005A"
+#define EFUSE_DATA_91_inst_adr                                                        "0x005B"
+#define EFUSE_DATA_92_inst_adr                                                        "0x005C"
+#define EFUSE_DATA_93_inst_adr                                                        "0x005D"
+#define EFUSE_DATA_94_inst_adr                                                        "0x005E"
+#define EFUSE_DATA_95_inst_adr                                                        "0x005F"
+#define EFUSE_DATA_96_inst_adr                                                        "0x0060"
+#define EFUSE_DATA_97_inst_adr                                                        "0x0061"
+#define EFUSE_DATA_98_inst_adr                                                        "0x0062"
+#define EFUSE_DATA_99_inst_adr                                                        "0x0063"
+#define EFUSE_DATA_100_inst_adr                                                        "0x0064"
+#define EFUSE_DATA_101_inst_adr                                                        "0x0065"
+#define EFUSE_DATA_102_inst_adr                                                        "0x0066"
+#define EFUSE_DATA_103_inst_adr                                                        "0x0067"
+#define EFUSE_DATA_104_inst_adr                                                        "0x0068"
+#define EFUSE_DATA_105_inst_adr                                                        "0x0069"
+#define EFUSE_DATA_106_inst_adr                                                        "0x006A"
+#define EFUSE_DATA_107_inst_adr                                                        "0x006B"
+#define EFUSE_DATA_108_inst_adr                                                        "0x006C"
+#define EFUSE_DATA_109_inst_adr                                                        "0x006D"
+#define EFUSE_DATA_110_inst_adr                                                        "0x006E"
+#define EFUSE_DATA_111_inst_adr                                                        "0x006F"
+#define EFUSE_DATA_112_inst_adr                                                        "0x0070"
+#define EFUSE_DATA_113_inst_adr                                                        "0x0071"
+#define EFUSE_DATA_114_inst_adr                                                        "0x0072"
+#define EFUSE_DATA_115_inst_adr                                                        "0x0073"
+#define EFUSE_DATA_116_inst_adr                                                        "0x0074"
+#define EFUSE_DATA_117_inst_adr                                                        "0x0075"
+#define EFUSE_DATA_118_inst_adr                                                        "0x0076"
+#define EFUSE_DATA_119_inst_adr                                                        "0x0077"
+#define EFUSE_DATA_120_inst_adr                                                        "0x0078"
+#define EFUSE_DATA_121_inst_adr                                                        "0x0079"
+#define EFUSE_DATA_122_inst_adr                                                        "0x007A"
+#define EFUSE_DATA_123_inst_adr                                                        "0x007B"
+#define EFUSE_DATA_124_inst_adr                                                        "0x007C"
+#define EFUSE_DATA_125_inst_adr                                                        "0x007D"
+#define EFUSE_DATA_126_inst_adr                                                        "0x007E"
+#define EFUSE_DATA_127_inst_adr                                                        "0x007F"
+#define EFUSE_DATA_0_inst                                                            0x0000
+#define EFUSE_DATA_1_inst                                                            0x0001
+#define EFUSE_DATA_2_inst                                                            0x0002
+#define EFUSE_DATA_3_inst                                                            0x0003
+#define EFUSE_DATA_4_inst                                                            0x0004
+#define EFUSE_DATA_5_inst                                                            0x0005
+#define EFUSE_DATA_6_inst                                                            0x0006
+#define EFUSE_DATA_7_inst                                                            0x0007
+#define EFUSE_DATA_8_inst                                                            0x0008
+#define EFUSE_DATA_9_inst                                                            0x0009
+#define EFUSE_DATA_10_inst                                                            0x000A
+#define EFUSE_DATA_11_inst                                                            0x000B
+#define EFUSE_DATA_12_inst                                                            0x000C
+#define EFUSE_DATA_13_inst                                                            0x000D
+#define EFUSE_DATA_14_inst                                                            0x000E
+#define EFUSE_DATA_15_inst                                                            0x000F
+#define EFUSE_DATA_16_inst                                                            0x0010
+#define EFUSE_DATA_17_inst                                                            0x0011
+#define EFUSE_DATA_18_inst                                                            0x0012
+#define EFUSE_DATA_19_inst                                                            0x0013
+#define EFUSE_DATA_20_inst                                                            0x0014
+#define EFUSE_DATA_21_inst                                                            0x0015
+#define EFUSE_DATA_22_inst                                                            0x0016
+#define EFUSE_DATA_23_inst                                                            0x0017
+#define EFUSE_DATA_24_inst                                                            0x0018
+#define EFUSE_DATA_25_inst                                                            0x0019
+#define EFUSE_DATA_26_inst                                                            0x001A
+#define EFUSE_DATA_27_inst                                                            0x001B
+#define EFUSE_DATA_28_inst                                                            0x001C
+#define EFUSE_DATA_29_inst                                                            0x001D
+#define EFUSE_DATA_30_inst                                                            0x001E
+#define EFUSE_DATA_31_inst                                                            0x001F
+#define EFUSE_DATA_32_inst                                                            0x0020
+#define EFUSE_DATA_33_inst                                                            0x0021
+#define EFUSE_DATA_34_inst                                                            0x0022
+#define EFUSE_DATA_35_inst                                                            0x0023
+#define EFUSE_DATA_36_inst                                                            0x0024
+#define EFUSE_DATA_37_inst                                                            0x0025
+#define EFUSE_DATA_38_inst                                                            0x0026
+#define EFUSE_DATA_39_inst                                                            0x0027
+#define EFUSE_DATA_40_inst                                                            0x0028
+#define EFUSE_DATA_41_inst                                                            0x0029
+#define EFUSE_DATA_42_inst                                                            0x002A
+#define EFUSE_DATA_43_inst                                                            0x002B
+#define EFUSE_DATA_44_inst                                                            0x002C
+#define EFUSE_DATA_45_inst                                                            0x002D
+#define EFUSE_DATA_46_inst                                                            0x002E
+#define EFUSE_DATA_47_inst                                                            0x002F
+#define EFUSE_DATA_48_inst                                                            0x0030
+#define EFUSE_DATA_49_inst                                                            0x0031
+#define EFUSE_DATA_50_inst                                                            0x0032
+#define EFUSE_DATA_51_inst                                                            0x0033
+#define EFUSE_DATA_52_inst                                                            0x0034
+#define EFUSE_DATA_53_inst                                                            0x0035
+#define EFUSE_DATA_54_inst                                                            0x0036
+#define EFUSE_DATA_55_inst                                                            0x0037
+#define EFUSE_DATA_56_inst                                                            0x0038
+#define EFUSE_DATA_57_inst                                                            0x0039
+#define EFUSE_DATA_58_inst                                                            0x003A
+#define EFUSE_DATA_59_inst                                                            0x003B
+#define EFUSE_DATA_60_inst                                                            0x003C
+#define EFUSE_DATA_61_inst                                                            0x003D
+#define EFUSE_DATA_62_inst                                                            0x003E
+#define EFUSE_DATA_63_inst                                                            0x003F
+#define EFUSE_DATA_64_inst                                                            0x0040
+#define EFUSE_DATA_65_inst                                                            0x0041
+#define EFUSE_DATA_66_inst                                                            0x0042
+#define EFUSE_DATA_67_inst                                                            0x0043
+#define EFUSE_DATA_68_inst                                                            0x0044
+#define EFUSE_DATA_69_inst                                                            0x0045
+#define EFUSE_DATA_70_inst                                                            0x0046
+#define EFUSE_DATA_71_inst                                                            0x0047
+#define EFUSE_DATA_72_inst                                                            0x0048
+#define EFUSE_DATA_73_inst                                                            0x0049
+#define EFUSE_DATA_74_inst                                                            0x004A
+#define EFUSE_DATA_75_inst                                                            0x004B
+#define EFUSE_DATA_76_inst                                                            0x004C
+#define EFUSE_DATA_77_inst                                                            0x004D
+#define EFUSE_DATA_78_inst                                                            0x004E
+#define EFUSE_DATA_79_inst                                                            0x004F
+#define EFUSE_DATA_80_inst                                                            0x0050
+#define EFUSE_DATA_81_inst                                                            0x0051
+#define EFUSE_DATA_82_inst                                                            0x0052
+#define EFUSE_DATA_83_inst                                                            0x0053
+#define EFUSE_DATA_84_inst                                                            0x0054
+#define EFUSE_DATA_85_inst                                                            0x0055
+#define EFUSE_DATA_86_inst                                                            0x0056
+#define EFUSE_DATA_87_inst                                                            0x0057
+#define EFUSE_DATA_88_inst                                                            0x0058
+#define EFUSE_DATA_89_inst                                                            0x0059
+#define EFUSE_DATA_90_inst                                                            0x005A
+#define EFUSE_DATA_91_inst                                                            0x005B
+#define EFUSE_DATA_92_inst                                                            0x005C
+#define EFUSE_DATA_93_inst                                                            0x005D
+#define EFUSE_DATA_94_inst                                                            0x005E
+#define EFUSE_DATA_95_inst                                                            0x005F
+#define EFUSE_DATA_96_inst                                                            0x0060
+#define EFUSE_DATA_97_inst                                                            0x0061
+#define EFUSE_DATA_98_inst                                                            0x0062
+#define EFUSE_DATA_99_inst                                                            0x0063
+#define EFUSE_DATA_100_inst                                                            0x0064
+#define EFUSE_DATA_101_inst                                                            0x0065
+#define EFUSE_DATA_102_inst                                                            0x0066
+#define EFUSE_DATA_103_inst                                                            0x0067
+#define EFUSE_DATA_104_inst                                                            0x0068
+#define EFUSE_DATA_105_inst                                                            0x0069
+#define EFUSE_DATA_106_inst                                                            0x006A
+#define EFUSE_DATA_107_inst                                                            0x006B
+#define EFUSE_DATA_108_inst                                                            0x006C
+#define EFUSE_DATA_109_inst                                                            0x006D
+#define EFUSE_DATA_110_inst                                                            0x006E
+#define EFUSE_DATA_111_inst                                                            0x006F
+#define EFUSE_DATA_112_inst                                                            0x0070
+#define EFUSE_DATA_113_inst                                                            0x0071
+#define EFUSE_DATA_114_inst                                                            0x0072
+#define EFUSE_DATA_115_inst                                                            0x0073
+#define EFUSE_DATA_116_inst                                                            0x0074
+#define EFUSE_DATA_117_inst                                                            0x0075
+#define EFUSE_DATA_118_inst                                                            0x0076
+#define EFUSE_DATA_119_inst                                                            0x0077
+#define EFUSE_DATA_120_inst                                                            0x0078
+#define EFUSE_DATA_121_inst                                                            0x0079
+#define EFUSE_DATA_122_inst                                                            0x007A
+#define EFUSE_DATA_123_inst                                                            0x007B
+#define EFUSE_DATA_124_inst                                                            0x007C
+#define EFUSE_DATA_125_inst                                                            0x007D
+#define EFUSE_DATA_126_inst                                                            0x007E
+#define EFUSE_DATA_127_inst                                                            0x007F
+#define EFUSE_DATA_datao_shift                                                       (0)
+#define EFUSE_DATA_datao_mask                                                        (0xFFFFFFFF)
+#define EFUSE_DATA_datao(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define EFUSE_DATA_datao_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define EFUSE_DATA_get_datao(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define EFUSE_EF_CTRL                                                                0x18017400
+#define EFUSE_EF_CTRL_reg_addr                                                       "0xB8017400"
+#define EFUSE_EF_CTRL_reg                                                            0xB8017400
+#define set_EFUSE_EF_CTRL_reg(data)   (*((volatile unsigned int*) EFUSE_EF_CTRL_reg)=data)
+#define get_EFUSE_EF_CTRL_reg   (*((volatile unsigned int*) EFUSE_EF_CTRL_reg))
+#define EFUSE_EF_CTRL_inst_adr                                                       "0x0000"
+#define EFUSE_EF_CTRL_inst                                                           0x0000
+#define EFUSE_EF_CTRL_write_enable4_shift                                            (23)
+#define EFUSE_EF_CTRL_write_enable4_mask                                             (0x00800000)
+#define EFUSE_EF_CTRL_write_enable4(data)                                            (0x00800000&((data)<<23))
+#define EFUSE_EF_CTRL_write_enable4_src(data)                                        ((0x00800000&(data))>>23)
+#define EFUSE_EF_CTRL_get_write_enable4(data)                                        ((0x00800000&(data))>>23)
+#define EFUSE_EF_CTRL_en_pro_efuse_shift                                             (22)
+#define EFUSE_EF_CTRL_en_pro_efuse_mask                                              (0x00400000)
+#define EFUSE_EF_CTRL_en_pro_efuse(data)                                             (0x00400000&((data)<<22))
+#define EFUSE_EF_CTRL_en_pro_efuse_src(data)                                         ((0x00400000&(data))>>22)
+#define EFUSE_EF_CTRL_get_en_pro_efuse(data)                                         ((0x00400000&(data))>>22)
+#define EFUSE_EF_CTRL_write_enable3_shift                                            (21)
+#define EFUSE_EF_CTRL_write_enable3_mask                                             (0x00200000)
+#define EFUSE_EF_CTRL_write_enable3(data)                                            (0x00200000&((data)<<21))
+#define EFUSE_EF_CTRL_write_enable3_src(data)                                        ((0x00200000&(data))>>21)
+#define EFUSE_EF_CTRL_get_write_enable3(data)                                        ((0x00200000&(data))>>21)
+#define EFUSE_EF_CTRL_auto_rd_req_shift                                              (20)
+#define EFUSE_EF_CTRL_auto_rd_req_mask                                               (0x00100000)
+#define EFUSE_EF_CTRL_auto_rd_req(data)                                              (0x00100000&((data)<<20))
+#define EFUSE_EF_CTRL_auto_rd_req_src(data)                                          ((0x00100000&(data))>>20)
+#define EFUSE_EF_CTRL_get_auto_rd_req(data)                                          ((0x00100000&(data))>>20)
+#define EFUSE_EF_CTRL_write_enable2_shift                                            (15)
+#define EFUSE_EF_CTRL_write_enable2_mask                                             (0x00008000)
+#define EFUSE_EF_CTRL_write_enable2(data)                                            (0x00008000&((data)<<15))
+#define EFUSE_EF_CTRL_write_enable2_src(data)                                        ((0x00008000&(data))>>15)
+#define EFUSE_EF_CTRL_get_write_enable2(data)                                        ((0x00008000&(data))>>15)
+#define EFUSE_EF_CTRL_strobe_shift                                                   (14)
+#define EFUSE_EF_CTRL_strobe_mask                                                    (0x00004000)
+#define EFUSE_EF_CTRL_strobe(data)                                                   (0x00004000&((data)<<14))
+#define EFUSE_EF_CTRL_strobe_src(data)                                               ((0x00004000&(data))>>14)
+#define EFUSE_EF_CTRL_get_strobe(data)                                               ((0x00004000&(data))>>14)
+#define EFUSE_EF_CTRL_write_enable1_shift                                            (13)
+#define EFUSE_EF_CTRL_write_enable1_mask                                             (0x00002000)
+#define EFUSE_EF_CTRL_write_enable1(data)                                            (0x00002000&((data)<<13))
+#define EFUSE_EF_CTRL_write_enable1_src(data)                                        ((0x00002000&(data))>>13)
+#define EFUSE_EF_CTRL_get_write_enable1(data)                                        ((0x00002000&(data))>>13)
+#define EFUSE_EF_CTRL_a_shift                                                        (0)
+#define EFUSE_EF_CTRL_a_mask                                                         (0x00001FFF)
+#define EFUSE_EF_CTRL_a(data)                                                        (0x00001FFF&((data)<<0))
+#define EFUSE_EF_CTRL_a_src(data)                                                    ((0x00001FFF&(data))>>0)
+#define EFUSE_EF_CTRL_get_a(data)                                                    ((0x00001FFF&(data))>>0)
+
+
+#define EFUSE_EF_CTRL_ST                                                             0x18017404
+#define EFUSE_EF_CTRL_ST_reg_addr                                                    "0xB8017404"
+#define EFUSE_EF_CTRL_ST_reg                                                         0xB8017404
+#define set_EFUSE_EF_CTRL_ST_reg(data)   (*((volatile unsigned int*) EFUSE_EF_CTRL_ST_reg)=data)
+#define get_EFUSE_EF_CTRL_ST_reg   (*((volatile unsigned int*) EFUSE_EF_CTRL_ST_reg))
+#define EFUSE_EF_CTRL_ST_inst_adr                                                    "0x0001"
+#define EFUSE_EF_CTRL_ST_inst                                                        0x0001
+#define EFUSE_EF_CTRL_ST_pro_efuse_act_shift                                         (16)
+#define EFUSE_EF_CTRL_ST_pro_efuse_act_mask                                          (0x00010000)
+#define EFUSE_EF_CTRL_ST_pro_efuse_act(data)                                         (0x00010000&((data)<<16))
+#define EFUSE_EF_CTRL_ST_pro_efuse_act_src(data)                                     ((0x00010000&(data))>>16)
+#define EFUSE_EF_CTRL_ST_get_pro_efuse_act(data)                                     ((0x00010000&(data))>>16)
+#define EFUSE_EF_CTRL_ST_crc_en_shift                                                (0)
+#define EFUSE_EF_CTRL_ST_crc_en_mask                                                 (0x00000001)
+#define EFUSE_EF_CTRL_ST_crc_en(data)                                                (0x00000001&((data)<<0))
+#define EFUSE_EF_CTRL_ST_crc_en_src(data)                                            ((0x00000001&(data))>>0)
+#define EFUSE_EF_CTRL_ST_get_crc_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define EFUSE_EF_CRC                                                                 0x18017408
+#define EFUSE_EF_CRC_reg_addr                                                        "0xB8017408"
+#define EFUSE_EF_CRC_reg                                                             0xB8017408
+#define set_EFUSE_EF_CRC_reg(data)   (*((volatile unsigned int*) EFUSE_EF_CRC_reg)=data)
+#define get_EFUSE_EF_CRC_reg   (*((volatile unsigned int*) EFUSE_EF_CRC_reg))
+#define EFUSE_EF_CRC_inst_adr                                                        "0x0002"
+#define EFUSE_EF_CRC_inst                                                            0x0002
+#define EFUSE_EF_CRC_crc_ini_shift                                                   (16)
+#define EFUSE_EF_CRC_crc_ini_mask                                                    (0x00FF0000)
+#define EFUSE_EF_CRC_crc_ini(data)                                                   (0x00FF0000&((data)<<16))
+#define EFUSE_EF_CRC_crc_ini_src(data)                                               ((0x00FF0000&(data))>>16)
+#define EFUSE_EF_CRC_get_crc_ini(data)                                               ((0x00FF0000&(data))>>16)
+#define EFUSE_EF_CRC_crc_out_shift                                                   (0)
+#define EFUSE_EF_CRC_crc_out_mask                                                    (0x000000FF)
+#define EFUSE_EF_CRC_crc_out(data)                                                   (0x000000FF&((data)<<0))
+#define EFUSE_EF_CRC_crc_out_src(data)                                               ((0x000000FF&(data))>>0)
+#define EFUSE_EF_CRC_get_crc_out(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define EFUSE_EF_CTRL_NEW                                                            0x1801740C
+#define EFUSE_EF_CTRL_NEW_reg_addr                                                   "0xB801740C"
+#define EFUSE_EF_CTRL_NEW_reg                                                        0xB801740C
+#define set_EFUSE_EF_CTRL_NEW_reg(data)   (*((volatile unsigned int*) EFUSE_EF_CTRL_NEW_reg)=data)
+#define get_EFUSE_EF_CTRL_NEW_reg   (*((volatile unsigned int*) EFUSE_EF_CTRL_NEW_reg))
+#define EFUSE_EF_CTRL_NEW_inst_adr                                                   "0x0003"
+#define EFUSE_EF_CTRL_NEW_inst                                                       0x0003
+#define EFUSE_EF_CTRL_NEW_write_enable2_shift                                        (7)
+#define EFUSE_EF_CTRL_NEW_write_enable2_mask                                         (0x00000080)
+#define EFUSE_EF_CTRL_NEW_write_enable2(data)                                        (0x00000080&((data)<<7))
+#define EFUSE_EF_CTRL_NEW_write_enable2_src(data)                                    ((0x00000080&(data))>>7)
+#define EFUSE_EF_CTRL_NEW_get_write_enable2(data)                                    ((0x00000080&(data))>>7)
+#define EFUSE_EF_CTRL_NEW_mr_mode_shift                                              (6)
+#define EFUSE_EF_CTRL_NEW_mr_mode_mask                                               (0x00000040)
+#define EFUSE_EF_CTRL_NEW_mr_mode(data)                                              (0x00000040&((data)<<6))
+#define EFUSE_EF_CTRL_NEW_mr_mode_src(data)                                          ((0x00000040&(data))>>6)
+#define EFUSE_EF_CTRL_NEW_get_mr_mode(data)                                          ((0x00000040&(data))>>6)
+#define EFUSE_EF_CTRL_NEW_write_enable1_shift                                        (4)
+#define EFUSE_EF_CTRL_NEW_write_enable1_mask                                         (0x00000010)
+#define EFUSE_EF_CTRL_NEW_write_enable1(data)                                        (0x00000010&((data)<<4))
+#define EFUSE_EF_CTRL_NEW_write_enable1_src(data)                                    ((0x00000010&(data))>>4)
+#define EFUSE_EF_CTRL_NEW_get_write_enable1(data)                                    ((0x00000010&(data))>>4)
+#define EFUSE_EF_CTRL_NEW_prog_strobe_pulse_width_shift                              (0)
+#define EFUSE_EF_CTRL_NEW_prog_strobe_pulse_width_mask                               (0x0000000F)
+#define EFUSE_EF_CTRL_NEW_prog_strobe_pulse_width(data)                              (0x0000000F&((data)<<0))
+#define EFUSE_EF_CTRL_NEW_prog_strobe_pulse_width_src(data)                          ((0x0000000F&(data))>>0)
+#define EFUSE_EF_CTRL_NEW_get_prog_strobe_pulse_width(data)                          ((0x0000000F&(data))>>0)
+
+
+#define EFUSE_EF_RD_DONE                                                             0x18017410
+#define EFUSE_EF_RD_DONE_reg_addr                                                    "0xB8017410"
+#define EFUSE_EF_RD_DONE_reg                                                         0xB8017410
+#define set_EFUSE_EF_RD_DONE_reg(data)   (*((volatile unsigned int*) EFUSE_EF_RD_DONE_reg)=data)
+#define get_EFUSE_EF_RD_DONE_reg   (*((volatile unsigned int*) EFUSE_EF_RD_DONE_reg))
+#define EFUSE_EF_RD_DONE_inst_adr                                                    "0x0004"
+#define EFUSE_EF_RD_DONE_inst                                                        0x0004
+#define EFUSE_EF_RD_DONE_Rd_done_shift                                               (1)
+#define EFUSE_EF_RD_DONE_Rd_done_mask                                                (0x00000002)
+#define EFUSE_EF_RD_DONE_Rd_done(data)                                               (0x00000002&((data)<<1))
+#define EFUSE_EF_RD_DONE_Rd_done_src(data)                                           ((0x00000002&(data))>>1)
+#define EFUSE_EF_RD_DONE_get_Rd_done(data)                                           ((0x00000002&(data))>>1)
+#define EFUSE_EF_RD_DONE_write_data_shift                                            (0)
+#define EFUSE_EF_RD_DONE_write_data_mask                                             (0x00000001)
+#define EFUSE_EF_RD_DONE_write_data(data)                                            (0x00000001&((data)<<0))
+#define EFUSE_EF_RD_DONE_write_data_src(data)                                        ((0x00000001&(data))>>0)
+#define EFUSE_EF_RD_DONE_get_write_data(data)                                        ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/emmc_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/emmc_reg.h
new file mode 100644
index 00000000..ddc4527
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/emmc_reg.h
@@ -0,0 +1,617 @@
+/**************************************************************
+// Spec Version                  : 0.7
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/7/17 20:54:5
+***************************************************************/
+
+
+#ifndef _EMMC_REG_H_INCLUDED_
+#define _EMMC_REG_H_INCLUDED_
+#ifdef  _EMMC_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     map_sel:1;
+unsigned int     access_en:1;
+unsigned int     mem_region:4;
+}EMMC_SRAM_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dram_sa:28;
+}EMMC_DMA_CTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     dma_len:16;
+}EMMC_DMA_CTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     dat64_sel:1;
+unsigned int     rsp17_sel:1;
+unsigned int     reserved_1:2;
+unsigned int     ddr_wr:1;
+unsigned int     dma_xfer:1;
+}EMMC_DMA_CTL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mcu_pp_sram_lp_ena:1;
+unsigned int     sys_clk_gate_ena:1;
+unsigned int     cp_clk_gate_ena:1;
+unsigned int     dma_sram_lp_ena:1;
+unsigned int     dma_sram_rdy_num:4;
+}EMMC_SYS_LOW_PWR;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     Int4:1;
+unsigned int     reserved_1:1;
+unsigned int     Int2:1;
+unsigned int     Int1:1;
+unsigned int     write_data:1;
+}EMMC_SD_ISR;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     reserved_1:4;
+unsigned int     Int4En:1;
+unsigned int     reserved_2:1;
+unsigned int     Int2En:1;
+unsigned int     Int1En:1;
+unsigned int     write_data:1;
+}EMMC_SD_ISREN;
+
+typedef struct 
+{
+unsigned int     dmy:32;
+}EMMC_DUMMY_SYS;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_enable3:1;
+unsigned int     sel1:3;
+unsigned int     write_enable2:1;
+unsigned int     sel0:3;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}EMMC_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     bist_cr_ppb_rme_1:1;
+unsigned int     bist_cr_ppb_rm_1:4;
+unsigned int     bist_cr_ppb_rme_0:1;
+unsigned int     bist_cr_ppb_rm_0:4;
+unsigned int     bist_clk_en:1;
+unsigned int     bist_drf_test_resume:1;
+unsigned int     bist_drf_mode:1;
+unsigned int     bist_en:1;
+}EMMC_IP_BIST_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     bist_drf_start_pause:1;
+unsigned int     bist_drf_fail_1:1;
+unsigned int     bist_drf_fail_0:1;
+unsigned int     bist_drf_done:1;
+unsigned int     bist_1_fail:1;
+unsigned int     bist_0_fail:1;
+unsigned int     bist_done:1;
+}EMMC_IP_BIST_STS;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     asic_crc_dbgo_sel:8;
+unsigned int     reserved_1:1;
+unsigned int     crc_dbgo_sel:4;
+unsigned int     ip_ea_flash:1;
+unsigned int     crc_clk_disable_trig:1;
+unsigned int     mcu_time_1_us:1;
+}EMMC_IP_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     tune3318:1;
+}EMMC_PAD_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     sd30_sample_change:1;
+unsigned int     sd30_push_change:1;
+unsigned int     crc_clk_change:1;
+unsigned int     reserved_1:2;
+unsigned int     sd30_sample_clk_src:2;
+unsigned int     reserved_2:2;
+unsigned int     sd30_push_clk_src:2;
+unsigned int     reserved_3:2;
+unsigned int     crc_clk_src:2;
+unsigned int     reserved_4:1;
+unsigned int     clk_div:3;
+}EMMC_CKGEN_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     buf_full:1;
+unsigned int     buf_sw:1;
+unsigned int     cpu_mode:1;
+}EMMC_CPU_ACC_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     EMMC_RST_n:1;
+}EMMC_CARD_SIG;
+
+#endif
+
+#define EMMC_SRAM_CTL                                                                0x18012000
+#define EMMC_SRAM_CTL_reg_addr                                                       "0xB8012000"
+#define EMMC_SRAM_CTL_reg                                                            0xB8012000
+#define set_EMMC_SRAM_CTL_reg(data)   (*((volatile unsigned int*) EMMC_SRAM_CTL_reg)=data)
+#define get_EMMC_SRAM_CTL_reg   (*((volatile unsigned int*) EMMC_SRAM_CTL_reg))
+#define EMMC_SRAM_CTL_inst_adr                                                       "0x0000"
+#define EMMC_SRAM_CTL_inst                                                           0x0000
+#define EMMC_SRAM_CTL_map_sel_shift                                                  (5)
+#define EMMC_SRAM_CTL_map_sel_mask                                                   (0x00000020)
+#define EMMC_SRAM_CTL_map_sel(data)                                                  (0x00000020&((data)<<5))
+#define EMMC_SRAM_CTL_map_sel_src(data)                                              ((0x00000020&(data))>>5)
+#define EMMC_SRAM_CTL_get_map_sel(data)                                              ((0x00000020&(data))>>5)
+#define EMMC_SRAM_CTL_access_en_shift                                                (4)
+#define EMMC_SRAM_CTL_access_en_mask                                                 (0x00000010)
+#define EMMC_SRAM_CTL_access_en(data)                                                (0x00000010&((data)<<4))
+#define EMMC_SRAM_CTL_access_en_src(data)                                            ((0x00000010&(data))>>4)
+#define EMMC_SRAM_CTL_get_access_en(data)                                            ((0x00000010&(data))>>4)
+#define EMMC_SRAM_CTL_mem_region_shift                                               (0)
+#define EMMC_SRAM_CTL_mem_region_mask                                                (0x0000000F)
+#define EMMC_SRAM_CTL_mem_region(data)                                               (0x0000000F&((data)<<0))
+#define EMMC_SRAM_CTL_mem_region_src(data)                                           ((0x0000000F&(data))>>0)
+#define EMMC_SRAM_CTL_get_mem_region(data)                                           ((0x0000000F&(data))>>0)
+
+
+#define EMMC_DMA_CTL1                                                                0x18012004
+#define EMMC_DMA_CTL1_reg_addr                                                       "0xB8012004"
+#define EMMC_DMA_CTL1_reg                                                            0xB8012004
+#define set_EMMC_DMA_CTL1_reg(data)   (*((volatile unsigned int*) EMMC_DMA_CTL1_reg)=data)
+#define get_EMMC_DMA_CTL1_reg   (*((volatile unsigned int*) EMMC_DMA_CTL1_reg))
+#define EMMC_DMA_CTL1_inst_adr                                                       "0x0001"
+#define EMMC_DMA_CTL1_inst                                                           0x0001
+#define EMMC_DMA_CTL1_dram_sa_shift                                                  (0)
+#define EMMC_DMA_CTL1_dram_sa_mask                                                   (0x0FFFFFFF)
+#define EMMC_DMA_CTL1_dram_sa(data)                                                  (0x0FFFFFFF&((data)<<0))
+#define EMMC_DMA_CTL1_dram_sa_src(data)                                              ((0x0FFFFFFF&(data))>>0)
+#define EMMC_DMA_CTL1_get_dram_sa(data)                                              ((0x0FFFFFFF&(data))>>0)
+
+
+#define EMMC_DMA_CTL2                                                                0x18012008
+#define EMMC_DMA_CTL2_reg_addr                                                       "0xB8012008"
+#define EMMC_DMA_CTL2_reg                                                            0xB8012008
+#define set_EMMC_DMA_CTL2_reg(data)   (*((volatile unsigned int*) EMMC_DMA_CTL2_reg)=data)
+#define get_EMMC_DMA_CTL2_reg   (*((volatile unsigned int*) EMMC_DMA_CTL2_reg))
+#define EMMC_DMA_CTL2_inst_adr                                                       "0x0002"
+#define EMMC_DMA_CTL2_inst                                                           0x0002
+#define EMMC_DMA_CTL2_dma_len_shift                                                  (0)
+#define EMMC_DMA_CTL2_dma_len_mask                                                   (0x0000FFFF)
+#define EMMC_DMA_CTL2_dma_len(data)                                                  (0x0000FFFF&((data)<<0))
+#define EMMC_DMA_CTL2_dma_len_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define EMMC_DMA_CTL2_get_dma_len(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define EMMC_DMA_CTL3                                                                0x1801200C
+#define EMMC_DMA_CTL3_reg_addr                                                       "0xB801200C"
+#define EMMC_DMA_CTL3_reg                                                            0xB801200C
+#define set_EMMC_DMA_CTL3_reg(data)   (*((volatile unsigned int*) EMMC_DMA_CTL3_reg)=data)
+#define get_EMMC_DMA_CTL3_reg   (*((volatile unsigned int*) EMMC_DMA_CTL3_reg))
+#define EMMC_DMA_CTL3_inst_adr                                                       "0x0003"
+#define EMMC_DMA_CTL3_inst                                                           0x0003
+#define EMMC_DMA_CTL3_dat64_sel_shift                                                (5)
+#define EMMC_DMA_CTL3_dat64_sel_mask                                                 (0x00000020)
+#define EMMC_DMA_CTL3_dat64_sel(data)                                                (0x00000020&((data)<<5))
+#define EMMC_DMA_CTL3_dat64_sel_src(data)                                            ((0x00000020&(data))>>5)
+#define EMMC_DMA_CTL3_get_dat64_sel(data)                                            ((0x00000020&(data))>>5)
+#define EMMC_DMA_CTL3_rsp17_sel_shift                                                (4)
+#define EMMC_DMA_CTL3_rsp17_sel_mask                                                 (0x00000010)
+#define EMMC_DMA_CTL3_rsp17_sel(data)                                                (0x00000010&((data)<<4))
+#define EMMC_DMA_CTL3_rsp17_sel_src(data)                                            ((0x00000010&(data))>>4)
+#define EMMC_DMA_CTL3_get_rsp17_sel(data)                                            ((0x00000010&(data))>>4)
+#define EMMC_DMA_CTL3_ddr_wr_shift                                                   (1)
+#define EMMC_DMA_CTL3_ddr_wr_mask                                                    (0x00000002)
+#define EMMC_DMA_CTL3_ddr_wr(data)                                                   (0x00000002&((data)<<1))
+#define EMMC_DMA_CTL3_ddr_wr_src(data)                                               ((0x00000002&(data))>>1)
+#define EMMC_DMA_CTL3_get_ddr_wr(data)                                               ((0x00000002&(data))>>1)
+#define EMMC_DMA_CTL3_dma_xfer_shift                                                 (0)
+#define EMMC_DMA_CTL3_dma_xfer_mask                                                  (0x00000001)
+#define EMMC_DMA_CTL3_dma_xfer(data)                                                 (0x00000001&((data)<<0))
+#define EMMC_DMA_CTL3_dma_xfer_src(data)                                             ((0x00000001&(data))>>0)
+#define EMMC_DMA_CTL3_get_dma_xfer(data)                                             ((0x00000001&(data))>>0)
+
+
+#define EMMC_SYS_LOW_PWR                                                             0x18012010
+#define EMMC_SYS_LOW_PWR_reg_addr                                                    "0xB8012010"
+#define EMMC_SYS_LOW_PWR_reg                                                         0xB8012010
+#define set_EMMC_SYS_LOW_PWR_reg(data)   (*((volatile unsigned int*) EMMC_SYS_LOW_PWR_reg)=data)
+#define get_EMMC_SYS_LOW_PWR_reg   (*((volatile unsigned int*) EMMC_SYS_LOW_PWR_reg))
+#define EMMC_SYS_LOW_PWR_inst_adr                                                    "0x0004"
+#define EMMC_SYS_LOW_PWR_inst                                                        0x0004
+#define EMMC_SYS_LOW_PWR_mcu_pp_sram_lp_ena_shift                                    (7)
+#define EMMC_SYS_LOW_PWR_mcu_pp_sram_lp_ena_mask                                     (0x00000080)
+#define EMMC_SYS_LOW_PWR_mcu_pp_sram_lp_ena(data)                                    (0x00000080&((data)<<7))
+#define EMMC_SYS_LOW_PWR_mcu_pp_sram_lp_ena_src(data)                                ((0x00000080&(data))>>7)
+#define EMMC_SYS_LOW_PWR_get_mcu_pp_sram_lp_ena(data)                                ((0x00000080&(data))>>7)
+#define EMMC_SYS_LOW_PWR_sys_clk_gate_ena_shift                                      (6)
+#define EMMC_SYS_LOW_PWR_sys_clk_gate_ena_mask                                       (0x00000040)
+#define EMMC_SYS_LOW_PWR_sys_clk_gate_ena(data)                                      (0x00000040&((data)<<6))
+#define EMMC_SYS_LOW_PWR_sys_clk_gate_ena_src(data)                                  ((0x00000040&(data))>>6)
+#define EMMC_SYS_LOW_PWR_get_sys_clk_gate_ena(data)                                  ((0x00000040&(data))>>6)
+#define EMMC_SYS_LOW_PWR_cp_clk_gate_ena_shift                                       (5)
+#define EMMC_SYS_LOW_PWR_cp_clk_gate_ena_mask                                        (0x00000020)
+#define EMMC_SYS_LOW_PWR_cp_clk_gate_ena(data)                                       (0x00000020&((data)<<5))
+#define EMMC_SYS_LOW_PWR_cp_clk_gate_ena_src(data)                                   ((0x00000020&(data))>>5)
+#define EMMC_SYS_LOW_PWR_get_cp_clk_gate_ena(data)                                   ((0x00000020&(data))>>5)
+#define EMMC_SYS_LOW_PWR_dma_sram_lp_ena_shift                                       (4)
+#define EMMC_SYS_LOW_PWR_dma_sram_lp_ena_mask                                        (0x00000010)
+#define EMMC_SYS_LOW_PWR_dma_sram_lp_ena(data)                                       (0x00000010&((data)<<4))
+#define EMMC_SYS_LOW_PWR_dma_sram_lp_ena_src(data)                                   ((0x00000010&(data))>>4)
+#define EMMC_SYS_LOW_PWR_get_dma_sram_lp_ena(data)                                   ((0x00000010&(data))>>4)
+#define EMMC_SYS_LOW_PWR_dma_sram_rdy_num_shift                                      (0)
+#define EMMC_SYS_LOW_PWR_dma_sram_rdy_num_mask                                       (0x0000000F)
+#define EMMC_SYS_LOW_PWR_dma_sram_rdy_num(data)                                      (0x0000000F&((data)<<0))
+#define EMMC_SYS_LOW_PWR_dma_sram_rdy_num_src(data)                                  ((0x0000000F&(data))>>0)
+#define EMMC_SYS_LOW_PWR_get_dma_sram_rdy_num(data)                                  ((0x0000000F&(data))>>0)
+
+
+#define EMMC_SD_ISR                                                                  0x18012024
+#define EMMC_SD_ISR_reg_addr                                                         "0xB8012024"
+#define EMMC_SD_ISR_reg                                                              0xB8012024
+#define set_EMMC_SD_ISR_reg(data)   (*((volatile unsigned int*) EMMC_SD_ISR_reg)=data)
+#define get_EMMC_SD_ISR_reg   (*((volatile unsigned int*) EMMC_SD_ISR_reg))
+#define EMMC_SD_ISR_inst_adr                                                         "0x0009"
+#define EMMC_SD_ISR_inst                                                             0x0009
+#define EMMC_SD_ISR_Int4_shift                                                       (4)
+#define EMMC_SD_ISR_Int4_mask                                                        (0x00000010)
+#define EMMC_SD_ISR_Int4(data)                                                       (0x00000010&((data)<<4))
+#define EMMC_SD_ISR_Int4_src(data)                                                   ((0x00000010&(data))>>4)
+#define EMMC_SD_ISR_get_Int4(data)                                                   ((0x00000010&(data))>>4)
+#define EMMC_SD_ISR_Int2_shift                                                       (2)
+#define EMMC_SD_ISR_Int2_mask                                                        (0x00000004)
+#define EMMC_SD_ISR_Int2(data)                                                       (0x00000004&((data)<<2))
+#define EMMC_SD_ISR_Int2_src(data)                                                   ((0x00000004&(data))>>2)
+#define EMMC_SD_ISR_get_Int2(data)                                                   ((0x00000004&(data))>>2)
+#define EMMC_SD_ISR_Int1_shift                                                       (1)
+#define EMMC_SD_ISR_Int1_mask                                                        (0x00000002)
+#define EMMC_SD_ISR_Int1(data)                                                       (0x00000002&((data)<<1))
+#define EMMC_SD_ISR_Int1_src(data)                                                   ((0x00000002&(data))>>1)
+#define EMMC_SD_ISR_get_Int1(data)                                                   ((0x00000002&(data))>>1)
+#define EMMC_SD_ISR_write_data_shift                                                 (0)
+#define EMMC_SD_ISR_write_data_mask                                                  (0x00000001)
+#define EMMC_SD_ISR_write_data(data)                                                 (0x00000001&((data)<<0))
+#define EMMC_SD_ISR_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define EMMC_SD_ISR_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define EMMC_SD_ISREN                                                                0x18012028
+#define EMMC_SD_ISREN_reg_addr                                                       "0xB8012028"
+#define EMMC_SD_ISREN_reg                                                            0xB8012028
+#define set_EMMC_SD_ISREN_reg(data)   (*((volatile unsigned int*) EMMC_SD_ISREN_reg)=data)
+#define get_EMMC_SD_ISREN_reg   (*((volatile unsigned int*) EMMC_SD_ISREN_reg))
+#define EMMC_SD_ISREN_inst_adr                                                       "0x000A"
+#define EMMC_SD_ISREN_inst                                                           0x000A
+#define EMMC_SD_ISREN_Int4En_shift                                                   (4)
+#define EMMC_SD_ISREN_Int4En_mask                                                    (0x00000010)
+#define EMMC_SD_ISREN_Int4En(data)                                                   (0x00000010&((data)<<4))
+#define EMMC_SD_ISREN_Int4En_src(data)                                               ((0x00000010&(data))>>4)
+#define EMMC_SD_ISREN_get_Int4En(data)                                               ((0x00000010&(data))>>4)
+#define EMMC_SD_ISREN_Int2En_shift                                                   (2)
+#define EMMC_SD_ISREN_Int2En_mask                                                    (0x00000004)
+#define EMMC_SD_ISREN_Int2En(data)                                                   (0x00000004&((data)<<2))
+#define EMMC_SD_ISREN_Int2En_src(data)                                               ((0x00000004&(data))>>2)
+#define EMMC_SD_ISREN_get_Int2En(data)                                               ((0x00000004&(data))>>2)
+#define EMMC_SD_ISREN_Int1En_shift                                                   (1)
+#define EMMC_SD_ISREN_Int1En_mask                                                    (0x00000002)
+#define EMMC_SD_ISREN_Int1En(data)                                                   (0x00000002&((data)<<1))
+#define EMMC_SD_ISREN_Int1En_src(data)                                               ((0x00000002&(data))>>1)
+#define EMMC_SD_ISREN_get_Int1En(data)                                               ((0x00000002&(data))>>1)
+#define EMMC_SD_ISREN_write_data_shift                                               (0)
+#define EMMC_SD_ISREN_write_data_mask                                                (0x00000001)
+#define EMMC_SD_ISREN_write_data(data)                                               (0x00000001&((data)<<0))
+#define EMMC_SD_ISREN_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define EMMC_SD_ISREN_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define EMMC_DUMMY_SYS                                                               0x1801202C
+#define EMMC_DUMMY_SYS_reg_addr                                                      "0xB801202C"
+#define EMMC_DUMMY_SYS_reg                                                           0xB801202C
+#define set_EMMC_DUMMY_SYS_reg(data)   (*((volatile unsigned int*) EMMC_DUMMY_SYS_reg)=data)
+#define get_EMMC_DUMMY_SYS_reg   (*((volatile unsigned int*) EMMC_DUMMY_SYS_reg))
+#define EMMC_DUMMY_SYS_inst_adr                                                      "0x000B"
+#define EMMC_DUMMY_SYS_inst                                                          0x000B
+#define EMMC_DUMMY_SYS_dmy_shift                                                     (0)
+#define EMMC_DUMMY_SYS_dmy_mask                                                      (0xFFFFFFFF)
+#define EMMC_DUMMY_SYS_dmy(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define EMMC_DUMMY_SYS_dmy_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define EMMC_DUMMY_SYS_get_dmy(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define EMMC_DBG                                                                     0x18012044
+#define EMMC_DBG_reg_addr                                                            "0xB8012044"
+#define EMMC_DBG_reg                                                                 0xB8012044
+#define set_EMMC_DBG_reg(data)   (*((volatile unsigned int*) EMMC_DBG_reg)=data)
+#define get_EMMC_DBG_reg   (*((volatile unsigned int*) EMMC_DBG_reg))
+#define EMMC_DBG_inst_adr                                                            "0x0011"
+#define EMMC_DBG_inst                                                                0x0011
+#define EMMC_DBG_write_enable3_shift                                                 (9)
+#define EMMC_DBG_write_enable3_mask                                                  (0x00000200)
+#define EMMC_DBG_write_enable3(data)                                                 (0x00000200&((data)<<9))
+#define EMMC_DBG_write_enable3_src(data)                                             ((0x00000200&(data))>>9)
+#define EMMC_DBG_get_write_enable3(data)                                             ((0x00000200&(data))>>9)
+#define EMMC_DBG_sel1_shift                                                          (6)
+#define EMMC_DBG_sel1_mask                                                           (0x000001C0)
+#define EMMC_DBG_sel1(data)                                                          (0x000001C0&((data)<<6))
+#define EMMC_DBG_sel1_src(data)                                                      ((0x000001C0&(data))>>6)
+#define EMMC_DBG_get_sel1(data)                                                      ((0x000001C0&(data))>>6)
+#define EMMC_DBG_write_enable2_shift                                                 (5)
+#define EMMC_DBG_write_enable2_mask                                                  (0x00000020)
+#define EMMC_DBG_write_enable2(data)                                                 (0x00000020&((data)<<5))
+#define EMMC_DBG_write_enable2_src(data)                                             ((0x00000020&(data))>>5)
+#define EMMC_DBG_get_write_enable2(data)                                             ((0x00000020&(data))>>5)
+#define EMMC_DBG_sel0_shift                                                          (2)
+#define EMMC_DBG_sel0_mask                                                           (0x0000001C)
+#define EMMC_DBG_sel0(data)                                                          (0x0000001C&((data)<<2))
+#define EMMC_DBG_sel0_src(data)                                                      ((0x0000001C&(data))>>2)
+#define EMMC_DBG_get_sel0(data)                                                      ((0x0000001C&(data))>>2)
+#define EMMC_DBG_write_enable1_shift                                                 (1)
+#define EMMC_DBG_write_enable1_mask                                                  (0x00000002)
+#define EMMC_DBG_write_enable1(data)                                                 (0x00000002&((data)<<1))
+#define EMMC_DBG_write_enable1_src(data)                                             ((0x00000002&(data))>>1)
+#define EMMC_DBG_get_write_enable1(data)                                             ((0x00000002&(data))>>1)
+#define EMMC_DBG_enable_shift                                                        (0)
+#define EMMC_DBG_enable_mask                                                         (0x00000001)
+#define EMMC_DBG_enable(data)                                                        (0x00000001&((data)<<0))
+#define EMMC_DBG_enable_src(data)                                                    ((0x00000001&(data))>>0)
+#define EMMC_DBG_get_enable(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define EMMC_IP_BIST_CTL                                                             0x18012060
+#define EMMC_IP_BIST_CTL_reg_addr                                                    "0xB8012060"
+#define EMMC_IP_BIST_CTL_reg                                                         0xB8012060
+#define set_EMMC_IP_BIST_CTL_reg(data)   (*((volatile unsigned int*) EMMC_IP_BIST_CTL_reg)=data)
+#define get_EMMC_IP_BIST_CTL_reg   (*((volatile unsigned int*) EMMC_IP_BIST_CTL_reg))
+#define EMMC_IP_BIST_CTL_inst_adr                                                    "0x0018"
+#define EMMC_IP_BIST_CTL_inst                                                        0x0018
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rme_1_shift                                     (13)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rme_1_mask                                      (0x00002000)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rme_1(data)                                     (0x00002000&((data)<<13))
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rme_1_src(data)                                 ((0x00002000&(data))>>13)
+#define EMMC_IP_BIST_CTL_get_bist_cr_ppb_rme_1(data)                                 ((0x00002000&(data))>>13)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rm_1_shift                                      (9)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rm_1_mask                                       (0x00001E00)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rm_1(data)                                      (0x00001E00&((data)<<9))
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rm_1_src(data)                                  ((0x00001E00&(data))>>9)
+#define EMMC_IP_BIST_CTL_get_bist_cr_ppb_rm_1(data)                                  ((0x00001E00&(data))>>9)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rme_0_shift                                     (8)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rme_0_mask                                      (0x00000100)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rme_0(data)                                     (0x00000100&((data)<<8))
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rme_0_src(data)                                 ((0x00000100&(data))>>8)
+#define EMMC_IP_BIST_CTL_get_bist_cr_ppb_rme_0(data)                                 ((0x00000100&(data))>>8)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rm_0_shift                                      (4)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rm_0_mask                                       (0x000000F0)
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rm_0(data)                                      (0x000000F0&((data)<<4))
+#define EMMC_IP_BIST_CTL_bist_cr_ppb_rm_0_src(data)                                  ((0x000000F0&(data))>>4)
+#define EMMC_IP_BIST_CTL_get_bist_cr_ppb_rm_0(data)                                  ((0x000000F0&(data))>>4)
+#define EMMC_IP_BIST_CTL_bist_clk_en_shift                                           (3)
+#define EMMC_IP_BIST_CTL_bist_clk_en_mask                                            (0x00000008)
+#define EMMC_IP_BIST_CTL_bist_clk_en(data)                                           (0x00000008&((data)<<3))
+#define EMMC_IP_BIST_CTL_bist_clk_en_src(data)                                       ((0x00000008&(data))>>3)
+#define EMMC_IP_BIST_CTL_get_bist_clk_en(data)                                       ((0x00000008&(data))>>3)
+#define EMMC_IP_BIST_CTL_bist_drf_test_resume_shift                                  (2)
+#define EMMC_IP_BIST_CTL_bist_drf_test_resume_mask                                   (0x00000004)
+#define EMMC_IP_BIST_CTL_bist_drf_test_resume(data)                                  (0x00000004&((data)<<2))
+#define EMMC_IP_BIST_CTL_bist_drf_test_resume_src(data)                              ((0x00000004&(data))>>2)
+#define EMMC_IP_BIST_CTL_get_bist_drf_test_resume(data)                              ((0x00000004&(data))>>2)
+#define EMMC_IP_BIST_CTL_bist_drf_mode_shift                                         (1)
+#define EMMC_IP_BIST_CTL_bist_drf_mode_mask                                          (0x00000002)
+#define EMMC_IP_BIST_CTL_bist_drf_mode(data)                                         (0x00000002&((data)<<1))
+#define EMMC_IP_BIST_CTL_bist_drf_mode_src(data)                                     ((0x00000002&(data))>>1)
+#define EMMC_IP_BIST_CTL_get_bist_drf_mode(data)                                     ((0x00000002&(data))>>1)
+#define EMMC_IP_BIST_CTL_bist_en_shift                                               (0)
+#define EMMC_IP_BIST_CTL_bist_en_mask                                                (0x00000001)
+#define EMMC_IP_BIST_CTL_bist_en(data)                                               (0x00000001&((data)<<0))
+#define EMMC_IP_BIST_CTL_bist_en_src(data)                                           ((0x00000001&(data))>>0)
+#define EMMC_IP_BIST_CTL_get_bist_en(data)                                           ((0x00000001&(data))>>0)
+
+
+#define EMMC_IP_BIST_STS                                                             0x18012064
+#define EMMC_IP_BIST_STS_reg_addr                                                    "0xB8012064"
+#define EMMC_IP_BIST_STS_reg                                                         0xB8012064
+#define set_EMMC_IP_BIST_STS_reg(data)   (*((volatile unsigned int*) EMMC_IP_BIST_STS_reg)=data)
+#define get_EMMC_IP_BIST_STS_reg   (*((volatile unsigned int*) EMMC_IP_BIST_STS_reg))
+#define EMMC_IP_BIST_STS_inst_adr                                                    "0x0019"
+#define EMMC_IP_BIST_STS_inst                                                        0x0019
+#define EMMC_IP_BIST_STS_bist_drf_start_pause_shift                                  (6)
+#define EMMC_IP_BIST_STS_bist_drf_start_pause_mask                                   (0x00000040)
+#define EMMC_IP_BIST_STS_bist_drf_start_pause(data)                                  (0x00000040&((data)<<6))
+#define EMMC_IP_BIST_STS_bist_drf_start_pause_src(data)                              ((0x00000040&(data))>>6)
+#define EMMC_IP_BIST_STS_get_bist_drf_start_pause(data)                              ((0x00000040&(data))>>6)
+#define EMMC_IP_BIST_STS_bist_drf_fail_1_shift                                       (5)
+#define EMMC_IP_BIST_STS_bist_drf_fail_1_mask                                        (0x00000020)
+#define EMMC_IP_BIST_STS_bist_drf_fail_1(data)                                       (0x00000020&((data)<<5))
+#define EMMC_IP_BIST_STS_bist_drf_fail_1_src(data)                                   ((0x00000020&(data))>>5)
+#define EMMC_IP_BIST_STS_get_bist_drf_fail_1(data)                                   ((0x00000020&(data))>>5)
+#define EMMC_IP_BIST_STS_bist_drf_fail_0_shift                                       (4)
+#define EMMC_IP_BIST_STS_bist_drf_fail_0_mask                                        (0x00000010)
+#define EMMC_IP_BIST_STS_bist_drf_fail_0(data)                                       (0x00000010&((data)<<4))
+#define EMMC_IP_BIST_STS_bist_drf_fail_0_src(data)                                   ((0x00000010&(data))>>4)
+#define EMMC_IP_BIST_STS_get_bist_drf_fail_0(data)                                   ((0x00000010&(data))>>4)
+#define EMMC_IP_BIST_STS_bist_drf_done_shift                                         (3)
+#define EMMC_IP_BIST_STS_bist_drf_done_mask                                          (0x00000008)
+#define EMMC_IP_BIST_STS_bist_drf_done(data)                                         (0x00000008&((data)<<3))
+#define EMMC_IP_BIST_STS_bist_drf_done_src(data)                                     ((0x00000008&(data))>>3)
+#define EMMC_IP_BIST_STS_get_bist_drf_done(data)                                     ((0x00000008&(data))>>3)
+#define EMMC_IP_BIST_STS_bist_1_fail_shift                                           (2)
+#define EMMC_IP_BIST_STS_bist_1_fail_mask                                            (0x00000004)
+#define EMMC_IP_BIST_STS_bist_1_fail(data)                                           (0x00000004&((data)<<2))
+#define EMMC_IP_BIST_STS_bist_1_fail_src(data)                                       ((0x00000004&(data))>>2)
+#define EMMC_IP_BIST_STS_get_bist_1_fail(data)                                       ((0x00000004&(data))>>2)
+#define EMMC_IP_BIST_STS_bist_0_fail_shift                                           (1)
+#define EMMC_IP_BIST_STS_bist_0_fail_mask                                            (0x00000002)
+#define EMMC_IP_BIST_STS_bist_0_fail(data)                                           (0x00000002&((data)<<1))
+#define EMMC_IP_BIST_STS_bist_0_fail_src(data)                                       ((0x00000002&(data))>>1)
+#define EMMC_IP_BIST_STS_get_bist_0_fail(data)                                       ((0x00000002&(data))>>1)
+#define EMMC_IP_BIST_STS_bist_done_shift                                             (0)
+#define EMMC_IP_BIST_STS_bist_done_mask                                              (0x00000001)
+#define EMMC_IP_BIST_STS_bist_done(data)                                             (0x00000001&((data)<<0))
+#define EMMC_IP_BIST_STS_bist_done_src(data)                                         ((0x00000001&(data))>>0)
+#define EMMC_IP_BIST_STS_get_bist_done(data)                                         ((0x00000001&(data))>>0)
+
+
+#define EMMC_IP_CTL                                                                  0x18012070
+#define EMMC_IP_CTL_reg_addr                                                         "0xB8012070"
+#define EMMC_IP_CTL_reg                                                              0xB8012070
+#define set_EMMC_IP_CTL_reg(data)   (*((volatile unsigned int*) EMMC_IP_CTL_reg)=data)
+#define get_EMMC_IP_CTL_reg   (*((volatile unsigned int*) EMMC_IP_CTL_reg))
+#define EMMC_IP_CTL_inst_adr                                                         "0x001C"
+#define EMMC_IP_CTL_inst                                                             0x001C
+#define EMMC_IP_CTL_asic_crc_dbgo_sel_shift                                          (8)
+#define EMMC_IP_CTL_asic_crc_dbgo_sel_mask                                           (0x0000FF00)
+#define EMMC_IP_CTL_asic_crc_dbgo_sel(data)                                          (0x0000FF00&((data)<<8))
+#define EMMC_IP_CTL_asic_crc_dbgo_sel_src(data)                                      ((0x0000FF00&(data))>>8)
+#define EMMC_IP_CTL_get_asic_crc_dbgo_sel(data)                                      ((0x0000FF00&(data))>>8)
+#define EMMC_IP_CTL_crc_dbgo_sel_shift                                               (3)
+#define EMMC_IP_CTL_crc_dbgo_sel_mask                                                (0x00000078)
+#define EMMC_IP_CTL_crc_dbgo_sel(data)                                               (0x00000078&((data)<<3))
+#define EMMC_IP_CTL_crc_dbgo_sel_src(data)                                           ((0x00000078&(data))>>3)
+#define EMMC_IP_CTL_get_crc_dbgo_sel(data)                                           ((0x00000078&(data))>>3)
+#define EMMC_IP_CTL_ip_ea_flash_shift                                                (2)
+#define EMMC_IP_CTL_ip_ea_flash_mask                                                 (0x00000004)
+#define EMMC_IP_CTL_ip_ea_flash(data)                                                (0x00000004&((data)<<2))
+#define EMMC_IP_CTL_ip_ea_flash_src(data)                                            ((0x00000004&(data))>>2)
+#define EMMC_IP_CTL_get_ip_ea_flash(data)                                            ((0x00000004&(data))>>2)
+#define EMMC_IP_CTL_crc_clk_disable_trig_shift                                       (1)
+#define EMMC_IP_CTL_crc_clk_disable_trig_mask                                        (0x00000002)
+#define EMMC_IP_CTL_crc_clk_disable_trig(data)                                       (0x00000002&((data)<<1))
+#define EMMC_IP_CTL_crc_clk_disable_trig_src(data)                                   ((0x00000002&(data))>>1)
+#define EMMC_IP_CTL_get_crc_clk_disable_trig(data)                                   ((0x00000002&(data))>>1)
+#define EMMC_IP_CTL_mcu_time_1_us_shift                                              (0)
+#define EMMC_IP_CTL_mcu_time_1_us_mask                                               (0x00000001)
+#define EMMC_IP_CTL_mcu_time_1_us(data)                                              (0x00000001&((data)<<0))
+#define EMMC_IP_CTL_mcu_time_1_us_src(data)                                          ((0x00000001&(data))>>0)
+#define EMMC_IP_CTL_get_mcu_time_1_us(data)                                          ((0x00000001&(data))>>0)
+
+
+#define EMMC_PAD_CTL                                                                 0x18012074
+#define EMMC_PAD_CTL_reg_addr                                                        "0xB8012074"
+#define EMMC_PAD_CTL_reg                                                             0xB8012074
+#define set_EMMC_PAD_CTL_reg(data)   (*((volatile unsigned int*) EMMC_PAD_CTL_reg)=data)
+#define get_EMMC_PAD_CTL_reg   (*((volatile unsigned int*) EMMC_PAD_CTL_reg))
+#define EMMC_PAD_CTL_inst_adr                                                        "0x001D"
+#define EMMC_PAD_CTL_inst                                                            0x001D
+#define EMMC_PAD_CTL_tune3318_shift                                                  (0)
+#define EMMC_PAD_CTL_tune3318_mask                                                   (0x00000001)
+#define EMMC_PAD_CTL_tune3318(data)                                                  (0x00000001&((data)<<0))
+#define EMMC_PAD_CTL_tune3318_src(data)                                              ((0x00000001&(data))>>0)
+#define EMMC_PAD_CTL_get_tune3318(data)                                              ((0x00000001&(data))>>0)
+
+
+#define EMMC_CKGEN_CTL                                                               0x18012078
+#define EMMC_CKGEN_CTL_reg_addr                                                      "0xB8012078"
+#define EMMC_CKGEN_CTL_reg                                                           0xB8012078
+#define set_EMMC_CKGEN_CTL_reg(data)   (*((volatile unsigned int*) EMMC_CKGEN_CTL_reg)=data)
+#define get_EMMC_CKGEN_CTL_reg   (*((volatile unsigned int*) EMMC_CKGEN_CTL_reg))
+#define EMMC_CKGEN_CTL_inst_adr                                                      "0x001E"
+#define EMMC_CKGEN_CTL_inst                                                          0x001E
+#define EMMC_CKGEN_CTL_sd30_sample_change_shift                                      (18)
+#define EMMC_CKGEN_CTL_sd30_sample_change_mask                                       (0x00040000)
+#define EMMC_CKGEN_CTL_sd30_sample_change(data)                                      (0x00040000&((data)<<18))
+#define EMMC_CKGEN_CTL_sd30_sample_change_src(data)                                  ((0x00040000&(data))>>18)
+#define EMMC_CKGEN_CTL_get_sd30_sample_change(data)                                  ((0x00040000&(data))>>18)
+#define EMMC_CKGEN_CTL_sd30_push_change_shift                                        (17)
+#define EMMC_CKGEN_CTL_sd30_push_change_mask                                         (0x00020000)
+#define EMMC_CKGEN_CTL_sd30_push_change(data)                                        (0x00020000&((data)<<17))
+#define EMMC_CKGEN_CTL_sd30_push_change_src(data)                                    ((0x00020000&(data))>>17)
+#define EMMC_CKGEN_CTL_get_sd30_push_change(data)                                    ((0x00020000&(data))>>17)
+#define EMMC_CKGEN_CTL_crc_clk_change_shift                                          (16)
+#define EMMC_CKGEN_CTL_crc_clk_change_mask                                           (0x00010000)
+#define EMMC_CKGEN_CTL_crc_clk_change(data)                                          (0x00010000&((data)<<16))
+#define EMMC_CKGEN_CTL_crc_clk_change_src(data)                                      ((0x00010000&(data))>>16)
+#define EMMC_CKGEN_CTL_get_crc_clk_change(data)                                      ((0x00010000&(data))>>16)
+#define EMMC_CKGEN_CTL_sd30_sample_clk_src_shift                                     (12)
+#define EMMC_CKGEN_CTL_sd30_sample_clk_src_mask                                      (0x00003000)
+#define EMMC_CKGEN_CTL_sd30_sample_clk_src(data)                                     (0x00003000&((data)<<12))
+#define EMMC_CKGEN_CTL_sd30_sample_clk_src_src(data)                                 ((0x00003000&(data))>>12)
+#define EMMC_CKGEN_CTL_get_sd30_sample_clk_src(data)                                 ((0x00003000&(data))>>12)
+#define EMMC_CKGEN_CTL_sd30_push_clk_src_shift                                       (8)
+#define EMMC_CKGEN_CTL_sd30_push_clk_src_mask                                        (0x00000300)
+#define EMMC_CKGEN_CTL_sd30_push_clk_src(data)                                       (0x00000300&((data)<<8))
+#define EMMC_CKGEN_CTL_sd30_push_clk_src_src(data)                                   ((0x00000300&(data))>>8)
+#define EMMC_CKGEN_CTL_get_sd30_push_clk_src(data)                                   ((0x00000300&(data))>>8)
+#define EMMC_CKGEN_CTL_crc_clk_src_shift                                             (4)
+#define EMMC_CKGEN_CTL_crc_clk_src_mask                                              (0x00000030)
+#define EMMC_CKGEN_CTL_crc_clk_src(data)                                             (0x00000030&((data)<<4))
+#define EMMC_CKGEN_CTL_crc_clk_src_src(data)                                         ((0x00000030&(data))>>4)
+#define EMMC_CKGEN_CTL_get_crc_clk_src(data)                                         ((0x00000030&(data))>>4)
+#define EMMC_CKGEN_CTL_clk_div_shift                                                 (0)
+#define EMMC_CKGEN_CTL_clk_div_mask                                                  (0x00000007)
+#define EMMC_CKGEN_CTL_clk_div(data)                                                 (0x00000007&((data)<<0))
+#define EMMC_CKGEN_CTL_clk_div_src(data)                                             ((0x00000007&(data))>>0)
+#define EMMC_CKGEN_CTL_get_clk_div(data)                                             ((0x00000007&(data))>>0)
+
+
+#define EMMC_CPU_ACC_CTRL                                                            0x18012080
+#define EMMC_CPU_ACC_CTRL_reg_addr                                                   "0xB8012080"
+#define EMMC_CPU_ACC_CTRL_reg                                                        0xB8012080
+#define set_EMMC_CPU_ACC_CTRL_reg(data)   (*((volatile unsigned int*) EMMC_CPU_ACC_CTRL_reg)=data)
+#define get_EMMC_CPU_ACC_CTRL_reg   (*((volatile unsigned int*) EMMC_CPU_ACC_CTRL_reg))
+#define EMMC_CPU_ACC_CTRL_inst_adr                                                   "0x0020"
+#define EMMC_CPU_ACC_CTRL_inst                                                       0x0020
+#define EMMC_CPU_ACC_CTRL_buf_full_shift                                             (2)
+#define EMMC_CPU_ACC_CTRL_buf_full_mask                                              (0x00000004)
+#define EMMC_CPU_ACC_CTRL_buf_full(data)                                             (0x00000004&((data)<<2))
+#define EMMC_CPU_ACC_CTRL_buf_full_src(data)                                         ((0x00000004&(data))>>2)
+#define EMMC_CPU_ACC_CTRL_get_buf_full(data)                                         ((0x00000004&(data))>>2)
+#define EMMC_CPU_ACC_CTRL_buf_sw_shift                                               (1)
+#define EMMC_CPU_ACC_CTRL_buf_sw_mask                                                (0x00000002)
+#define EMMC_CPU_ACC_CTRL_buf_sw(data)                                               (0x00000002&((data)<<1))
+#define EMMC_CPU_ACC_CTRL_buf_sw_src(data)                                           ((0x00000002&(data))>>1)
+#define EMMC_CPU_ACC_CTRL_get_buf_sw(data)                                           ((0x00000002&(data))>>1)
+#define EMMC_CPU_ACC_CTRL_cpu_mode_shift                                             (0)
+#define EMMC_CPU_ACC_CTRL_cpu_mode_mask                                              (0x00000001)
+#define EMMC_CPU_ACC_CTRL_cpu_mode(data)                                             (0x00000001&((data)<<0))
+#define EMMC_CPU_ACC_CTRL_cpu_mode_src(data)                                         ((0x00000001&(data))>>0)
+#define EMMC_CPU_ACC_CTRL_get_cpu_mode(data)                                         ((0x00000001&(data))>>0)
+
+
+#define EMMC_CARD_SIG                                                                 0x18012084
+#define EMMC_CARD_SIG_reg_addr                                                        "0xB8012084"
+#define EMMC_CARD_SIG_reg                                                             0xB8012084
+#define set_EMMC_CARD_SIG_reg(data)   (*((volatile unsigned int*) EMMC_CARD_SIG_reg)=data)
+#define get_EMMC_CARD_SIG_reg   (*((volatile unsigned int*) EMMC_CARD_SIG_reg))
+#define EMMC_CARD_SIG_inst_adr                                                        "0x0021"
+#define EMMC_CARD_SIG_inst                                                            0x0021
+#define EMMC_CARD_SIG_EMMC_RST_n_shift                                                (0)
+#define EMMC_CARD_SIG_EMMC_RST_n_mask                                                 (0x00000001)
+#define EMMC_CARD_SIG_EMMC_RST_n(data)                                                (0x00000001&((data)<<0))
+#define EMMC_CARD_SIG_EMMC_RST_n_src(data)                                            ((0x00000001&(data))>>0)
+#define EMMC_CARD_SIG_get_EMMC_RST_n(data)                                            ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/eregdef.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/eregdef.h
new file mode 100644
index 00000000..4e7cd65
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/eregdef.h
@@ -0,0 +1,713 @@
+/**************************************************************************/
+/*                              EREGDEF.H                                 */
+/**************************************************************************/
+/*  Copyright(c) 1987-99 Embedded Performance, Inc.. All rights reserved  */
+/*																		  */
+/*  This software is the property of Embedded Performance, Inc (EPI)	  */
+/*  which specifically  grants the user the right to modify, and use	  */
+/*  this software provided this notice is not removed or altered.  All	  */
+/*  other rights are reserved by EPI.									  */
+/*                                                                        */
+/**************************************************************************/
+/*                                                                        */
+/*  Embedded Performance, Inc. (EPI) makes no warranty  of any kind,      */
+/*  express or implied, with regard to this software.  In no event shall  */
+/*  EPI be liable for incidental or consequential damages in connection   */
+/*  with or arising from  the furnishing,  performance, or use of this    */
+/*  software.                                                             */
+/*                                                                        */
+/**************************************************************************/
+/*																		  */
+/*  This file defines various register names and chip addresses.          */
+/*																		  */
+/**************************************************************************/
+/*																		  */
+/*  Internal to EPI note:  This file is maintained in both scm and scmr4k */
+/*  Please make any changes to both places.                               */
+/*																		  */
+/**************************************************************************/
+
+
+#ifdef LANGUAGE_ASSEMBLY		/* set automatically by assembler */
+
+#define zero $0	
+#define AT	$at		/* assembler temp */
+#define v0	$2		/* function return value0 */
+#define v1	$3      /* function return value1 */
+#define a0	$4		/* argument registers 0-3 */
+#define a1	$5
+#define a2	$6
+#define a3	$7
+#define t0	$8
+#define t1	$9
+#define t2	$10
+#define t3	$11
+#define t4	$12
+#define t5	$13
+#define t6	$14
+#define t7	$15
+#define s0	$16
+#define s1	$17
+#define s2	$18
+#define s3	$19
+#define s4	$20
+#define s5	$21
+#define s6	$22
+#define s7	$23
+#define t8	$24	
+#define t9	$25
+#define k0	$26		/* kernel temporary */
+#define k1	$27		/* kernel reserved */
+#define gp	$28		/* global data pointer */
+#define sp	$29		/* stack pointer */
+#define s8	$30		/* one more callee saved */
+#define ra	$31		/* return address */
+
+/*----- hardware registers names ---------------------*/
+#define r0	$0	
+#define r1	$at	
+#define r2	$2	
+#define r3	$3
+#define r4	$4	
+#define r5	$5
+#define r6	$6
+#define r7	$7
+#define r8	$8	
+#define r9	$9
+#define r10	$10
+#define r11	$11
+#define r12	$12
+#define r13	$13
+#define r14	$14
+#define r15	$15
+#define r16	$16		
+#define r17	$17
+#define r18	$18
+#define r19	$19
+#define r20	$20
+#define r21	$21
+#define r22	$22
+#define r23	$23
+#define r24	$24		
+#define r25	$25
+#define r26	$26		
+#define r27	$27
+#define r28	$28		
+#define r29	$29		
+#define r30	$30		
+#define r31	$31		
+
+
+/*----- coprocessor 0 register names ----------------*/
+
+/* generic names */
+#define C0_0		$0
+#define C0_1		$1
+#define C0_2		$2
+#define C0_3		$3
+#define C0_4		$4
+#define C0_5		$5
+#define C0_6		$6
+#define C0_7		$7
+#define C0_8		$8
+#define C0_9		$9
+#define C0_10		$10
+#define C0_11		$11
+#define C0_12		$12
+#define C0_13		$13
+#define C0_14		$14
+#define C0_15		$15
+#define C0_16		$16
+#define C0_17		$17
+#define C0_18		$18
+#define C0_19		$19
+#define C0_20		$20
+#define C0_21		$21
+#define C0_22		$22
+#define C0_23		$23
+#define C0_24		$24
+#define C0_25		$25
+#define C0_26		$26
+#define C0_27		$27
+#define C0_28		$28
+#define C0_29		$29
+#define C0_30		$30
+#define C0_31		$31
+
+/* common register names of C0 */
+#define C0_INDEX	$0
+#define C0_INX		$0		/* TLB Index */
+#define C0_IBASE	$0		/* Instruction Addr. Space Base	*/
+#define	C0_IBOUND	$1		/* Instruction Addr. Space Bound	*/
+#define C0_RANDOM	$1
+#define C0_RAND		$1		/* TLB Random */
+#define C0_ENTRYLO	$2
+#define C0_TLBLO	$2		/* TLB EntryLo */
+#define C0_DBASE	$2		/* Data Address Space Base		*/
+#define	C0_ENTRYLO0	$2
+#define C0_DBOUND	$3		/* Data Address Space Bound		*/
+#define C0_ENTRYLO1	$3
+#define C0_CONTEXT	$4
+#define C0_CTEXT	$4		/* Context */
+#define	C0_PAGEMASK	$5
+#define	C0_WIRED	$6
+#define C0_BADVADDR	$8
+#define C0_COUNT	$9		/* R4K Timer	*/
+#define C0_ENTRYHI	$10
+#define C0_TLBHI	$10		/* TLB EntryHi */
+#define C0_COMPARE	$11		/* R4K: acts as s timer	*/
+#define C0_SR		$12
+#define C0_STATUS	$12
+#define C0_CAUSE	$13
+#define C0_EPC		$14
+#define C0_PRID		$15
+#if	defined(R4K)||defined(r4k)
+#define C0_CONFIG	$16		/* Device Configuration Information. Read ONLY	*/
+#else
+#define C0_CONFIG   $3		/* IDT 3081/71/41 specific registers */
+#endif	/* R4K	*/
+#define C0_CALG		$17		/* Cache Attributes	*/
+#define C0_LLADDR	$17
+#define C0_IWATCH	$18		/* R4K		*/
+#define C0_DWATCH	$19
+#define	C0_XCONTEXT	$20
+#define C0_ECC		$26		/* Error Checking and Correcting	*/
+#define C0_CACHEERR	$27		/* Cache parity error: read only	*/
+#define C0_TAGLO	$28		/* Cache Addressing	*/
+#define C0_TAGHI	$29
+#define C0_ERROREPC	$30
+
+
+
+/* IDT 3041 specific registers */
+#define C0_BUSCTRL  $2
+#define C0_COUNT	$9
+#define C0_PORTSIZE $10
+#define C0_COMPARE  $11
+
+
+
+/*----- coprocessor 1 control register names ---------*/
+#define C1_FCR0		$0		/* Implementation/Revision register */
+#define FPA_IRR		$0
+#define C1_FGR0		$0
+#define C1_FGR1		$1
+#define C1_FGR2		$2
+#define C1_FGR3		$3
+#define C1_FGR4		$4
+#define C1_FGR5		$5
+#define C1_FGR6		$6
+#define C1_FGR7		$7
+#define C1_FGR8		$8
+#define C1_FGR9		$9
+#define C1_FGR10	$10
+#define C1_FGR11	$11
+#define C1_FGR12	$12
+#define C1_FGR13	$13
+#define C1_FGR14	$14
+#define C1_FGR15	$15
+#define C1_FGR16	$16
+#define C1_FGR17	$17
+#define C1_FGR18	$18
+#define C1_FGR19	$19
+#define C1_FGR20	$20
+#define C1_FGR21	$21
+#define C1_FGR22	$22
+#define C1_FGR23	$23
+#define C1_FGR24	$24
+#define C1_FGR25	$25
+#define C1_FGR26	$26
+#define C1_FGR27	$27
+#define C1_FGR28	$28
+#define C1_FGR29	$29
+#define C1_FGR30	$30
+#define C1_FGR31	$31
+#define FPA_CSR		$31		/* Control/Status register */
+#define C1_FCR31	$31
+
+
+/*----- misc. assembly language defines -----------------------------*/
+#define global globl
+
+
+/*
+** LEAF: start of a leaf routine define
+*/
+#define	LEAF(proc)	\
+	.globl	proc;	\
+	.ent	proc;	\
+proc:;				\
+	.frame	sp,0,ra
+
+/*
+** END: end of the procedure define
+*/
+#define	END(proc) .end	proc
+
+
+
+#endif  /* LANGUAGE_ASSEMBLY */
+
+
+/* Exception vector locations */
+
+#if defined( R4K )||defined( r4k )
+#define TLB_MISS_VECT 	0x80000000
+#define XTLB_MISS_VECT 	0x80000080
+#define CACHE_ERROR_VECT 0xA0000100
+#define GENERAL_VECT	0x80000180
+#define INTERRUPT_VECT	0x80000200
+#else
+#define UTLB_MISS_VECT 	0x80000000
+#define GENERAL_VECT	0x80000080
+#endif
+
+
+
+
+/* Status Register */
+#if defined( R4K ) || defined( r4k )
+#define SR_CUMASK		0xf0000000	/* Coprocessor usable bits */
+#define	SR_CU3			0x80000000	/* Coprocessor 3 usable */
+#define SR_CU2			0x40000000	/* coprocessor 2 usable */
+#define SR_CU1			0x20000000	/* Coprocessor 1 usable */
+#define SR_CU0			0x10000000	/* Coprocessor 0 usable */
+#define SR_FR			0x04000000	/* Enable Additional Floating-point Reg.*/
+#define SR_RE			0x02000000	/* Reverse Endian Bit	*/
+#define SR_DL			0x01000000	/* Data Cache Lock: refill into A disable*/
+#define SR_IL			0x00800000	/* Instr. Cahe Lock: Refill to A disabled*/
+#define SR_BEV			0x00400000	/* Bootstrap Exception Vector */
+#define SR_SR			0x00100000	/* Soft Reset or NMI occurring bit	*/
+#define SR_CH			0x00040000	/* Cache Hit(: 1)/Miss(: 0) */
+#define SR_CE			0x00020000	/* ECC register set(: 1) */
+#define SR_DE			0x00010000	/* Cache parity exception:dis/enabled(1/0)*/
+
+#define SR_IMASK		0x0000ff00	/* Interrupt Mask */
+#define SR_IMASK8		0x00000000	/* Interrupt Mask level=8 */
+#define SR_IMASK7		0x00008000	/* Interrupt Mask level=7 */
+#define SR_IMASK6		0x0000c000	/* Interrupt Mask level=6 */
+#define SR_IMASK5		0x0000e000	/* Interrupt Mask level=5 */
+#define SR_IMASK4		0x0000f000	/* Interrupt Mask level=4 */
+#define SR_IMASK3		0x0000f800	/* Interrupt Mask level=3 */
+#define SR_IMASK2		0x0000fc00	/* Interrupt Mask level=2 */
+#define SR_IMASK1		0x0000fe00	/* Interrupt Mask level=1 */
+#define SR_IMASK0		0x0000ff00	/* Interrupt Mask level=0 */
+
+#define SR_IBIT8		0x00008000	/*  (Intr5) */
+#define SR_IBIT7		0x00004000	/*  (Intr4) */
+#define SR_IBIT6		0x00002000	/*  (Intr3) */
+#define SR_IBIT5		0x00001000	/*  (Intr2) */
+#define SR_IBIT4		0x00000800	/*  (Intr1) */
+#define SR_IBIT3		0x00000400	/*  (Intr0) */
+#define SR_IBIT2		0x00000200	/*  (Software Interrupt 1) */
+#define SR_IBIT1		0x00000100	/*  (Software Interrupt 0) */
+
+#define	SR_KX			0x00000080
+#define SR_SX			0x00000040
+#define SR_UX			0x00000020	/* 1=64 bit enabled; 0=32 bit enabled	*/
+#define SR_UM			0x00000010	/* 0=Kernal Mode / 1=User Mode	*/
+#define SR_KSU			0x00000018	/* Supervisor Mode.  4600/4700	*/
+#define SR_ERL			0x00000004	/* Error Level: 0-normal/1-error	*/
+#define SR_EXL			0x00000002	/* Exception Level: 0-normal/1-exception */
+#define SR_IE			0x00000001	/* Interrupt Enable, current */
+#else	/* end of R4K, start of R3K:	*/
+#define SR_CUMASK		0xf0000000	/* Coprocessor usable bits */
+#define	SR_CU3			0x80000000	/* Coprocessor 3 usable */
+#define SR_CU2			0x40000000	/* coprocessor 2 usable */
+#define SR_CU1			0x20000000	/* Coprocessor 1 usable */
+#define SR_CU0			0x10000000	/* Coprocessor 0 usable */
+#define SR_BEV			0x00400000	/* Bootstrap Exception Vector */
+#define SR_TS			0x00200000	/* TLB shutdown */
+#define SR_PE			0x00100000	/* Parity Error */
+#define SR_CM			0x00080000	/* Cache Miss */
+#define SR_PZ			0x00040000	/* Parity Zero */
+#define SR_SWC			0x00020000	/* Swap Caches */
+#define SR_ISC			0x00010000	/* Isolate Cache */
+
+#define SR_IMASK		0x0000ff00	/* Interrupt Mask */
+#define SR_IMASK8		0x00000000	/* Interrupt Mask level=8 */
+#define SR_IMASK7		0x00008000	/* Interrupt Mask level=7 */
+#define SR_IMASK6		0x0000c000	/* Interrupt Mask level=6 */
+#define SR_IMASK5		0x0000e000	/* Interrupt Mask level=5 */
+#define SR_IMASK4		0x0000f000	/* Interrupt Mask level=4 */
+#define SR_IMASK3		0x0000f800	/* Interrupt Mask level=3 */
+#define SR_IMASK2		0x0000fc00	/* Interrupt Mask level=2 */
+#define SR_IMASK1		0x0000fe00	/* Interrupt Mask level=1 */
+#define SR_IMASK0		0x0000ff00	/* Interrupt Mask level=0 */
+
+#define SR_IBIT8		0x00008000	/*  (Intr5) */
+#define SR_IBIT7		0x00004000	/*  (Intr4) */
+#define SR_IBIT6		0x00002000	/*  (Intr3) */
+#define SR_IBIT5		0x00001000	/*  (Intr2) */
+#define SR_IBIT4		0x00000800	/*  (Intr1) */
+#define SR_IBIT3		0x00000400	/*  (Intr0) */
+#define SR_IBIT2		0x00000200	/*  (Software Interrupt 1) */
+#define SR_IBIT1		0x00000100	/*  (Software Interrupt 0) */
+
+#define SR_KUO			0x00000020	/* Kernel/User mode, old */
+#define SR_IEO			0x00000010	/* Interrupt Enable, old */
+#define SR_KUP			0x00000008	/* Kernel/User mode, previous */
+#define SR_IEP			0x00000004	/* Interrupt Enable, previous */
+#define SR_KUC			0x00000002	/* Kernel/User mode, current */
+#define SR_IEC			0x00000001	/* Interrupt Enable, current */
+#endif	/*	R3K	*/
+
+
+/* C0_CALG	*/
+/* MX: cache mode; CX: number of bits for MX to be left shifted	in C0_CALG	*/
+#define C0_CALG_C0		0x0		/* 0x00000000 to 0x1FFFFFFF					*/
+#define C0_CALG_C1		0x4		/* 0x20000000 to 0x3FFFFFFF					*/
+#define C0_CALG_C2		0x8		/* 0x40000000 to 0x5FFFFFFF					*/
+#define C0_CALG_C3		0xc		/* 0x60000000 to 0x7FFFFFFF					*/
+#define C0_CALG_C4		0x10	/* 0x80000000 to 0x9FFFFFFF					*/
+#define C0_CALG_C5		0x14	/* 0xA0000000 to 0xBFFFFFFF					*/
+#define C0_CALG_C6		0x18	/* 0xC0000000 to 0xDFFFFFFF					*/
+#define C0_CALG_C7		0x1c	/* 0xE0000000 to 0xFFFFFFFF					*/
+#define C0_CALG_M0		0x0		/* Cached, write-through, no write-allocate */
+#define C0_CALG_M1		0x1		/* Cached, write-through, write-allocate	*/
+#define	C0_CALG_M2		0x2		/* Uncahced									*/
+#define C0_CALG_M3		0x3		/* Cached, write-back, write-allocate		*/
+
+/* BSO compatible */
+#define ST_KUO			0x00000020	/* Kernel/User mode, old */
+#define ST_IEO			0x00000010	/* Interrupt Enable, old */
+#define ST_KUP			0x00000008	/* Kernel/User mode, previous */
+#define ST_IEP			0x00000004	/* Interrupt Enable, previous */
+#define ST_KUC			0x00000002	/* Kernel/User mode, current */
+#define ST_IEC			0x00000001	/* Interrupt Enable, current */
+
+/* Cause Register */
+#define CAUSE_BD		0x80000000	/* Branch Delay */
+#define CAUSE_CEMASK	0x30000000	/* Coprocessor Error */
+#define CAUSE_CESHIFT	28			/* Right justify CE  */
+#define CAUSE_DW		0x02000000	/* DWatch Reg. matced on a Watch except. */
+#define CAUSE_IW		0x01000000	/* IWatch Reg. matced on a Watch except. */
+#define CAUSE_IV		0x00800000	/* Exception Vec. (200) for interrupt.	*/
+#define CAUSE_IPMASK	0x0000ff00	/* Interrupt Pending */
+#define CAUSE_IPSHIFT	8			/* Right justify IP  */
+#define CAUSE_IP8		0x00008000	/*  (Intr5) */
+#define CAUSE_IP7		0x00004000	/*  (Intr4) */
+#define CAUSE_IP6		0x00002000	/*  (Intr3) */
+#define CAUSE_IP5		0x00001000	/*  (Intr2) */
+#define CAUSE_IP4		0x00000800	/*  (Intr1) */
+#define CAUSE_IP3		0x00000400	/*  (Intr0) */
+#define CAUSE_SW2		0x00000200	/*  (Software Interrupt 1) */
+#define CAUSE_SW1		0x00000100	/*  (Software Interrupt 0) */
+#define CAUSE_EXCMASK	0x0000007c	/* Exception Code */
+#define CAUSE_EXCSHIFT	2			/* Right justify EXC */
+
+/* Exception Code */
+#define EXC_INT			(0 << 2)	/* External interrupt */
+#define EXC_MOD			(1 << 2)	/* TLB modification */
+#define EXC_TLBL		(2 << 2)    /* TLB miss (Load or Ifetch) */
+#define EXC_IBOUND		(2 << 2)	/* Replacing TLB in 4650	*/
+#define EXC_TLBS		(3 << 2)	/* TLB miss (Save) */
+#define EXC_DBOUND		(3 << 2)	/* Replacing TLB in 4650	*/
+#define EXC_ADEL		(4 << 2)    /* Address error (Load or Ifetch) */
+#define EXC_ADES		(5 << 2)	/* Address error (Store) */
+#define EXC_IBE			(6 << 2)	/* Bus error (Ifetch) */
+#define EXC_DBE			(7 << 2)	/* Bus error (data load or store) */
+#define EXC_SYS			(8 << 2)	/* System call */
+#define EXC_BP			(9 << 2)	/* Break point */
+#define EXC_RI			(10 << 2)	/* Reserved instruction */
+#define EXC_CPU			(11 << 2)	/* Coprocessor unusable */
+#define EXC_OVF			(12 << 2)	/* Arithmetic overflow */
+#define EXC_TR			(13 << 2)	/* Trap Exception		*/
+#define	EXC_FPE			(15 << 2)	/* Floating-Point Exception	*/
+#define EXC_WATCH		(23 << 23)	/* Watch Exception			*/
+
+/* 3041 */
+#define BUSCTRL_LOCK	0x80000000
+#define BUSCTRL_MEM		0x0C000000
+#define BUSCTRL_ED		0x03000000
+#define BUSCTRL_IO		0x00C00000
+#define BUSCTRL_BE16	0x00200000
+#define BUSCTRL_BE		0x00080000
+#define BUSCTRL_BTA		0x0000C000
+#define BUSCTRL_DMA		0x00002000
+#define BUSCTRL_TC		0x00001000
+#define BUSCTRL_BR		0x00000800
+
+
+
+
+/* Normalized Exception Codes */
+#if defined( R3K )||defined( r3k )
+
+#define EX_UNKNOWN_INTERRUPT		0
+#define	EX_TLB_MODIFIED				1
+#define	EX_TLB_MISS_LF				2
+#define	EX_TLB_MISS_S				3
+#define	EX_ADDRESS_ERROR_LF			4
+#define	EX_ADDRESS_ERROR_S			5
+#define	EX_BUS_ERROR_F				6
+#define	EX_BUS_ERROR_LS				7
+#define	EX_UNKNOWN_SYSCALL			8
+#define	EX_UNKNOWN_BREAK			9
+#define	EX_RESERVED_INSTRUCTION		10
+#define	EX_COPROCESSOR_UNUSABLE		11
+#define	EX_OVERFLOW					12
+#define	EX_RESERVED13				13
+#define	EX_RESERVED14				14
+#define	EX_RESERVED15				15
+
+#endif
+
+#if defined( R4K )||defined( r4k )
+
+#define EX_UNKNOWN_INTERRUPT		0
+#define	EX_TLB_MODIFIED				1
+#define	EX_TLB_MISS_LF				2
+#define	EX_TLB_MISS_S				3
+#define	EX_ADDRESS_ERROR_LF			4
+#define	EX_ADDRESS_ERROR_S			5
+#define	EX_BUS_ERROR_F				6
+#define	EX_BUS_ERROR_LS				7
+#define	EX_UNKNOWN_SYSCALL			8
+#define	EX_UNKNOWN_BREAK			9
+#define	EX_RESERVED_INSTRUCTION		10
+#define	EX_COPROCESSOR_UNUSABLE		11
+#define	EX_OVERFLOW					12
+#define	EX_TRP						13
+#define	EX_RESERVED14				14
+#define	EX_FPE						15
+
+#endif
+
+/* CACHE opcode	*/
+#if defined( R4K )||defined( r4k )
+
+/* primary cache	*/
+#define	I_INDEX_INVALIDATE			0x0
+#define D_INDEX_WRITEBACK_INVALIDATE		0x1
+#define	I_INDEX_LOAD_TAG			0x4
+#define	D_INDEX_LOAD_TAG			0x5
+#define	I_INDEX_STORE_TAG			0x8
+#define	D_INDEX_STORE_TAG			0x9
+#define D_CREATE_DIRTY_EXCLUSIVE	0xd
+#define I_HIT_INVALIDATE			0x10
+#define D_HIT_INVALIDATE			0x11
+#define	I_FILL						0x14
+#define	D_HIT_WRITEBACK_INVALIDATE	0x15
+#define	I_HIT_WRITEBACK				0x18
+#define	D_HIT_WRITEBACK				0x19
+
+/* secondary cache	*/
+#define S_INDEX_LOAD_TAG			0x7
+#define S_INDEX_STORE_TAG			0xb
+#define S_VALID_CLEAR				0x3
+#define S_PAGE_INVALIDATE			0x17
+#define S_CACHE_PAGE_SIZE			0x1000
+#define S_CACHE_UNIT_SIZE			0x80000
+#endif
+
+#define HI_HALF(x)	((x) >> 16)
+#define LO_HALF(x)	((x) & 0xffff)
+
+
+
+/* Floating-Point Control register bits */
+#define CSR_C			0x00800000
+#define CSR_EXC			0x0003f000
+#define CSR_EE			0x00020000
+#define CSR_EV			0x00010000
+#define CSR_EZ			0x00008000
+#define CSR_EO			0x00004000
+#define CSR_EU			0x00002000
+#define CSR_EI			0x00001000
+#define CSR_TV			0x00000800
+#define CSR_TZ			0x00000400
+#define CSR_TO			0x00000200
+#define CSR_TU			0x00000100
+#define CSR_TI			0x00000080
+#define CSR_SV			0x00000040
+#define CSR_SZ			0x00000020
+#define CSR_SO			0x00000010
+#define CSR_SU			0x00000008
+#define CSR_SI			0x00000004
+#define CSR_RM			0x00000003
+
+
+/*
+** PRID Values for various processors:
+*/
+#define PRID_3000		0x00000230 /* + 3051/52/81/71 */
+#define PRID_3041		0x00000700
+#define PRID_3041A		0x00000701
+#define PRID_3041FX		0x00000710
+#define PRID_36100		0x00000710
+
+#define PRID_33000		0			/* 33050/33020 */
+#define PRID_33300		0x00000A0A
+#define PRID_33310		0x00000B0A
+
+#define PRID_30100		0x00002100	/* Philips PR30100 (MR300 core) */
+
+#define PRID_4640		0x00002200
+#define PRID_4650		0x00002200
+#define PRID_4000		0x00000400
+#define PRID_4200		0x00000a00
+#define PRID_4300		0x00000b00
+#define PRID_4400		0x00000400	/* should 4400 = 4000 in that sense ? */
+#define PRID_4600		0x00002000
+#define PRID_4700		0x00002100
+
+#define PRID_5000		0x00002300
+#define PRID_52XX		0x00002800
+#define PRID_5230		0x00002800
+#define PRID_5260		0x00002800
+#define PRID_7000		0x00002700
+
+#define PRID_64475		0x00003000
+#define PRID_64474		0x00003000
+#define PRID_6447X		0x00003000
+
+#define PRID_32364      0x00002600
+
+#define PRID_MASK		0x0000ff00
+
+
+/*-------------------------------------------------------------------
+**
+** Memory Mapped Registers - IDT 36100 Family
+**
+**-------------------------------------------------------------------
+*/
+#define TM41_PRESCALE_COUNT 0xffffe900
+#define TM41_TIMER0_COUNT	0xffffe910
+#define TM41_TIMER0_COMPARE	0xffffe914
+#define TM41_TIMER0_PWM		0xffffe918
+#define TM41_TIMER0_CONTROL	0xffffe91c
+#define TM41_TIMER1_COUNT	0xffffe920
+#define TM41_TIMER1_COMPARE	0xffffe924
+#define TM41_TIMER1_CONTROL	0xffffe92c
+#define TM41_TIMER2_COUNT	0xffffe930
+#define TM41_TIMER2_COMPARE	0xffffe934
+#define TM41_TIMER2_CONTROL	0xffffe93c
+
+#define PIO41_GLOBAL_LOCK	0xffffea00
+#define PIO41_DATA0			0xffffea10
+#define PIO41_DC0			0xffffea10
+#define PIO41_ESC0			0xffffea10
+#define PIO41_DATA1			0xffffea10
+#define PIO41_DC1			0xffffea10
+#define PIO41_ESC1			0xffffea10
+
+#define INT41_EICR			0xffffeb00
+#define INT41_EIPR0			0xffffeb10
+#define INT41_EIMR0			0xffffeb14
+#define INT41_EIPR1			0xffffeb20
+#define INT41_EIMR1			0xffffeb24
+#define INT41_EIPR2			0xffffeb30
+#define INT41_EIMR2			0xffffeb34
+
+#define DBG41_TRACE_ADDR	0xffffe500
+#define DBG41_TRACE_CONTROL	0xffffe504
+#define DBG41_DEBUG_CONTROL	0xffffe508
+
+
+
+
+/*-------------------------------------------------------------------
+**
+** Defines for Lexra's LX-4080 core
+**
+**-------------------------------------------------------------------
+*/
+//#if defined( LX4080 ) || defined( LX4080_CORE )
+#define C0_CCTL		$20		/* Cache Control */
+#define CCTL_DIvl	0x00000001	/* Invalidate Dcache */
+#define CCTL_IIvl	0x00000002	/* Invalidate Icache/IRAM */
+#define CCTL_ILk	0x00000004
+#define CCTL_ILkM	0x00000008
+
+/* Coprocessor 3 Control Registers */
+#define C3_CON		$0
+
+/* Coprocessor 3 General Registers */
+#define C3_IWBASE	$0	/* IW Base Address [31:10] */
+#define C3_IWTOP	$1	/* IW Top Address [15:4] */
+#define C3_DWBASE	$4	/* DW Base Address [31:10] */
+#define C3_DWTOP	$5	/* DW Top Address [15:4] */
+#define C3_CNT0LO	$8	/* Counter 0 [31:0] */
+#define C3_CNT0HI	$9	/* Counter 0 [47:32] */
+#define C3_CNT1LO	$10	/* Counter 1 [31:0] */
+#define C3_CNT1HI	$11	/* Counter 1 [47:32] */
+#define C3_CNT2LO	$12	/* Counter 2 [31:0] */
+#define C3_CNT2HI	$13	/* Counter 2 [47:32] */
+#define C3_CNT3LO	$14	/* Counter 3 [31:0] */
+#define C3_CNT3HI	$15	/* Counter 3 [47:32] */
+
+//#endif
+
+
+
+
+
+/*-------------------------------------------------------------------
+**
+** Defines for Philips MR300 CORE / PR30100 OCP processor
+**
+**-------------------------------------------------------------------
+*/
+
+/* MR300 core registers and bit definitions */
+#define MR_CCR			$16
+#define MR_CONFIG		$17
+
+#define CCR_ICD			0x1
+#define CCR_ICI			0x2
+#define CCR_EII			0x4
+#define CCR_ICL			0x8
+#define CCR_DCD			0x10
+#define CCR_DCI			0x20
+#define CCR_EDI			0x40
+#define CCR_DBD			0x80
+#define CCR_DCL			0x100
+
+#define CONFIG_IS		0x1
+#define CONFIG_SP		0x2
+#define CONFIG_ILS		0xC
+#define CONFIG_DLS		0x30
+#define CONFIG_RVE		0x100
+#define CONFIG_VS		0x3000
+#define CONFIG_SMIO		0xFF0000
+
+/* R4650,R4700,R5000	*/
+#define	CONFIG_IC_MASK	0xE00	/* indicates i-cache size	*/
+#define CONFIG_DC_MASK	0x1C0	/* indicates d-cache size	*/
+#define CONFIG_IB_MASK	0x20	/* indicates i-cache line size	*/
+#define CONFIG_DB_MASK	0x10	/* indicates d-cache line szie	*/
+#define	CONFIG_BE		0x8000	/* endianness				*/
+#define	CONFIG_SS_MASK	0x00300000	/* secondary cache size	*/
+#define	CONFIG_SE		0x1000	/* secondary cache enable	*/
+
+/* OCP (PR30100) internal memory mapped registers internals */
+#define	OCP_REG_BASE	0xb0c00000
+
+/* register offsets from the base address */
+#define OCP_MCR0		0
+#define OCP_MCR1		4
+#define OCP_MCR2		8
+#define OCP_MCR3		0xc
+#define OCP_IO_DIR		0xa0
+#define OCP_IO_DATA_OUT 0xac
+
+#define	TB_CONF_REG		0xbe000080
+
+
+
+/*-------------------------------------------------------------------
+**  CPU sub groups (e.g. chip makers) (Used by osboot and rss)
+**  BIT Field
+**------------------------------------------------------------------- 
+*/
+#define R3000_CORE		1		/* R3000/R3010 */
+#define IDT_R3000_CORE	2		/* IDT 3051/52/81/71/41/41fx */
+								/* Philips MR300 core */
+#define LR33000_CORE	3		/* LR33000/33050/33020 */
+#define R4000_CORE		4		/* R4000 */
+#define LX4080_CORE		5		/* Lexra 4080  */
+#define IDT32_CORE		6		/* IDT MIPS32 core  */
+
+
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/gpu_wrapper_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/gpu_wrapper_reg.h
new file mode 100644
index 00000000..03ef8f6
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/gpu_wrapper_reg.h
@@ -0,0 +1,2180 @@
+/**************************************************************
+// Spec Version                  : unknown
+// Parser Version                : DVR_Parser_6.5
+// CModelGen Version             : 5.0 2009.04.09
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/6/27 14:1:58
+***************************************************************/
+
+
+#ifndef _GPU_WRAPPER_REG_H_INCLUDED_
+#define _GPU_WRAPPER_REG_H_INCLUDED_
+#ifdef  _GPU_WRAPPER_USE_STRUCT
+typedef struct 
+{
+unsigned int     wcmd_kn:5;
+unsigned int     rcmd_kn:5;
+unsigned int     outstd_wcmd:5;
+unsigned int     outstd_rcmd:5;
+unsigned int     grp_lmt:5;
+unsigned int     grp_size:3;
+unsigned int     cmd_reorder_en:1;
+unsigned int     burst_lmt:1;
+unsigned int     grp_wen:1;
+unsigned int     grp_ren:1;
+}GPU_WRAPPER;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     chk_rdfifo_mod:1;
+unsigned int     rcmd_chk_rdfifo_num:2;
+unsigned int     rcmd_chk_rdfifo:1;
+unsigned int     wcmd_wait_wd:1;
+}CHK_RDFIFO;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     BIST_MODE13:1;
+unsigned int     BIST_MODE12:1;
+unsigned int     BIST_MODE11:1;
+unsigned int     BIST_MODE10:1;
+unsigned int     BIST_MODE9:1;
+unsigned int     BIST_MODE8:1;
+unsigned int     BIST_MODE7:1;
+unsigned int     BIST_MODE6:1;
+unsigned int     BIST_MODE5:1;
+unsigned int     BIST_MODE4:1;
+unsigned int     BIST_MODE3:1;
+unsigned int     BIST_MODE2:1;
+unsigned int     BIST_MODE1:1;
+}BIST_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     DRF_TEST_RESUME13:1;
+unsigned int     DRF_TEST_RESUME12:1;
+unsigned int     DRF_TEST_RESUME11:1;
+unsigned int     DRF_TEST_RESUME10:1;
+unsigned int     DRF_TEST_RESUME9:1;
+unsigned int     DRF_TEST_RESUME8:1;
+unsigned int     DRF_TEST_RESUME7:1;
+unsigned int     DRF_TEST_RESUME6:1;
+unsigned int     DRF_TEST_RESUME5:1;
+unsigned int     DRF_TEST_RESUME4:1;
+unsigned int     DRF_TEST_RESUME3:1;
+unsigned int     DRF_TEST_RESUME2:1;
+unsigned int     DRF_TEST_RESUME1:1;
+unsigned int     DRF_BIST_MODE13:1;
+unsigned int     DRF_BIST_MODE12:1;
+unsigned int     DRF_BIST_MODE11:1;
+unsigned int     DRF_BIST_MODE10:1;
+unsigned int     DRF_BIST_MODE9:1;
+unsigned int     DRF_BIST_MODE8:1;
+unsigned int     DRF_BIST_MODE7:1;
+unsigned int     DRF_BIST_MODE6:1;
+unsigned int     DRF_BIST_MODE5:1;
+unsigned int     DRF_BIST_MODE4:1;
+unsigned int     DRF_BIST_MODE3:1;
+unsigned int     DRF_BIST_MODE2:1;
+unsigned int     DRF_BIST_MODE1:1;
+}DRF_BIST_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     DRF_START_PAUSE1:1;
+unsigned int     DRF_BIST_FAIL1_9:1;
+unsigned int     DRF_BIST_FAIL1_8:1;
+unsigned int     DRF_BIST_FAIL1_7:1;
+unsigned int     DRF_BIST_FAIL1_6:1;
+unsigned int     DRF_BIST_FAIL1_5:1;
+unsigned int     DRF_BIST_FAIL1_4:1;
+unsigned int     DRF_BIST_FAIL1_3:1;
+unsigned int     DRF_BIST_FAIL1_2:1;
+unsigned int     DRF_BIST_FAIL1_1:1;
+unsigned int     DRF_BIST_FAIL1_0:1;
+unsigned int     DRF_BIST_DONE1:1;
+unsigned int     BIST_FAIL1_9:1;
+unsigned int     BIST_FAIL1_8:1;
+unsigned int     BIST_FAIL1_7:1;
+unsigned int     BIST_FAIL1_6:1;
+unsigned int     BIST_FAIL1_5:1;
+unsigned int     BIST_FAIL1_4:1;
+unsigned int     BIST_FAIL1_3:1;
+unsigned int     BIST_FAIL1_2:1;
+unsigned int     BIST_FAIL1_1:1;
+unsigned int     BIST_FAIL1_0:1;
+unsigned int     BIST_DONE1:1;
+}BIST_RESULT1;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     DRF_START_PAUSE2:1;
+unsigned int     DRF_BIST_FAIL2_9:1;
+unsigned int     DRF_BIST_FAIL2_8:1;
+unsigned int     DRF_BIST_FAIL2_7:1;
+unsigned int     DRF_BIST_FAIL2_6:1;
+unsigned int     DRF_BIST_FAIL2_5:1;
+unsigned int     DRF_BIST_FAIL2_4:1;
+unsigned int     DRF_BIST_FAIL2_3:1;
+unsigned int     DRF_BIST_FAIL2_2:1;
+unsigned int     DRF_BIST_FAIL2_1:1;
+unsigned int     DRF_BIST_FAIL2_0:1;
+unsigned int     DRF_BIST_DONE2:1;
+unsigned int     BIST_FAIL2_9:1;
+unsigned int     BIST_FAIL2_8:1;
+unsigned int     BIST_FAIL2_7:1;
+unsigned int     BIST_FAIL2_6:1;
+unsigned int     BIST_FAIL2_5:1;
+unsigned int     BIST_FAIL2_4:1;
+unsigned int     BIST_FAIL2_3:1;
+unsigned int     BIST_FAIL2_2:1;
+unsigned int     BIST_FAIL2_1:1;
+unsigned int     BIST_FAIL2_0:1;
+unsigned int     BIST_DONE2:1;
+}BIST_RESULT2;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     DRF_START_PAUSE3:1;
+unsigned int     DRF_BIST_FAIL3_6:1;
+unsigned int     DRF_BIST_FAIL3_5:1;
+unsigned int     DRF_BIST_FAIL3_4:1;
+unsigned int     DRF_BIST_FAIL3_3:1;
+unsigned int     DRF_BIST_FAIL3_2:1;
+unsigned int     DRF_BIST_FAIL3_1:1;
+unsigned int     DRF_BIST_FAIL3_0:1;
+unsigned int     DRF_BIST_DONE3:1;
+unsigned int     BIST_FAIL3_6:1;
+unsigned int     BIST_FAIL3_5:1;
+unsigned int     BIST_FAIL3_4:1;
+unsigned int     BIST_FAIL3_3:1;
+unsigned int     BIST_FAIL3_2:1;
+unsigned int     BIST_FAIL3_1:1;
+unsigned int     BIST_FAIL3_0:1;
+unsigned int     BIST_DONE3:1;
+}BIST_RESULT3;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     DRF_START_PAUSE4:1;
+unsigned int     DRF_BIST_FAIL4_6:1;
+unsigned int     DRF_BIST_FAIL4_5:1;
+unsigned int     DRF_BIST_FAIL4_4:1;
+unsigned int     DRF_BIST_FAIL4_3:1;
+unsigned int     DRF_BIST_FAIL4_2:1;
+unsigned int     DRF_BIST_FAIL4_1:1;
+unsigned int     DRF_BIST_FAIL4_0:1;
+unsigned int     DRF_BIST_DONE4:1;
+unsigned int     BIST_FAIL4_6:1;
+unsigned int     BIST_FAIL4_5:1;
+unsigned int     BIST_FAIL4_4:1;
+unsigned int     BIST_FAIL4_3:1;
+unsigned int     BIST_FAIL4_2:1;
+unsigned int     BIST_FAIL4_1:1;
+unsigned int     BIST_FAIL4_0:1;
+unsigned int     BIST_DONE4:1;
+}BIST_RESULT4;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     DRF_START_PAUSE5:1;
+unsigned int     DRF_BIST_FAIL5_9:1;
+unsigned int     DRF_BIST_FAIL5_8:1;
+unsigned int     DRF_BIST_FAIL5_7:1;
+unsigned int     DRF_BIST_FAIL5_6:1;
+unsigned int     DRF_BIST_FAIL5_5:1;
+unsigned int     DRF_BIST_FAIL5_4:1;
+unsigned int     DRF_BIST_FAIL5_3:1;
+unsigned int     DRF_BIST_FAIL5_2:1;
+unsigned int     DRF_BIST_FAIL5_1:1;
+unsigned int     DRF_BIST_FAIL5_0:1;
+unsigned int     DRF_BIST_DONE5:1;
+unsigned int     BIST_FAIL5_9:1;
+unsigned int     BIST_FAIL5_8:1;
+unsigned int     BIST_FAIL5_7:1;
+unsigned int     BIST_FAIL5_6:1;
+unsigned int     BIST_FAIL5_5:1;
+unsigned int     BIST_FAIL5_4:1;
+unsigned int     BIST_FAIL5_3:1;
+unsigned int     BIST_FAIL5_2:1;
+unsigned int     BIST_FAIL5_1:1;
+unsigned int     BIST_FAIL5_0:1;
+unsigned int     BIST_DONE5:1;
+}BIST_RESULT5;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     DRF_START_PAUSE6:1;
+unsigned int     DRF_BIST_FAIL6_9:1;
+unsigned int     DRF_BIST_FAIL6_8:1;
+unsigned int     DRF_BIST_FAIL6_7:1;
+unsigned int     DRF_BIST_FAIL6_6:1;
+unsigned int     DRF_BIST_FAIL6_5:1;
+unsigned int     DRF_BIST_FAIL6_4:1;
+unsigned int     DRF_BIST_FAIL6_3:1;
+unsigned int     DRF_BIST_FAIL6_2:1;
+unsigned int     DRF_BIST_FAIL6_1:1;
+unsigned int     DRF_BIST_FAIL6_0:1;
+unsigned int     DRF_BIST_DONE6:1;
+unsigned int     BIST_FAIL6_9:1;
+unsigned int     BIST_FAIL6_8:1;
+unsigned int     BIST_FAIL6_7:1;
+unsigned int     BIST_FAIL6_6:1;
+unsigned int     BIST_FAIL6_5:1;
+unsigned int     BIST_FAIL6_4:1;
+unsigned int     BIST_FAIL6_3:1;
+unsigned int     BIST_FAIL6_2:1;
+unsigned int     BIST_FAIL6_1:1;
+unsigned int     BIST_FAIL6_0:1;
+unsigned int     BIST_DONE6:1;
+}BIST_RESULT6;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     DRF_START_PAUSE7:1;
+unsigned int     DRF_BIST_FAIL7_6:1;
+unsigned int     DRF_BIST_FAIL7_5:1;
+unsigned int     DRF_BIST_FAIL7_4:1;
+unsigned int     DRF_BIST_FAIL7_3:1;
+unsigned int     DRF_BIST_FAIL7_2:1;
+unsigned int     DRF_BIST_FAIL7_1:1;
+unsigned int     DRF_BIST_FAIL7_0:1;
+unsigned int     DRF_BIST_DONE7:1;
+unsigned int     BIST_FAIL7_6:1;
+unsigned int     BIST_FAIL7_5:1;
+unsigned int     BIST_FAIL7_4:1;
+unsigned int     BIST_FAIL7_3:1;
+unsigned int     BIST_FAIL7_2:1;
+unsigned int     BIST_FAIL7_1:1;
+unsigned int     BIST_FAIL7_0:1;
+unsigned int     BIST_DONE7:1;
+}BIST_RESULT7;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     DRF_START_PAUSE8:1;
+unsigned int     DRF_BIST_FAIL8_6:1;
+unsigned int     DRF_BIST_FAIL8_5:1;
+unsigned int     DRF_BIST_FAIL8_4:1;
+unsigned int     DRF_BIST_FAIL8_3:1;
+unsigned int     DRF_BIST_FAIL8_2:1;
+unsigned int     DRF_BIST_FAIL8_1:1;
+unsigned int     DRF_BIST_FAIL8_0:1;
+unsigned int     DRF_BIST_DONE8:1;
+unsigned int     BIST_FAIL8_6:1;
+unsigned int     BIST_FAIL8_5:1;
+unsigned int     BIST_FAIL8_4:1;
+unsigned int     BIST_FAIL8_3:1;
+unsigned int     BIST_FAIL8_2:1;
+unsigned int     BIST_FAIL8_1:1;
+unsigned int     BIST_FAIL8_0:1;
+unsigned int     BIST_DONE8:1;
+}BIST_RESULT8;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     DRF_START_PAUSE9:1;
+unsigned int     DRF_BIST_FAIL9_6:1;
+unsigned int     DRF_BIST_FAIL9_5:1;
+unsigned int     DRF_BIST_FAIL9_4:1;
+unsigned int     DRF_BIST_FAIL9_3:1;
+unsigned int     DRF_BIST_FAIL9_2:1;
+unsigned int     DRF_BIST_FAIL9_1:1;
+unsigned int     DRF_BIST_FAIL9_0:1;
+unsigned int     DRF_BIST_DONE9:1;
+unsigned int     BIST_FAIL9_6:1;
+unsigned int     BIST_FAIL9_5:1;
+unsigned int     BIST_FAIL9_4:1;
+unsigned int     BIST_FAIL9_3:1;
+unsigned int     BIST_FAIL9_2:1;
+unsigned int     BIST_FAIL9_1:1;
+unsigned int     BIST_FAIL9_0:1;
+unsigned int     BIST_DONE9:1;
+}BIST_RESULT9;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     DRF_START_PAUSE10:1;
+unsigned int     DRF_BIST_FAIL10_7:1;
+unsigned int     DRF_BIST_FAIL10_6:1;
+unsigned int     DRF_BIST_FAIL10_5:1;
+unsigned int     DRF_BIST_FAIL10_4:1;
+unsigned int     DRF_BIST_FAIL10_3:1;
+unsigned int     DRF_BIST_FAIL10_2:1;
+unsigned int     DRF_BIST_FAIL10_1:1;
+unsigned int     DRF_BIST_FAIL10_0:1;
+unsigned int     DRF_BIST_DONE10:1;
+unsigned int     BIST_FAIL10_7:1;
+unsigned int     BIST_FAIL10_6:1;
+unsigned int     BIST_FAIL10_5:1;
+unsigned int     BIST_FAIL10_4:1;
+unsigned int     BIST_FAIL10_3:1;
+unsigned int     BIST_FAIL10_2:1;
+unsigned int     BIST_FAIL10_1:1;
+unsigned int     BIST_FAIL10_0:1;
+unsigned int     BIST_DONE10:1;
+}BIST_RESULT10;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     DRF_START_PAUSE11:1;
+unsigned int     DRF_BIST_FAIL11_3:1;
+unsigned int     DRF_BIST_FAIL11_2:1;
+unsigned int     DRF_BIST_FAIL11_1:1;
+unsigned int     DRF_BIST_FAIL11_0:1;
+unsigned int     DRF_BIST_DONE11:1;
+unsigned int     BIST_FAIL11_3:1;
+unsigned int     BIST_FAIL11_2:1;
+unsigned int     BIST_FAIL11_1:1;
+unsigned int     BIST_FAIL11_0:1;
+unsigned int     BIST_DONE11:1;
+}BIST_RESULT11;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     DRF_START_PAUSE12:1;
+unsigned int     DRF_BIST_FAIL12_1:1;
+unsigned int     DRF_BIST_FAIL12_0:1;
+unsigned int     DRF_BIST_DONE12:1;
+unsigned int     BIST_FAIL12_1:1;
+unsigned int     BIST_FAIL12_0:1;
+unsigned int     BIST_DONE12:1;
+}BIST_RESULT12;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     DRF_START_PAUSE13:1;
+unsigned int     DRF_BIST_FAIL13_0:1;
+unsigned int     DRF_BIST_DONE13:1;
+unsigned int     BIST_FAIL13_0:1;
+unsigned int     BIST_DONE13:1;
+}BIST_RESULT13;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     sram_rm:4;
+unsigned int     sram_rme:1;
+}BIST_RESULT13;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     dbg_sel:1;
+unsigned int     dbg_sel1:4;
+unsigned int     dbg_sel0:4;
+}DEBUGPORTS;
+
+typedef struct 
+{
+unsigned int     dummy_reg0:32;
+}DUMMYREGISTERS0;
+
+typedef struct 
+{
+unsigned int     dummy_reg1:32;
+}DUMMYREGISTERS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     c35_data_in:20;
+unsigned int     reserved_1:2;
+unsigned int     c35_speed_en:1;
+unsigned int     c35_wire_sel:1;
+unsigned int     c35_ro_sel:3;
+unsigned int     c35_dss_rst_n:1;
+}DSS_C35_9D5T_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     c35_count_out:20;
+unsigned int     reserved_1:2;
+unsigned int     c35_wsort_go:1;
+unsigned int     c35_ready:1;
+}DSS_C35_9D5T_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     c35_dbgo:16;
+}DSS_C35_9D5T_DEBUG;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     c35d5_data_in:20;
+unsigned int     reserved_1:2;
+unsigned int     c35d5_speed_en:1;
+unsigned int     c35d5_wire_sel:1;
+unsigned int     c35d5_ro_sel:3;
+unsigned int     c35d5_dss_rst_n:1;
+}DSS_C35D5_9D5T_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     c35d5_count_out:20;
+unsigned int     reserved_1:2;
+unsigned int     c35d5_wsort_go:1;
+unsigned int     c35d5_ready:1;
+}DSS_C35D5_9D5T_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     c35d5_dbgo:16;
+}DSS_C35D5_9D5T_DEBUG;
+
+#endif
+
+#define GPU_WRAPPER                                                                  0x18036000
+#define GPU_WRAPPER_reg_addr                                                         "0xB8036000"
+#define GPU_WRAPPER_reg                                                              0xB8036000
+#define set_GPU_WRAPPER_reg(data)   (*((volatile unsigned int*) GPU_WRAPPER_reg)=data)
+#define get_GPU_WRAPPER_reg   (*((volatile unsigned int*) GPU_WRAPPER_reg))
+#define GPU_WRAPPER_inst_adr                                                         "0x0000"
+#define GPU_WRAPPER_inst                                                             0x0000
+#define GPU_WRAPPER_wcmd_kn_shift                                                    (27)
+#define GPU_WRAPPER_wcmd_kn_mask                                                     (0xF8000000)
+#define GPU_WRAPPER_wcmd_kn(data)                                                    (0xF8000000&((data)<<27))
+#define GPU_WRAPPER_wcmd_kn_src(data)                                                ((0xF8000000&(data))>>27)
+#define GPU_WRAPPER_get_wcmd_kn(data)                                                ((0xF8000000&(data))>>27)
+#define GPU_WRAPPER_rcmd_kn_shift                                                    (22)
+#define GPU_WRAPPER_rcmd_kn_mask                                                     (0x07C00000)
+#define GPU_WRAPPER_rcmd_kn(data)                                                    (0x07C00000&((data)<<22))
+#define GPU_WRAPPER_rcmd_kn_src(data)                                                ((0x07C00000&(data))>>22)
+#define GPU_WRAPPER_get_rcmd_kn(data)                                                ((0x07C00000&(data))>>22)
+#define GPU_WRAPPER_outstd_wcmd_shift                                                (17)
+#define GPU_WRAPPER_outstd_wcmd_mask                                                 (0x003E0000)
+#define GPU_WRAPPER_outstd_wcmd(data)                                                (0x003E0000&((data)<<17))
+#define GPU_WRAPPER_outstd_wcmd_src(data)                                            ((0x003E0000&(data))>>17)
+#define GPU_WRAPPER_get_outstd_wcmd(data)                                            ((0x003E0000&(data))>>17)
+#define GPU_WRAPPER_outstd_rcmd_shift                                                (12)
+#define GPU_WRAPPER_outstd_rcmd_mask                                                 (0x0001F000)
+#define GPU_WRAPPER_outstd_rcmd(data)                                                (0x0001F000&((data)<<12))
+#define GPU_WRAPPER_outstd_rcmd_src(data)                                            ((0x0001F000&(data))>>12)
+#define GPU_WRAPPER_get_outstd_rcmd(data)                                            ((0x0001F000&(data))>>12)
+#define GPU_WRAPPER_grp_lmt_shift                                                    (7)
+#define GPU_WRAPPER_grp_lmt_mask                                                     (0x00000F80)
+#define GPU_WRAPPER_grp_lmt(data)                                                    (0x00000F80&((data)<<7))
+#define GPU_WRAPPER_grp_lmt_src(data)                                                ((0x00000F80&(data))>>7)
+#define GPU_WRAPPER_get_grp_lmt(data)                                                ((0x00000F80&(data))>>7)
+#define GPU_WRAPPER_grp_size_shift                                                   (4)
+#define GPU_WRAPPER_grp_size_mask                                                    (0x00000070)
+#define GPU_WRAPPER_grp_size(data)                                                   (0x00000070&((data)<<4))
+#define GPU_WRAPPER_grp_size_src(data)                                               ((0x00000070&(data))>>4)
+#define GPU_WRAPPER_get_grp_size(data)                                               ((0x00000070&(data))>>4)
+#define GPU_WRAPPER_cmd_reorder_en_shift                                             (3)
+#define GPU_WRAPPER_cmd_reorder_en_mask                                              (0x00000008)
+#define GPU_WRAPPER_cmd_reorder_en(data)                                             (0x00000008&((data)<<3))
+#define GPU_WRAPPER_cmd_reorder_en_src(data)                                         ((0x00000008&(data))>>3)
+#define GPU_WRAPPER_get_cmd_reorder_en(data)                                         ((0x00000008&(data))>>3)
+#define GPU_WRAPPER_burst_lmt_shift                                                  (2)
+#define GPU_WRAPPER_burst_lmt_mask                                                   (0x00000004)
+#define GPU_WRAPPER_burst_lmt(data)                                                  (0x00000004&((data)<<2))
+#define GPU_WRAPPER_burst_lmt_src(data)                                              ((0x00000004&(data))>>2)
+#define GPU_WRAPPER_get_burst_lmt(data)                                              ((0x00000004&(data))>>2)
+#define GPU_WRAPPER_grp_wen_shift                                                    (1)
+#define GPU_WRAPPER_grp_wen_mask                                                     (0x00000002)
+#define GPU_WRAPPER_grp_wen(data)                                                    (0x00000002&((data)<<1))
+#define GPU_WRAPPER_grp_wen_src(data)                                                ((0x00000002&(data))>>1)
+#define GPU_WRAPPER_get_grp_wen(data)                                                ((0x00000002&(data))>>1)
+#define GPU_WRAPPER_grp_ren_shift                                                    (0)
+#define GPU_WRAPPER_grp_ren_mask                                                     (0x00000001)
+#define GPU_WRAPPER_grp_ren(data)                                                    (0x00000001&((data)<<0))
+#define GPU_WRAPPER_grp_ren_src(data)                                                ((0x00000001&(data))>>0)
+#define GPU_WRAPPER_get_grp_ren(data)                                                ((0x00000001&(data))>>0)
+
+
+#define CHK_RDFIFO                                                                   0x18036004
+#define CHK_RDFIFO_reg_addr                                                          "0xB8036004"
+#define CHK_RDFIFO_reg                                                               0xB8036004
+#define set_CHK_RDFIFO_reg(data)   (*((volatile unsigned int*) CHK_RDFIFO_reg)=data)
+#define get_CHK_RDFIFO_reg   (*((volatile unsigned int*) CHK_RDFIFO_reg))
+#define CHK_RDFIFO_inst_adr                                                          "0x0001"
+#define CHK_RDFIFO_inst                                                              0x0001
+#define CHK_RDFIFO_chk_rdfifo_mod_shift                                              (4)
+#define CHK_RDFIFO_chk_rdfifo_mod_mask                                               (0x00000010)
+#define CHK_RDFIFO_chk_rdfifo_mod(data)                                              (0x00000010&((data)<<4))
+#define CHK_RDFIFO_chk_rdfifo_mod_src(data)                                          ((0x00000010&(data))>>4)
+#define CHK_RDFIFO_get_chk_rdfifo_mod(data)                                          ((0x00000010&(data))>>4)
+#define CHK_RDFIFO_rcmd_chk_rdfifo_num_shift                                         (2)
+#define CHK_RDFIFO_rcmd_chk_rdfifo_num_mask                                          (0x0000000C)
+#define CHK_RDFIFO_rcmd_chk_rdfifo_num(data)                                         (0x0000000C&((data)<<2))
+#define CHK_RDFIFO_rcmd_chk_rdfifo_num_src(data)                                     ((0x0000000C&(data))>>2)
+#define CHK_RDFIFO_get_rcmd_chk_rdfifo_num(data)                                     ((0x0000000C&(data))>>2)
+#define CHK_RDFIFO_rcmd_chk_rdfifo_shift                                             (1)
+#define CHK_RDFIFO_rcmd_chk_rdfifo_mask                                              (0x00000002)
+#define CHK_RDFIFO_rcmd_chk_rdfifo(data)                                             (0x00000002&((data)<<1))
+#define CHK_RDFIFO_rcmd_chk_rdfifo_src(data)                                         ((0x00000002&(data))>>1)
+#define CHK_RDFIFO_get_rcmd_chk_rdfifo(data)                                         ((0x00000002&(data))>>1)
+#define CHK_RDFIFO_wcmd_wait_wd_shift                                                (0)
+#define CHK_RDFIFO_wcmd_wait_wd_mask                                                 (0x00000001)
+#define CHK_RDFIFO_wcmd_wait_wd(data)                                                (0x00000001&((data)<<0))
+#define CHK_RDFIFO_wcmd_wait_wd_src(data)                                            ((0x00000001&(data))>>0)
+#define CHK_RDFIFO_get_wcmd_wait_wd(data)                                            ((0x00000001&(data))>>0)
+
+
+#define BIST_MODE                                                                    0x18036008
+#define BIST_MODE_reg_addr                                                           "0xB8036008"
+#define BIST_MODE_reg                                                                0xB8036008
+#define set_BIST_MODE_reg(data)   (*((volatile unsigned int*) BIST_MODE_reg)=data)
+#define get_BIST_MODE_reg   (*((volatile unsigned int*) BIST_MODE_reg))
+#define BIST_MODE_inst_adr                                                           "0x0002"
+#define BIST_MODE_inst                                                               0x0002
+#define BIST_MODE_BIST_MODE13_shift                                                  (12)
+#define BIST_MODE_BIST_MODE13_mask                                                   (0x00001000)
+#define BIST_MODE_BIST_MODE13(data)                                                  (0x00001000&((data)<<12))
+#define BIST_MODE_BIST_MODE13_src(data)                                              ((0x00001000&(data))>>12)
+#define BIST_MODE_get_BIST_MODE13(data)                                              ((0x00001000&(data))>>12)
+#define BIST_MODE_BIST_MODE12_shift                                                  (11)
+#define BIST_MODE_BIST_MODE12_mask                                                   (0x00000800)
+#define BIST_MODE_BIST_MODE12(data)                                                  (0x00000800&((data)<<11))
+#define BIST_MODE_BIST_MODE12_src(data)                                              ((0x00000800&(data))>>11)
+#define BIST_MODE_get_BIST_MODE12(data)                                              ((0x00000800&(data))>>11)
+#define BIST_MODE_BIST_MODE11_shift                                                  (10)
+#define BIST_MODE_BIST_MODE11_mask                                                   (0x00000400)
+#define BIST_MODE_BIST_MODE11(data)                                                  (0x00000400&((data)<<10))
+#define BIST_MODE_BIST_MODE11_src(data)                                              ((0x00000400&(data))>>10)
+#define BIST_MODE_get_BIST_MODE11(data)                                              ((0x00000400&(data))>>10)
+#define BIST_MODE_BIST_MODE10_shift                                                  (9)
+#define BIST_MODE_BIST_MODE10_mask                                                   (0x00000200)
+#define BIST_MODE_BIST_MODE10(data)                                                  (0x00000200&((data)<<9))
+#define BIST_MODE_BIST_MODE10_src(data)                                              ((0x00000200&(data))>>9)
+#define BIST_MODE_get_BIST_MODE10(data)                                              ((0x00000200&(data))>>9)
+#define BIST_MODE_BIST_MODE9_shift                                                   (8)
+#define BIST_MODE_BIST_MODE9_mask                                                    (0x00000100)
+#define BIST_MODE_BIST_MODE9(data)                                                   (0x00000100&((data)<<8))
+#define BIST_MODE_BIST_MODE9_src(data)                                               ((0x00000100&(data))>>8)
+#define BIST_MODE_get_BIST_MODE9(data)                                               ((0x00000100&(data))>>8)
+#define BIST_MODE_BIST_MODE8_shift                                                   (7)
+#define BIST_MODE_BIST_MODE8_mask                                                    (0x00000080)
+#define BIST_MODE_BIST_MODE8(data)                                                   (0x00000080&((data)<<7))
+#define BIST_MODE_BIST_MODE8_src(data)                                               ((0x00000080&(data))>>7)
+#define BIST_MODE_get_BIST_MODE8(data)                                               ((0x00000080&(data))>>7)
+#define BIST_MODE_BIST_MODE7_shift                                                   (6)
+#define BIST_MODE_BIST_MODE7_mask                                                    (0x00000040)
+#define BIST_MODE_BIST_MODE7(data)                                                   (0x00000040&((data)<<6))
+#define BIST_MODE_BIST_MODE7_src(data)                                               ((0x00000040&(data))>>6)
+#define BIST_MODE_get_BIST_MODE7(data)                                               ((0x00000040&(data))>>6)
+#define BIST_MODE_BIST_MODE6_shift                                                   (5)
+#define BIST_MODE_BIST_MODE6_mask                                                    (0x00000020)
+#define BIST_MODE_BIST_MODE6(data)                                                   (0x00000020&((data)<<5))
+#define BIST_MODE_BIST_MODE6_src(data)                                               ((0x00000020&(data))>>5)
+#define BIST_MODE_get_BIST_MODE6(data)                                               ((0x00000020&(data))>>5)
+#define BIST_MODE_BIST_MODE5_shift                                                   (4)
+#define BIST_MODE_BIST_MODE5_mask                                                    (0x00000010)
+#define BIST_MODE_BIST_MODE5(data)                                                   (0x00000010&((data)<<4))
+#define BIST_MODE_BIST_MODE5_src(data)                                               ((0x00000010&(data))>>4)
+#define BIST_MODE_get_BIST_MODE5(data)                                               ((0x00000010&(data))>>4)
+#define BIST_MODE_BIST_MODE4_shift                                                   (3)
+#define BIST_MODE_BIST_MODE4_mask                                                    (0x00000008)
+#define BIST_MODE_BIST_MODE4(data)                                                   (0x00000008&((data)<<3))
+#define BIST_MODE_BIST_MODE4_src(data)                                               ((0x00000008&(data))>>3)
+#define BIST_MODE_get_BIST_MODE4(data)                                               ((0x00000008&(data))>>3)
+#define BIST_MODE_BIST_MODE3_shift                                                   (2)
+#define BIST_MODE_BIST_MODE3_mask                                                    (0x00000004)
+#define BIST_MODE_BIST_MODE3(data)                                                   (0x00000004&((data)<<2))
+#define BIST_MODE_BIST_MODE3_src(data)                                               ((0x00000004&(data))>>2)
+#define BIST_MODE_get_BIST_MODE3(data)                                               ((0x00000004&(data))>>2)
+#define BIST_MODE_BIST_MODE2_shift                                                   (1)
+#define BIST_MODE_BIST_MODE2_mask                                                    (0x00000002)
+#define BIST_MODE_BIST_MODE2(data)                                                   (0x00000002&((data)<<1))
+#define BIST_MODE_BIST_MODE2_src(data)                                               ((0x00000002&(data))>>1)
+#define BIST_MODE_get_BIST_MODE2(data)                                               ((0x00000002&(data))>>1)
+#define BIST_MODE_BIST_MODE1_shift                                                   (0)
+#define BIST_MODE_BIST_MODE1_mask                                                    (0x00000001)
+#define BIST_MODE_BIST_MODE1(data)                                                   (0x00000001&((data)<<0))
+#define BIST_MODE_BIST_MODE1_src(data)                                               ((0x00000001&(data))>>0)
+#define BIST_MODE_get_BIST_MODE1(data)                                               ((0x00000001&(data))>>0)
+
+
+#define DRF_BIST_MODE                                                                0x1803600C
+#define DRF_BIST_MODE_reg_addr                                                       "0xB803600C"
+#define DRF_BIST_MODE_reg                                                            0xB803600C
+#define set_DRF_BIST_MODE_reg(data)   (*((volatile unsigned int*) DRF_BIST_MODE_reg)=data)
+#define get_DRF_BIST_MODE_reg   (*((volatile unsigned int*) DRF_BIST_MODE_reg))
+#define DRF_BIST_MODE_inst_adr                                                       "0x0003"
+#define DRF_BIST_MODE_inst                                                           0x0003
+#define DRF_BIST_MODE_DRF_TEST_RESUME13_shift                                        (25)
+#define DRF_BIST_MODE_DRF_TEST_RESUME13_mask                                         (0x02000000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME13(data)                                        (0x02000000&((data)<<25))
+#define DRF_BIST_MODE_DRF_TEST_RESUME13_src(data)                                    ((0x02000000&(data))>>25)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME13(data)                                    ((0x02000000&(data))>>25)
+#define DRF_BIST_MODE_DRF_TEST_RESUME12_shift                                        (24)
+#define DRF_BIST_MODE_DRF_TEST_RESUME12_mask                                         (0x01000000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME12(data)                                        (0x01000000&((data)<<24))
+#define DRF_BIST_MODE_DRF_TEST_RESUME12_src(data)                                    ((0x01000000&(data))>>24)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME12(data)                                    ((0x01000000&(data))>>24)
+#define DRF_BIST_MODE_DRF_TEST_RESUME11_shift                                        (23)
+#define DRF_BIST_MODE_DRF_TEST_RESUME11_mask                                         (0x00800000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME11(data)                                        (0x00800000&((data)<<23))
+#define DRF_BIST_MODE_DRF_TEST_RESUME11_src(data)                                    ((0x00800000&(data))>>23)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME11(data)                                    ((0x00800000&(data))>>23)
+#define DRF_BIST_MODE_DRF_TEST_RESUME10_shift                                        (22)
+#define DRF_BIST_MODE_DRF_TEST_RESUME10_mask                                         (0x00400000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME10(data)                                        (0x00400000&((data)<<22))
+#define DRF_BIST_MODE_DRF_TEST_RESUME10_src(data)                                    ((0x00400000&(data))>>22)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME10(data)                                    ((0x00400000&(data))>>22)
+#define DRF_BIST_MODE_DRF_TEST_RESUME9_shift                                         (21)
+#define DRF_BIST_MODE_DRF_TEST_RESUME9_mask                                          (0x00200000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME9(data)                                         (0x00200000&((data)<<21))
+#define DRF_BIST_MODE_DRF_TEST_RESUME9_src(data)                                     ((0x00200000&(data))>>21)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME9(data)                                     ((0x00200000&(data))>>21)
+#define DRF_BIST_MODE_DRF_TEST_RESUME8_shift                                         (20)
+#define DRF_BIST_MODE_DRF_TEST_RESUME8_mask                                          (0x00100000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME8(data)                                         (0x00100000&((data)<<20))
+#define DRF_BIST_MODE_DRF_TEST_RESUME8_src(data)                                     ((0x00100000&(data))>>20)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME8(data)                                     ((0x00100000&(data))>>20)
+#define DRF_BIST_MODE_DRF_TEST_RESUME7_shift                                         (19)
+#define DRF_BIST_MODE_DRF_TEST_RESUME7_mask                                          (0x00080000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME7(data)                                         (0x00080000&((data)<<19))
+#define DRF_BIST_MODE_DRF_TEST_RESUME7_src(data)                                     ((0x00080000&(data))>>19)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME7(data)                                     ((0x00080000&(data))>>19)
+#define DRF_BIST_MODE_DRF_TEST_RESUME6_shift                                         (18)
+#define DRF_BIST_MODE_DRF_TEST_RESUME6_mask                                          (0x00040000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME6(data)                                         (0x00040000&((data)<<18))
+#define DRF_BIST_MODE_DRF_TEST_RESUME6_src(data)                                     ((0x00040000&(data))>>18)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME6(data)                                     ((0x00040000&(data))>>18)
+#define DRF_BIST_MODE_DRF_TEST_RESUME5_shift                                         (17)
+#define DRF_BIST_MODE_DRF_TEST_RESUME5_mask                                          (0x00020000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME5(data)                                         (0x00020000&((data)<<17))
+#define DRF_BIST_MODE_DRF_TEST_RESUME5_src(data)                                     ((0x00020000&(data))>>17)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME5(data)                                     ((0x00020000&(data))>>17)
+#define DRF_BIST_MODE_DRF_TEST_RESUME4_shift                                         (16)
+#define DRF_BIST_MODE_DRF_TEST_RESUME4_mask                                          (0x00010000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME4(data)                                         (0x00010000&((data)<<16))
+#define DRF_BIST_MODE_DRF_TEST_RESUME4_src(data)                                     ((0x00010000&(data))>>16)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME4(data)                                     ((0x00010000&(data))>>16)
+#define DRF_BIST_MODE_DRF_TEST_RESUME3_shift                                         (15)
+#define DRF_BIST_MODE_DRF_TEST_RESUME3_mask                                          (0x00008000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME3(data)                                         (0x00008000&((data)<<15))
+#define DRF_BIST_MODE_DRF_TEST_RESUME3_src(data)                                     ((0x00008000&(data))>>15)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME3(data)                                     ((0x00008000&(data))>>15)
+#define DRF_BIST_MODE_DRF_TEST_RESUME2_shift                                         (14)
+#define DRF_BIST_MODE_DRF_TEST_RESUME2_mask                                          (0x00004000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME2(data)                                         (0x00004000&((data)<<14))
+#define DRF_BIST_MODE_DRF_TEST_RESUME2_src(data)                                     ((0x00004000&(data))>>14)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME2(data)                                     ((0x00004000&(data))>>14)
+#define DRF_BIST_MODE_DRF_TEST_RESUME1_shift                                         (13)
+#define DRF_BIST_MODE_DRF_TEST_RESUME1_mask                                          (0x00002000)
+#define DRF_BIST_MODE_DRF_TEST_RESUME1(data)                                         (0x00002000&((data)<<13))
+#define DRF_BIST_MODE_DRF_TEST_RESUME1_src(data)                                     ((0x00002000&(data))>>13)
+#define DRF_BIST_MODE_get_DRF_TEST_RESUME1(data)                                     ((0x00002000&(data))>>13)
+#define DRF_BIST_MODE_DRF_BIST_MODE13_shift                                          (12)
+#define DRF_BIST_MODE_DRF_BIST_MODE13_mask                                           (0x00001000)
+#define DRF_BIST_MODE_DRF_BIST_MODE13(data)                                          (0x00001000&((data)<<12))
+#define DRF_BIST_MODE_DRF_BIST_MODE13_src(data)                                      ((0x00001000&(data))>>12)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE13(data)                                      ((0x00001000&(data))>>12)
+#define DRF_BIST_MODE_DRF_BIST_MODE12_shift                                          (11)
+#define DRF_BIST_MODE_DRF_BIST_MODE12_mask                                           (0x00000800)
+#define DRF_BIST_MODE_DRF_BIST_MODE12(data)                                          (0x00000800&((data)<<11))
+#define DRF_BIST_MODE_DRF_BIST_MODE12_src(data)                                      ((0x00000800&(data))>>11)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE12(data)                                      ((0x00000800&(data))>>11)
+#define DRF_BIST_MODE_DRF_BIST_MODE11_shift                                          (10)
+#define DRF_BIST_MODE_DRF_BIST_MODE11_mask                                           (0x00000400)
+#define DRF_BIST_MODE_DRF_BIST_MODE11(data)                                          (0x00000400&((data)<<10))
+#define DRF_BIST_MODE_DRF_BIST_MODE11_src(data)                                      ((0x00000400&(data))>>10)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE11(data)                                      ((0x00000400&(data))>>10)
+#define DRF_BIST_MODE_DRF_BIST_MODE10_shift                                          (9)
+#define DRF_BIST_MODE_DRF_BIST_MODE10_mask                                           (0x00000200)
+#define DRF_BIST_MODE_DRF_BIST_MODE10(data)                                          (0x00000200&((data)<<9))
+#define DRF_BIST_MODE_DRF_BIST_MODE10_src(data)                                      ((0x00000200&(data))>>9)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE10(data)                                      ((0x00000200&(data))>>9)
+#define DRF_BIST_MODE_DRF_BIST_MODE9_shift                                           (8)
+#define DRF_BIST_MODE_DRF_BIST_MODE9_mask                                            (0x00000100)
+#define DRF_BIST_MODE_DRF_BIST_MODE9(data)                                           (0x00000100&((data)<<8))
+#define DRF_BIST_MODE_DRF_BIST_MODE9_src(data)                                       ((0x00000100&(data))>>8)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE9(data)                                       ((0x00000100&(data))>>8)
+#define DRF_BIST_MODE_DRF_BIST_MODE8_shift                                           (7)
+#define DRF_BIST_MODE_DRF_BIST_MODE8_mask                                            (0x00000080)
+#define DRF_BIST_MODE_DRF_BIST_MODE8(data)                                           (0x00000080&((data)<<7))
+#define DRF_BIST_MODE_DRF_BIST_MODE8_src(data)                                       ((0x00000080&(data))>>7)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE8(data)                                       ((0x00000080&(data))>>7)
+#define DRF_BIST_MODE_DRF_BIST_MODE7_shift                                           (6)
+#define DRF_BIST_MODE_DRF_BIST_MODE7_mask                                            (0x00000040)
+#define DRF_BIST_MODE_DRF_BIST_MODE7(data)                                           (0x00000040&((data)<<6))
+#define DRF_BIST_MODE_DRF_BIST_MODE7_src(data)                                       ((0x00000040&(data))>>6)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE7(data)                                       ((0x00000040&(data))>>6)
+#define DRF_BIST_MODE_DRF_BIST_MODE6_shift                                           (5)
+#define DRF_BIST_MODE_DRF_BIST_MODE6_mask                                            (0x00000020)
+#define DRF_BIST_MODE_DRF_BIST_MODE6(data)                                           (0x00000020&((data)<<5))
+#define DRF_BIST_MODE_DRF_BIST_MODE6_src(data)                                       ((0x00000020&(data))>>5)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE6(data)                                       ((0x00000020&(data))>>5)
+#define DRF_BIST_MODE_DRF_BIST_MODE5_shift                                           (4)
+#define DRF_BIST_MODE_DRF_BIST_MODE5_mask                                            (0x00000010)
+#define DRF_BIST_MODE_DRF_BIST_MODE5(data)                                           (0x00000010&((data)<<4))
+#define DRF_BIST_MODE_DRF_BIST_MODE5_src(data)                                       ((0x00000010&(data))>>4)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE5(data)                                       ((0x00000010&(data))>>4)
+#define DRF_BIST_MODE_DRF_BIST_MODE4_shift                                           (3)
+#define DRF_BIST_MODE_DRF_BIST_MODE4_mask                                            (0x00000008)
+#define DRF_BIST_MODE_DRF_BIST_MODE4(data)                                           (0x00000008&((data)<<3))
+#define DRF_BIST_MODE_DRF_BIST_MODE4_src(data)                                       ((0x00000008&(data))>>3)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE4(data)                                       ((0x00000008&(data))>>3)
+#define DRF_BIST_MODE_DRF_BIST_MODE3_shift                                           (2)
+#define DRF_BIST_MODE_DRF_BIST_MODE3_mask                                            (0x00000004)
+#define DRF_BIST_MODE_DRF_BIST_MODE3(data)                                           (0x00000004&((data)<<2))
+#define DRF_BIST_MODE_DRF_BIST_MODE3_src(data)                                       ((0x00000004&(data))>>2)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE3(data)                                       ((0x00000004&(data))>>2)
+#define DRF_BIST_MODE_DRF_BIST_MODE2_shift                                           (1)
+#define DRF_BIST_MODE_DRF_BIST_MODE2_mask                                            (0x00000002)
+#define DRF_BIST_MODE_DRF_BIST_MODE2(data)                                           (0x00000002&((data)<<1))
+#define DRF_BIST_MODE_DRF_BIST_MODE2_src(data)                                       ((0x00000002&(data))>>1)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE2(data)                                       ((0x00000002&(data))>>1)
+#define DRF_BIST_MODE_DRF_BIST_MODE1_shift                                           (0)
+#define DRF_BIST_MODE_DRF_BIST_MODE1_mask                                            (0x00000001)
+#define DRF_BIST_MODE_DRF_BIST_MODE1(data)                                           (0x00000001&((data)<<0))
+#define DRF_BIST_MODE_DRF_BIST_MODE1_src(data)                                       ((0x00000001&(data))>>0)
+#define DRF_BIST_MODE_get_DRF_BIST_MODE1(data)                                       ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT1                                                                 0x18036010
+#define BIST_RESULT1_reg_addr                                                        "0xB8036010"
+#define BIST_RESULT1_reg                                                             0xB8036010
+#define set_BIST_RESULT1_reg(data)   (*((volatile unsigned int*) BIST_RESULT1_reg)=data)
+#define get_BIST_RESULT1_reg   (*((volatile unsigned int*) BIST_RESULT1_reg))
+#define BIST_RESULT1_inst_adr                                                        "0x0004"
+#define BIST_RESULT1_inst                                                            0x0004
+#define BIST_RESULT1_DRF_START_PAUSE1_shift                                          (22)
+#define BIST_RESULT1_DRF_START_PAUSE1_mask                                           (0x00400000)
+#define BIST_RESULT1_DRF_START_PAUSE1(data)                                          (0x00400000&((data)<<22))
+#define BIST_RESULT1_DRF_START_PAUSE1_src(data)                                      ((0x00400000&(data))>>22)
+#define BIST_RESULT1_get_DRF_START_PAUSE1(data)                                      ((0x00400000&(data))>>22)
+#define BIST_RESULT1_DRF_BIST_FAIL1_9_shift                                          (21)
+#define BIST_RESULT1_DRF_BIST_FAIL1_9_mask                                           (0x00200000)
+#define BIST_RESULT1_DRF_BIST_FAIL1_9(data)                                          (0x00200000&((data)<<21))
+#define BIST_RESULT1_DRF_BIST_FAIL1_9_src(data)                                      ((0x00200000&(data))>>21)
+#define BIST_RESULT1_get_DRF_BIST_FAIL1_9(data)                                      ((0x00200000&(data))>>21)
+#define BIST_RESULT1_DRF_BIST_FAIL1_8_shift                                          (20)
+#define BIST_RESULT1_DRF_BIST_FAIL1_8_mask                                           (0x00100000)
+#define BIST_RESULT1_DRF_BIST_FAIL1_8(data)                                          (0x00100000&((data)<<20))
+#define BIST_RESULT1_DRF_BIST_FAIL1_8_src(data)                                      ((0x00100000&(data))>>20)
+#define BIST_RESULT1_get_DRF_BIST_FAIL1_8(data)                                      ((0x00100000&(data))>>20)
+#define BIST_RESULT1_DRF_BIST_FAIL1_7_shift                                          (19)
+#define BIST_RESULT1_DRF_BIST_FAIL1_7_mask                                           (0x00080000)
+#define BIST_RESULT1_DRF_BIST_FAIL1_7(data)                                          (0x00080000&((data)<<19))
+#define BIST_RESULT1_DRF_BIST_FAIL1_7_src(data)                                      ((0x00080000&(data))>>19)
+#define BIST_RESULT1_get_DRF_BIST_FAIL1_7(data)                                      ((0x00080000&(data))>>19)
+#define BIST_RESULT1_DRF_BIST_FAIL1_6_shift                                          (18)
+#define BIST_RESULT1_DRF_BIST_FAIL1_6_mask                                           (0x00040000)
+#define BIST_RESULT1_DRF_BIST_FAIL1_6(data)                                          (0x00040000&((data)<<18))
+#define BIST_RESULT1_DRF_BIST_FAIL1_6_src(data)                                      ((0x00040000&(data))>>18)
+#define BIST_RESULT1_get_DRF_BIST_FAIL1_6(data)                                      ((0x00040000&(data))>>18)
+#define BIST_RESULT1_DRF_BIST_FAIL1_5_shift                                          (17)
+#define BIST_RESULT1_DRF_BIST_FAIL1_5_mask                                           (0x00020000)
+#define BIST_RESULT1_DRF_BIST_FAIL1_5(data)                                          (0x00020000&((data)<<17))
+#define BIST_RESULT1_DRF_BIST_FAIL1_5_src(data)                                      ((0x00020000&(data))>>17)
+#define BIST_RESULT1_get_DRF_BIST_FAIL1_5(data)                                      ((0x00020000&(data))>>17)
+#define BIST_RESULT1_DRF_BIST_FAIL1_4_shift                                          (16)
+#define BIST_RESULT1_DRF_BIST_FAIL1_4_mask                                           (0x00010000)
+#define BIST_RESULT1_DRF_BIST_FAIL1_4(data)                                          (0x00010000&((data)<<16))
+#define BIST_RESULT1_DRF_BIST_FAIL1_4_src(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT1_get_DRF_BIST_FAIL1_4(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT1_DRF_BIST_FAIL1_3_shift                                          (15)
+#define BIST_RESULT1_DRF_BIST_FAIL1_3_mask                                           (0x00008000)
+#define BIST_RESULT1_DRF_BIST_FAIL1_3(data)                                          (0x00008000&((data)<<15))
+#define BIST_RESULT1_DRF_BIST_FAIL1_3_src(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT1_get_DRF_BIST_FAIL1_3(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT1_DRF_BIST_FAIL1_2_shift                                          (14)
+#define BIST_RESULT1_DRF_BIST_FAIL1_2_mask                                           (0x00004000)
+#define BIST_RESULT1_DRF_BIST_FAIL1_2(data)                                          (0x00004000&((data)<<14))
+#define BIST_RESULT1_DRF_BIST_FAIL1_2_src(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT1_get_DRF_BIST_FAIL1_2(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT1_DRF_BIST_FAIL1_1_shift                                          (13)
+#define BIST_RESULT1_DRF_BIST_FAIL1_1_mask                                           (0x00002000)
+#define BIST_RESULT1_DRF_BIST_FAIL1_1(data)                                          (0x00002000&((data)<<13))
+#define BIST_RESULT1_DRF_BIST_FAIL1_1_src(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT1_get_DRF_BIST_FAIL1_1(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT1_DRF_BIST_FAIL1_0_shift                                          (12)
+#define BIST_RESULT1_DRF_BIST_FAIL1_0_mask                                           (0x00001000)
+#define BIST_RESULT1_DRF_BIST_FAIL1_0(data)                                          (0x00001000&((data)<<12))
+#define BIST_RESULT1_DRF_BIST_FAIL1_0_src(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT1_get_DRF_BIST_FAIL1_0(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT1_DRF_BIST_DONE1_shift                                            (11)
+#define BIST_RESULT1_DRF_BIST_DONE1_mask                                             (0x00000800)
+#define BIST_RESULT1_DRF_BIST_DONE1(data)                                            (0x00000800&((data)<<11))
+#define BIST_RESULT1_DRF_BIST_DONE1_src(data)                                        ((0x00000800&(data))>>11)
+#define BIST_RESULT1_get_DRF_BIST_DONE1(data)                                        ((0x00000800&(data))>>11)
+#define BIST_RESULT1_BIST_FAIL1_9_shift                                              (10)
+#define BIST_RESULT1_BIST_FAIL1_9_mask                                               (0x00000400)
+#define BIST_RESULT1_BIST_FAIL1_9(data)                                              (0x00000400&((data)<<10))
+#define BIST_RESULT1_BIST_FAIL1_9_src(data)                                          ((0x00000400&(data))>>10)
+#define BIST_RESULT1_get_BIST_FAIL1_9(data)                                          ((0x00000400&(data))>>10)
+#define BIST_RESULT1_BIST_FAIL1_8_shift                                              (9)
+#define BIST_RESULT1_BIST_FAIL1_8_mask                                               (0x00000200)
+#define BIST_RESULT1_BIST_FAIL1_8(data)                                              (0x00000200&((data)<<9))
+#define BIST_RESULT1_BIST_FAIL1_8_src(data)                                          ((0x00000200&(data))>>9)
+#define BIST_RESULT1_get_BIST_FAIL1_8(data)                                          ((0x00000200&(data))>>9)
+#define BIST_RESULT1_BIST_FAIL1_7_shift                                              (8)
+#define BIST_RESULT1_BIST_FAIL1_7_mask                                               (0x00000100)
+#define BIST_RESULT1_BIST_FAIL1_7(data)                                              (0x00000100&((data)<<8))
+#define BIST_RESULT1_BIST_FAIL1_7_src(data)                                          ((0x00000100&(data))>>8)
+#define BIST_RESULT1_get_BIST_FAIL1_7(data)                                          ((0x00000100&(data))>>8)
+#define BIST_RESULT1_BIST_FAIL1_6_shift                                              (7)
+#define BIST_RESULT1_BIST_FAIL1_6_mask                                               (0x00000080)
+#define BIST_RESULT1_BIST_FAIL1_6(data)                                              (0x00000080&((data)<<7))
+#define BIST_RESULT1_BIST_FAIL1_6_src(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT1_get_BIST_FAIL1_6(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT1_BIST_FAIL1_5_shift                                              (6)
+#define BIST_RESULT1_BIST_FAIL1_5_mask                                               (0x00000040)
+#define BIST_RESULT1_BIST_FAIL1_5(data)                                              (0x00000040&((data)<<6))
+#define BIST_RESULT1_BIST_FAIL1_5_src(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT1_get_BIST_FAIL1_5(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT1_BIST_FAIL1_4_shift                                              (5)
+#define BIST_RESULT1_BIST_FAIL1_4_mask                                               (0x00000020)
+#define BIST_RESULT1_BIST_FAIL1_4(data)                                              (0x00000020&((data)<<5))
+#define BIST_RESULT1_BIST_FAIL1_4_src(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT1_get_BIST_FAIL1_4(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT1_BIST_FAIL1_3_shift                                              (4)
+#define BIST_RESULT1_BIST_FAIL1_3_mask                                               (0x00000010)
+#define BIST_RESULT1_BIST_FAIL1_3(data)                                              (0x00000010&((data)<<4))
+#define BIST_RESULT1_BIST_FAIL1_3_src(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT1_get_BIST_FAIL1_3(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT1_BIST_FAIL1_2_shift                                              (3)
+#define BIST_RESULT1_BIST_FAIL1_2_mask                                               (0x00000008)
+#define BIST_RESULT1_BIST_FAIL1_2(data)                                              (0x00000008&((data)<<3))
+#define BIST_RESULT1_BIST_FAIL1_2_src(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT1_get_BIST_FAIL1_2(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT1_BIST_FAIL1_1_shift                                              (2)
+#define BIST_RESULT1_BIST_FAIL1_1_mask                                               (0x00000004)
+#define BIST_RESULT1_BIST_FAIL1_1(data)                                              (0x00000004&((data)<<2))
+#define BIST_RESULT1_BIST_FAIL1_1_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT1_get_BIST_FAIL1_1(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT1_BIST_FAIL1_0_shift                                              (1)
+#define BIST_RESULT1_BIST_FAIL1_0_mask                                               (0x00000002)
+#define BIST_RESULT1_BIST_FAIL1_0(data)                                              (0x00000002&((data)<<1))
+#define BIST_RESULT1_BIST_FAIL1_0_src(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT1_get_BIST_FAIL1_0(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT1_BIST_DONE1_shift                                                (0)
+#define BIST_RESULT1_BIST_DONE1_mask                                                 (0x00000001)
+#define BIST_RESULT1_BIST_DONE1(data)                                                (0x00000001&((data)<<0))
+#define BIST_RESULT1_BIST_DONE1_src(data)                                            ((0x00000001&(data))>>0)
+#define BIST_RESULT1_get_BIST_DONE1(data)                                            ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT2                                                                 0x18036014
+#define BIST_RESULT2_reg_addr                                                        "0xB8036014"
+#define BIST_RESULT2_reg                                                             0xB8036014
+#define set_BIST_RESULT2_reg(data)   (*((volatile unsigned int*) BIST_RESULT2_reg)=data)
+#define get_BIST_RESULT2_reg   (*((volatile unsigned int*) BIST_RESULT2_reg))
+#define BIST_RESULT2_inst_adr                                                        "0x0005"
+#define BIST_RESULT2_inst                                                            0x0005
+#define BIST_RESULT2_DRF_START_PAUSE2_shift                                          (22)
+#define BIST_RESULT2_DRF_START_PAUSE2_mask                                           (0x00400000)
+#define BIST_RESULT2_DRF_START_PAUSE2(data)                                          (0x00400000&((data)<<22))
+#define BIST_RESULT2_DRF_START_PAUSE2_src(data)                                      ((0x00400000&(data))>>22)
+#define BIST_RESULT2_get_DRF_START_PAUSE2(data)                                      ((0x00400000&(data))>>22)
+#define BIST_RESULT2_DRF_BIST_FAIL2_9_shift                                          (21)
+#define BIST_RESULT2_DRF_BIST_FAIL2_9_mask                                           (0x00200000)
+#define BIST_RESULT2_DRF_BIST_FAIL2_9(data)                                          (0x00200000&((data)<<21))
+#define BIST_RESULT2_DRF_BIST_FAIL2_9_src(data)                                      ((0x00200000&(data))>>21)
+#define BIST_RESULT2_get_DRF_BIST_FAIL2_9(data)                                      ((0x00200000&(data))>>21)
+#define BIST_RESULT2_DRF_BIST_FAIL2_8_shift                                          (20)
+#define BIST_RESULT2_DRF_BIST_FAIL2_8_mask                                           (0x00100000)
+#define BIST_RESULT2_DRF_BIST_FAIL2_8(data)                                          (0x00100000&((data)<<20))
+#define BIST_RESULT2_DRF_BIST_FAIL2_8_src(data)                                      ((0x00100000&(data))>>20)
+#define BIST_RESULT2_get_DRF_BIST_FAIL2_8(data)                                      ((0x00100000&(data))>>20)
+#define BIST_RESULT2_DRF_BIST_FAIL2_7_shift                                          (19)
+#define BIST_RESULT2_DRF_BIST_FAIL2_7_mask                                           (0x00080000)
+#define BIST_RESULT2_DRF_BIST_FAIL2_7(data)                                          (0x00080000&((data)<<19))
+#define BIST_RESULT2_DRF_BIST_FAIL2_7_src(data)                                      ((0x00080000&(data))>>19)
+#define BIST_RESULT2_get_DRF_BIST_FAIL2_7(data)                                      ((0x00080000&(data))>>19)
+#define BIST_RESULT2_DRF_BIST_FAIL2_6_shift                                          (18)
+#define BIST_RESULT2_DRF_BIST_FAIL2_6_mask                                           (0x00040000)
+#define BIST_RESULT2_DRF_BIST_FAIL2_6(data)                                          (0x00040000&((data)<<18))
+#define BIST_RESULT2_DRF_BIST_FAIL2_6_src(data)                                      ((0x00040000&(data))>>18)
+#define BIST_RESULT2_get_DRF_BIST_FAIL2_6(data)                                      ((0x00040000&(data))>>18)
+#define BIST_RESULT2_DRF_BIST_FAIL2_5_shift                                          (17)
+#define BIST_RESULT2_DRF_BIST_FAIL2_5_mask                                           (0x00020000)
+#define BIST_RESULT2_DRF_BIST_FAIL2_5(data)                                          (0x00020000&((data)<<17))
+#define BIST_RESULT2_DRF_BIST_FAIL2_5_src(data)                                      ((0x00020000&(data))>>17)
+#define BIST_RESULT2_get_DRF_BIST_FAIL2_5(data)                                      ((0x00020000&(data))>>17)
+#define BIST_RESULT2_DRF_BIST_FAIL2_4_shift                                          (16)
+#define BIST_RESULT2_DRF_BIST_FAIL2_4_mask                                           (0x00010000)
+#define BIST_RESULT2_DRF_BIST_FAIL2_4(data)                                          (0x00010000&((data)<<16))
+#define BIST_RESULT2_DRF_BIST_FAIL2_4_src(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT2_get_DRF_BIST_FAIL2_4(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT2_DRF_BIST_FAIL2_3_shift                                          (15)
+#define BIST_RESULT2_DRF_BIST_FAIL2_3_mask                                           (0x00008000)
+#define BIST_RESULT2_DRF_BIST_FAIL2_3(data)                                          (0x00008000&((data)<<15))
+#define BIST_RESULT2_DRF_BIST_FAIL2_3_src(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT2_get_DRF_BIST_FAIL2_3(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT2_DRF_BIST_FAIL2_2_shift                                          (14)
+#define BIST_RESULT2_DRF_BIST_FAIL2_2_mask                                           (0x00004000)
+#define BIST_RESULT2_DRF_BIST_FAIL2_2(data)                                          (0x00004000&((data)<<14))
+#define BIST_RESULT2_DRF_BIST_FAIL2_2_src(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT2_get_DRF_BIST_FAIL2_2(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT2_DRF_BIST_FAIL2_1_shift                                          (13)
+#define BIST_RESULT2_DRF_BIST_FAIL2_1_mask                                           (0x00002000)
+#define BIST_RESULT2_DRF_BIST_FAIL2_1(data)                                          (0x00002000&((data)<<13))
+#define BIST_RESULT2_DRF_BIST_FAIL2_1_src(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT2_get_DRF_BIST_FAIL2_1(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT2_DRF_BIST_FAIL2_0_shift                                          (12)
+#define BIST_RESULT2_DRF_BIST_FAIL2_0_mask                                           (0x00001000)
+#define BIST_RESULT2_DRF_BIST_FAIL2_0(data)                                          (0x00001000&((data)<<12))
+#define BIST_RESULT2_DRF_BIST_FAIL2_0_src(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT2_get_DRF_BIST_FAIL2_0(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT2_DRF_BIST_DONE2_shift                                            (11)
+#define BIST_RESULT2_DRF_BIST_DONE2_mask                                             (0x00000800)
+#define BIST_RESULT2_DRF_BIST_DONE2(data)                                            (0x00000800&((data)<<11))
+#define BIST_RESULT2_DRF_BIST_DONE2_src(data)                                        ((0x00000800&(data))>>11)
+#define BIST_RESULT2_get_DRF_BIST_DONE2(data)                                        ((0x00000800&(data))>>11)
+#define BIST_RESULT2_BIST_FAIL2_9_shift                                              (10)
+#define BIST_RESULT2_BIST_FAIL2_9_mask                                               (0x00000400)
+#define BIST_RESULT2_BIST_FAIL2_9(data)                                              (0x00000400&((data)<<10))
+#define BIST_RESULT2_BIST_FAIL2_9_src(data)                                          ((0x00000400&(data))>>10)
+#define BIST_RESULT2_get_BIST_FAIL2_9(data)                                          ((0x00000400&(data))>>10)
+#define BIST_RESULT2_BIST_FAIL2_8_shift                                              (9)
+#define BIST_RESULT2_BIST_FAIL2_8_mask                                               (0x00000200)
+#define BIST_RESULT2_BIST_FAIL2_8(data)                                              (0x00000200&((data)<<9))
+#define BIST_RESULT2_BIST_FAIL2_8_src(data)                                          ((0x00000200&(data))>>9)
+#define BIST_RESULT2_get_BIST_FAIL2_8(data)                                          ((0x00000200&(data))>>9)
+#define BIST_RESULT2_BIST_FAIL2_7_shift                                              (8)
+#define BIST_RESULT2_BIST_FAIL2_7_mask                                               (0x00000100)
+#define BIST_RESULT2_BIST_FAIL2_7(data)                                              (0x00000100&((data)<<8))
+#define BIST_RESULT2_BIST_FAIL2_7_src(data)                                          ((0x00000100&(data))>>8)
+#define BIST_RESULT2_get_BIST_FAIL2_7(data)                                          ((0x00000100&(data))>>8)
+#define BIST_RESULT2_BIST_FAIL2_6_shift                                              (7)
+#define BIST_RESULT2_BIST_FAIL2_6_mask                                               (0x00000080)
+#define BIST_RESULT2_BIST_FAIL2_6(data)                                              (0x00000080&((data)<<7))
+#define BIST_RESULT2_BIST_FAIL2_6_src(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT2_get_BIST_FAIL2_6(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT2_BIST_FAIL2_5_shift                                              (6)
+#define BIST_RESULT2_BIST_FAIL2_5_mask                                               (0x00000040)
+#define BIST_RESULT2_BIST_FAIL2_5(data)                                              (0x00000040&((data)<<6))
+#define BIST_RESULT2_BIST_FAIL2_5_src(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT2_get_BIST_FAIL2_5(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT2_BIST_FAIL2_4_shift                                              (5)
+#define BIST_RESULT2_BIST_FAIL2_4_mask                                               (0x00000020)
+#define BIST_RESULT2_BIST_FAIL2_4(data)                                              (0x00000020&((data)<<5))
+#define BIST_RESULT2_BIST_FAIL2_4_src(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT2_get_BIST_FAIL2_4(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT2_BIST_FAIL2_3_shift                                              (4)
+#define BIST_RESULT2_BIST_FAIL2_3_mask                                               (0x00000010)
+#define BIST_RESULT2_BIST_FAIL2_3(data)                                              (0x00000010&((data)<<4))
+#define BIST_RESULT2_BIST_FAIL2_3_src(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT2_get_BIST_FAIL2_3(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT2_BIST_FAIL2_2_shift                                              (3)
+#define BIST_RESULT2_BIST_FAIL2_2_mask                                               (0x00000008)
+#define BIST_RESULT2_BIST_FAIL2_2(data)                                              (0x00000008&((data)<<3))
+#define BIST_RESULT2_BIST_FAIL2_2_src(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT2_get_BIST_FAIL2_2(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT2_BIST_FAIL2_1_shift                                              (2)
+#define BIST_RESULT2_BIST_FAIL2_1_mask                                               (0x00000004)
+#define BIST_RESULT2_BIST_FAIL2_1(data)                                              (0x00000004&((data)<<2))
+#define BIST_RESULT2_BIST_FAIL2_1_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT2_get_BIST_FAIL2_1(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT2_BIST_FAIL2_0_shift                                              (1)
+#define BIST_RESULT2_BIST_FAIL2_0_mask                                               (0x00000002)
+#define BIST_RESULT2_BIST_FAIL2_0(data)                                              (0x00000002&((data)<<1))
+#define BIST_RESULT2_BIST_FAIL2_0_src(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT2_get_BIST_FAIL2_0(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT2_BIST_DONE2_shift                                                (0)
+#define BIST_RESULT2_BIST_DONE2_mask                                                 (0x00000001)
+#define BIST_RESULT2_BIST_DONE2(data)                                                (0x00000001&((data)<<0))
+#define BIST_RESULT2_BIST_DONE2_src(data)                                            ((0x00000001&(data))>>0)
+#define BIST_RESULT2_get_BIST_DONE2(data)                                            ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT3                                                                 0x18036018
+#define BIST_RESULT3_reg_addr                                                        "0xB8036018"
+#define BIST_RESULT3_reg                                                             0xB8036018
+#define set_BIST_RESULT3_reg(data)   (*((volatile unsigned int*) BIST_RESULT3_reg)=data)
+#define get_BIST_RESULT3_reg   (*((volatile unsigned int*) BIST_RESULT3_reg))
+#define BIST_RESULT3_inst_adr                                                        "0x0006"
+#define BIST_RESULT3_inst                                                            0x0006
+#define BIST_RESULT3_DRF_START_PAUSE3_shift                                          (16)
+#define BIST_RESULT3_DRF_START_PAUSE3_mask                                           (0x00010000)
+#define BIST_RESULT3_DRF_START_PAUSE3(data)                                          (0x00010000&((data)<<16))
+#define BIST_RESULT3_DRF_START_PAUSE3_src(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT3_get_DRF_START_PAUSE3(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT3_DRF_BIST_FAIL3_6_shift                                          (15)
+#define BIST_RESULT3_DRF_BIST_FAIL3_6_mask                                           (0x00008000)
+#define BIST_RESULT3_DRF_BIST_FAIL3_6(data)                                          (0x00008000&((data)<<15))
+#define BIST_RESULT3_DRF_BIST_FAIL3_6_src(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT3_get_DRF_BIST_FAIL3_6(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT3_DRF_BIST_FAIL3_5_shift                                          (14)
+#define BIST_RESULT3_DRF_BIST_FAIL3_5_mask                                           (0x00004000)
+#define BIST_RESULT3_DRF_BIST_FAIL3_5(data)                                          (0x00004000&((data)<<14))
+#define BIST_RESULT3_DRF_BIST_FAIL3_5_src(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT3_get_DRF_BIST_FAIL3_5(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT3_DRF_BIST_FAIL3_4_shift                                          (13)
+#define BIST_RESULT3_DRF_BIST_FAIL3_4_mask                                           (0x00002000)
+#define BIST_RESULT3_DRF_BIST_FAIL3_4(data)                                          (0x00002000&((data)<<13))
+#define BIST_RESULT3_DRF_BIST_FAIL3_4_src(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT3_get_DRF_BIST_FAIL3_4(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT3_DRF_BIST_FAIL3_3_shift                                          (12)
+#define BIST_RESULT3_DRF_BIST_FAIL3_3_mask                                           (0x00001000)
+#define BIST_RESULT3_DRF_BIST_FAIL3_3(data)                                          (0x00001000&((data)<<12))
+#define BIST_RESULT3_DRF_BIST_FAIL3_3_src(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT3_get_DRF_BIST_FAIL3_3(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT3_DRF_BIST_FAIL3_2_shift                                          (11)
+#define BIST_RESULT3_DRF_BIST_FAIL3_2_mask                                           (0x00000800)
+#define BIST_RESULT3_DRF_BIST_FAIL3_2(data)                                          (0x00000800&((data)<<11))
+#define BIST_RESULT3_DRF_BIST_FAIL3_2_src(data)                                      ((0x00000800&(data))>>11)
+#define BIST_RESULT3_get_DRF_BIST_FAIL3_2(data)                                      ((0x00000800&(data))>>11)
+#define BIST_RESULT3_DRF_BIST_FAIL3_1_shift                                          (10)
+#define BIST_RESULT3_DRF_BIST_FAIL3_1_mask                                           (0x00000400)
+#define BIST_RESULT3_DRF_BIST_FAIL3_1(data)                                          (0x00000400&((data)<<10))
+#define BIST_RESULT3_DRF_BIST_FAIL3_1_src(data)                                      ((0x00000400&(data))>>10)
+#define BIST_RESULT3_get_DRF_BIST_FAIL3_1(data)                                      ((0x00000400&(data))>>10)
+#define BIST_RESULT3_DRF_BIST_FAIL3_0_shift                                          (9)
+#define BIST_RESULT3_DRF_BIST_FAIL3_0_mask                                           (0x00000200)
+#define BIST_RESULT3_DRF_BIST_FAIL3_0(data)                                          (0x00000200&((data)<<9))
+#define BIST_RESULT3_DRF_BIST_FAIL3_0_src(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT3_get_DRF_BIST_FAIL3_0(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT3_DRF_BIST_DONE3_shift                                            (8)
+#define BIST_RESULT3_DRF_BIST_DONE3_mask                                             (0x00000100)
+#define BIST_RESULT3_DRF_BIST_DONE3(data)                                            (0x00000100&((data)<<8))
+#define BIST_RESULT3_DRF_BIST_DONE3_src(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT3_get_DRF_BIST_DONE3(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT3_BIST_FAIL3_6_shift                                              (7)
+#define BIST_RESULT3_BIST_FAIL3_6_mask                                               (0x00000080)
+#define BIST_RESULT3_BIST_FAIL3_6(data)                                              (0x00000080&((data)<<7))
+#define BIST_RESULT3_BIST_FAIL3_6_src(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT3_get_BIST_FAIL3_6(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT3_BIST_FAIL3_5_shift                                              (6)
+#define BIST_RESULT3_BIST_FAIL3_5_mask                                               (0x00000040)
+#define BIST_RESULT3_BIST_FAIL3_5(data)                                              (0x00000040&((data)<<6))
+#define BIST_RESULT3_BIST_FAIL3_5_src(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT3_get_BIST_FAIL3_5(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT3_BIST_FAIL3_4_shift                                              (5)
+#define BIST_RESULT3_BIST_FAIL3_4_mask                                               (0x00000020)
+#define BIST_RESULT3_BIST_FAIL3_4(data)                                              (0x00000020&((data)<<5))
+#define BIST_RESULT3_BIST_FAIL3_4_src(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT3_get_BIST_FAIL3_4(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT3_BIST_FAIL3_3_shift                                              (4)
+#define BIST_RESULT3_BIST_FAIL3_3_mask                                               (0x00000010)
+#define BIST_RESULT3_BIST_FAIL3_3(data)                                              (0x00000010&((data)<<4))
+#define BIST_RESULT3_BIST_FAIL3_3_src(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT3_get_BIST_FAIL3_3(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT3_BIST_FAIL3_2_shift                                              (3)
+#define BIST_RESULT3_BIST_FAIL3_2_mask                                               (0x00000008)
+#define BIST_RESULT3_BIST_FAIL3_2(data)                                              (0x00000008&((data)<<3))
+#define BIST_RESULT3_BIST_FAIL3_2_src(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT3_get_BIST_FAIL3_2(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT3_BIST_FAIL3_1_shift                                              (2)
+#define BIST_RESULT3_BIST_FAIL3_1_mask                                               (0x00000004)
+#define BIST_RESULT3_BIST_FAIL3_1(data)                                              (0x00000004&((data)<<2))
+#define BIST_RESULT3_BIST_FAIL3_1_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT3_get_BIST_FAIL3_1(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT3_BIST_FAIL3_0_shift                                              (1)
+#define BIST_RESULT3_BIST_FAIL3_0_mask                                               (0x00000002)
+#define BIST_RESULT3_BIST_FAIL3_0(data)                                              (0x00000002&((data)<<1))
+#define BIST_RESULT3_BIST_FAIL3_0_src(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT3_get_BIST_FAIL3_0(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT3_BIST_DONE3_shift                                                (0)
+#define BIST_RESULT3_BIST_DONE3_mask                                                 (0x00000001)
+#define BIST_RESULT3_BIST_DONE3(data)                                                (0x00000001&((data)<<0))
+#define BIST_RESULT3_BIST_DONE3_src(data)                                            ((0x00000001&(data))>>0)
+#define BIST_RESULT3_get_BIST_DONE3(data)                                            ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT4                                                                 0x1803601C
+#define BIST_RESULT4_reg_addr                                                        "0xB803601C"
+#define BIST_RESULT4_reg                                                             0xB803601C
+#define set_BIST_RESULT4_reg(data)   (*((volatile unsigned int*) BIST_RESULT4_reg)=data)
+#define get_BIST_RESULT4_reg   (*((volatile unsigned int*) BIST_RESULT4_reg))
+#define BIST_RESULT4_inst_adr                                                        "0x0007"
+#define BIST_RESULT4_inst                                                            0x0007
+#define BIST_RESULT4_DRF_START_PAUSE4_shift                                          (16)
+#define BIST_RESULT4_DRF_START_PAUSE4_mask                                           (0x00010000)
+#define BIST_RESULT4_DRF_START_PAUSE4(data)                                          (0x00010000&((data)<<16))
+#define BIST_RESULT4_DRF_START_PAUSE4_src(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT4_get_DRF_START_PAUSE4(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT4_DRF_BIST_FAIL4_6_shift                                          (15)
+#define BIST_RESULT4_DRF_BIST_FAIL4_6_mask                                           (0x00008000)
+#define BIST_RESULT4_DRF_BIST_FAIL4_6(data)                                          (0x00008000&((data)<<15))
+#define BIST_RESULT4_DRF_BIST_FAIL4_6_src(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT4_get_DRF_BIST_FAIL4_6(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT4_DRF_BIST_FAIL4_5_shift                                          (14)
+#define BIST_RESULT4_DRF_BIST_FAIL4_5_mask                                           (0x00004000)
+#define BIST_RESULT4_DRF_BIST_FAIL4_5(data)                                          (0x00004000&((data)<<14))
+#define BIST_RESULT4_DRF_BIST_FAIL4_5_src(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT4_get_DRF_BIST_FAIL4_5(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT4_DRF_BIST_FAIL4_4_shift                                          (13)
+#define BIST_RESULT4_DRF_BIST_FAIL4_4_mask                                           (0x00002000)
+#define BIST_RESULT4_DRF_BIST_FAIL4_4(data)                                          (0x00002000&((data)<<13))
+#define BIST_RESULT4_DRF_BIST_FAIL4_4_src(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT4_get_DRF_BIST_FAIL4_4(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT4_DRF_BIST_FAIL4_3_shift                                          (12)
+#define BIST_RESULT4_DRF_BIST_FAIL4_3_mask                                           (0x00001000)
+#define BIST_RESULT4_DRF_BIST_FAIL4_3(data)                                          (0x00001000&((data)<<12))
+#define BIST_RESULT4_DRF_BIST_FAIL4_3_src(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT4_get_DRF_BIST_FAIL4_3(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT4_DRF_BIST_FAIL4_2_shift                                          (11)
+#define BIST_RESULT4_DRF_BIST_FAIL4_2_mask                                           (0x00000800)
+#define BIST_RESULT4_DRF_BIST_FAIL4_2(data)                                          (0x00000800&((data)<<11))
+#define BIST_RESULT4_DRF_BIST_FAIL4_2_src(data)                                      ((0x00000800&(data))>>11)
+#define BIST_RESULT4_get_DRF_BIST_FAIL4_2(data)                                      ((0x00000800&(data))>>11)
+#define BIST_RESULT4_DRF_BIST_FAIL4_1_shift                                          (10)
+#define BIST_RESULT4_DRF_BIST_FAIL4_1_mask                                           (0x00000400)
+#define BIST_RESULT4_DRF_BIST_FAIL4_1(data)                                          (0x00000400&((data)<<10))
+#define BIST_RESULT4_DRF_BIST_FAIL4_1_src(data)                                      ((0x00000400&(data))>>10)
+#define BIST_RESULT4_get_DRF_BIST_FAIL4_1(data)                                      ((0x00000400&(data))>>10)
+#define BIST_RESULT4_DRF_BIST_FAIL4_0_shift                                          (9)
+#define BIST_RESULT4_DRF_BIST_FAIL4_0_mask                                           (0x00000200)
+#define BIST_RESULT4_DRF_BIST_FAIL4_0(data)                                          (0x00000200&((data)<<9))
+#define BIST_RESULT4_DRF_BIST_FAIL4_0_src(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT4_get_DRF_BIST_FAIL4_0(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT4_DRF_BIST_DONE4_shift                                            (8)
+#define BIST_RESULT4_DRF_BIST_DONE4_mask                                             (0x00000100)
+#define BIST_RESULT4_DRF_BIST_DONE4(data)                                            (0x00000100&((data)<<8))
+#define BIST_RESULT4_DRF_BIST_DONE4_src(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT4_get_DRF_BIST_DONE4(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT4_BIST_FAIL4_6_shift                                              (7)
+#define BIST_RESULT4_BIST_FAIL4_6_mask                                               (0x00000080)
+#define BIST_RESULT4_BIST_FAIL4_6(data)                                              (0x00000080&((data)<<7))
+#define BIST_RESULT4_BIST_FAIL4_6_src(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT4_get_BIST_FAIL4_6(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT4_BIST_FAIL4_5_shift                                              (6)
+#define BIST_RESULT4_BIST_FAIL4_5_mask                                               (0x00000040)
+#define BIST_RESULT4_BIST_FAIL4_5(data)                                              (0x00000040&((data)<<6))
+#define BIST_RESULT4_BIST_FAIL4_5_src(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT4_get_BIST_FAIL4_5(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT4_BIST_FAIL4_4_shift                                              (5)
+#define BIST_RESULT4_BIST_FAIL4_4_mask                                               (0x00000020)
+#define BIST_RESULT4_BIST_FAIL4_4(data)                                              (0x00000020&((data)<<5))
+#define BIST_RESULT4_BIST_FAIL4_4_src(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT4_get_BIST_FAIL4_4(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT4_BIST_FAIL4_3_shift                                              (4)
+#define BIST_RESULT4_BIST_FAIL4_3_mask                                               (0x00000010)
+#define BIST_RESULT4_BIST_FAIL4_3(data)                                              (0x00000010&((data)<<4))
+#define BIST_RESULT4_BIST_FAIL4_3_src(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT4_get_BIST_FAIL4_3(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT4_BIST_FAIL4_2_shift                                              (3)
+#define BIST_RESULT4_BIST_FAIL4_2_mask                                               (0x00000008)
+#define BIST_RESULT4_BIST_FAIL4_2(data)                                              (0x00000008&((data)<<3))
+#define BIST_RESULT4_BIST_FAIL4_2_src(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT4_get_BIST_FAIL4_2(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT4_BIST_FAIL4_1_shift                                              (2)
+#define BIST_RESULT4_BIST_FAIL4_1_mask                                               (0x00000004)
+#define BIST_RESULT4_BIST_FAIL4_1(data)                                              (0x00000004&((data)<<2))
+#define BIST_RESULT4_BIST_FAIL4_1_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT4_get_BIST_FAIL4_1(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT4_BIST_FAIL4_0_shift                                              (1)
+#define BIST_RESULT4_BIST_FAIL4_0_mask                                               (0x00000002)
+#define BIST_RESULT4_BIST_FAIL4_0(data)                                              (0x00000002&((data)<<1))
+#define BIST_RESULT4_BIST_FAIL4_0_src(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT4_get_BIST_FAIL4_0(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT4_BIST_DONE4_shift                                                (0)
+#define BIST_RESULT4_BIST_DONE4_mask                                                 (0x00000001)
+#define BIST_RESULT4_BIST_DONE4(data)                                                (0x00000001&((data)<<0))
+#define BIST_RESULT4_BIST_DONE4_src(data)                                            ((0x00000001&(data))>>0)
+#define BIST_RESULT4_get_BIST_DONE4(data)                                            ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT5                                                                 0x18036020
+#define BIST_RESULT5_reg_addr                                                        "0xB8036020"
+#define BIST_RESULT5_reg                                                             0xB8036020
+#define set_BIST_RESULT5_reg(data)   (*((volatile unsigned int*) BIST_RESULT5_reg)=data)
+#define get_BIST_RESULT5_reg   (*((volatile unsigned int*) BIST_RESULT5_reg))
+#define BIST_RESULT5_inst_adr                                                        "0x0008"
+#define BIST_RESULT5_inst                                                            0x0008
+#define BIST_RESULT5_DRF_START_PAUSE5_shift                                          (22)
+#define BIST_RESULT5_DRF_START_PAUSE5_mask                                           (0x00400000)
+#define BIST_RESULT5_DRF_START_PAUSE5(data)                                          (0x00400000&((data)<<22))
+#define BIST_RESULT5_DRF_START_PAUSE5_src(data)                                      ((0x00400000&(data))>>22)
+#define BIST_RESULT5_get_DRF_START_PAUSE5(data)                                      ((0x00400000&(data))>>22)
+#define BIST_RESULT5_DRF_BIST_FAIL5_9_shift                                          (21)
+#define BIST_RESULT5_DRF_BIST_FAIL5_9_mask                                           (0x00200000)
+#define BIST_RESULT5_DRF_BIST_FAIL5_9(data)                                          (0x00200000&((data)<<21))
+#define BIST_RESULT5_DRF_BIST_FAIL5_9_src(data)                                      ((0x00200000&(data))>>21)
+#define BIST_RESULT5_get_DRF_BIST_FAIL5_9(data)                                      ((0x00200000&(data))>>21)
+#define BIST_RESULT5_DRF_BIST_FAIL5_8_shift                                          (20)
+#define BIST_RESULT5_DRF_BIST_FAIL5_8_mask                                           (0x00100000)
+#define BIST_RESULT5_DRF_BIST_FAIL5_8(data)                                          (0x00100000&((data)<<20))
+#define BIST_RESULT5_DRF_BIST_FAIL5_8_src(data)                                      ((0x00100000&(data))>>20)
+#define BIST_RESULT5_get_DRF_BIST_FAIL5_8(data)                                      ((0x00100000&(data))>>20)
+#define BIST_RESULT5_DRF_BIST_FAIL5_7_shift                                          (19)
+#define BIST_RESULT5_DRF_BIST_FAIL5_7_mask                                           (0x00080000)
+#define BIST_RESULT5_DRF_BIST_FAIL5_7(data)                                          (0x00080000&((data)<<19))
+#define BIST_RESULT5_DRF_BIST_FAIL5_7_src(data)                                      ((0x00080000&(data))>>19)
+#define BIST_RESULT5_get_DRF_BIST_FAIL5_7(data)                                      ((0x00080000&(data))>>19)
+#define BIST_RESULT5_DRF_BIST_FAIL5_6_shift                                          (18)
+#define BIST_RESULT5_DRF_BIST_FAIL5_6_mask                                           (0x00040000)
+#define BIST_RESULT5_DRF_BIST_FAIL5_6(data)                                          (0x00040000&((data)<<18))
+#define BIST_RESULT5_DRF_BIST_FAIL5_6_src(data)                                      ((0x00040000&(data))>>18)
+#define BIST_RESULT5_get_DRF_BIST_FAIL5_6(data)                                      ((0x00040000&(data))>>18)
+#define BIST_RESULT5_DRF_BIST_FAIL5_5_shift                                          (17)
+#define BIST_RESULT5_DRF_BIST_FAIL5_5_mask                                           (0x00020000)
+#define BIST_RESULT5_DRF_BIST_FAIL5_5(data)                                          (0x00020000&((data)<<17))
+#define BIST_RESULT5_DRF_BIST_FAIL5_5_src(data)                                      ((0x00020000&(data))>>17)
+#define BIST_RESULT5_get_DRF_BIST_FAIL5_5(data)                                      ((0x00020000&(data))>>17)
+#define BIST_RESULT5_DRF_BIST_FAIL5_4_shift                                          (16)
+#define BIST_RESULT5_DRF_BIST_FAIL5_4_mask                                           (0x00010000)
+#define BIST_RESULT5_DRF_BIST_FAIL5_4(data)                                          (0x00010000&((data)<<16))
+#define BIST_RESULT5_DRF_BIST_FAIL5_4_src(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT5_get_DRF_BIST_FAIL5_4(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT5_DRF_BIST_FAIL5_3_shift                                          (15)
+#define BIST_RESULT5_DRF_BIST_FAIL5_3_mask                                           (0x00008000)
+#define BIST_RESULT5_DRF_BIST_FAIL5_3(data)                                          (0x00008000&((data)<<15))
+#define BIST_RESULT5_DRF_BIST_FAIL5_3_src(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT5_get_DRF_BIST_FAIL5_3(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT5_DRF_BIST_FAIL5_2_shift                                          (14)
+#define BIST_RESULT5_DRF_BIST_FAIL5_2_mask                                           (0x00004000)
+#define BIST_RESULT5_DRF_BIST_FAIL5_2(data)                                          (0x00004000&((data)<<14))
+#define BIST_RESULT5_DRF_BIST_FAIL5_2_src(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT5_get_DRF_BIST_FAIL5_2(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT5_DRF_BIST_FAIL5_1_shift                                          (13)
+#define BIST_RESULT5_DRF_BIST_FAIL5_1_mask                                           (0x00002000)
+#define BIST_RESULT5_DRF_BIST_FAIL5_1(data)                                          (0x00002000&((data)<<13))
+#define BIST_RESULT5_DRF_BIST_FAIL5_1_src(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT5_get_DRF_BIST_FAIL5_1(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT5_DRF_BIST_FAIL5_0_shift                                          (12)
+#define BIST_RESULT5_DRF_BIST_FAIL5_0_mask                                           (0x00001000)
+#define BIST_RESULT5_DRF_BIST_FAIL5_0(data)                                          (0x00001000&((data)<<12))
+#define BIST_RESULT5_DRF_BIST_FAIL5_0_src(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT5_get_DRF_BIST_FAIL5_0(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT5_DRF_BIST_DONE5_shift                                            (11)
+#define BIST_RESULT5_DRF_BIST_DONE5_mask                                             (0x00000800)
+#define BIST_RESULT5_DRF_BIST_DONE5(data)                                            (0x00000800&((data)<<11))
+#define BIST_RESULT5_DRF_BIST_DONE5_src(data)                                        ((0x00000800&(data))>>11)
+#define BIST_RESULT5_get_DRF_BIST_DONE5(data)                                        ((0x00000800&(data))>>11)
+#define BIST_RESULT5_BIST_FAIL5_9_shift                                              (10)
+#define BIST_RESULT5_BIST_FAIL5_9_mask                                               (0x00000400)
+#define BIST_RESULT5_BIST_FAIL5_9(data)                                              (0x00000400&((data)<<10))
+#define BIST_RESULT5_BIST_FAIL5_9_src(data)                                          ((0x00000400&(data))>>10)
+#define BIST_RESULT5_get_BIST_FAIL5_9(data)                                          ((0x00000400&(data))>>10)
+#define BIST_RESULT5_BIST_FAIL5_8_shift                                              (9)
+#define BIST_RESULT5_BIST_FAIL5_8_mask                                               (0x00000200)
+#define BIST_RESULT5_BIST_FAIL5_8(data)                                              (0x00000200&((data)<<9))
+#define BIST_RESULT5_BIST_FAIL5_8_src(data)                                          ((0x00000200&(data))>>9)
+#define BIST_RESULT5_get_BIST_FAIL5_8(data)                                          ((0x00000200&(data))>>9)
+#define BIST_RESULT5_BIST_FAIL5_7_shift                                              (8)
+#define BIST_RESULT5_BIST_FAIL5_7_mask                                               (0x00000100)
+#define BIST_RESULT5_BIST_FAIL5_7(data)                                              (0x00000100&((data)<<8))
+#define BIST_RESULT5_BIST_FAIL5_7_src(data)                                          ((0x00000100&(data))>>8)
+#define BIST_RESULT5_get_BIST_FAIL5_7(data)                                          ((0x00000100&(data))>>8)
+#define BIST_RESULT5_BIST_FAIL5_6_shift                                              (7)
+#define BIST_RESULT5_BIST_FAIL5_6_mask                                               (0x00000080)
+#define BIST_RESULT5_BIST_FAIL5_6(data)                                              (0x00000080&((data)<<7))
+#define BIST_RESULT5_BIST_FAIL5_6_src(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT5_get_BIST_FAIL5_6(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT5_BIST_FAIL5_5_shift                                              (6)
+#define BIST_RESULT5_BIST_FAIL5_5_mask                                               (0x00000040)
+#define BIST_RESULT5_BIST_FAIL5_5(data)                                              (0x00000040&((data)<<6))
+#define BIST_RESULT5_BIST_FAIL5_5_src(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT5_get_BIST_FAIL5_5(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT5_BIST_FAIL5_4_shift                                              (5)
+#define BIST_RESULT5_BIST_FAIL5_4_mask                                               (0x00000020)
+#define BIST_RESULT5_BIST_FAIL5_4(data)                                              (0x00000020&((data)<<5))
+#define BIST_RESULT5_BIST_FAIL5_4_src(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT5_get_BIST_FAIL5_4(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT5_BIST_FAIL5_3_shift                                              (4)
+#define BIST_RESULT5_BIST_FAIL5_3_mask                                               (0x00000010)
+#define BIST_RESULT5_BIST_FAIL5_3(data)                                              (0x00000010&((data)<<4))
+#define BIST_RESULT5_BIST_FAIL5_3_src(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT5_get_BIST_FAIL5_3(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT5_BIST_FAIL5_2_shift                                              (3)
+#define BIST_RESULT5_BIST_FAIL5_2_mask                                               (0x00000008)
+#define BIST_RESULT5_BIST_FAIL5_2(data)                                              (0x00000008&((data)<<3))
+#define BIST_RESULT5_BIST_FAIL5_2_src(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT5_get_BIST_FAIL5_2(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT5_BIST_FAIL5_1_shift                                              (2)
+#define BIST_RESULT5_BIST_FAIL5_1_mask                                               (0x00000004)
+#define BIST_RESULT5_BIST_FAIL5_1(data)                                              (0x00000004&((data)<<2))
+#define BIST_RESULT5_BIST_FAIL5_1_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT5_get_BIST_FAIL5_1(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT5_BIST_FAIL5_0_shift                                              (1)
+#define BIST_RESULT5_BIST_FAIL5_0_mask                                               (0x00000002)
+#define BIST_RESULT5_BIST_FAIL5_0(data)                                              (0x00000002&((data)<<1))
+#define BIST_RESULT5_BIST_FAIL5_0_src(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT5_get_BIST_FAIL5_0(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT5_BIST_DONE5_shift                                                (0)
+#define BIST_RESULT5_BIST_DONE5_mask                                                 (0x00000001)
+#define BIST_RESULT5_BIST_DONE5(data)                                                (0x00000001&((data)<<0))
+#define BIST_RESULT5_BIST_DONE5_src(data)                                            ((0x00000001&(data))>>0)
+#define BIST_RESULT5_get_BIST_DONE5(data)                                            ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT6                                                                 0x18036024
+#define BIST_RESULT6_reg_addr                                                        "0xB8036024"
+#define BIST_RESULT6_reg                                                             0xB8036024
+#define set_BIST_RESULT6_reg(data)   (*((volatile unsigned int*) BIST_RESULT6_reg)=data)
+#define get_BIST_RESULT6_reg   (*((volatile unsigned int*) BIST_RESULT6_reg))
+#define BIST_RESULT6_inst_adr                                                        "0x0009"
+#define BIST_RESULT6_inst                                                            0x0009
+#define BIST_RESULT6_DRF_START_PAUSE6_shift                                          (22)
+#define BIST_RESULT6_DRF_START_PAUSE6_mask                                           (0x00400000)
+#define BIST_RESULT6_DRF_START_PAUSE6(data)                                          (0x00400000&((data)<<22))
+#define BIST_RESULT6_DRF_START_PAUSE6_src(data)                                      ((0x00400000&(data))>>22)
+#define BIST_RESULT6_get_DRF_START_PAUSE6(data)                                      ((0x00400000&(data))>>22)
+#define BIST_RESULT6_DRF_BIST_FAIL6_9_shift                                          (21)
+#define BIST_RESULT6_DRF_BIST_FAIL6_9_mask                                           (0x00200000)
+#define BIST_RESULT6_DRF_BIST_FAIL6_9(data)                                          (0x00200000&((data)<<21))
+#define BIST_RESULT6_DRF_BIST_FAIL6_9_src(data)                                      ((0x00200000&(data))>>21)
+#define BIST_RESULT6_get_DRF_BIST_FAIL6_9(data)                                      ((0x00200000&(data))>>21)
+#define BIST_RESULT6_DRF_BIST_FAIL6_8_shift                                          (20)
+#define BIST_RESULT6_DRF_BIST_FAIL6_8_mask                                           (0x00100000)
+#define BIST_RESULT6_DRF_BIST_FAIL6_8(data)                                          (0x00100000&((data)<<20))
+#define BIST_RESULT6_DRF_BIST_FAIL6_8_src(data)                                      ((0x00100000&(data))>>20)
+#define BIST_RESULT6_get_DRF_BIST_FAIL6_8(data)                                      ((0x00100000&(data))>>20)
+#define BIST_RESULT6_DRF_BIST_FAIL6_7_shift                                          (19)
+#define BIST_RESULT6_DRF_BIST_FAIL6_7_mask                                           (0x00080000)
+#define BIST_RESULT6_DRF_BIST_FAIL6_7(data)                                          (0x00080000&((data)<<19))
+#define BIST_RESULT6_DRF_BIST_FAIL6_7_src(data)                                      ((0x00080000&(data))>>19)
+#define BIST_RESULT6_get_DRF_BIST_FAIL6_7(data)                                      ((0x00080000&(data))>>19)
+#define BIST_RESULT6_DRF_BIST_FAIL6_6_shift                                          (18)
+#define BIST_RESULT6_DRF_BIST_FAIL6_6_mask                                           (0x00040000)
+#define BIST_RESULT6_DRF_BIST_FAIL6_6(data)                                          (0x00040000&((data)<<18))
+#define BIST_RESULT6_DRF_BIST_FAIL6_6_src(data)                                      ((0x00040000&(data))>>18)
+#define BIST_RESULT6_get_DRF_BIST_FAIL6_6(data)                                      ((0x00040000&(data))>>18)
+#define BIST_RESULT6_DRF_BIST_FAIL6_5_shift                                          (17)
+#define BIST_RESULT6_DRF_BIST_FAIL6_5_mask                                           (0x00020000)
+#define BIST_RESULT6_DRF_BIST_FAIL6_5(data)                                          (0x00020000&((data)<<17))
+#define BIST_RESULT6_DRF_BIST_FAIL6_5_src(data)                                      ((0x00020000&(data))>>17)
+#define BIST_RESULT6_get_DRF_BIST_FAIL6_5(data)                                      ((0x00020000&(data))>>17)
+#define BIST_RESULT6_DRF_BIST_FAIL6_4_shift                                          (16)
+#define BIST_RESULT6_DRF_BIST_FAIL6_4_mask                                           (0x00010000)
+#define BIST_RESULT6_DRF_BIST_FAIL6_4(data)                                          (0x00010000&((data)<<16))
+#define BIST_RESULT6_DRF_BIST_FAIL6_4_src(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT6_get_DRF_BIST_FAIL6_4(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT6_DRF_BIST_FAIL6_3_shift                                          (15)
+#define BIST_RESULT6_DRF_BIST_FAIL6_3_mask                                           (0x00008000)
+#define BIST_RESULT6_DRF_BIST_FAIL6_3(data)                                          (0x00008000&((data)<<15))
+#define BIST_RESULT6_DRF_BIST_FAIL6_3_src(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT6_get_DRF_BIST_FAIL6_3(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT6_DRF_BIST_FAIL6_2_shift                                          (14)
+#define BIST_RESULT6_DRF_BIST_FAIL6_2_mask                                           (0x00004000)
+#define BIST_RESULT6_DRF_BIST_FAIL6_2(data)                                          (0x00004000&((data)<<14))
+#define BIST_RESULT6_DRF_BIST_FAIL6_2_src(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT6_get_DRF_BIST_FAIL6_2(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT6_DRF_BIST_FAIL6_1_shift                                          (13)
+#define BIST_RESULT6_DRF_BIST_FAIL6_1_mask                                           (0x00002000)
+#define BIST_RESULT6_DRF_BIST_FAIL6_1(data)                                          (0x00002000&((data)<<13))
+#define BIST_RESULT6_DRF_BIST_FAIL6_1_src(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT6_get_DRF_BIST_FAIL6_1(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT6_DRF_BIST_FAIL6_0_shift                                          (12)
+#define BIST_RESULT6_DRF_BIST_FAIL6_0_mask                                           (0x00001000)
+#define BIST_RESULT6_DRF_BIST_FAIL6_0(data)                                          (0x00001000&((data)<<12))
+#define BIST_RESULT6_DRF_BIST_FAIL6_0_src(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT6_get_DRF_BIST_FAIL6_0(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT6_DRF_BIST_DONE6_shift                                            (11)
+#define BIST_RESULT6_DRF_BIST_DONE6_mask                                             (0x00000800)
+#define BIST_RESULT6_DRF_BIST_DONE6(data)                                            (0x00000800&((data)<<11))
+#define BIST_RESULT6_DRF_BIST_DONE6_src(data)                                        ((0x00000800&(data))>>11)
+#define BIST_RESULT6_get_DRF_BIST_DONE6(data)                                        ((0x00000800&(data))>>11)
+#define BIST_RESULT6_BIST_FAIL6_9_shift                                              (10)
+#define BIST_RESULT6_BIST_FAIL6_9_mask                                               (0x00000400)
+#define BIST_RESULT6_BIST_FAIL6_9(data)                                              (0x00000400&((data)<<10))
+#define BIST_RESULT6_BIST_FAIL6_9_src(data)                                          ((0x00000400&(data))>>10)
+#define BIST_RESULT6_get_BIST_FAIL6_9(data)                                          ((0x00000400&(data))>>10)
+#define BIST_RESULT6_BIST_FAIL6_8_shift                                              (9)
+#define BIST_RESULT6_BIST_FAIL6_8_mask                                               (0x00000200)
+#define BIST_RESULT6_BIST_FAIL6_8(data)                                              (0x00000200&((data)<<9))
+#define BIST_RESULT6_BIST_FAIL6_8_src(data)                                          ((0x00000200&(data))>>9)
+#define BIST_RESULT6_get_BIST_FAIL6_8(data)                                          ((0x00000200&(data))>>9)
+#define BIST_RESULT6_BIST_FAIL6_7_shift                                              (8)
+#define BIST_RESULT6_BIST_FAIL6_7_mask                                               (0x00000100)
+#define BIST_RESULT6_BIST_FAIL6_7(data)                                              (0x00000100&((data)<<8))
+#define BIST_RESULT6_BIST_FAIL6_7_src(data)                                          ((0x00000100&(data))>>8)
+#define BIST_RESULT6_get_BIST_FAIL6_7(data)                                          ((0x00000100&(data))>>8)
+#define BIST_RESULT6_BIST_FAIL6_6_shift                                              (7)
+#define BIST_RESULT6_BIST_FAIL6_6_mask                                               (0x00000080)
+#define BIST_RESULT6_BIST_FAIL6_6(data)                                              (0x00000080&((data)<<7))
+#define BIST_RESULT6_BIST_FAIL6_6_src(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT6_get_BIST_FAIL6_6(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT6_BIST_FAIL6_5_shift                                              (6)
+#define BIST_RESULT6_BIST_FAIL6_5_mask                                               (0x00000040)
+#define BIST_RESULT6_BIST_FAIL6_5(data)                                              (0x00000040&((data)<<6))
+#define BIST_RESULT6_BIST_FAIL6_5_src(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT6_get_BIST_FAIL6_5(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT6_BIST_FAIL6_4_shift                                              (5)
+#define BIST_RESULT6_BIST_FAIL6_4_mask                                               (0x00000020)
+#define BIST_RESULT6_BIST_FAIL6_4(data)                                              (0x00000020&((data)<<5))
+#define BIST_RESULT6_BIST_FAIL6_4_src(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT6_get_BIST_FAIL6_4(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT6_BIST_FAIL6_3_shift                                              (4)
+#define BIST_RESULT6_BIST_FAIL6_3_mask                                               (0x00000010)
+#define BIST_RESULT6_BIST_FAIL6_3(data)                                              (0x00000010&((data)<<4))
+#define BIST_RESULT6_BIST_FAIL6_3_src(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT6_get_BIST_FAIL6_3(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT6_BIST_FAIL6_2_shift                                              (3)
+#define BIST_RESULT6_BIST_FAIL6_2_mask                                               (0x00000008)
+#define BIST_RESULT6_BIST_FAIL6_2(data)                                              (0x00000008&((data)<<3))
+#define BIST_RESULT6_BIST_FAIL6_2_src(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT6_get_BIST_FAIL6_2(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT6_BIST_FAIL6_1_shift                                              (2)
+#define BIST_RESULT6_BIST_FAIL6_1_mask                                               (0x00000004)
+#define BIST_RESULT6_BIST_FAIL6_1(data)                                              (0x00000004&((data)<<2))
+#define BIST_RESULT6_BIST_FAIL6_1_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT6_get_BIST_FAIL6_1(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT6_BIST_FAIL6_0_shift                                              (1)
+#define BIST_RESULT6_BIST_FAIL6_0_mask                                               (0x00000002)
+#define BIST_RESULT6_BIST_FAIL6_0(data)                                              (0x00000002&((data)<<1))
+#define BIST_RESULT6_BIST_FAIL6_0_src(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT6_get_BIST_FAIL6_0(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT6_BIST_DONE6_shift                                                (0)
+#define BIST_RESULT6_BIST_DONE6_mask                                                 (0x00000001)
+#define BIST_RESULT6_BIST_DONE6(data)                                                (0x00000001&((data)<<0))
+#define BIST_RESULT6_BIST_DONE6_src(data)                                            ((0x00000001&(data))>>0)
+#define BIST_RESULT6_get_BIST_DONE6(data)                                            ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT7                                                                 0x18036028
+#define BIST_RESULT7_reg_addr                                                        "0xB8036028"
+#define BIST_RESULT7_reg                                                             0xB8036028
+#define set_BIST_RESULT7_reg(data)   (*((volatile unsigned int*) BIST_RESULT7_reg)=data)
+#define get_BIST_RESULT7_reg   (*((volatile unsigned int*) BIST_RESULT7_reg))
+#define BIST_RESULT7_inst_adr                                                        "0x000A"
+#define BIST_RESULT7_inst                                                            0x000A
+#define BIST_RESULT7_DRF_START_PAUSE7_shift                                          (16)
+#define BIST_RESULT7_DRF_START_PAUSE7_mask                                           (0x00010000)
+#define BIST_RESULT7_DRF_START_PAUSE7(data)                                          (0x00010000&((data)<<16))
+#define BIST_RESULT7_DRF_START_PAUSE7_src(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT7_get_DRF_START_PAUSE7(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT7_DRF_BIST_FAIL7_6_shift                                          (15)
+#define BIST_RESULT7_DRF_BIST_FAIL7_6_mask                                           (0x00008000)
+#define BIST_RESULT7_DRF_BIST_FAIL7_6(data)                                          (0x00008000&((data)<<15))
+#define BIST_RESULT7_DRF_BIST_FAIL7_6_src(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT7_get_DRF_BIST_FAIL7_6(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT7_DRF_BIST_FAIL7_5_shift                                          (14)
+#define BIST_RESULT7_DRF_BIST_FAIL7_5_mask                                           (0x00004000)
+#define BIST_RESULT7_DRF_BIST_FAIL7_5(data)                                          (0x00004000&((data)<<14))
+#define BIST_RESULT7_DRF_BIST_FAIL7_5_src(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT7_get_DRF_BIST_FAIL7_5(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT7_DRF_BIST_FAIL7_4_shift                                          (13)
+#define BIST_RESULT7_DRF_BIST_FAIL7_4_mask                                           (0x00002000)
+#define BIST_RESULT7_DRF_BIST_FAIL7_4(data)                                          (0x00002000&((data)<<13))
+#define BIST_RESULT7_DRF_BIST_FAIL7_4_src(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT7_get_DRF_BIST_FAIL7_4(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT7_DRF_BIST_FAIL7_3_shift                                          (12)
+#define BIST_RESULT7_DRF_BIST_FAIL7_3_mask                                           (0x00001000)
+#define BIST_RESULT7_DRF_BIST_FAIL7_3(data)                                          (0x00001000&((data)<<12))
+#define BIST_RESULT7_DRF_BIST_FAIL7_3_src(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT7_get_DRF_BIST_FAIL7_3(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT7_DRF_BIST_FAIL7_2_shift                                          (11)
+#define BIST_RESULT7_DRF_BIST_FAIL7_2_mask                                           (0x00000800)
+#define BIST_RESULT7_DRF_BIST_FAIL7_2(data)                                          (0x00000800&((data)<<11))
+#define BIST_RESULT7_DRF_BIST_FAIL7_2_src(data)                                      ((0x00000800&(data))>>11)
+#define BIST_RESULT7_get_DRF_BIST_FAIL7_2(data)                                      ((0x00000800&(data))>>11)
+#define BIST_RESULT7_DRF_BIST_FAIL7_1_shift                                          (10)
+#define BIST_RESULT7_DRF_BIST_FAIL7_1_mask                                           (0x00000400)
+#define BIST_RESULT7_DRF_BIST_FAIL7_1(data)                                          (0x00000400&((data)<<10))
+#define BIST_RESULT7_DRF_BIST_FAIL7_1_src(data)                                      ((0x00000400&(data))>>10)
+#define BIST_RESULT7_get_DRF_BIST_FAIL7_1(data)                                      ((0x00000400&(data))>>10)
+#define BIST_RESULT7_DRF_BIST_FAIL7_0_shift                                          (9)
+#define BIST_RESULT7_DRF_BIST_FAIL7_0_mask                                           (0x00000200)
+#define BIST_RESULT7_DRF_BIST_FAIL7_0(data)                                          (0x00000200&((data)<<9))
+#define BIST_RESULT7_DRF_BIST_FAIL7_0_src(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT7_get_DRF_BIST_FAIL7_0(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT7_DRF_BIST_DONE7_shift                                            (8)
+#define BIST_RESULT7_DRF_BIST_DONE7_mask                                             (0x00000100)
+#define BIST_RESULT7_DRF_BIST_DONE7(data)                                            (0x00000100&((data)<<8))
+#define BIST_RESULT7_DRF_BIST_DONE7_src(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT7_get_DRF_BIST_DONE7(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT7_BIST_FAIL7_6_shift                                              (7)
+#define BIST_RESULT7_BIST_FAIL7_6_mask                                               (0x00000080)
+#define BIST_RESULT7_BIST_FAIL7_6(data)                                              (0x00000080&((data)<<7))
+#define BIST_RESULT7_BIST_FAIL7_6_src(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT7_get_BIST_FAIL7_6(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT7_BIST_FAIL7_5_shift                                              (6)
+#define BIST_RESULT7_BIST_FAIL7_5_mask                                               (0x00000040)
+#define BIST_RESULT7_BIST_FAIL7_5(data)                                              (0x00000040&((data)<<6))
+#define BIST_RESULT7_BIST_FAIL7_5_src(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT7_get_BIST_FAIL7_5(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT7_BIST_FAIL7_4_shift                                              (5)
+#define BIST_RESULT7_BIST_FAIL7_4_mask                                               (0x00000020)
+#define BIST_RESULT7_BIST_FAIL7_4(data)                                              (0x00000020&((data)<<5))
+#define BIST_RESULT7_BIST_FAIL7_4_src(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT7_get_BIST_FAIL7_4(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT7_BIST_FAIL7_3_shift                                              (4)
+#define BIST_RESULT7_BIST_FAIL7_3_mask                                               (0x00000010)
+#define BIST_RESULT7_BIST_FAIL7_3(data)                                              (0x00000010&((data)<<4))
+#define BIST_RESULT7_BIST_FAIL7_3_src(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT7_get_BIST_FAIL7_3(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT7_BIST_FAIL7_2_shift                                              (3)
+#define BIST_RESULT7_BIST_FAIL7_2_mask                                               (0x00000008)
+#define BIST_RESULT7_BIST_FAIL7_2(data)                                              (0x00000008&((data)<<3))
+#define BIST_RESULT7_BIST_FAIL7_2_src(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT7_get_BIST_FAIL7_2(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT7_BIST_FAIL7_1_shift                                              (2)
+#define BIST_RESULT7_BIST_FAIL7_1_mask                                               (0x00000004)
+#define BIST_RESULT7_BIST_FAIL7_1(data)                                              (0x00000004&((data)<<2))
+#define BIST_RESULT7_BIST_FAIL7_1_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT7_get_BIST_FAIL7_1(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT7_BIST_FAIL7_0_shift                                              (1)
+#define BIST_RESULT7_BIST_FAIL7_0_mask                                               (0x00000002)
+#define BIST_RESULT7_BIST_FAIL7_0(data)                                              (0x00000002&((data)<<1))
+#define BIST_RESULT7_BIST_FAIL7_0_src(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT7_get_BIST_FAIL7_0(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT7_BIST_DONE7_shift                                                (0)
+#define BIST_RESULT7_BIST_DONE7_mask                                                 (0x00000001)
+#define BIST_RESULT7_BIST_DONE7(data)                                                (0x00000001&((data)<<0))
+#define BIST_RESULT7_BIST_DONE7_src(data)                                            ((0x00000001&(data))>>0)
+#define BIST_RESULT7_get_BIST_DONE7(data)                                            ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT8                                                                 0x1803602C
+#define BIST_RESULT8_reg_addr                                                        "0xB803602C"
+#define BIST_RESULT8_reg                                                             0xB803602C
+#define set_BIST_RESULT8_reg(data)   (*((volatile unsigned int*) BIST_RESULT8_reg)=data)
+#define get_BIST_RESULT8_reg   (*((volatile unsigned int*) BIST_RESULT8_reg))
+#define BIST_RESULT8_inst_adr                                                        "0x000B"
+#define BIST_RESULT8_inst                                                            0x000B
+#define BIST_RESULT8_DRF_START_PAUSE8_shift                                          (16)
+#define BIST_RESULT8_DRF_START_PAUSE8_mask                                           (0x00010000)
+#define BIST_RESULT8_DRF_START_PAUSE8(data)                                          (0x00010000&((data)<<16))
+#define BIST_RESULT8_DRF_START_PAUSE8_src(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT8_get_DRF_START_PAUSE8(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT8_DRF_BIST_FAIL8_6_shift                                          (15)
+#define BIST_RESULT8_DRF_BIST_FAIL8_6_mask                                           (0x00008000)
+#define BIST_RESULT8_DRF_BIST_FAIL8_6(data)                                          (0x00008000&((data)<<15))
+#define BIST_RESULT8_DRF_BIST_FAIL8_6_src(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT8_get_DRF_BIST_FAIL8_6(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT8_DRF_BIST_FAIL8_5_shift                                          (14)
+#define BIST_RESULT8_DRF_BIST_FAIL8_5_mask                                           (0x00004000)
+#define BIST_RESULT8_DRF_BIST_FAIL8_5(data)                                          (0x00004000&((data)<<14))
+#define BIST_RESULT8_DRF_BIST_FAIL8_5_src(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT8_get_DRF_BIST_FAIL8_5(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT8_DRF_BIST_FAIL8_4_shift                                          (13)
+#define BIST_RESULT8_DRF_BIST_FAIL8_4_mask                                           (0x00002000)
+#define BIST_RESULT8_DRF_BIST_FAIL8_4(data)                                          (0x00002000&((data)<<13))
+#define BIST_RESULT8_DRF_BIST_FAIL8_4_src(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT8_get_DRF_BIST_FAIL8_4(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT8_DRF_BIST_FAIL8_3_shift                                          (12)
+#define BIST_RESULT8_DRF_BIST_FAIL8_3_mask                                           (0x00001000)
+#define BIST_RESULT8_DRF_BIST_FAIL8_3(data)                                          (0x00001000&((data)<<12))
+#define BIST_RESULT8_DRF_BIST_FAIL8_3_src(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT8_get_DRF_BIST_FAIL8_3(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT8_DRF_BIST_FAIL8_2_shift                                          (11)
+#define BIST_RESULT8_DRF_BIST_FAIL8_2_mask                                           (0x00000800)
+#define BIST_RESULT8_DRF_BIST_FAIL8_2(data)                                          (0x00000800&((data)<<11))
+#define BIST_RESULT8_DRF_BIST_FAIL8_2_src(data)                                      ((0x00000800&(data))>>11)
+#define BIST_RESULT8_get_DRF_BIST_FAIL8_2(data)                                      ((0x00000800&(data))>>11)
+#define BIST_RESULT8_DRF_BIST_FAIL8_1_shift                                          (10)
+#define BIST_RESULT8_DRF_BIST_FAIL8_1_mask                                           (0x00000400)
+#define BIST_RESULT8_DRF_BIST_FAIL8_1(data)                                          (0x00000400&((data)<<10))
+#define BIST_RESULT8_DRF_BIST_FAIL8_1_src(data)                                      ((0x00000400&(data))>>10)
+#define BIST_RESULT8_get_DRF_BIST_FAIL8_1(data)                                      ((0x00000400&(data))>>10)
+#define BIST_RESULT8_DRF_BIST_FAIL8_0_shift                                          (9)
+#define BIST_RESULT8_DRF_BIST_FAIL8_0_mask                                           (0x00000200)
+#define BIST_RESULT8_DRF_BIST_FAIL8_0(data)                                          (0x00000200&((data)<<9))
+#define BIST_RESULT8_DRF_BIST_FAIL8_0_src(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT8_get_DRF_BIST_FAIL8_0(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT8_DRF_BIST_DONE8_shift                                            (8)
+#define BIST_RESULT8_DRF_BIST_DONE8_mask                                             (0x00000100)
+#define BIST_RESULT8_DRF_BIST_DONE8(data)                                            (0x00000100&((data)<<8))
+#define BIST_RESULT8_DRF_BIST_DONE8_src(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT8_get_DRF_BIST_DONE8(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT8_BIST_FAIL8_6_shift                                              (7)
+#define BIST_RESULT8_BIST_FAIL8_6_mask                                               (0x00000080)
+#define BIST_RESULT8_BIST_FAIL8_6(data)                                              (0x00000080&((data)<<7))
+#define BIST_RESULT8_BIST_FAIL8_6_src(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT8_get_BIST_FAIL8_6(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT8_BIST_FAIL8_5_shift                                              (6)
+#define BIST_RESULT8_BIST_FAIL8_5_mask                                               (0x00000040)
+#define BIST_RESULT8_BIST_FAIL8_5(data)                                              (0x00000040&((data)<<6))
+#define BIST_RESULT8_BIST_FAIL8_5_src(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT8_get_BIST_FAIL8_5(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT8_BIST_FAIL8_4_shift                                              (5)
+#define BIST_RESULT8_BIST_FAIL8_4_mask                                               (0x00000020)
+#define BIST_RESULT8_BIST_FAIL8_4(data)                                              (0x00000020&((data)<<5))
+#define BIST_RESULT8_BIST_FAIL8_4_src(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT8_get_BIST_FAIL8_4(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT8_BIST_FAIL8_3_shift                                              (4)
+#define BIST_RESULT8_BIST_FAIL8_3_mask                                               (0x00000010)
+#define BIST_RESULT8_BIST_FAIL8_3(data)                                              (0x00000010&((data)<<4))
+#define BIST_RESULT8_BIST_FAIL8_3_src(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT8_get_BIST_FAIL8_3(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT8_BIST_FAIL8_2_shift                                              (3)
+#define BIST_RESULT8_BIST_FAIL8_2_mask                                               (0x00000008)
+#define BIST_RESULT8_BIST_FAIL8_2(data)                                              (0x00000008&((data)<<3))
+#define BIST_RESULT8_BIST_FAIL8_2_src(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT8_get_BIST_FAIL8_2(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT8_BIST_FAIL8_1_shift                                              (2)
+#define BIST_RESULT8_BIST_FAIL8_1_mask                                               (0x00000004)
+#define BIST_RESULT8_BIST_FAIL8_1(data)                                              (0x00000004&((data)<<2))
+#define BIST_RESULT8_BIST_FAIL8_1_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT8_get_BIST_FAIL8_1(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT8_BIST_FAIL8_0_shift                                              (1)
+#define BIST_RESULT8_BIST_FAIL8_0_mask                                               (0x00000002)
+#define BIST_RESULT8_BIST_FAIL8_0(data)                                              (0x00000002&((data)<<1))
+#define BIST_RESULT8_BIST_FAIL8_0_src(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT8_get_BIST_FAIL8_0(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT8_BIST_DONE8_shift                                                (0)
+#define BIST_RESULT8_BIST_DONE8_mask                                                 (0x00000001)
+#define BIST_RESULT8_BIST_DONE8(data)                                                (0x00000001&((data)<<0))
+#define BIST_RESULT8_BIST_DONE8_src(data)                                            ((0x00000001&(data))>>0)
+#define BIST_RESULT8_get_BIST_DONE8(data)                                            ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT9                                                                 0x18036030
+#define BIST_RESULT9_reg_addr                                                        "0xB8036030"
+#define BIST_RESULT9_reg                                                             0xB8036030
+#define set_BIST_RESULT9_reg(data)   (*((volatile unsigned int*) BIST_RESULT9_reg)=data)
+#define get_BIST_RESULT9_reg   (*((volatile unsigned int*) BIST_RESULT9_reg))
+#define BIST_RESULT9_inst_adr                                                        "0x000C"
+#define BIST_RESULT9_inst                                                            0x000C
+#define BIST_RESULT9_DRF_START_PAUSE9_shift                                          (16)
+#define BIST_RESULT9_DRF_START_PAUSE9_mask                                           (0x00010000)
+#define BIST_RESULT9_DRF_START_PAUSE9(data)                                          (0x00010000&((data)<<16))
+#define BIST_RESULT9_DRF_START_PAUSE9_src(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT9_get_DRF_START_PAUSE9(data)                                      ((0x00010000&(data))>>16)
+#define BIST_RESULT9_DRF_BIST_FAIL9_6_shift                                          (15)
+#define BIST_RESULT9_DRF_BIST_FAIL9_6_mask                                           (0x00008000)
+#define BIST_RESULT9_DRF_BIST_FAIL9_6(data)                                          (0x00008000&((data)<<15))
+#define BIST_RESULT9_DRF_BIST_FAIL9_6_src(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT9_get_DRF_BIST_FAIL9_6(data)                                      ((0x00008000&(data))>>15)
+#define BIST_RESULT9_DRF_BIST_FAIL9_5_shift                                          (14)
+#define BIST_RESULT9_DRF_BIST_FAIL9_5_mask                                           (0x00004000)
+#define BIST_RESULT9_DRF_BIST_FAIL9_5(data)                                          (0x00004000&((data)<<14))
+#define BIST_RESULT9_DRF_BIST_FAIL9_5_src(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT9_get_DRF_BIST_FAIL9_5(data)                                      ((0x00004000&(data))>>14)
+#define BIST_RESULT9_DRF_BIST_FAIL9_4_shift                                          (13)
+#define BIST_RESULT9_DRF_BIST_FAIL9_4_mask                                           (0x00002000)
+#define BIST_RESULT9_DRF_BIST_FAIL9_4(data)                                          (0x00002000&((data)<<13))
+#define BIST_RESULT9_DRF_BIST_FAIL9_4_src(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT9_get_DRF_BIST_FAIL9_4(data)                                      ((0x00002000&(data))>>13)
+#define BIST_RESULT9_DRF_BIST_FAIL9_3_shift                                          (12)
+#define BIST_RESULT9_DRF_BIST_FAIL9_3_mask                                           (0x00001000)
+#define BIST_RESULT9_DRF_BIST_FAIL9_3(data)                                          (0x00001000&((data)<<12))
+#define BIST_RESULT9_DRF_BIST_FAIL9_3_src(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT9_get_DRF_BIST_FAIL9_3(data)                                      ((0x00001000&(data))>>12)
+#define BIST_RESULT9_DRF_BIST_FAIL9_2_shift                                          (11)
+#define BIST_RESULT9_DRF_BIST_FAIL9_2_mask                                           (0x00000800)
+#define BIST_RESULT9_DRF_BIST_FAIL9_2(data)                                          (0x00000800&((data)<<11))
+#define BIST_RESULT9_DRF_BIST_FAIL9_2_src(data)                                      ((0x00000800&(data))>>11)
+#define BIST_RESULT9_get_DRF_BIST_FAIL9_2(data)                                      ((0x00000800&(data))>>11)
+#define BIST_RESULT9_DRF_BIST_FAIL9_1_shift                                          (10)
+#define BIST_RESULT9_DRF_BIST_FAIL9_1_mask                                           (0x00000400)
+#define BIST_RESULT9_DRF_BIST_FAIL9_1(data)                                          (0x00000400&((data)<<10))
+#define BIST_RESULT9_DRF_BIST_FAIL9_1_src(data)                                      ((0x00000400&(data))>>10)
+#define BIST_RESULT9_get_DRF_BIST_FAIL9_1(data)                                      ((0x00000400&(data))>>10)
+#define BIST_RESULT9_DRF_BIST_FAIL9_0_shift                                          (9)
+#define BIST_RESULT9_DRF_BIST_FAIL9_0_mask                                           (0x00000200)
+#define BIST_RESULT9_DRF_BIST_FAIL9_0(data)                                          (0x00000200&((data)<<9))
+#define BIST_RESULT9_DRF_BIST_FAIL9_0_src(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT9_get_DRF_BIST_FAIL9_0(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT9_DRF_BIST_DONE9_shift                                            (8)
+#define BIST_RESULT9_DRF_BIST_DONE9_mask                                             (0x00000100)
+#define BIST_RESULT9_DRF_BIST_DONE9(data)                                            (0x00000100&((data)<<8))
+#define BIST_RESULT9_DRF_BIST_DONE9_src(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT9_get_DRF_BIST_DONE9(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT9_BIST_FAIL9_6_shift                                              (7)
+#define BIST_RESULT9_BIST_FAIL9_6_mask                                               (0x00000080)
+#define BIST_RESULT9_BIST_FAIL9_6(data)                                              (0x00000080&((data)<<7))
+#define BIST_RESULT9_BIST_FAIL9_6_src(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT9_get_BIST_FAIL9_6(data)                                          ((0x00000080&(data))>>7)
+#define BIST_RESULT9_BIST_FAIL9_5_shift                                              (6)
+#define BIST_RESULT9_BIST_FAIL9_5_mask                                               (0x00000040)
+#define BIST_RESULT9_BIST_FAIL9_5(data)                                              (0x00000040&((data)<<6))
+#define BIST_RESULT9_BIST_FAIL9_5_src(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT9_get_BIST_FAIL9_5(data)                                          ((0x00000040&(data))>>6)
+#define BIST_RESULT9_BIST_FAIL9_4_shift                                              (5)
+#define BIST_RESULT9_BIST_FAIL9_4_mask                                               (0x00000020)
+#define BIST_RESULT9_BIST_FAIL9_4(data)                                              (0x00000020&((data)<<5))
+#define BIST_RESULT9_BIST_FAIL9_4_src(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT9_get_BIST_FAIL9_4(data)                                          ((0x00000020&(data))>>5)
+#define BIST_RESULT9_BIST_FAIL9_3_shift                                              (4)
+#define BIST_RESULT9_BIST_FAIL9_3_mask                                               (0x00000010)
+#define BIST_RESULT9_BIST_FAIL9_3(data)                                              (0x00000010&((data)<<4))
+#define BIST_RESULT9_BIST_FAIL9_3_src(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT9_get_BIST_FAIL9_3(data)                                          ((0x00000010&(data))>>4)
+#define BIST_RESULT9_BIST_FAIL9_2_shift                                              (3)
+#define BIST_RESULT9_BIST_FAIL9_2_mask                                               (0x00000008)
+#define BIST_RESULT9_BIST_FAIL9_2(data)                                              (0x00000008&((data)<<3))
+#define BIST_RESULT9_BIST_FAIL9_2_src(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT9_get_BIST_FAIL9_2(data)                                          ((0x00000008&(data))>>3)
+#define BIST_RESULT9_BIST_FAIL9_1_shift                                              (2)
+#define BIST_RESULT9_BIST_FAIL9_1_mask                                               (0x00000004)
+#define BIST_RESULT9_BIST_FAIL9_1(data)                                              (0x00000004&((data)<<2))
+#define BIST_RESULT9_BIST_FAIL9_1_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT9_get_BIST_FAIL9_1(data)                                          ((0x00000004&(data))>>2)
+#define BIST_RESULT9_BIST_FAIL9_0_shift                                              (1)
+#define BIST_RESULT9_BIST_FAIL9_0_mask                                               (0x00000002)
+#define BIST_RESULT9_BIST_FAIL9_0(data)                                              (0x00000002&((data)<<1))
+#define BIST_RESULT9_BIST_FAIL9_0_src(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT9_get_BIST_FAIL9_0(data)                                          ((0x00000002&(data))>>1)
+#define BIST_RESULT9_BIST_DONE9_shift                                                (0)
+#define BIST_RESULT9_BIST_DONE9_mask                                                 (0x00000001)
+#define BIST_RESULT9_BIST_DONE9(data)                                                (0x00000001&((data)<<0))
+#define BIST_RESULT9_BIST_DONE9_src(data)                                            ((0x00000001&(data))>>0)
+#define BIST_RESULT9_get_BIST_DONE9(data)                                            ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT10                                                                0x18036034
+#define BIST_RESULT10_reg_addr                                                       "0xB8036034"
+#define BIST_RESULT10_reg                                                            0xB8036034
+#define set_BIST_RESULT10_reg(data)   (*((volatile unsigned int*) BIST_RESULT10_reg)=data)
+#define get_BIST_RESULT10_reg   (*((volatile unsigned int*) BIST_RESULT10_reg))
+#define BIST_RESULT10_inst_adr                                                       "0x000D"
+#define BIST_RESULT10_inst                                                           0x000D
+#define BIST_RESULT10_DRF_START_PAUSE10_shift                                        (18)
+#define BIST_RESULT10_DRF_START_PAUSE10_mask                                         (0x00040000)
+#define BIST_RESULT10_DRF_START_PAUSE10(data)                                        (0x00040000&((data)<<18))
+#define BIST_RESULT10_DRF_START_PAUSE10_src(data)                                    ((0x00040000&(data))>>18)
+#define BIST_RESULT10_get_DRF_START_PAUSE10(data)                                    ((0x00040000&(data))>>18)
+#define BIST_RESULT10_DRF_BIST_FAIL10_7_shift                                        (17)
+#define BIST_RESULT10_DRF_BIST_FAIL10_7_mask                                         (0x00020000)
+#define BIST_RESULT10_DRF_BIST_FAIL10_7(data)                                        (0x00020000&((data)<<17))
+#define BIST_RESULT10_DRF_BIST_FAIL10_7_src(data)                                    ((0x00020000&(data))>>17)
+#define BIST_RESULT10_get_DRF_BIST_FAIL10_7(data)                                    ((0x00020000&(data))>>17)
+#define BIST_RESULT10_DRF_BIST_FAIL10_6_shift                                        (16)
+#define BIST_RESULT10_DRF_BIST_FAIL10_6_mask                                         (0x00010000)
+#define BIST_RESULT10_DRF_BIST_FAIL10_6(data)                                        (0x00010000&((data)<<16))
+#define BIST_RESULT10_DRF_BIST_FAIL10_6_src(data)                                    ((0x00010000&(data))>>16)
+#define BIST_RESULT10_get_DRF_BIST_FAIL10_6(data)                                    ((0x00010000&(data))>>16)
+#define BIST_RESULT10_DRF_BIST_FAIL10_5_shift                                        (15)
+#define BIST_RESULT10_DRF_BIST_FAIL10_5_mask                                         (0x00008000)
+#define BIST_RESULT10_DRF_BIST_FAIL10_5(data)                                        (0x00008000&((data)<<15))
+#define BIST_RESULT10_DRF_BIST_FAIL10_5_src(data)                                    ((0x00008000&(data))>>15)
+#define BIST_RESULT10_get_DRF_BIST_FAIL10_5(data)                                    ((0x00008000&(data))>>15)
+#define BIST_RESULT10_DRF_BIST_FAIL10_4_shift                                        (14)
+#define BIST_RESULT10_DRF_BIST_FAIL10_4_mask                                         (0x00004000)
+#define BIST_RESULT10_DRF_BIST_FAIL10_4(data)                                        (0x00004000&((data)<<14))
+#define BIST_RESULT10_DRF_BIST_FAIL10_4_src(data)                                    ((0x00004000&(data))>>14)
+#define BIST_RESULT10_get_DRF_BIST_FAIL10_4(data)                                    ((0x00004000&(data))>>14)
+#define BIST_RESULT10_DRF_BIST_FAIL10_3_shift                                        (13)
+#define BIST_RESULT10_DRF_BIST_FAIL10_3_mask                                         (0x00002000)
+#define BIST_RESULT10_DRF_BIST_FAIL10_3(data)                                        (0x00002000&((data)<<13))
+#define BIST_RESULT10_DRF_BIST_FAIL10_3_src(data)                                    ((0x00002000&(data))>>13)
+#define BIST_RESULT10_get_DRF_BIST_FAIL10_3(data)                                    ((0x00002000&(data))>>13)
+#define BIST_RESULT10_DRF_BIST_FAIL10_2_shift                                        (12)
+#define BIST_RESULT10_DRF_BIST_FAIL10_2_mask                                         (0x00001000)
+#define BIST_RESULT10_DRF_BIST_FAIL10_2(data)                                        (0x00001000&((data)<<12))
+#define BIST_RESULT10_DRF_BIST_FAIL10_2_src(data)                                    ((0x00001000&(data))>>12)
+#define BIST_RESULT10_get_DRF_BIST_FAIL10_2(data)                                    ((0x00001000&(data))>>12)
+#define BIST_RESULT10_DRF_BIST_FAIL10_1_shift                                        (11)
+#define BIST_RESULT10_DRF_BIST_FAIL10_1_mask                                         (0x00000800)
+#define BIST_RESULT10_DRF_BIST_FAIL10_1(data)                                        (0x00000800&((data)<<11))
+#define BIST_RESULT10_DRF_BIST_FAIL10_1_src(data)                                    ((0x00000800&(data))>>11)
+#define BIST_RESULT10_get_DRF_BIST_FAIL10_1(data)                                    ((0x00000800&(data))>>11)
+#define BIST_RESULT10_DRF_BIST_FAIL10_0_shift                                        (10)
+#define BIST_RESULT10_DRF_BIST_FAIL10_0_mask                                         (0x00000400)
+#define BIST_RESULT10_DRF_BIST_FAIL10_0(data)                                        (0x00000400&((data)<<10))
+#define BIST_RESULT10_DRF_BIST_FAIL10_0_src(data)                                    ((0x00000400&(data))>>10)
+#define BIST_RESULT10_get_DRF_BIST_FAIL10_0(data)                                    ((0x00000400&(data))>>10)
+#define BIST_RESULT10_DRF_BIST_DONE10_shift                                          (9)
+#define BIST_RESULT10_DRF_BIST_DONE10_mask                                           (0x00000200)
+#define BIST_RESULT10_DRF_BIST_DONE10(data)                                          (0x00000200&((data)<<9))
+#define BIST_RESULT10_DRF_BIST_DONE10_src(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT10_get_DRF_BIST_DONE10(data)                                      ((0x00000200&(data))>>9)
+#define BIST_RESULT10_BIST_FAIL10_7_shift                                            (8)
+#define BIST_RESULT10_BIST_FAIL10_7_mask                                             (0x00000100)
+#define BIST_RESULT10_BIST_FAIL10_7(data)                                            (0x00000100&((data)<<8))
+#define BIST_RESULT10_BIST_FAIL10_7_src(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT10_get_BIST_FAIL10_7(data)                                        ((0x00000100&(data))>>8)
+#define BIST_RESULT10_BIST_FAIL10_6_shift                                            (7)
+#define BIST_RESULT10_BIST_FAIL10_6_mask                                             (0x00000080)
+#define BIST_RESULT10_BIST_FAIL10_6(data)                                            (0x00000080&((data)<<7))
+#define BIST_RESULT10_BIST_FAIL10_6_src(data)                                        ((0x00000080&(data))>>7)
+#define BIST_RESULT10_get_BIST_FAIL10_6(data)                                        ((0x00000080&(data))>>7)
+#define BIST_RESULT10_BIST_FAIL10_5_shift                                            (6)
+#define BIST_RESULT10_BIST_FAIL10_5_mask                                             (0x00000040)
+#define BIST_RESULT10_BIST_FAIL10_5(data)                                            (0x00000040&((data)<<6))
+#define BIST_RESULT10_BIST_FAIL10_5_src(data)                                        ((0x00000040&(data))>>6)
+#define BIST_RESULT10_get_BIST_FAIL10_5(data)                                        ((0x00000040&(data))>>6)
+#define BIST_RESULT10_BIST_FAIL10_4_shift                                            (5)
+#define BIST_RESULT10_BIST_FAIL10_4_mask                                             (0x00000020)
+#define BIST_RESULT10_BIST_FAIL10_4(data)                                            (0x00000020&((data)<<5))
+#define BIST_RESULT10_BIST_FAIL10_4_src(data)                                        ((0x00000020&(data))>>5)
+#define BIST_RESULT10_get_BIST_FAIL10_4(data)                                        ((0x00000020&(data))>>5)
+#define BIST_RESULT10_BIST_FAIL10_3_shift                                            (4)
+#define BIST_RESULT10_BIST_FAIL10_3_mask                                             (0x00000010)
+#define BIST_RESULT10_BIST_FAIL10_3(data)                                            (0x00000010&((data)<<4))
+#define BIST_RESULT10_BIST_FAIL10_3_src(data)                                        ((0x00000010&(data))>>4)
+#define BIST_RESULT10_get_BIST_FAIL10_3(data)                                        ((0x00000010&(data))>>4)
+#define BIST_RESULT10_BIST_FAIL10_2_shift                                            (3)
+#define BIST_RESULT10_BIST_FAIL10_2_mask                                             (0x00000008)
+#define BIST_RESULT10_BIST_FAIL10_2(data)                                            (0x00000008&((data)<<3))
+#define BIST_RESULT10_BIST_FAIL10_2_src(data)                                        ((0x00000008&(data))>>3)
+#define BIST_RESULT10_get_BIST_FAIL10_2(data)                                        ((0x00000008&(data))>>3)
+#define BIST_RESULT10_BIST_FAIL10_1_shift                                            (2)
+#define BIST_RESULT10_BIST_FAIL10_1_mask                                             (0x00000004)
+#define BIST_RESULT10_BIST_FAIL10_1(data)                                            (0x00000004&((data)<<2))
+#define BIST_RESULT10_BIST_FAIL10_1_src(data)                                        ((0x00000004&(data))>>2)
+#define BIST_RESULT10_get_BIST_FAIL10_1(data)                                        ((0x00000004&(data))>>2)
+#define BIST_RESULT10_BIST_FAIL10_0_shift                                            (1)
+#define BIST_RESULT10_BIST_FAIL10_0_mask                                             (0x00000002)
+#define BIST_RESULT10_BIST_FAIL10_0(data)                                            (0x00000002&((data)<<1))
+#define BIST_RESULT10_BIST_FAIL10_0_src(data)                                        ((0x00000002&(data))>>1)
+#define BIST_RESULT10_get_BIST_FAIL10_0(data)                                        ((0x00000002&(data))>>1)
+#define BIST_RESULT10_BIST_DONE10_shift                                              (0)
+#define BIST_RESULT10_BIST_DONE10_mask                                               (0x00000001)
+#define BIST_RESULT10_BIST_DONE10(data)                                              (0x00000001&((data)<<0))
+#define BIST_RESULT10_BIST_DONE10_src(data)                                          ((0x00000001&(data))>>0)
+#define BIST_RESULT10_get_BIST_DONE10(data)                                          ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT11                                                                0x18036038
+#define BIST_RESULT11_reg_addr                                                       "0xB8036038"
+#define BIST_RESULT11_reg                                                            0xB8036038
+#define set_BIST_RESULT11_reg(data)   (*((volatile unsigned int*) BIST_RESULT11_reg)=data)
+#define get_BIST_RESULT11_reg   (*((volatile unsigned int*) BIST_RESULT11_reg))
+#define BIST_RESULT11_inst_adr                                                       "0x000E"
+#define BIST_RESULT11_inst                                                           0x000E
+#define BIST_RESULT11_DRF_START_PAUSE11_shift                                        (10)
+#define BIST_RESULT11_DRF_START_PAUSE11_mask                                         (0x00000400)
+#define BIST_RESULT11_DRF_START_PAUSE11(data)                                        (0x00000400&((data)<<10))
+#define BIST_RESULT11_DRF_START_PAUSE11_src(data)                                    ((0x00000400&(data))>>10)
+#define BIST_RESULT11_get_DRF_START_PAUSE11(data)                                    ((0x00000400&(data))>>10)
+#define BIST_RESULT11_DRF_BIST_FAIL11_3_shift                                        (9)
+#define BIST_RESULT11_DRF_BIST_FAIL11_3_mask                                         (0x00000200)
+#define BIST_RESULT11_DRF_BIST_FAIL11_3(data)                                        (0x00000200&((data)<<9))
+#define BIST_RESULT11_DRF_BIST_FAIL11_3_src(data)                                    ((0x00000200&(data))>>9)
+#define BIST_RESULT11_get_DRF_BIST_FAIL11_3(data)                                    ((0x00000200&(data))>>9)
+#define BIST_RESULT11_DRF_BIST_FAIL11_2_shift                                        (8)
+#define BIST_RESULT11_DRF_BIST_FAIL11_2_mask                                         (0x00000100)
+#define BIST_RESULT11_DRF_BIST_FAIL11_2(data)                                        (0x00000100&((data)<<8))
+#define BIST_RESULT11_DRF_BIST_FAIL11_2_src(data)                                    ((0x00000100&(data))>>8)
+#define BIST_RESULT11_get_DRF_BIST_FAIL11_2(data)                                    ((0x00000100&(data))>>8)
+#define BIST_RESULT11_DRF_BIST_FAIL11_1_shift                                        (7)
+#define BIST_RESULT11_DRF_BIST_FAIL11_1_mask                                         (0x00000080)
+#define BIST_RESULT11_DRF_BIST_FAIL11_1(data)                                        (0x00000080&((data)<<7))
+#define BIST_RESULT11_DRF_BIST_FAIL11_1_src(data)                                    ((0x00000080&(data))>>7)
+#define BIST_RESULT11_get_DRF_BIST_FAIL11_1(data)                                    ((0x00000080&(data))>>7)
+#define BIST_RESULT11_DRF_BIST_FAIL11_0_shift                                        (6)
+#define BIST_RESULT11_DRF_BIST_FAIL11_0_mask                                         (0x00000040)
+#define BIST_RESULT11_DRF_BIST_FAIL11_0(data)                                        (0x00000040&((data)<<6))
+#define BIST_RESULT11_DRF_BIST_FAIL11_0_src(data)                                    ((0x00000040&(data))>>6)
+#define BIST_RESULT11_get_DRF_BIST_FAIL11_0(data)                                    ((0x00000040&(data))>>6)
+#define BIST_RESULT11_DRF_BIST_DONE11_shift                                          (5)
+#define BIST_RESULT11_DRF_BIST_DONE11_mask                                           (0x00000020)
+#define BIST_RESULT11_DRF_BIST_DONE11(data)                                          (0x00000020&((data)<<5))
+#define BIST_RESULT11_DRF_BIST_DONE11_src(data)                                      ((0x00000020&(data))>>5)
+#define BIST_RESULT11_get_DRF_BIST_DONE11(data)                                      ((0x00000020&(data))>>5)
+#define BIST_RESULT11_BIST_FAIL11_3_shift                                            (4)
+#define BIST_RESULT11_BIST_FAIL11_3_mask                                             (0x00000010)
+#define BIST_RESULT11_BIST_FAIL11_3(data)                                            (0x00000010&((data)<<4))
+#define BIST_RESULT11_BIST_FAIL11_3_src(data)                                        ((0x00000010&(data))>>4)
+#define BIST_RESULT11_get_BIST_FAIL11_3(data)                                        ((0x00000010&(data))>>4)
+#define BIST_RESULT11_BIST_FAIL11_2_shift                                            (3)
+#define BIST_RESULT11_BIST_FAIL11_2_mask                                             (0x00000008)
+#define BIST_RESULT11_BIST_FAIL11_2(data)                                            (0x00000008&((data)<<3))
+#define BIST_RESULT11_BIST_FAIL11_2_src(data)                                        ((0x00000008&(data))>>3)
+#define BIST_RESULT11_get_BIST_FAIL11_2(data)                                        ((0x00000008&(data))>>3)
+#define BIST_RESULT11_BIST_FAIL11_1_shift                                            (2)
+#define BIST_RESULT11_BIST_FAIL11_1_mask                                             (0x00000004)
+#define BIST_RESULT11_BIST_FAIL11_1(data)                                            (0x00000004&((data)<<2))
+#define BIST_RESULT11_BIST_FAIL11_1_src(data)                                        ((0x00000004&(data))>>2)
+#define BIST_RESULT11_get_BIST_FAIL11_1(data)                                        ((0x00000004&(data))>>2)
+#define BIST_RESULT11_BIST_FAIL11_0_shift                                            (1)
+#define BIST_RESULT11_BIST_FAIL11_0_mask                                             (0x00000002)
+#define BIST_RESULT11_BIST_FAIL11_0(data)                                            (0x00000002&((data)<<1))
+#define BIST_RESULT11_BIST_FAIL11_0_src(data)                                        ((0x00000002&(data))>>1)
+#define BIST_RESULT11_get_BIST_FAIL11_0(data)                                        ((0x00000002&(data))>>1)
+#define BIST_RESULT11_BIST_DONE11_shift                                              (0)
+#define BIST_RESULT11_BIST_DONE11_mask                                               (0x00000001)
+#define BIST_RESULT11_BIST_DONE11(data)                                              (0x00000001&((data)<<0))
+#define BIST_RESULT11_BIST_DONE11_src(data)                                          ((0x00000001&(data))>>0)
+#define BIST_RESULT11_get_BIST_DONE11(data)                                          ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT12                                                                0x1803603C
+#define BIST_RESULT12_reg_addr                                                       "0xB803603C"
+#define BIST_RESULT12_reg                                                            0xB803603C
+#define set_BIST_RESULT12_reg(data)   (*((volatile unsigned int*) BIST_RESULT12_reg)=data)
+#define get_BIST_RESULT12_reg   (*((volatile unsigned int*) BIST_RESULT12_reg))
+#define BIST_RESULT12_inst_adr                                                       "0x000F"
+#define BIST_RESULT12_inst                                                           0x000F
+#define BIST_RESULT12_DRF_START_PAUSE12_shift                                        (6)
+#define BIST_RESULT12_DRF_START_PAUSE12_mask                                         (0x00000040)
+#define BIST_RESULT12_DRF_START_PAUSE12(data)                                        (0x00000040&((data)<<6))
+#define BIST_RESULT12_DRF_START_PAUSE12_src(data)                                    ((0x00000040&(data))>>6)
+#define BIST_RESULT12_get_DRF_START_PAUSE12(data)                                    ((0x00000040&(data))>>6)
+#define BIST_RESULT12_DRF_BIST_FAIL12_1_shift                                        (5)
+#define BIST_RESULT12_DRF_BIST_FAIL12_1_mask                                         (0x00000020)
+#define BIST_RESULT12_DRF_BIST_FAIL12_1(data)                                        (0x00000020&((data)<<5))
+#define BIST_RESULT12_DRF_BIST_FAIL12_1_src(data)                                    ((0x00000020&(data))>>5)
+#define BIST_RESULT12_get_DRF_BIST_FAIL12_1(data)                                    ((0x00000020&(data))>>5)
+#define BIST_RESULT12_DRF_BIST_FAIL12_0_shift                                        (4)
+#define BIST_RESULT12_DRF_BIST_FAIL12_0_mask                                         (0x00000010)
+#define BIST_RESULT12_DRF_BIST_FAIL12_0(data)                                        (0x00000010&((data)<<4))
+#define BIST_RESULT12_DRF_BIST_FAIL12_0_src(data)                                    ((0x00000010&(data))>>4)
+#define BIST_RESULT12_get_DRF_BIST_FAIL12_0(data)                                    ((0x00000010&(data))>>4)
+#define BIST_RESULT12_DRF_BIST_DONE12_shift                                          (3)
+#define BIST_RESULT12_DRF_BIST_DONE12_mask                                           (0x00000008)
+#define BIST_RESULT12_DRF_BIST_DONE12(data)                                          (0x00000008&((data)<<3))
+#define BIST_RESULT12_DRF_BIST_DONE12_src(data)                                      ((0x00000008&(data))>>3)
+#define BIST_RESULT12_get_DRF_BIST_DONE12(data)                                      ((0x00000008&(data))>>3)
+#define BIST_RESULT12_BIST_FAIL12_1_shift                                            (2)
+#define BIST_RESULT12_BIST_FAIL12_1_mask                                             (0x00000004)
+#define BIST_RESULT12_BIST_FAIL12_1(data)                                            (0x00000004&((data)<<2))
+#define BIST_RESULT12_BIST_FAIL12_1_src(data)                                        ((0x00000004&(data))>>2)
+#define BIST_RESULT12_get_BIST_FAIL12_1(data)                                        ((0x00000004&(data))>>2)
+#define BIST_RESULT12_BIST_FAIL12_0_shift                                            (1)
+#define BIST_RESULT12_BIST_FAIL12_0_mask                                             (0x00000002)
+#define BIST_RESULT12_BIST_FAIL12_0(data)                                            (0x00000002&((data)<<1))
+#define BIST_RESULT12_BIST_FAIL12_0_src(data)                                        ((0x00000002&(data))>>1)
+#define BIST_RESULT12_get_BIST_FAIL12_0(data)                                        ((0x00000002&(data))>>1)
+#define BIST_RESULT12_BIST_DONE12_shift                                              (0)
+#define BIST_RESULT12_BIST_DONE12_mask                                               (0x00000001)
+#define BIST_RESULT12_BIST_DONE12(data)                                              (0x00000001&((data)<<0))
+#define BIST_RESULT12_BIST_DONE12_src(data)                                          ((0x00000001&(data))>>0)
+#define BIST_RESULT12_get_BIST_DONE12(data)                                          ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT13                                                                0x18036040
+#define BIST_RESULT13_reg_addr                                                       "0xB8036040"
+#define BIST_RESULT13_reg                                                            0xB8036040
+#define set_BIST_RESULT13_reg(data)   (*((volatile unsigned int*) BIST_RESULT13_reg)=data)
+#define get_BIST_RESULT13_reg   (*((volatile unsigned int*) BIST_RESULT13_reg))
+#define BIST_RESULT13_inst_adr                                                       "0x0010"
+#define BIST_RESULT13_inst                                                           0x0010
+#define BIST_RESULT13_DRF_START_PAUSE13_shift                                        (4)
+#define BIST_RESULT13_DRF_START_PAUSE13_mask                                         (0x00000010)
+#define BIST_RESULT13_DRF_START_PAUSE13(data)                                        (0x00000010&((data)<<4))
+#define BIST_RESULT13_DRF_START_PAUSE13_src(data)                                    ((0x00000010&(data))>>4)
+#define BIST_RESULT13_get_DRF_START_PAUSE13(data)                                    ((0x00000010&(data))>>4)
+#define BIST_RESULT13_DRF_BIST_FAIL13_0_shift                                        (3)
+#define BIST_RESULT13_DRF_BIST_FAIL13_0_mask                                         (0x00000008)
+#define BIST_RESULT13_DRF_BIST_FAIL13_0(data)                                        (0x00000008&((data)<<3))
+#define BIST_RESULT13_DRF_BIST_FAIL13_0_src(data)                                    ((0x00000008&(data))>>3)
+#define BIST_RESULT13_get_DRF_BIST_FAIL13_0(data)                                    ((0x00000008&(data))>>3)
+#define BIST_RESULT13_DRF_BIST_DONE13_shift                                          (2)
+#define BIST_RESULT13_DRF_BIST_DONE13_mask                                           (0x00000004)
+#define BIST_RESULT13_DRF_BIST_DONE13(data)                                          (0x00000004&((data)<<2))
+#define BIST_RESULT13_DRF_BIST_DONE13_src(data)                                      ((0x00000004&(data))>>2)
+#define BIST_RESULT13_get_DRF_BIST_DONE13(data)                                      ((0x00000004&(data))>>2)
+#define BIST_RESULT13_BIST_FAIL13_0_shift                                            (1)
+#define BIST_RESULT13_BIST_FAIL13_0_mask                                             (0x00000002)
+#define BIST_RESULT13_BIST_FAIL13_0(data)                                            (0x00000002&((data)<<1))
+#define BIST_RESULT13_BIST_FAIL13_0_src(data)                                        ((0x00000002&(data))>>1)
+#define BIST_RESULT13_get_BIST_FAIL13_0(data)                                        ((0x00000002&(data))>>1)
+#define BIST_RESULT13_BIST_DONE13_shift                                              (0)
+#define BIST_RESULT13_BIST_DONE13_mask                                               (0x00000001)
+#define BIST_RESULT13_BIST_DONE13(data)                                              (0x00000001&((data)<<0))
+#define BIST_RESULT13_BIST_DONE13_src(data)                                          ((0x00000001&(data))>>0)
+#define BIST_RESULT13_get_BIST_DONE13(data)                                          ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT13                                                                0x18036044
+#define BIST_RESULT13_reg_addr                                                       "0xB8036044"
+#define BIST_RESULT13_reg                                                            0xB8036044
+#define set_BIST_RESULT13_reg(data)   (*((volatile unsigned int*) BIST_RESULT13_reg)=data)
+#define get_BIST_RESULT13_reg   (*((volatile unsigned int*) BIST_RESULT13_reg))
+#define BIST_RESULT13_inst_adr                                                       "0x0011"
+#define BIST_RESULT13_inst                                                           0x0011
+#define BIST_RESULT13_sram_rm_shift                                                  (1)
+#define BIST_RESULT13_sram_rm_mask                                                   (0x0000001E)
+#define BIST_RESULT13_sram_rm(data)                                                  (0x0000001E&((data)<<1))
+#define BIST_RESULT13_sram_rm_src(data)                                              ((0x0000001E&(data))>>1)
+#define BIST_RESULT13_get_sram_rm(data)                                              ((0x0000001E&(data))>>1)
+#define BIST_RESULT13_sram_rme_shift                                                 (0)
+#define BIST_RESULT13_sram_rme_mask                                                  (0x00000001)
+#define BIST_RESULT13_sram_rme(data)                                                 (0x00000001&((data)<<0))
+#define BIST_RESULT13_sram_rme_src(data)                                             ((0x00000001&(data))>>0)
+#define BIST_RESULT13_get_sram_rme(data)                                             ((0x00000001&(data))>>0)
+
+
+#define DEBUGPORTS                                                                   0x18036048
+#define DEBUGPORTS_reg_addr                                                          "0xB8036048"
+#define DEBUGPORTS_reg                                                               0xB8036048
+#define set_DEBUGPORTS_reg(data)   (*((volatile unsigned int*) DEBUGPORTS_reg)=data)
+#define get_DEBUGPORTS_reg   (*((volatile unsigned int*) DEBUGPORTS_reg))
+#define DEBUGPORTS_inst_adr                                                          "0x0012"
+#define DEBUGPORTS_inst                                                              0x0012
+#define DEBUGPORTS_dbg_sel_shift                                                     (8)
+#define DEBUGPORTS_dbg_sel_mask                                                      (0x00000100)
+#define DEBUGPORTS_dbg_sel(data)                                                     (0x00000100&((data)<<8))
+#define DEBUGPORTS_dbg_sel_src(data)                                                 ((0x00000100&(data))>>8)
+#define DEBUGPORTS_get_dbg_sel(data)                                                 ((0x00000100&(data))>>8)
+#define DEBUGPORTS_dbg_sel1_shift                                                    (4)
+#define DEBUGPORTS_dbg_sel1_mask                                                     (0x000000F0)
+#define DEBUGPORTS_dbg_sel1(data)                                                    (0x000000F0&((data)<<4))
+#define DEBUGPORTS_dbg_sel1_src(data)                                                ((0x000000F0&(data))>>4)
+#define DEBUGPORTS_get_dbg_sel1(data)                                                ((0x000000F0&(data))>>4)
+#define DEBUGPORTS_dbg_sel0_shift                                                    (0)
+#define DEBUGPORTS_dbg_sel0_mask                                                     (0x0000000F)
+#define DEBUGPORTS_dbg_sel0(data)                                                    (0x0000000F&((data)<<0))
+#define DEBUGPORTS_dbg_sel0_src(data)                                                ((0x0000000F&(data))>>0)
+#define DEBUGPORTS_get_dbg_sel0(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define DUMMYREGISTERS0                                                              0x1803604C
+#define DUMMYREGISTERS0_reg_addr                                                     "0xB803604C"
+#define DUMMYREGISTERS0_reg                                                          0xB803604C
+#define set_DUMMYREGISTERS0_reg(data)   (*((volatile unsigned int*) DUMMYREGISTERS0_reg)=data)
+#define get_DUMMYREGISTERS0_reg   (*((volatile unsigned int*) DUMMYREGISTERS0_reg))
+#define DUMMYREGISTERS0_inst_adr                                                     "0x0013"
+#define DUMMYREGISTERS0_inst                                                         0x0013
+#define DUMMYREGISTERS0_dummy_reg0_shift                                             (0)
+#define DUMMYREGISTERS0_dummy_reg0_mask                                              (0xFFFFFFFF)
+#define DUMMYREGISTERS0_dummy_reg0(data)                                             (0xFFFFFFFF&((data)<<0))
+#define DUMMYREGISTERS0_dummy_reg0_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define DUMMYREGISTERS0_get_dummy_reg0(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define DUMMYREGISTERS1                                                              0x18036050
+#define DUMMYREGISTERS1_reg_addr                                                     "0xB8036050"
+#define DUMMYREGISTERS1_reg                                                          0xB8036050
+#define set_DUMMYREGISTERS1_reg(data)   (*((volatile unsigned int*) DUMMYREGISTERS1_reg)=data)
+#define get_DUMMYREGISTERS1_reg   (*((volatile unsigned int*) DUMMYREGISTERS1_reg))
+#define DUMMYREGISTERS1_inst_adr                                                     "0x0014"
+#define DUMMYREGISTERS1_inst                                                         0x0014
+#define DUMMYREGISTERS1_dummy_reg1_shift                                             (0)
+#define DUMMYREGISTERS1_dummy_reg1_mask                                              (0xFFFFFFFF)
+#define DUMMYREGISTERS1_dummy_reg1(data)                                             (0xFFFFFFFF&((data)<<0))
+#define DUMMYREGISTERS1_dummy_reg1_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define DUMMYREGISTERS1_get_dummy_reg1(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define DSS_C35_9D5T_CTRL                                                            0x18036054
+#define DSS_C35_9D5T_CTRL_reg_addr                                                   "0xB8036054"
+#define DSS_C35_9D5T_CTRL_reg                                                        0xB8036054
+#define set_DSS_C35_9D5T_CTRL_reg(data)   (*((volatile unsigned int*) DSS_C35_9D5T_CTRL_reg)=data)
+#define get_DSS_C35_9D5T_CTRL_reg   (*((volatile unsigned int*) DSS_C35_9D5T_CTRL_reg))
+#define DSS_C35_9D5T_CTRL_inst_adr                                                   "0x0015"
+#define DSS_C35_9D5T_CTRL_inst                                                       0x0015
+#define DSS_C35_9D5T_CTRL_c35_data_in_shift                                          (8)
+#define DSS_C35_9D5T_CTRL_c35_data_in_mask                                           (0x0FFFFF00)
+#define DSS_C35_9D5T_CTRL_c35_data_in(data)                                          (0x0FFFFF00&((data)<<8))
+#define DSS_C35_9D5T_CTRL_c35_data_in_src(data)                                      ((0x0FFFFF00&(data))>>8)
+#define DSS_C35_9D5T_CTRL_get_c35_data_in(data)                                      ((0x0FFFFF00&(data))>>8)
+#define DSS_C35_9D5T_CTRL_c35_speed_en_shift                                         (5)
+#define DSS_C35_9D5T_CTRL_c35_speed_en_mask                                          (0x00000020)
+#define DSS_C35_9D5T_CTRL_c35_speed_en(data)                                         (0x00000020&((data)<<5))
+#define DSS_C35_9D5T_CTRL_c35_speed_en_src(data)                                     ((0x00000020&(data))>>5)
+#define DSS_C35_9D5T_CTRL_get_c35_speed_en(data)                                     ((0x00000020&(data))>>5)
+#define DSS_C35_9D5T_CTRL_c35_wire_sel_shift                                         (4)
+#define DSS_C35_9D5T_CTRL_c35_wire_sel_mask                                          (0x00000010)
+#define DSS_C35_9D5T_CTRL_c35_wire_sel(data)                                         (0x00000010&((data)<<4))
+#define DSS_C35_9D5T_CTRL_c35_wire_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define DSS_C35_9D5T_CTRL_get_c35_wire_sel(data)                                     ((0x00000010&(data))>>4)
+#define DSS_C35_9D5T_CTRL_c35_ro_sel_shift                                           (1)
+#define DSS_C35_9D5T_CTRL_c35_ro_sel_mask                                            (0x0000000E)
+#define DSS_C35_9D5T_CTRL_c35_ro_sel(data)                                           (0x0000000E&((data)<<1))
+#define DSS_C35_9D5T_CTRL_c35_ro_sel_src(data)                                       ((0x0000000E&(data))>>1)
+#define DSS_C35_9D5T_CTRL_get_c35_ro_sel(data)                                       ((0x0000000E&(data))>>1)
+#define DSS_C35_9D5T_CTRL_c35_dss_rst_n_shift                                        (0)
+#define DSS_C35_9D5T_CTRL_c35_dss_rst_n_mask                                         (0x00000001)
+#define DSS_C35_9D5T_CTRL_c35_dss_rst_n(data)                                        (0x00000001&((data)<<0))
+#define DSS_C35_9D5T_CTRL_c35_dss_rst_n_src(data)                                    ((0x00000001&(data))>>0)
+#define DSS_C35_9D5T_CTRL_get_c35_dss_rst_n(data)                                    ((0x00000001&(data))>>0)
+
+
+#define DSS_C35_9D5T_STATUS                                                          0x18036058
+#define DSS_C35_9D5T_STATUS_reg_addr                                                 "0xB8036058"
+#define DSS_C35_9D5T_STATUS_reg                                                      0xB8036058
+#define set_DSS_C35_9D5T_STATUS_reg(data)   (*((volatile unsigned int*) DSS_C35_9D5T_STATUS_reg)=data)
+#define get_DSS_C35_9D5T_STATUS_reg   (*((volatile unsigned int*) DSS_C35_9D5T_STATUS_reg))
+#define DSS_C35_9D5T_STATUS_inst_adr                                                 "0x0016"
+#define DSS_C35_9D5T_STATUS_inst                                                     0x0016
+#define DSS_C35_9D5T_STATUS_c35_count_out_shift                                      (4)
+#define DSS_C35_9D5T_STATUS_c35_count_out_mask                                       (0x00FFFFF0)
+#define DSS_C35_9D5T_STATUS_c35_count_out(data)                                      (0x00FFFFF0&((data)<<4))
+#define DSS_C35_9D5T_STATUS_c35_count_out_src(data)                                  ((0x00FFFFF0&(data))>>4)
+#define DSS_C35_9D5T_STATUS_get_c35_count_out(data)                                  ((0x00FFFFF0&(data))>>4)
+#define DSS_C35_9D5T_STATUS_c35_wsort_go_shift                                       (1)
+#define DSS_C35_9D5T_STATUS_c35_wsort_go_mask                                        (0x00000002)
+#define DSS_C35_9D5T_STATUS_c35_wsort_go(data)                                       (0x00000002&((data)<<1))
+#define DSS_C35_9D5T_STATUS_c35_wsort_go_src(data)                                   ((0x00000002&(data))>>1)
+#define DSS_C35_9D5T_STATUS_get_c35_wsort_go(data)                                   ((0x00000002&(data))>>1)
+#define DSS_C35_9D5T_STATUS_c35_ready_shift                                          (0)
+#define DSS_C35_9D5T_STATUS_c35_ready_mask                                           (0x00000001)
+#define DSS_C35_9D5T_STATUS_c35_ready(data)                                          (0x00000001&((data)<<0))
+#define DSS_C35_9D5T_STATUS_c35_ready_src(data)                                      ((0x00000001&(data))>>0)
+#define DSS_C35_9D5T_STATUS_get_c35_ready(data)                                      ((0x00000001&(data))>>0)
+
+
+#define DSS_C35_9D5T_DEBUG                                                           0x1803605C
+#define DSS_C35_9D5T_DEBUG_reg_addr                                                  "0xB803605C"
+#define DSS_C35_9D5T_DEBUG_reg                                                       0xB803605C
+#define set_DSS_C35_9D5T_DEBUG_reg(data)   (*((volatile unsigned int*) DSS_C35_9D5T_DEBUG_reg)=data)
+#define get_DSS_C35_9D5T_DEBUG_reg   (*((volatile unsigned int*) DSS_C35_9D5T_DEBUG_reg))
+#define DSS_C35_9D5T_DEBUG_inst_adr                                                  "0x0017"
+#define DSS_C35_9D5T_DEBUG_inst                                                      0x0017
+#define DSS_C35_9D5T_DEBUG_c35_dbgo_shift                                            (0)
+#define DSS_C35_9D5T_DEBUG_c35_dbgo_mask                                             (0x0000FFFF)
+#define DSS_C35_9D5T_DEBUG_c35_dbgo(data)                                            (0x0000FFFF&((data)<<0))
+#define DSS_C35_9D5T_DEBUG_c35_dbgo_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define DSS_C35_9D5T_DEBUG_get_c35_dbgo(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define DSS_C35D5_9D5T_CTRL                                                          0x18036060
+#define DSS_C35D5_9D5T_CTRL_reg_addr                                                 "0xB8036060"
+#define DSS_C35D5_9D5T_CTRL_reg                                                      0xB8036060
+#define set_DSS_C35D5_9D5T_CTRL_reg(data)   (*((volatile unsigned int*) DSS_C35D5_9D5T_CTRL_reg)=data)
+#define get_DSS_C35D5_9D5T_CTRL_reg   (*((volatile unsigned int*) DSS_C35D5_9D5T_CTRL_reg))
+#define DSS_C35D5_9D5T_CTRL_inst_adr                                                 "0x0018"
+#define DSS_C35D5_9D5T_CTRL_inst                                                     0x0018
+#define DSS_C35D5_9D5T_CTRL_c35d5_data_in_shift                                      (8)
+#define DSS_C35D5_9D5T_CTRL_c35d5_data_in_mask                                       (0x0FFFFF00)
+#define DSS_C35D5_9D5T_CTRL_c35d5_data_in(data)                                      (0x0FFFFF00&((data)<<8))
+#define DSS_C35D5_9D5T_CTRL_c35d5_data_in_src(data)                                  ((0x0FFFFF00&(data))>>8)
+#define DSS_C35D5_9D5T_CTRL_get_c35d5_data_in(data)                                  ((0x0FFFFF00&(data))>>8)
+#define DSS_C35D5_9D5T_CTRL_c35d5_speed_en_shift                                     (5)
+#define DSS_C35D5_9D5T_CTRL_c35d5_speed_en_mask                                      (0x00000020)
+#define DSS_C35D5_9D5T_CTRL_c35d5_speed_en(data)                                     (0x00000020&((data)<<5))
+#define DSS_C35D5_9D5T_CTRL_c35d5_speed_en_src(data)                                 ((0x00000020&(data))>>5)
+#define DSS_C35D5_9D5T_CTRL_get_c35d5_speed_en(data)                                 ((0x00000020&(data))>>5)
+#define DSS_C35D5_9D5T_CTRL_c35d5_wire_sel_shift                                     (4)
+#define DSS_C35D5_9D5T_CTRL_c35d5_wire_sel_mask                                      (0x00000010)
+#define DSS_C35D5_9D5T_CTRL_c35d5_wire_sel(data)                                     (0x00000010&((data)<<4))
+#define DSS_C35D5_9D5T_CTRL_c35d5_wire_sel_src(data)                                 ((0x00000010&(data))>>4)
+#define DSS_C35D5_9D5T_CTRL_get_c35d5_wire_sel(data)                                 ((0x00000010&(data))>>4)
+#define DSS_C35D5_9D5T_CTRL_c35d5_ro_sel_shift                                       (1)
+#define DSS_C35D5_9D5T_CTRL_c35d5_ro_sel_mask                                        (0x0000000E)
+#define DSS_C35D5_9D5T_CTRL_c35d5_ro_sel(data)                                       (0x0000000E&((data)<<1))
+#define DSS_C35D5_9D5T_CTRL_c35d5_ro_sel_src(data)                                   ((0x0000000E&(data))>>1)
+#define DSS_C35D5_9D5T_CTRL_get_c35d5_ro_sel(data)                                   ((0x0000000E&(data))>>1)
+#define DSS_C35D5_9D5T_CTRL_c35d5_dss_rst_n_shift                                    (0)
+#define DSS_C35D5_9D5T_CTRL_c35d5_dss_rst_n_mask                                     (0x00000001)
+#define DSS_C35D5_9D5T_CTRL_c35d5_dss_rst_n(data)                                    (0x00000001&((data)<<0))
+#define DSS_C35D5_9D5T_CTRL_c35d5_dss_rst_n_src(data)                                ((0x00000001&(data))>>0)
+#define DSS_C35D5_9D5T_CTRL_get_c35d5_dss_rst_n(data)                                ((0x00000001&(data))>>0)
+
+
+#define DSS_C35D5_9D5T_STATUS                                                        0x18036064
+#define DSS_C35D5_9D5T_STATUS_reg_addr                                               "0xB8036064"
+#define DSS_C35D5_9D5T_STATUS_reg                                                    0xB8036064
+#define set_DSS_C35D5_9D5T_STATUS_reg(data)   (*((volatile unsigned int*) DSS_C35D5_9D5T_STATUS_reg)=data)
+#define get_DSS_C35D5_9D5T_STATUS_reg   (*((volatile unsigned int*) DSS_C35D5_9D5T_STATUS_reg))
+#define DSS_C35D5_9D5T_STATUS_inst_adr                                               "0x0019"
+#define DSS_C35D5_9D5T_STATUS_inst                                                   0x0019
+#define DSS_C35D5_9D5T_STATUS_c35d5_count_out_shift                                  (4)
+#define DSS_C35D5_9D5T_STATUS_c35d5_count_out_mask                                   (0x00FFFFF0)
+#define DSS_C35D5_9D5T_STATUS_c35d5_count_out(data)                                  (0x00FFFFF0&((data)<<4))
+#define DSS_C35D5_9D5T_STATUS_c35d5_count_out_src(data)                              ((0x00FFFFF0&(data))>>4)
+#define DSS_C35D5_9D5T_STATUS_get_c35d5_count_out(data)                              ((0x00FFFFF0&(data))>>4)
+#define DSS_C35D5_9D5T_STATUS_c35d5_wsort_go_shift                                   (1)
+#define DSS_C35D5_9D5T_STATUS_c35d5_wsort_go_mask                                    (0x00000002)
+#define DSS_C35D5_9D5T_STATUS_c35d5_wsort_go(data)                                   (0x00000002&((data)<<1))
+#define DSS_C35D5_9D5T_STATUS_c35d5_wsort_go_src(data)                               ((0x00000002&(data))>>1)
+#define DSS_C35D5_9D5T_STATUS_get_c35d5_wsort_go(data)                               ((0x00000002&(data))>>1)
+#define DSS_C35D5_9D5T_STATUS_c35d5_ready_shift                                      (0)
+#define DSS_C35D5_9D5T_STATUS_c35d5_ready_mask                                       (0x00000001)
+#define DSS_C35D5_9D5T_STATUS_c35d5_ready(data)                                      (0x00000001&((data)<<0))
+#define DSS_C35D5_9D5T_STATUS_c35d5_ready_src(data)                                  ((0x00000001&(data))>>0)
+#define DSS_C35D5_9D5T_STATUS_get_c35d5_ready(data)                                  ((0x00000001&(data))>>0)
+
+
+#define DSS_C35D5_9D5T_DEBUG                                                         0x18036068
+#define DSS_C35D5_9D5T_DEBUG_reg_addr                                                "0xB8036068"
+#define DSS_C35D5_9D5T_DEBUG_reg                                                     0xB8036068
+#define set_DSS_C35D5_9D5T_DEBUG_reg(data)   (*((volatile unsigned int*) DSS_C35D5_9D5T_DEBUG_reg)=data)
+#define get_DSS_C35D5_9D5T_DEBUG_reg   (*((volatile unsigned int*) DSS_C35D5_9D5T_DEBUG_reg))
+#define DSS_C35D5_9D5T_DEBUG_inst_adr                                                "0x001A"
+#define DSS_C35D5_9D5T_DEBUG_inst                                                    0x001A
+#define DSS_C35D5_9D5T_DEBUG_c35d5_dbgo_shift                                        (0)
+#define DSS_C35D5_9D5T_DEBUG_c35d5_dbgo_mask                                         (0x0000FFFF)
+#define DSS_C35D5_9D5T_DEBUG_c35d5_dbgo(data)                                        (0x0000FFFF&((data)<<0))
+#define DSS_C35D5_9D5T_DEBUG_c35d5_dbgo_src(data)                                    ((0x0000FFFF&(data))>>0)
+#define DSS_C35D5_9D5T_DEBUG_get_c35d5_dbgo(data)                                    ((0x0000FFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/gspi_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/gspi_reg.h
new file mode 100644
index 00000000..5d60e71
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/gspi_reg.h
@@ -0,0 +1,521 @@
+/**************************************************************
+// Spec Version                  : 0.08
+// Parser Version                : DVR_Parser_6.10(110913)
+// CModelGen Version             : 5.0 2009.04.09
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : 0x1801bd00  ~  0x1801bd34
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2011/10/5 20:31:43
+***************************************************************/
+
+
+#ifndef _GSPI_REG_H_INCLUDED_
+#define _GSPI_REG_H_INCLUDED_
+#ifdef  _GSPI_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     sck_divider:8;
+unsigned int     reserved_1:14;
+unsigned int     phase:1;
+unsigned int     polarity:1;
+}SCK_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tcs_high:8;
+unsigned int     Tcs_end:8;
+unsigned int     Tcs_start:8;
+}CS_TIMING;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     SLAVE_MODE_ENABLE:1;
+unsigned int     reserved_1:6;
+unsigned int     CS_1_ENABLE:1;
+unsigned int     CS_0_ENABLE:1;
+}AUX_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     CMD_LEN:7;
+unsigned int     reserved_1:10;
+unsigned int     DMY_LEN:6;
+}CMD_DUMMY;
+
+typedef struct 
+{
+unsigned int     RWCMD:1;
+unsigned int     Master_Full_duplex:1;
+unsigned int     ADDR_LEN:8;
+unsigned int     LSBfirst:1;
+unsigned int     SOdualmodeselection:2;
+unsigned int     First_bit_sel:1;
+unsigned int     reserved_0:1;
+unsigned int     Slave_Full_duplex:1;
+unsigned int     WR_LEN:16;
+}SO_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     LSBfirst:1;
+unsigned int     reserved_1:12;
+unsigned int     RD_LEN:16;
+}SI_CTRL;
+
+typedef struct 
+{
+unsigned int     W_FIFO:32;
+}W_FIFO;
+
+typedef struct 
+{
+unsigned int     R_FIFO:32;
+}R_FIFO;
+
+typedef struct 
+{
+unsigned int     SPI_INS:32;
+}INSTRUCTION;
+
+typedef struct 
+{
+unsigned int     SPI_ADDR:32;
+}ADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     R_FIFO_ALMOST_FULL_SEL:1;
+unsigned int     W_FIFO_ALMOST_FULL_SEL:1;
+unsigned int     reserved_1:7;
+unsigned int     FIFO_PTR_RST:1;
+unsigned int     reserved_2:1;
+unsigned int     CONTI_TRANS_EN:1;
+unsigned int     CONTI_TRANS_LAST:1;
+unsigned int     DES_MODE_ENABLE:1;
+unsigned int     reserved_3:2;
+unsigned int     DMA_MODE_ENABLE:1;
+unsigned int     CMD_ENABLE:1;
+}SPI_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     R_FIFO_PTR:5;
+unsigned int     reserved_1:3;
+unsigned int     W_FIFO_PTR:5;
+unsigned int     reserved_2:8;
+unsigned int     reserved_3:6;
+unsigned int     MD_empty:1;
+unsigned int     SFC_BUSY:1;
+}SPI_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     R_FIFO_ALMOST_FULL:1;
+unsigned int     R_FIFO_FULL:1;
+unsigned int     reserved_1:6;
+unsigned int     W_FIFO_ALMOST_EMPTY:1;
+unsigned int     W_FIFO_EMPTY:1;
+unsigned int     reserved_2:8;
+unsigned int     reserved_3:6;
+unsigned int     DES_MODE_DONE:1;
+unsigned int     CMD_DONE:1;
+}SPI_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     R_FIFO_ALMOST_FULL:1;
+unsigned int     R_FIFO_FULL:1;
+unsigned int     reserved_1:6;
+unsigned int     W_FIFO_ALMOST_EMPTY:1;
+unsigned int     W_FIFO_EMPTY:1;
+unsigned int     reserved_2:8;
+unsigned int     reserved_3:6;
+unsigned int     DES_MODE_DONE_IE:1;
+unsigned int     CMD_DONE_IE:1;
+}SPI_INT_EN;
+
+#endif
+
+#define SCK_CTRL                                                                     0x1801B800
+#define SCK_CTRL_reg_addr                                                            "0xB801BD00"
+#define SCK_CTRL_reg                                                                 0xB801BD00
+#define set_SCK_CTRL_reg(data)   (*((volatile unsigned int*) SCK_CTRL_reg)=data)
+#define get_SCK_CTRL_reg   (*((volatile unsigned int*) SCK_CTRL_reg))
+#define SCK_CTRL_inst_adr                                                            "0x0040"
+#define SCK_CTRL_inst                                                                0x0040
+#define SCK_CTRL_sck_divider_shift                                                   (16)
+#define SCK_CTRL_sck_divider_mask                                                    (0x00FF0000)
+#define SCK_CTRL_sck_divider(data)                                                   (0x00FF0000&((data)<<16))
+#define SCK_CTRL_sck_divider_src(data)                                               ((0x00FF0000&(data))>>16)
+#define SCK_CTRL_get_sck_divider(data)                                               ((0x00FF0000&(data))>>16)
+#define SCK_CTRL_phase_shift                                                         (1)
+#define SCK_CTRL_phase_mask                                                          (0x00000002)
+#define SCK_CTRL_phase(data)                                                         (0x00000002&((data)<<1))
+#define SCK_CTRL_phase_src(data)                                                     ((0x00000002&(data))>>1)
+#define SCK_CTRL_get_phase(data)                                                     ((0x00000002&(data))>>1)
+#define SCK_CTRL_polarity_shift                                                      (0)
+#define SCK_CTRL_polarity_mask                                                       (0x00000001)
+#define SCK_CTRL_polarity(data)                                                      (0x00000001&((data)<<0))
+#define SCK_CTRL_polarity_src(data)                                                  ((0x00000001&(data))>>0)
+#define SCK_CTRL_get_polarity(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define CS_TIMING                                                                    0x1801B804
+#define CS_TIMING_reg_addr                                                           "0xB801BD04"
+#define CS_TIMING_reg                                                                0xB801BD04
+#define set_CS_TIMING_reg(data)   (*((volatile unsigned int*) CS_TIMING_reg)=data)
+#define get_CS_TIMING_reg   (*((volatile unsigned int*) CS_TIMING_reg))
+#define CS_TIMING_inst_adr                                                           "0x0041"
+#define CS_TIMING_inst                                                               0x0041
+#define CS_TIMING_Tcs_high_shift                                                     (16)
+#define CS_TIMING_Tcs_high_mask                                                      (0x00FF0000)
+#define CS_TIMING_Tcs_high(data)                                                     (0x00FF0000&((data)<<16))
+#define CS_TIMING_Tcs_high_src(data)                                                 ((0x00FF0000&(data))>>16)
+#define CS_TIMING_get_Tcs_high(data)                                                 ((0x00FF0000&(data))>>16)
+#define CS_TIMING_Tcs_end_shift                                                      (8)
+#define CS_TIMING_Tcs_end_mask                                                       (0x0000FF00)
+#define CS_TIMING_Tcs_end(data)                                                      (0x0000FF00&((data)<<8))
+#define CS_TIMING_Tcs_end_src(data)                                                  ((0x0000FF00&(data))>>8)
+#define CS_TIMING_get_Tcs_end(data)                                                  ((0x0000FF00&(data))>>8)
+#define CS_TIMING_Tcs_start_shift                                                    (0)
+#define CS_TIMING_Tcs_start_mask                                                     (0x000000FF)
+#define CS_TIMING_Tcs_start(data)                                                    (0x000000FF&((data)<<0))
+#define CS_TIMING_Tcs_start_src(data)                                                ((0x000000FF&(data))>>0)
+#define CS_TIMING_get_Tcs_start(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define AUX_CTRL                                                                     0x1801B808
+#define AUX_CTRL_reg_addr                                                            "0xB801BD08"
+#define AUX_CTRL_reg                                                                 0xB801BD08
+#define set_AUX_CTRL_reg(data)   (*((volatile unsigned int*) AUX_CTRL_reg)=data)
+#define get_AUX_CTRL_reg   (*((volatile unsigned int*) AUX_CTRL_reg))
+#define AUX_CTRL_inst_adr                                                            "0x0042"
+#define AUX_CTRL_inst                                                                0x0042
+#define AUX_CTRL_SLAVE_MODE_ENABLE_shift                                             (8)
+#define AUX_CTRL_SLAVE_MODE_ENABLE_mask                                              (0x00000100)
+#define AUX_CTRL_SLAVE_MODE_ENABLE(data)                                             (0x00000100&((data)<<8))
+#define AUX_CTRL_SLAVE_MODE_ENABLE_src(data)                                         ((0x00000100&(data))>>8)
+#define AUX_CTRL_get_SLAVE_MODE_ENABLE(data)                                         ((0x00000100&(data))>>8)
+#define AUX_CTRL_CS_1_ENABLE_shift                                                   (1)
+#define AUX_CTRL_CS_1_ENABLE_mask                                                    (0x00000002)
+#define AUX_CTRL_CS_1_ENABLE(data)                                                   (0x00000002&((data)<<1))
+#define AUX_CTRL_CS_1_ENABLE_src(data)                                               ((0x00000002&(data))>>1)
+#define AUX_CTRL_get_CS_1_ENABLE(data)                                               ((0x00000002&(data))>>1)
+#define AUX_CTRL_CS_0_ENABLE_shift                                                   (0)
+#define AUX_CTRL_CS_0_ENABLE_mask                                                    (0x00000001)
+#define AUX_CTRL_CS_0_ENABLE(data)                                                   (0x00000001&((data)<<0))
+#define AUX_CTRL_CS_0_ENABLE_src(data)                                               ((0x00000001&(data))>>0)
+#define AUX_CTRL_get_CS_0_ENABLE(data)                                               ((0x00000001&(data))>>0)
+
+
+#define CMD_DUMMY                                                                    0x1801B80C
+#define CMD_DUMMY_reg_addr                                                           "0xB801BD0C"
+#define CMD_DUMMY_reg                                                                0xB801BD0C
+#define set_CMD_DUMMY_reg(data)   (*((volatile unsigned int*) CMD_DUMMY_reg)=data)
+#define get_CMD_DUMMY_reg   (*((volatile unsigned int*) CMD_DUMMY_reg))
+#define CMD_DUMMY_inst_adr                                                           "0x0043"
+#define CMD_DUMMY_inst                                                               0x0043
+#define CMD_DUMMY_CMD_LEN_shift                                                      (16)
+#define CMD_DUMMY_CMD_LEN_mask                                                       (0x007F0000)
+#define CMD_DUMMY_CMD_LEN(data)                                                      (0x007F0000&((data)<<16))
+#define CMD_DUMMY_CMD_LEN_src(data)                                                  ((0x007F0000&(data))>>16)
+#define CMD_DUMMY_get_CMD_LEN(data)                                                  ((0x007F0000&(data))>>16)
+#define CMD_DUMMY_DMY_LEN_shift                                                      (0)
+#define CMD_DUMMY_DMY_LEN_mask                                                       (0x0000003F)
+#define CMD_DUMMY_DMY_LEN(data)                                                      (0x0000003F&((data)<<0))
+#define CMD_DUMMY_DMY_LEN_src(data)                                                  ((0x0000003F&(data))>>0)
+#define CMD_DUMMY_get_DMY_LEN(data)                                                  ((0x0000003F&(data))>>0)
+
+
+#define SO_CTRL                                                                      0x1801B810
+#define SO_CTRL_reg_addr                                                             "0xB801BD10"
+#define SO_CTRL_reg                                                                  0xB801BD10
+#define set_SO_CTRL_reg(data)   (*((volatile unsigned int*) SO_CTRL_reg)=data)
+#define get_SO_CTRL_reg   (*((volatile unsigned int*) SO_CTRL_reg))
+#define SO_CTRL_inst_adr                                                             "0x0044"
+#define SO_CTRL_inst                                                                 0x0044
+#define SO_CTRL_RWCMD_shift                                                          (31)
+#define SO_CTRL_RWCMD_mask                                                           (0x80000000)
+#define SO_CTRL_RWCMD(data)                                                          (0x80000000&((data)<<31))
+#define SO_CTRL_RWCMD_src(data)                                                      ((0x80000000&(data))>>31)
+#define SO_CTRL_get_RWCMD(data)                                                      ((0x80000000&(data))>>31)
+#define SO_CTRL_Master_Full_duplex_shift                                             (30)
+#define SO_CTRL_Master_Full_duplex_mask                                              (0x40000000)
+#define SO_CTRL_Master_Full_duplex(data)                                             (0x40000000&((data)<<30))
+#define SO_CTRL_Master_Full_duplex_src(data)                                         ((0x40000000&(data))>>30)
+#define SO_CTRL_get_Master_Full_duplex(data)                                         ((0x40000000&(data))>>30)
+#define SO_CTRL_ADDR_LEN_shift                                                       (22)
+#define SO_CTRL_ADDR_LEN_mask                                                        (0x3FC00000)
+#define SO_CTRL_ADDR_LEN(data)                                                       (0x3FC00000&((data)<<22))
+#define SO_CTRL_ADDR_LEN_src(data)                                                   ((0x3FC00000&(data))>>22)
+#define SO_CTRL_get_ADDR_LEN(data)                                                   ((0x3FC00000&(data))>>22)
+#define SO_CTRL_LSBfirst_shift                                                       (21)
+#define SO_CTRL_LSBfirst_mask                                                        (0x00200000)
+#define SO_CTRL_LSBfirst(data)                                                       (0x00200000&((data)<<21))
+#define SO_CTRL_LSBfirst_src(data)                                                   ((0x00200000&(data))>>21)
+#define SO_CTRL_get_LSBfirst(data)                                                   ((0x00200000&(data))>>21)
+#define SO_CTRL_SOdualmodeselection_shift                                            (19)
+#define SO_CTRL_SOdualmodeselection_mask                                             (0x00180000)
+#define SO_CTRL_SOdualmodeselection(data)                                            (0x00180000&((data)<<19))
+#define SO_CTRL_SOdualmodeselection_src(data)                                        ((0x00180000&(data))>>19)
+#define SO_CTRL_get_SOdualmodeselection(data)                                        ((0x00180000&(data))>>19)
+#define SO_CTRL_First_bit_sel_shift                                                  (18)
+#define SO_CTRL_First_bit_sel_mask                                                   (0x00040000)
+#define SO_CTRL_First_bit_sel(data)                                                  (0x00040000&((data)<<18))
+#define SO_CTRL_First_bit_sel_src(data)                                              ((0x00040000&(data))>>18)
+#define SO_CTRL_get_First_bit_sel(data)                                              ((0x00040000&(data))>>18)
+#define SO_CTRL_Slave_Full_duplex_shift                                              (16)
+#define SO_CTRL_Slave_Full_duplex_mask                                               (0x00010000)
+#define SO_CTRL_Slave_Full_duplex(data)                                              (0x00010000&((data)<<16))
+#define SO_CTRL_Slave_Full_duplex_src(data)                                          ((0x00010000&(data))>>16)
+#define SO_CTRL_get_Slave_Full_duplex(data)                                          ((0x00010000&(data))>>16)
+#define SO_CTRL_WR_LEN_shift                                                         (0)
+#define SO_CTRL_WR_LEN_mask                                                          (0x0000FFFF)
+#define SO_CTRL_WR_LEN(data)                                                         (0x0000FFFF&((data)<<0))
+#define SO_CTRL_WR_LEN_src(data)                                                     ((0x0000FFFF&(data))>>0)
+#define SO_CTRL_get_WR_LEN(data)                                                     ((0x0000FFFF&(data))>>0)
+
+
+#define SI_CTRL                                                                      0x1801B814
+#define SI_CTRL_reg_addr                                                             "0xB801BD14"
+#define SI_CTRL_reg                                                                  0xB801BD14
+#define set_SI_CTRL_reg(data)   (*((volatile unsigned int*) SI_CTRL_reg)=data)
+#define get_SI_CTRL_reg   (*((volatile unsigned int*) SI_CTRL_reg))
+#define SI_CTRL_inst_adr                                                             "0x0045"
+#define SI_CTRL_inst                                                                 0x0045
+#define SI_CTRL_LSBfirst_shift                                                       (28)
+#define SI_CTRL_LSBfirst_mask                                                        (0x10000000)
+#define SI_CTRL_LSBfirst(data)                                                       (0x10000000&((data)<<28))
+#define SI_CTRL_LSBfirst_src(data)                                                   ((0x10000000&(data))>>28)
+#define SI_CTRL_get_LSBfirst(data)                                                   ((0x10000000&(data))>>28)
+#define SI_CTRL_RD_LEN_shift                                                         (0)
+#define SI_CTRL_RD_LEN_mask                                                          (0x0000FFFF)
+#define SI_CTRL_RD_LEN(data)                                                         (0x0000FFFF&((data)<<0))
+#define SI_CTRL_RD_LEN_src(data)                                                     ((0x0000FFFF&(data))>>0)
+#define SI_CTRL_get_RD_LEN(data)                                                     ((0x0000FFFF&(data))>>0)
+
+
+#define W_FIFO                                                                       0x1801B818
+#define W_FIFO_reg_addr                                                              "0xB801BD18"
+#define W_FIFO_reg                                                                   0xB801BD18
+#define set_W_FIFO_reg(data)   (*((volatile unsigned int*) W_FIFO_reg)=data)
+#define get_W_FIFO_reg   (*((volatile unsigned int*) W_FIFO_reg))
+#define W_FIFO_inst_adr                                                              "0x0046"
+#define W_FIFO_inst                                                                  0x0046
+#define W_FIFO_W_FIFO_shift                                                          (0)
+#define W_FIFO_W_FIFO_mask                                                           (0xFFFFFFFF)
+#define W_FIFO_W_FIFO(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define W_FIFO_W_FIFO_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define W_FIFO_get_W_FIFO(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define R_FIFO                                                                       0x1801B81C
+#define R_FIFO_reg_addr                                                              "0xB801BD1C"
+#define R_FIFO_reg                                                                   0xB801BD1C
+#define set_R_FIFO_reg(data)   (*((volatile unsigned int*) R_FIFO_reg)=data)
+#define get_R_FIFO_reg   (*((volatile unsigned int*) R_FIFO_reg))
+#define R_FIFO_inst_adr                                                              "0x0047"
+#define R_FIFO_inst                                                                  0x0047
+#define R_FIFO_R_FIFO_shift                                                          (0)
+#define R_FIFO_R_FIFO_mask                                                           (0xFFFFFFFF)
+#define R_FIFO_R_FIFO(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define R_FIFO_R_FIFO_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define R_FIFO_get_R_FIFO(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define INSTRUCTION                                                                  0x1801B820
+#define INSTRUCTION_reg_addr                                                         "0xB801BD20"
+#define INSTRUCTION_reg                                                              0xB801BD20
+#define set_INSTRUCTION_reg(data)   (*((volatile unsigned int*) INSTRUCTION_reg)=data)
+#define get_INSTRUCTION_reg   (*((volatile unsigned int*) INSTRUCTION_reg))
+#define INSTRUCTION_inst_adr                                                         "0x0048"
+#define INSTRUCTION_inst                                                             0x0048
+#define INSTRUCTION_SPI_INS_shift                                                    (0)
+#define INSTRUCTION_SPI_INS_mask                                                     (0xFFFFFFFF)
+#define INSTRUCTION_SPI_INS(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define INSTRUCTION_SPI_INS_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define INSTRUCTION_get_SPI_INS(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define ADDR                                                                         0x1801B824
+#define ADDR_reg_addr                                                                "0xB801BD24"
+#define ADDR_reg                                                                     0xB801BD24
+#define set_ADDR_reg(data)   (*((volatile unsigned int*) ADDR_reg)=data)
+#define get_ADDR_reg   (*((volatile unsigned int*) ADDR_reg))
+#define ADDR_inst_adr                                                                "0x0049"
+#define ADDR_inst                                                                    0x0049
+#define ADDR_SPI_ADDR_shift                                                          (0)
+#define ADDR_SPI_ADDR_mask                                                           (0xFFFFFFFF)
+#define ADDR_SPI_ADDR(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define ADDR_SPI_ADDR_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define ADDR_get_SPI_ADDR(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define SPI_CTRL                                                                     0x1801B828
+#define SPI_CTRL_reg_addr                                                            "0xB801BD28"
+#define SPI_CTRL_reg                                                                 0xB801BD28
+#define set_SPI_CTRL_reg(data)   (*((volatile unsigned int*) SPI_CTRL_reg)=data)
+#define get_SPI_CTRL_reg   (*((volatile unsigned int*) SPI_CTRL_reg))
+#define SPI_CTRL_inst_adr                                                            "0x004A"
+#define SPI_CTRL_inst                                                                0x004A
+#define SPI_CTRL_R_FIFO_ALMOST_FULL_SEL_shift                                        (17)
+#define SPI_CTRL_R_FIFO_ALMOST_FULL_SEL_mask                                         (0x00020000)
+#define SPI_CTRL_R_FIFO_ALMOST_FULL_SEL(data)                                        (0x00020000&((data)<<17))
+#define SPI_CTRL_R_FIFO_ALMOST_FULL_SEL_src(data)                                    ((0x00020000&(data))>>17)
+#define SPI_CTRL_get_R_FIFO_ALMOST_FULL_SEL(data)                                    ((0x00020000&(data))>>17)
+#define SPI_CTRL_W_FIFO_ALMOST_FULL_SEL_shift                                        (16)
+#define SPI_CTRL_W_FIFO_ALMOST_FULL_SEL_mask                                         (0x00010000)
+#define SPI_CTRL_W_FIFO_ALMOST_FULL_SEL(data)                                        (0x00010000&((data)<<16))
+#define SPI_CTRL_W_FIFO_ALMOST_FULL_SEL_src(data)                                    ((0x00010000&(data))>>16)
+#define SPI_CTRL_get_W_FIFO_ALMOST_FULL_SEL(data)                                    ((0x00010000&(data))>>16)
+#define SPI_CTRL_FIFO_PTR_RST_shift                                                  (8)
+#define SPI_CTRL_FIFO_PTR_RST_mask                                                   (0x00000100)
+#define SPI_CTRL_FIFO_PTR_RST(data)                                                  (0x00000100&((data)<<8))
+#define SPI_CTRL_FIFO_PTR_RST_src(data)                                              ((0x00000100&(data))>>8)
+#define SPI_CTRL_get_FIFO_PTR_RST(data)                                              ((0x00000100&(data))>>8)
+#define SPI_CTRL_CONTI_TRANS_EN_shift                                                (6)
+#define SPI_CTRL_CONTI_TRANS_EN_mask                                                 (0x00000040)
+#define SPI_CTRL_CONTI_TRANS_EN(data)                                                (0x00000040&((data)<<6))
+#define SPI_CTRL_CONTI_TRANS_EN_src(data)                                            ((0x00000040&(data))>>6)
+#define SPI_CTRL_get_CONTI_TRANS_EN(data)                                            ((0x00000040&(data))>>6)
+#define SPI_CTRL_CONTI_TRANS_LAST_shift                                              (5)
+#define SPI_CTRL_CONTI_TRANS_LAST_mask                                               (0x00000020)
+#define SPI_CTRL_CONTI_TRANS_LAST(data)                                              (0x00000020&((data)<<5))
+#define SPI_CTRL_CONTI_TRANS_LAST_src(data)                                          ((0x00000020&(data))>>5)
+#define SPI_CTRL_get_CONTI_TRANS_LAST(data)                                          ((0x00000020&(data))>>5)
+#define SPI_CTRL_DES_MODE_ENABLE_shift                                               (4)
+#define SPI_CTRL_DES_MODE_ENABLE_mask                                                (0x00000010)
+#define SPI_CTRL_DES_MODE_ENABLE(data)                                               (0x00000010&((data)<<4))
+#define SPI_CTRL_DES_MODE_ENABLE_src(data)                                           ((0x00000010&(data))>>4)
+#define SPI_CTRL_get_DES_MODE_ENABLE(data)                                           ((0x00000010&(data))>>4)
+#define SPI_CTRL_DMA_MODE_ENABLE_shift                                               (1)
+#define SPI_CTRL_DMA_MODE_ENABLE_mask                                                (0x00000002)
+#define SPI_CTRL_DMA_MODE_ENABLE(data)                                               (0x00000002&((data)<<1))
+#define SPI_CTRL_DMA_MODE_ENABLE_src(data)                                           ((0x00000002&(data))>>1)
+#define SPI_CTRL_get_DMA_MODE_ENABLE(data)                                           ((0x00000002&(data))>>1)
+#define SPI_CTRL_CMD_ENABLE_shift                                                    (0)
+#define SPI_CTRL_CMD_ENABLE_mask                                                     (0x00000001)
+#define SPI_CTRL_CMD_ENABLE(data)                                                    (0x00000001&((data)<<0))
+#define SPI_CTRL_CMD_ENABLE_src(data)                                                ((0x00000001&(data))>>0)
+#define SPI_CTRL_get_CMD_ENABLE(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SPI_STATUS                                                                   0x1801B82C
+#define SPI_STATUS_reg_addr                                                          "0xB801BD2C"
+#define SPI_STATUS_reg                                                               0xB801BD2C
+#define set_SPI_STATUS_reg(data)   (*((volatile unsigned int*) SPI_STATUS_reg)=data)
+#define get_SPI_STATUS_reg   (*((volatile unsigned int*) SPI_STATUS_reg))
+#define SPI_STATUS_inst_adr                                                          "0x004B"
+#define SPI_STATUS_inst                                                              0x004B
+#define SPI_STATUS_R_FIFO_PTR_shift                                                  (24)
+#define SPI_STATUS_R_FIFO_PTR_mask                                                   (0x1F000000)
+#define SPI_STATUS_R_FIFO_PTR(data)                                                  (0x1F000000&((data)<<24))
+#define SPI_STATUS_R_FIFO_PTR_src(data)                                              ((0x1F000000&(data))>>24)
+#define SPI_STATUS_get_R_FIFO_PTR(data)                                              ((0x1F000000&(data))>>24)
+#define SPI_STATUS_W_FIFO_PTR_shift                                                  (16)
+#define SPI_STATUS_W_FIFO_PTR_mask                                                   (0x001F0000)
+#define SPI_STATUS_W_FIFO_PTR(data)                                                  (0x001F0000&((data)<<16))
+#define SPI_STATUS_W_FIFO_PTR_src(data)                                              ((0x001F0000&(data))>>16)
+#define SPI_STATUS_get_W_FIFO_PTR(data)                                              ((0x001F0000&(data))>>16)
+#define SPI_STATUS_MD_empty_shift                                                    (1)
+#define SPI_STATUS_MD_empty_mask                                                     (0x00000002)
+#define SPI_STATUS_MD_empty(data)                                                    (0x00000002&((data)<<1))
+#define SPI_STATUS_MD_empty_src(data)                                                ((0x00000002&(data))>>1)
+#define SPI_STATUS_get_MD_empty(data)                                                ((0x00000002&(data))>>1)
+#define SPI_STATUS_SFC_BUSY_shift                                                    (0)
+#define SPI_STATUS_SFC_BUSY_mask                                                     (0x00000001)
+#define SPI_STATUS_SFC_BUSY(data)                                                    (0x00000001&((data)<<0))
+#define SPI_STATUS_SFC_BUSY_src(data)                                                ((0x00000001&(data))>>0)
+#define SPI_STATUS_get_SFC_BUSY(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SPI_INT                                                                      0x1801B830
+#define SPI_INT_reg_addr                                                             "0xB801BD30"
+#define SPI_INT_reg                                                                  0xB801BD30
+#define set_SPI_INT_reg(data)   (*((volatile unsigned int*) SPI_INT_reg)=data)
+#define get_SPI_INT_reg   (*((volatile unsigned int*) SPI_INT_reg))
+#define SPI_INT_inst_adr                                                             "0x004C"
+#define SPI_INT_inst                                                                 0x004C
+#define SPI_INT_R_FIFO_ALMOST_FULL_shift                                             (25)
+#define SPI_INT_R_FIFO_ALMOST_FULL_mask                                              (0x02000000)
+#define SPI_INT_R_FIFO_ALMOST_FULL(data)                                             (0x02000000&((data)<<25))
+#define SPI_INT_R_FIFO_ALMOST_FULL_src(data)                                         ((0x02000000&(data))>>25)
+#define SPI_INT_get_R_FIFO_ALMOST_FULL(data)                                         ((0x02000000&(data))>>25)
+#define SPI_INT_R_FIFO_FULL_shift                                                    (24)
+#define SPI_INT_R_FIFO_FULL_mask                                                     (0x01000000)
+#define SPI_INT_R_FIFO_FULL(data)                                                    (0x01000000&((data)<<24))
+#define SPI_INT_R_FIFO_FULL_src(data)                                                ((0x01000000&(data))>>24)
+#define SPI_INT_get_R_FIFO_FULL(data)                                                ((0x01000000&(data))>>24)
+#define SPI_INT_W_FIFO_ALMOST_EMPTY_shift                                            (17)
+#define SPI_INT_W_FIFO_ALMOST_EMPTY_mask                                             (0x00020000)
+#define SPI_INT_W_FIFO_ALMOST_EMPTY(data)                                            (0x00020000&((data)<<17))
+#define SPI_INT_W_FIFO_ALMOST_EMPTY_src(data)                                        ((0x00020000&(data))>>17)
+#define SPI_INT_get_W_FIFO_ALMOST_EMPTY(data)                                        ((0x00020000&(data))>>17)
+#define SPI_INT_W_FIFO_EMPTY_shift                                                   (16)
+#define SPI_INT_W_FIFO_EMPTY_mask                                                    (0x00010000)
+#define SPI_INT_W_FIFO_EMPTY(data)                                                   (0x00010000&((data)<<16))
+#define SPI_INT_W_FIFO_EMPTY_src(data)                                               ((0x00010000&(data))>>16)
+#define SPI_INT_get_W_FIFO_EMPTY(data)                                               ((0x00010000&(data))>>16)
+#define SPI_INT_DES_MODE_DONE_shift                                                  (1)
+#define SPI_INT_DES_MODE_DONE_mask                                                   (0x00000002)
+#define SPI_INT_DES_MODE_DONE(data)                                                  (0x00000002&((data)<<1))
+#define SPI_INT_DES_MODE_DONE_src(data)                                              ((0x00000002&(data))>>1)
+#define SPI_INT_get_DES_MODE_DONE(data)                                              ((0x00000002&(data))>>1)
+#define SPI_INT_CMD_DONE_shift                                                       (0)
+#define SPI_INT_CMD_DONE_mask                                                        (0x00000001)
+#define SPI_INT_CMD_DONE(data)                                                       (0x00000001&((data)<<0))
+#define SPI_INT_CMD_DONE_src(data)                                                   ((0x00000001&(data))>>0)
+#define SPI_INT_get_CMD_DONE(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define SPI_INT_EN                                                                   0x1801B834
+#define SPI_INT_EN_reg_addr                                                          "0xB801BD34"
+#define SPI_INT_EN_reg                                                               0xB801BD34
+#define set_SPI_INT_EN_reg(data)   (*((volatile unsigned int*) SPI_INT_EN_reg)=data)
+#define get_SPI_INT_EN_reg   (*((volatile unsigned int*) SPI_INT_EN_reg))
+#define SPI_INT_EN_inst_adr                                                          "0x004D"
+#define SPI_INT_EN_inst                                                              0x004D
+#define SPI_INT_EN_R_FIFO_ALMOST_FULL_shift                                          (25)
+#define SPI_INT_EN_R_FIFO_ALMOST_FULL_mask                                           (0x02000000)
+#define SPI_INT_EN_R_FIFO_ALMOST_FULL(data)                                          (0x02000000&((data)<<25))
+#define SPI_INT_EN_R_FIFO_ALMOST_FULL_src(data)                                      ((0x02000000&(data))>>25)
+#define SPI_INT_EN_get_R_FIFO_ALMOST_FULL(data)                                      ((0x02000000&(data))>>25)
+#define SPI_INT_EN_R_FIFO_FULL_shift                                                 (24)
+#define SPI_INT_EN_R_FIFO_FULL_mask                                                  (0x01000000)
+#define SPI_INT_EN_R_FIFO_FULL(data)                                                 (0x01000000&((data)<<24))
+#define SPI_INT_EN_R_FIFO_FULL_src(data)                                             ((0x01000000&(data))>>24)
+#define SPI_INT_EN_get_R_FIFO_FULL(data)                                             ((0x01000000&(data))>>24)
+#define SPI_INT_EN_W_FIFO_ALMOST_EMPTY_shift                                         (17)
+#define SPI_INT_EN_W_FIFO_ALMOST_EMPTY_mask                                          (0x00020000)
+#define SPI_INT_EN_W_FIFO_ALMOST_EMPTY(data)                                         (0x00020000&((data)<<17))
+#define SPI_INT_EN_W_FIFO_ALMOST_EMPTY_src(data)                                     ((0x00020000&(data))>>17)
+#define SPI_INT_EN_get_W_FIFO_ALMOST_EMPTY(data)                                     ((0x00020000&(data))>>17)
+#define SPI_INT_EN_W_FIFO_EMPTY_shift                                                (16)
+#define SPI_INT_EN_W_FIFO_EMPTY_mask                                                 (0x00010000)
+#define SPI_INT_EN_W_FIFO_EMPTY(data)                                                (0x00010000&((data)<<16))
+#define SPI_INT_EN_W_FIFO_EMPTY_src(data)                                            ((0x00010000&(data))>>16)
+#define SPI_INT_EN_get_W_FIFO_EMPTY(data)                                            ((0x00010000&(data))>>16)
+#define SPI_INT_EN_DES_MODE_DONE_IE_shift                                            (1)
+#define SPI_INT_EN_DES_MODE_DONE_IE_mask                                             (0x00000002)
+#define SPI_INT_EN_DES_MODE_DONE_IE(data)                                            (0x00000002&((data)<<1))
+#define SPI_INT_EN_DES_MODE_DONE_IE_src(data)                                        ((0x00000002&(data))>>1)
+#define SPI_INT_EN_get_DES_MODE_DONE_IE(data)                                        ((0x00000002&(data))>>1)
+#define SPI_INT_EN_CMD_DONE_IE_shift                                                 (0)
+#define SPI_INT_EN_CMD_DONE_IE_mask                                                  (0x00000001)
+#define SPI_INT_EN_CMD_DONE_IE(data)                                                 (0x00000001&((data)<<0))
+#define SPI_INT_EN_CMD_DONE_IE_src(data)                                             ((0x00000001&(data))>>0)
+#define SPI_INT_EN_get_CMD_DONE_IE(data)                                             ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/hdmi_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/hdmi_reg.h
new file mode 100644
index 00000000..c861c82
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/hdmi_reg.h
@@ -0,0 +1,4861 @@
+/**************************************************************
+// Spec Version                  : 1.0
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/6/6 9:53:22
+***************************************************************/
+
+
+#ifndef _HDMI_REG_H_INCLUDED_
+#define _HDMI_REG_H_INCLUDED_
+#ifdef  _HDMI_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     rxsenseint:1;
+unsigned int     enriupdint:1;
+unsigned int     enpjupdint:1;
+unsigned int     write_data:1;
+}HDMI_INTEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     vendint:1;
+unsigned int     vsyncint:1;
+unsigned int     write_data:1;
+}HDMI_INTENV;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     asfifo_empty:1;
+unsigned int     asfifo_full:1;
+unsigned int     owctshw:1;
+unsigned int     asfifoow:1;
+unsigned int     write_data:1;
+}HDMI_AUDIO_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     rxupdated:1;
+unsigned int     riupdated:1;
+unsigned int     pjupdated:1;
+}HDMI_INTST;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     vendupdated:1;
+unsigned int     vsyncupdated:1;
+}HDMI_INTSTV;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     wdout:1;
+unsigned int     Rxstatus:1;
+}HDMI_PHY_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_en2:1;
+unsigned int     rirate:8;
+unsigned int     write_en1:1;
+unsigned int     pjrate:8;
+}HDMI_UPDATE_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     sram_shut_down_en:1;
+unsigned int     sram_sleep_en:1;
+unsigned int     video_sd:1;
+unsigned int     Interlaced_vfmt:1;
+unsigned int     3D_video_format:4;
+unsigned int     En_3D:1;
+unsigned int     timing_gen_en:1;
+unsigned int     chl_sel:2;
+}HDMI_CHNL_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c1:17;
+}HDMI_CS_TRANS0;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c2:17;
+}HDMI_CS_TRANS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c3:17;
+}HDMI_CS_TRANS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c4:17;
+}HDMI_CS_TRANS3;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c5:17;
+}HDMI_CS_TRANS4;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c6:17;
+}HDMI_CS_TRANS5;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c7:17;
+}HDMI_CS_TRANS6;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c8:17;
+}HDMI_CS_TRANS7;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     c9:17;
+}HDMI_CS_TRANS8;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     k1:16;
+}HDMI_CS_TRANS9;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     k2:16;
+}HDMI_CS_TRANS10;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     k3:16;
+}HDMI_CS_TRANS11;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en2:1;
+unsigned int     ygmax:12;
+unsigned int     reserved_1:3;
+unsigned int     write_en1:1;
+unsigned int     ygmin:12;
+}HDMI_CS_TRANS12;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en2:1;
+unsigned int     cbbmax:12;
+unsigned int     reserved_1:3;
+unsigned int     write_en1:1;
+unsigned int     cbbmin:12;
+}HDMI_CS_TRANS13;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en2:1;
+unsigned int     crrmax:12;
+unsigned int     reserved_1:3;
+unsigned int     write_en1:1;
+unsigned int     crrmin:12;
+}HDMI_CS_TRANS14;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en4:1;
+unsigned int     nor_v:2;
+unsigned int     write_en3:1;
+unsigned int     nor_h:2;
+unsigned int     write_en2:1;
+unsigned int     disp_v:2;
+unsigned int     write_en1:1;
+unsigned int     disp_h:2;
+}HDMI_SYNC_DLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     write_en3:1;
+unsigned int     tmds_encen:1;
+unsigned int     write_en2:1;
+unsigned int     enablehdcp:1;
+unsigned int     write_en1:1;
+unsigned int     enablehdmi:1;
+}HDMI_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en9:1;
+unsigned int     dp_vfch_num:2;
+unsigned int     reserved_1:2;
+unsigned int     write_en8:1;
+unsigned int     fp_swen:1;
+unsigned int     write_en7:1;
+unsigned int     fp:3;
+unsigned int     write_en6:1;
+unsigned int     pp_swen:1;
+unsigned int     reserved_2:2;
+unsigned int     write_en4:1;
+unsigned int     dp_swen:1;
+unsigned int     write_en3:1;
+unsigned int     default_phase:1;
+unsigned int     reserved_3:3;
+unsigned int     write_en2:1;
+unsigned int     color_depth:4;
+unsigned int     reserved_4:2;
+unsigned int     write_en1:1;
+unsigned int     dpc_enable:1;
+}HDMI_DPC;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_en2:1;
+unsigned int     dp_vfch:1;
+unsigned int     reserved_1:3;
+unsigned int     write_en1:1;
+unsigned int     pp:4;
+}HDMI_DPC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     tmds_ch2_out:10;
+unsigned int     tmds_ch1_out:10;
+unsigned int     tmds_ch0_out:10;
+}HDMI_TMDS_EODR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     default_phase_st:1;
+unsigned int     reserved_1:2;
+unsigned int     tmds_clk_out:10;
+}HDMI_TMDS_EODR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     REG_LDO_PLL_VSEL:3;
+unsigned int     REG_LDO_PLL_PU:1;
+unsigned int     REG_LDO_CCO_VSEL:2;
+unsigned int     REG_LDO_CCO_PU:1;
+unsigned int     REG_TX_CK5XP_DUTY:2;
+unsigned int     REG_TX_CK5XN_DUTY:2;
+unsigned int     REG_TX_AMP:4;
+unsigned int     REG_TX_IBIAS:2;
+unsigned int     REG_TX_EMPH:3;
+unsigned int     REG_TX_EN_EMPH:1;
+unsigned int     REG_TX_FORCE_VC:1;
+unsigned int     REG_TX_SET_VC:2;
+unsigned int     REG_TX_PLL_EDGE:1;
+unsigned int     REG_TX_PLL_ICP:3;
+unsigned int     REG_TX_PLL_RS:3;
+}HDMI_TMDS_SCR1;
+
+typedef struct 
+{
+unsigned int     REG_TX_V1P05_SEL:2;
+unsigned int     REG_TX_PDRV_ISEL:2;
+unsigned int     REG_TX_PLL_KVCO:1;
+unsigned int     REG_TX_PLL_CS:2;
+unsigned int     REG_TX_PLL_CP:2;
+unsigned int     REG_TX_PLL_PU:1;
+unsigned int     REG_TX_PU:4;
+unsigned int     REG_TX_DRIVER:2;
+unsigned int     REG_TX_SLEW:2;
+unsigned int     REG_TX_TST_EN:1;
+unsigned int     REG_TX_VGATE:3;
+unsigned int     REG_PLL_TST_EN:1;
+unsigned int     REG_TST_SEL:2;
+unsigned int     REG_TX_BYPASS_PLL:1;
+unsigned int     REG_TX_RT_EN:1;
+unsigned int     REG_TX_RT_SEL:2;
+unsigned int     REG_PLL_VCO_SCALE:2;
+unsigned int     REG_BYPASS_DIN:1;
+}HDMI_TMDS_SCR2;
+
+typedef struct 
+{
+unsigned int     REG_TX_PLL_WDMODE:2;
+unsigned int     REG_RESERVE:16;
+unsigned int     REG_CEC_ENB:1;
+unsigned int     REG_EN_MHL:1;
+unsigned int     REG_FORCE_RXSENSE:1;
+unsigned int     REG_RXSENSE:2;
+unsigned int     REG_MHL_DIV:1;
+unsigned int     REG_MHL_VCM:2;
+unsigned int     REG_DIFF_RT_EN:1;
+unsigned int     REG_CABLE_DET_EN:1;
+unsigned int     REG_LDO_TMDS_VSEL20:3;
+unsigned int     REG_LDO_TMDS_CAPSEL:1;
+}HDMI_TMDS_SCR3;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     REG_TV_WDMODE:2;
+unsigned int     REG_TV_KVCO:1;
+unsigned int     REG_TV_CS:2;
+unsigned int     REG_TV_CP:2;
+unsigned int     REG_TV_ICP:3;
+unsigned int     REG_TV_RS:3;
+unsigned int     REG_TV_BYPASS_PLL:1;
+unsigned int     REG_TV_FORCE_VC:1;
+unsigned int     REG_TV_SET_VC:2;
+unsigned int     REG_TV_TST_EN:1;
+}HDMI_TVPLL_CTRL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     REGO_TV_WDOUT:1;
+unsigned int     REGO_TX_PLL_WDOUT:1;
+unsigned int     REGO_TX_PLL_LOCK:1;
+unsigned int     REGO_CABLE_DETECT:8;
+unsigned int     REGO_TV_PLL_LOCK:1;
+}HDMI_MHL_CBUS;
+
+typedef struct 
+{
+unsigned int     tmds1ten:1;
+unsigned int     td1src:1;
+unsigned int     reserved_0:4;
+unsigned int     tmds1td:10;
+unsigned int     tmds0ten:1;
+unsigned int     td0src:1;
+unsigned int     reserved_1:4;
+unsigned int     tmds0td:10;
+}HDMI_TMDS_STR0;
+
+typedef struct 
+{
+unsigned int     tmdscten:1;
+unsigned int     tdcsrc:1;
+unsigned int     reserved_0:4;
+unsigned int     tmdsctd:10;
+unsigned int     tmds2ten:1;
+unsigned int     td2src:1;
+unsigned int     reserved_1:4;
+unsigned int     tmds2td:10;
+}HDMI_TMDS_STR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en8:1;
+unsigned int     ycbcr422_8bits:1;
+unsigned int     write_en7:1;
+unsigned int     cts_pkt_hp:1;
+unsigned int     write_en6:1;
+unsigned int     Audioheader0:8;
+unsigned int     write_en5:1;
+unsigned int     samplepresent:4;
+unsigned int     write_en4:1;
+unsigned int     forcesamplepresent:1;
+unsigned int     write_en3:1;
+unsigned int     b_frame:4;
+unsigned int     write_en2:1;
+unsigned int     forceb_frame:1;
+unsigned int     write_en1:1;
+unsigned int     audiolayout:1;
+}HDMI_ASPCR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_en4:1;
+unsigned int     hdmi_pk3map:3;
+unsigned int     write_en3:1;
+unsigned int     hdmi_pk2map:3;
+unsigned int     write_en2:1;
+unsigned int     hdmi_pk1map:3;
+unsigned int     write_en1:1;
+unsigned int     hdmi_pk0map:3;
+}HDMI_ACACR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en6:1;
+unsigned int     Audio_info_hp:1;
+unsigned int     write_en5:1;
+unsigned int     ac_hw_ctrl_en:1;
+unsigned int     write_en4:1;
+unsigned int     fs_div4:1;
+unsigned int     write_en3:1;
+unsigned int     disablecrp:1;
+unsigned int     write_en2:1;
+unsigned int     cts_source:1;
+unsigned int     write_en1:1;
+unsigned int     n_value:20;
+}HDMI_ACRPCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     ctssw:20;
+}HDMI_ACRPCTSR;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     ctshw:20;
+}HDMI_ACRPPR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     enablegcp:1;
+unsigned int     gcp_clearavmute:1;
+unsigned int     gcp_setavmute:1;
+unsigned int     write_data:1;
+}HDMI_GCPCR;
+
+typedef struct 
+{
+unsigned int     once_pkt:32;
+}HDMI_ORP6PH;
+
+typedef struct 
+{
+unsigned int     once_pkt:32;
+}HDMI_ORP6W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en6:1;
+unsigned int     prp5period:4;
+unsigned int     write_en5:1;
+unsigned int     prp4period:4;
+unsigned int     write_en4:1;
+unsigned int     prp3period:4;
+unsigned int     write_en3:1;
+unsigned int     prp2period:4;
+unsigned int     write_en2:1;
+unsigned int     prp1period:4;
+unsigned int     write_en1:1;
+unsigned int     prp0period:4;
+}HDMI_RPCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     enprpkt5:1;
+unsigned int     enprpkt4:1;
+unsigned int     enprpkt3:1;
+unsigned int     enprpkt2:1;
+unsigned int     enprpkt1:1;
+unsigned int     enprpkt0:1;
+unsigned int     write_data:1;
+}HDMI_RPEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     isramrbd:18;
+}HDMI_RPRBDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     write_en4:1;
+unsigned int     enrbpktsram:1;
+unsigned int     write_en3:1;
+unsigned int     wrdes:1;
+unsigned int     write_en2:1;
+unsigned int     rprwcmd:1;
+unsigned int     write_en1:1;
+unsigned int     rpadd:8;
+}HDMI_OPCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en2:1;
+unsigned int     vbidipcnt:5;
+unsigned int     write_en1:1;
+unsigned int     hbidipcnt:5;
+}HDMI_DIPCCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en12:1;
+unsigned int     color_transform_en:1;
+unsigned int     write_en11:1;
+unsigned int     ycbcr422_algo:1;
+unsigned int     write_en10:1;
+unsigned int     422_pixel_repeat:1;
+unsigned int     write_en9:1;
+unsigned int     vsyncpolin:1;
+unsigned int     write_en8:1;
+unsigned int     hsyncpolin:1;
+unsigned int     write_en7:1;
+unsigned int     vsyncpolinv:1;
+unsigned int     write_en6:1;
+unsigned int     hsyncpolinv:1;
+unsigned int     write_en5:1;
+unsigned int     pixelencycbcr422:1;
+unsigned int     write_en4:1;
+unsigned int     hdmi_videoxs:5;
+unsigned int     write_en3:1;
+unsigned int     pixelencfmt:2;
+unsigned int     write_en2:1;
+unsigned int     pixelrepeat:1;
+unsigned int     write_en1:1;
+unsigned int     hdmi_modesel:1;
+}HDMI_SCHCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en3:1;
+unsigned int     enaudio:1;
+unsigned int     write_en2:1;
+unsigned int     envitd:1;
+unsigned int     write_en1:1;
+unsigned int     vitd:24;
+}HDMI_ICR;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     write_en1:1;
+unsigned int     vitd:12;
+}HDMI_ICR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     write_en2:1;
+unsigned int     crcmode:1;
+unsigned int     write_en1:1;
+unsigned int     crcchsel:2;
+}HDMI_CRCCR;
+
+typedef struct 
+{
+unsigned int     crcvalue:32;
+}HDMI_CRCDOR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     hdcprekeykeepoutwin:8;
+}HDMI_HDCP_KOWR;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     hdcpverkeepoutwinend:12;
+unsigned int     write_en1:1;
+unsigned int     hdcpvertkeepoutwinstart:12;
+}HDMI_HDCP_KOWRSE;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     hdcpoppwinend:12;
+unsigned int     write_en1:1;
+unsigned int     hdcpoppwinstart:12;
+}HDMI_HDCP_OWR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     write_en4:1;
+unsigned int     en1_1_feature:1;
+unsigned int     write_en3:1;
+unsigned int     downstrisrepeater:1;
+unsigned int     write_en2:1;
+unsigned int     aninfluencemode:1;
+unsigned int     write_en1:1;
+unsigned int     hdcp_encryptenable:1;
+}HDMI_HDCP_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_en9:1;
+unsigned int     ddpken:1;
+unsigned int     write_en8:1;
+unsigned int     resetkmacc:1;
+unsigned int     write_en7:1;
+unsigned int     update_an:1;
+unsigned int     write_en6:1;
+unsigned int     aninfreq:1;
+unsigned int     write_en5:1;
+unsigned int     seedload:1;
+unsigned int     write_en4:1;
+unsigned int     deviceauthenticated:1;
+unsigned int     write_en3:1;
+unsigned int     forcetounauthenticated:1;
+unsigned int     write_en2:1;
+unsigned int     authcompute:1;
+unsigned int     write_en1:1;
+unsigned int     authrequest:1;
+}HDMI_HDCP_AUTH;
+
+typedef struct 
+{
+unsigned int     hdcpcipherstate:8;
+unsigned int     reserved_0:20;
+unsigned int     curdpkaccdone:1;
+unsigned int     hdcp_encrypt_status:1;
+unsigned int     authenticatedok:1;
+unsigned int     anready:1;
+}HDMI_HDCP_SR;
+
+typedef struct 
+{
+unsigned int     anlsw:32;
+}HDMI_HDCP_ANLR;
+
+typedef struct 
+{
+unsigned int     anmsw:32;
+}HDMI_HDCP_ANMR;
+
+typedef struct 
+{
+unsigned int     aninfluencelsw:32;
+}HDMI_HDCP_ANILR;
+
+typedef struct 
+{
+unsigned int     aninfluencemsw:32;
+}HDMI_HDCP_ANIMR;
+
+typedef struct 
+{
+unsigned int     ddpklsb24:24;
+unsigned int     dpkencpnt:8;
+}HDMI_HDCP_DPKLR;
+
+typedef struct 
+{
+unsigned int     ddpkmsw:32;
+}HDMI_HDCP_DPKMR;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ri:16;
+unsigned int     pj:8;
+}HDMI_HDCP_LIR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     shastart:1;
+unsigned int     shafirst:1;
+unsigned int     rstshaptr:1;
+unsigned int     write_data:1;
+}HDMI_HDCP_SHACR;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     vmatch:1;
+unsigned int     shaready:1;
+}HDMI_HDCP_SHARR;
+
+typedef struct 
+{
+unsigned int     sha_data:32;
+}HDMI_HDCP_SHADR;
+
+typedef struct 
+{
+unsigned int     milsw:32;
+}HDMI_HDCP_MILSW;
+
+typedef struct 
+{
+unsigned int     mimsw:32;
+}HDMI_HDCP_MIMSW;
+
+typedef struct 
+{
+unsigned int     kmlsw:32;
+}HDMI_HDCP_KMLSW;
+
+typedef struct 
+{
+unsigned int     kmmsw:32;
+}HDMI_HDCP_KMMSW;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_en5:1;
+unsigned int     pkt_vdo_cnt_add:1;
+unsigned int     write_en4:1;
+unsigned int     hdcp_2_2_en:1;
+unsigned int     write_en3:1;
+unsigned int     aes_sw_en:1;
+unsigned int     write_en2:1;
+unsigned int     aes_sw_start1:1;
+unsigned int     write_en1:1;
+unsigned int     aes_sw_start2:1;
+}HDMI_HDCP_2_2_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     rgs_sw_done_1:1;
+unsigned int     rgs_sw_done_2:1;
+}HDMI_HDCP_2_2_STATUS;
+
+typedef struct 
+{
+unsigned int     sw_data_1_1:32;
+}HDMI_HDCP_2_2_SW_DATA_1_1;
+
+typedef struct 
+{
+unsigned int     sw_data_1_2:32;
+}HDMI_HDCP_2_2_SW_DATA_1_2;
+
+typedef struct 
+{
+unsigned int     sw_data_1_3:32;
+}HDMI_HDCP_2_2_SW_DATA_1_3;
+
+typedef struct 
+{
+unsigned int     sw_data_1_4:32;
+}HDMI_HDCP_2_2_SW_DATA_1_4;
+
+typedef struct 
+{
+unsigned int     sw_data_2_1:32;
+}HDMI_HDCP_2_2_SW_DATA_2_1;
+
+typedef struct 
+{
+unsigned int     sw_data_2_2:32;
+}HDMI_HDCP_2_2_SW_DATA_2_2;
+
+typedef struct 
+{
+unsigned int     sw_data_2_3:32;
+}HDMI_HDCP_2_2_SW_DATA_2_3;
+
+typedef struct 
+{
+unsigned int     sw_data_2_4:32;
+}HDMI_HDCP_2_2_SW_DATA_2_4;
+
+typedef struct 
+{
+unsigned int     sw_key_1_1:32;
+}HDMI_HDCP_2_2_SW_KEY_1_1;
+
+typedef struct 
+{
+unsigned int     sw_key_1_2:32;
+}HDMI_HDCP_2_2_SW_KEY_1_2;
+
+typedef struct 
+{
+unsigned int     sw_key_1_3:32;
+}HDMI_HDCP_2_2_SW_KEY_1_3;
+
+typedef struct 
+{
+unsigned int     sw_key_1_4:32;
+}HDMI_HDCP_2_2_SW_KEY_1_4;
+
+typedef struct 
+{
+unsigned int     sw_key_2_1:32;
+}HDMI_HDCP_2_2_SW_KEY_2_1;
+
+typedef struct 
+{
+unsigned int     sw_key_2_2:32;
+}HDMI_HDCP_2_2_SW_KEY_2_2;
+
+typedef struct 
+{
+unsigned int     sw_key_2_3:32;
+}HDMI_HDCP_2_2_SW_KEY_2_3;
+
+typedef struct 
+{
+unsigned int     sw_key_2_4:32;
+}HDMI_HDCP_2_2_SW_KEY_2_4;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_1_1:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_1_1;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_1_2:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_1_2;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_1_3:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_1_3;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_1_4:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_1_4;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_2_1:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_2_1;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_2_2:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_2_2;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_2_3:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_2_3;
+
+typedef struct 
+{
+unsigned int     sw_data_xor_2_4:32;
+}HDMI_HDCP_2_2_SW_DATA_XOR_2_4;
+
+typedef struct 
+{
+unsigned int     data_out_1_1:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_1_1;
+
+typedef struct 
+{
+unsigned int     data_out_1_2:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_1_2;
+
+typedef struct 
+{
+unsigned int     data_out_1_3:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_1_3;
+
+typedef struct 
+{
+unsigned int     data_out_1_4:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_1_4;
+
+typedef struct 
+{
+unsigned int     data_out_2_1:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_2_1;
+
+typedef struct 
+{
+unsigned int     data_out_2_2:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_2_2;
+
+typedef struct 
+{
+unsigned int     data_out_2_3:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_2_3;
+
+typedef struct 
+{
+unsigned int     data_out_2_4:32;
+}HDMI_HDCP_2_2_SW_DATA_OUT_2_4;
+
+typedef struct 
+{
+unsigned int     hw_riv_1_1:32;
+}HDMI_HDCP_2_2_HW_RIV_1;
+
+typedef struct 
+{
+unsigned int     hw_riv_1_2:32;
+}HDMI_HDCP_2_2_HW_RIV_2;
+
+typedef struct 
+{
+unsigned int     frame_num_1:32;
+}HDMI_HDCP_2_2_HW_FRAME_NUM_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     frame_num_2:6;
+}HDMI_HDCP_2_2_HW_FRAME_NUM_2;
+
+typedef struct 
+{
+unsigned int     frame_num_add_1:32;
+}HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     frame_num_add_2:6;
+}HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     data_num:26;
+}HDMI_HDCP_2_2_HW_DATA_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     data_num_add:26;
+}HDMI_HDCP_2_2_HW_DATA_NUM_ADD;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     chsel0:4;
+unsigned int     chsel1:4;
+}HDMI_DBG;
+
+typedef struct 
+{
+unsigned int     dummy:32;
+}HDMI_DUMMY;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     test_mode:1;
+unsigned int     data_realign:1;
+}HDMI_PHY;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hblank:14;
+unsigned int     reserved_1:2;
+unsigned int     hactive:14;
+}HDMI_H_PARA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hsync:14;
+unsigned int     reserved_1:2;
+unsigned int     hfront:14;
+}HDMI_H_PARA2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     hback:14;
+}HDMI_H_PARA3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vact_video:14;
+unsigned int     reserved_1:2;
+unsigned int     vactive:14;
+}HDMI_V_PARA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vact_space1:14;
+unsigned int     reserved_1:2;
+unsigned int     Vact_space:14;
+}HDMI_V_PARA2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vblank3:14;
+unsigned int     reserved_1:2;
+unsigned int     Vact_space2:14;
+}HDMI_V_PARA3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vsync:14;
+unsigned int     reserved_1:2;
+unsigned int     vblank:14;
+}HDMI_V_PARA4;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vback:14;
+unsigned int     reserved_1:2;
+unsigned int     vfront:14;
+}HDMI_V_PARA5;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vsync1:14;
+unsigned int     reserved_1:2;
+unsigned int     Vblank1:14;
+}HDMI_V_PARA6;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vback1:14;
+unsigned int     reserved_1:2;
+unsigned int     Vfront1:14;
+}HDMI_V_PARA7;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vsync2:14;
+unsigned int     reserved_1:2;
+unsigned int     Vblank2:14;
+}HDMI_V_PARA8;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     Vback2:14;
+unsigned int     reserved_1:2;
+unsigned int     Vfront2:14;
+}HDMI_V_PARA9;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vsynci:14;
+unsigned int     reserved_1:2;
+unsigned int     vblanki:14;
+}HDMI_V_PARA12;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vbacki:14;
+unsigned int     reserved_1:2;
+unsigned int     vfronti:14;
+}HDMI_V_PARA13;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     G:12;
+}HDMI_V_PARA10;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     B:12;
+unsigned int     reserved_1:4;
+unsigned int     R:12;
+}HDMI_V_PARA11;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dft_test_resume:1;
+unsigned int     dft_bist_mode:1;
+unsigned int     bist_mode:1;
+unsigned int     rme:1;
+unsigned int     rm:4;
+}HDMI_BIST1_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dft_test_resume:1;
+unsigned int     dft_bist_mode:1;
+unsigned int     bist_mode:1;
+unsigned int     rme:1;
+unsigned int     rm:4;
+}HDMI_BIST2_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     bist1_fail0:1;
+unsigned int     bist1_done:1;
+}HDMI_BIST1_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_bist1_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_bist1_fail0:1;
+unsigned int     drf_bist1_done:1;
+}HDMI_DRF_BIST1_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     bist2_fail0:1;
+unsigned int     bist2_done:1;
+}HDMI_BIST2_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_bist2_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_bist2_fail0:1;
+unsigned int     drf_bist2_done:1;
+}HDMI_DRF_BIST2_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en5:1;
+unsigned int     mhl_phy_test_mode:1;
+unsigned int     write_en4:1;
+unsigned int     xor_pixel_sel:3;
+unsigned int     write_en3:1;
+unsigned int     mhl_enc_sel:1;
+unsigned int     write_en2:1;
+unsigned int     mhl_pp_mode:1;
+unsigned int     write_en1:1;
+unsigned int     mhl_enable:1;
+}HDMI_MHLCTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     write_en3:1;
+unsigned int     mhl_ch_sel:1;
+unsigned int     write_en2:1;
+unsigned int     hdmi_chcclk_swap:1;
+unsigned int     write_en1:1;
+unsigned int     hdmi_chab_swap:1;
+}HDMI_CHSWAP;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     write_en2:1;
+unsigned int     hdmi_prefifo_inv:1;
+unsigned int     write_en1:1;
+unsigned int     async_update:1;
+}HDMI_PREFIFO_CTRL;
+
+#endif
+
+#define HDMI_INTEN                                                                   0x1800D000
+#define HDMI_INTEN_reg_addr                                                          "0xB800D000"
+#define HDMI_INTEN_reg                                                               0xB800D000
+#define set_HDMI_INTEN_reg(data)   (*((volatile unsigned int*) HDMI_INTEN_reg)=data)
+#define get_HDMI_INTEN_reg   (*((volatile unsigned int*) HDMI_INTEN_reg))
+#define HDMI_INTEN_inst_adr                                                          "0x0000"
+#define HDMI_INTEN_inst                                                              0x0000
+#define HDMI_INTEN_rxsenseint_shift                                                  (3)
+#define HDMI_INTEN_rxsenseint_mask                                                   (0x00000008)
+#define HDMI_INTEN_rxsenseint(data)                                                  (0x00000008&((data)<<3))
+#define HDMI_INTEN_rxsenseint_src(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_INTEN_get_rxsenseint(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_INTEN_enriupdint_shift                                                  (2)
+#define HDMI_INTEN_enriupdint_mask                                                   (0x00000004)
+#define HDMI_INTEN_enriupdint(data)                                                  (0x00000004&((data)<<2))
+#define HDMI_INTEN_enriupdint_src(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_INTEN_get_enriupdint(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_INTEN_enpjupdint_shift                                                  (1)
+#define HDMI_INTEN_enpjupdint_mask                                                   (0x00000002)
+#define HDMI_INTEN_enpjupdint(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_INTEN_enpjupdint_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_INTEN_get_enpjupdint(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_INTEN_write_data_shift                                                  (0)
+#define HDMI_INTEN_write_data_mask                                                   (0x00000001)
+#define HDMI_INTEN_write_data(data)                                                  (0x00000001&((data)<<0))
+#define HDMI_INTEN_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define HDMI_INTEN_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define HDMI_INTENV                                                                  0x1800D274
+#define HDMI_INTENV_reg_addr                                                         "0xB800D274"
+#define HDMI_INTENV_reg                                                              0xB800D274
+#define set_HDMI_INTENV_reg(data)   (*((volatile unsigned int*) HDMI_INTENV_reg)=data)
+#define get_HDMI_INTENV_reg   (*((volatile unsigned int*) HDMI_INTENV_reg))
+#define HDMI_INTENV_inst_adr                                                         "0x009D"
+#define HDMI_INTENV_inst                                                             0x009D
+#define HDMI_INTENV_vendint_shift                                                    (2)
+#define HDMI_INTENV_vendint_mask                                                     (0x00000004)
+#define HDMI_INTENV_vendint(data)                                                    (0x00000004&((data)<<2))
+#define HDMI_INTENV_vendint_src(data)                                                ((0x00000004&(data))>>2)
+#define HDMI_INTENV_get_vendint(data)                                                ((0x00000004&(data))>>2)
+#define HDMI_INTENV_vsyncint_shift                                                   (1)
+#define HDMI_INTENV_vsyncint_mask                                                    (0x00000002)
+#define HDMI_INTENV_vsyncint(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_INTENV_vsyncint_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTENV_get_vsyncint(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTENV_write_data_shift                                                 (0)
+#define HDMI_INTENV_write_data_mask                                                  (0x00000001)
+#define HDMI_INTENV_write_data(data)                                                 (0x00000001&((data)<<0))
+#define HDMI_INTENV_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define HDMI_INTENV_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define HDMI_AUDIO_ST                                                                0x1800D004
+#define HDMI_AUDIO_ST_reg_addr                                                       "0xB800D004"
+#define HDMI_AUDIO_ST_reg                                                            0xB800D004
+#define set_HDMI_AUDIO_ST_reg(data)   (*((volatile unsigned int*) HDMI_AUDIO_ST_reg)=data)
+#define get_HDMI_AUDIO_ST_reg   (*((volatile unsigned int*) HDMI_AUDIO_ST_reg))
+#define HDMI_AUDIO_ST_inst_adr                                                       "0x0001"
+#define HDMI_AUDIO_ST_inst                                                           0x0001
+#define HDMI_AUDIO_ST_asfifo_empty_shift                                             (4)
+#define HDMI_AUDIO_ST_asfifo_empty_mask                                              (0x00000010)
+#define HDMI_AUDIO_ST_asfifo_empty(data)                                             (0x00000010&((data)<<4))
+#define HDMI_AUDIO_ST_asfifo_empty_src(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_AUDIO_ST_get_asfifo_empty(data)                                         ((0x00000010&(data))>>4)
+#define HDMI_AUDIO_ST_asfifo_full_shift                                              (3)
+#define HDMI_AUDIO_ST_asfifo_full_mask                                               (0x00000008)
+#define HDMI_AUDIO_ST_asfifo_full(data)                                              (0x00000008&((data)<<3))
+#define HDMI_AUDIO_ST_asfifo_full_src(data)                                          ((0x00000008&(data))>>3)
+#define HDMI_AUDIO_ST_get_asfifo_full(data)                                          ((0x00000008&(data))>>3)
+#define HDMI_AUDIO_ST_owctshw_shift                                                  (2)
+#define HDMI_AUDIO_ST_owctshw_mask                                                   (0x00000004)
+#define HDMI_AUDIO_ST_owctshw(data)                                                  (0x00000004&((data)<<2))
+#define HDMI_AUDIO_ST_owctshw_src(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_AUDIO_ST_get_owctshw(data)                                              ((0x00000004&(data))>>2)
+#define HDMI_AUDIO_ST_asfifoow_shift                                                 (1)
+#define HDMI_AUDIO_ST_asfifoow_mask                                                  (0x00000002)
+#define HDMI_AUDIO_ST_asfifoow(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_AUDIO_ST_asfifoow_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_AUDIO_ST_get_asfifoow(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_AUDIO_ST_write_data_shift                                               (0)
+#define HDMI_AUDIO_ST_write_data_mask                                                (0x00000001)
+#define HDMI_AUDIO_ST_write_data(data)                                               (0x00000001&((data)<<0))
+#define HDMI_AUDIO_ST_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_AUDIO_ST_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_INTST                                                                   0x1800D008
+#define HDMI_INTST_reg_addr                                                          "0xB800D008"
+#define HDMI_INTST_reg                                                               0xB800D008
+#define set_HDMI_INTST_reg(data)   (*((volatile unsigned int*) HDMI_INTST_reg)=data)
+#define get_HDMI_INTST_reg   (*((volatile unsigned int*) HDMI_INTST_reg))
+#define HDMI_INTST_inst_adr                                                          "0x0002"
+#define HDMI_INTST_inst                                                              0x0002
+#define HDMI_INTST_rxupdated_shift                                                   (2)
+#define HDMI_INTST_rxupdated_mask                                                    (0x00000004)
+#define HDMI_INTST_rxupdated(data)                                                   (0x00000004&((data)<<2))
+#define HDMI_INTST_rxupdated_src(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_INTST_get_rxupdated(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_INTST_riupdated_shift                                                   (1)
+#define HDMI_INTST_riupdated_mask                                                    (0x00000002)
+#define HDMI_INTST_riupdated(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_INTST_riupdated_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTST_get_riupdated(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_INTST_pjupdated_shift                                                   (0)
+#define HDMI_INTST_pjupdated_mask                                                    (0x00000001)
+#define HDMI_INTST_pjupdated(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_INTST_pjupdated_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_INTST_get_pjupdated(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_INTSTV                                                                  0x1800D278
+#define HDMI_INTSTV_reg_addr                                                         "0xB800D278"
+#define HDMI_INTSTV_reg                                                              0xB800D278
+#define set_HDMI_INTSTV_reg(data)   (*((volatile unsigned int*) HDMI_INTSTV_reg)=data)
+#define get_HDMI_INTSTV_reg   (*((volatile unsigned int*) HDMI_INTSTV_reg))
+#define HDMI_INTSTV_inst_adr                                                         "0x009E"
+#define HDMI_INTSTV_inst                                                             0x009E
+#define HDMI_INTSTV_vendupdated_shift                                                (1)
+#define HDMI_INTSTV_vendupdated_mask                                                 (0x00000002)
+#define HDMI_INTSTV_vendupdated(data)                                                (0x00000002&((data)<<1))
+#define HDMI_INTSTV_vendupdated_src(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_INTSTV_get_vendupdated(data)                                            ((0x00000002&(data))>>1)
+#define HDMI_INTSTV_vsyncupdated_shift                                               (0)
+#define HDMI_INTSTV_vsyncupdated_mask                                                (0x00000001)
+#define HDMI_INTSTV_vsyncupdated(data)                                               (0x00000001&((data)<<0))
+#define HDMI_INTSTV_vsyncupdated_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_INTSTV_get_vsyncupdated(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_PHY_STATUS                                                              0x1800D15c
+#define HDMI_PHY_STATUS_reg_addr                                                     "0xB800D15C"
+#define HDMI_PHY_STATUS_reg                                                          0xB800D15C
+#define set_HDMI_PHY_STATUS_reg(data)   (*((volatile unsigned int*) HDMI_PHY_STATUS_reg)=data)
+#define get_HDMI_PHY_STATUS_reg   (*((volatile unsigned int*) HDMI_PHY_STATUS_reg))
+#define HDMI_PHY_STATUS_inst_adr                                                     "0x0057"
+#define HDMI_PHY_STATUS_inst                                                         0x0057
+#define HDMI_PHY_STATUS_wdout_shift                                                  (1)
+#define HDMI_PHY_STATUS_wdout_mask                                                   (0x00000002)
+#define HDMI_PHY_STATUS_wdout(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_PHY_STATUS_wdout_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_PHY_STATUS_get_wdout(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_PHY_STATUS_Rxstatus_shift                                               (0)
+#define HDMI_PHY_STATUS_Rxstatus_mask                                                (0x00000001)
+#define HDMI_PHY_STATUS_Rxstatus(data)                                               (0x00000001&((data)<<0))
+#define HDMI_PHY_STATUS_Rxstatus_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_PHY_STATUS_get_Rxstatus(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_UPDATE_ST                                                               0x1800D00c
+#define HDMI_UPDATE_ST_reg_addr                                                      "0xB800D00C"
+#define HDMI_UPDATE_ST_reg                                                           0xB800D00C
+#define set_HDMI_UPDATE_ST_reg(data)   (*((volatile unsigned int*) HDMI_UPDATE_ST_reg)=data)
+#define get_HDMI_UPDATE_ST_reg   (*((volatile unsigned int*) HDMI_UPDATE_ST_reg))
+#define HDMI_UPDATE_ST_inst_adr                                                      "0x0003"
+#define HDMI_UPDATE_ST_inst                                                          0x0003
+#define HDMI_UPDATE_ST_write_en2_shift                                               (17)
+#define HDMI_UPDATE_ST_write_en2_mask                                                (0x00020000)
+#define HDMI_UPDATE_ST_write_en2(data)                                               (0x00020000&((data)<<17))
+#define HDMI_UPDATE_ST_write_en2_src(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_UPDATE_ST_get_write_en2(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_UPDATE_ST_rirate_shift                                                  (9)
+#define HDMI_UPDATE_ST_rirate_mask                                                   (0x0001FE00)
+#define HDMI_UPDATE_ST_rirate(data)                                                  (0x0001FE00&((data)<<9))
+#define HDMI_UPDATE_ST_rirate_src(data)                                              ((0x0001FE00&(data))>>9)
+#define HDMI_UPDATE_ST_get_rirate(data)                                              ((0x0001FE00&(data))>>9)
+#define HDMI_UPDATE_ST_write_en1_shift                                               (8)
+#define HDMI_UPDATE_ST_write_en1_mask                                                (0x00000100)
+#define HDMI_UPDATE_ST_write_en1(data)                                               (0x00000100&((data)<<8))
+#define HDMI_UPDATE_ST_write_en1_src(data)                                           ((0x00000100&(data))>>8)
+#define HDMI_UPDATE_ST_get_write_en1(data)                                           ((0x00000100&(data))>>8)
+#define HDMI_UPDATE_ST_pjrate_shift                                                  (0)
+#define HDMI_UPDATE_ST_pjrate_mask                                                   (0x000000FF)
+#define HDMI_UPDATE_ST_pjrate(data)                                                  (0x000000FF&((data)<<0))
+#define HDMI_UPDATE_ST_pjrate_src(data)                                              ((0x000000FF&(data))>>0)
+#define HDMI_UPDATE_ST_get_pjrate(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define HDMI_CHNL_SEL                                                                0x1800D020
+#define HDMI_CHNL_SEL_reg_addr                                                       "0xB800D020"
+#define HDMI_CHNL_SEL_reg                                                            0xB800D020
+#define set_HDMI_CHNL_SEL_reg(data)   (*((volatile unsigned int*) HDMI_CHNL_SEL_reg)=data)
+#define get_HDMI_CHNL_SEL_reg   (*((volatile unsigned int*) HDMI_CHNL_SEL_reg))
+#define HDMI_CHNL_SEL_inst_adr                                                       "0x0008"
+#define HDMI_CHNL_SEL_inst                                                           0x0008
+#define HDMI_CHNL_SEL_sram_shut_down_en_shift                                        (11)
+#define HDMI_CHNL_SEL_sram_shut_down_en_mask                                         (0x00000800)
+#define HDMI_CHNL_SEL_sram_shut_down_en(data)                                        (0x00000800&((data)<<11))
+#define HDMI_CHNL_SEL_sram_shut_down_en_src(data)                                    ((0x00000800&(data))>>11)
+#define HDMI_CHNL_SEL_get_sram_shut_down_en(data)                                    ((0x00000800&(data))>>11)
+#define HDMI_CHNL_SEL_sram_sleep_en_shift                                            (10)
+#define HDMI_CHNL_SEL_sram_sleep_en_mask                                             (0x00000400)
+#define HDMI_CHNL_SEL_sram_sleep_en(data)                                            (0x00000400&((data)<<10))
+#define HDMI_CHNL_SEL_sram_sleep_en_src(data)                                        ((0x00000400&(data))>>10)
+#define HDMI_CHNL_SEL_get_sram_sleep_en(data)                                        ((0x00000400&(data))>>10)
+#define HDMI_CHNL_SEL_video_sd_shift                                                 (9)
+#define HDMI_CHNL_SEL_video_sd_mask                                                  (0x00000200)
+#define HDMI_CHNL_SEL_video_sd(data)                                                 (0x00000200&((data)<<9))
+#define HDMI_CHNL_SEL_video_sd_src(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_CHNL_SEL_get_video_sd(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_CHNL_SEL_Interlaced_vfmt_shift                                          (8)
+#define HDMI_CHNL_SEL_Interlaced_vfmt_mask                                           (0x00000100)
+#define HDMI_CHNL_SEL_Interlaced_vfmt(data)                                          (0x00000100&((data)<<8))
+#define HDMI_CHNL_SEL_Interlaced_vfmt_src(data)                                      ((0x00000100&(data))>>8)
+#define HDMI_CHNL_SEL_get_Interlaced_vfmt(data)                                      ((0x00000100&(data))>>8)
+#define HDMI_CHNL_SEL_3D_video_format_shift                                          (4)
+#define HDMI_CHNL_SEL_3D_video_format_mask                                           (0x000000F0)
+#define HDMI_CHNL_SEL_3D_video_format(data)                                          (0x000000F0&((data)<<4))
+#define HDMI_CHNL_SEL_3D_video_format_src(data)                                      ((0x000000F0&(data))>>4)
+#define HDMI_CHNL_SEL_get_3D_video_format(data)                                      ((0x000000F0&(data))>>4)
+#define HDMI_CHNL_SEL_En_3D_shift                                                    (3)
+#define HDMI_CHNL_SEL_En_3D_mask                                                     (0x00000008)
+#define HDMI_CHNL_SEL_En_3D(data)                                                    (0x00000008&((data)<<3))
+#define HDMI_CHNL_SEL_En_3D_src(data)                                                ((0x00000008&(data))>>3)
+#define HDMI_CHNL_SEL_get_En_3D(data)                                                ((0x00000008&(data))>>3)
+#define HDMI_CHNL_SEL_timing_gen_en_shift                                            (2)
+#define HDMI_CHNL_SEL_timing_gen_en_mask                                             (0x00000004)
+#define HDMI_CHNL_SEL_timing_gen_en(data)                                            (0x00000004&((data)<<2))
+#define HDMI_CHNL_SEL_timing_gen_en_src(data)                                        ((0x00000004&(data))>>2)
+#define HDMI_CHNL_SEL_get_timing_gen_en(data)                                        ((0x00000004&(data))>>2)
+#define HDMI_CHNL_SEL_chl_sel_shift                                                  (0)
+#define HDMI_CHNL_SEL_chl_sel_mask                                                   (0x00000003)
+#define HDMI_CHNL_SEL_chl_sel(data)                                                  (0x00000003&((data)<<0))
+#define HDMI_CHNL_SEL_chl_sel_src(data)                                              ((0x00000003&(data))>>0)
+#define HDMI_CHNL_SEL_get_chl_sel(data)                                              ((0x00000003&(data))>>0)
+
+
+#define HDMI_CS_TRANS0                                                               0x1800D024
+#define HDMI_CS_TRANS0_reg_addr                                                      "0xB800D024"
+#define HDMI_CS_TRANS0_reg                                                           0xB800D024
+#define set_HDMI_CS_TRANS0_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS0_reg)=data)
+#define get_HDMI_CS_TRANS0_reg   (*((volatile unsigned int*) HDMI_CS_TRANS0_reg))
+#define HDMI_CS_TRANS0_inst_adr                                                      "0x0009"
+#define HDMI_CS_TRANS0_inst                                                          0x0009
+#define HDMI_CS_TRANS0_c1_shift                                                      (0)
+#define HDMI_CS_TRANS0_c1_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS0_c1(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS0_c1_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS0_get_c1(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS1                                                               0x1800D028
+#define HDMI_CS_TRANS1_reg_addr                                                      "0xB800D028"
+#define HDMI_CS_TRANS1_reg                                                           0xB800D028
+#define set_HDMI_CS_TRANS1_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS1_reg)=data)
+#define get_HDMI_CS_TRANS1_reg   (*((volatile unsigned int*) HDMI_CS_TRANS1_reg))
+#define HDMI_CS_TRANS1_inst_adr                                                      "0x000A"
+#define HDMI_CS_TRANS1_inst                                                          0x000A
+#define HDMI_CS_TRANS1_c2_shift                                                      (0)
+#define HDMI_CS_TRANS1_c2_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS1_c2(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS1_c2_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS1_get_c2(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS2                                                               0x1800D02c
+#define HDMI_CS_TRANS2_reg_addr                                                      "0xB800D02C"
+#define HDMI_CS_TRANS2_reg                                                           0xB800D02C
+#define set_HDMI_CS_TRANS2_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS2_reg)=data)
+#define get_HDMI_CS_TRANS2_reg   (*((volatile unsigned int*) HDMI_CS_TRANS2_reg))
+#define HDMI_CS_TRANS2_inst_adr                                                      "0x000B"
+#define HDMI_CS_TRANS2_inst                                                          0x000B
+#define HDMI_CS_TRANS2_c3_shift                                                      (0)
+#define HDMI_CS_TRANS2_c3_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS2_c3(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS2_c3_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS2_get_c3(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS3                                                               0x1800D200
+#define HDMI_CS_TRANS3_reg_addr                                                      "0xB800D200"
+#define HDMI_CS_TRANS3_reg                                                           0xB800D200
+#define set_HDMI_CS_TRANS3_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS3_reg)=data)
+#define get_HDMI_CS_TRANS3_reg   (*((volatile unsigned int*) HDMI_CS_TRANS3_reg))
+#define HDMI_CS_TRANS3_inst_adr                                                      "0x0080"
+#define HDMI_CS_TRANS3_inst                                                          0x0080
+#define HDMI_CS_TRANS3_c4_shift                                                      (0)
+#define HDMI_CS_TRANS3_c4_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS3_c4(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS3_c4_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS3_get_c4(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS4                                                               0x1800D204
+#define HDMI_CS_TRANS4_reg_addr                                                      "0xB800D204"
+#define HDMI_CS_TRANS4_reg                                                           0xB800D204
+#define set_HDMI_CS_TRANS4_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS4_reg)=data)
+#define get_HDMI_CS_TRANS4_reg   (*((volatile unsigned int*) HDMI_CS_TRANS4_reg))
+#define HDMI_CS_TRANS4_inst_adr                                                      "0x0081"
+#define HDMI_CS_TRANS4_inst                                                          0x0081
+#define HDMI_CS_TRANS4_c5_shift                                                      (0)
+#define HDMI_CS_TRANS4_c5_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS4_c5(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS4_c5_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS4_get_c5(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS5                                                               0x1800D208
+#define HDMI_CS_TRANS5_reg_addr                                                      "0xB800D208"
+#define HDMI_CS_TRANS5_reg                                                           0xB800D208
+#define set_HDMI_CS_TRANS5_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS5_reg)=data)
+#define get_HDMI_CS_TRANS5_reg   (*((volatile unsigned int*) HDMI_CS_TRANS5_reg))
+#define HDMI_CS_TRANS5_inst_adr                                                      "0x0082"
+#define HDMI_CS_TRANS5_inst                                                          0x0082
+#define HDMI_CS_TRANS5_c6_shift                                                      (0)
+#define HDMI_CS_TRANS5_c6_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS5_c6(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS5_c6_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS5_get_c6(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS6                                                               0x1800D20c
+#define HDMI_CS_TRANS6_reg_addr                                                      "0xB800D20C"
+#define HDMI_CS_TRANS6_reg                                                           0xB800D20C
+#define set_HDMI_CS_TRANS6_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS6_reg)=data)
+#define get_HDMI_CS_TRANS6_reg   (*((volatile unsigned int*) HDMI_CS_TRANS6_reg))
+#define HDMI_CS_TRANS6_inst_adr                                                      "0x0083"
+#define HDMI_CS_TRANS6_inst                                                          0x0083
+#define HDMI_CS_TRANS6_c7_shift                                                      (0)
+#define HDMI_CS_TRANS6_c7_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS6_c7(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS6_c7_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS6_get_c7(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS7                                                               0x1800D210
+#define HDMI_CS_TRANS7_reg_addr                                                      "0xB800D210"
+#define HDMI_CS_TRANS7_reg                                                           0xB800D210
+#define set_HDMI_CS_TRANS7_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS7_reg)=data)
+#define get_HDMI_CS_TRANS7_reg   (*((volatile unsigned int*) HDMI_CS_TRANS7_reg))
+#define HDMI_CS_TRANS7_inst_adr                                                      "0x0084"
+#define HDMI_CS_TRANS7_inst                                                          0x0084
+#define HDMI_CS_TRANS7_c8_shift                                                      (0)
+#define HDMI_CS_TRANS7_c8_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS7_c8(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS7_c8_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS7_get_c8(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS8                                                               0x1800D214
+#define HDMI_CS_TRANS8_reg_addr                                                      "0xB800D214"
+#define HDMI_CS_TRANS8_reg                                                           0xB800D214
+#define set_HDMI_CS_TRANS8_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS8_reg)=data)
+#define get_HDMI_CS_TRANS8_reg   (*((volatile unsigned int*) HDMI_CS_TRANS8_reg))
+#define HDMI_CS_TRANS8_inst_adr                                                      "0x0085"
+#define HDMI_CS_TRANS8_inst                                                          0x0085
+#define HDMI_CS_TRANS8_c9_shift                                                      (0)
+#define HDMI_CS_TRANS8_c9_mask                                                       (0x0001FFFF)
+#define HDMI_CS_TRANS8_c9(data)                                                      (0x0001FFFF&((data)<<0))
+#define HDMI_CS_TRANS8_c9_src(data)                                                  ((0x0001FFFF&(data))>>0)
+#define HDMI_CS_TRANS8_get_c9(data)                                                  ((0x0001FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS9                                                               0x1800D218
+#define HDMI_CS_TRANS9_reg_addr                                                      "0xB800D218"
+#define HDMI_CS_TRANS9_reg                                                           0xB800D218
+#define set_HDMI_CS_TRANS9_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS9_reg)=data)
+#define get_HDMI_CS_TRANS9_reg   (*((volatile unsigned int*) HDMI_CS_TRANS9_reg))
+#define HDMI_CS_TRANS9_inst_adr                                                      "0x0086"
+#define HDMI_CS_TRANS9_inst                                                          0x0086
+#define HDMI_CS_TRANS9_k1_shift                                                      (0)
+#define HDMI_CS_TRANS9_k1_mask                                                       (0x0000FFFF)
+#define HDMI_CS_TRANS9_k1(data)                                                      (0x0000FFFF&((data)<<0))
+#define HDMI_CS_TRANS9_k1_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define HDMI_CS_TRANS9_get_k1(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS10                                                              0x1800D21c
+#define HDMI_CS_TRANS10_reg_addr                                                     "0xB800D21C"
+#define HDMI_CS_TRANS10_reg                                                          0xB800D21C
+#define set_HDMI_CS_TRANS10_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS10_reg)=data)
+#define get_HDMI_CS_TRANS10_reg   (*((volatile unsigned int*) HDMI_CS_TRANS10_reg))
+#define HDMI_CS_TRANS10_inst_adr                                                     "0x0087"
+#define HDMI_CS_TRANS10_inst                                                         0x0087
+#define HDMI_CS_TRANS10_k2_shift                                                     (0)
+#define HDMI_CS_TRANS10_k2_mask                                                      (0x0000FFFF)
+#define HDMI_CS_TRANS10_k2(data)                                                     (0x0000FFFF&((data)<<0))
+#define HDMI_CS_TRANS10_k2_src(data)                                                 ((0x0000FFFF&(data))>>0)
+#define HDMI_CS_TRANS10_get_k2(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS11                                                              0x1800D220
+#define HDMI_CS_TRANS11_reg_addr                                                     "0xB800D220"
+#define HDMI_CS_TRANS11_reg                                                          0xB800D220
+#define set_HDMI_CS_TRANS11_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS11_reg)=data)
+#define get_HDMI_CS_TRANS11_reg   (*((volatile unsigned int*) HDMI_CS_TRANS11_reg))
+#define HDMI_CS_TRANS11_inst_adr                                                     "0x0088"
+#define HDMI_CS_TRANS11_inst                                                         0x0088
+#define HDMI_CS_TRANS11_k3_shift                                                     (0)
+#define HDMI_CS_TRANS11_k3_mask                                                      (0x0000FFFF)
+#define HDMI_CS_TRANS11_k3(data)                                                     (0x0000FFFF&((data)<<0))
+#define HDMI_CS_TRANS11_k3_src(data)                                                 ((0x0000FFFF&(data))>>0)
+#define HDMI_CS_TRANS11_get_k3(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS12                                                              0x1800D224
+#define HDMI_CS_TRANS12_reg_addr                                                     "0xB800D224"
+#define HDMI_CS_TRANS12_reg                                                          0xB800D224
+#define set_HDMI_CS_TRANS12_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS12_reg)=data)
+#define get_HDMI_CS_TRANS12_reg   (*((volatile unsigned int*) HDMI_CS_TRANS12_reg))
+#define HDMI_CS_TRANS12_inst_adr                                                     "0x0089"
+#define HDMI_CS_TRANS12_inst                                                         0x0089
+#define HDMI_CS_TRANS12_write_en2_shift                                              (28)
+#define HDMI_CS_TRANS12_write_en2_mask                                               (0x10000000)
+#define HDMI_CS_TRANS12_write_en2(data)                                              (0x10000000&((data)<<28))
+#define HDMI_CS_TRANS12_write_en2_src(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS12_get_write_en2(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS12_ygmax_shift                                                  (16)
+#define HDMI_CS_TRANS12_ygmax_mask                                                   (0x0FFF0000)
+#define HDMI_CS_TRANS12_ygmax(data)                                                  (0x0FFF0000&((data)<<16))
+#define HDMI_CS_TRANS12_ygmax_src(data)                                              ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS12_get_ygmax(data)                                              ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS12_write_en1_shift                                              (12)
+#define HDMI_CS_TRANS12_write_en1_mask                                               (0x00001000)
+#define HDMI_CS_TRANS12_write_en1(data)                                              (0x00001000&((data)<<12))
+#define HDMI_CS_TRANS12_write_en1_src(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS12_get_write_en1(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS12_ygmin_shift                                                  (0)
+#define HDMI_CS_TRANS12_ygmin_mask                                                   (0x00000FFF)
+#define HDMI_CS_TRANS12_ygmin(data)                                                  (0x00000FFF&((data)<<0))
+#define HDMI_CS_TRANS12_ygmin_src(data)                                              ((0x00000FFF&(data))>>0)
+#define HDMI_CS_TRANS12_get_ygmin(data)                                              ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS13                                                              0x1800D228
+#define HDMI_CS_TRANS13_reg_addr                                                     "0xB800D228"
+#define HDMI_CS_TRANS13_reg                                                          0xB800D228
+#define set_HDMI_CS_TRANS13_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS13_reg)=data)
+#define get_HDMI_CS_TRANS13_reg   (*((volatile unsigned int*) HDMI_CS_TRANS13_reg))
+#define HDMI_CS_TRANS13_inst_adr                                                     "0x008A"
+#define HDMI_CS_TRANS13_inst                                                         0x008A
+#define HDMI_CS_TRANS13_write_en2_shift                                              (28)
+#define HDMI_CS_TRANS13_write_en2_mask                                               (0x10000000)
+#define HDMI_CS_TRANS13_write_en2(data)                                              (0x10000000&((data)<<28))
+#define HDMI_CS_TRANS13_write_en2_src(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS13_get_write_en2(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS13_cbbmax_shift                                                 (16)
+#define HDMI_CS_TRANS13_cbbmax_mask                                                  (0x0FFF0000)
+#define HDMI_CS_TRANS13_cbbmax(data)                                                 (0x0FFF0000&((data)<<16))
+#define HDMI_CS_TRANS13_cbbmax_src(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS13_get_cbbmax(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS13_write_en1_shift                                              (12)
+#define HDMI_CS_TRANS13_write_en1_mask                                               (0x00001000)
+#define HDMI_CS_TRANS13_write_en1(data)                                              (0x00001000&((data)<<12))
+#define HDMI_CS_TRANS13_write_en1_src(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS13_get_write_en1(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS13_cbbmin_shift                                                 (0)
+#define HDMI_CS_TRANS13_cbbmin_mask                                                  (0x00000FFF)
+#define HDMI_CS_TRANS13_cbbmin(data)                                                 (0x00000FFF&((data)<<0))
+#define HDMI_CS_TRANS13_cbbmin_src(data)                                             ((0x00000FFF&(data))>>0)
+#define HDMI_CS_TRANS13_get_cbbmin(data)                                             ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_CS_TRANS14                                                              0x1800D22c
+#define HDMI_CS_TRANS14_reg_addr                                                     "0xB800D22C"
+#define HDMI_CS_TRANS14_reg                                                          0xB800D22C
+#define set_HDMI_CS_TRANS14_reg(data)   (*((volatile unsigned int*) HDMI_CS_TRANS14_reg)=data)
+#define get_HDMI_CS_TRANS14_reg   (*((volatile unsigned int*) HDMI_CS_TRANS14_reg))
+#define HDMI_CS_TRANS14_inst_adr                                                     "0x008B"
+#define HDMI_CS_TRANS14_inst                                                         0x008B
+#define HDMI_CS_TRANS14_write_en2_shift                                              (28)
+#define HDMI_CS_TRANS14_write_en2_mask                                               (0x10000000)
+#define HDMI_CS_TRANS14_write_en2(data)                                              (0x10000000&((data)<<28))
+#define HDMI_CS_TRANS14_write_en2_src(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS14_get_write_en2(data)                                          ((0x10000000&(data))>>28)
+#define HDMI_CS_TRANS14_crrmax_shift                                                 (16)
+#define HDMI_CS_TRANS14_crrmax_mask                                                  (0x0FFF0000)
+#define HDMI_CS_TRANS14_crrmax(data)                                                 (0x0FFF0000&((data)<<16))
+#define HDMI_CS_TRANS14_crrmax_src(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS14_get_crrmax(data)                                             ((0x0FFF0000&(data))>>16)
+#define HDMI_CS_TRANS14_write_en1_shift                                              (12)
+#define HDMI_CS_TRANS14_write_en1_mask                                               (0x00001000)
+#define HDMI_CS_TRANS14_write_en1(data)                                              (0x00001000&((data)<<12))
+#define HDMI_CS_TRANS14_write_en1_src(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS14_get_write_en1(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_CS_TRANS14_crrmin_shift                                                 (0)
+#define HDMI_CS_TRANS14_crrmin_mask                                                  (0x00000FFF)
+#define HDMI_CS_TRANS14_crrmin(data)                                                 (0x00000FFF&((data)<<0))
+#define HDMI_CS_TRANS14_crrmin_src(data)                                             ((0x00000FFF&(data))>>0)
+#define HDMI_CS_TRANS14_get_crrmin(data)                                             ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_SYNC_DLY                                                                0x1800D030
+#define HDMI_SYNC_DLY_reg_addr                                                       "0xB800D030"
+#define HDMI_SYNC_DLY_reg                                                            0xB800D030
+#define set_HDMI_SYNC_DLY_reg(data)   (*((volatile unsigned int*) HDMI_SYNC_DLY_reg)=data)
+#define get_HDMI_SYNC_DLY_reg   (*((volatile unsigned int*) HDMI_SYNC_DLY_reg))
+#define HDMI_SYNC_DLY_inst_adr                                                       "0x000C"
+#define HDMI_SYNC_DLY_inst                                                           0x000C
+#define HDMI_SYNC_DLY_write_en4_shift                                                (11)
+#define HDMI_SYNC_DLY_write_en4_mask                                                 (0x00000800)
+#define HDMI_SYNC_DLY_write_en4(data)                                                (0x00000800&((data)<<11))
+#define HDMI_SYNC_DLY_write_en4_src(data)                                            ((0x00000800&(data))>>11)
+#define HDMI_SYNC_DLY_get_write_en4(data)                                            ((0x00000800&(data))>>11)
+#define HDMI_SYNC_DLY_nor_v_shift                                                    (9)
+#define HDMI_SYNC_DLY_nor_v_mask                                                     (0x00000600)
+#define HDMI_SYNC_DLY_nor_v(data)                                                    (0x00000600&((data)<<9))
+#define HDMI_SYNC_DLY_nor_v_src(data)                                                ((0x00000600&(data))>>9)
+#define HDMI_SYNC_DLY_get_nor_v(data)                                                ((0x00000600&(data))>>9)
+#define HDMI_SYNC_DLY_write_en3_shift                                                (8)
+#define HDMI_SYNC_DLY_write_en3_mask                                                 (0x00000100)
+#define HDMI_SYNC_DLY_write_en3(data)                                                (0x00000100&((data)<<8))
+#define HDMI_SYNC_DLY_write_en3_src(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_SYNC_DLY_get_write_en3(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_SYNC_DLY_nor_h_shift                                                    (6)
+#define HDMI_SYNC_DLY_nor_h_mask                                                     (0x000000C0)
+#define HDMI_SYNC_DLY_nor_h(data)                                                    (0x000000C0&((data)<<6))
+#define HDMI_SYNC_DLY_nor_h_src(data)                                                ((0x000000C0&(data))>>6)
+#define HDMI_SYNC_DLY_get_nor_h(data)                                                ((0x000000C0&(data))>>6)
+#define HDMI_SYNC_DLY_write_en2_shift                                                (5)
+#define HDMI_SYNC_DLY_write_en2_mask                                                 (0x00000020)
+#define HDMI_SYNC_DLY_write_en2(data)                                                (0x00000020&((data)<<5))
+#define HDMI_SYNC_DLY_write_en2_src(data)                                            ((0x00000020&(data))>>5)
+#define HDMI_SYNC_DLY_get_write_en2(data)                                            ((0x00000020&(data))>>5)
+#define HDMI_SYNC_DLY_disp_v_shift                                                   (3)
+#define HDMI_SYNC_DLY_disp_v_mask                                                    (0x00000018)
+#define HDMI_SYNC_DLY_disp_v(data)                                                   (0x00000018&((data)<<3))
+#define HDMI_SYNC_DLY_disp_v_src(data)                                               ((0x00000018&(data))>>3)
+#define HDMI_SYNC_DLY_get_disp_v(data)                                               ((0x00000018&(data))>>3)
+#define HDMI_SYNC_DLY_write_en1_shift                                                (2)
+#define HDMI_SYNC_DLY_write_en1_mask                                                 (0x00000004)
+#define HDMI_SYNC_DLY_write_en1(data)                                                (0x00000004&((data)<<2))
+#define HDMI_SYNC_DLY_write_en1_src(data)                                            ((0x00000004&(data))>>2)
+#define HDMI_SYNC_DLY_get_write_en1(data)                                            ((0x00000004&(data))>>2)
+#define HDMI_SYNC_DLY_disp_h_shift                                                   (0)
+#define HDMI_SYNC_DLY_disp_h_mask                                                    (0x00000003)
+#define HDMI_SYNC_DLY_disp_h(data)                                                   (0x00000003&((data)<<0))
+#define HDMI_SYNC_DLY_disp_h_src(data)                                               ((0x00000003&(data))>>0)
+#define HDMI_SYNC_DLY_get_disp_h(data)                                               ((0x00000003&(data))>>0)
+
+
+#define HDMI_CR                                                                      0x1800D034
+#define HDMI_CR_reg_addr                                                             "0xB800D034"
+#define HDMI_CR_reg                                                                  0xB800D034
+#define set_HDMI_CR_reg(data)   (*((volatile unsigned int*) HDMI_CR_reg)=data)
+#define get_HDMI_CR_reg   (*((volatile unsigned int*) HDMI_CR_reg))
+#define HDMI_CR_inst_adr                                                             "0x000D"
+#define HDMI_CR_inst                                                                 0x000D
+#define HDMI_CR_write_en3_shift                                                      (5)
+#define HDMI_CR_write_en3_mask                                                       (0x00000020)
+#define HDMI_CR_write_en3(data)                                                      (0x00000020&((data)<<5))
+#define HDMI_CR_write_en3_src(data)                                                  ((0x00000020&(data))>>5)
+#define HDMI_CR_get_write_en3(data)                                                  ((0x00000020&(data))>>5)
+#define HDMI_CR_tmds_encen_shift                                                     (4)
+#define HDMI_CR_tmds_encen_mask                                                      (0x00000010)
+#define HDMI_CR_tmds_encen(data)                                                     (0x00000010&((data)<<4))
+#define HDMI_CR_tmds_encen_src(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_CR_get_tmds_encen(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_CR_write_en2_shift                                                      (3)
+#define HDMI_CR_write_en2_mask                                                       (0x00000008)
+#define HDMI_CR_write_en2(data)                                                      (0x00000008&((data)<<3))
+#define HDMI_CR_write_en2_src(data)                                                  ((0x00000008&(data))>>3)
+#define HDMI_CR_get_write_en2(data)                                                  ((0x00000008&(data))>>3)
+#define HDMI_CR_enablehdcp_shift                                                     (2)
+#define HDMI_CR_enablehdcp_mask                                                      (0x00000004)
+#define HDMI_CR_enablehdcp(data)                                                     (0x00000004&((data)<<2))
+#define HDMI_CR_enablehdcp_src(data)                                                 ((0x00000004&(data))>>2)
+#define HDMI_CR_get_enablehdcp(data)                                                 ((0x00000004&(data))>>2)
+#define HDMI_CR_write_en1_shift                                                      (1)
+#define HDMI_CR_write_en1_mask                                                       (0x00000002)
+#define HDMI_CR_write_en1(data)                                                      (0x00000002&((data)<<1))
+#define HDMI_CR_write_en1_src(data)                                                  ((0x00000002&(data))>>1)
+#define HDMI_CR_get_write_en1(data)                                                  ((0x00000002&(data))>>1)
+#define HDMI_CR_enablehdmi_shift                                                     (0)
+#define HDMI_CR_enablehdmi_mask                                                      (0x00000001)
+#define HDMI_CR_enablehdmi(data)                                                     (0x00000001&((data)<<0))
+#define HDMI_CR_enablehdmi_src(data)                                                 ((0x00000001&(data))>>0)
+#define HDMI_CR_get_enablehdmi(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define HDMI_DPC                                                                     0x1800D154
+#define HDMI_DPC_reg_addr                                                            "0xB800D154"
+#define HDMI_DPC_reg                                                                 0xB800D154
+#define set_HDMI_DPC_reg(data)   (*((volatile unsigned int*) HDMI_DPC_reg)=data)
+#define get_HDMI_DPC_reg   (*((volatile unsigned int*) HDMI_DPC_reg))
+#define HDMI_DPC_inst_adr                                                            "0x0055"
+#define HDMI_DPC_inst                                                                0x0055
+#define HDMI_DPC_write_en9_shift                                                     (30)
+#define HDMI_DPC_write_en9_mask                                                      (0x40000000)
+#define HDMI_DPC_write_en9(data)                                                     (0x40000000&((data)<<30))
+#define HDMI_DPC_write_en9_src(data)                                                 ((0x40000000&(data))>>30)
+#define HDMI_DPC_get_write_en9(data)                                                 ((0x40000000&(data))>>30)
+#define HDMI_DPC_dp_vfch_num_shift                                                   (28)
+#define HDMI_DPC_dp_vfch_num_mask                                                    (0x30000000)
+#define HDMI_DPC_dp_vfch_num(data)                                                   (0x30000000&((data)<<28))
+#define HDMI_DPC_dp_vfch_num_src(data)                                               ((0x30000000&(data))>>28)
+#define HDMI_DPC_get_dp_vfch_num(data)                                               ((0x30000000&(data))>>28)
+#define HDMI_DPC_write_en8_shift                                                     (25)
+#define HDMI_DPC_write_en8_mask                                                      (0x02000000)
+#define HDMI_DPC_write_en8(data)                                                     (0x02000000&((data)<<25))
+#define HDMI_DPC_write_en8_src(data)                                                 ((0x02000000&(data))>>25)
+#define HDMI_DPC_get_write_en8(data)                                                 ((0x02000000&(data))>>25)
+#define HDMI_DPC_fp_swen_shift                                                       (24)
+#define HDMI_DPC_fp_swen_mask                                                        (0x01000000)
+#define HDMI_DPC_fp_swen(data)                                                       (0x01000000&((data)<<24))
+#define HDMI_DPC_fp_swen_src(data)                                                   ((0x01000000&(data))>>24)
+#define HDMI_DPC_get_fp_swen(data)                                                   ((0x01000000&(data))>>24)
+#define HDMI_DPC_write_en7_shift                                                     (23)
+#define HDMI_DPC_write_en7_mask                                                      (0x00800000)
+#define HDMI_DPC_write_en7(data)                                                     (0x00800000&((data)<<23))
+#define HDMI_DPC_write_en7_src(data)                                                 ((0x00800000&(data))>>23)
+#define HDMI_DPC_get_write_en7(data)                                                 ((0x00800000&(data))>>23)
+#define HDMI_DPC_fp_shift                                                            (20)
+#define HDMI_DPC_fp_mask                                                             (0x00700000)
+#define HDMI_DPC_fp(data)                                                            (0x00700000&((data)<<20))
+#define HDMI_DPC_fp_src(data)                                                        ((0x00700000&(data))>>20)
+#define HDMI_DPC_get_fp(data)                                                        ((0x00700000&(data))>>20)
+#define HDMI_DPC_write_en6_shift                                                     (19)
+#define HDMI_DPC_write_en6_mask                                                      (0x00080000)
+#define HDMI_DPC_write_en6(data)                                                     (0x00080000&((data)<<19))
+#define HDMI_DPC_write_en6_src(data)                                                 ((0x00080000&(data))>>19)
+#define HDMI_DPC_get_write_en6(data)                                                 ((0x00080000&(data))>>19)
+#define HDMI_DPC_pp_swen_shift                                                       (18)
+#define HDMI_DPC_pp_swen_mask                                                        (0x00040000)
+#define HDMI_DPC_pp_swen(data)                                                       (0x00040000&((data)<<18))
+#define HDMI_DPC_pp_swen_src(data)                                                   ((0x00040000&(data))>>18)
+#define HDMI_DPC_get_pp_swen(data)                                                   ((0x00040000&(data))>>18)
+#define HDMI_DPC_write_en4_shift                                                     (15)
+#define HDMI_DPC_write_en4_mask                                                      (0x00008000)
+#define HDMI_DPC_write_en4(data)                                                     (0x00008000&((data)<<15))
+#define HDMI_DPC_write_en4_src(data)                                                 ((0x00008000&(data))>>15)
+#define HDMI_DPC_get_write_en4(data)                                                 ((0x00008000&(data))>>15)
+#define HDMI_DPC_dp_swen_shift                                                       (14)
+#define HDMI_DPC_dp_swen_mask                                                        (0x00004000)
+#define HDMI_DPC_dp_swen(data)                                                       (0x00004000&((data)<<14))
+#define HDMI_DPC_dp_swen_src(data)                                                   ((0x00004000&(data))>>14)
+#define HDMI_DPC_get_dp_swen(data)                                                   ((0x00004000&(data))>>14)
+#define HDMI_DPC_write_en3_shift                                                     (13)
+#define HDMI_DPC_write_en3_mask                                                      (0x00002000)
+#define HDMI_DPC_write_en3(data)                                                     (0x00002000&((data)<<13))
+#define HDMI_DPC_write_en3_src(data)                                                 ((0x00002000&(data))>>13)
+#define HDMI_DPC_get_write_en3(data)                                                 ((0x00002000&(data))>>13)
+#define HDMI_DPC_default_phase_shift                                                 (12)
+#define HDMI_DPC_default_phase_mask                                                  (0x00001000)
+#define HDMI_DPC_default_phase(data)                                                 (0x00001000&((data)<<12))
+#define HDMI_DPC_default_phase_src(data)                                             ((0x00001000&(data))>>12)
+#define HDMI_DPC_get_default_phase(data)                                             ((0x00001000&(data))>>12)
+#define HDMI_DPC_write_en2_shift                                                     (8)
+#define HDMI_DPC_write_en2_mask                                                      (0x00000100)
+#define HDMI_DPC_write_en2(data)                                                     (0x00000100&((data)<<8))
+#define HDMI_DPC_write_en2_src(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_DPC_get_write_en2(data)                                                 ((0x00000100&(data))>>8)
+#define HDMI_DPC_color_depth_shift                                                   (4)
+#define HDMI_DPC_color_depth_mask                                                    (0x000000F0)
+#define HDMI_DPC_color_depth(data)                                                   (0x000000F0&((data)<<4))
+#define HDMI_DPC_color_depth_src(data)                                               ((0x000000F0&(data))>>4)
+#define HDMI_DPC_get_color_depth(data)                                               ((0x000000F0&(data))>>4)
+#define HDMI_DPC_write_en1_shift                                                     (1)
+#define HDMI_DPC_write_en1_mask                                                      (0x00000002)
+#define HDMI_DPC_write_en1(data)                                                     (0x00000002&((data)<<1))
+#define HDMI_DPC_write_en1_src(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_DPC_get_write_en1(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_DPC_dpc_enable_shift                                                    (0)
+#define HDMI_DPC_dpc_enable_mask                                                     (0x00000001)
+#define HDMI_DPC_dpc_enable(data)                                                    (0x00000001&((data)<<0))
+#define HDMI_DPC_dpc_enable_src(data)                                                ((0x00000001&(data))>>0)
+#define HDMI_DPC_get_dpc_enable(data)                                                ((0x00000001&(data))>>0)
+
+
+#define HDMI_DPC1                                                                    0x1800D158
+#define HDMI_DPC1_reg_addr                                                           "0xB800D158"
+#define HDMI_DPC1_reg                                                                0xB800D158
+#define set_HDMI_DPC1_reg(data)   (*((volatile unsigned int*) HDMI_DPC1_reg)=data)
+#define get_HDMI_DPC1_reg   (*((volatile unsigned int*) HDMI_DPC1_reg))
+#define HDMI_DPC1_inst_adr                                                           "0x0056"
+#define HDMI_DPC1_inst                                                               0x0056
+#define HDMI_DPC1_write_en2_shift                                                    (9)
+#define HDMI_DPC1_write_en2_mask                                                     (0x00000200)
+#define HDMI_DPC1_write_en2(data)                                                    (0x00000200&((data)<<9))
+#define HDMI_DPC1_write_en2_src(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_DPC1_get_write_en2(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_DPC1_dp_vfch_shift                                                      (8)
+#define HDMI_DPC1_dp_vfch_mask                                                       (0x00000100)
+#define HDMI_DPC1_dp_vfch(data)                                                      (0x00000100&((data)<<8))
+#define HDMI_DPC1_dp_vfch_src(data)                                                  ((0x00000100&(data))>>8)
+#define HDMI_DPC1_get_dp_vfch(data)                                                  ((0x00000100&(data))>>8)
+#define HDMI_DPC1_write_en1_shift                                                    (4)
+#define HDMI_DPC1_write_en1_mask                                                     (0x00000010)
+#define HDMI_DPC1_write_en1(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_DPC1_write_en1_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_DPC1_get_write_en1(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_DPC1_pp_shift                                                           (0)
+#define HDMI_DPC1_pp_mask                                                            (0x0000000F)
+#define HDMI_DPC1_pp(data)                                                           (0x0000000F&((data)<<0))
+#define HDMI_DPC1_pp_src(data)                                                       ((0x0000000F&(data))>>0)
+#define HDMI_DPC1_get_pp(data)                                                       ((0x0000000F&(data))>>0)
+
+
+#define HDMI_TMDS_EODR0                                                              0x1800D038
+#define HDMI_TMDS_EODR0_reg_addr                                                     "0xB800D038"
+#define HDMI_TMDS_EODR0_reg                                                          0xB800D038
+#define set_HDMI_TMDS_EODR0_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_EODR0_reg)=data)
+#define get_HDMI_TMDS_EODR0_reg   (*((volatile unsigned int*) HDMI_TMDS_EODR0_reg))
+#define HDMI_TMDS_EODR0_inst_adr                                                     "0x000E"
+#define HDMI_TMDS_EODR0_inst                                                         0x000E
+#define HDMI_TMDS_EODR0_tmds_ch2_out_shift                                           (20)
+#define HDMI_TMDS_EODR0_tmds_ch2_out_mask                                            (0x3FF00000)
+#define HDMI_TMDS_EODR0_tmds_ch2_out(data)                                           (0x3FF00000&((data)<<20))
+#define HDMI_TMDS_EODR0_tmds_ch2_out_src(data)                                       ((0x3FF00000&(data))>>20)
+#define HDMI_TMDS_EODR0_get_tmds_ch2_out(data)                                       ((0x3FF00000&(data))>>20)
+#define HDMI_TMDS_EODR0_tmds_ch1_out_shift                                           (10)
+#define HDMI_TMDS_EODR0_tmds_ch1_out_mask                                            (0x000FFC00)
+#define HDMI_TMDS_EODR0_tmds_ch1_out(data)                                           (0x000FFC00&((data)<<10))
+#define HDMI_TMDS_EODR0_tmds_ch1_out_src(data)                                       ((0x000FFC00&(data))>>10)
+#define HDMI_TMDS_EODR0_get_tmds_ch1_out(data)                                       ((0x000FFC00&(data))>>10)
+#define HDMI_TMDS_EODR0_tmds_ch0_out_shift                                           (0)
+#define HDMI_TMDS_EODR0_tmds_ch0_out_mask                                            (0x000003FF)
+#define HDMI_TMDS_EODR0_tmds_ch0_out(data)                                           (0x000003FF&((data)<<0))
+#define HDMI_TMDS_EODR0_tmds_ch0_out_src(data)                                       ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_EODR0_get_tmds_ch0_out(data)                                       ((0x000003FF&(data))>>0)
+
+
+#define HDMI_TMDS_EODR1                                                              0x1800D03c
+#define HDMI_TMDS_EODR1_reg_addr                                                     "0xB800D03C"
+#define HDMI_TMDS_EODR1_reg                                                          0xB800D03C
+#define set_HDMI_TMDS_EODR1_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_EODR1_reg)=data)
+#define get_HDMI_TMDS_EODR1_reg   (*((volatile unsigned int*) HDMI_TMDS_EODR1_reg))
+#define HDMI_TMDS_EODR1_inst_adr                                                     "0x000F"
+#define HDMI_TMDS_EODR1_inst                                                         0x000F
+#define HDMI_TMDS_EODR1_default_phase_st_shift                                       (12)
+#define HDMI_TMDS_EODR1_default_phase_st_mask                                        (0x00001000)
+#define HDMI_TMDS_EODR1_default_phase_st(data)                                       (0x00001000&((data)<<12))
+#define HDMI_TMDS_EODR1_default_phase_st_src(data)                                   ((0x00001000&(data))>>12)
+#define HDMI_TMDS_EODR1_get_default_phase_st(data)                                   ((0x00001000&(data))>>12)
+#define HDMI_TMDS_EODR1_tmds_clk_out_shift                                           (0)
+#define HDMI_TMDS_EODR1_tmds_clk_out_mask                                            (0x000003FF)
+#define HDMI_TMDS_EODR1_tmds_clk_out(data)                                           (0x000003FF&((data)<<0))
+#define HDMI_TMDS_EODR1_tmds_clk_out_src(data)                                       ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_EODR1_get_tmds_clk_out(data)                                       ((0x000003FF&(data))>>0)
+
+
+#define HDMI_TMDS_SCR1                                                               0x1800D040
+#define HDMI_TMDS_SCR1_reg_addr                                                      "0xB800D040"
+#define HDMI_TMDS_SCR1_reg                                                           0xB800D040
+#define set_HDMI_TMDS_SCR1_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_SCR1_reg)=data)
+#define get_HDMI_TMDS_SCR1_reg   (*((volatile unsigned int*) HDMI_TMDS_SCR1_reg))
+#define HDMI_TMDS_SCR1_inst_adr                                                      "0x0010"
+#define HDMI_TMDS_SCR1_inst                                                          0x0010
+#define HDMI_TMDS_SCR1_REG_LDO_PLL_VSEL_shift                                        (28)
+#define HDMI_TMDS_SCR1_REG_LDO_PLL_VSEL_mask                                         (0x70000000)
+#define HDMI_TMDS_SCR1_REG_LDO_PLL_VSEL(data)                                        (0x70000000&((data)<<28))
+#define HDMI_TMDS_SCR1_REG_LDO_PLL_VSEL_src(data)                                    ((0x70000000&(data))>>28)
+#define HDMI_TMDS_SCR1_get_REG_LDO_PLL_VSEL(data)                                    ((0x70000000&(data))>>28)
+#define HDMI_TMDS_SCR1_REG_LDO_PLL_PU_shift                                          (27)
+#define HDMI_TMDS_SCR1_REG_LDO_PLL_PU_mask                                           (0x08000000)
+#define HDMI_TMDS_SCR1_REG_LDO_PLL_PU(data)                                          (0x08000000&((data)<<27))
+#define HDMI_TMDS_SCR1_REG_LDO_PLL_PU_src(data)                                      ((0x08000000&(data))>>27)
+#define HDMI_TMDS_SCR1_get_REG_LDO_PLL_PU(data)                                      ((0x08000000&(data))>>27)
+#define HDMI_TMDS_SCR1_REG_LDO_CCO_VSEL_shift                                        (25)
+#define HDMI_TMDS_SCR1_REG_LDO_CCO_VSEL_mask                                         (0x06000000)
+#define HDMI_TMDS_SCR1_REG_LDO_CCO_VSEL(data)                                        (0x06000000&((data)<<25))
+#define HDMI_TMDS_SCR1_REG_LDO_CCO_VSEL_src(data)                                    ((0x06000000&(data))>>25)
+#define HDMI_TMDS_SCR1_get_REG_LDO_CCO_VSEL(data)                                    ((0x06000000&(data))>>25)
+#define HDMI_TMDS_SCR1_REG_LDO_CCO_PU_shift                                          (24)
+#define HDMI_TMDS_SCR1_REG_LDO_CCO_PU_mask                                           (0x01000000)
+#define HDMI_TMDS_SCR1_REG_LDO_CCO_PU(data)                                          (0x01000000&((data)<<24))
+#define HDMI_TMDS_SCR1_REG_LDO_CCO_PU_src(data)                                      ((0x01000000&(data))>>24)
+#define HDMI_TMDS_SCR1_get_REG_LDO_CCO_PU(data)                                      ((0x01000000&(data))>>24)
+#define HDMI_TMDS_SCR1_REG_TX_CK5XP_DUTY_shift                                       (22)
+#define HDMI_TMDS_SCR1_REG_TX_CK5XP_DUTY_mask                                        (0x00C00000)
+#define HDMI_TMDS_SCR1_REG_TX_CK5XP_DUTY(data)                                       (0x00C00000&((data)<<22))
+#define HDMI_TMDS_SCR1_REG_TX_CK5XP_DUTY_src(data)                                   ((0x00C00000&(data))>>22)
+#define HDMI_TMDS_SCR1_get_REG_TX_CK5XP_DUTY(data)                                   ((0x00C00000&(data))>>22)
+#define HDMI_TMDS_SCR1_REG_TX_CK5XN_DUTY_shift                                       (20)
+#define HDMI_TMDS_SCR1_REG_TX_CK5XN_DUTY_mask                                        (0x00300000)
+#define HDMI_TMDS_SCR1_REG_TX_CK5XN_DUTY(data)                                       (0x00300000&((data)<<20))
+#define HDMI_TMDS_SCR1_REG_TX_CK5XN_DUTY_src(data)                                   ((0x00300000&(data))>>20)
+#define HDMI_TMDS_SCR1_get_REG_TX_CK5XN_DUTY(data)                                   ((0x00300000&(data))>>20)
+#define HDMI_TMDS_SCR1_REG_TX_AMP_shift                                              (16)
+#define HDMI_TMDS_SCR1_REG_TX_AMP_mask                                               (0x000F0000)
+#define HDMI_TMDS_SCR1_REG_TX_AMP(data)                                              (0x000F0000&((data)<<16))
+#define HDMI_TMDS_SCR1_REG_TX_AMP_src(data)                                          ((0x000F0000&(data))>>16)
+#define HDMI_TMDS_SCR1_get_REG_TX_AMP(data)                                          ((0x000F0000&(data))>>16)
+#define HDMI_TMDS_SCR1_REG_TX_IBIAS_shift                                            (14)
+#define HDMI_TMDS_SCR1_REG_TX_IBIAS_mask                                             (0x0000C000)
+#define HDMI_TMDS_SCR1_REG_TX_IBIAS(data)                                            (0x0000C000&((data)<<14))
+#define HDMI_TMDS_SCR1_REG_TX_IBIAS_src(data)                                        ((0x0000C000&(data))>>14)
+#define HDMI_TMDS_SCR1_get_REG_TX_IBIAS(data)                                        ((0x0000C000&(data))>>14)
+#define HDMI_TMDS_SCR1_REG_TX_EMPH_shift                                             (11)
+#define HDMI_TMDS_SCR1_REG_TX_EMPH_mask                                              (0x00003800)
+#define HDMI_TMDS_SCR1_REG_TX_EMPH(data)                                             (0x00003800&((data)<<11))
+#define HDMI_TMDS_SCR1_REG_TX_EMPH_src(data)                                         ((0x00003800&(data))>>11)
+#define HDMI_TMDS_SCR1_get_REG_TX_EMPH(data)                                         ((0x00003800&(data))>>11)
+#define HDMI_TMDS_SCR1_REG_TX_EN_EMPH_shift                                          (10)
+#define HDMI_TMDS_SCR1_REG_TX_EN_EMPH_mask                                           (0x00000400)
+#define HDMI_TMDS_SCR1_REG_TX_EN_EMPH(data)                                          (0x00000400&((data)<<10))
+#define HDMI_TMDS_SCR1_REG_TX_EN_EMPH_src(data)                                      ((0x00000400&(data))>>10)
+#define HDMI_TMDS_SCR1_get_REG_TX_EN_EMPH(data)                                      ((0x00000400&(data))>>10)
+#define HDMI_TMDS_SCR1_REG_TX_FORCE_VC_shift                                         (9)
+#define HDMI_TMDS_SCR1_REG_TX_FORCE_VC_mask                                          (0x00000200)
+#define HDMI_TMDS_SCR1_REG_TX_FORCE_VC(data)                                         (0x00000200&((data)<<9))
+#define HDMI_TMDS_SCR1_REG_TX_FORCE_VC_src(data)                                     ((0x00000200&(data))>>9)
+#define HDMI_TMDS_SCR1_get_REG_TX_FORCE_VC(data)                                     ((0x00000200&(data))>>9)
+#define HDMI_TMDS_SCR1_REG_TX_SET_VC_shift                                           (7)
+#define HDMI_TMDS_SCR1_REG_TX_SET_VC_mask                                            (0x00000180)
+#define HDMI_TMDS_SCR1_REG_TX_SET_VC(data)                                           (0x00000180&((data)<<7))
+#define HDMI_TMDS_SCR1_REG_TX_SET_VC_src(data)                                       ((0x00000180&(data))>>7)
+#define HDMI_TMDS_SCR1_get_REG_TX_SET_VC(data)                                       ((0x00000180&(data))>>7)
+#define HDMI_TMDS_SCR1_REG_TX_PLL_EDGE_shift                                         (6)
+#define HDMI_TMDS_SCR1_REG_TX_PLL_EDGE_mask                                          (0x00000040)
+#define HDMI_TMDS_SCR1_REG_TX_PLL_EDGE(data)                                         (0x00000040&((data)<<6))
+#define HDMI_TMDS_SCR1_REG_TX_PLL_EDGE_src(data)                                     ((0x00000040&(data))>>6)
+#define HDMI_TMDS_SCR1_get_REG_TX_PLL_EDGE(data)                                     ((0x00000040&(data))>>6)
+#define HDMI_TMDS_SCR1_REG_TX_PLL_ICP_shift                                          (3)
+#define HDMI_TMDS_SCR1_REG_TX_PLL_ICP_mask                                           (0x00000038)
+#define HDMI_TMDS_SCR1_REG_TX_PLL_ICP(data)                                          (0x00000038&((data)<<3))
+#define HDMI_TMDS_SCR1_REG_TX_PLL_ICP_src(data)                                      ((0x00000038&(data))>>3)
+#define HDMI_TMDS_SCR1_get_REG_TX_PLL_ICP(data)                                      ((0x00000038&(data))>>3)
+#define HDMI_TMDS_SCR1_REG_TX_PLL_RS_shift                                           (0)
+#define HDMI_TMDS_SCR1_REG_TX_PLL_RS_mask                                            (0x00000007)
+#define HDMI_TMDS_SCR1_REG_TX_PLL_RS(data)                                           (0x00000007&((data)<<0))
+#define HDMI_TMDS_SCR1_REG_TX_PLL_RS_src(data)                                       ((0x00000007&(data))>>0)
+#define HDMI_TMDS_SCR1_get_REG_TX_PLL_RS(data)                                       ((0x00000007&(data))>>0)
+
+
+#define HDMI_TMDS_SCR2                                                               0x1800D044
+#define HDMI_TMDS_SCR2_reg_addr                                                      "0xB800D044"
+#define HDMI_TMDS_SCR2_reg                                                           0xB800D044
+#define set_HDMI_TMDS_SCR2_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_SCR2_reg)=data)
+#define get_HDMI_TMDS_SCR2_reg   (*((volatile unsigned int*) HDMI_TMDS_SCR2_reg))
+#define HDMI_TMDS_SCR2_inst_adr                                                      "0x0011"
+#define HDMI_TMDS_SCR2_inst                                                          0x0011
+#define HDMI_TMDS_SCR2_REG_TX_V1P05_SEL_shift                                        (30)
+#define HDMI_TMDS_SCR2_REG_TX_V1P05_SEL_mask                                         (0xC0000000)
+#define HDMI_TMDS_SCR2_REG_TX_V1P05_SEL(data)                                        (0xC0000000&((data)<<30))
+#define HDMI_TMDS_SCR2_REG_TX_V1P05_SEL_src(data)                                    ((0xC0000000&(data))>>30)
+#define HDMI_TMDS_SCR2_get_REG_TX_V1P05_SEL(data)                                    ((0xC0000000&(data))>>30)
+#define HDMI_TMDS_SCR2_REG_TX_PDRV_ISEL_shift                                        (28)
+#define HDMI_TMDS_SCR2_REG_TX_PDRV_ISEL_mask                                         (0x30000000)
+#define HDMI_TMDS_SCR2_REG_TX_PDRV_ISEL(data)                                        (0x30000000&((data)<<28))
+#define HDMI_TMDS_SCR2_REG_TX_PDRV_ISEL_src(data)                                    ((0x30000000&(data))>>28)
+#define HDMI_TMDS_SCR2_get_REG_TX_PDRV_ISEL(data)                                    ((0x30000000&(data))>>28)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_KVCO_shift                                         (27)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_KVCO_mask                                          (0x08000000)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_KVCO(data)                                         (0x08000000&((data)<<27))
+#define HDMI_TMDS_SCR2_REG_TX_PLL_KVCO_src(data)                                     ((0x08000000&(data))>>27)
+#define HDMI_TMDS_SCR2_get_REG_TX_PLL_KVCO(data)                                     ((0x08000000&(data))>>27)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_CS_shift                                           (25)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_CS_mask                                            (0x06000000)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_CS(data)                                           (0x06000000&((data)<<25))
+#define HDMI_TMDS_SCR2_REG_TX_PLL_CS_src(data)                                       ((0x06000000&(data))>>25)
+#define HDMI_TMDS_SCR2_get_REG_TX_PLL_CS(data)                                       ((0x06000000&(data))>>25)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_CP_shift                                           (23)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_CP_mask                                            (0x01800000)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_CP(data)                                           (0x01800000&((data)<<23))
+#define HDMI_TMDS_SCR2_REG_TX_PLL_CP_src(data)                                       ((0x01800000&(data))>>23)
+#define HDMI_TMDS_SCR2_get_REG_TX_PLL_CP(data)                                       ((0x01800000&(data))>>23)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_PU_shift                                           (22)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_PU_mask                                            (0x00400000)
+#define HDMI_TMDS_SCR2_REG_TX_PLL_PU(data)                                           (0x00400000&((data)<<22))
+#define HDMI_TMDS_SCR2_REG_TX_PLL_PU_src(data)                                       ((0x00400000&(data))>>22)
+#define HDMI_TMDS_SCR2_get_REG_TX_PLL_PU(data)                                       ((0x00400000&(data))>>22)
+#define HDMI_TMDS_SCR2_REG_TX_PU_shift                                               (18)
+#define HDMI_TMDS_SCR2_REG_TX_PU_mask                                                (0x003C0000)
+#define HDMI_TMDS_SCR2_REG_TX_PU(data)                                               (0x003C0000&((data)<<18))
+#define HDMI_TMDS_SCR2_REG_TX_PU_src(data)                                           ((0x003C0000&(data))>>18)
+#define HDMI_TMDS_SCR2_get_REG_TX_PU(data)                                           ((0x003C0000&(data))>>18)
+#define HDMI_TMDS_SCR2_REG_TX_DRIVER_shift                                           (16)
+#define HDMI_TMDS_SCR2_REG_TX_DRIVER_mask                                            (0x00030000)
+#define HDMI_TMDS_SCR2_REG_TX_DRIVER(data)                                           (0x00030000&((data)<<16))
+#define HDMI_TMDS_SCR2_REG_TX_DRIVER_src(data)                                       ((0x00030000&(data))>>16)
+#define HDMI_TMDS_SCR2_get_REG_TX_DRIVER(data)                                       ((0x00030000&(data))>>16)
+#define HDMI_TMDS_SCR2_REG_TX_SLEW_shift                                             (14)
+#define HDMI_TMDS_SCR2_REG_TX_SLEW_mask                                              (0x0000C000)
+#define HDMI_TMDS_SCR2_REG_TX_SLEW(data)                                             (0x0000C000&((data)<<14))
+#define HDMI_TMDS_SCR2_REG_TX_SLEW_src(data)                                         ((0x0000C000&(data))>>14)
+#define HDMI_TMDS_SCR2_get_REG_TX_SLEW(data)                                         ((0x0000C000&(data))>>14)
+#define HDMI_TMDS_SCR2_REG_TX_TST_EN_shift                                           (13)
+#define HDMI_TMDS_SCR2_REG_TX_TST_EN_mask                                            (0x00002000)
+#define HDMI_TMDS_SCR2_REG_TX_TST_EN(data)                                           (0x00002000&((data)<<13))
+#define HDMI_TMDS_SCR2_REG_TX_TST_EN_src(data)                                       ((0x00002000&(data))>>13)
+#define HDMI_TMDS_SCR2_get_REG_TX_TST_EN(data)                                       ((0x00002000&(data))>>13)
+#define HDMI_TMDS_SCR2_REG_TX_VGATE_shift                                            (10)
+#define HDMI_TMDS_SCR2_REG_TX_VGATE_mask                                             (0x00001C00)
+#define HDMI_TMDS_SCR2_REG_TX_VGATE(data)                                            (0x00001C00&((data)<<10))
+#define HDMI_TMDS_SCR2_REG_TX_VGATE_src(data)                                        ((0x00001C00&(data))>>10)
+#define HDMI_TMDS_SCR2_get_REG_TX_VGATE(data)                                        ((0x00001C00&(data))>>10)
+#define HDMI_TMDS_SCR2_REG_PLL_TST_EN_shift                                          (9)
+#define HDMI_TMDS_SCR2_REG_PLL_TST_EN_mask                                           (0x00000200)
+#define HDMI_TMDS_SCR2_REG_PLL_TST_EN(data)                                          (0x00000200&((data)<<9))
+#define HDMI_TMDS_SCR2_REG_PLL_TST_EN_src(data)                                      ((0x00000200&(data))>>9)
+#define HDMI_TMDS_SCR2_get_REG_PLL_TST_EN(data)                                      ((0x00000200&(data))>>9)
+#define HDMI_TMDS_SCR2_REG_TST_SEL_shift                                             (7)
+#define HDMI_TMDS_SCR2_REG_TST_SEL_mask                                              (0x00000180)
+#define HDMI_TMDS_SCR2_REG_TST_SEL(data)                                             (0x00000180&((data)<<7))
+#define HDMI_TMDS_SCR2_REG_TST_SEL_src(data)                                         ((0x00000180&(data))>>7)
+#define HDMI_TMDS_SCR2_get_REG_TST_SEL(data)                                         ((0x00000180&(data))>>7)
+#define HDMI_TMDS_SCR2_REG_TX_BYPASS_PLL_shift                                       (6)
+#define HDMI_TMDS_SCR2_REG_TX_BYPASS_PLL_mask                                        (0x00000040)
+#define HDMI_TMDS_SCR2_REG_TX_BYPASS_PLL(data)                                       (0x00000040&((data)<<6))
+#define HDMI_TMDS_SCR2_REG_TX_BYPASS_PLL_src(data)                                   ((0x00000040&(data))>>6)
+#define HDMI_TMDS_SCR2_get_REG_TX_BYPASS_PLL(data)                                   ((0x00000040&(data))>>6)
+#define HDMI_TMDS_SCR2_REG_TX_RT_EN_shift                                            (5)
+#define HDMI_TMDS_SCR2_REG_TX_RT_EN_mask                                             (0x00000020)
+#define HDMI_TMDS_SCR2_REG_TX_RT_EN(data)                                            (0x00000020&((data)<<5))
+#define HDMI_TMDS_SCR2_REG_TX_RT_EN_src(data)                                        ((0x00000020&(data))>>5)
+#define HDMI_TMDS_SCR2_get_REG_TX_RT_EN(data)                                        ((0x00000020&(data))>>5)
+#define HDMI_TMDS_SCR2_REG_TX_RT_SEL_shift                                           (3)
+#define HDMI_TMDS_SCR2_REG_TX_RT_SEL_mask                                            (0x00000018)
+#define HDMI_TMDS_SCR2_REG_TX_RT_SEL(data)                                           (0x00000018&((data)<<3))
+#define HDMI_TMDS_SCR2_REG_TX_RT_SEL_src(data)                                       ((0x00000018&(data))>>3)
+#define HDMI_TMDS_SCR2_get_REG_TX_RT_SEL(data)                                       ((0x00000018&(data))>>3)
+#define HDMI_TMDS_SCR2_REG_PLL_VCO_SCALE_shift                                       (1)
+#define HDMI_TMDS_SCR2_REG_PLL_VCO_SCALE_mask                                        (0x00000006)
+#define HDMI_TMDS_SCR2_REG_PLL_VCO_SCALE(data)                                       (0x00000006&((data)<<1))
+#define HDMI_TMDS_SCR2_REG_PLL_VCO_SCALE_src(data)                                   ((0x00000006&(data))>>1)
+#define HDMI_TMDS_SCR2_get_REG_PLL_VCO_SCALE(data)                                   ((0x00000006&(data))>>1)
+#define HDMI_TMDS_SCR2_REG_BYPASS_DIN_shift                                          (0)
+#define HDMI_TMDS_SCR2_REG_BYPASS_DIN_mask                                           (0x00000001)
+#define HDMI_TMDS_SCR2_REG_BYPASS_DIN(data)                                          (0x00000001&((data)<<0))
+#define HDMI_TMDS_SCR2_REG_BYPASS_DIN_src(data)                                      ((0x00000001&(data))>>0)
+#define HDMI_TMDS_SCR2_get_REG_BYPASS_DIN(data)                                      ((0x00000001&(data))>>0)
+
+
+#define HDMI_TMDS_SCR3                                                               0x1800D230
+#define HDMI_TMDS_SCR3_reg_addr                                                      "0xB800D230"
+#define HDMI_TMDS_SCR3_reg                                                           0xB800D230
+#define set_HDMI_TMDS_SCR3_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_SCR3_reg)=data)
+#define get_HDMI_TMDS_SCR3_reg   (*((volatile unsigned int*) HDMI_TMDS_SCR3_reg))
+#define HDMI_TMDS_SCR3_inst_adr                                                      "0x008C"
+#define HDMI_TMDS_SCR3_inst                                                          0x008C
+#define HDMI_TMDS_SCR3_REG_TX_PLL_WDMODE_shift                                       (30)
+#define HDMI_TMDS_SCR3_REG_TX_PLL_WDMODE_mask                                        (0xC0000000)
+#define HDMI_TMDS_SCR3_REG_TX_PLL_WDMODE(data)                                       (0xC0000000&((data)<<30))
+#define HDMI_TMDS_SCR3_REG_TX_PLL_WDMODE_src(data)                                   ((0xC0000000&(data))>>30)
+#define HDMI_TMDS_SCR3_get_REG_TX_PLL_WDMODE(data)                                   ((0xC0000000&(data))>>30)
+#define HDMI_TMDS_SCR3_REG_RESERVE_shift                                             (14)
+#define HDMI_TMDS_SCR3_REG_RESERVE_mask                                              (0x3FFFC000)
+#define HDMI_TMDS_SCR3_REG_RESERVE(data)                                             (0x3FFFC000&((data)<<14))
+#define HDMI_TMDS_SCR3_REG_RESERVE_src(data)                                         ((0x3FFFC000&(data))>>14)
+#define HDMI_TMDS_SCR3_get_REG_RESERVE(data)                                         ((0x3FFFC000&(data))>>14)
+#define HDMI_TMDS_SCR3_REG_CEC_ENB_shift                                             (13)
+#define HDMI_TMDS_SCR3_REG_CEC_ENB_mask                                              (0x00002000)
+#define HDMI_TMDS_SCR3_REG_CEC_ENB(data)                                             (0x00002000&((data)<<13))
+#define HDMI_TMDS_SCR3_REG_CEC_ENB_src(data)                                         ((0x00002000&(data))>>13)
+#define HDMI_TMDS_SCR3_get_REG_CEC_ENB(data)                                         ((0x00002000&(data))>>13)
+#define HDMI_TMDS_SCR3_REG_EN_MHL_shift                                              (12)
+#define HDMI_TMDS_SCR3_REG_EN_MHL_mask                                               (0x00001000)
+#define HDMI_TMDS_SCR3_REG_EN_MHL(data)                                              (0x00001000&((data)<<12))
+#define HDMI_TMDS_SCR3_REG_EN_MHL_src(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_TMDS_SCR3_get_REG_EN_MHL(data)                                          ((0x00001000&(data))>>12)
+#define HDMI_TMDS_SCR3_REG_FORCE_RXSENSE_shift                                       (11)
+#define HDMI_TMDS_SCR3_REG_FORCE_RXSENSE_mask                                        (0x00000800)
+#define HDMI_TMDS_SCR3_REG_FORCE_RXSENSE(data)                                       (0x00000800&((data)<<11))
+#define HDMI_TMDS_SCR3_REG_FORCE_RXSENSE_src(data)                                   ((0x00000800&(data))>>11)
+#define HDMI_TMDS_SCR3_get_REG_FORCE_RXSENSE(data)                                   ((0x00000800&(data))>>11)
+#define HDMI_TMDS_SCR3_REG_RXSENSE_shift                                             (9)
+#define HDMI_TMDS_SCR3_REG_RXSENSE_mask                                              (0x00000600)
+#define HDMI_TMDS_SCR3_REG_RXSENSE(data)                                             (0x00000600&((data)<<9))
+#define HDMI_TMDS_SCR3_REG_RXSENSE_src(data)                                         ((0x00000600&(data))>>9)
+#define HDMI_TMDS_SCR3_get_REG_RXSENSE(data)                                         ((0x00000600&(data))>>9)
+#define HDMI_TMDS_SCR3_REG_MHL_DIV_shift                                             (8)
+#define HDMI_TMDS_SCR3_REG_MHL_DIV_mask                                              (0x00000100)
+#define HDMI_TMDS_SCR3_REG_MHL_DIV(data)                                             (0x00000100&((data)<<8))
+#define HDMI_TMDS_SCR3_REG_MHL_DIV_src(data)                                         ((0x00000100&(data))>>8)
+#define HDMI_TMDS_SCR3_get_REG_MHL_DIV(data)                                         ((0x00000100&(data))>>8)
+#define HDMI_TMDS_SCR3_REG_MHL_VCM_shift                                             (6)
+#define HDMI_TMDS_SCR3_REG_MHL_VCM_mask                                              (0x000000C0)
+#define HDMI_TMDS_SCR3_REG_MHL_VCM(data)                                             (0x000000C0&((data)<<6))
+#define HDMI_TMDS_SCR3_REG_MHL_VCM_src(data)                                         ((0x000000C0&(data))>>6)
+#define HDMI_TMDS_SCR3_get_REG_MHL_VCM(data)                                         ((0x000000C0&(data))>>6)
+#define HDMI_TMDS_SCR3_REG_DIFF_RT_EN_shift                                          (5)
+#define HDMI_TMDS_SCR3_REG_DIFF_RT_EN_mask                                           (0x00000020)
+#define HDMI_TMDS_SCR3_REG_DIFF_RT_EN(data)                                          (0x00000020&((data)<<5))
+#define HDMI_TMDS_SCR3_REG_DIFF_RT_EN_src(data)                                      ((0x00000020&(data))>>5)
+#define HDMI_TMDS_SCR3_get_REG_DIFF_RT_EN(data)                                      ((0x00000020&(data))>>5)
+#define HDMI_TMDS_SCR3_REG_CABLE_DET_EN_shift                                        (4)
+#define HDMI_TMDS_SCR3_REG_CABLE_DET_EN_mask                                         (0x00000010)
+#define HDMI_TMDS_SCR3_REG_CABLE_DET_EN(data)                                        (0x00000010&((data)<<4))
+#define HDMI_TMDS_SCR3_REG_CABLE_DET_EN_src(data)                                    ((0x00000010&(data))>>4)
+#define HDMI_TMDS_SCR3_get_REG_CABLE_DET_EN(data)                                    ((0x00000010&(data))>>4)
+#define HDMI_TMDS_SCR3_REG_LDO_TMDS_VSEL20_shift                                     (1)
+#define HDMI_TMDS_SCR3_REG_LDO_TMDS_VSEL20_mask                                      (0x0000000E)
+#define HDMI_TMDS_SCR3_REG_LDO_TMDS_VSEL20(data)                                     (0x0000000E&((data)<<1))
+#define HDMI_TMDS_SCR3_REG_LDO_TMDS_VSEL20_src(data)                                 ((0x0000000E&(data))>>1)
+#define HDMI_TMDS_SCR3_get_REG_LDO_TMDS_VSEL20(data)                                 ((0x0000000E&(data))>>1)
+#define HDMI_TMDS_SCR3_REG_LDO_TMDS_CAPSEL_shift                                     (0)
+#define HDMI_TMDS_SCR3_REG_LDO_TMDS_CAPSEL_mask                                      (0x00000001)
+#define HDMI_TMDS_SCR3_REG_LDO_TMDS_CAPSEL(data)                                     (0x00000001&((data)<<0))
+#define HDMI_TMDS_SCR3_REG_LDO_TMDS_CAPSEL_src(data)                                 ((0x00000001&(data))>>0)
+#define HDMI_TMDS_SCR3_get_REG_LDO_TMDS_CAPSEL(data)                                 ((0x00000001&(data))>>0)
+
+
+#define HDMI_TVPLL_CTRL2                                                             0x1800D2A4
+#define HDMI_TVPLL_CTRL2_reg_addr                                                    "0xB800D2A4"
+#define HDMI_TVPLL_CTRL2_reg                                                         0xB800D2A4
+#define set_HDMI_TVPLL_CTRL2_reg(data)   (*((volatile unsigned int*) HDMI_TVPLL_CTRL2_reg)=data)
+#define get_HDMI_TVPLL_CTRL2_reg   (*((volatile unsigned int*) HDMI_TVPLL_CTRL2_reg))
+#define HDMI_TVPLL_CTRL2_inst_adr                                                    "0x00A9"
+#define HDMI_TVPLL_CTRL2_inst                                                        0x00A9
+#define HDMI_TVPLL_CTRL2_REG_TV_WDMODE_shift                                         (16)
+#define HDMI_TVPLL_CTRL2_REG_TV_WDMODE_mask                                          (0x00030000)
+#define HDMI_TVPLL_CTRL2_REG_TV_WDMODE(data)                                         (0x00030000&((data)<<16))
+#define HDMI_TVPLL_CTRL2_REG_TV_WDMODE_src(data)                                     ((0x00030000&(data))>>16)
+#define HDMI_TVPLL_CTRL2_get_REG_TV_WDMODE(data)                                     ((0x00030000&(data))>>16)
+#define HDMI_TVPLL_CTRL2_REG_TV_KVCO_shift                                           (15)
+#define HDMI_TVPLL_CTRL2_REG_TV_KVCO_mask                                            (0x00008000)
+#define HDMI_TVPLL_CTRL2_REG_TV_KVCO(data)                                           (0x00008000&((data)<<15))
+#define HDMI_TVPLL_CTRL2_REG_TV_KVCO_src(data)                                       ((0x00008000&(data))>>15)
+#define HDMI_TVPLL_CTRL2_get_REG_TV_KVCO(data)                                       ((0x00008000&(data))>>15)
+#define HDMI_TVPLL_CTRL2_REG_TV_CS_shift                                             (13)
+#define HDMI_TVPLL_CTRL2_REG_TV_CS_mask                                              (0x00006000)
+#define HDMI_TVPLL_CTRL2_REG_TV_CS(data)                                             (0x00006000&((data)<<13))
+#define HDMI_TVPLL_CTRL2_REG_TV_CS_src(data)                                         ((0x00006000&(data))>>13)
+#define HDMI_TVPLL_CTRL2_get_REG_TV_CS(data)                                         ((0x00006000&(data))>>13)
+#define HDMI_TVPLL_CTRL2_REG_TV_CP_shift                                             (11)
+#define HDMI_TVPLL_CTRL2_REG_TV_CP_mask                                              (0x00001800)
+#define HDMI_TVPLL_CTRL2_REG_TV_CP(data)                                             (0x00001800&((data)<<11))
+#define HDMI_TVPLL_CTRL2_REG_TV_CP_src(data)                                         ((0x00001800&(data))>>11)
+#define HDMI_TVPLL_CTRL2_get_REG_TV_CP(data)                                         ((0x00001800&(data))>>11)
+#define HDMI_TVPLL_CTRL2_REG_TV_ICP_shift                                            (8)
+#define HDMI_TVPLL_CTRL2_REG_TV_ICP_mask                                             (0x00000700)
+#define HDMI_TVPLL_CTRL2_REG_TV_ICP(data)                                            (0x00000700&((data)<<8))
+#define HDMI_TVPLL_CTRL2_REG_TV_ICP_src(data)                                        ((0x00000700&(data))>>8)
+#define HDMI_TVPLL_CTRL2_get_REG_TV_ICP(data)                                        ((0x00000700&(data))>>8)
+#define HDMI_TVPLL_CTRL2_REG_TV_RS_shift                                             (5)
+#define HDMI_TVPLL_CTRL2_REG_TV_RS_mask                                              (0x000000E0)
+#define HDMI_TVPLL_CTRL2_REG_TV_RS(data)                                             (0x000000E0&((data)<<5))
+#define HDMI_TVPLL_CTRL2_REG_TV_RS_src(data)                                         ((0x000000E0&(data))>>5)
+#define HDMI_TVPLL_CTRL2_get_REG_TV_RS(data)                                         ((0x000000E0&(data))>>5)
+#define HDMI_TVPLL_CTRL2_REG_TV_BYPASS_PLL_shift                                     (4)
+#define HDMI_TVPLL_CTRL2_REG_TV_BYPASS_PLL_mask                                      (0x00000010)
+#define HDMI_TVPLL_CTRL2_REG_TV_BYPASS_PLL(data)                                     (0x00000010&((data)<<4))
+#define HDMI_TVPLL_CTRL2_REG_TV_BYPASS_PLL_src(data)                                 ((0x00000010&(data))>>4)
+#define HDMI_TVPLL_CTRL2_get_REG_TV_BYPASS_PLL(data)                                 ((0x00000010&(data))>>4)
+#define HDMI_TVPLL_CTRL2_REG_TV_FORCE_VC_shift                                       (3)
+#define HDMI_TVPLL_CTRL2_REG_TV_FORCE_VC_mask                                        (0x00000008)
+#define HDMI_TVPLL_CTRL2_REG_TV_FORCE_VC(data)                                       (0x00000008&((data)<<3))
+#define HDMI_TVPLL_CTRL2_REG_TV_FORCE_VC_src(data)                                   ((0x00000008&(data))>>3)
+#define HDMI_TVPLL_CTRL2_get_REG_TV_FORCE_VC(data)                                   ((0x00000008&(data))>>3)
+#define HDMI_TVPLL_CTRL2_REG_TV_SET_VC_shift                                         (1)
+#define HDMI_TVPLL_CTRL2_REG_TV_SET_VC_mask                                          (0x00000006)
+#define HDMI_TVPLL_CTRL2_REG_TV_SET_VC(data)                                         (0x00000006&((data)<<1))
+#define HDMI_TVPLL_CTRL2_REG_TV_SET_VC_src(data)                                     ((0x00000006&(data))>>1)
+#define HDMI_TVPLL_CTRL2_get_REG_TV_SET_VC(data)                                     ((0x00000006&(data))>>1)
+#define HDMI_TVPLL_CTRL2_REG_TV_TST_EN_shift                                         (0)
+#define HDMI_TVPLL_CTRL2_REG_TV_TST_EN_mask                                          (0x00000001)
+#define HDMI_TVPLL_CTRL2_REG_TV_TST_EN(data)                                         (0x00000001&((data)<<0))
+#define HDMI_TVPLL_CTRL2_REG_TV_TST_EN_src(data)                                     ((0x00000001&(data))>>0)
+#define HDMI_TVPLL_CTRL2_get_REG_TV_TST_EN(data)                                     ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHL_CBUS                                                                0x1800D2AC
+#define HDMI_MHL_CBUS_reg_addr                                                       "0xB800D2AC"
+#define HDMI_MHL_CBUS_reg                                                            0xB800D2AC
+#define set_HDMI_MHL_CBUS_reg(data)   (*((volatile unsigned int*) HDMI_MHL_CBUS_reg)=data)
+#define get_HDMI_MHL_CBUS_reg   (*((volatile unsigned int*) HDMI_MHL_CBUS_reg))
+#define HDMI_MHL_CBUS_inst_adr                                                       "0x00AB"
+#define HDMI_MHL_CBUS_inst                                                           0x00AB
+#define HDMI_MHL_CBUS_REGO_TV_WDOUT_shift                                            (11)
+#define HDMI_MHL_CBUS_REGO_TV_WDOUT_mask                                             (0x00000800)
+#define HDMI_MHL_CBUS_REGO_TV_WDOUT(data)                                            (0x00000800&((data)<<11))
+#define HDMI_MHL_CBUS_REGO_TV_WDOUT_src(data)                                        ((0x00000800&(data))>>11)
+#define HDMI_MHL_CBUS_get_REGO_TV_WDOUT(data)                                        ((0x00000800&(data))>>11)
+#define HDMI_MHL_CBUS_REGO_TX_PLL_WDOUT_shift                                        (10)
+#define HDMI_MHL_CBUS_REGO_TX_PLL_WDOUT_mask                                         (0x00000400)
+#define HDMI_MHL_CBUS_REGO_TX_PLL_WDOUT(data)                                        (0x00000400&((data)<<10))
+#define HDMI_MHL_CBUS_REGO_TX_PLL_WDOUT_src(data)                                    ((0x00000400&(data))>>10)
+#define HDMI_MHL_CBUS_get_REGO_TX_PLL_WDOUT(data)                                    ((0x00000400&(data))>>10)
+#define HDMI_MHL_CBUS_REGO_TX_PLL_LOCK_shift                                         (9)
+#define HDMI_MHL_CBUS_REGO_TX_PLL_LOCK_mask                                          (0x00000200)
+#define HDMI_MHL_CBUS_REGO_TX_PLL_LOCK(data)                                         (0x00000200&((data)<<9))
+#define HDMI_MHL_CBUS_REGO_TX_PLL_LOCK_src(data)                                     ((0x00000200&(data))>>9)
+#define HDMI_MHL_CBUS_get_REGO_TX_PLL_LOCK(data)                                     ((0x00000200&(data))>>9)
+#define HDMI_MHL_CBUS_REGO_CABLE_DETECT_shift                                        (1)
+#define HDMI_MHL_CBUS_REGO_CABLE_DETECT_mask                                         (0x000001FE)
+#define HDMI_MHL_CBUS_REGO_CABLE_DETECT(data)                                        (0x000001FE&((data)<<1))
+#define HDMI_MHL_CBUS_REGO_CABLE_DETECT_src(data)                                    ((0x000001FE&(data))>>1)
+#define HDMI_MHL_CBUS_get_REGO_CABLE_DETECT(data)                                    ((0x000001FE&(data))>>1)
+#define HDMI_MHL_CBUS_REGO_TV_PLL_LOCK_shift                                         (0)
+#define HDMI_MHL_CBUS_REGO_TV_PLL_LOCK_mask                                          (0x00000001)
+#define HDMI_MHL_CBUS_REGO_TV_PLL_LOCK(data)                                         (0x00000001&((data)<<0))
+#define HDMI_MHL_CBUS_REGO_TV_PLL_LOCK_src(data)                                     ((0x00000001&(data))>>0)
+#define HDMI_MHL_CBUS_get_REGO_TV_PLL_LOCK(data)                                     ((0x00000001&(data))>>0)
+
+
+#define HDMI_TMDS_STR0                                                               0x1800D048
+#define HDMI_TMDS_STR0_reg_addr                                                      "0xB800D048"
+#define HDMI_TMDS_STR0_reg                                                           0xB800D048
+#define set_HDMI_TMDS_STR0_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_STR0_reg)=data)
+#define get_HDMI_TMDS_STR0_reg   (*((volatile unsigned int*) HDMI_TMDS_STR0_reg))
+#define HDMI_TMDS_STR0_inst_adr                                                      "0x0012"
+#define HDMI_TMDS_STR0_inst                                                          0x0012
+#define HDMI_TMDS_STR0_tmds1ten_shift                                                (31)
+#define HDMI_TMDS_STR0_tmds1ten_mask                                                 (0x80000000)
+#define HDMI_TMDS_STR0_tmds1ten(data)                                                (0x80000000&((data)<<31))
+#define HDMI_TMDS_STR0_tmds1ten_src(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR0_get_tmds1ten(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR0_td1src_shift                                                  (30)
+#define HDMI_TMDS_STR0_td1src_mask                                                   (0x40000000)
+#define HDMI_TMDS_STR0_td1src(data)                                                  (0x40000000&((data)<<30))
+#define HDMI_TMDS_STR0_td1src_src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR0_get_td1src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR0_tmds1td_shift                                                 (16)
+#define HDMI_TMDS_STR0_tmds1td_mask                                                  (0x03FF0000)
+#define HDMI_TMDS_STR0_tmds1td(data)                                                 (0x03FF0000&((data)<<16))
+#define HDMI_TMDS_STR0_tmds1td_src(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR0_get_tmds1td(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR0_tmds0ten_shift                                                (15)
+#define HDMI_TMDS_STR0_tmds0ten_mask                                                 (0x00008000)
+#define HDMI_TMDS_STR0_tmds0ten(data)                                                (0x00008000&((data)<<15))
+#define HDMI_TMDS_STR0_tmds0ten_src(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR0_get_tmds0ten(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR0_td0src_shift                                                  (14)
+#define HDMI_TMDS_STR0_td0src_mask                                                   (0x00004000)
+#define HDMI_TMDS_STR0_td0src(data)                                                  (0x00004000&((data)<<14))
+#define HDMI_TMDS_STR0_td0src_src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR0_get_td0src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR0_tmds0td_shift                                                 (0)
+#define HDMI_TMDS_STR0_tmds0td_mask                                                  (0x000003FF)
+#define HDMI_TMDS_STR0_tmds0td(data)                                                 (0x000003FF&((data)<<0))
+#define HDMI_TMDS_STR0_tmds0td_src(data)                                             ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_STR0_get_tmds0td(data)                                             ((0x000003FF&(data))>>0)
+
+
+#define HDMI_TMDS_STR1                                                               0x1800D04c
+#define HDMI_TMDS_STR1_reg_addr                                                      "0xB800D04C"
+#define HDMI_TMDS_STR1_reg                                                           0xB800D04C
+#define set_HDMI_TMDS_STR1_reg(data)   (*((volatile unsigned int*) HDMI_TMDS_STR1_reg)=data)
+#define get_HDMI_TMDS_STR1_reg   (*((volatile unsigned int*) HDMI_TMDS_STR1_reg))
+#define HDMI_TMDS_STR1_inst_adr                                                      "0x0013"
+#define HDMI_TMDS_STR1_inst                                                          0x0013
+#define HDMI_TMDS_STR1_tmdscten_shift                                                (31)
+#define HDMI_TMDS_STR1_tmdscten_mask                                                 (0x80000000)
+#define HDMI_TMDS_STR1_tmdscten(data)                                                (0x80000000&((data)<<31))
+#define HDMI_TMDS_STR1_tmdscten_src(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR1_get_tmdscten(data)                                            ((0x80000000&(data))>>31)
+#define HDMI_TMDS_STR1_tdcsrc_shift                                                  (30)
+#define HDMI_TMDS_STR1_tdcsrc_mask                                                   (0x40000000)
+#define HDMI_TMDS_STR1_tdcsrc(data)                                                  (0x40000000&((data)<<30))
+#define HDMI_TMDS_STR1_tdcsrc_src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR1_get_tdcsrc(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_TMDS_STR1_tmdsctd_shift                                                 (16)
+#define HDMI_TMDS_STR1_tmdsctd_mask                                                  (0x03FF0000)
+#define HDMI_TMDS_STR1_tmdsctd(data)                                                 (0x03FF0000&((data)<<16))
+#define HDMI_TMDS_STR1_tmdsctd_src(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR1_get_tmdsctd(data)                                             ((0x03FF0000&(data))>>16)
+#define HDMI_TMDS_STR1_tmds2ten_shift                                                (15)
+#define HDMI_TMDS_STR1_tmds2ten_mask                                                 (0x00008000)
+#define HDMI_TMDS_STR1_tmds2ten(data)                                                (0x00008000&((data)<<15))
+#define HDMI_TMDS_STR1_tmds2ten_src(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR1_get_tmds2ten(data)                                            ((0x00008000&(data))>>15)
+#define HDMI_TMDS_STR1_td2src_shift                                                  (14)
+#define HDMI_TMDS_STR1_td2src_mask                                                   (0x00004000)
+#define HDMI_TMDS_STR1_td2src(data)                                                  (0x00004000&((data)<<14))
+#define HDMI_TMDS_STR1_td2src_src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR1_get_td2src(data)                                              ((0x00004000&(data))>>14)
+#define HDMI_TMDS_STR1_tmds2td_shift                                                 (0)
+#define HDMI_TMDS_STR1_tmds2td_mask                                                  (0x000003FF)
+#define HDMI_TMDS_STR1_tmds2td(data)                                                 (0x000003FF&((data)<<0))
+#define HDMI_TMDS_STR1_tmds2td_src(data)                                             ((0x000003FF&(data))>>0)
+#define HDMI_TMDS_STR1_get_tmds2td(data)                                             ((0x000003FF&(data))>>0)
+
+
+#define HDMI_ASPCR1                                                                  0x1800D054
+#define HDMI_ASPCR1_reg_addr                                                         "0xB800D054"
+#define HDMI_ASPCR1_reg                                                              0xB800D054
+#define set_HDMI_ASPCR1_reg(data)   (*((volatile unsigned int*) HDMI_ASPCR1_reg)=data)
+#define get_HDMI_ASPCR1_reg   (*((volatile unsigned int*) HDMI_ASPCR1_reg))
+#define HDMI_ASPCR1_inst_adr                                                         "0x0015"
+#define HDMI_ASPCR1_inst                                                             0x0015
+#define HDMI_ASPCR1_write_en8_shift                                                  (28)
+#define HDMI_ASPCR1_write_en8_mask                                                   (0x10000000)
+#define HDMI_ASPCR1_write_en8(data)                                                  (0x10000000&((data)<<28))
+#define HDMI_ASPCR1_write_en8_src(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ASPCR1_get_write_en8(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ASPCR1_ycbcr422_8bits_shift                                             (27)
+#define HDMI_ASPCR1_ycbcr422_8bits_mask                                              (0x08000000)
+#define HDMI_ASPCR1_ycbcr422_8bits(data)                                             (0x08000000&((data)<<27))
+#define HDMI_ASPCR1_ycbcr422_8bits_src(data)                                         ((0x08000000&(data))>>27)
+#define HDMI_ASPCR1_get_ycbcr422_8bits(data)                                         ((0x08000000&(data))>>27)
+#define HDMI_ASPCR1_write_en7_shift                                                  (26)
+#define HDMI_ASPCR1_write_en7_mask                                                   (0x04000000)
+#define HDMI_ASPCR1_write_en7(data)                                                  (0x04000000&((data)<<26))
+#define HDMI_ASPCR1_write_en7_src(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ASPCR1_get_write_en7(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ASPCR1_cts_pkt_hp_shift                                                 (25)
+#define HDMI_ASPCR1_cts_pkt_hp_mask                                                  (0x02000000)
+#define HDMI_ASPCR1_cts_pkt_hp(data)                                                 (0x02000000&((data)<<25))
+#define HDMI_ASPCR1_cts_pkt_hp_src(data)                                             ((0x02000000&(data))>>25)
+#define HDMI_ASPCR1_get_cts_pkt_hp(data)                                             ((0x02000000&(data))>>25)
+#define HDMI_ASPCR1_write_en6_shift                                                  (24)
+#define HDMI_ASPCR1_write_en6_mask                                                   (0x01000000)
+#define HDMI_ASPCR1_write_en6(data)                                                  (0x01000000&((data)<<24))
+#define HDMI_ASPCR1_write_en6_src(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ASPCR1_get_write_en6(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ASPCR1_Audioheader0_shift                                               (16)
+#define HDMI_ASPCR1_Audioheader0_mask                                                (0x00FF0000)
+#define HDMI_ASPCR1_Audioheader0(data)                                               (0x00FF0000&((data)<<16))
+#define HDMI_ASPCR1_Audioheader0_src(data)                                           ((0x00FF0000&(data))>>16)
+#define HDMI_ASPCR1_get_Audioheader0(data)                                           ((0x00FF0000&(data))>>16)
+#define HDMI_ASPCR1_write_en5_shift                                                  (15)
+#define HDMI_ASPCR1_write_en5_mask                                                   (0x00008000)
+#define HDMI_ASPCR1_write_en5(data)                                                  (0x00008000&((data)<<15))
+#define HDMI_ASPCR1_write_en5_src(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_ASPCR1_get_write_en5(data)                                              ((0x00008000&(data))>>15)
+#define HDMI_ASPCR1_samplepresent_shift                                              (11)
+#define HDMI_ASPCR1_samplepresent_mask                                               (0x00007800)
+#define HDMI_ASPCR1_samplepresent(data)                                              (0x00007800&((data)<<11))
+#define HDMI_ASPCR1_samplepresent_src(data)                                          ((0x00007800&(data))>>11)
+#define HDMI_ASPCR1_get_samplepresent(data)                                          ((0x00007800&(data))>>11)
+#define HDMI_ASPCR1_write_en4_shift                                                  (10)
+#define HDMI_ASPCR1_write_en4_mask                                                   (0x00000400)
+#define HDMI_ASPCR1_write_en4(data)                                                  (0x00000400&((data)<<10))
+#define HDMI_ASPCR1_write_en4_src(data)                                              ((0x00000400&(data))>>10)
+#define HDMI_ASPCR1_get_write_en4(data)                                              ((0x00000400&(data))>>10)
+#define HDMI_ASPCR1_forcesamplepresent_shift                                         (9)
+#define HDMI_ASPCR1_forcesamplepresent_mask                                          (0x00000200)
+#define HDMI_ASPCR1_forcesamplepresent(data)                                         (0x00000200&((data)<<9))
+#define HDMI_ASPCR1_forcesamplepresent_src(data)                                     ((0x00000200&(data))>>9)
+#define HDMI_ASPCR1_get_forcesamplepresent(data)                                     ((0x00000200&(data))>>9)
+#define HDMI_ASPCR1_write_en3_shift                                                  (8)
+#define HDMI_ASPCR1_write_en3_mask                                                   (0x00000100)
+#define HDMI_ASPCR1_write_en3(data)                                                  (0x00000100&((data)<<8))
+#define HDMI_ASPCR1_write_en3_src(data)                                              ((0x00000100&(data))>>8)
+#define HDMI_ASPCR1_get_write_en3(data)                                              ((0x00000100&(data))>>8)
+#define HDMI_ASPCR1_b_frame_shift                                                    (4)
+#define HDMI_ASPCR1_b_frame_mask                                                     (0x000000F0)
+#define HDMI_ASPCR1_b_frame(data)                                                    (0x000000F0&((data)<<4))
+#define HDMI_ASPCR1_b_frame_src(data)                                                ((0x000000F0&(data))>>4)
+#define HDMI_ASPCR1_get_b_frame(data)                                                ((0x000000F0&(data))>>4)
+#define HDMI_ASPCR1_write_en2_shift                                                  (3)
+#define HDMI_ASPCR1_write_en2_mask                                                   (0x00000008)
+#define HDMI_ASPCR1_write_en2(data)                                                  (0x00000008&((data)<<3))
+#define HDMI_ASPCR1_write_en2_src(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_ASPCR1_get_write_en2(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_ASPCR1_forceb_frame_shift                                               (2)
+#define HDMI_ASPCR1_forceb_frame_mask                                                (0x00000004)
+#define HDMI_ASPCR1_forceb_frame(data)                                               (0x00000004&((data)<<2))
+#define HDMI_ASPCR1_forceb_frame_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_ASPCR1_get_forceb_frame(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_ASPCR1_write_en1_shift                                                  (1)
+#define HDMI_ASPCR1_write_en1_mask                                                   (0x00000002)
+#define HDMI_ASPCR1_write_en1(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_ASPCR1_write_en1_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_ASPCR1_get_write_en1(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_ASPCR1_audiolayout_shift                                                (0)
+#define HDMI_ASPCR1_audiolayout_mask                                                 (0x00000001)
+#define HDMI_ASPCR1_audiolayout(data)                                                (0x00000001&((data)<<0))
+#define HDMI_ASPCR1_audiolayout_src(data)                                            ((0x00000001&(data))>>0)
+#define HDMI_ASPCR1_get_audiolayout(data)                                            ((0x00000001&(data))>>0)
+
+
+#define HDMI_ACACR                                                                   0x1800D058
+#define HDMI_ACACR_reg_addr                                                          "0xB800D058"
+#define HDMI_ACACR_reg                                                               0xB800D058
+#define set_HDMI_ACACR_reg(data)   (*((volatile unsigned int*) HDMI_ACACR_reg)=data)
+#define get_HDMI_ACACR_reg   (*((volatile unsigned int*) HDMI_ACACR_reg))
+#define HDMI_ACACR_inst_adr                                                          "0x0016"
+#define HDMI_ACACR_inst                                                              0x0016
+#define HDMI_ACACR_write_en4_shift                                                   (15)
+#define HDMI_ACACR_write_en4_mask                                                    (0x00008000)
+#define HDMI_ACACR_write_en4(data)                                                   (0x00008000&((data)<<15))
+#define HDMI_ACACR_write_en4_src(data)                                               ((0x00008000&(data))>>15)
+#define HDMI_ACACR_get_write_en4(data)                                               ((0x00008000&(data))>>15)
+#define HDMI_ACACR_hdmi_pk3map_shift                                                 (12)
+#define HDMI_ACACR_hdmi_pk3map_mask                                                  (0x00007000)
+#define HDMI_ACACR_hdmi_pk3map(data)                                                 (0x00007000&((data)<<12))
+#define HDMI_ACACR_hdmi_pk3map_src(data)                                             ((0x00007000&(data))>>12)
+#define HDMI_ACACR_get_hdmi_pk3map(data)                                             ((0x00007000&(data))>>12)
+#define HDMI_ACACR_write_en3_shift                                                   (11)
+#define HDMI_ACACR_write_en3_mask                                                    (0x00000800)
+#define HDMI_ACACR_write_en3(data)                                                   (0x00000800&((data)<<11))
+#define HDMI_ACACR_write_en3_src(data)                                               ((0x00000800&(data))>>11)
+#define HDMI_ACACR_get_write_en3(data)                                               ((0x00000800&(data))>>11)
+#define HDMI_ACACR_hdmi_pk2map_shift                                                 (8)
+#define HDMI_ACACR_hdmi_pk2map_mask                                                  (0x00000700)
+#define HDMI_ACACR_hdmi_pk2map(data)                                                 (0x00000700&((data)<<8))
+#define HDMI_ACACR_hdmi_pk2map_src(data)                                             ((0x00000700&(data))>>8)
+#define HDMI_ACACR_get_hdmi_pk2map(data)                                             ((0x00000700&(data))>>8)
+#define HDMI_ACACR_write_en2_shift                                                   (7)
+#define HDMI_ACACR_write_en2_mask                                                    (0x00000080)
+#define HDMI_ACACR_write_en2(data)                                                   (0x00000080&((data)<<7))
+#define HDMI_ACACR_write_en2_src(data)                                               ((0x00000080&(data))>>7)
+#define HDMI_ACACR_get_write_en2(data)                                               ((0x00000080&(data))>>7)
+#define HDMI_ACACR_hdmi_pk1map_shift                                                 (4)
+#define HDMI_ACACR_hdmi_pk1map_mask                                                  (0x00000070)
+#define HDMI_ACACR_hdmi_pk1map(data)                                                 (0x00000070&((data)<<4))
+#define HDMI_ACACR_hdmi_pk1map_src(data)                                             ((0x00000070&(data))>>4)
+#define HDMI_ACACR_get_hdmi_pk1map(data)                                             ((0x00000070&(data))>>4)
+#define HDMI_ACACR_write_en1_shift                                                   (3)
+#define HDMI_ACACR_write_en1_mask                                                    (0x00000008)
+#define HDMI_ACACR_write_en1(data)                                                   (0x00000008&((data)<<3))
+#define HDMI_ACACR_write_en1_src(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_ACACR_get_write_en1(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_ACACR_hdmi_pk0map_shift                                                 (0)
+#define HDMI_ACACR_hdmi_pk0map_mask                                                  (0x00000007)
+#define HDMI_ACACR_hdmi_pk0map(data)                                                 (0x00000007&((data)<<0))
+#define HDMI_ACACR_hdmi_pk0map_src(data)                                             ((0x00000007&(data))>>0)
+#define HDMI_ACACR_get_hdmi_pk0map(data)                                             ((0x00000007&(data))>>0)
+
+
+#define HDMI_ACRPCR                                                                  0x1800D06c
+#define HDMI_ACRPCR_reg_addr                                                         "0xB800D06C"
+#define HDMI_ACRPCR_reg                                                              0xB800D06C
+#define set_HDMI_ACRPCR_reg(data)   (*((volatile unsigned int*) HDMI_ACRPCR_reg)=data)
+#define get_HDMI_ACRPCR_reg   (*((volatile unsigned int*) HDMI_ACRPCR_reg))
+#define HDMI_ACRPCR_inst_adr                                                         "0x001B"
+#define HDMI_ACRPCR_inst                                                             0x001B
+#define HDMI_ACRPCR_write_en6_shift                                                  (30)
+#define HDMI_ACRPCR_write_en6_mask                                                   (0x40000000)
+#define HDMI_ACRPCR_write_en6(data)                                                  (0x40000000&((data)<<30))
+#define HDMI_ACRPCR_write_en6_src(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_ACRPCR_get_write_en6(data)                                              ((0x40000000&(data))>>30)
+#define HDMI_ACRPCR_Audio_info_hp_shift                                              (29)
+#define HDMI_ACRPCR_Audio_info_hp_mask                                               (0x20000000)
+#define HDMI_ACRPCR_Audio_info_hp(data)                                              (0x20000000&((data)<<29))
+#define HDMI_ACRPCR_Audio_info_hp_src(data)                                          ((0x20000000&(data))>>29)
+#define HDMI_ACRPCR_get_Audio_info_hp(data)                                          ((0x20000000&(data))>>29)
+#define HDMI_ACRPCR_write_en5_shift                                                  (28)
+#define HDMI_ACRPCR_write_en5_mask                                                   (0x10000000)
+#define HDMI_ACRPCR_write_en5(data)                                                  (0x10000000&((data)<<28))
+#define HDMI_ACRPCR_write_en5_src(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ACRPCR_get_write_en5(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_ACRPCR_ac_hw_ctrl_en_shift                                              (27)
+#define HDMI_ACRPCR_ac_hw_ctrl_en_mask                                               (0x08000000)
+#define HDMI_ACRPCR_ac_hw_ctrl_en(data)                                              (0x08000000&((data)<<27))
+#define HDMI_ACRPCR_ac_hw_ctrl_en_src(data)                                          ((0x08000000&(data))>>27)
+#define HDMI_ACRPCR_get_ac_hw_ctrl_en(data)                                          ((0x08000000&(data))>>27)
+#define HDMI_ACRPCR_write_en4_shift                                                  (26)
+#define HDMI_ACRPCR_write_en4_mask                                                   (0x04000000)
+#define HDMI_ACRPCR_write_en4(data)                                                  (0x04000000&((data)<<26))
+#define HDMI_ACRPCR_write_en4_src(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ACRPCR_get_write_en4(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_ACRPCR_fs_div4_shift                                                    (25)
+#define HDMI_ACRPCR_fs_div4_mask                                                     (0x02000000)
+#define HDMI_ACRPCR_fs_div4(data)                                                    (0x02000000&((data)<<25))
+#define HDMI_ACRPCR_fs_div4_src(data)                                                ((0x02000000&(data))>>25)
+#define HDMI_ACRPCR_get_fs_div4(data)                                                ((0x02000000&(data))>>25)
+#define HDMI_ACRPCR_write_en3_shift                                                  (24)
+#define HDMI_ACRPCR_write_en3_mask                                                   (0x01000000)
+#define HDMI_ACRPCR_write_en3(data)                                                  (0x01000000&((data)<<24))
+#define HDMI_ACRPCR_write_en3_src(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ACRPCR_get_write_en3(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_ACRPCR_disablecrp_shift                                                 (23)
+#define HDMI_ACRPCR_disablecrp_mask                                                  (0x00800000)
+#define HDMI_ACRPCR_disablecrp(data)                                                 (0x00800000&((data)<<23))
+#define HDMI_ACRPCR_disablecrp_src(data)                                             ((0x00800000&(data))>>23)
+#define HDMI_ACRPCR_get_disablecrp(data)                                             ((0x00800000&(data))>>23)
+#define HDMI_ACRPCR_write_en2_shift                                                  (22)
+#define HDMI_ACRPCR_write_en2_mask                                                   (0x00400000)
+#define HDMI_ACRPCR_write_en2(data)                                                  (0x00400000&((data)<<22))
+#define HDMI_ACRPCR_write_en2_src(data)                                              ((0x00400000&(data))>>22)
+#define HDMI_ACRPCR_get_write_en2(data)                                              ((0x00400000&(data))>>22)
+#define HDMI_ACRPCR_cts_source_shift                                                 (21)
+#define HDMI_ACRPCR_cts_source_mask                                                  (0x00200000)
+#define HDMI_ACRPCR_cts_source(data)                                                 (0x00200000&((data)<<21))
+#define HDMI_ACRPCR_cts_source_src(data)                                             ((0x00200000&(data))>>21)
+#define HDMI_ACRPCR_get_cts_source(data)                                             ((0x00200000&(data))>>21)
+#define HDMI_ACRPCR_write_en1_shift                                                  (20)
+#define HDMI_ACRPCR_write_en1_mask                                                   (0x00100000)
+#define HDMI_ACRPCR_write_en1(data)                                                  (0x00100000&((data)<<20))
+#define HDMI_ACRPCR_write_en1_src(data)                                              ((0x00100000&(data))>>20)
+#define HDMI_ACRPCR_get_write_en1(data)                                              ((0x00100000&(data))>>20)
+#define HDMI_ACRPCR_n_value_shift                                                    (0)
+#define HDMI_ACRPCR_n_value_mask                                                     (0x000FFFFF)
+#define HDMI_ACRPCR_n_value(data)                                                    (0x000FFFFF&((data)<<0))
+#define HDMI_ACRPCR_n_value_src(data)                                                ((0x000FFFFF&(data))>>0)
+#define HDMI_ACRPCR_get_n_value(data)                                                ((0x000FFFFF&(data))>>0)
+
+
+#define HDMI_ACRPCTSR                                                                0x1800D070
+#define HDMI_ACRPCTSR_reg_addr                                                       "0xB800D070"
+#define HDMI_ACRPCTSR_reg                                                            0xB800D070
+#define set_HDMI_ACRPCTSR_reg(data)   (*((volatile unsigned int*) HDMI_ACRPCTSR_reg)=data)
+#define get_HDMI_ACRPCTSR_reg   (*((volatile unsigned int*) HDMI_ACRPCTSR_reg))
+#define HDMI_ACRPCTSR_inst_adr                                                       "0x001C"
+#define HDMI_ACRPCTSR_inst                                                           0x001C
+#define HDMI_ACRPCTSR_ctssw_shift                                                    (0)
+#define HDMI_ACRPCTSR_ctssw_mask                                                     (0x000FFFFF)
+#define HDMI_ACRPCTSR_ctssw(data)                                                    (0x000FFFFF&((data)<<0))
+#define HDMI_ACRPCTSR_ctssw_src(data)                                                ((0x000FFFFF&(data))>>0)
+#define HDMI_ACRPCTSR_get_ctssw(data)                                                ((0x000FFFFF&(data))>>0)
+
+
+#define HDMI_ACRPPR                                                                  0x1800D074
+#define HDMI_ACRPPR_reg_addr                                                         "0xB800D074"
+#define HDMI_ACRPPR_reg                                                              0xB800D074
+#define set_HDMI_ACRPPR_reg(data)   (*((volatile unsigned int*) HDMI_ACRPPR_reg)=data)
+#define get_HDMI_ACRPPR_reg   (*((volatile unsigned int*) HDMI_ACRPPR_reg))
+#define HDMI_ACRPPR_inst_adr                                                         "0x001D"
+#define HDMI_ACRPPR_inst                                                             0x001D
+#define HDMI_ACRPPR_ctshw_shift                                                      (0)
+#define HDMI_ACRPPR_ctshw_mask                                                       (0x000FFFFF)
+#define HDMI_ACRPPR_ctshw(data)                                                      (0x000FFFFF&((data)<<0))
+#define HDMI_ACRPPR_ctshw_src(data)                                                  ((0x000FFFFF&(data))>>0)
+#define HDMI_ACRPPR_get_ctshw(data)                                                  ((0x000FFFFF&(data))>>0)
+
+
+#define HDMI_GCPCR                                                                   0x1800D078
+#define HDMI_GCPCR_reg_addr                                                          "0xB800D078"
+#define HDMI_GCPCR_reg                                                               0xB800D078
+#define set_HDMI_GCPCR_reg(data)   (*((volatile unsigned int*) HDMI_GCPCR_reg)=data)
+#define get_HDMI_GCPCR_reg   (*((volatile unsigned int*) HDMI_GCPCR_reg))
+#define HDMI_GCPCR_inst_adr                                                          "0x001E"
+#define HDMI_GCPCR_inst                                                              0x001E
+#define HDMI_GCPCR_enablegcp_shift                                                   (3)
+#define HDMI_GCPCR_enablegcp_mask                                                    (0x00000008)
+#define HDMI_GCPCR_enablegcp(data)                                                   (0x00000008&((data)<<3))
+#define HDMI_GCPCR_enablegcp_src(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_GCPCR_get_enablegcp(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_GCPCR_gcp_clearavmute_shift                                             (2)
+#define HDMI_GCPCR_gcp_clearavmute_mask                                              (0x00000004)
+#define HDMI_GCPCR_gcp_clearavmute(data)                                             (0x00000004&((data)<<2))
+#define HDMI_GCPCR_gcp_clearavmute_src(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_GCPCR_get_gcp_clearavmute(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_GCPCR_gcp_setavmute_shift                                               (1)
+#define HDMI_GCPCR_gcp_setavmute_mask                                                (0x00000002)
+#define HDMI_GCPCR_gcp_setavmute(data)                                               (0x00000002&((data)<<1))
+#define HDMI_GCPCR_gcp_setavmute_src(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_GCPCR_get_gcp_setavmute(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_GCPCR_write_data_shift                                                  (0)
+#define HDMI_GCPCR_write_data_mask                                                   (0x00000001)
+#define HDMI_GCPCR_write_data(data)                                                  (0x00000001&((data)<<0))
+#define HDMI_GCPCR_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define HDMI_GCPCR_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define HDMI_ORP6PH                                                                  0x1800D07c
+#define HDMI_ORP6PH_reg_addr                                                         "0xB800D07C"
+#define HDMI_ORP6PH_reg                                                              0xB800D07C
+#define set_HDMI_ORP6PH_reg(data)   (*((volatile unsigned int*) HDMI_ORP6PH_reg)=data)
+#define get_HDMI_ORP6PH_reg   (*((volatile unsigned int*) HDMI_ORP6PH_reg))
+#define HDMI_ORP6PH_inst_adr                                                         "0x001F"
+#define HDMI_ORP6PH_inst                                                             0x001F
+#define HDMI_ORP6PH_once_pkt_shift                                                   (0)
+#define HDMI_ORP6PH_once_pkt_mask                                                    (0xFFFFFFFF)
+#define HDMI_ORP6PH_once_pkt(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_ORP6PH_once_pkt_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_ORP6PH_get_once_pkt(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_ORP6W_0                                                                 0x1800D080
+#define HDMI_ORP6W_1                                                                 0x1800D084
+#define HDMI_ORP6W_2                                                                 0x1800D088
+#define HDMI_ORP6W_3                                                                 0x1800D08C
+#define HDMI_ORP6W_4                                                                 0x1800D090
+#define HDMI_ORP6W_5                                                                 0x1800D094
+#define HDMI_ORP6W_6                                                                 0x1800D098
+#define HDMI_ORP6W_7                                                                 0x1800D09C
+#define HDMI_ORP6W_0_reg_addr                                                        "0xB800D080"
+#define HDMI_ORP6W_1_reg_addr                                                        "0xB800D084"
+#define HDMI_ORP6W_2_reg_addr                                                        "0xB800D088"
+#define HDMI_ORP6W_3_reg_addr                                                        "0xB800D08C"
+#define HDMI_ORP6W_4_reg_addr                                                        "0xB800D090"
+#define HDMI_ORP6W_5_reg_addr                                                        "0xB800D094"
+#define HDMI_ORP6W_6_reg_addr                                                        "0xB800D098"
+#define HDMI_ORP6W_7_reg_addr                                                        "0xB800D09C"
+#define HDMI_ORP6W_0_reg                                                             0xB800D080
+#define HDMI_ORP6W_1_reg                                                             0xB800D084
+#define HDMI_ORP6W_2_reg                                                             0xB800D088
+#define HDMI_ORP6W_3_reg                                                             0xB800D08C
+#define HDMI_ORP6W_4_reg                                                             0xB800D090
+#define HDMI_ORP6W_5_reg                                                             0xB800D094
+#define HDMI_ORP6W_6_reg                                                             0xB800D098
+#define HDMI_ORP6W_7_reg                                                             0xB800D09C
+#define set_HDMI_ORP6W_0_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_0_reg)=data)
+#define set_HDMI_ORP6W_1_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_1_reg)=data)
+#define set_HDMI_ORP6W_2_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_2_reg)=data)
+#define set_HDMI_ORP6W_3_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_3_reg)=data)
+#define set_HDMI_ORP6W_4_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_4_reg)=data)
+#define set_HDMI_ORP6W_5_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_5_reg)=data)
+#define set_HDMI_ORP6W_6_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_6_reg)=data)
+#define set_HDMI_ORP6W_7_reg(data)   (*((volatile unsigned int*) HDMI_ORP6W_7_reg)=data)
+#define get_HDMI_ORP6W_0_reg   (*((volatile unsigned int*) HDMI_ORP6W_0_reg))
+#define get_HDMI_ORP6W_1_reg   (*((volatile unsigned int*) HDMI_ORP6W_1_reg))
+#define get_HDMI_ORP6W_2_reg   (*((volatile unsigned int*) HDMI_ORP6W_2_reg))
+#define get_HDMI_ORP6W_3_reg   (*((volatile unsigned int*) HDMI_ORP6W_3_reg))
+#define get_HDMI_ORP6W_4_reg   (*((volatile unsigned int*) HDMI_ORP6W_4_reg))
+#define get_HDMI_ORP6W_5_reg   (*((volatile unsigned int*) HDMI_ORP6W_5_reg))
+#define get_HDMI_ORP6W_6_reg   (*((volatile unsigned int*) HDMI_ORP6W_6_reg))
+#define get_HDMI_ORP6W_7_reg   (*((volatile unsigned int*) HDMI_ORP6W_7_reg))
+#define HDMI_ORP6W_0_inst_adr                                                        "0x0020"
+#define HDMI_ORP6W_1_inst_adr                                                        "0x0021"
+#define HDMI_ORP6W_2_inst_adr                                                        "0x0022"
+#define HDMI_ORP6W_3_inst_adr                                                        "0x0023"
+#define HDMI_ORP6W_4_inst_adr                                                        "0x0024"
+#define HDMI_ORP6W_5_inst_adr                                                        "0x0025"
+#define HDMI_ORP6W_6_inst_adr                                                        "0x0026"
+#define HDMI_ORP6W_7_inst_adr                                                        "0x0027"
+#define HDMI_ORP6W_0_inst                                                            0x0020
+#define HDMI_ORP6W_1_inst                                                            0x0021
+#define HDMI_ORP6W_2_inst                                                            0x0022
+#define HDMI_ORP6W_3_inst                                                            0x0023
+#define HDMI_ORP6W_4_inst                                                            0x0024
+#define HDMI_ORP6W_5_inst                                                            0x0025
+#define HDMI_ORP6W_6_inst                                                            0x0026
+#define HDMI_ORP6W_7_inst                                                            0x0027
+#define HDMI_ORP6W_once_pkt_shift                                                    (0)
+#define HDMI_ORP6W_once_pkt_mask                                                     (0xFFFFFFFF)
+#define HDMI_ORP6W_once_pkt(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_ORP6W_once_pkt_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_ORP6W_get_once_pkt(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_RPCR                                                                    0x1800D0a0
+#define HDMI_RPCR_reg_addr                                                           "0xB800D0A0"
+#define HDMI_RPCR_reg                                                                0xB800D0A0
+#define set_HDMI_RPCR_reg(data)   (*((volatile unsigned int*) HDMI_RPCR_reg)=data)
+#define get_HDMI_RPCR_reg   (*((volatile unsigned int*) HDMI_RPCR_reg))
+#define HDMI_RPCR_inst_adr                                                           "0x0028"
+#define HDMI_RPCR_inst                                                               0x0028
+#define HDMI_RPCR_write_en6_shift                                                    (29)
+#define HDMI_RPCR_write_en6_mask                                                     (0x20000000)
+#define HDMI_RPCR_write_en6(data)                                                    (0x20000000&((data)<<29))
+#define HDMI_RPCR_write_en6_src(data)                                                ((0x20000000&(data))>>29)
+#define HDMI_RPCR_get_write_en6(data)                                                ((0x20000000&(data))>>29)
+#define HDMI_RPCR_prp5period_shift                                                   (25)
+#define HDMI_RPCR_prp5period_mask                                                    (0x1E000000)
+#define HDMI_RPCR_prp5period(data)                                                   (0x1E000000&((data)<<25))
+#define HDMI_RPCR_prp5period_src(data)                                               ((0x1E000000&(data))>>25)
+#define HDMI_RPCR_get_prp5period(data)                                               ((0x1E000000&(data))>>25)
+#define HDMI_RPCR_write_en5_shift                                                    (24)
+#define HDMI_RPCR_write_en5_mask                                                     (0x01000000)
+#define HDMI_RPCR_write_en5(data)                                                    (0x01000000&((data)<<24))
+#define HDMI_RPCR_write_en5_src(data)                                                ((0x01000000&(data))>>24)
+#define HDMI_RPCR_get_write_en5(data)                                                ((0x01000000&(data))>>24)
+#define HDMI_RPCR_prp4period_shift                                                   (20)
+#define HDMI_RPCR_prp4period_mask                                                    (0x00F00000)
+#define HDMI_RPCR_prp4period(data)                                                   (0x00F00000&((data)<<20))
+#define HDMI_RPCR_prp4period_src(data)                                               ((0x00F00000&(data))>>20)
+#define HDMI_RPCR_get_prp4period(data)                                               ((0x00F00000&(data))>>20)
+#define HDMI_RPCR_write_en4_shift                                                    (19)
+#define HDMI_RPCR_write_en4_mask                                                     (0x00080000)
+#define HDMI_RPCR_write_en4(data)                                                    (0x00080000&((data)<<19))
+#define HDMI_RPCR_write_en4_src(data)                                                ((0x00080000&(data))>>19)
+#define HDMI_RPCR_get_write_en4(data)                                                ((0x00080000&(data))>>19)
+#define HDMI_RPCR_prp3period_shift                                                   (15)
+#define HDMI_RPCR_prp3period_mask                                                    (0x00078000)
+#define HDMI_RPCR_prp3period(data)                                                   (0x00078000&((data)<<15))
+#define HDMI_RPCR_prp3period_src(data)                                               ((0x00078000&(data))>>15)
+#define HDMI_RPCR_get_prp3period(data)                                               ((0x00078000&(data))>>15)
+#define HDMI_RPCR_write_en3_shift                                                    (14)
+#define HDMI_RPCR_write_en3_mask                                                     (0x00004000)
+#define HDMI_RPCR_write_en3(data)                                                    (0x00004000&((data)<<14))
+#define HDMI_RPCR_write_en3_src(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_RPCR_get_write_en3(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_RPCR_prp2period_shift                                                   (10)
+#define HDMI_RPCR_prp2period_mask                                                    (0x00003C00)
+#define HDMI_RPCR_prp2period(data)                                                   (0x00003C00&((data)<<10))
+#define HDMI_RPCR_prp2period_src(data)                                               ((0x00003C00&(data))>>10)
+#define HDMI_RPCR_get_prp2period(data)                                               ((0x00003C00&(data))>>10)
+#define HDMI_RPCR_write_en2_shift                                                    (9)
+#define HDMI_RPCR_write_en2_mask                                                     (0x00000200)
+#define HDMI_RPCR_write_en2(data)                                                    (0x00000200&((data)<<9))
+#define HDMI_RPCR_write_en2_src(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_RPCR_get_write_en2(data)                                                ((0x00000200&(data))>>9)
+#define HDMI_RPCR_prp1period_shift                                                   (5)
+#define HDMI_RPCR_prp1period_mask                                                    (0x000001E0)
+#define HDMI_RPCR_prp1period(data)                                                   (0x000001E0&((data)<<5))
+#define HDMI_RPCR_prp1period_src(data)                                               ((0x000001E0&(data))>>5)
+#define HDMI_RPCR_get_prp1period(data)                                               ((0x000001E0&(data))>>5)
+#define HDMI_RPCR_write_en1_shift                                                    (4)
+#define HDMI_RPCR_write_en1_mask                                                     (0x00000010)
+#define HDMI_RPCR_write_en1(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_RPCR_write_en1_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_RPCR_get_write_en1(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_RPCR_prp0period_shift                                                   (0)
+#define HDMI_RPCR_prp0period_mask                                                    (0x0000000F)
+#define HDMI_RPCR_prp0period(data)                                                   (0x0000000F&((data)<<0))
+#define HDMI_RPCR_prp0period_src(data)                                               ((0x0000000F&(data))>>0)
+#define HDMI_RPCR_get_prp0period(data)                                               ((0x0000000F&(data))>>0)
+
+
+#define HDMI_RPEN                                                                    0x1800D0a4
+#define HDMI_RPEN_reg_addr                                                           "0xB800D0A4"
+#define HDMI_RPEN_reg                                                                0xB800D0A4
+#define set_HDMI_RPEN_reg(data)   (*((volatile unsigned int*) HDMI_RPEN_reg)=data)
+#define get_HDMI_RPEN_reg   (*((volatile unsigned int*) HDMI_RPEN_reg))
+#define HDMI_RPEN_inst_adr                                                           "0x0029"
+#define HDMI_RPEN_inst                                                               0x0029
+#define HDMI_RPEN_enprpkt5_shift                                                     (6)
+#define HDMI_RPEN_enprpkt5_mask                                                      (0x00000040)
+#define HDMI_RPEN_enprpkt5(data)                                                     (0x00000040&((data)<<6))
+#define HDMI_RPEN_enprpkt5_src(data)                                                 ((0x00000040&(data))>>6)
+#define HDMI_RPEN_get_enprpkt5(data)                                                 ((0x00000040&(data))>>6)
+#define HDMI_RPEN_enprpkt4_shift                                                     (5)
+#define HDMI_RPEN_enprpkt4_mask                                                      (0x00000020)
+#define HDMI_RPEN_enprpkt4(data)                                                     (0x00000020&((data)<<5))
+#define HDMI_RPEN_enprpkt4_src(data)                                                 ((0x00000020&(data))>>5)
+#define HDMI_RPEN_get_enprpkt4(data)                                                 ((0x00000020&(data))>>5)
+#define HDMI_RPEN_enprpkt3_shift                                                     (4)
+#define HDMI_RPEN_enprpkt3_mask                                                      (0x00000010)
+#define HDMI_RPEN_enprpkt3(data)                                                     (0x00000010&((data)<<4))
+#define HDMI_RPEN_enprpkt3_src(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_RPEN_get_enprpkt3(data)                                                 ((0x00000010&(data))>>4)
+#define HDMI_RPEN_enprpkt2_shift                                                     (3)
+#define HDMI_RPEN_enprpkt2_mask                                                      (0x00000008)
+#define HDMI_RPEN_enprpkt2(data)                                                     (0x00000008&((data)<<3))
+#define HDMI_RPEN_enprpkt2_src(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_RPEN_get_enprpkt2(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_RPEN_enprpkt1_shift                                                     (2)
+#define HDMI_RPEN_enprpkt1_mask                                                      (0x00000004)
+#define HDMI_RPEN_enprpkt1(data)                                                     (0x00000004&((data)<<2))
+#define HDMI_RPEN_enprpkt1_src(data)                                                 ((0x00000004&(data))>>2)
+#define HDMI_RPEN_get_enprpkt1(data)                                                 ((0x00000004&(data))>>2)
+#define HDMI_RPEN_enprpkt0_shift                                                     (1)
+#define HDMI_RPEN_enprpkt0_mask                                                      (0x00000002)
+#define HDMI_RPEN_enprpkt0(data)                                                     (0x00000002&((data)<<1))
+#define HDMI_RPEN_enprpkt0_src(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_RPEN_get_enprpkt0(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_RPEN_write_data_shift                                                   (0)
+#define HDMI_RPEN_write_data_mask                                                    (0x00000001)
+#define HDMI_RPEN_write_data(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_RPEN_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_RPEN_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_RPRBDR                                                                  0x1800D0a8
+#define HDMI_RPRBDR_reg_addr                                                         "0xB800D0A8"
+#define HDMI_RPRBDR_reg                                                              0xB800D0A8
+#define set_HDMI_RPRBDR_reg(data)   (*((volatile unsigned int*) HDMI_RPRBDR_reg)=data)
+#define get_HDMI_RPRBDR_reg   (*((volatile unsigned int*) HDMI_RPRBDR_reg))
+#define HDMI_RPRBDR_inst_adr                                                         "0x002A"
+#define HDMI_RPRBDR_inst                                                             0x002A
+#define HDMI_RPRBDR_isramrbd_shift                                                   (0)
+#define HDMI_RPRBDR_isramrbd_mask                                                    (0x0003FFFF)
+#define HDMI_RPRBDR_isramrbd(data)                                                   (0x0003FFFF&((data)<<0))
+#define HDMI_RPRBDR_isramrbd_src(data)                                               ((0x0003FFFF&(data))>>0)
+#define HDMI_RPRBDR_get_isramrbd(data)                                               ((0x0003FFFF&(data))>>0)
+
+
+#define HDMI_OPCR                                                                    0x1800D0b0
+#define HDMI_OPCR_reg_addr                                                           "0xB800D0B0"
+#define HDMI_OPCR_reg                                                                0xB800D0B0
+#define set_HDMI_OPCR_reg(data)   (*((volatile unsigned int*) HDMI_OPCR_reg)=data)
+#define get_HDMI_OPCR_reg   (*((volatile unsigned int*) HDMI_OPCR_reg))
+#define HDMI_OPCR_inst_adr                                                           "0x002C"
+#define HDMI_OPCR_inst                                                               0x002C
+#define HDMI_OPCR_write_en4_shift                                                    (14)
+#define HDMI_OPCR_write_en4_mask                                                     (0x00004000)
+#define HDMI_OPCR_write_en4(data)                                                    (0x00004000&((data)<<14))
+#define HDMI_OPCR_write_en4_src(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_OPCR_get_write_en4(data)                                                ((0x00004000&(data))>>14)
+#define HDMI_OPCR_enrbpktsram_shift                                                  (13)
+#define HDMI_OPCR_enrbpktsram_mask                                                   (0x00002000)
+#define HDMI_OPCR_enrbpktsram(data)                                                  (0x00002000&((data)<<13))
+#define HDMI_OPCR_enrbpktsram_src(data)                                              ((0x00002000&(data))>>13)
+#define HDMI_OPCR_get_enrbpktsram(data)                                              ((0x00002000&(data))>>13)
+#define HDMI_OPCR_write_en3_shift                                                    (12)
+#define HDMI_OPCR_write_en3_mask                                                     (0x00001000)
+#define HDMI_OPCR_write_en3(data)                                                    (0x00001000&((data)<<12))
+#define HDMI_OPCR_write_en3_src(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_OPCR_get_write_en3(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_OPCR_wrdes_shift                                                        (11)
+#define HDMI_OPCR_wrdes_mask                                                         (0x00000800)
+#define HDMI_OPCR_wrdes(data)                                                        (0x00000800&((data)<<11))
+#define HDMI_OPCR_wrdes_src(data)                                                    ((0x00000800&(data))>>11)
+#define HDMI_OPCR_get_wrdes(data)                                                    ((0x00000800&(data))>>11)
+#define HDMI_OPCR_write_en2_shift                                                    (10)
+#define HDMI_OPCR_write_en2_mask                                                     (0x00000400)
+#define HDMI_OPCR_write_en2(data)                                                    (0x00000400&((data)<<10))
+#define HDMI_OPCR_write_en2_src(data)                                                ((0x00000400&(data))>>10)
+#define HDMI_OPCR_get_write_en2(data)                                                ((0x00000400&(data))>>10)
+#define HDMI_OPCR_rprwcmd_shift                                                      (9)
+#define HDMI_OPCR_rprwcmd_mask                                                       (0x00000200)
+#define HDMI_OPCR_rprwcmd(data)                                                      (0x00000200&((data)<<9))
+#define HDMI_OPCR_rprwcmd_src(data)                                                  ((0x00000200&(data))>>9)
+#define HDMI_OPCR_get_rprwcmd(data)                                                  ((0x00000200&(data))>>9)
+#define HDMI_OPCR_write_en1_shift                                                    (8)
+#define HDMI_OPCR_write_en1_mask                                                     (0x00000100)
+#define HDMI_OPCR_write_en1(data)                                                    (0x00000100&((data)<<8))
+#define HDMI_OPCR_write_en1_src(data)                                                ((0x00000100&(data))>>8)
+#define HDMI_OPCR_get_write_en1(data)                                                ((0x00000100&(data))>>8)
+#define HDMI_OPCR_rpadd_shift                                                        (0)
+#define HDMI_OPCR_rpadd_mask                                                         (0x000000FF)
+#define HDMI_OPCR_rpadd(data)                                                        (0x000000FF&((data)<<0))
+#define HDMI_OPCR_rpadd_src(data)                                                    ((0x000000FF&(data))>>0)
+#define HDMI_OPCR_get_rpadd(data)                                                    ((0x000000FF&(data))>>0)
+
+
+#define HDMI_DIPCCR                                                                  0x1800D0b4
+#define HDMI_DIPCCR_reg_addr                                                         "0xB800D0B4"
+#define HDMI_DIPCCR_reg                                                              0xB800D0B4
+#define set_HDMI_DIPCCR_reg(data)   (*((volatile unsigned int*) HDMI_DIPCCR_reg)=data)
+#define get_HDMI_DIPCCR_reg   (*((volatile unsigned int*) HDMI_DIPCCR_reg))
+#define HDMI_DIPCCR_inst_adr                                                         "0x002D"
+#define HDMI_DIPCCR_inst                                                             0x002D
+#define HDMI_DIPCCR_write_en2_shift                                                  (11)
+#define HDMI_DIPCCR_write_en2_mask                                                   (0x00000800)
+#define HDMI_DIPCCR_write_en2(data)                                                  (0x00000800&((data)<<11))
+#define HDMI_DIPCCR_write_en2_src(data)                                              ((0x00000800&(data))>>11)
+#define HDMI_DIPCCR_get_write_en2(data)                                              ((0x00000800&(data))>>11)
+#define HDMI_DIPCCR_vbidipcnt_shift                                                  (6)
+#define HDMI_DIPCCR_vbidipcnt_mask                                                   (0x000007C0)
+#define HDMI_DIPCCR_vbidipcnt(data)                                                  (0x000007C0&((data)<<6))
+#define HDMI_DIPCCR_vbidipcnt_src(data)                                              ((0x000007C0&(data))>>6)
+#define HDMI_DIPCCR_get_vbidipcnt(data)                                              ((0x000007C0&(data))>>6)
+#define HDMI_DIPCCR_write_en1_shift                                                  (5)
+#define HDMI_DIPCCR_write_en1_mask                                                   (0x00000020)
+#define HDMI_DIPCCR_write_en1(data)                                                  (0x00000020&((data)<<5))
+#define HDMI_DIPCCR_write_en1_src(data)                                              ((0x00000020&(data))>>5)
+#define HDMI_DIPCCR_get_write_en1(data)                                              ((0x00000020&(data))>>5)
+#define HDMI_DIPCCR_hbidipcnt_shift                                                  (0)
+#define HDMI_DIPCCR_hbidipcnt_mask                                                   (0x0000001F)
+#define HDMI_DIPCCR_hbidipcnt(data)                                                  (0x0000001F&((data)<<0))
+#define HDMI_DIPCCR_hbidipcnt_src(data)                                              ((0x0000001F&(data))>>0)
+#define HDMI_DIPCCR_get_hbidipcnt(data)                                              ((0x0000001F&(data))>>0)
+
+
+#define HDMI_SCHCR                                                                   0x1800D0b8
+#define HDMI_SCHCR_reg_addr                                                          "0xB800D0B8"
+#define HDMI_SCHCR_reg                                                               0xB800D0B8
+#define set_HDMI_SCHCR_reg(data)   (*((volatile unsigned int*) HDMI_SCHCR_reg)=data)
+#define get_HDMI_SCHCR_reg   (*((volatile unsigned int*) HDMI_SCHCR_reg))
+#define HDMI_SCHCR_inst_adr                                                          "0x002E"
+#define HDMI_SCHCR_inst                                                              0x002E
+#define HDMI_SCHCR_write_en12_shift                                                  (28)
+#define HDMI_SCHCR_write_en12_mask                                                   (0x10000000)
+#define HDMI_SCHCR_write_en12(data)                                                  (0x10000000&((data)<<28))
+#define HDMI_SCHCR_write_en12_src(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_SCHCR_get_write_en12(data)                                              ((0x10000000&(data))>>28)
+#define HDMI_SCHCR_color_transform_en_shift                                          (27)
+#define HDMI_SCHCR_color_transform_en_mask                                           (0x08000000)
+#define HDMI_SCHCR_color_transform_en(data)                                          (0x08000000&((data)<<27))
+#define HDMI_SCHCR_color_transform_en_src(data)                                      ((0x08000000&(data))>>27)
+#define HDMI_SCHCR_get_color_transform_en(data)                                      ((0x08000000&(data))>>27)
+#define HDMI_SCHCR_write_en11_shift                                                  (26)
+#define HDMI_SCHCR_write_en11_mask                                                   (0x04000000)
+#define HDMI_SCHCR_write_en11(data)                                                  (0x04000000&((data)<<26))
+#define HDMI_SCHCR_write_en11_src(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_SCHCR_get_write_en11(data)                                              ((0x04000000&(data))>>26)
+#define HDMI_SCHCR_ycbcr422_algo_shift                                               (25)
+#define HDMI_SCHCR_ycbcr422_algo_mask                                                (0x02000000)
+#define HDMI_SCHCR_ycbcr422_algo(data)                                               (0x02000000&((data)<<25))
+#define HDMI_SCHCR_ycbcr422_algo_src(data)                                           ((0x02000000&(data))>>25)
+#define HDMI_SCHCR_get_ycbcr422_algo(data)                                           ((0x02000000&(data))>>25)
+#define HDMI_SCHCR_write_en10_shift                                                  (24)
+#define HDMI_SCHCR_write_en10_mask                                                   (0x01000000)
+#define HDMI_SCHCR_write_en10(data)                                                  (0x01000000&((data)<<24))
+#define HDMI_SCHCR_write_en10_src(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_SCHCR_get_write_en10(data)                                              ((0x01000000&(data))>>24)
+#define HDMI_SCHCR_422_pixel_repeat_shift                                            (23)
+#define HDMI_SCHCR_422_pixel_repeat_mask                                             (0x00800000)
+#define HDMI_SCHCR_422_pixel_repeat(data)                                            (0x00800000&((data)<<23))
+#define HDMI_SCHCR_422_pixel_repeat_src(data)                                        ((0x00800000&(data))>>23)
+#define HDMI_SCHCR_get_422_pixel_repeat(data)                                        ((0x00800000&(data))>>23)
+#define HDMI_SCHCR_write_en9_shift                                                   (22)
+#define HDMI_SCHCR_write_en9_mask                                                    (0x00400000)
+#define HDMI_SCHCR_write_en9(data)                                                   (0x00400000&((data)<<22))
+#define HDMI_SCHCR_write_en9_src(data)                                               ((0x00400000&(data))>>22)
+#define HDMI_SCHCR_get_write_en9(data)                                               ((0x00400000&(data))>>22)
+#define HDMI_SCHCR_vsyncpolin_shift                                                  (21)
+#define HDMI_SCHCR_vsyncpolin_mask                                                   (0x00200000)
+#define HDMI_SCHCR_vsyncpolin(data)                                                  (0x00200000&((data)<<21))
+#define HDMI_SCHCR_vsyncpolin_src(data)                                              ((0x00200000&(data))>>21)
+#define HDMI_SCHCR_get_vsyncpolin(data)                                              ((0x00200000&(data))>>21)
+#define HDMI_SCHCR_write_en8_shift                                                   (20)
+#define HDMI_SCHCR_write_en8_mask                                                    (0x00100000)
+#define HDMI_SCHCR_write_en8(data)                                                   (0x00100000&((data)<<20))
+#define HDMI_SCHCR_write_en8_src(data)                                               ((0x00100000&(data))>>20)
+#define HDMI_SCHCR_get_write_en8(data)                                               ((0x00100000&(data))>>20)
+#define HDMI_SCHCR_hsyncpolin_shift                                                  (19)
+#define HDMI_SCHCR_hsyncpolin_mask                                                   (0x00080000)
+#define HDMI_SCHCR_hsyncpolin(data)                                                  (0x00080000&((data)<<19))
+#define HDMI_SCHCR_hsyncpolin_src(data)                                              ((0x00080000&(data))>>19)
+#define HDMI_SCHCR_get_hsyncpolin(data)                                              ((0x00080000&(data))>>19)
+#define HDMI_SCHCR_write_en7_shift                                                   (18)
+#define HDMI_SCHCR_write_en7_mask                                                    (0x00040000)
+#define HDMI_SCHCR_write_en7(data)                                                   (0x00040000&((data)<<18))
+#define HDMI_SCHCR_write_en7_src(data)                                               ((0x00040000&(data))>>18)
+#define HDMI_SCHCR_get_write_en7(data)                                               ((0x00040000&(data))>>18)
+#define HDMI_SCHCR_vsyncpolinv_shift                                                 (17)
+#define HDMI_SCHCR_vsyncpolinv_mask                                                  (0x00020000)
+#define HDMI_SCHCR_vsyncpolinv(data)                                                 (0x00020000&((data)<<17))
+#define HDMI_SCHCR_vsyncpolinv_src(data)                                             ((0x00020000&(data))>>17)
+#define HDMI_SCHCR_get_vsyncpolinv(data)                                             ((0x00020000&(data))>>17)
+#define HDMI_SCHCR_write_en6_shift                                                   (16)
+#define HDMI_SCHCR_write_en6_mask                                                    (0x00010000)
+#define HDMI_SCHCR_write_en6(data)                                                   (0x00010000&((data)<<16))
+#define HDMI_SCHCR_write_en6_src(data)                                               ((0x00010000&(data))>>16)
+#define HDMI_SCHCR_get_write_en6(data)                                               ((0x00010000&(data))>>16)
+#define HDMI_SCHCR_hsyncpolinv_shift                                                 (15)
+#define HDMI_SCHCR_hsyncpolinv_mask                                                  (0x00008000)
+#define HDMI_SCHCR_hsyncpolinv(data)                                                 (0x00008000&((data)<<15))
+#define HDMI_SCHCR_hsyncpolinv_src(data)                                             ((0x00008000&(data))>>15)
+#define HDMI_SCHCR_get_hsyncpolinv(data)                                             ((0x00008000&(data))>>15)
+#define HDMI_SCHCR_write_en5_shift                                                   (14)
+#define HDMI_SCHCR_write_en5_mask                                                    (0x00004000)
+#define HDMI_SCHCR_write_en5(data)                                                   (0x00004000&((data)<<14))
+#define HDMI_SCHCR_write_en5_src(data)                                               ((0x00004000&(data))>>14)
+#define HDMI_SCHCR_get_write_en5(data)                                               ((0x00004000&(data))>>14)
+#define HDMI_SCHCR_pixelencycbcr422_shift                                            (13)
+#define HDMI_SCHCR_pixelencycbcr422_mask                                             (0x00002000)
+#define HDMI_SCHCR_pixelencycbcr422(data)                                            (0x00002000&((data)<<13))
+#define HDMI_SCHCR_pixelencycbcr422_src(data)                                        ((0x00002000&(data))>>13)
+#define HDMI_SCHCR_get_pixelencycbcr422(data)                                        ((0x00002000&(data))>>13)
+#define HDMI_SCHCR_write_en4_shift                                                   (12)
+#define HDMI_SCHCR_write_en4_mask                                                    (0x00001000)
+#define HDMI_SCHCR_write_en4(data)                                                   (0x00001000&((data)<<12))
+#define HDMI_SCHCR_write_en4_src(data)                                               ((0x00001000&(data))>>12)
+#define HDMI_SCHCR_get_write_en4(data)                                               ((0x00001000&(data))>>12)
+#define HDMI_SCHCR_hdmi_videoxs_shift                                                (7)
+#define HDMI_SCHCR_hdmi_videoxs_mask                                                 (0x00000F80)
+#define HDMI_SCHCR_hdmi_videoxs(data)                                                (0x00000F80&((data)<<7))
+#define HDMI_SCHCR_hdmi_videoxs_src(data)                                            ((0x00000F80&(data))>>7)
+#define HDMI_SCHCR_get_hdmi_videoxs(data)                                            ((0x00000F80&(data))>>7)
+#define HDMI_SCHCR_write_en3_shift                                                   (6)
+#define HDMI_SCHCR_write_en3_mask                                                    (0x00000040)
+#define HDMI_SCHCR_write_en3(data)                                                   (0x00000040&((data)<<6))
+#define HDMI_SCHCR_write_en3_src(data)                                               ((0x00000040&(data))>>6)
+#define HDMI_SCHCR_get_write_en3(data)                                               ((0x00000040&(data))>>6)
+#define HDMI_SCHCR_pixelencfmt_shift                                                 (4)
+#define HDMI_SCHCR_pixelencfmt_mask                                                  (0x00000030)
+#define HDMI_SCHCR_pixelencfmt(data)                                                 (0x00000030&((data)<<4))
+#define HDMI_SCHCR_pixelencfmt_src(data)                                             ((0x00000030&(data))>>4)
+#define HDMI_SCHCR_get_pixelencfmt(data)                                             ((0x00000030&(data))>>4)
+#define HDMI_SCHCR_write_en2_shift                                                   (3)
+#define HDMI_SCHCR_write_en2_mask                                                    (0x00000008)
+#define HDMI_SCHCR_write_en2(data)                                                   (0x00000008&((data)<<3))
+#define HDMI_SCHCR_write_en2_src(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_SCHCR_get_write_en2(data)                                               ((0x00000008&(data))>>3)
+#define HDMI_SCHCR_pixelrepeat_shift                                                 (2)
+#define HDMI_SCHCR_pixelrepeat_mask                                                  (0x00000004)
+#define HDMI_SCHCR_pixelrepeat(data)                                                 (0x00000004&((data)<<2))
+#define HDMI_SCHCR_pixelrepeat_src(data)                                             ((0x00000004&(data))>>2)
+#define HDMI_SCHCR_get_pixelrepeat(data)                                             ((0x00000004&(data))>>2)
+#define HDMI_SCHCR_write_en1_shift                                                   (1)
+#define HDMI_SCHCR_write_en1_mask                                                    (0x00000002)
+#define HDMI_SCHCR_write_en1(data)                                                   (0x00000002&((data)<<1))
+#define HDMI_SCHCR_write_en1_src(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_SCHCR_get_write_en1(data)                                               ((0x00000002&(data))>>1)
+#define HDMI_SCHCR_hdmi_modesel_shift                                                (0)
+#define HDMI_SCHCR_hdmi_modesel_mask                                                 (0x00000001)
+#define HDMI_SCHCR_hdmi_modesel(data)                                                (0x00000001&((data)<<0))
+#define HDMI_SCHCR_hdmi_modesel_src(data)                                            ((0x00000001&(data))>>0)
+#define HDMI_SCHCR_get_hdmi_modesel(data)                                            ((0x00000001&(data))>>0)
+
+
+#define HDMI_ICR                                                                     0x1800D0bc
+#define HDMI_ICR_reg_addr                                                            "0xB800D0BC"
+#define HDMI_ICR_reg                                                                 0xB800D0BC
+#define set_HDMI_ICR_reg(data)   (*((volatile unsigned int*) HDMI_ICR_reg)=data)
+#define get_HDMI_ICR_reg   (*((volatile unsigned int*) HDMI_ICR_reg))
+#define HDMI_ICR_inst_adr                                                            "0x002F"
+#define HDMI_ICR_inst                                                                0x002F
+#define HDMI_ICR_write_en3_shift                                                     (28)
+#define HDMI_ICR_write_en3_mask                                                      (0x10000000)
+#define HDMI_ICR_write_en3(data)                                                     (0x10000000&((data)<<28))
+#define HDMI_ICR_write_en3_src(data)                                                 ((0x10000000&(data))>>28)
+#define HDMI_ICR_get_write_en3(data)                                                 ((0x10000000&(data))>>28)
+#define HDMI_ICR_enaudio_shift                                                       (27)
+#define HDMI_ICR_enaudio_mask                                                        (0x08000000)
+#define HDMI_ICR_enaudio(data)                                                       (0x08000000&((data)<<27))
+#define HDMI_ICR_enaudio_src(data)                                                   ((0x08000000&(data))>>27)
+#define HDMI_ICR_get_enaudio(data)                                                   ((0x08000000&(data))>>27)
+#define HDMI_ICR_write_en2_shift                                                     (26)
+#define HDMI_ICR_write_en2_mask                                                      (0x04000000)
+#define HDMI_ICR_write_en2(data)                                                     (0x04000000&((data)<<26))
+#define HDMI_ICR_write_en2_src(data)                                                 ((0x04000000&(data))>>26)
+#define HDMI_ICR_get_write_en2(data)                                                 ((0x04000000&(data))>>26)
+#define HDMI_ICR_envitd_shift                                                        (25)
+#define HDMI_ICR_envitd_mask                                                         (0x02000000)
+#define HDMI_ICR_envitd(data)                                                        (0x02000000&((data)<<25))
+#define HDMI_ICR_envitd_src(data)                                                    ((0x02000000&(data))>>25)
+#define HDMI_ICR_get_envitd(data)                                                    ((0x02000000&(data))>>25)
+#define HDMI_ICR_write_en1_shift                                                     (24)
+#define HDMI_ICR_write_en1_mask                                                      (0x01000000)
+#define HDMI_ICR_write_en1(data)                                                     (0x01000000&((data)<<24))
+#define HDMI_ICR_write_en1_src(data)                                                 ((0x01000000&(data))>>24)
+#define HDMI_ICR_get_write_en1(data)                                                 ((0x01000000&(data))>>24)
+#define HDMI_ICR_vitd_shift                                                          (0)
+#define HDMI_ICR_vitd_mask                                                           (0x00FFFFFF)
+#define HDMI_ICR_vitd(data)                                                          (0x00FFFFFF&((data)<<0))
+#define HDMI_ICR_vitd_src(data)                                                      ((0x00FFFFFF&(data))>>0)
+#define HDMI_ICR_get_vitd(data)                                                      ((0x00FFFFFF&(data))>>0)
+
+
+#define HDMI_ICR1                                                                    0x1800D150
+#define HDMI_ICR1_reg_addr                                                           "0xB800D150"
+#define HDMI_ICR1_reg                                                                0xB800D150
+#define set_HDMI_ICR1_reg(data)   (*((volatile unsigned int*) HDMI_ICR1_reg)=data)
+#define get_HDMI_ICR1_reg   (*((volatile unsigned int*) HDMI_ICR1_reg))
+#define HDMI_ICR1_inst_adr                                                           "0x0054"
+#define HDMI_ICR1_inst                                                               0x0054
+#define HDMI_ICR1_write_en1_shift                                                    (12)
+#define HDMI_ICR1_write_en1_mask                                                     (0x00001000)
+#define HDMI_ICR1_write_en1(data)                                                    (0x00001000&((data)<<12))
+#define HDMI_ICR1_write_en1_src(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_ICR1_get_write_en1(data)                                                ((0x00001000&(data))>>12)
+#define HDMI_ICR1_vitd_shift                                                         (0)
+#define HDMI_ICR1_vitd_mask                                                          (0x00000FFF)
+#define HDMI_ICR1_vitd(data)                                                         (0x00000FFF&((data)<<0))
+#define HDMI_ICR1_vitd_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define HDMI_ICR1_get_vitd(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_CRCCR                                                                   0x1800D0c0
+#define HDMI_CRCCR_reg_addr                                                          "0xB800D0C0"
+#define HDMI_CRCCR_reg                                                               0xB800D0C0
+#define set_HDMI_CRCCR_reg(data)   (*((volatile unsigned int*) HDMI_CRCCR_reg)=data)
+#define get_HDMI_CRCCR_reg   (*((volatile unsigned int*) HDMI_CRCCR_reg))
+#define HDMI_CRCCR_inst_adr                                                          "0x0030"
+#define HDMI_CRCCR_inst                                                              0x0030
+#define HDMI_CRCCR_write_en2_shift                                                   (4)
+#define HDMI_CRCCR_write_en2_mask                                                    (0x00000010)
+#define HDMI_CRCCR_write_en2(data)                                                   (0x00000010&((data)<<4))
+#define HDMI_CRCCR_write_en2_src(data)                                               ((0x00000010&(data))>>4)
+#define HDMI_CRCCR_get_write_en2(data)                                               ((0x00000010&(data))>>4)
+#define HDMI_CRCCR_crcmode_shift                                                     (3)
+#define HDMI_CRCCR_crcmode_mask                                                      (0x00000008)
+#define HDMI_CRCCR_crcmode(data)                                                     (0x00000008&((data)<<3))
+#define HDMI_CRCCR_crcmode_src(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_CRCCR_get_crcmode(data)                                                 ((0x00000008&(data))>>3)
+#define HDMI_CRCCR_write_en1_shift                                                   (2)
+#define HDMI_CRCCR_write_en1_mask                                                    (0x00000004)
+#define HDMI_CRCCR_write_en1(data)                                                   (0x00000004&((data)<<2))
+#define HDMI_CRCCR_write_en1_src(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_CRCCR_get_write_en1(data)                                               ((0x00000004&(data))>>2)
+#define HDMI_CRCCR_crcchsel_shift                                                    (0)
+#define HDMI_CRCCR_crcchsel_mask                                                     (0x00000003)
+#define HDMI_CRCCR_crcchsel(data)                                                    (0x00000003&((data)<<0))
+#define HDMI_CRCCR_crcchsel_src(data)                                                ((0x00000003&(data))>>0)
+#define HDMI_CRCCR_get_crcchsel(data)                                                ((0x00000003&(data))>>0)
+
+
+#define HDMI_CRCDOR                                                                  0x1800D0c4
+#define HDMI_CRCDOR_reg_addr                                                         "0xB800D0C4"
+#define HDMI_CRCDOR_reg                                                              0xB800D0C4
+#define set_HDMI_CRCDOR_reg(data)   (*((volatile unsigned int*) HDMI_CRCDOR_reg)=data)
+#define get_HDMI_CRCDOR_reg   (*((volatile unsigned int*) HDMI_CRCDOR_reg))
+#define HDMI_CRCDOR_inst_adr                                                         "0x0031"
+#define HDMI_CRCDOR_inst                                                             0x0031
+#define HDMI_CRCDOR_crcvalue_shift                                                   (0)
+#define HDMI_CRCDOR_crcvalue_mask                                                    (0xFFFFFFFF)
+#define HDMI_CRCDOR_crcvalue(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_CRCDOR_crcvalue_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_CRCDOR_get_crcvalue(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_KOWR                                                               0x1800D0f0
+#define HDMI_HDCP_KOWR_reg_addr                                                      "0xB800D0F0"
+#define HDMI_HDCP_KOWR_reg                                                           0xB800D0F0
+#define set_HDMI_HDCP_KOWR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KOWR_reg)=data)
+#define get_HDMI_HDCP_KOWR_reg   (*((volatile unsigned int*) HDMI_HDCP_KOWR_reg))
+#define HDMI_HDCP_KOWR_inst_adr                                                      "0x003C"
+#define HDMI_HDCP_KOWR_inst                                                          0x003C
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin_shift                                     (0)
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin_mask                                      (0x000000FF)
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin(data)                                     (0x000000FF&((data)<<0))
+#define HDMI_HDCP_KOWR_hdcprekeykeepoutwin_src(data)                                 ((0x000000FF&(data))>>0)
+#define HDMI_HDCP_KOWR_get_hdcprekeykeepoutwin(data)                                 ((0x000000FF&(data))>>0)
+
+
+#define HDMI_HDCP_KOWRSE                                                             0x1800D0f4
+#define HDMI_HDCP_KOWRSE_reg_addr                                                    "0xB800D0F4"
+#define HDMI_HDCP_KOWRSE_reg                                                         0xB800D0F4
+#define set_HDMI_HDCP_KOWRSE_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KOWRSE_reg)=data)
+#define get_HDMI_HDCP_KOWRSE_reg   (*((volatile unsigned int*) HDMI_HDCP_KOWRSE_reg))
+#define HDMI_HDCP_KOWRSE_inst_adr                                                    "0x003D"
+#define HDMI_HDCP_KOWRSE_inst                                                        0x003D
+#define HDMI_HDCP_KOWRSE_write_en2_shift                                             (25)
+#define HDMI_HDCP_KOWRSE_write_en2_mask                                              (0x02000000)
+#define HDMI_HDCP_KOWRSE_write_en2(data)                                             (0x02000000&((data)<<25))
+#define HDMI_HDCP_KOWRSE_write_en2_src(data)                                         ((0x02000000&(data))>>25)
+#define HDMI_HDCP_KOWRSE_get_write_en2(data)                                         ((0x02000000&(data))>>25)
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend_shift                                  (13)
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend_mask                                   (0x01FFE000)
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend(data)                                  (0x01FFE000&((data)<<13))
+#define HDMI_HDCP_KOWRSE_hdcpverkeepoutwinend_src(data)                              ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_KOWRSE_get_hdcpverkeepoutwinend(data)                              ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_KOWRSE_write_en1_shift                                             (12)
+#define HDMI_HDCP_KOWRSE_write_en1_mask                                              (0x00001000)
+#define HDMI_HDCP_KOWRSE_write_en1(data)                                             (0x00001000&((data)<<12))
+#define HDMI_HDCP_KOWRSE_write_en1_src(data)                                         ((0x00001000&(data))>>12)
+#define HDMI_HDCP_KOWRSE_get_write_en1(data)                                         ((0x00001000&(data))>>12)
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart_shift                               (0)
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart_mask                                (0x00000FFF)
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart(data)                               (0x00000FFF&((data)<<0))
+#define HDMI_HDCP_KOWRSE_hdcpvertkeepoutwinstart_src(data)                           ((0x00000FFF&(data))>>0)
+#define HDMI_HDCP_KOWRSE_get_hdcpvertkeepoutwinstart(data)                           ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_HDCP_OWR                                                                0x1800D0f8
+#define HDMI_HDCP_OWR_reg_addr                                                       "0xB800D0F8"
+#define HDMI_HDCP_OWR_reg                                                            0xB800D0F8
+#define set_HDMI_HDCP_OWR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_OWR_reg)=data)
+#define get_HDMI_HDCP_OWR_reg   (*((volatile unsigned int*) HDMI_HDCP_OWR_reg))
+#define HDMI_HDCP_OWR_inst_adr                                                       "0x003E"
+#define HDMI_HDCP_OWR_inst                                                           0x003E
+#define HDMI_HDCP_OWR_write_en2_shift                                                (25)
+#define HDMI_HDCP_OWR_write_en2_mask                                                 (0x02000000)
+#define HDMI_HDCP_OWR_write_en2(data)                                                (0x02000000&((data)<<25))
+#define HDMI_HDCP_OWR_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define HDMI_HDCP_OWR_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define HDMI_HDCP_OWR_hdcpoppwinend_shift                                            (13)
+#define HDMI_HDCP_OWR_hdcpoppwinend_mask                                             (0x01FFE000)
+#define HDMI_HDCP_OWR_hdcpoppwinend(data)                                            (0x01FFE000&((data)<<13))
+#define HDMI_HDCP_OWR_hdcpoppwinend_src(data)                                        ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_OWR_get_hdcpoppwinend(data)                                        ((0x01FFE000&(data))>>13)
+#define HDMI_HDCP_OWR_write_en1_shift                                                (12)
+#define HDMI_HDCP_OWR_write_en1_mask                                                 (0x00001000)
+#define HDMI_HDCP_OWR_write_en1(data)                                                (0x00001000&((data)<<12))
+#define HDMI_HDCP_OWR_write_en1_src(data)                                            ((0x00001000&(data))>>12)
+#define HDMI_HDCP_OWR_get_write_en1(data)                                            ((0x00001000&(data))>>12)
+#define HDMI_HDCP_OWR_hdcpoppwinstart_shift                                          (0)
+#define HDMI_HDCP_OWR_hdcpoppwinstart_mask                                           (0x00000FFF)
+#define HDMI_HDCP_OWR_hdcpoppwinstart(data)                                          (0x00000FFF&((data)<<0))
+#define HDMI_HDCP_OWR_hdcpoppwinstart_src(data)                                      ((0x00000FFF&(data))>>0)
+#define HDMI_HDCP_OWR_get_hdcpoppwinstart(data)                                      ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_HDCP_CR                                                                 0x1800D0fc
+#define HDMI_HDCP_CR_reg_addr                                                        "0xB800D0FC"
+#define HDMI_HDCP_CR_reg                                                             0xB800D0FC
+#define set_HDMI_HDCP_CR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_CR_reg)=data)
+#define get_HDMI_HDCP_CR_reg   (*((volatile unsigned int*) HDMI_HDCP_CR_reg))
+#define HDMI_HDCP_CR_inst_adr                                                        "0x003F"
+#define HDMI_HDCP_CR_inst                                                            0x003F
+#define HDMI_HDCP_CR_write_en4_shift                                                 (7)
+#define HDMI_HDCP_CR_write_en4_mask                                                  (0x00000080)
+#define HDMI_HDCP_CR_write_en4(data)                                                 (0x00000080&((data)<<7))
+#define HDMI_HDCP_CR_write_en4_src(data)                                             ((0x00000080&(data))>>7)
+#define HDMI_HDCP_CR_get_write_en4(data)                                             ((0x00000080&(data))>>7)
+#define HDMI_HDCP_CR_en1_1_feature_shift                                             (6)
+#define HDMI_HDCP_CR_en1_1_feature_mask                                              (0x00000040)
+#define HDMI_HDCP_CR_en1_1_feature(data)                                             (0x00000040&((data)<<6))
+#define HDMI_HDCP_CR_en1_1_feature_src(data)                                         ((0x00000040&(data))>>6)
+#define HDMI_HDCP_CR_get_en1_1_feature(data)                                         ((0x00000040&(data))>>6)
+#define HDMI_HDCP_CR_write_en3_shift                                                 (5)
+#define HDMI_HDCP_CR_write_en3_mask                                                  (0x00000020)
+#define HDMI_HDCP_CR_write_en3(data)                                                 (0x00000020&((data)<<5))
+#define HDMI_HDCP_CR_write_en3_src(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_HDCP_CR_get_write_en3(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_HDCP_CR_downstrisrepeater_shift                                         (4)
+#define HDMI_HDCP_CR_downstrisrepeater_mask                                          (0x00000010)
+#define HDMI_HDCP_CR_downstrisrepeater(data)                                         (0x00000010&((data)<<4))
+#define HDMI_HDCP_CR_downstrisrepeater_src(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_HDCP_CR_get_downstrisrepeater(data)                                     ((0x00000010&(data))>>4)
+#define HDMI_HDCP_CR_write_en2_shift                                                 (3)
+#define HDMI_HDCP_CR_write_en2_mask                                                  (0x00000008)
+#define HDMI_HDCP_CR_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define HDMI_HDCP_CR_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_HDCP_CR_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_HDCP_CR_aninfluencemode_shift                                           (2)
+#define HDMI_HDCP_CR_aninfluencemode_mask                                            (0x00000004)
+#define HDMI_HDCP_CR_aninfluencemode(data)                                           (0x00000004&((data)<<2))
+#define HDMI_HDCP_CR_aninfluencemode_src(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_HDCP_CR_get_aninfluencemode(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_HDCP_CR_write_en1_shift                                                 (1)
+#define HDMI_HDCP_CR_write_en1_mask                                                  (0x00000002)
+#define HDMI_HDCP_CR_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_HDCP_CR_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_CR_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_CR_hdcp_encryptenable_shift                                        (0)
+#define HDMI_HDCP_CR_hdcp_encryptenable_mask                                         (0x00000001)
+#define HDMI_HDCP_CR_hdcp_encryptenable(data)                                        (0x00000001&((data)<<0))
+#define HDMI_HDCP_CR_hdcp_encryptenable_src(data)                                    ((0x00000001&(data))>>0)
+#define HDMI_HDCP_CR_get_hdcp_encryptenable(data)                                    ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_AUTH                                                               0x1800D100
+#define HDMI_HDCP_AUTH_reg_addr                                                      "0xB800D100"
+#define HDMI_HDCP_AUTH_reg                                                           0xB800D100
+#define set_HDMI_HDCP_AUTH_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_AUTH_reg)=data)
+#define get_HDMI_HDCP_AUTH_reg   (*((volatile unsigned int*) HDMI_HDCP_AUTH_reg))
+#define HDMI_HDCP_AUTH_inst_adr                                                      "0x0040"
+#define HDMI_HDCP_AUTH_inst                                                          0x0040
+#define HDMI_HDCP_AUTH_write_en9_shift                                               (17)
+#define HDMI_HDCP_AUTH_write_en9_mask                                                (0x00020000)
+#define HDMI_HDCP_AUTH_write_en9(data)                                               (0x00020000&((data)<<17))
+#define HDMI_HDCP_AUTH_write_en9_src(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_HDCP_AUTH_get_write_en9(data)                                           ((0x00020000&(data))>>17)
+#define HDMI_HDCP_AUTH_ddpken_shift                                                  (16)
+#define HDMI_HDCP_AUTH_ddpken_mask                                                   (0x00010000)
+#define HDMI_HDCP_AUTH_ddpken(data)                                                  (0x00010000&((data)<<16))
+#define HDMI_HDCP_AUTH_ddpken_src(data)                                              ((0x00010000&(data))>>16)
+#define HDMI_HDCP_AUTH_get_ddpken(data)                                              ((0x00010000&(data))>>16)
+#define HDMI_HDCP_AUTH_write_en8_shift                                               (15)
+#define HDMI_HDCP_AUTH_write_en8_mask                                                (0x00008000)
+#define HDMI_HDCP_AUTH_write_en8(data)                                               (0x00008000&((data)<<15))
+#define HDMI_HDCP_AUTH_write_en8_src(data)                                           ((0x00008000&(data))>>15)
+#define HDMI_HDCP_AUTH_get_write_en8(data)                                           ((0x00008000&(data))>>15)
+#define HDMI_HDCP_AUTH_resetkmacc_shift                                              (14)
+#define HDMI_HDCP_AUTH_resetkmacc_mask                                               (0x00004000)
+#define HDMI_HDCP_AUTH_resetkmacc(data)                                              (0x00004000&((data)<<14))
+#define HDMI_HDCP_AUTH_resetkmacc_src(data)                                          ((0x00004000&(data))>>14)
+#define HDMI_HDCP_AUTH_get_resetkmacc(data)                                          ((0x00004000&(data))>>14)
+#define HDMI_HDCP_AUTH_write_en7_shift                                               (13)
+#define HDMI_HDCP_AUTH_write_en7_mask                                                (0x00002000)
+#define HDMI_HDCP_AUTH_write_en7(data)                                               (0x00002000&((data)<<13))
+#define HDMI_HDCP_AUTH_write_en7_src(data)                                           ((0x00002000&(data))>>13)
+#define HDMI_HDCP_AUTH_get_write_en7(data)                                           ((0x00002000&(data))>>13)
+#define HDMI_HDCP_AUTH_update_an_shift                                               (12)
+#define HDMI_HDCP_AUTH_update_an_mask                                                (0x00001000)
+#define HDMI_HDCP_AUTH_update_an(data)                                               (0x00001000&((data)<<12))
+#define HDMI_HDCP_AUTH_update_an_src(data)                                           ((0x00001000&(data))>>12)
+#define HDMI_HDCP_AUTH_get_update_an(data)                                           ((0x00001000&(data))>>12)
+#define HDMI_HDCP_AUTH_write_en6_shift                                               (11)
+#define HDMI_HDCP_AUTH_write_en6_mask                                                (0x00000800)
+#define HDMI_HDCP_AUTH_write_en6(data)                                               (0x00000800&((data)<<11))
+#define HDMI_HDCP_AUTH_write_en6_src(data)                                           ((0x00000800&(data))>>11)
+#define HDMI_HDCP_AUTH_get_write_en6(data)                                           ((0x00000800&(data))>>11)
+#define HDMI_HDCP_AUTH_aninfreq_shift                                                (10)
+#define HDMI_HDCP_AUTH_aninfreq_mask                                                 (0x00000400)
+#define HDMI_HDCP_AUTH_aninfreq(data)                                                (0x00000400&((data)<<10))
+#define HDMI_HDCP_AUTH_aninfreq_src(data)                                            ((0x00000400&(data))>>10)
+#define HDMI_HDCP_AUTH_get_aninfreq(data)                                            ((0x00000400&(data))>>10)
+#define HDMI_HDCP_AUTH_write_en5_shift                                               (9)
+#define HDMI_HDCP_AUTH_write_en5_mask                                                (0x00000200)
+#define HDMI_HDCP_AUTH_write_en5(data)                                               (0x00000200&((data)<<9))
+#define HDMI_HDCP_AUTH_write_en5_src(data)                                           ((0x00000200&(data))>>9)
+#define HDMI_HDCP_AUTH_get_write_en5(data)                                           ((0x00000200&(data))>>9)
+#define HDMI_HDCP_AUTH_seedload_shift                                                (8)
+#define HDMI_HDCP_AUTH_seedload_mask                                                 (0x00000100)
+#define HDMI_HDCP_AUTH_seedload(data)                                                (0x00000100&((data)<<8))
+#define HDMI_HDCP_AUTH_seedload_src(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_HDCP_AUTH_get_seedload(data)                                            ((0x00000100&(data))>>8)
+#define HDMI_HDCP_AUTH_write_en4_shift                                               (7)
+#define HDMI_HDCP_AUTH_write_en4_mask                                                (0x00000080)
+#define HDMI_HDCP_AUTH_write_en4(data)                                               (0x00000080&((data)<<7))
+#define HDMI_HDCP_AUTH_write_en4_src(data)                                           ((0x00000080&(data))>>7)
+#define HDMI_HDCP_AUTH_get_write_en4(data)                                           ((0x00000080&(data))>>7)
+#define HDMI_HDCP_AUTH_deviceauthenticated_shift                                     (6)
+#define HDMI_HDCP_AUTH_deviceauthenticated_mask                                      (0x00000040)
+#define HDMI_HDCP_AUTH_deviceauthenticated(data)                                     (0x00000040&((data)<<6))
+#define HDMI_HDCP_AUTH_deviceauthenticated_src(data)                                 ((0x00000040&(data))>>6)
+#define HDMI_HDCP_AUTH_get_deviceauthenticated(data)                                 ((0x00000040&(data))>>6)
+#define HDMI_HDCP_AUTH_write_en3_shift                                               (5)
+#define HDMI_HDCP_AUTH_write_en3_mask                                                (0x00000020)
+#define HDMI_HDCP_AUTH_write_en3(data)                                               (0x00000020&((data)<<5))
+#define HDMI_HDCP_AUTH_write_en3_src(data)                                           ((0x00000020&(data))>>5)
+#define HDMI_HDCP_AUTH_get_write_en3(data)                                           ((0x00000020&(data))>>5)
+#define HDMI_HDCP_AUTH_forcetounauthenticated_shift                                  (4)
+#define HDMI_HDCP_AUTH_forcetounauthenticated_mask                                   (0x00000010)
+#define HDMI_HDCP_AUTH_forcetounauthenticated(data)                                  (0x00000010&((data)<<4))
+#define HDMI_HDCP_AUTH_forcetounauthenticated_src(data)                              ((0x00000010&(data))>>4)
+#define HDMI_HDCP_AUTH_get_forcetounauthenticated(data)                              ((0x00000010&(data))>>4)
+#define HDMI_HDCP_AUTH_write_en2_shift                                               (3)
+#define HDMI_HDCP_AUTH_write_en2_mask                                                (0x00000008)
+#define HDMI_HDCP_AUTH_write_en2(data)                                               (0x00000008&((data)<<3))
+#define HDMI_HDCP_AUTH_write_en2_src(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_AUTH_get_write_en2(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_AUTH_authcompute_shift                                             (2)
+#define HDMI_HDCP_AUTH_authcompute_mask                                              (0x00000004)
+#define HDMI_HDCP_AUTH_authcompute(data)                                             (0x00000004&((data)<<2))
+#define HDMI_HDCP_AUTH_authcompute_src(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_HDCP_AUTH_get_authcompute(data)                                         ((0x00000004&(data))>>2)
+#define HDMI_HDCP_AUTH_write_en1_shift                                               (1)
+#define HDMI_HDCP_AUTH_write_en1_mask                                                (0x00000002)
+#define HDMI_HDCP_AUTH_write_en1(data)                                               (0x00000002&((data)<<1))
+#define HDMI_HDCP_AUTH_write_en1_src(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_HDCP_AUTH_get_write_en1(data)                                           ((0x00000002&(data))>>1)
+#define HDMI_HDCP_AUTH_authrequest_shift                                             (0)
+#define HDMI_HDCP_AUTH_authrequest_mask                                              (0x00000001)
+#define HDMI_HDCP_AUTH_authrequest(data)                                             (0x00000001&((data)<<0))
+#define HDMI_HDCP_AUTH_authrequest_src(data)                                         ((0x00000001&(data))>>0)
+#define HDMI_HDCP_AUTH_get_authrequest(data)                                         ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_SR                                                                 0x1800D104
+#define HDMI_HDCP_SR_reg_addr                                                        "0xB800D104"
+#define HDMI_HDCP_SR_reg                                                             0xB800D104
+#define set_HDMI_HDCP_SR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SR_reg)=data)
+#define get_HDMI_HDCP_SR_reg   (*((volatile unsigned int*) HDMI_HDCP_SR_reg))
+#define HDMI_HDCP_SR_inst_adr                                                        "0x0041"
+#define HDMI_HDCP_SR_inst                                                            0x0041
+#define HDMI_HDCP_SR_hdcpcipherstate_shift                                           (24)
+#define HDMI_HDCP_SR_hdcpcipherstate_mask                                            (0xFF000000)
+#define HDMI_HDCP_SR_hdcpcipherstate(data)                                           (0xFF000000&((data)<<24))
+#define HDMI_HDCP_SR_hdcpcipherstate_src(data)                                       ((0xFF000000&(data))>>24)
+#define HDMI_HDCP_SR_get_hdcpcipherstate(data)                                       ((0xFF000000&(data))>>24)
+#define HDMI_HDCP_SR_curdpkaccdone_shift                                             (3)
+#define HDMI_HDCP_SR_curdpkaccdone_mask                                              (0x00000008)
+#define HDMI_HDCP_SR_curdpkaccdone(data)                                             (0x00000008&((data)<<3))
+#define HDMI_HDCP_SR_curdpkaccdone_src(data)                                         ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SR_get_curdpkaccdone(data)                                         ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SR_hdcp_encrypt_status_shift                                       (2)
+#define HDMI_HDCP_SR_hdcp_encrypt_status_mask                                        (0x00000004)
+#define HDMI_HDCP_SR_hdcp_encrypt_status(data)                                       (0x00000004&((data)<<2))
+#define HDMI_HDCP_SR_hdcp_encrypt_status_src(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SR_get_hdcp_encrypt_status(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SR_authenticatedok_shift                                           (1)
+#define HDMI_HDCP_SR_authenticatedok_mask                                            (0x00000002)
+#define HDMI_HDCP_SR_authenticatedok(data)                                           (0x00000002&((data)<<1))
+#define HDMI_HDCP_SR_authenticatedok_src(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SR_get_authenticatedok(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SR_anready_shift                                                   (0)
+#define HDMI_HDCP_SR_anready_mask                                                    (0x00000001)
+#define HDMI_HDCP_SR_anready(data)                                                   (0x00000001&((data)<<0))
+#define HDMI_HDCP_SR_anready_src(data)                                               ((0x00000001&(data))>>0)
+#define HDMI_HDCP_SR_get_anready(data)                                               ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_ANLR                                                               0x1800D108
+#define HDMI_HDCP_ANLR_reg_addr                                                      "0xB800D108"
+#define HDMI_HDCP_ANLR_reg                                                           0xB800D108
+#define set_HDMI_HDCP_ANLR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANLR_reg)=data)
+#define get_HDMI_HDCP_ANLR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANLR_reg))
+#define HDMI_HDCP_ANLR_inst_adr                                                      "0x0042"
+#define HDMI_HDCP_ANLR_inst                                                          0x0042
+#define HDMI_HDCP_ANLR_anlsw_shift                                                   (0)
+#define HDMI_HDCP_ANLR_anlsw_mask                                                    (0xFFFFFFFF)
+#define HDMI_HDCP_ANLR_anlsw(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANLR_anlsw_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANLR_get_anlsw(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_ANMR                                                               0x1800D10c
+#define HDMI_HDCP_ANMR_reg_addr                                                      "0xB800D10C"
+#define HDMI_HDCP_ANMR_reg                                                           0xB800D10C
+#define set_HDMI_HDCP_ANMR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANMR_reg)=data)
+#define get_HDMI_HDCP_ANMR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANMR_reg))
+#define HDMI_HDCP_ANMR_inst_adr                                                      "0x0043"
+#define HDMI_HDCP_ANMR_inst                                                          0x0043
+#define HDMI_HDCP_ANMR_anmsw_shift                                                   (0)
+#define HDMI_HDCP_ANMR_anmsw_mask                                                    (0xFFFFFFFF)
+#define HDMI_HDCP_ANMR_anmsw(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANMR_anmsw_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANMR_get_anmsw(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_ANILR                                                              0x1800D110
+#define HDMI_HDCP_ANILR_reg_addr                                                     "0xB800D110"
+#define HDMI_HDCP_ANILR_reg                                                          0xB800D110
+#define set_HDMI_HDCP_ANILR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANILR_reg)=data)
+#define get_HDMI_HDCP_ANILR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANILR_reg))
+#define HDMI_HDCP_ANILR_inst_adr                                                     "0x0044"
+#define HDMI_HDCP_ANILR_inst                                                         0x0044
+#define HDMI_HDCP_ANILR_aninfluencelsw_shift                                         (0)
+#define HDMI_HDCP_ANILR_aninfluencelsw_mask                                          (0xFFFFFFFF)
+#define HDMI_HDCP_ANILR_aninfluencelsw(data)                                         (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANILR_aninfluencelsw_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANILR_get_aninfluencelsw(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_ANIMR                                                              0x1800D114
+#define HDMI_HDCP_ANIMR_reg_addr                                                     "0xB800D114"
+#define HDMI_HDCP_ANIMR_reg                                                          0xB800D114
+#define set_HDMI_HDCP_ANIMR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_ANIMR_reg)=data)
+#define get_HDMI_HDCP_ANIMR_reg   (*((volatile unsigned int*) HDMI_HDCP_ANIMR_reg))
+#define HDMI_HDCP_ANIMR_inst_adr                                                     "0x0045"
+#define HDMI_HDCP_ANIMR_inst                                                         0x0045
+#define HDMI_HDCP_ANIMR_aninfluencemsw_shift                                         (0)
+#define HDMI_HDCP_ANIMR_aninfluencemsw_mask                                          (0xFFFFFFFF)
+#define HDMI_HDCP_ANIMR_aninfluencemsw(data)                                         (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_ANIMR_aninfluencemsw_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_ANIMR_get_aninfluencemsw(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_DPKLR                                                              0x1800D118
+#define HDMI_HDCP_DPKLR_reg_addr                                                     "0xB800D118"
+#define HDMI_HDCP_DPKLR_reg                                                          0xB800D118
+#define set_HDMI_HDCP_DPKLR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_DPKLR_reg)=data)
+#define get_HDMI_HDCP_DPKLR_reg   (*((volatile unsigned int*) HDMI_HDCP_DPKLR_reg))
+#define HDMI_HDCP_DPKLR_inst_adr                                                     "0x0046"
+#define HDMI_HDCP_DPKLR_inst                                                         0x0046
+#define HDMI_HDCP_DPKLR_ddpklsb24_shift                                              (8)
+#define HDMI_HDCP_DPKLR_ddpklsb24_mask                                               (0xFFFFFF00)
+#define HDMI_HDCP_DPKLR_ddpklsb24(data)                                              (0xFFFFFF00&((data)<<8))
+#define HDMI_HDCP_DPKLR_ddpklsb24_src(data)                                          ((0xFFFFFF00&(data))>>8)
+#define HDMI_HDCP_DPKLR_get_ddpklsb24(data)                                          ((0xFFFFFF00&(data))>>8)
+#define HDMI_HDCP_DPKLR_dpkencpnt_shift                                              (0)
+#define HDMI_HDCP_DPKLR_dpkencpnt_mask                                               (0x000000FF)
+#define HDMI_HDCP_DPKLR_dpkencpnt(data)                                              (0x000000FF&((data)<<0))
+#define HDMI_HDCP_DPKLR_dpkencpnt_src(data)                                          ((0x000000FF&(data))>>0)
+#define HDMI_HDCP_DPKLR_get_dpkencpnt(data)                                          ((0x000000FF&(data))>>0)
+
+
+#define HDMI_HDCP_DPKMR                                                              0x1800D11c
+#define HDMI_HDCP_DPKMR_reg_addr                                                     "0xB800D11C"
+#define HDMI_HDCP_DPKMR_reg                                                          0xB800D11C
+#define set_HDMI_HDCP_DPKMR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_DPKMR_reg)=data)
+#define get_HDMI_HDCP_DPKMR_reg   (*((volatile unsigned int*) HDMI_HDCP_DPKMR_reg))
+#define HDMI_HDCP_DPKMR_inst_adr                                                     "0x0047"
+#define HDMI_HDCP_DPKMR_inst                                                         0x0047
+#define HDMI_HDCP_DPKMR_ddpkmsw_shift                                                (0)
+#define HDMI_HDCP_DPKMR_ddpkmsw_mask                                                 (0xFFFFFFFF)
+#define HDMI_HDCP_DPKMR_ddpkmsw(data)                                                (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_DPKMR_ddpkmsw_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_DPKMR_get_ddpkmsw(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_LIR                                                                0x1800D120
+#define HDMI_HDCP_LIR_reg_addr                                                       "0xB800D120"
+#define HDMI_HDCP_LIR_reg                                                            0xB800D120
+#define set_HDMI_HDCP_LIR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_LIR_reg)=data)
+#define get_HDMI_HDCP_LIR_reg   (*((volatile unsigned int*) HDMI_HDCP_LIR_reg))
+#define HDMI_HDCP_LIR_inst_adr                                                       "0x0048"
+#define HDMI_HDCP_LIR_inst                                                           0x0048
+#define HDMI_HDCP_LIR_ri_shift                                                       (8)
+#define HDMI_HDCP_LIR_ri_mask                                                        (0x00FFFF00)
+#define HDMI_HDCP_LIR_ri(data)                                                       (0x00FFFF00&((data)<<8))
+#define HDMI_HDCP_LIR_ri_src(data)                                                   ((0x00FFFF00&(data))>>8)
+#define HDMI_HDCP_LIR_get_ri(data)                                                   ((0x00FFFF00&(data))>>8)
+#define HDMI_HDCP_LIR_pj_shift                                                       (0)
+#define HDMI_HDCP_LIR_pj_mask                                                        (0x000000FF)
+#define HDMI_HDCP_LIR_pj(data)                                                       (0x000000FF&((data)<<0))
+#define HDMI_HDCP_LIR_pj_src(data)                                                   ((0x000000FF&(data))>>0)
+#define HDMI_HDCP_LIR_get_pj(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define HDMI_HDCP_SHACR                                                              0x1800D124
+#define HDMI_HDCP_SHACR_reg_addr                                                     "0xB800D124"
+#define HDMI_HDCP_SHACR_reg                                                          0xB800D124
+#define set_HDMI_HDCP_SHACR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SHACR_reg)=data)
+#define get_HDMI_HDCP_SHACR_reg   (*((volatile unsigned int*) HDMI_HDCP_SHACR_reg))
+#define HDMI_HDCP_SHACR_inst_adr                                                     "0x0049"
+#define HDMI_HDCP_SHACR_inst                                                         0x0049
+#define HDMI_HDCP_SHACR_shastart_shift                                               (3)
+#define HDMI_HDCP_SHACR_shastart_mask                                                (0x00000008)
+#define HDMI_HDCP_SHACR_shastart(data)                                               (0x00000008&((data)<<3))
+#define HDMI_HDCP_SHACR_shastart_src(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SHACR_get_shastart(data)                                           ((0x00000008&(data))>>3)
+#define HDMI_HDCP_SHACR_shafirst_shift                                               (2)
+#define HDMI_HDCP_SHACR_shafirst_mask                                                (0x00000004)
+#define HDMI_HDCP_SHACR_shafirst(data)                                               (0x00000004&((data)<<2))
+#define HDMI_HDCP_SHACR_shafirst_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SHACR_get_shafirst(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_HDCP_SHACR_rstshaptr_shift                                              (1)
+#define HDMI_HDCP_SHACR_rstshaptr_mask                                               (0x00000002)
+#define HDMI_HDCP_SHACR_rstshaptr(data)                                              (0x00000002&((data)<<1))
+#define HDMI_HDCP_SHACR_rstshaptr_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHACR_get_rstshaptr(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHACR_write_data_shift                                             (0)
+#define HDMI_HDCP_SHACR_write_data_mask                                              (0x00000001)
+#define HDMI_HDCP_SHACR_write_data(data)                                             (0x00000001&((data)<<0))
+#define HDMI_HDCP_SHACR_write_data_src(data)                                         ((0x00000001&(data))>>0)
+#define HDMI_HDCP_SHACR_get_write_data(data)                                         ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_SHARR                                                              0x1800D128
+#define HDMI_HDCP_SHARR_reg_addr                                                     "0xB800D128"
+#define HDMI_HDCP_SHARR_reg                                                          0xB800D128
+#define set_HDMI_HDCP_SHARR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SHARR_reg)=data)
+#define get_HDMI_HDCP_SHARR_reg   (*((volatile unsigned int*) HDMI_HDCP_SHARR_reg))
+#define HDMI_HDCP_SHARR_inst_adr                                                     "0x004A"
+#define HDMI_HDCP_SHARR_inst                                                         0x004A
+#define HDMI_HDCP_SHARR_vmatch_shift                                                 (1)
+#define HDMI_HDCP_SHARR_vmatch_mask                                                  (0x00000002)
+#define HDMI_HDCP_SHARR_vmatch(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_HDCP_SHARR_vmatch_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHARR_get_vmatch(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_HDCP_SHARR_shaready_shift                                               (0)
+#define HDMI_HDCP_SHARR_shaready_mask                                                (0x00000001)
+#define HDMI_HDCP_SHARR_shaready(data)                                               (0x00000001&((data)<<0))
+#define HDMI_HDCP_SHARR_shaready_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_HDCP_SHARR_get_shaready(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_SHADR                                                              0x1800D12c
+#define HDMI_HDCP_SHADR_reg_addr                                                     "0xB800D12C"
+#define HDMI_HDCP_SHADR_reg                                                          0xB800D12C
+#define set_HDMI_HDCP_SHADR_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_SHADR_reg)=data)
+#define get_HDMI_HDCP_SHADR_reg   (*((volatile unsigned int*) HDMI_HDCP_SHADR_reg))
+#define HDMI_HDCP_SHADR_inst_adr                                                     "0x004B"
+#define HDMI_HDCP_SHADR_inst                                                         0x004B
+#define HDMI_HDCP_SHADR_sha_data_shift                                               (0)
+#define HDMI_HDCP_SHADR_sha_data_mask                                                (0xFFFFFFFF)
+#define HDMI_HDCP_SHADR_sha_data(data)                                               (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_SHADR_sha_data_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_SHADR_get_sha_data(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_MILSW                                                              0x1800D130
+#define HDMI_HDCP_MILSW_reg_addr                                                     "0xB800D130"
+#define HDMI_HDCP_MILSW_reg                                                          0xB800D130
+#define set_HDMI_HDCP_MILSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_MILSW_reg)=data)
+#define get_HDMI_HDCP_MILSW_reg   (*((volatile unsigned int*) HDMI_HDCP_MILSW_reg))
+#define HDMI_HDCP_MILSW_inst_adr                                                     "0x004C"
+#define HDMI_HDCP_MILSW_inst                                                         0x004C
+#define HDMI_HDCP_MILSW_milsw_shift                                                  (0)
+#define HDMI_HDCP_MILSW_milsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_MILSW_milsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_MILSW_milsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_MILSW_get_milsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_MIMSW                                                              0x1800D134
+#define HDMI_HDCP_MIMSW_reg_addr                                                     "0xB800D134"
+#define HDMI_HDCP_MIMSW_reg                                                          0xB800D134
+#define set_HDMI_HDCP_MIMSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_MIMSW_reg)=data)
+#define get_HDMI_HDCP_MIMSW_reg   (*((volatile unsigned int*) HDMI_HDCP_MIMSW_reg))
+#define HDMI_HDCP_MIMSW_inst_adr                                                     "0x004D"
+#define HDMI_HDCP_MIMSW_inst                                                         0x004D
+#define HDMI_HDCP_MIMSW_mimsw_shift                                                  (0)
+#define HDMI_HDCP_MIMSW_mimsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_MIMSW_mimsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_MIMSW_mimsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_MIMSW_get_mimsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_KMLSW                                                              0x1800D138
+#define HDMI_HDCP_KMLSW_reg_addr                                                     "0xB800D138"
+#define HDMI_HDCP_KMLSW_reg                                                          0xB800D138
+#define set_HDMI_HDCP_KMLSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KMLSW_reg)=data)
+#define get_HDMI_HDCP_KMLSW_reg   (*((volatile unsigned int*) HDMI_HDCP_KMLSW_reg))
+#define HDMI_HDCP_KMLSW_inst_adr                                                     "0x004E"
+#define HDMI_HDCP_KMLSW_inst                                                         0x004E
+#define HDMI_HDCP_KMLSW_kmlsw_shift                                                  (0)
+#define HDMI_HDCP_KMLSW_kmlsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_KMLSW_kmlsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_KMLSW_kmlsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_KMLSW_get_kmlsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_KMMSW                                                              0x1800D13c
+#define HDMI_HDCP_KMMSW_reg_addr                                                     "0xB800D13C"
+#define HDMI_HDCP_KMMSW_reg                                                          0xB800D13C
+#define set_HDMI_HDCP_KMMSW_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_KMMSW_reg)=data)
+#define get_HDMI_HDCP_KMMSW_reg   (*((volatile unsigned int*) HDMI_HDCP_KMMSW_reg))
+#define HDMI_HDCP_KMMSW_inst_adr                                                     "0x004F"
+#define HDMI_HDCP_KMMSW_inst                                                         0x004F
+#define HDMI_HDCP_KMMSW_kmmsw_shift                                                  (0)
+#define HDMI_HDCP_KMMSW_kmmsw_mask                                                   (0xFFFFFFFF)
+#define HDMI_HDCP_KMMSW_kmmsw(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_KMMSW_kmmsw_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_KMMSW_get_kmmsw(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_CTRL                                                           0x1800D2b0
+#define HDMI_HDCP_2_2_CTRL_reg_addr                                                  "0xB800D2B0"
+#define HDMI_HDCP_2_2_CTRL_reg                                                       0xB800D2B0
+#define set_HDMI_HDCP_2_2_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_CTRL_reg)=data)
+#define get_HDMI_HDCP_2_2_CTRL_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_CTRL_reg))
+#define HDMI_HDCP_2_2_CTRL_inst_adr                                                  "0x00AC"
+#define HDMI_HDCP_2_2_CTRL_inst                                                      0x00AC
+#define HDMI_HDCP_2_2_CTRL_write_en5_shift                                           (9)
+#define HDMI_HDCP_2_2_CTRL_write_en5_mask                                            (0x00000200)
+#define HDMI_HDCP_2_2_CTRL_write_en5(data)                                           (0x00000200&((data)<<9))
+#define HDMI_HDCP_2_2_CTRL_write_en5_src(data)                                       ((0x00000200&(data))>>9)
+#define HDMI_HDCP_2_2_CTRL_get_write_en5(data)                                       ((0x00000200&(data))>>9)
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add_shift                                     (8)
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add_mask                                      (0x00000100)
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add(data)                                     (0x00000100&((data)<<8))
+#define HDMI_HDCP_2_2_CTRL_pkt_vdo_cnt_add_src(data)                                 ((0x00000100&(data))>>8)
+#define HDMI_HDCP_2_2_CTRL_get_pkt_vdo_cnt_add(data)                                 ((0x00000100&(data))>>8)
+#define HDMI_HDCP_2_2_CTRL_write_en4_shift                                           (7)
+#define HDMI_HDCP_2_2_CTRL_write_en4_mask                                            (0x00000080)
+#define HDMI_HDCP_2_2_CTRL_write_en4(data)                                           (0x00000080&((data)<<7))
+#define HDMI_HDCP_2_2_CTRL_write_en4_src(data)                                       ((0x00000080&(data))>>7)
+#define HDMI_HDCP_2_2_CTRL_get_write_en4(data)                                       ((0x00000080&(data))>>7)
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en_shift                                         (6)
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en_mask                                          (0x00000040)
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en(data)                                         (0x00000040&((data)<<6))
+#define HDMI_HDCP_2_2_CTRL_hdcp_2_2_en_src(data)                                     ((0x00000040&(data))>>6)
+#define HDMI_HDCP_2_2_CTRL_get_hdcp_2_2_en(data)                                     ((0x00000040&(data))>>6)
+#define HDMI_HDCP_2_2_CTRL_write_en3_shift                                           (5)
+#define HDMI_HDCP_2_2_CTRL_write_en3_mask                                            (0x00000020)
+#define HDMI_HDCP_2_2_CTRL_write_en3(data)                                           (0x00000020&((data)<<5))
+#define HDMI_HDCP_2_2_CTRL_write_en3_src(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_HDCP_2_2_CTRL_get_write_en3(data)                                       ((0x00000020&(data))>>5)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en_shift                                           (4)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en_mask                                            (0x00000010)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en(data)                                           (0x00000010&((data)<<4))
+#define HDMI_HDCP_2_2_CTRL_aes_sw_en_src(data)                                       ((0x00000010&(data))>>4)
+#define HDMI_HDCP_2_2_CTRL_get_aes_sw_en(data)                                       ((0x00000010&(data))>>4)
+#define HDMI_HDCP_2_2_CTRL_write_en2_shift                                           (3)
+#define HDMI_HDCP_2_2_CTRL_write_en2_mask                                            (0x00000008)
+#define HDMI_HDCP_2_2_CTRL_write_en2(data)                                           (0x00000008&((data)<<3))
+#define HDMI_HDCP_2_2_CTRL_write_en2_src(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_HDCP_2_2_CTRL_get_write_en2(data)                                       ((0x00000008&(data))>>3)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1_shift                                       (2)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1_mask                                        (0x00000004)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1(data)                                       (0x00000004&((data)<<2))
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start1_src(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_2_2_CTRL_get_aes_sw_start1(data)                                   ((0x00000004&(data))>>2)
+#define HDMI_HDCP_2_2_CTRL_write_en1_shift                                           (1)
+#define HDMI_HDCP_2_2_CTRL_write_en1_mask                                            (0x00000002)
+#define HDMI_HDCP_2_2_CTRL_write_en1(data)                                           (0x00000002&((data)<<1))
+#define HDMI_HDCP_2_2_CTRL_write_en1_src(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_CTRL_get_write_en1(data)                                       ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2_shift                                       (0)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2_mask                                        (0x00000001)
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2(data)                                       (0x00000001&((data)<<0))
+#define HDMI_HDCP_2_2_CTRL_aes_sw_start2_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_HDCP_2_2_CTRL_get_aes_sw_start2(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_STATUS                                                         0x1800D2b4
+#define HDMI_HDCP_2_2_STATUS_reg_addr                                                "0xB800D2B4"
+#define HDMI_HDCP_2_2_STATUS_reg                                                     0xB800D2B4
+#define set_HDMI_HDCP_2_2_STATUS_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_STATUS_reg)=data)
+#define get_HDMI_HDCP_2_2_STATUS_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_STATUS_reg))
+#define HDMI_HDCP_2_2_STATUS_inst_adr                                                "0x00AD"
+#define HDMI_HDCP_2_2_STATUS_inst                                                    0x00AD
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1_shift                                     (1)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1_mask                                      (0x00000002)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1(data)                                     (0x00000002&((data)<<1))
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_1_src(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_STATUS_get_rgs_sw_done_1(data)                                 ((0x00000002&(data))>>1)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2_shift                                     (0)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2_mask                                      (0x00000001)
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2(data)                                     (0x00000001&((data)<<0))
+#define HDMI_HDCP_2_2_STATUS_rgs_sw_done_2_src(data)                                 ((0x00000001&(data))>>0)
+#define HDMI_HDCP_2_2_STATUS_get_rgs_sw_done_2(data)                                 ((0x00000001&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_1                                                    0x1800D2b8
+#define HDMI_HDCP_2_2_SW_DATA_1_1_reg_addr                                           "0xB800D2B8"
+#define HDMI_HDCP_2_2_SW_DATA_1_1_reg                                                0xB800D2B8
+#define set_HDMI_HDCP_2_2_SW_DATA_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_1_inst_adr                                           "0x00AE"
+#define HDMI_HDCP_2_2_SW_DATA_1_1_inst                                               0x00AE
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_1_sw_data_1_1_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_1_get_sw_data_1_1(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_2                                                    0x1800D2bc
+#define HDMI_HDCP_2_2_SW_DATA_1_2_reg_addr                                           "0xB800D2BC"
+#define HDMI_HDCP_2_2_SW_DATA_1_2_reg                                                0xB800D2BC
+#define set_HDMI_HDCP_2_2_SW_DATA_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_2_inst_adr                                           "0x00AF"
+#define HDMI_HDCP_2_2_SW_DATA_1_2_inst                                               0x00AF
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_2_sw_data_1_2_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_2_get_sw_data_1_2(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_3                                                    0x1800D2c0
+#define HDMI_HDCP_2_2_SW_DATA_1_3_reg_addr                                           "0xB800D2C0"
+#define HDMI_HDCP_2_2_SW_DATA_1_3_reg                                                0xB800D2C0
+#define set_HDMI_HDCP_2_2_SW_DATA_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_3_inst_adr                                           "0x00B0"
+#define HDMI_HDCP_2_2_SW_DATA_1_3_inst                                               0x00B0
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_3_sw_data_1_3_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_3_get_sw_data_1_3(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_1_4                                                    0x1800D2c4
+#define HDMI_HDCP_2_2_SW_DATA_1_4_reg_addr                                           "0xB800D2C4"
+#define HDMI_HDCP_2_2_SW_DATA_1_4_reg                                                0xB800D2C4
+#define set_HDMI_HDCP_2_2_SW_DATA_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_1_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_1_4_inst_adr                                           "0x00B1"
+#define HDMI_HDCP_2_2_SW_DATA_1_4_inst                                               0x00B1
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_1_4_sw_data_1_4_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_1_4_get_sw_data_1_4(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_1                                                    0x1800D2c8
+#define HDMI_HDCP_2_2_SW_DATA_2_1_reg_addr                                           "0xB800D2C8"
+#define HDMI_HDCP_2_2_SW_DATA_2_1_reg                                                0xB800D2C8
+#define set_HDMI_HDCP_2_2_SW_DATA_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_1_inst_adr                                           "0x00B2"
+#define HDMI_HDCP_2_2_SW_DATA_2_1_inst                                               0x00B2
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_1_sw_data_2_1_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_1_get_sw_data_2_1(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_2                                                    0x1800D2cc
+#define HDMI_HDCP_2_2_SW_DATA_2_2_reg_addr                                           "0xB800D2CC"
+#define HDMI_HDCP_2_2_SW_DATA_2_2_reg                                                0xB800D2CC
+#define set_HDMI_HDCP_2_2_SW_DATA_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_2_inst_adr                                           "0x00B3"
+#define HDMI_HDCP_2_2_SW_DATA_2_2_inst                                               0x00B3
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_2_sw_data_2_2_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_2_get_sw_data_2_2(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_3                                                    0x1800D2d0
+#define HDMI_HDCP_2_2_SW_DATA_2_3_reg_addr                                           "0xB800D2D0"
+#define HDMI_HDCP_2_2_SW_DATA_2_3_reg                                                0xB800D2D0
+#define set_HDMI_HDCP_2_2_SW_DATA_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_3_inst_adr                                           "0x00B4"
+#define HDMI_HDCP_2_2_SW_DATA_2_3_inst                                               0x00B4
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_3_sw_data_2_3_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_3_get_sw_data_2_3(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_2_4                                                    0x1800D2d4
+#define HDMI_HDCP_2_2_SW_DATA_2_4_reg_addr                                           "0xB800D2D4"
+#define HDMI_HDCP_2_2_SW_DATA_2_4_reg                                                0xB800D2D4
+#define set_HDMI_HDCP_2_2_SW_DATA_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_2_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_2_4_inst_adr                                           "0x00B5"
+#define HDMI_HDCP_2_2_SW_DATA_2_4_inst                                               0x00B5
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4_shift                                  (0)
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4_mask                                   (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4(data)                                  (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_2_4_sw_data_2_4_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_2_4_get_sw_data_2_4(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_1                                                     0x1800D2d8
+#define HDMI_HDCP_2_2_SW_KEY_1_1_reg_addr                                            "0xB800D2D8"
+#define HDMI_HDCP_2_2_SW_KEY_1_1_reg                                                 0xB800D2D8
+#define set_HDMI_HDCP_2_2_SW_KEY_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_1_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_1_inst_adr                                            "0x00B6"
+#define HDMI_HDCP_2_2_SW_KEY_1_1_inst                                                0x00B6
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_1_sw_key_1_1_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_1_get_sw_key_1_1(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_2                                                     0x1800D2dc
+#define HDMI_HDCP_2_2_SW_KEY_1_2_reg_addr                                            "0xB800D2DC"
+#define HDMI_HDCP_2_2_SW_KEY_1_2_reg                                                 0xB800D2DC
+#define set_HDMI_HDCP_2_2_SW_KEY_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_2_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_2_inst_adr                                            "0x00B7"
+#define HDMI_HDCP_2_2_SW_KEY_1_2_inst                                                0x00B7
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_2_sw_key_1_2_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_2_get_sw_key_1_2(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_3                                                     0x1800D2e0
+#define HDMI_HDCP_2_2_SW_KEY_1_3_reg_addr                                            "0xB800D2E0"
+#define HDMI_HDCP_2_2_SW_KEY_1_3_reg                                                 0xB800D2E0
+#define set_HDMI_HDCP_2_2_SW_KEY_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_3_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_3_inst_adr                                            "0x00B8"
+#define HDMI_HDCP_2_2_SW_KEY_1_3_inst                                                0x00B8
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_3_sw_key_1_3_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_3_get_sw_key_1_3(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_1_4                                                     0x1800D2e4
+#define HDMI_HDCP_2_2_SW_KEY_1_4_reg_addr                                            "0xB800D2E4"
+#define HDMI_HDCP_2_2_SW_KEY_1_4_reg                                                 0xB800D2E4
+#define set_HDMI_HDCP_2_2_SW_KEY_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_1_4_reg))
+#define HDMI_HDCP_2_2_SW_KEY_1_4_inst_adr                                            "0x00B9"
+#define HDMI_HDCP_2_2_SW_KEY_1_4_inst                                                0x00B9
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_1_4_sw_key_1_4_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_1_4_get_sw_key_1_4(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_1                                                     0x1800D2e8
+#define HDMI_HDCP_2_2_SW_KEY_2_1_reg_addr                                            "0xB800D2E8"
+#define HDMI_HDCP_2_2_SW_KEY_2_1_reg                                                 0xB800D2E8
+#define set_HDMI_HDCP_2_2_SW_KEY_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_1_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_1_inst_adr                                            "0x00BA"
+#define HDMI_HDCP_2_2_SW_KEY_2_1_inst                                                0x00BA
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_1_sw_key_2_1_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_1_get_sw_key_2_1(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_2                                                     0x1800D2ec
+#define HDMI_HDCP_2_2_SW_KEY_2_2_reg_addr                                            "0xB800D2EC"
+#define HDMI_HDCP_2_2_SW_KEY_2_2_reg                                                 0xB800D2EC
+#define set_HDMI_HDCP_2_2_SW_KEY_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_2_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_2_inst_adr                                            "0x00BB"
+#define HDMI_HDCP_2_2_SW_KEY_2_2_inst                                                0x00BB
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_2_sw_key_2_2_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_2_get_sw_key_2_2(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_3                                                     0x1800D2f0
+#define HDMI_HDCP_2_2_SW_KEY_2_3_reg_addr                                            "0xB800D2F0"
+#define HDMI_HDCP_2_2_SW_KEY_2_3_reg                                                 0xB800D2F0
+#define set_HDMI_HDCP_2_2_SW_KEY_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_3_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_3_inst_adr                                            "0x00BC"
+#define HDMI_HDCP_2_2_SW_KEY_2_3_inst                                                0x00BC
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_3_sw_key_2_3_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_3_get_sw_key_2_3(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_KEY_2_4                                                     0x1800D2f4
+#define HDMI_HDCP_2_2_SW_KEY_2_4_reg_addr                                            "0xB800D2F4"
+#define HDMI_HDCP_2_2_SW_KEY_2_4_reg                                                 0xB800D2F4
+#define set_HDMI_HDCP_2_2_SW_KEY_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_KEY_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_KEY_2_4_reg))
+#define HDMI_HDCP_2_2_SW_KEY_2_4_inst_adr                                            "0x00BD"
+#define HDMI_HDCP_2_2_SW_KEY_2_4_inst                                                0x00BD
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4_shift                                    (0)
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4_mask                                     (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4(data)                                    (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_KEY_2_4_sw_key_2_4_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_KEY_2_4_get_sw_key_2_4(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1                                                0x1800D2f8
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg_addr                                       "0xB800D2F8"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg                                            0xB800D2F8
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_inst_adr                                       "0x00BE"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_inst                                           0x00BE
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_sw_data_xor_1_1_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_1_get_sw_data_xor_1_1(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2                                                0x1800D2fc
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg_addr                                       "0xB800D2FC"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg                                            0xB800D2FC
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_inst_adr                                       "0x00BF"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_inst                                           0x00BF
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_sw_data_xor_1_2_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_2_get_sw_data_xor_1_2(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3                                                0x1800D300
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg_addr                                       "0xB800D300"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg                                            0xB800D300
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_inst_adr                                       "0x00C0"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_inst                                           0x00C0
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_sw_data_xor_1_3_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_3_get_sw_data_xor_1_3(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4                                                0x1800D304
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg_addr                                       "0xB800D304"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg                                            0xB800D304
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_1_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_inst_adr                                       "0x00C1"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_inst                                           0x00C1
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_sw_data_xor_1_4_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_1_4_get_sw_data_xor_1_4(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1                                                0x1800D308
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg_addr                                       "0xB800D308"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg                                            0xB800D308
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_inst_adr                                       "0x00C2"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_inst                                           0x00C2
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_sw_data_xor_2_1_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_1_get_sw_data_xor_2_1(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2                                                0x1800D30c
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg_addr                                       "0xB800D30C"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg                                            0xB800D30C
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_inst_adr                                       "0x00C3"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_inst                                           0x00C3
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_sw_data_xor_2_2_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_2_get_sw_data_xor_2_2(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3                                                0x1800D310
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg_addr                                       "0xB800D310"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg                                            0xB800D310
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_inst_adr                                       "0x00C4"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_inst                                           0x00C4
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_sw_data_xor_2_3_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_3_get_sw_data_xor_2_3(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4                                                0x1800D314
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg_addr                                       "0xB800D314"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg                                            0xB800D314
+#define set_HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_XOR_2_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_inst_adr                                       "0x00C5"
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_inst                                           0x00C5
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4_shift                          (0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4_mask                           (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4(data)                          (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_sw_data_xor_2_4_src(data)                      ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_XOR_2_4_get_sw_data_xor_2_4(data)                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1                                                0x1800D318
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg_addr                                       "0xB800D318"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg                                            0xB800D318
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_inst_adr                                       "0x00C6"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_inst                                           0x00C6
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_data_out_1_1_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_1_get_data_out_1_1(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2                                                0x1800D31c
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg_addr                                       "0xB800D31C"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg                                            0xB800D31C
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_inst_adr                                       "0x00C7"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_inst                                           0x00C7
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_data_out_1_2_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_2_get_data_out_1_2(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3                                                0x1800D320
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg_addr                                       "0xB800D320"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg                                            0xB800D320
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_inst_adr                                       "0x00C8"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_inst                                           0x00C8
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_data_out_1_3_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_3_get_data_out_1_3(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4                                                0x1800D324
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg_addr                                       "0xB800D324"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg                                            0xB800D324
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_1_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_inst_adr                                       "0x00C9"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_inst                                           0x00C9
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_data_out_1_4_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_1_4_get_data_out_1_4(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1                                                0x1800D328
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg_addr                                       "0xB800D328"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg                                            0xB800D328
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_1_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_inst_adr                                       "0x00CA"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_inst                                           0x00CA
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_data_out_2_1_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_1_get_data_out_2_1(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2                                                0x1800D32c
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg_addr                                       "0xB800D32C"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg                                            0xB800D32C
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_2_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_inst_adr                                       "0x00CB"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_inst                                           0x00CB
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_data_out_2_2_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_2_get_data_out_2_2(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3                                                0x1800D330
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg_addr                                       "0xB800D330"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg                                            0xB800D330
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_3_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_inst_adr                                       "0x00CC"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_inst                                           0x00CC
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_data_out_2_3_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_3_get_data_out_2_3(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4                                                0x1800D334
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg_addr                                       "0xB800D334"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg                                            0xB800D334
+#define set_HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg)=data)
+#define get_HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_SW_DATA_OUT_2_4_reg))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_inst_adr                                       "0x00CD"
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_inst                                           0x00CD
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4_shift                             (0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4_mask                              (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4(data)                             (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_data_out_2_4_src(data)                         ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_SW_DATA_OUT_2_4_get_data_out_2_4(data)                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_RIV_1                                                       0x1800D338
+#define HDMI_HDCP_2_2_HW_RIV_1_reg_addr                                              "0xB800D338"
+#define HDMI_HDCP_2_2_HW_RIV_1_reg                                                   0xB800D338
+#define set_HDMI_HDCP_2_2_HW_RIV_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_1_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_RIV_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_1_reg))
+#define HDMI_HDCP_2_2_HW_RIV_1_inst_adr                                              "0x00CE"
+#define HDMI_HDCP_2_2_HW_RIV_1_inst                                                  0x00CE
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1_shift                                      (0)
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1_mask                                       (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1(data)                                      (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_RIV_1_hw_riv_1_1_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_RIV_1_get_hw_riv_1_1(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_RIV_2                                                       0x1800D33c
+#define HDMI_HDCP_2_2_HW_RIV_2_reg_addr                                              "0xB800D33C"
+#define HDMI_HDCP_2_2_HW_RIV_2_reg                                                   0xB800D33C
+#define set_HDMI_HDCP_2_2_HW_RIV_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_2_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_RIV_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_RIV_2_reg))
+#define HDMI_HDCP_2_2_HW_RIV_2_inst_adr                                              "0x00CF"
+#define HDMI_HDCP_2_2_HW_RIV_2_inst                                                  0x00CF
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2_shift                                      (0)
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2_mask                                       (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2(data)                                      (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_RIV_2_hw_riv_1_2_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_RIV_2_get_hw_riv_1_2(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1                                                 0x1800D340
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg_addr                                        "0xB800D340"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg                                             0xB800D340
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_1_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_inst_adr                                        "0x00D0"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_inst                                            0x00D0
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1_shift                               (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1_mask                                (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1(data)                               (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_frame_num_1_src(data)                           ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_1_get_frame_num_1(data)                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2                                                 0x1800D344
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg_addr                                        "0xB800D344"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg                                             0xB800D344
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_2_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_inst_adr                                        "0x00D1"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_inst                                            0x00D1
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2_shift                               (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2_mask                                (0x0000003F)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2(data)                               (0x0000003F&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_frame_num_2_src(data)                           ((0x0000003F&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_2_get_frame_num_2(data)                           ((0x0000003F&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1                                             0x1800D348
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg_addr                                    "0xB800D348"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg                                         0xB800D348
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_inst_adr                                    "0x00D2"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_inst                                        0x00D2
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1_shift                       (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1_mask                        (0xFFFFFFFF)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1(data)                       (0xFFFFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_frame_num_add_1_src(data)                   ((0xFFFFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_1_get_frame_num_add_1(data)                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2                                             0x1800D34c
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg_addr                                    "0xB800D34C"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg                                         0xB800D34C
+#define set_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_reg))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_inst_adr                                    "0x00D3"
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_inst                                        0x00D3
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2_shift                       (0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2_mask                        (0x0000003F)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2(data)                       (0x0000003F&((data)<<0))
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_frame_num_add_2_src(data)                   ((0x0000003F&(data))>>0)
+#define HDMI_HDCP_2_2_HW_FRAME_NUM_ADD_2_get_frame_num_add_2(data)                   ((0x0000003F&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_DATA_NUM                                                    0x1800D350
+#define HDMI_HDCP_2_2_HW_DATA_NUM_reg_addr                                           "0xB800D350"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_reg                                                0xB800D350
+#define set_HDMI_HDCP_2_2_HW_DATA_NUM_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_DATA_NUM_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_reg))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_inst_adr                                           "0x00D4"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_inst                                               0x00D4
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num_shift                                     (0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num_mask                                      (0x03FFFFFF)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num(data)                                     (0x03FFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_data_num_src(data)                                 ((0x03FFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_get_data_num(data)                                 ((0x03FFFFFF&(data))>>0)
+
+
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD                                                0x1800D354
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg_addr                                       "0xB800D354"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg                                            0xB800D354
+#define set_HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg(data)   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg)=data)
+#define get_HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg   (*((volatile unsigned int*) HDMI_HDCP_2_2_HW_DATA_NUM_ADD_reg))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_inst_adr                                       "0x00D5"
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_inst                                           0x00D5
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add_shift                             (0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add_mask                              (0x03FFFFFF)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add(data)                             (0x03FFFFFF&((data)<<0))
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_data_num_add_src(data)                         ((0x03FFFFFF&(data))>>0)
+#define HDMI_HDCP_2_2_HW_DATA_NUM_ADD_get_data_num_add(data)                         ((0x03FFFFFF&(data))>>0)
+
+
+#define HDMI_DBG                                                                     0x1800D140
+#define HDMI_DBG_reg_addr                                                            "0xB800D140"
+#define HDMI_DBG_reg                                                                 0xB800D140
+#define set_HDMI_DBG_reg(data)   (*((volatile unsigned int*) HDMI_DBG_reg)=data)
+#define get_HDMI_DBG_reg   (*((volatile unsigned int*) HDMI_DBG_reg))
+#define HDMI_DBG_inst_adr                                                            "0x0050"
+#define HDMI_DBG_inst                                                                0x0050
+#define HDMI_DBG_chsel0_shift                                                        (4)
+#define HDMI_DBG_chsel0_mask                                                         (0x000000F0)
+#define HDMI_DBG_chsel0(data)                                                        (0x000000F0&((data)<<4))
+#define HDMI_DBG_chsel0_src(data)                                                    ((0x000000F0&(data))>>4)
+#define HDMI_DBG_get_chsel0(data)                                                    ((0x000000F0&(data))>>4)
+#define HDMI_DBG_chsel1_shift                                                        (0)
+#define HDMI_DBG_chsel1_mask                                                         (0x0000000F)
+#define HDMI_DBG_chsel1(data)                                                        (0x0000000F&((data)<<0))
+#define HDMI_DBG_chsel1_src(data)                                                    ((0x0000000F&(data))>>0)
+#define HDMI_DBG_get_chsel1(data)                                                    ((0x0000000F&(data))>>0)
+
+
+#define HDMI_DUMMY_0                                                                 0x1800D144
+#define HDMI_DUMMY_1                                                                 0x1800D148
+#define HDMI_DUMMY_0_reg_addr                                                        "0xB800D144"
+#define HDMI_DUMMY_1_reg_addr                                                        "0xB800D148"
+#define HDMI_DUMMY_0_reg                                                             0xB800D144
+#define HDMI_DUMMY_1_reg                                                             0xB800D148
+#define set_HDMI_DUMMY_0_reg(data)   (*((volatile unsigned int*) HDMI_DUMMY_0_reg)=data)
+#define set_HDMI_DUMMY_1_reg(data)   (*((volatile unsigned int*) HDMI_DUMMY_1_reg)=data)
+#define get_HDMI_DUMMY_0_reg   (*((volatile unsigned int*) HDMI_DUMMY_0_reg))
+#define get_HDMI_DUMMY_1_reg   (*((volatile unsigned int*) HDMI_DUMMY_1_reg))
+#define HDMI_DUMMY_0_inst_adr                                                        "0x0051"
+#define HDMI_DUMMY_1_inst_adr                                                        "0x0052"
+#define HDMI_DUMMY_0_inst                                                            0x0051
+#define HDMI_DUMMY_1_inst                                                            0x0052
+#define HDMI_DUMMY_dummy_shift                                                       (0)
+#define HDMI_DUMMY_dummy_mask                                                        (0xFFFFFFFF)
+#define HDMI_DUMMY_dummy(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define HDMI_DUMMY_dummy_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define HDMI_DUMMY_get_dummy(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define HDMI_PHY                                                                     0x1800D14C
+#define HDMI_PHY_reg_addr                                                            "0xB800D14C"
+#define HDMI_PHY_reg                                                                 0xB800D14C
+#define set_HDMI_PHY_reg(data)   (*((volatile unsigned int*) HDMI_PHY_reg)=data)
+#define get_HDMI_PHY_reg   (*((volatile unsigned int*) HDMI_PHY_reg))
+#define HDMI_PHY_inst_adr                                                            "0x0053"
+#define HDMI_PHY_inst                                                                0x0053
+#define HDMI_PHY_test_mode_shift                                                     (1)
+#define HDMI_PHY_test_mode_mask                                                      (0x00000002)
+#define HDMI_PHY_test_mode(data)                                                     (0x00000002&((data)<<1))
+#define HDMI_PHY_test_mode_src(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_PHY_get_test_mode(data)                                                 ((0x00000002&(data))>>1)
+#define HDMI_PHY_data_realign_shift                                                  (0)
+#define HDMI_PHY_data_realign_mask                                                   (0x00000001)
+#define HDMI_PHY_data_realign(data)                                                  (0x00000001&((data)<<0))
+#define HDMI_PHY_data_realign_src(data)                                              ((0x00000001&(data))>>0)
+#define HDMI_PHY_get_data_realign(data)                                              ((0x00000001&(data))>>0)
+
+
+#define HDMI_H_PARA1                                                                 0x1800D234
+#define HDMI_H_PARA1_reg_addr                                                        "0xB800D234"
+#define HDMI_H_PARA1_reg                                                             0xB800D234
+#define set_HDMI_H_PARA1_reg(data)   (*((volatile unsigned int*) HDMI_H_PARA1_reg)=data)
+#define get_HDMI_H_PARA1_reg   (*((volatile unsigned int*) HDMI_H_PARA1_reg))
+#define HDMI_H_PARA1_inst_adr                                                        "0x008D"
+#define HDMI_H_PARA1_inst                                                            0x008D
+#define HDMI_H_PARA1_hblank_shift                                                    (16)
+#define HDMI_H_PARA1_hblank_mask                                                     (0x3FFF0000)
+#define HDMI_H_PARA1_hblank(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_H_PARA1_hblank_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA1_get_hblank(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA1_hactive_shift                                                   (0)
+#define HDMI_H_PARA1_hactive_mask                                                    (0x00003FFF)
+#define HDMI_H_PARA1_hactive(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_H_PARA1_hactive_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_H_PARA1_get_hactive(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_H_PARA2                                                                 0x1800D238
+#define HDMI_H_PARA2_reg_addr                                                        "0xB800D238"
+#define HDMI_H_PARA2_reg                                                             0xB800D238
+#define set_HDMI_H_PARA2_reg(data)   (*((volatile unsigned int*) HDMI_H_PARA2_reg)=data)
+#define get_HDMI_H_PARA2_reg   (*((volatile unsigned int*) HDMI_H_PARA2_reg))
+#define HDMI_H_PARA2_inst_adr                                                        "0x008E"
+#define HDMI_H_PARA2_inst                                                            0x008E
+#define HDMI_H_PARA2_hsync_shift                                                     (16)
+#define HDMI_H_PARA2_hsync_mask                                                      (0x3FFF0000)
+#define HDMI_H_PARA2_hsync(data)                                                     (0x3FFF0000&((data)<<16))
+#define HDMI_H_PARA2_hsync_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA2_get_hsync(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_H_PARA2_hfront_shift                                                    (0)
+#define HDMI_H_PARA2_hfront_mask                                                     (0x00003FFF)
+#define HDMI_H_PARA2_hfront(data)                                                    (0x00003FFF&((data)<<0))
+#define HDMI_H_PARA2_hfront_src(data)                                                ((0x00003FFF&(data))>>0)
+#define HDMI_H_PARA2_get_hfront(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_H_PARA3                                                                 0x1800D23c
+#define HDMI_H_PARA3_reg_addr                                                        "0xB800D23C"
+#define HDMI_H_PARA3_reg                                                             0xB800D23C
+#define set_HDMI_H_PARA3_reg(data)   (*((volatile unsigned int*) HDMI_H_PARA3_reg)=data)
+#define get_HDMI_H_PARA3_reg   (*((volatile unsigned int*) HDMI_H_PARA3_reg))
+#define HDMI_H_PARA3_inst_adr                                                        "0x008F"
+#define HDMI_H_PARA3_inst                                                            0x008F
+#define HDMI_H_PARA3_hback_shift                                                     (0)
+#define HDMI_H_PARA3_hback_mask                                                      (0x00003FFF)
+#define HDMI_H_PARA3_hback(data)                                                     (0x00003FFF&((data)<<0))
+#define HDMI_H_PARA3_hback_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define HDMI_H_PARA3_get_hback(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA1                                                                 0x1800D240
+#define HDMI_V_PARA1_reg_addr                                                        "0xB800D240"
+#define HDMI_V_PARA1_reg                                                             0xB800D240
+#define set_HDMI_V_PARA1_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA1_reg)=data)
+#define get_HDMI_V_PARA1_reg   (*((volatile unsigned int*) HDMI_V_PARA1_reg))
+#define HDMI_V_PARA1_inst_adr                                                        "0x0090"
+#define HDMI_V_PARA1_inst                                                            0x0090
+#define HDMI_V_PARA1_Vact_video_shift                                                (16)
+#define HDMI_V_PARA1_Vact_video_mask                                                 (0x3FFF0000)
+#define HDMI_V_PARA1_Vact_video(data)                                                (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA1_Vact_video_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA1_get_Vact_video(data)                                            ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA1_vactive_shift                                                   (0)
+#define HDMI_V_PARA1_vactive_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA1_vactive(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA1_vactive_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA1_get_vactive(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA2                                                                 0x1800D244
+#define HDMI_V_PARA2_reg_addr                                                        "0xB800D244"
+#define HDMI_V_PARA2_reg                                                             0xB800D244
+#define set_HDMI_V_PARA2_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA2_reg)=data)
+#define get_HDMI_V_PARA2_reg   (*((volatile unsigned int*) HDMI_V_PARA2_reg))
+#define HDMI_V_PARA2_inst_adr                                                        "0x0091"
+#define HDMI_V_PARA2_inst                                                            0x0091
+#define HDMI_V_PARA2_Vact_space1_shift                                               (16)
+#define HDMI_V_PARA2_Vact_space1_mask                                                (0x3FFF0000)
+#define HDMI_V_PARA2_Vact_space1(data)                                               (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA2_Vact_space1_src(data)                                           ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA2_get_Vact_space1(data)                                           ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA2_Vact_space_shift                                                (0)
+#define HDMI_V_PARA2_Vact_space_mask                                                 (0x00003FFF)
+#define HDMI_V_PARA2_Vact_space(data)                                                (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA2_Vact_space_src(data)                                            ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA2_get_Vact_space(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA3                                                                 0x1800D248
+#define HDMI_V_PARA3_reg_addr                                                        "0xB800D248"
+#define HDMI_V_PARA3_reg                                                             0xB800D248
+#define set_HDMI_V_PARA3_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA3_reg)=data)
+#define get_HDMI_V_PARA3_reg   (*((volatile unsigned int*) HDMI_V_PARA3_reg))
+#define HDMI_V_PARA3_inst_adr                                                        "0x0092"
+#define HDMI_V_PARA3_inst                                                            0x0092
+#define HDMI_V_PARA3_Vblank3_shift                                                   (16)
+#define HDMI_V_PARA3_Vblank3_mask                                                    (0x3FFF0000)
+#define HDMI_V_PARA3_Vblank3(data)                                                   (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA3_Vblank3_src(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA3_get_Vblank3(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA3_Vact_space2_shift                                               (0)
+#define HDMI_V_PARA3_Vact_space2_mask                                                (0x00003FFF)
+#define HDMI_V_PARA3_Vact_space2(data)                                               (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA3_Vact_space2_src(data)                                           ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA3_get_Vact_space2(data)                                           ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA4                                                                 0x1800D24C
+#define HDMI_V_PARA4_reg_addr                                                        "0xB800D24C"
+#define HDMI_V_PARA4_reg                                                             0xB800D24C
+#define set_HDMI_V_PARA4_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA4_reg)=data)
+#define get_HDMI_V_PARA4_reg   (*((volatile unsigned int*) HDMI_V_PARA4_reg))
+#define HDMI_V_PARA4_inst_adr                                                        "0x0093"
+#define HDMI_V_PARA4_inst                                                            0x0093
+#define HDMI_V_PARA4_vsync_shift                                                     (16)
+#define HDMI_V_PARA4_vsync_mask                                                      (0x3FFF0000)
+#define HDMI_V_PARA4_vsync(data)                                                     (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA4_vsync_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA4_get_vsync(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA4_vblank_shift                                                    (0)
+#define HDMI_V_PARA4_vblank_mask                                                     (0x00003FFF)
+#define HDMI_V_PARA4_vblank(data)                                                    (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA4_vblank_src(data)                                                ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA4_get_vblank(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA5                                                                 0x1800D250
+#define HDMI_V_PARA5_reg_addr                                                        "0xB800D250"
+#define HDMI_V_PARA5_reg                                                             0xB800D250
+#define set_HDMI_V_PARA5_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA5_reg)=data)
+#define get_HDMI_V_PARA5_reg   (*((volatile unsigned int*) HDMI_V_PARA5_reg))
+#define HDMI_V_PARA5_inst_adr                                                        "0x0094"
+#define HDMI_V_PARA5_inst                                                            0x0094
+#define HDMI_V_PARA5_vback_shift                                                     (16)
+#define HDMI_V_PARA5_vback_mask                                                      (0x3FFF0000)
+#define HDMI_V_PARA5_vback(data)                                                     (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA5_vback_src(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA5_get_vback(data)                                                 ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA5_vfront_shift                                                    (0)
+#define HDMI_V_PARA5_vfront_mask                                                     (0x00003FFF)
+#define HDMI_V_PARA5_vfront(data)                                                    (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA5_vfront_src(data)                                                ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA5_get_vfront(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA6                                                                 0x1800D254
+#define HDMI_V_PARA6_reg_addr                                                        "0xB800D254"
+#define HDMI_V_PARA6_reg                                                             0xB800D254
+#define set_HDMI_V_PARA6_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA6_reg)=data)
+#define get_HDMI_V_PARA6_reg   (*((volatile unsigned int*) HDMI_V_PARA6_reg))
+#define HDMI_V_PARA6_inst_adr                                                        "0x0095"
+#define HDMI_V_PARA6_inst                                                            0x0095
+#define HDMI_V_PARA6_Vsync1_shift                                                    (16)
+#define HDMI_V_PARA6_Vsync1_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA6_Vsync1(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA6_Vsync1_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA6_get_Vsync1(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA6_Vblank1_shift                                                   (0)
+#define HDMI_V_PARA6_Vblank1_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA6_Vblank1(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA6_Vblank1_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA6_get_Vblank1(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA7                                                                 0x1800D258
+#define HDMI_V_PARA7_reg_addr                                                        "0xB800D258"
+#define HDMI_V_PARA7_reg                                                             0xB800D258
+#define set_HDMI_V_PARA7_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA7_reg)=data)
+#define get_HDMI_V_PARA7_reg   (*((volatile unsigned int*) HDMI_V_PARA7_reg))
+#define HDMI_V_PARA7_inst_adr                                                        "0x0096"
+#define HDMI_V_PARA7_inst                                                            0x0096
+#define HDMI_V_PARA7_Vback1_shift                                                    (16)
+#define HDMI_V_PARA7_Vback1_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA7_Vback1(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA7_Vback1_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA7_get_Vback1(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA7_Vfront1_shift                                                   (0)
+#define HDMI_V_PARA7_Vfront1_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA7_Vfront1(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA7_Vfront1_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA7_get_Vfront1(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA8                                                                 0x1800D25C
+#define HDMI_V_PARA8_reg_addr                                                        "0xB800D25C"
+#define HDMI_V_PARA8_reg                                                             0xB800D25C
+#define set_HDMI_V_PARA8_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA8_reg)=data)
+#define get_HDMI_V_PARA8_reg   (*((volatile unsigned int*) HDMI_V_PARA8_reg))
+#define HDMI_V_PARA8_inst_adr                                                        "0x0097"
+#define HDMI_V_PARA8_inst                                                            0x0097
+#define HDMI_V_PARA8_Vsync2_shift                                                    (16)
+#define HDMI_V_PARA8_Vsync2_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA8_Vsync2(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA8_Vsync2_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA8_get_Vsync2(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA8_Vblank2_shift                                                   (0)
+#define HDMI_V_PARA8_Vblank2_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA8_Vblank2(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA8_Vblank2_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA8_get_Vblank2(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA9                                                                 0x1800D260
+#define HDMI_V_PARA9_reg_addr                                                        "0xB800D260"
+#define HDMI_V_PARA9_reg                                                             0xB800D260
+#define set_HDMI_V_PARA9_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA9_reg)=data)
+#define get_HDMI_V_PARA9_reg   (*((volatile unsigned int*) HDMI_V_PARA9_reg))
+#define HDMI_V_PARA9_inst_adr                                                        "0x0098"
+#define HDMI_V_PARA9_inst                                                            0x0098
+#define HDMI_V_PARA9_Vback2_shift                                                    (16)
+#define HDMI_V_PARA9_Vback2_mask                                                     (0x3FFF0000)
+#define HDMI_V_PARA9_Vback2(data)                                                    (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA9_Vback2_src(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA9_get_Vback2(data)                                                ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA9_Vfront2_shift                                                   (0)
+#define HDMI_V_PARA9_Vfront2_mask                                                    (0x00003FFF)
+#define HDMI_V_PARA9_Vfront2(data)                                                   (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA9_Vfront2_src(data)                                               ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA9_get_Vfront2(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA12                                                                0x1800D264
+#define HDMI_V_PARA12_reg_addr                                                       "0xB800D264"
+#define HDMI_V_PARA12_reg                                                            0xB800D264
+#define set_HDMI_V_PARA12_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA12_reg)=data)
+#define get_HDMI_V_PARA12_reg   (*((volatile unsigned int*) HDMI_V_PARA12_reg))
+#define HDMI_V_PARA12_inst_adr                                                       "0x0099"
+#define HDMI_V_PARA12_inst                                                           0x0099
+#define HDMI_V_PARA12_vsynci_shift                                                   (16)
+#define HDMI_V_PARA12_vsynci_mask                                                    (0x3FFF0000)
+#define HDMI_V_PARA12_vsynci(data)                                                   (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA12_vsynci_src(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA12_get_vsynci(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA12_vblanki_shift                                                  (0)
+#define HDMI_V_PARA12_vblanki_mask                                                   (0x00003FFF)
+#define HDMI_V_PARA12_vblanki(data)                                                  (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA12_vblanki_src(data)                                              ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA12_get_vblanki(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA13                                                                0x1800D268
+#define HDMI_V_PARA13_reg_addr                                                       "0xB800D268"
+#define HDMI_V_PARA13_reg                                                            0xB800D268
+#define set_HDMI_V_PARA13_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA13_reg)=data)
+#define get_HDMI_V_PARA13_reg   (*((volatile unsigned int*) HDMI_V_PARA13_reg))
+#define HDMI_V_PARA13_inst_adr                                                       "0x009A"
+#define HDMI_V_PARA13_inst                                                           0x009A
+#define HDMI_V_PARA13_vbacki_shift                                                   (16)
+#define HDMI_V_PARA13_vbacki_mask                                                    (0x3FFF0000)
+#define HDMI_V_PARA13_vbacki(data)                                                   (0x3FFF0000&((data)<<16))
+#define HDMI_V_PARA13_vbacki_src(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA13_get_vbacki(data)                                               ((0x3FFF0000&(data))>>16)
+#define HDMI_V_PARA13_vfronti_shift                                                  (0)
+#define HDMI_V_PARA13_vfronti_mask                                                   (0x00003FFF)
+#define HDMI_V_PARA13_vfronti(data)                                                  (0x00003FFF&((data)<<0))
+#define HDMI_V_PARA13_vfronti_src(data)                                              ((0x00003FFF&(data))>>0)
+#define HDMI_V_PARA13_get_vfronti(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define HDMI_V_PARA10                                                                0x1800D26C
+#define HDMI_V_PARA10_reg_addr                                                       "0xB800D26C"
+#define HDMI_V_PARA10_reg                                                            0xB800D26C
+#define set_HDMI_V_PARA10_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA10_reg)=data)
+#define get_HDMI_V_PARA10_reg   (*((volatile unsigned int*) HDMI_V_PARA10_reg))
+#define HDMI_V_PARA10_inst_adr                                                       "0x009B"
+#define HDMI_V_PARA10_inst                                                           0x009B
+#define HDMI_V_PARA10_G_shift                                                        (0)
+#define HDMI_V_PARA10_G_mask                                                         (0x00000FFF)
+#define HDMI_V_PARA10_G(data)                                                        (0x00000FFF&((data)<<0))
+#define HDMI_V_PARA10_G_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define HDMI_V_PARA10_get_G(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_V_PARA11                                                                0x1800D270
+#define HDMI_V_PARA11_reg_addr                                                       "0xB800D270"
+#define HDMI_V_PARA11_reg                                                            0xB800D270
+#define set_HDMI_V_PARA11_reg(data)   (*((volatile unsigned int*) HDMI_V_PARA11_reg)=data)
+#define get_HDMI_V_PARA11_reg   (*((volatile unsigned int*) HDMI_V_PARA11_reg))
+#define HDMI_V_PARA11_inst_adr                                                       "0x009C"
+#define HDMI_V_PARA11_inst                                                           0x009C
+#define HDMI_V_PARA11_B_shift                                                        (16)
+#define HDMI_V_PARA11_B_mask                                                         (0x0FFF0000)
+#define HDMI_V_PARA11_B(data)                                                        (0x0FFF0000&((data)<<16))
+#define HDMI_V_PARA11_B_src(data)                                                    ((0x0FFF0000&(data))>>16)
+#define HDMI_V_PARA11_get_B(data)                                                    ((0x0FFF0000&(data))>>16)
+#define HDMI_V_PARA11_R_shift                                                        (0)
+#define HDMI_V_PARA11_R_mask                                                         (0x00000FFF)
+#define HDMI_V_PARA11_R(data)                                                        (0x00000FFF&((data)<<0))
+#define HDMI_V_PARA11_R_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define HDMI_V_PARA11_get_R(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define HDMI_BIST1_CTRL                                                              0x1800D280
+#define HDMI_BIST1_CTRL_reg_addr                                                     "0xB800D280"
+#define HDMI_BIST1_CTRL_reg                                                          0xB800D280
+#define set_HDMI_BIST1_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_BIST1_CTRL_reg)=data)
+#define get_HDMI_BIST1_CTRL_reg   (*((volatile unsigned int*) HDMI_BIST1_CTRL_reg))
+#define HDMI_BIST1_CTRL_inst_adr                                                     "0x00A0"
+#define HDMI_BIST1_CTRL_inst                                                         0x00A0
+#define HDMI_BIST1_CTRL_dft_test_resume_shift                                        (7)
+#define HDMI_BIST1_CTRL_dft_test_resume_mask                                         (0x00000080)
+#define HDMI_BIST1_CTRL_dft_test_resume(data)                                        (0x00000080&((data)<<7))
+#define HDMI_BIST1_CTRL_dft_test_resume_src(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST1_CTRL_get_dft_test_resume(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST1_CTRL_dft_bist_mode_shift                                          (6)
+#define HDMI_BIST1_CTRL_dft_bist_mode_mask                                           (0x00000040)
+#define HDMI_BIST1_CTRL_dft_bist_mode(data)                                          (0x00000040&((data)<<6))
+#define HDMI_BIST1_CTRL_dft_bist_mode_src(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST1_CTRL_get_dft_bist_mode(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST1_CTRL_bist_mode_shift                                              (5)
+#define HDMI_BIST1_CTRL_bist_mode_mask                                               (0x00000020)
+#define HDMI_BIST1_CTRL_bist_mode(data)                                              (0x00000020&((data)<<5))
+#define HDMI_BIST1_CTRL_bist_mode_src(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST1_CTRL_get_bist_mode(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST1_CTRL_rme_shift                                                    (4)
+#define HDMI_BIST1_CTRL_rme_mask                                                     (0x00000010)
+#define HDMI_BIST1_CTRL_rme(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_BIST1_CTRL_rme_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST1_CTRL_get_rme(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST1_CTRL_rm_shift                                                     (0)
+#define HDMI_BIST1_CTRL_rm_mask                                                      (0x0000000F)
+#define HDMI_BIST1_CTRL_rm(data)                                                     (0x0000000F&((data)<<0))
+#define HDMI_BIST1_CTRL_rm_src(data)                                                 ((0x0000000F&(data))>>0)
+#define HDMI_BIST1_CTRL_get_rm(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define HDMI_BIST2_CTRL                                                              0x1800D29C
+#define HDMI_BIST2_CTRL_reg_addr                                                     "0xB800D29C"
+#define HDMI_BIST2_CTRL_reg                                                          0xB800D29C
+#define set_HDMI_BIST2_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_BIST2_CTRL_reg)=data)
+#define get_HDMI_BIST2_CTRL_reg   (*((volatile unsigned int*) HDMI_BIST2_CTRL_reg))
+#define HDMI_BIST2_CTRL_inst_adr                                                     "0x00A7"
+#define HDMI_BIST2_CTRL_inst                                                         0x00A7
+#define HDMI_BIST2_CTRL_dft_test_resume_shift                                        (7)
+#define HDMI_BIST2_CTRL_dft_test_resume_mask                                         (0x00000080)
+#define HDMI_BIST2_CTRL_dft_test_resume(data)                                        (0x00000080&((data)<<7))
+#define HDMI_BIST2_CTRL_dft_test_resume_src(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST2_CTRL_get_dft_test_resume(data)                                    ((0x00000080&(data))>>7)
+#define HDMI_BIST2_CTRL_dft_bist_mode_shift                                          (6)
+#define HDMI_BIST2_CTRL_dft_bist_mode_mask                                           (0x00000040)
+#define HDMI_BIST2_CTRL_dft_bist_mode(data)                                          (0x00000040&((data)<<6))
+#define HDMI_BIST2_CTRL_dft_bist_mode_src(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST2_CTRL_get_dft_bist_mode(data)                                      ((0x00000040&(data))>>6)
+#define HDMI_BIST2_CTRL_bist_mode_shift                                              (5)
+#define HDMI_BIST2_CTRL_bist_mode_mask                                               (0x00000020)
+#define HDMI_BIST2_CTRL_bist_mode(data)                                              (0x00000020&((data)<<5))
+#define HDMI_BIST2_CTRL_bist_mode_src(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST2_CTRL_get_bist_mode(data)                                          ((0x00000020&(data))>>5)
+#define HDMI_BIST2_CTRL_rme_shift                                                    (4)
+#define HDMI_BIST2_CTRL_rme_mask                                                     (0x00000010)
+#define HDMI_BIST2_CTRL_rme(data)                                                    (0x00000010&((data)<<4))
+#define HDMI_BIST2_CTRL_rme_src(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST2_CTRL_get_rme(data)                                                ((0x00000010&(data))>>4)
+#define HDMI_BIST2_CTRL_rm_shift                                                     (0)
+#define HDMI_BIST2_CTRL_rm_mask                                                      (0x0000000F)
+#define HDMI_BIST2_CTRL_rm(data)                                                     (0x0000000F&((data)<<0))
+#define HDMI_BIST2_CTRL_rm_src(data)                                                 ((0x0000000F&(data))>>0)
+#define HDMI_BIST2_CTRL_get_rm(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define HDMI_BIST1_ST                                                                0x1800D284
+#define HDMI_BIST1_ST_reg_addr                                                       "0xB800D284"
+#define HDMI_BIST1_ST_reg                                                            0xB800D284
+#define set_HDMI_BIST1_ST_reg(data)   (*((volatile unsigned int*) HDMI_BIST1_ST_reg)=data)
+#define get_HDMI_BIST1_ST_reg   (*((volatile unsigned int*) HDMI_BIST1_ST_reg))
+#define HDMI_BIST1_ST_inst_adr                                                       "0x00A1"
+#define HDMI_BIST1_ST_inst                                                           0x00A1
+#define HDMI_BIST1_ST_bist1_fail0_shift                                              (1)
+#define HDMI_BIST1_ST_bist1_fail0_mask                                               (0x00000002)
+#define HDMI_BIST1_ST_bist1_fail0(data)                                              (0x00000002&((data)<<1))
+#define HDMI_BIST1_ST_bist1_fail0_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST1_ST_get_bist1_fail0(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST1_ST_bist1_done_shift                                               (0)
+#define HDMI_BIST1_ST_bist1_done_mask                                                (0x00000001)
+#define HDMI_BIST1_ST_bist1_done(data)                                               (0x00000001&((data)<<0))
+#define HDMI_BIST1_ST_bist1_done_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_BIST1_ST_get_bist1_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_DRF_BIST1_ST                                                            0x1800D288
+#define HDMI_DRF_BIST1_ST_reg_addr                                                   "0xB800D288"
+#define HDMI_DRF_BIST1_ST_reg                                                        0xB800D288
+#define set_HDMI_DRF_BIST1_ST_reg(data)   (*((volatile unsigned int*) HDMI_DRF_BIST1_ST_reg)=data)
+#define get_HDMI_DRF_BIST1_ST_reg   (*((volatile unsigned int*) HDMI_DRF_BIST1_ST_reg))
+#define HDMI_DRF_BIST1_ST_inst_adr                                                   "0x00A2"
+#define HDMI_DRF_BIST1_ST_inst                                                       0x00A2
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause_shift                                (16)
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause_mask                                 (0x00010000)
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause(data)                                (0x00010000&((data)<<16))
+#define HDMI_DRF_BIST1_ST_drf_bist1_start_pause_src(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST1_ST_get_drf_bist1_start_pause(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0_shift                                      (1)
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0_mask                                       (0x00000002)
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0(data)                                      (0x00000002&((data)<<1))
+#define HDMI_DRF_BIST1_ST_drf_bist1_fail0_src(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST1_ST_get_drf_bist1_fail0(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST1_ST_drf_bist1_done_shift                                       (0)
+#define HDMI_DRF_BIST1_ST_drf_bist1_done_mask                                        (0x00000001)
+#define HDMI_DRF_BIST1_ST_drf_bist1_done(data)                                       (0x00000001&((data)<<0))
+#define HDMI_DRF_BIST1_ST_drf_bist1_done_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_DRF_BIST1_ST_get_drf_bist1_done(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_BIST2_ST                                                                0x1800D28C
+#define HDMI_BIST2_ST_reg_addr                                                       "0xB800D28C"
+#define HDMI_BIST2_ST_reg                                                            0xB800D28C
+#define set_HDMI_BIST2_ST_reg(data)   (*((volatile unsigned int*) HDMI_BIST2_ST_reg)=data)
+#define get_HDMI_BIST2_ST_reg   (*((volatile unsigned int*) HDMI_BIST2_ST_reg))
+#define HDMI_BIST2_ST_inst_adr                                                       "0x00A3"
+#define HDMI_BIST2_ST_inst                                                           0x00A3
+#define HDMI_BIST2_ST_bist2_fail0_shift                                              (1)
+#define HDMI_BIST2_ST_bist2_fail0_mask                                               (0x00000002)
+#define HDMI_BIST2_ST_bist2_fail0(data)                                              (0x00000002&((data)<<1))
+#define HDMI_BIST2_ST_bist2_fail0_src(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST2_ST_get_bist2_fail0(data)                                          ((0x00000002&(data))>>1)
+#define HDMI_BIST2_ST_bist2_done_shift                                               (0)
+#define HDMI_BIST2_ST_bist2_done_mask                                                (0x00000001)
+#define HDMI_BIST2_ST_bist2_done(data)                                               (0x00000001&((data)<<0))
+#define HDMI_BIST2_ST_bist2_done_src(data)                                           ((0x00000001&(data))>>0)
+#define HDMI_BIST2_ST_get_bist2_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define HDMI_DRF_BIST2_ST                                                            0x1800D290
+#define HDMI_DRF_BIST2_ST_reg_addr                                                   "0xB800D290"
+#define HDMI_DRF_BIST2_ST_reg                                                        0xB800D290
+#define set_HDMI_DRF_BIST2_ST_reg(data)   (*((volatile unsigned int*) HDMI_DRF_BIST2_ST_reg)=data)
+#define get_HDMI_DRF_BIST2_ST_reg   (*((volatile unsigned int*) HDMI_DRF_BIST2_ST_reg))
+#define HDMI_DRF_BIST2_ST_inst_adr                                                   "0x00A4"
+#define HDMI_DRF_BIST2_ST_inst                                                       0x00A4
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause_shift                                (16)
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause_mask                                 (0x00010000)
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause(data)                                (0x00010000&((data)<<16))
+#define HDMI_DRF_BIST2_ST_drf_bist2_start_pause_src(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST2_ST_get_drf_bist2_start_pause(data)                            ((0x00010000&(data))>>16)
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0_shift                                      (1)
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0_mask                                       (0x00000002)
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0(data)                                      (0x00000002&((data)<<1))
+#define HDMI_DRF_BIST2_ST_drf_bist2_fail0_src(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST2_ST_get_drf_bist2_fail0(data)                                  ((0x00000002&(data))>>1)
+#define HDMI_DRF_BIST2_ST_drf_bist2_done_shift                                       (0)
+#define HDMI_DRF_BIST2_ST_drf_bist2_done_mask                                        (0x00000001)
+#define HDMI_DRF_BIST2_ST_drf_bist2_done(data)                                       (0x00000001&((data)<<0))
+#define HDMI_DRF_BIST2_ST_drf_bist2_done_src(data)                                   ((0x00000001&(data))>>0)
+#define HDMI_DRF_BIST2_ST_get_drf_bist2_done(data)                                   ((0x00000001&(data))>>0)
+
+
+#define HDMI_MHLCTRL                                                                 0x1800D298
+#define HDMI_MHLCTRL_reg_addr                                                        "0xB800D298"
+#define HDMI_MHLCTRL_reg                                                             0xB800D298
+#define set_HDMI_MHLCTRL_reg(data)   (*((volatile unsigned int*) HDMI_MHLCTRL_reg)=data)
+#define get_HDMI_MHLCTRL_reg   (*((volatile unsigned int*) HDMI_MHLCTRL_reg))
+#define HDMI_MHLCTRL_inst_adr                                                        "0x00A6"
+#define HDMI_MHLCTRL_inst                                                            0x00A6
+#define HDMI_MHLCTRL_write_en5_shift                                                 (11)
+#define HDMI_MHLCTRL_write_en5_mask                                                  (0x00000800)
+#define HDMI_MHLCTRL_write_en5(data)                                                 (0x00000800&((data)<<11))
+#define HDMI_MHLCTRL_write_en5_src(data)                                             ((0x00000800&(data))>>11)
+#define HDMI_MHLCTRL_get_write_en5(data)                                             ((0x00000800&(data))>>11)
+#define HDMI_MHLCTRL_mhl_phy_test_mode_shift                                         (10)
+#define HDMI_MHLCTRL_mhl_phy_test_mode_mask                                          (0x00000400)
+#define HDMI_MHLCTRL_mhl_phy_test_mode(data)                                         (0x00000400&((data)<<10))
+#define HDMI_MHLCTRL_mhl_phy_test_mode_src(data)                                     ((0x00000400&(data))>>10)
+#define HDMI_MHLCTRL_get_mhl_phy_test_mode(data)                                     ((0x00000400&(data))>>10)
+#define HDMI_MHLCTRL_write_en4_shift                                                 (9)
+#define HDMI_MHLCTRL_write_en4_mask                                                  (0x00000200)
+#define HDMI_MHLCTRL_write_en4(data)                                                 (0x00000200&((data)<<9))
+#define HDMI_MHLCTRL_write_en4_src(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_MHLCTRL_get_write_en4(data)                                             ((0x00000200&(data))>>9)
+#define HDMI_MHLCTRL_xor_pixel_sel_shift                                             (6)
+#define HDMI_MHLCTRL_xor_pixel_sel_mask                                              (0x000001C0)
+#define HDMI_MHLCTRL_xor_pixel_sel(data)                                             (0x000001C0&((data)<<6))
+#define HDMI_MHLCTRL_xor_pixel_sel_src(data)                                         ((0x000001C0&(data))>>6)
+#define HDMI_MHLCTRL_get_xor_pixel_sel(data)                                         ((0x000001C0&(data))>>6)
+#define HDMI_MHLCTRL_write_en3_shift                                                 (5)
+#define HDMI_MHLCTRL_write_en3_mask                                                  (0x00000020)
+#define HDMI_MHLCTRL_write_en3(data)                                                 (0x00000020&((data)<<5))
+#define HDMI_MHLCTRL_write_en3_src(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_MHLCTRL_get_write_en3(data)                                             ((0x00000020&(data))>>5)
+#define HDMI_MHLCTRL_mhl_enc_sel_shift                                               (4)
+#define HDMI_MHLCTRL_mhl_enc_sel_mask                                                (0x00000010)
+#define HDMI_MHLCTRL_mhl_enc_sel(data)                                               (0x00000010&((data)<<4))
+#define HDMI_MHLCTRL_mhl_enc_sel_src(data)                                           ((0x00000010&(data))>>4)
+#define HDMI_MHLCTRL_get_mhl_enc_sel(data)                                           ((0x00000010&(data))>>4)
+#define HDMI_MHLCTRL_write_en2_shift                                                 (3)
+#define HDMI_MHLCTRL_write_en2_mask                                                  (0x00000008)
+#define HDMI_MHLCTRL_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define HDMI_MHLCTRL_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_MHLCTRL_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define HDMI_MHLCTRL_mhl_pp_mode_shift                                               (2)
+#define HDMI_MHLCTRL_mhl_pp_mode_mask                                                (0x00000004)
+#define HDMI_MHLCTRL_mhl_pp_mode(data)                                               (0x00000004&((data)<<2))
+#define HDMI_MHLCTRL_mhl_pp_mode_src(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_MHLCTRL_get_mhl_pp_mode(data)                                           ((0x00000004&(data))>>2)
+#define HDMI_MHLCTRL_write_en1_shift                                                 (1)
+#define HDMI_MHLCTRL_write_en1_mask                                                  (0x00000002)
+#define HDMI_MHLCTRL_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define HDMI_MHLCTRL_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_MHLCTRL_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define HDMI_MHLCTRL_mhl_enable_shift                                                (0)
+#define HDMI_MHLCTRL_mhl_enable_mask                                                 (0x00000001)
+#define HDMI_MHLCTRL_mhl_enable(data)                                                (0x00000001&((data)<<0))
+#define HDMI_MHLCTRL_mhl_enable_src(data)                                            ((0x00000001&(data))>>0)
+#define HDMI_MHLCTRL_get_mhl_enable(data)                                            ((0x00000001&(data))>>0)
+
+
+#define HDMI_CHSWAP                                                                  0x1800D2A0
+#define HDMI_CHSWAP_reg_addr                                                         "0xB800D2A0"
+#define HDMI_CHSWAP_reg                                                              0xB800D2A0
+#define set_HDMI_CHSWAP_reg(data)   (*((volatile unsigned int*) HDMI_CHSWAP_reg)=data)
+#define get_HDMI_CHSWAP_reg   (*((volatile unsigned int*) HDMI_CHSWAP_reg))
+#define HDMI_CHSWAP_inst_adr                                                         "0x00A8"
+#define HDMI_CHSWAP_inst                                                             0x00A8
+#define HDMI_CHSWAP_write_en3_shift                                                  (5)
+#define HDMI_CHSWAP_write_en3_mask                                                   (0x00000020)
+#define HDMI_CHSWAP_write_en3(data)                                                  (0x00000020&((data)<<5))
+#define HDMI_CHSWAP_write_en3_src(data)                                              ((0x00000020&(data))>>5)
+#define HDMI_CHSWAP_get_write_en3(data)                                              ((0x00000020&(data))>>5)
+#define HDMI_CHSWAP_mhl_ch_sel_shift                                                 (4)
+#define HDMI_CHSWAP_mhl_ch_sel_mask                                                  (0x00000010)
+#define HDMI_CHSWAP_mhl_ch_sel(data)                                                 (0x00000010&((data)<<4))
+#define HDMI_CHSWAP_mhl_ch_sel_src(data)                                             ((0x00000010&(data))>>4)
+#define HDMI_CHSWAP_get_mhl_ch_sel(data)                                             ((0x00000010&(data))>>4)
+#define HDMI_CHSWAP_write_en2_shift                                                  (3)
+#define HDMI_CHSWAP_write_en2_mask                                                   (0x00000008)
+#define HDMI_CHSWAP_write_en2(data)                                                  (0x00000008&((data)<<3))
+#define HDMI_CHSWAP_write_en2_src(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_CHSWAP_get_write_en2(data)                                              ((0x00000008&(data))>>3)
+#define HDMI_CHSWAP_hdmi_chcclk_swap_shift                                           (2)
+#define HDMI_CHSWAP_hdmi_chcclk_swap_mask                                            (0x00000004)
+#define HDMI_CHSWAP_hdmi_chcclk_swap(data)                                           (0x00000004&((data)<<2))
+#define HDMI_CHSWAP_hdmi_chcclk_swap_src(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_CHSWAP_get_hdmi_chcclk_swap(data)                                       ((0x00000004&(data))>>2)
+#define HDMI_CHSWAP_write_en1_shift                                                  (1)
+#define HDMI_CHSWAP_write_en1_mask                                                   (0x00000002)
+#define HDMI_CHSWAP_write_en1(data)                                                  (0x00000002&((data)<<1))
+#define HDMI_CHSWAP_write_en1_src(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_CHSWAP_get_write_en1(data)                                              ((0x00000002&(data))>>1)
+#define HDMI_CHSWAP_hdmi_chab_swap_shift                                             (0)
+#define HDMI_CHSWAP_hdmi_chab_swap_mask                                              (0x00000001)
+#define HDMI_CHSWAP_hdmi_chab_swap(data)                                             (0x00000001&((data)<<0))
+#define HDMI_CHSWAP_hdmi_chab_swap_src(data)                                         ((0x00000001&(data))>>0)
+#define HDMI_CHSWAP_get_hdmi_chab_swap(data)                                         ((0x00000001&(data))>>0)
+
+
+#define HDMI_PREFIFO_CTRL                                                            0x1800D294
+#define HDMI_PREFIFO_CTRL_reg_addr                                                   "0xB800D294"
+#define HDMI_PREFIFO_CTRL_reg                                                        0xB800D294
+#define set_HDMI_PREFIFO_CTRL_reg(data)   (*((volatile unsigned int*) HDMI_PREFIFO_CTRL_reg)=data)
+#define get_HDMI_PREFIFO_CTRL_reg   (*((volatile unsigned int*) HDMI_PREFIFO_CTRL_reg))
+#define HDMI_PREFIFO_CTRL_inst_adr                                                   "0x00A5"
+#define HDMI_PREFIFO_CTRL_inst                                                       0x00A5
+#define HDMI_PREFIFO_CTRL_write_en2_shift                                            (3)
+#define HDMI_PREFIFO_CTRL_write_en2_mask                                             (0x00000008)
+#define HDMI_PREFIFO_CTRL_write_en2(data)                                            (0x00000008&((data)<<3))
+#define HDMI_PREFIFO_CTRL_write_en2_src(data)                                        ((0x00000008&(data))>>3)
+#define HDMI_PREFIFO_CTRL_get_write_en2(data)                                        ((0x00000008&(data))>>3)
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv_shift                                     (2)
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv_mask                                      (0x00000004)
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv(data)                                     (0x00000004&((data)<<2))
+#define HDMI_PREFIFO_CTRL_hdmi_prefifo_inv_src(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_PREFIFO_CTRL_get_hdmi_prefifo_inv(data)                                 ((0x00000004&(data))>>2)
+#define HDMI_PREFIFO_CTRL_write_en1_shift                                            (1)
+#define HDMI_PREFIFO_CTRL_write_en1_mask                                             (0x00000002)
+#define HDMI_PREFIFO_CTRL_write_en1(data)                                            (0x00000002&((data)<<1))
+#define HDMI_PREFIFO_CTRL_write_en1_src(data)                                        ((0x00000002&(data))>>1)
+#define HDMI_PREFIFO_CTRL_get_write_en1(data)                                        ((0x00000002&(data))>>1)
+#define HDMI_PREFIFO_CTRL_async_update_shift                                         (0)
+#define HDMI_PREFIFO_CTRL_async_update_mask                                          (0x00000001)
+#define HDMI_PREFIFO_CTRL_async_update(data)                                         (0x00000001&((data)<<0))
+#define HDMI_PREFIFO_CTRL_async_update_src(data)                                     ((0x00000001&(data))>>0)
+#define HDMI_PREFIFO_CTRL_get_async_update(data)                                     ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/hdmirx_wrapper_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/hdmirx_wrapper_reg.h
new file mode 100644
index 00000000..a3452b4
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/hdmirx_wrapper_reg.h
@@ -0,0 +1,326 @@
+/**************************************************************
+// Spec Version                  : unknown
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/5/24 11:33:13
+***************************************************************/
+
+
+#ifndef _HDMIRX_WRAPPER_REG_H_INCLUDED_
+#define _HDMIRX_WRAPPER_REG_H_INCLUDED_
+#ifdef  _HDMIRX_WRAPPER_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     den_buf1:13;
+unsigned int     reserved_1:3;
+unsigned int     den_buf0:13;
+}HDMIRX_WRAPPER_DEN_BUF01;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     den_buf3:13;
+unsigned int     reserved_1:3;
+unsigned int     den_buf2:13;
+}HDMIRX_WRAPPER_DEN_BUF23;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     hor_threshold:13;
+}HDMIRX_WRAPPER_HOR_THRESHOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     set_ver_width:12;
+unsigned int     reserved_1:3;
+unsigned int     set_hor_width:13;
+}HDMIRX_WRAPPER_ACTIVE_PIXELS;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     polarity_l_cnt:12;
+unsigned int     reserved_1:4;
+unsigned int     polarity_h_cnt:12;
+}HDMIRX_WRAPPER_MONITOR_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     mux_polarity:1;
+unsigned int     line_buf0:12;
+}HDMIRX_WRAPPER_MONITOR_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ver_err_en:1;
+unsigned int     hor_err_en:1;
+unsigned int     polarity_detect_en:1;
+}HDMIRX_WRAPPER_INTERRUPT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ver_err_sts:1;
+unsigned int     hor_err_sts:1;
+unsigned int     polarity_detect_sts:1;
+}HDMIRX_WRAPPER_INTERRUPT_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     fifo_stage:1;
+unsigned int     fw_dma_en:1;
+unsigned int     polarity_set_en:1;
+unsigned int     polarity_set:1;
+unsigned int     addr_h:4;
+unsigned int     reserved_1:1;
+unsigned int     yuv_fmt:2;
+unsigned int     hdmirx_en:1;
+}HDMIRX_WRAPPER_CONTROL_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     dummy_ctrl:13;
+unsigned int     debug_sel:1;
+unsigned int     debug_mux:2;
+}HDMIRX_WRAPPER_CONTROL_1;
+
+#endif
+
+#define HDMIRX_WRAPPER_DEN_BUF01                                                     0x1800FF00
+#define HDMIRX_WRAPPER_DEN_BUF01_reg_addr                                            "0xB800FF00"
+#define HDMIRX_WRAPPER_DEN_BUF01_reg                                                 0xB800FF00
+#define set_HDMIRX_WRAPPER_DEN_BUF01_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_DEN_BUF01_reg)=data)
+#define get_HDMIRX_WRAPPER_DEN_BUF01_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_DEN_BUF01_reg))
+#define HDMIRX_WRAPPER_DEN_BUF01_inst_adr                                            "0x00C0"
+#define HDMIRX_WRAPPER_DEN_BUF01_inst                                                0x00C0
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1_shift                                      (16)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1_mask                                       (0x1FFF0000)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1(data)                                      (0x1FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf1_src(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF01_get_den_buf1(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0_shift                                      (0)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0_mask                                       (0x00001FFF)
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0(data)                                      (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_DEN_BUF01_den_buf0_src(data)                                  ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_DEN_BUF01_get_den_buf0(data)                                  ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_DEN_BUF23                                                     0x1800FF04
+#define HDMIRX_WRAPPER_DEN_BUF23_reg_addr                                            "0xB800FF04"
+#define HDMIRX_WRAPPER_DEN_BUF23_reg                                                 0xB800FF04
+#define set_HDMIRX_WRAPPER_DEN_BUF23_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_DEN_BUF23_reg)=data)
+#define get_HDMIRX_WRAPPER_DEN_BUF23_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_DEN_BUF23_reg))
+#define HDMIRX_WRAPPER_DEN_BUF23_inst_adr                                            "0x00C1"
+#define HDMIRX_WRAPPER_DEN_BUF23_inst                                                0x00C1
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3_shift                                      (16)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3_mask                                       (0x1FFF0000)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3(data)                                      (0x1FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf3_src(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF23_get_den_buf3(data)                                  ((0x1FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2_shift                                      (0)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2_mask                                       (0x00001FFF)
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2(data)                                      (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_DEN_BUF23_den_buf2_src(data)                                  ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_DEN_BUF23_get_den_buf2(data)                                  ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_HOR_THRESHOLD                                                 0x1800FF08
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_reg_addr                                        "0xB800FF08"
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_reg                                             0xB800FF08
+#define set_HDMIRX_WRAPPER_HOR_THRESHOLD_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_HOR_THRESHOLD_reg)=data)
+#define get_HDMIRX_WRAPPER_HOR_THRESHOLD_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_HOR_THRESHOLD_reg))
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_inst_adr                                        "0x00C2"
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_inst                                            0x00C2
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold_shift                             (0)
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold_mask                              (0x00001FFF)
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold(data)                             (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_hor_threshold_src(data)                         ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_HOR_THRESHOLD_get_hor_threshold(data)                         ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS                                                 0x1800FF0C
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_reg_addr                                        "0xB800FF0C"
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_reg                                             0xB800FF0C
+#define set_HDMIRX_WRAPPER_ACTIVE_PIXELS_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_ACTIVE_PIXELS_reg)=data)
+#define get_HDMIRX_WRAPPER_ACTIVE_PIXELS_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_ACTIVE_PIXELS_reg))
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_inst_adr                                        "0x00C3"
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_inst                                            0x00C3
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width_shift                             (16)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width_mask                              (0x0FFF0000)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width(data)                             (0x0FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_ver_width_src(data)                         ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_get_set_ver_width(data)                         ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width_shift                             (0)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width_mask                              (0x00001FFF)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width(data)                             (0x00001FFF&((data)<<0))
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_set_hor_width_src(data)                         ((0x00001FFF&(data))>>0)
+#define HDMIRX_WRAPPER_ACTIVE_PIXELS_get_set_hor_width(data)                         ((0x00001FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_MONITOR_0                                                     0x1800FF10
+#define HDMIRX_WRAPPER_MONITOR_0_reg_addr                                            "0xB800FF10"
+#define HDMIRX_WRAPPER_MONITOR_0_reg                                                 0xB800FF10
+#define set_HDMIRX_WRAPPER_MONITOR_0_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_MONITOR_0_reg)=data)
+#define get_HDMIRX_WRAPPER_MONITOR_0_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_MONITOR_0_reg))
+#define HDMIRX_WRAPPER_MONITOR_0_inst_adr                                            "0x00C4"
+#define HDMIRX_WRAPPER_MONITOR_0_inst                                                0x00C4
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt_shift                                (16)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt_mask                                 (0x0FFF0000)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt(data)                                (0x0FFF0000&((data)<<16))
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_l_cnt_src(data)                            ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_MONITOR_0_get_polarity_l_cnt(data)                            ((0x0FFF0000&(data))>>16)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt_shift                                (0)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt_mask                                 (0x00000FFF)
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt(data)                                (0x00000FFF&((data)<<0))
+#define HDMIRX_WRAPPER_MONITOR_0_polarity_h_cnt_src(data)                            ((0x00000FFF&(data))>>0)
+#define HDMIRX_WRAPPER_MONITOR_0_get_polarity_h_cnt(data)                            ((0x00000FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_MONITOR_1                                                     0x1800FF14
+#define HDMIRX_WRAPPER_MONITOR_1_reg_addr                                            "0xB800FF14"
+#define HDMIRX_WRAPPER_MONITOR_1_reg                                                 0xB800FF14
+#define set_HDMIRX_WRAPPER_MONITOR_1_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_MONITOR_1_reg)=data)
+#define get_HDMIRX_WRAPPER_MONITOR_1_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_MONITOR_1_reg))
+#define HDMIRX_WRAPPER_MONITOR_1_inst_adr                                            "0x00C5"
+#define HDMIRX_WRAPPER_MONITOR_1_inst                                                0x00C5
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity_shift                                  (12)
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity_mask                                   (0x00001000)
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity(data)                                  (0x00001000&((data)<<12))
+#define HDMIRX_WRAPPER_MONITOR_1_mux_polarity_src(data)                              ((0x00001000&(data))>>12)
+#define HDMIRX_WRAPPER_MONITOR_1_get_mux_polarity(data)                              ((0x00001000&(data))>>12)
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0_shift                                     (0)
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0_mask                                      (0x00000FFF)
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0(data)                                     (0x00000FFF&((data)<<0))
+#define HDMIRX_WRAPPER_MONITOR_1_line_buf0_src(data)                                 ((0x00000FFF&(data))>>0)
+#define HDMIRX_WRAPPER_MONITOR_1_get_line_buf0(data)                                 ((0x00000FFF&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_INTERRUPT_EN                                                  0x1800FF18
+#define HDMIRX_WRAPPER_INTERRUPT_EN_reg_addr                                         "0xB800FF18"
+#define HDMIRX_WRAPPER_INTERRUPT_EN_reg                                              0xB800FF18
+#define set_HDMIRX_WRAPPER_INTERRUPT_EN_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_INTERRUPT_EN_reg)=data)
+#define get_HDMIRX_WRAPPER_INTERRUPT_EN_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_INTERRUPT_EN_reg))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_inst_adr                                         "0x00C6"
+#define HDMIRX_WRAPPER_INTERRUPT_EN_inst                                             0x00C6
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_shift                                 (2)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_mask                                  (0x00000004)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en(data)                                 (0x00000004&((data)<<2))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_ver_err_en_src(data)                             ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_get_ver_err_en(data)                             ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_shift                                 (1)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_mask                                  (0x00000002)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en(data)                                 (0x00000002&((data)<<1))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_hor_err_en_src(data)                             ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_get_hor_err_en(data)                             ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_shift                         (0)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_mask                          (0x00000001)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en(data)                         (0x00000001&((data)<<0))
+#define HDMIRX_WRAPPER_INTERRUPT_EN_polarity_detect_en_src(data)                     ((0x00000001&(data))>>0)
+#define HDMIRX_WRAPPER_INTERRUPT_EN_get_polarity_detect_en(data)                     ((0x00000001&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS                                              0x1800FF1C
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_reg_addr                                     "0xB800FF1C"
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_reg                                          0xB800FF1C
+#define set_HDMIRX_WRAPPER_INTERRUPT_STATUS_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_INTERRUPT_STATUS_reg)=data)
+#define get_HDMIRX_WRAPPER_INTERRUPT_STATUS_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_INTERRUPT_STATUS_reg))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_inst_adr                                     "0x00C7"
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_inst                                         0x00C7
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts_shift                            (2)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts_mask                             (0x00000004)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts(data)                            (0x00000004&((data)<<2))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_ver_err_sts_src(data)                        ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_get_ver_err_sts(data)                        ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts_shift                            (1)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts_mask                             (0x00000002)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts(data)                            (0x00000002&((data)<<1))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_hor_err_sts_src(data)                        ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_get_hor_err_sts(data)                        ((0x00000002&(data))>>1)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts_shift                    (0)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts_mask                     (0x00000001)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts(data)                    (0x00000001&((data)<<0))
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_polarity_detect_sts_src(data)                ((0x00000001&(data))>>0)
+#define HDMIRX_WRAPPER_INTERRUPT_STATUS_get_polarity_detect_sts(data)                ((0x00000001&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_CONTROL_0                                                     0x1800FF20
+#define HDMIRX_WRAPPER_CONTROL_0_reg_addr                                            "0xB800FF20"
+#define HDMIRX_WRAPPER_CONTROL_0_reg                                                 0xB800FF20
+#define set_HDMIRX_WRAPPER_CONTROL_0_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_CONTROL_0_reg)=data)
+#define get_HDMIRX_WRAPPER_CONTROL_0_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_CONTROL_0_reg))
+#define HDMIRX_WRAPPER_CONTROL_0_inst_adr                                            "0x00C8"
+#define HDMIRX_WRAPPER_CONTROL_0_inst                                                0x00C8
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage_shift                                    (11)
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage_mask                                     (0x00000800)
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage(data)                                    (0x00000800&((data)<<11))
+#define HDMIRX_WRAPPER_CONTROL_0_fifo_stage_src(data)                                ((0x00000800&(data))>>11)
+#define HDMIRX_WRAPPER_CONTROL_0_get_fifo_stage(data)                                ((0x00000800&(data))>>11)
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_shift                                     (10)
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_mask                                      (0x00000400)
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en(data)                                     (0x00000400&((data)<<10))
+#define HDMIRX_WRAPPER_CONTROL_0_fw_dma_en_src(data)                                 ((0x00000400&(data))>>10)
+#define HDMIRX_WRAPPER_CONTROL_0_get_fw_dma_en(data)                                 ((0x00000400&(data))>>10)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_shift                               (9)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_mask                                (0x00000200)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en(data)                               (0x00000200&((data)<<9))
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_en_src(data)                           ((0x00000200&(data))>>9)
+#define HDMIRX_WRAPPER_CONTROL_0_get_polarity_set_en(data)                           ((0x00000200&(data))>>9)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_shift                                  (8)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_mask                                   (0x00000100)
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set(data)                                  (0x00000100&((data)<<8))
+#define HDMIRX_WRAPPER_CONTROL_0_polarity_set_src(data)                              ((0x00000100&(data))>>8)
+#define HDMIRX_WRAPPER_CONTROL_0_get_polarity_set(data)                              ((0x00000100&(data))>>8)
+#define HDMIRX_WRAPPER_CONTROL_0_addr_h_shift                                        (4)
+#define HDMIRX_WRAPPER_CONTROL_0_addr_h_mask                                         (0x000000F0)
+#define HDMIRX_WRAPPER_CONTROL_0_addr_h(data)                                        (0x000000F0&((data)<<4))
+#define HDMIRX_WRAPPER_CONTROL_0_addr_h_src(data)                                    ((0x000000F0&(data))>>4)
+#define HDMIRX_WRAPPER_CONTROL_0_get_addr_h(data)                                    ((0x000000F0&(data))>>4)
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_shift                                       (1)
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_mask                                        (0x00000006)
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt(data)                                       (0x00000006&((data)<<1))
+#define HDMIRX_WRAPPER_CONTROL_0_yuv_fmt_src(data)                                   ((0x00000006&(data))>>1)
+#define HDMIRX_WRAPPER_CONTROL_0_get_yuv_fmt(data)                                   ((0x00000006&(data))>>1)
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_shift                                     (0)
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_mask                                      (0x00000001)
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en(data)                                     (0x00000001&((data)<<0))
+#define HDMIRX_WRAPPER_CONTROL_0_hdmirx_en_src(data)                                 ((0x00000001&(data))>>0)
+#define HDMIRX_WRAPPER_CONTROL_0_get_hdmirx_en(data)                                 ((0x00000001&(data))>>0)
+
+
+#define HDMIRX_WRAPPER_CONTROL_1                                                     0x1800FF24
+#define HDMIRX_WRAPPER_CONTROL_1_reg_addr                                            "0xB800FF24"
+#define HDMIRX_WRAPPER_CONTROL_1_reg                                                 0xB800FF24
+#define set_HDMIRX_WRAPPER_CONTROL_1_reg(data)   (*((volatile unsigned int*) HDMIRX_WRAPPER_CONTROL_1_reg)=data)
+#define get_HDMIRX_WRAPPER_CONTROL_1_reg   (*((volatile unsigned int*) HDMIRX_WRAPPER_CONTROL_1_reg))
+#define HDMIRX_WRAPPER_CONTROL_1_inst_adr                                            "0x00C9"
+#define HDMIRX_WRAPPER_CONTROL_1_inst                                                0x00C9
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl_shift                                    (3)
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl_mask                                     (0x0000FFF8)
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl(data)                                    (0x0000FFF8&((data)<<3))
+#define HDMIRX_WRAPPER_CONTROL_1_dummy_ctrl_src(data)                                ((0x0000FFF8&(data))>>3)
+#define HDMIRX_WRAPPER_CONTROL_1_get_dummy_ctrl(data)                                ((0x0000FFF8&(data))>>3)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel_shift                                     (2)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel_mask                                      (0x00000004)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel(data)                                     (0x00000004&((data)<<2))
+#define HDMIRX_WRAPPER_CONTROL_1_debug_sel_src(data)                                 ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_CONTROL_1_get_debug_sel(data)                                 ((0x00000004&(data))>>2)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux_shift                                     (0)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux_mask                                      (0x00000003)
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux(data)                                     (0x00000003&((data)<<0))
+#define HDMIRX_WRAPPER_CONTROL_1_debug_mux_src(data)                                 ((0x00000003&(data))>>0)
+#define HDMIRX_WRAPPER_CONTROL_1_get_debug_mux(data)                                 ((0x00000003&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/icam_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/icam_reg.h
new file mode 100644
index 00000000..b7043f3
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/icam_reg.h
@@ -0,0 +1,1191 @@
+/**************************************************************
+// Spec Version                  : 1.0
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 16 bits
+// Firmware Header Generate Date : 2012/1/9 11:6:38
+***************************************************************/
+
+
+#ifndef _ICAM_REG_H_INCLUDED_
+#define _ICAM_REG_H_INCLUDED_
+#ifdef  _ICAM_USE_STRUCT
+typedef struct 
+{
+unsigned int     Data:32;
+}ICAM_DATA;
+
+typedef struct 
+{
+unsigned int     Restart:1;
+unsigned int     reserved_0:17;
+unsigned int     PID_Index:6;
+unsigned int     Algorithm:3;
+unsigned int     reserved_1:3;
+unsigned int     OpCode:2;
+}ICAM_COMMAND;
+
+typedef struct 
+{
+unsigned int     Version:32;
+}ICAM_VERSION;
+
+typedef struct 
+{
+unsigned int     ID_H:32;
+}ICAM_ID_H;
+
+typedef struct 
+{
+unsigned int     ID_L:32;
+}ICAM_ID_L;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Illegal_Transport_Stream_Write:1;
+unsigned int     Illegal_Transport_Stream_Read:1;
+unsigned int     Write_On_Busy:1;
+unsigned int     Illegal_Sequence:1;
+unsigned int     Illegal_Data:1;
+unsigned int     Invalid_OTP:1;
+unsigned int     Invalid_KTE:1;
+unsigned int     UART:1;
+}ICAM_INTERRUPT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Illegal_Transport_Stream_Write_Mask:1;
+unsigned int     Illegal_Transport_Stream_Read_Mask:1;
+unsigned int     Write_On_Busy_Mask:1;
+unsigned int     Illegal_Sequence_Mask:1;
+unsigned int     Illegal_Data_Mask:1;
+unsigned int     Invalid_OTP_Mask:1;
+unsigned int     Invalid_KTE_Mask:1;
+unsigned int     reserved_1:1;
+}ICAM_INTERRUPT_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     OTP_NDS_Mode:1;
+unsigned int     Serialization_Fail:1;
+unsigned int     Invalid_OTP:1;
+unsigned int     Busy:1;
+}ICAM_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     KT_Status:20;
+}ICAM_KT_STATUS_H;
+
+typedef struct 
+{
+unsigned int     KT_Status:32;
+}ICAM_KT_STATUS_L;
+
+typedef struct 
+{
+unsigned int     iv:32;
+}ICAM_AES_CBC_IV;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Data:8;
+}ICAM_UART_DATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Control_Status:8;
+}ICAM_UART_CTRL_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Baud_Rate:8;
+}ICAM_UART_BAUD_RATE_L;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Baud_Rate:8;
+}ICAM_UART_BAUD_RATE_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Communication:8;
+}ICAM_UART_COM;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Interrupt_Mask:8;
+}ICAM_UART_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Guard_Time:8;
+}ICAM_UART_GUARD_TIME;
+
+typedef struct 
+{
+unsigned int     SER_ID_H:32;
+}ICAM_SER_ID_H;
+
+typedef struct 
+{
+unsigned int     SER_ID_L:32;
+}ICAM_SER_ID_L;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     OTP_NDS_Mode:1;
+unsigned int     Serialization_Fail:1;
+unsigned int     Invalid_OTP:1;
+unsigned int     Busy:1;
+}ICAM_SER_FLAG;
+
+typedef struct 
+{
+unsigned int     SER_Base:32;
+}ICAM_SER_BASE;
+
+typedef struct 
+{
+unsigned int     SER_Result:32;
+}ICAM_SER_RESULT;
+
+#endif
+
+#define ICAM_DATA_0                                                                  0x18020000
+#define ICAM_DATA_1                                                                  0x18020004
+#define ICAM_DATA_2                                                                  0x18020008
+#define ICAM_DATA_3                                                                  0x1802000C
+#define ICAM_DATA_0_reg_addr                                                         "0xB8020000"
+#define ICAM_DATA_1_reg_addr                                                         "0xB8020004"
+#define ICAM_DATA_2_reg_addr                                                         "0xB8020008"
+#define ICAM_DATA_3_reg_addr                                                         "0xB802000C"
+#define ICAM_DATA_0_reg                                                              0xB8020000
+#define ICAM_DATA_1_reg                                                              0xB8020004
+#define ICAM_DATA_2_reg                                                              0xB8020008
+#define ICAM_DATA_3_reg                                                              0xB802000C
+#define set_ICAM_DATA_0_reg(data)   (*((volatile unsigned int*) ICAM_DATA_0_reg)=data)
+#define set_ICAM_DATA_1_reg(data)   (*((volatile unsigned int*) ICAM_DATA_1_reg)=data)
+#define set_ICAM_DATA_2_reg(data)   (*((volatile unsigned int*) ICAM_DATA_2_reg)=data)
+#define set_ICAM_DATA_3_reg(data)   (*((volatile unsigned int*) ICAM_DATA_3_reg)=data)
+#define get_ICAM_DATA_0_reg   (*((volatile unsigned int*) ICAM_DATA_0_reg))
+#define get_ICAM_DATA_1_reg   (*((volatile unsigned int*) ICAM_DATA_1_reg))
+#define get_ICAM_DATA_2_reg   (*((volatile unsigned int*) ICAM_DATA_2_reg))
+#define get_ICAM_DATA_3_reg   (*((volatile unsigned int*) ICAM_DATA_3_reg))
+#define ICAM_DATA_0_inst_adr                                                         "0x0000"
+#define ICAM_DATA_1_inst_adr                                                         "0x0001"
+#define ICAM_DATA_2_inst_adr                                                         "0x0002"
+#define ICAM_DATA_3_inst_adr                                                         "0x0003"
+#define ICAM_DATA_0_inst                                                             0x0000
+#define ICAM_DATA_1_inst                                                             0x0001
+#define ICAM_DATA_2_inst                                                             0x0002
+#define ICAM_DATA_3_inst                                                             0x0003
+#define ICAM_DATA_Data_shift                                                         (0)
+#define ICAM_DATA_Data_mask                                                          (0xFFFFFFFF)
+#define ICAM_DATA_Data(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define ICAM_DATA_Data_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define ICAM_DATA_get_Data(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ICAM_COMMAND                                                                 0x18020010
+#define ICAM_COMMAND_reg_addr                                                        "0xB8020010"
+#define ICAM_COMMAND_reg                                                             0xB8020010
+#define set_ICAM_COMMAND_reg(data)   (*((volatile unsigned int*) ICAM_COMMAND_reg)=data)
+#define get_ICAM_COMMAND_reg   (*((volatile unsigned int*) ICAM_COMMAND_reg))
+#define ICAM_COMMAND_inst_adr                                                        "0x0004"
+#define ICAM_COMMAND_inst                                                            0x0004
+#define ICAM_COMMAND_Restart_shift                                                   (31)
+#define ICAM_COMMAND_Restart_mask                                                    (0x80000000)
+#define ICAM_COMMAND_Restart(data)                                                   (0x80000000&((data)<<31))
+#define ICAM_COMMAND_Restart_src(data)                                               ((0x80000000&(data))>>31)
+#define ICAM_COMMAND_get_Restart(data)                                               ((0x80000000&(data))>>31)
+#define ICAM_COMMAND_PID_Index_shift                                                 (8)
+#define ICAM_COMMAND_PID_Index_mask                                                  (0x00003F00)
+#define ICAM_COMMAND_PID_Index(data)                                                 (0x00003F00&((data)<<8))
+#define ICAM_COMMAND_PID_Index_src(data)                                             ((0x00003F00&(data))>>8)
+#define ICAM_COMMAND_get_PID_Index(data)                                             ((0x00003F00&(data))>>8)
+#define ICAM_COMMAND_Algorithm_shift                                                 (5)
+#define ICAM_COMMAND_Algorithm_mask                                                  (0x000000E0)
+#define ICAM_COMMAND_Algorithm(data)                                                 (0x000000E0&((data)<<5))
+#define ICAM_COMMAND_Algorithm_src(data)                                             ((0x000000E0&(data))>>5)
+#define ICAM_COMMAND_get_Algorithm(data)                                             ((0x000000E0&(data))>>5)
+#define ICAM_COMMAND_OpCode_shift                                                    (0)
+#define ICAM_COMMAND_OpCode_mask                                                     (0x00000003)
+#define ICAM_COMMAND_OpCode(data)                                                    (0x00000003&((data)<<0))
+#define ICAM_COMMAND_OpCode_src(data)                                                ((0x00000003&(data))>>0)
+#define ICAM_COMMAND_get_OpCode(data)                                                ((0x00000003&(data))>>0)
+
+
+#define ICAM_VERSION                                                                 0x18020014
+#define ICAM_VERSION_reg_addr                                                        "0xB8020014"
+#define ICAM_VERSION_reg                                                             0xB8020014
+#define set_ICAM_VERSION_reg(data)   (*((volatile unsigned int*) ICAM_VERSION_reg)=data)
+#define get_ICAM_VERSION_reg   (*((volatile unsigned int*) ICAM_VERSION_reg))
+#define ICAM_VERSION_inst_adr                                                        "0x0005"
+#define ICAM_VERSION_inst                                                            0x0005
+#define ICAM_VERSION_Version_shift                                                   (0)
+#define ICAM_VERSION_Version_mask                                                    (0xFFFFFFFF)
+#define ICAM_VERSION_Version(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define ICAM_VERSION_Version_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define ICAM_VERSION_get_Version(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define ICAM_ID_H                                                                    0x18020018
+#define ICAM_ID_H_reg_addr                                                           "0xB8020018"
+#define ICAM_ID_H_reg                                                                0xB8020018
+#define set_ICAM_ID_H_reg(data)   (*((volatile unsigned int*) ICAM_ID_H_reg)=data)
+#define get_ICAM_ID_H_reg   (*((volatile unsigned int*) ICAM_ID_H_reg))
+#define ICAM_ID_H_inst_adr                                                           "0x0006"
+#define ICAM_ID_H_inst                                                               0x0006
+#define ICAM_ID_H_ID_H_shift                                                         (0)
+#define ICAM_ID_H_ID_H_mask                                                          (0xFFFFFFFF)
+#define ICAM_ID_H_ID_H(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define ICAM_ID_H_ID_H_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define ICAM_ID_H_get_ID_H(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ICAM_ID_L                                                                    0x1802001C
+#define ICAM_ID_L_reg_addr                                                           "0xB802001C"
+#define ICAM_ID_L_reg                                                                0xB802001C
+#define set_ICAM_ID_L_reg(data)   (*((volatile unsigned int*) ICAM_ID_L_reg)=data)
+#define get_ICAM_ID_L_reg   (*((volatile unsigned int*) ICAM_ID_L_reg))
+#define ICAM_ID_L_inst_adr                                                           "0x0007"
+#define ICAM_ID_L_inst                                                               0x0007
+#define ICAM_ID_L_ID_L_shift                                                         (0)
+#define ICAM_ID_L_ID_L_mask                                                          (0xFFFFFFFF)
+#define ICAM_ID_L_ID_L(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define ICAM_ID_L_ID_L_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define ICAM_ID_L_get_ID_L(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ICAM_INTERRUPT                                                               0x18020020
+#define ICAM_INTERRUPT_reg_addr                                                      "0xB8020020"
+#define ICAM_INTERRUPT_reg                                                           0xB8020020
+#define set_ICAM_INTERRUPT_reg(data)   (*((volatile unsigned int*) ICAM_INTERRUPT_reg)=data)
+#define get_ICAM_INTERRUPT_reg   (*((volatile unsigned int*) ICAM_INTERRUPT_reg))
+#define ICAM_INTERRUPT_inst_adr                                                      "0x0008"
+#define ICAM_INTERRUPT_inst                                                          0x0008
+#define ICAM_INTERRUPT_Illegal_Transport_Stream_Write_shift                          (7)
+#define ICAM_INTERRUPT_Illegal_Transport_Stream_Write_mask                           (0x00000080)
+#define ICAM_INTERRUPT_Illegal_Transport_Stream_Write(data)                          (0x00000080&((data)<<7))
+#define ICAM_INTERRUPT_Illegal_Transport_Stream_Write_src(data)                      ((0x00000080&(data))>>7)
+#define ICAM_INTERRUPT_get_Illegal_Transport_Stream_Write(data)                      ((0x00000080&(data))>>7)
+#define ICAM_INTERRUPT_Illegal_Transport_Stream_Read_shift                           (6)
+#define ICAM_INTERRUPT_Illegal_Transport_Stream_Read_mask                            (0x00000040)
+#define ICAM_INTERRUPT_Illegal_Transport_Stream_Read(data)                           (0x00000040&((data)<<6))
+#define ICAM_INTERRUPT_Illegal_Transport_Stream_Read_src(data)                       ((0x00000040&(data))>>6)
+#define ICAM_INTERRUPT_get_Illegal_Transport_Stream_Read(data)                       ((0x00000040&(data))>>6)
+#define ICAM_INTERRUPT_Write_On_Busy_shift                                           (5)
+#define ICAM_INTERRUPT_Write_On_Busy_mask                                            (0x00000020)
+#define ICAM_INTERRUPT_Write_On_Busy(data)                                           (0x00000020&((data)<<5))
+#define ICAM_INTERRUPT_Write_On_Busy_src(data)                                       ((0x00000020&(data))>>5)
+#define ICAM_INTERRUPT_get_Write_On_Busy(data)                                       ((0x00000020&(data))>>5)
+#define ICAM_INTERRUPT_Illegal_Sequence_shift                                        (4)
+#define ICAM_INTERRUPT_Illegal_Sequence_mask                                         (0x00000010)
+#define ICAM_INTERRUPT_Illegal_Sequence(data)                                        (0x00000010&((data)<<4))
+#define ICAM_INTERRUPT_Illegal_Sequence_src(data)                                    ((0x00000010&(data))>>4)
+#define ICAM_INTERRUPT_get_Illegal_Sequence(data)                                    ((0x00000010&(data))>>4)
+#define ICAM_INTERRUPT_Illegal_Data_shift                                            (3)
+#define ICAM_INTERRUPT_Illegal_Data_mask                                             (0x00000008)
+#define ICAM_INTERRUPT_Illegal_Data(data)                                            (0x00000008&((data)<<3))
+#define ICAM_INTERRUPT_Illegal_Data_src(data)                                        ((0x00000008&(data))>>3)
+#define ICAM_INTERRUPT_get_Illegal_Data(data)                                        ((0x00000008&(data))>>3)
+#define ICAM_INTERRUPT_Invalid_OTP_shift                                             (2)
+#define ICAM_INTERRUPT_Invalid_OTP_mask                                              (0x00000004)
+#define ICAM_INTERRUPT_Invalid_OTP(data)                                             (0x00000004&((data)<<2))
+#define ICAM_INTERRUPT_Invalid_OTP_src(data)                                         ((0x00000004&(data))>>2)
+#define ICAM_INTERRUPT_get_Invalid_OTP(data)                                         ((0x00000004&(data))>>2)
+#define ICAM_INTERRUPT_Invalid_KTE_shift                                             (1)
+#define ICAM_INTERRUPT_Invalid_KTE_mask                                              (0x00000002)
+#define ICAM_INTERRUPT_Invalid_KTE(data)                                             (0x00000002&((data)<<1))
+#define ICAM_INTERRUPT_Invalid_KTE_src(data)                                         ((0x00000002&(data))>>1)
+#define ICAM_INTERRUPT_get_Invalid_KTE(data)                                         ((0x00000002&(data))>>1)
+#define ICAM_INTERRUPT_UART_shift                                                    (0)
+#define ICAM_INTERRUPT_UART_mask                                                     (0x00000001)
+#define ICAM_INTERRUPT_UART(data)                                                    (0x00000001&((data)<<0))
+#define ICAM_INTERRUPT_UART_src(data)                                                ((0x00000001&(data))>>0)
+#define ICAM_INTERRUPT_get_UART(data)                                                ((0x00000001&(data))>>0)
+
+
+#define ICAM_INTERRUPT_MASK                                                          0x18020024
+#define ICAM_INTERRUPT_MASK_reg_addr                                                 "0xB8020024"
+#define ICAM_INTERRUPT_MASK_reg                                                      0xB8020024
+#define set_ICAM_INTERRUPT_MASK_reg(data)   (*((volatile unsigned int*) ICAM_INTERRUPT_MASK_reg)=data)
+#define get_ICAM_INTERRUPT_MASK_reg   (*((volatile unsigned int*) ICAM_INTERRUPT_MASK_reg))
+#define ICAM_INTERRUPT_MASK_inst_adr                                                 "0x0009"
+#define ICAM_INTERRUPT_MASK_inst                                                     0x0009
+#define ICAM_INTERRUPT_MASK_Illegal_Transport_Stream_Write_Mask_shift                (7)
+#define ICAM_INTERRUPT_MASK_Illegal_Transport_Stream_Write_Mask_mask                 (0x00000080)
+#define ICAM_INTERRUPT_MASK_Illegal_Transport_Stream_Write_Mask(data)                (0x00000080&((data)<<7))
+#define ICAM_INTERRUPT_MASK_Illegal_Transport_Stream_Write_Mask_src(data)            ((0x00000080&(data))>>7)
+#define ICAM_INTERRUPT_MASK_get_Illegal_Transport_Stream_Write_Mask(data)            ((0x00000080&(data))>>7)
+#define ICAM_INTERRUPT_MASK_Illegal_Transport_Stream_Read_Mask_shift                 (6)
+#define ICAM_INTERRUPT_MASK_Illegal_Transport_Stream_Read_Mask_mask                  (0x00000040)
+#define ICAM_INTERRUPT_MASK_Illegal_Transport_Stream_Read_Mask(data)                 (0x00000040&((data)<<6))
+#define ICAM_INTERRUPT_MASK_Illegal_Transport_Stream_Read_Mask_src(data)             ((0x00000040&(data))>>6)
+#define ICAM_INTERRUPT_MASK_get_Illegal_Transport_Stream_Read_Mask(data)             ((0x00000040&(data))>>6)
+#define ICAM_INTERRUPT_MASK_Write_On_Busy_Mask_shift                                 (5)
+#define ICAM_INTERRUPT_MASK_Write_On_Busy_Mask_mask                                  (0x00000020)
+#define ICAM_INTERRUPT_MASK_Write_On_Busy_Mask(data)                                 (0x00000020&((data)<<5))
+#define ICAM_INTERRUPT_MASK_Write_On_Busy_Mask_src(data)                             ((0x00000020&(data))>>5)
+#define ICAM_INTERRUPT_MASK_get_Write_On_Busy_Mask(data)                             ((0x00000020&(data))>>5)
+#define ICAM_INTERRUPT_MASK_Illegal_Sequence_Mask_shift                              (4)
+#define ICAM_INTERRUPT_MASK_Illegal_Sequence_Mask_mask                               (0x00000010)
+#define ICAM_INTERRUPT_MASK_Illegal_Sequence_Mask(data)                              (0x00000010&((data)<<4))
+#define ICAM_INTERRUPT_MASK_Illegal_Sequence_Mask_src(data)                          ((0x00000010&(data))>>4)
+#define ICAM_INTERRUPT_MASK_get_Illegal_Sequence_Mask(data)                          ((0x00000010&(data))>>4)
+#define ICAM_INTERRUPT_MASK_Illegal_Data_Mask_shift                                  (3)
+#define ICAM_INTERRUPT_MASK_Illegal_Data_Mask_mask                                   (0x00000008)
+#define ICAM_INTERRUPT_MASK_Illegal_Data_Mask(data)                                  (0x00000008&((data)<<3))
+#define ICAM_INTERRUPT_MASK_Illegal_Data_Mask_src(data)                              ((0x00000008&(data))>>3)
+#define ICAM_INTERRUPT_MASK_get_Illegal_Data_Mask(data)                              ((0x00000008&(data))>>3)
+#define ICAM_INTERRUPT_MASK_Invalid_OTP_Mask_shift                                   (2)
+#define ICAM_INTERRUPT_MASK_Invalid_OTP_Mask_mask                                    (0x00000004)
+#define ICAM_INTERRUPT_MASK_Invalid_OTP_Mask(data)                                   (0x00000004&((data)<<2))
+#define ICAM_INTERRUPT_MASK_Invalid_OTP_Mask_src(data)                               ((0x00000004&(data))>>2)
+#define ICAM_INTERRUPT_MASK_get_Invalid_OTP_Mask(data)                               ((0x00000004&(data))>>2)
+#define ICAM_INTERRUPT_MASK_Invalid_KTE_Mask_shift                                   (1)
+#define ICAM_INTERRUPT_MASK_Invalid_KTE_Mask_mask                                    (0x00000002)
+#define ICAM_INTERRUPT_MASK_Invalid_KTE_Mask(data)                                   (0x00000002&((data)<<1))
+#define ICAM_INTERRUPT_MASK_Invalid_KTE_Mask_src(data)                               ((0x00000002&(data))>>1)
+#define ICAM_INTERRUPT_MASK_get_Invalid_KTE_Mask(data)                               ((0x00000002&(data))>>1)
+
+
+#define ICAM_STATUS                                                                  0x18020028
+#define ICAM_STATUS_reg_addr                                                         "0xB8020028"
+#define ICAM_STATUS_reg                                                              0xB8020028
+#define set_ICAM_STATUS_reg(data)   (*((volatile unsigned int*) ICAM_STATUS_reg)=data)
+#define get_ICAM_STATUS_reg   (*((volatile unsigned int*) ICAM_STATUS_reg))
+#define ICAM_STATUS_inst_adr                                                         "0x000A"
+#define ICAM_STATUS_inst                                                             0x000A
+#define ICAM_STATUS_OTP_NDS_Mode_shift                                               (3)
+#define ICAM_STATUS_OTP_NDS_Mode_mask                                                (0x00000008)
+#define ICAM_STATUS_OTP_NDS_Mode(data)                                               (0x00000008&((data)<<3))
+#define ICAM_STATUS_OTP_NDS_Mode_src(data)                                           ((0x00000008&(data))>>3)
+#define ICAM_STATUS_get_OTP_NDS_Mode(data)                                           ((0x00000008&(data))>>3)
+#define ICAM_STATUS_Serialization_Fail_shift                                         (2)
+#define ICAM_STATUS_Serialization_Fail_mask                                          (0x00000004)
+#define ICAM_STATUS_Serialization_Fail(data)                                         (0x00000004&((data)<<2))
+#define ICAM_STATUS_Serialization_Fail_src(data)                                     ((0x00000004&(data))>>2)
+#define ICAM_STATUS_get_Serialization_Fail(data)                                     ((0x00000004&(data))>>2)
+#define ICAM_STATUS_Invalid_OTP_shift                                                (1)
+#define ICAM_STATUS_Invalid_OTP_mask                                                 (0x00000002)
+#define ICAM_STATUS_Invalid_OTP(data)                                                (0x00000002&((data)<<1))
+#define ICAM_STATUS_Invalid_OTP_src(data)                                            ((0x00000002&(data))>>1)
+#define ICAM_STATUS_get_Invalid_OTP(data)                                            ((0x00000002&(data))>>1)
+#define ICAM_STATUS_Busy_shift                                                       (0)
+#define ICAM_STATUS_Busy_mask                                                        (0x00000001)
+#define ICAM_STATUS_Busy(data)                                                       (0x00000001&((data)<<0))
+#define ICAM_STATUS_Busy_src(data)                                                   ((0x00000001&(data))>>0)
+#define ICAM_STATUS_get_Busy(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define ICAM_KT_STATUS_H                                                             0x1802002C
+#define ICAM_KT_STATUS_H_reg_addr                                                    "0xB802002C"
+#define ICAM_KT_STATUS_H_reg                                                         0xB802002C
+#define set_ICAM_KT_STATUS_H_reg(data)   (*((volatile unsigned int*) ICAM_KT_STATUS_H_reg)=data)
+#define get_ICAM_KT_STATUS_H_reg   (*((volatile unsigned int*) ICAM_KT_STATUS_H_reg))
+#define ICAM_KT_STATUS_H_inst_adr                                                    "0x000B"
+#define ICAM_KT_STATUS_H_inst                                                        0x000B
+#define ICAM_KT_STATUS_H_KT_Status_shift                                             (0)
+#define ICAM_KT_STATUS_H_KT_Status_mask                                              (0x000FFFFF)
+#define ICAM_KT_STATUS_H_KT_Status(data)                                             (0x000FFFFF&((data)<<0))
+#define ICAM_KT_STATUS_H_KT_Status_src(data)                                         ((0x000FFFFF&(data))>>0)
+#define ICAM_KT_STATUS_H_get_KT_Status(data)                                         ((0x000FFFFF&(data))>>0)
+
+
+#define ICAM_KT_STATUS_L                                                             0x18020030
+#define ICAM_KT_STATUS_L_reg_addr                                                    "0xB8020030"
+#define ICAM_KT_STATUS_L_reg                                                         0xB8020030
+#define set_ICAM_KT_STATUS_L_reg(data)   (*((volatile unsigned int*) ICAM_KT_STATUS_L_reg)=data)
+#define get_ICAM_KT_STATUS_L_reg   (*((volatile unsigned int*) ICAM_KT_STATUS_L_reg))
+#define ICAM_KT_STATUS_L_inst_adr                                                    "0x000C"
+#define ICAM_KT_STATUS_L_inst                                                        0x000C
+#define ICAM_KT_STATUS_L_KT_Status_shift                                             (0)
+#define ICAM_KT_STATUS_L_KT_Status_mask                                              (0xFFFFFFFF)
+#define ICAM_KT_STATUS_L_KT_Status(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ICAM_KT_STATUS_L_KT_Status_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ICAM_KT_STATUS_L_get_KT_Status(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define ICAM_AES_CBC_IV_0                                                            0x18020040
+#define ICAM_AES_CBC_IV_1                                                            0x18020044
+#define ICAM_AES_CBC_IV_2                                                            0x18020048
+#define ICAM_AES_CBC_IV_3                                                            0x1802004C
+#define ICAM_AES_CBC_IV_0_reg_addr                                                   "0xB8020040"
+#define ICAM_AES_CBC_IV_1_reg_addr                                                   "0xB8020044"
+#define ICAM_AES_CBC_IV_2_reg_addr                                                   "0xB8020048"
+#define ICAM_AES_CBC_IV_3_reg_addr                                                   "0xB802004C"
+#define ICAM_AES_CBC_IV_0_reg                                                        0xB8020040
+#define ICAM_AES_CBC_IV_1_reg                                                        0xB8020044
+#define ICAM_AES_CBC_IV_2_reg                                                        0xB8020048
+#define ICAM_AES_CBC_IV_3_reg                                                        0xB802004C
+#define set_ICAM_AES_CBC_IV_0_reg(data)   (*((volatile unsigned int*) ICAM_AES_CBC_IV_0_reg)=data)
+#define set_ICAM_AES_CBC_IV_1_reg(data)   (*((volatile unsigned int*) ICAM_AES_CBC_IV_1_reg)=data)
+#define set_ICAM_AES_CBC_IV_2_reg(data)   (*((volatile unsigned int*) ICAM_AES_CBC_IV_2_reg)=data)
+#define set_ICAM_AES_CBC_IV_3_reg(data)   (*((volatile unsigned int*) ICAM_AES_CBC_IV_3_reg)=data)
+#define get_ICAM_AES_CBC_IV_0_reg   (*((volatile unsigned int*) ICAM_AES_CBC_IV_0_reg))
+#define get_ICAM_AES_CBC_IV_1_reg   (*((volatile unsigned int*) ICAM_AES_CBC_IV_1_reg))
+#define get_ICAM_AES_CBC_IV_2_reg   (*((volatile unsigned int*) ICAM_AES_CBC_IV_2_reg))
+#define get_ICAM_AES_CBC_IV_3_reg   (*((volatile unsigned int*) ICAM_AES_CBC_IV_3_reg))
+#define ICAM_AES_CBC_IV_0_inst_adr                                                   "0x0010"
+#define ICAM_AES_CBC_IV_1_inst_adr                                                   "0x0011"
+#define ICAM_AES_CBC_IV_2_inst_adr                                                   "0x0012"
+#define ICAM_AES_CBC_IV_3_inst_adr                                                   "0x0013"
+#define ICAM_AES_CBC_IV_0_inst                                                       0x0010
+#define ICAM_AES_CBC_IV_1_inst                                                       0x0011
+#define ICAM_AES_CBC_IV_2_inst                                                       0x0012
+#define ICAM_AES_CBC_IV_3_inst                                                       0x0013
+#define ICAM_AES_CBC_IV_iv_shift                                                     (0)
+#define ICAM_AES_CBC_IV_iv_mask                                                      (0xFFFFFFFF)
+#define ICAM_AES_CBC_IV_iv(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define ICAM_AES_CBC_IV_iv_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define ICAM_AES_CBC_IV_get_iv(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ICAM_UART_DATA                                                               0x18020100
+#define ICAM_UART_DATA_reg_addr                                                      "0xB8020100"
+#define ICAM_UART_DATA_reg                                                           0xB8020100
+#define set_ICAM_UART_DATA_reg(data)   (*((volatile unsigned int*) ICAM_UART_DATA_reg)=data)
+#define get_ICAM_UART_DATA_reg   (*((volatile unsigned int*) ICAM_UART_DATA_reg))
+#define ICAM_UART_DATA_inst_adr                                                      "0x0040"
+#define ICAM_UART_DATA_inst                                                          0x0040
+#define ICAM_UART_DATA_Data_shift                                                    (0)
+#define ICAM_UART_DATA_Data_mask                                                     (0x000000FF)
+#define ICAM_UART_DATA_Data(data)                                                    (0x000000FF&((data)<<0))
+#define ICAM_UART_DATA_Data_src(data)                                                ((0x000000FF&(data))>>0)
+#define ICAM_UART_DATA_get_Data(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ICAM_UART_CTRL_STAT                                                          0x18020104
+#define ICAM_UART_CTRL_STAT_reg_addr                                                 "0xB8020104"
+#define ICAM_UART_CTRL_STAT_reg                                                      0xB8020104
+#define set_ICAM_UART_CTRL_STAT_reg(data)   (*((volatile unsigned int*) ICAM_UART_CTRL_STAT_reg)=data)
+#define get_ICAM_UART_CTRL_STAT_reg   (*((volatile unsigned int*) ICAM_UART_CTRL_STAT_reg))
+#define ICAM_UART_CTRL_STAT_inst_adr                                                 "0x0041"
+#define ICAM_UART_CTRL_STAT_inst                                                     0x0041
+#define ICAM_UART_CTRL_STAT_Control_Status_shift                                     (0)
+#define ICAM_UART_CTRL_STAT_Control_Status_mask                                      (0x000000FF)
+#define ICAM_UART_CTRL_STAT_Control_Status(data)                                     (0x000000FF&((data)<<0))
+#define ICAM_UART_CTRL_STAT_Control_Status_src(data)                                 ((0x000000FF&(data))>>0)
+#define ICAM_UART_CTRL_STAT_get_Control_Status(data)                                 ((0x000000FF&(data))>>0)
+
+
+#define ICAM_UART_BAUD_RATE_L                                                        0x18020108
+#define ICAM_UART_BAUD_RATE_L_reg_addr                                               "0xB8020108"
+#define ICAM_UART_BAUD_RATE_L_reg                                                    0xB8020108
+#define set_ICAM_UART_BAUD_RATE_L_reg(data)   (*((volatile unsigned int*) ICAM_UART_BAUD_RATE_L_reg)=data)
+#define get_ICAM_UART_BAUD_RATE_L_reg   (*((volatile unsigned int*) ICAM_UART_BAUD_RATE_L_reg))
+#define ICAM_UART_BAUD_RATE_L_inst_adr                                               "0x0042"
+#define ICAM_UART_BAUD_RATE_L_inst                                                   0x0042
+#define ICAM_UART_BAUD_RATE_L_Baud_Rate_shift                                        (0)
+#define ICAM_UART_BAUD_RATE_L_Baud_Rate_mask                                         (0x000000FF)
+#define ICAM_UART_BAUD_RATE_L_Baud_Rate(data)                                        (0x000000FF&((data)<<0))
+#define ICAM_UART_BAUD_RATE_L_Baud_Rate_src(data)                                    ((0x000000FF&(data))>>0)
+#define ICAM_UART_BAUD_RATE_L_get_Baud_Rate(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define ICAM_UART_BAUD_RATE_H                                                        0x1802010C
+#define ICAM_UART_BAUD_RATE_H_reg_addr                                               "0xB802010C"
+#define ICAM_UART_BAUD_RATE_H_reg                                                    0xB802010C
+#define set_ICAM_UART_BAUD_RATE_H_reg(data)   (*((volatile unsigned int*) ICAM_UART_BAUD_RATE_H_reg)=data)
+#define get_ICAM_UART_BAUD_RATE_H_reg   (*((volatile unsigned int*) ICAM_UART_BAUD_RATE_H_reg))
+#define ICAM_UART_BAUD_RATE_H_inst_adr                                               "0x0043"
+#define ICAM_UART_BAUD_RATE_H_inst                                                   0x0043
+#define ICAM_UART_BAUD_RATE_H_Baud_Rate_shift                                        (0)
+#define ICAM_UART_BAUD_RATE_H_Baud_Rate_mask                                         (0x000000FF)
+#define ICAM_UART_BAUD_RATE_H_Baud_Rate(data)                                        (0x000000FF&((data)<<0))
+#define ICAM_UART_BAUD_RATE_H_Baud_Rate_src(data)                                    ((0x000000FF&(data))>>0)
+#define ICAM_UART_BAUD_RATE_H_get_Baud_Rate(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define ICAM_UART_COM                                                                0x18020110
+#define ICAM_UART_COM_reg_addr                                                       "0xB8020110"
+#define ICAM_UART_COM_reg                                                            0xB8020110
+#define set_ICAM_UART_COM_reg(data)   (*((volatile unsigned int*) ICAM_UART_COM_reg)=data)
+#define get_ICAM_UART_COM_reg   (*((volatile unsigned int*) ICAM_UART_COM_reg))
+#define ICAM_UART_COM_inst_adr                                                       "0x0044"
+#define ICAM_UART_COM_inst                                                           0x0044
+#define ICAM_UART_COM_Communication_shift                                            (0)
+#define ICAM_UART_COM_Communication_mask                                             (0x000000FF)
+#define ICAM_UART_COM_Communication(data)                                            (0x000000FF&((data)<<0))
+#define ICAM_UART_COM_Communication_src(data)                                        ((0x000000FF&(data))>>0)
+#define ICAM_UART_COM_get_Communication(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define ICAM_UART_INT                                                                0x18020114
+#define ICAM_UART_INT_reg_addr                                                       "0xB8020114"
+#define ICAM_UART_INT_reg                                                            0xB8020114
+#define set_ICAM_UART_INT_reg(data)   (*((volatile unsigned int*) ICAM_UART_INT_reg)=data)
+#define get_ICAM_UART_INT_reg   (*((volatile unsigned int*) ICAM_UART_INT_reg))
+#define ICAM_UART_INT_inst_adr                                                       "0x0045"
+#define ICAM_UART_INT_inst                                                           0x0045
+#define ICAM_UART_INT_Interrupt_Mask_shift                                           (0)
+#define ICAM_UART_INT_Interrupt_Mask_mask                                            (0x000000FF)
+#define ICAM_UART_INT_Interrupt_Mask(data)                                           (0x000000FF&((data)<<0))
+#define ICAM_UART_INT_Interrupt_Mask_src(data)                                       ((0x000000FF&(data))>>0)
+#define ICAM_UART_INT_get_Interrupt_Mask(data)                                       ((0x000000FF&(data))>>0)
+
+
+#define ICAM_UART_GUARD_TIME                                                         0x18020118
+#define ICAM_UART_GUARD_TIME_reg_addr                                                "0xB8020118"
+#define ICAM_UART_GUARD_TIME_reg                                                     0xB8020118
+#define set_ICAM_UART_GUARD_TIME_reg(data)   (*((volatile unsigned int*) ICAM_UART_GUARD_TIME_reg)=data)
+#define get_ICAM_UART_GUARD_TIME_reg   (*((volatile unsigned int*) ICAM_UART_GUARD_TIME_reg))
+#define ICAM_UART_GUARD_TIME_inst_adr                                                "0x0046"
+#define ICAM_UART_GUARD_TIME_inst                                                    0x0046
+#define ICAM_UART_GUARD_TIME_Guard_Time_shift                                        (0)
+#define ICAM_UART_GUARD_TIME_Guard_Time_mask                                         (0x000000FF)
+#define ICAM_UART_GUARD_TIME_Guard_Time(data)                                        (0x000000FF&((data)<<0))
+#define ICAM_UART_GUARD_TIME_Guard_Time_src(data)                                    ((0x000000FF&(data))>>0)
+#define ICAM_UART_GUARD_TIME_get_Guard_Time(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define ICAM_SER_ID_H                                                                0x18021100
+#define ICAM_SER_ID_H_reg_addr                                                       "0xB8021100"
+#define ICAM_SER_ID_H_reg                                                            0xB8021100
+#define set_ICAM_SER_ID_H_reg(data)   (*((volatile unsigned int*) ICAM_SER_ID_H_reg)=data)
+#define get_ICAM_SER_ID_H_reg   (*((volatile unsigned int*) ICAM_SER_ID_H_reg))
+#define ICAM_SER_ID_H_inst_adr                                                       "0x0440"
+#define ICAM_SER_ID_H_inst                                                           0x0440
+#define ICAM_SER_ID_H_SER_ID_H_shift                                                 (0)
+#define ICAM_SER_ID_H_SER_ID_H_mask                                                  (0xFFFFFFFF)
+#define ICAM_SER_ID_H_SER_ID_H(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ICAM_SER_ID_H_SER_ID_H_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ICAM_SER_ID_H_get_SER_ID_H(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ICAM_SER_ID_L                                                                0x18021104
+#define ICAM_SER_ID_L_reg_addr                                                       "0xB8021104"
+#define ICAM_SER_ID_L_reg                                                            0xB8021104
+#define set_ICAM_SER_ID_L_reg(data)   (*((volatile unsigned int*) ICAM_SER_ID_L_reg)=data)
+#define get_ICAM_SER_ID_L_reg   (*((volatile unsigned int*) ICAM_SER_ID_L_reg))
+#define ICAM_SER_ID_L_inst_adr                                                       "0x0441"
+#define ICAM_SER_ID_L_inst                                                           0x0441
+#define ICAM_SER_ID_L_SER_ID_L_shift                                                 (0)
+#define ICAM_SER_ID_L_SER_ID_L_mask                                                  (0xFFFFFFFF)
+#define ICAM_SER_ID_L_SER_ID_L(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ICAM_SER_ID_L_SER_ID_L_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ICAM_SER_ID_L_get_SER_ID_L(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ICAM_SER_FLAG                                                                0x18021108
+#define ICAM_SER_FLAG_reg_addr                                                       "0xB8021108"
+#define ICAM_SER_FLAG_reg                                                            0xB8021108
+#define set_ICAM_SER_FLAG_reg(data)   (*((volatile unsigned int*) ICAM_SER_FLAG_reg)=data)
+#define get_ICAM_SER_FLAG_reg   (*((volatile unsigned int*) ICAM_SER_FLAG_reg))
+#define ICAM_SER_FLAG_inst_adr                                                       "0x0442"
+#define ICAM_SER_FLAG_inst                                                           0x0442
+#define ICAM_SER_FLAG_OTP_NDS_Mode_shift                                             (3)
+#define ICAM_SER_FLAG_OTP_NDS_Mode_mask                                              (0x00000008)
+#define ICAM_SER_FLAG_OTP_NDS_Mode(data)                                             (0x00000008&((data)<<3))
+#define ICAM_SER_FLAG_OTP_NDS_Mode_src(data)                                         ((0x00000008&(data))>>3)
+#define ICAM_SER_FLAG_get_OTP_NDS_Mode(data)                                         ((0x00000008&(data))>>3)
+#define ICAM_SER_FLAG_Serialization_Fail_shift                                       (2)
+#define ICAM_SER_FLAG_Serialization_Fail_mask                                        (0x00000004)
+#define ICAM_SER_FLAG_Serialization_Fail(data)                                       (0x00000004&((data)<<2))
+#define ICAM_SER_FLAG_Serialization_Fail_src(data)                                   ((0x00000004&(data))>>2)
+#define ICAM_SER_FLAG_get_Serialization_Fail(data)                                   ((0x00000004&(data))>>2)
+#define ICAM_SER_FLAG_Invalid_OTP_shift                                              (1)
+#define ICAM_SER_FLAG_Invalid_OTP_mask                                               (0x00000002)
+#define ICAM_SER_FLAG_Invalid_OTP(data)                                              (0x00000002&((data)<<1))
+#define ICAM_SER_FLAG_Invalid_OTP_src(data)                                          ((0x00000002&(data))>>1)
+#define ICAM_SER_FLAG_get_Invalid_OTP(data)                                          ((0x00000002&(data))>>1)
+#define ICAM_SER_FLAG_Busy_shift                                                     (0)
+#define ICAM_SER_FLAG_Busy_mask                                                      (0x00000001)
+#define ICAM_SER_FLAG_Busy(data)                                                     (0x00000001&((data)<<0))
+#define ICAM_SER_FLAG_Busy_src(data)                                                 ((0x00000001&(data))>>0)
+#define ICAM_SER_FLAG_get_Busy(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define ICAM_SER_BASE_0                                                              0x18021280
+#define ICAM_SER_BASE_1                                                              0x18021284
+#define ICAM_SER_BASE_2                                                              0x18021288
+#define ICAM_SER_BASE_3                                                              0x1802128C
+#define ICAM_SER_BASE_4                                                              0x18021290
+#define ICAM_SER_BASE_5                                                              0x18021294
+#define ICAM_SER_BASE_6                                                              0x18021298
+#define ICAM_SER_BASE_7                                                              0x1802129C
+#define ICAM_SER_BASE_8                                                              0x180212A0
+#define ICAM_SER_BASE_9                                                              0x180212A4
+#define ICAM_SER_BASE_10                                                              0x180212A8
+#define ICAM_SER_BASE_11                                                              0x180212AC
+#define ICAM_SER_BASE_12                                                              0x180212B0
+#define ICAM_SER_BASE_13                                                              0x180212B4
+#define ICAM_SER_BASE_14                                                              0x180212B8
+#define ICAM_SER_BASE_15                                                              0x180212BC
+#define ICAM_SER_BASE_16                                                              0x180212C0
+#define ICAM_SER_BASE_17                                                              0x180212C4
+#define ICAM_SER_BASE_18                                                              0x180212C8
+#define ICAM_SER_BASE_19                                                              0x180212CC
+#define ICAM_SER_BASE_20                                                              0x180212D0
+#define ICAM_SER_BASE_21                                                              0x180212D4
+#define ICAM_SER_BASE_22                                                              0x180212D8
+#define ICAM_SER_BASE_23                                                              0x180212DC
+#define ICAM_SER_BASE_24                                                              0x180212E0
+#define ICAM_SER_BASE_25                                                              0x180212E4
+#define ICAM_SER_BASE_26                                                              0x180212E8
+#define ICAM_SER_BASE_27                                                              0x180212EC
+#define ICAM_SER_BASE_28                                                              0x180212F0
+#define ICAM_SER_BASE_29                                                              0x180212F4
+#define ICAM_SER_BASE_30                                                              0x180212F8
+#define ICAM_SER_BASE_31                                                              0x180212FC
+#define ICAM_SER_BASE_32                                                              0x18021300
+#define ICAM_SER_BASE_33                                                              0x18021304
+#define ICAM_SER_BASE_34                                                              0x18021308
+#define ICAM_SER_BASE_35                                                              0x1802130C
+#define ICAM_SER_BASE_36                                                              0x18021310
+#define ICAM_SER_BASE_37                                                              0x18021314
+#define ICAM_SER_BASE_38                                                              0x18021318
+#define ICAM_SER_BASE_39                                                              0x1802131C
+#define ICAM_SER_BASE_40                                                              0x18021320
+#define ICAM_SER_BASE_41                                                              0x18021324
+#define ICAM_SER_BASE_42                                                              0x18021328
+#define ICAM_SER_BASE_43                                                              0x1802132C
+#define ICAM_SER_BASE_44                                                              0x18021330
+#define ICAM_SER_BASE_45                                                              0x18021334
+#define ICAM_SER_BASE_46                                                              0x18021338
+#define ICAM_SER_BASE_47                                                              0x1802133C
+#define ICAM_SER_BASE_0_reg_addr                                                     "0xB8021280"
+#define ICAM_SER_BASE_1_reg_addr                                                     "0xB8021284"
+#define ICAM_SER_BASE_2_reg_addr                                                     "0xB8021288"
+#define ICAM_SER_BASE_3_reg_addr                                                     "0xB802128C"
+#define ICAM_SER_BASE_4_reg_addr                                                     "0xB8021290"
+#define ICAM_SER_BASE_5_reg_addr                                                     "0xB8021294"
+#define ICAM_SER_BASE_6_reg_addr                                                     "0xB8021298"
+#define ICAM_SER_BASE_7_reg_addr                                                     "0xB802129C"
+#define ICAM_SER_BASE_8_reg_addr                                                     "0xB80212A0"
+#define ICAM_SER_BASE_9_reg_addr                                                     "0xB80212A4"
+#define ICAM_SER_BASE_10_reg_addr                                                     "0xB80212A8"
+#define ICAM_SER_BASE_11_reg_addr                                                     "0xB80212AC"
+#define ICAM_SER_BASE_12_reg_addr                                                     "0xB80212B0"
+#define ICAM_SER_BASE_13_reg_addr                                                     "0xB80212B4"
+#define ICAM_SER_BASE_14_reg_addr                                                     "0xB80212B8"
+#define ICAM_SER_BASE_15_reg_addr                                                     "0xB80212BC"
+#define ICAM_SER_BASE_16_reg_addr                                                     "0xB80212C0"
+#define ICAM_SER_BASE_17_reg_addr                                                     "0xB80212C4"
+#define ICAM_SER_BASE_18_reg_addr                                                     "0xB80212C8"
+#define ICAM_SER_BASE_19_reg_addr                                                     "0xB80212CC"
+#define ICAM_SER_BASE_20_reg_addr                                                     "0xB80212D0"
+#define ICAM_SER_BASE_21_reg_addr                                                     "0xB80212D4"
+#define ICAM_SER_BASE_22_reg_addr                                                     "0xB80212D8"
+#define ICAM_SER_BASE_23_reg_addr                                                     "0xB80212DC"
+#define ICAM_SER_BASE_24_reg_addr                                                     "0xB80212E0"
+#define ICAM_SER_BASE_25_reg_addr                                                     "0xB80212E4"
+#define ICAM_SER_BASE_26_reg_addr                                                     "0xB80212E8"
+#define ICAM_SER_BASE_27_reg_addr                                                     "0xB80212EC"
+#define ICAM_SER_BASE_28_reg_addr                                                     "0xB80212F0"
+#define ICAM_SER_BASE_29_reg_addr                                                     "0xB80212F4"
+#define ICAM_SER_BASE_30_reg_addr                                                     "0xB80212F8"
+#define ICAM_SER_BASE_31_reg_addr                                                     "0xB80212FC"
+#define ICAM_SER_BASE_32_reg_addr                                                     "0xB8021300"
+#define ICAM_SER_BASE_33_reg_addr                                                     "0xB8021304"
+#define ICAM_SER_BASE_34_reg_addr                                                     "0xB8021308"
+#define ICAM_SER_BASE_35_reg_addr                                                     "0xB802130C"
+#define ICAM_SER_BASE_36_reg_addr                                                     "0xB8021310"
+#define ICAM_SER_BASE_37_reg_addr                                                     "0xB8021314"
+#define ICAM_SER_BASE_38_reg_addr                                                     "0xB8021318"
+#define ICAM_SER_BASE_39_reg_addr                                                     "0xB802131C"
+#define ICAM_SER_BASE_40_reg_addr                                                     "0xB8021320"
+#define ICAM_SER_BASE_41_reg_addr                                                     "0xB8021324"
+#define ICAM_SER_BASE_42_reg_addr                                                     "0xB8021328"
+#define ICAM_SER_BASE_43_reg_addr                                                     "0xB802132C"
+#define ICAM_SER_BASE_44_reg_addr                                                     "0xB8021330"
+#define ICAM_SER_BASE_45_reg_addr                                                     "0xB8021334"
+#define ICAM_SER_BASE_46_reg_addr                                                     "0xB8021338"
+#define ICAM_SER_BASE_47_reg_addr                                                     "0xB802133C"
+#define ICAM_SER_BASE_0_reg                                                          0xB8021280
+#define ICAM_SER_BASE_1_reg                                                          0xB8021284
+#define ICAM_SER_BASE_2_reg                                                          0xB8021288
+#define ICAM_SER_BASE_3_reg                                                          0xB802128C
+#define ICAM_SER_BASE_4_reg                                                          0xB8021290
+#define ICAM_SER_BASE_5_reg                                                          0xB8021294
+#define ICAM_SER_BASE_6_reg                                                          0xB8021298
+#define ICAM_SER_BASE_7_reg                                                          0xB802129C
+#define ICAM_SER_BASE_8_reg                                                          0xB80212A0
+#define ICAM_SER_BASE_9_reg                                                          0xB80212A4
+#define ICAM_SER_BASE_10_reg                                                          0xB80212A8
+#define ICAM_SER_BASE_11_reg                                                          0xB80212AC
+#define ICAM_SER_BASE_12_reg                                                          0xB80212B0
+#define ICAM_SER_BASE_13_reg                                                          0xB80212B4
+#define ICAM_SER_BASE_14_reg                                                          0xB80212B8
+#define ICAM_SER_BASE_15_reg                                                          0xB80212BC
+#define ICAM_SER_BASE_16_reg                                                          0xB80212C0
+#define ICAM_SER_BASE_17_reg                                                          0xB80212C4
+#define ICAM_SER_BASE_18_reg                                                          0xB80212C8
+#define ICAM_SER_BASE_19_reg                                                          0xB80212CC
+#define ICAM_SER_BASE_20_reg                                                          0xB80212D0
+#define ICAM_SER_BASE_21_reg                                                          0xB80212D4
+#define ICAM_SER_BASE_22_reg                                                          0xB80212D8
+#define ICAM_SER_BASE_23_reg                                                          0xB80212DC
+#define ICAM_SER_BASE_24_reg                                                          0xB80212E0
+#define ICAM_SER_BASE_25_reg                                                          0xB80212E4
+#define ICAM_SER_BASE_26_reg                                                          0xB80212E8
+#define ICAM_SER_BASE_27_reg                                                          0xB80212EC
+#define ICAM_SER_BASE_28_reg                                                          0xB80212F0
+#define ICAM_SER_BASE_29_reg                                                          0xB80212F4
+#define ICAM_SER_BASE_30_reg                                                          0xB80212F8
+#define ICAM_SER_BASE_31_reg                                                          0xB80212FC
+#define ICAM_SER_BASE_32_reg                                                          0xB8021300
+#define ICAM_SER_BASE_33_reg                                                          0xB8021304
+#define ICAM_SER_BASE_34_reg                                                          0xB8021308
+#define ICAM_SER_BASE_35_reg                                                          0xB802130C
+#define ICAM_SER_BASE_36_reg                                                          0xB8021310
+#define ICAM_SER_BASE_37_reg                                                          0xB8021314
+#define ICAM_SER_BASE_38_reg                                                          0xB8021318
+#define ICAM_SER_BASE_39_reg                                                          0xB802131C
+#define ICAM_SER_BASE_40_reg                                                          0xB8021320
+#define ICAM_SER_BASE_41_reg                                                          0xB8021324
+#define ICAM_SER_BASE_42_reg                                                          0xB8021328
+#define ICAM_SER_BASE_43_reg                                                          0xB802132C
+#define ICAM_SER_BASE_44_reg                                                          0xB8021330
+#define ICAM_SER_BASE_45_reg                                                          0xB8021334
+#define ICAM_SER_BASE_46_reg                                                          0xB8021338
+#define ICAM_SER_BASE_47_reg                                                          0xB802133C
+#define set_ICAM_SER_BASE_0_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_0_reg)=data)
+#define set_ICAM_SER_BASE_1_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_1_reg)=data)
+#define set_ICAM_SER_BASE_2_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_2_reg)=data)
+#define set_ICAM_SER_BASE_3_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_3_reg)=data)
+#define set_ICAM_SER_BASE_4_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_4_reg)=data)
+#define set_ICAM_SER_BASE_5_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_5_reg)=data)
+#define set_ICAM_SER_BASE_6_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_6_reg)=data)
+#define set_ICAM_SER_BASE_7_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_7_reg)=data)
+#define set_ICAM_SER_BASE_8_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_8_reg)=data)
+#define set_ICAM_SER_BASE_9_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_9_reg)=data)
+#define set_ICAM_SER_BASE_10_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_10_reg)=data)
+#define set_ICAM_SER_BASE_11_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_11_reg)=data)
+#define set_ICAM_SER_BASE_12_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_12_reg)=data)
+#define set_ICAM_SER_BASE_13_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_13_reg)=data)
+#define set_ICAM_SER_BASE_14_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_14_reg)=data)
+#define set_ICAM_SER_BASE_15_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_15_reg)=data)
+#define set_ICAM_SER_BASE_16_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_16_reg)=data)
+#define set_ICAM_SER_BASE_17_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_17_reg)=data)
+#define set_ICAM_SER_BASE_18_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_18_reg)=data)
+#define set_ICAM_SER_BASE_19_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_19_reg)=data)
+#define set_ICAM_SER_BASE_20_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_20_reg)=data)
+#define set_ICAM_SER_BASE_21_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_21_reg)=data)
+#define set_ICAM_SER_BASE_22_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_22_reg)=data)
+#define set_ICAM_SER_BASE_23_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_23_reg)=data)
+#define set_ICAM_SER_BASE_24_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_24_reg)=data)
+#define set_ICAM_SER_BASE_25_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_25_reg)=data)
+#define set_ICAM_SER_BASE_26_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_26_reg)=data)
+#define set_ICAM_SER_BASE_27_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_27_reg)=data)
+#define set_ICAM_SER_BASE_28_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_28_reg)=data)
+#define set_ICAM_SER_BASE_29_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_29_reg)=data)
+#define set_ICAM_SER_BASE_30_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_30_reg)=data)
+#define set_ICAM_SER_BASE_31_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_31_reg)=data)
+#define set_ICAM_SER_BASE_32_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_32_reg)=data)
+#define set_ICAM_SER_BASE_33_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_33_reg)=data)
+#define set_ICAM_SER_BASE_34_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_34_reg)=data)
+#define set_ICAM_SER_BASE_35_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_35_reg)=data)
+#define set_ICAM_SER_BASE_36_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_36_reg)=data)
+#define set_ICAM_SER_BASE_37_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_37_reg)=data)
+#define set_ICAM_SER_BASE_38_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_38_reg)=data)
+#define set_ICAM_SER_BASE_39_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_39_reg)=data)
+#define set_ICAM_SER_BASE_40_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_40_reg)=data)
+#define set_ICAM_SER_BASE_41_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_41_reg)=data)
+#define set_ICAM_SER_BASE_42_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_42_reg)=data)
+#define set_ICAM_SER_BASE_43_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_43_reg)=data)
+#define set_ICAM_SER_BASE_44_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_44_reg)=data)
+#define set_ICAM_SER_BASE_45_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_45_reg)=data)
+#define set_ICAM_SER_BASE_46_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_46_reg)=data)
+#define set_ICAM_SER_BASE_47_reg(data)   (*((volatile unsigned int*) ICAM_SER_BASE_47_reg)=data)
+#define get_ICAM_SER_BASE_0_reg   (*((volatile unsigned int*) ICAM_SER_BASE_0_reg))
+#define get_ICAM_SER_BASE_1_reg   (*((volatile unsigned int*) ICAM_SER_BASE_1_reg))
+#define get_ICAM_SER_BASE_2_reg   (*((volatile unsigned int*) ICAM_SER_BASE_2_reg))
+#define get_ICAM_SER_BASE_3_reg   (*((volatile unsigned int*) ICAM_SER_BASE_3_reg))
+#define get_ICAM_SER_BASE_4_reg   (*((volatile unsigned int*) ICAM_SER_BASE_4_reg))
+#define get_ICAM_SER_BASE_5_reg   (*((volatile unsigned int*) ICAM_SER_BASE_5_reg))
+#define get_ICAM_SER_BASE_6_reg   (*((volatile unsigned int*) ICAM_SER_BASE_6_reg))
+#define get_ICAM_SER_BASE_7_reg   (*((volatile unsigned int*) ICAM_SER_BASE_7_reg))
+#define get_ICAM_SER_BASE_8_reg   (*((volatile unsigned int*) ICAM_SER_BASE_8_reg))
+#define get_ICAM_SER_BASE_9_reg   (*((volatile unsigned int*) ICAM_SER_BASE_9_reg))
+#define get_ICAM_SER_BASE_10_reg   (*((volatile unsigned int*) ICAM_SER_BASE_10_reg))
+#define get_ICAM_SER_BASE_11_reg   (*((volatile unsigned int*) ICAM_SER_BASE_11_reg))
+#define get_ICAM_SER_BASE_12_reg   (*((volatile unsigned int*) ICAM_SER_BASE_12_reg))
+#define get_ICAM_SER_BASE_13_reg   (*((volatile unsigned int*) ICAM_SER_BASE_13_reg))
+#define get_ICAM_SER_BASE_14_reg   (*((volatile unsigned int*) ICAM_SER_BASE_14_reg))
+#define get_ICAM_SER_BASE_15_reg   (*((volatile unsigned int*) ICAM_SER_BASE_15_reg))
+#define get_ICAM_SER_BASE_16_reg   (*((volatile unsigned int*) ICAM_SER_BASE_16_reg))
+#define get_ICAM_SER_BASE_17_reg   (*((volatile unsigned int*) ICAM_SER_BASE_17_reg))
+#define get_ICAM_SER_BASE_18_reg   (*((volatile unsigned int*) ICAM_SER_BASE_18_reg))
+#define get_ICAM_SER_BASE_19_reg   (*((volatile unsigned int*) ICAM_SER_BASE_19_reg))
+#define get_ICAM_SER_BASE_20_reg   (*((volatile unsigned int*) ICAM_SER_BASE_20_reg))
+#define get_ICAM_SER_BASE_21_reg   (*((volatile unsigned int*) ICAM_SER_BASE_21_reg))
+#define get_ICAM_SER_BASE_22_reg   (*((volatile unsigned int*) ICAM_SER_BASE_22_reg))
+#define get_ICAM_SER_BASE_23_reg   (*((volatile unsigned int*) ICAM_SER_BASE_23_reg))
+#define get_ICAM_SER_BASE_24_reg   (*((volatile unsigned int*) ICAM_SER_BASE_24_reg))
+#define get_ICAM_SER_BASE_25_reg   (*((volatile unsigned int*) ICAM_SER_BASE_25_reg))
+#define get_ICAM_SER_BASE_26_reg   (*((volatile unsigned int*) ICAM_SER_BASE_26_reg))
+#define get_ICAM_SER_BASE_27_reg   (*((volatile unsigned int*) ICAM_SER_BASE_27_reg))
+#define get_ICAM_SER_BASE_28_reg   (*((volatile unsigned int*) ICAM_SER_BASE_28_reg))
+#define get_ICAM_SER_BASE_29_reg   (*((volatile unsigned int*) ICAM_SER_BASE_29_reg))
+#define get_ICAM_SER_BASE_30_reg   (*((volatile unsigned int*) ICAM_SER_BASE_30_reg))
+#define get_ICAM_SER_BASE_31_reg   (*((volatile unsigned int*) ICAM_SER_BASE_31_reg))
+#define get_ICAM_SER_BASE_32_reg   (*((volatile unsigned int*) ICAM_SER_BASE_32_reg))
+#define get_ICAM_SER_BASE_33_reg   (*((volatile unsigned int*) ICAM_SER_BASE_33_reg))
+#define get_ICAM_SER_BASE_34_reg   (*((volatile unsigned int*) ICAM_SER_BASE_34_reg))
+#define get_ICAM_SER_BASE_35_reg   (*((volatile unsigned int*) ICAM_SER_BASE_35_reg))
+#define get_ICAM_SER_BASE_36_reg   (*((volatile unsigned int*) ICAM_SER_BASE_36_reg))
+#define get_ICAM_SER_BASE_37_reg   (*((volatile unsigned int*) ICAM_SER_BASE_37_reg))
+#define get_ICAM_SER_BASE_38_reg   (*((volatile unsigned int*) ICAM_SER_BASE_38_reg))
+#define get_ICAM_SER_BASE_39_reg   (*((volatile unsigned int*) ICAM_SER_BASE_39_reg))
+#define get_ICAM_SER_BASE_40_reg   (*((volatile unsigned int*) ICAM_SER_BASE_40_reg))
+#define get_ICAM_SER_BASE_41_reg   (*((volatile unsigned int*) ICAM_SER_BASE_41_reg))
+#define get_ICAM_SER_BASE_42_reg   (*((volatile unsigned int*) ICAM_SER_BASE_42_reg))
+#define get_ICAM_SER_BASE_43_reg   (*((volatile unsigned int*) ICAM_SER_BASE_43_reg))
+#define get_ICAM_SER_BASE_44_reg   (*((volatile unsigned int*) ICAM_SER_BASE_44_reg))
+#define get_ICAM_SER_BASE_45_reg   (*((volatile unsigned int*) ICAM_SER_BASE_45_reg))
+#define get_ICAM_SER_BASE_46_reg   (*((volatile unsigned int*) ICAM_SER_BASE_46_reg))
+#define get_ICAM_SER_BASE_47_reg   (*((volatile unsigned int*) ICAM_SER_BASE_47_reg))
+#define ICAM_SER_BASE_0_inst_adr                                                     "0x04A0"
+#define ICAM_SER_BASE_1_inst_adr                                                     "0x04A1"
+#define ICAM_SER_BASE_2_inst_adr                                                     "0x04A2"
+#define ICAM_SER_BASE_3_inst_adr                                                     "0x04A3"
+#define ICAM_SER_BASE_4_inst_adr                                                     "0x04A4"
+#define ICAM_SER_BASE_5_inst_adr                                                     "0x04A5"
+#define ICAM_SER_BASE_6_inst_adr                                                     "0x04A6"
+#define ICAM_SER_BASE_7_inst_adr                                                     "0x04A7"
+#define ICAM_SER_BASE_8_inst_adr                                                     "0x04A8"
+#define ICAM_SER_BASE_9_inst_adr                                                     "0x04A9"
+#define ICAM_SER_BASE_10_inst_adr                                                     "0x04AA"
+#define ICAM_SER_BASE_11_inst_adr                                                     "0x04AB"
+#define ICAM_SER_BASE_12_inst_adr                                                     "0x04AC"
+#define ICAM_SER_BASE_13_inst_adr                                                     "0x04AD"
+#define ICAM_SER_BASE_14_inst_adr                                                     "0x04AE"
+#define ICAM_SER_BASE_15_inst_adr                                                     "0x04AF"
+#define ICAM_SER_BASE_16_inst_adr                                                     "0x04B0"
+#define ICAM_SER_BASE_17_inst_adr                                                     "0x04B1"
+#define ICAM_SER_BASE_18_inst_adr                                                     "0x04B2"
+#define ICAM_SER_BASE_19_inst_adr                                                     "0x04B3"
+#define ICAM_SER_BASE_20_inst_adr                                                     "0x04B4"
+#define ICAM_SER_BASE_21_inst_adr                                                     "0x04B5"
+#define ICAM_SER_BASE_22_inst_adr                                                     "0x04B6"
+#define ICAM_SER_BASE_23_inst_adr                                                     "0x04B7"
+#define ICAM_SER_BASE_24_inst_adr                                                     "0x04B8"
+#define ICAM_SER_BASE_25_inst_adr                                                     "0x04B9"
+#define ICAM_SER_BASE_26_inst_adr                                                     "0x04BA"
+#define ICAM_SER_BASE_27_inst_adr                                                     "0x04BB"
+#define ICAM_SER_BASE_28_inst_adr                                                     "0x04BC"
+#define ICAM_SER_BASE_29_inst_adr                                                     "0x04BD"
+#define ICAM_SER_BASE_30_inst_adr                                                     "0x04BE"
+#define ICAM_SER_BASE_31_inst_adr                                                     "0x04BF"
+#define ICAM_SER_BASE_32_inst_adr                                                     "0x04C0"
+#define ICAM_SER_BASE_33_inst_adr                                                     "0x04C1"
+#define ICAM_SER_BASE_34_inst_adr                                                     "0x04C2"
+#define ICAM_SER_BASE_35_inst_adr                                                     "0x04C3"
+#define ICAM_SER_BASE_36_inst_adr                                                     "0x04C4"
+#define ICAM_SER_BASE_37_inst_adr                                                     "0x04C5"
+#define ICAM_SER_BASE_38_inst_adr                                                     "0x04C6"
+#define ICAM_SER_BASE_39_inst_adr                                                     "0x04C7"
+#define ICAM_SER_BASE_40_inst_adr                                                     "0x04C8"
+#define ICAM_SER_BASE_41_inst_adr                                                     "0x04C9"
+#define ICAM_SER_BASE_42_inst_adr                                                     "0x04CA"
+#define ICAM_SER_BASE_43_inst_adr                                                     "0x04CB"
+#define ICAM_SER_BASE_44_inst_adr                                                     "0x04CC"
+#define ICAM_SER_BASE_45_inst_adr                                                     "0x04CD"
+#define ICAM_SER_BASE_46_inst_adr                                                     "0x04CE"
+#define ICAM_SER_BASE_47_inst_adr                                                     "0x04CF"
+#define ICAM_SER_BASE_0_inst                                                         0x04A0
+#define ICAM_SER_BASE_1_inst                                                         0x04A1
+#define ICAM_SER_BASE_2_inst                                                         0x04A2
+#define ICAM_SER_BASE_3_inst                                                         0x04A3
+#define ICAM_SER_BASE_4_inst                                                         0x04A4
+#define ICAM_SER_BASE_5_inst                                                         0x04A5
+#define ICAM_SER_BASE_6_inst                                                         0x04A6
+#define ICAM_SER_BASE_7_inst                                                         0x04A7
+#define ICAM_SER_BASE_8_inst                                                         0x04A8
+#define ICAM_SER_BASE_9_inst                                                         0x04A9
+#define ICAM_SER_BASE_10_inst                                                         0x04AA
+#define ICAM_SER_BASE_11_inst                                                         0x04AB
+#define ICAM_SER_BASE_12_inst                                                         0x04AC
+#define ICAM_SER_BASE_13_inst                                                         0x04AD
+#define ICAM_SER_BASE_14_inst                                                         0x04AE
+#define ICAM_SER_BASE_15_inst                                                         0x04AF
+#define ICAM_SER_BASE_16_inst                                                         0x04B0
+#define ICAM_SER_BASE_17_inst                                                         0x04B1
+#define ICAM_SER_BASE_18_inst                                                         0x04B2
+#define ICAM_SER_BASE_19_inst                                                         0x04B3
+#define ICAM_SER_BASE_20_inst                                                         0x04B4
+#define ICAM_SER_BASE_21_inst                                                         0x04B5
+#define ICAM_SER_BASE_22_inst                                                         0x04B6
+#define ICAM_SER_BASE_23_inst                                                         0x04B7
+#define ICAM_SER_BASE_24_inst                                                         0x04B8
+#define ICAM_SER_BASE_25_inst                                                         0x04B9
+#define ICAM_SER_BASE_26_inst                                                         0x04BA
+#define ICAM_SER_BASE_27_inst                                                         0x04BB
+#define ICAM_SER_BASE_28_inst                                                         0x04BC
+#define ICAM_SER_BASE_29_inst                                                         0x04BD
+#define ICAM_SER_BASE_30_inst                                                         0x04BE
+#define ICAM_SER_BASE_31_inst                                                         0x04BF
+#define ICAM_SER_BASE_32_inst                                                         0x04C0
+#define ICAM_SER_BASE_33_inst                                                         0x04C1
+#define ICAM_SER_BASE_34_inst                                                         0x04C2
+#define ICAM_SER_BASE_35_inst                                                         0x04C3
+#define ICAM_SER_BASE_36_inst                                                         0x04C4
+#define ICAM_SER_BASE_37_inst                                                         0x04C5
+#define ICAM_SER_BASE_38_inst                                                         0x04C6
+#define ICAM_SER_BASE_39_inst                                                         0x04C7
+#define ICAM_SER_BASE_40_inst                                                         0x04C8
+#define ICAM_SER_BASE_41_inst                                                         0x04C9
+#define ICAM_SER_BASE_42_inst                                                         0x04CA
+#define ICAM_SER_BASE_43_inst                                                         0x04CB
+#define ICAM_SER_BASE_44_inst                                                         0x04CC
+#define ICAM_SER_BASE_45_inst                                                         0x04CD
+#define ICAM_SER_BASE_46_inst                                                         0x04CE
+#define ICAM_SER_BASE_47_inst                                                         0x04CF
+#define ICAM_SER_BASE_SER_Base_shift                                                 (0)
+#define ICAM_SER_BASE_SER_Base_mask                                                  (0xFFFFFFFF)
+#define ICAM_SER_BASE_SER_Base(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ICAM_SER_BASE_SER_Base_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ICAM_SER_BASE_get_SER_Base(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ICAM_SER_RESULT_0                                                            0x18021340
+#define ICAM_SER_RESULT_1                                                            0x18021344
+#define ICAM_SER_RESULT_2                                                            0x18021348
+#define ICAM_SER_RESULT_3                                                            0x1802134C
+#define ICAM_SER_RESULT_4                                                            0x18021350
+#define ICAM_SER_RESULT_5                                                            0x18021354
+#define ICAM_SER_RESULT_6                                                            0x18021358
+#define ICAM_SER_RESULT_7                                                            0x1802135C
+#define ICAM_SER_RESULT_8                                                            0x18021360
+#define ICAM_SER_RESULT_9                                                            0x18021364
+#define ICAM_SER_RESULT_10                                                            0x18021368
+#define ICAM_SER_RESULT_11                                                            0x1802136C
+#define ICAM_SER_RESULT_12                                                            0x18021370
+#define ICAM_SER_RESULT_13                                                            0x18021374
+#define ICAM_SER_RESULT_14                                                            0x18021378
+#define ICAM_SER_RESULT_15                                                            0x1802137C
+#define ICAM_SER_RESULT_16                                                            0x18021380
+#define ICAM_SER_RESULT_17                                                            0x18021384
+#define ICAM_SER_RESULT_18                                                            0x18021388
+#define ICAM_SER_RESULT_19                                                            0x1802138C
+#define ICAM_SER_RESULT_20                                                            0x18021390
+#define ICAM_SER_RESULT_21                                                            0x18021394
+#define ICAM_SER_RESULT_22                                                            0x18021398
+#define ICAM_SER_RESULT_23                                                            0x1802139C
+#define ICAM_SER_RESULT_24                                                            0x180213A0
+#define ICAM_SER_RESULT_25                                                            0x180213A4
+#define ICAM_SER_RESULT_26                                                            0x180213A8
+#define ICAM_SER_RESULT_27                                                            0x180213AC
+#define ICAM_SER_RESULT_28                                                            0x180213B0
+#define ICAM_SER_RESULT_29                                                            0x180213B4
+#define ICAM_SER_RESULT_30                                                            0x180213B8
+#define ICAM_SER_RESULT_31                                                            0x180213BC
+#define ICAM_SER_RESULT_0_reg_addr                                                   "0xB8021340"
+#define ICAM_SER_RESULT_1_reg_addr                                                   "0xB8021344"
+#define ICAM_SER_RESULT_2_reg_addr                                                   "0xB8021348"
+#define ICAM_SER_RESULT_3_reg_addr                                                   "0xB802134C"
+#define ICAM_SER_RESULT_4_reg_addr                                                   "0xB8021350"
+#define ICAM_SER_RESULT_5_reg_addr                                                   "0xB8021354"
+#define ICAM_SER_RESULT_6_reg_addr                                                   "0xB8021358"
+#define ICAM_SER_RESULT_7_reg_addr                                                   "0xB802135C"
+#define ICAM_SER_RESULT_8_reg_addr                                                   "0xB8021360"
+#define ICAM_SER_RESULT_9_reg_addr                                                   "0xB8021364"
+#define ICAM_SER_RESULT_10_reg_addr                                                   "0xB8021368"
+#define ICAM_SER_RESULT_11_reg_addr                                                   "0xB802136C"
+#define ICAM_SER_RESULT_12_reg_addr                                                   "0xB8021370"
+#define ICAM_SER_RESULT_13_reg_addr                                                   "0xB8021374"
+#define ICAM_SER_RESULT_14_reg_addr                                                   "0xB8021378"
+#define ICAM_SER_RESULT_15_reg_addr                                                   "0xB802137C"
+#define ICAM_SER_RESULT_16_reg_addr                                                   "0xB8021380"
+#define ICAM_SER_RESULT_17_reg_addr                                                   "0xB8021384"
+#define ICAM_SER_RESULT_18_reg_addr                                                   "0xB8021388"
+#define ICAM_SER_RESULT_19_reg_addr                                                   "0xB802138C"
+#define ICAM_SER_RESULT_20_reg_addr                                                   "0xB8021390"
+#define ICAM_SER_RESULT_21_reg_addr                                                   "0xB8021394"
+#define ICAM_SER_RESULT_22_reg_addr                                                   "0xB8021398"
+#define ICAM_SER_RESULT_23_reg_addr                                                   "0xB802139C"
+#define ICAM_SER_RESULT_24_reg_addr                                                   "0xB80213A0"
+#define ICAM_SER_RESULT_25_reg_addr                                                   "0xB80213A4"
+#define ICAM_SER_RESULT_26_reg_addr                                                   "0xB80213A8"
+#define ICAM_SER_RESULT_27_reg_addr                                                   "0xB80213AC"
+#define ICAM_SER_RESULT_28_reg_addr                                                   "0xB80213B0"
+#define ICAM_SER_RESULT_29_reg_addr                                                   "0xB80213B4"
+#define ICAM_SER_RESULT_30_reg_addr                                                   "0xB80213B8"
+#define ICAM_SER_RESULT_31_reg_addr                                                   "0xB80213BC"
+#define ICAM_SER_RESULT_0_reg                                                        0xB8021340
+#define ICAM_SER_RESULT_1_reg                                                        0xB8021344
+#define ICAM_SER_RESULT_2_reg                                                        0xB8021348
+#define ICAM_SER_RESULT_3_reg                                                        0xB802134C
+#define ICAM_SER_RESULT_4_reg                                                        0xB8021350
+#define ICAM_SER_RESULT_5_reg                                                        0xB8021354
+#define ICAM_SER_RESULT_6_reg                                                        0xB8021358
+#define ICAM_SER_RESULT_7_reg                                                        0xB802135C
+#define ICAM_SER_RESULT_8_reg                                                        0xB8021360
+#define ICAM_SER_RESULT_9_reg                                                        0xB8021364
+#define ICAM_SER_RESULT_10_reg                                                        0xB8021368
+#define ICAM_SER_RESULT_11_reg                                                        0xB802136C
+#define ICAM_SER_RESULT_12_reg                                                        0xB8021370
+#define ICAM_SER_RESULT_13_reg                                                        0xB8021374
+#define ICAM_SER_RESULT_14_reg                                                        0xB8021378
+#define ICAM_SER_RESULT_15_reg                                                        0xB802137C
+#define ICAM_SER_RESULT_16_reg                                                        0xB8021380
+#define ICAM_SER_RESULT_17_reg                                                        0xB8021384
+#define ICAM_SER_RESULT_18_reg                                                        0xB8021388
+#define ICAM_SER_RESULT_19_reg                                                        0xB802138C
+#define ICAM_SER_RESULT_20_reg                                                        0xB8021390
+#define ICAM_SER_RESULT_21_reg                                                        0xB8021394
+#define ICAM_SER_RESULT_22_reg                                                        0xB8021398
+#define ICAM_SER_RESULT_23_reg                                                        0xB802139C
+#define ICAM_SER_RESULT_24_reg                                                        0xB80213A0
+#define ICAM_SER_RESULT_25_reg                                                        0xB80213A4
+#define ICAM_SER_RESULT_26_reg                                                        0xB80213A8
+#define ICAM_SER_RESULT_27_reg                                                        0xB80213AC
+#define ICAM_SER_RESULT_28_reg                                                        0xB80213B0
+#define ICAM_SER_RESULT_29_reg                                                        0xB80213B4
+#define ICAM_SER_RESULT_30_reg                                                        0xB80213B8
+#define ICAM_SER_RESULT_31_reg                                                        0xB80213BC
+#define set_ICAM_SER_RESULT_0_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_0_reg)=data)
+#define set_ICAM_SER_RESULT_1_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_1_reg)=data)
+#define set_ICAM_SER_RESULT_2_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_2_reg)=data)
+#define set_ICAM_SER_RESULT_3_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_3_reg)=data)
+#define set_ICAM_SER_RESULT_4_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_4_reg)=data)
+#define set_ICAM_SER_RESULT_5_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_5_reg)=data)
+#define set_ICAM_SER_RESULT_6_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_6_reg)=data)
+#define set_ICAM_SER_RESULT_7_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_7_reg)=data)
+#define set_ICAM_SER_RESULT_8_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_8_reg)=data)
+#define set_ICAM_SER_RESULT_9_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_9_reg)=data)
+#define set_ICAM_SER_RESULT_10_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_10_reg)=data)
+#define set_ICAM_SER_RESULT_11_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_11_reg)=data)
+#define set_ICAM_SER_RESULT_12_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_12_reg)=data)
+#define set_ICAM_SER_RESULT_13_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_13_reg)=data)
+#define set_ICAM_SER_RESULT_14_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_14_reg)=data)
+#define set_ICAM_SER_RESULT_15_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_15_reg)=data)
+#define set_ICAM_SER_RESULT_16_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_16_reg)=data)
+#define set_ICAM_SER_RESULT_17_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_17_reg)=data)
+#define set_ICAM_SER_RESULT_18_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_18_reg)=data)
+#define set_ICAM_SER_RESULT_19_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_19_reg)=data)
+#define set_ICAM_SER_RESULT_20_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_20_reg)=data)
+#define set_ICAM_SER_RESULT_21_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_21_reg)=data)
+#define set_ICAM_SER_RESULT_22_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_22_reg)=data)
+#define set_ICAM_SER_RESULT_23_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_23_reg)=data)
+#define set_ICAM_SER_RESULT_24_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_24_reg)=data)
+#define set_ICAM_SER_RESULT_25_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_25_reg)=data)
+#define set_ICAM_SER_RESULT_26_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_26_reg)=data)
+#define set_ICAM_SER_RESULT_27_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_27_reg)=data)
+#define set_ICAM_SER_RESULT_28_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_28_reg)=data)
+#define set_ICAM_SER_RESULT_29_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_29_reg)=data)
+#define set_ICAM_SER_RESULT_30_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_30_reg)=data)
+#define set_ICAM_SER_RESULT_31_reg(data)   (*((volatile unsigned int*) ICAM_SER_RESULT_31_reg)=data)
+#define get_ICAM_SER_RESULT_0_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_0_reg))
+#define get_ICAM_SER_RESULT_1_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_1_reg))
+#define get_ICAM_SER_RESULT_2_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_2_reg))
+#define get_ICAM_SER_RESULT_3_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_3_reg))
+#define get_ICAM_SER_RESULT_4_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_4_reg))
+#define get_ICAM_SER_RESULT_5_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_5_reg))
+#define get_ICAM_SER_RESULT_6_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_6_reg))
+#define get_ICAM_SER_RESULT_7_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_7_reg))
+#define get_ICAM_SER_RESULT_8_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_8_reg))
+#define get_ICAM_SER_RESULT_9_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_9_reg))
+#define get_ICAM_SER_RESULT_10_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_10_reg))
+#define get_ICAM_SER_RESULT_11_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_11_reg))
+#define get_ICAM_SER_RESULT_12_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_12_reg))
+#define get_ICAM_SER_RESULT_13_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_13_reg))
+#define get_ICAM_SER_RESULT_14_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_14_reg))
+#define get_ICAM_SER_RESULT_15_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_15_reg))
+#define get_ICAM_SER_RESULT_16_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_16_reg))
+#define get_ICAM_SER_RESULT_17_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_17_reg))
+#define get_ICAM_SER_RESULT_18_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_18_reg))
+#define get_ICAM_SER_RESULT_19_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_19_reg))
+#define get_ICAM_SER_RESULT_20_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_20_reg))
+#define get_ICAM_SER_RESULT_21_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_21_reg))
+#define get_ICAM_SER_RESULT_22_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_22_reg))
+#define get_ICAM_SER_RESULT_23_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_23_reg))
+#define get_ICAM_SER_RESULT_24_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_24_reg))
+#define get_ICAM_SER_RESULT_25_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_25_reg))
+#define get_ICAM_SER_RESULT_26_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_26_reg))
+#define get_ICAM_SER_RESULT_27_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_27_reg))
+#define get_ICAM_SER_RESULT_28_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_28_reg))
+#define get_ICAM_SER_RESULT_29_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_29_reg))
+#define get_ICAM_SER_RESULT_30_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_30_reg))
+#define get_ICAM_SER_RESULT_31_reg   (*((volatile unsigned int*) ICAM_SER_RESULT_31_reg))
+#define ICAM_SER_RESULT_0_inst_adr                                                   "0x04D0"
+#define ICAM_SER_RESULT_1_inst_adr                                                   "0x04D1"
+#define ICAM_SER_RESULT_2_inst_adr                                                   "0x04D2"
+#define ICAM_SER_RESULT_3_inst_adr                                                   "0x04D3"
+#define ICAM_SER_RESULT_4_inst_adr                                                   "0x04D4"
+#define ICAM_SER_RESULT_5_inst_adr                                                   "0x04D5"
+#define ICAM_SER_RESULT_6_inst_adr                                                   "0x04D6"
+#define ICAM_SER_RESULT_7_inst_adr                                                   "0x04D7"
+#define ICAM_SER_RESULT_8_inst_adr                                                   "0x04D8"
+#define ICAM_SER_RESULT_9_inst_adr                                                   "0x04D9"
+#define ICAM_SER_RESULT_10_inst_adr                                                   "0x04DA"
+#define ICAM_SER_RESULT_11_inst_adr                                                   "0x04DB"
+#define ICAM_SER_RESULT_12_inst_adr                                                   "0x04DC"
+#define ICAM_SER_RESULT_13_inst_adr                                                   "0x04DD"
+#define ICAM_SER_RESULT_14_inst_adr                                                   "0x04DE"
+#define ICAM_SER_RESULT_15_inst_adr                                                   "0x04DF"
+#define ICAM_SER_RESULT_16_inst_adr                                                   "0x04E0"
+#define ICAM_SER_RESULT_17_inst_adr                                                   "0x04E1"
+#define ICAM_SER_RESULT_18_inst_adr                                                   "0x04E2"
+#define ICAM_SER_RESULT_19_inst_adr                                                   "0x04E3"
+#define ICAM_SER_RESULT_20_inst_adr                                                   "0x04E4"
+#define ICAM_SER_RESULT_21_inst_adr                                                   "0x04E5"
+#define ICAM_SER_RESULT_22_inst_adr                                                   "0x04E6"
+#define ICAM_SER_RESULT_23_inst_adr                                                   "0x04E7"
+#define ICAM_SER_RESULT_24_inst_adr                                                   "0x04E8"
+#define ICAM_SER_RESULT_25_inst_adr                                                   "0x04E9"
+#define ICAM_SER_RESULT_26_inst_adr                                                   "0x04EA"
+#define ICAM_SER_RESULT_27_inst_adr                                                   "0x04EB"
+#define ICAM_SER_RESULT_28_inst_adr                                                   "0x04EC"
+#define ICAM_SER_RESULT_29_inst_adr                                                   "0x04ED"
+#define ICAM_SER_RESULT_30_inst_adr                                                   "0x04EE"
+#define ICAM_SER_RESULT_31_inst_adr                                                   "0x04EF"
+#define ICAM_SER_RESULT_0_inst                                                       0x04D0
+#define ICAM_SER_RESULT_1_inst                                                       0x04D1
+#define ICAM_SER_RESULT_2_inst                                                       0x04D2
+#define ICAM_SER_RESULT_3_inst                                                       0x04D3
+#define ICAM_SER_RESULT_4_inst                                                       0x04D4
+#define ICAM_SER_RESULT_5_inst                                                       0x04D5
+#define ICAM_SER_RESULT_6_inst                                                       0x04D6
+#define ICAM_SER_RESULT_7_inst                                                       0x04D7
+#define ICAM_SER_RESULT_8_inst                                                       0x04D8
+#define ICAM_SER_RESULT_9_inst                                                       0x04D9
+#define ICAM_SER_RESULT_10_inst                                                       0x04DA
+#define ICAM_SER_RESULT_11_inst                                                       0x04DB
+#define ICAM_SER_RESULT_12_inst                                                       0x04DC
+#define ICAM_SER_RESULT_13_inst                                                       0x04DD
+#define ICAM_SER_RESULT_14_inst                                                       0x04DE
+#define ICAM_SER_RESULT_15_inst                                                       0x04DF
+#define ICAM_SER_RESULT_16_inst                                                       0x04E0
+#define ICAM_SER_RESULT_17_inst                                                       0x04E1
+#define ICAM_SER_RESULT_18_inst                                                       0x04E2
+#define ICAM_SER_RESULT_19_inst                                                       0x04E3
+#define ICAM_SER_RESULT_20_inst                                                       0x04E4
+#define ICAM_SER_RESULT_21_inst                                                       0x04E5
+#define ICAM_SER_RESULT_22_inst                                                       0x04E6
+#define ICAM_SER_RESULT_23_inst                                                       0x04E7
+#define ICAM_SER_RESULT_24_inst                                                       0x04E8
+#define ICAM_SER_RESULT_25_inst                                                       0x04E9
+#define ICAM_SER_RESULT_26_inst                                                       0x04EA
+#define ICAM_SER_RESULT_27_inst                                                       0x04EB
+#define ICAM_SER_RESULT_28_inst                                                       0x04EC
+#define ICAM_SER_RESULT_29_inst                                                       0x04ED
+#define ICAM_SER_RESULT_30_inst                                                       0x04EE
+#define ICAM_SER_RESULT_31_inst                                                       0x04EF
+#define ICAM_SER_RESULT_SER_Result_shift                                             (0)
+#define ICAM_SER_RESULT_SER_Result_mask                                              (0xFFFFFFFF)
+#define ICAM_SER_RESULT_SER_Result(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ICAM_SER_RESULT_SER_Result_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ICAM_SER_RESULT_get_SER_Result(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/ide_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/ide_reg.h
new file mode 100644
index 00000000..4e91294
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/ide_reg.h
@@ -0,0 +1,8 @@
+// This file is generated using the spec version 2.1.0, firmware template version 1.39and DVR_Parser_0.43
+#ifndef _IDE_REG_H_INCLUDED_
+#define _IDE_REG_H_INCLUDED_
+
+//#define  _IDE_USE_STRUCT
+#ifdef _IDE_USE_STRUCT
+#endif
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/img_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/img_reg.h
new file mode 100644
index 00000000..49d6e3a
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/img_reg.h
@@ -0,0 +1,360 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/6/22 11:40:33
+***************************************************************/
+
+
+#ifndef _IMG_REG_H_INCLUDED_
+#define _IMG_REG_H_INCLUDED_
+#ifdef  _IMG_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     dering_dbg_sel:3;
+unsigned int     reserved_1:1;
+unsigned int     dbg_group2_sel:5;
+unsigned int     dbg_group1_sel:5;
+unsigned int     dbg_out_en:1;
+unsigned int     reserved_2:8;
+}IMG_DBG_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     chroma_enable:1;
+unsigned int     luma_enable:1;
+}IMG_DERING_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     filt_prec:2;
+}IMG_FILT_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     init_value:10;
+}IMG_FILT_INIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     rcrpr:1;
+unsigned int     color_cr:8;
+unsigned int     color_cb:8;
+unsigned int     color_y:8;
+unsigned int     fill_mode:2;
+}IMG_RMRPR_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     m:4;
+unsigned int     pixel_offset:11;
+}IMG_RMRPR_PAR;
+
+typedef struct 
+{
+unsigned int     ax:32;
+}IMG_RMRPR_AX;
+
+typedef struct 
+{
+unsigned int     ay:32;
+}IMG_RMRPR_AY;
+
+typedef struct 
+{
+unsigned int     ax_inc:32;
+}IMG_RMRPR_AXINC;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     picmb_h:6;
+unsigned int     picmb_w:7;
+}IMG_RMRPR_PICINFO;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     basea:10;
+}IMG_BASEA;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     offseta:9;
+}IMG_OFFSETA;
+
+#endif
+
+#define IMG_DBG_CNTL                                                                 0x1800ED00
+#define IMG_DBG_CNTL_reg_addr                                                        "0xB800ED00"
+#define IMG_DBG_CNTL_reg                                                             0xB800ED00
+#define set_IMG_DBG_CNTL_reg(data)   (*((volatile unsigned int*) IMG_DBG_CNTL_reg)=data)
+#define get_IMG_DBG_CNTL_reg   (*((volatile unsigned int*) IMG_DBG_CNTL_reg))
+#define IMG_DBG_CNTL_inst_adr                                                        "0x0040"
+#define IMG_DBG_CNTL_inst                                                            0x0040
+#define IMG_DBG_CNTL_dering_dbg_sel_shift                                            (20)
+#define IMG_DBG_CNTL_dering_dbg_sel_mask                                             (0x00700000)
+#define IMG_DBG_CNTL_dering_dbg_sel(data)                                            (0x00700000&((data)<<20))
+#define IMG_DBG_CNTL_dering_dbg_sel_src(data)                                        ((0x00700000&(data))>>20)
+#define IMG_DBG_CNTL_get_dering_dbg_sel(data)                                        ((0x00700000&(data))>>20)
+#define IMG_DBG_CNTL_dbg_group2_sel_shift                                            (14)
+#define IMG_DBG_CNTL_dbg_group2_sel_mask                                             (0x0007C000)
+#define IMG_DBG_CNTL_dbg_group2_sel(data)                                            (0x0007C000&((data)<<14))
+#define IMG_DBG_CNTL_dbg_group2_sel_src(data)                                        ((0x0007C000&(data))>>14)
+#define IMG_DBG_CNTL_get_dbg_group2_sel(data)                                        ((0x0007C000&(data))>>14)
+#define IMG_DBG_CNTL_dbg_group1_sel_shift                                            (9)
+#define IMG_DBG_CNTL_dbg_group1_sel_mask                                             (0x00003E00)
+#define IMG_DBG_CNTL_dbg_group1_sel(data)                                            (0x00003E00&((data)<<9))
+#define IMG_DBG_CNTL_dbg_group1_sel_src(data)                                        ((0x00003E00&(data))>>9)
+#define IMG_DBG_CNTL_get_dbg_group1_sel(data)                                        ((0x00003E00&(data))>>9)
+#define IMG_DBG_CNTL_dbg_out_en_shift                                                (8)
+#define IMG_DBG_CNTL_dbg_out_en_mask                                                 (0x00000100)
+#define IMG_DBG_CNTL_dbg_out_en(data)                                                (0x00000100&((data)<<8))
+#define IMG_DBG_CNTL_dbg_out_en_src(data)                                            ((0x00000100&(data))>>8)
+#define IMG_DBG_CNTL_get_dbg_out_en(data)                                            ((0x00000100&(data))>>8)
+
+
+#define IMG_DERING_CNTL                                                              0x1800ED04
+#define IMG_DERING_CNTL_reg_addr                                                     "0xB800ED04"
+#define IMG_DERING_CNTL_reg                                                          0xB800ED04
+#define set_IMG_DERING_CNTL_reg(data)   (*((volatile unsigned int*) IMG_DERING_CNTL_reg)=data)
+#define get_IMG_DERING_CNTL_reg   (*((volatile unsigned int*) IMG_DERING_CNTL_reg))
+#define IMG_DERING_CNTL_inst_adr                                                     "0x0041"
+#define IMG_DERING_CNTL_inst                                                         0x0041
+#define IMG_DERING_CNTL_chroma_enable_shift                                          (1)
+#define IMG_DERING_CNTL_chroma_enable_mask                                           (0x00000002)
+#define IMG_DERING_CNTL_chroma_enable(data)                                          (0x00000002&((data)<<1))
+#define IMG_DERING_CNTL_chroma_enable_src(data)                                      ((0x00000002&(data))>>1)
+#define IMG_DERING_CNTL_get_chroma_enable(data)                                      ((0x00000002&(data))>>1)
+#define IMG_DERING_CNTL_luma_enable_shift                                            (0)
+#define IMG_DERING_CNTL_luma_enable_mask                                             (0x00000001)
+#define IMG_DERING_CNTL_luma_enable(data)                                            (0x00000001&((data)<<0))
+#define IMG_DERING_CNTL_luma_enable_src(data)                                        ((0x00000001&(data))>>0)
+#define IMG_DERING_CNTL_get_luma_enable(data)                                        ((0x00000001&(data))>>0)
+
+
+#define IMG_FILT_CNTL                                                                0x1800ED08
+#define IMG_FILT_CNTL_reg_addr                                                       "0xB800ED08"
+#define IMG_FILT_CNTL_reg                                                            0xB800ED08
+#define set_IMG_FILT_CNTL_reg(data)   (*((volatile unsigned int*) IMG_FILT_CNTL_reg)=data)
+#define get_IMG_FILT_CNTL_reg   (*((volatile unsigned int*) IMG_FILT_CNTL_reg))
+#define IMG_FILT_CNTL_inst_adr                                                       "0x0042"
+#define IMG_FILT_CNTL_inst                                                           0x0042
+#define IMG_FILT_CNTL_filt_prec_shift                                                (0)
+#define IMG_FILT_CNTL_filt_prec_mask                                                 (0x00000003)
+#define IMG_FILT_CNTL_filt_prec(data)                                                (0x00000003&((data)<<0))
+#define IMG_FILT_CNTL_filt_prec_src(data)                                            ((0x00000003&(data))>>0)
+#define IMG_FILT_CNTL_get_filt_prec(data)                                            ((0x00000003&(data))>>0)
+
+
+#define IMG_FILT_INIT                                                                0x1800ED0C
+#define IMG_FILT_INIT_reg_addr                                                       "0xB800ED0C"
+#define IMG_FILT_INIT_reg                                                            0xB800ED0C
+#define set_IMG_FILT_INIT_reg(data)   (*((volatile unsigned int*) IMG_FILT_INIT_reg)=data)
+#define get_IMG_FILT_INIT_reg   (*((volatile unsigned int*) IMG_FILT_INIT_reg))
+#define IMG_FILT_INIT_inst_adr                                                       "0x0043"
+#define IMG_FILT_INIT_inst                                                           0x0043
+#define IMG_FILT_INIT_init_value_shift                                               (0)
+#define IMG_FILT_INIT_init_value_mask                                                (0x000003FF)
+#define IMG_FILT_INIT_init_value(data)                                               (0x000003FF&((data)<<0))
+#define IMG_FILT_INIT_init_value_src(data)                                           ((0x000003FF&(data))>>0)
+#define IMG_FILT_INIT_get_init_value(data)                                           ((0x000003FF&(data))>>0)
+
+
+#define IMG_RMRPR_CNTL                                                               0x1800ED10
+#define IMG_RMRPR_CNTL_reg_addr                                                      "0xB800ED10"
+#define IMG_RMRPR_CNTL_reg                                                           0xB800ED10
+#define set_IMG_RMRPR_CNTL_reg(data)   (*((volatile unsigned int*) IMG_RMRPR_CNTL_reg)=data)
+#define get_IMG_RMRPR_CNTL_reg   (*((volatile unsigned int*) IMG_RMRPR_CNTL_reg))
+#define IMG_RMRPR_CNTL_inst_adr                                                      "0x0044"
+#define IMG_RMRPR_CNTL_inst                                                          0x0044
+#define IMG_RMRPR_CNTL_rcrpr_shift                                                   (26)
+#define IMG_RMRPR_CNTL_rcrpr_mask                                                    (0x04000000)
+#define IMG_RMRPR_CNTL_rcrpr(data)                                                   (0x04000000&((data)<<26))
+#define IMG_RMRPR_CNTL_rcrpr_src(data)                                               ((0x04000000&(data))>>26)
+#define IMG_RMRPR_CNTL_get_rcrpr(data)                                               ((0x04000000&(data))>>26)
+#define IMG_RMRPR_CNTL_color_cr_shift                                                (18)
+#define IMG_RMRPR_CNTL_color_cr_mask                                                 (0x03FC0000)
+#define IMG_RMRPR_CNTL_color_cr(data)                                                (0x03FC0000&((data)<<18))
+#define IMG_RMRPR_CNTL_color_cr_src(data)                                            ((0x03FC0000&(data))>>18)
+#define IMG_RMRPR_CNTL_get_color_cr(data)                                            ((0x03FC0000&(data))>>18)
+#define IMG_RMRPR_CNTL_color_cb_shift                                                (10)
+#define IMG_RMRPR_CNTL_color_cb_mask                                                 (0x0003FC00)
+#define IMG_RMRPR_CNTL_color_cb(data)                                                (0x0003FC00&((data)<<10))
+#define IMG_RMRPR_CNTL_color_cb_src(data)                                            ((0x0003FC00&(data))>>10)
+#define IMG_RMRPR_CNTL_get_color_cb(data)                                            ((0x0003FC00&(data))>>10)
+#define IMG_RMRPR_CNTL_color_y_shift                                                 (2)
+#define IMG_RMRPR_CNTL_color_y_mask                                                  (0x000003FC)
+#define IMG_RMRPR_CNTL_color_y(data)                                                 (0x000003FC&((data)<<2))
+#define IMG_RMRPR_CNTL_color_y_src(data)                                             ((0x000003FC&(data))>>2)
+#define IMG_RMRPR_CNTL_get_color_y(data)                                             ((0x000003FC&(data))>>2)
+#define IMG_RMRPR_CNTL_fill_mode_shift                                               (0)
+#define IMG_RMRPR_CNTL_fill_mode_mask                                                (0x00000003)
+#define IMG_RMRPR_CNTL_fill_mode(data)                                               (0x00000003&((data)<<0))
+#define IMG_RMRPR_CNTL_fill_mode_src(data)                                           ((0x00000003&(data))>>0)
+#define IMG_RMRPR_CNTL_get_fill_mode(data)                                           ((0x00000003&(data))>>0)
+
+
+#define IMG_RMRPR_PAR                                                                0x1800ED14
+#define IMG_RMRPR_PAR_reg_addr                                                       "0xB800ED14"
+#define IMG_RMRPR_PAR_reg                                                            0xB800ED14
+#define set_IMG_RMRPR_PAR_reg(data)   (*((volatile unsigned int*) IMG_RMRPR_PAR_reg)=data)
+#define get_IMG_RMRPR_PAR_reg   (*((volatile unsigned int*) IMG_RMRPR_PAR_reg))
+#define IMG_RMRPR_PAR_inst_adr                                                       "0x0045"
+#define IMG_RMRPR_PAR_inst                                                           0x0045
+#define IMG_RMRPR_PAR_m_shift                                                        (11)
+#define IMG_RMRPR_PAR_m_mask                                                         (0x00007800)
+#define IMG_RMRPR_PAR_m(data)                                                        (0x00007800&((data)<<11))
+#define IMG_RMRPR_PAR_m_src(data)                                                    ((0x00007800&(data))>>11)
+#define IMG_RMRPR_PAR_get_m(data)                                                    ((0x00007800&(data))>>11)
+#define IMG_RMRPR_PAR_pixel_offset_shift                                             (0)
+#define IMG_RMRPR_PAR_pixel_offset_mask                                              (0x000007FF)
+#define IMG_RMRPR_PAR_pixel_offset(data)                                             (0x000007FF&((data)<<0))
+#define IMG_RMRPR_PAR_pixel_offset_src(data)                                         ((0x000007FF&(data))>>0)
+#define IMG_RMRPR_PAR_get_pixel_offset(data)                                         ((0x000007FF&(data))>>0)
+
+
+#define IMG_RMRPR_AX                                                                 0x1800ED18
+#define IMG_RMRPR_AX_reg_addr                                                        "0xB800ED18"
+#define IMG_RMRPR_AX_reg                                                             0xB800ED18
+#define set_IMG_RMRPR_AX_reg(data)   (*((volatile unsigned int*) IMG_RMRPR_AX_reg)=data)
+#define get_IMG_RMRPR_AX_reg   (*((volatile unsigned int*) IMG_RMRPR_AX_reg))
+#define IMG_RMRPR_AX_inst_adr                                                        "0x0046"
+#define IMG_RMRPR_AX_inst                                                            0x0046
+#define IMG_RMRPR_AX_ax_shift                                                        (0)
+#define IMG_RMRPR_AX_ax_mask                                                         (0xFFFFFFFF)
+#define IMG_RMRPR_AX_ax(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define IMG_RMRPR_AX_ax_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define IMG_RMRPR_AX_get_ax(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define IMG_RMRPR_AY                                                                 0x1800ED1C
+#define IMG_RMRPR_AY_reg_addr                                                        "0xB800ED1C"
+#define IMG_RMRPR_AY_reg                                                             0xB800ED1C
+#define set_IMG_RMRPR_AY_reg(data)   (*((volatile unsigned int*) IMG_RMRPR_AY_reg)=data)
+#define get_IMG_RMRPR_AY_reg   (*((volatile unsigned int*) IMG_RMRPR_AY_reg))
+#define IMG_RMRPR_AY_inst_adr                                                        "0x0047"
+#define IMG_RMRPR_AY_inst                                                            0x0047
+#define IMG_RMRPR_AY_ay_shift                                                        (0)
+#define IMG_RMRPR_AY_ay_mask                                                         (0xFFFFFFFF)
+#define IMG_RMRPR_AY_ay(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define IMG_RMRPR_AY_ay_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define IMG_RMRPR_AY_get_ay(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define IMG_RMRPR_AXINC                                                              0x1800ED20
+#define IMG_RMRPR_AXINC_reg_addr                                                     "0xB800ED20"
+#define IMG_RMRPR_AXINC_reg                                                          0xB800ED20
+#define set_IMG_RMRPR_AXINC_reg(data)   (*((volatile unsigned int*) IMG_RMRPR_AXINC_reg)=data)
+#define get_IMG_RMRPR_AXINC_reg   (*((volatile unsigned int*) IMG_RMRPR_AXINC_reg))
+#define IMG_RMRPR_AXINC_inst_adr                                                     "0x0048"
+#define IMG_RMRPR_AXINC_inst                                                         0x0048
+#define IMG_RMRPR_AXINC_ax_inc_shift                                                 (0)
+#define IMG_RMRPR_AXINC_ax_inc_mask                                                  (0xFFFFFFFF)
+#define IMG_RMRPR_AXINC_ax_inc(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define IMG_RMRPR_AXINC_ax_inc_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define IMG_RMRPR_AXINC_get_ax_inc(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define IMG_RMRPR_PICINFO                                                            0x1800ED24
+#define IMG_RMRPR_PICINFO_reg_addr                                                   "0xB800ED24"
+#define IMG_RMRPR_PICINFO_reg                                                        0xB800ED24
+#define set_IMG_RMRPR_PICINFO_reg(data)   (*((volatile unsigned int*) IMG_RMRPR_PICINFO_reg)=data)
+#define get_IMG_RMRPR_PICINFO_reg   (*((volatile unsigned int*) IMG_RMRPR_PICINFO_reg))
+#define IMG_RMRPR_PICINFO_inst_adr                                                   "0x0049"
+#define IMG_RMRPR_PICINFO_inst                                                       0x0049
+#define IMG_RMRPR_PICINFO_picmb_h_shift                                              (7)
+#define IMG_RMRPR_PICINFO_picmb_h_mask                                               (0x00001F80)
+#define IMG_RMRPR_PICINFO_picmb_h(data)                                              (0x00001F80&((data)<<7))
+#define IMG_RMRPR_PICINFO_picmb_h_src(data)                                          ((0x00001F80&(data))>>7)
+#define IMG_RMRPR_PICINFO_get_picmb_h(data)                                          ((0x00001F80&(data))>>7)
+#define IMG_RMRPR_PICINFO_picmb_w_shift                                              (0)
+#define IMG_RMRPR_PICINFO_picmb_w_mask                                               (0x0000007F)
+#define IMG_RMRPR_PICINFO_picmb_w(data)                                              (0x0000007F&((data)<<0))
+#define IMG_RMRPR_PICINFO_picmb_w_src(data)                                          ((0x0000007F&(data))>>0)
+#define IMG_RMRPR_PICINFO_get_picmb_w(data)                                          ((0x0000007F&(data))>>0)
+
+
+#define IMG_BASEA_0                                                                  0x1800ED28
+#define IMG_BASEA_1                                                                  0x1800ED2C
+#define IMG_BASEA_2                                                                  0x1800ED30
+#define IMG_BASEA_3                                                                  0x1800ED34
+#define IMG_BASEA_0_reg_addr                                                         "0xB800ED28"
+#define IMG_BASEA_1_reg_addr                                                         "0xB800ED2C"
+#define IMG_BASEA_2_reg_addr                                                         "0xB800ED30"
+#define IMG_BASEA_3_reg_addr                                                         "0xB800ED34"
+#define IMG_BASEA_0_reg                                                              0xB800ED28
+#define IMG_BASEA_1_reg                                                              0xB800ED2C
+#define IMG_BASEA_2_reg                                                              0xB800ED30
+#define IMG_BASEA_3_reg                                                              0xB800ED34
+#define set_IMG_BASEA_0_reg(data)   (*((volatile unsigned int*) IMG_BASEA_0_reg)=data)
+#define set_IMG_BASEA_1_reg(data)   (*((volatile unsigned int*) IMG_BASEA_1_reg)=data)
+#define set_IMG_BASEA_2_reg(data)   (*((volatile unsigned int*) IMG_BASEA_2_reg)=data)
+#define set_IMG_BASEA_3_reg(data)   (*((volatile unsigned int*) IMG_BASEA_3_reg)=data)
+#define get_IMG_BASEA_0_reg   (*((volatile unsigned int*) IMG_BASEA_0_reg))
+#define get_IMG_BASEA_1_reg   (*((volatile unsigned int*) IMG_BASEA_1_reg))
+#define get_IMG_BASEA_2_reg   (*((volatile unsigned int*) IMG_BASEA_2_reg))
+#define get_IMG_BASEA_3_reg   (*((volatile unsigned int*) IMG_BASEA_3_reg))
+#define IMG_BASEA_0_inst_adr                                                         "0x004A"
+#define IMG_BASEA_1_inst_adr                                                         "0x004B"
+#define IMG_BASEA_2_inst_adr                                                         "0x004C"
+#define IMG_BASEA_3_inst_adr                                                         "0x004D"
+#define IMG_BASEA_0_inst                                                             0x004A
+#define IMG_BASEA_1_inst                                                             0x004B
+#define IMG_BASEA_2_inst                                                             0x004C
+#define IMG_BASEA_3_inst                                                             0x004D
+#define IMG_BASEA_basea_shift                                                        (0)
+#define IMG_BASEA_basea_mask                                                         (0x000003FF)
+#define IMG_BASEA_basea(data)                                                        (0x000003FF&((data)<<0))
+#define IMG_BASEA_basea_src(data)                                                    ((0x000003FF&(data))>>0)
+#define IMG_BASEA_get_basea(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define IMG_OFFSETA_0                                                                0x1800ED38
+#define IMG_OFFSETA_1                                                                0x1800ED3C
+#define IMG_OFFSETA_2                                                                0x1800ED40
+#define IMG_OFFSETA_3                                                                0x1800ED44
+#define IMG_OFFSETA_0_reg_addr                                                       "0xB800ED38"
+#define IMG_OFFSETA_1_reg_addr                                                       "0xB800ED3C"
+#define IMG_OFFSETA_2_reg_addr                                                       "0xB800ED40"
+#define IMG_OFFSETA_3_reg_addr                                                       "0xB800ED44"
+#define IMG_OFFSETA_0_reg                                                            0xB800ED38
+#define IMG_OFFSETA_1_reg                                                            0xB800ED3C
+#define IMG_OFFSETA_2_reg                                                            0xB800ED40
+#define IMG_OFFSETA_3_reg                                                            0xB800ED44
+#define set_IMG_OFFSETA_0_reg(data)   (*((volatile unsigned int*) IMG_OFFSETA_0_reg)=data)
+#define set_IMG_OFFSETA_1_reg(data)   (*((volatile unsigned int*) IMG_OFFSETA_1_reg)=data)
+#define set_IMG_OFFSETA_2_reg(data)   (*((volatile unsigned int*) IMG_OFFSETA_2_reg)=data)
+#define set_IMG_OFFSETA_3_reg(data)   (*((volatile unsigned int*) IMG_OFFSETA_3_reg)=data)
+#define get_IMG_OFFSETA_0_reg   (*((volatile unsigned int*) IMG_OFFSETA_0_reg))
+#define get_IMG_OFFSETA_1_reg   (*((volatile unsigned int*) IMG_OFFSETA_1_reg))
+#define get_IMG_OFFSETA_2_reg   (*((volatile unsigned int*) IMG_OFFSETA_2_reg))
+#define get_IMG_OFFSETA_3_reg   (*((volatile unsigned int*) IMG_OFFSETA_3_reg))
+#define IMG_OFFSETA_0_inst_adr                                                       "0x004E"
+#define IMG_OFFSETA_1_inst_adr                                                       "0x004F"
+#define IMG_OFFSETA_2_inst_adr                                                       "0x0050"
+#define IMG_OFFSETA_3_inst_adr                                                       "0x0051"
+#define IMG_OFFSETA_0_inst                                                           0x004E
+#define IMG_OFFSETA_1_inst                                                           0x004F
+#define IMG_OFFSETA_2_inst                                                           0x0050
+#define IMG_OFFSETA_3_inst                                                           0x0051
+#define IMG_OFFSETA_offseta_shift                                                    (0)
+#define IMG_OFFSETA_offseta_mask                                                     (0x000001FF)
+#define IMG_OFFSETA_offseta(data)                                                    (0x000001FF&((data)<<0))
+#define IMG_OFFSETA_offseta_src(data)                                                ((0x000001FF&(data))>>0)
+#define IMG_OFFSETA_get_offseta(data)                                                ((0x000001FF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/interrupts.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/interrupts.h
new file mode 100644
index 00000000..a206600
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/interrupts.h
@@ -0,0 +1,103 @@
+#ifndef __INTERRUPT_H_20130321
+#define __INTERRUPT_H_20130321
+
+#ifdef SCPU_ARM
+
+#define	INTERRUPT_SCPU_GLOBAL_TIMER	27
+#define	INTERRUPT_SCPU_LEGACY_FIQ 	28
+#define	INTERRUPT_SCPU_PRIVATE_TIMER 29
+#define	INTERRUPT_SCPU_WATCHDOG    	30
+#define	INTERRUPT_SCPU_IRQ      	31
+#define	INTERRUPT_SCPU_NMI      	32
+#define	INTERRUPT_SCPU_TIMER2  	    33
+#define	INTERRUPT_SCPU_CP_SWC       34
+#define	INTERRUPT_SCPU_MD_SWC       35
+#define	INTERRUPT_SCPU_NAND_SWC	    36
+#define	INTERRUPT_SCPU_AVCPU_SWC    37
+#define	INTERRUPT_SCPU_I2C  	    38
+#define	INTERRUPT_SCPU_TP  	        48
+#define	INTERRUPT_SCPU_TIMER0  	    49
+#define	INTERRUPT_SCPU_TIMER1  	    50
+#define	INTERRUPT_SCPU_MISC_TOP_HIGH    51
+#define	INTERRUPT_SCPU_SE     	    52
+#define	INTERRUPT_SCPU_USB     	    53
+#define	INTERRUPT_SCPU_ETN          54
+#define INTERRUPT_SCPU_MIPI_CSI     55
+#define INTERRUPT_SCPU_GPU_GP       56
+#define INTERRUPT_SCPU_GPU_MMU      57
+#define INTERRUPT_SCPU_GPU_PP0      58
+#define INTERRUPT_SCPU_GPU_PPMMU0   59
+#define INTERRUPT_SCPU_GPU_PP1      60
+#define INTERRUPT_SCPU_GPU_PPMMU1   61
+#define INTERRUPT_SCPU_TVE          62
+#define INTERRUPT_SCPU_HDMI         63
+#define INTERRUPT_SCPU_PIF          64
+#define INTERRUPT_SCPU_AVCPU_NWC    65
+#define INTERRUPT_SCPU_CBUS         66
+#define INTERRUPT_SCPU_DCU          67
+#define INTERRUPT_SCPU_SB2          68
+#define INTERRUPT_SCPU_CP_NWC       69
+#define INTERRUPT_SCPU_MD_NWC       70
+#define INTERRUPT_SCPU_RTC          71
+#define INTERRUPT_SCPU_TOP          72
+#define INTERRUPT_SCPU_ISO          73
+#define INTERRUPT_SCPU_EMMC         74
+#define INTERRUPT_SCPU_NAND_NWC     75
+#define INTERRUPT_SCPU_CARDREADER   76
+#define INTERRUPT_SCPU_SDIO         77
+#define INTERRUPT_SCPU_MEM_TRASH    78
+#define INTERRUPT_SCPU_AXI_ERR      79
+#define INTERRUPT_SCPU_PMU0         80
+#define INTERRUPT_SCPU_PMU1          81
+#define INTERRUPT_SCPU_MEM_TRASH_NEG 82
+#define INTERRUPT_SCPU_VE            83
+#define IRQ_MAX_ID	           63
+
+
+/*
+const ULONG   INTERRUPT_SCPU_ATA0      = 0x00000004;
+const ULONG   INTERRUPT_SCPU_ATA1      = 0x00000004;
+const ULONG   INTERRUPT_SCPU_NAND      = INTERRUPT_SCPU_MCP;    //bit 25
+const ULONG   INTERRUPT_SCPU_MCP       = 0x00000200;    //bit  9
+const ULONG   INTERRUPT_SCPU_SE        = 0x00000100;    //bit  8
+const ULONG   INTERRUPT_SCPU_ACPU      = 0x00000001;    //bit  1
+const ULONG   INTERRUPT_SCPU_VCPU      = 0x00000002;    //bit  2
+const ULONG   INTERRUPT_SCPU_SB2       = 0x00000010;    //bit  4
+
+const ULONG   INTERRUPT_SCPU_1394      = 0x00000004;
+const ULONG   INTERRUPT_SCPU_USB       = 0x20000000;    //bit 29
+const ULONG   INTERRUPT_SCPU_ETN       = 0x10000000;    //bit 28
+const ULONG   INTERRUPT_SCPU_MISC      = 0x00080000;    //bit 19
+const ULONG   INTERRUPT_SCPU_MIS_TIMER = 0x00010000;    //bit 16
+const ULONG   INTERRUPT_SCPU_MIS_TIMER1= 0x00020000;    //bit 17
+const ULONG   INTERRUPT_SCPU_TIMER5    = 0x00000020;    //?????
+const ULONG   INTERRUPT_SCPU_MISC_RTC  = 0x00040000;    //bit 18
+const ULONG   INTERRUPT_SCPU_TP        = 0x40000000;    //bit 30
+const ULONG   INTERRUPT_SCPU_SDE       = 0x00000008;
+const ULONG   INTERRUPT_SCPU_MD        = 61;//0x00000400;		//INTERRUPT_MD_NWC;
+const ULONG   INTERRUPT_SCPU_PCI       = 0x00000001; */
+#else
+
+const ULONG   INTERRUPT_SCPU_ATA0      = 0x0004;
+const ULONG   INTERRUPT_SCPU_ATA1      = 0x0004;
+const ULONG   INTERRUPT_SCPU_NAND      = 0x0004;
+const ULONG   INTERRUPT_SCPU_MCP       = 0x0008;
+const ULONG   INTERRUPT_SCPU_SE        = 0x0008;
+const ULONG   INTERRUPT_SCPU_ACPU      = 0x0008;
+const ULONG   INTERRUPT_SCPU_VCPU      = 0x0008;
+const ULONG   INTERRUPT_SCPU_SB2       = 0x0008;
+
+const ULONG   INTERRUPT_SCPU_1394      = 0x0004;
+const ULONG   INTERRUPT_SCPU_USB       = 0x0001;
+const ULONG   INTERRUPT_SCPU_ETN       = 0x0001;
+const ULONG   INTERRUPT_SCPU_MISC      = 0x0002;
+const ULONG   INTERRUPT_SCPU_MIS_TIMER = 0x0010;
+const ULONG   INTERRUPT_SCPU_TIMER5    = 0x0020;
+const ULONG   INTERRUPT_SCPU_MISC_RTC  = 0x0020;
+const ULONG   INTERRUPT_SCPU_TP        = 0x0008;
+const ULONG   INTERRUPT_SCPU_SDE       = 0x0008;
+const ULONG   INTERRUPT_SCPU_MD        = 0x0008;
+const ULONG   INTERRUPT_SCPU_PCI       = 0x0001;
+#endif
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/iso_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/iso_reg.h
new file mode 100644
index 00000000..d778bcc
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/iso_reg.h
@@ -0,0 +1,11672 @@
+/**************************************************************
+// Spec Version                  : 0.41
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/8/1 21:17:43
+***************************************************************/
+
+
+#ifndef _ISO_REG_H_INCLUDED_
+#define _ISO_REG_H_INCLUDED_
+#ifdef  _ISO_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     cec_int:1;
+unsigned int     reserved_1:1;
+unsigned int     gpioda_int:1;
+unsigned int     gpioa_int:1;
+unsigned int     vfd_ardswda_int:1;
+unsigned int     vfd_ardswa_int:1;
+unsigned int     vfd_ardkpadda_int:1;
+unsigned int     vfd_ardkpada_int:1;
+unsigned int     vfd_wdone_int:1;
+unsigned int     rtc_alarm_int:1;
+unsigned int     rtc_hsec_int:1;
+unsigned int     reserved_2:1;
+unsigned int     i2c6_int:1;
+unsigned int     tc4_int:1;
+unsigned int     i2c0_int:1;
+unsigned int     wdog_nmi_int:1;
+unsigned int     reserved_3:1;
+unsigned int     irda_int:1;
+unsigned int     reserved_4:2;
+unsigned int     ur0_int:1;
+unsigned int     tc3_int:1;
+unsigned int     write_data:1;
+}ISO_ISR;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     gpioda_int:1;
+unsigned int     gpioa_int:1;
+unsigned int     vfd_ardswda_int:1;
+unsigned int     vfd_ardswa_int:1;
+unsigned int     vfd_ardkpadda_int:1;
+unsigned int     vfd_ardkpada_int:1;
+unsigned int     vfd_wdone_int:1;
+unsigned int     rtc_alarm_int:1;
+unsigned int     rtc_hsec_int:1;
+unsigned int     reserved_1:2;
+unsigned int     tc4_int:1;
+unsigned int     reserved_2:1;
+unsigned int     wdog_nmi_int:1;
+unsigned int     reserved_3:1;
+unsigned int     irda_int:1;
+unsigned int     reserved_4:3;
+unsigned int     tc3_int:1;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     int20_a:1;
+unsigned int     int19_a:1;
+unsigned int     int18_a:1;
+unsigned int     int17_a:1;
+unsigned int     int16_a:1;
+unsigned int     int15_a:1;
+unsigned int     int14_a:1;
+unsigned int     int13_a:1;
+unsigned int     int12_a:1;
+unsigned int     int11_a:1;
+unsigned int     int10_a:1;
+unsigned int     int9_a:1;
+unsigned int     int8_a:1;
+unsigned int     int7_a:1;
+unsigned int     int6_a:1;
+unsigned int     int5_a:1;
+unsigned int     int4_a:1;
+unsigned int     int3_a:1;
+unsigned int     int2_a:1;
+unsigned int     int1_a:1;
+unsigned int     int0_a:1;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_GPA;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     int20_da:1;
+unsigned int     int19_da:1;
+unsigned int     int18_da:1;
+unsigned int     int17_da:1;
+unsigned int     int16_da:1;
+unsigned int     int15_da:1;
+unsigned int     int14_da:1;
+unsigned int     int13_da:1;
+unsigned int     int12_da:1;
+unsigned int     int11_da:1;
+unsigned int     int10_da:1;
+unsigned int     int9_da:1;
+unsigned int     int8_da:1;
+unsigned int     int7_da:1;
+unsigned int     int6_da:1;
+unsigned int     int5_da:1;
+unsigned int     int4_da:1;
+unsigned int     int3_da:1;
+unsigned int     int2_da:1;
+unsigned int     int1_da:1;
+unsigned int     int0_da:1;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_GPDA;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     int47:1;
+unsigned int     int46:1;
+unsigned int     int45:1;
+unsigned int     int44:1;
+unsigned int     int43:1;
+unsigned int     int42:1;
+unsigned int     int41:1;
+unsigned int     int40:1;
+unsigned int     int39:1;
+unsigned int     int38:1;
+unsigned int     int37:1;
+unsigned int     int36:1;
+unsigned int     int35:1;
+unsigned int     int34:1;
+unsigned int     int33:1;
+unsigned int     int32:1;
+unsigned int     int31:1;
+unsigned int     int30:1;
+unsigned int     int29:1;
+unsigned int     int28:1;
+unsigned int     reserved_1:3;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_KPADAH;
+
+typedef struct 
+{
+unsigned int     int27:1;
+unsigned int     int26:1;
+unsigned int     int25:1;
+unsigned int     int24:1;
+unsigned int     int23:1;
+unsigned int     int22:1;
+unsigned int     int21:1;
+unsigned int     int20:1;
+unsigned int     int19:1;
+unsigned int     int18:1;
+unsigned int     int17:1;
+unsigned int     int16:1;
+unsigned int     int15:1;
+unsigned int     int14:1;
+unsigned int     int13:1;
+unsigned int     int12:1;
+unsigned int     int11:1;
+unsigned int     int10:1;
+unsigned int     int9:1;
+unsigned int     int8:1;
+unsigned int     int7:1;
+unsigned int     int6:1;
+unsigned int     int5:1;
+unsigned int     int4:1;
+unsigned int     int3:1;
+unsigned int     int2:1;
+unsigned int     int1:1;
+unsigned int     int0:1;
+unsigned int     reserved_0:3;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_KPADAL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     int47:1;
+unsigned int     int46:1;
+unsigned int     int45:1;
+unsigned int     int44:1;
+unsigned int     int43:1;
+unsigned int     int42:1;
+unsigned int     int41:1;
+unsigned int     int40:1;
+unsigned int     int39:1;
+unsigned int     int38:1;
+unsigned int     int37:1;
+unsigned int     int36:1;
+unsigned int     int35:1;
+unsigned int     int34:1;
+unsigned int     int33:1;
+unsigned int     int32:1;
+unsigned int     int31:1;
+unsigned int     int30:1;
+unsigned int     int29:1;
+unsigned int     int28:1;
+unsigned int     reserved_1:3;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_KPADDAH;
+
+typedef struct 
+{
+unsigned int     int27:1;
+unsigned int     int26:1;
+unsigned int     int25:1;
+unsigned int     int24:1;
+unsigned int     int23:1;
+unsigned int     int22:1;
+unsigned int     int21:1;
+unsigned int     int20:1;
+unsigned int     int19:1;
+unsigned int     int18:1;
+unsigned int     int17:1;
+unsigned int     int16:1;
+unsigned int     int15:1;
+unsigned int     int14:1;
+unsigned int     int13:1;
+unsigned int     int12:1;
+unsigned int     int11:1;
+unsigned int     int10:1;
+unsigned int     int9:1;
+unsigned int     int8:1;
+unsigned int     int7:1;
+unsigned int     int6:1;
+unsigned int     int5:1;
+unsigned int     int4:1;
+unsigned int     int3:1;
+unsigned int     int2:1;
+unsigned int     int1:1;
+unsigned int     int0:1;
+unsigned int     reserved_0:3;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_KPADDAL;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     da_int3:1;
+unsigned int     da_int2:1;
+unsigned int     da_int1:1;
+unsigned int     da_int0:1;
+unsigned int     a_int3:1;
+unsigned int     a_int2:1;
+unsigned int     a_int1:1;
+unsigned int     a_int0:1;
+unsigned int     reserved_1:3;
+unsigned int     write_data:1;
+}ISO_UMSK_ISR_SW;
+
+typedef struct 
+{
+unsigned int     write_en5:1;
+unsigned int     standby_dbg_sel:7;
+unsigned int     write_en4:1;
+unsigned int     reserved_0:2;
+unsigned int     standby_dbg_en:1;
+unsigned int     write_en3:1;
+unsigned int     reserved_1:3;
+unsigned int     sel1:4;
+unsigned int     write_en2:1;
+unsigned int     reserved_2:3;
+unsigned int     sel0:4;
+unsigned int     write_en1:1;
+unsigned int     reserved_3:2;
+unsigned int     enable:1;
+}ISO_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     testmode:1;
+unsigned int     boot_sel:1;
+unsigned int     bound_opt:13;
+}ISO_CHIP_INFO1;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     pow_latch:19;
+}ISO_CHIP_INFO2;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_en9:1;
+unsigned int     iso_rst_wd_mask:1;
+unsigned int     write_en8:1;
+unsigned int     dc_phy_cke_pd:1;
+unsigned int     write_en7:1;
+unsigned int     iso_mis_clk_en:1;
+unsigned int     write_en6:1;
+unsigned int     iso_rbus_sel:1;
+unsigned int     write_en5:1;
+unsigned int     iso_rst_mask:1;
+unsigned int     write_en4:1;
+unsigned int     clk_osc_on_en:1;
+unsigned int     write_en3:1;
+unsigned int     crt_sw_rstn:1;
+unsigned int     write_en2:1;
+unsigned int     iso_clk_sel:1;
+unsigned int     write_en1:1;
+unsigned int     ejtag_en:1;
+}ISO_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     hsec_int_en:1;
+unsigned int     alarm_int_en:1;
+}ISO_RTC;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     bi_bypass:1;
+unsigned int     iso_ctrl_en1:1;
+unsigned int     iso_ctrl_en0:1;
+}ISO_CELL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     top_vdd_on:1;
+unsigned int     scpu_vdd_on:1;
+}ISO_POWER;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     cec:1;
+unsigned int     reserved_1:1;
+unsigned int     gpioda:1;
+unsigned int     gpioa:1;
+unsigned int     vfd_ardswda:1;
+unsigned int     vfd_ardswa:1;
+unsigned int     vfd_ardkpadda:1;
+unsigned int     vfd_ardkpada:1;
+unsigned int     vfd_wdone:1;
+unsigned int     rtc_alarm:1;
+unsigned int     rtc_hsec:1;
+unsigned int     reserved_2:1;
+unsigned int     i2c6:1;
+unsigned int     reserved_3:1;
+unsigned int     i2c0:1;
+unsigned int     reserved_4:2;
+unsigned int     irda:1;
+unsigned int     reserved_5:2;
+unsigned int     ur0:1;
+unsigned int     reserved_6:2;
+}ISO_SCPU_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     dcp_ctrl1:1;
+unsigned int     dcp_ctrl0:1;
+}ISO_USB;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     cec:1;
+unsigned int     reserved_1:1;
+unsigned int     gpioda:1;
+unsigned int     gpioa:1;
+unsigned int     vfd_ardswda:1;
+unsigned int     vfd_ardswa:1;
+unsigned int     vfd_ardkpadda:1;
+unsigned int     vfd_ardkpada:1;
+unsigned int     vfd_wdone:1;
+unsigned int     rtc_alarm:1;
+unsigned int     rtc_hsec:1;
+unsigned int     reserved_2:1;
+unsigned int     i2c6:1;
+unsigned int     reserved_3:1;
+unsigned int     i2c0:1;
+unsigned int     reserved_4:2;
+unsigned int     irda:1;
+unsigned int     reserved_5:2;
+unsigned int     ur0:1;
+unsigned int     reserved_6:2;
+}ISO_ACPU_INT_EN;
+
+typedef struct 
+{
+unsigned int     acpu_boot_info:32;
+}ISO_CPU_ST1;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     acpu_boot_info_valid:1;
+}ISO_CPU_ST1V;
+
+typedef struct 
+{
+unsigned int     rvd31:1;
+unsigned int     rvd30:1;
+unsigned int     rvd29:1;
+unsigned int     rvd28:1;
+unsigned int     rvd27:1;
+unsigned int     rvd26:1;
+unsigned int     rvd25:1;
+unsigned int     rvd24:1;
+unsigned int     rvd23:1;
+unsigned int     rvd22:1;
+unsigned int     rvd21:1;
+unsigned int     rvd20:1;
+unsigned int     rvd19:1;
+unsigned int     rvd18:1;
+unsigned int     rvd17:1;
+unsigned int     rvd16:1;
+unsigned int     rvd15:1;
+unsigned int     rvd14:1;
+unsigned int     rvd13:1;
+unsigned int     rvd12:1;
+unsigned int     rvd11:1;
+unsigned int     rvd10:1;
+unsigned int     rvd9:1;
+unsigned int     rvd8:1;
+unsigned int     rvd7:1;
+unsigned int     rvd6:1;
+unsigned int     rvd5:1;
+unsigned int     rvd4:1;
+unsigned int     rvd3:1;
+unsigned int     rvd2:1;
+unsigned int     rvd1:1;
+unsigned int     rvd0:1;
+}ISO_DUMMY1;
+
+typedef struct 
+{
+unsigned int     rvd31:1;
+unsigned int     rvd30:1;
+unsigned int     rvd29:1;
+unsigned int     rvd28:1;
+unsigned int     rvd27:1;
+unsigned int     rvd26:1;
+unsigned int     rvd25:1;
+unsigned int     rvd24:1;
+unsigned int     rvd23:1;
+unsigned int     rvd22:1;
+unsigned int     rvd21:1;
+unsigned int     rvd20:1;
+unsigned int     rvd19:1;
+unsigned int     rvd18:1;
+unsigned int     rvd17:1;
+unsigned int     rvd16:1;
+unsigned int     rvd15:1;
+unsigned int     rvd14:1;
+unsigned int     rvd13:1;
+unsigned int     rvd12:1;
+unsigned int     rvd11:1;
+unsigned int     rvd10:1;
+unsigned int     rvd9:1;
+unsigned int     rvd8:1;
+unsigned int     rvd7:1;
+unsigned int     rvd6:1;
+unsigned int     rvd5:1;
+unsigned int     rvd4:1;
+unsigned int     rvd3:1;
+unsigned int     rvd2:1;
+unsigned int     rvd1:1;
+unsigned int     rvd0:1;
+}ISO_DUMMY2;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     powercut_ana_d2a_isolate_b:1;
+unsigned int     powercut_ana_a2d_isolate_b:1;
+}ISO_POWERCUT_ETN;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     etn_bpsgphy_mode:1;
+unsigned int     etn_ocd_mode:1;
+}ISO_ETN_TESTIO;
+
+typedef struct 
+{
+unsigned int     dmy:32;
+}ISO_RESERVED_USE_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     ir_tx:1;
+unsigned int     ir_raw:1;
+}ISO_LPI;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     cnt_wait_pwr:16;
+}ISO_WD;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     plletn_wdout:1;
+}ISO_PLL_WDOUT;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     plletn_oeb:1;
+unsigned int     plletn_rstb:1;
+unsigned int     plletn_o:4;
+unsigned int     plletn_m:7;
+unsigned int     plletn_ldo_pow:1;
+unsigned int     plletn_pow:1;
+unsigned int     plletn_ldo_sel:2;
+unsigned int     plletn_wdmode:2;
+unsigned int     plletn_n:2;
+unsigned int     plletn_lf_rs:2;
+unsigned int     plletn_lf_cp:2;
+unsigned int     plletn_ip:3;
+}ISO_PLL_ETN;
+
+typedef struct 
+{
+unsigned int     dmy:32;
+}ISO_RESERVED_USE_1;
+
+typedef struct 
+{
+unsigned int     dmy:32;
+}ISO_RESERVED_USE_2;
+
+typedef struct 
+{
+unsigned int     dmy:32;
+}ISO_RESERVED_USE_3;
+
+typedef struct 
+{
+unsigned int     dmy1:20;
+unsigned int     reserved_0:3;
+unsigned int     en:1;
+unsigned int     reserved_1:3;
+unsigned int     sel:5;
+}ISO_I2C0_SDA_DEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     rstn_cbus:1;
+unsigned int     rstn_i2c_6:1;
+unsigned int     rstn_i2c_0:1;
+unsigned int     rstn_gphy:1;
+unsigned int     rstn_gmac:1;
+unsigned int     rstn_ur0:1;
+unsigned int     rstn_efuse:1;
+unsigned int     rstn_cbusrx:1;
+unsigned int     rstn_cbustx:1;
+unsigned int     rstn_dp:1;
+unsigned int     rstn_cec1:1;
+unsigned int     rstn_cec0:1;
+unsigned int     rstn_ir:1;
+unsigned int     rstn_vfd:1;
+}ISO_SOFT_RESET;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     clk_en_etn_sys:1;
+unsigned int     clk_en_etn_250m:1;
+unsigned int     clk_en_i2c6:1;
+unsigned int     clk_en_i2c0:1;
+unsigned int     clk_en_misc_ur0:1;
+unsigned int     clk_en_misc_ir:1;
+unsigned int     clk_en_cbus_osc:1;
+unsigned int     clk_en_cbus_sys:1;
+unsigned int     clk_en_cbustx_sys:1;
+unsigned int     clk_en_cbusrx_sys:1;
+unsigned int     clk_en_misc_cec0:1;
+unsigned int     clk_en_misc_vfd:1;
+unsigned int     clk_en_misc_mix:1;
+}ISO_CLOCK_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     rd_only_0_en:1;
+unsigned int     reserved_1:2;
+unsigned int     blk_protect_0_wpro_en:1;
+unsigned int     reserved_2:2;
+unsigned int     blk_protect_0_en:1;
+unsigned int     reserved_3:8;
+unsigned int     protect_0_wpro_en:1;
+unsigned int     reserved_4:8;
+unsigned int     protect_0_en:1;
+}ISO_DC_0;
+
+typedef struct 
+{
+unsigned int     mem_saddr0:20;
+unsigned int     reserved_0:12;
+}ISO_DC_1;
+
+typedef struct 
+{
+unsigned int     mem_eaddr0:20;
+unsigned int     reserved_0:12;
+}ISO_DC_2;
+
+typedef struct 
+{
+unsigned int     blk_saddr0:20;
+unsigned int     reserved_0:12;
+}ISO_DC_3;
+
+typedef struct 
+{
+unsigned int     blk_eaddr0:20;
+unsigned int     reserved_0:12;
+}ISO_DC_4;
+
+typedef struct 
+{
+unsigned int     ro_saddr0:20;
+unsigned int     reserved_0:12;
+}ISO_DC_5;
+
+typedef struct 
+{
+unsigned int     ro_eaddr0:20;
+unsigned int     reserved_0:12;
+}ISO_DC_6;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     md_tee_protect_en:1;
+unsigned int     reserved_1:7;
+unsigned int     cp_tee_protect_en:1;
+unsigned int     reserved_2:7;
+unsigned int     vo_protect_en:1;
+unsigned int     reserved_3:7;
+unsigned int     nf_tee_protect_en:1;
+}ISO_DC_7;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     scpu_tee_protect_en:1;
+unsigned int     reserved_1:7;
+unsigned int     acpu_protect_en:1;
+unsigned int     reserved_2:7;
+unsigned int     video_protect_en:1;
+unsigned int     reserved_3:7;
+unsigned int     audio_protect_en:1;
+}ISO_DC_8;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     scpu_tee_blk_protect_en:1;
+unsigned int     reserved_1:1;
+unsigned int     acpu_blk_protect_en:1;
+unsigned int     reserved_2:1;
+unsigned int     video_blk_protect_en:1;
+unsigned int     reserved_3:1;
+unsigned int     audio_blk_protect_en:1;
+unsigned int     reserved_4:1;
+unsigned int     md_tee_blk_protect_en:1;
+unsigned int     reserved_5:1;
+unsigned int     cp_tee_blk_protect_en:1;
+unsigned int     reserved_6:1;
+unsigned int     vo_blk_protect_en:1;
+unsigned int     reserved_7:1;
+unsigned int     nf_tee_blk_protect_en:1;
+}ISO_DC_9;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     scpu_tee_ro_protect_en:1;
+unsigned int     reserved_1:3;
+unsigned int     acpu_ro_protect_en:1;
+unsigned int     reserved_2:3;
+unsigned int     video_ro_protect_en:1;
+unsigned int     reserved_3:3;
+unsigned int     audio_ro_protect_en:1;
+unsigned int     reserved_4:3;
+unsigned int     md_tee_ro_protect_en:1;
+unsigned int     reserved_5:3;
+unsigned int     cp_tee_ro_protect_en:1;
+unsigned int     reserved_6:3;
+unsigned int     vo_ro_protect_en:1;
+unsigned int     reserved_7:3;
+unsigned int     nf_tee_ro_protect_en:1;
+}ISO_DC_A;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     xtal_pad_drv:2;
+}ISO_PLL_XTAL_CTRL;
+
+typedef struct 
+{
+unsigned int     dmy1:20;
+unsigned int     reserved_0:3;
+unsigned int     en:1;
+unsigned int     reserved_1:3;
+unsigned int     sel:5;
+}ISO_I2C6_SDA_DEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     int_option:1;
+}ISO_HDMI_RX;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     i2c6_mis_mux:1;
+}ISO_I2C6_MUX;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     usb2sram_ctrl:1;
+unsigned int     ve_encode_block_nwc:1;
+unsigned int     ve_block_nwc:1;
+unsigned int     vo_block_nwc:1;
+unsigned int     dc_mem_port_lock:1;
+unsigned int     secure_rbus:1;
+}ISO_SB2_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     gpdir:21;
+}ISO_GPDIR;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     gpdato:21;
+}ISO_GPDATO;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     gpdati:21;
+}ISO_GPDATI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     gp:21;
+}ISO_GPIE;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     gpha:21;
+}ISO_GPDP;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     write_en1:1;
+unsigned int     clk1:3;
+}ISO_GPDEB;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     kpaden:1;
+unsigned int     swen:1;
+unsigned int     clksel:1;
+unsigned int     envfd:1;
+}ISO_VFD_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     nact_csn:1;
+unsigned int     b3c:1;
+unsigned int     b2c:1;
+unsigned int     b1c:1;
+unsigned int     b0c:1;
+unsigned int     enb3:1;
+unsigned int     enb2:1;
+unsigned int     enb1:1;
+unsigned int     enb0:1;
+unsigned int     reserved_1:2;
+unsigned int     wd:1;
+unsigned int     wdie:1;
+}ISO_VFD_WRCTL;
+
+typedef struct 
+{
+unsigned int     byte3:8;
+unsigned int     byte2:8;
+unsigned int     byte1:8;
+unsigned int     byte0:8;
+}ISO_VFDO;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     kpadbn:3;
+unsigned int     reserved_1:2;
+unsigned int     swha:1;
+unsigned int     kpadha:1;
+unsigned int     reserved_2:2;
+unsigned int     ardp:2;
+}ISO_VFD_ARDCTL;
+
+typedef struct 
+{
+unsigned int     kpadie:32;
+}ISO_VFD_KPADLIE;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     kpadie:16;
+}ISO_VFD_KPADHIE;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     swie:4;
+}ISO_VFD_SWIE;
+
+typedef struct 
+{
+unsigned int     st_31_24:8;
+unsigned int     st_23_16:8;
+unsigned int     st_15_8:8;
+unsigned int     st_7_0:8;
+}ISO_VFD_ARDKPADL;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     st_15_8:8;
+unsigned int     st_7_0:8;
+}ISO_VFD_ARDKPADH;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     rvda:12;
+unsigned int     st:4;
+}ISO_VFD_ARDSW;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     clksel_1:1;
+unsigned int     tclk_csn:8;
+unsigned int     twait1:8;
+}ISO_VFD_CTL1;
+
+typedef struct 
+{
+unsigned int     i2c_scl_0_smt:1;
+unsigned int     i2c_scl_0_e2:1;
+unsigned int     i2c_scl_0_pud_en:1;
+unsigned int     i2c_scl_0_pud_sel:1;
+unsigned int     i2c_sda_0_smt:1;
+unsigned int     i2c_sda_0_e2:1;
+unsigned int     i2c_sda_0_pud_en:1;
+unsigned int     i2c_sda_0_pud_sel:1;
+unsigned int     vfd_d_smt:1;
+unsigned int     vfd_d_e2:1;
+unsigned int     vfd_d_pud_en:1;
+unsigned int     vfd_d_pud_sel:1;
+unsigned int     vfd_clk_smt:1;
+unsigned int     vfd_clk_e2:1;
+unsigned int     vfd_clk_pud_en:1;
+unsigned int     vfd_clk_pud_sel:1;
+unsigned int     vfd_cs_n_smt:1;
+unsigned int     vfd_cs_n_e2:1;
+unsigned int     vfd_cs_n_pud_en:1;
+unsigned int     vfd_cs_n_pud_sel:1;
+unsigned int     ir_rx_smt:1;
+unsigned int     ir_rx_e2:1;
+unsigned int     ir_rx_pud_en:1;
+unsigned int     ir_rx_pud_sel:1;
+unsigned int     usb_ovrcur_flag_n_1_smt:1;
+unsigned int     usb_ovrcur_flag_n_1_e2:1;
+unsigned int     usb_ovrcur_flag_n_1_pud_en:1;
+unsigned int     usb_ovrcur_flag_n_1_pud_sel:1;
+unsigned int     usb_ovrcur_flag_n_0_smt:1;
+unsigned int     usb_ovrcur_flag_n_0_e2:1;
+unsigned int     usb_ovrcur_flag_n_0_pud_en:1;
+unsigned int     usb_ovrcur_flag_n_0_pud_sel:1;
+}ISO_PFUNC0;
+
+typedef struct 
+{
+unsigned int     etn_led_rxtx_smt:1;
+unsigned int     etn_led_rxtx_e2:1;
+unsigned int     etn_led_rxtx_pud_en:1;
+unsigned int     etn_led_rxtx_pud_sel:1;
+unsigned int     etn_led_link_smt:1;
+unsigned int     etn_led_link_e2:1;
+unsigned int     etn_led_link_pud_en:1;
+unsigned int     etn_led_link_pud_sel:1;
+unsigned int     ur0_tx_smt:1;
+unsigned int     ur0_tx_e2:1;
+unsigned int     ur0_tx_pud_en:1;
+unsigned int     ur0_tx_pud_sel:1;
+unsigned int     ur0_rx_smt:1;
+unsigned int     ur0_rx_e2:1;
+unsigned int     ur0_rx_pud_en:1;
+unsigned int     ur0_rx_pud_sel:1;
+unsigned int     ur1_cts_n_smt:1;
+unsigned int     ur1_cts_n_e2:1;
+unsigned int     ur1_cts_n_pud_en:1;
+unsigned int     ur1_cts_n_pud_sel:1;
+unsigned int     ur1_rts_n_smt:1;
+unsigned int     ur1_rts_n_e2:1;
+unsigned int     ur1_rts_n_pud_en:1;
+unsigned int     ur1_rts_n_pud_sel:1;
+unsigned int     ur1_tx_smt:1;
+unsigned int     ur1_tx_e2:1;
+unsigned int     ur1_tx_pud_en:1;
+unsigned int     ur1_tx_pud_sel:1;
+unsigned int     ur1_rx_smt:1;
+unsigned int     ur1_rx_e2:1;
+unsigned int     ur1_rx_pud_en:1;
+unsigned int     ur1_rx_pud_sel:1;
+}ISO_PFUNC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ir_tx_smt:1;
+unsigned int     ir_tx_e2:1;
+unsigned int     ir_tx_pud_en:1;
+unsigned int     ir_tx_pud_sel:1;
+unsigned int     i2c_scl_6_smt:1;
+unsigned int     i2c_scl_6_e2:1;
+unsigned int     i2c_scl_6_pud_en:1;
+unsigned int     i2c_scl_6_pud_sel:1;
+unsigned int     i2c_sda_6_smt:1;
+unsigned int     i2c_sda_6_e2:1;
+unsigned int     i2c_sda_6_pud_en:1;
+unsigned int     i2c_sda_6_pud_sel:1;
+unsigned int     boot_sel_pud_en:1;
+unsigned int     boot_sel_pud_sel:1;
+unsigned int     testmode_pud_en:1;
+unsigned int     testmode_pud_sel:1;
+unsigned int     standby1_smt:1;
+unsigned int     standby1_e2:1;
+unsigned int     standby1_pud_en:1;
+unsigned int     standby1_pud_sel:1;
+unsigned int     standby_smt:1;
+unsigned int     standby_e2:1;
+unsigned int     standby_pud_en:1;
+unsigned int     standby_pud_sel:1;
+}ISO_PFUNC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     boption12_en:1;
+unsigned int     boption12_sel:1;
+unsigned int     boption11_en:1;
+unsigned int     boption11_sel:1;
+unsigned int     boption10_en:1;
+unsigned int     boption10_sel:1;
+unsigned int     boption2_en:1;
+unsigned int     boption2_sel:1;
+}ISO_PFUNC3;
+
+typedef struct 
+{
+unsigned int     etn_led_rxtx:2;
+unsigned int     etn_led_link:2;
+unsigned int     i2c_sda_0:2;
+unsigned int     i2c_scl_0:2;
+unsigned int     ur0_tx:2;
+unsigned int     ur0_rx:2;
+unsigned int     ur1_cts_n:2;
+unsigned int     ur1_rts_n:2;
+unsigned int     ur1_tx:2;
+unsigned int     ur1_rx:2;
+unsigned int     usb1:2;
+unsigned int     usb0:2;
+unsigned int     ir_rx:2;
+unsigned int     vfd_cs_n:2;
+unsigned int     vfd_clk:2;
+unsigned int     vfd_d:2;
+}ISO_MUXPAD0;
+
+typedef struct 
+{
+unsigned int     ai_loc:2;
+unsigned int     ejtag_avcpu_loc:2;
+unsigned int     ur1_loc:2;
+unsigned int     pwm_01_open_drain_switch:1;
+unsigned int     pwm_23_open_drain_switch:1;
+unsigned int     reserved_0:18;
+unsigned int     ir_tx:2;
+unsigned int     i2c_sda_6:2;
+unsigned int     i2c_scl_6:2;
+}ISO_MUXPAD1;
+
+typedef struct 
+{
+unsigned int     irrbl:8;
+unsigned int     irrml:8;
+unsigned int     irrdzl:8;
+unsigned int     irrdol:8;
+}ISO_IR_PSR;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     irrdl:6;
+unsigned int     irrrl:8;
+unsigned int     irrsl:8;
+}ISO_IR_PER;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     irfd:16;
+}ISO_IR_SF;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     iriotcdp:16;
+}ISO_IR_DPIR;
+
+typedef struct 
+{
+unsigned int     irsr:1;
+unsigned int     reserved_0:5;
+unsigned int     rcmm_en:1;
+unsigned int     toshiba_en:1;
+unsigned int     irednm:1;
+unsigned int     reserved_1:1;
+unsigned int     iredn:6;
+unsigned int     reserved_2:1;
+unsigned int     raw_fifo_ov:1;
+unsigned int     raw_fifo_val:1;
+unsigned int     raw_en:1;
+unsigned int     mlae:1;
+unsigned int     irie:1;
+unsigned int     irres:1;
+unsigned int     irue:1;
+unsigned int     ircm:1;
+unsigned int     irbme:1;
+unsigned int     irdpm:1;
+unsigned int     irdn:5;
+}ISO_IR_CR;
+
+typedef struct 
+{
+unsigned int     irrp:32;
+}ISO_IR_RP;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     slen_big:1;
+unsigned int     blen_big:1;
+unsigned int     raw_fifo_ov:1;
+unsigned int     raw_fifo_val:1;
+unsigned int     irrf:1;
+unsigned int     irdvf:1;
+}ISO_IR_SR;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     stop_sample:1;
+unsigned int     stop_time:16;
+unsigned int     reserved_1:1;
+unsigned int     write_en1:1;
+unsigned int     fifo_thr:6;
+}ISO_IR_RAW_CTRL;
+
+typedef struct 
+{
+unsigned int     dat:32;
+}ISO_IR_RAW_FF;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     cnt:16;
+}ISO_IR_RAW_SAMPLE_TIME;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     val:6;
+}ISO_IR_RAW_WL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     len:8;
+unsigned int     clk:16;
+}ISO_IR_RAW_DEB;
+
+typedef struct 
+{
+unsigned int     irrbl:8;
+unsigned int     irrml:8;
+unsigned int     irrdzl:8;
+unsigned int     irrdol:8;
+}ISO_IR_PSR_UP;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     irrrl:8;
+unsigned int     irrsl:8;
+}ISO_IR_PER_UP;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     rc6_en:1;
+unsigned int     irtr:8;
+}ISO_IR_CTRL_RC6;
+
+typedef struct 
+{
+unsigned int     irrp:32;
+}ISO_IR_RP2;
+
+typedef struct 
+{
+unsigned int     irtx_en:1;
+unsigned int     reserved_0:20;
+unsigned int     iact_lvl:1;
+unsigned int     modulation:1;
+unsigned int     endian:1;
+unsigned int     dummy:2;
+unsigned int     fifoout_inv:1;
+unsigned int     irtxout_inv:1;
+unsigned int     reserved_1:3;
+unsigned int     start:1;
+}ISO_IRTX_CFG;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     irtx_fd:16;
+}ISO_IRTX_TIM;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     pwm_clksrc_div:4;
+unsigned int     pwm_clk_duty:8;
+unsigned int     pwm_clk_div:8;
+}ISO_IRTX_PWM_SETTING;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     data_thr:6;
+unsigned int     reserved_1:5;
+unsigned int     fin_en:1;
+unsigned int     emp_en:1;
+unsigned int     req_en:1;
+}ISO_IRTX_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     fin_flag:1;
+unsigned int     emp_flag:1;
+unsigned int     req_flag:1;
+}ISO_IRTX_INT_ST;
+
+typedef struct 
+{
+unsigned int     fifo_rst:1;
+unsigned int     reserved_0:19;
+unsigned int     valid_len:4;
+unsigned int     wrp:4;
+unsigned int     rdp:4;
+}ISO_IRTX_FIFO_ST;
+
+typedef struct 
+{
+unsigned int     data:32;
+}ISO_IRTX_FIFO;
+
+typedef struct 
+{
+unsigned int     len_11:8;
+unsigned int     len_10:8;
+unsigned int     len_01:8;
+unsigned int     len_00:8;
+}ISO_IRRCMM_TIMING;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     dec_by_min_max:1;
+}ISO_IR_CR1;
+
+typedef struct 
+{
+unsigned int     rcmm_ap_max:8;
+unsigned int     rcmm_ap_min:8;
+unsigned int     rcmm_kb_max:8;
+unsigned int     rcmm_kb_min:8;
+}ISO_IRRCMM_APKB;
+
+typedef struct 
+{
+unsigned int     rcmm_apoint:1;
+unsigned int     rcmm_kboard:1;
+unsigned int     remote_cnt_lead_high:14;
+unsigned int     remote_cnt_lead_low:16;
+}ISO_IRRXRCLFIFO;
+
+typedef struct 
+{
+unsigned int     cec_mode:2;
+unsigned int     reserved_0:1;
+unsigned int     test_mode_pad_en:1;
+unsigned int     logical_addr0:4;
+unsigned int     timer_div:8;
+unsigned int     pre_div:8;
+unsigned int     unreg_ack_en:1;
+unsigned int     reserved_1:1;
+unsigned int     cdc_arbitration_en:1;
+unsigned int     test_mode_pad_data:5;
+}ISO_CEC_CR0;
+
+typedef struct 
+{
+unsigned int     cec_pad_in:1;
+unsigned int     dummy0:3;
+unsigned int     logical_addr3:4;
+unsigned int     logical_addr2:4;
+unsigned int     logical_addr1:4;
+unsigned int     dummy1:4;
+unsigned int     clear_cec_int:1;
+unsigned int     wt_cnt:6;
+unsigned int     lattest:1;
+unsigned int     retry_no:4;
+}ISO_CEC_RTCR0;
+
+typedef struct 
+{
+unsigned int     broadcast_addr:1;
+unsigned int     reserved_0:11;
+unsigned int     dest_addr:4;
+unsigned int     rx_en:1;
+unsigned int     rx_rst:1;
+unsigned int     rx_continuous:1;
+unsigned int     rx_int_en:1;
+unsigned int     init_addr:4;
+unsigned int     rx_eom:1;
+unsigned int     rx_int:1;
+unsigned int     rx_fifo_ov:1;
+unsigned int     rx_fifo_cnt:5;
+}ISO_CEC_RXCR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     tx_addr_en:1;
+unsigned int     tx_addr:4;
+unsigned int     tx_en:1;
+unsigned int     tx_rst:1;
+unsigned int     tx_continuous:1;
+unsigned int     tx_int_en:1;
+unsigned int     dest_addr:4;
+unsigned int     tx_eom:1;
+unsigned int     tx_int:1;
+unsigned int     tx_fifo_ud:1;
+unsigned int     tx_fifo_cnt:5;
+}ISO_CEC_TXCR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     tx_add_cnt:1;
+unsigned int     rx_sub_cnt:1;
+unsigned int     fifo_cnt:5;
+}ISO_CEC_TXDR0;
+
+typedef struct 
+{
+unsigned int     tx_fifo_0:8;
+unsigned int     tx_fifo_1:8;
+unsigned int     tx_fifo_2:8;
+unsigned int     tx_fifo_3:8;
+}ISO_CEC_TXDR1;
+
+typedef struct 
+{
+unsigned int     tx_fifo_4:8;
+unsigned int     tx_fifo_5:8;
+unsigned int     tx_fifo_6:8;
+unsigned int     tx_fifo_7:8;
+}ISO_CEC_TXDR2;
+
+typedef struct 
+{
+unsigned int     tx_fifo_8:8;
+unsigned int     tx_fifo_9:8;
+unsigned int     tx_fifo_a:8;
+unsigned int     tx_fifo_b:8;
+}ISO_CEC_TXDR3;
+
+typedef struct 
+{
+unsigned int     tx_fifo_c:8;
+unsigned int     tx_fifo_d:8;
+unsigned int     tx_fifo_e:8;
+unsigned int     tx_fifo_f:8;
+}ISO_CEC_TXDR4;
+
+typedef struct 
+{
+unsigned int     rx_fifo_0:8;
+unsigned int     rx_fifo_1:8;
+unsigned int     rx_fifo_2:8;
+unsigned int     rx_fifo_3:8;
+}ISO_CEC_RXDR1;
+
+typedef struct 
+{
+unsigned int     rx_fifo_4:8;
+unsigned int     rx_fifo_5:8;
+unsigned int     rx_fifo_6:8;
+unsigned int     rx_fifo_7:8;
+}ISO_CEC_RXDR2;
+
+typedef struct 
+{
+unsigned int     rx_fifo_8:8;
+unsigned int     rx_fifo_9:8;
+unsigned int     rx_fifo_a:8;
+unsigned int     rx_fifo_b:8;
+}ISO_CEC_RXDR3;
+
+typedef struct 
+{
+unsigned int     rx_fifo_c:8;
+unsigned int     rx_fifo_d:8;
+unsigned int     rx_fifo_e:8;
+unsigned int     rx_fifo_f:8;
+}ISO_CEC_RXDR4;
+
+typedef struct 
+{
+unsigned int     rx_start_low:8;
+unsigned int     rx_start_period:8;
+unsigned int     rx_data_sample:8;
+unsigned int     rx_data_period:8;
+}ISO_CEC_RXTCR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     tx_start_low:8;
+unsigned int     tx_start_high:8;
+}ISO_CEC_TXTCR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tx_data_low:8;
+unsigned int     tx_data_01:8;
+unsigned int     tx_data_high:8;
+}ISO_CEC_TXTCR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_01:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_01;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     send_opcode_01:8;
+}ISO_GDI_CEC_SEND_OPCODE_01;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     operand_number_01:2;
+}ISO_GDI_CEC_SEND_OPRAND_NUMBER_01;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_01:8;
+}ISO_GDI_CEC_OPRAND_01;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_02:8;
+}ISO_GDI_CEC_OPRAND_02;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_03:8;
+}ISO_GDI_CEC_OPRAND_03;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_02:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_02;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     send_opcode_02:8;
+}ISO_GDI_CEC_SEND_OPCODE_02;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     operand_number_02:2;
+}ISO_GDI_CEC_SEND_OPRAND_NUMBER_02;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_04:8;
+}ISO_GDI_CEC_OPRAND_04;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_05:8;
+}ISO_GDI_CEC_OPRAND_05;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_06:8;
+}ISO_GDI_CEC_OPRAND_06;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_03:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_03;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     send_opcode_03:8;
+}ISO_GDI_CEC_SEND_OPCODE_03;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     operand_number_03:2;
+}ISO_GDI_CEC_SEND_OPRAND_NUMBER_03;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_07:8;
+}ISO_GDI_CEC_OPRAND_07;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_08:8;
+}ISO_GDI_CEC_OPRAND_08;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_09:8;
+}ISO_GDI_CEC_OPRAND_09;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_04:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_04;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     send_opcode_04:8;
+}ISO_GDI_CEC_SEND_OPCODE_04;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     operand_number_04:2;
+}ISO_GDI_CEC_SEND_OPRAND_NUMBER_04;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_10:8;
+}ISO_GDI_CEC_OPRAND_10;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_11:8;
+}ISO_GDI_CEC_OPRAND_11;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     operand_12:8;
+}ISO_GDI_CEC_OPRAND_12;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_05:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_05;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_06:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_06;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_07:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_07;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_08:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_08;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_09:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_09;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_10:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_10;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_11:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_11;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_12:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_12;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_13:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_13;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_14:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_14;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     compare_opcode_15:8;
+}ISO_GDI_CEC_COMPARE_OPCODE_15;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     en_compare_opcode_15:1;
+unsigned int     en_compare_opcode_14:1;
+unsigned int     en_compare_opcode_13:1;
+unsigned int     en_compare_opcode_12:1;
+unsigned int     en_compare_opcode_11:1;
+unsigned int     en_compare_opcode_10:1;
+unsigned int     en_compare_opcode_09:1;
+unsigned int     en_compare_opcode_08:1;
+unsigned int     en_compare_opcode_07:1;
+unsigned int     en_compare_opcode_06:1;
+unsigned int     en_compare_opcode_05:1;
+unsigned int     en_compare_opcode_04:1;
+unsigned int     en_compare_opcode_03:1;
+unsigned int     en_compare_opcode_02:1;
+unsigned int     en_compare_opcode_01:1;
+}ISO_GDI_CEC_OPCODE_ENABLE;
+
+typedef struct 
+{
+unsigned int     irq_pending:1;
+unsigned int     reserved_0:5;
+unsigned int     cec_msg_status_01:1;
+unsigned int     cec_msg_status_02:1;
+unsigned int     reserved_1:15;
+unsigned int     irq_by_cec_receive_special_cmd:1;
+unsigned int     reserved_2:8;
+}ISO_GDI_POWER_SAVING_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     reg_cec_rpu_en:1;
+unsigned int     reg_cec_rsel:3;
+}ISO_CEC_ANALOG;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     set:1;
+}ISO_DRM_ST;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_DRM_SECURE_CLK;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_DRM_ELAPSED;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST1;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST2;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     clk_div_en:1;
+unsigned int     clk_sel:1;
+}ISO_DRM_CTRL;
+
+typedef struct 
+{
+unsigned int     init:32;
+}ISO_DRM_CLK_DIV;
+
+typedef struct 
+{
+unsigned int     tc3tvr:32;
+}ISO_TC3TVR;
+
+typedef struct 
+{
+unsigned int     tc3cvr:32;
+}ISO_TC3CVR;
+
+typedef struct 
+{
+unsigned int     tc3en:1;
+unsigned int     tc3mode:1;
+unsigned int     tc3pause:1;
+unsigned int     rvda:5;
+unsigned int     reserved_0:24;
+}ISO_TC3CR;
+
+typedef struct 
+{
+unsigned int     tc3ie:1;
+unsigned int     reserved_0:31;
+}ISO_TC3ICR;
+
+typedef struct 
+{
+unsigned int     tc4tvr:32;
+}ISO_TC4TVR;
+
+typedef struct 
+{
+unsigned int     tc4cvr:32;
+}ISO_TC4CVR;
+
+typedef struct 
+{
+unsigned int     tc4en:1;
+unsigned int     tc4mode:1;
+unsigned int     tc4pause:1;
+unsigned int     rvda:5;
+unsigned int     reserved_0:24;
+}ISO_TC4CR;
+
+typedef struct 
+{
+unsigned int     tc4ie:1;
+unsigned int     reserved_0:31;
+}ISO_TC4ICR;
+
+typedef struct 
+{
+unsigned int     dat:32;
+}ISO_NORST;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST3;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST4;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST5;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST6;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST7;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST8;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST9;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST10;
+
+typedef struct 
+{
+unsigned int     wd_int_en:1;
+unsigned int     reserved_0:15;
+unsigned int     nmic:4;
+unsigned int     wdc:4;
+unsigned int     wden:8;
+}ISO_TCWCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     wdclr:1;
+}ISO_TCWTR;
+
+typedef struct 
+{
+unsigned int     sel:32;
+}ISO_TCWNMI;
+
+typedef struct 
+{
+unsigned int     sel:32;
+}ISO_TCWOV;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     set:1;
+}ISO_DRM_ST_SWC;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_DRM_SECURE_CLK_SWC;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_DRM_ELAPSED_SWC;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     clk_div_en:1;
+unsigned int     clk_sel:1;
+}ISO_DRM_CTRL_SWC;
+
+typedef struct 
+{
+unsigned int     init:32;
+}ISO_DRM_CLK_DIV_SWC;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST_SWC;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST1_SWC;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST2_SWC;
+
+typedef struct 
+{
+unsigned int     val:32;
+}ISO_COLD_RST3_SWC;
+
+typedef struct 
+{
+unsigned int     dat:32;
+}ISO_NORST_SWC;
+
+typedef struct 
+{
+unsigned int     dat:32;
+}ISO_NORST1_SWC;
+
+typedef struct 
+{
+unsigned int     dat:32;
+}ISO_NORST2_SWC;
+
+typedef struct 
+{
+unsigned int     sel:32;
+}ISO_TCWOV_RSTB_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     scpu_boot_info_valid:1;
+}ISO_CPU_ST2V;
+
+typedef struct 
+{
+unsigned int     scpu_boot_info:32;
+}ISO_CPU_ST2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     write_enable3:1;
+unsigned int     sel1:5;
+unsigned int     write_enable2:1;
+unsigned int     sel0:5;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}ISO_ACPU_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     analogy_mode_in:1;
+}ISO_ANLG;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dll:8;
+}ISO_U0RBR_THR_DLL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dlh:8;
+}ISO_U0IER_DLH;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     fifo16:2;
+unsigned int     reserved_1:2;
+unsigned int     iid:4;
+}ISO_U0IIR_FCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dlab:1;
+unsigned int     brk:1;
+unsigned int     reserved_1:1;
+unsigned int     eps:1;
+unsigned int     pen:1;
+unsigned int     stb:1;
+unsigned int     wls:2;
+}ISO_U0LCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     afce:1;
+unsigned int     loop:1;
+unsigned int     reserved_1:2;
+unsigned int     rts:1;
+unsigned int     dtr:1;
+}ISO_U0MCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rfe:1;
+unsigned int     temt:1;
+unsigned int     thre:1;
+unsigned int     bi:1;
+unsigned int     fe:1;
+unsigned int     pe:1;
+unsigned int     oe:1;
+unsigned int     dr:1;
+}ISO_U0LSR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dcd:1;
+unsigned int     ri:1;
+unsigned int     dsr:1;
+unsigned int     cts:1;
+unsigned int     ddcd:1;
+unsigned int     teri:1;
+unsigned int     ddsr:1;
+unsigned int     dcts:1;
+}ISO_U0MSR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     scr:8;
+}ISO_U0SCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rbd:8;
+}ISO_U0SRBR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     far:1;
+}ISO_U0FAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     far:8;
+}ISO_U0TFR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     rffe:1;
+unsigned int     rfpf:1;
+unsigned int     rfwd:8;
+}ISO_U0RFW;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     busy:1;
+}ISO_U0USR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tfl:8;
+}ISO_U0TFL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rfl:8;
+}ISO_U0RFL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     xfr:1;
+unsigned int     rfr:1;
+unsigned int     ur:1;
+}ISO_U0SRR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     sbcr:1;
+}ISO_U0SBCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     sdmam:1;
+}ISO_U0SDMAM;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     sfe:1;
+}ISO_U0SFE;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     srt:2;
+}ISO_U0SRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     stet:2;
+}ISO_U0STET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     htx:1;
+}ISO_U0HTX;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     dmasa:1;
+}ISO_U0DMASA;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     fifo_mode:8;
+unsigned int     reserved_1:2;
+unsigned int     dma_extra:1;
+unsigned int     uart_add_encoded_params:1;
+unsigned int     shadow:1;
+unsigned int     fifo_stat:1;
+unsigned int     fifo_access:1;
+unsigned int     additional_feat:1;
+unsigned int     sir_lp_mode:1;
+unsigned int     sir_mode:1;
+unsigned int     thre_mode:1;
+unsigned int     afce_mode:1;
+unsigned int     reserved_2:2;
+unsigned int     apb_data_width:2;
+}ISO_U0CPR;
+
+typedef struct 
+{
+unsigned int     ucv:32;
+}ISO_U0UCV;
+
+typedef struct 
+{
+unsigned int     ctr:32;
+}ISO_U0CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     ic_slave_disable:1;
+unsigned int     ic_restart_en:1;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     ic_10bitaddr_slave:1;
+unsigned int     speed:2;
+unsigned int     master_mode:1;
+}ISO_IC0_CON;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     special:1;
+unsigned int     gc_or_start:1;
+unsigned int     ic_tar:10;
+}ISO_IC0_TAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     ic_sar:10;
+}ISO_IC0_SAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ic_hs_mar:3;
+}ISO_IC0_HS_MADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     restart:1;
+unsigned int     stop:1;
+unsigned int     cmd:1;
+unsigned int     dat:8;
+}ISO_IC0_DATA_CMD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_hcnt:16;
+}ISO_IC0_SS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_lcnt:16;
+}ISO_IC0_SS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_hcnt:16;
+}ISO_IC0_FS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_lcnt:16;
+}ISO_IC0_FS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     r_gen_call:1;
+unsigned int     r_start_det:1;
+unsigned int     r_stop_det:1;
+unsigned int     r_activity:1;
+unsigned int     r_rx_done:1;
+unsigned int     r_tx_abrt:1;
+unsigned int     r_rd_req:1;
+unsigned int     r_tx_empty:1;
+unsigned int     r_tx_over:1;
+unsigned int     r_rx_full:1;
+unsigned int     r_rx_over:1;
+unsigned int     r_rx_under:1;
+}ISO_IC0_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     m_gen_call:1;
+unsigned int     m_start_det:1;
+unsigned int     m_stop_det:1;
+unsigned int     m_activity:1;
+unsigned int     m_rx_done:1;
+unsigned int     m_tx_abrt:1;
+unsigned int     m_rd_req:1;
+unsigned int     m_tx_empty:1;
+unsigned int     m_tx_over:1;
+unsigned int     m_rx_full:1;
+unsigned int     m_rx_over:1;
+unsigned int     m_rx_under:1;
+}ISO_IC0_INTR_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     gen_call:1;
+unsigned int     start_det:1;
+unsigned int     stop_det:1;
+unsigned int     activity:1;
+unsigned int     rx_done:1;
+unsigned int     tx_abrt:1;
+unsigned int     rd_req:1;
+unsigned int     tx_empty:1;
+unsigned int     tx_over:1;
+unsigned int     rx_full:1;
+unsigned int     rx_over:1;
+unsigned int     rx_under:1;
+}ISO_IC0_RAW_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rx_tl:8;
+}ISO_IC0_RX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tx_tl:8;
+}ISO_IC0_TX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_intr:1;
+}ISO_IC0_CLR_INTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_under:1;
+}ISO_IC0_CLR_RX_UNDER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_over:1;
+}ISO_IC0_CLR_RX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_over:1;
+}ISO_IC0_CLR_TX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rd_req:1;
+}ISO_IC0_CLR_RD_REQ;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_abrt:1;
+}ISO_IC0_CLR_TX_ABRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_done:1;
+}ISO_IC0_CLR_RX_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_activity:1;
+}ISO_IC0_CLR_ACTIVITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_stop_det:1;
+}ISO_IC0_CLR_STOP_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_start_det:1;
+}ISO_IC0_CLR_START_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_gen_call:1;
+}ISO_IC0_CLR_GEN_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}ISO_IC0_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     slv_activity:1;
+unsigned int     mst_activity:1;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     activity:1;
+}ISO_IC0_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     txflr:4;
+}ISO_IC0_TXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     rxflr:4;
+}ISO_IC0_RXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_sda_hold:16;
+}ISO_IC0_SDA_HOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     abrt_slvrd_intx:1;
+unsigned int     abrt_slv_arblost:1;
+unsigned int     abrt_slvflush_txfifo:1;
+unsigned int     arb_lost:1;
+unsigned int     arb_master_dis:1;
+unsigned int     abrt_10b_rd_norstrt:1;
+unsigned int     abrt_sbyte_norstrt:1;
+unsigned int     abrt_hs_norstrt:1;
+unsigned int     abrt_sbyte_ackdet:1;
+unsigned int     abrt_hs_ackdet:1;
+unsigned int     abrt_gcall_read:1;
+unsigned int     abrt_gcall_noack:1;
+unsigned int     abrt_txdata_noack:1;
+unsigned int     abrt_10addr2_noack:1;
+unsigned int     abrt_10addr1_noack:1;
+unsigned int     abrt_7b_addr_noack:1;
+}ISO_IC0_TX_ABRT_SOURCE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     nack:1;
+}ISO_IC0_SLV_DATA_NACK_ONLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     tdmae:1;
+unsigned int     rdmae:1;
+}ISO_IC0_DMA_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     dmatdl:3;
+}ISO_IC0_DMA_TDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     dmardl:4;
+}ISO_IC0_DMA_RDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sda_setup:8;
+}ISO_IC0_SDA_SETUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     ack_gen_call:1;
+}ISO_IC0_ACK_GENERAL_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     slv_rx_data_lost:1;
+unsigned int     slv_disabled_whi:1;
+unsigned int     ic_en:1;
+}ISO_IC0_ENABLE_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tx_buffer_depth:8;
+unsigned int     rx_buffer_depth:8;
+unsigned int     add_encoded_params:1;
+unsigned int     has_dma:1;
+unsigned int     intr_io:1;
+unsigned int     hc_count_values:1;
+unsigned int     max_speed_mode:2;
+unsigned int     apb_data_width:2;
+}ISO_IC0_COMP_PARAM_1;
+
+typedef struct 
+{
+unsigned int     ic_comp_version:32;
+}ISO_IC0_COMP_VERSION;
+
+typedef struct 
+{
+unsigned int     ic_comp_type:32;
+}ISO_IC0_COMP_TYPE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     ic_slave_disable:1;
+unsigned int     ic_restart_en:1;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     ic_10bitaddr_slave:1;
+unsigned int     speed:2;
+unsigned int     master_mode:1;
+}ISO_IC6_CON;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     special:1;
+unsigned int     gc_or_start:1;
+unsigned int     ic_tar:10;
+}ISO_IC6_TAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     ic_sar:10;
+}ISO_IC6_SAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ic_hs_mar:3;
+}ISO_IC6_HS_MADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     restart:1;
+unsigned int     stop:1;
+unsigned int     cmd:1;
+unsigned int     dat:8;
+}ISO_IC6_DATA_CMD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_hcnt:16;
+}ISO_IC6_SS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_lcnt:16;
+}ISO_IC6_SS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_hcnt:16;
+}ISO_IC6_FS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_lcnt:16;
+}ISO_IC6_FS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     r_gen_call:1;
+unsigned int     r_start_det:1;
+unsigned int     r_stop_det:1;
+unsigned int     r_activity:1;
+unsigned int     r_rx_done:1;
+unsigned int     r_tx_abrt:1;
+unsigned int     r_rd_req:1;
+unsigned int     r_tx_empty:1;
+unsigned int     r_tx_over:1;
+unsigned int     r_rx_full:1;
+unsigned int     r_rx_over:1;
+unsigned int     r_rx_under:1;
+}ISO_IC6_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     m_gen_call:1;
+unsigned int     m_start_det:1;
+unsigned int     m_stop_det:1;
+unsigned int     m_activity:1;
+unsigned int     m_rx_done:1;
+unsigned int     m_tx_abrt:1;
+unsigned int     m_rd_req:1;
+unsigned int     m_tx_empty:1;
+unsigned int     m_tx_over:1;
+unsigned int     m_rx_full:1;
+unsigned int     m_rx_over:1;
+unsigned int     m_rx_under:1;
+}ISO_IC6_INTR_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     gen_call:1;
+unsigned int     start_det:1;
+unsigned int     stop_det:1;
+unsigned int     activity:1;
+unsigned int     rx_done:1;
+unsigned int     tx_abrt:1;
+unsigned int     rd_req:1;
+unsigned int     tx_empty:1;
+unsigned int     tx_over:1;
+unsigned int     rx_full:1;
+unsigned int     rx_over:1;
+unsigned int     rx_under:1;
+}ISO_IC6_RAW_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rx_tl:8;
+}ISO_IC6_RX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tx_tl:8;
+}ISO_IC6_TX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_intr:1;
+}ISO_IC6_CLR_INTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_under:1;
+}ISO_IC6_CLR_RX_UNDER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_over:1;
+}ISO_IC6_CLR_RX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_over:1;
+}ISO_IC6_CLR_TX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rd_req:1;
+}ISO_IC6_CLR_RD_REQ;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_abrt:1;
+}ISO_IC6_CLR_TX_ABRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_done:1;
+}ISO_IC6_CLR_RX_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_activity:1;
+}ISO_IC6_CLR_ACTIVITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_stop_det:1;
+}ISO_IC6_CLR_STOP_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_start_det:1;
+}ISO_IC6_CLR_START_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_gen_call:1;
+}ISO_IC6_CLR_GEN_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}ISO_IC6_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     slv_activity:1;
+unsigned int     mst_activity:1;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     activity:1;
+}ISO_IC6_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     txflr:4;
+}ISO_IC6_TXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     rxflr:4;
+}ISO_IC6_RXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_sda_hold:16;
+}ISO_IC6_SDA_HOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     abrt_slvrd_intx:1;
+unsigned int     abrt_slv_arblost:1;
+unsigned int     abrt_slvflush_txfifo:1;
+unsigned int     arb_lost:1;
+unsigned int     arb_master_dis:1;
+unsigned int     abrt_10b_rd_norstrt:1;
+unsigned int     abrt_sbyte_norstrt:1;
+unsigned int     abrt_hs_norstrt:1;
+unsigned int     abrt_sbyte_ackdet:1;
+unsigned int     abrt_hs_ackdet:1;
+unsigned int     abrt_gcall_read:1;
+unsigned int     abrt_gcall_noack:1;
+unsigned int     abrt_txdata_noack:1;
+unsigned int     abrt_10addr2_noack:1;
+unsigned int     abrt_10addr1_noack:1;
+unsigned int     abrt_7b_addr_noack:1;
+}ISO_IC6_TX_ABRT_SOURCE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     nack:1;
+}ISO_IC6_SLV_DATA_NACK_ONLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     tdmae:1;
+unsigned int     rdmae:1;
+}ISO_IC6_DMA_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     dmatdl:3;
+}ISO_IC6_DMA_TDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     dmardl:4;
+}ISO_IC6_DMA_RDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sda_setup:8;
+}ISO_IC6_SDA_SETUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     ack_gen_call:1;
+}ISO_IC6_ACK_GENERAL_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     slv_rx_data_lost:1;
+unsigned int     slv_disabled_whi:1;
+unsigned int     ic_en:1;
+}ISO_IC6_ENABLE_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tx_buffer_depth:8;
+unsigned int     rx_buffer_depth:8;
+unsigned int     add_encoded_params:1;
+unsigned int     has_dma:1;
+unsigned int     intr_io:1;
+unsigned int     hc_count_values:1;
+unsigned int     max_speed_mode:2;
+unsigned int     apb_data_width:2;
+}ISO_IC6_COMP_PARAM_1;
+
+typedef struct 
+{
+unsigned int     ic_comp_version:32;
+}ISO_IC6_COMP_VERSION;
+
+typedef struct 
+{
+unsigned int     ic_comp_type:32;
+}ISO_IC6_COMP_TYPE;
+
+typedef struct 
+{
+unsigned int     3:8;
+unsigned int     2:8;
+unsigned int     1:8;
+unsigned int     0:8;
+}ISO_PWM_OCD;
+
+typedef struct 
+{
+unsigned int     3:8;
+unsigned int     2:8;
+unsigned int     1:8;
+unsigned int     0:8;
+}ISO_PWM_CD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     3:4;
+unsigned int     2:4;
+unsigned int     1:4;
+unsigned int     0:4;
+}ISO_PWM_CSD;
+
+#endif
+
+#define ISO_ISR                                                                      0x18007000
+#define ISO_ISR_reg_addr                                                             "0xB8007000"
+#define ISO_ISR_reg                                                                  0xB8007000
+#define set_ISO_ISR_reg(data)   (*((volatile unsigned int*) ISO_ISR_reg)=data)
+#define get_ISO_ISR_reg   (*((volatile unsigned int*) ISO_ISR_reg))
+#define ISO_ISR_inst_adr                                                             "0x0000"
+#define ISO_ISR_inst                                                                 0x0000
+#define ISO_ISR_cec_int_shift                                                        (22)
+#define ISO_ISR_cec_int_mask                                                         (0x00400000)
+#define ISO_ISR_cec_int(data)                                                        (0x00400000&((data)<<22))
+#define ISO_ISR_cec_int_src(data)                                                    ((0x00400000&(data))>>22)
+#define ISO_ISR_get_cec_int(data)                                                    ((0x00400000&(data))>>22)
+#define ISO_ISR_gpioda_int_shift                                                     (20)
+#define ISO_ISR_gpioda_int_mask                                                      (0x00100000)
+#define ISO_ISR_gpioda_int(data)                                                     (0x00100000&((data)<<20))
+#define ISO_ISR_gpioda_int_src(data)                                                 ((0x00100000&(data))>>20)
+#define ISO_ISR_get_gpioda_int(data)                                                 ((0x00100000&(data))>>20)
+#define ISO_ISR_gpioa_int_shift                                                      (19)
+#define ISO_ISR_gpioa_int_mask                                                       (0x00080000)
+#define ISO_ISR_gpioa_int(data)                                                      (0x00080000&((data)<<19))
+#define ISO_ISR_gpioa_int_src(data)                                                  ((0x00080000&(data))>>19)
+#define ISO_ISR_get_gpioa_int(data)                                                  ((0x00080000&(data))>>19)
+#define ISO_ISR_vfd_ardswda_int_shift                                                (18)
+#define ISO_ISR_vfd_ardswda_int_mask                                                 (0x00040000)
+#define ISO_ISR_vfd_ardswda_int(data)                                                (0x00040000&((data)<<18))
+#define ISO_ISR_vfd_ardswda_int_src(data)                                            ((0x00040000&(data))>>18)
+#define ISO_ISR_get_vfd_ardswda_int(data)                                            ((0x00040000&(data))>>18)
+#define ISO_ISR_vfd_ardswa_int_shift                                                 (17)
+#define ISO_ISR_vfd_ardswa_int_mask                                                  (0x00020000)
+#define ISO_ISR_vfd_ardswa_int(data)                                                 (0x00020000&((data)<<17))
+#define ISO_ISR_vfd_ardswa_int_src(data)                                             ((0x00020000&(data))>>17)
+#define ISO_ISR_get_vfd_ardswa_int(data)                                             ((0x00020000&(data))>>17)
+#define ISO_ISR_vfd_ardkpadda_int_shift                                              (16)
+#define ISO_ISR_vfd_ardkpadda_int_mask                                               (0x00010000)
+#define ISO_ISR_vfd_ardkpadda_int(data)                                              (0x00010000&((data)<<16))
+#define ISO_ISR_vfd_ardkpadda_int_src(data)                                          ((0x00010000&(data))>>16)
+#define ISO_ISR_get_vfd_ardkpadda_int(data)                                          ((0x00010000&(data))>>16)
+#define ISO_ISR_vfd_ardkpada_int_shift                                               (15)
+#define ISO_ISR_vfd_ardkpada_int_mask                                                (0x00008000)
+#define ISO_ISR_vfd_ardkpada_int(data)                                               (0x00008000&((data)<<15))
+#define ISO_ISR_vfd_ardkpada_int_src(data)                                           ((0x00008000&(data))>>15)
+#define ISO_ISR_get_vfd_ardkpada_int(data)                                           ((0x00008000&(data))>>15)
+#define ISO_ISR_vfd_wdone_int_shift                                                  (14)
+#define ISO_ISR_vfd_wdone_int_mask                                                   (0x00004000)
+#define ISO_ISR_vfd_wdone_int(data)                                                  (0x00004000&((data)<<14))
+#define ISO_ISR_vfd_wdone_int_src(data)                                              ((0x00004000&(data))>>14)
+#define ISO_ISR_get_vfd_wdone_int(data)                                              ((0x00004000&(data))>>14)
+#define ISO_ISR_rtc_alarm_int_shift                                                  (13)
+#define ISO_ISR_rtc_alarm_int_mask                                                   (0x00002000)
+#define ISO_ISR_rtc_alarm_int(data)                                                  (0x00002000&((data)<<13))
+#define ISO_ISR_rtc_alarm_int_src(data)                                              ((0x00002000&(data))>>13)
+#define ISO_ISR_get_rtc_alarm_int(data)                                              ((0x00002000&(data))>>13)
+#define ISO_ISR_rtc_hsec_int_shift                                                   (12)
+#define ISO_ISR_rtc_hsec_int_mask                                                    (0x00001000)
+#define ISO_ISR_rtc_hsec_int(data)                                                   (0x00001000&((data)<<12))
+#define ISO_ISR_rtc_hsec_int_src(data)                                               ((0x00001000&(data))>>12)
+#define ISO_ISR_get_rtc_hsec_int(data)                                               ((0x00001000&(data))>>12)
+#define ISO_ISR_i2c6_int_shift                                                       (10)
+#define ISO_ISR_i2c6_int_mask                                                        (0x00000400)
+#define ISO_ISR_i2c6_int(data)                                                       (0x00000400&((data)<<10))
+#define ISO_ISR_i2c6_int_src(data)                                                   ((0x00000400&(data))>>10)
+#define ISO_ISR_get_i2c6_int(data)                                                   ((0x00000400&(data))>>10)
+#define ISO_ISR_tc4_int_shift                                                        (9)
+#define ISO_ISR_tc4_int_mask                                                         (0x00000200)
+#define ISO_ISR_tc4_int(data)                                                        (0x00000200&((data)<<9))
+#define ISO_ISR_tc4_int_src(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_ISR_get_tc4_int(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_ISR_i2c0_int_shift                                                       (8)
+#define ISO_ISR_i2c0_int_mask                                                        (0x00000100)
+#define ISO_ISR_i2c0_int(data)                                                       (0x00000100&((data)<<8))
+#define ISO_ISR_i2c0_int_src(data)                                                   ((0x00000100&(data))>>8)
+#define ISO_ISR_get_i2c0_int(data)                                                   ((0x00000100&(data))>>8)
+#define ISO_ISR_wdog_nmi_int_shift                                                   (7)
+#define ISO_ISR_wdog_nmi_int_mask                                                    (0x00000080)
+#define ISO_ISR_wdog_nmi_int(data)                                                   (0x00000080&((data)<<7))
+#define ISO_ISR_wdog_nmi_int_src(data)                                               ((0x00000080&(data))>>7)
+#define ISO_ISR_get_wdog_nmi_int(data)                                               ((0x00000080&(data))>>7)
+#define ISO_ISR_irda_int_shift                                                       (5)
+#define ISO_ISR_irda_int_mask                                                        (0x00000020)
+#define ISO_ISR_irda_int(data)                                                       (0x00000020&((data)<<5))
+#define ISO_ISR_irda_int_src(data)                                                   ((0x00000020&(data))>>5)
+#define ISO_ISR_get_irda_int(data)                                                   ((0x00000020&(data))>>5)
+#define ISO_ISR_ur0_int_shift                                                        (2)
+#define ISO_ISR_ur0_int_mask                                                         (0x00000004)
+#define ISO_ISR_ur0_int(data)                                                        (0x00000004&((data)<<2))
+#define ISO_ISR_ur0_int_src(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_ISR_get_ur0_int(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_ISR_tc3_int_shift                                                        (1)
+#define ISO_ISR_tc3_int_mask                                                         (0x00000002)
+#define ISO_ISR_tc3_int(data)                                                        (0x00000002&((data)<<1))
+#define ISO_ISR_tc3_int_src(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_ISR_get_tc3_int(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_ISR_write_data_shift                                                     (0)
+#define ISO_ISR_write_data_mask                                                      (0x00000001)
+#define ISO_ISR_write_data(data)                                                     (0x00000001&((data)<<0))
+#define ISO_ISR_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define ISO_ISR_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR                                                                 0x18007004
+#define ISO_UMSK_ISR_reg_addr                                                        "0xB8007004"
+#define ISO_UMSK_ISR_reg                                                             0xB8007004
+#define set_ISO_UMSK_ISR_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_reg)=data)
+#define get_ISO_UMSK_ISR_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_reg))
+#define ISO_UMSK_ISR_inst_adr                                                        "0x0001"
+#define ISO_UMSK_ISR_inst                                                            0x0001
+#define ISO_UMSK_ISR_gpioda_int_shift                                                (20)
+#define ISO_UMSK_ISR_gpioda_int_mask                                                 (0x00100000)
+#define ISO_UMSK_ISR_gpioda_int(data)                                                (0x00100000&((data)<<20))
+#define ISO_UMSK_ISR_gpioda_int_src(data)                                            ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_get_gpioda_int(data)                                            ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_gpioa_int_shift                                                 (19)
+#define ISO_UMSK_ISR_gpioa_int_mask                                                  (0x00080000)
+#define ISO_UMSK_ISR_gpioa_int(data)                                                 (0x00080000&((data)<<19))
+#define ISO_UMSK_ISR_gpioa_int_src(data)                                             ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_get_gpioa_int(data)                                             ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_vfd_ardswda_int_shift                                           (18)
+#define ISO_UMSK_ISR_vfd_ardswda_int_mask                                            (0x00040000)
+#define ISO_UMSK_ISR_vfd_ardswda_int(data)                                           (0x00040000&((data)<<18))
+#define ISO_UMSK_ISR_vfd_ardswda_int_src(data)                                       ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_get_vfd_ardswda_int(data)                                       ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_vfd_ardswa_int_shift                                            (17)
+#define ISO_UMSK_ISR_vfd_ardswa_int_mask                                             (0x00020000)
+#define ISO_UMSK_ISR_vfd_ardswa_int(data)                                            (0x00020000&((data)<<17))
+#define ISO_UMSK_ISR_vfd_ardswa_int_src(data)                                        ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_get_vfd_ardswa_int(data)                                        ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_vfd_ardkpadda_int_shift                                         (16)
+#define ISO_UMSK_ISR_vfd_ardkpadda_int_mask                                          (0x00010000)
+#define ISO_UMSK_ISR_vfd_ardkpadda_int(data)                                         (0x00010000&((data)<<16))
+#define ISO_UMSK_ISR_vfd_ardkpadda_int_src(data)                                     ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_get_vfd_ardkpadda_int(data)                                     ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_vfd_ardkpada_int_shift                                          (15)
+#define ISO_UMSK_ISR_vfd_ardkpada_int_mask                                           (0x00008000)
+#define ISO_UMSK_ISR_vfd_ardkpada_int(data)                                          (0x00008000&((data)<<15))
+#define ISO_UMSK_ISR_vfd_ardkpada_int_src(data)                                      ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_get_vfd_ardkpada_int(data)                                      ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_vfd_wdone_int_shift                                             (14)
+#define ISO_UMSK_ISR_vfd_wdone_int_mask                                              (0x00004000)
+#define ISO_UMSK_ISR_vfd_wdone_int(data)                                             (0x00004000&((data)<<14))
+#define ISO_UMSK_ISR_vfd_wdone_int_src(data)                                         ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_get_vfd_wdone_int(data)                                         ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_rtc_alarm_int_shift                                             (13)
+#define ISO_UMSK_ISR_rtc_alarm_int_mask                                              (0x00002000)
+#define ISO_UMSK_ISR_rtc_alarm_int(data)                                             (0x00002000&((data)<<13))
+#define ISO_UMSK_ISR_rtc_alarm_int_src(data)                                         ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_get_rtc_alarm_int(data)                                         ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_rtc_hsec_int_shift                                              (12)
+#define ISO_UMSK_ISR_rtc_hsec_int_mask                                               (0x00001000)
+#define ISO_UMSK_ISR_rtc_hsec_int(data)                                              (0x00001000&((data)<<12))
+#define ISO_UMSK_ISR_rtc_hsec_int_src(data)                                          ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_get_rtc_hsec_int(data)                                          ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_tc4_int_shift                                                   (9)
+#define ISO_UMSK_ISR_tc4_int_mask                                                    (0x00000200)
+#define ISO_UMSK_ISR_tc4_int(data)                                                   (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_tc4_int_src(data)                                               ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_get_tc4_int(data)                                               ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_wdog_nmi_int_shift                                              (7)
+#define ISO_UMSK_ISR_wdog_nmi_int_mask                                               (0x00000080)
+#define ISO_UMSK_ISR_wdog_nmi_int(data)                                              (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_wdog_nmi_int_src(data)                                          ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_get_wdog_nmi_int(data)                                          ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_irda_int_shift                                                  (5)
+#define ISO_UMSK_ISR_irda_int_mask                                                   (0x00000020)
+#define ISO_UMSK_ISR_irda_int(data)                                                  (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_irda_int_src(data)                                              ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_get_irda_int(data)                                              ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_tc3_int_shift                                                   (1)
+#define ISO_UMSK_ISR_tc3_int_mask                                                    (0x00000002)
+#define ISO_UMSK_ISR_tc3_int(data)                                                   (0x00000002&((data)<<1))
+#define ISO_UMSK_ISR_tc3_int_src(data)                                               ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_get_tc3_int(data)                                               ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_write_data_shift                                                (0)
+#define ISO_UMSK_ISR_write_data_mask                                                 (0x00000001)
+#define ISO_UMSK_ISR_write_data(data)                                                (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_GPA                                                             0x18007008
+#define ISO_UMSK_ISR_GPA_reg_addr                                                    "0xB8007008"
+#define ISO_UMSK_ISR_GPA_reg                                                         0xB8007008
+#define set_ISO_UMSK_ISR_GPA_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_GPA_reg)=data)
+#define get_ISO_UMSK_ISR_GPA_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_GPA_reg))
+#define ISO_UMSK_ISR_GPA_inst_adr                                                    "0x0002"
+#define ISO_UMSK_ISR_GPA_inst                                                        0x0002
+#define ISO_UMSK_ISR_GPA_int20_a_shift                                               (21)
+#define ISO_UMSK_ISR_GPA_int20_a_mask                                                (0x00200000)
+#define ISO_UMSK_ISR_GPA_int20_a(data)                                               (0x00200000&((data)<<21))
+#define ISO_UMSK_ISR_GPA_int20_a_src(data)                                           ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_GPA_get_int20_a(data)                                           ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_GPA_int19_a_shift                                               (20)
+#define ISO_UMSK_ISR_GPA_int19_a_mask                                                (0x00100000)
+#define ISO_UMSK_ISR_GPA_int19_a(data)                                               (0x00100000&((data)<<20))
+#define ISO_UMSK_ISR_GPA_int19_a_src(data)                                           ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_GPA_get_int19_a(data)                                           ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_GPA_int18_a_shift                                               (19)
+#define ISO_UMSK_ISR_GPA_int18_a_mask                                                (0x00080000)
+#define ISO_UMSK_ISR_GPA_int18_a(data)                                               (0x00080000&((data)<<19))
+#define ISO_UMSK_ISR_GPA_int18_a_src(data)                                           ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_GPA_get_int18_a(data)                                           ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_GPA_int17_a_shift                                               (18)
+#define ISO_UMSK_ISR_GPA_int17_a_mask                                                (0x00040000)
+#define ISO_UMSK_ISR_GPA_int17_a(data)                                               (0x00040000&((data)<<18))
+#define ISO_UMSK_ISR_GPA_int17_a_src(data)                                           ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_GPA_get_int17_a(data)                                           ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_GPA_int16_a_shift                                               (17)
+#define ISO_UMSK_ISR_GPA_int16_a_mask                                                (0x00020000)
+#define ISO_UMSK_ISR_GPA_int16_a(data)                                               (0x00020000&((data)<<17))
+#define ISO_UMSK_ISR_GPA_int16_a_src(data)                                           ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_GPA_get_int16_a(data)                                           ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_GPA_int15_a_shift                                               (16)
+#define ISO_UMSK_ISR_GPA_int15_a_mask                                                (0x00010000)
+#define ISO_UMSK_ISR_GPA_int15_a(data)                                               (0x00010000&((data)<<16))
+#define ISO_UMSK_ISR_GPA_int15_a_src(data)                                           ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_GPA_get_int15_a(data)                                           ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_GPA_int14_a_shift                                               (15)
+#define ISO_UMSK_ISR_GPA_int14_a_mask                                                (0x00008000)
+#define ISO_UMSK_ISR_GPA_int14_a(data)                                               (0x00008000&((data)<<15))
+#define ISO_UMSK_ISR_GPA_int14_a_src(data)                                           ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_GPA_get_int14_a(data)                                           ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_GPA_int13_a_shift                                               (14)
+#define ISO_UMSK_ISR_GPA_int13_a_mask                                                (0x00004000)
+#define ISO_UMSK_ISR_GPA_int13_a(data)                                               (0x00004000&((data)<<14))
+#define ISO_UMSK_ISR_GPA_int13_a_src(data)                                           ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_GPA_get_int13_a(data)                                           ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_GPA_int12_a_shift                                               (13)
+#define ISO_UMSK_ISR_GPA_int12_a_mask                                                (0x00002000)
+#define ISO_UMSK_ISR_GPA_int12_a(data)                                               (0x00002000&((data)<<13))
+#define ISO_UMSK_ISR_GPA_int12_a_src(data)                                           ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_GPA_get_int12_a(data)                                           ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_GPA_int11_a_shift                                               (12)
+#define ISO_UMSK_ISR_GPA_int11_a_mask                                                (0x00001000)
+#define ISO_UMSK_ISR_GPA_int11_a(data)                                               (0x00001000&((data)<<12))
+#define ISO_UMSK_ISR_GPA_int11_a_src(data)                                           ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_GPA_get_int11_a(data)                                           ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_GPA_int10_a_shift                                               (11)
+#define ISO_UMSK_ISR_GPA_int10_a_mask                                                (0x00000800)
+#define ISO_UMSK_ISR_GPA_int10_a(data)                                               (0x00000800&((data)<<11))
+#define ISO_UMSK_ISR_GPA_int10_a_src(data)                                           ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_GPA_get_int10_a(data)                                           ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_GPA_int9_a_shift                                                (10)
+#define ISO_UMSK_ISR_GPA_int9_a_mask                                                 (0x00000400)
+#define ISO_UMSK_ISR_GPA_int9_a(data)                                                (0x00000400&((data)<<10))
+#define ISO_UMSK_ISR_GPA_int9_a_src(data)                                            ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_GPA_get_int9_a(data)                                            ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_GPA_int8_a_shift                                                (9)
+#define ISO_UMSK_ISR_GPA_int8_a_mask                                                 (0x00000200)
+#define ISO_UMSK_ISR_GPA_int8_a(data)                                                (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_GPA_int8_a_src(data)                                            ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_GPA_get_int8_a(data)                                            ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_GPA_int7_a_shift                                                (8)
+#define ISO_UMSK_ISR_GPA_int7_a_mask                                                 (0x00000100)
+#define ISO_UMSK_ISR_GPA_int7_a(data)                                                (0x00000100&((data)<<8))
+#define ISO_UMSK_ISR_GPA_int7_a_src(data)                                            ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_GPA_get_int7_a(data)                                            ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_GPA_int6_a_shift                                                (7)
+#define ISO_UMSK_ISR_GPA_int6_a_mask                                                 (0x00000080)
+#define ISO_UMSK_ISR_GPA_int6_a(data)                                                (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_GPA_int6_a_src(data)                                            ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_GPA_get_int6_a(data)                                            ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_GPA_int5_a_shift                                                (6)
+#define ISO_UMSK_ISR_GPA_int5_a_mask                                                 (0x00000040)
+#define ISO_UMSK_ISR_GPA_int5_a(data)                                                (0x00000040&((data)<<6))
+#define ISO_UMSK_ISR_GPA_int5_a_src(data)                                            ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_GPA_get_int5_a(data)                                            ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_GPA_int4_a_shift                                                (5)
+#define ISO_UMSK_ISR_GPA_int4_a_mask                                                 (0x00000020)
+#define ISO_UMSK_ISR_GPA_int4_a(data)                                                (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_GPA_int4_a_src(data)                                            ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_GPA_get_int4_a(data)                                            ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_GPA_int3_a_shift                                                (4)
+#define ISO_UMSK_ISR_GPA_int3_a_mask                                                 (0x00000010)
+#define ISO_UMSK_ISR_GPA_int3_a(data)                                                (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_GPA_int3_a_src(data)                                            ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPA_get_int3_a(data)                                            ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPA_int2_a_shift                                                (3)
+#define ISO_UMSK_ISR_GPA_int2_a_mask                                                 (0x00000008)
+#define ISO_UMSK_ISR_GPA_int2_a(data)                                                (0x00000008&((data)<<3))
+#define ISO_UMSK_ISR_GPA_int2_a_src(data)                                            ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPA_get_int2_a(data)                                            ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPA_int1_a_shift                                                (2)
+#define ISO_UMSK_ISR_GPA_int1_a_mask                                                 (0x00000004)
+#define ISO_UMSK_ISR_GPA_int1_a(data)                                                (0x00000004&((data)<<2))
+#define ISO_UMSK_ISR_GPA_int1_a_src(data)                                            ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPA_get_int1_a(data)                                            ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPA_int0_a_shift                                                (1)
+#define ISO_UMSK_ISR_GPA_int0_a_mask                                                 (0x00000002)
+#define ISO_UMSK_ISR_GPA_int0_a(data)                                                (0x00000002&((data)<<1))
+#define ISO_UMSK_ISR_GPA_int0_a_src(data)                                            ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPA_get_int0_a(data)                                            ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPA_write_data_shift                                            (0)
+#define ISO_UMSK_ISR_GPA_write_data_mask                                             (0x00000001)
+#define ISO_UMSK_ISR_GPA_write_data(data)                                            (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_GPA_write_data_src(data)                                        ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_GPA_get_write_data(data)                                        ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_GPDA                                                            0x1800700C
+#define ISO_UMSK_ISR_GPDA_reg_addr                                                   "0xB800700C"
+#define ISO_UMSK_ISR_GPDA_reg                                                        0xB800700C
+#define set_ISO_UMSK_ISR_GPDA_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_GPDA_reg)=data)
+#define get_ISO_UMSK_ISR_GPDA_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_GPDA_reg))
+#define ISO_UMSK_ISR_GPDA_inst_adr                                                   "0x0003"
+#define ISO_UMSK_ISR_GPDA_inst                                                       0x0003
+#define ISO_UMSK_ISR_GPDA_int20_da_shift                                             (21)
+#define ISO_UMSK_ISR_GPDA_int20_da_mask                                              (0x00200000)
+#define ISO_UMSK_ISR_GPDA_int20_da(data)                                             (0x00200000&((data)<<21))
+#define ISO_UMSK_ISR_GPDA_int20_da_src(data)                                         ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_GPDA_get_int20_da(data)                                         ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_GPDA_int19_da_shift                                             (20)
+#define ISO_UMSK_ISR_GPDA_int19_da_mask                                              (0x00100000)
+#define ISO_UMSK_ISR_GPDA_int19_da(data)                                             (0x00100000&((data)<<20))
+#define ISO_UMSK_ISR_GPDA_int19_da_src(data)                                         ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_GPDA_get_int19_da(data)                                         ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_GPDA_int18_da_shift                                             (19)
+#define ISO_UMSK_ISR_GPDA_int18_da_mask                                              (0x00080000)
+#define ISO_UMSK_ISR_GPDA_int18_da(data)                                             (0x00080000&((data)<<19))
+#define ISO_UMSK_ISR_GPDA_int18_da_src(data)                                         ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_GPDA_get_int18_da(data)                                         ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_GPDA_int17_da_shift                                             (18)
+#define ISO_UMSK_ISR_GPDA_int17_da_mask                                              (0x00040000)
+#define ISO_UMSK_ISR_GPDA_int17_da(data)                                             (0x00040000&((data)<<18))
+#define ISO_UMSK_ISR_GPDA_int17_da_src(data)                                         ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_GPDA_get_int17_da(data)                                         ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_GPDA_int16_da_shift                                             (17)
+#define ISO_UMSK_ISR_GPDA_int16_da_mask                                              (0x00020000)
+#define ISO_UMSK_ISR_GPDA_int16_da(data)                                             (0x00020000&((data)<<17))
+#define ISO_UMSK_ISR_GPDA_int16_da_src(data)                                         ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_GPDA_get_int16_da(data)                                         ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_GPDA_int15_da_shift                                             (16)
+#define ISO_UMSK_ISR_GPDA_int15_da_mask                                              (0x00010000)
+#define ISO_UMSK_ISR_GPDA_int15_da(data)                                             (0x00010000&((data)<<16))
+#define ISO_UMSK_ISR_GPDA_int15_da_src(data)                                         ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_GPDA_get_int15_da(data)                                         ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_GPDA_int14_da_shift                                             (15)
+#define ISO_UMSK_ISR_GPDA_int14_da_mask                                              (0x00008000)
+#define ISO_UMSK_ISR_GPDA_int14_da(data)                                             (0x00008000&((data)<<15))
+#define ISO_UMSK_ISR_GPDA_int14_da_src(data)                                         ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_GPDA_get_int14_da(data)                                         ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_GPDA_int13_da_shift                                             (14)
+#define ISO_UMSK_ISR_GPDA_int13_da_mask                                              (0x00004000)
+#define ISO_UMSK_ISR_GPDA_int13_da(data)                                             (0x00004000&((data)<<14))
+#define ISO_UMSK_ISR_GPDA_int13_da_src(data)                                         ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_GPDA_get_int13_da(data)                                         ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_GPDA_int12_da_shift                                             (13)
+#define ISO_UMSK_ISR_GPDA_int12_da_mask                                              (0x00002000)
+#define ISO_UMSK_ISR_GPDA_int12_da(data)                                             (0x00002000&((data)<<13))
+#define ISO_UMSK_ISR_GPDA_int12_da_src(data)                                         ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_GPDA_get_int12_da(data)                                         ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_GPDA_int11_da_shift                                             (12)
+#define ISO_UMSK_ISR_GPDA_int11_da_mask                                              (0x00001000)
+#define ISO_UMSK_ISR_GPDA_int11_da(data)                                             (0x00001000&((data)<<12))
+#define ISO_UMSK_ISR_GPDA_int11_da_src(data)                                         ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_GPDA_get_int11_da(data)                                         ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_GPDA_int10_da_shift                                             (11)
+#define ISO_UMSK_ISR_GPDA_int10_da_mask                                              (0x00000800)
+#define ISO_UMSK_ISR_GPDA_int10_da(data)                                             (0x00000800&((data)<<11))
+#define ISO_UMSK_ISR_GPDA_int10_da_src(data)                                         ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_GPDA_get_int10_da(data)                                         ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_GPDA_int9_da_shift                                              (10)
+#define ISO_UMSK_ISR_GPDA_int9_da_mask                                               (0x00000400)
+#define ISO_UMSK_ISR_GPDA_int9_da(data)                                              (0x00000400&((data)<<10))
+#define ISO_UMSK_ISR_GPDA_int9_da_src(data)                                          ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_GPDA_get_int9_da(data)                                          ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_GPDA_int8_da_shift                                              (9)
+#define ISO_UMSK_ISR_GPDA_int8_da_mask                                               (0x00000200)
+#define ISO_UMSK_ISR_GPDA_int8_da(data)                                              (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_GPDA_int8_da_src(data)                                          ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_GPDA_get_int8_da(data)                                          ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_GPDA_int7_da_shift                                              (8)
+#define ISO_UMSK_ISR_GPDA_int7_da_mask                                               (0x00000100)
+#define ISO_UMSK_ISR_GPDA_int7_da(data)                                              (0x00000100&((data)<<8))
+#define ISO_UMSK_ISR_GPDA_int7_da_src(data)                                          ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_GPDA_get_int7_da(data)                                          ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_GPDA_int6_da_shift                                              (7)
+#define ISO_UMSK_ISR_GPDA_int6_da_mask                                               (0x00000080)
+#define ISO_UMSK_ISR_GPDA_int6_da(data)                                              (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_GPDA_int6_da_src(data)                                          ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_GPDA_get_int6_da(data)                                          ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_GPDA_int5_da_shift                                              (6)
+#define ISO_UMSK_ISR_GPDA_int5_da_mask                                               (0x00000040)
+#define ISO_UMSK_ISR_GPDA_int5_da(data)                                              (0x00000040&((data)<<6))
+#define ISO_UMSK_ISR_GPDA_int5_da_src(data)                                          ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_GPDA_get_int5_da(data)                                          ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_GPDA_int4_da_shift                                              (5)
+#define ISO_UMSK_ISR_GPDA_int4_da_mask                                               (0x00000020)
+#define ISO_UMSK_ISR_GPDA_int4_da(data)                                              (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_GPDA_int4_da_src(data)                                          ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_GPDA_get_int4_da(data)                                          ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_GPDA_int3_da_shift                                              (4)
+#define ISO_UMSK_ISR_GPDA_int3_da_mask                                               (0x00000010)
+#define ISO_UMSK_ISR_GPDA_int3_da(data)                                              (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_GPDA_int3_da_src(data)                                          ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPDA_get_int3_da(data)                                          ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_GPDA_int2_da_shift                                              (3)
+#define ISO_UMSK_ISR_GPDA_int2_da_mask                                               (0x00000008)
+#define ISO_UMSK_ISR_GPDA_int2_da(data)                                              (0x00000008&((data)<<3))
+#define ISO_UMSK_ISR_GPDA_int2_da_src(data)                                          ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPDA_get_int2_da(data)                                          ((0x00000008&(data))>>3)
+#define ISO_UMSK_ISR_GPDA_int1_da_shift                                              (2)
+#define ISO_UMSK_ISR_GPDA_int1_da_mask                                               (0x00000004)
+#define ISO_UMSK_ISR_GPDA_int1_da(data)                                              (0x00000004&((data)<<2))
+#define ISO_UMSK_ISR_GPDA_int1_da_src(data)                                          ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPDA_get_int1_da(data)                                          ((0x00000004&(data))>>2)
+#define ISO_UMSK_ISR_GPDA_int0_da_shift                                              (1)
+#define ISO_UMSK_ISR_GPDA_int0_da_mask                                               (0x00000002)
+#define ISO_UMSK_ISR_GPDA_int0_da(data)                                              (0x00000002&((data)<<1))
+#define ISO_UMSK_ISR_GPDA_int0_da_src(data)                                          ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPDA_get_int0_da(data)                                          ((0x00000002&(data))>>1)
+#define ISO_UMSK_ISR_GPDA_write_data_shift                                           (0)
+#define ISO_UMSK_ISR_GPDA_write_data_mask                                            (0x00000001)
+#define ISO_UMSK_ISR_GPDA_write_data(data)                                           (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_GPDA_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_GPDA_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_KPADAH                                                          0x18007010
+#define ISO_UMSK_ISR_KPADAH_reg_addr                                                 "0xB8007010"
+#define ISO_UMSK_ISR_KPADAH_reg                                                      0xB8007010
+#define set_ISO_UMSK_ISR_KPADAH_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_KPADAH_reg)=data)
+#define get_ISO_UMSK_ISR_KPADAH_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_KPADAH_reg))
+#define ISO_UMSK_ISR_KPADAH_inst_adr                                                 "0x0004"
+#define ISO_UMSK_ISR_KPADAH_inst                                                     0x0004
+#define ISO_UMSK_ISR_KPADAH_int47_shift                                              (23)
+#define ISO_UMSK_ISR_KPADAH_int47_mask                                               (0x00800000)
+#define ISO_UMSK_ISR_KPADAH_int47(data)                                              (0x00800000&((data)<<23))
+#define ISO_UMSK_ISR_KPADAH_int47_src(data)                                          ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_KPADAH_get_int47(data)                                          ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_KPADAH_int46_shift                                              (22)
+#define ISO_UMSK_ISR_KPADAH_int46_mask                                               (0x00400000)
+#define ISO_UMSK_ISR_KPADAH_int46(data)                                              (0x00400000&((data)<<22))
+#define ISO_UMSK_ISR_KPADAH_int46_src(data)                                          ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_KPADAH_get_int46(data)                                          ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_KPADAH_int45_shift                                              (21)
+#define ISO_UMSK_ISR_KPADAH_int45_mask                                               (0x00200000)
+#define ISO_UMSK_ISR_KPADAH_int45(data)                                              (0x00200000&((data)<<21))
+#define ISO_UMSK_ISR_KPADAH_int45_src(data)                                          ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_KPADAH_get_int45(data)                                          ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_KPADAH_int44_shift                                              (20)
+#define ISO_UMSK_ISR_KPADAH_int44_mask                                               (0x00100000)
+#define ISO_UMSK_ISR_KPADAH_int44(data)                                              (0x00100000&((data)<<20))
+#define ISO_UMSK_ISR_KPADAH_int44_src(data)                                          ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_KPADAH_get_int44(data)                                          ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_KPADAH_int43_shift                                              (19)
+#define ISO_UMSK_ISR_KPADAH_int43_mask                                               (0x00080000)
+#define ISO_UMSK_ISR_KPADAH_int43(data)                                              (0x00080000&((data)<<19))
+#define ISO_UMSK_ISR_KPADAH_int43_src(data)                                          ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_KPADAH_get_int43(data)                                          ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_KPADAH_int42_shift                                              (18)
+#define ISO_UMSK_ISR_KPADAH_int42_mask                                               (0x00040000)
+#define ISO_UMSK_ISR_KPADAH_int42(data)                                              (0x00040000&((data)<<18))
+#define ISO_UMSK_ISR_KPADAH_int42_src(data)                                          ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_KPADAH_get_int42(data)                                          ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_KPADAH_int41_shift                                              (17)
+#define ISO_UMSK_ISR_KPADAH_int41_mask                                               (0x00020000)
+#define ISO_UMSK_ISR_KPADAH_int41(data)                                              (0x00020000&((data)<<17))
+#define ISO_UMSK_ISR_KPADAH_int41_src(data)                                          ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_KPADAH_get_int41(data)                                          ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_KPADAH_int40_shift                                              (16)
+#define ISO_UMSK_ISR_KPADAH_int40_mask                                               (0x00010000)
+#define ISO_UMSK_ISR_KPADAH_int40(data)                                              (0x00010000&((data)<<16))
+#define ISO_UMSK_ISR_KPADAH_int40_src(data)                                          ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_KPADAH_get_int40(data)                                          ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_KPADAH_int39_shift                                              (15)
+#define ISO_UMSK_ISR_KPADAH_int39_mask                                               (0x00008000)
+#define ISO_UMSK_ISR_KPADAH_int39(data)                                              (0x00008000&((data)<<15))
+#define ISO_UMSK_ISR_KPADAH_int39_src(data)                                          ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_KPADAH_get_int39(data)                                          ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_KPADAH_int38_shift                                              (14)
+#define ISO_UMSK_ISR_KPADAH_int38_mask                                               (0x00004000)
+#define ISO_UMSK_ISR_KPADAH_int38(data)                                              (0x00004000&((data)<<14))
+#define ISO_UMSK_ISR_KPADAH_int38_src(data)                                          ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_KPADAH_get_int38(data)                                          ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_KPADAH_int37_shift                                              (13)
+#define ISO_UMSK_ISR_KPADAH_int37_mask                                               (0x00002000)
+#define ISO_UMSK_ISR_KPADAH_int37(data)                                              (0x00002000&((data)<<13))
+#define ISO_UMSK_ISR_KPADAH_int37_src(data)                                          ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_KPADAH_get_int37(data)                                          ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_KPADAH_int36_shift                                              (12)
+#define ISO_UMSK_ISR_KPADAH_int36_mask                                               (0x00001000)
+#define ISO_UMSK_ISR_KPADAH_int36(data)                                              (0x00001000&((data)<<12))
+#define ISO_UMSK_ISR_KPADAH_int36_src(data)                                          ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_KPADAH_get_int36(data)                                          ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_KPADAH_int35_shift                                              (11)
+#define ISO_UMSK_ISR_KPADAH_int35_mask                                               (0x00000800)
+#define ISO_UMSK_ISR_KPADAH_int35(data)                                              (0x00000800&((data)<<11))
+#define ISO_UMSK_ISR_KPADAH_int35_src(data)                                          ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_KPADAH_get_int35(data)                                          ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_KPADAH_int34_shift                                              (10)
+#define ISO_UMSK_ISR_KPADAH_int34_mask                                               (0x00000400)
+#define ISO_UMSK_ISR_KPADAH_int34(data)                                              (0x00000400&((data)<<10))
+#define ISO_UMSK_ISR_KPADAH_int34_src(data)                                          ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_KPADAH_get_int34(data)                                          ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_KPADAH_int33_shift                                              (9)
+#define ISO_UMSK_ISR_KPADAH_int33_mask                                               (0x00000200)
+#define ISO_UMSK_ISR_KPADAH_int33(data)                                              (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_KPADAH_int33_src(data)                                          ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_KPADAH_get_int33(data)                                          ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_KPADAH_int32_shift                                              (8)
+#define ISO_UMSK_ISR_KPADAH_int32_mask                                               (0x00000100)
+#define ISO_UMSK_ISR_KPADAH_int32(data)                                              (0x00000100&((data)<<8))
+#define ISO_UMSK_ISR_KPADAH_int32_src(data)                                          ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_KPADAH_get_int32(data)                                          ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_KPADAH_int31_shift                                              (7)
+#define ISO_UMSK_ISR_KPADAH_int31_mask                                               (0x00000080)
+#define ISO_UMSK_ISR_KPADAH_int31(data)                                              (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_KPADAH_int31_src(data)                                          ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_KPADAH_get_int31(data)                                          ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_KPADAH_int30_shift                                              (6)
+#define ISO_UMSK_ISR_KPADAH_int30_mask                                               (0x00000040)
+#define ISO_UMSK_ISR_KPADAH_int30(data)                                              (0x00000040&((data)<<6))
+#define ISO_UMSK_ISR_KPADAH_int30_src(data)                                          ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_KPADAH_get_int30(data)                                          ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_KPADAH_int29_shift                                              (5)
+#define ISO_UMSK_ISR_KPADAH_int29_mask                                               (0x00000020)
+#define ISO_UMSK_ISR_KPADAH_int29(data)                                              (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_KPADAH_int29_src(data)                                          ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_KPADAH_get_int29(data)                                          ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_KPADAH_int28_shift                                              (4)
+#define ISO_UMSK_ISR_KPADAH_int28_mask                                               (0x00000010)
+#define ISO_UMSK_ISR_KPADAH_int28(data)                                              (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_KPADAH_int28_src(data)                                          ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_KPADAH_get_int28(data)                                          ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_KPADAH_write_data_shift                                         (0)
+#define ISO_UMSK_ISR_KPADAH_write_data_mask                                          (0x00000001)
+#define ISO_UMSK_ISR_KPADAH_write_data(data)                                         (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_KPADAH_write_data_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_KPADAH_get_write_data(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_KPADAL                                                          0x18007014
+#define ISO_UMSK_ISR_KPADAL_reg_addr                                                 "0xB8007014"
+#define ISO_UMSK_ISR_KPADAL_reg                                                      0xB8007014
+#define set_ISO_UMSK_ISR_KPADAL_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_KPADAL_reg)=data)
+#define get_ISO_UMSK_ISR_KPADAL_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_KPADAL_reg))
+#define ISO_UMSK_ISR_KPADAL_inst_adr                                                 "0x0005"
+#define ISO_UMSK_ISR_KPADAL_inst                                                     0x0005
+#define ISO_UMSK_ISR_KPADAL_int27_shift                                              (31)
+#define ISO_UMSK_ISR_KPADAL_int27_mask                                               (0x80000000)
+#define ISO_UMSK_ISR_KPADAL_int27(data)                                              (0x80000000&((data)<<31))
+#define ISO_UMSK_ISR_KPADAL_int27_src(data)                                          ((0x80000000&(data))>>31)
+#define ISO_UMSK_ISR_KPADAL_get_int27(data)                                          ((0x80000000&(data))>>31)
+#define ISO_UMSK_ISR_KPADAL_int26_shift                                              (30)
+#define ISO_UMSK_ISR_KPADAL_int26_mask                                               (0x40000000)
+#define ISO_UMSK_ISR_KPADAL_int26(data)                                              (0x40000000&((data)<<30))
+#define ISO_UMSK_ISR_KPADAL_int26_src(data)                                          ((0x40000000&(data))>>30)
+#define ISO_UMSK_ISR_KPADAL_get_int26(data)                                          ((0x40000000&(data))>>30)
+#define ISO_UMSK_ISR_KPADAL_int25_shift                                              (29)
+#define ISO_UMSK_ISR_KPADAL_int25_mask                                               (0x20000000)
+#define ISO_UMSK_ISR_KPADAL_int25(data)                                              (0x20000000&((data)<<29))
+#define ISO_UMSK_ISR_KPADAL_int25_src(data)                                          ((0x20000000&(data))>>29)
+#define ISO_UMSK_ISR_KPADAL_get_int25(data)                                          ((0x20000000&(data))>>29)
+#define ISO_UMSK_ISR_KPADAL_int24_shift                                              (28)
+#define ISO_UMSK_ISR_KPADAL_int24_mask                                               (0x10000000)
+#define ISO_UMSK_ISR_KPADAL_int24(data)                                              (0x10000000&((data)<<28))
+#define ISO_UMSK_ISR_KPADAL_int24_src(data)                                          ((0x10000000&(data))>>28)
+#define ISO_UMSK_ISR_KPADAL_get_int24(data)                                          ((0x10000000&(data))>>28)
+#define ISO_UMSK_ISR_KPADAL_int23_shift                                              (27)
+#define ISO_UMSK_ISR_KPADAL_int23_mask                                               (0x08000000)
+#define ISO_UMSK_ISR_KPADAL_int23(data)                                              (0x08000000&((data)<<27))
+#define ISO_UMSK_ISR_KPADAL_int23_src(data)                                          ((0x08000000&(data))>>27)
+#define ISO_UMSK_ISR_KPADAL_get_int23(data)                                          ((0x08000000&(data))>>27)
+#define ISO_UMSK_ISR_KPADAL_int22_shift                                              (26)
+#define ISO_UMSK_ISR_KPADAL_int22_mask                                               (0x04000000)
+#define ISO_UMSK_ISR_KPADAL_int22(data)                                              (0x04000000&((data)<<26))
+#define ISO_UMSK_ISR_KPADAL_int22_src(data)                                          ((0x04000000&(data))>>26)
+#define ISO_UMSK_ISR_KPADAL_get_int22(data)                                          ((0x04000000&(data))>>26)
+#define ISO_UMSK_ISR_KPADAL_int21_shift                                              (25)
+#define ISO_UMSK_ISR_KPADAL_int21_mask                                               (0x02000000)
+#define ISO_UMSK_ISR_KPADAL_int21(data)                                              (0x02000000&((data)<<25))
+#define ISO_UMSK_ISR_KPADAL_int21_src(data)                                          ((0x02000000&(data))>>25)
+#define ISO_UMSK_ISR_KPADAL_get_int21(data)                                          ((0x02000000&(data))>>25)
+#define ISO_UMSK_ISR_KPADAL_int20_shift                                              (24)
+#define ISO_UMSK_ISR_KPADAL_int20_mask                                               (0x01000000)
+#define ISO_UMSK_ISR_KPADAL_int20(data)                                              (0x01000000&((data)<<24))
+#define ISO_UMSK_ISR_KPADAL_int20_src(data)                                          ((0x01000000&(data))>>24)
+#define ISO_UMSK_ISR_KPADAL_get_int20(data)                                          ((0x01000000&(data))>>24)
+#define ISO_UMSK_ISR_KPADAL_int19_shift                                              (23)
+#define ISO_UMSK_ISR_KPADAL_int19_mask                                               (0x00800000)
+#define ISO_UMSK_ISR_KPADAL_int19(data)                                              (0x00800000&((data)<<23))
+#define ISO_UMSK_ISR_KPADAL_int19_src(data)                                          ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_KPADAL_get_int19(data)                                          ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_KPADAL_int18_shift                                              (22)
+#define ISO_UMSK_ISR_KPADAL_int18_mask                                               (0x00400000)
+#define ISO_UMSK_ISR_KPADAL_int18(data)                                              (0x00400000&((data)<<22))
+#define ISO_UMSK_ISR_KPADAL_int18_src(data)                                          ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_KPADAL_get_int18(data)                                          ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_KPADAL_int17_shift                                              (21)
+#define ISO_UMSK_ISR_KPADAL_int17_mask                                               (0x00200000)
+#define ISO_UMSK_ISR_KPADAL_int17(data)                                              (0x00200000&((data)<<21))
+#define ISO_UMSK_ISR_KPADAL_int17_src(data)                                          ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_KPADAL_get_int17(data)                                          ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_KPADAL_int16_shift                                              (20)
+#define ISO_UMSK_ISR_KPADAL_int16_mask                                               (0x00100000)
+#define ISO_UMSK_ISR_KPADAL_int16(data)                                              (0x00100000&((data)<<20))
+#define ISO_UMSK_ISR_KPADAL_int16_src(data)                                          ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_KPADAL_get_int16(data)                                          ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_KPADAL_int15_shift                                              (19)
+#define ISO_UMSK_ISR_KPADAL_int15_mask                                               (0x00080000)
+#define ISO_UMSK_ISR_KPADAL_int15(data)                                              (0x00080000&((data)<<19))
+#define ISO_UMSK_ISR_KPADAL_int15_src(data)                                          ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_KPADAL_get_int15(data)                                          ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_KPADAL_int14_shift                                              (18)
+#define ISO_UMSK_ISR_KPADAL_int14_mask                                               (0x00040000)
+#define ISO_UMSK_ISR_KPADAL_int14(data)                                              (0x00040000&((data)<<18))
+#define ISO_UMSK_ISR_KPADAL_int14_src(data)                                          ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_KPADAL_get_int14(data)                                          ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_KPADAL_int13_shift                                              (17)
+#define ISO_UMSK_ISR_KPADAL_int13_mask                                               (0x00020000)
+#define ISO_UMSK_ISR_KPADAL_int13(data)                                              (0x00020000&((data)<<17))
+#define ISO_UMSK_ISR_KPADAL_int13_src(data)                                          ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_KPADAL_get_int13(data)                                          ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_KPADAL_int12_shift                                              (16)
+#define ISO_UMSK_ISR_KPADAL_int12_mask                                               (0x00010000)
+#define ISO_UMSK_ISR_KPADAL_int12(data)                                              (0x00010000&((data)<<16))
+#define ISO_UMSK_ISR_KPADAL_int12_src(data)                                          ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_KPADAL_get_int12(data)                                          ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_KPADAL_int11_shift                                              (15)
+#define ISO_UMSK_ISR_KPADAL_int11_mask                                               (0x00008000)
+#define ISO_UMSK_ISR_KPADAL_int11(data)                                              (0x00008000&((data)<<15))
+#define ISO_UMSK_ISR_KPADAL_int11_src(data)                                          ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_KPADAL_get_int11(data)                                          ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_KPADAL_int10_shift                                              (14)
+#define ISO_UMSK_ISR_KPADAL_int10_mask                                               (0x00004000)
+#define ISO_UMSK_ISR_KPADAL_int10(data)                                              (0x00004000&((data)<<14))
+#define ISO_UMSK_ISR_KPADAL_int10_src(data)                                          ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_KPADAL_get_int10(data)                                          ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_KPADAL_int9_shift                                               (13)
+#define ISO_UMSK_ISR_KPADAL_int9_mask                                                (0x00002000)
+#define ISO_UMSK_ISR_KPADAL_int9(data)                                               (0x00002000&((data)<<13))
+#define ISO_UMSK_ISR_KPADAL_int9_src(data)                                           ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_KPADAL_get_int9(data)                                           ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_KPADAL_int8_shift                                               (12)
+#define ISO_UMSK_ISR_KPADAL_int8_mask                                                (0x00001000)
+#define ISO_UMSK_ISR_KPADAL_int8(data)                                               (0x00001000&((data)<<12))
+#define ISO_UMSK_ISR_KPADAL_int8_src(data)                                           ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_KPADAL_get_int8(data)                                           ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_KPADAL_int7_shift                                               (11)
+#define ISO_UMSK_ISR_KPADAL_int7_mask                                                (0x00000800)
+#define ISO_UMSK_ISR_KPADAL_int7(data)                                               (0x00000800&((data)<<11))
+#define ISO_UMSK_ISR_KPADAL_int7_src(data)                                           ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_KPADAL_get_int7(data)                                           ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_KPADAL_int6_shift                                               (10)
+#define ISO_UMSK_ISR_KPADAL_int6_mask                                                (0x00000400)
+#define ISO_UMSK_ISR_KPADAL_int6(data)                                               (0x00000400&((data)<<10))
+#define ISO_UMSK_ISR_KPADAL_int6_src(data)                                           ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_KPADAL_get_int6(data)                                           ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_KPADAL_int5_shift                                               (9)
+#define ISO_UMSK_ISR_KPADAL_int5_mask                                                (0x00000200)
+#define ISO_UMSK_ISR_KPADAL_int5(data)                                               (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_KPADAL_int5_src(data)                                           ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_KPADAL_get_int5(data)                                           ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_KPADAL_int4_shift                                               (8)
+#define ISO_UMSK_ISR_KPADAL_int4_mask                                                (0x00000100)
+#define ISO_UMSK_ISR_KPADAL_int4(data)                                               (0x00000100&((data)<<8))
+#define ISO_UMSK_ISR_KPADAL_int4_src(data)                                           ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_KPADAL_get_int4(data)                                           ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_KPADAL_int3_shift                                               (7)
+#define ISO_UMSK_ISR_KPADAL_int3_mask                                                (0x00000080)
+#define ISO_UMSK_ISR_KPADAL_int3(data)                                               (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_KPADAL_int3_src(data)                                           ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_KPADAL_get_int3(data)                                           ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_KPADAL_int2_shift                                               (6)
+#define ISO_UMSK_ISR_KPADAL_int2_mask                                                (0x00000040)
+#define ISO_UMSK_ISR_KPADAL_int2(data)                                               (0x00000040&((data)<<6))
+#define ISO_UMSK_ISR_KPADAL_int2_src(data)                                           ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_KPADAL_get_int2(data)                                           ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_KPADAL_int1_shift                                               (5)
+#define ISO_UMSK_ISR_KPADAL_int1_mask                                                (0x00000020)
+#define ISO_UMSK_ISR_KPADAL_int1(data)                                               (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_KPADAL_int1_src(data)                                           ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_KPADAL_get_int1(data)                                           ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_KPADAL_int0_shift                                               (4)
+#define ISO_UMSK_ISR_KPADAL_int0_mask                                                (0x00000010)
+#define ISO_UMSK_ISR_KPADAL_int0(data)                                               (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_KPADAL_int0_src(data)                                           ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_KPADAL_get_int0(data)                                           ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_KPADAL_write_data_shift                                         (0)
+#define ISO_UMSK_ISR_KPADAL_write_data_mask                                          (0x00000001)
+#define ISO_UMSK_ISR_KPADAL_write_data(data)                                         (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_KPADAL_write_data_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_KPADAL_get_write_data(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_KPADDAH                                                         0x18007018
+#define ISO_UMSK_ISR_KPADDAH_reg_addr                                                "0xB8007018"
+#define ISO_UMSK_ISR_KPADDAH_reg                                                     0xB8007018
+#define set_ISO_UMSK_ISR_KPADDAH_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_KPADDAH_reg)=data)
+#define get_ISO_UMSK_ISR_KPADDAH_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_KPADDAH_reg))
+#define ISO_UMSK_ISR_KPADDAH_inst_adr                                                "0x0006"
+#define ISO_UMSK_ISR_KPADDAH_inst                                                    0x0006
+#define ISO_UMSK_ISR_KPADDAH_int47_shift                                             (23)
+#define ISO_UMSK_ISR_KPADDAH_int47_mask                                              (0x00800000)
+#define ISO_UMSK_ISR_KPADDAH_int47(data)                                             (0x00800000&((data)<<23))
+#define ISO_UMSK_ISR_KPADDAH_int47_src(data)                                         ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_KPADDAH_get_int47(data)                                         ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_KPADDAH_int46_shift                                             (22)
+#define ISO_UMSK_ISR_KPADDAH_int46_mask                                              (0x00400000)
+#define ISO_UMSK_ISR_KPADDAH_int46(data)                                             (0x00400000&((data)<<22))
+#define ISO_UMSK_ISR_KPADDAH_int46_src(data)                                         ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_KPADDAH_get_int46(data)                                         ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_KPADDAH_int45_shift                                             (21)
+#define ISO_UMSK_ISR_KPADDAH_int45_mask                                              (0x00200000)
+#define ISO_UMSK_ISR_KPADDAH_int45(data)                                             (0x00200000&((data)<<21))
+#define ISO_UMSK_ISR_KPADDAH_int45_src(data)                                         ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_KPADDAH_get_int45(data)                                         ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_KPADDAH_int44_shift                                             (20)
+#define ISO_UMSK_ISR_KPADDAH_int44_mask                                              (0x00100000)
+#define ISO_UMSK_ISR_KPADDAH_int44(data)                                             (0x00100000&((data)<<20))
+#define ISO_UMSK_ISR_KPADDAH_int44_src(data)                                         ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_KPADDAH_get_int44(data)                                         ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_KPADDAH_int43_shift                                             (19)
+#define ISO_UMSK_ISR_KPADDAH_int43_mask                                              (0x00080000)
+#define ISO_UMSK_ISR_KPADDAH_int43(data)                                             (0x00080000&((data)<<19))
+#define ISO_UMSK_ISR_KPADDAH_int43_src(data)                                         ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_KPADDAH_get_int43(data)                                         ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_KPADDAH_int42_shift                                             (18)
+#define ISO_UMSK_ISR_KPADDAH_int42_mask                                              (0x00040000)
+#define ISO_UMSK_ISR_KPADDAH_int42(data)                                             (0x00040000&((data)<<18))
+#define ISO_UMSK_ISR_KPADDAH_int42_src(data)                                         ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_KPADDAH_get_int42(data)                                         ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_KPADDAH_int41_shift                                             (17)
+#define ISO_UMSK_ISR_KPADDAH_int41_mask                                              (0x00020000)
+#define ISO_UMSK_ISR_KPADDAH_int41(data)                                             (0x00020000&((data)<<17))
+#define ISO_UMSK_ISR_KPADDAH_int41_src(data)                                         ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_KPADDAH_get_int41(data)                                         ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_KPADDAH_int40_shift                                             (16)
+#define ISO_UMSK_ISR_KPADDAH_int40_mask                                              (0x00010000)
+#define ISO_UMSK_ISR_KPADDAH_int40(data)                                             (0x00010000&((data)<<16))
+#define ISO_UMSK_ISR_KPADDAH_int40_src(data)                                         ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_KPADDAH_get_int40(data)                                         ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_KPADDAH_int39_shift                                             (15)
+#define ISO_UMSK_ISR_KPADDAH_int39_mask                                              (0x00008000)
+#define ISO_UMSK_ISR_KPADDAH_int39(data)                                             (0x00008000&((data)<<15))
+#define ISO_UMSK_ISR_KPADDAH_int39_src(data)                                         ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_KPADDAH_get_int39(data)                                         ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_KPADDAH_int38_shift                                             (14)
+#define ISO_UMSK_ISR_KPADDAH_int38_mask                                              (0x00004000)
+#define ISO_UMSK_ISR_KPADDAH_int38(data)                                             (0x00004000&((data)<<14))
+#define ISO_UMSK_ISR_KPADDAH_int38_src(data)                                         ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_KPADDAH_get_int38(data)                                         ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_KPADDAH_int37_shift                                             (13)
+#define ISO_UMSK_ISR_KPADDAH_int37_mask                                              (0x00002000)
+#define ISO_UMSK_ISR_KPADDAH_int37(data)                                             (0x00002000&((data)<<13))
+#define ISO_UMSK_ISR_KPADDAH_int37_src(data)                                         ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_KPADDAH_get_int37(data)                                         ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_KPADDAH_int36_shift                                             (12)
+#define ISO_UMSK_ISR_KPADDAH_int36_mask                                              (0x00001000)
+#define ISO_UMSK_ISR_KPADDAH_int36(data)                                             (0x00001000&((data)<<12))
+#define ISO_UMSK_ISR_KPADDAH_int36_src(data)                                         ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_KPADDAH_get_int36(data)                                         ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_KPADDAH_int35_shift                                             (11)
+#define ISO_UMSK_ISR_KPADDAH_int35_mask                                              (0x00000800)
+#define ISO_UMSK_ISR_KPADDAH_int35(data)                                             (0x00000800&((data)<<11))
+#define ISO_UMSK_ISR_KPADDAH_int35_src(data)                                         ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_KPADDAH_get_int35(data)                                         ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_KPADDAH_int34_shift                                             (10)
+#define ISO_UMSK_ISR_KPADDAH_int34_mask                                              (0x00000400)
+#define ISO_UMSK_ISR_KPADDAH_int34(data)                                             (0x00000400&((data)<<10))
+#define ISO_UMSK_ISR_KPADDAH_int34_src(data)                                         ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_KPADDAH_get_int34(data)                                         ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_KPADDAH_int33_shift                                             (9)
+#define ISO_UMSK_ISR_KPADDAH_int33_mask                                              (0x00000200)
+#define ISO_UMSK_ISR_KPADDAH_int33(data)                                             (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_KPADDAH_int33_src(data)                                         ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_KPADDAH_get_int33(data)                                         ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_KPADDAH_int32_shift                                             (8)
+#define ISO_UMSK_ISR_KPADDAH_int32_mask                                              (0x00000100)
+#define ISO_UMSK_ISR_KPADDAH_int32(data)                                             (0x00000100&((data)<<8))
+#define ISO_UMSK_ISR_KPADDAH_int32_src(data)                                         ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_KPADDAH_get_int32(data)                                         ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_KPADDAH_int31_shift                                             (7)
+#define ISO_UMSK_ISR_KPADDAH_int31_mask                                              (0x00000080)
+#define ISO_UMSK_ISR_KPADDAH_int31(data)                                             (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_KPADDAH_int31_src(data)                                         ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_KPADDAH_get_int31(data)                                         ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_KPADDAH_int30_shift                                             (6)
+#define ISO_UMSK_ISR_KPADDAH_int30_mask                                              (0x00000040)
+#define ISO_UMSK_ISR_KPADDAH_int30(data)                                             (0x00000040&((data)<<6))
+#define ISO_UMSK_ISR_KPADDAH_int30_src(data)                                         ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_KPADDAH_get_int30(data)                                         ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_KPADDAH_int29_shift                                             (5)
+#define ISO_UMSK_ISR_KPADDAH_int29_mask                                              (0x00000020)
+#define ISO_UMSK_ISR_KPADDAH_int29(data)                                             (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_KPADDAH_int29_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_KPADDAH_get_int29(data)                                         ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_KPADDAH_int28_shift                                             (4)
+#define ISO_UMSK_ISR_KPADDAH_int28_mask                                              (0x00000010)
+#define ISO_UMSK_ISR_KPADDAH_int28(data)                                             (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_KPADDAH_int28_src(data)                                         ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_KPADDAH_get_int28(data)                                         ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_KPADDAH_write_data_shift                                        (0)
+#define ISO_UMSK_ISR_KPADDAH_write_data_mask                                         (0x00000001)
+#define ISO_UMSK_ISR_KPADDAH_write_data(data)                                        (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_KPADDAH_write_data_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_KPADDAH_get_write_data(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_KPADDAL                                                         0x1800701C
+#define ISO_UMSK_ISR_KPADDAL_reg_addr                                                "0xB800701C"
+#define ISO_UMSK_ISR_KPADDAL_reg                                                     0xB800701C
+#define set_ISO_UMSK_ISR_KPADDAL_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_KPADDAL_reg)=data)
+#define get_ISO_UMSK_ISR_KPADDAL_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_KPADDAL_reg))
+#define ISO_UMSK_ISR_KPADDAL_inst_adr                                                "0x0007"
+#define ISO_UMSK_ISR_KPADDAL_inst                                                    0x0007
+#define ISO_UMSK_ISR_KPADDAL_int27_shift                                             (31)
+#define ISO_UMSK_ISR_KPADDAL_int27_mask                                              (0x80000000)
+#define ISO_UMSK_ISR_KPADDAL_int27(data)                                             (0x80000000&((data)<<31))
+#define ISO_UMSK_ISR_KPADDAL_int27_src(data)                                         ((0x80000000&(data))>>31)
+#define ISO_UMSK_ISR_KPADDAL_get_int27(data)                                         ((0x80000000&(data))>>31)
+#define ISO_UMSK_ISR_KPADDAL_int26_shift                                             (30)
+#define ISO_UMSK_ISR_KPADDAL_int26_mask                                              (0x40000000)
+#define ISO_UMSK_ISR_KPADDAL_int26(data)                                             (0x40000000&((data)<<30))
+#define ISO_UMSK_ISR_KPADDAL_int26_src(data)                                         ((0x40000000&(data))>>30)
+#define ISO_UMSK_ISR_KPADDAL_get_int26(data)                                         ((0x40000000&(data))>>30)
+#define ISO_UMSK_ISR_KPADDAL_int25_shift                                             (29)
+#define ISO_UMSK_ISR_KPADDAL_int25_mask                                              (0x20000000)
+#define ISO_UMSK_ISR_KPADDAL_int25(data)                                             (0x20000000&((data)<<29))
+#define ISO_UMSK_ISR_KPADDAL_int25_src(data)                                         ((0x20000000&(data))>>29)
+#define ISO_UMSK_ISR_KPADDAL_get_int25(data)                                         ((0x20000000&(data))>>29)
+#define ISO_UMSK_ISR_KPADDAL_int24_shift                                             (28)
+#define ISO_UMSK_ISR_KPADDAL_int24_mask                                              (0x10000000)
+#define ISO_UMSK_ISR_KPADDAL_int24(data)                                             (0x10000000&((data)<<28))
+#define ISO_UMSK_ISR_KPADDAL_int24_src(data)                                         ((0x10000000&(data))>>28)
+#define ISO_UMSK_ISR_KPADDAL_get_int24(data)                                         ((0x10000000&(data))>>28)
+#define ISO_UMSK_ISR_KPADDAL_int23_shift                                             (27)
+#define ISO_UMSK_ISR_KPADDAL_int23_mask                                              (0x08000000)
+#define ISO_UMSK_ISR_KPADDAL_int23(data)                                             (0x08000000&((data)<<27))
+#define ISO_UMSK_ISR_KPADDAL_int23_src(data)                                         ((0x08000000&(data))>>27)
+#define ISO_UMSK_ISR_KPADDAL_get_int23(data)                                         ((0x08000000&(data))>>27)
+#define ISO_UMSK_ISR_KPADDAL_int22_shift                                             (26)
+#define ISO_UMSK_ISR_KPADDAL_int22_mask                                              (0x04000000)
+#define ISO_UMSK_ISR_KPADDAL_int22(data)                                             (0x04000000&((data)<<26))
+#define ISO_UMSK_ISR_KPADDAL_int22_src(data)                                         ((0x04000000&(data))>>26)
+#define ISO_UMSK_ISR_KPADDAL_get_int22(data)                                         ((0x04000000&(data))>>26)
+#define ISO_UMSK_ISR_KPADDAL_int21_shift                                             (25)
+#define ISO_UMSK_ISR_KPADDAL_int21_mask                                              (0x02000000)
+#define ISO_UMSK_ISR_KPADDAL_int21(data)                                             (0x02000000&((data)<<25))
+#define ISO_UMSK_ISR_KPADDAL_int21_src(data)                                         ((0x02000000&(data))>>25)
+#define ISO_UMSK_ISR_KPADDAL_get_int21(data)                                         ((0x02000000&(data))>>25)
+#define ISO_UMSK_ISR_KPADDAL_int20_shift                                             (24)
+#define ISO_UMSK_ISR_KPADDAL_int20_mask                                              (0x01000000)
+#define ISO_UMSK_ISR_KPADDAL_int20(data)                                             (0x01000000&((data)<<24))
+#define ISO_UMSK_ISR_KPADDAL_int20_src(data)                                         ((0x01000000&(data))>>24)
+#define ISO_UMSK_ISR_KPADDAL_get_int20(data)                                         ((0x01000000&(data))>>24)
+#define ISO_UMSK_ISR_KPADDAL_int19_shift                                             (23)
+#define ISO_UMSK_ISR_KPADDAL_int19_mask                                              (0x00800000)
+#define ISO_UMSK_ISR_KPADDAL_int19(data)                                             (0x00800000&((data)<<23))
+#define ISO_UMSK_ISR_KPADDAL_int19_src(data)                                         ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_KPADDAL_get_int19(data)                                         ((0x00800000&(data))>>23)
+#define ISO_UMSK_ISR_KPADDAL_int18_shift                                             (22)
+#define ISO_UMSK_ISR_KPADDAL_int18_mask                                              (0x00400000)
+#define ISO_UMSK_ISR_KPADDAL_int18(data)                                             (0x00400000&((data)<<22))
+#define ISO_UMSK_ISR_KPADDAL_int18_src(data)                                         ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_KPADDAL_get_int18(data)                                         ((0x00400000&(data))>>22)
+#define ISO_UMSK_ISR_KPADDAL_int17_shift                                             (21)
+#define ISO_UMSK_ISR_KPADDAL_int17_mask                                              (0x00200000)
+#define ISO_UMSK_ISR_KPADDAL_int17(data)                                             (0x00200000&((data)<<21))
+#define ISO_UMSK_ISR_KPADDAL_int17_src(data)                                         ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_KPADDAL_get_int17(data)                                         ((0x00200000&(data))>>21)
+#define ISO_UMSK_ISR_KPADDAL_int16_shift                                             (20)
+#define ISO_UMSK_ISR_KPADDAL_int16_mask                                              (0x00100000)
+#define ISO_UMSK_ISR_KPADDAL_int16(data)                                             (0x00100000&((data)<<20))
+#define ISO_UMSK_ISR_KPADDAL_int16_src(data)                                         ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_KPADDAL_get_int16(data)                                         ((0x00100000&(data))>>20)
+#define ISO_UMSK_ISR_KPADDAL_int15_shift                                             (19)
+#define ISO_UMSK_ISR_KPADDAL_int15_mask                                              (0x00080000)
+#define ISO_UMSK_ISR_KPADDAL_int15(data)                                             (0x00080000&((data)<<19))
+#define ISO_UMSK_ISR_KPADDAL_int15_src(data)                                         ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_KPADDAL_get_int15(data)                                         ((0x00080000&(data))>>19)
+#define ISO_UMSK_ISR_KPADDAL_int14_shift                                             (18)
+#define ISO_UMSK_ISR_KPADDAL_int14_mask                                              (0x00040000)
+#define ISO_UMSK_ISR_KPADDAL_int14(data)                                             (0x00040000&((data)<<18))
+#define ISO_UMSK_ISR_KPADDAL_int14_src(data)                                         ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_KPADDAL_get_int14(data)                                         ((0x00040000&(data))>>18)
+#define ISO_UMSK_ISR_KPADDAL_int13_shift                                             (17)
+#define ISO_UMSK_ISR_KPADDAL_int13_mask                                              (0x00020000)
+#define ISO_UMSK_ISR_KPADDAL_int13(data)                                             (0x00020000&((data)<<17))
+#define ISO_UMSK_ISR_KPADDAL_int13_src(data)                                         ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_KPADDAL_get_int13(data)                                         ((0x00020000&(data))>>17)
+#define ISO_UMSK_ISR_KPADDAL_int12_shift                                             (16)
+#define ISO_UMSK_ISR_KPADDAL_int12_mask                                              (0x00010000)
+#define ISO_UMSK_ISR_KPADDAL_int12(data)                                             (0x00010000&((data)<<16))
+#define ISO_UMSK_ISR_KPADDAL_int12_src(data)                                         ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_KPADDAL_get_int12(data)                                         ((0x00010000&(data))>>16)
+#define ISO_UMSK_ISR_KPADDAL_int11_shift                                             (15)
+#define ISO_UMSK_ISR_KPADDAL_int11_mask                                              (0x00008000)
+#define ISO_UMSK_ISR_KPADDAL_int11(data)                                             (0x00008000&((data)<<15))
+#define ISO_UMSK_ISR_KPADDAL_int11_src(data)                                         ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_KPADDAL_get_int11(data)                                         ((0x00008000&(data))>>15)
+#define ISO_UMSK_ISR_KPADDAL_int10_shift                                             (14)
+#define ISO_UMSK_ISR_KPADDAL_int10_mask                                              (0x00004000)
+#define ISO_UMSK_ISR_KPADDAL_int10(data)                                             (0x00004000&((data)<<14))
+#define ISO_UMSK_ISR_KPADDAL_int10_src(data)                                         ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_KPADDAL_get_int10(data)                                         ((0x00004000&(data))>>14)
+#define ISO_UMSK_ISR_KPADDAL_int9_shift                                              (13)
+#define ISO_UMSK_ISR_KPADDAL_int9_mask                                               (0x00002000)
+#define ISO_UMSK_ISR_KPADDAL_int9(data)                                              (0x00002000&((data)<<13))
+#define ISO_UMSK_ISR_KPADDAL_int9_src(data)                                          ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_KPADDAL_get_int9(data)                                          ((0x00002000&(data))>>13)
+#define ISO_UMSK_ISR_KPADDAL_int8_shift                                              (12)
+#define ISO_UMSK_ISR_KPADDAL_int8_mask                                               (0x00001000)
+#define ISO_UMSK_ISR_KPADDAL_int8(data)                                              (0x00001000&((data)<<12))
+#define ISO_UMSK_ISR_KPADDAL_int8_src(data)                                          ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_KPADDAL_get_int8(data)                                          ((0x00001000&(data))>>12)
+#define ISO_UMSK_ISR_KPADDAL_int7_shift                                              (11)
+#define ISO_UMSK_ISR_KPADDAL_int7_mask                                               (0x00000800)
+#define ISO_UMSK_ISR_KPADDAL_int7(data)                                              (0x00000800&((data)<<11))
+#define ISO_UMSK_ISR_KPADDAL_int7_src(data)                                          ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_KPADDAL_get_int7(data)                                          ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_KPADDAL_int6_shift                                              (10)
+#define ISO_UMSK_ISR_KPADDAL_int6_mask                                               (0x00000400)
+#define ISO_UMSK_ISR_KPADDAL_int6(data)                                              (0x00000400&((data)<<10))
+#define ISO_UMSK_ISR_KPADDAL_int6_src(data)                                          ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_KPADDAL_get_int6(data)                                          ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_KPADDAL_int5_shift                                              (9)
+#define ISO_UMSK_ISR_KPADDAL_int5_mask                                               (0x00000200)
+#define ISO_UMSK_ISR_KPADDAL_int5(data)                                              (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_KPADDAL_int5_src(data)                                          ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_KPADDAL_get_int5(data)                                          ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_KPADDAL_int4_shift                                              (8)
+#define ISO_UMSK_ISR_KPADDAL_int4_mask                                               (0x00000100)
+#define ISO_UMSK_ISR_KPADDAL_int4(data)                                              (0x00000100&((data)<<8))
+#define ISO_UMSK_ISR_KPADDAL_int4_src(data)                                          ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_KPADDAL_get_int4(data)                                          ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_KPADDAL_int3_shift                                              (7)
+#define ISO_UMSK_ISR_KPADDAL_int3_mask                                               (0x00000080)
+#define ISO_UMSK_ISR_KPADDAL_int3(data)                                              (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_KPADDAL_int3_src(data)                                          ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_KPADDAL_get_int3(data)                                          ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_KPADDAL_int2_shift                                              (6)
+#define ISO_UMSK_ISR_KPADDAL_int2_mask                                               (0x00000040)
+#define ISO_UMSK_ISR_KPADDAL_int2(data)                                              (0x00000040&((data)<<6))
+#define ISO_UMSK_ISR_KPADDAL_int2_src(data)                                          ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_KPADDAL_get_int2(data)                                          ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_KPADDAL_int1_shift                                              (5)
+#define ISO_UMSK_ISR_KPADDAL_int1_mask                                               (0x00000020)
+#define ISO_UMSK_ISR_KPADDAL_int1(data)                                              (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_KPADDAL_int1_src(data)                                          ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_KPADDAL_get_int1(data)                                          ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_KPADDAL_int0_shift                                              (4)
+#define ISO_UMSK_ISR_KPADDAL_int0_mask                                               (0x00000010)
+#define ISO_UMSK_ISR_KPADDAL_int0(data)                                              (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_KPADDAL_int0_src(data)                                          ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_KPADDAL_get_int0(data)                                          ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_KPADDAL_write_data_shift                                        (0)
+#define ISO_UMSK_ISR_KPADDAL_write_data_mask                                         (0x00000001)
+#define ISO_UMSK_ISR_KPADDAL_write_data(data)                                        (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_KPADDAL_write_data_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_KPADDAL_get_write_data(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_UMSK_ISR_SW                                                              0x18007020
+#define ISO_UMSK_ISR_SW_reg_addr                                                     "0xB8007020"
+#define ISO_UMSK_ISR_SW_reg                                                          0xB8007020
+#define set_ISO_UMSK_ISR_SW_reg(data)   (*((volatile unsigned int*) ISO_UMSK_ISR_SW_reg)=data)
+#define get_ISO_UMSK_ISR_SW_reg   (*((volatile unsigned int*) ISO_UMSK_ISR_SW_reg))
+#define ISO_UMSK_ISR_SW_inst_adr                                                     "0x0008"
+#define ISO_UMSK_ISR_SW_inst                                                         0x0008
+#define ISO_UMSK_ISR_SW_da_int3_shift                                                (11)
+#define ISO_UMSK_ISR_SW_da_int3_mask                                                 (0x00000800)
+#define ISO_UMSK_ISR_SW_da_int3(data)                                                (0x00000800&((data)<<11))
+#define ISO_UMSK_ISR_SW_da_int3_src(data)                                            ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_SW_get_da_int3(data)                                            ((0x00000800&(data))>>11)
+#define ISO_UMSK_ISR_SW_da_int2_shift                                                (10)
+#define ISO_UMSK_ISR_SW_da_int2_mask                                                 (0x00000400)
+#define ISO_UMSK_ISR_SW_da_int2(data)                                                (0x00000400&((data)<<10))
+#define ISO_UMSK_ISR_SW_da_int2_src(data)                                            ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_SW_get_da_int2(data)                                            ((0x00000400&(data))>>10)
+#define ISO_UMSK_ISR_SW_da_int1_shift                                                (9)
+#define ISO_UMSK_ISR_SW_da_int1_mask                                                 (0x00000200)
+#define ISO_UMSK_ISR_SW_da_int1(data)                                                (0x00000200&((data)<<9))
+#define ISO_UMSK_ISR_SW_da_int1_src(data)                                            ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_SW_get_da_int1(data)                                            ((0x00000200&(data))>>9)
+#define ISO_UMSK_ISR_SW_da_int0_shift                                                (8)
+#define ISO_UMSK_ISR_SW_da_int0_mask                                                 (0x00000100)
+#define ISO_UMSK_ISR_SW_da_int0(data)                                                (0x00000100&((data)<<8))
+#define ISO_UMSK_ISR_SW_da_int0_src(data)                                            ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_SW_get_da_int0(data)                                            ((0x00000100&(data))>>8)
+#define ISO_UMSK_ISR_SW_a_int3_shift                                                 (7)
+#define ISO_UMSK_ISR_SW_a_int3_mask                                                  (0x00000080)
+#define ISO_UMSK_ISR_SW_a_int3(data)                                                 (0x00000080&((data)<<7))
+#define ISO_UMSK_ISR_SW_a_int3_src(data)                                             ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_SW_get_a_int3(data)                                             ((0x00000080&(data))>>7)
+#define ISO_UMSK_ISR_SW_a_int2_shift                                                 (6)
+#define ISO_UMSK_ISR_SW_a_int2_mask                                                  (0x00000040)
+#define ISO_UMSK_ISR_SW_a_int2(data)                                                 (0x00000040&((data)<<6))
+#define ISO_UMSK_ISR_SW_a_int2_src(data)                                             ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_SW_get_a_int2(data)                                             ((0x00000040&(data))>>6)
+#define ISO_UMSK_ISR_SW_a_int1_shift                                                 (5)
+#define ISO_UMSK_ISR_SW_a_int1_mask                                                  (0x00000020)
+#define ISO_UMSK_ISR_SW_a_int1(data)                                                 (0x00000020&((data)<<5))
+#define ISO_UMSK_ISR_SW_a_int1_src(data)                                             ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_SW_get_a_int1(data)                                             ((0x00000020&(data))>>5)
+#define ISO_UMSK_ISR_SW_a_int0_shift                                                 (4)
+#define ISO_UMSK_ISR_SW_a_int0_mask                                                  (0x00000010)
+#define ISO_UMSK_ISR_SW_a_int0(data)                                                 (0x00000010&((data)<<4))
+#define ISO_UMSK_ISR_SW_a_int0_src(data)                                             ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_SW_get_a_int0(data)                                             ((0x00000010&(data))>>4)
+#define ISO_UMSK_ISR_SW_write_data_shift                                             (0)
+#define ISO_UMSK_ISR_SW_write_data_mask                                              (0x00000001)
+#define ISO_UMSK_ISR_SW_write_data(data)                                             (0x00000001&((data)<<0))
+#define ISO_UMSK_ISR_SW_write_data_src(data)                                         ((0x00000001&(data))>>0)
+#define ISO_UMSK_ISR_SW_get_write_data(data)                                         ((0x00000001&(data))>>0)
+
+
+#define ISO_DBG                                                                      0x18007024
+#define ISO_DBG_reg_addr                                                             "0xB8007024"
+#define ISO_DBG_reg                                                                  0xB8007024
+#define set_ISO_DBG_reg(data)   (*((volatile unsigned int*) ISO_DBG_reg)=data)
+#define get_ISO_DBG_reg   (*((volatile unsigned int*) ISO_DBG_reg))
+#define ISO_DBG_inst_adr                                                             "0x0009"
+#define ISO_DBG_inst                                                                 0x0009
+#define ISO_DBG_write_en5_shift                                                      (31)
+#define ISO_DBG_write_en5_mask                                                       (0x80000000)
+#define ISO_DBG_write_en5(data)                                                      (0x80000000&((data)<<31))
+#define ISO_DBG_write_en5_src(data)                                                  ((0x80000000&(data))>>31)
+#define ISO_DBG_get_write_en5(data)                                                  ((0x80000000&(data))>>31)
+#define ISO_DBG_standby_dbg_sel_shift                                                (24)
+#define ISO_DBG_standby_dbg_sel_mask                                                 (0x7F000000)
+#define ISO_DBG_standby_dbg_sel(data)                                                (0x7F000000&((data)<<24))
+#define ISO_DBG_standby_dbg_sel_src(data)                                            ((0x7F000000&(data))>>24)
+#define ISO_DBG_get_standby_dbg_sel(data)                                            ((0x7F000000&(data))>>24)
+#define ISO_DBG_write_en4_shift                                                      (23)
+#define ISO_DBG_write_en4_mask                                                       (0x00800000)
+#define ISO_DBG_write_en4(data)                                                      (0x00800000&((data)<<23))
+#define ISO_DBG_write_en4_src(data)                                                  ((0x00800000&(data))>>23)
+#define ISO_DBG_get_write_en4(data)                                                  ((0x00800000&(data))>>23)
+#define ISO_DBG_standby_dbg_en_shift                                                 (20)
+#define ISO_DBG_standby_dbg_en_mask                                                  (0x00100000)
+#define ISO_DBG_standby_dbg_en(data)                                                 (0x00100000&((data)<<20))
+#define ISO_DBG_standby_dbg_en_src(data)                                             ((0x00100000&(data))>>20)
+#define ISO_DBG_get_standby_dbg_en(data)                                             ((0x00100000&(data))>>20)
+#define ISO_DBG_write_en3_shift                                                      (19)
+#define ISO_DBG_write_en3_mask                                                       (0x00080000)
+#define ISO_DBG_write_en3(data)                                                      (0x00080000&((data)<<19))
+#define ISO_DBG_write_en3_src(data)                                                  ((0x00080000&(data))>>19)
+#define ISO_DBG_get_write_en3(data)                                                  ((0x00080000&(data))>>19)
+#define ISO_DBG_sel1_shift                                                           (12)
+#define ISO_DBG_sel1_mask                                                            (0x0000F000)
+#define ISO_DBG_sel1(data)                                                           (0x0000F000&((data)<<12))
+#define ISO_DBG_sel1_src(data)                                                       ((0x0000F000&(data))>>12)
+#define ISO_DBG_get_sel1(data)                                                       ((0x0000F000&(data))>>12)
+#define ISO_DBG_write_en2_shift                                                      (11)
+#define ISO_DBG_write_en2_mask                                                       (0x00000800)
+#define ISO_DBG_write_en2(data)                                                      (0x00000800&((data)<<11))
+#define ISO_DBG_write_en2_src(data)                                                  ((0x00000800&(data))>>11)
+#define ISO_DBG_get_write_en2(data)                                                  ((0x00000800&(data))>>11)
+#define ISO_DBG_sel0_shift                                                           (4)
+#define ISO_DBG_sel0_mask                                                            (0x000000F0)
+#define ISO_DBG_sel0(data)                                                           (0x000000F0&((data)<<4))
+#define ISO_DBG_sel0_src(data)                                                       ((0x000000F0&(data))>>4)
+#define ISO_DBG_get_sel0(data)                                                       ((0x000000F0&(data))>>4)
+#define ISO_DBG_write_en1_shift                                                      (3)
+#define ISO_DBG_write_en1_mask                                                       (0x00000008)
+#define ISO_DBG_write_en1(data)                                                      (0x00000008&((data)<<3))
+#define ISO_DBG_write_en1_src(data)                                                  ((0x00000008&(data))>>3)
+#define ISO_DBG_get_write_en1(data)                                                  ((0x00000008&(data))>>3)
+#define ISO_DBG_enable_shift                                                         (0)
+#define ISO_DBG_enable_mask                                                          (0x00000001)
+#define ISO_DBG_enable(data)                                                         (0x00000001&((data)<<0))
+#define ISO_DBG_enable_src(data)                                                     ((0x00000001&(data))>>0)
+#define ISO_DBG_get_enable(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_CHIP_INFO1                                                               0x18007028
+#define ISO_CHIP_INFO1_reg_addr                                                      "0xB8007028"
+#define ISO_CHIP_INFO1_reg                                                           0xB8007028
+#define set_ISO_CHIP_INFO1_reg(data)   (*((volatile unsigned int*) ISO_CHIP_INFO1_reg)=data)
+#define get_ISO_CHIP_INFO1_reg   (*((volatile unsigned int*) ISO_CHIP_INFO1_reg))
+#define ISO_CHIP_INFO1_inst_adr                                                      "0x000A"
+#define ISO_CHIP_INFO1_inst                                                          0x000A
+#define ISO_CHIP_INFO1_testmode_shift                                                (14)
+#define ISO_CHIP_INFO1_testmode_mask                                                 (0x00004000)
+#define ISO_CHIP_INFO1_testmode(data)                                                (0x00004000&((data)<<14))
+#define ISO_CHIP_INFO1_testmode_src(data)                                            ((0x00004000&(data))>>14)
+#define ISO_CHIP_INFO1_get_testmode(data)                                            ((0x00004000&(data))>>14)
+#define ISO_CHIP_INFO1_boot_sel_shift                                                (13)
+#define ISO_CHIP_INFO1_boot_sel_mask                                                 (0x00002000)
+#define ISO_CHIP_INFO1_boot_sel(data)                                                (0x00002000&((data)<<13))
+#define ISO_CHIP_INFO1_boot_sel_src(data)                                            ((0x00002000&(data))>>13)
+#define ISO_CHIP_INFO1_get_boot_sel(data)                                            ((0x00002000&(data))>>13)
+#define ISO_CHIP_INFO1_bound_opt_shift                                               (0)
+#define ISO_CHIP_INFO1_bound_opt_mask                                                (0x00001FFF)
+#define ISO_CHIP_INFO1_bound_opt(data)                                               (0x00001FFF&((data)<<0))
+#define ISO_CHIP_INFO1_bound_opt_src(data)                                           ((0x00001FFF&(data))>>0)
+#define ISO_CHIP_INFO1_get_bound_opt(data)                                           ((0x00001FFF&(data))>>0)
+
+
+#define ISO_CHIP_INFO2                                                               0x1800702C
+#define ISO_CHIP_INFO2_reg_addr                                                      "0xB800702C"
+#define ISO_CHIP_INFO2_reg                                                           0xB800702C
+#define set_ISO_CHIP_INFO2_reg(data)   (*((volatile unsigned int*) ISO_CHIP_INFO2_reg)=data)
+#define get_ISO_CHIP_INFO2_reg   (*((volatile unsigned int*) ISO_CHIP_INFO2_reg))
+#define ISO_CHIP_INFO2_inst_adr                                                      "0x000B"
+#define ISO_CHIP_INFO2_inst                                                          0x000B
+#define ISO_CHIP_INFO2_pow_latch_shift                                               (0)
+#define ISO_CHIP_INFO2_pow_latch_mask                                                (0x0007FFFF)
+#define ISO_CHIP_INFO2_pow_latch(data)                                               (0x0007FFFF&((data)<<0))
+#define ISO_CHIP_INFO2_pow_latch_src(data)                                           ((0x0007FFFF&(data))>>0)
+#define ISO_CHIP_INFO2_get_pow_latch(data)                                           ((0x0007FFFF&(data))>>0)
+
+
+#define ISO_CTRL                                                                     0x18007030
+#define ISO_CTRL_reg_addr                                                            "0xB8007030"
+#define ISO_CTRL_reg                                                                 0xB8007030
+#define set_ISO_CTRL_reg(data)   (*((volatile unsigned int*) ISO_CTRL_reg)=data)
+#define get_ISO_CTRL_reg   (*((volatile unsigned int*) ISO_CTRL_reg))
+#define ISO_CTRL_inst_adr                                                            "0x000C"
+#define ISO_CTRL_inst                                                                0x000C
+#define ISO_CTRL_write_en9_shift                                                     (17)
+#define ISO_CTRL_write_en9_mask                                                      (0x00020000)
+#define ISO_CTRL_write_en9(data)                                                     (0x00020000&((data)<<17))
+#define ISO_CTRL_write_en9_src(data)                                                 ((0x00020000&(data))>>17)
+#define ISO_CTRL_get_write_en9(data)                                                 ((0x00020000&(data))>>17)
+#define ISO_CTRL_iso_rst_wd_mask_shift                                               (16)
+#define ISO_CTRL_iso_rst_wd_mask_mask                                                (0x00010000)
+#define ISO_CTRL_iso_rst_wd_mask(data)                                               (0x00010000&((data)<<16))
+#define ISO_CTRL_iso_rst_wd_mask_src(data)                                           ((0x00010000&(data))>>16)
+#define ISO_CTRL_get_iso_rst_wd_mask(data)                                           ((0x00010000&(data))>>16)
+#define ISO_CTRL_write_en8_shift                                                     (15)
+#define ISO_CTRL_write_en8_mask                                                      (0x00008000)
+#define ISO_CTRL_write_en8(data)                                                     (0x00008000&((data)<<15))
+#define ISO_CTRL_write_en8_src(data)                                                 ((0x00008000&(data))>>15)
+#define ISO_CTRL_get_write_en8(data)                                                 ((0x00008000&(data))>>15)
+#define ISO_CTRL_dc_phy_cke_pd_shift                                                 (14)
+#define ISO_CTRL_dc_phy_cke_pd_mask                                                  (0x00004000)
+#define ISO_CTRL_dc_phy_cke_pd(data)                                                 (0x00004000&((data)<<14))
+#define ISO_CTRL_dc_phy_cke_pd_src(data)                                             ((0x00004000&(data))>>14)
+#define ISO_CTRL_get_dc_phy_cke_pd(data)                                             ((0x00004000&(data))>>14)
+#define ISO_CTRL_write_en7_shift                                                     (13)
+#define ISO_CTRL_write_en7_mask                                                      (0x00002000)
+#define ISO_CTRL_write_en7(data)                                                     (0x00002000&((data)<<13))
+#define ISO_CTRL_write_en7_src(data)                                                 ((0x00002000&(data))>>13)
+#define ISO_CTRL_get_write_en7(data)                                                 ((0x00002000&(data))>>13)
+#define ISO_CTRL_iso_mis_clk_en_shift                                                (12)
+#define ISO_CTRL_iso_mis_clk_en_mask                                                 (0x00001000)
+#define ISO_CTRL_iso_mis_clk_en(data)                                                (0x00001000&((data)<<12))
+#define ISO_CTRL_iso_mis_clk_en_src(data)                                            ((0x00001000&(data))>>12)
+#define ISO_CTRL_get_iso_mis_clk_en(data)                                            ((0x00001000&(data))>>12)
+#define ISO_CTRL_write_en6_shift                                                     (11)
+#define ISO_CTRL_write_en6_mask                                                      (0x00000800)
+#define ISO_CTRL_write_en6(data)                                                     (0x00000800&((data)<<11))
+#define ISO_CTRL_write_en6_src(data)                                                 ((0x00000800&(data))>>11)
+#define ISO_CTRL_get_write_en6(data)                                                 ((0x00000800&(data))>>11)
+#define ISO_CTRL_iso_rbus_sel_shift                                                  (10)
+#define ISO_CTRL_iso_rbus_sel_mask                                                   (0x00000400)
+#define ISO_CTRL_iso_rbus_sel(data)                                                  (0x00000400&((data)<<10))
+#define ISO_CTRL_iso_rbus_sel_src(data)                                              ((0x00000400&(data))>>10)
+#define ISO_CTRL_get_iso_rbus_sel(data)                                              ((0x00000400&(data))>>10)
+#define ISO_CTRL_write_en5_shift                                                     (9)
+#define ISO_CTRL_write_en5_mask                                                      (0x00000200)
+#define ISO_CTRL_write_en5(data)                                                     (0x00000200&((data)<<9))
+#define ISO_CTRL_write_en5_src(data)                                                 ((0x00000200&(data))>>9)
+#define ISO_CTRL_get_write_en5(data)                                                 ((0x00000200&(data))>>9)
+#define ISO_CTRL_iso_rst_mask_shift                                                  (8)
+#define ISO_CTRL_iso_rst_mask_mask                                                   (0x00000100)
+#define ISO_CTRL_iso_rst_mask(data)                                                  (0x00000100&((data)<<8))
+#define ISO_CTRL_iso_rst_mask_src(data)                                              ((0x00000100&(data))>>8)
+#define ISO_CTRL_get_iso_rst_mask(data)                                              ((0x00000100&(data))>>8)
+#define ISO_CTRL_write_en4_shift                                                     (7)
+#define ISO_CTRL_write_en4_mask                                                      (0x00000080)
+#define ISO_CTRL_write_en4(data)                                                     (0x00000080&((data)<<7))
+#define ISO_CTRL_write_en4_src(data)                                                 ((0x00000080&(data))>>7)
+#define ISO_CTRL_get_write_en4(data)                                                 ((0x00000080&(data))>>7)
+#define ISO_CTRL_clk_osc_on_en_shift                                                 (6)
+#define ISO_CTRL_clk_osc_on_en_mask                                                  (0x00000040)
+#define ISO_CTRL_clk_osc_on_en(data)                                                 (0x00000040&((data)<<6))
+#define ISO_CTRL_clk_osc_on_en_src(data)                                             ((0x00000040&(data))>>6)
+#define ISO_CTRL_get_clk_osc_on_en(data)                                             ((0x00000040&(data))>>6)
+#define ISO_CTRL_write_en3_shift                                                     (5)
+#define ISO_CTRL_write_en3_mask                                                      (0x00000020)
+#define ISO_CTRL_write_en3(data)                                                     (0x00000020&((data)<<5))
+#define ISO_CTRL_write_en3_src(data)                                                 ((0x00000020&(data))>>5)
+#define ISO_CTRL_get_write_en3(data)                                                 ((0x00000020&(data))>>5)
+#define ISO_CTRL_crt_sw_rstn_shift                                                   (4)
+#define ISO_CTRL_crt_sw_rstn_mask                                                    (0x00000010)
+#define ISO_CTRL_crt_sw_rstn(data)                                                   (0x00000010&((data)<<4))
+#define ISO_CTRL_crt_sw_rstn_src(data)                                               ((0x00000010&(data))>>4)
+#define ISO_CTRL_get_crt_sw_rstn(data)                                               ((0x00000010&(data))>>4)
+#define ISO_CTRL_write_en2_shift                                                     (3)
+#define ISO_CTRL_write_en2_mask                                                      (0x00000008)
+#define ISO_CTRL_write_en2(data)                                                     (0x00000008&((data)<<3))
+#define ISO_CTRL_write_en2_src(data)                                                 ((0x00000008&(data))>>3)
+#define ISO_CTRL_get_write_en2(data)                                                 ((0x00000008&(data))>>3)
+#define ISO_CTRL_iso_clk_sel_shift                                                   (2)
+#define ISO_CTRL_iso_clk_sel_mask                                                    (0x00000004)
+#define ISO_CTRL_iso_clk_sel(data)                                                   (0x00000004&((data)<<2))
+#define ISO_CTRL_iso_clk_sel_src(data)                                               ((0x00000004&(data))>>2)
+#define ISO_CTRL_get_iso_clk_sel(data)                                               ((0x00000004&(data))>>2)
+#define ISO_CTRL_write_en1_shift                                                     (1)
+#define ISO_CTRL_write_en1_mask                                                      (0x00000002)
+#define ISO_CTRL_write_en1(data)                                                     (0x00000002&((data)<<1))
+#define ISO_CTRL_write_en1_src(data)                                                 ((0x00000002&(data))>>1)
+#define ISO_CTRL_get_write_en1(data)                                                 ((0x00000002&(data))>>1)
+#define ISO_CTRL_ejtag_en_shift                                                      (0)
+#define ISO_CTRL_ejtag_en_mask                                                       (0x00000001)
+#define ISO_CTRL_ejtag_en(data)                                                      (0x00000001&((data)<<0))
+#define ISO_CTRL_ejtag_en_src(data)                                                  ((0x00000001&(data))>>0)
+#define ISO_CTRL_get_ejtag_en(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_RTC                                                                      0x18007034
+#define ISO_RTC_reg_addr                                                             "0xB8007034"
+#define ISO_RTC_reg                                                                  0xB8007034
+#define set_ISO_RTC_reg(data)   (*((volatile unsigned int*) ISO_RTC_reg)=data)
+#define get_ISO_RTC_reg   (*((volatile unsigned int*) ISO_RTC_reg))
+#define ISO_RTC_inst_adr                                                             "0x000D"
+#define ISO_RTC_inst                                                                 0x000D
+#define ISO_RTC_hsec_int_en_shift                                                    (1)
+#define ISO_RTC_hsec_int_en_mask                                                     (0x00000002)
+#define ISO_RTC_hsec_int_en(data)                                                    (0x00000002&((data)<<1))
+#define ISO_RTC_hsec_int_en_src(data)                                                ((0x00000002&(data))>>1)
+#define ISO_RTC_get_hsec_int_en(data)                                                ((0x00000002&(data))>>1)
+#define ISO_RTC_alarm_int_en_shift                                                   (0)
+#define ISO_RTC_alarm_int_en_mask                                                    (0x00000001)
+#define ISO_RTC_alarm_int_en(data)                                                   (0x00000001&((data)<<0))
+#define ISO_RTC_alarm_int_en_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_RTC_get_alarm_int_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_CELL                                                                     0x18007038
+#define ISO_CELL_reg_addr                                                            "0xB8007038"
+#define ISO_CELL_reg                                                                 0xB8007038
+#define set_ISO_CELL_reg(data)   (*((volatile unsigned int*) ISO_CELL_reg)=data)
+#define get_ISO_CELL_reg   (*((volatile unsigned int*) ISO_CELL_reg))
+#define ISO_CELL_inst_adr                                                            "0x000E"
+#define ISO_CELL_inst                                                                0x000E
+#define ISO_CELL_bi_bypass_shift                                                     (2)
+#define ISO_CELL_bi_bypass_mask                                                      (0x00000004)
+#define ISO_CELL_bi_bypass(data)                                                     (0x00000004&((data)<<2))
+#define ISO_CELL_bi_bypass_src(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_CELL_get_bi_bypass(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_CELL_iso_ctrl_en1_shift                                                  (1)
+#define ISO_CELL_iso_ctrl_en1_mask                                                   (0x00000002)
+#define ISO_CELL_iso_ctrl_en1(data)                                                  (0x00000002&((data)<<1))
+#define ISO_CELL_iso_ctrl_en1_src(data)                                              ((0x00000002&(data))>>1)
+#define ISO_CELL_get_iso_ctrl_en1(data)                                              ((0x00000002&(data))>>1)
+#define ISO_CELL_iso_ctrl_en0_shift                                                  (0)
+#define ISO_CELL_iso_ctrl_en0_mask                                                   (0x00000001)
+#define ISO_CELL_iso_ctrl_en0(data)                                                  (0x00000001&((data)<<0))
+#define ISO_CELL_iso_ctrl_en0_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_CELL_get_iso_ctrl_en0(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_POWER                                                                    0x1800703C
+#define ISO_POWER_reg_addr                                                           "0xB800703C"
+#define ISO_POWER_reg                                                                0xB800703C
+#define set_ISO_POWER_reg(data)   (*((volatile unsigned int*) ISO_POWER_reg)=data)
+#define get_ISO_POWER_reg   (*((volatile unsigned int*) ISO_POWER_reg))
+#define ISO_POWER_inst_adr                                                           "0x000F"
+#define ISO_POWER_inst                                                               0x000F
+#define ISO_POWER_top_vdd_on_shift                                                   (1)
+#define ISO_POWER_top_vdd_on_mask                                                    (0x00000002)
+#define ISO_POWER_top_vdd_on(data)                                                   (0x00000002&((data)<<1))
+#define ISO_POWER_top_vdd_on_src(data)                                               ((0x00000002&(data))>>1)
+#define ISO_POWER_get_top_vdd_on(data)                                               ((0x00000002&(data))>>1)
+#define ISO_POWER_scpu_vdd_on_shift                                                  (0)
+#define ISO_POWER_scpu_vdd_on_mask                                                   (0x00000001)
+#define ISO_POWER_scpu_vdd_on(data)                                                  (0x00000001&((data)<<0))
+#define ISO_POWER_scpu_vdd_on_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_POWER_get_scpu_vdd_on(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_SCPU_INT_EN                                                              0x18007040
+#define ISO_SCPU_INT_EN_reg_addr                                                     "0xB8007040"
+#define ISO_SCPU_INT_EN_reg                                                          0xB8007040
+#define set_ISO_SCPU_INT_EN_reg(data)   (*((volatile unsigned int*) ISO_SCPU_INT_EN_reg)=data)
+#define get_ISO_SCPU_INT_EN_reg   (*((volatile unsigned int*) ISO_SCPU_INT_EN_reg))
+#define ISO_SCPU_INT_EN_inst_adr                                                     "0x0010"
+#define ISO_SCPU_INT_EN_inst                                                         0x0010
+#define ISO_SCPU_INT_EN_cec_shift                                                    (22)
+#define ISO_SCPU_INT_EN_cec_mask                                                     (0x00400000)
+#define ISO_SCPU_INT_EN_cec(data)                                                    (0x00400000&((data)<<22))
+#define ISO_SCPU_INT_EN_cec_src(data)                                                ((0x00400000&(data))>>22)
+#define ISO_SCPU_INT_EN_get_cec(data)                                                ((0x00400000&(data))>>22)
+#define ISO_SCPU_INT_EN_gpioda_shift                                                 (20)
+#define ISO_SCPU_INT_EN_gpioda_mask                                                  (0x00100000)
+#define ISO_SCPU_INT_EN_gpioda(data)                                                 (0x00100000&((data)<<20))
+#define ISO_SCPU_INT_EN_gpioda_src(data)                                             ((0x00100000&(data))>>20)
+#define ISO_SCPU_INT_EN_get_gpioda(data)                                             ((0x00100000&(data))>>20)
+#define ISO_SCPU_INT_EN_gpioa_shift                                                  (19)
+#define ISO_SCPU_INT_EN_gpioa_mask                                                   (0x00080000)
+#define ISO_SCPU_INT_EN_gpioa(data)                                                  (0x00080000&((data)<<19))
+#define ISO_SCPU_INT_EN_gpioa_src(data)                                              ((0x00080000&(data))>>19)
+#define ISO_SCPU_INT_EN_get_gpioa(data)                                              ((0x00080000&(data))>>19)
+#define ISO_SCPU_INT_EN_vfd_ardswda_shift                                            (18)
+#define ISO_SCPU_INT_EN_vfd_ardswda_mask                                             (0x00040000)
+#define ISO_SCPU_INT_EN_vfd_ardswda(data)                                            (0x00040000&((data)<<18))
+#define ISO_SCPU_INT_EN_vfd_ardswda_src(data)                                        ((0x00040000&(data))>>18)
+#define ISO_SCPU_INT_EN_get_vfd_ardswda(data)                                        ((0x00040000&(data))>>18)
+#define ISO_SCPU_INT_EN_vfd_ardswa_shift                                             (17)
+#define ISO_SCPU_INT_EN_vfd_ardswa_mask                                              (0x00020000)
+#define ISO_SCPU_INT_EN_vfd_ardswa(data)                                             (0x00020000&((data)<<17))
+#define ISO_SCPU_INT_EN_vfd_ardswa_src(data)                                         ((0x00020000&(data))>>17)
+#define ISO_SCPU_INT_EN_get_vfd_ardswa(data)                                         ((0x00020000&(data))>>17)
+#define ISO_SCPU_INT_EN_vfd_ardkpadda_shift                                          (16)
+#define ISO_SCPU_INT_EN_vfd_ardkpadda_mask                                           (0x00010000)
+#define ISO_SCPU_INT_EN_vfd_ardkpadda(data)                                          (0x00010000&((data)<<16))
+#define ISO_SCPU_INT_EN_vfd_ardkpadda_src(data)                                      ((0x00010000&(data))>>16)
+#define ISO_SCPU_INT_EN_get_vfd_ardkpadda(data)                                      ((0x00010000&(data))>>16)
+#define ISO_SCPU_INT_EN_vfd_ardkpada_shift                                           (15)
+#define ISO_SCPU_INT_EN_vfd_ardkpada_mask                                            (0x00008000)
+#define ISO_SCPU_INT_EN_vfd_ardkpada(data)                                           (0x00008000&((data)<<15))
+#define ISO_SCPU_INT_EN_vfd_ardkpada_src(data)                                       ((0x00008000&(data))>>15)
+#define ISO_SCPU_INT_EN_get_vfd_ardkpada(data)                                       ((0x00008000&(data))>>15)
+#define ISO_SCPU_INT_EN_vfd_wdone_shift                                              (14)
+#define ISO_SCPU_INT_EN_vfd_wdone_mask                                               (0x00004000)
+#define ISO_SCPU_INT_EN_vfd_wdone(data)                                              (0x00004000&((data)<<14))
+#define ISO_SCPU_INT_EN_vfd_wdone_src(data)                                          ((0x00004000&(data))>>14)
+#define ISO_SCPU_INT_EN_get_vfd_wdone(data)                                          ((0x00004000&(data))>>14)
+#define ISO_SCPU_INT_EN_rtc_alarm_shift                                              (13)
+#define ISO_SCPU_INT_EN_rtc_alarm_mask                                               (0x00002000)
+#define ISO_SCPU_INT_EN_rtc_alarm(data)                                              (0x00002000&((data)<<13))
+#define ISO_SCPU_INT_EN_rtc_alarm_src(data)                                          ((0x00002000&(data))>>13)
+#define ISO_SCPU_INT_EN_get_rtc_alarm(data)                                          ((0x00002000&(data))>>13)
+#define ISO_SCPU_INT_EN_rtc_hsec_shift                                               (12)
+#define ISO_SCPU_INT_EN_rtc_hsec_mask                                                (0x00001000)
+#define ISO_SCPU_INT_EN_rtc_hsec(data)                                               (0x00001000&((data)<<12))
+#define ISO_SCPU_INT_EN_rtc_hsec_src(data)                                           ((0x00001000&(data))>>12)
+#define ISO_SCPU_INT_EN_get_rtc_hsec(data)                                           ((0x00001000&(data))>>12)
+#define ISO_SCPU_INT_EN_i2c6_shift                                                   (10)
+#define ISO_SCPU_INT_EN_i2c6_mask                                                    (0x00000400)
+#define ISO_SCPU_INT_EN_i2c6(data)                                                   (0x00000400&((data)<<10))
+#define ISO_SCPU_INT_EN_i2c6_src(data)                                               ((0x00000400&(data))>>10)
+#define ISO_SCPU_INT_EN_get_i2c6(data)                                               ((0x00000400&(data))>>10)
+#define ISO_SCPU_INT_EN_i2c0_shift                                                   (8)
+#define ISO_SCPU_INT_EN_i2c0_mask                                                    (0x00000100)
+#define ISO_SCPU_INT_EN_i2c0(data)                                                   (0x00000100&((data)<<8))
+#define ISO_SCPU_INT_EN_i2c0_src(data)                                               ((0x00000100&(data))>>8)
+#define ISO_SCPU_INT_EN_get_i2c0(data)                                               ((0x00000100&(data))>>8)
+#define ISO_SCPU_INT_EN_irda_shift                                                   (5)
+#define ISO_SCPU_INT_EN_irda_mask                                                    (0x00000020)
+#define ISO_SCPU_INT_EN_irda(data)                                                   (0x00000020&((data)<<5))
+#define ISO_SCPU_INT_EN_irda_src(data)                                               ((0x00000020&(data))>>5)
+#define ISO_SCPU_INT_EN_get_irda(data)                                               ((0x00000020&(data))>>5)
+#define ISO_SCPU_INT_EN_ur0_shift                                                    (2)
+#define ISO_SCPU_INT_EN_ur0_mask                                                     (0x00000004)
+#define ISO_SCPU_INT_EN_ur0(data)                                                    (0x00000004&((data)<<2))
+#define ISO_SCPU_INT_EN_ur0_src(data)                                                ((0x00000004&(data))>>2)
+#define ISO_SCPU_INT_EN_get_ur0(data)                                                ((0x00000004&(data))>>2)
+
+
+#define ISO_USB                                                                      0x18007044
+#define ISO_USB_reg_addr                                                             "0xB8007044"
+#define ISO_USB_reg                                                                  0xB8007044
+#define set_ISO_USB_reg(data)   (*((volatile unsigned int*) ISO_USB_reg)=data)
+#define get_ISO_USB_reg   (*((volatile unsigned int*) ISO_USB_reg))
+#define ISO_USB_inst_adr                                                             "0x0011"
+#define ISO_USB_inst                                                                 0x0011
+#define ISO_USB_dcp_ctrl1_shift                                                      (1)
+#define ISO_USB_dcp_ctrl1_mask                                                       (0x00000002)
+#define ISO_USB_dcp_ctrl1(data)                                                      (0x00000002&((data)<<1))
+#define ISO_USB_dcp_ctrl1_src(data)                                                  ((0x00000002&(data))>>1)
+#define ISO_USB_get_dcp_ctrl1(data)                                                  ((0x00000002&(data))>>1)
+#define ISO_USB_dcp_ctrl0_shift                                                      (0)
+#define ISO_USB_dcp_ctrl0_mask                                                       (0x00000001)
+#define ISO_USB_dcp_ctrl0(data)                                                      (0x00000001&((data)<<0))
+#define ISO_USB_dcp_ctrl0_src(data)                                                  ((0x00000001&(data))>>0)
+#define ISO_USB_get_dcp_ctrl0(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_ACPU_INT_EN                                                              0x18007048
+#define ISO_ACPU_INT_EN_reg_addr                                                     "0xB8007048"
+#define ISO_ACPU_INT_EN_reg                                                          0xB8007048
+#define set_ISO_ACPU_INT_EN_reg(data)   (*((volatile unsigned int*) ISO_ACPU_INT_EN_reg)=data)
+#define get_ISO_ACPU_INT_EN_reg   (*((volatile unsigned int*) ISO_ACPU_INT_EN_reg))
+#define ISO_ACPU_INT_EN_inst_adr                                                     "0x0012"
+#define ISO_ACPU_INT_EN_inst                                                         0x0012
+#define ISO_ACPU_INT_EN_cec_shift                                                    (22)
+#define ISO_ACPU_INT_EN_cec_mask                                                     (0x00400000)
+#define ISO_ACPU_INT_EN_cec(data)                                                    (0x00400000&((data)<<22))
+#define ISO_ACPU_INT_EN_cec_src(data)                                                ((0x00400000&(data))>>22)
+#define ISO_ACPU_INT_EN_get_cec(data)                                                ((0x00400000&(data))>>22)
+#define ISO_ACPU_INT_EN_gpioda_shift                                                 (20)
+#define ISO_ACPU_INT_EN_gpioda_mask                                                  (0x00100000)
+#define ISO_ACPU_INT_EN_gpioda(data)                                                 (0x00100000&((data)<<20))
+#define ISO_ACPU_INT_EN_gpioda_src(data)                                             ((0x00100000&(data))>>20)
+#define ISO_ACPU_INT_EN_get_gpioda(data)                                             ((0x00100000&(data))>>20)
+#define ISO_ACPU_INT_EN_gpioa_shift                                                  (19)
+#define ISO_ACPU_INT_EN_gpioa_mask                                                   (0x00080000)
+#define ISO_ACPU_INT_EN_gpioa(data)                                                  (0x00080000&((data)<<19))
+#define ISO_ACPU_INT_EN_gpioa_src(data)                                              ((0x00080000&(data))>>19)
+#define ISO_ACPU_INT_EN_get_gpioa(data)                                              ((0x00080000&(data))>>19)
+#define ISO_ACPU_INT_EN_vfd_ardswda_shift                                            (18)
+#define ISO_ACPU_INT_EN_vfd_ardswda_mask                                             (0x00040000)
+#define ISO_ACPU_INT_EN_vfd_ardswda(data)                                            (0x00040000&((data)<<18))
+#define ISO_ACPU_INT_EN_vfd_ardswda_src(data)                                        ((0x00040000&(data))>>18)
+#define ISO_ACPU_INT_EN_get_vfd_ardswda(data)                                        ((0x00040000&(data))>>18)
+#define ISO_ACPU_INT_EN_vfd_ardswa_shift                                             (17)
+#define ISO_ACPU_INT_EN_vfd_ardswa_mask                                              (0x00020000)
+#define ISO_ACPU_INT_EN_vfd_ardswa(data)                                             (0x00020000&((data)<<17))
+#define ISO_ACPU_INT_EN_vfd_ardswa_src(data)                                         ((0x00020000&(data))>>17)
+#define ISO_ACPU_INT_EN_get_vfd_ardswa(data)                                         ((0x00020000&(data))>>17)
+#define ISO_ACPU_INT_EN_vfd_ardkpadda_shift                                          (16)
+#define ISO_ACPU_INT_EN_vfd_ardkpadda_mask                                           (0x00010000)
+#define ISO_ACPU_INT_EN_vfd_ardkpadda(data)                                          (0x00010000&((data)<<16))
+#define ISO_ACPU_INT_EN_vfd_ardkpadda_src(data)                                      ((0x00010000&(data))>>16)
+#define ISO_ACPU_INT_EN_get_vfd_ardkpadda(data)                                      ((0x00010000&(data))>>16)
+#define ISO_ACPU_INT_EN_vfd_ardkpada_shift                                           (15)
+#define ISO_ACPU_INT_EN_vfd_ardkpada_mask                                            (0x00008000)
+#define ISO_ACPU_INT_EN_vfd_ardkpada(data)                                           (0x00008000&((data)<<15))
+#define ISO_ACPU_INT_EN_vfd_ardkpada_src(data)                                       ((0x00008000&(data))>>15)
+#define ISO_ACPU_INT_EN_get_vfd_ardkpada(data)                                       ((0x00008000&(data))>>15)
+#define ISO_ACPU_INT_EN_vfd_wdone_shift                                              (14)
+#define ISO_ACPU_INT_EN_vfd_wdone_mask                                               (0x00004000)
+#define ISO_ACPU_INT_EN_vfd_wdone(data)                                              (0x00004000&((data)<<14))
+#define ISO_ACPU_INT_EN_vfd_wdone_src(data)                                          ((0x00004000&(data))>>14)
+#define ISO_ACPU_INT_EN_get_vfd_wdone(data)                                          ((0x00004000&(data))>>14)
+#define ISO_ACPU_INT_EN_rtc_alarm_shift                                              (13)
+#define ISO_ACPU_INT_EN_rtc_alarm_mask                                               (0x00002000)
+#define ISO_ACPU_INT_EN_rtc_alarm(data)                                              (0x00002000&((data)<<13))
+#define ISO_ACPU_INT_EN_rtc_alarm_src(data)                                          ((0x00002000&(data))>>13)
+#define ISO_ACPU_INT_EN_get_rtc_alarm(data)                                          ((0x00002000&(data))>>13)
+#define ISO_ACPU_INT_EN_rtc_hsec_shift                                               (12)
+#define ISO_ACPU_INT_EN_rtc_hsec_mask                                                (0x00001000)
+#define ISO_ACPU_INT_EN_rtc_hsec(data)                                               (0x00001000&((data)<<12))
+#define ISO_ACPU_INT_EN_rtc_hsec_src(data)                                           ((0x00001000&(data))>>12)
+#define ISO_ACPU_INT_EN_get_rtc_hsec(data)                                           ((0x00001000&(data))>>12)
+#define ISO_ACPU_INT_EN_i2c6_shift                                                   (10)
+#define ISO_ACPU_INT_EN_i2c6_mask                                                    (0x00000400)
+#define ISO_ACPU_INT_EN_i2c6(data)                                                   (0x00000400&((data)<<10))
+#define ISO_ACPU_INT_EN_i2c6_src(data)                                               ((0x00000400&(data))>>10)
+#define ISO_ACPU_INT_EN_get_i2c6(data)                                               ((0x00000400&(data))>>10)
+#define ISO_ACPU_INT_EN_i2c0_shift                                                   (8)
+#define ISO_ACPU_INT_EN_i2c0_mask                                                    (0x00000100)
+#define ISO_ACPU_INT_EN_i2c0(data)                                                   (0x00000100&((data)<<8))
+#define ISO_ACPU_INT_EN_i2c0_src(data)                                               ((0x00000100&(data))>>8)
+#define ISO_ACPU_INT_EN_get_i2c0(data)                                               ((0x00000100&(data))>>8)
+#define ISO_ACPU_INT_EN_irda_shift                                                   (5)
+#define ISO_ACPU_INT_EN_irda_mask                                                    (0x00000020)
+#define ISO_ACPU_INT_EN_irda(data)                                                   (0x00000020&((data)<<5))
+#define ISO_ACPU_INT_EN_irda_src(data)                                               ((0x00000020&(data))>>5)
+#define ISO_ACPU_INT_EN_get_irda(data)                                               ((0x00000020&(data))>>5)
+#define ISO_ACPU_INT_EN_ur0_shift                                                    (2)
+#define ISO_ACPU_INT_EN_ur0_mask                                                     (0x00000004)
+#define ISO_ACPU_INT_EN_ur0(data)                                                    (0x00000004&((data)<<2))
+#define ISO_ACPU_INT_EN_ur0_src(data)                                                ((0x00000004&(data))>>2)
+#define ISO_ACPU_INT_EN_get_ur0(data)                                                ((0x00000004&(data))>>2)
+
+
+#define ISO_CPU_ST1                                                                  0x1800704C
+#define ISO_CPU_ST1_reg_addr                                                         "0xB800704C"
+#define ISO_CPU_ST1_reg                                                              0xB800704C
+#define set_ISO_CPU_ST1_reg(data)   (*((volatile unsigned int*) ISO_CPU_ST1_reg)=data)
+#define get_ISO_CPU_ST1_reg   (*((volatile unsigned int*) ISO_CPU_ST1_reg))
+#define ISO_CPU_ST1_inst_adr                                                         "0x0013"
+#define ISO_CPU_ST1_inst                                                             0x0013
+#define ISO_CPU_ST1_acpu_boot_info_shift                                             (0)
+#define ISO_CPU_ST1_acpu_boot_info_mask                                              (0xFFFFFFFF)
+#define ISO_CPU_ST1_acpu_boot_info(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ISO_CPU_ST1_acpu_boot_info_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ISO_CPU_ST1_get_acpu_boot_info(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_CPU_ST1V                                                                 0x18007050
+#define ISO_CPU_ST1V_reg_addr                                                        "0xB8007050"
+#define ISO_CPU_ST1V_reg                                                             0xB8007050
+#define set_ISO_CPU_ST1V_reg(data)   (*((volatile unsigned int*) ISO_CPU_ST1V_reg)=data)
+#define get_ISO_CPU_ST1V_reg   (*((volatile unsigned int*) ISO_CPU_ST1V_reg))
+#define ISO_CPU_ST1V_inst_adr                                                        "0x0014"
+#define ISO_CPU_ST1V_inst                                                            0x0014
+#define ISO_CPU_ST1V_acpu_boot_info_valid_shift                                      (0)
+#define ISO_CPU_ST1V_acpu_boot_info_valid_mask                                       (0x00000001)
+#define ISO_CPU_ST1V_acpu_boot_info_valid(data)                                      (0x00000001&((data)<<0))
+#define ISO_CPU_ST1V_acpu_boot_info_valid_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_CPU_ST1V_get_acpu_boot_info_valid(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_DUMMY1                                                                   0x18007054
+#define ISO_DUMMY1_reg_addr                                                          "0xB8007054"
+#define ISO_DUMMY1_reg                                                               0xB8007054
+#define set_ISO_DUMMY1_reg(data)   (*((volatile unsigned int*) ISO_DUMMY1_reg)=data)
+#define get_ISO_DUMMY1_reg   (*((volatile unsigned int*) ISO_DUMMY1_reg))
+#define ISO_DUMMY1_inst_adr                                                          "0x0015"
+#define ISO_DUMMY1_inst                                                              0x0015
+#define ISO_DUMMY1_rvd31_shift                                                       (31)
+#define ISO_DUMMY1_rvd31_mask                                                        (0x80000000)
+#define ISO_DUMMY1_rvd31(data)                                                       (0x80000000&((data)<<31))
+#define ISO_DUMMY1_rvd31_src(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_DUMMY1_get_rvd31(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_DUMMY1_rvd30_shift                                                       (30)
+#define ISO_DUMMY1_rvd30_mask                                                        (0x40000000)
+#define ISO_DUMMY1_rvd30(data)                                                       (0x40000000&((data)<<30))
+#define ISO_DUMMY1_rvd30_src(data)                                                   ((0x40000000&(data))>>30)
+#define ISO_DUMMY1_get_rvd30(data)                                                   ((0x40000000&(data))>>30)
+#define ISO_DUMMY1_rvd29_shift                                                       (29)
+#define ISO_DUMMY1_rvd29_mask                                                        (0x20000000)
+#define ISO_DUMMY1_rvd29(data)                                                       (0x20000000&((data)<<29))
+#define ISO_DUMMY1_rvd29_src(data)                                                   ((0x20000000&(data))>>29)
+#define ISO_DUMMY1_get_rvd29(data)                                                   ((0x20000000&(data))>>29)
+#define ISO_DUMMY1_rvd28_shift                                                       (28)
+#define ISO_DUMMY1_rvd28_mask                                                        (0x10000000)
+#define ISO_DUMMY1_rvd28(data)                                                       (0x10000000&((data)<<28))
+#define ISO_DUMMY1_rvd28_src(data)                                                   ((0x10000000&(data))>>28)
+#define ISO_DUMMY1_get_rvd28(data)                                                   ((0x10000000&(data))>>28)
+#define ISO_DUMMY1_rvd27_shift                                                       (27)
+#define ISO_DUMMY1_rvd27_mask                                                        (0x08000000)
+#define ISO_DUMMY1_rvd27(data)                                                       (0x08000000&((data)<<27))
+#define ISO_DUMMY1_rvd27_src(data)                                                   ((0x08000000&(data))>>27)
+#define ISO_DUMMY1_get_rvd27(data)                                                   ((0x08000000&(data))>>27)
+#define ISO_DUMMY1_rvd26_shift                                                       (26)
+#define ISO_DUMMY1_rvd26_mask                                                        (0x04000000)
+#define ISO_DUMMY1_rvd26(data)                                                       (0x04000000&((data)<<26))
+#define ISO_DUMMY1_rvd26_src(data)                                                   ((0x04000000&(data))>>26)
+#define ISO_DUMMY1_get_rvd26(data)                                                   ((0x04000000&(data))>>26)
+#define ISO_DUMMY1_rvd25_shift                                                       (25)
+#define ISO_DUMMY1_rvd25_mask                                                        (0x02000000)
+#define ISO_DUMMY1_rvd25(data)                                                       (0x02000000&((data)<<25))
+#define ISO_DUMMY1_rvd25_src(data)                                                   ((0x02000000&(data))>>25)
+#define ISO_DUMMY1_get_rvd25(data)                                                   ((0x02000000&(data))>>25)
+#define ISO_DUMMY1_rvd24_shift                                                       (24)
+#define ISO_DUMMY1_rvd24_mask                                                        (0x01000000)
+#define ISO_DUMMY1_rvd24(data)                                                       (0x01000000&((data)<<24))
+#define ISO_DUMMY1_rvd24_src(data)                                                   ((0x01000000&(data))>>24)
+#define ISO_DUMMY1_get_rvd24(data)                                                   ((0x01000000&(data))>>24)
+#define ISO_DUMMY1_rvd23_shift                                                       (23)
+#define ISO_DUMMY1_rvd23_mask                                                        (0x00800000)
+#define ISO_DUMMY1_rvd23(data)                                                       (0x00800000&((data)<<23))
+#define ISO_DUMMY1_rvd23_src(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_DUMMY1_get_rvd23(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_DUMMY1_rvd22_shift                                                       (22)
+#define ISO_DUMMY1_rvd22_mask                                                        (0x00400000)
+#define ISO_DUMMY1_rvd22(data)                                                       (0x00400000&((data)<<22))
+#define ISO_DUMMY1_rvd22_src(data)                                                   ((0x00400000&(data))>>22)
+#define ISO_DUMMY1_get_rvd22(data)                                                   ((0x00400000&(data))>>22)
+#define ISO_DUMMY1_rvd21_shift                                                       (21)
+#define ISO_DUMMY1_rvd21_mask                                                        (0x00200000)
+#define ISO_DUMMY1_rvd21(data)                                                       (0x00200000&((data)<<21))
+#define ISO_DUMMY1_rvd21_src(data)                                                   ((0x00200000&(data))>>21)
+#define ISO_DUMMY1_get_rvd21(data)                                                   ((0x00200000&(data))>>21)
+#define ISO_DUMMY1_rvd20_shift                                                       (20)
+#define ISO_DUMMY1_rvd20_mask                                                        (0x00100000)
+#define ISO_DUMMY1_rvd20(data)                                                       (0x00100000&((data)<<20))
+#define ISO_DUMMY1_rvd20_src(data)                                                   ((0x00100000&(data))>>20)
+#define ISO_DUMMY1_get_rvd20(data)                                                   ((0x00100000&(data))>>20)
+#define ISO_DUMMY1_rvd19_shift                                                       (19)
+#define ISO_DUMMY1_rvd19_mask                                                        (0x00080000)
+#define ISO_DUMMY1_rvd19(data)                                                       (0x00080000&((data)<<19))
+#define ISO_DUMMY1_rvd19_src(data)                                                   ((0x00080000&(data))>>19)
+#define ISO_DUMMY1_get_rvd19(data)                                                   ((0x00080000&(data))>>19)
+#define ISO_DUMMY1_rvd18_shift                                                       (18)
+#define ISO_DUMMY1_rvd18_mask                                                        (0x00040000)
+#define ISO_DUMMY1_rvd18(data)                                                       (0x00040000&((data)<<18))
+#define ISO_DUMMY1_rvd18_src(data)                                                   ((0x00040000&(data))>>18)
+#define ISO_DUMMY1_get_rvd18(data)                                                   ((0x00040000&(data))>>18)
+#define ISO_DUMMY1_rvd17_shift                                                       (17)
+#define ISO_DUMMY1_rvd17_mask                                                        (0x00020000)
+#define ISO_DUMMY1_rvd17(data)                                                       (0x00020000&((data)<<17))
+#define ISO_DUMMY1_rvd17_src(data)                                                   ((0x00020000&(data))>>17)
+#define ISO_DUMMY1_get_rvd17(data)                                                   ((0x00020000&(data))>>17)
+#define ISO_DUMMY1_rvd16_shift                                                       (16)
+#define ISO_DUMMY1_rvd16_mask                                                        (0x00010000)
+#define ISO_DUMMY1_rvd16(data)                                                       (0x00010000&((data)<<16))
+#define ISO_DUMMY1_rvd16_src(data)                                                   ((0x00010000&(data))>>16)
+#define ISO_DUMMY1_get_rvd16(data)                                                   ((0x00010000&(data))>>16)
+#define ISO_DUMMY1_rvd15_shift                                                       (15)
+#define ISO_DUMMY1_rvd15_mask                                                        (0x00008000)
+#define ISO_DUMMY1_rvd15(data)                                                       (0x00008000&((data)<<15))
+#define ISO_DUMMY1_rvd15_src(data)                                                   ((0x00008000&(data))>>15)
+#define ISO_DUMMY1_get_rvd15(data)                                                   ((0x00008000&(data))>>15)
+#define ISO_DUMMY1_rvd14_shift                                                       (14)
+#define ISO_DUMMY1_rvd14_mask                                                        (0x00004000)
+#define ISO_DUMMY1_rvd14(data)                                                       (0x00004000&((data)<<14))
+#define ISO_DUMMY1_rvd14_src(data)                                                   ((0x00004000&(data))>>14)
+#define ISO_DUMMY1_get_rvd14(data)                                                   ((0x00004000&(data))>>14)
+#define ISO_DUMMY1_rvd13_shift                                                       (13)
+#define ISO_DUMMY1_rvd13_mask                                                        (0x00002000)
+#define ISO_DUMMY1_rvd13(data)                                                       (0x00002000&((data)<<13))
+#define ISO_DUMMY1_rvd13_src(data)                                                   ((0x00002000&(data))>>13)
+#define ISO_DUMMY1_get_rvd13(data)                                                   ((0x00002000&(data))>>13)
+#define ISO_DUMMY1_rvd12_shift                                                       (12)
+#define ISO_DUMMY1_rvd12_mask                                                        (0x00001000)
+#define ISO_DUMMY1_rvd12(data)                                                       (0x00001000&((data)<<12))
+#define ISO_DUMMY1_rvd12_src(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_DUMMY1_get_rvd12(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_DUMMY1_rvd11_shift                                                       (11)
+#define ISO_DUMMY1_rvd11_mask                                                        (0x00000800)
+#define ISO_DUMMY1_rvd11(data)                                                       (0x00000800&((data)<<11))
+#define ISO_DUMMY1_rvd11_src(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_DUMMY1_get_rvd11(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_DUMMY1_rvd10_shift                                                       (10)
+#define ISO_DUMMY1_rvd10_mask                                                        (0x00000400)
+#define ISO_DUMMY1_rvd10(data)                                                       (0x00000400&((data)<<10))
+#define ISO_DUMMY1_rvd10_src(data)                                                   ((0x00000400&(data))>>10)
+#define ISO_DUMMY1_get_rvd10(data)                                                   ((0x00000400&(data))>>10)
+#define ISO_DUMMY1_rvd9_shift                                                        (9)
+#define ISO_DUMMY1_rvd9_mask                                                         (0x00000200)
+#define ISO_DUMMY1_rvd9(data)                                                        (0x00000200&((data)<<9))
+#define ISO_DUMMY1_rvd9_src(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_DUMMY1_get_rvd9(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_DUMMY1_rvd8_shift                                                        (8)
+#define ISO_DUMMY1_rvd8_mask                                                         (0x00000100)
+#define ISO_DUMMY1_rvd8(data)                                                        (0x00000100&((data)<<8))
+#define ISO_DUMMY1_rvd8_src(data)                                                    ((0x00000100&(data))>>8)
+#define ISO_DUMMY1_get_rvd8(data)                                                    ((0x00000100&(data))>>8)
+#define ISO_DUMMY1_rvd7_shift                                                        (7)
+#define ISO_DUMMY1_rvd7_mask                                                         (0x00000080)
+#define ISO_DUMMY1_rvd7(data)                                                        (0x00000080&((data)<<7))
+#define ISO_DUMMY1_rvd7_src(data)                                                    ((0x00000080&(data))>>7)
+#define ISO_DUMMY1_get_rvd7(data)                                                    ((0x00000080&(data))>>7)
+#define ISO_DUMMY1_rvd6_shift                                                        (6)
+#define ISO_DUMMY1_rvd6_mask                                                         (0x00000040)
+#define ISO_DUMMY1_rvd6(data)                                                        (0x00000040&((data)<<6))
+#define ISO_DUMMY1_rvd6_src(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_DUMMY1_get_rvd6(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_DUMMY1_rvd5_shift                                                        (5)
+#define ISO_DUMMY1_rvd5_mask                                                         (0x00000020)
+#define ISO_DUMMY1_rvd5(data)                                                        (0x00000020&((data)<<5))
+#define ISO_DUMMY1_rvd5_src(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_DUMMY1_get_rvd5(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_DUMMY1_rvd4_shift                                                        (4)
+#define ISO_DUMMY1_rvd4_mask                                                         (0x00000010)
+#define ISO_DUMMY1_rvd4(data)                                                        (0x00000010&((data)<<4))
+#define ISO_DUMMY1_rvd4_src(data)                                                    ((0x00000010&(data))>>4)
+#define ISO_DUMMY1_get_rvd4(data)                                                    ((0x00000010&(data))>>4)
+#define ISO_DUMMY1_rvd3_shift                                                        (3)
+#define ISO_DUMMY1_rvd3_mask                                                         (0x00000008)
+#define ISO_DUMMY1_rvd3(data)                                                        (0x00000008&((data)<<3))
+#define ISO_DUMMY1_rvd3_src(data)                                                    ((0x00000008&(data))>>3)
+#define ISO_DUMMY1_get_rvd3(data)                                                    ((0x00000008&(data))>>3)
+#define ISO_DUMMY1_rvd2_shift                                                        (2)
+#define ISO_DUMMY1_rvd2_mask                                                         (0x00000004)
+#define ISO_DUMMY1_rvd2(data)                                                        (0x00000004&((data)<<2))
+#define ISO_DUMMY1_rvd2_src(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_DUMMY1_get_rvd2(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_DUMMY1_rvd1_shift                                                        (1)
+#define ISO_DUMMY1_rvd1_mask                                                         (0x00000002)
+#define ISO_DUMMY1_rvd1(data)                                                        (0x00000002&((data)<<1))
+#define ISO_DUMMY1_rvd1_src(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_DUMMY1_get_rvd1(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_DUMMY1_rvd0_shift                                                        (0)
+#define ISO_DUMMY1_rvd0_mask                                                         (0x00000001)
+#define ISO_DUMMY1_rvd0(data)                                                        (0x00000001&((data)<<0))
+#define ISO_DUMMY1_rvd0_src(data)                                                    ((0x00000001&(data))>>0)
+#define ISO_DUMMY1_get_rvd0(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_DUMMY2                                                                   0x18007058
+#define ISO_DUMMY2_reg_addr                                                          "0xB8007058"
+#define ISO_DUMMY2_reg                                                               0xB8007058
+#define set_ISO_DUMMY2_reg(data)   (*((volatile unsigned int*) ISO_DUMMY2_reg)=data)
+#define get_ISO_DUMMY2_reg   (*((volatile unsigned int*) ISO_DUMMY2_reg))
+#define ISO_DUMMY2_inst_adr                                                          "0x0016"
+#define ISO_DUMMY2_inst                                                              0x0016
+#define ISO_DUMMY2_rvd31_shift                                                       (31)
+#define ISO_DUMMY2_rvd31_mask                                                        (0x80000000)
+#define ISO_DUMMY2_rvd31(data)                                                       (0x80000000&((data)<<31))
+#define ISO_DUMMY2_rvd31_src(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_DUMMY2_get_rvd31(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_DUMMY2_rvd30_shift                                                       (30)
+#define ISO_DUMMY2_rvd30_mask                                                        (0x40000000)
+#define ISO_DUMMY2_rvd30(data)                                                       (0x40000000&((data)<<30))
+#define ISO_DUMMY2_rvd30_src(data)                                                   ((0x40000000&(data))>>30)
+#define ISO_DUMMY2_get_rvd30(data)                                                   ((0x40000000&(data))>>30)
+#define ISO_DUMMY2_rvd29_shift                                                       (29)
+#define ISO_DUMMY2_rvd29_mask                                                        (0x20000000)
+#define ISO_DUMMY2_rvd29(data)                                                       (0x20000000&((data)<<29))
+#define ISO_DUMMY2_rvd29_src(data)                                                   ((0x20000000&(data))>>29)
+#define ISO_DUMMY2_get_rvd29(data)                                                   ((0x20000000&(data))>>29)
+#define ISO_DUMMY2_rvd28_shift                                                       (28)
+#define ISO_DUMMY2_rvd28_mask                                                        (0x10000000)
+#define ISO_DUMMY2_rvd28(data)                                                       (0x10000000&((data)<<28))
+#define ISO_DUMMY2_rvd28_src(data)                                                   ((0x10000000&(data))>>28)
+#define ISO_DUMMY2_get_rvd28(data)                                                   ((0x10000000&(data))>>28)
+#define ISO_DUMMY2_rvd27_shift                                                       (27)
+#define ISO_DUMMY2_rvd27_mask                                                        (0x08000000)
+#define ISO_DUMMY2_rvd27(data)                                                       (0x08000000&((data)<<27))
+#define ISO_DUMMY2_rvd27_src(data)                                                   ((0x08000000&(data))>>27)
+#define ISO_DUMMY2_get_rvd27(data)                                                   ((0x08000000&(data))>>27)
+#define ISO_DUMMY2_rvd26_shift                                                       (26)
+#define ISO_DUMMY2_rvd26_mask                                                        (0x04000000)
+#define ISO_DUMMY2_rvd26(data)                                                       (0x04000000&((data)<<26))
+#define ISO_DUMMY2_rvd26_src(data)                                                   ((0x04000000&(data))>>26)
+#define ISO_DUMMY2_get_rvd26(data)                                                   ((0x04000000&(data))>>26)
+#define ISO_DUMMY2_rvd25_shift                                                       (25)
+#define ISO_DUMMY2_rvd25_mask                                                        (0x02000000)
+#define ISO_DUMMY2_rvd25(data)                                                       (0x02000000&((data)<<25))
+#define ISO_DUMMY2_rvd25_src(data)                                                   ((0x02000000&(data))>>25)
+#define ISO_DUMMY2_get_rvd25(data)                                                   ((0x02000000&(data))>>25)
+#define ISO_DUMMY2_rvd24_shift                                                       (24)
+#define ISO_DUMMY2_rvd24_mask                                                        (0x01000000)
+#define ISO_DUMMY2_rvd24(data)                                                       (0x01000000&((data)<<24))
+#define ISO_DUMMY2_rvd24_src(data)                                                   ((0x01000000&(data))>>24)
+#define ISO_DUMMY2_get_rvd24(data)                                                   ((0x01000000&(data))>>24)
+#define ISO_DUMMY2_rvd23_shift                                                       (23)
+#define ISO_DUMMY2_rvd23_mask                                                        (0x00800000)
+#define ISO_DUMMY2_rvd23(data)                                                       (0x00800000&((data)<<23))
+#define ISO_DUMMY2_rvd23_src(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_DUMMY2_get_rvd23(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_DUMMY2_rvd22_shift                                                       (22)
+#define ISO_DUMMY2_rvd22_mask                                                        (0x00400000)
+#define ISO_DUMMY2_rvd22(data)                                                       (0x00400000&((data)<<22))
+#define ISO_DUMMY2_rvd22_src(data)                                                   ((0x00400000&(data))>>22)
+#define ISO_DUMMY2_get_rvd22(data)                                                   ((0x00400000&(data))>>22)
+#define ISO_DUMMY2_rvd21_shift                                                       (21)
+#define ISO_DUMMY2_rvd21_mask                                                        (0x00200000)
+#define ISO_DUMMY2_rvd21(data)                                                       (0x00200000&((data)<<21))
+#define ISO_DUMMY2_rvd21_src(data)                                                   ((0x00200000&(data))>>21)
+#define ISO_DUMMY2_get_rvd21(data)                                                   ((0x00200000&(data))>>21)
+#define ISO_DUMMY2_rvd20_shift                                                       (20)
+#define ISO_DUMMY2_rvd20_mask                                                        (0x00100000)
+#define ISO_DUMMY2_rvd20(data)                                                       (0x00100000&((data)<<20))
+#define ISO_DUMMY2_rvd20_src(data)                                                   ((0x00100000&(data))>>20)
+#define ISO_DUMMY2_get_rvd20(data)                                                   ((0x00100000&(data))>>20)
+#define ISO_DUMMY2_rvd19_shift                                                       (19)
+#define ISO_DUMMY2_rvd19_mask                                                        (0x00080000)
+#define ISO_DUMMY2_rvd19(data)                                                       (0x00080000&((data)<<19))
+#define ISO_DUMMY2_rvd19_src(data)                                                   ((0x00080000&(data))>>19)
+#define ISO_DUMMY2_get_rvd19(data)                                                   ((0x00080000&(data))>>19)
+#define ISO_DUMMY2_rvd18_shift                                                       (18)
+#define ISO_DUMMY2_rvd18_mask                                                        (0x00040000)
+#define ISO_DUMMY2_rvd18(data)                                                       (0x00040000&((data)<<18))
+#define ISO_DUMMY2_rvd18_src(data)                                                   ((0x00040000&(data))>>18)
+#define ISO_DUMMY2_get_rvd18(data)                                                   ((0x00040000&(data))>>18)
+#define ISO_DUMMY2_rvd17_shift                                                       (17)
+#define ISO_DUMMY2_rvd17_mask                                                        (0x00020000)
+#define ISO_DUMMY2_rvd17(data)                                                       (0x00020000&((data)<<17))
+#define ISO_DUMMY2_rvd17_src(data)                                                   ((0x00020000&(data))>>17)
+#define ISO_DUMMY2_get_rvd17(data)                                                   ((0x00020000&(data))>>17)
+#define ISO_DUMMY2_rvd16_shift                                                       (16)
+#define ISO_DUMMY2_rvd16_mask                                                        (0x00010000)
+#define ISO_DUMMY2_rvd16(data)                                                       (0x00010000&((data)<<16))
+#define ISO_DUMMY2_rvd16_src(data)                                                   ((0x00010000&(data))>>16)
+#define ISO_DUMMY2_get_rvd16(data)                                                   ((0x00010000&(data))>>16)
+#define ISO_DUMMY2_rvd15_shift                                                       (15)
+#define ISO_DUMMY2_rvd15_mask                                                        (0x00008000)
+#define ISO_DUMMY2_rvd15(data)                                                       (0x00008000&((data)<<15))
+#define ISO_DUMMY2_rvd15_src(data)                                                   ((0x00008000&(data))>>15)
+#define ISO_DUMMY2_get_rvd15(data)                                                   ((0x00008000&(data))>>15)
+#define ISO_DUMMY2_rvd14_shift                                                       (14)
+#define ISO_DUMMY2_rvd14_mask                                                        (0x00004000)
+#define ISO_DUMMY2_rvd14(data)                                                       (0x00004000&((data)<<14))
+#define ISO_DUMMY2_rvd14_src(data)                                                   ((0x00004000&(data))>>14)
+#define ISO_DUMMY2_get_rvd14(data)                                                   ((0x00004000&(data))>>14)
+#define ISO_DUMMY2_rvd13_shift                                                       (13)
+#define ISO_DUMMY2_rvd13_mask                                                        (0x00002000)
+#define ISO_DUMMY2_rvd13(data)                                                       (0x00002000&((data)<<13))
+#define ISO_DUMMY2_rvd13_src(data)                                                   ((0x00002000&(data))>>13)
+#define ISO_DUMMY2_get_rvd13(data)                                                   ((0x00002000&(data))>>13)
+#define ISO_DUMMY2_rvd12_shift                                                       (12)
+#define ISO_DUMMY2_rvd12_mask                                                        (0x00001000)
+#define ISO_DUMMY2_rvd12(data)                                                       (0x00001000&((data)<<12))
+#define ISO_DUMMY2_rvd12_src(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_DUMMY2_get_rvd12(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_DUMMY2_rvd11_shift                                                       (11)
+#define ISO_DUMMY2_rvd11_mask                                                        (0x00000800)
+#define ISO_DUMMY2_rvd11(data)                                                       (0x00000800&((data)<<11))
+#define ISO_DUMMY2_rvd11_src(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_DUMMY2_get_rvd11(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_DUMMY2_rvd10_shift                                                       (10)
+#define ISO_DUMMY2_rvd10_mask                                                        (0x00000400)
+#define ISO_DUMMY2_rvd10(data)                                                       (0x00000400&((data)<<10))
+#define ISO_DUMMY2_rvd10_src(data)                                                   ((0x00000400&(data))>>10)
+#define ISO_DUMMY2_get_rvd10(data)                                                   ((0x00000400&(data))>>10)
+#define ISO_DUMMY2_rvd9_shift                                                        (9)
+#define ISO_DUMMY2_rvd9_mask                                                         (0x00000200)
+#define ISO_DUMMY2_rvd9(data)                                                        (0x00000200&((data)<<9))
+#define ISO_DUMMY2_rvd9_src(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_DUMMY2_get_rvd9(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_DUMMY2_rvd8_shift                                                        (8)
+#define ISO_DUMMY2_rvd8_mask                                                         (0x00000100)
+#define ISO_DUMMY2_rvd8(data)                                                        (0x00000100&((data)<<8))
+#define ISO_DUMMY2_rvd8_src(data)                                                    ((0x00000100&(data))>>8)
+#define ISO_DUMMY2_get_rvd8(data)                                                    ((0x00000100&(data))>>8)
+#define ISO_DUMMY2_rvd7_shift                                                        (7)
+#define ISO_DUMMY2_rvd7_mask                                                         (0x00000080)
+#define ISO_DUMMY2_rvd7(data)                                                        (0x00000080&((data)<<7))
+#define ISO_DUMMY2_rvd7_src(data)                                                    ((0x00000080&(data))>>7)
+#define ISO_DUMMY2_get_rvd7(data)                                                    ((0x00000080&(data))>>7)
+#define ISO_DUMMY2_rvd6_shift                                                        (6)
+#define ISO_DUMMY2_rvd6_mask                                                         (0x00000040)
+#define ISO_DUMMY2_rvd6(data)                                                        (0x00000040&((data)<<6))
+#define ISO_DUMMY2_rvd6_src(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_DUMMY2_get_rvd6(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_DUMMY2_rvd5_shift                                                        (5)
+#define ISO_DUMMY2_rvd5_mask                                                         (0x00000020)
+#define ISO_DUMMY2_rvd5(data)                                                        (0x00000020&((data)<<5))
+#define ISO_DUMMY2_rvd5_src(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_DUMMY2_get_rvd5(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_DUMMY2_rvd4_shift                                                        (4)
+#define ISO_DUMMY2_rvd4_mask                                                         (0x00000010)
+#define ISO_DUMMY2_rvd4(data)                                                        (0x00000010&((data)<<4))
+#define ISO_DUMMY2_rvd4_src(data)                                                    ((0x00000010&(data))>>4)
+#define ISO_DUMMY2_get_rvd4(data)                                                    ((0x00000010&(data))>>4)
+#define ISO_DUMMY2_rvd3_shift                                                        (3)
+#define ISO_DUMMY2_rvd3_mask                                                         (0x00000008)
+#define ISO_DUMMY2_rvd3(data)                                                        (0x00000008&((data)<<3))
+#define ISO_DUMMY2_rvd3_src(data)                                                    ((0x00000008&(data))>>3)
+#define ISO_DUMMY2_get_rvd3(data)                                                    ((0x00000008&(data))>>3)
+#define ISO_DUMMY2_rvd2_shift                                                        (2)
+#define ISO_DUMMY2_rvd2_mask                                                         (0x00000004)
+#define ISO_DUMMY2_rvd2(data)                                                        (0x00000004&((data)<<2))
+#define ISO_DUMMY2_rvd2_src(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_DUMMY2_get_rvd2(data)                                                    ((0x00000004&(data))>>2)
+#define ISO_DUMMY2_rvd1_shift                                                        (1)
+#define ISO_DUMMY2_rvd1_mask                                                         (0x00000002)
+#define ISO_DUMMY2_rvd1(data)                                                        (0x00000002&((data)<<1))
+#define ISO_DUMMY2_rvd1_src(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_DUMMY2_get_rvd1(data)                                                    ((0x00000002&(data))>>1)
+#define ISO_DUMMY2_rvd0_shift                                                        (0)
+#define ISO_DUMMY2_rvd0_mask                                                         (0x00000001)
+#define ISO_DUMMY2_rvd0(data)                                                        (0x00000001&((data)<<0))
+#define ISO_DUMMY2_rvd0_src(data)                                                    ((0x00000001&(data))>>0)
+#define ISO_DUMMY2_get_rvd0(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_POWERCUT_ETN                                                             0x1800705C
+#define ISO_POWERCUT_ETN_reg_addr                                                    "0xB800705C"
+#define ISO_POWERCUT_ETN_reg                                                         0xB800705C
+#define set_ISO_POWERCUT_ETN_reg(data)   (*((volatile unsigned int*) ISO_POWERCUT_ETN_reg)=data)
+#define get_ISO_POWERCUT_ETN_reg   (*((volatile unsigned int*) ISO_POWERCUT_ETN_reg))
+#define ISO_POWERCUT_ETN_inst_adr                                                    "0x0017"
+#define ISO_POWERCUT_ETN_inst                                                        0x0017
+#define ISO_POWERCUT_ETN_powercut_ana_d2a_isolate_b_shift                            (1)
+#define ISO_POWERCUT_ETN_powercut_ana_d2a_isolate_b_mask                             (0x00000002)
+#define ISO_POWERCUT_ETN_powercut_ana_d2a_isolate_b(data)                            (0x00000002&((data)<<1))
+#define ISO_POWERCUT_ETN_powercut_ana_d2a_isolate_b_src(data)                        ((0x00000002&(data))>>1)
+#define ISO_POWERCUT_ETN_get_powercut_ana_d2a_isolate_b(data)                        ((0x00000002&(data))>>1)
+#define ISO_POWERCUT_ETN_powercut_ana_a2d_isolate_b_shift                            (0)
+#define ISO_POWERCUT_ETN_powercut_ana_a2d_isolate_b_mask                             (0x00000001)
+#define ISO_POWERCUT_ETN_powercut_ana_a2d_isolate_b(data)                            (0x00000001&((data)<<0))
+#define ISO_POWERCUT_ETN_powercut_ana_a2d_isolate_b_src(data)                        ((0x00000001&(data))>>0)
+#define ISO_POWERCUT_ETN_get_powercut_ana_a2d_isolate_b(data)                        ((0x00000001&(data))>>0)
+
+
+#define ISO_ETN_TESTIO                                                               0x18007060
+#define ISO_ETN_TESTIO_reg_addr                                                      "0xB8007060"
+#define ISO_ETN_TESTIO_reg                                                           0xB8007060
+#define set_ISO_ETN_TESTIO_reg(data)   (*((volatile unsigned int*) ISO_ETN_TESTIO_reg)=data)
+#define get_ISO_ETN_TESTIO_reg   (*((volatile unsigned int*) ISO_ETN_TESTIO_reg))
+#define ISO_ETN_TESTIO_inst_adr                                                      "0x0018"
+#define ISO_ETN_TESTIO_inst                                                          0x0018
+#define ISO_ETN_TESTIO_etn_bpsgphy_mode_shift                                        (1)
+#define ISO_ETN_TESTIO_etn_bpsgphy_mode_mask                                         (0x00000002)
+#define ISO_ETN_TESTIO_etn_bpsgphy_mode(data)                                        (0x00000002&((data)<<1))
+#define ISO_ETN_TESTIO_etn_bpsgphy_mode_src(data)                                    ((0x00000002&(data))>>1)
+#define ISO_ETN_TESTIO_get_etn_bpsgphy_mode(data)                                    ((0x00000002&(data))>>1)
+#define ISO_ETN_TESTIO_etn_ocd_mode_shift                                            (0)
+#define ISO_ETN_TESTIO_etn_ocd_mode_mask                                             (0x00000001)
+#define ISO_ETN_TESTIO_etn_ocd_mode(data)                                            (0x00000001&((data)<<0))
+#define ISO_ETN_TESTIO_etn_ocd_mode_src(data)                                        ((0x00000001&(data))>>0)
+#define ISO_ETN_TESTIO_get_etn_ocd_mode(data)                                        ((0x00000001&(data))>>0)
+
+
+#define ISO_RESERVED_USE_0                                                           0x18007064
+#define ISO_RESERVED_USE_0_reg_addr                                                  "0xB8007064"
+#define ISO_RESERVED_USE_0_reg                                                       0xB8007064
+#define set_ISO_RESERVED_USE_0_reg(data)   (*((volatile unsigned int*) ISO_RESERVED_USE_0_reg)=data)
+#define get_ISO_RESERVED_USE_0_reg   (*((volatile unsigned int*) ISO_RESERVED_USE_0_reg))
+#define ISO_RESERVED_USE_0_inst_adr                                                  "0x0019"
+#define ISO_RESERVED_USE_0_inst                                                      0x0019
+#define ISO_RESERVED_USE_0_dmy_shift                                                 (0)
+#define ISO_RESERVED_USE_0_dmy_mask                                                  (0xFFFFFFFF)
+#define ISO_RESERVED_USE_0_dmy(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_RESERVED_USE_0_dmy_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_RESERVED_USE_0_get_dmy(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_LPI                                                                      0x18007068
+#define ISO_LPI_reg_addr                                                             "0xB8007068"
+#define ISO_LPI_reg                                                                  0xB8007068
+#define set_ISO_LPI_reg(data)   (*((volatile unsigned int*) ISO_LPI_reg)=data)
+#define get_ISO_LPI_reg   (*((volatile unsigned int*) ISO_LPI_reg))
+#define ISO_LPI_inst_adr                                                             "0x001A"
+#define ISO_LPI_inst                                                                 0x001A
+#define ISO_LPI_ir_tx_shift                                                          (1)
+#define ISO_LPI_ir_tx_mask                                                           (0x00000002)
+#define ISO_LPI_ir_tx(data)                                                          (0x00000002&((data)<<1))
+#define ISO_LPI_ir_tx_src(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_LPI_get_ir_tx(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_LPI_ir_raw_shift                                                         (0)
+#define ISO_LPI_ir_raw_mask                                                          (0x00000001)
+#define ISO_LPI_ir_raw(data)                                                         (0x00000001&((data)<<0))
+#define ISO_LPI_ir_raw_src(data)                                                     ((0x00000001&(data))>>0)
+#define ISO_LPI_get_ir_raw(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_WD                                                                       0x1800706C
+#define ISO_WD_reg_addr                                                              "0xB800706C"
+#define ISO_WD_reg                                                                   0xB800706C
+#define set_ISO_WD_reg(data)   (*((volatile unsigned int*) ISO_WD_reg)=data)
+#define get_ISO_WD_reg   (*((volatile unsigned int*) ISO_WD_reg))
+#define ISO_WD_inst_adr                                                              "0x001B"
+#define ISO_WD_inst                                                                  0x001B
+#define ISO_WD_cnt_wait_pwr_shift                                                    (0)
+#define ISO_WD_cnt_wait_pwr_mask                                                     (0x0000FFFF)
+#define ISO_WD_cnt_wait_pwr(data)                                                    (0x0000FFFF&((data)<<0))
+#define ISO_WD_cnt_wait_pwr_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define ISO_WD_get_cnt_wait_pwr(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_PLL_WDOUT                                                                0x18007070
+#define ISO_PLL_WDOUT_reg_addr                                                       "0xB8007070"
+#define ISO_PLL_WDOUT_reg                                                            0xB8007070
+#define set_ISO_PLL_WDOUT_reg(data)   (*((volatile unsigned int*) ISO_PLL_WDOUT_reg)=data)
+#define get_ISO_PLL_WDOUT_reg   (*((volatile unsigned int*) ISO_PLL_WDOUT_reg))
+#define ISO_PLL_WDOUT_inst_adr                                                       "0x001C"
+#define ISO_PLL_WDOUT_inst                                                           0x001C
+#define ISO_PLL_WDOUT_plletn_wdout_shift                                             (0)
+#define ISO_PLL_WDOUT_plletn_wdout_mask                                              (0x00000001)
+#define ISO_PLL_WDOUT_plletn_wdout(data)                                             (0x00000001&((data)<<0))
+#define ISO_PLL_WDOUT_plletn_wdout_src(data)                                         ((0x00000001&(data))>>0)
+#define ISO_PLL_WDOUT_get_plletn_wdout(data)                                         ((0x00000001&(data))>>0)
+
+
+#define ISO_PLL_ETN                                                                  0x18007074
+#define ISO_PLL_ETN_reg_addr                                                         "0xB8007074"
+#define ISO_PLL_ETN_reg                                                              0xB8007074
+#define set_ISO_PLL_ETN_reg(data)   (*((volatile unsigned int*) ISO_PLL_ETN_reg)=data)
+#define get_ISO_PLL_ETN_reg   (*((volatile unsigned int*) ISO_PLL_ETN_reg))
+#define ISO_PLL_ETN_inst_adr                                                         "0x001D"
+#define ISO_PLL_ETN_inst                                                             0x001D
+#define ISO_PLL_ETN_plletn_oeb_shift                                                 (27)
+#define ISO_PLL_ETN_plletn_oeb_mask                                                  (0x08000000)
+#define ISO_PLL_ETN_plletn_oeb(data)                                                 (0x08000000&((data)<<27))
+#define ISO_PLL_ETN_plletn_oeb_src(data)                                             ((0x08000000&(data))>>27)
+#define ISO_PLL_ETN_get_plletn_oeb(data)                                             ((0x08000000&(data))>>27)
+#define ISO_PLL_ETN_plletn_rstb_shift                                                (26)
+#define ISO_PLL_ETN_plletn_rstb_mask                                                 (0x04000000)
+#define ISO_PLL_ETN_plletn_rstb(data)                                                (0x04000000&((data)<<26))
+#define ISO_PLL_ETN_plletn_rstb_src(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PLL_ETN_get_plletn_rstb(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PLL_ETN_plletn_o_shift                                                   (22)
+#define ISO_PLL_ETN_plletn_o_mask                                                    (0x03C00000)
+#define ISO_PLL_ETN_plletn_o(data)                                                   (0x03C00000&((data)<<22))
+#define ISO_PLL_ETN_plletn_o_src(data)                                               ((0x03C00000&(data))>>22)
+#define ISO_PLL_ETN_get_plletn_o(data)                                               ((0x03C00000&(data))>>22)
+#define ISO_PLL_ETN_plletn_m_shift                                                   (15)
+#define ISO_PLL_ETN_plletn_m_mask                                                    (0x003F8000)
+#define ISO_PLL_ETN_plletn_m(data)                                                   (0x003F8000&((data)<<15))
+#define ISO_PLL_ETN_plletn_m_src(data)                                               ((0x003F8000&(data))>>15)
+#define ISO_PLL_ETN_get_plletn_m(data)                                               ((0x003F8000&(data))>>15)
+#define ISO_PLL_ETN_plletn_ldo_pow_shift                                             (14)
+#define ISO_PLL_ETN_plletn_ldo_pow_mask                                              (0x00004000)
+#define ISO_PLL_ETN_plletn_ldo_pow(data)                                             (0x00004000&((data)<<14))
+#define ISO_PLL_ETN_plletn_ldo_pow_src(data)                                         ((0x00004000&(data))>>14)
+#define ISO_PLL_ETN_get_plletn_ldo_pow(data)                                         ((0x00004000&(data))>>14)
+#define ISO_PLL_ETN_plletn_pow_shift                                                 (13)
+#define ISO_PLL_ETN_plletn_pow_mask                                                  (0x00002000)
+#define ISO_PLL_ETN_plletn_pow(data)                                                 (0x00002000&((data)<<13))
+#define ISO_PLL_ETN_plletn_pow_src(data)                                             ((0x00002000&(data))>>13)
+#define ISO_PLL_ETN_get_plletn_pow(data)                                             ((0x00002000&(data))>>13)
+#define ISO_PLL_ETN_plletn_ldo_sel_shift                                             (11)
+#define ISO_PLL_ETN_plletn_ldo_sel_mask                                              (0x00001800)
+#define ISO_PLL_ETN_plletn_ldo_sel(data)                                             (0x00001800&((data)<<11))
+#define ISO_PLL_ETN_plletn_ldo_sel_src(data)                                         ((0x00001800&(data))>>11)
+#define ISO_PLL_ETN_get_plletn_ldo_sel(data)                                         ((0x00001800&(data))>>11)
+#define ISO_PLL_ETN_plletn_wdmode_shift                                              (9)
+#define ISO_PLL_ETN_plletn_wdmode_mask                                               (0x00000600)
+#define ISO_PLL_ETN_plletn_wdmode(data)                                              (0x00000600&((data)<<9))
+#define ISO_PLL_ETN_plletn_wdmode_src(data)                                          ((0x00000600&(data))>>9)
+#define ISO_PLL_ETN_get_plletn_wdmode(data)                                          ((0x00000600&(data))>>9)
+#define ISO_PLL_ETN_plletn_n_shift                                                   (7)
+#define ISO_PLL_ETN_plletn_n_mask                                                    (0x00000180)
+#define ISO_PLL_ETN_plletn_n(data)                                                   (0x00000180&((data)<<7))
+#define ISO_PLL_ETN_plletn_n_src(data)                                               ((0x00000180&(data))>>7)
+#define ISO_PLL_ETN_get_plletn_n(data)                                               ((0x00000180&(data))>>7)
+#define ISO_PLL_ETN_plletn_lf_rs_shift                                               (5)
+#define ISO_PLL_ETN_plletn_lf_rs_mask                                                (0x00000060)
+#define ISO_PLL_ETN_plletn_lf_rs(data)                                               (0x00000060&((data)<<5))
+#define ISO_PLL_ETN_plletn_lf_rs_src(data)                                           ((0x00000060&(data))>>5)
+#define ISO_PLL_ETN_get_plletn_lf_rs(data)                                           ((0x00000060&(data))>>5)
+#define ISO_PLL_ETN_plletn_lf_cp_shift                                               (3)
+#define ISO_PLL_ETN_plletn_lf_cp_mask                                                (0x00000018)
+#define ISO_PLL_ETN_plletn_lf_cp(data)                                               (0x00000018&((data)<<3))
+#define ISO_PLL_ETN_plletn_lf_cp_src(data)                                           ((0x00000018&(data))>>3)
+#define ISO_PLL_ETN_get_plletn_lf_cp(data)                                           ((0x00000018&(data))>>3)
+#define ISO_PLL_ETN_plletn_ip_shift                                                  (0)
+#define ISO_PLL_ETN_plletn_ip_mask                                                   (0x00000007)
+#define ISO_PLL_ETN_plletn_ip(data)                                                  (0x00000007&((data)<<0))
+#define ISO_PLL_ETN_plletn_ip_src(data)                                              ((0x00000007&(data))>>0)
+#define ISO_PLL_ETN_get_plletn_ip(data)                                              ((0x00000007&(data))>>0)
+
+
+#define ISO_RESERVED_USE_1                                                           0x18007078
+#define ISO_RESERVED_USE_1_reg_addr                                                  "0xB8007078"
+#define ISO_RESERVED_USE_1_reg                                                       0xB8007078
+#define set_ISO_RESERVED_USE_1_reg(data)   (*((volatile unsigned int*) ISO_RESERVED_USE_1_reg)=data)
+#define get_ISO_RESERVED_USE_1_reg   (*((volatile unsigned int*) ISO_RESERVED_USE_1_reg))
+#define ISO_RESERVED_USE_1_inst_adr                                                  "0x001E"
+#define ISO_RESERVED_USE_1_inst                                                      0x001E
+#define ISO_RESERVED_USE_1_dmy_shift                                                 (0)
+#define ISO_RESERVED_USE_1_dmy_mask                                                  (0xFFFFFFFF)
+#define ISO_RESERVED_USE_1_dmy(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_RESERVED_USE_1_dmy_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_RESERVED_USE_1_get_dmy(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_RESERVED_USE_2                                                           0x1800707C
+#define ISO_RESERVED_USE_2_reg_addr                                                  "0xB800707C"
+#define ISO_RESERVED_USE_2_reg                                                       0xB800707C
+#define set_ISO_RESERVED_USE_2_reg(data)   (*((volatile unsigned int*) ISO_RESERVED_USE_2_reg)=data)
+#define get_ISO_RESERVED_USE_2_reg   (*((volatile unsigned int*) ISO_RESERVED_USE_2_reg))
+#define ISO_RESERVED_USE_2_inst_adr                                                  "0x001F"
+#define ISO_RESERVED_USE_2_inst                                                      0x001F
+#define ISO_RESERVED_USE_2_dmy_shift                                                 (0)
+#define ISO_RESERVED_USE_2_dmy_mask                                                  (0xFFFFFFFF)
+#define ISO_RESERVED_USE_2_dmy(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_RESERVED_USE_2_dmy_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_RESERVED_USE_2_get_dmy(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_RESERVED_USE_3                                                           0x18007080
+#define ISO_RESERVED_USE_3_reg_addr                                                  "0xB8007080"
+#define ISO_RESERVED_USE_3_reg                                                       0xB8007080
+#define set_ISO_RESERVED_USE_3_reg(data)   (*((volatile unsigned int*) ISO_RESERVED_USE_3_reg)=data)
+#define get_ISO_RESERVED_USE_3_reg   (*((volatile unsigned int*) ISO_RESERVED_USE_3_reg))
+#define ISO_RESERVED_USE_3_inst_adr                                                  "0x0020"
+#define ISO_RESERVED_USE_3_inst                                                      0x0020
+#define ISO_RESERVED_USE_3_dmy_shift                                                 (0)
+#define ISO_RESERVED_USE_3_dmy_mask                                                  (0xFFFFFFFF)
+#define ISO_RESERVED_USE_3_dmy(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_RESERVED_USE_3_dmy_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_RESERVED_USE_3_get_dmy(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_I2C0_SDA_DEL                                                             0x18007084
+#define ISO_I2C0_SDA_DEL_reg_addr                                                    "0xB8007084"
+#define ISO_I2C0_SDA_DEL_reg                                                         0xB8007084
+#define set_ISO_I2C0_SDA_DEL_reg(data)   (*((volatile unsigned int*) ISO_I2C0_SDA_DEL_reg)=data)
+#define get_ISO_I2C0_SDA_DEL_reg   (*((volatile unsigned int*) ISO_I2C0_SDA_DEL_reg))
+#define ISO_I2C0_SDA_DEL_inst_adr                                                    "0x0021"
+#define ISO_I2C0_SDA_DEL_inst                                                        0x0021
+#define ISO_I2C0_SDA_DEL_dmy1_shift                                                  (12)
+#define ISO_I2C0_SDA_DEL_dmy1_mask                                                   (0xFFFFF000)
+#define ISO_I2C0_SDA_DEL_dmy1(data)                                                  (0xFFFFF000&((data)<<12))
+#define ISO_I2C0_SDA_DEL_dmy1_src(data)                                              ((0xFFFFF000&(data))>>12)
+#define ISO_I2C0_SDA_DEL_get_dmy1(data)                                              ((0xFFFFF000&(data))>>12)
+#define ISO_I2C0_SDA_DEL_en_shift                                                    (8)
+#define ISO_I2C0_SDA_DEL_en_mask                                                     (0x00000100)
+#define ISO_I2C0_SDA_DEL_en(data)                                                    (0x00000100&((data)<<8))
+#define ISO_I2C0_SDA_DEL_en_src(data)                                                ((0x00000100&(data))>>8)
+#define ISO_I2C0_SDA_DEL_get_en(data)                                                ((0x00000100&(data))>>8)
+#define ISO_I2C0_SDA_DEL_sel_shift                                                   (0)
+#define ISO_I2C0_SDA_DEL_sel_mask                                                    (0x0000001F)
+#define ISO_I2C0_SDA_DEL_sel(data)                                                   (0x0000001F&((data)<<0))
+#define ISO_I2C0_SDA_DEL_sel_src(data)                                               ((0x0000001F&(data))>>0)
+#define ISO_I2C0_SDA_DEL_get_sel(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define ISO_SOFT_RESET                                                               0x18007088
+#define ISO_SOFT_RESET_reg_addr                                                      "0xB8007088"
+#define ISO_SOFT_RESET_reg                                                           0xB8007088
+#define set_ISO_SOFT_RESET_reg(data)   (*((volatile unsigned int*) ISO_SOFT_RESET_reg)=data)
+#define get_ISO_SOFT_RESET_reg   (*((volatile unsigned int*) ISO_SOFT_RESET_reg))
+#define ISO_SOFT_RESET_inst_adr                                                      "0x0022"
+#define ISO_SOFT_RESET_inst                                                          0x0022
+#define ISO_SOFT_RESET_rstn_cbus_shift                                               (13)
+#define ISO_SOFT_RESET_rstn_cbus_mask                                                (0x00002000)
+#define ISO_SOFT_RESET_rstn_cbus(data)                                               (0x00002000&((data)<<13))
+#define ISO_SOFT_RESET_rstn_cbus_src(data)                                           ((0x00002000&(data))>>13)
+#define ISO_SOFT_RESET_get_rstn_cbus(data)                                           ((0x00002000&(data))>>13)
+#define ISO_SOFT_RESET_rstn_i2c_6_shift                                              (12)
+#define ISO_SOFT_RESET_rstn_i2c_6_mask                                               (0x00001000)
+#define ISO_SOFT_RESET_rstn_i2c_6(data)                                              (0x00001000&((data)<<12))
+#define ISO_SOFT_RESET_rstn_i2c_6_src(data)                                          ((0x00001000&(data))>>12)
+#define ISO_SOFT_RESET_get_rstn_i2c_6(data)                                          ((0x00001000&(data))>>12)
+#define ISO_SOFT_RESET_rstn_i2c_0_shift                                              (11)
+#define ISO_SOFT_RESET_rstn_i2c_0_mask                                               (0x00000800)
+#define ISO_SOFT_RESET_rstn_i2c_0(data)                                              (0x00000800&((data)<<11))
+#define ISO_SOFT_RESET_rstn_i2c_0_src(data)                                          ((0x00000800&(data))>>11)
+#define ISO_SOFT_RESET_get_rstn_i2c_0(data)                                          ((0x00000800&(data))>>11)
+#define ISO_SOFT_RESET_rstn_gphy_shift                                               (10)
+#define ISO_SOFT_RESET_rstn_gphy_mask                                                (0x00000400)
+#define ISO_SOFT_RESET_rstn_gphy(data)                                               (0x00000400&((data)<<10))
+#define ISO_SOFT_RESET_rstn_gphy_src(data)                                           ((0x00000400&(data))>>10)
+#define ISO_SOFT_RESET_get_rstn_gphy(data)                                           ((0x00000400&(data))>>10)
+#define ISO_SOFT_RESET_rstn_gmac_shift                                               (9)
+#define ISO_SOFT_RESET_rstn_gmac_mask                                                (0x00000200)
+#define ISO_SOFT_RESET_rstn_gmac(data)                                               (0x00000200&((data)<<9))
+#define ISO_SOFT_RESET_rstn_gmac_src(data)                                           ((0x00000200&(data))>>9)
+#define ISO_SOFT_RESET_get_rstn_gmac(data)                                           ((0x00000200&(data))>>9)
+#define ISO_SOFT_RESET_rstn_ur0_shift                                                (8)
+#define ISO_SOFT_RESET_rstn_ur0_mask                                                 (0x00000100)
+#define ISO_SOFT_RESET_rstn_ur0(data)                                                (0x00000100&((data)<<8))
+#define ISO_SOFT_RESET_rstn_ur0_src(data)                                            ((0x00000100&(data))>>8)
+#define ISO_SOFT_RESET_get_rstn_ur0(data)                                            ((0x00000100&(data))>>8)
+#define ISO_SOFT_RESET_rstn_efuse_shift                                              (7)
+#define ISO_SOFT_RESET_rstn_efuse_mask                                               (0x00000080)
+#define ISO_SOFT_RESET_rstn_efuse(data)                                              (0x00000080&((data)<<7))
+#define ISO_SOFT_RESET_rstn_efuse_src(data)                                          ((0x00000080&(data))>>7)
+#define ISO_SOFT_RESET_get_rstn_efuse(data)                                          ((0x00000080&(data))>>7)
+#define ISO_SOFT_RESET_rstn_cbusrx_shift                                             (6)
+#define ISO_SOFT_RESET_rstn_cbusrx_mask                                              (0x00000040)
+#define ISO_SOFT_RESET_rstn_cbusrx(data)                                             (0x00000040&((data)<<6))
+#define ISO_SOFT_RESET_rstn_cbusrx_src(data)                                         ((0x00000040&(data))>>6)
+#define ISO_SOFT_RESET_get_rstn_cbusrx(data)                                         ((0x00000040&(data))>>6)
+#define ISO_SOFT_RESET_rstn_cbustx_shift                                             (5)
+#define ISO_SOFT_RESET_rstn_cbustx_mask                                              (0x00000020)
+#define ISO_SOFT_RESET_rstn_cbustx(data)                                             (0x00000020&((data)<<5))
+#define ISO_SOFT_RESET_rstn_cbustx_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_SOFT_RESET_get_rstn_cbustx(data)                                         ((0x00000020&(data))>>5)
+#define ISO_SOFT_RESET_rstn_dp_shift                                                 (4)
+#define ISO_SOFT_RESET_rstn_dp_mask                                                  (0x00000010)
+#define ISO_SOFT_RESET_rstn_dp(data)                                                 (0x00000010&((data)<<4))
+#define ISO_SOFT_RESET_rstn_dp_src(data)                                             ((0x00000010&(data))>>4)
+#define ISO_SOFT_RESET_get_rstn_dp(data)                                             ((0x00000010&(data))>>4)
+#define ISO_SOFT_RESET_rstn_cec1_shift                                               (3)
+#define ISO_SOFT_RESET_rstn_cec1_mask                                                (0x00000008)
+#define ISO_SOFT_RESET_rstn_cec1(data)                                               (0x00000008&((data)<<3))
+#define ISO_SOFT_RESET_rstn_cec1_src(data)                                           ((0x00000008&(data))>>3)
+#define ISO_SOFT_RESET_get_rstn_cec1(data)                                           ((0x00000008&(data))>>3)
+#define ISO_SOFT_RESET_rstn_cec0_shift                                               (2)
+#define ISO_SOFT_RESET_rstn_cec0_mask                                                (0x00000004)
+#define ISO_SOFT_RESET_rstn_cec0(data)                                               (0x00000004&((data)<<2))
+#define ISO_SOFT_RESET_rstn_cec0_src(data)                                           ((0x00000004&(data))>>2)
+#define ISO_SOFT_RESET_get_rstn_cec0(data)                                           ((0x00000004&(data))>>2)
+#define ISO_SOFT_RESET_rstn_ir_shift                                                 (1)
+#define ISO_SOFT_RESET_rstn_ir_mask                                                  (0x00000002)
+#define ISO_SOFT_RESET_rstn_ir(data)                                                 (0x00000002&((data)<<1))
+#define ISO_SOFT_RESET_rstn_ir_src(data)                                             ((0x00000002&(data))>>1)
+#define ISO_SOFT_RESET_get_rstn_ir(data)                                             ((0x00000002&(data))>>1)
+#define ISO_SOFT_RESET_rstn_vfd_shift                                                (0)
+#define ISO_SOFT_RESET_rstn_vfd_mask                                                 (0x00000001)
+#define ISO_SOFT_RESET_rstn_vfd(data)                                                (0x00000001&((data)<<0))
+#define ISO_SOFT_RESET_rstn_vfd_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_SOFT_RESET_get_rstn_vfd(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_CLOCK_ENABLE                                                             0x1800708C
+#define ISO_CLOCK_ENABLE_reg_addr                                                    "0xB800708C"
+#define ISO_CLOCK_ENABLE_reg                                                         0xB800708C
+#define set_ISO_CLOCK_ENABLE_reg(data)   (*((volatile unsigned int*) ISO_CLOCK_ENABLE_reg)=data)
+#define get_ISO_CLOCK_ENABLE_reg   (*((volatile unsigned int*) ISO_CLOCK_ENABLE_reg))
+#define ISO_CLOCK_ENABLE_inst_adr                                                    "0x0023"
+#define ISO_CLOCK_ENABLE_inst                                                        0x0023
+#define ISO_CLOCK_ENABLE_clk_en_etn_sys_shift                                        (12)
+#define ISO_CLOCK_ENABLE_clk_en_etn_sys_mask                                         (0x00001000)
+#define ISO_CLOCK_ENABLE_clk_en_etn_sys(data)                                        (0x00001000&((data)<<12))
+#define ISO_CLOCK_ENABLE_clk_en_etn_sys_src(data)                                    ((0x00001000&(data))>>12)
+#define ISO_CLOCK_ENABLE_get_clk_en_etn_sys(data)                                    ((0x00001000&(data))>>12)
+#define ISO_CLOCK_ENABLE_clk_en_etn_250m_shift                                       (11)
+#define ISO_CLOCK_ENABLE_clk_en_etn_250m_mask                                        (0x00000800)
+#define ISO_CLOCK_ENABLE_clk_en_etn_250m(data)                                       (0x00000800&((data)<<11))
+#define ISO_CLOCK_ENABLE_clk_en_etn_250m_src(data)                                   ((0x00000800&(data))>>11)
+#define ISO_CLOCK_ENABLE_get_clk_en_etn_250m(data)                                   ((0x00000800&(data))>>11)
+#define ISO_CLOCK_ENABLE_clk_en_i2c6_shift                                           (10)
+#define ISO_CLOCK_ENABLE_clk_en_i2c6_mask                                            (0x00000400)
+#define ISO_CLOCK_ENABLE_clk_en_i2c6(data)                                           (0x00000400&((data)<<10))
+#define ISO_CLOCK_ENABLE_clk_en_i2c6_src(data)                                       ((0x00000400&(data))>>10)
+#define ISO_CLOCK_ENABLE_get_clk_en_i2c6(data)                                       ((0x00000400&(data))>>10)
+#define ISO_CLOCK_ENABLE_clk_en_i2c0_shift                                           (9)
+#define ISO_CLOCK_ENABLE_clk_en_i2c0_mask                                            (0x00000200)
+#define ISO_CLOCK_ENABLE_clk_en_i2c0(data)                                           (0x00000200&((data)<<9))
+#define ISO_CLOCK_ENABLE_clk_en_i2c0_src(data)                                       ((0x00000200&(data))>>9)
+#define ISO_CLOCK_ENABLE_get_clk_en_i2c0(data)                                       ((0x00000200&(data))>>9)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ur0_shift                                       (8)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ur0_mask                                        (0x00000100)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ur0(data)                                       (0x00000100&((data)<<8))
+#define ISO_CLOCK_ENABLE_clk_en_misc_ur0_src(data)                                   ((0x00000100&(data))>>8)
+#define ISO_CLOCK_ENABLE_get_clk_en_misc_ur0(data)                                   ((0x00000100&(data))>>8)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ir_shift                                        (7)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ir_mask                                         (0x00000080)
+#define ISO_CLOCK_ENABLE_clk_en_misc_ir(data)                                        (0x00000080&((data)<<7))
+#define ISO_CLOCK_ENABLE_clk_en_misc_ir_src(data)                                    ((0x00000080&(data))>>7)
+#define ISO_CLOCK_ENABLE_get_clk_en_misc_ir(data)                                    ((0x00000080&(data))>>7)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_osc_shift                                       (6)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_osc_mask                                        (0x00000040)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_osc(data)                                       (0x00000040&((data)<<6))
+#define ISO_CLOCK_ENABLE_clk_en_cbus_osc_src(data)                                   ((0x00000040&(data))>>6)
+#define ISO_CLOCK_ENABLE_get_clk_en_cbus_osc(data)                                   ((0x00000040&(data))>>6)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_sys_shift                                       (5)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_sys_mask                                        (0x00000020)
+#define ISO_CLOCK_ENABLE_clk_en_cbus_sys(data)                                       (0x00000020&((data)<<5))
+#define ISO_CLOCK_ENABLE_clk_en_cbus_sys_src(data)                                   ((0x00000020&(data))>>5)
+#define ISO_CLOCK_ENABLE_get_clk_en_cbus_sys(data)                                   ((0x00000020&(data))>>5)
+#define ISO_CLOCK_ENABLE_clk_en_cbustx_sys_shift                                     (4)
+#define ISO_CLOCK_ENABLE_clk_en_cbustx_sys_mask                                      (0x00000010)
+#define ISO_CLOCK_ENABLE_clk_en_cbustx_sys(data)                                     (0x00000010&((data)<<4))
+#define ISO_CLOCK_ENABLE_clk_en_cbustx_sys_src(data)                                 ((0x00000010&(data))>>4)
+#define ISO_CLOCK_ENABLE_get_clk_en_cbustx_sys(data)                                 ((0x00000010&(data))>>4)
+#define ISO_CLOCK_ENABLE_clk_en_cbusrx_sys_shift                                     (3)
+#define ISO_CLOCK_ENABLE_clk_en_cbusrx_sys_mask                                      (0x00000008)
+#define ISO_CLOCK_ENABLE_clk_en_cbusrx_sys(data)                                     (0x00000008&((data)<<3))
+#define ISO_CLOCK_ENABLE_clk_en_cbusrx_sys_src(data)                                 ((0x00000008&(data))>>3)
+#define ISO_CLOCK_ENABLE_get_clk_en_cbusrx_sys(data)                                 ((0x00000008&(data))>>3)
+#define ISO_CLOCK_ENABLE_clk_en_misc_cec0_shift                                      (2)
+#define ISO_CLOCK_ENABLE_clk_en_misc_cec0_mask                                       (0x00000004)
+#define ISO_CLOCK_ENABLE_clk_en_misc_cec0(data)                                      (0x00000004&((data)<<2))
+#define ISO_CLOCK_ENABLE_clk_en_misc_cec0_src(data)                                  ((0x00000004&(data))>>2)
+#define ISO_CLOCK_ENABLE_get_clk_en_misc_cec0(data)                                  ((0x00000004&(data))>>2)
+#define ISO_CLOCK_ENABLE_clk_en_misc_vfd_shift                                       (1)
+#define ISO_CLOCK_ENABLE_clk_en_misc_vfd_mask                                        (0x00000002)
+#define ISO_CLOCK_ENABLE_clk_en_misc_vfd(data)                                       (0x00000002&((data)<<1))
+#define ISO_CLOCK_ENABLE_clk_en_misc_vfd_src(data)                                   ((0x00000002&(data))>>1)
+#define ISO_CLOCK_ENABLE_get_clk_en_misc_vfd(data)                                   ((0x00000002&(data))>>1)
+#define ISO_CLOCK_ENABLE_clk_en_misc_mix_shift                                       (0)
+#define ISO_CLOCK_ENABLE_clk_en_misc_mix_mask                                        (0x00000001)
+#define ISO_CLOCK_ENABLE_clk_en_misc_mix(data)                                       (0x00000001&((data)<<0))
+#define ISO_CLOCK_ENABLE_clk_en_misc_mix_src(data)                                   ((0x00000001&(data))>>0)
+#define ISO_CLOCK_ENABLE_get_clk_en_misc_mix(data)                                   ((0x00000001&(data))>>0)
+
+
+#define ISO_DC_0                                                                     0x18007090
+#define ISO_DC_0_reg_addr                                                            "0xB8007090"
+#define ISO_DC_0_reg                                                                 0xB8007090
+#define set_ISO_DC_0_reg(data)   (*((volatile unsigned int*) ISO_DC_0_reg)=data)
+#define get_ISO_DC_0_reg   (*((volatile unsigned int*) ISO_DC_0_reg))
+#define ISO_DC_0_inst_adr                                                            "0x0024"
+#define ISO_DC_0_inst                                                                0x0024
+#define ISO_DC_0_rd_only_0_en_shift                                                  (24)
+#define ISO_DC_0_rd_only_0_en_mask                                                   (0x01000000)
+#define ISO_DC_0_rd_only_0_en(data)                                                  (0x01000000&((data)<<24))
+#define ISO_DC_0_rd_only_0_en_src(data)                                              ((0x01000000&(data))>>24)
+#define ISO_DC_0_get_rd_only_0_en(data)                                              ((0x01000000&(data))>>24)
+#define ISO_DC_0_blk_protect_0_wpro_en_shift                                         (21)
+#define ISO_DC_0_blk_protect_0_wpro_en_mask                                          (0x00200000)
+#define ISO_DC_0_blk_protect_0_wpro_en(data)                                         (0x00200000&((data)<<21))
+#define ISO_DC_0_blk_protect_0_wpro_en_src(data)                                     ((0x00200000&(data))>>21)
+#define ISO_DC_0_get_blk_protect_0_wpro_en(data)                                     ((0x00200000&(data))>>21)
+#define ISO_DC_0_blk_protect_0_en_shift                                              (18)
+#define ISO_DC_0_blk_protect_0_en_mask                                               (0x00040000)
+#define ISO_DC_0_blk_protect_0_en(data)                                              (0x00040000&((data)<<18))
+#define ISO_DC_0_blk_protect_0_en_src(data)                                          ((0x00040000&(data))>>18)
+#define ISO_DC_0_get_blk_protect_0_en(data)                                          ((0x00040000&(data))>>18)
+#define ISO_DC_0_protect_0_wpro_en_shift                                             (9)
+#define ISO_DC_0_protect_0_wpro_en_mask                                              (0x00000200)
+#define ISO_DC_0_protect_0_wpro_en(data)                                             (0x00000200&((data)<<9))
+#define ISO_DC_0_protect_0_wpro_en_src(data)                                         ((0x00000200&(data))>>9)
+#define ISO_DC_0_get_protect_0_wpro_en(data)                                         ((0x00000200&(data))>>9)
+#define ISO_DC_0_protect_0_en_shift                                                  (0)
+#define ISO_DC_0_protect_0_en_mask                                                   (0x00000001)
+#define ISO_DC_0_protect_0_en(data)                                                  (0x00000001&((data)<<0))
+#define ISO_DC_0_protect_0_en_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_DC_0_get_protect_0_en(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_DC_1                                                                     0x18007094
+#define ISO_DC_1_reg_addr                                                            "0xB8007094"
+#define ISO_DC_1_reg                                                                 0xB8007094
+#define set_ISO_DC_1_reg(data)   (*((volatile unsigned int*) ISO_DC_1_reg)=data)
+#define get_ISO_DC_1_reg   (*((volatile unsigned int*) ISO_DC_1_reg))
+#define ISO_DC_1_inst_adr                                                            "0x0025"
+#define ISO_DC_1_inst                                                                0x0025
+#define ISO_DC_1_mem_saddr0_shift                                                    (12)
+#define ISO_DC_1_mem_saddr0_mask                                                     (0xFFFFF000)
+#define ISO_DC_1_mem_saddr0(data)                                                    (0xFFFFF000&((data)<<12))
+#define ISO_DC_1_mem_saddr0_src(data)                                                ((0xFFFFF000&(data))>>12)
+#define ISO_DC_1_get_mem_saddr0(data)                                                ((0xFFFFF000&(data))>>12)
+
+
+#define ISO_DC_2                                                                     0x18007098
+#define ISO_DC_2_reg_addr                                                            "0xB8007098"
+#define ISO_DC_2_reg                                                                 0xB8007098
+#define set_ISO_DC_2_reg(data)   (*((volatile unsigned int*) ISO_DC_2_reg)=data)
+#define get_ISO_DC_2_reg   (*((volatile unsigned int*) ISO_DC_2_reg))
+#define ISO_DC_2_inst_adr                                                            "0x0026"
+#define ISO_DC_2_inst                                                                0x0026
+#define ISO_DC_2_mem_eaddr0_shift                                                    (12)
+#define ISO_DC_2_mem_eaddr0_mask                                                     (0xFFFFF000)
+#define ISO_DC_2_mem_eaddr0(data)                                                    (0xFFFFF000&((data)<<12))
+#define ISO_DC_2_mem_eaddr0_src(data)                                                ((0xFFFFF000&(data))>>12)
+#define ISO_DC_2_get_mem_eaddr0(data)                                                ((0xFFFFF000&(data))>>12)
+
+
+#define ISO_DC_3                                                                     0x1800709C
+#define ISO_DC_3_reg_addr                                                            "0xB800709C"
+#define ISO_DC_3_reg                                                                 0xB800709C
+#define set_ISO_DC_3_reg(data)   (*((volatile unsigned int*) ISO_DC_3_reg)=data)
+#define get_ISO_DC_3_reg   (*((volatile unsigned int*) ISO_DC_3_reg))
+#define ISO_DC_3_inst_adr                                                            "0x0027"
+#define ISO_DC_3_inst                                                                0x0027
+#define ISO_DC_3_blk_saddr0_shift                                                    (12)
+#define ISO_DC_3_blk_saddr0_mask                                                     (0xFFFFF000)
+#define ISO_DC_3_blk_saddr0(data)                                                    (0xFFFFF000&((data)<<12))
+#define ISO_DC_3_blk_saddr0_src(data)                                                ((0xFFFFF000&(data))>>12)
+#define ISO_DC_3_get_blk_saddr0(data)                                                ((0xFFFFF000&(data))>>12)
+
+
+#define ISO_DC_4                                                                     0x180070A0
+#define ISO_DC_4_reg_addr                                                            "0xB80070A0"
+#define ISO_DC_4_reg                                                                 0xB80070A0
+#define set_ISO_DC_4_reg(data)   (*((volatile unsigned int*) ISO_DC_4_reg)=data)
+#define get_ISO_DC_4_reg   (*((volatile unsigned int*) ISO_DC_4_reg))
+#define ISO_DC_4_inst_adr                                                            "0x0028"
+#define ISO_DC_4_inst                                                                0x0028
+#define ISO_DC_4_blk_eaddr0_shift                                                    (12)
+#define ISO_DC_4_blk_eaddr0_mask                                                     (0xFFFFF000)
+#define ISO_DC_4_blk_eaddr0(data)                                                    (0xFFFFF000&((data)<<12))
+#define ISO_DC_4_blk_eaddr0_src(data)                                                ((0xFFFFF000&(data))>>12)
+#define ISO_DC_4_get_blk_eaddr0(data)                                                ((0xFFFFF000&(data))>>12)
+
+
+#define ISO_DC_5                                                                     0x180070A4
+#define ISO_DC_5_reg_addr                                                            "0xB80070A4"
+#define ISO_DC_5_reg                                                                 0xB80070A4
+#define set_ISO_DC_5_reg(data)   (*((volatile unsigned int*) ISO_DC_5_reg)=data)
+#define get_ISO_DC_5_reg   (*((volatile unsigned int*) ISO_DC_5_reg))
+#define ISO_DC_5_inst_adr                                                            "0x0029"
+#define ISO_DC_5_inst                                                                0x0029
+#define ISO_DC_5_ro_saddr0_shift                                                     (12)
+#define ISO_DC_5_ro_saddr0_mask                                                      (0xFFFFF000)
+#define ISO_DC_5_ro_saddr0(data)                                                     (0xFFFFF000&((data)<<12))
+#define ISO_DC_5_ro_saddr0_src(data)                                                 ((0xFFFFF000&(data))>>12)
+#define ISO_DC_5_get_ro_saddr0(data)                                                 ((0xFFFFF000&(data))>>12)
+
+
+#define ISO_DC_6                                                                     0x180070A8
+#define ISO_DC_6_reg_addr                                                            "0xB80070A8"
+#define ISO_DC_6_reg                                                                 0xB80070A8
+#define set_ISO_DC_6_reg(data)   (*((volatile unsigned int*) ISO_DC_6_reg)=data)
+#define get_ISO_DC_6_reg   (*((volatile unsigned int*) ISO_DC_6_reg))
+#define ISO_DC_6_inst_adr                                                            "0x002A"
+#define ISO_DC_6_inst                                                                0x002A
+#define ISO_DC_6_ro_eaddr0_shift                                                     (12)
+#define ISO_DC_6_ro_eaddr0_mask                                                      (0xFFFFF000)
+#define ISO_DC_6_ro_eaddr0(data)                                                     (0xFFFFF000&((data)<<12))
+#define ISO_DC_6_ro_eaddr0_src(data)                                                 ((0xFFFFF000&(data))>>12)
+#define ISO_DC_6_get_ro_eaddr0(data)                                                 ((0xFFFFF000&(data))>>12)
+
+
+#define ISO_DC_7                                                                     0x180070AC
+#define ISO_DC_7_reg_addr                                                            "0xB80070AC"
+#define ISO_DC_7_reg                                                                 0xB80070AC
+#define set_ISO_DC_7_reg(data)   (*((volatile unsigned int*) ISO_DC_7_reg)=data)
+#define get_ISO_DC_7_reg   (*((volatile unsigned int*) ISO_DC_7_reg))
+#define ISO_DC_7_inst_adr                                                            "0x002B"
+#define ISO_DC_7_inst                                                                0x002B
+#define ISO_DC_7_md_tee_protect_en_shift                                             (24)
+#define ISO_DC_7_md_tee_protect_en_mask                                              (0x01000000)
+#define ISO_DC_7_md_tee_protect_en(data)                                             (0x01000000&((data)<<24))
+#define ISO_DC_7_md_tee_protect_en_src(data)                                         ((0x01000000&(data))>>24)
+#define ISO_DC_7_get_md_tee_protect_en(data)                                         ((0x01000000&(data))>>24)
+#define ISO_DC_7_cp_tee_protect_en_shift                                             (16)
+#define ISO_DC_7_cp_tee_protect_en_mask                                              (0x00010000)
+#define ISO_DC_7_cp_tee_protect_en(data)                                             (0x00010000&((data)<<16))
+#define ISO_DC_7_cp_tee_protect_en_src(data)                                         ((0x00010000&(data))>>16)
+#define ISO_DC_7_get_cp_tee_protect_en(data)                                         ((0x00010000&(data))>>16)
+#define ISO_DC_7_vo_protect_en_shift                                                 (8)
+#define ISO_DC_7_vo_protect_en_mask                                                  (0x00000100)
+#define ISO_DC_7_vo_protect_en(data)                                                 (0x00000100&((data)<<8))
+#define ISO_DC_7_vo_protect_en_src(data)                                             ((0x00000100&(data))>>8)
+#define ISO_DC_7_get_vo_protect_en(data)                                             ((0x00000100&(data))>>8)
+#define ISO_DC_7_nf_tee_protect_en_shift                                             (0)
+#define ISO_DC_7_nf_tee_protect_en_mask                                              (0x00000001)
+#define ISO_DC_7_nf_tee_protect_en(data)                                             (0x00000001&((data)<<0))
+#define ISO_DC_7_nf_tee_protect_en_src(data)                                         ((0x00000001&(data))>>0)
+#define ISO_DC_7_get_nf_tee_protect_en(data)                                         ((0x00000001&(data))>>0)
+
+
+#define ISO_DC_8                                                                     0x180070B0
+#define ISO_DC_8_reg_addr                                                            "0xB80070B0"
+#define ISO_DC_8_reg                                                                 0xB80070B0
+#define set_ISO_DC_8_reg(data)   (*((volatile unsigned int*) ISO_DC_8_reg)=data)
+#define get_ISO_DC_8_reg   (*((volatile unsigned int*) ISO_DC_8_reg))
+#define ISO_DC_8_inst_adr                                                            "0x002C"
+#define ISO_DC_8_inst                                                                0x002C
+#define ISO_DC_8_scpu_tee_protect_en_shift                                           (24)
+#define ISO_DC_8_scpu_tee_protect_en_mask                                            (0x01000000)
+#define ISO_DC_8_scpu_tee_protect_en(data)                                           (0x01000000&((data)<<24))
+#define ISO_DC_8_scpu_tee_protect_en_src(data)                                       ((0x01000000&(data))>>24)
+#define ISO_DC_8_get_scpu_tee_protect_en(data)                                       ((0x01000000&(data))>>24)
+#define ISO_DC_8_acpu_protect_en_shift                                               (16)
+#define ISO_DC_8_acpu_protect_en_mask                                                (0x00010000)
+#define ISO_DC_8_acpu_protect_en(data)                                               (0x00010000&((data)<<16))
+#define ISO_DC_8_acpu_protect_en_src(data)                                           ((0x00010000&(data))>>16)
+#define ISO_DC_8_get_acpu_protect_en(data)                                           ((0x00010000&(data))>>16)
+#define ISO_DC_8_video_protect_en_shift                                              (8)
+#define ISO_DC_8_video_protect_en_mask                                               (0x00000100)
+#define ISO_DC_8_video_protect_en(data)                                              (0x00000100&((data)<<8))
+#define ISO_DC_8_video_protect_en_src(data)                                          ((0x00000100&(data))>>8)
+#define ISO_DC_8_get_video_protect_en(data)                                          ((0x00000100&(data))>>8)
+#define ISO_DC_8_audio_protect_en_shift                                              (0)
+#define ISO_DC_8_audio_protect_en_mask                                               (0x00000001)
+#define ISO_DC_8_audio_protect_en(data)                                              (0x00000001&((data)<<0))
+#define ISO_DC_8_audio_protect_en_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_DC_8_get_audio_protect_en(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_DC_9                                                                     0x180070B4
+#define ISO_DC_9_reg_addr                                                            "0xB80070B4"
+#define ISO_DC_9_reg                                                                 0xB80070B4
+#define set_ISO_DC_9_reg(data)   (*((volatile unsigned int*) ISO_DC_9_reg)=data)
+#define get_ISO_DC_9_reg   (*((volatile unsigned int*) ISO_DC_9_reg))
+#define ISO_DC_9_inst_adr                                                            "0x002D"
+#define ISO_DC_9_inst                                                                0x002D
+#define ISO_DC_9_scpu_tee_blk_protect_en_shift                                       (14)
+#define ISO_DC_9_scpu_tee_blk_protect_en_mask                                        (0x00004000)
+#define ISO_DC_9_scpu_tee_blk_protect_en(data)                                       (0x00004000&((data)<<14))
+#define ISO_DC_9_scpu_tee_blk_protect_en_src(data)                                   ((0x00004000&(data))>>14)
+#define ISO_DC_9_get_scpu_tee_blk_protect_en(data)                                   ((0x00004000&(data))>>14)
+#define ISO_DC_9_acpu_blk_protect_en_shift                                           (12)
+#define ISO_DC_9_acpu_blk_protect_en_mask                                            (0x00001000)
+#define ISO_DC_9_acpu_blk_protect_en(data)                                           (0x00001000&((data)<<12))
+#define ISO_DC_9_acpu_blk_protect_en_src(data)                                       ((0x00001000&(data))>>12)
+#define ISO_DC_9_get_acpu_blk_protect_en(data)                                       ((0x00001000&(data))>>12)
+#define ISO_DC_9_video_blk_protect_en_shift                                          (10)
+#define ISO_DC_9_video_blk_protect_en_mask                                           (0x00000400)
+#define ISO_DC_9_video_blk_protect_en(data)                                          (0x00000400&((data)<<10))
+#define ISO_DC_9_video_blk_protect_en_src(data)                                      ((0x00000400&(data))>>10)
+#define ISO_DC_9_get_video_blk_protect_en(data)                                      ((0x00000400&(data))>>10)
+#define ISO_DC_9_audio_blk_protect_en_shift                                          (8)
+#define ISO_DC_9_audio_blk_protect_en_mask                                           (0x00000100)
+#define ISO_DC_9_audio_blk_protect_en(data)                                          (0x00000100&((data)<<8))
+#define ISO_DC_9_audio_blk_protect_en_src(data)                                      ((0x00000100&(data))>>8)
+#define ISO_DC_9_get_audio_blk_protect_en(data)                                      ((0x00000100&(data))>>8)
+#define ISO_DC_9_md_tee_blk_protect_en_shift                                         (6)
+#define ISO_DC_9_md_tee_blk_protect_en_mask                                          (0x00000040)
+#define ISO_DC_9_md_tee_blk_protect_en(data)                                         (0x00000040&((data)<<6))
+#define ISO_DC_9_md_tee_blk_protect_en_src(data)                                     ((0x00000040&(data))>>6)
+#define ISO_DC_9_get_md_tee_blk_protect_en(data)                                     ((0x00000040&(data))>>6)
+#define ISO_DC_9_cp_tee_blk_protect_en_shift                                         (4)
+#define ISO_DC_9_cp_tee_blk_protect_en_mask                                          (0x00000010)
+#define ISO_DC_9_cp_tee_blk_protect_en(data)                                         (0x00000010&((data)<<4))
+#define ISO_DC_9_cp_tee_blk_protect_en_src(data)                                     ((0x00000010&(data))>>4)
+#define ISO_DC_9_get_cp_tee_blk_protect_en(data)                                     ((0x00000010&(data))>>4)
+#define ISO_DC_9_vo_blk_protect_en_shift                                             (2)
+#define ISO_DC_9_vo_blk_protect_en_mask                                              (0x00000004)
+#define ISO_DC_9_vo_blk_protect_en(data)                                             (0x00000004&((data)<<2))
+#define ISO_DC_9_vo_blk_protect_en_src(data)                                         ((0x00000004&(data))>>2)
+#define ISO_DC_9_get_vo_blk_protect_en(data)                                         ((0x00000004&(data))>>2)
+#define ISO_DC_9_nf_tee_blk_protect_en_shift                                         (0)
+#define ISO_DC_9_nf_tee_blk_protect_en_mask                                          (0x00000001)
+#define ISO_DC_9_nf_tee_blk_protect_en(data)                                         (0x00000001&((data)<<0))
+#define ISO_DC_9_nf_tee_blk_protect_en_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_DC_9_get_nf_tee_blk_protect_en(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_DC_A                                                                     0x180070B8
+#define ISO_DC_A_reg_addr                                                            "0xB80070B8"
+#define ISO_DC_A_reg                                                                 0xB80070B8
+#define set_ISO_DC_A_reg(data)   (*((volatile unsigned int*) ISO_DC_A_reg)=data)
+#define get_ISO_DC_A_reg   (*((volatile unsigned int*) ISO_DC_A_reg))
+#define ISO_DC_A_inst_adr                                                            "0x002E"
+#define ISO_DC_A_inst                                                                0x002E
+#define ISO_DC_A_scpu_tee_ro_protect_en_shift                                        (28)
+#define ISO_DC_A_scpu_tee_ro_protect_en_mask                                         (0x10000000)
+#define ISO_DC_A_scpu_tee_ro_protect_en(data)                                        (0x10000000&((data)<<28))
+#define ISO_DC_A_scpu_tee_ro_protect_en_src(data)                                    ((0x10000000&(data))>>28)
+#define ISO_DC_A_get_scpu_tee_ro_protect_en(data)                                    ((0x10000000&(data))>>28)
+#define ISO_DC_A_acpu_ro_protect_en_shift                                            (24)
+#define ISO_DC_A_acpu_ro_protect_en_mask                                             (0x01000000)
+#define ISO_DC_A_acpu_ro_protect_en(data)                                            (0x01000000&((data)<<24))
+#define ISO_DC_A_acpu_ro_protect_en_src(data)                                        ((0x01000000&(data))>>24)
+#define ISO_DC_A_get_acpu_ro_protect_en(data)                                        ((0x01000000&(data))>>24)
+#define ISO_DC_A_video_ro_protect_en_shift                                           (20)
+#define ISO_DC_A_video_ro_protect_en_mask                                            (0x00100000)
+#define ISO_DC_A_video_ro_protect_en(data)                                           (0x00100000&((data)<<20))
+#define ISO_DC_A_video_ro_protect_en_src(data)                                       ((0x00100000&(data))>>20)
+#define ISO_DC_A_get_video_ro_protect_en(data)                                       ((0x00100000&(data))>>20)
+#define ISO_DC_A_audio_ro_protect_en_shift                                           (16)
+#define ISO_DC_A_audio_ro_protect_en_mask                                            (0x00010000)
+#define ISO_DC_A_audio_ro_protect_en(data)                                           (0x00010000&((data)<<16))
+#define ISO_DC_A_audio_ro_protect_en_src(data)                                       ((0x00010000&(data))>>16)
+#define ISO_DC_A_get_audio_ro_protect_en(data)                                       ((0x00010000&(data))>>16)
+#define ISO_DC_A_md_tee_ro_protect_en_shift                                          (12)
+#define ISO_DC_A_md_tee_ro_protect_en_mask                                           (0x00001000)
+#define ISO_DC_A_md_tee_ro_protect_en(data)                                          (0x00001000&((data)<<12))
+#define ISO_DC_A_md_tee_ro_protect_en_src(data)                                      ((0x00001000&(data))>>12)
+#define ISO_DC_A_get_md_tee_ro_protect_en(data)                                      ((0x00001000&(data))>>12)
+#define ISO_DC_A_cp_tee_ro_protect_en_shift                                          (8)
+#define ISO_DC_A_cp_tee_ro_protect_en_mask                                           (0x00000100)
+#define ISO_DC_A_cp_tee_ro_protect_en(data)                                          (0x00000100&((data)<<8))
+#define ISO_DC_A_cp_tee_ro_protect_en_src(data)                                      ((0x00000100&(data))>>8)
+#define ISO_DC_A_get_cp_tee_ro_protect_en(data)                                      ((0x00000100&(data))>>8)
+#define ISO_DC_A_vo_ro_protect_en_shift                                              (4)
+#define ISO_DC_A_vo_ro_protect_en_mask                                               (0x00000010)
+#define ISO_DC_A_vo_ro_protect_en(data)                                              (0x00000010&((data)<<4))
+#define ISO_DC_A_vo_ro_protect_en_src(data)                                          ((0x00000010&(data))>>4)
+#define ISO_DC_A_get_vo_ro_protect_en(data)                                          ((0x00000010&(data))>>4)
+#define ISO_DC_A_nf_tee_ro_protect_en_shift                                          (0)
+#define ISO_DC_A_nf_tee_ro_protect_en_mask                                           (0x00000001)
+#define ISO_DC_A_nf_tee_ro_protect_en(data)                                          (0x00000001&((data)<<0))
+#define ISO_DC_A_nf_tee_ro_protect_en_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_DC_A_get_nf_tee_ro_protect_en(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_PLL_XTAL_CTRL                                                            0x180070BC
+#define ISO_PLL_XTAL_CTRL_reg_addr                                                   "0xB80070BC"
+#define ISO_PLL_XTAL_CTRL_reg                                                        0xB80070BC
+#define set_ISO_PLL_XTAL_CTRL_reg(data)   (*((volatile unsigned int*) ISO_PLL_XTAL_CTRL_reg)=data)
+#define get_ISO_PLL_XTAL_CTRL_reg   (*((volatile unsigned int*) ISO_PLL_XTAL_CTRL_reg))
+#define ISO_PLL_XTAL_CTRL_inst_adr                                                   "0x002F"
+#define ISO_PLL_XTAL_CTRL_inst                                                       0x002F
+#define ISO_PLL_XTAL_CTRL_xtal_pad_drv_shift                                         (0)
+#define ISO_PLL_XTAL_CTRL_xtal_pad_drv_mask                                          (0x00000003)
+#define ISO_PLL_XTAL_CTRL_xtal_pad_drv(data)                                         (0x00000003&((data)<<0))
+#define ISO_PLL_XTAL_CTRL_xtal_pad_drv_src(data)                                     ((0x00000003&(data))>>0)
+#define ISO_PLL_XTAL_CTRL_get_xtal_pad_drv(data)                                     ((0x00000003&(data))>>0)
+
+
+#define ISO_I2C6_SDA_DEL                                                             0x180070C0
+#define ISO_I2C6_SDA_DEL_reg_addr                                                    "0xB80070C0"
+#define ISO_I2C6_SDA_DEL_reg                                                         0xB80070C0
+#define set_ISO_I2C6_SDA_DEL_reg(data)   (*((volatile unsigned int*) ISO_I2C6_SDA_DEL_reg)=data)
+#define get_ISO_I2C6_SDA_DEL_reg   (*((volatile unsigned int*) ISO_I2C6_SDA_DEL_reg))
+#define ISO_I2C6_SDA_DEL_inst_adr                                                    "0x0030"
+#define ISO_I2C6_SDA_DEL_inst                                                        0x0030
+#define ISO_I2C6_SDA_DEL_dmy1_shift                                                  (12)
+#define ISO_I2C6_SDA_DEL_dmy1_mask                                                   (0xFFFFF000)
+#define ISO_I2C6_SDA_DEL_dmy1(data)                                                  (0xFFFFF000&((data)<<12))
+#define ISO_I2C6_SDA_DEL_dmy1_src(data)                                              ((0xFFFFF000&(data))>>12)
+#define ISO_I2C6_SDA_DEL_get_dmy1(data)                                              ((0xFFFFF000&(data))>>12)
+#define ISO_I2C6_SDA_DEL_en_shift                                                    (8)
+#define ISO_I2C6_SDA_DEL_en_mask                                                     (0x00000100)
+#define ISO_I2C6_SDA_DEL_en(data)                                                    (0x00000100&((data)<<8))
+#define ISO_I2C6_SDA_DEL_en_src(data)                                                ((0x00000100&(data))>>8)
+#define ISO_I2C6_SDA_DEL_get_en(data)                                                ((0x00000100&(data))>>8)
+#define ISO_I2C6_SDA_DEL_sel_shift                                                   (0)
+#define ISO_I2C6_SDA_DEL_sel_mask                                                    (0x0000001F)
+#define ISO_I2C6_SDA_DEL_sel(data)                                                   (0x0000001F&((data)<<0))
+#define ISO_I2C6_SDA_DEL_sel_src(data)                                               ((0x0000001F&(data))>>0)
+#define ISO_I2C6_SDA_DEL_get_sel(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define ISO_HDMI_RX                                                                  0x180070C4
+#define ISO_HDMI_RX_reg_addr                                                         "0xB80070C4"
+#define ISO_HDMI_RX_reg                                                              0xB80070C4
+#define set_ISO_HDMI_RX_reg(data)   (*((volatile unsigned int*) ISO_HDMI_RX_reg)=data)
+#define get_ISO_HDMI_RX_reg   (*((volatile unsigned int*) ISO_HDMI_RX_reg))
+#define ISO_HDMI_RX_inst_adr                                                         "0x0031"
+#define ISO_HDMI_RX_inst                                                             0x0031
+#define ISO_HDMI_RX_int_option_shift                                                 (0)
+#define ISO_HDMI_RX_int_option_mask                                                  (0x00000001)
+#define ISO_HDMI_RX_int_option(data)                                                 (0x00000001&((data)<<0))
+#define ISO_HDMI_RX_int_option_src(data)                                             ((0x00000001&(data))>>0)
+#define ISO_HDMI_RX_get_int_option(data)                                             ((0x00000001&(data))>>0)
+
+
+#define ISO_I2C6_MUX                                                                 0x180070C8
+#define ISO_I2C6_MUX_reg_addr                                                        "0xB80070C8"
+#define ISO_I2C6_MUX_reg                                                             0xB80070C8
+#define set_ISO_I2C6_MUX_reg(data)   (*((volatile unsigned int*) ISO_I2C6_MUX_reg)=data)
+#define get_ISO_I2C6_MUX_reg   (*((volatile unsigned int*) ISO_I2C6_MUX_reg))
+#define ISO_I2C6_MUX_inst_adr                                                        "0x0032"
+#define ISO_I2C6_MUX_inst                                                            0x0032
+#define ISO_I2C6_MUX_i2c6_mis_mux_shift                                              (0)
+#define ISO_I2C6_MUX_i2c6_mis_mux_mask                                               (0x00000001)
+#define ISO_I2C6_MUX_i2c6_mis_mux(data)                                              (0x00000001&((data)<<0))
+#define ISO_I2C6_MUX_i2c6_mis_mux_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_I2C6_MUX_get_i2c6_mis_mux(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_SB2_0                                                                    0x18007F00
+#define ISO_SB2_0_reg_addr                                                           "0xB8007F00"
+#define ISO_SB2_0_reg                                                                0xB8007F00
+#define set_ISO_SB2_0_reg(data)   (*((volatile unsigned int*) ISO_SB2_0_reg)=data)
+#define get_ISO_SB2_0_reg   (*((volatile unsigned int*) ISO_SB2_0_reg))
+#define ISO_SB2_0_inst_adr                                                           "0x00C0"
+#define ISO_SB2_0_inst                                                               0x00C0
+#define ISO_SB2_0_usb2sram_ctrl_shift                                                (5)
+#define ISO_SB2_0_usb2sram_ctrl_mask                                                 (0x00000020)
+#define ISO_SB2_0_usb2sram_ctrl(data)                                                (0x00000020&((data)<<5))
+#define ISO_SB2_0_usb2sram_ctrl_src(data)                                            ((0x00000020&(data))>>5)
+#define ISO_SB2_0_get_usb2sram_ctrl(data)                                            ((0x00000020&(data))>>5)
+#define ISO_SB2_0_ve_encode_block_nwc_shift                                          (4)
+#define ISO_SB2_0_ve_encode_block_nwc_mask                                           (0x00000010)
+#define ISO_SB2_0_ve_encode_block_nwc(data)                                          (0x00000010&((data)<<4))
+#define ISO_SB2_0_ve_encode_block_nwc_src(data)                                      ((0x00000010&(data))>>4)
+#define ISO_SB2_0_get_ve_encode_block_nwc(data)                                      ((0x00000010&(data))>>4)
+#define ISO_SB2_0_ve_block_nwc_shift                                                 (3)
+#define ISO_SB2_0_ve_block_nwc_mask                                                  (0x00000008)
+#define ISO_SB2_0_ve_block_nwc(data)                                                 (0x00000008&((data)<<3))
+#define ISO_SB2_0_ve_block_nwc_src(data)                                             ((0x00000008&(data))>>3)
+#define ISO_SB2_0_get_ve_block_nwc(data)                                             ((0x00000008&(data))>>3)
+#define ISO_SB2_0_vo_block_nwc_shift                                                 (2)
+#define ISO_SB2_0_vo_block_nwc_mask                                                  (0x00000004)
+#define ISO_SB2_0_vo_block_nwc(data)                                                 (0x00000004&((data)<<2))
+#define ISO_SB2_0_vo_block_nwc_src(data)                                             ((0x00000004&(data))>>2)
+#define ISO_SB2_0_get_vo_block_nwc(data)                                             ((0x00000004&(data))>>2)
+#define ISO_SB2_0_dc_mem_port_lock_shift                                             (1)
+#define ISO_SB2_0_dc_mem_port_lock_mask                                              (0x00000002)
+#define ISO_SB2_0_dc_mem_port_lock(data)                                             (0x00000002&((data)<<1))
+#define ISO_SB2_0_dc_mem_port_lock_src(data)                                         ((0x00000002&(data))>>1)
+#define ISO_SB2_0_get_dc_mem_port_lock(data)                                         ((0x00000002&(data))>>1)
+#define ISO_SB2_0_secure_rbus_shift                                                  (0)
+#define ISO_SB2_0_secure_rbus_mask                                                   (0x00000001)
+#define ISO_SB2_0_secure_rbus(data)                                                  (0x00000001&((data)<<0))
+#define ISO_SB2_0_secure_rbus_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_SB2_0_get_secure_rbus(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_GPDIR                                                                    0x18007100
+#define ISO_GPDIR_reg_addr                                                           "0xB8007100"
+#define ISO_GPDIR_reg                                                                0xB8007100
+#define set_ISO_GPDIR_reg(data)   (*((volatile unsigned int*) ISO_GPDIR_reg)=data)
+#define get_ISO_GPDIR_reg   (*((volatile unsigned int*) ISO_GPDIR_reg))
+#define ISO_GPDIR_inst_adr                                                           "0x0040"
+#define ISO_GPDIR_inst                                                               0x0040
+#define ISO_GPDIR_gpdir_shift                                                        (0)
+#define ISO_GPDIR_gpdir_mask                                                         (0x001FFFFF)
+#define ISO_GPDIR_gpdir(data)                                                        (0x001FFFFF&((data)<<0))
+#define ISO_GPDIR_gpdir_src(data)                                                    ((0x001FFFFF&(data))>>0)
+#define ISO_GPDIR_get_gpdir(data)                                                    ((0x001FFFFF&(data))>>0)
+
+
+#define ISO_GPDATO                                                                   0x18007104
+#define ISO_GPDATO_reg_addr                                                          "0xB8007104"
+#define ISO_GPDATO_reg                                                               0xB8007104
+#define set_ISO_GPDATO_reg(data)   (*((volatile unsigned int*) ISO_GPDATO_reg)=data)
+#define get_ISO_GPDATO_reg   (*((volatile unsigned int*) ISO_GPDATO_reg))
+#define ISO_GPDATO_inst_adr                                                          "0x0041"
+#define ISO_GPDATO_inst                                                              0x0041
+#define ISO_GPDATO_gpdato_shift                                                      (0)
+#define ISO_GPDATO_gpdato_mask                                                       (0x001FFFFF)
+#define ISO_GPDATO_gpdato(data)                                                      (0x001FFFFF&((data)<<0))
+#define ISO_GPDATO_gpdato_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define ISO_GPDATO_get_gpdato(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define ISO_GPDATI                                                                   0x18007108
+#define ISO_GPDATI_reg_addr                                                          "0xB8007108"
+#define ISO_GPDATI_reg                                                               0xB8007108
+#define set_ISO_GPDATI_reg(data)   (*((volatile unsigned int*) ISO_GPDATI_reg)=data)
+#define get_ISO_GPDATI_reg   (*((volatile unsigned int*) ISO_GPDATI_reg))
+#define ISO_GPDATI_inst_adr                                                          "0x0042"
+#define ISO_GPDATI_inst                                                              0x0042
+#define ISO_GPDATI_gpdati_shift                                                      (0)
+#define ISO_GPDATI_gpdati_mask                                                       (0x001FFFFF)
+#define ISO_GPDATI_gpdati(data)                                                      (0x001FFFFF&((data)<<0))
+#define ISO_GPDATI_gpdati_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define ISO_GPDATI_get_gpdati(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define ISO_GPIE                                                                     0x1800710C
+#define ISO_GPIE_reg_addr                                                            "0xB800710C"
+#define ISO_GPIE_reg                                                                 0xB800710C
+#define set_ISO_GPIE_reg(data)   (*((volatile unsigned int*) ISO_GPIE_reg)=data)
+#define get_ISO_GPIE_reg   (*((volatile unsigned int*) ISO_GPIE_reg))
+#define ISO_GPIE_inst_adr                                                            "0x0043"
+#define ISO_GPIE_inst                                                                0x0043
+#define ISO_GPIE_gp_shift                                                            (0)
+#define ISO_GPIE_gp_mask                                                             (0x001FFFFF)
+#define ISO_GPIE_gp(data)                                                            (0x001FFFFF&((data)<<0))
+#define ISO_GPIE_gp_src(data)                                                        ((0x001FFFFF&(data))>>0)
+#define ISO_GPIE_get_gp(data)                                                        ((0x001FFFFF&(data))>>0)
+
+
+#define ISO_GPDP                                                                     0x18007110
+#define ISO_GPDP_reg_addr                                                            "0xB8007110"
+#define ISO_GPDP_reg                                                                 0xB8007110
+#define set_ISO_GPDP_reg(data)   (*((volatile unsigned int*) ISO_GPDP_reg)=data)
+#define get_ISO_GPDP_reg   (*((volatile unsigned int*) ISO_GPDP_reg))
+#define ISO_GPDP_inst_adr                                                            "0x0044"
+#define ISO_GPDP_inst                                                                0x0044
+#define ISO_GPDP_gpha_shift                                                          (0)
+#define ISO_GPDP_gpha_mask                                                           (0x001FFFFF)
+#define ISO_GPDP_gpha(data)                                                          (0x001FFFFF&((data)<<0))
+#define ISO_GPDP_gpha_src(data)                                                      ((0x001FFFFF&(data))>>0)
+#define ISO_GPDP_get_gpha(data)                                                      ((0x001FFFFF&(data))>>0)
+
+
+#define ISO_GPDEB                                                                    0x18007114
+#define ISO_GPDEB_reg_addr                                                           "0xB8007114"
+#define ISO_GPDEB_reg                                                                0xB8007114
+#define set_ISO_GPDEB_reg(data)   (*((volatile unsigned int*) ISO_GPDEB_reg)=data)
+#define get_ISO_GPDEB_reg   (*((volatile unsigned int*) ISO_GPDEB_reg))
+#define ISO_GPDEB_inst_adr                                                           "0x0045"
+#define ISO_GPDEB_inst                                                               0x0045
+#define ISO_GPDEB_write_en1_shift                                                    (3)
+#define ISO_GPDEB_write_en1_mask                                                     (0x00000008)
+#define ISO_GPDEB_write_en1(data)                                                    (0x00000008&((data)<<3))
+#define ISO_GPDEB_write_en1_src(data)                                                ((0x00000008&(data))>>3)
+#define ISO_GPDEB_get_write_en1(data)                                                ((0x00000008&(data))>>3)
+#define ISO_GPDEB_clk1_shift                                                         (0)
+#define ISO_GPDEB_clk1_mask                                                          (0x00000007)
+#define ISO_GPDEB_clk1(data)                                                         (0x00000007&((data)<<0))
+#define ISO_GPDEB_clk1_src(data)                                                     ((0x00000007&(data))>>0)
+#define ISO_GPDEB_get_clk1(data)                                                     ((0x00000007&(data))>>0)
+
+
+#define ISO_VFD_CTL                                                                  0x18007200
+#define ISO_VFD_CTL_reg_addr                                                         "0xB8007200"
+#define ISO_VFD_CTL_reg                                                              0xB8007200
+#define set_ISO_VFD_CTL_reg(data)   (*((volatile unsigned int*) ISO_VFD_CTL_reg)=data)
+#define get_ISO_VFD_CTL_reg   (*((volatile unsigned int*) ISO_VFD_CTL_reg))
+#define ISO_VFD_CTL_inst_adr                                                         "0x0080"
+#define ISO_VFD_CTL_inst                                                             0x0080
+#define ISO_VFD_CTL_kpaden_shift                                                     (3)
+#define ISO_VFD_CTL_kpaden_mask                                                      (0x00000008)
+#define ISO_VFD_CTL_kpaden(data)                                                     (0x00000008&((data)<<3))
+#define ISO_VFD_CTL_kpaden_src(data)                                                 ((0x00000008&(data))>>3)
+#define ISO_VFD_CTL_get_kpaden(data)                                                 ((0x00000008&(data))>>3)
+#define ISO_VFD_CTL_swen_shift                                                       (2)
+#define ISO_VFD_CTL_swen_mask                                                        (0x00000004)
+#define ISO_VFD_CTL_swen(data)                                                       (0x00000004&((data)<<2))
+#define ISO_VFD_CTL_swen_src(data)                                                   ((0x00000004&(data))>>2)
+#define ISO_VFD_CTL_get_swen(data)                                                   ((0x00000004&(data))>>2)
+#define ISO_VFD_CTL_clksel_shift                                                     (1)
+#define ISO_VFD_CTL_clksel_mask                                                      (0x00000002)
+#define ISO_VFD_CTL_clksel(data)                                                     (0x00000002&((data)<<1))
+#define ISO_VFD_CTL_clksel_src(data)                                                 ((0x00000002&(data))>>1)
+#define ISO_VFD_CTL_get_clksel(data)                                                 ((0x00000002&(data))>>1)
+#define ISO_VFD_CTL_envfd_shift                                                      (0)
+#define ISO_VFD_CTL_envfd_mask                                                       (0x00000001)
+#define ISO_VFD_CTL_envfd(data)                                                      (0x00000001&((data)<<0))
+#define ISO_VFD_CTL_envfd_src(data)                                                  ((0x00000001&(data))>>0)
+#define ISO_VFD_CTL_get_envfd(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_VFD_WRCTL                                                                0x18007204
+#define ISO_VFD_WRCTL_reg_addr                                                       "0xB8007204"
+#define ISO_VFD_WRCTL_reg                                                            0xB8007204
+#define set_ISO_VFD_WRCTL_reg(data)   (*((volatile unsigned int*) ISO_VFD_WRCTL_reg)=data)
+#define get_ISO_VFD_WRCTL_reg   (*((volatile unsigned int*) ISO_VFD_WRCTL_reg))
+#define ISO_VFD_WRCTL_inst_adr                                                       "0x0081"
+#define ISO_VFD_WRCTL_inst                                                           0x0081
+#define ISO_VFD_WRCTL_nact_csn_shift                                                 (12)
+#define ISO_VFD_WRCTL_nact_csn_mask                                                  (0x00001000)
+#define ISO_VFD_WRCTL_nact_csn(data)                                                 (0x00001000&((data)<<12))
+#define ISO_VFD_WRCTL_nact_csn_src(data)                                             ((0x00001000&(data))>>12)
+#define ISO_VFD_WRCTL_get_nact_csn(data)                                             ((0x00001000&(data))>>12)
+#define ISO_VFD_WRCTL_b3c_shift                                                      (11)
+#define ISO_VFD_WRCTL_b3c_mask                                                       (0x00000800)
+#define ISO_VFD_WRCTL_b3c(data)                                                      (0x00000800&((data)<<11))
+#define ISO_VFD_WRCTL_b3c_src(data)                                                  ((0x00000800&(data))>>11)
+#define ISO_VFD_WRCTL_get_b3c(data)                                                  ((0x00000800&(data))>>11)
+#define ISO_VFD_WRCTL_b2c_shift                                                      (10)
+#define ISO_VFD_WRCTL_b2c_mask                                                       (0x00000400)
+#define ISO_VFD_WRCTL_b2c(data)                                                      (0x00000400&((data)<<10))
+#define ISO_VFD_WRCTL_b2c_src(data)                                                  ((0x00000400&(data))>>10)
+#define ISO_VFD_WRCTL_get_b2c(data)                                                  ((0x00000400&(data))>>10)
+#define ISO_VFD_WRCTL_b1c_shift                                                      (9)
+#define ISO_VFD_WRCTL_b1c_mask                                                       (0x00000200)
+#define ISO_VFD_WRCTL_b1c(data)                                                      (0x00000200&((data)<<9))
+#define ISO_VFD_WRCTL_b1c_src(data)                                                  ((0x00000200&(data))>>9)
+#define ISO_VFD_WRCTL_get_b1c(data)                                                  ((0x00000200&(data))>>9)
+#define ISO_VFD_WRCTL_b0c_shift                                                      (8)
+#define ISO_VFD_WRCTL_b0c_mask                                                       (0x00000100)
+#define ISO_VFD_WRCTL_b0c(data)                                                      (0x00000100&((data)<<8))
+#define ISO_VFD_WRCTL_b0c_src(data)                                                  ((0x00000100&(data))>>8)
+#define ISO_VFD_WRCTL_get_b0c(data)                                                  ((0x00000100&(data))>>8)
+#define ISO_VFD_WRCTL_enb3_shift                                                     (7)
+#define ISO_VFD_WRCTL_enb3_mask                                                      (0x00000080)
+#define ISO_VFD_WRCTL_enb3(data)                                                     (0x00000080&((data)<<7))
+#define ISO_VFD_WRCTL_enb3_src(data)                                                 ((0x00000080&(data))>>7)
+#define ISO_VFD_WRCTL_get_enb3(data)                                                 ((0x00000080&(data))>>7)
+#define ISO_VFD_WRCTL_enb2_shift                                                     (6)
+#define ISO_VFD_WRCTL_enb2_mask                                                      (0x00000040)
+#define ISO_VFD_WRCTL_enb2(data)                                                     (0x00000040&((data)<<6))
+#define ISO_VFD_WRCTL_enb2_src(data)                                                 ((0x00000040&(data))>>6)
+#define ISO_VFD_WRCTL_get_enb2(data)                                                 ((0x00000040&(data))>>6)
+#define ISO_VFD_WRCTL_enb1_shift                                                     (5)
+#define ISO_VFD_WRCTL_enb1_mask                                                      (0x00000020)
+#define ISO_VFD_WRCTL_enb1(data)                                                     (0x00000020&((data)<<5))
+#define ISO_VFD_WRCTL_enb1_src(data)                                                 ((0x00000020&(data))>>5)
+#define ISO_VFD_WRCTL_get_enb1(data)                                                 ((0x00000020&(data))>>5)
+#define ISO_VFD_WRCTL_enb0_shift                                                     (4)
+#define ISO_VFD_WRCTL_enb0_mask                                                      (0x00000010)
+#define ISO_VFD_WRCTL_enb0(data)                                                     (0x00000010&((data)<<4))
+#define ISO_VFD_WRCTL_enb0_src(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_VFD_WRCTL_get_enb0(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_VFD_WRCTL_wd_shift                                                       (1)
+#define ISO_VFD_WRCTL_wd_mask                                                        (0x00000002)
+#define ISO_VFD_WRCTL_wd(data)                                                       (0x00000002&((data)<<1))
+#define ISO_VFD_WRCTL_wd_src(data)                                                   ((0x00000002&(data))>>1)
+#define ISO_VFD_WRCTL_get_wd(data)                                                   ((0x00000002&(data))>>1)
+#define ISO_VFD_WRCTL_wdie_shift                                                     (0)
+#define ISO_VFD_WRCTL_wdie_mask                                                      (0x00000001)
+#define ISO_VFD_WRCTL_wdie(data)                                                     (0x00000001&((data)<<0))
+#define ISO_VFD_WRCTL_wdie_src(data)                                                 ((0x00000001&(data))>>0)
+#define ISO_VFD_WRCTL_get_wdie(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define ISO_VFDO                                                                     0x18007208
+#define ISO_VFDO_reg_addr                                                            "0xB8007208"
+#define ISO_VFDO_reg                                                                 0xB8007208
+#define set_ISO_VFDO_reg(data)   (*((volatile unsigned int*) ISO_VFDO_reg)=data)
+#define get_ISO_VFDO_reg   (*((volatile unsigned int*) ISO_VFDO_reg))
+#define ISO_VFDO_inst_adr                                                            "0x0082"
+#define ISO_VFDO_inst                                                                0x0082
+#define ISO_VFDO_byte3_shift                                                         (24)
+#define ISO_VFDO_byte3_mask                                                          (0xFF000000)
+#define ISO_VFDO_byte3(data)                                                         (0xFF000000&((data)<<24))
+#define ISO_VFDO_byte3_src(data)                                                     ((0xFF000000&(data))>>24)
+#define ISO_VFDO_get_byte3(data)                                                     ((0xFF000000&(data))>>24)
+#define ISO_VFDO_byte2_shift                                                         (16)
+#define ISO_VFDO_byte2_mask                                                          (0x00FF0000)
+#define ISO_VFDO_byte2(data)                                                         (0x00FF0000&((data)<<16))
+#define ISO_VFDO_byte2_src(data)                                                     ((0x00FF0000&(data))>>16)
+#define ISO_VFDO_get_byte2(data)                                                     ((0x00FF0000&(data))>>16)
+#define ISO_VFDO_byte1_shift                                                         (8)
+#define ISO_VFDO_byte1_mask                                                          (0x0000FF00)
+#define ISO_VFDO_byte1(data)                                                         (0x0000FF00&((data)<<8))
+#define ISO_VFDO_byte1_src(data)                                                     ((0x0000FF00&(data))>>8)
+#define ISO_VFDO_get_byte1(data)                                                     ((0x0000FF00&(data))>>8)
+#define ISO_VFDO_byte0_shift                                                         (0)
+#define ISO_VFDO_byte0_mask                                                          (0x000000FF)
+#define ISO_VFDO_byte0(data)                                                         (0x000000FF&((data)<<0))
+#define ISO_VFDO_byte0_src(data)                                                     ((0x000000FF&(data))>>0)
+#define ISO_VFDO_get_byte0(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define ISO_VFD_ARDCTL                                                               0x1800720C
+#define ISO_VFD_ARDCTL_reg_addr                                                      "0xB800720C"
+#define ISO_VFD_ARDCTL_reg                                                           0xB800720C
+#define set_ISO_VFD_ARDCTL_reg(data)   (*((volatile unsigned int*) ISO_VFD_ARDCTL_reg)=data)
+#define get_ISO_VFD_ARDCTL_reg   (*((volatile unsigned int*) ISO_VFD_ARDCTL_reg))
+#define ISO_VFD_ARDCTL_inst_adr                                                      "0x0083"
+#define ISO_VFD_ARDCTL_inst                                                          0x0083
+#define ISO_VFD_ARDCTL_kpadbn_shift                                                  (8)
+#define ISO_VFD_ARDCTL_kpadbn_mask                                                   (0x00000700)
+#define ISO_VFD_ARDCTL_kpadbn(data)                                                  (0x00000700&((data)<<8))
+#define ISO_VFD_ARDCTL_kpadbn_src(data)                                              ((0x00000700&(data))>>8)
+#define ISO_VFD_ARDCTL_get_kpadbn(data)                                              ((0x00000700&(data))>>8)
+#define ISO_VFD_ARDCTL_swha_shift                                                    (5)
+#define ISO_VFD_ARDCTL_swha_mask                                                     (0x00000020)
+#define ISO_VFD_ARDCTL_swha(data)                                                    (0x00000020&((data)<<5))
+#define ISO_VFD_ARDCTL_swha_src(data)                                                ((0x00000020&(data))>>5)
+#define ISO_VFD_ARDCTL_get_swha(data)                                                ((0x00000020&(data))>>5)
+#define ISO_VFD_ARDCTL_kpadha_shift                                                  (4)
+#define ISO_VFD_ARDCTL_kpadha_mask                                                   (0x00000010)
+#define ISO_VFD_ARDCTL_kpadha(data)                                                  (0x00000010&((data)<<4))
+#define ISO_VFD_ARDCTL_kpadha_src(data)                                              ((0x00000010&(data))>>4)
+#define ISO_VFD_ARDCTL_get_kpadha(data)                                              ((0x00000010&(data))>>4)
+#define ISO_VFD_ARDCTL_ardp_shift                                                    (0)
+#define ISO_VFD_ARDCTL_ardp_mask                                                     (0x00000003)
+#define ISO_VFD_ARDCTL_ardp(data)                                                    (0x00000003&((data)<<0))
+#define ISO_VFD_ARDCTL_ardp_src(data)                                                ((0x00000003&(data))>>0)
+#define ISO_VFD_ARDCTL_get_ardp(data)                                                ((0x00000003&(data))>>0)
+
+
+#define ISO_VFD_KPADLIE                                                              0x18007210
+#define ISO_VFD_KPADLIE_reg_addr                                                     "0xB8007210"
+#define ISO_VFD_KPADLIE_reg                                                          0xB8007210
+#define set_ISO_VFD_KPADLIE_reg(data)   (*((volatile unsigned int*) ISO_VFD_KPADLIE_reg)=data)
+#define get_ISO_VFD_KPADLIE_reg   (*((volatile unsigned int*) ISO_VFD_KPADLIE_reg))
+#define ISO_VFD_KPADLIE_inst_adr                                                     "0x0084"
+#define ISO_VFD_KPADLIE_inst                                                         0x0084
+#define ISO_VFD_KPADLIE_kpadie_shift                                                 (0)
+#define ISO_VFD_KPADLIE_kpadie_mask                                                  (0xFFFFFFFF)
+#define ISO_VFD_KPADLIE_kpadie(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_VFD_KPADLIE_kpadie_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_VFD_KPADLIE_get_kpadie(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_VFD_KPADHIE                                                              0x18007214
+#define ISO_VFD_KPADHIE_reg_addr                                                     "0xB8007214"
+#define ISO_VFD_KPADHIE_reg                                                          0xB8007214
+#define set_ISO_VFD_KPADHIE_reg(data)   (*((volatile unsigned int*) ISO_VFD_KPADHIE_reg)=data)
+#define get_ISO_VFD_KPADHIE_reg   (*((volatile unsigned int*) ISO_VFD_KPADHIE_reg))
+#define ISO_VFD_KPADHIE_inst_adr                                                     "0x0085"
+#define ISO_VFD_KPADHIE_inst                                                         0x0085
+#define ISO_VFD_KPADHIE_kpadie_shift                                                 (0)
+#define ISO_VFD_KPADHIE_kpadie_mask                                                  (0x0000FFFF)
+#define ISO_VFD_KPADHIE_kpadie(data)                                                 (0x0000FFFF&((data)<<0))
+#define ISO_VFD_KPADHIE_kpadie_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define ISO_VFD_KPADHIE_get_kpadie(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_VFD_SWIE                                                                 0x18007218
+#define ISO_VFD_SWIE_reg_addr                                                        "0xB8007218"
+#define ISO_VFD_SWIE_reg                                                             0xB8007218
+#define set_ISO_VFD_SWIE_reg(data)   (*((volatile unsigned int*) ISO_VFD_SWIE_reg)=data)
+#define get_ISO_VFD_SWIE_reg   (*((volatile unsigned int*) ISO_VFD_SWIE_reg))
+#define ISO_VFD_SWIE_inst_adr                                                        "0x0086"
+#define ISO_VFD_SWIE_inst                                                            0x0086
+#define ISO_VFD_SWIE_swie_shift                                                      (0)
+#define ISO_VFD_SWIE_swie_mask                                                       (0x0000000F)
+#define ISO_VFD_SWIE_swie(data)                                                      (0x0000000F&((data)<<0))
+#define ISO_VFD_SWIE_swie_src(data)                                                  ((0x0000000F&(data))>>0)
+#define ISO_VFD_SWIE_get_swie(data)                                                  ((0x0000000F&(data))>>0)
+
+
+#define ISO_VFD_ARDKPADL                                                             0x1800721C
+#define ISO_VFD_ARDKPADL_reg_addr                                                    "0xB800721C"
+#define ISO_VFD_ARDKPADL_reg                                                         0xB800721C
+#define set_ISO_VFD_ARDKPADL_reg(data)   (*((volatile unsigned int*) ISO_VFD_ARDKPADL_reg)=data)
+#define get_ISO_VFD_ARDKPADL_reg   (*((volatile unsigned int*) ISO_VFD_ARDKPADL_reg))
+#define ISO_VFD_ARDKPADL_inst_adr                                                    "0x0087"
+#define ISO_VFD_ARDKPADL_inst                                                        0x0087
+#define ISO_VFD_ARDKPADL_st_31_24_shift                                              (24)
+#define ISO_VFD_ARDKPADL_st_31_24_mask                                               (0xFF000000)
+#define ISO_VFD_ARDKPADL_st_31_24(data)                                              (0xFF000000&((data)<<24))
+#define ISO_VFD_ARDKPADL_st_31_24_src(data)                                          ((0xFF000000&(data))>>24)
+#define ISO_VFD_ARDKPADL_get_st_31_24(data)                                          ((0xFF000000&(data))>>24)
+#define ISO_VFD_ARDKPADL_st_23_16_shift                                              (16)
+#define ISO_VFD_ARDKPADL_st_23_16_mask                                               (0x00FF0000)
+#define ISO_VFD_ARDKPADL_st_23_16(data)                                              (0x00FF0000&((data)<<16))
+#define ISO_VFD_ARDKPADL_st_23_16_src(data)                                          ((0x00FF0000&(data))>>16)
+#define ISO_VFD_ARDKPADL_get_st_23_16(data)                                          ((0x00FF0000&(data))>>16)
+#define ISO_VFD_ARDKPADL_st_15_8_shift                                               (8)
+#define ISO_VFD_ARDKPADL_st_15_8_mask                                                (0x0000FF00)
+#define ISO_VFD_ARDKPADL_st_15_8(data)                                               (0x0000FF00&((data)<<8))
+#define ISO_VFD_ARDKPADL_st_15_8_src(data)                                           ((0x0000FF00&(data))>>8)
+#define ISO_VFD_ARDKPADL_get_st_15_8(data)                                           ((0x0000FF00&(data))>>8)
+#define ISO_VFD_ARDKPADL_st_7_0_shift                                                (0)
+#define ISO_VFD_ARDKPADL_st_7_0_mask                                                 (0x000000FF)
+#define ISO_VFD_ARDKPADL_st_7_0(data)                                                (0x000000FF&((data)<<0))
+#define ISO_VFD_ARDKPADL_st_7_0_src(data)                                            ((0x000000FF&(data))>>0)
+#define ISO_VFD_ARDKPADL_get_st_7_0(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define ISO_VFD_ARDKPADH                                                             0x18007220
+#define ISO_VFD_ARDKPADH_reg_addr                                                    "0xB8007220"
+#define ISO_VFD_ARDKPADH_reg                                                         0xB8007220
+#define set_ISO_VFD_ARDKPADH_reg(data)   (*((volatile unsigned int*) ISO_VFD_ARDKPADH_reg)=data)
+#define get_ISO_VFD_ARDKPADH_reg   (*((volatile unsigned int*) ISO_VFD_ARDKPADH_reg))
+#define ISO_VFD_ARDKPADH_inst_adr                                                    "0x0088"
+#define ISO_VFD_ARDKPADH_inst                                                        0x0088
+#define ISO_VFD_ARDKPADH_st_15_8_shift                                               (8)
+#define ISO_VFD_ARDKPADH_st_15_8_mask                                                (0x0000FF00)
+#define ISO_VFD_ARDKPADH_st_15_8(data)                                               (0x0000FF00&((data)<<8))
+#define ISO_VFD_ARDKPADH_st_15_8_src(data)                                           ((0x0000FF00&(data))>>8)
+#define ISO_VFD_ARDKPADH_get_st_15_8(data)                                           ((0x0000FF00&(data))>>8)
+#define ISO_VFD_ARDKPADH_st_7_0_shift                                                (0)
+#define ISO_VFD_ARDKPADH_st_7_0_mask                                                 (0x000000FF)
+#define ISO_VFD_ARDKPADH_st_7_0(data)                                                (0x000000FF&((data)<<0))
+#define ISO_VFD_ARDKPADH_st_7_0_src(data)                                            ((0x000000FF&(data))>>0)
+#define ISO_VFD_ARDKPADH_get_st_7_0(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define ISO_VFD_ARDSW                                                                0x18007224
+#define ISO_VFD_ARDSW_reg_addr                                                       "0xB8007224"
+#define ISO_VFD_ARDSW_reg                                                            0xB8007224
+#define set_ISO_VFD_ARDSW_reg(data)   (*((volatile unsigned int*) ISO_VFD_ARDSW_reg)=data)
+#define get_ISO_VFD_ARDSW_reg   (*((volatile unsigned int*) ISO_VFD_ARDSW_reg))
+#define ISO_VFD_ARDSW_inst_adr                                                       "0x0089"
+#define ISO_VFD_ARDSW_inst                                                           0x0089
+#define ISO_VFD_ARDSW_rvda_shift                                                     (4)
+#define ISO_VFD_ARDSW_rvda_mask                                                      (0x0000FFF0)
+#define ISO_VFD_ARDSW_rvda(data)                                                     (0x0000FFF0&((data)<<4))
+#define ISO_VFD_ARDSW_rvda_src(data)                                                 ((0x0000FFF0&(data))>>4)
+#define ISO_VFD_ARDSW_get_rvda(data)                                                 ((0x0000FFF0&(data))>>4)
+#define ISO_VFD_ARDSW_st_shift                                                       (0)
+#define ISO_VFD_ARDSW_st_mask                                                        (0x0000000F)
+#define ISO_VFD_ARDSW_st(data)                                                       (0x0000000F&((data)<<0))
+#define ISO_VFD_ARDSW_st_src(data)                                                   ((0x0000000F&(data))>>0)
+#define ISO_VFD_ARDSW_get_st(data)                                                   ((0x0000000F&(data))>>0)
+
+
+#define ISO_VFD_CTL1                                                                 0x18007228
+#define ISO_VFD_CTL1_reg_addr                                                        "0xB8007228"
+#define ISO_VFD_CTL1_reg                                                             0xB8007228
+#define set_ISO_VFD_CTL1_reg(data)   (*((volatile unsigned int*) ISO_VFD_CTL1_reg)=data)
+#define get_ISO_VFD_CTL1_reg   (*((volatile unsigned int*) ISO_VFD_CTL1_reg))
+#define ISO_VFD_CTL1_inst_adr                                                        "0x008A"
+#define ISO_VFD_CTL1_inst                                                            0x008A
+#define ISO_VFD_CTL1_clksel_1_shift                                                  (16)
+#define ISO_VFD_CTL1_clksel_1_mask                                                   (0x00010000)
+#define ISO_VFD_CTL1_clksel_1(data)                                                  (0x00010000&((data)<<16))
+#define ISO_VFD_CTL1_clksel_1_src(data)                                              ((0x00010000&(data))>>16)
+#define ISO_VFD_CTL1_get_clksel_1(data)                                              ((0x00010000&(data))>>16)
+#define ISO_VFD_CTL1_tclk_csn_shift                                                  (8)
+#define ISO_VFD_CTL1_tclk_csn_mask                                                   (0x0000FF00)
+#define ISO_VFD_CTL1_tclk_csn(data)                                                  (0x0000FF00&((data)<<8))
+#define ISO_VFD_CTL1_tclk_csn_src(data)                                              ((0x0000FF00&(data))>>8)
+#define ISO_VFD_CTL1_get_tclk_csn(data)                                              ((0x0000FF00&(data))>>8)
+#define ISO_VFD_CTL1_twait1_shift                                                    (0)
+#define ISO_VFD_CTL1_twait1_mask                                                     (0x000000FF)
+#define ISO_VFD_CTL1_twait1(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_VFD_CTL1_twait1_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_VFD_CTL1_get_twait1(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_PFUNC0                                                                   0x18007300
+#define ISO_PFUNC0_reg_addr                                                          "0xB8007300"
+#define ISO_PFUNC0_reg                                                               0xB8007300
+#define set_ISO_PFUNC0_reg(data)   (*((volatile unsigned int*) ISO_PFUNC0_reg)=data)
+#define get_ISO_PFUNC0_reg   (*((volatile unsigned int*) ISO_PFUNC0_reg))
+#define ISO_PFUNC0_inst_adr                                                          "0x00C0"
+#define ISO_PFUNC0_inst                                                              0x00C0
+#define ISO_PFUNC0_i2c_scl_0_smt_shift                                               (31)
+#define ISO_PFUNC0_i2c_scl_0_smt_mask                                                (0x80000000)
+#define ISO_PFUNC0_i2c_scl_0_smt(data)                                               (0x80000000&((data)<<31))
+#define ISO_PFUNC0_i2c_scl_0_smt_src(data)                                           ((0x80000000&(data))>>31)
+#define ISO_PFUNC0_get_i2c_scl_0_smt(data)                                           ((0x80000000&(data))>>31)
+#define ISO_PFUNC0_i2c_scl_0_e2_shift                                                (30)
+#define ISO_PFUNC0_i2c_scl_0_e2_mask                                                 (0x40000000)
+#define ISO_PFUNC0_i2c_scl_0_e2(data)                                                (0x40000000&((data)<<30))
+#define ISO_PFUNC0_i2c_scl_0_e2_src(data)                                            ((0x40000000&(data))>>30)
+#define ISO_PFUNC0_get_i2c_scl_0_e2(data)                                            ((0x40000000&(data))>>30)
+#define ISO_PFUNC0_i2c_scl_0_pud_en_shift                                            (29)
+#define ISO_PFUNC0_i2c_scl_0_pud_en_mask                                             (0x20000000)
+#define ISO_PFUNC0_i2c_scl_0_pud_en(data)                                            (0x20000000&((data)<<29))
+#define ISO_PFUNC0_i2c_scl_0_pud_en_src(data)                                        ((0x20000000&(data))>>29)
+#define ISO_PFUNC0_get_i2c_scl_0_pud_en(data)                                        ((0x20000000&(data))>>29)
+#define ISO_PFUNC0_i2c_scl_0_pud_sel_shift                                           (28)
+#define ISO_PFUNC0_i2c_scl_0_pud_sel_mask                                            (0x10000000)
+#define ISO_PFUNC0_i2c_scl_0_pud_sel(data)                                           (0x10000000&((data)<<28))
+#define ISO_PFUNC0_i2c_scl_0_pud_sel_src(data)                                       ((0x10000000&(data))>>28)
+#define ISO_PFUNC0_get_i2c_scl_0_pud_sel(data)                                       ((0x10000000&(data))>>28)
+#define ISO_PFUNC0_i2c_sda_0_smt_shift                                               (27)
+#define ISO_PFUNC0_i2c_sda_0_smt_mask                                                (0x08000000)
+#define ISO_PFUNC0_i2c_sda_0_smt(data)                                               (0x08000000&((data)<<27))
+#define ISO_PFUNC0_i2c_sda_0_smt_src(data)                                           ((0x08000000&(data))>>27)
+#define ISO_PFUNC0_get_i2c_sda_0_smt(data)                                           ((0x08000000&(data))>>27)
+#define ISO_PFUNC0_i2c_sda_0_e2_shift                                                (26)
+#define ISO_PFUNC0_i2c_sda_0_e2_mask                                                 (0x04000000)
+#define ISO_PFUNC0_i2c_sda_0_e2(data)                                                (0x04000000&((data)<<26))
+#define ISO_PFUNC0_i2c_sda_0_e2_src(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PFUNC0_get_i2c_sda_0_e2(data)                                            ((0x04000000&(data))>>26)
+#define ISO_PFUNC0_i2c_sda_0_pud_en_shift                                            (25)
+#define ISO_PFUNC0_i2c_sda_0_pud_en_mask                                             (0x02000000)
+#define ISO_PFUNC0_i2c_sda_0_pud_en(data)                                            (0x02000000&((data)<<25))
+#define ISO_PFUNC0_i2c_sda_0_pud_en_src(data)                                        ((0x02000000&(data))>>25)
+#define ISO_PFUNC0_get_i2c_sda_0_pud_en(data)                                        ((0x02000000&(data))>>25)
+#define ISO_PFUNC0_i2c_sda_0_pud_sel_shift                                           (24)
+#define ISO_PFUNC0_i2c_sda_0_pud_sel_mask                                            (0x01000000)
+#define ISO_PFUNC0_i2c_sda_0_pud_sel(data)                                           (0x01000000&((data)<<24))
+#define ISO_PFUNC0_i2c_sda_0_pud_sel_src(data)                                       ((0x01000000&(data))>>24)
+#define ISO_PFUNC0_get_i2c_sda_0_pud_sel(data)                                       ((0x01000000&(data))>>24)
+#define ISO_PFUNC0_vfd_d_smt_shift                                                   (23)
+#define ISO_PFUNC0_vfd_d_smt_mask                                                    (0x00800000)
+#define ISO_PFUNC0_vfd_d_smt(data)                                                   (0x00800000&((data)<<23))
+#define ISO_PFUNC0_vfd_d_smt_src(data)                                               ((0x00800000&(data))>>23)
+#define ISO_PFUNC0_get_vfd_d_smt(data)                                               ((0x00800000&(data))>>23)
+#define ISO_PFUNC0_vfd_d_e2_shift                                                    (22)
+#define ISO_PFUNC0_vfd_d_e2_mask                                                     (0x00400000)
+#define ISO_PFUNC0_vfd_d_e2(data)                                                    (0x00400000&((data)<<22))
+#define ISO_PFUNC0_vfd_d_e2_src(data)                                                ((0x00400000&(data))>>22)
+#define ISO_PFUNC0_get_vfd_d_e2(data)                                                ((0x00400000&(data))>>22)
+#define ISO_PFUNC0_vfd_d_pud_en_shift                                                (21)
+#define ISO_PFUNC0_vfd_d_pud_en_mask                                                 (0x00200000)
+#define ISO_PFUNC0_vfd_d_pud_en(data)                                                (0x00200000&((data)<<21))
+#define ISO_PFUNC0_vfd_d_pud_en_src(data)                                            ((0x00200000&(data))>>21)
+#define ISO_PFUNC0_get_vfd_d_pud_en(data)                                            ((0x00200000&(data))>>21)
+#define ISO_PFUNC0_vfd_d_pud_sel_shift                                               (20)
+#define ISO_PFUNC0_vfd_d_pud_sel_mask                                                (0x00100000)
+#define ISO_PFUNC0_vfd_d_pud_sel(data)                                               (0x00100000&((data)<<20))
+#define ISO_PFUNC0_vfd_d_pud_sel_src(data)                                           ((0x00100000&(data))>>20)
+#define ISO_PFUNC0_get_vfd_d_pud_sel(data)                                           ((0x00100000&(data))>>20)
+#define ISO_PFUNC0_vfd_clk_smt_shift                                                 (19)
+#define ISO_PFUNC0_vfd_clk_smt_mask                                                  (0x00080000)
+#define ISO_PFUNC0_vfd_clk_smt(data)                                                 (0x00080000&((data)<<19))
+#define ISO_PFUNC0_vfd_clk_smt_src(data)                                             ((0x00080000&(data))>>19)
+#define ISO_PFUNC0_get_vfd_clk_smt(data)                                             ((0x00080000&(data))>>19)
+#define ISO_PFUNC0_vfd_clk_e2_shift                                                  (18)
+#define ISO_PFUNC0_vfd_clk_e2_mask                                                   (0x00040000)
+#define ISO_PFUNC0_vfd_clk_e2(data)                                                  (0x00040000&((data)<<18))
+#define ISO_PFUNC0_vfd_clk_e2_src(data)                                              ((0x00040000&(data))>>18)
+#define ISO_PFUNC0_get_vfd_clk_e2(data)                                              ((0x00040000&(data))>>18)
+#define ISO_PFUNC0_vfd_clk_pud_en_shift                                              (17)
+#define ISO_PFUNC0_vfd_clk_pud_en_mask                                               (0x00020000)
+#define ISO_PFUNC0_vfd_clk_pud_en(data)                                              (0x00020000&((data)<<17))
+#define ISO_PFUNC0_vfd_clk_pud_en_src(data)                                          ((0x00020000&(data))>>17)
+#define ISO_PFUNC0_get_vfd_clk_pud_en(data)                                          ((0x00020000&(data))>>17)
+#define ISO_PFUNC0_vfd_clk_pud_sel_shift                                             (16)
+#define ISO_PFUNC0_vfd_clk_pud_sel_mask                                              (0x00010000)
+#define ISO_PFUNC0_vfd_clk_pud_sel(data)                                             (0x00010000&((data)<<16))
+#define ISO_PFUNC0_vfd_clk_pud_sel_src(data)                                         ((0x00010000&(data))>>16)
+#define ISO_PFUNC0_get_vfd_clk_pud_sel(data)                                         ((0x00010000&(data))>>16)
+#define ISO_PFUNC0_vfd_cs_n_smt_shift                                                (15)
+#define ISO_PFUNC0_vfd_cs_n_smt_mask                                                 (0x00008000)
+#define ISO_PFUNC0_vfd_cs_n_smt(data)                                                (0x00008000&((data)<<15))
+#define ISO_PFUNC0_vfd_cs_n_smt_src(data)                                            ((0x00008000&(data))>>15)
+#define ISO_PFUNC0_get_vfd_cs_n_smt(data)                                            ((0x00008000&(data))>>15)
+#define ISO_PFUNC0_vfd_cs_n_e2_shift                                                 (14)
+#define ISO_PFUNC0_vfd_cs_n_e2_mask                                                  (0x00004000)
+#define ISO_PFUNC0_vfd_cs_n_e2(data)                                                 (0x00004000&((data)<<14))
+#define ISO_PFUNC0_vfd_cs_n_e2_src(data)                                             ((0x00004000&(data))>>14)
+#define ISO_PFUNC0_get_vfd_cs_n_e2(data)                                             ((0x00004000&(data))>>14)
+#define ISO_PFUNC0_vfd_cs_n_pud_en_shift                                             (13)
+#define ISO_PFUNC0_vfd_cs_n_pud_en_mask                                              (0x00002000)
+#define ISO_PFUNC0_vfd_cs_n_pud_en(data)                                             (0x00002000&((data)<<13))
+#define ISO_PFUNC0_vfd_cs_n_pud_en_src(data)                                         ((0x00002000&(data))>>13)
+#define ISO_PFUNC0_get_vfd_cs_n_pud_en(data)                                         ((0x00002000&(data))>>13)
+#define ISO_PFUNC0_vfd_cs_n_pud_sel_shift                                            (12)
+#define ISO_PFUNC0_vfd_cs_n_pud_sel_mask                                             (0x00001000)
+#define ISO_PFUNC0_vfd_cs_n_pud_sel(data)                                            (0x00001000&((data)<<12))
+#define ISO_PFUNC0_vfd_cs_n_pud_sel_src(data)                                        ((0x00001000&(data))>>12)
+#define ISO_PFUNC0_get_vfd_cs_n_pud_sel(data)                                        ((0x00001000&(data))>>12)
+#define ISO_PFUNC0_ir_rx_smt_shift                                                   (11)
+#define ISO_PFUNC0_ir_rx_smt_mask                                                    (0x00000800)
+#define ISO_PFUNC0_ir_rx_smt(data)                                                   (0x00000800&((data)<<11))
+#define ISO_PFUNC0_ir_rx_smt_src(data)                                               ((0x00000800&(data))>>11)
+#define ISO_PFUNC0_get_ir_rx_smt(data)                                               ((0x00000800&(data))>>11)
+#define ISO_PFUNC0_ir_rx_e2_shift                                                    (10)
+#define ISO_PFUNC0_ir_rx_e2_mask                                                     (0x00000400)
+#define ISO_PFUNC0_ir_rx_e2(data)                                                    (0x00000400&((data)<<10))
+#define ISO_PFUNC0_ir_rx_e2_src(data)                                                ((0x00000400&(data))>>10)
+#define ISO_PFUNC0_get_ir_rx_e2(data)                                                ((0x00000400&(data))>>10)
+#define ISO_PFUNC0_ir_rx_pud_en_shift                                                (9)
+#define ISO_PFUNC0_ir_rx_pud_en_mask                                                 (0x00000200)
+#define ISO_PFUNC0_ir_rx_pud_en(data)                                                (0x00000200&((data)<<9))
+#define ISO_PFUNC0_ir_rx_pud_en_src(data)                                            ((0x00000200&(data))>>9)
+#define ISO_PFUNC0_get_ir_rx_pud_en(data)                                            ((0x00000200&(data))>>9)
+#define ISO_PFUNC0_ir_rx_pud_sel_shift                                               (8)
+#define ISO_PFUNC0_ir_rx_pud_sel_mask                                                (0x00000100)
+#define ISO_PFUNC0_ir_rx_pud_sel(data)                                               (0x00000100&((data)<<8))
+#define ISO_PFUNC0_ir_rx_pud_sel_src(data)                                           ((0x00000100&(data))>>8)
+#define ISO_PFUNC0_get_ir_rx_pud_sel(data)                                           ((0x00000100&(data))>>8)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_smt_shift                                     (7)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_smt_mask                                      (0x00000080)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_smt(data)                                     (0x00000080&((data)<<7))
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_smt_src(data)                                 ((0x00000080&(data))>>7)
+#define ISO_PFUNC0_get_usb_ovrcur_flag_n_1_smt(data)                                 ((0x00000080&(data))>>7)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_e2_shift                                      (6)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_e2_mask                                       (0x00000040)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_e2(data)                                      (0x00000040&((data)<<6))
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_e2_src(data)                                  ((0x00000040&(data))>>6)
+#define ISO_PFUNC0_get_usb_ovrcur_flag_n_1_e2(data)                                  ((0x00000040&(data))>>6)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_pud_en_shift                                  (5)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_pud_en_mask                                   (0x00000020)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_pud_en(data)                                  (0x00000020&((data)<<5))
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_pud_en_src(data)                              ((0x00000020&(data))>>5)
+#define ISO_PFUNC0_get_usb_ovrcur_flag_n_1_pud_en(data)                              ((0x00000020&(data))>>5)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_pud_sel_shift                                 (4)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_pud_sel_mask                                  (0x00000010)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_pud_sel(data)                                 (0x00000010&((data)<<4))
+#define ISO_PFUNC0_usb_ovrcur_flag_n_1_pud_sel_src(data)                             ((0x00000010&(data))>>4)
+#define ISO_PFUNC0_get_usb_ovrcur_flag_n_1_pud_sel(data)                             ((0x00000010&(data))>>4)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_smt_shift                                     (3)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_smt_mask                                      (0x00000008)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_smt(data)                                     (0x00000008&((data)<<3))
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_smt_src(data)                                 ((0x00000008&(data))>>3)
+#define ISO_PFUNC0_get_usb_ovrcur_flag_n_0_smt(data)                                 ((0x00000008&(data))>>3)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_e2_shift                                      (2)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_e2_mask                                       (0x00000004)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_e2(data)                                      (0x00000004&((data)<<2))
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_e2_src(data)                                  ((0x00000004&(data))>>2)
+#define ISO_PFUNC0_get_usb_ovrcur_flag_n_0_e2(data)                                  ((0x00000004&(data))>>2)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_pud_en_shift                                  (1)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_pud_en_mask                                   (0x00000002)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_pud_en(data)                                  (0x00000002&((data)<<1))
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_pud_en_src(data)                              ((0x00000002&(data))>>1)
+#define ISO_PFUNC0_get_usb_ovrcur_flag_n_0_pud_en(data)                              ((0x00000002&(data))>>1)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_pud_sel_shift                                 (0)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_pud_sel_mask                                  (0x00000001)
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_pud_sel(data)                                 (0x00000001&((data)<<0))
+#define ISO_PFUNC0_usb_ovrcur_flag_n_0_pud_sel_src(data)                             ((0x00000001&(data))>>0)
+#define ISO_PFUNC0_get_usb_ovrcur_flag_n_0_pud_sel(data)                             ((0x00000001&(data))>>0)
+
+
+#define ISO_PFUNC1                                                                   0x18007304
+#define ISO_PFUNC1_reg_addr                                                          "0xB8007304"
+#define ISO_PFUNC1_reg                                                               0xB8007304
+#define set_ISO_PFUNC1_reg(data)   (*((volatile unsigned int*) ISO_PFUNC1_reg)=data)
+#define get_ISO_PFUNC1_reg   (*((volatile unsigned int*) ISO_PFUNC1_reg))
+#define ISO_PFUNC1_inst_adr                                                          "0x00C1"
+#define ISO_PFUNC1_inst                                                              0x00C1
+#define ISO_PFUNC1_etn_led_rxtx_smt_shift                                            (31)
+#define ISO_PFUNC1_etn_led_rxtx_smt_mask                                             (0x80000000)
+#define ISO_PFUNC1_etn_led_rxtx_smt(data)                                            (0x80000000&((data)<<31))
+#define ISO_PFUNC1_etn_led_rxtx_smt_src(data)                                        ((0x80000000&(data))>>31)
+#define ISO_PFUNC1_get_etn_led_rxtx_smt(data)                                        ((0x80000000&(data))>>31)
+#define ISO_PFUNC1_etn_led_rxtx_e2_shift                                             (30)
+#define ISO_PFUNC1_etn_led_rxtx_e2_mask                                              (0x40000000)
+#define ISO_PFUNC1_etn_led_rxtx_e2(data)                                             (0x40000000&((data)<<30))
+#define ISO_PFUNC1_etn_led_rxtx_e2_src(data)                                         ((0x40000000&(data))>>30)
+#define ISO_PFUNC1_get_etn_led_rxtx_e2(data)                                         ((0x40000000&(data))>>30)
+#define ISO_PFUNC1_etn_led_rxtx_pud_en_shift                                         (29)
+#define ISO_PFUNC1_etn_led_rxtx_pud_en_mask                                          (0x20000000)
+#define ISO_PFUNC1_etn_led_rxtx_pud_en(data)                                         (0x20000000&((data)<<29))
+#define ISO_PFUNC1_etn_led_rxtx_pud_en_src(data)                                     ((0x20000000&(data))>>29)
+#define ISO_PFUNC1_get_etn_led_rxtx_pud_en(data)                                     ((0x20000000&(data))>>29)
+#define ISO_PFUNC1_etn_led_rxtx_pud_sel_shift                                        (28)
+#define ISO_PFUNC1_etn_led_rxtx_pud_sel_mask                                         (0x10000000)
+#define ISO_PFUNC1_etn_led_rxtx_pud_sel(data)                                        (0x10000000&((data)<<28))
+#define ISO_PFUNC1_etn_led_rxtx_pud_sel_src(data)                                    ((0x10000000&(data))>>28)
+#define ISO_PFUNC1_get_etn_led_rxtx_pud_sel(data)                                    ((0x10000000&(data))>>28)
+#define ISO_PFUNC1_etn_led_link_smt_shift                                            (27)
+#define ISO_PFUNC1_etn_led_link_smt_mask                                             (0x08000000)
+#define ISO_PFUNC1_etn_led_link_smt(data)                                            (0x08000000&((data)<<27))
+#define ISO_PFUNC1_etn_led_link_smt_src(data)                                        ((0x08000000&(data))>>27)
+#define ISO_PFUNC1_get_etn_led_link_smt(data)                                        ((0x08000000&(data))>>27)
+#define ISO_PFUNC1_etn_led_link_e2_shift                                             (26)
+#define ISO_PFUNC1_etn_led_link_e2_mask                                              (0x04000000)
+#define ISO_PFUNC1_etn_led_link_e2(data)                                             (0x04000000&((data)<<26))
+#define ISO_PFUNC1_etn_led_link_e2_src(data)                                         ((0x04000000&(data))>>26)
+#define ISO_PFUNC1_get_etn_led_link_e2(data)                                         ((0x04000000&(data))>>26)
+#define ISO_PFUNC1_etn_led_link_pud_en_shift                                         (25)
+#define ISO_PFUNC1_etn_led_link_pud_en_mask                                          (0x02000000)
+#define ISO_PFUNC1_etn_led_link_pud_en(data)                                         (0x02000000&((data)<<25))
+#define ISO_PFUNC1_etn_led_link_pud_en_src(data)                                     ((0x02000000&(data))>>25)
+#define ISO_PFUNC1_get_etn_led_link_pud_en(data)                                     ((0x02000000&(data))>>25)
+#define ISO_PFUNC1_etn_led_link_pud_sel_shift                                        (24)
+#define ISO_PFUNC1_etn_led_link_pud_sel_mask                                         (0x01000000)
+#define ISO_PFUNC1_etn_led_link_pud_sel(data)                                        (0x01000000&((data)<<24))
+#define ISO_PFUNC1_etn_led_link_pud_sel_src(data)                                    ((0x01000000&(data))>>24)
+#define ISO_PFUNC1_get_etn_led_link_pud_sel(data)                                    ((0x01000000&(data))>>24)
+#define ISO_PFUNC1_ur0_tx_smt_shift                                                  (23)
+#define ISO_PFUNC1_ur0_tx_smt_mask                                                   (0x00800000)
+#define ISO_PFUNC1_ur0_tx_smt(data)                                                  (0x00800000&((data)<<23))
+#define ISO_PFUNC1_ur0_tx_smt_src(data)                                              ((0x00800000&(data))>>23)
+#define ISO_PFUNC1_get_ur0_tx_smt(data)                                              ((0x00800000&(data))>>23)
+#define ISO_PFUNC1_ur0_tx_e2_shift                                                   (22)
+#define ISO_PFUNC1_ur0_tx_e2_mask                                                    (0x00400000)
+#define ISO_PFUNC1_ur0_tx_e2(data)                                                   (0x00400000&((data)<<22))
+#define ISO_PFUNC1_ur0_tx_e2_src(data)                                               ((0x00400000&(data))>>22)
+#define ISO_PFUNC1_get_ur0_tx_e2(data)                                               ((0x00400000&(data))>>22)
+#define ISO_PFUNC1_ur0_tx_pud_en_shift                                               (21)
+#define ISO_PFUNC1_ur0_tx_pud_en_mask                                                (0x00200000)
+#define ISO_PFUNC1_ur0_tx_pud_en(data)                                               (0x00200000&((data)<<21))
+#define ISO_PFUNC1_ur0_tx_pud_en_src(data)                                           ((0x00200000&(data))>>21)
+#define ISO_PFUNC1_get_ur0_tx_pud_en(data)                                           ((0x00200000&(data))>>21)
+#define ISO_PFUNC1_ur0_tx_pud_sel_shift                                              (20)
+#define ISO_PFUNC1_ur0_tx_pud_sel_mask                                               (0x00100000)
+#define ISO_PFUNC1_ur0_tx_pud_sel(data)                                              (0x00100000&((data)<<20))
+#define ISO_PFUNC1_ur0_tx_pud_sel_src(data)                                          ((0x00100000&(data))>>20)
+#define ISO_PFUNC1_get_ur0_tx_pud_sel(data)                                          ((0x00100000&(data))>>20)
+#define ISO_PFUNC1_ur0_rx_smt_shift                                                  (19)
+#define ISO_PFUNC1_ur0_rx_smt_mask                                                   (0x00080000)
+#define ISO_PFUNC1_ur0_rx_smt(data)                                                  (0x00080000&((data)<<19))
+#define ISO_PFUNC1_ur0_rx_smt_src(data)                                              ((0x00080000&(data))>>19)
+#define ISO_PFUNC1_get_ur0_rx_smt(data)                                              ((0x00080000&(data))>>19)
+#define ISO_PFUNC1_ur0_rx_e2_shift                                                   (18)
+#define ISO_PFUNC1_ur0_rx_e2_mask                                                    (0x00040000)
+#define ISO_PFUNC1_ur0_rx_e2(data)                                                   (0x00040000&((data)<<18))
+#define ISO_PFUNC1_ur0_rx_e2_src(data)                                               ((0x00040000&(data))>>18)
+#define ISO_PFUNC1_get_ur0_rx_e2(data)                                               ((0x00040000&(data))>>18)
+#define ISO_PFUNC1_ur0_rx_pud_en_shift                                               (17)
+#define ISO_PFUNC1_ur0_rx_pud_en_mask                                                (0x00020000)
+#define ISO_PFUNC1_ur0_rx_pud_en(data)                                               (0x00020000&((data)<<17))
+#define ISO_PFUNC1_ur0_rx_pud_en_src(data)                                           ((0x00020000&(data))>>17)
+#define ISO_PFUNC1_get_ur0_rx_pud_en(data)                                           ((0x00020000&(data))>>17)
+#define ISO_PFUNC1_ur0_rx_pud_sel_shift                                              (16)
+#define ISO_PFUNC1_ur0_rx_pud_sel_mask                                               (0x00010000)
+#define ISO_PFUNC1_ur0_rx_pud_sel(data)                                              (0x00010000&((data)<<16))
+#define ISO_PFUNC1_ur0_rx_pud_sel_src(data)                                          ((0x00010000&(data))>>16)
+#define ISO_PFUNC1_get_ur0_rx_pud_sel(data)                                          ((0x00010000&(data))>>16)
+#define ISO_PFUNC1_ur1_cts_n_smt_shift                                               (15)
+#define ISO_PFUNC1_ur1_cts_n_smt_mask                                                (0x00008000)
+#define ISO_PFUNC1_ur1_cts_n_smt(data)                                               (0x00008000&((data)<<15))
+#define ISO_PFUNC1_ur1_cts_n_smt_src(data)                                           ((0x00008000&(data))>>15)
+#define ISO_PFUNC1_get_ur1_cts_n_smt(data)                                           ((0x00008000&(data))>>15)
+#define ISO_PFUNC1_ur1_cts_n_e2_shift                                                (14)
+#define ISO_PFUNC1_ur1_cts_n_e2_mask                                                 (0x00004000)
+#define ISO_PFUNC1_ur1_cts_n_e2(data)                                                (0x00004000&((data)<<14))
+#define ISO_PFUNC1_ur1_cts_n_e2_src(data)                                            ((0x00004000&(data))>>14)
+#define ISO_PFUNC1_get_ur1_cts_n_e2(data)                                            ((0x00004000&(data))>>14)
+#define ISO_PFUNC1_ur1_cts_n_pud_en_shift                                            (13)
+#define ISO_PFUNC1_ur1_cts_n_pud_en_mask                                             (0x00002000)
+#define ISO_PFUNC1_ur1_cts_n_pud_en(data)                                            (0x00002000&((data)<<13))
+#define ISO_PFUNC1_ur1_cts_n_pud_en_src(data)                                        ((0x00002000&(data))>>13)
+#define ISO_PFUNC1_get_ur1_cts_n_pud_en(data)                                        ((0x00002000&(data))>>13)
+#define ISO_PFUNC1_ur1_cts_n_pud_sel_shift                                           (12)
+#define ISO_PFUNC1_ur1_cts_n_pud_sel_mask                                            (0x00001000)
+#define ISO_PFUNC1_ur1_cts_n_pud_sel(data)                                           (0x00001000&((data)<<12))
+#define ISO_PFUNC1_ur1_cts_n_pud_sel_src(data)                                       ((0x00001000&(data))>>12)
+#define ISO_PFUNC1_get_ur1_cts_n_pud_sel(data)                                       ((0x00001000&(data))>>12)
+#define ISO_PFUNC1_ur1_rts_n_smt_shift                                               (11)
+#define ISO_PFUNC1_ur1_rts_n_smt_mask                                                (0x00000800)
+#define ISO_PFUNC1_ur1_rts_n_smt(data)                                               (0x00000800&((data)<<11))
+#define ISO_PFUNC1_ur1_rts_n_smt_src(data)                                           ((0x00000800&(data))>>11)
+#define ISO_PFUNC1_get_ur1_rts_n_smt(data)                                           ((0x00000800&(data))>>11)
+#define ISO_PFUNC1_ur1_rts_n_e2_shift                                                (10)
+#define ISO_PFUNC1_ur1_rts_n_e2_mask                                                 (0x00000400)
+#define ISO_PFUNC1_ur1_rts_n_e2(data)                                                (0x00000400&((data)<<10))
+#define ISO_PFUNC1_ur1_rts_n_e2_src(data)                                            ((0x00000400&(data))>>10)
+#define ISO_PFUNC1_get_ur1_rts_n_e2(data)                                            ((0x00000400&(data))>>10)
+#define ISO_PFUNC1_ur1_rts_n_pud_en_shift                                            (9)
+#define ISO_PFUNC1_ur1_rts_n_pud_en_mask                                             (0x00000200)
+#define ISO_PFUNC1_ur1_rts_n_pud_en(data)                                            (0x00000200&((data)<<9))
+#define ISO_PFUNC1_ur1_rts_n_pud_en_src(data)                                        ((0x00000200&(data))>>9)
+#define ISO_PFUNC1_get_ur1_rts_n_pud_en(data)                                        ((0x00000200&(data))>>9)
+#define ISO_PFUNC1_ur1_rts_n_pud_sel_shift                                           (8)
+#define ISO_PFUNC1_ur1_rts_n_pud_sel_mask                                            (0x00000100)
+#define ISO_PFUNC1_ur1_rts_n_pud_sel(data)                                           (0x00000100&((data)<<8))
+#define ISO_PFUNC1_ur1_rts_n_pud_sel_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_PFUNC1_get_ur1_rts_n_pud_sel(data)                                       ((0x00000100&(data))>>8)
+#define ISO_PFUNC1_ur1_tx_smt_shift                                                  (7)
+#define ISO_PFUNC1_ur1_tx_smt_mask                                                   (0x00000080)
+#define ISO_PFUNC1_ur1_tx_smt(data)                                                  (0x00000080&((data)<<7))
+#define ISO_PFUNC1_ur1_tx_smt_src(data)                                              ((0x00000080&(data))>>7)
+#define ISO_PFUNC1_get_ur1_tx_smt(data)                                              ((0x00000080&(data))>>7)
+#define ISO_PFUNC1_ur1_tx_e2_shift                                                   (6)
+#define ISO_PFUNC1_ur1_tx_e2_mask                                                    (0x00000040)
+#define ISO_PFUNC1_ur1_tx_e2(data)                                                   (0x00000040&((data)<<6))
+#define ISO_PFUNC1_ur1_tx_e2_src(data)                                               ((0x00000040&(data))>>6)
+#define ISO_PFUNC1_get_ur1_tx_e2(data)                                               ((0x00000040&(data))>>6)
+#define ISO_PFUNC1_ur1_tx_pud_en_shift                                               (5)
+#define ISO_PFUNC1_ur1_tx_pud_en_mask                                                (0x00000020)
+#define ISO_PFUNC1_ur1_tx_pud_en(data)                                               (0x00000020&((data)<<5))
+#define ISO_PFUNC1_ur1_tx_pud_en_src(data)                                           ((0x00000020&(data))>>5)
+#define ISO_PFUNC1_get_ur1_tx_pud_en(data)                                           ((0x00000020&(data))>>5)
+#define ISO_PFUNC1_ur1_tx_pud_sel_shift                                              (4)
+#define ISO_PFUNC1_ur1_tx_pud_sel_mask                                               (0x00000010)
+#define ISO_PFUNC1_ur1_tx_pud_sel(data)                                              (0x00000010&((data)<<4))
+#define ISO_PFUNC1_ur1_tx_pud_sel_src(data)                                          ((0x00000010&(data))>>4)
+#define ISO_PFUNC1_get_ur1_tx_pud_sel(data)                                          ((0x00000010&(data))>>4)
+#define ISO_PFUNC1_ur1_rx_smt_shift                                                  (3)
+#define ISO_PFUNC1_ur1_rx_smt_mask                                                   (0x00000008)
+#define ISO_PFUNC1_ur1_rx_smt(data)                                                  (0x00000008&((data)<<3))
+#define ISO_PFUNC1_ur1_rx_smt_src(data)                                              ((0x00000008&(data))>>3)
+#define ISO_PFUNC1_get_ur1_rx_smt(data)                                              ((0x00000008&(data))>>3)
+#define ISO_PFUNC1_ur1_rx_e2_shift                                                   (2)
+#define ISO_PFUNC1_ur1_rx_e2_mask                                                    (0x00000004)
+#define ISO_PFUNC1_ur1_rx_e2(data)                                                   (0x00000004&((data)<<2))
+#define ISO_PFUNC1_ur1_rx_e2_src(data)                                               ((0x00000004&(data))>>2)
+#define ISO_PFUNC1_get_ur1_rx_e2(data)                                               ((0x00000004&(data))>>2)
+#define ISO_PFUNC1_ur1_rx_pud_en_shift                                               (1)
+#define ISO_PFUNC1_ur1_rx_pud_en_mask                                                (0x00000002)
+#define ISO_PFUNC1_ur1_rx_pud_en(data)                                               (0x00000002&((data)<<1))
+#define ISO_PFUNC1_ur1_rx_pud_en_src(data)                                           ((0x00000002&(data))>>1)
+#define ISO_PFUNC1_get_ur1_rx_pud_en(data)                                           ((0x00000002&(data))>>1)
+#define ISO_PFUNC1_ur1_rx_pud_sel_shift                                              (0)
+#define ISO_PFUNC1_ur1_rx_pud_sel_mask                                               (0x00000001)
+#define ISO_PFUNC1_ur1_rx_pud_sel(data)                                              (0x00000001&((data)<<0))
+#define ISO_PFUNC1_ur1_rx_pud_sel_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_PFUNC1_get_ur1_rx_pud_sel(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_PFUNC2                                                                   0x18007308
+#define ISO_PFUNC2_reg_addr                                                          "0xB8007308"
+#define ISO_PFUNC2_reg                                                               0xB8007308
+#define set_ISO_PFUNC2_reg(data)   (*((volatile unsigned int*) ISO_PFUNC2_reg)=data)
+#define get_ISO_PFUNC2_reg   (*((volatile unsigned int*) ISO_PFUNC2_reg))
+#define ISO_PFUNC2_inst_adr                                                          "0x00C2"
+#define ISO_PFUNC2_inst                                                              0x00C2
+#define ISO_PFUNC2_ir_tx_smt_shift                                                   (23)
+#define ISO_PFUNC2_ir_tx_smt_mask                                                    (0x00800000)
+#define ISO_PFUNC2_ir_tx_smt(data)                                                   (0x00800000&((data)<<23))
+#define ISO_PFUNC2_ir_tx_smt_src(data)                                               ((0x00800000&(data))>>23)
+#define ISO_PFUNC2_get_ir_tx_smt(data)                                               ((0x00800000&(data))>>23)
+#define ISO_PFUNC2_ir_tx_e2_shift                                                    (22)
+#define ISO_PFUNC2_ir_tx_e2_mask                                                     (0x00400000)
+#define ISO_PFUNC2_ir_tx_e2(data)                                                    (0x00400000&((data)<<22))
+#define ISO_PFUNC2_ir_tx_e2_src(data)                                                ((0x00400000&(data))>>22)
+#define ISO_PFUNC2_get_ir_tx_e2(data)                                                ((0x00400000&(data))>>22)
+#define ISO_PFUNC2_ir_tx_pud_en_shift                                                (21)
+#define ISO_PFUNC2_ir_tx_pud_en_mask                                                 (0x00200000)
+#define ISO_PFUNC2_ir_tx_pud_en(data)                                                (0x00200000&((data)<<21))
+#define ISO_PFUNC2_ir_tx_pud_en_src(data)                                            ((0x00200000&(data))>>21)
+#define ISO_PFUNC2_get_ir_tx_pud_en(data)                                            ((0x00200000&(data))>>21)
+#define ISO_PFUNC2_ir_tx_pud_sel_shift                                               (20)
+#define ISO_PFUNC2_ir_tx_pud_sel_mask                                                (0x00100000)
+#define ISO_PFUNC2_ir_tx_pud_sel(data)                                               (0x00100000&((data)<<20))
+#define ISO_PFUNC2_ir_tx_pud_sel_src(data)                                           ((0x00100000&(data))>>20)
+#define ISO_PFUNC2_get_ir_tx_pud_sel(data)                                           ((0x00100000&(data))>>20)
+#define ISO_PFUNC2_i2c_scl_6_smt_shift                                               (19)
+#define ISO_PFUNC2_i2c_scl_6_smt_mask                                                (0x00080000)
+#define ISO_PFUNC2_i2c_scl_6_smt(data)                                               (0x00080000&((data)<<19))
+#define ISO_PFUNC2_i2c_scl_6_smt_src(data)                                           ((0x00080000&(data))>>19)
+#define ISO_PFUNC2_get_i2c_scl_6_smt(data)                                           ((0x00080000&(data))>>19)
+#define ISO_PFUNC2_i2c_scl_6_e2_shift                                                (18)
+#define ISO_PFUNC2_i2c_scl_6_e2_mask                                                 (0x00040000)
+#define ISO_PFUNC2_i2c_scl_6_e2(data)                                                (0x00040000&((data)<<18))
+#define ISO_PFUNC2_i2c_scl_6_e2_src(data)                                            ((0x00040000&(data))>>18)
+#define ISO_PFUNC2_get_i2c_scl_6_e2(data)                                            ((0x00040000&(data))>>18)
+#define ISO_PFUNC2_i2c_scl_6_pud_en_shift                                            (17)
+#define ISO_PFUNC2_i2c_scl_6_pud_en_mask                                             (0x00020000)
+#define ISO_PFUNC2_i2c_scl_6_pud_en(data)                                            (0x00020000&((data)<<17))
+#define ISO_PFUNC2_i2c_scl_6_pud_en_src(data)                                        ((0x00020000&(data))>>17)
+#define ISO_PFUNC2_get_i2c_scl_6_pud_en(data)                                        ((0x00020000&(data))>>17)
+#define ISO_PFUNC2_i2c_scl_6_pud_sel_shift                                           (16)
+#define ISO_PFUNC2_i2c_scl_6_pud_sel_mask                                            (0x00010000)
+#define ISO_PFUNC2_i2c_scl_6_pud_sel(data)                                           (0x00010000&((data)<<16))
+#define ISO_PFUNC2_i2c_scl_6_pud_sel_src(data)                                       ((0x00010000&(data))>>16)
+#define ISO_PFUNC2_get_i2c_scl_6_pud_sel(data)                                       ((0x00010000&(data))>>16)
+#define ISO_PFUNC2_i2c_sda_6_smt_shift                                               (15)
+#define ISO_PFUNC2_i2c_sda_6_smt_mask                                                (0x00008000)
+#define ISO_PFUNC2_i2c_sda_6_smt(data)                                               (0x00008000&((data)<<15))
+#define ISO_PFUNC2_i2c_sda_6_smt_src(data)                                           ((0x00008000&(data))>>15)
+#define ISO_PFUNC2_get_i2c_sda_6_smt(data)                                           ((0x00008000&(data))>>15)
+#define ISO_PFUNC2_i2c_sda_6_e2_shift                                                (14)
+#define ISO_PFUNC2_i2c_sda_6_e2_mask                                                 (0x00004000)
+#define ISO_PFUNC2_i2c_sda_6_e2(data)                                                (0x00004000&((data)<<14))
+#define ISO_PFUNC2_i2c_sda_6_e2_src(data)                                            ((0x00004000&(data))>>14)
+#define ISO_PFUNC2_get_i2c_sda_6_e2(data)                                            ((0x00004000&(data))>>14)
+#define ISO_PFUNC2_i2c_sda_6_pud_en_shift                                            (13)
+#define ISO_PFUNC2_i2c_sda_6_pud_en_mask                                             (0x00002000)
+#define ISO_PFUNC2_i2c_sda_6_pud_en(data)                                            (0x00002000&((data)<<13))
+#define ISO_PFUNC2_i2c_sda_6_pud_en_src(data)                                        ((0x00002000&(data))>>13)
+#define ISO_PFUNC2_get_i2c_sda_6_pud_en(data)                                        ((0x00002000&(data))>>13)
+#define ISO_PFUNC2_i2c_sda_6_pud_sel_shift                                           (12)
+#define ISO_PFUNC2_i2c_sda_6_pud_sel_mask                                            (0x00001000)
+#define ISO_PFUNC2_i2c_sda_6_pud_sel(data)                                           (0x00001000&((data)<<12))
+#define ISO_PFUNC2_i2c_sda_6_pud_sel_src(data)                                       ((0x00001000&(data))>>12)
+#define ISO_PFUNC2_get_i2c_sda_6_pud_sel(data)                                       ((0x00001000&(data))>>12)
+#define ISO_PFUNC2_boot_sel_pud_en_shift                                             (11)
+#define ISO_PFUNC2_boot_sel_pud_en_mask                                              (0x00000800)
+#define ISO_PFUNC2_boot_sel_pud_en(data)                                             (0x00000800&((data)<<11))
+#define ISO_PFUNC2_boot_sel_pud_en_src(data)                                         ((0x00000800&(data))>>11)
+#define ISO_PFUNC2_get_boot_sel_pud_en(data)                                         ((0x00000800&(data))>>11)
+#define ISO_PFUNC2_boot_sel_pud_sel_shift                                            (10)
+#define ISO_PFUNC2_boot_sel_pud_sel_mask                                             (0x00000400)
+#define ISO_PFUNC2_boot_sel_pud_sel(data)                                            (0x00000400&((data)<<10))
+#define ISO_PFUNC2_boot_sel_pud_sel_src(data)                                        ((0x00000400&(data))>>10)
+#define ISO_PFUNC2_get_boot_sel_pud_sel(data)                                        ((0x00000400&(data))>>10)
+#define ISO_PFUNC2_testmode_pud_en_shift                                             (9)
+#define ISO_PFUNC2_testmode_pud_en_mask                                              (0x00000200)
+#define ISO_PFUNC2_testmode_pud_en(data)                                             (0x00000200&((data)<<9))
+#define ISO_PFUNC2_testmode_pud_en_src(data)                                         ((0x00000200&(data))>>9)
+#define ISO_PFUNC2_get_testmode_pud_en(data)                                         ((0x00000200&(data))>>9)
+#define ISO_PFUNC2_testmode_pud_sel_shift                                            (8)
+#define ISO_PFUNC2_testmode_pud_sel_mask                                             (0x00000100)
+#define ISO_PFUNC2_testmode_pud_sel(data)                                            (0x00000100&((data)<<8))
+#define ISO_PFUNC2_testmode_pud_sel_src(data)                                        ((0x00000100&(data))>>8)
+#define ISO_PFUNC2_get_testmode_pud_sel(data)                                        ((0x00000100&(data))>>8)
+#define ISO_PFUNC2_standby1_smt_shift                                                (7)
+#define ISO_PFUNC2_standby1_smt_mask                                                 (0x00000080)
+#define ISO_PFUNC2_standby1_smt(data)                                                (0x00000080&((data)<<7))
+#define ISO_PFUNC2_standby1_smt_src(data)                                            ((0x00000080&(data))>>7)
+#define ISO_PFUNC2_get_standby1_smt(data)                                            ((0x00000080&(data))>>7)
+#define ISO_PFUNC2_standby1_e2_shift                                                 (6)
+#define ISO_PFUNC2_standby1_e2_mask                                                  (0x00000040)
+#define ISO_PFUNC2_standby1_e2(data)                                                 (0x00000040&((data)<<6))
+#define ISO_PFUNC2_standby1_e2_src(data)                                             ((0x00000040&(data))>>6)
+#define ISO_PFUNC2_get_standby1_e2(data)                                             ((0x00000040&(data))>>6)
+#define ISO_PFUNC2_standby1_pud_en_shift                                             (5)
+#define ISO_PFUNC2_standby1_pud_en_mask                                              (0x00000020)
+#define ISO_PFUNC2_standby1_pud_en(data)                                             (0x00000020&((data)<<5))
+#define ISO_PFUNC2_standby1_pud_en_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_PFUNC2_get_standby1_pud_en(data)                                         ((0x00000020&(data))>>5)
+#define ISO_PFUNC2_standby1_pud_sel_shift                                            (4)
+#define ISO_PFUNC2_standby1_pud_sel_mask                                             (0x00000010)
+#define ISO_PFUNC2_standby1_pud_sel(data)                                            (0x00000010&((data)<<4))
+#define ISO_PFUNC2_standby1_pud_sel_src(data)                                        ((0x00000010&(data))>>4)
+#define ISO_PFUNC2_get_standby1_pud_sel(data)                                        ((0x00000010&(data))>>4)
+#define ISO_PFUNC2_standby_smt_shift                                                 (3)
+#define ISO_PFUNC2_standby_smt_mask                                                  (0x00000008)
+#define ISO_PFUNC2_standby_smt(data)                                                 (0x00000008&((data)<<3))
+#define ISO_PFUNC2_standby_smt_src(data)                                             ((0x00000008&(data))>>3)
+#define ISO_PFUNC2_get_standby_smt(data)                                             ((0x00000008&(data))>>3)
+#define ISO_PFUNC2_standby_e2_shift                                                  (2)
+#define ISO_PFUNC2_standby_e2_mask                                                   (0x00000004)
+#define ISO_PFUNC2_standby_e2(data)                                                  (0x00000004&((data)<<2))
+#define ISO_PFUNC2_standby_e2_src(data)                                              ((0x00000004&(data))>>2)
+#define ISO_PFUNC2_get_standby_e2(data)                                              ((0x00000004&(data))>>2)
+#define ISO_PFUNC2_standby_pud_en_shift                                              (1)
+#define ISO_PFUNC2_standby_pud_en_mask                                               (0x00000002)
+#define ISO_PFUNC2_standby_pud_en(data)                                              (0x00000002&((data)<<1))
+#define ISO_PFUNC2_standby_pud_en_src(data)                                          ((0x00000002&(data))>>1)
+#define ISO_PFUNC2_get_standby_pud_en(data)                                          ((0x00000002&(data))>>1)
+#define ISO_PFUNC2_standby_pud_sel_shift                                             (0)
+#define ISO_PFUNC2_standby_pud_sel_mask                                              (0x00000001)
+#define ISO_PFUNC2_standby_pud_sel(data)                                             (0x00000001&((data)<<0))
+#define ISO_PFUNC2_standby_pud_sel_src(data)                                         ((0x00000001&(data))>>0)
+#define ISO_PFUNC2_get_standby_pud_sel(data)                                         ((0x00000001&(data))>>0)
+
+
+#define ISO_PFUNC3                                                                   0x1800730C
+#define ISO_PFUNC3_reg_addr                                                          "0xB800730C"
+#define ISO_PFUNC3_reg                                                               0xB800730C
+#define set_ISO_PFUNC3_reg(data)   (*((volatile unsigned int*) ISO_PFUNC3_reg)=data)
+#define get_ISO_PFUNC3_reg   (*((volatile unsigned int*) ISO_PFUNC3_reg))
+#define ISO_PFUNC3_inst_adr                                                          "0x00C3"
+#define ISO_PFUNC3_inst                                                              0x00C3
+#define ISO_PFUNC3_boption12_en_shift                                                (7)
+#define ISO_PFUNC3_boption12_en_mask                                                 (0x00000080)
+#define ISO_PFUNC3_boption12_en(data)                                                (0x00000080&((data)<<7))
+#define ISO_PFUNC3_boption12_en_src(data)                                            ((0x00000080&(data))>>7)
+#define ISO_PFUNC3_get_boption12_en(data)                                            ((0x00000080&(data))>>7)
+#define ISO_PFUNC3_boption12_sel_shift                                               (6)
+#define ISO_PFUNC3_boption12_sel_mask                                                (0x00000040)
+#define ISO_PFUNC3_boption12_sel(data)                                               (0x00000040&((data)<<6))
+#define ISO_PFUNC3_boption12_sel_src(data)                                           ((0x00000040&(data))>>6)
+#define ISO_PFUNC3_get_boption12_sel(data)                                           ((0x00000040&(data))>>6)
+#define ISO_PFUNC3_boption11_en_shift                                                (5)
+#define ISO_PFUNC3_boption11_en_mask                                                 (0x00000020)
+#define ISO_PFUNC3_boption11_en(data)                                                (0x00000020&((data)<<5))
+#define ISO_PFUNC3_boption11_en_src(data)                                            ((0x00000020&(data))>>5)
+#define ISO_PFUNC3_get_boption11_en(data)                                            ((0x00000020&(data))>>5)
+#define ISO_PFUNC3_boption11_sel_shift                                               (4)
+#define ISO_PFUNC3_boption11_sel_mask                                                (0x00000010)
+#define ISO_PFUNC3_boption11_sel(data)                                               (0x00000010&((data)<<4))
+#define ISO_PFUNC3_boption11_sel_src(data)                                           ((0x00000010&(data))>>4)
+#define ISO_PFUNC3_get_boption11_sel(data)                                           ((0x00000010&(data))>>4)
+#define ISO_PFUNC3_boption10_en_shift                                                (3)
+#define ISO_PFUNC3_boption10_en_mask                                                 (0x00000008)
+#define ISO_PFUNC3_boption10_en(data)                                                (0x00000008&((data)<<3))
+#define ISO_PFUNC3_boption10_en_src(data)                                            ((0x00000008&(data))>>3)
+#define ISO_PFUNC3_get_boption10_en(data)                                            ((0x00000008&(data))>>3)
+#define ISO_PFUNC3_boption10_sel_shift                                               (2)
+#define ISO_PFUNC3_boption10_sel_mask                                                (0x00000004)
+#define ISO_PFUNC3_boption10_sel(data)                                               (0x00000004&((data)<<2))
+#define ISO_PFUNC3_boption10_sel_src(data)                                           ((0x00000004&(data))>>2)
+#define ISO_PFUNC3_get_boption10_sel(data)                                           ((0x00000004&(data))>>2)
+#define ISO_PFUNC3_boption2_en_shift                                                 (1)
+#define ISO_PFUNC3_boption2_en_mask                                                  (0x00000002)
+#define ISO_PFUNC3_boption2_en(data)                                                 (0x00000002&((data)<<1))
+#define ISO_PFUNC3_boption2_en_src(data)                                             ((0x00000002&(data))>>1)
+#define ISO_PFUNC3_get_boption2_en(data)                                             ((0x00000002&(data))>>1)
+#define ISO_PFUNC3_boption2_sel_shift                                                (0)
+#define ISO_PFUNC3_boption2_sel_mask                                                 (0x00000001)
+#define ISO_PFUNC3_boption2_sel(data)                                                (0x00000001&((data)<<0))
+#define ISO_PFUNC3_boption2_sel_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_PFUNC3_get_boption2_sel(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_MUXPAD0                                                                  0x18007310
+#define ISO_MUXPAD0_reg_addr                                                         "0xB8007310"
+#define ISO_MUXPAD0_reg                                                              0xB8007310
+#define set_ISO_MUXPAD0_reg(data)   (*((volatile unsigned int*) ISO_MUXPAD0_reg)=data)
+#define get_ISO_MUXPAD0_reg   (*((volatile unsigned int*) ISO_MUXPAD0_reg))
+#define ISO_MUXPAD0_inst_adr                                                         "0x00C4"
+#define ISO_MUXPAD0_inst                                                             0x00C4
+#define ISO_MUXPAD0_etn_led_rxtx_shift                                               (30)
+#define ISO_MUXPAD0_etn_led_rxtx_mask                                                (0xC0000000)
+#define ISO_MUXPAD0_etn_led_rxtx(data)                                               (0xC0000000&((data)<<30))
+#define ISO_MUXPAD0_etn_led_rxtx_src(data)                                           ((0xC0000000&(data))>>30)
+#define ISO_MUXPAD0_get_etn_led_rxtx(data)                                           ((0xC0000000&(data))>>30)
+#define ISO_MUXPAD0_etn_led_link_shift                                               (28)
+#define ISO_MUXPAD0_etn_led_link_mask                                                (0x30000000)
+#define ISO_MUXPAD0_etn_led_link(data)                                               (0x30000000&((data)<<28))
+#define ISO_MUXPAD0_etn_led_link_src(data)                                           ((0x30000000&(data))>>28)
+#define ISO_MUXPAD0_get_etn_led_link(data)                                           ((0x30000000&(data))>>28)
+#define ISO_MUXPAD0_i2c_sda_0_shift                                                  (26)
+#define ISO_MUXPAD0_i2c_sda_0_mask                                                   (0x0C000000)
+#define ISO_MUXPAD0_i2c_sda_0(data)                                                  (0x0C000000&((data)<<26))
+#define ISO_MUXPAD0_i2c_sda_0_src(data)                                              ((0x0C000000&(data))>>26)
+#define ISO_MUXPAD0_get_i2c_sda_0(data)                                              ((0x0C000000&(data))>>26)
+#define ISO_MUXPAD0_i2c_scl_0_shift                                                  (24)
+#define ISO_MUXPAD0_i2c_scl_0_mask                                                   (0x03000000)
+#define ISO_MUXPAD0_i2c_scl_0(data)                                                  (0x03000000&((data)<<24))
+#define ISO_MUXPAD0_i2c_scl_0_src(data)                                              ((0x03000000&(data))>>24)
+#define ISO_MUXPAD0_get_i2c_scl_0(data)                                              ((0x03000000&(data))>>24)
+#define ISO_MUXPAD0_ur0_tx_shift                                                     (22)
+#define ISO_MUXPAD0_ur0_tx_mask                                                      (0x00C00000)
+#define ISO_MUXPAD0_ur0_tx(data)                                                     (0x00C00000&((data)<<22))
+#define ISO_MUXPAD0_ur0_tx_src(data)                                                 ((0x00C00000&(data))>>22)
+#define ISO_MUXPAD0_get_ur0_tx(data)                                                 ((0x00C00000&(data))>>22)
+#define ISO_MUXPAD0_ur0_rx_shift                                                     (20)
+#define ISO_MUXPAD0_ur0_rx_mask                                                      (0x00300000)
+#define ISO_MUXPAD0_ur0_rx(data)                                                     (0x00300000&((data)<<20))
+#define ISO_MUXPAD0_ur0_rx_src(data)                                                 ((0x00300000&(data))>>20)
+#define ISO_MUXPAD0_get_ur0_rx(data)                                                 ((0x00300000&(data))>>20)
+#define ISO_MUXPAD0_ur1_cts_n_shift                                                  (18)
+#define ISO_MUXPAD0_ur1_cts_n_mask                                                   (0x000C0000)
+#define ISO_MUXPAD0_ur1_cts_n(data)                                                  (0x000C0000&((data)<<18))
+#define ISO_MUXPAD0_ur1_cts_n_src(data)                                              ((0x000C0000&(data))>>18)
+#define ISO_MUXPAD0_get_ur1_cts_n(data)                                              ((0x000C0000&(data))>>18)
+#define ISO_MUXPAD0_ur1_rts_n_shift                                                  (16)
+#define ISO_MUXPAD0_ur1_rts_n_mask                                                   (0x00030000)
+#define ISO_MUXPAD0_ur1_rts_n(data)                                                  (0x00030000&((data)<<16))
+#define ISO_MUXPAD0_ur1_rts_n_src(data)                                              ((0x00030000&(data))>>16)
+#define ISO_MUXPAD0_get_ur1_rts_n(data)                                              ((0x00030000&(data))>>16)
+#define ISO_MUXPAD0_ur1_tx_shift                                                     (14)
+#define ISO_MUXPAD0_ur1_tx_mask                                                      (0x0000C000)
+#define ISO_MUXPAD0_ur1_tx(data)                                                     (0x0000C000&((data)<<14))
+#define ISO_MUXPAD0_ur1_tx_src(data)                                                 ((0x0000C000&(data))>>14)
+#define ISO_MUXPAD0_get_ur1_tx(data)                                                 ((0x0000C000&(data))>>14)
+#define ISO_MUXPAD0_ur1_rx_shift                                                     (12)
+#define ISO_MUXPAD0_ur1_rx_mask                                                      (0x00003000)
+#define ISO_MUXPAD0_ur1_rx(data)                                                     (0x00003000&((data)<<12))
+#define ISO_MUXPAD0_ur1_rx_src(data)                                                 ((0x00003000&(data))>>12)
+#define ISO_MUXPAD0_get_ur1_rx(data)                                                 ((0x00003000&(data))>>12)
+#define ISO_MUXPAD0_usb1_shift                                                       (10)
+#define ISO_MUXPAD0_usb1_mask                                                        (0x00000C00)
+#define ISO_MUXPAD0_usb1(data)                                                       (0x00000C00&((data)<<10))
+#define ISO_MUXPAD0_usb1_src(data)                                                   ((0x00000C00&(data))>>10)
+#define ISO_MUXPAD0_get_usb1(data)                                                   ((0x00000C00&(data))>>10)
+#define ISO_MUXPAD0_usb0_shift                                                       (8)
+#define ISO_MUXPAD0_usb0_mask                                                        (0x00000300)
+#define ISO_MUXPAD0_usb0(data)                                                       (0x00000300&((data)<<8))
+#define ISO_MUXPAD0_usb0_src(data)                                                   ((0x00000300&(data))>>8)
+#define ISO_MUXPAD0_get_usb0(data)                                                   ((0x00000300&(data))>>8)
+#define ISO_MUXPAD0_ir_rx_shift                                                      (6)
+#define ISO_MUXPAD0_ir_rx_mask                                                       (0x000000C0)
+#define ISO_MUXPAD0_ir_rx(data)                                                      (0x000000C0&((data)<<6))
+#define ISO_MUXPAD0_ir_rx_src(data)                                                  ((0x000000C0&(data))>>6)
+#define ISO_MUXPAD0_get_ir_rx(data)                                                  ((0x000000C0&(data))>>6)
+#define ISO_MUXPAD0_vfd_cs_n_shift                                                   (4)
+#define ISO_MUXPAD0_vfd_cs_n_mask                                                    (0x00000030)
+#define ISO_MUXPAD0_vfd_cs_n(data)                                                   (0x00000030&((data)<<4))
+#define ISO_MUXPAD0_vfd_cs_n_src(data)                                               ((0x00000030&(data))>>4)
+#define ISO_MUXPAD0_get_vfd_cs_n(data)                                               ((0x00000030&(data))>>4)
+#define ISO_MUXPAD0_vfd_clk_shift                                                    (2)
+#define ISO_MUXPAD0_vfd_clk_mask                                                     (0x0000000C)
+#define ISO_MUXPAD0_vfd_clk(data)                                                    (0x0000000C&((data)<<2))
+#define ISO_MUXPAD0_vfd_clk_src(data)                                                ((0x0000000C&(data))>>2)
+#define ISO_MUXPAD0_get_vfd_clk(data)                                                ((0x0000000C&(data))>>2)
+#define ISO_MUXPAD0_vfd_d_shift                                                      (0)
+#define ISO_MUXPAD0_vfd_d_mask                                                       (0x00000003)
+#define ISO_MUXPAD0_vfd_d(data)                                                      (0x00000003&((data)<<0))
+#define ISO_MUXPAD0_vfd_d_src(data)                                                  ((0x00000003&(data))>>0)
+#define ISO_MUXPAD0_get_vfd_d(data)                                                  ((0x00000003&(data))>>0)
+
+
+#define ISO_MUXPAD1                                                                  0x18007314
+#define ISO_MUXPAD1_reg_addr                                                         "0xB8007314"
+#define ISO_MUXPAD1_reg                                                              0xB8007314
+#define set_ISO_MUXPAD1_reg(data)   (*((volatile unsigned int*) ISO_MUXPAD1_reg)=data)
+#define get_ISO_MUXPAD1_reg   (*((volatile unsigned int*) ISO_MUXPAD1_reg))
+#define ISO_MUXPAD1_inst_adr                                                         "0x00C5"
+#define ISO_MUXPAD1_inst                                                             0x00C5
+#define ISO_MUXPAD1_ai_loc_shift                                                     (30)
+#define ISO_MUXPAD1_ai_loc_mask                                                      (0xC0000000)
+#define ISO_MUXPAD1_ai_loc(data)                                                     (0xC0000000&((data)<<30))
+#define ISO_MUXPAD1_ai_loc_src(data)                                                 ((0xC0000000&(data))>>30)
+#define ISO_MUXPAD1_get_ai_loc(data)                                                 ((0xC0000000&(data))>>30)
+#define ISO_MUXPAD1_ejtag_avcpu_loc_shift                                            (28)
+#define ISO_MUXPAD1_ejtag_avcpu_loc_mask                                             (0x30000000)
+#define ISO_MUXPAD1_ejtag_avcpu_loc(data)                                            (0x30000000&((data)<<28))
+#define ISO_MUXPAD1_ejtag_avcpu_loc_src(data)                                        ((0x30000000&(data))>>28)
+#define ISO_MUXPAD1_get_ejtag_avcpu_loc(data)                                        ((0x30000000&(data))>>28)
+#define ISO_MUXPAD1_ur1_loc_shift                                                    (26)
+#define ISO_MUXPAD1_ur1_loc_mask                                                     (0x0C000000)
+#define ISO_MUXPAD1_ur1_loc(data)                                                    (0x0C000000&((data)<<26))
+#define ISO_MUXPAD1_ur1_loc_src(data)                                                ((0x0C000000&(data))>>26)
+#define ISO_MUXPAD1_get_ur1_loc(data)                                                ((0x0C000000&(data))>>26)
+#define ISO_MUXPAD1_pwm_01_open_drain_switch_shift                                   (25)
+#define ISO_MUXPAD1_pwm_01_open_drain_switch_mask                                    (0x02000000)
+#define ISO_MUXPAD1_pwm_01_open_drain_switch(data)                                   (0x02000000&((data)<<25))
+#define ISO_MUXPAD1_pwm_01_open_drain_switch_src(data)                               ((0x02000000&(data))>>25)
+#define ISO_MUXPAD1_get_pwm_01_open_drain_switch(data)                               ((0x02000000&(data))>>25)
+#define ISO_MUXPAD1_pwm_23_open_drain_switch_shift                                   (24)
+#define ISO_MUXPAD1_pwm_23_open_drain_switch_mask                                    (0x01000000)
+#define ISO_MUXPAD1_pwm_23_open_drain_switch(data)                                   (0x01000000&((data)<<24))
+#define ISO_MUXPAD1_pwm_23_open_drain_switch_src(data)                               ((0x01000000&(data))>>24)
+#define ISO_MUXPAD1_get_pwm_23_open_drain_switch(data)                               ((0x01000000&(data))>>24)
+#define ISO_MUXPAD1_ir_tx_shift                                                      (4)
+#define ISO_MUXPAD1_ir_tx_mask                                                       (0x00000030)
+#define ISO_MUXPAD1_ir_tx(data)                                                      (0x00000030&((data)<<4))
+#define ISO_MUXPAD1_ir_tx_src(data)                                                  ((0x00000030&(data))>>4)
+#define ISO_MUXPAD1_get_ir_tx(data)                                                  ((0x00000030&(data))>>4)
+#define ISO_MUXPAD1_i2c_sda_6_shift                                                  (2)
+#define ISO_MUXPAD1_i2c_sda_6_mask                                                   (0x0000000C)
+#define ISO_MUXPAD1_i2c_sda_6(data)                                                  (0x0000000C&((data)<<2))
+#define ISO_MUXPAD1_i2c_sda_6_src(data)                                              ((0x0000000C&(data))>>2)
+#define ISO_MUXPAD1_get_i2c_sda_6(data)                                              ((0x0000000C&(data))>>2)
+#define ISO_MUXPAD1_i2c_scl_6_shift                                                  (0)
+#define ISO_MUXPAD1_i2c_scl_6_mask                                                   (0x00000003)
+#define ISO_MUXPAD1_i2c_scl_6(data)                                                  (0x00000003&((data)<<0))
+#define ISO_MUXPAD1_i2c_scl_6_src(data)                                              ((0x00000003&(data))>>0)
+#define ISO_MUXPAD1_get_i2c_scl_6(data)                                              ((0x00000003&(data))>>0)
+
+
+#define ISO_IR_PSR                                                                   0x18007400
+#define ISO_IR_PSR_reg_addr                                                          "0xB8007400"
+#define ISO_IR_PSR_reg                                                               0xB8007400
+#define set_ISO_IR_PSR_reg(data)   (*((volatile unsigned int*) ISO_IR_PSR_reg)=data)
+#define get_ISO_IR_PSR_reg   (*((volatile unsigned int*) ISO_IR_PSR_reg))
+#define ISO_IR_PSR_inst_adr                                                          "0x0000"
+#define ISO_IR_PSR_inst                                                              0x0000
+#define ISO_IR_PSR_irrbl_shift                                                       (24)
+#define ISO_IR_PSR_irrbl_mask                                                        (0xFF000000)
+#define ISO_IR_PSR_irrbl(data)                                                       (0xFF000000&((data)<<24))
+#define ISO_IR_PSR_irrbl_src(data)                                                   ((0xFF000000&(data))>>24)
+#define ISO_IR_PSR_get_irrbl(data)                                                   ((0xFF000000&(data))>>24)
+#define ISO_IR_PSR_irrml_shift                                                       (16)
+#define ISO_IR_PSR_irrml_mask                                                        (0x00FF0000)
+#define ISO_IR_PSR_irrml(data)                                                       (0x00FF0000&((data)<<16))
+#define ISO_IR_PSR_irrml_src(data)                                                   ((0x00FF0000&(data))>>16)
+#define ISO_IR_PSR_get_irrml(data)                                                   ((0x00FF0000&(data))>>16)
+#define ISO_IR_PSR_irrdzl_shift                                                      (8)
+#define ISO_IR_PSR_irrdzl_mask                                                       (0x0000FF00)
+#define ISO_IR_PSR_irrdzl(data)                                                      (0x0000FF00&((data)<<8))
+#define ISO_IR_PSR_irrdzl_src(data)                                                  ((0x0000FF00&(data))>>8)
+#define ISO_IR_PSR_get_irrdzl(data)                                                  ((0x0000FF00&(data))>>8)
+#define ISO_IR_PSR_irrdol_shift                                                      (0)
+#define ISO_IR_PSR_irrdol_mask                                                       (0x000000FF)
+#define ISO_IR_PSR_irrdol(data)                                                      (0x000000FF&((data)<<0))
+#define ISO_IR_PSR_irrdol_src(data)                                                  ((0x000000FF&(data))>>0)
+#define ISO_IR_PSR_get_irrdol(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_PER                                                                   0x18007404
+#define ISO_IR_PER_reg_addr                                                          "0xB8007404"
+#define ISO_IR_PER_reg                                                               0xB8007404
+#define set_ISO_IR_PER_reg(data)   (*((volatile unsigned int*) ISO_IR_PER_reg)=data)
+#define get_ISO_IR_PER_reg   (*((volatile unsigned int*) ISO_IR_PER_reg))
+#define ISO_IR_PER_inst_adr                                                          "0x0001"
+#define ISO_IR_PER_inst                                                              0x0001
+#define ISO_IR_PER_irrdl_shift                                                       (16)
+#define ISO_IR_PER_irrdl_mask                                                        (0x003F0000)
+#define ISO_IR_PER_irrdl(data)                                                       (0x003F0000&((data)<<16))
+#define ISO_IR_PER_irrdl_src(data)                                                   ((0x003F0000&(data))>>16)
+#define ISO_IR_PER_get_irrdl(data)                                                   ((0x003F0000&(data))>>16)
+#define ISO_IR_PER_irrrl_shift                                                       (8)
+#define ISO_IR_PER_irrrl_mask                                                        (0x0000FF00)
+#define ISO_IR_PER_irrrl(data)                                                       (0x0000FF00&((data)<<8))
+#define ISO_IR_PER_irrrl_src(data)                                                   ((0x0000FF00&(data))>>8)
+#define ISO_IR_PER_get_irrrl(data)                                                   ((0x0000FF00&(data))>>8)
+#define ISO_IR_PER_irrsl_shift                                                       (0)
+#define ISO_IR_PER_irrsl_mask                                                        (0x000000FF)
+#define ISO_IR_PER_irrsl(data)                                                       (0x000000FF&((data)<<0))
+#define ISO_IR_PER_irrsl_src(data)                                                   ((0x000000FF&(data))>>0)
+#define ISO_IR_PER_get_irrsl(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_SF                                                                    0x18007408
+#define ISO_IR_SF_reg_addr                                                           "0xB8007408"
+#define ISO_IR_SF_reg                                                                0xB8007408
+#define set_ISO_IR_SF_reg(data)   (*((volatile unsigned int*) ISO_IR_SF_reg)=data)
+#define get_ISO_IR_SF_reg   (*((volatile unsigned int*) ISO_IR_SF_reg))
+#define ISO_IR_SF_inst_adr                                                           "0x0002"
+#define ISO_IR_SF_inst                                                               0x0002
+#define ISO_IR_SF_irfd_shift                                                         (0)
+#define ISO_IR_SF_irfd_mask                                                          (0x0000FFFF)
+#define ISO_IR_SF_irfd(data)                                                         (0x0000FFFF&((data)<<0))
+#define ISO_IR_SF_irfd_src(data)                                                     ((0x0000FFFF&(data))>>0)
+#define ISO_IR_SF_get_irfd(data)                                                     ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IR_DPIR                                                                  0x1800740C
+#define ISO_IR_DPIR_reg_addr                                                         "0xB800740C"
+#define ISO_IR_DPIR_reg                                                              0xB800740C
+#define set_ISO_IR_DPIR_reg(data)   (*((volatile unsigned int*) ISO_IR_DPIR_reg)=data)
+#define get_ISO_IR_DPIR_reg   (*((volatile unsigned int*) ISO_IR_DPIR_reg))
+#define ISO_IR_DPIR_inst_adr                                                         "0x0003"
+#define ISO_IR_DPIR_inst                                                             0x0003
+#define ISO_IR_DPIR_iriotcdp_shift                                                   (0)
+#define ISO_IR_DPIR_iriotcdp_mask                                                    (0x0000FFFF)
+#define ISO_IR_DPIR_iriotcdp(data)                                                   (0x0000FFFF&((data)<<0))
+#define ISO_IR_DPIR_iriotcdp_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define ISO_IR_DPIR_get_iriotcdp(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IR_CR                                                                    0x18007410
+#define ISO_IR_CR_reg_addr                                                           "0xB8007410"
+#define ISO_IR_CR_reg                                                                0xB8007410
+#define set_ISO_IR_CR_reg(data)   (*((volatile unsigned int*) ISO_IR_CR_reg)=data)
+#define get_ISO_IR_CR_reg   (*((volatile unsigned int*) ISO_IR_CR_reg))
+#define ISO_IR_CR_inst_adr                                                           "0x0004"
+#define ISO_IR_CR_inst                                                               0x0004
+#define ISO_IR_CR_irsr_shift                                                         (31)
+#define ISO_IR_CR_irsr_mask                                                          (0x80000000)
+#define ISO_IR_CR_irsr(data)                                                         (0x80000000&((data)<<31))
+#define ISO_IR_CR_irsr_src(data)                                                     ((0x80000000&(data))>>31)
+#define ISO_IR_CR_get_irsr(data)                                                     ((0x80000000&(data))>>31)
+#define ISO_IR_CR_rcmm_en_shift                                                      (25)
+#define ISO_IR_CR_rcmm_en_mask                                                       (0x02000000)
+#define ISO_IR_CR_rcmm_en(data)                                                      (0x02000000&((data)<<25))
+#define ISO_IR_CR_rcmm_en_src(data)                                                  ((0x02000000&(data))>>25)
+#define ISO_IR_CR_get_rcmm_en(data)                                                  ((0x02000000&(data))>>25)
+#define ISO_IR_CR_toshiba_en_shift                                                   (24)
+#define ISO_IR_CR_toshiba_en_mask                                                    (0x01000000)
+#define ISO_IR_CR_toshiba_en(data)                                                   (0x01000000&((data)<<24))
+#define ISO_IR_CR_toshiba_en_src(data)                                               ((0x01000000&(data))>>24)
+#define ISO_IR_CR_get_toshiba_en(data)                                               ((0x01000000&(data))>>24)
+#define ISO_IR_CR_irednm_shift                                                       (23)
+#define ISO_IR_CR_irednm_mask                                                        (0x00800000)
+#define ISO_IR_CR_irednm(data)                                                       (0x00800000&((data)<<23))
+#define ISO_IR_CR_irednm_src(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_IR_CR_get_irednm(data)                                                   ((0x00800000&(data))>>23)
+#define ISO_IR_CR_iredn_shift                                                        (16)
+#define ISO_IR_CR_iredn_mask                                                         (0x003F0000)
+#define ISO_IR_CR_iredn(data)                                                        (0x003F0000&((data)<<16))
+#define ISO_IR_CR_iredn_src(data)                                                    ((0x003F0000&(data))>>16)
+#define ISO_IR_CR_get_iredn(data)                                                    ((0x003F0000&(data))>>16)
+#define ISO_IR_CR_raw_fifo_ov_shift                                                  (14)
+#define ISO_IR_CR_raw_fifo_ov_mask                                                   (0x00004000)
+#define ISO_IR_CR_raw_fifo_ov(data)                                                  (0x00004000&((data)<<14))
+#define ISO_IR_CR_raw_fifo_ov_src(data)                                              ((0x00004000&(data))>>14)
+#define ISO_IR_CR_get_raw_fifo_ov(data)                                              ((0x00004000&(data))>>14)
+#define ISO_IR_CR_raw_fifo_val_shift                                                 (13)
+#define ISO_IR_CR_raw_fifo_val_mask                                                  (0x00002000)
+#define ISO_IR_CR_raw_fifo_val(data)                                                 (0x00002000&((data)<<13))
+#define ISO_IR_CR_raw_fifo_val_src(data)                                             ((0x00002000&(data))>>13)
+#define ISO_IR_CR_get_raw_fifo_val(data)                                             ((0x00002000&(data))>>13)
+#define ISO_IR_CR_raw_en_shift                                                       (12)
+#define ISO_IR_CR_raw_en_mask                                                        (0x00001000)
+#define ISO_IR_CR_raw_en(data)                                                       (0x00001000&((data)<<12))
+#define ISO_IR_CR_raw_en_src(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_IR_CR_get_raw_en(data)                                                   ((0x00001000&(data))>>12)
+#define ISO_IR_CR_mlae_shift                                                         (11)
+#define ISO_IR_CR_mlae_mask                                                          (0x00000800)
+#define ISO_IR_CR_mlae(data)                                                         (0x00000800&((data)<<11))
+#define ISO_IR_CR_mlae_src(data)                                                     ((0x00000800&(data))>>11)
+#define ISO_IR_CR_get_mlae(data)                                                     ((0x00000800&(data))>>11)
+#define ISO_IR_CR_irie_shift                                                         (10)
+#define ISO_IR_CR_irie_mask                                                          (0x00000400)
+#define ISO_IR_CR_irie(data)                                                         (0x00000400&((data)<<10))
+#define ISO_IR_CR_irie_src(data)                                                     ((0x00000400&(data))>>10)
+#define ISO_IR_CR_get_irie(data)                                                     ((0x00000400&(data))>>10)
+#define ISO_IR_CR_irres_shift                                                        (9)
+#define ISO_IR_CR_irres_mask                                                         (0x00000200)
+#define ISO_IR_CR_irres(data)                                                        (0x00000200&((data)<<9))
+#define ISO_IR_CR_irres_src(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_IR_CR_get_irres(data)                                                    ((0x00000200&(data))>>9)
+#define ISO_IR_CR_irue_shift                                                         (8)
+#define ISO_IR_CR_irue_mask                                                          (0x00000100)
+#define ISO_IR_CR_irue(data)                                                         (0x00000100&((data)<<8))
+#define ISO_IR_CR_irue_src(data)                                                     ((0x00000100&(data))>>8)
+#define ISO_IR_CR_get_irue(data)                                                     ((0x00000100&(data))>>8)
+#define ISO_IR_CR_ircm_shift                                                         (7)
+#define ISO_IR_CR_ircm_mask                                                          (0x00000080)
+#define ISO_IR_CR_ircm(data)                                                         (0x00000080&((data)<<7))
+#define ISO_IR_CR_ircm_src(data)                                                     ((0x00000080&(data))>>7)
+#define ISO_IR_CR_get_ircm(data)                                                     ((0x00000080&(data))>>7)
+#define ISO_IR_CR_irbme_shift                                                        (6)
+#define ISO_IR_CR_irbme_mask                                                         (0x00000040)
+#define ISO_IR_CR_irbme(data)                                                        (0x00000040&((data)<<6))
+#define ISO_IR_CR_irbme_src(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_IR_CR_get_irbme(data)                                                    ((0x00000040&(data))>>6)
+#define ISO_IR_CR_irdpm_shift                                                        (5)
+#define ISO_IR_CR_irdpm_mask                                                         (0x00000020)
+#define ISO_IR_CR_irdpm(data)                                                        (0x00000020&((data)<<5))
+#define ISO_IR_CR_irdpm_src(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_IR_CR_get_irdpm(data)                                                    ((0x00000020&(data))>>5)
+#define ISO_IR_CR_irdn_shift                                                         (0)
+#define ISO_IR_CR_irdn_mask                                                          (0x0000001F)
+#define ISO_IR_CR_irdn(data)                                                         (0x0000001F&((data)<<0))
+#define ISO_IR_CR_irdn_src(data)                                                     ((0x0000001F&(data))>>0)
+#define ISO_IR_CR_get_irdn(data)                                                     ((0x0000001F&(data))>>0)
+
+
+#define ISO_IR_RP                                                                    0x18007414
+#define ISO_IR_RP_reg_addr                                                           "0xB8007414"
+#define ISO_IR_RP_reg                                                                0xB8007414
+#define set_ISO_IR_RP_reg(data)   (*((volatile unsigned int*) ISO_IR_RP_reg)=data)
+#define get_ISO_IR_RP_reg   (*((volatile unsigned int*) ISO_IR_RP_reg))
+#define ISO_IR_RP_inst_adr                                                           "0x0005"
+#define ISO_IR_RP_inst                                                               0x0005
+#define ISO_IR_RP_irrp_shift                                                         (0)
+#define ISO_IR_RP_irrp_mask                                                          (0xFFFFFFFF)
+#define ISO_IR_RP_irrp(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define ISO_IR_RP_irrp_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define ISO_IR_RP_get_irrp(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IR_SR                                                                    0x18007418
+#define ISO_IR_SR_reg_addr                                                           "0xB8007418"
+#define ISO_IR_SR_reg                                                                0xB8007418
+#define set_ISO_IR_SR_reg(data)   (*((volatile unsigned int*) ISO_IR_SR_reg)=data)
+#define get_ISO_IR_SR_reg   (*((volatile unsigned int*) ISO_IR_SR_reg))
+#define ISO_IR_SR_inst_adr                                                           "0x0006"
+#define ISO_IR_SR_inst                                                               0x0006
+#define ISO_IR_SR_slen_big_shift                                                     (5)
+#define ISO_IR_SR_slen_big_mask                                                      (0x00000020)
+#define ISO_IR_SR_slen_big(data)                                                     (0x00000020&((data)<<5))
+#define ISO_IR_SR_slen_big_src(data)                                                 ((0x00000020&(data))>>5)
+#define ISO_IR_SR_get_slen_big(data)                                                 ((0x00000020&(data))>>5)
+#define ISO_IR_SR_blen_big_shift                                                     (4)
+#define ISO_IR_SR_blen_big_mask                                                      (0x00000010)
+#define ISO_IR_SR_blen_big(data)                                                     (0x00000010&((data)<<4))
+#define ISO_IR_SR_blen_big_src(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IR_SR_get_blen_big(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IR_SR_raw_fifo_ov_shift                                                  (3)
+#define ISO_IR_SR_raw_fifo_ov_mask                                                   (0x00000008)
+#define ISO_IR_SR_raw_fifo_ov(data)                                                  (0x00000008&((data)<<3))
+#define ISO_IR_SR_raw_fifo_ov_src(data)                                              ((0x00000008&(data))>>3)
+#define ISO_IR_SR_get_raw_fifo_ov(data)                                              ((0x00000008&(data))>>3)
+#define ISO_IR_SR_raw_fifo_val_shift                                                 (2)
+#define ISO_IR_SR_raw_fifo_val_mask                                                  (0x00000004)
+#define ISO_IR_SR_raw_fifo_val(data)                                                 (0x00000004&((data)<<2))
+#define ISO_IR_SR_raw_fifo_val_src(data)                                             ((0x00000004&(data))>>2)
+#define ISO_IR_SR_get_raw_fifo_val(data)                                             ((0x00000004&(data))>>2)
+#define ISO_IR_SR_irrf_shift                                                         (1)
+#define ISO_IR_SR_irrf_mask                                                          (0x00000002)
+#define ISO_IR_SR_irrf(data)                                                         (0x00000002&((data)<<1))
+#define ISO_IR_SR_irrf_src(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_IR_SR_get_irrf(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_IR_SR_irdvf_shift                                                        (0)
+#define ISO_IR_SR_irdvf_mask                                                         (0x00000001)
+#define ISO_IR_SR_irdvf(data)                                                        (0x00000001&((data)<<0))
+#define ISO_IR_SR_irdvf_src(data)                                                    ((0x00000001&(data))>>0)
+#define ISO_IR_SR_get_irdvf(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IR_RAW_CTRL                                                              0x1800741C
+#define ISO_IR_RAW_CTRL_reg_addr                                                     "0xB800741C"
+#define ISO_IR_RAW_CTRL_reg                                                          0xB800741C
+#define set_ISO_IR_RAW_CTRL_reg(data)   (*((volatile unsigned int*) ISO_IR_RAW_CTRL_reg)=data)
+#define get_ISO_IR_RAW_CTRL_reg   (*((volatile unsigned int*) ISO_IR_RAW_CTRL_reg))
+#define ISO_IR_RAW_CTRL_inst_adr                                                     "0x0007"
+#define ISO_IR_RAW_CTRL_inst                                                         0x0007
+#define ISO_IR_RAW_CTRL_write_en2_shift                                              (25)
+#define ISO_IR_RAW_CTRL_write_en2_mask                                               (0x02000000)
+#define ISO_IR_RAW_CTRL_write_en2(data)                                              (0x02000000&((data)<<25))
+#define ISO_IR_RAW_CTRL_write_en2_src(data)                                          ((0x02000000&(data))>>25)
+#define ISO_IR_RAW_CTRL_get_write_en2(data)                                          ((0x02000000&(data))>>25)
+#define ISO_IR_RAW_CTRL_stop_sample_shift                                            (24)
+#define ISO_IR_RAW_CTRL_stop_sample_mask                                             (0x01000000)
+#define ISO_IR_RAW_CTRL_stop_sample(data)                                            (0x01000000&((data)<<24))
+#define ISO_IR_RAW_CTRL_stop_sample_src(data)                                        ((0x01000000&(data))>>24)
+#define ISO_IR_RAW_CTRL_get_stop_sample(data)                                        ((0x01000000&(data))>>24)
+#define ISO_IR_RAW_CTRL_stop_time_shift                                              (8)
+#define ISO_IR_RAW_CTRL_stop_time_mask                                               (0x00FFFF00)
+#define ISO_IR_RAW_CTRL_stop_time(data)                                              (0x00FFFF00&((data)<<8))
+#define ISO_IR_RAW_CTRL_stop_time_src(data)                                          ((0x00FFFF00&(data))>>8)
+#define ISO_IR_RAW_CTRL_get_stop_time(data)                                          ((0x00FFFF00&(data))>>8)
+#define ISO_IR_RAW_CTRL_write_en1_shift                                              (6)
+#define ISO_IR_RAW_CTRL_write_en1_mask                                               (0x00000040)
+#define ISO_IR_RAW_CTRL_write_en1(data)                                              (0x00000040&((data)<<6))
+#define ISO_IR_RAW_CTRL_write_en1_src(data)                                          ((0x00000040&(data))>>6)
+#define ISO_IR_RAW_CTRL_get_write_en1(data)                                          ((0x00000040&(data))>>6)
+#define ISO_IR_RAW_CTRL_fifo_thr_shift                                               (0)
+#define ISO_IR_RAW_CTRL_fifo_thr_mask                                                (0x0000003F)
+#define ISO_IR_RAW_CTRL_fifo_thr(data)                                               (0x0000003F&((data)<<0))
+#define ISO_IR_RAW_CTRL_fifo_thr_src(data)                                           ((0x0000003F&(data))>>0)
+#define ISO_IR_RAW_CTRL_get_fifo_thr(data)                                           ((0x0000003F&(data))>>0)
+
+
+#define ISO_IR_RAW_FF                                                                0x18007420
+#define ISO_IR_RAW_FF_reg_addr                                                       "0xB8007420"
+#define ISO_IR_RAW_FF_reg                                                            0xB8007420
+#define set_ISO_IR_RAW_FF_reg(data)   (*((volatile unsigned int*) ISO_IR_RAW_FF_reg)=data)
+#define get_ISO_IR_RAW_FF_reg   (*((volatile unsigned int*) ISO_IR_RAW_FF_reg))
+#define ISO_IR_RAW_FF_inst_adr                                                       "0x0008"
+#define ISO_IR_RAW_FF_inst                                                           0x0008
+#define ISO_IR_RAW_FF_dat_shift                                                      (0)
+#define ISO_IR_RAW_FF_dat_mask                                                       (0xFFFFFFFF)
+#define ISO_IR_RAW_FF_dat(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_IR_RAW_FF_dat_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_IR_RAW_FF_get_dat(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IR_RAW_SAMPLE_TIME                                                       0x18007424
+#define ISO_IR_RAW_SAMPLE_TIME_reg_addr                                              "0xB8007424"
+#define ISO_IR_RAW_SAMPLE_TIME_reg                                                   0xB8007424
+#define set_ISO_IR_RAW_SAMPLE_TIME_reg(data)   (*((volatile unsigned int*) ISO_IR_RAW_SAMPLE_TIME_reg)=data)
+#define get_ISO_IR_RAW_SAMPLE_TIME_reg   (*((volatile unsigned int*) ISO_IR_RAW_SAMPLE_TIME_reg))
+#define ISO_IR_RAW_SAMPLE_TIME_inst_adr                                              "0x0009"
+#define ISO_IR_RAW_SAMPLE_TIME_inst                                                  0x0009
+#define ISO_IR_RAW_SAMPLE_TIME_cnt_shift                                             (0)
+#define ISO_IR_RAW_SAMPLE_TIME_cnt_mask                                              (0x0000FFFF)
+#define ISO_IR_RAW_SAMPLE_TIME_cnt(data)                                             (0x0000FFFF&((data)<<0))
+#define ISO_IR_RAW_SAMPLE_TIME_cnt_src(data)                                         ((0x0000FFFF&(data))>>0)
+#define ISO_IR_RAW_SAMPLE_TIME_get_cnt(data)                                         ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IR_RAW_WL                                                                0x18007428
+#define ISO_IR_RAW_WL_reg_addr                                                       "0xB8007428"
+#define ISO_IR_RAW_WL_reg                                                            0xB8007428
+#define set_ISO_IR_RAW_WL_reg(data)   (*((volatile unsigned int*) ISO_IR_RAW_WL_reg)=data)
+#define get_ISO_IR_RAW_WL_reg   (*((volatile unsigned int*) ISO_IR_RAW_WL_reg))
+#define ISO_IR_RAW_WL_inst_adr                                                       "0x000A"
+#define ISO_IR_RAW_WL_inst                                                           0x000A
+#define ISO_IR_RAW_WL_val_shift                                                      (0)
+#define ISO_IR_RAW_WL_val_mask                                                       (0x0000003F)
+#define ISO_IR_RAW_WL_val(data)                                                      (0x0000003F&((data)<<0))
+#define ISO_IR_RAW_WL_val_src(data)                                                  ((0x0000003F&(data))>>0)
+#define ISO_IR_RAW_WL_get_val(data)                                                  ((0x0000003F&(data))>>0)
+
+
+#define ISO_IR_RAW_DEB                                                               0x1800742C
+#define ISO_IR_RAW_DEB_reg_addr                                                      "0xB800742C"
+#define ISO_IR_RAW_DEB_reg                                                           0xB800742C
+#define set_ISO_IR_RAW_DEB_reg(data)   (*((volatile unsigned int*) ISO_IR_RAW_DEB_reg)=data)
+#define get_ISO_IR_RAW_DEB_reg   (*((volatile unsigned int*) ISO_IR_RAW_DEB_reg))
+#define ISO_IR_RAW_DEB_inst_adr                                                      "0x000B"
+#define ISO_IR_RAW_DEB_inst                                                          0x000B
+#define ISO_IR_RAW_DEB_len_shift                                                     (16)
+#define ISO_IR_RAW_DEB_len_mask                                                      (0x00FF0000)
+#define ISO_IR_RAW_DEB_len(data)                                                     (0x00FF0000&((data)<<16))
+#define ISO_IR_RAW_DEB_len_src(data)                                                 ((0x00FF0000&(data))>>16)
+#define ISO_IR_RAW_DEB_get_len(data)                                                 ((0x00FF0000&(data))>>16)
+#define ISO_IR_RAW_DEB_clk_shift                                                     (0)
+#define ISO_IR_RAW_DEB_clk_mask                                                      (0x0000FFFF)
+#define ISO_IR_RAW_DEB_clk(data)                                                     (0x0000FFFF&((data)<<0))
+#define ISO_IR_RAW_DEB_clk_src(data)                                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IR_RAW_DEB_get_clk(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IR_PSR_UP                                                                0x18007430
+#define ISO_IR_PSR_UP_reg_addr                                                       "0xB8007430"
+#define ISO_IR_PSR_UP_reg                                                            0xB8007430
+#define set_ISO_IR_PSR_UP_reg(data)   (*((volatile unsigned int*) ISO_IR_PSR_UP_reg)=data)
+#define get_ISO_IR_PSR_UP_reg   (*((volatile unsigned int*) ISO_IR_PSR_UP_reg))
+#define ISO_IR_PSR_UP_inst_adr                                                       "0x000C"
+#define ISO_IR_PSR_UP_inst                                                           0x000C
+#define ISO_IR_PSR_UP_irrbl_shift                                                    (24)
+#define ISO_IR_PSR_UP_irrbl_mask                                                     (0xFF000000)
+#define ISO_IR_PSR_UP_irrbl(data)                                                    (0xFF000000&((data)<<24))
+#define ISO_IR_PSR_UP_irrbl_src(data)                                                ((0xFF000000&(data))>>24)
+#define ISO_IR_PSR_UP_get_irrbl(data)                                                ((0xFF000000&(data))>>24)
+#define ISO_IR_PSR_UP_irrml_shift                                                    (16)
+#define ISO_IR_PSR_UP_irrml_mask                                                     (0x00FF0000)
+#define ISO_IR_PSR_UP_irrml(data)                                                    (0x00FF0000&((data)<<16))
+#define ISO_IR_PSR_UP_irrml_src(data)                                                ((0x00FF0000&(data))>>16)
+#define ISO_IR_PSR_UP_get_irrml(data)                                                ((0x00FF0000&(data))>>16)
+#define ISO_IR_PSR_UP_irrdzl_shift                                                   (8)
+#define ISO_IR_PSR_UP_irrdzl_mask                                                    (0x0000FF00)
+#define ISO_IR_PSR_UP_irrdzl(data)                                                   (0x0000FF00&((data)<<8))
+#define ISO_IR_PSR_UP_irrdzl_src(data)                                               ((0x0000FF00&(data))>>8)
+#define ISO_IR_PSR_UP_get_irrdzl(data)                                               ((0x0000FF00&(data))>>8)
+#define ISO_IR_PSR_UP_irrdol_shift                                                   (0)
+#define ISO_IR_PSR_UP_irrdol_mask                                                    (0x000000FF)
+#define ISO_IR_PSR_UP_irrdol(data)                                                   (0x000000FF&((data)<<0))
+#define ISO_IR_PSR_UP_irrdol_src(data)                                               ((0x000000FF&(data))>>0)
+#define ISO_IR_PSR_UP_get_irrdol(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_PER_UP                                                                0x18007434
+#define ISO_IR_PER_UP_reg_addr                                                       "0xB8007434"
+#define ISO_IR_PER_UP_reg                                                            0xB8007434
+#define set_ISO_IR_PER_UP_reg(data)   (*((volatile unsigned int*) ISO_IR_PER_UP_reg)=data)
+#define get_ISO_IR_PER_UP_reg   (*((volatile unsigned int*) ISO_IR_PER_UP_reg))
+#define ISO_IR_PER_UP_inst_adr                                                       "0x000D"
+#define ISO_IR_PER_UP_inst                                                           0x000D
+#define ISO_IR_PER_UP_irrrl_shift                                                    (8)
+#define ISO_IR_PER_UP_irrrl_mask                                                     (0x0000FF00)
+#define ISO_IR_PER_UP_irrrl(data)                                                    (0x0000FF00&((data)<<8))
+#define ISO_IR_PER_UP_irrrl_src(data)                                                ((0x0000FF00&(data))>>8)
+#define ISO_IR_PER_UP_get_irrrl(data)                                                ((0x0000FF00&(data))>>8)
+#define ISO_IR_PER_UP_irrsl_shift                                                    (0)
+#define ISO_IR_PER_UP_irrsl_mask                                                     (0x000000FF)
+#define ISO_IR_PER_UP_irrsl(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_IR_PER_UP_irrsl_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_IR_PER_UP_get_irrsl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_CTRL_RC6                                                              0x18007438
+#define ISO_IR_CTRL_RC6_reg_addr                                                     "0xB8007438"
+#define ISO_IR_CTRL_RC6_reg                                                          0xB8007438
+#define set_ISO_IR_CTRL_RC6_reg(data)   (*((volatile unsigned int*) ISO_IR_CTRL_RC6_reg)=data)
+#define get_ISO_IR_CTRL_RC6_reg   (*((volatile unsigned int*) ISO_IR_CTRL_RC6_reg))
+#define ISO_IR_CTRL_RC6_inst_adr                                                     "0x000E"
+#define ISO_IR_CTRL_RC6_inst                                                         0x000E
+#define ISO_IR_CTRL_RC6_rc6_en_shift                                                 (8)
+#define ISO_IR_CTRL_RC6_rc6_en_mask                                                  (0x00000100)
+#define ISO_IR_CTRL_RC6_rc6_en(data)                                                 (0x00000100&((data)<<8))
+#define ISO_IR_CTRL_RC6_rc6_en_src(data)                                             ((0x00000100&(data))>>8)
+#define ISO_IR_CTRL_RC6_get_rc6_en(data)                                             ((0x00000100&(data))>>8)
+#define ISO_IR_CTRL_RC6_irtr_shift                                                   (0)
+#define ISO_IR_CTRL_RC6_irtr_mask                                                    (0x000000FF)
+#define ISO_IR_CTRL_RC6_irtr(data)                                                   (0x000000FF&((data)<<0))
+#define ISO_IR_CTRL_RC6_irtr_src(data)                                               ((0x000000FF&(data))>>0)
+#define ISO_IR_CTRL_RC6_get_irtr(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_RP2                                                                   0x1800743C
+#define ISO_IR_RP2_reg_addr                                                          "0xB800743C"
+#define ISO_IR_RP2_reg                                                               0xB800743C
+#define set_ISO_IR_RP2_reg(data)   (*((volatile unsigned int*) ISO_IR_RP2_reg)=data)
+#define get_ISO_IR_RP2_reg   (*((volatile unsigned int*) ISO_IR_RP2_reg))
+#define ISO_IR_RP2_inst_adr                                                          "0x000F"
+#define ISO_IR_RP2_inst                                                              0x000F
+#define ISO_IR_RP2_irrp_shift                                                        (0)
+#define ISO_IR_RP2_irrp_mask                                                         (0xFFFFFFFF)
+#define ISO_IR_RP2_irrp(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define ISO_IR_RP2_irrp_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define ISO_IR_RP2_get_irrp(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IRTX_CFG                                                                 0x18007440
+#define ISO_IRTX_CFG_reg_addr                                                        "0xB8007440"
+#define ISO_IRTX_CFG_reg                                                             0xB8007440
+#define set_ISO_IRTX_CFG_reg(data)   (*((volatile unsigned int*) ISO_IRTX_CFG_reg)=data)
+#define get_ISO_IRTX_CFG_reg   (*((volatile unsigned int*) ISO_IRTX_CFG_reg))
+#define ISO_IRTX_CFG_inst_adr                                                        "0x0010"
+#define ISO_IRTX_CFG_inst                                                            0x0010
+#define ISO_IRTX_CFG_irtx_en_shift                                                   (31)
+#define ISO_IRTX_CFG_irtx_en_mask                                                    (0x80000000)
+#define ISO_IRTX_CFG_irtx_en(data)                                                   (0x80000000&((data)<<31))
+#define ISO_IRTX_CFG_irtx_en_src(data)                                               ((0x80000000&(data))>>31)
+#define ISO_IRTX_CFG_get_irtx_en(data)                                               ((0x80000000&(data))>>31)
+#define ISO_IRTX_CFG_iact_lvl_shift                                                  (10)
+#define ISO_IRTX_CFG_iact_lvl_mask                                                   (0x00000400)
+#define ISO_IRTX_CFG_iact_lvl(data)                                                  (0x00000400&((data)<<10))
+#define ISO_IRTX_CFG_iact_lvl_src(data)                                              ((0x00000400&(data))>>10)
+#define ISO_IRTX_CFG_get_iact_lvl(data)                                              ((0x00000400&(data))>>10)
+#define ISO_IRTX_CFG_modulation_shift                                                (9)
+#define ISO_IRTX_CFG_modulation_mask                                                 (0x00000200)
+#define ISO_IRTX_CFG_modulation(data)                                                (0x00000200&((data)<<9))
+#define ISO_IRTX_CFG_modulation_src(data)                                            ((0x00000200&(data))>>9)
+#define ISO_IRTX_CFG_get_modulation(data)                                            ((0x00000200&(data))>>9)
+#define ISO_IRTX_CFG_endian_shift                                                    (8)
+#define ISO_IRTX_CFG_endian_mask                                                     (0x00000100)
+#define ISO_IRTX_CFG_endian(data)                                                    (0x00000100&((data)<<8))
+#define ISO_IRTX_CFG_endian_src(data)                                                ((0x00000100&(data))>>8)
+#define ISO_IRTX_CFG_get_endian(data)                                                ((0x00000100&(data))>>8)
+#define ISO_IRTX_CFG_dummy_shift                                                     (6)
+#define ISO_IRTX_CFG_dummy_mask                                                      (0x000000C0)
+#define ISO_IRTX_CFG_dummy(data)                                                     (0x000000C0&((data)<<6))
+#define ISO_IRTX_CFG_dummy_src(data)                                                 ((0x000000C0&(data))>>6)
+#define ISO_IRTX_CFG_get_dummy(data)                                                 ((0x000000C0&(data))>>6)
+#define ISO_IRTX_CFG_fifoout_inv_shift                                               (5)
+#define ISO_IRTX_CFG_fifoout_inv_mask                                                (0x00000020)
+#define ISO_IRTX_CFG_fifoout_inv(data)                                               (0x00000020&((data)<<5))
+#define ISO_IRTX_CFG_fifoout_inv_src(data)                                           ((0x00000020&(data))>>5)
+#define ISO_IRTX_CFG_get_fifoout_inv(data)                                           ((0x00000020&(data))>>5)
+#define ISO_IRTX_CFG_irtxout_inv_shift                                               (4)
+#define ISO_IRTX_CFG_irtxout_inv_mask                                                (0x00000010)
+#define ISO_IRTX_CFG_irtxout_inv(data)                                               (0x00000010&((data)<<4))
+#define ISO_IRTX_CFG_irtxout_inv_src(data)                                           ((0x00000010&(data))>>4)
+#define ISO_IRTX_CFG_get_irtxout_inv(data)                                           ((0x00000010&(data))>>4)
+#define ISO_IRTX_CFG_start_shift                                                     (0)
+#define ISO_IRTX_CFG_start_mask                                                      (0x00000001)
+#define ISO_IRTX_CFG_start(data)                                                     (0x00000001&((data)<<0))
+#define ISO_IRTX_CFG_start_src(data)                                                 ((0x00000001&(data))>>0)
+#define ISO_IRTX_CFG_get_start(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define ISO_IRTX_TIM                                                                 0x18007444
+#define ISO_IRTX_TIM_reg_addr                                                        "0xB8007444"
+#define ISO_IRTX_TIM_reg                                                             0xB8007444
+#define set_ISO_IRTX_TIM_reg(data)   (*((volatile unsigned int*) ISO_IRTX_TIM_reg)=data)
+#define get_ISO_IRTX_TIM_reg   (*((volatile unsigned int*) ISO_IRTX_TIM_reg))
+#define ISO_IRTX_TIM_inst_adr                                                        "0x0011"
+#define ISO_IRTX_TIM_inst                                                            0x0011
+#define ISO_IRTX_TIM_irtx_fd_shift                                                   (0)
+#define ISO_IRTX_TIM_irtx_fd_mask                                                    (0x0000FFFF)
+#define ISO_IRTX_TIM_irtx_fd(data)                                                   (0x0000FFFF&((data)<<0))
+#define ISO_IRTX_TIM_irtx_fd_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define ISO_IRTX_TIM_get_irtx_fd(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IRTX_PWM_SETTING                                                         0x18007448
+#define ISO_IRTX_PWM_SETTING_reg_addr                                                "0xB8007448"
+#define ISO_IRTX_PWM_SETTING_reg                                                     0xB8007448
+#define set_ISO_IRTX_PWM_SETTING_reg(data)   (*((volatile unsigned int*) ISO_IRTX_PWM_SETTING_reg)=data)
+#define get_ISO_IRTX_PWM_SETTING_reg   (*((volatile unsigned int*) ISO_IRTX_PWM_SETTING_reg))
+#define ISO_IRTX_PWM_SETTING_inst_adr                                                "0x0012"
+#define ISO_IRTX_PWM_SETTING_inst                                                    0x0012
+#define ISO_IRTX_PWM_SETTING_pwm_clksrc_div_shift                                    (16)
+#define ISO_IRTX_PWM_SETTING_pwm_clksrc_div_mask                                     (0x000F0000)
+#define ISO_IRTX_PWM_SETTING_pwm_clksrc_div(data)                                    (0x000F0000&((data)<<16))
+#define ISO_IRTX_PWM_SETTING_pwm_clksrc_div_src(data)                                ((0x000F0000&(data))>>16)
+#define ISO_IRTX_PWM_SETTING_get_pwm_clksrc_div(data)                                ((0x000F0000&(data))>>16)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_duty_shift                                      (8)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_duty_mask                                       (0x0000FF00)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_duty(data)                                      (0x0000FF00&((data)<<8))
+#define ISO_IRTX_PWM_SETTING_pwm_clk_duty_src(data)                                  ((0x0000FF00&(data))>>8)
+#define ISO_IRTX_PWM_SETTING_get_pwm_clk_duty(data)                                  ((0x0000FF00&(data))>>8)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_div_shift                                       (0)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_div_mask                                        (0x000000FF)
+#define ISO_IRTX_PWM_SETTING_pwm_clk_div(data)                                       (0x000000FF&((data)<<0))
+#define ISO_IRTX_PWM_SETTING_pwm_clk_div_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_IRTX_PWM_SETTING_get_pwm_clk_div(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_IRTX_INT_EN                                                              0x1800744C
+#define ISO_IRTX_INT_EN_reg_addr                                                     "0xB800744C"
+#define ISO_IRTX_INT_EN_reg                                                          0xB800744C
+#define set_ISO_IRTX_INT_EN_reg(data)   (*((volatile unsigned int*) ISO_IRTX_INT_EN_reg)=data)
+#define get_ISO_IRTX_INT_EN_reg   (*((volatile unsigned int*) ISO_IRTX_INT_EN_reg))
+#define ISO_IRTX_INT_EN_inst_adr                                                     "0x0013"
+#define ISO_IRTX_INT_EN_inst                                                         0x0013
+#define ISO_IRTX_INT_EN_data_thr_shift                                               (8)
+#define ISO_IRTX_INT_EN_data_thr_mask                                                (0x00003F00)
+#define ISO_IRTX_INT_EN_data_thr(data)                                               (0x00003F00&((data)<<8))
+#define ISO_IRTX_INT_EN_data_thr_src(data)                                           ((0x00003F00&(data))>>8)
+#define ISO_IRTX_INT_EN_get_data_thr(data)                                           ((0x00003F00&(data))>>8)
+#define ISO_IRTX_INT_EN_fin_en_shift                                                 (2)
+#define ISO_IRTX_INT_EN_fin_en_mask                                                  (0x00000004)
+#define ISO_IRTX_INT_EN_fin_en(data)                                                 (0x00000004&((data)<<2))
+#define ISO_IRTX_INT_EN_fin_en_src(data)                                             ((0x00000004&(data))>>2)
+#define ISO_IRTX_INT_EN_get_fin_en(data)                                             ((0x00000004&(data))>>2)
+#define ISO_IRTX_INT_EN_emp_en_shift                                                 (1)
+#define ISO_IRTX_INT_EN_emp_en_mask                                                  (0x00000002)
+#define ISO_IRTX_INT_EN_emp_en(data)                                                 (0x00000002&((data)<<1))
+#define ISO_IRTX_INT_EN_emp_en_src(data)                                             ((0x00000002&(data))>>1)
+#define ISO_IRTX_INT_EN_get_emp_en(data)                                             ((0x00000002&(data))>>1)
+#define ISO_IRTX_INT_EN_req_en_shift                                                 (0)
+#define ISO_IRTX_INT_EN_req_en_mask                                                  (0x00000001)
+#define ISO_IRTX_INT_EN_req_en(data)                                                 (0x00000001&((data)<<0))
+#define ISO_IRTX_INT_EN_req_en_src(data)                                             ((0x00000001&(data))>>0)
+#define ISO_IRTX_INT_EN_get_req_en(data)                                             ((0x00000001&(data))>>0)
+
+
+#define ISO_IRTX_INT_ST                                                              0x18007450
+#define ISO_IRTX_INT_ST_reg_addr                                                     "0xB8007450"
+#define ISO_IRTX_INT_ST_reg                                                          0xB8007450
+#define set_ISO_IRTX_INT_ST_reg(data)   (*((volatile unsigned int*) ISO_IRTX_INT_ST_reg)=data)
+#define get_ISO_IRTX_INT_ST_reg   (*((volatile unsigned int*) ISO_IRTX_INT_ST_reg))
+#define ISO_IRTX_INT_ST_inst_adr                                                     "0x0014"
+#define ISO_IRTX_INT_ST_inst                                                         0x0014
+#define ISO_IRTX_INT_ST_fin_flag_shift                                               (2)
+#define ISO_IRTX_INT_ST_fin_flag_mask                                                (0x00000004)
+#define ISO_IRTX_INT_ST_fin_flag(data)                                               (0x00000004&((data)<<2))
+#define ISO_IRTX_INT_ST_fin_flag_src(data)                                           ((0x00000004&(data))>>2)
+#define ISO_IRTX_INT_ST_get_fin_flag(data)                                           ((0x00000004&(data))>>2)
+#define ISO_IRTX_INT_ST_emp_flag_shift                                               (1)
+#define ISO_IRTX_INT_ST_emp_flag_mask                                                (0x00000002)
+#define ISO_IRTX_INT_ST_emp_flag(data)                                               (0x00000002&((data)<<1))
+#define ISO_IRTX_INT_ST_emp_flag_src(data)                                           ((0x00000002&(data))>>1)
+#define ISO_IRTX_INT_ST_get_emp_flag(data)                                           ((0x00000002&(data))>>1)
+#define ISO_IRTX_INT_ST_req_flag_shift                                               (0)
+#define ISO_IRTX_INT_ST_req_flag_mask                                                (0x00000001)
+#define ISO_IRTX_INT_ST_req_flag(data)                                               (0x00000001&((data)<<0))
+#define ISO_IRTX_INT_ST_req_flag_src(data)                                           ((0x00000001&(data))>>0)
+#define ISO_IRTX_INT_ST_get_req_flag(data)                                           ((0x00000001&(data))>>0)
+
+
+#define ISO_IRTX_FIFO_ST                                                             0x18007454
+#define ISO_IRTX_FIFO_ST_reg_addr                                                    "0xB8007454"
+#define ISO_IRTX_FIFO_ST_reg                                                         0xB8007454
+#define set_ISO_IRTX_FIFO_ST_reg(data)   (*((volatile unsigned int*) ISO_IRTX_FIFO_ST_reg)=data)
+#define get_ISO_IRTX_FIFO_ST_reg   (*((volatile unsigned int*) ISO_IRTX_FIFO_ST_reg))
+#define ISO_IRTX_FIFO_ST_inst_adr                                                    "0x0015"
+#define ISO_IRTX_FIFO_ST_inst                                                        0x0015
+#define ISO_IRTX_FIFO_ST_fifo_rst_shift                                              (31)
+#define ISO_IRTX_FIFO_ST_fifo_rst_mask                                               (0x80000000)
+#define ISO_IRTX_FIFO_ST_fifo_rst(data)                                              (0x80000000&((data)<<31))
+#define ISO_IRTX_FIFO_ST_fifo_rst_src(data)                                          ((0x80000000&(data))>>31)
+#define ISO_IRTX_FIFO_ST_get_fifo_rst(data)                                          ((0x80000000&(data))>>31)
+#define ISO_IRTX_FIFO_ST_valid_len_shift                                             (8)
+#define ISO_IRTX_FIFO_ST_valid_len_mask                                              (0x00000F00)
+#define ISO_IRTX_FIFO_ST_valid_len(data)                                             (0x00000F00&((data)<<8))
+#define ISO_IRTX_FIFO_ST_valid_len_src(data)                                         ((0x00000F00&(data))>>8)
+#define ISO_IRTX_FIFO_ST_get_valid_len(data)                                         ((0x00000F00&(data))>>8)
+#define ISO_IRTX_FIFO_ST_wrp_shift                                                   (4)
+#define ISO_IRTX_FIFO_ST_wrp_mask                                                    (0x000000F0)
+#define ISO_IRTX_FIFO_ST_wrp(data)                                                   (0x000000F0&((data)<<4))
+#define ISO_IRTX_FIFO_ST_wrp_src(data)                                               ((0x000000F0&(data))>>4)
+#define ISO_IRTX_FIFO_ST_get_wrp(data)                                               ((0x000000F0&(data))>>4)
+#define ISO_IRTX_FIFO_ST_rdp_shift                                                   (0)
+#define ISO_IRTX_FIFO_ST_rdp_mask                                                    (0x0000000F)
+#define ISO_IRTX_FIFO_ST_rdp(data)                                                   (0x0000000F&((data)<<0))
+#define ISO_IRTX_FIFO_ST_rdp_src(data)                                               ((0x0000000F&(data))>>0)
+#define ISO_IRTX_FIFO_ST_get_rdp(data)                                               ((0x0000000F&(data))>>0)
+
+
+#define ISO_IRTX_FIFO                                                                0x18007458
+#define ISO_IRTX_FIFO_reg_addr                                                       "0xB8007458"
+#define ISO_IRTX_FIFO_reg                                                            0xB8007458
+#define set_ISO_IRTX_FIFO_reg(data)   (*((volatile unsigned int*) ISO_IRTX_FIFO_reg)=data)
+#define get_ISO_IRTX_FIFO_reg   (*((volatile unsigned int*) ISO_IRTX_FIFO_reg))
+#define ISO_IRTX_FIFO_inst_adr                                                       "0x0016"
+#define ISO_IRTX_FIFO_inst                                                           0x0016
+#define ISO_IRTX_FIFO_data_shift                                                     (0)
+#define ISO_IRTX_FIFO_data_mask                                                      (0xFFFFFFFF)
+#define ISO_IRTX_FIFO_data(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_IRTX_FIFO_data_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_IRTX_FIFO_get_data(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IRRCMM_TIMING                                                            0x18007460
+#define ISO_IRRCMM_TIMING_reg_addr                                                   "0xB8007460"
+#define ISO_IRRCMM_TIMING_reg                                                        0xB8007460
+#define set_ISO_IRRCMM_TIMING_reg(data)   (*((volatile unsigned int*) ISO_IRRCMM_TIMING_reg)=data)
+#define get_ISO_IRRCMM_TIMING_reg   (*((volatile unsigned int*) ISO_IRRCMM_TIMING_reg))
+#define ISO_IRRCMM_TIMING_inst_adr                                                   "0x0018"
+#define ISO_IRRCMM_TIMING_inst                                                       0x0018
+#define ISO_IRRCMM_TIMING_len_11_shift                                               (24)
+#define ISO_IRRCMM_TIMING_len_11_mask                                                (0xFF000000)
+#define ISO_IRRCMM_TIMING_len_11(data)                                               (0xFF000000&((data)<<24))
+#define ISO_IRRCMM_TIMING_len_11_src(data)                                           ((0xFF000000&(data))>>24)
+#define ISO_IRRCMM_TIMING_get_len_11(data)                                           ((0xFF000000&(data))>>24)
+#define ISO_IRRCMM_TIMING_len_10_shift                                               (16)
+#define ISO_IRRCMM_TIMING_len_10_mask                                                (0x00FF0000)
+#define ISO_IRRCMM_TIMING_len_10(data)                                               (0x00FF0000&((data)<<16))
+#define ISO_IRRCMM_TIMING_len_10_src(data)                                           ((0x00FF0000&(data))>>16)
+#define ISO_IRRCMM_TIMING_get_len_10(data)                                           ((0x00FF0000&(data))>>16)
+#define ISO_IRRCMM_TIMING_len_01_shift                                               (8)
+#define ISO_IRRCMM_TIMING_len_01_mask                                                (0x0000FF00)
+#define ISO_IRRCMM_TIMING_len_01(data)                                               (0x0000FF00&((data)<<8))
+#define ISO_IRRCMM_TIMING_len_01_src(data)                                           ((0x0000FF00&(data))>>8)
+#define ISO_IRRCMM_TIMING_get_len_01(data)                                           ((0x0000FF00&(data))>>8)
+#define ISO_IRRCMM_TIMING_len_00_shift                                               (0)
+#define ISO_IRRCMM_TIMING_len_00_mask                                                (0x000000FF)
+#define ISO_IRRCMM_TIMING_len_00(data)                                               (0x000000FF&((data)<<0))
+#define ISO_IRRCMM_TIMING_len_00_src(data)                                           ((0x000000FF&(data))>>0)
+#define ISO_IRRCMM_TIMING_get_len_00(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define ISO_IR_CR1                                                                   0x18007464
+#define ISO_IR_CR1_reg_addr                                                          "0xB8007464"
+#define ISO_IR_CR1_reg                                                               0xB8007464
+#define set_ISO_IR_CR1_reg(data)   (*((volatile unsigned int*) ISO_IR_CR1_reg)=data)
+#define get_ISO_IR_CR1_reg   (*((volatile unsigned int*) ISO_IR_CR1_reg))
+#define ISO_IR_CR1_inst_adr                                                          "0x0019"
+#define ISO_IR_CR1_inst                                                              0x0019
+#define ISO_IR_CR1_dec_by_min_max_shift                                              (0)
+#define ISO_IR_CR1_dec_by_min_max_mask                                               (0x00000001)
+#define ISO_IR_CR1_dec_by_min_max(data)                                              (0x00000001&((data)<<0))
+#define ISO_IR_CR1_dec_by_min_max_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_IR_CR1_get_dec_by_min_max(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_IRRCMM_APKB                                                              0x18007468
+#define ISO_IRRCMM_APKB_reg_addr                                                     "0xB8007468"
+#define ISO_IRRCMM_APKB_reg                                                          0xB8007468
+#define set_ISO_IRRCMM_APKB_reg(data)   (*((volatile unsigned int*) ISO_IRRCMM_APKB_reg)=data)
+#define get_ISO_IRRCMM_APKB_reg   (*((volatile unsigned int*) ISO_IRRCMM_APKB_reg))
+#define ISO_IRRCMM_APKB_inst_adr                                                     "0x001A"
+#define ISO_IRRCMM_APKB_inst                                                         0x001A
+#define ISO_IRRCMM_APKB_rcmm_ap_max_shift                                            (24)
+#define ISO_IRRCMM_APKB_rcmm_ap_max_mask                                             (0xFF000000)
+#define ISO_IRRCMM_APKB_rcmm_ap_max(data)                                            (0xFF000000&((data)<<24))
+#define ISO_IRRCMM_APKB_rcmm_ap_max_src(data)                                        ((0xFF000000&(data))>>24)
+#define ISO_IRRCMM_APKB_get_rcmm_ap_max(data)                                        ((0xFF000000&(data))>>24)
+#define ISO_IRRCMM_APKB_rcmm_ap_min_shift                                            (16)
+#define ISO_IRRCMM_APKB_rcmm_ap_min_mask                                             (0x00FF0000)
+#define ISO_IRRCMM_APKB_rcmm_ap_min(data)                                            (0x00FF0000&((data)<<16))
+#define ISO_IRRCMM_APKB_rcmm_ap_min_src(data)                                        ((0x00FF0000&(data))>>16)
+#define ISO_IRRCMM_APKB_get_rcmm_ap_min(data)                                        ((0x00FF0000&(data))>>16)
+#define ISO_IRRCMM_APKB_rcmm_kb_max_shift                                            (8)
+#define ISO_IRRCMM_APKB_rcmm_kb_max_mask                                             (0x0000FF00)
+#define ISO_IRRCMM_APKB_rcmm_kb_max(data)                                            (0x0000FF00&((data)<<8))
+#define ISO_IRRCMM_APKB_rcmm_kb_max_src(data)                                        ((0x0000FF00&(data))>>8)
+#define ISO_IRRCMM_APKB_get_rcmm_kb_max(data)                                        ((0x0000FF00&(data))>>8)
+#define ISO_IRRCMM_APKB_rcmm_kb_min_shift                                            (0)
+#define ISO_IRRCMM_APKB_rcmm_kb_min_mask                                             (0x000000FF)
+#define ISO_IRRCMM_APKB_rcmm_kb_min(data)                                            (0x000000FF&((data)<<0))
+#define ISO_IRRCMM_APKB_rcmm_kb_min_src(data)                                        ((0x000000FF&(data))>>0)
+#define ISO_IRRCMM_APKB_get_rcmm_kb_min(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define ISO_IRRXRCLFIFO                                                              0x1800746C
+#define ISO_IRRXRCLFIFO_reg_addr                                                     "0xB800746C"
+#define ISO_IRRXRCLFIFO_reg                                                          0xB800746C
+#define set_ISO_IRRXRCLFIFO_reg(data)   (*((volatile unsigned int*) ISO_IRRXRCLFIFO_reg)=data)
+#define get_ISO_IRRXRCLFIFO_reg   (*((volatile unsigned int*) ISO_IRRXRCLFIFO_reg))
+#define ISO_IRRXRCLFIFO_inst_adr                                                     "0x001B"
+#define ISO_IRRXRCLFIFO_inst                                                         0x001B
+#define ISO_IRRXRCLFIFO_rcmm_apoint_shift                                            (31)
+#define ISO_IRRXRCLFIFO_rcmm_apoint_mask                                             (0x80000000)
+#define ISO_IRRXRCLFIFO_rcmm_apoint(data)                                            (0x80000000&((data)<<31))
+#define ISO_IRRXRCLFIFO_rcmm_apoint_src(data)                                        ((0x80000000&(data))>>31)
+#define ISO_IRRXRCLFIFO_get_rcmm_apoint(data)                                        ((0x80000000&(data))>>31)
+#define ISO_IRRXRCLFIFO_rcmm_kboard_shift                                            (30)
+#define ISO_IRRXRCLFIFO_rcmm_kboard_mask                                             (0x40000000)
+#define ISO_IRRXRCLFIFO_rcmm_kboard(data)                                            (0x40000000&((data)<<30))
+#define ISO_IRRXRCLFIFO_rcmm_kboard_src(data)                                        ((0x40000000&(data))>>30)
+#define ISO_IRRXRCLFIFO_get_rcmm_kboard(data)                                        ((0x40000000&(data))>>30)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_high_shift                                   (16)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_high_mask                                    (0x3FFF0000)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_high(data)                                   (0x3FFF0000&((data)<<16))
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_high_src(data)                               ((0x3FFF0000&(data))>>16)
+#define ISO_IRRXRCLFIFO_get_remote_cnt_lead_high(data)                               ((0x3FFF0000&(data))>>16)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_low_shift                                    (0)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_low_mask                                     (0x0000FFFF)
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_low(data)                                    (0x0000FFFF&((data)<<0))
+#define ISO_IRRXRCLFIFO_remote_cnt_lead_low_src(data)                                ((0x0000FFFF&(data))>>0)
+#define ISO_IRRXRCLFIFO_get_remote_cnt_lead_low(data)                                ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_CEC_CR0                                                                  0x18007500
+#define ISO_CEC_CR0_reg_addr                                                         "0xB8007500"
+#define ISO_CEC_CR0_reg                                                              0xB8007500
+#define set_ISO_CEC_CR0_reg(data)   (*((volatile unsigned int*) ISO_CEC_CR0_reg)=data)
+#define get_ISO_CEC_CR0_reg   (*((volatile unsigned int*) ISO_CEC_CR0_reg))
+#define ISO_CEC_CR0_inst_adr                                                         "0x0040"
+#define ISO_CEC_CR0_inst                                                             0x0040
+#define ISO_CEC_CR0_cec_mode_shift                                                   (30)
+#define ISO_CEC_CR0_cec_mode_mask                                                    (0xC0000000)
+#define ISO_CEC_CR0_cec_mode(data)                                                   (0xC0000000&((data)<<30))
+#define ISO_CEC_CR0_cec_mode_src(data)                                               ((0xC0000000&(data))>>30)
+#define ISO_CEC_CR0_get_cec_mode(data)                                               ((0xC0000000&(data))>>30)
+#define ISO_CEC_CR0_test_mode_pad_en_shift                                           (28)
+#define ISO_CEC_CR0_test_mode_pad_en_mask                                            (0x10000000)
+#define ISO_CEC_CR0_test_mode_pad_en(data)                                           (0x10000000&((data)<<28))
+#define ISO_CEC_CR0_test_mode_pad_en_src(data)                                       ((0x10000000&(data))>>28)
+#define ISO_CEC_CR0_get_test_mode_pad_en(data)                                       ((0x10000000&(data))>>28)
+#define ISO_CEC_CR0_logical_addr0_shift                                              (24)
+#define ISO_CEC_CR0_logical_addr0_mask                                               (0x0F000000)
+#define ISO_CEC_CR0_logical_addr0(data)                                              (0x0F000000&((data)<<24))
+#define ISO_CEC_CR0_logical_addr0_src(data)                                          ((0x0F000000&(data))>>24)
+#define ISO_CEC_CR0_get_logical_addr0(data)                                          ((0x0F000000&(data))>>24)
+#define ISO_CEC_CR0_timer_div_shift                                                  (16)
+#define ISO_CEC_CR0_timer_div_mask                                                   (0x00FF0000)
+#define ISO_CEC_CR0_timer_div(data)                                                  (0x00FF0000&((data)<<16))
+#define ISO_CEC_CR0_timer_div_src(data)                                              ((0x00FF0000&(data))>>16)
+#define ISO_CEC_CR0_get_timer_div(data)                                              ((0x00FF0000&(data))>>16)
+#define ISO_CEC_CR0_pre_div_shift                                                    (8)
+#define ISO_CEC_CR0_pre_div_mask                                                     (0x0000FF00)
+#define ISO_CEC_CR0_pre_div(data)                                                    (0x0000FF00&((data)<<8))
+#define ISO_CEC_CR0_pre_div_src(data)                                                ((0x0000FF00&(data))>>8)
+#define ISO_CEC_CR0_get_pre_div(data)                                                ((0x0000FF00&(data))>>8)
+#define ISO_CEC_CR0_unreg_ack_en_shift                                               (7)
+#define ISO_CEC_CR0_unreg_ack_en_mask                                                (0x00000080)
+#define ISO_CEC_CR0_unreg_ack_en(data)                                               (0x00000080&((data)<<7))
+#define ISO_CEC_CR0_unreg_ack_en_src(data)                                           ((0x00000080&(data))>>7)
+#define ISO_CEC_CR0_get_unreg_ack_en(data)                                           ((0x00000080&(data))>>7)
+#define ISO_CEC_CR0_cdc_arbitration_en_shift                                         (5)
+#define ISO_CEC_CR0_cdc_arbitration_en_mask                                          (0x00000020)
+#define ISO_CEC_CR0_cdc_arbitration_en(data)                                         (0x00000020&((data)<<5))
+#define ISO_CEC_CR0_cdc_arbitration_en_src(data)                                     ((0x00000020&(data))>>5)
+#define ISO_CEC_CR0_get_cdc_arbitration_en(data)                                     ((0x00000020&(data))>>5)
+#define ISO_CEC_CR0_test_mode_pad_data_shift                                         (0)
+#define ISO_CEC_CR0_test_mode_pad_data_mask                                          (0x0000001F)
+#define ISO_CEC_CR0_test_mode_pad_data(data)                                         (0x0000001F&((data)<<0))
+#define ISO_CEC_CR0_test_mode_pad_data_src(data)                                     ((0x0000001F&(data))>>0)
+#define ISO_CEC_CR0_get_test_mode_pad_data(data)                                     ((0x0000001F&(data))>>0)
+
+
+#define ISO_CEC_RTCR0                                                                0x18007504
+#define ISO_CEC_RTCR0_reg_addr                                                       "0xB8007504"
+#define ISO_CEC_RTCR0_reg                                                            0xB8007504
+#define set_ISO_CEC_RTCR0_reg(data)   (*((volatile unsigned int*) ISO_CEC_RTCR0_reg)=data)
+#define get_ISO_CEC_RTCR0_reg   (*((volatile unsigned int*) ISO_CEC_RTCR0_reg))
+#define ISO_CEC_RTCR0_inst_adr                                                       "0x0041"
+#define ISO_CEC_RTCR0_inst                                                           0x0041
+#define ISO_CEC_RTCR0_cec_pad_in_shift                                               (31)
+#define ISO_CEC_RTCR0_cec_pad_in_mask                                                (0x80000000)
+#define ISO_CEC_RTCR0_cec_pad_in(data)                                               (0x80000000&((data)<<31))
+#define ISO_CEC_RTCR0_cec_pad_in_src(data)                                           ((0x80000000&(data))>>31)
+#define ISO_CEC_RTCR0_get_cec_pad_in(data)                                           ((0x80000000&(data))>>31)
+#define ISO_CEC_RTCR0_dummy0_shift                                                   (28)
+#define ISO_CEC_RTCR0_dummy0_mask                                                    (0x70000000)
+#define ISO_CEC_RTCR0_dummy0(data)                                                   (0x70000000&((data)<<28))
+#define ISO_CEC_RTCR0_dummy0_src(data)                                               ((0x70000000&(data))>>28)
+#define ISO_CEC_RTCR0_get_dummy0(data)                                               ((0x70000000&(data))>>28)
+#define ISO_CEC_RTCR0_logical_addr3_shift                                            (24)
+#define ISO_CEC_RTCR0_logical_addr3_mask                                             (0x0F000000)
+#define ISO_CEC_RTCR0_logical_addr3(data)                                            (0x0F000000&((data)<<24))
+#define ISO_CEC_RTCR0_logical_addr3_src(data)                                        ((0x0F000000&(data))>>24)
+#define ISO_CEC_RTCR0_get_logical_addr3(data)                                        ((0x0F000000&(data))>>24)
+#define ISO_CEC_RTCR0_logical_addr2_shift                                            (20)
+#define ISO_CEC_RTCR0_logical_addr2_mask                                             (0x00F00000)
+#define ISO_CEC_RTCR0_logical_addr2(data)                                            (0x00F00000&((data)<<20))
+#define ISO_CEC_RTCR0_logical_addr2_src(data)                                        ((0x00F00000&(data))>>20)
+#define ISO_CEC_RTCR0_get_logical_addr2(data)                                        ((0x00F00000&(data))>>20)
+#define ISO_CEC_RTCR0_logical_addr1_shift                                            (16)
+#define ISO_CEC_RTCR0_logical_addr1_mask                                             (0x000F0000)
+#define ISO_CEC_RTCR0_logical_addr1(data)                                            (0x000F0000&((data)<<16))
+#define ISO_CEC_RTCR0_logical_addr1_src(data)                                        ((0x000F0000&(data))>>16)
+#define ISO_CEC_RTCR0_get_logical_addr1(data)                                        ((0x000F0000&(data))>>16)
+#define ISO_CEC_RTCR0_dummy1_shift                                                   (12)
+#define ISO_CEC_RTCR0_dummy1_mask                                                    (0x0000F000)
+#define ISO_CEC_RTCR0_dummy1(data)                                                   (0x0000F000&((data)<<12))
+#define ISO_CEC_RTCR0_dummy1_src(data)                                               ((0x0000F000&(data))>>12)
+#define ISO_CEC_RTCR0_get_dummy1(data)                                               ((0x0000F000&(data))>>12)
+#define ISO_CEC_RTCR0_clear_cec_int_shift                                            (11)
+#define ISO_CEC_RTCR0_clear_cec_int_mask                                             (0x00000800)
+#define ISO_CEC_RTCR0_clear_cec_int(data)                                            (0x00000800&((data)<<11))
+#define ISO_CEC_RTCR0_clear_cec_int_src(data)                                        ((0x00000800&(data))>>11)
+#define ISO_CEC_RTCR0_get_clear_cec_int(data)                                        ((0x00000800&(data))>>11)
+#define ISO_CEC_RTCR0_wt_cnt_shift                                                   (5)
+#define ISO_CEC_RTCR0_wt_cnt_mask                                                    (0x000007E0)
+#define ISO_CEC_RTCR0_wt_cnt(data)                                                   (0x000007E0&((data)<<5))
+#define ISO_CEC_RTCR0_wt_cnt_src(data)                                               ((0x000007E0&(data))>>5)
+#define ISO_CEC_RTCR0_get_wt_cnt(data)                                               ((0x000007E0&(data))>>5)
+#define ISO_CEC_RTCR0_lattest_shift                                                  (4)
+#define ISO_CEC_RTCR0_lattest_mask                                                   (0x00000010)
+#define ISO_CEC_RTCR0_lattest(data)                                                  (0x00000010&((data)<<4))
+#define ISO_CEC_RTCR0_lattest_src(data)                                              ((0x00000010&(data))>>4)
+#define ISO_CEC_RTCR0_get_lattest(data)                                              ((0x00000010&(data))>>4)
+#define ISO_CEC_RTCR0_retry_no_shift                                                 (0)
+#define ISO_CEC_RTCR0_retry_no_mask                                                  (0x0000000F)
+#define ISO_CEC_RTCR0_retry_no(data)                                                 (0x0000000F&((data)<<0))
+#define ISO_CEC_RTCR0_retry_no_src(data)                                             ((0x0000000F&(data))>>0)
+#define ISO_CEC_RTCR0_get_retry_no(data)                                             ((0x0000000F&(data))>>0)
+
+
+#define ISO_CEC_RXCR0                                                                0x18007508
+#define ISO_CEC_RXCR0_reg_addr                                                       "0xB8007508"
+#define ISO_CEC_RXCR0_reg                                                            0xB8007508
+#define set_ISO_CEC_RXCR0_reg(data)   (*((volatile unsigned int*) ISO_CEC_RXCR0_reg)=data)
+#define get_ISO_CEC_RXCR0_reg   (*((volatile unsigned int*) ISO_CEC_RXCR0_reg))
+#define ISO_CEC_RXCR0_inst_adr                                                       "0x0042"
+#define ISO_CEC_RXCR0_inst                                                           0x0042
+#define ISO_CEC_RXCR0_broadcast_addr_shift                                           (31)
+#define ISO_CEC_RXCR0_broadcast_addr_mask                                            (0x80000000)
+#define ISO_CEC_RXCR0_broadcast_addr(data)                                           (0x80000000&((data)<<31))
+#define ISO_CEC_RXCR0_broadcast_addr_src(data)                                       ((0x80000000&(data))>>31)
+#define ISO_CEC_RXCR0_get_broadcast_addr(data)                                       ((0x80000000&(data))>>31)
+#define ISO_CEC_RXCR0_dest_addr_shift                                                (16)
+#define ISO_CEC_RXCR0_dest_addr_mask                                                 (0x000F0000)
+#define ISO_CEC_RXCR0_dest_addr(data)                                                (0x000F0000&((data)<<16))
+#define ISO_CEC_RXCR0_dest_addr_src(data)                                            ((0x000F0000&(data))>>16)
+#define ISO_CEC_RXCR0_get_dest_addr(data)                                            ((0x000F0000&(data))>>16)
+#define ISO_CEC_RXCR0_rx_en_shift                                                    (15)
+#define ISO_CEC_RXCR0_rx_en_mask                                                     (0x00008000)
+#define ISO_CEC_RXCR0_rx_en(data)                                                    (0x00008000&((data)<<15))
+#define ISO_CEC_RXCR0_rx_en_src(data)                                                ((0x00008000&(data))>>15)
+#define ISO_CEC_RXCR0_get_rx_en(data)                                                ((0x00008000&(data))>>15)
+#define ISO_CEC_RXCR0_rx_rst_shift                                                   (14)
+#define ISO_CEC_RXCR0_rx_rst_mask                                                    (0x00004000)
+#define ISO_CEC_RXCR0_rx_rst(data)                                                   (0x00004000&((data)<<14))
+#define ISO_CEC_RXCR0_rx_rst_src(data)                                               ((0x00004000&(data))>>14)
+#define ISO_CEC_RXCR0_get_rx_rst(data)                                               ((0x00004000&(data))>>14)
+#define ISO_CEC_RXCR0_rx_continuous_shift                                            (13)
+#define ISO_CEC_RXCR0_rx_continuous_mask                                             (0x00002000)
+#define ISO_CEC_RXCR0_rx_continuous(data)                                            (0x00002000&((data)<<13))
+#define ISO_CEC_RXCR0_rx_continuous_src(data)                                        ((0x00002000&(data))>>13)
+#define ISO_CEC_RXCR0_get_rx_continuous(data)                                        ((0x00002000&(data))>>13)
+#define ISO_CEC_RXCR0_rx_int_en_shift                                                (12)
+#define ISO_CEC_RXCR0_rx_int_en_mask                                                 (0x00001000)
+#define ISO_CEC_RXCR0_rx_int_en(data)                                                (0x00001000&((data)<<12))
+#define ISO_CEC_RXCR0_rx_int_en_src(data)                                            ((0x00001000&(data))>>12)
+#define ISO_CEC_RXCR0_get_rx_int_en(data)                                            ((0x00001000&(data))>>12)
+#define ISO_CEC_RXCR0_init_addr_shift                                                (8)
+#define ISO_CEC_RXCR0_init_addr_mask                                                 (0x00000F00)
+#define ISO_CEC_RXCR0_init_addr(data)                                                (0x00000F00&((data)<<8))
+#define ISO_CEC_RXCR0_init_addr_src(data)                                            ((0x00000F00&(data))>>8)
+#define ISO_CEC_RXCR0_get_init_addr(data)                                            ((0x00000F00&(data))>>8)
+#define ISO_CEC_RXCR0_rx_eom_shift                                                   (7)
+#define ISO_CEC_RXCR0_rx_eom_mask                                                    (0x00000080)
+#define ISO_CEC_RXCR0_rx_eom(data)                                                   (0x00000080&((data)<<7))
+#define ISO_CEC_RXCR0_rx_eom_src(data)                                               ((0x00000080&(data))>>7)
+#define ISO_CEC_RXCR0_get_rx_eom(data)                                               ((0x00000080&(data))>>7)
+#define ISO_CEC_RXCR0_rx_int_shift                                                   (6)
+#define ISO_CEC_RXCR0_rx_int_mask                                                    (0x00000040)
+#define ISO_CEC_RXCR0_rx_int(data)                                                   (0x00000040&((data)<<6))
+#define ISO_CEC_RXCR0_rx_int_src(data)                                               ((0x00000040&(data))>>6)
+#define ISO_CEC_RXCR0_get_rx_int(data)                                               ((0x00000040&(data))>>6)
+#define ISO_CEC_RXCR0_rx_fifo_ov_shift                                               (5)
+#define ISO_CEC_RXCR0_rx_fifo_ov_mask                                                (0x00000020)
+#define ISO_CEC_RXCR0_rx_fifo_ov(data)                                               (0x00000020&((data)<<5))
+#define ISO_CEC_RXCR0_rx_fifo_ov_src(data)                                           ((0x00000020&(data))>>5)
+#define ISO_CEC_RXCR0_get_rx_fifo_ov(data)                                           ((0x00000020&(data))>>5)
+#define ISO_CEC_RXCR0_rx_fifo_cnt_shift                                              (0)
+#define ISO_CEC_RXCR0_rx_fifo_cnt_mask                                               (0x0000001F)
+#define ISO_CEC_RXCR0_rx_fifo_cnt(data)                                              (0x0000001F&((data)<<0))
+#define ISO_CEC_RXCR0_rx_fifo_cnt_src(data)                                          ((0x0000001F&(data))>>0)
+#define ISO_CEC_RXCR0_get_rx_fifo_cnt(data)                                          ((0x0000001F&(data))>>0)
+
+
+#define ISO_CEC_TXCR0                                                                0x1800750C
+#define ISO_CEC_TXCR0_reg_addr                                                       "0xB800750C"
+#define ISO_CEC_TXCR0_reg                                                            0xB800750C
+#define set_ISO_CEC_TXCR0_reg(data)   (*((volatile unsigned int*) ISO_CEC_TXCR0_reg)=data)
+#define get_ISO_CEC_TXCR0_reg   (*((volatile unsigned int*) ISO_CEC_TXCR0_reg))
+#define ISO_CEC_TXCR0_inst_adr                                                       "0x0043"
+#define ISO_CEC_TXCR0_inst                                                           0x0043
+#define ISO_CEC_TXCR0_tx_addr_en_shift                                               (20)
+#define ISO_CEC_TXCR0_tx_addr_en_mask                                                (0x00100000)
+#define ISO_CEC_TXCR0_tx_addr_en(data)                                               (0x00100000&((data)<<20))
+#define ISO_CEC_TXCR0_tx_addr_en_src(data)                                           ((0x00100000&(data))>>20)
+#define ISO_CEC_TXCR0_get_tx_addr_en(data)                                           ((0x00100000&(data))>>20)
+#define ISO_CEC_TXCR0_tx_addr_shift                                                  (16)
+#define ISO_CEC_TXCR0_tx_addr_mask                                                   (0x000F0000)
+#define ISO_CEC_TXCR0_tx_addr(data)                                                  (0x000F0000&((data)<<16))
+#define ISO_CEC_TXCR0_tx_addr_src(data)                                              ((0x000F0000&(data))>>16)
+#define ISO_CEC_TXCR0_get_tx_addr(data)                                              ((0x000F0000&(data))>>16)
+#define ISO_CEC_TXCR0_tx_en_shift                                                    (15)
+#define ISO_CEC_TXCR0_tx_en_mask                                                     (0x00008000)
+#define ISO_CEC_TXCR0_tx_en(data)                                                    (0x00008000&((data)<<15))
+#define ISO_CEC_TXCR0_tx_en_src(data)                                                ((0x00008000&(data))>>15)
+#define ISO_CEC_TXCR0_get_tx_en(data)                                                ((0x00008000&(data))>>15)
+#define ISO_CEC_TXCR0_tx_rst_shift                                                   (14)
+#define ISO_CEC_TXCR0_tx_rst_mask                                                    (0x00004000)
+#define ISO_CEC_TXCR0_tx_rst(data)                                                   (0x00004000&((data)<<14))
+#define ISO_CEC_TXCR0_tx_rst_src(data)                                               ((0x00004000&(data))>>14)
+#define ISO_CEC_TXCR0_get_tx_rst(data)                                               ((0x00004000&(data))>>14)
+#define ISO_CEC_TXCR0_tx_continuous_shift                                            (13)
+#define ISO_CEC_TXCR0_tx_continuous_mask                                             (0x00002000)
+#define ISO_CEC_TXCR0_tx_continuous(data)                                            (0x00002000&((data)<<13))
+#define ISO_CEC_TXCR0_tx_continuous_src(data)                                        ((0x00002000&(data))>>13)
+#define ISO_CEC_TXCR0_get_tx_continuous(data)                                        ((0x00002000&(data))>>13)
+#define ISO_CEC_TXCR0_tx_int_en_shift                                                (12)
+#define ISO_CEC_TXCR0_tx_int_en_mask                                                 (0x00001000)
+#define ISO_CEC_TXCR0_tx_int_en(data)                                                (0x00001000&((data)<<12))
+#define ISO_CEC_TXCR0_tx_int_en_src(data)                                            ((0x00001000&(data))>>12)
+#define ISO_CEC_TXCR0_get_tx_int_en(data)                                            ((0x00001000&(data))>>12)
+#define ISO_CEC_TXCR0_dest_addr_shift                                                (8)
+#define ISO_CEC_TXCR0_dest_addr_mask                                                 (0x00000F00)
+#define ISO_CEC_TXCR0_dest_addr(data)                                                (0x00000F00&((data)<<8))
+#define ISO_CEC_TXCR0_dest_addr_src(data)                                            ((0x00000F00&(data))>>8)
+#define ISO_CEC_TXCR0_get_dest_addr(data)                                            ((0x00000F00&(data))>>8)
+#define ISO_CEC_TXCR0_tx_eom_shift                                                   (7)
+#define ISO_CEC_TXCR0_tx_eom_mask                                                    (0x00000080)
+#define ISO_CEC_TXCR0_tx_eom(data)                                                   (0x00000080&((data)<<7))
+#define ISO_CEC_TXCR0_tx_eom_src(data)                                               ((0x00000080&(data))>>7)
+#define ISO_CEC_TXCR0_get_tx_eom(data)                                               ((0x00000080&(data))>>7)
+#define ISO_CEC_TXCR0_tx_int_shift                                                   (6)
+#define ISO_CEC_TXCR0_tx_int_mask                                                    (0x00000040)
+#define ISO_CEC_TXCR0_tx_int(data)                                                   (0x00000040&((data)<<6))
+#define ISO_CEC_TXCR0_tx_int_src(data)                                               ((0x00000040&(data))>>6)
+#define ISO_CEC_TXCR0_get_tx_int(data)                                               ((0x00000040&(data))>>6)
+#define ISO_CEC_TXCR0_tx_fifo_ud_shift                                               (5)
+#define ISO_CEC_TXCR0_tx_fifo_ud_mask                                                (0x00000020)
+#define ISO_CEC_TXCR0_tx_fifo_ud(data)                                               (0x00000020&((data)<<5))
+#define ISO_CEC_TXCR0_tx_fifo_ud_src(data)                                           ((0x00000020&(data))>>5)
+#define ISO_CEC_TXCR0_get_tx_fifo_ud(data)                                           ((0x00000020&(data))>>5)
+#define ISO_CEC_TXCR0_tx_fifo_cnt_shift                                              (0)
+#define ISO_CEC_TXCR0_tx_fifo_cnt_mask                                               (0x0000001F)
+#define ISO_CEC_TXCR0_tx_fifo_cnt(data)                                              (0x0000001F&((data)<<0))
+#define ISO_CEC_TXCR0_tx_fifo_cnt_src(data)                                          ((0x0000001F&(data))>>0)
+#define ISO_CEC_TXCR0_get_tx_fifo_cnt(data)                                          ((0x0000001F&(data))>>0)
+
+
+#define ISO_CEC_TXDR0                                                                0x18007510
+#define ISO_CEC_TXDR0_reg_addr                                                       "0xB8007510"
+#define ISO_CEC_TXDR0_reg                                                            0xB8007510
+#define set_ISO_CEC_TXDR0_reg(data)   (*((volatile unsigned int*) ISO_CEC_TXDR0_reg)=data)
+#define get_ISO_CEC_TXDR0_reg   (*((volatile unsigned int*) ISO_CEC_TXDR0_reg))
+#define ISO_CEC_TXDR0_inst_adr                                                       "0x0044"
+#define ISO_CEC_TXDR0_inst                                                           0x0044
+#define ISO_CEC_TXDR0_tx_add_cnt_shift                                               (6)
+#define ISO_CEC_TXDR0_tx_add_cnt_mask                                                (0x00000040)
+#define ISO_CEC_TXDR0_tx_add_cnt(data)                                               (0x00000040&((data)<<6))
+#define ISO_CEC_TXDR0_tx_add_cnt_src(data)                                           ((0x00000040&(data))>>6)
+#define ISO_CEC_TXDR0_get_tx_add_cnt(data)                                           ((0x00000040&(data))>>6)
+#define ISO_CEC_TXDR0_rx_sub_cnt_shift                                               (5)
+#define ISO_CEC_TXDR0_rx_sub_cnt_mask                                                (0x00000020)
+#define ISO_CEC_TXDR0_rx_sub_cnt(data)                                               (0x00000020&((data)<<5))
+#define ISO_CEC_TXDR0_rx_sub_cnt_src(data)                                           ((0x00000020&(data))>>5)
+#define ISO_CEC_TXDR0_get_rx_sub_cnt(data)                                           ((0x00000020&(data))>>5)
+#define ISO_CEC_TXDR0_fifo_cnt_shift                                                 (0)
+#define ISO_CEC_TXDR0_fifo_cnt_mask                                                  (0x0000001F)
+#define ISO_CEC_TXDR0_fifo_cnt(data)                                                 (0x0000001F&((data)<<0))
+#define ISO_CEC_TXDR0_fifo_cnt_src(data)                                             ((0x0000001F&(data))>>0)
+#define ISO_CEC_TXDR0_get_fifo_cnt(data)                                             ((0x0000001F&(data))>>0)
+
+
+#define ISO_CEC_TXDR1                                                                0x18007514
+#define ISO_CEC_TXDR1_reg_addr                                                       "0xB8007514"
+#define ISO_CEC_TXDR1_reg                                                            0xB8007514
+#define set_ISO_CEC_TXDR1_reg(data)   (*((volatile unsigned int*) ISO_CEC_TXDR1_reg)=data)
+#define get_ISO_CEC_TXDR1_reg   (*((volatile unsigned int*) ISO_CEC_TXDR1_reg))
+#define ISO_CEC_TXDR1_inst_adr                                                       "0x0045"
+#define ISO_CEC_TXDR1_inst                                                           0x0045
+#define ISO_CEC_TXDR1_tx_fifo_0_shift                                                (24)
+#define ISO_CEC_TXDR1_tx_fifo_0_mask                                                 (0xFF000000)
+#define ISO_CEC_TXDR1_tx_fifo_0(data)                                                (0xFF000000&((data)<<24))
+#define ISO_CEC_TXDR1_tx_fifo_0_src(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_TXDR1_get_tx_fifo_0(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_TXDR1_tx_fifo_1_shift                                                (16)
+#define ISO_CEC_TXDR1_tx_fifo_1_mask                                                 (0x00FF0000)
+#define ISO_CEC_TXDR1_tx_fifo_1(data)                                                (0x00FF0000&((data)<<16))
+#define ISO_CEC_TXDR1_tx_fifo_1_src(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_TXDR1_get_tx_fifo_1(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_TXDR1_tx_fifo_2_shift                                                (8)
+#define ISO_CEC_TXDR1_tx_fifo_2_mask                                                 (0x0000FF00)
+#define ISO_CEC_TXDR1_tx_fifo_2(data)                                                (0x0000FF00&((data)<<8))
+#define ISO_CEC_TXDR1_tx_fifo_2_src(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXDR1_get_tx_fifo_2(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXDR1_tx_fifo_3_shift                                                (0)
+#define ISO_CEC_TXDR1_tx_fifo_3_mask                                                 (0x000000FF)
+#define ISO_CEC_TXDR1_tx_fifo_3(data)                                                (0x000000FF&((data)<<0))
+#define ISO_CEC_TXDR1_tx_fifo_3_src(data)                                            ((0x000000FF&(data))>>0)
+#define ISO_CEC_TXDR1_get_tx_fifo_3(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define ISO_CEC_TXDR2                                                                0x18007518
+#define ISO_CEC_TXDR2_reg_addr                                                       "0xB8007518"
+#define ISO_CEC_TXDR2_reg                                                            0xB8007518
+#define set_ISO_CEC_TXDR2_reg(data)   (*((volatile unsigned int*) ISO_CEC_TXDR2_reg)=data)
+#define get_ISO_CEC_TXDR2_reg   (*((volatile unsigned int*) ISO_CEC_TXDR2_reg))
+#define ISO_CEC_TXDR2_inst_adr                                                       "0x0046"
+#define ISO_CEC_TXDR2_inst                                                           0x0046
+#define ISO_CEC_TXDR2_tx_fifo_4_shift                                                (24)
+#define ISO_CEC_TXDR2_tx_fifo_4_mask                                                 (0xFF000000)
+#define ISO_CEC_TXDR2_tx_fifo_4(data)                                                (0xFF000000&((data)<<24))
+#define ISO_CEC_TXDR2_tx_fifo_4_src(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_TXDR2_get_tx_fifo_4(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_TXDR2_tx_fifo_5_shift                                                (16)
+#define ISO_CEC_TXDR2_tx_fifo_5_mask                                                 (0x00FF0000)
+#define ISO_CEC_TXDR2_tx_fifo_5(data)                                                (0x00FF0000&((data)<<16))
+#define ISO_CEC_TXDR2_tx_fifo_5_src(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_TXDR2_get_tx_fifo_5(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_TXDR2_tx_fifo_6_shift                                                (8)
+#define ISO_CEC_TXDR2_tx_fifo_6_mask                                                 (0x0000FF00)
+#define ISO_CEC_TXDR2_tx_fifo_6(data)                                                (0x0000FF00&((data)<<8))
+#define ISO_CEC_TXDR2_tx_fifo_6_src(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXDR2_get_tx_fifo_6(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXDR2_tx_fifo_7_shift                                                (0)
+#define ISO_CEC_TXDR2_tx_fifo_7_mask                                                 (0x000000FF)
+#define ISO_CEC_TXDR2_tx_fifo_7(data)                                                (0x000000FF&((data)<<0))
+#define ISO_CEC_TXDR2_tx_fifo_7_src(data)                                            ((0x000000FF&(data))>>0)
+#define ISO_CEC_TXDR2_get_tx_fifo_7(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define ISO_CEC_TXDR3                                                                0x1800751C
+#define ISO_CEC_TXDR3_reg_addr                                                       "0xB800751C"
+#define ISO_CEC_TXDR3_reg                                                            0xB800751C
+#define set_ISO_CEC_TXDR3_reg(data)   (*((volatile unsigned int*) ISO_CEC_TXDR3_reg)=data)
+#define get_ISO_CEC_TXDR3_reg   (*((volatile unsigned int*) ISO_CEC_TXDR3_reg))
+#define ISO_CEC_TXDR3_inst_adr                                                       "0x0047"
+#define ISO_CEC_TXDR3_inst                                                           0x0047
+#define ISO_CEC_TXDR3_tx_fifo_8_shift                                                (24)
+#define ISO_CEC_TXDR3_tx_fifo_8_mask                                                 (0xFF000000)
+#define ISO_CEC_TXDR3_tx_fifo_8(data)                                                (0xFF000000&((data)<<24))
+#define ISO_CEC_TXDR3_tx_fifo_8_src(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_TXDR3_get_tx_fifo_8(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_TXDR3_tx_fifo_9_shift                                                (16)
+#define ISO_CEC_TXDR3_tx_fifo_9_mask                                                 (0x00FF0000)
+#define ISO_CEC_TXDR3_tx_fifo_9(data)                                                (0x00FF0000&((data)<<16))
+#define ISO_CEC_TXDR3_tx_fifo_9_src(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_TXDR3_get_tx_fifo_9(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_TXDR3_tx_fifo_a_shift                                                (8)
+#define ISO_CEC_TXDR3_tx_fifo_a_mask                                                 (0x0000FF00)
+#define ISO_CEC_TXDR3_tx_fifo_a(data)                                                (0x0000FF00&((data)<<8))
+#define ISO_CEC_TXDR3_tx_fifo_a_src(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXDR3_get_tx_fifo_a(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXDR3_tx_fifo_b_shift                                                (0)
+#define ISO_CEC_TXDR3_tx_fifo_b_mask                                                 (0x000000FF)
+#define ISO_CEC_TXDR3_tx_fifo_b(data)                                                (0x000000FF&((data)<<0))
+#define ISO_CEC_TXDR3_tx_fifo_b_src(data)                                            ((0x000000FF&(data))>>0)
+#define ISO_CEC_TXDR3_get_tx_fifo_b(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define ISO_CEC_TXDR4                                                                0x18007520
+#define ISO_CEC_TXDR4_reg_addr                                                       "0xB8007520"
+#define ISO_CEC_TXDR4_reg                                                            0xB8007520
+#define set_ISO_CEC_TXDR4_reg(data)   (*((volatile unsigned int*) ISO_CEC_TXDR4_reg)=data)
+#define get_ISO_CEC_TXDR4_reg   (*((volatile unsigned int*) ISO_CEC_TXDR4_reg))
+#define ISO_CEC_TXDR4_inst_adr                                                       "0x0048"
+#define ISO_CEC_TXDR4_inst                                                           0x0048
+#define ISO_CEC_TXDR4_tx_fifo_c_shift                                                (24)
+#define ISO_CEC_TXDR4_tx_fifo_c_mask                                                 (0xFF000000)
+#define ISO_CEC_TXDR4_tx_fifo_c(data)                                                (0xFF000000&((data)<<24))
+#define ISO_CEC_TXDR4_tx_fifo_c_src(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_TXDR4_get_tx_fifo_c(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_TXDR4_tx_fifo_d_shift                                                (16)
+#define ISO_CEC_TXDR4_tx_fifo_d_mask                                                 (0x00FF0000)
+#define ISO_CEC_TXDR4_tx_fifo_d(data)                                                (0x00FF0000&((data)<<16))
+#define ISO_CEC_TXDR4_tx_fifo_d_src(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_TXDR4_get_tx_fifo_d(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_TXDR4_tx_fifo_e_shift                                                (8)
+#define ISO_CEC_TXDR4_tx_fifo_e_mask                                                 (0x0000FF00)
+#define ISO_CEC_TXDR4_tx_fifo_e(data)                                                (0x0000FF00&((data)<<8))
+#define ISO_CEC_TXDR4_tx_fifo_e_src(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXDR4_get_tx_fifo_e(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXDR4_tx_fifo_f_shift                                                (0)
+#define ISO_CEC_TXDR4_tx_fifo_f_mask                                                 (0x000000FF)
+#define ISO_CEC_TXDR4_tx_fifo_f(data)                                                (0x000000FF&((data)<<0))
+#define ISO_CEC_TXDR4_tx_fifo_f_src(data)                                            ((0x000000FF&(data))>>0)
+#define ISO_CEC_TXDR4_get_tx_fifo_f(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define ISO_CEC_RXDR1                                                                0x18007524
+#define ISO_CEC_RXDR1_reg_addr                                                       "0xB8007524"
+#define ISO_CEC_RXDR1_reg                                                            0xB8007524
+#define set_ISO_CEC_RXDR1_reg(data)   (*((volatile unsigned int*) ISO_CEC_RXDR1_reg)=data)
+#define get_ISO_CEC_RXDR1_reg   (*((volatile unsigned int*) ISO_CEC_RXDR1_reg))
+#define ISO_CEC_RXDR1_inst_adr                                                       "0x0049"
+#define ISO_CEC_RXDR1_inst                                                           0x0049
+#define ISO_CEC_RXDR1_rx_fifo_0_shift                                                (24)
+#define ISO_CEC_RXDR1_rx_fifo_0_mask                                                 (0xFF000000)
+#define ISO_CEC_RXDR1_rx_fifo_0(data)                                                (0xFF000000&((data)<<24))
+#define ISO_CEC_RXDR1_rx_fifo_0_src(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_RXDR1_get_rx_fifo_0(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_RXDR1_rx_fifo_1_shift                                                (16)
+#define ISO_CEC_RXDR1_rx_fifo_1_mask                                                 (0x00FF0000)
+#define ISO_CEC_RXDR1_rx_fifo_1(data)                                                (0x00FF0000&((data)<<16))
+#define ISO_CEC_RXDR1_rx_fifo_1_src(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_RXDR1_get_rx_fifo_1(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_RXDR1_rx_fifo_2_shift                                                (8)
+#define ISO_CEC_RXDR1_rx_fifo_2_mask                                                 (0x0000FF00)
+#define ISO_CEC_RXDR1_rx_fifo_2(data)                                                (0x0000FF00&((data)<<8))
+#define ISO_CEC_RXDR1_rx_fifo_2_src(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_RXDR1_get_rx_fifo_2(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_RXDR1_rx_fifo_3_shift                                                (0)
+#define ISO_CEC_RXDR1_rx_fifo_3_mask                                                 (0x000000FF)
+#define ISO_CEC_RXDR1_rx_fifo_3(data)                                                (0x000000FF&((data)<<0))
+#define ISO_CEC_RXDR1_rx_fifo_3_src(data)                                            ((0x000000FF&(data))>>0)
+#define ISO_CEC_RXDR1_get_rx_fifo_3(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define ISO_CEC_RXDR2                                                                0x18007528
+#define ISO_CEC_RXDR2_reg_addr                                                       "0xB8007528"
+#define ISO_CEC_RXDR2_reg                                                            0xB8007528
+#define set_ISO_CEC_RXDR2_reg(data)   (*((volatile unsigned int*) ISO_CEC_RXDR2_reg)=data)
+#define get_ISO_CEC_RXDR2_reg   (*((volatile unsigned int*) ISO_CEC_RXDR2_reg))
+#define ISO_CEC_RXDR2_inst_adr                                                       "0x004A"
+#define ISO_CEC_RXDR2_inst                                                           0x004A
+#define ISO_CEC_RXDR2_rx_fifo_4_shift                                                (24)
+#define ISO_CEC_RXDR2_rx_fifo_4_mask                                                 (0xFF000000)
+#define ISO_CEC_RXDR2_rx_fifo_4(data)                                                (0xFF000000&((data)<<24))
+#define ISO_CEC_RXDR2_rx_fifo_4_src(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_RXDR2_get_rx_fifo_4(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_RXDR2_rx_fifo_5_shift                                                (16)
+#define ISO_CEC_RXDR2_rx_fifo_5_mask                                                 (0x00FF0000)
+#define ISO_CEC_RXDR2_rx_fifo_5(data)                                                (0x00FF0000&((data)<<16))
+#define ISO_CEC_RXDR2_rx_fifo_5_src(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_RXDR2_get_rx_fifo_5(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_RXDR2_rx_fifo_6_shift                                                (8)
+#define ISO_CEC_RXDR2_rx_fifo_6_mask                                                 (0x0000FF00)
+#define ISO_CEC_RXDR2_rx_fifo_6(data)                                                (0x0000FF00&((data)<<8))
+#define ISO_CEC_RXDR2_rx_fifo_6_src(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_RXDR2_get_rx_fifo_6(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_RXDR2_rx_fifo_7_shift                                                (0)
+#define ISO_CEC_RXDR2_rx_fifo_7_mask                                                 (0x000000FF)
+#define ISO_CEC_RXDR2_rx_fifo_7(data)                                                (0x000000FF&((data)<<0))
+#define ISO_CEC_RXDR2_rx_fifo_7_src(data)                                            ((0x000000FF&(data))>>0)
+#define ISO_CEC_RXDR2_get_rx_fifo_7(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define ISO_CEC_RXDR3                                                                0x1800752C
+#define ISO_CEC_RXDR3_reg_addr                                                       "0xB800752C"
+#define ISO_CEC_RXDR3_reg                                                            0xB800752C
+#define set_ISO_CEC_RXDR3_reg(data)   (*((volatile unsigned int*) ISO_CEC_RXDR3_reg)=data)
+#define get_ISO_CEC_RXDR3_reg   (*((volatile unsigned int*) ISO_CEC_RXDR3_reg))
+#define ISO_CEC_RXDR3_inst_adr                                                       "0x004B"
+#define ISO_CEC_RXDR3_inst                                                           0x004B
+#define ISO_CEC_RXDR3_rx_fifo_8_shift                                                (24)
+#define ISO_CEC_RXDR3_rx_fifo_8_mask                                                 (0xFF000000)
+#define ISO_CEC_RXDR3_rx_fifo_8(data)                                                (0xFF000000&((data)<<24))
+#define ISO_CEC_RXDR3_rx_fifo_8_src(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_RXDR3_get_rx_fifo_8(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_RXDR3_rx_fifo_9_shift                                                (16)
+#define ISO_CEC_RXDR3_rx_fifo_9_mask                                                 (0x00FF0000)
+#define ISO_CEC_RXDR3_rx_fifo_9(data)                                                (0x00FF0000&((data)<<16))
+#define ISO_CEC_RXDR3_rx_fifo_9_src(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_RXDR3_get_rx_fifo_9(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_RXDR3_rx_fifo_a_shift                                                (8)
+#define ISO_CEC_RXDR3_rx_fifo_a_mask                                                 (0x0000FF00)
+#define ISO_CEC_RXDR3_rx_fifo_a(data)                                                (0x0000FF00&((data)<<8))
+#define ISO_CEC_RXDR3_rx_fifo_a_src(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_RXDR3_get_rx_fifo_a(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_RXDR3_rx_fifo_b_shift                                                (0)
+#define ISO_CEC_RXDR3_rx_fifo_b_mask                                                 (0x000000FF)
+#define ISO_CEC_RXDR3_rx_fifo_b(data)                                                (0x000000FF&((data)<<0))
+#define ISO_CEC_RXDR3_rx_fifo_b_src(data)                                            ((0x000000FF&(data))>>0)
+#define ISO_CEC_RXDR3_get_rx_fifo_b(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define ISO_CEC_RXDR4                                                                0x18007530
+#define ISO_CEC_RXDR4_reg_addr                                                       "0xB8007530"
+#define ISO_CEC_RXDR4_reg                                                            0xB8007530
+#define set_ISO_CEC_RXDR4_reg(data)   (*((volatile unsigned int*) ISO_CEC_RXDR4_reg)=data)
+#define get_ISO_CEC_RXDR4_reg   (*((volatile unsigned int*) ISO_CEC_RXDR4_reg))
+#define ISO_CEC_RXDR4_inst_adr                                                       "0x004C"
+#define ISO_CEC_RXDR4_inst                                                           0x004C
+#define ISO_CEC_RXDR4_rx_fifo_c_shift                                                (24)
+#define ISO_CEC_RXDR4_rx_fifo_c_mask                                                 (0xFF000000)
+#define ISO_CEC_RXDR4_rx_fifo_c(data)                                                (0xFF000000&((data)<<24))
+#define ISO_CEC_RXDR4_rx_fifo_c_src(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_RXDR4_get_rx_fifo_c(data)                                            ((0xFF000000&(data))>>24)
+#define ISO_CEC_RXDR4_rx_fifo_d_shift                                                (16)
+#define ISO_CEC_RXDR4_rx_fifo_d_mask                                                 (0x00FF0000)
+#define ISO_CEC_RXDR4_rx_fifo_d(data)                                                (0x00FF0000&((data)<<16))
+#define ISO_CEC_RXDR4_rx_fifo_d_src(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_RXDR4_get_rx_fifo_d(data)                                            ((0x00FF0000&(data))>>16)
+#define ISO_CEC_RXDR4_rx_fifo_e_shift                                                (8)
+#define ISO_CEC_RXDR4_rx_fifo_e_mask                                                 (0x0000FF00)
+#define ISO_CEC_RXDR4_rx_fifo_e(data)                                                (0x0000FF00&((data)<<8))
+#define ISO_CEC_RXDR4_rx_fifo_e_src(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_RXDR4_get_rx_fifo_e(data)                                            ((0x0000FF00&(data))>>8)
+#define ISO_CEC_RXDR4_rx_fifo_f_shift                                                (0)
+#define ISO_CEC_RXDR4_rx_fifo_f_mask                                                 (0x000000FF)
+#define ISO_CEC_RXDR4_rx_fifo_f(data)                                                (0x000000FF&((data)<<0))
+#define ISO_CEC_RXDR4_rx_fifo_f_src(data)                                            ((0x000000FF&(data))>>0)
+#define ISO_CEC_RXDR4_get_rx_fifo_f(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define ISO_CEC_RXTCR0                                                               0x18007534
+#define ISO_CEC_RXTCR0_reg_addr                                                      "0xB8007534"
+#define ISO_CEC_RXTCR0_reg                                                           0xB8007534
+#define set_ISO_CEC_RXTCR0_reg(data)   (*((volatile unsigned int*) ISO_CEC_RXTCR0_reg)=data)
+#define get_ISO_CEC_RXTCR0_reg   (*((volatile unsigned int*) ISO_CEC_RXTCR0_reg))
+#define ISO_CEC_RXTCR0_inst_adr                                                      "0x004D"
+#define ISO_CEC_RXTCR0_inst                                                          0x004D
+#define ISO_CEC_RXTCR0_rx_start_low_shift                                            (24)
+#define ISO_CEC_RXTCR0_rx_start_low_mask                                             (0xFF000000)
+#define ISO_CEC_RXTCR0_rx_start_low(data)                                            (0xFF000000&((data)<<24))
+#define ISO_CEC_RXTCR0_rx_start_low_src(data)                                        ((0xFF000000&(data))>>24)
+#define ISO_CEC_RXTCR0_get_rx_start_low(data)                                        ((0xFF000000&(data))>>24)
+#define ISO_CEC_RXTCR0_rx_start_period_shift                                         (16)
+#define ISO_CEC_RXTCR0_rx_start_period_mask                                          (0x00FF0000)
+#define ISO_CEC_RXTCR0_rx_start_period(data)                                         (0x00FF0000&((data)<<16))
+#define ISO_CEC_RXTCR0_rx_start_period_src(data)                                     ((0x00FF0000&(data))>>16)
+#define ISO_CEC_RXTCR0_get_rx_start_period(data)                                     ((0x00FF0000&(data))>>16)
+#define ISO_CEC_RXTCR0_rx_data_sample_shift                                          (8)
+#define ISO_CEC_RXTCR0_rx_data_sample_mask                                           (0x0000FF00)
+#define ISO_CEC_RXTCR0_rx_data_sample(data)                                          (0x0000FF00&((data)<<8))
+#define ISO_CEC_RXTCR0_rx_data_sample_src(data)                                      ((0x0000FF00&(data))>>8)
+#define ISO_CEC_RXTCR0_get_rx_data_sample(data)                                      ((0x0000FF00&(data))>>8)
+#define ISO_CEC_RXTCR0_rx_data_period_shift                                          (0)
+#define ISO_CEC_RXTCR0_rx_data_period_mask                                           (0x000000FF)
+#define ISO_CEC_RXTCR0_rx_data_period(data)                                          (0x000000FF&((data)<<0))
+#define ISO_CEC_RXTCR0_rx_data_period_src(data)                                      ((0x000000FF&(data))>>0)
+#define ISO_CEC_RXTCR0_get_rx_data_period(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_CEC_TXTCR0                                                               0x18007538
+#define ISO_CEC_TXTCR0_reg_addr                                                      "0xB8007538"
+#define ISO_CEC_TXTCR0_reg                                                           0xB8007538
+#define set_ISO_CEC_TXTCR0_reg(data)   (*((volatile unsigned int*) ISO_CEC_TXTCR0_reg)=data)
+#define get_ISO_CEC_TXTCR0_reg   (*((volatile unsigned int*) ISO_CEC_TXTCR0_reg))
+#define ISO_CEC_TXTCR0_inst_adr                                                      "0x004E"
+#define ISO_CEC_TXTCR0_inst                                                          0x004E
+#define ISO_CEC_TXTCR0_tx_start_low_shift                                            (8)
+#define ISO_CEC_TXTCR0_tx_start_low_mask                                             (0x0000FF00)
+#define ISO_CEC_TXTCR0_tx_start_low(data)                                            (0x0000FF00&((data)<<8))
+#define ISO_CEC_TXTCR0_tx_start_low_src(data)                                        ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXTCR0_get_tx_start_low(data)                                        ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXTCR0_tx_start_high_shift                                           (0)
+#define ISO_CEC_TXTCR0_tx_start_high_mask                                            (0x000000FF)
+#define ISO_CEC_TXTCR0_tx_start_high(data)                                           (0x000000FF&((data)<<0))
+#define ISO_CEC_TXTCR0_tx_start_high_src(data)                                       ((0x000000FF&(data))>>0)
+#define ISO_CEC_TXTCR0_get_tx_start_high(data)                                       ((0x000000FF&(data))>>0)
+
+
+#define ISO_CEC_TXTCR1                                                               0x1800753C
+#define ISO_CEC_TXTCR1_reg_addr                                                      "0xB800753C"
+#define ISO_CEC_TXTCR1_reg                                                           0xB800753C
+#define set_ISO_CEC_TXTCR1_reg(data)   (*((volatile unsigned int*) ISO_CEC_TXTCR1_reg)=data)
+#define get_ISO_CEC_TXTCR1_reg   (*((volatile unsigned int*) ISO_CEC_TXTCR1_reg))
+#define ISO_CEC_TXTCR1_inst_adr                                                      "0x004F"
+#define ISO_CEC_TXTCR1_inst                                                          0x004F
+#define ISO_CEC_TXTCR1_tx_data_low_shift                                             (16)
+#define ISO_CEC_TXTCR1_tx_data_low_mask                                              (0x00FF0000)
+#define ISO_CEC_TXTCR1_tx_data_low(data)                                             (0x00FF0000&((data)<<16))
+#define ISO_CEC_TXTCR1_tx_data_low_src(data)                                         ((0x00FF0000&(data))>>16)
+#define ISO_CEC_TXTCR1_get_tx_data_low(data)                                         ((0x00FF0000&(data))>>16)
+#define ISO_CEC_TXTCR1_tx_data_01_shift                                              (8)
+#define ISO_CEC_TXTCR1_tx_data_01_mask                                               (0x0000FF00)
+#define ISO_CEC_TXTCR1_tx_data_01(data)                                              (0x0000FF00&((data)<<8))
+#define ISO_CEC_TXTCR1_tx_data_01_src(data)                                          ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXTCR1_get_tx_data_01(data)                                          ((0x0000FF00&(data))>>8)
+#define ISO_CEC_TXTCR1_tx_data_high_shift                                            (0)
+#define ISO_CEC_TXTCR1_tx_data_high_mask                                             (0x000000FF)
+#define ISO_CEC_TXTCR1_tx_data_high(data)                                            (0x000000FF&((data)<<0))
+#define ISO_CEC_TXTCR1_tx_data_high_src(data)                                        ((0x000000FF&(data))>>0)
+#define ISO_CEC_TXTCR1_get_tx_data_high(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_01                                                0x18007540
+#define ISO_GDI_CEC_COMPARE_OPCODE_01_reg_addr                                       "0xB8007540"
+#define ISO_GDI_CEC_COMPARE_OPCODE_01_reg                                            0xB8007540
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_01_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_01_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_01_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_01_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_01_inst_adr                                       "0x0050"
+#define ISO_GDI_CEC_COMPARE_OPCODE_01_inst                                           0x0050
+#define ISO_GDI_CEC_COMPARE_OPCODE_01_compare_opcode_01_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_01_compare_opcode_01_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_01_compare_opcode_01(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_01_compare_opcode_01_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_01_get_compare_opcode_01(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_SEND_OPCODE_01                                                   0x18007544
+#define ISO_GDI_CEC_SEND_OPCODE_01_reg_addr                                          "0xB8007544"
+#define ISO_GDI_CEC_SEND_OPCODE_01_reg                                               0xB8007544
+#define set_ISO_GDI_CEC_SEND_OPCODE_01_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPCODE_01_reg)=data)
+#define get_ISO_GDI_CEC_SEND_OPCODE_01_reg   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPCODE_01_reg))
+#define ISO_GDI_CEC_SEND_OPCODE_01_inst_adr                                          "0x0051"
+#define ISO_GDI_CEC_SEND_OPCODE_01_inst                                              0x0051
+#define ISO_GDI_CEC_SEND_OPCODE_01_send_opcode_01_shift                              (0)
+#define ISO_GDI_CEC_SEND_OPCODE_01_send_opcode_01_mask                               (0x000000FF)
+#define ISO_GDI_CEC_SEND_OPCODE_01_send_opcode_01(data)                              (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_SEND_OPCODE_01_send_opcode_01_src(data)                          ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_SEND_OPCODE_01_get_send_opcode_01(data)                          ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_01                                            0x18007548
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_reg_addr                                   "0xB8007548"
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_reg                                        0xB8007548
+#define set_ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_reg)=data)
+#define get_ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_reg   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_reg))
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_inst_adr                                   "0x0052"
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_inst                                       0x0052
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_operand_number_01_shift                    (0)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_operand_number_01_mask                     (0x00000003)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_operand_number_01(data)                    (0x00000003&((data)<<0))
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_operand_number_01_src(data)                ((0x00000003&(data))>>0)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_01_get_operand_number_01(data)                ((0x00000003&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_01                                                        0x1800754C
+#define ISO_GDI_CEC_OPRAND_01_reg_addr                                               "0xB800754C"
+#define ISO_GDI_CEC_OPRAND_01_reg                                                    0xB800754C
+#define set_ISO_GDI_CEC_OPRAND_01_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_01_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_01_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_01_reg))
+#define ISO_GDI_CEC_OPRAND_01_inst_adr                                               "0x0053"
+#define ISO_GDI_CEC_OPRAND_01_inst                                                   0x0053
+#define ISO_GDI_CEC_OPRAND_01_operand_01_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_01_operand_01_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_01_operand_01(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_01_operand_01_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_01_get_operand_01(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_02                                                        0x18007550
+#define ISO_GDI_CEC_OPRAND_02_reg_addr                                               "0xB8007550"
+#define ISO_GDI_CEC_OPRAND_02_reg                                                    0xB8007550
+#define set_ISO_GDI_CEC_OPRAND_02_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_02_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_02_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_02_reg))
+#define ISO_GDI_CEC_OPRAND_02_inst_adr                                               "0x0054"
+#define ISO_GDI_CEC_OPRAND_02_inst                                                   0x0054
+#define ISO_GDI_CEC_OPRAND_02_operand_02_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_02_operand_02_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_02_operand_02(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_02_operand_02_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_02_get_operand_02(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_03                                                        0x18007554
+#define ISO_GDI_CEC_OPRAND_03_reg_addr                                               "0xB8007554"
+#define ISO_GDI_CEC_OPRAND_03_reg                                                    0xB8007554
+#define set_ISO_GDI_CEC_OPRAND_03_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_03_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_03_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_03_reg))
+#define ISO_GDI_CEC_OPRAND_03_inst_adr                                               "0x0055"
+#define ISO_GDI_CEC_OPRAND_03_inst                                                   0x0055
+#define ISO_GDI_CEC_OPRAND_03_operand_03_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_03_operand_03_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_03_operand_03(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_03_operand_03_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_03_get_operand_03(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_02                                                0x18007558
+#define ISO_GDI_CEC_COMPARE_OPCODE_02_reg_addr                                       "0xB8007558"
+#define ISO_GDI_CEC_COMPARE_OPCODE_02_reg                                            0xB8007558
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_02_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_02_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_02_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_02_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_02_inst_adr                                       "0x0056"
+#define ISO_GDI_CEC_COMPARE_OPCODE_02_inst                                           0x0056
+#define ISO_GDI_CEC_COMPARE_OPCODE_02_compare_opcode_02_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_02_compare_opcode_02_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_02_compare_opcode_02(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_02_compare_opcode_02_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_02_get_compare_opcode_02(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_SEND_OPCODE_02                                                   0x1800755C
+#define ISO_GDI_CEC_SEND_OPCODE_02_reg_addr                                          "0xB800755C"
+#define ISO_GDI_CEC_SEND_OPCODE_02_reg                                               0xB800755C
+#define set_ISO_GDI_CEC_SEND_OPCODE_02_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPCODE_02_reg)=data)
+#define get_ISO_GDI_CEC_SEND_OPCODE_02_reg   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPCODE_02_reg))
+#define ISO_GDI_CEC_SEND_OPCODE_02_inst_adr                                          "0x0057"
+#define ISO_GDI_CEC_SEND_OPCODE_02_inst                                              0x0057
+#define ISO_GDI_CEC_SEND_OPCODE_02_send_opcode_02_shift                              (0)
+#define ISO_GDI_CEC_SEND_OPCODE_02_send_opcode_02_mask                               (0x000000FF)
+#define ISO_GDI_CEC_SEND_OPCODE_02_send_opcode_02(data)                              (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_SEND_OPCODE_02_send_opcode_02_src(data)                          ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_SEND_OPCODE_02_get_send_opcode_02(data)                          ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_02                                            0x18007560
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_reg_addr                                   "0xB8007560"
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_reg                                        0xB8007560
+#define set_ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_reg)=data)
+#define get_ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_reg   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_reg))
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_inst_adr                                   "0x0058"
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_inst                                       0x0058
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_operand_number_02_shift                    (0)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_operand_number_02_mask                     (0x00000003)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_operand_number_02(data)                    (0x00000003&((data)<<0))
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_operand_number_02_src(data)                ((0x00000003&(data))>>0)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_02_get_operand_number_02(data)                ((0x00000003&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_04                                                        0x18007564
+#define ISO_GDI_CEC_OPRAND_04_reg_addr                                               "0xB8007564"
+#define ISO_GDI_CEC_OPRAND_04_reg                                                    0xB8007564
+#define set_ISO_GDI_CEC_OPRAND_04_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_04_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_04_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_04_reg))
+#define ISO_GDI_CEC_OPRAND_04_inst_adr                                               "0x0059"
+#define ISO_GDI_CEC_OPRAND_04_inst                                                   0x0059
+#define ISO_GDI_CEC_OPRAND_04_operand_04_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_04_operand_04_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_04_operand_04(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_04_operand_04_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_04_get_operand_04(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_05                                                        0x18007568
+#define ISO_GDI_CEC_OPRAND_05_reg_addr                                               "0xB8007568"
+#define ISO_GDI_CEC_OPRAND_05_reg                                                    0xB8007568
+#define set_ISO_GDI_CEC_OPRAND_05_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_05_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_05_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_05_reg))
+#define ISO_GDI_CEC_OPRAND_05_inst_adr                                               "0x005A"
+#define ISO_GDI_CEC_OPRAND_05_inst                                                   0x005A
+#define ISO_GDI_CEC_OPRAND_05_operand_05_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_05_operand_05_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_05_operand_05(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_05_operand_05_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_05_get_operand_05(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_06                                                        0x1800756C
+#define ISO_GDI_CEC_OPRAND_06_reg_addr                                               "0xB800756C"
+#define ISO_GDI_CEC_OPRAND_06_reg                                                    0xB800756C
+#define set_ISO_GDI_CEC_OPRAND_06_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_06_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_06_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_06_reg))
+#define ISO_GDI_CEC_OPRAND_06_inst_adr                                               "0x005B"
+#define ISO_GDI_CEC_OPRAND_06_inst                                                   0x005B
+#define ISO_GDI_CEC_OPRAND_06_operand_06_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_06_operand_06_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_06_operand_06(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_06_operand_06_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_06_get_operand_06(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_03                                                0x18007570
+#define ISO_GDI_CEC_COMPARE_OPCODE_03_reg_addr                                       "0xB8007570"
+#define ISO_GDI_CEC_COMPARE_OPCODE_03_reg                                            0xB8007570
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_03_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_03_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_03_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_03_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_03_inst_adr                                       "0x005C"
+#define ISO_GDI_CEC_COMPARE_OPCODE_03_inst                                           0x005C
+#define ISO_GDI_CEC_COMPARE_OPCODE_03_compare_opcode_03_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_03_compare_opcode_03_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_03_compare_opcode_03(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_03_compare_opcode_03_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_03_get_compare_opcode_03(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_SEND_OPCODE_03                                                   0x18007574
+#define ISO_GDI_CEC_SEND_OPCODE_03_reg_addr                                          "0xB8007574"
+#define ISO_GDI_CEC_SEND_OPCODE_03_reg                                               0xB8007574
+#define set_ISO_GDI_CEC_SEND_OPCODE_03_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPCODE_03_reg)=data)
+#define get_ISO_GDI_CEC_SEND_OPCODE_03_reg   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPCODE_03_reg))
+#define ISO_GDI_CEC_SEND_OPCODE_03_inst_adr                                          "0x005D"
+#define ISO_GDI_CEC_SEND_OPCODE_03_inst                                              0x005D
+#define ISO_GDI_CEC_SEND_OPCODE_03_send_opcode_03_shift                              (0)
+#define ISO_GDI_CEC_SEND_OPCODE_03_send_opcode_03_mask                               (0x000000FF)
+#define ISO_GDI_CEC_SEND_OPCODE_03_send_opcode_03(data)                              (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_SEND_OPCODE_03_send_opcode_03_src(data)                          ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_SEND_OPCODE_03_get_send_opcode_03(data)                          ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_03                                            0x18007578
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_reg_addr                                   "0xB8007578"
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_reg                                        0xB8007578
+#define set_ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_reg)=data)
+#define get_ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_reg   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_reg))
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_inst_adr                                   "0x005E"
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_inst                                       0x005E
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_operand_number_03_shift                    (0)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_operand_number_03_mask                     (0x00000003)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_operand_number_03(data)                    (0x00000003&((data)<<0))
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_operand_number_03_src(data)                ((0x00000003&(data))>>0)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_03_get_operand_number_03(data)                ((0x00000003&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_07                                                        0x1800757C
+#define ISO_GDI_CEC_OPRAND_07_reg_addr                                               "0xB800757C"
+#define ISO_GDI_CEC_OPRAND_07_reg                                                    0xB800757C
+#define set_ISO_GDI_CEC_OPRAND_07_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_07_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_07_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_07_reg))
+#define ISO_GDI_CEC_OPRAND_07_inst_adr                                               "0x005F"
+#define ISO_GDI_CEC_OPRAND_07_inst                                                   0x005F
+#define ISO_GDI_CEC_OPRAND_07_operand_07_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_07_operand_07_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_07_operand_07(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_07_operand_07_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_07_get_operand_07(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_08                                                        0x18007580
+#define ISO_GDI_CEC_OPRAND_08_reg_addr                                               "0xB8007580"
+#define ISO_GDI_CEC_OPRAND_08_reg                                                    0xB8007580
+#define set_ISO_GDI_CEC_OPRAND_08_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_08_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_08_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_08_reg))
+#define ISO_GDI_CEC_OPRAND_08_inst_adr                                               "0x0060"
+#define ISO_GDI_CEC_OPRAND_08_inst                                                   0x0060
+#define ISO_GDI_CEC_OPRAND_08_operand_08_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_08_operand_08_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_08_operand_08(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_08_operand_08_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_08_get_operand_08(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_09                                                        0x18007584
+#define ISO_GDI_CEC_OPRAND_09_reg_addr                                               "0xB8007584"
+#define ISO_GDI_CEC_OPRAND_09_reg                                                    0xB8007584
+#define set_ISO_GDI_CEC_OPRAND_09_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_09_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_09_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_09_reg))
+#define ISO_GDI_CEC_OPRAND_09_inst_adr                                               "0x0061"
+#define ISO_GDI_CEC_OPRAND_09_inst                                                   0x0061
+#define ISO_GDI_CEC_OPRAND_09_operand_09_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_09_operand_09_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_09_operand_09(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_09_operand_09_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_09_get_operand_09(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_04                                                0x18007588
+#define ISO_GDI_CEC_COMPARE_OPCODE_04_reg_addr                                       "0xB8007588"
+#define ISO_GDI_CEC_COMPARE_OPCODE_04_reg                                            0xB8007588
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_04_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_04_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_04_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_04_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_04_inst_adr                                       "0x0062"
+#define ISO_GDI_CEC_COMPARE_OPCODE_04_inst                                           0x0062
+#define ISO_GDI_CEC_COMPARE_OPCODE_04_compare_opcode_04_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_04_compare_opcode_04_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_04_compare_opcode_04(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_04_compare_opcode_04_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_04_get_compare_opcode_04(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_SEND_OPCODE_04                                                   0x1800758C
+#define ISO_GDI_CEC_SEND_OPCODE_04_reg_addr                                          "0xB800758C"
+#define ISO_GDI_CEC_SEND_OPCODE_04_reg                                               0xB800758C
+#define set_ISO_GDI_CEC_SEND_OPCODE_04_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPCODE_04_reg)=data)
+#define get_ISO_GDI_CEC_SEND_OPCODE_04_reg   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPCODE_04_reg))
+#define ISO_GDI_CEC_SEND_OPCODE_04_inst_adr                                          "0x0063"
+#define ISO_GDI_CEC_SEND_OPCODE_04_inst                                              0x0063
+#define ISO_GDI_CEC_SEND_OPCODE_04_send_opcode_04_shift                              (0)
+#define ISO_GDI_CEC_SEND_OPCODE_04_send_opcode_04_mask                               (0x000000FF)
+#define ISO_GDI_CEC_SEND_OPCODE_04_send_opcode_04(data)                              (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_SEND_OPCODE_04_send_opcode_04_src(data)                          ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_SEND_OPCODE_04_get_send_opcode_04(data)                          ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_04                                            0x18007590
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_reg_addr                                   "0xB8007590"
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_reg                                        0xB8007590
+#define set_ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_reg)=data)
+#define get_ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_reg   (*((volatile unsigned int*) ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_reg))
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_inst_adr                                   "0x0064"
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_inst                                       0x0064
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_operand_number_04_shift                    (0)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_operand_number_04_mask                     (0x00000003)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_operand_number_04(data)                    (0x00000003&((data)<<0))
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_operand_number_04_src(data)                ((0x00000003&(data))>>0)
+#define ISO_GDI_CEC_SEND_OPRAND_NUMBER_04_get_operand_number_04(data)                ((0x00000003&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_10                                                        0x18007594
+#define ISO_GDI_CEC_OPRAND_10_reg_addr                                               "0xB8007594"
+#define ISO_GDI_CEC_OPRAND_10_reg                                                    0xB8007594
+#define set_ISO_GDI_CEC_OPRAND_10_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_10_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_10_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_10_reg))
+#define ISO_GDI_CEC_OPRAND_10_inst_adr                                               "0x0065"
+#define ISO_GDI_CEC_OPRAND_10_inst                                                   0x0065
+#define ISO_GDI_CEC_OPRAND_10_operand_10_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_10_operand_10_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_10_operand_10(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_10_operand_10_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_10_get_operand_10(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_11                                                        0x18007598
+#define ISO_GDI_CEC_OPRAND_11_reg_addr                                               "0xB8007598"
+#define ISO_GDI_CEC_OPRAND_11_reg                                                    0xB8007598
+#define set_ISO_GDI_CEC_OPRAND_11_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_11_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_11_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_11_reg))
+#define ISO_GDI_CEC_OPRAND_11_inst_adr                                               "0x0066"
+#define ISO_GDI_CEC_OPRAND_11_inst                                                   0x0066
+#define ISO_GDI_CEC_OPRAND_11_operand_11_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_11_operand_11_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_11_operand_11(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_11_operand_11_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_11_get_operand_11(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPRAND_12                                                        0x1800759C
+#define ISO_GDI_CEC_OPRAND_12_reg_addr                                               "0xB800759C"
+#define ISO_GDI_CEC_OPRAND_12_reg                                                    0xB800759C
+#define set_ISO_GDI_CEC_OPRAND_12_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_12_reg)=data)
+#define get_ISO_GDI_CEC_OPRAND_12_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPRAND_12_reg))
+#define ISO_GDI_CEC_OPRAND_12_inst_adr                                               "0x0067"
+#define ISO_GDI_CEC_OPRAND_12_inst                                                   0x0067
+#define ISO_GDI_CEC_OPRAND_12_operand_12_shift                                       (0)
+#define ISO_GDI_CEC_OPRAND_12_operand_12_mask                                        (0x000000FF)
+#define ISO_GDI_CEC_OPRAND_12_operand_12(data)                                       (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_OPRAND_12_operand_12_src(data)                                   ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_OPRAND_12_get_operand_12(data)                                   ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_05                                                0x180075A0
+#define ISO_GDI_CEC_COMPARE_OPCODE_05_reg_addr                                       "0xB80075A0"
+#define ISO_GDI_CEC_COMPARE_OPCODE_05_reg                                            0xB80075A0
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_05_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_05_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_05_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_05_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_05_inst_adr                                       "0x0068"
+#define ISO_GDI_CEC_COMPARE_OPCODE_05_inst                                           0x0068
+#define ISO_GDI_CEC_COMPARE_OPCODE_05_compare_opcode_05_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_05_compare_opcode_05_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_05_compare_opcode_05(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_05_compare_opcode_05_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_05_get_compare_opcode_05(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_06                                                0x180075A4
+#define ISO_GDI_CEC_COMPARE_OPCODE_06_reg_addr                                       "0xB80075A4"
+#define ISO_GDI_CEC_COMPARE_OPCODE_06_reg                                            0xB80075A4
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_06_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_06_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_06_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_06_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_06_inst_adr                                       "0x0069"
+#define ISO_GDI_CEC_COMPARE_OPCODE_06_inst                                           0x0069
+#define ISO_GDI_CEC_COMPARE_OPCODE_06_compare_opcode_06_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_06_compare_opcode_06_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_06_compare_opcode_06(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_06_compare_opcode_06_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_06_get_compare_opcode_06(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_07                                                0x180075A8
+#define ISO_GDI_CEC_COMPARE_OPCODE_07_reg_addr                                       "0xB80075A8"
+#define ISO_GDI_CEC_COMPARE_OPCODE_07_reg                                            0xB80075A8
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_07_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_07_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_07_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_07_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_07_inst_adr                                       "0x006A"
+#define ISO_GDI_CEC_COMPARE_OPCODE_07_inst                                           0x006A
+#define ISO_GDI_CEC_COMPARE_OPCODE_07_compare_opcode_07_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_07_compare_opcode_07_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_07_compare_opcode_07(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_07_compare_opcode_07_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_07_get_compare_opcode_07(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_08                                                0x180075AC
+#define ISO_GDI_CEC_COMPARE_OPCODE_08_reg_addr                                       "0xB80075AC"
+#define ISO_GDI_CEC_COMPARE_OPCODE_08_reg                                            0xB80075AC
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_08_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_08_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_08_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_08_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_08_inst_adr                                       "0x006B"
+#define ISO_GDI_CEC_COMPARE_OPCODE_08_inst                                           0x006B
+#define ISO_GDI_CEC_COMPARE_OPCODE_08_compare_opcode_08_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_08_compare_opcode_08_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_08_compare_opcode_08(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_08_compare_opcode_08_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_08_get_compare_opcode_08(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_09                                                0x180075B0
+#define ISO_GDI_CEC_COMPARE_OPCODE_09_reg_addr                                       "0xB80075B0"
+#define ISO_GDI_CEC_COMPARE_OPCODE_09_reg                                            0xB80075B0
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_09_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_09_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_09_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_09_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_09_inst_adr                                       "0x006C"
+#define ISO_GDI_CEC_COMPARE_OPCODE_09_inst                                           0x006C
+#define ISO_GDI_CEC_COMPARE_OPCODE_09_compare_opcode_09_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_09_compare_opcode_09_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_09_compare_opcode_09(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_09_compare_opcode_09_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_09_get_compare_opcode_09(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_10                                                0x180075B4
+#define ISO_GDI_CEC_COMPARE_OPCODE_10_reg_addr                                       "0xB80075B4"
+#define ISO_GDI_CEC_COMPARE_OPCODE_10_reg                                            0xB80075B4
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_10_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_10_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_10_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_10_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_10_inst_adr                                       "0x006D"
+#define ISO_GDI_CEC_COMPARE_OPCODE_10_inst                                           0x006D
+#define ISO_GDI_CEC_COMPARE_OPCODE_10_compare_opcode_10_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_10_compare_opcode_10_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_10_compare_opcode_10(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_10_compare_opcode_10_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_10_get_compare_opcode_10(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_11                                                0x180075B8
+#define ISO_GDI_CEC_COMPARE_OPCODE_11_reg_addr                                       "0xB80075B8"
+#define ISO_GDI_CEC_COMPARE_OPCODE_11_reg                                            0xB80075B8
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_11_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_11_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_11_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_11_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_11_inst_adr                                       "0x006E"
+#define ISO_GDI_CEC_COMPARE_OPCODE_11_inst                                           0x006E
+#define ISO_GDI_CEC_COMPARE_OPCODE_11_compare_opcode_11_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_11_compare_opcode_11_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_11_compare_opcode_11(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_11_compare_opcode_11_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_11_get_compare_opcode_11(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_12                                                0x180075BC
+#define ISO_GDI_CEC_COMPARE_OPCODE_12_reg_addr                                       "0xB80075BC"
+#define ISO_GDI_CEC_COMPARE_OPCODE_12_reg                                            0xB80075BC
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_12_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_12_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_12_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_12_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_12_inst_adr                                       "0x006F"
+#define ISO_GDI_CEC_COMPARE_OPCODE_12_inst                                           0x006F
+#define ISO_GDI_CEC_COMPARE_OPCODE_12_compare_opcode_12_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_12_compare_opcode_12_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_12_compare_opcode_12(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_12_compare_opcode_12_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_12_get_compare_opcode_12(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_13                                                0x180075C0
+#define ISO_GDI_CEC_COMPARE_OPCODE_13_reg_addr                                       "0xB80075C0"
+#define ISO_GDI_CEC_COMPARE_OPCODE_13_reg                                            0xB80075C0
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_13_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_13_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_13_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_13_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_13_inst_adr                                       "0x0070"
+#define ISO_GDI_CEC_COMPARE_OPCODE_13_inst                                           0x0070
+#define ISO_GDI_CEC_COMPARE_OPCODE_13_compare_opcode_13_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_13_compare_opcode_13_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_13_compare_opcode_13(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_13_compare_opcode_13_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_13_get_compare_opcode_13(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_14                                                0x180075C4
+#define ISO_GDI_CEC_COMPARE_OPCODE_14_reg_addr                                       "0xB80075C4"
+#define ISO_GDI_CEC_COMPARE_OPCODE_14_reg                                            0xB80075C4
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_14_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_14_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_14_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_14_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_14_inst_adr                                       "0x0071"
+#define ISO_GDI_CEC_COMPARE_OPCODE_14_inst                                           0x0071
+#define ISO_GDI_CEC_COMPARE_OPCODE_14_compare_opcode_14_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_14_compare_opcode_14_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_14_compare_opcode_14(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_14_compare_opcode_14_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_14_get_compare_opcode_14(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_COMPARE_OPCODE_15                                                0x180075C8
+#define ISO_GDI_CEC_COMPARE_OPCODE_15_reg_addr                                       "0xB80075C8"
+#define ISO_GDI_CEC_COMPARE_OPCODE_15_reg                                            0xB80075C8
+#define set_ISO_GDI_CEC_COMPARE_OPCODE_15_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_15_reg)=data)
+#define get_ISO_GDI_CEC_COMPARE_OPCODE_15_reg   (*((volatile unsigned int*) ISO_GDI_CEC_COMPARE_OPCODE_15_reg))
+#define ISO_GDI_CEC_COMPARE_OPCODE_15_inst_adr                                       "0x0072"
+#define ISO_GDI_CEC_COMPARE_OPCODE_15_inst                                           0x0072
+#define ISO_GDI_CEC_COMPARE_OPCODE_15_compare_opcode_15_shift                        (0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_15_compare_opcode_15_mask                         (0x000000FF)
+#define ISO_GDI_CEC_COMPARE_OPCODE_15_compare_opcode_15(data)                        (0x000000FF&((data)<<0))
+#define ISO_GDI_CEC_COMPARE_OPCODE_15_compare_opcode_15_src(data)                    ((0x000000FF&(data))>>0)
+#define ISO_GDI_CEC_COMPARE_OPCODE_15_get_compare_opcode_15(data)                    ((0x000000FF&(data))>>0)
+
+
+#define ISO_GDI_CEC_OPCODE_ENABLE                                                    0x180075CC
+#define ISO_GDI_CEC_OPCODE_ENABLE_reg_addr                                           "0xB80075CC"
+#define ISO_GDI_CEC_OPCODE_ENABLE_reg                                                0xB80075CC
+#define set_ISO_GDI_CEC_OPCODE_ENABLE_reg(data)   (*((volatile unsigned int*) ISO_GDI_CEC_OPCODE_ENABLE_reg)=data)
+#define get_ISO_GDI_CEC_OPCODE_ENABLE_reg   (*((volatile unsigned int*) ISO_GDI_CEC_OPCODE_ENABLE_reg))
+#define ISO_GDI_CEC_OPCODE_ENABLE_inst_adr                                           "0x0073"
+#define ISO_GDI_CEC_OPCODE_ENABLE_inst                                               0x0073
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_15_shift                         (14)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_15_mask                          (0x00004000)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_15(data)                         (0x00004000&((data)<<14))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_15_src(data)                     ((0x00004000&(data))>>14)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_15(data)                     ((0x00004000&(data))>>14)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_14_shift                         (13)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_14_mask                          (0x00002000)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_14(data)                         (0x00002000&((data)<<13))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_14_src(data)                     ((0x00002000&(data))>>13)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_14(data)                     ((0x00002000&(data))>>13)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_13_shift                         (12)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_13_mask                          (0x00001000)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_13(data)                         (0x00001000&((data)<<12))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_13_src(data)                     ((0x00001000&(data))>>12)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_13(data)                     ((0x00001000&(data))>>12)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_12_shift                         (11)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_12_mask                          (0x00000800)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_12(data)                         (0x00000800&((data)<<11))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_12_src(data)                     ((0x00000800&(data))>>11)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_12(data)                     ((0x00000800&(data))>>11)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_11_shift                         (10)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_11_mask                          (0x00000400)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_11(data)                         (0x00000400&((data)<<10))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_11_src(data)                     ((0x00000400&(data))>>10)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_11(data)                     ((0x00000400&(data))>>10)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_10_shift                         (9)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_10_mask                          (0x00000200)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_10(data)                         (0x00000200&((data)<<9))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_10_src(data)                     ((0x00000200&(data))>>9)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_10(data)                     ((0x00000200&(data))>>9)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_09_shift                         (8)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_09_mask                          (0x00000100)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_09(data)                         (0x00000100&((data)<<8))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_09_src(data)                     ((0x00000100&(data))>>8)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_09(data)                     ((0x00000100&(data))>>8)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_08_shift                         (7)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_08_mask                          (0x00000080)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_08(data)                         (0x00000080&((data)<<7))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_08_src(data)                     ((0x00000080&(data))>>7)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_08(data)                     ((0x00000080&(data))>>7)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_07_shift                         (6)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_07_mask                          (0x00000040)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_07(data)                         (0x00000040&((data)<<6))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_07_src(data)                     ((0x00000040&(data))>>6)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_07(data)                     ((0x00000040&(data))>>6)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_06_shift                         (5)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_06_mask                          (0x00000020)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_06(data)                         (0x00000020&((data)<<5))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_06_src(data)                     ((0x00000020&(data))>>5)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_06(data)                     ((0x00000020&(data))>>5)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_05_shift                         (4)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_05_mask                          (0x00000010)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_05(data)                         (0x00000010&((data)<<4))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_05_src(data)                     ((0x00000010&(data))>>4)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_05(data)                     ((0x00000010&(data))>>4)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_04_shift                         (3)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_04_mask                          (0x00000008)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_04(data)                         (0x00000008&((data)<<3))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_04_src(data)                     ((0x00000008&(data))>>3)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_04(data)                     ((0x00000008&(data))>>3)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_03_shift                         (2)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_03_mask                          (0x00000004)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_03(data)                         (0x00000004&((data)<<2))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_03_src(data)                     ((0x00000004&(data))>>2)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_03(data)                     ((0x00000004&(data))>>2)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_02_shift                         (1)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_02_mask                          (0x00000002)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_02(data)                         (0x00000002&((data)<<1))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_02_src(data)                     ((0x00000002&(data))>>1)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_02(data)                     ((0x00000002&(data))>>1)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_01_shift                         (0)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_01_mask                          (0x00000001)
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_01(data)                         (0x00000001&((data)<<0))
+#define ISO_GDI_CEC_OPCODE_ENABLE_en_compare_opcode_01_src(data)                     ((0x00000001&(data))>>0)
+#define ISO_GDI_CEC_OPCODE_ENABLE_get_en_compare_opcode_01(data)                     ((0x00000001&(data))>>0)
+
+
+#define ISO_GDI_POWER_SAVING_MODE                                                    0x180075D0
+#define ISO_GDI_POWER_SAVING_MODE_reg_addr                                           "0xB80075D0"
+#define ISO_GDI_POWER_SAVING_MODE_reg                                                0xB80075D0
+#define set_ISO_GDI_POWER_SAVING_MODE_reg(data)   (*((volatile unsigned int*) ISO_GDI_POWER_SAVING_MODE_reg)=data)
+#define get_ISO_GDI_POWER_SAVING_MODE_reg   (*((volatile unsigned int*) ISO_GDI_POWER_SAVING_MODE_reg))
+#define ISO_GDI_POWER_SAVING_MODE_inst_adr                                           "0x0074"
+#define ISO_GDI_POWER_SAVING_MODE_inst                                               0x0074
+#define ISO_GDI_POWER_SAVING_MODE_irq_pending_shift                                  (31)
+#define ISO_GDI_POWER_SAVING_MODE_irq_pending_mask                                   (0x80000000)
+#define ISO_GDI_POWER_SAVING_MODE_irq_pending(data)                                  (0x80000000&((data)<<31))
+#define ISO_GDI_POWER_SAVING_MODE_irq_pending_src(data)                              ((0x80000000&(data))>>31)
+#define ISO_GDI_POWER_SAVING_MODE_get_irq_pending(data)                              ((0x80000000&(data))>>31)
+#define ISO_GDI_POWER_SAVING_MODE_cec_msg_status_01_shift                            (25)
+#define ISO_GDI_POWER_SAVING_MODE_cec_msg_status_01_mask                             (0x02000000)
+#define ISO_GDI_POWER_SAVING_MODE_cec_msg_status_01(data)                            (0x02000000&((data)<<25))
+#define ISO_GDI_POWER_SAVING_MODE_cec_msg_status_01_src(data)                        ((0x02000000&(data))>>25)
+#define ISO_GDI_POWER_SAVING_MODE_get_cec_msg_status_01(data)                        ((0x02000000&(data))>>25)
+#define ISO_GDI_POWER_SAVING_MODE_cec_msg_status_02_shift                            (24)
+#define ISO_GDI_POWER_SAVING_MODE_cec_msg_status_02_mask                             (0x01000000)
+#define ISO_GDI_POWER_SAVING_MODE_cec_msg_status_02(data)                            (0x01000000&((data)<<24))
+#define ISO_GDI_POWER_SAVING_MODE_cec_msg_status_02_src(data)                        ((0x01000000&(data))>>24)
+#define ISO_GDI_POWER_SAVING_MODE_get_cec_msg_status_02(data)                        ((0x01000000&(data))>>24)
+#define ISO_GDI_POWER_SAVING_MODE_irq_by_cec_receive_special_cmd_shift               (8)
+#define ISO_GDI_POWER_SAVING_MODE_irq_by_cec_receive_special_cmd_mask                (0x00000100)
+#define ISO_GDI_POWER_SAVING_MODE_irq_by_cec_receive_special_cmd(data)               (0x00000100&((data)<<8))
+#define ISO_GDI_POWER_SAVING_MODE_irq_by_cec_receive_special_cmd_src(data)           ((0x00000100&(data))>>8)
+#define ISO_GDI_POWER_SAVING_MODE_get_irq_by_cec_receive_special_cmd(data)           ((0x00000100&(data))>>8)
+
+
+#define ISO_CEC_ANALOG                                                               0x180075E0
+#define ISO_CEC_ANALOG_reg_addr                                                      "0xB80075E0"
+#define ISO_CEC_ANALOG_reg                                                           0xB80075E0
+#define set_ISO_CEC_ANALOG_reg(data)   (*((volatile unsigned int*) ISO_CEC_ANALOG_reg)=data)
+#define get_ISO_CEC_ANALOG_reg   (*((volatile unsigned int*) ISO_CEC_ANALOG_reg))
+#define ISO_CEC_ANALOG_inst_adr                                                      "0x0078"
+#define ISO_CEC_ANALOG_inst                                                          0x0078
+#define ISO_CEC_ANALOG_reg_cec_rpu_en_shift                                          (3)
+#define ISO_CEC_ANALOG_reg_cec_rpu_en_mask                                           (0x00000008)
+#define ISO_CEC_ANALOG_reg_cec_rpu_en(data)                                          (0x00000008&((data)<<3))
+#define ISO_CEC_ANALOG_reg_cec_rpu_en_src(data)                                      ((0x00000008&(data))>>3)
+#define ISO_CEC_ANALOG_get_reg_cec_rpu_en(data)                                      ((0x00000008&(data))>>3)
+#define ISO_CEC_ANALOG_reg_cec_rsel_shift                                            (0)
+#define ISO_CEC_ANALOG_reg_cec_rsel_mask                                             (0x00000007)
+#define ISO_CEC_ANALOG_reg_cec_rsel(data)                                            (0x00000007&((data)<<0))
+#define ISO_CEC_ANALOG_reg_cec_rsel_src(data)                                        ((0x00000007&(data))>>0)
+#define ISO_CEC_ANALOG_get_reg_cec_rsel(data)                                        ((0x00000007&(data))>>0)
+
+
+#define ISO_DRM_ST                                                                   0x18007600
+#define ISO_DRM_ST_reg_addr                                                          "0xB8007600"
+#define ISO_DRM_ST_reg                                                               0xB8007600
+#define set_ISO_DRM_ST_reg(data)   (*((volatile unsigned int*) ISO_DRM_ST_reg)=data)
+#define get_ISO_DRM_ST_reg   (*((volatile unsigned int*) ISO_DRM_ST_reg))
+#define ISO_DRM_ST_inst_adr                                                          "0x0080"
+#define ISO_DRM_ST_inst                                                              0x0080
+#define ISO_DRM_ST_set_shift                                                         (0)
+#define ISO_DRM_ST_set_mask                                                          (0x00000001)
+#define ISO_DRM_ST_set(data)                                                         (0x00000001&((data)<<0))
+#define ISO_DRM_ST_set_src(data)                                                     ((0x00000001&(data))>>0)
+#define ISO_DRM_ST_get_set(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_DRM_SECURE_CLK                                                           0x18007604
+#define ISO_DRM_SECURE_CLK_reg_addr                                                  "0xB8007604"
+#define ISO_DRM_SECURE_CLK_reg                                                       0xB8007604
+#define set_ISO_DRM_SECURE_CLK_reg(data)   (*((volatile unsigned int*) ISO_DRM_SECURE_CLK_reg)=data)
+#define get_ISO_DRM_SECURE_CLK_reg   (*((volatile unsigned int*) ISO_DRM_SECURE_CLK_reg))
+#define ISO_DRM_SECURE_CLK_inst_adr                                                  "0x0081"
+#define ISO_DRM_SECURE_CLK_inst                                                      0x0081
+#define ISO_DRM_SECURE_CLK_val_shift                                                 (0)
+#define ISO_DRM_SECURE_CLK_val_mask                                                  (0xFFFFFFFF)
+#define ISO_DRM_SECURE_CLK_val(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_SECURE_CLK_val_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_SECURE_CLK_get_val(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DRM_ELAPSED                                                              0x18007608
+#define ISO_DRM_ELAPSED_reg_addr                                                     "0xB8007608"
+#define ISO_DRM_ELAPSED_reg                                                          0xB8007608
+#define set_ISO_DRM_ELAPSED_reg(data)   (*((volatile unsigned int*) ISO_DRM_ELAPSED_reg)=data)
+#define get_ISO_DRM_ELAPSED_reg   (*((volatile unsigned int*) ISO_DRM_ELAPSED_reg))
+#define ISO_DRM_ELAPSED_inst_adr                                                     "0x0082"
+#define ISO_DRM_ELAPSED_inst                                                         0x0082
+#define ISO_DRM_ELAPSED_val_shift                                                    (0)
+#define ISO_DRM_ELAPSED_val_mask                                                     (0xFFFFFFFF)
+#define ISO_DRM_ELAPSED_val(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_ELAPSED_val_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_ELAPSED_get_val(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST                                                                 0x1800760C
+#define ISO_COLD_RST_reg_addr                                                        "0xB800760C"
+#define ISO_COLD_RST_reg                                                             0xB800760C
+#define set_ISO_COLD_RST_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST_reg)=data)
+#define get_ISO_COLD_RST_reg   (*((volatile unsigned int*) ISO_COLD_RST_reg))
+#define ISO_COLD_RST_inst_adr                                                        "0x0083"
+#define ISO_COLD_RST_inst                                                            0x0083
+#define ISO_COLD_RST_val_shift                                                       (0)
+#define ISO_COLD_RST_val_mask                                                        (0xFFFFFFFF)
+#define ISO_COLD_RST_val(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST_val_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST_get_val(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST1                                                                0x18007610
+#define ISO_COLD_RST1_reg_addr                                                       "0xB8007610"
+#define ISO_COLD_RST1_reg                                                            0xB8007610
+#define set_ISO_COLD_RST1_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST1_reg)=data)
+#define get_ISO_COLD_RST1_reg   (*((volatile unsigned int*) ISO_COLD_RST1_reg))
+#define ISO_COLD_RST1_inst_adr                                                       "0x0084"
+#define ISO_COLD_RST1_inst                                                           0x0084
+#define ISO_COLD_RST1_val_shift                                                      (0)
+#define ISO_COLD_RST1_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST1_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST1_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST1_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST2                                                                0x18007614
+#define ISO_COLD_RST2_reg_addr                                                       "0xB8007614"
+#define ISO_COLD_RST2_reg                                                            0xB8007614
+#define set_ISO_COLD_RST2_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST2_reg)=data)
+#define get_ISO_COLD_RST2_reg   (*((volatile unsigned int*) ISO_COLD_RST2_reg))
+#define ISO_COLD_RST2_inst_adr                                                       "0x0085"
+#define ISO_COLD_RST2_inst                                                           0x0085
+#define ISO_COLD_RST2_val_shift                                                      (0)
+#define ISO_COLD_RST2_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST2_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST2_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST2_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DRM_CTRL                                                                 0x18007618
+#define ISO_DRM_CTRL_reg_addr                                                        "0xB8007618"
+#define ISO_DRM_CTRL_reg                                                             0xB8007618
+#define set_ISO_DRM_CTRL_reg(data)   (*((volatile unsigned int*) ISO_DRM_CTRL_reg)=data)
+#define get_ISO_DRM_CTRL_reg   (*((volatile unsigned int*) ISO_DRM_CTRL_reg))
+#define ISO_DRM_CTRL_inst_adr                                                        "0x0086"
+#define ISO_DRM_CTRL_inst                                                            0x0086
+#define ISO_DRM_CTRL_clk_div_en_shift                                                (1)
+#define ISO_DRM_CTRL_clk_div_en_mask                                                 (0x00000002)
+#define ISO_DRM_CTRL_clk_div_en(data)                                                (0x00000002&((data)<<1))
+#define ISO_DRM_CTRL_clk_div_en_src(data)                                            ((0x00000002&(data))>>1)
+#define ISO_DRM_CTRL_get_clk_div_en(data)                                            ((0x00000002&(data))>>1)
+#define ISO_DRM_CTRL_clk_sel_shift                                                   (0)
+#define ISO_DRM_CTRL_clk_sel_mask                                                    (0x00000001)
+#define ISO_DRM_CTRL_clk_sel(data)                                                   (0x00000001&((data)<<0))
+#define ISO_DRM_CTRL_clk_sel_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_DRM_CTRL_get_clk_sel(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_DRM_CLK_DIV                                                              0x1800761c
+#define ISO_DRM_CLK_DIV_reg_addr                                                     "0xB800761C"
+#define ISO_DRM_CLK_DIV_reg                                                          0xB800761C
+#define set_ISO_DRM_CLK_DIV_reg(data)   (*((volatile unsigned int*) ISO_DRM_CLK_DIV_reg)=data)
+#define get_ISO_DRM_CLK_DIV_reg   (*((volatile unsigned int*) ISO_DRM_CLK_DIV_reg))
+#define ISO_DRM_CLK_DIV_inst_adr                                                     "0x0087"
+#define ISO_DRM_CLK_DIV_inst                                                         0x0087
+#define ISO_DRM_CLK_DIV_init_shift                                                   (0)
+#define ISO_DRM_CLK_DIV_init_mask                                                    (0xFFFFFFFF)
+#define ISO_DRM_CLK_DIV_init(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_CLK_DIV_init_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_CLK_DIV_get_init(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TC3TVR                                                                   0x18007620
+#define ISO_TC3TVR_reg_addr                                                          "0xB8007620"
+#define ISO_TC3TVR_reg                                                               0xB8007620
+#define set_ISO_TC3TVR_reg(data)   (*((volatile unsigned int*) ISO_TC3TVR_reg)=data)
+#define get_ISO_TC3TVR_reg   (*((volatile unsigned int*) ISO_TC3TVR_reg))
+#define ISO_TC3TVR_inst_adr                                                          "0x0088"
+#define ISO_TC3TVR_inst                                                              0x0088
+#define ISO_TC3TVR_tc3tvr_shift                                                      (0)
+#define ISO_TC3TVR_tc3tvr_mask                                                       (0xFFFFFFFF)
+#define ISO_TC3TVR_tc3tvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_TC3TVR_tc3tvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_TC3TVR_get_tc3tvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TC3CVR                                                                   0x18007624
+#define ISO_TC3CVR_reg_addr                                                          "0xB8007624"
+#define ISO_TC3CVR_reg                                                               0xB8007624
+#define set_ISO_TC3CVR_reg(data)   (*((volatile unsigned int*) ISO_TC3CVR_reg)=data)
+#define get_ISO_TC3CVR_reg   (*((volatile unsigned int*) ISO_TC3CVR_reg))
+#define ISO_TC3CVR_inst_adr                                                          "0x0089"
+#define ISO_TC3CVR_inst                                                              0x0089
+#define ISO_TC3CVR_tc3cvr_shift                                                      (0)
+#define ISO_TC3CVR_tc3cvr_mask                                                       (0xFFFFFFFF)
+#define ISO_TC3CVR_tc3cvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_TC3CVR_tc3cvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_TC3CVR_get_tc3cvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TC3CR                                                                    0x18007628
+#define ISO_TC3CR_reg_addr                                                           "0xB8007628"
+#define ISO_TC3CR_reg                                                                0xB8007628
+#define set_ISO_TC3CR_reg(data)   (*((volatile unsigned int*) ISO_TC3CR_reg)=data)
+#define get_ISO_TC3CR_reg   (*((volatile unsigned int*) ISO_TC3CR_reg))
+#define ISO_TC3CR_inst_adr                                                           "0x008A"
+#define ISO_TC3CR_inst                                                               0x008A
+#define ISO_TC3CR_tc3en_shift                                                        (31)
+#define ISO_TC3CR_tc3en_mask                                                         (0x80000000)
+#define ISO_TC3CR_tc3en(data)                                                        (0x80000000&((data)<<31))
+#define ISO_TC3CR_tc3en_src(data)                                                    ((0x80000000&(data))>>31)
+#define ISO_TC3CR_get_tc3en(data)                                                    ((0x80000000&(data))>>31)
+#define ISO_TC3CR_tc3mode_shift                                                      (30)
+#define ISO_TC3CR_tc3mode_mask                                                       (0x40000000)
+#define ISO_TC3CR_tc3mode(data)                                                      (0x40000000&((data)<<30))
+#define ISO_TC3CR_tc3mode_src(data)                                                  ((0x40000000&(data))>>30)
+#define ISO_TC3CR_get_tc3mode(data)                                                  ((0x40000000&(data))>>30)
+#define ISO_TC3CR_tc3pause_shift                                                     (29)
+#define ISO_TC3CR_tc3pause_mask                                                      (0x20000000)
+#define ISO_TC3CR_tc3pause(data)                                                     (0x20000000&((data)<<29))
+#define ISO_TC3CR_tc3pause_src(data)                                                 ((0x20000000&(data))>>29)
+#define ISO_TC3CR_get_tc3pause(data)                                                 ((0x20000000&(data))>>29)
+#define ISO_TC3CR_rvda_shift                                                         (24)
+#define ISO_TC3CR_rvda_mask                                                          (0x1F000000)
+#define ISO_TC3CR_rvda(data)                                                         (0x1F000000&((data)<<24))
+#define ISO_TC3CR_rvda_src(data)                                                     ((0x1F000000&(data))>>24)
+#define ISO_TC3CR_get_rvda(data)                                                     ((0x1F000000&(data))>>24)
+
+
+#define ISO_TC3ICR                                                                   0x1800762C
+#define ISO_TC3ICR_reg_addr                                                          "0xB800762C"
+#define ISO_TC3ICR_reg                                                               0xB800762C
+#define set_ISO_TC3ICR_reg(data)   (*((volatile unsigned int*) ISO_TC3ICR_reg)=data)
+#define get_ISO_TC3ICR_reg   (*((volatile unsigned int*) ISO_TC3ICR_reg))
+#define ISO_TC3ICR_inst_adr                                                          "0x008B"
+#define ISO_TC3ICR_inst                                                              0x008B
+#define ISO_TC3ICR_tc3ie_shift                                                       (31)
+#define ISO_TC3ICR_tc3ie_mask                                                        (0x80000000)
+#define ISO_TC3ICR_tc3ie(data)                                                       (0x80000000&((data)<<31))
+#define ISO_TC3ICR_tc3ie_src(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_TC3ICR_get_tc3ie(data)                                                   ((0x80000000&(data))>>31)
+
+
+#define ISO_TC4TVR                                                                   0x18007630
+#define ISO_TC4TVR_reg_addr                                                          "0xB8007630"
+#define ISO_TC4TVR_reg                                                               0xB8007630
+#define set_ISO_TC4TVR_reg(data)   (*((volatile unsigned int*) ISO_TC4TVR_reg)=data)
+#define get_ISO_TC4TVR_reg   (*((volatile unsigned int*) ISO_TC4TVR_reg))
+#define ISO_TC4TVR_inst_adr                                                          "0x008C"
+#define ISO_TC4TVR_inst                                                              0x008C
+#define ISO_TC4TVR_tc4tvr_shift                                                      (0)
+#define ISO_TC4TVR_tc4tvr_mask                                                       (0xFFFFFFFF)
+#define ISO_TC4TVR_tc4tvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_TC4TVR_tc4tvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_TC4TVR_get_tc4tvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TC4CVR                                                                   0x18007634
+#define ISO_TC4CVR_reg_addr                                                          "0xB8007634"
+#define ISO_TC4CVR_reg                                                               0xB8007634
+#define set_ISO_TC4CVR_reg(data)   (*((volatile unsigned int*) ISO_TC4CVR_reg)=data)
+#define get_ISO_TC4CVR_reg   (*((volatile unsigned int*) ISO_TC4CVR_reg))
+#define ISO_TC4CVR_inst_adr                                                          "0x008D"
+#define ISO_TC4CVR_inst                                                              0x008D
+#define ISO_TC4CVR_tc4cvr_shift                                                      (0)
+#define ISO_TC4CVR_tc4cvr_mask                                                       (0xFFFFFFFF)
+#define ISO_TC4CVR_tc4cvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_TC4CVR_tc4cvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_TC4CVR_get_tc4cvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TC4CR                                                                    0x18007638
+#define ISO_TC4CR_reg_addr                                                           "0xB8007638"
+#define ISO_TC4CR_reg                                                                0xB8007638
+#define set_ISO_TC4CR_reg(data)   (*((volatile unsigned int*) ISO_TC4CR_reg)=data)
+#define get_ISO_TC4CR_reg   (*((volatile unsigned int*) ISO_TC4CR_reg))
+#define ISO_TC4CR_inst_adr                                                           "0x008E"
+#define ISO_TC4CR_inst                                                               0x008E
+#define ISO_TC4CR_tc4en_shift                                                        (31)
+#define ISO_TC4CR_tc4en_mask                                                         (0x80000000)
+#define ISO_TC4CR_tc4en(data)                                                        (0x80000000&((data)<<31))
+#define ISO_TC4CR_tc4en_src(data)                                                    ((0x80000000&(data))>>31)
+#define ISO_TC4CR_get_tc4en(data)                                                    ((0x80000000&(data))>>31)
+#define ISO_TC4CR_tc4mode_shift                                                      (30)
+#define ISO_TC4CR_tc4mode_mask                                                       (0x40000000)
+#define ISO_TC4CR_tc4mode(data)                                                      (0x40000000&((data)<<30))
+#define ISO_TC4CR_tc4mode_src(data)                                                  ((0x40000000&(data))>>30)
+#define ISO_TC4CR_get_tc4mode(data)                                                  ((0x40000000&(data))>>30)
+#define ISO_TC4CR_tc4pause_shift                                                     (29)
+#define ISO_TC4CR_tc4pause_mask                                                      (0x20000000)
+#define ISO_TC4CR_tc4pause(data)                                                     (0x20000000&((data)<<29))
+#define ISO_TC4CR_tc4pause_src(data)                                                 ((0x20000000&(data))>>29)
+#define ISO_TC4CR_get_tc4pause(data)                                                 ((0x20000000&(data))>>29)
+#define ISO_TC4CR_rvda_shift                                                         (24)
+#define ISO_TC4CR_rvda_mask                                                          (0x1F000000)
+#define ISO_TC4CR_rvda(data)                                                         (0x1F000000&((data)<<24))
+#define ISO_TC4CR_rvda_src(data)                                                     ((0x1F000000&(data))>>24)
+#define ISO_TC4CR_get_rvda(data)                                                     ((0x1F000000&(data))>>24)
+
+
+#define ISO_TC4ICR                                                                   0x1800763C
+#define ISO_TC4ICR_reg_addr                                                          "0xB800763C"
+#define ISO_TC4ICR_reg                                                               0xB800763C
+#define set_ISO_TC4ICR_reg(data)   (*((volatile unsigned int*) ISO_TC4ICR_reg)=data)
+#define get_ISO_TC4ICR_reg   (*((volatile unsigned int*) ISO_TC4ICR_reg))
+#define ISO_TC4ICR_inst_adr                                                          "0x008F"
+#define ISO_TC4ICR_inst                                                              0x008F
+#define ISO_TC4ICR_tc4ie_shift                                                       (31)
+#define ISO_TC4ICR_tc4ie_mask                                                        (0x80000000)
+#define ISO_TC4ICR_tc4ie(data)                                                       (0x80000000&((data)<<31))
+#define ISO_TC4ICR_tc4ie_src(data)                                                   ((0x80000000&(data))>>31)
+#define ISO_TC4ICR_get_tc4ie(data)                                                   ((0x80000000&(data))>>31)
+
+
+#define ISO_NORST_0                                                                  0x18007640
+#define ISO_NORST_1                                                                  0x18007644
+#define ISO_NORST_2                                                                  0x18007648
+#define ISO_NORST_3                                                                  0x1800764C
+#define ISO_NORST_4                                                                  0x18007650
+#define ISO_NORST_5                                                                  0x18007654
+#define ISO_NORST_6                                                                  0x18007658
+#define ISO_NORST_7                                                                  0x1800765C
+#define ISO_NORST_0_reg_addr                                                         "0xB8007640"
+#define ISO_NORST_1_reg_addr                                                         "0xB8007644"
+#define ISO_NORST_2_reg_addr                                                         "0xB8007648"
+#define ISO_NORST_3_reg_addr                                                         "0xB800764C"
+#define ISO_NORST_4_reg_addr                                                         "0xB8007650"
+#define ISO_NORST_5_reg_addr                                                         "0xB8007654"
+#define ISO_NORST_6_reg_addr                                                         "0xB8007658"
+#define ISO_NORST_7_reg_addr                                                         "0xB800765C"
+#define ISO_NORST_0_reg                                                              0xB8007640
+#define ISO_NORST_1_reg                                                              0xB8007644
+#define ISO_NORST_2_reg                                                              0xB8007648
+#define ISO_NORST_3_reg                                                              0xB800764C
+#define ISO_NORST_4_reg                                                              0xB8007650
+#define ISO_NORST_5_reg                                                              0xB8007654
+#define ISO_NORST_6_reg                                                              0xB8007658
+#define ISO_NORST_7_reg                                                              0xB800765C
+#define set_ISO_NORST_0_reg(data)   (*((volatile unsigned int*) ISO_NORST_0_reg)=data)
+#define set_ISO_NORST_1_reg(data)   (*((volatile unsigned int*) ISO_NORST_1_reg)=data)
+#define set_ISO_NORST_2_reg(data)   (*((volatile unsigned int*) ISO_NORST_2_reg)=data)
+#define set_ISO_NORST_3_reg(data)   (*((volatile unsigned int*) ISO_NORST_3_reg)=data)
+#define set_ISO_NORST_4_reg(data)   (*((volatile unsigned int*) ISO_NORST_4_reg)=data)
+#define set_ISO_NORST_5_reg(data)   (*((volatile unsigned int*) ISO_NORST_5_reg)=data)
+#define set_ISO_NORST_6_reg(data)   (*((volatile unsigned int*) ISO_NORST_6_reg)=data)
+#define set_ISO_NORST_7_reg(data)   (*((volatile unsigned int*) ISO_NORST_7_reg)=data)
+#define get_ISO_NORST_0_reg   (*((volatile unsigned int*) ISO_NORST_0_reg))
+#define get_ISO_NORST_1_reg   (*((volatile unsigned int*) ISO_NORST_1_reg))
+#define get_ISO_NORST_2_reg   (*((volatile unsigned int*) ISO_NORST_2_reg))
+#define get_ISO_NORST_3_reg   (*((volatile unsigned int*) ISO_NORST_3_reg))
+#define get_ISO_NORST_4_reg   (*((volatile unsigned int*) ISO_NORST_4_reg))
+#define get_ISO_NORST_5_reg   (*((volatile unsigned int*) ISO_NORST_5_reg))
+#define get_ISO_NORST_6_reg   (*((volatile unsigned int*) ISO_NORST_6_reg))
+#define get_ISO_NORST_7_reg   (*((volatile unsigned int*) ISO_NORST_7_reg))
+#define ISO_NORST_0_inst_adr                                                         "0x0090"
+#define ISO_NORST_1_inst_adr                                                         "0x0091"
+#define ISO_NORST_2_inst_adr                                                         "0x0092"
+#define ISO_NORST_3_inst_adr                                                         "0x0093"
+#define ISO_NORST_4_inst_adr                                                         "0x0094"
+#define ISO_NORST_5_inst_adr                                                         "0x0095"
+#define ISO_NORST_6_inst_adr                                                         "0x0096"
+#define ISO_NORST_7_inst_adr                                                         "0x0097"
+#define ISO_NORST_0_inst                                                             0x0090
+#define ISO_NORST_1_inst                                                             0x0091
+#define ISO_NORST_2_inst                                                             0x0092
+#define ISO_NORST_3_inst                                                             0x0093
+#define ISO_NORST_4_inst                                                             0x0094
+#define ISO_NORST_5_inst                                                             0x0095
+#define ISO_NORST_6_inst                                                             0x0096
+#define ISO_NORST_7_inst                                                             0x0097
+#define ISO_NORST_dat_shift                                                          (0)
+#define ISO_NORST_dat_mask                                                           (0xFFFFFFFF)
+#define ISO_NORST_dat(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define ISO_NORST_dat_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define ISO_NORST_get_dat(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST3                                                                0x18007660
+#define ISO_COLD_RST3_reg_addr                                                       "0xB8007660"
+#define ISO_COLD_RST3_reg                                                            0xB8007660
+#define set_ISO_COLD_RST3_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST3_reg)=data)
+#define get_ISO_COLD_RST3_reg   (*((volatile unsigned int*) ISO_COLD_RST3_reg))
+#define ISO_COLD_RST3_inst_adr                                                       "0x0098"
+#define ISO_COLD_RST3_inst                                                           0x0098
+#define ISO_COLD_RST3_val_shift                                                      (0)
+#define ISO_COLD_RST3_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST3_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST3_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST3_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST4                                                                0x18007664
+#define ISO_COLD_RST4_reg_addr                                                       "0xB8007664"
+#define ISO_COLD_RST4_reg                                                            0xB8007664
+#define set_ISO_COLD_RST4_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST4_reg)=data)
+#define get_ISO_COLD_RST4_reg   (*((volatile unsigned int*) ISO_COLD_RST4_reg))
+#define ISO_COLD_RST4_inst_adr                                                       "0x0099"
+#define ISO_COLD_RST4_inst                                                           0x0099
+#define ISO_COLD_RST4_val_shift                                                      (0)
+#define ISO_COLD_RST4_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST4_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST4_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST4_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST5                                                                0x18007668
+#define ISO_COLD_RST5_reg_addr                                                       "0xB8007668"
+#define ISO_COLD_RST5_reg                                                            0xB8007668
+#define set_ISO_COLD_RST5_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST5_reg)=data)
+#define get_ISO_COLD_RST5_reg   (*((volatile unsigned int*) ISO_COLD_RST5_reg))
+#define ISO_COLD_RST5_inst_adr                                                       "0x009A"
+#define ISO_COLD_RST5_inst                                                           0x009A
+#define ISO_COLD_RST5_val_shift                                                      (0)
+#define ISO_COLD_RST5_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST5_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST5_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST5_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST6                                                                0x1800766C
+#define ISO_COLD_RST6_reg_addr                                                       "0xB800766C"
+#define ISO_COLD_RST6_reg                                                            0xB800766C
+#define set_ISO_COLD_RST6_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST6_reg)=data)
+#define get_ISO_COLD_RST6_reg   (*((volatile unsigned int*) ISO_COLD_RST6_reg))
+#define ISO_COLD_RST6_inst_adr                                                       "0x009B"
+#define ISO_COLD_RST6_inst                                                           0x009B
+#define ISO_COLD_RST6_val_shift                                                      (0)
+#define ISO_COLD_RST6_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST6_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST6_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST6_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST7                                                                0x18007670
+#define ISO_COLD_RST7_reg_addr                                                       "0xB8007670"
+#define ISO_COLD_RST7_reg                                                            0xB8007670
+#define set_ISO_COLD_RST7_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST7_reg)=data)
+#define get_ISO_COLD_RST7_reg   (*((volatile unsigned int*) ISO_COLD_RST7_reg))
+#define ISO_COLD_RST7_inst_adr                                                       "0x009C"
+#define ISO_COLD_RST7_inst                                                           0x009C
+#define ISO_COLD_RST7_val_shift                                                      (0)
+#define ISO_COLD_RST7_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST7_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST7_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST7_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST8                                                                0x18007674
+#define ISO_COLD_RST8_reg_addr                                                       "0xB8007674"
+#define ISO_COLD_RST8_reg                                                            0xB8007674
+#define set_ISO_COLD_RST8_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST8_reg)=data)
+#define get_ISO_COLD_RST8_reg   (*((volatile unsigned int*) ISO_COLD_RST8_reg))
+#define ISO_COLD_RST8_inst_adr                                                       "0x009D"
+#define ISO_COLD_RST8_inst                                                           0x009D
+#define ISO_COLD_RST8_val_shift                                                      (0)
+#define ISO_COLD_RST8_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST8_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST8_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST8_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST9                                                                0x18007678
+#define ISO_COLD_RST9_reg_addr                                                       "0xB8007678"
+#define ISO_COLD_RST9_reg                                                            0xB8007678
+#define set_ISO_COLD_RST9_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST9_reg)=data)
+#define get_ISO_COLD_RST9_reg   (*((volatile unsigned int*) ISO_COLD_RST9_reg))
+#define ISO_COLD_RST9_inst_adr                                                       "0x009E"
+#define ISO_COLD_RST9_inst                                                           0x009E
+#define ISO_COLD_RST9_val_shift                                                      (0)
+#define ISO_COLD_RST9_val_mask                                                       (0xFFFFFFFF)
+#define ISO_COLD_RST9_val(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST9_val_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST9_get_val(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST10                                                               0x1800767C
+#define ISO_COLD_RST10_reg_addr                                                      "0xB800767C"
+#define ISO_COLD_RST10_reg                                                           0xB800767C
+#define set_ISO_COLD_RST10_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST10_reg)=data)
+#define get_ISO_COLD_RST10_reg   (*((volatile unsigned int*) ISO_COLD_RST10_reg))
+#define ISO_COLD_RST10_inst_adr                                                      "0x009F"
+#define ISO_COLD_RST10_inst                                                          0x009F
+#define ISO_COLD_RST10_val_shift                                                     (0)
+#define ISO_COLD_RST10_val_mask                                                      (0xFFFFFFFF)
+#define ISO_COLD_RST10_val(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST10_val_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST10_get_val(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TCWCR                                                                    0x18007680
+#define ISO_TCWCR_reg_addr                                                           "0xB8007680"
+#define ISO_TCWCR_reg                                                                0xB8007680
+#define set_ISO_TCWCR_reg(data)   (*((volatile unsigned int*) ISO_TCWCR_reg)=data)
+#define get_ISO_TCWCR_reg   (*((volatile unsigned int*) ISO_TCWCR_reg))
+#define ISO_TCWCR_inst_adr                                                           "0x00A0"
+#define ISO_TCWCR_inst                                                               0x00A0
+#define ISO_TCWCR_wd_int_en_shift                                                    (31)
+#define ISO_TCWCR_wd_int_en_mask                                                     (0x80000000)
+#define ISO_TCWCR_wd_int_en(data)                                                    (0x80000000&((data)<<31))
+#define ISO_TCWCR_wd_int_en_src(data)                                                ((0x80000000&(data))>>31)
+#define ISO_TCWCR_get_wd_int_en(data)                                                ((0x80000000&(data))>>31)
+#define ISO_TCWCR_nmic_shift                                                         (12)
+#define ISO_TCWCR_nmic_mask                                                          (0x0000F000)
+#define ISO_TCWCR_nmic(data)                                                         (0x0000F000&((data)<<12))
+#define ISO_TCWCR_nmic_src(data)                                                     ((0x0000F000&(data))>>12)
+#define ISO_TCWCR_get_nmic(data)                                                     ((0x0000F000&(data))>>12)
+#define ISO_TCWCR_wdc_shift                                                          (8)
+#define ISO_TCWCR_wdc_mask                                                           (0x00000F00)
+#define ISO_TCWCR_wdc(data)                                                          (0x00000F00&((data)<<8))
+#define ISO_TCWCR_wdc_src(data)                                                      ((0x00000F00&(data))>>8)
+#define ISO_TCWCR_get_wdc(data)                                                      ((0x00000F00&(data))>>8)
+#define ISO_TCWCR_wden_shift                                                         (0)
+#define ISO_TCWCR_wden_mask                                                          (0x000000FF)
+#define ISO_TCWCR_wden(data)                                                         (0x000000FF&((data)<<0))
+#define ISO_TCWCR_wden_src(data)                                                     ((0x000000FF&(data))>>0)
+#define ISO_TCWCR_get_wden(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define ISO_TCWTR                                                                    0x18007684
+#define ISO_TCWTR_reg_addr                                                           "0xB8007684"
+#define ISO_TCWTR_reg                                                                0xB8007684
+#define set_ISO_TCWTR_reg(data)   (*((volatile unsigned int*) ISO_TCWTR_reg)=data)
+#define get_ISO_TCWTR_reg   (*((volatile unsigned int*) ISO_TCWTR_reg))
+#define ISO_TCWTR_inst_adr                                                           "0x00A1"
+#define ISO_TCWTR_inst                                                               0x00A1
+#define ISO_TCWTR_wdclr_shift                                                        (0)
+#define ISO_TCWTR_wdclr_mask                                                         (0x00000001)
+#define ISO_TCWTR_wdclr(data)                                                        (0x00000001&((data)<<0))
+#define ISO_TCWTR_wdclr_src(data)                                                    ((0x00000001&(data))>>0)
+#define ISO_TCWTR_get_wdclr(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_TCWNMI                                                                   0x18007688
+#define ISO_TCWNMI_reg_addr                                                          "0xB8007688"
+#define ISO_TCWNMI_reg                                                               0xB8007688
+#define set_ISO_TCWNMI_reg(data)   (*((volatile unsigned int*) ISO_TCWNMI_reg)=data)
+#define get_ISO_TCWNMI_reg   (*((volatile unsigned int*) ISO_TCWNMI_reg))
+#define ISO_TCWNMI_inst_adr                                                          "0x00A2"
+#define ISO_TCWNMI_inst                                                              0x00A2
+#define ISO_TCWNMI_sel_shift                                                         (0)
+#define ISO_TCWNMI_sel_mask                                                          (0xFFFFFFFF)
+#define ISO_TCWNMI_sel(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define ISO_TCWNMI_sel_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define ISO_TCWNMI_get_sel(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TCWOV                                                                    0x1800768C
+#define ISO_TCWOV_reg_addr                                                           "0xB800768C"
+#define ISO_TCWOV_reg                                                                0xB800768C
+#define set_ISO_TCWOV_reg(data)   (*((volatile unsigned int*) ISO_TCWOV_reg)=data)
+#define get_ISO_TCWOV_reg   (*((volatile unsigned int*) ISO_TCWOV_reg))
+#define ISO_TCWOV_inst_adr                                                           "0x00A3"
+#define ISO_TCWOV_inst                                                               0x00A3
+#define ISO_TCWOV_sel_shift                                                          (0)
+#define ISO_TCWOV_sel_mask                                                           (0xFFFFFFFF)
+#define ISO_TCWOV_sel(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define ISO_TCWOV_sel_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define ISO_TCWOV_get_sel(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DRM_ST_SWC                                                               0x18007690
+#define ISO_DRM_ST_SWC_reg_addr                                                      "0xB8007690"
+#define ISO_DRM_ST_SWC_reg                                                           0xB8007690
+#define set_ISO_DRM_ST_SWC_reg(data)   (*((volatile unsigned int*) ISO_DRM_ST_SWC_reg)=data)
+#define get_ISO_DRM_ST_SWC_reg   (*((volatile unsigned int*) ISO_DRM_ST_SWC_reg))
+#define ISO_DRM_ST_SWC_inst_adr                                                      "0x00A4"
+#define ISO_DRM_ST_SWC_inst                                                          0x00A4
+#define ISO_DRM_ST_SWC_set_shift                                                     (0)
+#define ISO_DRM_ST_SWC_set_mask                                                      (0x00000001)
+#define ISO_DRM_ST_SWC_set(data)                                                     (0x00000001&((data)<<0))
+#define ISO_DRM_ST_SWC_set_src(data)                                                 ((0x00000001&(data))>>0)
+#define ISO_DRM_ST_SWC_get_set(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define ISO_DRM_SECURE_CLK_SWC                                                       0x18007694
+#define ISO_DRM_SECURE_CLK_SWC_reg_addr                                              "0xB8007694"
+#define ISO_DRM_SECURE_CLK_SWC_reg                                                   0xB8007694
+#define set_ISO_DRM_SECURE_CLK_SWC_reg(data)   (*((volatile unsigned int*) ISO_DRM_SECURE_CLK_SWC_reg)=data)
+#define get_ISO_DRM_SECURE_CLK_SWC_reg   (*((volatile unsigned int*) ISO_DRM_SECURE_CLK_SWC_reg))
+#define ISO_DRM_SECURE_CLK_SWC_inst_adr                                              "0x00A5"
+#define ISO_DRM_SECURE_CLK_SWC_inst                                                  0x00A5
+#define ISO_DRM_SECURE_CLK_SWC_val_shift                                             (0)
+#define ISO_DRM_SECURE_CLK_SWC_val_mask                                              (0xFFFFFFFF)
+#define ISO_DRM_SECURE_CLK_SWC_val(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_SECURE_CLK_SWC_val_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_SECURE_CLK_SWC_get_val(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DRM_ELAPSED_SWC                                                          0x18007698
+#define ISO_DRM_ELAPSED_SWC_reg_addr                                                 "0xB8007698"
+#define ISO_DRM_ELAPSED_SWC_reg                                                      0xB8007698
+#define set_ISO_DRM_ELAPSED_SWC_reg(data)   (*((volatile unsigned int*) ISO_DRM_ELAPSED_SWC_reg)=data)
+#define get_ISO_DRM_ELAPSED_SWC_reg   (*((volatile unsigned int*) ISO_DRM_ELAPSED_SWC_reg))
+#define ISO_DRM_ELAPSED_SWC_inst_adr                                                 "0x00A6"
+#define ISO_DRM_ELAPSED_SWC_inst                                                     0x00A6
+#define ISO_DRM_ELAPSED_SWC_val_shift                                                (0)
+#define ISO_DRM_ELAPSED_SWC_val_mask                                                 (0xFFFFFFFF)
+#define ISO_DRM_ELAPSED_SWC_val(data)                                                (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_ELAPSED_SWC_val_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_ELAPSED_SWC_get_val(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_DRM_CTRL_SWC                                                             0x1800769C
+#define ISO_DRM_CTRL_SWC_reg_addr                                                    "0xB800769C"
+#define ISO_DRM_CTRL_SWC_reg                                                         0xB800769C
+#define set_ISO_DRM_CTRL_SWC_reg(data)   (*((volatile unsigned int*) ISO_DRM_CTRL_SWC_reg)=data)
+#define get_ISO_DRM_CTRL_SWC_reg   (*((volatile unsigned int*) ISO_DRM_CTRL_SWC_reg))
+#define ISO_DRM_CTRL_SWC_inst_adr                                                    "0x00A7"
+#define ISO_DRM_CTRL_SWC_inst                                                        0x00A7
+#define ISO_DRM_CTRL_SWC_clk_div_en_shift                                            (1)
+#define ISO_DRM_CTRL_SWC_clk_div_en_mask                                             (0x00000002)
+#define ISO_DRM_CTRL_SWC_clk_div_en(data)                                            (0x00000002&((data)<<1))
+#define ISO_DRM_CTRL_SWC_clk_div_en_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_DRM_CTRL_SWC_get_clk_div_en(data)                                        ((0x00000002&(data))>>1)
+#define ISO_DRM_CTRL_SWC_clk_sel_shift                                               (0)
+#define ISO_DRM_CTRL_SWC_clk_sel_mask                                                (0x00000001)
+#define ISO_DRM_CTRL_SWC_clk_sel(data)                                               (0x00000001&((data)<<0))
+#define ISO_DRM_CTRL_SWC_clk_sel_src(data)                                           ((0x00000001&(data))>>0)
+#define ISO_DRM_CTRL_SWC_get_clk_sel(data)                                           ((0x00000001&(data))>>0)
+
+
+#define ISO_DRM_CLK_DIV_SWC                                                          0x180076A0
+#define ISO_DRM_CLK_DIV_SWC_reg_addr                                                 "0xB80076A0"
+#define ISO_DRM_CLK_DIV_SWC_reg                                                      0xB80076A0
+#define set_ISO_DRM_CLK_DIV_SWC_reg(data)   (*((volatile unsigned int*) ISO_DRM_CLK_DIV_SWC_reg)=data)
+#define get_ISO_DRM_CLK_DIV_SWC_reg   (*((volatile unsigned int*) ISO_DRM_CLK_DIV_SWC_reg))
+#define ISO_DRM_CLK_DIV_SWC_inst_adr                                                 "0x00A8"
+#define ISO_DRM_CLK_DIV_SWC_inst                                                     0x00A8
+#define ISO_DRM_CLK_DIV_SWC_init_shift                                               (0)
+#define ISO_DRM_CLK_DIV_SWC_init_mask                                                (0xFFFFFFFF)
+#define ISO_DRM_CLK_DIV_SWC_init(data)                                               (0xFFFFFFFF&((data)<<0))
+#define ISO_DRM_CLK_DIV_SWC_init_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define ISO_DRM_CLK_DIV_SWC_get_init(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST_SWC                                                             0x180076A4
+#define ISO_COLD_RST_SWC_reg_addr                                                    "0xB80076A4"
+#define ISO_COLD_RST_SWC_reg                                                         0xB80076A4
+#define set_ISO_COLD_RST_SWC_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST_SWC_reg)=data)
+#define get_ISO_COLD_RST_SWC_reg   (*((volatile unsigned int*) ISO_COLD_RST_SWC_reg))
+#define ISO_COLD_RST_SWC_inst_adr                                                    "0x00A9"
+#define ISO_COLD_RST_SWC_inst                                                        0x00A9
+#define ISO_COLD_RST_SWC_val_shift                                                   (0)
+#define ISO_COLD_RST_SWC_val_mask                                                    (0xFFFFFFFF)
+#define ISO_COLD_RST_SWC_val(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST_SWC_val_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST_SWC_get_val(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST1_SWC                                                            0x180076A8
+#define ISO_COLD_RST1_SWC_reg_addr                                                   "0xB80076A8"
+#define ISO_COLD_RST1_SWC_reg                                                        0xB80076A8
+#define set_ISO_COLD_RST1_SWC_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST1_SWC_reg)=data)
+#define get_ISO_COLD_RST1_SWC_reg   (*((volatile unsigned int*) ISO_COLD_RST1_SWC_reg))
+#define ISO_COLD_RST1_SWC_inst_adr                                                   "0x00AA"
+#define ISO_COLD_RST1_SWC_inst                                                       0x00AA
+#define ISO_COLD_RST1_SWC_val_shift                                                  (0)
+#define ISO_COLD_RST1_SWC_val_mask                                                   (0xFFFFFFFF)
+#define ISO_COLD_RST1_SWC_val(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST1_SWC_val_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST1_SWC_get_val(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST2_SWC                                                            0x180076AC
+#define ISO_COLD_RST2_SWC_reg_addr                                                   "0xB80076AC"
+#define ISO_COLD_RST2_SWC_reg                                                        0xB80076AC
+#define set_ISO_COLD_RST2_SWC_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST2_SWC_reg)=data)
+#define get_ISO_COLD_RST2_SWC_reg   (*((volatile unsigned int*) ISO_COLD_RST2_SWC_reg))
+#define ISO_COLD_RST2_SWC_inst_adr                                                   "0x00AB"
+#define ISO_COLD_RST2_SWC_inst                                                       0x00AB
+#define ISO_COLD_RST2_SWC_val_shift                                                  (0)
+#define ISO_COLD_RST2_SWC_val_mask                                                   (0xFFFFFFFF)
+#define ISO_COLD_RST2_SWC_val(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST2_SWC_val_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST2_SWC_get_val(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_COLD_RST3_SWC                                                            0x180076B0
+#define ISO_COLD_RST3_SWC_reg_addr                                                   "0xB80076B0"
+#define ISO_COLD_RST3_SWC_reg                                                        0xB80076B0
+#define set_ISO_COLD_RST3_SWC_reg(data)   (*((volatile unsigned int*) ISO_COLD_RST3_SWC_reg)=data)
+#define get_ISO_COLD_RST3_SWC_reg   (*((volatile unsigned int*) ISO_COLD_RST3_SWC_reg))
+#define ISO_COLD_RST3_SWC_inst_adr                                                   "0x00AC"
+#define ISO_COLD_RST3_SWC_inst                                                       0x00AC
+#define ISO_COLD_RST3_SWC_val_shift                                                  (0)
+#define ISO_COLD_RST3_SWC_val_mask                                                   (0xFFFFFFFF)
+#define ISO_COLD_RST3_SWC_val(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define ISO_COLD_RST3_SWC_val_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define ISO_COLD_RST3_SWC_get_val(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_NORST_SWC                                                                0x180076B4
+#define ISO_NORST_SWC_reg_addr                                                       "0xB80076B4"
+#define ISO_NORST_SWC_reg                                                            0xB80076B4
+#define set_ISO_NORST_SWC_reg(data)   (*((volatile unsigned int*) ISO_NORST_SWC_reg)=data)
+#define get_ISO_NORST_SWC_reg   (*((volatile unsigned int*) ISO_NORST_SWC_reg))
+#define ISO_NORST_SWC_inst_adr                                                       "0x00AD"
+#define ISO_NORST_SWC_inst                                                           0x00AD
+#define ISO_NORST_SWC_dat_shift                                                      (0)
+#define ISO_NORST_SWC_dat_mask                                                       (0xFFFFFFFF)
+#define ISO_NORST_SWC_dat(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define ISO_NORST_SWC_dat_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define ISO_NORST_SWC_get_dat(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_NORST1_SWC                                                               0x180076B8
+#define ISO_NORST1_SWC_reg_addr                                                      "0xB80076B8"
+#define ISO_NORST1_SWC_reg                                                           0xB80076B8
+#define set_ISO_NORST1_SWC_reg(data)   (*((volatile unsigned int*) ISO_NORST1_SWC_reg)=data)
+#define get_ISO_NORST1_SWC_reg   (*((volatile unsigned int*) ISO_NORST1_SWC_reg))
+#define ISO_NORST1_SWC_inst_adr                                                      "0x00AE"
+#define ISO_NORST1_SWC_inst                                                          0x00AE
+#define ISO_NORST1_SWC_dat_shift                                                     (0)
+#define ISO_NORST1_SWC_dat_mask                                                      (0xFFFFFFFF)
+#define ISO_NORST1_SWC_dat(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_NORST1_SWC_dat_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_NORST1_SWC_get_dat(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_NORST2_SWC                                                               0x180076BC
+#define ISO_NORST2_SWC_reg_addr                                                      "0xB80076BC"
+#define ISO_NORST2_SWC_reg                                                           0xB80076BC
+#define set_ISO_NORST2_SWC_reg(data)   (*((volatile unsigned int*) ISO_NORST2_SWC_reg)=data)
+#define get_ISO_NORST2_SWC_reg   (*((volatile unsigned int*) ISO_NORST2_SWC_reg))
+#define ISO_NORST2_SWC_inst_adr                                                      "0x00AF"
+#define ISO_NORST2_SWC_inst                                                          0x00AF
+#define ISO_NORST2_SWC_dat_shift                                                     (0)
+#define ISO_NORST2_SWC_dat_mask                                                      (0xFFFFFFFF)
+#define ISO_NORST2_SWC_dat(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define ISO_NORST2_SWC_dat_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define ISO_NORST2_SWC_get_dat(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_TCWOV_RSTB_CNT                                                           0x180076C0
+#define ISO_TCWOV_RSTB_CNT_reg_addr                                                  "0xB80076C0"
+#define ISO_TCWOV_RSTB_CNT_reg                                                       0xB80076C0
+#define set_ISO_TCWOV_RSTB_CNT_reg(data)   (*((volatile unsigned int*) ISO_TCWOV_RSTB_CNT_reg)=data)
+#define get_ISO_TCWOV_RSTB_CNT_reg   (*((volatile unsigned int*) ISO_TCWOV_RSTB_CNT_reg))
+#define ISO_TCWOV_RSTB_CNT_inst_adr                                                  "0x00B0"
+#define ISO_TCWOV_RSTB_CNT_inst                                                      0x00B0
+#define ISO_TCWOV_RSTB_CNT_sel_shift                                                 (0)
+#define ISO_TCWOV_RSTB_CNT_sel_mask                                                  (0xFFFFFFFF)
+#define ISO_TCWOV_RSTB_CNT_sel(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define ISO_TCWOV_RSTB_CNT_sel_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define ISO_TCWOV_RSTB_CNT_get_sel(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_CPU_ST2V                                                                 0x18007738
+#define ISO_CPU_ST2V_reg_addr                                                        "0xB8007738"
+#define ISO_CPU_ST2V_reg                                                             0xB8007738
+#define set_ISO_CPU_ST2V_reg(data)   (*((volatile unsigned int*) ISO_CPU_ST2V_reg)=data)
+#define get_ISO_CPU_ST2V_reg   (*((volatile unsigned int*) ISO_CPU_ST2V_reg))
+#define ISO_CPU_ST2V_inst_adr                                                        "0x00CE"
+#define ISO_CPU_ST2V_inst                                                            0x00CE
+#define ISO_CPU_ST2V_scpu_boot_info_valid_shift                                      (0)
+#define ISO_CPU_ST2V_scpu_boot_info_valid_mask                                       (0x00000001)
+#define ISO_CPU_ST2V_scpu_boot_info_valid(data)                                      (0x00000001&((data)<<0))
+#define ISO_CPU_ST2V_scpu_boot_info_valid_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_CPU_ST2V_get_scpu_boot_info_valid(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_CPU_ST2                                                                  0x1800773C
+#define ISO_CPU_ST2_reg_addr                                                         "0xB800773C"
+#define ISO_CPU_ST2_reg                                                              0xB800773C
+#define set_ISO_CPU_ST2_reg(data)   (*((volatile unsigned int*) ISO_CPU_ST2_reg)=data)
+#define get_ISO_CPU_ST2_reg   (*((volatile unsigned int*) ISO_CPU_ST2_reg))
+#define ISO_CPU_ST2_inst_adr                                                         "0x00CF"
+#define ISO_CPU_ST2_inst                                                             0x00CF
+#define ISO_CPU_ST2_scpu_boot_info_shift                                             (0)
+#define ISO_CPU_ST2_scpu_boot_info_mask                                              (0xFFFFFFFF)
+#define ISO_CPU_ST2_scpu_boot_info(data)                                             (0xFFFFFFFF&((data)<<0))
+#define ISO_CPU_ST2_scpu_boot_info_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define ISO_CPU_ST2_get_scpu_boot_info(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_ACPU_DBG                                                                 0x18007740
+#define ISO_ACPU_DBG_reg_addr                                                        "0xB8007740"
+#define ISO_ACPU_DBG_reg                                                             0xB8007740
+#define set_ISO_ACPU_DBG_reg(data)   (*((volatile unsigned int*) ISO_ACPU_DBG_reg)=data)
+#define get_ISO_ACPU_DBG_reg   (*((volatile unsigned int*) ISO_ACPU_DBG_reg))
+#define ISO_ACPU_DBG_inst_adr                                                        "0x00D0"
+#define ISO_ACPU_DBG_inst                                                            0x00D0
+#define ISO_ACPU_DBG_write_enable3_shift                                             (13)
+#define ISO_ACPU_DBG_write_enable3_mask                                              (0x00002000)
+#define ISO_ACPU_DBG_write_enable3(data)                                             (0x00002000&((data)<<13))
+#define ISO_ACPU_DBG_write_enable3_src(data)                                         ((0x00002000&(data))>>13)
+#define ISO_ACPU_DBG_get_write_enable3(data)                                         ((0x00002000&(data))>>13)
+#define ISO_ACPU_DBG_sel1_shift                                                      (8)
+#define ISO_ACPU_DBG_sel1_mask                                                       (0x00001F00)
+#define ISO_ACPU_DBG_sel1(data)                                                      (0x00001F00&((data)<<8))
+#define ISO_ACPU_DBG_sel1_src(data)                                                  ((0x00001F00&(data))>>8)
+#define ISO_ACPU_DBG_get_sel1(data)                                                  ((0x00001F00&(data))>>8)
+#define ISO_ACPU_DBG_write_enable2_shift                                             (7)
+#define ISO_ACPU_DBG_write_enable2_mask                                              (0x00000080)
+#define ISO_ACPU_DBG_write_enable2(data)                                             (0x00000080&((data)<<7))
+#define ISO_ACPU_DBG_write_enable2_src(data)                                         ((0x00000080&(data))>>7)
+#define ISO_ACPU_DBG_get_write_enable2(data)                                         ((0x00000080&(data))>>7)
+#define ISO_ACPU_DBG_sel0_shift                                                      (2)
+#define ISO_ACPU_DBG_sel0_mask                                                       (0x0000007C)
+#define ISO_ACPU_DBG_sel0(data)                                                      (0x0000007C&((data)<<2))
+#define ISO_ACPU_DBG_sel0_src(data)                                                  ((0x0000007C&(data))>>2)
+#define ISO_ACPU_DBG_get_sel0(data)                                                  ((0x0000007C&(data))>>2)
+#define ISO_ACPU_DBG_write_enable1_shift                                             (1)
+#define ISO_ACPU_DBG_write_enable1_mask                                              (0x00000002)
+#define ISO_ACPU_DBG_write_enable1(data)                                             (0x00000002&((data)<<1))
+#define ISO_ACPU_DBG_write_enable1_src(data)                                         ((0x00000002&(data))>>1)
+#define ISO_ACPU_DBG_get_write_enable1(data)                                         ((0x00000002&(data))>>1)
+#define ISO_ACPU_DBG_enable_shift                                                    (0)
+#define ISO_ACPU_DBG_enable_mask                                                     (0x00000001)
+#define ISO_ACPU_DBG_enable(data)                                                    (0x00000001&((data)<<0))
+#define ISO_ACPU_DBG_enable_src(data)                                                ((0x00000001&(data))>>0)
+#define ISO_ACPU_DBG_get_enable(data)                                                ((0x00000001&(data))>>0)
+
+
+#define ISO_ANLG                                                                     0x18007744
+#define ISO_ANLG_reg_addr                                                            "0xB8007744"
+#define ISO_ANLG_reg                                                                 0xB8007744
+#define set_ISO_ANLG_reg(data)   (*((volatile unsigned int*) ISO_ANLG_reg)=data)
+#define get_ISO_ANLG_reg   (*((volatile unsigned int*) ISO_ANLG_reg))
+#define ISO_ANLG_inst_adr                                                            "0x00D1"
+#define ISO_ANLG_inst                                                                0x00D1
+#define ISO_ANLG_analogy_mode_in_shift                                               (0)
+#define ISO_ANLG_analogy_mode_in_mask                                                (0x00000001)
+#define ISO_ANLG_analogy_mode_in(data)                                               (0x00000001&((data)<<0))
+#define ISO_ANLG_analogy_mode_in_src(data)                                           ((0x00000001&(data))>>0)
+#define ISO_ANLG_get_analogy_mode_in(data)                                           ((0x00000001&(data))>>0)
+
+
+#define ISO_U0RBR_THR_DLL                                                            0x18007800
+#define ISO_U0RBR_THR_DLL_reg_addr                                                   "0xB8007800"
+#define ISO_U0RBR_THR_DLL_reg                                                        0xB8007800
+#define set_ISO_U0RBR_THR_DLL_reg(data)   (*((volatile unsigned int*) ISO_U0RBR_THR_DLL_reg)=data)
+#define get_ISO_U0RBR_THR_DLL_reg   (*((volatile unsigned int*) ISO_U0RBR_THR_DLL_reg))
+#define ISO_U0RBR_THR_DLL_inst_adr                                                   "0x0000"
+#define ISO_U0RBR_THR_DLL_inst                                                       0x0000
+#define ISO_U0RBR_THR_DLL_dll_shift                                                  (0)
+#define ISO_U0RBR_THR_DLL_dll_mask                                                   (0x000000FF)
+#define ISO_U0RBR_THR_DLL_dll(data)                                                  (0x000000FF&((data)<<0))
+#define ISO_U0RBR_THR_DLL_dll_src(data)                                              ((0x000000FF&(data))>>0)
+#define ISO_U0RBR_THR_DLL_get_dll(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0IER_DLH                                                                0x18007804
+#define ISO_U0IER_DLH_reg_addr                                                       "0xB8007804"
+#define ISO_U0IER_DLH_reg                                                            0xB8007804
+#define set_ISO_U0IER_DLH_reg(data)   (*((volatile unsigned int*) ISO_U0IER_DLH_reg)=data)
+#define get_ISO_U0IER_DLH_reg   (*((volatile unsigned int*) ISO_U0IER_DLH_reg))
+#define ISO_U0IER_DLH_inst_adr                                                       "0x0001"
+#define ISO_U0IER_DLH_inst                                                           0x0001
+#define ISO_U0IER_DLH_dlh_shift                                                      (0)
+#define ISO_U0IER_DLH_dlh_mask                                                       (0x000000FF)
+#define ISO_U0IER_DLH_dlh(data)                                                      (0x000000FF&((data)<<0))
+#define ISO_U0IER_DLH_dlh_src(data)                                                  ((0x000000FF&(data))>>0)
+#define ISO_U0IER_DLH_get_dlh(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0IIR_FCR                                                                0x18007808
+#define ISO_U0IIR_FCR_reg_addr                                                       "0xB8007808"
+#define ISO_U0IIR_FCR_reg                                                            0xB8007808
+#define set_ISO_U0IIR_FCR_reg(data)   (*((volatile unsigned int*) ISO_U0IIR_FCR_reg)=data)
+#define get_ISO_U0IIR_FCR_reg   (*((volatile unsigned int*) ISO_U0IIR_FCR_reg))
+#define ISO_U0IIR_FCR_inst_adr                                                       "0x0002"
+#define ISO_U0IIR_FCR_inst                                                           0x0002
+#define ISO_U0IIR_FCR_fifo16_shift                                                   (6)
+#define ISO_U0IIR_FCR_fifo16_mask                                                    (0x000000C0)
+#define ISO_U0IIR_FCR_fifo16(data)                                                   (0x000000C0&((data)<<6))
+#define ISO_U0IIR_FCR_fifo16_src(data)                                               ((0x000000C0&(data))>>6)
+#define ISO_U0IIR_FCR_get_fifo16(data)                                               ((0x000000C0&(data))>>6)
+#define ISO_U0IIR_FCR_iid_shift                                                      (0)
+#define ISO_U0IIR_FCR_iid_mask                                                       (0x0000000F)
+#define ISO_U0IIR_FCR_iid(data)                                                      (0x0000000F&((data)<<0))
+#define ISO_U0IIR_FCR_iid_src(data)                                                  ((0x0000000F&(data))>>0)
+#define ISO_U0IIR_FCR_get_iid(data)                                                  ((0x0000000F&(data))>>0)
+
+
+#define ISO_U0LCR                                                                    0x1800780C
+#define ISO_U0LCR_reg_addr                                                           "0xB800780C"
+#define ISO_U0LCR_reg                                                                0xB800780C
+#define set_ISO_U0LCR_reg(data)   (*((volatile unsigned int*) ISO_U0LCR_reg)=data)
+#define get_ISO_U0LCR_reg   (*((volatile unsigned int*) ISO_U0LCR_reg))
+#define ISO_U0LCR_inst_adr                                                           "0x0003"
+#define ISO_U0LCR_inst                                                               0x0003
+#define ISO_U0LCR_dlab_shift                                                         (7)
+#define ISO_U0LCR_dlab_mask                                                          (0x00000080)
+#define ISO_U0LCR_dlab(data)                                                         (0x00000080&((data)<<7))
+#define ISO_U0LCR_dlab_src(data)                                                     ((0x00000080&(data))>>7)
+#define ISO_U0LCR_get_dlab(data)                                                     ((0x00000080&(data))>>7)
+#define ISO_U0LCR_brk_shift                                                          (6)
+#define ISO_U0LCR_brk_mask                                                           (0x00000040)
+#define ISO_U0LCR_brk(data)                                                          (0x00000040&((data)<<6))
+#define ISO_U0LCR_brk_src(data)                                                      ((0x00000040&(data))>>6)
+#define ISO_U0LCR_get_brk(data)                                                      ((0x00000040&(data))>>6)
+#define ISO_U0LCR_eps_shift                                                          (4)
+#define ISO_U0LCR_eps_mask                                                           (0x00000010)
+#define ISO_U0LCR_eps(data)                                                          (0x00000010&((data)<<4))
+#define ISO_U0LCR_eps_src(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0LCR_get_eps(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0LCR_pen_shift                                                          (3)
+#define ISO_U0LCR_pen_mask                                                           (0x00000008)
+#define ISO_U0LCR_pen(data)                                                          (0x00000008&((data)<<3))
+#define ISO_U0LCR_pen_src(data)                                                      ((0x00000008&(data))>>3)
+#define ISO_U0LCR_get_pen(data)                                                      ((0x00000008&(data))>>3)
+#define ISO_U0LCR_stb_shift                                                          (2)
+#define ISO_U0LCR_stb_mask                                                           (0x00000004)
+#define ISO_U0LCR_stb(data)                                                          (0x00000004&((data)<<2))
+#define ISO_U0LCR_stb_src(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0LCR_get_stb(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0LCR_wls_shift                                                          (0)
+#define ISO_U0LCR_wls_mask                                                           (0x00000003)
+#define ISO_U0LCR_wls(data)                                                          (0x00000003&((data)<<0))
+#define ISO_U0LCR_wls_src(data)                                                      ((0x00000003&(data))>>0)
+#define ISO_U0LCR_get_wls(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define ISO_U0MCR                                                                    0x18007810
+#define ISO_U0MCR_reg_addr                                                           "0xB8007810"
+#define ISO_U0MCR_reg                                                                0xB8007810
+#define set_ISO_U0MCR_reg(data)   (*((volatile unsigned int*) ISO_U0MCR_reg)=data)
+#define get_ISO_U0MCR_reg   (*((volatile unsigned int*) ISO_U0MCR_reg))
+#define ISO_U0MCR_inst_adr                                                           "0x0004"
+#define ISO_U0MCR_inst                                                               0x0004
+#define ISO_U0MCR_afce_shift                                                         (5)
+#define ISO_U0MCR_afce_mask                                                          (0x00000020)
+#define ISO_U0MCR_afce(data)                                                         (0x00000020&((data)<<5))
+#define ISO_U0MCR_afce_src(data)                                                     ((0x00000020&(data))>>5)
+#define ISO_U0MCR_get_afce(data)                                                     ((0x00000020&(data))>>5)
+#define ISO_U0MCR_loop_shift                                                         (4)
+#define ISO_U0MCR_loop_mask                                                          (0x00000010)
+#define ISO_U0MCR_loop(data)                                                         (0x00000010&((data)<<4))
+#define ISO_U0MCR_loop_src(data)                                                     ((0x00000010&(data))>>4)
+#define ISO_U0MCR_get_loop(data)                                                     ((0x00000010&(data))>>4)
+#define ISO_U0MCR_rts_shift                                                          (1)
+#define ISO_U0MCR_rts_mask                                                           (0x00000002)
+#define ISO_U0MCR_rts(data)                                                          (0x00000002&((data)<<1))
+#define ISO_U0MCR_rts_src(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_U0MCR_get_rts(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_U0MCR_dtr_shift                                                          (0)
+#define ISO_U0MCR_dtr_mask                                                           (0x00000001)
+#define ISO_U0MCR_dtr(data)                                                          (0x00000001&((data)<<0))
+#define ISO_U0MCR_dtr_src(data)                                                      ((0x00000001&(data))>>0)
+#define ISO_U0MCR_get_dtr(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_U0LSR                                                                    0x18007814
+#define ISO_U0LSR_reg_addr                                                           "0xB8007814"
+#define ISO_U0LSR_reg                                                                0xB8007814
+#define set_ISO_U0LSR_reg(data)   (*((volatile unsigned int*) ISO_U0LSR_reg)=data)
+#define get_ISO_U0LSR_reg   (*((volatile unsigned int*) ISO_U0LSR_reg))
+#define ISO_U0LSR_inst_adr                                                           "0x0005"
+#define ISO_U0LSR_inst                                                               0x0005
+#define ISO_U0LSR_rfe_shift                                                          (7)
+#define ISO_U0LSR_rfe_mask                                                           (0x00000080)
+#define ISO_U0LSR_rfe(data)                                                          (0x00000080&((data)<<7))
+#define ISO_U0LSR_rfe_src(data)                                                      ((0x00000080&(data))>>7)
+#define ISO_U0LSR_get_rfe(data)                                                      ((0x00000080&(data))>>7)
+#define ISO_U0LSR_temt_shift                                                         (6)
+#define ISO_U0LSR_temt_mask                                                          (0x00000040)
+#define ISO_U0LSR_temt(data)                                                         (0x00000040&((data)<<6))
+#define ISO_U0LSR_temt_src(data)                                                     ((0x00000040&(data))>>6)
+#define ISO_U0LSR_get_temt(data)                                                     ((0x00000040&(data))>>6)
+#define ISO_U0LSR_thre_shift                                                         (5)
+#define ISO_U0LSR_thre_mask                                                          (0x00000020)
+#define ISO_U0LSR_thre(data)                                                         (0x00000020&((data)<<5))
+#define ISO_U0LSR_thre_src(data)                                                     ((0x00000020&(data))>>5)
+#define ISO_U0LSR_get_thre(data)                                                     ((0x00000020&(data))>>5)
+#define ISO_U0LSR_bi_shift                                                           (4)
+#define ISO_U0LSR_bi_mask                                                            (0x00000010)
+#define ISO_U0LSR_bi(data)                                                           (0x00000010&((data)<<4))
+#define ISO_U0LSR_bi_src(data)                                                       ((0x00000010&(data))>>4)
+#define ISO_U0LSR_get_bi(data)                                                       ((0x00000010&(data))>>4)
+#define ISO_U0LSR_fe_shift                                                           (3)
+#define ISO_U0LSR_fe_mask                                                            (0x00000008)
+#define ISO_U0LSR_fe(data)                                                           (0x00000008&((data)<<3))
+#define ISO_U0LSR_fe_src(data)                                                       ((0x00000008&(data))>>3)
+#define ISO_U0LSR_get_fe(data)                                                       ((0x00000008&(data))>>3)
+#define ISO_U0LSR_pe_shift                                                           (2)
+#define ISO_U0LSR_pe_mask                                                            (0x00000004)
+#define ISO_U0LSR_pe(data)                                                           (0x00000004&((data)<<2))
+#define ISO_U0LSR_pe_src(data)                                                       ((0x00000004&(data))>>2)
+#define ISO_U0LSR_get_pe(data)                                                       ((0x00000004&(data))>>2)
+#define ISO_U0LSR_oe_shift                                                           (1)
+#define ISO_U0LSR_oe_mask                                                            (0x00000002)
+#define ISO_U0LSR_oe(data)                                                           (0x00000002&((data)<<1))
+#define ISO_U0LSR_oe_src(data)                                                       ((0x00000002&(data))>>1)
+#define ISO_U0LSR_get_oe(data)                                                       ((0x00000002&(data))>>1)
+#define ISO_U0LSR_dr_shift                                                           (0)
+#define ISO_U0LSR_dr_mask                                                            (0x00000001)
+#define ISO_U0LSR_dr(data)                                                           (0x00000001&((data)<<0))
+#define ISO_U0LSR_dr_src(data)                                                       ((0x00000001&(data))>>0)
+#define ISO_U0LSR_get_dr(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_U0MSR                                                                    0x18007818
+#define ISO_U0MSR_reg_addr                                                           "0xB8007818"
+#define ISO_U0MSR_reg                                                                0xB8007818
+#define set_ISO_U0MSR_reg(data)   (*((volatile unsigned int*) ISO_U0MSR_reg)=data)
+#define get_ISO_U0MSR_reg   (*((volatile unsigned int*) ISO_U0MSR_reg))
+#define ISO_U0MSR_inst_adr                                                           "0x0006"
+#define ISO_U0MSR_inst                                                               0x0006
+#define ISO_U0MSR_dcd_shift                                                          (7)
+#define ISO_U0MSR_dcd_mask                                                           (0x00000080)
+#define ISO_U0MSR_dcd(data)                                                          (0x00000080&((data)<<7))
+#define ISO_U0MSR_dcd_src(data)                                                      ((0x00000080&(data))>>7)
+#define ISO_U0MSR_get_dcd(data)                                                      ((0x00000080&(data))>>7)
+#define ISO_U0MSR_ri_shift                                                           (6)
+#define ISO_U0MSR_ri_mask                                                            (0x00000040)
+#define ISO_U0MSR_ri(data)                                                           (0x00000040&((data)<<6))
+#define ISO_U0MSR_ri_src(data)                                                       ((0x00000040&(data))>>6)
+#define ISO_U0MSR_get_ri(data)                                                       ((0x00000040&(data))>>6)
+#define ISO_U0MSR_dsr_shift                                                          (5)
+#define ISO_U0MSR_dsr_mask                                                           (0x00000020)
+#define ISO_U0MSR_dsr(data)                                                          (0x00000020&((data)<<5))
+#define ISO_U0MSR_dsr_src(data)                                                      ((0x00000020&(data))>>5)
+#define ISO_U0MSR_get_dsr(data)                                                      ((0x00000020&(data))>>5)
+#define ISO_U0MSR_cts_shift                                                          (4)
+#define ISO_U0MSR_cts_mask                                                           (0x00000010)
+#define ISO_U0MSR_cts(data)                                                          (0x00000010&((data)<<4))
+#define ISO_U0MSR_cts_src(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0MSR_get_cts(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0MSR_ddcd_shift                                                         (3)
+#define ISO_U0MSR_ddcd_mask                                                          (0x00000008)
+#define ISO_U0MSR_ddcd(data)                                                         (0x00000008&((data)<<3))
+#define ISO_U0MSR_ddcd_src(data)                                                     ((0x00000008&(data))>>3)
+#define ISO_U0MSR_get_ddcd(data)                                                     ((0x00000008&(data))>>3)
+#define ISO_U0MSR_teri_shift                                                         (2)
+#define ISO_U0MSR_teri_mask                                                          (0x00000004)
+#define ISO_U0MSR_teri(data)                                                         (0x00000004&((data)<<2))
+#define ISO_U0MSR_teri_src(data)                                                     ((0x00000004&(data))>>2)
+#define ISO_U0MSR_get_teri(data)                                                     ((0x00000004&(data))>>2)
+#define ISO_U0MSR_ddsr_shift                                                         (1)
+#define ISO_U0MSR_ddsr_mask                                                          (0x00000002)
+#define ISO_U0MSR_ddsr(data)                                                         (0x00000002&((data)<<1))
+#define ISO_U0MSR_ddsr_src(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_U0MSR_get_ddsr(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_U0MSR_dcts_shift                                                         (0)
+#define ISO_U0MSR_dcts_mask                                                          (0x00000001)
+#define ISO_U0MSR_dcts(data)                                                         (0x00000001&((data)<<0))
+#define ISO_U0MSR_dcts_src(data)                                                     ((0x00000001&(data))>>0)
+#define ISO_U0MSR_get_dcts(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_U0SCR                                                                    0x1800781C
+#define ISO_U0SCR_reg_addr                                                           "0xB800781C"
+#define ISO_U0SCR_reg                                                                0xB800781C
+#define set_ISO_U0SCR_reg(data)   (*((volatile unsigned int*) ISO_U0SCR_reg)=data)
+#define get_ISO_U0SCR_reg   (*((volatile unsigned int*) ISO_U0SCR_reg))
+#define ISO_U0SCR_inst_adr                                                           "0x0007"
+#define ISO_U0SCR_inst                                                               0x0007
+#define ISO_U0SCR_scr_shift                                                          (0)
+#define ISO_U0SCR_scr_mask                                                           (0x000000FF)
+#define ISO_U0SCR_scr(data)                                                          (0x000000FF&((data)<<0))
+#define ISO_U0SCR_scr_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ISO_U0SCR_get_scr(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0SRBR_0                                                                 0x18007830
+#define ISO_U0SRBR_1                                                                 0x18007834
+#define ISO_U0SRBR_2                                                                 0x18007838
+#define ISO_U0SRBR_3                                                                 0x1800783C
+#define ISO_U0SRBR_4                                                                 0x18007840
+#define ISO_U0SRBR_5                                                                 0x18007844
+#define ISO_U0SRBR_6                                                                 0x18007848
+#define ISO_U0SRBR_7                                                                 0x1800784C
+#define ISO_U0SRBR_8                                                                 0x18007850
+#define ISO_U0SRBR_9                                                                 0x18007854
+#define ISO_U0SRBR_10                                                                 0x18007858
+#define ISO_U0SRBR_11                                                                 0x1800785C
+#define ISO_U0SRBR_12                                                                 0x18007860
+#define ISO_U0SRBR_13                                                                 0x18007864
+#define ISO_U0SRBR_14                                                                 0x18007868
+#define ISO_U0SRBR_15                                                                 0x1800786C
+#define ISO_U0SRBR_0_reg_addr                                                        "0xB8007830"
+#define ISO_U0SRBR_1_reg_addr                                                        "0xB8007834"
+#define ISO_U0SRBR_2_reg_addr                                                        "0xB8007838"
+#define ISO_U0SRBR_3_reg_addr                                                        "0xB800783C"
+#define ISO_U0SRBR_4_reg_addr                                                        "0xB8007840"
+#define ISO_U0SRBR_5_reg_addr                                                        "0xB8007844"
+#define ISO_U0SRBR_6_reg_addr                                                        "0xB8007848"
+#define ISO_U0SRBR_7_reg_addr                                                        "0xB800784C"
+#define ISO_U0SRBR_8_reg_addr                                                        "0xB8007850"
+#define ISO_U0SRBR_9_reg_addr                                                        "0xB8007854"
+#define ISO_U0SRBR_10_reg_addr                                                        "0xB8007858"
+#define ISO_U0SRBR_11_reg_addr                                                        "0xB800785C"
+#define ISO_U0SRBR_12_reg_addr                                                        "0xB8007860"
+#define ISO_U0SRBR_13_reg_addr                                                        "0xB8007864"
+#define ISO_U0SRBR_14_reg_addr                                                        "0xB8007868"
+#define ISO_U0SRBR_15_reg_addr                                                        "0xB800786C"
+#define ISO_U0SRBR_0_reg                                                             0xB8007830
+#define ISO_U0SRBR_1_reg                                                             0xB8007834
+#define ISO_U0SRBR_2_reg                                                             0xB8007838
+#define ISO_U0SRBR_3_reg                                                             0xB800783C
+#define ISO_U0SRBR_4_reg                                                             0xB8007840
+#define ISO_U0SRBR_5_reg                                                             0xB8007844
+#define ISO_U0SRBR_6_reg                                                             0xB8007848
+#define ISO_U0SRBR_7_reg                                                             0xB800784C
+#define ISO_U0SRBR_8_reg                                                             0xB8007850
+#define ISO_U0SRBR_9_reg                                                             0xB8007854
+#define ISO_U0SRBR_10_reg                                                             0xB8007858
+#define ISO_U0SRBR_11_reg                                                             0xB800785C
+#define ISO_U0SRBR_12_reg                                                             0xB8007860
+#define ISO_U0SRBR_13_reg                                                             0xB8007864
+#define ISO_U0SRBR_14_reg                                                             0xB8007868
+#define ISO_U0SRBR_15_reg                                                             0xB800786C
+#define set_ISO_U0SRBR_0_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_0_reg)=data)
+#define set_ISO_U0SRBR_1_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_1_reg)=data)
+#define set_ISO_U0SRBR_2_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_2_reg)=data)
+#define set_ISO_U0SRBR_3_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_3_reg)=data)
+#define set_ISO_U0SRBR_4_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_4_reg)=data)
+#define set_ISO_U0SRBR_5_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_5_reg)=data)
+#define set_ISO_U0SRBR_6_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_6_reg)=data)
+#define set_ISO_U0SRBR_7_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_7_reg)=data)
+#define set_ISO_U0SRBR_8_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_8_reg)=data)
+#define set_ISO_U0SRBR_9_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_9_reg)=data)
+#define set_ISO_U0SRBR_10_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_10_reg)=data)
+#define set_ISO_U0SRBR_11_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_11_reg)=data)
+#define set_ISO_U0SRBR_12_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_12_reg)=data)
+#define set_ISO_U0SRBR_13_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_13_reg)=data)
+#define set_ISO_U0SRBR_14_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_14_reg)=data)
+#define set_ISO_U0SRBR_15_reg(data)   (*((volatile unsigned int*) ISO_U0SRBR_15_reg)=data)
+#define get_ISO_U0SRBR_0_reg   (*((volatile unsigned int*) ISO_U0SRBR_0_reg))
+#define get_ISO_U0SRBR_1_reg   (*((volatile unsigned int*) ISO_U0SRBR_1_reg))
+#define get_ISO_U0SRBR_2_reg   (*((volatile unsigned int*) ISO_U0SRBR_2_reg))
+#define get_ISO_U0SRBR_3_reg   (*((volatile unsigned int*) ISO_U0SRBR_3_reg))
+#define get_ISO_U0SRBR_4_reg   (*((volatile unsigned int*) ISO_U0SRBR_4_reg))
+#define get_ISO_U0SRBR_5_reg   (*((volatile unsigned int*) ISO_U0SRBR_5_reg))
+#define get_ISO_U0SRBR_6_reg   (*((volatile unsigned int*) ISO_U0SRBR_6_reg))
+#define get_ISO_U0SRBR_7_reg   (*((volatile unsigned int*) ISO_U0SRBR_7_reg))
+#define get_ISO_U0SRBR_8_reg   (*((volatile unsigned int*) ISO_U0SRBR_8_reg))
+#define get_ISO_U0SRBR_9_reg   (*((volatile unsigned int*) ISO_U0SRBR_9_reg))
+#define get_ISO_U0SRBR_10_reg   (*((volatile unsigned int*) ISO_U0SRBR_10_reg))
+#define get_ISO_U0SRBR_11_reg   (*((volatile unsigned int*) ISO_U0SRBR_11_reg))
+#define get_ISO_U0SRBR_12_reg   (*((volatile unsigned int*) ISO_U0SRBR_12_reg))
+#define get_ISO_U0SRBR_13_reg   (*((volatile unsigned int*) ISO_U0SRBR_13_reg))
+#define get_ISO_U0SRBR_14_reg   (*((volatile unsigned int*) ISO_U0SRBR_14_reg))
+#define get_ISO_U0SRBR_15_reg   (*((volatile unsigned int*) ISO_U0SRBR_15_reg))
+#define ISO_U0SRBR_0_inst_adr                                                        "0x000C"
+#define ISO_U0SRBR_1_inst_adr                                                        "0x000D"
+#define ISO_U0SRBR_2_inst_adr                                                        "0x000E"
+#define ISO_U0SRBR_3_inst_adr                                                        "0x000F"
+#define ISO_U0SRBR_4_inst_adr                                                        "0x0010"
+#define ISO_U0SRBR_5_inst_adr                                                        "0x0011"
+#define ISO_U0SRBR_6_inst_adr                                                        "0x0012"
+#define ISO_U0SRBR_7_inst_adr                                                        "0x0013"
+#define ISO_U0SRBR_8_inst_adr                                                        "0x0014"
+#define ISO_U0SRBR_9_inst_adr                                                        "0x0015"
+#define ISO_U0SRBR_10_inst_adr                                                        "0x0016"
+#define ISO_U0SRBR_11_inst_adr                                                        "0x0017"
+#define ISO_U0SRBR_12_inst_adr                                                        "0x0018"
+#define ISO_U0SRBR_13_inst_adr                                                        "0x0019"
+#define ISO_U0SRBR_14_inst_adr                                                        "0x001A"
+#define ISO_U0SRBR_15_inst_adr                                                        "0x001B"
+#define ISO_U0SRBR_0_inst                                                            0x000C
+#define ISO_U0SRBR_1_inst                                                            0x000D
+#define ISO_U0SRBR_2_inst                                                            0x000E
+#define ISO_U0SRBR_3_inst                                                            0x000F
+#define ISO_U0SRBR_4_inst                                                            0x0010
+#define ISO_U0SRBR_5_inst                                                            0x0011
+#define ISO_U0SRBR_6_inst                                                            0x0012
+#define ISO_U0SRBR_7_inst                                                            0x0013
+#define ISO_U0SRBR_8_inst                                                            0x0014
+#define ISO_U0SRBR_9_inst                                                            0x0015
+#define ISO_U0SRBR_10_inst                                                            0x0016
+#define ISO_U0SRBR_11_inst                                                            0x0017
+#define ISO_U0SRBR_12_inst                                                            0x0018
+#define ISO_U0SRBR_13_inst                                                            0x0019
+#define ISO_U0SRBR_14_inst                                                            0x001A
+#define ISO_U0SRBR_15_inst                                                            0x001B
+#define ISO_U0SRBR_rbd_shift                                                         (0)
+#define ISO_U0SRBR_rbd_mask                                                          (0x000000FF)
+#define ISO_U0SRBR_rbd(data)                                                         (0x000000FF&((data)<<0))
+#define ISO_U0SRBR_rbd_src(data)                                                     ((0x000000FF&(data))>>0)
+#define ISO_U0SRBR_get_rbd(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0FAR                                                                    0x18007870
+#define ISO_U0FAR_reg_addr                                                           "0xB8007870"
+#define ISO_U0FAR_reg                                                                0xB8007870
+#define set_ISO_U0FAR_reg(data)   (*((volatile unsigned int*) ISO_U0FAR_reg)=data)
+#define get_ISO_U0FAR_reg   (*((volatile unsigned int*) ISO_U0FAR_reg))
+#define ISO_U0FAR_inst_adr                                                           "0x001C"
+#define ISO_U0FAR_inst                                                               0x001C
+#define ISO_U0FAR_far_shift                                                          (0)
+#define ISO_U0FAR_far_mask                                                           (0x00000001)
+#define ISO_U0FAR_far(data)                                                          (0x00000001&((data)<<0))
+#define ISO_U0FAR_far_src(data)                                                      ((0x00000001&(data))>>0)
+#define ISO_U0FAR_get_far(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_U0TFR                                                                    0x18007874
+#define ISO_U0TFR_reg_addr                                                           "0xB8007874"
+#define ISO_U0TFR_reg                                                                0xB8007874
+#define set_ISO_U0TFR_reg(data)   (*((volatile unsigned int*) ISO_U0TFR_reg)=data)
+#define get_ISO_U0TFR_reg   (*((volatile unsigned int*) ISO_U0TFR_reg))
+#define ISO_U0TFR_inst_adr                                                           "0x001D"
+#define ISO_U0TFR_inst                                                               0x001D
+#define ISO_U0TFR_far_shift                                                          (0)
+#define ISO_U0TFR_far_mask                                                           (0x000000FF)
+#define ISO_U0TFR_far(data)                                                          (0x000000FF&((data)<<0))
+#define ISO_U0TFR_far_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ISO_U0TFR_get_far(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0RFW                                                                    0x18007878
+#define ISO_U0RFW_reg_addr                                                           "0xB8007878"
+#define ISO_U0RFW_reg                                                                0xB8007878
+#define set_ISO_U0RFW_reg(data)   (*((volatile unsigned int*) ISO_U0RFW_reg)=data)
+#define get_ISO_U0RFW_reg   (*((volatile unsigned int*) ISO_U0RFW_reg))
+#define ISO_U0RFW_inst_adr                                                           "0x001E"
+#define ISO_U0RFW_inst                                                               0x001E
+#define ISO_U0RFW_rffe_shift                                                         (9)
+#define ISO_U0RFW_rffe_mask                                                          (0x00000200)
+#define ISO_U0RFW_rffe(data)                                                         (0x00000200&((data)<<9))
+#define ISO_U0RFW_rffe_src(data)                                                     ((0x00000200&(data))>>9)
+#define ISO_U0RFW_get_rffe(data)                                                     ((0x00000200&(data))>>9)
+#define ISO_U0RFW_rfpf_shift                                                         (8)
+#define ISO_U0RFW_rfpf_mask                                                          (0x00000100)
+#define ISO_U0RFW_rfpf(data)                                                         (0x00000100&((data)<<8))
+#define ISO_U0RFW_rfpf_src(data)                                                     ((0x00000100&(data))>>8)
+#define ISO_U0RFW_get_rfpf(data)                                                     ((0x00000100&(data))>>8)
+#define ISO_U0RFW_rfwd_shift                                                         (0)
+#define ISO_U0RFW_rfwd_mask                                                          (0x000000FF)
+#define ISO_U0RFW_rfwd(data)                                                         (0x000000FF&((data)<<0))
+#define ISO_U0RFW_rfwd_src(data)                                                     ((0x000000FF&(data))>>0)
+#define ISO_U0RFW_get_rfwd(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0USR                                                                    0x1800787C
+#define ISO_U0USR_reg_addr                                                           "0xB800787C"
+#define ISO_U0USR_reg                                                                0xB800787C
+#define set_ISO_U0USR_reg(data)   (*((volatile unsigned int*) ISO_U0USR_reg)=data)
+#define get_ISO_U0USR_reg   (*((volatile unsigned int*) ISO_U0USR_reg))
+#define ISO_U0USR_inst_adr                                                           "0x001F"
+#define ISO_U0USR_inst                                                               0x001F
+#define ISO_U0USR_rff_shift                                                          (4)
+#define ISO_U0USR_rff_mask                                                           (0x00000010)
+#define ISO_U0USR_rff(data)                                                          (0x00000010&((data)<<4))
+#define ISO_U0USR_rff_src(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0USR_get_rff(data)                                                      ((0x00000010&(data))>>4)
+#define ISO_U0USR_rfne_shift                                                         (3)
+#define ISO_U0USR_rfne_mask                                                          (0x00000008)
+#define ISO_U0USR_rfne(data)                                                         (0x00000008&((data)<<3))
+#define ISO_U0USR_rfne_src(data)                                                     ((0x00000008&(data))>>3)
+#define ISO_U0USR_get_rfne(data)                                                     ((0x00000008&(data))>>3)
+#define ISO_U0USR_tfe_shift                                                          (2)
+#define ISO_U0USR_tfe_mask                                                           (0x00000004)
+#define ISO_U0USR_tfe(data)                                                          (0x00000004&((data)<<2))
+#define ISO_U0USR_tfe_src(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0USR_get_tfe(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0USR_tfnf_shift                                                         (1)
+#define ISO_U0USR_tfnf_mask                                                          (0x00000002)
+#define ISO_U0USR_tfnf(data)                                                         (0x00000002&((data)<<1))
+#define ISO_U0USR_tfnf_src(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_U0USR_get_tfnf(data)                                                     ((0x00000002&(data))>>1)
+#define ISO_U0USR_busy_shift                                                         (0)
+#define ISO_U0USR_busy_mask                                                          (0x00000001)
+#define ISO_U0USR_busy(data)                                                         (0x00000001&((data)<<0))
+#define ISO_U0USR_busy_src(data)                                                     ((0x00000001&(data))>>0)
+#define ISO_U0USR_get_busy(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_U0TFL                                                                    0x18007880
+#define ISO_U0TFL_reg_addr                                                           "0xB8007880"
+#define ISO_U0TFL_reg                                                                0xB8007880
+#define set_ISO_U0TFL_reg(data)   (*((volatile unsigned int*) ISO_U0TFL_reg)=data)
+#define get_ISO_U0TFL_reg   (*((volatile unsigned int*) ISO_U0TFL_reg))
+#define ISO_U0TFL_inst_adr                                                           "0x0020"
+#define ISO_U0TFL_inst                                                               0x0020
+#define ISO_U0TFL_tfl_shift                                                          (0)
+#define ISO_U0TFL_tfl_mask                                                           (0x000000FF)
+#define ISO_U0TFL_tfl(data)                                                          (0x000000FF&((data)<<0))
+#define ISO_U0TFL_tfl_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ISO_U0TFL_get_tfl(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0RFL                                                                    0x18007884
+#define ISO_U0RFL_reg_addr                                                           "0xB8007884"
+#define ISO_U0RFL_reg                                                                0xB8007884
+#define set_ISO_U0RFL_reg(data)   (*((volatile unsigned int*) ISO_U0RFL_reg)=data)
+#define get_ISO_U0RFL_reg   (*((volatile unsigned int*) ISO_U0RFL_reg))
+#define ISO_U0RFL_inst_adr                                                           "0x0021"
+#define ISO_U0RFL_inst                                                               0x0021
+#define ISO_U0RFL_rfl_shift                                                          (0)
+#define ISO_U0RFL_rfl_mask                                                           (0x000000FF)
+#define ISO_U0RFL_rfl(data)                                                          (0x000000FF&((data)<<0))
+#define ISO_U0RFL_rfl_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ISO_U0RFL_get_rfl(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_U0SRR                                                                    0x18007888
+#define ISO_U0SRR_reg_addr                                                           "0xB8007888"
+#define ISO_U0SRR_reg                                                                0xB8007888
+#define set_ISO_U0SRR_reg(data)   (*((volatile unsigned int*) ISO_U0SRR_reg)=data)
+#define get_ISO_U0SRR_reg   (*((volatile unsigned int*) ISO_U0SRR_reg))
+#define ISO_U0SRR_inst_adr                                                           "0x0022"
+#define ISO_U0SRR_inst                                                               0x0022
+#define ISO_U0SRR_xfr_shift                                                          (2)
+#define ISO_U0SRR_xfr_mask                                                           (0x00000004)
+#define ISO_U0SRR_xfr(data)                                                          (0x00000004&((data)<<2))
+#define ISO_U0SRR_xfr_src(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0SRR_get_xfr(data)                                                      ((0x00000004&(data))>>2)
+#define ISO_U0SRR_rfr_shift                                                          (1)
+#define ISO_U0SRR_rfr_mask                                                           (0x00000002)
+#define ISO_U0SRR_rfr(data)                                                          (0x00000002&((data)<<1))
+#define ISO_U0SRR_rfr_src(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_U0SRR_get_rfr(data)                                                      ((0x00000002&(data))>>1)
+#define ISO_U0SRR_ur_shift                                                           (0)
+#define ISO_U0SRR_ur_mask                                                            (0x00000001)
+#define ISO_U0SRR_ur(data)                                                           (0x00000001&((data)<<0))
+#define ISO_U0SRR_ur_src(data)                                                       ((0x00000001&(data))>>0)
+#define ISO_U0SRR_get_ur(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_U0SBCR                                                                   0x18007890
+#define ISO_U0SBCR_reg_addr                                                          "0xB8007890"
+#define ISO_U0SBCR_reg                                                               0xB8007890
+#define set_ISO_U0SBCR_reg(data)   (*((volatile unsigned int*) ISO_U0SBCR_reg)=data)
+#define get_ISO_U0SBCR_reg   (*((volatile unsigned int*) ISO_U0SBCR_reg))
+#define ISO_U0SBCR_inst_adr                                                          "0x0024"
+#define ISO_U0SBCR_inst                                                              0x0024
+#define ISO_U0SBCR_sbcr_shift                                                        (0)
+#define ISO_U0SBCR_sbcr_mask                                                         (0x00000001)
+#define ISO_U0SBCR_sbcr(data)                                                        (0x00000001&((data)<<0))
+#define ISO_U0SBCR_sbcr_src(data)                                                    ((0x00000001&(data))>>0)
+#define ISO_U0SBCR_get_sbcr(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_U0SDMAM                                                                  0x18007894
+#define ISO_U0SDMAM_reg_addr                                                         "0xB8007894"
+#define ISO_U0SDMAM_reg                                                              0xB8007894
+#define set_ISO_U0SDMAM_reg(data)   (*((volatile unsigned int*) ISO_U0SDMAM_reg)=data)
+#define get_ISO_U0SDMAM_reg   (*((volatile unsigned int*) ISO_U0SDMAM_reg))
+#define ISO_U0SDMAM_inst_adr                                                         "0x0025"
+#define ISO_U0SDMAM_inst                                                             0x0025
+#define ISO_U0SDMAM_sdmam_shift                                                      (0)
+#define ISO_U0SDMAM_sdmam_mask                                                       (0x00000001)
+#define ISO_U0SDMAM_sdmam(data)                                                      (0x00000001&((data)<<0))
+#define ISO_U0SDMAM_sdmam_src(data)                                                  ((0x00000001&(data))>>0)
+#define ISO_U0SDMAM_get_sdmam(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_U0SFE                                                                    0x18007898
+#define ISO_U0SFE_reg_addr                                                           "0xB8007898"
+#define ISO_U0SFE_reg                                                                0xB8007898
+#define set_ISO_U0SFE_reg(data)   (*((volatile unsigned int*) ISO_U0SFE_reg)=data)
+#define get_ISO_U0SFE_reg   (*((volatile unsigned int*) ISO_U0SFE_reg))
+#define ISO_U0SFE_inst_adr                                                           "0x0026"
+#define ISO_U0SFE_inst                                                               0x0026
+#define ISO_U0SFE_sfe_shift                                                          (0)
+#define ISO_U0SFE_sfe_mask                                                           (0x00000001)
+#define ISO_U0SFE_sfe(data)                                                          (0x00000001&((data)<<0))
+#define ISO_U0SFE_sfe_src(data)                                                      ((0x00000001&(data))>>0)
+#define ISO_U0SFE_get_sfe(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_U0SRT                                                                    0x1800789C
+#define ISO_U0SRT_reg_addr                                                           "0xB800789C"
+#define ISO_U0SRT_reg                                                                0xB800789C
+#define set_ISO_U0SRT_reg(data)   (*((volatile unsigned int*) ISO_U0SRT_reg)=data)
+#define get_ISO_U0SRT_reg   (*((volatile unsigned int*) ISO_U0SRT_reg))
+#define ISO_U0SRT_inst_adr                                                           "0x0027"
+#define ISO_U0SRT_inst                                                               0x0027
+#define ISO_U0SRT_srt_shift                                                          (0)
+#define ISO_U0SRT_srt_mask                                                           (0x00000003)
+#define ISO_U0SRT_srt(data)                                                          (0x00000003&((data)<<0))
+#define ISO_U0SRT_srt_src(data)                                                      ((0x00000003&(data))>>0)
+#define ISO_U0SRT_get_srt(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define ISO_U0STET                                                                   0x180078A0
+#define ISO_U0STET_reg_addr                                                          "0xB80078A0"
+#define ISO_U0STET_reg                                                               0xB80078A0
+#define set_ISO_U0STET_reg(data)   (*((volatile unsigned int*) ISO_U0STET_reg)=data)
+#define get_ISO_U0STET_reg   (*((volatile unsigned int*) ISO_U0STET_reg))
+#define ISO_U0STET_inst_adr                                                          "0x0028"
+#define ISO_U0STET_inst                                                              0x0028
+#define ISO_U0STET_stet_shift                                                        (0)
+#define ISO_U0STET_stet_mask                                                         (0x00000003)
+#define ISO_U0STET_stet(data)                                                        (0x00000003&((data)<<0))
+#define ISO_U0STET_stet_src(data)                                                    ((0x00000003&(data))>>0)
+#define ISO_U0STET_get_stet(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define ISO_U0HTX                                                                    0x180078A4
+#define ISO_U0HTX_reg_addr                                                           "0xB80078A4"
+#define ISO_U0HTX_reg                                                                0xB80078A4
+#define set_ISO_U0HTX_reg(data)   (*((volatile unsigned int*) ISO_U0HTX_reg)=data)
+#define get_ISO_U0HTX_reg   (*((volatile unsigned int*) ISO_U0HTX_reg))
+#define ISO_U0HTX_inst_adr                                                           "0x0029"
+#define ISO_U0HTX_inst                                                               0x0029
+#define ISO_U0HTX_htx_shift                                                          (0)
+#define ISO_U0HTX_htx_mask                                                           (0x00000001)
+#define ISO_U0HTX_htx(data)                                                          (0x00000001&((data)<<0))
+#define ISO_U0HTX_htx_src(data)                                                      ((0x00000001&(data))>>0)
+#define ISO_U0HTX_get_htx(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_U0DMASA                                                                  0x180078A8
+#define ISO_U0DMASA_reg_addr                                                         "0xB80078A8"
+#define ISO_U0DMASA_reg                                                              0xB80078A8
+#define set_ISO_U0DMASA_reg(data)   (*((volatile unsigned int*) ISO_U0DMASA_reg)=data)
+#define get_ISO_U0DMASA_reg   (*((volatile unsigned int*) ISO_U0DMASA_reg))
+#define ISO_U0DMASA_inst_adr                                                         "0x002A"
+#define ISO_U0DMASA_inst                                                             0x002A
+#define ISO_U0DMASA_dmasa_shift                                                      (0)
+#define ISO_U0DMASA_dmasa_mask                                                       (0x00000001)
+#define ISO_U0DMASA_dmasa(data)                                                      (0x00000001&((data)<<0))
+#define ISO_U0DMASA_dmasa_src(data)                                                  ((0x00000001&(data))>>0)
+#define ISO_U0DMASA_get_dmasa(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_U0CPR                                                                    0x180078F4
+#define ISO_U0CPR_reg_addr                                                           "0xB80078F4"
+#define ISO_U0CPR_reg                                                                0xB80078F4
+#define set_ISO_U0CPR_reg(data)   (*((volatile unsigned int*) ISO_U0CPR_reg)=data)
+#define get_ISO_U0CPR_reg   (*((volatile unsigned int*) ISO_U0CPR_reg))
+#define ISO_U0CPR_inst_adr                                                           "0x003D"
+#define ISO_U0CPR_inst                                                               0x003D
+#define ISO_U0CPR_fifo_mode_shift                                                    (16)
+#define ISO_U0CPR_fifo_mode_mask                                                     (0x00FF0000)
+#define ISO_U0CPR_fifo_mode(data)                                                    (0x00FF0000&((data)<<16))
+#define ISO_U0CPR_fifo_mode_src(data)                                                ((0x00FF0000&(data))>>16)
+#define ISO_U0CPR_get_fifo_mode(data)                                                ((0x00FF0000&(data))>>16)
+#define ISO_U0CPR_dma_extra_shift                                                    (13)
+#define ISO_U0CPR_dma_extra_mask                                                     (0x00002000)
+#define ISO_U0CPR_dma_extra(data)                                                    (0x00002000&((data)<<13))
+#define ISO_U0CPR_dma_extra_src(data)                                                ((0x00002000&(data))>>13)
+#define ISO_U0CPR_get_dma_extra(data)                                                ((0x00002000&(data))>>13)
+#define ISO_U0CPR_uart_add_encoded_params_shift                                      (12)
+#define ISO_U0CPR_uart_add_encoded_params_mask                                       (0x00001000)
+#define ISO_U0CPR_uart_add_encoded_params(data)                                      (0x00001000&((data)<<12))
+#define ISO_U0CPR_uart_add_encoded_params_src(data)                                  ((0x00001000&(data))>>12)
+#define ISO_U0CPR_get_uart_add_encoded_params(data)                                  ((0x00001000&(data))>>12)
+#define ISO_U0CPR_shadow_shift                                                       (11)
+#define ISO_U0CPR_shadow_mask                                                        (0x00000800)
+#define ISO_U0CPR_shadow(data)                                                       (0x00000800&((data)<<11))
+#define ISO_U0CPR_shadow_src(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_U0CPR_get_shadow(data)                                                   ((0x00000800&(data))>>11)
+#define ISO_U0CPR_fifo_stat_shift                                                    (10)
+#define ISO_U0CPR_fifo_stat_mask                                                     (0x00000400)
+#define ISO_U0CPR_fifo_stat(data)                                                    (0x00000400&((data)<<10))
+#define ISO_U0CPR_fifo_stat_src(data)                                                ((0x00000400&(data))>>10)
+#define ISO_U0CPR_get_fifo_stat(data)                                                ((0x00000400&(data))>>10)
+#define ISO_U0CPR_fifo_access_shift                                                  (9)
+#define ISO_U0CPR_fifo_access_mask                                                   (0x00000200)
+#define ISO_U0CPR_fifo_access(data)                                                  (0x00000200&((data)<<9))
+#define ISO_U0CPR_fifo_access_src(data)                                              ((0x00000200&(data))>>9)
+#define ISO_U0CPR_get_fifo_access(data)                                              ((0x00000200&(data))>>9)
+#define ISO_U0CPR_additional_feat_shift                                              (8)
+#define ISO_U0CPR_additional_feat_mask                                               (0x00000100)
+#define ISO_U0CPR_additional_feat(data)                                              (0x00000100&((data)<<8))
+#define ISO_U0CPR_additional_feat_src(data)                                          ((0x00000100&(data))>>8)
+#define ISO_U0CPR_get_additional_feat(data)                                          ((0x00000100&(data))>>8)
+#define ISO_U0CPR_sir_lp_mode_shift                                                  (7)
+#define ISO_U0CPR_sir_lp_mode_mask                                                   (0x00000080)
+#define ISO_U0CPR_sir_lp_mode(data)                                                  (0x00000080&((data)<<7))
+#define ISO_U0CPR_sir_lp_mode_src(data)                                              ((0x00000080&(data))>>7)
+#define ISO_U0CPR_get_sir_lp_mode(data)                                              ((0x00000080&(data))>>7)
+#define ISO_U0CPR_sir_mode_shift                                                     (6)
+#define ISO_U0CPR_sir_mode_mask                                                      (0x00000040)
+#define ISO_U0CPR_sir_mode(data)                                                     (0x00000040&((data)<<6))
+#define ISO_U0CPR_sir_mode_src(data)                                                 ((0x00000040&(data))>>6)
+#define ISO_U0CPR_get_sir_mode(data)                                                 ((0x00000040&(data))>>6)
+#define ISO_U0CPR_thre_mode_shift                                                    (5)
+#define ISO_U0CPR_thre_mode_mask                                                     (0x00000020)
+#define ISO_U0CPR_thre_mode(data)                                                    (0x00000020&((data)<<5))
+#define ISO_U0CPR_thre_mode_src(data)                                                ((0x00000020&(data))>>5)
+#define ISO_U0CPR_get_thre_mode(data)                                                ((0x00000020&(data))>>5)
+#define ISO_U0CPR_afce_mode_shift                                                    (4)
+#define ISO_U0CPR_afce_mode_mask                                                     (0x00000010)
+#define ISO_U0CPR_afce_mode(data)                                                    (0x00000010&((data)<<4))
+#define ISO_U0CPR_afce_mode_src(data)                                                ((0x00000010&(data))>>4)
+#define ISO_U0CPR_get_afce_mode(data)                                                ((0x00000010&(data))>>4)
+#define ISO_U0CPR_apb_data_width_shift                                               (0)
+#define ISO_U0CPR_apb_data_width_mask                                                (0x00000003)
+#define ISO_U0CPR_apb_data_width(data)                                               (0x00000003&((data)<<0))
+#define ISO_U0CPR_apb_data_width_src(data)                                           ((0x00000003&(data))>>0)
+#define ISO_U0CPR_get_apb_data_width(data)                                           ((0x00000003&(data))>>0)
+
+
+#define ISO_U0UCV                                                                    0x180078F8
+#define ISO_U0UCV_reg_addr                                                           "0xB80078F8"
+#define ISO_U0UCV_reg                                                                0xB80078F8
+#define set_ISO_U0UCV_reg(data)   (*((volatile unsigned int*) ISO_U0UCV_reg)=data)
+#define get_ISO_U0UCV_reg   (*((volatile unsigned int*) ISO_U0UCV_reg))
+#define ISO_U0UCV_inst_adr                                                           "0x003E"
+#define ISO_U0UCV_inst                                                               0x003E
+#define ISO_U0UCV_ucv_shift                                                          (0)
+#define ISO_U0UCV_ucv_mask                                                           (0xFFFFFFFF)
+#define ISO_U0UCV_ucv(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define ISO_U0UCV_ucv_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define ISO_U0UCV_get_ucv(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_U0CTR                                                                    0x180078FC
+#define ISO_U0CTR_reg_addr                                                           "0xB80078FC"
+#define ISO_U0CTR_reg                                                                0xB80078FC
+#define set_ISO_U0CTR_reg(data)   (*((volatile unsigned int*) ISO_U0CTR_reg)=data)
+#define get_ISO_U0CTR_reg   (*((volatile unsigned int*) ISO_U0CTR_reg))
+#define ISO_U0CTR_inst_adr                                                           "0x003F"
+#define ISO_U0CTR_inst                                                               0x003F
+#define ISO_U0CTR_ctr_shift                                                          (0)
+#define ISO_U0CTR_ctr_mask                                                           (0xFFFFFFFF)
+#define ISO_U0CTR_ctr(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define ISO_U0CTR_ctr_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define ISO_U0CTR_get_ctr(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IC0_CON                                                                  0x18007D00
+#define ISO_IC0_CON_reg_addr                                                         "0xB8007D00"
+#define ISO_IC0_CON_reg                                                              0xB8007D00
+#define set_ISO_IC0_CON_reg(data)   (*((volatile unsigned int*) ISO_IC0_CON_reg)=data)
+#define get_ISO_IC0_CON_reg   (*((volatile unsigned int*) ISO_IC0_CON_reg))
+#define ISO_IC0_CON_inst_adr                                                         "0x0040"
+#define ISO_IC0_CON_inst                                                             0x0040
+#define ISO_IC0_CON_ic_slave_disable_shift                                           (6)
+#define ISO_IC0_CON_ic_slave_disable_mask                                            (0x00000040)
+#define ISO_IC0_CON_ic_slave_disable(data)                                           (0x00000040&((data)<<6))
+#define ISO_IC0_CON_ic_slave_disable_src(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC0_CON_get_ic_slave_disable(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC0_CON_ic_restart_en_shift                                              (5)
+#define ISO_IC0_CON_ic_restart_en_mask                                               (0x00000020)
+#define ISO_IC0_CON_ic_restart_en(data)                                              (0x00000020&((data)<<5))
+#define ISO_IC0_CON_ic_restart_en_src(data)                                          ((0x00000020&(data))>>5)
+#define ISO_IC0_CON_get_ic_restart_en(data)                                          ((0x00000020&(data))>>5)
+#define ISO_IC0_CON_ic_10bitaddr_master_shift                                        (4)
+#define ISO_IC0_CON_ic_10bitaddr_master_mask                                         (0x00000010)
+#define ISO_IC0_CON_ic_10bitaddr_master(data)                                        (0x00000010&((data)<<4))
+#define ISO_IC0_CON_ic_10bitaddr_master_src(data)                                    ((0x00000010&(data))>>4)
+#define ISO_IC0_CON_get_ic_10bitaddr_master(data)                                    ((0x00000010&(data))>>4)
+#define ISO_IC0_CON_ic_10bitaddr_slave_shift                                         (3)
+#define ISO_IC0_CON_ic_10bitaddr_slave_mask                                          (0x00000008)
+#define ISO_IC0_CON_ic_10bitaddr_slave(data)                                         (0x00000008&((data)<<3))
+#define ISO_IC0_CON_ic_10bitaddr_slave_src(data)                                     ((0x00000008&(data))>>3)
+#define ISO_IC0_CON_get_ic_10bitaddr_slave(data)                                     ((0x00000008&(data))>>3)
+#define ISO_IC0_CON_speed_shift                                                      (1)
+#define ISO_IC0_CON_speed_mask                                                       (0x00000006)
+#define ISO_IC0_CON_speed(data)                                                      (0x00000006&((data)<<1))
+#define ISO_IC0_CON_speed_src(data)                                                  ((0x00000006&(data))>>1)
+#define ISO_IC0_CON_get_speed(data)                                                  ((0x00000006&(data))>>1)
+#define ISO_IC0_CON_master_mode_shift                                                (0)
+#define ISO_IC0_CON_master_mode_mask                                                 (0x00000001)
+#define ISO_IC0_CON_master_mode(data)                                                (0x00000001&((data)<<0))
+#define ISO_IC0_CON_master_mode_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_IC0_CON_get_master_mode(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_TAR                                                                  0x18007D04
+#define ISO_IC0_TAR_reg_addr                                                         "0xB8007D04"
+#define ISO_IC0_TAR_reg                                                              0xB8007D04
+#define set_ISO_IC0_TAR_reg(data)   (*((volatile unsigned int*) ISO_IC0_TAR_reg)=data)
+#define get_ISO_IC0_TAR_reg   (*((volatile unsigned int*) ISO_IC0_TAR_reg))
+#define ISO_IC0_TAR_inst_adr                                                         "0x0041"
+#define ISO_IC0_TAR_inst                                                             0x0041
+#define ISO_IC0_TAR_ic_10bitaddr_master_shift                                        (12)
+#define ISO_IC0_TAR_ic_10bitaddr_master_mask                                         (0x00001000)
+#define ISO_IC0_TAR_ic_10bitaddr_master(data)                                        (0x00001000&((data)<<12))
+#define ISO_IC0_TAR_ic_10bitaddr_master_src(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC0_TAR_get_ic_10bitaddr_master(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC0_TAR_special_shift                                                    (11)
+#define ISO_IC0_TAR_special_mask                                                     (0x00000800)
+#define ISO_IC0_TAR_special(data)                                                    (0x00000800&((data)<<11))
+#define ISO_IC0_TAR_special_src(data)                                                ((0x00000800&(data))>>11)
+#define ISO_IC0_TAR_get_special(data)                                                ((0x00000800&(data))>>11)
+#define ISO_IC0_TAR_gc_or_start_shift                                                (10)
+#define ISO_IC0_TAR_gc_or_start_mask                                                 (0x00000400)
+#define ISO_IC0_TAR_gc_or_start(data)                                                (0x00000400&((data)<<10))
+#define ISO_IC0_TAR_gc_or_start_src(data)                                            ((0x00000400&(data))>>10)
+#define ISO_IC0_TAR_get_gc_or_start(data)                                            ((0x00000400&(data))>>10)
+#define ISO_IC0_TAR_ic_tar_shift                                                     (0)
+#define ISO_IC0_TAR_ic_tar_mask                                                      (0x000003FF)
+#define ISO_IC0_TAR_ic_tar(data)                                                     (0x000003FF&((data)<<0))
+#define ISO_IC0_TAR_ic_tar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define ISO_IC0_TAR_get_ic_tar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define ISO_IC0_SAR                                                                  0x18007D08
+#define ISO_IC0_SAR_reg_addr                                                         "0xB8007D08"
+#define ISO_IC0_SAR_reg                                                              0xB8007D08
+#define set_ISO_IC0_SAR_reg(data)   (*((volatile unsigned int*) ISO_IC0_SAR_reg)=data)
+#define get_ISO_IC0_SAR_reg   (*((volatile unsigned int*) ISO_IC0_SAR_reg))
+#define ISO_IC0_SAR_inst_adr                                                         "0x0042"
+#define ISO_IC0_SAR_inst                                                             0x0042
+#define ISO_IC0_SAR_ic_sar_shift                                                     (0)
+#define ISO_IC0_SAR_ic_sar_mask                                                      (0x000003FF)
+#define ISO_IC0_SAR_ic_sar(data)                                                     (0x000003FF&((data)<<0))
+#define ISO_IC0_SAR_ic_sar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define ISO_IC0_SAR_get_ic_sar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define ISO_IC0_HS_MADDR                                                             0x18007D0C
+#define ISO_IC0_HS_MADDR_reg_addr                                                    "0xB8007D0C"
+#define ISO_IC0_HS_MADDR_reg                                                         0xB8007D0C
+#define set_ISO_IC0_HS_MADDR_reg(data)   (*((volatile unsigned int*) ISO_IC0_HS_MADDR_reg)=data)
+#define get_ISO_IC0_HS_MADDR_reg   (*((volatile unsigned int*) ISO_IC0_HS_MADDR_reg))
+#define ISO_IC0_HS_MADDR_inst_adr                                                    "0x0043"
+#define ISO_IC0_HS_MADDR_inst                                                        0x0043
+#define ISO_IC0_HS_MADDR_ic_hs_mar_shift                                             (0)
+#define ISO_IC0_HS_MADDR_ic_hs_mar_mask                                              (0x00000007)
+#define ISO_IC0_HS_MADDR_ic_hs_mar(data)                                             (0x00000007&((data)<<0))
+#define ISO_IC0_HS_MADDR_ic_hs_mar_src(data)                                         ((0x00000007&(data))>>0)
+#define ISO_IC0_HS_MADDR_get_ic_hs_mar(data)                                         ((0x00000007&(data))>>0)
+
+
+#define ISO_IC0_DATA_CMD                                                             0x18007D10
+#define ISO_IC0_DATA_CMD_reg_addr                                                    "0xB8007D10"
+#define ISO_IC0_DATA_CMD_reg                                                         0xB8007D10
+#define set_ISO_IC0_DATA_CMD_reg(data)   (*((volatile unsigned int*) ISO_IC0_DATA_CMD_reg)=data)
+#define get_ISO_IC0_DATA_CMD_reg   (*((volatile unsigned int*) ISO_IC0_DATA_CMD_reg))
+#define ISO_IC0_DATA_CMD_inst_adr                                                    "0x0044"
+#define ISO_IC0_DATA_CMD_inst                                                        0x0044
+#define ISO_IC0_DATA_CMD_restart_shift                                               (10)
+#define ISO_IC0_DATA_CMD_restart_mask                                                (0x00000400)
+#define ISO_IC0_DATA_CMD_restart(data)                                               (0x00000400&((data)<<10))
+#define ISO_IC0_DATA_CMD_restart_src(data)                                           ((0x00000400&(data))>>10)
+#define ISO_IC0_DATA_CMD_get_restart(data)                                           ((0x00000400&(data))>>10)
+#define ISO_IC0_DATA_CMD_stop_shift                                                  (9)
+#define ISO_IC0_DATA_CMD_stop_mask                                                   (0x00000200)
+#define ISO_IC0_DATA_CMD_stop(data)                                                  (0x00000200&((data)<<9))
+#define ISO_IC0_DATA_CMD_stop_src(data)                                              ((0x00000200&(data))>>9)
+#define ISO_IC0_DATA_CMD_get_stop(data)                                              ((0x00000200&(data))>>9)
+#define ISO_IC0_DATA_CMD_cmd_shift                                                   (8)
+#define ISO_IC0_DATA_CMD_cmd_mask                                                    (0x00000100)
+#define ISO_IC0_DATA_CMD_cmd(data)                                                   (0x00000100&((data)<<8))
+#define ISO_IC0_DATA_CMD_cmd_src(data)                                               ((0x00000100&(data))>>8)
+#define ISO_IC0_DATA_CMD_get_cmd(data)                                               ((0x00000100&(data))>>8)
+#define ISO_IC0_DATA_CMD_dat_shift                                                   (0)
+#define ISO_IC0_DATA_CMD_dat_mask                                                    (0x000000FF)
+#define ISO_IC0_DATA_CMD_dat(data)                                                   (0x000000FF&((data)<<0))
+#define ISO_IC0_DATA_CMD_dat_src(data)                                               ((0x000000FF&(data))>>0)
+#define ISO_IC0_DATA_CMD_get_dat(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC0_SS_SCL_HCNT                                                          0x18007D14
+#define ISO_IC0_SS_SCL_HCNT_reg_addr                                                 "0xB8007D14"
+#define ISO_IC0_SS_SCL_HCNT_reg                                                      0xB8007D14
+#define set_ISO_IC0_SS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) ISO_IC0_SS_SCL_HCNT_reg)=data)
+#define get_ISO_IC0_SS_SCL_HCNT_reg   (*((volatile unsigned int*) ISO_IC0_SS_SCL_HCNT_reg))
+#define ISO_IC0_SS_SCL_HCNT_inst_adr                                                 "0x0045"
+#define ISO_IC0_SS_SCL_HCNT_inst                                                     0x0045
+#define ISO_IC0_SS_SCL_HCNT_ic_ss_scl_hcnt_shift                                     (0)
+#define ISO_IC0_SS_SCL_HCNT_ic_ss_scl_hcnt_mask                                      (0x0000FFFF)
+#define ISO_IC0_SS_SCL_HCNT_ic_ss_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC0_SS_SCL_HCNT_ic_ss_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC0_SS_SCL_HCNT_get_ic_ss_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC0_SS_SCL_LCNT                                                          0x18007D18
+#define ISO_IC0_SS_SCL_LCNT_reg_addr                                                 "0xB8007D18"
+#define ISO_IC0_SS_SCL_LCNT_reg                                                      0xB8007D18
+#define set_ISO_IC0_SS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) ISO_IC0_SS_SCL_LCNT_reg)=data)
+#define get_ISO_IC0_SS_SCL_LCNT_reg   (*((volatile unsigned int*) ISO_IC0_SS_SCL_LCNT_reg))
+#define ISO_IC0_SS_SCL_LCNT_inst_adr                                                 "0x0046"
+#define ISO_IC0_SS_SCL_LCNT_inst                                                     0x0046
+#define ISO_IC0_SS_SCL_LCNT_ic_ss_scl_lcnt_shift                                     (0)
+#define ISO_IC0_SS_SCL_LCNT_ic_ss_scl_lcnt_mask                                      (0x0000FFFF)
+#define ISO_IC0_SS_SCL_LCNT_ic_ss_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC0_SS_SCL_LCNT_ic_ss_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC0_SS_SCL_LCNT_get_ic_ss_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC0_FS_SCL_HCNT                                                          0x18007D1C
+#define ISO_IC0_FS_SCL_HCNT_reg_addr                                                 "0xB8007D1C"
+#define ISO_IC0_FS_SCL_HCNT_reg                                                      0xB8007D1C
+#define set_ISO_IC0_FS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) ISO_IC0_FS_SCL_HCNT_reg)=data)
+#define get_ISO_IC0_FS_SCL_HCNT_reg   (*((volatile unsigned int*) ISO_IC0_FS_SCL_HCNT_reg))
+#define ISO_IC0_FS_SCL_HCNT_inst_adr                                                 "0x0047"
+#define ISO_IC0_FS_SCL_HCNT_inst                                                     0x0047
+#define ISO_IC0_FS_SCL_HCNT_ic_fs_scl_hcnt_shift                                     (0)
+#define ISO_IC0_FS_SCL_HCNT_ic_fs_scl_hcnt_mask                                      (0x0000FFFF)
+#define ISO_IC0_FS_SCL_HCNT_ic_fs_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC0_FS_SCL_HCNT_ic_fs_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC0_FS_SCL_HCNT_get_ic_fs_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC0_FS_SCL_LCNT                                                          0x18007D20
+#define ISO_IC0_FS_SCL_LCNT_reg_addr                                                 "0xB8007D20"
+#define ISO_IC0_FS_SCL_LCNT_reg                                                      0xB8007D20
+#define set_ISO_IC0_FS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) ISO_IC0_FS_SCL_LCNT_reg)=data)
+#define get_ISO_IC0_FS_SCL_LCNT_reg   (*((volatile unsigned int*) ISO_IC0_FS_SCL_LCNT_reg))
+#define ISO_IC0_FS_SCL_LCNT_inst_adr                                                 "0x0048"
+#define ISO_IC0_FS_SCL_LCNT_inst                                                     0x0048
+#define ISO_IC0_FS_SCL_LCNT_ic_fs_scl_lcnt_shift                                     (0)
+#define ISO_IC0_FS_SCL_LCNT_ic_fs_scl_lcnt_mask                                      (0x0000FFFF)
+#define ISO_IC0_FS_SCL_LCNT_ic_fs_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC0_FS_SCL_LCNT_ic_fs_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC0_FS_SCL_LCNT_get_ic_fs_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC0_INTR_STAT                                                            0x18007D2C
+#define ISO_IC0_INTR_STAT_reg_addr                                                   "0xB8007D2C"
+#define ISO_IC0_INTR_STAT_reg                                                        0xB8007D2C
+#define set_ISO_IC0_INTR_STAT_reg(data)   (*((volatile unsigned int*) ISO_IC0_INTR_STAT_reg)=data)
+#define get_ISO_IC0_INTR_STAT_reg   (*((volatile unsigned int*) ISO_IC0_INTR_STAT_reg))
+#define ISO_IC0_INTR_STAT_inst_adr                                                   "0x004B"
+#define ISO_IC0_INTR_STAT_inst                                                       0x004B
+#define ISO_IC0_INTR_STAT_r_gen_call_shift                                           (11)
+#define ISO_IC0_INTR_STAT_r_gen_call_mask                                            (0x00000800)
+#define ISO_IC0_INTR_STAT_r_gen_call(data)                                           (0x00000800&((data)<<11))
+#define ISO_IC0_INTR_STAT_r_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC0_INTR_STAT_get_r_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC0_INTR_STAT_r_start_det_shift                                          (10)
+#define ISO_IC0_INTR_STAT_r_start_det_mask                                           (0x00000400)
+#define ISO_IC0_INTR_STAT_r_start_det(data)                                          (0x00000400&((data)<<10))
+#define ISO_IC0_INTR_STAT_r_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC0_INTR_STAT_get_r_start_det(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC0_INTR_STAT_r_stop_det_shift                                           (9)
+#define ISO_IC0_INTR_STAT_r_stop_det_mask                                            (0x00000200)
+#define ISO_IC0_INTR_STAT_r_stop_det(data)                                           (0x00000200&((data)<<9))
+#define ISO_IC0_INTR_STAT_r_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC0_INTR_STAT_get_r_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC0_INTR_STAT_r_activity_shift                                           (8)
+#define ISO_IC0_INTR_STAT_r_activity_mask                                            (0x00000100)
+#define ISO_IC0_INTR_STAT_r_activity(data)                                           (0x00000100&((data)<<8))
+#define ISO_IC0_INTR_STAT_r_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC0_INTR_STAT_get_r_activity(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC0_INTR_STAT_r_rx_done_shift                                            (7)
+#define ISO_IC0_INTR_STAT_r_rx_done_mask                                             (0x00000080)
+#define ISO_IC0_INTR_STAT_r_rx_done(data)                                            (0x00000080&((data)<<7))
+#define ISO_IC0_INTR_STAT_r_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC0_INTR_STAT_get_r_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC0_INTR_STAT_r_tx_abrt_shift                                            (6)
+#define ISO_IC0_INTR_STAT_r_tx_abrt_mask                                             (0x00000040)
+#define ISO_IC0_INTR_STAT_r_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC0_INTR_STAT_r_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_INTR_STAT_get_r_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_INTR_STAT_r_rd_req_shift                                             (5)
+#define ISO_IC0_INTR_STAT_r_rd_req_mask                                              (0x00000020)
+#define ISO_IC0_INTR_STAT_r_rd_req(data)                                             (0x00000020&((data)<<5))
+#define ISO_IC0_INTR_STAT_r_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC0_INTR_STAT_get_r_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC0_INTR_STAT_r_tx_empty_shift                                           (4)
+#define ISO_IC0_INTR_STAT_r_tx_empty_mask                                            (0x00000010)
+#define ISO_IC0_INTR_STAT_r_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define ISO_IC0_INTR_STAT_r_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC0_INTR_STAT_get_r_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC0_INTR_STAT_r_tx_over_shift                                            (3)
+#define ISO_IC0_INTR_STAT_r_tx_over_mask                                             (0x00000008)
+#define ISO_IC0_INTR_STAT_r_tx_over(data)                                            (0x00000008&((data)<<3))
+#define ISO_IC0_INTR_STAT_r_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC0_INTR_STAT_get_r_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC0_INTR_STAT_r_rx_full_shift                                            (2)
+#define ISO_IC0_INTR_STAT_r_rx_full_mask                                             (0x00000004)
+#define ISO_IC0_INTR_STAT_r_rx_full(data)                                            (0x00000004&((data)<<2))
+#define ISO_IC0_INTR_STAT_r_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC0_INTR_STAT_get_r_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC0_INTR_STAT_r_rx_over_shift                                            (1)
+#define ISO_IC0_INTR_STAT_r_rx_over_mask                                             (0x00000002)
+#define ISO_IC0_INTR_STAT_r_rx_over(data)                                            (0x00000002&((data)<<1))
+#define ISO_IC0_INTR_STAT_r_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC0_INTR_STAT_get_r_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC0_INTR_STAT_r_rx_under_shift                                           (0)
+#define ISO_IC0_INTR_STAT_r_rx_under_mask                                            (0x00000001)
+#define ISO_IC0_INTR_STAT_r_rx_under(data)                                           (0x00000001&((data)<<0))
+#define ISO_IC0_INTR_STAT_r_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_IC0_INTR_STAT_get_r_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_INTR_MASK                                                            0x18007D30
+#define ISO_IC0_INTR_MASK_reg_addr                                                   "0xB8007D30"
+#define ISO_IC0_INTR_MASK_reg                                                        0xB8007D30
+#define set_ISO_IC0_INTR_MASK_reg(data)   (*((volatile unsigned int*) ISO_IC0_INTR_MASK_reg)=data)
+#define get_ISO_IC0_INTR_MASK_reg   (*((volatile unsigned int*) ISO_IC0_INTR_MASK_reg))
+#define ISO_IC0_INTR_MASK_inst_adr                                                   "0x004C"
+#define ISO_IC0_INTR_MASK_inst                                                       0x004C
+#define ISO_IC0_INTR_MASK_m_gen_call_shift                                           (11)
+#define ISO_IC0_INTR_MASK_m_gen_call_mask                                            (0x00000800)
+#define ISO_IC0_INTR_MASK_m_gen_call(data)                                           (0x00000800&((data)<<11))
+#define ISO_IC0_INTR_MASK_m_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC0_INTR_MASK_get_m_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC0_INTR_MASK_m_start_det_shift                                          (10)
+#define ISO_IC0_INTR_MASK_m_start_det_mask                                           (0x00000400)
+#define ISO_IC0_INTR_MASK_m_start_det(data)                                          (0x00000400&((data)<<10))
+#define ISO_IC0_INTR_MASK_m_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC0_INTR_MASK_get_m_start_det(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC0_INTR_MASK_m_stop_det_shift                                           (9)
+#define ISO_IC0_INTR_MASK_m_stop_det_mask                                            (0x00000200)
+#define ISO_IC0_INTR_MASK_m_stop_det(data)                                           (0x00000200&((data)<<9))
+#define ISO_IC0_INTR_MASK_m_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC0_INTR_MASK_get_m_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC0_INTR_MASK_m_activity_shift                                           (8)
+#define ISO_IC0_INTR_MASK_m_activity_mask                                            (0x00000100)
+#define ISO_IC0_INTR_MASK_m_activity(data)                                           (0x00000100&((data)<<8))
+#define ISO_IC0_INTR_MASK_m_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC0_INTR_MASK_get_m_activity(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC0_INTR_MASK_m_rx_done_shift                                            (7)
+#define ISO_IC0_INTR_MASK_m_rx_done_mask                                             (0x00000080)
+#define ISO_IC0_INTR_MASK_m_rx_done(data)                                            (0x00000080&((data)<<7))
+#define ISO_IC0_INTR_MASK_m_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC0_INTR_MASK_get_m_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC0_INTR_MASK_m_tx_abrt_shift                                            (6)
+#define ISO_IC0_INTR_MASK_m_tx_abrt_mask                                             (0x00000040)
+#define ISO_IC0_INTR_MASK_m_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC0_INTR_MASK_m_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_INTR_MASK_get_m_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_INTR_MASK_m_rd_req_shift                                             (5)
+#define ISO_IC0_INTR_MASK_m_rd_req_mask                                              (0x00000020)
+#define ISO_IC0_INTR_MASK_m_rd_req(data)                                             (0x00000020&((data)<<5))
+#define ISO_IC0_INTR_MASK_m_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC0_INTR_MASK_get_m_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC0_INTR_MASK_m_tx_empty_shift                                           (4)
+#define ISO_IC0_INTR_MASK_m_tx_empty_mask                                            (0x00000010)
+#define ISO_IC0_INTR_MASK_m_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define ISO_IC0_INTR_MASK_m_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC0_INTR_MASK_get_m_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC0_INTR_MASK_m_tx_over_shift                                            (3)
+#define ISO_IC0_INTR_MASK_m_tx_over_mask                                             (0x00000008)
+#define ISO_IC0_INTR_MASK_m_tx_over(data)                                            (0x00000008&((data)<<3))
+#define ISO_IC0_INTR_MASK_m_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC0_INTR_MASK_get_m_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC0_INTR_MASK_m_rx_full_shift                                            (2)
+#define ISO_IC0_INTR_MASK_m_rx_full_mask                                             (0x00000004)
+#define ISO_IC0_INTR_MASK_m_rx_full(data)                                            (0x00000004&((data)<<2))
+#define ISO_IC0_INTR_MASK_m_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC0_INTR_MASK_get_m_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC0_INTR_MASK_m_rx_over_shift                                            (1)
+#define ISO_IC0_INTR_MASK_m_rx_over_mask                                             (0x00000002)
+#define ISO_IC0_INTR_MASK_m_rx_over(data)                                            (0x00000002&((data)<<1))
+#define ISO_IC0_INTR_MASK_m_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC0_INTR_MASK_get_m_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC0_INTR_MASK_m_rx_under_shift                                           (0)
+#define ISO_IC0_INTR_MASK_m_rx_under_mask                                            (0x00000001)
+#define ISO_IC0_INTR_MASK_m_rx_under(data)                                           (0x00000001&((data)<<0))
+#define ISO_IC0_INTR_MASK_m_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_IC0_INTR_MASK_get_m_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_RAW_INTR_STAT                                                        0x18007D34
+#define ISO_IC0_RAW_INTR_STAT_reg_addr                                               "0xB8007D34"
+#define ISO_IC0_RAW_INTR_STAT_reg                                                    0xB8007D34
+#define set_ISO_IC0_RAW_INTR_STAT_reg(data)   (*((volatile unsigned int*) ISO_IC0_RAW_INTR_STAT_reg)=data)
+#define get_ISO_IC0_RAW_INTR_STAT_reg   (*((volatile unsigned int*) ISO_IC0_RAW_INTR_STAT_reg))
+#define ISO_IC0_RAW_INTR_STAT_inst_adr                                               "0x004D"
+#define ISO_IC0_RAW_INTR_STAT_inst                                                   0x004D
+#define ISO_IC0_RAW_INTR_STAT_gen_call_shift                                         (11)
+#define ISO_IC0_RAW_INTR_STAT_gen_call_mask                                          (0x00000800)
+#define ISO_IC0_RAW_INTR_STAT_gen_call(data)                                         (0x00000800&((data)<<11))
+#define ISO_IC0_RAW_INTR_STAT_gen_call_src(data)                                     ((0x00000800&(data))>>11)
+#define ISO_IC0_RAW_INTR_STAT_get_gen_call(data)                                     ((0x00000800&(data))>>11)
+#define ISO_IC0_RAW_INTR_STAT_start_det_shift                                        (10)
+#define ISO_IC0_RAW_INTR_STAT_start_det_mask                                         (0x00000400)
+#define ISO_IC0_RAW_INTR_STAT_start_det(data)                                        (0x00000400&((data)<<10))
+#define ISO_IC0_RAW_INTR_STAT_start_det_src(data)                                    ((0x00000400&(data))>>10)
+#define ISO_IC0_RAW_INTR_STAT_get_start_det(data)                                    ((0x00000400&(data))>>10)
+#define ISO_IC0_RAW_INTR_STAT_stop_det_shift                                         (9)
+#define ISO_IC0_RAW_INTR_STAT_stop_det_mask                                          (0x00000200)
+#define ISO_IC0_RAW_INTR_STAT_stop_det(data)                                         (0x00000200&((data)<<9))
+#define ISO_IC0_RAW_INTR_STAT_stop_det_src(data)                                     ((0x00000200&(data))>>9)
+#define ISO_IC0_RAW_INTR_STAT_get_stop_det(data)                                     ((0x00000200&(data))>>9)
+#define ISO_IC0_RAW_INTR_STAT_activity_shift                                         (8)
+#define ISO_IC0_RAW_INTR_STAT_activity_mask                                          (0x00000100)
+#define ISO_IC0_RAW_INTR_STAT_activity(data)                                         (0x00000100&((data)<<8))
+#define ISO_IC0_RAW_INTR_STAT_activity_src(data)                                     ((0x00000100&(data))>>8)
+#define ISO_IC0_RAW_INTR_STAT_get_activity(data)                                     ((0x00000100&(data))>>8)
+#define ISO_IC0_RAW_INTR_STAT_rx_done_shift                                          (7)
+#define ISO_IC0_RAW_INTR_STAT_rx_done_mask                                           (0x00000080)
+#define ISO_IC0_RAW_INTR_STAT_rx_done(data)                                          (0x00000080&((data)<<7))
+#define ISO_IC0_RAW_INTR_STAT_rx_done_src(data)                                      ((0x00000080&(data))>>7)
+#define ISO_IC0_RAW_INTR_STAT_get_rx_done(data)                                      ((0x00000080&(data))>>7)
+#define ISO_IC0_RAW_INTR_STAT_tx_abrt_shift                                          (6)
+#define ISO_IC0_RAW_INTR_STAT_tx_abrt_mask                                           (0x00000040)
+#define ISO_IC0_RAW_INTR_STAT_tx_abrt(data)                                          (0x00000040&((data)<<6))
+#define ISO_IC0_RAW_INTR_STAT_tx_abrt_src(data)                                      ((0x00000040&(data))>>6)
+#define ISO_IC0_RAW_INTR_STAT_get_tx_abrt(data)                                      ((0x00000040&(data))>>6)
+#define ISO_IC0_RAW_INTR_STAT_rd_req_shift                                           (5)
+#define ISO_IC0_RAW_INTR_STAT_rd_req_mask                                            (0x00000020)
+#define ISO_IC0_RAW_INTR_STAT_rd_req(data)                                           (0x00000020&((data)<<5))
+#define ISO_IC0_RAW_INTR_STAT_rd_req_src(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC0_RAW_INTR_STAT_get_rd_req(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC0_RAW_INTR_STAT_tx_empty_shift                                         (4)
+#define ISO_IC0_RAW_INTR_STAT_tx_empty_mask                                          (0x00000010)
+#define ISO_IC0_RAW_INTR_STAT_tx_empty(data)                                         (0x00000010&((data)<<4))
+#define ISO_IC0_RAW_INTR_STAT_tx_empty_src(data)                                     ((0x00000010&(data))>>4)
+#define ISO_IC0_RAW_INTR_STAT_get_tx_empty(data)                                     ((0x00000010&(data))>>4)
+#define ISO_IC0_RAW_INTR_STAT_tx_over_shift                                          (3)
+#define ISO_IC0_RAW_INTR_STAT_tx_over_mask                                           (0x00000008)
+#define ISO_IC0_RAW_INTR_STAT_tx_over(data)                                          (0x00000008&((data)<<3))
+#define ISO_IC0_RAW_INTR_STAT_tx_over_src(data)                                      ((0x00000008&(data))>>3)
+#define ISO_IC0_RAW_INTR_STAT_get_tx_over(data)                                      ((0x00000008&(data))>>3)
+#define ISO_IC0_RAW_INTR_STAT_rx_full_shift                                          (2)
+#define ISO_IC0_RAW_INTR_STAT_rx_full_mask                                           (0x00000004)
+#define ISO_IC0_RAW_INTR_STAT_rx_full(data)                                          (0x00000004&((data)<<2))
+#define ISO_IC0_RAW_INTR_STAT_rx_full_src(data)                                      ((0x00000004&(data))>>2)
+#define ISO_IC0_RAW_INTR_STAT_get_rx_full(data)                                      ((0x00000004&(data))>>2)
+#define ISO_IC0_RAW_INTR_STAT_rx_over_shift                                          (1)
+#define ISO_IC0_RAW_INTR_STAT_rx_over_mask                                           (0x00000002)
+#define ISO_IC0_RAW_INTR_STAT_rx_over(data)                                          (0x00000002&((data)<<1))
+#define ISO_IC0_RAW_INTR_STAT_rx_over_src(data)                                      ((0x00000002&(data))>>1)
+#define ISO_IC0_RAW_INTR_STAT_get_rx_over(data)                                      ((0x00000002&(data))>>1)
+#define ISO_IC0_RAW_INTR_STAT_rx_under_shift                                         (0)
+#define ISO_IC0_RAW_INTR_STAT_rx_under_mask                                          (0x00000001)
+#define ISO_IC0_RAW_INTR_STAT_rx_under(data)                                         (0x00000001&((data)<<0))
+#define ISO_IC0_RAW_INTR_STAT_rx_under_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_IC0_RAW_INTR_STAT_get_rx_under(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_RX_TL                                                                0x18007D38
+#define ISO_IC0_RX_TL_reg_addr                                                       "0xB8007D38"
+#define ISO_IC0_RX_TL_reg                                                            0xB8007D38
+#define set_ISO_IC0_RX_TL_reg(data)   (*((volatile unsigned int*) ISO_IC0_RX_TL_reg)=data)
+#define get_ISO_IC0_RX_TL_reg   (*((volatile unsigned int*) ISO_IC0_RX_TL_reg))
+#define ISO_IC0_RX_TL_inst_adr                                                       "0x004E"
+#define ISO_IC0_RX_TL_inst                                                           0x004E
+#define ISO_IC0_RX_TL_rx_tl_shift                                                    (0)
+#define ISO_IC0_RX_TL_rx_tl_mask                                                     (0x000000FF)
+#define ISO_IC0_RX_TL_rx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_IC0_RX_TL_rx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_IC0_RX_TL_get_rx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC0_TX_TL                                                                0x18007D3C
+#define ISO_IC0_TX_TL_reg_addr                                                       "0xB8007D3C"
+#define ISO_IC0_TX_TL_reg                                                            0xB8007D3C
+#define set_ISO_IC0_TX_TL_reg(data)   (*((volatile unsigned int*) ISO_IC0_TX_TL_reg)=data)
+#define get_ISO_IC0_TX_TL_reg   (*((volatile unsigned int*) ISO_IC0_TX_TL_reg))
+#define ISO_IC0_TX_TL_inst_adr                                                       "0x004F"
+#define ISO_IC0_TX_TL_inst                                                           0x004F
+#define ISO_IC0_TX_TL_tx_tl_shift                                                    (0)
+#define ISO_IC0_TX_TL_tx_tl_mask                                                     (0x000000FF)
+#define ISO_IC0_TX_TL_tx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_IC0_TX_TL_tx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_IC0_TX_TL_get_tx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC0_CLR_INTR                                                             0x18007D40
+#define ISO_IC0_CLR_INTR_reg_addr                                                    "0xB8007D40"
+#define ISO_IC0_CLR_INTR_reg                                                         0xB8007D40
+#define set_ISO_IC0_CLR_INTR_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_INTR_reg)=data)
+#define get_ISO_IC0_CLR_INTR_reg   (*((volatile unsigned int*) ISO_IC0_CLR_INTR_reg))
+#define ISO_IC0_CLR_INTR_inst_adr                                                    "0x0050"
+#define ISO_IC0_CLR_INTR_inst                                                        0x0050
+#define ISO_IC0_CLR_INTR_clr_intr_shift                                              (0)
+#define ISO_IC0_CLR_INTR_clr_intr_mask                                               (0x00000001)
+#define ISO_IC0_CLR_INTR_clr_intr(data)                                              (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_INTR_clr_intr_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_INTR_get_clr_intr(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_RX_UNDER                                                         0x18007D44
+#define ISO_IC0_CLR_RX_UNDER_reg_addr                                                "0xB8007D44"
+#define ISO_IC0_CLR_RX_UNDER_reg                                                     0xB8007D44
+#define set_ISO_IC0_CLR_RX_UNDER_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_RX_UNDER_reg)=data)
+#define get_ISO_IC0_CLR_RX_UNDER_reg   (*((volatile unsigned int*) ISO_IC0_CLR_RX_UNDER_reg))
+#define ISO_IC0_CLR_RX_UNDER_inst_adr                                                "0x0051"
+#define ISO_IC0_CLR_RX_UNDER_inst                                                    0x0051
+#define ISO_IC0_CLR_RX_UNDER_clr_rx_under_shift                                      (0)
+#define ISO_IC0_CLR_RX_UNDER_clr_rx_under_mask                                       (0x00000001)
+#define ISO_IC0_CLR_RX_UNDER_clr_rx_under(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_RX_UNDER_clr_rx_under_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_RX_UNDER_get_clr_rx_under(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_RX_OVER                                                          0x18007D48
+#define ISO_IC0_CLR_RX_OVER_reg_addr                                                 "0xB8007D48"
+#define ISO_IC0_CLR_RX_OVER_reg                                                      0xB8007D48
+#define set_ISO_IC0_CLR_RX_OVER_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_RX_OVER_reg)=data)
+#define get_ISO_IC0_CLR_RX_OVER_reg   (*((volatile unsigned int*) ISO_IC0_CLR_RX_OVER_reg))
+#define ISO_IC0_CLR_RX_OVER_inst_adr                                                 "0x0052"
+#define ISO_IC0_CLR_RX_OVER_inst                                                     0x0052
+#define ISO_IC0_CLR_RX_OVER_clr_rx_over_shift                                        (0)
+#define ISO_IC0_CLR_RX_OVER_clr_rx_over_mask                                         (0x00000001)
+#define ISO_IC0_CLR_RX_OVER_clr_rx_over(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_RX_OVER_clr_rx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_RX_OVER_get_clr_rx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_TX_OVER                                                          0x18007D4C
+#define ISO_IC0_CLR_TX_OVER_reg_addr                                                 "0xB8007D4C"
+#define ISO_IC0_CLR_TX_OVER_reg                                                      0xB8007D4C
+#define set_ISO_IC0_CLR_TX_OVER_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_TX_OVER_reg)=data)
+#define get_ISO_IC0_CLR_TX_OVER_reg   (*((volatile unsigned int*) ISO_IC0_CLR_TX_OVER_reg))
+#define ISO_IC0_CLR_TX_OVER_inst_adr                                                 "0x0053"
+#define ISO_IC0_CLR_TX_OVER_inst                                                     0x0053
+#define ISO_IC0_CLR_TX_OVER_clr_tx_over_shift                                        (0)
+#define ISO_IC0_CLR_TX_OVER_clr_tx_over_mask                                         (0x00000001)
+#define ISO_IC0_CLR_TX_OVER_clr_tx_over(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_TX_OVER_clr_tx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_TX_OVER_get_clr_tx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_RD_REQ                                                           0x18007D50
+#define ISO_IC0_CLR_RD_REQ_reg_addr                                                  "0xB8007D50"
+#define ISO_IC0_CLR_RD_REQ_reg                                                       0xB8007D50
+#define set_ISO_IC0_CLR_RD_REQ_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_RD_REQ_reg)=data)
+#define get_ISO_IC0_CLR_RD_REQ_reg   (*((volatile unsigned int*) ISO_IC0_CLR_RD_REQ_reg))
+#define ISO_IC0_CLR_RD_REQ_inst_adr                                                  "0x0054"
+#define ISO_IC0_CLR_RD_REQ_inst                                                      0x0054
+#define ISO_IC0_CLR_RD_REQ_clr_rd_req_shift                                          (0)
+#define ISO_IC0_CLR_RD_REQ_clr_rd_req_mask                                           (0x00000001)
+#define ISO_IC0_CLR_RD_REQ_clr_rd_req(data)                                          (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_RD_REQ_clr_rd_req_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_RD_REQ_get_clr_rd_req(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_TX_ABRT                                                          0x18007D54
+#define ISO_IC0_CLR_TX_ABRT_reg_addr                                                 "0xB8007D54"
+#define ISO_IC0_CLR_TX_ABRT_reg                                                      0xB8007D54
+#define set_ISO_IC0_CLR_TX_ABRT_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_TX_ABRT_reg)=data)
+#define get_ISO_IC0_CLR_TX_ABRT_reg   (*((volatile unsigned int*) ISO_IC0_CLR_TX_ABRT_reg))
+#define ISO_IC0_CLR_TX_ABRT_inst_adr                                                 "0x0055"
+#define ISO_IC0_CLR_TX_ABRT_inst                                                     0x0055
+#define ISO_IC0_CLR_TX_ABRT_clr_tx_abrt_shift                                        (0)
+#define ISO_IC0_CLR_TX_ABRT_clr_tx_abrt_mask                                         (0x00000001)
+#define ISO_IC0_CLR_TX_ABRT_clr_tx_abrt(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_TX_ABRT_clr_tx_abrt_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_TX_ABRT_get_clr_tx_abrt(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_RX_DONE                                                          0x18007D58
+#define ISO_IC0_CLR_RX_DONE_reg_addr                                                 "0xB8007D58"
+#define ISO_IC0_CLR_RX_DONE_reg                                                      0xB8007D58
+#define set_ISO_IC0_CLR_RX_DONE_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_RX_DONE_reg)=data)
+#define get_ISO_IC0_CLR_RX_DONE_reg   (*((volatile unsigned int*) ISO_IC0_CLR_RX_DONE_reg))
+#define ISO_IC0_CLR_RX_DONE_inst_adr                                                 "0x0056"
+#define ISO_IC0_CLR_RX_DONE_inst                                                     0x0056
+#define ISO_IC0_CLR_RX_DONE_clr_rx_done_shift                                        (0)
+#define ISO_IC0_CLR_RX_DONE_clr_rx_done_mask                                         (0x00000001)
+#define ISO_IC0_CLR_RX_DONE_clr_rx_done(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_RX_DONE_clr_rx_done_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_RX_DONE_get_clr_rx_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_ACTIVITY                                                         0x18007D5C
+#define ISO_IC0_CLR_ACTIVITY_reg_addr                                                "0xB8007D5C"
+#define ISO_IC0_CLR_ACTIVITY_reg                                                     0xB8007D5C
+#define set_ISO_IC0_CLR_ACTIVITY_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_ACTIVITY_reg)=data)
+#define get_ISO_IC0_CLR_ACTIVITY_reg   (*((volatile unsigned int*) ISO_IC0_CLR_ACTIVITY_reg))
+#define ISO_IC0_CLR_ACTIVITY_inst_adr                                                "0x0057"
+#define ISO_IC0_CLR_ACTIVITY_inst                                                    0x0057
+#define ISO_IC0_CLR_ACTIVITY_clr_activity_shift                                      (0)
+#define ISO_IC0_CLR_ACTIVITY_clr_activity_mask                                       (0x00000001)
+#define ISO_IC0_CLR_ACTIVITY_clr_activity(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_ACTIVITY_clr_activity_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_ACTIVITY_get_clr_activity(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_STOP_DET                                                         0x18007D60
+#define ISO_IC0_CLR_STOP_DET_reg_addr                                                "0xB8007D60"
+#define ISO_IC0_CLR_STOP_DET_reg                                                     0xB8007D60
+#define set_ISO_IC0_CLR_STOP_DET_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_STOP_DET_reg)=data)
+#define get_ISO_IC0_CLR_STOP_DET_reg   (*((volatile unsigned int*) ISO_IC0_CLR_STOP_DET_reg))
+#define ISO_IC0_CLR_STOP_DET_inst_adr                                                "0x0058"
+#define ISO_IC0_CLR_STOP_DET_inst                                                    0x0058
+#define ISO_IC0_CLR_STOP_DET_clr_stop_det_shift                                      (0)
+#define ISO_IC0_CLR_STOP_DET_clr_stop_det_mask                                       (0x00000001)
+#define ISO_IC0_CLR_STOP_DET_clr_stop_det(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_STOP_DET_clr_stop_det_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_STOP_DET_get_clr_stop_det(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_START_DET                                                        0x18007D64
+#define ISO_IC0_CLR_START_DET_reg_addr                                               "0xB8007D64"
+#define ISO_IC0_CLR_START_DET_reg                                                    0xB8007D64
+#define set_ISO_IC0_CLR_START_DET_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_START_DET_reg)=data)
+#define get_ISO_IC0_CLR_START_DET_reg   (*((volatile unsigned int*) ISO_IC0_CLR_START_DET_reg))
+#define ISO_IC0_CLR_START_DET_inst_adr                                               "0x0059"
+#define ISO_IC0_CLR_START_DET_inst                                                   0x0059
+#define ISO_IC0_CLR_START_DET_clr_start_det_shift                                    (0)
+#define ISO_IC0_CLR_START_DET_clr_start_det_mask                                     (0x00000001)
+#define ISO_IC0_CLR_START_DET_clr_start_det(data)                                    (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_START_DET_clr_start_det_src(data)                                ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_START_DET_get_clr_start_det(data)                                ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_CLR_GEN_CALL                                                         0x18007D68
+#define ISO_IC0_CLR_GEN_CALL_reg_addr                                                "0xB8007D68"
+#define ISO_IC0_CLR_GEN_CALL_reg                                                     0xB8007D68
+#define set_ISO_IC0_CLR_GEN_CALL_reg(data)   (*((volatile unsigned int*) ISO_IC0_CLR_GEN_CALL_reg)=data)
+#define get_ISO_IC0_CLR_GEN_CALL_reg   (*((volatile unsigned int*) ISO_IC0_CLR_GEN_CALL_reg))
+#define ISO_IC0_CLR_GEN_CALL_inst_adr                                                "0x005A"
+#define ISO_IC0_CLR_GEN_CALL_inst                                                    0x005A
+#define ISO_IC0_CLR_GEN_CALL_clr_gen_call_shift                                      (0)
+#define ISO_IC0_CLR_GEN_CALL_clr_gen_call_mask                                       (0x00000001)
+#define ISO_IC0_CLR_GEN_CALL_clr_gen_call(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC0_CLR_GEN_CALL_clr_gen_call_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC0_CLR_GEN_CALL_get_clr_gen_call(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_ENABLE                                                               0x18007D6C
+#define ISO_IC0_ENABLE_reg_addr                                                      "0xB8007D6C"
+#define ISO_IC0_ENABLE_reg                                                           0xB8007D6C
+#define set_ISO_IC0_ENABLE_reg(data)   (*((volatile unsigned int*) ISO_IC0_ENABLE_reg)=data)
+#define get_ISO_IC0_ENABLE_reg   (*((volatile unsigned int*) ISO_IC0_ENABLE_reg))
+#define ISO_IC0_ENABLE_inst_adr                                                      "0x005B"
+#define ISO_IC0_ENABLE_inst                                                          0x005B
+#define ISO_IC0_ENABLE_enable_shift                                                  (0)
+#define ISO_IC0_ENABLE_enable_mask                                                   (0x00000001)
+#define ISO_IC0_ENABLE_enable(data)                                                  (0x00000001&((data)<<0))
+#define ISO_IC0_ENABLE_enable_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_IC0_ENABLE_get_enable(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_STATUS                                                               0x18007D70
+#define ISO_IC0_STATUS_reg_addr                                                      "0xB8007D70"
+#define ISO_IC0_STATUS_reg                                                           0xB8007D70
+#define set_ISO_IC0_STATUS_reg(data)   (*((volatile unsigned int*) ISO_IC0_STATUS_reg)=data)
+#define get_ISO_IC0_STATUS_reg   (*((volatile unsigned int*) ISO_IC0_STATUS_reg))
+#define ISO_IC0_STATUS_inst_adr                                                      "0x005C"
+#define ISO_IC0_STATUS_inst                                                          0x005C
+#define ISO_IC0_STATUS_slv_activity_shift                                            (6)
+#define ISO_IC0_STATUS_slv_activity_mask                                             (0x00000040)
+#define ISO_IC0_STATUS_slv_activity(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC0_STATUS_slv_activity_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_STATUS_get_slv_activity(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC0_STATUS_mst_activity_shift                                            (5)
+#define ISO_IC0_STATUS_mst_activity_mask                                             (0x00000020)
+#define ISO_IC0_STATUS_mst_activity(data)                                            (0x00000020&((data)<<5))
+#define ISO_IC0_STATUS_mst_activity_src(data)                                        ((0x00000020&(data))>>5)
+#define ISO_IC0_STATUS_get_mst_activity(data)                                        ((0x00000020&(data))>>5)
+#define ISO_IC0_STATUS_rff_shift                                                     (4)
+#define ISO_IC0_STATUS_rff_mask                                                      (0x00000010)
+#define ISO_IC0_STATUS_rff(data)                                                     (0x00000010&((data)<<4))
+#define ISO_IC0_STATUS_rff_src(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IC0_STATUS_get_rff(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IC0_STATUS_rfne_shift                                                    (3)
+#define ISO_IC0_STATUS_rfne_mask                                                     (0x00000008)
+#define ISO_IC0_STATUS_rfne(data)                                                    (0x00000008&((data)<<3))
+#define ISO_IC0_STATUS_rfne_src(data)                                                ((0x00000008&(data))>>3)
+#define ISO_IC0_STATUS_get_rfne(data)                                                ((0x00000008&(data))>>3)
+#define ISO_IC0_STATUS_tfe_shift                                                     (2)
+#define ISO_IC0_STATUS_tfe_mask                                                      (0x00000004)
+#define ISO_IC0_STATUS_tfe(data)                                                     (0x00000004&((data)<<2))
+#define ISO_IC0_STATUS_tfe_src(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_IC0_STATUS_get_tfe(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_IC0_STATUS_tfnf_shift                                                    (1)
+#define ISO_IC0_STATUS_tfnf_mask                                                     (0x00000002)
+#define ISO_IC0_STATUS_tfnf(data)                                                    (0x00000002&((data)<<1))
+#define ISO_IC0_STATUS_tfnf_src(data)                                                ((0x00000002&(data))>>1)
+#define ISO_IC0_STATUS_get_tfnf(data)                                                ((0x00000002&(data))>>1)
+#define ISO_IC0_STATUS_activity_shift                                                (0)
+#define ISO_IC0_STATUS_activity_mask                                                 (0x00000001)
+#define ISO_IC0_STATUS_activity(data)                                                (0x00000001&((data)<<0))
+#define ISO_IC0_STATUS_activity_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_IC0_STATUS_get_activity(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_TXFLR                                                                0x18007D74
+#define ISO_IC0_TXFLR_reg_addr                                                       "0xB8007D74"
+#define ISO_IC0_TXFLR_reg                                                            0xB8007D74
+#define set_ISO_IC0_TXFLR_reg(data)   (*((volatile unsigned int*) ISO_IC0_TXFLR_reg)=data)
+#define get_ISO_IC0_TXFLR_reg   (*((volatile unsigned int*) ISO_IC0_TXFLR_reg))
+#define ISO_IC0_TXFLR_inst_adr                                                       "0x005D"
+#define ISO_IC0_TXFLR_inst                                                           0x005D
+#define ISO_IC0_TXFLR_txflr_shift                                                    (0)
+#define ISO_IC0_TXFLR_txflr_mask                                                     (0x0000000F)
+#define ISO_IC0_TXFLR_txflr(data)                                                    (0x0000000F&((data)<<0))
+#define ISO_IC0_TXFLR_txflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define ISO_IC0_TXFLR_get_txflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC0_RXFLR                                                                0x18007D78
+#define ISO_IC0_RXFLR_reg_addr                                                       "0xB8007D78"
+#define ISO_IC0_RXFLR_reg                                                            0xB8007D78
+#define set_ISO_IC0_RXFLR_reg(data)   (*((volatile unsigned int*) ISO_IC0_RXFLR_reg)=data)
+#define get_ISO_IC0_RXFLR_reg   (*((volatile unsigned int*) ISO_IC0_RXFLR_reg))
+#define ISO_IC0_RXFLR_inst_adr                                                       "0x005E"
+#define ISO_IC0_RXFLR_inst                                                           0x005E
+#define ISO_IC0_RXFLR_rxflr_shift                                                    (0)
+#define ISO_IC0_RXFLR_rxflr_mask                                                     (0x0000000F)
+#define ISO_IC0_RXFLR_rxflr(data)                                                    (0x0000000F&((data)<<0))
+#define ISO_IC0_RXFLR_rxflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define ISO_IC0_RXFLR_get_rxflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC0_SDA_HOLD                                                             0x18007D7C
+#define ISO_IC0_SDA_HOLD_reg_addr                                                    "0xB8007D7C"
+#define ISO_IC0_SDA_HOLD_reg                                                         0xB8007D7C
+#define set_ISO_IC0_SDA_HOLD_reg(data)   (*((volatile unsigned int*) ISO_IC0_SDA_HOLD_reg)=data)
+#define get_ISO_IC0_SDA_HOLD_reg   (*((volatile unsigned int*) ISO_IC0_SDA_HOLD_reg))
+#define ISO_IC0_SDA_HOLD_inst_adr                                                    "0x005F"
+#define ISO_IC0_SDA_HOLD_inst                                                        0x005F
+#define ISO_IC0_SDA_HOLD_ic_sda_hold_shift                                           (0)
+#define ISO_IC0_SDA_HOLD_ic_sda_hold_mask                                            (0x0000FFFF)
+#define ISO_IC0_SDA_HOLD_ic_sda_hold(data)                                           (0x0000FFFF&((data)<<0))
+#define ISO_IC0_SDA_HOLD_ic_sda_hold_src(data)                                       ((0x0000FFFF&(data))>>0)
+#define ISO_IC0_SDA_HOLD_get_ic_sda_hold(data)                                       ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC0_TX_ABRT_SOURCE                                                       0x18007D80
+#define ISO_IC0_TX_ABRT_SOURCE_reg_addr                                              "0xB8007D80"
+#define ISO_IC0_TX_ABRT_SOURCE_reg                                                   0xB8007D80
+#define set_ISO_IC0_TX_ABRT_SOURCE_reg(data)   (*((volatile unsigned int*) ISO_IC0_TX_ABRT_SOURCE_reg)=data)
+#define get_ISO_IC0_TX_ABRT_SOURCE_reg   (*((volatile unsigned int*) ISO_IC0_TX_ABRT_SOURCE_reg))
+#define ISO_IC0_TX_ABRT_SOURCE_inst_adr                                              "0x0060"
+#define ISO_IC0_TX_ABRT_SOURCE_inst                                                  0x0060
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvrd_intx_shift                                 (15)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvrd_intx_mask                                  (0x00008000)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvrd_intx(data)                                 (0x00008000&((data)<<15))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvrd_intx_src(data)                             ((0x00008000&(data))>>15)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_slvrd_intx(data)                             ((0x00008000&(data))>>15)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slv_arblost_shift                                (14)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slv_arblost_mask                                 (0x00004000)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slv_arblost(data)                                (0x00004000&((data)<<14))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slv_arblost_src(data)                            ((0x00004000&(data))>>14)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_slv_arblost(data)                            ((0x00004000&(data))>>14)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvflush_txfifo_shift                            (13)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvflush_txfifo_mask                             (0x00002000)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvflush_txfifo(data)                            (0x00002000&((data)<<13))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_slvflush_txfifo_src(data)                        ((0x00002000&(data))>>13)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_slvflush_txfifo(data)                        ((0x00002000&(data))>>13)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_lost_shift                                        (12)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_lost_mask                                         (0x00001000)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_lost(data)                                        (0x00001000&((data)<<12))
+#define ISO_IC0_TX_ABRT_SOURCE_arb_lost_src(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC0_TX_ABRT_SOURCE_get_arb_lost(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_master_dis_shift                                  (11)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_master_dis_mask                                   (0x00000800)
+#define ISO_IC0_TX_ABRT_SOURCE_arb_master_dis(data)                                  (0x00000800&((data)<<11))
+#define ISO_IC0_TX_ABRT_SOURCE_arb_master_dis_src(data)                              ((0x00000800&(data))>>11)
+#define ISO_IC0_TX_ABRT_SOURCE_get_arb_master_dis(data)                              ((0x00000800&(data))>>11)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_shift                             (10)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_mask                              (0x00000400)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10b_rd_norstrt(data)                             (0x00000400&((data)<<10))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_src(data)                         ((0x00000400&(data))>>10)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_10b_rd_norstrt(data)                         ((0x00000400&(data))>>10)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_norstrt_shift                              (9)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_norstrt_mask                               (0x00000200)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_norstrt(data)                              (0x00000200&((data)<<9))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_norstrt_src(data)                          ((0x00000200&(data))>>9)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_sbyte_norstrt(data)                          ((0x00000200&(data))>>9)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_norstrt_shift                                 (8)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_norstrt_mask                                  (0x00000100)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_norstrt(data)                                 (0x00000100&((data)<<8))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_norstrt_src(data)                             ((0x00000100&(data))>>8)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_hs_norstrt(data)                             ((0x00000100&(data))>>8)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_ackdet_shift                               (7)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_ackdet_mask                                (0x00000080)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_ackdet(data)                               (0x00000080&((data)<<7))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_sbyte_ackdet_src(data)                           ((0x00000080&(data))>>7)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_sbyte_ackdet(data)                           ((0x00000080&(data))>>7)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_ackdet_shift                                  (6)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_ackdet_mask                                   (0x00000040)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_ackdet(data)                                  (0x00000040&((data)<<6))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_hs_ackdet_src(data)                              ((0x00000040&(data))>>6)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_hs_ackdet(data)                              ((0x00000040&(data))>>6)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_read_shift                                 (5)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_read_mask                                  (0x00000020)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_read(data)                                 (0x00000020&((data)<<5))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_read_src(data)                             ((0x00000020&(data))>>5)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_gcall_read(data)                             ((0x00000020&(data))>>5)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_noack_shift                                (4)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_noack_mask                                 (0x00000010)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_noack(data)                                (0x00000010&((data)<<4))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_gcall_noack_src(data)                            ((0x00000010&(data))>>4)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_gcall_noack(data)                            ((0x00000010&(data))>>4)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_txdata_noack_shift                               (3)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_txdata_noack_mask                                (0x00000008)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_txdata_noack(data)                               (0x00000008&((data)<<3))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_txdata_noack_src(data)                           ((0x00000008&(data))>>3)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_txdata_noack(data)                           ((0x00000008&(data))>>3)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr2_noack_shift                              (2)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr2_noack_mask                               (0x00000004)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr2_noack(data)                              (0x00000004&((data)<<2))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr2_noack_src(data)                          ((0x00000004&(data))>>2)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_10addr2_noack(data)                          ((0x00000004&(data))>>2)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr1_noack_shift                              (1)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr1_noack_mask                               (0x00000002)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr1_noack(data)                              (0x00000002&((data)<<1))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_10addr1_noack_src(data)                          ((0x00000002&(data))>>1)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_10addr1_noack(data)                          ((0x00000002&(data))>>1)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_7b_addr_noack_shift                              (0)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_7b_addr_noack_mask                               (0x00000001)
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_7b_addr_noack(data)                              (0x00000001&((data)<<0))
+#define ISO_IC0_TX_ABRT_SOURCE_abrt_7b_addr_noack_src(data)                          ((0x00000001&(data))>>0)
+#define ISO_IC0_TX_ABRT_SOURCE_get_abrt_7b_addr_noack(data)                          ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_SLV_DATA_NACK_ONLY                                                   0x18007D84
+#define ISO_IC0_SLV_DATA_NACK_ONLY_reg_addr                                          "0xB8007D84"
+#define ISO_IC0_SLV_DATA_NACK_ONLY_reg                                               0xB8007D84
+#define set_ISO_IC0_SLV_DATA_NACK_ONLY_reg(data)   (*((volatile unsigned int*) ISO_IC0_SLV_DATA_NACK_ONLY_reg)=data)
+#define get_ISO_IC0_SLV_DATA_NACK_ONLY_reg   (*((volatile unsigned int*) ISO_IC0_SLV_DATA_NACK_ONLY_reg))
+#define ISO_IC0_SLV_DATA_NACK_ONLY_inst_adr                                          "0x0061"
+#define ISO_IC0_SLV_DATA_NACK_ONLY_inst                                              0x0061
+#define ISO_IC0_SLV_DATA_NACK_ONLY_nack_shift                                        (0)
+#define ISO_IC0_SLV_DATA_NACK_ONLY_nack_mask                                         (0x00000001)
+#define ISO_IC0_SLV_DATA_NACK_ONLY_nack(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC0_SLV_DATA_NACK_ONLY_nack_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC0_SLV_DATA_NACK_ONLY_get_nack(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_DMA_CR                                                               0x18007D88
+#define ISO_IC0_DMA_CR_reg_addr                                                      "0xB8007D88"
+#define ISO_IC0_DMA_CR_reg                                                           0xB8007D88
+#define set_ISO_IC0_DMA_CR_reg(data)   (*((volatile unsigned int*) ISO_IC0_DMA_CR_reg)=data)
+#define get_ISO_IC0_DMA_CR_reg   (*((volatile unsigned int*) ISO_IC0_DMA_CR_reg))
+#define ISO_IC0_DMA_CR_inst_adr                                                      "0x0062"
+#define ISO_IC0_DMA_CR_inst                                                          0x0062
+#define ISO_IC0_DMA_CR_tdmae_shift                                                   (1)
+#define ISO_IC0_DMA_CR_tdmae_mask                                                    (0x00000002)
+#define ISO_IC0_DMA_CR_tdmae(data)                                                   (0x00000002&((data)<<1))
+#define ISO_IC0_DMA_CR_tdmae_src(data)                                               ((0x00000002&(data))>>1)
+#define ISO_IC0_DMA_CR_get_tdmae(data)                                               ((0x00000002&(data))>>1)
+#define ISO_IC0_DMA_CR_rdmae_shift                                                   (0)
+#define ISO_IC0_DMA_CR_rdmae_mask                                                    (0x00000001)
+#define ISO_IC0_DMA_CR_rdmae(data)                                                   (0x00000001&((data)<<0))
+#define ISO_IC0_DMA_CR_rdmae_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_IC0_DMA_CR_get_rdmae(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_DMA_TDLR                                                             0x18007D8C
+#define ISO_IC0_DMA_TDLR_reg_addr                                                    "0xB8007D8C"
+#define ISO_IC0_DMA_TDLR_reg                                                         0xB8007D8C
+#define set_ISO_IC0_DMA_TDLR_reg(data)   (*((volatile unsigned int*) ISO_IC0_DMA_TDLR_reg)=data)
+#define get_ISO_IC0_DMA_TDLR_reg   (*((volatile unsigned int*) ISO_IC0_DMA_TDLR_reg))
+#define ISO_IC0_DMA_TDLR_inst_adr                                                    "0x0063"
+#define ISO_IC0_DMA_TDLR_inst                                                        0x0063
+#define ISO_IC0_DMA_TDLR_dmatdl_shift                                                (0)
+#define ISO_IC0_DMA_TDLR_dmatdl_mask                                                 (0x00000007)
+#define ISO_IC0_DMA_TDLR_dmatdl(data)                                                (0x00000007&((data)<<0))
+#define ISO_IC0_DMA_TDLR_dmatdl_src(data)                                            ((0x00000007&(data))>>0)
+#define ISO_IC0_DMA_TDLR_get_dmatdl(data)                                            ((0x00000007&(data))>>0)
+
+
+#define ISO_IC0_DMA_RDLR                                                             0x18007D90
+#define ISO_IC0_DMA_RDLR_reg_addr                                                    "0xB8007D90"
+#define ISO_IC0_DMA_RDLR_reg                                                         0xB8007D90
+#define set_ISO_IC0_DMA_RDLR_reg(data)   (*((volatile unsigned int*) ISO_IC0_DMA_RDLR_reg)=data)
+#define get_ISO_IC0_DMA_RDLR_reg   (*((volatile unsigned int*) ISO_IC0_DMA_RDLR_reg))
+#define ISO_IC0_DMA_RDLR_inst_adr                                                    "0x0064"
+#define ISO_IC0_DMA_RDLR_inst                                                        0x0064
+#define ISO_IC0_DMA_RDLR_dmardl_shift                                                (0)
+#define ISO_IC0_DMA_RDLR_dmardl_mask                                                 (0x0000000F)
+#define ISO_IC0_DMA_RDLR_dmardl(data)                                                (0x0000000F&((data)<<0))
+#define ISO_IC0_DMA_RDLR_dmardl_src(data)                                            ((0x0000000F&(data))>>0)
+#define ISO_IC0_DMA_RDLR_get_dmardl(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC0_SDA_SETUP                                                            0x18007D94
+#define ISO_IC0_SDA_SETUP_reg_addr                                                   "0xB8007D94"
+#define ISO_IC0_SDA_SETUP_reg                                                        0xB8007D94
+#define set_ISO_IC0_SDA_SETUP_reg(data)   (*((volatile unsigned int*) ISO_IC0_SDA_SETUP_reg)=data)
+#define get_ISO_IC0_SDA_SETUP_reg   (*((volatile unsigned int*) ISO_IC0_SDA_SETUP_reg))
+#define ISO_IC0_SDA_SETUP_inst_adr                                                   "0x0065"
+#define ISO_IC0_SDA_SETUP_inst                                                       0x0065
+#define ISO_IC0_SDA_SETUP_sda_setup_shift                                            (0)
+#define ISO_IC0_SDA_SETUP_sda_setup_mask                                             (0x000000FF)
+#define ISO_IC0_SDA_SETUP_sda_setup(data)                                            (0x000000FF&((data)<<0))
+#define ISO_IC0_SDA_SETUP_sda_setup_src(data)                                        ((0x000000FF&(data))>>0)
+#define ISO_IC0_SDA_SETUP_get_sda_setup(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC0_ACK_GENERAL_CALL                                                     0x18007D98
+#define ISO_IC0_ACK_GENERAL_CALL_reg_addr                                            "0xB8007D98"
+#define ISO_IC0_ACK_GENERAL_CALL_reg                                                 0xB8007D98
+#define set_ISO_IC0_ACK_GENERAL_CALL_reg(data)   (*((volatile unsigned int*) ISO_IC0_ACK_GENERAL_CALL_reg)=data)
+#define get_ISO_IC0_ACK_GENERAL_CALL_reg   (*((volatile unsigned int*) ISO_IC0_ACK_GENERAL_CALL_reg))
+#define ISO_IC0_ACK_GENERAL_CALL_inst_adr                                            "0x0066"
+#define ISO_IC0_ACK_GENERAL_CALL_inst                                                0x0066
+#define ISO_IC0_ACK_GENERAL_CALL_ack_gen_call_shift                                  (0)
+#define ISO_IC0_ACK_GENERAL_CALL_ack_gen_call_mask                                   (0x00000001)
+#define ISO_IC0_ACK_GENERAL_CALL_ack_gen_call(data)                                  (0x00000001&((data)<<0))
+#define ISO_IC0_ACK_GENERAL_CALL_ack_gen_call_src(data)                              ((0x00000001&(data))>>0)
+#define ISO_IC0_ACK_GENERAL_CALL_get_ack_gen_call(data)                              ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_ENABLE_STATUS                                                        0x18007D9C
+#define ISO_IC0_ENABLE_STATUS_reg_addr                                               "0xB8007D9C"
+#define ISO_IC0_ENABLE_STATUS_reg                                                    0xB8007D9C
+#define set_ISO_IC0_ENABLE_STATUS_reg(data)   (*((volatile unsigned int*) ISO_IC0_ENABLE_STATUS_reg)=data)
+#define get_ISO_IC0_ENABLE_STATUS_reg   (*((volatile unsigned int*) ISO_IC0_ENABLE_STATUS_reg))
+#define ISO_IC0_ENABLE_STATUS_inst_adr                                               "0x0067"
+#define ISO_IC0_ENABLE_STATUS_inst                                                   0x0067
+#define ISO_IC0_ENABLE_STATUS_slv_rx_data_lost_shift                                 (2)
+#define ISO_IC0_ENABLE_STATUS_slv_rx_data_lost_mask                                  (0x00000004)
+#define ISO_IC0_ENABLE_STATUS_slv_rx_data_lost(data)                                 (0x00000004&((data)<<2))
+#define ISO_IC0_ENABLE_STATUS_slv_rx_data_lost_src(data)                             ((0x00000004&(data))>>2)
+#define ISO_IC0_ENABLE_STATUS_get_slv_rx_data_lost(data)                             ((0x00000004&(data))>>2)
+#define ISO_IC0_ENABLE_STATUS_slv_disabled_whi_shift                                 (1)
+#define ISO_IC0_ENABLE_STATUS_slv_disabled_whi_mask                                  (0x00000002)
+#define ISO_IC0_ENABLE_STATUS_slv_disabled_whi(data)                                 (0x00000002&((data)<<1))
+#define ISO_IC0_ENABLE_STATUS_slv_disabled_whi_src(data)                             ((0x00000002&(data))>>1)
+#define ISO_IC0_ENABLE_STATUS_get_slv_disabled_whi(data)                             ((0x00000002&(data))>>1)
+#define ISO_IC0_ENABLE_STATUS_ic_en_shift                                            (0)
+#define ISO_IC0_ENABLE_STATUS_ic_en_mask                                             (0x00000001)
+#define ISO_IC0_ENABLE_STATUS_ic_en(data)                                            (0x00000001&((data)<<0))
+#define ISO_IC0_ENABLE_STATUS_ic_en_src(data)                                        ((0x00000001&(data))>>0)
+#define ISO_IC0_ENABLE_STATUS_get_ic_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define ISO_IC0_COMP_PARAM_1                                                         0x18007DF4
+#define ISO_IC0_COMP_PARAM_1_reg_addr                                                "0xB8007DF4"
+#define ISO_IC0_COMP_PARAM_1_reg                                                     0xB8007DF4
+#define set_ISO_IC0_COMP_PARAM_1_reg(data)   (*((volatile unsigned int*) ISO_IC0_COMP_PARAM_1_reg)=data)
+#define get_ISO_IC0_COMP_PARAM_1_reg   (*((volatile unsigned int*) ISO_IC0_COMP_PARAM_1_reg))
+#define ISO_IC0_COMP_PARAM_1_inst_adr                                                "0x007D"
+#define ISO_IC0_COMP_PARAM_1_inst                                                    0x007D
+#define ISO_IC0_COMP_PARAM_1_tx_buffer_depth_shift                                   (16)
+#define ISO_IC0_COMP_PARAM_1_tx_buffer_depth_mask                                    (0x00FF0000)
+#define ISO_IC0_COMP_PARAM_1_tx_buffer_depth(data)                                   (0x00FF0000&((data)<<16))
+#define ISO_IC0_COMP_PARAM_1_tx_buffer_depth_src(data)                               ((0x00FF0000&(data))>>16)
+#define ISO_IC0_COMP_PARAM_1_get_tx_buffer_depth(data)                               ((0x00FF0000&(data))>>16)
+#define ISO_IC0_COMP_PARAM_1_rx_buffer_depth_shift                                   (8)
+#define ISO_IC0_COMP_PARAM_1_rx_buffer_depth_mask                                    (0x0000FF00)
+#define ISO_IC0_COMP_PARAM_1_rx_buffer_depth(data)                                   (0x0000FF00&((data)<<8))
+#define ISO_IC0_COMP_PARAM_1_rx_buffer_depth_src(data)                               ((0x0000FF00&(data))>>8)
+#define ISO_IC0_COMP_PARAM_1_get_rx_buffer_depth(data)                               ((0x0000FF00&(data))>>8)
+#define ISO_IC0_COMP_PARAM_1_add_encoded_params_shift                                (7)
+#define ISO_IC0_COMP_PARAM_1_add_encoded_params_mask                                 (0x00000080)
+#define ISO_IC0_COMP_PARAM_1_add_encoded_params(data)                                (0x00000080&((data)<<7))
+#define ISO_IC0_COMP_PARAM_1_add_encoded_params_src(data)                            ((0x00000080&(data))>>7)
+#define ISO_IC0_COMP_PARAM_1_get_add_encoded_params(data)                            ((0x00000080&(data))>>7)
+#define ISO_IC0_COMP_PARAM_1_has_dma_shift                                           (6)
+#define ISO_IC0_COMP_PARAM_1_has_dma_mask                                            (0x00000040)
+#define ISO_IC0_COMP_PARAM_1_has_dma(data)                                           (0x00000040&((data)<<6))
+#define ISO_IC0_COMP_PARAM_1_has_dma_src(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC0_COMP_PARAM_1_get_has_dma(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC0_COMP_PARAM_1_intr_io_shift                                           (5)
+#define ISO_IC0_COMP_PARAM_1_intr_io_mask                                            (0x00000020)
+#define ISO_IC0_COMP_PARAM_1_intr_io(data)                                           (0x00000020&((data)<<5))
+#define ISO_IC0_COMP_PARAM_1_intr_io_src(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC0_COMP_PARAM_1_get_intr_io(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC0_COMP_PARAM_1_hc_count_values_shift                                   (4)
+#define ISO_IC0_COMP_PARAM_1_hc_count_values_mask                                    (0x00000010)
+#define ISO_IC0_COMP_PARAM_1_hc_count_values(data)                                   (0x00000010&((data)<<4))
+#define ISO_IC0_COMP_PARAM_1_hc_count_values_src(data)                               ((0x00000010&(data))>>4)
+#define ISO_IC0_COMP_PARAM_1_get_hc_count_values(data)                               ((0x00000010&(data))>>4)
+#define ISO_IC0_COMP_PARAM_1_max_speed_mode_shift                                    (2)
+#define ISO_IC0_COMP_PARAM_1_max_speed_mode_mask                                     (0x0000000C)
+#define ISO_IC0_COMP_PARAM_1_max_speed_mode(data)                                    (0x0000000C&((data)<<2))
+#define ISO_IC0_COMP_PARAM_1_max_speed_mode_src(data)                                ((0x0000000C&(data))>>2)
+#define ISO_IC0_COMP_PARAM_1_get_max_speed_mode(data)                                ((0x0000000C&(data))>>2)
+#define ISO_IC0_COMP_PARAM_1_apb_data_width_shift                                    (0)
+#define ISO_IC0_COMP_PARAM_1_apb_data_width_mask                                     (0x00000003)
+#define ISO_IC0_COMP_PARAM_1_apb_data_width(data)                                    (0x00000003&((data)<<0))
+#define ISO_IC0_COMP_PARAM_1_apb_data_width_src(data)                                ((0x00000003&(data))>>0)
+#define ISO_IC0_COMP_PARAM_1_get_apb_data_width(data)                                ((0x00000003&(data))>>0)
+
+
+#define ISO_IC0_COMP_VERSION                                                         0x18007DF8
+#define ISO_IC0_COMP_VERSION_reg_addr                                                "0xB8007DF8"
+#define ISO_IC0_COMP_VERSION_reg                                                     0xB8007DF8
+#define set_ISO_IC0_COMP_VERSION_reg(data)   (*((volatile unsigned int*) ISO_IC0_COMP_VERSION_reg)=data)
+#define get_ISO_IC0_COMP_VERSION_reg   (*((volatile unsigned int*) ISO_IC0_COMP_VERSION_reg))
+#define ISO_IC0_COMP_VERSION_inst_adr                                                "0x007E"
+#define ISO_IC0_COMP_VERSION_inst                                                    0x007E
+#define ISO_IC0_COMP_VERSION_ic_comp_version_shift                                   (0)
+#define ISO_IC0_COMP_VERSION_ic_comp_version_mask                                    (0xFFFFFFFF)
+#define ISO_IC0_COMP_VERSION_ic_comp_version(data)                                   (0xFFFFFFFF&((data)<<0))
+#define ISO_IC0_COMP_VERSION_ic_comp_version_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define ISO_IC0_COMP_VERSION_get_ic_comp_version(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IC0_COMP_TYPE                                                            0x18007DFC
+#define ISO_IC0_COMP_TYPE_reg_addr                                                   "0xB8007DFC"
+#define ISO_IC0_COMP_TYPE_reg                                                        0xB8007DFC
+#define set_ISO_IC0_COMP_TYPE_reg(data)   (*((volatile unsigned int*) ISO_IC0_COMP_TYPE_reg)=data)
+#define get_ISO_IC0_COMP_TYPE_reg   (*((volatile unsigned int*) ISO_IC0_COMP_TYPE_reg))
+#define ISO_IC0_COMP_TYPE_inst_adr                                                   "0x007F"
+#define ISO_IC0_COMP_TYPE_inst                                                       0x007F
+#define ISO_IC0_COMP_TYPE_ic_comp_type_shift                                         (0)
+#define ISO_IC0_COMP_TYPE_ic_comp_type_mask                                          (0xFFFFFFFF)
+#define ISO_IC0_COMP_TYPE_ic_comp_type(data)                                         (0xFFFFFFFF&((data)<<0))
+#define ISO_IC0_COMP_TYPE_ic_comp_type_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define ISO_IC0_COMP_TYPE_get_ic_comp_type(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IC6_CON                                                                  0x18007E00
+#define ISO_IC6_CON_reg_addr                                                         "0xB8007E00"
+#define ISO_IC6_CON_reg                                                              0xB8007E00
+#define set_ISO_IC6_CON_reg(data)   (*((volatile unsigned int*) ISO_IC6_CON_reg)=data)
+#define get_ISO_IC6_CON_reg   (*((volatile unsigned int*) ISO_IC6_CON_reg))
+#define ISO_IC6_CON_inst_adr                                                         "0x0080"
+#define ISO_IC6_CON_inst                                                             0x0080
+#define ISO_IC6_CON_ic_slave_disable_shift                                           (6)
+#define ISO_IC6_CON_ic_slave_disable_mask                                            (0x00000040)
+#define ISO_IC6_CON_ic_slave_disable(data)                                           (0x00000040&((data)<<6))
+#define ISO_IC6_CON_ic_slave_disable_src(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC6_CON_get_ic_slave_disable(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC6_CON_ic_restart_en_shift                                              (5)
+#define ISO_IC6_CON_ic_restart_en_mask                                               (0x00000020)
+#define ISO_IC6_CON_ic_restart_en(data)                                              (0x00000020&((data)<<5))
+#define ISO_IC6_CON_ic_restart_en_src(data)                                          ((0x00000020&(data))>>5)
+#define ISO_IC6_CON_get_ic_restart_en(data)                                          ((0x00000020&(data))>>5)
+#define ISO_IC6_CON_ic_10bitaddr_master_shift                                        (4)
+#define ISO_IC6_CON_ic_10bitaddr_master_mask                                         (0x00000010)
+#define ISO_IC6_CON_ic_10bitaddr_master(data)                                        (0x00000010&((data)<<4))
+#define ISO_IC6_CON_ic_10bitaddr_master_src(data)                                    ((0x00000010&(data))>>4)
+#define ISO_IC6_CON_get_ic_10bitaddr_master(data)                                    ((0x00000010&(data))>>4)
+#define ISO_IC6_CON_ic_10bitaddr_slave_shift                                         (3)
+#define ISO_IC6_CON_ic_10bitaddr_slave_mask                                          (0x00000008)
+#define ISO_IC6_CON_ic_10bitaddr_slave(data)                                         (0x00000008&((data)<<3))
+#define ISO_IC6_CON_ic_10bitaddr_slave_src(data)                                     ((0x00000008&(data))>>3)
+#define ISO_IC6_CON_get_ic_10bitaddr_slave(data)                                     ((0x00000008&(data))>>3)
+#define ISO_IC6_CON_speed_shift                                                      (1)
+#define ISO_IC6_CON_speed_mask                                                       (0x00000006)
+#define ISO_IC6_CON_speed(data)                                                      (0x00000006&((data)<<1))
+#define ISO_IC6_CON_speed_src(data)                                                  ((0x00000006&(data))>>1)
+#define ISO_IC6_CON_get_speed(data)                                                  ((0x00000006&(data))>>1)
+#define ISO_IC6_CON_master_mode_shift                                                (0)
+#define ISO_IC6_CON_master_mode_mask                                                 (0x00000001)
+#define ISO_IC6_CON_master_mode(data)                                                (0x00000001&((data)<<0))
+#define ISO_IC6_CON_master_mode_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_IC6_CON_get_master_mode(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_TAR                                                                  0x18007E04
+#define ISO_IC6_TAR_reg_addr                                                         "0xB8007E04"
+#define ISO_IC6_TAR_reg                                                              0xB8007E04
+#define set_ISO_IC6_TAR_reg(data)   (*((volatile unsigned int*) ISO_IC6_TAR_reg)=data)
+#define get_ISO_IC6_TAR_reg   (*((volatile unsigned int*) ISO_IC6_TAR_reg))
+#define ISO_IC6_TAR_inst_adr                                                         "0x0081"
+#define ISO_IC6_TAR_inst                                                             0x0081
+#define ISO_IC6_TAR_ic_10bitaddr_master_shift                                        (12)
+#define ISO_IC6_TAR_ic_10bitaddr_master_mask                                         (0x00001000)
+#define ISO_IC6_TAR_ic_10bitaddr_master(data)                                        (0x00001000&((data)<<12))
+#define ISO_IC6_TAR_ic_10bitaddr_master_src(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC6_TAR_get_ic_10bitaddr_master(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC6_TAR_special_shift                                                    (11)
+#define ISO_IC6_TAR_special_mask                                                     (0x00000800)
+#define ISO_IC6_TAR_special(data)                                                    (0x00000800&((data)<<11))
+#define ISO_IC6_TAR_special_src(data)                                                ((0x00000800&(data))>>11)
+#define ISO_IC6_TAR_get_special(data)                                                ((0x00000800&(data))>>11)
+#define ISO_IC6_TAR_gc_or_start_shift                                                (10)
+#define ISO_IC6_TAR_gc_or_start_mask                                                 (0x00000400)
+#define ISO_IC6_TAR_gc_or_start(data)                                                (0x00000400&((data)<<10))
+#define ISO_IC6_TAR_gc_or_start_src(data)                                            ((0x00000400&(data))>>10)
+#define ISO_IC6_TAR_get_gc_or_start(data)                                            ((0x00000400&(data))>>10)
+#define ISO_IC6_TAR_ic_tar_shift                                                     (0)
+#define ISO_IC6_TAR_ic_tar_mask                                                      (0x000003FF)
+#define ISO_IC6_TAR_ic_tar(data)                                                     (0x000003FF&((data)<<0))
+#define ISO_IC6_TAR_ic_tar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define ISO_IC6_TAR_get_ic_tar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define ISO_IC6_SAR                                                                  0x18007E08
+#define ISO_IC6_SAR_reg_addr                                                         "0xB8007E08"
+#define ISO_IC6_SAR_reg                                                              0xB8007E08
+#define set_ISO_IC6_SAR_reg(data)   (*((volatile unsigned int*) ISO_IC6_SAR_reg)=data)
+#define get_ISO_IC6_SAR_reg   (*((volatile unsigned int*) ISO_IC6_SAR_reg))
+#define ISO_IC6_SAR_inst_adr                                                         "0x0082"
+#define ISO_IC6_SAR_inst                                                             0x0082
+#define ISO_IC6_SAR_ic_sar_shift                                                     (0)
+#define ISO_IC6_SAR_ic_sar_mask                                                      (0x000003FF)
+#define ISO_IC6_SAR_ic_sar(data)                                                     (0x000003FF&((data)<<0))
+#define ISO_IC6_SAR_ic_sar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define ISO_IC6_SAR_get_ic_sar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define ISO_IC6_HS_MADDR                                                             0x18007E0C
+#define ISO_IC6_HS_MADDR_reg_addr                                                    "0xB8007E0C"
+#define ISO_IC6_HS_MADDR_reg                                                         0xB8007E0C
+#define set_ISO_IC6_HS_MADDR_reg(data)   (*((volatile unsigned int*) ISO_IC6_HS_MADDR_reg)=data)
+#define get_ISO_IC6_HS_MADDR_reg   (*((volatile unsigned int*) ISO_IC6_HS_MADDR_reg))
+#define ISO_IC6_HS_MADDR_inst_adr                                                    "0x0083"
+#define ISO_IC6_HS_MADDR_inst                                                        0x0083
+#define ISO_IC6_HS_MADDR_ic_hs_mar_shift                                             (0)
+#define ISO_IC6_HS_MADDR_ic_hs_mar_mask                                              (0x00000007)
+#define ISO_IC6_HS_MADDR_ic_hs_mar(data)                                             (0x00000007&((data)<<0))
+#define ISO_IC6_HS_MADDR_ic_hs_mar_src(data)                                         ((0x00000007&(data))>>0)
+#define ISO_IC6_HS_MADDR_get_ic_hs_mar(data)                                         ((0x00000007&(data))>>0)
+
+
+#define ISO_IC6_DATA_CMD                                                             0x18007E10
+#define ISO_IC6_DATA_CMD_reg_addr                                                    "0xB8007E10"
+#define ISO_IC6_DATA_CMD_reg                                                         0xB8007E10
+#define set_ISO_IC6_DATA_CMD_reg(data)   (*((volatile unsigned int*) ISO_IC6_DATA_CMD_reg)=data)
+#define get_ISO_IC6_DATA_CMD_reg   (*((volatile unsigned int*) ISO_IC6_DATA_CMD_reg))
+#define ISO_IC6_DATA_CMD_inst_adr                                                    "0x0084"
+#define ISO_IC6_DATA_CMD_inst                                                        0x0084
+#define ISO_IC6_DATA_CMD_restart_shift                                               (10)
+#define ISO_IC6_DATA_CMD_restart_mask                                                (0x00000400)
+#define ISO_IC6_DATA_CMD_restart(data)                                               (0x00000400&((data)<<10))
+#define ISO_IC6_DATA_CMD_restart_src(data)                                           ((0x00000400&(data))>>10)
+#define ISO_IC6_DATA_CMD_get_restart(data)                                           ((0x00000400&(data))>>10)
+#define ISO_IC6_DATA_CMD_stop_shift                                                  (9)
+#define ISO_IC6_DATA_CMD_stop_mask                                                   (0x00000200)
+#define ISO_IC6_DATA_CMD_stop(data)                                                  (0x00000200&((data)<<9))
+#define ISO_IC6_DATA_CMD_stop_src(data)                                              ((0x00000200&(data))>>9)
+#define ISO_IC6_DATA_CMD_get_stop(data)                                              ((0x00000200&(data))>>9)
+#define ISO_IC6_DATA_CMD_cmd_shift                                                   (8)
+#define ISO_IC6_DATA_CMD_cmd_mask                                                    (0x00000100)
+#define ISO_IC6_DATA_CMD_cmd(data)                                                   (0x00000100&((data)<<8))
+#define ISO_IC6_DATA_CMD_cmd_src(data)                                               ((0x00000100&(data))>>8)
+#define ISO_IC6_DATA_CMD_get_cmd(data)                                               ((0x00000100&(data))>>8)
+#define ISO_IC6_DATA_CMD_dat_shift                                                   (0)
+#define ISO_IC6_DATA_CMD_dat_mask                                                    (0x000000FF)
+#define ISO_IC6_DATA_CMD_dat(data)                                                   (0x000000FF&((data)<<0))
+#define ISO_IC6_DATA_CMD_dat_src(data)                                               ((0x000000FF&(data))>>0)
+#define ISO_IC6_DATA_CMD_get_dat(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC6_SS_SCL_HCNT                                                          0x18007E14
+#define ISO_IC6_SS_SCL_HCNT_reg_addr                                                 "0xB8007E14"
+#define ISO_IC6_SS_SCL_HCNT_reg                                                      0xB8007E14
+#define set_ISO_IC6_SS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) ISO_IC6_SS_SCL_HCNT_reg)=data)
+#define get_ISO_IC6_SS_SCL_HCNT_reg   (*((volatile unsigned int*) ISO_IC6_SS_SCL_HCNT_reg))
+#define ISO_IC6_SS_SCL_HCNT_inst_adr                                                 "0x0085"
+#define ISO_IC6_SS_SCL_HCNT_inst                                                     0x0085
+#define ISO_IC6_SS_SCL_HCNT_ic_ss_scl_hcnt_shift                                     (0)
+#define ISO_IC6_SS_SCL_HCNT_ic_ss_scl_hcnt_mask                                      (0x0000FFFF)
+#define ISO_IC6_SS_SCL_HCNT_ic_ss_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC6_SS_SCL_HCNT_ic_ss_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC6_SS_SCL_HCNT_get_ic_ss_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC6_SS_SCL_LCNT                                                          0x18007E18
+#define ISO_IC6_SS_SCL_LCNT_reg_addr                                                 "0xB8007E18"
+#define ISO_IC6_SS_SCL_LCNT_reg                                                      0xB8007E18
+#define set_ISO_IC6_SS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) ISO_IC6_SS_SCL_LCNT_reg)=data)
+#define get_ISO_IC6_SS_SCL_LCNT_reg   (*((volatile unsigned int*) ISO_IC6_SS_SCL_LCNT_reg))
+#define ISO_IC6_SS_SCL_LCNT_inst_adr                                                 "0x0086"
+#define ISO_IC6_SS_SCL_LCNT_inst                                                     0x0086
+#define ISO_IC6_SS_SCL_LCNT_ic_ss_scl_lcnt_shift                                     (0)
+#define ISO_IC6_SS_SCL_LCNT_ic_ss_scl_lcnt_mask                                      (0x0000FFFF)
+#define ISO_IC6_SS_SCL_LCNT_ic_ss_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC6_SS_SCL_LCNT_ic_ss_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC6_SS_SCL_LCNT_get_ic_ss_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC6_FS_SCL_HCNT                                                          0x18007E1C
+#define ISO_IC6_FS_SCL_HCNT_reg_addr                                                 "0xB8007E1C"
+#define ISO_IC6_FS_SCL_HCNT_reg                                                      0xB8007E1C
+#define set_ISO_IC6_FS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) ISO_IC6_FS_SCL_HCNT_reg)=data)
+#define get_ISO_IC6_FS_SCL_HCNT_reg   (*((volatile unsigned int*) ISO_IC6_FS_SCL_HCNT_reg))
+#define ISO_IC6_FS_SCL_HCNT_inst_adr                                                 "0x0087"
+#define ISO_IC6_FS_SCL_HCNT_inst                                                     0x0087
+#define ISO_IC6_FS_SCL_HCNT_ic_fs_scl_hcnt_shift                                     (0)
+#define ISO_IC6_FS_SCL_HCNT_ic_fs_scl_hcnt_mask                                      (0x0000FFFF)
+#define ISO_IC6_FS_SCL_HCNT_ic_fs_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC6_FS_SCL_HCNT_ic_fs_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC6_FS_SCL_HCNT_get_ic_fs_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC6_FS_SCL_LCNT                                                          0x18007E20
+#define ISO_IC6_FS_SCL_LCNT_reg_addr                                                 "0xB8007E20"
+#define ISO_IC6_FS_SCL_LCNT_reg                                                      0xB8007E20
+#define set_ISO_IC6_FS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) ISO_IC6_FS_SCL_LCNT_reg)=data)
+#define get_ISO_IC6_FS_SCL_LCNT_reg   (*((volatile unsigned int*) ISO_IC6_FS_SCL_LCNT_reg))
+#define ISO_IC6_FS_SCL_LCNT_inst_adr                                                 "0x0088"
+#define ISO_IC6_FS_SCL_LCNT_inst                                                     0x0088
+#define ISO_IC6_FS_SCL_LCNT_ic_fs_scl_lcnt_shift                                     (0)
+#define ISO_IC6_FS_SCL_LCNT_ic_fs_scl_lcnt_mask                                      (0x0000FFFF)
+#define ISO_IC6_FS_SCL_LCNT_ic_fs_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define ISO_IC6_FS_SCL_LCNT_ic_fs_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define ISO_IC6_FS_SCL_LCNT_get_ic_fs_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC6_INTR_STAT                                                            0x18007E2C
+#define ISO_IC6_INTR_STAT_reg_addr                                                   "0xB8007E2C"
+#define ISO_IC6_INTR_STAT_reg                                                        0xB8007E2C
+#define set_ISO_IC6_INTR_STAT_reg(data)   (*((volatile unsigned int*) ISO_IC6_INTR_STAT_reg)=data)
+#define get_ISO_IC6_INTR_STAT_reg   (*((volatile unsigned int*) ISO_IC6_INTR_STAT_reg))
+#define ISO_IC6_INTR_STAT_inst_adr                                                   "0x008B"
+#define ISO_IC6_INTR_STAT_inst                                                       0x008B
+#define ISO_IC6_INTR_STAT_r_gen_call_shift                                           (11)
+#define ISO_IC6_INTR_STAT_r_gen_call_mask                                            (0x00000800)
+#define ISO_IC6_INTR_STAT_r_gen_call(data)                                           (0x00000800&((data)<<11))
+#define ISO_IC6_INTR_STAT_r_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC6_INTR_STAT_get_r_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC6_INTR_STAT_r_start_det_shift                                          (10)
+#define ISO_IC6_INTR_STAT_r_start_det_mask                                           (0x00000400)
+#define ISO_IC6_INTR_STAT_r_start_det(data)                                          (0x00000400&((data)<<10))
+#define ISO_IC6_INTR_STAT_r_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC6_INTR_STAT_get_r_start_det(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC6_INTR_STAT_r_stop_det_shift                                           (9)
+#define ISO_IC6_INTR_STAT_r_stop_det_mask                                            (0x00000200)
+#define ISO_IC6_INTR_STAT_r_stop_det(data)                                           (0x00000200&((data)<<9))
+#define ISO_IC6_INTR_STAT_r_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC6_INTR_STAT_get_r_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC6_INTR_STAT_r_activity_shift                                           (8)
+#define ISO_IC6_INTR_STAT_r_activity_mask                                            (0x00000100)
+#define ISO_IC6_INTR_STAT_r_activity(data)                                           (0x00000100&((data)<<8))
+#define ISO_IC6_INTR_STAT_r_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC6_INTR_STAT_get_r_activity(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC6_INTR_STAT_r_rx_done_shift                                            (7)
+#define ISO_IC6_INTR_STAT_r_rx_done_mask                                             (0x00000080)
+#define ISO_IC6_INTR_STAT_r_rx_done(data)                                            (0x00000080&((data)<<7))
+#define ISO_IC6_INTR_STAT_r_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC6_INTR_STAT_get_r_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC6_INTR_STAT_r_tx_abrt_shift                                            (6)
+#define ISO_IC6_INTR_STAT_r_tx_abrt_mask                                             (0x00000040)
+#define ISO_IC6_INTR_STAT_r_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC6_INTR_STAT_r_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC6_INTR_STAT_get_r_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC6_INTR_STAT_r_rd_req_shift                                             (5)
+#define ISO_IC6_INTR_STAT_r_rd_req_mask                                              (0x00000020)
+#define ISO_IC6_INTR_STAT_r_rd_req(data)                                             (0x00000020&((data)<<5))
+#define ISO_IC6_INTR_STAT_r_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC6_INTR_STAT_get_r_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC6_INTR_STAT_r_tx_empty_shift                                           (4)
+#define ISO_IC6_INTR_STAT_r_tx_empty_mask                                            (0x00000010)
+#define ISO_IC6_INTR_STAT_r_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define ISO_IC6_INTR_STAT_r_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC6_INTR_STAT_get_r_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC6_INTR_STAT_r_tx_over_shift                                            (3)
+#define ISO_IC6_INTR_STAT_r_tx_over_mask                                             (0x00000008)
+#define ISO_IC6_INTR_STAT_r_tx_over(data)                                            (0x00000008&((data)<<3))
+#define ISO_IC6_INTR_STAT_r_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC6_INTR_STAT_get_r_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC6_INTR_STAT_r_rx_full_shift                                            (2)
+#define ISO_IC6_INTR_STAT_r_rx_full_mask                                             (0x00000004)
+#define ISO_IC6_INTR_STAT_r_rx_full(data)                                            (0x00000004&((data)<<2))
+#define ISO_IC6_INTR_STAT_r_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC6_INTR_STAT_get_r_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC6_INTR_STAT_r_rx_over_shift                                            (1)
+#define ISO_IC6_INTR_STAT_r_rx_over_mask                                             (0x00000002)
+#define ISO_IC6_INTR_STAT_r_rx_over(data)                                            (0x00000002&((data)<<1))
+#define ISO_IC6_INTR_STAT_r_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC6_INTR_STAT_get_r_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC6_INTR_STAT_r_rx_under_shift                                           (0)
+#define ISO_IC6_INTR_STAT_r_rx_under_mask                                            (0x00000001)
+#define ISO_IC6_INTR_STAT_r_rx_under(data)                                           (0x00000001&((data)<<0))
+#define ISO_IC6_INTR_STAT_r_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_IC6_INTR_STAT_get_r_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_INTR_MASK                                                            0x18007E30
+#define ISO_IC6_INTR_MASK_reg_addr                                                   "0xB8007E30"
+#define ISO_IC6_INTR_MASK_reg                                                        0xB8007E30
+#define set_ISO_IC6_INTR_MASK_reg(data)   (*((volatile unsigned int*) ISO_IC6_INTR_MASK_reg)=data)
+#define get_ISO_IC6_INTR_MASK_reg   (*((volatile unsigned int*) ISO_IC6_INTR_MASK_reg))
+#define ISO_IC6_INTR_MASK_inst_adr                                                   "0x008C"
+#define ISO_IC6_INTR_MASK_inst                                                       0x008C
+#define ISO_IC6_INTR_MASK_m_gen_call_shift                                           (11)
+#define ISO_IC6_INTR_MASK_m_gen_call_mask                                            (0x00000800)
+#define ISO_IC6_INTR_MASK_m_gen_call(data)                                           (0x00000800&((data)<<11))
+#define ISO_IC6_INTR_MASK_m_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC6_INTR_MASK_get_m_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define ISO_IC6_INTR_MASK_m_start_det_shift                                          (10)
+#define ISO_IC6_INTR_MASK_m_start_det_mask                                           (0x00000400)
+#define ISO_IC6_INTR_MASK_m_start_det(data)                                          (0x00000400&((data)<<10))
+#define ISO_IC6_INTR_MASK_m_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC6_INTR_MASK_get_m_start_det(data)                                      ((0x00000400&(data))>>10)
+#define ISO_IC6_INTR_MASK_m_stop_det_shift                                           (9)
+#define ISO_IC6_INTR_MASK_m_stop_det_mask                                            (0x00000200)
+#define ISO_IC6_INTR_MASK_m_stop_det(data)                                           (0x00000200&((data)<<9))
+#define ISO_IC6_INTR_MASK_m_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC6_INTR_MASK_get_m_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define ISO_IC6_INTR_MASK_m_activity_shift                                           (8)
+#define ISO_IC6_INTR_MASK_m_activity_mask                                            (0x00000100)
+#define ISO_IC6_INTR_MASK_m_activity(data)                                           (0x00000100&((data)<<8))
+#define ISO_IC6_INTR_MASK_m_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC6_INTR_MASK_get_m_activity(data)                                       ((0x00000100&(data))>>8)
+#define ISO_IC6_INTR_MASK_m_rx_done_shift                                            (7)
+#define ISO_IC6_INTR_MASK_m_rx_done_mask                                             (0x00000080)
+#define ISO_IC6_INTR_MASK_m_rx_done(data)                                            (0x00000080&((data)<<7))
+#define ISO_IC6_INTR_MASK_m_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC6_INTR_MASK_get_m_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define ISO_IC6_INTR_MASK_m_tx_abrt_shift                                            (6)
+#define ISO_IC6_INTR_MASK_m_tx_abrt_mask                                             (0x00000040)
+#define ISO_IC6_INTR_MASK_m_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC6_INTR_MASK_m_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC6_INTR_MASK_get_m_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC6_INTR_MASK_m_rd_req_shift                                             (5)
+#define ISO_IC6_INTR_MASK_m_rd_req_mask                                              (0x00000020)
+#define ISO_IC6_INTR_MASK_m_rd_req(data)                                             (0x00000020&((data)<<5))
+#define ISO_IC6_INTR_MASK_m_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC6_INTR_MASK_get_m_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define ISO_IC6_INTR_MASK_m_tx_empty_shift                                           (4)
+#define ISO_IC6_INTR_MASK_m_tx_empty_mask                                            (0x00000010)
+#define ISO_IC6_INTR_MASK_m_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define ISO_IC6_INTR_MASK_m_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC6_INTR_MASK_get_m_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define ISO_IC6_INTR_MASK_m_tx_over_shift                                            (3)
+#define ISO_IC6_INTR_MASK_m_tx_over_mask                                             (0x00000008)
+#define ISO_IC6_INTR_MASK_m_tx_over(data)                                            (0x00000008&((data)<<3))
+#define ISO_IC6_INTR_MASK_m_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC6_INTR_MASK_get_m_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define ISO_IC6_INTR_MASK_m_rx_full_shift                                            (2)
+#define ISO_IC6_INTR_MASK_m_rx_full_mask                                             (0x00000004)
+#define ISO_IC6_INTR_MASK_m_rx_full(data)                                            (0x00000004&((data)<<2))
+#define ISO_IC6_INTR_MASK_m_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC6_INTR_MASK_get_m_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define ISO_IC6_INTR_MASK_m_rx_over_shift                                            (1)
+#define ISO_IC6_INTR_MASK_m_rx_over_mask                                             (0x00000002)
+#define ISO_IC6_INTR_MASK_m_rx_over(data)                                            (0x00000002&((data)<<1))
+#define ISO_IC6_INTR_MASK_m_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC6_INTR_MASK_get_m_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define ISO_IC6_INTR_MASK_m_rx_under_shift                                           (0)
+#define ISO_IC6_INTR_MASK_m_rx_under_mask                                            (0x00000001)
+#define ISO_IC6_INTR_MASK_m_rx_under(data)                                           (0x00000001&((data)<<0))
+#define ISO_IC6_INTR_MASK_m_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define ISO_IC6_INTR_MASK_get_m_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_RAW_INTR_STAT                                                        0x18007E34
+#define ISO_IC6_RAW_INTR_STAT_reg_addr                                               "0xB8007E34"
+#define ISO_IC6_RAW_INTR_STAT_reg                                                    0xB8007E34
+#define set_ISO_IC6_RAW_INTR_STAT_reg(data)   (*((volatile unsigned int*) ISO_IC6_RAW_INTR_STAT_reg)=data)
+#define get_ISO_IC6_RAW_INTR_STAT_reg   (*((volatile unsigned int*) ISO_IC6_RAW_INTR_STAT_reg))
+#define ISO_IC6_RAW_INTR_STAT_inst_adr                                               "0x008D"
+#define ISO_IC6_RAW_INTR_STAT_inst                                                   0x008D
+#define ISO_IC6_RAW_INTR_STAT_gen_call_shift                                         (11)
+#define ISO_IC6_RAW_INTR_STAT_gen_call_mask                                          (0x00000800)
+#define ISO_IC6_RAW_INTR_STAT_gen_call(data)                                         (0x00000800&((data)<<11))
+#define ISO_IC6_RAW_INTR_STAT_gen_call_src(data)                                     ((0x00000800&(data))>>11)
+#define ISO_IC6_RAW_INTR_STAT_get_gen_call(data)                                     ((0x00000800&(data))>>11)
+#define ISO_IC6_RAW_INTR_STAT_start_det_shift                                        (10)
+#define ISO_IC6_RAW_INTR_STAT_start_det_mask                                         (0x00000400)
+#define ISO_IC6_RAW_INTR_STAT_start_det(data)                                        (0x00000400&((data)<<10))
+#define ISO_IC6_RAW_INTR_STAT_start_det_src(data)                                    ((0x00000400&(data))>>10)
+#define ISO_IC6_RAW_INTR_STAT_get_start_det(data)                                    ((0x00000400&(data))>>10)
+#define ISO_IC6_RAW_INTR_STAT_stop_det_shift                                         (9)
+#define ISO_IC6_RAW_INTR_STAT_stop_det_mask                                          (0x00000200)
+#define ISO_IC6_RAW_INTR_STAT_stop_det(data)                                         (0x00000200&((data)<<9))
+#define ISO_IC6_RAW_INTR_STAT_stop_det_src(data)                                     ((0x00000200&(data))>>9)
+#define ISO_IC6_RAW_INTR_STAT_get_stop_det(data)                                     ((0x00000200&(data))>>9)
+#define ISO_IC6_RAW_INTR_STAT_activity_shift                                         (8)
+#define ISO_IC6_RAW_INTR_STAT_activity_mask                                          (0x00000100)
+#define ISO_IC6_RAW_INTR_STAT_activity(data)                                         (0x00000100&((data)<<8))
+#define ISO_IC6_RAW_INTR_STAT_activity_src(data)                                     ((0x00000100&(data))>>8)
+#define ISO_IC6_RAW_INTR_STAT_get_activity(data)                                     ((0x00000100&(data))>>8)
+#define ISO_IC6_RAW_INTR_STAT_rx_done_shift                                          (7)
+#define ISO_IC6_RAW_INTR_STAT_rx_done_mask                                           (0x00000080)
+#define ISO_IC6_RAW_INTR_STAT_rx_done(data)                                          (0x00000080&((data)<<7))
+#define ISO_IC6_RAW_INTR_STAT_rx_done_src(data)                                      ((0x00000080&(data))>>7)
+#define ISO_IC6_RAW_INTR_STAT_get_rx_done(data)                                      ((0x00000080&(data))>>7)
+#define ISO_IC6_RAW_INTR_STAT_tx_abrt_shift                                          (6)
+#define ISO_IC6_RAW_INTR_STAT_tx_abrt_mask                                           (0x00000040)
+#define ISO_IC6_RAW_INTR_STAT_tx_abrt(data)                                          (0x00000040&((data)<<6))
+#define ISO_IC6_RAW_INTR_STAT_tx_abrt_src(data)                                      ((0x00000040&(data))>>6)
+#define ISO_IC6_RAW_INTR_STAT_get_tx_abrt(data)                                      ((0x00000040&(data))>>6)
+#define ISO_IC6_RAW_INTR_STAT_rd_req_shift                                           (5)
+#define ISO_IC6_RAW_INTR_STAT_rd_req_mask                                            (0x00000020)
+#define ISO_IC6_RAW_INTR_STAT_rd_req(data)                                           (0x00000020&((data)<<5))
+#define ISO_IC6_RAW_INTR_STAT_rd_req_src(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC6_RAW_INTR_STAT_get_rd_req(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC6_RAW_INTR_STAT_tx_empty_shift                                         (4)
+#define ISO_IC6_RAW_INTR_STAT_tx_empty_mask                                          (0x00000010)
+#define ISO_IC6_RAW_INTR_STAT_tx_empty(data)                                         (0x00000010&((data)<<4))
+#define ISO_IC6_RAW_INTR_STAT_tx_empty_src(data)                                     ((0x00000010&(data))>>4)
+#define ISO_IC6_RAW_INTR_STAT_get_tx_empty(data)                                     ((0x00000010&(data))>>4)
+#define ISO_IC6_RAW_INTR_STAT_tx_over_shift                                          (3)
+#define ISO_IC6_RAW_INTR_STAT_tx_over_mask                                           (0x00000008)
+#define ISO_IC6_RAW_INTR_STAT_tx_over(data)                                          (0x00000008&((data)<<3))
+#define ISO_IC6_RAW_INTR_STAT_tx_over_src(data)                                      ((0x00000008&(data))>>3)
+#define ISO_IC6_RAW_INTR_STAT_get_tx_over(data)                                      ((0x00000008&(data))>>3)
+#define ISO_IC6_RAW_INTR_STAT_rx_full_shift                                          (2)
+#define ISO_IC6_RAW_INTR_STAT_rx_full_mask                                           (0x00000004)
+#define ISO_IC6_RAW_INTR_STAT_rx_full(data)                                          (0x00000004&((data)<<2))
+#define ISO_IC6_RAW_INTR_STAT_rx_full_src(data)                                      ((0x00000004&(data))>>2)
+#define ISO_IC6_RAW_INTR_STAT_get_rx_full(data)                                      ((0x00000004&(data))>>2)
+#define ISO_IC6_RAW_INTR_STAT_rx_over_shift                                          (1)
+#define ISO_IC6_RAW_INTR_STAT_rx_over_mask                                           (0x00000002)
+#define ISO_IC6_RAW_INTR_STAT_rx_over(data)                                          (0x00000002&((data)<<1))
+#define ISO_IC6_RAW_INTR_STAT_rx_over_src(data)                                      ((0x00000002&(data))>>1)
+#define ISO_IC6_RAW_INTR_STAT_get_rx_over(data)                                      ((0x00000002&(data))>>1)
+#define ISO_IC6_RAW_INTR_STAT_rx_under_shift                                         (0)
+#define ISO_IC6_RAW_INTR_STAT_rx_under_mask                                          (0x00000001)
+#define ISO_IC6_RAW_INTR_STAT_rx_under(data)                                         (0x00000001&((data)<<0))
+#define ISO_IC6_RAW_INTR_STAT_rx_under_src(data)                                     ((0x00000001&(data))>>0)
+#define ISO_IC6_RAW_INTR_STAT_get_rx_under(data)                                     ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_RX_TL                                                                0x18007E38
+#define ISO_IC6_RX_TL_reg_addr                                                       "0xB8007E38"
+#define ISO_IC6_RX_TL_reg                                                            0xB8007E38
+#define set_ISO_IC6_RX_TL_reg(data)   (*((volatile unsigned int*) ISO_IC6_RX_TL_reg)=data)
+#define get_ISO_IC6_RX_TL_reg   (*((volatile unsigned int*) ISO_IC6_RX_TL_reg))
+#define ISO_IC6_RX_TL_inst_adr                                                       "0x008E"
+#define ISO_IC6_RX_TL_inst                                                           0x008E
+#define ISO_IC6_RX_TL_rx_tl_shift                                                    (0)
+#define ISO_IC6_RX_TL_rx_tl_mask                                                     (0x000000FF)
+#define ISO_IC6_RX_TL_rx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_IC6_RX_TL_rx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_IC6_RX_TL_get_rx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC6_TX_TL                                                                0x18007E3C
+#define ISO_IC6_TX_TL_reg_addr                                                       "0xB8007E3C"
+#define ISO_IC6_TX_TL_reg                                                            0xB8007E3C
+#define set_ISO_IC6_TX_TL_reg(data)   (*((volatile unsigned int*) ISO_IC6_TX_TL_reg)=data)
+#define get_ISO_IC6_TX_TL_reg   (*((volatile unsigned int*) ISO_IC6_TX_TL_reg))
+#define ISO_IC6_TX_TL_inst_adr                                                       "0x008F"
+#define ISO_IC6_TX_TL_inst                                                           0x008F
+#define ISO_IC6_TX_TL_tx_tl_shift                                                    (0)
+#define ISO_IC6_TX_TL_tx_tl_mask                                                     (0x000000FF)
+#define ISO_IC6_TX_TL_tx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define ISO_IC6_TX_TL_tx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define ISO_IC6_TX_TL_get_tx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC6_CLR_INTR                                                             0x18007E40
+#define ISO_IC6_CLR_INTR_reg_addr                                                    "0xB8007E40"
+#define ISO_IC6_CLR_INTR_reg                                                         0xB8007E40
+#define set_ISO_IC6_CLR_INTR_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_INTR_reg)=data)
+#define get_ISO_IC6_CLR_INTR_reg   (*((volatile unsigned int*) ISO_IC6_CLR_INTR_reg))
+#define ISO_IC6_CLR_INTR_inst_adr                                                    "0x0090"
+#define ISO_IC6_CLR_INTR_inst                                                        0x0090
+#define ISO_IC6_CLR_INTR_clr_intr_shift                                              (0)
+#define ISO_IC6_CLR_INTR_clr_intr_mask                                               (0x00000001)
+#define ISO_IC6_CLR_INTR_clr_intr(data)                                              (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_INTR_clr_intr_src(data)                                          ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_INTR_get_clr_intr(data)                                          ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_CLR_RX_UNDER                                                         0x18007E44
+#define ISO_IC6_CLR_RX_UNDER_reg_addr                                                "0xB8007E44"
+#define ISO_IC6_CLR_RX_UNDER_reg                                                     0xB8007E44
+#define set_ISO_IC6_CLR_RX_UNDER_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_RX_UNDER_reg)=data)
+#define get_ISO_IC6_CLR_RX_UNDER_reg   (*((volatile unsigned int*) ISO_IC6_CLR_RX_UNDER_reg))
+#define ISO_IC6_CLR_RX_UNDER_inst_adr                                                "0x0091"
+#define ISO_IC6_CLR_RX_UNDER_inst                                                    0x0091
+#define ISO_IC6_CLR_RX_UNDER_clr_rx_under_shift                                      (0)
+#define ISO_IC6_CLR_RX_UNDER_clr_rx_under_mask                                       (0x00000001)
+#define ISO_IC6_CLR_RX_UNDER_clr_rx_under(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_RX_UNDER_clr_rx_under_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_RX_UNDER_get_clr_rx_under(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_CLR_RX_OVER                                                          0x18007E48
+#define ISO_IC6_CLR_RX_OVER_reg_addr                                                 "0xB8007E48"
+#define ISO_IC6_CLR_RX_OVER_reg                                                      0xB8007E48
+#define set_ISO_IC6_CLR_RX_OVER_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_RX_OVER_reg)=data)
+#define get_ISO_IC6_CLR_RX_OVER_reg   (*((volatile unsigned int*) ISO_IC6_CLR_RX_OVER_reg))
+#define ISO_IC6_CLR_RX_OVER_inst_adr                                                 "0x0092"
+#define ISO_IC6_CLR_RX_OVER_inst                                                     0x0092
+#define ISO_IC6_CLR_RX_OVER_clr_rx_over_shift                                        (0)
+#define ISO_IC6_CLR_RX_OVER_clr_rx_over_mask                                         (0x00000001)
+#define ISO_IC6_CLR_RX_OVER_clr_rx_over(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_RX_OVER_clr_rx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_RX_OVER_get_clr_rx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_CLR_TX_OVER                                                          0x18007E4C
+#define ISO_IC6_CLR_TX_OVER_reg_addr                                                 "0xB8007E4C"
+#define ISO_IC6_CLR_TX_OVER_reg                                                      0xB8007E4C
+#define set_ISO_IC6_CLR_TX_OVER_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_TX_OVER_reg)=data)
+#define get_ISO_IC6_CLR_TX_OVER_reg   (*((volatile unsigned int*) ISO_IC6_CLR_TX_OVER_reg))
+#define ISO_IC6_CLR_TX_OVER_inst_adr                                                 "0x0093"
+#define ISO_IC6_CLR_TX_OVER_inst                                                     0x0093
+#define ISO_IC6_CLR_TX_OVER_clr_tx_over_shift                                        (0)
+#define ISO_IC6_CLR_TX_OVER_clr_tx_over_mask                                         (0x00000001)
+#define ISO_IC6_CLR_TX_OVER_clr_tx_over(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_TX_OVER_clr_tx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_TX_OVER_get_clr_tx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_CLR_RD_REQ                                                           0x18007E50
+#define ISO_IC6_CLR_RD_REQ_reg_addr                                                  "0xB8007E50"
+#define ISO_IC6_CLR_RD_REQ_reg                                                       0xB8007E50
+#define set_ISO_IC6_CLR_RD_REQ_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_RD_REQ_reg)=data)
+#define get_ISO_IC6_CLR_RD_REQ_reg   (*((volatile unsigned int*) ISO_IC6_CLR_RD_REQ_reg))
+#define ISO_IC6_CLR_RD_REQ_inst_adr                                                  "0x0094"
+#define ISO_IC6_CLR_RD_REQ_inst                                                      0x0094
+#define ISO_IC6_CLR_RD_REQ_clr_rd_req_shift                                          (0)
+#define ISO_IC6_CLR_RD_REQ_clr_rd_req_mask                                           (0x00000001)
+#define ISO_IC6_CLR_RD_REQ_clr_rd_req(data)                                          (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_RD_REQ_clr_rd_req_src(data)                                      ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_RD_REQ_get_clr_rd_req(data)                                      ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_CLR_TX_ABRT                                                          0x18007E54
+#define ISO_IC6_CLR_TX_ABRT_reg_addr                                                 "0xB8007E54"
+#define ISO_IC6_CLR_TX_ABRT_reg                                                      0xB8007E54
+#define set_ISO_IC6_CLR_TX_ABRT_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_TX_ABRT_reg)=data)
+#define get_ISO_IC6_CLR_TX_ABRT_reg   (*((volatile unsigned int*) ISO_IC6_CLR_TX_ABRT_reg))
+#define ISO_IC6_CLR_TX_ABRT_inst_adr                                                 "0x0095"
+#define ISO_IC6_CLR_TX_ABRT_inst                                                     0x0095
+#define ISO_IC6_CLR_TX_ABRT_clr_tx_abrt_shift                                        (0)
+#define ISO_IC6_CLR_TX_ABRT_clr_tx_abrt_mask                                         (0x00000001)
+#define ISO_IC6_CLR_TX_ABRT_clr_tx_abrt(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_TX_ABRT_clr_tx_abrt_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_TX_ABRT_get_clr_tx_abrt(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_CLR_RX_DONE                                                          0x18007E58
+#define ISO_IC6_CLR_RX_DONE_reg_addr                                                 "0xB8007E58"
+#define ISO_IC6_CLR_RX_DONE_reg                                                      0xB8007E58
+#define set_ISO_IC6_CLR_RX_DONE_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_RX_DONE_reg)=data)
+#define get_ISO_IC6_CLR_RX_DONE_reg   (*((volatile unsigned int*) ISO_IC6_CLR_RX_DONE_reg))
+#define ISO_IC6_CLR_RX_DONE_inst_adr                                                 "0x0096"
+#define ISO_IC6_CLR_RX_DONE_inst                                                     0x0096
+#define ISO_IC6_CLR_RX_DONE_clr_rx_done_shift                                        (0)
+#define ISO_IC6_CLR_RX_DONE_clr_rx_done_mask                                         (0x00000001)
+#define ISO_IC6_CLR_RX_DONE_clr_rx_done(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_RX_DONE_clr_rx_done_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_RX_DONE_get_clr_rx_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_CLR_ACTIVITY                                                         0x18007E5C
+#define ISO_IC6_CLR_ACTIVITY_reg_addr                                                "0xB8007E5C"
+#define ISO_IC6_CLR_ACTIVITY_reg                                                     0xB8007E5C
+#define set_ISO_IC6_CLR_ACTIVITY_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_ACTIVITY_reg)=data)
+#define get_ISO_IC6_CLR_ACTIVITY_reg   (*((volatile unsigned int*) ISO_IC6_CLR_ACTIVITY_reg))
+#define ISO_IC6_CLR_ACTIVITY_inst_adr                                                "0x0097"
+#define ISO_IC6_CLR_ACTIVITY_inst                                                    0x0097
+#define ISO_IC6_CLR_ACTIVITY_clr_activity_shift                                      (0)
+#define ISO_IC6_CLR_ACTIVITY_clr_activity_mask                                       (0x00000001)
+#define ISO_IC6_CLR_ACTIVITY_clr_activity(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_ACTIVITY_clr_activity_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_ACTIVITY_get_clr_activity(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_CLR_STOP_DET                                                         0x18007E60
+#define ISO_IC6_CLR_STOP_DET_reg_addr                                                "0xB8007E60"
+#define ISO_IC6_CLR_STOP_DET_reg                                                     0xB8007E60
+#define set_ISO_IC6_CLR_STOP_DET_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_STOP_DET_reg)=data)
+#define get_ISO_IC6_CLR_STOP_DET_reg   (*((volatile unsigned int*) ISO_IC6_CLR_STOP_DET_reg))
+#define ISO_IC6_CLR_STOP_DET_inst_adr                                                "0x0098"
+#define ISO_IC6_CLR_STOP_DET_inst                                                    0x0098
+#define ISO_IC6_CLR_STOP_DET_clr_stop_det_shift                                      (0)
+#define ISO_IC6_CLR_STOP_DET_clr_stop_det_mask                                       (0x00000001)
+#define ISO_IC6_CLR_STOP_DET_clr_stop_det(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_STOP_DET_clr_stop_det_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_STOP_DET_get_clr_stop_det(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_CLR_START_DET                                                        0x18007E64
+#define ISO_IC6_CLR_START_DET_reg_addr                                               "0xB8007E64"
+#define ISO_IC6_CLR_START_DET_reg                                                    0xB8007E64
+#define set_ISO_IC6_CLR_START_DET_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_START_DET_reg)=data)
+#define get_ISO_IC6_CLR_START_DET_reg   (*((volatile unsigned int*) ISO_IC6_CLR_START_DET_reg))
+#define ISO_IC6_CLR_START_DET_inst_adr                                               "0x0099"
+#define ISO_IC6_CLR_START_DET_inst                                                   0x0099
+#define ISO_IC6_CLR_START_DET_clr_start_det_shift                                    (0)
+#define ISO_IC6_CLR_START_DET_clr_start_det_mask                                     (0x00000001)
+#define ISO_IC6_CLR_START_DET_clr_start_det(data)                                    (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_START_DET_clr_start_det_src(data)                                ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_START_DET_get_clr_start_det(data)                                ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_CLR_GEN_CALL                                                         0x18007E68
+#define ISO_IC6_CLR_GEN_CALL_reg_addr                                                "0xB8007E68"
+#define ISO_IC6_CLR_GEN_CALL_reg                                                     0xB8007E68
+#define set_ISO_IC6_CLR_GEN_CALL_reg(data)   (*((volatile unsigned int*) ISO_IC6_CLR_GEN_CALL_reg)=data)
+#define get_ISO_IC6_CLR_GEN_CALL_reg   (*((volatile unsigned int*) ISO_IC6_CLR_GEN_CALL_reg))
+#define ISO_IC6_CLR_GEN_CALL_inst_adr                                                "0x009A"
+#define ISO_IC6_CLR_GEN_CALL_inst                                                    0x009A
+#define ISO_IC6_CLR_GEN_CALL_clr_gen_call_shift                                      (0)
+#define ISO_IC6_CLR_GEN_CALL_clr_gen_call_mask                                       (0x00000001)
+#define ISO_IC6_CLR_GEN_CALL_clr_gen_call(data)                                      (0x00000001&((data)<<0))
+#define ISO_IC6_CLR_GEN_CALL_clr_gen_call_src(data)                                  ((0x00000001&(data))>>0)
+#define ISO_IC6_CLR_GEN_CALL_get_clr_gen_call(data)                                  ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_ENABLE                                                               0x18007E6C
+#define ISO_IC6_ENABLE_reg_addr                                                      "0xB8007E6C"
+#define ISO_IC6_ENABLE_reg                                                           0xB8007E6C
+#define set_ISO_IC6_ENABLE_reg(data)   (*((volatile unsigned int*) ISO_IC6_ENABLE_reg)=data)
+#define get_ISO_IC6_ENABLE_reg   (*((volatile unsigned int*) ISO_IC6_ENABLE_reg))
+#define ISO_IC6_ENABLE_inst_adr                                                      "0x009B"
+#define ISO_IC6_ENABLE_inst                                                          0x009B
+#define ISO_IC6_ENABLE_enable_shift                                                  (0)
+#define ISO_IC6_ENABLE_enable_mask                                                   (0x00000001)
+#define ISO_IC6_ENABLE_enable(data)                                                  (0x00000001&((data)<<0))
+#define ISO_IC6_ENABLE_enable_src(data)                                              ((0x00000001&(data))>>0)
+#define ISO_IC6_ENABLE_get_enable(data)                                              ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_STATUS                                                               0x18007E70
+#define ISO_IC6_STATUS_reg_addr                                                      "0xB8007E70"
+#define ISO_IC6_STATUS_reg                                                           0xB8007E70
+#define set_ISO_IC6_STATUS_reg(data)   (*((volatile unsigned int*) ISO_IC6_STATUS_reg)=data)
+#define get_ISO_IC6_STATUS_reg   (*((volatile unsigned int*) ISO_IC6_STATUS_reg))
+#define ISO_IC6_STATUS_inst_adr                                                      "0x009C"
+#define ISO_IC6_STATUS_inst                                                          0x009C
+#define ISO_IC6_STATUS_slv_activity_shift                                            (6)
+#define ISO_IC6_STATUS_slv_activity_mask                                             (0x00000040)
+#define ISO_IC6_STATUS_slv_activity(data)                                            (0x00000040&((data)<<6))
+#define ISO_IC6_STATUS_slv_activity_src(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC6_STATUS_get_slv_activity(data)                                        ((0x00000040&(data))>>6)
+#define ISO_IC6_STATUS_mst_activity_shift                                            (5)
+#define ISO_IC6_STATUS_mst_activity_mask                                             (0x00000020)
+#define ISO_IC6_STATUS_mst_activity(data)                                            (0x00000020&((data)<<5))
+#define ISO_IC6_STATUS_mst_activity_src(data)                                        ((0x00000020&(data))>>5)
+#define ISO_IC6_STATUS_get_mst_activity(data)                                        ((0x00000020&(data))>>5)
+#define ISO_IC6_STATUS_rff_shift                                                     (4)
+#define ISO_IC6_STATUS_rff_mask                                                      (0x00000010)
+#define ISO_IC6_STATUS_rff(data)                                                     (0x00000010&((data)<<4))
+#define ISO_IC6_STATUS_rff_src(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IC6_STATUS_get_rff(data)                                                 ((0x00000010&(data))>>4)
+#define ISO_IC6_STATUS_rfne_shift                                                    (3)
+#define ISO_IC6_STATUS_rfne_mask                                                     (0x00000008)
+#define ISO_IC6_STATUS_rfne(data)                                                    (0x00000008&((data)<<3))
+#define ISO_IC6_STATUS_rfne_src(data)                                                ((0x00000008&(data))>>3)
+#define ISO_IC6_STATUS_get_rfne(data)                                                ((0x00000008&(data))>>3)
+#define ISO_IC6_STATUS_tfe_shift                                                     (2)
+#define ISO_IC6_STATUS_tfe_mask                                                      (0x00000004)
+#define ISO_IC6_STATUS_tfe(data)                                                     (0x00000004&((data)<<2))
+#define ISO_IC6_STATUS_tfe_src(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_IC6_STATUS_get_tfe(data)                                                 ((0x00000004&(data))>>2)
+#define ISO_IC6_STATUS_tfnf_shift                                                    (1)
+#define ISO_IC6_STATUS_tfnf_mask                                                     (0x00000002)
+#define ISO_IC6_STATUS_tfnf(data)                                                    (0x00000002&((data)<<1))
+#define ISO_IC6_STATUS_tfnf_src(data)                                                ((0x00000002&(data))>>1)
+#define ISO_IC6_STATUS_get_tfnf(data)                                                ((0x00000002&(data))>>1)
+#define ISO_IC6_STATUS_activity_shift                                                (0)
+#define ISO_IC6_STATUS_activity_mask                                                 (0x00000001)
+#define ISO_IC6_STATUS_activity(data)                                                (0x00000001&((data)<<0))
+#define ISO_IC6_STATUS_activity_src(data)                                            ((0x00000001&(data))>>0)
+#define ISO_IC6_STATUS_get_activity(data)                                            ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_TXFLR                                                                0x18007E74
+#define ISO_IC6_TXFLR_reg_addr                                                       "0xB8007E74"
+#define ISO_IC6_TXFLR_reg                                                            0xB8007E74
+#define set_ISO_IC6_TXFLR_reg(data)   (*((volatile unsigned int*) ISO_IC6_TXFLR_reg)=data)
+#define get_ISO_IC6_TXFLR_reg   (*((volatile unsigned int*) ISO_IC6_TXFLR_reg))
+#define ISO_IC6_TXFLR_inst_adr                                                       "0x009D"
+#define ISO_IC6_TXFLR_inst                                                           0x009D
+#define ISO_IC6_TXFLR_txflr_shift                                                    (0)
+#define ISO_IC6_TXFLR_txflr_mask                                                     (0x0000000F)
+#define ISO_IC6_TXFLR_txflr(data)                                                    (0x0000000F&((data)<<0))
+#define ISO_IC6_TXFLR_txflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define ISO_IC6_TXFLR_get_txflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC6_RXFLR                                                                0x18007E78
+#define ISO_IC6_RXFLR_reg_addr                                                       "0xB8007E78"
+#define ISO_IC6_RXFLR_reg                                                            0xB8007E78
+#define set_ISO_IC6_RXFLR_reg(data)   (*((volatile unsigned int*) ISO_IC6_RXFLR_reg)=data)
+#define get_ISO_IC6_RXFLR_reg   (*((volatile unsigned int*) ISO_IC6_RXFLR_reg))
+#define ISO_IC6_RXFLR_inst_adr                                                       "0x009E"
+#define ISO_IC6_RXFLR_inst                                                           0x009E
+#define ISO_IC6_RXFLR_rxflr_shift                                                    (0)
+#define ISO_IC6_RXFLR_rxflr_mask                                                     (0x0000000F)
+#define ISO_IC6_RXFLR_rxflr(data)                                                    (0x0000000F&((data)<<0))
+#define ISO_IC6_RXFLR_rxflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define ISO_IC6_RXFLR_get_rxflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC6_SDA_HOLD                                                             0x18007E7C
+#define ISO_IC6_SDA_HOLD_reg_addr                                                    "0xB8007E7C"
+#define ISO_IC6_SDA_HOLD_reg                                                         0xB8007E7C
+#define set_ISO_IC6_SDA_HOLD_reg(data)   (*((volatile unsigned int*) ISO_IC6_SDA_HOLD_reg)=data)
+#define get_ISO_IC6_SDA_HOLD_reg   (*((volatile unsigned int*) ISO_IC6_SDA_HOLD_reg))
+#define ISO_IC6_SDA_HOLD_inst_adr                                                    "0x009F"
+#define ISO_IC6_SDA_HOLD_inst                                                        0x009F
+#define ISO_IC6_SDA_HOLD_ic_sda_hold_shift                                           (0)
+#define ISO_IC6_SDA_HOLD_ic_sda_hold_mask                                            (0x0000FFFF)
+#define ISO_IC6_SDA_HOLD_ic_sda_hold(data)                                           (0x0000FFFF&((data)<<0))
+#define ISO_IC6_SDA_HOLD_ic_sda_hold_src(data)                                       ((0x0000FFFF&(data))>>0)
+#define ISO_IC6_SDA_HOLD_get_ic_sda_hold(data)                                       ((0x0000FFFF&(data))>>0)
+
+
+#define ISO_IC6_TX_ABRT_SOURCE                                                       0x18007E80
+#define ISO_IC6_TX_ABRT_SOURCE_reg_addr                                              "0xB8007E80"
+#define ISO_IC6_TX_ABRT_SOURCE_reg                                                   0xB8007E80
+#define set_ISO_IC6_TX_ABRT_SOURCE_reg(data)   (*((volatile unsigned int*) ISO_IC6_TX_ABRT_SOURCE_reg)=data)
+#define get_ISO_IC6_TX_ABRT_SOURCE_reg   (*((volatile unsigned int*) ISO_IC6_TX_ABRT_SOURCE_reg))
+#define ISO_IC6_TX_ABRT_SOURCE_inst_adr                                              "0x00A0"
+#define ISO_IC6_TX_ABRT_SOURCE_inst                                                  0x00A0
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slvrd_intx_shift                                 (15)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slvrd_intx_mask                                  (0x00008000)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slvrd_intx(data)                                 (0x00008000&((data)<<15))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slvrd_intx_src(data)                             ((0x00008000&(data))>>15)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_slvrd_intx(data)                             ((0x00008000&(data))>>15)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slv_arblost_shift                                (14)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slv_arblost_mask                                 (0x00004000)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slv_arblost(data)                                (0x00004000&((data)<<14))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slv_arblost_src(data)                            ((0x00004000&(data))>>14)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_slv_arblost(data)                            ((0x00004000&(data))>>14)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slvflush_txfifo_shift                            (13)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slvflush_txfifo_mask                             (0x00002000)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slvflush_txfifo(data)                            (0x00002000&((data)<<13))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_slvflush_txfifo_src(data)                        ((0x00002000&(data))>>13)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_slvflush_txfifo(data)                        ((0x00002000&(data))>>13)
+#define ISO_IC6_TX_ABRT_SOURCE_arb_lost_shift                                        (12)
+#define ISO_IC6_TX_ABRT_SOURCE_arb_lost_mask                                         (0x00001000)
+#define ISO_IC6_TX_ABRT_SOURCE_arb_lost(data)                                        (0x00001000&((data)<<12))
+#define ISO_IC6_TX_ABRT_SOURCE_arb_lost_src(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC6_TX_ABRT_SOURCE_get_arb_lost(data)                                    ((0x00001000&(data))>>12)
+#define ISO_IC6_TX_ABRT_SOURCE_arb_master_dis_shift                                  (11)
+#define ISO_IC6_TX_ABRT_SOURCE_arb_master_dis_mask                                   (0x00000800)
+#define ISO_IC6_TX_ABRT_SOURCE_arb_master_dis(data)                                  (0x00000800&((data)<<11))
+#define ISO_IC6_TX_ABRT_SOURCE_arb_master_dis_src(data)                              ((0x00000800&(data))>>11)
+#define ISO_IC6_TX_ABRT_SOURCE_get_arb_master_dis(data)                              ((0x00000800&(data))>>11)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_shift                             (10)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_mask                              (0x00000400)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10b_rd_norstrt(data)                             (0x00000400&((data)<<10))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_src(data)                         ((0x00000400&(data))>>10)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_10b_rd_norstrt(data)                         ((0x00000400&(data))>>10)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_sbyte_norstrt_shift                              (9)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_sbyte_norstrt_mask                               (0x00000200)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_sbyte_norstrt(data)                              (0x00000200&((data)<<9))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_sbyte_norstrt_src(data)                          ((0x00000200&(data))>>9)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_sbyte_norstrt(data)                          ((0x00000200&(data))>>9)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_hs_norstrt_shift                                 (8)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_hs_norstrt_mask                                  (0x00000100)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_hs_norstrt(data)                                 (0x00000100&((data)<<8))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_hs_norstrt_src(data)                             ((0x00000100&(data))>>8)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_hs_norstrt(data)                             ((0x00000100&(data))>>8)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_sbyte_ackdet_shift                               (7)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_sbyte_ackdet_mask                                (0x00000080)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_sbyte_ackdet(data)                               (0x00000080&((data)<<7))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_sbyte_ackdet_src(data)                           ((0x00000080&(data))>>7)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_sbyte_ackdet(data)                           ((0x00000080&(data))>>7)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_hs_ackdet_shift                                  (6)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_hs_ackdet_mask                                   (0x00000040)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_hs_ackdet(data)                                  (0x00000040&((data)<<6))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_hs_ackdet_src(data)                              ((0x00000040&(data))>>6)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_hs_ackdet(data)                              ((0x00000040&(data))>>6)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_gcall_read_shift                                 (5)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_gcall_read_mask                                  (0x00000020)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_gcall_read(data)                                 (0x00000020&((data)<<5))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_gcall_read_src(data)                             ((0x00000020&(data))>>5)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_gcall_read(data)                             ((0x00000020&(data))>>5)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_gcall_noack_shift                                (4)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_gcall_noack_mask                                 (0x00000010)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_gcall_noack(data)                                (0x00000010&((data)<<4))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_gcall_noack_src(data)                            ((0x00000010&(data))>>4)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_gcall_noack(data)                            ((0x00000010&(data))>>4)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_txdata_noack_shift                               (3)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_txdata_noack_mask                                (0x00000008)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_txdata_noack(data)                               (0x00000008&((data)<<3))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_txdata_noack_src(data)                           ((0x00000008&(data))>>3)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_txdata_noack(data)                           ((0x00000008&(data))>>3)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10addr2_noack_shift                              (2)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10addr2_noack_mask                               (0x00000004)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10addr2_noack(data)                              (0x00000004&((data)<<2))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10addr2_noack_src(data)                          ((0x00000004&(data))>>2)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_10addr2_noack(data)                          ((0x00000004&(data))>>2)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10addr1_noack_shift                              (1)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10addr1_noack_mask                               (0x00000002)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10addr1_noack(data)                              (0x00000002&((data)<<1))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_10addr1_noack_src(data)                          ((0x00000002&(data))>>1)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_10addr1_noack(data)                          ((0x00000002&(data))>>1)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_7b_addr_noack_shift                              (0)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_7b_addr_noack_mask                               (0x00000001)
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_7b_addr_noack(data)                              (0x00000001&((data)<<0))
+#define ISO_IC6_TX_ABRT_SOURCE_abrt_7b_addr_noack_src(data)                          ((0x00000001&(data))>>0)
+#define ISO_IC6_TX_ABRT_SOURCE_get_abrt_7b_addr_noack(data)                          ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_SLV_DATA_NACK_ONLY                                                   0x18007E84
+#define ISO_IC6_SLV_DATA_NACK_ONLY_reg_addr                                          "0xB8007E84"
+#define ISO_IC6_SLV_DATA_NACK_ONLY_reg                                               0xB8007E84
+#define set_ISO_IC6_SLV_DATA_NACK_ONLY_reg(data)   (*((volatile unsigned int*) ISO_IC6_SLV_DATA_NACK_ONLY_reg)=data)
+#define get_ISO_IC6_SLV_DATA_NACK_ONLY_reg   (*((volatile unsigned int*) ISO_IC6_SLV_DATA_NACK_ONLY_reg))
+#define ISO_IC6_SLV_DATA_NACK_ONLY_inst_adr                                          "0x00A1"
+#define ISO_IC6_SLV_DATA_NACK_ONLY_inst                                              0x00A1
+#define ISO_IC6_SLV_DATA_NACK_ONLY_nack_shift                                        (0)
+#define ISO_IC6_SLV_DATA_NACK_ONLY_nack_mask                                         (0x00000001)
+#define ISO_IC6_SLV_DATA_NACK_ONLY_nack(data)                                        (0x00000001&((data)<<0))
+#define ISO_IC6_SLV_DATA_NACK_ONLY_nack_src(data)                                    ((0x00000001&(data))>>0)
+#define ISO_IC6_SLV_DATA_NACK_ONLY_get_nack(data)                                    ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_DMA_CR                                                               0x18007E88
+#define ISO_IC6_DMA_CR_reg_addr                                                      "0xB8007E88"
+#define ISO_IC6_DMA_CR_reg                                                           0xB8007E88
+#define set_ISO_IC6_DMA_CR_reg(data)   (*((volatile unsigned int*) ISO_IC6_DMA_CR_reg)=data)
+#define get_ISO_IC6_DMA_CR_reg   (*((volatile unsigned int*) ISO_IC6_DMA_CR_reg))
+#define ISO_IC6_DMA_CR_inst_adr                                                      "0x00A2"
+#define ISO_IC6_DMA_CR_inst                                                          0x00A2
+#define ISO_IC6_DMA_CR_tdmae_shift                                                   (1)
+#define ISO_IC6_DMA_CR_tdmae_mask                                                    (0x00000002)
+#define ISO_IC6_DMA_CR_tdmae(data)                                                   (0x00000002&((data)<<1))
+#define ISO_IC6_DMA_CR_tdmae_src(data)                                               ((0x00000002&(data))>>1)
+#define ISO_IC6_DMA_CR_get_tdmae(data)                                               ((0x00000002&(data))>>1)
+#define ISO_IC6_DMA_CR_rdmae_shift                                                   (0)
+#define ISO_IC6_DMA_CR_rdmae_mask                                                    (0x00000001)
+#define ISO_IC6_DMA_CR_rdmae(data)                                                   (0x00000001&((data)<<0))
+#define ISO_IC6_DMA_CR_rdmae_src(data)                                               ((0x00000001&(data))>>0)
+#define ISO_IC6_DMA_CR_get_rdmae(data)                                               ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_DMA_TDLR                                                             0x18007E8C
+#define ISO_IC6_DMA_TDLR_reg_addr                                                    "0xB8007E8C"
+#define ISO_IC6_DMA_TDLR_reg                                                         0xB8007E8C
+#define set_ISO_IC6_DMA_TDLR_reg(data)   (*((volatile unsigned int*) ISO_IC6_DMA_TDLR_reg)=data)
+#define get_ISO_IC6_DMA_TDLR_reg   (*((volatile unsigned int*) ISO_IC6_DMA_TDLR_reg))
+#define ISO_IC6_DMA_TDLR_inst_adr                                                    "0x00A3"
+#define ISO_IC6_DMA_TDLR_inst                                                        0x00A3
+#define ISO_IC6_DMA_TDLR_dmatdl_shift                                                (0)
+#define ISO_IC6_DMA_TDLR_dmatdl_mask                                                 (0x00000007)
+#define ISO_IC6_DMA_TDLR_dmatdl(data)                                                (0x00000007&((data)<<0))
+#define ISO_IC6_DMA_TDLR_dmatdl_src(data)                                            ((0x00000007&(data))>>0)
+#define ISO_IC6_DMA_TDLR_get_dmatdl(data)                                            ((0x00000007&(data))>>0)
+
+
+#define ISO_IC6_DMA_RDLR                                                             0x18007E90
+#define ISO_IC6_DMA_RDLR_reg_addr                                                    "0xB8007E90"
+#define ISO_IC6_DMA_RDLR_reg                                                         0xB8007E90
+#define set_ISO_IC6_DMA_RDLR_reg(data)   (*((volatile unsigned int*) ISO_IC6_DMA_RDLR_reg)=data)
+#define get_ISO_IC6_DMA_RDLR_reg   (*((volatile unsigned int*) ISO_IC6_DMA_RDLR_reg))
+#define ISO_IC6_DMA_RDLR_inst_adr                                                    "0x00A4"
+#define ISO_IC6_DMA_RDLR_inst                                                        0x00A4
+#define ISO_IC6_DMA_RDLR_dmardl_shift                                                (0)
+#define ISO_IC6_DMA_RDLR_dmardl_mask                                                 (0x0000000F)
+#define ISO_IC6_DMA_RDLR_dmardl(data)                                                (0x0000000F&((data)<<0))
+#define ISO_IC6_DMA_RDLR_dmardl_src(data)                                            ((0x0000000F&(data))>>0)
+#define ISO_IC6_DMA_RDLR_get_dmardl(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define ISO_IC6_SDA_SETUP                                                            0x18007E94
+#define ISO_IC6_SDA_SETUP_reg_addr                                                   "0xB8007E94"
+#define ISO_IC6_SDA_SETUP_reg                                                        0xB8007E94
+#define set_ISO_IC6_SDA_SETUP_reg(data)   (*((volatile unsigned int*) ISO_IC6_SDA_SETUP_reg)=data)
+#define get_ISO_IC6_SDA_SETUP_reg   (*((volatile unsigned int*) ISO_IC6_SDA_SETUP_reg))
+#define ISO_IC6_SDA_SETUP_inst_adr                                                   "0x00A5"
+#define ISO_IC6_SDA_SETUP_inst                                                       0x00A5
+#define ISO_IC6_SDA_SETUP_sda_setup_shift                                            (0)
+#define ISO_IC6_SDA_SETUP_sda_setup_mask                                             (0x000000FF)
+#define ISO_IC6_SDA_SETUP_sda_setup(data)                                            (0x000000FF&((data)<<0))
+#define ISO_IC6_SDA_SETUP_sda_setup_src(data)                                        ((0x000000FF&(data))>>0)
+#define ISO_IC6_SDA_SETUP_get_sda_setup(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define ISO_IC6_ACK_GENERAL_CALL                                                     0x18007E98
+#define ISO_IC6_ACK_GENERAL_CALL_reg_addr                                            "0xB8007E98"
+#define ISO_IC6_ACK_GENERAL_CALL_reg                                                 0xB8007E98
+#define set_ISO_IC6_ACK_GENERAL_CALL_reg(data)   (*((volatile unsigned int*) ISO_IC6_ACK_GENERAL_CALL_reg)=data)
+#define get_ISO_IC6_ACK_GENERAL_CALL_reg   (*((volatile unsigned int*) ISO_IC6_ACK_GENERAL_CALL_reg))
+#define ISO_IC6_ACK_GENERAL_CALL_inst_adr                                            "0x00A6"
+#define ISO_IC6_ACK_GENERAL_CALL_inst                                                0x00A6
+#define ISO_IC6_ACK_GENERAL_CALL_ack_gen_call_shift                                  (0)
+#define ISO_IC6_ACK_GENERAL_CALL_ack_gen_call_mask                                   (0x00000001)
+#define ISO_IC6_ACK_GENERAL_CALL_ack_gen_call(data)                                  (0x00000001&((data)<<0))
+#define ISO_IC6_ACK_GENERAL_CALL_ack_gen_call_src(data)                              ((0x00000001&(data))>>0)
+#define ISO_IC6_ACK_GENERAL_CALL_get_ack_gen_call(data)                              ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_ENABLE_STATUS                                                        0x18007E9C
+#define ISO_IC6_ENABLE_STATUS_reg_addr                                               "0xB8007E9C"
+#define ISO_IC6_ENABLE_STATUS_reg                                                    0xB8007E9C
+#define set_ISO_IC6_ENABLE_STATUS_reg(data)   (*((volatile unsigned int*) ISO_IC6_ENABLE_STATUS_reg)=data)
+#define get_ISO_IC6_ENABLE_STATUS_reg   (*((volatile unsigned int*) ISO_IC6_ENABLE_STATUS_reg))
+#define ISO_IC6_ENABLE_STATUS_inst_adr                                               "0x00A7"
+#define ISO_IC6_ENABLE_STATUS_inst                                                   0x00A7
+#define ISO_IC6_ENABLE_STATUS_slv_rx_data_lost_shift                                 (2)
+#define ISO_IC6_ENABLE_STATUS_slv_rx_data_lost_mask                                  (0x00000004)
+#define ISO_IC6_ENABLE_STATUS_slv_rx_data_lost(data)                                 (0x00000004&((data)<<2))
+#define ISO_IC6_ENABLE_STATUS_slv_rx_data_lost_src(data)                             ((0x00000004&(data))>>2)
+#define ISO_IC6_ENABLE_STATUS_get_slv_rx_data_lost(data)                             ((0x00000004&(data))>>2)
+#define ISO_IC6_ENABLE_STATUS_slv_disabled_whi_shift                                 (1)
+#define ISO_IC6_ENABLE_STATUS_slv_disabled_whi_mask                                  (0x00000002)
+#define ISO_IC6_ENABLE_STATUS_slv_disabled_whi(data)                                 (0x00000002&((data)<<1))
+#define ISO_IC6_ENABLE_STATUS_slv_disabled_whi_src(data)                             ((0x00000002&(data))>>1)
+#define ISO_IC6_ENABLE_STATUS_get_slv_disabled_whi(data)                             ((0x00000002&(data))>>1)
+#define ISO_IC6_ENABLE_STATUS_ic_en_shift                                            (0)
+#define ISO_IC6_ENABLE_STATUS_ic_en_mask                                             (0x00000001)
+#define ISO_IC6_ENABLE_STATUS_ic_en(data)                                            (0x00000001&((data)<<0))
+#define ISO_IC6_ENABLE_STATUS_ic_en_src(data)                                        ((0x00000001&(data))>>0)
+#define ISO_IC6_ENABLE_STATUS_get_ic_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define ISO_IC6_COMP_PARAM_1                                                         0x18007EF4
+#define ISO_IC6_COMP_PARAM_1_reg_addr                                                "0xB8007EF4"
+#define ISO_IC6_COMP_PARAM_1_reg                                                     0xB8007EF4
+#define set_ISO_IC6_COMP_PARAM_1_reg(data)   (*((volatile unsigned int*) ISO_IC6_COMP_PARAM_1_reg)=data)
+#define get_ISO_IC6_COMP_PARAM_1_reg   (*((volatile unsigned int*) ISO_IC6_COMP_PARAM_1_reg))
+#define ISO_IC6_COMP_PARAM_1_inst_adr                                                "0x00BD"
+#define ISO_IC6_COMP_PARAM_1_inst                                                    0x00BD
+#define ISO_IC6_COMP_PARAM_1_tx_buffer_depth_shift                                   (16)
+#define ISO_IC6_COMP_PARAM_1_tx_buffer_depth_mask                                    (0x00FF0000)
+#define ISO_IC6_COMP_PARAM_1_tx_buffer_depth(data)                                   (0x00FF0000&((data)<<16))
+#define ISO_IC6_COMP_PARAM_1_tx_buffer_depth_src(data)                               ((0x00FF0000&(data))>>16)
+#define ISO_IC6_COMP_PARAM_1_get_tx_buffer_depth(data)                               ((0x00FF0000&(data))>>16)
+#define ISO_IC6_COMP_PARAM_1_rx_buffer_depth_shift                                   (8)
+#define ISO_IC6_COMP_PARAM_1_rx_buffer_depth_mask                                    (0x0000FF00)
+#define ISO_IC6_COMP_PARAM_1_rx_buffer_depth(data)                                   (0x0000FF00&((data)<<8))
+#define ISO_IC6_COMP_PARAM_1_rx_buffer_depth_src(data)                               ((0x0000FF00&(data))>>8)
+#define ISO_IC6_COMP_PARAM_1_get_rx_buffer_depth(data)                               ((0x0000FF00&(data))>>8)
+#define ISO_IC6_COMP_PARAM_1_add_encoded_params_shift                                (7)
+#define ISO_IC6_COMP_PARAM_1_add_encoded_params_mask                                 (0x00000080)
+#define ISO_IC6_COMP_PARAM_1_add_encoded_params(data)                                (0x00000080&((data)<<7))
+#define ISO_IC6_COMP_PARAM_1_add_encoded_params_src(data)                            ((0x00000080&(data))>>7)
+#define ISO_IC6_COMP_PARAM_1_get_add_encoded_params(data)                            ((0x00000080&(data))>>7)
+#define ISO_IC6_COMP_PARAM_1_has_dma_shift                                           (6)
+#define ISO_IC6_COMP_PARAM_1_has_dma_mask                                            (0x00000040)
+#define ISO_IC6_COMP_PARAM_1_has_dma(data)                                           (0x00000040&((data)<<6))
+#define ISO_IC6_COMP_PARAM_1_has_dma_src(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC6_COMP_PARAM_1_get_has_dma(data)                                       ((0x00000040&(data))>>6)
+#define ISO_IC6_COMP_PARAM_1_intr_io_shift                                           (5)
+#define ISO_IC6_COMP_PARAM_1_intr_io_mask                                            (0x00000020)
+#define ISO_IC6_COMP_PARAM_1_intr_io(data)                                           (0x00000020&((data)<<5))
+#define ISO_IC6_COMP_PARAM_1_intr_io_src(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC6_COMP_PARAM_1_get_intr_io(data)                                       ((0x00000020&(data))>>5)
+#define ISO_IC6_COMP_PARAM_1_hc_count_values_shift                                   (4)
+#define ISO_IC6_COMP_PARAM_1_hc_count_values_mask                                    (0x00000010)
+#define ISO_IC6_COMP_PARAM_1_hc_count_values(data)                                   (0x00000010&((data)<<4))
+#define ISO_IC6_COMP_PARAM_1_hc_count_values_src(data)                               ((0x00000010&(data))>>4)
+#define ISO_IC6_COMP_PARAM_1_get_hc_count_values(data)                               ((0x00000010&(data))>>4)
+#define ISO_IC6_COMP_PARAM_1_max_speed_mode_shift                                    (2)
+#define ISO_IC6_COMP_PARAM_1_max_speed_mode_mask                                     (0x0000000C)
+#define ISO_IC6_COMP_PARAM_1_max_speed_mode(data)                                    (0x0000000C&((data)<<2))
+#define ISO_IC6_COMP_PARAM_1_max_speed_mode_src(data)                                ((0x0000000C&(data))>>2)
+#define ISO_IC6_COMP_PARAM_1_get_max_speed_mode(data)                                ((0x0000000C&(data))>>2)
+#define ISO_IC6_COMP_PARAM_1_apb_data_width_shift                                    (0)
+#define ISO_IC6_COMP_PARAM_1_apb_data_width_mask                                     (0x00000003)
+#define ISO_IC6_COMP_PARAM_1_apb_data_width(data)                                    (0x00000003&((data)<<0))
+#define ISO_IC6_COMP_PARAM_1_apb_data_width_src(data)                                ((0x00000003&(data))>>0)
+#define ISO_IC6_COMP_PARAM_1_get_apb_data_width(data)                                ((0x00000003&(data))>>0)
+
+
+#define ISO_IC6_COMP_VERSION                                                         0x18007EF8
+#define ISO_IC6_COMP_VERSION_reg_addr                                                "0xB8007EF8"
+#define ISO_IC6_COMP_VERSION_reg                                                     0xB8007EF8
+#define set_ISO_IC6_COMP_VERSION_reg(data)   (*((volatile unsigned int*) ISO_IC6_COMP_VERSION_reg)=data)
+#define get_ISO_IC6_COMP_VERSION_reg   (*((volatile unsigned int*) ISO_IC6_COMP_VERSION_reg))
+#define ISO_IC6_COMP_VERSION_inst_adr                                                "0x00BE"
+#define ISO_IC6_COMP_VERSION_inst                                                    0x00BE
+#define ISO_IC6_COMP_VERSION_ic_comp_version_shift                                   (0)
+#define ISO_IC6_COMP_VERSION_ic_comp_version_mask                                    (0xFFFFFFFF)
+#define ISO_IC6_COMP_VERSION_ic_comp_version(data)                                   (0xFFFFFFFF&((data)<<0))
+#define ISO_IC6_COMP_VERSION_ic_comp_version_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define ISO_IC6_COMP_VERSION_get_ic_comp_version(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_IC6_COMP_TYPE                                                            0x18007EFC
+#define ISO_IC6_COMP_TYPE_reg_addr                                                   "0xB8007EFC"
+#define ISO_IC6_COMP_TYPE_reg                                                        0xB8007EFC
+#define set_ISO_IC6_COMP_TYPE_reg(data)   (*((volatile unsigned int*) ISO_IC6_COMP_TYPE_reg)=data)
+#define get_ISO_IC6_COMP_TYPE_reg   (*((volatile unsigned int*) ISO_IC6_COMP_TYPE_reg))
+#define ISO_IC6_COMP_TYPE_inst_adr                                                   "0x00BF"
+#define ISO_IC6_COMP_TYPE_inst                                                       0x00BF
+#define ISO_IC6_COMP_TYPE_ic_comp_type_shift                                         (0)
+#define ISO_IC6_COMP_TYPE_ic_comp_type_mask                                          (0xFFFFFFFF)
+#define ISO_IC6_COMP_TYPE_ic_comp_type(data)                                         (0xFFFFFFFF&((data)<<0))
+#define ISO_IC6_COMP_TYPE_ic_comp_type_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define ISO_IC6_COMP_TYPE_get_ic_comp_type(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define ISO_PWM_OCD                                                                  0x180070D0
+#define ISO_PWM_OCD_reg_addr                                                         "0xB80070D0"
+#define ISO_PWM_OCD_reg                                                              0xB80070D0
+#define set_ISO_PWM_OCD_reg(data)   (*((volatile unsigned int*) ISO_PWM_OCD_reg)=data)
+#define get_ISO_PWM_OCD_reg   (*((volatile unsigned int*) ISO_PWM_OCD_reg))
+#define ISO_PWM_OCD_inst_adr                                                         "0x0034"
+#define ISO_PWM_OCD_inst                                                             0x0034
+#define ISO_PWM_OCD_3_shift                                                          (24)
+#define ISO_PWM_OCD_3_mask                                                           (0xFF000000)
+#define ISO_PWM_OCD_3(data)                                                          (0xFF000000&((data)<<24))
+#define ISO_PWM_OCD_3_src(data)                                                      ((0xFF000000&(data))>>24)
+#define ISO_PWM_OCD_get_3(data)                                                      ((0xFF000000&(data))>>24)
+#define ISO_PWM_OCD_2_shift                                                          (16)
+#define ISO_PWM_OCD_2_mask                                                           (0x00FF0000)
+#define ISO_PWM_OCD_2(data)                                                          (0x00FF0000&((data)<<16))
+#define ISO_PWM_OCD_2_src(data)                                                      ((0x00FF0000&(data))>>16)
+#define ISO_PWM_OCD_get_2(data)                                                      ((0x00FF0000&(data))>>16)
+#define ISO_PWM_OCD_1_shift                                                          (8)
+#define ISO_PWM_OCD_1_mask                                                           (0x0000FF00)
+#define ISO_PWM_OCD_1(data)                                                          (0x0000FF00&((data)<<8))
+#define ISO_PWM_OCD_1_src(data)                                                      ((0x0000FF00&(data))>>8)
+#define ISO_PWM_OCD_get_1(data)                                                      ((0x0000FF00&(data))>>8)
+#define ISO_PWM_OCD_0_shift                                                          (0)
+#define ISO_PWM_OCD_0_mask                                                           (0x000000FF)
+#define ISO_PWM_OCD_0(data)                                                          (0x000000FF&((data)<<0))
+#define ISO_PWM_OCD_0_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ISO_PWM_OCD_get_0(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ISO_PWM_CD                                                                   0x180070D4
+#define ISO_PWM_CD_reg_addr                                                          "0xB80070D4"
+#define ISO_PWM_CD_reg                                                               0xB80070D4
+#define set_ISO_PWM_CD_reg(data)   (*((volatile unsigned int*) ISO_PWM_CD_reg)=data)
+#define get_ISO_PWM_CD_reg   (*((volatile unsigned int*) ISO_PWM_CD_reg))
+#define ISO_PWM_CD_inst_adr                                                          "0x0035"
+#define ISO_PWM_CD_inst                                                              0x0035
+#define ISO_PWM_CD_3_shift                                                           (24)
+#define ISO_PWM_CD_3_mask                                                            (0xFF000000)
+#define ISO_PWM_CD_3(data)                                                           (0xFF000000&((data)<<24))
+#define ISO_PWM_CD_3_src(data)                                                       ((0xFF000000&(data))>>24)
+#define ISO_PWM_CD_get_3(data)                                                       ((0xFF000000&(data))>>24)
+#define ISO_PWM_CD_2_shift                                                           (16)
+#define ISO_PWM_CD_2_mask                                                            (0x00FF0000)
+#define ISO_PWM_CD_2(data)                                                           (0x00FF0000&((data)<<16))
+#define ISO_PWM_CD_2_src(data)                                                       ((0x00FF0000&(data))>>16)
+#define ISO_PWM_CD_get_2(data)                                                       ((0x00FF0000&(data))>>16)
+#define ISO_PWM_CD_1_shift                                                           (8)
+#define ISO_PWM_CD_1_mask                                                            (0x0000FF00)
+#define ISO_PWM_CD_1(data)                                                           (0x0000FF00&((data)<<8))
+#define ISO_PWM_CD_1_src(data)                                                       ((0x0000FF00&(data))>>8)
+#define ISO_PWM_CD_get_1(data)                                                       ((0x0000FF00&(data))>>8)
+#define ISO_PWM_CD_0_shift                                                           (0)
+#define ISO_PWM_CD_0_mask                                                            (0x000000FF)
+#define ISO_PWM_CD_0(data)                                                           (0x000000FF&((data)<<0))
+#define ISO_PWM_CD_0_src(data)                                                       ((0x000000FF&(data))>>0)
+#define ISO_PWM_CD_get_0(data)                                                       ((0x000000FF&(data))>>0)
+
+
+#define ISO_PWM_CSD                                                                  0x180070D8
+#define ISO_PWM_CSD_reg_addr                                                         "0xB80070D8"
+#define ISO_PWM_CSD_reg                                                              0xB80070D8
+#define set_ISO_PWM_CSD_reg(data)   (*((volatile unsigned int*) ISO_PWM_CSD_reg)=data)
+#define get_ISO_PWM_CSD_reg   (*((volatile unsigned int*) ISO_PWM_CSD_reg))
+#define ISO_PWM_CSD_inst_adr                                                         "0x0036"
+#define ISO_PWM_CSD_inst                                                             0x0036
+#define ISO_PWM_CSD_3_shift                                                          (12)
+#define ISO_PWM_CSD_3_mask                                                           (0x0000F000)
+#define ISO_PWM_CSD_3(data)                                                          (0x0000F000&((data)<<12))
+#define ISO_PWM_CSD_3_src(data)                                                      ((0x0000F000&(data))>>12)
+#define ISO_PWM_CSD_get_3(data)                                                      ((0x0000F000&(data))>>12)
+#define ISO_PWM_CSD_2_shift                                                          (8)
+#define ISO_PWM_CSD_2_mask                                                           (0x00000F00)
+#define ISO_PWM_CSD_2(data)                                                          (0x00000F00&((data)<<8))
+#define ISO_PWM_CSD_2_src(data)                                                      ((0x00000F00&(data))>>8)
+#define ISO_PWM_CSD_get_2(data)                                                      ((0x00000F00&(data))>>8)
+#define ISO_PWM_CSD_1_shift                                                          (4)
+#define ISO_PWM_CSD_1_mask                                                           (0x000000F0)
+#define ISO_PWM_CSD_1(data)                                                          (0x000000F0&((data)<<4))
+#define ISO_PWM_CSD_1_src(data)                                                      ((0x000000F0&(data))>>4)
+#define ISO_PWM_CSD_get_1(data)                                                      ((0x000000F0&(data))>>4)
+#define ISO_PWM_CSD_0_shift                                                          (0)
+#define ISO_PWM_CSD_0_mask                                                           (0x0000000F)
+#define ISO_PWM_CSD_0(data)                                                          (0x0000000F&((data)<<0))
+#define ISO_PWM_CSD_0_src(data)                                                      ((0x0000000F&(data))>>0)
+#define ISO_PWM_CSD_get_0(data)                                                      ((0x0000000F&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/jupiter.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/jupiter.h
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_aif_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_aif_reg.h
new file mode 100644
index 00000000..dba3ab2
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_aif_reg.h
@@ -0,0 +1,795 @@
+/**************************************************************
+// Spec Version                  : 0
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/8/8 16:12:26
+***************************************************************/
+
+
+#ifndef _AIF_REG_H_INCLUDED_
+#define _AIF_REG_H_INCLUDED_
+#ifdef  _AIF_USE_STRUCT
+typedef struct 
+{
+unsigned int     reg_oapmodel0:3;
+unsigned int     reg_oanmodel0:3;
+unsigned int     reg_obpmodel0:3;
+unsigned int     reg_obnmodel0:3;
+unsigned int     reg_ocpmodel0:3;
+unsigned int     reg_ocnmodel0:3;
+unsigned int     reg_odpmodel0:3;
+unsigned int     reg_odnmodel0:3;
+unsigned int     reg_oepmodel0:3;
+unsigned int     reg_oenmodel0:3;
+unsigned int     reserved_0:2;
+}AIF_CTRL1;
+
+typedef struct 
+{
+unsigned int     reg_ofpmodel0:3;
+unsigned int     reg_ofnmodel0:3;
+unsigned int     reserved_0:26;
+}AIF_CTRL2;
+
+typedef struct 
+{
+unsigned int     reg_eapmodel0:3;
+unsigned int     reg_eanmodel0:3;
+unsigned int     reg_ebpmodel0:3;
+unsigned int     reg_ebnmodel0:3;
+unsigned int     reg_ecpmodel0:3;
+unsigned int     reg_ecnmodel0:3;
+unsigned int     reg_edpmodel0:3;
+unsigned int     reg_ednmodel0:3;
+unsigned int     reg_eepmodel0:3;
+unsigned int     reg_eenmodel0:3;
+unsigned int     reserved_0:2;
+}AIF_CTRL3;
+
+typedef struct 
+{
+unsigned int     reg_efpmodel0:3;
+unsigned int     reg_efnmodel0:3;
+unsigned int     reserved_0:26;
+}AIF_CTRL4;
+
+typedef struct 
+{
+unsigned int     reg_ibhx_sell0:3;
+unsigned int     reg_pll_rsl0:3;
+unsigned int     reg_ibhn_sell0:3;
+unsigned int     reg_ser_sell0:2;
+unsigned int     reg_tst_sell0:3;
+unsigned int     reserved_0:2;
+unsigned int     reg_pll_ipl0:3;
+unsigned int     reg_pre_sl0:4;
+unsigned int     reg_vcm_sell0:3;
+unsigned int     reg_pll_nl0:2;
+unsigned int     reg_pll_csl0:2;
+unsigned int     reserved_1:2;
+}AIF_CTRL5;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     reg_ibtx_sell0:2;
+}AIF_CTRL6;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     reg_pll_lvreg:2;
+unsigned int     reg_pll_reserved:4;
+unsigned int     reg_clk_2xdrvl:1;
+unsigned int     reg_ib_powl:1;
+unsigned int     reg_pdbl:1;
+unsigned int     reserved_1:4;
+unsigned int     reg_pll_cpl:1;
+unsigned int     reserved_2:2;
+unsigned int     reg_pll_powl:1;
+unsigned int     reg_pll_reserve1l:1;
+unsigned int     reg_pll_rstbl:1;
+unsigned int     reg_pll_sel_div2l:1;
+unsigned int     reg_pll_vcorstbl:1;
+unsigned int     reserved_3:2;
+unsigned int     reg_pll_wdrstl:1;
+unsigned int     reg_pll_wdsetl:1;
+unsigned int     reg_pre_sr_enl:1;
+unsigned int     reg_pre_sr_sell:1;
+unsigned int     reg_sl:2;
+unsigned int     reg_ttlo_2xdrvl:1;
+}AIF_CTRL7;
+
+typedef struct 
+{
+unsigned int     reg_edalagl0:6;
+unsigned int     reg_odalagl0:6;
+unsigned int     reg_epassrsdsl0:6;
+unsigned int     reg_opassrsdsl0:6;
+unsigned int     reserved_0:8;
+}AIF_CTRL8;
+
+typedef struct 
+{
+unsigned int     reg_resvrl:24;
+unsigned int     reserved_0:8;
+}AIF_CTRL9;
+
+typedef struct 
+{
+unsigned int     reserved_0:32;
+}AIF_CTRLA;
+
+typedef struct 
+{
+unsigned int     reg_slew:24;
+unsigned int     reserved_0:8;
+}AIF_CTRLB;
+
+typedef struct 
+{
+unsigned int     reg_shapeh:32;
+}AIF_CTRLC;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     reg_shapel:4;
+}AIF_CTRLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     reg_wdol:1;
+}AIF_CTRLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     reg_pll_ldo_powl:1;
+}AIF_CTRLF;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     orsdsttlinfl0:2;
+unsigned int     orsdsttlinel0:2;
+unsigned int     orsdsttlindl0:2;
+unsigned int     orsdsttlincl0:2;
+unsigned int     orsdsttlinbl0:2;
+unsigned int     orsdsttlinal0:2;
+unsigned int     ersdsttlinfl0:2;
+unsigned int     ersdsttlinel0:2;
+unsigned int     ersdsttlindl0:2;
+unsigned int     ersdsttlincl0:2;
+unsigned int     ersdsttlinbl0:2;
+unsigned int     ersdsttlinal0:2;
+}AIF_TTLO;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     op2dfl0:2;
+unsigned int     op2del0:2;
+unsigned int     op2ddl0:2;
+unsigned int     op2dcl0:2;
+unsigned int     op2dbl0:2;
+unsigned int     op2dal0:2;
+unsigned int     ep2dfl0:2;
+unsigned int     ep2del0:2;
+unsigned int     ep2ddl0:2;
+unsigned int     ep2dcl0:2;
+unsigned int     ep2dbl0:2;
+unsigned int     ep2dal0:2;
+}AIF_TTLI;
+
+typedef struct 
+{
+unsigned int     dummy:32;
+}AIF_CTRLG;
+
+#endif
+
+#define AIF_CTRL1                                                                    0x18009010
+#define AIF_CTRL1_reg_addr                                                           "0xB8009010"
+#define AIF_CTRL1_reg                                                                0xB8009010
+#define set_AIF_CTRL1_reg(data)   (*((volatile unsigned int*) AIF_CTRL1_reg)=data)
+#define get_AIF_CTRL1_reg   (*((volatile unsigned int*) AIF_CTRL1_reg))
+#define AIF_CTRL1_inst_adr                                                           "0x0004"
+#define AIF_CTRL1_inst                                                               0x0004
+#define AIF_CTRL1_reg_oapmodel0_shift                                                (29)
+#define AIF_CTRL1_reg_oapmodel0_mask                                                 (0xE0000000)
+#define AIF_CTRL1_reg_oapmodel0(data)                                                (0xE0000000&((data)<<29))
+#define AIF_CTRL1_reg_oapmodel0_src(data)                                            ((0xE0000000&(data))>>29)
+#define AIF_CTRL1_get_reg_oapmodel0(data)                                            ((0xE0000000&(data))>>29)
+#define AIF_CTRL1_reg_oanmodel0_shift                                                (26)
+#define AIF_CTRL1_reg_oanmodel0_mask                                                 (0x1C000000)
+#define AIF_CTRL1_reg_oanmodel0(data)                                                (0x1C000000&((data)<<26))
+#define AIF_CTRL1_reg_oanmodel0_src(data)                                            ((0x1C000000&(data))>>26)
+#define AIF_CTRL1_get_reg_oanmodel0(data)                                            ((0x1C000000&(data))>>26)
+#define AIF_CTRL1_reg_obpmodel0_shift                                                (23)
+#define AIF_CTRL1_reg_obpmodel0_mask                                                 (0x03800000)
+#define AIF_CTRL1_reg_obpmodel0(data)                                                (0x03800000&((data)<<23))
+#define AIF_CTRL1_reg_obpmodel0_src(data)                                            ((0x03800000&(data))>>23)
+#define AIF_CTRL1_get_reg_obpmodel0(data)                                            ((0x03800000&(data))>>23)
+#define AIF_CTRL1_reg_obnmodel0_shift                                                (20)
+#define AIF_CTRL1_reg_obnmodel0_mask                                                 (0x00700000)
+#define AIF_CTRL1_reg_obnmodel0(data)                                                (0x00700000&((data)<<20))
+#define AIF_CTRL1_reg_obnmodel0_src(data)                                            ((0x00700000&(data))>>20)
+#define AIF_CTRL1_get_reg_obnmodel0(data)                                            ((0x00700000&(data))>>20)
+#define AIF_CTRL1_reg_ocpmodel0_shift                                                (17)
+#define AIF_CTRL1_reg_ocpmodel0_mask                                                 (0x000E0000)
+#define AIF_CTRL1_reg_ocpmodel0(data)                                                (0x000E0000&((data)<<17))
+#define AIF_CTRL1_reg_ocpmodel0_src(data)                                            ((0x000E0000&(data))>>17)
+#define AIF_CTRL1_get_reg_ocpmodel0(data)                                            ((0x000E0000&(data))>>17)
+#define AIF_CTRL1_reg_ocnmodel0_shift                                                (14)
+#define AIF_CTRL1_reg_ocnmodel0_mask                                                 (0x0001C000)
+#define AIF_CTRL1_reg_ocnmodel0(data)                                                (0x0001C000&((data)<<14))
+#define AIF_CTRL1_reg_ocnmodel0_src(data)                                            ((0x0001C000&(data))>>14)
+#define AIF_CTRL1_get_reg_ocnmodel0(data)                                            ((0x0001C000&(data))>>14)
+#define AIF_CTRL1_reg_odpmodel0_shift                                                (11)
+#define AIF_CTRL1_reg_odpmodel0_mask                                                 (0x00003800)
+#define AIF_CTRL1_reg_odpmodel0(data)                                                (0x00003800&((data)<<11))
+#define AIF_CTRL1_reg_odpmodel0_src(data)                                            ((0x00003800&(data))>>11)
+#define AIF_CTRL1_get_reg_odpmodel0(data)                                            ((0x00003800&(data))>>11)
+#define AIF_CTRL1_reg_odnmodel0_shift                                                (8)
+#define AIF_CTRL1_reg_odnmodel0_mask                                                 (0x00000700)
+#define AIF_CTRL1_reg_odnmodel0(data)                                                (0x00000700&((data)<<8))
+#define AIF_CTRL1_reg_odnmodel0_src(data)                                            ((0x00000700&(data))>>8)
+#define AIF_CTRL1_get_reg_odnmodel0(data)                                            ((0x00000700&(data))>>8)
+#define AIF_CTRL1_reg_oepmodel0_shift                                                (5)
+#define AIF_CTRL1_reg_oepmodel0_mask                                                 (0x000000E0)
+#define AIF_CTRL1_reg_oepmodel0(data)                                                (0x000000E0&((data)<<5))
+#define AIF_CTRL1_reg_oepmodel0_src(data)                                            ((0x000000E0&(data))>>5)
+#define AIF_CTRL1_get_reg_oepmodel0(data)                                            ((0x000000E0&(data))>>5)
+#define AIF_CTRL1_reg_oenmodel0_shift                                                (2)
+#define AIF_CTRL1_reg_oenmodel0_mask                                                 (0x0000001C)
+#define AIF_CTRL1_reg_oenmodel0(data)                                                (0x0000001C&((data)<<2))
+#define AIF_CTRL1_reg_oenmodel0_src(data)                                            ((0x0000001C&(data))>>2)
+#define AIF_CTRL1_get_reg_oenmodel0(data)                                            ((0x0000001C&(data))>>2)
+
+
+#define AIF_CTRL2                                                                    0x18009014
+#define AIF_CTRL2_reg_addr                                                           "0xB8009014"
+#define AIF_CTRL2_reg                                                                0xB8009014
+#define set_AIF_CTRL2_reg(data)   (*((volatile unsigned int*) AIF_CTRL2_reg)=data)
+#define get_AIF_CTRL2_reg   (*((volatile unsigned int*) AIF_CTRL2_reg))
+#define AIF_CTRL2_inst_adr                                                           "0x0005"
+#define AIF_CTRL2_inst                                                               0x0005
+#define AIF_CTRL2_reg_ofpmodel0_shift                                                (29)
+#define AIF_CTRL2_reg_ofpmodel0_mask                                                 (0xE0000000)
+#define AIF_CTRL2_reg_ofpmodel0(data)                                                (0xE0000000&((data)<<29))
+#define AIF_CTRL2_reg_ofpmodel0_src(data)                                            ((0xE0000000&(data))>>29)
+#define AIF_CTRL2_get_reg_ofpmodel0(data)                                            ((0xE0000000&(data))>>29)
+#define AIF_CTRL2_reg_ofnmodel0_shift                                                (26)
+#define AIF_CTRL2_reg_ofnmodel0_mask                                                 (0x1C000000)
+#define AIF_CTRL2_reg_ofnmodel0(data)                                                (0x1C000000&((data)<<26))
+#define AIF_CTRL2_reg_ofnmodel0_src(data)                                            ((0x1C000000&(data))>>26)
+#define AIF_CTRL2_get_reg_ofnmodel0(data)                                            ((0x1C000000&(data))>>26)
+
+
+#define AIF_CTRL3                                                                    0x18009018
+#define AIF_CTRL3_reg_addr                                                           "0xB8009018"
+#define AIF_CTRL3_reg                                                                0xB8009018
+#define set_AIF_CTRL3_reg(data)   (*((volatile unsigned int*) AIF_CTRL3_reg)=data)
+#define get_AIF_CTRL3_reg   (*((volatile unsigned int*) AIF_CTRL3_reg))
+#define AIF_CTRL3_inst_adr                                                           "0x0006"
+#define AIF_CTRL3_inst                                                               0x0006
+#define AIF_CTRL3_reg_eapmodel0_shift                                                (29)
+#define AIF_CTRL3_reg_eapmodel0_mask                                                 (0xE0000000)
+#define AIF_CTRL3_reg_eapmodel0(data)                                                (0xE0000000&((data)<<29))
+#define AIF_CTRL3_reg_eapmodel0_src(data)                                            ((0xE0000000&(data))>>29)
+#define AIF_CTRL3_get_reg_eapmodel0(data)                                            ((0xE0000000&(data))>>29)
+#define AIF_CTRL3_reg_eanmodel0_shift                                                (26)
+#define AIF_CTRL3_reg_eanmodel0_mask                                                 (0x1C000000)
+#define AIF_CTRL3_reg_eanmodel0(data)                                                (0x1C000000&((data)<<26))
+#define AIF_CTRL3_reg_eanmodel0_src(data)                                            ((0x1C000000&(data))>>26)
+#define AIF_CTRL3_get_reg_eanmodel0(data)                                            ((0x1C000000&(data))>>26)
+#define AIF_CTRL3_reg_ebpmodel0_shift                                                (23)
+#define AIF_CTRL3_reg_ebpmodel0_mask                                                 (0x03800000)
+#define AIF_CTRL3_reg_ebpmodel0(data)                                                (0x03800000&((data)<<23))
+#define AIF_CTRL3_reg_ebpmodel0_src(data)                                            ((0x03800000&(data))>>23)
+#define AIF_CTRL3_get_reg_ebpmodel0(data)                                            ((0x03800000&(data))>>23)
+#define AIF_CTRL3_reg_ebnmodel0_shift                                                (20)
+#define AIF_CTRL3_reg_ebnmodel0_mask                                                 (0x00700000)
+#define AIF_CTRL3_reg_ebnmodel0(data)                                                (0x00700000&((data)<<20))
+#define AIF_CTRL3_reg_ebnmodel0_src(data)                                            ((0x00700000&(data))>>20)
+#define AIF_CTRL3_get_reg_ebnmodel0(data)                                            ((0x00700000&(data))>>20)
+#define AIF_CTRL3_reg_ecpmodel0_shift                                                (17)
+#define AIF_CTRL3_reg_ecpmodel0_mask                                                 (0x000E0000)
+#define AIF_CTRL3_reg_ecpmodel0(data)                                                (0x000E0000&((data)<<17))
+#define AIF_CTRL3_reg_ecpmodel0_src(data)                                            ((0x000E0000&(data))>>17)
+#define AIF_CTRL3_get_reg_ecpmodel0(data)                                            ((0x000E0000&(data))>>17)
+#define AIF_CTRL3_reg_ecnmodel0_shift                                                (14)
+#define AIF_CTRL3_reg_ecnmodel0_mask                                                 (0x0001C000)
+#define AIF_CTRL3_reg_ecnmodel0(data)                                                (0x0001C000&((data)<<14))
+#define AIF_CTRL3_reg_ecnmodel0_src(data)                                            ((0x0001C000&(data))>>14)
+#define AIF_CTRL3_get_reg_ecnmodel0(data)                                            ((0x0001C000&(data))>>14)
+#define AIF_CTRL3_reg_edpmodel0_shift                                                (11)
+#define AIF_CTRL3_reg_edpmodel0_mask                                                 (0x00003800)
+#define AIF_CTRL3_reg_edpmodel0(data)                                                (0x00003800&((data)<<11))
+#define AIF_CTRL3_reg_edpmodel0_src(data)                                            ((0x00003800&(data))>>11)
+#define AIF_CTRL3_get_reg_edpmodel0(data)                                            ((0x00003800&(data))>>11)
+#define AIF_CTRL3_reg_ednmodel0_shift                                                (8)
+#define AIF_CTRL3_reg_ednmodel0_mask                                                 (0x00000700)
+#define AIF_CTRL3_reg_ednmodel0(data)                                                (0x00000700&((data)<<8))
+#define AIF_CTRL3_reg_ednmodel0_src(data)                                            ((0x00000700&(data))>>8)
+#define AIF_CTRL3_get_reg_ednmodel0(data)                                            ((0x00000700&(data))>>8)
+#define AIF_CTRL3_reg_eepmodel0_shift                                                (5)
+#define AIF_CTRL3_reg_eepmodel0_mask                                                 (0x000000E0)
+#define AIF_CTRL3_reg_eepmodel0(data)                                                (0x000000E0&((data)<<5))
+#define AIF_CTRL3_reg_eepmodel0_src(data)                                            ((0x000000E0&(data))>>5)
+#define AIF_CTRL3_get_reg_eepmodel0(data)                                            ((0x000000E0&(data))>>5)
+#define AIF_CTRL3_reg_eenmodel0_shift                                                (2)
+#define AIF_CTRL3_reg_eenmodel0_mask                                                 (0x0000001C)
+#define AIF_CTRL3_reg_eenmodel0(data)                                                (0x0000001C&((data)<<2))
+#define AIF_CTRL3_reg_eenmodel0_src(data)                                            ((0x0000001C&(data))>>2)
+#define AIF_CTRL3_get_reg_eenmodel0(data)                                            ((0x0000001C&(data))>>2)
+
+
+#define AIF_CTRL4                                                                    0x1800901C
+#define AIF_CTRL4_reg_addr                                                           "0xB800901C"
+#define AIF_CTRL4_reg                                                                0xB800901C
+#define set_AIF_CTRL4_reg(data)   (*((volatile unsigned int*) AIF_CTRL4_reg)=data)
+#define get_AIF_CTRL4_reg   (*((volatile unsigned int*) AIF_CTRL4_reg))
+#define AIF_CTRL4_inst_adr                                                           "0x0007"
+#define AIF_CTRL4_inst                                                               0x0007
+#define AIF_CTRL4_reg_efpmodel0_shift                                                (29)
+#define AIF_CTRL4_reg_efpmodel0_mask                                                 (0xE0000000)
+#define AIF_CTRL4_reg_efpmodel0(data)                                                (0xE0000000&((data)<<29))
+#define AIF_CTRL4_reg_efpmodel0_src(data)                                            ((0xE0000000&(data))>>29)
+#define AIF_CTRL4_get_reg_efpmodel0(data)                                            ((0xE0000000&(data))>>29)
+#define AIF_CTRL4_reg_efnmodel0_shift                                                (26)
+#define AIF_CTRL4_reg_efnmodel0_mask                                                 (0x1C000000)
+#define AIF_CTRL4_reg_efnmodel0(data)                                                (0x1C000000&((data)<<26))
+#define AIF_CTRL4_reg_efnmodel0_src(data)                                            ((0x1C000000&(data))>>26)
+#define AIF_CTRL4_get_reg_efnmodel0(data)                                            ((0x1C000000&(data))>>26)
+
+
+#define AIF_CTRL5                                                                    0x18009020
+#define AIF_CTRL5_reg_addr                                                           "0xB8009020"
+#define AIF_CTRL5_reg                                                                0xB8009020
+#define set_AIF_CTRL5_reg(data)   (*((volatile unsigned int*) AIF_CTRL5_reg)=data)
+#define get_AIF_CTRL5_reg   (*((volatile unsigned int*) AIF_CTRL5_reg))
+#define AIF_CTRL5_inst_adr                                                           "0x0008"
+#define AIF_CTRL5_inst                                                               0x0008
+#define AIF_CTRL5_reg_ibhx_sell0_shift                                               (29)
+#define AIF_CTRL5_reg_ibhx_sell0_mask                                                (0xE0000000)
+#define AIF_CTRL5_reg_ibhx_sell0(data)                                               (0xE0000000&((data)<<29))
+#define AIF_CTRL5_reg_ibhx_sell0_src(data)                                           ((0xE0000000&(data))>>29)
+#define AIF_CTRL5_get_reg_ibhx_sell0(data)                                           ((0xE0000000&(data))>>29)
+#define AIF_CTRL5_reg_pll_rsl0_shift                                                 (26)
+#define AIF_CTRL5_reg_pll_rsl0_mask                                                  (0x1C000000)
+#define AIF_CTRL5_reg_pll_rsl0(data)                                                 (0x1C000000&((data)<<26))
+#define AIF_CTRL5_reg_pll_rsl0_src(data)                                             ((0x1C000000&(data))>>26)
+#define AIF_CTRL5_get_reg_pll_rsl0(data)                                             ((0x1C000000&(data))>>26)
+#define AIF_CTRL5_reg_ibhn_sell0_shift                                               (23)
+#define AIF_CTRL5_reg_ibhn_sell0_mask                                                (0x03800000)
+#define AIF_CTRL5_reg_ibhn_sell0(data)                                               (0x03800000&((data)<<23))
+#define AIF_CTRL5_reg_ibhn_sell0_src(data)                                           ((0x03800000&(data))>>23)
+#define AIF_CTRL5_get_reg_ibhn_sell0(data)                                           ((0x03800000&(data))>>23)
+#define AIF_CTRL5_reg_ser_sell0_shift                                                (21)
+#define AIF_CTRL5_reg_ser_sell0_mask                                                 (0x00600000)
+#define AIF_CTRL5_reg_ser_sell0(data)                                                (0x00600000&((data)<<21))
+#define AIF_CTRL5_reg_ser_sell0_src(data)                                            ((0x00600000&(data))>>21)
+#define AIF_CTRL5_get_reg_ser_sell0(data)                                            ((0x00600000&(data))>>21)
+#define AIF_CTRL5_reg_tst_sell0_shift                                                (18)
+#define AIF_CTRL5_reg_tst_sell0_mask                                                 (0x001C0000)
+#define AIF_CTRL5_reg_tst_sell0(data)                                                (0x001C0000&((data)<<18))
+#define AIF_CTRL5_reg_tst_sell0_src(data)                                            ((0x001C0000&(data))>>18)
+#define AIF_CTRL5_get_reg_tst_sell0(data)                                            ((0x001C0000&(data))>>18)
+#define AIF_CTRL5_reg_pll_ipl0_shift                                                 (13)
+#define AIF_CTRL5_reg_pll_ipl0_mask                                                  (0x0000E000)
+#define AIF_CTRL5_reg_pll_ipl0(data)                                                 (0x0000E000&((data)<<13))
+#define AIF_CTRL5_reg_pll_ipl0_src(data)                                             ((0x0000E000&(data))>>13)
+#define AIF_CTRL5_get_reg_pll_ipl0(data)                                             ((0x0000E000&(data))>>13)
+#define AIF_CTRL5_reg_pre_sl0_shift                                                  (9)
+#define AIF_CTRL5_reg_pre_sl0_mask                                                   (0x00001E00)
+#define AIF_CTRL5_reg_pre_sl0(data)                                                  (0x00001E00&((data)<<9))
+#define AIF_CTRL5_reg_pre_sl0_src(data)                                              ((0x00001E00&(data))>>9)
+#define AIF_CTRL5_get_reg_pre_sl0(data)                                              ((0x00001E00&(data))>>9)
+#define AIF_CTRL5_reg_vcm_sell0_shift                                                (6)
+#define AIF_CTRL5_reg_vcm_sell0_mask                                                 (0x000001C0)
+#define AIF_CTRL5_reg_vcm_sell0(data)                                                (0x000001C0&((data)<<6))
+#define AIF_CTRL5_reg_vcm_sell0_src(data)                                            ((0x000001C0&(data))>>6)
+#define AIF_CTRL5_get_reg_vcm_sell0(data)                                            ((0x000001C0&(data))>>6)
+#define AIF_CTRL5_reg_pll_nl0_shift                                                  (4)
+#define AIF_CTRL5_reg_pll_nl0_mask                                                   (0x00000030)
+#define AIF_CTRL5_reg_pll_nl0(data)                                                  (0x00000030&((data)<<4))
+#define AIF_CTRL5_reg_pll_nl0_src(data)                                              ((0x00000030&(data))>>4)
+#define AIF_CTRL5_get_reg_pll_nl0(data)                                              ((0x00000030&(data))>>4)
+#define AIF_CTRL5_reg_pll_csl0_shift                                                 (2)
+#define AIF_CTRL5_reg_pll_csl0_mask                                                  (0x0000000C)
+#define AIF_CTRL5_reg_pll_csl0(data)                                                 (0x0000000C&((data)<<2))
+#define AIF_CTRL5_reg_pll_csl0_src(data)                                             ((0x0000000C&(data))>>2)
+#define AIF_CTRL5_get_reg_pll_csl0(data)                                             ((0x0000000C&(data))>>2)
+
+
+#define AIF_CTRL6                                                                    0x18009024
+#define AIF_CTRL6_reg_addr                                                           "0xB8009024"
+#define AIF_CTRL6_reg                                                                0xB8009024
+#define set_AIF_CTRL6_reg(data)   (*((volatile unsigned int*) AIF_CTRL6_reg)=data)
+#define get_AIF_CTRL6_reg   (*((volatile unsigned int*) AIF_CTRL6_reg))
+#define AIF_CTRL6_inst_adr                                                           "0x0009"
+#define AIF_CTRL6_inst                                                               0x0009
+#define AIF_CTRL6_reg_ibtx_sell0_shift                                               (0)
+#define AIF_CTRL6_reg_ibtx_sell0_mask                                                (0x00000003)
+#define AIF_CTRL6_reg_ibtx_sell0(data)                                               (0x00000003&((data)<<0))
+#define AIF_CTRL6_reg_ibtx_sell0_src(data)                                           ((0x00000003&(data))>>0)
+#define AIF_CTRL6_get_reg_ibtx_sell0(data)                                           ((0x00000003&(data))>>0)
+
+
+#define AIF_CTRL7                                                                    0x18009028
+#define AIF_CTRL7_reg_addr                                                           "0xB8009028"
+#define AIF_CTRL7_reg                                                                0xB8009028
+#define set_AIF_CTRL7_reg(data)   (*((volatile unsigned int*) AIF_CTRL7_reg)=data)
+#define get_AIF_CTRL7_reg   (*((volatile unsigned int*) AIF_CTRL7_reg))
+#define AIF_CTRL7_inst_adr                                                           "0x000A"
+#define AIF_CTRL7_inst                                                               0x000A
+#define AIF_CTRL7_reg_pll_lvreg_shift                                                (28)
+#define AIF_CTRL7_reg_pll_lvreg_mask                                                 (0x30000000)
+#define AIF_CTRL7_reg_pll_lvreg(data)                                                (0x30000000&((data)<<28))
+#define AIF_CTRL7_reg_pll_lvreg_src(data)                                            ((0x30000000&(data))>>28)
+#define AIF_CTRL7_get_reg_pll_lvreg(data)                                            ((0x30000000&(data))>>28)
+#define AIF_CTRL7_reg_pll_reserved_shift                                             (24)
+#define AIF_CTRL7_reg_pll_reserved_mask                                              (0x0F000000)
+#define AIF_CTRL7_reg_pll_reserved(data)                                             (0x0F000000&((data)<<24))
+#define AIF_CTRL7_reg_pll_reserved_src(data)                                         ((0x0F000000&(data))>>24)
+#define AIF_CTRL7_get_reg_pll_reserved(data)                                         ((0x0F000000&(data))>>24)
+#define AIF_CTRL7_reg_clk_2xdrvl_shift                                               (23)
+#define AIF_CTRL7_reg_clk_2xdrvl_mask                                                (0x00800000)
+#define AIF_CTRL7_reg_clk_2xdrvl(data)                                               (0x00800000&((data)<<23))
+#define AIF_CTRL7_reg_clk_2xdrvl_src(data)                                           ((0x00800000&(data))>>23)
+#define AIF_CTRL7_get_reg_clk_2xdrvl(data)                                           ((0x00800000&(data))>>23)
+#define AIF_CTRL7_reg_ib_powl_shift                                                  (22)
+#define AIF_CTRL7_reg_ib_powl_mask                                                   (0x00400000)
+#define AIF_CTRL7_reg_ib_powl(data)                                                  (0x00400000&((data)<<22))
+#define AIF_CTRL7_reg_ib_powl_src(data)                                              ((0x00400000&(data))>>22)
+#define AIF_CTRL7_get_reg_ib_powl(data)                                              ((0x00400000&(data))>>22)
+#define AIF_CTRL7_reg_pdbl_shift                                                     (21)
+#define AIF_CTRL7_reg_pdbl_mask                                                      (0x00200000)
+#define AIF_CTRL7_reg_pdbl(data)                                                     (0x00200000&((data)<<21))
+#define AIF_CTRL7_reg_pdbl_src(data)                                                 ((0x00200000&(data))>>21)
+#define AIF_CTRL7_get_reg_pdbl(data)                                                 ((0x00200000&(data))>>21)
+#define AIF_CTRL7_reg_pll_cpl_shift                                                  (16)
+#define AIF_CTRL7_reg_pll_cpl_mask                                                   (0x00010000)
+#define AIF_CTRL7_reg_pll_cpl(data)                                                  (0x00010000&((data)<<16))
+#define AIF_CTRL7_reg_pll_cpl_src(data)                                              ((0x00010000&(data))>>16)
+#define AIF_CTRL7_get_reg_pll_cpl(data)                                              ((0x00010000&(data))>>16)
+#define AIF_CTRL7_reg_pll_powl_shift                                                 (13)
+#define AIF_CTRL7_reg_pll_powl_mask                                                  (0x00002000)
+#define AIF_CTRL7_reg_pll_powl(data)                                                 (0x00002000&((data)<<13))
+#define AIF_CTRL7_reg_pll_powl_src(data)                                             ((0x00002000&(data))>>13)
+#define AIF_CTRL7_get_reg_pll_powl(data)                                             ((0x00002000&(data))>>13)
+#define AIF_CTRL7_reg_pll_reserve1l_shift                                            (12)
+#define AIF_CTRL7_reg_pll_reserve1l_mask                                             (0x00001000)
+#define AIF_CTRL7_reg_pll_reserve1l(data)                                            (0x00001000&((data)<<12))
+#define AIF_CTRL7_reg_pll_reserve1l_src(data)                                        ((0x00001000&(data))>>12)
+#define AIF_CTRL7_get_reg_pll_reserve1l(data)                                        ((0x00001000&(data))>>12)
+#define AIF_CTRL7_reg_pll_rstbl_shift                                                (11)
+#define AIF_CTRL7_reg_pll_rstbl_mask                                                 (0x00000800)
+#define AIF_CTRL7_reg_pll_rstbl(data)                                                (0x00000800&((data)<<11))
+#define AIF_CTRL7_reg_pll_rstbl_src(data)                                            ((0x00000800&(data))>>11)
+#define AIF_CTRL7_get_reg_pll_rstbl(data)                                            ((0x00000800&(data))>>11)
+#define AIF_CTRL7_reg_pll_sel_div2l_shift                                            (10)
+#define AIF_CTRL7_reg_pll_sel_div2l_mask                                             (0x00000400)
+#define AIF_CTRL7_reg_pll_sel_div2l(data)                                            (0x00000400&((data)<<10))
+#define AIF_CTRL7_reg_pll_sel_div2l_src(data)                                        ((0x00000400&(data))>>10)
+#define AIF_CTRL7_get_reg_pll_sel_div2l(data)                                        ((0x00000400&(data))>>10)
+#define AIF_CTRL7_reg_pll_vcorstbl_shift                                             (9)
+#define AIF_CTRL7_reg_pll_vcorstbl_mask                                              (0x00000200)
+#define AIF_CTRL7_reg_pll_vcorstbl(data)                                             (0x00000200&((data)<<9))
+#define AIF_CTRL7_reg_pll_vcorstbl_src(data)                                         ((0x00000200&(data))>>9)
+#define AIF_CTRL7_get_reg_pll_vcorstbl(data)                                         ((0x00000200&(data))>>9)
+#define AIF_CTRL7_reg_pll_wdrstl_shift                                               (6)
+#define AIF_CTRL7_reg_pll_wdrstl_mask                                                (0x00000040)
+#define AIF_CTRL7_reg_pll_wdrstl(data)                                               (0x00000040&((data)<<6))
+#define AIF_CTRL7_reg_pll_wdrstl_src(data)                                           ((0x00000040&(data))>>6)
+#define AIF_CTRL7_get_reg_pll_wdrstl(data)                                           ((0x00000040&(data))>>6)
+#define AIF_CTRL7_reg_pll_wdsetl_shift                                               (5)
+#define AIF_CTRL7_reg_pll_wdsetl_mask                                                (0x00000020)
+#define AIF_CTRL7_reg_pll_wdsetl(data)                                               (0x00000020&((data)<<5))
+#define AIF_CTRL7_reg_pll_wdsetl_src(data)                                           ((0x00000020&(data))>>5)
+#define AIF_CTRL7_get_reg_pll_wdsetl(data)                                           ((0x00000020&(data))>>5)
+#define AIF_CTRL7_reg_pre_sr_enl_shift                                               (4)
+#define AIF_CTRL7_reg_pre_sr_enl_mask                                                (0x00000010)
+#define AIF_CTRL7_reg_pre_sr_enl(data)                                               (0x00000010&((data)<<4))
+#define AIF_CTRL7_reg_pre_sr_enl_src(data)                                           ((0x00000010&(data))>>4)
+#define AIF_CTRL7_get_reg_pre_sr_enl(data)                                           ((0x00000010&(data))>>4)
+#define AIF_CTRL7_reg_pre_sr_sell_shift                                              (3)
+#define AIF_CTRL7_reg_pre_sr_sell_mask                                               (0x00000008)
+#define AIF_CTRL7_reg_pre_sr_sell(data)                                              (0x00000008&((data)<<3))
+#define AIF_CTRL7_reg_pre_sr_sell_src(data)                                          ((0x00000008&(data))>>3)
+#define AIF_CTRL7_get_reg_pre_sr_sell(data)                                          ((0x00000008&(data))>>3)
+#define AIF_CTRL7_reg_sl_shift                                                       (1)
+#define AIF_CTRL7_reg_sl_mask                                                        (0x00000006)
+#define AIF_CTRL7_reg_sl(data)                                                       (0x00000006&((data)<<1))
+#define AIF_CTRL7_reg_sl_src(data)                                                   ((0x00000006&(data))>>1)
+#define AIF_CTRL7_get_reg_sl(data)                                                   ((0x00000006&(data))>>1)
+#define AIF_CTRL7_reg_ttlo_2xdrvl_shift                                              (0)
+#define AIF_CTRL7_reg_ttlo_2xdrvl_mask                                               (0x00000001)
+#define AIF_CTRL7_reg_ttlo_2xdrvl(data)                                              (0x00000001&((data)<<0))
+#define AIF_CTRL7_reg_ttlo_2xdrvl_src(data)                                          ((0x00000001&(data))>>0)
+#define AIF_CTRL7_get_reg_ttlo_2xdrvl(data)                                          ((0x00000001&(data))>>0)
+
+
+#define AIF_CTRL8                                                                    0x1800902C
+#define AIF_CTRL8_reg_addr                                                           "0xB800902C"
+#define AIF_CTRL8_reg                                                                0xB800902C
+#define set_AIF_CTRL8_reg(data)   (*((volatile unsigned int*) AIF_CTRL8_reg)=data)
+#define get_AIF_CTRL8_reg   (*((volatile unsigned int*) AIF_CTRL8_reg))
+#define AIF_CTRL8_inst_adr                                                           "0x000B"
+#define AIF_CTRL8_inst                                                               0x000B
+#define AIF_CTRL8_reg_edalagl0_shift                                                 (26)
+#define AIF_CTRL8_reg_edalagl0_mask                                                  (0xFC000000)
+#define AIF_CTRL8_reg_edalagl0(data)                                                 (0xFC000000&((data)<<26))
+#define AIF_CTRL8_reg_edalagl0_src(data)                                             ((0xFC000000&(data))>>26)
+#define AIF_CTRL8_get_reg_edalagl0(data)                                             ((0xFC000000&(data))>>26)
+#define AIF_CTRL8_reg_odalagl0_shift                                                 (20)
+#define AIF_CTRL8_reg_odalagl0_mask                                                  (0x03F00000)
+#define AIF_CTRL8_reg_odalagl0(data)                                                 (0x03F00000&((data)<<20))
+#define AIF_CTRL8_reg_odalagl0_src(data)                                             ((0x03F00000&(data))>>20)
+#define AIF_CTRL8_get_reg_odalagl0(data)                                             ((0x03F00000&(data))>>20)
+#define AIF_CTRL8_reg_epassrsdsl0_shift                                              (14)
+#define AIF_CTRL8_reg_epassrsdsl0_mask                                               (0x000FC000)
+#define AIF_CTRL8_reg_epassrsdsl0(data)                                              (0x000FC000&((data)<<14))
+#define AIF_CTRL8_reg_epassrsdsl0_src(data)                                          ((0x000FC000&(data))>>14)
+#define AIF_CTRL8_get_reg_epassrsdsl0(data)                                          ((0x000FC000&(data))>>14)
+#define AIF_CTRL8_reg_opassrsdsl0_shift                                              (8)
+#define AIF_CTRL8_reg_opassrsdsl0_mask                                               (0x00003F00)
+#define AIF_CTRL8_reg_opassrsdsl0(data)                                              (0x00003F00&((data)<<8))
+#define AIF_CTRL8_reg_opassrsdsl0_src(data)                                          ((0x00003F00&(data))>>8)
+#define AIF_CTRL8_get_reg_opassrsdsl0(data)                                          ((0x00003F00&(data))>>8)
+
+
+#define AIF_CTRL9                                                                    0x18009030
+#define AIF_CTRL9_reg_addr                                                           "0xB8009030"
+#define AIF_CTRL9_reg                                                                0xB8009030
+#define set_AIF_CTRL9_reg(data)   (*((volatile unsigned int*) AIF_CTRL9_reg)=data)
+#define get_AIF_CTRL9_reg   (*((volatile unsigned int*) AIF_CTRL9_reg))
+#define AIF_CTRL9_inst_adr                                                           "0x000C"
+#define AIF_CTRL9_inst                                                               0x000C
+#define AIF_CTRL9_reg_resvrl_shift                                                   (8)
+#define AIF_CTRL9_reg_resvrl_mask                                                    (0xFFFFFF00)
+#define AIF_CTRL9_reg_resvrl(data)                                                   (0xFFFFFF00&((data)<<8))
+#define AIF_CTRL9_reg_resvrl_src(data)                                               ((0xFFFFFF00&(data))>>8)
+#define AIF_CTRL9_get_reg_resvrl(data)                                               ((0xFFFFFF00&(data))>>8)
+
+
+#define AIF_CTRLA                                                                    0x18009034
+#define AIF_CTRLA_reg_addr                                                           "0xB8009034"
+#define AIF_CTRLA_reg                                                                0xB8009034
+#define set_AIF_CTRLA_reg(data)   (*((volatile unsigned int*) AIF_CTRLA_reg)=data)
+#define get_AIF_CTRLA_reg   (*((volatile unsigned int*) AIF_CTRLA_reg))
+#define AIF_CTRLA_inst_adr                                                           "0x000D"
+#define AIF_CTRLA_inst                                                               0x000D
+
+
+#define AIF_CTRLB                                                                    0x18009038
+#define AIF_CTRLB_reg_addr                                                           "0xB8009038"
+#define AIF_CTRLB_reg                                                                0xB8009038
+#define set_AIF_CTRLB_reg(data)   (*((volatile unsigned int*) AIF_CTRLB_reg)=data)
+#define get_AIF_CTRLB_reg   (*((volatile unsigned int*) AIF_CTRLB_reg))
+#define AIF_CTRLB_inst_adr                                                           "0x000E"
+#define AIF_CTRLB_inst                                                               0x000E
+#define AIF_CTRLB_reg_slew_shift                                                     (8)
+#define AIF_CTRLB_reg_slew_mask                                                      (0xFFFFFF00)
+#define AIF_CTRLB_reg_slew(data)                                                     (0xFFFFFF00&((data)<<8))
+#define AIF_CTRLB_reg_slew_src(data)                                                 ((0xFFFFFF00&(data))>>8)
+#define AIF_CTRLB_get_reg_slew(data)                                                 ((0xFFFFFF00&(data))>>8)
+
+
+#define AIF_CTRLC                                                                    0x18009040
+#define AIF_CTRLC_reg_addr                                                           "0xB8009040"
+#define AIF_CTRLC_reg                                                                0xB8009040
+#define set_AIF_CTRLC_reg(data)   (*((volatile unsigned int*) AIF_CTRLC_reg)=data)
+#define get_AIF_CTRLC_reg   (*((volatile unsigned int*) AIF_CTRLC_reg))
+#define AIF_CTRLC_inst_adr                                                           "0x0010"
+#define AIF_CTRLC_inst                                                               0x0010
+#define AIF_CTRLC_reg_shapeh_shift                                                   (0)
+#define AIF_CTRLC_reg_shapeh_mask                                                    (0xFFFFFFFF)
+#define AIF_CTRLC_reg_shapeh(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define AIF_CTRLC_reg_shapeh_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define AIF_CTRLC_get_reg_shapeh(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define AIF_CTRLD                                                                    0x18009044
+#define AIF_CTRLD_reg_addr                                                           "0xB8009044"
+#define AIF_CTRLD_reg                                                                0xB8009044
+#define set_AIF_CTRLD_reg(data)   (*((volatile unsigned int*) AIF_CTRLD_reg)=data)
+#define get_AIF_CTRLD_reg   (*((volatile unsigned int*) AIF_CTRLD_reg))
+#define AIF_CTRLD_inst_adr                                                           "0x0011"
+#define AIF_CTRLD_inst                                                               0x0011
+#define AIF_CTRLD_reg_shapel_shift                                                   (0)
+#define AIF_CTRLD_reg_shapel_mask                                                    (0x0000000F)
+#define AIF_CTRLD_reg_shapel(data)                                                   (0x0000000F&((data)<<0))
+#define AIF_CTRLD_reg_shapel_src(data)                                               ((0x0000000F&(data))>>0)
+#define AIF_CTRLD_get_reg_shapel(data)                                               ((0x0000000F&(data))>>0)
+
+
+#define AIF_CTRLE                                                                    0x18009048
+#define AIF_CTRLE_reg_addr                                                           "0xB8009048"
+#define AIF_CTRLE_reg                                                                0xB8009048
+#define set_AIF_CTRLE_reg(data)   (*((volatile unsigned int*) AIF_CTRLE_reg)=data)
+#define get_AIF_CTRLE_reg   (*((volatile unsigned int*) AIF_CTRLE_reg))
+#define AIF_CTRLE_inst_adr                                                           "0x0012"
+#define AIF_CTRLE_inst                                                               0x0012
+#define AIF_CTRLE_reg_wdol_shift                                                     (0)
+#define AIF_CTRLE_reg_wdol_mask                                                      (0x00000001)
+#define AIF_CTRLE_reg_wdol(data)                                                     (0x00000001&((data)<<0))
+#define AIF_CTRLE_reg_wdol_src(data)                                                 ((0x00000001&(data))>>0)
+#define AIF_CTRLE_get_reg_wdol(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define AIF_CTRLF                                                                    0x1800904C
+#define AIF_CTRLF_reg_addr                                                           "0xB800904C"
+#define AIF_CTRLF_reg                                                                0xB800904C
+#define set_AIF_CTRLF_reg(data)   (*((volatile unsigned int*) AIF_CTRLF_reg)=data)
+#define get_AIF_CTRLF_reg   (*((volatile unsigned int*) AIF_CTRLF_reg))
+#define AIF_CTRLF_inst_adr                                                           "0x0013"
+#define AIF_CTRLF_inst                                                               0x0013
+#define AIF_CTRLF_reg_pll_ldo_powl_shift                                             (0)
+#define AIF_CTRLF_reg_pll_ldo_powl_mask                                              (0x00000001)
+#define AIF_CTRLF_reg_pll_ldo_powl(data)                                             (0x00000001&((data)<<0))
+#define AIF_CTRLF_reg_pll_ldo_powl_src(data)                                         ((0x00000001&(data))>>0)
+#define AIF_CTRLF_get_reg_pll_ldo_powl(data)                                         ((0x00000001&(data))>>0)
+
+
+#define AIF_TTLO                                                                     0x18009050
+#define AIF_TTLO_reg_addr                                                            "0xB8009050"
+#define AIF_TTLO_reg                                                                 0xB8009050
+#define set_AIF_TTLO_reg(data)   (*((volatile unsigned int*) AIF_TTLO_reg)=data)
+#define get_AIF_TTLO_reg   (*((volatile unsigned int*) AIF_TTLO_reg))
+#define AIF_TTLO_inst_adr                                                            "0x0014"
+#define AIF_TTLO_inst                                                                0x0014
+#define AIF_TTLO_orsdsttlinfl0_shift                                                 (22)
+#define AIF_TTLO_orsdsttlinfl0_mask                                                  (0x00C00000)
+#define AIF_TTLO_orsdsttlinfl0(data)                                                 (0x00C00000&((data)<<22))
+#define AIF_TTLO_orsdsttlinfl0_src(data)                                             ((0x00C00000&(data))>>22)
+#define AIF_TTLO_get_orsdsttlinfl0(data)                                             ((0x00C00000&(data))>>22)
+#define AIF_TTLO_orsdsttlinel0_shift                                                 (20)
+#define AIF_TTLO_orsdsttlinel0_mask                                                  (0x00300000)
+#define AIF_TTLO_orsdsttlinel0(data)                                                 (0x00300000&((data)<<20))
+#define AIF_TTLO_orsdsttlinel0_src(data)                                             ((0x00300000&(data))>>20)
+#define AIF_TTLO_get_orsdsttlinel0(data)                                             ((0x00300000&(data))>>20)
+#define AIF_TTLO_orsdsttlindl0_shift                                                 (18)
+#define AIF_TTLO_orsdsttlindl0_mask                                                  (0x000C0000)
+#define AIF_TTLO_orsdsttlindl0(data)                                                 (0x000C0000&((data)<<18))
+#define AIF_TTLO_orsdsttlindl0_src(data)                                             ((0x000C0000&(data))>>18)
+#define AIF_TTLO_get_orsdsttlindl0(data)                                             ((0x000C0000&(data))>>18)
+#define AIF_TTLO_orsdsttlincl0_shift                                                 (16)
+#define AIF_TTLO_orsdsttlincl0_mask                                                  (0x00030000)
+#define AIF_TTLO_orsdsttlincl0(data)                                                 (0x00030000&((data)<<16))
+#define AIF_TTLO_orsdsttlincl0_src(data)                                             ((0x00030000&(data))>>16)
+#define AIF_TTLO_get_orsdsttlincl0(data)                                             ((0x00030000&(data))>>16)
+#define AIF_TTLO_orsdsttlinbl0_shift                                                 (14)
+#define AIF_TTLO_orsdsttlinbl0_mask                                                  (0x0000C000)
+#define AIF_TTLO_orsdsttlinbl0(data)                                                 (0x0000C000&((data)<<14))
+#define AIF_TTLO_orsdsttlinbl0_src(data)                                             ((0x0000C000&(data))>>14)
+#define AIF_TTLO_get_orsdsttlinbl0(data)                                             ((0x0000C000&(data))>>14)
+#define AIF_TTLO_orsdsttlinal0_shift                                                 (12)
+#define AIF_TTLO_orsdsttlinal0_mask                                                  (0x00003000)
+#define AIF_TTLO_orsdsttlinal0(data)                                                 (0x00003000&((data)<<12))
+#define AIF_TTLO_orsdsttlinal0_src(data)                                             ((0x00003000&(data))>>12)
+#define AIF_TTLO_get_orsdsttlinal0(data)                                             ((0x00003000&(data))>>12)
+#define AIF_TTLO_ersdsttlinfl0_shift                                                 (10)
+#define AIF_TTLO_ersdsttlinfl0_mask                                                  (0x00000C00)
+#define AIF_TTLO_ersdsttlinfl0(data)                                                 (0x00000C00&((data)<<10))
+#define AIF_TTLO_ersdsttlinfl0_src(data)                                             ((0x00000C00&(data))>>10)
+#define AIF_TTLO_get_ersdsttlinfl0(data)                                             ((0x00000C00&(data))>>10)
+#define AIF_TTLO_ersdsttlinel0_shift                                                 (8)
+#define AIF_TTLO_ersdsttlinel0_mask                                                  (0x00000300)
+#define AIF_TTLO_ersdsttlinel0(data)                                                 (0x00000300&((data)<<8))
+#define AIF_TTLO_ersdsttlinel0_src(data)                                             ((0x00000300&(data))>>8)
+#define AIF_TTLO_get_ersdsttlinel0(data)                                             ((0x00000300&(data))>>8)
+#define AIF_TTLO_ersdsttlindl0_shift                                                 (6)
+#define AIF_TTLO_ersdsttlindl0_mask                                                  (0x000000C0)
+#define AIF_TTLO_ersdsttlindl0(data)                                                 (0x000000C0&((data)<<6))
+#define AIF_TTLO_ersdsttlindl0_src(data)                                             ((0x000000C0&(data))>>6)
+#define AIF_TTLO_get_ersdsttlindl0(data)                                             ((0x000000C0&(data))>>6)
+#define AIF_TTLO_ersdsttlincl0_shift                                                 (4)
+#define AIF_TTLO_ersdsttlincl0_mask                                                  (0x00000030)
+#define AIF_TTLO_ersdsttlincl0(data)                                                 (0x00000030&((data)<<4))
+#define AIF_TTLO_ersdsttlincl0_src(data)                                             ((0x00000030&(data))>>4)
+#define AIF_TTLO_get_ersdsttlincl0(data)                                             ((0x00000030&(data))>>4)
+#define AIF_TTLO_ersdsttlinbl0_shift                                                 (2)
+#define AIF_TTLO_ersdsttlinbl0_mask                                                  (0x0000000C)
+#define AIF_TTLO_ersdsttlinbl0(data)                                                 (0x0000000C&((data)<<2))
+#define AIF_TTLO_ersdsttlinbl0_src(data)                                             ((0x0000000C&(data))>>2)
+#define AIF_TTLO_get_ersdsttlinbl0(data)                                             ((0x0000000C&(data))>>2)
+#define AIF_TTLO_ersdsttlinal0_shift                                                 (0)
+#define AIF_TTLO_ersdsttlinal0_mask                                                  (0x00000003)
+#define AIF_TTLO_ersdsttlinal0(data)                                                 (0x00000003&((data)<<0))
+#define AIF_TTLO_ersdsttlinal0_src(data)                                             ((0x00000003&(data))>>0)
+#define AIF_TTLO_get_ersdsttlinal0(data)                                             ((0x00000003&(data))>>0)
+
+
+#define AIF_TTLI                                                                     0x18009054
+#define AIF_TTLI_reg_addr                                                            "0xB8009054"
+#define AIF_TTLI_reg                                                                 0xB8009054
+#define set_AIF_TTLI_reg(data)   (*((volatile unsigned int*) AIF_TTLI_reg)=data)
+#define get_AIF_TTLI_reg   (*((volatile unsigned int*) AIF_TTLI_reg))
+#define AIF_TTLI_inst_adr                                                            "0x0015"
+#define AIF_TTLI_inst                                                                0x0015
+#define AIF_TTLI_op2dfl0_shift                                                       (22)
+#define AIF_TTLI_op2dfl0_mask                                                        (0x00C00000)
+#define AIF_TTLI_op2dfl0(data)                                                       (0x00C00000&((data)<<22))
+#define AIF_TTLI_op2dfl0_src(data)                                                   ((0x00C00000&(data))>>22)
+#define AIF_TTLI_get_op2dfl0(data)                                                   ((0x00C00000&(data))>>22)
+#define AIF_TTLI_op2del0_shift                                                       (20)
+#define AIF_TTLI_op2del0_mask                                                        (0x00300000)
+#define AIF_TTLI_op2del0(data)                                                       (0x00300000&((data)<<20))
+#define AIF_TTLI_op2del0_src(data)                                                   ((0x00300000&(data))>>20)
+#define AIF_TTLI_get_op2del0(data)                                                   ((0x00300000&(data))>>20)
+#define AIF_TTLI_op2ddl0_shift                                                       (18)
+#define AIF_TTLI_op2ddl0_mask                                                        (0x000C0000)
+#define AIF_TTLI_op2ddl0(data)                                                       (0x000C0000&((data)<<18))
+#define AIF_TTLI_op2ddl0_src(data)                                                   ((0x000C0000&(data))>>18)
+#define AIF_TTLI_get_op2ddl0(data)                                                   ((0x000C0000&(data))>>18)
+#define AIF_TTLI_op2dcl0_shift                                                       (16)
+#define AIF_TTLI_op2dcl0_mask                                                        (0x00030000)
+#define AIF_TTLI_op2dcl0(data)                                                       (0x00030000&((data)<<16))
+#define AIF_TTLI_op2dcl0_src(data)                                                   ((0x00030000&(data))>>16)
+#define AIF_TTLI_get_op2dcl0(data)                                                   ((0x00030000&(data))>>16)
+#define AIF_TTLI_op2dbl0_shift                                                       (14)
+#define AIF_TTLI_op2dbl0_mask                                                        (0x0000C000)
+#define AIF_TTLI_op2dbl0(data)                                                       (0x0000C000&((data)<<14))
+#define AIF_TTLI_op2dbl0_src(data)                                                   ((0x0000C000&(data))>>14)
+#define AIF_TTLI_get_op2dbl0(data)                                                   ((0x0000C000&(data))>>14)
+#define AIF_TTLI_op2dal0_shift                                                       (12)
+#define AIF_TTLI_op2dal0_mask                                                        (0x00003000)
+#define AIF_TTLI_op2dal0(data)                                                       (0x00003000&((data)<<12))
+#define AIF_TTLI_op2dal0_src(data)                                                   ((0x00003000&(data))>>12)
+#define AIF_TTLI_get_op2dal0(data)                                                   ((0x00003000&(data))>>12)
+#define AIF_TTLI_ep2dfl0_shift                                                       (10)
+#define AIF_TTLI_ep2dfl0_mask                                                        (0x00000C00)
+#define AIF_TTLI_ep2dfl0(data)                                                       (0x00000C00&((data)<<10))
+#define AIF_TTLI_ep2dfl0_src(data)                                                   ((0x00000C00&(data))>>10)
+#define AIF_TTLI_get_ep2dfl0(data)                                                   ((0x00000C00&(data))>>10)
+#define AIF_TTLI_ep2del0_shift                                                       (8)
+#define AIF_TTLI_ep2del0_mask                                                        (0x00000300)
+#define AIF_TTLI_ep2del0(data)                                                       (0x00000300&((data)<<8))
+#define AIF_TTLI_ep2del0_src(data)                                                   ((0x00000300&(data))>>8)
+#define AIF_TTLI_get_ep2del0(data)                                                   ((0x00000300&(data))>>8)
+#define AIF_TTLI_ep2ddl0_shift                                                       (6)
+#define AIF_TTLI_ep2ddl0_mask                                                        (0x000000C0)
+#define AIF_TTLI_ep2ddl0(data)                                                       (0x000000C0&((data)<<6))
+#define AIF_TTLI_ep2ddl0_src(data)                                                   ((0x000000C0&(data))>>6)
+#define AIF_TTLI_get_ep2ddl0(data)                                                   ((0x000000C0&(data))>>6)
+#define AIF_TTLI_ep2dcl0_shift                                                       (4)
+#define AIF_TTLI_ep2dcl0_mask                                                        (0x00000030)
+#define AIF_TTLI_ep2dcl0(data)                                                       (0x00000030&((data)<<4))
+#define AIF_TTLI_ep2dcl0_src(data)                                                   ((0x00000030&(data))>>4)
+#define AIF_TTLI_get_ep2dcl0(data)                                                   ((0x00000030&(data))>>4)
+#define AIF_TTLI_ep2dbl0_shift                                                       (2)
+#define AIF_TTLI_ep2dbl0_mask                                                        (0x0000000C)
+#define AIF_TTLI_ep2dbl0(data)                                                       (0x0000000C&((data)<<2))
+#define AIF_TTLI_ep2dbl0_src(data)                                                   ((0x0000000C&(data))>>2)
+#define AIF_TTLI_get_ep2dbl0(data)                                                   ((0x0000000C&(data))>>2)
+#define AIF_TTLI_ep2dal0_shift                                                       (0)
+#define AIF_TTLI_ep2dal0_mask                                                        (0x00000003)
+#define AIF_TTLI_ep2dal0(data)                                                       (0x00000003&((data)<<0))
+#define AIF_TTLI_ep2dal0_src(data)                                                   ((0x00000003&(data))>>0)
+#define AIF_TTLI_get_ep2dal0(data)                                                   ((0x00000003&(data))>>0)
+
+
+#define AIF_CTRLG                                                                    0x18009058
+#define AIF_CTRLG_reg_addr                                                           "0xB8009058"
+#define AIF_CTRLG_reg                                                                0xB8009058
+#define set_AIF_CTRLG_reg(data)   (*((volatile unsigned int*) AIF_CTRLG_reg)=data)
+#define get_AIF_CTRLG_reg   (*((volatile unsigned int*) AIF_CTRLG_reg))
+#define AIF_CTRLG_inst_adr                                                           "0x0016"
+#define AIF_CTRLG_inst                                                               0x0016
+#define AIF_CTRLG_dummy_shift                                                        (0)
+#define AIF_CTRLG_dummy_mask                                                         (0xFFFFFFFF)
+#define AIF_CTRLG_dummy(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define AIF_CTRLG_dummy_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define AIF_CTRLG_get_dummy(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_dither_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_dither_reg.h
new file mode 100644
index 00000000..46cacc7
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_dither_reg.h
@@ -0,0 +1,3490 @@
+/**************************************************************
+// Spec Version                  : 1.0.6
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/4/11 16:51:21
+***************************************************************/
+
+
+#ifndef _DITHER_REG_H_INCLUDED_
+#define _DITHER_REG_H_INCLUDED_
+#ifdef  _DITHER_USE_STRUCT
+typedef struct 
+{
+unsigned int     Seq_2nd_B_th:8;
+unsigned int     Seq_2nd_G_th:8;
+unsigned int     Seq_2nd_R_th:8;
+unsigned int     Seq_2nd_mode:1;
+unsigned int     reserved_0:1;
+unsigned int     Function_Enable:1;
+unsigned int     Temporal_Enable:1;
+unsigned int     Value_Sign:1;
+unsigned int     Dithering_Mode:1;
+unsigned int     V_Modulation:1;
+unsigned int     H_Modulation:1;
+}DITHERING_CTRL;
+
+typedef struct 
+{
+unsigned int     Seq_R_7:4;
+unsigned int     Seq_R_6:4;
+unsigned int     Seq_R_5:4;
+unsigned int     Seq_R_4:4;
+unsigned int     Seq_R_3:4;
+unsigned int     Seq_R_2:4;
+unsigned int     Seq_R_1:4;
+unsigned int     Seq_R_0:4;
+}DITHERING_SEQ_R_0;
+
+typedef struct 
+{
+unsigned int     Seq_R_15:4;
+unsigned int     Seq_R_14:4;
+unsigned int     Seq_R_13:4;
+unsigned int     Seq_R_12:4;
+unsigned int     Seq_R_11:4;
+unsigned int     Seq_R_10:4;
+unsigned int     Seq_R_9:4;
+unsigned int     Seq_R_8:4;
+}DITHERING_SEQ_R_1;
+
+typedef struct 
+{
+unsigned int     Seq_R_23:4;
+unsigned int     Seq_R_22:4;
+unsigned int     Seq_R_21:4;
+unsigned int     Seq_R_20:4;
+unsigned int     Seq_R_19:4;
+unsigned int     Seq_R_18:4;
+unsigned int     Seq_R_17:4;
+unsigned int     Seq_R_16:4;
+}DITHERING_SEQ_R_2;
+
+typedef struct 
+{
+unsigned int     Seq_R_31:4;
+unsigned int     Seq_R_30:4;
+unsigned int     Seq_R_29:4;
+unsigned int     Seq_R_28:4;
+unsigned int     Seq_R_27:4;
+unsigned int     Seq_R_26:4;
+unsigned int     Seq_R_25:4;
+unsigned int     Seq_R_24:4;
+}DITHERING_SEQ_R_3;
+
+typedef struct 
+{
+unsigned int     Seq_G_7:4;
+unsigned int     Seq_G_6:4;
+unsigned int     Seq_G_5:4;
+unsigned int     Seq_G_4:4;
+unsigned int     Seq_G_3:4;
+unsigned int     Seq_G_2:4;
+unsigned int     Seq_G_1:4;
+unsigned int     Seq_G_0:4;
+}DITHERING_SEQ_G_0;
+
+typedef struct 
+{
+unsigned int     Seq_G_15:4;
+unsigned int     Seq_G_14:4;
+unsigned int     Seq_G_13:4;
+unsigned int     Seq_G_12:4;
+unsigned int     Seq_G_11:4;
+unsigned int     Seq_G_10:4;
+unsigned int     Seq_G_9:4;
+unsigned int     Seq_G_8:4;
+}DITHERING_SEQ_G_1;
+
+typedef struct 
+{
+unsigned int     Seq_G_23:4;
+unsigned int     Seq_G_22:4;
+unsigned int     Seq_G_21:4;
+unsigned int     Seq_G_20:4;
+unsigned int     Seq_G_19:4;
+unsigned int     Seq_G_18:4;
+unsigned int     Seq_G_17:4;
+unsigned int     Seq_G_16:4;
+}DITHERING_SEQ_G_2;
+
+typedef struct 
+{
+unsigned int     Seq_G_31:4;
+unsigned int     Seq_G_30:4;
+unsigned int     Seq_G_29:4;
+unsigned int     Seq_G_28:4;
+unsigned int     Seq_G_27:4;
+unsigned int     Seq_G_26:4;
+unsigned int     Seq_G_25:4;
+unsigned int     Seq_G_24:4;
+}DITHERING_SEQ_G_3;
+
+typedef struct 
+{
+unsigned int     Seq_B_7:4;
+unsigned int     Seq_B_6:4;
+unsigned int     Seq_B_5:4;
+unsigned int     Seq_B_4:4;
+unsigned int     Seq_B_3:4;
+unsigned int     Seq_B_2:4;
+unsigned int     Seq_B_1:4;
+unsigned int     Seq_B_0:4;
+}DITHERING_SEQ_B_0;
+
+typedef struct 
+{
+unsigned int     Seq_B_15:4;
+unsigned int     Seq_B_14:4;
+unsigned int     Seq_B_13:4;
+unsigned int     Seq_B_12:4;
+unsigned int     Seq_B_11:4;
+unsigned int     Seq_B_10:4;
+unsigned int     Seq_B_9:4;
+unsigned int     Seq_B_8:4;
+}DITHERING_SEQ_B_1;
+
+typedef struct 
+{
+unsigned int     Seq_B_23:4;
+unsigned int     Seq_B_22:4;
+unsigned int     Seq_B_21:4;
+unsigned int     Seq_B_20:4;
+unsigned int     Seq_B_19:4;
+unsigned int     Seq_B_18:4;
+unsigned int     Seq_B_17:4;
+unsigned int     Seq_B_16:4;
+}DITHERING_SEQ_B_2;
+
+typedef struct 
+{
+unsigned int     Seq_B_31:4;
+unsigned int     Seq_B_30:4;
+unsigned int     Seq_B_29:4;
+unsigned int     Seq_B_28:4;
+unsigned int     Seq_B_27:4;
+unsigned int     Seq_B_26:4;
+unsigned int     Seq_B_25:4;
+unsigned int     Seq_B_24:4;
+}DITHERING_SEQ_B_3;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_03:6;
+unsigned int     Tab_R_02:6;
+unsigned int     Tab_R_01:6;
+unsigned int     Tab_R_00:6;
+}DITHERING_TAB_R_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_13:6;
+unsigned int     Tab_R_12:6;
+unsigned int     Tab_R_11:6;
+unsigned int     Tab_R_10:6;
+}DITHERING_TAB_R_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_23:6;
+unsigned int     Tab_R_22:6;
+unsigned int     Tab_R_21:6;
+unsigned int     Tab_R_20:6;
+}DITHERING_TAB_R_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_33:6;
+unsigned int     Tab_R_32:6;
+unsigned int     Tab_R_31:6;
+unsigned int     Tab_R_30:6;
+}DITHERING_TAB_R_3;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_43:6;
+unsigned int     Tab_R_42:6;
+unsigned int     Tab_R_41:6;
+unsigned int     Tab_R_40:6;
+}DITHERING_TAB_R_4;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_53:6;
+unsigned int     Tab_R_52:6;
+unsigned int     Tab_R_51:6;
+unsigned int     Tab_R_50:6;
+}DITHERING_TAB_R_5;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_63:6;
+unsigned int     Tab_R_62:6;
+unsigned int     Tab_R_61:6;
+unsigned int     Tab_R_60:6;
+}DITHERING_TAB_R_6;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_73:6;
+unsigned int     Tab_R_72:6;
+unsigned int     Tab_R_71:6;
+unsigned int     Tab_R_70:6;
+}DITHERING_TAB_R_7;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_83:6;
+unsigned int     Tab_R_82:6;
+unsigned int     Tab_R_81:6;
+unsigned int     Tab_R_80:6;
+}DITHERING_TAB_R_8;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_93:6;
+unsigned int     Tab_R_92:6;
+unsigned int     Tab_R_91:6;
+unsigned int     Tab_R_90:6;
+}DITHERING_TAB_R_9;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_A3:6;
+unsigned int     Tab_R_A2:6;
+unsigned int     Tab_R_A1:6;
+unsigned int     Tab_R_A0:6;
+}DITHERING_TAB_R_10;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_B3:6;
+unsigned int     Tab_R_B2:6;
+unsigned int     Tab_R_B1:6;
+unsigned int     Tab_R_B0:6;
+}DITHERING_TAB_R_11;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_C3:6;
+unsigned int     Tab_R_C2:6;
+unsigned int     Tab_R_C1:6;
+unsigned int     Tab_R_C0:6;
+}DITHERING_TAB_R_12;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_D3:6;
+unsigned int     Tab_R_D2:6;
+unsigned int     Tab_R_D1:6;
+unsigned int     Tab_R_D0:6;
+}DITHERING_TAB_R_13;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_E3:6;
+unsigned int     Tab_R_E2:6;
+unsigned int     Tab_R_E1:6;
+unsigned int     Tab_R_E0:6;
+}DITHERING_TAB_R_14;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_R_F3:6;
+unsigned int     Tab_R_F2:6;
+unsigned int     Tab_R_F1:6;
+unsigned int     Tab_R_F0:6;
+}DITHERING_TAB_R_15;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_03:6;
+unsigned int     Tab_G_02:6;
+unsigned int     Tab_G_01:6;
+unsigned int     Tab_G_00:6;
+}DITHERING_TAB_G_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_13:6;
+unsigned int     Tab_G_12:6;
+unsigned int     Tab_G_11:6;
+unsigned int     Tab_G_10:6;
+}DITHERING_TAB_G_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_23:6;
+unsigned int     Tab_G_22:6;
+unsigned int     Tab_G_21:6;
+unsigned int     Tab_G_20:6;
+}DITHERING_TAB_G_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_33:6;
+unsigned int     Tab_G_32:6;
+unsigned int     Tab_G_31:6;
+unsigned int     Tab_G_30:6;
+}DITHERING_TAB_G_3;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_43:6;
+unsigned int     Tab_G_42:6;
+unsigned int     Tab_G_41:6;
+unsigned int     Tab_G_40:6;
+}DITHERING_TAB_G_4;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_53:6;
+unsigned int     Tab_G_52:6;
+unsigned int     Tab_G_51:6;
+unsigned int     Tab_G_50:6;
+}DITHERING_TAB_G_5;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_63:6;
+unsigned int     Tab_G_62:6;
+unsigned int     Tab_G_61:6;
+unsigned int     Tab_G_60:6;
+}DITHERING_TAB_G_6;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_73:6;
+unsigned int     Tab_G_72:6;
+unsigned int     Tab_G_71:6;
+unsigned int     Tab_G_70:6;
+}DITHERING_TAB_G_7;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_83:6;
+unsigned int     Tab_G_82:6;
+unsigned int     Tab_G_81:6;
+unsigned int     Tab_G_80:6;
+}DITHERING_TAB_G_8;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_93:6;
+unsigned int     Tab_G_92:6;
+unsigned int     Tab_G_91:6;
+unsigned int     Tab_G_90:6;
+}DITHERING_TAB_G_9;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_A3:6;
+unsigned int     Tab_G_A2:6;
+unsigned int     Tab_G_A1:6;
+unsigned int     Tab_G_A0:6;
+}DITHERING_TAB_G_10;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_B3:6;
+unsigned int     Tab_G_B2:6;
+unsigned int     Tab_G_B1:6;
+unsigned int     Tab_G_B0:6;
+}DITHERING_TAB_G_11;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_C3:6;
+unsigned int     Tab_G_C2:6;
+unsigned int     Tab_G_C1:6;
+unsigned int     Tab_G_C0:6;
+}DITHERING_TAB_G_12;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_D3:6;
+unsigned int     Tab_G_D2:6;
+unsigned int     Tab_G_D1:6;
+unsigned int     Tab_G_D0:6;
+}DITHERING_TAB_G_13;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_E3:6;
+unsigned int     Tab_G_E2:6;
+unsigned int     Tab_G_E1:6;
+unsigned int     Tab_G_E0:6;
+}DITHERING_TAB_G_14;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_G_F3:6;
+unsigned int     Tab_G_F2:6;
+unsigned int     Tab_G_F1:6;
+unsigned int     Tab_G_F0:6;
+}DITHERING_TAB_G_15;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_03:6;
+unsigned int     Tab_B_02:6;
+unsigned int     Tab_B_01:6;
+unsigned int     Tab_B_00:6;
+}DITHERING_TAB_B_0;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_13:6;
+unsigned int     Tab_B_12:6;
+unsigned int     Tab_B_11:6;
+unsigned int     Tab_B_10:6;
+}DITHERING_TAB_B_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_23:6;
+unsigned int     Tab_B_22:6;
+unsigned int     Tab_B_21:6;
+unsigned int     Tab_B_20:6;
+}DITHERING_TAB_B_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_33:6;
+unsigned int     Tab_B_32:6;
+unsigned int     Tab_B_31:6;
+unsigned int     Tab_B_30:6;
+}DITHERING_TAB_B_3;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_43:6;
+unsigned int     Tab_B_42:6;
+unsigned int     Tab_B_41:6;
+unsigned int     Tab_B_40:6;
+}DITHERING_TAB_B_4;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_53:6;
+unsigned int     Tab_B_52:6;
+unsigned int     Tab_B_51:6;
+unsigned int     Tab_B_50:6;
+}DITHERING_TAB_B_5;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_63:6;
+unsigned int     Tab_B_62:6;
+unsigned int     Tab_B_61:6;
+unsigned int     Tab_B_60:6;
+}DITHERING_TAB_B_6;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_73:6;
+unsigned int     Tab_B_72:6;
+unsigned int     Tab_B_71:6;
+unsigned int     Tab_B_70:6;
+}DITHERING_TAB_B_7;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_83:6;
+unsigned int     Tab_B_82:6;
+unsigned int     Tab_B_81:6;
+unsigned int     Tab_B_80:6;
+}DITHERING_TAB_B_8;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_93:6;
+unsigned int     Tab_B_92:6;
+unsigned int     Tab_B_91:6;
+unsigned int     Tab_B_90:6;
+}DITHERING_TAB_B_9;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_A3:6;
+unsigned int     Tab_B_A2:6;
+unsigned int     Tab_B_A1:6;
+unsigned int     Tab_B_A0:6;
+}DITHERING_TAB_B_10;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_B3:6;
+unsigned int     Tab_B_B2:6;
+unsigned int     Tab_B_B1:6;
+unsigned int     Tab_B_B0:6;
+}DITHERING_TAB_B_11;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_C3:6;
+unsigned int     Tab_B_C2:6;
+unsigned int     Tab_B_C1:6;
+unsigned int     Tab_B_C0:6;
+}DITHERING_TAB_B_12;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_D3:6;
+unsigned int     Tab_B_D2:6;
+unsigned int     Tab_B_D1:6;
+unsigned int     Tab_B_D0:6;
+}DITHERING_TAB_B_13;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_E3:6;
+unsigned int     Tab_B_E2:6;
+unsigned int     Tab_B_E1:6;
+unsigned int     Tab_B_E0:6;
+}DITHERING_TAB_B_14;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Tab_B_F3:6;
+unsigned int     Tab_B_F2:6;
+unsigned int     Tab_B_F1:6;
+unsigned int     Tab_B_F0:6;
+}DITHERING_TAB_B_15;
+
+typedef struct 
+{
+unsigned int     Temp_offset_15:2;
+unsigned int     Temp_offset_14:2;
+unsigned int     Temp_offset_13:2;
+unsigned int     Temp_offset_12:2;
+unsigned int     Temp_offset_11:2;
+unsigned int     Temp_offset_10:2;
+unsigned int     Temp_offset_9:2;
+unsigned int     Temp_offset_8:2;
+unsigned int     Temp_offset_7:2;
+unsigned int     Temp_offset_6:2;
+unsigned int     Temp_offset_5:2;
+unsigned int     Temp_offset_4:2;
+unsigned int     Temp_offset_3:2;
+unsigned int     Temp_offset_2:2;
+unsigned int     Temp_offset_1:2;
+unsigned int     Temp_offset_0:2;
+}TEMPORAL_OFFSET;
+
+typedef struct 
+{
+unsigned int     Seq_R_7:4;
+unsigned int     Seq_R_6:4;
+unsigned int     Seq_R_5:4;
+unsigned int     Seq_R_4:4;
+unsigned int     Seq_R_3:4;
+unsigned int     Seq_R_2:4;
+unsigned int     Seq_R_1:4;
+unsigned int     Seq_R_0:4;
+}DITHERING_2ND_SEQ_R_0;
+
+typedef struct 
+{
+unsigned int     Seq_R_15:4;
+unsigned int     Seq_R_14:4;
+unsigned int     Seq_R_13:4;
+unsigned int     Seq_R_12:4;
+unsigned int     Seq_R_11:4;
+unsigned int     Seq_R_10:4;
+unsigned int     Seq_R_9:4;
+unsigned int     Seq_R_8:4;
+}DITHERING_2ND_SEQ_R_1;
+
+typedef struct 
+{
+unsigned int     Seq_R_23:4;
+unsigned int     Seq_R_22:4;
+unsigned int     Seq_R_21:4;
+unsigned int     Seq_R_20:4;
+unsigned int     Seq_R_19:4;
+unsigned int     Seq_R_18:4;
+unsigned int     Seq_R_17:4;
+unsigned int     Seq_R_16:4;
+}DITHERING_2ND_SEQ_R_2;
+
+typedef struct 
+{
+unsigned int     Seq_R_31:4;
+unsigned int     Seq_R_30:4;
+unsigned int     Seq_R_29:4;
+unsigned int     Seq_R_28:4;
+unsigned int     Seq_R_27:4;
+unsigned int     Seq_R_26:4;
+unsigned int     Seq_R_25:4;
+unsigned int     Seq_R_24:4;
+}DITHERING_2ND_SEQ_R_3;
+
+typedef struct 
+{
+unsigned int     Seq_G_7:4;
+unsigned int     Seq_G_6:4;
+unsigned int     Seq_G_5:4;
+unsigned int     Seq_G_4:4;
+unsigned int     Seq_G_3:4;
+unsigned int     Seq_G_2:4;
+unsigned int     Seq_G_1:4;
+unsigned int     Seq_G_0:4;
+}DITHERING_2ND_SEQ_G_0;
+
+typedef struct 
+{
+unsigned int     Seq_G_15:4;
+unsigned int     Seq_G_14:4;
+unsigned int     Seq_G_13:4;
+unsigned int     Seq_G_12:4;
+unsigned int     Seq_G_11:4;
+unsigned int     Seq_G_10:4;
+unsigned int     Seq_G_9:4;
+unsigned int     Seq_G_8:4;
+}DITHERING_2ND_SEQ_G_1;
+
+typedef struct 
+{
+unsigned int     Seq_G_23:4;
+unsigned int     Seq_G_22:4;
+unsigned int     Seq_G_21:4;
+unsigned int     Seq_G_20:4;
+unsigned int     Seq_G_19:4;
+unsigned int     Seq_G_18:4;
+unsigned int     Seq_G_17:4;
+unsigned int     Seq_G_16:4;
+}DITHERING_2ND_SEQ_G_2;
+
+typedef struct 
+{
+unsigned int     Seq_G_31:4;
+unsigned int     Seq_G_30:4;
+unsigned int     Seq_G_29:4;
+unsigned int     Seq_G_28:4;
+unsigned int     Seq_G_27:4;
+unsigned int     Seq_G_26:4;
+unsigned int     Seq_G_25:4;
+unsigned int     Seq_G_24:4;
+}DITHERING_2ND_SEQ_G_3;
+
+typedef struct 
+{
+unsigned int     Seq_B_7:4;
+unsigned int     Seq_B_6:4;
+unsigned int     Seq_B_5:4;
+unsigned int     Seq_B_4:4;
+unsigned int     Seq_B_3:4;
+unsigned int     Seq_B_2:4;
+unsigned int     Seq_B_1:4;
+unsigned int     Seq_B_0:4;
+}DITHERING_2ND_SEQ_B_0;
+
+typedef struct 
+{
+unsigned int     Seq_B_15:4;
+unsigned int     Seq_B_14:4;
+unsigned int     Seq_B_13:4;
+unsigned int     Seq_B_12:4;
+unsigned int     Seq_B_11:4;
+unsigned int     Seq_B_10:4;
+unsigned int     Seq_B_9:4;
+unsigned int     Seq_B_8:4;
+}DITHERING_2ND_SEQ_B_1;
+
+typedef struct 
+{
+unsigned int     Seq_B_23:4;
+unsigned int     Seq_B_22:4;
+unsigned int     Seq_B_21:4;
+unsigned int     Seq_B_20:4;
+unsigned int     Seq_B_19:4;
+unsigned int     Seq_B_18:4;
+unsigned int     Seq_B_17:4;
+unsigned int     Seq_B_16:4;
+}DITHERING_2ND_SEQ_B_2;
+
+typedef struct 
+{
+unsigned int     Seq_B_31:4;
+unsigned int     Seq_B_30:4;
+unsigned int     Seq_B_29:4;
+unsigned int     Seq_B_28:4;
+unsigned int     Seq_B_27:4;
+unsigned int     Seq_B_26:4;
+unsigned int     Seq_B_25:4;
+unsigned int     Seq_B_24:4;
+}DITHERING_2ND_SEQ_B_3;
+
+#endif
+
+#define DITHERING_CTRL                                                               0x180098b4
+#define DITHERING_CTRL_reg_addr                                                      "0xB80098B4"
+#define DITHERING_CTRL_reg                                                           0xB80098B4
+#define set_DITHERING_CTRL_reg(data)   (*((volatile unsigned int*) DITHERING_CTRL_reg)=data)
+#define get_DITHERING_CTRL_reg   (*((volatile unsigned int*) DITHERING_CTRL_reg))
+#define DITHERING_CTRL_inst_adr                                                      "0x002D"
+#define DITHERING_CTRL_inst                                                          0x002D
+#define DITHERING_CTRL_Seq_2nd_B_th_shift                                            (24)
+#define DITHERING_CTRL_Seq_2nd_B_th_mask                                             (0xFF000000)
+#define DITHERING_CTRL_Seq_2nd_B_th(data)                                            (0xFF000000&((data)<<24))
+#define DITHERING_CTRL_Seq_2nd_B_th_src(data)                                        ((0xFF000000&(data))>>24)
+#define DITHERING_CTRL_get_Seq_2nd_B_th(data)                                        ((0xFF000000&(data))>>24)
+#define DITHERING_CTRL_Seq_2nd_G_th_shift                                            (16)
+#define DITHERING_CTRL_Seq_2nd_G_th_mask                                             (0x00FF0000)
+#define DITHERING_CTRL_Seq_2nd_G_th(data)                                            (0x00FF0000&((data)<<16))
+#define DITHERING_CTRL_Seq_2nd_G_th_src(data)                                        ((0x00FF0000&(data))>>16)
+#define DITHERING_CTRL_get_Seq_2nd_G_th(data)                                        ((0x00FF0000&(data))>>16)
+#define DITHERING_CTRL_Seq_2nd_R_th_shift                                            (8)
+#define DITHERING_CTRL_Seq_2nd_R_th_mask                                             (0x0000FF00)
+#define DITHERING_CTRL_Seq_2nd_R_th(data)                                            (0x0000FF00&((data)<<8))
+#define DITHERING_CTRL_Seq_2nd_R_th_src(data)                                        ((0x0000FF00&(data))>>8)
+#define DITHERING_CTRL_get_Seq_2nd_R_th(data)                                        ((0x0000FF00&(data))>>8)
+#define DITHERING_CTRL_Seq_2nd_mode_shift                                            (7)
+#define DITHERING_CTRL_Seq_2nd_mode_mask                                             (0x00000080)
+#define DITHERING_CTRL_Seq_2nd_mode(data)                                            (0x00000080&((data)<<7))
+#define DITHERING_CTRL_Seq_2nd_mode_src(data)                                        ((0x00000080&(data))>>7)
+#define DITHERING_CTRL_get_Seq_2nd_mode(data)                                        ((0x00000080&(data))>>7)
+#define DITHERING_CTRL_Function_Enable_shift                                         (5)
+#define DITHERING_CTRL_Function_Enable_mask                                          (0x00000020)
+#define DITHERING_CTRL_Function_Enable(data)                                         (0x00000020&((data)<<5))
+#define DITHERING_CTRL_Function_Enable_src(data)                                     ((0x00000020&(data))>>5)
+#define DITHERING_CTRL_get_Function_Enable(data)                                     ((0x00000020&(data))>>5)
+#define DITHERING_CTRL_Temporal_Enable_shift                                         (4)
+#define DITHERING_CTRL_Temporal_Enable_mask                                          (0x00000010)
+#define DITHERING_CTRL_Temporal_Enable(data)                                         (0x00000010&((data)<<4))
+#define DITHERING_CTRL_Temporal_Enable_src(data)                                     ((0x00000010&(data))>>4)
+#define DITHERING_CTRL_get_Temporal_Enable(data)                                     ((0x00000010&(data))>>4)
+#define DITHERING_CTRL_Value_Sign_shift                                              (3)
+#define DITHERING_CTRL_Value_Sign_mask                                               (0x00000008)
+#define DITHERING_CTRL_Value_Sign(data)                                              (0x00000008&((data)<<3))
+#define DITHERING_CTRL_Value_Sign_src(data)                                          ((0x00000008&(data))>>3)
+#define DITHERING_CTRL_get_Value_Sign(data)                                          ((0x00000008&(data))>>3)
+#define DITHERING_CTRL_Dithering_Mode_shift                                          (2)
+#define DITHERING_CTRL_Dithering_Mode_mask                                           (0x00000004)
+#define DITHERING_CTRL_Dithering_Mode(data)                                          (0x00000004&((data)<<2))
+#define DITHERING_CTRL_Dithering_Mode_src(data)                                      ((0x00000004&(data))>>2)
+#define DITHERING_CTRL_get_Dithering_Mode(data)                                      ((0x00000004&(data))>>2)
+#define DITHERING_CTRL_V_Modulation_shift                                            (1)
+#define DITHERING_CTRL_V_Modulation_mask                                             (0x00000002)
+#define DITHERING_CTRL_V_Modulation(data)                                            (0x00000002&((data)<<1))
+#define DITHERING_CTRL_V_Modulation_src(data)                                        ((0x00000002&(data))>>1)
+#define DITHERING_CTRL_get_V_Modulation(data)                                        ((0x00000002&(data))>>1)
+#define DITHERING_CTRL_H_Modulation_shift                                            (0)
+#define DITHERING_CTRL_H_Modulation_mask                                             (0x00000001)
+#define DITHERING_CTRL_H_Modulation(data)                                            (0x00000001&((data)<<0))
+#define DITHERING_CTRL_H_Modulation_src(data)                                        ((0x00000001&(data))>>0)
+#define DITHERING_CTRL_get_H_Modulation(data)                                        ((0x00000001&(data))>>0)
+
+
+#define DITHERING_SEQ_R_0                                                            0x180098b8
+#define DITHERING_SEQ_R_0_reg_addr                                                   "0xB80098B8"
+#define DITHERING_SEQ_R_0_reg                                                        0xB80098B8
+#define set_DITHERING_SEQ_R_0_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_R_0_reg)=data)
+#define get_DITHERING_SEQ_R_0_reg   (*((volatile unsigned int*) DITHERING_SEQ_R_0_reg))
+#define DITHERING_SEQ_R_0_inst_adr                                                   "0x002E"
+#define DITHERING_SEQ_R_0_inst                                                       0x002E
+#define DITHERING_SEQ_R_0_Seq_R_7_shift                                              (28)
+#define DITHERING_SEQ_R_0_Seq_R_7_mask                                               (0xF0000000)
+#define DITHERING_SEQ_R_0_Seq_R_7(data)                                              (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_R_0_Seq_R_7_src(data)                                          ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_R_0_get_Seq_R_7(data)                                          ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_R_0_Seq_R_6_shift                                              (24)
+#define DITHERING_SEQ_R_0_Seq_R_6_mask                                               (0x0F000000)
+#define DITHERING_SEQ_R_0_Seq_R_6(data)                                              (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_R_0_Seq_R_6_src(data)                                          ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_R_0_get_Seq_R_6(data)                                          ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_R_0_Seq_R_5_shift                                              (20)
+#define DITHERING_SEQ_R_0_Seq_R_5_mask                                               (0x00F00000)
+#define DITHERING_SEQ_R_0_Seq_R_5(data)                                              (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_R_0_Seq_R_5_src(data)                                          ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_R_0_get_Seq_R_5(data)                                          ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_R_0_Seq_R_4_shift                                              (16)
+#define DITHERING_SEQ_R_0_Seq_R_4_mask                                               (0x000F0000)
+#define DITHERING_SEQ_R_0_Seq_R_4(data)                                              (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_R_0_Seq_R_4_src(data)                                          ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_R_0_get_Seq_R_4(data)                                          ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_R_0_Seq_R_3_shift                                              (12)
+#define DITHERING_SEQ_R_0_Seq_R_3_mask                                               (0x0000F000)
+#define DITHERING_SEQ_R_0_Seq_R_3(data)                                              (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_R_0_Seq_R_3_src(data)                                          ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_R_0_get_Seq_R_3(data)                                          ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_R_0_Seq_R_2_shift                                              (8)
+#define DITHERING_SEQ_R_0_Seq_R_2_mask                                               (0x00000F00)
+#define DITHERING_SEQ_R_0_Seq_R_2(data)                                              (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_R_0_Seq_R_2_src(data)                                          ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_R_0_get_Seq_R_2(data)                                          ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_R_0_Seq_R_1_shift                                              (4)
+#define DITHERING_SEQ_R_0_Seq_R_1_mask                                               (0x000000F0)
+#define DITHERING_SEQ_R_0_Seq_R_1(data)                                              (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_R_0_Seq_R_1_src(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_R_0_get_Seq_R_1(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_R_0_Seq_R_0_shift                                              (0)
+#define DITHERING_SEQ_R_0_Seq_R_0_mask                                               (0x0000000F)
+#define DITHERING_SEQ_R_0_Seq_R_0(data)                                              (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_R_0_Seq_R_0_src(data)                                          ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_R_0_get_Seq_R_0(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_R_1                                                            0x180098bc
+#define DITHERING_SEQ_R_1_reg_addr                                                   "0xB80098BC"
+#define DITHERING_SEQ_R_1_reg                                                        0xB80098BC
+#define set_DITHERING_SEQ_R_1_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_R_1_reg)=data)
+#define get_DITHERING_SEQ_R_1_reg   (*((volatile unsigned int*) DITHERING_SEQ_R_1_reg))
+#define DITHERING_SEQ_R_1_inst_adr                                                   "0x002F"
+#define DITHERING_SEQ_R_1_inst                                                       0x002F
+#define DITHERING_SEQ_R_1_Seq_R_15_shift                                             (28)
+#define DITHERING_SEQ_R_1_Seq_R_15_mask                                              (0xF0000000)
+#define DITHERING_SEQ_R_1_Seq_R_15(data)                                             (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_R_1_Seq_R_15_src(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_R_1_get_Seq_R_15(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_R_1_Seq_R_14_shift                                             (24)
+#define DITHERING_SEQ_R_1_Seq_R_14_mask                                              (0x0F000000)
+#define DITHERING_SEQ_R_1_Seq_R_14(data)                                             (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_R_1_Seq_R_14_src(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_R_1_get_Seq_R_14(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_R_1_Seq_R_13_shift                                             (20)
+#define DITHERING_SEQ_R_1_Seq_R_13_mask                                              (0x00F00000)
+#define DITHERING_SEQ_R_1_Seq_R_13(data)                                             (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_R_1_Seq_R_13_src(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_R_1_get_Seq_R_13(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_R_1_Seq_R_12_shift                                             (16)
+#define DITHERING_SEQ_R_1_Seq_R_12_mask                                              (0x000F0000)
+#define DITHERING_SEQ_R_1_Seq_R_12(data)                                             (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_R_1_Seq_R_12_src(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_R_1_get_Seq_R_12(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_R_1_Seq_R_11_shift                                             (12)
+#define DITHERING_SEQ_R_1_Seq_R_11_mask                                              (0x0000F000)
+#define DITHERING_SEQ_R_1_Seq_R_11(data)                                             (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_R_1_Seq_R_11_src(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_R_1_get_Seq_R_11(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_R_1_Seq_R_10_shift                                             (8)
+#define DITHERING_SEQ_R_1_Seq_R_10_mask                                              (0x00000F00)
+#define DITHERING_SEQ_R_1_Seq_R_10(data)                                             (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_R_1_Seq_R_10_src(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_R_1_get_Seq_R_10(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_R_1_Seq_R_9_shift                                              (4)
+#define DITHERING_SEQ_R_1_Seq_R_9_mask                                               (0x000000F0)
+#define DITHERING_SEQ_R_1_Seq_R_9(data)                                              (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_R_1_Seq_R_9_src(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_R_1_get_Seq_R_9(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_R_1_Seq_R_8_shift                                              (0)
+#define DITHERING_SEQ_R_1_Seq_R_8_mask                                               (0x0000000F)
+#define DITHERING_SEQ_R_1_Seq_R_8(data)                                              (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_R_1_Seq_R_8_src(data)                                          ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_R_1_get_Seq_R_8(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_R_2                                                            0x180098c0
+#define DITHERING_SEQ_R_2_reg_addr                                                   "0xB80098C0"
+#define DITHERING_SEQ_R_2_reg                                                        0xB80098C0
+#define set_DITHERING_SEQ_R_2_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_R_2_reg)=data)
+#define get_DITHERING_SEQ_R_2_reg   (*((volatile unsigned int*) DITHERING_SEQ_R_2_reg))
+#define DITHERING_SEQ_R_2_inst_adr                                                   "0x0030"
+#define DITHERING_SEQ_R_2_inst                                                       0x0030
+#define DITHERING_SEQ_R_2_Seq_R_23_shift                                             (28)
+#define DITHERING_SEQ_R_2_Seq_R_23_mask                                              (0xF0000000)
+#define DITHERING_SEQ_R_2_Seq_R_23(data)                                             (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_R_2_Seq_R_23_src(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_R_2_get_Seq_R_23(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_R_2_Seq_R_22_shift                                             (24)
+#define DITHERING_SEQ_R_2_Seq_R_22_mask                                              (0x0F000000)
+#define DITHERING_SEQ_R_2_Seq_R_22(data)                                             (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_R_2_Seq_R_22_src(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_R_2_get_Seq_R_22(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_R_2_Seq_R_21_shift                                             (20)
+#define DITHERING_SEQ_R_2_Seq_R_21_mask                                              (0x00F00000)
+#define DITHERING_SEQ_R_2_Seq_R_21(data)                                             (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_R_2_Seq_R_21_src(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_R_2_get_Seq_R_21(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_R_2_Seq_R_20_shift                                             (16)
+#define DITHERING_SEQ_R_2_Seq_R_20_mask                                              (0x000F0000)
+#define DITHERING_SEQ_R_2_Seq_R_20(data)                                             (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_R_2_Seq_R_20_src(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_R_2_get_Seq_R_20(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_R_2_Seq_R_19_shift                                             (12)
+#define DITHERING_SEQ_R_2_Seq_R_19_mask                                              (0x0000F000)
+#define DITHERING_SEQ_R_2_Seq_R_19(data)                                             (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_R_2_Seq_R_19_src(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_R_2_get_Seq_R_19(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_R_2_Seq_R_18_shift                                             (8)
+#define DITHERING_SEQ_R_2_Seq_R_18_mask                                              (0x00000F00)
+#define DITHERING_SEQ_R_2_Seq_R_18(data)                                             (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_R_2_Seq_R_18_src(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_R_2_get_Seq_R_18(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_R_2_Seq_R_17_shift                                             (4)
+#define DITHERING_SEQ_R_2_Seq_R_17_mask                                              (0x000000F0)
+#define DITHERING_SEQ_R_2_Seq_R_17(data)                                             (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_R_2_Seq_R_17_src(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_R_2_get_Seq_R_17(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_R_2_Seq_R_16_shift                                             (0)
+#define DITHERING_SEQ_R_2_Seq_R_16_mask                                              (0x0000000F)
+#define DITHERING_SEQ_R_2_Seq_R_16(data)                                             (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_R_2_Seq_R_16_src(data)                                         ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_R_2_get_Seq_R_16(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_R_3                                                            0x180098c4
+#define DITHERING_SEQ_R_3_reg_addr                                                   "0xB80098C4"
+#define DITHERING_SEQ_R_3_reg                                                        0xB80098C4
+#define set_DITHERING_SEQ_R_3_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_R_3_reg)=data)
+#define get_DITHERING_SEQ_R_3_reg   (*((volatile unsigned int*) DITHERING_SEQ_R_3_reg))
+#define DITHERING_SEQ_R_3_inst_adr                                                   "0x0031"
+#define DITHERING_SEQ_R_3_inst                                                       0x0031
+#define DITHERING_SEQ_R_3_Seq_R_31_shift                                             (28)
+#define DITHERING_SEQ_R_3_Seq_R_31_mask                                              (0xF0000000)
+#define DITHERING_SEQ_R_3_Seq_R_31(data)                                             (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_R_3_Seq_R_31_src(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_R_3_get_Seq_R_31(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_R_3_Seq_R_30_shift                                             (24)
+#define DITHERING_SEQ_R_3_Seq_R_30_mask                                              (0x0F000000)
+#define DITHERING_SEQ_R_3_Seq_R_30(data)                                             (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_R_3_Seq_R_30_src(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_R_3_get_Seq_R_30(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_R_3_Seq_R_29_shift                                             (20)
+#define DITHERING_SEQ_R_3_Seq_R_29_mask                                              (0x00F00000)
+#define DITHERING_SEQ_R_3_Seq_R_29(data)                                             (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_R_3_Seq_R_29_src(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_R_3_get_Seq_R_29(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_R_3_Seq_R_28_shift                                             (16)
+#define DITHERING_SEQ_R_3_Seq_R_28_mask                                              (0x000F0000)
+#define DITHERING_SEQ_R_3_Seq_R_28(data)                                             (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_R_3_Seq_R_28_src(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_R_3_get_Seq_R_28(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_R_3_Seq_R_27_shift                                             (12)
+#define DITHERING_SEQ_R_3_Seq_R_27_mask                                              (0x0000F000)
+#define DITHERING_SEQ_R_3_Seq_R_27(data)                                             (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_R_3_Seq_R_27_src(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_R_3_get_Seq_R_27(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_R_3_Seq_R_26_shift                                             (8)
+#define DITHERING_SEQ_R_3_Seq_R_26_mask                                              (0x00000F00)
+#define DITHERING_SEQ_R_3_Seq_R_26(data)                                             (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_R_3_Seq_R_26_src(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_R_3_get_Seq_R_26(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_R_3_Seq_R_25_shift                                             (4)
+#define DITHERING_SEQ_R_3_Seq_R_25_mask                                              (0x000000F0)
+#define DITHERING_SEQ_R_3_Seq_R_25(data)                                             (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_R_3_Seq_R_25_src(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_R_3_get_Seq_R_25(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_R_3_Seq_R_24_shift                                             (0)
+#define DITHERING_SEQ_R_3_Seq_R_24_mask                                              (0x0000000F)
+#define DITHERING_SEQ_R_3_Seq_R_24(data)                                             (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_R_3_Seq_R_24_src(data)                                         ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_R_3_get_Seq_R_24(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_G_0                                                            0x180098c8
+#define DITHERING_SEQ_G_0_reg_addr                                                   "0xB80098C8"
+#define DITHERING_SEQ_G_0_reg                                                        0xB80098C8
+#define set_DITHERING_SEQ_G_0_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_G_0_reg)=data)
+#define get_DITHERING_SEQ_G_0_reg   (*((volatile unsigned int*) DITHERING_SEQ_G_0_reg))
+#define DITHERING_SEQ_G_0_inst_adr                                                   "0x0032"
+#define DITHERING_SEQ_G_0_inst                                                       0x0032
+#define DITHERING_SEQ_G_0_Seq_G_7_shift                                              (28)
+#define DITHERING_SEQ_G_0_Seq_G_7_mask                                               (0xF0000000)
+#define DITHERING_SEQ_G_0_Seq_G_7(data)                                              (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_G_0_Seq_G_7_src(data)                                          ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_G_0_get_Seq_G_7(data)                                          ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_G_0_Seq_G_6_shift                                              (24)
+#define DITHERING_SEQ_G_0_Seq_G_6_mask                                               (0x0F000000)
+#define DITHERING_SEQ_G_0_Seq_G_6(data)                                              (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_G_0_Seq_G_6_src(data)                                          ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_G_0_get_Seq_G_6(data)                                          ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_G_0_Seq_G_5_shift                                              (20)
+#define DITHERING_SEQ_G_0_Seq_G_5_mask                                               (0x00F00000)
+#define DITHERING_SEQ_G_0_Seq_G_5(data)                                              (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_G_0_Seq_G_5_src(data)                                          ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_G_0_get_Seq_G_5(data)                                          ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_G_0_Seq_G_4_shift                                              (16)
+#define DITHERING_SEQ_G_0_Seq_G_4_mask                                               (0x000F0000)
+#define DITHERING_SEQ_G_0_Seq_G_4(data)                                              (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_G_0_Seq_G_4_src(data)                                          ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_G_0_get_Seq_G_4(data)                                          ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_G_0_Seq_G_3_shift                                              (12)
+#define DITHERING_SEQ_G_0_Seq_G_3_mask                                               (0x0000F000)
+#define DITHERING_SEQ_G_0_Seq_G_3(data)                                              (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_G_0_Seq_G_3_src(data)                                          ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_G_0_get_Seq_G_3(data)                                          ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_G_0_Seq_G_2_shift                                              (8)
+#define DITHERING_SEQ_G_0_Seq_G_2_mask                                               (0x00000F00)
+#define DITHERING_SEQ_G_0_Seq_G_2(data)                                              (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_G_0_Seq_G_2_src(data)                                          ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_G_0_get_Seq_G_2(data)                                          ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_G_0_Seq_G_1_shift                                              (4)
+#define DITHERING_SEQ_G_0_Seq_G_1_mask                                               (0x000000F0)
+#define DITHERING_SEQ_G_0_Seq_G_1(data)                                              (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_G_0_Seq_G_1_src(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_G_0_get_Seq_G_1(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_G_0_Seq_G_0_shift                                              (0)
+#define DITHERING_SEQ_G_0_Seq_G_0_mask                                               (0x0000000F)
+#define DITHERING_SEQ_G_0_Seq_G_0(data)                                              (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_G_0_Seq_G_0_src(data)                                          ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_G_0_get_Seq_G_0(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_G_1                                                            0x180098cc
+#define DITHERING_SEQ_G_1_reg_addr                                                   "0xB80098CC"
+#define DITHERING_SEQ_G_1_reg                                                        0xB80098CC
+#define set_DITHERING_SEQ_G_1_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_G_1_reg)=data)
+#define get_DITHERING_SEQ_G_1_reg   (*((volatile unsigned int*) DITHERING_SEQ_G_1_reg))
+#define DITHERING_SEQ_G_1_inst_adr                                                   "0x0033"
+#define DITHERING_SEQ_G_1_inst                                                       0x0033
+#define DITHERING_SEQ_G_1_Seq_G_15_shift                                             (28)
+#define DITHERING_SEQ_G_1_Seq_G_15_mask                                              (0xF0000000)
+#define DITHERING_SEQ_G_1_Seq_G_15(data)                                             (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_G_1_Seq_G_15_src(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_G_1_get_Seq_G_15(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_G_1_Seq_G_14_shift                                             (24)
+#define DITHERING_SEQ_G_1_Seq_G_14_mask                                              (0x0F000000)
+#define DITHERING_SEQ_G_1_Seq_G_14(data)                                             (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_G_1_Seq_G_14_src(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_G_1_get_Seq_G_14(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_G_1_Seq_G_13_shift                                             (20)
+#define DITHERING_SEQ_G_1_Seq_G_13_mask                                              (0x00F00000)
+#define DITHERING_SEQ_G_1_Seq_G_13(data)                                             (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_G_1_Seq_G_13_src(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_G_1_get_Seq_G_13(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_G_1_Seq_G_12_shift                                             (16)
+#define DITHERING_SEQ_G_1_Seq_G_12_mask                                              (0x000F0000)
+#define DITHERING_SEQ_G_1_Seq_G_12(data)                                             (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_G_1_Seq_G_12_src(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_G_1_get_Seq_G_12(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_G_1_Seq_G_11_shift                                             (12)
+#define DITHERING_SEQ_G_1_Seq_G_11_mask                                              (0x0000F000)
+#define DITHERING_SEQ_G_1_Seq_G_11(data)                                             (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_G_1_Seq_G_11_src(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_G_1_get_Seq_G_11(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_G_1_Seq_G_10_shift                                             (8)
+#define DITHERING_SEQ_G_1_Seq_G_10_mask                                              (0x00000F00)
+#define DITHERING_SEQ_G_1_Seq_G_10(data)                                             (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_G_1_Seq_G_10_src(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_G_1_get_Seq_G_10(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_G_1_Seq_G_9_shift                                              (4)
+#define DITHERING_SEQ_G_1_Seq_G_9_mask                                               (0x000000F0)
+#define DITHERING_SEQ_G_1_Seq_G_9(data)                                              (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_G_1_Seq_G_9_src(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_G_1_get_Seq_G_9(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_G_1_Seq_G_8_shift                                              (0)
+#define DITHERING_SEQ_G_1_Seq_G_8_mask                                               (0x0000000F)
+#define DITHERING_SEQ_G_1_Seq_G_8(data)                                              (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_G_1_Seq_G_8_src(data)                                          ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_G_1_get_Seq_G_8(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_G_2                                                            0x180098d0
+#define DITHERING_SEQ_G_2_reg_addr                                                   "0xB80098D0"
+#define DITHERING_SEQ_G_2_reg                                                        0xB80098D0
+#define set_DITHERING_SEQ_G_2_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_G_2_reg)=data)
+#define get_DITHERING_SEQ_G_2_reg   (*((volatile unsigned int*) DITHERING_SEQ_G_2_reg))
+#define DITHERING_SEQ_G_2_inst_adr                                                   "0x0034"
+#define DITHERING_SEQ_G_2_inst                                                       0x0034
+#define DITHERING_SEQ_G_2_Seq_G_23_shift                                             (28)
+#define DITHERING_SEQ_G_2_Seq_G_23_mask                                              (0xF0000000)
+#define DITHERING_SEQ_G_2_Seq_G_23(data)                                             (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_G_2_Seq_G_23_src(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_G_2_get_Seq_G_23(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_G_2_Seq_G_22_shift                                             (24)
+#define DITHERING_SEQ_G_2_Seq_G_22_mask                                              (0x0F000000)
+#define DITHERING_SEQ_G_2_Seq_G_22(data)                                             (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_G_2_Seq_G_22_src(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_G_2_get_Seq_G_22(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_G_2_Seq_G_21_shift                                             (20)
+#define DITHERING_SEQ_G_2_Seq_G_21_mask                                              (0x00F00000)
+#define DITHERING_SEQ_G_2_Seq_G_21(data)                                             (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_G_2_Seq_G_21_src(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_G_2_get_Seq_G_21(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_G_2_Seq_G_20_shift                                             (16)
+#define DITHERING_SEQ_G_2_Seq_G_20_mask                                              (0x000F0000)
+#define DITHERING_SEQ_G_2_Seq_G_20(data)                                             (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_G_2_Seq_G_20_src(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_G_2_get_Seq_G_20(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_G_2_Seq_G_19_shift                                             (12)
+#define DITHERING_SEQ_G_2_Seq_G_19_mask                                              (0x0000F000)
+#define DITHERING_SEQ_G_2_Seq_G_19(data)                                             (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_G_2_Seq_G_19_src(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_G_2_get_Seq_G_19(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_G_2_Seq_G_18_shift                                             (8)
+#define DITHERING_SEQ_G_2_Seq_G_18_mask                                              (0x00000F00)
+#define DITHERING_SEQ_G_2_Seq_G_18(data)                                             (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_G_2_Seq_G_18_src(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_G_2_get_Seq_G_18(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_G_2_Seq_G_17_shift                                             (4)
+#define DITHERING_SEQ_G_2_Seq_G_17_mask                                              (0x000000F0)
+#define DITHERING_SEQ_G_2_Seq_G_17(data)                                             (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_G_2_Seq_G_17_src(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_G_2_get_Seq_G_17(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_G_2_Seq_G_16_shift                                             (0)
+#define DITHERING_SEQ_G_2_Seq_G_16_mask                                              (0x0000000F)
+#define DITHERING_SEQ_G_2_Seq_G_16(data)                                             (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_G_2_Seq_G_16_src(data)                                         ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_G_2_get_Seq_G_16(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_G_3                                                            0x180098d4
+#define DITHERING_SEQ_G_3_reg_addr                                                   "0xB80098D4"
+#define DITHERING_SEQ_G_3_reg                                                        0xB80098D4
+#define set_DITHERING_SEQ_G_3_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_G_3_reg)=data)
+#define get_DITHERING_SEQ_G_3_reg   (*((volatile unsigned int*) DITHERING_SEQ_G_3_reg))
+#define DITHERING_SEQ_G_3_inst_adr                                                   "0x0035"
+#define DITHERING_SEQ_G_3_inst                                                       0x0035
+#define DITHERING_SEQ_G_3_Seq_G_31_shift                                             (28)
+#define DITHERING_SEQ_G_3_Seq_G_31_mask                                              (0xF0000000)
+#define DITHERING_SEQ_G_3_Seq_G_31(data)                                             (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_G_3_Seq_G_31_src(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_G_3_get_Seq_G_31(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_G_3_Seq_G_30_shift                                             (24)
+#define DITHERING_SEQ_G_3_Seq_G_30_mask                                              (0x0F000000)
+#define DITHERING_SEQ_G_3_Seq_G_30(data)                                             (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_G_3_Seq_G_30_src(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_G_3_get_Seq_G_30(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_G_3_Seq_G_29_shift                                             (20)
+#define DITHERING_SEQ_G_3_Seq_G_29_mask                                              (0x00F00000)
+#define DITHERING_SEQ_G_3_Seq_G_29(data)                                             (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_G_3_Seq_G_29_src(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_G_3_get_Seq_G_29(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_G_3_Seq_G_28_shift                                             (16)
+#define DITHERING_SEQ_G_3_Seq_G_28_mask                                              (0x000F0000)
+#define DITHERING_SEQ_G_3_Seq_G_28(data)                                             (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_G_3_Seq_G_28_src(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_G_3_get_Seq_G_28(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_G_3_Seq_G_27_shift                                             (12)
+#define DITHERING_SEQ_G_3_Seq_G_27_mask                                              (0x0000F000)
+#define DITHERING_SEQ_G_3_Seq_G_27(data)                                             (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_G_3_Seq_G_27_src(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_G_3_get_Seq_G_27(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_G_3_Seq_G_26_shift                                             (8)
+#define DITHERING_SEQ_G_3_Seq_G_26_mask                                              (0x00000F00)
+#define DITHERING_SEQ_G_3_Seq_G_26(data)                                             (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_G_3_Seq_G_26_src(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_G_3_get_Seq_G_26(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_G_3_Seq_G_25_shift                                             (4)
+#define DITHERING_SEQ_G_3_Seq_G_25_mask                                              (0x000000F0)
+#define DITHERING_SEQ_G_3_Seq_G_25(data)                                             (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_G_3_Seq_G_25_src(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_G_3_get_Seq_G_25(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_G_3_Seq_G_24_shift                                             (0)
+#define DITHERING_SEQ_G_3_Seq_G_24_mask                                              (0x0000000F)
+#define DITHERING_SEQ_G_3_Seq_G_24(data)                                             (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_G_3_Seq_G_24_src(data)                                         ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_G_3_get_Seq_G_24(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_B_0                                                            0x180098d8
+#define DITHERING_SEQ_B_0_reg_addr                                                   "0xB80098D8"
+#define DITHERING_SEQ_B_0_reg                                                        0xB80098D8
+#define set_DITHERING_SEQ_B_0_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_B_0_reg)=data)
+#define get_DITHERING_SEQ_B_0_reg   (*((volatile unsigned int*) DITHERING_SEQ_B_0_reg))
+#define DITHERING_SEQ_B_0_inst_adr                                                   "0x0036"
+#define DITHERING_SEQ_B_0_inst                                                       0x0036
+#define DITHERING_SEQ_B_0_Seq_B_7_shift                                              (28)
+#define DITHERING_SEQ_B_0_Seq_B_7_mask                                               (0xF0000000)
+#define DITHERING_SEQ_B_0_Seq_B_7(data)                                              (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_B_0_Seq_B_7_src(data)                                          ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_B_0_get_Seq_B_7(data)                                          ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_B_0_Seq_B_6_shift                                              (24)
+#define DITHERING_SEQ_B_0_Seq_B_6_mask                                               (0x0F000000)
+#define DITHERING_SEQ_B_0_Seq_B_6(data)                                              (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_B_0_Seq_B_6_src(data)                                          ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_B_0_get_Seq_B_6(data)                                          ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_B_0_Seq_B_5_shift                                              (20)
+#define DITHERING_SEQ_B_0_Seq_B_5_mask                                               (0x00F00000)
+#define DITHERING_SEQ_B_0_Seq_B_5(data)                                              (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_B_0_Seq_B_5_src(data)                                          ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_B_0_get_Seq_B_5(data)                                          ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_B_0_Seq_B_4_shift                                              (16)
+#define DITHERING_SEQ_B_0_Seq_B_4_mask                                               (0x000F0000)
+#define DITHERING_SEQ_B_0_Seq_B_4(data)                                              (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_B_0_Seq_B_4_src(data)                                          ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_B_0_get_Seq_B_4(data)                                          ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_B_0_Seq_B_3_shift                                              (12)
+#define DITHERING_SEQ_B_0_Seq_B_3_mask                                               (0x0000F000)
+#define DITHERING_SEQ_B_0_Seq_B_3(data)                                              (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_B_0_Seq_B_3_src(data)                                          ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_B_0_get_Seq_B_3(data)                                          ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_B_0_Seq_B_2_shift                                              (8)
+#define DITHERING_SEQ_B_0_Seq_B_2_mask                                               (0x00000F00)
+#define DITHERING_SEQ_B_0_Seq_B_2(data)                                              (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_B_0_Seq_B_2_src(data)                                          ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_B_0_get_Seq_B_2(data)                                          ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_B_0_Seq_B_1_shift                                              (4)
+#define DITHERING_SEQ_B_0_Seq_B_1_mask                                               (0x000000F0)
+#define DITHERING_SEQ_B_0_Seq_B_1(data)                                              (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_B_0_Seq_B_1_src(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_B_0_get_Seq_B_1(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_B_0_Seq_B_0_shift                                              (0)
+#define DITHERING_SEQ_B_0_Seq_B_0_mask                                               (0x0000000F)
+#define DITHERING_SEQ_B_0_Seq_B_0(data)                                              (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_B_0_Seq_B_0_src(data)                                          ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_B_0_get_Seq_B_0(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_B_1                                                            0x180098dc
+#define DITHERING_SEQ_B_1_reg_addr                                                   "0xB80098DC"
+#define DITHERING_SEQ_B_1_reg                                                        0xB80098DC
+#define set_DITHERING_SEQ_B_1_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_B_1_reg)=data)
+#define get_DITHERING_SEQ_B_1_reg   (*((volatile unsigned int*) DITHERING_SEQ_B_1_reg))
+#define DITHERING_SEQ_B_1_inst_adr                                                   "0x0037"
+#define DITHERING_SEQ_B_1_inst                                                       0x0037
+#define DITHERING_SEQ_B_1_Seq_B_15_shift                                             (28)
+#define DITHERING_SEQ_B_1_Seq_B_15_mask                                              (0xF0000000)
+#define DITHERING_SEQ_B_1_Seq_B_15(data)                                             (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_B_1_Seq_B_15_src(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_B_1_get_Seq_B_15(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_B_1_Seq_B_14_shift                                             (24)
+#define DITHERING_SEQ_B_1_Seq_B_14_mask                                              (0x0F000000)
+#define DITHERING_SEQ_B_1_Seq_B_14(data)                                             (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_B_1_Seq_B_14_src(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_B_1_get_Seq_B_14(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_B_1_Seq_B_13_shift                                             (20)
+#define DITHERING_SEQ_B_1_Seq_B_13_mask                                              (0x00F00000)
+#define DITHERING_SEQ_B_1_Seq_B_13(data)                                             (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_B_1_Seq_B_13_src(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_B_1_get_Seq_B_13(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_B_1_Seq_B_12_shift                                             (16)
+#define DITHERING_SEQ_B_1_Seq_B_12_mask                                              (0x000F0000)
+#define DITHERING_SEQ_B_1_Seq_B_12(data)                                             (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_B_1_Seq_B_12_src(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_B_1_get_Seq_B_12(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_B_1_Seq_B_11_shift                                             (12)
+#define DITHERING_SEQ_B_1_Seq_B_11_mask                                              (0x0000F000)
+#define DITHERING_SEQ_B_1_Seq_B_11(data)                                             (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_B_1_Seq_B_11_src(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_B_1_get_Seq_B_11(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_B_1_Seq_B_10_shift                                             (8)
+#define DITHERING_SEQ_B_1_Seq_B_10_mask                                              (0x00000F00)
+#define DITHERING_SEQ_B_1_Seq_B_10(data)                                             (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_B_1_Seq_B_10_src(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_B_1_get_Seq_B_10(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_B_1_Seq_B_9_shift                                              (4)
+#define DITHERING_SEQ_B_1_Seq_B_9_mask                                               (0x000000F0)
+#define DITHERING_SEQ_B_1_Seq_B_9(data)                                              (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_B_1_Seq_B_9_src(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_B_1_get_Seq_B_9(data)                                          ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_B_1_Seq_B_8_shift                                              (0)
+#define DITHERING_SEQ_B_1_Seq_B_8_mask                                               (0x0000000F)
+#define DITHERING_SEQ_B_1_Seq_B_8(data)                                              (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_B_1_Seq_B_8_src(data)                                          ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_B_1_get_Seq_B_8(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_B_2                                                            0x180098e0
+#define DITHERING_SEQ_B_2_reg_addr                                                   "0xB80098E0"
+#define DITHERING_SEQ_B_2_reg                                                        0xB80098E0
+#define set_DITHERING_SEQ_B_2_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_B_2_reg)=data)
+#define get_DITHERING_SEQ_B_2_reg   (*((volatile unsigned int*) DITHERING_SEQ_B_2_reg))
+#define DITHERING_SEQ_B_2_inst_adr                                                   "0x0038"
+#define DITHERING_SEQ_B_2_inst                                                       0x0038
+#define DITHERING_SEQ_B_2_Seq_B_23_shift                                             (28)
+#define DITHERING_SEQ_B_2_Seq_B_23_mask                                              (0xF0000000)
+#define DITHERING_SEQ_B_2_Seq_B_23(data)                                             (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_B_2_Seq_B_23_src(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_B_2_get_Seq_B_23(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_B_2_Seq_B_22_shift                                             (24)
+#define DITHERING_SEQ_B_2_Seq_B_22_mask                                              (0x0F000000)
+#define DITHERING_SEQ_B_2_Seq_B_22(data)                                             (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_B_2_Seq_B_22_src(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_B_2_get_Seq_B_22(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_B_2_Seq_B_21_shift                                             (20)
+#define DITHERING_SEQ_B_2_Seq_B_21_mask                                              (0x00F00000)
+#define DITHERING_SEQ_B_2_Seq_B_21(data)                                             (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_B_2_Seq_B_21_src(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_B_2_get_Seq_B_21(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_B_2_Seq_B_20_shift                                             (16)
+#define DITHERING_SEQ_B_2_Seq_B_20_mask                                              (0x000F0000)
+#define DITHERING_SEQ_B_2_Seq_B_20(data)                                             (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_B_2_Seq_B_20_src(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_B_2_get_Seq_B_20(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_B_2_Seq_B_19_shift                                             (12)
+#define DITHERING_SEQ_B_2_Seq_B_19_mask                                              (0x0000F000)
+#define DITHERING_SEQ_B_2_Seq_B_19(data)                                             (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_B_2_Seq_B_19_src(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_B_2_get_Seq_B_19(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_B_2_Seq_B_18_shift                                             (8)
+#define DITHERING_SEQ_B_2_Seq_B_18_mask                                              (0x00000F00)
+#define DITHERING_SEQ_B_2_Seq_B_18(data)                                             (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_B_2_Seq_B_18_src(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_B_2_get_Seq_B_18(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_B_2_Seq_B_17_shift                                             (4)
+#define DITHERING_SEQ_B_2_Seq_B_17_mask                                              (0x000000F0)
+#define DITHERING_SEQ_B_2_Seq_B_17(data)                                             (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_B_2_Seq_B_17_src(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_B_2_get_Seq_B_17(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_B_2_Seq_B_16_shift                                             (0)
+#define DITHERING_SEQ_B_2_Seq_B_16_mask                                              (0x0000000F)
+#define DITHERING_SEQ_B_2_Seq_B_16(data)                                             (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_B_2_Seq_B_16_src(data)                                         ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_B_2_get_Seq_B_16(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_SEQ_B_3                                                            0x180098e4
+#define DITHERING_SEQ_B_3_reg_addr                                                   "0xB80098E4"
+#define DITHERING_SEQ_B_3_reg                                                        0xB80098E4
+#define set_DITHERING_SEQ_B_3_reg(data)   (*((volatile unsigned int*) DITHERING_SEQ_B_3_reg)=data)
+#define get_DITHERING_SEQ_B_3_reg   (*((volatile unsigned int*) DITHERING_SEQ_B_3_reg))
+#define DITHERING_SEQ_B_3_inst_adr                                                   "0x0039"
+#define DITHERING_SEQ_B_3_inst                                                       0x0039
+#define DITHERING_SEQ_B_3_Seq_B_31_shift                                             (28)
+#define DITHERING_SEQ_B_3_Seq_B_31_mask                                              (0xF0000000)
+#define DITHERING_SEQ_B_3_Seq_B_31(data)                                             (0xF0000000&((data)<<28))
+#define DITHERING_SEQ_B_3_Seq_B_31_src(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_B_3_get_Seq_B_31(data)                                         ((0xF0000000&(data))>>28)
+#define DITHERING_SEQ_B_3_Seq_B_30_shift                                             (24)
+#define DITHERING_SEQ_B_3_Seq_B_30_mask                                              (0x0F000000)
+#define DITHERING_SEQ_B_3_Seq_B_30(data)                                             (0x0F000000&((data)<<24))
+#define DITHERING_SEQ_B_3_Seq_B_30_src(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_B_3_get_Seq_B_30(data)                                         ((0x0F000000&(data))>>24)
+#define DITHERING_SEQ_B_3_Seq_B_29_shift                                             (20)
+#define DITHERING_SEQ_B_3_Seq_B_29_mask                                              (0x00F00000)
+#define DITHERING_SEQ_B_3_Seq_B_29(data)                                             (0x00F00000&((data)<<20))
+#define DITHERING_SEQ_B_3_Seq_B_29_src(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_B_3_get_Seq_B_29(data)                                         ((0x00F00000&(data))>>20)
+#define DITHERING_SEQ_B_3_Seq_B_28_shift                                             (16)
+#define DITHERING_SEQ_B_3_Seq_B_28_mask                                              (0x000F0000)
+#define DITHERING_SEQ_B_3_Seq_B_28(data)                                             (0x000F0000&((data)<<16))
+#define DITHERING_SEQ_B_3_Seq_B_28_src(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_B_3_get_Seq_B_28(data)                                         ((0x000F0000&(data))>>16)
+#define DITHERING_SEQ_B_3_Seq_B_27_shift                                             (12)
+#define DITHERING_SEQ_B_3_Seq_B_27_mask                                              (0x0000F000)
+#define DITHERING_SEQ_B_3_Seq_B_27(data)                                             (0x0000F000&((data)<<12))
+#define DITHERING_SEQ_B_3_Seq_B_27_src(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_B_3_get_Seq_B_27(data)                                         ((0x0000F000&(data))>>12)
+#define DITHERING_SEQ_B_3_Seq_B_26_shift                                             (8)
+#define DITHERING_SEQ_B_3_Seq_B_26_mask                                              (0x00000F00)
+#define DITHERING_SEQ_B_3_Seq_B_26(data)                                             (0x00000F00&((data)<<8))
+#define DITHERING_SEQ_B_3_Seq_B_26_src(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_B_3_get_Seq_B_26(data)                                         ((0x00000F00&(data))>>8)
+#define DITHERING_SEQ_B_3_Seq_B_25_shift                                             (4)
+#define DITHERING_SEQ_B_3_Seq_B_25_mask                                              (0x000000F0)
+#define DITHERING_SEQ_B_3_Seq_B_25(data)                                             (0x000000F0&((data)<<4))
+#define DITHERING_SEQ_B_3_Seq_B_25_src(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_B_3_get_Seq_B_25(data)                                         ((0x000000F0&(data))>>4)
+#define DITHERING_SEQ_B_3_Seq_B_24_shift                                             (0)
+#define DITHERING_SEQ_B_3_Seq_B_24_mask                                              (0x0000000F)
+#define DITHERING_SEQ_B_3_Seq_B_24(data)                                             (0x0000000F&((data)<<0))
+#define DITHERING_SEQ_B_3_Seq_B_24_src(data)                                         ((0x0000000F&(data))>>0)
+#define DITHERING_SEQ_B_3_get_Seq_B_24(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_TAB_R_0                                                            0x180098e8
+#define DITHERING_TAB_R_0_reg_addr                                                   "0xB80098E8"
+#define DITHERING_TAB_R_0_reg                                                        0xB80098E8
+#define set_DITHERING_TAB_R_0_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_0_reg)=data)
+#define get_DITHERING_TAB_R_0_reg   (*((volatile unsigned int*) DITHERING_TAB_R_0_reg))
+#define DITHERING_TAB_R_0_inst_adr                                                   "0x003A"
+#define DITHERING_TAB_R_0_inst                                                       0x003A
+#define DITHERING_TAB_R_0_Tab_R_03_shift                                             (18)
+#define DITHERING_TAB_R_0_Tab_R_03_mask                                              (0x00FC0000)
+#define DITHERING_TAB_R_0_Tab_R_03(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_0_Tab_R_03_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_0_get_Tab_R_03(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_0_Tab_R_02_shift                                             (12)
+#define DITHERING_TAB_R_0_Tab_R_02_mask                                              (0x0003F000)
+#define DITHERING_TAB_R_0_Tab_R_02(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_0_Tab_R_02_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_0_get_Tab_R_02(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_0_Tab_R_01_shift                                             (6)
+#define DITHERING_TAB_R_0_Tab_R_01_mask                                              (0x00000FC0)
+#define DITHERING_TAB_R_0_Tab_R_01(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_0_Tab_R_01_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_0_get_Tab_R_01(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_0_Tab_R_00_shift                                             (0)
+#define DITHERING_TAB_R_0_Tab_R_00_mask                                              (0x0000003F)
+#define DITHERING_TAB_R_0_Tab_R_00(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_0_Tab_R_00_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_0_get_Tab_R_00(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_1                                                            0x180098ec
+#define DITHERING_TAB_R_1_reg_addr                                                   "0xB80098EC"
+#define DITHERING_TAB_R_1_reg                                                        0xB80098EC
+#define set_DITHERING_TAB_R_1_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_1_reg)=data)
+#define get_DITHERING_TAB_R_1_reg   (*((volatile unsigned int*) DITHERING_TAB_R_1_reg))
+#define DITHERING_TAB_R_1_inst_adr                                                   "0x003B"
+#define DITHERING_TAB_R_1_inst                                                       0x003B
+#define DITHERING_TAB_R_1_Tab_R_13_shift                                             (18)
+#define DITHERING_TAB_R_1_Tab_R_13_mask                                              (0x00FC0000)
+#define DITHERING_TAB_R_1_Tab_R_13(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_1_Tab_R_13_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_1_get_Tab_R_13(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_1_Tab_R_12_shift                                             (12)
+#define DITHERING_TAB_R_1_Tab_R_12_mask                                              (0x0003F000)
+#define DITHERING_TAB_R_1_Tab_R_12(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_1_Tab_R_12_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_1_get_Tab_R_12(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_1_Tab_R_11_shift                                             (6)
+#define DITHERING_TAB_R_1_Tab_R_11_mask                                              (0x00000FC0)
+#define DITHERING_TAB_R_1_Tab_R_11(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_1_Tab_R_11_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_1_get_Tab_R_11(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_1_Tab_R_10_shift                                             (0)
+#define DITHERING_TAB_R_1_Tab_R_10_mask                                              (0x0000003F)
+#define DITHERING_TAB_R_1_Tab_R_10(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_1_Tab_R_10_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_1_get_Tab_R_10(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_2                                                            0x180098f0
+#define DITHERING_TAB_R_2_reg_addr                                                   "0xB80098F0"
+#define DITHERING_TAB_R_2_reg                                                        0xB80098F0
+#define set_DITHERING_TAB_R_2_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_2_reg)=data)
+#define get_DITHERING_TAB_R_2_reg   (*((volatile unsigned int*) DITHERING_TAB_R_2_reg))
+#define DITHERING_TAB_R_2_inst_adr                                                   "0x003C"
+#define DITHERING_TAB_R_2_inst                                                       0x003C
+#define DITHERING_TAB_R_2_Tab_R_23_shift                                             (18)
+#define DITHERING_TAB_R_2_Tab_R_23_mask                                              (0x00FC0000)
+#define DITHERING_TAB_R_2_Tab_R_23(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_2_Tab_R_23_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_2_get_Tab_R_23(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_2_Tab_R_22_shift                                             (12)
+#define DITHERING_TAB_R_2_Tab_R_22_mask                                              (0x0003F000)
+#define DITHERING_TAB_R_2_Tab_R_22(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_2_Tab_R_22_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_2_get_Tab_R_22(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_2_Tab_R_21_shift                                             (6)
+#define DITHERING_TAB_R_2_Tab_R_21_mask                                              (0x00000FC0)
+#define DITHERING_TAB_R_2_Tab_R_21(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_2_Tab_R_21_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_2_get_Tab_R_21(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_2_Tab_R_20_shift                                             (0)
+#define DITHERING_TAB_R_2_Tab_R_20_mask                                              (0x0000003F)
+#define DITHERING_TAB_R_2_Tab_R_20(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_2_Tab_R_20_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_2_get_Tab_R_20(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_3                                                            0x180098f4
+#define DITHERING_TAB_R_3_reg_addr                                                   "0xB80098F4"
+#define DITHERING_TAB_R_3_reg                                                        0xB80098F4
+#define set_DITHERING_TAB_R_3_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_3_reg)=data)
+#define get_DITHERING_TAB_R_3_reg   (*((volatile unsigned int*) DITHERING_TAB_R_3_reg))
+#define DITHERING_TAB_R_3_inst_adr                                                   "0x003D"
+#define DITHERING_TAB_R_3_inst                                                       0x003D
+#define DITHERING_TAB_R_3_Tab_R_33_shift                                             (18)
+#define DITHERING_TAB_R_3_Tab_R_33_mask                                              (0x00FC0000)
+#define DITHERING_TAB_R_3_Tab_R_33(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_3_Tab_R_33_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_3_get_Tab_R_33(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_3_Tab_R_32_shift                                             (12)
+#define DITHERING_TAB_R_3_Tab_R_32_mask                                              (0x0003F000)
+#define DITHERING_TAB_R_3_Tab_R_32(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_3_Tab_R_32_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_3_get_Tab_R_32(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_3_Tab_R_31_shift                                             (6)
+#define DITHERING_TAB_R_3_Tab_R_31_mask                                              (0x00000FC0)
+#define DITHERING_TAB_R_3_Tab_R_31(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_3_Tab_R_31_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_3_get_Tab_R_31(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_3_Tab_R_30_shift                                             (0)
+#define DITHERING_TAB_R_3_Tab_R_30_mask                                              (0x0000003F)
+#define DITHERING_TAB_R_3_Tab_R_30(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_3_Tab_R_30_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_3_get_Tab_R_30(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_4                                                            0x180098f8
+#define DITHERING_TAB_R_4_reg_addr                                                   "0xB80098F8"
+#define DITHERING_TAB_R_4_reg                                                        0xB80098F8
+#define set_DITHERING_TAB_R_4_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_4_reg)=data)
+#define get_DITHERING_TAB_R_4_reg   (*((volatile unsigned int*) DITHERING_TAB_R_4_reg))
+#define DITHERING_TAB_R_4_inst_adr                                                   "0x003E"
+#define DITHERING_TAB_R_4_inst                                                       0x003E
+#define DITHERING_TAB_R_4_Tab_R_43_shift                                             (18)
+#define DITHERING_TAB_R_4_Tab_R_43_mask                                              (0x00FC0000)
+#define DITHERING_TAB_R_4_Tab_R_43(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_4_Tab_R_43_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_4_get_Tab_R_43(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_4_Tab_R_42_shift                                             (12)
+#define DITHERING_TAB_R_4_Tab_R_42_mask                                              (0x0003F000)
+#define DITHERING_TAB_R_4_Tab_R_42(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_4_Tab_R_42_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_4_get_Tab_R_42(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_4_Tab_R_41_shift                                             (6)
+#define DITHERING_TAB_R_4_Tab_R_41_mask                                              (0x00000FC0)
+#define DITHERING_TAB_R_4_Tab_R_41(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_4_Tab_R_41_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_4_get_Tab_R_41(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_4_Tab_R_40_shift                                             (0)
+#define DITHERING_TAB_R_4_Tab_R_40_mask                                              (0x0000003F)
+#define DITHERING_TAB_R_4_Tab_R_40(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_4_Tab_R_40_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_4_get_Tab_R_40(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_5                                                            0x180098fc
+#define DITHERING_TAB_R_5_reg_addr                                                   "0xB80098FC"
+#define DITHERING_TAB_R_5_reg                                                        0xB80098FC
+#define set_DITHERING_TAB_R_5_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_5_reg)=data)
+#define get_DITHERING_TAB_R_5_reg   (*((volatile unsigned int*) DITHERING_TAB_R_5_reg))
+#define DITHERING_TAB_R_5_inst_adr                                                   "0x003F"
+#define DITHERING_TAB_R_5_inst                                                       0x003F
+#define DITHERING_TAB_R_5_Tab_R_53_shift                                             (18)
+#define DITHERING_TAB_R_5_Tab_R_53_mask                                              (0x00FC0000)
+#define DITHERING_TAB_R_5_Tab_R_53(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_5_Tab_R_53_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_5_get_Tab_R_53(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_5_Tab_R_52_shift                                             (12)
+#define DITHERING_TAB_R_5_Tab_R_52_mask                                              (0x0003F000)
+#define DITHERING_TAB_R_5_Tab_R_52(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_5_Tab_R_52_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_5_get_Tab_R_52(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_5_Tab_R_51_shift                                             (6)
+#define DITHERING_TAB_R_5_Tab_R_51_mask                                              (0x00000FC0)
+#define DITHERING_TAB_R_5_Tab_R_51(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_5_Tab_R_51_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_5_get_Tab_R_51(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_5_Tab_R_50_shift                                             (0)
+#define DITHERING_TAB_R_5_Tab_R_50_mask                                              (0x0000003F)
+#define DITHERING_TAB_R_5_Tab_R_50(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_5_Tab_R_50_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_5_get_Tab_R_50(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_6                                                            0x18009900
+#define DITHERING_TAB_R_6_reg_addr                                                   "0xB8009900"
+#define DITHERING_TAB_R_6_reg                                                        0xB8009900
+#define set_DITHERING_TAB_R_6_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_6_reg)=data)
+#define get_DITHERING_TAB_R_6_reg   (*((volatile unsigned int*) DITHERING_TAB_R_6_reg))
+#define DITHERING_TAB_R_6_inst_adr                                                   "0x0040"
+#define DITHERING_TAB_R_6_inst                                                       0x0040
+#define DITHERING_TAB_R_6_Tab_R_63_shift                                             (18)
+#define DITHERING_TAB_R_6_Tab_R_63_mask                                              (0x00FC0000)
+#define DITHERING_TAB_R_6_Tab_R_63(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_6_Tab_R_63_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_6_get_Tab_R_63(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_6_Tab_R_62_shift                                             (12)
+#define DITHERING_TAB_R_6_Tab_R_62_mask                                              (0x0003F000)
+#define DITHERING_TAB_R_6_Tab_R_62(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_6_Tab_R_62_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_6_get_Tab_R_62(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_6_Tab_R_61_shift                                             (6)
+#define DITHERING_TAB_R_6_Tab_R_61_mask                                              (0x00000FC0)
+#define DITHERING_TAB_R_6_Tab_R_61(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_6_Tab_R_61_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_6_get_Tab_R_61(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_6_Tab_R_60_shift                                             (0)
+#define DITHERING_TAB_R_6_Tab_R_60_mask                                              (0x0000003F)
+#define DITHERING_TAB_R_6_Tab_R_60(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_6_Tab_R_60_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_6_get_Tab_R_60(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_7                                                            0x18009904
+#define DITHERING_TAB_R_7_reg_addr                                                   "0xB8009904"
+#define DITHERING_TAB_R_7_reg                                                        0xB8009904
+#define set_DITHERING_TAB_R_7_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_7_reg)=data)
+#define get_DITHERING_TAB_R_7_reg   (*((volatile unsigned int*) DITHERING_TAB_R_7_reg))
+#define DITHERING_TAB_R_7_inst_adr                                                   "0x0041"
+#define DITHERING_TAB_R_7_inst                                                       0x0041
+#define DITHERING_TAB_R_7_Tab_R_73_shift                                             (18)
+#define DITHERING_TAB_R_7_Tab_R_73_mask                                              (0x00FC0000)
+#define DITHERING_TAB_R_7_Tab_R_73(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_7_Tab_R_73_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_7_get_Tab_R_73(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_7_Tab_R_72_shift                                             (12)
+#define DITHERING_TAB_R_7_Tab_R_72_mask                                              (0x0003F000)
+#define DITHERING_TAB_R_7_Tab_R_72(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_7_Tab_R_72_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_7_get_Tab_R_72(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_7_Tab_R_71_shift                                             (6)
+#define DITHERING_TAB_R_7_Tab_R_71_mask                                              (0x00000FC0)
+#define DITHERING_TAB_R_7_Tab_R_71(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_7_Tab_R_71_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_7_get_Tab_R_71(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_7_Tab_R_70_shift                                             (0)
+#define DITHERING_TAB_R_7_Tab_R_70_mask                                              (0x0000003F)
+#define DITHERING_TAB_R_7_Tab_R_70(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_7_Tab_R_70_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_7_get_Tab_R_70(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_8                                                            0x18009908
+#define DITHERING_TAB_R_8_reg_addr                                                   "0xB8009908"
+#define DITHERING_TAB_R_8_reg                                                        0xB8009908
+#define set_DITHERING_TAB_R_8_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_8_reg)=data)
+#define get_DITHERING_TAB_R_8_reg   (*((volatile unsigned int*) DITHERING_TAB_R_8_reg))
+#define DITHERING_TAB_R_8_inst_adr                                                   "0x0042"
+#define DITHERING_TAB_R_8_inst                                                       0x0042
+#define DITHERING_TAB_R_8_Tab_R_83_shift                                             (18)
+#define DITHERING_TAB_R_8_Tab_R_83_mask                                              (0x00FC0000)
+#define DITHERING_TAB_R_8_Tab_R_83(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_8_Tab_R_83_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_8_get_Tab_R_83(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_8_Tab_R_82_shift                                             (12)
+#define DITHERING_TAB_R_8_Tab_R_82_mask                                              (0x0003F000)
+#define DITHERING_TAB_R_8_Tab_R_82(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_8_Tab_R_82_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_8_get_Tab_R_82(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_8_Tab_R_81_shift                                             (6)
+#define DITHERING_TAB_R_8_Tab_R_81_mask                                              (0x00000FC0)
+#define DITHERING_TAB_R_8_Tab_R_81(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_8_Tab_R_81_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_8_get_Tab_R_81(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_8_Tab_R_80_shift                                             (0)
+#define DITHERING_TAB_R_8_Tab_R_80_mask                                              (0x0000003F)
+#define DITHERING_TAB_R_8_Tab_R_80(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_8_Tab_R_80_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_8_get_Tab_R_80(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_9                                                            0x1800990c
+#define DITHERING_TAB_R_9_reg_addr                                                   "0xB800990C"
+#define DITHERING_TAB_R_9_reg                                                        0xB800990C
+#define set_DITHERING_TAB_R_9_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_9_reg)=data)
+#define get_DITHERING_TAB_R_9_reg   (*((volatile unsigned int*) DITHERING_TAB_R_9_reg))
+#define DITHERING_TAB_R_9_inst_adr                                                   "0x0043"
+#define DITHERING_TAB_R_9_inst                                                       0x0043
+#define DITHERING_TAB_R_9_Tab_R_93_shift                                             (18)
+#define DITHERING_TAB_R_9_Tab_R_93_mask                                              (0x00FC0000)
+#define DITHERING_TAB_R_9_Tab_R_93(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_9_Tab_R_93_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_9_get_Tab_R_93(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_9_Tab_R_92_shift                                             (12)
+#define DITHERING_TAB_R_9_Tab_R_92_mask                                              (0x0003F000)
+#define DITHERING_TAB_R_9_Tab_R_92(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_9_Tab_R_92_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_9_get_Tab_R_92(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_9_Tab_R_91_shift                                             (6)
+#define DITHERING_TAB_R_9_Tab_R_91_mask                                              (0x00000FC0)
+#define DITHERING_TAB_R_9_Tab_R_91(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_9_Tab_R_91_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_9_get_Tab_R_91(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_9_Tab_R_90_shift                                             (0)
+#define DITHERING_TAB_R_9_Tab_R_90_mask                                              (0x0000003F)
+#define DITHERING_TAB_R_9_Tab_R_90(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_9_Tab_R_90_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_9_get_Tab_R_90(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_10                                                           0x18009910
+#define DITHERING_TAB_R_10_reg_addr                                                  "0xB8009910"
+#define DITHERING_TAB_R_10_reg                                                       0xB8009910
+#define set_DITHERING_TAB_R_10_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_10_reg)=data)
+#define get_DITHERING_TAB_R_10_reg   (*((volatile unsigned int*) DITHERING_TAB_R_10_reg))
+#define DITHERING_TAB_R_10_inst_adr                                                  "0x0044"
+#define DITHERING_TAB_R_10_inst                                                      0x0044
+#define DITHERING_TAB_R_10_Tab_R_A3_shift                                            (18)
+#define DITHERING_TAB_R_10_Tab_R_A3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_R_10_Tab_R_A3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_10_Tab_R_A3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_10_get_Tab_R_A3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_10_Tab_R_A2_shift                                            (12)
+#define DITHERING_TAB_R_10_Tab_R_A2_mask                                             (0x0003F000)
+#define DITHERING_TAB_R_10_Tab_R_A2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_10_Tab_R_A2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_10_get_Tab_R_A2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_10_Tab_R_A1_shift                                            (6)
+#define DITHERING_TAB_R_10_Tab_R_A1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_R_10_Tab_R_A1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_10_Tab_R_A1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_10_get_Tab_R_A1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_10_Tab_R_A0_shift                                            (0)
+#define DITHERING_TAB_R_10_Tab_R_A0_mask                                             (0x0000003F)
+#define DITHERING_TAB_R_10_Tab_R_A0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_10_Tab_R_A0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_10_get_Tab_R_A0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_11                                                           0x18009914
+#define DITHERING_TAB_R_11_reg_addr                                                  "0xB8009914"
+#define DITHERING_TAB_R_11_reg                                                       0xB8009914
+#define set_DITHERING_TAB_R_11_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_11_reg)=data)
+#define get_DITHERING_TAB_R_11_reg   (*((volatile unsigned int*) DITHERING_TAB_R_11_reg))
+#define DITHERING_TAB_R_11_inst_adr                                                  "0x0045"
+#define DITHERING_TAB_R_11_inst                                                      0x0045
+#define DITHERING_TAB_R_11_Tab_R_B3_shift                                            (18)
+#define DITHERING_TAB_R_11_Tab_R_B3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_R_11_Tab_R_B3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_11_Tab_R_B3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_11_get_Tab_R_B3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_11_Tab_R_B2_shift                                            (12)
+#define DITHERING_TAB_R_11_Tab_R_B2_mask                                             (0x0003F000)
+#define DITHERING_TAB_R_11_Tab_R_B2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_11_Tab_R_B2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_11_get_Tab_R_B2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_11_Tab_R_B1_shift                                            (6)
+#define DITHERING_TAB_R_11_Tab_R_B1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_R_11_Tab_R_B1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_11_Tab_R_B1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_11_get_Tab_R_B1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_11_Tab_R_B0_shift                                            (0)
+#define DITHERING_TAB_R_11_Tab_R_B0_mask                                             (0x0000003F)
+#define DITHERING_TAB_R_11_Tab_R_B0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_11_Tab_R_B0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_11_get_Tab_R_B0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_12                                                           0x18009918
+#define DITHERING_TAB_R_12_reg_addr                                                  "0xB8009918"
+#define DITHERING_TAB_R_12_reg                                                       0xB8009918
+#define set_DITHERING_TAB_R_12_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_12_reg)=data)
+#define get_DITHERING_TAB_R_12_reg   (*((volatile unsigned int*) DITHERING_TAB_R_12_reg))
+#define DITHERING_TAB_R_12_inst_adr                                                  "0x0046"
+#define DITHERING_TAB_R_12_inst                                                      0x0046
+#define DITHERING_TAB_R_12_Tab_R_C3_shift                                            (18)
+#define DITHERING_TAB_R_12_Tab_R_C3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_R_12_Tab_R_C3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_12_Tab_R_C3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_12_get_Tab_R_C3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_12_Tab_R_C2_shift                                            (12)
+#define DITHERING_TAB_R_12_Tab_R_C2_mask                                             (0x0003F000)
+#define DITHERING_TAB_R_12_Tab_R_C2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_12_Tab_R_C2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_12_get_Tab_R_C2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_12_Tab_R_C1_shift                                            (6)
+#define DITHERING_TAB_R_12_Tab_R_C1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_R_12_Tab_R_C1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_12_Tab_R_C1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_12_get_Tab_R_C1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_12_Tab_R_C0_shift                                            (0)
+#define DITHERING_TAB_R_12_Tab_R_C0_mask                                             (0x0000003F)
+#define DITHERING_TAB_R_12_Tab_R_C0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_12_Tab_R_C0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_12_get_Tab_R_C0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_13                                                           0x1800991c
+#define DITHERING_TAB_R_13_reg_addr                                                  "0xB800991C"
+#define DITHERING_TAB_R_13_reg                                                       0xB800991C
+#define set_DITHERING_TAB_R_13_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_13_reg)=data)
+#define get_DITHERING_TAB_R_13_reg   (*((volatile unsigned int*) DITHERING_TAB_R_13_reg))
+#define DITHERING_TAB_R_13_inst_adr                                                  "0x0047"
+#define DITHERING_TAB_R_13_inst                                                      0x0047
+#define DITHERING_TAB_R_13_Tab_R_D3_shift                                            (18)
+#define DITHERING_TAB_R_13_Tab_R_D3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_R_13_Tab_R_D3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_13_Tab_R_D3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_13_get_Tab_R_D3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_13_Tab_R_D2_shift                                            (12)
+#define DITHERING_TAB_R_13_Tab_R_D2_mask                                             (0x0003F000)
+#define DITHERING_TAB_R_13_Tab_R_D2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_13_Tab_R_D2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_13_get_Tab_R_D2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_13_Tab_R_D1_shift                                            (6)
+#define DITHERING_TAB_R_13_Tab_R_D1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_R_13_Tab_R_D1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_13_Tab_R_D1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_13_get_Tab_R_D1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_13_Tab_R_D0_shift                                            (0)
+#define DITHERING_TAB_R_13_Tab_R_D0_mask                                             (0x0000003F)
+#define DITHERING_TAB_R_13_Tab_R_D0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_13_Tab_R_D0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_13_get_Tab_R_D0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_14                                                           0x18009920
+#define DITHERING_TAB_R_14_reg_addr                                                  "0xB8009920"
+#define DITHERING_TAB_R_14_reg                                                       0xB8009920
+#define set_DITHERING_TAB_R_14_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_14_reg)=data)
+#define get_DITHERING_TAB_R_14_reg   (*((volatile unsigned int*) DITHERING_TAB_R_14_reg))
+#define DITHERING_TAB_R_14_inst_adr                                                  "0x0048"
+#define DITHERING_TAB_R_14_inst                                                      0x0048
+#define DITHERING_TAB_R_14_Tab_R_E3_shift                                            (18)
+#define DITHERING_TAB_R_14_Tab_R_E3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_R_14_Tab_R_E3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_14_Tab_R_E3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_14_get_Tab_R_E3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_14_Tab_R_E2_shift                                            (12)
+#define DITHERING_TAB_R_14_Tab_R_E2_mask                                             (0x0003F000)
+#define DITHERING_TAB_R_14_Tab_R_E2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_14_Tab_R_E2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_14_get_Tab_R_E2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_14_Tab_R_E1_shift                                            (6)
+#define DITHERING_TAB_R_14_Tab_R_E1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_R_14_Tab_R_E1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_14_Tab_R_E1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_14_get_Tab_R_E1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_14_Tab_R_E0_shift                                            (0)
+#define DITHERING_TAB_R_14_Tab_R_E0_mask                                             (0x0000003F)
+#define DITHERING_TAB_R_14_Tab_R_E0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_14_Tab_R_E0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_14_get_Tab_R_E0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_R_15                                                           0x18009924
+#define DITHERING_TAB_R_15_reg_addr                                                  "0xB8009924"
+#define DITHERING_TAB_R_15_reg                                                       0xB8009924
+#define set_DITHERING_TAB_R_15_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_R_15_reg)=data)
+#define get_DITHERING_TAB_R_15_reg   (*((volatile unsigned int*) DITHERING_TAB_R_15_reg))
+#define DITHERING_TAB_R_15_inst_adr                                                  "0x0049"
+#define DITHERING_TAB_R_15_inst                                                      0x0049
+#define DITHERING_TAB_R_15_Tab_R_F3_shift                                            (18)
+#define DITHERING_TAB_R_15_Tab_R_F3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_R_15_Tab_R_F3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_R_15_Tab_R_F3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_15_get_Tab_R_F3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_R_15_Tab_R_F2_shift                                            (12)
+#define DITHERING_TAB_R_15_Tab_R_F2_mask                                             (0x0003F000)
+#define DITHERING_TAB_R_15_Tab_R_F2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_R_15_Tab_R_F2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_15_get_Tab_R_F2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_R_15_Tab_R_F1_shift                                            (6)
+#define DITHERING_TAB_R_15_Tab_R_F1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_R_15_Tab_R_F1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_R_15_Tab_R_F1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_15_get_Tab_R_F1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_R_15_Tab_R_F0_shift                                            (0)
+#define DITHERING_TAB_R_15_Tab_R_F0_mask                                             (0x0000003F)
+#define DITHERING_TAB_R_15_Tab_R_F0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_R_15_Tab_R_F0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_R_15_get_Tab_R_F0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_0                                                            0x18009928
+#define DITHERING_TAB_G_0_reg_addr                                                   "0xB8009928"
+#define DITHERING_TAB_G_0_reg                                                        0xB8009928
+#define set_DITHERING_TAB_G_0_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_0_reg)=data)
+#define get_DITHERING_TAB_G_0_reg   (*((volatile unsigned int*) DITHERING_TAB_G_0_reg))
+#define DITHERING_TAB_G_0_inst_adr                                                   "0x004A"
+#define DITHERING_TAB_G_0_inst                                                       0x004A
+#define DITHERING_TAB_G_0_Tab_G_03_shift                                             (18)
+#define DITHERING_TAB_G_0_Tab_G_03_mask                                              (0x00FC0000)
+#define DITHERING_TAB_G_0_Tab_G_03(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_0_Tab_G_03_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_0_get_Tab_G_03(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_0_Tab_G_02_shift                                             (12)
+#define DITHERING_TAB_G_0_Tab_G_02_mask                                              (0x0003F000)
+#define DITHERING_TAB_G_0_Tab_G_02(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_0_Tab_G_02_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_0_get_Tab_G_02(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_0_Tab_G_01_shift                                             (6)
+#define DITHERING_TAB_G_0_Tab_G_01_mask                                              (0x00000FC0)
+#define DITHERING_TAB_G_0_Tab_G_01(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_0_Tab_G_01_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_0_get_Tab_G_01(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_0_Tab_G_00_shift                                             (0)
+#define DITHERING_TAB_G_0_Tab_G_00_mask                                              (0x0000003F)
+#define DITHERING_TAB_G_0_Tab_G_00(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_0_Tab_G_00_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_0_get_Tab_G_00(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_1                                                            0x1800992c
+#define DITHERING_TAB_G_1_reg_addr                                                   "0xB800992C"
+#define DITHERING_TAB_G_1_reg                                                        0xB800992C
+#define set_DITHERING_TAB_G_1_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_1_reg)=data)
+#define get_DITHERING_TAB_G_1_reg   (*((volatile unsigned int*) DITHERING_TAB_G_1_reg))
+#define DITHERING_TAB_G_1_inst_adr                                                   "0x004B"
+#define DITHERING_TAB_G_1_inst                                                       0x004B
+#define DITHERING_TAB_G_1_Tab_G_13_shift                                             (18)
+#define DITHERING_TAB_G_1_Tab_G_13_mask                                              (0x00FC0000)
+#define DITHERING_TAB_G_1_Tab_G_13(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_1_Tab_G_13_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_1_get_Tab_G_13(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_1_Tab_G_12_shift                                             (12)
+#define DITHERING_TAB_G_1_Tab_G_12_mask                                              (0x0003F000)
+#define DITHERING_TAB_G_1_Tab_G_12(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_1_Tab_G_12_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_1_get_Tab_G_12(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_1_Tab_G_11_shift                                             (6)
+#define DITHERING_TAB_G_1_Tab_G_11_mask                                              (0x00000FC0)
+#define DITHERING_TAB_G_1_Tab_G_11(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_1_Tab_G_11_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_1_get_Tab_G_11(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_1_Tab_G_10_shift                                             (0)
+#define DITHERING_TAB_G_1_Tab_G_10_mask                                              (0x0000003F)
+#define DITHERING_TAB_G_1_Tab_G_10(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_1_Tab_G_10_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_1_get_Tab_G_10(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_2                                                            0x18009930
+#define DITHERING_TAB_G_2_reg_addr                                                   "0xB8009930"
+#define DITHERING_TAB_G_2_reg                                                        0xB8009930
+#define set_DITHERING_TAB_G_2_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_2_reg)=data)
+#define get_DITHERING_TAB_G_2_reg   (*((volatile unsigned int*) DITHERING_TAB_G_2_reg))
+#define DITHERING_TAB_G_2_inst_adr                                                   "0x004C"
+#define DITHERING_TAB_G_2_inst                                                       0x004C
+#define DITHERING_TAB_G_2_Tab_G_23_shift                                             (18)
+#define DITHERING_TAB_G_2_Tab_G_23_mask                                              (0x00FC0000)
+#define DITHERING_TAB_G_2_Tab_G_23(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_2_Tab_G_23_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_2_get_Tab_G_23(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_2_Tab_G_22_shift                                             (12)
+#define DITHERING_TAB_G_2_Tab_G_22_mask                                              (0x0003F000)
+#define DITHERING_TAB_G_2_Tab_G_22(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_2_Tab_G_22_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_2_get_Tab_G_22(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_2_Tab_G_21_shift                                             (6)
+#define DITHERING_TAB_G_2_Tab_G_21_mask                                              (0x00000FC0)
+#define DITHERING_TAB_G_2_Tab_G_21(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_2_Tab_G_21_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_2_get_Tab_G_21(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_2_Tab_G_20_shift                                             (0)
+#define DITHERING_TAB_G_2_Tab_G_20_mask                                              (0x0000003F)
+#define DITHERING_TAB_G_2_Tab_G_20(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_2_Tab_G_20_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_2_get_Tab_G_20(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_3                                                            0x18009934
+#define DITHERING_TAB_G_3_reg_addr                                                   "0xB8009934"
+#define DITHERING_TAB_G_3_reg                                                        0xB8009934
+#define set_DITHERING_TAB_G_3_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_3_reg)=data)
+#define get_DITHERING_TAB_G_3_reg   (*((volatile unsigned int*) DITHERING_TAB_G_3_reg))
+#define DITHERING_TAB_G_3_inst_adr                                                   "0x004D"
+#define DITHERING_TAB_G_3_inst                                                       0x004D
+#define DITHERING_TAB_G_3_Tab_G_33_shift                                             (18)
+#define DITHERING_TAB_G_3_Tab_G_33_mask                                              (0x00FC0000)
+#define DITHERING_TAB_G_3_Tab_G_33(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_3_Tab_G_33_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_3_get_Tab_G_33(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_3_Tab_G_32_shift                                             (12)
+#define DITHERING_TAB_G_3_Tab_G_32_mask                                              (0x0003F000)
+#define DITHERING_TAB_G_3_Tab_G_32(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_3_Tab_G_32_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_3_get_Tab_G_32(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_3_Tab_G_31_shift                                             (6)
+#define DITHERING_TAB_G_3_Tab_G_31_mask                                              (0x00000FC0)
+#define DITHERING_TAB_G_3_Tab_G_31(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_3_Tab_G_31_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_3_get_Tab_G_31(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_3_Tab_G_30_shift                                             (0)
+#define DITHERING_TAB_G_3_Tab_G_30_mask                                              (0x0000003F)
+#define DITHERING_TAB_G_3_Tab_G_30(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_3_Tab_G_30_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_3_get_Tab_G_30(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_4                                                            0x18009938
+#define DITHERING_TAB_G_4_reg_addr                                                   "0xB8009938"
+#define DITHERING_TAB_G_4_reg                                                        0xB8009938
+#define set_DITHERING_TAB_G_4_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_4_reg)=data)
+#define get_DITHERING_TAB_G_4_reg   (*((volatile unsigned int*) DITHERING_TAB_G_4_reg))
+#define DITHERING_TAB_G_4_inst_adr                                                   "0x004E"
+#define DITHERING_TAB_G_4_inst                                                       0x004E
+#define DITHERING_TAB_G_4_Tab_G_43_shift                                             (18)
+#define DITHERING_TAB_G_4_Tab_G_43_mask                                              (0x00FC0000)
+#define DITHERING_TAB_G_4_Tab_G_43(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_4_Tab_G_43_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_4_get_Tab_G_43(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_4_Tab_G_42_shift                                             (12)
+#define DITHERING_TAB_G_4_Tab_G_42_mask                                              (0x0003F000)
+#define DITHERING_TAB_G_4_Tab_G_42(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_4_Tab_G_42_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_4_get_Tab_G_42(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_4_Tab_G_41_shift                                             (6)
+#define DITHERING_TAB_G_4_Tab_G_41_mask                                              (0x00000FC0)
+#define DITHERING_TAB_G_4_Tab_G_41(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_4_Tab_G_41_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_4_get_Tab_G_41(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_4_Tab_G_40_shift                                             (0)
+#define DITHERING_TAB_G_4_Tab_G_40_mask                                              (0x0000003F)
+#define DITHERING_TAB_G_4_Tab_G_40(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_4_Tab_G_40_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_4_get_Tab_G_40(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_5                                                            0x1800993c
+#define DITHERING_TAB_G_5_reg_addr                                                   "0xB800993C"
+#define DITHERING_TAB_G_5_reg                                                        0xB800993C
+#define set_DITHERING_TAB_G_5_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_5_reg)=data)
+#define get_DITHERING_TAB_G_5_reg   (*((volatile unsigned int*) DITHERING_TAB_G_5_reg))
+#define DITHERING_TAB_G_5_inst_adr                                                   "0x004F"
+#define DITHERING_TAB_G_5_inst                                                       0x004F
+#define DITHERING_TAB_G_5_Tab_G_53_shift                                             (18)
+#define DITHERING_TAB_G_5_Tab_G_53_mask                                              (0x00FC0000)
+#define DITHERING_TAB_G_5_Tab_G_53(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_5_Tab_G_53_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_5_get_Tab_G_53(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_5_Tab_G_52_shift                                             (12)
+#define DITHERING_TAB_G_5_Tab_G_52_mask                                              (0x0003F000)
+#define DITHERING_TAB_G_5_Tab_G_52(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_5_Tab_G_52_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_5_get_Tab_G_52(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_5_Tab_G_51_shift                                             (6)
+#define DITHERING_TAB_G_5_Tab_G_51_mask                                              (0x00000FC0)
+#define DITHERING_TAB_G_5_Tab_G_51(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_5_Tab_G_51_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_5_get_Tab_G_51(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_5_Tab_G_50_shift                                             (0)
+#define DITHERING_TAB_G_5_Tab_G_50_mask                                              (0x0000003F)
+#define DITHERING_TAB_G_5_Tab_G_50(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_5_Tab_G_50_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_5_get_Tab_G_50(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_6                                                            0x18009940
+#define DITHERING_TAB_G_6_reg_addr                                                   "0xB8009940"
+#define DITHERING_TAB_G_6_reg                                                        0xB8009940
+#define set_DITHERING_TAB_G_6_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_6_reg)=data)
+#define get_DITHERING_TAB_G_6_reg   (*((volatile unsigned int*) DITHERING_TAB_G_6_reg))
+#define DITHERING_TAB_G_6_inst_adr                                                   "0x0050"
+#define DITHERING_TAB_G_6_inst                                                       0x0050
+#define DITHERING_TAB_G_6_Tab_G_63_shift                                             (18)
+#define DITHERING_TAB_G_6_Tab_G_63_mask                                              (0x00FC0000)
+#define DITHERING_TAB_G_6_Tab_G_63(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_6_Tab_G_63_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_6_get_Tab_G_63(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_6_Tab_G_62_shift                                             (12)
+#define DITHERING_TAB_G_6_Tab_G_62_mask                                              (0x0003F000)
+#define DITHERING_TAB_G_6_Tab_G_62(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_6_Tab_G_62_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_6_get_Tab_G_62(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_6_Tab_G_61_shift                                             (6)
+#define DITHERING_TAB_G_6_Tab_G_61_mask                                              (0x00000FC0)
+#define DITHERING_TAB_G_6_Tab_G_61(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_6_Tab_G_61_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_6_get_Tab_G_61(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_6_Tab_G_60_shift                                             (0)
+#define DITHERING_TAB_G_6_Tab_G_60_mask                                              (0x0000003F)
+#define DITHERING_TAB_G_6_Tab_G_60(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_6_Tab_G_60_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_6_get_Tab_G_60(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_7                                                            0x18009944
+#define DITHERING_TAB_G_7_reg_addr                                                   "0xB8009944"
+#define DITHERING_TAB_G_7_reg                                                        0xB8009944
+#define set_DITHERING_TAB_G_7_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_7_reg)=data)
+#define get_DITHERING_TAB_G_7_reg   (*((volatile unsigned int*) DITHERING_TAB_G_7_reg))
+#define DITHERING_TAB_G_7_inst_adr                                                   "0x0051"
+#define DITHERING_TAB_G_7_inst                                                       0x0051
+#define DITHERING_TAB_G_7_Tab_G_73_shift                                             (18)
+#define DITHERING_TAB_G_7_Tab_G_73_mask                                              (0x00FC0000)
+#define DITHERING_TAB_G_7_Tab_G_73(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_7_Tab_G_73_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_7_get_Tab_G_73(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_7_Tab_G_72_shift                                             (12)
+#define DITHERING_TAB_G_7_Tab_G_72_mask                                              (0x0003F000)
+#define DITHERING_TAB_G_7_Tab_G_72(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_7_Tab_G_72_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_7_get_Tab_G_72(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_7_Tab_G_71_shift                                             (6)
+#define DITHERING_TAB_G_7_Tab_G_71_mask                                              (0x00000FC0)
+#define DITHERING_TAB_G_7_Tab_G_71(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_7_Tab_G_71_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_7_get_Tab_G_71(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_7_Tab_G_70_shift                                             (0)
+#define DITHERING_TAB_G_7_Tab_G_70_mask                                              (0x0000003F)
+#define DITHERING_TAB_G_7_Tab_G_70(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_7_Tab_G_70_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_7_get_Tab_G_70(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_8                                                            0x18009948
+#define DITHERING_TAB_G_8_reg_addr                                                   "0xB8009948"
+#define DITHERING_TAB_G_8_reg                                                        0xB8009948
+#define set_DITHERING_TAB_G_8_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_8_reg)=data)
+#define get_DITHERING_TAB_G_8_reg   (*((volatile unsigned int*) DITHERING_TAB_G_8_reg))
+#define DITHERING_TAB_G_8_inst_adr                                                   "0x0052"
+#define DITHERING_TAB_G_8_inst                                                       0x0052
+#define DITHERING_TAB_G_8_Tab_G_83_shift                                             (18)
+#define DITHERING_TAB_G_8_Tab_G_83_mask                                              (0x00FC0000)
+#define DITHERING_TAB_G_8_Tab_G_83(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_8_Tab_G_83_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_8_get_Tab_G_83(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_8_Tab_G_82_shift                                             (12)
+#define DITHERING_TAB_G_8_Tab_G_82_mask                                              (0x0003F000)
+#define DITHERING_TAB_G_8_Tab_G_82(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_8_Tab_G_82_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_8_get_Tab_G_82(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_8_Tab_G_81_shift                                             (6)
+#define DITHERING_TAB_G_8_Tab_G_81_mask                                              (0x00000FC0)
+#define DITHERING_TAB_G_8_Tab_G_81(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_8_Tab_G_81_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_8_get_Tab_G_81(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_8_Tab_G_80_shift                                             (0)
+#define DITHERING_TAB_G_8_Tab_G_80_mask                                              (0x0000003F)
+#define DITHERING_TAB_G_8_Tab_G_80(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_8_Tab_G_80_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_8_get_Tab_G_80(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_9                                                            0x1800994c
+#define DITHERING_TAB_G_9_reg_addr                                                   "0xB800994C"
+#define DITHERING_TAB_G_9_reg                                                        0xB800994C
+#define set_DITHERING_TAB_G_9_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_9_reg)=data)
+#define get_DITHERING_TAB_G_9_reg   (*((volatile unsigned int*) DITHERING_TAB_G_9_reg))
+#define DITHERING_TAB_G_9_inst_adr                                                   "0x0053"
+#define DITHERING_TAB_G_9_inst                                                       0x0053
+#define DITHERING_TAB_G_9_Tab_G_93_shift                                             (18)
+#define DITHERING_TAB_G_9_Tab_G_93_mask                                              (0x00FC0000)
+#define DITHERING_TAB_G_9_Tab_G_93(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_9_Tab_G_93_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_9_get_Tab_G_93(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_9_Tab_G_92_shift                                             (12)
+#define DITHERING_TAB_G_9_Tab_G_92_mask                                              (0x0003F000)
+#define DITHERING_TAB_G_9_Tab_G_92(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_9_Tab_G_92_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_9_get_Tab_G_92(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_9_Tab_G_91_shift                                             (6)
+#define DITHERING_TAB_G_9_Tab_G_91_mask                                              (0x00000FC0)
+#define DITHERING_TAB_G_9_Tab_G_91(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_9_Tab_G_91_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_9_get_Tab_G_91(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_9_Tab_G_90_shift                                             (0)
+#define DITHERING_TAB_G_9_Tab_G_90_mask                                              (0x0000003F)
+#define DITHERING_TAB_G_9_Tab_G_90(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_9_Tab_G_90_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_9_get_Tab_G_90(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_10                                                           0x18009950
+#define DITHERING_TAB_G_10_reg_addr                                                  "0xB8009950"
+#define DITHERING_TAB_G_10_reg                                                       0xB8009950
+#define set_DITHERING_TAB_G_10_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_10_reg)=data)
+#define get_DITHERING_TAB_G_10_reg   (*((volatile unsigned int*) DITHERING_TAB_G_10_reg))
+#define DITHERING_TAB_G_10_inst_adr                                                  "0x0054"
+#define DITHERING_TAB_G_10_inst                                                      0x0054
+#define DITHERING_TAB_G_10_Tab_G_A3_shift                                            (18)
+#define DITHERING_TAB_G_10_Tab_G_A3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_G_10_Tab_G_A3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_10_Tab_G_A3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_10_get_Tab_G_A3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_10_Tab_G_A2_shift                                            (12)
+#define DITHERING_TAB_G_10_Tab_G_A2_mask                                             (0x0003F000)
+#define DITHERING_TAB_G_10_Tab_G_A2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_10_Tab_G_A2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_10_get_Tab_G_A2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_10_Tab_G_A1_shift                                            (6)
+#define DITHERING_TAB_G_10_Tab_G_A1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_G_10_Tab_G_A1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_10_Tab_G_A1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_10_get_Tab_G_A1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_10_Tab_G_A0_shift                                            (0)
+#define DITHERING_TAB_G_10_Tab_G_A0_mask                                             (0x0000003F)
+#define DITHERING_TAB_G_10_Tab_G_A0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_10_Tab_G_A0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_10_get_Tab_G_A0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_11                                                           0x18009954
+#define DITHERING_TAB_G_11_reg_addr                                                  "0xB8009954"
+#define DITHERING_TAB_G_11_reg                                                       0xB8009954
+#define set_DITHERING_TAB_G_11_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_11_reg)=data)
+#define get_DITHERING_TAB_G_11_reg   (*((volatile unsigned int*) DITHERING_TAB_G_11_reg))
+#define DITHERING_TAB_G_11_inst_adr                                                  "0x0055"
+#define DITHERING_TAB_G_11_inst                                                      0x0055
+#define DITHERING_TAB_G_11_Tab_G_B3_shift                                            (18)
+#define DITHERING_TAB_G_11_Tab_G_B3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_G_11_Tab_G_B3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_11_Tab_G_B3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_11_get_Tab_G_B3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_11_Tab_G_B2_shift                                            (12)
+#define DITHERING_TAB_G_11_Tab_G_B2_mask                                             (0x0003F000)
+#define DITHERING_TAB_G_11_Tab_G_B2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_11_Tab_G_B2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_11_get_Tab_G_B2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_11_Tab_G_B1_shift                                            (6)
+#define DITHERING_TAB_G_11_Tab_G_B1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_G_11_Tab_G_B1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_11_Tab_G_B1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_11_get_Tab_G_B1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_11_Tab_G_B0_shift                                            (0)
+#define DITHERING_TAB_G_11_Tab_G_B0_mask                                             (0x0000003F)
+#define DITHERING_TAB_G_11_Tab_G_B0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_11_Tab_G_B0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_11_get_Tab_G_B0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_12                                                           0x18009958
+#define DITHERING_TAB_G_12_reg_addr                                                  "0xB8009958"
+#define DITHERING_TAB_G_12_reg                                                       0xB8009958
+#define set_DITHERING_TAB_G_12_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_12_reg)=data)
+#define get_DITHERING_TAB_G_12_reg   (*((volatile unsigned int*) DITHERING_TAB_G_12_reg))
+#define DITHERING_TAB_G_12_inst_adr                                                  "0x0056"
+#define DITHERING_TAB_G_12_inst                                                      0x0056
+#define DITHERING_TAB_G_12_Tab_G_C3_shift                                            (18)
+#define DITHERING_TAB_G_12_Tab_G_C3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_G_12_Tab_G_C3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_12_Tab_G_C3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_12_get_Tab_G_C3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_12_Tab_G_C2_shift                                            (12)
+#define DITHERING_TAB_G_12_Tab_G_C2_mask                                             (0x0003F000)
+#define DITHERING_TAB_G_12_Tab_G_C2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_12_Tab_G_C2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_12_get_Tab_G_C2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_12_Tab_G_C1_shift                                            (6)
+#define DITHERING_TAB_G_12_Tab_G_C1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_G_12_Tab_G_C1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_12_Tab_G_C1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_12_get_Tab_G_C1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_12_Tab_G_C0_shift                                            (0)
+#define DITHERING_TAB_G_12_Tab_G_C0_mask                                             (0x0000003F)
+#define DITHERING_TAB_G_12_Tab_G_C0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_12_Tab_G_C0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_12_get_Tab_G_C0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_13                                                           0x1800995c
+#define DITHERING_TAB_G_13_reg_addr                                                  "0xB800995C"
+#define DITHERING_TAB_G_13_reg                                                       0xB800995C
+#define set_DITHERING_TAB_G_13_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_13_reg)=data)
+#define get_DITHERING_TAB_G_13_reg   (*((volatile unsigned int*) DITHERING_TAB_G_13_reg))
+#define DITHERING_TAB_G_13_inst_adr                                                  "0x0057"
+#define DITHERING_TAB_G_13_inst                                                      0x0057
+#define DITHERING_TAB_G_13_Tab_G_D3_shift                                            (18)
+#define DITHERING_TAB_G_13_Tab_G_D3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_G_13_Tab_G_D3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_13_Tab_G_D3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_13_get_Tab_G_D3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_13_Tab_G_D2_shift                                            (12)
+#define DITHERING_TAB_G_13_Tab_G_D2_mask                                             (0x0003F000)
+#define DITHERING_TAB_G_13_Tab_G_D2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_13_Tab_G_D2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_13_get_Tab_G_D2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_13_Tab_G_D1_shift                                            (6)
+#define DITHERING_TAB_G_13_Tab_G_D1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_G_13_Tab_G_D1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_13_Tab_G_D1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_13_get_Tab_G_D1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_13_Tab_G_D0_shift                                            (0)
+#define DITHERING_TAB_G_13_Tab_G_D0_mask                                             (0x0000003F)
+#define DITHERING_TAB_G_13_Tab_G_D0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_13_Tab_G_D0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_13_get_Tab_G_D0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_14                                                           0x18009960
+#define DITHERING_TAB_G_14_reg_addr                                                  "0xB8009960"
+#define DITHERING_TAB_G_14_reg                                                       0xB8009960
+#define set_DITHERING_TAB_G_14_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_14_reg)=data)
+#define get_DITHERING_TAB_G_14_reg   (*((volatile unsigned int*) DITHERING_TAB_G_14_reg))
+#define DITHERING_TAB_G_14_inst_adr                                                  "0x0058"
+#define DITHERING_TAB_G_14_inst                                                      0x0058
+#define DITHERING_TAB_G_14_Tab_G_E3_shift                                            (18)
+#define DITHERING_TAB_G_14_Tab_G_E3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_G_14_Tab_G_E3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_14_Tab_G_E3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_14_get_Tab_G_E3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_14_Tab_G_E2_shift                                            (12)
+#define DITHERING_TAB_G_14_Tab_G_E2_mask                                             (0x0003F000)
+#define DITHERING_TAB_G_14_Tab_G_E2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_14_Tab_G_E2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_14_get_Tab_G_E2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_14_Tab_G_E1_shift                                            (6)
+#define DITHERING_TAB_G_14_Tab_G_E1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_G_14_Tab_G_E1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_14_Tab_G_E1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_14_get_Tab_G_E1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_14_Tab_G_E0_shift                                            (0)
+#define DITHERING_TAB_G_14_Tab_G_E0_mask                                             (0x0000003F)
+#define DITHERING_TAB_G_14_Tab_G_E0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_14_Tab_G_E0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_14_get_Tab_G_E0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_G_15                                                           0x18009964
+#define DITHERING_TAB_G_15_reg_addr                                                  "0xB8009964"
+#define DITHERING_TAB_G_15_reg                                                       0xB8009964
+#define set_DITHERING_TAB_G_15_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_G_15_reg)=data)
+#define get_DITHERING_TAB_G_15_reg   (*((volatile unsigned int*) DITHERING_TAB_G_15_reg))
+#define DITHERING_TAB_G_15_inst_adr                                                  "0x0059"
+#define DITHERING_TAB_G_15_inst                                                      0x0059
+#define DITHERING_TAB_G_15_Tab_G_F3_shift                                            (18)
+#define DITHERING_TAB_G_15_Tab_G_F3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_G_15_Tab_G_F3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_G_15_Tab_G_F3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_15_get_Tab_G_F3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_G_15_Tab_G_F2_shift                                            (12)
+#define DITHERING_TAB_G_15_Tab_G_F2_mask                                             (0x0003F000)
+#define DITHERING_TAB_G_15_Tab_G_F2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_G_15_Tab_G_F2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_15_get_Tab_G_F2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_G_15_Tab_G_F1_shift                                            (6)
+#define DITHERING_TAB_G_15_Tab_G_F1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_G_15_Tab_G_F1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_G_15_Tab_G_F1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_15_get_Tab_G_F1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_G_15_Tab_G_F0_shift                                            (0)
+#define DITHERING_TAB_G_15_Tab_G_F0_mask                                             (0x0000003F)
+#define DITHERING_TAB_G_15_Tab_G_F0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_G_15_Tab_G_F0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_G_15_get_Tab_G_F0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_0                                                            0x18009968
+#define DITHERING_TAB_B_0_reg_addr                                                   "0xB8009968"
+#define DITHERING_TAB_B_0_reg                                                        0xB8009968
+#define set_DITHERING_TAB_B_0_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_0_reg)=data)
+#define get_DITHERING_TAB_B_0_reg   (*((volatile unsigned int*) DITHERING_TAB_B_0_reg))
+#define DITHERING_TAB_B_0_inst_adr                                                   "0x005A"
+#define DITHERING_TAB_B_0_inst                                                       0x005A
+#define DITHERING_TAB_B_0_Tab_B_03_shift                                             (18)
+#define DITHERING_TAB_B_0_Tab_B_03_mask                                              (0x00FC0000)
+#define DITHERING_TAB_B_0_Tab_B_03(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_0_Tab_B_03_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_0_get_Tab_B_03(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_0_Tab_B_02_shift                                             (12)
+#define DITHERING_TAB_B_0_Tab_B_02_mask                                              (0x0003F000)
+#define DITHERING_TAB_B_0_Tab_B_02(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_0_Tab_B_02_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_0_get_Tab_B_02(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_0_Tab_B_01_shift                                             (6)
+#define DITHERING_TAB_B_0_Tab_B_01_mask                                              (0x00000FC0)
+#define DITHERING_TAB_B_0_Tab_B_01(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_0_Tab_B_01_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_0_get_Tab_B_01(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_0_Tab_B_00_shift                                             (0)
+#define DITHERING_TAB_B_0_Tab_B_00_mask                                              (0x0000003F)
+#define DITHERING_TAB_B_0_Tab_B_00(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_0_Tab_B_00_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_0_get_Tab_B_00(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_1                                                            0x1800996c
+#define DITHERING_TAB_B_1_reg_addr                                                   "0xB800996C"
+#define DITHERING_TAB_B_1_reg                                                        0xB800996C
+#define set_DITHERING_TAB_B_1_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_1_reg)=data)
+#define get_DITHERING_TAB_B_1_reg   (*((volatile unsigned int*) DITHERING_TAB_B_1_reg))
+#define DITHERING_TAB_B_1_inst_adr                                                   "0x005B"
+#define DITHERING_TAB_B_1_inst                                                       0x005B
+#define DITHERING_TAB_B_1_Tab_B_13_shift                                             (18)
+#define DITHERING_TAB_B_1_Tab_B_13_mask                                              (0x00FC0000)
+#define DITHERING_TAB_B_1_Tab_B_13(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_1_Tab_B_13_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_1_get_Tab_B_13(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_1_Tab_B_12_shift                                             (12)
+#define DITHERING_TAB_B_1_Tab_B_12_mask                                              (0x0003F000)
+#define DITHERING_TAB_B_1_Tab_B_12(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_1_Tab_B_12_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_1_get_Tab_B_12(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_1_Tab_B_11_shift                                             (6)
+#define DITHERING_TAB_B_1_Tab_B_11_mask                                              (0x00000FC0)
+#define DITHERING_TAB_B_1_Tab_B_11(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_1_Tab_B_11_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_1_get_Tab_B_11(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_1_Tab_B_10_shift                                             (0)
+#define DITHERING_TAB_B_1_Tab_B_10_mask                                              (0x0000003F)
+#define DITHERING_TAB_B_1_Tab_B_10(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_1_Tab_B_10_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_1_get_Tab_B_10(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_2                                                            0x18009970
+#define DITHERING_TAB_B_2_reg_addr                                                   "0xB8009970"
+#define DITHERING_TAB_B_2_reg                                                        0xB8009970
+#define set_DITHERING_TAB_B_2_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_2_reg)=data)
+#define get_DITHERING_TAB_B_2_reg   (*((volatile unsigned int*) DITHERING_TAB_B_2_reg))
+#define DITHERING_TAB_B_2_inst_adr                                                   "0x005C"
+#define DITHERING_TAB_B_2_inst                                                       0x005C
+#define DITHERING_TAB_B_2_Tab_B_23_shift                                             (18)
+#define DITHERING_TAB_B_2_Tab_B_23_mask                                              (0x00FC0000)
+#define DITHERING_TAB_B_2_Tab_B_23(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_2_Tab_B_23_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_2_get_Tab_B_23(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_2_Tab_B_22_shift                                             (12)
+#define DITHERING_TAB_B_2_Tab_B_22_mask                                              (0x0003F000)
+#define DITHERING_TAB_B_2_Tab_B_22(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_2_Tab_B_22_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_2_get_Tab_B_22(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_2_Tab_B_21_shift                                             (6)
+#define DITHERING_TAB_B_2_Tab_B_21_mask                                              (0x00000FC0)
+#define DITHERING_TAB_B_2_Tab_B_21(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_2_Tab_B_21_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_2_get_Tab_B_21(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_2_Tab_B_20_shift                                             (0)
+#define DITHERING_TAB_B_2_Tab_B_20_mask                                              (0x0000003F)
+#define DITHERING_TAB_B_2_Tab_B_20(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_2_Tab_B_20_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_2_get_Tab_B_20(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_3                                                            0x18009974
+#define DITHERING_TAB_B_3_reg_addr                                                   "0xB8009974"
+#define DITHERING_TAB_B_3_reg                                                        0xB8009974
+#define set_DITHERING_TAB_B_3_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_3_reg)=data)
+#define get_DITHERING_TAB_B_3_reg   (*((volatile unsigned int*) DITHERING_TAB_B_3_reg))
+#define DITHERING_TAB_B_3_inst_adr                                                   "0x005D"
+#define DITHERING_TAB_B_3_inst                                                       0x005D
+#define DITHERING_TAB_B_3_Tab_B_33_shift                                             (18)
+#define DITHERING_TAB_B_3_Tab_B_33_mask                                              (0x00FC0000)
+#define DITHERING_TAB_B_3_Tab_B_33(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_3_Tab_B_33_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_3_get_Tab_B_33(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_3_Tab_B_32_shift                                             (12)
+#define DITHERING_TAB_B_3_Tab_B_32_mask                                              (0x0003F000)
+#define DITHERING_TAB_B_3_Tab_B_32(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_3_Tab_B_32_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_3_get_Tab_B_32(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_3_Tab_B_31_shift                                             (6)
+#define DITHERING_TAB_B_3_Tab_B_31_mask                                              (0x00000FC0)
+#define DITHERING_TAB_B_3_Tab_B_31(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_3_Tab_B_31_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_3_get_Tab_B_31(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_3_Tab_B_30_shift                                             (0)
+#define DITHERING_TAB_B_3_Tab_B_30_mask                                              (0x0000003F)
+#define DITHERING_TAB_B_3_Tab_B_30(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_3_Tab_B_30_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_3_get_Tab_B_30(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_4                                                            0x18009978
+#define DITHERING_TAB_B_4_reg_addr                                                   "0xB8009978"
+#define DITHERING_TAB_B_4_reg                                                        0xB8009978
+#define set_DITHERING_TAB_B_4_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_4_reg)=data)
+#define get_DITHERING_TAB_B_4_reg   (*((volatile unsigned int*) DITHERING_TAB_B_4_reg))
+#define DITHERING_TAB_B_4_inst_adr                                                   "0x005E"
+#define DITHERING_TAB_B_4_inst                                                       0x005E
+#define DITHERING_TAB_B_4_Tab_B_43_shift                                             (18)
+#define DITHERING_TAB_B_4_Tab_B_43_mask                                              (0x00FC0000)
+#define DITHERING_TAB_B_4_Tab_B_43(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_4_Tab_B_43_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_4_get_Tab_B_43(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_4_Tab_B_42_shift                                             (12)
+#define DITHERING_TAB_B_4_Tab_B_42_mask                                              (0x0003F000)
+#define DITHERING_TAB_B_4_Tab_B_42(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_4_Tab_B_42_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_4_get_Tab_B_42(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_4_Tab_B_41_shift                                             (6)
+#define DITHERING_TAB_B_4_Tab_B_41_mask                                              (0x00000FC0)
+#define DITHERING_TAB_B_4_Tab_B_41(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_4_Tab_B_41_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_4_get_Tab_B_41(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_4_Tab_B_40_shift                                             (0)
+#define DITHERING_TAB_B_4_Tab_B_40_mask                                              (0x0000003F)
+#define DITHERING_TAB_B_4_Tab_B_40(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_4_Tab_B_40_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_4_get_Tab_B_40(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_5                                                            0x1800997c
+#define DITHERING_TAB_B_5_reg_addr                                                   "0xB800997C"
+#define DITHERING_TAB_B_5_reg                                                        0xB800997C
+#define set_DITHERING_TAB_B_5_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_5_reg)=data)
+#define get_DITHERING_TAB_B_5_reg   (*((volatile unsigned int*) DITHERING_TAB_B_5_reg))
+#define DITHERING_TAB_B_5_inst_adr                                                   "0x005F"
+#define DITHERING_TAB_B_5_inst                                                       0x005F
+#define DITHERING_TAB_B_5_Tab_B_53_shift                                             (18)
+#define DITHERING_TAB_B_5_Tab_B_53_mask                                              (0x00FC0000)
+#define DITHERING_TAB_B_5_Tab_B_53(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_5_Tab_B_53_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_5_get_Tab_B_53(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_5_Tab_B_52_shift                                             (12)
+#define DITHERING_TAB_B_5_Tab_B_52_mask                                              (0x0003F000)
+#define DITHERING_TAB_B_5_Tab_B_52(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_5_Tab_B_52_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_5_get_Tab_B_52(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_5_Tab_B_51_shift                                             (6)
+#define DITHERING_TAB_B_5_Tab_B_51_mask                                              (0x00000FC0)
+#define DITHERING_TAB_B_5_Tab_B_51(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_5_Tab_B_51_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_5_get_Tab_B_51(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_5_Tab_B_50_shift                                             (0)
+#define DITHERING_TAB_B_5_Tab_B_50_mask                                              (0x0000003F)
+#define DITHERING_TAB_B_5_Tab_B_50(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_5_Tab_B_50_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_5_get_Tab_B_50(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_6                                                            0x18009980
+#define DITHERING_TAB_B_6_reg_addr                                                   "0xB8009980"
+#define DITHERING_TAB_B_6_reg                                                        0xB8009980
+#define set_DITHERING_TAB_B_6_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_6_reg)=data)
+#define get_DITHERING_TAB_B_6_reg   (*((volatile unsigned int*) DITHERING_TAB_B_6_reg))
+#define DITHERING_TAB_B_6_inst_adr                                                   "0x0060"
+#define DITHERING_TAB_B_6_inst                                                       0x0060
+#define DITHERING_TAB_B_6_Tab_B_63_shift                                             (18)
+#define DITHERING_TAB_B_6_Tab_B_63_mask                                              (0x00FC0000)
+#define DITHERING_TAB_B_6_Tab_B_63(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_6_Tab_B_63_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_6_get_Tab_B_63(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_6_Tab_B_62_shift                                             (12)
+#define DITHERING_TAB_B_6_Tab_B_62_mask                                              (0x0003F000)
+#define DITHERING_TAB_B_6_Tab_B_62(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_6_Tab_B_62_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_6_get_Tab_B_62(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_6_Tab_B_61_shift                                             (6)
+#define DITHERING_TAB_B_6_Tab_B_61_mask                                              (0x00000FC0)
+#define DITHERING_TAB_B_6_Tab_B_61(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_6_Tab_B_61_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_6_get_Tab_B_61(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_6_Tab_B_60_shift                                             (0)
+#define DITHERING_TAB_B_6_Tab_B_60_mask                                              (0x0000003F)
+#define DITHERING_TAB_B_6_Tab_B_60(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_6_Tab_B_60_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_6_get_Tab_B_60(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_7                                                            0x18009984
+#define DITHERING_TAB_B_7_reg_addr                                                   "0xB8009984"
+#define DITHERING_TAB_B_7_reg                                                        0xB8009984
+#define set_DITHERING_TAB_B_7_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_7_reg)=data)
+#define get_DITHERING_TAB_B_7_reg   (*((volatile unsigned int*) DITHERING_TAB_B_7_reg))
+#define DITHERING_TAB_B_7_inst_adr                                                   "0x0061"
+#define DITHERING_TAB_B_7_inst                                                       0x0061
+#define DITHERING_TAB_B_7_Tab_B_73_shift                                             (18)
+#define DITHERING_TAB_B_7_Tab_B_73_mask                                              (0x00FC0000)
+#define DITHERING_TAB_B_7_Tab_B_73(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_7_Tab_B_73_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_7_get_Tab_B_73(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_7_Tab_B_72_shift                                             (12)
+#define DITHERING_TAB_B_7_Tab_B_72_mask                                              (0x0003F000)
+#define DITHERING_TAB_B_7_Tab_B_72(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_7_Tab_B_72_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_7_get_Tab_B_72(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_7_Tab_B_71_shift                                             (6)
+#define DITHERING_TAB_B_7_Tab_B_71_mask                                              (0x00000FC0)
+#define DITHERING_TAB_B_7_Tab_B_71(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_7_Tab_B_71_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_7_get_Tab_B_71(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_7_Tab_B_70_shift                                             (0)
+#define DITHERING_TAB_B_7_Tab_B_70_mask                                              (0x0000003F)
+#define DITHERING_TAB_B_7_Tab_B_70(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_7_Tab_B_70_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_7_get_Tab_B_70(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_8                                                            0x18009988
+#define DITHERING_TAB_B_8_reg_addr                                                   "0xB8009988"
+#define DITHERING_TAB_B_8_reg                                                        0xB8009988
+#define set_DITHERING_TAB_B_8_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_8_reg)=data)
+#define get_DITHERING_TAB_B_8_reg   (*((volatile unsigned int*) DITHERING_TAB_B_8_reg))
+#define DITHERING_TAB_B_8_inst_adr                                                   "0x0062"
+#define DITHERING_TAB_B_8_inst                                                       0x0062
+#define DITHERING_TAB_B_8_Tab_B_83_shift                                             (18)
+#define DITHERING_TAB_B_8_Tab_B_83_mask                                              (0x00FC0000)
+#define DITHERING_TAB_B_8_Tab_B_83(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_8_Tab_B_83_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_8_get_Tab_B_83(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_8_Tab_B_82_shift                                             (12)
+#define DITHERING_TAB_B_8_Tab_B_82_mask                                              (0x0003F000)
+#define DITHERING_TAB_B_8_Tab_B_82(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_8_Tab_B_82_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_8_get_Tab_B_82(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_8_Tab_B_81_shift                                             (6)
+#define DITHERING_TAB_B_8_Tab_B_81_mask                                              (0x00000FC0)
+#define DITHERING_TAB_B_8_Tab_B_81(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_8_Tab_B_81_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_8_get_Tab_B_81(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_8_Tab_B_80_shift                                             (0)
+#define DITHERING_TAB_B_8_Tab_B_80_mask                                              (0x0000003F)
+#define DITHERING_TAB_B_8_Tab_B_80(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_8_Tab_B_80_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_8_get_Tab_B_80(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_9                                                            0x1800998c
+#define DITHERING_TAB_B_9_reg_addr                                                   "0xB800998C"
+#define DITHERING_TAB_B_9_reg                                                        0xB800998C
+#define set_DITHERING_TAB_B_9_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_9_reg)=data)
+#define get_DITHERING_TAB_B_9_reg   (*((volatile unsigned int*) DITHERING_TAB_B_9_reg))
+#define DITHERING_TAB_B_9_inst_adr                                                   "0x0063"
+#define DITHERING_TAB_B_9_inst                                                       0x0063
+#define DITHERING_TAB_B_9_Tab_B_93_shift                                             (18)
+#define DITHERING_TAB_B_9_Tab_B_93_mask                                              (0x00FC0000)
+#define DITHERING_TAB_B_9_Tab_B_93(data)                                             (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_9_Tab_B_93_src(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_9_get_Tab_B_93(data)                                         ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_9_Tab_B_92_shift                                             (12)
+#define DITHERING_TAB_B_9_Tab_B_92_mask                                              (0x0003F000)
+#define DITHERING_TAB_B_9_Tab_B_92(data)                                             (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_9_Tab_B_92_src(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_9_get_Tab_B_92(data)                                         ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_9_Tab_B_91_shift                                             (6)
+#define DITHERING_TAB_B_9_Tab_B_91_mask                                              (0x00000FC0)
+#define DITHERING_TAB_B_9_Tab_B_91(data)                                             (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_9_Tab_B_91_src(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_9_get_Tab_B_91(data)                                         ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_9_Tab_B_90_shift                                             (0)
+#define DITHERING_TAB_B_9_Tab_B_90_mask                                              (0x0000003F)
+#define DITHERING_TAB_B_9_Tab_B_90(data)                                             (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_9_Tab_B_90_src(data)                                         ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_9_get_Tab_B_90(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_10                                                           0x18009990
+#define DITHERING_TAB_B_10_reg_addr                                                  "0xB8009990"
+#define DITHERING_TAB_B_10_reg                                                       0xB8009990
+#define set_DITHERING_TAB_B_10_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_10_reg)=data)
+#define get_DITHERING_TAB_B_10_reg   (*((volatile unsigned int*) DITHERING_TAB_B_10_reg))
+#define DITHERING_TAB_B_10_inst_adr                                                  "0x0064"
+#define DITHERING_TAB_B_10_inst                                                      0x0064
+#define DITHERING_TAB_B_10_Tab_B_A3_shift                                            (18)
+#define DITHERING_TAB_B_10_Tab_B_A3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_B_10_Tab_B_A3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_10_Tab_B_A3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_10_get_Tab_B_A3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_10_Tab_B_A2_shift                                            (12)
+#define DITHERING_TAB_B_10_Tab_B_A2_mask                                             (0x0003F000)
+#define DITHERING_TAB_B_10_Tab_B_A2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_10_Tab_B_A2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_10_get_Tab_B_A2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_10_Tab_B_A1_shift                                            (6)
+#define DITHERING_TAB_B_10_Tab_B_A1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_B_10_Tab_B_A1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_10_Tab_B_A1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_10_get_Tab_B_A1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_10_Tab_B_A0_shift                                            (0)
+#define DITHERING_TAB_B_10_Tab_B_A0_mask                                             (0x0000003F)
+#define DITHERING_TAB_B_10_Tab_B_A0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_10_Tab_B_A0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_10_get_Tab_B_A0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_11                                                           0x18009994
+#define DITHERING_TAB_B_11_reg_addr                                                  "0xB8009994"
+#define DITHERING_TAB_B_11_reg                                                       0xB8009994
+#define set_DITHERING_TAB_B_11_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_11_reg)=data)
+#define get_DITHERING_TAB_B_11_reg   (*((volatile unsigned int*) DITHERING_TAB_B_11_reg))
+#define DITHERING_TAB_B_11_inst_adr                                                  "0x0065"
+#define DITHERING_TAB_B_11_inst                                                      0x0065
+#define DITHERING_TAB_B_11_Tab_B_B3_shift                                            (18)
+#define DITHERING_TAB_B_11_Tab_B_B3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_B_11_Tab_B_B3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_11_Tab_B_B3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_11_get_Tab_B_B3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_11_Tab_B_B2_shift                                            (12)
+#define DITHERING_TAB_B_11_Tab_B_B2_mask                                             (0x0003F000)
+#define DITHERING_TAB_B_11_Tab_B_B2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_11_Tab_B_B2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_11_get_Tab_B_B2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_11_Tab_B_B1_shift                                            (6)
+#define DITHERING_TAB_B_11_Tab_B_B1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_B_11_Tab_B_B1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_11_Tab_B_B1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_11_get_Tab_B_B1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_11_Tab_B_B0_shift                                            (0)
+#define DITHERING_TAB_B_11_Tab_B_B0_mask                                             (0x0000003F)
+#define DITHERING_TAB_B_11_Tab_B_B0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_11_Tab_B_B0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_11_get_Tab_B_B0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_12                                                           0x18009998
+#define DITHERING_TAB_B_12_reg_addr                                                  "0xB8009998"
+#define DITHERING_TAB_B_12_reg                                                       0xB8009998
+#define set_DITHERING_TAB_B_12_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_12_reg)=data)
+#define get_DITHERING_TAB_B_12_reg   (*((volatile unsigned int*) DITHERING_TAB_B_12_reg))
+#define DITHERING_TAB_B_12_inst_adr                                                  "0x0066"
+#define DITHERING_TAB_B_12_inst                                                      0x0066
+#define DITHERING_TAB_B_12_Tab_B_C3_shift                                            (18)
+#define DITHERING_TAB_B_12_Tab_B_C3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_B_12_Tab_B_C3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_12_Tab_B_C3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_12_get_Tab_B_C3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_12_Tab_B_C2_shift                                            (12)
+#define DITHERING_TAB_B_12_Tab_B_C2_mask                                             (0x0003F000)
+#define DITHERING_TAB_B_12_Tab_B_C2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_12_Tab_B_C2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_12_get_Tab_B_C2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_12_Tab_B_C1_shift                                            (6)
+#define DITHERING_TAB_B_12_Tab_B_C1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_B_12_Tab_B_C1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_12_Tab_B_C1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_12_get_Tab_B_C1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_12_Tab_B_C0_shift                                            (0)
+#define DITHERING_TAB_B_12_Tab_B_C0_mask                                             (0x0000003F)
+#define DITHERING_TAB_B_12_Tab_B_C0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_12_Tab_B_C0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_12_get_Tab_B_C0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_13                                                           0x1800999c
+#define DITHERING_TAB_B_13_reg_addr                                                  "0xB800999C"
+#define DITHERING_TAB_B_13_reg                                                       0xB800999C
+#define set_DITHERING_TAB_B_13_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_13_reg)=data)
+#define get_DITHERING_TAB_B_13_reg   (*((volatile unsigned int*) DITHERING_TAB_B_13_reg))
+#define DITHERING_TAB_B_13_inst_adr                                                  "0x0067"
+#define DITHERING_TAB_B_13_inst                                                      0x0067
+#define DITHERING_TAB_B_13_Tab_B_D3_shift                                            (18)
+#define DITHERING_TAB_B_13_Tab_B_D3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_B_13_Tab_B_D3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_13_Tab_B_D3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_13_get_Tab_B_D3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_13_Tab_B_D2_shift                                            (12)
+#define DITHERING_TAB_B_13_Tab_B_D2_mask                                             (0x0003F000)
+#define DITHERING_TAB_B_13_Tab_B_D2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_13_Tab_B_D2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_13_get_Tab_B_D2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_13_Tab_B_D1_shift                                            (6)
+#define DITHERING_TAB_B_13_Tab_B_D1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_B_13_Tab_B_D1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_13_Tab_B_D1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_13_get_Tab_B_D1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_13_Tab_B_D0_shift                                            (0)
+#define DITHERING_TAB_B_13_Tab_B_D0_mask                                             (0x0000003F)
+#define DITHERING_TAB_B_13_Tab_B_D0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_13_Tab_B_D0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_13_get_Tab_B_D0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_14                                                           0x180099a0
+#define DITHERING_TAB_B_14_reg_addr                                                  "0xB80099A0"
+#define DITHERING_TAB_B_14_reg                                                       0xB80099A0
+#define set_DITHERING_TAB_B_14_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_14_reg)=data)
+#define get_DITHERING_TAB_B_14_reg   (*((volatile unsigned int*) DITHERING_TAB_B_14_reg))
+#define DITHERING_TAB_B_14_inst_adr                                                  "0x0068"
+#define DITHERING_TAB_B_14_inst                                                      0x0068
+#define DITHERING_TAB_B_14_Tab_B_E3_shift                                            (18)
+#define DITHERING_TAB_B_14_Tab_B_E3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_B_14_Tab_B_E3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_14_Tab_B_E3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_14_get_Tab_B_E3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_14_Tab_B_E2_shift                                            (12)
+#define DITHERING_TAB_B_14_Tab_B_E2_mask                                             (0x0003F000)
+#define DITHERING_TAB_B_14_Tab_B_E2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_14_Tab_B_E2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_14_get_Tab_B_E2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_14_Tab_B_E1_shift                                            (6)
+#define DITHERING_TAB_B_14_Tab_B_E1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_B_14_Tab_B_E1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_14_Tab_B_E1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_14_get_Tab_B_E1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_14_Tab_B_E0_shift                                            (0)
+#define DITHERING_TAB_B_14_Tab_B_E0_mask                                             (0x0000003F)
+#define DITHERING_TAB_B_14_Tab_B_E0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_14_Tab_B_E0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_14_get_Tab_B_E0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define DITHERING_TAB_B_15                                                           0x180099a4
+#define DITHERING_TAB_B_15_reg_addr                                                  "0xB80099A4"
+#define DITHERING_TAB_B_15_reg                                                       0xB80099A4
+#define set_DITHERING_TAB_B_15_reg(data)   (*((volatile unsigned int*) DITHERING_TAB_B_15_reg)=data)
+#define get_DITHERING_TAB_B_15_reg   (*((volatile unsigned int*) DITHERING_TAB_B_15_reg))
+#define DITHERING_TAB_B_15_inst_adr                                                  "0x0069"
+#define DITHERING_TAB_B_15_inst                                                      0x0069
+#define DITHERING_TAB_B_15_Tab_B_F3_shift                                            (18)
+#define DITHERING_TAB_B_15_Tab_B_F3_mask                                             (0x00FC0000)
+#define DITHERING_TAB_B_15_Tab_B_F3(data)                                            (0x00FC0000&((data)<<18))
+#define DITHERING_TAB_B_15_Tab_B_F3_src(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_15_get_Tab_B_F3(data)                                        ((0x00FC0000&(data))>>18)
+#define DITHERING_TAB_B_15_Tab_B_F2_shift                                            (12)
+#define DITHERING_TAB_B_15_Tab_B_F2_mask                                             (0x0003F000)
+#define DITHERING_TAB_B_15_Tab_B_F2(data)                                            (0x0003F000&((data)<<12))
+#define DITHERING_TAB_B_15_Tab_B_F2_src(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_15_get_Tab_B_F2(data)                                        ((0x0003F000&(data))>>12)
+#define DITHERING_TAB_B_15_Tab_B_F1_shift                                            (6)
+#define DITHERING_TAB_B_15_Tab_B_F1_mask                                             (0x00000FC0)
+#define DITHERING_TAB_B_15_Tab_B_F1(data)                                            (0x00000FC0&((data)<<6))
+#define DITHERING_TAB_B_15_Tab_B_F1_src(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_15_get_Tab_B_F1(data)                                        ((0x00000FC0&(data))>>6)
+#define DITHERING_TAB_B_15_Tab_B_F0_shift                                            (0)
+#define DITHERING_TAB_B_15_Tab_B_F0_mask                                             (0x0000003F)
+#define DITHERING_TAB_B_15_Tab_B_F0(data)                                            (0x0000003F&((data)<<0))
+#define DITHERING_TAB_B_15_Tab_B_F0_src(data)                                        ((0x0000003F&(data))>>0)
+#define DITHERING_TAB_B_15_get_Tab_B_F0(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define TEMPORAL_OFFSET                                                              0x180099a8
+#define TEMPORAL_OFFSET_reg_addr                                                     "0xB80099A8"
+#define TEMPORAL_OFFSET_reg                                                          0xB80099A8
+#define set_TEMPORAL_OFFSET_reg(data)   (*((volatile unsigned int*) TEMPORAL_OFFSET_reg)=data)
+#define get_TEMPORAL_OFFSET_reg   (*((volatile unsigned int*) TEMPORAL_OFFSET_reg))
+#define TEMPORAL_OFFSET_inst_adr                                                     "0x006A"
+#define TEMPORAL_OFFSET_inst                                                         0x006A
+#define TEMPORAL_OFFSET_Temp_offset_15_shift                                         (30)
+#define TEMPORAL_OFFSET_Temp_offset_15_mask                                          (0xC0000000)
+#define TEMPORAL_OFFSET_Temp_offset_15(data)                                         (0xC0000000&((data)<<30))
+#define TEMPORAL_OFFSET_Temp_offset_15_src(data)                                     ((0xC0000000&(data))>>30)
+#define TEMPORAL_OFFSET_get_Temp_offset_15(data)                                     ((0xC0000000&(data))>>30)
+#define TEMPORAL_OFFSET_Temp_offset_14_shift                                         (28)
+#define TEMPORAL_OFFSET_Temp_offset_14_mask                                          (0x30000000)
+#define TEMPORAL_OFFSET_Temp_offset_14(data)                                         (0x30000000&((data)<<28))
+#define TEMPORAL_OFFSET_Temp_offset_14_src(data)                                     ((0x30000000&(data))>>28)
+#define TEMPORAL_OFFSET_get_Temp_offset_14(data)                                     ((0x30000000&(data))>>28)
+#define TEMPORAL_OFFSET_Temp_offset_13_shift                                         (26)
+#define TEMPORAL_OFFSET_Temp_offset_13_mask                                          (0x0C000000)
+#define TEMPORAL_OFFSET_Temp_offset_13(data)                                         (0x0C000000&((data)<<26))
+#define TEMPORAL_OFFSET_Temp_offset_13_src(data)                                     ((0x0C000000&(data))>>26)
+#define TEMPORAL_OFFSET_get_Temp_offset_13(data)                                     ((0x0C000000&(data))>>26)
+#define TEMPORAL_OFFSET_Temp_offset_12_shift                                         (24)
+#define TEMPORAL_OFFSET_Temp_offset_12_mask                                          (0x03000000)
+#define TEMPORAL_OFFSET_Temp_offset_12(data)                                         (0x03000000&((data)<<24))
+#define TEMPORAL_OFFSET_Temp_offset_12_src(data)                                     ((0x03000000&(data))>>24)
+#define TEMPORAL_OFFSET_get_Temp_offset_12(data)                                     ((0x03000000&(data))>>24)
+#define TEMPORAL_OFFSET_Temp_offset_11_shift                                         (22)
+#define TEMPORAL_OFFSET_Temp_offset_11_mask                                          (0x00C00000)
+#define TEMPORAL_OFFSET_Temp_offset_11(data)                                         (0x00C00000&((data)<<22))
+#define TEMPORAL_OFFSET_Temp_offset_11_src(data)                                     ((0x00C00000&(data))>>22)
+#define TEMPORAL_OFFSET_get_Temp_offset_11(data)                                     ((0x00C00000&(data))>>22)
+#define TEMPORAL_OFFSET_Temp_offset_10_shift                                         (20)
+#define TEMPORAL_OFFSET_Temp_offset_10_mask                                          (0x00300000)
+#define TEMPORAL_OFFSET_Temp_offset_10(data)                                         (0x00300000&((data)<<20))
+#define TEMPORAL_OFFSET_Temp_offset_10_src(data)                                     ((0x00300000&(data))>>20)
+#define TEMPORAL_OFFSET_get_Temp_offset_10(data)                                     ((0x00300000&(data))>>20)
+#define TEMPORAL_OFFSET_Temp_offset_9_shift                                          (18)
+#define TEMPORAL_OFFSET_Temp_offset_9_mask                                           (0x000C0000)
+#define TEMPORAL_OFFSET_Temp_offset_9(data)                                          (0x000C0000&((data)<<18))
+#define TEMPORAL_OFFSET_Temp_offset_9_src(data)                                      ((0x000C0000&(data))>>18)
+#define TEMPORAL_OFFSET_get_Temp_offset_9(data)                                      ((0x000C0000&(data))>>18)
+#define TEMPORAL_OFFSET_Temp_offset_8_shift                                          (16)
+#define TEMPORAL_OFFSET_Temp_offset_8_mask                                           (0x00030000)
+#define TEMPORAL_OFFSET_Temp_offset_8(data)                                          (0x00030000&((data)<<16))
+#define TEMPORAL_OFFSET_Temp_offset_8_src(data)                                      ((0x00030000&(data))>>16)
+#define TEMPORAL_OFFSET_get_Temp_offset_8(data)                                      ((0x00030000&(data))>>16)
+#define TEMPORAL_OFFSET_Temp_offset_7_shift                                          (14)
+#define TEMPORAL_OFFSET_Temp_offset_7_mask                                           (0x0000C000)
+#define TEMPORAL_OFFSET_Temp_offset_7(data)                                          (0x0000C000&((data)<<14))
+#define TEMPORAL_OFFSET_Temp_offset_7_src(data)                                      ((0x0000C000&(data))>>14)
+#define TEMPORAL_OFFSET_get_Temp_offset_7(data)                                      ((0x0000C000&(data))>>14)
+#define TEMPORAL_OFFSET_Temp_offset_6_shift                                          (12)
+#define TEMPORAL_OFFSET_Temp_offset_6_mask                                           (0x00003000)
+#define TEMPORAL_OFFSET_Temp_offset_6(data)                                          (0x00003000&((data)<<12))
+#define TEMPORAL_OFFSET_Temp_offset_6_src(data)                                      ((0x00003000&(data))>>12)
+#define TEMPORAL_OFFSET_get_Temp_offset_6(data)                                      ((0x00003000&(data))>>12)
+#define TEMPORAL_OFFSET_Temp_offset_5_shift                                          (10)
+#define TEMPORAL_OFFSET_Temp_offset_5_mask                                           (0x00000C00)
+#define TEMPORAL_OFFSET_Temp_offset_5(data)                                          (0x00000C00&((data)<<10))
+#define TEMPORAL_OFFSET_Temp_offset_5_src(data)                                      ((0x00000C00&(data))>>10)
+#define TEMPORAL_OFFSET_get_Temp_offset_5(data)                                      ((0x00000C00&(data))>>10)
+#define TEMPORAL_OFFSET_Temp_offset_4_shift                                          (8)
+#define TEMPORAL_OFFSET_Temp_offset_4_mask                                           (0x00000300)
+#define TEMPORAL_OFFSET_Temp_offset_4(data)                                          (0x00000300&((data)<<8))
+#define TEMPORAL_OFFSET_Temp_offset_4_src(data)                                      ((0x00000300&(data))>>8)
+#define TEMPORAL_OFFSET_get_Temp_offset_4(data)                                      ((0x00000300&(data))>>8)
+#define TEMPORAL_OFFSET_Temp_offset_3_shift                                          (6)
+#define TEMPORAL_OFFSET_Temp_offset_3_mask                                           (0x000000C0)
+#define TEMPORAL_OFFSET_Temp_offset_3(data)                                          (0x000000C0&((data)<<6))
+#define TEMPORAL_OFFSET_Temp_offset_3_src(data)                                      ((0x000000C0&(data))>>6)
+#define TEMPORAL_OFFSET_get_Temp_offset_3(data)                                      ((0x000000C0&(data))>>6)
+#define TEMPORAL_OFFSET_Temp_offset_2_shift                                          (4)
+#define TEMPORAL_OFFSET_Temp_offset_2_mask                                           (0x00000030)
+#define TEMPORAL_OFFSET_Temp_offset_2(data)                                          (0x00000030&((data)<<4))
+#define TEMPORAL_OFFSET_Temp_offset_2_src(data)                                      ((0x00000030&(data))>>4)
+#define TEMPORAL_OFFSET_get_Temp_offset_2(data)                                      ((0x00000030&(data))>>4)
+#define TEMPORAL_OFFSET_Temp_offset_1_shift                                          (2)
+#define TEMPORAL_OFFSET_Temp_offset_1_mask                                           (0x0000000C)
+#define TEMPORAL_OFFSET_Temp_offset_1(data)                                          (0x0000000C&((data)<<2))
+#define TEMPORAL_OFFSET_Temp_offset_1_src(data)                                      ((0x0000000C&(data))>>2)
+#define TEMPORAL_OFFSET_get_Temp_offset_1(data)                                      ((0x0000000C&(data))>>2)
+#define TEMPORAL_OFFSET_Temp_offset_0_shift                                          (0)
+#define TEMPORAL_OFFSET_Temp_offset_0_mask                                           (0x00000003)
+#define TEMPORAL_OFFSET_Temp_offset_0(data)                                          (0x00000003&((data)<<0))
+#define TEMPORAL_OFFSET_Temp_offset_0_src(data)                                      ((0x00000003&(data))>>0)
+#define TEMPORAL_OFFSET_get_Temp_offset_0(data)                                      ((0x00000003&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_R_0                                                        0x180099ac
+#define DITHERING_2ND_SEQ_R_0_reg_addr                                               "0xB80099AC"
+#define DITHERING_2ND_SEQ_R_0_reg                                                    0xB80099AC
+#define set_DITHERING_2ND_SEQ_R_0_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_R_0_reg)=data)
+#define get_DITHERING_2ND_SEQ_R_0_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_R_0_reg))
+#define DITHERING_2ND_SEQ_R_0_inst_adr                                               "0x006B"
+#define DITHERING_2ND_SEQ_R_0_inst                                                   0x006B
+#define DITHERING_2ND_SEQ_R_0_Seq_R_7_shift                                          (28)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_7_mask                                           (0xF0000000)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_7(data)                                          (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_R_0_Seq_R_7_src(data)                                      ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_R_0_get_Seq_R_7(data)                                      ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_6_shift                                          (24)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_6_mask                                           (0x0F000000)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_6(data)                                          (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_R_0_Seq_R_6_src(data)                                      ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_R_0_get_Seq_R_6(data)                                      ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_5_shift                                          (20)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_5_mask                                           (0x00F00000)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_5(data)                                          (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_R_0_Seq_R_5_src(data)                                      ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_R_0_get_Seq_R_5(data)                                      ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_4_shift                                          (16)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_4_mask                                           (0x000F0000)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_4(data)                                          (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_R_0_Seq_R_4_src(data)                                      ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_R_0_get_Seq_R_4(data)                                      ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_3_shift                                          (12)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_3_mask                                           (0x0000F000)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_3(data)                                          (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_R_0_Seq_R_3_src(data)                                      ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_R_0_get_Seq_R_3(data)                                      ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_2_shift                                          (8)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_2_mask                                           (0x00000F00)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_2(data)                                          (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_R_0_Seq_R_2_src(data)                                      ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_R_0_get_Seq_R_2(data)                                      ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_1_shift                                          (4)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_1_mask                                           (0x000000F0)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_1(data)                                          (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_R_0_Seq_R_1_src(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_R_0_get_Seq_R_1(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_0_shift                                          (0)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_0_mask                                           (0x0000000F)
+#define DITHERING_2ND_SEQ_R_0_Seq_R_0(data)                                          (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_R_0_Seq_R_0_src(data)                                      ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_R_0_get_Seq_R_0(data)                                      ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_R_1                                                        0x180099b0
+#define DITHERING_2ND_SEQ_R_1_reg_addr                                               "0xB80099B0"
+#define DITHERING_2ND_SEQ_R_1_reg                                                    0xB80099B0
+#define set_DITHERING_2ND_SEQ_R_1_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_R_1_reg)=data)
+#define get_DITHERING_2ND_SEQ_R_1_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_R_1_reg))
+#define DITHERING_2ND_SEQ_R_1_inst_adr                                               "0x006C"
+#define DITHERING_2ND_SEQ_R_1_inst                                                   0x006C
+#define DITHERING_2ND_SEQ_R_1_Seq_R_15_shift                                         (28)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_15_mask                                          (0xF0000000)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_15(data)                                         (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_R_1_Seq_R_15_src(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_R_1_get_Seq_R_15(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_14_shift                                         (24)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_14_mask                                          (0x0F000000)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_14(data)                                         (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_R_1_Seq_R_14_src(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_R_1_get_Seq_R_14(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_13_shift                                         (20)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_13_mask                                          (0x00F00000)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_13(data)                                         (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_R_1_Seq_R_13_src(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_R_1_get_Seq_R_13(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_12_shift                                         (16)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_12_mask                                          (0x000F0000)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_12(data)                                         (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_R_1_Seq_R_12_src(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_R_1_get_Seq_R_12(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_11_shift                                         (12)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_11_mask                                          (0x0000F000)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_11(data)                                         (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_R_1_Seq_R_11_src(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_R_1_get_Seq_R_11(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_10_shift                                         (8)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_10_mask                                          (0x00000F00)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_10(data)                                         (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_R_1_Seq_R_10_src(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_R_1_get_Seq_R_10(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_9_shift                                          (4)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_9_mask                                           (0x000000F0)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_9(data)                                          (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_R_1_Seq_R_9_src(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_R_1_get_Seq_R_9(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_8_shift                                          (0)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_8_mask                                           (0x0000000F)
+#define DITHERING_2ND_SEQ_R_1_Seq_R_8(data)                                          (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_R_1_Seq_R_8_src(data)                                      ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_R_1_get_Seq_R_8(data)                                      ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_R_2                                                        0x180099b4
+#define DITHERING_2ND_SEQ_R_2_reg_addr                                               "0xB80099B4"
+#define DITHERING_2ND_SEQ_R_2_reg                                                    0xB80099B4
+#define set_DITHERING_2ND_SEQ_R_2_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_R_2_reg)=data)
+#define get_DITHERING_2ND_SEQ_R_2_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_R_2_reg))
+#define DITHERING_2ND_SEQ_R_2_inst_adr                                               "0x006D"
+#define DITHERING_2ND_SEQ_R_2_inst                                                   0x006D
+#define DITHERING_2ND_SEQ_R_2_Seq_R_23_shift                                         (28)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_23_mask                                          (0xF0000000)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_23(data)                                         (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_R_2_Seq_R_23_src(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_R_2_get_Seq_R_23(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_22_shift                                         (24)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_22_mask                                          (0x0F000000)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_22(data)                                         (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_R_2_Seq_R_22_src(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_R_2_get_Seq_R_22(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_21_shift                                         (20)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_21_mask                                          (0x00F00000)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_21(data)                                         (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_R_2_Seq_R_21_src(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_R_2_get_Seq_R_21(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_20_shift                                         (16)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_20_mask                                          (0x000F0000)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_20(data)                                         (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_R_2_Seq_R_20_src(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_R_2_get_Seq_R_20(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_19_shift                                         (12)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_19_mask                                          (0x0000F000)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_19(data)                                         (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_R_2_Seq_R_19_src(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_R_2_get_Seq_R_19(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_18_shift                                         (8)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_18_mask                                          (0x00000F00)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_18(data)                                         (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_R_2_Seq_R_18_src(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_R_2_get_Seq_R_18(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_17_shift                                         (4)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_17_mask                                          (0x000000F0)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_17(data)                                         (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_R_2_Seq_R_17_src(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_R_2_get_Seq_R_17(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_16_shift                                         (0)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_16_mask                                          (0x0000000F)
+#define DITHERING_2ND_SEQ_R_2_Seq_R_16(data)                                         (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_R_2_Seq_R_16_src(data)                                     ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_R_2_get_Seq_R_16(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_R_3                                                        0x180099b8
+#define DITHERING_2ND_SEQ_R_3_reg_addr                                               "0xB80099B8"
+#define DITHERING_2ND_SEQ_R_3_reg                                                    0xB80099B8
+#define set_DITHERING_2ND_SEQ_R_3_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_R_3_reg)=data)
+#define get_DITHERING_2ND_SEQ_R_3_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_R_3_reg))
+#define DITHERING_2ND_SEQ_R_3_inst_adr                                               "0x006E"
+#define DITHERING_2ND_SEQ_R_3_inst                                                   0x006E
+#define DITHERING_2ND_SEQ_R_3_Seq_R_31_shift                                         (28)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_31_mask                                          (0xF0000000)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_31(data)                                         (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_R_3_Seq_R_31_src(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_R_3_get_Seq_R_31(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_30_shift                                         (24)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_30_mask                                          (0x0F000000)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_30(data)                                         (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_R_3_Seq_R_30_src(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_R_3_get_Seq_R_30(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_29_shift                                         (20)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_29_mask                                          (0x00F00000)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_29(data)                                         (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_R_3_Seq_R_29_src(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_R_3_get_Seq_R_29(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_28_shift                                         (16)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_28_mask                                          (0x000F0000)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_28(data)                                         (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_R_3_Seq_R_28_src(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_R_3_get_Seq_R_28(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_27_shift                                         (12)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_27_mask                                          (0x0000F000)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_27(data)                                         (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_R_3_Seq_R_27_src(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_R_3_get_Seq_R_27(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_26_shift                                         (8)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_26_mask                                          (0x00000F00)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_26(data)                                         (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_R_3_Seq_R_26_src(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_R_3_get_Seq_R_26(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_25_shift                                         (4)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_25_mask                                          (0x000000F0)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_25(data)                                         (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_R_3_Seq_R_25_src(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_R_3_get_Seq_R_25(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_24_shift                                         (0)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_24_mask                                          (0x0000000F)
+#define DITHERING_2ND_SEQ_R_3_Seq_R_24(data)                                         (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_R_3_Seq_R_24_src(data)                                     ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_R_3_get_Seq_R_24(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_G_0                                                        0x180099bc
+#define DITHERING_2ND_SEQ_G_0_reg_addr                                               "0xB80099BC"
+#define DITHERING_2ND_SEQ_G_0_reg                                                    0xB80099BC
+#define set_DITHERING_2ND_SEQ_G_0_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_G_0_reg)=data)
+#define get_DITHERING_2ND_SEQ_G_0_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_G_0_reg))
+#define DITHERING_2ND_SEQ_G_0_inst_adr                                               "0x006F"
+#define DITHERING_2ND_SEQ_G_0_inst                                                   0x006F
+#define DITHERING_2ND_SEQ_G_0_Seq_G_7_shift                                          (28)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_7_mask                                           (0xF0000000)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_7(data)                                          (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_G_0_Seq_G_7_src(data)                                      ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_G_0_get_Seq_G_7(data)                                      ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_6_shift                                          (24)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_6_mask                                           (0x0F000000)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_6(data)                                          (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_G_0_Seq_G_6_src(data)                                      ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_G_0_get_Seq_G_6(data)                                      ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_5_shift                                          (20)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_5_mask                                           (0x00F00000)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_5(data)                                          (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_G_0_Seq_G_5_src(data)                                      ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_G_0_get_Seq_G_5(data)                                      ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_4_shift                                          (16)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_4_mask                                           (0x000F0000)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_4(data)                                          (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_G_0_Seq_G_4_src(data)                                      ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_G_0_get_Seq_G_4(data)                                      ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_3_shift                                          (12)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_3_mask                                           (0x0000F000)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_3(data)                                          (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_G_0_Seq_G_3_src(data)                                      ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_G_0_get_Seq_G_3(data)                                      ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_2_shift                                          (8)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_2_mask                                           (0x00000F00)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_2(data)                                          (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_G_0_Seq_G_2_src(data)                                      ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_G_0_get_Seq_G_2(data)                                      ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_1_shift                                          (4)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_1_mask                                           (0x000000F0)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_1(data)                                          (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_G_0_Seq_G_1_src(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_G_0_get_Seq_G_1(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_0_shift                                          (0)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_0_mask                                           (0x0000000F)
+#define DITHERING_2ND_SEQ_G_0_Seq_G_0(data)                                          (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_G_0_Seq_G_0_src(data)                                      ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_G_0_get_Seq_G_0(data)                                      ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_G_1                                                        0x180099c0
+#define DITHERING_2ND_SEQ_G_1_reg_addr                                               "0xB80099C0"
+#define DITHERING_2ND_SEQ_G_1_reg                                                    0xB80099C0
+#define set_DITHERING_2ND_SEQ_G_1_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_G_1_reg)=data)
+#define get_DITHERING_2ND_SEQ_G_1_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_G_1_reg))
+#define DITHERING_2ND_SEQ_G_1_inst_adr                                               "0x0070"
+#define DITHERING_2ND_SEQ_G_1_inst                                                   0x0070
+#define DITHERING_2ND_SEQ_G_1_Seq_G_15_shift                                         (28)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_15_mask                                          (0xF0000000)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_15(data)                                         (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_G_1_Seq_G_15_src(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_G_1_get_Seq_G_15(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_14_shift                                         (24)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_14_mask                                          (0x0F000000)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_14(data)                                         (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_G_1_Seq_G_14_src(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_G_1_get_Seq_G_14(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_13_shift                                         (20)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_13_mask                                          (0x00F00000)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_13(data)                                         (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_G_1_Seq_G_13_src(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_G_1_get_Seq_G_13(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_12_shift                                         (16)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_12_mask                                          (0x000F0000)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_12(data)                                         (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_G_1_Seq_G_12_src(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_G_1_get_Seq_G_12(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_11_shift                                         (12)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_11_mask                                          (0x0000F000)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_11(data)                                         (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_G_1_Seq_G_11_src(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_G_1_get_Seq_G_11(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_10_shift                                         (8)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_10_mask                                          (0x00000F00)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_10(data)                                         (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_G_1_Seq_G_10_src(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_G_1_get_Seq_G_10(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_9_shift                                          (4)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_9_mask                                           (0x000000F0)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_9(data)                                          (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_G_1_Seq_G_9_src(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_G_1_get_Seq_G_9(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_8_shift                                          (0)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_8_mask                                           (0x0000000F)
+#define DITHERING_2ND_SEQ_G_1_Seq_G_8(data)                                          (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_G_1_Seq_G_8_src(data)                                      ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_G_1_get_Seq_G_8(data)                                      ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_G_2                                                        0x180099c4
+#define DITHERING_2ND_SEQ_G_2_reg_addr                                               "0xB80099C4"
+#define DITHERING_2ND_SEQ_G_2_reg                                                    0xB80099C4
+#define set_DITHERING_2ND_SEQ_G_2_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_G_2_reg)=data)
+#define get_DITHERING_2ND_SEQ_G_2_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_G_2_reg))
+#define DITHERING_2ND_SEQ_G_2_inst_adr                                               "0x0071"
+#define DITHERING_2ND_SEQ_G_2_inst                                                   0x0071
+#define DITHERING_2ND_SEQ_G_2_Seq_G_23_shift                                         (28)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_23_mask                                          (0xF0000000)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_23(data)                                         (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_G_2_Seq_G_23_src(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_G_2_get_Seq_G_23(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_22_shift                                         (24)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_22_mask                                          (0x0F000000)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_22(data)                                         (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_G_2_Seq_G_22_src(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_G_2_get_Seq_G_22(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_21_shift                                         (20)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_21_mask                                          (0x00F00000)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_21(data)                                         (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_G_2_Seq_G_21_src(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_G_2_get_Seq_G_21(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_20_shift                                         (16)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_20_mask                                          (0x000F0000)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_20(data)                                         (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_G_2_Seq_G_20_src(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_G_2_get_Seq_G_20(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_19_shift                                         (12)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_19_mask                                          (0x0000F000)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_19(data)                                         (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_G_2_Seq_G_19_src(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_G_2_get_Seq_G_19(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_18_shift                                         (8)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_18_mask                                          (0x00000F00)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_18(data)                                         (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_G_2_Seq_G_18_src(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_G_2_get_Seq_G_18(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_17_shift                                         (4)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_17_mask                                          (0x000000F0)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_17(data)                                         (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_G_2_Seq_G_17_src(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_G_2_get_Seq_G_17(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_16_shift                                         (0)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_16_mask                                          (0x0000000F)
+#define DITHERING_2ND_SEQ_G_2_Seq_G_16(data)                                         (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_G_2_Seq_G_16_src(data)                                     ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_G_2_get_Seq_G_16(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_G_3                                                        0x180099c8
+#define DITHERING_2ND_SEQ_G_3_reg_addr                                               "0xB80099C8"
+#define DITHERING_2ND_SEQ_G_3_reg                                                    0xB80099C8
+#define set_DITHERING_2ND_SEQ_G_3_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_G_3_reg)=data)
+#define get_DITHERING_2ND_SEQ_G_3_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_G_3_reg))
+#define DITHERING_2ND_SEQ_G_3_inst_adr                                               "0x0072"
+#define DITHERING_2ND_SEQ_G_3_inst                                                   0x0072
+#define DITHERING_2ND_SEQ_G_3_Seq_G_31_shift                                         (28)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_31_mask                                          (0xF0000000)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_31(data)                                         (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_G_3_Seq_G_31_src(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_G_3_get_Seq_G_31(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_30_shift                                         (24)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_30_mask                                          (0x0F000000)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_30(data)                                         (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_G_3_Seq_G_30_src(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_G_3_get_Seq_G_30(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_29_shift                                         (20)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_29_mask                                          (0x00F00000)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_29(data)                                         (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_G_3_Seq_G_29_src(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_G_3_get_Seq_G_29(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_28_shift                                         (16)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_28_mask                                          (0x000F0000)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_28(data)                                         (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_G_3_Seq_G_28_src(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_G_3_get_Seq_G_28(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_27_shift                                         (12)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_27_mask                                          (0x0000F000)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_27(data)                                         (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_G_3_Seq_G_27_src(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_G_3_get_Seq_G_27(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_26_shift                                         (8)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_26_mask                                          (0x00000F00)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_26(data)                                         (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_G_3_Seq_G_26_src(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_G_3_get_Seq_G_26(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_25_shift                                         (4)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_25_mask                                          (0x000000F0)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_25(data)                                         (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_G_3_Seq_G_25_src(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_G_3_get_Seq_G_25(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_24_shift                                         (0)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_24_mask                                          (0x0000000F)
+#define DITHERING_2ND_SEQ_G_3_Seq_G_24(data)                                         (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_G_3_Seq_G_24_src(data)                                     ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_G_3_get_Seq_G_24(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_B_0                                                        0x180099cc
+#define DITHERING_2ND_SEQ_B_0_reg_addr                                               "0xB80099CC"
+#define DITHERING_2ND_SEQ_B_0_reg                                                    0xB80099CC
+#define set_DITHERING_2ND_SEQ_B_0_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_B_0_reg)=data)
+#define get_DITHERING_2ND_SEQ_B_0_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_B_0_reg))
+#define DITHERING_2ND_SEQ_B_0_inst_adr                                               "0x0073"
+#define DITHERING_2ND_SEQ_B_0_inst                                                   0x0073
+#define DITHERING_2ND_SEQ_B_0_Seq_B_7_shift                                          (28)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_7_mask                                           (0xF0000000)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_7(data)                                          (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_B_0_Seq_B_7_src(data)                                      ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_B_0_get_Seq_B_7(data)                                      ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_6_shift                                          (24)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_6_mask                                           (0x0F000000)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_6(data)                                          (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_B_0_Seq_B_6_src(data)                                      ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_B_0_get_Seq_B_6(data)                                      ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_5_shift                                          (20)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_5_mask                                           (0x00F00000)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_5(data)                                          (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_B_0_Seq_B_5_src(data)                                      ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_B_0_get_Seq_B_5(data)                                      ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_4_shift                                          (16)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_4_mask                                           (0x000F0000)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_4(data)                                          (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_B_0_Seq_B_4_src(data)                                      ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_B_0_get_Seq_B_4(data)                                      ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_3_shift                                          (12)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_3_mask                                           (0x0000F000)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_3(data)                                          (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_B_0_Seq_B_3_src(data)                                      ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_B_0_get_Seq_B_3(data)                                      ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_2_shift                                          (8)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_2_mask                                           (0x00000F00)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_2(data)                                          (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_B_0_Seq_B_2_src(data)                                      ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_B_0_get_Seq_B_2(data)                                      ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_1_shift                                          (4)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_1_mask                                           (0x000000F0)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_1(data)                                          (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_B_0_Seq_B_1_src(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_B_0_get_Seq_B_1(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_0_shift                                          (0)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_0_mask                                           (0x0000000F)
+#define DITHERING_2ND_SEQ_B_0_Seq_B_0(data)                                          (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_B_0_Seq_B_0_src(data)                                      ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_B_0_get_Seq_B_0(data)                                      ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_B_1                                                        0x180099d0
+#define DITHERING_2ND_SEQ_B_1_reg_addr                                               "0xB80099D0"
+#define DITHERING_2ND_SEQ_B_1_reg                                                    0xB80099D0
+#define set_DITHERING_2ND_SEQ_B_1_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_B_1_reg)=data)
+#define get_DITHERING_2ND_SEQ_B_1_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_B_1_reg))
+#define DITHERING_2ND_SEQ_B_1_inst_adr                                               "0x0074"
+#define DITHERING_2ND_SEQ_B_1_inst                                                   0x0074
+#define DITHERING_2ND_SEQ_B_1_Seq_B_15_shift                                         (28)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_15_mask                                          (0xF0000000)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_15(data)                                         (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_B_1_Seq_B_15_src(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_B_1_get_Seq_B_15(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_14_shift                                         (24)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_14_mask                                          (0x0F000000)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_14(data)                                         (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_B_1_Seq_B_14_src(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_B_1_get_Seq_B_14(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_13_shift                                         (20)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_13_mask                                          (0x00F00000)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_13(data)                                         (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_B_1_Seq_B_13_src(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_B_1_get_Seq_B_13(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_12_shift                                         (16)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_12_mask                                          (0x000F0000)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_12(data)                                         (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_B_1_Seq_B_12_src(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_B_1_get_Seq_B_12(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_11_shift                                         (12)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_11_mask                                          (0x0000F000)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_11(data)                                         (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_B_1_Seq_B_11_src(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_B_1_get_Seq_B_11(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_10_shift                                         (8)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_10_mask                                          (0x00000F00)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_10(data)                                         (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_B_1_Seq_B_10_src(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_B_1_get_Seq_B_10(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_9_shift                                          (4)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_9_mask                                           (0x000000F0)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_9(data)                                          (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_B_1_Seq_B_9_src(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_B_1_get_Seq_B_9(data)                                      ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_8_shift                                          (0)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_8_mask                                           (0x0000000F)
+#define DITHERING_2ND_SEQ_B_1_Seq_B_8(data)                                          (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_B_1_Seq_B_8_src(data)                                      ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_B_1_get_Seq_B_8(data)                                      ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_B_2                                                        0x180099d4
+#define DITHERING_2ND_SEQ_B_2_reg_addr                                               "0xB80099D4"
+#define DITHERING_2ND_SEQ_B_2_reg                                                    0xB80099D4
+#define set_DITHERING_2ND_SEQ_B_2_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_B_2_reg)=data)
+#define get_DITHERING_2ND_SEQ_B_2_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_B_2_reg))
+#define DITHERING_2ND_SEQ_B_2_inst_adr                                               "0x0075"
+#define DITHERING_2ND_SEQ_B_2_inst                                                   0x0075
+#define DITHERING_2ND_SEQ_B_2_Seq_B_23_shift                                         (28)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_23_mask                                          (0xF0000000)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_23(data)                                         (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_B_2_Seq_B_23_src(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_B_2_get_Seq_B_23(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_22_shift                                         (24)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_22_mask                                          (0x0F000000)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_22(data)                                         (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_B_2_Seq_B_22_src(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_B_2_get_Seq_B_22(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_21_shift                                         (20)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_21_mask                                          (0x00F00000)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_21(data)                                         (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_B_2_Seq_B_21_src(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_B_2_get_Seq_B_21(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_20_shift                                         (16)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_20_mask                                          (0x000F0000)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_20(data)                                         (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_B_2_Seq_B_20_src(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_B_2_get_Seq_B_20(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_19_shift                                         (12)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_19_mask                                          (0x0000F000)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_19(data)                                         (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_B_2_Seq_B_19_src(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_B_2_get_Seq_B_19(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_18_shift                                         (8)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_18_mask                                          (0x00000F00)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_18(data)                                         (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_B_2_Seq_B_18_src(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_B_2_get_Seq_B_18(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_17_shift                                         (4)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_17_mask                                          (0x000000F0)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_17(data)                                         (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_B_2_Seq_B_17_src(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_B_2_get_Seq_B_17(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_16_shift                                         (0)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_16_mask                                          (0x0000000F)
+#define DITHERING_2ND_SEQ_B_2_Seq_B_16(data)                                         (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_B_2_Seq_B_16_src(data)                                     ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_B_2_get_Seq_B_16(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define DITHERING_2ND_SEQ_B_3                                                        0x180099d8
+#define DITHERING_2ND_SEQ_B_3_reg_addr                                               "0xB80099D8"
+#define DITHERING_2ND_SEQ_B_3_reg                                                    0xB80099D8
+#define set_DITHERING_2ND_SEQ_B_3_reg(data)   (*((volatile unsigned int*) DITHERING_2ND_SEQ_B_3_reg)=data)
+#define get_DITHERING_2ND_SEQ_B_3_reg   (*((volatile unsigned int*) DITHERING_2ND_SEQ_B_3_reg))
+#define DITHERING_2ND_SEQ_B_3_inst_adr                                               "0x0076"
+#define DITHERING_2ND_SEQ_B_3_inst                                                   0x0076
+#define DITHERING_2ND_SEQ_B_3_Seq_B_31_shift                                         (28)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_31_mask                                          (0xF0000000)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_31(data)                                         (0xF0000000&((data)<<28))
+#define DITHERING_2ND_SEQ_B_3_Seq_B_31_src(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_B_3_get_Seq_B_31(data)                                     ((0xF0000000&(data))>>28)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_30_shift                                         (24)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_30_mask                                          (0x0F000000)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_30(data)                                         (0x0F000000&((data)<<24))
+#define DITHERING_2ND_SEQ_B_3_Seq_B_30_src(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_B_3_get_Seq_B_30(data)                                     ((0x0F000000&(data))>>24)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_29_shift                                         (20)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_29_mask                                          (0x00F00000)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_29(data)                                         (0x00F00000&((data)<<20))
+#define DITHERING_2ND_SEQ_B_3_Seq_B_29_src(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_B_3_get_Seq_B_29(data)                                     ((0x00F00000&(data))>>20)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_28_shift                                         (16)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_28_mask                                          (0x000F0000)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_28(data)                                         (0x000F0000&((data)<<16))
+#define DITHERING_2ND_SEQ_B_3_Seq_B_28_src(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_B_3_get_Seq_B_28(data)                                     ((0x000F0000&(data))>>16)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_27_shift                                         (12)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_27_mask                                          (0x0000F000)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_27(data)                                         (0x0000F000&((data)<<12))
+#define DITHERING_2ND_SEQ_B_3_Seq_B_27_src(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_B_3_get_Seq_B_27(data)                                     ((0x0000F000&(data))>>12)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_26_shift                                         (8)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_26_mask                                          (0x00000F00)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_26(data)                                         (0x00000F00&((data)<<8))
+#define DITHERING_2ND_SEQ_B_3_Seq_B_26_src(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_B_3_get_Seq_B_26(data)                                     ((0x00000F00&(data))>>8)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_25_shift                                         (4)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_25_mask                                          (0x000000F0)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_25(data)                                         (0x000000F0&((data)<<4))
+#define DITHERING_2ND_SEQ_B_3_Seq_B_25_src(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_B_3_get_Seq_B_25(data)                                     ((0x000000F0&(data))>>4)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_24_shift                                         (0)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_24_mask                                          (0x0000000F)
+#define DITHERING_2ND_SEQ_B_3_Seq_B_24(data)                                         (0x0000000F&((data)<<0))
+#define DITHERING_2ND_SEQ_B_3_Seq_B_24_src(data)                                     ((0x0000000F&(data))>>0)
+#define DITHERING_2ND_SEQ_B_3_get_Seq_B_24(data)                                     ((0x0000000F&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_gamma_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_gamma_reg.h
new file mode 100644
index 00000000..723fbe8
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_gamma_reg.h
@@ -0,0 +1,515 @@
+/**************************************************************
+// Spec Version                  : 1.0.6
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/4/24 15:23:28
+***************************************************************/
+
+
+#ifndef _GAMMA_REG_H_INCLUDED_
+#define _GAMMA_REG_H_INCLUDED_
+#ifdef  _GAMMA_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     GAMMA_AX_RW_Sel:2;
+unsigned int     GAMMA_AX_Ch_Sel:2;
+unsigned int     GAMMA_AX_Type_Sel:1;
+}GAMMA_CTRL_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     GAMMA_FIFO_Empty:1;
+unsigned int     GAMMA_FIFO_Full:1;
+unsigned int     GAMMA_WR_Error:1;
+}GAMMA_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     GAMMA_R_En:1;
+unsigned int     GAMMA_G_En:1;
+unsigned int     GAMMA_B_En:1;
+unsigned int     GAMMA_M_TAB_Sel:1;
+unsigned int     Dummy:5;
+}GAMMA_CTRL_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     RME:1;
+unsigned int     RM_3:1;
+unsigned int     RM_2:1;
+unsigned int     RM_1:1;
+unsigned int     RM_0:1;
+}BIST_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     bist_fail2:1;
+unsigned int     bist_fail1:1;
+unsigned int     bist_fail0:1;
+unsigned int     bist_done:1;
+}BIST_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:12;
+unsigned int     drf_fail2:1;
+unsigned int     drf_fail1:1;
+unsigned int     drf_fail0:1;
+unsigned int     drf_done:1;
+}DRF_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     drf_test_resume:1;
+unsigned int     drf_bist_mode:1;
+unsigned int     bist_mode:1;
+}MBIST_CON;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     D_Stat_SrcSel:1;
+unsigned int     reserved_1:4;
+unsigned int     R_Low:10;
+unsigned int     reserved_2:6;
+unsigned int     R_High:10;
+}DSTAT_CTRL_R;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     G_Low:10;
+unsigned int     reserved_1:6;
+unsigned int     G_High:10;
+}DSTAT_CTRL_G;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     B_Low:10;
+unsigned int     reserved_1:6;
+unsigned int     B_High:10;
+}DSTAT_CTRL_B;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     R_Cnt:21;
+}DSTAT_O_R1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     R_Min:10;
+unsigned int     reserved_1:6;
+unsigned int     R_Max:10;
+}DSTAT_O_R2;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     G_Cnt:21;
+}DSTAT_O_G1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     G_Min:10;
+unsigned int     reserved_1:6;
+unsigned int     G_Max:10;
+}DSTAT_O_G2;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     B_Cnt:21;
+}DSTAT_O_B1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     B_Min:10;
+unsigned int     reserved_1:6;
+unsigned int     B_Max:10;
+}DSTAT_O_B2;
+
+#endif
+
+#define GAMMA_CTRL_1                                                                 0x18009864
+#define GAMMA_CTRL_1_reg_addr                                                        "0xB8009864"
+#define GAMMA_CTRL_1_reg                                                             0xB8009864
+#define set_GAMMA_CTRL_1_reg(data)   (*((volatile unsigned int*) GAMMA_CTRL_1_reg)=data)
+#define get_GAMMA_CTRL_1_reg   (*((volatile unsigned int*) GAMMA_CTRL_1_reg))
+#define GAMMA_CTRL_1_inst_adr                                                        "0x0019"
+#define GAMMA_CTRL_1_inst                                                            0x0019
+#define GAMMA_CTRL_1_GAMMA_AX_RW_Sel_shift                                           (3)
+#define GAMMA_CTRL_1_GAMMA_AX_RW_Sel_mask                                            (0x00000018)
+#define GAMMA_CTRL_1_GAMMA_AX_RW_Sel(data)                                           (0x00000018&((data)<<3))
+#define GAMMA_CTRL_1_GAMMA_AX_RW_Sel_src(data)                                       ((0x00000018&(data))>>3)
+#define GAMMA_CTRL_1_get_GAMMA_AX_RW_Sel(data)                                       ((0x00000018&(data))>>3)
+#define GAMMA_CTRL_1_GAMMA_AX_Ch_Sel_shift                                           (1)
+#define GAMMA_CTRL_1_GAMMA_AX_Ch_Sel_mask                                            (0x00000006)
+#define GAMMA_CTRL_1_GAMMA_AX_Ch_Sel(data)                                           (0x00000006&((data)<<1))
+#define GAMMA_CTRL_1_GAMMA_AX_Ch_Sel_src(data)                                       ((0x00000006&(data))>>1)
+#define GAMMA_CTRL_1_get_GAMMA_AX_Ch_Sel(data)                                       ((0x00000006&(data))>>1)
+#define GAMMA_CTRL_1_GAMMA_AX_Type_Sel_shift                                         (0)
+#define GAMMA_CTRL_1_GAMMA_AX_Type_Sel_mask                                          (0x00000001)
+#define GAMMA_CTRL_1_GAMMA_AX_Type_Sel(data)                                         (0x00000001&((data)<<0))
+#define GAMMA_CTRL_1_GAMMA_AX_Type_Sel_src(data)                                     ((0x00000001&(data))>>0)
+#define GAMMA_CTRL_1_get_GAMMA_AX_Type_Sel(data)                                     ((0x00000001&(data))>>0)
+
+
+#define GAMMA_STATUS                                                                 0x18009868
+#define GAMMA_STATUS_reg_addr                                                        "0xB8009868"
+#define GAMMA_STATUS_reg                                                             0xB8009868
+#define set_GAMMA_STATUS_reg(data)   (*((volatile unsigned int*) GAMMA_STATUS_reg)=data)
+#define get_GAMMA_STATUS_reg   (*((volatile unsigned int*) GAMMA_STATUS_reg))
+#define GAMMA_STATUS_inst_adr                                                        "0x001A"
+#define GAMMA_STATUS_inst                                                            0x001A
+#define GAMMA_STATUS_GAMMA_FIFO_Empty_shift                                          (2)
+#define GAMMA_STATUS_GAMMA_FIFO_Empty_mask                                           (0x00000004)
+#define GAMMA_STATUS_GAMMA_FIFO_Empty(data)                                          (0x00000004&((data)<<2))
+#define GAMMA_STATUS_GAMMA_FIFO_Empty_src(data)                                      ((0x00000004&(data))>>2)
+#define GAMMA_STATUS_get_GAMMA_FIFO_Empty(data)                                      ((0x00000004&(data))>>2)
+#define GAMMA_STATUS_GAMMA_FIFO_Full_shift                                           (1)
+#define GAMMA_STATUS_GAMMA_FIFO_Full_mask                                            (0x00000002)
+#define GAMMA_STATUS_GAMMA_FIFO_Full(data)                                           (0x00000002&((data)<<1))
+#define GAMMA_STATUS_GAMMA_FIFO_Full_src(data)                                       ((0x00000002&(data))>>1)
+#define GAMMA_STATUS_get_GAMMA_FIFO_Full(data)                                       ((0x00000002&(data))>>1)
+#define GAMMA_STATUS_GAMMA_WR_Error_shift                                            (0)
+#define GAMMA_STATUS_GAMMA_WR_Error_mask                                             (0x00000001)
+#define GAMMA_STATUS_GAMMA_WR_Error(data)                                            (0x00000001&((data)<<0))
+#define GAMMA_STATUS_GAMMA_WR_Error_src(data)                                        ((0x00000001&(data))>>0)
+#define GAMMA_STATUS_get_GAMMA_WR_Error(data)                                        ((0x00000001&(data))>>0)
+
+
+#define GAMMA_CTRL_2                                                                 0x1800986c
+#define GAMMA_CTRL_2_reg_addr                                                        "0xB800986C"
+#define GAMMA_CTRL_2_reg                                                             0xB800986C
+#define set_GAMMA_CTRL_2_reg(data)   (*((volatile unsigned int*) GAMMA_CTRL_2_reg)=data)
+#define get_GAMMA_CTRL_2_reg   (*((volatile unsigned int*) GAMMA_CTRL_2_reg))
+#define GAMMA_CTRL_2_inst_adr                                                        "0x001B"
+#define GAMMA_CTRL_2_inst                                                            0x001B
+#define GAMMA_CTRL_2_GAMMA_R_En_shift                                                (8)
+#define GAMMA_CTRL_2_GAMMA_R_En_mask                                                 (0x00000100)
+#define GAMMA_CTRL_2_GAMMA_R_En(data)                                                (0x00000100&((data)<<8))
+#define GAMMA_CTRL_2_GAMMA_R_En_src(data)                                            ((0x00000100&(data))>>8)
+#define GAMMA_CTRL_2_get_GAMMA_R_En(data)                                            ((0x00000100&(data))>>8)
+#define GAMMA_CTRL_2_GAMMA_G_En_shift                                                (7)
+#define GAMMA_CTRL_2_GAMMA_G_En_mask                                                 (0x00000080)
+#define GAMMA_CTRL_2_GAMMA_G_En(data)                                                (0x00000080&((data)<<7))
+#define GAMMA_CTRL_2_GAMMA_G_En_src(data)                                            ((0x00000080&(data))>>7)
+#define GAMMA_CTRL_2_get_GAMMA_G_En(data)                                            ((0x00000080&(data))>>7)
+#define GAMMA_CTRL_2_GAMMA_B_En_shift                                                (6)
+#define GAMMA_CTRL_2_GAMMA_B_En_mask                                                 (0x00000040)
+#define GAMMA_CTRL_2_GAMMA_B_En(data)                                                (0x00000040&((data)<<6))
+#define GAMMA_CTRL_2_GAMMA_B_En_src(data)                                            ((0x00000040&(data))>>6)
+#define GAMMA_CTRL_2_get_GAMMA_B_En(data)                                            ((0x00000040&(data))>>6)
+#define GAMMA_CTRL_2_GAMMA_M_TAB_Sel_shift                                           (5)
+#define GAMMA_CTRL_2_GAMMA_M_TAB_Sel_mask                                            (0x00000020)
+#define GAMMA_CTRL_2_GAMMA_M_TAB_Sel(data)                                           (0x00000020&((data)<<5))
+#define GAMMA_CTRL_2_GAMMA_M_TAB_Sel_src(data)                                       ((0x00000020&(data))>>5)
+#define GAMMA_CTRL_2_get_GAMMA_M_TAB_Sel(data)                                       ((0x00000020&(data))>>5)
+#define GAMMA_CTRL_2_Dummy_shift                                                     (0)
+#define GAMMA_CTRL_2_Dummy_mask                                                      (0x0000001F)
+#define GAMMA_CTRL_2_Dummy(data)                                                     (0x0000001F&((data)<<0))
+#define GAMMA_CTRL_2_Dummy_src(data)                                                 ((0x0000001F&(data))>>0)
+#define GAMMA_CTRL_2_get_Dummy(data)                                                 ((0x0000001F&(data))>>0)
+
+
+#define BIST_RM                                                                      0x18009870
+#define BIST_RM_reg_addr                                                             "0xB8009870"
+#define BIST_RM_reg                                                                  0xB8009870
+#define set_BIST_RM_reg(data)   (*((volatile unsigned int*) BIST_RM_reg)=data)
+#define get_BIST_RM_reg   (*((volatile unsigned int*) BIST_RM_reg))
+#define BIST_RM_inst_adr                                                             "0x001C"
+#define BIST_RM_inst                                                                 0x001C
+#define BIST_RM_RME_shift                                                            (4)
+#define BIST_RM_RME_mask                                                             (0x00000010)
+#define BIST_RM_RME(data)                                                            (0x00000010&((data)<<4))
+#define BIST_RM_RME_src(data)                                                        ((0x00000010&(data))>>4)
+#define BIST_RM_get_RME(data)                                                        ((0x00000010&(data))>>4)
+#define BIST_RM_RM_3_shift                                                           (3)
+#define BIST_RM_RM_3_mask                                                            (0x00000008)
+#define BIST_RM_RM_3(data)                                                           (0x00000008&((data)<<3))
+#define BIST_RM_RM_3_src(data)                                                       ((0x00000008&(data))>>3)
+#define BIST_RM_get_RM_3(data)                                                       ((0x00000008&(data))>>3)
+#define BIST_RM_RM_2_shift                                                           (2)
+#define BIST_RM_RM_2_mask                                                            (0x00000004)
+#define BIST_RM_RM_2(data)                                                           (0x00000004&((data)<<2))
+#define BIST_RM_RM_2_src(data)                                                       ((0x00000004&(data))>>2)
+#define BIST_RM_get_RM_2(data)                                                       ((0x00000004&(data))>>2)
+#define BIST_RM_RM_1_shift                                                           (1)
+#define BIST_RM_RM_1_mask                                                            (0x00000002)
+#define BIST_RM_RM_1(data)                                                           (0x00000002&((data)<<1))
+#define BIST_RM_RM_1_src(data)                                                       ((0x00000002&(data))>>1)
+#define BIST_RM_get_RM_1(data)                                                       ((0x00000002&(data))>>1)
+#define BIST_RM_RM_0_shift                                                           (0)
+#define BIST_RM_RM_0_mask                                                            (0x00000001)
+#define BIST_RM_RM_0(data)                                                           (0x00000001&((data)<<0))
+#define BIST_RM_RM_0_src(data)                                                       ((0x00000001&(data))>>0)
+#define BIST_RM_get_RM_0(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define BIST_ST                                                                      0x18009874
+#define BIST_ST_reg_addr                                                             "0xB8009874"
+#define BIST_ST_reg                                                                  0xB8009874
+#define set_BIST_ST_reg(data)   (*((volatile unsigned int*) BIST_ST_reg)=data)
+#define get_BIST_ST_reg   (*((volatile unsigned int*) BIST_ST_reg))
+#define BIST_ST_inst_adr                                                             "0x001D"
+#define BIST_ST_inst                                                                 0x001D
+#define BIST_ST_bist_fail2_shift                                                     (3)
+#define BIST_ST_bist_fail2_mask                                                      (0x00000008)
+#define BIST_ST_bist_fail2(data)                                                     (0x00000008&((data)<<3))
+#define BIST_ST_bist_fail2_src(data)                                                 ((0x00000008&(data))>>3)
+#define BIST_ST_get_bist_fail2(data)                                                 ((0x00000008&(data))>>3)
+#define BIST_ST_bist_fail1_shift                                                     (2)
+#define BIST_ST_bist_fail1_mask                                                      (0x00000004)
+#define BIST_ST_bist_fail1(data)                                                     (0x00000004&((data)<<2))
+#define BIST_ST_bist_fail1_src(data)                                                 ((0x00000004&(data))>>2)
+#define BIST_ST_get_bist_fail1(data)                                                 ((0x00000004&(data))>>2)
+#define BIST_ST_bist_fail0_shift                                                     (1)
+#define BIST_ST_bist_fail0_mask                                                      (0x00000002)
+#define BIST_ST_bist_fail0(data)                                                     (0x00000002&((data)<<1))
+#define BIST_ST_bist_fail0_src(data)                                                 ((0x00000002&(data))>>1)
+#define BIST_ST_get_bist_fail0(data)                                                 ((0x00000002&(data))>>1)
+#define BIST_ST_bist_done_shift                                                      (0)
+#define BIST_ST_bist_done_mask                                                       (0x00000001)
+#define BIST_ST_bist_done(data)                                                      (0x00000001&((data)<<0))
+#define BIST_ST_bist_done_src(data)                                                  ((0x00000001&(data))>>0)
+#define BIST_ST_get_bist_done(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define DRF_ST                                                                       0x18009878
+#define DRF_ST_reg_addr                                                              "0xB8009878"
+#define DRF_ST_reg                                                                   0xB8009878
+#define set_DRF_ST_reg(data)   (*((volatile unsigned int*) DRF_ST_reg)=data)
+#define get_DRF_ST_reg   (*((volatile unsigned int*) DRF_ST_reg))
+#define DRF_ST_inst_adr                                                              "0x001E"
+#define DRF_ST_inst                                                                  0x001E
+#define DRF_ST_drf_start_pause_shift                                                 (16)
+#define DRF_ST_drf_start_pause_mask                                                  (0x00010000)
+#define DRF_ST_drf_start_pause(data)                                                 (0x00010000&((data)<<16))
+#define DRF_ST_drf_start_pause_src(data)                                             ((0x00010000&(data))>>16)
+#define DRF_ST_get_drf_start_pause(data)                                             ((0x00010000&(data))>>16)
+#define DRF_ST_drf_fail2_shift                                                       (3)
+#define DRF_ST_drf_fail2_mask                                                        (0x00000008)
+#define DRF_ST_drf_fail2(data)                                                       (0x00000008&((data)<<3))
+#define DRF_ST_drf_fail2_src(data)                                                   ((0x00000008&(data))>>3)
+#define DRF_ST_get_drf_fail2(data)                                                   ((0x00000008&(data))>>3)
+#define DRF_ST_drf_fail1_shift                                                       (2)
+#define DRF_ST_drf_fail1_mask                                                        (0x00000004)
+#define DRF_ST_drf_fail1(data)                                                       (0x00000004&((data)<<2))
+#define DRF_ST_drf_fail1_src(data)                                                   ((0x00000004&(data))>>2)
+#define DRF_ST_get_drf_fail1(data)                                                   ((0x00000004&(data))>>2)
+#define DRF_ST_drf_fail0_shift                                                       (1)
+#define DRF_ST_drf_fail0_mask                                                        (0x00000002)
+#define DRF_ST_drf_fail0(data)                                                       (0x00000002&((data)<<1))
+#define DRF_ST_drf_fail0_src(data)                                                   ((0x00000002&(data))>>1)
+#define DRF_ST_get_drf_fail0(data)                                                   ((0x00000002&(data))>>1)
+#define DRF_ST_drf_done_shift                                                        (0)
+#define DRF_ST_drf_done_mask                                                         (0x00000001)
+#define DRF_ST_drf_done(data)                                                        (0x00000001&((data)<<0))
+#define DRF_ST_drf_done_src(data)                                                    ((0x00000001&(data))>>0)
+#define DRF_ST_get_drf_done(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define MBIST_CON                                                                    0x180098A4
+#define MBIST_CON_reg_addr                                                           "0xB80098A4"
+#define MBIST_CON_reg                                                                0xB80098A4
+#define set_MBIST_CON_reg(data)   (*((volatile unsigned int*) MBIST_CON_reg)=data)
+#define get_MBIST_CON_reg   (*((volatile unsigned int*) MBIST_CON_reg))
+#define MBIST_CON_inst_adr                                                           "0x0029"
+#define MBIST_CON_inst                                                               0x0029
+#define MBIST_CON_drf_test_resume_shift                                              (2)
+#define MBIST_CON_drf_test_resume_mask                                               (0x00000004)
+#define MBIST_CON_drf_test_resume(data)                                              (0x00000004&((data)<<2))
+#define MBIST_CON_drf_test_resume_src(data)                                          ((0x00000004&(data))>>2)
+#define MBIST_CON_get_drf_test_resume(data)                                          ((0x00000004&(data))>>2)
+#define MBIST_CON_drf_bist_mode_shift                                                (1)
+#define MBIST_CON_drf_bist_mode_mask                                                 (0x00000002)
+#define MBIST_CON_drf_bist_mode(data)                                                (0x00000002&((data)<<1))
+#define MBIST_CON_drf_bist_mode_src(data)                                            ((0x00000002&(data))>>1)
+#define MBIST_CON_get_drf_bist_mode(data)                                            ((0x00000002&(data))>>1)
+#define MBIST_CON_bist_mode_shift                                                    (0)
+#define MBIST_CON_bist_mode_mask                                                     (0x00000001)
+#define MBIST_CON_bist_mode(data)                                                    (0x00000001&((data)<<0))
+#define MBIST_CON_bist_mode_src(data)                                                ((0x00000001&(data))>>0)
+#define MBIST_CON_get_bist_mode(data)                                                ((0x00000001&(data))>>0)
+
+
+#define DSTAT_CTRL_R                                                                 0x18009880
+#define DSTAT_CTRL_R_reg_addr                                                        "0xB8009880"
+#define DSTAT_CTRL_R_reg                                                             0xB8009880
+#define set_DSTAT_CTRL_R_reg(data)   (*((volatile unsigned int*) DSTAT_CTRL_R_reg)=data)
+#define get_DSTAT_CTRL_R_reg   (*((volatile unsigned int*) DSTAT_CTRL_R_reg))
+#define DSTAT_CTRL_R_inst_adr                                                        "0x0020"
+#define DSTAT_CTRL_R_inst                                                            0x0020
+#define DSTAT_CTRL_R_D_Stat_SrcSel_shift                                             (30)
+#define DSTAT_CTRL_R_D_Stat_SrcSel_mask                                              (0x40000000)
+#define DSTAT_CTRL_R_D_Stat_SrcSel(data)                                             (0x40000000&((data)<<30))
+#define DSTAT_CTRL_R_D_Stat_SrcSel_src(data)                                         ((0x40000000&(data))>>30)
+#define DSTAT_CTRL_R_get_D_Stat_SrcSel(data)                                         ((0x40000000&(data))>>30)
+#define DSTAT_CTRL_R_R_Low_shift                                                     (16)
+#define DSTAT_CTRL_R_R_Low_mask                                                      (0x03FF0000)
+#define DSTAT_CTRL_R_R_Low(data)                                                     (0x03FF0000&((data)<<16))
+#define DSTAT_CTRL_R_R_Low_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define DSTAT_CTRL_R_get_R_Low(data)                                                 ((0x03FF0000&(data))>>16)
+#define DSTAT_CTRL_R_R_High_shift                                                    (0)
+#define DSTAT_CTRL_R_R_High_mask                                                     (0x000003FF)
+#define DSTAT_CTRL_R_R_High(data)                                                    (0x000003FF&((data)<<0))
+#define DSTAT_CTRL_R_R_High_src(data)                                                ((0x000003FF&(data))>>0)
+#define DSTAT_CTRL_R_get_R_High(data)                                                ((0x000003FF&(data))>>0)
+
+
+#define DSTAT_CTRL_G                                                                 0x18009884
+#define DSTAT_CTRL_G_reg_addr                                                        "0xB8009884"
+#define DSTAT_CTRL_G_reg                                                             0xB8009884
+#define set_DSTAT_CTRL_G_reg(data)   (*((volatile unsigned int*) DSTAT_CTRL_G_reg)=data)
+#define get_DSTAT_CTRL_G_reg   (*((volatile unsigned int*) DSTAT_CTRL_G_reg))
+#define DSTAT_CTRL_G_inst_adr                                                        "0x0021"
+#define DSTAT_CTRL_G_inst                                                            0x0021
+#define DSTAT_CTRL_G_G_Low_shift                                                     (16)
+#define DSTAT_CTRL_G_G_Low_mask                                                      (0x03FF0000)
+#define DSTAT_CTRL_G_G_Low(data)                                                     (0x03FF0000&((data)<<16))
+#define DSTAT_CTRL_G_G_Low_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define DSTAT_CTRL_G_get_G_Low(data)                                                 ((0x03FF0000&(data))>>16)
+#define DSTAT_CTRL_G_G_High_shift                                                    (0)
+#define DSTAT_CTRL_G_G_High_mask                                                     (0x000003FF)
+#define DSTAT_CTRL_G_G_High(data)                                                    (0x000003FF&((data)<<0))
+#define DSTAT_CTRL_G_G_High_src(data)                                                ((0x000003FF&(data))>>0)
+#define DSTAT_CTRL_G_get_G_High(data)                                                ((0x000003FF&(data))>>0)
+
+
+#define DSTAT_CTRL_B                                                                 0x18009888
+#define DSTAT_CTRL_B_reg_addr                                                        "0xB8009888"
+#define DSTAT_CTRL_B_reg                                                             0xB8009888
+#define set_DSTAT_CTRL_B_reg(data)   (*((volatile unsigned int*) DSTAT_CTRL_B_reg)=data)
+#define get_DSTAT_CTRL_B_reg   (*((volatile unsigned int*) DSTAT_CTRL_B_reg))
+#define DSTAT_CTRL_B_inst_adr                                                        "0x0022"
+#define DSTAT_CTRL_B_inst                                                            0x0022
+#define DSTAT_CTRL_B_B_Low_shift                                                     (16)
+#define DSTAT_CTRL_B_B_Low_mask                                                      (0x03FF0000)
+#define DSTAT_CTRL_B_B_Low(data)                                                     (0x03FF0000&((data)<<16))
+#define DSTAT_CTRL_B_B_Low_src(data)                                                 ((0x03FF0000&(data))>>16)
+#define DSTAT_CTRL_B_get_B_Low(data)                                                 ((0x03FF0000&(data))>>16)
+#define DSTAT_CTRL_B_B_High_shift                                                    (0)
+#define DSTAT_CTRL_B_B_High_mask                                                     (0x000003FF)
+#define DSTAT_CTRL_B_B_High(data)                                                    (0x000003FF&((data)<<0))
+#define DSTAT_CTRL_B_B_High_src(data)                                                ((0x000003FF&(data))>>0)
+#define DSTAT_CTRL_B_get_B_High(data)                                                ((0x000003FF&(data))>>0)
+
+
+#define DSTAT_O_R1                                                                   0x1800988c
+#define DSTAT_O_R1_reg_addr                                                          "0xB800988C"
+#define DSTAT_O_R1_reg                                                               0xB800988C
+#define set_DSTAT_O_R1_reg(data)   (*((volatile unsigned int*) DSTAT_O_R1_reg)=data)
+#define get_DSTAT_O_R1_reg   (*((volatile unsigned int*) DSTAT_O_R1_reg))
+#define DSTAT_O_R1_inst_adr                                                          "0x0023"
+#define DSTAT_O_R1_inst                                                              0x0023
+#define DSTAT_O_R1_R_Cnt_shift                                                       (0)
+#define DSTAT_O_R1_R_Cnt_mask                                                        (0x001FFFFF)
+#define DSTAT_O_R1_R_Cnt(data)                                                       (0x001FFFFF&((data)<<0))
+#define DSTAT_O_R1_R_Cnt_src(data)                                                   ((0x001FFFFF&(data))>>0)
+#define DSTAT_O_R1_get_R_Cnt(data)                                                   ((0x001FFFFF&(data))>>0)
+
+
+#define DSTAT_O_R2                                                                   0x18009890
+#define DSTAT_O_R2_reg_addr                                                          "0xB8009890"
+#define DSTAT_O_R2_reg                                                               0xB8009890
+#define set_DSTAT_O_R2_reg(data)   (*((volatile unsigned int*) DSTAT_O_R2_reg)=data)
+#define get_DSTAT_O_R2_reg   (*((volatile unsigned int*) DSTAT_O_R2_reg))
+#define DSTAT_O_R2_inst_adr                                                          "0x0024"
+#define DSTAT_O_R2_inst                                                              0x0024
+#define DSTAT_O_R2_R_Min_shift                                                       (16)
+#define DSTAT_O_R2_R_Min_mask                                                        (0x03FF0000)
+#define DSTAT_O_R2_R_Min(data)                                                       (0x03FF0000&((data)<<16))
+#define DSTAT_O_R2_R_Min_src(data)                                                   ((0x03FF0000&(data))>>16)
+#define DSTAT_O_R2_get_R_Min(data)                                                   ((0x03FF0000&(data))>>16)
+#define DSTAT_O_R2_R_Max_shift                                                       (0)
+#define DSTAT_O_R2_R_Max_mask                                                        (0x000003FF)
+#define DSTAT_O_R2_R_Max(data)                                                       (0x000003FF&((data)<<0))
+#define DSTAT_O_R2_R_Max_src(data)                                                   ((0x000003FF&(data))>>0)
+#define DSTAT_O_R2_get_R_Max(data)                                                   ((0x000003FF&(data))>>0)
+
+
+#define DSTAT_O_G1                                                                   0x18009894
+#define DSTAT_O_G1_reg_addr                                                          "0xB8009894"
+#define DSTAT_O_G1_reg                                                               0xB8009894
+#define set_DSTAT_O_G1_reg(data)   (*((volatile unsigned int*) DSTAT_O_G1_reg)=data)
+#define get_DSTAT_O_G1_reg   (*((volatile unsigned int*) DSTAT_O_G1_reg))
+#define DSTAT_O_G1_inst_adr                                                          "0x0025"
+#define DSTAT_O_G1_inst                                                              0x0025
+#define DSTAT_O_G1_G_Cnt_shift                                                       (0)
+#define DSTAT_O_G1_G_Cnt_mask                                                        (0x001FFFFF)
+#define DSTAT_O_G1_G_Cnt(data)                                                       (0x001FFFFF&((data)<<0))
+#define DSTAT_O_G1_G_Cnt_src(data)                                                   ((0x001FFFFF&(data))>>0)
+#define DSTAT_O_G1_get_G_Cnt(data)                                                   ((0x001FFFFF&(data))>>0)
+
+
+#define DSTAT_O_G2                                                                   0x18009898
+#define DSTAT_O_G2_reg_addr                                                          "0xB8009898"
+#define DSTAT_O_G2_reg                                                               0xB8009898
+#define set_DSTAT_O_G2_reg(data)   (*((volatile unsigned int*) DSTAT_O_G2_reg)=data)
+#define get_DSTAT_O_G2_reg   (*((volatile unsigned int*) DSTAT_O_G2_reg))
+#define DSTAT_O_G2_inst_adr                                                          "0x0026"
+#define DSTAT_O_G2_inst                                                              0x0026
+#define DSTAT_O_G2_G_Min_shift                                                       (16)
+#define DSTAT_O_G2_G_Min_mask                                                        (0x03FF0000)
+#define DSTAT_O_G2_G_Min(data)                                                       (0x03FF0000&((data)<<16))
+#define DSTAT_O_G2_G_Min_src(data)                                                   ((0x03FF0000&(data))>>16)
+#define DSTAT_O_G2_get_G_Min(data)                                                   ((0x03FF0000&(data))>>16)
+#define DSTAT_O_G2_G_Max_shift                                                       (0)
+#define DSTAT_O_G2_G_Max_mask                                                        (0x000003FF)
+#define DSTAT_O_G2_G_Max(data)                                                       (0x000003FF&((data)<<0))
+#define DSTAT_O_G2_G_Max_src(data)                                                   ((0x000003FF&(data))>>0)
+#define DSTAT_O_G2_get_G_Max(data)                                                   ((0x000003FF&(data))>>0)
+
+
+#define DSTAT_O_B1                                                                   0x1800989c
+#define DSTAT_O_B1_reg_addr                                                          "0xB800989C"
+#define DSTAT_O_B1_reg                                                               0xB800989C
+#define set_DSTAT_O_B1_reg(data)   (*((volatile unsigned int*) DSTAT_O_B1_reg)=data)
+#define get_DSTAT_O_B1_reg   (*((volatile unsigned int*) DSTAT_O_B1_reg))
+#define DSTAT_O_B1_inst_adr                                                          "0x0027"
+#define DSTAT_O_B1_inst                                                              0x0027
+#define DSTAT_O_B1_B_Cnt_shift                                                       (0)
+#define DSTAT_O_B1_B_Cnt_mask                                                        (0x001FFFFF)
+#define DSTAT_O_B1_B_Cnt(data)                                                       (0x001FFFFF&((data)<<0))
+#define DSTAT_O_B1_B_Cnt_src(data)                                                   ((0x001FFFFF&(data))>>0)
+#define DSTAT_O_B1_get_B_Cnt(data)                                                   ((0x001FFFFF&(data))>>0)
+
+
+#define DSTAT_O_B2                                                                   0x180098a0
+#define DSTAT_O_B2_reg_addr                                                          "0xB80098A0"
+#define DSTAT_O_B2_reg                                                               0xB80098A0
+#define set_DSTAT_O_B2_reg(data)   (*((volatile unsigned int*) DSTAT_O_B2_reg)=data)
+#define get_DSTAT_O_B2_reg   (*((volatile unsigned int*) DSTAT_O_B2_reg))
+#define DSTAT_O_B2_inst_adr                                                          "0x0028"
+#define DSTAT_O_B2_inst                                                              0x0028
+#define DSTAT_O_B2_B_Min_shift                                                       (16)
+#define DSTAT_O_B2_B_Min_mask                                                        (0x03FF0000)
+#define DSTAT_O_B2_B_Min(data)                                                       (0x03FF0000&((data)<<16))
+#define DSTAT_O_B2_B_Min_src(data)                                                   ((0x03FF0000&(data))>>16)
+#define DSTAT_O_B2_get_B_Min(data)                                                   ((0x03FF0000&(data))>>16)
+#define DSTAT_O_B2_B_Max_shift                                                       (0)
+#define DSTAT_O_B2_B_Max_mask                                                        (0x000003FF)
+#define DSTAT_O_B2_B_Max(data)                                                       (0x000003FF&((data)<<0))
+#define DSTAT_O_B2_B_Max_src(data)                                                   ((0x000003FF&(data))>>0)
+#define DSTAT_O_B2_get_B_Max(data)                                                   ((0x000003FF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_lvdsout_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_lvdsout_reg.h
new file mode 100644
index 00000000..cdd4e81
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_lvdsout_reg.h
@@ -0,0 +1,167 @@
+/**************************************************************
+// Spec Version                  : 1.0.6
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/7/16 15:33:11
+***************************************************************/
+
+
+#ifndef _LVDSOUT_REG_H_INCLUDED_
+#define _LVDSOUT_REG_H_INCLUDED_
+#ifdef  _LVDSOUT_USE_STRUCT
+typedef struct 
+{
+unsigned int     lvds_arsv1_sel:3;
+unsigned int     lvds_arsv0_sel:3;
+unsigned int     lvds_aden_sel:3;
+unsigned int     lvds_avs_sel:3;
+unsigned int     lvds_ahs_sel:3;
+unsigned int     reserved_0:1;
+unsigned int     lvds_brsv1_sel:3;
+unsigned int     lvds_brsv0_sel:3;
+unsigned int     lvds_bden_sel:3;
+unsigned int     lvds_bvs_sel:3;
+unsigned int     lvds_bhs_sel:3;
+unsigned int     dual_mode:1;
+}LVDS_CTRL1;
+
+typedef struct 
+{
+unsigned int     reserved:19;
+unsigned int     lvds_port_swap:1;
+unsigned int     lvds_pn_swap:1;
+unsigned int     lvds_mirror:1;
+unsigned int     lvds_map:1;
+unsigned int     ttl_en:1;
+unsigned int     lvds_aport_en:1;
+unsigned int     lvds_bport_en:1;
+unsigned int     reserved_0:4;
+unsigned int     dout_mode:2;
+}LVDS_CTRL2;
+
+#endif
+
+#define LVDS_CTRL1                                                                   0x18009008
+#define LVDS_CTRL1_reg_addr                                                          "0xB8009008"
+#define LVDS_CTRL1_reg                                                               0xB8009008
+#define set_LVDS_CTRL1_reg(data)   (*((volatile unsigned int*) LVDS_CTRL1_reg)=data)
+#define get_LVDS_CTRL1_reg   (*((volatile unsigned int*) LVDS_CTRL1_reg))
+#define LVDS_CTRL1_inst_adr                                                          "0x0002"
+#define LVDS_CTRL1_inst                                                              0x0002
+#define LVDS_CTRL1_lvds_arsv1_sel_shift                                              (29)
+#define LVDS_CTRL1_lvds_arsv1_sel_mask                                               (0xE0000000)
+#define LVDS_CTRL1_lvds_arsv1_sel(data)                                              (0xE0000000&((data)<<29))
+#define LVDS_CTRL1_lvds_arsv1_sel_src(data)                                          ((0xE0000000&(data))>>29)
+#define LVDS_CTRL1_get_lvds_arsv1_sel(data)                                          ((0xE0000000&(data))>>29)
+#define LVDS_CTRL1_lvds_arsv0_sel_shift                                              (26)
+#define LVDS_CTRL1_lvds_arsv0_sel_mask                                               (0x1C000000)
+#define LVDS_CTRL1_lvds_arsv0_sel(data)                                              (0x1C000000&((data)<<26))
+#define LVDS_CTRL1_lvds_arsv0_sel_src(data)                                          ((0x1C000000&(data))>>26)
+#define LVDS_CTRL1_get_lvds_arsv0_sel(data)                                          ((0x1C000000&(data))>>26)
+#define LVDS_CTRL1_lvds_aden_sel_shift                                               (23)
+#define LVDS_CTRL1_lvds_aden_sel_mask                                                (0x03800000)
+#define LVDS_CTRL1_lvds_aden_sel(data)                                               (0x03800000&((data)<<23))
+#define LVDS_CTRL1_lvds_aden_sel_src(data)                                           ((0x03800000&(data))>>23)
+#define LVDS_CTRL1_get_lvds_aden_sel(data)                                           ((0x03800000&(data))>>23)
+#define LVDS_CTRL1_lvds_avs_sel_shift                                                (20)
+#define LVDS_CTRL1_lvds_avs_sel_mask                                                 (0x00700000)
+#define LVDS_CTRL1_lvds_avs_sel(data)                                                (0x00700000&((data)<<20))
+#define LVDS_CTRL1_lvds_avs_sel_src(data)                                            ((0x00700000&(data))>>20)
+#define LVDS_CTRL1_get_lvds_avs_sel(data)                                            ((0x00700000&(data))>>20)
+#define LVDS_CTRL1_lvds_ahs_sel_shift                                                (17)
+#define LVDS_CTRL1_lvds_ahs_sel_mask                                                 (0x000E0000)
+#define LVDS_CTRL1_lvds_ahs_sel(data)                                                (0x000E0000&((data)<<17))
+#define LVDS_CTRL1_lvds_ahs_sel_src(data)                                            ((0x000E0000&(data))>>17)
+#define LVDS_CTRL1_get_lvds_ahs_sel(data)                                            ((0x000E0000&(data))>>17)
+#define LVDS_CTRL1_lvds_brsv1_sel_shift                                              (13)
+#define LVDS_CTRL1_lvds_brsv1_sel_mask                                               (0x0000E000)
+#define LVDS_CTRL1_lvds_brsv1_sel(data)                                              (0x0000E000&((data)<<13))
+#define LVDS_CTRL1_lvds_brsv1_sel_src(data)                                          ((0x0000E000&(data))>>13)
+#define LVDS_CTRL1_get_lvds_brsv1_sel(data)                                          ((0x0000E000&(data))>>13)
+#define LVDS_CTRL1_lvds_brsv0_sel_shift                                              (10)
+#define LVDS_CTRL1_lvds_brsv0_sel_mask                                               (0x00001C00)
+#define LVDS_CTRL1_lvds_brsv0_sel(data)                                              (0x00001C00&((data)<<10))
+#define LVDS_CTRL1_lvds_brsv0_sel_src(data)                                          ((0x00001C00&(data))>>10)
+#define LVDS_CTRL1_get_lvds_brsv0_sel(data)                                          ((0x00001C00&(data))>>10)
+#define LVDS_CTRL1_lvds_bden_sel_shift                                               (7)
+#define LVDS_CTRL1_lvds_bden_sel_mask                                                (0x00000380)
+#define LVDS_CTRL1_lvds_bden_sel(data)                                               (0x00000380&((data)<<7))
+#define LVDS_CTRL1_lvds_bden_sel_src(data)                                           ((0x00000380&(data))>>7)
+#define LVDS_CTRL1_get_lvds_bden_sel(data)                                           ((0x00000380&(data))>>7)
+#define LVDS_CTRL1_lvds_bvs_sel_shift                                                (4)
+#define LVDS_CTRL1_lvds_bvs_sel_mask                                                 (0x00000070)
+#define LVDS_CTRL1_lvds_bvs_sel(data)                                                (0x00000070&((data)<<4))
+#define LVDS_CTRL1_lvds_bvs_sel_src(data)                                            ((0x00000070&(data))>>4)
+#define LVDS_CTRL1_get_lvds_bvs_sel(data)                                            ((0x00000070&(data))>>4)
+#define LVDS_CTRL1_lvds_bhs_sel_shift                                                (1)
+#define LVDS_CTRL1_lvds_bhs_sel_mask                                                 (0x0000000E)
+#define LVDS_CTRL1_lvds_bhs_sel(data)                                                (0x0000000E&((data)<<1))
+#define LVDS_CTRL1_lvds_bhs_sel_src(data)                                            ((0x0000000E&(data))>>1)
+#define LVDS_CTRL1_get_lvds_bhs_sel(data)                                            ((0x0000000E&(data))>>1)
+#define LVDS_CTRL1_dual_mode_shift                                                   (0)
+#define LVDS_CTRL1_dual_mode_mask                                                    (0x00000001)
+#define LVDS_CTRL1_dual_mode(data)                                                   (0x00000001&((data)<<0))
+#define LVDS_CTRL1_dual_mode_src(data)                                               ((0x00000001&(data))>>0)
+#define LVDS_CTRL1_get_dual_mode(data)                                               ((0x00000001&(data))>>0)
+
+
+#define LVDS_CTRL2                                                                   0x1800900C
+#define LVDS_CTRL2_reg_addr                                                          "0xB800900C"
+#define LVDS_CTRL2_reg                                                               0xB800900C
+#define set_LVDS_CTRL2_reg(data)   (*((volatile unsigned int*) LVDS_CTRL2_reg)=data)
+#define get_LVDS_CTRL2_reg   (*((volatile unsigned int*) LVDS_CTRL2_reg))
+#define LVDS_CTRL2_inst_adr                                                          "0x0003"
+#define LVDS_CTRL2_inst                                                              0x0003
+#define LVDS_CTRL2_reserved_shift                                                    (13)
+#define LVDS_CTRL2_reserved_mask                                                     (0xFFFFE000)
+#define LVDS_CTRL2_reserved(data)                                                    (0xFFFFE000&((data)<<13))
+#define LVDS_CTRL2_reserved_src(data)                                                ((0xFFFFE000&(data))>>13)
+#define LVDS_CTRL2_get_reserved(data)                                                ((0xFFFFE000&(data))>>13)
+#define LVDS_CTRL2_lvds_port_swap_shift                                              (12)
+#define LVDS_CTRL2_lvds_port_swap_mask                                               (0x00001000)
+#define LVDS_CTRL2_lvds_port_swap(data)                                              (0x00001000&((data)<<12))
+#define LVDS_CTRL2_lvds_port_swap_src(data)                                          ((0x00001000&(data))>>12)
+#define LVDS_CTRL2_get_lvds_port_swap(data)                                          ((0x00001000&(data))>>12)
+#define LVDS_CTRL2_lvds_pn_swap_shift                                                (11)
+#define LVDS_CTRL2_lvds_pn_swap_mask                                                 (0x00000800)
+#define LVDS_CTRL2_lvds_pn_swap(data)                                                (0x00000800&((data)<<11))
+#define LVDS_CTRL2_lvds_pn_swap_src(data)                                            ((0x00000800&(data))>>11)
+#define LVDS_CTRL2_get_lvds_pn_swap(data)                                            ((0x00000800&(data))>>11)
+#define LVDS_CTRL2_lvds_mirror_shift                                                 (10)
+#define LVDS_CTRL2_lvds_mirror_mask                                                  (0x00000400)
+#define LVDS_CTRL2_lvds_mirror(data)                                                 (0x00000400&((data)<<10))
+#define LVDS_CTRL2_lvds_mirror_src(data)                                             ((0x00000400&(data))>>10)
+#define LVDS_CTRL2_get_lvds_mirror(data)                                             ((0x00000400&(data))>>10)
+#define LVDS_CTRL2_lvds_map_shift                                                    (9)
+#define LVDS_CTRL2_lvds_map_mask                                                     (0x00000200)
+#define LVDS_CTRL2_lvds_map(data)                                                    (0x00000200&((data)<<9))
+#define LVDS_CTRL2_lvds_map_src(data)                                                ((0x00000200&(data))>>9)
+#define LVDS_CTRL2_get_lvds_map(data)                                                ((0x00000200&(data))>>9)
+#define LVDS_CTRL2_ttl_en_shift                                                      (8)
+#define LVDS_CTRL2_ttl_en_mask                                                       (0x00000100)
+#define LVDS_CTRL2_ttl_en(data)                                                      (0x00000100&((data)<<8))
+#define LVDS_CTRL2_ttl_en_src(data)                                                  ((0x00000100&(data))>>8)
+#define LVDS_CTRL2_get_ttl_en(data)                                                  ((0x00000100&(data))>>8)
+#define LVDS_CTRL2_lvds_aport_en_shift                                               (7)
+#define LVDS_CTRL2_lvds_aport_en_mask                                                (0x00000080)
+#define LVDS_CTRL2_lvds_aport_en(data)                                               (0x00000080&((data)<<7))
+#define LVDS_CTRL2_lvds_aport_en_src(data)                                           ((0x00000080&(data))>>7)
+#define LVDS_CTRL2_get_lvds_aport_en(data)                                           ((0x00000080&(data))>>7)
+#define LVDS_CTRL2_lvds_bport_en_shift                                               (6)
+#define LVDS_CTRL2_lvds_bport_en_mask                                                (0x00000040)
+#define LVDS_CTRL2_lvds_bport_en(data)                                               (0x00000040&((data)<<6))
+#define LVDS_CTRL2_lvds_bport_en_src(data)                                           ((0x00000040&(data))>>6)
+#define LVDS_CTRL2_get_lvds_bport_en(data)                                           ((0x00000040&(data))>>6)
+#define LVDS_CTRL2_dout_mode_shift                                                   (0)
+#define LVDS_CTRL2_dout_mode_mask                                                    (0x00000003)
+#define LVDS_CTRL2_dout_mode(data)                                                   (0x00000003&((data)<<0))
+#define LVDS_CTRL2_dout_mode_src(data)                                               ((0x00000003&(data))>>0)
+#define LVDS_CTRL2_get_dout_mode(data)                                               ((0x00000003&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_pif_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_pif_reg.h
new file mode 100644
index 00000000..8b369a9
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_pif_reg.h
@@ -0,0 +1,297 @@
+/**************************************************************
+// Spec Version                  : 1.0.6
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/4/24 15:17:21
+***************************************************************/
+
+
+#ifndef _PIF_REG_H_INCLUDED_
+#define _PIF_REG_H_INCLUDED_
+#ifdef  _PIF_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     int_prog:1;
+unsigned int     dh_inv:1;
+unsigned int     dv_inv:1;
+}TIMEGEN_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     dh_width:12;
+}DH_WIDTH;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dh_total:12;
+unsigned int     reserved_1:4;
+unsigned int     dh_total_last_line:12;
+}DH_TOTAL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dh_den_sta:12;
+unsigned int     reserved_1:4;
+unsigned int     dh_den_end:12;
+}DH_DEN_START_END;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dv_den_sta_field1:12;
+unsigned int     reserved_1:4;
+unsigned int     dv_den_end_field1:12;
+}DV_DEN_START_END_FIELD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     dv_total:12;
+}DV_TOTAL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dv_vs_sta_field1:12;
+unsigned int     reserved_1:4;
+unsigned int     dv_vs_end_field1:12;
+}DV_VS_START_END_FIELD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     dh_vs_adj_field1:12;
+}DH_VS_ADJ_FIELD1;
+
+typedef struct 
+{
+unsigned int     int_en:1;
+unsigned int     reserved_0:19;
+unsigned int     dv_sync_int:12;
+}DV_SYNC_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     neg:1;
+}PIF_CTRL0;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     lvds_dbg_sel1:7;
+unsigned int     lvds_dbg_sel0:7;
+unsigned int     lvds_dbg_enable:1;
+}LVDS_DBG;
+
+#endif
+
+#define TIMEGEN_CTRL                                                                 0x18009800
+#define TIMEGEN_CTRL_reg_addr                                                        "0xB8009800"
+#define TIMEGEN_CTRL_reg                                                             0xB8009800
+#define set_TIMEGEN_CTRL_reg(data)   (*((volatile unsigned int*) TIMEGEN_CTRL_reg)=data)
+#define get_TIMEGEN_CTRL_reg   (*((volatile unsigned int*) TIMEGEN_CTRL_reg))
+#define TIMEGEN_CTRL_inst_adr                                                        "0x0000"
+#define TIMEGEN_CTRL_inst                                                            0x0000
+#define TIMEGEN_CTRL_int_prog_shift                                                  (2)
+#define TIMEGEN_CTRL_int_prog_mask                                                   (0x00000004)
+#define TIMEGEN_CTRL_int_prog(data)                                                  (0x00000004&((data)<<2))
+#define TIMEGEN_CTRL_int_prog_src(data)                                              ((0x00000004&(data))>>2)
+#define TIMEGEN_CTRL_get_int_prog(data)                                              ((0x00000004&(data))>>2)
+#define TIMEGEN_CTRL_dh_inv_shift                                                    (1)
+#define TIMEGEN_CTRL_dh_inv_mask                                                     (0x00000002)
+#define TIMEGEN_CTRL_dh_inv(data)                                                    (0x00000002&((data)<<1))
+#define TIMEGEN_CTRL_dh_inv_src(data)                                                ((0x00000002&(data))>>1)
+#define TIMEGEN_CTRL_get_dh_inv(data)                                                ((0x00000002&(data))>>1)
+#define TIMEGEN_CTRL_dv_inv_shift                                                    (0)
+#define TIMEGEN_CTRL_dv_inv_mask                                                     (0x00000001)
+#define TIMEGEN_CTRL_dv_inv(data)                                                    (0x00000001&((data)<<0))
+#define TIMEGEN_CTRL_dv_inv_src(data)                                                ((0x00000001&(data))>>0)
+#define TIMEGEN_CTRL_get_dv_inv(data)                                                ((0x00000001&(data))>>0)
+
+
+#define DH_WIDTH                                                                     0x18009804
+#define DH_WIDTH_reg_addr                                                            "0xB8009804"
+#define DH_WIDTH_reg                                                                 0xB8009804
+#define set_DH_WIDTH_reg(data)   (*((volatile unsigned int*) DH_WIDTH_reg)=data)
+#define get_DH_WIDTH_reg   (*((volatile unsigned int*) DH_WIDTH_reg))
+#define DH_WIDTH_inst_adr                                                            "0x0001"
+#define DH_WIDTH_inst                                                                0x0001
+#define DH_WIDTH_dh_width_shift                                                      (0)
+#define DH_WIDTH_dh_width_mask                                                       (0x00000FFF)
+#define DH_WIDTH_dh_width(data)                                                      (0x00000FFF&((data)<<0))
+#define DH_WIDTH_dh_width_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define DH_WIDTH_get_dh_width(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define DH_TOTAL                                                                     0x18009808
+#define DH_TOTAL_reg_addr                                                            "0xB8009808"
+#define DH_TOTAL_reg                                                                 0xB8009808
+#define set_DH_TOTAL_reg(data)   (*((volatile unsigned int*) DH_TOTAL_reg)=data)
+#define get_DH_TOTAL_reg   (*((volatile unsigned int*) DH_TOTAL_reg))
+#define DH_TOTAL_inst_adr                                                            "0x0002"
+#define DH_TOTAL_inst                                                                0x0002
+#define DH_TOTAL_dh_total_shift                                                      (16)
+#define DH_TOTAL_dh_total_mask                                                       (0x0FFF0000)
+#define DH_TOTAL_dh_total(data)                                                      (0x0FFF0000&((data)<<16))
+#define DH_TOTAL_dh_total_src(data)                                                  ((0x0FFF0000&(data))>>16)
+#define DH_TOTAL_get_dh_total(data)                                                  ((0x0FFF0000&(data))>>16)
+#define DH_TOTAL_dh_total_last_line_shift                                            (0)
+#define DH_TOTAL_dh_total_last_line_mask                                             (0x00000FFF)
+#define DH_TOTAL_dh_total_last_line(data)                                            (0x00000FFF&((data)<<0))
+#define DH_TOTAL_dh_total_last_line_src(data)                                        ((0x00000FFF&(data))>>0)
+#define DH_TOTAL_get_dh_total_last_line(data)                                        ((0x00000FFF&(data))>>0)
+
+
+#define DH_DEN_START_END                                                             0x1800980c
+#define DH_DEN_START_END_reg_addr                                                    "0xB800980C"
+#define DH_DEN_START_END_reg                                                         0xB800980C
+#define set_DH_DEN_START_END_reg(data)   (*((volatile unsigned int*) DH_DEN_START_END_reg)=data)
+#define get_DH_DEN_START_END_reg   (*((volatile unsigned int*) DH_DEN_START_END_reg))
+#define DH_DEN_START_END_inst_adr                                                    "0x0003"
+#define DH_DEN_START_END_inst                                                        0x0003
+#define DH_DEN_START_END_dh_den_sta_shift                                            (16)
+#define DH_DEN_START_END_dh_den_sta_mask                                             (0x0FFF0000)
+#define DH_DEN_START_END_dh_den_sta(data)                                            (0x0FFF0000&((data)<<16))
+#define DH_DEN_START_END_dh_den_sta_src(data)                                        ((0x0FFF0000&(data))>>16)
+#define DH_DEN_START_END_get_dh_den_sta(data)                                        ((0x0FFF0000&(data))>>16)
+#define DH_DEN_START_END_dh_den_end_shift                                            (0)
+#define DH_DEN_START_END_dh_den_end_mask                                             (0x00000FFF)
+#define DH_DEN_START_END_dh_den_end(data)                                            (0x00000FFF&((data)<<0))
+#define DH_DEN_START_END_dh_den_end_src(data)                                        ((0x00000FFF&(data))>>0)
+#define DH_DEN_START_END_get_dh_den_end(data)                                        ((0x00000FFF&(data))>>0)
+
+
+#define DV_DEN_START_END_FIELD1                                                      0x18009810
+#define DV_DEN_START_END_FIELD1_reg_addr                                             "0xB8009810"
+#define DV_DEN_START_END_FIELD1_reg                                                  0xB8009810
+#define set_DV_DEN_START_END_FIELD1_reg(data)   (*((volatile unsigned int*) DV_DEN_START_END_FIELD1_reg)=data)
+#define get_DV_DEN_START_END_FIELD1_reg   (*((volatile unsigned int*) DV_DEN_START_END_FIELD1_reg))
+#define DV_DEN_START_END_FIELD1_inst_adr                                             "0x0004"
+#define DV_DEN_START_END_FIELD1_inst                                                 0x0004
+#define DV_DEN_START_END_FIELD1_dv_den_sta_field1_shift                              (16)
+#define DV_DEN_START_END_FIELD1_dv_den_sta_field1_mask                               (0x0FFF0000)
+#define DV_DEN_START_END_FIELD1_dv_den_sta_field1(data)                              (0x0FFF0000&((data)<<16))
+#define DV_DEN_START_END_FIELD1_dv_den_sta_field1_src(data)                          ((0x0FFF0000&(data))>>16)
+#define DV_DEN_START_END_FIELD1_get_dv_den_sta_field1(data)                          ((0x0FFF0000&(data))>>16)
+#define DV_DEN_START_END_FIELD1_dv_den_end_field1_shift                              (0)
+#define DV_DEN_START_END_FIELD1_dv_den_end_field1_mask                               (0x00000FFF)
+#define DV_DEN_START_END_FIELD1_dv_den_end_field1(data)                              (0x00000FFF&((data)<<0))
+#define DV_DEN_START_END_FIELD1_dv_den_end_field1_src(data)                          ((0x00000FFF&(data))>>0)
+#define DV_DEN_START_END_FIELD1_get_dv_den_end_field1(data)                          ((0x00000FFF&(data))>>0)
+
+
+#define DV_TOTAL                                                                     0x18009818
+#define DV_TOTAL_reg_addr                                                            "0xB8009818"
+#define DV_TOTAL_reg                                                                 0xB8009818
+#define set_DV_TOTAL_reg(data)   (*((volatile unsigned int*) DV_TOTAL_reg)=data)
+#define get_DV_TOTAL_reg   (*((volatile unsigned int*) DV_TOTAL_reg))
+#define DV_TOTAL_inst_adr                                                            "0x0006"
+#define DV_TOTAL_inst                                                                0x0006
+#define DV_TOTAL_dv_total_shift                                                      (0)
+#define DV_TOTAL_dv_total_mask                                                       (0x00000FFF)
+#define DV_TOTAL_dv_total(data)                                                      (0x00000FFF&((data)<<0))
+#define DV_TOTAL_dv_total_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define DV_TOTAL_get_dv_total(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define DV_VS_START_END_FIELD1                                                       0x1800981c
+#define DV_VS_START_END_FIELD1_reg_addr                                              "0xB800981C"
+#define DV_VS_START_END_FIELD1_reg                                                   0xB800981C
+#define set_DV_VS_START_END_FIELD1_reg(data)   (*((volatile unsigned int*) DV_VS_START_END_FIELD1_reg)=data)
+#define get_DV_VS_START_END_FIELD1_reg   (*((volatile unsigned int*) DV_VS_START_END_FIELD1_reg))
+#define DV_VS_START_END_FIELD1_inst_adr                                              "0x0007"
+#define DV_VS_START_END_FIELD1_inst                                                  0x0007
+#define DV_VS_START_END_FIELD1_dv_vs_sta_field1_shift                                (16)
+#define DV_VS_START_END_FIELD1_dv_vs_sta_field1_mask                                 (0x0FFF0000)
+#define DV_VS_START_END_FIELD1_dv_vs_sta_field1(data)                                (0x0FFF0000&((data)<<16))
+#define DV_VS_START_END_FIELD1_dv_vs_sta_field1_src(data)                            ((0x0FFF0000&(data))>>16)
+#define DV_VS_START_END_FIELD1_get_dv_vs_sta_field1(data)                            ((0x0FFF0000&(data))>>16)
+#define DV_VS_START_END_FIELD1_dv_vs_end_field1_shift                                (0)
+#define DV_VS_START_END_FIELD1_dv_vs_end_field1_mask                                 (0x00000FFF)
+#define DV_VS_START_END_FIELD1_dv_vs_end_field1(data)                                (0x00000FFF&((data)<<0))
+#define DV_VS_START_END_FIELD1_dv_vs_end_field1_src(data)                            ((0x00000FFF&(data))>>0)
+#define DV_VS_START_END_FIELD1_get_dv_vs_end_field1(data)                            ((0x00000FFF&(data))>>0)
+
+
+#define DH_VS_ADJ_FIELD1                                                             0x18009820
+#define DH_VS_ADJ_FIELD1_reg_addr                                                    "0xB8009820"
+#define DH_VS_ADJ_FIELD1_reg                                                         0xB8009820
+#define set_DH_VS_ADJ_FIELD1_reg(data)   (*((volatile unsigned int*) DH_VS_ADJ_FIELD1_reg)=data)
+#define get_DH_VS_ADJ_FIELD1_reg   (*((volatile unsigned int*) DH_VS_ADJ_FIELD1_reg))
+#define DH_VS_ADJ_FIELD1_inst_adr                                                    "0x0008"
+#define DH_VS_ADJ_FIELD1_inst                                                        0x0008
+#define DH_VS_ADJ_FIELD1_dh_vs_adj_field1_shift                                      (0)
+#define DH_VS_ADJ_FIELD1_dh_vs_adj_field1_mask                                       (0x00000FFF)
+#define DH_VS_ADJ_FIELD1_dh_vs_adj_field1(data)                                      (0x00000FFF&((data)<<0))
+#define DH_VS_ADJ_FIELD1_dh_vs_adj_field1_src(data)                                  ((0x00000FFF&(data))>>0)
+#define DH_VS_ADJ_FIELD1_get_dh_vs_adj_field1(data)                                  ((0x00000FFF&(data))>>0)
+
+
+#define DV_SYNC_INT                                                                  0x1800982c
+#define DV_SYNC_INT_reg_addr                                                         "0xB800982C"
+#define DV_SYNC_INT_reg                                                              0xB800982C
+#define set_DV_SYNC_INT_reg(data)   (*((volatile unsigned int*) DV_SYNC_INT_reg)=data)
+#define get_DV_SYNC_INT_reg   (*((volatile unsigned int*) DV_SYNC_INT_reg))
+#define DV_SYNC_INT_inst_adr                                                         "0x000B"
+#define DV_SYNC_INT_inst                                                             0x000B
+#define DV_SYNC_INT_int_en_shift                                                     (31)
+#define DV_SYNC_INT_int_en_mask                                                      (0x80000000)
+#define DV_SYNC_INT_int_en(data)                                                     (0x80000000&((data)<<31))
+#define DV_SYNC_INT_int_en_src(data)                                                 ((0x80000000&(data))>>31)
+#define DV_SYNC_INT_get_int_en(data)                                                 ((0x80000000&(data))>>31)
+#define DV_SYNC_INT_dv_sync_int_shift                                                (0)
+#define DV_SYNC_INT_dv_sync_int_mask                                                 (0x00000FFF)
+#define DV_SYNC_INT_dv_sync_int(data)                                                (0x00000FFF&((data)<<0))
+#define DV_SYNC_INT_dv_sync_int_src(data)                                            ((0x00000FFF&(data))>>0)
+#define DV_SYNC_INT_get_dv_sync_int(data)                                            ((0x00000FFF&(data))>>0)
+
+
+#define PIF_CTRL0                                                                    0x18009844
+#define PIF_CTRL0_reg_addr                                                           "0xB8009844"
+#define PIF_CTRL0_reg                                                                0xB8009844
+#define set_PIF_CTRL0_reg(data)   (*((volatile unsigned int*) PIF_CTRL0_reg)=data)
+#define get_PIF_CTRL0_reg   (*((volatile unsigned int*) PIF_CTRL0_reg))
+#define PIF_CTRL0_inst_adr                                                           "0x0011"
+#define PIF_CTRL0_inst                                                               0x0011
+#define PIF_CTRL0_neg_shift                                                          (0)
+#define PIF_CTRL0_neg_mask                                                           (0x00000001)
+#define PIF_CTRL0_neg(data)                                                          (0x00000001&((data)<<0))
+#define PIF_CTRL0_neg_src(data)                                                      ((0x00000001&(data))>>0)
+#define PIF_CTRL0_get_neg(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define LVDS_DBG                                                                     0x18009848
+#define LVDS_DBG_reg_addr                                                            "0xB8009848"
+#define LVDS_DBG_reg                                                                 0xB8009848
+#define set_LVDS_DBG_reg(data)   (*((volatile unsigned int*) LVDS_DBG_reg)=data)
+#define get_LVDS_DBG_reg   (*((volatile unsigned int*) LVDS_DBG_reg))
+#define LVDS_DBG_inst_adr                                                            "0x0012"
+#define LVDS_DBG_inst                                                                0x0012
+#define LVDS_DBG_lvds_dbg_sel1_shift                                                 (8)
+#define LVDS_DBG_lvds_dbg_sel1_mask                                                  (0x00007F00)
+#define LVDS_DBG_lvds_dbg_sel1(data)                                                 (0x00007F00&((data)<<8))
+#define LVDS_DBG_lvds_dbg_sel1_src(data)                                             ((0x00007F00&(data))>>8)
+#define LVDS_DBG_get_lvds_dbg_sel1(data)                                             ((0x00007F00&(data))>>8)
+#define LVDS_DBG_lvds_dbg_sel0_shift                                                 (1)
+#define LVDS_DBG_lvds_dbg_sel0_mask                                                  (0x000000FE)
+#define LVDS_DBG_lvds_dbg_sel0(data)                                                 (0x000000FE&((data)<<1))
+#define LVDS_DBG_lvds_dbg_sel0_src(data)                                             ((0x000000FE&(data))>>1)
+#define LVDS_DBG_get_lvds_dbg_sel0(data)                                             ((0x000000FE&(data))>>1)
+#define LVDS_DBG_lvds_dbg_enable_shift                                               (0)
+#define LVDS_DBG_lvds_dbg_enable_mask                                                (0x00000001)
+#define LVDS_DBG_lvds_dbg_enable(data)                                               (0x00000001&((data)<<0))
+#define LVDS_DBG_lvds_dbg_enable_src(data)                                           ((0x00000001&(data))>>0)
+#define LVDS_DBG_get_lvds_dbg_enable(data)                                           ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_sfdf_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_sfdf_reg.h
new file mode 100644
index 00000000..57d6c7f
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/lvds_sfdf_reg.h
@@ -0,0 +1,113 @@
+/**************************************************************
+// Spec Version                  : 1.0.6
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/4/11 19:55:7
+***************************************************************/
+
+
+#ifndef _SFDF_REG_H_INCLUDED_
+#define _SFDF_REG_H_INCLUDED_
+#ifdef  _SFDF_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     int_status:1;
+}INTTERRUPT_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     gamma_tab_index:10;
+unsigned int     reserved_1:3;
+unsigned int     gamma_tab_d0:5;
+unsigned int     reserved_2:3;
+unsigned int     gamma_tab_d1:5;
+}GAMMA_PORT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     d_stat_enable:1;
+}DSTAT_CTRL_R;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     crc_start:1;
+}CRC_CTRL_1;
+
+#endif
+
+#define INTTERRUPT_STATUS                                                            0x18009830
+#define INTTERRUPT_STATUS_reg_addr                                                   "0xB8009830"
+#define INTTERRUPT_STATUS_reg                                                        0xB8009830
+#define set_INTTERRUPT_STATUS_reg(data)   (*((volatile unsigned int*) INTTERRUPT_STATUS_reg)=data)
+#define get_INTTERRUPT_STATUS_reg   (*((volatile unsigned int*) INTTERRUPT_STATUS_reg))
+#define INTTERRUPT_STATUS_inst_adr                                                   "0x000C"
+#define INTTERRUPT_STATUS_inst                                                       0x000C
+#define INTTERRUPT_STATUS_int_status_shift                                           (0)
+#define INTTERRUPT_STATUS_int_status_mask                                            (0x00000001)
+#define INTTERRUPT_STATUS_int_status(data)                                           (0x00000001&((data)<<0))
+#define INTTERRUPT_STATUS_int_status_src(data)                                       ((0x00000001&(data))>>0)
+#define INTTERRUPT_STATUS_get_int_status(data)                                       ((0x00000001&(data))>>0)
+
+
+#define GAMMA_PORT                                                                   0x18009860
+#define GAMMA_PORT_reg_addr                                                          "0xB8009860"
+#define GAMMA_PORT_reg                                                               0xB8009860
+#define set_GAMMA_PORT_reg(data)   (*((volatile unsigned int*) GAMMA_PORT_reg)=data)
+#define get_GAMMA_PORT_reg   (*((volatile unsigned int*) GAMMA_PORT_reg))
+#define GAMMA_PORT_inst_adr                                                          "0x0018"
+#define GAMMA_PORT_inst                                                              0x0018
+#define GAMMA_PORT_gamma_tab_index_shift                                             (16)
+#define GAMMA_PORT_gamma_tab_index_mask                                              (0x03FF0000)
+#define GAMMA_PORT_gamma_tab_index(data)                                             (0x03FF0000&((data)<<16))
+#define GAMMA_PORT_gamma_tab_index_src(data)                                         ((0x03FF0000&(data))>>16)
+#define GAMMA_PORT_get_gamma_tab_index(data)                                         ((0x03FF0000&(data))>>16)
+#define GAMMA_PORT_gamma_tab_d0_shift                                                (8)
+#define GAMMA_PORT_gamma_tab_d0_mask                                                 (0x00001F00)
+#define GAMMA_PORT_gamma_tab_d0(data)                                                (0x00001F00&((data)<<8))
+#define GAMMA_PORT_gamma_tab_d0_src(data)                                            ((0x00001F00&(data))>>8)
+#define GAMMA_PORT_get_gamma_tab_d0(data)                                            ((0x00001F00&(data))>>8)
+#define GAMMA_PORT_gamma_tab_d1_shift                                                (0)
+#define GAMMA_PORT_gamma_tab_d1_mask                                                 (0x0000001F)
+#define GAMMA_PORT_gamma_tab_d1(data)                                                (0x0000001F&((data)<<0))
+#define GAMMA_PORT_gamma_tab_d1_src(data)                                            ((0x0000001F&(data))>>0)
+#define GAMMA_PORT_get_gamma_tab_d1(data)                                            ((0x0000001F&(data))>>0)
+
+
+#define DSTAT_CTRL_R                                                                 0x1800987c
+#define DSTAT_CTRL_R_reg_addr                                                        "0xB800987C"
+#define DSTAT_CTRL_R_reg                                                             0xB800987C
+#define set_DSTAT_CTRL_R_reg(data)   (*((volatile unsigned int*) DSTAT_CTRL_R_reg)=data)
+#define get_DSTAT_CTRL_R_reg   (*((volatile unsigned int*) DSTAT_CTRL_R_reg))
+#define DSTAT_CTRL_R_inst_adr                                                        "0x001F"
+#define DSTAT_CTRL_R_inst                                                            0x001F
+#define DSTAT_CTRL_R_d_stat_enable_shift                                             (0)
+#define DSTAT_CTRL_R_d_stat_enable_mask                                              (0x00000001)
+#define DSTAT_CTRL_R_d_stat_enable(data)                                             (0x00000001&((data)<<0))
+#define DSTAT_CTRL_R_d_stat_enable_src(data)                                         ((0x00000001&(data))>>0)
+#define DSTAT_CTRL_R_get_d_stat_enable(data)                                         ((0x00000001&(data))>>0)
+
+
+#define CRC_CTRL_1                                                                   0x180099e0
+#define CRC_CTRL_1_reg_addr                                                          "0xB80099E0"
+#define CRC_CTRL_1_reg                                                               0xB80099E0
+#define set_CRC_CTRL_1_reg(data)   (*((volatile unsigned int*) CRC_CTRL_1_reg)=data)
+#define get_CRC_CTRL_1_reg   (*((volatile unsigned int*) CRC_CTRL_1_reg))
+#define CRC_CTRL_1_inst_adr                                                          "0x0078"
+#define CRC_CTRL_1_inst                                                              0x0078
+#define CRC_CTRL_1_crc_start_shift                                                   (0)
+#define CRC_CTRL_1_crc_start_mask                                                    (0x00000001)
+#define CRC_CTRL_1_crc_start(data)                                                   (0x00000001&((data)<<0))
+#define CRC_CTRL_1_crc_start_src(data)                                               ((0x00000001&(data))>>0)
+#define CRC_CTRL_1_get_crc_start(data)                                               ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/m2m_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/m2m_reg.h
new file mode 100644
index 00000000..172c92c3
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/m2m_reg.h
@@ -0,0 +1,561 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.10(110913)
+// CModelGen Version             : 5.0 2009.04.09
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/1/6 22:22:6
+***************************************************************/
+
+
+#ifndef _M2M_REG_H_INCLUDED_
+#define _M2M_REG_H_INCLUDED_
+#ifdef  _M2M_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     entry:3;
+unsigned int     load:1;
+}M2M_LOAD_KEY;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     encode:1;
+unsigned int     entry:3;
+unsigned int     go:1;
+}M2M_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     length:20;
+}M2M_BC;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     error:1;
+unsigned int     done:1;
+}M2M_STATUS;
+
+typedef struct 
+{
+unsigned int     data:32;
+}M2M_IV;
+
+typedef struct 
+{
+unsigned int     data:32;
+}M2M_KEY;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     residue:2;
+unsigned int     reserved_1:2;
+unsigned int     bcm:2;
+unsigned int     reserved_2:1;
+unsigned int     mode:3;
+unsigned int     reserved_3:6;
+unsigned int     decrypt:1;
+unsigned int     encrypt:1;
+}M2M_KEY_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     adr:31;
+}M2M_M2M_SRC;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     adr:31;
+}M2M_M2M_DST;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     error:1;
+unsigned int     done:1;
+}M2M_STATUS_EN;
+
+#endif
+
+#define M2M_LOAD_KEY                                                                 0x18015E00
+#define M2M_LOAD_KEY_reg_addr                                                        "0xB8015E00"
+#define M2M_LOAD_KEY_reg                                                             0xB8015E00
+#define set_M2M_LOAD_KEY_reg(data)   (*((volatile unsigned int*) M2M_LOAD_KEY_reg)=data)
+#define get_M2M_LOAD_KEY_reg   (*((volatile unsigned int*) M2M_LOAD_KEY_reg))
+#define M2M_LOAD_KEY_inst_adr                                                        "0x0080"
+#define M2M_LOAD_KEY_inst                                                            0x0080
+#define M2M_LOAD_KEY_entry_shift                                                     (1)
+#define M2M_LOAD_KEY_entry_mask                                                      (0x0000000E)
+#define M2M_LOAD_KEY_entry(data)                                                     (0x0000000E&((data)<<1))
+#define M2M_LOAD_KEY_entry_src(data)                                                 ((0x0000000E&(data))>>1)
+#define M2M_LOAD_KEY_get_entry(data)                                                 ((0x0000000E&(data))>>1)
+#define M2M_LOAD_KEY_load_shift                                                      (0)
+#define M2M_LOAD_KEY_load_mask                                                       (0x00000001)
+#define M2M_LOAD_KEY_load(data)                                                      (0x00000001&((data)<<0))
+#define M2M_LOAD_KEY_load_src(data)                                                  ((0x00000001&(data))>>0)
+#define M2M_LOAD_KEY_get_load(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define M2M_CTRL                                                                     0x18015E04
+#define M2M_CTRL_reg_addr                                                            "0xB8015E04"
+#define M2M_CTRL_reg                                                                 0xB8015E04
+#define set_M2M_CTRL_reg(data)   (*((volatile unsigned int*) M2M_CTRL_reg)=data)
+#define get_M2M_CTRL_reg   (*((volatile unsigned int*) M2M_CTRL_reg))
+#define M2M_CTRL_inst_adr                                                            "0x0081"
+#define M2M_CTRL_inst                                                                0x0081
+#define M2M_CTRL_encode_shift                                                        (4)
+#define M2M_CTRL_encode_mask                                                         (0x00000010)
+#define M2M_CTRL_encode(data)                                                        (0x00000010&((data)<<4))
+#define M2M_CTRL_encode_src(data)                                                    ((0x00000010&(data))>>4)
+#define M2M_CTRL_get_encode(data)                                                    ((0x00000010&(data))>>4)
+#define M2M_CTRL_entry_shift                                                         (1)
+#define M2M_CTRL_entry_mask                                                          (0x0000000E)
+#define M2M_CTRL_entry(data)                                                         (0x0000000E&((data)<<1))
+#define M2M_CTRL_entry_src(data)                                                     ((0x0000000E&(data))>>1)
+#define M2M_CTRL_get_entry(data)                                                     ((0x0000000E&(data))>>1)
+#define M2M_CTRL_go_shift                                                            (0)
+#define M2M_CTRL_go_mask                                                             (0x00000001)
+#define M2M_CTRL_go(data)                                                            (0x00000001&((data)<<0))
+#define M2M_CTRL_go_src(data)                                                        ((0x00000001&(data))>>0)
+#define M2M_CTRL_get_go(data)                                                        ((0x00000001&(data))>>0)
+
+
+#define M2M_BC                                                                       0x18015E08
+#define M2M_BC_reg_addr                                                              "0xB8015E08"
+#define M2M_BC_reg                                                                   0xB8015E08
+#define set_M2M_BC_reg(data)   (*((volatile unsigned int*) M2M_BC_reg)=data)
+#define get_M2M_BC_reg   (*((volatile unsigned int*) M2M_BC_reg))
+#define M2M_BC_inst_adr                                                              "0x0082"
+#define M2M_BC_inst                                                                  0x0082
+#define M2M_BC_length_shift                                                          (0)
+#define M2M_BC_length_mask                                                           (0x000FFFFF)
+#define M2M_BC_length(data)                                                          (0x000FFFFF&((data)<<0))
+#define M2M_BC_length_src(data)                                                      ((0x000FFFFF&(data))>>0)
+#define M2M_BC_get_length(data)                                                      ((0x000FFFFF&(data))>>0)
+
+
+#define M2M_STATUS                                                                   0x18015E0C
+#define M2M_STATUS_reg_addr                                                          "0xB8015E0C"
+#define M2M_STATUS_reg                                                               0xB8015E0C
+#define set_M2M_STATUS_reg(data)   (*((volatile unsigned int*) M2M_STATUS_reg)=data)
+#define get_M2M_STATUS_reg   (*((volatile unsigned int*) M2M_STATUS_reg))
+#define M2M_STATUS_inst_adr                                                          "0x0083"
+#define M2M_STATUS_inst                                                              0x0083
+#define M2M_STATUS_error_shift                                                       (1)
+#define M2M_STATUS_error_mask                                                        (0x00000002)
+#define M2M_STATUS_error(data)                                                       (0x00000002&((data)<<1))
+#define M2M_STATUS_error_src(data)                                                   ((0x00000002&(data))>>1)
+#define M2M_STATUS_get_error(data)                                                   ((0x00000002&(data))>>1)
+#define M2M_STATUS_done_shift                                                        (0)
+#define M2M_STATUS_done_mask                                                         (0x00000001)
+#define M2M_STATUS_done(data)                                                        (0x00000001&((data)<<0))
+#define M2M_STATUS_done_src(data)                                                    ((0x00000001&(data))>>0)
+#define M2M_STATUS_get_done(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define M2M_IV_0                                                                     0x18015E10
+#define M2M_IV_1                                                                     0x18015E14
+#define M2M_IV_2                                                                     0x18015E18
+#define M2M_IV_3                                                                     0x18015E1C
+#define M2M_IV_0_reg_addr                                                            "0xB8015E10"
+#define M2M_IV_1_reg_addr                                                            "0xB8015E14"
+#define M2M_IV_2_reg_addr                                                            "0xB8015E18"
+#define M2M_IV_3_reg_addr                                                            "0xB8015E1C"
+#define M2M_IV_0_reg                                                                 0xB8015E10
+#define M2M_IV_1_reg                                                                 0xB8015E14
+#define M2M_IV_2_reg                                                                 0xB8015E18
+#define M2M_IV_3_reg                                                                 0xB8015E1C
+#define set_M2M_IV_0_reg(data)   (*((volatile unsigned int*) M2M_IV_0_reg)=data)
+#define set_M2M_IV_1_reg(data)   (*((volatile unsigned int*) M2M_IV_1_reg)=data)
+#define set_M2M_IV_2_reg(data)   (*((volatile unsigned int*) M2M_IV_2_reg)=data)
+#define set_M2M_IV_3_reg(data)   (*((volatile unsigned int*) M2M_IV_3_reg)=data)
+#define get_M2M_IV_0_reg   (*((volatile unsigned int*) M2M_IV_0_reg))
+#define get_M2M_IV_1_reg   (*((volatile unsigned int*) M2M_IV_1_reg))
+#define get_M2M_IV_2_reg   (*((volatile unsigned int*) M2M_IV_2_reg))
+#define get_M2M_IV_3_reg   (*((volatile unsigned int*) M2M_IV_3_reg))
+#define M2M_IV_0_inst_adr                                                            "0x0084"
+#define M2M_IV_1_inst_adr                                                            "0x0085"
+#define M2M_IV_2_inst_adr                                                            "0x0086"
+#define M2M_IV_3_inst_adr                                                            "0x0087"
+#define M2M_IV_0_inst                                                                0x0084
+#define M2M_IV_1_inst                                                                0x0085
+#define M2M_IV_2_inst                                                                0x0086
+#define M2M_IV_3_inst                                                                0x0087
+#define M2M_IV_data_shift                                                            (0)
+#define M2M_IV_data_mask                                                             (0xFFFFFFFF)
+#define M2M_IV_data(data)                                                            (0xFFFFFFFF&((data)<<0))
+#define M2M_IV_data_src(data)                                                        ((0xFFFFFFFF&(data))>>0)
+#define M2M_IV_get_data(data)                                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define M2M_KEY_0                                                                    0x18015E20
+#define M2M_KEY_1                                                                    0x18015E24
+#define M2M_KEY_2                                                                    0x18015E28
+#define M2M_KEY_3                                                                    0x18015E2C
+#define M2M_KEY_4                                                                    0x18015E30
+#define M2M_KEY_5                                                                    0x18015E34
+#define M2M_KEY_6                                                                    0x18015E38
+#define M2M_KEY_7                                                                    0x18015E3C
+#define M2M_KEY_8                                                                    0x18015E40
+#define M2M_KEY_9                                                                    0x18015E44
+#define M2M_KEY_10                                                                    0x18015E48
+#define M2M_KEY_11                                                                    0x18015E4C
+#define M2M_KEY_12                                                                    0x18015E50
+#define M2M_KEY_13                                                                    0x18015E54
+#define M2M_KEY_14                                                                    0x18015E58
+#define M2M_KEY_15                                                                    0x18015E5C
+#define M2M_KEY_16                                                                    0x18015E60
+#define M2M_KEY_17                                                                    0x18015E64
+#define M2M_KEY_18                                                                    0x18015E68
+#define M2M_KEY_19                                                                    0x18015E6C
+#define M2M_KEY_20                                                                    0x18015E70
+#define M2M_KEY_21                                                                    0x18015E74
+#define M2M_KEY_22                                                                    0x18015E78
+#define M2M_KEY_23                                                                    0x18015E7C
+#define M2M_KEY_24                                                                    0x18015E80
+#define M2M_KEY_25                                                                    0x18015E84
+#define M2M_KEY_26                                                                    0x18015E88
+#define M2M_KEY_27                                                                    0x18015E8C
+#define M2M_KEY_28                                                                    0x18015E90
+#define M2M_KEY_29                                                                    0x18015E94
+#define M2M_KEY_30                                                                    0x18015E98
+#define M2M_KEY_31                                                                    0x18015E9C
+#define M2M_KEY_0_reg_addr                                                           "0xB8015E20"
+#define M2M_KEY_1_reg_addr                                                           "0xB8015E24"
+#define M2M_KEY_2_reg_addr                                                           "0xB8015E28"
+#define M2M_KEY_3_reg_addr                                                           "0xB8015E2C"
+#define M2M_KEY_4_reg_addr                                                           "0xB8015E30"
+#define M2M_KEY_5_reg_addr                                                           "0xB8015E34"
+#define M2M_KEY_6_reg_addr                                                           "0xB8015E38"
+#define M2M_KEY_7_reg_addr                                                           "0xB8015E3C"
+#define M2M_KEY_8_reg_addr                                                           "0xB8015E40"
+#define M2M_KEY_9_reg_addr                                                           "0xB8015E44"
+#define M2M_KEY_10_reg_addr                                                           "0xB8015E48"
+#define M2M_KEY_11_reg_addr                                                           "0xB8015E4C"
+#define M2M_KEY_12_reg_addr                                                           "0xB8015E50"
+#define M2M_KEY_13_reg_addr                                                           "0xB8015E54"
+#define M2M_KEY_14_reg_addr                                                           "0xB8015E58"
+#define M2M_KEY_15_reg_addr                                                           "0xB8015E5C"
+#define M2M_KEY_16_reg_addr                                                           "0xB8015E60"
+#define M2M_KEY_17_reg_addr                                                           "0xB8015E64"
+#define M2M_KEY_18_reg_addr                                                           "0xB8015E68"
+#define M2M_KEY_19_reg_addr                                                           "0xB8015E6C"
+#define M2M_KEY_20_reg_addr                                                           "0xB8015E70"
+#define M2M_KEY_21_reg_addr                                                           "0xB8015E74"
+#define M2M_KEY_22_reg_addr                                                           "0xB8015E78"
+#define M2M_KEY_23_reg_addr                                                           "0xB8015E7C"
+#define M2M_KEY_24_reg_addr                                                           "0xB8015E80"
+#define M2M_KEY_25_reg_addr                                                           "0xB8015E84"
+#define M2M_KEY_26_reg_addr                                                           "0xB8015E88"
+#define M2M_KEY_27_reg_addr                                                           "0xB8015E8C"
+#define M2M_KEY_28_reg_addr                                                           "0xB8015E90"
+#define M2M_KEY_29_reg_addr                                                           "0xB8015E94"
+#define M2M_KEY_30_reg_addr                                                           "0xB8015E98"
+#define M2M_KEY_31_reg_addr                                                           "0xB8015E9C"
+#define M2M_KEY_0_reg                                                                0xB8015E20
+#define M2M_KEY_1_reg                                                                0xB8015E24
+#define M2M_KEY_2_reg                                                                0xB8015E28
+#define M2M_KEY_3_reg                                                                0xB8015E2C
+#define M2M_KEY_4_reg                                                                0xB8015E30
+#define M2M_KEY_5_reg                                                                0xB8015E34
+#define M2M_KEY_6_reg                                                                0xB8015E38
+#define M2M_KEY_7_reg                                                                0xB8015E3C
+#define M2M_KEY_8_reg                                                                0xB8015E40
+#define M2M_KEY_9_reg                                                                0xB8015E44
+#define M2M_KEY_10_reg                                                                0xB8015E48
+#define M2M_KEY_11_reg                                                                0xB8015E4C
+#define M2M_KEY_12_reg                                                                0xB8015E50
+#define M2M_KEY_13_reg                                                                0xB8015E54
+#define M2M_KEY_14_reg                                                                0xB8015E58
+#define M2M_KEY_15_reg                                                                0xB8015E5C
+#define M2M_KEY_16_reg                                                                0xB8015E60
+#define M2M_KEY_17_reg                                                                0xB8015E64
+#define M2M_KEY_18_reg                                                                0xB8015E68
+#define M2M_KEY_19_reg                                                                0xB8015E6C
+#define M2M_KEY_20_reg                                                                0xB8015E70
+#define M2M_KEY_21_reg                                                                0xB8015E74
+#define M2M_KEY_22_reg                                                                0xB8015E78
+#define M2M_KEY_23_reg                                                                0xB8015E7C
+#define M2M_KEY_24_reg                                                                0xB8015E80
+#define M2M_KEY_25_reg                                                                0xB8015E84
+#define M2M_KEY_26_reg                                                                0xB8015E88
+#define M2M_KEY_27_reg                                                                0xB8015E8C
+#define M2M_KEY_28_reg                                                                0xB8015E90
+#define M2M_KEY_29_reg                                                                0xB8015E94
+#define M2M_KEY_30_reg                                                                0xB8015E98
+#define M2M_KEY_31_reg                                                                0xB8015E9C
+#define set_M2M_KEY_0_reg(data)   (*((volatile unsigned int*) M2M_KEY_0_reg)=data)
+#define set_M2M_KEY_1_reg(data)   (*((volatile unsigned int*) M2M_KEY_1_reg)=data)
+#define set_M2M_KEY_2_reg(data)   (*((volatile unsigned int*) M2M_KEY_2_reg)=data)
+#define set_M2M_KEY_3_reg(data)   (*((volatile unsigned int*) M2M_KEY_3_reg)=data)
+#define set_M2M_KEY_4_reg(data)   (*((volatile unsigned int*) M2M_KEY_4_reg)=data)
+#define set_M2M_KEY_5_reg(data)   (*((volatile unsigned int*) M2M_KEY_5_reg)=data)
+#define set_M2M_KEY_6_reg(data)   (*((volatile unsigned int*) M2M_KEY_6_reg)=data)
+#define set_M2M_KEY_7_reg(data)   (*((volatile unsigned int*) M2M_KEY_7_reg)=data)
+#define set_M2M_KEY_8_reg(data)   (*((volatile unsigned int*) M2M_KEY_8_reg)=data)
+#define set_M2M_KEY_9_reg(data)   (*((volatile unsigned int*) M2M_KEY_9_reg)=data)
+#define set_M2M_KEY_10_reg(data)   (*((volatile unsigned int*) M2M_KEY_10_reg)=data)
+#define set_M2M_KEY_11_reg(data)   (*((volatile unsigned int*) M2M_KEY_11_reg)=data)
+#define set_M2M_KEY_12_reg(data)   (*((volatile unsigned int*) M2M_KEY_12_reg)=data)
+#define set_M2M_KEY_13_reg(data)   (*((volatile unsigned int*) M2M_KEY_13_reg)=data)
+#define set_M2M_KEY_14_reg(data)   (*((volatile unsigned int*) M2M_KEY_14_reg)=data)
+#define set_M2M_KEY_15_reg(data)   (*((volatile unsigned int*) M2M_KEY_15_reg)=data)
+#define set_M2M_KEY_16_reg(data)   (*((volatile unsigned int*) M2M_KEY_16_reg)=data)
+#define set_M2M_KEY_17_reg(data)   (*((volatile unsigned int*) M2M_KEY_17_reg)=data)
+#define set_M2M_KEY_18_reg(data)   (*((volatile unsigned int*) M2M_KEY_18_reg)=data)
+#define set_M2M_KEY_19_reg(data)   (*((volatile unsigned int*) M2M_KEY_19_reg)=data)
+#define set_M2M_KEY_20_reg(data)   (*((volatile unsigned int*) M2M_KEY_20_reg)=data)
+#define set_M2M_KEY_21_reg(data)   (*((volatile unsigned int*) M2M_KEY_21_reg)=data)
+#define set_M2M_KEY_22_reg(data)   (*((volatile unsigned int*) M2M_KEY_22_reg)=data)
+#define set_M2M_KEY_23_reg(data)   (*((volatile unsigned int*) M2M_KEY_23_reg)=data)
+#define set_M2M_KEY_24_reg(data)   (*((volatile unsigned int*) M2M_KEY_24_reg)=data)
+#define set_M2M_KEY_25_reg(data)   (*((volatile unsigned int*) M2M_KEY_25_reg)=data)
+#define set_M2M_KEY_26_reg(data)   (*((volatile unsigned int*) M2M_KEY_26_reg)=data)
+#define set_M2M_KEY_27_reg(data)   (*((volatile unsigned int*) M2M_KEY_27_reg)=data)
+#define set_M2M_KEY_28_reg(data)   (*((volatile unsigned int*) M2M_KEY_28_reg)=data)
+#define set_M2M_KEY_29_reg(data)   (*((volatile unsigned int*) M2M_KEY_29_reg)=data)
+#define set_M2M_KEY_30_reg(data)   (*((volatile unsigned int*) M2M_KEY_30_reg)=data)
+#define set_M2M_KEY_31_reg(data)   (*((volatile unsigned int*) M2M_KEY_31_reg)=data)
+#define get_M2M_KEY_0_reg   (*((volatile unsigned int*) M2M_KEY_0_reg))
+#define get_M2M_KEY_1_reg   (*((volatile unsigned int*) M2M_KEY_1_reg))
+#define get_M2M_KEY_2_reg   (*((volatile unsigned int*) M2M_KEY_2_reg))
+#define get_M2M_KEY_3_reg   (*((volatile unsigned int*) M2M_KEY_3_reg))
+#define get_M2M_KEY_4_reg   (*((volatile unsigned int*) M2M_KEY_4_reg))
+#define get_M2M_KEY_5_reg   (*((volatile unsigned int*) M2M_KEY_5_reg))
+#define get_M2M_KEY_6_reg   (*((volatile unsigned int*) M2M_KEY_6_reg))
+#define get_M2M_KEY_7_reg   (*((volatile unsigned int*) M2M_KEY_7_reg))
+#define get_M2M_KEY_8_reg   (*((volatile unsigned int*) M2M_KEY_8_reg))
+#define get_M2M_KEY_9_reg   (*((volatile unsigned int*) M2M_KEY_9_reg))
+#define get_M2M_KEY_10_reg   (*((volatile unsigned int*) M2M_KEY_10_reg))
+#define get_M2M_KEY_11_reg   (*((volatile unsigned int*) M2M_KEY_11_reg))
+#define get_M2M_KEY_12_reg   (*((volatile unsigned int*) M2M_KEY_12_reg))
+#define get_M2M_KEY_13_reg   (*((volatile unsigned int*) M2M_KEY_13_reg))
+#define get_M2M_KEY_14_reg   (*((volatile unsigned int*) M2M_KEY_14_reg))
+#define get_M2M_KEY_15_reg   (*((volatile unsigned int*) M2M_KEY_15_reg))
+#define get_M2M_KEY_16_reg   (*((volatile unsigned int*) M2M_KEY_16_reg))
+#define get_M2M_KEY_17_reg   (*((volatile unsigned int*) M2M_KEY_17_reg))
+#define get_M2M_KEY_18_reg   (*((volatile unsigned int*) M2M_KEY_18_reg))
+#define get_M2M_KEY_19_reg   (*((volatile unsigned int*) M2M_KEY_19_reg))
+#define get_M2M_KEY_20_reg   (*((volatile unsigned int*) M2M_KEY_20_reg))
+#define get_M2M_KEY_21_reg   (*((volatile unsigned int*) M2M_KEY_21_reg))
+#define get_M2M_KEY_22_reg   (*((volatile unsigned int*) M2M_KEY_22_reg))
+#define get_M2M_KEY_23_reg   (*((volatile unsigned int*) M2M_KEY_23_reg))
+#define get_M2M_KEY_24_reg   (*((volatile unsigned int*) M2M_KEY_24_reg))
+#define get_M2M_KEY_25_reg   (*((volatile unsigned int*) M2M_KEY_25_reg))
+#define get_M2M_KEY_26_reg   (*((volatile unsigned int*) M2M_KEY_26_reg))
+#define get_M2M_KEY_27_reg   (*((volatile unsigned int*) M2M_KEY_27_reg))
+#define get_M2M_KEY_28_reg   (*((volatile unsigned int*) M2M_KEY_28_reg))
+#define get_M2M_KEY_29_reg   (*((volatile unsigned int*) M2M_KEY_29_reg))
+#define get_M2M_KEY_30_reg   (*((volatile unsigned int*) M2M_KEY_30_reg))
+#define get_M2M_KEY_31_reg   (*((volatile unsigned int*) M2M_KEY_31_reg))
+#define M2M_KEY_0_inst_adr                                                           "0x0088"
+#define M2M_KEY_1_inst_adr                                                           "0x0089"
+#define M2M_KEY_2_inst_adr                                                           "0x008A"
+#define M2M_KEY_3_inst_adr                                                           "0x008B"
+#define M2M_KEY_4_inst_adr                                                           "0x008C"
+#define M2M_KEY_5_inst_adr                                                           "0x008D"
+#define M2M_KEY_6_inst_adr                                                           "0x008E"
+#define M2M_KEY_7_inst_adr                                                           "0x008F"
+#define M2M_KEY_8_inst_adr                                                           "0x0090"
+#define M2M_KEY_9_inst_adr                                                           "0x0091"
+#define M2M_KEY_10_inst_adr                                                           "0x0092"
+#define M2M_KEY_11_inst_adr                                                           "0x0093"
+#define M2M_KEY_12_inst_adr                                                           "0x0094"
+#define M2M_KEY_13_inst_adr                                                           "0x0095"
+#define M2M_KEY_14_inst_adr                                                           "0x0096"
+#define M2M_KEY_15_inst_adr                                                           "0x0097"
+#define M2M_KEY_16_inst_adr                                                           "0x0098"
+#define M2M_KEY_17_inst_adr                                                           "0x0099"
+#define M2M_KEY_18_inst_adr                                                           "0x009A"
+#define M2M_KEY_19_inst_adr                                                           "0x009B"
+#define M2M_KEY_20_inst_adr                                                           "0x009C"
+#define M2M_KEY_21_inst_adr                                                           "0x009D"
+#define M2M_KEY_22_inst_adr                                                           "0x009E"
+#define M2M_KEY_23_inst_adr                                                           "0x009F"
+#define M2M_KEY_24_inst_adr                                                           "0x00A0"
+#define M2M_KEY_25_inst_adr                                                           "0x00A1"
+#define M2M_KEY_26_inst_adr                                                           "0x00A2"
+#define M2M_KEY_27_inst_adr                                                           "0x00A3"
+#define M2M_KEY_28_inst_adr                                                           "0x00A4"
+#define M2M_KEY_29_inst_adr                                                           "0x00A5"
+#define M2M_KEY_30_inst_adr                                                           "0x00A6"
+#define M2M_KEY_31_inst_adr                                                           "0x00A7"
+#define M2M_KEY_0_inst                                                               0x0088
+#define M2M_KEY_1_inst                                                               0x0089
+#define M2M_KEY_2_inst                                                               0x008A
+#define M2M_KEY_3_inst                                                               0x008B
+#define M2M_KEY_4_inst                                                               0x008C
+#define M2M_KEY_5_inst                                                               0x008D
+#define M2M_KEY_6_inst                                                               0x008E
+#define M2M_KEY_7_inst                                                               0x008F
+#define M2M_KEY_8_inst                                                               0x0090
+#define M2M_KEY_9_inst                                                               0x0091
+#define M2M_KEY_10_inst                                                               0x0092
+#define M2M_KEY_11_inst                                                               0x0093
+#define M2M_KEY_12_inst                                                               0x0094
+#define M2M_KEY_13_inst                                                               0x0095
+#define M2M_KEY_14_inst                                                               0x0096
+#define M2M_KEY_15_inst                                                               0x0097
+#define M2M_KEY_16_inst                                                               0x0098
+#define M2M_KEY_17_inst                                                               0x0099
+#define M2M_KEY_18_inst                                                               0x009A
+#define M2M_KEY_19_inst                                                               0x009B
+#define M2M_KEY_20_inst                                                               0x009C
+#define M2M_KEY_21_inst                                                               0x009D
+#define M2M_KEY_22_inst                                                               0x009E
+#define M2M_KEY_23_inst                                                               0x009F
+#define M2M_KEY_24_inst                                                               0x00A0
+#define M2M_KEY_25_inst                                                               0x00A1
+#define M2M_KEY_26_inst                                                               0x00A2
+#define M2M_KEY_27_inst                                                               0x00A3
+#define M2M_KEY_28_inst                                                               0x00A4
+#define M2M_KEY_29_inst                                                               0x00A5
+#define M2M_KEY_30_inst                                                               0x00A6
+#define M2M_KEY_31_inst                                                               0x00A7
+#define M2M_KEY_data_shift                                                           (0)
+#define M2M_KEY_data_mask                                                            (0xFFFFFFFF)
+#define M2M_KEY_data(data)                                                           (0xFFFFFFFF&((data)<<0))
+#define M2M_KEY_data_src(data)                                                       ((0xFFFFFFFF&(data))>>0)
+#define M2M_KEY_get_data(data)                                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define M2M_KEY_CTRL_0                                                               0x18015EA0
+#define M2M_KEY_CTRL_1                                                               0x18015EA4
+#define M2M_KEY_CTRL_2                                                               0x18015EA8
+#define M2M_KEY_CTRL_3                                                               0x18015EAC
+#define M2M_KEY_CTRL_4                                                               0x18015EB0
+#define M2M_KEY_CTRL_5                                                               0x18015EB4
+#define M2M_KEY_CTRL_6                                                               0x18015EB8
+#define M2M_KEY_CTRL_7                                                               0x18015EBC
+#define M2M_KEY_CTRL_0_reg_addr                                                      "0xB8015EA0"
+#define M2M_KEY_CTRL_1_reg_addr                                                      "0xB8015EA4"
+#define M2M_KEY_CTRL_2_reg_addr                                                      "0xB8015EA8"
+#define M2M_KEY_CTRL_3_reg_addr                                                      "0xB8015EAC"
+#define M2M_KEY_CTRL_4_reg_addr                                                      "0xB8015EB0"
+#define M2M_KEY_CTRL_5_reg_addr                                                      "0xB8015EB4"
+#define M2M_KEY_CTRL_6_reg_addr                                                      "0xB8015EB8"
+#define M2M_KEY_CTRL_7_reg_addr                                                      "0xB8015EBC"
+#define M2M_KEY_CTRL_0_reg                                                           0xB8015EA0
+#define M2M_KEY_CTRL_1_reg                                                           0xB8015EA4
+#define M2M_KEY_CTRL_2_reg                                                           0xB8015EA8
+#define M2M_KEY_CTRL_3_reg                                                           0xB8015EAC
+#define M2M_KEY_CTRL_4_reg                                                           0xB8015EB0
+#define M2M_KEY_CTRL_5_reg                                                           0xB8015EB4
+#define M2M_KEY_CTRL_6_reg                                                           0xB8015EB8
+#define M2M_KEY_CTRL_7_reg                                                           0xB8015EBC
+#define set_M2M_KEY_CTRL_0_reg(data)   (*((volatile unsigned int*) M2M_KEY_CTRL_0_reg)=data)
+#define set_M2M_KEY_CTRL_1_reg(data)   (*((volatile unsigned int*) M2M_KEY_CTRL_1_reg)=data)
+#define set_M2M_KEY_CTRL_2_reg(data)   (*((volatile unsigned int*) M2M_KEY_CTRL_2_reg)=data)
+#define set_M2M_KEY_CTRL_3_reg(data)   (*((volatile unsigned int*) M2M_KEY_CTRL_3_reg)=data)
+#define set_M2M_KEY_CTRL_4_reg(data)   (*((volatile unsigned int*) M2M_KEY_CTRL_4_reg)=data)
+#define set_M2M_KEY_CTRL_5_reg(data)   (*((volatile unsigned int*) M2M_KEY_CTRL_5_reg)=data)
+#define set_M2M_KEY_CTRL_6_reg(data)   (*((volatile unsigned int*) M2M_KEY_CTRL_6_reg)=data)
+#define set_M2M_KEY_CTRL_7_reg(data)   (*((volatile unsigned int*) M2M_KEY_CTRL_7_reg)=data)
+#define get_M2M_KEY_CTRL_0_reg   (*((volatile unsigned int*) M2M_KEY_CTRL_0_reg))
+#define get_M2M_KEY_CTRL_1_reg   (*((volatile unsigned int*) M2M_KEY_CTRL_1_reg))
+#define get_M2M_KEY_CTRL_2_reg   (*((volatile unsigned int*) M2M_KEY_CTRL_2_reg))
+#define get_M2M_KEY_CTRL_3_reg   (*((volatile unsigned int*) M2M_KEY_CTRL_3_reg))
+#define get_M2M_KEY_CTRL_4_reg   (*((volatile unsigned int*) M2M_KEY_CTRL_4_reg))
+#define get_M2M_KEY_CTRL_5_reg   (*((volatile unsigned int*) M2M_KEY_CTRL_5_reg))
+#define get_M2M_KEY_CTRL_6_reg   (*((volatile unsigned int*) M2M_KEY_CTRL_6_reg))
+#define get_M2M_KEY_CTRL_7_reg   (*((volatile unsigned int*) M2M_KEY_CTRL_7_reg))
+#define M2M_KEY_CTRL_0_inst_adr                                                      "0x00A8"
+#define M2M_KEY_CTRL_1_inst_adr                                                      "0x00A9"
+#define M2M_KEY_CTRL_2_inst_adr                                                      "0x00AA"
+#define M2M_KEY_CTRL_3_inst_adr                                                      "0x00AB"
+#define M2M_KEY_CTRL_4_inst_adr                                                      "0x00AC"
+#define M2M_KEY_CTRL_5_inst_adr                                                      "0x00AD"
+#define M2M_KEY_CTRL_6_inst_adr                                                      "0x00AE"
+#define M2M_KEY_CTRL_7_inst_adr                                                      "0x00AF"
+#define M2M_KEY_CTRL_0_inst                                                          0x00A8
+#define M2M_KEY_CTRL_1_inst                                                          0x00A9
+#define M2M_KEY_CTRL_2_inst                                                          0x00AA
+#define M2M_KEY_CTRL_3_inst                                                          0x00AB
+#define M2M_KEY_CTRL_4_inst                                                          0x00AC
+#define M2M_KEY_CTRL_5_inst                                                          0x00AD
+#define M2M_KEY_CTRL_6_inst                                                          0x00AE
+#define M2M_KEY_CTRL_7_inst                                                          0x00AF
+#define M2M_KEY_CTRL_residue_shift                                                   (16)
+#define M2M_KEY_CTRL_residue_mask                                                    (0x00030000)
+#define M2M_KEY_CTRL_residue(data)                                                   (0x00030000&((data)<<16))
+#define M2M_KEY_CTRL_residue_src(data)                                               ((0x00030000&(data))>>16)
+#define M2M_KEY_CTRL_get_residue(data)                                               ((0x00030000&(data))>>16)
+#define M2M_KEY_CTRL_bcm_shift                                                       (12)
+#define M2M_KEY_CTRL_bcm_mask                                                        (0x00003000)
+#define M2M_KEY_CTRL_bcm(data)                                                       (0x00003000&((data)<<12))
+#define M2M_KEY_CTRL_bcm_src(data)                                                   ((0x00003000&(data))>>12)
+#define M2M_KEY_CTRL_get_bcm(data)                                                   ((0x00003000&(data))>>12)
+#define M2M_KEY_CTRL_mode_shift                                                      (8)
+#define M2M_KEY_CTRL_mode_mask                                                       (0x00000700)
+#define M2M_KEY_CTRL_mode(data)                                                      (0x00000700&((data)<<8))
+#define M2M_KEY_CTRL_mode_src(data)                                                  ((0x00000700&(data))>>8)
+#define M2M_KEY_CTRL_get_mode(data)                                                  ((0x00000700&(data))>>8)
+#define M2M_KEY_CTRL_decrypt_shift                                                   (1)
+#define M2M_KEY_CTRL_decrypt_mask                                                    (0x00000002)
+#define M2M_KEY_CTRL_decrypt(data)                                                   (0x00000002&((data)<<1))
+#define M2M_KEY_CTRL_decrypt_src(data)                                               ((0x00000002&(data))>>1)
+#define M2M_KEY_CTRL_get_decrypt(data)                                               ((0x00000002&(data))>>1)
+#define M2M_KEY_CTRL_encrypt_shift                                                   (0)
+#define M2M_KEY_CTRL_encrypt_mask                                                    (0x00000001)
+#define M2M_KEY_CTRL_encrypt(data)                                                   (0x00000001&((data)<<0))
+#define M2M_KEY_CTRL_encrypt_src(data)                                               ((0x00000001&(data))>>0)
+#define M2M_KEY_CTRL_get_encrypt(data)                                               ((0x00000001&(data))>>0)
+
+
+#define M2M_M2M_SRC                                                                  0x18015EC0
+#define M2M_M2M_SRC_reg_addr                                                         "0xB8015EC0"
+#define M2M_M2M_SRC_reg                                                              0xB8015EC0
+#define set_M2M_M2M_SRC_reg(data)   (*((volatile unsigned int*) M2M_M2M_SRC_reg)=data)
+#define get_M2M_M2M_SRC_reg   (*((volatile unsigned int*) M2M_M2M_SRC_reg))
+#define M2M_M2M_SRC_inst_adr                                                         "0x00B0"
+#define M2M_M2M_SRC_inst                                                             0x00B0
+#define M2M_M2M_SRC_adr_shift                                                        (0)
+#define M2M_M2M_SRC_adr_mask                                                         (0x7FFFFFFF)
+#define M2M_M2M_SRC_adr(data)                                                        (0x7FFFFFFF&((data)<<0))
+#define M2M_M2M_SRC_adr_src(data)                                                    ((0x7FFFFFFF&(data))>>0)
+#define M2M_M2M_SRC_get_adr(data)                                                    ((0x7FFFFFFF&(data))>>0)
+
+
+#define M2M_M2M_DST                                                                  0x18015EC4
+#define M2M_M2M_DST_reg_addr                                                         "0xB8015EC4"
+#define M2M_M2M_DST_reg                                                              0xB8015EC4
+#define set_M2M_M2M_DST_reg(data)   (*((volatile unsigned int*) M2M_M2M_DST_reg)=data)
+#define get_M2M_M2M_DST_reg   (*((volatile unsigned int*) M2M_M2M_DST_reg))
+#define M2M_M2M_DST_inst_adr                                                         "0x00B1"
+#define M2M_M2M_DST_inst                                                             0x00B1
+#define M2M_M2M_DST_adr_shift                                                        (0)
+#define M2M_M2M_DST_adr_mask                                                         (0x7FFFFFFF)
+#define M2M_M2M_DST_adr(data)                                                        (0x7FFFFFFF&((data)<<0))
+#define M2M_M2M_DST_adr_src(data)                                                    ((0x7FFFFFFF&(data))>>0)
+#define M2M_M2M_DST_get_adr(data)                                                    ((0x7FFFFFFF&(data))>>0)
+
+
+#define M2M_STATUS_EN                                                                0x18015EC8
+#define M2M_STATUS_EN_reg_addr                                                       "0xB8015EC8"
+#define M2M_STATUS_EN_reg                                                            0xB8015EC8
+#define set_M2M_STATUS_EN_reg(data)   (*((volatile unsigned int*) M2M_STATUS_EN_reg)=data)
+#define get_M2M_STATUS_EN_reg   (*((volatile unsigned int*) M2M_STATUS_EN_reg))
+#define M2M_STATUS_EN_inst_adr                                                       "0x00B2"
+#define M2M_STATUS_EN_inst                                                           0x00B2
+#define M2M_STATUS_EN_error_shift                                                    (1)
+#define M2M_STATUS_EN_error_mask                                                     (0x00000002)
+#define M2M_STATUS_EN_error(data)                                                    (0x00000002&((data)<<1))
+#define M2M_STATUS_EN_error_src(data)                                                ((0x00000002&(data))>>1)
+#define M2M_STATUS_EN_get_error(data)                                                ((0x00000002&(data))>>1)
+#define M2M_STATUS_EN_done_shift                                                     (0)
+#define M2M_STATUS_EN_done_mask                                                      (0x00000001)
+#define M2M_STATUS_EN_done(data)                                                     (0x00000001&((data)<<0))
+#define M2M_STATUS_EN_done_src(data)                                                 ((0x00000001&(data))>>0)
+#define M2M_STATUS_EN_get_done(data)                                                 ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/m32c0.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/m32c0.h
new file mode 100644
index 00000000..607965f
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/m32c0.h
@@ -0,0 +1,861 @@
+/*
+ * Copyright (c) 1999-2003 MIPS Technologies, Inc.  All rights reserved.
+ * 
+ * Unpublished rights (if any) reserved under the copyright laws of the
+ * United States of America and other countries.
+ * 
+ * This code is proprietary to MIPS Technologies, Inc. ("MIPS
+ * Technologies").  Any copying, reproducing, modifying or use of this
+ * code (in whole or in part) that is not expressly permitted in writing
+ * by MIPS Technologies or an authorized third party is strictly
+ * prohibited.  At a minimum, this code is protected under unfair
+ * competition and copyright laws.  Violations thereof may result in
+ * criminal penalties and fines.
+ * 
+ * MIPS Technologies reserves the right to change this code to improve
+ * function, design or otherwise.  MIPS Technologies does not assume any
+ * liability arising out of the application or use of this code, or of
+ * any error or omission in such code.  Any warranties, whether express,
+ * statutory, implied or otherwise, including but not limited to the
+ * implied warranties of merchantability or fitness for a particular
+ * purpose, are excluded.  Except as expressly provided in any written
+ * license agreement from MIPS Technologies or an authorized third party,
+ * the furnishing of this code does not give recipient any license to any
+ * intellectual property rights, including any patent rights, that cover
+ * this code.
+ * 
+ * This code shall not be exported or transferred for the purpose of
+ * reexporting in violation of any U.S. or non-U.S. regulation, treaty,
+ * Executive Order, law, statute, amendment or supplement thereto.
+ * 
+ * This code constitutes one or more of the following: commercial
+ * computer software, commercial computer software documentation or other
+ * commercial items.  If the user of this code, or any related
+ * documentation of any kind, including related technical data or
+ * manuals, is an agency, department, or other entity of the United
+ * States government ("Government"), the use, duplication, reproduction,
+ * release, modification, disclosure, or transfer of this code, or any
+ * related documentation of any kind, is restricted in accordance with
+ * Federal Acquisition Regulation 12.212 for civilian agencies and
+ * Defense Federal Acquisition Regulation Supplement 227.7202 for
+ * military agencies.  The use of this code by the Government is further
+ * restricted in accordance with the terms of the license agreement(s)
+ * and/or applicable contract terms and conditions covering this code
+ * from MIPS Technologies or an authorized third party.
+ */
+
+/*
+ * m32c0.h : MIPS32 coprocessor 0 definitions
+ */
+
+
+#ifndef _M32C0_H_
+#define _M32C0_H_
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/* MIPS32-specific MMU interface */
+#assert mmu(m32)
+#include <mips/m32tlb.h>
+
+/*
+ * MIPS32 Exception Codes
+ */
+#define EXC_INTR	0	/* interrupt */
+#define EXC_MOD		1	/* tlb modification */
+#define EXC_TLBL	2	/* tlb miss (load/i-fetch) */
+#define EXC_TLBS	3	/* tlb miss (store) */
+#define EXC_ADEL	4	/* address error (load/i-fetch) */
+#define EXC_ADES	5	/* address error (store) */
+#define EXC_IBE		6	/* bus error (i-fetch) */
+#define EXC_DBE		7	/* data bus error (load/store) */
+#define EXC_SYS		8	/* system call */
+#define EXC_BP		9	/* breakpoint */
+#define EXC_RI		10	/* reserved instruction */
+#define EXC_CPU		11	/* coprocessor unusable */
+#define EXC_OVF		12	/* integer overflow */
+#define EXC_TRAP	13	/* trap exception */
+#define EXC_RES14	14
+#define EXC_FPE		15	/* floating point exception */
+#define EXC_IS1		16	/* implementation-specific 1 */
+#define EXC_IS2		17	/* implementation-specific 2 */
+#define EXC_C2E		18	/* coprocessor 2 exception */
+#define EXC_RES19	19
+#define EXC_RES20	20
+#define EXC_RES21	21
+#define EXC_MDMX	22	/* mdmx unusable */
+#define EXC_WATCH	23	/* watchpoint */
+#define EXC_MCHECK	24	/* machine check */
+#define EXC_RES25	25
+#define EXC_RES26	26
+#define EXC_RES27	27
+#define EXC_RES28	28
+#define EXC_RES29	29
+#define EXC_RES30	30
+#define EXC_RES31	31
+
+
+/*
+ * MIPS32 Cause Register (CP0 Register 13, Select 0)
+ */
+#define CR_BD		0x80000000	/* branch delay */
+#define CR_TI		0x40000000	/* timer interrupt (r2) */
+#define CR_CEMASK	0x30000000      /* coprocessor used */
+#define CR_CESHIFT	28
+#define CR_DC		0x08000000	/* disable count (r2) */
+#define CR_PCI		0x04000000	/* performance counter i/u (r2) */
+#define CR_IV		0x00800000	/* use special i/u vec */
+#define CR_WP		0x00400000	/* deferred watchpoint */
+
+/* interrupt pending bits */
+#define CR_SINT0	0x00000100 	/* s/w interrupt 0 */
+#define CR_SINT1	0x00000200	/* s/w interrupt 1 */
+#define CR_HINT0	0x00000400	/* h/w interrupt 0 */
+#define CR_HINT1	0x00000800	/* h/w interrupt 1 */
+#define CR_HINT2	0x00001000	/* h/w interrupt 2 */
+#define CR_HINT3	0x00002000	/* h/w interrupt 3 */
+#define CR_HINT4	0x00004000	/* h/w interrupt 4 */
+#define CR_HINT5	0x00008000	/* h/w interrupt 5 */
+
+/* alternative interrupt pending bit naming */
+#define CR_IP0		0x00000100
+#define CR_IP1		0x00000200
+#define CR_IP2		0x00000400
+#define CR_IP3		0x00000800
+#define CR_IP4		0x00001000
+#define CR_IP5		0x00002000
+#define CR_IP6		0x00004000
+#define CR_IP7		0x00008000
+
+#define CR_IMASK	0x0000ff00 	/* interrupt pending mask */
+#define CR_XMASK	0x0000007c 	/* exception code mask */
+#define CR_XCPT(x)	((x)<<2)
+
+
+/*
+ * MIPS32 Status Register  (CP0 Register 12, Select 0)
+ */
+#define SR_IE		0x00000001 	/* interrupt enable */
+#define SR_EXL		0x00000002	/* exception level */
+#define SR_ERL		0x00000004	/* error level */
+
+#define SR_UM		0x00000010	/* user mode */
+#define SR_KSU_MASK	0x00000018	/* ksu mode mask */
+#define SR_KSU_USER	0x00000010	/* user mode */
+#define SR_KSU_SPVS	0x00000008	/* supervisor mode */
+#define SR_KSU_KERN	0x00000000	/* kernel mode */
+
+/* interrupt mask bits */
+#define SR_SINT0	0x00000100	/* enable s/w interrupt 0 */
+#define SR_SINT1	0x00000200	/* enable s/w interrupt 1 */
+#define SR_HINT0	0x00000400	/* enable h/w interrupt 1 */
+#define SR_HINT1	0x00000800	/* enable h/w interrupt 2 */
+#define SR_HINT2	0x00001000	/* enable h/w interrupt 3 */
+#define SR_HINT3	0x00002000	/* enable h/w interrupt 4 */
+#define SR_HINT4	0x00004000	/* enable h/w interrupt 5 */
+#define SR_HINT5	0x00008000	/* enable h/w interrupt 6 */
+
+/* alternative interrupt mask naming */
+#define SR_IM0		0x00000100
+#define SR_IM1		0x00000200
+#define SR_IM2		0x00000400
+#define SR_IM3		0x00000800
+#define SR_IM4		0x00001000
+#define SR_IM5		0x00002000
+#define SR_IM6		0x00004000
+#define SR_IM7		0x00008000
+
+#define SR_IMASK	0x0000ff00
+
+#define SR_NMI		0x00080000 	/* NMI occurred */
+#define SR_SR		0x00100000	/* soft reset occurred */
+#define SR_TS		0x00200000	/* TLB shutdown */
+#define SR_BEV		0x00400000	/* boot exception vectors */
+#define SR_PX		0x00800000	/* user 64-bit reg / 32-bit addr */
+#define SR_MX		0x01000000	/* enable MDMX ASE */
+#define SR_RE		0x02000000	/* reverse endian (user mode) */
+#define SR_FR		0x04000000	/* 64-bit fpu registers */
+#define SR_RP		0x08000000	/* reduce power */
+
+#define SR_CU0		0x10000000	/* coprocessor 0 enable */
+#define SR_CU1		0x20000000	/* coprocessor 1 enable */
+#define SR_CU2		0x40000000	/* coprocessor 2 enable */
+#define SR_CU3		0x80000000	/* coprocessor 3 enable */
+
+
+/*
+ * MIPS32r2 HWREna Register  (CP0 Register 7, Select 0)
+ */
+#define HWRENA_CPUNUM	0x00000001
+#define HWRENA_SYNCSTEP	0x00000002
+#define HWRENA_CC	0x00000004
+#define HWRENA_CCRES	0x00000008
+
+/*
+ * MIPS32r2 IntCtl Register  (CP0 Register 12, Select 1)
+ */
+#define INTCTL_IPTI	0xe0000000	/* timer i/u pending bit */
+#define  INTCTL_IPTI_SHIFT	29
+#define INTCTL_IPPCI	0x1c000000	/* perfctr i/u pending bit */
+#define  INTCTL_IPPCI_SHIFT	26
+#define INTCTL_VS	0x000003e0	/* vector spacing */
+#define  INTCTL_VS_0		(0x00<<5)
+#define  INTCTL_VS_32		(0x01<<5)
+#define  INTCTL_VS_64		(0x02<<5)
+#define  INTCTL_VS_128		(0x04<<5)
+#define  INTCTL_VS_256		(0x08<<5)
+#define  INTCTL_VS_512		(0x10<<5)
+
+/*
+ * MIPS32r2 SRSCtl Register  (CP0 Register 12, Select 2)
+ */
+#define SRSCTL_HSS	0x3c000000	/* highest shadow set */
+#define  SRSCTL_HSS_SHIFT	26
+#define SRSCTL_EICSS	0x003c0000	/* EIC shadow set */
+#define  SRSCTL_EICSS_SHIFT	18
+#define SRSCTL_ESS	0x0000f000	/* exception shadow set */
+#define  SRSCTL_ESS_SHIFT	12
+#define SRSCTL_PSS	0x000003c0	/* previous shadow set */
+#define  SRSCTL_PSS_SHIFT	 6
+#define SRSCTL_CSS	0x0000000f	/* current shadow set */
+#define  SRSCTL_CSS_SHIFT	 0
+
+/*
+ * MIPS32 Config0 Register  (CP0 Register 16, Select 0)
+ */
+#define CFG0_M		0x80000000	/* Config1 implemented */
+#define CFG0_BE		0x00008000	/* Big Endian */
+#define CFG0_ATMASK	0x00006000	/* Architecture type: */
+#define  CFG0_AT_M32	 (0<<13)	 /* MIPS32 */
+#define  CFG0_AT_M64_A32 (1<<13)	 /* MIPS64, 32-bit addresses */
+#define  CFG0_AT_M64_A64 (2<<13)	 /* MIPS64, 64-bit addresses */
+#define  CFG0_AT_RES	 (3<<13)
+#define CFG0_ARMASK	0x00001c00
+#define CFG0_ARSHIFT	10
+#define CFG0_MTMASK	0x00000380
+#define  CFG0_MT_NONE	 (0<<7)
+#define  CFG0_MT_TLB	 (1<<7)
+#define  CFG0_MT_BAT	 (2<<7)
+#define  CFG0_MT_NONSTD	 (3<<7)
+#define CFG0_VI		0x00000008	/* Icache is virtual */
+#define CFG0_K0MASK	0x00000007	/* KSEG0 coherency algorithm */
+
+/*
+ * R4000 compatibility Config Register (actually processor dependent)
+ */
+#define CFG_BE		CFG0_BE		/* Big Endian */
+#define CFG_K0MASK	CFG0_K0MASK	/* KSEG0 coherency algorithm */
+
+/*
+ * MIPS32 Config1 Register (CP0 Register 16, Select 1)
+ */
+#define CFG1_M		0x80000000	/* Config2 implemented */
+#define CFG1_MMUSMASK	0x7e000000	/* mmu size - 1 */
+#define CFG1_MMUSSHIFT	25
+#define CFG1_ISMASK	0x01c00000	/* icache lines 64<<n */
+#define CFG1_ISSHIFT	22
+#define CFG1_ILMASK	0x00380000	/* icache line size 2<<n */
+#define CFG1_ILSHIFT	19
+#define CFG1_IAMASK	0x00070000	/* icache ways - 1 */
+#define CFG1_IASHIFT	16
+#define CFG1_DSMASK	0x0000e000	/* dcache lines 64<<n */
+#define CFG1_DSSHIFT	13
+#define CFG1_DLMASK	0x00001c00	/* dcache line size 2<<n */
+#define CFG1_DLSHIFT	10
+#define CFG1_DAMASK	0x00000380	/* dcache ways - 1 */
+#define CFG1_DASHIFT	7
+#define CFG1_C2		0x00000040	/* Coprocessor 2 present */
+#define CFG1_MD		0x00000020	/* MDMX implemented */
+#define CFG1_PC		0x00000010	/* performance counters implemented */
+#define CFG1_WR		0x00000008	/* watch registers implemented */
+#define CFG1_CA		0x00000004	/* compression (mips16) implemented */
+#define CFG1_EP		0x00000002	/* ejtag implemented */
+#define CFG1_FP		0x00000001	/* fpu implemented */
+
+
+/*
+ * MIPS32r2 Config2 Register (CP0 Register 16, Select 2)
+ */
+#define CFG2_M		0x80000000	/* Config3 implemented */
+#define CFG2_TUMASK	0x70000000	/* tertiary cache control */
+#define CFG2_TUSHIFT	28
+#define CFG2_TSMASK	0x0f000000	/* tcache sets per wway 64<<n */
+#define CFG2_TSSHIFT	24
+#define CFG2_TLMASK	0x00f00000	/* tcache line size 2<<n */
+#define CFG2_TLSHIFT	20
+#define CFG2_TAMASK	0x000f0000	/* tcache ways - 1 */
+#define CFG2_TASHIFT	16
+#define CFG2_SUMASK	0x0000f000	/* secondary cache control */
+#define CFG2_SUSHIFT	12
+#define CFG2_SSMASK	0x00000f00	/* scache sets per wway 64<<n */
+#define CFG2_SSSHIFT	8
+#define CFG2_SLMASK	0x000000f0	/* scache line size 2<<n */
+#define CFG2_SLSHIFT	4
+#define CFG2_SAMASK	0x0000000f	/* scache ways - 1 */
+#define CFG2_SASHIFT	0
+
+/*
+ * MIPS32r2 Config2 Register (CP0 Register 16, Select 3)
+ */
+#define CFG3_M		0x80000000	/* Config4 implemented */
+#define CFG3_LPA	0x00000080	/* Large physical addresses */
+#define CFG3_VEIC	0x00000040	/* Vectored external i/u controller */
+#define CFG3_VI		0x00000020	/* Vectored i/us */
+#define CFG3_SP		0x00000010	/* Small page support */
+#define CFG3_ISP	0x00000008	/* Instruction ScratchPad */
+#define CFG3_DSP	0x00000004	/* Data ScratchPad */
+#define CFG3_SM		0x00000002	/* SmartMIPS ASE */
+#define CFG3_TL		0x00000001	/* Trace Logic */
+
+
+/*
+ * Primary cache mode
+ */
+#define CFG_C_UNCACHED		2
+#define CFG_C_WBACK		3
+#define CFG_C_NONCOHERENT	3
+
+#if 0
+/* These cache modes are CPU specific */
+#define CFG_C_WTHRU_NOALLOC	0
+#define CFG_C_WTHRU_ALLOC	1
+#define CFG_C_COHERENTXCL	4
+#define CFG_C_COHERENTXCLW	5 	
+#define CFG_C_COHERENTUPD	6
+#define CFG_C_UNCACHED_ACCEL	7
+#endif
+
+
+/* 
+ * Primary Cache TagLo (CP0 Register 28, Select 0/2)
+ */
+#define TAG_PTAG_MASK           0xffffff00      /* Primary Tag */
+#define TAG_PTAG_SHIFT          8
+#define TAG_PSTATE_MASK         0x000000c0      /* Primary Cache State */
+#define TAG_PSTATE_SHIFT        6
+#define TAG_PSTATE_LOCK		0x00000020
+#define TAG_PARITY_MASK         0x00000001      /* Primary Tag Parity */
+#define TAG_PARITY_SHIFT        0
+
+/* primary cache state (XXX actually implementation specific) */
+#define PSTATE_INVAL		0
+#define PSTATE_SHARED		1
+#define PSTATE_CLEAN_EXCL	2
+#define PSTATE_DIRTY_EXCL	3
+
+
+/*
+ * Cache operations
+ */
+#define Index_Invalidate_I               0x00        /* 0       0 */
+#define Index_Writeback_Inv_D            0x01        /* 0       1 */
+#define Index_Writeback_Inv_T            0x02        /* 0       2 */
+#define Index_Writeback_Inv_S            0x03        /* 0       3 */
+#define Index_Load_Tag_I                 0x04        /* 1       0 */
+#define Index_Load_Tag_D                 0x05        /* 1       1 */
+#define Index_Load_Tag_T                 0x06        /* 1       2 */
+#define Index_Load_Tag_S                 0x07        /* 1       3 */
+#define Index_Store_Tag_I                0x08        /* 2       0 */
+#define Index_Store_Tag_D                0x09        /* 2       1 */
+#define Index_Store_Tag_T                0x0A        /* 2       2 */
+#define Index_Store_Tag_S                0x0B        /* 2       3 */
+#define Hit_Invalidate_I                 0x10        /* 4       0 */
+#define Hit_Invalidate_D                 0x11        /* 4       1 */
+#define Hit_Invalidate_T                 0x12        /* 4       2 */
+#define Hit_Invalidate_S                 0x13        /* 4       3 */
+#define Fill_I                           0x14        /* 5       0 */
+#define Hit_Writeback_Inv_D              0x15        /* 5       1 */
+#define Hit_Writeback_Inv_T              0x16        /* 5       2 */
+#define Hit_Writeback_Inv_S              0x17        /* 5       3 */
+#define Hit_Writeback_D                  0x19        /* 6       1 */
+#define Hit_Writeback_T                  0x1A        /* 6       1 */
+#define Hit_Writeback_S                  0x1B        /* 6       3 */
+#define Fetch_Lock_I                 	 0x1C        /* 7       0 */
+#define Fetch_Lock_D                 	 0x1D        /* 7       1 */
+
+/* MIPS32 WatchLo Register (CP0 Register 18) */
+#define WATCHLO_VA		0xfffffff8
+#define WATCHLO_I		0x00000004
+#define WATCHLO_R		0x00000002
+#define WATCHLO_W		0x00000001
+
+/* MIPS32 WatchHi Register (CP0 Register 19) */
+#define WATCHHI_M		0x80000000
+#define WATCHHI_G		0x40000000
+#define WATCHHI_ASIDMASK	0x00ff0000
+#define WATCHHI_ASIDSHIFT	16
+#define WATCHHI_MASK		0x00000ffc
+#define WATCHHI_I		0x00000004
+#define WATCHHI_R		0x00000002
+#define WATCHHI_W		0x00000001
+
+/* MIPS32 PerfCnt Register (CP0 Register 25) */
+#define PERFCNT_M		0x80000000
+#define PERFCNT_EVENTMASK	0x000007e0
+#define PERFCNT_EVENTSHFT	5
+#define PERFCNT_IE		0x00000010
+#define PERFCNT_U		0x00000008
+#define PERFCNT_S		0x00000004
+#define PERFCNT_K		0x00000002
+#define PERFCNT_EXL		0x00000001
+
+/* MIPS32r2 PageGrain  Register (CP0 Register 5, Select 1) */
+#define PAGEGRAIN_ELPA	0x20000000	/* Enable large phusical addresses */
+#define PAGEGRAIN_ESP	0x10000000	/* Enable small (1KB) page support */
+
+/* MIPS32r2 EBase  Register (CP0 Register 15, Select 1) */
+#define EBASE_BASE	0xfffff000	/* Exception base */
+#define EBASE_CPU	0x000003ff	/* CPU number */
+
+#ifdef __ASSEMBLER__
+
+/* 
+ * MIPS32 Coprocessor 0 register numbers 
+ */
+#define C0_INDEX	$0
+#define C0_INX		$0
+#define C0_RANDOM	$1
+#define C0_RAND		$1
+#define C0_ENTRYLO0	$2
+#define C0_TLBLO0	$2
+#define C0_ENTRYLO1	$3
+#define C0_TLBLO1	$3
+#define C0_CONTEXT	$4
+#define C0_CTXT		$4
+#define C0_PAGEMASK	$5
+#define C0_PAGEGRAIN	$5,1
+#define C0_WIRED	$6
+#define C0_HWRENA	$7
+#define C0_BADVADDR 	$8
+#define C0_VADDR 	$8
+#define C0_COUNT 	$9
+#define C0_ENTRYHI	$10
+#define C0_TLBHI	$10
+#define C0_COMPARE	$11
+#define C0_STATUS	$12
+#define C0_SR		$12
+#define C0_INTCTL	$12,1
+#define C0_SRSCTL	$12,2
+#define C0_SRSMAP	$12,3
+#define C0_CAUSE	$13
+#define C0_CR		$13
+#define C0_EPC 		$14
+#define C0_PRID		$15
+#define C0_EBASE	$15,1
+#define C0_CONFIG	$16
+#define C0_CONFIG0	$16,0
+#define C0_CONFIG1	$16,1
+#define C0_CONFIG2	$16,2
+#define C0_CONFIG3	$16,3
+#define C0_LLADDR	$17
+#define C0_WATCHLO	$18
+#define C0_WATCHHI	$19
+#define C0_DEBUG	$23
+#define C0_DEPC		$24
+#define C0_PERFCNT	$25
+#define C0_ERRCTL	$26
+#define C0_CACHEERR	$27
+#define C0_TAGLO	$28
+#define C0_DATALO	$28,1
+#define C0_TAGHI	$29
+#define C0_DATAHI	$29,1
+#define C0_ERRPC	$30
+#define C0_DESAVE	$31
+
+$index		=	$0
+$random		=	$1
+$entrylo0	=	$2
+$entrylo1	=	$3
+$context	=	$4
+$pagemask	=	$5
+$wired		=	$6
+$hwrena		=	$7
+$vaddr 		=	$8
+$badvaddr	=	$8
+$count 		=	$9
+$entryhi	=	$10
+$compare	=	$11
+$sr		=	$12
+$cr		=	$13
+$epc 		=	$14
+$prid		=	$15
+$config		=	$16
+$lladdr		=	$17
+$watchlo	=	$18
+$watchhi	=	$19
+$debug		= 	$23
+$depc		= 	$24
+$perfcnt	= 	$25
+$errctl		=	$26
+$cacheerr	=	$27
+$taglo		=	$28
+$taghi		=	$29
+$errpc		=	$30
+$desave		=	$31
+
+
+#else /* !__ASSEMBLER__ */
+
+/*
+ * Standard types
+ */
+typedef unsigned long		reg32_t;	/* a 32-bit register */
+typedef unsigned long long	reg64_t;	/* a 64-bit register */
+#if __mips == 64 || __mips64
+typedef unsigned long long	reg_t;
+typedef signed long long	sreg_t;
+#else
+typedef unsigned long		reg_t;
+typedef signed long		sreg_t;
+#endif
+
+/* 
+ * MIPS32 Coprocessor 0 register numbers 
+ */
+#define C0_INDEX	0
+#define C0_INX		0
+#define C0_RANDOM	1
+#define C0_RAND		1
+#define C0_ENTRYLO0	2
+#define C0_TLBLO0	2
+#define C0_ENTRYLO1	3
+#define C0_TLBLO1	3
+#define C0_CONTEXT	4
+#define C0_CTXT		4
+#define C0_PAGEMASK	5
+#define C0_WIRED	6
+#define C0_HWRENA	7
+#define C0_BADVADDR 	8
+#define C0_VADDR 	8
+#define C0_COUNT 	9
+#define C0_ENTRYHI	10
+#define C0_TLBHI	10
+#define C0_COMPARE	11
+#define C0_STATUS	12
+#define C0_SR		12
+#define C0_CAUSE	13
+#define C0_CR		13
+#define C0_EPC 		14
+#define C0_PRID		15
+#define C0_CONFIG	16
+#define C0_LLADDR	17
+#define C0_WATCHLO	18
+#define C0_WATCHHI	19
+#define C0_DEBUG	23
+#define C0_DEPC		24
+#define C0_PERFCNT	25
+#define C0_ERRCTL	26
+#define C0_CACHEERR	27
+#define C0_TAGLO	28
+#define C0_TAGHI	29
+#define C0_ERRPC	30
+#define C0_DESAVE	31
+
+#define _mips_nop() \
+  __asm__ __volatile ("%(ssnop%)" : :) 
+
+#define _mips_sync() \
+  __asm__ __volatile ("sync" : : : "memory")
+
+/* wait for unmasked interrupt */
+#define _mips_wait() \
+  __asm__ __volatile ("wait")
+
+/* 
+ * Define macros for accessing the MIPS32 coprocessor 0 registers.
+ * Most apart from "set" return the original register value.
+ */
+
+#if !__mips16
+
+#define _m32c0_mfc0(reg, sel) \
+__extension__ ({ \
+  register unsigned long __r; \
+  __asm__ __volatile ("mfc0 %0,$%1,%2" \
+		      : "=d" (__r) \
+      		      : "JK" (reg), "JK" (sel)); \
+  __r; \
+})
+
+#if __mips_isa_rev >= 2
+#define _m32c0_mtc0(reg, sel, val) \
+do { \
+    __asm__ __volatile ("%(mtc0 %z0,$%1,%2; ehb%)" \
+			: \
+			: "dJ" ((reg32_t)(val)), "JK" (reg), "JK" (sel) \
+			: "memory"); \
+} while (0)
+#else
+#define _m32c0_mtc0(reg, sel, val) \
+do { \
+    __asm__ __volatile ("%(mtc0 %z0,$%1,%2; ssnop; ssnop; ehb%)" \
+			: \
+			: "dJ" ((reg32_t)(val)), "JK" (reg), "JK" (sel) \
+			: "memory"); \
+} while (0)
+#endif
+
+#define _m32c0_mxc0(reg, sel, val) \
+__extension__ ({ \
+    register reg32_t __o; \
+    __o = _m32c0_mfc0 (reg, sel); \
+    _m32c0_mtc0 (reg, sel, val); \
+    __o; \
+})
+
+#else
+
+#define _m32c0_mfc0(rn, sel) 	_mips_xxc0 ((rn) + (sel)*32, 0, 0)
+#define _m32c0_mtc0(rn, sel, v)	(void) _mips_xxc0 ((rn) + (sel)*32, ~0, v)
+#define _m32c0_mxc0(rn, sel, v)	_mips_xxc0 ((rn) + (sel)*32, ~0, v)
+
+#endif /* !__mips16 */
+
+/* generic equivalents for mips/cpu.h */
+#define _mips_mfc0(r)		_m32c0_mfc0(r,0)
+#define _mips_mtc0(r,v)		_m32c0_mtc0(r,0,v)
+
+/* MIPS32 Config0 register */
+#define mips32_getconfig0()	_mips_mfc0(16)
+#define mips32_setconfig0(v)	_mips_mtc0(16,v)
+#define mips32_xchconfig0(v)	_mips_mxc0(16,v)
+#define mips32_bicconfig0(clr)	_mips_bcc0(16,clr)
+#define mips32_bisconfig0(set)	_mips_bsc0(16,set)
+#define mips32_bcsconfig0(c,s)	_mips_bcsc0(16,c,s)
+
+/* MIPS32 Config1, 2 & 3 register */
+#define mips32_getconfig1()	_m32c0_mfc0(16,1)
+#define mips32_getconfig2()	_m32c0_mfc0(16,2)
+#define mips32_getconfig3()	_m32c0_mfc0(16,3)
+
+/* MIPS32 WatchLo register */
+#define mips32_getwatchlo(sel)	 _mips_xxc0(18 + (sel)*32, 0, 0)
+#define mips32_setwatchlo(sel,v) _mips_xxc0(18 + (sel)*32, ~0, v)
+
+/* MIPS32 WatchHi register */
+#define mips32_getwatchhi(sel)	 _mips_xxc0(19 + (sel)*32, 0, 0)
+#define mips32_setwatchhi(sel,v) _mips_xxc0(19 + (sel)*32, ~0, v)
+
+/* MIPS32 Debug register */
+#define mips32_getdebug()	_mips_mfc0(23)
+#define mips32_setdebug(v)	_mips_mtc0(23,v)
+#define mips32_xchdebug(v)	_mips_mxc0(23,v)
+#define mips32_bicdebug(clr)	_mips_bcc0(23,clr)
+#define mips32_bisdebug(set)	_mips_bsc0(23,set)
+#define mips32_bcsdebug(c,s)	_mips_bcsc0(23,c,s)
+
+/* MIPS32 ErrCtl register */
+#define mips32_geterrctl()	_mips_mfc0(26)
+#define mips32_seterrctl(x)	_mips_mtc0(26,x)
+#define mips32_xcherrctl(x)	_mips_mxc0(26,x)
+#define mips32_bicerrctl(clr)	_mips_bcc0(26,clr)
+#define mips32_biserrctl(set)	_mips_bsc0(26,set)
+#define mips32_bcserrctl(c,s)	_mips_bcsc0(26,c,s)
+
+/* MIPS32 DataLo register */
+#define mips32_getdatalo()	_m32c0_mfc0(28,1)
+#define mips32_setdatalo(x)	_m32c0_mtc0(28,1,x)
+#define mips32_xchdatalo(x)	_m32c0_mxc0(28,1,x)
+
+/* MIPS32r2 IntCtl register */
+#define mips32_getintctl()	_m32c0_mfc0(12,1)
+#define mips32_setintctl(x)	_m32c0_mtc0(12,1,x)
+#define mips32_xchintctl(x)	_m32c0_mxc0(12,1,x)
+
+/* MIPS32r2 SRSCtl register */
+#define mips32_getsrsctl()	_m32c0_mfc0(12,2)
+#define mips32_setsrsctl(x)	_m32c0_mtc0(12,2,x)
+#define mips32_xchsrsctl(x)	_m32c0_mxc0(12,2,x)
+
+/* MIPS32r2 SRSMap register */
+#define mips32_getsrsmapl()	_m32c0_mfc0(12,3)
+#define mips32_setsrsmap(x)	_m32c0_mtc0(12,3,x)
+#define mips32_xchsrsmap(x)	_m32c0_mxc0(12,3,x)
+
+/* MIPS32r2/SmartMIPS PageGrain register */
+#define mips32_getpagegrain()	_m32c0_mfc0(5,1)
+#define mips32_setpagegrain(x)	_m32c0_mtc0(5,1,x)
+#define mips32_xchpagegrain(x)	_m32c0_mxc0(5,1,x)
+
+/* MIPS32r2 HWREna register */
+#define mips32_gethwrena()	_mips_mfc0(7)
+#define mips32_sethwrena(v)	_mips_mtc0(7,v)
+#define mips32_xchhwrena(v)	_mips_mxc0(7,v)
+#define mips32_bichwrena(clr)	_mips_bcc0(7,clr)
+#define mips32_bishwrena(set)	_mips_bsc0(7,set)
+#define mips32_bcshwrena(c,s)	_mips_bcsc0(7,c,s)
+
+/* MIPS32r2 EBase register */
+#define mips32_getebase()	_m32c0_mfc0(15,1)
+#define mips32_setebase(x)	_m32c0_mtc0(15,1,x)
+#define mips32_xchebase(x)	_m32c0_mxc0(15,1,x)
+
+/* MIPS32 PREF instruction hint codes */
+#define PREF_LOAD		0
+#define PREF_STORE		1
+#define PREF_LOAD_STREAMED	4
+#define PREF_STORE_STREAMED	5
+#define PREF_LOAD_RETAINED	6
+#define PREF_STORE_RETAINED	7
+#define PREF_WRITEBACK_INVAL	25
+#define PREF_PREPAREFORSTORE	30
+
+#if ! __mips16
+
+/* C interface to clz/clo instructions */
+#define mips_clz(x) __extension__({ \
+    unsigned int __x = (x); \
+    unsigned int __v; \
+    __asm__ ("clz %0,%1" : "=d" (__v) : "d" (__x)); \
+    __v; \
+})
+
+#define mips_clo(x) __extension__({ \
+    unsigned int __x = (x); \
+    unsigned int __v; \
+    __asm__ ("clo %0,%1" : "=d" (__v) : "d" (__x)); \
+    __v; \
+})
+
+#if __mips_isa_rev >= 2
+
+/* MIPS32r2 wsbh opcode */
+#define _mips32r2_wsbh(x) __extension__({ \
+    unsigned int __x = (x), __v; \
+    __asm__ ("wsbh %0,%1" \
+	     : "=d" (__v) \
+	     : "d" (__x)); \
+    __v; \
+})
+
+/* MIPS32r2 byte-swap word */
+#define _mips32r2_bswapw(x) __extension__({ \
+    unsigned int __x = (x), __v; \
+    __asm__ ("wsbh %0,%1; rotr %0,16" \
+	     : "=d" (__v) \
+	     : "d" (__x)); \
+    __v; \
+})
+
+/* MIPS32r2 insert bits */
+#define _mips32r2_ins(tgt,val,pos,sz) __extension__({ \
+    unsigned long __t = (tgt), __v = (val); \
+    __asm__ ("ins %0,%z1,%2,%3" \
+	     : "+d" (__t) \
+	     : "dJ" (__v), "I" (pos), "I" (sz)); \
+    __t; \
+})
+
+/* MIPS32r2 extract bits */
+#define _mips32r2_ext(x,pos,sz) __extension__({ \
+    unsigned long __x = (x), __v; \
+    __asm__ ("ext %0,%z1,%2,%3" \
+	     : "=d" (__v) \
+	     : "dJ" (__x), "I" (pos), "I" (sz)); \
+    __v; \
+})
+
+#if __mips == 64
+
+/* MIPS64r2 dshd opcode */
+#define _mips64r2_dshd(x) __extension__({ \
+    unsigned long long __x = (x), __v; \
+    __asm__ ("dshd %0,%1" \
+	     : "=d" (__v) \
+	     : "d" (__x)); \
+    __v; \
+})
+
+/* MIPS64r2 dsbh opcode */
+#define _mips64r2_dsbh(x) __extension__({ \
+    unsigned long long __x = (x), __v; \
+    __asm__ ("dsbh %0,%1" \
+	     : "=d" (__v) \
+	     : "d" (__x)); \
+    __v; \
+})
+
+/* MIPS64r2 byte-swap doubleword */
+#define _mips64r2_bswapd(x) __extension__({ \
+    unsigned long long __x = (x), __v; \
+    __asm__ ("dsbh %0,%1; dshd %0,%0" \
+	     : "=d" (__v) \
+	     : "d" (__x)); \
+    __v; \
+})
+
+/* MIPS64r2 insert bits */
+#define _mips64r2_dins(tgt,val,pos,sz) __extension__({ \
+    unsigned long long __t = (tgt), __v = (val); \
+    __asm__ ("dins %0,%z1,%2,%3" \
+	     : "+d" (__t) \
+	     : "dJ" (__v), "I" (pos), "I" (sz)); \
+    __t; \
+})
+
+/* MIPS64r2 extract bits */
+#define _mips64r2_dext(x,pos,sz) __extension__({ \
+    unsigned long long __x = (x), __v; \
+    __asm__ ("dext %0,%z1,%2,%3" \
+	     : "=d" (__v) \
+	     : "dJ" (__x), "I" (pos), "I" (sz)); \
+    __v; \
+})
+
+#endif /* __mips == 64 */
+
+/* MIPS32r2 atomic interrupt disable */
+#define _mips_intdisable() __extension__({ \
+    unsigned int __v; \
+    __asm__ __volatile__ ("di %0; ehb" : "=d" (__v)); \
+    __v; \
+})
+
+/* MIPS32r2 atomic interrupt restore */
+#define _mips_intrestore(x) \
+    mips_setsr (x)
+
+/* MIPS32r2 set SRSCtl.PSS (previous shadow set), returning old value */
+#define _mips32r2_xchsrspss(set) \
+__extension__({ \
+    int __tmp, __old; \
+    __asm __volatile ("mfc0 %0,$12,2\n\
+		       ext %1,%0,6,4\n\
+		       ins %0,%z2,6,4\n\
+		       mtc0 %0,$12,2\n\
+		       ehb" \
+      		       : "=&d" (__tmp), "=&d" (__old) \
+       		       : "dJ" (set)); \
+    __old; \
+})
+
+/* MIPS32r2 write previous gpr */
+#define _mips32r2_wrpgpr(regno, val) \
+do { \
+    __asm __volatile ("wrpgpr $%0,%z1" \
+        	      : /* no outputs */ \
+ 		      : "JK" (regno), "dJ" (val)); \
+} while (0)
+
+/* MIPS32r2 read previous gpr */
+#define _mips32r2_rdpgpr(regno) \
+__extension__({ \
+    reg_t __val; \
+    __asm __volatile ("rdpgpr %0,$%1" \
+        	      : "=d" (__val) \
+ 		      : "JK" (regno)); \
+    __val; \
+})
+
+#endif /* __mips_isa_rev >= 2 */
+
+#endif /* ! __mips16 */
+
+#endif /* __ASSEMBLER__ */
+
+#ifdef __cplusplus
+}
+#endif
+#endif /* _M32C0_H_ */
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/mars.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mars.h
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/mcp_defines.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mcp_defines.h
new file mode 100644
index 00000000..0929c07
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mcp_defines.h
@@ -0,0 +1,98 @@
+#ifndef _MCP_DEFINES_H_INCLUDED_
+#define _MCP_DEFINES_H_INCLUDED_
+enum {E_MODE_DES=0,
+      E_MODE_TDES=1,
+      E_MODE_RC4=2,
+      E_MODE_MD5=3,
+      E_MODE_SHA1=4,
+      E_MODE_AES128=5,
+      E_MODE_AES192=29,
+      E_MODE_AES256=21,
+      E_MODE_AES_G=6,
+      E_MODE_AES_H=7,
+      E_MODE_CMAC=8,
+      E_MODE_CSA=9,
+      E_MODE_MULTI2=10,
+      E_MODE_SHA256=11,
+      E_MODE_BYPASS=31,
+      //E_MODE_CRC=12,
+      //E_MODE_CRC_SHA256=13,
+      E_MODE_LOAD_MICRO_CODE=14,
+      E_MODE_MICRO_CODE=15,
+      E_MODE_DECSS=17,
+      E_MODE_BDR=28,
+      E_MODE_BDP=27,
+      E_MODE_HDR_SOB=26,
+      E_MODE_HDR_VOB=25,
+      E_MODE_HDP=24,
+      E_MODE_CPRM=19,
+      E_MODE_CPPM=18};
+enum {E_BCM_ECB=0,E_BCM_CBC=1,E_BCM_CTR=2,E_BCM_RCBC_CS=3,E_BCM_CBC_CS3=7,E_BCM_CBC_CS2=11,E_BCM_CBC_CS1=15};
+enum {E_ENDE_DE = 0,E_ENDE_EN=1};
+enum {E_OTP_SEL_KN=0,E_OTP_SEL_KH=1,E_OTP_SEL_KS=2};
+enum {E_KEY_SEL_DT=0,E_KEY_SEL_OTP=1,E_KEY_SEL_CW=2,E_KEY_SEL_DDR=3};
+
+enum {E_RCP_MODE_AES128=0,
+      E_RCP_MODE_TDES=1,
+      E_RCP_MODE_DES=2,
+      E_RCP_MODE_AES192=3,
+      E_RCP_MODE_AES256=4,
+      E_RCP_MODE_TDES_DROP_LSB=5,
+      E_RCP_MODE_DES_DROP_LSB=6,
+      E_RCP_MODE_TDES_DROP_MSB=13,
+      E_RCP_MODE_DES_DROP_MSB=14};
+enum {E_RCP_CBC=1,E_RCP_ECB=0};      
+enum {E_RCP_KEY_MODE_REG=0,E_RCP_KEY_MODE_CW=1,E_RCP_KEY_MODE_OTP_KN=2,E_RCP_KEY_MODE_OTP_KH=3,E_RCP_KEY_MODE_OTP_KS=4};
+enum {E_RCP_IV_MODE_REG=0,E_RCP_IV_MODE_CW=1};
+enum {E_RCP_INPUT_MODE_REG=0,E_RCP_INPUT_MODE_CW=1};
+enum {E_RCP_OUTPUT_MODE_REG=0,E_RCP_OUTPUT_MODE_CW=1};
+enum {E_CPU_SCPU=0,E_CPU_KCPU=1};
+#ifdef SCPU_ARM
+    #define SET_CP_ISR_NWC(addr) SET_INT(INTERRUPT_SCPU_CP_NWC,(void*)addr)
+    #define SET_CP_ISR_SWC(addr) SET_INT(INTERRUPT_SCPU_CP_SWC,(void*)addr)
+    #define CP_DATA_BASE 0x00160000
+#else
+    #define SET_CP_ISR_NWC(addr) *((volatile*) HW_INTVEC_ADDR5) = (void*) addr
+    #define SET_CP_ISR_SWC(addr) *((volatile*) HW_INTVEC_ADDR5_KCPU) = (void*) addr
+    #define CP_DATA_BASE 0
+#endif
+#define CP_BYTE_SWAP(data)\
+       ((((data) & 0xFF000000)>>24)  |\
+        (((data) & 0x00FF0000)>> 8)  |\
+        (((data) & 0x0000FF00)<< 8)  |\
+        (((data) & 0x000000FF)<<24))
+
+#define DT_SIZE  56
+#define MCP_DATA_OFFSET(data)    (0xFF000000&((data)<<24))
+#define MCP_OTP_SEL(data)        (0x00300000&((data)<<20))
+#define MCP_MICRO_CODE_SEL(data) (0x000C0000&((data)<<18))
+#define MCP_INIKEY_REG3(data)    (0x00020000&((data)<<17))
+#define MCP_SHORT_BLOCK(data)    (0x00018000&((data)<<15))
+#define MCP_INIKEY_REG2(data)    (0x00004000&((data)<<14))
+#define MCP_KEY_SEL(data)        (0x00003000&((data)<<12))
+#define MCP_INIKEY_REG(data)     (0x00000800&((data)<<11))
+#define MCP_STATE_DUMP(data)     (0x00000400&((data)<<10))
+#define MCP_BCM(data)            (0x000003C0&((data)<< 6))
+#define MCP_ENDE(data)           (0x00000020&((data)<< 5))
+#define MCP_MODE(data)           (0x0000001F&((data)<< 0))
+
+#define CW_IV_ADDR(data)      (0x0000007f&((data)<<0))
+#define CW_KEY_ADDR(data)     (0x00007f00&((data)<<8))
+#define CW_SYSKEY_ADDR(data)  (0x007f0000&((data)<<16))
+
+#define SET_DDR(addr,data)                (*(unsigned int *) (0xa0000000|(addr)) = (data))
+#define SET_DT_WD0(base_addr,data)        SET_DDR(base_addr+ 0, data)
+#define SET_DT_KEY0(base_addr,data)       SET_DDR(base_addr+ 4, data)
+#define SET_DT_KEY1(base_addr,data)       SET_DDR(base_addr+ 8, data)
+#define SET_DT_KEY2(base_addr,data)       SET_DDR(base_addr+12, data)
+#define SET_DT_KEY3(base_addr,data)       SET_DDR(base_addr+16, data)
+#define SET_DT_KEY4(base_addr,data)       SET_DDR(base_addr+20, data)
+#define SET_DT_KEY5(base_addr,data)       SET_DDR(base_addr+24, data)
+#define SET_DT_INI_KEY0(base_addr,data)   SET_DDR(base_addr+28, data)
+#define SET_DT_INI_KEY1(base_addr,data)   SET_DDR(base_addr+32, data)
+#define SET_DT_INI_KEY2(base_addr,data)   SET_DDR(base_addr+36, data)
+#define SET_DT_INI_KEY3(base_addr,data)   SET_DDR(base_addr+40, data)
+#define SET_DT_SADR(base_addr,data)       SET_DDR(base_addr+44, data)
+#define SET_DT_DADR(base_addr,data)       SET_DDR(base_addr+48, data)
+#define SET_DT_BC(base_addr,data)         SET_DDR(base_addr+52, data)
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/mcp_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mcp_reg.h
new file mode 100644
index 00000000..a8b7c7c
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mcp_reg.h
@@ -0,0 +1,1873 @@
+/**************************************************************
+// Spec Version                  : 0.3
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/4/1 14:32:35
+***************************************************************/
+
+
+#ifndef _MCP_REG_H_INCLUDED_
+#define _MCP_REG_H_INCLUDED_
+#ifdef  _MCP_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     arb_mode:1;
+unsigned int     reserved_1:1;
+unsigned int     clear:1;
+unsigned int     swap:1;
+unsigned int     idle:1;
+unsigned int     go:1;
+unsigned int     write_data:1;
+}MCP_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     scramble_region:1;
+unsigned int     security_region:1;
+unsigned int     tm_out_wr:1;
+unsigned int     tm_out_rd:1;
+unsigned int     bc_not_empty:1;
+unsigned int     pc_range_err:1;
+unsigned int     err_reg:1;
+unsigned int     mc_dec_err:1;
+unsigned int     pp_w_err:1;
+unsigned int     pp_r_err:1;
+unsigned int     pp_ov:1;
+unsigned int     pp_mode_err:1;
+unsigned int     reserved_1:5;
+unsigned int     k_mcp_error:1;
+unsigned int     k_error:1;
+unsigned int     k_compare:1;
+unsigned int     k_ring_empty:1;
+unsigned int     mcp_error:1;
+unsigned int     reserved_2:2;
+unsigned int     compare:1;
+unsigned int     error:1;
+unsigned int     ring_empty:1;
+unsigned int     write_data:1;
+}MCP_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     scramble_region_en:1;
+unsigned int     cdpu_isr_en:1;
+unsigned int     mcp_error_en:1;
+unsigned int     reserved_1:2;
+unsigned int     compare_en:1;
+unsigned int     error_en:1;
+unsigned int     ring_empty_en:1;
+unsigned int     write_data:1;
+}MCP_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     aesh_pad_off:1;
+unsigned int     csa_entropy:2;
+unsigned int     mcp_round_no:8;
+}MCP_CTRL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     base:31;
+}MCP_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     limit:31;
+}MCP_LIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rdptr:31;
+}MCP_RDPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     wrptr:31;
+}MCP_WRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     count:16;
+}MCP_DES_COUNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     compare:16;
+}MCP_DES_COMPARE;
+
+typedef struct 
+{
+unsigned int     data:32;
+}MCP_DES_INI_KEY;
+
+typedef struct 
+{
+unsigned int     data:32;
+}MCP_AES_INI_KEY;
+
+typedef struct 
+{
+unsigned int     data:32;
+}MCP_MULTI2_SYS_KEY;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     otp_load:1;
+}CP_OTP_LOAD;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     clear:1;
+unsigned int     swap:1;
+unsigned int     idle:1;
+unsigned int     go:1;
+unsigned int     write_data:1;
+}K_MCP_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     scramble_region:1;
+unsigned int     security_region:1;
+unsigned int     tm_out_wr:1;
+unsigned int     tm_out_rd:1;
+unsigned int     bc_not_empty:1;
+unsigned int     pc_range_err:1;
+unsigned int     err_reg:1;
+unsigned int     mc_dec_err:1;
+unsigned int     pp_w_err:1;
+unsigned int     pp_r_err:1;
+unsigned int     pp_ov:1;
+unsigned int     pp_mode_err:1;
+unsigned int     reserved_1:5;
+unsigned int     s_mcp_error:1;
+unsigned int     s_error:1;
+unsigned int     s_compare:1;
+unsigned int     s_ring_empty:1;
+unsigned int     mcp_error:1;
+unsigned int     reserved_2:2;
+unsigned int     compare:1;
+unsigned int     error:1;
+unsigned int     ring_empty:1;
+unsigned int     write_data:1;
+}K_MCP_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     security_region_en:1;
+unsigned int     cdpu_isr_en:1;
+unsigned int     mcp_error_en:1;
+unsigned int     reserved_1:2;
+unsigned int     compare_en:1;
+unsigned int     error_en:1;
+unsigned int     ring_empty_en:1;
+unsigned int     write_data:1;
+}K_MCP_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     aesh_pad_off:1;
+unsigned int     csa_entropy:2;
+unsigned int     mcp_round_no:8;
+}K_MCP_CTRL1;
+
+typedef struct 
+{
+unsigned int     base:32;
+}K_MCP_BASE;
+
+typedef struct 
+{
+unsigned int     limit:32;
+}K_MCP_LIMIT;
+
+typedef struct 
+{
+unsigned int     rdptr:32;
+}K_MCP_RDPTR;
+
+typedef struct 
+{
+unsigned int     wrptr:32;
+}K_MCP_WRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     count:16;
+}K_MCP_DES_COUNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     compare:16;
+}K_MCP_DES_COMPARE;
+
+typedef struct 
+{
+unsigned int     data:32;
+}K_MCP_DES_INI_KEY;
+
+typedef struct 
+{
+unsigned int     data:32;
+}K_MCP_AES_INI_KEY;
+
+typedef struct 
+{
+unsigned int     data:32;
+}K_MCP_MULTI2_SYS_KEY;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     enable:1;
+unsigned int     kam:3;
+}K_MCP_M2M_DES_KAM;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     rd_sm:4;
+unsigned int     wr_sm:3;
+unsigned int     reserved_1:10;
+unsigned int     mcp_aes_like_sm:11;
+}MCP_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     mcp_top_sm:20;
+}MCP_ST1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     adr3:10;
+unsigned int     reserved_1:6;
+unsigned int     adr2:10;
+}MC_MAP1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     adr1:10;
+unsigned int     reserved_1:6;
+unsigned int     adr0:10;
+}MC_MAP2;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     pc:10;
+}MC_INFO1;
+
+typedef struct 
+{
+unsigned int     word1:32;
+}MC_INFO2;
+
+typedef struct 
+{
+unsigned int     word2:32;
+}MC_INFO3;
+
+typedef struct 
+{
+unsigned int     word3:32;
+}MC_INFO4;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     tmout_ctr:16;
+}MC_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rm:4;
+unsigned int     rme:1;
+unsigned int     drf_test_resume:1;
+unsigned int     drf_bist_mode:1;
+unsigned int     bist_mode:1;
+}MBIST_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     drf_bist_fail_5:1;
+unsigned int     bist_fail_5:1;
+unsigned int     drf_bist_fail_4:1;
+unsigned int     bist_fail_4:1;
+unsigned int     drf_bist_fail_3:1;
+unsigned int     bist_fail_3:1;
+unsigned int     drf_bist_fail_2:1;
+unsigned int     bist_fail_2:1;
+unsigned int     drf_bist_fail_1:1;
+unsigned int     bist_fail_1:1;
+unsigned int     drf_bist_fail_0:1;
+unsigned int     bist_fail_0:1;
+unsigned int     drf_start_pause:1;
+unsigned int     drf_bist_done:1;
+unsigned int     bist_done:1;
+}MBIST_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     en_cp:1;
+unsigned int     en_mcp:1;
+unsigned int     en_cdpu:1;
+unsigned int     reserved_1:5;
+unsigned int     sram_ctr:5;
+unsigned int     idle_ctr:10;
+}PWM_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     write_en3:1;
+unsigned int     stop:1;
+unsigned int     write_en2:1;
+unsigned int     test_mode:2;
+unsigned int     write_en1:1;
+unsigned int     wait_sec:5;
+}RCIC_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_en7:1;
+unsigned int     valid_7:1;
+unsigned int     write_en6:1;
+unsigned int     valid_6:1;
+unsigned int     write_en5:1;
+unsigned int     valid_5:1;
+unsigned int     write_en4:1;
+unsigned int     valid_4:1;
+unsigned int     write_en3:1;
+unsigned int     valid_3:1;
+unsigned int     write_en2:1;
+unsigned int     valid_2:1;
+unsigned int     write_en1:1;
+unsigned int     valid_1:1;
+unsigned int     write_en0:1;
+unsigned int     valid_0:1;
+}RCIC_ENTR_VLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     entry:3;
+unsigned int     done:1;
+}RCIC_STATUS;
+
+typedef struct 
+{
+unsigned int     adr:32;
+}RCIC_ENTR_SRC;
+
+typedef struct 
+{
+unsigned int     adr:32;
+}RCIC_ENTR_DST;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     rcic_bc:1;
+unsigned int     int_en:1;
+}RCIC_INT_EN;
+
+#endif
+
+#define MCP_CTRL                                                                     0x18015100
+#define MCP_CTRL_reg_addr                                                            "0xB8015100"
+#define MCP_CTRL_reg                                                                 0xB8015100
+#define set_MCP_CTRL_reg(data)   (*((volatile unsigned int*) MCP_CTRL_reg)=data)
+#define get_MCP_CTRL_reg   (*((volatile unsigned int*) MCP_CTRL_reg))
+#define MCP_CTRL_inst_adr                                                            "0x0040"
+#define MCP_CTRL_inst                                                                0x0040
+#define MCP_CTRL_arb_mode_shift                                                      (6)
+#define MCP_CTRL_arb_mode_mask                                                       (0x00000040)
+#define MCP_CTRL_arb_mode(data)                                                      (0x00000040&((data)<<6))
+#define MCP_CTRL_arb_mode_src(data)                                                  ((0x00000040&(data))>>6)
+#define MCP_CTRL_get_arb_mode(data)                                                  ((0x00000040&(data))>>6)
+#define MCP_CTRL_clear_shift                                                         (4)
+#define MCP_CTRL_clear_mask                                                          (0x00000010)
+#define MCP_CTRL_clear(data)                                                         (0x00000010&((data)<<4))
+#define MCP_CTRL_clear_src(data)                                                     ((0x00000010&(data))>>4)
+#define MCP_CTRL_get_clear(data)                                                     ((0x00000010&(data))>>4)
+#define MCP_CTRL_swap_shift                                                          (3)
+#define MCP_CTRL_swap_mask                                                           (0x00000008)
+#define MCP_CTRL_swap(data)                                                          (0x00000008&((data)<<3))
+#define MCP_CTRL_swap_src(data)                                                      ((0x00000008&(data))>>3)
+#define MCP_CTRL_get_swap(data)                                                      ((0x00000008&(data))>>3)
+#define MCP_CTRL_idle_shift                                                          (2)
+#define MCP_CTRL_idle_mask                                                           (0x00000004)
+#define MCP_CTRL_idle(data)                                                          (0x00000004&((data)<<2))
+#define MCP_CTRL_idle_src(data)                                                      ((0x00000004&(data))>>2)
+#define MCP_CTRL_get_idle(data)                                                      ((0x00000004&(data))>>2)
+#define MCP_CTRL_go_shift                                                            (1)
+#define MCP_CTRL_go_mask                                                             (0x00000002)
+#define MCP_CTRL_go(data)                                                            (0x00000002&((data)<<1))
+#define MCP_CTRL_go_src(data)                                                        ((0x00000002&(data))>>1)
+#define MCP_CTRL_get_go(data)                                                        ((0x00000002&(data))>>1)
+#define MCP_CTRL_write_data_shift                                                    (0)
+#define MCP_CTRL_write_data_mask                                                     (0x00000001)
+#define MCP_CTRL_write_data(data)                                                    (0x00000001&((data)<<0))
+#define MCP_CTRL_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define MCP_CTRL_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define MCP_STATUS                                                                   0x18015104
+#define MCP_STATUS_reg_addr                                                          "0xB8015104"
+#define MCP_STATUS_reg                                                               0xB8015104
+#define set_MCP_STATUS_reg(data)   (*((volatile unsigned int*) MCP_STATUS_reg)=data)
+#define get_MCP_STATUS_reg   (*((volatile unsigned int*) MCP_STATUS_reg))
+#define MCP_STATUS_inst_adr                                                          "0x0041"
+#define MCP_STATUS_inst                                                              0x0041
+#define MCP_STATUS_scramble_region_shift                                             (27)
+#define MCP_STATUS_scramble_region_mask                                              (0x08000000)
+#define MCP_STATUS_scramble_region(data)                                             (0x08000000&((data)<<27))
+#define MCP_STATUS_scramble_region_src(data)                                         ((0x08000000&(data))>>27)
+#define MCP_STATUS_get_scramble_region(data)                                         ((0x08000000&(data))>>27)
+#define MCP_STATUS_security_region_shift                                             (26)
+#define MCP_STATUS_security_region_mask                                              (0x04000000)
+#define MCP_STATUS_security_region(data)                                             (0x04000000&((data)<<26))
+#define MCP_STATUS_security_region_src(data)                                         ((0x04000000&(data))>>26)
+#define MCP_STATUS_get_security_region(data)                                         ((0x04000000&(data))>>26)
+#define MCP_STATUS_tm_out_wr_shift                                                   (25)
+#define MCP_STATUS_tm_out_wr_mask                                                    (0x02000000)
+#define MCP_STATUS_tm_out_wr(data)                                                   (0x02000000&((data)<<25))
+#define MCP_STATUS_tm_out_wr_src(data)                                               ((0x02000000&(data))>>25)
+#define MCP_STATUS_get_tm_out_wr(data)                                               ((0x02000000&(data))>>25)
+#define MCP_STATUS_tm_out_rd_shift                                                   (24)
+#define MCP_STATUS_tm_out_rd_mask                                                    (0x01000000)
+#define MCP_STATUS_tm_out_rd(data)                                                   (0x01000000&((data)<<24))
+#define MCP_STATUS_tm_out_rd_src(data)                                               ((0x01000000&(data))>>24)
+#define MCP_STATUS_get_tm_out_rd(data)                                               ((0x01000000&(data))>>24)
+#define MCP_STATUS_bc_not_empty_shift                                                (23)
+#define MCP_STATUS_bc_not_empty_mask                                                 (0x00800000)
+#define MCP_STATUS_bc_not_empty(data)                                                (0x00800000&((data)<<23))
+#define MCP_STATUS_bc_not_empty_src(data)                                            ((0x00800000&(data))>>23)
+#define MCP_STATUS_get_bc_not_empty(data)                                            ((0x00800000&(data))>>23)
+#define MCP_STATUS_pc_range_err_shift                                                (22)
+#define MCP_STATUS_pc_range_err_mask                                                 (0x00400000)
+#define MCP_STATUS_pc_range_err(data)                                                (0x00400000&((data)<<22))
+#define MCP_STATUS_pc_range_err_src(data)                                            ((0x00400000&(data))>>22)
+#define MCP_STATUS_get_pc_range_err(data)                                            ((0x00400000&(data))>>22)
+#define MCP_STATUS_err_reg_shift                                                     (21)
+#define MCP_STATUS_err_reg_mask                                                      (0x00200000)
+#define MCP_STATUS_err_reg(data)                                                     (0x00200000&((data)<<21))
+#define MCP_STATUS_err_reg_src(data)                                                 ((0x00200000&(data))>>21)
+#define MCP_STATUS_get_err_reg(data)                                                 ((0x00200000&(data))>>21)
+#define MCP_STATUS_mc_dec_err_shift                                                  (20)
+#define MCP_STATUS_mc_dec_err_mask                                                   (0x00100000)
+#define MCP_STATUS_mc_dec_err(data)                                                  (0x00100000&((data)<<20))
+#define MCP_STATUS_mc_dec_err_src(data)                                              ((0x00100000&(data))>>20)
+#define MCP_STATUS_get_mc_dec_err(data)                                              ((0x00100000&(data))>>20)
+#define MCP_STATUS_pp_w_err_shift                                                    (19)
+#define MCP_STATUS_pp_w_err_mask                                                     (0x00080000)
+#define MCP_STATUS_pp_w_err(data)                                                    (0x00080000&((data)<<19))
+#define MCP_STATUS_pp_w_err_src(data)                                                ((0x00080000&(data))>>19)
+#define MCP_STATUS_get_pp_w_err(data)                                                ((0x00080000&(data))>>19)
+#define MCP_STATUS_pp_r_err_shift                                                    (18)
+#define MCP_STATUS_pp_r_err_mask                                                     (0x00040000)
+#define MCP_STATUS_pp_r_err(data)                                                    (0x00040000&((data)<<18))
+#define MCP_STATUS_pp_r_err_src(data)                                                ((0x00040000&(data))>>18)
+#define MCP_STATUS_get_pp_r_err(data)                                                ((0x00040000&(data))>>18)
+#define MCP_STATUS_pp_ov_shift                                                       (17)
+#define MCP_STATUS_pp_ov_mask                                                        (0x00020000)
+#define MCP_STATUS_pp_ov(data)                                                       (0x00020000&((data)<<17))
+#define MCP_STATUS_pp_ov_src(data)                                                   ((0x00020000&(data))>>17)
+#define MCP_STATUS_get_pp_ov(data)                                                   ((0x00020000&(data))>>17)
+#define MCP_STATUS_pp_mode_err_shift                                                 (16)
+#define MCP_STATUS_pp_mode_err_mask                                                  (0x00010000)
+#define MCP_STATUS_pp_mode_err(data)                                                 (0x00010000&((data)<<16))
+#define MCP_STATUS_pp_mode_err_src(data)                                             ((0x00010000&(data))>>16)
+#define MCP_STATUS_get_pp_mode_err(data)                                             ((0x00010000&(data))>>16)
+#define MCP_STATUS_k_mcp_error_shift                                                 (10)
+#define MCP_STATUS_k_mcp_error_mask                                                  (0x00000400)
+#define MCP_STATUS_k_mcp_error(data)                                                 (0x00000400&((data)<<10))
+#define MCP_STATUS_k_mcp_error_src(data)                                             ((0x00000400&(data))>>10)
+#define MCP_STATUS_get_k_mcp_error(data)                                             ((0x00000400&(data))>>10)
+#define MCP_STATUS_k_error_shift                                                     (9)
+#define MCP_STATUS_k_error_mask                                                      (0x00000200)
+#define MCP_STATUS_k_error(data)                                                     (0x00000200&((data)<<9))
+#define MCP_STATUS_k_error_src(data)                                                 ((0x00000200&(data))>>9)
+#define MCP_STATUS_get_k_error(data)                                                 ((0x00000200&(data))>>9)
+#define MCP_STATUS_k_compare_shift                                                   (8)
+#define MCP_STATUS_k_compare_mask                                                    (0x00000100)
+#define MCP_STATUS_k_compare(data)                                                   (0x00000100&((data)<<8))
+#define MCP_STATUS_k_compare_src(data)                                               ((0x00000100&(data))>>8)
+#define MCP_STATUS_get_k_compare(data)                                               ((0x00000100&(data))>>8)
+#define MCP_STATUS_k_ring_empty_shift                                                (7)
+#define MCP_STATUS_k_ring_empty_mask                                                 (0x00000080)
+#define MCP_STATUS_k_ring_empty(data)                                                (0x00000080&((data)<<7))
+#define MCP_STATUS_k_ring_empty_src(data)                                            ((0x00000080&(data))>>7)
+#define MCP_STATUS_get_k_ring_empty(data)                                            ((0x00000080&(data))>>7)
+#define MCP_STATUS_mcp_error_shift                                                   (6)
+#define MCP_STATUS_mcp_error_mask                                                    (0x00000040)
+#define MCP_STATUS_mcp_error(data)                                                   (0x00000040&((data)<<6))
+#define MCP_STATUS_mcp_error_src(data)                                               ((0x00000040&(data))>>6)
+#define MCP_STATUS_get_mcp_error(data)                                               ((0x00000040&(data))>>6)
+#define MCP_STATUS_compare_shift                                                     (3)
+#define MCP_STATUS_compare_mask                                                      (0x00000008)
+#define MCP_STATUS_compare(data)                                                     (0x00000008&((data)<<3))
+#define MCP_STATUS_compare_src(data)                                                 ((0x00000008&(data))>>3)
+#define MCP_STATUS_get_compare(data)                                                 ((0x00000008&(data))>>3)
+#define MCP_STATUS_error_shift                                                       (2)
+#define MCP_STATUS_error_mask                                                        (0x00000004)
+#define MCP_STATUS_error(data)                                                       (0x00000004&((data)<<2))
+#define MCP_STATUS_error_src(data)                                                   ((0x00000004&(data))>>2)
+#define MCP_STATUS_get_error(data)                                                   ((0x00000004&(data))>>2)
+#define MCP_STATUS_ring_empty_shift                                                  (1)
+#define MCP_STATUS_ring_empty_mask                                                   (0x00000002)
+#define MCP_STATUS_ring_empty(data)                                                  (0x00000002&((data)<<1))
+#define MCP_STATUS_ring_empty_src(data)                                              ((0x00000002&(data))>>1)
+#define MCP_STATUS_get_ring_empty(data)                                              ((0x00000002&(data))>>1)
+#define MCP_STATUS_write_data_shift                                                  (0)
+#define MCP_STATUS_write_data_mask                                                   (0x00000001)
+#define MCP_STATUS_write_data(data)                                                  (0x00000001&((data)<<0))
+#define MCP_STATUS_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define MCP_STATUS_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MCP_EN                                                                       0x18015108
+#define MCP_EN_reg_addr                                                              "0xB8015108"
+#define MCP_EN_reg                                                                   0xB8015108
+#define set_MCP_EN_reg(data)   (*((volatile unsigned int*) MCP_EN_reg)=data)
+#define get_MCP_EN_reg   (*((volatile unsigned int*) MCP_EN_reg))
+#define MCP_EN_inst_adr                                                              "0x0042"
+#define MCP_EN_inst                                                                  0x0042
+#define MCP_EN_scramble_region_en_shift                                              (8)
+#define MCP_EN_scramble_region_en_mask                                               (0x00000100)
+#define MCP_EN_scramble_region_en(data)                                              (0x00000100&((data)<<8))
+#define MCP_EN_scramble_region_en_src(data)                                          ((0x00000100&(data))>>8)
+#define MCP_EN_get_scramble_region_en(data)                                          ((0x00000100&(data))>>8)
+#define MCP_EN_cdpu_isr_en_shift                                                     (7)
+#define MCP_EN_cdpu_isr_en_mask                                                      (0x00000080)
+#define MCP_EN_cdpu_isr_en(data)                                                     (0x00000080&((data)<<7))
+#define MCP_EN_cdpu_isr_en_src(data)                                                 ((0x00000080&(data))>>7)
+#define MCP_EN_get_cdpu_isr_en(data)                                                 ((0x00000080&(data))>>7)
+#define MCP_EN_mcp_error_en_shift                                                    (6)
+#define MCP_EN_mcp_error_en_mask                                                     (0x00000040)
+#define MCP_EN_mcp_error_en(data)                                                    (0x00000040&((data)<<6))
+#define MCP_EN_mcp_error_en_src(data)                                                ((0x00000040&(data))>>6)
+#define MCP_EN_get_mcp_error_en(data)                                                ((0x00000040&(data))>>6)
+#define MCP_EN_compare_en_shift                                                      (3)
+#define MCP_EN_compare_en_mask                                                       (0x00000008)
+#define MCP_EN_compare_en(data)                                                      (0x00000008&((data)<<3))
+#define MCP_EN_compare_en_src(data)                                                  ((0x00000008&(data))>>3)
+#define MCP_EN_get_compare_en(data)                                                  ((0x00000008&(data))>>3)
+#define MCP_EN_error_en_shift                                                        (2)
+#define MCP_EN_error_en_mask                                                         (0x00000004)
+#define MCP_EN_error_en(data)                                                        (0x00000004&((data)<<2))
+#define MCP_EN_error_en_src(data)                                                    ((0x00000004&(data))>>2)
+#define MCP_EN_get_error_en(data)                                                    ((0x00000004&(data))>>2)
+#define MCP_EN_ring_empty_en_shift                                                   (1)
+#define MCP_EN_ring_empty_en_mask                                                    (0x00000002)
+#define MCP_EN_ring_empty_en(data)                                                   (0x00000002&((data)<<1))
+#define MCP_EN_ring_empty_en_src(data)                                               ((0x00000002&(data))>>1)
+#define MCP_EN_get_ring_empty_en(data)                                               ((0x00000002&(data))>>1)
+#define MCP_EN_write_data_shift                                                      (0)
+#define MCP_EN_write_data_mask                                                       (0x00000001)
+#define MCP_EN_write_data(data)                                                      (0x00000001&((data)<<0))
+#define MCP_EN_write_data_src(data)                                                  ((0x00000001&(data))>>0)
+#define MCP_EN_get_write_data(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define MCP_CTRL1                                                                    0x18015198
+#define MCP_CTRL1_reg_addr                                                           "0xB8015198"
+#define MCP_CTRL1_reg                                                                0xB8015198
+#define set_MCP_CTRL1_reg(data)   (*((volatile unsigned int*) MCP_CTRL1_reg)=data)
+#define get_MCP_CTRL1_reg   (*((volatile unsigned int*) MCP_CTRL1_reg))
+#define MCP_CTRL1_inst_adr                                                           "0x0066"
+#define MCP_CTRL1_inst                                                               0x0066
+#define MCP_CTRL1_aesh_pad_off_shift                                                 (10)
+#define MCP_CTRL1_aesh_pad_off_mask                                                  (0x00000400)
+#define MCP_CTRL1_aesh_pad_off(data)                                                 (0x00000400&((data)<<10))
+#define MCP_CTRL1_aesh_pad_off_src(data)                                             ((0x00000400&(data))>>10)
+#define MCP_CTRL1_get_aesh_pad_off(data)                                             ((0x00000400&(data))>>10)
+#define MCP_CTRL1_csa_entropy_shift                                                  (8)
+#define MCP_CTRL1_csa_entropy_mask                                                   (0x00000300)
+#define MCP_CTRL1_csa_entropy(data)                                                  (0x00000300&((data)<<8))
+#define MCP_CTRL1_csa_entropy_src(data)                                              ((0x00000300&(data))>>8)
+#define MCP_CTRL1_get_csa_entropy(data)                                              ((0x00000300&(data))>>8)
+#define MCP_CTRL1_mcp_round_no_shift                                                 (0)
+#define MCP_CTRL1_mcp_round_no_mask                                                  (0x000000FF)
+#define MCP_CTRL1_mcp_round_no(data)                                                 (0x000000FF&((data)<<0))
+#define MCP_CTRL1_mcp_round_no_src(data)                                             ((0x000000FF&(data))>>0)
+#define MCP_CTRL1_get_mcp_round_no(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define MCP_BASE                                                                     0x1801510C
+#define MCP_BASE_reg_addr                                                            "0xB801510C"
+#define MCP_BASE_reg                                                                 0xB801510C
+#define set_MCP_BASE_reg(data)   (*((volatile unsigned int*) MCP_BASE_reg)=data)
+#define get_MCP_BASE_reg   (*((volatile unsigned int*) MCP_BASE_reg))
+#define MCP_BASE_inst_adr                                                            "0x0043"
+#define MCP_BASE_inst                                                                0x0043
+#define MCP_BASE_base_shift                                                          (0)
+#define MCP_BASE_base_mask                                                           (0x7FFFFFFF)
+#define MCP_BASE_base(data)                                                          (0x7FFFFFFF&((data)<<0))
+#define MCP_BASE_base_src(data)                                                      ((0x7FFFFFFF&(data))>>0)
+#define MCP_BASE_get_base(data)                                                      ((0x7FFFFFFF&(data))>>0)
+
+
+#define MCP_LIMIT                                                                    0x18015110
+#define MCP_LIMIT_reg_addr                                                           "0xB8015110"
+#define MCP_LIMIT_reg                                                                0xB8015110
+#define set_MCP_LIMIT_reg(data)   (*((volatile unsigned int*) MCP_LIMIT_reg)=data)
+#define get_MCP_LIMIT_reg   (*((volatile unsigned int*) MCP_LIMIT_reg))
+#define MCP_LIMIT_inst_adr                                                           "0x0044"
+#define MCP_LIMIT_inst                                                               0x0044
+#define MCP_LIMIT_limit_shift                                                        (0)
+#define MCP_LIMIT_limit_mask                                                         (0x7FFFFFFF)
+#define MCP_LIMIT_limit(data)                                                        (0x7FFFFFFF&((data)<<0))
+#define MCP_LIMIT_limit_src(data)                                                    ((0x7FFFFFFF&(data))>>0)
+#define MCP_LIMIT_get_limit(data)                                                    ((0x7FFFFFFF&(data))>>0)
+
+
+#define MCP_RDPTR                                                                    0x18015114
+#define MCP_RDPTR_reg_addr                                                           "0xB8015114"
+#define MCP_RDPTR_reg                                                                0xB8015114
+#define set_MCP_RDPTR_reg(data)   (*((volatile unsigned int*) MCP_RDPTR_reg)=data)
+#define get_MCP_RDPTR_reg   (*((volatile unsigned int*) MCP_RDPTR_reg))
+#define MCP_RDPTR_inst_adr                                                           "0x0045"
+#define MCP_RDPTR_inst                                                               0x0045
+#define MCP_RDPTR_rdptr_shift                                                        (0)
+#define MCP_RDPTR_rdptr_mask                                                         (0x7FFFFFFF)
+#define MCP_RDPTR_rdptr(data)                                                        (0x7FFFFFFF&((data)<<0))
+#define MCP_RDPTR_rdptr_src(data)                                                    ((0x7FFFFFFF&(data))>>0)
+#define MCP_RDPTR_get_rdptr(data)                                                    ((0x7FFFFFFF&(data))>>0)
+
+
+#define MCP_WRPTR                                                                    0x18015118
+#define MCP_WRPTR_reg_addr                                                           "0xB8015118"
+#define MCP_WRPTR_reg                                                                0xB8015118
+#define set_MCP_WRPTR_reg(data)   (*((volatile unsigned int*) MCP_WRPTR_reg)=data)
+#define get_MCP_WRPTR_reg   (*((volatile unsigned int*) MCP_WRPTR_reg))
+#define MCP_WRPTR_inst_adr                                                           "0x0046"
+#define MCP_WRPTR_inst                                                               0x0046
+#define MCP_WRPTR_wrptr_shift                                                        (0)
+#define MCP_WRPTR_wrptr_mask                                                         (0x7FFFFFFF)
+#define MCP_WRPTR_wrptr(data)                                                        (0x7FFFFFFF&((data)<<0))
+#define MCP_WRPTR_wrptr_src(data)                                                    ((0x7FFFFFFF&(data))>>0)
+#define MCP_WRPTR_get_wrptr(data)                                                    ((0x7FFFFFFF&(data))>>0)
+
+
+#define MCP_DES_COUNT                                                                0x18015134
+#define MCP_DES_COUNT_reg_addr                                                       "0xB8015134"
+#define MCP_DES_COUNT_reg                                                            0xB8015134
+#define set_MCP_DES_COUNT_reg(data)   (*((volatile unsigned int*) MCP_DES_COUNT_reg)=data)
+#define get_MCP_DES_COUNT_reg   (*((volatile unsigned int*) MCP_DES_COUNT_reg))
+#define MCP_DES_COUNT_inst_adr                                                       "0x004D"
+#define MCP_DES_COUNT_inst                                                           0x004D
+#define MCP_DES_COUNT_count_shift                                                    (0)
+#define MCP_DES_COUNT_count_mask                                                     (0x0000FFFF)
+#define MCP_DES_COUNT_count(data)                                                    (0x0000FFFF&((data)<<0))
+#define MCP_DES_COUNT_count_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define MCP_DES_COUNT_get_count(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define MCP_DES_COMPARE                                                              0x18015138
+#define MCP_DES_COMPARE_reg_addr                                                     "0xB8015138"
+#define MCP_DES_COMPARE_reg                                                          0xB8015138
+#define set_MCP_DES_COMPARE_reg(data)   (*((volatile unsigned int*) MCP_DES_COMPARE_reg)=data)
+#define get_MCP_DES_COMPARE_reg   (*((volatile unsigned int*) MCP_DES_COMPARE_reg))
+#define MCP_DES_COMPARE_inst_adr                                                     "0x004E"
+#define MCP_DES_COMPARE_inst                                                         0x004E
+#define MCP_DES_COMPARE_compare_shift                                                (0)
+#define MCP_DES_COMPARE_compare_mask                                                 (0x0000FFFF)
+#define MCP_DES_COMPARE_compare(data)                                                (0x0000FFFF&((data)<<0))
+#define MCP_DES_COMPARE_compare_src(data)                                            ((0x0000FFFF&(data))>>0)
+#define MCP_DES_COMPARE_get_compare(data)                                            ((0x0000FFFF&(data))>>0)
+
+
+#define MCP_DES_INI_KEY_0                                                            0x1801511C
+#define MCP_DES_INI_KEY_1                                                            0x18015120
+#define MCP_DES_INI_KEY_0_reg_addr                                                   "0xB801511C"
+#define MCP_DES_INI_KEY_1_reg_addr                                                   "0xB8015120"
+#define MCP_DES_INI_KEY_0_reg                                                        0xB801511C
+#define MCP_DES_INI_KEY_1_reg                                                        0xB8015120
+#define set_MCP_DES_INI_KEY_0_reg(data)   (*((volatile unsigned int*) MCP_DES_INI_KEY_0_reg)=data)
+#define set_MCP_DES_INI_KEY_1_reg(data)   (*((volatile unsigned int*) MCP_DES_INI_KEY_1_reg)=data)
+#define get_MCP_DES_INI_KEY_0_reg   (*((volatile unsigned int*) MCP_DES_INI_KEY_0_reg))
+#define get_MCP_DES_INI_KEY_1_reg   (*((volatile unsigned int*) MCP_DES_INI_KEY_1_reg))
+#define MCP_DES_INI_KEY_0_inst_adr                                                   "0x0047"
+#define MCP_DES_INI_KEY_1_inst_adr                                                   "0x0048"
+#define MCP_DES_INI_KEY_0_inst                                                       0x0047
+#define MCP_DES_INI_KEY_1_inst                                                       0x0048
+#define MCP_DES_INI_KEY_data_shift                                                   (0)
+#define MCP_DES_INI_KEY_data_mask                                                    (0xFFFFFFFF)
+#define MCP_DES_INI_KEY_data(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define MCP_DES_INI_KEY_data_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define MCP_DES_INI_KEY_get_data(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define MCP_AES_INI_KEY_0                                                            0x18015124
+#define MCP_AES_INI_KEY_1                                                            0x18015128
+#define MCP_AES_INI_KEY_2                                                            0x1801512C
+#define MCP_AES_INI_KEY_3                                                            0x18015130
+#define MCP_AES_INI_KEY_0_reg_addr                                                   "0xB8015124"
+#define MCP_AES_INI_KEY_1_reg_addr                                                   "0xB8015128"
+#define MCP_AES_INI_KEY_2_reg_addr                                                   "0xB801512C"
+#define MCP_AES_INI_KEY_3_reg_addr                                                   "0xB8015130"
+#define MCP_AES_INI_KEY_0_reg                                                        0xB8015124
+#define MCP_AES_INI_KEY_1_reg                                                        0xB8015128
+#define MCP_AES_INI_KEY_2_reg                                                        0xB801512C
+#define MCP_AES_INI_KEY_3_reg                                                        0xB8015130
+#define set_MCP_AES_INI_KEY_0_reg(data)   (*((volatile unsigned int*) MCP_AES_INI_KEY_0_reg)=data)
+#define set_MCP_AES_INI_KEY_1_reg(data)   (*((volatile unsigned int*) MCP_AES_INI_KEY_1_reg)=data)
+#define set_MCP_AES_INI_KEY_2_reg(data)   (*((volatile unsigned int*) MCP_AES_INI_KEY_2_reg)=data)
+#define set_MCP_AES_INI_KEY_3_reg(data)   (*((volatile unsigned int*) MCP_AES_INI_KEY_3_reg)=data)
+#define get_MCP_AES_INI_KEY_0_reg   (*((volatile unsigned int*) MCP_AES_INI_KEY_0_reg))
+#define get_MCP_AES_INI_KEY_1_reg   (*((volatile unsigned int*) MCP_AES_INI_KEY_1_reg))
+#define get_MCP_AES_INI_KEY_2_reg   (*((volatile unsigned int*) MCP_AES_INI_KEY_2_reg))
+#define get_MCP_AES_INI_KEY_3_reg   (*((volatile unsigned int*) MCP_AES_INI_KEY_3_reg))
+#define MCP_AES_INI_KEY_0_inst_adr                                                   "0x0049"
+#define MCP_AES_INI_KEY_1_inst_adr                                                   "0x004A"
+#define MCP_AES_INI_KEY_2_inst_adr                                                   "0x004B"
+#define MCP_AES_INI_KEY_3_inst_adr                                                   "0x004C"
+#define MCP_AES_INI_KEY_0_inst                                                       0x0049
+#define MCP_AES_INI_KEY_1_inst                                                       0x004A
+#define MCP_AES_INI_KEY_2_inst                                                       0x004B
+#define MCP_AES_INI_KEY_3_inst                                                       0x004C
+#define MCP_AES_INI_KEY_data_shift                                                   (0)
+#define MCP_AES_INI_KEY_data_mask                                                    (0xFFFFFFFF)
+#define MCP_AES_INI_KEY_data(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define MCP_AES_INI_KEY_data_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define MCP_AES_INI_KEY_get_data(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define MCP_MULTI2_SYS_KEY_0                                                         0x18015178
+#define MCP_MULTI2_SYS_KEY_1                                                         0x1801517C
+#define MCP_MULTI2_SYS_KEY_2                                                         0x18015180
+#define MCP_MULTI2_SYS_KEY_3                                                         0x18015184
+#define MCP_MULTI2_SYS_KEY_4                                                         0x18015188
+#define MCP_MULTI2_SYS_KEY_5                                                         0x1801518C
+#define MCP_MULTI2_SYS_KEY_6                                                         0x18015190
+#define MCP_MULTI2_SYS_KEY_7                                                         0x18015194
+#define MCP_MULTI2_SYS_KEY_0_reg_addr                                                "0xB8015178"
+#define MCP_MULTI2_SYS_KEY_1_reg_addr                                                "0xB801517C"
+#define MCP_MULTI2_SYS_KEY_2_reg_addr                                                "0xB8015180"
+#define MCP_MULTI2_SYS_KEY_3_reg_addr                                                "0xB8015184"
+#define MCP_MULTI2_SYS_KEY_4_reg_addr                                                "0xB8015188"
+#define MCP_MULTI2_SYS_KEY_5_reg_addr                                                "0xB801518C"
+#define MCP_MULTI2_SYS_KEY_6_reg_addr                                                "0xB8015190"
+#define MCP_MULTI2_SYS_KEY_7_reg_addr                                                "0xB8015194"
+#define MCP_MULTI2_SYS_KEY_0_reg                                                     0xB8015178
+#define MCP_MULTI2_SYS_KEY_1_reg                                                     0xB801517C
+#define MCP_MULTI2_SYS_KEY_2_reg                                                     0xB8015180
+#define MCP_MULTI2_SYS_KEY_3_reg                                                     0xB8015184
+#define MCP_MULTI2_SYS_KEY_4_reg                                                     0xB8015188
+#define MCP_MULTI2_SYS_KEY_5_reg                                                     0xB801518C
+#define MCP_MULTI2_SYS_KEY_6_reg                                                     0xB8015190
+#define MCP_MULTI2_SYS_KEY_7_reg                                                     0xB8015194
+#define set_MCP_MULTI2_SYS_KEY_0_reg(data)   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_0_reg)=data)
+#define set_MCP_MULTI2_SYS_KEY_1_reg(data)   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_1_reg)=data)
+#define set_MCP_MULTI2_SYS_KEY_2_reg(data)   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_2_reg)=data)
+#define set_MCP_MULTI2_SYS_KEY_3_reg(data)   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_3_reg)=data)
+#define set_MCP_MULTI2_SYS_KEY_4_reg(data)   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_4_reg)=data)
+#define set_MCP_MULTI2_SYS_KEY_5_reg(data)   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_5_reg)=data)
+#define set_MCP_MULTI2_SYS_KEY_6_reg(data)   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_6_reg)=data)
+#define set_MCP_MULTI2_SYS_KEY_7_reg(data)   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_7_reg)=data)
+#define get_MCP_MULTI2_SYS_KEY_0_reg   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_0_reg))
+#define get_MCP_MULTI2_SYS_KEY_1_reg   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_1_reg))
+#define get_MCP_MULTI2_SYS_KEY_2_reg   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_2_reg))
+#define get_MCP_MULTI2_SYS_KEY_3_reg   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_3_reg))
+#define get_MCP_MULTI2_SYS_KEY_4_reg   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_4_reg))
+#define get_MCP_MULTI2_SYS_KEY_5_reg   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_5_reg))
+#define get_MCP_MULTI2_SYS_KEY_6_reg   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_6_reg))
+#define get_MCP_MULTI2_SYS_KEY_7_reg   (*((volatile unsigned int*) MCP_MULTI2_SYS_KEY_7_reg))
+#define MCP_MULTI2_SYS_KEY_0_inst_adr                                                "0x005E"
+#define MCP_MULTI2_SYS_KEY_1_inst_adr                                                "0x005F"
+#define MCP_MULTI2_SYS_KEY_2_inst_adr                                                "0x0060"
+#define MCP_MULTI2_SYS_KEY_3_inst_adr                                                "0x0061"
+#define MCP_MULTI2_SYS_KEY_4_inst_adr                                                "0x0062"
+#define MCP_MULTI2_SYS_KEY_5_inst_adr                                                "0x0063"
+#define MCP_MULTI2_SYS_KEY_6_inst_adr                                                "0x0064"
+#define MCP_MULTI2_SYS_KEY_7_inst_adr                                                "0x0065"
+#define MCP_MULTI2_SYS_KEY_0_inst                                                    0x005E
+#define MCP_MULTI2_SYS_KEY_1_inst                                                    0x005F
+#define MCP_MULTI2_SYS_KEY_2_inst                                                    0x0060
+#define MCP_MULTI2_SYS_KEY_3_inst                                                    0x0061
+#define MCP_MULTI2_SYS_KEY_4_inst                                                    0x0062
+#define MCP_MULTI2_SYS_KEY_5_inst                                                    0x0063
+#define MCP_MULTI2_SYS_KEY_6_inst                                                    0x0064
+#define MCP_MULTI2_SYS_KEY_7_inst                                                    0x0065
+#define MCP_MULTI2_SYS_KEY_data_shift                                                (0)
+#define MCP_MULTI2_SYS_KEY_data_mask                                                 (0xFFFFFFFF)
+#define MCP_MULTI2_SYS_KEY_data(data)                                                (0xFFFFFFFF&((data)<<0))
+#define MCP_MULTI2_SYS_KEY_data_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define MCP_MULTI2_SYS_KEY_get_data(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define CP_OTP_LOAD                                                                  0x1801519C
+#define CP_OTP_LOAD_reg_addr                                                         "0xB801519C"
+#define CP_OTP_LOAD_reg                                                              0xB801519C
+#define set_CP_OTP_LOAD_reg(data)   (*((volatile unsigned int*) CP_OTP_LOAD_reg)=data)
+#define get_CP_OTP_LOAD_reg   (*((volatile unsigned int*) CP_OTP_LOAD_reg))
+#define CP_OTP_LOAD_inst_adr                                                         "0x0067"
+#define CP_OTP_LOAD_inst                                                             0x0067
+#define CP_OTP_LOAD_otp_load_shift                                                   (0)
+#define CP_OTP_LOAD_otp_load_mask                                                    (0x00000001)
+#define CP_OTP_LOAD_otp_load(data)                                                   (0x00000001&((data)<<0))
+#define CP_OTP_LOAD_otp_load_src(data)                                               ((0x00000001&(data))>>0)
+#define CP_OTP_LOAD_get_otp_load(data)                                               ((0x00000001&(data))>>0)
+
+
+#define K_MCP_CTRL                                                                   0x18015900
+#define K_MCP_CTRL_reg_addr                                                          "0xB8015900"
+#define K_MCP_CTRL_reg                                                               0xB8015900
+#define set_K_MCP_CTRL_reg(data)   (*((volatile unsigned int*) K_MCP_CTRL_reg)=data)
+#define get_K_MCP_CTRL_reg   (*((volatile unsigned int*) K_MCP_CTRL_reg))
+#define K_MCP_CTRL_inst_adr                                                          "0x0040"
+#define K_MCP_CTRL_inst                                                              0x0040
+#define K_MCP_CTRL_clear_shift                                                       (4)
+#define K_MCP_CTRL_clear_mask                                                        (0x00000010)
+#define K_MCP_CTRL_clear(data)                                                       (0x00000010&((data)<<4))
+#define K_MCP_CTRL_clear_src(data)                                                   ((0x00000010&(data))>>4)
+#define K_MCP_CTRL_get_clear(data)                                                   ((0x00000010&(data))>>4)
+#define K_MCP_CTRL_swap_shift                                                        (3)
+#define K_MCP_CTRL_swap_mask                                                         (0x00000008)
+#define K_MCP_CTRL_swap(data)                                                        (0x00000008&((data)<<3))
+#define K_MCP_CTRL_swap_src(data)                                                    ((0x00000008&(data))>>3)
+#define K_MCP_CTRL_get_swap(data)                                                    ((0x00000008&(data))>>3)
+#define K_MCP_CTRL_idle_shift                                                        (2)
+#define K_MCP_CTRL_idle_mask                                                         (0x00000004)
+#define K_MCP_CTRL_idle(data)                                                        (0x00000004&((data)<<2))
+#define K_MCP_CTRL_idle_src(data)                                                    ((0x00000004&(data))>>2)
+#define K_MCP_CTRL_get_idle(data)                                                    ((0x00000004&(data))>>2)
+#define K_MCP_CTRL_go_shift                                                          (1)
+#define K_MCP_CTRL_go_mask                                                           (0x00000002)
+#define K_MCP_CTRL_go(data)                                                          (0x00000002&((data)<<1))
+#define K_MCP_CTRL_go_src(data)                                                      ((0x00000002&(data))>>1)
+#define K_MCP_CTRL_get_go(data)                                                      ((0x00000002&(data))>>1)
+#define K_MCP_CTRL_write_data_shift                                                  (0)
+#define K_MCP_CTRL_write_data_mask                                                   (0x00000001)
+#define K_MCP_CTRL_write_data(data)                                                  (0x00000001&((data)<<0))
+#define K_MCP_CTRL_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define K_MCP_CTRL_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define K_MCP_STATUS                                                                 0x18015904
+#define K_MCP_STATUS_reg_addr                                                        "0xB8015904"
+#define K_MCP_STATUS_reg                                                             0xB8015904
+#define set_K_MCP_STATUS_reg(data)   (*((volatile unsigned int*) K_MCP_STATUS_reg)=data)
+#define get_K_MCP_STATUS_reg   (*((volatile unsigned int*) K_MCP_STATUS_reg))
+#define K_MCP_STATUS_inst_adr                                                        "0x0041"
+#define K_MCP_STATUS_inst                                                            0x0041
+#define K_MCP_STATUS_scramble_region_shift                                           (27)
+#define K_MCP_STATUS_scramble_region_mask                                            (0x08000000)
+#define K_MCP_STATUS_scramble_region(data)                                           (0x08000000&((data)<<27))
+#define K_MCP_STATUS_scramble_region_src(data)                                       ((0x08000000&(data))>>27)
+#define K_MCP_STATUS_get_scramble_region(data)                                       ((0x08000000&(data))>>27)
+#define K_MCP_STATUS_security_region_shift                                           (26)
+#define K_MCP_STATUS_security_region_mask                                            (0x04000000)
+#define K_MCP_STATUS_security_region(data)                                           (0x04000000&((data)<<26))
+#define K_MCP_STATUS_security_region_src(data)                                       ((0x04000000&(data))>>26)
+#define K_MCP_STATUS_get_security_region(data)                                       ((0x04000000&(data))>>26)
+#define K_MCP_STATUS_tm_out_wr_shift                                                 (25)
+#define K_MCP_STATUS_tm_out_wr_mask                                                  (0x02000000)
+#define K_MCP_STATUS_tm_out_wr(data)                                                 (0x02000000&((data)<<25))
+#define K_MCP_STATUS_tm_out_wr_src(data)                                             ((0x02000000&(data))>>25)
+#define K_MCP_STATUS_get_tm_out_wr(data)                                             ((0x02000000&(data))>>25)
+#define K_MCP_STATUS_tm_out_rd_shift                                                 (24)
+#define K_MCP_STATUS_tm_out_rd_mask                                                  (0x01000000)
+#define K_MCP_STATUS_tm_out_rd(data)                                                 (0x01000000&((data)<<24))
+#define K_MCP_STATUS_tm_out_rd_src(data)                                             ((0x01000000&(data))>>24)
+#define K_MCP_STATUS_get_tm_out_rd(data)                                             ((0x01000000&(data))>>24)
+#define K_MCP_STATUS_bc_not_empty_shift                                              (23)
+#define K_MCP_STATUS_bc_not_empty_mask                                               (0x00800000)
+#define K_MCP_STATUS_bc_not_empty(data)                                              (0x00800000&((data)<<23))
+#define K_MCP_STATUS_bc_not_empty_src(data)                                          ((0x00800000&(data))>>23)
+#define K_MCP_STATUS_get_bc_not_empty(data)                                          ((0x00800000&(data))>>23)
+#define K_MCP_STATUS_pc_range_err_shift                                              (22)
+#define K_MCP_STATUS_pc_range_err_mask                                               (0x00400000)
+#define K_MCP_STATUS_pc_range_err(data)                                              (0x00400000&((data)<<22))
+#define K_MCP_STATUS_pc_range_err_src(data)                                          ((0x00400000&(data))>>22)
+#define K_MCP_STATUS_get_pc_range_err(data)                                          ((0x00400000&(data))>>22)
+#define K_MCP_STATUS_err_reg_shift                                                   (21)
+#define K_MCP_STATUS_err_reg_mask                                                    (0x00200000)
+#define K_MCP_STATUS_err_reg(data)                                                   (0x00200000&((data)<<21))
+#define K_MCP_STATUS_err_reg_src(data)                                               ((0x00200000&(data))>>21)
+#define K_MCP_STATUS_get_err_reg(data)                                               ((0x00200000&(data))>>21)
+#define K_MCP_STATUS_mc_dec_err_shift                                                (20)
+#define K_MCP_STATUS_mc_dec_err_mask                                                 (0x00100000)
+#define K_MCP_STATUS_mc_dec_err(data)                                                (0x00100000&((data)<<20))
+#define K_MCP_STATUS_mc_dec_err_src(data)                                            ((0x00100000&(data))>>20)
+#define K_MCP_STATUS_get_mc_dec_err(data)                                            ((0x00100000&(data))>>20)
+#define K_MCP_STATUS_pp_w_err_shift                                                  (19)
+#define K_MCP_STATUS_pp_w_err_mask                                                   (0x00080000)
+#define K_MCP_STATUS_pp_w_err(data)                                                  (0x00080000&((data)<<19))
+#define K_MCP_STATUS_pp_w_err_src(data)                                              ((0x00080000&(data))>>19)
+#define K_MCP_STATUS_get_pp_w_err(data)                                              ((0x00080000&(data))>>19)
+#define K_MCP_STATUS_pp_r_err_shift                                                  (18)
+#define K_MCP_STATUS_pp_r_err_mask                                                   (0x00040000)
+#define K_MCP_STATUS_pp_r_err(data)                                                  (0x00040000&((data)<<18))
+#define K_MCP_STATUS_pp_r_err_src(data)                                              ((0x00040000&(data))>>18)
+#define K_MCP_STATUS_get_pp_r_err(data)                                              ((0x00040000&(data))>>18)
+#define K_MCP_STATUS_pp_ov_shift                                                     (17)
+#define K_MCP_STATUS_pp_ov_mask                                                      (0x00020000)
+#define K_MCP_STATUS_pp_ov(data)                                                     (0x00020000&((data)<<17))
+#define K_MCP_STATUS_pp_ov_src(data)                                                 ((0x00020000&(data))>>17)
+#define K_MCP_STATUS_get_pp_ov(data)                                                 ((0x00020000&(data))>>17)
+#define K_MCP_STATUS_pp_mode_err_shift                                               (16)
+#define K_MCP_STATUS_pp_mode_err_mask                                                (0x00010000)
+#define K_MCP_STATUS_pp_mode_err(data)                                               (0x00010000&((data)<<16))
+#define K_MCP_STATUS_pp_mode_err_src(data)                                           ((0x00010000&(data))>>16)
+#define K_MCP_STATUS_get_pp_mode_err(data)                                           ((0x00010000&(data))>>16)
+#define K_MCP_STATUS_s_mcp_error_shift                                               (10)
+#define K_MCP_STATUS_s_mcp_error_mask                                                (0x00000400)
+#define K_MCP_STATUS_s_mcp_error(data)                                               (0x00000400&((data)<<10))
+#define K_MCP_STATUS_s_mcp_error_src(data)                                           ((0x00000400&(data))>>10)
+#define K_MCP_STATUS_get_s_mcp_error(data)                                           ((0x00000400&(data))>>10)
+#define K_MCP_STATUS_s_error_shift                                                   (9)
+#define K_MCP_STATUS_s_error_mask                                                    (0x00000200)
+#define K_MCP_STATUS_s_error(data)                                                   (0x00000200&((data)<<9))
+#define K_MCP_STATUS_s_error_src(data)                                               ((0x00000200&(data))>>9)
+#define K_MCP_STATUS_get_s_error(data)                                               ((0x00000200&(data))>>9)
+#define K_MCP_STATUS_s_compare_shift                                                 (8)
+#define K_MCP_STATUS_s_compare_mask                                                  (0x00000100)
+#define K_MCP_STATUS_s_compare(data)                                                 (0x00000100&((data)<<8))
+#define K_MCP_STATUS_s_compare_src(data)                                             ((0x00000100&(data))>>8)
+#define K_MCP_STATUS_get_s_compare(data)                                             ((0x00000100&(data))>>8)
+#define K_MCP_STATUS_s_ring_empty_shift                                              (7)
+#define K_MCP_STATUS_s_ring_empty_mask                                               (0x00000080)
+#define K_MCP_STATUS_s_ring_empty(data)                                              (0x00000080&((data)<<7))
+#define K_MCP_STATUS_s_ring_empty_src(data)                                          ((0x00000080&(data))>>7)
+#define K_MCP_STATUS_get_s_ring_empty(data)                                          ((0x00000080&(data))>>7)
+#define K_MCP_STATUS_mcp_error_shift                                                 (6)
+#define K_MCP_STATUS_mcp_error_mask                                                  (0x00000040)
+#define K_MCP_STATUS_mcp_error(data)                                                 (0x00000040&((data)<<6))
+#define K_MCP_STATUS_mcp_error_src(data)                                             ((0x00000040&(data))>>6)
+#define K_MCP_STATUS_get_mcp_error(data)                                             ((0x00000040&(data))>>6)
+#define K_MCP_STATUS_compare_shift                                                   (3)
+#define K_MCP_STATUS_compare_mask                                                    (0x00000008)
+#define K_MCP_STATUS_compare(data)                                                   (0x00000008&((data)<<3))
+#define K_MCP_STATUS_compare_src(data)                                               ((0x00000008&(data))>>3)
+#define K_MCP_STATUS_get_compare(data)                                               ((0x00000008&(data))>>3)
+#define K_MCP_STATUS_error_shift                                                     (2)
+#define K_MCP_STATUS_error_mask                                                      (0x00000004)
+#define K_MCP_STATUS_error(data)                                                     (0x00000004&((data)<<2))
+#define K_MCP_STATUS_error_src(data)                                                 ((0x00000004&(data))>>2)
+#define K_MCP_STATUS_get_error(data)                                                 ((0x00000004&(data))>>2)
+#define K_MCP_STATUS_ring_empty_shift                                                (1)
+#define K_MCP_STATUS_ring_empty_mask                                                 (0x00000002)
+#define K_MCP_STATUS_ring_empty(data)                                                (0x00000002&((data)<<1))
+#define K_MCP_STATUS_ring_empty_src(data)                                            ((0x00000002&(data))>>1)
+#define K_MCP_STATUS_get_ring_empty(data)                                            ((0x00000002&(data))>>1)
+#define K_MCP_STATUS_write_data_shift                                                (0)
+#define K_MCP_STATUS_write_data_mask                                                 (0x00000001)
+#define K_MCP_STATUS_write_data(data)                                                (0x00000001&((data)<<0))
+#define K_MCP_STATUS_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define K_MCP_STATUS_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define K_MCP_EN                                                                     0x18015908
+#define K_MCP_EN_reg_addr                                                            "0xB8015908"
+#define K_MCP_EN_reg                                                                 0xB8015908
+#define set_K_MCP_EN_reg(data)   (*((volatile unsigned int*) K_MCP_EN_reg)=data)
+#define get_K_MCP_EN_reg   (*((volatile unsigned int*) K_MCP_EN_reg))
+#define K_MCP_EN_inst_adr                                                            "0x0042"
+#define K_MCP_EN_inst                                                                0x0042
+#define K_MCP_EN_security_region_en_shift                                            (8)
+#define K_MCP_EN_security_region_en_mask                                             (0x00000100)
+#define K_MCP_EN_security_region_en(data)                                            (0x00000100&((data)<<8))
+#define K_MCP_EN_security_region_en_src(data)                                        ((0x00000100&(data))>>8)
+#define K_MCP_EN_get_security_region_en(data)                                        ((0x00000100&(data))>>8)
+#define K_MCP_EN_cdpu_isr_en_shift                                                   (7)
+#define K_MCP_EN_cdpu_isr_en_mask                                                    (0x00000080)
+#define K_MCP_EN_cdpu_isr_en(data)                                                   (0x00000080&((data)<<7))
+#define K_MCP_EN_cdpu_isr_en_src(data)                                               ((0x00000080&(data))>>7)
+#define K_MCP_EN_get_cdpu_isr_en(data)                                               ((0x00000080&(data))>>7)
+#define K_MCP_EN_mcp_error_en_shift                                                  (6)
+#define K_MCP_EN_mcp_error_en_mask                                                   (0x00000040)
+#define K_MCP_EN_mcp_error_en(data)                                                  (0x00000040&((data)<<6))
+#define K_MCP_EN_mcp_error_en_src(data)                                              ((0x00000040&(data))>>6)
+#define K_MCP_EN_get_mcp_error_en(data)                                              ((0x00000040&(data))>>6)
+#define K_MCP_EN_compare_en_shift                                                    (3)
+#define K_MCP_EN_compare_en_mask                                                     (0x00000008)
+#define K_MCP_EN_compare_en(data)                                                    (0x00000008&((data)<<3))
+#define K_MCP_EN_compare_en_src(data)                                                ((0x00000008&(data))>>3)
+#define K_MCP_EN_get_compare_en(data)                                                ((0x00000008&(data))>>3)
+#define K_MCP_EN_error_en_shift                                                      (2)
+#define K_MCP_EN_error_en_mask                                                       (0x00000004)
+#define K_MCP_EN_error_en(data)                                                      (0x00000004&((data)<<2))
+#define K_MCP_EN_error_en_src(data)                                                  ((0x00000004&(data))>>2)
+#define K_MCP_EN_get_error_en(data)                                                  ((0x00000004&(data))>>2)
+#define K_MCP_EN_ring_empty_en_shift                                                 (1)
+#define K_MCP_EN_ring_empty_en_mask                                                  (0x00000002)
+#define K_MCP_EN_ring_empty_en(data)                                                 (0x00000002&((data)<<1))
+#define K_MCP_EN_ring_empty_en_src(data)                                             ((0x00000002&(data))>>1)
+#define K_MCP_EN_get_ring_empty_en(data)                                             ((0x00000002&(data))>>1)
+#define K_MCP_EN_write_data_shift                                                    (0)
+#define K_MCP_EN_write_data_mask                                                     (0x00000001)
+#define K_MCP_EN_write_data(data)                                                    (0x00000001&((data)<<0))
+#define K_MCP_EN_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define K_MCP_EN_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define K_MCP_CTRL1                                                                  0x18015998
+#define K_MCP_CTRL1_reg_addr                                                         "0xB8015998"
+#define K_MCP_CTRL1_reg                                                              0xB8015998
+#define set_K_MCP_CTRL1_reg(data)   (*((volatile unsigned int*) K_MCP_CTRL1_reg)=data)
+#define get_K_MCP_CTRL1_reg   (*((volatile unsigned int*) K_MCP_CTRL1_reg))
+#define K_MCP_CTRL1_inst_adr                                                         "0x0066"
+#define K_MCP_CTRL1_inst                                                             0x0066
+#define K_MCP_CTRL1_aesh_pad_off_shift                                               (10)
+#define K_MCP_CTRL1_aesh_pad_off_mask                                                (0x00000400)
+#define K_MCP_CTRL1_aesh_pad_off(data)                                               (0x00000400&((data)<<10))
+#define K_MCP_CTRL1_aesh_pad_off_src(data)                                           ((0x00000400&(data))>>10)
+#define K_MCP_CTRL1_get_aesh_pad_off(data)                                           ((0x00000400&(data))>>10)
+#define K_MCP_CTRL1_csa_entropy_shift                                                (8)
+#define K_MCP_CTRL1_csa_entropy_mask                                                 (0x00000300)
+#define K_MCP_CTRL1_csa_entropy(data)                                                (0x00000300&((data)<<8))
+#define K_MCP_CTRL1_csa_entropy_src(data)                                            ((0x00000300&(data))>>8)
+#define K_MCP_CTRL1_get_csa_entropy(data)                                            ((0x00000300&(data))>>8)
+#define K_MCP_CTRL1_mcp_round_no_shift                                               (0)
+#define K_MCP_CTRL1_mcp_round_no_mask                                                (0x000000FF)
+#define K_MCP_CTRL1_mcp_round_no(data)                                               (0x000000FF&((data)<<0))
+#define K_MCP_CTRL1_mcp_round_no_src(data)                                           ((0x000000FF&(data))>>0)
+#define K_MCP_CTRL1_get_mcp_round_no(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define K_MCP_BASE                                                                   0x1801590C
+#define K_MCP_BASE_reg_addr                                                          "0xB801590C"
+#define K_MCP_BASE_reg                                                               0xB801590C
+#define set_K_MCP_BASE_reg(data)   (*((volatile unsigned int*) K_MCP_BASE_reg)=data)
+#define get_K_MCP_BASE_reg   (*((volatile unsigned int*) K_MCP_BASE_reg))
+#define K_MCP_BASE_inst_adr                                                          "0x0043"
+#define K_MCP_BASE_inst                                                              0x0043
+#define K_MCP_BASE_base_shift                                                        (0)
+#define K_MCP_BASE_base_mask                                                         (0xFFFFFFFF)
+#define K_MCP_BASE_base(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define K_MCP_BASE_base_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define K_MCP_BASE_get_base(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_MCP_LIMIT                                                                  0x18015910
+#define K_MCP_LIMIT_reg_addr                                                         "0xB8015910"
+#define K_MCP_LIMIT_reg                                                              0xB8015910
+#define set_K_MCP_LIMIT_reg(data)   (*((volatile unsigned int*) K_MCP_LIMIT_reg)=data)
+#define get_K_MCP_LIMIT_reg   (*((volatile unsigned int*) K_MCP_LIMIT_reg))
+#define K_MCP_LIMIT_inst_adr                                                         "0x0044"
+#define K_MCP_LIMIT_inst                                                             0x0044
+#define K_MCP_LIMIT_limit_shift                                                      (0)
+#define K_MCP_LIMIT_limit_mask                                                       (0xFFFFFFFF)
+#define K_MCP_LIMIT_limit(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define K_MCP_LIMIT_limit_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define K_MCP_LIMIT_get_limit(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_MCP_RDPTR                                                                  0x18015914
+#define K_MCP_RDPTR_reg_addr                                                         "0xB8015914"
+#define K_MCP_RDPTR_reg                                                              0xB8015914
+#define set_K_MCP_RDPTR_reg(data)   (*((volatile unsigned int*) K_MCP_RDPTR_reg)=data)
+#define get_K_MCP_RDPTR_reg   (*((volatile unsigned int*) K_MCP_RDPTR_reg))
+#define K_MCP_RDPTR_inst_adr                                                         "0x0045"
+#define K_MCP_RDPTR_inst                                                             0x0045
+#define K_MCP_RDPTR_rdptr_shift                                                      (0)
+#define K_MCP_RDPTR_rdptr_mask                                                       (0xFFFFFFFF)
+#define K_MCP_RDPTR_rdptr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define K_MCP_RDPTR_rdptr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define K_MCP_RDPTR_get_rdptr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_MCP_WRPTR                                                                  0x18015918
+#define K_MCP_WRPTR_reg_addr                                                         "0xB8015918"
+#define K_MCP_WRPTR_reg                                                              0xB8015918
+#define set_K_MCP_WRPTR_reg(data)   (*((volatile unsigned int*) K_MCP_WRPTR_reg)=data)
+#define get_K_MCP_WRPTR_reg   (*((volatile unsigned int*) K_MCP_WRPTR_reg))
+#define K_MCP_WRPTR_inst_adr                                                         "0x0046"
+#define K_MCP_WRPTR_inst                                                             0x0046
+#define K_MCP_WRPTR_wrptr_shift                                                      (0)
+#define K_MCP_WRPTR_wrptr_mask                                                       (0xFFFFFFFF)
+#define K_MCP_WRPTR_wrptr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define K_MCP_WRPTR_wrptr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define K_MCP_WRPTR_get_wrptr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_MCP_DES_COUNT                                                              0x18015934
+#define K_MCP_DES_COUNT_reg_addr                                                     "0xB8015934"
+#define K_MCP_DES_COUNT_reg                                                          0xB8015934
+#define set_K_MCP_DES_COUNT_reg(data)   (*((volatile unsigned int*) K_MCP_DES_COUNT_reg)=data)
+#define get_K_MCP_DES_COUNT_reg   (*((volatile unsigned int*) K_MCP_DES_COUNT_reg))
+#define K_MCP_DES_COUNT_inst_adr                                                     "0x004D"
+#define K_MCP_DES_COUNT_inst                                                         0x004D
+#define K_MCP_DES_COUNT_count_shift                                                  (0)
+#define K_MCP_DES_COUNT_count_mask                                                   (0x0000FFFF)
+#define K_MCP_DES_COUNT_count(data)                                                  (0x0000FFFF&((data)<<0))
+#define K_MCP_DES_COUNT_count_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define K_MCP_DES_COUNT_get_count(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define K_MCP_DES_COMPARE                                                            0x18015938
+#define K_MCP_DES_COMPARE_reg_addr                                                   "0xB8015938"
+#define K_MCP_DES_COMPARE_reg                                                        0xB8015938
+#define set_K_MCP_DES_COMPARE_reg(data)   (*((volatile unsigned int*) K_MCP_DES_COMPARE_reg)=data)
+#define get_K_MCP_DES_COMPARE_reg   (*((volatile unsigned int*) K_MCP_DES_COMPARE_reg))
+#define K_MCP_DES_COMPARE_inst_adr                                                   "0x004E"
+#define K_MCP_DES_COMPARE_inst                                                       0x004E
+#define K_MCP_DES_COMPARE_compare_shift                                              (0)
+#define K_MCP_DES_COMPARE_compare_mask                                               (0x0000FFFF)
+#define K_MCP_DES_COMPARE_compare(data)                                              (0x0000FFFF&((data)<<0))
+#define K_MCP_DES_COMPARE_compare_src(data)                                          ((0x0000FFFF&(data))>>0)
+#define K_MCP_DES_COMPARE_get_compare(data)                                          ((0x0000FFFF&(data))>>0)
+
+
+#define K_MCP_DES_INI_KEY_0                                                          0x1801591C
+#define K_MCP_DES_INI_KEY_1                                                          0x18015920
+#define K_MCP_DES_INI_KEY_0_reg_addr                                                 "0xB801591C"
+#define K_MCP_DES_INI_KEY_1_reg_addr                                                 "0xB8015920"
+#define K_MCP_DES_INI_KEY_0_reg                                                      0xB801591C
+#define K_MCP_DES_INI_KEY_1_reg                                                      0xB8015920
+#define set_K_MCP_DES_INI_KEY_0_reg(data)   (*((volatile unsigned int*) K_MCP_DES_INI_KEY_0_reg)=data)
+#define set_K_MCP_DES_INI_KEY_1_reg(data)   (*((volatile unsigned int*) K_MCP_DES_INI_KEY_1_reg)=data)
+#define get_K_MCP_DES_INI_KEY_0_reg   (*((volatile unsigned int*) K_MCP_DES_INI_KEY_0_reg))
+#define get_K_MCP_DES_INI_KEY_1_reg   (*((volatile unsigned int*) K_MCP_DES_INI_KEY_1_reg))
+#define K_MCP_DES_INI_KEY_0_inst_adr                                                 "0x0047"
+#define K_MCP_DES_INI_KEY_1_inst_adr                                                 "0x0048"
+#define K_MCP_DES_INI_KEY_0_inst                                                     0x0047
+#define K_MCP_DES_INI_KEY_1_inst                                                     0x0048
+#define K_MCP_DES_INI_KEY_data_shift                                                 (0)
+#define K_MCP_DES_INI_KEY_data_mask                                                  (0xFFFFFFFF)
+#define K_MCP_DES_INI_KEY_data(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define K_MCP_DES_INI_KEY_data_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define K_MCP_DES_INI_KEY_get_data(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_MCP_AES_INI_KEY_0                                                          0x18015924
+#define K_MCP_AES_INI_KEY_1                                                          0x18015928
+#define K_MCP_AES_INI_KEY_2                                                          0x1801592C
+#define K_MCP_AES_INI_KEY_3                                                          0x18015930
+#define K_MCP_AES_INI_KEY_0_reg_addr                                                 "0xB8015924"
+#define K_MCP_AES_INI_KEY_1_reg_addr                                                 "0xB8015928"
+#define K_MCP_AES_INI_KEY_2_reg_addr                                                 "0xB801592C"
+#define K_MCP_AES_INI_KEY_3_reg_addr                                                 "0xB8015930"
+#define K_MCP_AES_INI_KEY_0_reg                                                      0xB8015924
+#define K_MCP_AES_INI_KEY_1_reg                                                      0xB8015928
+#define K_MCP_AES_INI_KEY_2_reg                                                      0xB801592C
+#define K_MCP_AES_INI_KEY_3_reg                                                      0xB8015930
+#define set_K_MCP_AES_INI_KEY_0_reg(data)   (*((volatile unsigned int*) K_MCP_AES_INI_KEY_0_reg)=data)
+#define set_K_MCP_AES_INI_KEY_1_reg(data)   (*((volatile unsigned int*) K_MCP_AES_INI_KEY_1_reg)=data)
+#define set_K_MCP_AES_INI_KEY_2_reg(data)   (*((volatile unsigned int*) K_MCP_AES_INI_KEY_2_reg)=data)
+#define set_K_MCP_AES_INI_KEY_3_reg(data)   (*((volatile unsigned int*) K_MCP_AES_INI_KEY_3_reg)=data)
+#define get_K_MCP_AES_INI_KEY_0_reg   (*((volatile unsigned int*) K_MCP_AES_INI_KEY_0_reg))
+#define get_K_MCP_AES_INI_KEY_1_reg   (*((volatile unsigned int*) K_MCP_AES_INI_KEY_1_reg))
+#define get_K_MCP_AES_INI_KEY_2_reg   (*((volatile unsigned int*) K_MCP_AES_INI_KEY_2_reg))
+#define get_K_MCP_AES_INI_KEY_3_reg   (*((volatile unsigned int*) K_MCP_AES_INI_KEY_3_reg))
+#define K_MCP_AES_INI_KEY_0_inst_adr                                                 "0x0049"
+#define K_MCP_AES_INI_KEY_1_inst_adr                                                 "0x004A"
+#define K_MCP_AES_INI_KEY_2_inst_adr                                                 "0x004B"
+#define K_MCP_AES_INI_KEY_3_inst_adr                                                 "0x004C"
+#define K_MCP_AES_INI_KEY_0_inst                                                     0x0049
+#define K_MCP_AES_INI_KEY_1_inst                                                     0x004A
+#define K_MCP_AES_INI_KEY_2_inst                                                     0x004B
+#define K_MCP_AES_INI_KEY_3_inst                                                     0x004C
+#define K_MCP_AES_INI_KEY_data_shift                                                 (0)
+#define K_MCP_AES_INI_KEY_data_mask                                                  (0xFFFFFFFF)
+#define K_MCP_AES_INI_KEY_data(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define K_MCP_AES_INI_KEY_data_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define K_MCP_AES_INI_KEY_get_data(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_MCP_MULTI2_SYS_KEY_0                                                       0x18015978
+#define K_MCP_MULTI2_SYS_KEY_1                                                       0x1801597C
+#define K_MCP_MULTI2_SYS_KEY_2                                                       0x18015980
+#define K_MCP_MULTI2_SYS_KEY_3                                                       0x18015984
+#define K_MCP_MULTI2_SYS_KEY_4                                                       0x18015988
+#define K_MCP_MULTI2_SYS_KEY_5                                                       0x1801598C
+#define K_MCP_MULTI2_SYS_KEY_6                                                       0x18015990
+#define K_MCP_MULTI2_SYS_KEY_7                                                       0x18015994
+#define K_MCP_MULTI2_SYS_KEY_0_reg_addr                                              "0xB8015978"
+#define K_MCP_MULTI2_SYS_KEY_1_reg_addr                                              "0xB801597C"
+#define K_MCP_MULTI2_SYS_KEY_2_reg_addr                                              "0xB8015980"
+#define K_MCP_MULTI2_SYS_KEY_3_reg_addr                                              "0xB8015984"
+#define K_MCP_MULTI2_SYS_KEY_4_reg_addr                                              "0xB8015988"
+#define K_MCP_MULTI2_SYS_KEY_5_reg_addr                                              "0xB801598C"
+#define K_MCP_MULTI2_SYS_KEY_6_reg_addr                                              "0xB8015990"
+#define K_MCP_MULTI2_SYS_KEY_7_reg_addr                                              "0xB8015994"
+#define K_MCP_MULTI2_SYS_KEY_0_reg                                                   0xB8015978
+#define K_MCP_MULTI2_SYS_KEY_1_reg                                                   0xB801597C
+#define K_MCP_MULTI2_SYS_KEY_2_reg                                                   0xB8015980
+#define K_MCP_MULTI2_SYS_KEY_3_reg                                                   0xB8015984
+#define K_MCP_MULTI2_SYS_KEY_4_reg                                                   0xB8015988
+#define K_MCP_MULTI2_SYS_KEY_5_reg                                                   0xB801598C
+#define K_MCP_MULTI2_SYS_KEY_6_reg                                                   0xB8015990
+#define K_MCP_MULTI2_SYS_KEY_7_reg                                                   0xB8015994
+#define set_K_MCP_MULTI2_SYS_KEY_0_reg(data)   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_0_reg)=data)
+#define set_K_MCP_MULTI2_SYS_KEY_1_reg(data)   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_1_reg)=data)
+#define set_K_MCP_MULTI2_SYS_KEY_2_reg(data)   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_2_reg)=data)
+#define set_K_MCP_MULTI2_SYS_KEY_3_reg(data)   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_3_reg)=data)
+#define set_K_MCP_MULTI2_SYS_KEY_4_reg(data)   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_4_reg)=data)
+#define set_K_MCP_MULTI2_SYS_KEY_5_reg(data)   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_5_reg)=data)
+#define set_K_MCP_MULTI2_SYS_KEY_6_reg(data)   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_6_reg)=data)
+#define set_K_MCP_MULTI2_SYS_KEY_7_reg(data)   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_7_reg)=data)
+#define get_K_MCP_MULTI2_SYS_KEY_0_reg   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_0_reg))
+#define get_K_MCP_MULTI2_SYS_KEY_1_reg   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_1_reg))
+#define get_K_MCP_MULTI2_SYS_KEY_2_reg   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_2_reg))
+#define get_K_MCP_MULTI2_SYS_KEY_3_reg   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_3_reg))
+#define get_K_MCP_MULTI2_SYS_KEY_4_reg   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_4_reg))
+#define get_K_MCP_MULTI2_SYS_KEY_5_reg   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_5_reg))
+#define get_K_MCP_MULTI2_SYS_KEY_6_reg   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_6_reg))
+#define get_K_MCP_MULTI2_SYS_KEY_7_reg   (*((volatile unsigned int*) K_MCP_MULTI2_SYS_KEY_7_reg))
+#define K_MCP_MULTI2_SYS_KEY_0_inst_adr                                              "0x005E"
+#define K_MCP_MULTI2_SYS_KEY_1_inst_adr                                              "0x005F"
+#define K_MCP_MULTI2_SYS_KEY_2_inst_adr                                              "0x0060"
+#define K_MCP_MULTI2_SYS_KEY_3_inst_adr                                              "0x0061"
+#define K_MCP_MULTI2_SYS_KEY_4_inst_adr                                              "0x0062"
+#define K_MCP_MULTI2_SYS_KEY_5_inst_adr                                              "0x0063"
+#define K_MCP_MULTI2_SYS_KEY_6_inst_adr                                              "0x0064"
+#define K_MCP_MULTI2_SYS_KEY_7_inst_adr                                              "0x0065"
+#define K_MCP_MULTI2_SYS_KEY_0_inst                                                  0x005E
+#define K_MCP_MULTI2_SYS_KEY_1_inst                                                  0x005F
+#define K_MCP_MULTI2_SYS_KEY_2_inst                                                  0x0060
+#define K_MCP_MULTI2_SYS_KEY_3_inst                                                  0x0061
+#define K_MCP_MULTI2_SYS_KEY_4_inst                                                  0x0062
+#define K_MCP_MULTI2_SYS_KEY_5_inst                                                  0x0063
+#define K_MCP_MULTI2_SYS_KEY_6_inst                                                  0x0064
+#define K_MCP_MULTI2_SYS_KEY_7_inst                                                  0x0065
+#define K_MCP_MULTI2_SYS_KEY_data_shift                                              (0)
+#define K_MCP_MULTI2_SYS_KEY_data_mask                                               (0xFFFFFFFF)
+#define K_MCP_MULTI2_SYS_KEY_data(data)                                              (0xFFFFFFFF&((data)<<0))
+#define K_MCP_MULTI2_SYS_KEY_data_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define K_MCP_MULTI2_SYS_KEY_get_data(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define K_MCP_M2M_DES_KAM                                                            0x1801599c
+#define K_MCP_M2M_DES_KAM_reg_addr                                                   "0xB801599C"
+#define K_MCP_M2M_DES_KAM_reg                                                        0xB801599C
+#define set_K_MCP_M2M_DES_KAM_reg(data)   (*((volatile unsigned int*) K_MCP_M2M_DES_KAM_reg)=data)
+#define get_K_MCP_M2M_DES_KAM_reg   (*((volatile unsigned int*) K_MCP_M2M_DES_KAM_reg))
+#define K_MCP_M2M_DES_KAM_inst_adr                                                   "0x0067"
+#define K_MCP_M2M_DES_KAM_inst                                                       0x0067
+#define K_MCP_M2M_DES_KAM_enable_shift                                               (3)
+#define K_MCP_M2M_DES_KAM_enable_mask                                                (0x00000008)
+#define K_MCP_M2M_DES_KAM_enable(data)                                               (0x00000008&((data)<<3))
+#define K_MCP_M2M_DES_KAM_enable_src(data)                                           ((0x00000008&(data))>>3)
+#define K_MCP_M2M_DES_KAM_get_enable(data)                                           ((0x00000008&(data))>>3)
+#define K_MCP_M2M_DES_KAM_kam_shift                                                  (0)
+#define K_MCP_M2M_DES_KAM_kam_mask                                                   (0x00000007)
+#define K_MCP_M2M_DES_KAM_kam(data)                                                  (0x00000007&((data)<<0))
+#define K_MCP_M2M_DES_KAM_kam_src(data)                                              ((0x00000007&(data))>>0)
+#define K_MCP_M2M_DES_KAM_get_kam(data)                                              ((0x00000007&(data))>>0)
+
+
+#define MCP_ST                                                                       0x180151a0
+#define MCP_ST_reg_addr                                                              "0xB80151A0"
+#define MCP_ST_reg                                                                   0xB80151A0
+#define set_MCP_ST_reg(data)   (*((volatile unsigned int*) MCP_ST_reg)=data)
+#define get_MCP_ST_reg   (*((volatile unsigned int*) MCP_ST_reg))
+#define MCP_ST_inst_adr                                                              "0x0068"
+#define MCP_ST_inst                                                                  0x0068
+#define MCP_ST_rd_sm_shift                                                           (24)
+#define MCP_ST_rd_sm_mask                                                            (0x0F000000)
+#define MCP_ST_rd_sm(data)                                                           (0x0F000000&((data)<<24))
+#define MCP_ST_rd_sm_src(data)                                                       ((0x0F000000&(data))>>24)
+#define MCP_ST_get_rd_sm(data)                                                       ((0x0F000000&(data))>>24)
+#define MCP_ST_wr_sm_shift                                                           (21)
+#define MCP_ST_wr_sm_mask                                                            (0x00E00000)
+#define MCP_ST_wr_sm(data)                                                           (0x00E00000&((data)<<21))
+#define MCP_ST_wr_sm_src(data)                                                       ((0x00E00000&(data))>>21)
+#define MCP_ST_get_wr_sm(data)                                                       ((0x00E00000&(data))>>21)
+#define MCP_ST_mcp_aes_like_sm_shift                                                 (0)
+#define MCP_ST_mcp_aes_like_sm_mask                                                  (0x000007FF)
+#define MCP_ST_mcp_aes_like_sm(data)                                                 (0x000007FF&((data)<<0))
+#define MCP_ST_mcp_aes_like_sm_src(data)                                             ((0x000007FF&(data))>>0)
+#define MCP_ST_get_mcp_aes_like_sm(data)                                             ((0x000007FF&(data))>>0)
+
+
+#define MCP_ST1                                                                      0x180151a4
+#define MCP_ST1_reg_addr                                                             "0xB80151A4"
+#define MCP_ST1_reg                                                                  0xB80151A4
+#define set_MCP_ST1_reg(data)   (*((volatile unsigned int*) MCP_ST1_reg)=data)
+#define get_MCP_ST1_reg   (*((volatile unsigned int*) MCP_ST1_reg))
+#define MCP_ST1_inst_adr                                                             "0x0069"
+#define MCP_ST1_inst                                                                 0x0069
+#define MCP_ST1_mcp_top_sm_shift                                                     (0)
+#define MCP_ST1_mcp_top_sm_mask                                                      (0x000FFFFF)
+#define MCP_ST1_mcp_top_sm(data)                                                     (0x000FFFFF&((data)<<0))
+#define MCP_ST1_mcp_top_sm_src(data)                                                 ((0x000FFFFF&(data))>>0)
+#define MCP_ST1_get_mcp_top_sm(data)                                                 ((0x000FFFFF&(data))>>0)
+
+
+#define MC_MAP1                                                                      0x180151a8
+#define MC_MAP1_reg_addr                                                             "0xB80151A8"
+#define MC_MAP1_reg                                                                  0xB80151A8
+#define set_MC_MAP1_reg(data)   (*((volatile unsigned int*) MC_MAP1_reg)=data)
+#define get_MC_MAP1_reg   (*((volatile unsigned int*) MC_MAP1_reg))
+#define MC_MAP1_inst_adr                                                             "0x006A"
+#define MC_MAP1_inst                                                                 0x006A
+#define MC_MAP1_adr3_shift                                                           (16)
+#define MC_MAP1_adr3_mask                                                            (0x03FF0000)
+#define MC_MAP1_adr3(data)                                                           (0x03FF0000&((data)<<16))
+#define MC_MAP1_adr3_src(data)                                                       ((0x03FF0000&(data))>>16)
+#define MC_MAP1_get_adr3(data)                                                       ((0x03FF0000&(data))>>16)
+#define MC_MAP1_adr2_shift                                                           (0)
+#define MC_MAP1_adr2_mask                                                            (0x000003FF)
+#define MC_MAP1_adr2(data)                                                           (0x000003FF&((data)<<0))
+#define MC_MAP1_adr2_src(data)                                                       ((0x000003FF&(data))>>0)
+#define MC_MAP1_get_adr2(data)                                                       ((0x000003FF&(data))>>0)
+
+
+#define MC_MAP2                                                                      0x180151ac
+#define MC_MAP2_reg_addr                                                             "0xB80151AC"
+#define MC_MAP2_reg                                                                  0xB80151AC
+#define set_MC_MAP2_reg(data)   (*((volatile unsigned int*) MC_MAP2_reg)=data)
+#define get_MC_MAP2_reg   (*((volatile unsigned int*) MC_MAP2_reg))
+#define MC_MAP2_inst_adr                                                             "0x006B"
+#define MC_MAP2_inst                                                                 0x006B
+#define MC_MAP2_adr1_shift                                                           (16)
+#define MC_MAP2_adr1_mask                                                            (0x03FF0000)
+#define MC_MAP2_adr1(data)                                                           (0x03FF0000&((data)<<16))
+#define MC_MAP2_adr1_src(data)                                                       ((0x03FF0000&(data))>>16)
+#define MC_MAP2_get_adr1(data)                                                       ((0x03FF0000&(data))>>16)
+#define MC_MAP2_adr0_shift                                                           (0)
+#define MC_MAP2_adr0_mask                                                            (0x000003FF)
+#define MC_MAP2_adr0(data)                                                           (0x000003FF&((data)<<0))
+#define MC_MAP2_adr0_src(data)                                                       ((0x000003FF&(data))>>0)
+#define MC_MAP2_get_adr0(data)                                                       ((0x000003FF&(data))>>0)
+
+
+#define MC_INFO1                                                                     0x180151b0
+#define MC_INFO1_reg_addr                                                            "0xB80151B0"
+#define MC_INFO1_reg                                                                 0xB80151B0
+#define set_MC_INFO1_reg(data)   (*((volatile unsigned int*) MC_INFO1_reg)=data)
+#define get_MC_INFO1_reg   (*((volatile unsigned int*) MC_INFO1_reg))
+#define MC_INFO1_inst_adr                                                            "0x006C"
+#define MC_INFO1_inst                                                                0x006C
+#define MC_INFO1_pc_shift                                                            (0)
+#define MC_INFO1_pc_mask                                                             (0x000003FF)
+#define MC_INFO1_pc(data)                                                            (0x000003FF&((data)<<0))
+#define MC_INFO1_pc_src(data)                                                        ((0x000003FF&(data))>>0)
+#define MC_INFO1_get_pc(data)                                                        ((0x000003FF&(data))>>0)
+
+
+#define MC_INFO2                                                                     0x180151b4
+#define MC_INFO2_reg_addr                                                            "0xB80151B4"
+#define MC_INFO2_reg                                                                 0xB80151B4
+#define set_MC_INFO2_reg(data)   (*((volatile unsigned int*) MC_INFO2_reg)=data)
+#define get_MC_INFO2_reg   (*((volatile unsigned int*) MC_INFO2_reg))
+#define MC_INFO2_inst_adr                                                            "0x006D"
+#define MC_INFO2_inst                                                                0x006D
+#define MC_INFO2_word1_shift                                                         (0)
+#define MC_INFO2_word1_mask                                                          (0xFFFFFFFF)
+#define MC_INFO2_word1(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define MC_INFO2_word1_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define MC_INFO2_get_word1(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define MC_INFO3                                                                     0x180151b8
+#define MC_INFO3_reg_addr                                                            "0xB80151B8"
+#define MC_INFO3_reg                                                                 0xB80151B8
+#define set_MC_INFO3_reg(data)   (*((volatile unsigned int*) MC_INFO3_reg)=data)
+#define get_MC_INFO3_reg   (*((volatile unsigned int*) MC_INFO3_reg))
+#define MC_INFO3_inst_adr                                                            "0x006E"
+#define MC_INFO3_inst                                                                0x006E
+#define MC_INFO3_word2_shift                                                         (0)
+#define MC_INFO3_word2_mask                                                          (0xFFFFFFFF)
+#define MC_INFO3_word2(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define MC_INFO3_word2_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define MC_INFO3_get_word2(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define MC_INFO4                                                                     0x180151bc
+#define MC_INFO4_reg_addr                                                            "0xB80151BC"
+#define MC_INFO4_reg                                                                 0xB80151BC
+#define set_MC_INFO4_reg(data)   (*((volatile unsigned int*) MC_INFO4_reg)=data)
+#define get_MC_INFO4_reg   (*((volatile unsigned int*) MC_INFO4_reg))
+#define MC_INFO4_inst_adr                                                            "0x006F"
+#define MC_INFO4_inst                                                                0x006F
+#define MC_INFO4_word3_shift                                                         (0)
+#define MC_INFO4_word3_mask                                                          (0xFFFFFFFF)
+#define MC_INFO4_word3(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define MC_INFO4_word3_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define MC_INFO4_get_word3(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define MC_CTR                                                                       0x180151c0
+#define MC_CTR_reg_addr                                                              "0xB80151C0"
+#define MC_CTR_reg                                                                   0xB80151C0
+#define set_MC_CTR_reg(data)   (*((volatile unsigned int*) MC_CTR_reg)=data)
+#define get_MC_CTR_reg   (*((volatile unsigned int*) MC_CTR_reg))
+#define MC_CTR_inst_adr                                                              "0x0070"
+#define MC_CTR_inst                                                                  0x0070
+#define MC_CTR_tmout_ctr_shift                                                       (0)
+#define MC_CTR_tmout_ctr_mask                                                        (0x0000FFFF)
+#define MC_CTR_tmout_ctr(data)                                                       (0x0000FFFF&((data)<<0))
+#define MC_CTR_tmout_ctr_src(data)                                                   ((0x0000FFFF&(data))>>0)
+#define MC_CTR_get_tmout_ctr(data)                                                   ((0x0000FFFF&(data))>>0)
+
+
+#define MBIST_1                                                                      0x180151d0
+#define MBIST_1_reg_addr                                                             "0xB80151D0"
+#define MBIST_1_reg                                                                  0xB80151D0
+#define set_MBIST_1_reg(data)   (*((volatile unsigned int*) MBIST_1_reg)=data)
+#define get_MBIST_1_reg   (*((volatile unsigned int*) MBIST_1_reg))
+#define MBIST_1_inst_adr                                                             "0x0074"
+#define MBIST_1_inst                                                                 0x0074
+#define MBIST_1_rm_shift                                                             (4)
+#define MBIST_1_rm_mask                                                              (0x000000F0)
+#define MBIST_1_rm(data)                                                             (0x000000F0&((data)<<4))
+#define MBIST_1_rm_src(data)                                                         ((0x000000F0&(data))>>4)
+#define MBIST_1_get_rm(data)                                                         ((0x000000F0&(data))>>4)
+#define MBIST_1_rme_shift                                                            (3)
+#define MBIST_1_rme_mask                                                             (0x00000008)
+#define MBIST_1_rme(data)                                                            (0x00000008&((data)<<3))
+#define MBIST_1_rme_src(data)                                                        ((0x00000008&(data))>>3)
+#define MBIST_1_get_rme(data)                                                        ((0x00000008&(data))>>3)
+#define MBIST_1_drf_test_resume_shift                                                (2)
+#define MBIST_1_drf_test_resume_mask                                                 (0x00000004)
+#define MBIST_1_drf_test_resume(data)                                                (0x00000004&((data)<<2))
+#define MBIST_1_drf_test_resume_src(data)                                            ((0x00000004&(data))>>2)
+#define MBIST_1_get_drf_test_resume(data)                                            ((0x00000004&(data))>>2)
+#define MBIST_1_drf_bist_mode_shift                                                  (1)
+#define MBIST_1_drf_bist_mode_mask                                                   (0x00000002)
+#define MBIST_1_drf_bist_mode(data)                                                  (0x00000002&((data)<<1))
+#define MBIST_1_drf_bist_mode_src(data)                                              ((0x00000002&(data))>>1)
+#define MBIST_1_get_drf_bist_mode(data)                                              ((0x00000002&(data))>>1)
+#define MBIST_1_bist_mode_shift                                                      (0)
+#define MBIST_1_bist_mode_mask                                                       (0x00000001)
+#define MBIST_1_bist_mode(data)                                                      (0x00000001&((data)<<0))
+#define MBIST_1_bist_mode_src(data)                                                  ((0x00000001&(data))>>0)
+#define MBIST_1_get_bist_mode(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define MBIST_2                                                                      0x180151d4
+#define MBIST_2_reg_addr                                                             "0xB80151D4"
+#define MBIST_2_reg                                                                  0xB80151D4
+#define set_MBIST_2_reg(data)   (*((volatile unsigned int*) MBIST_2_reg)=data)
+#define get_MBIST_2_reg   (*((volatile unsigned int*) MBIST_2_reg))
+#define MBIST_2_inst_adr                                                             "0x0075"
+#define MBIST_2_inst                                                                 0x0075
+#define MBIST_2_drf_bist_fail_5_shift                                                (14)
+#define MBIST_2_drf_bist_fail_5_mask                                                 (0x00004000)
+#define MBIST_2_drf_bist_fail_5(data)                                                (0x00004000&((data)<<14))
+#define MBIST_2_drf_bist_fail_5_src(data)                                            ((0x00004000&(data))>>14)
+#define MBIST_2_get_drf_bist_fail_5(data)                                            ((0x00004000&(data))>>14)
+#define MBIST_2_bist_fail_5_shift                                                    (13)
+#define MBIST_2_bist_fail_5_mask                                                     (0x00002000)
+#define MBIST_2_bist_fail_5(data)                                                    (0x00002000&((data)<<13))
+#define MBIST_2_bist_fail_5_src(data)                                                ((0x00002000&(data))>>13)
+#define MBIST_2_get_bist_fail_5(data)                                                ((0x00002000&(data))>>13)
+#define MBIST_2_drf_bist_fail_4_shift                                                (12)
+#define MBIST_2_drf_bist_fail_4_mask                                                 (0x00001000)
+#define MBIST_2_drf_bist_fail_4(data)                                                (0x00001000&((data)<<12))
+#define MBIST_2_drf_bist_fail_4_src(data)                                            ((0x00001000&(data))>>12)
+#define MBIST_2_get_drf_bist_fail_4(data)                                            ((0x00001000&(data))>>12)
+#define MBIST_2_bist_fail_4_shift                                                    (11)
+#define MBIST_2_bist_fail_4_mask                                                     (0x00000800)
+#define MBIST_2_bist_fail_4(data)                                                    (0x00000800&((data)<<11))
+#define MBIST_2_bist_fail_4_src(data)                                                ((0x00000800&(data))>>11)
+#define MBIST_2_get_bist_fail_4(data)                                                ((0x00000800&(data))>>11)
+#define MBIST_2_drf_bist_fail_3_shift                                                (10)
+#define MBIST_2_drf_bist_fail_3_mask                                                 (0x00000400)
+#define MBIST_2_drf_bist_fail_3(data)                                                (0x00000400&((data)<<10))
+#define MBIST_2_drf_bist_fail_3_src(data)                                            ((0x00000400&(data))>>10)
+#define MBIST_2_get_drf_bist_fail_3(data)                                            ((0x00000400&(data))>>10)
+#define MBIST_2_bist_fail_3_shift                                                    (9)
+#define MBIST_2_bist_fail_3_mask                                                     (0x00000200)
+#define MBIST_2_bist_fail_3(data)                                                    (0x00000200&((data)<<9))
+#define MBIST_2_bist_fail_3_src(data)                                                ((0x00000200&(data))>>9)
+#define MBIST_2_get_bist_fail_3(data)                                                ((0x00000200&(data))>>9)
+#define MBIST_2_drf_bist_fail_2_shift                                                (8)
+#define MBIST_2_drf_bist_fail_2_mask                                                 (0x00000100)
+#define MBIST_2_drf_bist_fail_2(data)                                                (0x00000100&((data)<<8))
+#define MBIST_2_drf_bist_fail_2_src(data)                                            ((0x00000100&(data))>>8)
+#define MBIST_2_get_drf_bist_fail_2(data)                                            ((0x00000100&(data))>>8)
+#define MBIST_2_bist_fail_2_shift                                                    (7)
+#define MBIST_2_bist_fail_2_mask                                                     (0x00000080)
+#define MBIST_2_bist_fail_2(data)                                                    (0x00000080&((data)<<7))
+#define MBIST_2_bist_fail_2_src(data)                                                ((0x00000080&(data))>>7)
+#define MBIST_2_get_bist_fail_2(data)                                                ((0x00000080&(data))>>7)
+#define MBIST_2_drf_bist_fail_1_shift                                                (6)
+#define MBIST_2_drf_bist_fail_1_mask                                                 (0x00000040)
+#define MBIST_2_drf_bist_fail_1(data)                                                (0x00000040&((data)<<6))
+#define MBIST_2_drf_bist_fail_1_src(data)                                            ((0x00000040&(data))>>6)
+#define MBIST_2_get_drf_bist_fail_1(data)                                            ((0x00000040&(data))>>6)
+#define MBIST_2_bist_fail_1_shift                                                    (5)
+#define MBIST_2_bist_fail_1_mask                                                     (0x00000020)
+#define MBIST_2_bist_fail_1(data)                                                    (0x00000020&((data)<<5))
+#define MBIST_2_bist_fail_1_src(data)                                                ((0x00000020&(data))>>5)
+#define MBIST_2_get_bist_fail_1(data)                                                ((0x00000020&(data))>>5)
+#define MBIST_2_drf_bist_fail_0_shift                                                (4)
+#define MBIST_2_drf_bist_fail_0_mask                                                 (0x00000010)
+#define MBIST_2_drf_bist_fail_0(data)                                                (0x00000010&((data)<<4))
+#define MBIST_2_drf_bist_fail_0_src(data)                                            ((0x00000010&(data))>>4)
+#define MBIST_2_get_drf_bist_fail_0(data)                                            ((0x00000010&(data))>>4)
+#define MBIST_2_bist_fail_0_shift                                                    (3)
+#define MBIST_2_bist_fail_0_mask                                                     (0x00000008)
+#define MBIST_2_bist_fail_0(data)                                                    (0x00000008&((data)<<3))
+#define MBIST_2_bist_fail_0_src(data)                                                ((0x00000008&(data))>>3)
+#define MBIST_2_get_bist_fail_0(data)                                                ((0x00000008&(data))>>3)
+#define MBIST_2_drf_start_pause_shift                                                (2)
+#define MBIST_2_drf_start_pause_mask                                                 (0x00000004)
+#define MBIST_2_drf_start_pause(data)                                                (0x00000004&((data)<<2))
+#define MBIST_2_drf_start_pause_src(data)                                            ((0x00000004&(data))>>2)
+#define MBIST_2_get_drf_start_pause(data)                                            ((0x00000004&(data))>>2)
+#define MBIST_2_drf_bist_done_shift                                                  (1)
+#define MBIST_2_drf_bist_done_mask                                                   (0x00000002)
+#define MBIST_2_drf_bist_done(data)                                                  (0x00000002&((data)<<1))
+#define MBIST_2_drf_bist_done_src(data)                                              ((0x00000002&(data))>>1)
+#define MBIST_2_get_drf_bist_done(data)                                              ((0x00000002&(data))>>1)
+#define MBIST_2_bist_done_shift                                                      (0)
+#define MBIST_2_bist_done_mask                                                       (0x00000001)
+#define MBIST_2_bist_done(data)                                                      (0x00000001&((data)<<0))
+#define MBIST_2_bist_done_src(data)                                                  ((0x00000001&(data))>>0)
+#define MBIST_2_get_bist_done(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define PWM_CTRL                                                                     0x180151e0
+#define PWM_CTRL_reg_addr                                                            "0xB80151E0"
+#define PWM_CTRL_reg                                                                 0xB80151E0
+#define set_PWM_CTRL_reg(data)   (*((volatile unsigned int*) PWM_CTRL_reg)=data)
+#define get_PWM_CTRL_reg   (*((volatile unsigned int*) PWM_CTRL_reg))
+#define PWM_CTRL_inst_adr                                                            "0x0078"
+#define PWM_CTRL_inst                                                                0x0078
+#define PWM_CTRL_en_cp_shift                                                         (22)
+#define PWM_CTRL_en_cp_mask                                                          (0x00400000)
+#define PWM_CTRL_en_cp(data)                                                         (0x00400000&((data)<<22))
+#define PWM_CTRL_en_cp_src(data)                                                     ((0x00400000&(data))>>22)
+#define PWM_CTRL_get_en_cp(data)                                                     ((0x00400000&(data))>>22)
+#define PWM_CTRL_en_mcp_shift                                                        (21)
+#define PWM_CTRL_en_mcp_mask                                                         (0x00200000)
+#define PWM_CTRL_en_mcp(data)                                                        (0x00200000&((data)<<21))
+#define PWM_CTRL_en_mcp_src(data)                                                    ((0x00200000&(data))>>21)
+#define PWM_CTRL_get_en_mcp(data)                                                    ((0x00200000&(data))>>21)
+#define PWM_CTRL_en_cdpu_shift                                                       (20)
+#define PWM_CTRL_en_cdpu_mask                                                        (0x00100000)
+#define PWM_CTRL_en_cdpu(data)                                                       (0x00100000&((data)<<20))
+#define PWM_CTRL_en_cdpu_src(data)                                                   ((0x00100000&(data))>>20)
+#define PWM_CTRL_get_en_cdpu(data)                                                   ((0x00100000&(data))>>20)
+#define PWM_CTRL_sram_ctr_shift                                                      (10)
+#define PWM_CTRL_sram_ctr_mask                                                       (0x00007C00)
+#define PWM_CTRL_sram_ctr(data)                                                      (0x00007C00&((data)<<10))
+#define PWM_CTRL_sram_ctr_src(data)                                                  ((0x00007C00&(data))>>10)
+#define PWM_CTRL_get_sram_ctr(data)                                                  ((0x00007C00&(data))>>10)
+#define PWM_CTRL_idle_ctr_shift                                                      (0)
+#define PWM_CTRL_idle_ctr_mask                                                       (0x000003FF)
+#define PWM_CTRL_idle_ctr(data)                                                      (0x000003FF&((data)<<0))
+#define PWM_CTRL_idle_ctr_src(data)                                                  ((0x000003FF&(data))>>0)
+#define PWM_CTRL_get_idle_ctr(data)                                                  ((0x000003FF&(data))>>0)
+
+
+#define RCIC_CTRL                                                                    0x180159a0
+#define RCIC_CTRL_reg_addr                                                           "0xB80159A0"
+#define RCIC_CTRL_reg                                                                0xB80159A0
+#define set_RCIC_CTRL_reg(data)   (*((volatile unsigned int*) RCIC_CTRL_reg)=data)
+#define get_RCIC_CTRL_reg   (*((volatile unsigned int*) RCIC_CTRL_reg))
+#define RCIC_CTRL_inst_adr                                                           "0x0068"
+#define RCIC_CTRL_inst                                                               0x0068
+#define RCIC_CTRL_write_en3_shift                                                    (10)
+#define RCIC_CTRL_write_en3_mask                                                     (0x00000400)
+#define RCIC_CTRL_write_en3(data)                                                    (0x00000400&((data)<<10))
+#define RCIC_CTRL_write_en3_src(data)                                                ((0x00000400&(data))>>10)
+#define RCIC_CTRL_get_write_en3(data)                                                ((0x00000400&(data))>>10)
+#define RCIC_CTRL_stop_shift                                                         (9)
+#define RCIC_CTRL_stop_mask                                                          (0x00000200)
+#define RCIC_CTRL_stop(data)                                                         (0x00000200&((data)<<9))
+#define RCIC_CTRL_stop_src(data)                                                     ((0x00000200&(data))>>9)
+#define RCIC_CTRL_get_stop(data)                                                     ((0x00000200&(data))>>9)
+#define RCIC_CTRL_write_en2_shift                                                    (8)
+#define RCIC_CTRL_write_en2_mask                                                     (0x00000100)
+#define RCIC_CTRL_write_en2(data)                                                    (0x00000100&((data)<<8))
+#define RCIC_CTRL_write_en2_src(data)                                                ((0x00000100&(data))>>8)
+#define RCIC_CTRL_get_write_en2(data)                                                ((0x00000100&(data))>>8)
+#define RCIC_CTRL_test_mode_shift                                                    (6)
+#define RCIC_CTRL_test_mode_mask                                                     (0x000000C0)
+#define RCIC_CTRL_test_mode(data)                                                    (0x000000C0&((data)<<6))
+#define RCIC_CTRL_test_mode_src(data)                                                ((0x000000C0&(data))>>6)
+#define RCIC_CTRL_get_test_mode(data)                                                ((0x000000C0&(data))>>6)
+#define RCIC_CTRL_write_en1_shift                                                    (5)
+#define RCIC_CTRL_write_en1_mask                                                     (0x00000020)
+#define RCIC_CTRL_write_en1(data)                                                    (0x00000020&((data)<<5))
+#define RCIC_CTRL_write_en1_src(data)                                                ((0x00000020&(data))>>5)
+#define RCIC_CTRL_get_write_en1(data)                                                ((0x00000020&(data))>>5)
+#define RCIC_CTRL_wait_sec_shift                                                     (0)
+#define RCIC_CTRL_wait_sec_mask                                                      (0x0000001F)
+#define RCIC_CTRL_wait_sec(data)                                                     (0x0000001F&((data)<<0))
+#define RCIC_CTRL_wait_sec_src(data)                                                 ((0x0000001F&(data))>>0)
+#define RCIC_CTRL_get_wait_sec(data)                                                 ((0x0000001F&(data))>>0)
+
+
+#define RCIC_ENTR_VLD                                                                0x180159a4
+#define RCIC_ENTR_VLD_reg_addr                                                       "0xB80159A4"
+#define RCIC_ENTR_VLD_reg                                                            0xB80159A4
+#define set_RCIC_ENTR_VLD_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_VLD_reg)=data)
+#define get_RCIC_ENTR_VLD_reg   (*((volatile unsigned int*) RCIC_ENTR_VLD_reg))
+#define RCIC_ENTR_VLD_inst_adr                                                       "0x0069"
+#define RCIC_ENTR_VLD_inst                                                           0x0069
+#define RCIC_ENTR_VLD_write_en7_shift                                                (15)
+#define RCIC_ENTR_VLD_write_en7_mask                                                 (0x00008000)
+#define RCIC_ENTR_VLD_write_en7(data)                                                (0x00008000&((data)<<15))
+#define RCIC_ENTR_VLD_write_en7_src(data)                                            ((0x00008000&(data))>>15)
+#define RCIC_ENTR_VLD_get_write_en7(data)                                            ((0x00008000&(data))>>15)
+#define RCIC_ENTR_VLD_valid_7_shift                                                  (14)
+#define RCIC_ENTR_VLD_valid_7_mask                                                   (0x00004000)
+#define RCIC_ENTR_VLD_valid_7(data)                                                  (0x00004000&((data)<<14))
+#define RCIC_ENTR_VLD_valid_7_src(data)                                              ((0x00004000&(data))>>14)
+#define RCIC_ENTR_VLD_get_valid_7(data)                                              ((0x00004000&(data))>>14)
+#define RCIC_ENTR_VLD_write_en6_shift                                                (13)
+#define RCIC_ENTR_VLD_write_en6_mask                                                 (0x00002000)
+#define RCIC_ENTR_VLD_write_en6(data)                                                (0x00002000&((data)<<13))
+#define RCIC_ENTR_VLD_write_en6_src(data)                                            ((0x00002000&(data))>>13)
+#define RCIC_ENTR_VLD_get_write_en6(data)                                            ((0x00002000&(data))>>13)
+#define RCIC_ENTR_VLD_valid_6_shift                                                  (12)
+#define RCIC_ENTR_VLD_valid_6_mask                                                   (0x00001000)
+#define RCIC_ENTR_VLD_valid_6(data)                                                  (0x00001000&((data)<<12))
+#define RCIC_ENTR_VLD_valid_6_src(data)                                              ((0x00001000&(data))>>12)
+#define RCIC_ENTR_VLD_get_valid_6(data)                                              ((0x00001000&(data))>>12)
+#define RCIC_ENTR_VLD_write_en5_shift                                                (11)
+#define RCIC_ENTR_VLD_write_en5_mask                                                 (0x00000800)
+#define RCIC_ENTR_VLD_write_en5(data)                                                (0x00000800&((data)<<11))
+#define RCIC_ENTR_VLD_write_en5_src(data)                                            ((0x00000800&(data))>>11)
+#define RCIC_ENTR_VLD_get_write_en5(data)                                            ((0x00000800&(data))>>11)
+#define RCIC_ENTR_VLD_valid_5_shift                                                  (10)
+#define RCIC_ENTR_VLD_valid_5_mask                                                   (0x00000400)
+#define RCIC_ENTR_VLD_valid_5(data)                                                  (0x00000400&((data)<<10))
+#define RCIC_ENTR_VLD_valid_5_src(data)                                              ((0x00000400&(data))>>10)
+#define RCIC_ENTR_VLD_get_valid_5(data)                                              ((0x00000400&(data))>>10)
+#define RCIC_ENTR_VLD_write_en4_shift                                                (9)
+#define RCIC_ENTR_VLD_write_en4_mask                                                 (0x00000200)
+#define RCIC_ENTR_VLD_write_en4(data)                                                (0x00000200&((data)<<9))
+#define RCIC_ENTR_VLD_write_en4_src(data)                                            ((0x00000200&(data))>>9)
+#define RCIC_ENTR_VLD_get_write_en4(data)                                            ((0x00000200&(data))>>9)
+#define RCIC_ENTR_VLD_valid_4_shift                                                  (8)
+#define RCIC_ENTR_VLD_valid_4_mask                                                   (0x00000100)
+#define RCIC_ENTR_VLD_valid_4(data)                                                  (0x00000100&((data)<<8))
+#define RCIC_ENTR_VLD_valid_4_src(data)                                              ((0x00000100&(data))>>8)
+#define RCIC_ENTR_VLD_get_valid_4(data)                                              ((0x00000100&(data))>>8)
+#define RCIC_ENTR_VLD_write_en3_shift                                                (7)
+#define RCIC_ENTR_VLD_write_en3_mask                                                 (0x00000080)
+#define RCIC_ENTR_VLD_write_en3(data)                                                (0x00000080&((data)<<7))
+#define RCIC_ENTR_VLD_write_en3_src(data)                                            ((0x00000080&(data))>>7)
+#define RCIC_ENTR_VLD_get_write_en3(data)                                            ((0x00000080&(data))>>7)
+#define RCIC_ENTR_VLD_valid_3_shift                                                  (6)
+#define RCIC_ENTR_VLD_valid_3_mask                                                   (0x00000040)
+#define RCIC_ENTR_VLD_valid_3(data)                                                  (0x00000040&((data)<<6))
+#define RCIC_ENTR_VLD_valid_3_src(data)                                              ((0x00000040&(data))>>6)
+#define RCIC_ENTR_VLD_get_valid_3(data)                                              ((0x00000040&(data))>>6)
+#define RCIC_ENTR_VLD_write_en2_shift                                                (5)
+#define RCIC_ENTR_VLD_write_en2_mask                                                 (0x00000020)
+#define RCIC_ENTR_VLD_write_en2(data)                                                (0x00000020&((data)<<5))
+#define RCIC_ENTR_VLD_write_en2_src(data)                                            ((0x00000020&(data))>>5)
+#define RCIC_ENTR_VLD_get_write_en2(data)                                            ((0x00000020&(data))>>5)
+#define RCIC_ENTR_VLD_valid_2_shift                                                  (4)
+#define RCIC_ENTR_VLD_valid_2_mask                                                   (0x00000010)
+#define RCIC_ENTR_VLD_valid_2(data)                                                  (0x00000010&((data)<<4))
+#define RCIC_ENTR_VLD_valid_2_src(data)                                              ((0x00000010&(data))>>4)
+#define RCIC_ENTR_VLD_get_valid_2(data)                                              ((0x00000010&(data))>>4)
+#define RCIC_ENTR_VLD_write_en1_shift                                                (3)
+#define RCIC_ENTR_VLD_write_en1_mask                                                 (0x00000008)
+#define RCIC_ENTR_VLD_write_en1(data)                                                (0x00000008&((data)<<3))
+#define RCIC_ENTR_VLD_write_en1_src(data)                                            ((0x00000008&(data))>>3)
+#define RCIC_ENTR_VLD_get_write_en1(data)                                            ((0x00000008&(data))>>3)
+#define RCIC_ENTR_VLD_valid_1_shift                                                  (2)
+#define RCIC_ENTR_VLD_valid_1_mask                                                   (0x00000004)
+#define RCIC_ENTR_VLD_valid_1(data)                                                  (0x00000004&((data)<<2))
+#define RCIC_ENTR_VLD_valid_1_src(data)                                              ((0x00000004&(data))>>2)
+#define RCIC_ENTR_VLD_get_valid_1(data)                                              ((0x00000004&(data))>>2)
+#define RCIC_ENTR_VLD_write_en0_shift                                                (1)
+#define RCIC_ENTR_VLD_write_en0_mask                                                 (0x00000002)
+#define RCIC_ENTR_VLD_write_en0(data)                                                (0x00000002&((data)<<1))
+#define RCIC_ENTR_VLD_write_en0_src(data)                                            ((0x00000002&(data))>>1)
+#define RCIC_ENTR_VLD_get_write_en0(data)                                            ((0x00000002&(data))>>1)
+#define RCIC_ENTR_VLD_valid_0_shift                                                  (0)
+#define RCIC_ENTR_VLD_valid_0_mask                                                   (0x00000001)
+#define RCIC_ENTR_VLD_valid_0(data)                                                  (0x00000001&((data)<<0))
+#define RCIC_ENTR_VLD_valid_0_src(data)                                              ((0x00000001&(data))>>0)
+#define RCIC_ENTR_VLD_get_valid_0(data)                                              ((0x00000001&(data))>>0)
+
+
+#define RCIC_STATUS                                                                  0x180159a8
+#define RCIC_STATUS_reg_addr                                                         "0xB80159A8"
+#define RCIC_STATUS_reg                                                              0xB80159A8
+#define set_RCIC_STATUS_reg(data)   (*((volatile unsigned int*) RCIC_STATUS_reg)=data)
+#define get_RCIC_STATUS_reg   (*((volatile unsigned int*) RCIC_STATUS_reg))
+#define RCIC_STATUS_inst_adr                                                         "0x006A"
+#define RCIC_STATUS_inst                                                             0x006A
+#define RCIC_STATUS_entry_shift                                                      (1)
+#define RCIC_STATUS_entry_mask                                                       (0x0000000E)
+#define RCIC_STATUS_entry(data)                                                      (0x0000000E&((data)<<1))
+#define RCIC_STATUS_entry_src(data)                                                  ((0x0000000E&(data))>>1)
+#define RCIC_STATUS_get_entry(data)                                                  ((0x0000000E&(data))>>1)
+#define RCIC_STATUS_done_shift                                                       (0)
+#define RCIC_STATUS_done_mask                                                        (0x00000001)
+#define RCIC_STATUS_done(data)                                                       (0x00000001&((data)<<0))
+#define RCIC_STATUS_done_src(data)                                                   ((0x00000001&(data))>>0)
+#define RCIC_STATUS_get_done(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define RCIC_ENTR_SRC_0                                                              0x180159AC
+#define RCIC_ENTR_SRC_1                                                              0x180159B0
+#define RCIC_ENTR_SRC_2                                                              0x180159B4
+#define RCIC_ENTR_SRC_3                                                              0x180159B8
+#define RCIC_ENTR_SRC_4                                                              0x180159BC
+#define RCIC_ENTR_SRC_5                                                              0x180159C0
+#define RCIC_ENTR_SRC_6                                                              0x180159C4
+#define RCIC_ENTR_SRC_7                                                              0x180159C8
+#define RCIC_ENTR_SRC_0_reg_addr                                                     "0xB80159AC"
+#define RCIC_ENTR_SRC_1_reg_addr                                                     "0xB80159B0"
+#define RCIC_ENTR_SRC_2_reg_addr                                                     "0xB80159B4"
+#define RCIC_ENTR_SRC_3_reg_addr                                                     "0xB80159B8"
+#define RCIC_ENTR_SRC_4_reg_addr                                                     "0xB80159BC"
+#define RCIC_ENTR_SRC_5_reg_addr                                                     "0xB80159C0"
+#define RCIC_ENTR_SRC_6_reg_addr                                                     "0xB80159C4"
+#define RCIC_ENTR_SRC_7_reg_addr                                                     "0xB80159C8"
+#define RCIC_ENTR_SRC_0_reg                                                          0xB80159AC
+#define RCIC_ENTR_SRC_1_reg                                                          0xB80159B0
+#define RCIC_ENTR_SRC_2_reg                                                          0xB80159B4
+#define RCIC_ENTR_SRC_3_reg                                                          0xB80159B8
+#define RCIC_ENTR_SRC_4_reg                                                          0xB80159BC
+#define RCIC_ENTR_SRC_5_reg                                                          0xB80159C0
+#define RCIC_ENTR_SRC_6_reg                                                          0xB80159C4
+#define RCIC_ENTR_SRC_7_reg                                                          0xB80159C8
+#define set_RCIC_ENTR_SRC_0_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_SRC_0_reg)=data)
+#define set_RCIC_ENTR_SRC_1_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_SRC_1_reg)=data)
+#define set_RCIC_ENTR_SRC_2_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_SRC_2_reg)=data)
+#define set_RCIC_ENTR_SRC_3_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_SRC_3_reg)=data)
+#define set_RCIC_ENTR_SRC_4_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_SRC_4_reg)=data)
+#define set_RCIC_ENTR_SRC_5_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_SRC_5_reg)=data)
+#define set_RCIC_ENTR_SRC_6_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_SRC_6_reg)=data)
+#define set_RCIC_ENTR_SRC_7_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_SRC_7_reg)=data)
+#define get_RCIC_ENTR_SRC_0_reg   (*((volatile unsigned int*) RCIC_ENTR_SRC_0_reg))
+#define get_RCIC_ENTR_SRC_1_reg   (*((volatile unsigned int*) RCIC_ENTR_SRC_1_reg))
+#define get_RCIC_ENTR_SRC_2_reg   (*((volatile unsigned int*) RCIC_ENTR_SRC_2_reg))
+#define get_RCIC_ENTR_SRC_3_reg   (*((volatile unsigned int*) RCIC_ENTR_SRC_3_reg))
+#define get_RCIC_ENTR_SRC_4_reg   (*((volatile unsigned int*) RCIC_ENTR_SRC_4_reg))
+#define get_RCIC_ENTR_SRC_5_reg   (*((volatile unsigned int*) RCIC_ENTR_SRC_5_reg))
+#define get_RCIC_ENTR_SRC_6_reg   (*((volatile unsigned int*) RCIC_ENTR_SRC_6_reg))
+#define get_RCIC_ENTR_SRC_7_reg   (*((volatile unsigned int*) RCIC_ENTR_SRC_7_reg))
+#define RCIC_ENTR_SRC_0_inst_adr                                                     "0x006B"
+#define RCIC_ENTR_SRC_1_inst_adr                                                     "0x006C"
+#define RCIC_ENTR_SRC_2_inst_adr                                                     "0x006D"
+#define RCIC_ENTR_SRC_3_inst_adr                                                     "0x006E"
+#define RCIC_ENTR_SRC_4_inst_adr                                                     "0x006F"
+#define RCIC_ENTR_SRC_5_inst_adr                                                     "0x0070"
+#define RCIC_ENTR_SRC_6_inst_adr                                                     "0x0071"
+#define RCIC_ENTR_SRC_7_inst_adr                                                     "0x0072"
+#define RCIC_ENTR_SRC_0_inst                                                         0x006B
+#define RCIC_ENTR_SRC_1_inst                                                         0x006C
+#define RCIC_ENTR_SRC_2_inst                                                         0x006D
+#define RCIC_ENTR_SRC_3_inst                                                         0x006E
+#define RCIC_ENTR_SRC_4_inst                                                         0x006F
+#define RCIC_ENTR_SRC_5_inst                                                         0x0070
+#define RCIC_ENTR_SRC_6_inst                                                         0x0071
+#define RCIC_ENTR_SRC_7_inst                                                         0x0072
+#define RCIC_ENTR_SRC_adr_shift                                                      (0)
+#define RCIC_ENTR_SRC_adr_mask                                                       (0xFFFFFFFF)
+#define RCIC_ENTR_SRC_adr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define RCIC_ENTR_SRC_adr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define RCIC_ENTR_SRC_get_adr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define RCIC_ENTR_DST_0                                                              0x180159CC
+#define RCIC_ENTR_DST_1                                                              0x180159D0
+#define RCIC_ENTR_DST_2                                                              0x180159D4
+#define RCIC_ENTR_DST_3                                                              0x180159D8
+#define RCIC_ENTR_DST_4                                                              0x180159DC
+#define RCIC_ENTR_DST_5                                                              0x180159E0
+#define RCIC_ENTR_DST_6                                                              0x180159E4
+#define RCIC_ENTR_DST_7                                                              0x180159E8
+#define RCIC_ENTR_DST_0_reg_addr                                                     "0xB80159CC"
+#define RCIC_ENTR_DST_1_reg_addr                                                     "0xB80159D0"
+#define RCIC_ENTR_DST_2_reg_addr                                                     "0xB80159D4"
+#define RCIC_ENTR_DST_3_reg_addr                                                     "0xB80159D8"
+#define RCIC_ENTR_DST_4_reg_addr                                                     "0xB80159DC"
+#define RCIC_ENTR_DST_5_reg_addr                                                     "0xB80159E0"
+#define RCIC_ENTR_DST_6_reg_addr                                                     "0xB80159E4"
+#define RCIC_ENTR_DST_7_reg_addr                                                     "0xB80159E8"
+#define RCIC_ENTR_DST_0_reg                                                          0xB80159CC
+#define RCIC_ENTR_DST_1_reg                                                          0xB80159D0
+#define RCIC_ENTR_DST_2_reg                                                          0xB80159D4
+#define RCIC_ENTR_DST_3_reg                                                          0xB80159D8
+#define RCIC_ENTR_DST_4_reg                                                          0xB80159DC
+#define RCIC_ENTR_DST_5_reg                                                          0xB80159E0
+#define RCIC_ENTR_DST_6_reg                                                          0xB80159E4
+#define RCIC_ENTR_DST_7_reg                                                          0xB80159E8
+#define set_RCIC_ENTR_DST_0_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_DST_0_reg)=data)
+#define set_RCIC_ENTR_DST_1_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_DST_1_reg)=data)
+#define set_RCIC_ENTR_DST_2_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_DST_2_reg)=data)
+#define set_RCIC_ENTR_DST_3_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_DST_3_reg)=data)
+#define set_RCIC_ENTR_DST_4_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_DST_4_reg)=data)
+#define set_RCIC_ENTR_DST_5_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_DST_5_reg)=data)
+#define set_RCIC_ENTR_DST_6_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_DST_6_reg)=data)
+#define set_RCIC_ENTR_DST_7_reg(data)   (*((volatile unsigned int*) RCIC_ENTR_DST_7_reg)=data)
+#define get_RCIC_ENTR_DST_0_reg   (*((volatile unsigned int*) RCIC_ENTR_DST_0_reg))
+#define get_RCIC_ENTR_DST_1_reg   (*((volatile unsigned int*) RCIC_ENTR_DST_1_reg))
+#define get_RCIC_ENTR_DST_2_reg   (*((volatile unsigned int*) RCIC_ENTR_DST_2_reg))
+#define get_RCIC_ENTR_DST_3_reg   (*((volatile unsigned int*) RCIC_ENTR_DST_3_reg))
+#define get_RCIC_ENTR_DST_4_reg   (*((volatile unsigned int*) RCIC_ENTR_DST_4_reg))
+#define get_RCIC_ENTR_DST_5_reg   (*((volatile unsigned int*) RCIC_ENTR_DST_5_reg))
+#define get_RCIC_ENTR_DST_6_reg   (*((volatile unsigned int*) RCIC_ENTR_DST_6_reg))
+#define get_RCIC_ENTR_DST_7_reg   (*((volatile unsigned int*) RCIC_ENTR_DST_7_reg))
+#define RCIC_ENTR_DST_0_inst_adr                                                     "0x0073"
+#define RCIC_ENTR_DST_1_inst_adr                                                     "0x0074"
+#define RCIC_ENTR_DST_2_inst_adr                                                     "0x0075"
+#define RCIC_ENTR_DST_3_inst_adr                                                     "0x0076"
+#define RCIC_ENTR_DST_4_inst_adr                                                     "0x0077"
+#define RCIC_ENTR_DST_5_inst_adr                                                     "0x0078"
+#define RCIC_ENTR_DST_6_inst_adr                                                     "0x0079"
+#define RCIC_ENTR_DST_7_inst_adr                                                     "0x007A"
+#define RCIC_ENTR_DST_0_inst                                                         0x0073
+#define RCIC_ENTR_DST_1_inst                                                         0x0074
+#define RCIC_ENTR_DST_2_inst                                                         0x0075
+#define RCIC_ENTR_DST_3_inst                                                         0x0076
+#define RCIC_ENTR_DST_4_inst                                                         0x0077
+#define RCIC_ENTR_DST_5_inst                                                         0x0078
+#define RCIC_ENTR_DST_6_inst                                                         0x0079
+#define RCIC_ENTR_DST_7_inst                                                         0x007A
+#define RCIC_ENTR_DST_adr_shift                                                      (0)
+#define RCIC_ENTR_DST_adr_mask                                                       (0xFFFFFFFF)
+#define RCIC_ENTR_DST_adr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define RCIC_ENTR_DST_adr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define RCIC_ENTR_DST_get_adr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define RCIC_INT_EN                                                                  0x180159ec
+#define RCIC_INT_EN_reg_addr                                                         "0xB80159EC"
+#define RCIC_INT_EN_reg                                                              0xB80159EC
+#define set_RCIC_INT_EN_reg(data)   (*((volatile unsigned int*) RCIC_INT_EN_reg)=data)
+#define get_RCIC_INT_EN_reg   (*((volatile unsigned int*) RCIC_INT_EN_reg))
+#define RCIC_INT_EN_inst_adr                                                         "0x007B"
+#define RCIC_INT_EN_inst                                                             0x007B
+#define RCIC_INT_EN_rcic_bc_shift                                                    (1)
+#define RCIC_INT_EN_rcic_bc_mask                                                     (0x00000002)
+#define RCIC_INT_EN_rcic_bc(data)                                                    (0x00000002&((data)<<1))
+#define RCIC_INT_EN_rcic_bc_src(data)                                                ((0x00000002&(data))>>1)
+#define RCIC_INT_EN_get_rcic_bc(data)                                                ((0x00000002&(data))>>1)
+#define RCIC_INT_EN_int_en_shift                                                     (0)
+#define RCIC_INT_EN_int_en_mask                                                      (0x00000001)
+#define RCIC_INT_EN_int_en(data)                                                     (0x00000001&((data)<<0))
+#define RCIC_INT_EN_int_en_src(data)                                                 ((0x00000001&(data))>>0)
+#define RCIC_INT_EN_get_int_en(data)                                                 ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/md_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/md_reg.h
new file mode 100644
index 00000000..3043a63
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/md_reg.h
@@ -0,0 +1,2083 @@
+/**************************************************************
+// Spec Version                  : 0.4
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/4/19 10:44:17
+***************************************************************/
+
+
+#ifndef _MD_REG_H_INCLUDED_
+#define _MD_REG_H_INCLUDED_
+#ifdef  _MD_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     smq_idle:1;
+unsigned int     smq_cmd_swap:1;
+unsigned int     smq_go:1;
+unsigned int     write_data:1;
+}MD_SMQ_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     gsp_length_err:1;
+unsigned int     gsp_rx_thd_ints:1;
+unsigned int     gsp_txdat_thd_ints:1;
+unsigned int     gsp_txbasic_thd_ints:1;
+unsigned int     gsp_tx_thd_ints:1;
+unsigned int     smq_chksum_err:1;
+unsigned int     ur_length_err:1;
+unsigned int     ur_rx_timeout:1;
+unsigned int     ur_rx_thd:1;
+unsigned int     ur_tx_thd:1;
+unsigned int     smq_mode_2b4berr:1;
+unsigned int     fdma_done:1;
+unsigned int     smq_empty:1;
+unsigned int     smq_length_err:1;
+unsigned int     smq_inst_err:1;
+unsigned int     write_data:1;
+}MD_SMQ_INT_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     scpu_int_en:1;
+unsigned int     gsp_length_err_en:1;
+unsigned int     gsp_rx_thd_en:1;
+unsigned int     gsp_txdat_thd_en:1;
+unsigned int     gsp_txbasic_thd_en:1;
+unsigned int     gsp_tx_thd_en:1;
+unsigned int     smq_chksum_err_en:1;
+unsigned int     ur_length_err_en:1;
+unsigned int     ur_rx_timeout_en:1;
+unsigned int     ur_rx_thd_en:1;
+unsigned int     ur_tx_thd_en:1;
+unsigned int     smq_mode_2b4b_err_en:1;
+unsigned int     fdma_done_en:1;
+unsigned int     smq_empty_en:1;
+unsigned int     smq_length_err_en:1;
+unsigned int     smq_inst_err_en:1;
+unsigned int     write_data:1;
+}MD_SMQ_INT_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     smq_base:27;
+unsigned int     reserved_1:4;
+}MD_SMQBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     smq_limit:27;
+unsigned int     reserved_1:4;
+}MD_SMQLIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     smq_rdptr:27;
+unsigned int     reserved_1:4;
+}MD_SMQRDPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     smq_wrptr:27;
+unsigned int     reserved_1:4;
+}MD_SMQWRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     smq_inst_remain:5;
+}MD_SMQFIFOSTATE;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     smq_inst_cnt:16;
+}MD_SMQ_INSTCNT;
+
+typedef struct 
+{
+unsigned int     smq_chksum:32;
+}MD_SMQ_CHKSUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     vmq_idle:1;
+unsigned int     vmq_cmd_swap:1;
+unsigned int     vmq_go:1;
+unsigned int     write_data:1;
+}MD_VMQ_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     vmq_chksum_err:1;
+unsigned int     vmq_mode_2b4berr:1;
+unsigned int     vmq_empty:1;
+unsigned int     vmq_length_err:1;
+unsigned int     vmq_inst_err:1;
+unsigned int     write_data:1;
+}MD_VMQ_INT_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     vcpu_int_en:1;
+unsigned int     vmq_chksum_err_en:1;
+unsigned int     vmq_mode_2b4b_err_en:1;
+unsigned int     vmq_empty_en:1;
+unsigned int     vmq_length_err_en:1;
+unsigned int     vmq_inst_err_en:1;
+unsigned int     write_data:1;
+}MD_VMQ_INT_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     vmq_base:27;
+unsigned int     reserved_1:4;
+}MD_VMQBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     vmq_limit:27;
+unsigned int     reserved_1:4;
+}MD_VMQLIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     vmq_rdptr:27;
+unsigned int     reserved_1:4;
+}MD_VMQRDPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     vmq_wrptr:27;
+unsigned int     reserved_1:4;
+}MD_VMQWRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     vmq_inst_remain:5;
+}MD_VMQFIFOSTATE;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     vmq_inst_cnt:16;
+}MD_VMQ_INSTCNT;
+
+typedef struct 
+{
+unsigned int     vmq_chksum:32;
+}MD_VMQ_CHKSUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     kmq_idle:1;
+unsigned int     kmq_cmd_swap:1;
+unsigned int     kmq_go:1;
+unsigned int     write_data:1;
+}MD_KMQ_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     kmq_chksum_err:1;
+unsigned int     kmq_mode_2b4berr:1;
+unsigned int     kmq_empty:1;
+unsigned int     kmq_length_err:1;
+unsigned int     kmq_inst_err:1;
+unsigned int     write_data:1;
+}MD_KMQ_INT_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     kcpu_int_en:1;
+unsigned int     kmq_chksum_err_en:1;
+unsigned int     kmq_mode_2b4b_err_en:1;
+unsigned int     kmq_empty_en:1;
+unsigned int     kmq_length_err_en:1;
+unsigned int     kmq_inst_err_en:1;
+unsigned int     write_data:1;
+}MD_KMQ_INT_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     kmq_base:27;
+unsigned int     reserved_1:4;
+}MD_KMQBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     kmq_limit:27;
+unsigned int     reserved_1:4;
+}MD_KMQLIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     kmq_rdptr:27;
+unsigned int     reserved_1:4;
+}MD_KMQRDPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     kmq_wrptr:27;
+unsigned int     reserved_1:4;
+}MD_KMQWRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     kmq_inst_remain:5;
+}MD_KMQFIFOSTATE;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     kmq_inst_cnt:16;
+}MD_KMQ_INSTCNT;
+
+typedef struct 
+{
+unsigned int     kmq_chksum:32;
+}MD_KMQ_CHKSUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     md_dbg_sel1:7;
+unsigned int     md_dbg_sel0:7;
+unsigned int     md_dbg_enable:1;
+}MD_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     fdma_ddr_saddr:31;
+}MD_FDMA_DDR_SADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     fdma_fl_saddr:25;
+}MD_FDMA_FL_SADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     fl_cp_en:1;
+unsigned int     fl_mapping_mode:1;
+unsigned int     fdma_swap:1;
+unsigned int     fdma_max_xfer:2;
+unsigned int     fdma_dir:1;
+unsigned int     fdma_length:25;
+}MD_FDMA_CTRL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     write_en2:1;
+unsigned int     fdma_stop:1;
+unsigned int     write_en1:1;
+unsigned int     fdma_go:1;
+}MD_FDMA_CTRL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     tx_base:28;
+unsigned int     reserved_1:3;
+}MD_UR_TXBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     tx_limit:28;
+unsigned int     reserved_1:3;
+}MD_UR_TXLIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     tx_wrptr:31;
+}MD_UR_TXWRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     tx_rdptr:31;
+}MD_UR_TXRDPTR;
+
+typedef struct 
+{
+unsigned int     tx_thd:32;
+}MD_UR_TXTHD;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rx_base:28;
+unsigned int     reserved_1:3;
+}MD_UR_RXBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rx_limit:28;
+unsigned int     reserved_1:3;
+}MD_UR_RXLIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rx_wrptr:31;
+}MD_UR_RXWRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rx_rdptr:31;
+}MD_UR_RXRDPTR;
+
+typedef struct 
+{
+unsigned int     rx_thd:32;
+}MD_UR_RXTHD;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     ur_en:1;
+}MD_UR_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_tx_base:28;
+unsigned int     reserved_1:3;
+}MD_GSP_TXBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_tx_limit:28;
+unsigned int     reserved_1:3;
+}MD_GSP_TXLIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_tx_wrptr:31;
+}MD_GSP_TXWRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_tx_rdptr:31;
+}MD_GSP_TXRDPTR;
+
+typedef struct 
+{
+unsigned int     gsp_tx_thd:32;
+}MD_GSP_TXTHD;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_rx_base:28;
+unsigned int     reserved_1:3;
+}MD_GSP_RXBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_rx_limit:28;
+unsigned int     reserved_1:3;
+}MD_GSP_RXLIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_rx_wrptr:31;
+}MD_GSP_RXWRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_rx_rdptr:31;
+}MD_GSP_RXRDPTR;
+
+typedef struct 
+{
+unsigned int     gsp_rx_thd:32;
+}MD_GSP_RXTHD;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     gsp_en:1;
+}MD_GSP_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_txbasic_base:28;
+unsigned int     reserved_1:3;
+}MD_GSP_TXBASICBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_txbasic_limit:28;
+unsigned int     reserved_1:3;
+}MD_GSP_TXBASICLIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_txbasic_wrptr:31;
+}MD_GSP_TXBASICWRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_txbasic_rdptr:31;
+}MD_GSP_TXBASICRDPTR;
+
+typedef struct 
+{
+unsigned int     gsp_txbasic_thd:32;
+}MD_GSP_TXBASICTHD;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_txdat_base:28;
+unsigned int     reserved_1:3;
+}MD_GSP_TXDATBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_txdat_limit:28;
+unsigned int     reserved_1:3;
+}MD_GSP_TXDATLIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_txdat_wrptr:31;
+}MD_GSP_TXDATWRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     gsp_txdat_rdptr:31;
+}MD_GSP_TXDATRDPTR;
+
+typedef struct 
+{
+unsigned int     gsp_txdat_thd:32;
+}MD_GSP_TXDATTHD;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     gating_en:1;
+}MD_POWER;
+
+typedef struct 
+{
+unsigned int     dummy1:32;
+}MD_DUMMY1;
+
+typedef struct 
+{
+unsigned int     dummy2:32;
+}MD_DUMMY2;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     dvse:1;
+unsigned int     dvs_3:1;
+unsigned int     dvs_2:1;
+unsigned int     dvs_1:1;
+unsigned int     dvs_0:1;
+}BIST_DVS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     bist_fail2:1;
+unsigned int     bist_fail1:1;
+unsigned int     bist_fail0:1;
+unsigned int     bist_done:1;
+}BIST_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:12;
+unsigned int     drf_fail2:1;
+unsigned int     drf_fail1:1;
+unsigned int     drf_fail0:1;
+unsigned int     drf_done:1;
+}DRF_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     drf_test_resume:1;
+unsigned int     drf_bist_mode:1;
+unsigned int     bist_mode:1;
+}MBIST_CON;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     smq_freerun:1;
+}MD_SMQFREERUN;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     vmq_freerun:1;
+}MD_VMQFREERUN;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     kmq_freerun:1;
+}MD_KMQFREERUN;
+
+#endif
+
+#define MD_SMQ_CNTL                                                                  0x1800B000
+#define MD_SMQ_CNTL_reg_addr                                                         "0xB800B000"
+#define MD_SMQ_CNTL_reg                                                              0xB800B000
+#define set_MD_SMQ_CNTL_reg(data)   (*((volatile unsigned int*) MD_SMQ_CNTL_reg)=data)
+#define get_MD_SMQ_CNTL_reg   (*((volatile unsigned int*) MD_SMQ_CNTL_reg))
+#define MD_SMQ_CNTL_inst_adr                                                         "0x0000"
+#define MD_SMQ_CNTL_inst                                                             0x0000
+#define MD_SMQ_CNTL_smq_idle_shift                                                   (3)
+#define MD_SMQ_CNTL_smq_idle_mask                                                    (0x00000008)
+#define MD_SMQ_CNTL_smq_idle(data)                                                   (0x00000008&((data)<<3))
+#define MD_SMQ_CNTL_smq_idle_src(data)                                               ((0x00000008&(data))>>3)
+#define MD_SMQ_CNTL_get_smq_idle(data)                                               ((0x00000008&(data))>>3)
+#define MD_SMQ_CNTL_smq_cmd_swap_shift                                               (2)
+#define MD_SMQ_CNTL_smq_cmd_swap_mask                                                (0x00000004)
+#define MD_SMQ_CNTL_smq_cmd_swap(data)                                               (0x00000004&((data)<<2))
+#define MD_SMQ_CNTL_smq_cmd_swap_src(data)                                           ((0x00000004&(data))>>2)
+#define MD_SMQ_CNTL_get_smq_cmd_swap(data)                                           ((0x00000004&(data))>>2)
+#define MD_SMQ_CNTL_smq_go_shift                                                     (1)
+#define MD_SMQ_CNTL_smq_go_mask                                                      (0x00000002)
+#define MD_SMQ_CNTL_smq_go(data)                                                     (0x00000002&((data)<<1))
+#define MD_SMQ_CNTL_smq_go_src(data)                                                 ((0x00000002&(data))>>1)
+#define MD_SMQ_CNTL_get_smq_go(data)                                                 ((0x00000002&(data))>>1)
+#define MD_SMQ_CNTL_write_data_shift                                                 (0)
+#define MD_SMQ_CNTL_write_data_mask                                                  (0x00000001)
+#define MD_SMQ_CNTL_write_data(data)                                                 (0x00000001&((data)<<0))
+#define MD_SMQ_CNTL_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define MD_SMQ_CNTL_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MD_SMQ_INT_STATUS                                                            0x1800B004
+#define MD_SMQ_INT_STATUS_reg_addr                                                   "0xB800B004"
+#define MD_SMQ_INT_STATUS_reg                                                        0xB800B004
+#define set_MD_SMQ_INT_STATUS_reg(data)   (*((volatile unsigned int*) MD_SMQ_INT_STATUS_reg)=data)
+#define get_MD_SMQ_INT_STATUS_reg   (*((volatile unsigned int*) MD_SMQ_INT_STATUS_reg))
+#define MD_SMQ_INT_STATUS_inst_adr                                                   "0x0001"
+#define MD_SMQ_INT_STATUS_inst                                                       0x0001
+#define MD_SMQ_INT_STATUS_gsp_length_err_shift                                       (15)
+#define MD_SMQ_INT_STATUS_gsp_length_err_mask                                        (0x00008000)
+#define MD_SMQ_INT_STATUS_gsp_length_err(data)                                       (0x00008000&((data)<<15))
+#define MD_SMQ_INT_STATUS_gsp_length_err_src(data)                                   ((0x00008000&(data))>>15)
+#define MD_SMQ_INT_STATUS_get_gsp_length_err(data)                                   ((0x00008000&(data))>>15)
+#define MD_SMQ_INT_STATUS_gsp_rx_thd_ints_shift                                      (14)
+#define MD_SMQ_INT_STATUS_gsp_rx_thd_ints_mask                                       (0x00004000)
+#define MD_SMQ_INT_STATUS_gsp_rx_thd_ints(data)                                      (0x00004000&((data)<<14))
+#define MD_SMQ_INT_STATUS_gsp_rx_thd_ints_src(data)                                  ((0x00004000&(data))>>14)
+#define MD_SMQ_INT_STATUS_get_gsp_rx_thd_ints(data)                                  ((0x00004000&(data))>>14)
+#define MD_SMQ_INT_STATUS_gsp_txdat_thd_ints_shift                                   (13)
+#define MD_SMQ_INT_STATUS_gsp_txdat_thd_ints_mask                                    (0x00002000)
+#define MD_SMQ_INT_STATUS_gsp_txdat_thd_ints(data)                                   (0x00002000&((data)<<13))
+#define MD_SMQ_INT_STATUS_gsp_txdat_thd_ints_src(data)                               ((0x00002000&(data))>>13)
+#define MD_SMQ_INT_STATUS_get_gsp_txdat_thd_ints(data)                               ((0x00002000&(data))>>13)
+#define MD_SMQ_INT_STATUS_gsp_txbasic_thd_ints_shift                                 (12)
+#define MD_SMQ_INT_STATUS_gsp_txbasic_thd_ints_mask                                  (0x00001000)
+#define MD_SMQ_INT_STATUS_gsp_txbasic_thd_ints(data)                                 (0x00001000&((data)<<12))
+#define MD_SMQ_INT_STATUS_gsp_txbasic_thd_ints_src(data)                             ((0x00001000&(data))>>12)
+#define MD_SMQ_INT_STATUS_get_gsp_txbasic_thd_ints(data)                             ((0x00001000&(data))>>12)
+#define MD_SMQ_INT_STATUS_gsp_tx_thd_ints_shift                                      (11)
+#define MD_SMQ_INT_STATUS_gsp_tx_thd_ints_mask                                       (0x00000800)
+#define MD_SMQ_INT_STATUS_gsp_tx_thd_ints(data)                                      (0x00000800&((data)<<11))
+#define MD_SMQ_INT_STATUS_gsp_tx_thd_ints_src(data)                                  ((0x00000800&(data))>>11)
+#define MD_SMQ_INT_STATUS_get_gsp_tx_thd_ints(data)                                  ((0x00000800&(data))>>11)
+#define MD_SMQ_INT_STATUS_smq_chksum_err_shift                                       (10)
+#define MD_SMQ_INT_STATUS_smq_chksum_err_mask                                        (0x00000400)
+#define MD_SMQ_INT_STATUS_smq_chksum_err(data)                                       (0x00000400&((data)<<10))
+#define MD_SMQ_INT_STATUS_smq_chksum_err_src(data)                                   ((0x00000400&(data))>>10)
+#define MD_SMQ_INT_STATUS_get_smq_chksum_err(data)                                   ((0x00000400&(data))>>10)
+#define MD_SMQ_INT_STATUS_ur_length_err_shift                                        (9)
+#define MD_SMQ_INT_STATUS_ur_length_err_mask                                         (0x00000200)
+#define MD_SMQ_INT_STATUS_ur_length_err(data)                                        (0x00000200&((data)<<9))
+#define MD_SMQ_INT_STATUS_ur_length_err_src(data)                                    ((0x00000200&(data))>>9)
+#define MD_SMQ_INT_STATUS_get_ur_length_err(data)                                    ((0x00000200&(data))>>9)
+#define MD_SMQ_INT_STATUS_ur_rx_timeout_shift                                        (8)
+#define MD_SMQ_INT_STATUS_ur_rx_timeout_mask                                         (0x00000100)
+#define MD_SMQ_INT_STATUS_ur_rx_timeout(data)                                        (0x00000100&((data)<<8))
+#define MD_SMQ_INT_STATUS_ur_rx_timeout_src(data)                                    ((0x00000100&(data))>>8)
+#define MD_SMQ_INT_STATUS_get_ur_rx_timeout(data)                                    ((0x00000100&(data))>>8)
+#define MD_SMQ_INT_STATUS_ur_rx_thd_shift                                            (7)
+#define MD_SMQ_INT_STATUS_ur_rx_thd_mask                                             (0x00000080)
+#define MD_SMQ_INT_STATUS_ur_rx_thd(data)                                            (0x00000080&((data)<<7))
+#define MD_SMQ_INT_STATUS_ur_rx_thd_src(data)                                        ((0x00000080&(data))>>7)
+#define MD_SMQ_INT_STATUS_get_ur_rx_thd(data)                                        ((0x00000080&(data))>>7)
+#define MD_SMQ_INT_STATUS_ur_tx_thd_shift                                            (6)
+#define MD_SMQ_INT_STATUS_ur_tx_thd_mask                                             (0x00000040)
+#define MD_SMQ_INT_STATUS_ur_tx_thd(data)                                            (0x00000040&((data)<<6))
+#define MD_SMQ_INT_STATUS_ur_tx_thd_src(data)                                        ((0x00000040&(data))>>6)
+#define MD_SMQ_INT_STATUS_get_ur_tx_thd(data)                                        ((0x00000040&(data))>>6)
+#define MD_SMQ_INT_STATUS_smq_mode_2b4berr_shift                                     (5)
+#define MD_SMQ_INT_STATUS_smq_mode_2b4berr_mask                                      (0x00000020)
+#define MD_SMQ_INT_STATUS_smq_mode_2b4berr(data)                                     (0x00000020&((data)<<5))
+#define MD_SMQ_INT_STATUS_smq_mode_2b4berr_src(data)                                 ((0x00000020&(data))>>5)
+#define MD_SMQ_INT_STATUS_get_smq_mode_2b4berr(data)                                 ((0x00000020&(data))>>5)
+#define MD_SMQ_INT_STATUS_fdma_done_shift                                            (4)
+#define MD_SMQ_INT_STATUS_fdma_done_mask                                             (0x00000010)
+#define MD_SMQ_INT_STATUS_fdma_done(data)                                            (0x00000010&((data)<<4))
+#define MD_SMQ_INT_STATUS_fdma_done_src(data)                                        ((0x00000010&(data))>>4)
+#define MD_SMQ_INT_STATUS_get_fdma_done(data)                                        ((0x00000010&(data))>>4)
+#define MD_SMQ_INT_STATUS_smq_empty_shift                                            (3)
+#define MD_SMQ_INT_STATUS_smq_empty_mask                                             (0x00000008)
+#define MD_SMQ_INT_STATUS_smq_empty(data)                                            (0x00000008&((data)<<3))
+#define MD_SMQ_INT_STATUS_smq_empty_src(data)                                        ((0x00000008&(data))>>3)
+#define MD_SMQ_INT_STATUS_get_smq_empty(data)                                        ((0x00000008&(data))>>3)
+#define MD_SMQ_INT_STATUS_smq_length_err_shift                                       (2)
+#define MD_SMQ_INT_STATUS_smq_length_err_mask                                        (0x00000004)
+#define MD_SMQ_INT_STATUS_smq_length_err(data)                                       (0x00000004&((data)<<2))
+#define MD_SMQ_INT_STATUS_smq_length_err_src(data)                                   ((0x00000004&(data))>>2)
+#define MD_SMQ_INT_STATUS_get_smq_length_err(data)                                   ((0x00000004&(data))>>2)
+#define MD_SMQ_INT_STATUS_smq_inst_err_shift                                         (1)
+#define MD_SMQ_INT_STATUS_smq_inst_err_mask                                          (0x00000002)
+#define MD_SMQ_INT_STATUS_smq_inst_err(data)                                         (0x00000002&((data)<<1))
+#define MD_SMQ_INT_STATUS_smq_inst_err_src(data)                                     ((0x00000002&(data))>>1)
+#define MD_SMQ_INT_STATUS_get_smq_inst_err(data)                                     ((0x00000002&(data))>>1)
+#define MD_SMQ_INT_STATUS_write_data_shift                                           (0)
+#define MD_SMQ_INT_STATUS_write_data_mask                                            (0x00000001)
+#define MD_SMQ_INT_STATUS_write_data(data)                                           (0x00000001&((data)<<0))
+#define MD_SMQ_INT_STATUS_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define MD_SMQ_INT_STATUS_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MD_SMQ_INT_ENABLE                                                            0x1800B008
+#define MD_SMQ_INT_ENABLE_reg_addr                                                   "0xB800B008"
+#define MD_SMQ_INT_ENABLE_reg                                                        0xB800B008
+#define set_MD_SMQ_INT_ENABLE_reg(data)   (*((volatile unsigned int*) MD_SMQ_INT_ENABLE_reg)=data)
+#define get_MD_SMQ_INT_ENABLE_reg   (*((volatile unsigned int*) MD_SMQ_INT_ENABLE_reg))
+#define MD_SMQ_INT_ENABLE_inst_adr                                                   "0x0002"
+#define MD_SMQ_INT_ENABLE_inst                                                       0x0002
+#define MD_SMQ_INT_ENABLE_scpu_int_en_shift                                          (16)
+#define MD_SMQ_INT_ENABLE_scpu_int_en_mask                                           (0x00010000)
+#define MD_SMQ_INT_ENABLE_scpu_int_en(data)                                          (0x00010000&((data)<<16))
+#define MD_SMQ_INT_ENABLE_scpu_int_en_src(data)                                      ((0x00010000&(data))>>16)
+#define MD_SMQ_INT_ENABLE_get_scpu_int_en(data)                                      ((0x00010000&(data))>>16)
+#define MD_SMQ_INT_ENABLE_gsp_length_err_en_shift                                    (15)
+#define MD_SMQ_INT_ENABLE_gsp_length_err_en_mask                                     (0x00008000)
+#define MD_SMQ_INT_ENABLE_gsp_length_err_en(data)                                    (0x00008000&((data)<<15))
+#define MD_SMQ_INT_ENABLE_gsp_length_err_en_src(data)                                ((0x00008000&(data))>>15)
+#define MD_SMQ_INT_ENABLE_get_gsp_length_err_en(data)                                ((0x00008000&(data))>>15)
+#define MD_SMQ_INT_ENABLE_gsp_rx_thd_en_shift                                        (14)
+#define MD_SMQ_INT_ENABLE_gsp_rx_thd_en_mask                                         (0x00004000)
+#define MD_SMQ_INT_ENABLE_gsp_rx_thd_en(data)                                        (0x00004000&((data)<<14))
+#define MD_SMQ_INT_ENABLE_gsp_rx_thd_en_src(data)                                    ((0x00004000&(data))>>14)
+#define MD_SMQ_INT_ENABLE_get_gsp_rx_thd_en(data)                                    ((0x00004000&(data))>>14)
+#define MD_SMQ_INT_ENABLE_gsp_txdat_thd_en_shift                                     (13)
+#define MD_SMQ_INT_ENABLE_gsp_txdat_thd_en_mask                                      (0x00002000)
+#define MD_SMQ_INT_ENABLE_gsp_txdat_thd_en(data)                                     (0x00002000&((data)<<13))
+#define MD_SMQ_INT_ENABLE_gsp_txdat_thd_en_src(data)                                 ((0x00002000&(data))>>13)
+#define MD_SMQ_INT_ENABLE_get_gsp_txdat_thd_en(data)                                 ((0x00002000&(data))>>13)
+#define MD_SMQ_INT_ENABLE_gsp_txbasic_thd_en_shift                                   (12)
+#define MD_SMQ_INT_ENABLE_gsp_txbasic_thd_en_mask                                    (0x00001000)
+#define MD_SMQ_INT_ENABLE_gsp_txbasic_thd_en(data)                                   (0x00001000&((data)<<12))
+#define MD_SMQ_INT_ENABLE_gsp_txbasic_thd_en_src(data)                               ((0x00001000&(data))>>12)
+#define MD_SMQ_INT_ENABLE_get_gsp_txbasic_thd_en(data)                               ((0x00001000&(data))>>12)
+#define MD_SMQ_INT_ENABLE_gsp_tx_thd_en_shift                                        (11)
+#define MD_SMQ_INT_ENABLE_gsp_tx_thd_en_mask                                         (0x00000800)
+#define MD_SMQ_INT_ENABLE_gsp_tx_thd_en(data)                                        (0x00000800&((data)<<11))
+#define MD_SMQ_INT_ENABLE_gsp_tx_thd_en_src(data)                                    ((0x00000800&(data))>>11)
+#define MD_SMQ_INT_ENABLE_get_gsp_tx_thd_en(data)                                    ((0x00000800&(data))>>11)
+#define MD_SMQ_INT_ENABLE_smq_chksum_err_en_shift                                    (10)
+#define MD_SMQ_INT_ENABLE_smq_chksum_err_en_mask                                     (0x00000400)
+#define MD_SMQ_INT_ENABLE_smq_chksum_err_en(data)                                    (0x00000400&((data)<<10))
+#define MD_SMQ_INT_ENABLE_smq_chksum_err_en_src(data)                                ((0x00000400&(data))>>10)
+#define MD_SMQ_INT_ENABLE_get_smq_chksum_err_en(data)                                ((0x00000400&(data))>>10)
+#define MD_SMQ_INT_ENABLE_ur_length_err_en_shift                                     (9)
+#define MD_SMQ_INT_ENABLE_ur_length_err_en_mask                                      (0x00000200)
+#define MD_SMQ_INT_ENABLE_ur_length_err_en(data)                                     (0x00000200&((data)<<9))
+#define MD_SMQ_INT_ENABLE_ur_length_err_en_src(data)                                 ((0x00000200&(data))>>9)
+#define MD_SMQ_INT_ENABLE_get_ur_length_err_en(data)                                 ((0x00000200&(data))>>9)
+#define MD_SMQ_INT_ENABLE_ur_rx_timeout_en_shift                                     (8)
+#define MD_SMQ_INT_ENABLE_ur_rx_timeout_en_mask                                      (0x00000100)
+#define MD_SMQ_INT_ENABLE_ur_rx_timeout_en(data)                                     (0x00000100&((data)<<8))
+#define MD_SMQ_INT_ENABLE_ur_rx_timeout_en_src(data)                                 ((0x00000100&(data))>>8)
+#define MD_SMQ_INT_ENABLE_get_ur_rx_timeout_en(data)                                 ((0x00000100&(data))>>8)
+#define MD_SMQ_INT_ENABLE_ur_rx_thd_en_shift                                         (7)
+#define MD_SMQ_INT_ENABLE_ur_rx_thd_en_mask                                          (0x00000080)
+#define MD_SMQ_INT_ENABLE_ur_rx_thd_en(data)                                         (0x00000080&((data)<<7))
+#define MD_SMQ_INT_ENABLE_ur_rx_thd_en_src(data)                                     ((0x00000080&(data))>>7)
+#define MD_SMQ_INT_ENABLE_get_ur_rx_thd_en(data)                                     ((0x00000080&(data))>>7)
+#define MD_SMQ_INT_ENABLE_ur_tx_thd_en_shift                                         (6)
+#define MD_SMQ_INT_ENABLE_ur_tx_thd_en_mask                                          (0x00000040)
+#define MD_SMQ_INT_ENABLE_ur_tx_thd_en(data)                                         (0x00000040&((data)<<6))
+#define MD_SMQ_INT_ENABLE_ur_tx_thd_en_src(data)                                     ((0x00000040&(data))>>6)
+#define MD_SMQ_INT_ENABLE_get_ur_tx_thd_en(data)                                     ((0x00000040&(data))>>6)
+#define MD_SMQ_INT_ENABLE_smq_mode_2b4b_err_en_shift                                 (5)
+#define MD_SMQ_INT_ENABLE_smq_mode_2b4b_err_en_mask                                  (0x00000020)
+#define MD_SMQ_INT_ENABLE_smq_mode_2b4b_err_en(data)                                 (0x00000020&((data)<<5))
+#define MD_SMQ_INT_ENABLE_smq_mode_2b4b_err_en_src(data)                             ((0x00000020&(data))>>5)
+#define MD_SMQ_INT_ENABLE_get_smq_mode_2b4b_err_en(data)                             ((0x00000020&(data))>>5)
+#define MD_SMQ_INT_ENABLE_fdma_done_en_shift                                         (4)
+#define MD_SMQ_INT_ENABLE_fdma_done_en_mask                                          (0x00000010)
+#define MD_SMQ_INT_ENABLE_fdma_done_en(data)                                         (0x00000010&((data)<<4))
+#define MD_SMQ_INT_ENABLE_fdma_done_en_src(data)                                     ((0x00000010&(data))>>4)
+#define MD_SMQ_INT_ENABLE_get_fdma_done_en(data)                                     ((0x00000010&(data))>>4)
+#define MD_SMQ_INT_ENABLE_smq_empty_en_shift                                         (3)
+#define MD_SMQ_INT_ENABLE_smq_empty_en_mask                                          (0x00000008)
+#define MD_SMQ_INT_ENABLE_smq_empty_en(data)                                         (0x00000008&((data)<<3))
+#define MD_SMQ_INT_ENABLE_smq_empty_en_src(data)                                     ((0x00000008&(data))>>3)
+#define MD_SMQ_INT_ENABLE_get_smq_empty_en(data)                                     ((0x00000008&(data))>>3)
+#define MD_SMQ_INT_ENABLE_smq_length_err_en_shift                                    (2)
+#define MD_SMQ_INT_ENABLE_smq_length_err_en_mask                                     (0x00000004)
+#define MD_SMQ_INT_ENABLE_smq_length_err_en(data)                                    (0x00000004&((data)<<2))
+#define MD_SMQ_INT_ENABLE_smq_length_err_en_src(data)                                ((0x00000004&(data))>>2)
+#define MD_SMQ_INT_ENABLE_get_smq_length_err_en(data)                                ((0x00000004&(data))>>2)
+#define MD_SMQ_INT_ENABLE_smq_inst_err_en_shift                                      (1)
+#define MD_SMQ_INT_ENABLE_smq_inst_err_en_mask                                       (0x00000002)
+#define MD_SMQ_INT_ENABLE_smq_inst_err_en(data)                                      (0x00000002&((data)<<1))
+#define MD_SMQ_INT_ENABLE_smq_inst_err_en_src(data)                                  ((0x00000002&(data))>>1)
+#define MD_SMQ_INT_ENABLE_get_smq_inst_err_en(data)                                  ((0x00000002&(data))>>1)
+#define MD_SMQ_INT_ENABLE_write_data_shift                                           (0)
+#define MD_SMQ_INT_ENABLE_write_data_mask                                            (0x00000001)
+#define MD_SMQ_INT_ENABLE_write_data(data)                                           (0x00000001&((data)<<0))
+#define MD_SMQ_INT_ENABLE_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define MD_SMQ_INT_ENABLE_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MD_SMQBASE                                                                   0x1800B00C
+#define MD_SMQBASE_reg_addr                                                          "0xB800B00C"
+#define MD_SMQBASE_reg                                                               0xB800B00C
+#define set_MD_SMQBASE_reg(data)   (*((volatile unsigned int*) MD_SMQBASE_reg)=data)
+#define get_MD_SMQBASE_reg   (*((volatile unsigned int*) MD_SMQBASE_reg))
+#define MD_SMQBASE_inst_adr                                                          "0x0003"
+#define MD_SMQBASE_inst                                                              0x0003
+#define MD_SMQBASE_smq_base_shift                                                    (4)
+#define MD_SMQBASE_smq_base_mask                                                     (0x7FFFFFF0)
+#define MD_SMQBASE_smq_base(data)                                                    (0x7FFFFFF0&((data)<<4))
+#define MD_SMQBASE_smq_base_src(data)                                                ((0x7FFFFFF0&(data))>>4)
+#define MD_SMQBASE_get_smq_base(data)                                                ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_SMQLIMIT                                                                  0x1800B010
+#define MD_SMQLIMIT_reg_addr                                                         "0xB800B010"
+#define MD_SMQLIMIT_reg                                                              0xB800B010
+#define set_MD_SMQLIMIT_reg(data)   (*((volatile unsigned int*) MD_SMQLIMIT_reg)=data)
+#define get_MD_SMQLIMIT_reg   (*((volatile unsigned int*) MD_SMQLIMIT_reg))
+#define MD_SMQLIMIT_inst_adr                                                         "0x0004"
+#define MD_SMQLIMIT_inst                                                             0x0004
+#define MD_SMQLIMIT_smq_limit_shift                                                  (4)
+#define MD_SMQLIMIT_smq_limit_mask                                                   (0x7FFFFFF0)
+#define MD_SMQLIMIT_smq_limit(data)                                                  (0x7FFFFFF0&((data)<<4))
+#define MD_SMQLIMIT_smq_limit_src(data)                                              ((0x7FFFFFF0&(data))>>4)
+#define MD_SMQLIMIT_get_smq_limit(data)                                              ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_SMQRDPTR                                                                  0x1800B014
+#define MD_SMQRDPTR_reg_addr                                                         "0xB800B014"
+#define MD_SMQRDPTR_reg                                                              0xB800B014
+#define set_MD_SMQRDPTR_reg(data)   (*((volatile unsigned int*) MD_SMQRDPTR_reg)=data)
+#define get_MD_SMQRDPTR_reg   (*((volatile unsigned int*) MD_SMQRDPTR_reg))
+#define MD_SMQRDPTR_inst_adr                                                         "0x0005"
+#define MD_SMQRDPTR_inst                                                             0x0005
+#define MD_SMQRDPTR_smq_rdptr_shift                                                  (4)
+#define MD_SMQRDPTR_smq_rdptr_mask                                                   (0x7FFFFFF0)
+#define MD_SMQRDPTR_smq_rdptr(data)                                                  (0x7FFFFFF0&((data)<<4))
+#define MD_SMQRDPTR_smq_rdptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
+#define MD_SMQRDPTR_get_smq_rdptr(data)                                              ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_SMQWRPTR                                                                  0x1800B018
+#define MD_SMQWRPTR_reg_addr                                                         "0xB800B018"
+#define MD_SMQWRPTR_reg                                                              0xB800B018
+#define set_MD_SMQWRPTR_reg(data)   (*((volatile unsigned int*) MD_SMQWRPTR_reg)=data)
+#define get_MD_SMQWRPTR_reg   (*((volatile unsigned int*) MD_SMQWRPTR_reg))
+#define MD_SMQWRPTR_inst_adr                                                         "0x0006"
+#define MD_SMQWRPTR_inst                                                             0x0006
+#define MD_SMQWRPTR_smq_wrptr_shift                                                  (4)
+#define MD_SMQWRPTR_smq_wrptr_mask                                                   (0x7FFFFFF0)
+#define MD_SMQWRPTR_smq_wrptr(data)                                                  (0x7FFFFFF0&((data)<<4))
+#define MD_SMQWRPTR_smq_wrptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
+#define MD_SMQWRPTR_get_smq_wrptr(data)                                              ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_SMQFIFOSTATE                                                              0x1800B01C
+#define MD_SMQFIFOSTATE_reg_addr                                                     "0xB800B01C"
+#define MD_SMQFIFOSTATE_reg                                                          0xB800B01C
+#define set_MD_SMQFIFOSTATE_reg(data)   (*((volatile unsigned int*) MD_SMQFIFOSTATE_reg)=data)
+#define get_MD_SMQFIFOSTATE_reg   (*((volatile unsigned int*) MD_SMQFIFOSTATE_reg))
+#define MD_SMQFIFOSTATE_inst_adr                                                     "0x0007"
+#define MD_SMQFIFOSTATE_inst                                                         0x0007
+#define MD_SMQFIFOSTATE_smq_inst_remain_shift                                        (0)
+#define MD_SMQFIFOSTATE_smq_inst_remain_mask                                         (0x0000001F)
+#define MD_SMQFIFOSTATE_smq_inst_remain(data)                                        (0x0000001F&((data)<<0))
+#define MD_SMQFIFOSTATE_smq_inst_remain_src(data)                                    ((0x0000001F&(data))>>0)
+#define MD_SMQFIFOSTATE_get_smq_inst_remain(data)                                    ((0x0000001F&(data))>>0)
+
+
+#define MD_SMQ_INSTCNT                                                               0x1800B020
+#define MD_SMQ_INSTCNT_reg_addr                                                      "0xB800B020"
+#define MD_SMQ_INSTCNT_reg                                                           0xB800B020
+#define set_MD_SMQ_INSTCNT_reg(data)   (*((volatile unsigned int*) MD_SMQ_INSTCNT_reg)=data)
+#define get_MD_SMQ_INSTCNT_reg   (*((volatile unsigned int*) MD_SMQ_INSTCNT_reg))
+#define MD_SMQ_INSTCNT_inst_adr                                                      "0x0008"
+#define MD_SMQ_INSTCNT_inst                                                          0x0008
+#define MD_SMQ_INSTCNT_smq_inst_cnt_shift                                            (0)
+#define MD_SMQ_INSTCNT_smq_inst_cnt_mask                                             (0x0000FFFF)
+#define MD_SMQ_INSTCNT_smq_inst_cnt(data)                                            (0x0000FFFF&((data)<<0))
+#define MD_SMQ_INSTCNT_smq_inst_cnt_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define MD_SMQ_INSTCNT_get_smq_inst_cnt(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define MD_SMQ_CHKSUM                                                                0x1800B024
+#define MD_SMQ_CHKSUM_reg_addr                                                       "0xB800B024"
+#define MD_SMQ_CHKSUM_reg                                                            0xB800B024
+#define set_MD_SMQ_CHKSUM_reg(data)   (*((volatile unsigned int*) MD_SMQ_CHKSUM_reg)=data)
+#define get_MD_SMQ_CHKSUM_reg   (*((volatile unsigned int*) MD_SMQ_CHKSUM_reg))
+#define MD_SMQ_CHKSUM_inst_adr                                                       "0x0009"
+#define MD_SMQ_CHKSUM_inst                                                           0x0009
+#define MD_SMQ_CHKSUM_smq_chksum_shift                                               (0)
+#define MD_SMQ_CHKSUM_smq_chksum_mask                                                (0xFFFFFFFF)
+#define MD_SMQ_CHKSUM_smq_chksum(data)                                               (0xFFFFFFFF&((data)<<0))
+#define MD_SMQ_CHKSUM_smq_chksum_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define MD_SMQ_CHKSUM_get_smq_chksum(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define MD_VMQ_CNTL                                                                  0x1800B030
+#define MD_VMQ_CNTL_reg_addr                                                         "0xB800B030"
+#define MD_VMQ_CNTL_reg                                                              0xB800B030
+#define set_MD_VMQ_CNTL_reg(data)   (*((volatile unsigned int*) MD_VMQ_CNTL_reg)=data)
+#define get_MD_VMQ_CNTL_reg   (*((volatile unsigned int*) MD_VMQ_CNTL_reg))
+#define MD_VMQ_CNTL_inst_adr                                                         "0x000C"
+#define MD_VMQ_CNTL_inst                                                             0x000C
+#define MD_VMQ_CNTL_vmq_idle_shift                                                   (3)
+#define MD_VMQ_CNTL_vmq_idle_mask                                                    (0x00000008)
+#define MD_VMQ_CNTL_vmq_idle(data)                                                   (0x00000008&((data)<<3))
+#define MD_VMQ_CNTL_vmq_idle_src(data)                                               ((0x00000008&(data))>>3)
+#define MD_VMQ_CNTL_get_vmq_idle(data)                                               ((0x00000008&(data))>>3)
+#define MD_VMQ_CNTL_vmq_cmd_swap_shift                                               (2)
+#define MD_VMQ_CNTL_vmq_cmd_swap_mask                                                (0x00000004)
+#define MD_VMQ_CNTL_vmq_cmd_swap(data)                                               (0x00000004&((data)<<2))
+#define MD_VMQ_CNTL_vmq_cmd_swap_src(data)                                           ((0x00000004&(data))>>2)
+#define MD_VMQ_CNTL_get_vmq_cmd_swap(data)                                           ((0x00000004&(data))>>2)
+#define MD_VMQ_CNTL_vmq_go_shift                                                     (1)
+#define MD_VMQ_CNTL_vmq_go_mask                                                      (0x00000002)
+#define MD_VMQ_CNTL_vmq_go(data)                                                     (0x00000002&((data)<<1))
+#define MD_VMQ_CNTL_vmq_go_src(data)                                                 ((0x00000002&(data))>>1)
+#define MD_VMQ_CNTL_get_vmq_go(data)                                                 ((0x00000002&(data))>>1)
+#define MD_VMQ_CNTL_write_data_shift                                                 (0)
+#define MD_VMQ_CNTL_write_data_mask                                                  (0x00000001)
+#define MD_VMQ_CNTL_write_data(data)                                                 (0x00000001&((data)<<0))
+#define MD_VMQ_CNTL_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define MD_VMQ_CNTL_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MD_VMQ_INT_STATUS                                                            0x1800B034
+#define MD_VMQ_INT_STATUS_reg_addr                                                   "0xB800B034"
+#define MD_VMQ_INT_STATUS_reg                                                        0xB800B034
+#define set_MD_VMQ_INT_STATUS_reg(data)   (*((volatile unsigned int*) MD_VMQ_INT_STATUS_reg)=data)
+#define get_MD_VMQ_INT_STATUS_reg   (*((volatile unsigned int*) MD_VMQ_INT_STATUS_reg))
+#define MD_VMQ_INT_STATUS_inst_adr                                                   "0x000D"
+#define MD_VMQ_INT_STATUS_inst                                                       0x000D
+#define MD_VMQ_INT_STATUS_vmq_chksum_err_shift                                       (5)
+#define MD_VMQ_INT_STATUS_vmq_chksum_err_mask                                        (0x00000020)
+#define MD_VMQ_INT_STATUS_vmq_chksum_err(data)                                       (0x00000020&((data)<<5))
+#define MD_VMQ_INT_STATUS_vmq_chksum_err_src(data)                                   ((0x00000020&(data))>>5)
+#define MD_VMQ_INT_STATUS_get_vmq_chksum_err(data)                                   ((0x00000020&(data))>>5)
+#define MD_VMQ_INT_STATUS_vmq_mode_2b4berr_shift                                     (4)
+#define MD_VMQ_INT_STATUS_vmq_mode_2b4berr_mask                                      (0x00000010)
+#define MD_VMQ_INT_STATUS_vmq_mode_2b4berr(data)                                     (0x00000010&((data)<<4))
+#define MD_VMQ_INT_STATUS_vmq_mode_2b4berr_src(data)                                 ((0x00000010&(data))>>4)
+#define MD_VMQ_INT_STATUS_get_vmq_mode_2b4berr(data)                                 ((0x00000010&(data))>>4)
+#define MD_VMQ_INT_STATUS_vmq_empty_shift                                            (3)
+#define MD_VMQ_INT_STATUS_vmq_empty_mask                                             (0x00000008)
+#define MD_VMQ_INT_STATUS_vmq_empty(data)                                            (0x00000008&((data)<<3))
+#define MD_VMQ_INT_STATUS_vmq_empty_src(data)                                        ((0x00000008&(data))>>3)
+#define MD_VMQ_INT_STATUS_get_vmq_empty(data)                                        ((0x00000008&(data))>>3)
+#define MD_VMQ_INT_STATUS_vmq_length_err_shift                                       (2)
+#define MD_VMQ_INT_STATUS_vmq_length_err_mask                                        (0x00000004)
+#define MD_VMQ_INT_STATUS_vmq_length_err(data)                                       (0x00000004&((data)<<2))
+#define MD_VMQ_INT_STATUS_vmq_length_err_src(data)                                   ((0x00000004&(data))>>2)
+#define MD_VMQ_INT_STATUS_get_vmq_length_err(data)                                   ((0x00000004&(data))>>2)
+#define MD_VMQ_INT_STATUS_vmq_inst_err_shift                                         (1)
+#define MD_VMQ_INT_STATUS_vmq_inst_err_mask                                          (0x00000002)
+#define MD_VMQ_INT_STATUS_vmq_inst_err(data)                                         (0x00000002&((data)<<1))
+#define MD_VMQ_INT_STATUS_vmq_inst_err_src(data)                                     ((0x00000002&(data))>>1)
+#define MD_VMQ_INT_STATUS_get_vmq_inst_err(data)                                     ((0x00000002&(data))>>1)
+#define MD_VMQ_INT_STATUS_write_data_shift                                           (0)
+#define MD_VMQ_INT_STATUS_write_data_mask                                            (0x00000001)
+#define MD_VMQ_INT_STATUS_write_data(data)                                           (0x00000001&((data)<<0))
+#define MD_VMQ_INT_STATUS_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define MD_VMQ_INT_STATUS_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MD_VMQ_INT_ENABLE                                                            0x1800B038
+#define MD_VMQ_INT_ENABLE_reg_addr                                                   "0xB800B038"
+#define MD_VMQ_INT_ENABLE_reg                                                        0xB800B038
+#define set_MD_VMQ_INT_ENABLE_reg(data)   (*((volatile unsigned int*) MD_VMQ_INT_ENABLE_reg)=data)
+#define get_MD_VMQ_INT_ENABLE_reg   (*((volatile unsigned int*) MD_VMQ_INT_ENABLE_reg))
+#define MD_VMQ_INT_ENABLE_inst_adr                                                   "0x000E"
+#define MD_VMQ_INT_ENABLE_inst                                                       0x000E
+#define MD_VMQ_INT_ENABLE_vcpu_int_en_shift                                          (6)
+#define MD_VMQ_INT_ENABLE_vcpu_int_en_mask                                           (0x00000040)
+#define MD_VMQ_INT_ENABLE_vcpu_int_en(data)                                          (0x00000040&((data)<<6))
+#define MD_VMQ_INT_ENABLE_vcpu_int_en_src(data)                                      ((0x00000040&(data))>>6)
+#define MD_VMQ_INT_ENABLE_get_vcpu_int_en(data)                                      ((0x00000040&(data))>>6)
+#define MD_VMQ_INT_ENABLE_vmq_chksum_err_en_shift                                    (5)
+#define MD_VMQ_INT_ENABLE_vmq_chksum_err_en_mask                                     (0x00000020)
+#define MD_VMQ_INT_ENABLE_vmq_chksum_err_en(data)                                    (0x00000020&((data)<<5))
+#define MD_VMQ_INT_ENABLE_vmq_chksum_err_en_src(data)                                ((0x00000020&(data))>>5)
+#define MD_VMQ_INT_ENABLE_get_vmq_chksum_err_en(data)                                ((0x00000020&(data))>>5)
+#define MD_VMQ_INT_ENABLE_vmq_mode_2b4b_err_en_shift                                 (4)
+#define MD_VMQ_INT_ENABLE_vmq_mode_2b4b_err_en_mask                                  (0x00000010)
+#define MD_VMQ_INT_ENABLE_vmq_mode_2b4b_err_en(data)                                 (0x00000010&((data)<<4))
+#define MD_VMQ_INT_ENABLE_vmq_mode_2b4b_err_en_src(data)                             ((0x00000010&(data))>>4)
+#define MD_VMQ_INT_ENABLE_get_vmq_mode_2b4b_err_en(data)                             ((0x00000010&(data))>>4)
+#define MD_VMQ_INT_ENABLE_vmq_empty_en_shift                                         (3)
+#define MD_VMQ_INT_ENABLE_vmq_empty_en_mask                                          (0x00000008)
+#define MD_VMQ_INT_ENABLE_vmq_empty_en(data)                                         (0x00000008&((data)<<3))
+#define MD_VMQ_INT_ENABLE_vmq_empty_en_src(data)                                     ((0x00000008&(data))>>3)
+#define MD_VMQ_INT_ENABLE_get_vmq_empty_en(data)                                     ((0x00000008&(data))>>3)
+#define MD_VMQ_INT_ENABLE_vmq_length_err_en_shift                                    (2)
+#define MD_VMQ_INT_ENABLE_vmq_length_err_en_mask                                     (0x00000004)
+#define MD_VMQ_INT_ENABLE_vmq_length_err_en(data)                                    (0x00000004&((data)<<2))
+#define MD_VMQ_INT_ENABLE_vmq_length_err_en_src(data)                                ((0x00000004&(data))>>2)
+#define MD_VMQ_INT_ENABLE_get_vmq_length_err_en(data)                                ((0x00000004&(data))>>2)
+#define MD_VMQ_INT_ENABLE_vmq_inst_err_en_shift                                      (1)
+#define MD_VMQ_INT_ENABLE_vmq_inst_err_en_mask                                       (0x00000002)
+#define MD_VMQ_INT_ENABLE_vmq_inst_err_en(data)                                      (0x00000002&((data)<<1))
+#define MD_VMQ_INT_ENABLE_vmq_inst_err_en_src(data)                                  ((0x00000002&(data))>>1)
+#define MD_VMQ_INT_ENABLE_get_vmq_inst_err_en(data)                                  ((0x00000002&(data))>>1)
+#define MD_VMQ_INT_ENABLE_write_data_shift                                           (0)
+#define MD_VMQ_INT_ENABLE_write_data_mask                                            (0x00000001)
+#define MD_VMQ_INT_ENABLE_write_data(data)                                           (0x00000001&((data)<<0))
+#define MD_VMQ_INT_ENABLE_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define MD_VMQ_INT_ENABLE_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MD_VMQBASE                                                                   0x1800B03C
+#define MD_VMQBASE_reg_addr                                                          "0xB800B03C"
+#define MD_VMQBASE_reg                                                               0xB800B03C
+#define set_MD_VMQBASE_reg(data)   (*((volatile unsigned int*) MD_VMQBASE_reg)=data)
+#define get_MD_VMQBASE_reg   (*((volatile unsigned int*) MD_VMQBASE_reg))
+#define MD_VMQBASE_inst_adr                                                          "0x000F"
+#define MD_VMQBASE_inst                                                              0x000F
+#define MD_VMQBASE_vmq_base_shift                                                    (4)
+#define MD_VMQBASE_vmq_base_mask                                                     (0x7FFFFFF0)
+#define MD_VMQBASE_vmq_base(data)                                                    (0x7FFFFFF0&((data)<<4))
+#define MD_VMQBASE_vmq_base_src(data)                                                ((0x7FFFFFF0&(data))>>4)
+#define MD_VMQBASE_get_vmq_base(data)                                                ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_VMQLIMIT                                                                  0x1800B040
+#define MD_VMQLIMIT_reg_addr                                                         "0xB800B040"
+#define MD_VMQLIMIT_reg                                                              0xB800B040
+#define set_MD_VMQLIMIT_reg(data)   (*((volatile unsigned int*) MD_VMQLIMIT_reg)=data)
+#define get_MD_VMQLIMIT_reg   (*((volatile unsigned int*) MD_VMQLIMIT_reg))
+#define MD_VMQLIMIT_inst_adr                                                         "0x0010"
+#define MD_VMQLIMIT_inst                                                             0x0010
+#define MD_VMQLIMIT_vmq_limit_shift                                                  (4)
+#define MD_VMQLIMIT_vmq_limit_mask                                                   (0x7FFFFFF0)
+#define MD_VMQLIMIT_vmq_limit(data)                                                  (0x7FFFFFF0&((data)<<4))
+#define MD_VMQLIMIT_vmq_limit_src(data)                                              ((0x7FFFFFF0&(data))>>4)
+#define MD_VMQLIMIT_get_vmq_limit(data)                                              ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_VMQRDPTR                                                                  0x1800B044
+#define MD_VMQRDPTR_reg_addr                                                         "0xB800B044"
+#define MD_VMQRDPTR_reg                                                              0xB800B044
+#define set_MD_VMQRDPTR_reg(data)   (*((volatile unsigned int*) MD_VMQRDPTR_reg)=data)
+#define get_MD_VMQRDPTR_reg   (*((volatile unsigned int*) MD_VMQRDPTR_reg))
+#define MD_VMQRDPTR_inst_adr                                                         "0x0011"
+#define MD_VMQRDPTR_inst                                                             0x0011
+#define MD_VMQRDPTR_vmq_rdptr_shift                                                  (4)
+#define MD_VMQRDPTR_vmq_rdptr_mask                                                   (0x7FFFFFF0)
+#define MD_VMQRDPTR_vmq_rdptr(data)                                                  (0x7FFFFFF0&((data)<<4))
+#define MD_VMQRDPTR_vmq_rdptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
+#define MD_VMQRDPTR_get_vmq_rdptr(data)                                              ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_VMQWRPTR                                                                  0x1800B048
+#define MD_VMQWRPTR_reg_addr                                                         "0xB800B048"
+#define MD_VMQWRPTR_reg                                                              0xB800B048
+#define set_MD_VMQWRPTR_reg(data)   (*((volatile unsigned int*) MD_VMQWRPTR_reg)=data)
+#define get_MD_VMQWRPTR_reg   (*((volatile unsigned int*) MD_VMQWRPTR_reg))
+#define MD_VMQWRPTR_inst_adr                                                         "0x0012"
+#define MD_VMQWRPTR_inst                                                             0x0012
+#define MD_VMQWRPTR_vmq_wrptr_shift                                                  (4)
+#define MD_VMQWRPTR_vmq_wrptr_mask                                                   (0x7FFFFFF0)
+#define MD_VMQWRPTR_vmq_wrptr(data)                                                  (0x7FFFFFF0&((data)<<4))
+#define MD_VMQWRPTR_vmq_wrptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
+#define MD_VMQWRPTR_get_vmq_wrptr(data)                                              ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_VMQFIFOSTATE                                                              0x1800B04C
+#define MD_VMQFIFOSTATE_reg_addr                                                     "0xB800B04C"
+#define MD_VMQFIFOSTATE_reg                                                          0xB800B04C
+#define set_MD_VMQFIFOSTATE_reg(data)   (*((volatile unsigned int*) MD_VMQFIFOSTATE_reg)=data)
+#define get_MD_VMQFIFOSTATE_reg   (*((volatile unsigned int*) MD_VMQFIFOSTATE_reg))
+#define MD_VMQFIFOSTATE_inst_adr                                                     "0x0013"
+#define MD_VMQFIFOSTATE_inst                                                         0x0013
+#define MD_VMQFIFOSTATE_vmq_inst_remain_shift                                        (0)
+#define MD_VMQFIFOSTATE_vmq_inst_remain_mask                                         (0x0000001F)
+#define MD_VMQFIFOSTATE_vmq_inst_remain(data)                                        (0x0000001F&((data)<<0))
+#define MD_VMQFIFOSTATE_vmq_inst_remain_src(data)                                    ((0x0000001F&(data))>>0)
+#define MD_VMQFIFOSTATE_get_vmq_inst_remain(data)                                    ((0x0000001F&(data))>>0)
+
+
+#define MD_VMQ_INSTCNT                                                               0x1800B050
+#define MD_VMQ_INSTCNT_reg_addr                                                      "0xB800B050"
+#define MD_VMQ_INSTCNT_reg                                                           0xB800B050
+#define set_MD_VMQ_INSTCNT_reg(data)   (*((volatile unsigned int*) MD_VMQ_INSTCNT_reg)=data)
+#define get_MD_VMQ_INSTCNT_reg   (*((volatile unsigned int*) MD_VMQ_INSTCNT_reg))
+#define MD_VMQ_INSTCNT_inst_adr                                                      "0x0014"
+#define MD_VMQ_INSTCNT_inst                                                          0x0014
+#define MD_VMQ_INSTCNT_vmq_inst_cnt_shift                                            (0)
+#define MD_VMQ_INSTCNT_vmq_inst_cnt_mask                                             (0x0000FFFF)
+#define MD_VMQ_INSTCNT_vmq_inst_cnt(data)                                            (0x0000FFFF&((data)<<0))
+#define MD_VMQ_INSTCNT_vmq_inst_cnt_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define MD_VMQ_INSTCNT_get_vmq_inst_cnt(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define MD_VMQ_CHKSUM                                                                0x1800B054
+#define MD_VMQ_CHKSUM_reg_addr                                                       "0xB800B054"
+#define MD_VMQ_CHKSUM_reg                                                            0xB800B054
+#define set_MD_VMQ_CHKSUM_reg(data)   (*((volatile unsigned int*) MD_VMQ_CHKSUM_reg)=data)
+#define get_MD_VMQ_CHKSUM_reg   (*((volatile unsigned int*) MD_VMQ_CHKSUM_reg))
+#define MD_VMQ_CHKSUM_inst_adr                                                       "0x0015"
+#define MD_VMQ_CHKSUM_inst                                                           0x0015
+#define MD_VMQ_CHKSUM_vmq_chksum_shift                                               (0)
+#define MD_VMQ_CHKSUM_vmq_chksum_mask                                                (0xFFFFFFFF)
+#define MD_VMQ_CHKSUM_vmq_chksum(data)                                               (0xFFFFFFFF&((data)<<0))
+#define MD_VMQ_CHKSUM_vmq_chksum_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define MD_VMQ_CHKSUM_get_vmq_chksum(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define MD_KMQ_CNTL                                                                  0x1800B060
+#define MD_KMQ_CNTL_reg_addr                                                         "0xB800B060"
+#define MD_KMQ_CNTL_reg                                                              0xB800B060
+#define set_MD_KMQ_CNTL_reg(data)   (*((volatile unsigned int*) MD_KMQ_CNTL_reg)=data)
+#define get_MD_KMQ_CNTL_reg   (*((volatile unsigned int*) MD_KMQ_CNTL_reg))
+#define MD_KMQ_CNTL_inst_adr                                                         "0x0018"
+#define MD_KMQ_CNTL_inst                                                             0x0018
+#define MD_KMQ_CNTL_kmq_idle_shift                                                   (3)
+#define MD_KMQ_CNTL_kmq_idle_mask                                                    (0x00000008)
+#define MD_KMQ_CNTL_kmq_idle(data)                                                   (0x00000008&((data)<<3))
+#define MD_KMQ_CNTL_kmq_idle_src(data)                                               ((0x00000008&(data))>>3)
+#define MD_KMQ_CNTL_get_kmq_idle(data)                                               ((0x00000008&(data))>>3)
+#define MD_KMQ_CNTL_kmq_cmd_swap_shift                                               (2)
+#define MD_KMQ_CNTL_kmq_cmd_swap_mask                                                (0x00000004)
+#define MD_KMQ_CNTL_kmq_cmd_swap(data)                                               (0x00000004&((data)<<2))
+#define MD_KMQ_CNTL_kmq_cmd_swap_src(data)                                           ((0x00000004&(data))>>2)
+#define MD_KMQ_CNTL_get_kmq_cmd_swap(data)                                           ((0x00000004&(data))>>2)
+#define MD_KMQ_CNTL_kmq_go_shift                                                     (1)
+#define MD_KMQ_CNTL_kmq_go_mask                                                      (0x00000002)
+#define MD_KMQ_CNTL_kmq_go(data)                                                     (0x00000002&((data)<<1))
+#define MD_KMQ_CNTL_kmq_go_src(data)                                                 ((0x00000002&(data))>>1)
+#define MD_KMQ_CNTL_get_kmq_go(data)                                                 ((0x00000002&(data))>>1)
+#define MD_KMQ_CNTL_write_data_shift                                                 (0)
+#define MD_KMQ_CNTL_write_data_mask                                                  (0x00000001)
+#define MD_KMQ_CNTL_write_data(data)                                                 (0x00000001&((data)<<0))
+#define MD_KMQ_CNTL_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define MD_KMQ_CNTL_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MD_KMQ_INT_STATUS                                                            0x1800B064
+#define MD_KMQ_INT_STATUS_reg_addr                                                   "0xB800B064"
+#define MD_KMQ_INT_STATUS_reg                                                        0xB800B064
+#define set_MD_KMQ_INT_STATUS_reg(data)   (*((volatile unsigned int*) MD_KMQ_INT_STATUS_reg)=data)
+#define get_MD_KMQ_INT_STATUS_reg   (*((volatile unsigned int*) MD_KMQ_INT_STATUS_reg))
+#define MD_KMQ_INT_STATUS_inst_adr                                                   "0x0019"
+#define MD_KMQ_INT_STATUS_inst                                                       0x0019
+#define MD_KMQ_INT_STATUS_kmq_chksum_err_shift                                       (5)
+#define MD_KMQ_INT_STATUS_kmq_chksum_err_mask                                        (0x00000020)
+#define MD_KMQ_INT_STATUS_kmq_chksum_err(data)                                       (0x00000020&((data)<<5))
+#define MD_KMQ_INT_STATUS_kmq_chksum_err_src(data)                                   ((0x00000020&(data))>>5)
+#define MD_KMQ_INT_STATUS_get_kmq_chksum_err(data)                                   ((0x00000020&(data))>>5)
+#define MD_KMQ_INT_STATUS_kmq_mode_2b4berr_shift                                     (4)
+#define MD_KMQ_INT_STATUS_kmq_mode_2b4berr_mask                                      (0x00000010)
+#define MD_KMQ_INT_STATUS_kmq_mode_2b4berr(data)                                     (0x00000010&((data)<<4))
+#define MD_KMQ_INT_STATUS_kmq_mode_2b4berr_src(data)                                 ((0x00000010&(data))>>4)
+#define MD_KMQ_INT_STATUS_get_kmq_mode_2b4berr(data)                                 ((0x00000010&(data))>>4)
+#define MD_KMQ_INT_STATUS_kmq_empty_shift                                            (3)
+#define MD_KMQ_INT_STATUS_kmq_empty_mask                                             (0x00000008)
+#define MD_KMQ_INT_STATUS_kmq_empty(data)                                            (0x00000008&((data)<<3))
+#define MD_KMQ_INT_STATUS_kmq_empty_src(data)                                        ((0x00000008&(data))>>3)
+#define MD_KMQ_INT_STATUS_get_kmq_empty(data)                                        ((0x00000008&(data))>>3)
+#define MD_KMQ_INT_STATUS_kmq_length_err_shift                                       (2)
+#define MD_KMQ_INT_STATUS_kmq_length_err_mask                                        (0x00000004)
+#define MD_KMQ_INT_STATUS_kmq_length_err(data)                                       (0x00000004&((data)<<2))
+#define MD_KMQ_INT_STATUS_kmq_length_err_src(data)                                   ((0x00000004&(data))>>2)
+#define MD_KMQ_INT_STATUS_get_kmq_length_err(data)                                   ((0x00000004&(data))>>2)
+#define MD_KMQ_INT_STATUS_kmq_inst_err_shift                                         (1)
+#define MD_KMQ_INT_STATUS_kmq_inst_err_mask                                          (0x00000002)
+#define MD_KMQ_INT_STATUS_kmq_inst_err(data)                                         (0x00000002&((data)<<1))
+#define MD_KMQ_INT_STATUS_kmq_inst_err_src(data)                                     ((0x00000002&(data))>>1)
+#define MD_KMQ_INT_STATUS_get_kmq_inst_err(data)                                     ((0x00000002&(data))>>1)
+#define MD_KMQ_INT_STATUS_write_data_shift                                           (0)
+#define MD_KMQ_INT_STATUS_write_data_mask                                            (0x00000001)
+#define MD_KMQ_INT_STATUS_write_data(data)                                           (0x00000001&((data)<<0))
+#define MD_KMQ_INT_STATUS_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define MD_KMQ_INT_STATUS_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MD_KMQ_INT_ENABLE                                                            0x1800B068
+#define MD_KMQ_INT_ENABLE_reg_addr                                                   "0xB800B068"
+#define MD_KMQ_INT_ENABLE_reg                                                        0xB800B068
+#define set_MD_KMQ_INT_ENABLE_reg(data)   (*((volatile unsigned int*) MD_KMQ_INT_ENABLE_reg)=data)
+#define get_MD_KMQ_INT_ENABLE_reg   (*((volatile unsigned int*) MD_KMQ_INT_ENABLE_reg))
+#define MD_KMQ_INT_ENABLE_inst_adr                                                   "0x001A"
+#define MD_KMQ_INT_ENABLE_inst                                                       0x001A
+#define MD_KMQ_INT_ENABLE_kcpu_int_en_shift                                          (6)
+#define MD_KMQ_INT_ENABLE_kcpu_int_en_mask                                           (0x00000040)
+#define MD_KMQ_INT_ENABLE_kcpu_int_en(data)                                          (0x00000040&((data)<<6))
+#define MD_KMQ_INT_ENABLE_kcpu_int_en_src(data)                                      ((0x00000040&(data))>>6)
+#define MD_KMQ_INT_ENABLE_get_kcpu_int_en(data)                                      ((0x00000040&(data))>>6)
+#define MD_KMQ_INT_ENABLE_kmq_chksum_err_en_shift                                    (5)
+#define MD_KMQ_INT_ENABLE_kmq_chksum_err_en_mask                                     (0x00000020)
+#define MD_KMQ_INT_ENABLE_kmq_chksum_err_en(data)                                    (0x00000020&((data)<<5))
+#define MD_KMQ_INT_ENABLE_kmq_chksum_err_en_src(data)                                ((0x00000020&(data))>>5)
+#define MD_KMQ_INT_ENABLE_get_kmq_chksum_err_en(data)                                ((0x00000020&(data))>>5)
+#define MD_KMQ_INT_ENABLE_kmq_mode_2b4b_err_en_shift                                 (4)
+#define MD_KMQ_INT_ENABLE_kmq_mode_2b4b_err_en_mask                                  (0x00000010)
+#define MD_KMQ_INT_ENABLE_kmq_mode_2b4b_err_en(data)                                 (0x00000010&((data)<<4))
+#define MD_KMQ_INT_ENABLE_kmq_mode_2b4b_err_en_src(data)                             ((0x00000010&(data))>>4)
+#define MD_KMQ_INT_ENABLE_get_kmq_mode_2b4b_err_en(data)                             ((0x00000010&(data))>>4)
+#define MD_KMQ_INT_ENABLE_kmq_empty_en_shift                                         (3)
+#define MD_KMQ_INT_ENABLE_kmq_empty_en_mask                                          (0x00000008)
+#define MD_KMQ_INT_ENABLE_kmq_empty_en(data)                                         (0x00000008&((data)<<3))
+#define MD_KMQ_INT_ENABLE_kmq_empty_en_src(data)                                     ((0x00000008&(data))>>3)
+#define MD_KMQ_INT_ENABLE_get_kmq_empty_en(data)                                     ((0x00000008&(data))>>3)
+#define MD_KMQ_INT_ENABLE_kmq_length_err_en_shift                                    (2)
+#define MD_KMQ_INT_ENABLE_kmq_length_err_en_mask                                     (0x00000004)
+#define MD_KMQ_INT_ENABLE_kmq_length_err_en(data)                                    (0x00000004&((data)<<2))
+#define MD_KMQ_INT_ENABLE_kmq_length_err_en_src(data)                                ((0x00000004&(data))>>2)
+#define MD_KMQ_INT_ENABLE_get_kmq_length_err_en(data)                                ((0x00000004&(data))>>2)
+#define MD_KMQ_INT_ENABLE_kmq_inst_err_en_shift                                      (1)
+#define MD_KMQ_INT_ENABLE_kmq_inst_err_en_mask                                       (0x00000002)
+#define MD_KMQ_INT_ENABLE_kmq_inst_err_en(data)                                      (0x00000002&((data)<<1))
+#define MD_KMQ_INT_ENABLE_kmq_inst_err_en_src(data)                                  ((0x00000002&(data))>>1)
+#define MD_KMQ_INT_ENABLE_get_kmq_inst_err_en(data)                                  ((0x00000002&(data))>>1)
+#define MD_KMQ_INT_ENABLE_write_data_shift                                           (0)
+#define MD_KMQ_INT_ENABLE_write_data_mask                                            (0x00000001)
+#define MD_KMQ_INT_ENABLE_write_data(data)                                           (0x00000001&((data)<<0))
+#define MD_KMQ_INT_ENABLE_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define MD_KMQ_INT_ENABLE_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MD_KMQBASE                                                                   0x1800B06C
+#define MD_KMQBASE_reg_addr                                                          "0xB800B06C"
+#define MD_KMQBASE_reg                                                               0xB800B06C
+#define set_MD_KMQBASE_reg(data)   (*((volatile unsigned int*) MD_KMQBASE_reg)=data)
+#define get_MD_KMQBASE_reg   (*((volatile unsigned int*) MD_KMQBASE_reg))
+#define MD_KMQBASE_inst_adr                                                          "0x001B"
+#define MD_KMQBASE_inst                                                              0x001B
+#define MD_KMQBASE_kmq_base_shift                                                    (4)
+#define MD_KMQBASE_kmq_base_mask                                                     (0x7FFFFFF0)
+#define MD_KMQBASE_kmq_base(data)                                                    (0x7FFFFFF0&((data)<<4))
+#define MD_KMQBASE_kmq_base_src(data)                                                ((0x7FFFFFF0&(data))>>4)
+#define MD_KMQBASE_get_kmq_base(data)                                                ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_KMQLIMIT                                                                  0x1800B070
+#define MD_KMQLIMIT_reg_addr                                                         "0xB800B070"
+#define MD_KMQLIMIT_reg                                                              0xB800B070
+#define set_MD_KMQLIMIT_reg(data)   (*((volatile unsigned int*) MD_KMQLIMIT_reg)=data)
+#define get_MD_KMQLIMIT_reg   (*((volatile unsigned int*) MD_KMQLIMIT_reg))
+#define MD_KMQLIMIT_inst_adr                                                         "0x001C"
+#define MD_KMQLIMIT_inst                                                             0x001C
+#define MD_KMQLIMIT_kmq_limit_shift                                                  (4)
+#define MD_KMQLIMIT_kmq_limit_mask                                                   (0x7FFFFFF0)
+#define MD_KMQLIMIT_kmq_limit(data)                                                  (0x7FFFFFF0&((data)<<4))
+#define MD_KMQLIMIT_kmq_limit_src(data)                                              ((0x7FFFFFF0&(data))>>4)
+#define MD_KMQLIMIT_get_kmq_limit(data)                                              ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_KMQRDPTR                                                                  0x1800B074
+#define MD_KMQRDPTR_reg_addr                                                         "0xB800B074"
+#define MD_KMQRDPTR_reg                                                              0xB800B074
+#define set_MD_KMQRDPTR_reg(data)   (*((volatile unsigned int*) MD_KMQRDPTR_reg)=data)
+#define get_MD_KMQRDPTR_reg   (*((volatile unsigned int*) MD_KMQRDPTR_reg))
+#define MD_KMQRDPTR_inst_adr                                                         "0x001D"
+#define MD_KMQRDPTR_inst                                                             0x001D
+#define MD_KMQRDPTR_kmq_rdptr_shift                                                  (4)
+#define MD_KMQRDPTR_kmq_rdptr_mask                                                   (0x7FFFFFF0)
+#define MD_KMQRDPTR_kmq_rdptr(data)                                                  (0x7FFFFFF0&((data)<<4))
+#define MD_KMQRDPTR_kmq_rdptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
+#define MD_KMQRDPTR_get_kmq_rdptr(data)                                              ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_KMQWRPTR                                                                  0x1800B078
+#define MD_KMQWRPTR_reg_addr                                                         "0xB800B078"
+#define MD_KMQWRPTR_reg                                                              0xB800B078
+#define set_MD_KMQWRPTR_reg(data)   (*((volatile unsigned int*) MD_KMQWRPTR_reg)=data)
+#define get_MD_KMQWRPTR_reg   (*((volatile unsigned int*) MD_KMQWRPTR_reg))
+#define MD_KMQWRPTR_inst_adr                                                         "0x001E"
+#define MD_KMQWRPTR_inst                                                             0x001E
+#define MD_KMQWRPTR_kmq_wrptr_shift                                                  (4)
+#define MD_KMQWRPTR_kmq_wrptr_mask                                                   (0x7FFFFFF0)
+#define MD_KMQWRPTR_kmq_wrptr(data)                                                  (0x7FFFFFF0&((data)<<4))
+#define MD_KMQWRPTR_kmq_wrptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
+#define MD_KMQWRPTR_get_kmq_wrptr(data)                                              ((0x7FFFFFF0&(data))>>4)
+
+
+#define MD_KMQFIFOSTATE                                                              0x1800B07C
+#define MD_KMQFIFOSTATE_reg_addr                                                     "0xB800B07C"
+#define MD_KMQFIFOSTATE_reg                                                          0xB800B07C
+#define set_MD_KMQFIFOSTATE_reg(data)   (*((volatile unsigned int*) MD_KMQFIFOSTATE_reg)=data)
+#define get_MD_KMQFIFOSTATE_reg   (*((volatile unsigned int*) MD_KMQFIFOSTATE_reg))
+#define MD_KMQFIFOSTATE_inst_adr                                                     "0x001F"
+#define MD_KMQFIFOSTATE_inst                                                         0x001F
+#define MD_KMQFIFOSTATE_kmq_inst_remain_shift                                        (0)
+#define MD_KMQFIFOSTATE_kmq_inst_remain_mask                                         (0x0000001F)
+#define MD_KMQFIFOSTATE_kmq_inst_remain(data)                                        (0x0000001F&((data)<<0))
+#define MD_KMQFIFOSTATE_kmq_inst_remain_src(data)                                    ((0x0000001F&(data))>>0)
+#define MD_KMQFIFOSTATE_get_kmq_inst_remain(data)                                    ((0x0000001F&(data))>>0)
+
+
+#define MD_KMQ_INSTCNT                                                               0x1800B080
+#define MD_KMQ_INSTCNT_reg_addr                                                      "0xB800B080"
+#define MD_KMQ_INSTCNT_reg                                                           0xB800B080
+#define set_MD_KMQ_INSTCNT_reg(data)   (*((volatile unsigned int*) MD_KMQ_INSTCNT_reg)=data)
+#define get_MD_KMQ_INSTCNT_reg   (*((volatile unsigned int*) MD_KMQ_INSTCNT_reg))
+#define MD_KMQ_INSTCNT_inst_adr                                                      "0x0020"
+#define MD_KMQ_INSTCNT_inst                                                          0x0020
+#define MD_KMQ_INSTCNT_kmq_inst_cnt_shift                                            (0)
+#define MD_KMQ_INSTCNT_kmq_inst_cnt_mask                                             (0x0000FFFF)
+#define MD_KMQ_INSTCNT_kmq_inst_cnt(data)                                            (0x0000FFFF&((data)<<0))
+#define MD_KMQ_INSTCNT_kmq_inst_cnt_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define MD_KMQ_INSTCNT_get_kmq_inst_cnt(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define MD_KMQ_CHKSUM                                                                0x1800B084
+#define MD_KMQ_CHKSUM_reg_addr                                                       "0xB800B084"
+#define MD_KMQ_CHKSUM_reg                                                            0xB800B084
+#define set_MD_KMQ_CHKSUM_reg(data)   (*((volatile unsigned int*) MD_KMQ_CHKSUM_reg)=data)
+#define get_MD_KMQ_CHKSUM_reg   (*((volatile unsigned int*) MD_KMQ_CHKSUM_reg))
+#define MD_KMQ_CHKSUM_inst_adr                                                       "0x0021"
+#define MD_KMQ_CHKSUM_inst                                                           0x0021
+#define MD_KMQ_CHKSUM_kmq_chksum_shift                                               (0)
+#define MD_KMQ_CHKSUM_kmq_chksum_mask                                                (0xFFFFFFFF)
+#define MD_KMQ_CHKSUM_kmq_chksum(data)                                               (0xFFFFFFFF&((data)<<0))
+#define MD_KMQ_CHKSUM_kmq_chksum_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define MD_KMQ_CHKSUM_get_kmq_chksum(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define MD_DBG                                                                       0x1800B0D0
+#define MD_DBG_reg_addr                                                              "0xB800B0D0"
+#define MD_DBG_reg                                                                   0xB800B0D0
+#define set_MD_DBG_reg(data)   (*((volatile unsigned int*) MD_DBG_reg)=data)
+#define get_MD_DBG_reg   (*((volatile unsigned int*) MD_DBG_reg))
+#define MD_DBG_inst_adr                                                              "0x0034"
+#define MD_DBG_inst                                                                  0x0034
+#define MD_DBG_md_dbg_sel1_shift                                                     (8)
+#define MD_DBG_md_dbg_sel1_mask                                                      (0x00007F00)
+#define MD_DBG_md_dbg_sel1(data)                                                     (0x00007F00&((data)<<8))
+#define MD_DBG_md_dbg_sel1_src(data)                                                 ((0x00007F00&(data))>>8)
+#define MD_DBG_get_md_dbg_sel1(data)                                                 ((0x00007F00&(data))>>8)
+#define MD_DBG_md_dbg_sel0_shift                                                     (1)
+#define MD_DBG_md_dbg_sel0_mask                                                      (0x000000FE)
+#define MD_DBG_md_dbg_sel0(data)                                                     (0x000000FE&((data)<<1))
+#define MD_DBG_md_dbg_sel0_src(data)                                                 ((0x000000FE&(data))>>1)
+#define MD_DBG_get_md_dbg_sel0(data)                                                 ((0x000000FE&(data))>>1)
+#define MD_DBG_md_dbg_enable_shift                                                   (0)
+#define MD_DBG_md_dbg_enable_mask                                                    (0x00000001)
+#define MD_DBG_md_dbg_enable(data)                                                   (0x00000001&((data)<<0))
+#define MD_DBG_md_dbg_enable_src(data)                                               ((0x00000001&(data))>>0)
+#define MD_DBG_get_md_dbg_enable(data)                                               ((0x00000001&(data))>>0)
+
+
+#define MD_FDMA_DDR_SADDR                                                            0x1800B088
+#define MD_FDMA_DDR_SADDR_reg_addr                                                   "0xB800B088"
+#define MD_FDMA_DDR_SADDR_reg                                                        0xB800B088
+#define set_MD_FDMA_DDR_SADDR_reg(data)   (*((volatile unsigned int*) MD_FDMA_DDR_SADDR_reg)=data)
+#define get_MD_FDMA_DDR_SADDR_reg   (*((volatile unsigned int*) MD_FDMA_DDR_SADDR_reg))
+#define MD_FDMA_DDR_SADDR_inst_adr                                                   "0x0022"
+#define MD_FDMA_DDR_SADDR_inst                                                       0x0022
+#define MD_FDMA_DDR_SADDR_fdma_ddr_saddr_shift                                       (0)
+#define MD_FDMA_DDR_SADDR_fdma_ddr_saddr_mask                                        (0x7FFFFFFF)
+#define MD_FDMA_DDR_SADDR_fdma_ddr_saddr(data)                                       (0x7FFFFFFF&((data)<<0))
+#define MD_FDMA_DDR_SADDR_fdma_ddr_saddr_src(data)                                   ((0x7FFFFFFF&(data))>>0)
+#define MD_FDMA_DDR_SADDR_get_fdma_ddr_saddr(data)                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_FDMA_FL_SADDR                                                             0x1800B08c
+#define MD_FDMA_FL_SADDR_reg_addr                                                    "0xB800B08C"
+#define MD_FDMA_FL_SADDR_reg                                                         0xB800B08C
+#define set_MD_FDMA_FL_SADDR_reg(data)   (*((volatile unsigned int*) MD_FDMA_FL_SADDR_reg)=data)
+#define get_MD_FDMA_FL_SADDR_reg   (*((volatile unsigned int*) MD_FDMA_FL_SADDR_reg))
+#define MD_FDMA_FL_SADDR_inst_adr                                                    "0x0023"
+#define MD_FDMA_FL_SADDR_inst                                                        0x0023
+#define MD_FDMA_FL_SADDR_fdma_fl_saddr_shift                                         (0)
+#define MD_FDMA_FL_SADDR_fdma_fl_saddr_mask                                          (0x01FFFFFF)
+#define MD_FDMA_FL_SADDR_fdma_fl_saddr(data)                                         (0x01FFFFFF&((data)<<0))
+#define MD_FDMA_FL_SADDR_fdma_fl_saddr_src(data)                                     ((0x01FFFFFF&(data))>>0)
+#define MD_FDMA_FL_SADDR_get_fdma_fl_saddr(data)                                     ((0x01FFFFFF&(data))>>0)
+
+
+#define MD_FDMA_CTRL2                                                                0x1800B090
+#define MD_FDMA_CTRL2_reg_addr                                                       "0xB800B090"
+#define MD_FDMA_CTRL2_reg                                                            0xB800B090
+#define set_MD_FDMA_CTRL2_reg(data)   (*((volatile unsigned int*) MD_FDMA_CTRL2_reg)=data)
+#define get_MD_FDMA_CTRL2_reg   (*((volatile unsigned int*) MD_FDMA_CTRL2_reg))
+#define MD_FDMA_CTRL2_inst_adr                                                       "0x0024"
+#define MD_FDMA_CTRL2_inst                                                           0x0024
+#define MD_FDMA_CTRL2_fl_cp_en_shift                                                 (30)
+#define MD_FDMA_CTRL2_fl_cp_en_mask                                                  (0x40000000)
+#define MD_FDMA_CTRL2_fl_cp_en(data)                                                 (0x40000000&((data)<<30))
+#define MD_FDMA_CTRL2_fl_cp_en_src(data)                                             ((0x40000000&(data))>>30)
+#define MD_FDMA_CTRL2_get_fl_cp_en(data)                                             ((0x40000000&(data))>>30)
+#define MD_FDMA_CTRL2_fl_mapping_mode_shift                                          (29)
+#define MD_FDMA_CTRL2_fl_mapping_mode_mask                                           (0x20000000)
+#define MD_FDMA_CTRL2_fl_mapping_mode(data)                                          (0x20000000&((data)<<29))
+#define MD_FDMA_CTRL2_fl_mapping_mode_src(data)                                      ((0x20000000&(data))>>29)
+#define MD_FDMA_CTRL2_get_fl_mapping_mode(data)                                      ((0x20000000&(data))>>29)
+#define MD_FDMA_CTRL2_fdma_swap_shift                                                (28)
+#define MD_FDMA_CTRL2_fdma_swap_mask                                                 (0x10000000)
+#define MD_FDMA_CTRL2_fdma_swap(data)                                                (0x10000000&((data)<<28))
+#define MD_FDMA_CTRL2_fdma_swap_src(data)                                            ((0x10000000&(data))>>28)
+#define MD_FDMA_CTRL2_get_fdma_swap(data)                                            ((0x10000000&(data))>>28)
+#define MD_FDMA_CTRL2_fdma_max_xfer_shift                                            (26)
+#define MD_FDMA_CTRL2_fdma_max_xfer_mask                                             (0x0C000000)
+#define MD_FDMA_CTRL2_fdma_max_xfer(data)                                            (0x0C000000&((data)<<26))
+#define MD_FDMA_CTRL2_fdma_max_xfer_src(data)                                        ((0x0C000000&(data))>>26)
+#define MD_FDMA_CTRL2_get_fdma_max_xfer(data)                                        ((0x0C000000&(data))>>26)
+#define MD_FDMA_CTRL2_fdma_dir_shift                                                 (25)
+#define MD_FDMA_CTRL2_fdma_dir_mask                                                  (0x02000000)
+#define MD_FDMA_CTRL2_fdma_dir(data)                                                 (0x02000000&((data)<<25))
+#define MD_FDMA_CTRL2_fdma_dir_src(data)                                             ((0x02000000&(data))>>25)
+#define MD_FDMA_CTRL2_get_fdma_dir(data)                                             ((0x02000000&(data))>>25)
+#define MD_FDMA_CTRL2_fdma_length_shift                                              (0)
+#define MD_FDMA_CTRL2_fdma_length_mask                                               (0x01FFFFFF)
+#define MD_FDMA_CTRL2_fdma_length(data)                                              (0x01FFFFFF&((data)<<0))
+#define MD_FDMA_CTRL2_fdma_length_src(data)                                          ((0x01FFFFFF&(data))>>0)
+#define MD_FDMA_CTRL2_get_fdma_length(data)                                          ((0x01FFFFFF&(data))>>0)
+
+
+#define MD_FDMA_CTRL1                                                                0x1800B094
+#define MD_FDMA_CTRL1_reg_addr                                                       "0xB800B094"
+#define MD_FDMA_CTRL1_reg                                                            0xB800B094
+#define set_MD_FDMA_CTRL1_reg(data)   (*((volatile unsigned int*) MD_FDMA_CTRL1_reg)=data)
+#define get_MD_FDMA_CTRL1_reg   (*((volatile unsigned int*) MD_FDMA_CTRL1_reg))
+#define MD_FDMA_CTRL1_inst_adr                                                       "0x0025"
+#define MD_FDMA_CTRL1_inst                                                           0x0025
+#define MD_FDMA_CTRL1_write_en2_shift                                                (3)
+#define MD_FDMA_CTRL1_write_en2_mask                                                 (0x00000008)
+#define MD_FDMA_CTRL1_write_en2(data)                                                (0x00000008&((data)<<3))
+#define MD_FDMA_CTRL1_write_en2_src(data)                                            ((0x00000008&(data))>>3)
+#define MD_FDMA_CTRL1_get_write_en2(data)                                            ((0x00000008&(data))>>3)
+#define MD_FDMA_CTRL1_fdma_stop_shift                                                (2)
+#define MD_FDMA_CTRL1_fdma_stop_mask                                                 (0x00000004)
+#define MD_FDMA_CTRL1_fdma_stop(data)                                                (0x00000004&((data)<<2))
+#define MD_FDMA_CTRL1_fdma_stop_src(data)                                            ((0x00000004&(data))>>2)
+#define MD_FDMA_CTRL1_get_fdma_stop(data)                                            ((0x00000004&(data))>>2)
+#define MD_FDMA_CTRL1_write_en1_shift                                                (1)
+#define MD_FDMA_CTRL1_write_en1_mask                                                 (0x00000002)
+#define MD_FDMA_CTRL1_write_en1(data)                                                (0x00000002&((data)<<1))
+#define MD_FDMA_CTRL1_write_en1_src(data)                                            ((0x00000002&(data))>>1)
+#define MD_FDMA_CTRL1_get_write_en1(data)                                            ((0x00000002&(data))>>1)
+#define MD_FDMA_CTRL1_fdma_go_shift                                                  (0)
+#define MD_FDMA_CTRL1_fdma_go_mask                                                   (0x00000001)
+#define MD_FDMA_CTRL1_fdma_go(data)                                                  (0x00000001&((data)<<0))
+#define MD_FDMA_CTRL1_fdma_go_src(data)                                              ((0x00000001&(data))>>0)
+#define MD_FDMA_CTRL1_get_fdma_go(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MD_UR_TXBASE                                                                 0x1800B0A4
+#define MD_UR_TXBASE_reg_addr                                                        "0xB800B0A4"
+#define MD_UR_TXBASE_reg                                                             0xB800B0A4
+#define set_MD_UR_TXBASE_reg(data)   (*((volatile unsigned int*) MD_UR_TXBASE_reg)=data)
+#define get_MD_UR_TXBASE_reg   (*((volatile unsigned int*) MD_UR_TXBASE_reg))
+#define MD_UR_TXBASE_inst_adr                                                        "0x0029"
+#define MD_UR_TXBASE_inst                                                            0x0029
+#define MD_UR_TXBASE_tx_base_shift                                                   (3)
+#define MD_UR_TXBASE_tx_base_mask                                                    (0x7FFFFFF8)
+#define MD_UR_TXBASE_tx_base(data)                                                   (0x7FFFFFF8&((data)<<3))
+#define MD_UR_TXBASE_tx_base_src(data)                                               ((0x7FFFFFF8&(data))>>3)
+#define MD_UR_TXBASE_get_tx_base(data)                                               ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_UR_TXLIMIT                                                                0x1800B0A8
+#define MD_UR_TXLIMIT_reg_addr                                                       "0xB800B0A8"
+#define MD_UR_TXLIMIT_reg                                                            0xB800B0A8
+#define set_MD_UR_TXLIMIT_reg(data)   (*((volatile unsigned int*) MD_UR_TXLIMIT_reg)=data)
+#define get_MD_UR_TXLIMIT_reg   (*((volatile unsigned int*) MD_UR_TXLIMIT_reg))
+#define MD_UR_TXLIMIT_inst_adr                                                       "0x002A"
+#define MD_UR_TXLIMIT_inst                                                           0x002A
+#define MD_UR_TXLIMIT_tx_limit_shift                                                 (3)
+#define MD_UR_TXLIMIT_tx_limit_mask                                                  (0x7FFFFFF8)
+#define MD_UR_TXLIMIT_tx_limit(data)                                                 (0x7FFFFFF8&((data)<<3))
+#define MD_UR_TXLIMIT_tx_limit_src(data)                                             ((0x7FFFFFF8&(data))>>3)
+#define MD_UR_TXLIMIT_get_tx_limit(data)                                             ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_UR_TXWRPTR                                                                0x1800B0AC
+#define MD_UR_TXWRPTR_reg_addr                                                       "0xB800B0AC"
+#define MD_UR_TXWRPTR_reg                                                            0xB800B0AC
+#define set_MD_UR_TXWRPTR_reg(data)   (*((volatile unsigned int*) MD_UR_TXWRPTR_reg)=data)
+#define get_MD_UR_TXWRPTR_reg   (*((volatile unsigned int*) MD_UR_TXWRPTR_reg))
+#define MD_UR_TXWRPTR_inst_adr                                                       "0x002B"
+#define MD_UR_TXWRPTR_inst                                                           0x002B
+#define MD_UR_TXWRPTR_tx_wrptr_shift                                                 (0)
+#define MD_UR_TXWRPTR_tx_wrptr_mask                                                  (0x7FFFFFFF)
+#define MD_UR_TXWRPTR_tx_wrptr(data)                                                 (0x7FFFFFFF&((data)<<0))
+#define MD_UR_TXWRPTR_tx_wrptr_src(data)                                             ((0x7FFFFFFF&(data))>>0)
+#define MD_UR_TXWRPTR_get_tx_wrptr(data)                                             ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_UR_TXRDPTR                                                                0x1800B0B0
+#define MD_UR_TXRDPTR_reg_addr                                                       "0xB800B0B0"
+#define MD_UR_TXRDPTR_reg                                                            0xB800B0B0
+#define set_MD_UR_TXRDPTR_reg(data)   (*((volatile unsigned int*) MD_UR_TXRDPTR_reg)=data)
+#define get_MD_UR_TXRDPTR_reg   (*((volatile unsigned int*) MD_UR_TXRDPTR_reg))
+#define MD_UR_TXRDPTR_inst_adr                                                       "0x002C"
+#define MD_UR_TXRDPTR_inst                                                           0x002C
+#define MD_UR_TXRDPTR_tx_rdptr_shift                                                 (0)
+#define MD_UR_TXRDPTR_tx_rdptr_mask                                                  (0x7FFFFFFF)
+#define MD_UR_TXRDPTR_tx_rdptr(data)                                                 (0x7FFFFFFF&((data)<<0))
+#define MD_UR_TXRDPTR_tx_rdptr_src(data)                                             ((0x7FFFFFFF&(data))>>0)
+#define MD_UR_TXRDPTR_get_tx_rdptr(data)                                             ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_UR_TXTHD                                                                  0x1800B0B4
+#define MD_UR_TXTHD_reg_addr                                                         "0xB800B0B4"
+#define MD_UR_TXTHD_reg                                                              0xB800B0B4
+#define set_MD_UR_TXTHD_reg(data)   (*((volatile unsigned int*) MD_UR_TXTHD_reg)=data)
+#define get_MD_UR_TXTHD_reg   (*((volatile unsigned int*) MD_UR_TXTHD_reg))
+#define MD_UR_TXTHD_inst_adr                                                         "0x002D"
+#define MD_UR_TXTHD_inst                                                             0x002D
+#define MD_UR_TXTHD_tx_thd_shift                                                     (0)
+#define MD_UR_TXTHD_tx_thd_mask                                                      (0xFFFFFFFF)
+#define MD_UR_TXTHD_tx_thd(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define MD_UR_TXTHD_tx_thd_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define MD_UR_TXTHD_get_tx_thd(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define MD_UR_RXBASE                                                                 0x1800B0B8
+#define MD_UR_RXBASE_reg_addr                                                        "0xB800B0B8"
+#define MD_UR_RXBASE_reg                                                             0xB800B0B8
+#define set_MD_UR_RXBASE_reg(data)   (*((volatile unsigned int*) MD_UR_RXBASE_reg)=data)
+#define get_MD_UR_RXBASE_reg   (*((volatile unsigned int*) MD_UR_RXBASE_reg))
+#define MD_UR_RXBASE_inst_adr                                                        "0x002E"
+#define MD_UR_RXBASE_inst                                                            0x002E
+#define MD_UR_RXBASE_rx_base_shift                                                   (3)
+#define MD_UR_RXBASE_rx_base_mask                                                    (0x7FFFFFF8)
+#define MD_UR_RXBASE_rx_base(data)                                                   (0x7FFFFFF8&((data)<<3))
+#define MD_UR_RXBASE_rx_base_src(data)                                               ((0x7FFFFFF8&(data))>>3)
+#define MD_UR_RXBASE_get_rx_base(data)                                               ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_UR_RXLIMIT                                                                0x1800B0BC
+#define MD_UR_RXLIMIT_reg_addr                                                       "0xB800B0BC"
+#define MD_UR_RXLIMIT_reg                                                            0xB800B0BC
+#define set_MD_UR_RXLIMIT_reg(data)   (*((volatile unsigned int*) MD_UR_RXLIMIT_reg)=data)
+#define get_MD_UR_RXLIMIT_reg   (*((volatile unsigned int*) MD_UR_RXLIMIT_reg))
+#define MD_UR_RXLIMIT_inst_adr                                                       "0x002F"
+#define MD_UR_RXLIMIT_inst                                                           0x002F
+#define MD_UR_RXLIMIT_rx_limit_shift                                                 (3)
+#define MD_UR_RXLIMIT_rx_limit_mask                                                  (0x7FFFFFF8)
+#define MD_UR_RXLIMIT_rx_limit(data)                                                 (0x7FFFFFF8&((data)<<3))
+#define MD_UR_RXLIMIT_rx_limit_src(data)                                             ((0x7FFFFFF8&(data))>>3)
+#define MD_UR_RXLIMIT_get_rx_limit(data)                                             ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_UR_RXWRPTR                                                                0x1800B0C0
+#define MD_UR_RXWRPTR_reg_addr                                                       "0xB800B0C0"
+#define MD_UR_RXWRPTR_reg                                                            0xB800B0C0
+#define set_MD_UR_RXWRPTR_reg(data)   (*((volatile unsigned int*) MD_UR_RXWRPTR_reg)=data)
+#define get_MD_UR_RXWRPTR_reg   (*((volatile unsigned int*) MD_UR_RXWRPTR_reg))
+#define MD_UR_RXWRPTR_inst_adr                                                       "0x0030"
+#define MD_UR_RXWRPTR_inst                                                           0x0030
+#define MD_UR_RXWRPTR_rx_wrptr_shift                                                 (0)
+#define MD_UR_RXWRPTR_rx_wrptr_mask                                                  (0x7FFFFFFF)
+#define MD_UR_RXWRPTR_rx_wrptr(data)                                                 (0x7FFFFFFF&((data)<<0))
+#define MD_UR_RXWRPTR_rx_wrptr_src(data)                                             ((0x7FFFFFFF&(data))>>0)
+#define MD_UR_RXWRPTR_get_rx_wrptr(data)                                             ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_UR_RXRDPTR                                                                0x1800B0C4
+#define MD_UR_RXRDPTR_reg_addr                                                       "0xB800B0C4"
+#define MD_UR_RXRDPTR_reg                                                            0xB800B0C4
+#define set_MD_UR_RXRDPTR_reg(data)   (*((volatile unsigned int*) MD_UR_RXRDPTR_reg)=data)
+#define get_MD_UR_RXRDPTR_reg   (*((volatile unsigned int*) MD_UR_RXRDPTR_reg))
+#define MD_UR_RXRDPTR_inst_adr                                                       "0x0031"
+#define MD_UR_RXRDPTR_inst                                                           0x0031
+#define MD_UR_RXRDPTR_rx_rdptr_shift                                                 (0)
+#define MD_UR_RXRDPTR_rx_rdptr_mask                                                  (0x7FFFFFFF)
+#define MD_UR_RXRDPTR_rx_rdptr(data)                                                 (0x7FFFFFFF&((data)<<0))
+#define MD_UR_RXRDPTR_rx_rdptr_src(data)                                             ((0x7FFFFFFF&(data))>>0)
+#define MD_UR_RXRDPTR_get_rx_rdptr(data)                                             ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_UR_RXTHD                                                                  0x1800B0C8
+#define MD_UR_RXTHD_reg_addr                                                         "0xB800B0C8"
+#define MD_UR_RXTHD_reg                                                              0xB800B0C8
+#define set_MD_UR_RXTHD_reg(data)   (*((volatile unsigned int*) MD_UR_RXTHD_reg)=data)
+#define get_MD_UR_RXTHD_reg   (*((volatile unsigned int*) MD_UR_RXTHD_reg))
+#define MD_UR_RXTHD_inst_adr                                                         "0x0032"
+#define MD_UR_RXTHD_inst                                                             0x0032
+#define MD_UR_RXTHD_rx_thd_shift                                                     (0)
+#define MD_UR_RXTHD_rx_thd_mask                                                      (0xFFFFFFFF)
+#define MD_UR_RXTHD_rx_thd(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define MD_UR_RXTHD_rx_thd_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define MD_UR_RXTHD_get_rx_thd(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define MD_UR_ENABLE                                                                 0x1800B0CC
+#define MD_UR_ENABLE_reg_addr                                                        "0xB800B0CC"
+#define MD_UR_ENABLE_reg                                                             0xB800B0CC
+#define set_MD_UR_ENABLE_reg(data)   (*((volatile unsigned int*) MD_UR_ENABLE_reg)=data)
+#define get_MD_UR_ENABLE_reg   (*((volatile unsigned int*) MD_UR_ENABLE_reg))
+#define MD_UR_ENABLE_inst_adr                                                        "0x0033"
+#define MD_UR_ENABLE_inst                                                            0x0033
+#define MD_UR_ENABLE_ur_en_shift                                                     (0)
+#define MD_UR_ENABLE_ur_en_mask                                                      (0x00000001)
+#define MD_UR_ENABLE_ur_en(data)                                                     (0x00000001&((data)<<0))
+#define MD_UR_ENABLE_ur_en_src(data)                                                 ((0x00000001&(data))>>0)
+#define MD_UR_ENABLE_get_ur_en(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define MD_GSP_TXBASE                                                                0x1800B0D4
+#define MD_GSP_TXBASE_reg_addr                                                       "0xB800B0D4"
+#define MD_GSP_TXBASE_reg                                                            0xB800B0D4
+#define set_MD_GSP_TXBASE_reg(data)   (*((volatile unsigned int*) MD_GSP_TXBASE_reg)=data)
+#define get_MD_GSP_TXBASE_reg   (*((volatile unsigned int*) MD_GSP_TXBASE_reg))
+#define MD_GSP_TXBASE_inst_adr                                                       "0x0035"
+#define MD_GSP_TXBASE_inst                                                           0x0035
+#define MD_GSP_TXBASE_gsp_tx_base_shift                                              (3)
+#define MD_GSP_TXBASE_gsp_tx_base_mask                                               (0x7FFFFFF8)
+#define MD_GSP_TXBASE_gsp_tx_base(data)                                              (0x7FFFFFF8&((data)<<3))
+#define MD_GSP_TXBASE_gsp_tx_base_src(data)                                          ((0x7FFFFFF8&(data))>>3)
+#define MD_GSP_TXBASE_get_gsp_tx_base(data)                                          ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_GSP_TXLIMIT                                                               0x1800B0D8
+#define MD_GSP_TXLIMIT_reg_addr                                                      "0xB800B0D8"
+#define MD_GSP_TXLIMIT_reg                                                           0xB800B0D8
+#define set_MD_GSP_TXLIMIT_reg(data)   (*((volatile unsigned int*) MD_GSP_TXLIMIT_reg)=data)
+#define get_MD_GSP_TXLIMIT_reg   (*((volatile unsigned int*) MD_GSP_TXLIMIT_reg))
+#define MD_GSP_TXLIMIT_inst_adr                                                      "0x0036"
+#define MD_GSP_TXLIMIT_inst                                                          0x0036
+#define MD_GSP_TXLIMIT_gsp_tx_limit_shift                                            (3)
+#define MD_GSP_TXLIMIT_gsp_tx_limit_mask                                             (0x7FFFFFF8)
+#define MD_GSP_TXLIMIT_gsp_tx_limit(data)                                            (0x7FFFFFF8&((data)<<3))
+#define MD_GSP_TXLIMIT_gsp_tx_limit_src(data)                                        ((0x7FFFFFF8&(data))>>3)
+#define MD_GSP_TXLIMIT_get_gsp_tx_limit(data)                                        ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_GSP_TXWRPTR                                                               0x1800B0DC
+#define MD_GSP_TXWRPTR_reg_addr                                                      "0xB800B0DC"
+#define MD_GSP_TXWRPTR_reg                                                           0xB800B0DC
+#define set_MD_GSP_TXWRPTR_reg(data)   (*((volatile unsigned int*) MD_GSP_TXWRPTR_reg)=data)
+#define get_MD_GSP_TXWRPTR_reg   (*((volatile unsigned int*) MD_GSP_TXWRPTR_reg))
+#define MD_GSP_TXWRPTR_inst_adr                                                      "0x0037"
+#define MD_GSP_TXWRPTR_inst                                                          0x0037
+#define MD_GSP_TXWRPTR_gsp_tx_wrptr_shift                                            (0)
+#define MD_GSP_TXWRPTR_gsp_tx_wrptr_mask                                             (0x7FFFFFFF)
+#define MD_GSP_TXWRPTR_gsp_tx_wrptr(data)                                            (0x7FFFFFFF&((data)<<0))
+#define MD_GSP_TXWRPTR_gsp_tx_wrptr_src(data)                                        ((0x7FFFFFFF&(data))>>0)
+#define MD_GSP_TXWRPTR_get_gsp_tx_wrptr(data)                                        ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_GSP_TXRDPTR                                                               0x1800B0E0
+#define MD_GSP_TXRDPTR_reg_addr                                                      "0xB800B0E0"
+#define MD_GSP_TXRDPTR_reg                                                           0xB800B0E0
+#define set_MD_GSP_TXRDPTR_reg(data)   (*((volatile unsigned int*) MD_GSP_TXRDPTR_reg)=data)
+#define get_MD_GSP_TXRDPTR_reg   (*((volatile unsigned int*) MD_GSP_TXRDPTR_reg))
+#define MD_GSP_TXRDPTR_inst_adr                                                      "0x0038"
+#define MD_GSP_TXRDPTR_inst                                                          0x0038
+#define MD_GSP_TXRDPTR_gsp_tx_rdptr_shift                                            (0)
+#define MD_GSP_TXRDPTR_gsp_tx_rdptr_mask                                             (0x7FFFFFFF)
+#define MD_GSP_TXRDPTR_gsp_tx_rdptr(data)                                            (0x7FFFFFFF&((data)<<0))
+#define MD_GSP_TXRDPTR_gsp_tx_rdptr_src(data)                                        ((0x7FFFFFFF&(data))>>0)
+#define MD_GSP_TXRDPTR_get_gsp_tx_rdptr(data)                                        ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_GSP_TXTHD                                                                 0x1800B0E4
+#define MD_GSP_TXTHD_reg_addr                                                        "0xB800B0E4"
+#define MD_GSP_TXTHD_reg                                                             0xB800B0E4
+#define set_MD_GSP_TXTHD_reg(data)   (*((volatile unsigned int*) MD_GSP_TXTHD_reg)=data)
+#define get_MD_GSP_TXTHD_reg   (*((volatile unsigned int*) MD_GSP_TXTHD_reg))
+#define MD_GSP_TXTHD_inst_adr                                                        "0x0039"
+#define MD_GSP_TXTHD_inst                                                            0x0039
+#define MD_GSP_TXTHD_gsp_tx_thd_shift                                                (0)
+#define MD_GSP_TXTHD_gsp_tx_thd_mask                                                 (0xFFFFFFFF)
+#define MD_GSP_TXTHD_gsp_tx_thd(data)                                                (0xFFFFFFFF&((data)<<0))
+#define MD_GSP_TXTHD_gsp_tx_thd_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define MD_GSP_TXTHD_get_gsp_tx_thd(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define MD_GSP_RXBASE                                                                0x1800B0E8
+#define MD_GSP_RXBASE_reg_addr                                                       "0xB800B0E8"
+#define MD_GSP_RXBASE_reg                                                            0xB800B0E8
+#define set_MD_GSP_RXBASE_reg(data)   (*((volatile unsigned int*) MD_GSP_RXBASE_reg)=data)
+#define get_MD_GSP_RXBASE_reg   (*((volatile unsigned int*) MD_GSP_RXBASE_reg))
+#define MD_GSP_RXBASE_inst_adr                                                       "0x003A"
+#define MD_GSP_RXBASE_inst                                                           0x003A
+#define MD_GSP_RXBASE_gsp_rx_base_shift                                              (3)
+#define MD_GSP_RXBASE_gsp_rx_base_mask                                               (0x7FFFFFF8)
+#define MD_GSP_RXBASE_gsp_rx_base(data)                                              (0x7FFFFFF8&((data)<<3))
+#define MD_GSP_RXBASE_gsp_rx_base_src(data)                                          ((0x7FFFFFF8&(data))>>3)
+#define MD_GSP_RXBASE_get_gsp_rx_base(data)                                          ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_GSP_RXLIMIT                                                               0x1800B0EC
+#define MD_GSP_RXLIMIT_reg_addr                                                      "0xB800B0EC"
+#define MD_GSP_RXLIMIT_reg                                                           0xB800B0EC
+#define set_MD_GSP_RXLIMIT_reg(data)   (*((volatile unsigned int*) MD_GSP_RXLIMIT_reg)=data)
+#define get_MD_GSP_RXLIMIT_reg   (*((volatile unsigned int*) MD_GSP_RXLIMIT_reg))
+#define MD_GSP_RXLIMIT_inst_adr                                                      "0x003B"
+#define MD_GSP_RXLIMIT_inst                                                          0x003B
+#define MD_GSP_RXLIMIT_gsp_rx_limit_shift                                            (3)
+#define MD_GSP_RXLIMIT_gsp_rx_limit_mask                                             (0x7FFFFFF8)
+#define MD_GSP_RXLIMIT_gsp_rx_limit(data)                                            (0x7FFFFFF8&((data)<<3))
+#define MD_GSP_RXLIMIT_gsp_rx_limit_src(data)                                        ((0x7FFFFFF8&(data))>>3)
+#define MD_GSP_RXLIMIT_get_gsp_rx_limit(data)                                        ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_GSP_RXWRPTR                                                               0x1800B0F0
+#define MD_GSP_RXWRPTR_reg_addr                                                      "0xB800B0F0"
+#define MD_GSP_RXWRPTR_reg                                                           0xB800B0F0
+#define set_MD_GSP_RXWRPTR_reg(data)   (*((volatile unsigned int*) MD_GSP_RXWRPTR_reg)=data)
+#define get_MD_GSP_RXWRPTR_reg   (*((volatile unsigned int*) MD_GSP_RXWRPTR_reg))
+#define MD_GSP_RXWRPTR_inst_adr                                                      "0x003C"
+#define MD_GSP_RXWRPTR_inst                                                          0x003C
+#define MD_GSP_RXWRPTR_gsp_rx_wrptr_shift                                            (0)
+#define MD_GSP_RXWRPTR_gsp_rx_wrptr_mask                                             (0x7FFFFFFF)
+#define MD_GSP_RXWRPTR_gsp_rx_wrptr(data)                                            (0x7FFFFFFF&((data)<<0))
+#define MD_GSP_RXWRPTR_gsp_rx_wrptr_src(data)                                        ((0x7FFFFFFF&(data))>>0)
+#define MD_GSP_RXWRPTR_get_gsp_rx_wrptr(data)                                        ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_GSP_RXRDPTR                                                               0x1800B0F4
+#define MD_GSP_RXRDPTR_reg_addr                                                      "0xB800B0F4"
+#define MD_GSP_RXRDPTR_reg                                                           0xB800B0F4
+#define set_MD_GSP_RXRDPTR_reg(data)   (*((volatile unsigned int*) MD_GSP_RXRDPTR_reg)=data)
+#define get_MD_GSP_RXRDPTR_reg   (*((volatile unsigned int*) MD_GSP_RXRDPTR_reg))
+#define MD_GSP_RXRDPTR_inst_adr                                                      "0x003D"
+#define MD_GSP_RXRDPTR_inst                                                          0x003D
+#define MD_GSP_RXRDPTR_gsp_rx_rdptr_shift                                            (0)
+#define MD_GSP_RXRDPTR_gsp_rx_rdptr_mask                                             (0x7FFFFFFF)
+#define MD_GSP_RXRDPTR_gsp_rx_rdptr(data)                                            (0x7FFFFFFF&((data)<<0))
+#define MD_GSP_RXRDPTR_gsp_rx_rdptr_src(data)                                        ((0x7FFFFFFF&(data))>>0)
+#define MD_GSP_RXRDPTR_get_gsp_rx_rdptr(data)                                        ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_GSP_RXTHD                                                                 0x1800B0F8
+#define MD_GSP_RXTHD_reg_addr                                                        "0xB800B0F8"
+#define MD_GSP_RXTHD_reg                                                             0xB800B0F8
+#define set_MD_GSP_RXTHD_reg(data)   (*((volatile unsigned int*) MD_GSP_RXTHD_reg)=data)
+#define get_MD_GSP_RXTHD_reg   (*((volatile unsigned int*) MD_GSP_RXTHD_reg))
+#define MD_GSP_RXTHD_inst_adr                                                        "0x003E"
+#define MD_GSP_RXTHD_inst                                                            0x003E
+#define MD_GSP_RXTHD_gsp_rx_thd_shift                                                (0)
+#define MD_GSP_RXTHD_gsp_rx_thd_mask                                                 (0xFFFFFFFF)
+#define MD_GSP_RXTHD_gsp_rx_thd(data)                                                (0xFFFFFFFF&((data)<<0))
+#define MD_GSP_RXTHD_gsp_rx_thd_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define MD_GSP_RXTHD_get_gsp_rx_thd(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define MD_GSP_ENABLE                                                                0x1800B0FC
+#define MD_GSP_ENABLE_reg_addr                                                       "0xB800B0FC"
+#define MD_GSP_ENABLE_reg                                                            0xB800B0FC
+#define set_MD_GSP_ENABLE_reg(data)   (*((volatile unsigned int*) MD_GSP_ENABLE_reg)=data)
+#define get_MD_GSP_ENABLE_reg   (*((volatile unsigned int*) MD_GSP_ENABLE_reg))
+#define MD_GSP_ENABLE_inst_adr                                                       "0x003F"
+#define MD_GSP_ENABLE_inst                                                           0x003F
+#define MD_GSP_ENABLE_gsp_en_shift                                                   (0)
+#define MD_GSP_ENABLE_gsp_en_mask                                                    (0x00000001)
+#define MD_GSP_ENABLE_gsp_en(data)                                                   (0x00000001&((data)<<0))
+#define MD_GSP_ENABLE_gsp_en_src(data)                                               ((0x00000001&(data))>>0)
+#define MD_GSP_ENABLE_get_gsp_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define MD_GSP_TXBASICBASE                                                           0x1800B100
+#define MD_GSP_TXBASICBASE_reg_addr                                                  "0xB800B100"
+#define MD_GSP_TXBASICBASE_reg                                                       0xB800B100
+#define set_MD_GSP_TXBASICBASE_reg(data)   (*((volatile unsigned int*) MD_GSP_TXBASICBASE_reg)=data)
+#define get_MD_GSP_TXBASICBASE_reg   (*((volatile unsigned int*) MD_GSP_TXBASICBASE_reg))
+#define MD_GSP_TXBASICBASE_inst_adr                                                  "0x0040"
+#define MD_GSP_TXBASICBASE_inst                                                      0x0040
+#define MD_GSP_TXBASICBASE_gsp_txbasic_base_shift                                    (3)
+#define MD_GSP_TXBASICBASE_gsp_txbasic_base_mask                                     (0x7FFFFFF8)
+#define MD_GSP_TXBASICBASE_gsp_txbasic_base(data)                                    (0x7FFFFFF8&((data)<<3))
+#define MD_GSP_TXBASICBASE_gsp_txbasic_base_src(data)                                ((0x7FFFFFF8&(data))>>3)
+#define MD_GSP_TXBASICBASE_get_gsp_txbasic_base(data)                                ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_GSP_TXBASICLIMIT                                                          0x1800B104
+#define MD_GSP_TXBASICLIMIT_reg_addr                                                 "0xB800B104"
+#define MD_GSP_TXBASICLIMIT_reg                                                      0xB800B104
+#define set_MD_GSP_TXBASICLIMIT_reg(data)   (*((volatile unsigned int*) MD_GSP_TXBASICLIMIT_reg)=data)
+#define get_MD_GSP_TXBASICLIMIT_reg   (*((volatile unsigned int*) MD_GSP_TXBASICLIMIT_reg))
+#define MD_GSP_TXBASICLIMIT_inst_adr                                                 "0x0041"
+#define MD_GSP_TXBASICLIMIT_inst                                                     0x0041
+#define MD_GSP_TXBASICLIMIT_gsp_txbasic_limit_shift                                  (3)
+#define MD_GSP_TXBASICLIMIT_gsp_txbasic_limit_mask                                   (0x7FFFFFF8)
+#define MD_GSP_TXBASICLIMIT_gsp_txbasic_limit(data)                                  (0x7FFFFFF8&((data)<<3))
+#define MD_GSP_TXBASICLIMIT_gsp_txbasic_limit_src(data)                              ((0x7FFFFFF8&(data))>>3)
+#define MD_GSP_TXBASICLIMIT_get_gsp_txbasic_limit(data)                              ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_GSP_TXBASICWRPTR                                                          0x1800B108
+#define MD_GSP_TXBASICWRPTR_reg_addr                                                 "0xB800B108"
+#define MD_GSP_TXBASICWRPTR_reg                                                      0xB800B108
+#define set_MD_GSP_TXBASICWRPTR_reg(data)   (*((volatile unsigned int*) MD_GSP_TXBASICWRPTR_reg)=data)
+#define get_MD_GSP_TXBASICWRPTR_reg   (*((volatile unsigned int*) MD_GSP_TXBASICWRPTR_reg))
+#define MD_GSP_TXBASICWRPTR_inst_adr                                                 "0x0042"
+#define MD_GSP_TXBASICWRPTR_inst                                                     0x0042
+#define MD_GSP_TXBASICWRPTR_gsp_txbasic_wrptr_shift                                  (0)
+#define MD_GSP_TXBASICWRPTR_gsp_txbasic_wrptr_mask                                   (0x7FFFFFFF)
+#define MD_GSP_TXBASICWRPTR_gsp_txbasic_wrptr(data)                                  (0x7FFFFFFF&((data)<<0))
+#define MD_GSP_TXBASICWRPTR_gsp_txbasic_wrptr_src(data)                              ((0x7FFFFFFF&(data))>>0)
+#define MD_GSP_TXBASICWRPTR_get_gsp_txbasic_wrptr(data)                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_GSP_TXBASICRDPTR                                                          0x1800B10C
+#define MD_GSP_TXBASICRDPTR_reg_addr                                                 "0xB800B10C"
+#define MD_GSP_TXBASICRDPTR_reg                                                      0xB800B10C
+#define set_MD_GSP_TXBASICRDPTR_reg(data)   (*((volatile unsigned int*) MD_GSP_TXBASICRDPTR_reg)=data)
+#define get_MD_GSP_TXBASICRDPTR_reg   (*((volatile unsigned int*) MD_GSP_TXBASICRDPTR_reg))
+#define MD_GSP_TXBASICRDPTR_inst_adr                                                 "0x0043"
+#define MD_GSP_TXBASICRDPTR_inst                                                     0x0043
+#define MD_GSP_TXBASICRDPTR_gsp_txbasic_rdptr_shift                                  (0)
+#define MD_GSP_TXBASICRDPTR_gsp_txbasic_rdptr_mask                                   (0x7FFFFFFF)
+#define MD_GSP_TXBASICRDPTR_gsp_txbasic_rdptr(data)                                  (0x7FFFFFFF&((data)<<0))
+#define MD_GSP_TXBASICRDPTR_gsp_txbasic_rdptr_src(data)                              ((0x7FFFFFFF&(data))>>0)
+#define MD_GSP_TXBASICRDPTR_get_gsp_txbasic_rdptr(data)                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_GSP_TXBASICTHD                                                            0x1800B110
+#define MD_GSP_TXBASICTHD_reg_addr                                                   "0xB800B110"
+#define MD_GSP_TXBASICTHD_reg                                                        0xB800B110
+#define set_MD_GSP_TXBASICTHD_reg(data)   (*((volatile unsigned int*) MD_GSP_TXBASICTHD_reg)=data)
+#define get_MD_GSP_TXBASICTHD_reg   (*((volatile unsigned int*) MD_GSP_TXBASICTHD_reg))
+#define MD_GSP_TXBASICTHD_inst_adr                                                   "0x0044"
+#define MD_GSP_TXBASICTHD_inst                                                       0x0044
+#define MD_GSP_TXBASICTHD_gsp_txbasic_thd_shift                                      (0)
+#define MD_GSP_TXBASICTHD_gsp_txbasic_thd_mask                                       (0xFFFFFFFF)
+#define MD_GSP_TXBASICTHD_gsp_txbasic_thd(data)                                      (0xFFFFFFFF&((data)<<0))
+#define MD_GSP_TXBASICTHD_gsp_txbasic_thd_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define MD_GSP_TXBASICTHD_get_gsp_txbasic_thd(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define MD_GSP_TXDATBASE                                                             0x1800B114
+#define MD_GSP_TXDATBASE_reg_addr                                                    "0xB800B114"
+#define MD_GSP_TXDATBASE_reg                                                         0xB800B114
+#define set_MD_GSP_TXDATBASE_reg(data)   (*((volatile unsigned int*) MD_GSP_TXDATBASE_reg)=data)
+#define get_MD_GSP_TXDATBASE_reg   (*((volatile unsigned int*) MD_GSP_TXDATBASE_reg))
+#define MD_GSP_TXDATBASE_inst_adr                                                    "0x0045"
+#define MD_GSP_TXDATBASE_inst                                                        0x0045
+#define MD_GSP_TXDATBASE_gsp_txdat_base_shift                                        (3)
+#define MD_GSP_TXDATBASE_gsp_txdat_base_mask                                         (0x7FFFFFF8)
+#define MD_GSP_TXDATBASE_gsp_txdat_base(data)                                        (0x7FFFFFF8&((data)<<3))
+#define MD_GSP_TXDATBASE_gsp_txdat_base_src(data)                                    ((0x7FFFFFF8&(data))>>3)
+#define MD_GSP_TXDATBASE_get_gsp_txdat_base(data)                                    ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_GSP_TXDATLIMIT                                                            0x1800B118
+#define MD_GSP_TXDATLIMIT_reg_addr                                                   "0xB800B118"
+#define MD_GSP_TXDATLIMIT_reg                                                        0xB800B118
+#define set_MD_GSP_TXDATLIMIT_reg(data)   (*((volatile unsigned int*) MD_GSP_TXDATLIMIT_reg)=data)
+#define get_MD_GSP_TXDATLIMIT_reg   (*((volatile unsigned int*) MD_GSP_TXDATLIMIT_reg))
+#define MD_GSP_TXDATLIMIT_inst_adr                                                   "0x0046"
+#define MD_GSP_TXDATLIMIT_inst                                                       0x0046
+#define MD_GSP_TXDATLIMIT_gsp_txdat_limit_shift                                      (3)
+#define MD_GSP_TXDATLIMIT_gsp_txdat_limit_mask                                       (0x7FFFFFF8)
+#define MD_GSP_TXDATLIMIT_gsp_txdat_limit(data)                                      (0x7FFFFFF8&((data)<<3))
+#define MD_GSP_TXDATLIMIT_gsp_txdat_limit_src(data)                                  ((0x7FFFFFF8&(data))>>3)
+#define MD_GSP_TXDATLIMIT_get_gsp_txdat_limit(data)                                  ((0x7FFFFFF8&(data))>>3)
+
+
+#define MD_GSP_TXDATWRPTR                                                            0x1800B11C
+#define MD_GSP_TXDATWRPTR_reg_addr                                                   "0xB800B11C"
+#define MD_GSP_TXDATWRPTR_reg                                                        0xB800B11C
+#define set_MD_GSP_TXDATWRPTR_reg(data)   (*((volatile unsigned int*) MD_GSP_TXDATWRPTR_reg)=data)
+#define get_MD_GSP_TXDATWRPTR_reg   (*((volatile unsigned int*) MD_GSP_TXDATWRPTR_reg))
+#define MD_GSP_TXDATWRPTR_inst_adr                                                   "0x0047"
+#define MD_GSP_TXDATWRPTR_inst                                                       0x0047
+#define MD_GSP_TXDATWRPTR_gsp_txdat_wrptr_shift                                      (0)
+#define MD_GSP_TXDATWRPTR_gsp_txdat_wrptr_mask                                       (0x7FFFFFFF)
+#define MD_GSP_TXDATWRPTR_gsp_txdat_wrptr(data)                                      (0x7FFFFFFF&((data)<<0))
+#define MD_GSP_TXDATWRPTR_gsp_txdat_wrptr_src(data)                                  ((0x7FFFFFFF&(data))>>0)
+#define MD_GSP_TXDATWRPTR_get_gsp_txdat_wrptr(data)                                  ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_GSP_TXDATRDPTR                                                            0x1800B120
+#define MD_GSP_TXDATRDPTR_reg_addr                                                   "0xB800B120"
+#define MD_GSP_TXDATRDPTR_reg                                                        0xB800B120
+#define set_MD_GSP_TXDATRDPTR_reg(data)   (*((volatile unsigned int*) MD_GSP_TXDATRDPTR_reg)=data)
+#define get_MD_GSP_TXDATRDPTR_reg   (*((volatile unsigned int*) MD_GSP_TXDATRDPTR_reg))
+#define MD_GSP_TXDATRDPTR_inst_adr                                                   "0x0048"
+#define MD_GSP_TXDATRDPTR_inst                                                       0x0048
+#define MD_GSP_TXDATRDPTR_gsp_txdat_rdptr_shift                                      (0)
+#define MD_GSP_TXDATRDPTR_gsp_txdat_rdptr_mask                                       (0x7FFFFFFF)
+#define MD_GSP_TXDATRDPTR_gsp_txdat_rdptr(data)                                      (0x7FFFFFFF&((data)<<0))
+#define MD_GSP_TXDATRDPTR_gsp_txdat_rdptr_src(data)                                  ((0x7FFFFFFF&(data))>>0)
+#define MD_GSP_TXDATRDPTR_get_gsp_txdat_rdptr(data)                                  ((0x7FFFFFFF&(data))>>0)
+
+
+#define MD_GSP_TXDATTHD                                                              0x1800B124
+#define MD_GSP_TXDATTHD_reg_addr                                                     "0xB800B124"
+#define MD_GSP_TXDATTHD_reg                                                          0xB800B124
+#define set_MD_GSP_TXDATTHD_reg(data)   (*((volatile unsigned int*) MD_GSP_TXDATTHD_reg)=data)
+#define get_MD_GSP_TXDATTHD_reg   (*((volatile unsigned int*) MD_GSP_TXDATTHD_reg))
+#define MD_GSP_TXDATTHD_inst_adr                                                     "0x0049"
+#define MD_GSP_TXDATTHD_inst                                                         0x0049
+#define MD_GSP_TXDATTHD_gsp_txdat_thd_shift                                          (0)
+#define MD_GSP_TXDATTHD_gsp_txdat_thd_mask                                           (0xFFFFFFFF)
+#define MD_GSP_TXDATTHD_gsp_txdat_thd(data)                                          (0xFFFFFFFF&((data)<<0))
+#define MD_GSP_TXDATTHD_gsp_txdat_thd_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define MD_GSP_TXDATTHD_get_gsp_txdat_thd(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define MD_POWER                                                                     0x1800B128
+#define MD_POWER_reg_addr                                                            "0xB800B128"
+#define MD_POWER_reg                                                                 0xB800B128
+#define set_MD_POWER_reg(data)   (*((volatile unsigned int*) MD_POWER_reg)=data)
+#define get_MD_POWER_reg   (*((volatile unsigned int*) MD_POWER_reg))
+#define MD_POWER_inst_adr                                                            "0x004A"
+#define MD_POWER_inst                                                                0x004A
+#define MD_POWER_gating_en_shift                                                     (0)
+#define MD_POWER_gating_en_mask                                                      (0x00000001)
+#define MD_POWER_gating_en(data)                                                     (0x00000001&((data)<<0))
+#define MD_POWER_gating_en_src(data)                                                 ((0x00000001&(data))>>0)
+#define MD_POWER_get_gating_en(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define MD_DUMMY1                                                                    0x1800B09C
+#define MD_DUMMY1_reg_addr                                                           "0xB800B09C"
+#define MD_DUMMY1_reg                                                                0xB800B09C
+#define set_MD_DUMMY1_reg(data)   (*((volatile unsigned int*) MD_DUMMY1_reg)=data)
+#define get_MD_DUMMY1_reg   (*((volatile unsigned int*) MD_DUMMY1_reg))
+#define MD_DUMMY1_inst_adr                                                           "0x0027"
+#define MD_DUMMY1_inst                                                               0x0027
+#define MD_DUMMY1_dummy1_shift                                                       (0)
+#define MD_DUMMY1_dummy1_mask                                                        (0xFFFFFFFF)
+#define MD_DUMMY1_dummy1(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define MD_DUMMY1_dummy1_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define MD_DUMMY1_get_dummy1(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define MD_DUMMY2                                                                    0x1800B0A0
+#define MD_DUMMY2_reg_addr                                                           "0xB800B0A0"
+#define MD_DUMMY2_reg                                                                0xB800B0A0
+#define set_MD_DUMMY2_reg(data)   (*((volatile unsigned int*) MD_DUMMY2_reg)=data)
+#define get_MD_DUMMY2_reg   (*((volatile unsigned int*) MD_DUMMY2_reg))
+#define MD_DUMMY2_inst_adr                                                           "0x0028"
+#define MD_DUMMY2_inst                                                               0x0028
+#define MD_DUMMY2_dummy2_shift                                                       (0)
+#define MD_DUMMY2_dummy2_mask                                                        (0xFFFFFFFF)
+#define MD_DUMMY2_dummy2(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define MD_DUMMY2_dummy2_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define MD_DUMMY2_get_dummy2(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define BIST_DVS                                                                     0x1800B12C
+#define BIST_DVS_reg_addr                                                            "0xB800B12C"
+#define BIST_DVS_reg                                                                 0xB800B12C
+#define set_BIST_DVS_reg(data)   (*((volatile unsigned int*) BIST_DVS_reg)=data)
+#define get_BIST_DVS_reg   (*((volatile unsigned int*) BIST_DVS_reg))
+#define BIST_DVS_inst_adr                                                            "0x004B"
+#define BIST_DVS_inst                                                                0x004B
+#define BIST_DVS_dvse_shift                                                          (4)
+#define BIST_DVS_dvse_mask                                                           (0x00000010)
+#define BIST_DVS_dvse(data)                                                          (0x00000010&((data)<<4))
+#define BIST_DVS_dvse_src(data)                                                      ((0x00000010&(data))>>4)
+#define BIST_DVS_get_dvse(data)                                                      ((0x00000010&(data))>>4)
+#define BIST_DVS_dvs_3_shift                                                         (3)
+#define BIST_DVS_dvs_3_mask                                                          (0x00000008)
+#define BIST_DVS_dvs_3(data)                                                         (0x00000008&((data)<<3))
+#define BIST_DVS_dvs_3_src(data)                                                     ((0x00000008&(data))>>3)
+#define BIST_DVS_get_dvs_3(data)                                                     ((0x00000008&(data))>>3)
+#define BIST_DVS_dvs_2_shift                                                         (2)
+#define BIST_DVS_dvs_2_mask                                                          (0x00000004)
+#define BIST_DVS_dvs_2(data)                                                         (0x00000004&((data)<<2))
+#define BIST_DVS_dvs_2_src(data)                                                     ((0x00000004&(data))>>2)
+#define BIST_DVS_get_dvs_2(data)                                                     ((0x00000004&(data))>>2)
+#define BIST_DVS_dvs_1_shift                                                         (1)
+#define BIST_DVS_dvs_1_mask                                                          (0x00000002)
+#define BIST_DVS_dvs_1(data)                                                         (0x00000002&((data)<<1))
+#define BIST_DVS_dvs_1_src(data)                                                     ((0x00000002&(data))>>1)
+#define BIST_DVS_get_dvs_1(data)                                                     ((0x00000002&(data))>>1)
+#define BIST_DVS_dvs_0_shift                                                         (0)
+#define BIST_DVS_dvs_0_mask                                                          (0x00000001)
+#define BIST_DVS_dvs_0(data)                                                         (0x00000001&((data)<<0))
+#define BIST_DVS_dvs_0_src(data)                                                     ((0x00000001&(data))>>0)
+#define BIST_DVS_get_dvs_0(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define BIST_ST                                                                      0x1800B130
+#define BIST_ST_reg_addr                                                             "0xB800B130"
+#define BIST_ST_reg                                                                  0xB800B130
+#define set_BIST_ST_reg(data)   (*((volatile unsigned int*) BIST_ST_reg)=data)
+#define get_BIST_ST_reg   (*((volatile unsigned int*) BIST_ST_reg))
+#define BIST_ST_inst_adr                                                             "0x004C"
+#define BIST_ST_inst                                                                 0x004C
+#define BIST_ST_bist_fail2_shift                                                     (3)
+#define BIST_ST_bist_fail2_mask                                                      (0x00000008)
+#define BIST_ST_bist_fail2(data)                                                     (0x00000008&((data)<<3))
+#define BIST_ST_bist_fail2_src(data)                                                 ((0x00000008&(data))>>3)
+#define BIST_ST_get_bist_fail2(data)                                                 ((0x00000008&(data))>>3)
+#define BIST_ST_bist_fail1_shift                                                     (2)
+#define BIST_ST_bist_fail1_mask                                                      (0x00000004)
+#define BIST_ST_bist_fail1(data)                                                     (0x00000004&((data)<<2))
+#define BIST_ST_bist_fail1_src(data)                                                 ((0x00000004&(data))>>2)
+#define BIST_ST_get_bist_fail1(data)                                                 ((0x00000004&(data))>>2)
+#define BIST_ST_bist_fail0_shift                                                     (1)
+#define BIST_ST_bist_fail0_mask                                                      (0x00000002)
+#define BIST_ST_bist_fail0(data)                                                     (0x00000002&((data)<<1))
+#define BIST_ST_bist_fail0_src(data)                                                 ((0x00000002&(data))>>1)
+#define BIST_ST_get_bist_fail0(data)                                                 ((0x00000002&(data))>>1)
+#define BIST_ST_bist_done_shift                                                      (0)
+#define BIST_ST_bist_done_mask                                                       (0x00000001)
+#define BIST_ST_bist_done(data)                                                      (0x00000001&((data)<<0))
+#define BIST_ST_bist_done_src(data)                                                  ((0x00000001&(data))>>0)
+#define BIST_ST_get_bist_done(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define DRF_ST                                                                       0x1800B134
+#define DRF_ST_reg_addr                                                              "0xB800B134"
+#define DRF_ST_reg                                                                   0xB800B134
+#define set_DRF_ST_reg(data)   (*((volatile unsigned int*) DRF_ST_reg)=data)
+#define get_DRF_ST_reg   (*((volatile unsigned int*) DRF_ST_reg))
+#define DRF_ST_inst_adr                                                              "0x004D"
+#define DRF_ST_inst                                                                  0x004D
+#define DRF_ST_drf_start_pause_shift                                                 (16)
+#define DRF_ST_drf_start_pause_mask                                                  (0x00010000)
+#define DRF_ST_drf_start_pause(data)                                                 (0x00010000&((data)<<16))
+#define DRF_ST_drf_start_pause_src(data)                                             ((0x00010000&(data))>>16)
+#define DRF_ST_get_drf_start_pause(data)                                             ((0x00010000&(data))>>16)
+#define DRF_ST_drf_fail2_shift                                                       (3)
+#define DRF_ST_drf_fail2_mask                                                        (0x00000008)
+#define DRF_ST_drf_fail2(data)                                                       (0x00000008&((data)<<3))
+#define DRF_ST_drf_fail2_src(data)                                                   ((0x00000008&(data))>>3)
+#define DRF_ST_get_drf_fail2(data)                                                   ((0x00000008&(data))>>3)
+#define DRF_ST_drf_fail1_shift                                                       (2)
+#define DRF_ST_drf_fail1_mask                                                        (0x00000004)
+#define DRF_ST_drf_fail1(data)                                                       (0x00000004&((data)<<2))
+#define DRF_ST_drf_fail1_src(data)                                                   ((0x00000004&(data))>>2)
+#define DRF_ST_get_drf_fail1(data)                                                   ((0x00000004&(data))>>2)
+#define DRF_ST_drf_fail0_shift                                                       (1)
+#define DRF_ST_drf_fail0_mask                                                        (0x00000002)
+#define DRF_ST_drf_fail0(data)                                                       (0x00000002&((data)<<1))
+#define DRF_ST_drf_fail0_src(data)                                                   ((0x00000002&(data))>>1)
+#define DRF_ST_get_drf_fail0(data)                                                   ((0x00000002&(data))>>1)
+#define DRF_ST_drf_done_shift                                                        (0)
+#define DRF_ST_drf_done_mask                                                         (0x00000001)
+#define DRF_ST_drf_done(data)                                                        (0x00000001&((data)<<0))
+#define DRF_ST_drf_done_src(data)                                                    ((0x00000001&(data))>>0)
+#define DRF_ST_get_drf_done(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define MBIST_CON                                                                    0x1800B138
+#define MBIST_CON_reg_addr                                                           "0xB800B138"
+#define MBIST_CON_reg                                                                0xB800B138
+#define set_MBIST_CON_reg(data)   (*((volatile unsigned int*) MBIST_CON_reg)=data)
+#define get_MBIST_CON_reg   (*((volatile unsigned int*) MBIST_CON_reg))
+#define MBIST_CON_inst_adr                                                           "0x004E"
+#define MBIST_CON_inst                                                               0x004E
+#define MBIST_CON_drf_test_resume_shift                                              (2)
+#define MBIST_CON_drf_test_resume_mask                                               (0x00000004)
+#define MBIST_CON_drf_test_resume(data)                                              (0x00000004&((data)<<2))
+#define MBIST_CON_drf_test_resume_src(data)                                          ((0x00000004&(data))>>2)
+#define MBIST_CON_get_drf_test_resume(data)                                          ((0x00000004&(data))>>2)
+#define MBIST_CON_drf_bist_mode_shift                                                (1)
+#define MBIST_CON_drf_bist_mode_mask                                                 (0x00000002)
+#define MBIST_CON_drf_bist_mode(data)                                                (0x00000002&((data)<<1))
+#define MBIST_CON_drf_bist_mode_src(data)                                            ((0x00000002&(data))>>1)
+#define MBIST_CON_get_drf_bist_mode(data)                                            ((0x00000002&(data))>>1)
+#define MBIST_CON_bist_mode_shift                                                    (0)
+#define MBIST_CON_bist_mode_mask                                                     (0x00000001)
+#define MBIST_CON_bist_mode(data)                                                    (0x00000001&((data)<<0))
+#define MBIST_CON_bist_mode_src(data)                                                ((0x00000001&(data))>>0)
+#define MBIST_CON_get_bist_mode(data)                                                ((0x00000001&(data))>>0)
+
+
+#define MD_SMQFREERUN                                                                0x1800B140
+#define MD_SMQFREERUN_reg_addr                                                       "0xB800B140"
+#define MD_SMQFREERUN_reg                                                            0xB800B140
+#define set_MD_SMQFREERUN_reg(data)   (*((volatile unsigned int*) MD_SMQFREERUN_reg)=data)
+#define get_MD_SMQFREERUN_reg   (*((volatile unsigned int*) MD_SMQFREERUN_reg))
+#define MD_SMQFREERUN_inst_adr                                                       "0x0050"
+#define MD_SMQFREERUN_inst                                                           0x0050
+#define MD_SMQFREERUN_smq_freerun_shift                                              (0)
+#define MD_SMQFREERUN_smq_freerun_mask                                               (0x00000001)
+#define MD_SMQFREERUN_smq_freerun(data)                                              (0x00000001&((data)<<0))
+#define MD_SMQFREERUN_smq_freerun_src(data)                                          ((0x00000001&(data))>>0)
+#define MD_SMQFREERUN_get_smq_freerun(data)                                          ((0x00000001&(data))>>0)
+
+
+#define MD_VMQFREERUN                                                                0x1800B144
+#define MD_VMQFREERUN_reg_addr                                                       "0xB800B144"
+#define MD_VMQFREERUN_reg                                                            0xB800B144
+#define set_MD_VMQFREERUN_reg(data)   (*((volatile unsigned int*) MD_VMQFREERUN_reg)=data)
+#define get_MD_VMQFREERUN_reg   (*((volatile unsigned int*) MD_VMQFREERUN_reg))
+#define MD_VMQFREERUN_inst_adr                                                       "0x0051"
+#define MD_VMQFREERUN_inst                                                           0x0051
+#define MD_VMQFREERUN_vmq_freerun_shift                                              (0)
+#define MD_VMQFREERUN_vmq_freerun_mask                                               (0x00000001)
+#define MD_VMQFREERUN_vmq_freerun(data)                                              (0x00000001&((data)<<0))
+#define MD_VMQFREERUN_vmq_freerun_src(data)                                          ((0x00000001&(data))>>0)
+#define MD_VMQFREERUN_get_vmq_freerun(data)                                          ((0x00000001&(data))>>0)
+
+
+#define MD_KMQFREERUN                                                                0x1800B148
+#define MD_KMQFREERUN_reg_addr                                                       "0xB800B148"
+#define MD_KMQFREERUN_reg                                                            0xB800B148
+#define set_MD_KMQFREERUN_reg(data)   (*((volatile unsigned int*) MD_KMQFREERUN_reg)=data)
+#define get_MD_KMQFREERUN_reg   (*((volatile unsigned int*) MD_KMQFREERUN_reg))
+#define MD_KMQFREERUN_inst_adr                                                       "0x0052"
+#define MD_KMQFREERUN_inst                                                           0x0052
+#define MD_KMQFREERUN_kmq_freerun_shift                                              (0)
+#define MD_KMQFREERUN_kmq_freerun_mask                                               (0x00000001)
+#define MD_KMQFREERUN_kmq_freerun(data)                                              (0x00000001&((data)<<0))
+#define MD_KMQFREERUN_kmq_freerun_src(data)                                          ((0x00000001&(data))>>0)
+#define MD_KMQFREERUN_get_kmq_freerun(data)                                          ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/me_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/me_reg.h
new file mode 100644
index 00000000..7b6512a
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/me_reg.h
@@ -0,0 +1,763 @@
+/**************************************************************
+// Spec Version                  : 0.0.5
+// Parser Version                : MAR_Parser_1.0
+// CModelGen Version             : 1.0 2006.04.18
+// Naming Rule                   : Module_Register_Name_reg
+// Firmware Header Generate Date : 2008/4/3
+***************************************************************/
+
+
+#ifndef _ME_REG_H_INCLUDED_
+#define _ME_REG_H_INCLUDED_
+#ifdef  _ME_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     err:1;
+unsigned int     reserved_1:4;
+unsigned int     qs:1;
+unsigned int     rnd:1;
+unsigned int     fmt1:1;
+unsigned int     fmt0:1;
+unsigned int     reserved_2:2;
+unsigned int     mbl1:1;
+unsigned int     mbl0:1;
+unsigned int     ints:1;
+unsigned int     inte:1;
+unsigned int     disable_mp:1;
+unsigned int     tw:1;
+unsigned int     tms:1;
+unsigned int     tbs:1;
+unsigned int     go:1;
+unsigned int     write_data:1;
+}ME_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}ME_CMDADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}ME_RLTADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     fld:1;
+unsigned int     reserved_1:1;
+unsigned int     ti:7;
+unsigned int     reserved_2:1;
+unsigned int     bi:7;
+}ME_TSETA;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     y:11;
+unsigned int     xinc:4;
+unsigned int     reserved_1:1;
+unsigned int     x:11;
+}ME_TSETB;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     fld:1;
+unsigned int     reserved_1:1;
+unsigned int     ti:7;
+unsigned int     reserved_2:1;
+unsigned int     bi:7;
+}ME_RSETA;
+
+typedef struct 
+{
+unsigned int     mvys:2;
+unsigned int     reserved_0:6;
+unsigned int     mvxs:2;
+unsigned int     reserved_1:6;
+unsigned int     mvx:8;
+unsigned int     mvy:8;
+}ME_RSETB;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     y:11;
+unsigned int     xinc:4;
+unsigned int     reserved_1:1;
+unsigned int     x:11;
+}ME_RSETC;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     rh:11;
+unsigned int     reserved_1:5;
+unsigned int     rw:11;
+}ME_RSETD;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     tsy:11;
+unsigned int     reserved_1:5;
+unsigned int     tsx:11;
+}ME_RSETE;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     tey:11;
+unsigned int     reserved_1:5;
+unsigned int     tex:11;
+}ME_RSETF;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     bsy:11;
+unsigned int     reserved_1:5;
+unsigned int     bsx:11;
+}ME_RSETG;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     bey:11;
+unsigned int     reserved_1:5;
+unsigned int     bex:11;
+}ME_RSETH;
+
+typedef struct 
+{
+unsigned int     stage:1;
+unsigned int     half:2;
+unsigned int     mvce:1;
+unsigned int     hdrlt:1;
+unsigned int     mvcfp:3;
+unsigned int     mvcf:8;
+unsigned int     zmvp:1;
+unsigned int     hdsad:1;
+unsigned int     can:2;
+unsigned int     bk8x8:1;
+unsigned int     bscale:3;
+unsigned int     zmvb:8;
+}ME_MSETA;
+
+typedef struct 
+{
+unsigned int     mvcb:8;
+unsigned int     mvct:8;
+unsigned int     reserved_0:1;
+unsigned int     ryadj:1;
+unsigned int     ry:6;
+unsigned int     reserved_1:1;
+unsigned int     rxadj:1;
+unsigned int     rx:6;
+}ME_MSETB;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_enable3:1;
+unsigned int     sel1:3;
+unsigned int     write_enable2:1;
+unsigned int     sel0:3;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}ME_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}ME_MVM_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     skip_sad:1;
+unsigned int     reserved_1:7;
+unsigned int     len:6;
+unsigned int     reserved_2:1;
+unsigned int     rstfmt:1;
+}ME_MVM_LEN;
+
+#endif
+
+#define ME_CTRL                                                                      0x18009000
+#define ME_CTRL_reg_addr                                                             "0xB8009000"
+#define ME_CTRL_reg                                                                  0xB8009000
+#define ME_CTRL_inst_adr                                                             "0x0000"
+#define ME_CTRL_inst                                                                 0x0000
+#define ME_CTRL_err_shift                                                            (20)
+#define ME_CTRL_err_mask                                                             (0x00100000)
+#define ME_CTRL_err(data)                                                            (0x00100000&((data)<<20))
+#define ME_CTRL_err_src(data)                                                        ((0x00100000&(data))>>20)
+#define ME_CTRL_get_err(data)                                                        ((0x00100000&(data))>>20)
+#define ME_CTRL_qs_shift                                                             (15)
+#define ME_CTRL_qs_mask                                                              (0x00008000)
+#define ME_CTRL_qs(data)                                                             (0x00008000&((data)<<15))
+#define ME_CTRL_qs_src(data)                                                         ((0x00008000&(data))>>15)
+#define ME_CTRL_get_qs(data)                                                         ((0x00008000&(data))>>15)
+#define ME_CTRL_rnd_shift                                                            (14)
+#define ME_CTRL_rnd_mask                                                             (0x00004000)
+#define ME_CTRL_rnd(data)                                                            (0x00004000&((data)<<14))
+#define ME_CTRL_rnd_src(data)                                                        ((0x00004000&(data))>>14)
+#define ME_CTRL_get_rnd(data)                                                        ((0x00004000&(data))>>14)
+#define ME_CTRL_fmt1_shift                                                           (13)
+#define ME_CTRL_fmt1_mask                                                            (0x00002000)
+#define ME_CTRL_fmt1(data)                                                           (0x00002000&((data)<<13))
+#define ME_CTRL_fmt1_src(data)                                                       ((0x00002000&(data))>>13)
+#define ME_CTRL_get_fmt1(data)                                                       ((0x00002000&(data))>>13)
+#define ME_CTRL_fmt0_shift                                                           (12)
+#define ME_CTRL_fmt0_mask                                                            (0x00001000)
+#define ME_CTRL_fmt0(data)                                                           (0x00001000&((data)<<12))
+#define ME_CTRL_fmt0_src(data)                                                       ((0x00001000&(data))>>12)
+#define ME_CTRL_get_fmt0(data)                                                       ((0x00001000&(data))>>12)
+#define ME_CTRL_mbl1_shift                                                           (9)
+#define ME_CTRL_mbl1_mask                                                            (0x00000200)
+#define ME_CTRL_mbl1(data)                                                           (0x00000200&((data)<<9))
+#define ME_CTRL_mbl1_src(data)                                                       ((0x00000200&(data))>>9)
+#define ME_CTRL_get_mbl1(data)                                                       ((0x00000200&(data))>>9)
+#define ME_CTRL_mbl0_shift                                                           (8)
+#define ME_CTRL_mbl0_mask                                                            (0x00000100)
+#define ME_CTRL_mbl0(data)                                                           (0x00000100&((data)<<8))
+#define ME_CTRL_mbl0_src(data)                                                       ((0x00000100&(data))>>8)
+#define ME_CTRL_get_mbl0(data)                                                       ((0x00000100&(data))>>8)
+#define ME_CTRL_ints_shift                                                           (7)
+#define ME_CTRL_ints_mask                                                            (0x00000080)
+#define ME_CTRL_ints(data)                                                           (0x00000080&((data)<<7))
+#define ME_CTRL_ints_src(data)                                                       ((0x00000080&(data))>>7)
+#define ME_CTRL_get_ints(data)                                                       ((0x00000080&(data))>>7)
+#define ME_CTRL_inte_shift                                                           (6)
+#define ME_CTRL_inte_mask                                                            (0x00000040)
+#define ME_CTRL_inte(data)                                                           (0x00000040&((data)<<6))
+#define ME_CTRL_inte_src(data)                                                       ((0x00000040&(data))>>6)
+#define ME_CTRL_get_inte(data)                                                       ((0x00000040&(data))>>6)
+#define ME_CTRL_disable_mp_shift                                                     (5)
+#define ME_CTRL_disable_mp_mask                                                      (0x00000020)
+#define ME_CTRL_disable_mp(data)                                                     (0x00000020&((data)<<5))
+#define ME_CTRL_disable_mp_src(data)                                                 ((0x00000020&(data))>>5)
+#define ME_CTRL_get_disable_mp(data)                                                 ((0x00000020&(data))>>5)
+#define ME_CTRL_tw_shift                                                             (4)
+#define ME_CTRL_tw_mask                                                              (0x00000010)
+#define ME_CTRL_tw(data)                                                             (0x00000010&((data)<<4))
+#define ME_CTRL_tw_src(data)                                                         ((0x00000010&(data))>>4)
+#define ME_CTRL_get_tw(data)                                                         ((0x00000010&(data))>>4)
+#define ME_CTRL_tms_shift                                                            (3)
+#define ME_CTRL_tms_mask                                                             (0x00000008)
+#define ME_CTRL_tms(data)                                                            (0x00000008&((data)<<3))
+#define ME_CTRL_tms_src(data)                                                        ((0x00000008&(data))>>3)
+#define ME_CTRL_get_tms(data)                                                        ((0x00000008&(data))>>3)
+#define ME_CTRL_tbs_shift                                                            (2)
+#define ME_CTRL_tbs_mask                                                             (0x00000004)
+#define ME_CTRL_tbs(data)                                                            (0x00000004&((data)<<2))
+#define ME_CTRL_tbs_src(data)                                                        ((0x00000004&(data))>>2)
+#define ME_CTRL_get_tbs(data)                                                        ((0x00000004&(data))>>2)
+#define ME_CTRL_go_shift                                                             (1)
+#define ME_CTRL_go_mask                                                              (0x00000002)
+#define ME_CTRL_go(data)                                                             (0x00000002&((data)<<1))
+#define ME_CTRL_go_src(data)                                                         ((0x00000002&(data))>>1)
+#define ME_CTRL_get_go(data)                                                         ((0x00000002&(data))>>1)
+#define ME_CTRL_write_data_shift                                                     (0)
+#define ME_CTRL_write_data_mask                                                      (0x00000001)
+#define ME_CTRL_write_data(data)                                                     (0x00000001&((data)<<0))
+#define ME_CTRL_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define ME_CTRL_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define ME_CMDADDR                                                                   0x18009010
+#define ME_CMDADDR_reg_addr                                                          "0xB8009010"
+#define ME_CMDADDR_reg                                                               0xB8009010
+#define ME_CMDADDR_inst_adr                                                          "0x0004"
+#define ME_CMDADDR_inst                                                              0x0004
+#define ME_CMDADDR_addr_shift                                                        (0)
+#define ME_CMDADDR_addr_mask                                                         (0x0FFFFFFF)
+#define ME_CMDADDR_addr(data)                                                        (0x0FFFFFFF&((data)<<0))
+#define ME_CMDADDR_addr_src(data)                                                    ((0x0FFFFFFF&(data))>>0)
+#define ME_CMDADDR_get_addr(data)                                                    ((0x0FFFFFFF&(data))>>0)
+
+
+#define ME_RLTADDR                                                                   0x18009014
+#define ME_RLTADDR_reg_addr                                                          "0xB8009014"
+#define ME_RLTADDR_reg                                                               0xB8009014
+#define ME_RLTADDR_inst_adr                                                          "0x0005"
+#define ME_RLTADDR_inst                                                              0x0005
+#define ME_RLTADDR_addr_shift                                                        (0)
+#define ME_RLTADDR_addr_mask                                                         (0x0FFFFFFF)
+#define ME_RLTADDR_addr(data)                                                        (0x0FFFFFFF&((data)<<0))
+#define ME_RLTADDR_addr_src(data)                                                    ((0x0FFFFFFF&(data))>>0)
+#define ME_RLTADDR_get_addr(data)                                                    ((0x0FFFFFFF&(data))>>0)
+
+
+#define ME_TSETA_0                                                                   0x18009018
+#define ME_TSETA_1                                                                   0x1800901C
+#define ME_TSETA_0_reg_addr                                                          "0xB8009018"
+#define ME_TSETA_1_reg_addr                                                          "0xB800901C"
+#define ME_TSETA_0_reg                                                               0xB8009018
+#define ME_TSETA_1_reg                                                               0xB800901C
+#define ME_TSETA_0_inst_adr                                                          "0x0006"
+#define ME_TSETA_1_inst_adr                                                          "0x0007"
+#define ME_TSETA_0_inst                                                              0x0006
+#define ME_TSETA_1_inst                                                              0x0007
+#define ME_TSETA_fld_shift                                                           (16)
+#define ME_TSETA_fld_mask                                                            (0x00010000)
+#define ME_TSETA_fld(data)                                                           (0x00010000&((data)<<16))
+#define ME_TSETA_fld_src(data)                                                       ((0x00010000&(data))>>16)
+#define ME_TSETA_get_fld(data)                                                       ((0x00010000&(data))>>16)
+#define ME_TSETA_ti_shift                                                            (8)
+#define ME_TSETA_ti_mask                                                             (0x00007F00)
+#define ME_TSETA_ti(data)                                                            (0x00007F00&((data)<<8))
+#define ME_TSETA_ti_src(data)                                                        ((0x00007F00&(data))>>8)
+#define ME_TSETA_get_ti(data)                                                        ((0x00007F00&(data))>>8)
+#define ME_TSETA_bi_shift                                                            (0)
+#define ME_TSETA_bi_mask                                                             (0x0000007F)
+#define ME_TSETA_bi(data)                                                            (0x0000007F&((data)<<0))
+#define ME_TSETA_bi_src(data)                                                        ((0x0000007F&(data))>>0)
+#define ME_TSETA_get_bi(data)                                                        ((0x0000007F&(data))>>0)
+
+
+#define ME_TSETB_0                                                                   0x18009020
+#define ME_TSETB_1                                                                   0x18009024
+#define ME_TSETB_0_reg_addr                                                          "0xB8009020"
+#define ME_TSETB_1_reg_addr                                                          "0xB8009024"
+#define ME_TSETB_0_reg                                                               0xB8009020
+#define ME_TSETB_1_reg                                                               0xB8009024
+#define ME_TSETB_0_inst_adr                                                          "0x0008"
+#define ME_TSETB_1_inst_adr                                                          "0x0009"
+#define ME_TSETB_0_inst                                                              0x0008
+#define ME_TSETB_1_inst                                                              0x0009
+#define ME_TSETB_y_shift                                                             (16)
+#define ME_TSETB_y_mask                                                              (0x07FF0000)
+#define ME_TSETB_y(data)                                                             (0x07FF0000&((data)<<16))
+#define ME_TSETB_y_src(data)                                                         ((0x07FF0000&(data))>>16)
+#define ME_TSETB_get_y(data)                                                         ((0x07FF0000&(data))>>16)
+#define ME_TSETB_xinc_shift                                                          (12)
+#define ME_TSETB_xinc_mask                                                           (0x0000F000)
+#define ME_TSETB_xinc(data)                                                          (0x0000F000&((data)<<12))
+#define ME_TSETB_xinc_src(data)                                                      ((0x0000F000&(data))>>12)
+#define ME_TSETB_get_xinc(data)                                                      ((0x0000F000&(data))>>12)
+#define ME_TSETB_x_shift                                                             (0)
+#define ME_TSETB_x_mask                                                              (0x000007FF)
+#define ME_TSETB_x(data)                                                             (0x000007FF&((data)<<0))
+#define ME_TSETB_x_src(data)                                                         ((0x000007FF&(data))>>0)
+#define ME_TSETB_get_x(data)                                                         ((0x000007FF&(data))>>0)
+
+
+#define ME_RSETA_0                                                                   0x18009028
+#define ME_RSETA_1                                                                   0x1800902C
+#define ME_RSETA_0_reg_addr                                                          "0xB8009028"
+#define ME_RSETA_1_reg_addr                                                          "0xB800902C"
+#define ME_RSETA_0_reg                                                               0xB8009028
+#define ME_RSETA_1_reg                                                               0xB800902C
+#define ME_RSETA_0_inst_adr                                                          "0x000A"
+#define ME_RSETA_1_inst_adr                                                          "0x000B"
+#define ME_RSETA_0_inst                                                              0x000A
+#define ME_RSETA_1_inst                                                              0x000B
+#define ME_RSETA_fld_shift                                                           (16)
+#define ME_RSETA_fld_mask                                                            (0x00010000)
+#define ME_RSETA_fld(data)                                                           (0x00010000&((data)<<16))
+#define ME_RSETA_fld_src(data)                                                       ((0x00010000&(data))>>16)
+#define ME_RSETA_get_fld(data)                                                       ((0x00010000&(data))>>16)
+#define ME_RSETA_ti_shift                                                            (8)
+#define ME_RSETA_ti_mask                                                             (0x00007F00)
+#define ME_RSETA_ti(data)                                                            (0x00007F00&((data)<<8))
+#define ME_RSETA_ti_src(data)                                                        ((0x00007F00&(data))>>8)
+#define ME_RSETA_get_ti(data)                                                        ((0x00007F00&(data))>>8)
+#define ME_RSETA_bi_shift                                                            (0)
+#define ME_RSETA_bi_mask                                                             (0x0000007F)
+#define ME_RSETA_bi(data)                                                            (0x0000007F&((data)<<0))
+#define ME_RSETA_bi_src(data)                                                        ((0x0000007F&(data))>>0)
+#define ME_RSETA_get_bi(data)                                                        ((0x0000007F&(data))>>0)
+
+
+#define ME_RSETB_0                                                                   0x18009030
+#define ME_RSETB_1                                                                   0x18009034
+#define ME_RSETB_0_reg_addr                                                          "0xB8009030"
+#define ME_RSETB_1_reg_addr                                                          "0xB8009034"
+#define ME_RSETB_0_reg                                                               0xB8009030
+#define ME_RSETB_1_reg                                                               0xB8009034
+#define ME_RSETB_0_inst_adr                                                          "0x000C"
+#define ME_RSETB_1_inst_adr                                                          "0x000D"
+#define ME_RSETB_0_inst                                                              0x000C
+#define ME_RSETB_1_inst                                                              0x000D
+#define ME_RSETB_mvys_shift                                                          (30)
+#define ME_RSETB_mvys_mask                                                           (0xC0000000)
+#define ME_RSETB_mvys(data)                                                          (0xC0000000&((data)<<30))
+#define ME_RSETB_mvys_src(data)                                                      ((0xC0000000&(data))>>30)
+#define ME_RSETB_get_mvys(data)                                                      ((0xC0000000&(data))>>30)
+#define ME_RSETB_mvxs_shift                                                          (22)
+#define ME_RSETB_mvxs_mask                                                           (0x00C00000)
+#define ME_RSETB_mvxs(data)                                                          (0x00C00000&((data)<<22))
+#define ME_RSETB_mvxs_src(data)                                                      ((0x00C00000&(data))>>22)
+#define ME_RSETB_get_mvxs(data)                                                      ((0x00C00000&(data))>>22)
+#define ME_RSETB_mvx_shift                                                           (8)
+#define ME_RSETB_mvx_mask                                                            (0x0000FF00)
+#define ME_RSETB_mvx(data)                                                           (0x0000FF00&((data)<<8))
+#define ME_RSETB_mvx_src(data)                                                       ((0x0000FF00&(data))>>8)
+#define ME_RSETB_get_mvx(data)                                                       ((0x0000FF00&(data))>>8)
+#define ME_RSETB_mvy_shift                                                           (0)
+#define ME_RSETB_mvy_mask                                                            (0x000000FF)
+#define ME_RSETB_mvy(data)                                                           (0x000000FF&((data)<<0))
+#define ME_RSETB_mvy_src(data)                                                       ((0x000000FF&(data))>>0)
+#define ME_RSETB_get_mvy(data)                                                       ((0x000000FF&(data))>>0)
+
+
+#define ME_RSETC_0                                                                   0x18009038
+#define ME_RSETC_1                                                                   0x1800903C
+#define ME_RSETC_0_reg_addr                                                          "0xB8009038"
+#define ME_RSETC_1_reg_addr                                                          "0xB800903C"
+#define ME_RSETC_0_reg                                                               0xB8009038
+#define ME_RSETC_1_reg                                                               0xB800903C
+#define ME_RSETC_0_inst_adr                                                          "0x000E"
+#define ME_RSETC_1_inst_adr                                                          "0x000F"
+#define ME_RSETC_0_inst                                                              0x000E
+#define ME_RSETC_1_inst                                                              0x000F
+#define ME_RSETC_y_shift                                                             (16)
+#define ME_RSETC_y_mask                                                              (0x07FF0000)
+#define ME_RSETC_y(data)                                                             (0x07FF0000&((data)<<16))
+#define ME_RSETC_y_src(data)                                                         ((0x07FF0000&(data))>>16)
+#define ME_RSETC_get_y(data)                                                         ((0x07FF0000&(data))>>16)
+#define ME_RSETC_xinc_shift                                                          (12)
+#define ME_RSETC_xinc_mask                                                           (0x0000F000)
+#define ME_RSETC_xinc(data)                                                          (0x0000F000&((data)<<12))
+#define ME_RSETC_xinc_src(data)                                                      ((0x0000F000&(data))>>12)
+#define ME_RSETC_get_xinc(data)                                                      ((0x0000F000&(data))>>12)
+#define ME_RSETC_x_shift                                                             (0)
+#define ME_RSETC_x_mask                                                              (0x000007FF)
+#define ME_RSETC_x(data)                                                             (0x000007FF&((data)<<0))
+#define ME_RSETC_x_src(data)                                                         ((0x000007FF&(data))>>0)
+#define ME_RSETC_get_x(data)                                                         ((0x000007FF&(data))>>0)
+
+
+#define ME_RSETD_0                                                                   0x18009040
+#define ME_RSETD_1                                                                   0x18009044
+#define ME_RSETD_0_reg_addr                                                          "0xB8009040"
+#define ME_RSETD_1_reg_addr                                                          "0xB8009044"
+#define ME_RSETD_0_reg                                                               0xB8009040
+#define ME_RSETD_1_reg                                                               0xB8009044
+#define ME_RSETD_0_inst_adr                                                          "0x0010"
+#define ME_RSETD_1_inst_adr                                                          "0x0011"
+#define ME_RSETD_0_inst                                                              0x0010
+#define ME_RSETD_1_inst                                                              0x0011
+#define ME_RSETD_rh_shift                                                            (16)
+#define ME_RSETD_rh_mask                                                             (0x07FF0000)
+#define ME_RSETD_rh(data)                                                            (0x07FF0000&((data)<<16))
+#define ME_RSETD_rh_src(data)                                                        ((0x07FF0000&(data))>>16)
+#define ME_RSETD_get_rh(data)                                                        ((0x07FF0000&(data))>>16)
+#define ME_RSETD_rw_shift                                                            (0)
+#define ME_RSETD_rw_mask                                                             (0x000007FF)
+#define ME_RSETD_rw(data)                                                            (0x000007FF&((data)<<0))
+#define ME_RSETD_rw_src(data)                                                        ((0x000007FF&(data))>>0)
+#define ME_RSETD_get_rw(data)                                                        ((0x000007FF&(data))>>0)
+
+
+#define ME_RSETE_0                                                                   0x18009048
+#define ME_RSETE_1                                                                   0x1800904C
+#define ME_RSETE_0_reg_addr                                                          "0xB8009048"
+#define ME_RSETE_1_reg_addr                                                          "0xB800904C"
+#define ME_RSETE_0_reg                                                               0xB8009048
+#define ME_RSETE_1_reg                                                               0xB800904C
+#define ME_RSETE_0_inst_adr                                                          "0x0012"
+#define ME_RSETE_1_inst_adr                                                          "0x0013"
+#define ME_RSETE_0_inst                                                              0x0012
+#define ME_RSETE_1_inst                                                              0x0013
+#define ME_RSETE_tsy_shift                                                           (16)
+#define ME_RSETE_tsy_mask                                                            (0x07FF0000)
+#define ME_RSETE_tsy(data)                                                           (0x07FF0000&((data)<<16))
+#define ME_RSETE_tsy_src(data)                                                       ((0x07FF0000&(data))>>16)
+#define ME_RSETE_get_tsy(data)                                                       ((0x07FF0000&(data))>>16)
+#define ME_RSETE_tsx_shift                                                           (0)
+#define ME_RSETE_tsx_mask                                                            (0x000007FF)
+#define ME_RSETE_tsx(data)                                                           (0x000007FF&((data)<<0))
+#define ME_RSETE_tsx_src(data)                                                       ((0x000007FF&(data))>>0)
+#define ME_RSETE_get_tsx(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define ME_RSETF_0                                                                   0x18009050
+#define ME_RSETF_1                                                                   0x18009054
+#define ME_RSETF_0_reg_addr                                                          "0xB8009050"
+#define ME_RSETF_1_reg_addr                                                          "0xB8009054"
+#define ME_RSETF_0_reg                                                               0xB8009050
+#define ME_RSETF_1_reg                                                               0xB8009054
+#define ME_RSETF_0_inst_adr                                                          "0x0014"
+#define ME_RSETF_1_inst_adr                                                          "0x0015"
+#define ME_RSETF_0_inst                                                              0x0014
+#define ME_RSETF_1_inst                                                              0x0015
+#define ME_RSETF_tey_shift                                                           (16)
+#define ME_RSETF_tey_mask                                                            (0x07FF0000)
+#define ME_RSETF_tey(data)                                                           (0x07FF0000&((data)<<16))
+#define ME_RSETF_tey_src(data)                                                       ((0x07FF0000&(data))>>16)
+#define ME_RSETF_get_tey(data)                                                       ((0x07FF0000&(data))>>16)
+#define ME_RSETF_tex_shift                                                           (0)
+#define ME_RSETF_tex_mask                                                            (0x000007FF)
+#define ME_RSETF_tex(data)                                                           (0x000007FF&((data)<<0))
+#define ME_RSETF_tex_src(data)                                                       ((0x000007FF&(data))>>0)
+#define ME_RSETF_get_tex(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define ME_RSETG_0                                                                   0x18009058
+#define ME_RSETG_1                                                                   0x1800905C
+#define ME_RSETG_0_reg_addr                                                          "0xB8009058"
+#define ME_RSETG_1_reg_addr                                                          "0xB800905C"
+#define ME_RSETG_0_reg                                                               0xB8009058
+#define ME_RSETG_1_reg                                                               0xB800905C
+#define ME_RSETG_0_inst_adr                                                          "0x0016"
+#define ME_RSETG_1_inst_adr                                                          "0x0017"
+#define ME_RSETG_0_inst                                                              0x0016
+#define ME_RSETG_1_inst                                                              0x0017
+#define ME_RSETG_bsy_shift                                                           (16)
+#define ME_RSETG_bsy_mask                                                            (0x07FF0000)
+#define ME_RSETG_bsy(data)                                                           (0x07FF0000&((data)<<16))
+#define ME_RSETG_bsy_src(data)                                                       ((0x07FF0000&(data))>>16)
+#define ME_RSETG_get_bsy(data)                                                       ((0x07FF0000&(data))>>16)
+#define ME_RSETG_bsx_shift                                                           (0)
+#define ME_RSETG_bsx_mask                                                            (0x000007FF)
+#define ME_RSETG_bsx(data)                                                           (0x000007FF&((data)<<0))
+#define ME_RSETG_bsx_src(data)                                                       ((0x000007FF&(data))>>0)
+#define ME_RSETG_get_bsx(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define ME_RSETH_0                                                                   0x18009060
+#define ME_RSETH_1                                                                   0x18009064
+#define ME_RSETH_0_reg_addr                                                          "0xB8009060"
+#define ME_RSETH_1_reg_addr                                                          "0xB8009064"
+#define ME_RSETH_0_reg                                                               0xB8009060
+#define ME_RSETH_1_reg                                                               0xB8009064
+#define ME_RSETH_0_inst_adr                                                          "0x0018"
+#define ME_RSETH_1_inst_adr                                                          "0x0019"
+#define ME_RSETH_0_inst                                                              0x0018
+#define ME_RSETH_1_inst                                                              0x0019
+#define ME_RSETH_bey_shift                                                           (16)
+#define ME_RSETH_bey_mask                                                            (0x07FF0000)
+#define ME_RSETH_bey(data)                                                           (0x07FF0000&((data)<<16))
+#define ME_RSETH_bey_src(data)                                                       ((0x07FF0000&(data))>>16)
+#define ME_RSETH_get_bey(data)                                                       ((0x07FF0000&(data))>>16)
+#define ME_RSETH_bex_shift                                                           (0)
+#define ME_RSETH_bex_mask                                                            (0x000007FF)
+#define ME_RSETH_bex(data)                                                           (0x000007FF&((data)<<0))
+#define ME_RSETH_bex_src(data)                                                       ((0x000007FF&(data))>>0)
+#define ME_RSETH_get_bex(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define ME_MSETA_0                                                                   0x18009068
+#define ME_MSETA_1                                                                   0x1800906C
+#define ME_MSETA_2                                                                   0x18009070
+#define ME_MSETA_3                                                                   0x18009074
+#define ME_MSETA_0_reg_addr                                                          "0xB8009068"
+#define ME_MSETA_1_reg_addr                                                          "0xB800906C"
+#define ME_MSETA_2_reg_addr                                                          "0xB8009070"
+#define ME_MSETA_3_reg_addr                                                          "0xB8009074"
+#define ME_MSETA_0_reg                                                               0xB8009068
+#define ME_MSETA_1_reg                                                               0xB800906C
+#define ME_MSETA_2_reg                                                               0xB8009070
+#define ME_MSETA_3_reg                                                               0xB8009074
+#define ME_MSETA_0_inst_adr                                                          "0x001A"
+#define ME_MSETA_1_inst_adr                                                          "0x001B"
+#define ME_MSETA_2_inst_adr                                                          "0x001C"
+#define ME_MSETA_3_inst_adr                                                          "0x001D"
+#define ME_MSETA_0_inst                                                              0x001A
+#define ME_MSETA_1_inst                                                              0x001B
+#define ME_MSETA_2_inst                                                              0x001C
+#define ME_MSETA_3_inst                                                              0x001D
+#define ME_MSETA_stage_shift                                                         (31)
+#define ME_MSETA_stage_mask                                                          (0x80000000)
+#define ME_MSETA_stage(data)                                                         (0x80000000&((data)<<31))
+#define ME_MSETA_stage_src(data)                                                     ((0x80000000&(data))>>31)
+#define ME_MSETA_get_stage(data)                                                     ((0x80000000&(data))>>31)
+#define ME_MSETA_half_shift                                                          (29)
+#define ME_MSETA_half_mask                                                           (0x60000000)
+#define ME_MSETA_half(data)                                                          (0x60000000&((data)<<29))
+#define ME_MSETA_half_src(data)                                                      ((0x60000000&(data))>>29)
+#define ME_MSETA_get_half(data)                                                      ((0x60000000&(data))>>29)
+#define ME_MSETA_mvce_shift                                                          (28)
+#define ME_MSETA_mvce_mask                                                           (0x10000000)
+#define ME_MSETA_mvce(data)                                                          (0x10000000&((data)<<28))
+#define ME_MSETA_mvce_src(data)                                                      ((0x10000000&(data))>>28)
+#define ME_MSETA_get_mvce(data)                                                      ((0x10000000&(data))>>28)
+#define ME_MSETA_hdrlt_shift                                                         (27)
+#define ME_MSETA_hdrlt_mask                                                          (0x08000000)
+#define ME_MSETA_hdrlt(data)                                                         (0x08000000&((data)<<27))
+#define ME_MSETA_hdrlt_src(data)                                                     ((0x08000000&(data))>>27)
+#define ME_MSETA_get_hdrlt(data)                                                     ((0x08000000&(data))>>27)
+#define ME_MSETA_mvcfp_shift                                                         (24)
+#define ME_MSETA_mvcfp_mask                                                          (0x07000000)
+#define ME_MSETA_mvcfp(data)                                                         (0x07000000&((data)<<24))
+#define ME_MSETA_mvcfp_src(data)                                                     ((0x07000000&(data))>>24)
+#define ME_MSETA_get_mvcfp(data)                                                     ((0x07000000&(data))>>24)
+#define ME_MSETA_mvcf_shift                                                          (16)
+#define ME_MSETA_mvcf_mask                                                           (0x00FF0000)
+#define ME_MSETA_mvcf(data)                                                          (0x00FF0000&((data)<<16))
+#define ME_MSETA_mvcf_src(data)                                                      ((0x00FF0000&(data))>>16)
+#define ME_MSETA_get_mvcf(data)                                                      ((0x00FF0000&(data))>>16)
+#define ME_MSETA_zmvp_shift                                                          (15)
+#define ME_MSETA_zmvp_mask                                                           (0x00008000)
+#define ME_MSETA_zmvp(data)                                                          (0x00008000&((data)<<15))
+#define ME_MSETA_zmvp_src(data)                                                      ((0x00008000&(data))>>15)
+#define ME_MSETA_get_zmvp(data)                                                      ((0x00008000&(data))>>15)
+#define ME_MSETA_hdsad_shift                                                         (14)
+#define ME_MSETA_hdsad_mask                                                          (0x00004000)
+#define ME_MSETA_hdsad(data)                                                         (0x00004000&((data)<<14))
+#define ME_MSETA_hdsad_src(data)                                                     ((0x00004000&(data))>>14)
+#define ME_MSETA_get_hdsad(data)                                                     ((0x00004000&(data))>>14)
+#define ME_MSETA_can_shift                                                           (12)
+#define ME_MSETA_can_mask                                                            (0x00003000)
+#define ME_MSETA_can(data)                                                           (0x00003000&((data)<<12))
+#define ME_MSETA_can_src(data)                                                       ((0x00003000&(data))>>12)
+#define ME_MSETA_get_can(data)                                                       ((0x00003000&(data))>>12)
+#define ME_MSETA_bk8x8_shift                                                         (11)
+#define ME_MSETA_bk8x8_mask                                                          (0x00000800)
+#define ME_MSETA_bk8x8(data)                                                         (0x00000800&((data)<<11))
+#define ME_MSETA_bk8x8_src(data)                                                     ((0x00000800&(data))>>11)
+#define ME_MSETA_get_bk8x8(data)                                                     ((0x00000800&(data))>>11)
+#define ME_MSETA_bscale_shift                                                        (8)
+#define ME_MSETA_bscale_mask                                                         (0x00000700)
+#define ME_MSETA_bscale(data)                                                        (0x00000700&((data)<<8))
+#define ME_MSETA_bscale_src(data)                                                    ((0x00000700&(data))>>8)
+#define ME_MSETA_get_bscale(data)                                                    ((0x00000700&(data))>>8)
+#define ME_MSETA_zmvb_shift                                                          (0)
+#define ME_MSETA_zmvb_mask                                                           (0x000000FF)
+#define ME_MSETA_zmvb(data)                                                          (0x000000FF&((data)<<0))
+#define ME_MSETA_zmvb_src(data)                                                      ((0x000000FF&(data))>>0)
+#define ME_MSETA_get_zmvb(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define ME_MSETB_0                                                                   0x18009078
+#define ME_MSETB_1                                                                   0x1800907C
+#define ME_MSETB_2                                                                   0x18009080
+#define ME_MSETB_3                                                                   0x18009084
+#define ME_MSETB_0_reg_addr                                                          "0xB8009078"
+#define ME_MSETB_1_reg_addr                                                          "0xB800907C"
+#define ME_MSETB_2_reg_addr                                                          "0xB8009080"
+#define ME_MSETB_3_reg_addr                                                          "0xB8009084"
+#define ME_MSETB_0_reg                                                               0xB8009078
+#define ME_MSETB_1_reg                                                               0xB800907C
+#define ME_MSETB_2_reg                                                               0xB8009080
+#define ME_MSETB_3_reg                                                               0xB8009084
+#define ME_MSETB_0_inst_adr                                                          "0x001E"
+#define ME_MSETB_1_inst_adr                                                          "0x001F"
+#define ME_MSETB_2_inst_adr                                                          "0x0020"
+#define ME_MSETB_3_inst_adr                                                          "0x0021"
+#define ME_MSETB_0_inst                                                              0x001E
+#define ME_MSETB_1_inst                                                              0x001F
+#define ME_MSETB_2_inst                                                              0x0020
+#define ME_MSETB_3_inst                                                              0x0021
+#define ME_MSETB_mvcb_shift                                                          (24)
+#define ME_MSETB_mvcb_mask                                                           (0xFF000000)
+#define ME_MSETB_mvcb(data)                                                          (0xFF000000&((data)<<24))
+#define ME_MSETB_mvcb_src(data)                                                      ((0xFF000000&(data))>>24)
+#define ME_MSETB_get_mvcb(data)                                                      ((0xFF000000&(data))>>24)
+#define ME_MSETB_mvct_shift                                                          (16)
+#define ME_MSETB_mvct_mask                                                           (0x00FF0000)
+#define ME_MSETB_mvct(data)                                                          (0x00FF0000&((data)<<16))
+#define ME_MSETB_mvct_src(data)                                                      ((0x00FF0000&(data))>>16)
+#define ME_MSETB_get_mvct(data)                                                      ((0x00FF0000&(data))>>16)
+#define ME_MSETB_ryadj_shift                                                         (14)
+#define ME_MSETB_ryadj_mask                                                          (0x00004000)
+#define ME_MSETB_ryadj(data)                                                         (0x00004000&((data)<<14))
+#define ME_MSETB_ryadj_src(data)                                                     ((0x00004000&(data))>>14)
+#define ME_MSETB_get_ryadj(data)                                                     ((0x00004000&(data))>>14)
+#define ME_MSETB_ry_shift                                                            (8)
+#define ME_MSETB_ry_mask                                                             (0x00003F00)
+#define ME_MSETB_ry(data)                                                            (0x00003F00&((data)<<8))
+#define ME_MSETB_ry_src(data)                                                        ((0x00003F00&(data))>>8)
+#define ME_MSETB_get_ry(data)                                                        ((0x00003F00&(data))>>8)
+#define ME_MSETB_rxadj_shift                                                         (6)
+#define ME_MSETB_rxadj_mask                                                          (0x00000040)
+#define ME_MSETB_rxadj(data)                                                         (0x00000040&((data)<<6))
+#define ME_MSETB_rxadj_src(data)                                                     ((0x00000040&(data))>>6)
+#define ME_MSETB_get_rxadj(data)                                                     ((0x00000040&(data))>>6)
+#define ME_MSETB_rx_shift                                                            (0)
+#define ME_MSETB_rx_mask                                                             (0x0000003F)
+#define ME_MSETB_rx(data)                                                            (0x0000003F&((data)<<0))
+#define ME_MSETB_rx_src(data)                                                        ((0x0000003F&(data))>>0)
+#define ME_MSETB_get_rx(data)                                                        ((0x0000003F&(data))>>0)
+
+
+#define ME_DBG                                                                       0x18009088
+#define ME_DBG_reg_addr                                                              "0xB8009088"
+#define ME_DBG_reg                                                                   0xB8009088
+#define ME_DBG_inst_adr                                                              "0x0022"
+#define ME_DBG_inst                                                                  0x0022
+#define ME_DBG_write_enable3_shift                                                   (9)
+#define ME_DBG_write_enable3_mask                                                    (0x00000200)
+#define ME_DBG_write_enable3(data)                                                   (0x00000200&((data)<<9))
+#define ME_DBG_write_enable3_src(data)                                               ((0x00000200&(data))>>9)
+#define ME_DBG_get_write_enable3(data)                                               ((0x00000200&(data))>>9)
+#define ME_DBG_sel1_shift                                                            (6)
+#define ME_DBG_sel1_mask                                                             (0x000001C0)
+#define ME_DBG_sel1(data)                                                            (0x000001C0&((data)<<6))
+#define ME_DBG_sel1_src(data)                                                        ((0x000001C0&(data))>>6)
+#define ME_DBG_get_sel1(data)                                                        ((0x000001C0&(data))>>6)
+#define ME_DBG_write_enable2_shift                                                   (5)
+#define ME_DBG_write_enable2_mask                                                    (0x00000020)
+#define ME_DBG_write_enable2(data)                                                   (0x00000020&((data)<<5))
+#define ME_DBG_write_enable2_src(data)                                               ((0x00000020&(data))>>5)
+#define ME_DBG_get_write_enable2(data)                                               ((0x00000020&(data))>>5)
+#define ME_DBG_sel0_shift                                                            (2)
+#define ME_DBG_sel0_mask                                                             (0x0000001C)
+#define ME_DBG_sel0(data)                                                            (0x0000001C&((data)<<2))
+#define ME_DBG_sel0_src(data)                                                        ((0x0000001C&(data))>>2)
+#define ME_DBG_get_sel0(data)                                                        ((0x0000001C&(data))>>2)
+#define ME_DBG_write_enable1_shift                                                   (1)
+#define ME_DBG_write_enable1_mask                                                    (0x00000002)
+#define ME_DBG_write_enable1(data)                                                   (0x00000002&((data)<<1))
+#define ME_DBG_write_enable1_src(data)                                               ((0x00000002&(data))>>1)
+#define ME_DBG_get_write_enable1(data)                                               ((0x00000002&(data))>>1)
+#define ME_DBG_enable_shift                                                          (0)
+#define ME_DBG_enable_mask                                                           (0x00000001)
+#define ME_DBG_enable(data)                                                          (0x00000001&((data)<<0))
+#define ME_DBG_enable_src(data)                                                      ((0x00000001&(data))>>0)
+#define ME_DBG_get_enable(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define ME_MVM_BASE_0                                                                0x1800908C
+#define ME_MVM_BASE_1                                                                0x18009090
+#define ME_MVM_BASE_0_reg_addr                                                       "0xB800908C"
+#define ME_MVM_BASE_1_reg_addr                                                       "0xB8009090"
+#define ME_MVM_BASE_0_reg                                                            0xB800908C
+#define ME_MVM_BASE_1_reg                                                            0xB8009090
+#define ME_MVM_BASE_0_inst_adr                                                       "0x0023"
+#define ME_MVM_BASE_1_inst_adr                                                       "0x0024"
+#define ME_MVM_BASE_0_inst                                                           0x0023
+#define ME_MVM_BASE_1_inst                                                           0x0024
+#define ME_MVM_BASE_addr_shift                                                       (0)
+#define ME_MVM_BASE_addr_mask                                                        (0x0FFFFFFF)
+#define ME_MVM_BASE_addr(data)                                                       (0x0FFFFFFF&((data)<<0))
+#define ME_MVM_BASE_addr_src(data)                                                   ((0x0FFFFFFF&(data))>>0)
+#define ME_MVM_BASE_get_addr(data)                                                   ((0x0FFFFFFF&(data))>>0)
+
+
+#define ME_MVM_LEN_0                                                                 0x18009094
+#define ME_MVM_LEN_1                                                                 0x18009098
+#define ME_MVM_LEN_0_reg_addr                                                        "0xB8009094"
+#define ME_MVM_LEN_1_reg_addr                                                        "0xB8009098"
+#define ME_MVM_LEN_0_reg                                                             0xB8009094
+#define ME_MVM_LEN_1_reg                                                             0xB8009098
+#define ME_MVM_LEN_0_inst_adr                                                        "0x0025"
+#define ME_MVM_LEN_1_inst_adr                                                        "0x0026"
+#define ME_MVM_LEN_0_inst                                                            0x0025
+#define ME_MVM_LEN_1_inst                                                            0x0026
+#define ME_MVM_LEN_skip_sad_shift                                                    (15)
+#define ME_MVM_LEN_skip_sad_mask                                                     (0x00008000)
+#define ME_MVM_LEN_skip_sad(data)                                                    (0x00008000&((data)<<15))
+#define ME_MVM_LEN_skip_sad_src(data)                                                ((0x00008000&(data))>>15)
+#define ME_MVM_LEN_get_skip_sad(data)                                                ((0x00008000&(data))>>15)
+#define ME_MVM_LEN_len_shift                                                         (2)
+#define ME_MVM_LEN_len_mask                                                          (0x000000FC)
+#define ME_MVM_LEN_len(data)                                                         (0x000000FC&((data)<<2))
+#define ME_MVM_LEN_len_src(data)                                                     ((0x000000FC&(data))>>2)
+#define ME_MVM_LEN_get_len(data)                                                     ((0x000000FC&(data))>>2)
+#define ME_MVM_LEN_rstfmt_shift                                                      (0)
+#define ME_MVM_LEN_rstfmt_mask                                                       (0x00000001)
+#define ME_MVM_LEN_rstfmt(data)                                                      (0x00000001&((data)<<0))
+#define ME_MVM_LEN_rstfmt_src(data)                                                  ((0x00000001&(data))>>0)
+#define ME_MVM_LEN_get_rstfmt(data)                                                  ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/mercury.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mercury.h
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/mipi_aphy_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mipi_aphy_reg.h
new file mode 100644
index 00000000..7275966
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mipi_aphy_reg.h
@@ -0,0 +1,744 @@
+/**************************************************************
+// Spec Version                  : unknown
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/4/18 19:15:34
+***************************************************************/
+
+
+#ifndef _MIPI_APHY_REG_H_INCLUDED_
+#define _MIPI_APHY_REG_H_INCLUDED_
+#ifdef  _MIPI_APHY_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     R50_CAL_RG:6;
+}MIPI_APHY_REG0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     EN_SKW:1;
+unsigned int     EN_AUTO_SKW:1;
+unsigned int     PAUSEB_SKW_CAL:1;
+unsigned int     EN_AUTO_STPB_SKW_CAL_RG:1;
+unsigned int     EN_OSK:1;
+unsigned int     EN_AUTO_OSK:1;
+unsigned int     EN_R50_CAL_RG:1;
+unsigned int     EN_R50_AUTO_CAL_RG:1;
+}MIPI_APHY_REG1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     SEL0_PAUSED_SKW_K_RG:1;
+unsigned int     LGTH_D0:3;
+unsigned int     PDBH_k:1;
+unsigned int     PWDB_OSK:1;
+unsigned int     DOUBL_PUMP:1;
+unsigned int     ENSEL:1;
+}MIPI_APHY_REG2;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     HSPAMP0_RL_RG:6;
+}MIPI_APHY_REG3;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     HSPAMP1_RL_RG:6;
+}MIPI_APHY_REG4;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     SDATA0_SKW_RG:4;
+unsigned int     SDATA1_SKW_RG:4;
+}MIPI_APHY_REG5;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     SDATA2_SKW_RG:4;
+unsigned int     SDATA3_SKW_RG:4;
+}MIPI_APHY_REG6;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     SCLK0_SKW_RG:4;
+unsigned int     SCLK1_SKW_RG:4;
+}MIPI_APHY_REG7;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     SCLK2_SKW_RG:4;
+unsigned int     SCLK3_SKW_RG:4;
+}MIPI_APHY_REG8;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     HSAMPCK_RL_RG:6;
+}MIPI_APHY_REG9;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     COUNT_RUN:8;
+}MIPI_APHY_REG10;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     COUNT_RUN:1;
+}MIPI_APHY_REG11;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     COUNT_RT:7;
+}MIPI_APHY_REG12;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     HS_CM:3;
+unsigned int     COUNT_SEL:5;
+}MIPI_APHY_REG13;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     CMP_REF:4;
+unsigned int     LPAMP_REF:4;
+}MIPI_APHY_REG14;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     adrst_sel:2;
+unsigned int     SEL_DIV_RG:2;
+}MIPI_APHY_REG15;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     HSAMP3_RL_2RG:6;
+}MIPI_APHY_REG16;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     HSAMP2_RL_2RG:6;
+}MIPI_APHY_REG17;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     HSAMP1_RL_2RG:6;
+}MIPI_APHY_REG18;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     HSAMP0_RL_2RG:6;
+}MIPI_APHY_REG19;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     HSAMPCK_RL_2RG:6;
+}MIPI_APHY_REG20;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     CLK0_DLY_CODE_2RG:4;
+unsigned int     CLK1_DLY_CODE_2RG:4;
+}MIPI_APHY_REG21;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     CLK2_DLY_CODE_2RG:4;
+unsigned int     CLK3_DLY_CODE_2RG:4;
+}MIPI_APHY_REG22;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     DATA0_DLY_CODE_2RG:4;
+unsigned int     DATA1_DLY_CODE_2RG:4;
+}MIPI_APHY_REG23;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     DATA2_DLY_CODE_2RG:4;
+unsigned int     DATA3_DLY_CODE_2RG:4;
+}MIPI_APHY_REG24;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     R50_CAL_OK_2RG:1;
+unsigned int     reserved_1:1;
+unsigned int     R50_CAL_2RG:6;
+}MIPI_APHY_REG25;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     LANE_OK:4;
+}MIPI_APHY_REG26;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     HSPAMP2_RL_RG:6;
+}MIPI_APHY_REG27;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     HSPAMP3_RL_RG:6;
+}MIPI_APHY_REG28;
+
+#endif
+
+#define MIPI_APHY_REG0                                                               0x18004000
+#define MIPI_APHY_REG0_reg_addr                                                      "0xB8004000"
+#define MIPI_APHY_REG0_reg                                                           0xB8004000
+#define set_MIPI_APHY_REG0_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG0_reg)=data)
+#define get_MIPI_APHY_REG0_reg   (*((volatile unsigned int*) MIPI_APHY_REG0_reg))
+#define MIPI_APHY_REG0_inst_adr                                                      "0x0000"
+#define MIPI_APHY_REG0_inst                                                          0x0000
+#define MIPI_APHY_REG0_R50_CAL_RG_shift                                              (0)
+#define MIPI_APHY_REG0_R50_CAL_RG_mask                                               (0x0000003F)
+#define MIPI_APHY_REG0_R50_CAL_RG(data)                                              (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG0_R50_CAL_RG_src(data)                                          ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG0_get_R50_CAL_RG(data)                                          ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG1                                                               0x18004004
+#define MIPI_APHY_REG1_reg_addr                                                      "0xB8004004"
+#define MIPI_APHY_REG1_reg                                                           0xB8004004
+#define set_MIPI_APHY_REG1_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG1_reg)=data)
+#define get_MIPI_APHY_REG1_reg   (*((volatile unsigned int*) MIPI_APHY_REG1_reg))
+#define MIPI_APHY_REG1_inst_adr                                                      "0x0001"
+#define MIPI_APHY_REG1_inst                                                          0x0001
+#define MIPI_APHY_REG1_EN_SKW_shift                                                  (7)
+#define MIPI_APHY_REG1_EN_SKW_mask                                                   (0x00000080)
+#define MIPI_APHY_REG1_EN_SKW(data)                                                  (0x00000080&((data)<<7))
+#define MIPI_APHY_REG1_EN_SKW_src(data)                                              ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG1_get_EN_SKW(data)                                              ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG1_EN_AUTO_SKW_shift                                             (6)
+#define MIPI_APHY_REG1_EN_AUTO_SKW_mask                                              (0x00000040)
+#define MIPI_APHY_REG1_EN_AUTO_SKW(data)                                             (0x00000040&((data)<<6))
+#define MIPI_APHY_REG1_EN_AUTO_SKW_src(data)                                         ((0x00000040&(data))>>6)
+#define MIPI_APHY_REG1_get_EN_AUTO_SKW(data)                                         ((0x00000040&(data))>>6)
+#define MIPI_APHY_REG1_PAUSEB_SKW_CAL_shift                                          (5)
+#define MIPI_APHY_REG1_PAUSEB_SKW_CAL_mask                                           (0x00000020)
+#define MIPI_APHY_REG1_PAUSEB_SKW_CAL(data)                                          (0x00000020&((data)<<5))
+#define MIPI_APHY_REG1_PAUSEB_SKW_CAL_src(data)                                      ((0x00000020&(data))>>5)
+#define MIPI_APHY_REG1_get_PAUSEB_SKW_CAL(data)                                      ((0x00000020&(data))>>5)
+#define MIPI_APHY_REG1_EN_AUTO_STPB_SKW_CAL_RG_shift                                 (4)
+#define MIPI_APHY_REG1_EN_AUTO_STPB_SKW_CAL_RG_mask                                  (0x00000010)
+#define MIPI_APHY_REG1_EN_AUTO_STPB_SKW_CAL_RG(data)                                 (0x00000010&((data)<<4))
+#define MIPI_APHY_REG1_EN_AUTO_STPB_SKW_CAL_RG_src(data)                             ((0x00000010&(data))>>4)
+#define MIPI_APHY_REG1_get_EN_AUTO_STPB_SKW_CAL_RG(data)                             ((0x00000010&(data))>>4)
+#define MIPI_APHY_REG1_EN_OSK_shift                                                  (3)
+#define MIPI_APHY_REG1_EN_OSK_mask                                                   (0x00000008)
+#define MIPI_APHY_REG1_EN_OSK(data)                                                  (0x00000008&((data)<<3))
+#define MIPI_APHY_REG1_EN_OSK_src(data)                                              ((0x00000008&(data))>>3)
+#define MIPI_APHY_REG1_get_EN_OSK(data)                                              ((0x00000008&(data))>>3)
+#define MIPI_APHY_REG1_EN_AUTO_OSK_shift                                             (2)
+#define MIPI_APHY_REG1_EN_AUTO_OSK_mask                                              (0x00000004)
+#define MIPI_APHY_REG1_EN_AUTO_OSK(data)                                             (0x00000004&((data)<<2))
+#define MIPI_APHY_REG1_EN_AUTO_OSK_src(data)                                         ((0x00000004&(data))>>2)
+#define MIPI_APHY_REG1_get_EN_AUTO_OSK(data)                                         ((0x00000004&(data))>>2)
+#define MIPI_APHY_REG1_EN_R50_CAL_RG_shift                                           (1)
+#define MIPI_APHY_REG1_EN_R50_CAL_RG_mask                                            (0x00000002)
+#define MIPI_APHY_REG1_EN_R50_CAL_RG(data)                                           (0x00000002&((data)<<1))
+#define MIPI_APHY_REG1_EN_R50_CAL_RG_src(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_APHY_REG1_get_EN_R50_CAL_RG(data)                                       ((0x00000002&(data))>>1)
+#define MIPI_APHY_REG1_EN_R50_AUTO_CAL_RG_shift                                      (0)
+#define MIPI_APHY_REG1_EN_R50_AUTO_CAL_RG_mask                                       (0x00000001)
+#define MIPI_APHY_REG1_EN_R50_AUTO_CAL_RG(data)                                      (0x00000001&((data)<<0))
+#define MIPI_APHY_REG1_EN_R50_AUTO_CAL_RG_src(data)                                  ((0x00000001&(data))>>0)
+#define MIPI_APHY_REG1_get_EN_R50_AUTO_CAL_RG(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIPI_APHY_REG2                                                               0x18004008
+#define MIPI_APHY_REG2_reg_addr                                                      "0xB8004008"
+#define MIPI_APHY_REG2_reg                                                           0xB8004008
+#define set_MIPI_APHY_REG2_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG2_reg)=data)
+#define get_MIPI_APHY_REG2_reg   (*((volatile unsigned int*) MIPI_APHY_REG2_reg))
+#define MIPI_APHY_REG2_inst_adr                                                      "0x0002"
+#define MIPI_APHY_REG2_inst                                                          0x0002
+#define MIPI_APHY_REG2_SEL0_PAUSED_SKW_K_RG_shift                                    (7)
+#define MIPI_APHY_REG2_SEL0_PAUSED_SKW_K_RG_mask                                     (0x00000080)
+#define MIPI_APHY_REG2_SEL0_PAUSED_SKW_K_RG(data)                                    (0x00000080&((data)<<7))
+#define MIPI_APHY_REG2_SEL0_PAUSED_SKW_K_RG_src(data)                                ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG2_get_SEL0_PAUSED_SKW_K_RG(data)                                ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG2_LGTH_D0_shift                                                 (4)
+#define MIPI_APHY_REG2_LGTH_D0_mask                                                  (0x00000070)
+#define MIPI_APHY_REG2_LGTH_D0(data)                                                 (0x00000070&((data)<<4))
+#define MIPI_APHY_REG2_LGTH_D0_src(data)                                             ((0x00000070&(data))>>4)
+#define MIPI_APHY_REG2_get_LGTH_D0(data)                                             ((0x00000070&(data))>>4)
+#define MIPI_APHY_REG2_PDBH_k_shift                                                  (3)
+#define MIPI_APHY_REG2_PDBH_k_mask                                                   (0x00000008)
+#define MIPI_APHY_REG2_PDBH_k(data)                                                  (0x00000008&((data)<<3))
+#define MIPI_APHY_REG2_PDBH_k_src(data)                                              ((0x00000008&(data))>>3)
+#define MIPI_APHY_REG2_get_PDBH_k(data)                                              ((0x00000008&(data))>>3)
+#define MIPI_APHY_REG2_PWDB_OSK_shift                                                (2)
+#define MIPI_APHY_REG2_PWDB_OSK_mask                                                 (0x00000004)
+#define MIPI_APHY_REG2_PWDB_OSK(data)                                                (0x00000004&((data)<<2))
+#define MIPI_APHY_REG2_PWDB_OSK_src(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_APHY_REG2_get_PWDB_OSK(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_APHY_REG2_DOUBL_PUMP_shift                                              (1)
+#define MIPI_APHY_REG2_DOUBL_PUMP_mask                                               (0x00000002)
+#define MIPI_APHY_REG2_DOUBL_PUMP(data)                                              (0x00000002&((data)<<1))
+#define MIPI_APHY_REG2_DOUBL_PUMP_src(data)                                          ((0x00000002&(data))>>1)
+#define MIPI_APHY_REG2_get_DOUBL_PUMP(data)                                          ((0x00000002&(data))>>1)
+#define MIPI_APHY_REG2_ENSEL_shift                                                   (0)
+#define MIPI_APHY_REG2_ENSEL_mask                                                    (0x00000001)
+#define MIPI_APHY_REG2_ENSEL(data)                                                   (0x00000001&((data)<<0))
+#define MIPI_APHY_REG2_ENSEL_src(data)                                               ((0x00000001&(data))>>0)
+#define MIPI_APHY_REG2_get_ENSEL(data)                                               ((0x00000001&(data))>>0)
+
+
+#define MIPI_APHY_REG3                                                               0x1800400C
+#define MIPI_APHY_REG3_reg_addr                                                      "0xB800400C"
+#define MIPI_APHY_REG3_reg                                                           0xB800400C
+#define set_MIPI_APHY_REG3_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG3_reg)=data)
+#define get_MIPI_APHY_REG3_reg   (*((volatile unsigned int*) MIPI_APHY_REG3_reg))
+#define MIPI_APHY_REG3_inst_adr                                                      "0x0003"
+#define MIPI_APHY_REG3_inst                                                          0x0003
+#define MIPI_APHY_REG3_HSPAMP0_RL_RG_shift                                           (0)
+#define MIPI_APHY_REG3_HSPAMP0_RL_RG_mask                                            (0x0000003F)
+#define MIPI_APHY_REG3_HSPAMP0_RL_RG(data)                                           (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG3_HSPAMP0_RL_RG_src(data)                                       ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG3_get_HSPAMP0_RL_RG(data)                                       ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG4                                                               0x18004010
+#define MIPI_APHY_REG4_reg_addr                                                      "0xB8004010"
+#define MIPI_APHY_REG4_reg                                                           0xB8004010
+#define set_MIPI_APHY_REG4_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG4_reg)=data)
+#define get_MIPI_APHY_REG4_reg   (*((volatile unsigned int*) MIPI_APHY_REG4_reg))
+#define MIPI_APHY_REG4_inst_adr                                                      "0x0004"
+#define MIPI_APHY_REG4_inst                                                          0x0004
+#define MIPI_APHY_REG4_HSPAMP1_RL_RG_shift                                           (0)
+#define MIPI_APHY_REG4_HSPAMP1_RL_RG_mask                                            (0x0000003F)
+#define MIPI_APHY_REG4_HSPAMP1_RL_RG(data)                                           (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG4_HSPAMP1_RL_RG_src(data)                                       ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG4_get_HSPAMP1_RL_RG(data)                                       ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG5                                                               0x18004014
+#define MIPI_APHY_REG5_reg_addr                                                      "0xB8004014"
+#define MIPI_APHY_REG5_reg                                                           0xB8004014
+#define set_MIPI_APHY_REG5_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG5_reg)=data)
+#define get_MIPI_APHY_REG5_reg   (*((volatile unsigned int*) MIPI_APHY_REG5_reg))
+#define MIPI_APHY_REG5_inst_adr                                                      "0x0005"
+#define MIPI_APHY_REG5_inst                                                          0x0005
+#define MIPI_APHY_REG5_SDATA0_SKW_RG_shift                                           (4)
+#define MIPI_APHY_REG5_SDATA0_SKW_RG_mask                                            (0x000000F0)
+#define MIPI_APHY_REG5_SDATA0_SKW_RG(data)                                           (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG5_SDATA0_SKW_RG_src(data)                                       ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG5_get_SDATA0_SKW_RG(data)                                       ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG5_SDATA1_SKW_RG_shift                                           (0)
+#define MIPI_APHY_REG5_SDATA1_SKW_RG_mask                                            (0x0000000F)
+#define MIPI_APHY_REG5_SDATA1_SKW_RG(data)                                           (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG5_SDATA1_SKW_RG_src(data)                                       ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG5_get_SDATA1_SKW_RG(data)                                       ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG6                                                               0x18004018
+#define MIPI_APHY_REG6_reg_addr                                                      "0xB8004018"
+#define MIPI_APHY_REG6_reg                                                           0xB8004018
+#define set_MIPI_APHY_REG6_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG6_reg)=data)
+#define get_MIPI_APHY_REG6_reg   (*((volatile unsigned int*) MIPI_APHY_REG6_reg))
+#define MIPI_APHY_REG6_inst_adr                                                      "0x0006"
+#define MIPI_APHY_REG6_inst                                                          0x0006
+#define MIPI_APHY_REG6_SDATA2_SKW_RG_shift                                           (4)
+#define MIPI_APHY_REG6_SDATA2_SKW_RG_mask                                            (0x000000F0)
+#define MIPI_APHY_REG6_SDATA2_SKW_RG(data)                                           (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG6_SDATA2_SKW_RG_src(data)                                       ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG6_get_SDATA2_SKW_RG(data)                                       ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG6_SDATA3_SKW_RG_shift                                           (0)
+#define MIPI_APHY_REG6_SDATA3_SKW_RG_mask                                            (0x0000000F)
+#define MIPI_APHY_REG6_SDATA3_SKW_RG(data)                                           (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG6_SDATA3_SKW_RG_src(data)                                       ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG6_get_SDATA3_SKW_RG(data)                                       ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG7                                                               0x1800401C
+#define MIPI_APHY_REG7_reg_addr                                                      "0xB800401C"
+#define MIPI_APHY_REG7_reg                                                           0xB800401C
+#define set_MIPI_APHY_REG7_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG7_reg)=data)
+#define get_MIPI_APHY_REG7_reg   (*((volatile unsigned int*) MIPI_APHY_REG7_reg))
+#define MIPI_APHY_REG7_inst_adr                                                      "0x0007"
+#define MIPI_APHY_REG7_inst                                                          0x0007
+#define MIPI_APHY_REG7_SCLK0_SKW_RG_shift                                            (4)
+#define MIPI_APHY_REG7_SCLK0_SKW_RG_mask                                             (0x000000F0)
+#define MIPI_APHY_REG7_SCLK0_SKW_RG(data)                                            (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG7_SCLK0_SKW_RG_src(data)                                        ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG7_get_SCLK0_SKW_RG(data)                                        ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG7_SCLK1_SKW_RG_shift                                            (0)
+#define MIPI_APHY_REG7_SCLK1_SKW_RG_mask                                             (0x0000000F)
+#define MIPI_APHY_REG7_SCLK1_SKW_RG(data)                                            (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG7_SCLK1_SKW_RG_src(data)                                        ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG7_get_SCLK1_SKW_RG(data)                                        ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG8                                                               0x18004020
+#define MIPI_APHY_REG8_reg_addr                                                      "0xB8004020"
+#define MIPI_APHY_REG8_reg                                                           0xB8004020
+#define set_MIPI_APHY_REG8_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG8_reg)=data)
+#define get_MIPI_APHY_REG8_reg   (*((volatile unsigned int*) MIPI_APHY_REG8_reg))
+#define MIPI_APHY_REG8_inst_adr                                                      "0x0008"
+#define MIPI_APHY_REG8_inst                                                          0x0008
+#define MIPI_APHY_REG8_SCLK2_SKW_RG_shift                                            (4)
+#define MIPI_APHY_REG8_SCLK2_SKW_RG_mask                                             (0x000000F0)
+#define MIPI_APHY_REG8_SCLK2_SKW_RG(data)                                            (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG8_SCLK2_SKW_RG_src(data)                                        ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG8_get_SCLK2_SKW_RG(data)                                        ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG8_SCLK3_SKW_RG_shift                                            (0)
+#define MIPI_APHY_REG8_SCLK3_SKW_RG_mask                                             (0x0000000F)
+#define MIPI_APHY_REG8_SCLK3_SKW_RG(data)                                            (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG8_SCLK3_SKW_RG_src(data)                                        ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG8_get_SCLK3_SKW_RG(data)                                        ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG9                                                               0x18004024
+#define MIPI_APHY_REG9_reg_addr                                                      "0xB8004024"
+#define MIPI_APHY_REG9_reg                                                           0xB8004024
+#define set_MIPI_APHY_REG9_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG9_reg)=data)
+#define get_MIPI_APHY_REG9_reg   (*((volatile unsigned int*) MIPI_APHY_REG9_reg))
+#define MIPI_APHY_REG9_inst_adr                                                      "0x0009"
+#define MIPI_APHY_REG9_inst                                                          0x0009
+#define MIPI_APHY_REG9_HSAMPCK_RL_RG_shift                                           (0)
+#define MIPI_APHY_REG9_HSAMPCK_RL_RG_mask                                            (0x0000003F)
+#define MIPI_APHY_REG9_HSAMPCK_RL_RG(data)                                           (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG9_HSAMPCK_RL_RG_src(data)                                       ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG9_get_HSAMPCK_RL_RG(data)                                       ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG10                                                              0x18004028
+#define MIPI_APHY_REG10_reg_addr                                                     "0xB8004028"
+#define MIPI_APHY_REG10_reg                                                          0xB8004028
+#define set_MIPI_APHY_REG10_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG10_reg)=data)
+#define get_MIPI_APHY_REG10_reg   (*((volatile unsigned int*) MIPI_APHY_REG10_reg))
+#define MIPI_APHY_REG10_inst_adr                                                     "0x000A"
+#define MIPI_APHY_REG10_inst                                                         0x000A
+#define MIPI_APHY_REG10_COUNT_RUN_shift                                              (0)
+#define MIPI_APHY_REG10_COUNT_RUN_mask                                               (0x000000FF)
+#define MIPI_APHY_REG10_COUNT_RUN(data)                                              (0x000000FF&((data)<<0))
+#define MIPI_APHY_REG10_COUNT_RUN_src(data)                                          ((0x000000FF&(data))>>0)
+#define MIPI_APHY_REG10_get_COUNT_RUN(data)                                          ((0x000000FF&(data))>>0)
+
+
+#define MIPI_APHY_REG11                                                              0x1800402C
+#define MIPI_APHY_REG11_reg_addr                                                     "0xB800402C"
+#define MIPI_APHY_REG11_reg                                                          0xB800402C
+#define set_MIPI_APHY_REG11_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG11_reg)=data)
+#define get_MIPI_APHY_REG11_reg   (*((volatile unsigned int*) MIPI_APHY_REG11_reg))
+#define MIPI_APHY_REG11_inst_adr                                                     "0x000B"
+#define MIPI_APHY_REG11_inst                                                         0x000B
+#define MIPI_APHY_REG11_COUNT_RUN_shift                                              (0)
+#define MIPI_APHY_REG11_COUNT_RUN_mask                                               (0x00000001)
+#define MIPI_APHY_REG11_COUNT_RUN(data)                                              (0x00000001&((data)<<0))
+#define MIPI_APHY_REG11_COUNT_RUN_src(data)                                          ((0x00000001&(data))>>0)
+#define MIPI_APHY_REG11_get_COUNT_RUN(data)                                          ((0x00000001&(data))>>0)
+
+
+#define MIPI_APHY_REG12                                                              0x18004030
+#define MIPI_APHY_REG12_reg_addr                                                     "0xB8004030"
+#define MIPI_APHY_REG12_reg                                                          0xB8004030
+#define set_MIPI_APHY_REG12_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG12_reg)=data)
+#define get_MIPI_APHY_REG12_reg   (*((volatile unsigned int*) MIPI_APHY_REG12_reg))
+#define MIPI_APHY_REG12_inst_adr                                                     "0x000C"
+#define MIPI_APHY_REG12_inst                                                         0x000C
+#define MIPI_APHY_REG12_COUNT_RT_shift                                               (0)
+#define MIPI_APHY_REG12_COUNT_RT_mask                                                (0x0000007F)
+#define MIPI_APHY_REG12_COUNT_RT(data)                                               (0x0000007F&((data)<<0))
+#define MIPI_APHY_REG12_COUNT_RT_src(data)                                           ((0x0000007F&(data))>>0)
+#define MIPI_APHY_REG12_get_COUNT_RT(data)                                           ((0x0000007F&(data))>>0)
+
+
+#define MIPI_APHY_REG13                                                              0x18004034
+#define MIPI_APHY_REG13_reg_addr                                                     "0xB8004034"
+#define MIPI_APHY_REG13_reg                                                          0xB8004034
+#define set_MIPI_APHY_REG13_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG13_reg)=data)
+#define get_MIPI_APHY_REG13_reg   (*((volatile unsigned int*) MIPI_APHY_REG13_reg))
+#define MIPI_APHY_REG13_inst_adr                                                     "0x000D"
+#define MIPI_APHY_REG13_inst                                                         0x000D
+#define MIPI_APHY_REG13_HS_CM_shift                                                  (5)
+#define MIPI_APHY_REG13_HS_CM_mask                                                   (0x000000E0)
+#define MIPI_APHY_REG13_HS_CM(data)                                                  (0x000000E0&((data)<<5))
+#define MIPI_APHY_REG13_HS_CM_src(data)                                              ((0x000000E0&(data))>>5)
+#define MIPI_APHY_REG13_get_HS_CM(data)                                              ((0x000000E0&(data))>>5)
+#define MIPI_APHY_REG13_COUNT_SEL_shift                                              (0)
+#define MIPI_APHY_REG13_COUNT_SEL_mask                                               (0x0000001F)
+#define MIPI_APHY_REG13_COUNT_SEL(data)                                              (0x0000001F&((data)<<0))
+#define MIPI_APHY_REG13_COUNT_SEL_src(data)                                          ((0x0000001F&(data))>>0)
+#define MIPI_APHY_REG13_get_COUNT_SEL(data)                                          ((0x0000001F&(data))>>0)
+
+
+#define MIPI_APHY_REG14                                                              0x18004038
+#define MIPI_APHY_REG14_reg_addr                                                     "0xB8004038"
+#define MIPI_APHY_REG14_reg                                                          0xB8004038
+#define set_MIPI_APHY_REG14_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG14_reg)=data)
+#define get_MIPI_APHY_REG14_reg   (*((volatile unsigned int*) MIPI_APHY_REG14_reg))
+#define MIPI_APHY_REG14_inst_adr                                                     "0x000E"
+#define MIPI_APHY_REG14_inst                                                         0x000E
+#define MIPI_APHY_REG14_CMP_REF_shift                                                (4)
+#define MIPI_APHY_REG14_CMP_REF_mask                                                 (0x000000F0)
+#define MIPI_APHY_REG14_CMP_REF(data)                                                (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG14_CMP_REF_src(data)                                            ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG14_get_CMP_REF(data)                                            ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG14_LPAMP_REF_shift                                              (0)
+#define MIPI_APHY_REG14_LPAMP_REF_mask                                               (0x0000000F)
+#define MIPI_APHY_REG14_LPAMP_REF(data)                                              (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG14_LPAMP_REF_src(data)                                          ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG14_get_LPAMP_REF(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG15                                                              0x1800403C
+#define MIPI_APHY_REG15_reg_addr                                                     "0xB800403C"
+#define MIPI_APHY_REG15_reg                                                          0xB800403C
+#define set_MIPI_APHY_REG15_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG15_reg)=data)
+#define get_MIPI_APHY_REG15_reg   (*((volatile unsigned int*) MIPI_APHY_REG15_reg))
+#define MIPI_APHY_REG15_inst_adr                                                     "0x000F"
+#define MIPI_APHY_REG15_inst                                                         0x000F
+#define MIPI_APHY_REG15_adrst_sel_shift                                              (2)
+#define MIPI_APHY_REG15_adrst_sel_mask                                               (0x0000000C)
+#define MIPI_APHY_REG15_adrst_sel(data)                                              (0x0000000C&((data)<<2))
+#define MIPI_APHY_REG15_adrst_sel_src(data)                                          ((0x0000000C&(data))>>2)
+#define MIPI_APHY_REG15_get_adrst_sel(data)                                          ((0x0000000C&(data))>>2)
+#define MIPI_APHY_REG15_SEL_DIV_RG_shift                                             (0)
+#define MIPI_APHY_REG15_SEL_DIV_RG_mask                                              (0x00000003)
+#define MIPI_APHY_REG15_SEL_DIV_RG(data)                                             (0x00000003&((data)<<0))
+#define MIPI_APHY_REG15_SEL_DIV_RG_src(data)                                         ((0x00000003&(data))>>0)
+#define MIPI_APHY_REG15_get_SEL_DIV_RG(data)                                         ((0x00000003&(data))>>0)
+
+
+#define MIPI_APHY_REG16                                                              0x18004040
+#define MIPI_APHY_REG16_reg_addr                                                     "0xB8004040"
+#define MIPI_APHY_REG16_reg                                                          0xB8004040
+#define set_MIPI_APHY_REG16_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG16_reg)=data)
+#define get_MIPI_APHY_REG16_reg   (*((volatile unsigned int*) MIPI_APHY_REG16_reg))
+#define MIPI_APHY_REG16_inst_adr                                                     "0x0010"
+#define MIPI_APHY_REG16_inst                                                         0x0010
+#define MIPI_APHY_REG16_HSAMP3_RL_2RG_shift                                          (0)
+#define MIPI_APHY_REG16_HSAMP3_RL_2RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG16_HSAMP3_RL_2RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG16_HSAMP3_RL_2RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG16_get_HSAMP3_RL_2RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG17                                                              0x18004044
+#define MIPI_APHY_REG17_reg_addr                                                     "0xB8004044"
+#define MIPI_APHY_REG17_reg                                                          0xB8004044
+#define set_MIPI_APHY_REG17_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG17_reg)=data)
+#define get_MIPI_APHY_REG17_reg   (*((volatile unsigned int*) MIPI_APHY_REG17_reg))
+#define MIPI_APHY_REG17_inst_adr                                                     "0x0011"
+#define MIPI_APHY_REG17_inst                                                         0x0011
+#define MIPI_APHY_REG17_HSAMP2_RL_2RG_shift                                          (0)
+#define MIPI_APHY_REG17_HSAMP2_RL_2RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG17_HSAMP2_RL_2RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG17_HSAMP2_RL_2RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG17_get_HSAMP2_RL_2RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG18                                                              0x18004048
+#define MIPI_APHY_REG18_reg_addr                                                     "0xB8004048"
+#define MIPI_APHY_REG18_reg                                                          0xB8004048
+#define set_MIPI_APHY_REG18_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG18_reg)=data)
+#define get_MIPI_APHY_REG18_reg   (*((volatile unsigned int*) MIPI_APHY_REG18_reg))
+#define MIPI_APHY_REG18_inst_adr                                                     "0x0012"
+#define MIPI_APHY_REG18_inst                                                         0x0012
+#define MIPI_APHY_REG18_HSAMP1_RL_2RG_shift                                          (0)
+#define MIPI_APHY_REG18_HSAMP1_RL_2RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG18_HSAMP1_RL_2RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG18_HSAMP1_RL_2RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG18_get_HSAMP1_RL_2RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG19                                                              0x1800404C
+#define MIPI_APHY_REG19_reg_addr                                                     "0xB800404C"
+#define MIPI_APHY_REG19_reg                                                          0xB800404C
+#define set_MIPI_APHY_REG19_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG19_reg)=data)
+#define get_MIPI_APHY_REG19_reg   (*((volatile unsigned int*) MIPI_APHY_REG19_reg))
+#define MIPI_APHY_REG19_inst_adr                                                     "0x0013"
+#define MIPI_APHY_REG19_inst                                                         0x0013
+#define MIPI_APHY_REG19_HSAMP0_RL_2RG_shift                                          (0)
+#define MIPI_APHY_REG19_HSAMP0_RL_2RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG19_HSAMP0_RL_2RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG19_HSAMP0_RL_2RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG19_get_HSAMP0_RL_2RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG20                                                              0x18004050
+#define MIPI_APHY_REG20_reg_addr                                                     "0xB8004050"
+#define MIPI_APHY_REG20_reg                                                          0xB8004050
+#define set_MIPI_APHY_REG20_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG20_reg)=data)
+#define get_MIPI_APHY_REG20_reg   (*((volatile unsigned int*) MIPI_APHY_REG20_reg))
+#define MIPI_APHY_REG20_inst_adr                                                     "0x0014"
+#define MIPI_APHY_REG20_inst                                                         0x0014
+#define MIPI_APHY_REG20_HSAMPCK_RL_2RG_shift                                         (0)
+#define MIPI_APHY_REG20_HSAMPCK_RL_2RG_mask                                          (0x0000003F)
+#define MIPI_APHY_REG20_HSAMPCK_RL_2RG(data)                                         (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG20_HSAMPCK_RL_2RG_src(data)                                     ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG20_get_HSAMPCK_RL_2RG(data)                                     ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG21                                                              0x18004054
+#define MIPI_APHY_REG21_reg_addr                                                     "0xB8004054"
+#define MIPI_APHY_REG21_reg                                                          0xB8004054
+#define set_MIPI_APHY_REG21_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG21_reg)=data)
+#define get_MIPI_APHY_REG21_reg   (*((volatile unsigned int*) MIPI_APHY_REG21_reg))
+#define MIPI_APHY_REG21_inst_adr                                                     "0x0015"
+#define MIPI_APHY_REG21_inst                                                         0x0015
+#define MIPI_APHY_REG21_CLK0_DLY_CODE_2RG_shift                                      (4)
+#define MIPI_APHY_REG21_CLK0_DLY_CODE_2RG_mask                                       (0x000000F0)
+#define MIPI_APHY_REG21_CLK0_DLY_CODE_2RG(data)                                      (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG21_CLK0_DLY_CODE_2RG_src(data)                                  ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG21_get_CLK0_DLY_CODE_2RG(data)                                  ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG21_CLK1_DLY_CODE_2RG_shift                                      (0)
+#define MIPI_APHY_REG21_CLK1_DLY_CODE_2RG_mask                                       (0x0000000F)
+#define MIPI_APHY_REG21_CLK1_DLY_CODE_2RG(data)                                      (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG21_CLK1_DLY_CODE_2RG_src(data)                                  ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG21_get_CLK1_DLY_CODE_2RG(data)                                  ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG22                                                              0x18004058
+#define MIPI_APHY_REG22_reg_addr                                                     "0xB8004058"
+#define MIPI_APHY_REG22_reg                                                          0xB8004058
+#define set_MIPI_APHY_REG22_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG22_reg)=data)
+#define get_MIPI_APHY_REG22_reg   (*((volatile unsigned int*) MIPI_APHY_REG22_reg))
+#define MIPI_APHY_REG22_inst_adr                                                     "0x0016"
+#define MIPI_APHY_REG22_inst                                                         0x0016
+#define MIPI_APHY_REG22_CLK2_DLY_CODE_2RG_shift                                      (4)
+#define MIPI_APHY_REG22_CLK2_DLY_CODE_2RG_mask                                       (0x000000F0)
+#define MIPI_APHY_REG22_CLK2_DLY_CODE_2RG(data)                                      (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG22_CLK2_DLY_CODE_2RG_src(data)                                  ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG22_get_CLK2_DLY_CODE_2RG(data)                                  ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG22_CLK3_DLY_CODE_2RG_shift                                      (0)
+#define MIPI_APHY_REG22_CLK3_DLY_CODE_2RG_mask                                       (0x0000000F)
+#define MIPI_APHY_REG22_CLK3_DLY_CODE_2RG(data)                                      (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG22_CLK3_DLY_CODE_2RG_src(data)                                  ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG22_get_CLK3_DLY_CODE_2RG(data)                                  ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG23                                                              0x1800405C
+#define MIPI_APHY_REG23_reg_addr                                                     "0xB800405C"
+#define MIPI_APHY_REG23_reg                                                          0xB800405C
+#define set_MIPI_APHY_REG23_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG23_reg)=data)
+#define get_MIPI_APHY_REG23_reg   (*((volatile unsigned int*) MIPI_APHY_REG23_reg))
+#define MIPI_APHY_REG23_inst_adr                                                     "0x0017"
+#define MIPI_APHY_REG23_inst                                                         0x0017
+#define MIPI_APHY_REG23_DATA0_DLY_CODE_2RG_shift                                     (4)
+#define MIPI_APHY_REG23_DATA0_DLY_CODE_2RG_mask                                      (0x000000F0)
+#define MIPI_APHY_REG23_DATA0_DLY_CODE_2RG(data)                                     (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG23_DATA0_DLY_CODE_2RG_src(data)                                 ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG23_get_DATA0_DLY_CODE_2RG(data)                                 ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG23_DATA1_DLY_CODE_2RG_shift                                     (0)
+#define MIPI_APHY_REG23_DATA1_DLY_CODE_2RG_mask                                      (0x0000000F)
+#define MIPI_APHY_REG23_DATA1_DLY_CODE_2RG(data)                                     (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG23_DATA1_DLY_CODE_2RG_src(data)                                 ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG23_get_DATA1_DLY_CODE_2RG(data)                                 ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG24                                                              0x18004060
+#define MIPI_APHY_REG24_reg_addr                                                     "0xB8004060"
+#define MIPI_APHY_REG24_reg                                                          0xB8004060
+#define set_MIPI_APHY_REG24_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG24_reg)=data)
+#define get_MIPI_APHY_REG24_reg   (*((volatile unsigned int*) MIPI_APHY_REG24_reg))
+#define MIPI_APHY_REG24_inst_adr                                                     "0x0018"
+#define MIPI_APHY_REG24_inst                                                         0x0018
+#define MIPI_APHY_REG24_DATA2_DLY_CODE_2RG_shift                                     (4)
+#define MIPI_APHY_REG24_DATA2_DLY_CODE_2RG_mask                                      (0x000000F0)
+#define MIPI_APHY_REG24_DATA2_DLY_CODE_2RG(data)                                     (0x000000F0&((data)<<4))
+#define MIPI_APHY_REG24_DATA2_DLY_CODE_2RG_src(data)                                 ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG24_get_DATA2_DLY_CODE_2RG(data)                                 ((0x000000F0&(data))>>4)
+#define MIPI_APHY_REG24_DATA3_DLY_CODE_2RG_shift                                     (0)
+#define MIPI_APHY_REG24_DATA3_DLY_CODE_2RG_mask                                      (0x0000000F)
+#define MIPI_APHY_REG24_DATA3_DLY_CODE_2RG(data)                                     (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG24_DATA3_DLY_CODE_2RG_src(data)                                 ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG24_get_DATA3_DLY_CODE_2RG(data)                                 ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG25                                                              0x18004064
+#define MIPI_APHY_REG25_reg_addr                                                     "0xB8004064"
+#define MIPI_APHY_REG25_reg                                                          0xB8004064
+#define set_MIPI_APHY_REG25_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG25_reg)=data)
+#define get_MIPI_APHY_REG25_reg   (*((volatile unsigned int*) MIPI_APHY_REG25_reg))
+#define MIPI_APHY_REG25_inst_adr                                                     "0x0019"
+#define MIPI_APHY_REG25_inst                                                         0x0019
+#define MIPI_APHY_REG25_R50_CAL_OK_2RG_shift                                         (7)
+#define MIPI_APHY_REG25_R50_CAL_OK_2RG_mask                                          (0x00000080)
+#define MIPI_APHY_REG25_R50_CAL_OK_2RG(data)                                         (0x00000080&((data)<<7))
+#define MIPI_APHY_REG25_R50_CAL_OK_2RG_src(data)                                     ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG25_get_R50_CAL_OK_2RG(data)                                     ((0x00000080&(data))>>7)
+#define MIPI_APHY_REG25_R50_CAL_2RG_shift                                            (0)
+#define MIPI_APHY_REG25_R50_CAL_2RG_mask                                             (0x0000003F)
+#define MIPI_APHY_REG25_R50_CAL_2RG(data)                                            (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG25_R50_CAL_2RG_src(data)                                        ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG25_get_R50_CAL_2RG(data)                                        ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG26                                                              0x18004068
+#define MIPI_APHY_REG26_reg_addr                                                     "0xB8004068"
+#define MIPI_APHY_REG26_reg                                                          0xB8004068
+#define set_MIPI_APHY_REG26_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG26_reg)=data)
+#define get_MIPI_APHY_REG26_reg   (*((volatile unsigned int*) MIPI_APHY_REG26_reg))
+#define MIPI_APHY_REG26_inst_adr                                                     "0x001A"
+#define MIPI_APHY_REG26_inst                                                         0x001A
+#define MIPI_APHY_REG26_LANE_OK_shift                                                (0)
+#define MIPI_APHY_REG26_LANE_OK_mask                                                 (0x0000000F)
+#define MIPI_APHY_REG26_LANE_OK(data)                                                (0x0000000F&((data)<<0))
+#define MIPI_APHY_REG26_LANE_OK_src(data)                                            ((0x0000000F&(data))>>0)
+#define MIPI_APHY_REG26_get_LANE_OK(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define MIPI_APHY_REG27                                                              0x18004084
+#define MIPI_APHY_REG27_reg_addr                                                     "0xB8004084"
+#define MIPI_APHY_REG27_reg                                                          0xB8004084
+#define set_MIPI_APHY_REG27_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG27_reg)=data)
+#define get_MIPI_APHY_REG27_reg   (*((volatile unsigned int*) MIPI_APHY_REG27_reg))
+#define MIPI_APHY_REG27_inst_adr                                                     "0x0021"
+#define MIPI_APHY_REG27_inst                                                         0x0021
+#define MIPI_APHY_REG27_HSPAMP2_RL_RG_shift                                          (0)
+#define MIPI_APHY_REG27_HSPAMP2_RL_RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG27_HSPAMP2_RL_RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG27_HSPAMP2_RL_RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG27_get_HSPAMP2_RL_RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#define MIPI_APHY_REG28                                                              0x18004088
+#define MIPI_APHY_REG28_reg_addr                                                     "0xB8004088"
+#define MIPI_APHY_REG28_reg                                                          0xB8004088
+#define set_MIPI_APHY_REG28_reg(data)   (*((volatile unsigned int*) MIPI_APHY_REG28_reg)=data)
+#define get_MIPI_APHY_REG28_reg   (*((volatile unsigned int*) MIPI_APHY_REG28_reg))
+#define MIPI_APHY_REG28_inst_adr                                                     "0x0022"
+#define MIPI_APHY_REG28_inst                                                         0x0022
+#define MIPI_APHY_REG28_HSPAMP3_RL_RG_shift                                          (0)
+#define MIPI_APHY_REG28_HSPAMP3_RL_RG_mask                                           (0x0000003F)
+#define MIPI_APHY_REG28_HSPAMP3_RL_RG(data)                                          (0x0000003F&((data)<<0))
+#define MIPI_APHY_REG28_HSPAMP3_RL_RG_src(data)                                      ((0x0000003F&(data))>>0)
+#define MIPI_APHY_REG28_get_HSPAMP3_RL_RG(data)                                      ((0x0000003F&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/mipi_dphy_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mipi_dphy_reg.h
new file mode 100644
index 00000000..546999e
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mipi_dphy_reg.h
@@ -0,0 +1,826 @@
+/**************************************************************
+// Spec Version                  : unknown
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/4/18 19:15:35
+***************************************************************/
+
+
+#ifndef _MIPI_DPHY_REG_H_INCLUDED_
+#define _MIPI_DPHY_REG_H_INCLUDED_
+#ifdef  _MIPI_DPHY_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     L3_pwdb:1;
+unsigned int     L2_pwdb:1;
+unsigned int     L1_pwdb:1;
+unsigned int     L0_pwdb:1;
+}MIPI_DPHY_PWDB;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rxpre_lane:8;
+}MIPI_DPHY_RXPRE;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rxpos_lane:8;
+}MIPI_DPHY_RXPRE;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Div_sel:2;
+unsigned int     reserved_1:1;
+unsigned int     drst_sel:1;
+unsigned int     Lane3_en:1;
+unsigned int     Lane2_en:1;
+unsigned int     Lane1_en:1;
+unsigned int     Lane0_en:1;
+}MIPI_DPHY_REG0;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     yuv_src_sel:2;
+unsigned int     reserved_1:1;
+unsigned int     dec_format:3;
+}MIPI_DPHY_REG1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     D_type:8;
+}MIPI_DPHY_REG2;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     D_type:1;
+unsigned int     L3_deglitch:1;
+unsigned int     L2_deglitch:1;
+unsigned int     L1_deglitch:1;
+unsigned int     L0_deglitch:1;
+}MIPI_DPHY_REG3;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     SL_RG:1;
+unsigned int     reserved_1:2;
+unsigned int     Sw_rst:1;
+}MIPI_DPHY_REG4;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     Bit_switch_en:1;
+unsigned int     Crc16_en:1;
+unsigned int     Ecc_en:1;
+unsigned int     Con_clk_lane_en:1;
+}MIPI_DPHY_REG5;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Dvld_lane1:4;
+unsigned int     Dvld_lane0:4;
+}MIPI_DPHY_REG6;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Dvld_lane3:4;
+unsigned int     Dvld_lane2:4;
+}MIPI_DPHY_REG7;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Lane3_sel:2;
+unsigned int     Lane2_sel:2;
+unsigned int     Lane1_sel:2;
+unsigned int     Lane0_sel:2;
+}MIPI_DPHY_REG8;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     Lane3_clk_edge:1;
+unsigned int     Lane2_clk_edge:1;
+unsigned int     Lane1_clk_edge:1;
+unsigned int     Lane0_clk_edge:1;
+}MIPI_DPHY_REG9;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Esc_lane3_int_en:1;
+unsigned int     Esc_lane2_int_en:1;
+unsigned int     Esc_lane1_int_en:1;
+unsigned int     Esc_lane0_int_en:1;
+unsigned int     Clk_ulps_int_en:1;
+unsigned int     Crc16_err_int_en:1;
+unsigned int     Ecc_crt_int_en:1;
+unsigned int     Ecc_err_int_en:1;
+}MIPI_DPHY_REG10;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Esc_lane3_int_flg:1;
+unsigned int     Esc_lane2_int_flg:1;
+unsigned int     Esc_lane1_int_flg:1;
+unsigned int     Esc_lane0_int_flg:1;
+unsigned int     Clk_ulps_int_flg:1;
+unsigned int     Crc16_err_int_flg:1;
+unsigned int     Ecc_crt_int_flg:1;
+unsigned int     Ecc_err_int_flg:1;
+}MIPI_DPHY_REG11;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Num_ecc_err:8;
+}MIPI_DPHY_REG12;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Num_ecc_err:8;
+}MIPI_DPHY_REG13;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Num_crc_err:8;
+}MIPI_DPHY_REG14;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Num_crc_err:8;
+}MIPI_DPHY_REG15;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     Clk_term_en:1;
+unsigned int     Lane3_term_en:1;
+unsigned int     Lane2_term_en:1;
+unsigned int     Lane1_term_en:1;
+unsigned int     Lane0_term_en:1;
+}MIPI_DPHY_REG16;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     Lane3_pwdb_en:1;
+unsigned int     Lane2_pwdb_en:1;
+unsigned int     Lane1_pwdb_en:1;
+unsigned int     Lane0_pwdb_en:1;
+}MIPI_DPHY_REG17;
+
+typedef struct 
+{
+unsigned int     reserved_0:32;
+}MIPI_DPHY_REG18;
+
+typedef struct 
+{
+unsigned int     reserved_0:32;
+}MIPI_DPHY_REG19;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Lane0_esc_cod:8;
+}MIPI_DPHY_REG20;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Lane1_esc_cod:8;
+}MIPI_DPHY_REG21;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Lane2_esc_cod:8;
+}MIPI_DPHY_REG22;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Lane3_esc_cod:8;
+}MIPI_DPHY_REG23;
+
+#endif
+
+#define MIPI_DPHY_PWDB                                                               0x18004074
+#define MIPI_DPHY_PWDB_reg_addr                                                      "0xB8004074"
+#define MIPI_DPHY_PWDB_reg                                                           0xB8004074
+#define set_MIPI_DPHY_PWDB_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_PWDB_reg)=data)
+#define get_MIPI_DPHY_PWDB_reg   (*((volatile unsigned int*) MIPI_DPHY_PWDB_reg))
+#define MIPI_DPHY_PWDB_inst_adr                                                      "0x001D"
+#define MIPI_DPHY_PWDB_inst                                                          0x001D
+#define MIPI_DPHY_PWDB_L3_pwdb_shift                                                 (3)
+#define MIPI_DPHY_PWDB_L3_pwdb_mask                                                  (0x00000008)
+#define MIPI_DPHY_PWDB_L3_pwdb(data)                                                 (0x00000008&((data)<<3))
+#define MIPI_DPHY_PWDB_L3_pwdb_src(data)                                             ((0x00000008&(data))>>3)
+#define MIPI_DPHY_PWDB_get_L3_pwdb(data)                                             ((0x00000008&(data))>>3)
+#define MIPI_DPHY_PWDB_L2_pwdb_shift                                                 (2)
+#define MIPI_DPHY_PWDB_L2_pwdb_mask                                                  (0x00000004)
+#define MIPI_DPHY_PWDB_L2_pwdb(data)                                                 (0x00000004&((data)<<2))
+#define MIPI_DPHY_PWDB_L2_pwdb_src(data)                                             ((0x00000004&(data))>>2)
+#define MIPI_DPHY_PWDB_get_L2_pwdb(data)                                             ((0x00000004&(data))>>2)
+#define MIPI_DPHY_PWDB_L1_pwdb_shift                                                 (1)
+#define MIPI_DPHY_PWDB_L1_pwdb_mask                                                  (0x00000002)
+#define MIPI_DPHY_PWDB_L1_pwdb(data)                                                 (0x00000002&((data)<<1))
+#define MIPI_DPHY_PWDB_L1_pwdb_src(data)                                             ((0x00000002&(data))>>1)
+#define MIPI_DPHY_PWDB_get_L1_pwdb(data)                                             ((0x00000002&(data))>>1)
+#define MIPI_DPHY_PWDB_L0_pwdb_shift                                                 (0)
+#define MIPI_DPHY_PWDB_L0_pwdb_mask                                                  (0x00000001)
+#define MIPI_DPHY_PWDB_L0_pwdb(data)                                                 (0x00000001&((data)<<0))
+#define MIPI_DPHY_PWDB_L0_pwdb_src(data)                                             ((0x00000001&(data))>>0)
+#define MIPI_DPHY_PWDB_get_L0_pwdb(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_RXPRE                                                              0x18004078
+#define MIPI_DPHY_RXPRE_reg_addr                                                     "0xB8004078"
+#define MIPI_DPHY_RXPRE_reg                                                          0xB8004078
+#define set_MIPI_DPHY_RXPRE_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_RXPRE_reg)=data)
+#define get_MIPI_DPHY_RXPRE_reg   (*((volatile unsigned int*) MIPI_DPHY_RXPRE_reg))
+#define MIPI_DPHY_RXPRE_inst_adr                                                     "0x001E"
+#define MIPI_DPHY_RXPRE_inst                                                         0x001E
+#define MIPI_DPHY_RXPRE_rxpre_lane_shift                                             (0)
+#define MIPI_DPHY_RXPRE_rxpre_lane_mask                                              (0x000000FF)
+#define MIPI_DPHY_RXPRE_rxpre_lane(data)                                             (0x000000FF&((data)<<0))
+#define MIPI_DPHY_RXPRE_rxpre_lane_src(data)                                         ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_RXPRE_get_rxpre_lane(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_RXPRE                                                              0x1800407C
+#define MIPI_DPHY_RXPRE_reg_addr                                                     "0xB800407C"
+#define MIPI_DPHY_RXPRE_reg                                                          0xB800407C
+#define set_MIPI_DPHY_RXPRE_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_RXPRE_reg)=data)
+#define get_MIPI_DPHY_RXPRE_reg   (*((volatile unsigned int*) MIPI_DPHY_RXPRE_reg))
+#define MIPI_DPHY_RXPRE_inst_adr                                                     "0x001F"
+#define MIPI_DPHY_RXPRE_inst                                                         0x001F
+#define MIPI_DPHY_RXPRE_rxpos_lane_shift                                             (0)
+#define MIPI_DPHY_RXPRE_rxpos_lane_mask                                              (0x000000FF)
+#define MIPI_DPHY_RXPRE_rxpos_lane(data)                                             (0x000000FF&((data)<<0))
+#define MIPI_DPHY_RXPRE_rxpos_lane_src(data)                                         ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_RXPRE_get_rxpos_lane(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG0                                                               0x18004080
+#define MIPI_DPHY_REG0_reg_addr                                                      "0xB8004080"
+#define MIPI_DPHY_REG0_reg                                                           0xB8004080
+#define set_MIPI_DPHY_REG0_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG0_reg)=data)
+#define get_MIPI_DPHY_REG0_reg   (*((volatile unsigned int*) MIPI_DPHY_REG0_reg))
+#define MIPI_DPHY_REG0_inst_adr                                                      "0x0020"
+#define MIPI_DPHY_REG0_inst                                                          0x0020
+#define MIPI_DPHY_REG0_Div_sel_shift                                                 (6)
+#define MIPI_DPHY_REG0_Div_sel_mask                                                  (0x000000C0)
+#define MIPI_DPHY_REG0_Div_sel(data)                                                 (0x000000C0&((data)<<6))
+#define MIPI_DPHY_REG0_Div_sel_src(data)                                             ((0x000000C0&(data))>>6)
+#define MIPI_DPHY_REG0_get_Div_sel(data)                                             ((0x000000C0&(data))>>6)
+#define MIPI_DPHY_REG0_drst_sel_shift                                                (4)
+#define MIPI_DPHY_REG0_drst_sel_mask                                                 (0x00000010)
+#define MIPI_DPHY_REG0_drst_sel(data)                                                (0x00000010&((data)<<4))
+#define MIPI_DPHY_REG0_drst_sel_src(data)                                            ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG0_get_drst_sel(data)                                            ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG0_Lane3_en_shift                                                (3)
+#define MIPI_DPHY_REG0_Lane3_en_mask                                                 (0x00000008)
+#define MIPI_DPHY_REG0_Lane3_en(data)                                                (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG0_Lane3_en_src(data)                                            ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG0_get_Lane3_en(data)                                            ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG0_Lane2_en_shift                                                (2)
+#define MIPI_DPHY_REG0_Lane2_en_mask                                                 (0x00000004)
+#define MIPI_DPHY_REG0_Lane2_en(data)                                                (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG0_Lane2_en_src(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG0_get_Lane2_en(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG0_Lane1_en_shift                                                (1)
+#define MIPI_DPHY_REG0_Lane1_en_mask                                                 (0x00000002)
+#define MIPI_DPHY_REG0_Lane1_en(data)                                                (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG0_Lane1_en_src(data)                                            ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG0_get_Lane1_en(data)                                            ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG0_Lane0_en_shift                                                (0)
+#define MIPI_DPHY_REG0_Lane0_en_mask                                                 (0x00000001)
+#define MIPI_DPHY_REG0_Lane0_en(data)                                                (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG0_Lane0_en_src(data)                                            ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG0_get_Lane0_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG1                                                               0x1800408C
+#define MIPI_DPHY_REG1_reg_addr                                                      "0xB800408C"
+#define MIPI_DPHY_REG1_reg                                                           0xB800408C
+#define set_MIPI_DPHY_REG1_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG1_reg)=data)
+#define get_MIPI_DPHY_REG1_reg   (*((volatile unsigned int*) MIPI_DPHY_REG1_reg))
+#define MIPI_DPHY_REG1_inst_adr                                                      "0x0023"
+#define MIPI_DPHY_REG1_inst                                                          0x0023
+#define MIPI_DPHY_REG1_yuv_src_sel_shift                                             (4)
+#define MIPI_DPHY_REG1_yuv_src_sel_mask                                              (0x00000030)
+#define MIPI_DPHY_REG1_yuv_src_sel(data)                                             (0x00000030&((data)<<4))
+#define MIPI_DPHY_REG1_yuv_src_sel_src(data)                                         ((0x00000030&(data))>>4)
+#define MIPI_DPHY_REG1_get_yuv_src_sel(data)                                         ((0x00000030&(data))>>4)
+#define MIPI_DPHY_REG1_dec_format_shift                                              (0)
+#define MIPI_DPHY_REG1_dec_format_mask                                               (0x00000007)
+#define MIPI_DPHY_REG1_dec_format(data)                                              (0x00000007&((data)<<0))
+#define MIPI_DPHY_REG1_dec_format_src(data)                                          ((0x00000007&(data))>>0)
+#define MIPI_DPHY_REG1_get_dec_format(data)                                          ((0x00000007&(data))>>0)
+
+
+#define MIPI_DPHY_REG2                                                               0x18004090
+#define MIPI_DPHY_REG2_reg_addr                                                      "0xB8004090"
+#define MIPI_DPHY_REG2_reg                                                           0xB8004090
+#define set_MIPI_DPHY_REG2_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG2_reg)=data)
+#define get_MIPI_DPHY_REG2_reg   (*((volatile unsigned int*) MIPI_DPHY_REG2_reg))
+#define MIPI_DPHY_REG2_inst_adr                                                      "0x0024"
+#define MIPI_DPHY_REG2_inst                                                          0x0024
+#define MIPI_DPHY_REG2_D_type_shift                                                  (0)
+#define MIPI_DPHY_REG2_D_type_mask                                                   (0x000000FF)
+#define MIPI_DPHY_REG2_D_type(data)                                                  (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG2_D_type_src(data)                                              ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG2_get_D_type(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG3                                                               0x18004094
+#define MIPI_DPHY_REG3_reg_addr                                                      "0xB8004094"
+#define MIPI_DPHY_REG3_reg                                                           0xB8004094
+#define set_MIPI_DPHY_REG3_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG3_reg)=data)
+#define get_MIPI_DPHY_REG3_reg   (*((volatile unsigned int*) MIPI_DPHY_REG3_reg))
+#define MIPI_DPHY_REG3_inst_adr                                                      "0x0025"
+#define MIPI_DPHY_REG3_inst                                                          0x0025
+#define MIPI_DPHY_REG3_D_type_shift                                                  (4)
+#define MIPI_DPHY_REG3_D_type_mask                                                   (0x00000010)
+#define MIPI_DPHY_REG3_D_type(data)                                                  (0x00000010&((data)<<4))
+#define MIPI_DPHY_REG3_D_type_src(data)                                              ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG3_get_D_type(data)                                              ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG3_L3_deglitch_shift                                             (3)
+#define MIPI_DPHY_REG3_L3_deglitch_mask                                              (0x00000008)
+#define MIPI_DPHY_REG3_L3_deglitch(data)                                             (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG3_L3_deglitch_src(data)                                         ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG3_get_L3_deglitch(data)                                         ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG3_L2_deglitch_shift                                             (2)
+#define MIPI_DPHY_REG3_L2_deglitch_mask                                              (0x00000004)
+#define MIPI_DPHY_REG3_L2_deglitch(data)                                             (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG3_L2_deglitch_src(data)                                         ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG3_get_L2_deglitch(data)                                         ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG3_L1_deglitch_shift                                             (1)
+#define MIPI_DPHY_REG3_L1_deglitch_mask                                              (0x00000002)
+#define MIPI_DPHY_REG3_L1_deglitch(data)                                             (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG3_L1_deglitch_src(data)                                         ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG3_get_L1_deglitch(data)                                         ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG3_L0_deglitch_shift                                             (0)
+#define MIPI_DPHY_REG3_L0_deglitch_mask                                              (0x00000001)
+#define MIPI_DPHY_REG3_L0_deglitch(data)                                             (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG3_L0_deglitch_src(data)                                         ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG3_get_L0_deglitch(data)                                         ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG4                                                               0x18004098
+#define MIPI_DPHY_REG4_reg_addr                                                      "0xB8004098"
+#define MIPI_DPHY_REG4_reg                                                           0xB8004098
+#define set_MIPI_DPHY_REG4_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG4_reg)=data)
+#define get_MIPI_DPHY_REG4_reg   (*((volatile unsigned int*) MIPI_DPHY_REG4_reg))
+#define MIPI_DPHY_REG4_inst_adr                                                      "0x0026"
+#define MIPI_DPHY_REG4_inst                                                          0x0026
+#define MIPI_DPHY_REG4_SL_RG_shift                                                   (3)
+#define MIPI_DPHY_REG4_SL_RG_mask                                                    (0x00000008)
+#define MIPI_DPHY_REG4_SL_RG(data)                                                   (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG4_SL_RG_src(data)                                               ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG4_get_SL_RG(data)                                               ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG4_Sw_rst_shift                                                  (0)
+#define MIPI_DPHY_REG4_Sw_rst_mask                                                   (0x00000001)
+#define MIPI_DPHY_REG4_Sw_rst(data)                                                  (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG4_Sw_rst_src(data)                                              ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG4_get_Sw_rst(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG5                                                               0x1800409C
+#define MIPI_DPHY_REG5_reg_addr                                                      "0xB800409C"
+#define MIPI_DPHY_REG5_reg                                                           0xB800409C
+#define set_MIPI_DPHY_REG5_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG5_reg)=data)
+#define get_MIPI_DPHY_REG5_reg   (*((volatile unsigned int*) MIPI_DPHY_REG5_reg))
+#define MIPI_DPHY_REG5_inst_adr                                                      "0x0027"
+#define MIPI_DPHY_REG5_inst                                                          0x0027
+#define MIPI_DPHY_REG5_Bit_switch_en_shift                                           (3)
+#define MIPI_DPHY_REG5_Bit_switch_en_mask                                            (0x00000008)
+#define MIPI_DPHY_REG5_Bit_switch_en(data)                                           (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG5_Bit_switch_en_src(data)                                       ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG5_get_Bit_switch_en(data)                                       ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG5_Crc16_en_shift                                                (2)
+#define MIPI_DPHY_REG5_Crc16_en_mask                                                 (0x00000004)
+#define MIPI_DPHY_REG5_Crc16_en(data)                                                (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG5_Crc16_en_src(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG5_get_Crc16_en(data)                                            ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG5_Ecc_en_shift                                                  (1)
+#define MIPI_DPHY_REG5_Ecc_en_mask                                                   (0x00000002)
+#define MIPI_DPHY_REG5_Ecc_en(data)                                                  (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG5_Ecc_en_src(data)                                              ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG5_get_Ecc_en(data)                                              ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG5_Con_clk_lane_en_shift                                         (0)
+#define MIPI_DPHY_REG5_Con_clk_lane_en_mask                                          (0x00000001)
+#define MIPI_DPHY_REG5_Con_clk_lane_en(data)                                         (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG5_Con_clk_lane_en_src(data)                                     ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG5_get_Con_clk_lane_en(data)                                     ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG6                                                               0x180040A0
+#define MIPI_DPHY_REG6_reg_addr                                                      "0xB80040A0"
+#define MIPI_DPHY_REG6_reg                                                           0xB80040A0
+#define set_MIPI_DPHY_REG6_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG6_reg)=data)
+#define get_MIPI_DPHY_REG6_reg   (*((volatile unsigned int*) MIPI_DPHY_REG6_reg))
+#define MIPI_DPHY_REG6_inst_adr                                                      "0x0028"
+#define MIPI_DPHY_REG6_inst                                                          0x0028
+#define MIPI_DPHY_REG6_Dvld_lane1_shift                                              (4)
+#define MIPI_DPHY_REG6_Dvld_lane1_mask                                               (0x000000F0)
+#define MIPI_DPHY_REG6_Dvld_lane1(data)                                              (0x000000F0&((data)<<4))
+#define MIPI_DPHY_REG6_Dvld_lane1_src(data)                                          ((0x000000F0&(data))>>4)
+#define MIPI_DPHY_REG6_get_Dvld_lane1(data)                                          ((0x000000F0&(data))>>4)
+#define MIPI_DPHY_REG6_Dvld_lane0_shift                                              (0)
+#define MIPI_DPHY_REG6_Dvld_lane0_mask                                               (0x0000000F)
+#define MIPI_DPHY_REG6_Dvld_lane0(data)                                              (0x0000000F&((data)<<0))
+#define MIPI_DPHY_REG6_Dvld_lane0_src(data)                                          ((0x0000000F&(data))>>0)
+#define MIPI_DPHY_REG6_get_Dvld_lane0(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define MIPI_DPHY_REG7                                                               0x180040A4
+#define MIPI_DPHY_REG7_reg_addr                                                      "0xB80040A4"
+#define MIPI_DPHY_REG7_reg                                                           0xB80040A4
+#define set_MIPI_DPHY_REG7_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG7_reg)=data)
+#define get_MIPI_DPHY_REG7_reg   (*((volatile unsigned int*) MIPI_DPHY_REG7_reg))
+#define MIPI_DPHY_REG7_inst_adr                                                      "0x0029"
+#define MIPI_DPHY_REG7_inst                                                          0x0029
+#define MIPI_DPHY_REG7_Dvld_lane3_shift                                              (4)
+#define MIPI_DPHY_REG7_Dvld_lane3_mask                                               (0x000000F0)
+#define MIPI_DPHY_REG7_Dvld_lane3(data)                                              (0x000000F0&((data)<<4))
+#define MIPI_DPHY_REG7_Dvld_lane3_src(data)                                          ((0x000000F0&(data))>>4)
+#define MIPI_DPHY_REG7_get_Dvld_lane3(data)                                          ((0x000000F0&(data))>>4)
+#define MIPI_DPHY_REG7_Dvld_lane2_shift                                              (0)
+#define MIPI_DPHY_REG7_Dvld_lane2_mask                                               (0x0000000F)
+#define MIPI_DPHY_REG7_Dvld_lane2(data)                                              (0x0000000F&((data)<<0))
+#define MIPI_DPHY_REG7_Dvld_lane2_src(data)                                          ((0x0000000F&(data))>>0)
+#define MIPI_DPHY_REG7_get_Dvld_lane2(data)                                          ((0x0000000F&(data))>>0)
+
+
+#define MIPI_DPHY_REG8                                                               0x180040A8
+#define MIPI_DPHY_REG8_reg_addr                                                      "0xB80040A8"
+#define MIPI_DPHY_REG8_reg                                                           0xB80040A8
+#define set_MIPI_DPHY_REG8_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG8_reg)=data)
+#define get_MIPI_DPHY_REG8_reg   (*((volatile unsigned int*) MIPI_DPHY_REG8_reg))
+#define MIPI_DPHY_REG8_inst_adr                                                      "0x002A"
+#define MIPI_DPHY_REG8_inst                                                          0x002A
+#define MIPI_DPHY_REG8_Lane3_sel_shift                                               (6)
+#define MIPI_DPHY_REG8_Lane3_sel_mask                                                (0x000000C0)
+#define MIPI_DPHY_REG8_Lane3_sel(data)                                               (0x000000C0&((data)<<6))
+#define MIPI_DPHY_REG8_Lane3_sel_src(data)                                           ((0x000000C0&(data))>>6)
+#define MIPI_DPHY_REG8_get_Lane3_sel(data)                                           ((0x000000C0&(data))>>6)
+#define MIPI_DPHY_REG8_Lane2_sel_shift                                               (4)
+#define MIPI_DPHY_REG8_Lane2_sel_mask                                                (0x00000030)
+#define MIPI_DPHY_REG8_Lane2_sel(data)                                               (0x00000030&((data)<<4))
+#define MIPI_DPHY_REG8_Lane2_sel_src(data)                                           ((0x00000030&(data))>>4)
+#define MIPI_DPHY_REG8_get_Lane2_sel(data)                                           ((0x00000030&(data))>>4)
+#define MIPI_DPHY_REG8_Lane1_sel_shift                                               (2)
+#define MIPI_DPHY_REG8_Lane1_sel_mask                                                (0x0000000C)
+#define MIPI_DPHY_REG8_Lane1_sel(data)                                               (0x0000000C&((data)<<2))
+#define MIPI_DPHY_REG8_Lane1_sel_src(data)                                           ((0x0000000C&(data))>>2)
+#define MIPI_DPHY_REG8_get_Lane1_sel(data)                                           ((0x0000000C&(data))>>2)
+#define MIPI_DPHY_REG8_Lane0_sel_shift                                               (0)
+#define MIPI_DPHY_REG8_Lane0_sel_mask                                                (0x00000003)
+#define MIPI_DPHY_REG8_Lane0_sel(data)                                               (0x00000003&((data)<<0))
+#define MIPI_DPHY_REG8_Lane0_sel_src(data)                                           ((0x00000003&(data))>>0)
+#define MIPI_DPHY_REG8_get_Lane0_sel(data)                                           ((0x00000003&(data))>>0)
+
+
+#define MIPI_DPHY_REG9                                                               0x180040AC
+#define MIPI_DPHY_REG9_reg_addr                                                      "0xB80040AC"
+#define MIPI_DPHY_REG9_reg                                                           0xB80040AC
+#define set_MIPI_DPHY_REG9_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG9_reg)=data)
+#define get_MIPI_DPHY_REG9_reg   (*((volatile unsigned int*) MIPI_DPHY_REG9_reg))
+#define MIPI_DPHY_REG9_inst_adr                                                      "0x002B"
+#define MIPI_DPHY_REG9_inst                                                          0x002B
+#define MIPI_DPHY_REG9_Lane3_clk_edge_shift                                          (3)
+#define MIPI_DPHY_REG9_Lane3_clk_edge_mask                                           (0x00000008)
+#define MIPI_DPHY_REG9_Lane3_clk_edge(data)                                          (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG9_Lane3_clk_edge_src(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG9_get_Lane3_clk_edge(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG9_Lane2_clk_edge_shift                                          (2)
+#define MIPI_DPHY_REG9_Lane2_clk_edge_mask                                           (0x00000004)
+#define MIPI_DPHY_REG9_Lane2_clk_edge(data)                                          (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG9_Lane2_clk_edge_src(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG9_get_Lane2_clk_edge(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG9_Lane1_clk_edge_shift                                          (1)
+#define MIPI_DPHY_REG9_Lane1_clk_edge_mask                                           (0x00000002)
+#define MIPI_DPHY_REG9_Lane1_clk_edge(data)                                          (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG9_Lane1_clk_edge_src(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG9_get_Lane1_clk_edge(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG9_Lane0_clk_edge_shift                                          (0)
+#define MIPI_DPHY_REG9_Lane0_clk_edge_mask                                           (0x00000001)
+#define MIPI_DPHY_REG9_Lane0_clk_edge(data)                                          (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG9_Lane0_clk_edge_src(data)                                      ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG9_get_Lane0_clk_edge(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG10                                                              0x180040B0
+#define MIPI_DPHY_REG10_reg_addr                                                     "0xB80040B0"
+#define MIPI_DPHY_REG10_reg                                                          0xB80040B0
+#define set_MIPI_DPHY_REG10_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG10_reg)=data)
+#define get_MIPI_DPHY_REG10_reg   (*((volatile unsigned int*) MIPI_DPHY_REG10_reg))
+#define MIPI_DPHY_REG10_inst_adr                                                     "0x002C"
+#define MIPI_DPHY_REG10_inst                                                         0x002C
+#define MIPI_DPHY_REG10_Esc_lane3_int_en_shift                                       (7)
+#define MIPI_DPHY_REG10_Esc_lane3_int_en_mask                                        (0x00000080)
+#define MIPI_DPHY_REG10_Esc_lane3_int_en(data)                                       (0x00000080&((data)<<7))
+#define MIPI_DPHY_REG10_Esc_lane3_int_en_src(data)                                   ((0x00000080&(data))>>7)
+#define MIPI_DPHY_REG10_get_Esc_lane3_int_en(data)                                   ((0x00000080&(data))>>7)
+#define MIPI_DPHY_REG10_Esc_lane2_int_en_shift                                       (6)
+#define MIPI_DPHY_REG10_Esc_lane2_int_en_mask                                        (0x00000040)
+#define MIPI_DPHY_REG10_Esc_lane2_int_en(data)                                       (0x00000040&((data)<<6))
+#define MIPI_DPHY_REG10_Esc_lane2_int_en_src(data)                                   ((0x00000040&(data))>>6)
+#define MIPI_DPHY_REG10_get_Esc_lane2_int_en(data)                                   ((0x00000040&(data))>>6)
+#define MIPI_DPHY_REG10_Esc_lane1_int_en_shift                                       (5)
+#define MIPI_DPHY_REG10_Esc_lane1_int_en_mask                                        (0x00000020)
+#define MIPI_DPHY_REG10_Esc_lane1_int_en(data)                                       (0x00000020&((data)<<5))
+#define MIPI_DPHY_REG10_Esc_lane1_int_en_src(data)                                   ((0x00000020&(data))>>5)
+#define MIPI_DPHY_REG10_get_Esc_lane1_int_en(data)                                   ((0x00000020&(data))>>5)
+#define MIPI_DPHY_REG10_Esc_lane0_int_en_shift                                       (4)
+#define MIPI_DPHY_REG10_Esc_lane0_int_en_mask                                        (0x00000010)
+#define MIPI_DPHY_REG10_Esc_lane0_int_en(data)                                       (0x00000010&((data)<<4))
+#define MIPI_DPHY_REG10_Esc_lane0_int_en_src(data)                                   ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG10_get_Esc_lane0_int_en(data)                                   ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG10_Clk_ulps_int_en_shift                                        (3)
+#define MIPI_DPHY_REG10_Clk_ulps_int_en_mask                                         (0x00000008)
+#define MIPI_DPHY_REG10_Clk_ulps_int_en(data)                                        (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG10_Clk_ulps_int_en_src(data)                                    ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG10_get_Clk_ulps_int_en(data)                                    ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG10_Crc16_err_int_en_shift                                       (2)
+#define MIPI_DPHY_REG10_Crc16_err_int_en_mask                                        (0x00000004)
+#define MIPI_DPHY_REG10_Crc16_err_int_en(data)                                       (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG10_Crc16_err_int_en_src(data)                                   ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG10_get_Crc16_err_int_en(data)                                   ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG10_Ecc_crt_int_en_shift                                         (1)
+#define MIPI_DPHY_REG10_Ecc_crt_int_en_mask                                          (0x00000002)
+#define MIPI_DPHY_REG10_Ecc_crt_int_en(data)                                         (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG10_Ecc_crt_int_en_src(data)                                     ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG10_get_Ecc_crt_int_en(data)                                     ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG10_Ecc_err_int_en_shift                                         (0)
+#define MIPI_DPHY_REG10_Ecc_err_int_en_mask                                          (0x00000001)
+#define MIPI_DPHY_REG10_Ecc_err_int_en(data)                                         (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG10_Ecc_err_int_en_src(data)                                     ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG10_get_Ecc_err_int_en(data)                                     ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG11                                                              0x180040B4
+#define MIPI_DPHY_REG11_reg_addr                                                     "0xB80040B4"
+#define MIPI_DPHY_REG11_reg                                                          0xB80040B4
+#define set_MIPI_DPHY_REG11_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG11_reg)=data)
+#define get_MIPI_DPHY_REG11_reg   (*((volatile unsigned int*) MIPI_DPHY_REG11_reg))
+#define MIPI_DPHY_REG11_inst_adr                                                     "0x002D"
+#define MIPI_DPHY_REG11_inst                                                         0x002D
+#define MIPI_DPHY_REG11_Esc_lane3_int_flg_shift                                      (7)
+#define MIPI_DPHY_REG11_Esc_lane3_int_flg_mask                                       (0x00000080)
+#define MIPI_DPHY_REG11_Esc_lane3_int_flg(data)                                      (0x00000080&((data)<<7))
+#define MIPI_DPHY_REG11_Esc_lane3_int_flg_src(data)                                  ((0x00000080&(data))>>7)
+#define MIPI_DPHY_REG11_get_Esc_lane3_int_flg(data)                                  ((0x00000080&(data))>>7)
+#define MIPI_DPHY_REG11_Esc_lane2_int_flg_shift                                      (6)
+#define MIPI_DPHY_REG11_Esc_lane2_int_flg_mask                                       (0x00000040)
+#define MIPI_DPHY_REG11_Esc_lane2_int_flg(data)                                      (0x00000040&((data)<<6))
+#define MIPI_DPHY_REG11_Esc_lane2_int_flg_src(data)                                  ((0x00000040&(data))>>6)
+#define MIPI_DPHY_REG11_get_Esc_lane2_int_flg(data)                                  ((0x00000040&(data))>>6)
+#define MIPI_DPHY_REG11_Esc_lane1_int_flg_shift                                      (5)
+#define MIPI_DPHY_REG11_Esc_lane1_int_flg_mask                                       (0x00000020)
+#define MIPI_DPHY_REG11_Esc_lane1_int_flg(data)                                      (0x00000020&((data)<<5))
+#define MIPI_DPHY_REG11_Esc_lane1_int_flg_src(data)                                  ((0x00000020&(data))>>5)
+#define MIPI_DPHY_REG11_get_Esc_lane1_int_flg(data)                                  ((0x00000020&(data))>>5)
+#define MIPI_DPHY_REG11_Esc_lane0_int_flg_shift                                      (4)
+#define MIPI_DPHY_REG11_Esc_lane0_int_flg_mask                                       (0x00000010)
+#define MIPI_DPHY_REG11_Esc_lane0_int_flg(data)                                      (0x00000010&((data)<<4))
+#define MIPI_DPHY_REG11_Esc_lane0_int_flg_src(data)                                  ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG11_get_Esc_lane0_int_flg(data)                                  ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG11_Clk_ulps_int_flg_shift                                       (3)
+#define MIPI_DPHY_REG11_Clk_ulps_int_flg_mask                                        (0x00000008)
+#define MIPI_DPHY_REG11_Clk_ulps_int_flg(data)                                       (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG11_Clk_ulps_int_flg_src(data)                                   ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG11_get_Clk_ulps_int_flg(data)                                   ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG11_Crc16_err_int_flg_shift                                      (2)
+#define MIPI_DPHY_REG11_Crc16_err_int_flg_mask                                       (0x00000004)
+#define MIPI_DPHY_REG11_Crc16_err_int_flg(data)                                      (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG11_Crc16_err_int_flg_src(data)                                  ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG11_get_Crc16_err_int_flg(data)                                  ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG11_Ecc_crt_int_flg_shift                                        (1)
+#define MIPI_DPHY_REG11_Ecc_crt_int_flg_mask                                         (0x00000002)
+#define MIPI_DPHY_REG11_Ecc_crt_int_flg(data)                                        (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG11_Ecc_crt_int_flg_src(data)                                    ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG11_get_Ecc_crt_int_flg(data)                                    ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG11_Ecc_err_int_flg_shift                                        (0)
+#define MIPI_DPHY_REG11_Ecc_err_int_flg_mask                                         (0x00000001)
+#define MIPI_DPHY_REG11_Ecc_err_int_flg(data)                                        (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG11_Ecc_err_int_flg_src(data)                                    ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG11_get_Ecc_err_int_flg(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG12                                                              0x180040B8
+#define MIPI_DPHY_REG12_reg_addr                                                     "0xB80040B8"
+#define MIPI_DPHY_REG12_reg                                                          0xB80040B8
+#define set_MIPI_DPHY_REG12_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG12_reg)=data)
+#define get_MIPI_DPHY_REG12_reg   (*((volatile unsigned int*) MIPI_DPHY_REG12_reg))
+#define MIPI_DPHY_REG12_inst_adr                                                     "0x002E"
+#define MIPI_DPHY_REG12_inst                                                         0x002E
+#define MIPI_DPHY_REG12_Num_ecc_err_shift                                            (0)
+#define MIPI_DPHY_REG12_Num_ecc_err_mask                                             (0x000000FF)
+#define MIPI_DPHY_REG12_Num_ecc_err(data)                                            (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG12_Num_ecc_err_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG12_get_Num_ecc_err(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG13                                                              0x180040BC
+#define MIPI_DPHY_REG13_reg_addr                                                     "0xB80040BC"
+#define MIPI_DPHY_REG13_reg                                                          0xB80040BC
+#define set_MIPI_DPHY_REG13_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG13_reg)=data)
+#define get_MIPI_DPHY_REG13_reg   (*((volatile unsigned int*) MIPI_DPHY_REG13_reg))
+#define MIPI_DPHY_REG13_inst_adr                                                     "0x002F"
+#define MIPI_DPHY_REG13_inst                                                         0x002F
+#define MIPI_DPHY_REG13_Num_ecc_err_shift                                            (0)
+#define MIPI_DPHY_REG13_Num_ecc_err_mask                                             (0x000000FF)
+#define MIPI_DPHY_REG13_Num_ecc_err(data)                                            (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG13_Num_ecc_err_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG13_get_Num_ecc_err(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG14                                                              0x180040C0
+#define MIPI_DPHY_REG14_reg_addr                                                     "0xB80040C0"
+#define MIPI_DPHY_REG14_reg                                                          0xB80040C0
+#define set_MIPI_DPHY_REG14_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG14_reg)=data)
+#define get_MIPI_DPHY_REG14_reg   (*((volatile unsigned int*) MIPI_DPHY_REG14_reg))
+#define MIPI_DPHY_REG14_inst_adr                                                     "0x0030"
+#define MIPI_DPHY_REG14_inst                                                         0x0030
+#define MIPI_DPHY_REG14_Num_crc_err_shift                                            (0)
+#define MIPI_DPHY_REG14_Num_crc_err_mask                                             (0x000000FF)
+#define MIPI_DPHY_REG14_Num_crc_err(data)                                            (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG14_Num_crc_err_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG14_get_Num_crc_err(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG15                                                              0x180040C4
+#define MIPI_DPHY_REG15_reg_addr                                                     "0xB80040C4"
+#define MIPI_DPHY_REG15_reg                                                          0xB80040C4
+#define set_MIPI_DPHY_REG15_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG15_reg)=data)
+#define get_MIPI_DPHY_REG15_reg   (*((volatile unsigned int*) MIPI_DPHY_REG15_reg))
+#define MIPI_DPHY_REG15_inst_adr                                                     "0x0031"
+#define MIPI_DPHY_REG15_inst                                                         0x0031
+#define MIPI_DPHY_REG15_Num_crc_err_shift                                            (0)
+#define MIPI_DPHY_REG15_Num_crc_err_mask                                             (0x000000FF)
+#define MIPI_DPHY_REG15_Num_crc_err(data)                                            (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG15_Num_crc_err_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG15_get_Num_crc_err(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG16                                                              0x180040C8
+#define MIPI_DPHY_REG16_reg_addr                                                     "0xB80040C8"
+#define MIPI_DPHY_REG16_reg                                                          0xB80040C8
+#define set_MIPI_DPHY_REG16_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG16_reg)=data)
+#define get_MIPI_DPHY_REG16_reg   (*((volatile unsigned int*) MIPI_DPHY_REG16_reg))
+#define MIPI_DPHY_REG16_inst_adr                                                     "0x0032"
+#define MIPI_DPHY_REG16_inst                                                         0x0032
+#define MIPI_DPHY_REG16_Clk_term_en_shift                                            (4)
+#define MIPI_DPHY_REG16_Clk_term_en_mask                                             (0x00000010)
+#define MIPI_DPHY_REG16_Clk_term_en(data)                                            (0x00000010&((data)<<4))
+#define MIPI_DPHY_REG16_Clk_term_en_src(data)                                        ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG16_get_Clk_term_en(data)                                        ((0x00000010&(data))>>4)
+#define MIPI_DPHY_REG16_Lane3_term_en_shift                                          (3)
+#define MIPI_DPHY_REG16_Lane3_term_en_mask                                           (0x00000008)
+#define MIPI_DPHY_REG16_Lane3_term_en(data)                                          (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG16_Lane3_term_en_src(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG16_get_Lane3_term_en(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG16_Lane2_term_en_shift                                          (2)
+#define MIPI_DPHY_REG16_Lane2_term_en_mask                                           (0x00000004)
+#define MIPI_DPHY_REG16_Lane2_term_en(data)                                          (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG16_Lane2_term_en_src(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG16_get_Lane2_term_en(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG16_Lane1_term_en_shift                                          (1)
+#define MIPI_DPHY_REG16_Lane1_term_en_mask                                           (0x00000002)
+#define MIPI_DPHY_REG16_Lane1_term_en(data)                                          (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG16_Lane1_term_en_src(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG16_get_Lane1_term_en(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG16_Lane0_term_en_shift                                          (0)
+#define MIPI_DPHY_REG16_Lane0_term_en_mask                                           (0x00000001)
+#define MIPI_DPHY_REG16_Lane0_term_en(data)                                          (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG16_Lane0_term_en_src(data)                                      ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG16_get_Lane0_term_en(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG17                                                              0x180040CC
+#define MIPI_DPHY_REG17_reg_addr                                                     "0xB80040CC"
+#define MIPI_DPHY_REG17_reg                                                          0xB80040CC
+#define set_MIPI_DPHY_REG17_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG17_reg)=data)
+#define get_MIPI_DPHY_REG17_reg   (*((volatile unsigned int*) MIPI_DPHY_REG17_reg))
+#define MIPI_DPHY_REG17_inst_adr                                                     "0x0033"
+#define MIPI_DPHY_REG17_inst                                                         0x0033
+#define MIPI_DPHY_REG17_Lane3_pwdb_en_shift                                          (3)
+#define MIPI_DPHY_REG17_Lane3_pwdb_en_mask                                           (0x00000008)
+#define MIPI_DPHY_REG17_Lane3_pwdb_en(data)                                          (0x00000008&((data)<<3))
+#define MIPI_DPHY_REG17_Lane3_pwdb_en_src(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG17_get_Lane3_pwdb_en(data)                                      ((0x00000008&(data))>>3)
+#define MIPI_DPHY_REG17_Lane2_pwdb_en_shift                                          (2)
+#define MIPI_DPHY_REG17_Lane2_pwdb_en_mask                                           (0x00000004)
+#define MIPI_DPHY_REG17_Lane2_pwdb_en(data)                                          (0x00000004&((data)<<2))
+#define MIPI_DPHY_REG17_Lane2_pwdb_en_src(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG17_get_Lane2_pwdb_en(data)                                      ((0x00000004&(data))>>2)
+#define MIPI_DPHY_REG17_Lane1_pwdb_en_shift                                          (1)
+#define MIPI_DPHY_REG17_Lane1_pwdb_en_mask                                           (0x00000002)
+#define MIPI_DPHY_REG17_Lane1_pwdb_en(data)                                          (0x00000002&((data)<<1))
+#define MIPI_DPHY_REG17_Lane1_pwdb_en_src(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG17_get_Lane1_pwdb_en(data)                                      ((0x00000002&(data))>>1)
+#define MIPI_DPHY_REG17_Lane0_pwdb_en_shift                                          (0)
+#define MIPI_DPHY_REG17_Lane0_pwdb_en_mask                                           (0x00000001)
+#define MIPI_DPHY_REG17_Lane0_pwdb_en(data)                                          (0x00000001&((data)<<0))
+#define MIPI_DPHY_REG17_Lane0_pwdb_en_src(data)                                      ((0x00000001&(data))>>0)
+#define MIPI_DPHY_REG17_get_Lane0_pwdb_en(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIPI_DPHY_REG18                                                              0x180040D0
+#define MIPI_DPHY_REG18_reg_addr                                                     "0xB80040D0"
+#define MIPI_DPHY_REG18_reg                                                          0xB80040D0
+#define set_MIPI_DPHY_REG18_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG18_reg)=data)
+#define get_MIPI_DPHY_REG18_reg   (*((volatile unsigned int*) MIPI_DPHY_REG18_reg))
+#define MIPI_DPHY_REG18_inst_adr                                                     "0x0034"
+#define MIPI_DPHY_REG18_inst                                                         0x0034
+
+
+#define MIPI_DPHY_REG19                                                              0x180040D4
+#define MIPI_DPHY_REG19_reg_addr                                                     "0xB80040D4"
+#define MIPI_DPHY_REG19_reg                                                          0xB80040D4
+#define set_MIPI_DPHY_REG19_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG19_reg)=data)
+#define get_MIPI_DPHY_REG19_reg   (*((volatile unsigned int*) MIPI_DPHY_REG19_reg))
+#define MIPI_DPHY_REG19_inst_adr                                                     "0x0035"
+#define MIPI_DPHY_REG19_inst                                                         0x0035
+
+
+#define MIPI_DPHY_REG20                                                              0x180040D8
+#define MIPI_DPHY_REG20_reg_addr                                                     "0xB80040D8"
+#define MIPI_DPHY_REG20_reg                                                          0xB80040D8
+#define set_MIPI_DPHY_REG20_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG20_reg)=data)
+#define get_MIPI_DPHY_REG20_reg   (*((volatile unsigned int*) MIPI_DPHY_REG20_reg))
+#define MIPI_DPHY_REG20_inst_adr                                                     "0x0036"
+#define MIPI_DPHY_REG20_inst                                                         0x0036
+#define MIPI_DPHY_REG20_Lane0_esc_cod_shift                                          (0)
+#define MIPI_DPHY_REG20_Lane0_esc_cod_mask                                           (0x000000FF)
+#define MIPI_DPHY_REG20_Lane0_esc_cod(data)                                          (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG20_Lane0_esc_cod_src(data)                                      ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG20_get_Lane0_esc_cod(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG21                                                              0x180040DC
+#define MIPI_DPHY_REG21_reg_addr                                                     "0xB80040DC"
+#define MIPI_DPHY_REG21_reg                                                          0xB80040DC
+#define set_MIPI_DPHY_REG21_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG21_reg)=data)
+#define get_MIPI_DPHY_REG21_reg   (*((volatile unsigned int*) MIPI_DPHY_REG21_reg))
+#define MIPI_DPHY_REG21_inst_adr                                                     "0x0037"
+#define MIPI_DPHY_REG21_inst                                                         0x0037
+#define MIPI_DPHY_REG21_Lane1_esc_cod_shift                                          (0)
+#define MIPI_DPHY_REG21_Lane1_esc_cod_mask                                           (0x000000FF)
+#define MIPI_DPHY_REG21_Lane1_esc_cod(data)                                          (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG21_Lane1_esc_cod_src(data)                                      ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG21_get_Lane1_esc_cod(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG22                                                              0x180040E0
+#define MIPI_DPHY_REG22_reg_addr                                                     "0xB80040E0"
+#define MIPI_DPHY_REG22_reg                                                          0xB80040E0
+#define set_MIPI_DPHY_REG22_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG22_reg)=data)
+#define get_MIPI_DPHY_REG22_reg   (*((volatile unsigned int*) MIPI_DPHY_REG22_reg))
+#define MIPI_DPHY_REG22_inst_adr                                                     "0x0038"
+#define MIPI_DPHY_REG22_inst                                                         0x0038
+#define MIPI_DPHY_REG22_Lane2_esc_cod_shift                                          (0)
+#define MIPI_DPHY_REG22_Lane2_esc_cod_mask                                           (0x000000FF)
+#define MIPI_DPHY_REG22_Lane2_esc_cod(data)                                          (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG22_Lane2_esc_cod_src(data)                                      ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG22_get_Lane2_esc_cod(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define MIPI_DPHY_REG23                                                              0x180040E4
+#define MIPI_DPHY_REG23_reg_addr                                                     "0xB80040E4"
+#define MIPI_DPHY_REG23_reg                                                          0xB80040E4
+#define set_MIPI_DPHY_REG23_reg(data)   (*((volatile unsigned int*) MIPI_DPHY_REG23_reg)=data)
+#define get_MIPI_DPHY_REG23_reg   (*((volatile unsigned int*) MIPI_DPHY_REG23_reg))
+#define MIPI_DPHY_REG23_inst_adr                                                     "0x0039"
+#define MIPI_DPHY_REG23_inst                                                         0x0039
+#define MIPI_DPHY_REG23_Lane3_esc_cod_shift                                          (0)
+#define MIPI_DPHY_REG23_Lane3_esc_cod_mask                                           (0x000000FF)
+#define MIPI_DPHY_REG23_Lane3_esc_cod(data)                                          (0x000000FF&((data)<<0))
+#define MIPI_DPHY_REG23_Lane3_esc_cod_src(data)                                      ((0x000000FF&(data))>>0)
+#define MIPI_DPHY_REG23_get_Lane3_esc_cod(data)                                      ((0x000000FF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/mipi_wrapper_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mipi_wrapper_reg.h
new file mode 100644
index 00000000..f543063
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mipi_wrapper_reg.h
@@ -0,0 +1,1838 @@
+/**************************************************************
+// Spec Version                  : unknown
+// Parser Version                : DVR_Parser_6.5
+// CModelGen Version             : 5.0 2009.04.09
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/8/14 9:16:18
+***************************************************************/
+
+
+#ifndef _MIPI_WRAPPER_REG_H_INCLUDED_
+#define _MIPI_WRAPPER_REG_H_INCLUDED_
+#ifdef  _MIPI_WRAPPER_USE_STRUCT
+typedef struct 
+{
+unsigned int     dst_fmt:5;
+unsigned int     src_fmt:2;
+unsigned int     src_sel:1;
+unsigned int     seq_en:1;
+unsigned int     vs:1;
+unsigned int     vs_near:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     hs:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     reserved_0:3;
+unsigned int     yuv_to_rgb:1;
+unsigned int     chroma_ds_mode:1;
+unsigned int     chroma_ds_en:1;
+unsigned int     chroma_us_mode:1;
+unsigned int     chroma_us_en:1;
+unsigned int     hdmirx_interlace_en:1;
+unsigned int     hdmirx_interlace_polarity:1;
+unsigned int     int_en4:1;
+unsigned int     int_en3:1;
+unsigned int     int_en2:1;
+unsigned int     int_en1:1;
+unsigned int     int_en0:1;
+unsigned int     en:1;
+}MIPI;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sa0_video:31;
+}MIPI_SA0;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sa1_video:31;
+}MIPI_SA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sa2_pic:31;
+}MIPI_SA2;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     dst_width_video:13;
+unsigned int     pitch_video:16;
+}MIPI_SIZE0;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     dst_width_pic:13;
+unsigned int     pitch_pic:16;
+}MIPI_SIZE1;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     src_width_pic:13;
+unsigned int     reserved_1:3;
+unsigned int     src_width_video:13;
+}MIPI_SIZE2;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     index_y0_video:7;
+unsigned int     reserved_1:9;
+unsigned int     index_c0_video:7;
+}MIPI_INDEX0;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     index_y1_video:7;
+unsigned int     reserved_1:9;
+unsigned int     index_c1_video:7;
+}MIPI_INDEX1;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     index_y2_pic:7;
+unsigned int     reserved_1:9;
+unsigned int     index_c2_pic:7;
+}MIPI_INDEX2;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     mipi_data_valid:1;
+unsigned int     mipi_line_end:1;
+unsigned int     mipi_line_start:1;
+unsigned int     mipi_frame_end:1;
+unsigned int     mipi_frame_start:1;
+unsigned int     esc_lane3_int_flg:1;
+unsigned int     esc_lane2_int_flg:1;
+unsigned int     esc_lane1_int_flg:1;
+unsigned int     esc_lane0_int_flg:1;
+unsigned int     clk_ulps_int_flg:1;
+unsigned int     crc16_err_int_flg:1;
+unsigned int     ecc_crt_int_flg:1;
+unsigned int     ecc_err_int_flg:1;
+unsigned int     reserved_1:2;
+unsigned int     overflow_drop:1;
+unsigned int     fm_drop:1;
+unsigned int     fm_done2:1;
+unsigned int     fm_done1:1;
+unsigned int     fm_done0:1;
+unsigned int     write_data:1;
+}MIPI_INT_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     mipi_type:1;
+}MIPI_TYPE;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     cs_trans0_c1:17;
+}CS_TRANS0;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     cs_trans1_c2:17;
+}CS_TRANS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     cs_trans2_c3:17;
+}CS_TRANS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     cs_trans3_c4:17;
+}CS_TRANS3;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     cs_trans4_c5:17;
+}CS_TRANS4;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     cs_trans5_c6:17;
+}CS_TRANS5;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     cs_trans6_c7:17;
+}CS_TRANS6;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     cs_trans7_c8:17;
+}CS_TRANS7;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     cs_trans8_c9:17;
+}CS_TRANS8;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     cs_trans9_k1:16;
+}CS_TRANS9;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     cs_trans10_k2:16;
+}CS_TRANS10;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     cs_trans11_k3:16;
+}CS_TRANS11;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     hsi_offset:11;
+unsigned int     hsi_phase:14;
+unsigned int     reserved_1:2;
+}SCALER_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     hsd_out:11;
+unsigned int     reserved_1:1;
+unsigned int     hsd_delta:19;
+}SCALER_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     vsi_offset:12;
+unsigned int     vsi_phase:14;
+unsigned int     reserved_1:2;
+}SCALER_VSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     vsd_out:11;
+unsigned int     reserved_1:1;
+unsigned int     vsd_delta:19;
+}SCALER_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hsync0_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hsync0_c0:14;
+}SCALER_HSYNC0;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hsync1_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hsync1_c0:14;
+}SCALER_HSYNC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hsync2_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hsync2_c0:14;
+}SCALER_HSYNC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hsync3_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hsync3_c0:14;
+}SCALER_HSYNC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hsync4_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hsync4_c0:14;
+}SCALER_HSYNC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hsync5_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hsync5_c0:14;
+}SCALER_HSYNC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hsync6_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hsync6_c0:14;
+}SCALER_HSYNC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hsync7_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hsync7_c0:14;
+}SCALER_HSYNC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hscc0_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hscc0_c0:14;
+}SCALER_HSCC0;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hscc1_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hscc1_c0:14;
+}SCALER_HSCC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hscc2_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hscc2_c0:14;
+}SCALER_HSCC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hscc3_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hscc3_c0:14;
+}SCALER_HSCC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hscc4_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hscc4_c0:14;
+}SCALER_HSCC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hscc5_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hscc5_c0:14;
+}SCALER_HSCC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hscc6_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hscc6_c0:14;
+}SCALER_HSCC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hscc7_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     hscc7_c0:14;
+}SCALER_HSCC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vsyc0_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     vsyc0_c0:14;
+}SCALER_VSYC0;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vsyc1_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     vsyc1_c0:14;
+}SCALER_VSYC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vsyc2_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     vsyc2_c0:14;
+}SCALER_VSYC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vsyc3_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     vsyc3_c0:14;
+}SCALER_VSYC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vscc0_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     vscc0_c0:14;
+}SCALER_VSCC0;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vscc1_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     vscc1_c0:14;
+}SCALER_VSCC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vscc2_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     vscc2_c0:14;
+}SCALER_VSCC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vscc3_c1:14;
+unsigned int     reserved_1:2;
+unsigned int     vscc3_c0:14;
+}SCALER_VSCC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     alpha:8;
+}CONSTANT_ALPHA;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     drf_test_resume:1;
+unsigned int     drf_bist_mode:1;
+unsigned int     bist_mode:1;
+}BIST_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     drf_start_pause:1;
+unsigned int     drf_bist_fail2:1;
+unsigned int     drf_bist_fail1:1;
+unsigned int     drf_bist_fail0:1;
+unsigned int     drf_bist_done:1;
+unsigned int     bist_fail2:1;
+unsigned int     bist_fail1:1;
+unsigned int     bist_fail0:1;
+unsigned int     bist_done:1;
+}BIST_RESULT0;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     sram_rm:4;
+unsigned int     sram_rme:1;
+}BIST_RESULT1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sa0_video_uv:31;
+}MIPI_SA0_UV;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sa1_video_uv:31;
+}MIPI_SA1_UV;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sa2_pic_uv:31;
+}MIPI_SA2_UV;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     mipi_sw_rst:1;
+}MIPI_RESET;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     dbg_sel:1;
+unsigned int     dbg_sel1:4;
+unsigned int     dbg_sel0:4;
+}BIST_RESULT1;
+
+typedef struct 
+{
+unsigned int     mipi_dummy_reg0:32;
+}MIPI_DUMMY_REG0;
+
+typedef struct 
+{
+unsigned int     mipi_dummy_reg1:32;
+}MIPI_DUMMY_REG1;
+
+#endif
+
+#define MIPI                                                                         0x18004100
+#define MIPI_reg_addr                                                                "0xB8004100"
+#define MIPI_reg                                                                     0xB8004100
+#define set_MIPI_reg(data)   (*((volatile unsigned int*) MIPI_reg)=data)
+#define get_MIPI_reg   (*((volatile unsigned int*) MIPI_reg))
+#define MIPI_inst_adr                                                                "0x0040"
+#define MIPI_inst                                                                    0x0040
+#define MIPI_dst_fmt_shift                                                           (27)
+#define MIPI_dst_fmt_mask                                                            (0xF8000000)
+#define MIPI_dst_fmt(data)                                                           (0xF8000000&((data)<<27))
+#define MIPI_dst_fmt_src(data)                                                       ((0xF8000000&(data))>>27)
+#define MIPI_get_dst_fmt(data)                                                       ((0xF8000000&(data))>>27)
+#define MIPI_src_fmt_shift                                                           (25)
+#define MIPI_src_fmt_mask                                                            (0x06000000)
+#define MIPI_src_fmt(data)                                                           (0x06000000&((data)<<25))
+#define MIPI_src_fmt_src(data)                                                       ((0x06000000&(data))>>25)
+#define MIPI_get_src_fmt(data)                                                       ((0x06000000&(data))>>25)
+#define MIPI_src_sel_shift                                                           (24)
+#define MIPI_src_sel_mask                                                            (0x01000000)
+#define MIPI_src_sel(data)                                                           (0x01000000&((data)<<24))
+#define MIPI_src_sel_src(data)                                                       ((0x01000000&(data))>>24)
+#define MIPI_get_src_sel(data)                                                       ((0x01000000&(data))>>24)
+#define MIPI_seq_en_shift                                                            (23)
+#define MIPI_seq_en_mask                                                             (0x00800000)
+#define MIPI_seq_en(data)                                                            (0x00800000&((data)<<23))
+#define MIPI_seq_en_src(data)                                                        ((0x00800000&(data))>>23)
+#define MIPI_get_seq_en(data)                                                        ((0x00800000&(data))>>23)
+#define MIPI_vs_shift                                                                (22)
+#define MIPI_vs_mask                                                                 (0x00400000)
+#define MIPI_vs(data)                                                                (0x00400000&((data)<<22))
+#define MIPI_vs_src(data)                                                            ((0x00400000&(data))>>22)
+#define MIPI_get_vs(data)                                                            ((0x00400000&(data))>>22)
+#define MIPI_vs_near_shift                                                           (21)
+#define MIPI_vs_near_mask                                                            (0x00200000)
+#define MIPI_vs_near(data)                                                           (0x00200000&((data)<<21))
+#define MIPI_vs_near_src(data)                                                       ((0x00200000&(data))>>21)
+#define MIPI_get_vs_near(data)                                                       ((0x00200000&(data))>>21)
+#define MIPI_vs_yodd_shift                                                           (20)
+#define MIPI_vs_yodd_mask                                                            (0x00100000)
+#define MIPI_vs_yodd(data)                                                           (0x00100000&((data)<<20))
+#define MIPI_vs_yodd_src(data)                                                       ((0x00100000&(data))>>20)
+#define MIPI_get_vs_yodd(data)                                                       ((0x00100000&(data))>>20)
+#define MIPI_vs_codd_shift                                                           (19)
+#define MIPI_vs_codd_mask                                                            (0x00080000)
+#define MIPI_vs_codd(data)                                                           (0x00080000&((data)<<19))
+#define MIPI_vs_codd_src(data)                                                       ((0x00080000&(data))>>19)
+#define MIPI_get_vs_codd(data)                                                       ((0x00080000&(data))>>19)
+#define MIPI_hs_shift                                                                (18)
+#define MIPI_hs_mask                                                                 (0x00040000)
+#define MIPI_hs(data)                                                                (0x00040000&((data)<<18))
+#define MIPI_hs_src(data)                                                            ((0x00040000&(data))>>18)
+#define MIPI_get_hs(data)                                                            ((0x00040000&(data))>>18)
+#define MIPI_hs_yodd_shift                                                           (17)
+#define MIPI_hs_yodd_mask                                                            (0x00020000)
+#define MIPI_hs_yodd(data)                                                           (0x00020000&((data)<<17))
+#define MIPI_hs_yodd_src(data)                                                       ((0x00020000&(data))>>17)
+#define MIPI_get_hs_yodd(data)                                                       ((0x00020000&(data))>>17)
+#define MIPI_hs_codd_shift                                                           (16)
+#define MIPI_hs_codd_mask                                                            (0x00010000)
+#define MIPI_hs_codd(data)                                                           (0x00010000&((data)<<16))
+#define MIPI_hs_codd_src(data)                                                       ((0x00010000&(data))>>16)
+#define MIPI_get_hs_codd(data)                                                       ((0x00010000&(data))>>16)
+#define MIPI_yuv_to_rgb_shift                                                        (12)
+#define MIPI_yuv_to_rgb_mask                                                         (0x00001000)
+#define MIPI_yuv_to_rgb(data)                                                        (0x00001000&((data)<<12))
+#define MIPI_yuv_to_rgb_src(data)                                                    ((0x00001000&(data))>>12)
+#define MIPI_get_yuv_to_rgb(data)                                                    ((0x00001000&(data))>>12)
+#define MIPI_chroma_ds_mode_shift                                                    (11)
+#define MIPI_chroma_ds_mode_mask                                                     (0x00000800)
+#define MIPI_chroma_ds_mode(data)                                                    (0x00000800&((data)<<11))
+#define MIPI_chroma_ds_mode_src(data)                                                ((0x00000800&(data))>>11)
+#define MIPI_get_chroma_ds_mode(data)                                                ((0x00000800&(data))>>11)
+#define MIPI_chroma_ds_en_shift                                                      (10)
+#define MIPI_chroma_ds_en_mask                                                       (0x00000400)
+#define MIPI_chroma_ds_en(data)                                                      (0x00000400&((data)<<10))
+#define MIPI_chroma_ds_en_src(data)                                                  ((0x00000400&(data))>>10)
+#define MIPI_get_chroma_ds_en(data)                                                  ((0x00000400&(data))>>10)
+#define MIPI_chroma_us_mode_shift                                                    (9)
+#define MIPI_chroma_us_mode_mask                                                     (0x00000200)
+#define MIPI_chroma_us_mode(data)                                                    (0x00000200&((data)<<9))
+#define MIPI_chroma_us_mode_src(data)                                                ((0x00000200&(data))>>9)
+#define MIPI_get_chroma_us_mode(data)                                                ((0x00000200&(data))>>9)
+#define MIPI_chroma_us_en_shift                                                      (8)
+#define MIPI_chroma_us_en_mask                                                       (0x00000100)
+#define MIPI_chroma_us_en(data)                                                      (0x00000100&((data)<<8))
+#define MIPI_chroma_us_en_src(data)                                                  ((0x00000100&(data))>>8)
+#define MIPI_get_chroma_us_en(data)                                                  ((0x00000100&(data))>>8)
+#define MIPI_hdmirx_interlace_en_shift                                               (7)
+#define MIPI_hdmirx_interlace_en_mask                                                (0x00000080)
+#define MIPI_hdmirx_interlace_en(data)                                               (0x00000080&((data)<<7))
+#define MIPI_hdmirx_interlace_en_src(data)                                           ((0x00000080&(data))>>7)
+#define MIPI_get_hdmirx_interlace_en(data)                                           ((0x00000080&(data))>>7)
+#define MIPI_hdmirx_interlace_polarity_shift                                         (6)
+#define MIPI_hdmirx_interlace_polarity_mask                                          (0x00000040)
+#define MIPI_hdmirx_interlace_polarity(data)                                         (0x00000040&((data)<<6))
+#define MIPI_hdmirx_interlace_polarity_src(data)                                     ((0x00000040&(data))>>6)
+#define MIPI_get_hdmirx_interlace_polarity(data)                                     ((0x00000040&(data))>>6)
+#define MIPI_int_en4_shift                                                           (5)
+#define MIPI_int_en4_mask                                                            (0x00000020)
+#define MIPI_int_en4(data)                                                           (0x00000020&((data)<<5))
+#define MIPI_int_en4_src(data)                                                       ((0x00000020&(data))>>5)
+#define MIPI_get_int_en4(data)                                                       ((0x00000020&(data))>>5)
+#define MIPI_int_en3_shift                                                           (4)
+#define MIPI_int_en3_mask                                                            (0x00000010)
+#define MIPI_int_en3(data)                                                           (0x00000010&((data)<<4))
+#define MIPI_int_en3_src(data)                                                       ((0x00000010&(data))>>4)
+#define MIPI_get_int_en3(data)                                                       ((0x00000010&(data))>>4)
+#define MIPI_int_en2_shift                                                           (3)
+#define MIPI_int_en2_mask                                                            (0x00000008)
+#define MIPI_int_en2(data)                                                           (0x00000008&((data)<<3))
+#define MIPI_int_en2_src(data)                                                       ((0x00000008&(data))>>3)
+#define MIPI_get_int_en2(data)                                                       ((0x00000008&(data))>>3)
+#define MIPI_int_en1_shift                                                           (2)
+#define MIPI_int_en1_mask                                                            (0x00000004)
+#define MIPI_int_en1(data)                                                           (0x00000004&((data)<<2))
+#define MIPI_int_en1_src(data)                                                       ((0x00000004&(data))>>2)
+#define MIPI_get_int_en1(data)                                                       ((0x00000004&(data))>>2)
+#define MIPI_int_en0_shift                                                           (1)
+#define MIPI_int_en0_mask                                                            (0x00000002)
+#define MIPI_int_en0(data)                                                           (0x00000002&((data)<<1))
+#define MIPI_int_en0_src(data)                                                       ((0x00000002&(data))>>1)
+#define MIPI_get_int_en0(data)                                                       ((0x00000002&(data))>>1)
+#define MIPI_en_shift                                                                (0)
+#define MIPI_en_mask                                                                 (0x00000001)
+#define MIPI_en(data)                                                                (0x00000001&((data)<<0))
+#define MIPI_en_src(data)                                                            ((0x00000001&(data))>>0)
+#define MIPI_get_en(data)                                                            ((0x00000001&(data))>>0)
+
+
+#define MIPI_SA0                                                                     0x18004104
+#define MIPI_SA0_reg_addr                                                            "0xB8004104"
+#define MIPI_SA0_reg                                                                 0xB8004104
+#define set_MIPI_SA0_reg(data)   (*((volatile unsigned int*) MIPI_SA0_reg)=data)
+#define get_MIPI_SA0_reg   (*((volatile unsigned int*) MIPI_SA0_reg))
+#define MIPI_SA0_inst_adr                                                            "0x0041"
+#define MIPI_SA0_inst                                                                0x0041
+#define MIPI_SA0_sa0_video_shift                                                     (0)
+#define MIPI_SA0_sa0_video_mask                                                      (0x7FFFFFFF)
+#define MIPI_SA0_sa0_video(data)                                                     (0x7FFFFFFF&((data)<<0))
+#define MIPI_SA0_sa0_video_src(data)                                                 ((0x7FFFFFFF&(data))>>0)
+#define MIPI_SA0_get_sa0_video(data)                                                 ((0x7FFFFFFF&(data))>>0)
+
+
+#define MIPI_SA1                                                                     0x18004108
+#define MIPI_SA1_reg_addr                                                            "0xB8004108"
+#define MIPI_SA1_reg                                                                 0xB8004108
+#define set_MIPI_SA1_reg(data)   (*((volatile unsigned int*) MIPI_SA1_reg)=data)
+#define get_MIPI_SA1_reg   (*((volatile unsigned int*) MIPI_SA1_reg))
+#define MIPI_SA1_inst_adr                                                            "0x0042"
+#define MIPI_SA1_inst                                                                0x0042
+#define MIPI_SA1_sa1_video_shift                                                     (0)
+#define MIPI_SA1_sa1_video_mask                                                      (0x7FFFFFFF)
+#define MIPI_SA1_sa1_video(data)                                                     (0x7FFFFFFF&((data)<<0))
+#define MIPI_SA1_sa1_video_src(data)                                                 ((0x7FFFFFFF&(data))>>0)
+#define MIPI_SA1_get_sa1_video(data)                                                 ((0x7FFFFFFF&(data))>>0)
+
+
+#define MIPI_SA2                                                                     0x1800410C
+#define MIPI_SA2_reg_addr                                                            "0xB800410C"
+#define MIPI_SA2_reg                                                                 0xB800410C
+#define set_MIPI_SA2_reg(data)   (*((volatile unsigned int*) MIPI_SA2_reg)=data)
+#define get_MIPI_SA2_reg   (*((volatile unsigned int*) MIPI_SA2_reg))
+#define MIPI_SA2_inst_adr                                                            "0x0043"
+#define MIPI_SA2_inst                                                                0x0043
+#define MIPI_SA2_sa2_pic_shift                                                       (0)
+#define MIPI_SA2_sa2_pic_mask                                                        (0x7FFFFFFF)
+#define MIPI_SA2_sa2_pic(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define MIPI_SA2_sa2_pic_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define MIPI_SA2_get_sa2_pic(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define MIPI_SIZE0                                                                   0x18004110
+#define MIPI_SIZE0_reg_addr                                                          "0xB8004110"
+#define MIPI_SIZE0_reg                                                               0xB8004110
+#define set_MIPI_SIZE0_reg(data)   (*((volatile unsigned int*) MIPI_SIZE0_reg)=data)
+#define get_MIPI_SIZE0_reg   (*((volatile unsigned int*) MIPI_SIZE0_reg))
+#define MIPI_SIZE0_inst_adr                                                          "0x0044"
+#define MIPI_SIZE0_inst                                                              0x0044
+#define MIPI_SIZE0_dst_width_video_shift                                             (16)
+#define MIPI_SIZE0_dst_width_video_mask                                              (0x1FFF0000)
+#define MIPI_SIZE0_dst_width_video(data)                                             (0x1FFF0000&((data)<<16))
+#define MIPI_SIZE0_dst_width_video_src(data)                                         ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE0_get_dst_width_video(data)                                         ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE0_pitch_video_shift                                                 (0)
+#define MIPI_SIZE0_pitch_video_mask                                                  (0x0000FFFF)
+#define MIPI_SIZE0_pitch_video(data)                                                 (0x0000FFFF&((data)<<0))
+#define MIPI_SIZE0_pitch_video_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define MIPI_SIZE0_get_pitch_video(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define MIPI_SIZE1                                                                   0x18004114
+#define MIPI_SIZE1_reg_addr                                                          "0xB8004114"
+#define MIPI_SIZE1_reg                                                               0xB8004114
+#define set_MIPI_SIZE1_reg(data)   (*((volatile unsigned int*) MIPI_SIZE1_reg)=data)
+#define get_MIPI_SIZE1_reg   (*((volatile unsigned int*) MIPI_SIZE1_reg))
+#define MIPI_SIZE1_inst_adr                                                          "0x0045"
+#define MIPI_SIZE1_inst                                                              0x0045
+#define MIPI_SIZE1_dst_width_pic_shift                                               (16)
+#define MIPI_SIZE1_dst_width_pic_mask                                                (0x1FFF0000)
+#define MIPI_SIZE1_dst_width_pic(data)                                               (0x1FFF0000&((data)<<16))
+#define MIPI_SIZE1_dst_width_pic_src(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE1_get_dst_width_pic(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE1_pitch_pic_shift                                                   (0)
+#define MIPI_SIZE1_pitch_pic_mask                                                    (0x0000FFFF)
+#define MIPI_SIZE1_pitch_pic(data)                                                   (0x0000FFFF&((data)<<0))
+#define MIPI_SIZE1_pitch_pic_src(data)                                               ((0x0000FFFF&(data))>>0)
+#define MIPI_SIZE1_get_pitch_pic(data)                                               ((0x0000FFFF&(data))>>0)
+
+
+#define MIPI_SIZE2                                                                   0x18004118
+#define MIPI_SIZE2_reg_addr                                                          "0xB8004118"
+#define MIPI_SIZE2_reg                                                               0xB8004118
+#define set_MIPI_SIZE2_reg(data)   (*((volatile unsigned int*) MIPI_SIZE2_reg)=data)
+#define get_MIPI_SIZE2_reg   (*((volatile unsigned int*) MIPI_SIZE2_reg))
+#define MIPI_SIZE2_inst_adr                                                          "0x0046"
+#define MIPI_SIZE2_inst                                                              0x0046
+#define MIPI_SIZE2_src_width_pic_shift                                               (16)
+#define MIPI_SIZE2_src_width_pic_mask                                                (0x1FFF0000)
+#define MIPI_SIZE2_src_width_pic(data)                                               (0x1FFF0000&((data)<<16))
+#define MIPI_SIZE2_src_width_pic_src(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE2_get_src_width_pic(data)                                           ((0x1FFF0000&(data))>>16)
+#define MIPI_SIZE2_src_width_video_shift                                             (0)
+#define MIPI_SIZE2_src_width_video_mask                                              (0x00001FFF)
+#define MIPI_SIZE2_src_width_video(data)                                             (0x00001FFF&((data)<<0))
+#define MIPI_SIZE2_src_width_video_src(data)                                         ((0x00001FFF&(data))>>0)
+#define MIPI_SIZE2_get_src_width_video(data)                                         ((0x00001FFF&(data))>>0)
+
+
+#define MIPI_INDEX0                                                                  0x1800411C
+#define MIPI_INDEX0_reg_addr                                                         "0xB800411C"
+#define MIPI_INDEX0_reg                                                              0xB800411C
+#define set_MIPI_INDEX0_reg(data)   (*((volatile unsigned int*) MIPI_INDEX0_reg)=data)
+#define get_MIPI_INDEX0_reg   (*((volatile unsigned int*) MIPI_INDEX0_reg))
+#define MIPI_INDEX0_inst_adr                                                         "0x0047"
+#define MIPI_INDEX0_inst                                                             0x0047
+#define MIPI_INDEX0_index_y0_video_shift                                             (16)
+#define MIPI_INDEX0_index_y0_video_mask                                              (0x007F0000)
+#define MIPI_INDEX0_index_y0_video(data)                                             (0x007F0000&((data)<<16))
+#define MIPI_INDEX0_index_y0_video_src(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX0_get_index_y0_video(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX0_index_c0_video_shift                                             (0)
+#define MIPI_INDEX0_index_c0_video_mask                                              (0x0000007F)
+#define MIPI_INDEX0_index_c0_video(data)                                             (0x0000007F&((data)<<0))
+#define MIPI_INDEX0_index_c0_video_src(data)                                         ((0x0000007F&(data))>>0)
+#define MIPI_INDEX0_get_index_c0_video(data)                                         ((0x0000007F&(data))>>0)
+
+
+#define MIPI_INDEX1                                                                  0x18004120
+#define MIPI_INDEX1_reg_addr                                                         "0xB8004120"
+#define MIPI_INDEX1_reg                                                              0xB8004120
+#define set_MIPI_INDEX1_reg(data)   (*((volatile unsigned int*) MIPI_INDEX1_reg)=data)
+#define get_MIPI_INDEX1_reg   (*((volatile unsigned int*) MIPI_INDEX1_reg))
+#define MIPI_INDEX1_inst_adr                                                         "0x0048"
+#define MIPI_INDEX1_inst                                                             0x0048
+#define MIPI_INDEX1_index_y1_video_shift                                             (16)
+#define MIPI_INDEX1_index_y1_video_mask                                              (0x007F0000)
+#define MIPI_INDEX1_index_y1_video(data)                                             (0x007F0000&((data)<<16))
+#define MIPI_INDEX1_index_y1_video_src(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX1_get_index_y1_video(data)                                         ((0x007F0000&(data))>>16)
+#define MIPI_INDEX1_index_c1_video_shift                                             (0)
+#define MIPI_INDEX1_index_c1_video_mask                                              (0x0000007F)
+#define MIPI_INDEX1_index_c1_video(data)                                             (0x0000007F&((data)<<0))
+#define MIPI_INDEX1_index_c1_video_src(data)                                         ((0x0000007F&(data))>>0)
+#define MIPI_INDEX1_get_index_c1_video(data)                                         ((0x0000007F&(data))>>0)
+
+
+#define MIPI_INDEX2                                                                  0x18004124
+#define MIPI_INDEX2_reg_addr                                                         "0xB8004124"
+#define MIPI_INDEX2_reg                                                              0xB8004124
+#define set_MIPI_INDEX2_reg(data)   (*((volatile unsigned int*) MIPI_INDEX2_reg)=data)
+#define get_MIPI_INDEX2_reg   (*((volatile unsigned int*) MIPI_INDEX2_reg))
+#define MIPI_INDEX2_inst_adr                                                         "0x0049"
+#define MIPI_INDEX2_inst                                                             0x0049
+#define MIPI_INDEX2_index_y2_pic_shift                                               (16)
+#define MIPI_INDEX2_index_y2_pic_mask                                                (0x007F0000)
+#define MIPI_INDEX2_index_y2_pic(data)                                               (0x007F0000&((data)<<16))
+#define MIPI_INDEX2_index_y2_pic_src(data)                                           ((0x007F0000&(data))>>16)
+#define MIPI_INDEX2_get_index_y2_pic(data)                                           ((0x007F0000&(data))>>16)
+#define MIPI_INDEX2_index_c2_pic_shift                                               (0)
+#define MIPI_INDEX2_index_c2_pic_mask                                                (0x0000007F)
+#define MIPI_INDEX2_index_c2_pic(data)                                               (0x0000007F&((data)<<0))
+#define MIPI_INDEX2_index_c2_pic_src(data)                                           ((0x0000007F&(data))>>0)
+#define MIPI_INDEX2_get_index_c2_pic(data)                                           ((0x0000007F&(data))>>0)
+
+
+#define MIPI_INT_ST                                                                  0x18004128
+#define MIPI_INT_ST_reg_addr                                                         "0xB8004128"
+#define MIPI_INT_ST_reg                                                              0xB8004128
+#define set_MIPI_INT_ST_reg(data)   (*((volatile unsigned int*) MIPI_INT_ST_reg)=data)
+#define get_MIPI_INT_ST_reg   (*((volatile unsigned int*) MIPI_INT_ST_reg))
+#define MIPI_INT_ST_inst_adr                                                         "0x004A"
+#define MIPI_INT_ST_inst                                                             0x004A
+#define MIPI_INT_ST_mipi_data_valid_shift                                            (20)
+#define MIPI_INT_ST_mipi_data_valid_mask                                             (0x00100000)
+#define MIPI_INT_ST_mipi_data_valid(data)                                            (0x00100000&((data)<<20))
+#define MIPI_INT_ST_mipi_data_valid_src(data)                                        ((0x00100000&(data))>>20)
+#define MIPI_INT_ST_get_mipi_data_valid(data)                                        ((0x00100000&(data))>>20)
+#define MIPI_INT_ST_mipi_line_end_shift                                              (19)
+#define MIPI_INT_ST_mipi_line_end_mask                                               (0x00080000)
+#define MIPI_INT_ST_mipi_line_end(data)                                              (0x00080000&((data)<<19))
+#define MIPI_INT_ST_mipi_line_end_src(data)                                          ((0x00080000&(data))>>19)
+#define MIPI_INT_ST_get_mipi_line_end(data)                                          ((0x00080000&(data))>>19)
+#define MIPI_INT_ST_mipi_line_start_shift                                            (18)
+#define MIPI_INT_ST_mipi_line_start_mask                                             (0x00040000)
+#define MIPI_INT_ST_mipi_line_start(data)                                            (0x00040000&((data)<<18))
+#define MIPI_INT_ST_mipi_line_start_src(data)                                        ((0x00040000&(data))>>18)
+#define MIPI_INT_ST_get_mipi_line_start(data)                                        ((0x00040000&(data))>>18)
+#define MIPI_INT_ST_mipi_frame_end_shift                                             (17)
+#define MIPI_INT_ST_mipi_frame_end_mask                                              (0x00020000)
+#define MIPI_INT_ST_mipi_frame_end(data)                                             (0x00020000&((data)<<17))
+#define MIPI_INT_ST_mipi_frame_end_src(data)                                         ((0x00020000&(data))>>17)
+#define MIPI_INT_ST_get_mipi_frame_end(data)                                         ((0x00020000&(data))>>17)
+#define MIPI_INT_ST_mipi_frame_start_shift                                           (16)
+#define MIPI_INT_ST_mipi_frame_start_mask                                            (0x00010000)
+#define MIPI_INT_ST_mipi_frame_start(data)                                           (0x00010000&((data)<<16))
+#define MIPI_INT_ST_mipi_frame_start_src(data)                                       ((0x00010000&(data))>>16)
+#define MIPI_INT_ST_get_mipi_frame_start(data)                                       ((0x00010000&(data))>>16)
+#define MIPI_INT_ST_esc_lane3_int_flg_shift                                          (15)
+#define MIPI_INT_ST_esc_lane3_int_flg_mask                                           (0x00008000)
+#define MIPI_INT_ST_esc_lane3_int_flg(data)                                          (0x00008000&((data)<<15))
+#define MIPI_INT_ST_esc_lane3_int_flg_src(data)                                      ((0x00008000&(data))>>15)
+#define MIPI_INT_ST_get_esc_lane3_int_flg(data)                                      ((0x00008000&(data))>>15)
+#define MIPI_INT_ST_esc_lane2_int_flg_shift                                          (14)
+#define MIPI_INT_ST_esc_lane2_int_flg_mask                                           (0x00004000)
+#define MIPI_INT_ST_esc_lane2_int_flg(data)                                          (0x00004000&((data)<<14))
+#define MIPI_INT_ST_esc_lane2_int_flg_src(data)                                      ((0x00004000&(data))>>14)
+#define MIPI_INT_ST_get_esc_lane2_int_flg(data)                                      ((0x00004000&(data))>>14)
+#define MIPI_INT_ST_esc_lane1_int_flg_shift                                          (13)
+#define MIPI_INT_ST_esc_lane1_int_flg_mask                                           (0x00002000)
+#define MIPI_INT_ST_esc_lane1_int_flg(data)                                          (0x00002000&((data)<<13))
+#define MIPI_INT_ST_esc_lane1_int_flg_src(data)                                      ((0x00002000&(data))>>13)
+#define MIPI_INT_ST_get_esc_lane1_int_flg(data)                                      ((0x00002000&(data))>>13)
+#define MIPI_INT_ST_esc_lane0_int_flg_shift                                          (12)
+#define MIPI_INT_ST_esc_lane0_int_flg_mask                                           (0x00001000)
+#define MIPI_INT_ST_esc_lane0_int_flg(data)                                          (0x00001000&((data)<<12))
+#define MIPI_INT_ST_esc_lane0_int_flg_src(data)                                      ((0x00001000&(data))>>12)
+#define MIPI_INT_ST_get_esc_lane0_int_flg(data)                                      ((0x00001000&(data))>>12)
+#define MIPI_INT_ST_clk_ulps_int_flg_shift                                           (11)
+#define MIPI_INT_ST_clk_ulps_int_flg_mask                                            (0x00000800)
+#define MIPI_INT_ST_clk_ulps_int_flg(data)                                           (0x00000800&((data)<<11))
+#define MIPI_INT_ST_clk_ulps_int_flg_src(data)                                       ((0x00000800&(data))>>11)
+#define MIPI_INT_ST_get_clk_ulps_int_flg(data)                                       ((0x00000800&(data))>>11)
+#define MIPI_INT_ST_crc16_err_int_flg_shift                                          (10)
+#define MIPI_INT_ST_crc16_err_int_flg_mask                                           (0x00000400)
+#define MIPI_INT_ST_crc16_err_int_flg(data)                                          (0x00000400&((data)<<10))
+#define MIPI_INT_ST_crc16_err_int_flg_src(data)                                      ((0x00000400&(data))>>10)
+#define MIPI_INT_ST_get_crc16_err_int_flg(data)                                      ((0x00000400&(data))>>10)
+#define MIPI_INT_ST_ecc_crt_int_flg_shift                                            (9)
+#define MIPI_INT_ST_ecc_crt_int_flg_mask                                             (0x00000200)
+#define MIPI_INT_ST_ecc_crt_int_flg(data)                                            (0x00000200&((data)<<9))
+#define MIPI_INT_ST_ecc_crt_int_flg_src(data)                                        ((0x00000200&(data))>>9)
+#define MIPI_INT_ST_get_ecc_crt_int_flg(data)                                        ((0x00000200&(data))>>9)
+#define MIPI_INT_ST_ecc_err_int_flg_shift                                            (8)
+#define MIPI_INT_ST_ecc_err_int_flg_mask                                             (0x00000100)
+#define MIPI_INT_ST_ecc_err_int_flg(data)                                            (0x00000100&((data)<<8))
+#define MIPI_INT_ST_ecc_err_int_flg_src(data)                                        ((0x00000100&(data))>>8)
+#define MIPI_INT_ST_get_ecc_err_int_flg(data)                                        ((0x00000100&(data))>>8)
+#define MIPI_INT_ST_overflow_drop_shift                                              (5)
+#define MIPI_INT_ST_overflow_drop_mask                                               (0x00000020)
+#define MIPI_INT_ST_overflow_drop(data)                                              (0x00000020&((data)<<5))
+#define MIPI_INT_ST_overflow_drop_src(data)                                          ((0x00000020&(data))>>5)
+#define MIPI_INT_ST_get_overflow_drop(data)                                          ((0x00000020&(data))>>5)
+#define MIPI_INT_ST_fm_drop_shift                                                    (4)
+#define MIPI_INT_ST_fm_drop_mask                                                     (0x00000010)
+#define MIPI_INT_ST_fm_drop(data)                                                    (0x00000010&((data)<<4))
+#define MIPI_INT_ST_fm_drop_src(data)                                                ((0x00000010&(data))>>4)
+#define MIPI_INT_ST_get_fm_drop(data)                                                ((0x00000010&(data))>>4)
+#define MIPI_INT_ST_fm_done2_shift                                                   (3)
+#define MIPI_INT_ST_fm_done2_mask                                                    (0x00000008)
+#define MIPI_INT_ST_fm_done2(data)                                                   (0x00000008&((data)<<3))
+#define MIPI_INT_ST_fm_done2_src(data)                                               ((0x00000008&(data))>>3)
+#define MIPI_INT_ST_get_fm_done2(data)                                               ((0x00000008&(data))>>3)
+#define MIPI_INT_ST_fm_done1_shift                                                   (2)
+#define MIPI_INT_ST_fm_done1_mask                                                    (0x00000004)
+#define MIPI_INT_ST_fm_done1(data)                                                   (0x00000004&((data)<<2))
+#define MIPI_INT_ST_fm_done1_src(data)                                               ((0x00000004&(data))>>2)
+#define MIPI_INT_ST_get_fm_done1(data)                                               ((0x00000004&(data))>>2)
+#define MIPI_INT_ST_fm_done0_shift                                                   (1)
+#define MIPI_INT_ST_fm_done0_mask                                                    (0x00000002)
+#define MIPI_INT_ST_fm_done0(data)                                                   (0x00000002&((data)<<1))
+#define MIPI_INT_ST_fm_done0_src(data)                                               ((0x00000002&(data))>>1)
+#define MIPI_INT_ST_get_fm_done0(data)                                               ((0x00000002&(data))>>1)
+#define MIPI_INT_ST_write_data_shift                                                 (0)
+#define MIPI_INT_ST_write_data_mask                                                  (0x00000001)
+#define MIPI_INT_ST_write_data(data)                                                 (0x00000001&((data)<<0))
+#define MIPI_INT_ST_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define MIPI_INT_ST_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MIPI_TYPE                                                                    0x1800412C
+#define MIPI_TYPE_reg_addr                                                           "0xB800412C"
+#define MIPI_TYPE_reg                                                                0xB800412C
+#define set_MIPI_TYPE_reg(data)   (*((volatile unsigned int*) MIPI_TYPE_reg)=data)
+#define get_MIPI_TYPE_reg   (*((volatile unsigned int*) MIPI_TYPE_reg))
+#define MIPI_TYPE_inst_adr                                                           "0x004B"
+#define MIPI_TYPE_inst                                                               0x004B
+#define MIPI_TYPE_mipi_type_shift                                                    (0)
+#define MIPI_TYPE_mipi_type_mask                                                     (0x00000001)
+#define MIPI_TYPE_mipi_type(data)                                                    (0x00000001&((data)<<0))
+#define MIPI_TYPE_mipi_type_src(data)                                                ((0x00000001&(data))>>0)
+#define MIPI_TYPE_get_mipi_type(data)                                                ((0x00000001&(data))>>0)
+
+
+#define CS_TRANS0                                                                    0x18004130
+#define CS_TRANS0_reg_addr                                                           "0xB8004130"
+#define CS_TRANS0_reg                                                                0xB8004130
+#define set_CS_TRANS0_reg(data)   (*((volatile unsigned int*) CS_TRANS0_reg)=data)
+#define get_CS_TRANS0_reg   (*((volatile unsigned int*) CS_TRANS0_reg))
+#define CS_TRANS0_inst_adr                                                           "0x004C"
+#define CS_TRANS0_inst                                                               0x004C
+#define CS_TRANS0_cs_trans0_c1_shift                                                 (0)
+#define CS_TRANS0_cs_trans0_c1_mask                                                  (0x0001FFFF)
+#define CS_TRANS0_cs_trans0_c1(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS0_cs_trans0_c1_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS0_get_cs_trans0_c1(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS1                                                                    0x18004134
+#define CS_TRANS1_reg_addr                                                           "0xB8004134"
+#define CS_TRANS1_reg                                                                0xB8004134
+#define set_CS_TRANS1_reg(data)   (*((volatile unsigned int*) CS_TRANS1_reg)=data)
+#define get_CS_TRANS1_reg   (*((volatile unsigned int*) CS_TRANS1_reg))
+#define CS_TRANS1_inst_adr                                                           "0x004D"
+#define CS_TRANS1_inst                                                               0x004D
+#define CS_TRANS1_cs_trans1_c2_shift                                                 (0)
+#define CS_TRANS1_cs_trans1_c2_mask                                                  (0x0001FFFF)
+#define CS_TRANS1_cs_trans1_c2(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS1_cs_trans1_c2_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS1_get_cs_trans1_c2(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS2                                                                    0x18004138
+#define CS_TRANS2_reg_addr                                                           "0xB8004138"
+#define CS_TRANS2_reg                                                                0xB8004138
+#define set_CS_TRANS2_reg(data)   (*((volatile unsigned int*) CS_TRANS2_reg)=data)
+#define get_CS_TRANS2_reg   (*((volatile unsigned int*) CS_TRANS2_reg))
+#define CS_TRANS2_inst_adr                                                           "0x004E"
+#define CS_TRANS2_inst                                                               0x004E
+#define CS_TRANS2_cs_trans2_c3_shift                                                 (0)
+#define CS_TRANS2_cs_trans2_c3_mask                                                  (0x0001FFFF)
+#define CS_TRANS2_cs_trans2_c3(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS2_cs_trans2_c3_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS2_get_cs_trans2_c3(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS3                                                                    0x1800413C
+#define CS_TRANS3_reg_addr                                                           "0xB800413C"
+#define CS_TRANS3_reg                                                                0xB800413C
+#define set_CS_TRANS3_reg(data)   (*((volatile unsigned int*) CS_TRANS3_reg)=data)
+#define get_CS_TRANS3_reg   (*((volatile unsigned int*) CS_TRANS3_reg))
+#define CS_TRANS3_inst_adr                                                           "0x004F"
+#define CS_TRANS3_inst                                                               0x004F
+#define CS_TRANS3_cs_trans3_c4_shift                                                 (0)
+#define CS_TRANS3_cs_trans3_c4_mask                                                  (0x0001FFFF)
+#define CS_TRANS3_cs_trans3_c4(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS3_cs_trans3_c4_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS3_get_cs_trans3_c4(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS4                                                                    0x18004140
+#define CS_TRANS4_reg_addr                                                           "0xB8004140"
+#define CS_TRANS4_reg                                                                0xB8004140
+#define set_CS_TRANS4_reg(data)   (*((volatile unsigned int*) CS_TRANS4_reg)=data)
+#define get_CS_TRANS4_reg   (*((volatile unsigned int*) CS_TRANS4_reg))
+#define CS_TRANS4_inst_adr                                                           "0x0050"
+#define CS_TRANS4_inst                                                               0x0050
+#define CS_TRANS4_cs_trans4_c5_shift                                                 (0)
+#define CS_TRANS4_cs_trans4_c5_mask                                                  (0x0001FFFF)
+#define CS_TRANS4_cs_trans4_c5(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS4_cs_trans4_c5_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS4_get_cs_trans4_c5(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS5                                                                    0x18004144
+#define CS_TRANS5_reg_addr                                                           "0xB8004144"
+#define CS_TRANS5_reg                                                                0xB8004144
+#define set_CS_TRANS5_reg(data)   (*((volatile unsigned int*) CS_TRANS5_reg)=data)
+#define get_CS_TRANS5_reg   (*((volatile unsigned int*) CS_TRANS5_reg))
+#define CS_TRANS5_inst_adr                                                           "0x0051"
+#define CS_TRANS5_inst                                                               0x0051
+#define CS_TRANS5_cs_trans5_c6_shift                                                 (0)
+#define CS_TRANS5_cs_trans5_c6_mask                                                  (0x0001FFFF)
+#define CS_TRANS5_cs_trans5_c6(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS5_cs_trans5_c6_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS5_get_cs_trans5_c6(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS6                                                                    0x18004148
+#define CS_TRANS6_reg_addr                                                           "0xB8004148"
+#define CS_TRANS6_reg                                                                0xB8004148
+#define set_CS_TRANS6_reg(data)   (*((volatile unsigned int*) CS_TRANS6_reg)=data)
+#define get_CS_TRANS6_reg   (*((volatile unsigned int*) CS_TRANS6_reg))
+#define CS_TRANS6_inst_adr                                                           "0x0052"
+#define CS_TRANS6_inst                                                               0x0052
+#define CS_TRANS6_cs_trans6_c7_shift                                                 (0)
+#define CS_TRANS6_cs_trans6_c7_mask                                                  (0x0001FFFF)
+#define CS_TRANS6_cs_trans6_c7(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS6_cs_trans6_c7_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS6_get_cs_trans6_c7(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS7                                                                    0x1800414C
+#define CS_TRANS7_reg_addr                                                           "0xB800414C"
+#define CS_TRANS7_reg                                                                0xB800414C
+#define set_CS_TRANS7_reg(data)   (*((volatile unsigned int*) CS_TRANS7_reg)=data)
+#define get_CS_TRANS7_reg   (*((volatile unsigned int*) CS_TRANS7_reg))
+#define CS_TRANS7_inst_adr                                                           "0x0053"
+#define CS_TRANS7_inst                                                               0x0053
+#define CS_TRANS7_cs_trans7_c8_shift                                                 (0)
+#define CS_TRANS7_cs_trans7_c8_mask                                                  (0x0001FFFF)
+#define CS_TRANS7_cs_trans7_c8(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS7_cs_trans7_c8_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS7_get_cs_trans7_c8(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS8                                                                    0x18004150
+#define CS_TRANS8_reg_addr                                                           "0xB8004150"
+#define CS_TRANS8_reg                                                                0xB8004150
+#define set_CS_TRANS8_reg(data)   (*((volatile unsigned int*) CS_TRANS8_reg)=data)
+#define get_CS_TRANS8_reg   (*((volatile unsigned int*) CS_TRANS8_reg))
+#define CS_TRANS8_inst_adr                                                           "0x0054"
+#define CS_TRANS8_inst                                                               0x0054
+#define CS_TRANS8_cs_trans8_c9_shift                                                 (0)
+#define CS_TRANS8_cs_trans8_c9_mask                                                  (0x0001FFFF)
+#define CS_TRANS8_cs_trans8_c9(data)                                                 (0x0001FFFF&((data)<<0))
+#define CS_TRANS8_cs_trans8_c9_src(data)                                             ((0x0001FFFF&(data))>>0)
+#define CS_TRANS8_get_cs_trans8_c9(data)                                             ((0x0001FFFF&(data))>>0)
+
+
+#define CS_TRANS9                                                                    0x18004154
+#define CS_TRANS9_reg_addr                                                           "0xB8004154"
+#define CS_TRANS9_reg                                                                0xB8004154
+#define set_CS_TRANS9_reg(data)   (*((volatile unsigned int*) CS_TRANS9_reg)=data)
+#define get_CS_TRANS9_reg   (*((volatile unsigned int*) CS_TRANS9_reg))
+#define CS_TRANS9_inst_adr                                                           "0x0055"
+#define CS_TRANS9_inst                                                               0x0055
+#define CS_TRANS9_cs_trans9_k1_shift                                                 (0)
+#define CS_TRANS9_cs_trans9_k1_mask                                                  (0x0000FFFF)
+#define CS_TRANS9_cs_trans9_k1(data)                                                 (0x0000FFFF&((data)<<0))
+#define CS_TRANS9_cs_trans9_k1_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define CS_TRANS9_get_cs_trans9_k1(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define CS_TRANS10                                                                   0x18004158
+#define CS_TRANS10_reg_addr                                                          "0xB8004158"
+#define CS_TRANS10_reg                                                               0xB8004158
+#define set_CS_TRANS10_reg(data)   (*((volatile unsigned int*) CS_TRANS10_reg)=data)
+#define get_CS_TRANS10_reg   (*((volatile unsigned int*) CS_TRANS10_reg))
+#define CS_TRANS10_inst_adr                                                          "0x0056"
+#define CS_TRANS10_inst                                                              0x0056
+#define CS_TRANS10_cs_trans10_k2_shift                                               (0)
+#define CS_TRANS10_cs_trans10_k2_mask                                                (0x0000FFFF)
+#define CS_TRANS10_cs_trans10_k2(data)                                               (0x0000FFFF&((data)<<0))
+#define CS_TRANS10_cs_trans10_k2_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define CS_TRANS10_get_cs_trans10_k2(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define CS_TRANS11                                                                   0x1800415C
+#define CS_TRANS11_reg_addr                                                          "0xB800415C"
+#define CS_TRANS11_reg                                                               0xB800415C
+#define set_CS_TRANS11_reg(data)   (*((volatile unsigned int*) CS_TRANS11_reg)=data)
+#define get_CS_TRANS11_reg   (*((volatile unsigned int*) CS_TRANS11_reg))
+#define CS_TRANS11_inst_adr                                                          "0x0057"
+#define CS_TRANS11_inst                                                              0x0057
+#define CS_TRANS11_cs_trans11_k3_shift                                               (0)
+#define CS_TRANS11_cs_trans11_k3_mask                                                (0x0000FFFF)
+#define CS_TRANS11_cs_trans11_k3(data)                                               (0x0000FFFF&((data)<<0))
+#define CS_TRANS11_cs_trans11_k3_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define CS_TRANS11_get_cs_trans11_k3(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define SCALER_HSI                                                                   0x18004160
+#define SCALER_HSI_reg_addr                                                          "0xB8004160"
+#define SCALER_HSI_reg                                                               0xB8004160
+#define set_SCALER_HSI_reg(data)   (*((volatile unsigned int*) SCALER_HSI_reg)=data)
+#define get_SCALER_HSI_reg   (*((volatile unsigned int*) SCALER_HSI_reg))
+#define SCALER_HSI_inst_adr                                                          "0x0058"
+#define SCALER_HSI_inst                                                              0x0058
+#define SCALER_HSI_hsi_offset_shift                                                  (16)
+#define SCALER_HSI_hsi_offset_mask                                                   (0x07FF0000)
+#define SCALER_HSI_hsi_offset(data)                                                  (0x07FF0000&((data)<<16))
+#define SCALER_HSI_hsi_offset_src(data)                                              ((0x07FF0000&(data))>>16)
+#define SCALER_HSI_get_hsi_offset(data)                                              ((0x07FF0000&(data))>>16)
+#define SCALER_HSI_hsi_phase_shift                                                   (2)
+#define SCALER_HSI_hsi_phase_mask                                                    (0x0000FFFC)
+#define SCALER_HSI_hsi_phase(data)                                                   (0x0000FFFC&((data)<<2))
+#define SCALER_HSI_hsi_phase_src(data)                                               ((0x0000FFFC&(data))>>2)
+#define SCALER_HSI_get_hsi_phase(data)                                               ((0x0000FFFC&(data))>>2)
+
+
+#define SCALER_HSD                                                                   0x18004164
+#define SCALER_HSD_reg_addr                                                          "0xB8004164"
+#define SCALER_HSD_reg                                                               0xB8004164
+#define set_SCALER_HSD_reg(data)   (*((volatile unsigned int*) SCALER_HSD_reg)=data)
+#define get_SCALER_HSD_reg   (*((volatile unsigned int*) SCALER_HSD_reg))
+#define SCALER_HSD_inst_adr                                                          "0x0059"
+#define SCALER_HSD_inst                                                              0x0059
+#define SCALER_HSD_hsd_out_shift                                                     (20)
+#define SCALER_HSD_hsd_out_mask                                                      (0x7FF00000)
+#define SCALER_HSD_hsd_out(data)                                                     (0x7FF00000&((data)<<20))
+#define SCALER_HSD_hsd_out_src(data)                                                 ((0x7FF00000&(data))>>20)
+#define SCALER_HSD_get_hsd_out(data)                                                 ((0x7FF00000&(data))>>20)
+#define SCALER_HSD_hsd_delta_shift                                                   (0)
+#define SCALER_HSD_hsd_delta_mask                                                    (0x0007FFFF)
+#define SCALER_HSD_hsd_delta(data)                                                   (0x0007FFFF&((data)<<0))
+#define SCALER_HSD_hsd_delta_src(data)                                               ((0x0007FFFF&(data))>>0)
+#define SCALER_HSD_get_hsd_delta(data)                                               ((0x0007FFFF&(data))>>0)
+
+
+#define SCALER_VSI                                                                   0x18004168
+#define SCALER_VSI_reg_addr                                                          "0xB8004168"
+#define SCALER_VSI_reg                                                               0xB8004168
+#define set_SCALER_VSI_reg(data)   (*((volatile unsigned int*) SCALER_VSI_reg)=data)
+#define get_SCALER_VSI_reg   (*((volatile unsigned int*) SCALER_VSI_reg))
+#define SCALER_VSI_inst_adr                                                          "0x005A"
+#define SCALER_VSI_inst                                                              0x005A
+#define SCALER_VSI_vsi_offset_shift                                                  (16)
+#define SCALER_VSI_vsi_offset_mask                                                   (0x0FFF0000)
+#define SCALER_VSI_vsi_offset(data)                                                  (0x0FFF0000&((data)<<16))
+#define SCALER_VSI_vsi_offset_src(data)                                              ((0x0FFF0000&(data))>>16)
+#define SCALER_VSI_get_vsi_offset(data)                                              ((0x0FFF0000&(data))>>16)
+#define SCALER_VSI_vsi_phase_shift                                                   (2)
+#define SCALER_VSI_vsi_phase_mask                                                    (0x0000FFFC)
+#define SCALER_VSI_vsi_phase(data)                                                   (0x0000FFFC&((data)<<2))
+#define SCALER_VSI_vsi_phase_src(data)                                               ((0x0000FFFC&(data))>>2)
+#define SCALER_VSI_get_vsi_phase(data)                                               ((0x0000FFFC&(data))>>2)
+
+
+#define SCALER_VSD                                                                   0x1800416C
+#define SCALER_VSD_reg_addr                                                          "0xB800416C"
+#define SCALER_VSD_reg                                                               0xB800416C
+#define set_SCALER_VSD_reg(data)   (*((volatile unsigned int*) SCALER_VSD_reg)=data)
+#define get_SCALER_VSD_reg   (*((volatile unsigned int*) SCALER_VSD_reg))
+#define SCALER_VSD_inst_adr                                                          "0x005B"
+#define SCALER_VSD_inst                                                              0x005B
+#define SCALER_VSD_vsd_out_shift                                                     (20)
+#define SCALER_VSD_vsd_out_mask                                                      (0x7FF00000)
+#define SCALER_VSD_vsd_out(data)                                                     (0x7FF00000&((data)<<20))
+#define SCALER_VSD_vsd_out_src(data)                                                 ((0x7FF00000&(data))>>20)
+#define SCALER_VSD_get_vsd_out(data)                                                 ((0x7FF00000&(data))>>20)
+#define SCALER_VSD_vsd_delta_shift                                                   (0)
+#define SCALER_VSD_vsd_delta_mask                                                    (0x0007FFFF)
+#define SCALER_VSD_vsd_delta(data)                                                   (0x0007FFFF&((data)<<0))
+#define SCALER_VSD_vsd_delta_src(data)                                               ((0x0007FFFF&(data))>>0)
+#define SCALER_VSD_get_vsd_delta(data)                                               ((0x0007FFFF&(data))>>0)
+
+
+#define SCALER_HSYNC0                                                                0x18004170
+#define SCALER_HSYNC0_reg_addr                                                       "0xB8004170"
+#define SCALER_HSYNC0_reg                                                            0xB8004170
+#define set_SCALER_HSYNC0_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC0_reg)=data)
+#define get_SCALER_HSYNC0_reg   (*((volatile unsigned int*) SCALER_HSYNC0_reg))
+#define SCALER_HSYNC0_inst_adr                                                       "0x005C"
+#define SCALER_HSYNC0_inst                                                           0x005C
+#define SCALER_HSYNC0_hsync0_c1_shift                                                (16)
+#define SCALER_HSYNC0_hsync0_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC0_hsync0_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC0_hsync0_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC0_get_hsync0_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC0_hsync0_c0_shift                                                (0)
+#define SCALER_HSYNC0_hsync0_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC0_hsync0_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC0_hsync0_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC0_get_hsync0_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC1                                                                0x18004174
+#define SCALER_HSYNC1_reg_addr                                                       "0xB8004174"
+#define SCALER_HSYNC1_reg                                                            0xB8004174
+#define set_SCALER_HSYNC1_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC1_reg)=data)
+#define get_SCALER_HSYNC1_reg   (*((volatile unsigned int*) SCALER_HSYNC1_reg))
+#define SCALER_HSYNC1_inst_adr                                                       "0x005D"
+#define SCALER_HSYNC1_inst                                                           0x005D
+#define SCALER_HSYNC1_hsync1_c1_shift                                                (16)
+#define SCALER_HSYNC1_hsync1_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC1_hsync1_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC1_hsync1_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC1_get_hsync1_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC1_hsync1_c0_shift                                                (0)
+#define SCALER_HSYNC1_hsync1_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC1_hsync1_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC1_hsync1_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC1_get_hsync1_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC2                                                                0x18004178
+#define SCALER_HSYNC2_reg_addr                                                       "0xB8004178"
+#define SCALER_HSYNC2_reg                                                            0xB8004178
+#define set_SCALER_HSYNC2_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC2_reg)=data)
+#define get_SCALER_HSYNC2_reg   (*((volatile unsigned int*) SCALER_HSYNC2_reg))
+#define SCALER_HSYNC2_inst_adr                                                       "0x005E"
+#define SCALER_HSYNC2_inst                                                           0x005E
+#define SCALER_HSYNC2_hsync2_c1_shift                                                (16)
+#define SCALER_HSYNC2_hsync2_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC2_hsync2_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC2_hsync2_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC2_get_hsync2_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC2_hsync2_c0_shift                                                (0)
+#define SCALER_HSYNC2_hsync2_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC2_hsync2_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC2_hsync2_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC2_get_hsync2_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC3                                                                0x1800417C
+#define SCALER_HSYNC3_reg_addr                                                       "0xB800417C"
+#define SCALER_HSYNC3_reg                                                            0xB800417C
+#define set_SCALER_HSYNC3_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC3_reg)=data)
+#define get_SCALER_HSYNC3_reg   (*((volatile unsigned int*) SCALER_HSYNC3_reg))
+#define SCALER_HSYNC3_inst_adr                                                       "0x005F"
+#define SCALER_HSYNC3_inst                                                           0x005F
+#define SCALER_HSYNC3_hsync3_c1_shift                                                (16)
+#define SCALER_HSYNC3_hsync3_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC3_hsync3_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC3_hsync3_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC3_get_hsync3_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC3_hsync3_c0_shift                                                (0)
+#define SCALER_HSYNC3_hsync3_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC3_hsync3_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC3_hsync3_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC3_get_hsync3_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC4                                                                0x18004180
+#define SCALER_HSYNC4_reg_addr                                                       "0xB8004180"
+#define SCALER_HSYNC4_reg                                                            0xB8004180
+#define set_SCALER_HSYNC4_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC4_reg)=data)
+#define get_SCALER_HSYNC4_reg   (*((volatile unsigned int*) SCALER_HSYNC4_reg))
+#define SCALER_HSYNC4_inst_adr                                                       "0x0060"
+#define SCALER_HSYNC4_inst                                                           0x0060
+#define SCALER_HSYNC4_hsync4_c1_shift                                                (16)
+#define SCALER_HSYNC4_hsync4_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC4_hsync4_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC4_hsync4_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC4_get_hsync4_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC4_hsync4_c0_shift                                                (0)
+#define SCALER_HSYNC4_hsync4_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC4_hsync4_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC4_hsync4_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC4_get_hsync4_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC5                                                                0x18004184
+#define SCALER_HSYNC5_reg_addr                                                       "0xB8004184"
+#define SCALER_HSYNC5_reg                                                            0xB8004184
+#define set_SCALER_HSYNC5_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC5_reg)=data)
+#define get_SCALER_HSYNC5_reg   (*((volatile unsigned int*) SCALER_HSYNC5_reg))
+#define SCALER_HSYNC5_inst_adr                                                       "0x0061"
+#define SCALER_HSYNC5_inst                                                           0x0061
+#define SCALER_HSYNC5_hsync5_c1_shift                                                (16)
+#define SCALER_HSYNC5_hsync5_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC5_hsync5_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC5_hsync5_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC5_get_hsync5_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC5_hsync5_c0_shift                                                (0)
+#define SCALER_HSYNC5_hsync5_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC5_hsync5_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC5_hsync5_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC5_get_hsync5_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC6                                                                0x18004188
+#define SCALER_HSYNC6_reg_addr                                                       "0xB8004188"
+#define SCALER_HSYNC6_reg                                                            0xB8004188
+#define set_SCALER_HSYNC6_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC6_reg)=data)
+#define get_SCALER_HSYNC6_reg   (*((volatile unsigned int*) SCALER_HSYNC6_reg))
+#define SCALER_HSYNC6_inst_adr                                                       "0x0062"
+#define SCALER_HSYNC6_inst                                                           0x0062
+#define SCALER_HSYNC6_hsync6_c1_shift                                                (16)
+#define SCALER_HSYNC6_hsync6_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC6_hsync6_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC6_hsync6_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC6_get_hsync6_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC6_hsync6_c0_shift                                                (0)
+#define SCALER_HSYNC6_hsync6_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC6_hsync6_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC6_hsync6_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC6_get_hsync6_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSYNC7                                                                0x1800418C
+#define SCALER_HSYNC7_reg_addr                                                       "0xB800418C"
+#define SCALER_HSYNC7_reg                                                            0xB800418C
+#define set_SCALER_HSYNC7_reg(data)   (*((volatile unsigned int*) SCALER_HSYNC7_reg)=data)
+#define get_SCALER_HSYNC7_reg   (*((volatile unsigned int*) SCALER_HSYNC7_reg))
+#define SCALER_HSYNC7_inst_adr                                                       "0x0063"
+#define SCALER_HSYNC7_inst                                                           0x0063
+#define SCALER_HSYNC7_hsync7_c1_shift                                                (16)
+#define SCALER_HSYNC7_hsync7_c1_mask                                                 (0x3FFF0000)
+#define SCALER_HSYNC7_hsync7_c1(data)                                                (0x3FFF0000&((data)<<16))
+#define SCALER_HSYNC7_hsync7_c1_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC7_get_hsync7_c1(data)                                            ((0x3FFF0000&(data))>>16)
+#define SCALER_HSYNC7_hsync7_c0_shift                                                (0)
+#define SCALER_HSYNC7_hsync7_c0_mask                                                 (0x00003FFF)
+#define SCALER_HSYNC7_hsync7_c0(data)                                                (0x00003FFF&((data)<<0))
+#define SCALER_HSYNC7_hsync7_c0_src(data)                                            ((0x00003FFF&(data))>>0)
+#define SCALER_HSYNC7_get_hsync7_c0(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC0                                                                 0x18004190
+#define SCALER_HSCC0_reg_addr                                                        "0xB8004190"
+#define SCALER_HSCC0_reg                                                             0xB8004190
+#define set_SCALER_HSCC0_reg(data)   (*((volatile unsigned int*) SCALER_HSCC0_reg)=data)
+#define get_SCALER_HSCC0_reg   (*((volatile unsigned int*) SCALER_HSCC0_reg))
+#define SCALER_HSCC0_inst_adr                                                        "0x0064"
+#define SCALER_HSCC0_inst                                                            0x0064
+#define SCALER_HSCC0_hscc0_c1_shift                                                  (16)
+#define SCALER_HSCC0_hscc0_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC0_hscc0_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC0_hscc0_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC0_get_hscc0_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC0_hscc0_c0_shift                                                  (0)
+#define SCALER_HSCC0_hscc0_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC0_hscc0_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC0_hscc0_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC0_get_hscc0_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC1                                                                 0x18004194
+#define SCALER_HSCC1_reg_addr                                                        "0xB8004194"
+#define SCALER_HSCC1_reg                                                             0xB8004194
+#define set_SCALER_HSCC1_reg(data)   (*((volatile unsigned int*) SCALER_HSCC1_reg)=data)
+#define get_SCALER_HSCC1_reg   (*((volatile unsigned int*) SCALER_HSCC1_reg))
+#define SCALER_HSCC1_inst_adr                                                        "0x0065"
+#define SCALER_HSCC1_inst                                                            0x0065
+#define SCALER_HSCC1_hscc1_c1_shift                                                  (16)
+#define SCALER_HSCC1_hscc1_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC1_hscc1_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC1_hscc1_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC1_get_hscc1_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC1_hscc1_c0_shift                                                  (0)
+#define SCALER_HSCC1_hscc1_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC1_hscc1_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC1_hscc1_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC1_get_hscc1_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC2                                                                 0x18004198
+#define SCALER_HSCC2_reg_addr                                                        "0xB8004198"
+#define SCALER_HSCC2_reg                                                             0xB8004198
+#define set_SCALER_HSCC2_reg(data)   (*((volatile unsigned int*) SCALER_HSCC2_reg)=data)
+#define get_SCALER_HSCC2_reg   (*((volatile unsigned int*) SCALER_HSCC2_reg))
+#define SCALER_HSCC2_inst_adr                                                        "0x0066"
+#define SCALER_HSCC2_inst                                                            0x0066
+#define SCALER_HSCC2_hscc2_c1_shift                                                  (16)
+#define SCALER_HSCC2_hscc2_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC2_hscc2_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC2_hscc2_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC2_get_hscc2_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC2_hscc2_c0_shift                                                  (0)
+#define SCALER_HSCC2_hscc2_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC2_hscc2_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC2_hscc2_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC2_get_hscc2_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC3                                                                 0x1800419C
+#define SCALER_HSCC3_reg_addr                                                        "0xB800419C"
+#define SCALER_HSCC3_reg                                                             0xB800419C
+#define set_SCALER_HSCC3_reg(data)   (*((volatile unsigned int*) SCALER_HSCC3_reg)=data)
+#define get_SCALER_HSCC3_reg   (*((volatile unsigned int*) SCALER_HSCC3_reg))
+#define SCALER_HSCC3_inst_adr                                                        "0x0067"
+#define SCALER_HSCC3_inst                                                            0x0067
+#define SCALER_HSCC3_hscc3_c1_shift                                                  (16)
+#define SCALER_HSCC3_hscc3_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC3_hscc3_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC3_hscc3_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC3_get_hscc3_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC3_hscc3_c0_shift                                                  (0)
+#define SCALER_HSCC3_hscc3_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC3_hscc3_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC3_hscc3_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC3_get_hscc3_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC4                                                                 0x180041A0
+#define SCALER_HSCC4_reg_addr                                                        "0xB80041A0"
+#define SCALER_HSCC4_reg                                                             0xB80041A0
+#define set_SCALER_HSCC4_reg(data)   (*((volatile unsigned int*) SCALER_HSCC4_reg)=data)
+#define get_SCALER_HSCC4_reg   (*((volatile unsigned int*) SCALER_HSCC4_reg))
+#define SCALER_HSCC4_inst_adr                                                        "0x0068"
+#define SCALER_HSCC4_inst                                                            0x0068
+#define SCALER_HSCC4_hscc4_c1_shift                                                  (16)
+#define SCALER_HSCC4_hscc4_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC4_hscc4_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC4_hscc4_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC4_get_hscc4_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC4_hscc4_c0_shift                                                  (0)
+#define SCALER_HSCC4_hscc4_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC4_hscc4_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC4_hscc4_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC4_get_hscc4_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC5                                                                 0x180041A4
+#define SCALER_HSCC5_reg_addr                                                        "0xB80041A4"
+#define SCALER_HSCC5_reg                                                             0xB80041A4
+#define set_SCALER_HSCC5_reg(data)   (*((volatile unsigned int*) SCALER_HSCC5_reg)=data)
+#define get_SCALER_HSCC5_reg   (*((volatile unsigned int*) SCALER_HSCC5_reg))
+#define SCALER_HSCC5_inst_adr                                                        "0x0069"
+#define SCALER_HSCC5_inst                                                            0x0069
+#define SCALER_HSCC5_hscc5_c1_shift                                                  (16)
+#define SCALER_HSCC5_hscc5_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC5_hscc5_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC5_hscc5_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC5_get_hscc5_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC5_hscc5_c0_shift                                                  (0)
+#define SCALER_HSCC5_hscc5_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC5_hscc5_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC5_hscc5_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC5_get_hscc5_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC6                                                                 0x180041A8
+#define SCALER_HSCC6_reg_addr                                                        "0xB80041A8"
+#define SCALER_HSCC6_reg                                                             0xB80041A8
+#define set_SCALER_HSCC6_reg(data)   (*((volatile unsigned int*) SCALER_HSCC6_reg)=data)
+#define get_SCALER_HSCC6_reg   (*((volatile unsigned int*) SCALER_HSCC6_reg))
+#define SCALER_HSCC6_inst_adr                                                        "0x006A"
+#define SCALER_HSCC6_inst                                                            0x006A
+#define SCALER_HSCC6_hscc6_c1_shift                                                  (16)
+#define SCALER_HSCC6_hscc6_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC6_hscc6_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC6_hscc6_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC6_get_hscc6_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC6_hscc6_c0_shift                                                  (0)
+#define SCALER_HSCC6_hscc6_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC6_hscc6_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC6_hscc6_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC6_get_hscc6_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_HSCC7                                                                 0x180041AC
+#define SCALER_HSCC7_reg_addr                                                        "0xB80041AC"
+#define SCALER_HSCC7_reg                                                             0xB80041AC
+#define set_SCALER_HSCC7_reg(data)   (*((volatile unsigned int*) SCALER_HSCC7_reg)=data)
+#define get_SCALER_HSCC7_reg   (*((volatile unsigned int*) SCALER_HSCC7_reg))
+#define SCALER_HSCC7_inst_adr                                                        "0x006B"
+#define SCALER_HSCC7_inst                                                            0x006B
+#define SCALER_HSCC7_hscc7_c1_shift                                                  (16)
+#define SCALER_HSCC7_hscc7_c1_mask                                                   (0x3FFF0000)
+#define SCALER_HSCC7_hscc7_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_HSCC7_hscc7_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC7_get_hscc7_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_HSCC7_hscc7_c0_shift                                                  (0)
+#define SCALER_HSCC7_hscc7_c0_mask                                                   (0x00003FFF)
+#define SCALER_HSCC7_hscc7_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_HSCC7_hscc7_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_HSCC7_get_hscc7_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC0                                                                 0x180041B0
+#define SCALER_VSYC0_reg_addr                                                        "0xB80041B0"
+#define SCALER_VSYC0_reg                                                             0xB80041B0
+#define set_SCALER_VSYC0_reg(data)   (*((volatile unsigned int*) SCALER_VSYC0_reg)=data)
+#define get_SCALER_VSYC0_reg   (*((volatile unsigned int*) SCALER_VSYC0_reg))
+#define SCALER_VSYC0_inst_adr                                                        "0x006C"
+#define SCALER_VSYC0_inst                                                            0x006C
+#define SCALER_VSYC0_vsyc0_c1_shift                                                  (16)
+#define SCALER_VSYC0_vsyc0_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC0_vsyc0_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC0_vsyc0_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC0_get_vsyc0_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC0_vsyc0_c0_shift                                                  (0)
+#define SCALER_VSYC0_vsyc0_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC0_vsyc0_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC0_vsyc0_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC0_get_vsyc0_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC1                                                                 0x180041B4
+#define SCALER_VSYC1_reg_addr                                                        "0xB80041B4"
+#define SCALER_VSYC1_reg                                                             0xB80041B4
+#define set_SCALER_VSYC1_reg(data)   (*((volatile unsigned int*) SCALER_VSYC1_reg)=data)
+#define get_SCALER_VSYC1_reg   (*((volatile unsigned int*) SCALER_VSYC1_reg))
+#define SCALER_VSYC1_inst_adr                                                        "0x006D"
+#define SCALER_VSYC1_inst                                                            0x006D
+#define SCALER_VSYC1_vsyc1_c1_shift                                                  (16)
+#define SCALER_VSYC1_vsyc1_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC1_vsyc1_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC1_vsyc1_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC1_get_vsyc1_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC1_vsyc1_c0_shift                                                  (0)
+#define SCALER_VSYC1_vsyc1_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC1_vsyc1_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC1_vsyc1_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC1_get_vsyc1_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC2                                                                 0x180041B8
+#define SCALER_VSYC2_reg_addr                                                        "0xB80041B8"
+#define SCALER_VSYC2_reg                                                             0xB80041B8
+#define set_SCALER_VSYC2_reg(data)   (*((volatile unsigned int*) SCALER_VSYC2_reg)=data)
+#define get_SCALER_VSYC2_reg   (*((volatile unsigned int*) SCALER_VSYC2_reg))
+#define SCALER_VSYC2_inst_adr                                                        "0x006E"
+#define SCALER_VSYC2_inst                                                            0x006E
+#define SCALER_VSYC2_vsyc2_c1_shift                                                  (16)
+#define SCALER_VSYC2_vsyc2_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC2_vsyc2_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC2_vsyc2_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC2_get_vsyc2_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC2_vsyc2_c0_shift                                                  (0)
+#define SCALER_VSYC2_vsyc2_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC2_vsyc2_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC2_vsyc2_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC2_get_vsyc2_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSYC3                                                                 0x180041BC
+#define SCALER_VSYC3_reg_addr                                                        "0xB80041BC"
+#define SCALER_VSYC3_reg                                                             0xB80041BC
+#define set_SCALER_VSYC3_reg(data)   (*((volatile unsigned int*) SCALER_VSYC3_reg)=data)
+#define get_SCALER_VSYC3_reg   (*((volatile unsigned int*) SCALER_VSYC3_reg))
+#define SCALER_VSYC3_inst_adr                                                        "0x006F"
+#define SCALER_VSYC3_inst                                                            0x006F
+#define SCALER_VSYC3_vsyc3_c1_shift                                                  (16)
+#define SCALER_VSYC3_vsyc3_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSYC3_vsyc3_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSYC3_vsyc3_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC3_get_vsyc3_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSYC3_vsyc3_c0_shift                                                  (0)
+#define SCALER_VSYC3_vsyc3_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSYC3_vsyc3_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSYC3_vsyc3_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSYC3_get_vsyc3_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC0                                                                 0x180041C0
+#define SCALER_VSCC0_reg_addr                                                        "0xB80041C0"
+#define SCALER_VSCC0_reg                                                             0xB80041C0
+#define set_SCALER_VSCC0_reg(data)   (*((volatile unsigned int*) SCALER_VSCC0_reg)=data)
+#define get_SCALER_VSCC0_reg   (*((volatile unsigned int*) SCALER_VSCC0_reg))
+#define SCALER_VSCC0_inst_adr                                                        "0x0070"
+#define SCALER_VSCC0_inst                                                            0x0070
+#define SCALER_VSCC0_vscc0_c1_shift                                                  (16)
+#define SCALER_VSCC0_vscc0_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC0_vscc0_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC0_vscc0_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC0_get_vscc0_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC0_vscc0_c0_shift                                                  (0)
+#define SCALER_VSCC0_vscc0_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC0_vscc0_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC0_vscc0_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC0_get_vscc0_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC1                                                                 0x180041C4
+#define SCALER_VSCC1_reg_addr                                                        "0xB80041C4"
+#define SCALER_VSCC1_reg                                                             0xB80041C4
+#define set_SCALER_VSCC1_reg(data)   (*((volatile unsigned int*) SCALER_VSCC1_reg)=data)
+#define get_SCALER_VSCC1_reg   (*((volatile unsigned int*) SCALER_VSCC1_reg))
+#define SCALER_VSCC1_inst_adr                                                        "0x0071"
+#define SCALER_VSCC1_inst                                                            0x0071
+#define SCALER_VSCC1_vscc1_c1_shift                                                  (16)
+#define SCALER_VSCC1_vscc1_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC1_vscc1_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC1_vscc1_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC1_get_vscc1_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC1_vscc1_c0_shift                                                  (0)
+#define SCALER_VSCC1_vscc1_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC1_vscc1_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC1_vscc1_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC1_get_vscc1_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC2                                                                 0x180041C8
+#define SCALER_VSCC2_reg_addr                                                        "0xB80041C8"
+#define SCALER_VSCC2_reg                                                             0xB80041C8
+#define set_SCALER_VSCC2_reg(data)   (*((volatile unsigned int*) SCALER_VSCC2_reg)=data)
+#define get_SCALER_VSCC2_reg   (*((volatile unsigned int*) SCALER_VSCC2_reg))
+#define SCALER_VSCC2_inst_adr                                                        "0x0072"
+#define SCALER_VSCC2_inst                                                            0x0072
+#define SCALER_VSCC2_vscc2_c1_shift                                                  (16)
+#define SCALER_VSCC2_vscc2_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC2_vscc2_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC2_vscc2_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC2_get_vscc2_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC2_vscc2_c0_shift                                                  (0)
+#define SCALER_VSCC2_vscc2_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC2_vscc2_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC2_vscc2_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC2_get_vscc2_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define SCALER_VSCC3                                                                 0x180041CC
+#define SCALER_VSCC3_reg_addr                                                        "0xB80041CC"
+#define SCALER_VSCC3_reg                                                             0xB80041CC
+#define set_SCALER_VSCC3_reg(data)   (*((volatile unsigned int*) SCALER_VSCC3_reg)=data)
+#define get_SCALER_VSCC3_reg   (*((volatile unsigned int*) SCALER_VSCC3_reg))
+#define SCALER_VSCC3_inst_adr                                                        "0x0073"
+#define SCALER_VSCC3_inst                                                            0x0073
+#define SCALER_VSCC3_vscc3_c1_shift                                                  (16)
+#define SCALER_VSCC3_vscc3_c1_mask                                                   (0x3FFF0000)
+#define SCALER_VSCC3_vscc3_c1(data)                                                  (0x3FFF0000&((data)<<16))
+#define SCALER_VSCC3_vscc3_c1_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC3_get_vscc3_c1(data)                                              ((0x3FFF0000&(data))>>16)
+#define SCALER_VSCC3_vscc3_c0_shift                                                  (0)
+#define SCALER_VSCC3_vscc3_c0_mask                                                   (0x00003FFF)
+#define SCALER_VSCC3_vscc3_c0(data)                                                  (0x00003FFF&((data)<<0))
+#define SCALER_VSCC3_vscc3_c0_src(data)                                              ((0x00003FFF&(data))>>0)
+#define SCALER_VSCC3_get_vscc3_c0(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define CONSTANT_ALPHA                                                               0x180041D0
+#define CONSTANT_ALPHA_reg_addr                                                      "0xB80041D0"
+#define CONSTANT_ALPHA_reg                                                           0xB80041D0
+#define set_CONSTANT_ALPHA_reg(data)   (*((volatile unsigned int*) CONSTANT_ALPHA_reg)=data)
+#define get_CONSTANT_ALPHA_reg   (*((volatile unsigned int*) CONSTANT_ALPHA_reg))
+#define CONSTANT_ALPHA_inst_adr                                                      "0x0074"
+#define CONSTANT_ALPHA_inst                                                          0x0074
+#define CONSTANT_ALPHA_alpha_shift                                                   (0)
+#define CONSTANT_ALPHA_alpha_mask                                                    (0x000000FF)
+#define CONSTANT_ALPHA_alpha(data)                                                   (0x000000FF&((data)<<0))
+#define CONSTANT_ALPHA_alpha_src(data)                                               ((0x000000FF&(data))>>0)
+#define CONSTANT_ALPHA_get_alpha(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define BIST_MODE                                                                    0x180041D4
+#define BIST_MODE_reg_addr                                                           "0xB80041D4"
+#define BIST_MODE_reg                                                                0xB80041D4
+#define set_BIST_MODE_reg(data)   (*((volatile unsigned int*) BIST_MODE_reg)=data)
+#define get_BIST_MODE_reg   (*((volatile unsigned int*) BIST_MODE_reg))
+#define BIST_MODE_inst_adr                                                           "0x0075"
+#define BIST_MODE_inst                                                               0x0075
+#define BIST_MODE_drf_test_resume_shift                                              (2)
+#define BIST_MODE_drf_test_resume_mask                                               (0x00000004)
+#define BIST_MODE_drf_test_resume(data)                                              (0x00000004&((data)<<2))
+#define BIST_MODE_drf_test_resume_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_MODE_get_drf_test_resume(data)                                          ((0x00000004&(data))>>2)
+#define BIST_MODE_drf_bist_mode_shift                                                (1)
+#define BIST_MODE_drf_bist_mode_mask                                                 (0x00000002)
+#define BIST_MODE_drf_bist_mode(data)                                                (0x00000002&((data)<<1))
+#define BIST_MODE_drf_bist_mode_src(data)                                            ((0x00000002&(data))>>1)
+#define BIST_MODE_get_drf_bist_mode(data)                                            ((0x00000002&(data))>>1)
+#define BIST_MODE_bist_mode_shift                                                    (0)
+#define BIST_MODE_bist_mode_mask                                                     (0x00000001)
+#define BIST_MODE_bist_mode(data)                                                    (0x00000001&((data)<<0))
+#define BIST_MODE_bist_mode_src(data)                                                ((0x00000001&(data))>>0)
+#define BIST_MODE_get_bist_mode(data)                                                ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT0                                                                 0x180041D8
+#define BIST_RESULT0_reg_addr                                                        "0xB80041D8"
+#define BIST_RESULT0_reg                                                             0xB80041D8
+#define set_BIST_RESULT0_reg(data)   (*((volatile unsigned int*) BIST_RESULT0_reg)=data)
+#define get_BIST_RESULT0_reg   (*((volatile unsigned int*) BIST_RESULT0_reg))
+#define BIST_RESULT0_inst_adr                                                        "0x0076"
+#define BIST_RESULT0_inst                                                            0x0076
+#define BIST_RESULT0_drf_start_pause_shift                                           (8)
+#define BIST_RESULT0_drf_start_pause_mask                                            (0x00000100)
+#define BIST_RESULT0_drf_start_pause(data)                                           (0x00000100&((data)<<8))
+#define BIST_RESULT0_drf_start_pause_src(data)                                       ((0x00000100&(data))>>8)
+#define BIST_RESULT0_get_drf_start_pause(data)                                       ((0x00000100&(data))>>8)
+#define BIST_RESULT0_drf_bist_fail2_shift                                            (7)
+#define BIST_RESULT0_drf_bist_fail2_mask                                             (0x00000080)
+#define BIST_RESULT0_drf_bist_fail2(data)                                            (0x00000080&((data)<<7))
+#define BIST_RESULT0_drf_bist_fail2_src(data)                                        ((0x00000080&(data))>>7)
+#define BIST_RESULT0_get_drf_bist_fail2(data)                                        ((0x00000080&(data))>>7)
+#define BIST_RESULT0_drf_bist_fail1_shift                                            (6)
+#define BIST_RESULT0_drf_bist_fail1_mask                                             (0x00000040)
+#define BIST_RESULT0_drf_bist_fail1(data)                                            (0x00000040&((data)<<6))
+#define BIST_RESULT0_drf_bist_fail1_src(data)                                        ((0x00000040&(data))>>6)
+#define BIST_RESULT0_get_drf_bist_fail1(data)                                        ((0x00000040&(data))>>6)
+#define BIST_RESULT0_drf_bist_fail0_shift                                            (5)
+#define BIST_RESULT0_drf_bist_fail0_mask                                             (0x00000020)
+#define BIST_RESULT0_drf_bist_fail0(data)                                            (0x00000020&((data)<<5))
+#define BIST_RESULT0_drf_bist_fail0_src(data)                                        ((0x00000020&(data))>>5)
+#define BIST_RESULT0_get_drf_bist_fail0(data)                                        ((0x00000020&(data))>>5)
+#define BIST_RESULT0_drf_bist_done_shift                                             (4)
+#define BIST_RESULT0_drf_bist_done_mask                                              (0x00000010)
+#define BIST_RESULT0_drf_bist_done(data)                                             (0x00000010&((data)<<4))
+#define BIST_RESULT0_drf_bist_done_src(data)                                         ((0x00000010&(data))>>4)
+#define BIST_RESULT0_get_drf_bist_done(data)                                         ((0x00000010&(data))>>4)
+#define BIST_RESULT0_bist_fail2_shift                                                (3)
+#define BIST_RESULT0_bist_fail2_mask                                                 (0x00000008)
+#define BIST_RESULT0_bist_fail2(data)                                                (0x00000008&((data)<<3))
+#define BIST_RESULT0_bist_fail2_src(data)                                            ((0x00000008&(data))>>3)
+#define BIST_RESULT0_get_bist_fail2(data)                                            ((0x00000008&(data))>>3)
+#define BIST_RESULT0_bist_fail1_shift                                                (2)
+#define BIST_RESULT0_bist_fail1_mask                                                 (0x00000004)
+#define BIST_RESULT0_bist_fail1(data)                                                (0x00000004&((data)<<2))
+#define BIST_RESULT0_bist_fail1_src(data)                                            ((0x00000004&(data))>>2)
+#define BIST_RESULT0_get_bist_fail1(data)                                            ((0x00000004&(data))>>2)
+#define BIST_RESULT0_bist_fail0_shift                                                (1)
+#define BIST_RESULT0_bist_fail0_mask                                                 (0x00000002)
+#define BIST_RESULT0_bist_fail0(data)                                                (0x00000002&((data)<<1))
+#define BIST_RESULT0_bist_fail0_src(data)                                            ((0x00000002&(data))>>1)
+#define BIST_RESULT0_get_bist_fail0(data)                                            ((0x00000002&(data))>>1)
+#define BIST_RESULT0_bist_done_shift                                                 (0)
+#define BIST_RESULT0_bist_done_mask                                                  (0x00000001)
+#define BIST_RESULT0_bist_done(data)                                                 (0x00000001&((data)<<0))
+#define BIST_RESULT0_bist_done_src(data)                                             ((0x00000001&(data))>>0)
+#define BIST_RESULT0_get_bist_done(data)                                             ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT1                                                                 0x180041DC
+#define BIST_RESULT1_reg_addr                                                        "0xB80041DC"
+#define BIST_RESULT1_reg                                                             0xB80041DC
+#define set_BIST_RESULT1_reg(data)   (*((volatile unsigned int*) BIST_RESULT1_reg)=data)
+#define get_BIST_RESULT1_reg   (*((volatile unsigned int*) BIST_RESULT1_reg))
+#define BIST_RESULT1_inst_adr                                                        "0x0077"
+#define BIST_RESULT1_inst                                                            0x0077
+#define BIST_RESULT1_sram_rm_shift                                                   (1)
+#define BIST_RESULT1_sram_rm_mask                                                    (0x0000001E)
+#define BIST_RESULT1_sram_rm(data)                                                   (0x0000001E&((data)<<1))
+#define BIST_RESULT1_sram_rm_src(data)                                               ((0x0000001E&(data))>>1)
+#define BIST_RESULT1_get_sram_rm(data)                                               ((0x0000001E&(data))>>1)
+#define BIST_RESULT1_sram_rme_shift                                                  (0)
+#define BIST_RESULT1_sram_rme_mask                                                   (0x00000001)
+#define BIST_RESULT1_sram_rme(data)                                                  (0x00000001&((data)<<0))
+#define BIST_RESULT1_sram_rme_src(data)                                              ((0x00000001&(data))>>0)
+#define BIST_RESULT1_get_sram_rme(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MIPI_SA0_UV                                                                  0x180041E0
+#define MIPI_SA0_UV_reg_addr                                                         "0xB80041E0"
+#define MIPI_SA0_UV_reg                                                              0xB80041E0
+#define set_MIPI_SA0_UV_reg(data)   (*((volatile unsigned int*) MIPI_SA0_UV_reg)=data)
+#define get_MIPI_SA0_UV_reg   (*((volatile unsigned int*) MIPI_SA0_UV_reg))
+#define MIPI_SA0_UV_inst_adr                                                         "0x0078"
+#define MIPI_SA0_UV_inst                                                             0x0078
+#define MIPI_SA0_UV_sa0_video_uv_shift                                               (0)
+#define MIPI_SA0_UV_sa0_video_uv_mask                                                (0x7FFFFFFF)
+#define MIPI_SA0_UV_sa0_video_uv(data)                                               (0x7FFFFFFF&((data)<<0))
+#define MIPI_SA0_UV_sa0_video_uv_src(data)                                           ((0x7FFFFFFF&(data))>>0)
+#define MIPI_SA0_UV_get_sa0_video_uv(data)                                           ((0x7FFFFFFF&(data))>>0)
+
+
+#define MIPI_SA1_UV                                                                  0x180041E4
+#define MIPI_SA1_UV_reg_addr                                                         "0xB80041E4"
+#define MIPI_SA1_UV_reg                                                              0xB80041E4
+#define set_MIPI_SA1_UV_reg(data)   (*((volatile unsigned int*) MIPI_SA1_UV_reg)=data)
+#define get_MIPI_SA1_UV_reg   (*((volatile unsigned int*) MIPI_SA1_UV_reg))
+#define MIPI_SA1_UV_inst_adr                                                         "0x0079"
+#define MIPI_SA1_UV_inst                                                             0x0079
+#define MIPI_SA1_UV_sa1_video_uv_shift                                               (0)
+#define MIPI_SA1_UV_sa1_video_uv_mask                                                (0x7FFFFFFF)
+#define MIPI_SA1_UV_sa1_video_uv(data)                                               (0x7FFFFFFF&((data)<<0))
+#define MIPI_SA1_UV_sa1_video_uv_src(data)                                           ((0x7FFFFFFF&(data))>>0)
+#define MIPI_SA1_UV_get_sa1_video_uv(data)                                           ((0x7FFFFFFF&(data))>>0)
+
+
+#define MIPI_SA2_UV                                                                  0x180041E8
+#define MIPI_SA2_UV_reg_addr                                                         "0xB80041E8"
+#define MIPI_SA2_UV_reg                                                              0xB80041E8
+#define set_MIPI_SA2_UV_reg(data)   (*((volatile unsigned int*) MIPI_SA2_UV_reg)=data)
+#define get_MIPI_SA2_UV_reg   (*((volatile unsigned int*) MIPI_SA2_UV_reg))
+#define MIPI_SA2_UV_inst_adr                                                         "0x007A"
+#define MIPI_SA2_UV_inst                                                             0x007A
+#define MIPI_SA2_UV_sa2_pic_uv_shift                                                 (0)
+#define MIPI_SA2_UV_sa2_pic_uv_mask                                                  (0x7FFFFFFF)
+#define MIPI_SA2_UV_sa2_pic_uv(data)                                                 (0x7FFFFFFF&((data)<<0))
+#define MIPI_SA2_UV_sa2_pic_uv_src(data)                                             ((0x7FFFFFFF&(data))>>0)
+#define MIPI_SA2_UV_get_sa2_pic_uv(data)                                             ((0x7FFFFFFF&(data))>>0)
+
+
+#define MIPI_RESET                                                                   0x180041EC
+#define MIPI_RESET_reg_addr                                                          "0xB80041EC"
+#define MIPI_RESET_reg                                                               0xB80041EC
+#define set_MIPI_RESET_reg(data)   (*((volatile unsigned int*) MIPI_RESET_reg)=data)
+#define get_MIPI_RESET_reg   (*((volatile unsigned int*) MIPI_RESET_reg))
+#define MIPI_RESET_inst_adr                                                          "0x007B"
+#define MIPI_RESET_inst                                                              0x007B
+#define MIPI_RESET_mipi_sw_rst_shift                                                 (0)
+#define MIPI_RESET_mipi_sw_rst_mask                                                  (0x00000001)
+#define MIPI_RESET_mipi_sw_rst(data)                                                 (0x00000001&((data)<<0))
+#define MIPI_RESET_mipi_sw_rst_src(data)                                             ((0x00000001&(data))>>0)
+#define MIPI_RESET_get_mipi_sw_rst(data)                                             ((0x00000001&(data))>>0)
+
+
+#define BIST_RESULT1                                                                 0x180041F0
+#define BIST_RESULT1_reg_addr                                                        "0xB80041F0"
+#define BIST_RESULT1_reg                                                             0xB80041F0
+#define set_BIST_RESULT1_reg(data)   (*((volatile unsigned int*) BIST_RESULT1_reg)=data)
+#define get_BIST_RESULT1_reg   (*((volatile unsigned int*) BIST_RESULT1_reg))
+#define BIST_RESULT1_inst_adr                                                        "0x007C"
+#define BIST_RESULT1_inst                                                            0x007C
+#define BIST_RESULT1_dbg_sel_shift                                                   (8)
+#define BIST_RESULT1_dbg_sel_mask                                                    (0x00000100)
+#define BIST_RESULT1_dbg_sel(data)                                                   (0x00000100&((data)<<8))
+#define BIST_RESULT1_dbg_sel_src(data)                                               ((0x00000100&(data))>>8)
+#define BIST_RESULT1_get_dbg_sel(data)                                               ((0x00000100&(data))>>8)
+#define BIST_RESULT1_dbg_sel1_shift                                                  (4)
+#define BIST_RESULT1_dbg_sel1_mask                                                   (0x000000F0)
+#define BIST_RESULT1_dbg_sel1(data)                                                  (0x000000F0&((data)<<4))
+#define BIST_RESULT1_dbg_sel1_src(data)                                              ((0x000000F0&(data))>>4)
+#define BIST_RESULT1_get_dbg_sel1(data)                                              ((0x000000F0&(data))>>4)
+#define BIST_RESULT1_dbg_sel0_shift                                                  (0)
+#define BIST_RESULT1_dbg_sel0_mask                                                   (0x0000000F)
+#define BIST_RESULT1_dbg_sel0(data)                                                  (0x0000000F&((data)<<0))
+#define BIST_RESULT1_dbg_sel0_src(data)                                              ((0x0000000F&(data))>>0)
+#define BIST_RESULT1_get_dbg_sel0(data)                                              ((0x0000000F&(data))>>0)
+
+
+#define MIPI_DUMMY_REG0                                                              0x180041F4
+#define MIPI_DUMMY_REG0_reg_addr                                                     "0xB80041F4"
+#define MIPI_DUMMY_REG0_reg                                                          0xB80041F4
+#define set_MIPI_DUMMY_REG0_reg(data)   (*((volatile unsigned int*) MIPI_DUMMY_REG0_reg)=data)
+#define get_MIPI_DUMMY_REG0_reg   (*((volatile unsigned int*) MIPI_DUMMY_REG0_reg))
+#define MIPI_DUMMY_REG0_inst_adr                                                     "0x007D"
+#define MIPI_DUMMY_REG0_inst                                                         0x007D
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0_shift                                        (0)
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0_mask                                         (0xFFFFFFFF)
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0(data)                                        (0xFFFFFFFF&((data)<<0))
+#define MIPI_DUMMY_REG0_mipi_dummy_reg0_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define MIPI_DUMMY_REG0_get_mipi_dummy_reg0(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIPI_DUMMY_REG1                                                              0x180041F8
+#define MIPI_DUMMY_REG1_reg_addr                                                     "0xB80041F8"
+#define MIPI_DUMMY_REG1_reg                                                          0xB80041F8
+#define set_MIPI_DUMMY_REG1_reg(data)   (*((volatile unsigned int*) MIPI_DUMMY_REG1_reg)=data)
+#define get_MIPI_DUMMY_REG1_reg   (*((volatile unsigned int*) MIPI_DUMMY_REG1_reg))
+#define MIPI_DUMMY_REG1_inst_adr                                                     "0x007E"
+#define MIPI_DUMMY_REG1_inst                                                         0x007E
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1_shift                                        (0)
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1_mask                                         (0xFFFFFFFF)
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1(data)                                        (0xFFFFFFFF&((data)<<0))
+#define MIPI_DUMMY_REG1_mipi_dummy_reg1_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define MIPI_DUMMY_REG1_get_mipi_dummy_reg1(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/mis_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mis_reg.h
new file mode 100644
index 00000000..6e0d5f6
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mis_reg.h
@@ -0,0 +1,11949 @@
+/**************************************************************
+// Spec Version                  : 0.0.7
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/7/25 16:46:20
+***************************************************************/
+
+
+#ifndef _MIS_REG_H_INCLUDED_
+#define _MIS_REG_H_INCLUDED_
+#ifdef  _MIS_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     gspi_int:1;
+unsigned int     reserved_1:6;
+unsigned int     gpioda_int:1;
+unsigned int     gpioa_int:1;
+unsigned int     reserved_2:6;
+unsigned int     rtc_date_int:1;
+unsigned int     rtc_hour_int:1;
+unsigned int     rtc_min_int:1;
+unsigned int     rtc_hsec_int:1;
+unsigned int     reserved_3:1;
+unsigned int     tc1_int:1;
+unsigned int     tc0_int:1;
+unsigned int     ur1_to_int:1;
+unsigned int     reserved_4:2;
+unsigned int     wdog_nmi_int:1;
+unsigned int     reserved_5:1;
+unsigned int     write_data:1;
+}MIS_UMSK_ISR;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     gspi_int:1;
+unsigned int     i2c2_int:1;
+unsigned int     reserved_1:2;
+unsigned int     i2c3_int:1;
+unsigned int     reserved_2:1;
+unsigned int     lsadc_int:1;
+unsigned int     gpioda_int:1;
+unsigned int     gpioa_int:1;
+unsigned int     reserved_3:3;
+unsigned int     i2c4_int:1;
+unsigned int     i2c5_int:1;
+unsigned int     reserved_4:1;
+unsigned int     rtc_date_int:1;
+unsigned int     rtc_hour_int:1;
+unsigned int     rtc_min_int:1;
+unsigned int     rtc_hsec_int:1;
+unsigned int     reserved_5:1;
+unsigned int     tc1_int:1;
+unsigned int     tc0_int:1;
+unsigned int     ur1_to_int:1;
+unsigned int     i2c1_int:1;
+unsigned int     ur1_int:1;
+unsigned int     wdog_nmi_int:1;
+unsigned int     reserved_6:1;
+unsigned int     write_data:1;
+}MIS_ISR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     wdog_nmi_int:1;
+unsigned int     reserved_1:1;
+unsigned int     tc2_int:1;
+unsigned int     write_data:1;
+}MIS_UMSK_ISR_SWC;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     wdog_nmi_int:1;
+unsigned int     i2c_2_int:1;
+unsigned int     tc2_int:1;
+unsigned int     write_data:1;
+}MIS_ISR_SWC;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     i2c_2_swc_en:1;
+unsigned int     i2c_2_en:1;
+}MIS_SETTING_SWC;
+
+typedef struct 
+{
+unsigned int     gp_int:31;
+unsigned int     reserved_0:1;
+}MIS_FAST_INT_EN_0;
+
+typedef struct 
+{
+unsigned int     gspi_int:1;
+unsigned int     i2c3_int:1;
+unsigned int     gp_int:29;
+unsigned int     i2c2_int:1;
+}MIS_FAST_INT_EN_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     i2c2_int:1;
+unsigned int     gspi_int:1;
+unsigned int     i2c3_int:1;
+unsigned int     gpioda_int:1;
+unsigned int     gpioa_int:1;
+unsigned int     write_data:1;
+}MIS_FAST_ISR;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_enable3:1;
+unsigned int     sel1:4;
+unsigned int     write_enable2:1;
+unsigned int     sel0:4;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}MIS_DBG;
+
+typedef struct 
+{
+unsigned int     write_enable4:1;
+unsigned int     rvd4:7;
+unsigned int     write_enable3:1;
+unsigned int     rvd3:7;
+unsigned int     write_enable2:1;
+unsigned int     rvd2:7;
+unsigned int     write_enable1:1;
+unsigned int     rvd1:7;
+}MIS_DUMMY;
+
+typedef struct 
+{
+unsigned int     int30:1;
+unsigned int     int29:1;
+unsigned int     int28:1;
+unsigned int     int27:1;
+unsigned int     int26:1;
+unsigned int     int25:1;
+unsigned int     int24:1;
+unsigned int     int23:1;
+unsigned int     int22:1;
+unsigned int     int21:1;
+unsigned int     int20:1;
+unsigned int     int19:1;
+unsigned int     int18:1;
+unsigned int     int17:1;
+unsigned int     int16:1;
+unsigned int     int15:1;
+unsigned int     int14:1;
+unsigned int     int13:1;
+unsigned int     int12:1;
+unsigned int     int11:1;
+unsigned int     int10:1;
+unsigned int     int9:1;
+unsigned int     int8:1;
+unsigned int     int7:1;
+unsigned int     int6:1;
+unsigned int     int5:1;
+unsigned int     int4:1;
+unsigned int     int3:1;
+unsigned int     int2:1;
+unsigned int     int1:1;
+unsigned int     int0:1;
+unsigned int     write_data:1;
+}MIS_UMSK_ISR_GP0A;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     int59:1;
+unsigned int     int58:1;
+unsigned int     int57:1;
+unsigned int     int56:1;
+unsigned int     int55:1;
+unsigned int     int54:1;
+unsigned int     int53:1;
+unsigned int     int52:1;
+unsigned int     int51:1;
+unsigned int     int50:1;
+unsigned int     int49:1;
+unsigned int     int48:1;
+unsigned int     int47:1;
+unsigned int     int46:1;
+unsigned int     int45:1;
+unsigned int     int44:1;
+unsigned int     int43:1;
+unsigned int     int42:1;
+unsigned int     int41:1;
+unsigned int     int40:1;
+unsigned int     int39:1;
+unsigned int     int38:1;
+unsigned int     int37:1;
+unsigned int     int36:1;
+unsigned int     int35:1;
+unsigned int     int34:1;
+unsigned int     int33:1;
+unsigned int     int32:1;
+unsigned int     int31:1;
+unsigned int     write_data:1;
+}MIS_UMSK_ISR_GP1A;
+
+typedef struct 
+{
+unsigned int     int30:1;
+unsigned int     int29:1;
+unsigned int     int28:1;
+unsigned int     int27:1;
+unsigned int     int26:1;
+unsigned int     int25:1;
+unsigned int     int24:1;
+unsigned int     int23:1;
+unsigned int     int22:1;
+unsigned int     int21:1;
+unsigned int     int20:1;
+unsigned int     int19:1;
+unsigned int     int18:1;
+unsigned int     int17:1;
+unsigned int     int16:1;
+unsigned int     int15:1;
+unsigned int     int14:1;
+unsigned int     int13:1;
+unsigned int     int12:1;
+unsigned int     int11:1;
+unsigned int     int10:1;
+unsigned int     int9:1;
+unsigned int     int8:1;
+unsigned int     int7:1;
+unsigned int     int6:1;
+unsigned int     int5:1;
+unsigned int     int4:1;
+unsigned int     int3:1;
+unsigned int     int2:1;
+unsigned int     int1:1;
+unsigned int     int0:1;
+unsigned int     write_data:1;
+}MIS_UMSK_ISR_GP0DA;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     int59:1;
+unsigned int     int58:1;
+unsigned int     int57:1;
+unsigned int     int56:1;
+unsigned int     int55:1;
+unsigned int     int54:1;
+unsigned int     int53:1;
+unsigned int     int52:1;
+unsigned int     int51:1;
+unsigned int     int50:1;
+unsigned int     int49:1;
+unsigned int     int48:1;
+unsigned int     int47:1;
+unsigned int     int46:1;
+unsigned int     int45:1;
+unsigned int     int44:1;
+unsigned int     int43:1;
+unsigned int     int42:1;
+unsigned int     int41:1;
+unsigned int     int40:1;
+unsigned int     int39:1;
+unsigned int     int38:1;
+unsigned int     int37:1;
+unsigned int     int36:1;
+unsigned int     int35:1;
+unsigned int     int34:1;
+unsigned int     int33:1;
+unsigned int     int32:1;
+unsigned int     int31:1;
+unsigned int     write_data:1;
+}MIS_UMSK_ISR_GP1DA;
+
+typedef struct 
+{
+unsigned int     write_enable2:1;
+unsigned int     rvd2:15;
+unsigned int     write_enable1:1;
+unsigned int     rvd1:15;
+}MIS_DUMMY1;
+
+typedef struct 
+{
+unsigned int     rvd3:3;
+unsigned int     reserved_0:1;
+unsigned int     to_len:8;
+unsigned int     to_int_en:1;
+unsigned int     toauareq:1;
+unsigned int     flow_pol:1;
+unsigned int     mdifen:1;
+unsigned int     reserved_1:2;
+unsigned int     txempthr:6;
+unsigned int     reserved_2:2;
+unsigned int     rxfulthr:6;
+}MIS_UR_CTRL;
+
+typedef struct 
+{
+unsigned int     int_30:1;
+unsigned int     int_29:1;
+unsigned int     int_28:1;
+unsigned int     int_27:1;
+unsigned int     int_26:1;
+unsigned int     int_25:1;
+unsigned int     int_24:1;
+unsigned int     int_23:1;
+unsigned int     int_22:1;
+unsigned int     int_21:1;
+unsigned int     int_20:1;
+unsigned int     int_19:1;
+unsigned int     int_18:1;
+unsigned int     int_17:1;
+unsigned int     int_16:1;
+unsigned int     int_15:1;
+unsigned int     int_14:1;
+unsigned int     int_13:1;
+unsigned int     int_12:1;
+unsigned int     int_11:1;
+unsigned int     int_10:1;
+unsigned int     int_9:1;
+unsigned int     int_8:1;
+unsigned int     int_7:1;
+unsigned int     int_6:1;
+unsigned int     int_5:1;
+unsigned int     int_4:1;
+unsigned int     int_3:1;
+unsigned int     int_2:1;
+unsigned int     int_1:1;
+unsigned int     int_0:1;
+unsigned int     write_data:1;
+}MIS_FAST_ISR_GPIO0_A;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     int_59:1;
+unsigned int     int_58:1;
+unsigned int     int_57:1;
+unsigned int     int_56:1;
+unsigned int     int_55:1;
+unsigned int     int_54:1;
+unsigned int     int_53:1;
+unsigned int     int_52:1;
+unsigned int     int_51:1;
+unsigned int     int_50:1;
+unsigned int     int_49:1;
+unsigned int     int_48:1;
+unsigned int     int_47:1;
+unsigned int     int_46:1;
+unsigned int     int_45:1;
+unsigned int     int_44:1;
+unsigned int     int_43:1;
+unsigned int     int_42:1;
+unsigned int     int_41:1;
+unsigned int     int_40:1;
+unsigned int     int_39:1;
+unsigned int     int_38:1;
+unsigned int     int_37:1;
+unsigned int     int_36:1;
+unsigned int     int_35:1;
+unsigned int     int_34:1;
+unsigned int     int_33:1;
+unsigned int     int_32:1;
+unsigned int     int_31:1;
+unsigned int     write_data:1;
+}MIS_FAST_ISR_GPIO1_A;
+
+typedef struct 
+{
+unsigned int     int_30:1;
+unsigned int     int_29:1;
+unsigned int     int_28:1;
+unsigned int     int_27:1;
+unsigned int     int_26:1;
+unsigned int     int_25:1;
+unsigned int     int_24:1;
+unsigned int     int_23:1;
+unsigned int     int_22:1;
+unsigned int     int_21:1;
+unsigned int     int_20:1;
+unsigned int     int_19:1;
+unsigned int     int_18:1;
+unsigned int     int_17:1;
+unsigned int     int_16:1;
+unsigned int     int_15:1;
+unsigned int     int_14:1;
+unsigned int     int_13:1;
+unsigned int     int_12:1;
+unsigned int     int_11:1;
+unsigned int     int_10:1;
+unsigned int     int_9:1;
+unsigned int     int_8:1;
+unsigned int     int_7:1;
+unsigned int     int_6:1;
+unsigned int     int_5:1;
+unsigned int     int_4:1;
+unsigned int     int_3:1;
+unsigned int     int_2:1;
+unsigned int     int_1:1;
+unsigned int     int_0:1;
+unsigned int     write_data:1;
+}MIS_FAST_ISR_GPIO0_DA;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     int_59:1;
+unsigned int     int_58:1;
+unsigned int     int_57:1;
+unsigned int     int_56:1;
+unsigned int     int_55:1;
+unsigned int     int_54:1;
+unsigned int     int_53:1;
+unsigned int     int_52:1;
+unsigned int     int_51:1;
+unsigned int     int_50:1;
+unsigned int     int_49:1;
+unsigned int     int_48:1;
+unsigned int     int_47:1;
+unsigned int     int_46:1;
+unsigned int     int_45:1;
+unsigned int     int_44:1;
+unsigned int     int_43:1;
+unsigned int     int_42:1;
+unsigned int     int_41:1;
+unsigned int     int_40:1;
+unsigned int     int_39:1;
+unsigned int     int_38:1;
+unsigned int     int_37:1;
+unsigned int     int_36:1;
+unsigned int     int_35:1;
+unsigned int     int_34:1;
+unsigned int     int_33:1;
+unsigned int     int_32:1;
+unsigned int     int_31:1;
+unsigned int     write_data:1;
+}MIS_FAST_ISR_GPIO1_DA;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     i2c3:1;
+unsigned int     gspi:1;
+unsigned int     i2c2:1;
+unsigned int     reserved_1:4;
+unsigned int     lsadc:1;
+unsigned int     gpioda:1;
+unsigned int     gpioa:1;
+unsigned int     reserved_2:3;
+unsigned int     i2c4:1;
+unsigned int     i2c5:1;
+unsigned int     reserved_3:1;
+unsigned int     rtc_date:1;
+unsigned int     rtc_hour:1;
+unsigned int     rtc_min:1;
+unsigned int     reserved_4:4;
+unsigned int     ur1_to:1;
+unsigned int     i2c1:1;
+unsigned int     ur1:1;
+unsigned int     reserved_5:3;
+}MIS_SCPU_INT_EN;
+
+typedef struct 
+{
+unsigned int     dmy1:20;
+unsigned int     reserved_0:3;
+unsigned int     en:1;
+unsigned int     reserved_1:3;
+unsigned int     sel:5;
+}MIS_I2C1_SDA_DEL;
+
+typedef struct 
+{
+unsigned int     dmy1:20;
+unsigned int     reserved_0:3;
+unsigned int     en:1;
+unsigned int     reserved_1:3;
+unsigned int     sel:5;
+}MIS_I2C2_SDA_DEL;
+
+typedef struct 
+{
+unsigned int     dmy1:20;
+unsigned int     reserved_0:3;
+unsigned int     en:1;
+unsigned int     reserved_1:3;
+unsigned int     sel:5;
+}MIS_I2C3_SDA_DEL;
+
+typedef struct 
+{
+unsigned int     dmy1:20;
+unsigned int     reserved_0:3;
+unsigned int     en:1;
+unsigned int     reserved_1:3;
+unsigned int     sel:5;
+}MIS_I2C4_SDA_DEL;
+
+typedef struct 
+{
+unsigned int     dmy1:20;
+unsigned int     reserved_0:3;
+unsigned int     en:1;
+unsigned int     reserved_1:3;
+unsigned int     sel:5;
+}MIS_I2C5_SDA_DEL;
+
+typedef struct 
+{
+unsigned int     gpdir:32;
+}MIS_GP0DIR;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     gpdir:28;
+}MIS_GP1DIR;
+
+typedef struct 
+{
+unsigned int     gpdato:32;
+}MIS_GP0DATO;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     gpdato:28;
+}MIS_GP1DATO;
+
+typedef struct 
+{
+unsigned int     gpdati:32;
+}MIS_GP0DATI;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     gpdati:28;
+}MIS_GP1DATI;
+
+typedef struct 
+{
+unsigned int     gp:32;
+}MIS_GP0IE;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     gp:28;
+}MIS_GP1IE;
+
+typedef struct 
+{
+unsigned int     gpha:32;
+}MIS_GP0DP;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     gpha:28;
+}MIS_GP1DP;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_enable4:1;
+unsigned int     clk4:3;
+unsigned int     write_enable3:1;
+unsigned int     clk3:3;
+unsigned int     write_enable2:1;
+unsigned int     clk2:3;
+unsigned int     write_enable1:1;
+unsigned int     clk1:3;
+}MIS_GPDEB;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dll:8;
+}MIS_U1RBR_THR_DLL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dlh:8;
+}MIS_U1IER_DLH;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     fifo16:2;
+unsigned int     reserved_1:2;
+unsigned int     iid:4;
+}MIS_U1IIR_FCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dlab:1;
+unsigned int     brk:1;
+unsigned int     reserved_1:1;
+unsigned int     eps:1;
+unsigned int     pen:1;
+unsigned int     stb:1;
+unsigned int     wls:2;
+}MIS_U1LCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     afce:1;
+unsigned int     loop:1;
+unsigned int     reserved_1:2;
+unsigned int     rts:1;
+unsigned int     dtr:1;
+}MIS_U1MCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rfe:1;
+unsigned int     temt:1;
+unsigned int     thre:1;
+unsigned int     bi:1;
+unsigned int     fe:1;
+unsigned int     pe:1;
+unsigned int     oe:1;
+unsigned int     dr:1;
+}MIS_U1LSR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dcd:1;
+unsigned int     ri:1;
+unsigned int     dsr:1;
+unsigned int     cts:1;
+unsigned int     ddcd:1;
+unsigned int     teri:1;
+unsigned int     ddsr:1;
+unsigned int     dcts:1;
+}MIS_U1MSR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     scr:8;
+}MIS_U1SCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rbd:8;
+}MIS_U1SRBR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     far:1;
+}MIS_U1FAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     far:8;
+}MIS_U1TFR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     rffe:1;
+unsigned int     rfpf:1;
+unsigned int     rfwd:8;
+}MIS_U1RFW;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     busy:1;
+}MIS_U1USR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tfl:8;
+}MIS_U1TFL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rfl:8;
+}MIS_U1RFL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     xfr:1;
+unsigned int     rfr:1;
+unsigned int     ur:1;
+}MIS_U1SRR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     sbcr:1;
+}MIS_U1SBCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     sdmam:1;
+}MIS_U1SDMAM;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     sfe:1;
+}MIS_U1SFE;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     srt:2;
+}MIS_U1SRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     stet:2;
+}MIS_U1STET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     htx:1;
+}MIS_U1HTX;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     dmasa:1;
+}MIS_U1DMASA;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     fifo_mode:8;
+unsigned int     reserved_1:2;
+unsigned int     dma_extra:1;
+unsigned int     uart_add_encoded_params:1;
+unsigned int     shadow:1;
+unsigned int     fifo_stat:1;
+unsigned int     fifo_access:1;
+unsigned int     additional_feat:1;
+unsigned int     sir_lp_mode:1;
+unsigned int     sir_mode:1;
+unsigned int     thre_mode:1;
+unsigned int     afce_mode:1;
+unsigned int     reserved_2:2;
+unsigned int     apb_data_width:2;
+}MIS_U1CPR;
+
+typedef struct 
+{
+unsigned int     ucv:32;
+}MIS_U1UCV;
+
+typedef struct 
+{
+unsigned int     ctr:32;
+}MIS_U1CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     ic_slave_disable:1;
+unsigned int     ic_restart_en:1;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     ic_10bitaddr_slave:1;
+unsigned int     speed:2;
+unsigned int     master_mode:1;
+}MIS_IC1_CON;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     special:1;
+unsigned int     gc_or_start:1;
+unsigned int     ic_tar:10;
+}MIS_IC1_TAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     ic_sar:10;
+}MIS_IC1_SAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ic_hs_mar:3;
+}MIS_IC1_HS_MADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     restart:1;
+unsigned int     stop:1;
+unsigned int     cmd:1;
+unsigned int     dat:8;
+}MIS_IC1_DATA_CMD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_hcnt:16;
+}MIS_IC1_SS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_lcnt:16;
+}MIS_IC1_SS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_hcnt:16;
+}MIS_IC1_FS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_lcnt:16;
+}MIS_IC1_FS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     r_gen_call:1;
+unsigned int     r_start_det:1;
+unsigned int     r_stop_det:1;
+unsigned int     r_activity:1;
+unsigned int     r_rx_done:1;
+unsigned int     r_tx_abrt:1;
+unsigned int     r_rd_req:1;
+unsigned int     r_tx_empty:1;
+unsigned int     r_tx_over:1;
+unsigned int     r_rx_full:1;
+unsigned int     r_rx_over:1;
+unsigned int     r_rx_under:1;
+}MIS_IC1_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     m_gen_call:1;
+unsigned int     m_start_det:1;
+unsigned int     m_stop_det:1;
+unsigned int     m_activity:1;
+unsigned int     m_rx_done:1;
+unsigned int     m_tx_abrt:1;
+unsigned int     m_rd_req:1;
+unsigned int     m_tx_empty:1;
+unsigned int     m_tx_over:1;
+unsigned int     m_rx_full:1;
+unsigned int     m_rx_over:1;
+unsigned int     m_rx_under:1;
+}MIS_IC1_INTR_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     gen_call:1;
+unsigned int     start_det:1;
+unsigned int     stop_det:1;
+unsigned int     activity:1;
+unsigned int     rx_done:1;
+unsigned int     tx_abrt:1;
+unsigned int     rd_req:1;
+unsigned int     tx_empty:1;
+unsigned int     tx_over:1;
+unsigned int     rx_full:1;
+unsigned int     rx_over:1;
+unsigned int     rx_under:1;
+}MIS_IC1_RAW_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rx_tl:8;
+}MIS_IC1_RX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tx_tl:8;
+}MIS_IC1_TX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_intr:1;
+}MIS_IC1_CLR_INTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_under:1;
+}MIS_IC1_CLR_RX_UNDER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_over:1;
+}MIS_IC1_CLR_RX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_over:1;
+}MIS_IC1_CLR_TX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rd_req:1;
+}MIS_IC1_CLR_RD_REQ;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_abrt:1;
+}MIS_IC1_CLR_TX_ABRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_done:1;
+}MIS_IC1_CLR_RX_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_activity:1;
+}MIS_IC1_CLR_ACTIVITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_stop_det:1;
+}MIS_IC1_CLR_STOP_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_start_det:1;
+}MIS_IC1_CLR_START_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_gen_call:1;
+}MIS_IC1_CLR_GEN_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}MIS_IC1_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     slv_activity:1;
+unsigned int     mst_activity:1;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     activity:1;
+}MIS_IC1_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     txflr:4;
+}MIS_IC1_TXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     rxflr:4;
+}MIS_IC1_RXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sda_hold:16;
+}MIS_IC1_SDA_HOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     abrt_slvrd_intx:1;
+unsigned int     abrt_slv_arblost:1;
+unsigned int     abrt_slvflush_txfifo:1;
+unsigned int     arb_lost:1;
+unsigned int     arb_master_dis:1;
+unsigned int     abrt_10b_rd_norstrt:1;
+unsigned int     abrt_sbyte_norstrt:1;
+unsigned int     abrt_hs_norstrt:1;
+unsigned int     abrt_sbyte_ackdet:1;
+unsigned int     abrt_hs_ackdet:1;
+unsigned int     abrt_gcall_read:1;
+unsigned int     abrt_gcall_noack:1;
+unsigned int     abrt_txdata_noack:1;
+unsigned int     abrt_10addr2_noack:1;
+unsigned int     abrt_10addr1_noack:1;
+unsigned int     abrt_7b_addr_noack:1;
+}MIS_IC1_TX_ABRT_SOURCE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     nack:1;
+}MIS_IC1_SLV_DATA_NACK_ONLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     tdmae:1;
+unsigned int     rdmae:1;
+}MIS_IC1_DMA_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     dmatdl:3;
+}MIS_IC1_DMA_TDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     dmardl:4;
+}MIS_IC1_DMA_RDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sda_setup:8;
+}MIS_IC1_SDA_SETUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     ack_gen_call:1;
+}MIS_IC1_ACK_GENERAL_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     slv_rx_data_lost:1;
+unsigned int     slv_disabled_whi:1;
+unsigned int     ic_en:1;
+}MIS_IC1_ENABLE_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tx_buffer_depth:8;
+unsigned int     rx_buffer_depth:8;
+unsigned int     add_encoded_params:1;
+unsigned int     has_dma:1;
+unsigned int     intr_io:1;
+unsigned int     hc_count_values:1;
+unsigned int     max_speed_mode:2;
+unsigned int     apb_data_width:2;
+}MIS_IC1_COMP_PARAM_1;
+
+typedef struct 
+{
+unsigned int     ic_comp_version:32;
+}MIS_IC1_COMP_VERSION;
+
+typedef struct 
+{
+unsigned int     ic_comp_type:32;
+}MIS_IC1_COMP_TYPE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     ic_slave_disable:1;
+unsigned int     ic_restart_en:1;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     ic_10bitaddr_slave:1;
+unsigned int     speed:2;
+unsigned int     master_mode:1;
+}MIS_IC2_CON;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     special:1;
+unsigned int     gc_or_start:1;
+unsigned int     ic_tar:10;
+}MIS_IC2_TAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     ic_sar:10;
+}MIS_IC2_SAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ic_hs_mar:3;
+}MIS_IC2_HS_MADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     restart:1;
+unsigned int     stop:1;
+unsigned int     cmd:1;
+unsigned int     dat:8;
+}MIS_IC2_DATA_CMD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_hcnt:16;
+}MIS_IC2_SS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_lcnt:16;
+}MIS_IC2_SS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_hcnt:16;
+}MIS_IC2_FS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_lcnt:16;
+}MIS_IC2_FS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     r_gen_call:1;
+unsigned int     r_start_det:1;
+unsigned int     r_stop_det:1;
+unsigned int     r_activity:1;
+unsigned int     r_rx_done:1;
+unsigned int     r_tx_abrt:1;
+unsigned int     r_rd_req:1;
+unsigned int     r_tx_empty:1;
+unsigned int     r_tx_over:1;
+unsigned int     r_rx_full:1;
+unsigned int     r_rx_over:1;
+unsigned int     r_rx_under:1;
+}MIS_IC2_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     m_gen_call:1;
+unsigned int     m_start_det:1;
+unsigned int     m_stop_det:1;
+unsigned int     m_activity:1;
+unsigned int     m_rx_done:1;
+unsigned int     m_tx_abrt:1;
+unsigned int     m_rd_req:1;
+unsigned int     m_tx_empty:1;
+unsigned int     m_tx_over:1;
+unsigned int     m_rx_full:1;
+unsigned int     m_rx_over:1;
+unsigned int     m_rx_under:1;
+}MIS_IC2_INTR_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     gen_call:1;
+unsigned int     start_det:1;
+unsigned int     stop_det:1;
+unsigned int     activity:1;
+unsigned int     rx_done:1;
+unsigned int     tx_abrt:1;
+unsigned int     rd_req:1;
+unsigned int     tx_empty:1;
+unsigned int     tx_over:1;
+unsigned int     rx_full:1;
+unsigned int     rx_over:1;
+unsigned int     rx_under:1;
+}MIS_IC2_RAW_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rx_tl:8;
+}MIS_IC2_RX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tx_tl:8;
+}MIS_IC2_TX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_intr:1;
+}MIS_IC2_CLR_INTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_under:1;
+}MIS_IC2_CLR_RX_UNDER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_over:1;
+}MIS_IC2_CLR_RX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_over:1;
+}MIS_IC2_CLR_TX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rd_req:1;
+}MIS_IC2_CLR_RD_REQ;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_abrt:1;
+}MIS_IC2_CLR_TX_ABRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_done:1;
+}MIS_IC2_CLR_RX_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_activity:1;
+}MIS_IC2_CLR_ACTIVITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_stop_det:1;
+}MIS_IC2_CLR_STOP_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_start_det:1;
+}MIS_IC2_CLR_START_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_gen_call:1;
+}MIS_IC2_CLR_GEN_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}MIS_IC2_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     slv_activity:1;
+unsigned int     mst_activity:1;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     activity:1;
+}MIS_IC2_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     txflr:4;
+}MIS_IC2_TXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     rxflr:4;
+}MIS_IC2_RXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sda_hold:16;
+}MIS_IC2_SDA_HOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     abrt_slvrd_intx:1;
+unsigned int     abrt_slv_arblost:1;
+unsigned int     abrt_slvflush_txfifo:1;
+unsigned int     arb_lost:1;
+unsigned int     arb_master_dis:1;
+unsigned int     abrt_10b_rd_norstrt:1;
+unsigned int     abrt_sbyte_norstrt:1;
+unsigned int     abrt_hs_norstrt:1;
+unsigned int     abrt_sbyte_ackdet:1;
+unsigned int     abrt_hs_ackdet:1;
+unsigned int     abrt_gcall_read:1;
+unsigned int     abrt_gcall_noack:1;
+unsigned int     abrt_txdata_noack:1;
+unsigned int     abrt_10addr2_noack:1;
+unsigned int     abrt_10addr1_noack:1;
+unsigned int     abrt_7b_addr_noack:1;
+}MIS_IC2_TX_ABRT_SOURCE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     nack:1;
+}MIS_IC2_SLV_DATA_NACK_ONLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     tdmae:1;
+unsigned int     rdmae:1;
+}MIS_IC2_DMA_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     dmatdl:3;
+}MIS_IC2_DMA_TDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     dmardl:4;
+}MIS_IC2_DMA_RDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sda_setup:8;
+}MIS_IC2_SDA_SETUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     ack_gen_call:1;
+}MIS_IC2_ACK_GENERAL_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     slv_rx_data_lost:1;
+unsigned int     slv_disabled_whi:1;
+unsigned int     ic_en:1;
+}MIS_IC2_ENABLE_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tx_buffer_depth:8;
+unsigned int     rx_buffer_depth:8;
+unsigned int     add_encoded_params:1;
+unsigned int     has_dma:1;
+unsigned int     intr_io:1;
+unsigned int     hc_count_values:1;
+unsigned int     max_speed_mode:2;
+unsigned int     apb_data_width:2;
+}MIS_IC2_COMP_PARAM_1;
+
+typedef struct 
+{
+unsigned int     ic_comp_version:32;
+}MIS_IC2_COMP_VERSION;
+
+typedef struct 
+{
+unsigned int     ic_comp_type:32;
+}MIS_IC2_COMP_TYPE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     ic_slave_disable:1;
+unsigned int     ic_restart_en:1;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     ic_10bitaddr_slave:1;
+unsigned int     speed:2;
+unsigned int     master_mode:1;
+}MIS_IC3_CON;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     special:1;
+unsigned int     gc_or_start:1;
+unsigned int     ic_tar:10;
+}MIS_IC3_TAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     ic_sar:10;
+}MIS_IC3_SAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ic_hs_mar:3;
+}MIS_IC3_HS_MADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     restart:1;
+unsigned int     stop:1;
+unsigned int     cmd:1;
+unsigned int     dat:8;
+}MIS_IC3_DATA_CMD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_hcnt:16;
+}MIS_IC3_SS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_lcnt:16;
+}MIS_IC3_SS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_hcnt:16;
+}MIS_IC3_FS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_lcnt:16;
+}MIS_IC3_FS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     r_gen_call:1;
+unsigned int     r_start_det:1;
+unsigned int     r_stop_det:1;
+unsigned int     r_activity:1;
+unsigned int     r_rx_done:1;
+unsigned int     r_tx_abrt:1;
+unsigned int     r_rd_req:1;
+unsigned int     r_tx_empty:1;
+unsigned int     r_tx_over:1;
+unsigned int     r_rx_full:1;
+unsigned int     r_rx_over:1;
+unsigned int     r_rx_under:1;
+}MIS_IC3_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     m_gen_call:1;
+unsigned int     m_start_det:1;
+unsigned int     m_stop_det:1;
+unsigned int     m_activity:1;
+unsigned int     m_rx_done:1;
+unsigned int     m_tx_abrt:1;
+unsigned int     m_rd_req:1;
+unsigned int     m_tx_empty:1;
+unsigned int     m_tx_over:1;
+unsigned int     m_rx_full:1;
+unsigned int     m_rx_over:1;
+unsigned int     m_rx_under:1;
+}MIS_IC3_INTR_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     gen_call:1;
+unsigned int     start_det:1;
+unsigned int     stop_det:1;
+unsigned int     activity:1;
+unsigned int     rx_done:1;
+unsigned int     tx_abrt:1;
+unsigned int     rd_req:1;
+unsigned int     tx_empty:1;
+unsigned int     tx_over:1;
+unsigned int     rx_full:1;
+unsigned int     rx_over:1;
+unsigned int     rx_under:1;
+}MIS_IC3_RAW_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rx_tl:8;
+}MIS_IC3_RX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tx_tl:8;
+}MIS_IC3_TX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_intr:1;
+}MIS_IC3_CLR_INTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_under:1;
+}MIS_IC3_CLR_RX_UNDER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_over:1;
+}MIS_IC3_CLR_RX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_over:1;
+}MIS_IC3_CLR_TX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rd_req:1;
+}MIS_IC3_CLR_RD_REQ;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_abrt:1;
+}MIS_IC3_CLR_TX_ABRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_done:1;
+}MIS_IC3_CLR_RX_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_activity:1;
+}MIS_IC3_CLR_ACTIVITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_stop_det:1;
+}MIS_IC3_CLR_STOP_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_start_det:1;
+}MIS_IC3_CLR_START_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_gen_call:1;
+}MIS_IC3_CLR_GEN_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}MIS_IC3_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     slv_activity:1;
+unsigned int     mst_activity:1;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     activity:1;
+}MIS_IC3_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     txflr:4;
+}MIS_IC3_TXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     rxflr:4;
+}MIS_IC3_RXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sda_hold:16;
+}MIS_IC3_SDA_HOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     abrt_slvrd_intx:1;
+unsigned int     abrt_slv_arblost:1;
+unsigned int     abrt_slvflush_txfifo:1;
+unsigned int     arb_lost:1;
+unsigned int     arb_master_dis:1;
+unsigned int     abrt_10b_rd_norstrt:1;
+unsigned int     abrt_sbyte_norstrt:1;
+unsigned int     abrt_hs_norstrt:1;
+unsigned int     abrt_sbyte_ackdet:1;
+unsigned int     abrt_hs_ackdet:1;
+unsigned int     abrt_gcall_read:1;
+unsigned int     abrt_gcall_noack:1;
+unsigned int     abrt_txdata_noack:1;
+unsigned int     abrt_10addr2_noack:1;
+unsigned int     abrt_10addr1_noack:1;
+unsigned int     abrt_7b_addr_noack:1;
+}MIS_IC3_TX_ABRT_SOURCE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     nack:1;
+}MIS_IC3_SLV_DATA_NACK_ONLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     tdmae:1;
+unsigned int     rdmae:1;
+}MIS_IC3_DMA_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     dmatdl:3;
+}MIS_IC3_DMA_TDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     dmardl:4;
+}MIS_IC3_DMA_RDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sda_setup:8;
+}MIS_IC3_SDA_SETUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     ack_gen_call:1;
+}MIS_IC3_ACK_GENERAL_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     slv_rx_data_lost:1;
+unsigned int     slv_disabled_whi:1;
+unsigned int     ic_en:1;
+}MIS_IC3_ENABLE_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tx_buffer_depth:8;
+unsigned int     rx_buffer_depth:8;
+unsigned int     add_encoded_params:1;
+unsigned int     has_dma:1;
+unsigned int     intr_io:1;
+unsigned int     hc_count_values:1;
+unsigned int     max_speed_mode:2;
+unsigned int     apb_data_width:2;
+}MIS_IC3_COMP_PARAM_1;
+
+typedef struct 
+{
+unsigned int     ic_comp_version:32;
+}MIS_IC3_COMP_VERSION;
+
+typedef struct 
+{
+unsigned int     ic_comp_type:32;
+}MIS_IC3_COMP_TYPE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     ic_slave_disable:1;
+unsigned int     ic_restart_en:1;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     ic_10bitaddr_slave:1;
+unsigned int     speed:2;
+unsigned int     master_mode:1;
+}MIS_IC4_CON;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     special:1;
+unsigned int     gc_or_start:1;
+unsigned int     ic_tar:10;
+}MIS_IC4_TAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     ic_sar:10;
+}MIS_IC4_SAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ic_hs_mar:3;
+}MIS_IC4_HS_MADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     restart:1;
+unsigned int     stop:1;
+unsigned int     cmd:1;
+unsigned int     dat:8;
+}MIS_IC4_DATA_CMD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_hcnt:16;
+}MIS_IC4_SS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_lcnt:16;
+}MIS_IC4_SS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_hcnt:16;
+}MIS_IC4_FS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_lcnt:16;
+}MIS_IC4_FS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     r_gen_call:1;
+unsigned int     r_start_det:1;
+unsigned int     r_stop_det:1;
+unsigned int     r_activity:1;
+unsigned int     r_rx_done:1;
+unsigned int     r_tx_abrt:1;
+unsigned int     r_rd_req:1;
+unsigned int     r_tx_empty:1;
+unsigned int     r_tx_over:1;
+unsigned int     r_rx_full:1;
+unsigned int     r_rx_over:1;
+unsigned int     r_rx_under:1;
+}MIS_IC4_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     m_gen_call:1;
+unsigned int     m_start_det:1;
+unsigned int     m_stop_det:1;
+unsigned int     m_activity:1;
+unsigned int     m_rx_done:1;
+unsigned int     m_tx_abrt:1;
+unsigned int     m_rd_req:1;
+unsigned int     m_tx_empty:1;
+unsigned int     m_tx_over:1;
+unsigned int     m_rx_full:1;
+unsigned int     m_rx_over:1;
+unsigned int     m_rx_under:1;
+}MIS_IC4_INTR_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     gen_call:1;
+unsigned int     start_det:1;
+unsigned int     stop_det:1;
+unsigned int     activity:1;
+unsigned int     rx_done:1;
+unsigned int     tx_abrt:1;
+unsigned int     rd_req:1;
+unsigned int     tx_empty:1;
+unsigned int     tx_over:1;
+unsigned int     rx_full:1;
+unsigned int     rx_over:1;
+unsigned int     rx_under:1;
+}MIS_IC4_RAW_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rx_tl:8;
+}MIS_IC4_RX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tx_tl:8;
+}MIS_IC4_TX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_intr:1;
+}MIS_IC4_CLR_INTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_under:1;
+}MIS_IC4_CLR_RX_UNDER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_over:1;
+}MIS_IC4_CLR_RX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_over:1;
+}MIS_IC4_CLR_TX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rd_req:1;
+}MIS_IC4_CLR_RD_REQ;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_abrt:1;
+}MIS_IC4_CLR_TX_ABRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_done:1;
+}MIS_IC4_CLR_RX_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_activity:1;
+}MIS_IC4_CLR_ACTIVITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_stop_det:1;
+}MIS_IC4_CLR_STOP_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_start_det:1;
+}MIS_IC4_CLR_START_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_gen_call:1;
+}MIS_IC4_CLR_GEN_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}MIS_IC4_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     slv_activity:1;
+unsigned int     mst_activity:1;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     activity:1;
+}MIS_IC4_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     txflr:4;
+}MIS_IC4_TXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     rxflr:4;
+}MIS_IC4_RXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sda_hold:16;
+}MIS_IC4_SDA_HOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     abrt_slvrd_intx:1;
+unsigned int     abrt_slv_arblost:1;
+unsigned int     abrt_slvflush_txfifo:1;
+unsigned int     arb_lost:1;
+unsigned int     arb_master_dis:1;
+unsigned int     abrt_10b_rd_norstrt:1;
+unsigned int     abrt_sbyte_norstrt:1;
+unsigned int     abrt_hs_norstrt:1;
+unsigned int     abrt_sbyte_ackdet:1;
+unsigned int     abrt_hs_ackdet:1;
+unsigned int     abrt_gcall_read:1;
+unsigned int     abrt_gcall_noack:1;
+unsigned int     abrt_txdata_noack:1;
+unsigned int     abrt_10addr2_noack:1;
+unsigned int     abrt_10addr1_noack:1;
+unsigned int     abrt_7b_addr_noack:1;
+}MIS_IC4_TX_ABRT_SOURCE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     nack:1;
+}MIS_IC4_SLV_DATA_NACK_ONLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     tdmae:1;
+unsigned int     rdmae:1;
+}MIS_IC4_DMA_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     dmatdl:3;
+}MIS_IC4_DMA_TDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     dmardl:4;
+}MIS_IC4_DMA_RDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sda_setup:8;
+}MIS_IC4_SDA_SETUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     ack_gen_call:1;
+}MIS_IC4_ACK_GENERAL_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     slv_rx_data_lost:1;
+unsigned int     slv_disabled_whi:1;
+unsigned int     ic_en:1;
+}MIS_IC4_ENABLE_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tx_buffer_depth:8;
+unsigned int     rx_buffer_depth:8;
+unsigned int     add_encoded_params:1;
+unsigned int     has_dma:1;
+unsigned int     intr_io:1;
+unsigned int     hc_count_values:1;
+unsigned int     max_speed_mode:2;
+unsigned int     apb_data_width:2;
+}MIS_IC4_COMP_PARAM_1;
+
+typedef struct 
+{
+unsigned int     ic_comp_version:32;
+}MIS_IC4_COMP_VERSION;
+
+typedef struct 
+{
+unsigned int     ic_comp_type:32;
+}MIS_IC4_COMP_TYPE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     ic_slave_disable:1;
+unsigned int     ic_restart_en:1;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     ic_10bitaddr_slave:1;
+unsigned int     speed:2;
+unsigned int     master_mode:1;
+}MIS_IC5_CON;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     ic_10bitaddr_master:1;
+unsigned int     special:1;
+unsigned int     gc_or_start:1;
+unsigned int     ic_tar:10;
+}MIS_IC5_TAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     ic_sar:10;
+}MIS_IC5_SAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     ic_hs_mar:3;
+}MIS_IC5_HS_MADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     restart:1;
+unsigned int     stop:1;
+unsigned int     cmd:1;
+unsigned int     dat:8;
+}MIS_IC5_DATA_CMD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_hcnt:16;
+}MIS_IC5_SS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_ss_scl_lcnt:16;
+}MIS_IC5_SS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_hcnt:16;
+}MIS_IC5_FS_SCL_HCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ic_fs_scl_lcnt:16;
+}MIS_IC5_FS_SCL_LCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     r_gen_call:1;
+unsigned int     r_start_det:1;
+unsigned int     r_stop_det:1;
+unsigned int     r_activity:1;
+unsigned int     r_rx_done:1;
+unsigned int     r_tx_abrt:1;
+unsigned int     r_rd_req:1;
+unsigned int     r_tx_empty:1;
+unsigned int     r_tx_over:1;
+unsigned int     r_rx_full:1;
+unsigned int     r_rx_over:1;
+unsigned int     r_rx_under:1;
+}MIS_IC5_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     m_gen_call:1;
+unsigned int     m_start_det:1;
+unsigned int     m_stop_det:1;
+unsigned int     m_activity:1;
+unsigned int     m_rx_done:1;
+unsigned int     m_tx_abrt:1;
+unsigned int     m_rd_req:1;
+unsigned int     m_tx_empty:1;
+unsigned int     m_tx_over:1;
+unsigned int     m_rx_full:1;
+unsigned int     m_rx_over:1;
+unsigned int     m_rx_under:1;
+}MIS_IC5_INTR_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     gen_call:1;
+unsigned int     start_det:1;
+unsigned int     stop_det:1;
+unsigned int     activity:1;
+unsigned int     rx_done:1;
+unsigned int     tx_abrt:1;
+unsigned int     rd_req:1;
+unsigned int     tx_empty:1;
+unsigned int     tx_over:1;
+unsigned int     rx_full:1;
+unsigned int     rx_over:1;
+unsigned int     rx_under:1;
+}MIS_IC5_RAW_INTR_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rx_tl:8;
+}MIS_IC5_RX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tx_tl:8;
+}MIS_IC5_TX_TL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_intr:1;
+}MIS_IC5_CLR_INTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_under:1;
+}MIS_IC5_CLR_RX_UNDER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_over:1;
+}MIS_IC5_CLR_RX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_over:1;
+}MIS_IC5_CLR_TX_OVER;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rd_req:1;
+}MIS_IC5_CLR_RD_REQ;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_tx_abrt:1;
+}MIS_IC5_CLR_TX_ABRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_rx_done:1;
+}MIS_IC5_CLR_RX_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_activity:1;
+}MIS_IC5_CLR_ACTIVITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_stop_det:1;
+}MIS_IC5_CLR_STOP_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_start_det:1;
+}MIS_IC5_CLR_START_DET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     clr_gen_call:1;
+}MIS_IC5_CLR_GEN_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}MIS_IC5_ENABLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     slv_activity:1;
+unsigned int     mst_activity:1;
+unsigned int     rff:1;
+unsigned int     rfne:1;
+unsigned int     tfe:1;
+unsigned int     tfnf:1;
+unsigned int     activity:1;
+}MIS_IC5_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     txflr:4;
+}MIS_IC5_TXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     rxflr:4;
+}MIS_IC5_RXFLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     sda_hold:16;
+}MIS_IC5_SDA_HOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     abrt_slvrd_intx:1;
+unsigned int     abrt_slv_arblost:1;
+unsigned int     abrt_slvflush_txfifo:1;
+unsigned int     arb_lost:1;
+unsigned int     arb_master_dis:1;
+unsigned int     abrt_10b_rd_norstrt:1;
+unsigned int     abrt_sbyte_norstrt:1;
+unsigned int     abrt_hs_norstrt:1;
+unsigned int     abrt_sbyte_ackdet:1;
+unsigned int     abrt_hs_ackdet:1;
+unsigned int     abrt_gcall_read:1;
+unsigned int     abrt_gcall_noack:1;
+unsigned int     abrt_txdata_noack:1;
+unsigned int     abrt_10addr2_noack:1;
+unsigned int     abrt_10addr1_noack:1;
+unsigned int     abrt_7b_addr_noack:1;
+}MIS_IC5_TX_ABRT_SOURCE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     nack:1;
+}MIS_IC5_SLV_DATA_NACK_ONLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     tdmae:1;
+unsigned int     rdmae:1;
+}MIS_IC5_DMA_CR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     dmatdl:3;
+}MIS_IC5_DMA_TDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     dmardl:4;
+}MIS_IC5_DMA_RDLR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sda_setup:8;
+}MIS_IC5_SDA_SETUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     ack_gen_call:1;
+}MIS_IC5_ACK_GENERAL_CALL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     slv_rx_data_lost:1;
+unsigned int     slv_disabled_whi:1;
+unsigned int     ic_en:1;
+}MIS_IC5_ENABLE_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     tx_buffer_depth:8;
+unsigned int     rx_buffer_depth:8;
+unsigned int     add_encoded_params:1;
+unsigned int     has_dma:1;
+unsigned int     intr_io:1;
+unsigned int     hc_count_values:1;
+unsigned int     max_speed_mode:2;
+unsigned int     apb_data_width:2;
+}MIS_IC5_COMP_PARAM_1;
+
+typedef struct 
+{
+unsigned int     ic_comp_version:32;
+}MIS_IC5_COMP_VERSION;
+
+typedef struct 
+{
+unsigned int     ic_comp_type:32;
+}MIS_IC5_COMP_TYPE;
+
+typedef struct 
+{
+unsigned int     tc0tvr:32;
+}MIS_TC0TVR;
+
+typedef struct 
+{
+unsigned int     tc1tvr:32;
+}MIS_TC1TVR;
+
+typedef struct 
+{
+unsigned int     tc2tvr:32;
+}MIS_TC2TVR;
+
+typedef struct 
+{
+unsigned int     tc0cvr:32;
+}MIS_TC0CVR;
+
+typedef struct 
+{
+unsigned int     tc1cvr:32;
+}MIS_TC1CVR;
+
+typedef struct 
+{
+unsigned int     tc2vr:32;
+}MIS_TC2CVR;
+
+typedef struct 
+{
+unsigned int     tc0en:1;
+unsigned int     tc0mode:1;
+unsigned int     tc0pause:1;
+unsigned int     rvda:5;
+unsigned int     reserved_0:24;
+}MIS_TC0CR;
+
+typedef struct 
+{
+unsigned int     tc1en:1;
+unsigned int     tc1mode:1;
+unsigned int     tc1pause:1;
+unsigned int     rvda:5;
+unsigned int     reserved_0:24;
+}MIS_TC1CR;
+
+typedef struct 
+{
+unsigned int     tc2en:1;
+unsigned int     tc2mode:1;
+unsigned int     tc2pause:1;
+unsigned int     rvda:5;
+unsigned int     reserved_0:24;
+}MIS_TC2CR;
+
+typedef struct 
+{
+unsigned int     tc0ie:1;
+unsigned int     reserved_0:31;
+}MIS_TC0ICR;
+
+typedef struct 
+{
+unsigned int     tc1ie:1;
+unsigned int     reserved_0:31;
+}MIS_TC1ICR;
+
+typedef struct 
+{
+unsigned int     tc2ie:1;
+unsigned int     reserved_0:31;
+}MIS_TC2ICR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     en:1;
+}MIS_CLK90K_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}MIS_SCPU_CLK27M_90K;
+
+typedef struct 
+{
+unsigned int     val:32;
+}MIS_SCPU_CLK90K_LO;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     val:16;
+}MIS_SCPU_CLK90K_HI;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}MIS_ACPU_CLK27M_90K;
+
+typedef struct 
+{
+unsigned int     val:32;
+}MIS_ACPU_CLK90K_LO;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     val:16;
+}MIS_ACPU_CLK90K_HI;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     en:1;
+}MIS_PCR_CLK90K_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}MIS_PCR_SCPU_CLK27M_90K;
+
+typedef struct 
+{
+unsigned int     val:32;
+}MIS_PCR_SCPU_CLK90K_LO;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     val:16;
+}MIS_PCR_SCPU_CLK90K_HI;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}MIS_PCR_ACPU_CLK27M_90K;
+
+typedef struct 
+{
+unsigned int     val:32;
+}MIS_PCR_ACPU_CLK90K_LO;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     val:16;
+}MIS_PCR_ACPU_CLK90K_HI;
+
+typedef struct 
+{
+unsigned int     wd_int_en:1;
+unsigned int     reserved_0:15;
+unsigned int     nmic:4;
+unsigned int     wdc:4;
+unsigned int     wden:8;
+}MIS_TCWCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     wdclr:1;
+}MIS_TCWTR;
+
+typedef struct 
+{
+unsigned int     sel:32;
+}MIS_TCWNMI;
+
+typedef struct 
+{
+unsigned int     sel:32;
+}MIS_TCWOV;
+
+typedef struct 
+{
+unsigned int     wd_int_en:1;
+unsigned int     reserved_0:15;
+unsigned int     nmic:4;
+unsigned int     wdc:4;
+unsigned int     wden:8;
+}MIS_TCWCR_SWC;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     wdclr:1;
+}MIS_TCWTR_SWC;
+
+typedef struct 
+{
+unsigned int     sel:32;
+}MIS_TCWNMI_SWC;
+
+typedef struct 
+{
+unsigned int     sel:32;
+}MIS_TCWOV_SWC;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     rtcsec:7;
+}MIS_RTCSEC;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     rtcmin:6;
+}MIS_RTCMIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     rtchr:5;
+}MIS_RTCHR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rtcdate1:8;
+}MIS_RTCDATE1;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     rtcdate2:7;
+}MIS_RTCDATE2;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     almmin:6;
+}MIS_ALMMIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     almhr:5;
+}MIS_ALMHR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     almdate1:8;
+}MIS_ALMDATE1;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     almdate2:7;
+}MIS_ALMDATE2;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     vref:2;
+unsigned int     rtcstop:1;
+}MIS_RTCSTOP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rtcpwr:1;
+unsigned int     co:2;
+unsigned int     ci:2;
+unsigned int     clksel:1;
+unsigned int     bc:2;
+}MIS_RTCACR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rtcen:8;
+}MIS_RTCEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     rtcrst:1;
+unsigned int     reserved_1:2;
+unsigned int     dainte:1;
+unsigned int     huinte:1;
+unsigned int     muinte:1;
+unsigned int     hsuinte:1;
+}MIS_RTCCR;
+
+typedef struct 
+{
+unsigned int     pad0_active:1;
+unsigned int     reserved_0:7;
+unsigned int     pad0_thred:8;
+unsigned int     pad0_sw:4;
+unsigned int     reserved_1:3;
+unsigned int     pad0_ctrl:1;
+unsigned int     reserved_2:2;
+unsigned int     adc_val0:6;
+}MIS_ST_PAD0;
+
+typedef struct 
+{
+unsigned int     pad1_active:1;
+unsigned int     reserved_0:7;
+unsigned int     pad1_thred:8;
+unsigned int     pad1_sw:4;
+unsigned int     reserved_1:3;
+unsigned int     pad1_ctrl:1;
+unsigned int     reserved_2:2;
+unsigned int     50:6;
+}MIS_ST_PAD1;
+
+typedef struct 
+{
+unsigned int     sel_wait:4;
+unsigned int     sel_adc_ck:4;
+unsigned int     debounce_cnt:4;
+unsigned int     reserved_0:4;
+unsigned int     dout_test_in:8;
+unsigned int     reserved_1:6;
+unsigned int     test_en:1;
+unsigned int     enable:1;
+}MIS_ST_LSADC_CTRL;
+
+typedef struct 
+{
+unsigned int     irq_en:8;
+unsigned int     pad_cnt:4;
+unsigned int     adc_busy:1;
+unsigned int     reserved_0:2;
+unsigned int     pad_ctrl:5;
+unsigned int     reserved_1:10;
+unsigned int     pad1_status:1;
+unsigned int     pad0_status:1;
+}MIS_ST_LSADC_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     jd_sbias:2;
+unsigned int     reserved_1:2;
+unsigned int     jd_adsbias:2;
+unsigned int     jd_dummy:2;
+unsigned int     reserved_2:1;
+unsigned int     jd_svr:1;
+unsigned int     reserved_3:3;
+unsigned int     jd_adcksel:1;
+unsigned int     reserved_4:3;
+unsigned int     jd_power:1;
+}MIS_ST_LSADC_ANALOG_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     lsadc_2_ifd_data_sel:3;
+unsigned int     reserved_1:1;
+unsigned int     power_saving_enable:1;
+unsigned int     power_saving_cycle_time:3;
+unsigned int     power_saving_disable_time:3;
+unsigned int     peri_top_debug:8;
+}MIS_ST_LSADC_PERI_TOP_DEBUG;
+
+typedef struct 
+{
+unsigned int     level_0_top_bound:8;
+unsigned int     level_0_low_bound:8;
+unsigned int     block0_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en0:1;
+unsigned int     int_pending_bit0:1;
+}MIS_LSADC_PAD0_LEVEL_SET0;
+
+typedef struct 
+{
+unsigned int     level_1_top_bound:8;
+unsigned int     level_0_low_bound:8;
+unsigned int     block1_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en1:1;
+unsigned int     int_pending_bit1:1;
+}MIS_LSADC_PAD0_LEVEL_SET1;
+
+typedef struct 
+{
+unsigned int     level_2_top_bound:8;
+unsigned int     level_2_low_bound:8;
+unsigned int     block2_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en2:1;
+unsigned int     int_pending_bit2:1;
+}MIS_LSADC_PAD0_LEVEL_SET2;
+
+typedef struct 
+{
+unsigned int     level_3_top_bound:8;
+unsigned int     level_3_low_bound:8;
+unsigned int     block3_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en3:1;
+unsigned int     int_pending_bit3:1;
+}MIS_LSADC_PAD0_LEVEL_SET3;
+
+typedef struct 
+{
+unsigned int     level_4_top_bound:8;
+unsigned int     level_4_low_bound:8;
+unsigned int     block4_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en4:1;
+unsigned int     int_pending_bit4:1;
+}MIS_LSADC_PAD0_LEVEL_SET4;
+
+typedef struct 
+{
+unsigned int     level_5_top_bound:8;
+unsigned int     level_5_low_bound:8;
+unsigned int     block5_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en5:1;
+unsigned int     int_pending_bit5:1;
+}MIS_LSADC_PAD0_LEVEL_SET5;
+
+typedef struct 
+{
+unsigned int     level_0_top_bound:8;
+unsigned int     level_0_low_bound:8;
+unsigned int     block0_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en0:1;
+unsigned int     int_pending_bit0:1;
+}MIS_LSADC_PAD1_LEVEL_SET0;
+
+typedef struct 
+{
+unsigned int     level_1_top_bound:8;
+unsigned int     level_0_low_bound:8;
+unsigned int     block1_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en1:1;
+unsigned int     int_pending_bit1:1;
+}MIS_LSADC_PAD1_LEVEL_SET1;
+
+typedef struct 
+{
+unsigned int     level_2_top_bound:8;
+unsigned int     level_2_low_bound:8;
+unsigned int     block2_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en2:1;
+unsigned int     int_pending_bit2:1;
+}MIS_LSADC_PAD1_LEVEL_SET2;
+
+typedef struct 
+{
+unsigned int     level_3_top_bound:8;
+unsigned int     level_3_low_bound:8;
+unsigned int     block3_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en3:1;
+unsigned int     int_pending_bit3:1;
+}MIS_LSADC_PAD1_LEVEL_SET3;
+
+typedef struct 
+{
+unsigned int     level_4_top_bound:8;
+unsigned int     level_4_low_bound:8;
+unsigned int     block4_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en4:1;
+unsigned int     int_pending_bit4:1;
+}MIS_LSADC_PAD1_LEVEL_SET4;
+
+typedef struct 
+{
+unsigned int     level_5_top_bound:8;
+unsigned int     level_5_low_bound:8;
+unsigned int     block5_en:1;
+unsigned int     reserved_0:13;
+unsigned int     int_en5:1;
+unsigned int     int_pending_bit5:1;
+}MIS_LSADC_PAD1_LEVEL_SET5;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     reserved_1:2;
+unsigned int     adc_value0latch:6;
+unsigned int     reserved_2:7;
+unsigned int     int_latchstatus:1;
+}MIS_LSADC_INT_PAD0;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     reserved_1:2;
+unsigned int     adc_value1latch:6;
+unsigned int     reserved_2:7;
+unsigned int     int_latchstatus:1;
+}MIS_LSADC_INT_PAD1;
+
+#endif
+
+#define MIS_UMSK_ISR                                                                 0x1801B008
+#define MIS_UMSK_ISR_reg_addr                                                        "0xB801B008"
+#define MIS_UMSK_ISR_reg                                                             0xB801B008
+#define set_MIS_UMSK_ISR_reg(data)   (*((volatile unsigned int*) MIS_UMSK_ISR_reg)=data)
+#define get_MIS_UMSK_ISR_reg   (*((volatile unsigned int*) MIS_UMSK_ISR_reg))
+#define MIS_UMSK_ISR_inst_adr                                                        "0x0002"
+#define MIS_UMSK_ISR_inst                                                            0x0002
+#define MIS_UMSK_ISR_gspi_int_shift                                                  (27)
+#define MIS_UMSK_ISR_gspi_int_mask                                                   (0x08000000)
+#define MIS_UMSK_ISR_gspi_int(data)                                                  (0x08000000&((data)<<27))
+#define MIS_UMSK_ISR_gspi_int_src(data)                                              ((0x08000000&(data))>>27)
+#define MIS_UMSK_ISR_get_gspi_int(data)                                              ((0x08000000&(data))>>27)
+#define MIS_UMSK_ISR_gpioda_int_shift                                                (20)
+#define MIS_UMSK_ISR_gpioda_int_mask                                                 (0x00100000)
+#define MIS_UMSK_ISR_gpioda_int(data)                                                (0x00100000&((data)<<20))
+#define MIS_UMSK_ISR_gpioda_int_src(data)                                            ((0x00100000&(data))>>20)
+#define MIS_UMSK_ISR_get_gpioda_int(data)                                            ((0x00100000&(data))>>20)
+#define MIS_UMSK_ISR_gpioa_int_shift                                                 (19)
+#define MIS_UMSK_ISR_gpioa_int_mask                                                  (0x00080000)
+#define MIS_UMSK_ISR_gpioa_int(data)                                                 (0x00080000&((data)<<19))
+#define MIS_UMSK_ISR_gpioa_int_src(data)                                             ((0x00080000&(data))>>19)
+#define MIS_UMSK_ISR_get_gpioa_int(data)                                             ((0x00080000&(data))>>19)
+#define MIS_UMSK_ISR_rtc_date_int_shift                                              (12)
+#define MIS_UMSK_ISR_rtc_date_int_mask                                               (0x00001000)
+#define MIS_UMSK_ISR_rtc_date_int(data)                                              (0x00001000&((data)<<12))
+#define MIS_UMSK_ISR_rtc_date_int_src(data)                                          ((0x00001000&(data))>>12)
+#define MIS_UMSK_ISR_get_rtc_date_int(data)                                          ((0x00001000&(data))>>12)
+#define MIS_UMSK_ISR_rtc_hour_int_shift                                              (11)
+#define MIS_UMSK_ISR_rtc_hour_int_mask                                               (0x00000800)
+#define MIS_UMSK_ISR_rtc_hour_int(data)                                              (0x00000800&((data)<<11))
+#define MIS_UMSK_ISR_rtc_hour_int_src(data)                                          ((0x00000800&(data))>>11)
+#define MIS_UMSK_ISR_get_rtc_hour_int(data)                                          ((0x00000800&(data))>>11)
+#define MIS_UMSK_ISR_rtc_min_int_shift                                               (10)
+#define MIS_UMSK_ISR_rtc_min_int_mask                                                (0x00000400)
+#define MIS_UMSK_ISR_rtc_min_int(data)                                               (0x00000400&((data)<<10))
+#define MIS_UMSK_ISR_rtc_min_int_src(data)                                           ((0x00000400&(data))>>10)
+#define MIS_UMSK_ISR_get_rtc_min_int(data)                                           ((0x00000400&(data))>>10)
+#define MIS_UMSK_ISR_rtc_hsec_int_shift                                              (9)
+#define MIS_UMSK_ISR_rtc_hsec_int_mask                                               (0x00000200)
+#define MIS_UMSK_ISR_rtc_hsec_int(data)                                              (0x00000200&((data)<<9))
+#define MIS_UMSK_ISR_rtc_hsec_int_src(data)                                          ((0x00000200&(data))>>9)
+#define MIS_UMSK_ISR_get_rtc_hsec_int(data)                                          ((0x00000200&(data))>>9)
+#define MIS_UMSK_ISR_tc1_int_shift                                                   (7)
+#define MIS_UMSK_ISR_tc1_int_mask                                                    (0x00000080)
+#define MIS_UMSK_ISR_tc1_int(data)                                                   (0x00000080&((data)<<7))
+#define MIS_UMSK_ISR_tc1_int_src(data)                                               ((0x00000080&(data))>>7)
+#define MIS_UMSK_ISR_get_tc1_int(data)                                               ((0x00000080&(data))>>7)
+#define MIS_UMSK_ISR_tc0_int_shift                                                   (6)
+#define MIS_UMSK_ISR_tc0_int_mask                                                    (0x00000040)
+#define MIS_UMSK_ISR_tc0_int(data)                                                   (0x00000040&((data)<<6))
+#define MIS_UMSK_ISR_tc0_int_src(data)                                               ((0x00000040&(data))>>6)
+#define MIS_UMSK_ISR_get_tc0_int(data)                                               ((0x00000040&(data))>>6)
+#define MIS_UMSK_ISR_ur1_to_int_shift                                                (5)
+#define MIS_UMSK_ISR_ur1_to_int_mask                                                 (0x00000020)
+#define MIS_UMSK_ISR_ur1_to_int(data)                                                (0x00000020&((data)<<5))
+#define MIS_UMSK_ISR_ur1_to_int_src(data)                                            ((0x00000020&(data))>>5)
+#define MIS_UMSK_ISR_get_ur1_to_int(data)                                            ((0x00000020&(data))>>5)
+#define MIS_UMSK_ISR_wdog_nmi_int_shift                                              (2)
+#define MIS_UMSK_ISR_wdog_nmi_int_mask                                               (0x00000004)
+#define MIS_UMSK_ISR_wdog_nmi_int(data)                                              (0x00000004&((data)<<2))
+#define MIS_UMSK_ISR_wdog_nmi_int_src(data)                                          ((0x00000004&(data))>>2)
+#define MIS_UMSK_ISR_get_wdog_nmi_int(data)                                          ((0x00000004&(data))>>2)
+#define MIS_UMSK_ISR_write_data_shift                                                (0)
+#define MIS_UMSK_ISR_write_data_mask                                                 (0x00000001)
+#define MIS_UMSK_ISR_write_data(data)                                                (0x00000001&((data)<<0))
+#define MIS_UMSK_ISR_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_UMSK_ISR_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_ISR                                                                      0x1801B00C
+#define MIS_ISR_reg_addr                                                             "0xB801B00C"
+#define MIS_ISR_reg                                                                  0xB801B00C
+#define set_MIS_ISR_reg(data)   (*((volatile unsigned int*) MIS_ISR_reg)=data)
+#define get_MIS_ISR_reg   (*((volatile unsigned int*) MIS_ISR_reg))
+#define MIS_ISR_inst_adr                                                             "0x0003"
+#define MIS_ISR_inst                                                                 0x0003
+#define MIS_ISR_gspi_int_shift                                                       (27)
+#define MIS_ISR_gspi_int_mask                                                        (0x08000000)
+#define MIS_ISR_gspi_int(data)                                                       (0x08000000&((data)<<27))
+#define MIS_ISR_gspi_int_src(data)                                                   ((0x08000000&(data))>>27)
+#define MIS_ISR_get_gspi_int(data)                                                   ((0x08000000&(data))>>27)
+#define MIS_ISR_i2c2_int_shift                                                       (26)
+#define MIS_ISR_i2c2_int_mask                                                        (0x04000000)
+#define MIS_ISR_i2c2_int(data)                                                       (0x04000000&((data)<<26))
+#define MIS_ISR_i2c2_int_src(data)                                                   ((0x04000000&(data))>>26)
+#define MIS_ISR_get_i2c2_int(data)                                                   ((0x04000000&(data))>>26)
+#define MIS_ISR_i2c3_int_shift                                                       (23)
+#define MIS_ISR_i2c3_int_mask                                                        (0x00800000)
+#define MIS_ISR_i2c3_int(data)                                                       (0x00800000&((data)<<23))
+#define MIS_ISR_i2c3_int_src(data)                                                   ((0x00800000&(data))>>23)
+#define MIS_ISR_get_i2c3_int(data)                                                   ((0x00800000&(data))>>23)
+#define MIS_ISR_lsadc_int_shift                                                      (21)
+#define MIS_ISR_lsadc_int_mask                                                       (0x00200000)
+#define MIS_ISR_lsadc_int(data)                                                      (0x00200000&((data)<<21))
+#define MIS_ISR_lsadc_int_src(data)                                                  ((0x00200000&(data))>>21)
+#define MIS_ISR_get_lsadc_int(data)                                                  ((0x00200000&(data))>>21)
+#define MIS_ISR_gpioda_int_shift                                                     (20)
+#define MIS_ISR_gpioda_int_mask                                                      (0x00100000)
+#define MIS_ISR_gpioda_int(data)                                                     (0x00100000&((data)<<20))
+#define MIS_ISR_gpioda_int_src(data)                                                 ((0x00100000&(data))>>20)
+#define MIS_ISR_get_gpioda_int(data)                                                 ((0x00100000&(data))>>20)
+#define MIS_ISR_gpioa_int_shift                                                      (19)
+#define MIS_ISR_gpioa_int_mask                                                       (0x00080000)
+#define MIS_ISR_gpioa_int(data)                                                      (0x00080000&((data)<<19))
+#define MIS_ISR_gpioa_int_src(data)                                                  ((0x00080000&(data))>>19)
+#define MIS_ISR_get_gpioa_int(data)                                                  ((0x00080000&(data))>>19)
+#define MIS_ISR_i2c4_int_shift                                                       (15)
+#define MIS_ISR_i2c4_int_mask                                                        (0x00008000)
+#define MIS_ISR_i2c4_int(data)                                                       (0x00008000&((data)<<15))
+#define MIS_ISR_i2c4_int_src(data)                                                   ((0x00008000&(data))>>15)
+#define MIS_ISR_get_i2c4_int(data)                                                   ((0x00008000&(data))>>15)
+#define MIS_ISR_i2c5_int_shift                                                       (14)
+#define MIS_ISR_i2c5_int_mask                                                        (0x00004000)
+#define MIS_ISR_i2c5_int(data)                                                       (0x00004000&((data)<<14))
+#define MIS_ISR_i2c5_int_src(data)                                                   ((0x00004000&(data))>>14)
+#define MIS_ISR_get_i2c5_int(data)                                                   ((0x00004000&(data))>>14)
+#define MIS_ISR_rtc_date_int_shift                                                   (12)
+#define MIS_ISR_rtc_date_int_mask                                                    (0x00001000)
+#define MIS_ISR_rtc_date_int(data)                                                   (0x00001000&((data)<<12))
+#define MIS_ISR_rtc_date_int_src(data)                                               ((0x00001000&(data))>>12)
+#define MIS_ISR_get_rtc_date_int(data)                                               ((0x00001000&(data))>>12)
+#define MIS_ISR_rtc_hour_int_shift                                                   (11)
+#define MIS_ISR_rtc_hour_int_mask                                                    (0x00000800)
+#define MIS_ISR_rtc_hour_int(data)                                                   (0x00000800&((data)<<11))
+#define MIS_ISR_rtc_hour_int_src(data)                                               ((0x00000800&(data))>>11)
+#define MIS_ISR_get_rtc_hour_int(data)                                               ((0x00000800&(data))>>11)
+#define MIS_ISR_rtc_min_int_shift                                                    (10)
+#define MIS_ISR_rtc_min_int_mask                                                     (0x00000400)
+#define MIS_ISR_rtc_min_int(data)                                                    (0x00000400&((data)<<10))
+#define MIS_ISR_rtc_min_int_src(data)                                                ((0x00000400&(data))>>10)
+#define MIS_ISR_get_rtc_min_int(data)                                                ((0x00000400&(data))>>10)
+#define MIS_ISR_rtc_hsec_int_shift                                                   (9)
+#define MIS_ISR_rtc_hsec_int_mask                                                    (0x00000200)
+#define MIS_ISR_rtc_hsec_int(data)                                                   (0x00000200&((data)<<9))
+#define MIS_ISR_rtc_hsec_int_src(data)                                               ((0x00000200&(data))>>9)
+#define MIS_ISR_get_rtc_hsec_int(data)                                               ((0x00000200&(data))>>9)
+#define MIS_ISR_tc1_int_shift                                                        (7)
+#define MIS_ISR_tc1_int_mask                                                         (0x00000080)
+#define MIS_ISR_tc1_int(data)                                                        (0x00000080&((data)<<7))
+#define MIS_ISR_tc1_int_src(data)                                                    ((0x00000080&(data))>>7)
+#define MIS_ISR_get_tc1_int(data)                                                    ((0x00000080&(data))>>7)
+#define MIS_ISR_tc0_int_shift                                                        (6)
+#define MIS_ISR_tc0_int_mask                                                         (0x00000040)
+#define MIS_ISR_tc0_int(data)                                                        (0x00000040&((data)<<6))
+#define MIS_ISR_tc0_int_src(data)                                                    ((0x00000040&(data))>>6)
+#define MIS_ISR_get_tc0_int(data)                                                    ((0x00000040&(data))>>6)
+#define MIS_ISR_ur1_to_int_shift                                                     (5)
+#define MIS_ISR_ur1_to_int_mask                                                      (0x00000020)
+#define MIS_ISR_ur1_to_int(data)                                                     (0x00000020&((data)<<5))
+#define MIS_ISR_ur1_to_int_src(data)                                                 ((0x00000020&(data))>>5)
+#define MIS_ISR_get_ur1_to_int(data)                                                 ((0x00000020&(data))>>5)
+#define MIS_ISR_i2c1_int_shift                                                       (4)
+#define MIS_ISR_i2c1_int_mask                                                        (0x00000010)
+#define MIS_ISR_i2c1_int(data)                                                       (0x00000010&((data)<<4))
+#define MIS_ISR_i2c1_int_src(data)                                                   ((0x00000010&(data))>>4)
+#define MIS_ISR_get_i2c1_int(data)                                                   ((0x00000010&(data))>>4)
+#define MIS_ISR_ur1_int_shift                                                        (3)
+#define MIS_ISR_ur1_int_mask                                                         (0x00000008)
+#define MIS_ISR_ur1_int(data)                                                        (0x00000008&((data)<<3))
+#define MIS_ISR_ur1_int_src(data)                                                    ((0x00000008&(data))>>3)
+#define MIS_ISR_get_ur1_int(data)                                                    ((0x00000008&(data))>>3)
+#define MIS_ISR_wdog_nmi_int_shift                                                   (2)
+#define MIS_ISR_wdog_nmi_int_mask                                                    (0x00000004)
+#define MIS_ISR_wdog_nmi_int(data)                                                   (0x00000004&((data)<<2))
+#define MIS_ISR_wdog_nmi_int_src(data)                                               ((0x00000004&(data))>>2)
+#define MIS_ISR_get_wdog_nmi_int(data)                                               ((0x00000004&(data))>>2)
+#define MIS_ISR_write_data_shift                                                     (0)
+#define MIS_ISR_write_data_mask                                                      (0x00000001)
+#define MIS_ISR_write_data(data)                                                     (0x00000001&((data)<<0))
+#define MIS_ISR_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define MIS_ISR_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define MIS_UMSK_ISR_SWC                                                             0x1801B010
+#define MIS_UMSK_ISR_SWC_reg_addr                                                    "0xB801B010"
+#define MIS_UMSK_ISR_SWC_reg                                                         0xB801B010
+#define set_MIS_UMSK_ISR_SWC_reg(data)   (*((volatile unsigned int*) MIS_UMSK_ISR_SWC_reg)=data)
+#define get_MIS_UMSK_ISR_SWC_reg   (*((volatile unsigned int*) MIS_UMSK_ISR_SWC_reg))
+#define MIS_UMSK_ISR_SWC_inst_adr                                                    "0x0004"
+#define MIS_UMSK_ISR_SWC_inst                                                        0x0004
+#define MIS_UMSK_ISR_SWC_wdog_nmi_int_shift                                          (3)
+#define MIS_UMSK_ISR_SWC_wdog_nmi_int_mask                                           (0x00000008)
+#define MIS_UMSK_ISR_SWC_wdog_nmi_int(data)                                          (0x00000008&((data)<<3))
+#define MIS_UMSK_ISR_SWC_wdog_nmi_int_src(data)                                      ((0x00000008&(data))>>3)
+#define MIS_UMSK_ISR_SWC_get_wdog_nmi_int(data)                                      ((0x00000008&(data))>>3)
+#define MIS_UMSK_ISR_SWC_tc2_int_shift                                               (1)
+#define MIS_UMSK_ISR_SWC_tc2_int_mask                                                (0x00000002)
+#define MIS_UMSK_ISR_SWC_tc2_int(data)                                               (0x00000002&((data)<<1))
+#define MIS_UMSK_ISR_SWC_tc2_int_src(data)                                           ((0x00000002&(data))>>1)
+#define MIS_UMSK_ISR_SWC_get_tc2_int(data)                                           ((0x00000002&(data))>>1)
+#define MIS_UMSK_ISR_SWC_write_data_shift                                            (0)
+#define MIS_UMSK_ISR_SWC_write_data_mask                                             (0x00000001)
+#define MIS_UMSK_ISR_SWC_write_data(data)                                            (0x00000001&((data)<<0))
+#define MIS_UMSK_ISR_SWC_write_data_src(data)                                        ((0x00000001&(data))>>0)
+#define MIS_UMSK_ISR_SWC_get_write_data(data)                                        ((0x00000001&(data))>>0)
+
+
+#define MIS_ISR_SWC                                                                  0x1801B014
+#define MIS_ISR_SWC_reg_addr                                                         "0xB801B014"
+#define MIS_ISR_SWC_reg                                                              0xB801B014
+#define set_MIS_ISR_SWC_reg(data)   (*((volatile unsigned int*) MIS_ISR_SWC_reg)=data)
+#define get_MIS_ISR_SWC_reg   (*((volatile unsigned int*) MIS_ISR_SWC_reg))
+#define MIS_ISR_SWC_inst_adr                                                         "0x0005"
+#define MIS_ISR_SWC_inst                                                             0x0005
+#define MIS_ISR_SWC_wdog_nmi_int_shift                                               (3)
+#define MIS_ISR_SWC_wdog_nmi_int_mask                                                (0x00000008)
+#define MIS_ISR_SWC_wdog_nmi_int(data)                                               (0x00000008&((data)<<3))
+#define MIS_ISR_SWC_wdog_nmi_int_src(data)                                           ((0x00000008&(data))>>3)
+#define MIS_ISR_SWC_get_wdog_nmi_int(data)                                           ((0x00000008&(data))>>3)
+#define MIS_ISR_SWC_i2c_2_int_shift                                                  (2)
+#define MIS_ISR_SWC_i2c_2_int_mask                                                   (0x00000004)
+#define MIS_ISR_SWC_i2c_2_int(data)                                                  (0x00000004&((data)<<2))
+#define MIS_ISR_SWC_i2c_2_int_src(data)                                              ((0x00000004&(data))>>2)
+#define MIS_ISR_SWC_get_i2c_2_int(data)                                              ((0x00000004&(data))>>2)
+#define MIS_ISR_SWC_tc2_int_shift                                                    (1)
+#define MIS_ISR_SWC_tc2_int_mask                                                     (0x00000002)
+#define MIS_ISR_SWC_tc2_int(data)                                                    (0x00000002&((data)<<1))
+#define MIS_ISR_SWC_tc2_int_src(data)                                                ((0x00000002&(data))>>1)
+#define MIS_ISR_SWC_get_tc2_int(data)                                                ((0x00000002&(data))>>1)
+#define MIS_ISR_SWC_write_data_shift                                                 (0)
+#define MIS_ISR_SWC_write_data_mask                                                  (0x00000001)
+#define MIS_ISR_SWC_write_data(data)                                                 (0x00000001&((data)<<0))
+#define MIS_ISR_SWC_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define MIS_ISR_SWC_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MIS_SETTING_SWC                                                              0x1801B018
+#define MIS_SETTING_SWC_reg_addr                                                     "0xB801B018"
+#define MIS_SETTING_SWC_reg                                                          0xB801B018
+#define set_MIS_SETTING_SWC_reg(data)   (*((volatile unsigned int*) MIS_SETTING_SWC_reg)=data)
+#define get_MIS_SETTING_SWC_reg   (*((volatile unsigned int*) MIS_SETTING_SWC_reg))
+#define MIS_SETTING_SWC_inst_adr                                                     "0x0006"
+#define MIS_SETTING_SWC_inst                                                         0x0006
+#define MIS_SETTING_SWC_i2c_2_swc_en_shift                                           (1)
+#define MIS_SETTING_SWC_i2c_2_swc_en_mask                                            (0x00000002)
+#define MIS_SETTING_SWC_i2c_2_swc_en(data)                                           (0x00000002&((data)<<1))
+#define MIS_SETTING_SWC_i2c_2_swc_en_src(data)                                       ((0x00000002&(data))>>1)
+#define MIS_SETTING_SWC_get_i2c_2_swc_en(data)                                       ((0x00000002&(data))>>1)
+#define MIS_SETTING_SWC_i2c_2_en_shift                                               (0)
+#define MIS_SETTING_SWC_i2c_2_en_mask                                                (0x00000001)
+#define MIS_SETTING_SWC_i2c_2_en(data)                                               (0x00000001&((data)<<0))
+#define MIS_SETTING_SWC_i2c_2_en_src(data)                                           ((0x00000001&(data))>>0)
+#define MIS_SETTING_SWC_get_i2c_2_en(data)                                           ((0x00000001&(data))>>0)
+
+
+#define MIS_FAST_INT_EN_0                                                            0x1801B01C
+#define MIS_FAST_INT_EN_0_reg_addr                                                   "0xB801B01C"
+#define MIS_FAST_INT_EN_0_reg                                                        0xB801B01C
+#define set_MIS_FAST_INT_EN_0_reg(data)   (*((volatile unsigned int*) MIS_FAST_INT_EN_0_reg)=data)
+#define get_MIS_FAST_INT_EN_0_reg   (*((volatile unsigned int*) MIS_FAST_INT_EN_0_reg))
+#define MIS_FAST_INT_EN_0_inst_adr                                                   "0x0007"
+#define MIS_FAST_INT_EN_0_inst                                                       0x0007
+#define MIS_FAST_INT_EN_0_gp_int_shift                                               (1)
+#define MIS_FAST_INT_EN_0_gp_int_mask                                                (0xFFFFFFFE)
+#define MIS_FAST_INT_EN_0_gp_int(data)                                               (0xFFFFFFFE&((data)<<1))
+#define MIS_FAST_INT_EN_0_gp_int_src(data)                                           ((0xFFFFFFFE&(data))>>1)
+#define MIS_FAST_INT_EN_0_get_gp_int(data)                                           ((0xFFFFFFFE&(data))>>1)
+
+
+#define MIS_FAST_INT_EN_1                                                            0x1801B020
+#define MIS_FAST_INT_EN_1_reg_addr                                                   "0xB801B020"
+#define MIS_FAST_INT_EN_1_reg                                                        0xB801B020
+#define set_MIS_FAST_INT_EN_1_reg(data)   (*((volatile unsigned int*) MIS_FAST_INT_EN_1_reg)=data)
+#define get_MIS_FAST_INT_EN_1_reg   (*((volatile unsigned int*) MIS_FAST_INT_EN_1_reg))
+#define MIS_FAST_INT_EN_1_inst_adr                                                   "0x0008"
+#define MIS_FAST_INT_EN_1_inst                                                       0x0008
+#define MIS_FAST_INT_EN_1_gspi_int_shift                                             (31)
+#define MIS_FAST_INT_EN_1_gspi_int_mask                                              (0x80000000)
+#define MIS_FAST_INT_EN_1_gspi_int(data)                                             (0x80000000&((data)<<31))
+#define MIS_FAST_INT_EN_1_gspi_int_src(data)                                         ((0x80000000&(data))>>31)
+#define MIS_FAST_INT_EN_1_get_gspi_int(data)                                         ((0x80000000&(data))>>31)
+#define MIS_FAST_INT_EN_1_i2c3_int_shift                                             (30)
+#define MIS_FAST_INT_EN_1_i2c3_int_mask                                              (0x40000000)
+#define MIS_FAST_INT_EN_1_i2c3_int(data)                                             (0x40000000&((data)<<30))
+#define MIS_FAST_INT_EN_1_i2c3_int_src(data)                                         ((0x40000000&(data))>>30)
+#define MIS_FAST_INT_EN_1_get_i2c3_int(data)                                         ((0x40000000&(data))>>30)
+#define MIS_FAST_INT_EN_1_gp_int_shift                                               (1)
+#define MIS_FAST_INT_EN_1_gp_int_mask                                                (0x3FFFFFFE)
+#define MIS_FAST_INT_EN_1_gp_int(data)                                               (0x3FFFFFFE&((data)<<1))
+#define MIS_FAST_INT_EN_1_gp_int_src(data)                                           ((0x3FFFFFFE&(data))>>1)
+#define MIS_FAST_INT_EN_1_get_gp_int(data)                                           ((0x3FFFFFFE&(data))>>1)
+#define MIS_FAST_INT_EN_1_i2c2_int_shift                                             (0)
+#define MIS_FAST_INT_EN_1_i2c2_int_mask                                              (0x00000001)
+#define MIS_FAST_INT_EN_1_i2c2_int(data)                                             (0x00000001&((data)<<0))
+#define MIS_FAST_INT_EN_1_i2c2_int_src(data)                                         ((0x00000001&(data))>>0)
+#define MIS_FAST_INT_EN_1_get_i2c2_int(data)                                         ((0x00000001&(data))>>0)
+
+
+#define MIS_FAST_ISR                                                                 0x1801B024
+#define MIS_FAST_ISR_reg_addr                                                        "0xB801B024"
+#define MIS_FAST_ISR_reg                                                             0xB801B024
+#define set_MIS_FAST_ISR_reg(data)   (*((volatile unsigned int*) MIS_FAST_ISR_reg)=data)
+#define get_MIS_FAST_ISR_reg   (*((volatile unsigned int*) MIS_FAST_ISR_reg))
+#define MIS_FAST_ISR_inst_adr                                                        "0x0009"
+#define MIS_FAST_ISR_inst                                                            0x0009
+#define MIS_FAST_ISR_i2c2_int_shift                                                  (5)
+#define MIS_FAST_ISR_i2c2_int_mask                                                   (0x00000020)
+#define MIS_FAST_ISR_i2c2_int(data)                                                  (0x00000020&((data)<<5))
+#define MIS_FAST_ISR_i2c2_int_src(data)                                              ((0x00000020&(data))>>5)
+#define MIS_FAST_ISR_get_i2c2_int(data)                                              ((0x00000020&(data))>>5)
+#define MIS_FAST_ISR_gspi_int_shift                                                  (4)
+#define MIS_FAST_ISR_gspi_int_mask                                                   (0x00000010)
+#define MIS_FAST_ISR_gspi_int(data)                                                  (0x00000010&((data)<<4))
+#define MIS_FAST_ISR_gspi_int_src(data)                                              ((0x00000010&(data))>>4)
+#define MIS_FAST_ISR_get_gspi_int(data)                                              ((0x00000010&(data))>>4)
+#define MIS_FAST_ISR_i2c3_int_shift                                                  (3)
+#define MIS_FAST_ISR_i2c3_int_mask                                                   (0x00000008)
+#define MIS_FAST_ISR_i2c3_int(data)                                                  (0x00000008&((data)<<3))
+#define MIS_FAST_ISR_i2c3_int_src(data)                                              ((0x00000008&(data))>>3)
+#define MIS_FAST_ISR_get_i2c3_int(data)                                              ((0x00000008&(data))>>3)
+#define MIS_FAST_ISR_gpioda_int_shift                                                (2)
+#define MIS_FAST_ISR_gpioda_int_mask                                                 (0x00000004)
+#define MIS_FAST_ISR_gpioda_int(data)                                                (0x00000004&((data)<<2))
+#define MIS_FAST_ISR_gpioda_int_src(data)                                            ((0x00000004&(data))>>2)
+#define MIS_FAST_ISR_get_gpioda_int(data)                                            ((0x00000004&(data))>>2)
+#define MIS_FAST_ISR_gpioa_int_shift                                                 (1)
+#define MIS_FAST_ISR_gpioa_int_mask                                                  (0x00000002)
+#define MIS_FAST_ISR_gpioa_int(data)                                                 (0x00000002&((data)<<1))
+#define MIS_FAST_ISR_gpioa_int_src(data)                                             ((0x00000002&(data))>>1)
+#define MIS_FAST_ISR_get_gpioa_int(data)                                             ((0x00000002&(data))>>1)
+#define MIS_FAST_ISR_write_data_shift                                                (0)
+#define MIS_FAST_ISR_write_data_mask                                                 (0x00000001)
+#define MIS_FAST_ISR_write_data(data)                                                (0x00000001&((data)<<0))
+#define MIS_FAST_ISR_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_FAST_ISR_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_DBG                                                                      0x1801B02C
+#define MIS_DBG_reg_addr                                                             "0xB801B02C"
+#define MIS_DBG_reg                                                                  0xB801B02C
+#define set_MIS_DBG_reg(data)   (*((volatile unsigned int*) MIS_DBG_reg)=data)
+#define get_MIS_DBG_reg   (*((volatile unsigned int*) MIS_DBG_reg))
+#define MIS_DBG_inst_adr                                                             "0x000B"
+#define MIS_DBG_inst                                                                 0x000B
+#define MIS_DBG_write_enable3_shift                                                  (11)
+#define MIS_DBG_write_enable3_mask                                                   (0x00000800)
+#define MIS_DBG_write_enable3(data)                                                  (0x00000800&((data)<<11))
+#define MIS_DBG_write_enable3_src(data)                                              ((0x00000800&(data))>>11)
+#define MIS_DBG_get_write_enable3(data)                                              ((0x00000800&(data))>>11)
+#define MIS_DBG_sel1_shift                                                           (7)
+#define MIS_DBG_sel1_mask                                                            (0x00000780)
+#define MIS_DBG_sel1(data)                                                           (0x00000780&((data)<<7))
+#define MIS_DBG_sel1_src(data)                                                       ((0x00000780&(data))>>7)
+#define MIS_DBG_get_sel1(data)                                                       ((0x00000780&(data))>>7)
+#define MIS_DBG_write_enable2_shift                                                  (6)
+#define MIS_DBG_write_enable2_mask                                                   (0x00000040)
+#define MIS_DBG_write_enable2(data)                                                  (0x00000040&((data)<<6))
+#define MIS_DBG_write_enable2_src(data)                                              ((0x00000040&(data))>>6)
+#define MIS_DBG_get_write_enable2(data)                                              ((0x00000040&(data))>>6)
+#define MIS_DBG_sel0_shift                                                           (2)
+#define MIS_DBG_sel0_mask                                                            (0x0000003C)
+#define MIS_DBG_sel0(data)                                                           (0x0000003C&((data)<<2))
+#define MIS_DBG_sel0_src(data)                                                       ((0x0000003C&(data))>>2)
+#define MIS_DBG_get_sel0(data)                                                       ((0x0000003C&(data))>>2)
+#define MIS_DBG_write_enable1_shift                                                  (1)
+#define MIS_DBG_write_enable1_mask                                                   (0x00000002)
+#define MIS_DBG_write_enable1(data)                                                  (0x00000002&((data)<<1))
+#define MIS_DBG_write_enable1_src(data)                                              ((0x00000002&(data))>>1)
+#define MIS_DBG_get_write_enable1(data)                                              ((0x00000002&(data))>>1)
+#define MIS_DBG_enable_shift                                                         (0)
+#define MIS_DBG_enable_mask                                                          (0x00000001)
+#define MIS_DBG_enable(data)                                                         (0x00000001&((data)<<0))
+#define MIS_DBG_enable_src(data)                                                     ((0x00000001&(data))>>0)
+#define MIS_DBG_get_enable(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define MIS_DUMMY                                                                    0x1801B030
+#define MIS_DUMMY_reg_addr                                                           "0xB801B030"
+#define MIS_DUMMY_reg                                                                0xB801B030
+#define set_MIS_DUMMY_reg(data)   (*((volatile unsigned int*) MIS_DUMMY_reg)=data)
+#define get_MIS_DUMMY_reg   (*((volatile unsigned int*) MIS_DUMMY_reg))
+#define MIS_DUMMY_inst_adr                                                           "0x000C"
+#define MIS_DUMMY_inst                                                               0x000C
+#define MIS_DUMMY_write_enable4_shift                                                (31)
+#define MIS_DUMMY_write_enable4_mask                                                 (0x80000000)
+#define MIS_DUMMY_write_enable4(data)                                                (0x80000000&((data)<<31))
+#define MIS_DUMMY_write_enable4_src(data)                                            ((0x80000000&(data))>>31)
+#define MIS_DUMMY_get_write_enable4(data)                                            ((0x80000000&(data))>>31)
+#define MIS_DUMMY_rvd4_shift                                                         (24)
+#define MIS_DUMMY_rvd4_mask                                                          (0x7F000000)
+#define MIS_DUMMY_rvd4(data)                                                         (0x7F000000&((data)<<24))
+#define MIS_DUMMY_rvd4_src(data)                                                     ((0x7F000000&(data))>>24)
+#define MIS_DUMMY_get_rvd4(data)                                                     ((0x7F000000&(data))>>24)
+#define MIS_DUMMY_write_enable3_shift                                                (23)
+#define MIS_DUMMY_write_enable3_mask                                                 (0x00800000)
+#define MIS_DUMMY_write_enable3(data)                                                (0x00800000&((data)<<23))
+#define MIS_DUMMY_write_enable3_src(data)                                            ((0x00800000&(data))>>23)
+#define MIS_DUMMY_get_write_enable3(data)                                            ((0x00800000&(data))>>23)
+#define MIS_DUMMY_rvd3_shift                                                         (16)
+#define MIS_DUMMY_rvd3_mask                                                          (0x007F0000)
+#define MIS_DUMMY_rvd3(data)                                                         (0x007F0000&((data)<<16))
+#define MIS_DUMMY_rvd3_src(data)                                                     ((0x007F0000&(data))>>16)
+#define MIS_DUMMY_get_rvd3(data)                                                     ((0x007F0000&(data))>>16)
+#define MIS_DUMMY_write_enable2_shift                                                (15)
+#define MIS_DUMMY_write_enable2_mask                                                 (0x00008000)
+#define MIS_DUMMY_write_enable2(data)                                                (0x00008000&((data)<<15))
+#define MIS_DUMMY_write_enable2_src(data)                                            ((0x00008000&(data))>>15)
+#define MIS_DUMMY_get_write_enable2(data)                                            ((0x00008000&(data))>>15)
+#define MIS_DUMMY_rvd2_shift                                                         (8)
+#define MIS_DUMMY_rvd2_mask                                                          (0x00007F00)
+#define MIS_DUMMY_rvd2(data)                                                         (0x00007F00&((data)<<8))
+#define MIS_DUMMY_rvd2_src(data)                                                     ((0x00007F00&(data))>>8)
+#define MIS_DUMMY_get_rvd2(data)                                                     ((0x00007F00&(data))>>8)
+#define MIS_DUMMY_write_enable1_shift                                                (7)
+#define MIS_DUMMY_write_enable1_mask                                                 (0x00000080)
+#define MIS_DUMMY_write_enable1(data)                                                (0x00000080&((data)<<7))
+#define MIS_DUMMY_write_enable1_src(data)                                            ((0x00000080&(data))>>7)
+#define MIS_DUMMY_get_write_enable1(data)                                            ((0x00000080&(data))>>7)
+#define MIS_DUMMY_rvd1_shift                                                         (0)
+#define MIS_DUMMY_rvd1_mask                                                          (0x0000007F)
+#define MIS_DUMMY_rvd1(data)                                                         (0x0000007F&((data)<<0))
+#define MIS_DUMMY_rvd1_src(data)                                                     ((0x0000007F&(data))>>0)
+#define MIS_DUMMY_get_rvd1(data)                                                     ((0x0000007F&(data))>>0)
+
+
+#define MIS_UMSK_ISR_GP0A                                                            0x1801B040
+#define MIS_UMSK_ISR_GP0A_reg_addr                                                   "0xB801B040"
+#define MIS_UMSK_ISR_GP0A_reg                                                        0xB801B040
+#define set_MIS_UMSK_ISR_GP0A_reg(data)   (*((volatile unsigned int*) MIS_UMSK_ISR_GP0A_reg)=data)
+#define get_MIS_UMSK_ISR_GP0A_reg   (*((volatile unsigned int*) MIS_UMSK_ISR_GP0A_reg))
+#define MIS_UMSK_ISR_GP0A_inst_adr                                                   "0x0010"
+#define MIS_UMSK_ISR_GP0A_inst                                                       0x0010
+#define MIS_UMSK_ISR_GP0A_int30_shift                                                (31)
+#define MIS_UMSK_ISR_GP0A_int30_mask                                                 (0x80000000)
+#define MIS_UMSK_ISR_GP0A_int30(data)                                                (0x80000000&((data)<<31))
+#define MIS_UMSK_ISR_GP0A_int30_src(data)                                            ((0x80000000&(data))>>31)
+#define MIS_UMSK_ISR_GP0A_get_int30(data)                                            ((0x80000000&(data))>>31)
+#define MIS_UMSK_ISR_GP0A_int29_shift                                                (30)
+#define MIS_UMSK_ISR_GP0A_int29_mask                                                 (0x40000000)
+#define MIS_UMSK_ISR_GP0A_int29(data)                                                (0x40000000&((data)<<30))
+#define MIS_UMSK_ISR_GP0A_int29_src(data)                                            ((0x40000000&(data))>>30)
+#define MIS_UMSK_ISR_GP0A_get_int29(data)                                            ((0x40000000&(data))>>30)
+#define MIS_UMSK_ISR_GP0A_int28_shift                                                (29)
+#define MIS_UMSK_ISR_GP0A_int28_mask                                                 (0x20000000)
+#define MIS_UMSK_ISR_GP0A_int28(data)                                                (0x20000000&((data)<<29))
+#define MIS_UMSK_ISR_GP0A_int28_src(data)                                            ((0x20000000&(data))>>29)
+#define MIS_UMSK_ISR_GP0A_get_int28(data)                                            ((0x20000000&(data))>>29)
+#define MIS_UMSK_ISR_GP0A_int27_shift                                                (28)
+#define MIS_UMSK_ISR_GP0A_int27_mask                                                 (0x10000000)
+#define MIS_UMSK_ISR_GP0A_int27(data)                                                (0x10000000&((data)<<28))
+#define MIS_UMSK_ISR_GP0A_int27_src(data)                                            ((0x10000000&(data))>>28)
+#define MIS_UMSK_ISR_GP0A_get_int27(data)                                            ((0x10000000&(data))>>28)
+#define MIS_UMSK_ISR_GP0A_int26_shift                                                (27)
+#define MIS_UMSK_ISR_GP0A_int26_mask                                                 (0x08000000)
+#define MIS_UMSK_ISR_GP0A_int26(data)                                                (0x08000000&((data)<<27))
+#define MIS_UMSK_ISR_GP0A_int26_src(data)                                            ((0x08000000&(data))>>27)
+#define MIS_UMSK_ISR_GP0A_get_int26(data)                                            ((0x08000000&(data))>>27)
+#define MIS_UMSK_ISR_GP0A_int25_shift                                                (26)
+#define MIS_UMSK_ISR_GP0A_int25_mask                                                 (0x04000000)
+#define MIS_UMSK_ISR_GP0A_int25(data)                                                (0x04000000&((data)<<26))
+#define MIS_UMSK_ISR_GP0A_int25_src(data)                                            ((0x04000000&(data))>>26)
+#define MIS_UMSK_ISR_GP0A_get_int25(data)                                            ((0x04000000&(data))>>26)
+#define MIS_UMSK_ISR_GP0A_int24_shift                                                (25)
+#define MIS_UMSK_ISR_GP0A_int24_mask                                                 (0x02000000)
+#define MIS_UMSK_ISR_GP0A_int24(data)                                                (0x02000000&((data)<<25))
+#define MIS_UMSK_ISR_GP0A_int24_src(data)                                            ((0x02000000&(data))>>25)
+#define MIS_UMSK_ISR_GP0A_get_int24(data)                                            ((0x02000000&(data))>>25)
+#define MIS_UMSK_ISR_GP0A_int23_shift                                                (24)
+#define MIS_UMSK_ISR_GP0A_int23_mask                                                 (0x01000000)
+#define MIS_UMSK_ISR_GP0A_int23(data)                                                (0x01000000&((data)<<24))
+#define MIS_UMSK_ISR_GP0A_int23_src(data)                                            ((0x01000000&(data))>>24)
+#define MIS_UMSK_ISR_GP0A_get_int23(data)                                            ((0x01000000&(data))>>24)
+#define MIS_UMSK_ISR_GP0A_int22_shift                                                (23)
+#define MIS_UMSK_ISR_GP0A_int22_mask                                                 (0x00800000)
+#define MIS_UMSK_ISR_GP0A_int22(data)                                                (0x00800000&((data)<<23))
+#define MIS_UMSK_ISR_GP0A_int22_src(data)                                            ((0x00800000&(data))>>23)
+#define MIS_UMSK_ISR_GP0A_get_int22(data)                                            ((0x00800000&(data))>>23)
+#define MIS_UMSK_ISR_GP0A_int21_shift                                                (22)
+#define MIS_UMSK_ISR_GP0A_int21_mask                                                 (0x00400000)
+#define MIS_UMSK_ISR_GP0A_int21(data)                                                (0x00400000&((data)<<22))
+#define MIS_UMSK_ISR_GP0A_int21_src(data)                                            ((0x00400000&(data))>>22)
+#define MIS_UMSK_ISR_GP0A_get_int21(data)                                            ((0x00400000&(data))>>22)
+#define MIS_UMSK_ISR_GP0A_int20_shift                                                (21)
+#define MIS_UMSK_ISR_GP0A_int20_mask                                                 (0x00200000)
+#define MIS_UMSK_ISR_GP0A_int20(data)                                                (0x00200000&((data)<<21))
+#define MIS_UMSK_ISR_GP0A_int20_src(data)                                            ((0x00200000&(data))>>21)
+#define MIS_UMSK_ISR_GP0A_get_int20(data)                                            ((0x00200000&(data))>>21)
+#define MIS_UMSK_ISR_GP0A_int19_shift                                                (20)
+#define MIS_UMSK_ISR_GP0A_int19_mask                                                 (0x00100000)
+#define MIS_UMSK_ISR_GP0A_int19(data)                                                (0x00100000&((data)<<20))
+#define MIS_UMSK_ISR_GP0A_int19_src(data)                                            ((0x00100000&(data))>>20)
+#define MIS_UMSK_ISR_GP0A_get_int19(data)                                            ((0x00100000&(data))>>20)
+#define MIS_UMSK_ISR_GP0A_int18_shift                                                (19)
+#define MIS_UMSK_ISR_GP0A_int18_mask                                                 (0x00080000)
+#define MIS_UMSK_ISR_GP0A_int18(data)                                                (0x00080000&((data)<<19))
+#define MIS_UMSK_ISR_GP0A_int18_src(data)                                            ((0x00080000&(data))>>19)
+#define MIS_UMSK_ISR_GP0A_get_int18(data)                                            ((0x00080000&(data))>>19)
+#define MIS_UMSK_ISR_GP0A_int17_shift                                                (18)
+#define MIS_UMSK_ISR_GP0A_int17_mask                                                 (0x00040000)
+#define MIS_UMSK_ISR_GP0A_int17(data)                                                (0x00040000&((data)<<18))
+#define MIS_UMSK_ISR_GP0A_int17_src(data)                                            ((0x00040000&(data))>>18)
+#define MIS_UMSK_ISR_GP0A_get_int17(data)                                            ((0x00040000&(data))>>18)
+#define MIS_UMSK_ISR_GP0A_int16_shift                                                (17)
+#define MIS_UMSK_ISR_GP0A_int16_mask                                                 (0x00020000)
+#define MIS_UMSK_ISR_GP0A_int16(data)                                                (0x00020000&((data)<<17))
+#define MIS_UMSK_ISR_GP0A_int16_src(data)                                            ((0x00020000&(data))>>17)
+#define MIS_UMSK_ISR_GP0A_get_int16(data)                                            ((0x00020000&(data))>>17)
+#define MIS_UMSK_ISR_GP0A_int15_shift                                                (16)
+#define MIS_UMSK_ISR_GP0A_int15_mask                                                 (0x00010000)
+#define MIS_UMSK_ISR_GP0A_int15(data)                                                (0x00010000&((data)<<16))
+#define MIS_UMSK_ISR_GP0A_int15_src(data)                                            ((0x00010000&(data))>>16)
+#define MIS_UMSK_ISR_GP0A_get_int15(data)                                            ((0x00010000&(data))>>16)
+#define MIS_UMSK_ISR_GP0A_int14_shift                                                (15)
+#define MIS_UMSK_ISR_GP0A_int14_mask                                                 (0x00008000)
+#define MIS_UMSK_ISR_GP0A_int14(data)                                                (0x00008000&((data)<<15))
+#define MIS_UMSK_ISR_GP0A_int14_src(data)                                            ((0x00008000&(data))>>15)
+#define MIS_UMSK_ISR_GP0A_get_int14(data)                                            ((0x00008000&(data))>>15)
+#define MIS_UMSK_ISR_GP0A_int13_shift                                                (14)
+#define MIS_UMSK_ISR_GP0A_int13_mask                                                 (0x00004000)
+#define MIS_UMSK_ISR_GP0A_int13(data)                                                (0x00004000&((data)<<14))
+#define MIS_UMSK_ISR_GP0A_int13_src(data)                                            ((0x00004000&(data))>>14)
+#define MIS_UMSK_ISR_GP0A_get_int13(data)                                            ((0x00004000&(data))>>14)
+#define MIS_UMSK_ISR_GP0A_int12_shift                                                (13)
+#define MIS_UMSK_ISR_GP0A_int12_mask                                                 (0x00002000)
+#define MIS_UMSK_ISR_GP0A_int12(data)                                                (0x00002000&((data)<<13))
+#define MIS_UMSK_ISR_GP0A_int12_src(data)                                            ((0x00002000&(data))>>13)
+#define MIS_UMSK_ISR_GP0A_get_int12(data)                                            ((0x00002000&(data))>>13)
+#define MIS_UMSK_ISR_GP0A_int11_shift                                                (12)
+#define MIS_UMSK_ISR_GP0A_int11_mask                                                 (0x00001000)
+#define MIS_UMSK_ISR_GP0A_int11(data)                                                (0x00001000&((data)<<12))
+#define MIS_UMSK_ISR_GP0A_int11_src(data)                                            ((0x00001000&(data))>>12)
+#define MIS_UMSK_ISR_GP0A_get_int11(data)                                            ((0x00001000&(data))>>12)
+#define MIS_UMSK_ISR_GP0A_int10_shift                                                (11)
+#define MIS_UMSK_ISR_GP0A_int10_mask                                                 (0x00000800)
+#define MIS_UMSK_ISR_GP0A_int10(data)                                                (0x00000800&((data)<<11))
+#define MIS_UMSK_ISR_GP0A_int10_src(data)                                            ((0x00000800&(data))>>11)
+#define MIS_UMSK_ISR_GP0A_get_int10(data)                                            ((0x00000800&(data))>>11)
+#define MIS_UMSK_ISR_GP0A_int9_shift                                                 (10)
+#define MIS_UMSK_ISR_GP0A_int9_mask                                                  (0x00000400)
+#define MIS_UMSK_ISR_GP0A_int9(data)                                                 (0x00000400&((data)<<10))
+#define MIS_UMSK_ISR_GP0A_int9_src(data)                                             ((0x00000400&(data))>>10)
+#define MIS_UMSK_ISR_GP0A_get_int9(data)                                             ((0x00000400&(data))>>10)
+#define MIS_UMSK_ISR_GP0A_int8_shift                                                 (9)
+#define MIS_UMSK_ISR_GP0A_int8_mask                                                  (0x00000200)
+#define MIS_UMSK_ISR_GP0A_int8(data)                                                 (0x00000200&((data)<<9))
+#define MIS_UMSK_ISR_GP0A_int8_src(data)                                             ((0x00000200&(data))>>9)
+#define MIS_UMSK_ISR_GP0A_get_int8(data)                                             ((0x00000200&(data))>>9)
+#define MIS_UMSK_ISR_GP0A_int7_shift                                                 (8)
+#define MIS_UMSK_ISR_GP0A_int7_mask                                                  (0x00000100)
+#define MIS_UMSK_ISR_GP0A_int7(data)                                                 (0x00000100&((data)<<8))
+#define MIS_UMSK_ISR_GP0A_int7_src(data)                                             ((0x00000100&(data))>>8)
+#define MIS_UMSK_ISR_GP0A_get_int7(data)                                             ((0x00000100&(data))>>8)
+#define MIS_UMSK_ISR_GP0A_int6_shift                                                 (7)
+#define MIS_UMSK_ISR_GP0A_int6_mask                                                  (0x00000080)
+#define MIS_UMSK_ISR_GP0A_int6(data)                                                 (0x00000080&((data)<<7))
+#define MIS_UMSK_ISR_GP0A_int6_src(data)                                             ((0x00000080&(data))>>7)
+#define MIS_UMSK_ISR_GP0A_get_int6(data)                                             ((0x00000080&(data))>>7)
+#define MIS_UMSK_ISR_GP0A_int5_shift                                                 (6)
+#define MIS_UMSK_ISR_GP0A_int5_mask                                                  (0x00000040)
+#define MIS_UMSK_ISR_GP0A_int5(data)                                                 (0x00000040&((data)<<6))
+#define MIS_UMSK_ISR_GP0A_int5_src(data)                                             ((0x00000040&(data))>>6)
+#define MIS_UMSK_ISR_GP0A_get_int5(data)                                             ((0x00000040&(data))>>6)
+#define MIS_UMSK_ISR_GP0A_int4_shift                                                 (5)
+#define MIS_UMSK_ISR_GP0A_int4_mask                                                  (0x00000020)
+#define MIS_UMSK_ISR_GP0A_int4(data)                                                 (0x00000020&((data)<<5))
+#define MIS_UMSK_ISR_GP0A_int4_src(data)                                             ((0x00000020&(data))>>5)
+#define MIS_UMSK_ISR_GP0A_get_int4(data)                                             ((0x00000020&(data))>>5)
+#define MIS_UMSK_ISR_GP0A_int3_shift                                                 (4)
+#define MIS_UMSK_ISR_GP0A_int3_mask                                                  (0x00000010)
+#define MIS_UMSK_ISR_GP0A_int3(data)                                                 (0x00000010&((data)<<4))
+#define MIS_UMSK_ISR_GP0A_int3_src(data)                                             ((0x00000010&(data))>>4)
+#define MIS_UMSK_ISR_GP0A_get_int3(data)                                             ((0x00000010&(data))>>4)
+#define MIS_UMSK_ISR_GP0A_int2_shift                                                 (3)
+#define MIS_UMSK_ISR_GP0A_int2_mask                                                  (0x00000008)
+#define MIS_UMSK_ISR_GP0A_int2(data)                                                 (0x00000008&((data)<<3))
+#define MIS_UMSK_ISR_GP0A_int2_src(data)                                             ((0x00000008&(data))>>3)
+#define MIS_UMSK_ISR_GP0A_get_int2(data)                                             ((0x00000008&(data))>>3)
+#define MIS_UMSK_ISR_GP0A_int1_shift                                                 (2)
+#define MIS_UMSK_ISR_GP0A_int1_mask                                                  (0x00000004)
+#define MIS_UMSK_ISR_GP0A_int1(data)                                                 (0x00000004&((data)<<2))
+#define MIS_UMSK_ISR_GP0A_int1_src(data)                                             ((0x00000004&(data))>>2)
+#define MIS_UMSK_ISR_GP0A_get_int1(data)                                             ((0x00000004&(data))>>2)
+#define MIS_UMSK_ISR_GP0A_int0_shift                                                 (1)
+#define MIS_UMSK_ISR_GP0A_int0_mask                                                  (0x00000002)
+#define MIS_UMSK_ISR_GP0A_int0(data)                                                 (0x00000002&((data)<<1))
+#define MIS_UMSK_ISR_GP0A_int0_src(data)                                             ((0x00000002&(data))>>1)
+#define MIS_UMSK_ISR_GP0A_get_int0(data)                                             ((0x00000002&(data))>>1)
+#define MIS_UMSK_ISR_GP0A_write_data_shift                                           (0)
+#define MIS_UMSK_ISR_GP0A_write_data_mask                                            (0x00000001)
+#define MIS_UMSK_ISR_GP0A_write_data(data)                                           (0x00000001&((data)<<0))
+#define MIS_UMSK_ISR_GP0A_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_UMSK_ISR_GP0A_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_UMSK_ISR_GP1A                                                            0x1801B044
+#define MIS_UMSK_ISR_GP1A_reg_addr                                                   "0xB801B044"
+#define MIS_UMSK_ISR_GP1A_reg                                                        0xB801B044
+#define set_MIS_UMSK_ISR_GP1A_reg(data)   (*((volatile unsigned int*) MIS_UMSK_ISR_GP1A_reg)=data)
+#define get_MIS_UMSK_ISR_GP1A_reg   (*((volatile unsigned int*) MIS_UMSK_ISR_GP1A_reg))
+#define MIS_UMSK_ISR_GP1A_inst_adr                                                   "0x0011"
+#define MIS_UMSK_ISR_GP1A_inst                                                       0x0011
+#define MIS_UMSK_ISR_GP1A_int59_shift                                                (29)
+#define MIS_UMSK_ISR_GP1A_int59_mask                                                 (0x20000000)
+#define MIS_UMSK_ISR_GP1A_int59(data)                                                (0x20000000&((data)<<29))
+#define MIS_UMSK_ISR_GP1A_int59_src(data)                                            ((0x20000000&(data))>>29)
+#define MIS_UMSK_ISR_GP1A_get_int59(data)                                            ((0x20000000&(data))>>29)
+#define MIS_UMSK_ISR_GP1A_int58_shift                                                (28)
+#define MIS_UMSK_ISR_GP1A_int58_mask                                                 (0x10000000)
+#define MIS_UMSK_ISR_GP1A_int58(data)                                                (0x10000000&((data)<<28))
+#define MIS_UMSK_ISR_GP1A_int58_src(data)                                            ((0x10000000&(data))>>28)
+#define MIS_UMSK_ISR_GP1A_get_int58(data)                                            ((0x10000000&(data))>>28)
+#define MIS_UMSK_ISR_GP1A_int57_shift                                                (27)
+#define MIS_UMSK_ISR_GP1A_int57_mask                                                 (0x08000000)
+#define MIS_UMSK_ISR_GP1A_int57(data)                                                (0x08000000&((data)<<27))
+#define MIS_UMSK_ISR_GP1A_int57_src(data)                                            ((0x08000000&(data))>>27)
+#define MIS_UMSK_ISR_GP1A_get_int57(data)                                            ((0x08000000&(data))>>27)
+#define MIS_UMSK_ISR_GP1A_int56_shift                                                (26)
+#define MIS_UMSK_ISR_GP1A_int56_mask                                                 (0x04000000)
+#define MIS_UMSK_ISR_GP1A_int56(data)                                                (0x04000000&((data)<<26))
+#define MIS_UMSK_ISR_GP1A_int56_src(data)                                            ((0x04000000&(data))>>26)
+#define MIS_UMSK_ISR_GP1A_get_int56(data)                                            ((0x04000000&(data))>>26)
+#define MIS_UMSK_ISR_GP1A_int55_shift                                                (25)
+#define MIS_UMSK_ISR_GP1A_int55_mask                                                 (0x02000000)
+#define MIS_UMSK_ISR_GP1A_int55(data)                                                (0x02000000&((data)<<25))
+#define MIS_UMSK_ISR_GP1A_int55_src(data)                                            ((0x02000000&(data))>>25)
+#define MIS_UMSK_ISR_GP1A_get_int55(data)                                            ((0x02000000&(data))>>25)
+#define MIS_UMSK_ISR_GP1A_int54_shift                                                (24)
+#define MIS_UMSK_ISR_GP1A_int54_mask                                                 (0x01000000)
+#define MIS_UMSK_ISR_GP1A_int54(data)                                                (0x01000000&((data)<<24))
+#define MIS_UMSK_ISR_GP1A_int54_src(data)                                            ((0x01000000&(data))>>24)
+#define MIS_UMSK_ISR_GP1A_get_int54(data)                                            ((0x01000000&(data))>>24)
+#define MIS_UMSK_ISR_GP1A_int53_shift                                                (23)
+#define MIS_UMSK_ISR_GP1A_int53_mask                                                 (0x00800000)
+#define MIS_UMSK_ISR_GP1A_int53(data)                                                (0x00800000&((data)<<23))
+#define MIS_UMSK_ISR_GP1A_int53_src(data)                                            ((0x00800000&(data))>>23)
+#define MIS_UMSK_ISR_GP1A_get_int53(data)                                            ((0x00800000&(data))>>23)
+#define MIS_UMSK_ISR_GP1A_int52_shift                                                (22)
+#define MIS_UMSK_ISR_GP1A_int52_mask                                                 (0x00400000)
+#define MIS_UMSK_ISR_GP1A_int52(data)                                                (0x00400000&((data)<<22))
+#define MIS_UMSK_ISR_GP1A_int52_src(data)                                            ((0x00400000&(data))>>22)
+#define MIS_UMSK_ISR_GP1A_get_int52(data)                                            ((0x00400000&(data))>>22)
+#define MIS_UMSK_ISR_GP1A_int51_shift                                                (21)
+#define MIS_UMSK_ISR_GP1A_int51_mask                                                 (0x00200000)
+#define MIS_UMSK_ISR_GP1A_int51(data)                                                (0x00200000&((data)<<21))
+#define MIS_UMSK_ISR_GP1A_int51_src(data)                                            ((0x00200000&(data))>>21)
+#define MIS_UMSK_ISR_GP1A_get_int51(data)                                            ((0x00200000&(data))>>21)
+#define MIS_UMSK_ISR_GP1A_int50_shift                                                (20)
+#define MIS_UMSK_ISR_GP1A_int50_mask                                                 (0x00100000)
+#define MIS_UMSK_ISR_GP1A_int50(data)                                                (0x00100000&((data)<<20))
+#define MIS_UMSK_ISR_GP1A_int50_src(data)                                            ((0x00100000&(data))>>20)
+#define MIS_UMSK_ISR_GP1A_get_int50(data)                                            ((0x00100000&(data))>>20)
+#define MIS_UMSK_ISR_GP1A_int49_shift                                                (19)
+#define MIS_UMSK_ISR_GP1A_int49_mask                                                 (0x00080000)
+#define MIS_UMSK_ISR_GP1A_int49(data)                                                (0x00080000&((data)<<19))
+#define MIS_UMSK_ISR_GP1A_int49_src(data)                                            ((0x00080000&(data))>>19)
+#define MIS_UMSK_ISR_GP1A_get_int49(data)                                            ((0x00080000&(data))>>19)
+#define MIS_UMSK_ISR_GP1A_int48_shift                                                (18)
+#define MIS_UMSK_ISR_GP1A_int48_mask                                                 (0x00040000)
+#define MIS_UMSK_ISR_GP1A_int48(data)                                                (0x00040000&((data)<<18))
+#define MIS_UMSK_ISR_GP1A_int48_src(data)                                            ((0x00040000&(data))>>18)
+#define MIS_UMSK_ISR_GP1A_get_int48(data)                                            ((0x00040000&(data))>>18)
+#define MIS_UMSK_ISR_GP1A_int47_shift                                                (17)
+#define MIS_UMSK_ISR_GP1A_int47_mask                                                 (0x00020000)
+#define MIS_UMSK_ISR_GP1A_int47(data)                                                (0x00020000&((data)<<17))
+#define MIS_UMSK_ISR_GP1A_int47_src(data)                                            ((0x00020000&(data))>>17)
+#define MIS_UMSK_ISR_GP1A_get_int47(data)                                            ((0x00020000&(data))>>17)
+#define MIS_UMSK_ISR_GP1A_int46_shift                                                (16)
+#define MIS_UMSK_ISR_GP1A_int46_mask                                                 (0x00010000)
+#define MIS_UMSK_ISR_GP1A_int46(data)                                                (0x00010000&((data)<<16))
+#define MIS_UMSK_ISR_GP1A_int46_src(data)                                            ((0x00010000&(data))>>16)
+#define MIS_UMSK_ISR_GP1A_get_int46(data)                                            ((0x00010000&(data))>>16)
+#define MIS_UMSK_ISR_GP1A_int45_shift                                                (15)
+#define MIS_UMSK_ISR_GP1A_int45_mask                                                 (0x00008000)
+#define MIS_UMSK_ISR_GP1A_int45(data)                                                (0x00008000&((data)<<15))
+#define MIS_UMSK_ISR_GP1A_int45_src(data)                                            ((0x00008000&(data))>>15)
+#define MIS_UMSK_ISR_GP1A_get_int45(data)                                            ((0x00008000&(data))>>15)
+#define MIS_UMSK_ISR_GP1A_int44_shift                                                (14)
+#define MIS_UMSK_ISR_GP1A_int44_mask                                                 (0x00004000)
+#define MIS_UMSK_ISR_GP1A_int44(data)                                                (0x00004000&((data)<<14))
+#define MIS_UMSK_ISR_GP1A_int44_src(data)                                            ((0x00004000&(data))>>14)
+#define MIS_UMSK_ISR_GP1A_get_int44(data)                                            ((0x00004000&(data))>>14)
+#define MIS_UMSK_ISR_GP1A_int43_shift                                                (13)
+#define MIS_UMSK_ISR_GP1A_int43_mask                                                 (0x00002000)
+#define MIS_UMSK_ISR_GP1A_int43(data)                                                (0x00002000&((data)<<13))
+#define MIS_UMSK_ISR_GP1A_int43_src(data)                                            ((0x00002000&(data))>>13)
+#define MIS_UMSK_ISR_GP1A_get_int43(data)                                            ((0x00002000&(data))>>13)
+#define MIS_UMSK_ISR_GP1A_int42_shift                                                (12)
+#define MIS_UMSK_ISR_GP1A_int42_mask                                                 (0x00001000)
+#define MIS_UMSK_ISR_GP1A_int42(data)                                                (0x00001000&((data)<<12))
+#define MIS_UMSK_ISR_GP1A_int42_src(data)                                            ((0x00001000&(data))>>12)
+#define MIS_UMSK_ISR_GP1A_get_int42(data)                                            ((0x00001000&(data))>>12)
+#define MIS_UMSK_ISR_GP1A_int41_shift                                                (11)
+#define MIS_UMSK_ISR_GP1A_int41_mask                                                 (0x00000800)
+#define MIS_UMSK_ISR_GP1A_int41(data)                                                (0x00000800&((data)<<11))
+#define MIS_UMSK_ISR_GP1A_int41_src(data)                                            ((0x00000800&(data))>>11)
+#define MIS_UMSK_ISR_GP1A_get_int41(data)                                            ((0x00000800&(data))>>11)
+#define MIS_UMSK_ISR_GP1A_int40_shift                                                (10)
+#define MIS_UMSK_ISR_GP1A_int40_mask                                                 (0x00000400)
+#define MIS_UMSK_ISR_GP1A_int40(data)                                                (0x00000400&((data)<<10))
+#define MIS_UMSK_ISR_GP1A_int40_src(data)                                            ((0x00000400&(data))>>10)
+#define MIS_UMSK_ISR_GP1A_get_int40(data)                                            ((0x00000400&(data))>>10)
+#define MIS_UMSK_ISR_GP1A_int39_shift                                                (9)
+#define MIS_UMSK_ISR_GP1A_int39_mask                                                 (0x00000200)
+#define MIS_UMSK_ISR_GP1A_int39(data)                                                (0x00000200&((data)<<9))
+#define MIS_UMSK_ISR_GP1A_int39_src(data)                                            ((0x00000200&(data))>>9)
+#define MIS_UMSK_ISR_GP1A_get_int39(data)                                            ((0x00000200&(data))>>9)
+#define MIS_UMSK_ISR_GP1A_int38_shift                                                (8)
+#define MIS_UMSK_ISR_GP1A_int38_mask                                                 (0x00000100)
+#define MIS_UMSK_ISR_GP1A_int38(data)                                                (0x00000100&((data)<<8))
+#define MIS_UMSK_ISR_GP1A_int38_src(data)                                            ((0x00000100&(data))>>8)
+#define MIS_UMSK_ISR_GP1A_get_int38(data)                                            ((0x00000100&(data))>>8)
+#define MIS_UMSK_ISR_GP1A_int37_shift                                                (7)
+#define MIS_UMSK_ISR_GP1A_int37_mask                                                 (0x00000080)
+#define MIS_UMSK_ISR_GP1A_int37(data)                                                (0x00000080&((data)<<7))
+#define MIS_UMSK_ISR_GP1A_int37_src(data)                                            ((0x00000080&(data))>>7)
+#define MIS_UMSK_ISR_GP1A_get_int37(data)                                            ((0x00000080&(data))>>7)
+#define MIS_UMSK_ISR_GP1A_int36_shift                                                (6)
+#define MIS_UMSK_ISR_GP1A_int36_mask                                                 (0x00000040)
+#define MIS_UMSK_ISR_GP1A_int36(data)                                                (0x00000040&((data)<<6))
+#define MIS_UMSK_ISR_GP1A_int36_src(data)                                            ((0x00000040&(data))>>6)
+#define MIS_UMSK_ISR_GP1A_get_int36(data)                                            ((0x00000040&(data))>>6)
+#define MIS_UMSK_ISR_GP1A_int35_shift                                                (5)
+#define MIS_UMSK_ISR_GP1A_int35_mask                                                 (0x00000020)
+#define MIS_UMSK_ISR_GP1A_int35(data)                                                (0x00000020&((data)<<5))
+#define MIS_UMSK_ISR_GP1A_int35_src(data)                                            ((0x00000020&(data))>>5)
+#define MIS_UMSK_ISR_GP1A_get_int35(data)                                            ((0x00000020&(data))>>5)
+#define MIS_UMSK_ISR_GP1A_int34_shift                                                (4)
+#define MIS_UMSK_ISR_GP1A_int34_mask                                                 (0x00000010)
+#define MIS_UMSK_ISR_GP1A_int34(data)                                                (0x00000010&((data)<<4))
+#define MIS_UMSK_ISR_GP1A_int34_src(data)                                            ((0x00000010&(data))>>4)
+#define MIS_UMSK_ISR_GP1A_get_int34(data)                                            ((0x00000010&(data))>>4)
+#define MIS_UMSK_ISR_GP1A_int33_shift                                                (3)
+#define MIS_UMSK_ISR_GP1A_int33_mask                                                 (0x00000008)
+#define MIS_UMSK_ISR_GP1A_int33(data)                                                (0x00000008&((data)<<3))
+#define MIS_UMSK_ISR_GP1A_int33_src(data)                                            ((0x00000008&(data))>>3)
+#define MIS_UMSK_ISR_GP1A_get_int33(data)                                            ((0x00000008&(data))>>3)
+#define MIS_UMSK_ISR_GP1A_int32_shift                                                (2)
+#define MIS_UMSK_ISR_GP1A_int32_mask                                                 (0x00000004)
+#define MIS_UMSK_ISR_GP1A_int32(data)                                                (0x00000004&((data)<<2))
+#define MIS_UMSK_ISR_GP1A_int32_src(data)                                            ((0x00000004&(data))>>2)
+#define MIS_UMSK_ISR_GP1A_get_int32(data)                                            ((0x00000004&(data))>>2)
+#define MIS_UMSK_ISR_GP1A_int31_shift                                                (1)
+#define MIS_UMSK_ISR_GP1A_int31_mask                                                 (0x00000002)
+#define MIS_UMSK_ISR_GP1A_int31(data)                                                (0x00000002&((data)<<1))
+#define MIS_UMSK_ISR_GP1A_int31_src(data)                                            ((0x00000002&(data))>>1)
+#define MIS_UMSK_ISR_GP1A_get_int31(data)                                            ((0x00000002&(data))>>1)
+#define MIS_UMSK_ISR_GP1A_write_data_shift                                           (0)
+#define MIS_UMSK_ISR_GP1A_write_data_mask                                            (0x00000001)
+#define MIS_UMSK_ISR_GP1A_write_data(data)                                           (0x00000001&((data)<<0))
+#define MIS_UMSK_ISR_GP1A_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_UMSK_ISR_GP1A_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_UMSK_ISR_GP0DA                                                           0x1801B054
+#define MIS_UMSK_ISR_GP0DA_reg_addr                                                  "0xB801B054"
+#define MIS_UMSK_ISR_GP0DA_reg                                                       0xB801B054
+#define set_MIS_UMSK_ISR_GP0DA_reg(data)   (*((volatile unsigned int*) MIS_UMSK_ISR_GP0DA_reg)=data)
+#define get_MIS_UMSK_ISR_GP0DA_reg   (*((volatile unsigned int*) MIS_UMSK_ISR_GP0DA_reg))
+#define MIS_UMSK_ISR_GP0DA_inst_adr                                                  "0x0015"
+#define MIS_UMSK_ISR_GP0DA_inst                                                      0x0015
+#define MIS_UMSK_ISR_GP0DA_int30_shift                                               (31)
+#define MIS_UMSK_ISR_GP0DA_int30_mask                                                (0x80000000)
+#define MIS_UMSK_ISR_GP0DA_int30(data)                                               (0x80000000&((data)<<31))
+#define MIS_UMSK_ISR_GP0DA_int30_src(data)                                           ((0x80000000&(data))>>31)
+#define MIS_UMSK_ISR_GP0DA_get_int30(data)                                           ((0x80000000&(data))>>31)
+#define MIS_UMSK_ISR_GP0DA_int29_shift                                               (30)
+#define MIS_UMSK_ISR_GP0DA_int29_mask                                                (0x40000000)
+#define MIS_UMSK_ISR_GP0DA_int29(data)                                               (0x40000000&((data)<<30))
+#define MIS_UMSK_ISR_GP0DA_int29_src(data)                                           ((0x40000000&(data))>>30)
+#define MIS_UMSK_ISR_GP0DA_get_int29(data)                                           ((0x40000000&(data))>>30)
+#define MIS_UMSK_ISR_GP0DA_int28_shift                                               (29)
+#define MIS_UMSK_ISR_GP0DA_int28_mask                                                (0x20000000)
+#define MIS_UMSK_ISR_GP0DA_int28(data)                                               (0x20000000&((data)<<29))
+#define MIS_UMSK_ISR_GP0DA_int28_src(data)                                           ((0x20000000&(data))>>29)
+#define MIS_UMSK_ISR_GP0DA_get_int28(data)                                           ((0x20000000&(data))>>29)
+#define MIS_UMSK_ISR_GP0DA_int27_shift                                               (28)
+#define MIS_UMSK_ISR_GP0DA_int27_mask                                                (0x10000000)
+#define MIS_UMSK_ISR_GP0DA_int27(data)                                               (0x10000000&((data)<<28))
+#define MIS_UMSK_ISR_GP0DA_int27_src(data)                                           ((0x10000000&(data))>>28)
+#define MIS_UMSK_ISR_GP0DA_get_int27(data)                                           ((0x10000000&(data))>>28)
+#define MIS_UMSK_ISR_GP0DA_int26_shift                                               (27)
+#define MIS_UMSK_ISR_GP0DA_int26_mask                                                (0x08000000)
+#define MIS_UMSK_ISR_GP0DA_int26(data)                                               (0x08000000&((data)<<27))
+#define MIS_UMSK_ISR_GP0DA_int26_src(data)                                           ((0x08000000&(data))>>27)
+#define MIS_UMSK_ISR_GP0DA_get_int26(data)                                           ((0x08000000&(data))>>27)
+#define MIS_UMSK_ISR_GP0DA_int25_shift                                               (26)
+#define MIS_UMSK_ISR_GP0DA_int25_mask                                                (0x04000000)
+#define MIS_UMSK_ISR_GP0DA_int25(data)                                               (0x04000000&((data)<<26))
+#define MIS_UMSK_ISR_GP0DA_int25_src(data)                                           ((0x04000000&(data))>>26)
+#define MIS_UMSK_ISR_GP0DA_get_int25(data)                                           ((0x04000000&(data))>>26)
+#define MIS_UMSK_ISR_GP0DA_int24_shift                                               (25)
+#define MIS_UMSK_ISR_GP0DA_int24_mask                                                (0x02000000)
+#define MIS_UMSK_ISR_GP0DA_int24(data)                                               (0x02000000&((data)<<25))
+#define MIS_UMSK_ISR_GP0DA_int24_src(data)                                           ((0x02000000&(data))>>25)
+#define MIS_UMSK_ISR_GP0DA_get_int24(data)                                           ((0x02000000&(data))>>25)
+#define MIS_UMSK_ISR_GP0DA_int23_shift                                               (24)
+#define MIS_UMSK_ISR_GP0DA_int23_mask                                                (0x01000000)
+#define MIS_UMSK_ISR_GP0DA_int23(data)                                               (0x01000000&((data)<<24))
+#define MIS_UMSK_ISR_GP0DA_int23_src(data)                                           ((0x01000000&(data))>>24)
+#define MIS_UMSK_ISR_GP0DA_get_int23(data)                                           ((0x01000000&(data))>>24)
+#define MIS_UMSK_ISR_GP0DA_int22_shift                                               (23)
+#define MIS_UMSK_ISR_GP0DA_int22_mask                                                (0x00800000)
+#define MIS_UMSK_ISR_GP0DA_int22(data)                                               (0x00800000&((data)<<23))
+#define MIS_UMSK_ISR_GP0DA_int22_src(data)                                           ((0x00800000&(data))>>23)
+#define MIS_UMSK_ISR_GP0DA_get_int22(data)                                           ((0x00800000&(data))>>23)
+#define MIS_UMSK_ISR_GP0DA_int21_shift                                               (22)
+#define MIS_UMSK_ISR_GP0DA_int21_mask                                                (0x00400000)
+#define MIS_UMSK_ISR_GP0DA_int21(data)                                               (0x00400000&((data)<<22))
+#define MIS_UMSK_ISR_GP0DA_int21_src(data)                                           ((0x00400000&(data))>>22)
+#define MIS_UMSK_ISR_GP0DA_get_int21(data)                                           ((0x00400000&(data))>>22)
+#define MIS_UMSK_ISR_GP0DA_int20_shift                                               (21)
+#define MIS_UMSK_ISR_GP0DA_int20_mask                                                (0x00200000)
+#define MIS_UMSK_ISR_GP0DA_int20(data)                                               (0x00200000&((data)<<21))
+#define MIS_UMSK_ISR_GP0DA_int20_src(data)                                           ((0x00200000&(data))>>21)
+#define MIS_UMSK_ISR_GP0DA_get_int20(data)                                           ((0x00200000&(data))>>21)
+#define MIS_UMSK_ISR_GP0DA_int19_shift                                               (20)
+#define MIS_UMSK_ISR_GP0DA_int19_mask                                                (0x00100000)
+#define MIS_UMSK_ISR_GP0DA_int19(data)                                               (0x00100000&((data)<<20))
+#define MIS_UMSK_ISR_GP0DA_int19_src(data)                                           ((0x00100000&(data))>>20)
+#define MIS_UMSK_ISR_GP0DA_get_int19(data)                                           ((0x00100000&(data))>>20)
+#define MIS_UMSK_ISR_GP0DA_int18_shift                                               (19)
+#define MIS_UMSK_ISR_GP0DA_int18_mask                                                (0x00080000)
+#define MIS_UMSK_ISR_GP0DA_int18(data)                                               (0x00080000&((data)<<19))
+#define MIS_UMSK_ISR_GP0DA_int18_src(data)                                           ((0x00080000&(data))>>19)
+#define MIS_UMSK_ISR_GP0DA_get_int18(data)                                           ((0x00080000&(data))>>19)
+#define MIS_UMSK_ISR_GP0DA_int17_shift                                               (18)
+#define MIS_UMSK_ISR_GP0DA_int17_mask                                                (0x00040000)
+#define MIS_UMSK_ISR_GP0DA_int17(data)                                               (0x00040000&((data)<<18))
+#define MIS_UMSK_ISR_GP0DA_int17_src(data)                                           ((0x00040000&(data))>>18)
+#define MIS_UMSK_ISR_GP0DA_get_int17(data)                                           ((0x00040000&(data))>>18)
+#define MIS_UMSK_ISR_GP0DA_int16_shift                                               (17)
+#define MIS_UMSK_ISR_GP0DA_int16_mask                                                (0x00020000)
+#define MIS_UMSK_ISR_GP0DA_int16(data)                                               (0x00020000&((data)<<17))
+#define MIS_UMSK_ISR_GP0DA_int16_src(data)                                           ((0x00020000&(data))>>17)
+#define MIS_UMSK_ISR_GP0DA_get_int16(data)                                           ((0x00020000&(data))>>17)
+#define MIS_UMSK_ISR_GP0DA_int15_shift                                               (16)
+#define MIS_UMSK_ISR_GP0DA_int15_mask                                                (0x00010000)
+#define MIS_UMSK_ISR_GP0DA_int15(data)                                               (0x00010000&((data)<<16))
+#define MIS_UMSK_ISR_GP0DA_int15_src(data)                                           ((0x00010000&(data))>>16)
+#define MIS_UMSK_ISR_GP0DA_get_int15(data)                                           ((0x00010000&(data))>>16)
+#define MIS_UMSK_ISR_GP0DA_int14_shift                                               (15)
+#define MIS_UMSK_ISR_GP0DA_int14_mask                                                (0x00008000)
+#define MIS_UMSK_ISR_GP0DA_int14(data)                                               (0x00008000&((data)<<15))
+#define MIS_UMSK_ISR_GP0DA_int14_src(data)                                           ((0x00008000&(data))>>15)
+#define MIS_UMSK_ISR_GP0DA_get_int14(data)                                           ((0x00008000&(data))>>15)
+#define MIS_UMSK_ISR_GP0DA_int13_shift                                               (14)
+#define MIS_UMSK_ISR_GP0DA_int13_mask                                                (0x00004000)
+#define MIS_UMSK_ISR_GP0DA_int13(data)                                               (0x00004000&((data)<<14))
+#define MIS_UMSK_ISR_GP0DA_int13_src(data)                                           ((0x00004000&(data))>>14)
+#define MIS_UMSK_ISR_GP0DA_get_int13(data)                                           ((0x00004000&(data))>>14)
+#define MIS_UMSK_ISR_GP0DA_int12_shift                                               (13)
+#define MIS_UMSK_ISR_GP0DA_int12_mask                                                (0x00002000)
+#define MIS_UMSK_ISR_GP0DA_int12(data)                                               (0x00002000&((data)<<13))
+#define MIS_UMSK_ISR_GP0DA_int12_src(data)                                           ((0x00002000&(data))>>13)
+#define MIS_UMSK_ISR_GP0DA_get_int12(data)                                           ((0x00002000&(data))>>13)
+#define MIS_UMSK_ISR_GP0DA_int11_shift                                               (12)
+#define MIS_UMSK_ISR_GP0DA_int11_mask                                                (0x00001000)
+#define MIS_UMSK_ISR_GP0DA_int11(data)                                               (0x00001000&((data)<<12))
+#define MIS_UMSK_ISR_GP0DA_int11_src(data)                                           ((0x00001000&(data))>>12)
+#define MIS_UMSK_ISR_GP0DA_get_int11(data)                                           ((0x00001000&(data))>>12)
+#define MIS_UMSK_ISR_GP0DA_int10_shift                                               (11)
+#define MIS_UMSK_ISR_GP0DA_int10_mask                                                (0x00000800)
+#define MIS_UMSK_ISR_GP0DA_int10(data)                                               (0x00000800&((data)<<11))
+#define MIS_UMSK_ISR_GP0DA_int10_src(data)                                           ((0x00000800&(data))>>11)
+#define MIS_UMSK_ISR_GP0DA_get_int10(data)                                           ((0x00000800&(data))>>11)
+#define MIS_UMSK_ISR_GP0DA_int9_shift                                                (10)
+#define MIS_UMSK_ISR_GP0DA_int9_mask                                                 (0x00000400)
+#define MIS_UMSK_ISR_GP0DA_int9(data)                                                (0x00000400&((data)<<10))
+#define MIS_UMSK_ISR_GP0DA_int9_src(data)                                            ((0x00000400&(data))>>10)
+#define MIS_UMSK_ISR_GP0DA_get_int9(data)                                            ((0x00000400&(data))>>10)
+#define MIS_UMSK_ISR_GP0DA_int8_shift                                                (9)
+#define MIS_UMSK_ISR_GP0DA_int8_mask                                                 (0x00000200)
+#define MIS_UMSK_ISR_GP0DA_int8(data)                                                (0x00000200&((data)<<9))
+#define MIS_UMSK_ISR_GP0DA_int8_src(data)                                            ((0x00000200&(data))>>9)
+#define MIS_UMSK_ISR_GP0DA_get_int8(data)                                            ((0x00000200&(data))>>9)
+#define MIS_UMSK_ISR_GP0DA_int7_shift                                                (8)
+#define MIS_UMSK_ISR_GP0DA_int7_mask                                                 (0x00000100)
+#define MIS_UMSK_ISR_GP0DA_int7(data)                                                (0x00000100&((data)<<8))
+#define MIS_UMSK_ISR_GP0DA_int7_src(data)                                            ((0x00000100&(data))>>8)
+#define MIS_UMSK_ISR_GP0DA_get_int7(data)                                            ((0x00000100&(data))>>8)
+#define MIS_UMSK_ISR_GP0DA_int6_shift                                                (7)
+#define MIS_UMSK_ISR_GP0DA_int6_mask                                                 (0x00000080)
+#define MIS_UMSK_ISR_GP0DA_int6(data)                                                (0x00000080&((data)<<7))
+#define MIS_UMSK_ISR_GP0DA_int6_src(data)                                            ((0x00000080&(data))>>7)
+#define MIS_UMSK_ISR_GP0DA_get_int6(data)                                            ((0x00000080&(data))>>7)
+#define MIS_UMSK_ISR_GP0DA_int5_shift                                                (6)
+#define MIS_UMSK_ISR_GP0DA_int5_mask                                                 (0x00000040)
+#define MIS_UMSK_ISR_GP0DA_int5(data)                                                (0x00000040&((data)<<6))
+#define MIS_UMSK_ISR_GP0DA_int5_src(data)                                            ((0x00000040&(data))>>6)
+#define MIS_UMSK_ISR_GP0DA_get_int5(data)                                            ((0x00000040&(data))>>6)
+#define MIS_UMSK_ISR_GP0DA_int4_shift                                                (5)
+#define MIS_UMSK_ISR_GP0DA_int4_mask                                                 (0x00000020)
+#define MIS_UMSK_ISR_GP0DA_int4(data)                                                (0x00000020&((data)<<5))
+#define MIS_UMSK_ISR_GP0DA_int4_src(data)                                            ((0x00000020&(data))>>5)
+#define MIS_UMSK_ISR_GP0DA_get_int4(data)                                            ((0x00000020&(data))>>5)
+#define MIS_UMSK_ISR_GP0DA_int3_shift                                                (4)
+#define MIS_UMSK_ISR_GP0DA_int3_mask                                                 (0x00000010)
+#define MIS_UMSK_ISR_GP0DA_int3(data)                                                (0x00000010&((data)<<4))
+#define MIS_UMSK_ISR_GP0DA_int3_src(data)                                            ((0x00000010&(data))>>4)
+#define MIS_UMSK_ISR_GP0DA_get_int3(data)                                            ((0x00000010&(data))>>4)
+#define MIS_UMSK_ISR_GP0DA_int2_shift                                                (3)
+#define MIS_UMSK_ISR_GP0DA_int2_mask                                                 (0x00000008)
+#define MIS_UMSK_ISR_GP0DA_int2(data)                                                (0x00000008&((data)<<3))
+#define MIS_UMSK_ISR_GP0DA_int2_src(data)                                            ((0x00000008&(data))>>3)
+#define MIS_UMSK_ISR_GP0DA_get_int2(data)                                            ((0x00000008&(data))>>3)
+#define MIS_UMSK_ISR_GP0DA_int1_shift                                                (2)
+#define MIS_UMSK_ISR_GP0DA_int1_mask                                                 (0x00000004)
+#define MIS_UMSK_ISR_GP0DA_int1(data)                                                (0x00000004&((data)<<2))
+#define MIS_UMSK_ISR_GP0DA_int1_src(data)                                            ((0x00000004&(data))>>2)
+#define MIS_UMSK_ISR_GP0DA_get_int1(data)                                            ((0x00000004&(data))>>2)
+#define MIS_UMSK_ISR_GP0DA_int0_shift                                                (1)
+#define MIS_UMSK_ISR_GP0DA_int0_mask                                                 (0x00000002)
+#define MIS_UMSK_ISR_GP0DA_int0(data)                                                (0x00000002&((data)<<1))
+#define MIS_UMSK_ISR_GP0DA_int0_src(data)                                            ((0x00000002&(data))>>1)
+#define MIS_UMSK_ISR_GP0DA_get_int0(data)                                            ((0x00000002&(data))>>1)
+#define MIS_UMSK_ISR_GP0DA_write_data_shift                                          (0)
+#define MIS_UMSK_ISR_GP0DA_write_data_mask                                           (0x00000001)
+#define MIS_UMSK_ISR_GP0DA_write_data(data)                                          (0x00000001&((data)<<0))
+#define MIS_UMSK_ISR_GP0DA_write_data_src(data)                                      ((0x00000001&(data))>>0)
+#define MIS_UMSK_ISR_GP0DA_get_write_data(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_UMSK_ISR_GP1DA                                                           0x1801B058
+#define MIS_UMSK_ISR_GP1DA_reg_addr                                                  "0xB801B058"
+#define MIS_UMSK_ISR_GP1DA_reg                                                       0xB801B058
+#define set_MIS_UMSK_ISR_GP1DA_reg(data)   (*((volatile unsigned int*) MIS_UMSK_ISR_GP1DA_reg)=data)
+#define get_MIS_UMSK_ISR_GP1DA_reg   (*((volatile unsigned int*) MIS_UMSK_ISR_GP1DA_reg))
+#define MIS_UMSK_ISR_GP1DA_inst_adr                                                  "0x0016"
+#define MIS_UMSK_ISR_GP1DA_inst                                                      0x0016
+#define MIS_UMSK_ISR_GP1DA_int59_shift                                               (29)
+#define MIS_UMSK_ISR_GP1DA_int59_mask                                                (0x20000000)
+#define MIS_UMSK_ISR_GP1DA_int59(data)                                               (0x20000000&((data)<<29))
+#define MIS_UMSK_ISR_GP1DA_int59_src(data)                                           ((0x20000000&(data))>>29)
+#define MIS_UMSK_ISR_GP1DA_get_int59(data)                                           ((0x20000000&(data))>>29)
+#define MIS_UMSK_ISR_GP1DA_int58_shift                                               (28)
+#define MIS_UMSK_ISR_GP1DA_int58_mask                                                (0x10000000)
+#define MIS_UMSK_ISR_GP1DA_int58(data)                                               (0x10000000&((data)<<28))
+#define MIS_UMSK_ISR_GP1DA_int58_src(data)                                           ((0x10000000&(data))>>28)
+#define MIS_UMSK_ISR_GP1DA_get_int58(data)                                           ((0x10000000&(data))>>28)
+#define MIS_UMSK_ISR_GP1DA_int57_shift                                               (27)
+#define MIS_UMSK_ISR_GP1DA_int57_mask                                                (0x08000000)
+#define MIS_UMSK_ISR_GP1DA_int57(data)                                               (0x08000000&((data)<<27))
+#define MIS_UMSK_ISR_GP1DA_int57_src(data)                                           ((0x08000000&(data))>>27)
+#define MIS_UMSK_ISR_GP1DA_get_int57(data)                                           ((0x08000000&(data))>>27)
+#define MIS_UMSK_ISR_GP1DA_int56_shift                                               (26)
+#define MIS_UMSK_ISR_GP1DA_int56_mask                                                (0x04000000)
+#define MIS_UMSK_ISR_GP1DA_int56(data)                                               (0x04000000&((data)<<26))
+#define MIS_UMSK_ISR_GP1DA_int56_src(data)                                           ((0x04000000&(data))>>26)
+#define MIS_UMSK_ISR_GP1DA_get_int56(data)                                           ((0x04000000&(data))>>26)
+#define MIS_UMSK_ISR_GP1DA_int55_shift                                               (25)
+#define MIS_UMSK_ISR_GP1DA_int55_mask                                                (0x02000000)
+#define MIS_UMSK_ISR_GP1DA_int55(data)                                               (0x02000000&((data)<<25))
+#define MIS_UMSK_ISR_GP1DA_int55_src(data)                                           ((0x02000000&(data))>>25)
+#define MIS_UMSK_ISR_GP1DA_get_int55(data)                                           ((0x02000000&(data))>>25)
+#define MIS_UMSK_ISR_GP1DA_int54_shift                                               (24)
+#define MIS_UMSK_ISR_GP1DA_int54_mask                                                (0x01000000)
+#define MIS_UMSK_ISR_GP1DA_int54(data)                                               (0x01000000&((data)<<24))
+#define MIS_UMSK_ISR_GP1DA_int54_src(data)                                           ((0x01000000&(data))>>24)
+#define MIS_UMSK_ISR_GP1DA_get_int54(data)                                           ((0x01000000&(data))>>24)
+#define MIS_UMSK_ISR_GP1DA_int53_shift                                               (23)
+#define MIS_UMSK_ISR_GP1DA_int53_mask                                                (0x00800000)
+#define MIS_UMSK_ISR_GP1DA_int53(data)                                               (0x00800000&((data)<<23))
+#define MIS_UMSK_ISR_GP1DA_int53_src(data)                                           ((0x00800000&(data))>>23)
+#define MIS_UMSK_ISR_GP1DA_get_int53(data)                                           ((0x00800000&(data))>>23)
+#define MIS_UMSK_ISR_GP1DA_int52_shift                                               (22)
+#define MIS_UMSK_ISR_GP1DA_int52_mask                                                (0x00400000)
+#define MIS_UMSK_ISR_GP1DA_int52(data)                                               (0x00400000&((data)<<22))
+#define MIS_UMSK_ISR_GP1DA_int52_src(data)                                           ((0x00400000&(data))>>22)
+#define MIS_UMSK_ISR_GP1DA_get_int52(data)                                           ((0x00400000&(data))>>22)
+#define MIS_UMSK_ISR_GP1DA_int51_shift                                               (21)
+#define MIS_UMSK_ISR_GP1DA_int51_mask                                                (0x00200000)
+#define MIS_UMSK_ISR_GP1DA_int51(data)                                               (0x00200000&((data)<<21))
+#define MIS_UMSK_ISR_GP1DA_int51_src(data)                                           ((0x00200000&(data))>>21)
+#define MIS_UMSK_ISR_GP1DA_get_int51(data)                                           ((0x00200000&(data))>>21)
+#define MIS_UMSK_ISR_GP1DA_int50_shift                                               (20)
+#define MIS_UMSK_ISR_GP1DA_int50_mask                                                (0x00100000)
+#define MIS_UMSK_ISR_GP1DA_int50(data)                                               (0x00100000&((data)<<20))
+#define MIS_UMSK_ISR_GP1DA_int50_src(data)                                           ((0x00100000&(data))>>20)
+#define MIS_UMSK_ISR_GP1DA_get_int50(data)                                           ((0x00100000&(data))>>20)
+#define MIS_UMSK_ISR_GP1DA_int49_shift                                               (19)
+#define MIS_UMSK_ISR_GP1DA_int49_mask                                                (0x00080000)
+#define MIS_UMSK_ISR_GP1DA_int49(data)                                               (0x00080000&((data)<<19))
+#define MIS_UMSK_ISR_GP1DA_int49_src(data)                                           ((0x00080000&(data))>>19)
+#define MIS_UMSK_ISR_GP1DA_get_int49(data)                                           ((0x00080000&(data))>>19)
+#define MIS_UMSK_ISR_GP1DA_int48_shift                                               (18)
+#define MIS_UMSK_ISR_GP1DA_int48_mask                                                (0x00040000)
+#define MIS_UMSK_ISR_GP1DA_int48(data)                                               (0x00040000&((data)<<18))
+#define MIS_UMSK_ISR_GP1DA_int48_src(data)                                           ((0x00040000&(data))>>18)
+#define MIS_UMSK_ISR_GP1DA_get_int48(data)                                           ((0x00040000&(data))>>18)
+#define MIS_UMSK_ISR_GP1DA_int47_shift                                               (17)
+#define MIS_UMSK_ISR_GP1DA_int47_mask                                                (0x00020000)
+#define MIS_UMSK_ISR_GP1DA_int47(data)                                               (0x00020000&((data)<<17))
+#define MIS_UMSK_ISR_GP1DA_int47_src(data)                                           ((0x00020000&(data))>>17)
+#define MIS_UMSK_ISR_GP1DA_get_int47(data)                                           ((0x00020000&(data))>>17)
+#define MIS_UMSK_ISR_GP1DA_int46_shift                                               (16)
+#define MIS_UMSK_ISR_GP1DA_int46_mask                                                (0x00010000)
+#define MIS_UMSK_ISR_GP1DA_int46(data)                                               (0x00010000&((data)<<16))
+#define MIS_UMSK_ISR_GP1DA_int46_src(data)                                           ((0x00010000&(data))>>16)
+#define MIS_UMSK_ISR_GP1DA_get_int46(data)                                           ((0x00010000&(data))>>16)
+#define MIS_UMSK_ISR_GP1DA_int45_shift                                               (15)
+#define MIS_UMSK_ISR_GP1DA_int45_mask                                                (0x00008000)
+#define MIS_UMSK_ISR_GP1DA_int45(data)                                               (0x00008000&((data)<<15))
+#define MIS_UMSK_ISR_GP1DA_int45_src(data)                                           ((0x00008000&(data))>>15)
+#define MIS_UMSK_ISR_GP1DA_get_int45(data)                                           ((0x00008000&(data))>>15)
+#define MIS_UMSK_ISR_GP1DA_int44_shift                                               (14)
+#define MIS_UMSK_ISR_GP1DA_int44_mask                                                (0x00004000)
+#define MIS_UMSK_ISR_GP1DA_int44(data)                                               (0x00004000&((data)<<14))
+#define MIS_UMSK_ISR_GP1DA_int44_src(data)                                           ((0x00004000&(data))>>14)
+#define MIS_UMSK_ISR_GP1DA_get_int44(data)                                           ((0x00004000&(data))>>14)
+#define MIS_UMSK_ISR_GP1DA_int43_shift                                               (13)
+#define MIS_UMSK_ISR_GP1DA_int43_mask                                                (0x00002000)
+#define MIS_UMSK_ISR_GP1DA_int43(data)                                               (0x00002000&((data)<<13))
+#define MIS_UMSK_ISR_GP1DA_int43_src(data)                                           ((0x00002000&(data))>>13)
+#define MIS_UMSK_ISR_GP1DA_get_int43(data)                                           ((0x00002000&(data))>>13)
+#define MIS_UMSK_ISR_GP1DA_int42_shift                                               (12)
+#define MIS_UMSK_ISR_GP1DA_int42_mask                                                (0x00001000)
+#define MIS_UMSK_ISR_GP1DA_int42(data)                                               (0x00001000&((data)<<12))
+#define MIS_UMSK_ISR_GP1DA_int42_src(data)                                           ((0x00001000&(data))>>12)
+#define MIS_UMSK_ISR_GP1DA_get_int42(data)                                           ((0x00001000&(data))>>12)
+#define MIS_UMSK_ISR_GP1DA_int41_shift                                               (11)
+#define MIS_UMSK_ISR_GP1DA_int41_mask                                                (0x00000800)
+#define MIS_UMSK_ISR_GP1DA_int41(data)                                               (0x00000800&((data)<<11))
+#define MIS_UMSK_ISR_GP1DA_int41_src(data)                                           ((0x00000800&(data))>>11)
+#define MIS_UMSK_ISR_GP1DA_get_int41(data)                                           ((0x00000800&(data))>>11)
+#define MIS_UMSK_ISR_GP1DA_int40_shift                                               (10)
+#define MIS_UMSK_ISR_GP1DA_int40_mask                                                (0x00000400)
+#define MIS_UMSK_ISR_GP1DA_int40(data)                                               (0x00000400&((data)<<10))
+#define MIS_UMSK_ISR_GP1DA_int40_src(data)                                           ((0x00000400&(data))>>10)
+#define MIS_UMSK_ISR_GP1DA_get_int40(data)                                           ((0x00000400&(data))>>10)
+#define MIS_UMSK_ISR_GP1DA_int39_shift                                               (9)
+#define MIS_UMSK_ISR_GP1DA_int39_mask                                                (0x00000200)
+#define MIS_UMSK_ISR_GP1DA_int39(data)                                               (0x00000200&((data)<<9))
+#define MIS_UMSK_ISR_GP1DA_int39_src(data)                                           ((0x00000200&(data))>>9)
+#define MIS_UMSK_ISR_GP1DA_get_int39(data)                                           ((0x00000200&(data))>>9)
+#define MIS_UMSK_ISR_GP1DA_int38_shift                                               (8)
+#define MIS_UMSK_ISR_GP1DA_int38_mask                                                (0x00000100)
+#define MIS_UMSK_ISR_GP1DA_int38(data)                                               (0x00000100&((data)<<8))
+#define MIS_UMSK_ISR_GP1DA_int38_src(data)                                           ((0x00000100&(data))>>8)
+#define MIS_UMSK_ISR_GP1DA_get_int38(data)                                           ((0x00000100&(data))>>8)
+#define MIS_UMSK_ISR_GP1DA_int37_shift                                               (7)
+#define MIS_UMSK_ISR_GP1DA_int37_mask                                                (0x00000080)
+#define MIS_UMSK_ISR_GP1DA_int37(data)                                               (0x00000080&((data)<<7))
+#define MIS_UMSK_ISR_GP1DA_int37_src(data)                                           ((0x00000080&(data))>>7)
+#define MIS_UMSK_ISR_GP1DA_get_int37(data)                                           ((0x00000080&(data))>>7)
+#define MIS_UMSK_ISR_GP1DA_int36_shift                                               (6)
+#define MIS_UMSK_ISR_GP1DA_int36_mask                                                (0x00000040)
+#define MIS_UMSK_ISR_GP1DA_int36(data)                                               (0x00000040&((data)<<6))
+#define MIS_UMSK_ISR_GP1DA_int36_src(data)                                           ((0x00000040&(data))>>6)
+#define MIS_UMSK_ISR_GP1DA_get_int36(data)                                           ((0x00000040&(data))>>6)
+#define MIS_UMSK_ISR_GP1DA_int35_shift                                               (5)
+#define MIS_UMSK_ISR_GP1DA_int35_mask                                                (0x00000020)
+#define MIS_UMSK_ISR_GP1DA_int35(data)                                               (0x00000020&((data)<<5))
+#define MIS_UMSK_ISR_GP1DA_int35_src(data)                                           ((0x00000020&(data))>>5)
+#define MIS_UMSK_ISR_GP1DA_get_int35(data)                                           ((0x00000020&(data))>>5)
+#define MIS_UMSK_ISR_GP1DA_int34_shift                                               (4)
+#define MIS_UMSK_ISR_GP1DA_int34_mask                                                (0x00000010)
+#define MIS_UMSK_ISR_GP1DA_int34(data)                                               (0x00000010&((data)<<4))
+#define MIS_UMSK_ISR_GP1DA_int34_src(data)                                           ((0x00000010&(data))>>4)
+#define MIS_UMSK_ISR_GP1DA_get_int34(data)                                           ((0x00000010&(data))>>4)
+#define MIS_UMSK_ISR_GP1DA_int33_shift                                               (3)
+#define MIS_UMSK_ISR_GP1DA_int33_mask                                                (0x00000008)
+#define MIS_UMSK_ISR_GP1DA_int33(data)                                               (0x00000008&((data)<<3))
+#define MIS_UMSK_ISR_GP1DA_int33_src(data)                                           ((0x00000008&(data))>>3)
+#define MIS_UMSK_ISR_GP1DA_get_int33(data)                                           ((0x00000008&(data))>>3)
+#define MIS_UMSK_ISR_GP1DA_int32_shift                                               (2)
+#define MIS_UMSK_ISR_GP1DA_int32_mask                                                (0x00000004)
+#define MIS_UMSK_ISR_GP1DA_int32(data)                                               (0x00000004&((data)<<2))
+#define MIS_UMSK_ISR_GP1DA_int32_src(data)                                           ((0x00000004&(data))>>2)
+#define MIS_UMSK_ISR_GP1DA_get_int32(data)                                           ((0x00000004&(data))>>2)
+#define MIS_UMSK_ISR_GP1DA_int31_shift                                               (1)
+#define MIS_UMSK_ISR_GP1DA_int31_mask                                                (0x00000002)
+#define MIS_UMSK_ISR_GP1DA_int31(data)                                               (0x00000002&((data)<<1))
+#define MIS_UMSK_ISR_GP1DA_int31_src(data)                                           ((0x00000002&(data))>>1)
+#define MIS_UMSK_ISR_GP1DA_get_int31(data)                                           ((0x00000002&(data))>>1)
+#define MIS_UMSK_ISR_GP1DA_write_data_shift                                          (0)
+#define MIS_UMSK_ISR_GP1DA_write_data_mask                                           (0x00000001)
+#define MIS_UMSK_ISR_GP1DA_write_data(data)                                          (0x00000001&((data)<<0))
+#define MIS_UMSK_ISR_GP1DA_write_data_src(data)                                      ((0x00000001&(data))>>0)
+#define MIS_UMSK_ISR_GP1DA_get_write_data(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_DUMMY1                                                                   0x1801B068
+#define MIS_DUMMY1_reg_addr                                                          "0xB801B068"
+#define MIS_DUMMY1_reg                                                               0xB801B068
+#define set_MIS_DUMMY1_reg(data)   (*((volatile unsigned int*) MIS_DUMMY1_reg)=data)
+#define get_MIS_DUMMY1_reg   (*((volatile unsigned int*) MIS_DUMMY1_reg))
+#define MIS_DUMMY1_inst_adr                                                          "0x001A"
+#define MIS_DUMMY1_inst                                                              0x001A
+#define MIS_DUMMY1_write_enable2_shift                                               (31)
+#define MIS_DUMMY1_write_enable2_mask                                                (0x80000000)
+#define MIS_DUMMY1_write_enable2(data)                                               (0x80000000&((data)<<31))
+#define MIS_DUMMY1_write_enable2_src(data)                                           ((0x80000000&(data))>>31)
+#define MIS_DUMMY1_get_write_enable2(data)                                           ((0x80000000&(data))>>31)
+#define MIS_DUMMY1_rvd2_shift                                                        (16)
+#define MIS_DUMMY1_rvd2_mask                                                         (0x7FFF0000)
+#define MIS_DUMMY1_rvd2(data)                                                        (0x7FFF0000&((data)<<16))
+#define MIS_DUMMY1_rvd2_src(data)                                                    ((0x7FFF0000&(data))>>16)
+#define MIS_DUMMY1_get_rvd2(data)                                                    ((0x7FFF0000&(data))>>16)
+#define MIS_DUMMY1_write_enable1_shift                                               (15)
+#define MIS_DUMMY1_write_enable1_mask                                                (0x00008000)
+#define MIS_DUMMY1_write_enable1(data)                                               (0x00008000&((data)<<15))
+#define MIS_DUMMY1_write_enable1_src(data)                                           ((0x00008000&(data))>>15)
+#define MIS_DUMMY1_get_write_enable1(data)                                           ((0x00008000&(data))>>15)
+#define MIS_DUMMY1_rvd1_shift                                                        (0)
+#define MIS_DUMMY1_rvd1_mask                                                         (0x00007FFF)
+#define MIS_DUMMY1_rvd1(data)                                                        (0x00007FFF&((data)<<0))
+#define MIS_DUMMY1_rvd1_src(data)                                                    ((0x00007FFF&(data))>>0)
+#define MIS_DUMMY1_get_rvd1(data)                                                    ((0x00007FFF&(data))>>0)
+
+
+#define MIS_UR_CTRL                                                                  0x1801B06C
+#define MIS_UR_CTRL_reg_addr                                                         "0xB801B06C"
+#define MIS_UR_CTRL_reg                                                              0xB801B06C
+#define set_MIS_UR_CTRL_reg(data)   (*((volatile unsigned int*) MIS_UR_CTRL_reg)=data)
+#define get_MIS_UR_CTRL_reg   (*((volatile unsigned int*) MIS_UR_CTRL_reg))
+#define MIS_UR_CTRL_inst_adr                                                         "0x001B"
+#define MIS_UR_CTRL_inst                                                             0x001B
+#define MIS_UR_CTRL_rvd3_shift                                                       (29)
+#define MIS_UR_CTRL_rvd3_mask                                                        (0xE0000000)
+#define MIS_UR_CTRL_rvd3(data)                                                       (0xE0000000&((data)<<29))
+#define MIS_UR_CTRL_rvd3_src(data)                                                   ((0xE0000000&(data))>>29)
+#define MIS_UR_CTRL_get_rvd3(data)                                                   ((0xE0000000&(data))>>29)
+#define MIS_UR_CTRL_to_len_shift                                                     (20)
+#define MIS_UR_CTRL_to_len_mask                                                      (0x0FF00000)
+#define MIS_UR_CTRL_to_len(data)                                                     (0x0FF00000&((data)<<20))
+#define MIS_UR_CTRL_to_len_src(data)                                                 ((0x0FF00000&(data))>>20)
+#define MIS_UR_CTRL_get_to_len(data)                                                 ((0x0FF00000&(data))>>20)
+#define MIS_UR_CTRL_to_int_en_shift                                                  (19)
+#define MIS_UR_CTRL_to_int_en_mask                                                   (0x00080000)
+#define MIS_UR_CTRL_to_int_en(data)                                                  (0x00080000&((data)<<19))
+#define MIS_UR_CTRL_to_int_en_src(data)                                              ((0x00080000&(data))>>19)
+#define MIS_UR_CTRL_get_to_int_en(data)                                              ((0x00080000&(data))>>19)
+#define MIS_UR_CTRL_toauareq_shift                                                   (18)
+#define MIS_UR_CTRL_toauareq_mask                                                    (0x00040000)
+#define MIS_UR_CTRL_toauareq(data)                                                   (0x00040000&((data)<<18))
+#define MIS_UR_CTRL_toauareq_src(data)                                               ((0x00040000&(data))>>18)
+#define MIS_UR_CTRL_get_toauareq(data)                                               ((0x00040000&(data))>>18)
+#define MIS_UR_CTRL_flow_pol_shift                                                   (17)
+#define MIS_UR_CTRL_flow_pol_mask                                                    (0x00020000)
+#define MIS_UR_CTRL_flow_pol(data)                                                   (0x00020000&((data)<<17))
+#define MIS_UR_CTRL_flow_pol_src(data)                                               ((0x00020000&(data))>>17)
+#define MIS_UR_CTRL_get_flow_pol(data)                                               ((0x00020000&(data))>>17)
+#define MIS_UR_CTRL_mdifen_shift                                                     (16)
+#define MIS_UR_CTRL_mdifen_mask                                                      (0x00010000)
+#define MIS_UR_CTRL_mdifen(data)                                                     (0x00010000&((data)<<16))
+#define MIS_UR_CTRL_mdifen_src(data)                                                 ((0x00010000&(data))>>16)
+#define MIS_UR_CTRL_get_mdifen(data)                                                 ((0x00010000&(data))>>16)
+#define MIS_UR_CTRL_txempthr_shift                                                   (8)
+#define MIS_UR_CTRL_txempthr_mask                                                    (0x00003F00)
+#define MIS_UR_CTRL_txempthr(data)                                                   (0x00003F00&((data)<<8))
+#define MIS_UR_CTRL_txempthr_src(data)                                               ((0x00003F00&(data))>>8)
+#define MIS_UR_CTRL_get_txempthr(data)                                               ((0x00003F00&(data))>>8)
+#define MIS_UR_CTRL_rxfulthr_shift                                                   (0)
+#define MIS_UR_CTRL_rxfulthr_mask                                                    (0x0000003F)
+#define MIS_UR_CTRL_rxfulthr(data)                                                   (0x0000003F&((data)<<0))
+#define MIS_UR_CTRL_rxfulthr_src(data)                                               ((0x0000003F&(data))>>0)
+#define MIS_UR_CTRL_get_rxfulthr(data)                                               ((0x0000003F&(data))>>0)
+
+
+#define MIS_FAST_ISR_GPIO0_A                                                         0x1801B070
+#define MIS_FAST_ISR_GPIO0_A_reg_addr                                                "0xB801B070"
+#define MIS_FAST_ISR_GPIO0_A_reg                                                     0xB801B070
+#define set_MIS_FAST_ISR_GPIO0_A_reg(data)   (*((volatile unsigned int*) MIS_FAST_ISR_GPIO0_A_reg)=data)
+#define get_MIS_FAST_ISR_GPIO0_A_reg   (*((volatile unsigned int*) MIS_FAST_ISR_GPIO0_A_reg))
+#define MIS_FAST_ISR_GPIO0_A_inst_adr                                                "0x001C"
+#define MIS_FAST_ISR_GPIO0_A_inst                                                    0x001C
+#define MIS_FAST_ISR_GPIO0_A_int_30_shift                                            (31)
+#define MIS_FAST_ISR_GPIO0_A_int_30_mask                                             (0x80000000)
+#define MIS_FAST_ISR_GPIO0_A_int_30(data)                                            (0x80000000&((data)<<31))
+#define MIS_FAST_ISR_GPIO0_A_int_30_src(data)                                        ((0x80000000&(data))>>31)
+#define MIS_FAST_ISR_GPIO0_A_get_int_30(data)                                        ((0x80000000&(data))>>31)
+#define MIS_FAST_ISR_GPIO0_A_int_29_shift                                            (30)
+#define MIS_FAST_ISR_GPIO0_A_int_29_mask                                             (0x40000000)
+#define MIS_FAST_ISR_GPIO0_A_int_29(data)                                            (0x40000000&((data)<<30))
+#define MIS_FAST_ISR_GPIO0_A_int_29_src(data)                                        ((0x40000000&(data))>>30)
+#define MIS_FAST_ISR_GPIO0_A_get_int_29(data)                                        ((0x40000000&(data))>>30)
+#define MIS_FAST_ISR_GPIO0_A_int_28_shift                                            (29)
+#define MIS_FAST_ISR_GPIO0_A_int_28_mask                                             (0x20000000)
+#define MIS_FAST_ISR_GPIO0_A_int_28(data)                                            (0x20000000&((data)<<29))
+#define MIS_FAST_ISR_GPIO0_A_int_28_src(data)                                        ((0x20000000&(data))>>29)
+#define MIS_FAST_ISR_GPIO0_A_get_int_28(data)                                        ((0x20000000&(data))>>29)
+#define MIS_FAST_ISR_GPIO0_A_int_27_shift                                            (28)
+#define MIS_FAST_ISR_GPIO0_A_int_27_mask                                             (0x10000000)
+#define MIS_FAST_ISR_GPIO0_A_int_27(data)                                            (0x10000000&((data)<<28))
+#define MIS_FAST_ISR_GPIO0_A_int_27_src(data)                                        ((0x10000000&(data))>>28)
+#define MIS_FAST_ISR_GPIO0_A_get_int_27(data)                                        ((0x10000000&(data))>>28)
+#define MIS_FAST_ISR_GPIO0_A_int_26_shift                                            (27)
+#define MIS_FAST_ISR_GPIO0_A_int_26_mask                                             (0x08000000)
+#define MIS_FAST_ISR_GPIO0_A_int_26(data)                                            (0x08000000&((data)<<27))
+#define MIS_FAST_ISR_GPIO0_A_int_26_src(data)                                        ((0x08000000&(data))>>27)
+#define MIS_FAST_ISR_GPIO0_A_get_int_26(data)                                        ((0x08000000&(data))>>27)
+#define MIS_FAST_ISR_GPIO0_A_int_25_shift                                            (26)
+#define MIS_FAST_ISR_GPIO0_A_int_25_mask                                             (0x04000000)
+#define MIS_FAST_ISR_GPIO0_A_int_25(data)                                            (0x04000000&((data)<<26))
+#define MIS_FAST_ISR_GPIO0_A_int_25_src(data)                                        ((0x04000000&(data))>>26)
+#define MIS_FAST_ISR_GPIO0_A_get_int_25(data)                                        ((0x04000000&(data))>>26)
+#define MIS_FAST_ISR_GPIO0_A_int_24_shift                                            (25)
+#define MIS_FAST_ISR_GPIO0_A_int_24_mask                                             (0x02000000)
+#define MIS_FAST_ISR_GPIO0_A_int_24(data)                                            (0x02000000&((data)<<25))
+#define MIS_FAST_ISR_GPIO0_A_int_24_src(data)                                        ((0x02000000&(data))>>25)
+#define MIS_FAST_ISR_GPIO0_A_get_int_24(data)                                        ((0x02000000&(data))>>25)
+#define MIS_FAST_ISR_GPIO0_A_int_23_shift                                            (24)
+#define MIS_FAST_ISR_GPIO0_A_int_23_mask                                             (0x01000000)
+#define MIS_FAST_ISR_GPIO0_A_int_23(data)                                            (0x01000000&((data)<<24))
+#define MIS_FAST_ISR_GPIO0_A_int_23_src(data)                                        ((0x01000000&(data))>>24)
+#define MIS_FAST_ISR_GPIO0_A_get_int_23(data)                                        ((0x01000000&(data))>>24)
+#define MIS_FAST_ISR_GPIO0_A_int_22_shift                                            (23)
+#define MIS_FAST_ISR_GPIO0_A_int_22_mask                                             (0x00800000)
+#define MIS_FAST_ISR_GPIO0_A_int_22(data)                                            (0x00800000&((data)<<23))
+#define MIS_FAST_ISR_GPIO0_A_int_22_src(data)                                        ((0x00800000&(data))>>23)
+#define MIS_FAST_ISR_GPIO0_A_get_int_22(data)                                        ((0x00800000&(data))>>23)
+#define MIS_FAST_ISR_GPIO0_A_int_21_shift                                            (22)
+#define MIS_FAST_ISR_GPIO0_A_int_21_mask                                             (0x00400000)
+#define MIS_FAST_ISR_GPIO0_A_int_21(data)                                            (0x00400000&((data)<<22))
+#define MIS_FAST_ISR_GPIO0_A_int_21_src(data)                                        ((0x00400000&(data))>>22)
+#define MIS_FAST_ISR_GPIO0_A_get_int_21(data)                                        ((0x00400000&(data))>>22)
+#define MIS_FAST_ISR_GPIO0_A_int_20_shift                                            (21)
+#define MIS_FAST_ISR_GPIO0_A_int_20_mask                                             (0x00200000)
+#define MIS_FAST_ISR_GPIO0_A_int_20(data)                                            (0x00200000&((data)<<21))
+#define MIS_FAST_ISR_GPIO0_A_int_20_src(data)                                        ((0x00200000&(data))>>21)
+#define MIS_FAST_ISR_GPIO0_A_get_int_20(data)                                        ((0x00200000&(data))>>21)
+#define MIS_FAST_ISR_GPIO0_A_int_19_shift                                            (20)
+#define MIS_FAST_ISR_GPIO0_A_int_19_mask                                             (0x00100000)
+#define MIS_FAST_ISR_GPIO0_A_int_19(data)                                            (0x00100000&((data)<<20))
+#define MIS_FAST_ISR_GPIO0_A_int_19_src(data)                                        ((0x00100000&(data))>>20)
+#define MIS_FAST_ISR_GPIO0_A_get_int_19(data)                                        ((0x00100000&(data))>>20)
+#define MIS_FAST_ISR_GPIO0_A_int_18_shift                                            (19)
+#define MIS_FAST_ISR_GPIO0_A_int_18_mask                                             (0x00080000)
+#define MIS_FAST_ISR_GPIO0_A_int_18(data)                                            (0x00080000&((data)<<19))
+#define MIS_FAST_ISR_GPIO0_A_int_18_src(data)                                        ((0x00080000&(data))>>19)
+#define MIS_FAST_ISR_GPIO0_A_get_int_18(data)                                        ((0x00080000&(data))>>19)
+#define MIS_FAST_ISR_GPIO0_A_int_17_shift                                            (18)
+#define MIS_FAST_ISR_GPIO0_A_int_17_mask                                             (0x00040000)
+#define MIS_FAST_ISR_GPIO0_A_int_17(data)                                            (0x00040000&((data)<<18))
+#define MIS_FAST_ISR_GPIO0_A_int_17_src(data)                                        ((0x00040000&(data))>>18)
+#define MIS_FAST_ISR_GPIO0_A_get_int_17(data)                                        ((0x00040000&(data))>>18)
+#define MIS_FAST_ISR_GPIO0_A_int_16_shift                                            (17)
+#define MIS_FAST_ISR_GPIO0_A_int_16_mask                                             (0x00020000)
+#define MIS_FAST_ISR_GPIO0_A_int_16(data)                                            (0x00020000&((data)<<17))
+#define MIS_FAST_ISR_GPIO0_A_int_16_src(data)                                        ((0x00020000&(data))>>17)
+#define MIS_FAST_ISR_GPIO0_A_get_int_16(data)                                        ((0x00020000&(data))>>17)
+#define MIS_FAST_ISR_GPIO0_A_int_15_shift                                            (16)
+#define MIS_FAST_ISR_GPIO0_A_int_15_mask                                             (0x00010000)
+#define MIS_FAST_ISR_GPIO0_A_int_15(data)                                            (0x00010000&((data)<<16))
+#define MIS_FAST_ISR_GPIO0_A_int_15_src(data)                                        ((0x00010000&(data))>>16)
+#define MIS_FAST_ISR_GPIO0_A_get_int_15(data)                                        ((0x00010000&(data))>>16)
+#define MIS_FAST_ISR_GPIO0_A_int_14_shift                                            (15)
+#define MIS_FAST_ISR_GPIO0_A_int_14_mask                                             (0x00008000)
+#define MIS_FAST_ISR_GPIO0_A_int_14(data)                                            (0x00008000&((data)<<15))
+#define MIS_FAST_ISR_GPIO0_A_int_14_src(data)                                        ((0x00008000&(data))>>15)
+#define MIS_FAST_ISR_GPIO0_A_get_int_14(data)                                        ((0x00008000&(data))>>15)
+#define MIS_FAST_ISR_GPIO0_A_int_13_shift                                            (14)
+#define MIS_FAST_ISR_GPIO0_A_int_13_mask                                             (0x00004000)
+#define MIS_FAST_ISR_GPIO0_A_int_13(data)                                            (0x00004000&((data)<<14))
+#define MIS_FAST_ISR_GPIO0_A_int_13_src(data)                                        ((0x00004000&(data))>>14)
+#define MIS_FAST_ISR_GPIO0_A_get_int_13(data)                                        ((0x00004000&(data))>>14)
+#define MIS_FAST_ISR_GPIO0_A_int_12_shift                                            (13)
+#define MIS_FAST_ISR_GPIO0_A_int_12_mask                                             (0x00002000)
+#define MIS_FAST_ISR_GPIO0_A_int_12(data)                                            (0x00002000&((data)<<13))
+#define MIS_FAST_ISR_GPIO0_A_int_12_src(data)                                        ((0x00002000&(data))>>13)
+#define MIS_FAST_ISR_GPIO0_A_get_int_12(data)                                        ((0x00002000&(data))>>13)
+#define MIS_FAST_ISR_GPIO0_A_int_11_shift                                            (12)
+#define MIS_FAST_ISR_GPIO0_A_int_11_mask                                             (0x00001000)
+#define MIS_FAST_ISR_GPIO0_A_int_11(data)                                            (0x00001000&((data)<<12))
+#define MIS_FAST_ISR_GPIO0_A_int_11_src(data)                                        ((0x00001000&(data))>>12)
+#define MIS_FAST_ISR_GPIO0_A_get_int_11(data)                                        ((0x00001000&(data))>>12)
+#define MIS_FAST_ISR_GPIO0_A_int_10_shift                                            (11)
+#define MIS_FAST_ISR_GPIO0_A_int_10_mask                                             (0x00000800)
+#define MIS_FAST_ISR_GPIO0_A_int_10(data)                                            (0x00000800&((data)<<11))
+#define MIS_FAST_ISR_GPIO0_A_int_10_src(data)                                        ((0x00000800&(data))>>11)
+#define MIS_FAST_ISR_GPIO0_A_get_int_10(data)                                        ((0x00000800&(data))>>11)
+#define MIS_FAST_ISR_GPIO0_A_int_9_shift                                             (10)
+#define MIS_FAST_ISR_GPIO0_A_int_9_mask                                              (0x00000400)
+#define MIS_FAST_ISR_GPIO0_A_int_9(data)                                             (0x00000400&((data)<<10))
+#define MIS_FAST_ISR_GPIO0_A_int_9_src(data)                                         ((0x00000400&(data))>>10)
+#define MIS_FAST_ISR_GPIO0_A_get_int_9(data)                                         ((0x00000400&(data))>>10)
+#define MIS_FAST_ISR_GPIO0_A_int_8_shift                                             (9)
+#define MIS_FAST_ISR_GPIO0_A_int_8_mask                                              (0x00000200)
+#define MIS_FAST_ISR_GPIO0_A_int_8(data)                                             (0x00000200&((data)<<9))
+#define MIS_FAST_ISR_GPIO0_A_int_8_src(data)                                         ((0x00000200&(data))>>9)
+#define MIS_FAST_ISR_GPIO0_A_get_int_8(data)                                         ((0x00000200&(data))>>9)
+#define MIS_FAST_ISR_GPIO0_A_int_7_shift                                             (8)
+#define MIS_FAST_ISR_GPIO0_A_int_7_mask                                              (0x00000100)
+#define MIS_FAST_ISR_GPIO0_A_int_7(data)                                             (0x00000100&((data)<<8))
+#define MIS_FAST_ISR_GPIO0_A_int_7_src(data)                                         ((0x00000100&(data))>>8)
+#define MIS_FAST_ISR_GPIO0_A_get_int_7(data)                                         ((0x00000100&(data))>>8)
+#define MIS_FAST_ISR_GPIO0_A_int_6_shift                                             (7)
+#define MIS_FAST_ISR_GPIO0_A_int_6_mask                                              (0x00000080)
+#define MIS_FAST_ISR_GPIO0_A_int_6(data)                                             (0x00000080&((data)<<7))
+#define MIS_FAST_ISR_GPIO0_A_int_6_src(data)                                         ((0x00000080&(data))>>7)
+#define MIS_FAST_ISR_GPIO0_A_get_int_6(data)                                         ((0x00000080&(data))>>7)
+#define MIS_FAST_ISR_GPIO0_A_int_5_shift                                             (6)
+#define MIS_FAST_ISR_GPIO0_A_int_5_mask                                              (0x00000040)
+#define MIS_FAST_ISR_GPIO0_A_int_5(data)                                             (0x00000040&((data)<<6))
+#define MIS_FAST_ISR_GPIO0_A_int_5_src(data)                                         ((0x00000040&(data))>>6)
+#define MIS_FAST_ISR_GPIO0_A_get_int_5(data)                                         ((0x00000040&(data))>>6)
+#define MIS_FAST_ISR_GPIO0_A_int_4_shift                                             (5)
+#define MIS_FAST_ISR_GPIO0_A_int_4_mask                                              (0x00000020)
+#define MIS_FAST_ISR_GPIO0_A_int_4(data)                                             (0x00000020&((data)<<5))
+#define MIS_FAST_ISR_GPIO0_A_int_4_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_FAST_ISR_GPIO0_A_get_int_4(data)                                         ((0x00000020&(data))>>5)
+#define MIS_FAST_ISR_GPIO0_A_int_3_shift                                             (4)
+#define MIS_FAST_ISR_GPIO0_A_int_3_mask                                              (0x00000010)
+#define MIS_FAST_ISR_GPIO0_A_int_3(data)                                             (0x00000010&((data)<<4))
+#define MIS_FAST_ISR_GPIO0_A_int_3_src(data)                                         ((0x00000010&(data))>>4)
+#define MIS_FAST_ISR_GPIO0_A_get_int_3(data)                                         ((0x00000010&(data))>>4)
+#define MIS_FAST_ISR_GPIO0_A_int_2_shift                                             (3)
+#define MIS_FAST_ISR_GPIO0_A_int_2_mask                                              (0x00000008)
+#define MIS_FAST_ISR_GPIO0_A_int_2(data)                                             (0x00000008&((data)<<3))
+#define MIS_FAST_ISR_GPIO0_A_int_2_src(data)                                         ((0x00000008&(data))>>3)
+#define MIS_FAST_ISR_GPIO0_A_get_int_2(data)                                         ((0x00000008&(data))>>3)
+#define MIS_FAST_ISR_GPIO0_A_int_1_shift                                             (2)
+#define MIS_FAST_ISR_GPIO0_A_int_1_mask                                              (0x00000004)
+#define MIS_FAST_ISR_GPIO0_A_int_1(data)                                             (0x00000004&((data)<<2))
+#define MIS_FAST_ISR_GPIO0_A_int_1_src(data)                                         ((0x00000004&(data))>>2)
+#define MIS_FAST_ISR_GPIO0_A_get_int_1(data)                                         ((0x00000004&(data))>>2)
+#define MIS_FAST_ISR_GPIO0_A_int_0_shift                                             (1)
+#define MIS_FAST_ISR_GPIO0_A_int_0_mask                                              (0x00000002)
+#define MIS_FAST_ISR_GPIO0_A_int_0(data)                                             (0x00000002&((data)<<1))
+#define MIS_FAST_ISR_GPIO0_A_int_0_src(data)                                         ((0x00000002&(data))>>1)
+#define MIS_FAST_ISR_GPIO0_A_get_int_0(data)                                         ((0x00000002&(data))>>1)
+#define MIS_FAST_ISR_GPIO0_A_write_data_shift                                        (0)
+#define MIS_FAST_ISR_GPIO0_A_write_data_mask                                         (0x00000001)
+#define MIS_FAST_ISR_GPIO0_A_write_data(data)                                        (0x00000001&((data)<<0))
+#define MIS_FAST_ISR_GPIO0_A_write_data_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_FAST_ISR_GPIO0_A_get_write_data(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_FAST_ISR_GPIO1_A                                                         0x1801B074
+#define MIS_FAST_ISR_GPIO1_A_reg_addr                                                "0xB801B074"
+#define MIS_FAST_ISR_GPIO1_A_reg                                                     0xB801B074
+#define set_MIS_FAST_ISR_GPIO1_A_reg(data)   (*((volatile unsigned int*) MIS_FAST_ISR_GPIO1_A_reg)=data)
+#define get_MIS_FAST_ISR_GPIO1_A_reg   (*((volatile unsigned int*) MIS_FAST_ISR_GPIO1_A_reg))
+#define MIS_FAST_ISR_GPIO1_A_inst_adr                                                "0x001D"
+#define MIS_FAST_ISR_GPIO1_A_inst                                                    0x001D
+#define MIS_FAST_ISR_GPIO1_A_int_59_shift                                            (29)
+#define MIS_FAST_ISR_GPIO1_A_int_59_mask                                             (0x20000000)
+#define MIS_FAST_ISR_GPIO1_A_int_59(data)                                            (0x20000000&((data)<<29))
+#define MIS_FAST_ISR_GPIO1_A_int_59_src(data)                                        ((0x20000000&(data))>>29)
+#define MIS_FAST_ISR_GPIO1_A_get_int_59(data)                                        ((0x20000000&(data))>>29)
+#define MIS_FAST_ISR_GPIO1_A_int_58_shift                                            (28)
+#define MIS_FAST_ISR_GPIO1_A_int_58_mask                                             (0x10000000)
+#define MIS_FAST_ISR_GPIO1_A_int_58(data)                                            (0x10000000&((data)<<28))
+#define MIS_FAST_ISR_GPIO1_A_int_58_src(data)                                        ((0x10000000&(data))>>28)
+#define MIS_FAST_ISR_GPIO1_A_get_int_58(data)                                        ((0x10000000&(data))>>28)
+#define MIS_FAST_ISR_GPIO1_A_int_57_shift                                            (27)
+#define MIS_FAST_ISR_GPIO1_A_int_57_mask                                             (0x08000000)
+#define MIS_FAST_ISR_GPIO1_A_int_57(data)                                            (0x08000000&((data)<<27))
+#define MIS_FAST_ISR_GPIO1_A_int_57_src(data)                                        ((0x08000000&(data))>>27)
+#define MIS_FAST_ISR_GPIO1_A_get_int_57(data)                                        ((0x08000000&(data))>>27)
+#define MIS_FAST_ISR_GPIO1_A_int_56_shift                                            (26)
+#define MIS_FAST_ISR_GPIO1_A_int_56_mask                                             (0x04000000)
+#define MIS_FAST_ISR_GPIO1_A_int_56(data)                                            (0x04000000&((data)<<26))
+#define MIS_FAST_ISR_GPIO1_A_int_56_src(data)                                        ((0x04000000&(data))>>26)
+#define MIS_FAST_ISR_GPIO1_A_get_int_56(data)                                        ((0x04000000&(data))>>26)
+#define MIS_FAST_ISR_GPIO1_A_int_55_shift                                            (25)
+#define MIS_FAST_ISR_GPIO1_A_int_55_mask                                             (0x02000000)
+#define MIS_FAST_ISR_GPIO1_A_int_55(data)                                            (0x02000000&((data)<<25))
+#define MIS_FAST_ISR_GPIO1_A_int_55_src(data)                                        ((0x02000000&(data))>>25)
+#define MIS_FAST_ISR_GPIO1_A_get_int_55(data)                                        ((0x02000000&(data))>>25)
+#define MIS_FAST_ISR_GPIO1_A_int_54_shift                                            (24)
+#define MIS_FAST_ISR_GPIO1_A_int_54_mask                                             (0x01000000)
+#define MIS_FAST_ISR_GPIO1_A_int_54(data)                                            (0x01000000&((data)<<24))
+#define MIS_FAST_ISR_GPIO1_A_int_54_src(data)                                        ((0x01000000&(data))>>24)
+#define MIS_FAST_ISR_GPIO1_A_get_int_54(data)                                        ((0x01000000&(data))>>24)
+#define MIS_FAST_ISR_GPIO1_A_int_53_shift                                            (23)
+#define MIS_FAST_ISR_GPIO1_A_int_53_mask                                             (0x00800000)
+#define MIS_FAST_ISR_GPIO1_A_int_53(data)                                            (0x00800000&((data)<<23))
+#define MIS_FAST_ISR_GPIO1_A_int_53_src(data)                                        ((0x00800000&(data))>>23)
+#define MIS_FAST_ISR_GPIO1_A_get_int_53(data)                                        ((0x00800000&(data))>>23)
+#define MIS_FAST_ISR_GPIO1_A_int_52_shift                                            (22)
+#define MIS_FAST_ISR_GPIO1_A_int_52_mask                                             (0x00400000)
+#define MIS_FAST_ISR_GPIO1_A_int_52(data)                                            (0x00400000&((data)<<22))
+#define MIS_FAST_ISR_GPIO1_A_int_52_src(data)                                        ((0x00400000&(data))>>22)
+#define MIS_FAST_ISR_GPIO1_A_get_int_52(data)                                        ((0x00400000&(data))>>22)
+#define MIS_FAST_ISR_GPIO1_A_int_51_shift                                            (21)
+#define MIS_FAST_ISR_GPIO1_A_int_51_mask                                             (0x00200000)
+#define MIS_FAST_ISR_GPIO1_A_int_51(data)                                            (0x00200000&((data)<<21))
+#define MIS_FAST_ISR_GPIO1_A_int_51_src(data)                                        ((0x00200000&(data))>>21)
+#define MIS_FAST_ISR_GPIO1_A_get_int_51(data)                                        ((0x00200000&(data))>>21)
+#define MIS_FAST_ISR_GPIO1_A_int_50_shift                                            (20)
+#define MIS_FAST_ISR_GPIO1_A_int_50_mask                                             (0x00100000)
+#define MIS_FAST_ISR_GPIO1_A_int_50(data)                                            (0x00100000&((data)<<20))
+#define MIS_FAST_ISR_GPIO1_A_int_50_src(data)                                        ((0x00100000&(data))>>20)
+#define MIS_FAST_ISR_GPIO1_A_get_int_50(data)                                        ((0x00100000&(data))>>20)
+#define MIS_FAST_ISR_GPIO1_A_int_49_shift                                            (19)
+#define MIS_FAST_ISR_GPIO1_A_int_49_mask                                             (0x00080000)
+#define MIS_FAST_ISR_GPIO1_A_int_49(data)                                            (0x00080000&((data)<<19))
+#define MIS_FAST_ISR_GPIO1_A_int_49_src(data)                                        ((0x00080000&(data))>>19)
+#define MIS_FAST_ISR_GPIO1_A_get_int_49(data)                                        ((0x00080000&(data))>>19)
+#define MIS_FAST_ISR_GPIO1_A_int_48_shift                                            (18)
+#define MIS_FAST_ISR_GPIO1_A_int_48_mask                                             (0x00040000)
+#define MIS_FAST_ISR_GPIO1_A_int_48(data)                                            (0x00040000&((data)<<18))
+#define MIS_FAST_ISR_GPIO1_A_int_48_src(data)                                        ((0x00040000&(data))>>18)
+#define MIS_FAST_ISR_GPIO1_A_get_int_48(data)                                        ((0x00040000&(data))>>18)
+#define MIS_FAST_ISR_GPIO1_A_int_47_shift                                            (17)
+#define MIS_FAST_ISR_GPIO1_A_int_47_mask                                             (0x00020000)
+#define MIS_FAST_ISR_GPIO1_A_int_47(data)                                            (0x00020000&((data)<<17))
+#define MIS_FAST_ISR_GPIO1_A_int_47_src(data)                                        ((0x00020000&(data))>>17)
+#define MIS_FAST_ISR_GPIO1_A_get_int_47(data)                                        ((0x00020000&(data))>>17)
+#define MIS_FAST_ISR_GPIO1_A_int_46_shift                                            (16)
+#define MIS_FAST_ISR_GPIO1_A_int_46_mask                                             (0x00010000)
+#define MIS_FAST_ISR_GPIO1_A_int_46(data)                                            (0x00010000&((data)<<16))
+#define MIS_FAST_ISR_GPIO1_A_int_46_src(data)                                        ((0x00010000&(data))>>16)
+#define MIS_FAST_ISR_GPIO1_A_get_int_46(data)                                        ((0x00010000&(data))>>16)
+#define MIS_FAST_ISR_GPIO1_A_int_45_shift                                            (15)
+#define MIS_FAST_ISR_GPIO1_A_int_45_mask                                             (0x00008000)
+#define MIS_FAST_ISR_GPIO1_A_int_45(data)                                            (0x00008000&((data)<<15))
+#define MIS_FAST_ISR_GPIO1_A_int_45_src(data)                                        ((0x00008000&(data))>>15)
+#define MIS_FAST_ISR_GPIO1_A_get_int_45(data)                                        ((0x00008000&(data))>>15)
+#define MIS_FAST_ISR_GPIO1_A_int_44_shift                                            (14)
+#define MIS_FAST_ISR_GPIO1_A_int_44_mask                                             (0x00004000)
+#define MIS_FAST_ISR_GPIO1_A_int_44(data)                                            (0x00004000&((data)<<14))
+#define MIS_FAST_ISR_GPIO1_A_int_44_src(data)                                        ((0x00004000&(data))>>14)
+#define MIS_FAST_ISR_GPIO1_A_get_int_44(data)                                        ((0x00004000&(data))>>14)
+#define MIS_FAST_ISR_GPIO1_A_int_43_shift                                            (13)
+#define MIS_FAST_ISR_GPIO1_A_int_43_mask                                             (0x00002000)
+#define MIS_FAST_ISR_GPIO1_A_int_43(data)                                            (0x00002000&((data)<<13))
+#define MIS_FAST_ISR_GPIO1_A_int_43_src(data)                                        ((0x00002000&(data))>>13)
+#define MIS_FAST_ISR_GPIO1_A_get_int_43(data)                                        ((0x00002000&(data))>>13)
+#define MIS_FAST_ISR_GPIO1_A_int_42_shift                                            (12)
+#define MIS_FAST_ISR_GPIO1_A_int_42_mask                                             (0x00001000)
+#define MIS_FAST_ISR_GPIO1_A_int_42(data)                                            (0x00001000&((data)<<12))
+#define MIS_FAST_ISR_GPIO1_A_int_42_src(data)                                        ((0x00001000&(data))>>12)
+#define MIS_FAST_ISR_GPIO1_A_get_int_42(data)                                        ((0x00001000&(data))>>12)
+#define MIS_FAST_ISR_GPIO1_A_int_41_shift                                            (11)
+#define MIS_FAST_ISR_GPIO1_A_int_41_mask                                             (0x00000800)
+#define MIS_FAST_ISR_GPIO1_A_int_41(data)                                            (0x00000800&((data)<<11))
+#define MIS_FAST_ISR_GPIO1_A_int_41_src(data)                                        ((0x00000800&(data))>>11)
+#define MIS_FAST_ISR_GPIO1_A_get_int_41(data)                                        ((0x00000800&(data))>>11)
+#define MIS_FAST_ISR_GPIO1_A_int_40_shift                                            (10)
+#define MIS_FAST_ISR_GPIO1_A_int_40_mask                                             (0x00000400)
+#define MIS_FAST_ISR_GPIO1_A_int_40(data)                                            (0x00000400&((data)<<10))
+#define MIS_FAST_ISR_GPIO1_A_int_40_src(data)                                        ((0x00000400&(data))>>10)
+#define MIS_FAST_ISR_GPIO1_A_get_int_40(data)                                        ((0x00000400&(data))>>10)
+#define MIS_FAST_ISR_GPIO1_A_int_39_shift                                            (9)
+#define MIS_FAST_ISR_GPIO1_A_int_39_mask                                             (0x00000200)
+#define MIS_FAST_ISR_GPIO1_A_int_39(data)                                            (0x00000200&((data)<<9))
+#define MIS_FAST_ISR_GPIO1_A_int_39_src(data)                                        ((0x00000200&(data))>>9)
+#define MIS_FAST_ISR_GPIO1_A_get_int_39(data)                                        ((0x00000200&(data))>>9)
+#define MIS_FAST_ISR_GPIO1_A_int_38_shift                                            (8)
+#define MIS_FAST_ISR_GPIO1_A_int_38_mask                                             (0x00000100)
+#define MIS_FAST_ISR_GPIO1_A_int_38(data)                                            (0x00000100&((data)<<8))
+#define MIS_FAST_ISR_GPIO1_A_int_38_src(data)                                        ((0x00000100&(data))>>8)
+#define MIS_FAST_ISR_GPIO1_A_get_int_38(data)                                        ((0x00000100&(data))>>8)
+#define MIS_FAST_ISR_GPIO1_A_int_37_shift                                            (7)
+#define MIS_FAST_ISR_GPIO1_A_int_37_mask                                             (0x00000080)
+#define MIS_FAST_ISR_GPIO1_A_int_37(data)                                            (0x00000080&((data)<<7))
+#define MIS_FAST_ISR_GPIO1_A_int_37_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_FAST_ISR_GPIO1_A_get_int_37(data)                                        ((0x00000080&(data))>>7)
+#define MIS_FAST_ISR_GPIO1_A_int_36_shift                                            (6)
+#define MIS_FAST_ISR_GPIO1_A_int_36_mask                                             (0x00000040)
+#define MIS_FAST_ISR_GPIO1_A_int_36(data)                                            (0x00000040&((data)<<6))
+#define MIS_FAST_ISR_GPIO1_A_int_36_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_FAST_ISR_GPIO1_A_get_int_36(data)                                        ((0x00000040&(data))>>6)
+#define MIS_FAST_ISR_GPIO1_A_int_35_shift                                            (5)
+#define MIS_FAST_ISR_GPIO1_A_int_35_mask                                             (0x00000020)
+#define MIS_FAST_ISR_GPIO1_A_int_35(data)                                            (0x00000020&((data)<<5))
+#define MIS_FAST_ISR_GPIO1_A_int_35_src(data)                                        ((0x00000020&(data))>>5)
+#define MIS_FAST_ISR_GPIO1_A_get_int_35(data)                                        ((0x00000020&(data))>>5)
+#define MIS_FAST_ISR_GPIO1_A_int_34_shift                                            (4)
+#define MIS_FAST_ISR_GPIO1_A_int_34_mask                                             (0x00000010)
+#define MIS_FAST_ISR_GPIO1_A_int_34(data)                                            (0x00000010&((data)<<4))
+#define MIS_FAST_ISR_GPIO1_A_int_34_src(data)                                        ((0x00000010&(data))>>4)
+#define MIS_FAST_ISR_GPIO1_A_get_int_34(data)                                        ((0x00000010&(data))>>4)
+#define MIS_FAST_ISR_GPIO1_A_int_33_shift                                            (3)
+#define MIS_FAST_ISR_GPIO1_A_int_33_mask                                             (0x00000008)
+#define MIS_FAST_ISR_GPIO1_A_int_33(data)                                            (0x00000008&((data)<<3))
+#define MIS_FAST_ISR_GPIO1_A_int_33_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_FAST_ISR_GPIO1_A_get_int_33(data)                                        ((0x00000008&(data))>>3)
+#define MIS_FAST_ISR_GPIO1_A_int_32_shift                                            (2)
+#define MIS_FAST_ISR_GPIO1_A_int_32_mask                                             (0x00000004)
+#define MIS_FAST_ISR_GPIO1_A_int_32(data)                                            (0x00000004&((data)<<2))
+#define MIS_FAST_ISR_GPIO1_A_int_32_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_FAST_ISR_GPIO1_A_get_int_32(data)                                        ((0x00000004&(data))>>2)
+#define MIS_FAST_ISR_GPIO1_A_int_31_shift                                            (1)
+#define MIS_FAST_ISR_GPIO1_A_int_31_mask                                             (0x00000002)
+#define MIS_FAST_ISR_GPIO1_A_int_31(data)                                            (0x00000002&((data)<<1))
+#define MIS_FAST_ISR_GPIO1_A_int_31_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_FAST_ISR_GPIO1_A_get_int_31(data)                                        ((0x00000002&(data))>>1)
+#define MIS_FAST_ISR_GPIO1_A_write_data_shift                                        (0)
+#define MIS_FAST_ISR_GPIO1_A_write_data_mask                                         (0x00000001)
+#define MIS_FAST_ISR_GPIO1_A_write_data(data)                                        (0x00000001&((data)<<0))
+#define MIS_FAST_ISR_GPIO1_A_write_data_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_FAST_ISR_GPIO1_A_get_write_data(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_FAST_ISR_GPIO0_DA                                                        0x1801B078
+#define MIS_FAST_ISR_GPIO0_DA_reg_addr                                               "0xB801B078"
+#define MIS_FAST_ISR_GPIO0_DA_reg                                                    0xB801B078
+#define set_MIS_FAST_ISR_GPIO0_DA_reg(data)   (*((volatile unsigned int*) MIS_FAST_ISR_GPIO0_DA_reg)=data)
+#define get_MIS_FAST_ISR_GPIO0_DA_reg   (*((volatile unsigned int*) MIS_FAST_ISR_GPIO0_DA_reg))
+#define MIS_FAST_ISR_GPIO0_DA_inst_adr                                               "0x001E"
+#define MIS_FAST_ISR_GPIO0_DA_inst                                                   0x001E
+#define MIS_FAST_ISR_GPIO0_DA_int_30_shift                                           (31)
+#define MIS_FAST_ISR_GPIO0_DA_int_30_mask                                            (0x80000000)
+#define MIS_FAST_ISR_GPIO0_DA_int_30(data)                                           (0x80000000&((data)<<31))
+#define MIS_FAST_ISR_GPIO0_DA_int_30_src(data)                                       ((0x80000000&(data))>>31)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_30(data)                                       ((0x80000000&(data))>>31)
+#define MIS_FAST_ISR_GPIO0_DA_int_29_shift                                           (30)
+#define MIS_FAST_ISR_GPIO0_DA_int_29_mask                                            (0x40000000)
+#define MIS_FAST_ISR_GPIO0_DA_int_29(data)                                           (0x40000000&((data)<<30))
+#define MIS_FAST_ISR_GPIO0_DA_int_29_src(data)                                       ((0x40000000&(data))>>30)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_29(data)                                       ((0x40000000&(data))>>30)
+#define MIS_FAST_ISR_GPIO0_DA_int_28_shift                                           (29)
+#define MIS_FAST_ISR_GPIO0_DA_int_28_mask                                            (0x20000000)
+#define MIS_FAST_ISR_GPIO0_DA_int_28(data)                                           (0x20000000&((data)<<29))
+#define MIS_FAST_ISR_GPIO0_DA_int_28_src(data)                                       ((0x20000000&(data))>>29)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_28(data)                                       ((0x20000000&(data))>>29)
+#define MIS_FAST_ISR_GPIO0_DA_int_27_shift                                           (28)
+#define MIS_FAST_ISR_GPIO0_DA_int_27_mask                                            (0x10000000)
+#define MIS_FAST_ISR_GPIO0_DA_int_27(data)                                           (0x10000000&((data)<<28))
+#define MIS_FAST_ISR_GPIO0_DA_int_27_src(data)                                       ((0x10000000&(data))>>28)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_27(data)                                       ((0x10000000&(data))>>28)
+#define MIS_FAST_ISR_GPIO0_DA_int_26_shift                                           (27)
+#define MIS_FAST_ISR_GPIO0_DA_int_26_mask                                            (0x08000000)
+#define MIS_FAST_ISR_GPIO0_DA_int_26(data)                                           (0x08000000&((data)<<27))
+#define MIS_FAST_ISR_GPIO0_DA_int_26_src(data)                                       ((0x08000000&(data))>>27)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_26(data)                                       ((0x08000000&(data))>>27)
+#define MIS_FAST_ISR_GPIO0_DA_int_25_shift                                           (26)
+#define MIS_FAST_ISR_GPIO0_DA_int_25_mask                                            (0x04000000)
+#define MIS_FAST_ISR_GPIO0_DA_int_25(data)                                           (0x04000000&((data)<<26))
+#define MIS_FAST_ISR_GPIO0_DA_int_25_src(data)                                       ((0x04000000&(data))>>26)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_25(data)                                       ((0x04000000&(data))>>26)
+#define MIS_FAST_ISR_GPIO0_DA_int_24_shift                                           (25)
+#define MIS_FAST_ISR_GPIO0_DA_int_24_mask                                            (0x02000000)
+#define MIS_FAST_ISR_GPIO0_DA_int_24(data)                                           (0x02000000&((data)<<25))
+#define MIS_FAST_ISR_GPIO0_DA_int_24_src(data)                                       ((0x02000000&(data))>>25)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_24(data)                                       ((0x02000000&(data))>>25)
+#define MIS_FAST_ISR_GPIO0_DA_int_23_shift                                           (24)
+#define MIS_FAST_ISR_GPIO0_DA_int_23_mask                                            (0x01000000)
+#define MIS_FAST_ISR_GPIO0_DA_int_23(data)                                           (0x01000000&((data)<<24))
+#define MIS_FAST_ISR_GPIO0_DA_int_23_src(data)                                       ((0x01000000&(data))>>24)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_23(data)                                       ((0x01000000&(data))>>24)
+#define MIS_FAST_ISR_GPIO0_DA_int_22_shift                                           (23)
+#define MIS_FAST_ISR_GPIO0_DA_int_22_mask                                            (0x00800000)
+#define MIS_FAST_ISR_GPIO0_DA_int_22(data)                                           (0x00800000&((data)<<23))
+#define MIS_FAST_ISR_GPIO0_DA_int_22_src(data)                                       ((0x00800000&(data))>>23)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_22(data)                                       ((0x00800000&(data))>>23)
+#define MIS_FAST_ISR_GPIO0_DA_int_21_shift                                           (22)
+#define MIS_FAST_ISR_GPIO0_DA_int_21_mask                                            (0x00400000)
+#define MIS_FAST_ISR_GPIO0_DA_int_21(data)                                           (0x00400000&((data)<<22))
+#define MIS_FAST_ISR_GPIO0_DA_int_21_src(data)                                       ((0x00400000&(data))>>22)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_21(data)                                       ((0x00400000&(data))>>22)
+#define MIS_FAST_ISR_GPIO0_DA_int_20_shift                                           (21)
+#define MIS_FAST_ISR_GPIO0_DA_int_20_mask                                            (0x00200000)
+#define MIS_FAST_ISR_GPIO0_DA_int_20(data)                                           (0x00200000&((data)<<21))
+#define MIS_FAST_ISR_GPIO0_DA_int_20_src(data)                                       ((0x00200000&(data))>>21)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_20(data)                                       ((0x00200000&(data))>>21)
+#define MIS_FAST_ISR_GPIO0_DA_int_19_shift                                           (20)
+#define MIS_FAST_ISR_GPIO0_DA_int_19_mask                                            (0x00100000)
+#define MIS_FAST_ISR_GPIO0_DA_int_19(data)                                           (0x00100000&((data)<<20))
+#define MIS_FAST_ISR_GPIO0_DA_int_19_src(data)                                       ((0x00100000&(data))>>20)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_19(data)                                       ((0x00100000&(data))>>20)
+#define MIS_FAST_ISR_GPIO0_DA_int_18_shift                                           (19)
+#define MIS_FAST_ISR_GPIO0_DA_int_18_mask                                            (0x00080000)
+#define MIS_FAST_ISR_GPIO0_DA_int_18(data)                                           (0x00080000&((data)<<19))
+#define MIS_FAST_ISR_GPIO0_DA_int_18_src(data)                                       ((0x00080000&(data))>>19)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_18(data)                                       ((0x00080000&(data))>>19)
+#define MIS_FAST_ISR_GPIO0_DA_int_17_shift                                           (18)
+#define MIS_FAST_ISR_GPIO0_DA_int_17_mask                                            (0x00040000)
+#define MIS_FAST_ISR_GPIO0_DA_int_17(data)                                           (0x00040000&((data)<<18))
+#define MIS_FAST_ISR_GPIO0_DA_int_17_src(data)                                       ((0x00040000&(data))>>18)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_17(data)                                       ((0x00040000&(data))>>18)
+#define MIS_FAST_ISR_GPIO0_DA_int_16_shift                                           (17)
+#define MIS_FAST_ISR_GPIO0_DA_int_16_mask                                            (0x00020000)
+#define MIS_FAST_ISR_GPIO0_DA_int_16(data)                                           (0x00020000&((data)<<17))
+#define MIS_FAST_ISR_GPIO0_DA_int_16_src(data)                                       ((0x00020000&(data))>>17)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_16(data)                                       ((0x00020000&(data))>>17)
+#define MIS_FAST_ISR_GPIO0_DA_int_15_shift                                           (16)
+#define MIS_FAST_ISR_GPIO0_DA_int_15_mask                                            (0x00010000)
+#define MIS_FAST_ISR_GPIO0_DA_int_15(data)                                           (0x00010000&((data)<<16))
+#define MIS_FAST_ISR_GPIO0_DA_int_15_src(data)                                       ((0x00010000&(data))>>16)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_15(data)                                       ((0x00010000&(data))>>16)
+#define MIS_FAST_ISR_GPIO0_DA_int_14_shift                                           (15)
+#define MIS_FAST_ISR_GPIO0_DA_int_14_mask                                            (0x00008000)
+#define MIS_FAST_ISR_GPIO0_DA_int_14(data)                                           (0x00008000&((data)<<15))
+#define MIS_FAST_ISR_GPIO0_DA_int_14_src(data)                                       ((0x00008000&(data))>>15)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_14(data)                                       ((0x00008000&(data))>>15)
+#define MIS_FAST_ISR_GPIO0_DA_int_13_shift                                           (14)
+#define MIS_FAST_ISR_GPIO0_DA_int_13_mask                                            (0x00004000)
+#define MIS_FAST_ISR_GPIO0_DA_int_13(data)                                           (0x00004000&((data)<<14))
+#define MIS_FAST_ISR_GPIO0_DA_int_13_src(data)                                       ((0x00004000&(data))>>14)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_13(data)                                       ((0x00004000&(data))>>14)
+#define MIS_FAST_ISR_GPIO0_DA_int_12_shift                                           (13)
+#define MIS_FAST_ISR_GPIO0_DA_int_12_mask                                            (0x00002000)
+#define MIS_FAST_ISR_GPIO0_DA_int_12(data)                                           (0x00002000&((data)<<13))
+#define MIS_FAST_ISR_GPIO0_DA_int_12_src(data)                                       ((0x00002000&(data))>>13)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_12(data)                                       ((0x00002000&(data))>>13)
+#define MIS_FAST_ISR_GPIO0_DA_int_11_shift                                           (12)
+#define MIS_FAST_ISR_GPIO0_DA_int_11_mask                                            (0x00001000)
+#define MIS_FAST_ISR_GPIO0_DA_int_11(data)                                           (0x00001000&((data)<<12))
+#define MIS_FAST_ISR_GPIO0_DA_int_11_src(data)                                       ((0x00001000&(data))>>12)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_11(data)                                       ((0x00001000&(data))>>12)
+#define MIS_FAST_ISR_GPIO0_DA_int_10_shift                                           (11)
+#define MIS_FAST_ISR_GPIO0_DA_int_10_mask                                            (0x00000800)
+#define MIS_FAST_ISR_GPIO0_DA_int_10(data)                                           (0x00000800&((data)<<11))
+#define MIS_FAST_ISR_GPIO0_DA_int_10_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_10(data)                                       ((0x00000800&(data))>>11)
+#define MIS_FAST_ISR_GPIO0_DA_int_9_shift                                            (10)
+#define MIS_FAST_ISR_GPIO0_DA_int_9_mask                                             (0x00000400)
+#define MIS_FAST_ISR_GPIO0_DA_int_9(data)                                            (0x00000400&((data)<<10))
+#define MIS_FAST_ISR_GPIO0_DA_int_9_src(data)                                        ((0x00000400&(data))>>10)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_9(data)                                        ((0x00000400&(data))>>10)
+#define MIS_FAST_ISR_GPIO0_DA_int_8_shift                                            (9)
+#define MIS_FAST_ISR_GPIO0_DA_int_8_mask                                             (0x00000200)
+#define MIS_FAST_ISR_GPIO0_DA_int_8(data)                                            (0x00000200&((data)<<9))
+#define MIS_FAST_ISR_GPIO0_DA_int_8_src(data)                                        ((0x00000200&(data))>>9)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_8(data)                                        ((0x00000200&(data))>>9)
+#define MIS_FAST_ISR_GPIO0_DA_int_7_shift                                            (8)
+#define MIS_FAST_ISR_GPIO0_DA_int_7_mask                                             (0x00000100)
+#define MIS_FAST_ISR_GPIO0_DA_int_7(data)                                            (0x00000100&((data)<<8))
+#define MIS_FAST_ISR_GPIO0_DA_int_7_src(data)                                        ((0x00000100&(data))>>8)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_7(data)                                        ((0x00000100&(data))>>8)
+#define MIS_FAST_ISR_GPIO0_DA_int_6_shift                                            (7)
+#define MIS_FAST_ISR_GPIO0_DA_int_6_mask                                             (0x00000080)
+#define MIS_FAST_ISR_GPIO0_DA_int_6(data)                                            (0x00000080&((data)<<7))
+#define MIS_FAST_ISR_GPIO0_DA_int_6_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_6(data)                                        ((0x00000080&(data))>>7)
+#define MIS_FAST_ISR_GPIO0_DA_int_5_shift                                            (6)
+#define MIS_FAST_ISR_GPIO0_DA_int_5_mask                                             (0x00000040)
+#define MIS_FAST_ISR_GPIO0_DA_int_5(data)                                            (0x00000040&((data)<<6))
+#define MIS_FAST_ISR_GPIO0_DA_int_5_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_5(data)                                        ((0x00000040&(data))>>6)
+#define MIS_FAST_ISR_GPIO0_DA_int_4_shift                                            (5)
+#define MIS_FAST_ISR_GPIO0_DA_int_4_mask                                             (0x00000020)
+#define MIS_FAST_ISR_GPIO0_DA_int_4(data)                                            (0x00000020&((data)<<5))
+#define MIS_FAST_ISR_GPIO0_DA_int_4_src(data)                                        ((0x00000020&(data))>>5)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_4(data)                                        ((0x00000020&(data))>>5)
+#define MIS_FAST_ISR_GPIO0_DA_int_3_shift                                            (4)
+#define MIS_FAST_ISR_GPIO0_DA_int_3_mask                                             (0x00000010)
+#define MIS_FAST_ISR_GPIO0_DA_int_3(data)                                            (0x00000010&((data)<<4))
+#define MIS_FAST_ISR_GPIO0_DA_int_3_src(data)                                        ((0x00000010&(data))>>4)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_3(data)                                        ((0x00000010&(data))>>4)
+#define MIS_FAST_ISR_GPIO0_DA_int_2_shift                                            (3)
+#define MIS_FAST_ISR_GPIO0_DA_int_2_mask                                             (0x00000008)
+#define MIS_FAST_ISR_GPIO0_DA_int_2(data)                                            (0x00000008&((data)<<3))
+#define MIS_FAST_ISR_GPIO0_DA_int_2_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_2(data)                                        ((0x00000008&(data))>>3)
+#define MIS_FAST_ISR_GPIO0_DA_int_1_shift                                            (2)
+#define MIS_FAST_ISR_GPIO0_DA_int_1_mask                                             (0x00000004)
+#define MIS_FAST_ISR_GPIO0_DA_int_1(data)                                            (0x00000004&((data)<<2))
+#define MIS_FAST_ISR_GPIO0_DA_int_1_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_1(data)                                        ((0x00000004&(data))>>2)
+#define MIS_FAST_ISR_GPIO0_DA_int_0_shift                                            (1)
+#define MIS_FAST_ISR_GPIO0_DA_int_0_mask                                             (0x00000002)
+#define MIS_FAST_ISR_GPIO0_DA_int_0(data)                                            (0x00000002&((data)<<1))
+#define MIS_FAST_ISR_GPIO0_DA_int_0_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_FAST_ISR_GPIO0_DA_get_int_0(data)                                        ((0x00000002&(data))>>1)
+#define MIS_FAST_ISR_GPIO0_DA_write_data_shift                                       (0)
+#define MIS_FAST_ISR_GPIO0_DA_write_data_mask                                        (0x00000001)
+#define MIS_FAST_ISR_GPIO0_DA_write_data(data)                                       (0x00000001&((data)<<0))
+#define MIS_FAST_ISR_GPIO0_DA_write_data_src(data)                                   ((0x00000001&(data))>>0)
+#define MIS_FAST_ISR_GPIO0_DA_get_write_data(data)                                   ((0x00000001&(data))>>0)
+
+
+#define MIS_FAST_ISR_GPIO1_DA                                                        0x1801B07C
+#define MIS_FAST_ISR_GPIO1_DA_reg_addr                                               "0xB801B07C"
+#define MIS_FAST_ISR_GPIO1_DA_reg                                                    0xB801B07C
+#define set_MIS_FAST_ISR_GPIO1_DA_reg(data)   (*((volatile unsigned int*) MIS_FAST_ISR_GPIO1_DA_reg)=data)
+#define get_MIS_FAST_ISR_GPIO1_DA_reg   (*((volatile unsigned int*) MIS_FAST_ISR_GPIO1_DA_reg))
+#define MIS_FAST_ISR_GPIO1_DA_inst_adr                                               "0x001F"
+#define MIS_FAST_ISR_GPIO1_DA_inst                                                   0x001F
+#define MIS_FAST_ISR_GPIO1_DA_int_59_shift                                           (29)
+#define MIS_FAST_ISR_GPIO1_DA_int_59_mask                                            (0x20000000)
+#define MIS_FAST_ISR_GPIO1_DA_int_59(data)                                           (0x20000000&((data)<<29))
+#define MIS_FAST_ISR_GPIO1_DA_int_59_src(data)                                       ((0x20000000&(data))>>29)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_59(data)                                       ((0x20000000&(data))>>29)
+#define MIS_FAST_ISR_GPIO1_DA_int_58_shift                                           (28)
+#define MIS_FAST_ISR_GPIO1_DA_int_58_mask                                            (0x10000000)
+#define MIS_FAST_ISR_GPIO1_DA_int_58(data)                                           (0x10000000&((data)<<28))
+#define MIS_FAST_ISR_GPIO1_DA_int_58_src(data)                                       ((0x10000000&(data))>>28)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_58(data)                                       ((0x10000000&(data))>>28)
+#define MIS_FAST_ISR_GPIO1_DA_int_57_shift                                           (27)
+#define MIS_FAST_ISR_GPIO1_DA_int_57_mask                                            (0x08000000)
+#define MIS_FAST_ISR_GPIO1_DA_int_57(data)                                           (0x08000000&((data)<<27))
+#define MIS_FAST_ISR_GPIO1_DA_int_57_src(data)                                       ((0x08000000&(data))>>27)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_57(data)                                       ((0x08000000&(data))>>27)
+#define MIS_FAST_ISR_GPIO1_DA_int_56_shift                                           (26)
+#define MIS_FAST_ISR_GPIO1_DA_int_56_mask                                            (0x04000000)
+#define MIS_FAST_ISR_GPIO1_DA_int_56(data)                                           (0x04000000&((data)<<26))
+#define MIS_FAST_ISR_GPIO1_DA_int_56_src(data)                                       ((0x04000000&(data))>>26)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_56(data)                                       ((0x04000000&(data))>>26)
+#define MIS_FAST_ISR_GPIO1_DA_int_55_shift                                           (25)
+#define MIS_FAST_ISR_GPIO1_DA_int_55_mask                                            (0x02000000)
+#define MIS_FAST_ISR_GPIO1_DA_int_55(data)                                           (0x02000000&((data)<<25))
+#define MIS_FAST_ISR_GPIO1_DA_int_55_src(data)                                       ((0x02000000&(data))>>25)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_55(data)                                       ((0x02000000&(data))>>25)
+#define MIS_FAST_ISR_GPIO1_DA_int_54_shift                                           (24)
+#define MIS_FAST_ISR_GPIO1_DA_int_54_mask                                            (0x01000000)
+#define MIS_FAST_ISR_GPIO1_DA_int_54(data)                                           (0x01000000&((data)<<24))
+#define MIS_FAST_ISR_GPIO1_DA_int_54_src(data)                                       ((0x01000000&(data))>>24)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_54(data)                                       ((0x01000000&(data))>>24)
+#define MIS_FAST_ISR_GPIO1_DA_int_53_shift                                           (23)
+#define MIS_FAST_ISR_GPIO1_DA_int_53_mask                                            (0x00800000)
+#define MIS_FAST_ISR_GPIO1_DA_int_53(data)                                           (0x00800000&((data)<<23))
+#define MIS_FAST_ISR_GPIO1_DA_int_53_src(data)                                       ((0x00800000&(data))>>23)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_53(data)                                       ((0x00800000&(data))>>23)
+#define MIS_FAST_ISR_GPIO1_DA_int_52_shift                                           (22)
+#define MIS_FAST_ISR_GPIO1_DA_int_52_mask                                            (0x00400000)
+#define MIS_FAST_ISR_GPIO1_DA_int_52(data)                                           (0x00400000&((data)<<22))
+#define MIS_FAST_ISR_GPIO1_DA_int_52_src(data)                                       ((0x00400000&(data))>>22)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_52(data)                                       ((0x00400000&(data))>>22)
+#define MIS_FAST_ISR_GPIO1_DA_int_51_shift                                           (21)
+#define MIS_FAST_ISR_GPIO1_DA_int_51_mask                                            (0x00200000)
+#define MIS_FAST_ISR_GPIO1_DA_int_51(data)                                           (0x00200000&((data)<<21))
+#define MIS_FAST_ISR_GPIO1_DA_int_51_src(data)                                       ((0x00200000&(data))>>21)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_51(data)                                       ((0x00200000&(data))>>21)
+#define MIS_FAST_ISR_GPIO1_DA_int_50_shift                                           (20)
+#define MIS_FAST_ISR_GPIO1_DA_int_50_mask                                            (0x00100000)
+#define MIS_FAST_ISR_GPIO1_DA_int_50(data)                                           (0x00100000&((data)<<20))
+#define MIS_FAST_ISR_GPIO1_DA_int_50_src(data)                                       ((0x00100000&(data))>>20)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_50(data)                                       ((0x00100000&(data))>>20)
+#define MIS_FAST_ISR_GPIO1_DA_int_49_shift                                           (19)
+#define MIS_FAST_ISR_GPIO1_DA_int_49_mask                                            (0x00080000)
+#define MIS_FAST_ISR_GPIO1_DA_int_49(data)                                           (0x00080000&((data)<<19))
+#define MIS_FAST_ISR_GPIO1_DA_int_49_src(data)                                       ((0x00080000&(data))>>19)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_49(data)                                       ((0x00080000&(data))>>19)
+#define MIS_FAST_ISR_GPIO1_DA_int_48_shift                                           (18)
+#define MIS_FAST_ISR_GPIO1_DA_int_48_mask                                            (0x00040000)
+#define MIS_FAST_ISR_GPIO1_DA_int_48(data)                                           (0x00040000&((data)<<18))
+#define MIS_FAST_ISR_GPIO1_DA_int_48_src(data)                                       ((0x00040000&(data))>>18)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_48(data)                                       ((0x00040000&(data))>>18)
+#define MIS_FAST_ISR_GPIO1_DA_int_47_shift                                           (17)
+#define MIS_FAST_ISR_GPIO1_DA_int_47_mask                                            (0x00020000)
+#define MIS_FAST_ISR_GPIO1_DA_int_47(data)                                           (0x00020000&((data)<<17))
+#define MIS_FAST_ISR_GPIO1_DA_int_47_src(data)                                       ((0x00020000&(data))>>17)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_47(data)                                       ((0x00020000&(data))>>17)
+#define MIS_FAST_ISR_GPIO1_DA_int_46_shift                                           (16)
+#define MIS_FAST_ISR_GPIO1_DA_int_46_mask                                            (0x00010000)
+#define MIS_FAST_ISR_GPIO1_DA_int_46(data)                                           (0x00010000&((data)<<16))
+#define MIS_FAST_ISR_GPIO1_DA_int_46_src(data)                                       ((0x00010000&(data))>>16)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_46(data)                                       ((0x00010000&(data))>>16)
+#define MIS_FAST_ISR_GPIO1_DA_int_45_shift                                           (15)
+#define MIS_FAST_ISR_GPIO1_DA_int_45_mask                                            (0x00008000)
+#define MIS_FAST_ISR_GPIO1_DA_int_45(data)                                           (0x00008000&((data)<<15))
+#define MIS_FAST_ISR_GPIO1_DA_int_45_src(data)                                       ((0x00008000&(data))>>15)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_45(data)                                       ((0x00008000&(data))>>15)
+#define MIS_FAST_ISR_GPIO1_DA_int_44_shift                                           (14)
+#define MIS_FAST_ISR_GPIO1_DA_int_44_mask                                            (0x00004000)
+#define MIS_FAST_ISR_GPIO1_DA_int_44(data)                                           (0x00004000&((data)<<14))
+#define MIS_FAST_ISR_GPIO1_DA_int_44_src(data)                                       ((0x00004000&(data))>>14)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_44(data)                                       ((0x00004000&(data))>>14)
+#define MIS_FAST_ISR_GPIO1_DA_int_43_shift                                           (13)
+#define MIS_FAST_ISR_GPIO1_DA_int_43_mask                                            (0x00002000)
+#define MIS_FAST_ISR_GPIO1_DA_int_43(data)                                           (0x00002000&((data)<<13))
+#define MIS_FAST_ISR_GPIO1_DA_int_43_src(data)                                       ((0x00002000&(data))>>13)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_43(data)                                       ((0x00002000&(data))>>13)
+#define MIS_FAST_ISR_GPIO1_DA_int_42_shift                                           (12)
+#define MIS_FAST_ISR_GPIO1_DA_int_42_mask                                            (0x00001000)
+#define MIS_FAST_ISR_GPIO1_DA_int_42(data)                                           (0x00001000&((data)<<12))
+#define MIS_FAST_ISR_GPIO1_DA_int_42_src(data)                                       ((0x00001000&(data))>>12)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_42(data)                                       ((0x00001000&(data))>>12)
+#define MIS_FAST_ISR_GPIO1_DA_int_41_shift                                           (11)
+#define MIS_FAST_ISR_GPIO1_DA_int_41_mask                                            (0x00000800)
+#define MIS_FAST_ISR_GPIO1_DA_int_41(data)                                           (0x00000800&((data)<<11))
+#define MIS_FAST_ISR_GPIO1_DA_int_41_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_41(data)                                       ((0x00000800&(data))>>11)
+#define MIS_FAST_ISR_GPIO1_DA_int_40_shift                                           (10)
+#define MIS_FAST_ISR_GPIO1_DA_int_40_mask                                            (0x00000400)
+#define MIS_FAST_ISR_GPIO1_DA_int_40(data)                                           (0x00000400&((data)<<10))
+#define MIS_FAST_ISR_GPIO1_DA_int_40_src(data)                                       ((0x00000400&(data))>>10)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_40(data)                                       ((0x00000400&(data))>>10)
+#define MIS_FAST_ISR_GPIO1_DA_int_39_shift                                           (9)
+#define MIS_FAST_ISR_GPIO1_DA_int_39_mask                                            (0x00000200)
+#define MIS_FAST_ISR_GPIO1_DA_int_39(data)                                           (0x00000200&((data)<<9))
+#define MIS_FAST_ISR_GPIO1_DA_int_39_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_39(data)                                       ((0x00000200&(data))>>9)
+#define MIS_FAST_ISR_GPIO1_DA_int_38_shift                                           (8)
+#define MIS_FAST_ISR_GPIO1_DA_int_38_mask                                            (0x00000100)
+#define MIS_FAST_ISR_GPIO1_DA_int_38(data)                                           (0x00000100&((data)<<8))
+#define MIS_FAST_ISR_GPIO1_DA_int_38_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_38(data)                                       ((0x00000100&(data))>>8)
+#define MIS_FAST_ISR_GPIO1_DA_int_37_shift                                           (7)
+#define MIS_FAST_ISR_GPIO1_DA_int_37_mask                                            (0x00000080)
+#define MIS_FAST_ISR_GPIO1_DA_int_37(data)                                           (0x00000080&((data)<<7))
+#define MIS_FAST_ISR_GPIO1_DA_int_37_src(data)                                       ((0x00000080&(data))>>7)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_37(data)                                       ((0x00000080&(data))>>7)
+#define MIS_FAST_ISR_GPIO1_DA_int_36_shift                                           (6)
+#define MIS_FAST_ISR_GPIO1_DA_int_36_mask                                            (0x00000040)
+#define MIS_FAST_ISR_GPIO1_DA_int_36(data)                                           (0x00000040&((data)<<6))
+#define MIS_FAST_ISR_GPIO1_DA_int_36_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_36(data)                                       ((0x00000040&(data))>>6)
+#define MIS_FAST_ISR_GPIO1_DA_int_35_shift                                           (5)
+#define MIS_FAST_ISR_GPIO1_DA_int_35_mask                                            (0x00000020)
+#define MIS_FAST_ISR_GPIO1_DA_int_35(data)                                           (0x00000020&((data)<<5))
+#define MIS_FAST_ISR_GPIO1_DA_int_35_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_35(data)                                       ((0x00000020&(data))>>5)
+#define MIS_FAST_ISR_GPIO1_DA_int_34_shift                                           (4)
+#define MIS_FAST_ISR_GPIO1_DA_int_34_mask                                            (0x00000010)
+#define MIS_FAST_ISR_GPIO1_DA_int_34(data)                                           (0x00000010&((data)<<4))
+#define MIS_FAST_ISR_GPIO1_DA_int_34_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_34(data)                                       ((0x00000010&(data))>>4)
+#define MIS_FAST_ISR_GPIO1_DA_int_33_shift                                           (3)
+#define MIS_FAST_ISR_GPIO1_DA_int_33_mask                                            (0x00000008)
+#define MIS_FAST_ISR_GPIO1_DA_int_33(data)                                           (0x00000008&((data)<<3))
+#define MIS_FAST_ISR_GPIO1_DA_int_33_src(data)                                       ((0x00000008&(data))>>3)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_33(data)                                       ((0x00000008&(data))>>3)
+#define MIS_FAST_ISR_GPIO1_DA_int_32_shift                                           (2)
+#define MIS_FAST_ISR_GPIO1_DA_int_32_mask                                            (0x00000004)
+#define MIS_FAST_ISR_GPIO1_DA_int_32(data)                                           (0x00000004&((data)<<2))
+#define MIS_FAST_ISR_GPIO1_DA_int_32_src(data)                                       ((0x00000004&(data))>>2)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_32(data)                                       ((0x00000004&(data))>>2)
+#define MIS_FAST_ISR_GPIO1_DA_int_31_shift                                           (1)
+#define MIS_FAST_ISR_GPIO1_DA_int_31_mask                                            (0x00000002)
+#define MIS_FAST_ISR_GPIO1_DA_int_31(data)                                           (0x00000002&((data)<<1))
+#define MIS_FAST_ISR_GPIO1_DA_int_31_src(data)                                       ((0x00000002&(data))>>1)
+#define MIS_FAST_ISR_GPIO1_DA_get_int_31(data)                                       ((0x00000002&(data))>>1)
+#define MIS_FAST_ISR_GPIO1_DA_write_data_shift                                       (0)
+#define MIS_FAST_ISR_GPIO1_DA_write_data_mask                                        (0x00000001)
+#define MIS_FAST_ISR_GPIO1_DA_write_data(data)                                       (0x00000001&((data)<<0))
+#define MIS_FAST_ISR_GPIO1_DA_write_data_src(data)                                   ((0x00000001&(data))>>0)
+#define MIS_FAST_ISR_GPIO1_DA_get_write_data(data)                                   ((0x00000001&(data))>>0)
+
+
+#define MIS_SCPU_INT_EN                                                              0x1801B080
+#define MIS_SCPU_INT_EN_reg_addr                                                     "0xB801B080"
+#define MIS_SCPU_INT_EN_reg                                                          0xB801B080
+#define set_MIS_SCPU_INT_EN_reg(data)   (*((volatile unsigned int*) MIS_SCPU_INT_EN_reg)=data)
+#define get_MIS_SCPU_INT_EN_reg   (*((volatile unsigned int*) MIS_SCPU_INT_EN_reg))
+#define MIS_SCPU_INT_EN_inst_adr                                                     "0x0020"
+#define MIS_SCPU_INT_EN_inst                                                         0x0020
+#define MIS_SCPU_INT_EN_i2c3_shift                                                   (28)
+#define MIS_SCPU_INT_EN_i2c3_mask                                                    (0x10000000)
+#define MIS_SCPU_INT_EN_i2c3(data)                                                   (0x10000000&((data)<<28))
+#define MIS_SCPU_INT_EN_i2c3_src(data)                                               ((0x10000000&(data))>>28)
+#define MIS_SCPU_INT_EN_get_i2c3(data)                                               ((0x10000000&(data))>>28)
+#define MIS_SCPU_INT_EN_gspi_shift                                                   (27)
+#define MIS_SCPU_INT_EN_gspi_mask                                                    (0x08000000)
+#define MIS_SCPU_INT_EN_gspi(data)                                                   (0x08000000&((data)<<27))
+#define MIS_SCPU_INT_EN_gspi_src(data)                                               ((0x08000000&(data))>>27)
+#define MIS_SCPU_INT_EN_get_gspi(data)                                               ((0x08000000&(data))>>27)
+#define MIS_SCPU_INT_EN_i2c2_shift                                                   (26)
+#define MIS_SCPU_INT_EN_i2c2_mask                                                    (0x04000000)
+#define MIS_SCPU_INT_EN_i2c2(data)                                                   (0x04000000&((data)<<26))
+#define MIS_SCPU_INT_EN_i2c2_src(data)                                               ((0x04000000&(data))>>26)
+#define MIS_SCPU_INT_EN_get_i2c2(data)                                               ((0x04000000&(data))>>26)
+#define MIS_SCPU_INT_EN_lsadc_shift                                                  (21)
+#define MIS_SCPU_INT_EN_lsadc_mask                                                   (0x00200000)
+#define MIS_SCPU_INT_EN_lsadc(data)                                                  (0x00200000&((data)<<21))
+#define MIS_SCPU_INT_EN_lsadc_src(data)                                              ((0x00200000&(data))>>21)
+#define MIS_SCPU_INT_EN_get_lsadc(data)                                              ((0x00200000&(data))>>21)
+#define MIS_SCPU_INT_EN_gpioda_shift                                                 (20)
+#define MIS_SCPU_INT_EN_gpioda_mask                                                  (0x00100000)
+#define MIS_SCPU_INT_EN_gpioda(data)                                                 (0x00100000&((data)<<20))
+#define MIS_SCPU_INT_EN_gpioda_src(data)                                             ((0x00100000&(data))>>20)
+#define MIS_SCPU_INT_EN_get_gpioda(data)                                             ((0x00100000&(data))>>20)
+#define MIS_SCPU_INT_EN_gpioa_shift                                                  (19)
+#define MIS_SCPU_INT_EN_gpioa_mask                                                   (0x00080000)
+#define MIS_SCPU_INT_EN_gpioa(data)                                                  (0x00080000&((data)<<19))
+#define MIS_SCPU_INT_EN_gpioa_src(data)                                              ((0x00080000&(data))>>19)
+#define MIS_SCPU_INT_EN_get_gpioa(data)                                              ((0x00080000&(data))>>19)
+#define MIS_SCPU_INT_EN_i2c4_shift                                                   (15)
+#define MIS_SCPU_INT_EN_i2c4_mask                                                    (0x00008000)
+#define MIS_SCPU_INT_EN_i2c4(data)                                                   (0x00008000&((data)<<15))
+#define MIS_SCPU_INT_EN_i2c4_src(data)                                               ((0x00008000&(data))>>15)
+#define MIS_SCPU_INT_EN_get_i2c4(data)                                               ((0x00008000&(data))>>15)
+#define MIS_SCPU_INT_EN_i2c5_shift                                                   (14)
+#define MIS_SCPU_INT_EN_i2c5_mask                                                    (0x00004000)
+#define MIS_SCPU_INT_EN_i2c5(data)                                                   (0x00004000&((data)<<14))
+#define MIS_SCPU_INT_EN_i2c5_src(data)                                               ((0x00004000&(data))>>14)
+#define MIS_SCPU_INT_EN_get_i2c5(data)                                               ((0x00004000&(data))>>14)
+#define MIS_SCPU_INT_EN_rtc_date_shift                                               (12)
+#define MIS_SCPU_INT_EN_rtc_date_mask                                                (0x00001000)
+#define MIS_SCPU_INT_EN_rtc_date(data)                                               (0x00001000&((data)<<12))
+#define MIS_SCPU_INT_EN_rtc_date_src(data)                                           ((0x00001000&(data))>>12)
+#define MIS_SCPU_INT_EN_get_rtc_date(data)                                           ((0x00001000&(data))>>12)
+#define MIS_SCPU_INT_EN_rtc_hour_shift                                               (11)
+#define MIS_SCPU_INT_EN_rtc_hour_mask                                                (0x00000800)
+#define MIS_SCPU_INT_EN_rtc_hour(data)                                               (0x00000800&((data)<<11))
+#define MIS_SCPU_INT_EN_rtc_hour_src(data)                                           ((0x00000800&(data))>>11)
+#define MIS_SCPU_INT_EN_get_rtc_hour(data)                                           ((0x00000800&(data))>>11)
+#define MIS_SCPU_INT_EN_rtc_min_shift                                                (10)
+#define MIS_SCPU_INT_EN_rtc_min_mask                                                 (0x00000400)
+#define MIS_SCPU_INT_EN_rtc_min(data)                                                (0x00000400&((data)<<10))
+#define MIS_SCPU_INT_EN_rtc_min_src(data)                                            ((0x00000400&(data))>>10)
+#define MIS_SCPU_INT_EN_get_rtc_min(data)                                            ((0x00000400&(data))>>10)
+#define MIS_SCPU_INT_EN_ur1_to_shift                                                 (5)
+#define MIS_SCPU_INT_EN_ur1_to_mask                                                  (0x00000020)
+#define MIS_SCPU_INT_EN_ur1_to(data)                                                 (0x00000020&((data)<<5))
+#define MIS_SCPU_INT_EN_ur1_to_src(data)                                             ((0x00000020&(data))>>5)
+#define MIS_SCPU_INT_EN_get_ur1_to(data)                                             ((0x00000020&(data))>>5)
+#define MIS_SCPU_INT_EN_i2c1_shift                                                   (4)
+#define MIS_SCPU_INT_EN_i2c1_mask                                                    (0x00000010)
+#define MIS_SCPU_INT_EN_i2c1(data)                                                   (0x00000010&((data)<<4))
+#define MIS_SCPU_INT_EN_i2c1_src(data)                                               ((0x00000010&(data))>>4)
+#define MIS_SCPU_INT_EN_get_i2c1(data)                                               ((0x00000010&(data))>>4)
+#define MIS_SCPU_INT_EN_ur1_shift                                                    (3)
+#define MIS_SCPU_INT_EN_ur1_mask                                                     (0x00000008)
+#define MIS_SCPU_INT_EN_ur1(data)                                                    (0x00000008&((data)<<3))
+#define MIS_SCPU_INT_EN_ur1_src(data)                                                ((0x00000008&(data))>>3)
+#define MIS_SCPU_INT_EN_get_ur1(data)                                                ((0x00000008&(data))>>3)
+
+
+#define MIS_I2C1_SDA_DEL                                                             0x1801B088
+#define MIS_I2C1_SDA_DEL_reg_addr                                                    "0xB801B088"
+#define MIS_I2C1_SDA_DEL_reg                                                         0xB801B088
+#define set_MIS_I2C1_SDA_DEL_reg(data)   (*((volatile unsigned int*) MIS_I2C1_SDA_DEL_reg)=data)
+#define get_MIS_I2C1_SDA_DEL_reg   (*((volatile unsigned int*) MIS_I2C1_SDA_DEL_reg))
+#define MIS_I2C1_SDA_DEL_inst_adr                                                    "0x0022"
+#define MIS_I2C1_SDA_DEL_inst                                                        0x0022
+#define MIS_I2C1_SDA_DEL_dmy1_shift                                                  (12)
+#define MIS_I2C1_SDA_DEL_dmy1_mask                                                   (0xFFFFF000)
+#define MIS_I2C1_SDA_DEL_dmy1(data)                                                  (0xFFFFF000&((data)<<12))
+#define MIS_I2C1_SDA_DEL_dmy1_src(data)                                              ((0xFFFFF000&(data))>>12)
+#define MIS_I2C1_SDA_DEL_get_dmy1(data)                                              ((0xFFFFF000&(data))>>12)
+#define MIS_I2C1_SDA_DEL_en_shift                                                    (8)
+#define MIS_I2C1_SDA_DEL_en_mask                                                     (0x00000100)
+#define MIS_I2C1_SDA_DEL_en(data)                                                    (0x00000100&((data)<<8))
+#define MIS_I2C1_SDA_DEL_en_src(data)                                                ((0x00000100&(data))>>8)
+#define MIS_I2C1_SDA_DEL_get_en(data)                                                ((0x00000100&(data))>>8)
+#define MIS_I2C1_SDA_DEL_sel_shift                                                   (0)
+#define MIS_I2C1_SDA_DEL_sel_mask                                                    (0x0000001F)
+#define MIS_I2C1_SDA_DEL_sel(data)                                                   (0x0000001F&((data)<<0))
+#define MIS_I2C1_SDA_DEL_sel_src(data)                                               ((0x0000001F&(data))>>0)
+#define MIS_I2C1_SDA_DEL_get_sel(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define MIS_I2C2_SDA_DEL                                                             0x1801B08c
+#define MIS_I2C2_SDA_DEL_reg_addr                                                    "0xB801B08C"
+#define MIS_I2C2_SDA_DEL_reg                                                         0xB801B08C
+#define set_MIS_I2C2_SDA_DEL_reg(data)   (*((volatile unsigned int*) MIS_I2C2_SDA_DEL_reg)=data)
+#define get_MIS_I2C2_SDA_DEL_reg   (*((volatile unsigned int*) MIS_I2C2_SDA_DEL_reg))
+#define MIS_I2C2_SDA_DEL_inst_adr                                                    "0x0023"
+#define MIS_I2C2_SDA_DEL_inst                                                        0x0023
+#define MIS_I2C2_SDA_DEL_dmy1_shift                                                  (12)
+#define MIS_I2C2_SDA_DEL_dmy1_mask                                                   (0xFFFFF000)
+#define MIS_I2C2_SDA_DEL_dmy1(data)                                                  (0xFFFFF000&((data)<<12))
+#define MIS_I2C2_SDA_DEL_dmy1_src(data)                                              ((0xFFFFF000&(data))>>12)
+#define MIS_I2C2_SDA_DEL_get_dmy1(data)                                              ((0xFFFFF000&(data))>>12)
+#define MIS_I2C2_SDA_DEL_en_shift                                                    (8)
+#define MIS_I2C2_SDA_DEL_en_mask                                                     (0x00000100)
+#define MIS_I2C2_SDA_DEL_en(data)                                                    (0x00000100&((data)<<8))
+#define MIS_I2C2_SDA_DEL_en_src(data)                                                ((0x00000100&(data))>>8)
+#define MIS_I2C2_SDA_DEL_get_en(data)                                                ((0x00000100&(data))>>8)
+#define MIS_I2C2_SDA_DEL_sel_shift                                                   (0)
+#define MIS_I2C2_SDA_DEL_sel_mask                                                    (0x0000001F)
+#define MIS_I2C2_SDA_DEL_sel(data)                                                   (0x0000001F&((data)<<0))
+#define MIS_I2C2_SDA_DEL_sel_src(data)                                               ((0x0000001F&(data))>>0)
+#define MIS_I2C2_SDA_DEL_get_sel(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define MIS_I2C3_SDA_DEL                                                             0x1801B090
+#define MIS_I2C3_SDA_DEL_reg_addr                                                    "0xB801B090"
+#define MIS_I2C3_SDA_DEL_reg                                                         0xB801B090
+#define set_MIS_I2C3_SDA_DEL_reg(data)   (*((volatile unsigned int*) MIS_I2C3_SDA_DEL_reg)=data)
+#define get_MIS_I2C3_SDA_DEL_reg   (*((volatile unsigned int*) MIS_I2C3_SDA_DEL_reg))
+#define MIS_I2C3_SDA_DEL_inst_adr                                                    "0x0024"
+#define MIS_I2C3_SDA_DEL_inst                                                        0x0024
+#define MIS_I2C3_SDA_DEL_dmy1_shift                                                  (12)
+#define MIS_I2C3_SDA_DEL_dmy1_mask                                                   (0xFFFFF000)
+#define MIS_I2C3_SDA_DEL_dmy1(data)                                                  (0xFFFFF000&((data)<<12))
+#define MIS_I2C3_SDA_DEL_dmy1_src(data)                                              ((0xFFFFF000&(data))>>12)
+#define MIS_I2C3_SDA_DEL_get_dmy1(data)                                              ((0xFFFFF000&(data))>>12)
+#define MIS_I2C3_SDA_DEL_en_shift                                                    (8)
+#define MIS_I2C3_SDA_DEL_en_mask                                                     (0x00000100)
+#define MIS_I2C3_SDA_DEL_en(data)                                                    (0x00000100&((data)<<8))
+#define MIS_I2C3_SDA_DEL_en_src(data)                                                ((0x00000100&(data))>>8)
+#define MIS_I2C3_SDA_DEL_get_en(data)                                                ((0x00000100&(data))>>8)
+#define MIS_I2C3_SDA_DEL_sel_shift                                                   (0)
+#define MIS_I2C3_SDA_DEL_sel_mask                                                    (0x0000001F)
+#define MIS_I2C3_SDA_DEL_sel(data)                                                   (0x0000001F&((data)<<0))
+#define MIS_I2C3_SDA_DEL_sel_src(data)                                               ((0x0000001F&(data))>>0)
+#define MIS_I2C3_SDA_DEL_get_sel(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define MIS_I2C4_SDA_DEL                                                             0x1801B094
+#define MIS_I2C4_SDA_DEL_reg_addr                                                    "0xB801B094"
+#define MIS_I2C4_SDA_DEL_reg                                                         0xB801B094
+#define set_MIS_I2C4_SDA_DEL_reg(data)   (*((volatile unsigned int*) MIS_I2C4_SDA_DEL_reg)=data)
+#define get_MIS_I2C4_SDA_DEL_reg   (*((volatile unsigned int*) MIS_I2C4_SDA_DEL_reg))
+#define MIS_I2C4_SDA_DEL_inst_adr                                                    "0x0025"
+#define MIS_I2C4_SDA_DEL_inst                                                        0x0025
+#define MIS_I2C4_SDA_DEL_dmy1_shift                                                  (12)
+#define MIS_I2C4_SDA_DEL_dmy1_mask                                                   (0xFFFFF000)
+#define MIS_I2C4_SDA_DEL_dmy1(data)                                                  (0xFFFFF000&((data)<<12))
+#define MIS_I2C4_SDA_DEL_dmy1_src(data)                                              ((0xFFFFF000&(data))>>12)
+#define MIS_I2C4_SDA_DEL_get_dmy1(data)                                              ((0xFFFFF000&(data))>>12)
+#define MIS_I2C4_SDA_DEL_en_shift                                                    (8)
+#define MIS_I2C4_SDA_DEL_en_mask                                                     (0x00000100)
+#define MIS_I2C4_SDA_DEL_en(data)                                                    (0x00000100&((data)<<8))
+#define MIS_I2C4_SDA_DEL_en_src(data)                                                ((0x00000100&(data))>>8)
+#define MIS_I2C4_SDA_DEL_get_en(data)                                                ((0x00000100&(data))>>8)
+#define MIS_I2C4_SDA_DEL_sel_shift                                                   (0)
+#define MIS_I2C4_SDA_DEL_sel_mask                                                    (0x0000001F)
+#define MIS_I2C4_SDA_DEL_sel(data)                                                   (0x0000001F&((data)<<0))
+#define MIS_I2C4_SDA_DEL_sel_src(data)                                               ((0x0000001F&(data))>>0)
+#define MIS_I2C4_SDA_DEL_get_sel(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define MIS_I2C5_SDA_DEL                                                             0x1801B098
+#define MIS_I2C5_SDA_DEL_reg_addr                                                    "0xB801B098"
+#define MIS_I2C5_SDA_DEL_reg                                                         0xB801B098
+#define set_MIS_I2C5_SDA_DEL_reg(data)   (*((volatile unsigned int*) MIS_I2C5_SDA_DEL_reg)=data)
+#define get_MIS_I2C5_SDA_DEL_reg   (*((volatile unsigned int*) MIS_I2C5_SDA_DEL_reg))
+#define MIS_I2C5_SDA_DEL_inst_adr                                                    "0x0026"
+#define MIS_I2C5_SDA_DEL_inst                                                        0x0026
+#define MIS_I2C5_SDA_DEL_dmy1_shift                                                  (12)
+#define MIS_I2C5_SDA_DEL_dmy1_mask                                                   (0xFFFFF000)
+#define MIS_I2C5_SDA_DEL_dmy1(data)                                                  (0xFFFFF000&((data)<<12))
+#define MIS_I2C5_SDA_DEL_dmy1_src(data)                                              ((0xFFFFF000&(data))>>12)
+#define MIS_I2C5_SDA_DEL_get_dmy1(data)                                              ((0xFFFFF000&(data))>>12)
+#define MIS_I2C5_SDA_DEL_en_shift                                                    (8)
+#define MIS_I2C5_SDA_DEL_en_mask                                                     (0x00000100)
+#define MIS_I2C5_SDA_DEL_en(data)                                                    (0x00000100&((data)<<8))
+#define MIS_I2C5_SDA_DEL_en_src(data)                                                ((0x00000100&(data))>>8)
+#define MIS_I2C5_SDA_DEL_get_en(data)                                                ((0x00000100&(data))>>8)
+#define MIS_I2C5_SDA_DEL_sel_shift                                                   (0)
+#define MIS_I2C5_SDA_DEL_sel_mask                                                    (0x0000001F)
+#define MIS_I2C5_SDA_DEL_sel(data)                                                   (0x0000001F&((data)<<0))
+#define MIS_I2C5_SDA_DEL_sel_src(data)                                               ((0x0000001F&(data))>>0)
+#define MIS_I2C5_SDA_DEL_get_sel(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define MIS_GP0DIR                                                                   0x1801B100
+#define MIS_GP0DIR_reg_addr                                                          "0xB801B100"
+#define MIS_GP0DIR_reg                                                               0xB801B100
+#define set_MIS_GP0DIR_reg(data)   (*((volatile unsigned int*) MIS_GP0DIR_reg)=data)
+#define get_MIS_GP0DIR_reg   (*((volatile unsigned int*) MIS_GP0DIR_reg))
+#define MIS_GP0DIR_inst_adr                                                          "0x0040"
+#define MIS_GP0DIR_inst                                                              0x0040
+#define MIS_GP0DIR_gpdir_shift                                                       (0)
+#define MIS_GP0DIR_gpdir_mask                                                        (0xFFFFFFFF)
+#define MIS_GP0DIR_gpdir(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define MIS_GP0DIR_gpdir_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define MIS_GP0DIR_get_gpdir(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_GP1DIR                                                                   0x1801B104
+#define MIS_GP1DIR_reg_addr                                                          "0xB801B104"
+#define MIS_GP1DIR_reg                                                               0xB801B104
+#define set_MIS_GP1DIR_reg(data)   (*((volatile unsigned int*) MIS_GP1DIR_reg)=data)
+#define get_MIS_GP1DIR_reg   (*((volatile unsigned int*) MIS_GP1DIR_reg))
+#define MIS_GP1DIR_inst_adr                                                          "0x0041"
+#define MIS_GP1DIR_inst                                                              0x0041
+#define MIS_GP1DIR_gpdir_shift                                                       (0)
+#define MIS_GP1DIR_gpdir_mask                                                        (0x0FFFFFFF)
+#define MIS_GP1DIR_gpdir(data)                                                       (0x0FFFFFFF&((data)<<0))
+#define MIS_GP1DIR_gpdir_src(data)                                                   ((0x0FFFFFFF&(data))>>0)
+#define MIS_GP1DIR_get_gpdir(data)                                                   ((0x0FFFFFFF&(data))>>0)
+
+
+#define MIS_GP0DATO                                                                  0x1801B110
+#define MIS_GP0DATO_reg_addr                                                         "0xB801B110"
+#define MIS_GP0DATO_reg                                                              0xB801B110
+#define set_MIS_GP0DATO_reg(data)   (*((volatile unsigned int*) MIS_GP0DATO_reg)=data)
+#define get_MIS_GP0DATO_reg   (*((volatile unsigned int*) MIS_GP0DATO_reg))
+#define MIS_GP0DATO_inst_adr                                                         "0x0044"
+#define MIS_GP0DATO_inst                                                             0x0044
+#define MIS_GP0DATO_gpdato_shift                                                     (0)
+#define MIS_GP0DATO_gpdato_mask                                                      (0xFFFFFFFF)
+#define MIS_GP0DATO_gpdato(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define MIS_GP0DATO_gpdato_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define MIS_GP0DATO_get_gpdato(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_GP1DATO                                                                  0x1801B114
+#define MIS_GP1DATO_reg_addr                                                         "0xB801B114"
+#define MIS_GP1DATO_reg                                                              0xB801B114
+#define set_MIS_GP1DATO_reg(data)   (*((volatile unsigned int*) MIS_GP1DATO_reg)=data)
+#define get_MIS_GP1DATO_reg   (*((volatile unsigned int*) MIS_GP1DATO_reg))
+#define MIS_GP1DATO_inst_adr                                                         "0x0045"
+#define MIS_GP1DATO_inst                                                             0x0045
+#define MIS_GP1DATO_gpdato_shift                                                     (0)
+#define MIS_GP1DATO_gpdato_mask                                                      (0x0FFFFFFF)
+#define MIS_GP1DATO_gpdato(data)                                                     (0x0FFFFFFF&((data)<<0))
+#define MIS_GP1DATO_gpdato_src(data)                                                 ((0x0FFFFFFF&(data))>>0)
+#define MIS_GP1DATO_get_gpdato(data)                                                 ((0x0FFFFFFF&(data))>>0)
+
+
+#define MIS_GP0DATI                                                                  0x1801B120
+#define MIS_GP0DATI_reg_addr                                                         "0xB801B120"
+#define MIS_GP0DATI_reg                                                              0xB801B120
+#define set_MIS_GP0DATI_reg(data)   (*((volatile unsigned int*) MIS_GP0DATI_reg)=data)
+#define get_MIS_GP0DATI_reg   (*((volatile unsigned int*) MIS_GP0DATI_reg))
+#define MIS_GP0DATI_inst_adr                                                         "0x0048"
+#define MIS_GP0DATI_inst                                                             0x0048
+#define MIS_GP0DATI_gpdati_shift                                                     (0)
+#define MIS_GP0DATI_gpdati_mask                                                      (0xFFFFFFFF)
+#define MIS_GP0DATI_gpdati(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define MIS_GP0DATI_gpdati_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define MIS_GP0DATI_get_gpdati(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_GP1DATI                                                                  0x1801B124
+#define MIS_GP1DATI_reg_addr                                                         "0xB801B124"
+#define MIS_GP1DATI_reg                                                              0xB801B124
+#define set_MIS_GP1DATI_reg(data)   (*((volatile unsigned int*) MIS_GP1DATI_reg)=data)
+#define get_MIS_GP1DATI_reg   (*((volatile unsigned int*) MIS_GP1DATI_reg))
+#define MIS_GP1DATI_inst_adr                                                         "0x0049"
+#define MIS_GP1DATI_inst                                                             0x0049
+#define MIS_GP1DATI_gpdati_shift                                                     (0)
+#define MIS_GP1DATI_gpdati_mask                                                      (0x0FFFFFFF)
+#define MIS_GP1DATI_gpdati(data)                                                     (0x0FFFFFFF&((data)<<0))
+#define MIS_GP1DATI_gpdati_src(data)                                                 ((0x0FFFFFFF&(data))>>0)
+#define MIS_GP1DATI_get_gpdati(data)                                                 ((0x0FFFFFFF&(data))>>0)
+
+
+#define MIS_GP0IE                                                                    0x1801B130
+#define MIS_GP0IE_reg_addr                                                           "0xB801B130"
+#define MIS_GP0IE_reg                                                                0xB801B130
+#define set_MIS_GP0IE_reg(data)   (*((volatile unsigned int*) MIS_GP0IE_reg)=data)
+#define get_MIS_GP0IE_reg   (*((volatile unsigned int*) MIS_GP0IE_reg))
+#define MIS_GP0IE_inst_adr                                                           "0x004C"
+#define MIS_GP0IE_inst                                                               0x004C
+#define MIS_GP0IE_gp_shift                                                           (0)
+#define MIS_GP0IE_gp_mask                                                            (0xFFFFFFFF)
+#define MIS_GP0IE_gp(data)                                                           (0xFFFFFFFF&((data)<<0))
+#define MIS_GP0IE_gp_src(data)                                                       ((0xFFFFFFFF&(data))>>0)
+#define MIS_GP0IE_get_gp(data)                                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_GP1IE                                                                    0x1801B134
+#define MIS_GP1IE_reg_addr                                                           "0xB801B134"
+#define MIS_GP1IE_reg                                                                0xB801B134
+#define set_MIS_GP1IE_reg(data)   (*((volatile unsigned int*) MIS_GP1IE_reg)=data)
+#define get_MIS_GP1IE_reg   (*((volatile unsigned int*) MIS_GP1IE_reg))
+#define MIS_GP1IE_inst_adr                                                           "0x004D"
+#define MIS_GP1IE_inst                                                               0x004D
+#define MIS_GP1IE_gp_shift                                                           (0)
+#define MIS_GP1IE_gp_mask                                                            (0x0FFFFFFF)
+#define MIS_GP1IE_gp(data)                                                           (0x0FFFFFFF&((data)<<0))
+#define MIS_GP1IE_gp_src(data)                                                       ((0x0FFFFFFF&(data))>>0)
+#define MIS_GP1IE_get_gp(data)                                                       ((0x0FFFFFFF&(data))>>0)
+
+
+#define MIS_GP0DP                                                                    0x1801B140
+#define MIS_GP0DP_reg_addr                                                           "0xB801B140"
+#define MIS_GP0DP_reg                                                                0xB801B140
+#define set_MIS_GP0DP_reg(data)   (*((volatile unsigned int*) MIS_GP0DP_reg)=data)
+#define get_MIS_GP0DP_reg   (*((volatile unsigned int*) MIS_GP0DP_reg))
+#define MIS_GP0DP_inst_adr                                                           "0x0050"
+#define MIS_GP0DP_inst                                                               0x0050
+#define MIS_GP0DP_gpha_shift                                                         (0)
+#define MIS_GP0DP_gpha_mask                                                          (0xFFFFFFFF)
+#define MIS_GP0DP_gpha(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define MIS_GP0DP_gpha_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define MIS_GP0DP_get_gpha(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_GP1DP                                                                    0x1801B144
+#define MIS_GP1DP_reg_addr                                                           "0xB801B144"
+#define MIS_GP1DP_reg                                                                0xB801B144
+#define set_MIS_GP1DP_reg(data)   (*((volatile unsigned int*) MIS_GP1DP_reg)=data)
+#define get_MIS_GP1DP_reg   (*((volatile unsigned int*) MIS_GP1DP_reg))
+#define MIS_GP1DP_inst_adr                                                           "0x0051"
+#define MIS_GP1DP_inst                                                               0x0051
+#define MIS_GP1DP_gpha_shift                                                         (0)
+#define MIS_GP1DP_gpha_mask                                                          (0x0FFFFFFF)
+#define MIS_GP1DP_gpha(data)                                                         (0x0FFFFFFF&((data)<<0))
+#define MIS_GP1DP_gpha_src(data)                                                     ((0x0FFFFFFF&(data))>>0)
+#define MIS_GP1DP_get_gpha(data)                                                     ((0x0FFFFFFF&(data))>>0)
+
+
+#define MIS_GPDEB                                                                    0x1801B150
+#define MIS_GPDEB_reg_addr                                                           "0xB801B150"
+#define MIS_GPDEB_reg                                                                0xB801B150
+#define set_MIS_GPDEB_reg(data)   (*((volatile unsigned int*) MIS_GPDEB_reg)=data)
+#define get_MIS_GPDEB_reg   (*((volatile unsigned int*) MIS_GPDEB_reg))
+#define MIS_GPDEB_inst_adr                                                           "0x0054"
+#define MIS_GPDEB_inst                                                               0x0054
+#define MIS_GPDEB_write_enable4_shift                                                (15)
+#define MIS_GPDEB_write_enable4_mask                                                 (0x00008000)
+#define MIS_GPDEB_write_enable4(data)                                                (0x00008000&((data)<<15))
+#define MIS_GPDEB_write_enable4_src(data)                                            ((0x00008000&(data))>>15)
+#define MIS_GPDEB_get_write_enable4(data)                                            ((0x00008000&(data))>>15)
+#define MIS_GPDEB_clk4_shift                                                         (12)
+#define MIS_GPDEB_clk4_mask                                                          (0x00007000)
+#define MIS_GPDEB_clk4(data)                                                         (0x00007000&((data)<<12))
+#define MIS_GPDEB_clk4_src(data)                                                     ((0x00007000&(data))>>12)
+#define MIS_GPDEB_get_clk4(data)                                                     ((0x00007000&(data))>>12)
+#define MIS_GPDEB_write_enable3_shift                                                (11)
+#define MIS_GPDEB_write_enable3_mask                                                 (0x00000800)
+#define MIS_GPDEB_write_enable3(data)                                                (0x00000800&((data)<<11))
+#define MIS_GPDEB_write_enable3_src(data)                                            ((0x00000800&(data))>>11)
+#define MIS_GPDEB_get_write_enable3(data)                                            ((0x00000800&(data))>>11)
+#define MIS_GPDEB_clk3_shift                                                         (8)
+#define MIS_GPDEB_clk3_mask                                                          (0x00000700)
+#define MIS_GPDEB_clk3(data)                                                         (0x00000700&((data)<<8))
+#define MIS_GPDEB_clk3_src(data)                                                     ((0x00000700&(data))>>8)
+#define MIS_GPDEB_get_clk3(data)                                                     ((0x00000700&(data))>>8)
+#define MIS_GPDEB_write_enable2_shift                                                (7)
+#define MIS_GPDEB_write_enable2_mask                                                 (0x00000080)
+#define MIS_GPDEB_write_enable2(data)                                                (0x00000080&((data)<<7))
+#define MIS_GPDEB_write_enable2_src(data)                                            ((0x00000080&(data))>>7)
+#define MIS_GPDEB_get_write_enable2(data)                                            ((0x00000080&(data))>>7)
+#define MIS_GPDEB_clk2_shift                                                         (4)
+#define MIS_GPDEB_clk2_mask                                                          (0x00000070)
+#define MIS_GPDEB_clk2(data)                                                         (0x00000070&((data)<<4))
+#define MIS_GPDEB_clk2_src(data)                                                     ((0x00000070&(data))>>4)
+#define MIS_GPDEB_get_clk2(data)                                                     ((0x00000070&(data))>>4)
+#define MIS_GPDEB_write_enable1_shift                                                (3)
+#define MIS_GPDEB_write_enable1_mask                                                 (0x00000008)
+#define MIS_GPDEB_write_enable1(data)                                                (0x00000008&((data)<<3))
+#define MIS_GPDEB_write_enable1_src(data)                                            ((0x00000008&(data))>>3)
+#define MIS_GPDEB_get_write_enable1(data)                                            ((0x00000008&(data))>>3)
+#define MIS_GPDEB_clk1_shift                                                         (0)
+#define MIS_GPDEB_clk1_mask                                                          (0x00000007)
+#define MIS_GPDEB_clk1(data)                                                         (0x00000007&((data)<<0))
+#define MIS_GPDEB_clk1_src(data)                                                     ((0x00000007&(data))>>0)
+#define MIS_GPDEB_get_clk1(data)                                                     ((0x00000007&(data))>>0)
+
+
+#define MIS_U1RBR_THR_DLL                                                            0x1801B200
+#define MIS_U1RBR_THR_DLL_reg_addr                                                   "0xB801B200"
+#define MIS_U1RBR_THR_DLL_reg                                                        0xB801B200
+#define set_MIS_U1RBR_THR_DLL_reg(data)   (*((volatile unsigned int*) MIS_U1RBR_THR_DLL_reg)=data)
+#define get_MIS_U1RBR_THR_DLL_reg   (*((volatile unsigned int*) MIS_U1RBR_THR_DLL_reg))
+#define MIS_U1RBR_THR_DLL_inst_adr                                                   "0x0080"
+#define MIS_U1RBR_THR_DLL_inst                                                       0x0080
+#define MIS_U1RBR_THR_DLL_dll_shift                                                  (0)
+#define MIS_U1RBR_THR_DLL_dll_mask                                                   (0x000000FF)
+#define MIS_U1RBR_THR_DLL_dll(data)                                                  (0x000000FF&((data)<<0))
+#define MIS_U1RBR_THR_DLL_dll_src(data)                                              ((0x000000FF&(data))>>0)
+#define MIS_U1RBR_THR_DLL_get_dll(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define MIS_U1IER_DLH                                                                0x1801B204
+#define MIS_U1IER_DLH_reg_addr                                                       "0xB801B204"
+#define MIS_U1IER_DLH_reg                                                            0xB801B204
+#define set_MIS_U1IER_DLH_reg(data)   (*((volatile unsigned int*) MIS_U1IER_DLH_reg)=data)
+#define get_MIS_U1IER_DLH_reg   (*((volatile unsigned int*) MIS_U1IER_DLH_reg))
+#define MIS_U1IER_DLH_inst_adr                                                       "0x0081"
+#define MIS_U1IER_DLH_inst                                                           0x0081
+#define MIS_U1IER_DLH_dlh_shift                                                      (0)
+#define MIS_U1IER_DLH_dlh_mask                                                       (0x000000FF)
+#define MIS_U1IER_DLH_dlh(data)                                                      (0x000000FF&((data)<<0))
+#define MIS_U1IER_DLH_dlh_src(data)                                                  ((0x000000FF&(data))>>0)
+#define MIS_U1IER_DLH_get_dlh(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define MIS_U1IIR_FCR                                                                0x1801B208
+#define MIS_U1IIR_FCR_reg_addr                                                       "0xB801B208"
+#define MIS_U1IIR_FCR_reg                                                            0xB801B208
+#define set_MIS_U1IIR_FCR_reg(data)   (*((volatile unsigned int*) MIS_U1IIR_FCR_reg)=data)
+#define get_MIS_U1IIR_FCR_reg   (*((volatile unsigned int*) MIS_U1IIR_FCR_reg))
+#define MIS_U1IIR_FCR_inst_adr                                                       "0x0082"
+#define MIS_U1IIR_FCR_inst                                                           0x0082
+#define MIS_U1IIR_FCR_fifo16_shift                                                   (6)
+#define MIS_U1IIR_FCR_fifo16_mask                                                    (0x000000C0)
+#define MIS_U1IIR_FCR_fifo16(data)                                                   (0x000000C0&((data)<<6))
+#define MIS_U1IIR_FCR_fifo16_src(data)                                               ((0x000000C0&(data))>>6)
+#define MIS_U1IIR_FCR_get_fifo16(data)                                               ((0x000000C0&(data))>>6)
+#define MIS_U1IIR_FCR_iid_shift                                                      (0)
+#define MIS_U1IIR_FCR_iid_mask                                                       (0x0000000F)
+#define MIS_U1IIR_FCR_iid(data)                                                      (0x0000000F&((data)<<0))
+#define MIS_U1IIR_FCR_iid_src(data)                                                  ((0x0000000F&(data))>>0)
+#define MIS_U1IIR_FCR_get_iid(data)                                                  ((0x0000000F&(data))>>0)
+
+
+#define MIS_U1LCR                                                                    0x1801B20C
+#define MIS_U1LCR_reg_addr                                                           "0xB801B20C"
+#define MIS_U1LCR_reg                                                                0xB801B20C
+#define set_MIS_U1LCR_reg(data)   (*((volatile unsigned int*) MIS_U1LCR_reg)=data)
+#define get_MIS_U1LCR_reg   (*((volatile unsigned int*) MIS_U1LCR_reg))
+#define MIS_U1LCR_inst_adr                                                           "0x0083"
+#define MIS_U1LCR_inst                                                               0x0083
+#define MIS_U1LCR_dlab_shift                                                         (7)
+#define MIS_U1LCR_dlab_mask                                                          (0x00000080)
+#define MIS_U1LCR_dlab(data)                                                         (0x00000080&((data)<<7))
+#define MIS_U1LCR_dlab_src(data)                                                     ((0x00000080&(data))>>7)
+#define MIS_U1LCR_get_dlab(data)                                                     ((0x00000080&(data))>>7)
+#define MIS_U1LCR_brk_shift                                                          (6)
+#define MIS_U1LCR_brk_mask                                                           (0x00000040)
+#define MIS_U1LCR_brk(data)                                                          (0x00000040&((data)<<6))
+#define MIS_U1LCR_brk_src(data)                                                      ((0x00000040&(data))>>6)
+#define MIS_U1LCR_get_brk(data)                                                      ((0x00000040&(data))>>6)
+#define MIS_U1LCR_eps_shift                                                          (4)
+#define MIS_U1LCR_eps_mask                                                           (0x00000010)
+#define MIS_U1LCR_eps(data)                                                          (0x00000010&((data)<<4))
+#define MIS_U1LCR_eps_src(data)                                                      ((0x00000010&(data))>>4)
+#define MIS_U1LCR_get_eps(data)                                                      ((0x00000010&(data))>>4)
+#define MIS_U1LCR_pen_shift                                                          (3)
+#define MIS_U1LCR_pen_mask                                                           (0x00000008)
+#define MIS_U1LCR_pen(data)                                                          (0x00000008&((data)<<3))
+#define MIS_U1LCR_pen_src(data)                                                      ((0x00000008&(data))>>3)
+#define MIS_U1LCR_get_pen(data)                                                      ((0x00000008&(data))>>3)
+#define MIS_U1LCR_stb_shift                                                          (2)
+#define MIS_U1LCR_stb_mask                                                           (0x00000004)
+#define MIS_U1LCR_stb(data)                                                          (0x00000004&((data)<<2))
+#define MIS_U1LCR_stb_src(data)                                                      ((0x00000004&(data))>>2)
+#define MIS_U1LCR_get_stb(data)                                                      ((0x00000004&(data))>>2)
+#define MIS_U1LCR_wls_shift                                                          (0)
+#define MIS_U1LCR_wls_mask                                                           (0x00000003)
+#define MIS_U1LCR_wls(data)                                                          (0x00000003&((data)<<0))
+#define MIS_U1LCR_wls_src(data)                                                      ((0x00000003&(data))>>0)
+#define MIS_U1LCR_get_wls(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define MIS_U1MCR                                                                    0x1801B210
+#define MIS_U1MCR_reg_addr                                                           "0xB801B210"
+#define MIS_U1MCR_reg                                                                0xB801B210
+#define set_MIS_U1MCR_reg(data)   (*((volatile unsigned int*) MIS_U1MCR_reg)=data)
+#define get_MIS_U1MCR_reg   (*((volatile unsigned int*) MIS_U1MCR_reg))
+#define MIS_U1MCR_inst_adr                                                           "0x0084"
+#define MIS_U1MCR_inst                                                               0x0084
+#define MIS_U1MCR_afce_shift                                                         (5)
+#define MIS_U1MCR_afce_mask                                                          (0x00000020)
+#define MIS_U1MCR_afce(data)                                                         (0x00000020&((data)<<5))
+#define MIS_U1MCR_afce_src(data)                                                     ((0x00000020&(data))>>5)
+#define MIS_U1MCR_get_afce(data)                                                     ((0x00000020&(data))>>5)
+#define MIS_U1MCR_loop_shift                                                         (4)
+#define MIS_U1MCR_loop_mask                                                          (0x00000010)
+#define MIS_U1MCR_loop(data)                                                         (0x00000010&((data)<<4))
+#define MIS_U1MCR_loop_src(data)                                                     ((0x00000010&(data))>>4)
+#define MIS_U1MCR_get_loop(data)                                                     ((0x00000010&(data))>>4)
+#define MIS_U1MCR_rts_shift                                                          (1)
+#define MIS_U1MCR_rts_mask                                                           (0x00000002)
+#define MIS_U1MCR_rts(data)                                                          (0x00000002&((data)<<1))
+#define MIS_U1MCR_rts_src(data)                                                      ((0x00000002&(data))>>1)
+#define MIS_U1MCR_get_rts(data)                                                      ((0x00000002&(data))>>1)
+#define MIS_U1MCR_dtr_shift                                                          (0)
+#define MIS_U1MCR_dtr_mask                                                           (0x00000001)
+#define MIS_U1MCR_dtr(data)                                                          (0x00000001&((data)<<0))
+#define MIS_U1MCR_dtr_src(data)                                                      ((0x00000001&(data))>>0)
+#define MIS_U1MCR_get_dtr(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_U1LSR                                                                    0x1801B214
+#define MIS_U1LSR_reg_addr                                                           "0xB801B214"
+#define MIS_U1LSR_reg                                                                0xB801B214
+#define set_MIS_U1LSR_reg(data)   (*((volatile unsigned int*) MIS_U1LSR_reg)=data)
+#define get_MIS_U1LSR_reg   (*((volatile unsigned int*) MIS_U1LSR_reg))
+#define MIS_U1LSR_inst_adr                                                           "0x0085"
+#define MIS_U1LSR_inst                                                               0x0085
+#define MIS_U1LSR_rfe_shift                                                          (7)
+#define MIS_U1LSR_rfe_mask                                                           (0x00000080)
+#define MIS_U1LSR_rfe(data)                                                          (0x00000080&((data)<<7))
+#define MIS_U1LSR_rfe_src(data)                                                      ((0x00000080&(data))>>7)
+#define MIS_U1LSR_get_rfe(data)                                                      ((0x00000080&(data))>>7)
+#define MIS_U1LSR_temt_shift                                                         (6)
+#define MIS_U1LSR_temt_mask                                                          (0x00000040)
+#define MIS_U1LSR_temt(data)                                                         (0x00000040&((data)<<6))
+#define MIS_U1LSR_temt_src(data)                                                     ((0x00000040&(data))>>6)
+#define MIS_U1LSR_get_temt(data)                                                     ((0x00000040&(data))>>6)
+#define MIS_U1LSR_thre_shift                                                         (5)
+#define MIS_U1LSR_thre_mask                                                          (0x00000020)
+#define MIS_U1LSR_thre(data)                                                         (0x00000020&((data)<<5))
+#define MIS_U1LSR_thre_src(data)                                                     ((0x00000020&(data))>>5)
+#define MIS_U1LSR_get_thre(data)                                                     ((0x00000020&(data))>>5)
+#define MIS_U1LSR_bi_shift                                                           (4)
+#define MIS_U1LSR_bi_mask                                                            (0x00000010)
+#define MIS_U1LSR_bi(data)                                                           (0x00000010&((data)<<4))
+#define MIS_U1LSR_bi_src(data)                                                       ((0x00000010&(data))>>4)
+#define MIS_U1LSR_get_bi(data)                                                       ((0x00000010&(data))>>4)
+#define MIS_U1LSR_fe_shift                                                           (3)
+#define MIS_U1LSR_fe_mask                                                            (0x00000008)
+#define MIS_U1LSR_fe(data)                                                           (0x00000008&((data)<<3))
+#define MIS_U1LSR_fe_src(data)                                                       ((0x00000008&(data))>>3)
+#define MIS_U1LSR_get_fe(data)                                                       ((0x00000008&(data))>>3)
+#define MIS_U1LSR_pe_shift                                                           (2)
+#define MIS_U1LSR_pe_mask                                                            (0x00000004)
+#define MIS_U1LSR_pe(data)                                                           (0x00000004&((data)<<2))
+#define MIS_U1LSR_pe_src(data)                                                       ((0x00000004&(data))>>2)
+#define MIS_U1LSR_get_pe(data)                                                       ((0x00000004&(data))>>2)
+#define MIS_U1LSR_oe_shift                                                           (1)
+#define MIS_U1LSR_oe_mask                                                            (0x00000002)
+#define MIS_U1LSR_oe(data)                                                           (0x00000002&((data)<<1))
+#define MIS_U1LSR_oe_src(data)                                                       ((0x00000002&(data))>>1)
+#define MIS_U1LSR_get_oe(data)                                                       ((0x00000002&(data))>>1)
+#define MIS_U1LSR_dr_shift                                                           (0)
+#define MIS_U1LSR_dr_mask                                                            (0x00000001)
+#define MIS_U1LSR_dr(data)                                                           (0x00000001&((data)<<0))
+#define MIS_U1LSR_dr_src(data)                                                       ((0x00000001&(data))>>0)
+#define MIS_U1LSR_get_dr(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_U1MSR                                                                    0x1801B218
+#define MIS_U1MSR_reg_addr                                                           "0xB801B218"
+#define MIS_U1MSR_reg                                                                0xB801B218
+#define set_MIS_U1MSR_reg(data)   (*((volatile unsigned int*) MIS_U1MSR_reg)=data)
+#define get_MIS_U1MSR_reg   (*((volatile unsigned int*) MIS_U1MSR_reg))
+#define MIS_U1MSR_inst_adr                                                           "0x0086"
+#define MIS_U1MSR_inst                                                               0x0086
+#define MIS_U1MSR_dcd_shift                                                          (7)
+#define MIS_U1MSR_dcd_mask                                                           (0x00000080)
+#define MIS_U1MSR_dcd(data)                                                          (0x00000080&((data)<<7))
+#define MIS_U1MSR_dcd_src(data)                                                      ((0x00000080&(data))>>7)
+#define MIS_U1MSR_get_dcd(data)                                                      ((0x00000080&(data))>>7)
+#define MIS_U1MSR_ri_shift                                                           (6)
+#define MIS_U1MSR_ri_mask                                                            (0x00000040)
+#define MIS_U1MSR_ri(data)                                                           (0x00000040&((data)<<6))
+#define MIS_U1MSR_ri_src(data)                                                       ((0x00000040&(data))>>6)
+#define MIS_U1MSR_get_ri(data)                                                       ((0x00000040&(data))>>6)
+#define MIS_U1MSR_dsr_shift                                                          (5)
+#define MIS_U1MSR_dsr_mask                                                           (0x00000020)
+#define MIS_U1MSR_dsr(data)                                                          (0x00000020&((data)<<5))
+#define MIS_U1MSR_dsr_src(data)                                                      ((0x00000020&(data))>>5)
+#define MIS_U1MSR_get_dsr(data)                                                      ((0x00000020&(data))>>5)
+#define MIS_U1MSR_cts_shift                                                          (4)
+#define MIS_U1MSR_cts_mask                                                           (0x00000010)
+#define MIS_U1MSR_cts(data)                                                          (0x00000010&((data)<<4))
+#define MIS_U1MSR_cts_src(data)                                                      ((0x00000010&(data))>>4)
+#define MIS_U1MSR_get_cts(data)                                                      ((0x00000010&(data))>>4)
+#define MIS_U1MSR_ddcd_shift                                                         (3)
+#define MIS_U1MSR_ddcd_mask                                                          (0x00000008)
+#define MIS_U1MSR_ddcd(data)                                                         (0x00000008&((data)<<3))
+#define MIS_U1MSR_ddcd_src(data)                                                     ((0x00000008&(data))>>3)
+#define MIS_U1MSR_get_ddcd(data)                                                     ((0x00000008&(data))>>3)
+#define MIS_U1MSR_teri_shift                                                         (2)
+#define MIS_U1MSR_teri_mask                                                          (0x00000004)
+#define MIS_U1MSR_teri(data)                                                         (0x00000004&((data)<<2))
+#define MIS_U1MSR_teri_src(data)                                                     ((0x00000004&(data))>>2)
+#define MIS_U1MSR_get_teri(data)                                                     ((0x00000004&(data))>>2)
+#define MIS_U1MSR_ddsr_shift                                                         (1)
+#define MIS_U1MSR_ddsr_mask                                                          (0x00000002)
+#define MIS_U1MSR_ddsr(data)                                                         (0x00000002&((data)<<1))
+#define MIS_U1MSR_ddsr_src(data)                                                     ((0x00000002&(data))>>1)
+#define MIS_U1MSR_get_ddsr(data)                                                     ((0x00000002&(data))>>1)
+#define MIS_U1MSR_dcts_shift                                                         (0)
+#define MIS_U1MSR_dcts_mask                                                          (0x00000001)
+#define MIS_U1MSR_dcts(data)                                                         (0x00000001&((data)<<0))
+#define MIS_U1MSR_dcts_src(data)                                                     ((0x00000001&(data))>>0)
+#define MIS_U1MSR_get_dcts(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define MIS_U1SCR                                                                    0x1801B21C
+#define MIS_U1SCR_reg_addr                                                           "0xB801B21C"
+#define MIS_U1SCR_reg                                                                0xB801B21C
+#define set_MIS_U1SCR_reg(data)   (*((volatile unsigned int*) MIS_U1SCR_reg)=data)
+#define get_MIS_U1SCR_reg   (*((volatile unsigned int*) MIS_U1SCR_reg))
+#define MIS_U1SCR_inst_adr                                                           "0x0087"
+#define MIS_U1SCR_inst                                                               0x0087
+#define MIS_U1SCR_scr_shift                                                          (0)
+#define MIS_U1SCR_scr_mask                                                           (0x000000FF)
+#define MIS_U1SCR_scr(data)                                                          (0x000000FF&((data)<<0))
+#define MIS_U1SCR_scr_src(data)                                                      ((0x000000FF&(data))>>0)
+#define MIS_U1SCR_get_scr(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define MIS_U1SRBR_0                                                                 0x1801B230
+#define MIS_U1SRBR_1                                                                 0x1801B234
+#define MIS_U1SRBR_2                                                                 0x1801B238
+#define MIS_U1SRBR_3                                                                 0x1801B23C
+#define MIS_U1SRBR_4                                                                 0x1801B240
+#define MIS_U1SRBR_5                                                                 0x1801B244
+#define MIS_U1SRBR_6                                                                 0x1801B248
+#define MIS_U1SRBR_7                                                                 0x1801B24C
+#define MIS_U1SRBR_8                                                                 0x1801B250
+#define MIS_U1SRBR_9                                                                 0x1801B254
+#define MIS_U1SRBR_10                                                                 0x1801B258
+#define MIS_U1SRBR_11                                                                 0x1801B25C
+#define MIS_U1SRBR_12                                                                 0x1801B260
+#define MIS_U1SRBR_13                                                                 0x1801B264
+#define MIS_U1SRBR_14                                                                 0x1801B268
+#define MIS_U1SRBR_15                                                                 0x1801B26C
+#define MIS_U1SRBR_0_reg_addr                                                        "0xB801B230"
+#define MIS_U1SRBR_1_reg_addr                                                        "0xB801B234"
+#define MIS_U1SRBR_2_reg_addr                                                        "0xB801B238"
+#define MIS_U1SRBR_3_reg_addr                                                        "0xB801B23C"
+#define MIS_U1SRBR_4_reg_addr                                                        "0xB801B240"
+#define MIS_U1SRBR_5_reg_addr                                                        "0xB801B244"
+#define MIS_U1SRBR_6_reg_addr                                                        "0xB801B248"
+#define MIS_U1SRBR_7_reg_addr                                                        "0xB801B24C"
+#define MIS_U1SRBR_8_reg_addr                                                        "0xB801B250"
+#define MIS_U1SRBR_9_reg_addr                                                        "0xB801B254"
+#define MIS_U1SRBR_10_reg_addr                                                        "0xB801B258"
+#define MIS_U1SRBR_11_reg_addr                                                        "0xB801B25C"
+#define MIS_U1SRBR_12_reg_addr                                                        "0xB801B260"
+#define MIS_U1SRBR_13_reg_addr                                                        "0xB801B264"
+#define MIS_U1SRBR_14_reg_addr                                                        "0xB801B268"
+#define MIS_U1SRBR_15_reg_addr                                                        "0xB801B26C"
+#define MIS_U1SRBR_0_reg                                                             0xB801B230
+#define MIS_U1SRBR_1_reg                                                             0xB801B234
+#define MIS_U1SRBR_2_reg                                                             0xB801B238
+#define MIS_U1SRBR_3_reg                                                             0xB801B23C
+#define MIS_U1SRBR_4_reg                                                             0xB801B240
+#define MIS_U1SRBR_5_reg                                                             0xB801B244
+#define MIS_U1SRBR_6_reg                                                             0xB801B248
+#define MIS_U1SRBR_7_reg                                                             0xB801B24C
+#define MIS_U1SRBR_8_reg                                                             0xB801B250
+#define MIS_U1SRBR_9_reg                                                             0xB801B254
+#define MIS_U1SRBR_10_reg                                                             0xB801B258
+#define MIS_U1SRBR_11_reg                                                             0xB801B25C
+#define MIS_U1SRBR_12_reg                                                             0xB801B260
+#define MIS_U1SRBR_13_reg                                                             0xB801B264
+#define MIS_U1SRBR_14_reg                                                             0xB801B268
+#define MIS_U1SRBR_15_reg                                                             0xB801B26C
+#define set_MIS_U1SRBR_0_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_0_reg)=data)
+#define set_MIS_U1SRBR_1_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_1_reg)=data)
+#define set_MIS_U1SRBR_2_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_2_reg)=data)
+#define set_MIS_U1SRBR_3_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_3_reg)=data)
+#define set_MIS_U1SRBR_4_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_4_reg)=data)
+#define set_MIS_U1SRBR_5_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_5_reg)=data)
+#define set_MIS_U1SRBR_6_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_6_reg)=data)
+#define set_MIS_U1SRBR_7_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_7_reg)=data)
+#define set_MIS_U1SRBR_8_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_8_reg)=data)
+#define set_MIS_U1SRBR_9_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_9_reg)=data)
+#define set_MIS_U1SRBR_10_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_10_reg)=data)
+#define set_MIS_U1SRBR_11_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_11_reg)=data)
+#define set_MIS_U1SRBR_12_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_12_reg)=data)
+#define set_MIS_U1SRBR_13_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_13_reg)=data)
+#define set_MIS_U1SRBR_14_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_14_reg)=data)
+#define set_MIS_U1SRBR_15_reg(data)   (*((volatile unsigned int*) MIS_U1SRBR_15_reg)=data)
+#define get_MIS_U1SRBR_0_reg   (*((volatile unsigned int*) MIS_U1SRBR_0_reg))
+#define get_MIS_U1SRBR_1_reg   (*((volatile unsigned int*) MIS_U1SRBR_1_reg))
+#define get_MIS_U1SRBR_2_reg   (*((volatile unsigned int*) MIS_U1SRBR_2_reg))
+#define get_MIS_U1SRBR_3_reg   (*((volatile unsigned int*) MIS_U1SRBR_3_reg))
+#define get_MIS_U1SRBR_4_reg   (*((volatile unsigned int*) MIS_U1SRBR_4_reg))
+#define get_MIS_U1SRBR_5_reg   (*((volatile unsigned int*) MIS_U1SRBR_5_reg))
+#define get_MIS_U1SRBR_6_reg   (*((volatile unsigned int*) MIS_U1SRBR_6_reg))
+#define get_MIS_U1SRBR_7_reg   (*((volatile unsigned int*) MIS_U1SRBR_7_reg))
+#define get_MIS_U1SRBR_8_reg   (*((volatile unsigned int*) MIS_U1SRBR_8_reg))
+#define get_MIS_U1SRBR_9_reg   (*((volatile unsigned int*) MIS_U1SRBR_9_reg))
+#define get_MIS_U1SRBR_10_reg   (*((volatile unsigned int*) MIS_U1SRBR_10_reg))
+#define get_MIS_U1SRBR_11_reg   (*((volatile unsigned int*) MIS_U1SRBR_11_reg))
+#define get_MIS_U1SRBR_12_reg   (*((volatile unsigned int*) MIS_U1SRBR_12_reg))
+#define get_MIS_U1SRBR_13_reg   (*((volatile unsigned int*) MIS_U1SRBR_13_reg))
+#define get_MIS_U1SRBR_14_reg   (*((volatile unsigned int*) MIS_U1SRBR_14_reg))
+#define get_MIS_U1SRBR_15_reg   (*((volatile unsigned int*) MIS_U1SRBR_15_reg))
+#define MIS_U1SRBR_0_inst_adr                                                        "0x008C"
+#define MIS_U1SRBR_1_inst_adr                                                        "0x008D"
+#define MIS_U1SRBR_2_inst_adr                                                        "0x008E"
+#define MIS_U1SRBR_3_inst_adr                                                        "0x008F"
+#define MIS_U1SRBR_4_inst_adr                                                        "0x0090"
+#define MIS_U1SRBR_5_inst_adr                                                        "0x0091"
+#define MIS_U1SRBR_6_inst_adr                                                        "0x0092"
+#define MIS_U1SRBR_7_inst_adr                                                        "0x0093"
+#define MIS_U1SRBR_8_inst_adr                                                        "0x0094"
+#define MIS_U1SRBR_9_inst_adr                                                        "0x0095"
+#define MIS_U1SRBR_10_inst_adr                                                        "0x0096"
+#define MIS_U1SRBR_11_inst_adr                                                        "0x0097"
+#define MIS_U1SRBR_12_inst_adr                                                        "0x0098"
+#define MIS_U1SRBR_13_inst_adr                                                        "0x0099"
+#define MIS_U1SRBR_14_inst_adr                                                        "0x009A"
+#define MIS_U1SRBR_15_inst_adr                                                        "0x009B"
+#define MIS_U1SRBR_0_inst                                                            0x008C
+#define MIS_U1SRBR_1_inst                                                            0x008D
+#define MIS_U1SRBR_2_inst                                                            0x008E
+#define MIS_U1SRBR_3_inst                                                            0x008F
+#define MIS_U1SRBR_4_inst                                                            0x0090
+#define MIS_U1SRBR_5_inst                                                            0x0091
+#define MIS_U1SRBR_6_inst                                                            0x0092
+#define MIS_U1SRBR_7_inst                                                            0x0093
+#define MIS_U1SRBR_8_inst                                                            0x0094
+#define MIS_U1SRBR_9_inst                                                            0x0095
+#define MIS_U1SRBR_10_inst                                                            0x0096
+#define MIS_U1SRBR_11_inst                                                            0x0097
+#define MIS_U1SRBR_12_inst                                                            0x0098
+#define MIS_U1SRBR_13_inst                                                            0x0099
+#define MIS_U1SRBR_14_inst                                                            0x009A
+#define MIS_U1SRBR_15_inst                                                            0x009B
+#define MIS_U1SRBR_rbd_shift                                                         (0)
+#define MIS_U1SRBR_rbd_mask                                                          (0x000000FF)
+#define MIS_U1SRBR_rbd(data)                                                         (0x000000FF&((data)<<0))
+#define MIS_U1SRBR_rbd_src(data)                                                     ((0x000000FF&(data))>>0)
+#define MIS_U1SRBR_get_rbd(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define MIS_U1FAR                                                                    0x1801B270
+#define MIS_U1FAR_reg_addr                                                           "0xB801B270"
+#define MIS_U1FAR_reg                                                                0xB801B270
+#define set_MIS_U1FAR_reg(data)   (*((volatile unsigned int*) MIS_U1FAR_reg)=data)
+#define get_MIS_U1FAR_reg   (*((volatile unsigned int*) MIS_U1FAR_reg))
+#define MIS_U1FAR_inst_adr                                                           "0x009C"
+#define MIS_U1FAR_inst                                                               0x009C
+#define MIS_U1FAR_far_shift                                                          (0)
+#define MIS_U1FAR_far_mask                                                           (0x00000001)
+#define MIS_U1FAR_far(data)                                                          (0x00000001&((data)<<0))
+#define MIS_U1FAR_far_src(data)                                                      ((0x00000001&(data))>>0)
+#define MIS_U1FAR_get_far(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_U1TFR                                                                    0x1801B274
+#define MIS_U1TFR_reg_addr                                                           "0xB801B274"
+#define MIS_U1TFR_reg                                                                0xB801B274
+#define set_MIS_U1TFR_reg(data)   (*((volatile unsigned int*) MIS_U1TFR_reg)=data)
+#define get_MIS_U1TFR_reg   (*((volatile unsigned int*) MIS_U1TFR_reg))
+#define MIS_U1TFR_inst_adr                                                           "0x009D"
+#define MIS_U1TFR_inst                                                               0x009D
+#define MIS_U1TFR_far_shift                                                          (0)
+#define MIS_U1TFR_far_mask                                                           (0x000000FF)
+#define MIS_U1TFR_far(data)                                                          (0x000000FF&((data)<<0))
+#define MIS_U1TFR_far_src(data)                                                      ((0x000000FF&(data))>>0)
+#define MIS_U1TFR_get_far(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define MIS_U1RFW                                                                    0x1801B278
+#define MIS_U1RFW_reg_addr                                                           "0xB801B278"
+#define MIS_U1RFW_reg                                                                0xB801B278
+#define set_MIS_U1RFW_reg(data)   (*((volatile unsigned int*) MIS_U1RFW_reg)=data)
+#define get_MIS_U1RFW_reg   (*((volatile unsigned int*) MIS_U1RFW_reg))
+#define MIS_U1RFW_inst_adr                                                           "0x009E"
+#define MIS_U1RFW_inst                                                               0x009E
+#define MIS_U1RFW_rffe_shift                                                         (9)
+#define MIS_U1RFW_rffe_mask                                                          (0x00000200)
+#define MIS_U1RFW_rffe(data)                                                         (0x00000200&((data)<<9))
+#define MIS_U1RFW_rffe_src(data)                                                     ((0x00000200&(data))>>9)
+#define MIS_U1RFW_get_rffe(data)                                                     ((0x00000200&(data))>>9)
+#define MIS_U1RFW_rfpf_shift                                                         (8)
+#define MIS_U1RFW_rfpf_mask                                                          (0x00000100)
+#define MIS_U1RFW_rfpf(data)                                                         (0x00000100&((data)<<8))
+#define MIS_U1RFW_rfpf_src(data)                                                     ((0x00000100&(data))>>8)
+#define MIS_U1RFW_get_rfpf(data)                                                     ((0x00000100&(data))>>8)
+#define MIS_U1RFW_rfwd_shift                                                         (0)
+#define MIS_U1RFW_rfwd_mask                                                          (0x000000FF)
+#define MIS_U1RFW_rfwd(data)                                                         (0x000000FF&((data)<<0))
+#define MIS_U1RFW_rfwd_src(data)                                                     ((0x000000FF&(data))>>0)
+#define MIS_U1RFW_get_rfwd(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define MIS_U1USR                                                                    0x1801B27C
+#define MIS_U1USR_reg_addr                                                           "0xB801B27C"
+#define MIS_U1USR_reg                                                                0xB801B27C
+#define set_MIS_U1USR_reg(data)   (*((volatile unsigned int*) MIS_U1USR_reg)=data)
+#define get_MIS_U1USR_reg   (*((volatile unsigned int*) MIS_U1USR_reg))
+#define MIS_U1USR_inst_adr                                                           "0x009F"
+#define MIS_U1USR_inst                                                               0x009F
+#define MIS_U1USR_rff_shift                                                          (4)
+#define MIS_U1USR_rff_mask                                                           (0x00000010)
+#define MIS_U1USR_rff(data)                                                          (0x00000010&((data)<<4))
+#define MIS_U1USR_rff_src(data)                                                      ((0x00000010&(data))>>4)
+#define MIS_U1USR_get_rff(data)                                                      ((0x00000010&(data))>>4)
+#define MIS_U1USR_rfne_shift                                                         (3)
+#define MIS_U1USR_rfne_mask                                                          (0x00000008)
+#define MIS_U1USR_rfne(data)                                                         (0x00000008&((data)<<3))
+#define MIS_U1USR_rfne_src(data)                                                     ((0x00000008&(data))>>3)
+#define MIS_U1USR_get_rfne(data)                                                     ((0x00000008&(data))>>3)
+#define MIS_U1USR_tfe_shift                                                          (2)
+#define MIS_U1USR_tfe_mask                                                           (0x00000004)
+#define MIS_U1USR_tfe(data)                                                          (0x00000004&((data)<<2))
+#define MIS_U1USR_tfe_src(data)                                                      ((0x00000004&(data))>>2)
+#define MIS_U1USR_get_tfe(data)                                                      ((0x00000004&(data))>>2)
+#define MIS_U1USR_tfnf_shift                                                         (1)
+#define MIS_U1USR_tfnf_mask                                                          (0x00000002)
+#define MIS_U1USR_tfnf(data)                                                         (0x00000002&((data)<<1))
+#define MIS_U1USR_tfnf_src(data)                                                     ((0x00000002&(data))>>1)
+#define MIS_U1USR_get_tfnf(data)                                                     ((0x00000002&(data))>>1)
+#define MIS_U1USR_busy_shift                                                         (0)
+#define MIS_U1USR_busy_mask                                                          (0x00000001)
+#define MIS_U1USR_busy(data)                                                         (0x00000001&((data)<<0))
+#define MIS_U1USR_busy_src(data)                                                     ((0x00000001&(data))>>0)
+#define MIS_U1USR_get_busy(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define MIS_U1TFL                                                                    0x1801B280
+#define MIS_U1TFL_reg_addr                                                           "0xB801B280"
+#define MIS_U1TFL_reg                                                                0xB801B280
+#define set_MIS_U1TFL_reg(data)   (*((volatile unsigned int*) MIS_U1TFL_reg)=data)
+#define get_MIS_U1TFL_reg   (*((volatile unsigned int*) MIS_U1TFL_reg))
+#define MIS_U1TFL_inst_adr                                                           "0x00A0"
+#define MIS_U1TFL_inst                                                               0x00A0
+#define MIS_U1TFL_tfl_shift                                                          (0)
+#define MIS_U1TFL_tfl_mask                                                           (0x000000FF)
+#define MIS_U1TFL_tfl(data)                                                          (0x000000FF&((data)<<0))
+#define MIS_U1TFL_tfl_src(data)                                                      ((0x000000FF&(data))>>0)
+#define MIS_U1TFL_get_tfl(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define MIS_U1RFL                                                                    0x1801B284
+#define MIS_U1RFL_reg_addr                                                           "0xB801B284"
+#define MIS_U1RFL_reg                                                                0xB801B284
+#define set_MIS_U1RFL_reg(data)   (*((volatile unsigned int*) MIS_U1RFL_reg)=data)
+#define get_MIS_U1RFL_reg   (*((volatile unsigned int*) MIS_U1RFL_reg))
+#define MIS_U1RFL_inst_adr                                                           "0x00A1"
+#define MIS_U1RFL_inst                                                               0x00A1
+#define MIS_U1RFL_rfl_shift                                                          (0)
+#define MIS_U1RFL_rfl_mask                                                           (0x000000FF)
+#define MIS_U1RFL_rfl(data)                                                          (0x000000FF&((data)<<0))
+#define MIS_U1RFL_rfl_src(data)                                                      ((0x000000FF&(data))>>0)
+#define MIS_U1RFL_get_rfl(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define MIS_U1SRR                                                                    0x1801B288
+#define MIS_U1SRR_reg_addr                                                           "0xB801B288"
+#define MIS_U1SRR_reg                                                                0xB801B288
+#define set_MIS_U1SRR_reg(data)   (*((volatile unsigned int*) MIS_U1SRR_reg)=data)
+#define get_MIS_U1SRR_reg   (*((volatile unsigned int*) MIS_U1SRR_reg))
+#define MIS_U1SRR_inst_adr                                                           "0x00A2"
+#define MIS_U1SRR_inst                                                               0x00A2
+#define MIS_U1SRR_xfr_shift                                                          (2)
+#define MIS_U1SRR_xfr_mask                                                           (0x00000004)
+#define MIS_U1SRR_xfr(data)                                                          (0x00000004&((data)<<2))
+#define MIS_U1SRR_xfr_src(data)                                                      ((0x00000004&(data))>>2)
+#define MIS_U1SRR_get_xfr(data)                                                      ((0x00000004&(data))>>2)
+#define MIS_U1SRR_rfr_shift                                                          (1)
+#define MIS_U1SRR_rfr_mask                                                           (0x00000002)
+#define MIS_U1SRR_rfr(data)                                                          (0x00000002&((data)<<1))
+#define MIS_U1SRR_rfr_src(data)                                                      ((0x00000002&(data))>>1)
+#define MIS_U1SRR_get_rfr(data)                                                      ((0x00000002&(data))>>1)
+#define MIS_U1SRR_ur_shift                                                           (0)
+#define MIS_U1SRR_ur_mask                                                            (0x00000001)
+#define MIS_U1SRR_ur(data)                                                           (0x00000001&((data)<<0))
+#define MIS_U1SRR_ur_src(data)                                                       ((0x00000001&(data))>>0)
+#define MIS_U1SRR_get_ur(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_U1SBCR                                                                   0x1801B290
+#define MIS_U1SBCR_reg_addr                                                          "0xB801B290"
+#define MIS_U1SBCR_reg                                                               0xB801B290
+#define set_MIS_U1SBCR_reg(data)   (*((volatile unsigned int*) MIS_U1SBCR_reg)=data)
+#define get_MIS_U1SBCR_reg   (*((volatile unsigned int*) MIS_U1SBCR_reg))
+#define MIS_U1SBCR_inst_adr                                                          "0x00A4"
+#define MIS_U1SBCR_inst                                                              0x00A4
+#define MIS_U1SBCR_sbcr_shift                                                        (0)
+#define MIS_U1SBCR_sbcr_mask                                                         (0x00000001)
+#define MIS_U1SBCR_sbcr(data)                                                        (0x00000001&((data)<<0))
+#define MIS_U1SBCR_sbcr_src(data)                                                    ((0x00000001&(data))>>0)
+#define MIS_U1SBCR_get_sbcr(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_U1SDMAM                                                                  0x1801B294
+#define MIS_U1SDMAM_reg_addr                                                         "0xB801B294"
+#define MIS_U1SDMAM_reg                                                              0xB801B294
+#define set_MIS_U1SDMAM_reg(data)   (*((volatile unsigned int*) MIS_U1SDMAM_reg)=data)
+#define get_MIS_U1SDMAM_reg   (*((volatile unsigned int*) MIS_U1SDMAM_reg))
+#define MIS_U1SDMAM_inst_adr                                                         "0x00A5"
+#define MIS_U1SDMAM_inst                                                             0x00A5
+#define MIS_U1SDMAM_sdmam_shift                                                      (0)
+#define MIS_U1SDMAM_sdmam_mask                                                       (0x00000001)
+#define MIS_U1SDMAM_sdmam(data)                                                      (0x00000001&((data)<<0))
+#define MIS_U1SDMAM_sdmam_src(data)                                                  ((0x00000001&(data))>>0)
+#define MIS_U1SDMAM_get_sdmam(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_U1SFE                                                                    0x1801B298
+#define MIS_U1SFE_reg_addr                                                           "0xB801B298"
+#define MIS_U1SFE_reg                                                                0xB801B298
+#define set_MIS_U1SFE_reg(data)   (*((volatile unsigned int*) MIS_U1SFE_reg)=data)
+#define get_MIS_U1SFE_reg   (*((volatile unsigned int*) MIS_U1SFE_reg))
+#define MIS_U1SFE_inst_adr                                                           "0x00A6"
+#define MIS_U1SFE_inst                                                               0x00A6
+#define MIS_U1SFE_sfe_shift                                                          (0)
+#define MIS_U1SFE_sfe_mask                                                           (0x00000001)
+#define MIS_U1SFE_sfe(data)                                                          (0x00000001&((data)<<0))
+#define MIS_U1SFE_sfe_src(data)                                                      ((0x00000001&(data))>>0)
+#define MIS_U1SFE_get_sfe(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_U1SRT                                                                    0x1801B29C
+#define MIS_U1SRT_reg_addr                                                           "0xB801B29C"
+#define MIS_U1SRT_reg                                                                0xB801B29C
+#define set_MIS_U1SRT_reg(data)   (*((volatile unsigned int*) MIS_U1SRT_reg)=data)
+#define get_MIS_U1SRT_reg   (*((volatile unsigned int*) MIS_U1SRT_reg))
+#define MIS_U1SRT_inst_adr                                                           "0x00A7"
+#define MIS_U1SRT_inst                                                               0x00A7
+#define MIS_U1SRT_srt_shift                                                          (0)
+#define MIS_U1SRT_srt_mask                                                           (0x00000003)
+#define MIS_U1SRT_srt(data)                                                          (0x00000003&((data)<<0))
+#define MIS_U1SRT_srt_src(data)                                                      ((0x00000003&(data))>>0)
+#define MIS_U1SRT_get_srt(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define MIS_U1STET                                                                   0x1801B2A0
+#define MIS_U1STET_reg_addr                                                          "0xB801B2A0"
+#define MIS_U1STET_reg                                                               0xB801B2A0
+#define set_MIS_U1STET_reg(data)   (*((volatile unsigned int*) MIS_U1STET_reg)=data)
+#define get_MIS_U1STET_reg   (*((volatile unsigned int*) MIS_U1STET_reg))
+#define MIS_U1STET_inst_adr                                                          "0x00A8"
+#define MIS_U1STET_inst                                                              0x00A8
+#define MIS_U1STET_stet_shift                                                        (0)
+#define MIS_U1STET_stet_mask                                                         (0x00000003)
+#define MIS_U1STET_stet(data)                                                        (0x00000003&((data)<<0))
+#define MIS_U1STET_stet_src(data)                                                    ((0x00000003&(data))>>0)
+#define MIS_U1STET_get_stet(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define MIS_U1HTX                                                                    0x1801B2A4
+#define MIS_U1HTX_reg_addr                                                           "0xB801B2A4"
+#define MIS_U1HTX_reg                                                                0xB801B2A4
+#define set_MIS_U1HTX_reg(data)   (*((volatile unsigned int*) MIS_U1HTX_reg)=data)
+#define get_MIS_U1HTX_reg   (*((volatile unsigned int*) MIS_U1HTX_reg))
+#define MIS_U1HTX_inst_adr                                                           "0x00A9"
+#define MIS_U1HTX_inst                                                               0x00A9
+#define MIS_U1HTX_htx_shift                                                          (0)
+#define MIS_U1HTX_htx_mask                                                           (0x00000001)
+#define MIS_U1HTX_htx(data)                                                          (0x00000001&((data)<<0))
+#define MIS_U1HTX_htx_src(data)                                                      ((0x00000001&(data))>>0)
+#define MIS_U1HTX_get_htx(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_U1DMASA                                                                  0x1801B2A8
+#define MIS_U1DMASA_reg_addr                                                         "0xB801B2A8"
+#define MIS_U1DMASA_reg                                                              0xB801B2A8
+#define set_MIS_U1DMASA_reg(data)   (*((volatile unsigned int*) MIS_U1DMASA_reg)=data)
+#define get_MIS_U1DMASA_reg   (*((volatile unsigned int*) MIS_U1DMASA_reg))
+#define MIS_U1DMASA_inst_adr                                                         "0x00AA"
+#define MIS_U1DMASA_inst                                                             0x00AA
+#define MIS_U1DMASA_dmasa_shift                                                      (0)
+#define MIS_U1DMASA_dmasa_mask                                                       (0x00000001)
+#define MIS_U1DMASA_dmasa(data)                                                      (0x00000001&((data)<<0))
+#define MIS_U1DMASA_dmasa_src(data)                                                  ((0x00000001&(data))>>0)
+#define MIS_U1DMASA_get_dmasa(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_U1CPR                                                                    0x1801B2F4
+#define MIS_U1CPR_reg_addr                                                           "0xB801B2F4"
+#define MIS_U1CPR_reg                                                                0xB801B2F4
+#define set_MIS_U1CPR_reg(data)   (*((volatile unsigned int*) MIS_U1CPR_reg)=data)
+#define get_MIS_U1CPR_reg   (*((volatile unsigned int*) MIS_U1CPR_reg))
+#define MIS_U1CPR_inst_adr                                                           "0x00BD"
+#define MIS_U1CPR_inst                                                               0x00BD
+#define MIS_U1CPR_fifo_mode_shift                                                    (16)
+#define MIS_U1CPR_fifo_mode_mask                                                     (0x00FF0000)
+#define MIS_U1CPR_fifo_mode(data)                                                    (0x00FF0000&((data)<<16))
+#define MIS_U1CPR_fifo_mode_src(data)                                                ((0x00FF0000&(data))>>16)
+#define MIS_U1CPR_get_fifo_mode(data)                                                ((0x00FF0000&(data))>>16)
+#define MIS_U1CPR_dma_extra_shift                                                    (13)
+#define MIS_U1CPR_dma_extra_mask                                                     (0x00002000)
+#define MIS_U1CPR_dma_extra(data)                                                    (0x00002000&((data)<<13))
+#define MIS_U1CPR_dma_extra_src(data)                                                ((0x00002000&(data))>>13)
+#define MIS_U1CPR_get_dma_extra(data)                                                ((0x00002000&(data))>>13)
+#define MIS_U1CPR_uart_add_encoded_params_shift                                      (12)
+#define MIS_U1CPR_uart_add_encoded_params_mask                                       (0x00001000)
+#define MIS_U1CPR_uart_add_encoded_params(data)                                      (0x00001000&((data)<<12))
+#define MIS_U1CPR_uart_add_encoded_params_src(data)                                  ((0x00001000&(data))>>12)
+#define MIS_U1CPR_get_uart_add_encoded_params(data)                                  ((0x00001000&(data))>>12)
+#define MIS_U1CPR_shadow_shift                                                       (11)
+#define MIS_U1CPR_shadow_mask                                                        (0x00000800)
+#define MIS_U1CPR_shadow(data)                                                       (0x00000800&((data)<<11))
+#define MIS_U1CPR_shadow_src(data)                                                   ((0x00000800&(data))>>11)
+#define MIS_U1CPR_get_shadow(data)                                                   ((0x00000800&(data))>>11)
+#define MIS_U1CPR_fifo_stat_shift                                                    (10)
+#define MIS_U1CPR_fifo_stat_mask                                                     (0x00000400)
+#define MIS_U1CPR_fifo_stat(data)                                                    (0x00000400&((data)<<10))
+#define MIS_U1CPR_fifo_stat_src(data)                                                ((0x00000400&(data))>>10)
+#define MIS_U1CPR_get_fifo_stat(data)                                                ((0x00000400&(data))>>10)
+#define MIS_U1CPR_fifo_access_shift                                                  (9)
+#define MIS_U1CPR_fifo_access_mask                                                   (0x00000200)
+#define MIS_U1CPR_fifo_access(data)                                                  (0x00000200&((data)<<9))
+#define MIS_U1CPR_fifo_access_src(data)                                              ((0x00000200&(data))>>9)
+#define MIS_U1CPR_get_fifo_access(data)                                              ((0x00000200&(data))>>9)
+#define MIS_U1CPR_additional_feat_shift                                              (8)
+#define MIS_U1CPR_additional_feat_mask                                               (0x00000100)
+#define MIS_U1CPR_additional_feat(data)                                              (0x00000100&((data)<<8))
+#define MIS_U1CPR_additional_feat_src(data)                                          ((0x00000100&(data))>>8)
+#define MIS_U1CPR_get_additional_feat(data)                                          ((0x00000100&(data))>>8)
+#define MIS_U1CPR_sir_lp_mode_shift                                                  (7)
+#define MIS_U1CPR_sir_lp_mode_mask                                                   (0x00000080)
+#define MIS_U1CPR_sir_lp_mode(data)                                                  (0x00000080&((data)<<7))
+#define MIS_U1CPR_sir_lp_mode_src(data)                                              ((0x00000080&(data))>>7)
+#define MIS_U1CPR_get_sir_lp_mode(data)                                              ((0x00000080&(data))>>7)
+#define MIS_U1CPR_sir_mode_shift                                                     (6)
+#define MIS_U1CPR_sir_mode_mask                                                      (0x00000040)
+#define MIS_U1CPR_sir_mode(data)                                                     (0x00000040&((data)<<6))
+#define MIS_U1CPR_sir_mode_src(data)                                                 ((0x00000040&(data))>>6)
+#define MIS_U1CPR_get_sir_mode(data)                                                 ((0x00000040&(data))>>6)
+#define MIS_U1CPR_thre_mode_shift                                                    (5)
+#define MIS_U1CPR_thre_mode_mask                                                     (0x00000020)
+#define MIS_U1CPR_thre_mode(data)                                                    (0x00000020&((data)<<5))
+#define MIS_U1CPR_thre_mode_src(data)                                                ((0x00000020&(data))>>5)
+#define MIS_U1CPR_get_thre_mode(data)                                                ((0x00000020&(data))>>5)
+#define MIS_U1CPR_afce_mode_shift                                                    (4)
+#define MIS_U1CPR_afce_mode_mask                                                     (0x00000010)
+#define MIS_U1CPR_afce_mode(data)                                                    (0x00000010&((data)<<4))
+#define MIS_U1CPR_afce_mode_src(data)                                                ((0x00000010&(data))>>4)
+#define MIS_U1CPR_get_afce_mode(data)                                                ((0x00000010&(data))>>4)
+#define MIS_U1CPR_apb_data_width_shift                                               (0)
+#define MIS_U1CPR_apb_data_width_mask                                                (0x00000003)
+#define MIS_U1CPR_apb_data_width(data)                                               (0x00000003&((data)<<0))
+#define MIS_U1CPR_apb_data_width_src(data)                                           ((0x00000003&(data))>>0)
+#define MIS_U1CPR_get_apb_data_width(data)                                           ((0x00000003&(data))>>0)
+
+
+#define MIS_U1UCV                                                                    0x1801B2F8
+#define MIS_U1UCV_reg_addr                                                           "0xB801B2F8"
+#define MIS_U1UCV_reg                                                                0xB801B2F8
+#define set_MIS_U1UCV_reg(data)   (*((volatile unsigned int*) MIS_U1UCV_reg)=data)
+#define get_MIS_U1UCV_reg   (*((volatile unsigned int*) MIS_U1UCV_reg))
+#define MIS_U1UCV_inst_adr                                                           "0x00BE"
+#define MIS_U1UCV_inst                                                               0x00BE
+#define MIS_U1UCV_ucv_shift                                                          (0)
+#define MIS_U1UCV_ucv_mask                                                           (0xFFFFFFFF)
+#define MIS_U1UCV_ucv(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define MIS_U1UCV_ucv_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define MIS_U1UCV_get_ucv(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_U1CTR                                                                    0x1801B2FC
+#define MIS_U1CTR_reg_addr                                                           "0xB801B2FC"
+#define MIS_U1CTR_reg                                                                0xB801B2FC
+#define set_MIS_U1CTR_reg(data)   (*((volatile unsigned int*) MIS_U1CTR_reg)=data)
+#define get_MIS_U1CTR_reg   (*((volatile unsigned int*) MIS_U1CTR_reg))
+#define MIS_U1CTR_inst_adr                                                           "0x00BF"
+#define MIS_U1CTR_inst                                                               0x00BF
+#define MIS_U1CTR_ctr_shift                                                          (0)
+#define MIS_U1CTR_ctr_mask                                                           (0xFFFFFFFF)
+#define MIS_U1CTR_ctr(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define MIS_U1CTR_ctr_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define MIS_U1CTR_get_ctr(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_IC1_CON                                                                  0x1801B300
+#define MIS_IC1_CON_reg_addr                                                         "0xB801B300"
+#define MIS_IC1_CON_reg                                                              0xB801B300
+#define set_MIS_IC1_CON_reg(data)   (*((volatile unsigned int*) MIS_IC1_CON_reg)=data)
+#define get_MIS_IC1_CON_reg   (*((volatile unsigned int*) MIS_IC1_CON_reg))
+#define MIS_IC1_CON_inst_adr                                                         "0x00C0"
+#define MIS_IC1_CON_inst                                                             0x00C0
+#define MIS_IC1_CON_ic_slave_disable_shift                                           (6)
+#define MIS_IC1_CON_ic_slave_disable_mask                                            (0x00000040)
+#define MIS_IC1_CON_ic_slave_disable(data)                                           (0x00000040&((data)<<6))
+#define MIS_IC1_CON_ic_slave_disable_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC1_CON_get_ic_slave_disable(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC1_CON_ic_restart_en_shift                                              (5)
+#define MIS_IC1_CON_ic_restart_en_mask                                               (0x00000020)
+#define MIS_IC1_CON_ic_restart_en(data)                                              (0x00000020&((data)<<5))
+#define MIS_IC1_CON_ic_restart_en_src(data)                                          ((0x00000020&(data))>>5)
+#define MIS_IC1_CON_get_ic_restart_en(data)                                          ((0x00000020&(data))>>5)
+#define MIS_IC1_CON_ic_10bitaddr_master_shift                                        (4)
+#define MIS_IC1_CON_ic_10bitaddr_master_mask                                         (0x00000010)
+#define MIS_IC1_CON_ic_10bitaddr_master(data)                                        (0x00000010&((data)<<4))
+#define MIS_IC1_CON_ic_10bitaddr_master_src(data)                                    ((0x00000010&(data))>>4)
+#define MIS_IC1_CON_get_ic_10bitaddr_master(data)                                    ((0x00000010&(data))>>4)
+#define MIS_IC1_CON_ic_10bitaddr_slave_shift                                         (3)
+#define MIS_IC1_CON_ic_10bitaddr_slave_mask                                          (0x00000008)
+#define MIS_IC1_CON_ic_10bitaddr_slave(data)                                         (0x00000008&((data)<<3))
+#define MIS_IC1_CON_ic_10bitaddr_slave_src(data)                                     ((0x00000008&(data))>>3)
+#define MIS_IC1_CON_get_ic_10bitaddr_slave(data)                                     ((0x00000008&(data))>>3)
+#define MIS_IC1_CON_speed_shift                                                      (1)
+#define MIS_IC1_CON_speed_mask                                                       (0x00000006)
+#define MIS_IC1_CON_speed(data)                                                      (0x00000006&((data)<<1))
+#define MIS_IC1_CON_speed_src(data)                                                  ((0x00000006&(data))>>1)
+#define MIS_IC1_CON_get_speed(data)                                                  ((0x00000006&(data))>>1)
+#define MIS_IC1_CON_master_mode_shift                                                (0)
+#define MIS_IC1_CON_master_mode_mask                                                 (0x00000001)
+#define MIS_IC1_CON_master_mode(data)                                                (0x00000001&((data)<<0))
+#define MIS_IC1_CON_master_mode_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_IC1_CON_get_master_mode(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_TAR                                                                  0x1801B304
+#define MIS_IC1_TAR_reg_addr                                                         "0xB801B304"
+#define MIS_IC1_TAR_reg                                                              0xB801B304
+#define set_MIS_IC1_TAR_reg(data)   (*((volatile unsigned int*) MIS_IC1_TAR_reg)=data)
+#define get_MIS_IC1_TAR_reg   (*((volatile unsigned int*) MIS_IC1_TAR_reg))
+#define MIS_IC1_TAR_inst_adr                                                         "0x00C1"
+#define MIS_IC1_TAR_inst                                                             0x00C1
+#define MIS_IC1_TAR_ic_10bitaddr_master_shift                                        (12)
+#define MIS_IC1_TAR_ic_10bitaddr_master_mask                                         (0x00001000)
+#define MIS_IC1_TAR_ic_10bitaddr_master(data)                                        (0x00001000&((data)<<12))
+#define MIS_IC1_TAR_ic_10bitaddr_master_src(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC1_TAR_get_ic_10bitaddr_master(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC1_TAR_special_shift                                                    (11)
+#define MIS_IC1_TAR_special_mask                                                     (0x00000800)
+#define MIS_IC1_TAR_special(data)                                                    (0x00000800&((data)<<11))
+#define MIS_IC1_TAR_special_src(data)                                                ((0x00000800&(data))>>11)
+#define MIS_IC1_TAR_get_special(data)                                                ((0x00000800&(data))>>11)
+#define MIS_IC1_TAR_gc_or_start_shift                                                (10)
+#define MIS_IC1_TAR_gc_or_start_mask                                                 (0x00000400)
+#define MIS_IC1_TAR_gc_or_start(data)                                                (0x00000400&((data)<<10))
+#define MIS_IC1_TAR_gc_or_start_src(data)                                            ((0x00000400&(data))>>10)
+#define MIS_IC1_TAR_get_gc_or_start(data)                                            ((0x00000400&(data))>>10)
+#define MIS_IC1_TAR_ic_tar_shift                                                     (0)
+#define MIS_IC1_TAR_ic_tar_mask                                                      (0x000003FF)
+#define MIS_IC1_TAR_ic_tar(data)                                                     (0x000003FF&((data)<<0))
+#define MIS_IC1_TAR_ic_tar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define MIS_IC1_TAR_get_ic_tar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define MIS_IC1_SAR                                                                  0x1801B308
+#define MIS_IC1_SAR_reg_addr                                                         "0xB801B308"
+#define MIS_IC1_SAR_reg                                                              0xB801B308
+#define set_MIS_IC1_SAR_reg(data)   (*((volatile unsigned int*) MIS_IC1_SAR_reg)=data)
+#define get_MIS_IC1_SAR_reg   (*((volatile unsigned int*) MIS_IC1_SAR_reg))
+#define MIS_IC1_SAR_inst_adr                                                         "0x00C2"
+#define MIS_IC1_SAR_inst                                                             0x00C2
+#define MIS_IC1_SAR_ic_sar_shift                                                     (0)
+#define MIS_IC1_SAR_ic_sar_mask                                                      (0x000003FF)
+#define MIS_IC1_SAR_ic_sar(data)                                                     (0x000003FF&((data)<<0))
+#define MIS_IC1_SAR_ic_sar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define MIS_IC1_SAR_get_ic_sar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define MIS_IC1_HS_MADDR                                                             0x1801B30C
+#define MIS_IC1_HS_MADDR_reg_addr                                                    "0xB801B30C"
+#define MIS_IC1_HS_MADDR_reg                                                         0xB801B30C
+#define set_MIS_IC1_HS_MADDR_reg(data)   (*((volatile unsigned int*) MIS_IC1_HS_MADDR_reg)=data)
+#define get_MIS_IC1_HS_MADDR_reg   (*((volatile unsigned int*) MIS_IC1_HS_MADDR_reg))
+#define MIS_IC1_HS_MADDR_inst_adr                                                    "0x00C3"
+#define MIS_IC1_HS_MADDR_inst                                                        0x00C3
+#define MIS_IC1_HS_MADDR_ic_hs_mar_shift                                             (0)
+#define MIS_IC1_HS_MADDR_ic_hs_mar_mask                                              (0x00000007)
+#define MIS_IC1_HS_MADDR_ic_hs_mar(data)                                             (0x00000007&((data)<<0))
+#define MIS_IC1_HS_MADDR_ic_hs_mar_src(data)                                         ((0x00000007&(data))>>0)
+#define MIS_IC1_HS_MADDR_get_ic_hs_mar(data)                                         ((0x00000007&(data))>>0)
+
+
+#define MIS_IC1_DATA_CMD                                                             0x1801B310
+#define MIS_IC1_DATA_CMD_reg_addr                                                    "0xB801B310"
+#define MIS_IC1_DATA_CMD_reg                                                         0xB801B310
+#define set_MIS_IC1_DATA_CMD_reg(data)   (*((volatile unsigned int*) MIS_IC1_DATA_CMD_reg)=data)
+#define get_MIS_IC1_DATA_CMD_reg   (*((volatile unsigned int*) MIS_IC1_DATA_CMD_reg))
+#define MIS_IC1_DATA_CMD_inst_adr                                                    "0x00C4"
+#define MIS_IC1_DATA_CMD_inst                                                        0x00C4
+#define MIS_IC1_DATA_CMD_restart_shift                                               (10)
+#define MIS_IC1_DATA_CMD_restart_mask                                                (0x00000400)
+#define MIS_IC1_DATA_CMD_restart(data)                                               (0x00000400&((data)<<10))
+#define MIS_IC1_DATA_CMD_restart_src(data)                                           ((0x00000400&(data))>>10)
+#define MIS_IC1_DATA_CMD_get_restart(data)                                           ((0x00000400&(data))>>10)
+#define MIS_IC1_DATA_CMD_stop_shift                                                  (9)
+#define MIS_IC1_DATA_CMD_stop_mask                                                   (0x00000200)
+#define MIS_IC1_DATA_CMD_stop(data)                                                  (0x00000200&((data)<<9))
+#define MIS_IC1_DATA_CMD_stop_src(data)                                              ((0x00000200&(data))>>9)
+#define MIS_IC1_DATA_CMD_get_stop(data)                                              ((0x00000200&(data))>>9)
+#define MIS_IC1_DATA_CMD_cmd_shift                                                   (8)
+#define MIS_IC1_DATA_CMD_cmd_mask                                                    (0x00000100)
+#define MIS_IC1_DATA_CMD_cmd(data)                                                   (0x00000100&((data)<<8))
+#define MIS_IC1_DATA_CMD_cmd_src(data)                                               ((0x00000100&(data))>>8)
+#define MIS_IC1_DATA_CMD_get_cmd(data)                                               ((0x00000100&(data))>>8)
+#define MIS_IC1_DATA_CMD_dat_shift                                                   (0)
+#define MIS_IC1_DATA_CMD_dat_mask                                                    (0x000000FF)
+#define MIS_IC1_DATA_CMD_dat(data)                                                   (0x000000FF&((data)<<0))
+#define MIS_IC1_DATA_CMD_dat_src(data)                                               ((0x000000FF&(data))>>0)
+#define MIS_IC1_DATA_CMD_get_dat(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC1_SS_SCL_HCNT                                                          0x1801B314
+#define MIS_IC1_SS_SCL_HCNT_reg_addr                                                 "0xB801B314"
+#define MIS_IC1_SS_SCL_HCNT_reg                                                      0xB801B314
+#define set_MIS_IC1_SS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) MIS_IC1_SS_SCL_HCNT_reg)=data)
+#define get_MIS_IC1_SS_SCL_HCNT_reg   (*((volatile unsigned int*) MIS_IC1_SS_SCL_HCNT_reg))
+#define MIS_IC1_SS_SCL_HCNT_inst_adr                                                 "0x00C5"
+#define MIS_IC1_SS_SCL_HCNT_inst                                                     0x00C5
+#define MIS_IC1_SS_SCL_HCNT_ic_ss_scl_hcnt_shift                                     (0)
+#define MIS_IC1_SS_SCL_HCNT_ic_ss_scl_hcnt_mask                                      (0x0000FFFF)
+#define MIS_IC1_SS_SCL_HCNT_ic_ss_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC1_SS_SCL_HCNT_ic_ss_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC1_SS_SCL_HCNT_get_ic_ss_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC1_SS_SCL_LCNT                                                          0x1801B318
+#define MIS_IC1_SS_SCL_LCNT_reg_addr                                                 "0xB801B318"
+#define MIS_IC1_SS_SCL_LCNT_reg                                                      0xB801B318
+#define set_MIS_IC1_SS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) MIS_IC1_SS_SCL_LCNT_reg)=data)
+#define get_MIS_IC1_SS_SCL_LCNT_reg   (*((volatile unsigned int*) MIS_IC1_SS_SCL_LCNT_reg))
+#define MIS_IC1_SS_SCL_LCNT_inst_adr                                                 "0x00C6"
+#define MIS_IC1_SS_SCL_LCNT_inst                                                     0x00C6
+#define MIS_IC1_SS_SCL_LCNT_ic_ss_scl_lcnt_shift                                     (0)
+#define MIS_IC1_SS_SCL_LCNT_ic_ss_scl_lcnt_mask                                      (0x0000FFFF)
+#define MIS_IC1_SS_SCL_LCNT_ic_ss_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC1_SS_SCL_LCNT_ic_ss_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC1_SS_SCL_LCNT_get_ic_ss_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC1_FS_SCL_HCNT                                                          0x1801B31C
+#define MIS_IC1_FS_SCL_HCNT_reg_addr                                                 "0xB801B31C"
+#define MIS_IC1_FS_SCL_HCNT_reg                                                      0xB801B31C
+#define set_MIS_IC1_FS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) MIS_IC1_FS_SCL_HCNT_reg)=data)
+#define get_MIS_IC1_FS_SCL_HCNT_reg   (*((volatile unsigned int*) MIS_IC1_FS_SCL_HCNT_reg))
+#define MIS_IC1_FS_SCL_HCNT_inst_adr                                                 "0x00C7"
+#define MIS_IC1_FS_SCL_HCNT_inst                                                     0x00C7
+#define MIS_IC1_FS_SCL_HCNT_ic_fs_scl_hcnt_shift                                     (0)
+#define MIS_IC1_FS_SCL_HCNT_ic_fs_scl_hcnt_mask                                      (0x0000FFFF)
+#define MIS_IC1_FS_SCL_HCNT_ic_fs_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC1_FS_SCL_HCNT_ic_fs_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC1_FS_SCL_HCNT_get_ic_fs_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC1_FS_SCL_LCNT                                                          0x1801B320
+#define MIS_IC1_FS_SCL_LCNT_reg_addr                                                 "0xB801B320"
+#define MIS_IC1_FS_SCL_LCNT_reg                                                      0xB801B320
+#define set_MIS_IC1_FS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) MIS_IC1_FS_SCL_LCNT_reg)=data)
+#define get_MIS_IC1_FS_SCL_LCNT_reg   (*((volatile unsigned int*) MIS_IC1_FS_SCL_LCNT_reg))
+#define MIS_IC1_FS_SCL_LCNT_inst_adr                                                 "0x00C8"
+#define MIS_IC1_FS_SCL_LCNT_inst                                                     0x00C8
+#define MIS_IC1_FS_SCL_LCNT_ic_fs_scl_lcnt_shift                                     (0)
+#define MIS_IC1_FS_SCL_LCNT_ic_fs_scl_lcnt_mask                                      (0x0000FFFF)
+#define MIS_IC1_FS_SCL_LCNT_ic_fs_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC1_FS_SCL_LCNT_ic_fs_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC1_FS_SCL_LCNT_get_ic_fs_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC1_INTR_STAT                                                            0x1801B32C
+#define MIS_IC1_INTR_STAT_reg_addr                                                   "0xB801B32C"
+#define MIS_IC1_INTR_STAT_reg                                                        0xB801B32C
+#define set_MIS_IC1_INTR_STAT_reg(data)   (*((volatile unsigned int*) MIS_IC1_INTR_STAT_reg)=data)
+#define get_MIS_IC1_INTR_STAT_reg   (*((volatile unsigned int*) MIS_IC1_INTR_STAT_reg))
+#define MIS_IC1_INTR_STAT_inst_adr                                                   "0x00CB"
+#define MIS_IC1_INTR_STAT_inst                                                       0x00CB
+#define MIS_IC1_INTR_STAT_r_gen_call_shift                                           (11)
+#define MIS_IC1_INTR_STAT_r_gen_call_mask                                            (0x00000800)
+#define MIS_IC1_INTR_STAT_r_gen_call(data)                                           (0x00000800&((data)<<11))
+#define MIS_IC1_INTR_STAT_r_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC1_INTR_STAT_get_r_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC1_INTR_STAT_r_start_det_shift                                          (10)
+#define MIS_IC1_INTR_STAT_r_start_det_mask                                           (0x00000400)
+#define MIS_IC1_INTR_STAT_r_start_det(data)                                          (0x00000400&((data)<<10))
+#define MIS_IC1_INTR_STAT_r_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC1_INTR_STAT_get_r_start_det(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC1_INTR_STAT_r_stop_det_shift                                           (9)
+#define MIS_IC1_INTR_STAT_r_stop_det_mask                                            (0x00000200)
+#define MIS_IC1_INTR_STAT_r_stop_det(data)                                           (0x00000200&((data)<<9))
+#define MIS_IC1_INTR_STAT_r_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC1_INTR_STAT_get_r_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC1_INTR_STAT_r_activity_shift                                           (8)
+#define MIS_IC1_INTR_STAT_r_activity_mask                                            (0x00000100)
+#define MIS_IC1_INTR_STAT_r_activity(data)                                           (0x00000100&((data)<<8))
+#define MIS_IC1_INTR_STAT_r_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC1_INTR_STAT_get_r_activity(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC1_INTR_STAT_r_rx_done_shift                                            (7)
+#define MIS_IC1_INTR_STAT_r_rx_done_mask                                             (0x00000080)
+#define MIS_IC1_INTR_STAT_r_rx_done(data)                                            (0x00000080&((data)<<7))
+#define MIS_IC1_INTR_STAT_r_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC1_INTR_STAT_get_r_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC1_INTR_STAT_r_tx_abrt_shift                                            (6)
+#define MIS_IC1_INTR_STAT_r_tx_abrt_mask                                             (0x00000040)
+#define MIS_IC1_INTR_STAT_r_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC1_INTR_STAT_r_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC1_INTR_STAT_get_r_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC1_INTR_STAT_r_rd_req_shift                                             (5)
+#define MIS_IC1_INTR_STAT_r_rd_req_mask                                              (0x00000020)
+#define MIS_IC1_INTR_STAT_r_rd_req(data)                                             (0x00000020&((data)<<5))
+#define MIS_IC1_INTR_STAT_r_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC1_INTR_STAT_get_r_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC1_INTR_STAT_r_tx_empty_shift                                           (4)
+#define MIS_IC1_INTR_STAT_r_tx_empty_mask                                            (0x00000010)
+#define MIS_IC1_INTR_STAT_r_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define MIS_IC1_INTR_STAT_r_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC1_INTR_STAT_get_r_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC1_INTR_STAT_r_tx_over_shift                                            (3)
+#define MIS_IC1_INTR_STAT_r_tx_over_mask                                             (0x00000008)
+#define MIS_IC1_INTR_STAT_r_tx_over(data)                                            (0x00000008&((data)<<3))
+#define MIS_IC1_INTR_STAT_r_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC1_INTR_STAT_get_r_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC1_INTR_STAT_r_rx_full_shift                                            (2)
+#define MIS_IC1_INTR_STAT_r_rx_full_mask                                             (0x00000004)
+#define MIS_IC1_INTR_STAT_r_rx_full(data)                                            (0x00000004&((data)<<2))
+#define MIS_IC1_INTR_STAT_r_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC1_INTR_STAT_get_r_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC1_INTR_STAT_r_rx_over_shift                                            (1)
+#define MIS_IC1_INTR_STAT_r_rx_over_mask                                             (0x00000002)
+#define MIS_IC1_INTR_STAT_r_rx_over(data)                                            (0x00000002&((data)<<1))
+#define MIS_IC1_INTR_STAT_r_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC1_INTR_STAT_get_r_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC1_INTR_STAT_r_rx_under_shift                                           (0)
+#define MIS_IC1_INTR_STAT_r_rx_under_mask                                            (0x00000001)
+#define MIS_IC1_INTR_STAT_r_rx_under(data)                                           (0x00000001&((data)<<0))
+#define MIS_IC1_INTR_STAT_r_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_IC1_INTR_STAT_get_r_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_INTR_MASK                                                            0x1801B330
+#define MIS_IC1_INTR_MASK_reg_addr                                                   "0xB801B330"
+#define MIS_IC1_INTR_MASK_reg                                                        0xB801B330
+#define set_MIS_IC1_INTR_MASK_reg(data)   (*((volatile unsigned int*) MIS_IC1_INTR_MASK_reg)=data)
+#define get_MIS_IC1_INTR_MASK_reg   (*((volatile unsigned int*) MIS_IC1_INTR_MASK_reg))
+#define MIS_IC1_INTR_MASK_inst_adr                                                   "0x00CC"
+#define MIS_IC1_INTR_MASK_inst                                                       0x00CC
+#define MIS_IC1_INTR_MASK_m_gen_call_shift                                           (11)
+#define MIS_IC1_INTR_MASK_m_gen_call_mask                                            (0x00000800)
+#define MIS_IC1_INTR_MASK_m_gen_call(data)                                           (0x00000800&((data)<<11))
+#define MIS_IC1_INTR_MASK_m_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC1_INTR_MASK_get_m_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC1_INTR_MASK_m_start_det_shift                                          (10)
+#define MIS_IC1_INTR_MASK_m_start_det_mask                                           (0x00000400)
+#define MIS_IC1_INTR_MASK_m_start_det(data)                                          (0x00000400&((data)<<10))
+#define MIS_IC1_INTR_MASK_m_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC1_INTR_MASK_get_m_start_det(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC1_INTR_MASK_m_stop_det_shift                                           (9)
+#define MIS_IC1_INTR_MASK_m_stop_det_mask                                            (0x00000200)
+#define MIS_IC1_INTR_MASK_m_stop_det(data)                                           (0x00000200&((data)<<9))
+#define MIS_IC1_INTR_MASK_m_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC1_INTR_MASK_get_m_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC1_INTR_MASK_m_activity_shift                                           (8)
+#define MIS_IC1_INTR_MASK_m_activity_mask                                            (0x00000100)
+#define MIS_IC1_INTR_MASK_m_activity(data)                                           (0x00000100&((data)<<8))
+#define MIS_IC1_INTR_MASK_m_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC1_INTR_MASK_get_m_activity(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC1_INTR_MASK_m_rx_done_shift                                            (7)
+#define MIS_IC1_INTR_MASK_m_rx_done_mask                                             (0x00000080)
+#define MIS_IC1_INTR_MASK_m_rx_done(data)                                            (0x00000080&((data)<<7))
+#define MIS_IC1_INTR_MASK_m_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC1_INTR_MASK_get_m_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC1_INTR_MASK_m_tx_abrt_shift                                            (6)
+#define MIS_IC1_INTR_MASK_m_tx_abrt_mask                                             (0x00000040)
+#define MIS_IC1_INTR_MASK_m_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC1_INTR_MASK_m_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC1_INTR_MASK_get_m_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC1_INTR_MASK_m_rd_req_shift                                             (5)
+#define MIS_IC1_INTR_MASK_m_rd_req_mask                                              (0x00000020)
+#define MIS_IC1_INTR_MASK_m_rd_req(data)                                             (0x00000020&((data)<<5))
+#define MIS_IC1_INTR_MASK_m_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC1_INTR_MASK_get_m_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC1_INTR_MASK_m_tx_empty_shift                                           (4)
+#define MIS_IC1_INTR_MASK_m_tx_empty_mask                                            (0x00000010)
+#define MIS_IC1_INTR_MASK_m_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define MIS_IC1_INTR_MASK_m_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC1_INTR_MASK_get_m_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC1_INTR_MASK_m_tx_over_shift                                            (3)
+#define MIS_IC1_INTR_MASK_m_tx_over_mask                                             (0x00000008)
+#define MIS_IC1_INTR_MASK_m_tx_over(data)                                            (0x00000008&((data)<<3))
+#define MIS_IC1_INTR_MASK_m_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC1_INTR_MASK_get_m_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC1_INTR_MASK_m_rx_full_shift                                            (2)
+#define MIS_IC1_INTR_MASK_m_rx_full_mask                                             (0x00000004)
+#define MIS_IC1_INTR_MASK_m_rx_full(data)                                            (0x00000004&((data)<<2))
+#define MIS_IC1_INTR_MASK_m_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC1_INTR_MASK_get_m_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC1_INTR_MASK_m_rx_over_shift                                            (1)
+#define MIS_IC1_INTR_MASK_m_rx_over_mask                                             (0x00000002)
+#define MIS_IC1_INTR_MASK_m_rx_over(data)                                            (0x00000002&((data)<<1))
+#define MIS_IC1_INTR_MASK_m_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC1_INTR_MASK_get_m_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC1_INTR_MASK_m_rx_under_shift                                           (0)
+#define MIS_IC1_INTR_MASK_m_rx_under_mask                                            (0x00000001)
+#define MIS_IC1_INTR_MASK_m_rx_under(data)                                           (0x00000001&((data)<<0))
+#define MIS_IC1_INTR_MASK_m_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_IC1_INTR_MASK_get_m_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_RAW_INTR_STAT                                                        0x1801B334
+#define MIS_IC1_RAW_INTR_STAT_reg_addr                                               "0xB801B334"
+#define MIS_IC1_RAW_INTR_STAT_reg                                                    0xB801B334
+#define set_MIS_IC1_RAW_INTR_STAT_reg(data)   (*((volatile unsigned int*) MIS_IC1_RAW_INTR_STAT_reg)=data)
+#define get_MIS_IC1_RAW_INTR_STAT_reg   (*((volatile unsigned int*) MIS_IC1_RAW_INTR_STAT_reg))
+#define MIS_IC1_RAW_INTR_STAT_inst_adr                                               "0x00CD"
+#define MIS_IC1_RAW_INTR_STAT_inst                                                   0x00CD
+#define MIS_IC1_RAW_INTR_STAT_gen_call_shift                                         (11)
+#define MIS_IC1_RAW_INTR_STAT_gen_call_mask                                          (0x00000800)
+#define MIS_IC1_RAW_INTR_STAT_gen_call(data)                                         (0x00000800&((data)<<11))
+#define MIS_IC1_RAW_INTR_STAT_gen_call_src(data)                                     ((0x00000800&(data))>>11)
+#define MIS_IC1_RAW_INTR_STAT_get_gen_call(data)                                     ((0x00000800&(data))>>11)
+#define MIS_IC1_RAW_INTR_STAT_start_det_shift                                        (10)
+#define MIS_IC1_RAW_INTR_STAT_start_det_mask                                         (0x00000400)
+#define MIS_IC1_RAW_INTR_STAT_start_det(data)                                        (0x00000400&((data)<<10))
+#define MIS_IC1_RAW_INTR_STAT_start_det_src(data)                                    ((0x00000400&(data))>>10)
+#define MIS_IC1_RAW_INTR_STAT_get_start_det(data)                                    ((0x00000400&(data))>>10)
+#define MIS_IC1_RAW_INTR_STAT_stop_det_shift                                         (9)
+#define MIS_IC1_RAW_INTR_STAT_stop_det_mask                                          (0x00000200)
+#define MIS_IC1_RAW_INTR_STAT_stop_det(data)                                         (0x00000200&((data)<<9))
+#define MIS_IC1_RAW_INTR_STAT_stop_det_src(data)                                     ((0x00000200&(data))>>9)
+#define MIS_IC1_RAW_INTR_STAT_get_stop_det(data)                                     ((0x00000200&(data))>>9)
+#define MIS_IC1_RAW_INTR_STAT_activity_shift                                         (8)
+#define MIS_IC1_RAW_INTR_STAT_activity_mask                                          (0x00000100)
+#define MIS_IC1_RAW_INTR_STAT_activity(data)                                         (0x00000100&((data)<<8))
+#define MIS_IC1_RAW_INTR_STAT_activity_src(data)                                     ((0x00000100&(data))>>8)
+#define MIS_IC1_RAW_INTR_STAT_get_activity(data)                                     ((0x00000100&(data))>>8)
+#define MIS_IC1_RAW_INTR_STAT_rx_done_shift                                          (7)
+#define MIS_IC1_RAW_INTR_STAT_rx_done_mask                                           (0x00000080)
+#define MIS_IC1_RAW_INTR_STAT_rx_done(data)                                          (0x00000080&((data)<<7))
+#define MIS_IC1_RAW_INTR_STAT_rx_done_src(data)                                      ((0x00000080&(data))>>7)
+#define MIS_IC1_RAW_INTR_STAT_get_rx_done(data)                                      ((0x00000080&(data))>>7)
+#define MIS_IC1_RAW_INTR_STAT_tx_abrt_shift                                          (6)
+#define MIS_IC1_RAW_INTR_STAT_tx_abrt_mask                                           (0x00000040)
+#define MIS_IC1_RAW_INTR_STAT_tx_abrt(data)                                          (0x00000040&((data)<<6))
+#define MIS_IC1_RAW_INTR_STAT_tx_abrt_src(data)                                      ((0x00000040&(data))>>6)
+#define MIS_IC1_RAW_INTR_STAT_get_tx_abrt(data)                                      ((0x00000040&(data))>>6)
+#define MIS_IC1_RAW_INTR_STAT_rd_req_shift                                           (5)
+#define MIS_IC1_RAW_INTR_STAT_rd_req_mask                                            (0x00000020)
+#define MIS_IC1_RAW_INTR_STAT_rd_req(data)                                           (0x00000020&((data)<<5))
+#define MIS_IC1_RAW_INTR_STAT_rd_req_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC1_RAW_INTR_STAT_get_rd_req(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC1_RAW_INTR_STAT_tx_empty_shift                                         (4)
+#define MIS_IC1_RAW_INTR_STAT_tx_empty_mask                                          (0x00000010)
+#define MIS_IC1_RAW_INTR_STAT_tx_empty(data)                                         (0x00000010&((data)<<4))
+#define MIS_IC1_RAW_INTR_STAT_tx_empty_src(data)                                     ((0x00000010&(data))>>4)
+#define MIS_IC1_RAW_INTR_STAT_get_tx_empty(data)                                     ((0x00000010&(data))>>4)
+#define MIS_IC1_RAW_INTR_STAT_tx_over_shift                                          (3)
+#define MIS_IC1_RAW_INTR_STAT_tx_over_mask                                           (0x00000008)
+#define MIS_IC1_RAW_INTR_STAT_tx_over(data)                                          (0x00000008&((data)<<3))
+#define MIS_IC1_RAW_INTR_STAT_tx_over_src(data)                                      ((0x00000008&(data))>>3)
+#define MIS_IC1_RAW_INTR_STAT_get_tx_over(data)                                      ((0x00000008&(data))>>3)
+#define MIS_IC1_RAW_INTR_STAT_rx_full_shift                                          (2)
+#define MIS_IC1_RAW_INTR_STAT_rx_full_mask                                           (0x00000004)
+#define MIS_IC1_RAW_INTR_STAT_rx_full(data)                                          (0x00000004&((data)<<2))
+#define MIS_IC1_RAW_INTR_STAT_rx_full_src(data)                                      ((0x00000004&(data))>>2)
+#define MIS_IC1_RAW_INTR_STAT_get_rx_full(data)                                      ((0x00000004&(data))>>2)
+#define MIS_IC1_RAW_INTR_STAT_rx_over_shift                                          (1)
+#define MIS_IC1_RAW_INTR_STAT_rx_over_mask                                           (0x00000002)
+#define MIS_IC1_RAW_INTR_STAT_rx_over(data)                                          (0x00000002&((data)<<1))
+#define MIS_IC1_RAW_INTR_STAT_rx_over_src(data)                                      ((0x00000002&(data))>>1)
+#define MIS_IC1_RAW_INTR_STAT_get_rx_over(data)                                      ((0x00000002&(data))>>1)
+#define MIS_IC1_RAW_INTR_STAT_rx_under_shift                                         (0)
+#define MIS_IC1_RAW_INTR_STAT_rx_under_mask                                          (0x00000001)
+#define MIS_IC1_RAW_INTR_STAT_rx_under(data)                                         (0x00000001&((data)<<0))
+#define MIS_IC1_RAW_INTR_STAT_rx_under_src(data)                                     ((0x00000001&(data))>>0)
+#define MIS_IC1_RAW_INTR_STAT_get_rx_under(data)                                     ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_RX_TL                                                                0x1801B338
+#define MIS_IC1_RX_TL_reg_addr                                                       "0xB801B338"
+#define MIS_IC1_RX_TL_reg                                                            0xB801B338
+#define set_MIS_IC1_RX_TL_reg(data)   (*((volatile unsigned int*) MIS_IC1_RX_TL_reg)=data)
+#define get_MIS_IC1_RX_TL_reg   (*((volatile unsigned int*) MIS_IC1_RX_TL_reg))
+#define MIS_IC1_RX_TL_inst_adr                                                       "0x00CE"
+#define MIS_IC1_RX_TL_inst                                                           0x00CE
+#define MIS_IC1_RX_TL_rx_tl_shift                                                    (0)
+#define MIS_IC1_RX_TL_rx_tl_mask                                                     (0x000000FF)
+#define MIS_IC1_RX_TL_rx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define MIS_IC1_RX_TL_rx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define MIS_IC1_RX_TL_get_rx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC1_TX_TL                                                                0x1801B33C
+#define MIS_IC1_TX_TL_reg_addr                                                       "0xB801B33C"
+#define MIS_IC1_TX_TL_reg                                                            0xB801B33C
+#define set_MIS_IC1_TX_TL_reg(data)   (*((volatile unsigned int*) MIS_IC1_TX_TL_reg)=data)
+#define get_MIS_IC1_TX_TL_reg   (*((volatile unsigned int*) MIS_IC1_TX_TL_reg))
+#define MIS_IC1_TX_TL_inst_adr                                                       "0x00CF"
+#define MIS_IC1_TX_TL_inst                                                           0x00CF
+#define MIS_IC1_TX_TL_tx_tl_shift                                                    (0)
+#define MIS_IC1_TX_TL_tx_tl_mask                                                     (0x000000FF)
+#define MIS_IC1_TX_TL_tx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define MIS_IC1_TX_TL_tx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define MIS_IC1_TX_TL_get_tx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC1_CLR_INTR                                                             0x1801B340
+#define MIS_IC1_CLR_INTR_reg_addr                                                    "0xB801B340"
+#define MIS_IC1_CLR_INTR_reg                                                         0xB801B340
+#define set_MIS_IC1_CLR_INTR_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_INTR_reg)=data)
+#define get_MIS_IC1_CLR_INTR_reg   (*((volatile unsigned int*) MIS_IC1_CLR_INTR_reg))
+#define MIS_IC1_CLR_INTR_inst_adr                                                    "0x00D0"
+#define MIS_IC1_CLR_INTR_inst                                                        0x00D0
+#define MIS_IC1_CLR_INTR_clr_intr_shift                                              (0)
+#define MIS_IC1_CLR_INTR_clr_intr_mask                                               (0x00000001)
+#define MIS_IC1_CLR_INTR_clr_intr(data)                                              (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_INTR_clr_intr_src(data)                                          ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_INTR_get_clr_intr(data)                                          ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_CLR_RX_UNDER                                                         0x1801B344
+#define MIS_IC1_CLR_RX_UNDER_reg_addr                                                "0xB801B344"
+#define MIS_IC1_CLR_RX_UNDER_reg                                                     0xB801B344
+#define set_MIS_IC1_CLR_RX_UNDER_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_RX_UNDER_reg)=data)
+#define get_MIS_IC1_CLR_RX_UNDER_reg   (*((volatile unsigned int*) MIS_IC1_CLR_RX_UNDER_reg))
+#define MIS_IC1_CLR_RX_UNDER_inst_adr                                                "0x00D1"
+#define MIS_IC1_CLR_RX_UNDER_inst                                                    0x00D1
+#define MIS_IC1_CLR_RX_UNDER_clr_rx_under_shift                                      (0)
+#define MIS_IC1_CLR_RX_UNDER_clr_rx_under_mask                                       (0x00000001)
+#define MIS_IC1_CLR_RX_UNDER_clr_rx_under(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_RX_UNDER_clr_rx_under_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_RX_UNDER_get_clr_rx_under(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_CLR_RX_OVER                                                          0x1801B348
+#define MIS_IC1_CLR_RX_OVER_reg_addr                                                 "0xB801B348"
+#define MIS_IC1_CLR_RX_OVER_reg                                                      0xB801B348
+#define set_MIS_IC1_CLR_RX_OVER_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_RX_OVER_reg)=data)
+#define get_MIS_IC1_CLR_RX_OVER_reg   (*((volatile unsigned int*) MIS_IC1_CLR_RX_OVER_reg))
+#define MIS_IC1_CLR_RX_OVER_inst_adr                                                 "0x00D2"
+#define MIS_IC1_CLR_RX_OVER_inst                                                     0x00D2
+#define MIS_IC1_CLR_RX_OVER_clr_rx_over_shift                                        (0)
+#define MIS_IC1_CLR_RX_OVER_clr_rx_over_mask                                         (0x00000001)
+#define MIS_IC1_CLR_RX_OVER_clr_rx_over(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_RX_OVER_clr_rx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_RX_OVER_get_clr_rx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_CLR_TX_OVER                                                          0x1801B34C
+#define MIS_IC1_CLR_TX_OVER_reg_addr                                                 "0xB801B34C"
+#define MIS_IC1_CLR_TX_OVER_reg                                                      0xB801B34C
+#define set_MIS_IC1_CLR_TX_OVER_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_TX_OVER_reg)=data)
+#define get_MIS_IC1_CLR_TX_OVER_reg   (*((volatile unsigned int*) MIS_IC1_CLR_TX_OVER_reg))
+#define MIS_IC1_CLR_TX_OVER_inst_adr                                                 "0x00D3"
+#define MIS_IC1_CLR_TX_OVER_inst                                                     0x00D3
+#define MIS_IC1_CLR_TX_OVER_clr_tx_over_shift                                        (0)
+#define MIS_IC1_CLR_TX_OVER_clr_tx_over_mask                                         (0x00000001)
+#define MIS_IC1_CLR_TX_OVER_clr_tx_over(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_TX_OVER_clr_tx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_TX_OVER_get_clr_tx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_CLR_RD_REQ                                                           0x1801B350
+#define MIS_IC1_CLR_RD_REQ_reg_addr                                                  "0xB801B350"
+#define MIS_IC1_CLR_RD_REQ_reg                                                       0xB801B350
+#define set_MIS_IC1_CLR_RD_REQ_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_RD_REQ_reg)=data)
+#define get_MIS_IC1_CLR_RD_REQ_reg   (*((volatile unsigned int*) MIS_IC1_CLR_RD_REQ_reg))
+#define MIS_IC1_CLR_RD_REQ_inst_adr                                                  "0x00D4"
+#define MIS_IC1_CLR_RD_REQ_inst                                                      0x00D4
+#define MIS_IC1_CLR_RD_REQ_clr_rd_req_shift                                          (0)
+#define MIS_IC1_CLR_RD_REQ_clr_rd_req_mask                                           (0x00000001)
+#define MIS_IC1_CLR_RD_REQ_clr_rd_req(data)                                          (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_RD_REQ_clr_rd_req_src(data)                                      ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_RD_REQ_get_clr_rd_req(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_CLR_TX_ABRT                                                          0x1801B354
+#define MIS_IC1_CLR_TX_ABRT_reg_addr                                                 "0xB801B354"
+#define MIS_IC1_CLR_TX_ABRT_reg                                                      0xB801B354
+#define set_MIS_IC1_CLR_TX_ABRT_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_TX_ABRT_reg)=data)
+#define get_MIS_IC1_CLR_TX_ABRT_reg   (*((volatile unsigned int*) MIS_IC1_CLR_TX_ABRT_reg))
+#define MIS_IC1_CLR_TX_ABRT_inst_adr                                                 "0x00D5"
+#define MIS_IC1_CLR_TX_ABRT_inst                                                     0x00D5
+#define MIS_IC1_CLR_TX_ABRT_clr_tx_abrt_shift                                        (0)
+#define MIS_IC1_CLR_TX_ABRT_clr_tx_abrt_mask                                         (0x00000001)
+#define MIS_IC1_CLR_TX_ABRT_clr_tx_abrt(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_TX_ABRT_clr_tx_abrt_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_TX_ABRT_get_clr_tx_abrt(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_CLR_RX_DONE                                                          0x1801B358
+#define MIS_IC1_CLR_RX_DONE_reg_addr                                                 "0xB801B358"
+#define MIS_IC1_CLR_RX_DONE_reg                                                      0xB801B358
+#define set_MIS_IC1_CLR_RX_DONE_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_RX_DONE_reg)=data)
+#define get_MIS_IC1_CLR_RX_DONE_reg   (*((volatile unsigned int*) MIS_IC1_CLR_RX_DONE_reg))
+#define MIS_IC1_CLR_RX_DONE_inst_adr                                                 "0x00D6"
+#define MIS_IC1_CLR_RX_DONE_inst                                                     0x00D6
+#define MIS_IC1_CLR_RX_DONE_clr_rx_done_shift                                        (0)
+#define MIS_IC1_CLR_RX_DONE_clr_rx_done_mask                                         (0x00000001)
+#define MIS_IC1_CLR_RX_DONE_clr_rx_done(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_RX_DONE_clr_rx_done_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_RX_DONE_get_clr_rx_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_CLR_ACTIVITY                                                         0x1801B35C
+#define MIS_IC1_CLR_ACTIVITY_reg_addr                                                "0xB801B35C"
+#define MIS_IC1_CLR_ACTIVITY_reg                                                     0xB801B35C
+#define set_MIS_IC1_CLR_ACTIVITY_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_ACTIVITY_reg)=data)
+#define get_MIS_IC1_CLR_ACTIVITY_reg   (*((volatile unsigned int*) MIS_IC1_CLR_ACTIVITY_reg))
+#define MIS_IC1_CLR_ACTIVITY_inst_adr                                                "0x00D7"
+#define MIS_IC1_CLR_ACTIVITY_inst                                                    0x00D7
+#define MIS_IC1_CLR_ACTIVITY_clr_activity_shift                                      (0)
+#define MIS_IC1_CLR_ACTIVITY_clr_activity_mask                                       (0x00000001)
+#define MIS_IC1_CLR_ACTIVITY_clr_activity(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_ACTIVITY_clr_activity_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_ACTIVITY_get_clr_activity(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_CLR_STOP_DET                                                         0x1801B360
+#define MIS_IC1_CLR_STOP_DET_reg_addr                                                "0xB801B360"
+#define MIS_IC1_CLR_STOP_DET_reg                                                     0xB801B360
+#define set_MIS_IC1_CLR_STOP_DET_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_STOP_DET_reg)=data)
+#define get_MIS_IC1_CLR_STOP_DET_reg   (*((volatile unsigned int*) MIS_IC1_CLR_STOP_DET_reg))
+#define MIS_IC1_CLR_STOP_DET_inst_adr                                                "0x00D8"
+#define MIS_IC1_CLR_STOP_DET_inst                                                    0x00D8
+#define MIS_IC1_CLR_STOP_DET_clr_stop_det_shift                                      (0)
+#define MIS_IC1_CLR_STOP_DET_clr_stop_det_mask                                       (0x00000001)
+#define MIS_IC1_CLR_STOP_DET_clr_stop_det(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_STOP_DET_clr_stop_det_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_STOP_DET_get_clr_stop_det(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_CLR_START_DET                                                        0x1801B364
+#define MIS_IC1_CLR_START_DET_reg_addr                                               "0xB801B364"
+#define MIS_IC1_CLR_START_DET_reg                                                    0xB801B364
+#define set_MIS_IC1_CLR_START_DET_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_START_DET_reg)=data)
+#define get_MIS_IC1_CLR_START_DET_reg   (*((volatile unsigned int*) MIS_IC1_CLR_START_DET_reg))
+#define MIS_IC1_CLR_START_DET_inst_adr                                               "0x00D9"
+#define MIS_IC1_CLR_START_DET_inst                                                   0x00D9
+#define MIS_IC1_CLR_START_DET_clr_start_det_shift                                    (0)
+#define MIS_IC1_CLR_START_DET_clr_start_det_mask                                     (0x00000001)
+#define MIS_IC1_CLR_START_DET_clr_start_det(data)                                    (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_START_DET_clr_start_det_src(data)                                ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_START_DET_get_clr_start_det(data)                                ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_CLR_GEN_CALL                                                         0x1801B368
+#define MIS_IC1_CLR_GEN_CALL_reg_addr                                                "0xB801B368"
+#define MIS_IC1_CLR_GEN_CALL_reg                                                     0xB801B368
+#define set_MIS_IC1_CLR_GEN_CALL_reg(data)   (*((volatile unsigned int*) MIS_IC1_CLR_GEN_CALL_reg)=data)
+#define get_MIS_IC1_CLR_GEN_CALL_reg   (*((volatile unsigned int*) MIS_IC1_CLR_GEN_CALL_reg))
+#define MIS_IC1_CLR_GEN_CALL_inst_adr                                                "0x00DA"
+#define MIS_IC1_CLR_GEN_CALL_inst                                                    0x00DA
+#define MIS_IC1_CLR_GEN_CALL_clr_gen_call_shift                                      (0)
+#define MIS_IC1_CLR_GEN_CALL_clr_gen_call_mask                                       (0x00000001)
+#define MIS_IC1_CLR_GEN_CALL_clr_gen_call(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC1_CLR_GEN_CALL_clr_gen_call_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC1_CLR_GEN_CALL_get_clr_gen_call(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_ENABLE                                                               0x1801B36C
+#define MIS_IC1_ENABLE_reg_addr                                                      "0xB801B36C"
+#define MIS_IC1_ENABLE_reg                                                           0xB801B36C
+#define set_MIS_IC1_ENABLE_reg(data)   (*((volatile unsigned int*) MIS_IC1_ENABLE_reg)=data)
+#define get_MIS_IC1_ENABLE_reg   (*((volatile unsigned int*) MIS_IC1_ENABLE_reg))
+#define MIS_IC1_ENABLE_inst_adr                                                      "0x00DB"
+#define MIS_IC1_ENABLE_inst                                                          0x00DB
+#define MIS_IC1_ENABLE_enable_shift                                                  (0)
+#define MIS_IC1_ENABLE_enable_mask                                                   (0x00000001)
+#define MIS_IC1_ENABLE_enable(data)                                                  (0x00000001&((data)<<0))
+#define MIS_IC1_ENABLE_enable_src(data)                                              ((0x00000001&(data))>>0)
+#define MIS_IC1_ENABLE_get_enable(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_STATUS                                                               0x1801B370
+#define MIS_IC1_STATUS_reg_addr                                                      "0xB801B370"
+#define MIS_IC1_STATUS_reg                                                           0xB801B370
+#define set_MIS_IC1_STATUS_reg(data)   (*((volatile unsigned int*) MIS_IC1_STATUS_reg)=data)
+#define get_MIS_IC1_STATUS_reg   (*((volatile unsigned int*) MIS_IC1_STATUS_reg))
+#define MIS_IC1_STATUS_inst_adr                                                      "0x00DC"
+#define MIS_IC1_STATUS_inst                                                          0x00DC
+#define MIS_IC1_STATUS_slv_activity_shift                                            (6)
+#define MIS_IC1_STATUS_slv_activity_mask                                             (0x00000040)
+#define MIS_IC1_STATUS_slv_activity(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC1_STATUS_slv_activity_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC1_STATUS_get_slv_activity(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC1_STATUS_mst_activity_shift                                            (5)
+#define MIS_IC1_STATUS_mst_activity_mask                                             (0x00000020)
+#define MIS_IC1_STATUS_mst_activity(data)                                            (0x00000020&((data)<<5))
+#define MIS_IC1_STATUS_mst_activity_src(data)                                        ((0x00000020&(data))>>5)
+#define MIS_IC1_STATUS_get_mst_activity(data)                                        ((0x00000020&(data))>>5)
+#define MIS_IC1_STATUS_rff_shift                                                     (4)
+#define MIS_IC1_STATUS_rff_mask                                                      (0x00000010)
+#define MIS_IC1_STATUS_rff(data)                                                     (0x00000010&((data)<<4))
+#define MIS_IC1_STATUS_rff_src(data)                                                 ((0x00000010&(data))>>4)
+#define MIS_IC1_STATUS_get_rff(data)                                                 ((0x00000010&(data))>>4)
+#define MIS_IC1_STATUS_rfne_shift                                                    (3)
+#define MIS_IC1_STATUS_rfne_mask                                                     (0x00000008)
+#define MIS_IC1_STATUS_rfne(data)                                                    (0x00000008&((data)<<3))
+#define MIS_IC1_STATUS_rfne_src(data)                                                ((0x00000008&(data))>>3)
+#define MIS_IC1_STATUS_get_rfne(data)                                                ((0x00000008&(data))>>3)
+#define MIS_IC1_STATUS_tfe_shift                                                     (2)
+#define MIS_IC1_STATUS_tfe_mask                                                      (0x00000004)
+#define MIS_IC1_STATUS_tfe(data)                                                     (0x00000004&((data)<<2))
+#define MIS_IC1_STATUS_tfe_src(data)                                                 ((0x00000004&(data))>>2)
+#define MIS_IC1_STATUS_get_tfe(data)                                                 ((0x00000004&(data))>>2)
+#define MIS_IC1_STATUS_tfnf_shift                                                    (1)
+#define MIS_IC1_STATUS_tfnf_mask                                                     (0x00000002)
+#define MIS_IC1_STATUS_tfnf(data)                                                    (0x00000002&((data)<<1))
+#define MIS_IC1_STATUS_tfnf_src(data)                                                ((0x00000002&(data))>>1)
+#define MIS_IC1_STATUS_get_tfnf(data)                                                ((0x00000002&(data))>>1)
+#define MIS_IC1_STATUS_activity_shift                                                (0)
+#define MIS_IC1_STATUS_activity_mask                                                 (0x00000001)
+#define MIS_IC1_STATUS_activity(data)                                                (0x00000001&((data)<<0))
+#define MIS_IC1_STATUS_activity_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_IC1_STATUS_get_activity(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_TXFLR                                                                0x1801B374
+#define MIS_IC1_TXFLR_reg_addr                                                       "0xB801B374"
+#define MIS_IC1_TXFLR_reg                                                            0xB801B374
+#define set_MIS_IC1_TXFLR_reg(data)   (*((volatile unsigned int*) MIS_IC1_TXFLR_reg)=data)
+#define get_MIS_IC1_TXFLR_reg   (*((volatile unsigned int*) MIS_IC1_TXFLR_reg))
+#define MIS_IC1_TXFLR_inst_adr                                                       "0x00DD"
+#define MIS_IC1_TXFLR_inst                                                           0x00DD
+#define MIS_IC1_TXFLR_txflr_shift                                                    (0)
+#define MIS_IC1_TXFLR_txflr_mask                                                     (0x0000000F)
+#define MIS_IC1_TXFLR_txflr(data)                                                    (0x0000000F&((data)<<0))
+#define MIS_IC1_TXFLR_txflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define MIS_IC1_TXFLR_get_txflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC1_RXFLR                                                                0x1801B378
+#define MIS_IC1_RXFLR_reg_addr                                                       "0xB801B378"
+#define MIS_IC1_RXFLR_reg                                                            0xB801B378
+#define set_MIS_IC1_RXFLR_reg(data)   (*((volatile unsigned int*) MIS_IC1_RXFLR_reg)=data)
+#define get_MIS_IC1_RXFLR_reg   (*((volatile unsigned int*) MIS_IC1_RXFLR_reg))
+#define MIS_IC1_RXFLR_inst_adr                                                       "0x00DE"
+#define MIS_IC1_RXFLR_inst                                                           0x00DE
+#define MIS_IC1_RXFLR_rxflr_shift                                                    (0)
+#define MIS_IC1_RXFLR_rxflr_mask                                                     (0x0000000F)
+#define MIS_IC1_RXFLR_rxflr(data)                                                    (0x0000000F&((data)<<0))
+#define MIS_IC1_RXFLR_rxflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define MIS_IC1_RXFLR_get_rxflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC1_SDA_HOLD                                                             0x1801B37C
+#define MIS_IC1_SDA_HOLD_reg_addr                                                    "0xB801B37C"
+#define MIS_IC1_SDA_HOLD_reg                                                         0xB801B37C
+#define set_MIS_IC1_SDA_HOLD_reg(data)   (*((volatile unsigned int*) MIS_IC1_SDA_HOLD_reg)=data)
+#define get_MIS_IC1_SDA_HOLD_reg   (*((volatile unsigned int*) MIS_IC1_SDA_HOLD_reg))
+#define MIS_IC1_SDA_HOLD_inst_adr                                                    "0x00DF"
+#define MIS_IC1_SDA_HOLD_inst                                                        0x00DF
+#define MIS_IC1_SDA_HOLD_sda_hold_shift                                              (0)
+#define MIS_IC1_SDA_HOLD_sda_hold_mask                                               (0x0000FFFF)
+#define MIS_IC1_SDA_HOLD_sda_hold(data)                                              (0x0000FFFF&((data)<<0))
+#define MIS_IC1_SDA_HOLD_sda_hold_src(data)                                          ((0x0000FFFF&(data))>>0)
+#define MIS_IC1_SDA_HOLD_get_sda_hold(data)                                          ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC1_TX_ABRT_SOURCE                                                       0x1801B380
+#define MIS_IC1_TX_ABRT_SOURCE_reg_addr                                              "0xB801B380"
+#define MIS_IC1_TX_ABRT_SOURCE_reg                                                   0xB801B380
+#define set_MIS_IC1_TX_ABRT_SOURCE_reg(data)   (*((volatile unsigned int*) MIS_IC1_TX_ABRT_SOURCE_reg)=data)
+#define get_MIS_IC1_TX_ABRT_SOURCE_reg   (*((volatile unsigned int*) MIS_IC1_TX_ABRT_SOURCE_reg))
+#define MIS_IC1_TX_ABRT_SOURCE_inst_adr                                              "0x00E0"
+#define MIS_IC1_TX_ABRT_SOURCE_inst                                                  0x00E0
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slvrd_intx_shift                                 (15)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slvrd_intx_mask                                  (0x00008000)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slvrd_intx(data)                                 (0x00008000&((data)<<15))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slvrd_intx_src(data)                             ((0x00008000&(data))>>15)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_slvrd_intx(data)                             ((0x00008000&(data))>>15)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slv_arblost_shift                                (14)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slv_arblost_mask                                 (0x00004000)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slv_arblost(data)                                (0x00004000&((data)<<14))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slv_arblost_src(data)                            ((0x00004000&(data))>>14)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_slv_arblost(data)                            ((0x00004000&(data))>>14)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slvflush_txfifo_shift                            (13)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slvflush_txfifo_mask                             (0x00002000)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slvflush_txfifo(data)                            (0x00002000&((data)<<13))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_slvflush_txfifo_src(data)                        ((0x00002000&(data))>>13)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_slvflush_txfifo(data)                        ((0x00002000&(data))>>13)
+#define MIS_IC1_TX_ABRT_SOURCE_arb_lost_shift                                        (12)
+#define MIS_IC1_TX_ABRT_SOURCE_arb_lost_mask                                         (0x00001000)
+#define MIS_IC1_TX_ABRT_SOURCE_arb_lost(data)                                        (0x00001000&((data)<<12))
+#define MIS_IC1_TX_ABRT_SOURCE_arb_lost_src(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC1_TX_ABRT_SOURCE_get_arb_lost(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC1_TX_ABRT_SOURCE_arb_master_dis_shift                                  (11)
+#define MIS_IC1_TX_ABRT_SOURCE_arb_master_dis_mask                                   (0x00000800)
+#define MIS_IC1_TX_ABRT_SOURCE_arb_master_dis(data)                                  (0x00000800&((data)<<11))
+#define MIS_IC1_TX_ABRT_SOURCE_arb_master_dis_src(data)                              ((0x00000800&(data))>>11)
+#define MIS_IC1_TX_ABRT_SOURCE_get_arb_master_dis(data)                              ((0x00000800&(data))>>11)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_shift                             (10)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_mask                              (0x00000400)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10b_rd_norstrt(data)                             (0x00000400&((data)<<10))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_src(data)                         ((0x00000400&(data))>>10)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_10b_rd_norstrt(data)                         ((0x00000400&(data))>>10)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_sbyte_norstrt_shift                              (9)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_sbyte_norstrt_mask                               (0x00000200)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_sbyte_norstrt(data)                              (0x00000200&((data)<<9))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_sbyte_norstrt_src(data)                          ((0x00000200&(data))>>9)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_sbyte_norstrt(data)                          ((0x00000200&(data))>>9)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_hs_norstrt_shift                                 (8)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_hs_norstrt_mask                                  (0x00000100)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_hs_norstrt(data)                                 (0x00000100&((data)<<8))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_hs_norstrt_src(data)                             ((0x00000100&(data))>>8)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_hs_norstrt(data)                             ((0x00000100&(data))>>8)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_sbyte_ackdet_shift                               (7)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_sbyte_ackdet_mask                                (0x00000080)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_sbyte_ackdet(data)                               (0x00000080&((data)<<7))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_sbyte_ackdet_src(data)                           ((0x00000080&(data))>>7)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_sbyte_ackdet(data)                           ((0x00000080&(data))>>7)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_hs_ackdet_shift                                  (6)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_hs_ackdet_mask                                   (0x00000040)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_hs_ackdet(data)                                  (0x00000040&((data)<<6))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_hs_ackdet_src(data)                              ((0x00000040&(data))>>6)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_hs_ackdet(data)                              ((0x00000040&(data))>>6)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_gcall_read_shift                                 (5)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_gcall_read_mask                                  (0x00000020)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_gcall_read(data)                                 (0x00000020&((data)<<5))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_gcall_read_src(data)                             ((0x00000020&(data))>>5)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_gcall_read(data)                             ((0x00000020&(data))>>5)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_gcall_noack_shift                                (4)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_gcall_noack_mask                                 (0x00000010)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_gcall_noack(data)                                (0x00000010&((data)<<4))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_gcall_noack_src(data)                            ((0x00000010&(data))>>4)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_gcall_noack(data)                            ((0x00000010&(data))>>4)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_txdata_noack_shift                               (3)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_txdata_noack_mask                                (0x00000008)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_txdata_noack(data)                               (0x00000008&((data)<<3))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_txdata_noack_src(data)                           ((0x00000008&(data))>>3)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_txdata_noack(data)                           ((0x00000008&(data))>>3)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10addr2_noack_shift                              (2)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10addr2_noack_mask                               (0x00000004)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10addr2_noack(data)                              (0x00000004&((data)<<2))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10addr2_noack_src(data)                          ((0x00000004&(data))>>2)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_10addr2_noack(data)                          ((0x00000004&(data))>>2)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10addr1_noack_shift                              (1)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10addr1_noack_mask                               (0x00000002)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10addr1_noack(data)                              (0x00000002&((data)<<1))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_10addr1_noack_src(data)                          ((0x00000002&(data))>>1)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_10addr1_noack(data)                          ((0x00000002&(data))>>1)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_7b_addr_noack_shift                              (0)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_7b_addr_noack_mask                               (0x00000001)
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_7b_addr_noack(data)                              (0x00000001&((data)<<0))
+#define MIS_IC1_TX_ABRT_SOURCE_abrt_7b_addr_noack_src(data)                          ((0x00000001&(data))>>0)
+#define MIS_IC1_TX_ABRT_SOURCE_get_abrt_7b_addr_noack(data)                          ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_SLV_DATA_NACK_ONLY                                                   0x1801B384
+#define MIS_IC1_SLV_DATA_NACK_ONLY_reg_addr                                          "0xB801B384"
+#define MIS_IC1_SLV_DATA_NACK_ONLY_reg                                               0xB801B384
+#define set_MIS_IC1_SLV_DATA_NACK_ONLY_reg(data)   (*((volatile unsigned int*) MIS_IC1_SLV_DATA_NACK_ONLY_reg)=data)
+#define get_MIS_IC1_SLV_DATA_NACK_ONLY_reg   (*((volatile unsigned int*) MIS_IC1_SLV_DATA_NACK_ONLY_reg))
+#define MIS_IC1_SLV_DATA_NACK_ONLY_inst_adr                                          "0x00E1"
+#define MIS_IC1_SLV_DATA_NACK_ONLY_inst                                              0x00E1
+#define MIS_IC1_SLV_DATA_NACK_ONLY_nack_shift                                        (0)
+#define MIS_IC1_SLV_DATA_NACK_ONLY_nack_mask                                         (0x00000001)
+#define MIS_IC1_SLV_DATA_NACK_ONLY_nack(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC1_SLV_DATA_NACK_ONLY_nack_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC1_SLV_DATA_NACK_ONLY_get_nack(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_DMA_CR                                                               0x1801B388
+#define MIS_IC1_DMA_CR_reg_addr                                                      "0xB801B388"
+#define MIS_IC1_DMA_CR_reg                                                           0xB801B388
+#define set_MIS_IC1_DMA_CR_reg(data)   (*((volatile unsigned int*) MIS_IC1_DMA_CR_reg)=data)
+#define get_MIS_IC1_DMA_CR_reg   (*((volatile unsigned int*) MIS_IC1_DMA_CR_reg))
+#define MIS_IC1_DMA_CR_inst_adr                                                      "0x00E2"
+#define MIS_IC1_DMA_CR_inst                                                          0x00E2
+#define MIS_IC1_DMA_CR_tdmae_shift                                                   (1)
+#define MIS_IC1_DMA_CR_tdmae_mask                                                    (0x00000002)
+#define MIS_IC1_DMA_CR_tdmae(data)                                                   (0x00000002&((data)<<1))
+#define MIS_IC1_DMA_CR_tdmae_src(data)                                               ((0x00000002&(data))>>1)
+#define MIS_IC1_DMA_CR_get_tdmae(data)                                               ((0x00000002&(data))>>1)
+#define MIS_IC1_DMA_CR_rdmae_shift                                                   (0)
+#define MIS_IC1_DMA_CR_rdmae_mask                                                    (0x00000001)
+#define MIS_IC1_DMA_CR_rdmae(data)                                                   (0x00000001&((data)<<0))
+#define MIS_IC1_DMA_CR_rdmae_src(data)                                               ((0x00000001&(data))>>0)
+#define MIS_IC1_DMA_CR_get_rdmae(data)                                               ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_DMA_TDLR                                                             0x1801B38C
+#define MIS_IC1_DMA_TDLR_reg_addr                                                    "0xB801B38C"
+#define MIS_IC1_DMA_TDLR_reg                                                         0xB801B38C
+#define set_MIS_IC1_DMA_TDLR_reg(data)   (*((volatile unsigned int*) MIS_IC1_DMA_TDLR_reg)=data)
+#define get_MIS_IC1_DMA_TDLR_reg   (*((volatile unsigned int*) MIS_IC1_DMA_TDLR_reg))
+#define MIS_IC1_DMA_TDLR_inst_adr                                                    "0x00E3"
+#define MIS_IC1_DMA_TDLR_inst                                                        0x00E3
+#define MIS_IC1_DMA_TDLR_dmatdl_shift                                                (0)
+#define MIS_IC1_DMA_TDLR_dmatdl_mask                                                 (0x00000007)
+#define MIS_IC1_DMA_TDLR_dmatdl(data)                                                (0x00000007&((data)<<0))
+#define MIS_IC1_DMA_TDLR_dmatdl_src(data)                                            ((0x00000007&(data))>>0)
+#define MIS_IC1_DMA_TDLR_get_dmatdl(data)                                            ((0x00000007&(data))>>0)
+
+
+#define MIS_IC1_DMA_RDLR                                                             0x1801B390
+#define MIS_IC1_DMA_RDLR_reg_addr                                                    "0xB801B390"
+#define MIS_IC1_DMA_RDLR_reg                                                         0xB801B390
+#define set_MIS_IC1_DMA_RDLR_reg(data)   (*((volatile unsigned int*) MIS_IC1_DMA_RDLR_reg)=data)
+#define get_MIS_IC1_DMA_RDLR_reg   (*((volatile unsigned int*) MIS_IC1_DMA_RDLR_reg))
+#define MIS_IC1_DMA_RDLR_inst_adr                                                    "0x00E4"
+#define MIS_IC1_DMA_RDLR_inst                                                        0x00E4
+#define MIS_IC1_DMA_RDLR_dmardl_shift                                                (0)
+#define MIS_IC1_DMA_RDLR_dmardl_mask                                                 (0x0000000F)
+#define MIS_IC1_DMA_RDLR_dmardl(data)                                                (0x0000000F&((data)<<0))
+#define MIS_IC1_DMA_RDLR_dmardl_src(data)                                            ((0x0000000F&(data))>>0)
+#define MIS_IC1_DMA_RDLR_get_dmardl(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC1_SDA_SETUP                                                            0x1801B394
+#define MIS_IC1_SDA_SETUP_reg_addr                                                   "0xB801B394"
+#define MIS_IC1_SDA_SETUP_reg                                                        0xB801B394
+#define set_MIS_IC1_SDA_SETUP_reg(data)   (*((volatile unsigned int*) MIS_IC1_SDA_SETUP_reg)=data)
+#define get_MIS_IC1_SDA_SETUP_reg   (*((volatile unsigned int*) MIS_IC1_SDA_SETUP_reg))
+#define MIS_IC1_SDA_SETUP_inst_adr                                                   "0x00E5"
+#define MIS_IC1_SDA_SETUP_inst                                                       0x00E5
+#define MIS_IC1_SDA_SETUP_sda_setup_shift                                            (0)
+#define MIS_IC1_SDA_SETUP_sda_setup_mask                                             (0x000000FF)
+#define MIS_IC1_SDA_SETUP_sda_setup(data)                                            (0x000000FF&((data)<<0))
+#define MIS_IC1_SDA_SETUP_sda_setup_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIS_IC1_SDA_SETUP_get_sda_setup(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC1_ACK_GENERAL_CALL                                                     0x1801B398
+#define MIS_IC1_ACK_GENERAL_CALL_reg_addr                                            "0xB801B398"
+#define MIS_IC1_ACK_GENERAL_CALL_reg                                                 0xB801B398
+#define set_MIS_IC1_ACK_GENERAL_CALL_reg(data)   (*((volatile unsigned int*) MIS_IC1_ACK_GENERAL_CALL_reg)=data)
+#define get_MIS_IC1_ACK_GENERAL_CALL_reg   (*((volatile unsigned int*) MIS_IC1_ACK_GENERAL_CALL_reg))
+#define MIS_IC1_ACK_GENERAL_CALL_inst_adr                                            "0x00E6"
+#define MIS_IC1_ACK_GENERAL_CALL_inst                                                0x00E6
+#define MIS_IC1_ACK_GENERAL_CALL_ack_gen_call_shift                                  (0)
+#define MIS_IC1_ACK_GENERAL_CALL_ack_gen_call_mask                                   (0x00000001)
+#define MIS_IC1_ACK_GENERAL_CALL_ack_gen_call(data)                                  (0x00000001&((data)<<0))
+#define MIS_IC1_ACK_GENERAL_CALL_ack_gen_call_src(data)                              ((0x00000001&(data))>>0)
+#define MIS_IC1_ACK_GENERAL_CALL_get_ack_gen_call(data)                              ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_ENABLE_STATUS                                                        0x1801B39C
+#define MIS_IC1_ENABLE_STATUS_reg_addr                                               "0xB801B39C"
+#define MIS_IC1_ENABLE_STATUS_reg                                                    0xB801B39C
+#define set_MIS_IC1_ENABLE_STATUS_reg(data)   (*((volatile unsigned int*) MIS_IC1_ENABLE_STATUS_reg)=data)
+#define get_MIS_IC1_ENABLE_STATUS_reg   (*((volatile unsigned int*) MIS_IC1_ENABLE_STATUS_reg))
+#define MIS_IC1_ENABLE_STATUS_inst_adr                                               "0x00E7"
+#define MIS_IC1_ENABLE_STATUS_inst                                                   0x00E7
+#define MIS_IC1_ENABLE_STATUS_slv_rx_data_lost_shift                                 (2)
+#define MIS_IC1_ENABLE_STATUS_slv_rx_data_lost_mask                                  (0x00000004)
+#define MIS_IC1_ENABLE_STATUS_slv_rx_data_lost(data)                                 (0x00000004&((data)<<2))
+#define MIS_IC1_ENABLE_STATUS_slv_rx_data_lost_src(data)                             ((0x00000004&(data))>>2)
+#define MIS_IC1_ENABLE_STATUS_get_slv_rx_data_lost(data)                             ((0x00000004&(data))>>2)
+#define MIS_IC1_ENABLE_STATUS_slv_disabled_whi_shift                                 (1)
+#define MIS_IC1_ENABLE_STATUS_slv_disabled_whi_mask                                  (0x00000002)
+#define MIS_IC1_ENABLE_STATUS_slv_disabled_whi(data)                                 (0x00000002&((data)<<1))
+#define MIS_IC1_ENABLE_STATUS_slv_disabled_whi_src(data)                             ((0x00000002&(data))>>1)
+#define MIS_IC1_ENABLE_STATUS_get_slv_disabled_whi(data)                             ((0x00000002&(data))>>1)
+#define MIS_IC1_ENABLE_STATUS_ic_en_shift                                            (0)
+#define MIS_IC1_ENABLE_STATUS_ic_en_mask                                             (0x00000001)
+#define MIS_IC1_ENABLE_STATUS_ic_en(data)                                            (0x00000001&((data)<<0))
+#define MIS_IC1_ENABLE_STATUS_ic_en_src(data)                                        ((0x00000001&(data))>>0)
+#define MIS_IC1_ENABLE_STATUS_get_ic_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define MIS_IC1_COMP_PARAM_1                                                         0x1801B3F4
+#define MIS_IC1_COMP_PARAM_1_reg_addr                                                "0xB801B3F4"
+#define MIS_IC1_COMP_PARAM_1_reg                                                     0xB801B3F4
+#define set_MIS_IC1_COMP_PARAM_1_reg(data)   (*((volatile unsigned int*) MIS_IC1_COMP_PARAM_1_reg)=data)
+#define get_MIS_IC1_COMP_PARAM_1_reg   (*((volatile unsigned int*) MIS_IC1_COMP_PARAM_1_reg))
+#define MIS_IC1_COMP_PARAM_1_inst_adr                                                "0x00FD"
+#define MIS_IC1_COMP_PARAM_1_inst                                                    0x00FD
+#define MIS_IC1_COMP_PARAM_1_tx_buffer_depth_shift                                   (16)
+#define MIS_IC1_COMP_PARAM_1_tx_buffer_depth_mask                                    (0x00FF0000)
+#define MIS_IC1_COMP_PARAM_1_tx_buffer_depth(data)                                   (0x00FF0000&((data)<<16))
+#define MIS_IC1_COMP_PARAM_1_tx_buffer_depth_src(data)                               ((0x00FF0000&(data))>>16)
+#define MIS_IC1_COMP_PARAM_1_get_tx_buffer_depth(data)                               ((0x00FF0000&(data))>>16)
+#define MIS_IC1_COMP_PARAM_1_rx_buffer_depth_shift                                   (8)
+#define MIS_IC1_COMP_PARAM_1_rx_buffer_depth_mask                                    (0x0000FF00)
+#define MIS_IC1_COMP_PARAM_1_rx_buffer_depth(data)                                   (0x0000FF00&((data)<<8))
+#define MIS_IC1_COMP_PARAM_1_rx_buffer_depth_src(data)                               ((0x0000FF00&(data))>>8)
+#define MIS_IC1_COMP_PARAM_1_get_rx_buffer_depth(data)                               ((0x0000FF00&(data))>>8)
+#define MIS_IC1_COMP_PARAM_1_add_encoded_params_shift                                (7)
+#define MIS_IC1_COMP_PARAM_1_add_encoded_params_mask                                 (0x00000080)
+#define MIS_IC1_COMP_PARAM_1_add_encoded_params(data)                                (0x00000080&((data)<<7))
+#define MIS_IC1_COMP_PARAM_1_add_encoded_params_src(data)                            ((0x00000080&(data))>>7)
+#define MIS_IC1_COMP_PARAM_1_get_add_encoded_params(data)                            ((0x00000080&(data))>>7)
+#define MIS_IC1_COMP_PARAM_1_has_dma_shift                                           (6)
+#define MIS_IC1_COMP_PARAM_1_has_dma_mask                                            (0x00000040)
+#define MIS_IC1_COMP_PARAM_1_has_dma(data)                                           (0x00000040&((data)<<6))
+#define MIS_IC1_COMP_PARAM_1_has_dma_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC1_COMP_PARAM_1_get_has_dma(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC1_COMP_PARAM_1_intr_io_shift                                           (5)
+#define MIS_IC1_COMP_PARAM_1_intr_io_mask                                            (0x00000020)
+#define MIS_IC1_COMP_PARAM_1_intr_io(data)                                           (0x00000020&((data)<<5))
+#define MIS_IC1_COMP_PARAM_1_intr_io_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC1_COMP_PARAM_1_get_intr_io(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC1_COMP_PARAM_1_hc_count_values_shift                                   (4)
+#define MIS_IC1_COMP_PARAM_1_hc_count_values_mask                                    (0x00000010)
+#define MIS_IC1_COMP_PARAM_1_hc_count_values(data)                                   (0x00000010&((data)<<4))
+#define MIS_IC1_COMP_PARAM_1_hc_count_values_src(data)                               ((0x00000010&(data))>>4)
+#define MIS_IC1_COMP_PARAM_1_get_hc_count_values(data)                               ((0x00000010&(data))>>4)
+#define MIS_IC1_COMP_PARAM_1_max_speed_mode_shift                                    (2)
+#define MIS_IC1_COMP_PARAM_1_max_speed_mode_mask                                     (0x0000000C)
+#define MIS_IC1_COMP_PARAM_1_max_speed_mode(data)                                    (0x0000000C&((data)<<2))
+#define MIS_IC1_COMP_PARAM_1_max_speed_mode_src(data)                                ((0x0000000C&(data))>>2)
+#define MIS_IC1_COMP_PARAM_1_get_max_speed_mode(data)                                ((0x0000000C&(data))>>2)
+#define MIS_IC1_COMP_PARAM_1_apb_data_width_shift                                    (0)
+#define MIS_IC1_COMP_PARAM_1_apb_data_width_mask                                     (0x00000003)
+#define MIS_IC1_COMP_PARAM_1_apb_data_width(data)                                    (0x00000003&((data)<<0))
+#define MIS_IC1_COMP_PARAM_1_apb_data_width_src(data)                                ((0x00000003&(data))>>0)
+#define MIS_IC1_COMP_PARAM_1_get_apb_data_width(data)                                ((0x00000003&(data))>>0)
+
+
+#define MIS_IC1_COMP_VERSION                                                         0x1801B3F8
+#define MIS_IC1_COMP_VERSION_reg_addr                                                "0xB801B3F8"
+#define MIS_IC1_COMP_VERSION_reg                                                     0xB801B3F8
+#define set_MIS_IC1_COMP_VERSION_reg(data)   (*((volatile unsigned int*) MIS_IC1_COMP_VERSION_reg)=data)
+#define get_MIS_IC1_COMP_VERSION_reg   (*((volatile unsigned int*) MIS_IC1_COMP_VERSION_reg))
+#define MIS_IC1_COMP_VERSION_inst_adr                                                "0x00FE"
+#define MIS_IC1_COMP_VERSION_inst                                                    0x00FE
+#define MIS_IC1_COMP_VERSION_ic_comp_version_shift                                   (0)
+#define MIS_IC1_COMP_VERSION_ic_comp_version_mask                                    (0xFFFFFFFF)
+#define MIS_IC1_COMP_VERSION_ic_comp_version(data)                                   (0xFFFFFFFF&((data)<<0))
+#define MIS_IC1_COMP_VERSION_ic_comp_version_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define MIS_IC1_COMP_VERSION_get_ic_comp_version(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_IC1_COMP_TYPE                                                            0x1801B3FC
+#define MIS_IC1_COMP_TYPE_reg_addr                                                   "0xB801B3FC"
+#define MIS_IC1_COMP_TYPE_reg                                                        0xB801B3FC
+#define set_MIS_IC1_COMP_TYPE_reg(data)   (*((volatile unsigned int*) MIS_IC1_COMP_TYPE_reg)=data)
+#define get_MIS_IC1_COMP_TYPE_reg   (*((volatile unsigned int*) MIS_IC1_COMP_TYPE_reg))
+#define MIS_IC1_COMP_TYPE_inst_adr                                                   "0x00FF"
+#define MIS_IC1_COMP_TYPE_inst                                                       0x00FF
+#define MIS_IC1_COMP_TYPE_ic_comp_type_shift                                         (0)
+#define MIS_IC1_COMP_TYPE_ic_comp_type_mask                                          (0xFFFFFFFF)
+#define MIS_IC1_COMP_TYPE_ic_comp_type(data)                                         (0xFFFFFFFF&((data)<<0))
+#define MIS_IC1_COMP_TYPE_ic_comp_type_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define MIS_IC1_COMP_TYPE_get_ic_comp_type(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_IC2_CON                                                                  0x1801B700
+#define MIS_IC2_CON_reg_addr                                                         "0xB801B700"
+#define MIS_IC2_CON_reg                                                              0xB801B700
+#define set_MIS_IC2_CON_reg(data)   (*((volatile unsigned int*) MIS_IC2_CON_reg)=data)
+#define get_MIS_IC2_CON_reg   (*((volatile unsigned int*) MIS_IC2_CON_reg))
+#define MIS_IC2_CON_inst_adr                                                         "0x00C0"
+#define MIS_IC2_CON_inst                                                             0x00C0
+#define MIS_IC2_CON_ic_slave_disable_shift                                           (6)
+#define MIS_IC2_CON_ic_slave_disable_mask                                            (0x00000040)
+#define MIS_IC2_CON_ic_slave_disable(data)                                           (0x00000040&((data)<<6))
+#define MIS_IC2_CON_ic_slave_disable_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC2_CON_get_ic_slave_disable(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC2_CON_ic_restart_en_shift                                              (5)
+#define MIS_IC2_CON_ic_restart_en_mask                                               (0x00000020)
+#define MIS_IC2_CON_ic_restart_en(data)                                              (0x00000020&((data)<<5))
+#define MIS_IC2_CON_ic_restart_en_src(data)                                          ((0x00000020&(data))>>5)
+#define MIS_IC2_CON_get_ic_restart_en(data)                                          ((0x00000020&(data))>>5)
+#define MIS_IC2_CON_ic_10bitaddr_master_shift                                        (4)
+#define MIS_IC2_CON_ic_10bitaddr_master_mask                                         (0x00000010)
+#define MIS_IC2_CON_ic_10bitaddr_master(data)                                        (0x00000010&((data)<<4))
+#define MIS_IC2_CON_ic_10bitaddr_master_src(data)                                    ((0x00000010&(data))>>4)
+#define MIS_IC2_CON_get_ic_10bitaddr_master(data)                                    ((0x00000010&(data))>>4)
+#define MIS_IC2_CON_ic_10bitaddr_slave_shift                                         (3)
+#define MIS_IC2_CON_ic_10bitaddr_slave_mask                                          (0x00000008)
+#define MIS_IC2_CON_ic_10bitaddr_slave(data)                                         (0x00000008&((data)<<3))
+#define MIS_IC2_CON_ic_10bitaddr_slave_src(data)                                     ((0x00000008&(data))>>3)
+#define MIS_IC2_CON_get_ic_10bitaddr_slave(data)                                     ((0x00000008&(data))>>3)
+#define MIS_IC2_CON_speed_shift                                                      (1)
+#define MIS_IC2_CON_speed_mask                                                       (0x00000006)
+#define MIS_IC2_CON_speed(data)                                                      (0x00000006&((data)<<1))
+#define MIS_IC2_CON_speed_src(data)                                                  ((0x00000006&(data))>>1)
+#define MIS_IC2_CON_get_speed(data)                                                  ((0x00000006&(data))>>1)
+#define MIS_IC2_CON_master_mode_shift                                                (0)
+#define MIS_IC2_CON_master_mode_mask                                                 (0x00000001)
+#define MIS_IC2_CON_master_mode(data)                                                (0x00000001&((data)<<0))
+#define MIS_IC2_CON_master_mode_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_IC2_CON_get_master_mode(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_TAR                                                                  0x1801B704
+#define MIS_IC2_TAR_reg_addr                                                         "0xB801B704"
+#define MIS_IC2_TAR_reg                                                              0xB801B704
+#define set_MIS_IC2_TAR_reg(data)   (*((volatile unsigned int*) MIS_IC2_TAR_reg)=data)
+#define get_MIS_IC2_TAR_reg   (*((volatile unsigned int*) MIS_IC2_TAR_reg))
+#define MIS_IC2_TAR_inst_adr                                                         "0x00C1"
+#define MIS_IC2_TAR_inst                                                             0x00C1
+#define MIS_IC2_TAR_ic_10bitaddr_master_shift                                        (12)
+#define MIS_IC2_TAR_ic_10bitaddr_master_mask                                         (0x00001000)
+#define MIS_IC2_TAR_ic_10bitaddr_master(data)                                        (0x00001000&((data)<<12))
+#define MIS_IC2_TAR_ic_10bitaddr_master_src(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC2_TAR_get_ic_10bitaddr_master(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC2_TAR_special_shift                                                    (11)
+#define MIS_IC2_TAR_special_mask                                                     (0x00000800)
+#define MIS_IC2_TAR_special(data)                                                    (0x00000800&((data)<<11))
+#define MIS_IC2_TAR_special_src(data)                                                ((0x00000800&(data))>>11)
+#define MIS_IC2_TAR_get_special(data)                                                ((0x00000800&(data))>>11)
+#define MIS_IC2_TAR_gc_or_start_shift                                                (10)
+#define MIS_IC2_TAR_gc_or_start_mask                                                 (0x00000400)
+#define MIS_IC2_TAR_gc_or_start(data)                                                (0x00000400&((data)<<10))
+#define MIS_IC2_TAR_gc_or_start_src(data)                                            ((0x00000400&(data))>>10)
+#define MIS_IC2_TAR_get_gc_or_start(data)                                            ((0x00000400&(data))>>10)
+#define MIS_IC2_TAR_ic_tar_shift                                                     (0)
+#define MIS_IC2_TAR_ic_tar_mask                                                      (0x000003FF)
+#define MIS_IC2_TAR_ic_tar(data)                                                     (0x000003FF&((data)<<0))
+#define MIS_IC2_TAR_ic_tar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define MIS_IC2_TAR_get_ic_tar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define MIS_IC2_SAR                                                                  0x1801B708
+#define MIS_IC2_SAR_reg_addr                                                         "0xB801B708"
+#define MIS_IC2_SAR_reg                                                              0xB801B708
+#define set_MIS_IC2_SAR_reg(data)   (*((volatile unsigned int*) MIS_IC2_SAR_reg)=data)
+#define get_MIS_IC2_SAR_reg   (*((volatile unsigned int*) MIS_IC2_SAR_reg))
+#define MIS_IC2_SAR_inst_adr                                                         "0x00C2"
+#define MIS_IC2_SAR_inst                                                             0x00C2
+#define MIS_IC2_SAR_ic_sar_shift                                                     (0)
+#define MIS_IC2_SAR_ic_sar_mask                                                      (0x000003FF)
+#define MIS_IC2_SAR_ic_sar(data)                                                     (0x000003FF&((data)<<0))
+#define MIS_IC2_SAR_ic_sar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define MIS_IC2_SAR_get_ic_sar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define MIS_IC2_HS_MADDR                                                             0x1801B70C
+#define MIS_IC2_HS_MADDR_reg_addr                                                    "0xB801B70C"
+#define MIS_IC2_HS_MADDR_reg                                                         0xB801B70C
+#define set_MIS_IC2_HS_MADDR_reg(data)   (*((volatile unsigned int*) MIS_IC2_HS_MADDR_reg)=data)
+#define get_MIS_IC2_HS_MADDR_reg   (*((volatile unsigned int*) MIS_IC2_HS_MADDR_reg))
+#define MIS_IC2_HS_MADDR_inst_adr                                                    "0x00C3"
+#define MIS_IC2_HS_MADDR_inst                                                        0x00C3
+#define MIS_IC2_HS_MADDR_ic_hs_mar_shift                                             (0)
+#define MIS_IC2_HS_MADDR_ic_hs_mar_mask                                              (0x00000007)
+#define MIS_IC2_HS_MADDR_ic_hs_mar(data)                                             (0x00000007&((data)<<0))
+#define MIS_IC2_HS_MADDR_ic_hs_mar_src(data)                                         ((0x00000007&(data))>>0)
+#define MIS_IC2_HS_MADDR_get_ic_hs_mar(data)                                         ((0x00000007&(data))>>0)
+
+
+#define MIS_IC2_DATA_CMD                                                             0x1801B710
+#define MIS_IC2_DATA_CMD_reg_addr                                                    "0xB801B710"
+#define MIS_IC2_DATA_CMD_reg                                                         0xB801B710
+#define set_MIS_IC2_DATA_CMD_reg(data)   (*((volatile unsigned int*) MIS_IC2_DATA_CMD_reg)=data)
+#define get_MIS_IC2_DATA_CMD_reg   (*((volatile unsigned int*) MIS_IC2_DATA_CMD_reg))
+#define MIS_IC2_DATA_CMD_inst_adr                                                    "0x00C4"
+#define MIS_IC2_DATA_CMD_inst                                                        0x00C4
+#define MIS_IC2_DATA_CMD_restart_shift                                               (10)
+#define MIS_IC2_DATA_CMD_restart_mask                                                (0x00000400)
+#define MIS_IC2_DATA_CMD_restart(data)                                               (0x00000400&((data)<<10))
+#define MIS_IC2_DATA_CMD_restart_src(data)                                           ((0x00000400&(data))>>10)
+#define MIS_IC2_DATA_CMD_get_restart(data)                                           ((0x00000400&(data))>>10)
+#define MIS_IC2_DATA_CMD_stop_shift                                                  (9)
+#define MIS_IC2_DATA_CMD_stop_mask                                                   (0x00000200)
+#define MIS_IC2_DATA_CMD_stop(data)                                                  (0x00000200&((data)<<9))
+#define MIS_IC2_DATA_CMD_stop_src(data)                                              ((0x00000200&(data))>>9)
+#define MIS_IC2_DATA_CMD_get_stop(data)                                              ((0x00000200&(data))>>9)
+#define MIS_IC2_DATA_CMD_cmd_shift                                                   (8)
+#define MIS_IC2_DATA_CMD_cmd_mask                                                    (0x00000100)
+#define MIS_IC2_DATA_CMD_cmd(data)                                                   (0x00000100&((data)<<8))
+#define MIS_IC2_DATA_CMD_cmd_src(data)                                               ((0x00000100&(data))>>8)
+#define MIS_IC2_DATA_CMD_get_cmd(data)                                               ((0x00000100&(data))>>8)
+#define MIS_IC2_DATA_CMD_dat_shift                                                   (0)
+#define MIS_IC2_DATA_CMD_dat_mask                                                    (0x000000FF)
+#define MIS_IC2_DATA_CMD_dat(data)                                                   (0x000000FF&((data)<<0))
+#define MIS_IC2_DATA_CMD_dat_src(data)                                               ((0x000000FF&(data))>>0)
+#define MIS_IC2_DATA_CMD_get_dat(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC2_SS_SCL_HCNT                                                          0x1801B714
+#define MIS_IC2_SS_SCL_HCNT_reg_addr                                                 "0xB801B714"
+#define MIS_IC2_SS_SCL_HCNT_reg                                                      0xB801B714
+#define set_MIS_IC2_SS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) MIS_IC2_SS_SCL_HCNT_reg)=data)
+#define get_MIS_IC2_SS_SCL_HCNT_reg   (*((volatile unsigned int*) MIS_IC2_SS_SCL_HCNT_reg))
+#define MIS_IC2_SS_SCL_HCNT_inst_adr                                                 "0x00C5"
+#define MIS_IC2_SS_SCL_HCNT_inst                                                     0x00C5
+#define MIS_IC2_SS_SCL_HCNT_ic_ss_scl_hcnt_shift                                     (0)
+#define MIS_IC2_SS_SCL_HCNT_ic_ss_scl_hcnt_mask                                      (0x0000FFFF)
+#define MIS_IC2_SS_SCL_HCNT_ic_ss_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC2_SS_SCL_HCNT_ic_ss_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC2_SS_SCL_HCNT_get_ic_ss_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC2_SS_SCL_LCNT                                                          0x1801B718
+#define MIS_IC2_SS_SCL_LCNT_reg_addr                                                 "0xB801B718"
+#define MIS_IC2_SS_SCL_LCNT_reg                                                      0xB801B718
+#define set_MIS_IC2_SS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) MIS_IC2_SS_SCL_LCNT_reg)=data)
+#define get_MIS_IC2_SS_SCL_LCNT_reg   (*((volatile unsigned int*) MIS_IC2_SS_SCL_LCNT_reg))
+#define MIS_IC2_SS_SCL_LCNT_inst_adr                                                 "0x00C6"
+#define MIS_IC2_SS_SCL_LCNT_inst                                                     0x00C6
+#define MIS_IC2_SS_SCL_LCNT_ic_ss_scl_lcnt_shift                                     (0)
+#define MIS_IC2_SS_SCL_LCNT_ic_ss_scl_lcnt_mask                                      (0x0000FFFF)
+#define MIS_IC2_SS_SCL_LCNT_ic_ss_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC2_SS_SCL_LCNT_ic_ss_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC2_SS_SCL_LCNT_get_ic_ss_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC2_FS_SCL_HCNT                                                          0x1801B71C
+#define MIS_IC2_FS_SCL_HCNT_reg_addr                                                 "0xB801B71C"
+#define MIS_IC2_FS_SCL_HCNT_reg                                                      0xB801B71C
+#define set_MIS_IC2_FS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) MIS_IC2_FS_SCL_HCNT_reg)=data)
+#define get_MIS_IC2_FS_SCL_HCNT_reg   (*((volatile unsigned int*) MIS_IC2_FS_SCL_HCNT_reg))
+#define MIS_IC2_FS_SCL_HCNT_inst_adr                                                 "0x00C7"
+#define MIS_IC2_FS_SCL_HCNT_inst                                                     0x00C7
+#define MIS_IC2_FS_SCL_HCNT_ic_fs_scl_hcnt_shift                                     (0)
+#define MIS_IC2_FS_SCL_HCNT_ic_fs_scl_hcnt_mask                                      (0x0000FFFF)
+#define MIS_IC2_FS_SCL_HCNT_ic_fs_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC2_FS_SCL_HCNT_ic_fs_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC2_FS_SCL_HCNT_get_ic_fs_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC2_FS_SCL_LCNT                                                          0x1801B720
+#define MIS_IC2_FS_SCL_LCNT_reg_addr                                                 "0xB801B720"
+#define MIS_IC2_FS_SCL_LCNT_reg                                                      0xB801B720
+#define set_MIS_IC2_FS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) MIS_IC2_FS_SCL_LCNT_reg)=data)
+#define get_MIS_IC2_FS_SCL_LCNT_reg   (*((volatile unsigned int*) MIS_IC2_FS_SCL_LCNT_reg))
+#define MIS_IC2_FS_SCL_LCNT_inst_adr                                                 "0x00C8"
+#define MIS_IC2_FS_SCL_LCNT_inst                                                     0x00C8
+#define MIS_IC2_FS_SCL_LCNT_ic_fs_scl_lcnt_shift                                     (0)
+#define MIS_IC2_FS_SCL_LCNT_ic_fs_scl_lcnt_mask                                      (0x0000FFFF)
+#define MIS_IC2_FS_SCL_LCNT_ic_fs_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC2_FS_SCL_LCNT_ic_fs_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC2_FS_SCL_LCNT_get_ic_fs_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC2_INTR_STAT                                                            0x1801B72C
+#define MIS_IC2_INTR_STAT_reg_addr                                                   "0xB801B72C"
+#define MIS_IC2_INTR_STAT_reg                                                        0xB801B72C
+#define set_MIS_IC2_INTR_STAT_reg(data)   (*((volatile unsigned int*) MIS_IC2_INTR_STAT_reg)=data)
+#define get_MIS_IC2_INTR_STAT_reg   (*((volatile unsigned int*) MIS_IC2_INTR_STAT_reg))
+#define MIS_IC2_INTR_STAT_inst_adr                                                   "0x00CB"
+#define MIS_IC2_INTR_STAT_inst                                                       0x00CB
+#define MIS_IC2_INTR_STAT_r_gen_call_shift                                           (11)
+#define MIS_IC2_INTR_STAT_r_gen_call_mask                                            (0x00000800)
+#define MIS_IC2_INTR_STAT_r_gen_call(data)                                           (0x00000800&((data)<<11))
+#define MIS_IC2_INTR_STAT_r_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC2_INTR_STAT_get_r_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC2_INTR_STAT_r_start_det_shift                                          (10)
+#define MIS_IC2_INTR_STAT_r_start_det_mask                                           (0x00000400)
+#define MIS_IC2_INTR_STAT_r_start_det(data)                                          (0x00000400&((data)<<10))
+#define MIS_IC2_INTR_STAT_r_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC2_INTR_STAT_get_r_start_det(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC2_INTR_STAT_r_stop_det_shift                                           (9)
+#define MIS_IC2_INTR_STAT_r_stop_det_mask                                            (0x00000200)
+#define MIS_IC2_INTR_STAT_r_stop_det(data)                                           (0x00000200&((data)<<9))
+#define MIS_IC2_INTR_STAT_r_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC2_INTR_STAT_get_r_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC2_INTR_STAT_r_activity_shift                                           (8)
+#define MIS_IC2_INTR_STAT_r_activity_mask                                            (0x00000100)
+#define MIS_IC2_INTR_STAT_r_activity(data)                                           (0x00000100&((data)<<8))
+#define MIS_IC2_INTR_STAT_r_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC2_INTR_STAT_get_r_activity(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC2_INTR_STAT_r_rx_done_shift                                            (7)
+#define MIS_IC2_INTR_STAT_r_rx_done_mask                                             (0x00000080)
+#define MIS_IC2_INTR_STAT_r_rx_done(data)                                            (0x00000080&((data)<<7))
+#define MIS_IC2_INTR_STAT_r_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC2_INTR_STAT_get_r_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC2_INTR_STAT_r_tx_abrt_shift                                            (6)
+#define MIS_IC2_INTR_STAT_r_tx_abrt_mask                                             (0x00000040)
+#define MIS_IC2_INTR_STAT_r_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC2_INTR_STAT_r_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC2_INTR_STAT_get_r_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC2_INTR_STAT_r_rd_req_shift                                             (5)
+#define MIS_IC2_INTR_STAT_r_rd_req_mask                                              (0x00000020)
+#define MIS_IC2_INTR_STAT_r_rd_req(data)                                             (0x00000020&((data)<<5))
+#define MIS_IC2_INTR_STAT_r_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC2_INTR_STAT_get_r_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC2_INTR_STAT_r_tx_empty_shift                                           (4)
+#define MIS_IC2_INTR_STAT_r_tx_empty_mask                                            (0x00000010)
+#define MIS_IC2_INTR_STAT_r_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define MIS_IC2_INTR_STAT_r_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC2_INTR_STAT_get_r_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC2_INTR_STAT_r_tx_over_shift                                            (3)
+#define MIS_IC2_INTR_STAT_r_tx_over_mask                                             (0x00000008)
+#define MIS_IC2_INTR_STAT_r_tx_over(data)                                            (0x00000008&((data)<<3))
+#define MIS_IC2_INTR_STAT_r_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC2_INTR_STAT_get_r_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC2_INTR_STAT_r_rx_full_shift                                            (2)
+#define MIS_IC2_INTR_STAT_r_rx_full_mask                                             (0x00000004)
+#define MIS_IC2_INTR_STAT_r_rx_full(data)                                            (0x00000004&((data)<<2))
+#define MIS_IC2_INTR_STAT_r_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC2_INTR_STAT_get_r_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC2_INTR_STAT_r_rx_over_shift                                            (1)
+#define MIS_IC2_INTR_STAT_r_rx_over_mask                                             (0x00000002)
+#define MIS_IC2_INTR_STAT_r_rx_over(data)                                            (0x00000002&((data)<<1))
+#define MIS_IC2_INTR_STAT_r_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC2_INTR_STAT_get_r_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC2_INTR_STAT_r_rx_under_shift                                           (0)
+#define MIS_IC2_INTR_STAT_r_rx_under_mask                                            (0x00000001)
+#define MIS_IC2_INTR_STAT_r_rx_under(data)                                           (0x00000001&((data)<<0))
+#define MIS_IC2_INTR_STAT_r_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_IC2_INTR_STAT_get_r_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_INTR_MASK                                                            0x1801B730
+#define MIS_IC2_INTR_MASK_reg_addr                                                   "0xB801B730"
+#define MIS_IC2_INTR_MASK_reg                                                        0xB801B730
+#define set_MIS_IC2_INTR_MASK_reg(data)   (*((volatile unsigned int*) MIS_IC2_INTR_MASK_reg)=data)
+#define get_MIS_IC2_INTR_MASK_reg   (*((volatile unsigned int*) MIS_IC2_INTR_MASK_reg))
+#define MIS_IC2_INTR_MASK_inst_adr                                                   "0x00CC"
+#define MIS_IC2_INTR_MASK_inst                                                       0x00CC
+#define MIS_IC2_INTR_MASK_m_gen_call_shift                                           (11)
+#define MIS_IC2_INTR_MASK_m_gen_call_mask                                            (0x00000800)
+#define MIS_IC2_INTR_MASK_m_gen_call(data)                                           (0x00000800&((data)<<11))
+#define MIS_IC2_INTR_MASK_m_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC2_INTR_MASK_get_m_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC2_INTR_MASK_m_start_det_shift                                          (10)
+#define MIS_IC2_INTR_MASK_m_start_det_mask                                           (0x00000400)
+#define MIS_IC2_INTR_MASK_m_start_det(data)                                          (0x00000400&((data)<<10))
+#define MIS_IC2_INTR_MASK_m_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC2_INTR_MASK_get_m_start_det(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC2_INTR_MASK_m_stop_det_shift                                           (9)
+#define MIS_IC2_INTR_MASK_m_stop_det_mask                                            (0x00000200)
+#define MIS_IC2_INTR_MASK_m_stop_det(data)                                           (0x00000200&((data)<<9))
+#define MIS_IC2_INTR_MASK_m_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC2_INTR_MASK_get_m_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC2_INTR_MASK_m_activity_shift                                           (8)
+#define MIS_IC2_INTR_MASK_m_activity_mask                                            (0x00000100)
+#define MIS_IC2_INTR_MASK_m_activity(data)                                           (0x00000100&((data)<<8))
+#define MIS_IC2_INTR_MASK_m_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC2_INTR_MASK_get_m_activity(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC2_INTR_MASK_m_rx_done_shift                                            (7)
+#define MIS_IC2_INTR_MASK_m_rx_done_mask                                             (0x00000080)
+#define MIS_IC2_INTR_MASK_m_rx_done(data)                                            (0x00000080&((data)<<7))
+#define MIS_IC2_INTR_MASK_m_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC2_INTR_MASK_get_m_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC2_INTR_MASK_m_tx_abrt_shift                                            (6)
+#define MIS_IC2_INTR_MASK_m_tx_abrt_mask                                             (0x00000040)
+#define MIS_IC2_INTR_MASK_m_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC2_INTR_MASK_m_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC2_INTR_MASK_get_m_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC2_INTR_MASK_m_rd_req_shift                                             (5)
+#define MIS_IC2_INTR_MASK_m_rd_req_mask                                              (0x00000020)
+#define MIS_IC2_INTR_MASK_m_rd_req(data)                                             (0x00000020&((data)<<5))
+#define MIS_IC2_INTR_MASK_m_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC2_INTR_MASK_get_m_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC2_INTR_MASK_m_tx_empty_shift                                           (4)
+#define MIS_IC2_INTR_MASK_m_tx_empty_mask                                            (0x00000010)
+#define MIS_IC2_INTR_MASK_m_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define MIS_IC2_INTR_MASK_m_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC2_INTR_MASK_get_m_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC2_INTR_MASK_m_tx_over_shift                                            (3)
+#define MIS_IC2_INTR_MASK_m_tx_over_mask                                             (0x00000008)
+#define MIS_IC2_INTR_MASK_m_tx_over(data)                                            (0x00000008&((data)<<3))
+#define MIS_IC2_INTR_MASK_m_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC2_INTR_MASK_get_m_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC2_INTR_MASK_m_rx_full_shift                                            (2)
+#define MIS_IC2_INTR_MASK_m_rx_full_mask                                             (0x00000004)
+#define MIS_IC2_INTR_MASK_m_rx_full(data)                                            (0x00000004&((data)<<2))
+#define MIS_IC2_INTR_MASK_m_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC2_INTR_MASK_get_m_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC2_INTR_MASK_m_rx_over_shift                                            (1)
+#define MIS_IC2_INTR_MASK_m_rx_over_mask                                             (0x00000002)
+#define MIS_IC2_INTR_MASK_m_rx_over(data)                                            (0x00000002&((data)<<1))
+#define MIS_IC2_INTR_MASK_m_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC2_INTR_MASK_get_m_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC2_INTR_MASK_m_rx_under_shift                                           (0)
+#define MIS_IC2_INTR_MASK_m_rx_under_mask                                            (0x00000001)
+#define MIS_IC2_INTR_MASK_m_rx_under(data)                                           (0x00000001&((data)<<0))
+#define MIS_IC2_INTR_MASK_m_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_IC2_INTR_MASK_get_m_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_RAW_INTR_STAT                                                        0x1801B734
+#define MIS_IC2_RAW_INTR_STAT_reg_addr                                               "0xB801B734"
+#define MIS_IC2_RAW_INTR_STAT_reg                                                    0xB801B734
+#define set_MIS_IC2_RAW_INTR_STAT_reg(data)   (*((volatile unsigned int*) MIS_IC2_RAW_INTR_STAT_reg)=data)
+#define get_MIS_IC2_RAW_INTR_STAT_reg   (*((volatile unsigned int*) MIS_IC2_RAW_INTR_STAT_reg))
+#define MIS_IC2_RAW_INTR_STAT_inst_adr                                               "0x00CD"
+#define MIS_IC2_RAW_INTR_STAT_inst                                                   0x00CD
+#define MIS_IC2_RAW_INTR_STAT_gen_call_shift                                         (11)
+#define MIS_IC2_RAW_INTR_STAT_gen_call_mask                                          (0x00000800)
+#define MIS_IC2_RAW_INTR_STAT_gen_call(data)                                         (0x00000800&((data)<<11))
+#define MIS_IC2_RAW_INTR_STAT_gen_call_src(data)                                     ((0x00000800&(data))>>11)
+#define MIS_IC2_RAW_INTR_STAT_get_gen_call(data)                                     ((0x00000800&(data))>>11)
+#define MIS_IC2_RAW_INTR_STAT_start_det_shift                                        (10)
+#define MIS_IC2_RAW_INTR_STAT_start_det_mask                                         (0x00000400)
+#define MIS_IC2_RAW_INTR_STAT_start_det(data)                                        (0x00000400&((data)<<10))
+#define MIS_IC2_RAW_INTR_STAT_start_det_src(data)                                    ((0x00000400&(data))>>10)
+#define MIS_IC2_RAW_INTR_STAT_get_start_det(data)                                    ((0x00000400&(data))>>10)
+#define MIS_IC2_RAW_INTR_STAT_stop_det_shift                                         (9)
+#define MIS_IC2_RAW_INTR_STAT_stop_det_mask                                          (0x00000200)
+#define MIS_IC2_RAW_INTR_STAT_stop_det(data)                                         (0x00000200&((data)<<9))
+#define MIS_IC2_RAW_INTR_STAT_stop_det_src(data)                                     ((0x00000200&(data))>>9)
+#define MIS_IC2_RAW_INTR_STAT_get_stop_det(data)                                     ((0x00000200&(data))>>9)
+#define MIS_IC2_RAW_INTR_STAT_activity_shift                                         (8)
+#define MIS_IC2_RAW_INTR_STAT_activity_mask                                          (0x00000100)
+#define MIS_IC2_RAW_INTR_STAT_activity(data)                                         (0x00000100&((data)<<8))
+#define MIS_IC2_RAW_INTR_STAT_activity_src(data)                                     ((0x00000100&(data))>>8)
+#define MIS_IC2_RAW_INTR_STAT_get_activity(data)                                     ((0x00000100&(data))>>8)
+#define MIS_IC2_RAW_INTR_STAT_rx_done_shift                                          (7)
+#define MIS_IC2_RAW_INTR_STAT_rx_done_mask                                           (0x00000080)
+#define MIS_IC2_RAW_INTR_STAT_rx_done(data)                                          (0x00000080&((data)<<7))
+#define MIS_IC2_RAW_INTR_STAT_rx_done_src(data)                                      ((0x00000080&(data))>>7)
+#define MIS_IC2_RAW_INTR_STAT_get_rx_done(data)                                      ((0x00000080&(data))>>7)
+#define MIS_IC2_RAW_INTR_STAT_tx_abrt_shift                                          (6)
+#define MIS_IC2_RAW_INTR_STAT_tx_abrt_mask                                           (0x00000040)
+#define MIS_IC2_RAW_INTR_STAT_tx_abrt(data)                                          (0x00000040&((data)<<6))
+#define MIS_IC2_RAW_INTR_STAT_tx_abrt_src(data)                                      ((0x00000040&(data))>>6)
+#define MIS_IC2_RAW_INTR_STAT_get_tx_abrt(data)                                      ((0x00000040&(data))>>6)
+#define MIS_IC2_RAW_INTR_STAT_rd_req_shift                                           (5)
+#define MIS_IC2_RAW_INTR_STAT_rd_req_mask                                            (0x00000020)
+#define MIS_IC2_RAW_INTR_STAT_rd_req(data)                                           (0x00000020&((data)<<5))
+#define MIS_IC2_RAW_INTR_STAT_rd_req_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC2_RAW_INTR_STAT_get_rd_req(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC2_RAW_INTR_STAT_tx_empty_shift                                         (4)
+#define MIS_IC2_RAW_INTR_STAT_tx_empty_mask                                          (0x00000010)
+#define MIS_IC2_RAW_INTR_STAT_tx_empty(data)                                         (0x00000010&((data)<<4))
+#define MIS_IC2_RAW_INTR_STAT_tx_empty_src(data)                                     ((0x00000010&(data))>>4)
+#define MIS_IC2_RAW_INTR_STAT_get_tx_empty(data)                                     ((0x00000010&(data))>>4)
+#define MIS_IC2_RAW_INTR_STAT_tx_over_shift                                          (3)
+#define MIS_IC2_RAW_INTR_STAT_tx_over_mask                                           (0x00000008)
+#define MIS_IC2_RAW_INTR_STAT_tx_over(data)                                          (0x00000008&((data)<<3))
+#define MIS_IC2_RAW_INTR_STAT_tx_over_src(data)                                      ((0x00000008&(data))>>3)
+#define MIS_IC2_RAW_INTR_STAT_get_tx_over(data)                                      ((0x00000008&(data))>>3)
+#define MIS_IC2_RAW_INTR_STAT_rx_full_shift                                          (2)
+#define MIS_IC2_RAW_INTR_STAT_rx_full_mask                                           (0x00000004)
+#define MIS_IC2_RAW_INTR_STAT_rx_full(data)                                          (0x00000004&((data)<<2))
+#define MIS_IC2_RAW_INTR_STAT_rx_full_src(data)                                      ((0x00000004&(data))>>2)
+#define MIS_IC2_RAW_INTR_STAT_get_rx_full(data)                                      ((0x00000004&(data))>>2)
+#define MIS_IC2_RAW_INTR_STAT_rx_over_shift                                          (1)
+#define MIS_IC2_RAW_INTR_STAT_rx_over_mask                                           (0x00000002)
+#define MIS_IC2_RAW_INTR_STAT_rx_over(data)                                          (0x00000002&((data)<<1))
+#define MIS_IC2_RAW_INTR_STAT_rx_over_src(data)                                      ((0x00000002&(data))>>1)
+#define MIS_IC2_RAW_INTR_STAT_get_rx_over(data)                                      ((0x00000002&(data))>>1)
+#define MIS_IC2_RAW_INTR_STAT_rx_under_shift                                         (0)
+#define MIS_IC2_RAW_INTR_STAT_rx_under_mask                                          (0x00000001)
+#define MIS_IC2_RAW_INTR_STAT_rx_under(data)                                         (0x00000001&((data)<<0))
+#define MIS_IC2_RAW_INTR_STAT_rx_under_src(data)                                     ((0x00000001&(data))>>0)
+#define MIS_IC2_RAW_INTR_STAT_get_rx_under(data)                                     ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_RX_TL                                                                0x1801B738
+#define MIS_IC2_RX_TL_reg_addr                                                       "0xB801B738"
+#define MIS_IC2_RX_TL_reg                                                            0xB801B738
+#define set_MIS_IC2_RX_TL_reg(data)   (*((volatile unsigned int*) MIS_IC2_RX_TL_reg)=data)
+#define get_MIS_IC2_RX_TL_reg   (*((volatile unsigned int*) MIS_IC2_RX_TL_reg))
+#define MIS_IC2_RX_TL_inst_adr                                                       "0x00CE"
+#define MIS_IC2_RX_TL_inst                                                           0x00CE
+#define MIS_IC2_RX_TL_rx_tl_shift                                                    (0)
+#define MIS_IC2_RX_TL_rx_tl_mask                                                     (0x000000FF)
+#define MIS_IC2_RX_TL_rx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define MIS_IC2_RX_TL_rx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define MIS_IC2_RX_TL_get_rx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC2_TX_TL                                                                0x1801B73C
+#define MIS_IC2_TX_TL_reg_addr                                                       "0xB801B73C"
+#define MIS_IC2_TX_TL_reg                                                            0xB801B73C
+#define set_MIS_IC2_TX_TL_reg(data)   (*((volatile unsigned int*) MIS_IC2_TX_TL_reg)=data)
+#define get_MIS_IC2_TX_TL_reg   (*((volatile unsigned int*) MIS_IC2_TX_TL_reg))
+#define MIS_IC2_TX_TL_inst_adr                                                       "0x00CF"
+#define MIS_IC2_TX_TL_inst                                                           0x00CF
+#define MIS_IC2_TX_TL_tx_tl_shift                                                    (0)
+#define MIS_IC2_TX_TL_tx_tl_mask                                                     (0x000000FF)
+#define MIS_IC2_TX_TL_tx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define MIS_IC2_TX_TL_tx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define MIS_IC2_TX_TL_get_tx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC2_CLR_INTR                                                             0x1801B740
+#define MIS_IC2_CLR_INTR_reg_addr                                                    "0xB801B740"
+#define MIS_IC2_CLR_INTR_reg                                                         0xB801B740
+#define set_MIS_IC2_CLR_INTR_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_INTR_reg)=data)
+#define get_MIS_IC2_CLR_INTR_reg   (*((volatile unsigned int*) MIS_IC2_CLR_INTR_reg))
+#define MIS_IC2_CLR_INTR_inst_adr                                                    "0x00D0"
+#define MIS_IC2_CLR_INTR_inst                                                        0x00D0
+#define MIS_IC2_CLR_INTR_clr_intr_shift                                              (0)
+#define MIS_IC2_CLR_INTR_clr_intr_mask                                               (0x00000001)
+#define MIS_IC2_CLR_INTR_clr_intr(data)                                              (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_INTR_clr_intr_src(data)                                          ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_INTR_get_clr_intr(data)                                          ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_CLR_RX_UNDER                                                         0x1801B744
+#define MIS_IC2_CLR_RX_UNDER_reg_addr                                                "0xB801B744"
+#define MIS_IC2_CLR_RX_UNDER_reg                                                     0xB801B744
+#define set_MIS_IC2_CLR_RX_UNDER_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_RX_UNDER_reg)=data)
+#define get_MIS_IC2_CLR_RX_UNDER_reg   (*((volatile unsigned int*) MIS_IC2_CLR_RX_UNDER_reg))
+#define MIS_IC2_CLR_RX_UNDER_inst_adr                                                "0x00D1"
+#define MIS_IC2_CLR_RX_UNDER_inst                                                    0x00D1
+#define MIS_IC2_CLR_RX_UNDER_clr_rx_under_shift                                      (0)
+#define MIS_IC2_CLR_RX_UNDER_clr_rx_under_mask                                       (0x00000001)
+#define MIS_IC2_CLR_RX_UNDER_clr_rx_under(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_RX_UNDER_clr_rx_under_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_RX_UNDER_get_clr_rx_under(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_CLR_RX_OVER                                                          0x1801B748
+#define MIS_IC2_CLR_RX_OVER_reg_addr                                                 "0xB801B748"
+#define MIS_IC2_CLR_RX_OVER_reg                                                      0xB801B748
+#define set_MIS_IC2_CLR_RX_OVER_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_RX_OVER_reg)=data)
+#define get_MIS_IC2_CLR_RX_OVER_reg   (*((volatile unsigned int*) MIS_IC2_CLR_RX_OVER_reg))
+#define MIS_IC2_CLR_RX_OVER_inst_adr                                                 "0x00D2"
+#define MIS_IC2_CLR_RX_OVER_inst                                                     0x00D2
+#define MIS_IC2_CLR_RX_OVER_clr_rx_over_shift                                        (0)
+#define MIS_IC2_CLR_RX_OVER_clr_rx_over_mask                                         (0x00000001)
+#define MIS_IC2_CLR_RX_OVER_clr_rx_over(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_RX_OVER_clr_rx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_RX_OVER_get_clr_rx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_CLR_TX_OVER                                                          0x1801B74C
+#define MIS_IC2_CLR_TX_OVER_reg_addr                                                 "0xB801B74C"
+#define MIS_IC2_CLR_TX_OVER_reg                                                      0xB801B74C
+#define set_MIS_IC2_CLR_TX_OVER_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_TX_OVER_reg)=data)
+#define get_MIS_IC2_CLR_TX_OVER_reg   (*((volatile unsigned int*) MIS_IC2_CLR_TX_OVER_reg))
+#define MIS_IC2_CLR_TX_OVER_inst_adr                                                 "0x00D3"
+#define MIS_IC2_CLR_TX_OVER_inst                                                     0x00D3
+#define MIS_IC2_CLR_TX_OVER_clr_tx_over_shift                                        (0)
+#define MIS_IC2_CLR_TX_OVER_clr_tx_over_mask                                         (0x00000001)
+#define MIS_IC2_CLR_TX_OVER_clr_tx_over(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_TX_OVER_clr_tx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_TX_OVER_get_clr_tx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_CLR_RD_REQ                                                           0x1801B750
+#define MIS_IC2_CLR_RD_REQ_reg_addr                                                  "0xB801B750"
+#define MIS_IC2_CLR_RD_REQ_reg                                                       0xB801B750
+#define set_MIS_IC2_CLR_RD_REQ_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_RD_REQ_reg)=data)
+#define get_MIS_IC2_CLR_RD_REQ_reg   (*((volatile unsigned int*) MIS_IC2_CLR_RD_REQ_reg))
+#define MIS_IC2_CLR_RD_REQ_inst_adr                                                  "0x00D4"
+#define MIS_IC2_CLR_RD_REQ_inst                                                      0x00D4
+#define MIS_IC2_CLR_RD_REQ_clr_rd_req_shift                                          (0)
+#define MIS_IC2_CLR_RD_REQ_clr_rd_req_mask                                           (0x00000001)
+#define MIS_IC2_CLR_RD_REQ_clr_rd_req(data)                                          (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_RD_REQ_clr_rd_req_src(data)                                      ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_RD_REQ_get_clr_rd_req(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_CLR_TX_ABRT                                                          0x1801B754
+#define MIS_IC2_CLR_TX_ABRT_reg_addr                                                 "0xB801B754"
+#define MIS_IC2_CLR_TX_ABRT_reg                                                      0xB801B754
+#define set_MIS_IC2_CLR_TX_ABRT_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_TX_ABRT_reg)=data)
+#define get_MIS_IC2_CLR_TX_ABRT_reg   (*((volatile unsigned int*) MIS_IC2_CLR_TX_ABRT_reg))
+#define MIS_IC2_CLR_TX_ABRT_inst_adr                                                 "0x00D5"
+#define MIS_IC2_CLR_TX_ABRT_inst                                                     0x00D5
+#define MIS_IC2_CLR_TX_ABRT_clr_tx_abrt_shift                                        (0)
+#define MIS_IC2_CLR_TX_ABRT_clr_tx_abrt_mask                                         (0x00000001)
+#define MIS_IC2_CLR_TX_ABRT_clr_tx_abrt(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_TX_ABRT_clr_tx_abrt_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_TX_ABRT_get_clr_tx_abrt(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_CLR_RX_DONE                                                          0x1801B758
+#define MIS_IC2_CLR_RX_DONE_reg_addr                                                 "0xB801B758"
+#define MIS_IC2_CLR_RX_DONE_reg                                                      0xB801B758
+#define set_MIS_IC2_CLR_RX_DONE_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_RX_DONE_reg)=data)
+#define get_MIS_IC2_CLR_RX_DONE_reg   (*((volatile unsigned int*) MIS_IC2_CLR_RX_DONE_reg))
+#define MIS_IC2_CLR_RX_DONE_inst_adr                                                 "0x00D6"
+#define MIS_IC2_CLR_RX_DONE_inst                                                     0x00D6
+#define MIS_IC2_CLR_RX_DONE_clr_rx_done_shift                                        (0)
+#define MIS_IC2_CLR_RX_DONE_clr_rx_done_mask                                         (0x00000001)
+#define MIS_IC2_CLR_RX_DONE_clr_rx_done(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_RX_DONE_clr_rx_done_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_RX_DONE_get_clr_rx_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_CLR_ACTIVITY                                                         0x1801B75C
+#define MIS_IC2_CLR_ACTIVITY_reg_addr                                                "0xB801B75C"
+#define MIS_IC2_CLR_ACTIVITY_reg                                                     0xB801B75C
+#define set_MIS_IC2_CLR_ACTIVITY_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_ACTIVITY_reg)=data)
+#define get_MIS_IC2_CLR_ACTIVITY_reg   (*((volatile unsigned int*) MIS_IC2_CLR_ACTIVITY_reg))
+#define MIS_IC2_CLR_ACTIVITY_inst_adr                                                "0x00D7"
+#define MIS_IC2_CLR_ACTIVITY_inst                                                    0x00D7
+#define MIS_IC2_CLR_ACTIVITY_clr_activity_shift                                      (0)
+#define MIS_IC2_CLR_ACTIVITY_clr_activity_mask                                       (0x00000001)
+#define MIS_IC2_CLR_ACTIVITY_clr_activity(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_ACTIVITY_clr_activity_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_ACTIVITY_get_clr_activity(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_CLR_STOP_DET                                                         0x1801B760
+#define MIS_IC2_CLR_STOP_DET_reg_addr                                                "0xB801B760"
+#define MIS_IC2_CLR_STOP_DET_reg                                                     0xB801B760
+#define set_MIS_IC2_CLR_STOP_DET_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_STOP_DET_reg)=data)
+#define get_MIS_IC2_CLR_STOP_DET_reg   (*((volatile unsigned int*) MIS_IC2_CLR_STOP_DET_reg))
+#define MIS_IC2_CLR_STOP_DET_inst_adr                                                "0x00D8"
+#define MIS_IC2_CLR_STOP_DET_inst                                                    0x00D8
+#define MIS_IC2_CLR_STOP_DET_clr_stop_det_shift                                      (0)
+#define MIS_IC2_CLR_STOP_DET_clr_stop_det_mask                                       (0x00000001)
+#define MIS_IC2_CLR_STOP_DET_clr_stop_det(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_STOP_DET_clr_stop_det_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_STOP_DET_get_clr_stop_det(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_CLR_START_DET                                                        0x1801B764
+#define MIS_IC2_CLR_START_DET_reg_addr                                               "0xB801B764"
+#define MIS_IC2_CLR_START_DET_reg                                                    0xB801B764
+#define set_MIS_IC2_CLR_START_DET_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_START_DET_reg)=data)
+#define get_MIS_IC2_CLR_START_DET_reg   (*((volatile unsigned int*) MIS_IC2_CLR_START_DET_reg))
+#define MIS_IC2_CLR_START_DET_inst_adr                                               "0x00D9"
+#define MIS_IC2_CLR_START_DET_inst                                                   0x00D9
+#define MIS_IC2_CLR_START_DET_clr_start_det_shift                                    (0)
+#define MIS_IC2_CLR_START_DET_clr_start_det_mask                                     (0x00000001)
+#define MIS_IC2_CLR_START_DET_clr_start_det(data)                                    (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_START_DET_clr_start_det_src(data)                                ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_START_DET_get_clr_start_det(data)                                ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_CLR_GEN_CALL                                                         0x1801B768
+#define MIS_IC2_CLR_GEN_CALL_reg_addr                                                "0xB801B768"
+#define MIS_IC2_CLR_GEN_CALL_reg                                                     0xB801B768
+#define set_MIS_IC2_CLR_GEN_CALL_reg(data)   (*((volatile unsigned int*) MIS_IC2_CLR_GEN_CALL_reg)=data)
+#define get_MIS_IC2_CLR_GEN_CALL_reg   (*((volatile unsigned int*) MIS_IC2_CLR_GEN_CALL_reg))
+#define MIS_IC2_CLR_GEN_CALL_inst_adr                                                "0x00DA"
+#define MIS_IC2_CLR_GEN_CALL_inst                                                    0x00DA
+#define MIS_IC2_CLR_GEN_CALL_clr_gen_call_shift                                      (0)
+#define MIS_IC2_CLR_GEN_CALL_clr_gen_call_mask                                       (0x00000001)
+#define MIS_IC2_CLR_GEN_CALL_clr_gen_call(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC2_CLR_GEN_CALL_clr_gen_call_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC2_CLR_GEN_CALL_get_clr_gen_call(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_ENABLE                                                               0x1801B76C
+#define MIS_IC2_ENABLE_reg_addr                                                      "0xB801B76C"
+#define MIS_IC2_ENABLE_reg                                                           0xB801B76C
+#define set_MIS_IC2_ENABLE_reg(data)   (*((volatile unsigned int*) MIS_IC2_ENABLE_reg)=data)
+#define get_MIS_IC2_ENABLE_reg   (*((volatile unsigned int*) MIS_IC2_ENABLE_reg))
+#define MIS_IC2_ENABLE_inst_adr                                                      "0x00DB"
+#define MIS_IC2_ENABLE_inst                                                          0x00DB
+#define MIS_IC2_ENABLE_enable_shift                                                  (0)
+#define MIS_IC2_ENABLE_enable_mask                                                   (0x00000001)
+#define MIS_IC2_ENABLE_enable(data)                                                  (0x00000001&((data)<<0))
+#define MIS_IC2_ENABLE_enable_src(data)                                              ((0x00000001&(data))>>0)
+#define MIS_IC2_ENABLE_get_enable(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_STATUS                                                               0x1801B770
+#define MIS_IC2_STATUS_reg_addr                                                      "0xB801B770"
+#define MIS_IC2_STATUS_reg                                                           0xB801B770
+#define set_MIS_IC2_STATUS_reg(data)   (*((volatile unsigned int*) MIS_IC2_STATUS_reg)=data)
+#define get_MIS_IC2_STATUS_reg   (*((volatile unsigned int*) MIS_IC2_STATUS_reg))
+#define MIS_IC2_STATUS_inst_adr                                                      "0x00DC"
+#define MIS_IC2_STATUS_inst                                                          0x00DC
+#define MIS_IC2_STATUS_slv_activity_shift                                            (6)
+#define MIS_IC2_STATUS_slv_activity_mask                                             (0x00000040)
+#define MIS_IC2_STATUS_slv_activity(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC2_STATUS_slv_activity_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC2_STATUS_get_slv_activity(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC2_STATUS_mst_activity_shift                                            (5)
+#define MIS_IC2_STATUS_mst_activity_mask                                             (0x00000020)
+#define MIS_IC2_STATUS_mst_activity(data)                                            (0x00000020&((data)<<5))
+#define MIS_IC2_STATUS_mst_activity_src(data)                                        ((0x00000020&(data))>>5)
+#define MIS_IC2_STATUS_get_mst_activity(data)                                        ((0x00000020&(data))>>5)
+#define MIS_IC2_STATUS_rff_shift                                                     (4)
+#define MIS_IC2_STATUS_rff_mask                                                      (0x00000010)
+#define MIS_IC2_STATUS_rff(data)                                                     (0x00000010&((data)<<4))
+#define MIS_IC2_STATUS_rff_src(data)                                                 ((0x00000010&(data))>>4)
+#define MIS_IC2_STATUS_get_rff(data)                                                 ((0x00000010&(data))>>4)
+#define MIS_IC2_STATUS_rfne_shift                                                    (3)
+#define MIS_IC2_STATUS_rfne_mask                                                     (0x00000008)
+#define MIS_IC2_STATUS_rfne(data)                                                    (0x00000008&((data)<<3))
+#define MIS_IC2_STATUS_rfne_src(data)                                                ((0x00000008&(data))>>3)
+#define MIS_IC2_STATUS_get_rfne(data)                                                ((0x00000008&(data))>>3)
+#define MIS_IC2_STATUS_tfe_shift                                                     (2)
+#define MIS_IC2_STATUS_tfe_mask                                                      (0x00000004)
+#define MIS_IC2_STATUS_tfe(data)                                                     (0x00000004&((data)<<2))
+#define MIS_IC2_STATUS_tfe_src(data)                                                 ((0x00000004&(data))>>2)
+#define MIS_IC2_STATUS_get_tfe(data)                                                 ((0x00000004&(data))>>2)
+#define MIS_IC2_STATUS_tfnf_shift                                                    (1)
+#define MIS_IC2_STATUS_tfnf_mask                                                     (0x00000002)
+#define MIS_IC2_STATUS_tfnf(data)                                                    (0x00000002&((data)<<1))
+#define MIS_IC2_STATUS_tfnf_src(data)                                                ((0x00000002&(data))>>1)
+#define MIS_IC2_STATUS_get_tfnf(data)                                                ((0x00000002&(data))>>1)
+#define MIS_IC2_STATUS_activity_shift                                                (0)
+#define MIS_IC2_STATUS_activity_mask                                                 (0x00000001)
+#define MIS_IC2_STATUS_activity(data)                                                (0x00000001&((data)<<0))
+#define MIS_IC2_STATUS_activity_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_IC2_STATUS_get_activity(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_TXFLR                                                                0x1801B774
+#define MIS_IC2_TXFLR_reg_addr                                                       "0xB801B774"
+#define MIS_IC2_TXFLR_reg                                                            0xB801B774
+#define set_MIS_IC2_TXFLR_reg(data)   (*((volatile unsigned int*) MIS_IC2_TXFLR_reg)=data)
+#define get_MIS_IC2_TXFLR_reg   (*((volatile unsigned int*) MIS_IC2_TXFLR_reg))
+#define MIS_IC2_TXFLR_inst_adr                                                       "0x00DD"
+#define MIS_IC2_TXFLR_inst                                                           0x00DD
+#define MIS_IC2_TXFLR_txflr_shift                                                    (0)
+#define MIS_IC2_TXFLR_txflr_mask                                                     (0x0000000F)
+#define MIS_IC2_TXFLR_txflr(data)                                                    (0x0000000F&((data)<<0))
+#define MIS_IC2_TXFLR_txflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define MIS_IC2_TXFLR_get_txflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC2_RXFLR                                                                0x1801B778
+#define MIS_IC2_RXFLR_reg_addr                                                       "0xB801B778"
+#define MIS_IC2_RXFLR_reg                                                            0xB801B778
+#define set_MIS_IC2_RXFLR_reg(data)   (*((volatile unsigned int*) MIS_IC2_RXFLR_reg)=data)
+#define get_MIS_IC2_RXFLR_reg   (*((volatile unsigned int*) MIS_IC2_RXFLR_reg))
+#define MIS_IC2_RXFLR_inst_adr                                                       "0x00DE"
+#define MIS_IC2_RXFLR_inst                                                           0x00DE
+#define MIS_IC2_RXFLR_rxflr_shift                                                    (0)
+#define MIS_IC2_RXFLR_rxflr_mask                                                     (0x0000000F)
+#define MIS_IC2_RXFLR_rxflr(data)                                                    (0x0000000F&((data)<<0))
+#define MIS_IC2_RXFLR_rxflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define MIS_IC2_RXFLR_get_rxflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC2_SDA_HOLD                                                             0x1801B77C
+#define MIS_IC2_SDA_HOLD_reg_addr                                                    "0xB801B77C"
+#define MIS_IC2_SDA_HOLD_reg                                                         0xB801B77C
+#define set_MIS_IC2_SDA_HOLD_reg(data)   (*((volatile unsigned int*) MIS_IC2_SDA_HOLD_reg)=data)
+#define get_MIS_IC2_SDA_HOLD_reg   (*((volatile unsigned int*) MIS_IC2_SDA_HOLD_reg))
+#define MIS_IC2_SDA_HOLD_inst_adr                                                    "0x00DF"
+#define MIS_IC2_SDA_HOLD_inst                                                        0x00DF
+#define MIS_IC2_SDA_HOLD_sda_hold_shift                                              (0)
+#define MIS_IC2_SDA_HOLD_sda_hold_mask                                               (0x0000FFFF)
+#define MIS_IC2_SDA_HOLD_sda_hold(data)                                              (0x0000FFFF&((data)<<0))
+#define MIS_IC2_SDA_HOLD_sda_hold_src(data)                                          ((0x0000FFFF&(data))>>0)
+#define MIS_IC2_SDA_HOLD_get_sda_hold(data)                                          ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC2_TX_ABRT_SOURCE                                                       0x1801B780
+#define MIS_IC2_TX_ABRT_SOURCE_reg_addr                                              "0xB801B780"
+#define MIS_IC2_TX_ABRT_SOURCE_reg                                                   0xB801B780
+#define set_MIS_IC2_TX_ABRT_SOURCE_reg(data)   (*((volatile unsigned int*) MIS_IC2_TX_ABRT_SOURCE_reg)=data)
+#define get_MIS_IC2_TX_ABRT_SOURCE_reg   (*((volatile unsigned int*) MIS_IC2_TX_ABRT_SOURCE_reg))
+#define MIS_IC2_TX_ABRT_SOURCE_inst_adr                                              "0x00E0"
+#define MIS_IC2_TX_ABRT_SOURCE_inst                                                  0x00E0
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slvrd_intx_shift                                 (15)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slvrd_intx_mask                                  (0x00008000)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slvrd_intx(data)                                 (0x00008000&((data)<<15))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slvrd_intx_src(data)                             ((0x00008000&(data))>>15)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_slvrd_intx(data)                             ((0x00008000&(data))>>15)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slv_arblost_shift                                (14)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slv_arblost_mask                                 (0x00004000)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slv_arblost(data)                                (0x00004000&((data)<<14))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slv_arblost_src(data)                            ((0x00004000&(data))>>14)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_slv_arblost(data)                            ((0x00004000&(data))>>14)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slvflush_txfifo_shift                            (13)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slvflush_txfifo_mask                             (0x00002000)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slvflush_txfifo(data)                            (0x00002000&((data)<<13))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_slvflush_txfifo_src(data)                        ((0x00002000&(data))>>13)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_slvflush_txfifo(data)                        ((0x00002000&(data))>>13)
+#define MIS_IC2_TX_ABRT_SOURCE_arb_lost_shift                                        (12)
+#define MIS_IC2_TX_ABRT_SOURCE_arb_lost_mask                                         (0x00001000)
+#define MIS_IC2_TX_ABRT_SOURCE_arb_lost(data)                                        (0x00001000&((data)<<12))
+#define MIS_IC2_TX_ABRT_SOURCE_arb_lost_src(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC2_TX_ABRT_SOURCE_get_arb_lost(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC2_TX_ABRT_SOURCE_arb_master_dis_shift                                  (11)
+#define MIS_IC2_TX_ABRT_SOURCE_arb_master_dis_mask                                   (0x00000800)
+#define MIS_IC2_TX_ABRT_SOURCE_arb_master_dis(data)                                  (0x00000800&((data)<<11))
+#define MIS_IC2_TX_ABRT_SOURCE_arb_master_dis_src(data)                              ((0x00000800&(data))>>11)
+#define MIS_IC2_TX_ABRT_SOURCE_get_arb_master_dis(data)                              ((0x00000800&(data))>>11)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_shift                             (10)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_mask                              (0x00000400)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10b_rd_norstrt(data)                             (0x00000400&((data)<<10))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_src(data)                         ((0x00000400&(data))>>10)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_10b_rd_norstrt(data)                         ((0x00000400&(data))>>10)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_sbyte_norstrt_shift                              (9)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_sbyte_norstrt_mask                               (0x00000200)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_sbyte_norstrt(data)                              (0x00000200&((data)<<9))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_sbyte_norstrt_src(data)                          ((0x00000200&(data))>>9)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_sbyte_norstrt(data)                          ((0x00000200&(data))>>9)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_hs_norstrt_shift                                 (8)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_hs_norstrt_mask                                  (0x00000100)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_hs_norstrt(data)                                 (0x00000100&((data)<<8))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_hs_norstrt_src(data)                             ((0x00000100&(data))>>8)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_hs_norstrt(data)                             ((0x00000100&(data))>>8)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_sbyte_ackdet_shift                               (7)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_sbyte_ackdet_mask                                (0x00000080)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_sbyte_ackdet(data)                               (0x00000080&((data)<<7))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_sbyte_ackdet_src(data)                           ((0x00000080&(data))>>7)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_sbyte_ackdet(data)                           ((0x00000080&(data))>>7)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_hs_ackdet_shift                                  (6)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_hs_ackdet_mask                                   (0x00000040)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_hs_ackdet(data)                                  (0x00000040&((data)<<6))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_hs_ackdet_src(data)                              ((0x00000040&(data))>>6)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_hs_ackdet(data)                              ((0x00000040&(data))>>6)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_gcall_read_shift                                 (5)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_gcall_read_mask                                  (0x00000020)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_gcall_read(data)                                 (0x00000020&((data)<<5))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_gcall_read_src(data)                             ((0x00000020&(data))>>5)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_gcall_read(data)                             ((0x00000020&(data))>>5)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_gcall_noack_shift                                (4)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_gcall_noack_mask                                 (0x00000010)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_gcall_noack(data)                                (0x00000010&((data)<<4))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_gcall_noack_src(data)                            ((0x00000010&(data))>>4)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_gcall_noack(data)                            ((0x00000010&(data))>>4)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_txdata_noack_shift                               (3)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_txdata_noack_mask                                (0x00000008)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_txdata_noack(data)                               (0x00000008&((data)<<3))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_txdata_noack_src(data)                           ((0x00000008&(data))>>3)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_txdata_noack(data)                           ((0x00000008&(data))>>3)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10addr2_noack_shift                              (2)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10addr2_noack_mask                               (0x00000004)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10addr2_noack(data)                              (0x00000004&((data)<<2))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10addr2_noack_src(data)                          ((0x00000004&(data))>>2)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_10addr2_noack(data)                          ((0x00000004&(data))>>2)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10addr1_noack_shift                              (1)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10addr1_noack_mask                               (0x00000002)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10addr1_noack(data)                              (0x00000002&((data)<<1))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_10addr1_noack_src(data)                          ((0x00000002&(data))>>1)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_10addr1_noack(data)                          ((0x00000002&(data))>>1)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_7b_addr_noack_shift                              (0)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_7b_addr_noack_mask                               (0x00000001)
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_7b_addr_noack(data)                              (0x00000001&((data)<<0))
+#define MIS_IC2_TX_ABRT_SOURCE_abrt_7b_addr_noack_src(data)                          ((0x00000001&(data))>>0)
+#define MIS_IC2_TX_ABRT_SOURCE_get_abrt_7b_addr_noack(data)                          ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_SLV_DATA_NACK_ONLY                                                   0x1801B784
+#define MIS_IC2_SLV_DATA_NACK_ONLY_reg_addr                                          "0xB801B784"
+#define MIS_IC2_SLV_DATA_NACK_ONLY_reg                                               0xB801B784
+#define set_MIS_IC2_SLV_DATA_NACK_ONLY_reg(data)   (*((volatile unsigned int*) MIS_IC2_SLV_DATA_NACK_ONLY_reg)=data)
+#define get_MIS_IC2_SLV_DATA_NACK_ONLY_reg   (*((volatile unsigned int*) MIS_IC2_SLV_DATA_NACK_ONLY_reg))
+#define MIS_IC2_SLV_DATA_NACK_ONLY_inst_adr                                          "0x00E1"
+#define MIS_IC2_SLV_DATA_NACK_ONLY_inst                                              0x00E1
+#define MIS_IC2_SLV_DATA_NACK_ONLY_nack_shift                                        (0)
+#define MIS_IC2_SLV_DATA_NACK_ONLY_nack_mask                                         (0x00000001)
+#define MIS_IC2_SLV_DATA_NACK_ONLY_nack(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC2_SLV_DATA_NACK_ONLY_nack_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC2_SLV_DATA_NACK_ONLY_get_nack(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_DMA_CR                                                               0x1801B788
+#define MIS_IC2_DMA_CR_reg_addr                                                      "0xB801B788"
+#define MIS_IC2_DMA_CR_reg                                                           0xB801B788
+#define set_MIS_IC2_DMA_CR_reg(data)   (*((volatile unsigned int*) MIS_IC2_DMA_CR_reg)=data)
+#define get_MIS_IC2_DMA_CR_reg   (*((volatile unsigned int*) MIS_IC2_DMA_CR_reg))
+#define MIS_IC2_DMA_CR_inst_adr                                                      "0x00E2"
+#define MIS_IC2_DMA_CR_inst                                                          0x00E2
+#define MIS_IC2_DMA_CR_tdmae_shift                                                   (1)
+#define MIS_IC2_DMA_CR_tdmae_mask                                                    (0x00000002)
+#define MIS_IC2_DMA_CR_tdmae(data)                                                   (0x00000002&((data)<<1))
+#define MIS_IC2_DMA_CR_tdmae_src(data)                                               ((0x00000002&(data))>>1)
+#define MIS_IC2_DMA_CR_get_tdmae(data)                                               ((0x00000002&(data))>>1)
+#define MIS_IC2_DMA_CR_rdmae_shift                                                   (0)
+#define MIS_IC2_DMA_CR_rdmae_mask                                                    (0x00000001)
+#define MIS_IC2_DMA_CR_rdmae(data)                                                   (0x00000001&((data)<<0))
+#define MIS_IC2_DMA_CR_rdmae_src(data)                                               ((0x00000001&(data))>>0)
+#define MIS_IC2_DMA_CR_get_rdmae(data)                                               ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_DMA_TDLR                                                             0x1801B78C
+#define MIS_IC2_DMA_TDLR_reg_addr                                                    "0xB801B78C"
+#define MIS_IC2_DMA_TDLR_reg                                                         0xB801B78C
+#define set_MIS_IC2_DMA_TDLR_reg(data)   (*((volatile unsigned int*) MIS_IC2_DMA_TDLR_reg)=data)
+#define get_MIS_IC2_DMA_TDLR_reg   (*((volatile unsigned int*) MIS_IC2_DMA_TDLR_reg))
+#define MIS_IC2_DMA_TDLR_inst_adr                                                    "0x00E3"
+#define MIS_IC2_DMA_TDLR_inst                                                        0x00E3
+#define MIS_IC2_DMA_TDLR_dmatdl_shift                                                (0)
+#define MIS_IC2_DMA_TDLR_dmatdl_mask                                                 (0x00000007)
+#define MIS_IC2_DMA_TDLR_dmatdl(data)                                                (0x00000007&((data)<<0))
+#define MIS_IC2_DMA_TDLR_dmatdl_src(data)                                            ((0x00000007&(data))>>0)
+#define MIS_IC2_DMA_TDLR_get_dmatdl(data)                                            ((0x00000007&(data))>>0)
+
+
+#define MIS_IC2_DMA_RDLR                                                             0x1801B790
+#define MIS_IC2_DMA_RDLR_reg_addr                                                    "0xB801B790"
+#define MIS_IC2_DMA_RDLR_reg                                                         0xB801B790
+#define set_MIS_IC2_DMA_RDLR_reg(data)   (*((volatile unsigned int*) MIS_IC2_DMA_RDLR_reg)=data)
+#define get_MIS_IC2_DMA_RDLR_reg   (*((volatile unsigned int*) MIS_IC2_DMA_RDLR_reg))
+#define MIS_IC2_DMA_RDLR_inst_adr                                                    "0x00E4"
+#define MIS_IC2_DMA_RDLR_inst                                                        0x00E4
+#define MIS_IC2_DMA_RDLR_dmardl_shift                                                (0)
+#define MIS_IC2_DMA_RDLR_dmardl_mask                                                 (0x0000000F)
+#define MIS_IC2_DMA_RDLR_dmardl(data)                                                (0x0000000F&((data)<<0))
+#define MIS_IC2_DMA_RDLR_dmardl_src(data)                                            ((0x0000000F&(data))>>0)
+#define MIS_IC2_DMA_RDLR_get_dmardl(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC2_SDA_SETUP                                                            0x1801B794
+#define MIS_IC2_SDA_SETUP_reg_addr                                                   "0xB801B794"
+#define MIS_IC2_SDA_SETUP_reg                                                        0xB801B794
+#define set_MIS_IC2_SDA_SETUP_reg(data)   (*((volatile unsigned int*) MIS_IC2_SDA_SETUP_reg)=data)
+#define get_MIS_IC2_SDA_SETUP_reg   (*((volatile unsigned int*) MIS_IC2_SDA_SETUP_reg))
+#define MIS_IC2_SDA_SETUP_inst_adr                                                   "0x00E5"
+#define MIS_IC2_SDA_SETUP_inst                                                       0x00E5
+#define MIS_IC2_SDA_SETUP_sda_setup_shift                                            (0)
+#define MIS_IC2_SDA_SETUP_sda_setup_mask                                             (0x000000FF)
+#define MIS_IC2_SDA_SETUP_sda_setup(data)                                            (0x000000FF&((data)<<0))
+#define MIS_IC2_SDA_SETUP_sda_setup_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIS_IC2_SDA_SETUP_get_sda_setup(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC2_ACK_GENERAL_CALL                                                     0x1801B798
+#define MIS_IC2_ACK_GENERAL_CALL_reg_addr                                            "0xB801B798"
+#define MIS_IC2_ACK_GENERAL_CALL_reg                                                 0xB801B798
+#define set_MIS_IC2_ACK_GENERAL_CALL_reg(data)   (*((volatile unsigned int*) MIS_IC2_ACK_GENERAL_CALL_reg)=data)
+#define get_MIS_IC2_ACK_GENERAL_CALL_reg   (*((volatile unsigned int*) MIS_IC2_ACK_GENERAL_CALL_reg))
+#define MIS_IC2_ACK_GENERAL_CALL_inst_adr                                            "0x00E6"
+#define MIS_IC2_ACK_GENERAL_CALL_inst                                                0x00E6
+#define MIS_IC2_ACK_GENERAL_CALL_ack_gen_call_shift                                  (0)
+#define MIS_IC2_ACK_GENERAL_CALL_ack_gen_call_mask                                   (0x00000001)
+#define MIS_IC2_ACK_GENERAL_CALL_ack_gen_call(data)                                  (0x00000001&((data)<<0))
+#define MIS_IC2_ACK_GENERAL_CALL_ack_gen_call_src(data)                              ((0x00000001&(data))>>0)
+#define MIS_IC2_ACK_GENERAL_CALL_get_ack_gen_call(data)                              ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_ENABLE_STATUS                                                        0x1801B79C
+#define MIS_IC2_ENABLE_STATUS_reg_addr                                               "0xB801B79C"
+#define MIS_IC2_ENABLE_STATUS_reg                                                    0xB801B79C
+#define set_MIS_IC2_ENABLE_STATUS_reg(data)   (*((volatile unsigned int*) MIS_IC2_ENABLE_STATUS_reg)=data)
+#define get_MIS_IC2_ENABLE_STATUS_reg   (*((volatile unsigned int*) MIS_IC2_ENABLE_STATUS_reg))
+#define MIS_IC2_ENABLE_STATUS_inst_adr                                               "0x00E7"
+#define MIS_IC2_ENABLE_STATUS_inst                                                   0x00E7
+#define MIS_IC2_ENABLE_STATUS_slv_rx_data_lost_shift                                 (2)
+#define MIS_IC2_ENABLE_STATUS_slv_rx_data_lost_mask                                  (0x00000004)
+#define MIS_IC2_ENABLE_STATUS_slv_rx_data_lost(data)                                 (0x00000004&((data)<<2))
+#define MIS_IC2_ENABLE_STATUS_slv_rx_data_lost_src(data)                             ((0x00000004&(data))>>2)
+#define MIS_IC2_ENABLE_STATUS_get_slv_rx_data_lost(data)                             ((0x00000004&(data))>>2)
+#define MIS_IC2_ENABLE_STATUS_slv_disabled_whi_shift                                 (1)
+#define MIS_IC2_ENABLE_STATUS_slv_disabled_whi_mask                                  (0x00000002)
+#define MIS_IC2_ENABLE_STATUS_slv_disabled_whi(data)                                 (0x00000002&((data)<<1))
+#define MIS_IC2_ENABLE_STATUS_slv_disabled_whi_src(data)                             ((0x00000002&(data))>>1)
+#define MIS_IC2_ENABLE_STATUS_get_slv_disabled_whi(data)                             ((0x00000002&(data))>>1)
+#define MIS_IC2_ENABLE_STATUS_ic_en_shift                                            (0)
+#define MIS_IC2_ENABLE_STATUS_ic_en_mask                                             (0x00000001)
+#define MIS_IC2_ENABLE_STATUS_ic_en(data)                                            (0x00000001&((data)<<0))
+#define MIS_IC2_ENABLE_STATUS_ic_en_src(data)                                        ((0x00000001&(data))>>0)
+#define MIS_IC2_ENABLE_STATUS_get_ic_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define MIS_IC2_COMP_PARAM_1                                                         0x1801B7F4
+#define MIS_IC2_COMP_PARAM_1_reg_addr                                                "0xB801B7F4"
+#define MIS_IC2_COMP_PARAM_1_reg                                                     0xB801B7F4
+#define set_MIS_IC2_COMP_PARAM_1_reg(data)   (*((volatile unsigned int*) MIS_IC2_COMP_PARAM_1_reg)=data)
+#define get_MIS_IC2_COMP_PARAM_1_reg   (*((volatile unsigned int*) MIS_IC2_COMP_PARAM_1_reg))
+#define MIS_IC2_COMP_PARAM_1_inst_adr                                                "0x00FD"
+#define MIS_IC2_COMP_PARAM_1_inst                                                    0x00FD
+#define MIS_IC2_COMP_PARAM_1_tx_buffer_depth_shift                                   (16)
+#define MIS_IC2_COMP_PARAM_1_tx_buffer_depth_mask                                    (0x00FF0000)
+#define MIS_IC2_COMP_PARAM_1_tx_buffer_depth(data)                                   (0x00FF0000&((data)<<16))
+#define MIS_IC2_COMP_PARAM_1_tx_buffer_depth_src(data)                               ((0x00FF0000&(data))>>16)
+#define MIS_IC2_COMP_PARAM_1_get_tx_buffer_depth(data)                               ((0x00FF0000&(data))>>16)
+#define MIS_IC2_COMP_PARAM_1_rx_buffer_depth_shift                                   (8)
+#define MIS_IC2_COMP_PARAM_1_rx_buffer_depth_mask                                    (0x0000FF00)
+#define MIS_IC2_COMP_PARAM_1_rx_buffer_depth(data)                                   (0x0000FF00&((data)<<8))
+#define MIS_IC2_COMP_PARAM_1_rx_buffer_depth_src(data)                               ((0x0000FF00&(data))>>8)
+#define MIS_IC2_COMP_PARAM_1_get_rx_buffer_depth(data)                               ((0x0000FF00&(data))>>8)
+#define MIS_IC2_COMP_PARAM_1_add_encoded_params_shift                                (7)
+#define MIS_IC2_COMP_PARAM_1_add_encoded_params_mask                                 (0x00000080)
+#define MIS_IC2_COMP_PARAM_1_add_encoded_params(data)                                (0x00000080&((data)<<7))
+#define MIS_IC2_COMP_PARAM_1_add_encoded_params_src(data)                            ((0x00000080&(data))>>7)
+#define MIS_IC2_COMP_PARAM_1_get_add_encoded_params(data)                            ((0x00000080&(data))>>7)
+#define MIS_IC2_COMP_PARAM_1_has_dma_shift                                           (6)
+#define MIS_IC2_COMP_PARAM_1_has_dma_mask                                            (0x00000040)
+#define MIS_IC2_COMP_PARAM_1_has_dma(data)                                           (0x00000040&((data)<<6))
+#define MIS_IC2_COMP_PARAM_1_has_dma_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC2_COMP_PARAM_1_get_has_dma(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC2_COMP_PARAM_1_intr_io_shift                                           (5)
+#define MIS_IC2_COMP_PARAM_1_intr_io_mask                                            (0x00000020)
+#define MIS_IC2_COMP_PARAM_1_intr_io(data)                                           (0x00000020&((data)<<5))
+#define MIS_IC2_COMP_PARAM_1_intr_io_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC2_COMP_PARAM_1_get_intr_io(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC2_COMP_PARAM_1_hc_count_values_shift                                   (4)
+#define MIS_IC2_COMP_PARAM_1_hc_count_values_mask                                    (0x00000010)
+#define MIS_IC2_COMP_PARAM_1_hc_count_values(data)                                   (0x00000010&((data)<<4))
+#define MIS_IC2_COMP_PARAM_1_hc_count_values_src(data)                               ((0x00000010&(data))>>4)
+#define MIS_IC2_COMP_PARAM_1_get_hc_count_values(data)                               ((0x00000010&(data))>>4)
+#define MIS_IC2_COMP_PARAM_1_max_speed_mode_shift                                    (2)
+#define MIS_IC2_COMP_PARAM_1_max_speed_mode_mask                                     (0x0000000C)
+#define MIS_IC2_COMP_PARAM_1_max_speed_mode(data)                                    (0x0000000C&((data)<<2))
+#define MIS_IC2_COMP_PARAM_1_max_speed_mode_src(data)                                ((0x0000000C&(data))>>2)
+#define MIS_IC2_COMP_PARAM_1_get_max_speed_mode(data)                                ((0x0000000C&(data))>>2)
+#define MIS_IC2_COMP_PARAM_1_apb_data_width_shift                                    (0)
+#define MIS_IC2_COMP_PARAM_1_apb_data_width_mask                                     (0x00000003)
+#define MIS_IC2_COMP_PARAM_1_apb_data_width(data)                                    (0x00000003&((data)<<0))
+#define MIS_IC2_COMP_PARAM_1_apb_data_width_src(data)                                ((0x00000003&(data))>>0)
+#define MIS_IC2_COMP_PARAM_1_get_apb_data_width(data)                                ((0x00000003&(data))>>0)
+
+
+#define MIS_IC2_COMP_VERSION                                                         0x1801B7F8
+#define MIS_IC2_COMP_VERSION_reg_addr                                                "0xB801B7F8"
+#define MIS_IC2_COMP_VERSION_reg                                                     0xB801B7F8
+#define set_MIS_IC2_COMP_VERSION_reg(data)   (*((volatile unsigned int*) MIS_IC2_COMP_VERSION_reg)=data)
+#define get_MIS_IC2_COMP_VERSION_reg   (*((volatile unsigned int*) MIS_IC2_COMP_VERSION_reg))
+#define MIS_IC2_COMP_VERSION_inst_adr                                                "0x00FE"
+#define MIS_IC2_COMP_VERSION_inst                                                    0x00FE
+#define MIS_IC2_COMP_VERSION_ic_comp_version_shift                                   (0)
+#define MIS_IC2_COMP_VERSION_ic_comp_version_mask                                    (0xFFFFFFFF)
+#define MIS_IC2_COMP_VERSION_ic_comp_version(data)                                   (0xFFFFFFFF&((data)<<0))
+#define MIS_IC2_COMP_VERSION_ic_comp_version_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define MIS_IC2_COMP_VERSION_get_ic_comp_version(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_IC2_COMP_TYPE                                                            0x1801B7FC
+#define MIS_IC2_COMP_TYPE_reg_addr                                                   "0xB801B7FC"
+#define MIS_IC2_COMP_TYPE_reg                                                        0xB801B7FC
+#define set_MIS_IC2_COMP_TYPE_reg(data)   (*((volatile unsigned int*) MIS_IC2_COMP_TYPE_reg)=data)
+#define get_MIS_IC2_COMP_TYPE_reg   (*((volatile unsigned int*) MIS_IC2_COMP_TYPE_reg))
+#define MIS_IC2_COMP_TYPE_inst_adr                                                   "0x00FF"
+#define MIS_IC2_COMP_TYPE_inst                                                       0x00FF
+#define MIS_IC2_COMP_TYPE_ic_comp_type_shift                                         (0)
+#define MIS_IC2_COMP_TYPE_ic_comp_type_mask                                          (0xFFFFFFFF)
+#define MIS_IC2_COMP_TYPE_ic_comp_type(data)                                         (0xFFFFFFFF&((data)<<0))
+#define MIS_IC2_COMP_TYPE_ic_comp_type_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define MIS_IC2_COMP_TYPE_get_ic_comp_type(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_IC3_CON                                                                  0x1801B900
+#define MIS_IC3_CON_reg_addr                                                         "0xB801B900"
+#define MIS_IC3_CON_reg                                                              0xB801B900
+#define set_MIS_IC3_CON_reg(data)   (*((volatile unsigned int*) MIS_IC3_CON_reg)=data)
+#define get_MIS_IC3_CON_reg   (*((volatile unsigned int*) MIS_IC3_CON_reg))
+#define MIS_IC3_CON_inst_adr                                                         "0x0040"
+#define MIS_IC3_CON_inst                                                             0x0040
+#define MIS_IC3_CON_ic_slave_disable_shift                                           (6)
+#define MIS_IC3_CON_ic_slave_disable_mask                                            (0x00000040)
+#define MIS_IC3_CON_ic_slave_disable(data)                                           (0x00000040&((data)<<6))
+#define MIS_IC3_CON_ic_slave_disable_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC3_CON_get_ic_slave_disable(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC3_CON_ic_restart_en_shift                                              (5)
+#define MIS_IC3_CON_ic_restart_en_mask                                               (0x00000020)
+#define MIS_IC3_CON_ic_restart_en(data)                                              (0x00000020&((data)<<5))
+#define MIS_IC3_CON_ic_restart_en_src(data)                                          ((0x00000020&(data))>>5)
+#define MIS_IC3_CON_get_ic_restart_en(data)                                          ((0x00000020&(data))>>5)
+#define MIS_IC3_CON_ic_10bitaddr_master_shift                                        (4)
+#define MIS_IC3_CON_ic_10bitaddr_master_mask                                         (0x00000010)
+#define MIS_IC3_CON_ic_10bitaddr_master(data)                                        (0x00000010&((data)<<4))
+#define MIS_IC3_CON_ic_10bitaddr_master_src(data)                                    ((0x00000010&(data))>>4)
+#define MIS_IC3_CON_get_ic_10bitaddr_master(data)                                    ((0x00000010&(data))>>4)
+#define MIS_IC3_CON_ic_10bitaddr_slave_shift                                         (3)
+#define MIS_IC3_CON_ic_10bitaddr_slave_mask                                          (0x00000008)
+#define MIS_IC3_CON_ic_10bitaddr_slave(data)                                         (0x00000008&((data)<<3))
+#define MIS_IC3_CON_ic_10bitaddr_slave_src(data)                                     ((0x00000008&(data))>>3)
+#define MIS_IC3_CON_get_ic_10bitaddr_slave(data)                                     ((0x00000008&(data))>>3)
+#define MIS_IC3_CON_speed_shift                                                      (1)
+#define MIS_IC3_CON_speed_mask                                                       (0x00000006)
+#define MIS_IC3_CON_speed(data)                                                      (0x00000006&((data)<<1))
+#define MIS_IC3_CON_speed_src(data)                                                  ((0x00000006&(data))>>1)
+#define MIS_IC3_CON_get_speed(data)                                                  ((0x00000006&(data))>>1)
+#define MIS_IC3_CON_master_mode_shift                                                (0)
+#define MIS_IC3_CON_master_mode_mask                                                 (0x00000001)
+#define MIS_IC3_CON_master_mode(data)                                                (0x00000001&((data)<<0))
+#define MIS_IC3_CON_master_mode_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_IC3_CON_get_master_mode(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_TAR                                                                  0x1801B904
+#define MIS_IC3_TAR_reg_addr                                                         "0xB801B904"
+#define MIS_IC3_TAR_reg                                                              0xB801B904
+#define set_MIS_IC3_TAR_reg(data)   (*((volatile unsigned int*) MIS_IC3_TAR_reg)=data)
+#define get_MIS_IC3_TAR_reg   (*((volatile unsigned int*) MIS_IC3_TAR_reg))
+#define MIS_IC3_TAR_inst_adr                                                         "0x0041"
+#define MIS_IC3_TAR_inst                                                             0x0041
+#define MIS_IC3_TAR_ic_10bitaddr_master_shift                                        (12)
+#define MIS_IC3_TAR_ic_10bitaddr_master_mask                                         (0x00001000)
+#define MIS_IC3_TAR_ic_10bitaddr_master(data)                                        (0x00001000&((data)<<12))
+#define MIS_IC3_TAR_ic_10bitaddr_master_src(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC3_TAR_get_ic_10bitaddr_master(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC3_TAR_special_shift                                                    (11)
+#define MIS_IC3_TAR_special_mask                                                     (0x00000800)
+#define MIS_IC3_TAR_special(data)                                                    (0x00000800&((data)<<11))
+#define MIS_IC3_TAR_special_src(data)                                                ((0x00000800&(data))>>11)
+#define MIS_IC3_TAR_get_special(data)                                                ((0x00000800&(data))>>11)
+#define MIS_IC3_TAR_gc_or_start_shift                                                (10)
+#define MIS_IC3_TAR_gc_or_start_mask                                                 (0x00000400)
+#define MIS_IC3_TAR_gc_or_start(data)                                                (0x00000400&((data)<<10))
+#define MIS_IC3_TAR_gc_or_start_src(data)                                            ((0x00000400&(data))>>10)
+#define MIS_IC3_TAR_get_gc_or_start(data)                                            ((0x00000400&(data))>>10)
+#define MIS_IC3_TAR_ic_tar_shift                                                     (0)
+#define MIS_IC3_TAR_ic_tar_mask                                                      (0x000003FF)
+#define MIS_IC3_TAR_ic_tar(data)                                                     (0x000003FF&((data)<<0))
+#define MIS_IC3_TAR_ic_tar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define MIS_IC3_TAR_get_ic_tar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define MIS_IC3_SAR                                                                  0x1801B908
+#define MIS_IC3_SAR_reg_addr                                                         "0xB801B908"
+#define MIS_IC3_SAR_reg                                                              0xB801B908
+#define set_MIS_IC3_SAR_reg(data)   (*((volatile unsigned int*) MIS_IC3_SAR_reg)=data)
+#define get_MIS_IC3_SAR_reg   (*((volatile unsigned int*) MIS_IC3_SAR_reg))
+#define MIS_IC3_SAR_inst_adr                                                         "0x0042"
+#define MIS_IC3_SAR_inst                                                             0x0042
+#define MIS_IC3_SAR_ic_sar_shift                                                     (0)
+#define MIS_IC3_SAR_ic_sar_mask                                                      (0x000003FF)
+#define MIS_IC3_SAR_ic_sar(data)                                                     (0x000003FF&((data)<<0))
+#define MIS_IC3_SAR_ic_sar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define MIS_IC3_SAR_get_ic_sar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define MIS_IC3_HS_MADDR                                                             0x1801B90C
+#define MIS_IC3_HS_MADDR_reg_addr                                                    "0xB801B90C"
+#define MIS_IC3_HS_MADDR_reg                                                         0xB801B90C
+#define set_MIS_IC3_HS_MADDR_reg(data)   (*((volatile unsigned int*) MIS_IC3_HS_MADDR_reg)=data)
+#define get_MIS_IC3_HS_MADDR_reg   (*((volatile unsigned int*) MIS_IC3_HS_MADDR_reg))
+#define MIS_IC3_HS_MADDR_inst_adr                                                    "0x0043"
+#define MIS_IC3_HS_MADDR_inst                                                        0x0043
+#define MIS_IC3_HS_MADDR_ic_hs_mar_shift                                             (0)
+#define MIS_IC3_HS_MADDR_ic_hs_mar_mask                                              (0x00000007)
+#define MIS_IC3_HS_MADDR_ic_hs_mar(data)                                             (0x00000007&((data)<<0))
+#define MIS_IC3_HS_MADDR_ic_hs_mar_src(data)                                         ((0x00000007&(data))>>0)
+#define MIS_IC3_HS_MADDR_get_ic_hs_mar(data)                                         ((0x00000007&(data))>>0)
+
+
+#define MIS_IC3_DATA_CMD                                                             0x1801B910
+#define MIS_IC3_DATA_CMD_reg_addr                                                    "0xB801B910"
+#define MIS_IC3_DATA_CMD_reg                                                         0xB801B910
+#define set_MIS_IC3_DATA_CMD_reg(data)   (*((volatile unsigned int*) MIS_IC3_DATA_CMD_reg)=data)
+#define get_MIS_IC3_DATA_CMD_reg   (*((volatile unsigned int*) MIS_IC3_DATA_CMD_reg))
+#define MIS_IC3_DATA_CMD_inst_adr                                                    "0x0044"
+#define MIS_IC3_DATA_CMD_inst                                                        0x0044
+#define MIS_IC3_DATA_CMD_restart_shift                                               (10)
+#define MIS_IC3_DATA_CMD_restart_mask                                                (0x00000400)
+#define MIS_IC3_DATA_CMD_restart(data)                                               (0x00000400&((data)<<10))
+#define MIS_IC3_DATA_CMD_restart_src(data)                                           ((0x00000400&(data))>>10)
+#define MIS_IC3_DATA_CMD_get_restart(data)                                           ((0x00000400&(data))>>10)
+#define MIS_IC3_DATA_CMD_stop_shift                                                  (9)
+#define MIS_IC3_DATA_CMD_stop_mask                                                   (0x00000200)
+#define MIS_IC3_DATA_CMD_stop(data)                                                  (0x00000200&((data)<<9))
+#define MIS_IC3_DATA_CMD_stop_src(data)                                              ((0x00000200&(data))>>9)
+#define MIS_IC3_DATA_CMD_get_stop(data)                                              ((0x00000200&(data))>>9)
+#define MIS_IC3_DATA_CMD_cmd_shift                                                   (8)
+#define MIS_IC3_DATA_CMD_cmd_mask                                                    (0x00000100)
+#define MIS_IC3_DATA_CMD_cmd(data)                                                   (0x00000100&((data)<<8))
+#define MIS_IC3_DATA_CMD_cmd_src(data)                                               ((0x00000100&(data))>>8)
+#define MIS_IC3_DATA_CMD_get_cmd(data)                                               ((0x00000100&(data))>>8)
+#define MIS_IC3_DATA_CMD_dat_shift                                                   (0)
+#define MIS_IC3_DATA_CMD_dat_mask                                                    (0x000000FF)
+#define MIS_IC3_DATA_CMD_dat(data)                                                   (0x000000FF&((data)<<0))
+#define MIS_IC3_DATA_CMD_dat_src(data)                                               ((0x000000FF&(data))>>0)
+#define MIS_IC3_DATA_CMD_get_dat(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC3_SS_SCL_HCNT                                                          0x1801B914
+#define MIS_IC3_SS_SCL_HCNT_reg_addr                                                 "0xB801B914"
+#define MIS_IC3_SS_SCL_HCNT_reg                                                      0xB801B914
+#define set_MIS_IC3_SS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) MIS_IC3_SS_SCL_HCNT_reg)=data)
+#define get_MIS_IC3_SS_SCL_HCNT_reg   (*((volatile unsigned int*) MIS_IC3_SS_SCL_HCNT_reg))
+#define MIS_IC3_SS_SCL_HCNT_inst_adr                                                 "0x0045"
+#define MIS_IC3_SS_SCL_HCNT_inst                                                     0x0045
+#define MIS_IC3_SS_SCL_HCNT_ic_ss_scl_hcnt_shift                                     (0)
+#define MIS_IC3_SS_SCL_HCNT_ic_ss_scl_hcnt_mask                                      (0x0000FFFF)
+#define MIS_IC3_SS_SCL_HCNT_ic_ss_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC3_SS_SCL_HCNT_ic_ss_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC3_SS_SCL_HCNT_get_ic_ss_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC3_SS_SCL_LCNT                                                          0x1801B918
+#define MIS_IC3_SS_SCL_LCNT_reg_addr                                                 "0xB801B918"
+#define MIS_IC3_SS_SCL_LCNT_reg                                                      0xB801B918
+#define set_MIS_IC3_SS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) MIS_IC3_SS_SCL_LCNT_reg)=data)
+#define get_MIS_IC3_SS_SCL_LCNT_reg   (*((volatile unsigned int*) MIS_IC3_SS_SCL_LCNT_reg))
+#define MIS_IC3_SS_SCL_LCNT_inst_adr                                                 "0x0046"
+#define MIS_IC3_SS_SCL_LCNT_inst                                                     0x0046
+#define MIS_IC3_SS_SCL_LCNT_ic_ss_scl_lcnt_shift                                     (0)
+#define MIS_IC3_SS_SCL_LCNT_ic_ss_scl_lcnt_mask                                      (0x0000FFFF)
+#define MIS_IC3_SS_SCL_LCNT_ic_ss_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC3_SS_SCL_LCNT_ic_ss_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC3_SS_SCL_LCNT_get_ic_ss_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC3_FS_SCL_HCNT                                                          0x1801B91C
+#define MIS_IC3_FS_SCL_HCNT_reg_addr                                                 "0xB801B91C"
+#define MIS_IC3_FS_SCL_HCNT_reg                                                      0xB801B91C
+#define set_MIS_IC3_FS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) MIS_IC3_FS_SCL_HCNT_reg)=data)
+#define get_MIS_IC3_FS_SCL_HCNT_reg   (*((volatile unsigned int*) MIS_IC3_FS_SCL_HCNT_reg))
+#define MIS_IC3_FS_SCL_HCNT_inst_adr                                                 "0x0047"
+#define MIS_IC3_FS_SCL_HCNT_inst                                                     0x0047
+#define MIS_IC3_FS_SCL_HCNT_ic_fs_scl_hcnt_shift                                     (0)
+#define MIS_IC3_FS_SCL_HCNT_ic_fs_scl_hcnt_mask                                      (0x0000FFFF)
+#define MIS_IC3_FS_SCL_HCNT_ic_fs_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC3_FS_SCL_HCNT_ic_fs_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC3_FS_SCL_HCNT_get_ic_fs_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC3_FS_SCL_LCNT                                                          0x1801B920
+#define MIS_IC3_FS_SCL_LCNT_reg_addr                                                 "0xB801B920"
+#define MIS_IC3_FS_SCL_LCNT_reg                                                      0xB801B920
+#define set_MIS_IC3_FS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) MIS_IC3_FS_SCL_LCNT_reg)=data)
+#define get_MIS_IC3_FS_SCL_LCNT_reg   (*((volatile unsigned int*) MIS_IC3_FS_SCL_LCNT_reg))
+#define MIS_IC3_FS_SCL_LCNT_inst_adr                                                 "0x0048"
+#define MIS_IC3_FS_SCL_LCNT_inst                                                     0x0048
+#define MIS_IC3_FS_SCL_LCNT_ic_fs_scl_lcnt_shift                                     (0)
+#define MIS_IC3_FS_SCL_LCNT_ic_fs_scl_lcnt_mask                                      (0x0000FFFF)
+#define MIS_IC3_FS_SCL_LCNT_ic_fs_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC3_FS_SCL_LCNT_ic_fs_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC3_FS_SCL_LCNT_get_ic_fs_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC3_INTR_STAT                                                            0x1801B92C
+#define MIS_IC3_INTR_STAT_reg_addr                                                   "0xB801B92C"
+#define MIS_IC3_INTR_STAT_reg                                                        0xB801B92C
+#define set_MIS_IC3_INTR_STAT_reg(data)   (*((volatile unsigned int*) MIS_IC3_INTR_STAT_reg)=data)
+#define get_MIS_IC3_INTR_STAT_reg   (*((volatile unsigned int*) MIS_IC3_INTR_STAT_reg))
+#define MIS_IC3_INTR_STAT_inst_adr                                                   "0x004B"
+#define MIS_IC3_INTR_STAT_inst                                                       0x004B
+#define MIS_IC3_INTR_STAT_r_gen_call_shift                                           (11)
+#define MIS_IC3_INTR_STAT_r_gen_call_mask                                            (0x00000800)
+#define MIS_IC3_INTR_STAT_r_gen_call(data)                                           (0x00000800&((data)<<11))
+#define MIS_IC3_INTR_STAT_r_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC3_INTR_STAT_get_r_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC3_INTR_STAT_r_start_det_shift                                          (10)
+#define MIS_IC3_INTR_STAT_r_start_det_mask                                           (0x00000400)
+#define MIS_IC3_INTR_STAT_r_start_det(data)                                          (0x00000400&((data)<<10))
+#define MIS_IC3_INTR_STAT_r_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC3_INTR_STAT_get_r_start_det(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC3_INTR_STAT_r_stop_det_shift                                           (9)
+#define MIS_IC3_INTR_STAT_r_stop_det_mask                                            (0x00000200)
+#define MIS_IC3_INTR_STAT_r_stop_det(data)                                           (0x00000200&((data)<<9))
+#define MIS_IC3_INTR_STAT_r_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC3_INTR_STAT_get_r_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC3_INTR_STAT_r_activity_shift                                           (8)
+#define MIS_IC3_INTR_STAT_r_activity_mask                                            (0x00000100)
+#define MIS_IC3_INTR_STAT_r_activity(data)                                           (0x00000100&((data)<<8))
+#define MIS_IC3_INTR_STAT_r_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC3_INTR_STAT_get_r_activity(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC3_INTR_STAT_r_rx_done_shift                                            (7)
+#define MIS_IC3_INTR_STAT_r_rx_done_mask                                             (0x00000080)
+#define MIS_IC3_INTR_STAT_r_rx_done(data)                                            (0x00000080&((data)<<7))
+#define MIS_IC3_INTR_STAT_r_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC3_INTR_STAT_get_r_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC3_INTR_STAT_r_tx_abrt_shift                                            (6)
+#define MIS_IC3_INTR_STAT_r_tx_abrt_mask                                             (0x00000040)
+#define MIS_IC3_INTR_STAT_r_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC3_INTR_STAT_r_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC3_INTR_STAT_get_r_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC3_INTR_STAT_r_rd_req_shift                                             (5)
+#define MIS_IC3_INTR_STAT_r_rd_req_mask                                              (0x00000020)
+#define MIS_IC3_INTR_STAT_r_rd_req(data)                                             (0x00000020&((data)<<5))
+#define MIS_IC3_INTR_STAT_r_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC3_INTR_STAT_get_r_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC3_INTR_STAT_r_tx_empty_shift                                           (4)
+#define MIS_IC3_INTR_STAT_r_tx_empty_mask                                            (0x00000010)
+#define MIS_IC3_INTR_STAT_r_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define MIS_IC3_INTR_STAT_r_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC3_INTR_STAT_get_r_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC3_INTR_STAT_r_tx_over_shift                                            (3)
+#define MIS_IC3_INTR_STAT_r_tx_over_mask                                             (0x00000008)
+#define MIS_IC3_INTR_STAT_r_tx_over(data)                                            (0x00000008&((data)<<3))
+#define MIS_IC3_INTR_STAT_r_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC3_INTR_STAT_get_r_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC3_INTR_STAT_r_rx_full_shift                                            (2)
+#define MIS_IC3_INTR_STAT_r_rx_full_mask                                             (0x00000004)
+#define MIS_IC3_INTR_STAT_r_rx_full(data)                                            (0x00000004&((data)<<2))
+#define MIS_IC3_INTR_STAT_r_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC3_INTR_STAT_get_r_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC3_INTR_STAT_r_rx_over_shift                                            (1)
+#define MIS_IC3_INTR_STAT_r_rx_over_mask                                             (0x00000002)
+#define MIS_IC3_INTR_STAT_r_rx_over(data)                                            (0x00000002&((data)<<1))
+#define MIS_IC3_INTR_STAT_r_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC3_INTR_STAT_get_r_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC3_INTR_STAT_r_rx_under_shift                                           (0)
+#define MIS_IC3_INTR_STAT_r_rx_under_mask                                            (0x00000001)
+#define MIS_IC3_INTR_STAT_r_rx_under(data)                                           (0x00000001&((data)<<0))
+#define MIS_IC3_INTR_STAT_r_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_IC3_INTR_STAT_get_r_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_INTR_MASK                                                            0x1801B930
+#define MIS_IC3_INTR_MASK_reg_addr                                                   "0xB801B930"
+#define MIS_IC3_INTR_MASK_reg                                                        0xB801B930
+#define set_MIS_IC3_INTR_MASK_reg(data)   (*((volatile unsigned int*) MIS_IC3_INTR_MASK_reg)=data)
+#define get_MIS_IC3_INTR_MASK_reg   (*((volatile unsigned int*) MIS_IC3_INTR_MASK_reg))
+#define MIS_IC3_INTR_MASK_inst_adr                                                   "0x004C"
+#define MIS_IC3_INTR_MASK_inst                                                       0x004C
+#define MIS_IC3_INTR_MASK_m_gen_call_shift                                           (11)
+#define MIS_IC3_INTR_MASK_m_gen_call_mask                                            (0x00000800)
+#define MIS_IC3_INTR_MASK_m_gen_call(data)                                           (0x00000800&((data)<<11))
+#define MIS_IC3_INTR_MASK_m_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC3_INTR_MASK_get_m_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC3_INTR_MASK_m_start_det_shift                                          (10)
+#define MIS_IC3_INTR_MASK_m_start_det_mask                                           (0x00000400)
+#define MIS_IC3_INTR_MASK_m_start_det(data)                                          (0x00000400&((data)<<10))
+#define MIS_IC3_INTR_MASK_m_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC3_INTR_MASK_get_m_start_det(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC3_INTR_MASK_m_stop_det_shift                                           (9)
+#define MIS_IC3_INTR_MASK_m_stop_det_mask                                            (0x00000200)
+#define MIS_IC3_INTR_MASK_m_stop_det(data)                                           (0x00000200&((data)<<9))
+#define MIS_IC3_INTR_MASK_m_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC3_INTR_MASK_get_m_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC3_INTR_MASK_m_activity_shift                                           (8)
+#define MIS_IC3_INTR_MASK_m_activity_mask                                            (0x00000100)
+#define MIS_IC3_INTR_MASK_m_activity(data)                                           (0x00000100&((data)<<8))
+#define MIS_IC3_INTR_MASK_m_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC3_INTR_MASK_get_m_activity(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC3_INTR_MASK_m_rx_done_shift                                            (7)
+#define MIS_IC3_INTR_MASK_m_rx_done_mask                                             (0x00000080)
+#define MIS_IC3_INTR_MASK_m_rx_done(data)                                            (0x00000080&((data)<<7))
+#define MIS_IC3_INTR_MASK_m_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC3_INTR_MASK_get_m_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC3_INTR_MASK_m_tx_abrt_shift                                            (6)
+#define MIS_IC3_INTR_MASK_m_tx_abrt_mask                                             (0x00000040)
+#define MIS_IC3_INTR_MASK_m_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC3_INTR_MASK_m_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC3_INTR_MASK_get_m_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC3_INTR_MASK_m_rd_req_shift                                             (5)
+#define MIS_IC3_INTR_MASK_m_rd_req_mask                                              (0x00000020)
+#define MIS_IC3_INTR_MASK_m_rd_req(data)                                             (0x00000020&((data)<<5))
+#define MIS_IC3_INTR_MASK_m_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC3_INTR_MASK_get_m_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC3_INTR_MASK_m_tx_empty_shift                                           (4)
+#define MIS_IC3_INTR_MASK_m_tx_empty_mask                                            (0x00000010)
+#define MIS_IC3_INTR_MASK_m_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define MIS_IC3_INTR_MASK_m_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC3_INTR_MASK_get_m_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC3_INTR_MASK_m_tx_over_shift                                            (3)
+#define MIS_IC3_INTR_MASK_m_tx_over_mask                                             (0x00000008)
+#define MIS_IC3_INTR_MASK_m_tx_over(data)                                            (0x00000008&((data)<<3))
+#define MIS_IC3_INTR_MASK_m_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC3_INTR_MASK_get_m_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC3_INTR_MASK_m_rx_full_shift                                            (2)
+#define MIS_IC3_INTR_MASK_m_rx_full_mask                                             (0x00000004)
+#define MIS_IC3_INTR_MASK_m_rx_full(data)                                            (0x00000004&((data)<<2))
+#define MIS_IC3_INTR_MASK_m_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC3_INTR_MASK_get_m_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC3_INTR_MASK_m_rx_over_shift                                            (1)
+#define MIS_IC3_INTR_MASK_m_rx_over_mask                                             (0x00000002)
+#define MIS_IC3_INTR_MASK_m_rx_over(data)                                            (0x00000002&((data)<<1))
+#define MIS_IC3_INTR_MASK_m_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC3_INTR_MASK_get_m_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC3_INTR_MASK_m_rx_under_shift                                           (0)
+#define MIS_IC3_INTR_MASK_m_rx_under_mask                                            (0x00000001)
+#define MIS_IC3_INTR_MASK_m_rx_under(data)                                           (0x00000001&((data)<<0))
+#define MIS_IC3_INTR_MASK_m_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_IC3_INTR_MASK_get_m_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_RAW_INTR_STAT                                                        0x1801B934
+#define MIS_IC3_RAW_INTR_STAT_reg_addr                                               "0xB801B934"
+#define MIS_IC3_RAW_INTR_STAT_reg                                                    0xB801B934
+#define set_MIS_IC3_RAW_INTR_STAT_reg(data)   (*((volatile unsigned int*) MIS_IC3_RAW_INTR_STAT_reg)=data)
+#define get_MIS_IC3_RAW_INTR_STAT_reg   (*((volatile unsigned int*) MIS_IC3_RAW_INTR_STAT_reg))
+#define MIS_IC3_RAW_INTR_STAT_inst_adr                                               "0x004D"
+#define MIS_IC3_RAW_INTR_STAT_inst                                                   0x004D
+#define MIS_IC3_RAW_INTR_STAT_gen_call_shift                                         (11)
+#define MIS_IC3_RAW_INTR_STAT_gen_call_mask                                          (0x00000800)
+#define MIS_IC3_RAW_INTR_STAT_gen_call(data)                                         (0x00000800&((data)<<11))
+#define MIS_IC3_RAW_INTR_STAT_gen_call_src(data)                                     ((0x00000800&(data))>>11)
+#define MIS_IC3_RAW_INTR_STAT_get_gen_call(data)                                     ((0x00000800&(data))>>11)
+#define MIS_IC3_RAW_INTR_STAT_start_det_shift                                        (10)
+#define MIS_IC3_RAW_INTR_STAT_start_det_mask                                         (0x00000400)
+#define MIS_IC3_RAW_INTR_STAT_start_det(data)                                        (0x00000400&((data)<<10))
+#define MIS_IC3_RAW_INTR_STAT_start_det_src(data)                                    ((0x00000400&(data))>>10)
+#define MIS_IC3_RAW_INTR_STAT_get_start_det(data)                                    ((0x00000400&(data))>>10)
+#define MIS_IC3_RAW_INTR_STAT_stop_det_shift                                         (9)
+#define MIS_IC3_RAW_INTR_STAT_stop_det_mask                                          (0x00000200)
+#define MIS_IC3_RAW_INTR_STAT_stop_det(data)                                         (0x00000200&((data)<<9))
+#define MIS_IC3_RAW_INTR_STAT_stop_det_src(data)                                     ((0x00000200&(data))>>9)
+#define MIS_IC3_RAW_INTR_STAT_get_stop_det(data)                                     ((0x00000200&(data))>>9)
+#define MIS_IC3_RAW_INTR_STAT_activity_shift                                         (8)
+#define MIS_IC3_RAW_INTR_STAT_activity_mask                                          (0x00000100)
+#define MIS_IC3_RAW_INTR_STAT_activity(data)                                         (0x00000100&((data)<<8))
+#define MIS_IC3_RAW_INTR_STAT_activity_src(data)                                     ((0x00000100&(data))>>8)
+#define MIS_IC3_RAW_INTR_STAT_get_activity(data)                                     ((0x00000100&(data))>>8)
+#define MIS_IC3_RAW_INTR_STAT_rx_done_shift                                          (7)
+#define MIS_IC3_RAW_INTR_STAT_rx_done_mask                                           (0x00000080)
+#define MIS_IC3_RAW_INTR_STAT_rx_done(data)                                          (0x00000080&((data)<<7))
+#define MIS_IC3_RAW_INTR_STAT_rx_done_src(data)                                      ((0x00000080&(data))>>7)
+#define MIS_IC3_RAW_INTR_STAT_get_rx_done(data)                                      ((0x00000080&(data))>>7)
+#define MIS_IC3_RAW_INTR_STAT_tx_abrt_shift                                          (6)
+#define MIS_IC3_RAW_INTR_STAT_tx_abrt_mask                                           (0x00000040)
+#define MIS_IC3_RAW_INTR_STAT_tx_abrt(data)                                          (0x00000040&((data)<<6))
+#define MIS_IC3_RAW_INTR_STAT_tx_abrt_src(data)                                      ((0x00000040&(data))>>6)
+#define MIS_IC3_RAW_INTR_STAT_get_tx_abrt(data)                                      ((0x00000040&(data))>>6)
+#define MIS_IC3_RAW_INTR_STAT_rd_req_shift                                           (5)
+#define MIS_IC3_RAW_INTR_STAT_rd_req_mask                                            (0x00000020)
+#define MIS_IC3_RAW_INTR_STAT_rd_req(data)                                           (0x00000020&((data)<<5))
+#define MIS_IC3_RAW_INTR_STAT_rd_req_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC3_RAW_INTR_STAT_get_rd_req(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC3_RAW_INTR_STAT_tx_empty_shift                                         (4)
+#define MIS_IC3_RAW_INTR_STAT_tx_empty_mask                                          (0x00000010)
+#define MIS_IC3_RAW_INTR_STAT_tx_empty(data)                                         (0x00000010&((data)<<4))
+#define MIS_IC3_RAW_INTR_STAT_tx_empty_src(data)                                     ((0x00000010&(data))>>4)
+#define MIS_IC3_RAW_INTR_STAT_get_tx_empty(data)                                     ((0x00000010&(data))>>4)
+#define MIS_IC3_RAW_INTR_STAT_tx_over_shift                                          (3)
+#define MIS_IC3_RAW_INTR_STAT_tx_over_mask                                           (0x00000008)
+#define MIS_IC3_RAW_INTR_STAT_tx_over(data)                                          (0x00000008&((data)<<3))
+#define MIS_IC3_RAW_INTR_STAT_tx_over_src(data)                                      ((0x00000008&(data))>>3)
+#define MIS_IC3_RAW_INTR_STAT_get_tx_over(data)                                      ((0x00000008&(data))>>3)
+#define MIS_IC3_RAW_INTR_STAT_rx_full_shift                                          (2)
+#define MIS_IC3_RAW_INTR_STAT_rx_full_mask                                           (0x00000004)
+#define MIS_IC3_RAW_INTR_STAT_rx_full(data)                                          (0x00000004&((data)<<2))
+#define MIS_IC3_RAW_INTR_STAT_rx_full_src(data)                                      ((0x00000004&(data))>>2)
+#define MIS_IC3_RAW_INTR_STAT_get_rx_full(data)                                      ((0x00000004&(data))>>2)
+#define MIS_IC3_RAW_INTR_STAT_rx_over_shift                                          (1)
+#define MIS_IC3_RAW_INTR_STAT_rx_over_mask                                           (0x00000002)
+#define MIS_IC3_RAW_INTR_STAT_rx_over(data)                                          (0x00000002&((data)<<1))
+#define MIS_IC3_RAW_INTR_STAT_rx_over_src(data)                                      ((0x00000002&(data))>>1)
+#define MIS_IC3_RAW_INTR_STAT_get_rx_over(data)                                      ((0x00000002&(data))>>1)
+#define MIS_IC3_RAW_INTR_STAT_rx_under_shift                                         (0)
+#define MIS_IC3_RAW_INTR_STAT_rx_under_mask                                          (0x00000001)
+#define MIS_IC3_RAW_INTR_STAT_rx_under(data)                                         (0x00000001&((data)<<0))
+#define MIS_IC3_RAW_INTR_STAT_rx_under_src(data)                                     ((0x00000001&(data))>>0)
+#define MIS_IC3_RAW_INTR_STAT_get_rx_under(data)                                     ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_RX_TL                                                                0x1801B938
+#define MIS_IC3_RX_TL_reg_addr                                                       "0xB801B938"
+#define MIS_IC3_RX_TL_reg                                                            0xB801B938
+#define set_MIS_IC3_RX_TL_reg(data)   (*((volatile unsigned int*) MIS_IC3_RX_TL_reg)=data)
+#define get_MIS_IC3_RX_TL_reg   (*((volatile unsigned int*) MIS_IC3_RX_TL_reg))
+#define MIS_IC3_RX_TL_inst_adr                                                       "0x004E"
+#define MIS_IC3_RX_TL_inst                                                           0x004E
+#define MIS_IC3_RX_TL_rx_tl_shift                                                    (0)
+#define MIS_IC3_RX_TL_rx_tl_mask                                                     (0x000000FF)
+#define MIS_IC3_RX_TL_rx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define MIS_IC3_RX_TL_rx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define MIS_IC3_RX_TL_get_rx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC3_TX_TL                                                                0x1801B93C
+#define MIS_IC3_TX_TL_reg_addr                                                       "0xB801B93C"
+#define MIS_IC3_TX_TL_reg                                                            0xB801B93C
+#define set_MIS_IC3_TX_TL_reg(data)   (*((volatile unsigned int*) MIS_IC3_TX_TL_reg)=data)
+#define get_MIS_IC3_TX_TL_reg   (*((volatile unsigned int*) MIS_IC3_TX_TL_reg))
+#define MIS_IC3_TX_TL_inst_adr                                                       "0x004F"
+#define MIS_IC3_TX_TL_inst                                                           0x004F
+#define MIS_IC3_TX_TL_tx_tl_shift                                                    (0)
+#define MIS_IC3_TX_TL_tx_tl_mask                                                     (0x000000FF)
+#define MIS_IC3_TX_TL_tx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define MIS_IC3_TX_TL_tx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define MIS_IC3_TX_TL_get_tx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC3_CLR_INTR                                                             0x1801B940
+#define MIS_IC3_CLR_INTR_reg_addr                                                    "0xB801B940"
+#define MIS_IC3_CLR_INTR_reg                                                         0xB801B940
+#define set_MIS_IC3_CLR_INTR_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_INTR_reg)=data)
+#define get_MIS_IC3_CLR_INTR_reg   (*((volatile unsigned int*) MIS_IC3_CLR_INTR_reg))
+#define MIS_IC3_CLR_INTR_inst_adr                                                    "0x0050"
+#define MIS_IC3_CLR_INTR_inst                                                        0x0050
+#define MIS_IC3_CLR_INTR_clr_intr_shift                                              (0)
+#define MIS_IC3_CLR_INTR_clr_intr_mask                                               (0x00000001)
+#define MIS_IC3_CLR_INTR_clr_intr(data)                                              (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_INTR_clr_intr_src(data)                                          ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_INTR_get_clr_intr(data)                                          ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_CLR_RX_UNDER                                                         0x1801B944
+#define MIS_IC3_CLR_RX_UNDER_reg_addr                                                "0xB801B944"
+#define MIS_IC3_CLR_RX_UNDER_reg                                                     0xB801B944
+#define set_MIS_IC3_CLR_RX_UNDER_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_RX_UNDER_reg)=data)
+#define get_MIS_IC3_CLR_RX_UNDER_reg   (*((volatile unsigned int*) MIS_IC3_CLR_RX_UNDER_reg))
+#define MIS_IC3_CLR_RX_UNDER_inst_adr                                                "0x0051"
+#define MIS_IC3_CLR_RX_UNDER_inst                                                    0x0051
+#define MIS_IC3_CLR_RX_UNDER_clr_rx_under_shift                                      (0)
+#define MIS_IC3_CLR_RX_UNDER_clr_rx_under_mask                                       (0x00000001)
+#define MIS_IC3_CLR_RX_UNDER_clr_rx_under(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_RX_UNDER_clr_rx_under_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_RX_UNDER_get_clr_rx_under(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_CLR_RX_OVER                                                          0x1801B948
+#define MIS_IC3_CLR_RX_OVER_reg_addr                                                 "0xB801B948"
+#define MIS_IC3_CLR_RX_OVER_reg                                                      0xB801B948
+#define set_MIS_IC3_CLR_RX_OVER_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_RX_OVER_reg)=data)
+#define get_MIS_IC3_CLR_RX_OVER_reg   (*((volatile unsigned int*) MIS_IC3_CLR_RX_OVER_reg))
+#define MIS_IC3_CLR_RX_OVER_inst_adr                                                 "0x0052"
+#define MIS_IC3_CLR_RX_OVER_inst                                                     0x0052
+#define MIS_IC3_CLR_RX_OVER_clr_rx_over_shift                                        (0)
+#define MIS_IC3_CLR_RX_OVER_clr_rx_over_mask                                         (0x00000001)
+#define MIS_IC3_CLR_RX_OVER_clr_rx_over(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_RX_OVER_clr_rx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_RX_OVER_get_clr_rx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_CLR_TX_OVER                                                          0x1801B94C
+#define MIS_IC3_CLR_TX_OVER_reg_addr                                                 "0xB801B94C"
+#define MIS_IC3_CLR_TX_OVER_reg                                                      0xB801B94C
+#define set_MIS_IC3_CLR_TX_OVER_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_TX_OVER_reg)=data)
+#define get_MIS_IC3_CLR_TX_OVER_reg   (*((volatile unsigned int*) MIS_IC3_CLR_TX_OVER_reg))
+#define MIS_IC3_CLR_TX_OVER_inst_adr                                                 "0x0053"
+#define MIS_IC3_CLR_TX_OVER_inst                                                     0x0053
+#define MIS_IC3_CLR_TX_OVER_clr_tx_over_shift                                        (0)
+#define MIS_IC3_CLR_TX_OVER_clr_tx_over_mask                                         (0x00000001)
+#define MIS_IC3_CLR_TX_OVER_clr_tx_over(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_TX_OVER_clr_tx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_TX_OVER_get_clr_tx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_CLR_RD_REQ                                                           0x1801B950
+#define MIS_IC3_CLR_RD_REQ_reg_addr                                                  "0xB801B950"
+#define MIS_IC3_CLR_RD_REQ_reg                                                       0xB801B950
+#define set_MIS_IC3_CLR_RD_REQ_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_RD_REQ_reg)=data)
+#define get_MIS_IC3_CLR_RD_REQ_reg   (*((volatile unsigned int*) MIS_IC3_CLR_RD_REQ_reg))
+#define MIS_IC3_CLR_RD_REQ_inst_adr                                                  "0x0054"
+#define MIS_IC3_CLR_RD_REQ_inst                                                      0x0054
+#define MIS_IC3_CLR_RD_REQ_clr_rd_req_shift                                          (0)
+#define MIS_IC3_CLR_RD_REQ_clr_rd_req_mask                                           (0x00000001)
+#define MIS_IC3_CLR_RD_REQ_clr_rd_req(data)                                          (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_RD_REQ_clr_rd_req_src(data)                                      ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_RD_REQ_get_clr_rd_req(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_CLR_TX_ABRT                                                          0x1801B954
+#define MIS_IC3_CLR_TX_ABRT_reg_addr                                                 "0xB801B954"
+#define MIS_IC3_CLR_TX_ABRT_reg                                                      0xB801B954
+#define set_MIS_IC3_CLR_TX_ABRT_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_TX_ABRT_reg)=data)
+#define get_MIS_IC3_CLR_TX_ABRT_reg   (*((volatile unsigned int*) MIS_IC3_CLR_TX_ABRT_reg))
+#define MIS_IC3_CLR_TX_ABRT_inst_adr                                                 "0x0055"
+#define MIS_IC3_CLR_TX_ABRT_inst                                                     0x0055
+#define MIS_IC3_CLR_TX_ABRT_clr_tx_abrt_shift                                        (0)
+#define MIS_IC3_CLR_TX_ABRT_clr_tx_abrt_mask                                         (0x00000001)
+#define MIS_IC3_CLR_TX_ABRT_clr_tx_abrt(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_TX_ABRT_clr_tx_abrt_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_TX_ABRT_get_clr_tx_abrt(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_CLR_RX_DONE                                                          0x1801B958
+#define MIS_IC3_CLR_RX_DONE_reg_addr                                                 "0xB801B958"
+#define MIS_IC3_CLR_RX_DONE_reg                                                      0xB801B958
+#define set_MIS_IC3_CLR_RX_DONE_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_RX_DONE_reg)=data)
+#define get_MIS_IC3_CLR_RX_DONE_reg   (*((volatile unsigned int*) MIS_IC3_CLR_RX_DONE_reg))
+#define MIS_IC3_CLR_RX_DONE_inst_adr                                                 "0x0056"
+#define MIS_IC3_CLR_RX_DONE_inst                                                     0x0056
+#define MIS_IC3_CLR_RX_DONE_clr_rx_done_shift                                        (0)
+#define MIS_IC3_CLR_RX_DONE_clr_rx_done_mask                                         (0x00000001)
+#define MIS_IC3_CLR_RX_DONE_clr_rx_done(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_RX_DONE_clr_rx_done_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_RX_DONE_get_clr_rx_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_CLR_ACTIVITY                                                         0x1801B95C
+#define MIS_IC3_CLR_ACTIVITY_reg_addr                                                "0xB801B95C"
+#define MIS_IC3_CLR_ACTIVITY_reg                                                     0xB801B95C
+#define set_MIS_IC3_CLR_ACTIVITY_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_ACTIVITY_reg)=data)
+#define get_MIS_IC3_CLR_ACTIVITY_reg   (*((volatile unsigned int*) MIS_IC3_CLR_ACTIVITY_reg))
+#define MIS_IC3_CLR_ACTIVITY_inst_adr                                                "0x0057"
+#define MIS_IC3_CLR_ACTIVITY_inst                                                    0x0057
+#define MIS_IC3_CLR_ACTIVITY_clr_activity_shift                                      (0)
+#define MIS_IC3_CLR_ACTIVITY_clr_activity_mask                                       (0x00000001)
+#define MIS_IC3_CLR_ACTIVITY_clr_activity(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_ACTIVITY_clr_activity_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_ACTIVITY_get_clr_activity(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_CLR_STOP_DET                                                         0x1801B960
+#define MIS_IC3_CLR_STOP_DET_reg_addr                                                "0xB801B960"
+#define MIS_IC3_CLR_STOP_DET_reg                                                     0xB801B960
+#define set_MIS_IC3_CLR_STOP_DET_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_STOP_DET_reg)=data)
+#define get_MIS_IC3_CLR_STOP_DET_reg   (*((volatile unsigned int*) MIS_IC3_CLR_STOP_DET_reg))
+#define MIS_IC3_CLR_STOP_DET_inst_adr                                                "0x0058"
+#define MIS_IC3_CLR_STOP_DET_inst                                                    0x0058
+#define MIS_IC3_CLR_STOP_DET_clr_stop_det_shift                                      (0)
+#define MIS_IC3_CLR_STOP_DET_clr_stop_det_mask                                       (0x00000001)
+#define MIS_IC3_CLR_STOP_DET_clr_stop_det(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_STOP_DET_clr_stop_det_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_STOP_DET_get_clr_stop_det(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_CLR_START_DET                                                        0x1801B964
+#define MIS_IC3_CLR_START_DET_reg_addr                                               "0xB801B964"
+#define MIS_IC3_CLR_START_DET_reg                                                    0xB801B964
+#define set_MIS_IC3_CLR_START_DET_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_START_DET_reg)=data)
+#define get_MIS_IC3_CLR_START_DET_reg   (*((volatile unsigned int*) MIS_IC3_CLR_START_DET_reg))
+#define MIS_IC3_CLR_START_DET_inst_adr                                               "0x0059"
+#define MIS_IC3_CLR_START_DET_inst                                                   0x0059
+#define MIS_IC3_CLR_START_DET_clr_start_det_shift                                    (0)
+#define MIS_IC3_CLR_START_DET_clr_start_det_mask                                     (0x00000001)
+#define MIS_IC3_CLR_START_DET_clr_start_det(data)                                    (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_START_DET_clr_start_det_src(data)                                ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_START_DET_get_clr_start_det(data)                                ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_CLR_GEN_CALL                                                         0x1801B968
+#define MIS_IC3_CLR_GEN_CALL_reg_addr                                                "0xB801B968"
+#define MIS_IC3_CLR_GEN_CALL_reg                                                     0xB801B968
+#define set_MIS_IC3_CLR_GEN_CALL_reg(data)   (*((volatile unsigned int*) MIS_IC3_CLR_GEN_CALL_reg)=data)
+#define get_MIS_IC3_CLR_GEN_CALL_reg   (*((volatile unsigned int*) MIS_IC3_CLR_GEN_CALL_reg))
+#define MIS_IC3_CLR_GEN_CALL_inst_adr                                                "0x005A"
+#define MIS_IC3_CLR_GEN_CALL_inst                                                    0x005A
+#define MIS_IC3_CLR_GEN_CALL_clr_gen_call_shift                                      (0)
+#define MIS_IC3_CLR_GEN_CALL_clr_gen_call_mask                                       (0x00000001)
+#define MIS_IC3_CLR_GEN_CALL_clr_gen_call(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC3_CLR_GEN_CALL_clr_gen_call_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC3_CLR_GEN_CALL_get_clr_gen_call(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_ENABLE                                                               0x1801B96C
+#define MIS_IC3_ENABLE_reg_addr                                                      "0xB801B96C"
+#define MIS_IC3_ENABLE_reg                                                           0xB801B96C
+#define set_MIS_IC3_ENABLE_reg(data)   (*((volatile unsigned int*) MIS_IC3_ENABLE_reg)=data)
+#define get_MIS_IC3_ENABLE_reg   (*((volatile unsigned int*) MIS_IC3_ENABLE_reg))
+#define MIS_IC3_ENABLE_inst_adr                                                      "0x005B"
+#define MIS_IC3_ENABLE_inst                                                          0x005B
+#define MIS_IC3_ENABLE_enable_shift                                                  (0)
+#define MIS_IC3_ENABLE_enable_mask                                                   (0x00000001)
+#define MIS_IC3_ENABLE_enable(data)                                                  (0x00000001&((data)<<0))
+#define MIS_IC3_ENABLE_enable_src(data)                                              ((0x00000001&(data))>>0)
+#define MIS_IC3_ENABLE_get_enable(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_STATUS                                                               0x1801B970
+#define MIS_IC3_STATUS_reg_addr                                                      "0xB801B970"
+#define MIS_IC3_STATUS_reg                                                           0xB801B970
+#define set_MIS_IC3_STATUS_reg(data)   (*((volatile unsigned int*) MIS_IC3_STATUS_reg)=data)
+#define get_MIS_IC3_STATUS_reg   (*((volatile unsigned int*) MIS_IC3_STATUS_reg))
+#define MIS_IC3_STATUS_inst_adr                                                      "0x005C"
+#define MIS_IC3_STATUS_inst                                                          0x005C
+#define MIS_IC3_STATUS_slv_activity_shift                                            (6)
+#define MIS_IC3_STATUS_slv_activity_mask                                             (0x00000040)
+#define MIS_IC3_STATUS_slv_activity(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC3_STATUS_slv_activity_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC3_STATUS_get_slv_activity(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC3_STATUS_mst_activity_shift                                            (5)
+#define MIS_IC3_STATUS_mst_activity_mask                                             (0x00000020)
+#define MIS_IC3_STATUS_mst_activity(data)                                            (0x00000020&((data)<<5))
+#define MIS_IC3_STATUS_mst_activity_src(data)                                        ((0x00000020&(data))>>5)
+#define MIS_IC3_STATUS_get_mst_activity(data)                                        ((0x00000020&(data))>>5)
+#define MIS_IC3_STATUS_rff_shift                                                     (4)
+#define MIS_IC3_STATUS_rff_mask                                                      (0x00000010)
+#define MIS_IC3_STATUS_rff(data)                                                     (0x00000010&((data)<<4))
+#define MIS_IC3_STATUS_rff_src(data)                                                 ((0x00000010&(data))>>4)
+#define MIS_IC3_STATUS_get_rff(data)                                                 ((0x00000010&(data))>>4)
+#define MIS_IC3_STATUS_rfne_shift                                                    (3)
+#define MIS_IC3_STATUS_rfne_mask                                                     (0x00000008)
+#define MIS_IC3_STATUS_rfne(data)                                                    (0x00000008&((data)<<3))
+#define MIS_IC3_STATUS_rfne_src(data)                                                ((0x00000008&(data))>>3)
+#define MIS_IC3_STATUS_get_rfne(data)                                                ((0x00000008&(data))>>3)
+#define MIS_IC3_STATUS_tfe_shift                                                     (2)
+#define MIS_IC3_STATUS_tfe_mask                                                      (0x00000004)
+#define MIS_IC3_STATUS_tfe(data)                                                     (0x00000004&((data)<<2))
+#define MIS_IC3_STATUS_tfe_src(data)                                                 ((0x00000004&(data))>>2)
+#define MIS_IC3_STATUS_get_tfe(data)                                                 ((0x00000004&(data))>>2)
+#define MIS_IC3_STATUS_tfnf_shift                                                    (1)
+#define MIS_IC3_STATUS_tfnf_mask                                                     (0x00000002)
+#define MIS_IC3_STATUS_tfnf(data)                                                    (0x00000002&((data)<<1))
+#define MIS_IC3_STATUS_tfnf_src(data)                                                ((0x00000002&(data))>>1)
+#define MIS_IC3_STATUS_get_tfnf(data)                                                ((0x00000002&(data))>>1)
+#define MIS_IC3_STATUS_activity_shift                                                (0)
+#define MIS_IC3_STATUS_activity_mask                                                 (0x00000001)
+#define MIS_IC3_STATUS_activity(data)                                                (0x00000001&((data)<<0))
+#define MIS_IC3_STATUS_activity_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_IC3_STATUS_get_activity(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_TXFLR                                                                0x1801B974
+#define MIS_IC3_TXFLR_reg_addr                                                       "0xB801B974"
+#define MIS_IC3_TXFLR_reg                                                            0xB801B974
+#define set_MIS_IC3_TXFLR_reg(data)   (*((volatile unsigned int*) MIS_IC3_TXFLR_reg)=data)
+#define get_MIS_IC3_TXFLR_reg   (*((volatile unsigned int*) MIS_IC3_TXFLR_reg))
+#define MIS_IC3_TXFLR_inst_adr                                                       "0x005D"
+#define MIS_IC3_TXFLR_inst                                                           0x005D
+#define MIS_IC3_TXFLR_txflr_shift                                                    (0)
+#define MIS_IC3_TXFLR_txflr_mask                                                     (0x0000000F)
+#define MIS_IC3_TXFLR_txflr(data)                                                    (0x0000000F&((data)<<0))
+#define MIS_IC3_TXFLR_txflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define MIS_IC3_TXFLR_get_txflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC3_RXFLR                                                                0x1801B978
+#define MIS_IC3_RXFLR_reg_addr                                                       "0xB801B978"
+#define MIS_IC3_RXFLR_reg                                                            0xB801B978
+#define set_MIS_IC3_RXFLR_reg(data)   (*((volatile unsigned int*) MIS_IC3_RXFLR_reg)=data)
+#define get_MIS_IC3_RXFLR_reg   (*((volatile unsigned int*) MIS_IC3_RXFLR_reg))
+#define MIS_IC3_RXFLR_inst_adr                                                       "0x005E"
+#define MIS_IC3_RXFLR_inst                                                           0x005E
+#define MIS_IC3_RXFLR_rxflr_shift                                                    (0)
+#define MIS_IC3_RXFLR_rxflr_mask                                                     (0x0000000F)
+#define MIS_IC3_RXFLR_rxflr(data)                                                    (0x0000000F&((data)<<0))
+#define MIS_IC3_RXFLR_rxflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define MIS_IC3_RXFLR_get_rxflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC3_SDA_HOLD                                                             0x1801B97C
+#define MIS_IC3_SDA_HOLD_reg_addr                                                    "0xB801B97C"
+#define MIS_IC3_SDA_HOLD_reg                                                         0xB801B97C
+#define set_MIS_IC3_SDA_HOLD_reg(data)   (*((volatile unsigned int*) MIS_IC3_SDA_HOLD_reg)=data)
+#define get_MIS_IC3_SDA_HOLD_reg   (*((volatile unsigned int*) MIS_IC3_SDA_HOLD_reg))
+#define MIS_IC3_SDA_HOLD_inst_adr                                                    "0x005F"
+#define MIS_IC3_SDA_HOLD_inst                                                        0x005F
+#define MIS_IC3_SDA_HOLD_sda_hold_shift                                              (0)
+#define MIS_IC3_SDA_HOLD_sda_hold_mask                                               (0x0000FFFF)
+#define MIS_IC3_SDA_HOLD_sda_hold(data)                                              (0x0000FFFF&((data)<<0))
+#define MIS_IC3_SDA_HOLD_sda_hold_src(data)                                          ((0x0000FFFF&(data))>>0)
+#define MIS_IC3_SDA_HOLD_get_sda_hold(data)                                          ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC3_TX_ABRT_SOURCE                                                       0x1801B980
+#define MIS_IC3_TX_ABRT_SOURCE_reg_addr                                              "0xB801B980"
+#define MIS_IC3_TX_ABRT_SOURCE_reg                                                   0xB801B980
+#define set_MIS_IC3_TX_ABRT_SOURCE_reg(data)   (*((volatile unsigned int*) MIS_IC3_TX_ABRT_SOURCE_reg)=data)
+#define get_MIS_IC3_TX_ABRT_SOURCE_reg   (*((volatile unsigned int*) MIS_IC3_TX_ABRT_SOURCE_reg))
+#define MIS_IC3_TX_ABRT_SOURCE_inst_adr                                              "0x0060"
+#define MIS_IC3_TX_ABRT_SOURCE_inst                                                  0x0060
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slvrd_intx_shift                                 (15)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slvrd_intx_mask                                  (0x00008000)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slvrd_intx(data)                                 (0x00008000&((data)<<15))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slvrd_intx_src(data)                             ((0x00008000&(data))>>15)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_slvrd_intx(data)                             ((0x00008000&(data))>>15)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slv_arblost_shift                                (14)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slv_arblost_mask                                 (0x00004000)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slv_arblost(data)                                (0x00004000&((data)<<14))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slv_arblost_src(data)                            ((0x00004000&(data))>>14)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_slv_arblost(data)                            ((0x00004000&(data))>>14)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slvflush_txfifo_shift                            (13)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slvflush_txfifo_mask                             (0x00002000)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slvflush_txfifo(data)                            (0x00002000&((data)<<13))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_slvflush_txfifo_src(data)                        ((0x00002000&(data))>>13)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_slvflush_txfifo(data)                        ((0x00002000&(data))>>13)
+#define MIS_IC3_TX_ABRT_SOURCE_arb_lost_shift                                        (12)
+#define MIS_IC3_TX_ABRT_SOURCE_arb_lost_mask                                         (0x00001000)
+#define MIS_IC3_TX_ABRT_SOURCE_arb_lost(data)                                        (0x00001000&((data)<<12))
+#define MIS_IC3_TX_ABRT_SOURCE_arb_lost_src(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC3_TX_ABRT_SOURCE_get_arb_lost(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC3_TX_ABRT_SOURCE_arb_master_dis_shift                                  (11)
+#define MIS_IC3_TX_ABRT_SOURCE_arb_master_dis_mask                                   (0x00000800)
+#define MIS_IC3_TX_ABRT_SOURCE_arb_master_dis(data)                                  (0x00000800&((data)<<11))
+#define MIS_IC3_TX_ABRT_SOURCE_arb_master_dis_src(data)                              ((0x00000800&(data))>>11)
+#define MIS_IC3_TX_ABRT_SOURCE_get_arb_master_dis(data)                              ((0x00000800&(data))>>11)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_shift                             (10)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_mask                              (0x00000400)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10b_rd_norstrt(data)                             (0x00000400&((data)<<10))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_src(data)                         ((0x00000400&(data))>>10)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_10b_rd_norstrt(data)                         ((0x00000400&(data))>>10)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_sbyte_norstrt_shift                              (9)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_sbyte_norstrt_mask                               (0x00000200)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_sbyte_norstrt(data)                              (0x00000200&((data)<<9))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_sbyte_norstrt_src(data)                          ((0x00000200&(data))>>9)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_sbyte_norstrt(data)                          ((0x00000200&(data))>>9)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_hs_norstrt_shift                                 (8)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_hs_norstrt_mask                                  (0x00000100)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_hs_norstrt(data)                                 (0x00000100&((data)<<8))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_hs_norstrt_src(data)                             ((0x00000100&(data))>>8)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_hs_norstrt(data)                             ((0x00000100&(data))>>8)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_sbyte_ackdet_shift                               (7)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_sbyte_ackdet_mask                                (0x00000080)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_sbyte_ackdet(data)                               (0x00000080&((data)<<7))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_sbyte_ackdet_src(data)                           ((0x00000080&(data))>>7)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_sbyte_ackdet(data)                           ((0x00000080&(data))>>7)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_hs_ackdet_shift                                  (6)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_hs_ackdet_mask                                   (0x00000040)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_hs_ackdet(data)                                  (0x00000040&((data)<<6))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_hs_ackdet_src(data)                              ((0x00000040&(data))>>6)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_hs_ackdet(data)                              ((0x00000040&(data))>>6)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_gcall_read_shift                                 (5)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_gcall_read_mask                                  (0x00000020)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_gcall_read(data)                                 (0x00000020&((data)<<5))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_gcall_read_src(data)                             ((0x00000020&(data))>>5)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_gcall_read(data)                             ((0x00000020&(data))>>5)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_gcall_noack_shift                                (4)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_gcall_noack_mask                                 (0x00000010)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_gcall_noack(data)                                (0x00000010&((data)<<4))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_gcall_noack_src(data)                            ((0x00000010&(data))>>4)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_gcall_noack(data)                            ((0x00000010&(data))>>4)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_txdata_noack_shift                               (3)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_txdata_noack_mask                                (0x00000008)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_txdata_noack(data)                               (0x00000008&((data)<<3))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_txdata_noack_src(data)                           ((0x00000008&(data))>>3)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_txdata_noack(data)                           ((0x00000008&(data))>>3)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10addr2_noack_shift                              (2)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10addr2_noack_mask                               (0x00000004)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10addr2_noack(data)                              (0x00000004&((data)<<2))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10addr2_noack_src(data)                          ((0x00000004&(data))>>2)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_10addr2_noack(data)                          ((0x00000004&(data))>>2)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10addr1_noack_shift                              (1)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10addr1_noack_mask                               (0x00000002)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10addr1_noack(data)                              (0x00000002&((data)<<1))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_10addr1_noack_src(data)                          ((0x00000002&(data))>>1)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_10addr1_noack(data)                          ((0x00000002&(data))>>1)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_7b_addr_noack_shift                              (0)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_7b_addr_noack_mask                               (0x00000001)
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_7b_addr_noack(data)                              (0x00000001&((data)<<0))
+#define MIS_IC3_TX_ABRT_SOURCE_abrt_7b_addr_noack_src(data)                          ((0x00000001&(data))>>0)
+#define MIS_IC3_TX_ABRT_SOURCE_get_abrt_7b_addr_noack(data)                          ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_SLV_DATA_NACK_ONLY                                                   0x1801B984
+#define MIS_IC3_SLV_DATA_NACK_ONLY_reg_addr                                          "0xB801B984"
+#define MIS_IC3_SLV_DATA_NACK_ONLY_reg                                               0xB801B984
+#define set_MIS_IC3_SLV_DATA_NACK_ONLY_reg(data)   (*((volatile unsigned int*) MIS_IC3_SLV_DATA_NACK_ONLY_reg)=data)
+#define get_MIS_IC3_SLV_DATA_NACK_ONLY_reg   (*((volatile unsigned int*) MIS_IC3_SLV_DATA_NACK_ONLY_reg))
+#define MIS_IC3_SLV_DATA_NACK_ONLY_inst_adr                                          "0x0061"
+#define MIS_IC3_SLV_DATA_NACK_ONLY_inst                                              0x0061
+#define MIS_IC3_SLV_DATA_NACK_ONLY_nack_shift                                        (0)
+#define MIS_IC3_SLV_DATA_NACK_ONLY_nack_mask                                         (0x00000001)
+#define MIS_IC3_SLV_DATA_NACK_ONLY_nack(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC3_SLV_DATA_NACK_ONLY_nack_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC3_SLV_DATA_NACK_ONLY_get_nack(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_DMA_CR                                                               0x1801B988
+#define MIS_IC3_DMA_CR_reg_addr                                                      "0xB801B988"
+#define MIS_IC3_DMA_CR_reg                                                           0xB801B988
+#define set_MIS_IC3_DMA_CR_reg(data)   (*((volatile unsigned int*) MIS_IC3_DMA_CR_reg)=data)
+#define get_MIS_IC3_DMA_CR_reg   (*((volatile unsigned int*) MIS_IC3_DMA_CR_reg))
+#define MIS_IC3_DMA_CR_inst_adr                                                      "0x0062"
+#define MIS_IC3_DMA_CR_inst                                                          0x0062
+#define MIS_IC3_DMA_CR_tdmae_shift                                                   (1)
+#define MIS_IC3_DMA_CR_tdmae_mask                                                    (0x00000002)
+#define MIS_IC3_DMA_CR_tdmae(data)                                                   (0x00000002&((data)<<1))
+#define MIS_IC3_DMA_CR_tdmae_src(data)                                               ((0x00000002&(data))>>1)
+#define MIS_IC3_DMA_CR_get_tdmae(data)                                               ((0x00000002&(data))>>1)
+#define MIS_IC3_DMA_CR_rdmae_shift                                                   (0)
+#define MIS_IC3_DMA_CR_rdmae_mask                                                    (0x00000001)
+#define MIS_IC3_DMA_CR_rdmae(data)                                                   (0x00000001&((data)<<0))
+#define MIS_IC3_DMA_CR_rdmae_src(data)                                               ((0x00000001&(data))>>0)
+#define MIS_IC3_DMA_CR_get_rdmae(data)                                               ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_DMA_TDLR                                                             0x1801B98C
+#define MIS_IC3_DMA_TDLR_reg_addr                                                    "0xB801B98C"
+#define MIS_IC3_DMA_TDLR_reg                                                         0xB801B98C
+#define set_MIS_IC3_DMA_TDLR_reg(data)   (*((volatile unsigned int*) MIS_IC3_DMA_TDLR_reg)=data)
+#define get_MIS_IC3_DMA_TDLR_reg   (*((volatile unsigned int*) MIS_IC3_DMA_TDLR_reg))
+#define MIS_IC3_DMA_TDLR_inst_adr                                                    "0x0063"
+#define MIS_IC3_DMA_TDLR_inst                                                        0x0063
+#define MIS_IC3_DMA_TDLR_dmatdl_shift                                                (0)
+#define MIS_IC3_DMA_TDLR_dmatdl_mask                                                 (0x00000007)
+#define MIS_IC3_DMA_TDLR_dmatdl(data)                                                (0x00000007&((data)<<0))
+#define MIS_IC3_DMA_TDLR_dmatdl_src(data)                                            ((0x00000007&(data))>>0)
+#define MIS_IC3_DMA_TDLR_get_dmatdl(data)                                            ((0x00000007&(data))>>0)
+
+
+#define MIS_IC3_DMA_RDLR                                                             0x1801B990
+#define MIS_IC3_DMA_RDLR_reg_addr                                                    "0xB801B990"
+#define MIS_IC3_DMA_RDLR_reg                                                         0xB801B990
+#define set_MIS_IC3_DMA_RDLR_reg(data)   (*((volatile unsigned int*) MIS_IC3_DMA_RDLR_reg)=data)
+#define get_MIS_IC3_DMA_RDLR_reg   (*((volatile unsigned int*) MIS_IC3_DMA_RDLR_reg))
+#define MIS_IC3_DMA_RDLR_inst_adr                                                    "0x0064"
+#define MIS_IC3_DMA_RDLR_inst                                                        0x0064
+#define MIS_IC3_DMA_RDLR_dmardl_shift                                                (0)
+#define MIS_IC3_DMA_RDLR_dmardl_mask                                                 (0x0000000F)
+#define MIS_IC3_DMA_RDLR_dmardl(data)                                                (0x0000000F&((data)<<0))
+#define MIS_IC3_DMA_RDLR_dmardl_src(data)                                            ((0x0000000F&(data))>>0)
+#define MIS_IC3_DMA_RDLR_get_dmardl(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC3_SDA_SETUP                                                            0x1801B994
+#define MIS_IC3_SDA_SETUP_reg_addr                                                   "0xB801B994"
+#define MIS_IC3_SDA_SETUP_reg                                                        0xB801B994
+#define set_MIS_IC3_SDA_SETUP_reg(data)   (*((volatile unsigned int*) MIS_IC3_SDA_SETUP_reg)=data)
+#define get_MIS_IC3_SDA_SETUP_reg   (*((volatile unsigned int*) MIS_IC3_SDA_SETUP_reg))
+#define MIS_IC3_SDA_SETUP_inst_adr                                                   "0x0065"
+#define MIS_IC3_SDA_SETUP_inst                                                       0x0065
+#define MIS_IC3_SDA_SETUP_sda_setup_shift                                            (0)
+#define MIS_IC3_SDA_SETUP_sda_setup_mask                                             (0x000000FF)
+#define MIS_IC3_SDA_SETUP_sda_setup(data)                                            (0x000000FF&((data)<<0))
+#define MIS_IC3_SDA_SETUP_sda_setup_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIS_IC3_SDA_SETUP_get_sda_setup(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC3_ACK_GENERAL_CALL                                                     0x1801B998
+#define MIS_IC3_ACK_GENERAL_CALL_reg_addr                                            "0xB801B998"
+#define MIS_IC3_ACK_GENERAL_CALL_reg                                                 0xB801B998
+#define set_MIS_IC3_ACK_GENERAL_CALL_reg(data)   (*((volatile unsigned int*) MIS_IC3_ACK_GENERAL_CALL_reg)=data)
+#define get_MIS_IC3_ACK_GENERAL_CALL_reg   (*((volatile unsigned int*) MIS_IC3_ACK_GENERAL_CALL_reg))
+#define MIS_IC3_ACK_GENERAL_CALL_inst_adr                                            "0x0066"
+#define MIS_IC3_ACK_GENERAL_CALL_inst                                                0x0066
+#define MIS_IC3_ACK_GENERAL_CALL_ack_gen_call_shift                                  (0)
+#define MIS_IC3_ACK_GENERAL_CALL_ack_gen_call_mask                                   (0x00000001)
+#define MIS_IC3_ACK_GENERAL_CALL_ack_gen_call(data)                                  (0x00000001&((data)<<0))
+#define MIS_IC3_ACK_GENERAL_CALL_ack_gen_call_src(data)                              ((0x00000001&(data))>>0)
+#define MIS_IC3_ACK_GENERAL_CALL_get_ack_gen_call(data)                              ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_ENABLE_STATUS                                                        0x1801B99C
+#define MIS_IC3_ENABLE_STATUS_reg_addr                                               "0xB801B99C"
+#define MIS_IC3_ENABLE_STATUS_reg                                                    0xB801B99C
+#define set_MIS_IC3_ENABLE_STATUS_reg(data)   (*((volatile unsigned int*) MIS_IC3_ENABLE_STATUS_reg)=data)
+#define get_MIS_IC3_ENABLE_STATUS_reg   (*((volatile unsigned int*) MIS_IC3_ENABLE_STATUS_reg))
+#define MIS_IC3_ENABLE_STATUS_inst_adr                                               "0x0067"
+#define MIS_IC3_ENABLE_STATUS_inst                                                   0x0067
+#define MIS_IC3_ENABLE_STATUS_slv_rx_data_lost_shift                                 (2)
+#define MIS_IC3_ENABLE_STATUS_slv_rx_data_lost_mask                                  (0x00000004)
+#define MIS_IC3_ENABLE_STATUS_slv_rx_data_lost(data)                                 (0x00000004&((data)<<2))
+#define MIS_IC3_ENABLE_STATUS_slv_rx_data_lost_src(data)                             ((0x00000004&(data))>>2)
+#define MIS_IC3_ENABLE_STATUS_get_slv_rx_data_lost(data)                             ((0x00000004&(data))>>2)
+#define MIS_IC3_ENABLE_STATUS_slv_disabled_whi_shift                                 (1)
+#define MIS_IC3_ENABLE_STATUS_slv_disabled_whi_mask                                  (0x00000002)
+#define MIS_IC3_ENABLE_STATUS_slv_disabled_whi(data)                                 (0x00000002&((data)<<1))
+#define MIS_IC3_ENABLE_STATUS_slv_disabled_whi_src(data)                             ((0x00000002&(data))>>1)
+#define MIS_IC3_ENABLE_STATUS_get_slv_disabled_whi(data)                             ((0x00000002&(data))>>1)
+#define MIS_IC3_ENABLE_STATUS_ic_en_shift                                            (0)
+#define MIS_IC3_ENABLE_STATUS_ic_en_mask                                             (0x00000001)
+#define MIS_IC3_ENABLE_STATUS_ic_en(data)                                            (0x00000001&((data)<<0))
+#define MIS_IC3_ENABLE_STATUS_ic_en_src(data)                                        ((0x00000001&(data))>>0)
+#define MIS_IC3_ENABLE_STATUS_get_ic_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define MIS_IC3_COMP_PARAM_1                                                         0x1801B9F4
+#define MIS_IC3_COMP_PARAM_1_reg_addr                                                "0xB801B9F4"
+#define MIS_IC3_COMP_PARAM_1_reg                                                     0xB801B9F4
+#define set_MIS_IC3_COMP_PARAM_1_reg(data)   (*((volatile unsigned int*) MIS_IC3_COMP_PARAM_1_reg)=data)
+#define get_MIS_IC3_COMP_PARAM_1_reg   (*((volatile unsigned int*) MIS_IC3_COMP_PARAM_1_reg))
+#define MIS_IC3_COMP_PARAM_1_inst_adr                                                "0x007D"
+#define MIS_IC3_COMP_PARAM_1_inst                                                    0x007D
+#define MIS_IC3_COMP_PARAM_1_tx_buffer_depth_shift                                   (16)
+#define MIS_IC3_COMP_PARAM_1_tx_buffer_depth_mask                                    (0x00FF0000)
+#define MIS_IC3_COMP_PARAM_1_tx_buffer_depth(data)                                   (0x00FF0000&((data)<<16))
+#define MIS_IC3_COMP_PARAM_1_tx_buffer_depth_src(data)                               ((0x00FF0000&(data))>>16)
+#define MIS_IC3_COMP_PARAM_1_get_tx_buffer_depth(data)                               ((0x00FF0000&(data))>>16)
+#define MIS_IC3_COMP_PARAM_1_rx_buffer_depth_shift                                   (8)
+#define MIS_IC3_COMP_PARAM_1_rx_buffer_depth_mask                                    (0x0000FF00)
+#define MIS_IC3_COMP_PARAM_1_rx_buffer_depth(data)                                   (0x0000FF00&((data)<<8))
+#define MIS_IC3_COMP_PARAM_1_rx_buffer_depth_src(data)                               ((0x0000FF00&(data))>>8)
+#define MIS_IC3_COMP_PARAM_1_get_rx_buffer_depth(data)                               ((0x0000FF00&(data))>>8)
+#define MIS_IC3_COMP_PARAM_1_add_encoded_params_shift                                (7)
+#define MIS_IC3_COMP_PARAM_1_add_encoded_params_mask                                 (0x00000080)
+#define MIS_IC3_COMP_PARAM_1_add_encoded_params(data)                                (0x00000080&((data)<<7))
+#define MIS_IC3_COMP_PARAM_1_add_encoded_params_src(data)                            ((0x00000080&(data))>>7)
+#define MIS_IC3_COMP_PARAM_1_get_add_encoded_params(data)                            ((0x00000080&(data))>>7)
+#define MIS_IC3_COMP_PARAM_1_has_dma_shift                                           (6)
+#define MIS_IC3_COMP_PARAM_1_has_dma_mask                                            (0x00000040)
+#define MIS_IC3_COMP_PARAM_1_has_dma(data)                                           (0x00000040&((data)<<6))
+#define MIS_IC3_COMP_PARAM_1_has_dma_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC3_COMP_PARAM_1_get_has_dma(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC3_COMP_PARAM_1_intr_io_shift                                           (5)
+#define MIS_IC3_COMP_PARAM_1_intr_io_mask                                            (0x00000020)
+#define MIS_IC3_COMP_PARAM_1_intr_io(data)                                           (0x00000020&((data)<<5))
+#define MIS_IC3_COMP_PARAM_1_intr_io_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC3_COMP_PARAM_1_get_intr_io(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC3_COMP_PARAM_1_hc_count_values_shift                                   (4)
+#define MIS_IC3_COMP_PARAM_1_hc_count_values_mask                                    (0x00000010)
+#define MIS_IC3_COMP_PARAM_1_hc_count_values(data)                                   (0x00000010&((data)<<4))
+#define MIS_IC3_COMP_PARAM_1_hc_count_values_src(data)                               ((0x00000010&(data))>>4)
+#define MIS_IC3_COMP_PARAM_1_get_hc_count_values(data)                               ((0x00000010&(data))>>4)
+#define MIS_IC3_COMP_PARAM_1_max_speed_mode_shift                                    (2)
+#define MIS_IC3_COMP_PARAM_1_max_speed_mode_mask                                     (0x0000000C)
+#define MIS_IC3_COMP_PARAM_1_max_speed_mode(data)                                    (0x0000000C&((data)<<2))
+#define MIS_IC3_COMP_PARAM_1_max_speed_mode_src(data)                                ((0x0000000C&(data))>>2)
+#define MIS_IC3_COMP_PARAM_1_get_max_speed_mode(data)                                ((0x0000000C&(data))>>2)
+#define MIS_IC3_COMP_PARAM_1_apb_data_width_shift                                    (0)
+#define MIS_IC3_COMP_PARAM_1_apb_data_width_mask                                     (0x00000003)
+#define MIS_IC3_COMP_PARAM_1_apb_data_width(data)                                    (0x00000003&((data)<<0))
+#define MIS_IC3_COMP_PARAM_1_apb_data_width_src(data)                                ((0x00000003&(data))>>0)
+#define MIS_IC3_COMP_PARAM_1_get_apb_data_width(data)                                ((0x00000003&(data))>>0)
+
+
+#define MIS_IC3_COMP_VERSION                                                         0x1801B9F8
+#define MIS_IC3_COMP_VERSION_reg_addr                                                "0xB801B9F8"
+#define MIS_IC3_COMP_VERSION_reg                                                     0xB801B9F8
+#define set_MIS_IC3_COMP_VERSION_reg(data)   (*((volatile unsigned int*) MIS_IC3_COMP_VERSION_reg)=data)
+#define get_MIS_IC3_COMP_VERSION_reg   (*((volatile unsigned int*) MIS_IC3_COMP_VERSION_reg))
+#define MIS_IC3_COMP_VERSION_inst_adr                                                "0x007E"
+#define MIS_IC3_COMP_VERSION_inst                                                    0x007E
+#define MIS_IC3_COMP_VERSION_ic_comp_version_shift                                   (0)
+#define MIS_IC3_COMP_VERSION_ic_comp_version_mask                                    (0xFFFFFFFF)
+#define MIS_IC3_COMP_VERSION_ic_comp_version(data)                                   (0xFFFFFFFF&((data)<<0))
+#define MIS_IC3_COMP_VERSION_ic_comp_version_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define MIS_IC3_COMP_VERSION_get_ic_comp_version(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_IC3_COMP_TYPE                                                            0x1801B9FC
+#define MIS_IC3_COMP_TYPE_reg_addr                                                   "0xB801B9FC"
+#define MIS_IC3_COMP_TYPE_reg                                                        0xB801B9FC
+#define set_MIS_IC3_COMP_TYPE_reg(data)   (*((volatile unsigned int*) MIS_IC3_COMP_TYPE_reg)=data)
+#define get_MIS_IC3_COMP_TYPE_reg   (*((volatile unsigned int*) MIS_IC3_COMP_TYPE_reg))
+#define MIS_IC3_COMP_TYPE_inst_adr                                                   "0x007F"
+#define MIS_IC3_COMP_TYPE_inst                                                       0x007F
+#define MIS_IC3_COMP_TYPE_ic_comp_type_shift                                         (0)
+#define MIS_IC3_COMP_TYPE_ic_comp_type_mask                                          (0xFFFFFFFF)
+#define MIS_IC3_COMP_TYPE_ic_comp_type(data)                                         (0xFFFFFFFF&((data)<<0))
+#define MIS_IC3_COMP_TYPE_ic_comp_type_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define MIS_IC3_COMP_TYPE_get_ic_comp_type(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_IC4_CON                                                                  0x1801BA00
+#define MIS_IC4_CON_reg_addr                                                         "0xB801BA00"
+#define MIS_IC4_CON_reg                                                              0xB801BA00
+#define set_MIS_IC4_CON_reg(data)   (*((volatile unsigned int*) MIS_IC4_CON_reg)=data)
+#define get_MIS_IC4_CON_reg   (*((volatile unsigned int*) MIS_IC4_CON_reg))
+#define MIS_IC4_CON_inst_adr                                                         "0x0080"
+#define MIS_IC4_CON_inst                                                             0x0080
+#define MIS_IC4_CON_ic_slave_disable_shift                                           (6)
+#define MIS_IC4_CON_ic_slave_disable_mask                                            (0x00000040)
+#define MIS_IC4_CON_ic_slave_disable(data)                                           (0x00000040&((data)<<6))
+#define MIS_IC4_CON_ic_slave_disable_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC4_CON_get_ic_slave_disable(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC4_CON_ic_restart_en_shift                                              (5)
+#define MIS_IC4_CON_ic_restart_en_mask                                               (0x00000020)
+#define MIS_IC4_CON_ic_restart_en(data)                                              (0x00000020&((data)<<5))
+#define MIS_IC4_CON_ic_restart_en_src(data)                                          ((0x00000020&(data))>>5)
+#define MIS_IC4_CON_get_ic_restart_en(data)                                          ((0x00000020&(data))>>5)
+#define MIS_IC4_CON_ic_10bitaddr_master_shift                                        (4)
+#define MIS_IC4_CON_ic_10bitaddr_master_mask                                         (0x00000010)
+#define MIS_IC4_CON_ic_10bitaddr_master(data)                                        (0x00000010&((data)<<4))
+#define MIS_IC4_CON_ic_10bitaddr_master_src(data)                                    ((0x00000010&(data))>>4)
+#define MIS_IC4_CON_get_ic_10bitaddr_master(data)                                    ((0x00000010&(data))>>4)
+#define MIS_IC4_CON_ic_10bitaddr_slave_shift                                         (3)
+#define MIS_IC4_CON_ic_10bitaddr_slave_mask                                          (0x00000008)
+#define MIS_IC4_CON_ic_10bitaddr_slave(data)                                         (0x00000008&((data)<<3))
+#define MIS_IC4_CON_ic_10bitaddr_slave_src(data)                                     ((0x00000008&(data))>>3)
+#define MIS_IC4_CON_get_ic_10bitaddr_slave(data)                                     ((0x00000008&(data))>>3)
+#define MIS_IC4_CON_speed_shift                                                      (1)
+#define MIS_IC4_CON_speed_mask                                                       (0x00000006)
+#define MIS_IC4_CON_speed(data)                                                      (0x00000006&((data)<<1))
+#define MIS_IC4_CON_speed_src(data)                                                  ((0x00000006&(data))>>1)
+#define MIS_IC4_CON_get_speed(data)                                                  ((0x00000006&(data))>>1)
+#define MIS_IC4_CON_master_mode_shift                                                (0)
+#define MIS_IC4_CON_master_mode_mask                                                 (0x00000001)
+#define MIS_IC4_CON_master_mode(data)                                                (0x00000001&((data)<<0))
+#define MIS_IC4_CON_master_mode_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_IC4_CON_get_master_mode(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_TAR                                                                  0x1801BA04
+#define MIS_IC4_TAR_reg_addr                                                         "0xB801BA04"
+#define MIS_IC4_TAR_reg                                                              0xB801BA04
+#define set_MIS_IC4_TAR_reg(data)   (*((volatile unsigned int*) MIS_IC4_TAR_reg)=data)
+#define get_MIS_IC4_TAR_reg   (*((volatile unsigned int*) MIS_IC4_TAR_reg))
+#define MIS_IC4_TAR_inst_adr                                                         "0x0081"
+#define MIS_IC4_TAR_inst                                                             0x0081
+#define MIS_IC4_TAR_ic_10bitaddr_master_shift                                        (12)
+#define MIS_IC4_TAR_ic_10bitaddr_master_mask                                         (0x00001000)
+#define MIS_IC4_TAR_ic_10bitaddr_master(data)                                        (0x00001000&((data)<<12))
+#define MIS_IC4_TAR_ic_10bitaddr_master_src(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC4_TAR_get_ic_10bitaddr_master(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC4_TAR_special_shift                                                    (11)
+#define MIS_IC4_TAR_special_mask                                                     (0x00000800)
+#define MIS_IC4_TAR_special(data)                                                    (0x00000800&((data)<<11))
+#define MIS_IC4_TAR_special_src(data)                                                ((0x00000800&(data))>>11)
+#define MIS_IC4_TAR_get_special(data)                                                ((0x00000800&(data))>>11)
+#define MIS_IC4_TAR_gc_or_start_shift                                                (10)
+#define MIS_IC4_TAR_gc_or_start_mask                                                 (0x00000400)
+#define MIS_IC4_TAR_gc_or_start(data)                                                (0x00000400&((data)<<10))
+#define MIS_IC4_TAR_gc_or_start_src(data)                                            ((0x00000400&(data))>>10)
+#define MIS_IC4_TAR_get_gc_or_start(data)                                            ((0x00000400&(data))>>10)
+#define MIS_IC4_TAR_ic_tar_shift                                                     (0)
+#define MIS_IC4_TAR_ic_tar_mask                                                      (0x000003FF)
+#define MIS_IC4_TAR_ic_tar(data)                                                     (0x000003FF&((data)<<0))
+#define MIS_IC4_TAR_ic_tar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define MIS_IC4_TAR_get_ic_tar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define MIS_IC4_SAR                                                                  0x1801BA08
+#define MIS_IC4_SAR_reg_addr                                                         "0xB801BA08"
+#define MIS_IC4_SAR_reg                                                              0xB801BA08
+#define set_MIS_IC4_SAR_reg(data)   (*((volatile unsigned int*) MIS_IC4_SAR_reg)=data)
+#define get_MIS_IC4_SAR_reg   (*((volatile unsigned int*) MIS_IC4_SAR_reg))
+#define MIS_IC4_SAR_inst_adr                                                         "0x0082"
+#define MIS_IC4_SAR_inst                                                             0x0082
+#define MIS_IC4_SAR_ic_sar_shift                                                     (0)
+#define MIS_IC4_SAR_ic_sar_mask                                                      (0x000003FF)
+#define MIS_IC4_SAR_ic_sar(data)                                                     (0x000003FF&((data)<<0))
+#define MIS_IC4_SAR_ic_sar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define MIS_IC4_SAR_get_ic_sar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define MIS_IC4_HS_MADDR                                                             0x1801BA0C
+#define MIS_IC4_HS_MADDR_reg_addr                                                    "0xB801BA0C"
+#define MIS_IC4_HS_MADDR_reg                                                         0xB801BA0C
+#define set_MIS_IC4_HS_MADDR_reg(data)   (*((volatile unsigned int*) MIS_IC4_HS_MADDR_reg)=data)
+#define get_MIS_IC4_HS_MADDR_reg   (*((volatile unsigned int*) MIS_IC4_HS_MADDR_reg))
+#define MIS_IC4_HS_MADDR_inst_adr                                                    "0x0083"
+#define MIS_IC4_HS_MADDR_inst                                                        0x0083
+#define MIS_IC4_HS_MADDR_ic_hs_mar_shift                                             (0)
+#define MIS_IC4_HS_MADDR_ic_hs_mar_mask                                              (0x00000007)
+#define MIS_IC4_HS_MADDR_ic_hs_mar(data)                                             (0x00000007&((data)<<0))
+#define MIS_IC4_HS_MADDR_ic_hs_mar_src(data)                                         ((0x00000007&(data))>>0)
+#define MIS_IC4_HS_MADDR_get_ic_hs_mar(data)                                         ((0x00000007&(data))>>0)
+
+
+#define MIS_IC4_DATA_CMD                                                             0x1801BA10
+#define MIS_IC4_DATA_CMD_reg_addr                                                    "0xB801BA10"
+#define MIS_IC4_DATA_CMD_reg                                                         0xB801BA10
+#define set_MIS_IC4_DATA_CMD_reg(data)   (*((volatile unsigned int*) MIS_IC4_DATA_CMD_reg)=data)
+#define get_MIS_IC4_DATA_CMD_reg   (*((volatile unsigned int*) MIS_IC4_DATA_CMD_reg))
+#define MIS_IC4_DATA_CMD_inst_adr                                                    "0x0084"
+#define MIS_IC4_DATA_CMD_inst                                                        0x0084
+#define MIS_IC4_DATA_CMD_restart_shift                                               (10)
+#define MIS_IC4_DATA_CMD_restart_mask                                                (0x00000400)
+#define MIS_IC4_DATA_CMD_restart(data)                                               (0x00000400&((data)<<10))
+#define MIS_IC4_DATA_CMD_restart_src(data)                                           ((0x00000400&(data))>>10)
+#define MIS_IC4_DATA_CMD_get_restart(data)                                           ((0x00000400&(data))>>10)
+#define MIS_IC4_DATA_CMD_stop_shift                                                  (9)
+#define MIS_IC4_DATA_CMD_stop_mask                                                   (0x00000200)
+#define MIS_IC4_DATA_CMD_stop(data)                                                  (0x00000200&((data)<<9))
+#define MIS_IC4_DATA_CMD_stop_src(data)                                              ((0x00000200&(data))>>9)
+#define MIS_IC4_DATA_CMD_get_stop(data)                                              ((0x00000200&(data))>>9)
+#define MIS_IC4_DATA_CMD_cmd_shift                                                   (8)
+#define MIS_IC4_DATA_CMD_cmd_mask                                                    (0x00000100)
+#define MIS_IC4_DATA_CMD_cmd(data)                                                   (0x00000100&((data)<<8))
+#define MIS_IC4_DATA_CMD_cmd_src(data)                                               ((0x00000100&(data))>>8)
+#define MIS_IC4_DATA_CMD_get_cmd(data)                                               ((0x00000100&(data))>>8)
+#define MIS_IC4_DATA_CMD_dat_shift                                                   (0)
+#define MIS_IC4_DATA_CMD_dat_mask                                                    (0x000000FF)
+#define MIS_IC4_DATA_CMD_dat(data)                                                   (0x000000FF&((data)<<0))
+#define MIS_IC4_DATA_CMD_dat_src(data)                                               ((0x000000FF&(data))>>0)
+#define MIS_IC4_DATA_CMD_get_dat(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC4_SS_SCL_HCNT                                                          0x1801BA14
+#define MIS_IC4_SS_SCL_HCNT_reg_addr                                                 "0xB801BA14"
+#define MIS_IC4_SS_SCL_HCNT_reg                                                      0xB801BA14
+#define set_MIS_IC4_SS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) MIS_IC4_SS_SCL_HCNT_reg)=data)
+#define get_MIS_IC4_SS_SCL_HCNT_reg   (*((volatile unsigned int*) MIS_IC4_SS_SCL_HCNT_reg))
+#define MIS_IC4_SS_SCL_HCNT_inst_adr                                                 "0x0085"
+#define MIS_IC4_SS_SCL_HCNT_inst                                                     0x0085
+#define MIS_IC4_SS_SCL_HCNT_ic_ss_scl_hcnt_shift                                     (0)
+#define MIS_IC4_SS_SCL_HCNT_ic_ss_scl_hcnt_mask                                      (0x0000FFFF)
+#define MIS_IC4_SS_SCL_HCNT_ic_ss_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC4_SS_SCL_HCNT_ic_ss_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC4_SS_SCL_HCNT_get_ic_ss_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC4_SS_SCL_LCNT                                                          0x1801BA18
+#define MIS_IC4_SS_SCL_LCNT_reg_addr                                                 "0xB801BA18"
+#define MIS_IC4_SS_SCL_LCNT_reg                                                      0xB801BA18
+#define set_MIS_IC4_SS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) MIS_IC4_SS_SCL_LCNT_reg)=data)
+#define get_MIS_IC4_SS_SCL_LCNT_reg   (*((volatile unsigned int*) MIS_IC4_SS_SCL_LCNT_reg))
+#define MIS_IC4_SS_SCL_LCNT_inst_adr                                                 "0x0086"
+#define MIS_IC4_SS_SCL_LCNT_inst                                                     0x0086
+#define MIS_IC4_SS_SCL_LCNT_ic_ss_scl_lcnt_shift                                     (0)
+#define MIS_IC4_SS_SCL_LCNT_ic_ss_scl_lcnt_mask                                      (0x0000FFFF)
+#define MIS_IC4_SS_SCL_LCNT_ic_ss_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC4_SS_SCL_LCNT_ic_ss_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC4_SS_SCL_LCNT_get_ic_ss_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC4_FS_SCL_HCNT                                                          0x1801BA1C
+#define MIS_IC4_FS_SCL_HCNT_reg_addr                                                 "0xB801BA1C"
+#define MIS_IC4_FS_SCL_HCNT_reg                                                      0xB801BA1C
+#define set_MIS_IC4_FS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) MIS_IC4_FS_SCL_HCNT_reg)=data)
+#define get_MIS_IC4_FS_SCL_HCNT_reg   (*((volatile unsigned int*) MIS_IC4_FS_SCL_HCNT_reg))
+#define MIS_IC4_FS_SCL_HCNT_inst_adr                                                 "0x0087"
+#define MIS_IC4_FS_SCL_HCNT_inst                                                     0x0087
+#define MIS_IC4_FS_SCL_HCNT_ic_fs_scl_hcnt_shift                                     (0)
+#define MIS_IC4_FS_SCL_HCNT_ic_fs_scl_hcnt_mask                                      (0x0000FFFF)
+#define MIS_IC4_FS_SCL_HCNT_ic_fs_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC4_FS_SCL_HCNT_ic_fs_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC4_FS_SCL_HCNT_get_ic_fs_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC4_FS_SCL_LCNT                                                          0x1801BA20
+#define MIS_IC4_FS_SCL_LCNT_reg_addr                                                 "0xB801BA20"
+#define MIS_IC4_FS_SCL_LCNT_reg                                                      0xB801BA20
+#define set_MIS_IC4_FS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) MIS_IC4_FS_SCL_LCNT_reg)=data)
+#define get_MIS_IC4_FS_SCL_LCNT_reg   (*((volatile unsigned int*) MIS_IC4_FS_SCL_LCNT_reg))
+#define MIS_IC4_FS_SCL_LCNT_inst_adr                                                 "0x0088"
+#define MIS_IC4_FS_SCL_LCNT_inst                                                     0x0088
+#define MIS_IC4_FS_SCL_LCNT_ic_fs_scl_lcnt_shift                                     (0)
+#define MIS_IC4_FS_SCL_LCNT_ic_fs_scl_lcnt_mask                                      (0x0000FFFF)
+#define MIS_IC4_FS_SCL_LCNT_ic_fs_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC4_FS_SCL_LCNT_ic_fs_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC4_FS_SCL_LCNT_get_ic_fs_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC4_INTR_STAT                                                            0x1801BA2C
+#define MIS_IC4_INTR_STAT_reg_addr                                                   "0xB801BA2C"
+#define MIS_IC4_INTR_STAT_reg                                                        0xB801BA2C
+#define set_MIS_IC4_INTR_STAT_reg(data)   (*((volatile unsigned int*) MIS_IC4_INTR_STAT_reg)=data)
+#define get_MIS_IC4_INTR_STAT_reg   (*((volatile unsigned int*) MIS_IC4_INTR_STAT_reg))
+#define MIS_IC4_INTR_STAT_inst_adr                                                   "0x008B"
+#define MIS_IC4_INTR_STAT_inst                                                       0x008B
+#define MIS_IC4_INTR_STAT_r_gen_call_shift                                           (11)
+#define MIS_IC4_INTR_STAT_r_gen_call_mask                                            (0x00000800)
+#define MIS_IC4_INTR_STAT_r_gen_call(data)                                           (0x00000800&((data)<<11))
+#define MIS_IC4_INTR_STAT_r_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC4_INTR_STAT_get_r_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC4_INTR_STAT_r_start_det_shift                                          (10)
+#define MIS_IC4_INTR_STAT_r_start_det_mask                                           (0x00000400)
+#define MIS_IC4_INTR_STAT_r_start_det(data)                                          (0x00000400&((data)<<10))
+#define MIS_IC4_INTR_STAT_r_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC4_INTR_STAT_get_r_start_det(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC4_INTR_STAT_r_stop_det_shift                                           (9)
+#define MIS_IC4_INTR_STAT_r_stop_det_mask                                            (0x00000200)
+#define MIS_IC4_INTR_STAT_r_stop_det(data)                                           (0x00000200&((data)<<9))
+#define MIS_IC4_INTR_STAT_r_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC4_INTR_STAT_get_r_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC4_INTR_STAT_r_activity_shift                                           (8)
+#define MIS_IC4_INTR_STAT_r_activity_mask                                            (0x00000100)
+#define MIS_IC4_INTR_STAT_r_activity(data)                                           (0x00000100&((data)<<8))
+#define MIS_IC4_INTR_STAT_r_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC4_INTR_STAT_get_r_activity(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC4_INTR_STAT_r_rx_done_shift                                            (7)
+#define MIS_IC4_INTR_STAT_r_rx_done_mask                                             (0x00000080)
+#define MIS_IC4_INTR_STAT_r_rx_done(data)                                            (0x00000080&((data)<<7))
+#define MIS_IC4_INTR_STAT_r_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC4_INTR_STAT_get_r_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC4_INTR_STAT_r_tx_abrt_shift                                            (6)
+#define MIS_IC4_INTR_STAT_r_tx_abrt_mask                                             (0x00000040)
+#define MIS_IC4_INTR_STAT_r_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC4_INTR_STAT_r_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC4_INTR_STAT_get_r_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC4_INTR_STAT_r_rd_req_shift                                             (5)
+#define MIS_IC4_INTR_STAT_r_rd_req_mask                                              (0x00000020)
+#define MIS_IC4_INTR_STAT_r_rd_req(data)                                             (0x00000020&((data)<<5))
+#define MIS_IC4_INTR_STAT_r_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC4_INTR_STAT_get_r_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC4_INTR_STAT_r_tx_empty_shift                                           (4)
+#define MIS_IC4_INTR_STAT_r_tx_empty_mask                                            (0x00000010)
+#define MIS_IC4_INTR_STAT_r_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define MIS_IC4_INTR_STAT_r_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC4_INTR_STAT_get_r_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC4_INTR_STAT_r_tx_over_shift                                            (3)
+#define MIS_IC4_INTR_STAT_r_tx_over_mask                                             (0x00000008)
+#define MIS_IC4_INTR_STAT_r_tx_over(data)                                            (0x00000008&((data)<<3))
+#define MIS_IC4_INTR_STAT_r_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC4_INTR_STAT_get_r_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC4_INTR_STAT_r_rx_full_shift                                            (2)
+#define MIS_IC4_INTR_STAT_r_rx_full_mask                                             (0x00000004)
+#define MIS_IC4_INTR_STAT_r_rx_full(data)                                            (0x00000004&((data)<<2))
+#define MIS_IC4_INTR_STAT_r_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC4_INTR_STAT_get_r_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC4_INTR_STAT_r_rx_over_shift                                            (1)
+#define MIS_IC4_INTR_STAT_r_rx_over_mask                                             (0x00000002)
+#define MIS_IC4_INTR_STAT_r_rx_over(data)                                            (0x00000002&((data)<<1))
+#define MIS_IC4_INTR_STAT_r_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC4_INTR_STAT_get_r_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC4_INTR_STAT_r_rx_under_shift                                           (0)
+#define MIS_IC4_INTR_STAT_r_rx_under_mask                                            (0x00000001)
+#define MIS_IC4_INTR_STAT_r_rx_under(data)                                           (0x00000001&((data)<<0))
+#define MIS_IC4_INTR_STAT_r_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_IC4_INTR_STAT_get_r_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_INTR_MASK                                                            0x1801BA30
+#define MIS_IC4_INTR_MASK_reg_addr                                                   "0xB801BA30"
+#define MIS_IC4_INTR_MASK_reg                                                        0xB801BA30
+#define set_MIS_IC4_INTR_MASK_reg(data)   (*((volatile unsigned int*) MIS_IC4_INTR_MASK_reg)=data)
+#define get_MIS_IC4_INTR_MASK_reg   (*((volatile unsigned int*) MIS_IC4_INTR_MASK_reg))
+#define MIS_IC4_INTR_MASK_inst_adr                                                   "0x008C"
+#define MIS_IC4_INTR_MASK_inst                                                       0x008C
+#define MIS_IC4_INTR_MASK_m_gen_call_shift                                           (11)
+#define MIS_IC4_INTR_MASK_m_gen_call_mask                                            (0x00000800)
+#define MIS_IC4_INTR_MASK_m_gen_call(data)                                           (0x00000800&((data)<<11))
+#define MIS_IC4_INTR_MASK_m_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC4_INTR_MASK_get_m_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC4_INTR_MASK_m_start_det_shift                                          (10)
+#define MIS_IC4_INTR_MASK_m_start_det_mask                                           (0x00000400)
+#define MIS_IC4_INTR_MASK_m_start_det(data)                                          (0x00000400&((data)<<10))
+#define MIS_IC4_INTR_MASK_m_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC4_INTR_MASK_get_m_start_det(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC4_INTR_MASK_m_stop_det_shift                                           (9)
+#define MIS_IC4_INTR_MASK_m_stop_det_mask                                            (0x00000200)
+#define MIS_IC4_INTR_MASK_m_stop_det(data)                                           (0x00000200&((data)<<9))
+#define MIS_IC4_INTR_MASK_m_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC4_INTR_MASK_get_m_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC4_INTR_MASK_m_activity_shift                                           (8)
+#define MIS_IC4_INTR_MASK_m_activity_mask                                            (0x00000100)
+#define MIS_IC4_INTR_MASK_m_activity(data)                                           (0x00000100&((data)<<8))
+#define MIS_IC4_INTR_MASK_m_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC4_INTR_MASK_get_m_activity(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC4_INTR_MASK_m_rx_done_shift                                            (7)
+#define MIS_IC4_INTR_MASK_m_rx_done_mask                                             (0x00000080)
+#define MIS_IC4_INTR_MASK_m_rx_done(data)                                            (0x00000080&((data)<<7))
+#define MIS_IC4_INTR_MASK_m_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC4_INTR_MASK_get_m_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC4_INTR_MASK_m_tx_abrt_shift                                            (6)
+#define MIS_IC4_INTR_MASK_m_tx_abrt_mask                                             (0x00000040)
+#define MIS_IC4_INTR_MASK_m_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC4_INTR_MASK_m_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC4_INTR_MASK_get_m_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC4_INTR_MASK_m_rd_req_shift                                             (5)
+#define MIS_IC4_INTR_MASK_m_rd_req_mask                                              (0x00000020)
+#define MIS_IC4_INTR_MASK_m_rd_req(data)                                             (0x00000020&((data)<<5))
+#define MIS_IC4_INTR_MASK_m_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC4_INTR_MASK_get_m_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC4_INTR_MASK_m_tx_empty_shift                                           (4)
+#define MIS_IC4_INTR_MASK_m_tx_empty_mask                                            (0x00000010)
+#define MIS_IC4_INTR_MASK_m_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define MIS_IC4_INTR_MASK_m_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC4_INTR_MASK_get_m_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC4_INTR_MASK_m_tx_over_shift                                            (3)
+#define MIS_IC4_INTR_MASK_m_tx_over_mask                                             (0x00000008)
+#define MIS_IC4_INTR_MASK_m_tx_over(data)                                            (0x00000008&((data)<<3))
+#define MIS_IC4_INTR_MASK_m_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC4_INTR_MASK_get_m_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC4_INTR_MASK_m_rx_full_shift                                            (2)
+#define MIS_IC4_INTR_MASK_m_rx_full_mask                                             (0x00000004)
+#define MIS_IC4_INTR_MASK_m_rx_full(data)                                            (0x00000004&((data)<<2))
+#define MIS_IC4_INTR_MASK_m_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC4_INTR_MASK_get_m_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC4_INTR_MASK_m_rx_over_shift                                            (1)
+#define MIS_IC4_INTR_MASK_m_rx_over_mask                                             (0x00000002)
+#define MIS_IC4_INTR_MASK_m_rx_over(data)                                            (0x00000002&((data)<<1))
+#define MIS_IC4_INTR_MASK_m_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC4_INTR_MASK_get_m_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC4_INTR_MASK_m_rx_under_shift                                           (0)
+#define MIS_IC4_INTR_MASK_m_rx_under_mask                                            (0x00000001)
+#define MIS_IC4_INTR_MASK_m_rx_under(data)                                           (0x00000001&((data)<<0))
+#define MIS_IC4_INTR_MASK_m_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_IC4_INTR_MASK_get_m_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_RAW_INTR_STAT                                                        0x1801BA34
+#define MIS_IC4_RAW_INTR_STAT_reg_addr                                               "0xB801BA34"
+#define MIS_IC4_RAW_INTR_STAT_reg                                                    0xB801BA34
+#define set_MIS_IC4_RAW_INTR_STAT_reg(data)   (*((volatile unsigned int*) MIS_IC4_RAW_INTR_STAT_reg)=data)
+#define get_MIS_IC4_RAW_INTR_STAT_reg   (*((volatile unsigned int*) MIS_IC4_RAW_INTR_STAT_reg))
+#define MIS_IC4_RAW_INTR_STAT_inst_adr                                               "0x008D"
+#define MIS_IC4_RAW_INTR_STAT_inst                                                   0x008D
+#define MIS_IC4_RAW_INTR_STAT_gen_call_shift                                         (11)
+#define MIS_IC4_RAW_INTR_STAT_gen_call_mask                                          (0x00000800)
+#define MIS_IC4_RAW_INTR_STAT_gen_call(data)                                         (0x00000800&((data)<<11))
+#define MIS_IC4_RAW_INTR_STAT_gen_call_src(data)                                     ((0x00000800&(data))>>11)
+#define MIS_IC4_RAW_INTR_STAT_get_gen_call(data)                                     ((0x00000800&(data))>>11)
+#define MIS_IC4_RAW_INTR_STAT_start_det_shift                                        (10)
+#define MIS_IC4_RAW_INTR_STAT_start_det_mask                                         (0x00000400)
+#define MIS_IC4_RAW_INTR_STAT_start_det(data)                                        (0x00000400&((data)<<10))
+#define MIS_IC4_RAW_INTR_STAT_start_det_src(data)                                    ((0x00000400&(data))>>10)
+#define MIS_IC4_RAW_INTR_STAT_get_start_det(data)                                    ((0x00000400&(data))>>10)
+#define MIS_IC4_RAW_INTR_STAT_stop_det_shift                                         (9)
+#define MIS_IC4_RAW_INTR_STAT_stop_det_mask                                          (0x00000200)
+#define MIS_IC4_RAW_INTR_STAT_stop_det(data)                                         (0x00000200&((data)<<9))
+#define MIS_IC4_RAW_INTR_STAT_stop_det_src(data)                                     ((0x00000200&(data))>>9)
+#define MIS_IC4_RAW_INTR_STAT_get_stop_det(data)                                     ((0x00000200&(data))>>9)
+#define MIS_IC4_RAW_INTR_STAT_activity_shift                                         (8)
+#define MIS_IC4_RAW_INTR_STAT_activity_mask                                          (0x00000100)
+#define MIS_IC4_RAW_INTR_STAT_activity(data)                                         (0x00000100&((data)<<8))
+#define MIS_IC4_RAW_INTR_STAT_activity_src(data)                                     ((0x00000100&(data))>>8)
+#define MIS_IC4_RAW_INTR_STAT_get_activity(data)                                     ((0x00000100&(data))>>8)
+#define MIS_IC4_RAW_INTR_STAT_rx_done_shift                                          (7)
+#define MIS_IC4_RAW_INTR_STAT_rx_done_mask                                           (0x00000080)
+#define MIS_IC4_RAW_INTR_STAT_rx_done(data)                                          (0x00000080&((data)<<7))
+#define MIS_IC4_RAW_INTR_STAT_rx_done_src(data)                                      ((0x00000080&(data))>>7)
+#define MIS_IC4_RAW_INTR_STAT_get_rx_done(data)                                      ((0x00000080&(data))>>7)
+#define MIS_IC4_RAW_INTR_STAT_tx_abrt_shift                                          (6)
+#define MIS_IC4_RAW_INTR_STAT_tx_abrt_mask                                           (0x00000040)
+#define MIS_IC4_RAW_INTR_STAT_tx_abrt(data)                                          (0x00000040&((data)<<6))
+#define MIS_IC4_RAW_INTR_STAT_tx_abrt_src(data)                                      ((0x00000040&(data))>>6)
+#define MIS_IC4_RAW_INTR_STAT_get_tx_abrt(data)                                      ((0x00000040&(data))>>6)
+#define MIS_IC4_RAW_INTR_STAT_rd_req_shift                                           (5)
+#define MIS_IC4_RAW_INTR_STAT_rd_req_mask                                            (0x00000020)
+#define MIS_IC4_RAW_INTR_STAT_rd_req(data)                                           (0x00000020&((data)<<5))
+#define MIS_IC4_RAW_INTR_STAT_rd_req_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC4_RAW_INTR_STAT_get_rd_req(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC4_RAW_INTR_STAT_tx_empty_shift                                         (4)
+#define MIS_IC4_RAW_INTR_STAT_tx_empty_mask                                          (0x00000010)
+#define MIS_IC4_RAW_INTR_STAT_tx_empty(data)                                         (0x00000010&((data)<<4))
+#define MIS_IC4_RAW_INTR_STAT_tx_empty_src(data)                                     ((0x00000010&(data))>>4)
+#define MIS_IC4_RAW_INTR_STAT_get_tx_empty(data)                                     ((0x00000010&(data))>>4)
+#define MIS_IC4_RAW_INTR_STAT_tx_over_shift                                          (3)
+#define MIS_IC4_RAW_INTR_STAT_tx_over_mask                                           (0x00000008)
+#define MIS_IC4_RAW_INTR_STAT_tx_over(data)                                          (0x00000008&((data)<<3))
+#define MIS_IC4_RAW_INTR_STAT_tx_over_src(data)                                      ((0x00000008&(data))>>3)
+#define MIS_IC4_RAW_INTR_STAT_get_tx_over(data)                                      ((0x00000008&(data))>>3)
+#define MIS_IC4_RAW_INTR_STAT_rx_full_shift                                          (2)
+#define MIS_IC4_RAW_INTR_STAT_rx_full_mask                                           (0x00000004)
+#define MIS_IC4_RAW_INTR_STAT_rx_full(data)                                          (0x00000004&((data)<<2))
+#define MIS_IC4_RAW_INTR_STAT_rx_full_src(data)                                      ((0x00000004&(data))>>2)
+#define MIS_IC4_RAW_INTR_STAT_get_rx_full(data)                                      ((0x00000004&(data))>>2)
+#define MIS_IC4_RAW_INTR_STAT_rx_over_shift                                          (1)
+#define MIS_IC4_RAW_INTR_STAT_rx_over_mask                                           (0x00000002)
+#define MIS_IC4_RAW_INTR_STAT_rx_over(data)                                          (0x00000002&((data)<<1))
+#define MIS_IC4_RAW_INTR_STAT_rx_over_src(data)                                      ((0x00000002&(data))>>1)
+#define MIS_IC4_RAW_INTR_STAT_get_rx_over(data)                                      ((0x00000002&(data))>>1)
+#define MIS_IC4_RAW_INTR_STAT_rx_under_shift                                         (0)
+#define MIS_IC4_RAW_INTR_STAT_rx_under_mask                                          (0x00000001)
+#define MIS_IC4_RAW_INTR_STAT_rx_under(data)                                         (0x00000001&((data)<<0))
+#define MIS_IC4_RAW_INTR_STAT_rx_under_src(data)                                     ((0x00000001&(data))>>0)
+#define MIS_IC4_RAW_INTR_STAT_get_rx_under(data)                                     ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_RX_TL                                                                0x1801BA38
+#define MIS_IC4_RX_TL_reg_addr                                                       "0xB801BA38"
+#define MIS_IC4_RX_TL_reg                                                            0xB801BA38
+#define set_MIS_IC4_RX_TL_reg(data)   (*((volatile unsigned int*) MIS_IC4_RX_TL_reg)=data)
+#define get_MIS_IC4_RX_TL_reg   (*((volatile unsigned int*) MIS_IC4_RX_TL_reg))
+#define MIS_IC4_RX_TL_inst_adr                                                       "0x008E"
+#define MIS_IC4_RX_TL_inst                                                           0x008E
+#define MIS_IC4_RX_TL_rx_tl_shift                                                    (0)
+#define MIS_IC4_RX_TL_rx_tl_mask                                                     (0x000000FF)
+#define MIS_IC4_RX_TL_rx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define MIS_IC4_RX_TL_rx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define MIS_IC4_RX_TL_get_rx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC4_TX_TL                                                                0x1801BA3C
+#define MIS_IC4_TX_TL_reg_addr                                                       "0xB801BA3C"
+#define MIS_IC4_TX_TL_reg                                                            0xB801BA3C
+#define set_MIS_IC4_TX_TL_reg(data)   (*((volatile unsigned int*) MIS_IC4_TX_TL_reg)=data)
+#define get_MIS_IC4_TX_TL_reg   (*((volatile unsigned int*) MIS_IC4_TX_TL_reg))
+#define MIS_IC4_TX_TL_inst_adr                                                       "0x008F"
+#define MIS_IC4_TX_TL_inst                                                           0x008F
+#define MIS_IC4_TX_TL_tx_tl_shift                                                    (0)
+#define MIS_IC4_TX_TL_tx_tl_mask                                                     (0x000000FF)
+#define MIS_IC4_TX_TL_tx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define MIS_IC4_TX_TL_tx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define MIS_IC4_TX_TL_get_tx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC4_CLR_INTR                                                             0x1801BA40
+#define MIS_IC4_CLR_INTR_reg_addr                                                    "0xB801BA40"
+#define MIS_IC4_CLR_INTR_reg                                                         0xB801BA40
+#define set_MIS_IC4_CLR_INTR_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_INTR_reg)=data)
+#define get_MIS_IC4_CLR_INTR_reg   (*((volatile unsigned int*) MIS_IC4_CLR_INTR_reg))
+#define MIS_IC4_CLR_INTR_inst_adr                                                    "0x0090"
+#define MIS_IC4_CLR_INTR_inst                                                        0x0090
+#define MIS_IC4_CLR_INTR_clr_intr_shift                                              (0)
+#define MIS_IC4_CLR_INTR_clr_intr_mask                                               (0x00000001)
+#define MIS_IC4_CLR_INTR_clr_intr(data)                                              (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_INTR_clr_intr_src(data)                                          ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_INTR_get_clr_intr(data)                                          ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_CLR_RX_UNDER                                                         0x1801BA44
+#define MIS_IC4_CLR_RX_UNDER_reg_addr                                                "0xB801BA44"
+#define MIS_IC4_CLR_RX_UNDER_reg                                                     0xB801BA44
+#define set_MIS_IC4_CLR_RX_UNDER_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_RX_UNDER_reg)=data)
+#define get_MIS_IC4_CLR_RX_UNDER_reg   (*((volatile unsigned int*) MIS_IC4_CLR_RX_UNDER_reg))
+#define MIS_IC4_CLR_RX_UNDER_inst_adr                                                "0x0091"
+#define MIS_IC4_CLR_RX_UNDER_inst                                                    0x0091
+#define MIS_IC4_CLR_RX_UNDER_clr_rx_under_shift                                      (0)
+#define MIS_IC4_CLR_RX_UNDER_clr_rx_under_mask                                       (0x00000001)
+#define MIS_IC4_CLR_RX_UNDER_clr_rx_under(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_RX_UNDER_clr_rx_under_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_RX_UNDER_get_clr_rx_under(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_CLR_RX_OVER                                                          0x1801BA48
+#define MIS_IC4_CLR_RX_OVER_reg_addr                                                 "0xB801BA48"
+#define MIS_IC4_CLR_RX_OVER_reg                                                      0xB801BA48
+#define set_MIS_IC4_CLR_RX_OVER_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_RX_OVER_reg)=data)
+#define get_MIS_IC4_CLR_RX_OVER_reg   (*((volatile unsigned int*) MIS_IC4_CLR_RX_OVER_reg))
+#define MIS_IC4_CLR_RX_OVER_inst_adr                                                 "0x0092"
+#define MIS_IC4_CLR_RX_OVER_inst                                                     0x0092
+#define MIS_IC4_CLR_RX_OVER_clr_rx_over_shift                                        (0)
+#define MIS_IC4_CLR_RX_OVER_clr_rx_over_mask                                         (0x00000001)
+#define MIS_IC4_CLR_RX_OVER_clr_rx_over(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_RX_OVER_clr_rx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_RX_OVER_get_clr_rx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_CLR_TX_OVER                                                          0x1801BA4C
+#define MIS_IC4_CLR_TX_OVER_reg_addr                                                 "0xB801BA4C"
+#define MIS_IC4_CLR_TX_OVER_reg                                                      0xB801BA4C
+#define set_MIS_IC4_CLR_TX_OVER_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_TX_OVER_reg)=data)
+#define get_MIS_IC4_CLR_TX_OVER_reg   (*((volatile unsigned int*) MIS_IC4_CLR_TX_OVER_reg))
+#define MIS_IC4_CLR_TX_OVER_inst_adr                                                 "0x0093"
+#define MIS_IC4_CLR_TX_OVER_inst                                                     0x0093
+#define MIS_IC4_CLR_TX_OVER_clr_tx_over_shift                                        (0)
+#define MIS_IC4_CLR_TX_OVER_clr_tx_over_mask                                         (0x00000001)
+#define MIS_IC4_CLR_TX_OVER_clr_tx_over(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_TX_OVER_clr_tx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_TX_OVER_get_clr_tx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_CLR_RD_REQ                                                           0x1801BA50
+#define MIS_IC4_CLR_RD_REQ_reg_addr                                                  "0xB801BA50"
+#define MIS_IC4_CLR_RD_REQ_reg                                                       0xB801BA50
+#define set_MIS_IC4_CLR_RD_REQ_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_RD_REQ_reg)=data)
+#define get_MIS_IC4_CLR_RD_REQ_reg   (*((volatile unsigned int*) MIS_IC4_CLR_RD_REQ_reg))
+#define MIS_IC4_CLR_RD_REQ_inst_adr                                                  "0x0094"
+#define MIS_IC4_CLR_RD_REQ_inst                                                      0x0094
+#define MIS_IC4_CLR_RD_REQ_clr_rd_req_shift                                          (0)
+#define MIS_IC4_CLR_RD_REQ_clr_rd_req_mask                                           (0x00000001)
+#define MIS_IC4_CLR_RD_REQ_clr_rd_req(data)                                          (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_RD_REQ_clr_rd_req_src(data)                                      ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_RD_REQ_get_clr_rd_req(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_CLR_TX_ABRT                                                          0x1801BA54
+#define MIS_IC4_CLR_TX_ABRT_reg_addr                                                 "0xB801BA54"
+#define MIS_IC4_CLR_TX_ABRT_reg                                                      0xB801BA54
+#define set_MIS_IC4_CLR_TX_ABRT_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_TX_ABRT_reg)=data)
+#define get_MIS_IC4_CLR_TX_ABRT_reg   (*((volatile unsigned int*) MIS_IC4_CLR_TX_ABRT_reg))
+#define MIS_IC4_CLR_TX_ABRT_inst_adr                                                 "0x0095"
+#define MIS_IC4_CLR_TX_ABRT_inst                                                     0x0095
+#define MIS_IC4_CLR_TX_ABRT_clr_tx_abrt_shift                                        (0)
+#define MIS_IC4_CLR_TX_ABRT_clr_tx_abrt_mask                                         (0x00000001)
+#define MIS_IC4_CLR_TX_ABRT_clr_tx_abrt(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_TX_ABRT_clr_tx_abrt_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_TX_ABRT_get_clr_tx_abrt(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_CLR_RX_DONE                                                          0x1801BA58
+#define MIS_IC4_CLR_RX_DONE_reg_addr                                                 "0xB801BA58"
+#define MIS_IC4_CLR_RX_DONE_reg                                                      0xB801BA58
+#define set_MIS_IC4_CLR_RX_DONE_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_RX_DONE_reg)=data)
+#define get_MIS_IC4_CLR_RX_DONE_reg   (*((volatile unsigned int*) MIS_IC4_CLR_RX_DONE_reg))
+#define MIS_IC4_CLR_RX_DONE_inst_adr                                                 "0x0096"
+#define MIS_IC4_CLR_RX_DONE_inst                                                     0x0096
+#define MIS_IC4_CLR_RX_DONE_clr_rx_done_shift                                        (0)
+#define MIS_IC4_CLR_RX_DONE_clr_rx_done_mask                                         (0x00000001)
+#define MIS_IC4_CLR_RX_DONE_clr_rx_done(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_RX_DONE_clr_rx_done_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_RX_DONE_get_clr_rx_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_CLR_ACTIVITY                                                         0x1801BA5C
+#define MIS_IC4_CLR_ACTIVITY_reg_addr                                                "0xB801BA5C"
+#define MIS_IC4_CLR_ACTIVITY_reg                                                     0xB801BA5C
+#define set_MIS_IC4_CLR_ACTIVITY_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_ACTIVITY_reg)=data)
+#define get_MIS_IC4_CLR_ACTIVITY_reg   (*((volatile unsigned int*) MIS_IC4_CLR_ACTIVITY_reg))
+#define MIS_IC4_CLR_ACTIVITY_inst_adr                                                "0x0097"
+#define MIS_IC4_CLR_ACTIVITY_inst                                                    0x0097
+#define MIS_IC4_CLR_ACTIVITY_clr_activity_shift                                      (0)
+#define MIS_IC4_CLR_ACTIVITY_clr_activity_mask                                       (0x00000001)
+#define MIS_IC4_CLR_ACTIVITY_clr_activity(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_ACTIVITY_clr_activity_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_ACTIVITY_get_clr_activity(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_CLR_STOP_DET                                                         0x1801BA60
+#define MIS_IC4_CLR_STOP_DET_reg_addr                                                "0xB801BA60"
+#define MIS_IC4_CLR_STOP_DET_reg                                                     0xB801BA60
+#define set_MIS_IC4_CLR_STOP_DET_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_STOP_DET_reg)=data)
+#define get_MIS_IC4_CLR_STOP_DET_reg   (*((volatile unsigned int*) MIS_IC4_CLR_STOP_DET_reg))
+#define MIS_IC4_CLR_STOP_DET_inst_adr                                                "0x0098"
+#define MIS_IC4_CLR_STOP_DET_inst                                                    0x0098
+#define MIS_IC4_CLR_STOP_DET_clr_stop_det_shift                                      (0)
+#define MIS_IC4_CLR_STOP_DET_clr_stop_det_mask                                       (0x00000001)
+#define MIS_IC4_CLR_STOP_DET_clr_stop_det(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_STOP_DET_clr_stop_det_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_STOP_DET_get_clr_stop_det(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_CLR_START_DET                                                        0x1801BA64
+#define MIS_IC4_CLR_START_DET_reg_addr                                               "0xB801BA64"
+#define MIS_IC4_CLR_START_DET_reg                                                    0xB801BA64
+#define set_MIS_IC4_CLR_START_DET_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_START_DET_reg)=data)
+#define get_MIS_IC4_CLR_START_DET_reg   (*((volatile unsigned int*) MIS_IC4_CLR_START_DET_reg))
+#define MIS_IC4_CLR_START_DET_inst_adr                                               "0x0099"
+#define MIS_IC4_CLR_START_DET_inst                                                   0x0099
+#define MIS_IC4_CLR_START_DET_clr_start_det_shift                                    (0)
+#define MIS_IC4_CLR_START_DET_clr_start_det_mask                                     (0x00000001)
+#define MIS_IC4_CLR_START_DET_clr_start_det(data)                                    (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_START_DET_clr_start_det_src(data)                                ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_START_DET_get_clr_start_det(data)                                ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_CLR_GEN_CALL                                                         0x1801BA68
+#define MIS_IC4_CLR_GEN_CALL_reg_addr                                                "0xB801BA68"
+#define MIS_IC4_CLR_GEN_CALL_reg                                                     0xB801BA68
+#define set_MIS_IC4_CLR_GEN_CALL_reg(data)   (*((volatile unsigned int*) MIS_IC4_CLR_GEN_CALL_reg)=data)
+#define get_MIS_IC4_CLR_GEN_CALL_reg   (*((volatile unsigned int*) MIS_IC4_CLR_GEN_CALL_reg))
+#define MIS_IC4_CLR_GEN_CALL_inst_adr                                                "0x009A"
+#define MIS_IC4_CLR_GEN_CALL_inst                                                    0x009A
+#define MIS_IC4_CLR_GEN_CALL_clr_gen_call_shift                                      (0)
+#define MIS_IC4_CLR_GEN_CALL_clr_gen_call_mask                                       (0x00000001)
+#define MIS_IC4_CLR_GEN_CALL_clr_gen_call(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC4_CLR_GEN_CALL_clr_gen_call_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC4_CLR_GEN_CALL_get_clr_gen_call(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_ENABLE                                                               0x1801BA6C
+#define MIS_IC4_ENABLE_reg_addr                                                      "0xB801BA6C"
+#define MIS_IC4_ENABLE_reg                                                           0xB801BA6C
+#define set_MIS_IC4_ENABLE_reg(data)   (*((volatile unsigned int*) MIS_IC4_ENABLE_reg)=data)
+#define get_MIS_IC4_ENABLE_reg   (*((volatile unsigned int*) MIS_IC4_ENABLE_reg))
+#define MIS_IC4_ENABLE_inst_adr                                                      "0x009B"
+#define MIS_IC4_ENABLE_inst                                                          0x009B
+#define MIS_IC4_ENABLE_enable_shift                                                  (0)
+#define MIS_IC4_ENABLE_enable_mask                                                   (0x00000001)
+#define MIS_IC4_ENABLE_enable(data)                                                  (0x00000001&((data)<<0))
+#define MIS_IC4_ENABLE_enable_src(data)                                              ((0x00000001&(data))>>0)
+#define MIS_IC4_ENABLE_get_enable(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_STATUS                                                               0x1801BA70
+#define MIS_IC4_STATUS_reg_addr                                                      "0xB801BA70"
+#define MIS_IC4_STATUS_reg                                                           0xB801BA70
+#define set_MIS_IC4_STATUS_reg(data)   (*((volatile unsigned int*) MIS_IC4_STATUS_reg)=data)
+#define get_MIS_IC4_STATUS_reg   (*((volatile unsigned int*) MIS_IC4_STATUS_reg))
+#define MIS_IC4_STATUS_inst_adr                                                      "0x009C"
+#define MIS_IC4_STATUS_inst                                                          0x009C
+#define MIS_IC4_STATUS_slv_activity_shift                                            (6)
+#define MIS_IC4_STATUS_slv_activity_mask                                             (0x00000040)
+#define MIS_IC4_STATUS_slv_activity(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC4_STATUS_slv_activity_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC4_STATUS_get_slv_activity(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC4_STATUS_mst_activity_shift                                            (5)
+#define MIS_IC4_STATUS_mst_activity_mask                                             (0x00000020)
+#define MIS_IC4_STATUS_mst_activity(data)                                            (0x00000020&((data)<<5))
+#define MIS_IC4_STATUS_mst_activity_src(data)                                        ((0x00000020&(data))>>5)
+#define MIS_IC4_STATUS_get_mst_activity(data)                                        ((0x00000020&(data))>>5)
+#define MIS_IC4_STATUS_rff_shift                                                     (4)
+#define MIS_IC4_STATUS_rff_mask                                                      (0x00000010)
+#define MIS_IC4_STATUS_rff(data)                                                     (0x00000010&((data)<<4))
+#define MIS_IC4_STATUS_rff_src(data)                                                 ((0x00000010&(data))>>4)
+#define MIS_IC4_STATUS_get_rff(data)                                                 ((0x00000010&(data))>>4)
+#define MIS_IC4_STATUS_rfne_shift                                                    (3)
+#define MIS_IC4_STATUS_rfne_mask                                                     (0x00000008)
+#define MIS_IC4_STATUS_rfne(data)                                                    (0x00000008&((data)<<3))
+#define MIS_IC4_STATUS_rfne_src(data)                                                ((0x00000008&(data))>>3)
+#define MIS_IC4_STATUS_get_rfne(data)                                                ((0x00000008&(data))>>3)
+#define MIS_IC4_STATUS_tfe_shift                                                     (2)
+#define MIS_IC4_STATUS_tfe_mask                                                      (0x00000004)
+#define MIS_IC4_STATUS_tfe(data)                                                     (0x00000004&((data)<<2))
+#define MIS_IC4_STATUS_tfe_src(data)                                                 ((0x00000004&(data))>>2)
+#define MIS_IC4_STATUS_get_tfe(data)                                                 ((0x00000004&(data))>>2)
+#define MIS_IC4_STATUS_tfnf_shift                                                    (1)
+#define MIS_IC4_STATUS_tfnf_mask                                                     (0x00000002)
+#define MIS_IC4_STATUS_tfnf(data)                                                    (0x00000002&((data)<<1))
+#define MIS_IC4_STATUS_tfnf_src(data)                                                ((0x00000002&(data))>>1)
+#define MIS_IC4_STATUS_get_tfnf(data)                                                ((0x00000002&(data))>>1)
+#define MIS_IC4_STATUS_activity_shift                                                (0)
+#define MIS_IC4_STATUS_activity_mask                                                 (0x00000001)
+#define MIS_IC4_STATUS_activity(data)                                                (0x00000001&((data)<<0))
+#define MIS_IC4_STATUS_activity_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_IC4_STATUS_get_activity(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_TXFLR                                                                0x1801BA74
+#define MIS_IC4_TXFLR_reg_addr                                                       "0xB801BA74"
+#define MIS_IC4_TXFLR_reg                                                            0xB801BA74
+#define set_MIS_IC4_TXFLR_reg(data)   (*((volatile unsigned int*) MIS_IC4_TXFLR_reg)=data)
+#define get_MIS_IC4_TXFLR_reg   (*((volatile unsigned int*) MIS_IC4_TXFLR_reg))
+#define MIS_IC4_TXFLR_inst_adr                                                       "0x009D"
+#define MIS_IC4_TXFLR_inst                                                           0x009D
+#define MIS_IC4_TXFLR_txflr_shift                                                    (0)
+#define MIS_IC4_TXFLR_txflr_mask                                                     (0x0000000F)
+#define MIS_IC4_TXFLR_txflr(data)                                                    (0x0000000F&((data)<<0))
+#define MIS_IC4_TXFLR_txflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define MIS_IC4_TXFLR_get_txflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC4_RXFLR                                                                0x1801BA78
+#define MIS_IC4_RXFLR_reg_addr                                                       "0xB801BA78"
+#define MIS_IC4_RXFLR_reg                                                            0xB801BA78
+#define set_MIS_IC4_RXFLR_reg(data)   (*((volatile unsigned int*) MIS_IC4_RXFLR_reg)=data)
+#define get_MIS_IC4_RXFLR_reg   (*((volatile unsigned int*) MIS_IC4_RXFLR_reg))
+#define MIS_IC4_RXFLR_inst_adr                                                       "0x009E"
+#define MIS_IC4_RXFLR_inst                                                           0x009E
+#define MIS_IC4_RXFLR_rxflr_shift                                                    (0)
+#define MIS_IC4_RXFLR_rxflr_mask                                                     (0x0000000F)
+#define MIS_IC4_RXFLR_rxflr(data)                                                    (0x0000000F&((data)<<0))
+#define MIS_IC4_RXFLR_rxflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define MIS_IC4_RXFLR_get_rxflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC4_SDA_HOLD                                                             0x1801BA7C
+#define MIS_IC4_SDA_HOLD_reg_addr                                                    "0xB801BA7C"
+#define MIS_IC4_SDA_HOLD_reg                                                         0xB801BA7C
+#define set_MIS_IC4_SDA_HOLD_reg(data)   (*((volatile unsigned int*) MIS_IC4_SDA_HOLD_reg)=data)
+#define get_MIS_IC4_SDA_HOLD_reg   (*((volatile unsigned int*) MIS_IC4_SDA_HOLD_reg))
+#define MIS_IC4_SDA_HOLD_inst_adr                                                    "0x009F"
+#define MIS_IC4_SDA_HOLD_inst                                                        0x009F
+#define MIS_IC4_SDA_HOLD_sda_hold_shift                                              (0)
+#define MIS_IC4_SDA_HOLD_sda_hold_mask                                               (0x0000FFFF)
+#define MIS_IC4_SDA_HOLD_sda_hold(data)                                              (0x0000FFFF&((data)<<0))
+#define MIS_IC4_SDA_HOLD_sda_hold_src(data)                                          ((0x0000FFFF&(data))>>0)
+#define MIS_IC4_SDA_HOLD_get_sda_hold(data)                                          ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC4_TX_ABRT_SOURCE                                                       0x1801BA80
+#define MIS_IC4_TX_ABRT_SOURCE_reg_addr                                              "0xB801BA80"
+#define MIS_IC4_TX_ABRT_SOURCE_reg                                                   0xB801BA80
+#define set_MIS_IC4_TX_ABRT_SOURCE_reg(data)   (*((volatile unsigned int*) MIS_IC4_TX_ABRT_SOURCE_reg)=data)
+#define get_MIS_IC4_TX_ABRT_SOURCE_reg   (*((volatile unsigned int*) MIS_IC4_TX_ABRT_SOURCE_reg))
+#define MIS_IC4_TX_ABRT_SOURCE_inst_adr                                              "0x00A0"
+#define MIS_IC4_TX_ABRT_SOURCE_inst                                                  0x00A0
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slvrd_intx_shift                                 (15)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slvrd_intx_mask                                  (0x00008000)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slvrd_intx(data)                                 (0x00008000&((data)<<15))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slvrd_intx_src(data)                             ((0x00008000&(data))>>15)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_slvrd_intx(data)                             ((0x00008000&(data))>>15)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slv_arblost_shift                                (14)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slv_arblost_mask                                 (0x00004000)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slv_arblost(data)                                (0x00004000&((data)<<14))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slv_arblost_src(data)                            ((0x00004000&(data))>>14)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_slv_arblost(data)                            ((0x00004000&(data))>>14)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slvflush_txfifo_shift                            (13)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slvflush_txfifo_mask                             (0x00002000)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slvflush_txfifo(data)                            (0x00002000&((data)<<13))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_slvflush_txfifo_src(data)                        ((0x00002000&(data))>>13)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_slvflush_txfifo(data)                        ((0x00002000&(data))>>13)
+#define MIS_IC4_TX_ABRT_SOURCE_arb_lost_shift                                        (12)
+#define MIS_IC4_TX_ABRT_SOURCE_arb_lost_mask                                         (0x00001000)
+#define MIS_IC4_TX_ABRT_SOURCE_arb_lost(data)                                        (0x00001000&((data)<<12))
+#define MIS_IC4_TX_ABRT_SOURCE_arb_lost_src(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC4_TX_ABRT_SOURCE_get_arb_lost(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC4_TX_ABRT_SOURCE_arb_master_dis_shift                                  (11)
+#define MIS_IC4_TX_ABRT_SOURCE_arb_master_dis_mask                                   (0x00000800)
+#define MIS_IC4_TX_ABRT_SOURCE_arb_master_dis(data)                                  (0x00000800&((data)<<11))
+#define MIS_IC4_TX_ABRT_SOURCE_arb_master_dis_src(data)                              ((0x00000800&(data))>>11)
+#define MIS_IC4_TX_ABRT_SOURCE_get_arb_master_dis(data)                              ((0x00000800&(data))>>11)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_shift                             (10)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_mask                              (0x00000400)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10b_rd_norstrt(data)                             (0x00000400&((data)<<10))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_src(data)                         ((0x00000400&(data))>>10)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_10b_rd_norstrt(data)                         ((0x00000400&(data))>>10)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_sbyte_norstrt_shift                              (9)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_sbyte_norstrt_mask                               (0x00000200)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_sbyte_norstrt(data)                              (0x00000200&((data)<<9))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_sbyte_norstrt_src(data)                          ((0x00000200&(data))>>9)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_sbyte_norstrt(data)                          ((0x00000200&(data))>>9)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_hs_norstrt_shift                                 (8)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_hs_norstrt_mask                                  (0x00000100)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_hs_norstrt(data)                                 (0x00000100&((data)<<8))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_hs_norstrt_src(data)                             ((0x00000100&(data))>>8)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_hs_norstrt(data)                             ((0x00000100&(data))>>8)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_sbyte_ackdet_shift                               (7)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_sbyte_ackdet_mask                                (0x00000080)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_sbyte_ackdet(data)                               (0x00000080&((data)<<7))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_sbyte_ackdet_src(data)                           ((0x00000080&(data))>>7)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_sbyte_ackdet(data)                           ((0x00000080&(data))>>7)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_hs_ackdet_shift                                  (6)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_hs_ackdet_mask                                   (0x00000040)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_hs_ackdet(data)                                  (0x00000040&((data)<<6))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_hs_ackdet_src(data)                              ((0x00000040&(data))>>6)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_hs_ackdet(data)                              ((0x00000040&(data))>>6)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_gcall_read_shift                                 (5)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_gcall_read_mask                                  (0x00000020)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_gcall_read(data)                                 (0x00000020&((data)<<5))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_gcall_read_src(data)                             ((0x00000020&(data))>>5)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_gcall_read(data)                             ((0x00000020&(data))>>5)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_gcall_noack_shift                                (4)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_gcall_noack_mask                                 (0x00000010)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_gcall_noack(data)                                (0x00000010&((data)<<4))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_gcall_noack_src(data)                            ((0x00000010&(data))>>4)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_gcall_noack(data)                            ((0x00000010&(data))>>4)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_txdata_noack_shift                               (3)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_txdata_noack_mask                                (0x00000008)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_txdata_noack(data)                               (0x00000008&((data)<<3))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_txdata_noack_src(data)                           ((0x00000008&(data))>>3)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_txdata_noack(data)                           ((0x00000008&(data))>>3)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10addr2_noack_shift                              (2)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10addr2_noack_mask                               (0x00000004)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10addr2_noack(data)                              (0x00000004&((data)<<2))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10addr2_noack_src(data)                          ((0x00000004&(data))>>2)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_10addr2_noack(data)                          ((0x00000004&(data))>>2)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10addr1_noack_shift                              (1)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10addr1_noack_mask                               (0x00000002)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10addr1_noack(data)                              (0x00000002&((data)<<1))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_10addr1_noack_src(data)                          ((0x00000002&(data))>>1)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_10addr1_noack(data)                          ((0x00000002&(data))>>1)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_7b_addr_noack_shift                              (0)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_7b_addr_noack_mask                               (0x00000001)
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_7b_addr_noack(data)                              (0x00000001&((data)<<0))
+#define MIS_IC4_TX_ABRT_SOURCE_abrt_7b_addr_noack_src(data)                          ((0x00000001&(data))>>0)
+#define MIS_IC4_TX_ABRT_SOURCE_get_abrt_7b_addr_noack(data)                          ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_SLV_DATA_NACK_ONLY                                                   0x1801BA84
+#define MIS_IC4_SLV_DATA_NACK_ONLY_reg_addr                                          "0xB801BA84"
+#define MIS_IC4_SLV_DATA_NACK_ONLY_reg                                               0xB801BA84
+#define set_MIS_IC4_SLV_DATA_NACK_ONLY_reg(data)   (*((volatile unsigned int*) MIS_IC4_SLV_DATA_NACK_ONLY_reg)=data)
+#define get_MIS_IC4_SLV_DATA_NACK_ONLY_reg   (*((volatile unsigned int*) MIS_IC4_SLV_DATA_NACK_ONLY_reg))
+#define MIS_IC4_SLV_DATA_NACK_ONLY_inst_adr                                          "0x00A1"
+#define MIS_IC4_SLV_DATA_NACK_ONLY_inst                                              0x00A1
+#define MIS_IC4_SLV_DATA_NACK_ONLY_nack_shift                                        (0)
+#define MIS_IC4_SLV_DATA_NACK_ONLY_nack_mask                                         (0x00000001)
+#define MIS_IC4_SLV_DATA_NACK_ONLY_nack(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC4_SLV_DATA_NACK_ONLY_nack_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC4_SLV_DATA_NACK_ONLY_get_nack(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_DMA_CR                                                               0x1801BA88
+#define MIS_IC4_DMA_CR_reg_addr                                                      "0xB801BA88"
+#define MIS_IC4_DMA_CR_reg                                                           0xB801BA88
+#define set_MIS_IC4_DMA_CR_reg(data)   (*((volatile unsigned int*) MIS_IC4_DMA_CR_reg)=data)
+#define get_MIS_IC4_DMA_CR_reg   (*((volatile unsigned int*) MIS_IC4_DMA_CR_reg))
+#define MIS_IC4_DMA_CR_inst_adr                                                      "0x00A2"
+#define MIS_IC4_DMA_CR_inst                                                          0x00A2
+#define MIS_IC4_DMA_CR_tdmae_shift                                                   (1)
+#define MIS_IC4_DMA_CR_tdmae_mask                                                    (0x00000002)
+#define MIS_IC4_DMA_CR_tdmae(data)                                                   (0x00000002&((data)<<1))
+#define MIS_IC4_DMA_CR_tdmae_src(data)                                               ((0x00000002&(data))>>1)
+#define MIS_IC4_DMA_CR_get_tdmae(data)                                               ((0x00000002&(data))>>1)
+#define MIS_IC4_DMA_CR_rdmae_shift                                                   (0)
+#define MIS_IC4_DMA_CR_rdmae_mask                                                    (0x00000001)
+#define MIS_IC4_DMA_CR_rdmae(data)                                                   (0x00000001&((data)<<0))
+#define MIS_IC4_DMA_CR_rdmae_src(data)                                               ((0x00000001&(data))>>0)
+#define MIS_IC4_DMA_CR_get_rdmae(data)                                               ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_DMA_TDLR                                                             0x1801BA8C
+#define MIS_IC4_DMA_TDLR_reg_addr                                                    "0xB801BA8C"
+#define MIS_IC4_DMA_TDLR_reg                                                         0xB801BA8C
+#define set_MIS_IC4_DMA_TDLR_reg(data)   (*((volatile unsigned int*) MIS_IC4_DMA_TDLR_reg)=data)
+#define get_MIS_IC4_DMA_TDLR_reg   (*((volatile unsigned int*) MIS_IC4_DMA_TDLR_reg))
+#define MIS_IC4_DMA_TDLR_inst_adr                                                    "0x00A3"
+#define MIS_IC4_DMA_TDLR_inst                                                        0x00A3
+#define MIS_IC4_DMA_TDLR_dmatdl_shift                                                (0)
+#define MIS_IC4_DMA_TDLR_dmatdl_mask                                                 (0x00000007)
+#define MIS_IC4_DMA_TDLR_dmatdl(data)                                                (0x00000007&((data)<<0))
+#define MIS_IC4_DMA_TDLR_dmatdl_src(data)                                            ((0x00000007&(data))>>0)
+#define MIS_IC4_DMA_TDLR_get_dmatdl(data)                                            ((0x00000007&(data))>>0)
+
+
+#define MIS_IC4_DMA_RDLR                                                             0x1801BA90
+#define MIS_IC4_DMA_RDLR_reg_addr                                                    "0xB801BA90"
+#define MIS_IC4_DMA_RDLR_reg                                                         0xB801BA90
+#define set_MIS_IC4_DMA_RDLR_reg(data)   (*((volatile unsigned int*) MIS_IC4_DMA_RDLR_reg)=data)
+#define get_MIS_IC4_DMA_RDLR_reg   (*((volatile unsigned int*) MIS_IC4_DMA_RDLR_reg))
+#define MIS_IC4_DMA_RDLR_inst_adr                                                    "0x00A4"
+#define MIS_IC4_DMA_RDLR_inst                                                        0x00A4
+#define MIS_IC4_DMA_RDLR_dmardl_shift                                                (0)
+#define MIS_IC4_DMA_RDLR_dmardl_mask                                                 (0x0000000F)
+#define MIS_IC4_DMA_RDLR_dmardl(data)                                                (0x0000000F&((data)<<0))
+#define MIS_IC4_DMA_RDLR_dmardl_src(data)                                            ((0x0000000F&(data))>>0)
+#define MIS_IC4_DMA_RDLR_get_dmardl(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC4_SDA_SETUP                                                            0x1801BA94
+#define MIS_IC4_SDA_SETUP_reg_addr                                                   "0xB801BA94"
+#define MIS_IC4_SDA_SETUP_reg                                                        0xB801BA94
+#define set_MIS_IC4_SDA_SETUP_reg(data)   (*((volatile unsigned int*) MIS_IC4_SDA_SETUP_reg)=data)
+#define get_MIS_IC4_SDA_SETUP_reg   (*((volatile unsigned int*) MIS_IC4_SDA_SETUP_reg))
+#define MIS_IC4_SDA_SETUP_inst_adr                                                   "0x00A5"
+#define MIS_IC4_SDA_SETUP_inst                                                       0x00A5
+#define MIS_IC4_SDA_SETUP_sda_setup_shift                                            (0)
+#define MIS_IC4_SDA_SETUP_sda_setup_mask                                             (0x000000FF)
+#define MIS_IC4_SDA_SETUP_sda_setup(data)                                            (0x000000FF&((data)<<0))
+#define MIS_IC4_SDA_SETUP_sda_setup_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIS_IC4_SDA_SETUP_get_sda_setup(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC4_ACK_GENERAL_CALL                                                     0x1801BA98
+#define MIS_IC4_ACK_GENERAL_CALL_reg_addr                                            "0xB801BA98"
+#define MIS_IC4_ACK_GENERAL_CALL_reg                                                 0xB801BA98
+#define set_MIS_IC4_ACK_GENERAL_CALL_reg(data)   (*((volatile unsigned int*) MIS_IC4_ACK_GENERAL_CALL_reg)=data)
+#define get_MIS_IC4_ACK_GENERAL_CALL_reg   (*((volatile unsigned int*) MIS_IC4_ACK_GENERAL_CALL_reg))
+#define MIS_IC4_ACK_GENERAL_CALL_inst_adr                                            "0x00A6"
+#define MIS_IC4_ACK_GENERAL_CALL_inst                                                0x00A6
+#define MIS_IC4_ACK_GENERAL_CALL_ack_gen_call_shift                                  (0)
+#define MIS_IC4_ACK_GENERAL_CALL_ack_gen_call_mask                                   (0x00000001)
+#define MIS_IC4_ACK_GENERAL_CALL_ack_gen_call(data)                                  (0x00000001&((data)<<0))
+#define MIS_IC4_ACK_GENERAL_CALL_ack_gen_call_src(data)                              ((0x00000001&(data))>>0)
+#define MIS_IC4_ACK_GENERAL_CALL_get_ack_gen_call(data)                              ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_ENABLE_STATUS                                                        0x1801BA9C
+#define MIS_IC4_ENABLE_STATUS_reg_addr                                               "0xB801BA9C"
+#define MIS_IC4_ENABLE_STATUS_reg                                                    0xB801BA9C
+#define set_MIS_IC4_ENABLE_STATUS_reg(data)   (*((volatile unsigned int*) MIS_IC4_ENABLE_STATUS_reg)=data)
+#define get_MIS_IC4_ENABLE_STATUS_reg   (*((volatile unsigned int*) MIS_IC4_ENABLE_STATUS_reg))
+#define MIS_IC4_ENABLE_STATUS_inst_adr                                               "0x00A7"
+#define MIS_IC4_ENABLE_STATUS_inst                                                   0x00A7
+#define MIS_IC4_ENABLE_STATUS_slv_rx_data_lost_shift                                 (2)
+#define MIS_IC4_ENABLE_STATUS_slv_rx_data_lost_mask                                  (0x00000004)
+#define MIS_IC4_ENABLE_STATUS_slv_rx_data_lost(data)                                 (0x00000004&((data)<<2))
+#define MIS_IC4_ENABLE_STATUS_slv_rx_data_lost_src(data)                             ((0x00000004&(data))>>2)
+#define MIS_IC4_ENABLE_STATUS_get_slv_rx_data_lost(data)                             ((0x00000004&(data))>>2)
+#define MIS_IC4_ENABLE_STATUS_slv_disabled_whi_shift                                 (1)
+#define MIS_IC4_ENABLE_STATUS_slv_disabled_whi_mask                                  (0x00000002)
+#define MIS_IC4_ENABLE_STATUS_slv_disabled_whi(data)                                 (0x00000002&((data)<<1))
+#define MIS_IC4_ENABLE_STATUS_slv_disabled_whi_src(data)                             ((0x00000002&(data))>>1)
+#define MIS_IC4_ENABLE_STATUS_get_slv_disabled_whi(data)                             ((0x00000002&(data))>>1)
+#define MIS_IC4_ENABLE_STATUS_ic_en_shift                                            (0)
+#define MIS_IC4_ENABLE_STATUS_ic_en_mask                                             (0x00000001)
+#define MIS_IC4_ENABLE_STATUS_ic_en(data)                                            (0x00000001&((data)<<0))
+#define MIS_IC4_ENABLE_STATUS_ic_en_src(data)                                        ((0x00000001&(data))>>0)
+#define MIS_IC4_ENABLE_STATUS_get_ic_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define MIS_IC4_COMP_PARAM_1                                                         0x1801BAF4
+#define MIS_IC4_COMP_PARAM_1_reg_addr                                                "0xB801BAF4"
+#define MIS_IC4_COMP_PARAM_1_reg                                                     0xB801BAF4
+#define set_MIS_IC4_COMP_PARAM_1_reg(data)   (*((volatile unsigned int*) MIS_IC4_COMP_PARAM_1_reg)=data)
+#define get_MIS_IC4_COMP_PARAM_1_reg   (*((volatile unsigned int*) MIS_IC4_COMP_PARAM_1_reg))
+#define MIS_IC4_COMP_PARAM_1_inst_adr                                                "0x00BD"
+#define MIS_IC4_COMP_PARAM_1_inst                                                    0x00BD
+#define MIS_IC4_COMP_PARAM_1_tx_buffer_depth_shift                                   (16)
+#define MIS_IC4_COMP_PARAM_1_tx_buffer_depth_mask                                    (0x00FF0000)
+#define MIS_IC4_COMP_PARAM_1_tx_buffer_depth(data)                                   (0x00FF0000&((data)<<16))
+#define MIS_IC4_COMP_PARAM_1_tx_buffer_depth_src(data)                               ((0x00FF0000&(data))>>16)
+#define MIS_IC4_COMP_PARAM_1_get_tx_buffer_depth(data)                               ((0x00FF0000&(data))>>16)
+#define MIS_IC4_COMP_PARAM_1_rx_buffer_depth_shift                                   (8)
+#define MIS_IC4_COMP_PARAM_1_rx_buffer_depth_mask                                    (0x0000FF00)
+#define MIS_IC4_COMP_PARAM_1_rx_buffer_depth(data)                                   (0x0000FF00&((data)<<8))
+#define MIS_IC4_COMP_PARAM_1_rx_buffer_depth_src(data)                               ((0x0000FF00&(data))>>8)
+#define MIS_IC4_COMP_PARAM_1_get_rx_buffer_depth(data)                               ((0x0000FF00&(data))>>8)
+#define MIS_IC4_COMP_PARAM_1_add_encoded_params_shift                                (7)
+#define MIS_IC4_COMP_PARAM_1_add_encoded_params_mask                                 (0x00000080)
+#define MIS_IC4_COMP_PARAM_1_add_encoded_params(data)                                (0x00000080&((data)<<7))
+#define MIS_IC4_COMP_PARAM_1_add_encoded_params_src(data)                            ((0x00000080&(data))>>7)
+#define MIS_IC4_COMP_PARAM_1_get_add_encoded_params(data)                            ((0x00000080&(data))>>7)
+#define MIS_IC4_COMP_PARAM_1_has_dma_shift                                           (6)
+#define MIS_IC4_COMP_PARAM_1_has_dma_mask                                            (0x00000040)
+#define MIS_IC4_COMP_PARAM_1_has_dma(data)                                           (0x00000040&((data)<<6))
+#define MIS_IC4_COMP_PARAM_1_has_dma_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC4_COMP_PARAM_1_get_has_dma(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC4_COMP_PARAM_1_intr_io_shift                                           (5)
+#define MIS_IC4_COMP_PARAM_1_intr_io_mask                                            (0x00000020)
+#define MIS_IC4_COMP_PARAM_1_intr_io(data)                                           (0x00000020&((data)<<5))
+#define MIS_IC4_COMP_PARAM_1_intr_io_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC4_COMP_PARAM_1_get_intr_io(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC4_COMP_PARAM_1_hc_count_values_shift                                   (4)
+#define MIS_IC4_COMP_PARAM_1_hc_count_values_mask                                    (0x00000010)
+#define MIS_IC4_COMP_PARAM_1_hc_count_values(data)                                   (0x00000010&((data)<<4))
+#define MIS_IC4_COMP_PARAM_1_hc_count_values_src(data)                               ((0x00000010&(data))>>4)
+#define MIS_IC4_COMP_PARAM_1_get_hc_count_values(data)                               ((0x00000010&(data))>>4)
+#define MIS_IC4_COMP_PARAM_1_max_speed_mode_shift                                    (2)
+#define MIS_IC4_COMP_PARAM_1_max_speed_mode_mask                                     (0x0000000C)
+#define MIS_IC4_COMP_PARAM_1_max_speed_mode(data)                                    (0x0000000C&((data)<<2))
+#define MIS_IC4_COMP_PARAM_1_max_speed_mode_src(data)                                ((0x0000000C&(data))>>2)
+#define MIS_IC4_COMP_PARAM_1_get_max_speed_mode(data)                                ((0x0000000C&(data))>>2)
+#define MIS_IC4_COMP_PARAM_1_apb_data_width_shift                                    (0)
+#define MIS_IC4_COMP_PARAM_1_apb_data_width_mask                                     (0x00000003)
+#define MIS_IC4_COMP_PARAM_1_apb_data_width(data)                                    (0x00000003&((data)<<0))
+#define MIS_IC4_COMP_PARAM_1_apb_data_width_src(data)                                ((0x00000003&(data))>>0)
+#define MIS_IC4_COMP_PARAM_1_get_apb_data_width(data)                                ((0x00000003&(data))>>0)
+
+
+#define MIS_IC4_COMP_VERSION                                                         0x1801BAF8
+#define MIS_IC4_COMP_VERSION_reg_addr                                                "0xB801BAF8"
+#define MIS_IC4_COMP_VERSION_reg                                                     0xB801BAF8
+#define set_MIS_IC4_COMP_VERSION_reg(data)   (*((volatile unsigned int*) MIS_IC4_COMP_VERSION_reg)=data)
+#define get_MIS_IC4_COMP_VERSION_reg   (*((volatile unsigned int*) MIS_IC4_COMP_VERSION_reg))
+#define MIS_IC4_COMP_VERSION_inst_adr                                                "0x00BE"
+#define MIS_IC4_COMP_VERSION_inst                                                    0x00BE
+#define MIS_IC4_COMP_VERSION_ic_comp_version_shift                                   (0)
+#define MIS_IC4_COMP_VERSION_ic_comp_version_mask                                    (0xFFFFFFFF)
+#define MIS_IC4_COMP_VERSION_ic_comp_version(data)                                   (0xFFFFFFFF&((data)<<0))
+#define MIS_IC4_COMP_VERSION_ic_comp_version_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define MIS_IC4_COMP_VERSION_get_ic_comp_version(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_IC4_COMP_TYPE                                                            0x1801BAFC
+#define MIS_IC4_COMP_TYPE_reg_addr                                                   "0xB801BAFC"
+#define MIS_IC4_COMP_TYPE_reg                                                        0xB801BAFC
+#define set_MIS_IC4_COMP_TYPE_reg(data)   (*((volatile unsigned int*) MIS_IC4_COMP_TYPE_reg)=data)
+#define get_MIS_IC4_COMP_TYPE_reg   (*((volatile unsigned int*) MIS_IC4_COMP_TYPE_reg))
+#define MIS_IC4_COMP_TYPE_inst_adr                                                   "0x00BF"
+#define MIS_IC4_COMP_TYPE_inst                                                       0x00BF
+#define MIS_IC4_COMP_TYPE_ic_comp_type_shift                                         (0)
+#define MIS_IC4_COMP_TYPE_ic_comp_type_mask                                          (0xFFFFFFFF)
+#define MIS_IC4_COMP_TYPE_ic_comp_type(data)                                         (0xFFFFFFFF&((data)<<0))
+#define MIS_IC4_COMP_TYPE_ic_comp_type_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define MIS_IC4_COMP_TYPE_get_ic_comp_type(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_IC5_CON                                                                  0x1801BB00
+#define MIS_IC5_CON_reg_addr                                                         "0xB801BB00"
+#define MIS_IC5_CON_reg                                                              0xB801BB00
+#define set_MIS_IC5_CON_reg(data)   (*((volatile unsigned int*) MIS_IC5_CON_reg)=data)
+#define get_MIS_IC5_CON_reg   (*((volatile unsigned int*) MIS_IC5_CON_reg))
+#define MIS_IC5_CON_inst_adr                                                         "0x00C0"
+#define MIS_IC5_CON_inst                                                             0x00C0
+#define MIS_IC5_CON_ic_slave_disable_shift                                           (6)
+#define MIS_IC5_CON_ic_slave_disable_mask                                            (0x00000040)
+#define MIS_IC5_CON_ic_slave_disable(data)                                           (0x00000040&((data)<<6))
+#define MIS_IC5_CON_ic_slave_disable_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC5_CON_get_ic_slave_disable(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC5_CON_ic_restart_en_shift                                              (5)
+#define MIS_IC5_CON_ic_restart_en_mask                                               (0x00000020)
+#define MIS_IC5_CON_ic_restart_en(data)                                              (0x00000020&((data)<<5))
+#define MIS_IC5_CON_ic_restart_en_src(data)                                          ((0x00000020&(data))>>5)
+#define MIS_IC5_CON_get_ic_restart_en(data)                                          ((0x00000020&(data))>>5)
+#define MIS_IC5_CON_ic_10bitaddr_master_shift                                        (4)
+#define MIS_IC5_CON_ic_10bitaddr_master_mask                                         (0x00000010)
+#define MIS_IC5_CON_ic_10bitaddr_master(data)                                        (0x00000010&((data)<<4))
+#define MIS_IC5_CON_ic_10bitaddr_master_src(data)                                    ((0x00000010&(data))>>4)
+#define MIS_IC5_CON_get_ic_10bitaddr_master(data)                                    ((0x00000010&(data))>>4)
+#define MIS_IC5_CON_ic_10bitaddr_slave_shift                                         (3)
+#define MIS_IC5_CON_ic_10bitaddr_slave_mask                                          (0x00000008)
+#define MIS_IC5_CON_ic_10bitaddr_slave(data)                                         (0x00000008&((data)<<3))
+#define MIS_IC5_CON_ic_10bitaddr_slave_src(data)                                     ((0x00000008&(data))>>3)
+#define MIS_IC5_CON_get_ic_10bitaddr_slave(data)                                     ((0x00000008&(data))>>3)
+#define MIS_IC5_CON_speed_shift                                                      (1)
+#define MIS_IC5_CON_speed_mask                                                       (0x00000006)
+#define MIS_IC5_CON_speed(data)                                                      (0x00000006&((data)<<1))
+#define MIS_IC5_CON_speed_src(data)                                                  ((0x00000006&(data))>>1)
+#define MIS_IC5_CON_get_speed(data)                                                  ((0x00000006&(data))>>1)
+#define MIS_IC5_CON_master_mode_shift                                                (0)
+#define MIS_IC5_CON_master_mode_mask                                                 (0x00000001)
+#define MIS_IC5_CON_master_mode(data)                                                (0x00000001&((data)<<0))
+#define MIS_IC5_CON_master_mode_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_IC5_CON_get_master_mode(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_TAR                                                                  0x1801BB04
+#define MIS_IC5_TAR_reg_addr                                                         "0xB801BB04"
+#define MIS_IC5_TAR_reg                                                              0xB801BB04
+#define set_MIS_IC5_TAR_reg(data)   (*((volatile unsigned int*) MIS_IC5_TAR_reg)=data)
+#define get_MIS_IC5_TAR_reg   (*((volatile unsigned int*) MIS_IC5_TAR_reg))
+#define MIS_IC5_TAR_inst_adr                                                         "0x00C1"
+#define MIS_IC5_TAR_inst                                                             0x00C1
+#define MIS_IC5_TAR_ic_10bitaddr_master_shift                                        (12)
+#define MIS_IC5_TAR_ic_10bitaddr_master_mask                                         (0x00001000)
+#define MIS_IC5_TAR_ic_10bitaddr_master(data)                                        (0x00001000&((data)<<12))
+#define MIS_IC5_TAR_ic_10bitaddr_master_src(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC5_TAR_get_ic_10bitaddr_master(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC5_TAR_special_shift                                                    (11)
+#define MIS_IC5_TAR_special_mask                                                     (0x00000800)
+#define MIS_IC5_TAR_special(data)                                                    (0x00000800&((data)<<11))
+#define MIS_IC5_TAR_special_src(data)                                                ((0x00000800&(data))>>11)
+#define MIS_IC5_TAR_get_special(data)                                                ((0x00000800&(data))>>11)
+#define MIS_IC5_TAR_gc_or_start_shift                                                (10)
+#define MIS_IC5_TAR_gc_or_start_mask                                                 (0x00000400)
+#define MIS_IC5_TAR_gc_or_start(data)                                                (0x00000400&((data)<<10))
+#define MIS_IC5_TAR_gc_or_start_src(data)                                            ((0x00000400&(data))>>10)
+#define MIS_IC5_TAR_get_gc_or_start(data)                                            ((0x00000400&(data))>>10)
+#define MIS_IC5_TAR_ic_tar_shift                                                     (0)
+#define MIS_IC5_TAR_ic_tar_mask                                                      (0x000003FF)
+#define MIS_IC5_TAR_ic_tar(data)                                                     (0x000003FF&((data)<<0))
+#define MIS_IC5_TAR_ic_tar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define MIS_IC5_TAR_get_ic_tar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define MIS_IC5_SAR                                                                  0x1801BB08
+#define MIS_IC5_SAR_reg_addr                                                         "0xB801BB08"
+#define MIS_IC5_SAR_reg                                                              0xB801BB08
+#define set_MIS_IC5_SAR_reg(data)   (*((volatile unsigned int*) MIS_IC5_SAR_reg)=data)
+#define get_MIS_IC5_SAR_reg   (*((volatile unsigned int*) MIS_IC5_SAR_reg))
+#define MIS_IC5_SAR_inst_adr                                                         "0x00C2"
+#define MIS_IC5_SAR_inst                                                             0x00C2
+#define MIS_IC5_SAR_ic_sar_shift                                                     (0)
+#define MIS_IC5_SAR_ic_sar_mask                                                      (0x000003FF)
+#define MIS_IC5_SAR_ic_sar(data)                                                     (0x000003FF&((data)<<0))
+#define MIS_IC5_SAR_ic_sar_src(data)                                                 ((0x000003FF&(data))>>0)
+#define MIS_IC5_SAR_get_ic_sar(data)                                                 ((0x000003FF&(data))>>0)
+
+
+#define MIS_IC5_HS_MADDR                                                             0x1801BB0C
+#define MIS_IC5_HS_MADDR_reg_addr                                                    "0xB801BB0C"
+#define MIS_IC5_HS_MADDR_reg                                                         0xB801BB0C
+#define set_MIS_IC5_HS_MADDR_reg(data)   (*((volatile unsigned int*) MIS_IC5_HS_MADDR_reg)=data)
+#define get_MIS_IC5_HS_MADDR_reg   (*((volatile unsigned int*) MIS_IC5_HS_MADDR_reg))
+#define MIS_IC5_HS_MADDR_inst_adr                                                    "0x00C3"
+#define MIS_IC5_HS_MADDR_inst                                                        0x00C3
+#define MIS_IC5_HS_MADDR_ic_hs_mar_shift                                             (0)
+#define MIS_IC5_HS_MADDR_ic_hs_mar_mask                                              (0x00000007)
+#define MIS_IC5_HS_MADDR_ic_hs_mar(data)                                             (0x00000007&((data)<<0))
+#define MIS_IC5_HS_MADDR_ic_hs_mar_src(data)                                         ((0x00000007&(data))>>0)
+#define MIS_IC5_HS_MADDR_get_ic_hs_mar(data)                                         ((0x00000007&(data))>>0)
+
+
+#define MIS_IC5_DATA_CMD                                                             0x1801BB10
+#define MIS_IC5_DATA_CMD_reg_addr                                                    "0xB801BB10"
+#define MIS_IC5_DATA_CMD_reg                                                         0xB801BB10
+#define set_MIS_IC5_DATA_CMD_reg(data)   (*((volatile unsigned int*) MIS_IC5_DATA_CMD_reg)=data)
+#define get_MIS_IC5_DATA_CMD_reg   (*((volatile unsigned int*) MIS_IC5_DATA_CMD_reg))
+#define MIS_IC5_DATA_CMD_inst_adr                                                    "0x00C4"
+#define MIS_IC5_DATA_CMD_inst                                                        0x00C4
+#define MIS_IC5_DATA_CMD_restart_shift                                               (10)
+#define MIS_IC5_DATA_CMD_restart_mask                                                (0x00000400)
+#define MIS_IC5_DATA_CMD_restart(data)                                               (0x00000400&((data)<<10))
+#define MIS_IC5_DATA_CMD_restart_src(data)                                           ((0x00000400&(data))>>10)
+#define MIS_IC5_DATA_CMD_get_restart(data)                                           ((0x00000400&(data))>>10)
+#define MIS_IC5_DATA_CMD_stop_shift                                                  (9)
+#define MIS_IC5_DATA_CMD_stop_mask                                                   (0x00000200)
+#define MIS_IC5_DATA_CMD_stop(data)                                                  (0x00000200&((data)<<9))
+#define MIS_IC5_DATA_CMD_stop_src(data)                                              ((0x00000200&(data))>>9)
+#define MIS_IC5_DATA_CMD_get_stop(data)                                              ((0x00000200&(data))>>9)
+#define MIS_IC5_DATA_CMD_cmd_shift                                                   (8)
+#define MIS_IC5_DATA_CMD_cmd_mask                                                    (0x00000100)
+#define MIS_IC5_DATA_CMD_cmd(data)                                                   (0x00000100&((data)<<8))
+#define MIS_IC5_DATA_CMD_cmd_src(data)                                               ((0x00000100&(data))>>8)
+#define MIS_IC5_DATA_CMD_get_cmd(data)                                               ((0x00000100&(data))>>8)
+#define MIS_IC5_DATA_CMD_dat_shift                                                   (0)
+#define MIS_IC5_DATA_CMD_dat_mask                                                    (0x000000FF)
+#define MIS_IC5_DATA_CMD_dat(data)                                                   (0x000000FF&((data)<<0))
+#define MIS_IC5_DATA_CMD_dat_src(data)                                               ((0x000000FF&(data))>>0)
+#define MIS_IC5_DATA_CMD_get_dat(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC5_SS_SCL_HCNT                                                          0x1801BB14
+#define MIS_IC5_SS_SCL_HCNT_reg_addr                                                 "0xB801BB14"
+#define MIS_IC5_SS_SCL_HCNT_reg                                                      0xB801BB14
+#define set_MIS_IC5_SS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) MIS_IC5_SS_SCL_HCNT_reg)=data)
+#define get_MIS_IC5_SS_SCL_HCNT_reg   (*((volatile unsigned int*) MIS_IC5_SS_SCL_HCNT_reg))
+#define MIS_IC5_SS_SCL_HCNT_inst_adr                                                 "0x00C5"
+#define MIS_IC5_SS_SCL_HCNT_inst                                                     0x00C5
+#define MIS_IC5_SS_SCL_HCNT_ic_ss_scl_hcnt_shift                                     (0)
+#define MIS_IC5_SS_SCL_HCNT_ic_ss_scl_hcnt_mask                                      (0x0000FFFF)
+#define MIS_IC5_SS_SCL_HCNT_ic_ss_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC5_SS_SCL_HCNT_ic_ss_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC5_SS_SCL_HCNT_get_ic_ss_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC5_SS_SCL_LCNT                                                          0x1801BB18
+#define MIS_IC5_SS_SCL_LCNT_reg_addr                                                 "0xB801BB18"
+#define MIS_IC5_SS_SCL_LCNT_reg                                                      0xB801BB18
+#define set_MIS_IC5_SS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) MIS_IC5_SS_SCL_LCNT_reg)=data)
+#define get_MIS_IC5_SS_SCL_LCNT_reg   (*((volatile unsigned int*) MIS_IC5_SS_SCL_LCNT_reg))
+#define MIS_IC5_SS_SCL_LCNT_inst_adr                                                 "0x00C6"
+#define MIS_IC5_SS_SCL_LCNT_inst                                                     0x00C6
+#define MIS_IC5_SS_SCL_LCNT_ic_ss_scl_lcnt_shift                                     (0)
+#define MIS_IC5_SS_SCL_LCNT_ic_ss_scl_lcnt_mask                                      (0x0000FFFF)
+#define MIS_IC5_SS_SCL_LCNT_ic_ss_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC5_SS_SCL_LCNT_ic_ss_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC5_SS_SCL_LCNT_get_ic_ss_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC5_FS_SCL_HCNT                                                          0x1801BB1C
+#define MIS_IC5_FS_SCL_HCNT_reg_addr                                                 "0xB801BB1C"
+#define MIS_IC5_FS_SCL_HCNT_reg                                                      0xB801BB1C
+#define set_MIS_IC5_FS_SCL_HCNT_reg(data)   (*((volatile unsigned int*) MIS_IC5_FS_SCL_HCNT_reg)=data)
+#define get_MIS_IC5_FS_SCL_HCNT_reg   (*((volatile unsigned int*) MIS_IC5_FS_SCL_HCNT_reg))
+#define MIS_IC5_FS_SCL_HCNT_inst_adr                                                 "0x00C7"
+#define MIS_IC5_FS_SCL_HCNT_inst                                                     0x00C7
+#define MIS_IC5_FS_SCL_HCNT_ic_fs_scl_hcnt_shift                                     (0)
+#define MIS_IC5_FS_SCL_HCNT_ic_fs_scl_hcnt_mask                                      (0x0000FFFF)
+#define MIS_IC5_FS_SCL_HCNT_ic_fs_scl_hcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC5_FS_SCL_HCNT_ic_fs_scl_hcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC5_FS_SCL_HCNT_get_ic_fs_scl_hcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC5_FS_SCL_LCNT                                                          0x1801BB20
+#define MIS_IC5_FS_SCL_LCNT_reg_addr                                                 "0xB801BB20"
+#define MIS_IC5_FS_SCL_LCNT_reg                                                      0xB801BB20
+#define set_MIS_IC5_FS_SCL_LCNT_reg(data)   (*((volatile unsigned int*) MIS_IC5_FS_SCL_LCNT_reg)=data)
+#define get_MIS_IC5_FS_SCL_LCNT_reg   (*((volatile unsigned int*) MIS_IC5_FS_SCL_LCNT_reg))
+#define MIS_IC5_FS_SCL_LCNT_inst_adr                                                 "0x00C8"
+#define MIS_IC5_FS_SCL_LCNT_inst                                                     0x00C8
+#define MIS_IC5_FS_SCL_LCNT_ic_fs_scl_lcnt_shift                                     (0)
+#define MIS_IC5_FS_SCL_LCNT_ic_fs_scl_lcnt_mask                                      (0x0000FFFF)
+#define MIS_IC5_FS_SCL_LCNT_ic_fs_scl_lcnt(data)                                     (0x0000FFFF&((data)<<0))
+#define MIS_IC5_FS_SCL_LCNT_ic_fs_scl_lcnt_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define MIS_IC5_FS_SCL_LCNT_get_ic_fs_scl_lcnt(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC5_INTR_STAT                                                            0x1801BB2C
+#define MIS_IC5_INTR_STAT_reg_addr                                                   "0xB801BB2C"
+#define MIS_IC5_INTR_STAT_reg                                                        0xB801BB2C
+#define set_MIS_IC5_INTR_STAT_reg(data)   (*((volatile unsigned int*) MIS_IC5_INTR_STAT_reg)=data)
+#define get_MIS_IC5_INTR_STAT_reg   (*((volatile unsigned int*) MIS_IC5_INTR_STAT_reg))
+#define MIS_IC5_INTR_STAT_inst_adr                                                   "0x00CB"
+#define MIS_IC5_INTR_STAT_inst                                                       0x00CB
+#define MIS_IC5_INTR_STAT_r_gen_call_shift                                           (11)
+#define MIS_IC5_INTR_STAT_r_gen_call_mask                                            (0x00000800)
+#define MIS_IC5_INTR_STAT_r_gen_call(data)                                           (0x00000800&((data)<<11))
+#define MIS_IC5_INTR_STAT_r_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC5_INTR_STAT_get_r_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC5_INTR_STAT_r_start_det_shift                                          (10)
+#define MIS_IC5_INTR_STAT_r_start_det_mask                                           (0x00000400)
+#define MIS_IC5_INTR_STAT_r_start_det(data)                                          (0x00000400&((data)<<10))
+#define MIS_IC5_INTR_STAT_r_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC5_INTR_STAT_get_r_start_det(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC5_INTR_STAT_r_stop_det_shift                                           (9)
+#define MIS_IC5_INTR_STAT_r_stop_det_mask                                            (0x00000200)
+#define MIS_IC5_INTR_STAT_r_stop_det(data)                                           (0x00000200&((data)<<9))
+#define MIS_IC5_INTR_STAT_r_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC5_INTR_STAT_get_r_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC5_INTR_STAT_r_activity_shift                                           (8)
+#define MIS_IC5_INTR_STAT_r_activity_mask                                            (0x00000100)
+#define MIS_IC5_INTR_STAT_r_activity(data)                                           (0x00000100&((data)<<8))
+#define MIS_IC5_INTR_STAT_r_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC5_INTR_STAT_get_r_activity(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC5_INTR_STAT_r_rx_done_shift                                            (7)
+#define MIS_IC5_INTR_STAT_r_rx_done_mask                                             (0x00000080)
+#define MIS_IC5_INTR_STAT_r_rx_done(data)                                            (0x00000080&((data)<<7))
+#define MIS_IC5_INTR_STAT_r_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC5_INTR_STAT_get_r_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC5_INTR_STAT_r_tx_abrt_shift                                            (6)
+#define MIS_IC5_INTR_STAT_r_tx_abrt_mask                                             (0x00000040)
+#define MIS_IC5_INTR_STAT_r_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC5_INTR_STAT_r_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC5_INTR_STAT_get_r_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC5_INTR_STAT_r_rd_req_shift                                             (5)
+#define MIS_IC5_INTR_STAT_r_rd_req_mask                                              (0x00000020)
+#define MIS_IC5_INTR_STAT_r_rd_req(data)                                             (0x00000020&((data)<<5))
+#define MIS_IC5_INTR_STAT_r_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC5_INTR_STAT_get_r_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC5_INTR_STAT_r_tx_empty_shift                                           (4)
+#define MIS_IC5_INTR_STAT_r_tx_empty_mask                                            (0x00000010)
+#define MIS_IC5_INTR_STAT_r_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define MIS_IC5_INTR_STAT_r_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC5_INTR_STAT_get_r_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC5_INTR_STAT_r_tx_over_shift                                            (3)
+#define MIS_IC5_INTR_STAT_r_tx_over_mask                                             (0x00000008)
+#define MIS_IC5_INTR_STAT_r_tx_over(data)                                            (0x00000008&((data)<<3))
+#define MIS_IC5_INTR_STAT_r_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC5_INTR_STAT_get_r_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC5_INTR_STAT_r_rx_full_shift                                            (2)
+#define MIS_IC5_INTR_STAT_r_rx_full_mask                                             (0x00000004)
+#define MIS_IC5_INTR_STAT_r_rx_full(data)                                            (0x00000004&((data)<<2))
+#define MIS_IC5_INTR_STAT_r_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC5_INTR_STAT_get_r_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC5_INTR_STAT_r_rx_over_shift                                            (1)
+#define MIS_IC5_INTR_STAT_r_rx_over_mask                                             (0x00000002)
+#define MIS_IC5_INTR_STAT_r_rx_over(data)                                            (0x00000002&((data)<<1))
+#define MIS_IC5_INTR_STAT_r_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC5_INTR_STAT_get_r_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC5_INTR_STAT_r_rx_under_shift                                           (0)
+#define MIS_IC5_INTR_STAT_r_rx_under_mask                                            (0x00000001)
+#define MIS_IC5_INTR_STAT_r_rx_under(data)                                           (0x00000001&((data)<<0))
+#define MIS_IC5_INTR_STAT_r_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_IC5_INTR_STAT_get_r_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_INTR_MASK                                                            0x1801BB30
+#define MIS_IC5_INTR_MASK_reg_addr                                                   "0xB801BB30"
+#define MIS_IC5_INTR_MASK_reg                                                        0xB801BB30
+#define set_MIS_IC5_INTR_MASK_reg(data)   (*((volatile unsigned int*) MIS_IC5_INTR_MASK_reg)=data)
+#define get_MIS_IC5_INTR_MASK_reg   (*((volatile unsigned int*) MIS_IC5_INTR_MASK_reg))
+#define MIS_IC5_INTR_MASK_inst_adr                                                   "0x00CC"
+#define MIS_IC5_INTR_MASK_inst                                                       0x00CC
+#define MIS_IC5_INTR_MASK_m_gen_call_shift                                           (11)
+#define MIS_IC5_INTR_MASK_m_gen_call_mask                                            (0x00000800)
+#define MIS_IC5_INTR_MASK_m_gen_call(data)                                           (0x00000800&((data)<<11))
+#define MIS_IC5_INTR_MASK_m_gen_call_src(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC5_INTR_MASK_get_m_gen_call(data)                                       ((0x00000800&(data))>>11)
+#define MIS_IC5_INTR_MASK_m_start_det_shift                                          (10)
+#define MIS_IC5_INTR_MASK_m_start_det_mask                                           (0x00000400)
+#define MIS_IC5_INTR_MASK_m_start_det(data)                                          (0x00000400&((data)<<10))
+#define MIS_IC5_INTR_MASK_m_start_det_src(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC5_INTR_MASK_get_m_start_det(data)                                      ((0x00000400&(data))>>10)
+#define MIS_IC5_INTR_MASK_m_stop_det_shift                                           (9)
+#define MIS_IC5_INTR_MASK_m_stop_det_mask                                            (0x00000200)
+#define MIS_IC5_INTR_MASK_m_stop_det(data)                                           (0x00000200&((data)<<9))
+#define MIS_IC5_INTR_MASK_m_stop_det_src(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC5_INTR_MASK_get_m_stop_det(data)                                       ((0x00000200&(data))>>9)
+#define MIS_IC5_INTR_MASK_m_activity_shift                                           (8)
+#define MIS_IC5_INTR_MASK_m_activity_mask                                            (0x00000100)
+#define MIS_IC5_INTR_MASK_m_activity(data)                                           (0x00000100&((data)<<8))
+#define MIS_IC5_INTR_MASK_m_activity_src(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC5_INTR_MASK_get_m_activity(data)                                       ((0x00000100&(data))>>8)
+#define MIS_IC5_INTR_MASK_m_rx_done_shift                                            (7)
+#define MIS_IC5_INTR_MASK_m_rx_done_mask                                             (0x00000080)
+#define MIS_IC5_INTR_MASK_m_rx_done(data)                                            (0x00000080&((data)<<7))
+#define MIS_IC5_INTR_MASK_m_rx_done_src(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC5_INTR_MASK_get_m_rx_done(data)                                        ((0x00000080&(data))>>7)
+#define MIS_IC5_INTR_MASK_m_tx_abrt_shift                                            (6)
+#define MIS_IC5_INTR_MASK_m_tx_abrt_mask                                             (0x00000040)
+#define MIS_IC5_INTR_MASK_m_tx_abrt(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC5_INTR_MASK_m_tx_abrt_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC5_INTR_MASK_get_m_tx_abrt(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC5_INTR_MASK_m_rd_req_shift                                             (5)
+#define MIS_IC5_INTR_MASK_m_rd_req_mask                                              (0x00000020)
+#define MIS_IC5_INTR_MASK_m_rd_req(data)                                             (0x00000020&((data)<<5))
+#define MIS_IC5_INTR_MASK_m_rd_req_src(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC5_INTR_MASK_get_m_rd_req(data)                                         ((0x00000020&(data))>>5)
+#define MIS_IC5_INTR_MASK_m_tx_empty_shift                                           (4)
+#define MIS_IC5_INTR_MASK_m_tx_empty_mask                                            (0x00000010)
+#define MIS_IC5_INTR_MASK_m_tx_empty(data)                                           (0x00000010&((data)<<4))
+#define MIS_IC5_INTR_MASK_m_tx_empty_src(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC5_INTR_MASK_get_m_tx_empty(data)                                       ((0x00000010&(data))>>4)
+#define MIS_IC5_INTR_MASK_m_tx_over_shift                                            (3)
+#define MIS_IC5_INTR_MASK_m_tx_over_mask                                             (0x00000008)
+#define MIS_IC5_INTR_MASK_m_tx_over(data)                                            (0x00000008&((data)<<3))
+#define MIS_IC5_INTR_MASK_m_tx_over_src(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC5_INTR_MASK_get_m_tx_over(data)                                        ((0x00000008&(data))>>3)
+#define MIS_IC5_INTR_MASK_m_rx_full_shift                                            (2)
+#define MIS_IC5_INTR_MASK_m_rx_full_mask                                             (0x00000004)
+#define MIS_IC5_INTR_MASK_m_rx_full(data)                                            (0x00000004&((data)<<2))
+#define MIS_IC5_INTR_MASK_m_rx_full_src(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC5_INTR_MASK_get_m_rx_full(data)                                        ((0x00000004&(data))>>2)
+#define MIS_IC5_INTR_MASK_m_rx_over_shift                                            (1)
+#define MIS_IC5_INTR_MASK_m_rx_over_mask                                             (0x00000002)
+#define MIS_IC5_INTR_MASK_m_rx_over(data)                                            (0x00000002&((data)<<1))
+#define MIS_IC5_INTR_MASK_m_rx_over_src(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC5_INTR_MASK_get_m_rx_over(data)                                        ((0x00000002&(data))>>1)
+#define MIS_IC5_INTR_MASK_m_rx_under_shift                                           (0)
+#define MIS_IC5_INTR_MASK_m_rx_under_mask                                            (0x00000001)
+#define MIS_IC5_INTR_MASK_m_rx_under(data)                                           (0x00000001&((data)<<0))
+#define MIS_IC5_INTR_MASK_m_rx_under_src(data)                                       ((0x00000001&(data))>>0)
+#define MIS_IC5_INTR_MASK_get_m_rx_under(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_RAW_INTR_STAT                                                        0x1801BB34
+#define MIS_IC5_RAW_INTR_STAT_reg_addr                                               "0xB801BB34"
+#define MIS_IC5_RAW_INTR_STAT_reg                                                    0xB801BB34
+#define set_MIS_IC5_RAW_INTR_STAT_reg(data)   (*((volatile unsigned int*) MIS_IC5_RAW_INTR_STAT_reg)=data)
+#define get_MIS_IC5_RAW_INTR_STAT_reg   (*((volatile unsigned int*) MIS_IC5_RAW_INTR_STAT_reg))
+#define MIS_IC5_RAW_INTR_STAT_inst_adr                                               "0x00CD"
+#define MIS_IC5_RAW_INTR_STAT_inst                                                   0x00CD
+#define MIS_IC5_RAW_INTR_STAT_gen_call_shift                                         (11)
+#define MIS_IC5_RAW_INTR_STAT_gen_call_mask                                          (0x00000800)
+#define MIS_IC5_RAW_INTR_STAT_gen_call(data)                                         (0x00000800&((data)<<11))
+#define MIS_IC5_RAW_INTR_STAT_gen_call_src(data)                                     ((0x00000800&(data))>>11)
+#define MIS_IC5_RAW_INTR_STAT_get_gen_call(data)                                     ((0x00000800&(data))>>11)
+#define MIS_IC5_RAW_INTR_STAT_start_det_shift                                        (10)
+#define MIS_IC5_RAW_INTR_STAT_start_det_mask                                         (0x00000400)
+#define MIS_IC5_RAW_INTR_STAT_start_det(data)                                        (0x00000400&((data)<<10))
+#define MIS_IC5_RAW_INTR_STAT_start_det_src(data)                                    ((0x00000400&(data))>>10)
+#define MIS_IC5_RAW_INTR_STAT_get_start_det(data)                                    ((0x00000400&(data))>>10)
+#define MIS_IC5_RAW_INTR_STAT_stop_det_shift                                         (9)
+#define MIS_IC5_RAW_INTR_STAT_stop_det_mask                                          (0x00000200)
+#define MIS_IC5_RAW_INTR_STAT_stop_det(data)                                         (0x00000200&((data)<<9))
+#define MIS_IC5_RAW_INTR_STAT_stop_det_src(data)                                     ((0x00000200&(data))>>9)
+#define MIS_IC5_RAW_INTR_STAT_get_stop_det(data)                                     ((0x00000200&(data))>>9)
+#define MIS_IC5_RAW_INTR_STAT_activity_shift                                         (8)
+#define MIS_IC5_RAW_INTR_STAT_activity_mask                                          (0x00000100)
+#define MIS_IC5_RAW_INTR_STAT_activity(data)                                         (0x00000100&((data)<<8))
+#define MIS_IC5_RAW_INTR_STAT_activity_src(data)                                     ((0x00000100&(data))>>8)
+#define MIS_IC5_RAW_INTR_STAT_get_activity(data)                                     ((0x00000100&(data))>>8)
+#define MIS_IC5_RAW_INTR_STAT_rx_done_shift                                          (7)
+#define MIS_IC5_RAW_INTR_STAT_rx_done_mask                                           (0x00000080)
+#define MIS_IC5_RAW_INTR_STAT_rx_done(data)                                          (0x00000080&((data)<<7))
+#define MIS_IC5_RAW_INTR_STAT_rx_done_src(data)                                      ((0x00000080&(data))>>7)
+#define MIS_IC5_RAW_INTR_STAT_get_rx_done(data)                                      ((0x00000080&(data))>>7)
+#define MIS_IC5_RAW_INTR_STAT_tx_abrt_shift                                          (6)
+#define MIS_IC5_RAW_INTR_STAT_tx_abrt_mask                                           (0x00000040)
+#define MIS_IC5_RAW_INTR_STAT_tx_abrt(data)                                          (0x00000040&((data)<<6))
+#define MIS_IC5_RAW_INTR_STAT_tx_abrt_src(data)                                      ((0x00000040&(data))>>6)
+#define MIS_IC5_RAW_INTR_STAT_get_tx_abrt(data)                                      ((0x00000040&(data))>>6)
+#define MIS_IC5_RAW_INTR_STAT_rd_req_shift                                           (5)
+#define MIS_IC5_RAW_INTR_STAT_rd_req_mask                                            (0x00000020)
+#define MIS_IC5_RAW_INTR_STAT_rd_req(data)                                           (0x00000020&((data)<<5))
+#define MIS_IC5_RAW_INTR_STAT_rd_req_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC5_RAW_INTR_STAT_get_rd_req(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC5_RAW_INTR_STAT_tx_empty_shift                                         (4)
+#define MIS_IC5_RAW_INTR_STAT_tx_empty_mask                                          (0x00000010)
+#define MIS_IC5_RAW_INTR_STAT_tx_empty(data)                                         (0x00000010&((data)<<4))
+#define MIS_IC5_RAW_INTR_STAT_tx_empty_src(data)                                     ((0x00000010&(data))>>4)
+#define MIS_IC5_RAW_INTR_STAT_get_tx_empty(data)                                     ((0x00000010&(data))>>4)
+#define MIS_IC5_RAW_INTR_STAT_tx_over_shift                                          (3)
+#define MIS_IC5_RAW_INTR_STAT_tx_over_mask                                           (0x00000008)
+#define MIS_IC5_RAW_INTR_STAT_tx_over(data)                                          (0x00000008&((data)<<3))
+#define MIS_IC5_RAW_INTR_STAT_tx_over_src(data)                                      ((0x00000008&(data))>>3)
+#define MIS_IC5_RAW_INTR_STAT_get_tx_over(data)                                      ((0x00000008&(data))>>3)
+#define MIS_IC5_RAW_INTR_STAT_rx_full_shift                                          (2)
+#define MIS_IC5_RAW_INTR_STAT_rx_full_mask                                           (0x00000004)
+#define MIS_IC5_RAW_INTR_STAT_rx_full(data)                                          (0x00000004&((data)<<2))
+#define MIS_IC5_RAW_INTR_STAT_rx_full_src(data)                                      ((0x00000004&(data))>>2)
+#define MIS_IC5_RAW_INTR_STAT_get_rx_full(data)                                      ((0x00000004&(data))>>2)
+#define MIS_IC5_RAW_INTR_STAT_rx_over_shift                                          (1)
+#define MIS_IC5_RAW_INTR_STAT_rx_over_mask                                           (0x00000002)
+#define MIS_IC5_RAW_INTR_STAT_rx_over(data)                                          (0x00000002&((data)<<1))
+#define MIS_IC5_RAW_INTR_STAT_rx_over_src(data)                                      ((0x00000002&(data))>>1)
+#define MIS_IC5_RAW_INTR_STAT_get_rx_over(data)                                      ((0x00000002&(data))>>1)
+#define MIS_IC5_RAW_INTR_STAT_rx_under_shift                                         (0)
+#define MIS_IC5_RAW_INTR_STAT_rx_under_mask                                          (0x00000001)
+#define MIS_IC5_RAW_INTR_STAT_rx_under(data)                                         (0x00000001&((data)<<0))
+#define MIS_IC5_RAW_INTR_STAT_rx_under_src(data)                                     ((0x00000001&(data))>>0)
+#define MIS_IC5_RAW_INTR_STAT_get_rx_under(data)                                     ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_RX_TL                                                                0x1801BB38
+#define MIS_IC5_RX_TL_reg_addr                                                       "0xB801BB38"
+#define MIS_IC5_RX_TL_reg                                                            0xB801BB38
+#define set_MIS_IC5_RX_TL_reg(data)   (*((volatile unsigned int*) MIS_IC5_RX_TL_reg)=data)
+#define get_MIS_IC5_RX_TL_reg   (*((volatile unsigned int*) MIS_IC5_RX_TL_reg))
+#define MIS_IC5_RX_TL_inst_adr                                                       "0x00CE"
+#define MIS_IC5_RX_TL_inst                                                           0x00CE
+#define MIS_IC5_RX_TL_rx_tl_shift                                                    (0)
+#define MIS_IC5_RX_TL_rx_tl_mask                                                     (0x000000FF)
+#define MIS_IC5_RX_TL_rx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define MIS_IC5_RX_TL_rx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define MIS_IC5_RX_TL_get_rx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC5_TX_TL                                                                0x1801BB3C
+#define MIS_IC5_TX_TL_reg_addr                                                       "0xB801BB3C"
+#define MIS_IC5_TX_TL_reg                                                            0xB801BB3C
+#define set_MIS_IC5_TX_TL_reg(data)   (*((volatile unsigned int*) MIS_IC5_TX_TL_reg)=data)
+#define get_MIS_IC5_TX_TL_reg   (*((volatile unsigned int*) MIS_IC5_TX_TL_reg))
+#define MIS_IC5_TX_TL_inst_adr                                                       "0x00CF"
+#define MIS_IC5_TX_TL_inst                                                           0x00CF
+#define MIS_IC5_TX_TL_tx_tl_shift                                                    (0)
+#define MIS_IC5_TX_TL_tx_tl_mask                                                     (0x000000FF)
+#define MIS_IC5_TX_TL_tx_tl(data)                                                    (0x000000FF&((data)<<0))
+#define MIS_IC5_TX_TL_tx_tl_src(data)                                                ((0x000000FF&(data))>>0)
+#define MIS_IC5_TX_TL_get_tx_tl(data)                                                ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC5_CLR_INTR                                                             0x1801BB40
+#define MIS_IC5_CLR_INTR_reg_addr                                                    "0xB801BB40"
+#define MIS_IC5_CLR_INTR_reg                                                         0xB801BB40
+#define set_MIS_IC5_CLR_INTR_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_INTR_reg)=data)
+#define get_MIS_IC5_CLR_INTR_reg   (*((volatile unsigned int*) MIS_IC5_CLR_INTR_reg))
+#define MIS_IC5_CLR_INTR_inst_adr                                                    "0x00D0"
+#define MIS_IC5_CLR_INTR_inst                                                        0x00D0
+#define MIS_IC5_CLR_INTR_clr_intr_shift                                              (0)
+#define MIS_IC5_CLR_INTR_clr_intr_mask                                               (0x00000001)
+#define MIS_IC5_CLR_INTR_clr_intr(data)                                              (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_INTR_clr_intr_src(data)                                          ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_INTR_get_clr_intr(data)                                          ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_CLR_RX_UNDER                                                         0x1801BB44
+#define MIS_IC5_CLR_RX_UNDER_reg_addr                                                "0xB801BB44"
+#define MIS_IC5_CLR_RX_UNDER_reg                                                     0xB801BB44
+#define set_MIS_IC5_CLR_RX_UNDER_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_RX_UNDER_reg)=data)
+#define get_MIS_IC5_CLR_RX_UNDER_reg   (*((volatile unsigned int*) MIS_IC5_CLR_RX_UNDER_reg))
+#define MIS_IC5_CLR_RX_UNDER_inst_adr                                                "0x00D1"
+#define MIS_IC5_CLR_RX_UNDER_inst                                                    0x00D1
+#define MIS_IC5_CLR_RX_UNDER_clr_rx_under_shift                                      (0)
+#define MIS_IC5_CLR_RX_UNDER_clr_rx_under_mask                                       (0x00000001)
+#define MIS_IC5_CLR_RX_UNDER_clr_rx_under(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_RX_UNDER_clr_rx_under_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_RX_UNDER_get_clr_rx_under(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_CLR_RX_OVER                                                          0x1801BB48
+#define MIS_IC5_CLR_RX_OVER_reg_addr                                                 "0xB801BB48"
+#define MIS_IC5_CLR_RX_OVER_reg                                                      0xB801BB48
+#define set_MIS_IC5_CLR_RX_OVER_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_RX_OVER_reg)=data)
+#define get_MIS_IC5_CLR_RX_OVER_reg   (*((volatile unsigned int*) MIS_IC5_CLR_RX_OVER_reg))
+#define MIS_IC5_CLR_RX_OVER_inst_adr                                                 "0x00D2"
+#define MIS_IC5_CLR_RX_OVER_inst                                                     0x00D2
+#define MIS_IC5_CLR_RX_OVER_clr_rx_over_shift                                        (0)
+#define MIS_IC5_CLR_RX_OVER_clr_rx_over_mask                                         (0x00000001)
+#define MIS_IC5_CLR_RX_OVER_clr_rx_over(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_RX_OVER_clr_rx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_RX_OVER_get_clr_rx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_CLR_TX_OVER                                                          0x1801BB4C
+#define MIS_IC5_CLR_TX_OVER_reg_addr                                                 "0xB801BB4C"
+#define MIS_IC5_CLR_TX_OVER_reg                                                      0xB801BB4C
+#define set_MIS_IC5_CLR_TX_OVER_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_TX_OVER_reg)=data)
+#define get_MIS_IC5_CLR_TX_OVER_reg   (*((volatile unsigned int*) MIS_IC5_CLR_TX_OVER_reg))
+#define MIS_IC5_CLR_TX_OVER_inst_adr                                                 "0x00D3"
+#define MIS_IC5_CLR_TX_OVER_inst                                                     0x00D3
+#define MIS_IC5_CLR_TX_OVER_clr_tx_over_shift                                        (0)
+#define MIS_IC5_CLR_TX_OVER_clr_tx_over_mask                                         (0x00000001)
+#define MIS_IC5_CLR_TX_OVER_clr_tx_over(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_TX_OVER_clr_tx_over_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_TX_OVER_get_clr_tx_over(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_CLR_RD_REQ                                                           0x1801BB50
+#define MIS_IC5_CLR_RD_REQ_reg_addr                                                  "0xB801BB50"
+#define MIS_IC5_CLR_RD_REQ_reg                                                       0xB801BB50
+#define set_MIS_IC5_CLR_RD_REQ_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_RD_REQ_reg)=data)
+#define get_MIS_IC5_CLR_RD_REQ_reg   (*((volatile unsigned int*) MIS_IC5_CLR_RD_REQ_reg))
+#define MIS_IC5_CLR_RD_REQ_inst_adr                                                  "0x00D4"
+#define MIS_IC5_CLR_RD_REQ_inst                                                      0x00D4
+#define MIS_IC5_CLR_RD_REQ_clr_rd_req_shift                                          (0)
+#define MIS_IC5_CLR_RD_REQ_clr_rd_req_mask                                           (0x00000001)
+#define MIS_IC5_CLR_RD_REQ_clr_rd_req(data)                                          (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_RD_REQ_clr_rd_req_src(data)                                      ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_RD_REQ_get_clr_rd_req(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_CLR_TX_ABRT                                                          0x1801BB54
+#define MIS_IC5_CLR_TX_ABRT_reg_addr                                                 "0xB801BB54"
+#define MIS_IC5_CLR_TX_ABRT_reg                                                      0xB801BB54
+#define set_MIS_IC5_CLR_TX_ABRT_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_TX_ABRT_reg)=data)
+#define get_MIS_IC5_CLR_TX_ABRT_reg   (*((volatile unsigned int*) MIS_IC5_CLR_TX_ABRT_reg))
+#define MIS_IC5_CLR_TX_ABRT_inst_adr                                                 "0x00D5"
+#define MIS_IC5_CLR_TX_ABRT_inst                                                     0x00D5
+#define MIS_IC5_CLR_TX_ABRT_clr_tx_abrt_shift                                        (0)
+#define MIS_IC5_CLR_TX_ABRT_clr_tx_abrt_mask                                         (0x00000001)
+#define MIS_IC5_CLR_TX_ABRT_clr_tx_abrt(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_TX_ABRT_clr_tx_abrt_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_TX_ABRT_get_clr_tx_abrt(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_CLR_RX_DONE                                                          0x1801BB58
+#define MIS_IC5_CLR_RX_DONE_reg_addr                                                 "0xB801BB58"
+#define MIS_IC5_CLR_RX_DONE_reg                                                      0xB801BB58
+#define set_MIS_IC5_CLR_RX_DONE_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_RX_DONE_reg)=data)
+#define get_MIS_IC5_CLR_RX_DONE_reg   (*((volatile unsigned int*) MIS_IC5_CLR_RX_DONE_reg))
+#define MIS_IC5_CLR_RX_DONE_inst_adr                                                 "0x00D6"
+#define MIS_IC5_CLR_RX_DONE_inst                                                     0x00D6
+#define MIS_IC5_CLR_RX_DONE_clr_rx_done_shift                                        (0)
+#define MIS_IC5_CLR_RX_DONE_clr_rx_done_mask                                         (0x00000001)
+#define MIS_IC5_CLR_RX_DONE_clr_rx_done(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_RX_DONE_clr_rx_done_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_RX_DONE_get_clr_rx_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_CLR_ACTIVITY                                                         0x1801BB5C
+#define MIS_IC5_CLR_ACTIVITY_reg_addr                                                "0xB801BB5C"
+#define MIS_IC5_CLR_ACTIVITY_reg                                                     0xB801BB5C
+#define set_MIS_IC5_CLR_ACTIVITY_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_ACTIVITY_reg)=data)
+#define get_MIS_IC5_CLR_ACTIVITY_reg   (*((volatile unsigned int*) MIS_IC5_CLR_ACTIVITY_reg))
+#define MIS_IC5_CLR_ACTIVITY_inst_adr                                                "0x00D7"
+#define MIS_IC5_CLR_ACTIVITY_inst                                                    0x00D7
+#define MIS_IC5_CLR_ACTIVITY_clr_activity_shift                                      (0)
+#define MIS_IC5_CLR_ACTIVITY_clr_activity_mask                                       (0x00000001)
+#define MIS_IC5_CLR_ACTIVITY_clr_activity(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_ACTIVITY_clr_activity_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_ACTIVITY_get_clr_activity(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_CLR_STOP_DET                                                         0x1801BB60
+#define MIS_IC5_CLR_STOP_DET_reg_addr                                                "0xB801BB60"
+#define MIS_IC5_CLR_STOP_DET_reg                                                     0xB801BB60
+#define set_MIS_IC5_CLR_STOP_DET_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_STOP_DET_reg)=data)
+#define get_MIS_IC5_CLR_STOP_DET_reg   (*((volatile unsigned int*) MIS_IC5_CLR_STOP_DET_reg))
+#define MIS_IC5_CLR_STOP_DET_inst_adr                                                "0x00D8"
+#define MIS_IC5_CLR_STOP_DET_inst                                                    0x00D8
+#define MIS_IC5_CLR_STOP_DET_clr_stop_det_shift                                      (0)
+#define MIS_IC5_CLR_STOP_DET_clr_stop_det_mask                                       (0x00000001)
+#define MIS_IC5_CLR_STOP_DET_clr_stop_det(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_STOP_DET_clr_stop_det_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_STOP_DET_get_clr_stop_det(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_CLR_START_DET                                                        0x1801BB64
+#define MIS_IC5_CLR_START_DET_reg_addr                                               "0xB801BB64"
+#define MIS_IC5_CLR_START_DET_reg                                                    0xB801BB64
+#define set_MIS_IC5_CLR_START_DET_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_START_DET_reg)=data)
+#define get_MIS_IC5_CLR_START_DET_reg   (*((volatile unsigned int*) MIS_IC5_CLR_START_DET_reg))
+#define MIS_IC5_CLR_START_DET_inst_adr                                               "0x00D9"
+#define MIS_IC5_CLR_START_DET_inst                                                   0x00D9
+#define MIS_IC5_CLR_START_DET_clr_start_det_shift                                    (0)
+#define MIS_IC5_CLR_START_DET_clr_start_det_mask                                     (0x00000001)
+#define MIS_IC5_CLR_START_DET_clr_start_det(data)                                    (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_START_DET_clr_start_det_src(data)                                ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_START_DET_get_clr_start_det(data)                                ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_CLR_GEN_CALL                                                         0x1801BB68
+#define MIS_IC5_CLR_GEN_CALL_reg_addr                                                "0xB801BB68"
+#define MIS_IC5_CLR_GEN_CALL_reg                                                     0xB801BB68
+#define set_MIS_IC5_CLR_GEN_CALL_reg(data)   (*((volatile unsigned int*) MIS_IC5_CLR_GEN_CALL_reg)=data)
+#define get_MIS_IC5_CLR_GEN_CALL_reg   (*((volatile unsigned int*) MIS_IC5_CLR_GEN_CALL_reg))
+#define MIS_IC5_CLR_GEN_CALL_inst_adr                                                "0x00DA"
+#define MIS_IC5_CLR_GEN_CALL_inst                                                    0x00DA
+#define MIS_IC5_CLR_GEN_CALL_clr_gen_call_shift                                      (0)
+#define MIS_IC5_CLR_GEN_CALL_clr_gen_call_mask                                       (0x00000001)
+#define MIS_IC5_CLR_GEN_CALL_clr_gen_call(data)                                      (0x00000001&((data)<<0))
+#define MIS_IC5_CLR_GEN_CALL_clr_gen_call_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_IC5_CLR_GEN_CALL_get_clr_gen_call(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_ENABLE                                                               0x1801BB6C
+#define MIS_IC5_ENABLE_reg_addr                                                      "0xB801BB6C"
+#define MIS_IC5_ENABLE_reg                                                           0xB801BB6C
+#define set_MIS_IC5_ENABLE_reg(data)   (*((volatile unsigned int*) MIS_IC5_ENABLE_reg)=data)
+#define get_MIS_IC5_ENABLE_reg   (*((volatile unsigned int*) MIS_IC5_ENABLE_reg))
+#define MIS_IC5_ENABLE_inst_adr                                                      "0x00DB"
+#define MIS_IC5_ENABLE_inst                                                          0x00DB
+#define MIS_IC5_ENABLE_enable_shift                                                  (0)
+#define MIS_IC5_ENABLE_enable_mask                                                   (0x00000001)
+#define MIS_IC5_ENABLE_enable(data)                                                  (0x00000001&((data)<<0))
+#define MIS_IC5_ENABLE_enable_src(data)                                              ((0x00000001&(data))>>0)
+#define MIS_IC5_ENABLE_get_enable(data)                                              ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_STATUS                                                               0x1801BB70
+#define MIS_IC5_STATUS_reg_addr                                                      "0xB801BB70"
+#define MIS_IC5_STATUS_reg                                                           0xB801BB70
+#define set_MIS_IC5_STATUS_reg(data)   (*((volatile unsigned int*) MIS_IC5_STATUS_reg)=data)
+#define get_MIS_IC5_STATUS_reg   (*((volatile unsigned int*) MIS_IC5_STATUS_reg))
+#define MIS_IC5_STATUS_inst_adr                                                      "0x00DC"
+#define MIS_IC5_STATUS_inst                                                          0x00DC
+#define MIS_IC5_STATUS_slv_activity_shift                                            (6)
+#define MIS_IC5_STATUS_slv_activity_mask                                             (0x00000040)
+#define MIS_IC5_STATUS_slv_activity(data)                                            (0x00000040&((data)<<6))
+#define MIS_IC5_STATUS_slv_activity_src(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC5_STATUS_get_slv_activity(data)                                        ((0x00000040&(data))>>6)
+#define MIS_IC5_STATUS_mst_activity_shift                                            (5)
+#define MIS_IC5_STATUS_mst_activity_mask                                             (0x00000020)
+#define MIS_IC5_STATUS_mst_activity(data)                                            (0x00000020&((data)<<5))
+#define MIS_IC5_STATUS_mst_activity_src(data)                                        ((0x00000020&(data))>>5)
+#define MIS_IC5_STATUS_get_mst_activity(data)                                        ((0x00000020&(data))>>5)
+#define MIS_IC5_STATUS_rff_shift                                                     (4)
+#define MIS_IC5_STATUS_rff_mask                                                      (0x00000010)
+#define MIS_IC5_STATUS_rff(data)                                                     (0x00000010&((data)<<4))
+#define MIS_IC5_STATUS_rff_src(data)                                                 ((0x00000010&(data))>>4)
+#define MIS_IC5_STATUS_get_rff(data)                                                 ((0x00000010&(data))>>4)
+#define MIS_IC5_STATUS_rfne_shift                                                    (3)
+#define MIS_IC5_STATUS_rfne_mask                                                     (0x00000008)
+#define MIS_IC5_STATUS_rfne(data)                                                    (0x00000008&((data)<<3))
+#define MIS_IC5_STATUS_rfne_src(data)                                                ((0x00000008&(data))>>3)
+#define MIS_IC5_STATUS_get_rfne(data)                                                ((0x00000008&(data))>>3)
+#define MIS_IC5_STATUS_tfe_shift                                                     (2)
+#define MIS_IC5_STATUS_tfe_mask                                                      (0x00000004)
+#define MIS_IC5_STATUS_tfe(data)                                                     (0x00000004&((data)<<2))
+#define MIS_IC5_STATUS_tfe_src(data)                                                 ((0x00000004&(data))>>2)
+#define MIS_IC5_STATUS_get_tfe(data)                                                 ((0x00000004&(data))>>2)
+#define MIS_IC5_STATUS_tfnf_shift                                                    (1)
+#define MIS_IC5_STATUS_tfnf_mask                                                     (0x00000002)
+#define MIS_IC5_STATUS_tfnf(data)                                                    (0x00000002&((data)<<1))
+#define MIS_IC5_STATUS_tfnf_src(data)                                                ((0x00000002&(data))>>1)
+#define MIS_IC5_STATUS_get_tfnf(data)                                                ((0x00000002&(data))>>1)
+#define MIS_IC5_STATUS_activity_shift                                                (0)
+#define MIS_IC5_STATUS_activity_mask                                                 (0x00000001)
+#define MIS_IC5_STATUS_activity(data)                                                (0x00000001&((data)<<0))
+#define MIS_IC5_STATUS_activity_src(data)                                            ((0x00000001&(data))>>0)
+#define MIS_IC5_STATUS_get_activity(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_TXFLR                                                                0x1801BB74
+#define MIS_IC5_TXFLR_reg_addr                                                       "0xB801BB74"
+#define MIS_IC5_TXFLR_reg                                                            0xB801BB74
+#define set_MIS_IC5_TXFLR_reg(data)   (*((volatile unsigned int*) MIS_IC5_TXFLR_reg)=data)
+#define get_MIS_IC5_TXFLR_reg   (*((volatile unsigned int*) MIS_IC5_TXFLR_reg))
+#define MIS_IC5_TXFLR_inst_adr                                                       "0x00DD"
+#define MIS_IC5_TXFLR_inst                                                           0x00DD
+#define MIS_IC5_TXFLR_txflr_shift                                                    (0)
+#define MIS_IC5_TXFLR_txflr_mask                                                     (0x0000000F)
+#define MIS_IC5_TXFLR_txflr(data)                                                    (0x0000000F&((data)<<0))
+#define MIS_IC5_TXFLR_txflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define MIS_IC5_TXFLR_get_txflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC5_RXFLR                                                                0x1801BB78
+#define MIS_IC5_RXFLR_reg_addr                                                       "0xB801BB78"
+#define MIS_IC5_RXFLR_reg                                                            0xB801BB78
+#define set_MIS_IC5_RXFLR_reg(data)   (*((volatile unsigned int*) MIS_IC5_RXFLR_reg)=data)
+#define get_MIS_IC5_RXFLR_reg   (*((volatile unsigned int*) MIS_IC5_RXFLR_reg))
+#define MIS_IC5_RXFLR_inst_adr                                                       "0x00DE"
+#define MIS_IC5_RXFLR_inst                                                           0x00DE
+#define MIS_IC5_RXFLR_rxflr_shift                                                    (0)
+#define MIS_IC5_RXFLR_rxflr_mask                                                     (0x0000000F)
+#define MIS_IC5_RXFLR_rxflr(data)                                                    (0x0000000F&((data)<<0))
+#define MIS_IC5_RXFLR_rxflr_src(data)                                                ((0x0000000F&(data))>>0)
+#define MIS_IC5_RXFLR_get_rxflr(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC5_SDA_HOLD                                                             0x1801BB7C
+#define MIS_IC5_SDA_HOLD_reg_addr                                                    "0xB801BB7C"
+#define MIS_IC5_SDA_HOLD_reg                                                         0xB801BB7C
+#define set_MIS_IC5_SDA_HOLD_reg(data)   (*((volatile unsigned int*) MIS_IC5_SDA_HOLD_reg)=data)
+#define get_MIS_IC5_SDA_HOLD_reg   (*((volatile unsigned int*) MIS_IC5_SDA_HOLD_reg))
+#define MIS_IC5_SDA_HOLD_inst_adr                                                    "0x00DF"
+#define MIS_IC5_SDA_HOLD_inst                                                        0x00DF
+#define MIS_IC5_SDA_HOLD_sda_hold_shift                                              (0)
+#define MIS_IC5_SDA_HOLD_sda_hold_mask                                               (0x0000FFFF)
+#define MIS_IC5_SDA_HOLD_sda_hold(data)                                              (0x0000FFFF&((data)<<0))
+#define MIS_IC5_SDA_HOLD_sda_hold_src(data)                                          ((0x0000FFFF&(data))>>0)
+#define MIS_IC5_SDA_HOLD_get_sda_hold(data)                                          ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_IC5_TX_ABRT_SOURCE                                                       0x1801BB80
+#define MIS_IC5_TX_ABRT_SOURCE_reg_addr                                              "0xB801BB80"
+#define MIS_IC5_TX_ABRT_SOURCE_reg                                                   0xB801BB80
+#define set_MIS_IC5_TX_ABRT_SOURCE_reg(data)   (*((volatile unsigned int*) MIS_IC5_TX_ABRT_SOURCE_reg)=data)
+#define get_MIS_IC5_TX_ABRT_SOURCE_reg   (*((volatile unsigned int*) MIS_IC5_TX_ABRT_SOURCE_reg))
+#define MIS_IC5_TX_ABRT_SOURCE_inst_adr                                              "0x00E0"
+#define MIS_IC5_TX_ABRT_SOURCE_inst                                                  0x00E0
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slvrd_intx_shift                                 (15)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slvrd_intx_mask                                  (0x00008000)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slvrd_intx(data)                                 (0x00008000&((data)<<15))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slvrd_intx_src(data)                             ((0x00008000&(data))>>15)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_slvrd_intx(data)                             ((0x00008000&(data))>>15)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slv_arblost_shift                                (14)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slv_arblost_mask                                 (0x00004000)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slv_arblost(data)                                (0x00004000&((data)<<14))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slv_arblost_src(data)                            ((0x00004000&(data))>>14)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_slv_arblost(data)                            ((0x00004000&(data))>>14)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slvflush_txfifo_shift                            (13)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slvflush_txfifo_mask                             (0x00002000)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slvflush_txfifo(data)                            (0x00002000&((data)<<13))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_slvflush_txfifo_src(data)                        ((0x00002000&(data))>>13)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_slvflush_txfifo(data)                        ((0x00002000&(data))>>13)
+#define MIS_IC5_TX_ABRT_SOURCE_arb_lost_shift                                        (12)
+#define MIS_IC5_TX_ABRT_SOURCE_arb_lost_mask                                         (0x00001000)
+#define MIS_IC5_TX_ABRT_SOURCE_arb_lost(data)                                        (0x00001000&((data)<<12))
+#define MIS_IC5_TX_ABRT_SOURCE_arb_lost_src(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC5_TX_ABRT_SOURCE_get_arb_lost(data)                                    ((0x00001000&(data))>>12)
+#define MIS_IC5_TX_ABRT_SOURCE_arb_master_dis_shift                                  (11)
+#define MIS_IC5_TX_ABRT_SOURCE_arb_master_dis_mask                                   (0x00000800)
+#define MIS_IC5_TX_ABRT_SOURCE_arb_master_dis(data)                                  (0x00000800&((data)<<11))
+#define MIS_IC5_TX_ABRT_SOURCE_arb_master_dis_src(data)                              ((0x00000800&(data))>>11)
+#define MIS_IC5_TX_ABRT_SOURCE_get_arb_master_dis(data)                              ((0x00000800&(data))>>11)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_shift                             (10)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_mask                              (0x00000400)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10b_rd_norstrt(data)                             (0x00000400&((data)<<10))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10b_rd_norstrt_src(data)                         ((0x00000400&(data))>>10)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_10b_rd_norstrt(data)                         ((0x00000400&(data))>>10)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_sbyte_norstrt_shift                              (9)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_sbyte_norstrt_mask                               (0x00000200)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_sbyte_norstrt(data)                              (0x00000200&((data)<<9))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_sbyte_norstrt_src(data)                          ((0x00000200&(data))>>9)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_sbyte_norstrt(data)                          ((0x00000200&(data))>>9)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_hs_norstrt_shift                                 (8)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_hs_norstrt_mask                                  (0x00000100)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_hs_norstrt(data)                                 (0x00000100&((data)<<8))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_hs_norstrt_src(data)                             ((0x00000100&(data))>>8)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_hs_norstrt(data)                             ((0x00000100&(data))>>8)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_sbyte_ackdet_shift                               (7)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_sbyte_ackdet_mask                                (0x00000080)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_sbyte_ackdet(data)                               (0x00000080&((data)<<7))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_sbyte_ackdet_src(data)                           ((0x00000080&(data))>>7)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_sbyte_ackdet(data)                           ((0x00000080&(data))>>7)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_hs_ackdet_shift                                  (6)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_hs_ackdet_mask                                   (0x00000040)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_hs_ackdet(data)                                  (0x00000040&((data)<<6))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_hs_ackdet_src(data)                              ((0x00000040&(data))>>6)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_hs_ackdet(data)                              ((0x00000040&(data))>>6)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_gcall_read_shift                                 (5)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_gcall_read_mask                                  (0x00000020)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_gcall_read(data)                                 (0x00000020&((data)<<5))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_gcall_read_src(data)                             ((0x00000020&(data))>>5)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_gcall_read(data)                             ((0x00000020&(data))>>5)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_gcall_noack_shift                                (4)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_gcall_noack_mask                                 (0x00000010)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_gcall_noack(data)                                (0x00000010&((data)<<4))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_gcall_noack_src(data)                            ((0x00000010&(data))>>4)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_gcall_noack(data)                            ((0x00000010&(data))>>4)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_txdata_noack_shift                               (3)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_txdata_noack_mask                                (0x00000008)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_txdata_noack(data)                               (0x00000008&((data)<<3))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_txdata_noack_src(data)                           ((0x00000008&(data))>>3)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_txdata_noack(data)                           ((0x00000008&(data))>>3)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10addr2_noack_shift                              (2)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10addr2_noack_mask                               (0x00000004)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10addr2_noack(data)                              (0x00000004&((data)<<2))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10addr2_noack_src(data)                          ((0x00000004&(data))>>2)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_10addr2_noack(data)                          ((0x00000004&(data))>>2)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10addr1_noack_shift                              (1)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10addr1_noack_mask                               (0x00000002)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10addr1_noack(data)                              (0x00000002&((data)<<1))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_10addr1_noack_src(data)                          ((0x00000002&(data))>>1)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_10addr1_noack(data)                          ((0x00000002&(data))>>1)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_7b_addr_noack_shift                              (0)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_7b_addr_noack_mask                               (0x00000001)
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_7b_addr_noack(data)                              (0x00000001&((data)<<0))
+#define MIS_IC5_TX_ABRT_SOURCE_abrt_7b_addr_noack_src(data)                          ((0x00000001&(data))>>0)
+#define MIS_IC5_TX_ABRT_SOURCE_get_abrt_7b_addr_noack(data)                          ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_SLV_DATA_NACK_ONLY                                                   0x1801BB84
+#define MIS_IC5_SLV_DATA_NACK_ONLY_reg_addr                                          "0xB801BB84"
+#define MIS_IC5_SLV_DATA_NACK_ONLY_reg                                               0xB801BB84
+#define set_MIS_IC5_SLV_DATA_NACK_ONLY_reg(data)   (*((volatile unsigned int*) MIS_IC5_SLV_DATA_NACK_ONLY_reg)=data)
+#define get_MIS_IC5_SLV_DATA_NACK_ONLY_reg   (*((volatile unsigned int*) MIS_IC5_SLV_DATA_NACK_ONLY_reg))
+#define MIS_IC5_SLV_DATA_NACK_ONLY_inst_adr                                          "0x00E1"
+#define MIS_IC5_SLV_DATA_NACK_ONLY_inst                                              0x00E1
+#define MIS_IC5_SLV_DATA_NACK_ONLY_nack_shift                                        (0)
+#define MIS_IC5_SLV_DATA_NACK_ONLY_nack_mask                                         (0x00000001)
+#define MIS_IC5_SLV_DATA_NACK_ONLY_nack(data)                                        (0x00000001&((data)<<0))
+#define MIS_IC5_SLV_DATA_NACK_ONLY_nack_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_IC5_SLV_DATA_NACK_ONLY_get_nack(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_DMA_CR                                                               0x1801BB88
+#define MIS_IC5_DMA_CR_reg_addr                                                      "0xB801BB88"
+#define MIS_IC5_DMA_CR_reg                                                           0xB801BB88
+#define set_MIS_IC5_DMA_CR_reg(data)   (*((volatile unsigned int*) MIS_IC5_DMA_CR_reg)=data)
+#define get_MIS_IC5_DMA_CR_reg   (*((volatile unsigned int*) MIS_IC5_DMA_CR_reg))
+#define MIS_IC5_DMA_CR_inst_adr                                                      "0x00E2"
+#define MIS_IC5_DMA_CR_inst                                                          0x00E2
+#define MIS_IC5_DMA_CR_tdmae_shift                                                   (1)
+#define MIS_IC5_DMA_CR_tdmae_mask                                                    (0x00000002)
+#define MIS_IC5_DMA_CR_tdmae(data)                                                   (0x00000002&((data)<<1))
+#define MIS_IC5_DMA_CR_tdmae_src(data)                                               ((0x00000002&(data))>>1)
+#define MIS_IC5_DMA_CR_get_tdmae(data)                                               ((0x00000002&(data))>>1)
+#define MIS_IC5_DMA_CR_rdmae_shift                                                   (0)
+#define MIS_IC5_DMA_CR_rdmae_mask                                                    (0x00000001)
+#define MIS_IC5_DMA_CR_rdmae(data)                                                   (0x00000001&((data)<<0))
+#define MIS_IC5_DMA_CR_rdmae_src(data)                                               ((0x00000001&(data))>>0)
+#define MIS_IC5_DMA_CR_get_rdmae(data)                                               ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_DMA_TDLR                                                             0x1801BB8C
+#define MIS_IC5_DMA_TDLR_reg_addr                                                    "0xB801BB8C"
+#define MIS_IC5_DMA_TDLR_reg                                                         0xB801BB8C
+#define set_MIS_IC5_DMA_TDLR_reg(data)   (*((volatile unsigned int*) MIS_IC5_DMA_TDLR_reg)=data)
+#define get_MIS_IC5_DMA_TDLR_reg   (*((volatile unsigned int*) MIS_IC5_DMA_TDLR_reg))
+#define MIS_IC5_DMA_TDLR_inst_adr                                                    "0x00E3"
+#define MIS_IC5_DMA_TDLR_inst                                                        0x00E3
+#define MIS_IC5_DMA_TDLR_dmatdl_shift                                                (0)
+#define MIS_IC5_DMA_TDLR_dmatdl_mask                                                 (0x00000007)
+#define MIS_IC5_DMA_TDLR_dmatdl(data)                                                (0x00000007&((data)<<0))
+#define MIS_IC5_DMA_TDLR_dmatdl_src(data)                                            ((0x00000007&(data))>>0)
+#define MIS_IC5_DMA_TDLR_get_dmatdl(data)                                            ((0x00000007&(data))>>0)
+
+
+#define MIS_IC5_DMA_RDLR                                                             0x1801BB90
+#define MIS_IC5_DMA_RDLR_reg_addr                                                    "0xB801BB90"
+#define MIS_IC5_DMA_RDLR_reg                                                         0xB801BB90
+#define set_MIS_IC5_DMA_RDLR_reg(data)   (*((volatile unsigned int*) MIS_IC5_DMA_RDLR_reg)=data)
+#define get_MIS_IC5_DMA_RDLR_reg   (*((volatile unsigned int*) MIS_IC5_DMA_RDLR_reg))
+#define MIS_IC5_DMA_RDLR_inst_adr                                                    "0x00E4"
+#define MIS_IC5_DMA_RDLR_inst                                                        0x00E4
+#define MIS_IC5_DMA_RDLR_dmardl_shift                                                (0)
+#define MIS_IC5_DMA_RDLR_dmardl_mask                                                 (0x0000000F)
+#define MIS_IC5_DMA_RDLR_dmardl(data)                                                (0x0000000F&((data)<<0))
+#define MIS_IC5_DMA_RDLR_dmardl_src(data)                                            ((0x0000000F&(data))>>0)
+#define MIS_IC5_DMA_RDLR_get_dmardl(data)                                            ((0x0000000F&(data))>>0)
+
+
+#define MIS_IC5_SDA_SETUP                                                            0x1801BB94
+#define MIS_IC5_SDA_SETUP_reg_addr                                                   "0xB801BB94"
+#define MIS_IC5_SDA_SETUP_reg                                                        0xB801BB94
+#define set_MIS_IC5_SDA_SETUP_reg(data)   (*((volatile unsigned int*) MIS_IC5_SDA_SETUP_reg)=data)
+#define get_MIS_IC5_SDA_SETUP_reg   (*((volatile unsigned int*) MIS_IC5_SDA_SETUP_reg))
+#define MIS_IC5_SDA_SETUP_inst_adr                                                   "0x00E5"
+#define MIS_IC5_SDA_SETUP_inst                                                       0x00E5
+#define MIS_IC5_SDA_SETUP_sda_setup_shift                                            (0)
+#define MIS_IC5_SDA_SETUP_sda_setup_mask                                             (0x000000FF)
+#define MIS_IC5_SDA_SETUP_sda_setup(data)                                            (0x000000FF&((data)<<0))
+#define MIS_IC5_SDA_SETUP_sda_setup_src(data)                                        ((0x000000FF&(data))>>0)
+#define MIS_IC5_SDA_SETUP_get_sda_setup(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define MIS_IC5_ACK_GENERAL_CALL                                                     0x1801BB98
+#define MIS_IC5_ACK_GENERAL_CALL_reg_addr                                            "0xB801BB98"
+#define MIS_IC5_ACK_GENERAL_CALL_reg                                                 0xB801BB98
+#define set_MIS_IC5_ACK_GENERAL_CALL_reg(data)   (*((volatile unsigned int*) MIS_IC5_ACK_GENERAL_CALL_reg)=data)
+#define get_MIS_IC5_ACK_GENERAL_CALL_reg   (*((volatile unsigned int*) MIS_IC5_ACK_GENERAL_CALL_reg))
+#define MIS_IC5_ACK_GENERAL_CALL_inst_adr                                            "0x00E6"
+#define MIS_IC5_ACK_GENERAL_CALL_inst                                                0x00E6
+#define MIS_IC5_ACK_GENERAL_CALL_ack_gen_call_shift                                  (0)
+#define MIS_IC5_ACK_GENERAL_CALL_ack_gen_call_mask                                   (0x00000001)
+#define MIS_IC5_ACK_GENERAL_CALL_ack_gen_call(data)                                  (0x00000001&((data)<<0))
+#define MIS_IC5_ACK_GENERAL_CALL_ack_gen_call_src(data)                              ((0x00000001&(data))>>0)
+#define MIS_IC5_ACK_GENERAL_CALL_get_ack_gen_call(data)                              ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_ENABLE_STATUS                                                        0x1801BB9C
+#define MIS_IC5_ENABLE_STATUS_reg_addr                                               "0xB801BB9C"
+#define MIS_IC5_ENABLE_STATUS_reg                                                    0xB801BB9C
+#define set_MIS_IC5_ENABLE_STATUS_reg(data)   (*((volatile unsigned int*) MIS_IC5_ENABLE_STATUS_reg)=data)
+#define get_MIS_IC5_ENABLE_STATUS_reg   (*((volatile unsigned int*) MIS_IC5_ENABLE_STATUS_reg))
+#define MIS_IC5_ENABLE_STATUS_inst_adr                                               "0x00E7"
+#define MIS_IC5_ENABLE_STATUS_inst                                                   0x00E7
+#define MIS_IC5_ENABLE_STATUS_slv_rx_data_lost_shift                                 (2)
+#define MIS_IC5_ENABLE_STATUS_slv_rx_data_lost_mask                                  (0x00000004)
+#define MIS_IC5_ENABLE_STATUS_slv_rx_data_lost(data)                                 (0x00000004&((data)<<2))
+#define MIS_IC5_ENABLE_STATUS_slv_rx_data_lost_src(data)                             ((0x00000004&(data))>>2)
+#define MIS_IC5_ENABLE_STATUS_get_slv_rx_data_lost(data)                             ((0x00000004&(data))>>2)
+#define MIS_IC5_ENABLE_STATUS_slv_disabled_whi_shift                                 (1)
+#define MIS_IC5_ENABLE_STATUS_slv_disabled_whi_mask                                  (0x00000002)
+#define MIS_IC5_ENABLE_STATUS_slv_disabled_whi(data)                                 (0x00000002&((data)<<1))
+#define MIS_IC5_ENABLE_STATUS_slv_disabled_whi_src(data)                             ((0x00000002&(data))>>1)
+#define MIS_IC5_ENABLE_STATUS_get_slv_disabled_whi(data)                             ((0x00000002&(data))>>1)
+#define MIS_IC5_ENABLE_STATUS_ic_en_shift                                            (0)
+#define MIS_IC5_ENABLE_STATUS_ic_en_mask                                             (0x00000001)
+#define MIS_IC5_ENABLE_STATUS_ic_en(data)                                            (0x00000001&((data)<<0))
+#define MIS_IC5_ENABLE_STATUS_ic_en_src(data)                                        ((0x00000001&(data))>>0)
+#define MIS_IC5_ENABLE_STATUS_get_ic_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define MIS_IC5_COMP_PARAM_1                                                         0x1801BBF4
+#define MIS_IC5_COMP_PARAM_1_reg_addr                                                "0xB801BBF4"
+#define MIS_IC5_COMP_PARAM_1_reg                                                     0xB801BBF4
+#define set_MIS_IC5_COMP_PARAM_1_reg(data)   (*((volatile unsigned int*) MIS_IC5_COMP_PARAM_1_reg)=data)
+#define get_MIS_IC5_COMP_PARAM_1_reg   (*((volatile unsigned int*) MIS_IC5_COMP_PARAM_1_reg))
+#define MIS_IC5_COMP_PARAM_1_inst_adr                                                "0x00FD"
+#define MIS_IC5_COMP_PARAM_1_inst                                                    0x00FD
+#define MIS_IC5_COMP_PARAM_1_tx_buffer_depth_shift                                   (16)
+#define MIS_IC5_COMP_PARAM_1_tx_buffer_depth_mask                                    (0x00FF0000)
+#define MIS_IC5_COMP_PARAM_1_tx_buffer_depth(data)                                   (0x00FF0000&((data)<<16))
+#define MIS_IC5_COMP_PARAM_1_tx_buffer_depth_src(data)                               ((0x00FF0000&(data))>>16)
+#define MIS_IC5_COMP_PARAM_1_get_tx_buffer_depth(data)                               ((0x00FF0000&(data))>>16)
+#define MIS_IC5_COMP_PARAM_1_rx_buffer_depth_shift                                   (8)
+#define MIS_IC5_COMP_PARAM_1_rx_buffer_depth_mask                                    (0x0000FF00)
+#define MIS_IC5_COMP_PARAM_1_rx_buffer_depth(data)                                   (0x0000FF00&((data)<<8))
+#define MIS_IC5_COMP_PARAM_1_rx_buffer_depth_src(data)                               ((0x0000FF00&(data))>>8)
+#define MIS_IC5_COMP_PARAM_1_get_rx_buffer_depth(data)                               ((0x0000FF00&(data))>>8)
+#define MIS_IC5_COMP_PARAM_1_add_encoded_params_shift                                (7)
+#define MIS_IC5_COMP_PARAM_1_add_encoded_params_mask                                 (0x00000080)
+#define MIS_IC5_COMP_PARAM_1_add_encoded_params(data)                                (0x00000080&((data)<<7))
+#define MIS_IC5_COMP_PARAM_1_add_encoded_params_src(data)                            ((0x00000080&(data))>>7)
+#define MIS_IC5_COMP_PARAM_1_get_add_encoded_params(data)                            ((0x00000080&(data))>>7)
+#define MIS_IC5_COMP_PARAM_1_has_dma_shift                                           (6)
+#define MIS_IC5_COMP_PARAM_1_has_dma_mask                                            (0x00000040)
+#define MIS_IC5_COMP_PARAM_1_has_dma(data)                                           (0x00000040&((data)<<6))
+#define MIS_IC5_COMP_PARAM_1_has_dma_src(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC5_COMP_PARAM_1_get_has_dma(data)                                       ((0x00000040&(data))>>6)
+#define MIS_IC5_COMP_PARAM_1_intr_io_shift                                           (5)
+#define MIS_IC5_COMP_PARAM_1_intr_io_mask                                            (0x00000020)
+#define MIS_IC5_COMP_PARAM_1_intr_io(data)                                           (0x00000020&((data)<<5))
+#define MIS_IC5_COMP_PARAM_1_intr_io_src(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC5_COMP_PARAM_1_get_intr_io(data)                                       ((0x00000020&(data))>>5)
+#define MIS_IC5_COMP_PARAM_1_hc_count_values_shift                                   (4)
+#define MIS_IC5_COMP_PARAM_1_hc_count_values_mask                                    (0x00000010)
+#define MIS_IC5_COMP_PARAM_1_hc_count_values(data)                                   (0x00000010&((data)<<4))
+#define MIS_IC5_COMP_PARAM_1_hc_count_values_src(data)                               ((0x00000010&(data))>>4)
+#define MIS_IC5_COMP_PARAM_1_get_hc_count_values(data)                               ((0x00000010&(data))>>4)
+#define MIS_IC5_COMP_PARAM_1_max_speed_mode_shift                                    (2)
+#define MIS_IC5_COMP_PARAM_1_max_speed_mode_mask                                     (0x0000000C)
+#define MIS_IC5_COMP_PARAM_1_max_speed_mode(data)                                    (0x0000000C&((data)<<2))
+#define MIS_IC5_COMP_PARAM_1_max_speed_mode_src(data)                                ((0x0000000C&(data))>>2)
+#define MIS_IC5_COMP_PARAM_1_get_max_speed_mode(data)                                ((0x0000000C&(data))>>2)
+#define MIS_IC5_COMP_PARAM_1_apb_data_width_shift                                    (0)
+#define MIS_IC5_COMP_PARAM_1_apb_data_width_mask                                     (0x00000003)
+#define MIS_IC5_COMP_PARAM_1_apb_data_width(data)                                    (0x00000003&((data)<<0))
+#define MIS_IC5_COMP_PARAM_1_apb_data_width_src(data)                                ((0x00000003&(data))>>0)
+#define MIS_IC5_COMP_PARAM_1_get_apb_data_width(data)                                ((0x00000003&(data))>>0)
+
+
+#define MIS_IC5_COMP_VERSION                                                         0x1801BBF8
+#define MIS_IC5_COMP_VERSION_reg_addr                                                "0xB801BBF8"
+#define MIS_IC5_COMP_VERSION_reg                                                     0xB801BBF8
+#define set_MIS_IC5_COMP_VERSION_reg(data)   (*((volatile unsigned int*) MIS_IC5_COMP_VERSION_reg)=data)
+#define get_MIS_IC5_COMP_VERSION_reg   (*((volatile unsigned int*) MIS_IC5_COMP_VERSION_reg))
+#define MIS_IC5_COMP_VERSION_inst_adr                                                "0x00FE"
+#define MIS_IC5_COMP_VERSION_inst                                                    0x00FE
+#define MIS_IC5_COMP_VERSION_ic_comp_version_shift                                   (0)
+#define MIS_IC5_COMP_VERSION_ic_comp_version_mask                                    (0xFFFFFFFF)
+#define MIS_IC5_COMP_VERSION_ic_comp_version(data)                                   (0xFFFFFFFF&((data)<<0))
+#define MIS_IC5_COMP_VERSION_ic_comp_version_src(data)                               ((0xFFFFFFFF&(data))>>0)
+#define MIS_IC5_COMP_VERSION_get_ic_comp_version(data)                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_IC5_COMP_TYPE                                                            0x1801BBFC
+#define MIS_IC5_COMP_TYPE_reg_addr                                                   "0xB801BBFC"
+#define MIS_IC5_COMP_TYPE_reg                                                        0xB801BBFC
+#define set_MIS_IC5_COMP_TYPE_reg(data)   (*((volatile unsigned int*) MIS_IC5_COMP_TYPE_reg)=data)
+#define get_MIS_IC5_COMP_TYPE_reg   (*((volatile unsigned int*) MIS_IC5_COMP_TYPE_reg))
+#define MIS_IC5_COMP_TYPE_inst_adr                                                   "0x00FF"
+#define MIS_IC5_COMP_TYPE_inst                                                       0x00FF
+#define MIS_IC5_COMP_TYPE_ic_comp_type_shift                                         (0)
+#define MIS_IC5_COMP_TYPE_ic_comp_type_mask                                          (0xFFFFFFFF)
+#define MIS_IC5_COMP_TYPE_ic_comp_type(data)                                         (0xFFFFFFFF&((data)<<0))
+#define MIS_IC5_COMP_TYPE_ic_comp_type_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define MIS_IC5_COMP_TYPE_get_ic_comp_type(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_TC0TVR                                                                   0x1801B500
+#define MIS_TC0TVR_reg_addr                                                          "0xB801B500"
+#define MIS_TC0TVR_reg                                                               0xB801B500
+#define set_MIS_TC0TVR_reg(data)   (*((volatile unsigned int*) MIS_TC0TVR_reg)=data)
+#define get_MIS_TC0TVR_reg   (*((volatile unsigned int*) MIS_TC0TVR_reg))
+#define MIS_TC0TVR_inst_adr                                                          "0x0040"
+#define MIS_TC0TVR_inst                                                              0x0040
+#define MIS_TC0TVR_tc0tvr_shift                                                      (0)
+#define MIS_TC0TVR_tc0tvr_mask                                                       (0xFFFFFFFF)
+#define MIS_TC0TVR_tc0tvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define MIS_TC0TVR_tc0tvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define MIS_TC0TVR_get_tc0tvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_TC1TVR                                                                   0x1801B504
+#define MIS_TC1TVR_reg_addr                                                          "0xB801B504"
+#define MIS_TC1TVR_reg                                                               0xB801B504
+#define set_MIS_TC1TVR_reg(data)   (*((volatile unsigned int*) MIS_TC1TVR_reg)=data)
+#define get_MIS_TC1TVR_reg   (*((volatile unsigned int*) MIS_TC1TVR_reg))
+#define MIS_TC1TVR_inst_adr                                                          "0x0041"
+#define MIS_TC1TVR_inst                                                              0x0041
+#define MIS_TC1TVR_tc1tvr_shift                                                      (0)
+#define MIS_TC1TVR_tc1tvr_mask                                                       (0xFFFFFFFF)
+#define MIS_TC1TVR_tc1tvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define MIS_TC1TVR_tc1tvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define MIS_TC1TVR_get_tc1tvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_TC2TVR                                                                   0x1801B508
+#define MIS_TC2TVR_reg_addr                                                          "0xB801B508"
+#define MIS_TC2TVR_reg                                                               0xB801B508
+#define set_MIS_TC2TVR_reg(data)   (*((volatile unsigned int*) MIS_TC2TVR_reg)=data)
+#define get_MIS_TC2TVR_reg   (*((volatile unsigned int*) MIS_TC2TVR_reg))
+#define MIS_TC2TVR_inst_adr                                                          "0x0042"
+#define MIS_TC2TVR_inst                                                              0x0042
+#define MIS_TC2TVR_tc2tvr_shift                                                      (0)
+#define MIS_TC2TVR_tc2tvr_mask                                                       (0xFFFFFFFF)
+#define MIS_TC2TVR_tc2tvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define MIS_TC2TVR_tc2tvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define MIS_TC2TVR_get_tc2tvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_TC0CVR                                                                   0x1801B50C
+#define MIS_TC0CVR_reg_addr                                                          "0xB801B50C"
+#define MIS_TC0CVR_reg                                                               0xB801B50C
+#define set_MIS_TC0CVR_reg(data)   (*((volatile unsigned int*) MIS_TC0CVR_reg)=data)
+#define get_MIS_TC0CVR_reg   (*((volatile unsigned int*) MIS_TC0CVR_reg))
+#define MIS_TC0CVR_inst_adr                                                          "0x0043"
+#define MIS_TC0CVR_inst                                                              0x0043
+#define MIS_TC0CVR_tc0cvr_shift                                                      (0)
+#define MIS_TC0CVR_tc0cvr_mask                                                       (0xFFFFFFFF)
+#define MIS_TC0CVR_tc0cvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define MIS_TC0CVR_tc0cvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define MIS_TC0CVR_get_tc0cvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_TC1CVR                                                                   0x1801B510
+#define MIS_TC1CVR_reg_addr                                                          "0xB801B510"
+#define MIS_TC1CVR_reg                                                               0xB801B510
+#define set_MIS_TC1CVR_reg(data)   (*((volatile unsigned int*) MIS_TC1CVR_reg)=data)
+#define get_MIS_TC1CVR_reg   (*((volatile unsigned int*) MIS_TC1CVR_reg))
+#define MIS_TC1CVR_inst_adr                                                          "0x0044"
+#define MIS_TC1CVR_inst                                                              0x0044
+#define MIS_TC1CVR_tc1cvr_shift                                                      (0)
+#define MIS_TC1CVR_tc1cvr_mask                                                       (0xFFFFFFFF)
+#define MIS_TC1CVR_tc1cvr(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define MIS_TC1CVR_tc1cvr_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define MIS_TC1CVR_get_tc1cvr(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_TC2CVR                                                                   0x1801B514
+#define MIS_TC2CVR_reg_addr                                                          "0xB801B514"
+#define MIS_TC2CVR_reg                                                               0xB801B514
+#define set_MIS_TC2CVR_reg(data)   (*((volatile unsigned int*) MIS_TC2CVR_reg)=data)
+#define get_MIS_TC2CVR_reg   (*((volatile unsigned int*) MIS_TC2CVR_reg))
+#define MIS_TC2CVR_inst_adr                                                          "0x0045"
+#define MIS_TC2CVR_inst                                                              0x0045
+#define MIS_TC2CVR_tc2vr_shift                                                       (0)
+#define MIS_TC2CVR_tc2vr_mask                                                        (0xFFFFFFFF)
+#define MIS_TC2CVR_tc2vr(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define MIS_TC2CVR_tc2vr_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define MIS_TC2CVR_get_tc2vr(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_TC0CR                                                                    0x1801B518
+#define MIS_TC0CR_reg_addr                                                           "0xB801B518"
+#define MIS_TC0CR_reg                                                                0xB801B518
+#define set_MIS_TC0CR_reg(data)   (*((volatile unsigned int*) MIS_TC0CR_reg)=data)
+#define get_MIS_TC0CR_reg   (*((volatile unsigned int*) MIS_TC0CR_reg))
+#define MIS_TC0CR_inst_adr                                                           "0x0046"
+#define MIS_TC0CR_inst                                                               0x0046
+#define MIS_TC0CR_tc0en_shift                                                        (31)
+#define MIS_TC0CR_tc0en_mask                                                         (0x80000000)
+#define MIS_TC0CR_tc0en(data)                                                        (0x80000000&((data)<<31))
+#define MIS_TC0CR_tc0en_src(data)                                                    ((0x80000000&(data))>>31)
+#define MIS_TC0CR_get_tc0en(data)                                                    ((0x80000000&(data))>>31)
+#define MIS_TC0CR_tc0mode_shift                                                      (30)
+#define MIS_TC0CR_tc0mode_mask                                                       (0x40000000)
+#define MIS_TC0CR_tc0mode(data)                                                      (0x40000000&((data)<<30))
+#define MIS_TC0CR_tc0mode_src(data)                                                  ((0x40000000&(data))>>30)
+#define MIS_TC0CR_get_tc0mode(data)                                                  ((0x40000000&(data))>>30)
+#define MIS_TC0CR_tc0pause_shift                                                     (29)
+#define MIS_TC0CR_tc0pause_mask                                                      (0x20000000)
+#define MIS_TC0CR_tc0pause(data)                                                     (0x20000000&((data)<<29))
+#define MIS_TC0CR_tc0pause_src(data)                                                 ((0x20000000&(data))>>29)
+#define MIS_TC0CR_get_tc0pause(data)                                                 ((0x20000000&(data))>>29)
+#define MIS_TC0CR_rvda_shift                                                         (24)
+#define MIS_TC0CR_rvda_mask                                                          (0x1F000000)
+#define MIS_TC0CR_rvda(data)                                                         (0x1F000000&((data)<<24))
+#define MIS_TC0CR_rvda_src(data)                                                     ((0x1F000000&(data))>>24)
+#define MIS_TC0CR_get_rvda(data)                                                     ((0x1F000000&(data))>>24)
+
+
+#define MIS_TC1CR                                                                    0x1801B51C
+#define MIS_TC1CR_reg_addr                                                           "0xB801B51C"
+#define MIS_TC1CR_reg                                                                0xB801B51C
+#define set_MIS_TC1CR_reg(data)   (*((volatile unsigned int*) MIS_TC1CR_reg)=data)
+#define get_MIS_TC1CR_reg   (*((volatile unsigned int*) MIS_TC1CR_reg))
+#define MIS_TC1CR_inst_adr                                                           "0x0047"
+#define MIS_TC1CR_inst                                                               0x0047
+#define MIS_TC1CR_tc1en_shift                                                        (31)
+#define MIS_TC1CR_tc1en_mask                                                         (0x80000000)
+#define MIS_TC1CR_tc1en(data)                                                        (0x80000000&((data)<<31))
+#define MIS_TC1CR_tc1en_src(data)                                                    ((0x80000000&(data))>>31)
+#define MIS_TC1CR_get_tc1en(data)                                                    ((0x80000000&(data))>>31)
+#define MIS_TC1CR_tc1mode_shift                                                      (30)
+#define MIS_TC1CR_tc1mode_mask                                                       (0x40000000)
+#define MIS_TC1CR_tc1mode(data)                                                      (0x40000000&((data)<<30))
+#define MIS_TC1CR_tc1mode_src(data)                                                  ((0x40000000&(data))>>30)
+#define MIS_TC1CR_get_tc1mode(data)                                                  ((0x40000000&(data))>>30)
+#define MIS_TC1CR_tc1pause_shift                                                     (29)
+#define MIS_TC1CR_tc1pause_mask                                                      (0x20000000)
+#define MIS_TC1CR_tc1pause(data)                                                     (0x20000000&((data)<<29))
+#define MIS_TC1CR_tc1pause_src(data)                                                 ((0x20000000&(data))>>29)
+#define MIS_TC1CR_get_tc1pause(data)                                                 ((0x20000000&(data))>>29)
+#define MIS_TC1CR_rvda_shift                                                         (24)
+#define MIS_TC1CR_rvda_mask                                                          (0x1F000000)
+#define MIS_TC1CR_rvda(data)                                                         (0x1F000000&((data)<<24))
+#define MIS_TC1CR_rvda_src(data)                                                     ((0x1F000000&(data))>>24)
+#define MIS_TC1CR_get_rvda(data)                                                     ((0x1F000000&(data))>>24)
+
+
+#define MIS_TC2CR                                                                    0x1801B520
+#define MIS_TC2CR_reg_addr                                                           "0xB801B520"
+#define MIS_TC2CR_reg                                                                0xB801B520
+#define set_MIS_TC2CR_reg(data)   (*((volatile unsigned int*) MIS_TC2CR_reg)=data)
+#define get_MIS_TC2CR_reg   (*((volatile unsigned int*) MIS_TC2CR_reg))
+#define MIS_TC2CR_inst_adr                                                           "0x0048"
+#define MIS_TC2CR_inst                                                               0x0048
+#define MIS_TC2CR_tc2en_shift                                                        (31)
+#define MIS_TC2CR_tc2en_mask                                                         (0x80000000)
+#define MIS_TC2CR_tc2en(data)                                                        (0x80000000&((data)<<31))
+#define MIS_TC2CR_tc2en_src(data)                                                    ((0x80000000&(data))>>31)
+#define MIS_TC2CR_get_tc2en(data)                                                    ((0x80000000&(data))>>31)
+#define MIS_TC2CR_tc2mode_shift                                                      (30)
+#define MIS_TC2CR_tc2mode_mask                                                       (0x40000000)
+#define MIS_TC2CR_tc2mode(data)                                                      (0x40000000&((data)<<30))
+#define MIS_TC2CR_tc2mode_src(data)                                                  ((0x40000000&(data))>>30)
+#define MIS_TC2CR_get_tc2mode(data)                                                  ((0x40000000&(data))>>30)
+#define MIS_TC2CR_tc2pause_shift                                                     (29)
+#define MIS_TC2CR_tc2pause_mask                                                      (0x20000000)
+#define MIS_TC2CR_tc2pause(data)                                                     (0x20000000&((data)<<29))
+#define MIS_TC2CR_tc2pause_src(data)                                                 ((0x20000000&(data))>>29)
+#define MIS_TC2CR_get_tc2pause(data)                                                 ((0x20000000&(data))>>29)
+#define MIS_TC2CR_rvda_shift                                                         (24)
+#define MIS_TC2CR_rvda_mask                                                          (0x1F000000)
+#define MIS_TC2CR_rvda(data)                                                         (0x1F000000&((data)<<24))
+#define MIS_TC2CR_rvda_src(data)                                                     ((0x1F000000&(data))>>24)
+#define MIS_TC2CR_get_rvda(data)                                                     ((0x1F000000&(data))>>24)
+
+
+#define MIS_TC0ICR                                                                   0x1801B524
+#define MIS_TC0ICR_reg_addr                                                          "0xB801B524"
+#define MIS_TC0ICR_reg                                                               0xB801B524
+#define set_MIS_TC0ICR_reg(data)   (*((volatile unsigned int*) MIS_TC0ICR_reg)=data)
+#define get_MIS_TC0ICR_reg   (*((volatile unsigned int*) MIS_TC0ICR_reg))
+#define MIS_TC0ICR_inst_adr                                                          "0x0049"
+#define MIS_TC0ICR_inst                                                              0x0049
+#define MIS_TC0ICR_tc0ie_shift                                                       (31)
+#define MIS_TC0ICR_tc0ie_mask                                                        (0x80000000)
+#define MIS_TC0ICR_tc0ie(data)                                                       (0x80000000&((data)<<31))
+#define MIS_TC0ICR_tc0ie_src(data)                                                   ((0x80000000&(data))>>31)
+#define MIS_TC0ICR_get_tc0ie(data)                                                   ((0x80000000&(data))>>31)
+
+
+#define MIS_TC1ICR                                                                   0x1801B528
+#define MIS_TC1ICR_reg_addr                                                          "0xB801B528"
+#define MIS_TC1ICR_reg                                                               0xB801B528
+#define set_MIS_TC1ICR_reg(data)   (*((volatile unsigned int*) MIS_TC1ICR_reg)=data)
+#define get_MIS_TC1ICR_reg   (*((volatile unsigned int*) MIS_TC1ICR_reg))
+#define MIS_TC1ICR_inst_adr                                                          "0x004A"
+#define MIS_TC1ICR_inst                                                              0x004A
+#define MIS_TC1ICR_tc1ie_shift                                                       (31)
+#define MIS_TC1ICR_tc1ie_mask                                                        (0x80000000)
+#define MIS_TC1ICR_tc1ie(data)                                                       (0x80000000&((data)<<31))
+#define MIS_TC1ICR_tc1ie_src(data)                                                   ((0x80000000&(data))>>31)
+#define MIS_TC1ICR_get_tc1ie(data)                                                   ((0x80000000&(data))>>31)
+
+
+#define MIS_TC2ICR                                                                   0x1801B52C
+#define MIS_TC2ICR_reg_addr                                                          "0xB801B52C"
+#define MIS_TC2ICR_reg                                                               0xB801B52C
+#define set_MIS_TC2ICR_reg(data)   (*((volatile unsigned int*) MIS_TC2ICR_reg)=data)
+#define get_MIS_TC2ICR_reg   (*((volatile unsigned int*) MIS_TC2ICR_reg))
+#define MIS_TC2ICR_inst_adr                                                          "0x004B"
+#define MIS_TC2ICR_inst                                                              0x004B
+#define MIS_TC2ICR_tc2ie_shift                                                       (31)
+#define MIS_TC2ICR_tc2ie_mask                                                        (0x80000000)
+#define MIS_TC2ICR_tc2ie(data)                                                       (0x80000000&((data)<<31))
+#define MIS_TC2ICR_tc2ie_src(data)                                                   ((0x80000000&(data))>>31)
+#define MIS_TC2ICR_get_tc2ie(data)                                                   ((0x80000000&(data))>>31)
+
+
+#define MIS_CLK90K_CTRL                                                              0x1801B538
+#define MIS_CLK90K_CTRL_reg_addr                                                     "0xB801B538"
+#define MIS_CLK90K_CTRL_reg                                                          0xB801B538
+#define set_MIS_CLK90K_CTRL_reg(data)   (*((volatile unsigned int*) MIS_CLK90K_CTRL_reg)=data)
+#define get_MIS_CLK90K_CTRL_reg   (*((volatile unsigned int*) MIS_CLK90K_CTRL_reg))
+#define MIS_CLK90K_CTRL_inst_adr                                                     "0x004E"
+#define MIS_CLK90K_CTRL_inst                                                         0x004E
+#define MIS_CLK90K_CTRL_en_shift                                                     (0)
+#define MIS_CLK90K_CTRL_en_mask                                                      (0x00000001)
+#define MIS_CLK90K_CTRL_en(data)                                                     (0x00000001&((data)<<0))
+#define MIS_CLK90K_CTRL_en_src(data)                                                 ((0x00000001&(data))>>0)
+#define MIS_CLK90K_CTRL_get_en(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define MIS_SCPU_CLK27M_90K                                                          0x1801B53C
+#define MIS_SCPU_CLK27M_90K_reg_addr                                                 "0xB801B53C"
+#define MIS_SCPU_CLK27M_90K_reg                                                      0xB801B53C
+#define set_MIS_SCPU_CLK27M_90K_reg(data)   (*((volatile unsigned int*) MIS_SCPU_CLK27M_90K_reg)=data)
+#define get_MIS_SCPU_CLK27M_90K_reg   (*((volatile unsigned int*) MIS_SCPU_CLK27M_90K_reg))
+#define MIS_SCPU_CLK27M_90K_inst_adr                                                 "0x004F"
+#define MIS_SCPU_CLK27M_90K_inst                                                     0x004F
+#define MIS_SCPU_CLK27M_90K_cnt_shift                                                (0)
+#define MIS_SCPU_CLK27M_90K_cnt_mask                                                 (0x000001FF)
+#define MIS_SCPU_CLK27M_90K_cnt(data)                                                (0x000001FF&((data)<<0))
+#define MIS_SCPU_CLK27M_90K_cnt_src(data)                                            ((0x000001FF&(data))>>0)
+#define MIS_SCPU_CLK27M_90K_get_cnt(data)                                            ((0x000001FF&(data))>>0)
+
+
+#define MIS_SCPU_CLK90K_LO                                                           0x1801B540
+#define MIS_SCPU_CLK90K_LO_reg_addr                                                  "0xB801B540"
+#define MIS_SCPU_CLK90K_LO_reg                                                       0xB801B540
+#define set_MIS_SCPU_CLK90K_LO_reg(data)   (*((volatile unsigned int*) MIS_SCPU_CLK90K_LO_reg)=data)
+#define get_MIS_SCPU_CLK90K_LO_reg   (*((volatile unsigned int*) MIS_SCPU_CLK90K_LO_reg))
+#define MIS_SCPU_CLK90K_LO_inst_adr                                                  "0x0050"
+#define MIS_SCPU_CLK90K_LO_inst                                                      0x0050
+#define MIS_SCPU_CLK90K_LO_val_shift                                                 (0)
+#define MIS_SCPU_CLK90K_LO_val_mask                                                  (0xFFFFFFFF)
+#define MIS_SCPU_CLK90K_LO_val(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define MIS_SCPU_CLK90K_LO_val_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define MIS_SCPU_CLK90K_LO_get_val(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_SCPU_CLK90K_HI                                                           0x1801B544
+#define MIS_SCPU_CLK90K_HI_reg_addr                                                  "0xB801B544"
+#define MIS_SCPU_CLK90K_HI_reg                                                       0xB801B544
+#define set_MIS_SCPU_CLK90K_HI_reg(data)   (*((volatile unsigned int*) MIS_SCPU_CLK90K_HI_reg)=data)
+#define get_MIS_SCPU_CLK90K_HI_reg   (*((volatile unsigned int*) MIS_SCPU_CLK90K_HI_reg))
+#define MIS_SCPU_CLK90K_HI_inst_adr                                                  "0x0051"
+#define MIS_SCPU_CLK90K_HI_inst                                                      0x0051
+#define MIS_SCPU_CLK90K_HI_val_shift                                                 (0)
+#define MIS_SCPU_CLK90K_HI_val_mask                                                  (0x0000FFFF)
+#define MIS_SCPU_CLK90K_HI_val(data)                                                 (0x0000FFFF&((data)<<0))
+#define MIS_SCPU_CLK90K_HI_val_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define MIS_SCPU_CLK90K_HI_get_val(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_ACPU_CLK27M_90K                                                          0x1801B548
+#define MIS_ACPU_CLK27M_90K_reg_addr                                                 "0xB801B548"
+#define MIS_ACPU_CLK27M_90K_reg                                                      0xB801B548
+#define set_MIS_ACPU_CLK27M_90K_reg(data)   (*((volatile unsigned int*) MIS_ACPU_CLK27M_90K_reg)=data)
+#define get_MIS_ACPU_CLK27M_90K_reg   (*((volatile unsigned int*) MIS_ACPU_CLK27M_90K_reg))
+#define MIS_ACPU_CLK27M_90K_inst_adr                                                 "0x0052"
+#define MIS_ACPU_CLK27M_90K_inst                                                     0x0052
+#define MIS_ACPU_CLK27M_90K_cnt_shift                                                (0)
+#define MIS_ACPU_CLK27M_90K_cnt_mask                                                 (0x000001FF)
+#define MIS_ACPU_CLK27M_90K_cnt(data)                                                (0x000001FF&((data)<<0))
+#define MIS_ACPU_CLK27M_90K_cnt_src(data)                                            ((0x000001FF&(data))>>0)
+#define MIS_ACPU_CLK27M_90K_get_cnt(data)                                            ((0x000001FF&(data))>>0)
+
+
+#define MIS_ACPU_CLK90K_LO                                                           0x1801B54C
+#define MIS_ACPU_CLK90K_LO_reg_addr                                                  "0xB801B54C"
+#define MIS_ACPU_CLK90K_LO_reg                                                       0xB801B54C
+#define set_MIS_ACPU_CLK90K_LO_reg(data)   (*((volatile unsigned int*) MIS_ACPU_CLK90K_LO_reg)=data)
+#define get_MIS_ACPU_CLK90K_LO_reg   (*((volatile unsigned int*) MIS_ACPU_CLK90K_LO_reg))
+#define MIS_ACPU_CLK90K_LO_inst_adr                                                  "0x0053"
+#define MIS_ACPU_CLK90K_LO_inst                                                      0x0053
+#define MIS_ACPU_CLK90K_LO_val_shift                                                 (0)
+#define MIS_ACPU_CLK90K_LO_val_mask                                                  (0xFFFFFFFF)
+#define MIS_ACPU_CLK90K_LO_val(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define MIS_ACPU_CLK90K_LO_val_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define MIS_ACPU_CLK90K_LO_get_val(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_ACPU_CLK90K_HI                                                           0x1801B550
+#define MIS_ACPU_CLK90K_HI_reg_addr                                                  "0xB801B550"
+#define MIS_ACPU_CLK90K_HI_reg                                                       0xB801B550
+#define set_MIS_ACPU_CLK90K_HI_reg(data)   (*((volatile unsigned int*) MIS_ACPU_CLK90K_HI_reg)=data)
+#define get_MIS_ACPU_CLK90K_HI_reg   (*((volatile unsigned int*) MIS_ACPU_CLK90K_HI_reg))
+#define MIS_ACPU_CLK90K_HI_inst_adr                                                  "0x0054"
+#define MIS_ACPU_CLK90K_HI_inst                                                      0x0054
+#define MIS_ACPU_CLK90K_HI_val_shift                                                 (0)
+#define MIS_ACPU_CLK90K_HI_val_mask                                                  (0x0000FFFF)
+#define MIS_ACPU_CLK90K_HI_val(data)                                                 (0x0000FFFF&((data)<<0))
+#define MIS_ACPU_CLK90K_HI_val_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define MIS_ACPU_CLK90K_HI_get_val(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_PCR_CLK90K_CTRL                                                          0x1801B570
+#define MIS_PCR_CLK90K_CTRL_reg_addr                                                 "0xB801B570"
+#define MIS_PCR_CLK90K_CTRL_reg                                                      0xB801B570
+#define set_MIS_PCR_CLK90K_CTRL_reg(data)   (*((volatile unsigned int*) MIS_PCR_CLK90K_CTRL_reg)=data)
+#define get_MIS_PCR_CLK90K_CTRL_reg   (*((volatile unsigned int*) MIS_PCR_CLK90K_CTRL_reg))
+#define MIS_PCR_CLK90K_CTRL_inst_adr                                                 "0x005C"
+#define MIS_PCR_CLK90K_CTRL_inst                                                     0x005C
+#define MIS_PCR_CLK90K_CTRL_en_shift                                                 (0)
+#define MIS_PCR_CLK90K_CTRL_en_mask                                                  (0x00000001)
+#define MIS_PCR_CLK90K_CTRL_en(data)                                                 (0x00000001&((data)<<0))
+#define MIS_PCR_CLK90K_CTRL_en_src(data)                                             ((0x00000001&(data))>>0)
+#define MIS_PCR_CLK90K_CTRL_get_en(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MIS_PCR_SCPU_CLK27M_90K                                                      0x1801B574
+#define MIS_PCR_SCPU_CLK27M_90K_reg_addr                                             "0xB801B574"
+#define MIS_PCR_SCPU_CLK27M_90K_reg                                                  0xB801B574
+#define set_MIS_PCR_SCPU_CLK27M_90K_reg(data)   (*((volatile unsigned int*) MIS_PCR_SCPU_CLK27M_90K_reg)=data)
+#define get_MIS_PCR_SCPU_CLK27M_90K_reg   (*((volatile unsigned int*) MIS_PCR_SCPU_CLK27M_90K_reg))
+#define MIS_PCR_SCPU_CLK27M_90K_inst_adr                                             "0x005D"
+#define MIS_PCR_SCPU_CLK27M_90K_inst                                                 0x005D
+#define MIS_PCR_SCPU_CLK27M_90K_cnt_shift                                            (0)
+#define MIS_PCR_SCPU_CLK27M_90K_cnt_mask                                             (0x000001FF)
+#define MIS_PCR_SCPU_CLK27M_90K_cnt(data)                                            (0x000001FF&((data)<<0))
+#define MIS_PCR_SCPU_CLK27M_90K_cnt_src(data)                                        ((0x000001FF&(data))>>0)
+#define MIS_PCR_SCPU_CLK27M_90K_get_cnt(data)                                        ((0x000001FF&(data))>>0)
+
+
+#define MIS_PCR_SCPU_CLK90K_LO                                                       0x1801B578
+#define MIS_PCR_SCPU_CLK90K_LO_reg_addr                                              "0xB801B578"
+#define MIS_PCR_SCPU_CLK90K_LO_reg                                                   0xB801B578
+#define set_MIS_PCR_SCPU_CLK90K_LO_reg(data)   (*((volatile unsigned int*) MIS_PCR_SCPU_CLK90K_LO_reg)=data)
+#define get_MIS_PCR_SCPU_CLK90K_LO_reg   (*((volatile unsigned int*) MIS_PCR_SCPU_CLK90K_LO_reg))
+#define MIS_PCR_SCPU_CLK90K_LO_inst_adr                                              "0x005E"
+#define MIS_PCR_SCPU_CLK90K_LO_inst                                                  0x005E
+#define MIS_PCR_SCPU_CLK90K_LO_val_shift                                             (0)
+#define MIS_PCR_SCPU_CLK90K_LO_val_mask                                              (0xFFFFFFFF)
+#define MIS_PCR_SCPU_CLK90K_LO_val(data)                                             (0xFFFFFFFF&((data)<<0))
+#define MIS_PCR_SCPU_CLK90K_LO_val_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define MIS_PCR_SCPU_CLK90K_LO_get_val(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_PCR_SCPU_CLK90K_HI                                                       0x1801B57C
+#define MIS_PCR_SCPU_CLK90K_HI_reg_addr                                              "0xB801B57C"
+#define MIS_PCR_SCPU_CLK90K_HI_reg                                                   0xB801B57C
+#define set_MIS_PCR_SCPU_CLK90K_HI_reg(data)   (*((volatile unsigned int*) MIS_PCR_SCPU_CLK90K_HI_reg)=data)
+#define get_MIS_PCR_SCPU_CLK90K_HI_reg   (*((volatile unsigned int*) MIS_PCR_SCPU_CLK90K_HI_reg))
+#define MIS_PCR_SCPU_CLK90K_HI_inst_adr                                              "0x005F"
+#define MIS_PCR_SCPU_CLK90K_HI_inst                                                  0x005F
+#define MIS_PCR_SCPU_CLK90K_HI_val_shift                                             (0)
+#define MIS_PCR_SCPU_CLK90K_HI_val_mask                                              (0x0000FFFF)
+#define MIS_PCR_SCPU_CLK90K_HI_val(data)                                             (0x0000FFFF&((data)<<0))
+#define MIS_PCR_SCPU_CLK90K_HI_val_src(data)                                         ((0x0000FFFF&(data))>>0)
+#define MIS_PCR_SCPU_CLK90K_HI_get_val(data)                                         ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_PCR_ACPU_CLK27M_90K                                                      0x1801B580
+#define MIS_PCR_ACPU_CLK27M_90K_reg_addr                                             "0xB801B580"
+#define MIS_PCR_ACPU_CLK27M_90K_reg                                                  0xB801B580
+#define set_MIS_PCR_ACPU_CLK27M_90K_reg(data)   (*((volatile unsigned int*) MIS_PCR_ACPU_CLK27M_90K_reg)=data)
+#define get_MIS_PCR_ACPU_CLK27M_90K_reg   (*((volatile unsigned int*) MIS_PCR_ACPU_CLK27M_90K_reg))
+#define MIS_PCR_ACPU_CLK27M_90K_inst_adr                                             "0x0060"
+#define MIS_PCR_ACPU_CLK27M_90K_inst                                                 0x0060
+#define MIS_PCR_ACPU_CLK27M_90K_cnt_shift                                            (0)
+#define MIS_PCR_ACPU_CLK27M_90K_cnt_mask                                             (0x000001FF)
+#define MIS_PCR_ACPU_CLK27M_90K_cnt(data)                                            (0x000001FF&((data)<<0))
+#define MIS_PCR_ACPU_CLK27M_90K_cnt_src(data)                                        ((0x000001FF&(data))>>0)
+#define MIS_PCR_ACPU_CLK27M_90K_get_cnt(data)                                        ((0x000001FF&(data))>>0)
+
+
+#define MIS_PCR_ACPU_CLK90K_LO                                                       0x1801B584
+#define MIS_PCR_ACPU_CLK90K_LO_reg_addr                                              "0xB801B584"
+#define MIS_PCR_ACPU_CLK90K_LO_reg                                                   0xB801B584
+#define set_MIS_PCR_ACPU_CLK90K_LO_reg(data)   (*((volatile unsigned int*) MIS_PCR_ACPU_CLK90K_LO_reg)=data)
+#define get_MIS_PCR_ACPU_CLK90K_LO_reg   (*((volatile unsigned int*) MIS_PCR_ACPU_CLK90K_LO_reg))
+#define MIS_PCR_ACPU_CLK90K_LO_inst_adr                                              "0x0061"
+#define MIS_PCR_ACPU_CLK90K_LO_inst                                                  0x0061
+#define MIS_PCR_ACPU_CLK90K_LO_val_shift                                             (0)
+#define MIS_PCR_ACPU_CLK90K_LO_val_mask                                              (0xFFFFFFFF)
+#define MIS_PCR_ACPU_CLK90K_LO_val(data)                                             (0xFFFFFFFF&((data)<<0))
+#define MIS_PCR_ACPU_CLK90K_LO_val_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define MIS_PCR_ACPU_CLK90K_LO_get_val(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_PCR_ACPU_CLK90K_HI                                                       0x1801B588
+#define MIS_PCR_ACPU_CLK90K_HI_reg_addr                                              "0xB801B588"
+#define MIS_PCR_ACPU_CLK90K_HI_reg                                                   0xB801B588
+#define set_MIS_PCR_ACPU_CLK90K_HI_reg(data)   (*((volatile unsigned int*) MIS_PCR_ACPU_CLK90K_HI_reg)=data)
+#define get_MIS_PCR_ACPU_CLK90K_HI_reg   (*((volatile unsigned int*) MIS_PCR_ACPU_CLK90K_HI_reg))
+#define MIS_PCR_ACPU_CLK90K_HI_inst_adr                                              "0x0062"
+#define MIS_PCR_ACPU_CLK90K_HI_inst                                                  0x0062
+#define MIS_PCR_ACPU_CLK90K_HI_val_shift                                             (0)
+#define MIS_PCR_ACPU_CLK90K_HI_val_mask                                              (0x0000FFFF)
+#define MIS_PCR_ACPU_CLK90K_HI_val(data)                                             (0x0000FFFF&((data)<<0))
+#define MIS_PCR_ACPU_CLK90K_HI_val_src(data)                                         ((0x0000FFFF&(data))>>0)
+#define MIS_PCR_ACPU_CLK90K_HI_get_val(data)                                         ((0x0000FFFF&(data))>>0)
+
+
+#define MIS_TCWCR                                                                    0x1801B5B0
+#define MIS_TCWCR_reg_addr                                                           "0xB801B5B0"
+#define MIS_TCWCR_reg                                                                0xB801B5B0
+#define set_MIS_TCWCR_reg(data)   (*((volatile unsigned int*) MIS_TCWCR_reg)=data)
+#define get_MIS_TCWCR_reg   (*((volatile unsigned int*) MIS_TCWCR_reg))
+#define MIS_TCWCR_inst_adr                                                           "0x006C"
+#define MIS_TCWCR_inst                                                               0x006C
+#define MIS_TCWCR_wd_int_en_shift                                                    (31)
+#define MIS_TCWCR_wd_int_en_mask                                                     (0x80000000)
+#define MIS_TCWCR_wd_int_en(data)                                                    (0x80000000&((data)<<31))
+#define MIS_TCWCR_wd_int_en_src(data)                                                ((0x80000000&(data))>>31)
+#define MIS_TCWCR_get_wd_int_en(data)                                                ((0x80000000&(data))>>31)
+#define MIS_TCWCR_nmic_shift                                                         (12)
+#define MIS_TCWCR_nmic_mask                                                          (0x0000F000)
+#define MIS_TCWCR_nmic(data)                                                         (0x0000F000&((data)<<12))
+#define MIS_TCWCR_nmic_src(data)                                                     ((0x0000F000&(data))>>12)
+#define MIS_TCWCR_get_nmic(data)                                                     ((0x0000F000&(data))>>12)
+#define MIS_TCWCR_wdc_shift                                                          (8)
+#define MIS_TCWCR_wdc_mask                                                           (0x00000F00)
+#define MIS_TCWCR_wdc(data)                                                          (0x00000F00&((data)<<8))
+#define MIS_TCWCR_wdc_src(data)                                                      ((0x00000F00&(data))>>8)
+#define MIS_TCWCR_get_wdc(data)                                                      ((0x00000F00&(data))>>8)
+#define MIS_TCWCR_wden_shift                                                         (0)
+#define MIS_TCWCR_wden_mask                                                          (0x000000FF)
+#define MIS_TCWCR_wden(data)                                                         (0x000000FF&((data)<<0))
+#define MIS_TCWCR_wden_src(data)                                                     ((0x000000FF&(data))>>0)
+#define MIS_TCWCR_get_wden(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define MIS_TCWTR                                                                    0x1801B5B4
+#define MIS_TCWTR_reg_addr                                                           "0xB801B5B4"
+#define MIS_TCWTR_reg                                                                0xB801B5B4
+#define set_MIS_TCWTR_reg(data)   (*((volatile unsigned int*) MIS_TCWTR_reg)=data)
+#define get_MIS_TCWTR_reg   (*((volatile unsigned int*) MIS_TCWTR_reg))
+#define MIS_TCWTR_inst_adr                                                           "0x006D"
+#define MIS_TCWTR_inst                                                               0x006D
+#define MIS_TCWTR_wdclr_shift                                                        (0)
+#define MIS_TCWTR_wdclr_mask                                                         (0x00000001)
+#define MIS_TCWTR_wdclr(data)                                                        (0x00000001&((data)<<0))
+#define MIS_TCWTR_wdclr_src(data)                                                    ((0x00000001&(data))>>0)
+#define MIS_TCWTR_get_wdclr(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_TCWNMI                                                                   0x1801B5B8
+#define MIS_TCWNMI_reg_addr                                                          "0xB801B5B8"
+#define MIS_TCWNMI_reg                                                               0xB801B5B8
+#define set_MIS_TCWNMI_reg(data)   (*((volatile unsigned int*) MIS_TCWNMI_reg)=data)
+#define get_MIS_TCWNMI_reg   (*((volatile unsigned int*) MIS_TCWNMI_reg))
+#define MIS_TCWNMI_inst_adr                                                          "0x006E"
+#define MIS_TCWNMI_inst                                                              0x006E
+#define MIS_TCWNMI_sel_shift                                                         (0)
+#define MIS_TCWNMI_sel_mask                                                          (0xFFFFFFFF)
+#define MIS_TCWNMI_sel(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define MIS_TCWNMI_sel_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define MIS_TCWNMI_get_sel(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_TCWOV                                                                    0x1801B5BC
+#define MIS_TCWOV_reg_addr                                                           "0xB801B5BC"
+#define MIS_TCWOV_reg                                                                0xB801B5BC
+#define set_MIS_TCWOV_reg(data)   (*((volatile unsigned int*) MIS_TCWOV_reg)=data)
+#define get_MIS_TCWOV_reg   (*((volatile unsigned int*) MIS_TCWOV_reg))
+#define MIS_TCWOV_inst_adr                                                           "0x006F"
+#define MIS_TCWOV_inst                                                               0x006F
+#define MIS_TCWOV_sel_shift                                                          (0)
+#define MIS_TCWOV_sel_mask                                                           (0xFFFFFFFF)
+#define MIS_TCWOV_sel(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define MIS_TCWOV_sel_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define MIS_TCWOV_get_sel(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_TCWCR_SWC                                                                0x1801B5C0
+#define MIS_TCWCR_SWC_reg_addr                                                       "0xB801B5C0"
+#define MIS_TCWCR_SWC_reg                                                            0xB801B5C0
+#define set_MIS_TCWCR_SWC_reg(data)   (*((volatile unsigned int*) MIS_TCWCR_SWC_reg)=data)
+#define get_MIS_TCWCR_SWC_reg   (*((volatile unsigned int*) MIS_TCWCR_SWC_reg))
+#define MIS_TCWCR_SWC_inst_adr                                                       "0x0070"
+#define MIS_TCWCR_SWC_inst                                                           0x0070
+#define MIS_TCWCR_SWC_wd_int_en_shift                                                (31)
+#define MIS_TCWCR_SWC_wd_int_en_mask                                                 (0x80000000)
+#define MIS_TCWCR_SWC_wd_int_en(data)                                                (0x80000000&((data)<<31))
+#define MIS_TCWCR_SWC_wd_int_en_src(data)                                            ((0x80000000&(data))>>31)
+#define MIS_TCWCR_SWC_get_wd_int_en(data)                                            ((0x80000000&(data))>>31)
+#define MIS_TCWCR_SWC_nmic_shift                                                     (12)
+#define MIS_TCWCR_SWC_nmic_mask                                                      (0x0000F000)
+#define MIS_TCWCR_SWC_nmic(data)                                                     (0x0000F000&((data)<<12))
+#define MIS_TCWCR_SWC_nmic_src(data)                                                 ((0x0000F000&(data))>>12)
+#define MIS_TCWCR_SWC_get_nmic(data)                                                 ((0x0000F000&(data))>>12)
+#define MIS_TCWCR_SWC_wdc_shift                                                      (8)
+#define MIS_TCWCR_SWC_wdc_mask                                                       (0x00000F00)
+#define MIS_TCWCR_SWC_wdc(data)                                                      (0x00000F00&((data)<<8))
+#define MIS_TCWCR_SWC_wdc_src(data)                                                  ((0x00000F00&(data))>>8)
+#define MIS_TCWCR_SWC_get_wdc(data)                                                  ((0x00000F00&(data))>>8)
+#define MIS_TCWCR_SWC_wden_shift                                                     (0)
+#define MIS_TCWCR_SWC_wden_mask                                                      (0x000000FF)
+#define MIS_TCWCR_SWC_wden(data)                                                     (0x000000FF&((data)<<0))
+#define MIS_TCWCR_SWC_wden_src(data)                                                 ((0x000000FF&(data))>>0)
+#define MIS_TCWCR_SWC_get_wden(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define MIS_TCWTR_SWC                                                                0x1801B5C4
+#define MIS_TCWTR_SWC_reg_addr                                                       "0xB801B5C4"
+#define MIS_TCWTR_SWC_reg                                                            0xB801B5C4
+#define set_MIS_TCWTR_SWC_reg(data)   (*((volatile unsigned int*) MIS_TCWTR_SWC_reg)=data)
+#define get_MIS_TCWTR_SWC_reg   (*((volatile unsigned int*) MIS_TCWTR_SWC_reg))
+#define MIS_TCWTR_SWC_inst_adr                                                       "0x0071"
+#define MIS_TCWTR_SWC_inst                                                           0x0071
+#define MIS_TCWTR_SWC_wdclr_shift                                                    (0)
+#define MIS_TCWTR_SWC_wdclr_mask                                                     (0x00000001)
+#define MIS_TCWTR_SWC_wdclr(data)                                                    (0x00000001&((data)<<0))
+#define MIS_TCWTR_SWC_wdclr_src(data)                                                ((0x00000001&(data))>>0)
+#define MIS_TCWTR_SWC_get_wdclr(data)                                                ((0x00000001&(data))>>0)
+
+
+#define MIS_TCWNMI_SWC                                                               0x1801B5C8
+#define MIS_TCWNMI_SWC_reg_addr                                                      "0xB801B5C8"
+#define MIS_TCWNMI_SWC_reg                                                           0xB801B5C8
+#define set_MIS_TCWNMI_SWC_reg(data)   (*((volatile unsigned int*) MIS_TCWNMI_SWC_reg)=data)
+#define get_MIS_TCWNMI_SWC_reg   (*((volatile unsigned int*) MIS_TCWNMI_SWC_reg))
+#define MIS_TCWNMI_SWC_inst_adr                                                      "0x0072"
+#define MIS_TCWNMI_SWC_inst                                                          0x0072
+#define MIS_TCWNMI_SWC_sel_shift                                                     (0)
+#define MIS_TCWNMI_SWC_sel_mask                                                      (0xFFFFFFFF)
+#define MIS_TCWNMI_SWC_sel(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define MIS_TCWNMI_SWC_sel_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define MIS_TCWNMI_SWC_get_sel(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_TCWOV_SWC                                                                0x1801B5CC
+#define MIS_TCWOV_SWC_reg_addr                                                       "0xB801B5CC"
+#define MIS_TCWOV_SWC_reg                                                            0xB801B5CC
+#define set_MIS_TCWOV_SWC_reg(data)   (*((volatile unsigned int*) MIS_TCWOV_SWC_reg)=data)
+#define get_MIS_TCWOV_SWC_reg   (*((volatile unsigned int*) MIS_TCWOV_SWC_reg))
+#define MIS_TCWOV_SWC_inst_adr                                                       "0x0073"
+#define MIS_TCWOV_SWC_inst                                                           0x0073
+#define MIS_TCWOV_SWC_sel_shift                                                      (0)
+#define MIS_TCWOV_SWC_sel_mask                                                       (0xFFFFFFFF)
+#define MIS_TCWOV_SWC_sel(data)                                                      (0xFFFFFFFF&((data)<<0))
+#define MIS_TCWOV_SWC_sel_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
+#define MIS_TCWOV_SWC_get_sel(data)                                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define MIS_RTCSEC                                                                   0x1801B600
+#define MIS_RTCSEC_reg_addr                                                          "0xB801B600"
+#define MIS_RTCSEC_reg                                                               0xB801B600
+#define set_MIS_RTCSEC_reg(data)   (*((volatile unsigned int*) MIS_RTCSEC_reg)=data)
+#define get_MIS_RTCSEC_reg   (*((volatile unsigned int*) MIS_RTCSEC_reg))
+#define MIS_RTCSEC_inst_adr                                                          "0x0080"
+#define MIS_RTCSEC_inst                                                              0x0080
+#define MIS_RTCSEC_rtcsec_shift                                                      (0)
+#define MIS_RTCSEC_rtcsec_mask                                                       (0x0000007F)
+#define MIS_RTCSEC_rtcsec(data)                                                      (0x0000007F&((data)<<0))
+#define MIS_RTCSEC_rtcsec_src(data)                                                  ((0x0000007F&(data))>>0)
+#define MIS_RTCSEC_get_rtcsec(data)                                                  ((0x0000007F&(data))>>0)
+
+
+#define MIS_RTCMIN                                                                   0x1801B604
+#define MIS_RTCMIN_reg_addr                                                          "0xB801B604"
+#define MIS_RTCMIN_reg                                                               0xB801B604
+#define set_MIS_RTCMIN_reg(data)   (*((volatile unsigned int*) MIS_RTCMIN_reg)=data)
+#define get_MIS_RTCMIN_reg   (*((volatile unsigned int*) MIS_RTCMIN_reg))
+#define MIS_RTCMIN_inst_adr                                                          "0x0081"
+#define MIS_RTCMIN_inst                                                              0x0081
+#define MIS_RTCMIN_rtcmin_shift                                                      (0)
+#define MIS_RTCMIN_rtcmin_mask                                                       (0x0000003F)
+#define MIS_RTCMIN_rtcmin(data)                                                      (0x0000003F&((data)<<0))
+#define MIS_RTCMIN_rtcmin_src(data)                                                  ((0x0000003F&(data))>>0)
+#define MIS_RTCMIN_get_rtcmin(data)                                                  ((0x0000003F&(data))>>0)
+
+
+#define MIS_RTCHR                                                                    0x1801B608
+#define MIS_RTCHR_reg_addr                                                           "0xB801B608"
+#define MIS_RTCHR_reg                                                                0xB801B608
+#define set_MIS_RTCHR_reg(data)   (*((volatile unsigned int*) MIS_RTCHR_reg)=data)
+#define get_MIS_RTCHR_reg   (*((volatile unsigned int*) MIS_RTCHR_reg))
+#define MIS_RTCHR_inst_adr                                                           "0x0082"
+#define MIS_RTCHR_inst                                                               0x0082
+#define MIS_RTCHR_rtchr_shift                                                        (0)
+#define MIS_RTCHR_rtchr_mask                                                         (0x0000001F)
+#define MIS_RTCHR_rtchr(data)                                                        (0x0000001F&((data)<<0))
+#define MIS_RTCHR_rtchr_src(data)                                                    ((0x0000001F&(data))>>0)
+#define MIS_RTCHR_get_rtchr(data)                                                    ((0x0000001F&(data))>>0)
+
+
+#define MIS_RTCDATE1                                                                 0x1801B60C
+#define MIS_RTCDATE1_reg_addr                                                        "0xB801B60C"
+#define MIS_RTCDATE1_reg                                                             0xB801B60C
+#define set_MIS_RTCDATE1_reg(data)   (*((volatile unsigned int*) MIS_RTCDATE1_reg)=data)
+#define get_MIS_RTCDATE1_reg   (*((volatile unsigned int*) MIS_RTCDATE1_reg))
+#define MIS_RTCDATE1_inst_adr                                                        "0x0083"
+#define MIS_RTCDATE1_inst                                                            0x0083
+#define MIS_RTCDATE1_rtcdate1_shift                                                  (0)
+#define MIS_RTCDATE1_rtcdate1_mask                                                   (0x000000FF)
+#define MIS_RTCDATE1_rtcdate1(data)                                                  (0x000000FF&((data)<<0))
+#define MIS_RTCDATE1_rtcdate1_src(data)                                              ((0x000000FF&(data))>>0)
+#define MIS_RTCDATE1_get_rtcdate1(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define MIS_RTCDATE2                                                                 0x1801B610
+#define MIS_RTCDATE2_reg_addr                                                        "0xB801B610"
+#define MIS_RTCDATE2_reg                                                             0xB801B610
+#define set_MIS_RTCDATE2_reg(data)   (*((volatile unsigned int*) MIS_RTCDATE2_reg)=data)
+#define get_MIS_RTCDATE2_reg   (*((volatile unsigned int*) MIS_RTCDATE2_reg))
+#define MIS_RTCDATE2_inst_adr                                                        "0x0084"
+#define MIS_RTCDATE2_inst                                                            0x0084
+#define MIS_RTCDATE2_rtcdate2_shift                                                  (0)
+#define MIS_RTCDATE2_rtcdate2_mask                                                   (0x0000007F)
+#define MIS_RTCDATE2_rtcdate2(data)                                                  (0x0000007F&((data)<<0))
+#define MIS_RTCDATE2_rtcdate2_src(data)                                              ((0x0000007F&(data))>>0)
+#define MIS_RTCDATE2_get_rtcdate2(data)                                              ((0x0000007F&(data))>>0)
+
+
+#define MIS_ALMMIN                                                                   0x1801B614
+#define MIS_ALMMIN_reg_addr                                                          "0xB801B614"
+#define MIS_ALMMIN_reg                                                               0xB801B614
+#define set_MIS_ALMMIN_reg(data)   (*((volatile unsigned int*) MIS_ALMMIN_reg)=data)
+#define get_MIS_ALMMIN_reg   (*((volatile unsigned int*) MIS_ALMMIN_reg))
+#define MIS_ALMMIN_inst_adr                                                          "0x0085"
+#define MIS_ALMMIN_inst                                                              0x0085
+#define MIS_ALMMIN_almmin_shift                                                      (0)
+#define MIS_ALMMIN_almmin_mask                                                       (0x0000003F)
+#define MIS_ALMMIN_almmin(data)                                                      (0x0000003F&((data)<<0))
+#define MIS_ALMMIN_almmin_src(data)                                                  ((0x0000003F&(data))>>0)
+#define MIS_ALMMIN_get_almmin(data)                                                  ((0x0000003F&(data))>>0)
+
+
+#define MIS_ALMHR                                                                    0x1801B618
+#define MIS_ALMHR_reg_addr                                                           "0xB801B618"
+#define MIS_ALMHR_reg                                                                0xB801B618
+#define set_MIS_ALMHR_reg(data)   (*((volatile unsigned int*) MIS_ALMHR_reg)=data)
+#define get_MIS_ALMHR_reg   (*((volatile unsigned int*) MIS_ALMHR_reg))
+#define MIS_ALMHR_inst_adr                                                           "0x0086"
+#define MIS_ALMHR_inst                                                               0x0086
+#define MIS_ALMHR_almhr_shift                                                        (0)
+#define MIS_ALMHR_almhr_mask                                                         (0x0000001F)
+#define MIS_ALMHR_almhr(data)                                                        (0x0000001F&((data)<<0))
+#define MIS_ALMHR_almhr_src(data)                                                    ((0x0000001F&(data))>>0)
+#define MIS_ALMHR_get_almhr(data)                                                    ((0x0000001F&(data))>>0)
+
+
+#define MIS_ALMDATE1                                                                 0x1801B61C
+#define MIS_ALMDATE1_reg_addr                                                        "0xB801B61C"
+#define MIS_ALMDATE1_reg                                                             0xB801B61C
+#define set_MIS_ALMDATE1_reg(data)   (*((volatile unsigned int*) MIS_ALMDATE1_reg)=data)
+#define get_MIS_ALMDATE1_reg   (*((volatile unsigned int*) MIS_ALMDATE1_reg))
+#define MIS_ALMDATE1_inst_adr                                                        "0x0087"
+#define MIS_ALMDATE1_inst                                                            0x0087
+#define MIS_ALMDATE1_almdate1_shift                                                  (0)
+#define MIS_ALMDATE1_almdate1_mask                                                   (0x000000FF)
+#define MIS_ALMDATE1_almdate1(data)                                                  (0x000000FF&((data)<<0))
+#define MIS_ALMDATE1_almdate1_src(data)                                              ((0x000000FF&(data))>>0)
+#define MIS_ALMDATE1_get_almdate1(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define MIS_ALMDATE2                                                                 0x1801B620
+#define MIS_ALMDATE2_reg_addr                                                        "0xB801B620"
+#define MIS_ALMDATE2_reg                                                             0xB801B620
+#define set_MIS_ALMDATE2_reg(data)   (*((volatile unsigned int*) MIS_ALMDATE2_reg)=data)
+#define get_MIS_ALMDATE2_reg   (*((volatile unsigned int*) MIS_ALMDATE2_reg))
+#define MIS_ALMDATE2_inst_adr                                                        "0x0088"
+#define MIS_ALMDATE2_inst                                                            0x0088
+#define MIS_ALMDATE2_almdate2_shift                                                  (0)
+#define MIS_ALMDATE2_almdate2_mask                                                   (0x0000007F)
+#define MIS_ALMDATE2_almdate2(data)                                                  (0x0000007F&((data)<<0))
+#define MIS_ALMDATE2_almdate2_src(data)                                              ((0x0000007F&(data))>>0)
+#define MIS_ALMDATE2_get_almdate2(data)                                              ((0x0000007F&(data))>>0)
+
+
+#define MIS_RTCSTOP                                                                  0x1801B624
+#define MIS_RTCSTOP_reg_addr                                                         "0xB801B624"
+#define MIS_RTCSTOP_reg                                                              0xB801B624
+#define set_MIS_RTCSTOP_reg(data)   (*((volatile unsigned int*) MIS_RTCSTOP_reg)=data)
+#define get_MIS_RTCSTOP_reg   (*((volatile unsigned int*) MIS_RTCSTOP_reg))
+#define MIS_RTCSTOP_inst_adr                                                         "0x0089"
+#define MIS_RTCSTOP_inst                                                             0x0089
+#define MIS_RTCSTOP_vref_shift                                                       (1)
+#define MIS_RTCSTOP_vref_mask                                                        (0x00000006)
+#define MIS_RTCSTOP_vref(data)                                                       (0x00000006&((data)<<1))
+#define MIS_RTCSTOP_vref_src(data)                                                   ((0x00000006&(data))>>1)
+#define MIS_RTCSTOP_get_vref(data)                                                   ((0x00000006&(data))>>1)
+#define MIS_RTCSTOP_rtcstop_shift                                                    (0)
+#define MIS_RTCSTOP_rtcstop_mask                                                     (0x00000001)
+#define MIS_RTCSTOP_rtcstop(data)                                                    (0x00000001&((data)<<0))
+#define MIS_RTCSTOP_rtcstop_src(data)                                                ((0x00000001&(data))>>0)
+#define MIS_RTCSTOP_get_rtcstop(data)                                                ((0x00000001&(data))>>0)
+
+
+#define MIS_RTCACR                                                                   0x1801B628
+#define MIS_RTCACR_reg_addr                                                          "0xB801B628"
+#define MIS_RTCACR_reg                                                               0xB801B628
+#define set_MIS_RTCACR_reg(data)   (*((volatile unsigned int*) MIS_RTCACR_reg)=data)
+#define get_MIS_RTCACR_reg   (*((volatile unsigned int*) MIS_RTCACR_reg))
+#define MIS_RTCACR_inst_adr                                                          "0x008A"
+#define MIS_RTCACR_inst                                                              0x008A
+#define MIS_RTCACR_rtcpwr_shift                                                      (7)
+#define MIS_RTCACR_rtcpwr_mask                                                       (0x00000080)
+#define MIS_RTCACR_rtcpwr(data)                                                      (0x00000080&((data)<<7))
+#define MIS_RTCACR_rtcpwr_src(data)                                                  ((0x00000080&(data))>>7)
+#define MIS_RTCACR_get_rtcpwr(data)                                                  ((0x00000080&(data))>>7)
+#define MIS_RTCACR_co_shift                                                          (5)
+#define MIS_RTCACR_co_mask                                                           (0x00000060)
+#define MIS_RTCACR_co(data)                                                          (0x00000060&((data)<<5))
+#define MIS_RTCACR_co_src(data)                                                      ((0x00000060&(data))>>5)
+#define MIS_RTCACR_get_co(data)                                                      ((0x00000060&(data))>>5)
+#define MIS_RTCACR_ci_shift                                                          (3)
+#define MIS_RTCACR_ci_mask                                                           (0x00000018)
+#define MIS_RTCACR_ci(data)                                                          (0x00000018&((data)<<3))
+#define MIS_RTCACR_ci_src(data)                                                      ((0x00000018&(data))>>3)
+#define MIS_RTCACR_get_ci(data)                                                      ((0x00000018&(data))>>3)
+#define MIS_RTCACR_clksel_shift                                                      (2)
+#define MIS_RTCACR_clksel_mask                                                       (0x00000004)
+#define MIS_RTCACR_clksel(data)                                                      (0x00000004&((data)<<2))
+#define MIS_RTCACR_clksel_src(data)                                                  ((0x00000004&(data))>>2)
+#define MIS_RTCACR_get_clksel(data)                                                  ((0x00000004&(data))>>2)
+#define MIS_RTCACR_bc_shift                                                          (0)
+#define MIS_RTCACR_bc_mask                                                           (0x00000003)
+#define MIS_RTCACR_bc(data)                                                          (0x00000003&((data)<<0))
+#define MIS_RTCACR_bc_src(data)                                                      ((0x00000003&(data))>>0)
+#define MIS_RTCACR_get_bc(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define MIS_RTCEN                                                                    0x1801B62C
+#define MIS_RTCEN_reg_addr                                                           "0xB801B62C"
+#define MIS_RTCEN_reg                                                                0xB801B62C
+#define set_MIS_RTCEN_reg(data)   (*((volatile unsigned int*) MIS_RTCEN_reg)=data)
+#define get_MIS_RTCEN_reg   (*((volatile unsigned int*) MIS_RTCEN_reg))
+#define MIS_RTCEN_inst_adr                                                           "0x008B"
+#define MIS_RTCEN_inst                                                               0x008B
+#define MIS_RTCEN_rtcen_shift                                                        (0)
+#define MIS_RTCEN_rtcen_mask                                                         (0x000000FF)
+#define MIS_RTCEN_rtcen(data)                                                        (0x000000FF&((data)<<0))
+#define MIS_RTCEN_rtcen_src(data)                                                    ((0x000000FF&(data))>>0)
+#define MIS_RTCEN_get_rtcen(data)                                                    ((0x000000FF&(data))>>0)
+
+
+#define MIS_RTCCR                                                                    0x1801B630
+#define MIS_RTCCR_reg_addr                                                           "0xB801B630"
+#define MIS_RTCCR_reg                                                                0xB801B630
+#define set_MIS_RTCCR_reg(data)   (*((volatile unsigned int*) MIS_RTCCR_reg)=data)
+#define get_MIS_RTCCR_reg   (*((volatile unsigned int*) MIS_RTCCR_reg))
+#define MIS_RTCCR_inst_adr                                                           "0x008C"
+#define MIS_RTCCR_inst                                                               0x008C
+#define MIS_RTCCR_rtcrst_shift                                                       (6)
+#define MIS_RTCCR_rtcrst_mask                                                        (0x00000040)
+#define MIS_RTCCR_rtcrst(data)                                                       (0x00000040&((data)<<6))
+#define MIS_RTCCR_rtcrst_src(data)                                                   ((0x00000040&(data))>>6)
+#define MIS_RTCCR_get_rtcrst(data)                                                   ((0x00000040&(data))>>6)
+#define MIS_RTCCR_dainte_shift                                                       (3)
+#define MIS_RTCCR_dainte_mask                                                        (0x00000008)
+#define MIS_RTCCR_dainte(data)                                                       (0x00000008&((data)<<3))
+#define MIS_RTCCR_dainte_src(data)                                                   ((0x00000008&(data))>>3)
+#define MIS_RTCCR_get_dainte(data)                                                   ((0x00000008&(data))>>3)
+#define MIS_RTCCR_huinte_shift                                                       (2)
+#define MIS_RTCCR_huinte_mask                                                        (0x00000004)
+#define MIS_RTCCR_huinte(data)                                                       (0x00000004&((data)<<2))
+#define MIS_RTCCR_huinte_src(data)                                                   ((0x00000004&(data))>>2)
+#define MIS_RTCCR_get_huinte(data)                                                   ((0x00000004&(data))>>2)
+#define MIS_RTCCR_muinte_shift                                                       (1)
+#define MIS_RTCCR_muinte_mask                                                        (0x00000002)
+#define MIS_RTCCR_muinte(data)                                                       (0x00000002&((data)<<1))
+#define MIS_RTCCR_muinte_src(data)                                                   ((0x00000002&(data))>>1)
+#define MIS_RTCCR_get_muinte(data)                                                   ((0x00000002&(data))>>1)
+#define MIS_RTCCR_hsuinte_shift                                                      (0)
+#define MIS_RTCCR_hsuinte_mask                                                       (0x00000001)
+#define MIS_RTCCR_hsuinte(data)                                                      (0x00000001&((data)<<0))
+#define MIS_RTCCR_hsuinte_src(data)                                                  ((0x00000001&(data))>>0)
+#define MIS_RTCCR_get_hsuinte(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_ST_PAD0                                                                  0x1801BC00
+#define MIS_ST_PAD0_reg_addr                                                         "0xB801BC00"
+#define MIS_ST_PAD0_reg                                                              0xB801BC00
+#define set_MIS_ST_PAD0_reg(data)   (*((volatile unsigned int*) MIS_ST_PAD0_reg)=data)
+#define get_MIS_ST_PAD0_reg   (*((volatile unsigned int*) MIS_ST_PAD0_reg))
+#define MIS_ST_PAD0_inst_adr                                                         "0x0000"
+#define MIS_ST_PAD0_inst                                                             0x0000
+#define MIS_ST_PAD0_pad0_active_shift                                                (31)
+#define MIS_ST_PAD0_pad0_active_mask                                                 (0x80000000)
+#define MIS_ST_PAD0_pad0_active(data)                                                (0x80000000&((data)<<31))
+#define MIS_ST_PAD0_pad0_active_src(data)                                            ((0x80000000&(data))>>31)
+#define MIS_ST_PAD0_get_pad0_active(data)                                            ((0x80000000&(data))>>31)
+#define MIS_ST_PAD0_pad0_thred_shift                                                 (16)
+#define MIS_ST_PAD0_pad0_thred_mask                                                  (0x00FF0000)
+#define MIS_ST_PAD0_pad0_thred(data)                                                 (0x00FF0000&((data)<<16))
+#define MIS_ST_PAD0_pad0_thred_src(data)                                             ((0x00FF0000&(data))>>16)
+#define MIS_ST_PAD0_get_pad0_thred(data)                                             ((0x00FF0000&(data))>>16)
+#define MIS_ST_PAD0_pad0_sw_shift                                                    (12)
+#define MIS_ST_PAD0_pad0_sw_mask                                                     (0x0000F000)
+#define MIS_ST_PAD0_pad0_sw(data)                                                    (0x0000F000&((data)<<12))
+#define MIS_ST_PAD0_pad0_sw_src(data)                                                ((0x0000F000&(data))>>12)
+#define MIS_ST_PAD0_get_pad0_sw(data)                                                ((0x0000F000&(data))>>12)
+#define MIS_ST_PAD0_pad0_ctrl_shift                                                  (8)
+#define MIS_ST_PAD0_pad0_ctrl_mask                                                   (0x00000100)
+#define MIS_ST_PAD0_pad0_ctrl(data)                                                  (0x00000100&((data)<<8))
+#define MIS_ST_PAD0_pad0_ctrl_src(data)                                              ((0x00000100&(data))>>8)
+#define MIS_ST_PAD0_get_pad0_ctrl(data)                                              ((0x00000100&(data))>>8)
+#define MIS_ST_PAD0_adc_val0_shift                                                   (0)
+#define MIS_ST_PAD0_adc_val0_mask                                                    (0x0000003F)
+#define MIS_ST_PAD0_adc_val0(data)                                                   (0x0000003F&((data)<<0))
+#define MIS_ST_PAD0_adc_val0_src(data)                                               ((0x0000003F&(data))>>0)
+#define MIS_ST_PAD0_get_adc_val0(data)                                               ((0x0000003F&(data))>>0)
+
+
+#define MIS_ST_PAD1                                                                  0x1801BC04
+#define MIS_ST_PAD1_reg_addr                                                         "0xB801BC04"
+#define MIS_ST_PAD1_reg                                                              0xB801BC04
+#define set_MIS_ST_PAD1_reg(data)   (*((volatile unsigned int*) MIS_ST_PAD1_reg)=data)
+#define get_MIS_ST_PAD1_reg   (*((volatile unsigned int*) MIS_ST_PAD1_reg))
+#define MIS_ST_PAD1_inst_adr                                                         "0x0001"
+#define MIS_ST_PAD1_inst                                                             0x0001
+#define MIS_ST_PAD1_pad1_active_shift                                                (31)
+#define MIS_ST_PAD1_pad1_active_mask                                                 (0x80000000)
+#define MIS_ST_PAD1_pad1_active(data)                                                (0x80000000&((data)<<31))
+#define MIS_ST_PAD1_pad1_active_src(data)                                            ((0x80000000&(data))>>31)
+#define MIS_ST_PAD1_get_pad1_active(data)                                            ((0x80000000&(data))>>31)
+#define MIS_ST_PAD1_pad1_thred_shift                                                 (16)
+#define MIS_ST_PAD1_pad1_thred_mask                                                  (0x00FF0000)
+#define MIS_ST_PAD1_pad1_thred(data)                                                 (0x00FF0000&((data)<<16))
+#define MIS_ST_PAD1_pad1_thred_src(data)                                             ((0x00FF0000&(data))>>16)
+#define MIS_ST_PAD1_get_pad1_thred(data)                                             ((0x00FF0000&(data))>>16)
+#define MIS_ST_PAD1_pad1_sw_shift                                                    (12)
+#define MIS_ST_PAD1_pad1_sw_mask                                                     (0x0000F000)
+#define MIS_ST_PAD1_pad1_sw(data)                                                    (0x0000F000&((data)<<12))
+#define MIS_ST_PAD1_pad1_sw_src(data)                                                ((0x0000F000&(data))>>12)
+#define MIS_ST_PAD1_get_pad1_sw(data)                                                ((0x0000F000&(data))>>12)
+#define MIS_ST_PAD1_pad1_ctrl_shift                                                  (8)
+#define MIS_ST_PAD1_pad1_ctrl_mask                                                   (0x00000100)
+#define MIS_ST_PAD1_pad1_ctrl(data)                                                  (0x00000100&((data)<<8))
+#define MIS_ST_PAD1_pad1_ctrl_src(data)                                              ((0x00000100&(data))>>8)
+#define MIS_ST_PAD1_get_pad1_ctrl(data)                                              ((0x00000100&(data))>>8)
+#define MIS_ST_PAD1_50_shift                                                         (0)
+#define MIS_ST_PAD1_50_mask                                                          (0x0000003F)
+#define MIS_ST_PAD1_50(data)                                                         (0x0000003F&((data)<<0))
+#define MIS_ST_PAD1_50_src(data)                                                     ((0x0000003F&(data))>>0)
+#define MIS_ST_PAD1_get_50(data)                                                     ((0x0000003F&(data))>>0)
+
+
+#define MIS_ST_LSADC_CTRL                                                            0x1801BC20
+#define MIS_ST_LSADC_CTRL_reg_addr                                                   "0xB801BC20"
+#define MIS_ST_LSADC_CTRL_reg                                                        0xB801BC20
+#define set_MIS_ST_LSADC_CTRL_reg(data)   (*((volatile unsigned int*) MIS_ST_LSADC_CTRL_reg)=data)
+#define get_MIS_ST_LSADC_CTRL_reg   (*((volatile unsigned int*) MIS_ST_LSADC_CTRL_reg))
+#define MIS_ST_LSADC_CTRL_inst_adr                                                   "0x0008"
+#define MIS_ST_LSADC_CTRL_inst                                                       0x0008
+#define MIS_ST_LSADC_CTRL_sel_wait_shift                                             (28)
+#define MIS_ST_LSADC_CTRL_sel_wait_mask                                              (0xF0000000)
+#define MIS_ST_LSADC_CTRL_sel_wait(data)                                             (0xF0000000&((data)<<28))
+#define MIS_ST_LSADC_CTRL_sel_wait_src(data)                                         ((0xF0000000&(data))>>28)
+#define MIS_ST_LSADC_CTRL_get_sel_wait(data)                                         ((0xF0000000&(data))>>28)
+#define MIS_ST_LSADC_CTRL_sel_adc_ck_shift                                           (24)
+#define MIS_ST_LSADC_CTRL_sel_adc_ck_mask                                            (0x0F000000)
+#define MIS_ST_LSADC_CTRL_sel_adc_ck(data)                                           (0x0F000000&((data)<<24))
+#define MIS_ST_LSADC_CTRL_sel_adc_ck_src(data)                                       ((0x0F000000&(data))>>24)
+#define MIS_ST_LSADC_CTRL_get_sel_adc_ck(data)                                       ((0x0F000000&(data))>>24)
+#define MIS_ST_LSADC_CTRL_debounce_cnt_shift                                         (20)
+#define MIS_ST_LSADC_CTRL_debounce_cnt_mask                                          (0x00F00000)
+#define MIS_ST_LSADC_CTRL_debounce_cnt(data)                                         (0x00F00000&((data)<<20))
+#define MIS_ST_LSADC_CTRL_debounce_cnt_src(data)                                     ((0x00F00000&(data))>>20)
+#define MIS_ST_LSADC_CTRL_get_debounce_cnt(data)                                     ((0x00F00000&(data))>>20)
+#define MIS_ST_LSADC_CTRL_dout_test_in_shift                                         (8)
+#define MIS_ST_LSADC_CTRL_dout_test_in_mask                                          (0x0000FF00)
+#define MIS_ST_LSADC_CTRL_dout_test_in(data)                                         (0x0000FF00&((data)<<8))
+#define MIS_ST_LSADC_CTRL_dout_test_in_src(data)                                     ((0x0000FF00&(data))>>8)
+#define MIS_ST_LSADC_CTRL_get_dout_test_in(data)                                     ((0x0000FF00&(data))>>8)
+#define MIS_ST_LSADC_CTRL_test_en_shift                                              (1)
+#define MIS_ST_LSADC_CTRL_test_en_mask                                               (0x00000002)
+#define MIS_ST_LSADC_CTRL_test_en(data)                                              (0x00000002&((data)<<1))
+#define MIS_ST_LSADC_CTRL_test_en_src(data)                                          ((0x00000002&(data))>>1)
+#define MIS_ST_LSADC_CTRL_get_test_en(data)                                          ((0x00000002&(data))>>1)
+#define MIS_ST_LSADC_CTRL_enable_shift                                               (0)
+#define MIS_ST_LSADC_CTRL_enable_mask                                                (0x00000001)
+#define MIS_ST_LSADC_CTRL_enable(data)                                               (0x00000001&((data)<<0))
+#define MIS_ST_LSADC_CTRL_enable_src(data)                                           ((0x00000001&(data))>>0)
+#define MIS_ST_LSADC_CTRL_get_enable(data)                                           ((0x00000001&(data))>>0)
+
+
+#define MIS_ST_LSADC_STATUS                                                          0x1801BC24
+#define MIS_ST_LSADC_STATUS_reg_addr                                                 "0xB801BC24"
+#define MIS_ST_LSADC_STATUS_reg                                                      0xB801BC24
+#define set_MIS_ST_LSADC_STATUS_reg(data)   (*((volatile unsigned int*) MIS_ST_LSADC_STATUS_reg)=data)
+#define get_MIS_ST_LSADC_STATUS_reg   (*((volatile unsigned int*) MIS_ST_LSADC_STATUS_reg))
+#define MIS_ST_LSADC_STATUS_inst_adr                                                 "0x0009"
+#define MIS_ST_LSADC_STATUS_inst                                                     0x0009
+#define MIS_ST_LSADC_STATUS_irq_en_shift                                             (24)
+#define MIS_ST_LSADC_STATUS_irq_en_mask                                              (0xFF000000)
+#define MIS_ST_LSADC_STATUS_irq_en(data)                                             (0xFF000000&((data)<<24))
+#define MIS_ST_LSADC_STATUS_irq_en_src(data)                                         ((0xFF000000&(data))>>24)
+#define MIS_ST_LSADC_STATUS_get_irq_en(data)                                         ((0xFF000000&(data))>>24)
+#define MIS_ST_LSADC_STATUS_pad_cnt_shift                                            (20)
+#define MIS_ST_LSADC_STATUS_pad_cnt_mask                                             (0x00F00000)
+#define MIS_ST_LSADC_STATUS_pad_cnt(data)                                            (0x00F00000&((data)<<20))
+#define MIS_ST_LSADC_STATUS_pad_cnt_src(data)                                        ((0x00F00000&(data))>>20)
+#define MIS_ST_LSADC_STATUS_get_pad_cnt(data)                                        ((0x00F00000&(data))>>20)
+#define MIS_ST_LSADC_STATUS_adc_busy_shift                                           (19)
+#define MIS_ST_LSADC_STATUS_adc_busy_mask                                            (0x00080000)
+#define MIS_ST_LSADC_STATUS_adc_busy(data)                                           (0x00080000&((data)<<19))
+#define MIS_ST_LSADC_STATUS_adc_busy_src(data)                                       ((0x00080000&(data))>>19)
+#define MIS_ST_LSADC_STATUS_get_adc_busy(data)                                       ((0x00080000&(data))>>19)
+#define MIS_ST_LSADC_STATUS_pad_ctrl_shift                                           (12)
+#define MIS_ST_LSADC_STATUS_pad_ctrl_mask                                            (0x0001F000)
+#define MIS_ST_LSADC_STATUS_pad_ctrl(data)                                           (0x0001F000&((data)<<12))
+#define MIS_ST_LSADC_STATUS_pad_ctrl_src(data)                                       ((0x0001F000&(data))>>12)
+#define MIS_ST_LSADC_STATUS_get_pad_ctrl(data)                                       ((0x0001F000&(data))>>12)
+#define MIS_ST_LSADC_STATUS_pad1_status_shift                                        (1)
+#define MIS_ST_LSADC_STATUS_pad1_status_mask                                         (0x00000002)
+#define MIS_ST_LSADC_STATUS_pad1_status(data)                                        (0x00000002&((data)<<1))
+#define MIS_ST_LSADC_STATUS_pad1_status_src(data)                                    ((0x00000002&(data))>>1)
+#define MIS_ST_LSADC_STATUS_get_pad1_status(data)                                    ((0x00000002&(data))>>1)
+#define MIS_ST_LSADC_STATUS_pad0_status_shift                                        (0)
+#define MIS_ST_LSADC_STATUS_pad0_status_mask                                         (0x00000001)
+#define MIS_ST_LSADC_STATUS_pad0_status(data)                                        (0x00000001&((data)<<0))
+#define MIS_ST_LSADC_STATUS_pad0_status_src(data)                                    ((0x00000001&(data))>>0)
+#define MIS_ST_LSADC_STATUS_get_pad0_status(data)                                    ((0x00000001&(data))>>0)
+
+
+#define MIS_ST_LSADC_ANALOG_CTRL                                                     0x1801BC28
+#define MIS_ST_LSADC_ANALOG_CTRL_reg_addr                                            "0xB801BC28"
+#define MIS_ST_LSADC_ANALOG_CTRL_reg                                                 0xB801BC28
+#define set_MIS_ST_LSADC_ANALOG_CTRL_reg(data)   (*((volatile unsigned int*) MIS_ST_LSADC_ANALOG_CTRL_reg)=data)
+#define get_MIS_ST_LSADC_ANALOG_CTRL_reg   (*((volatile unsigned int*) MIS_ST_LSADC_ANALOG_CTRL_reg))
+#define MIS_ST_LSADC_ANALOG_CTRL_inst_adr                                            "0x000A"
+#define MIS_ST_LSADC_ANALOG_CTRL_inst                                                0x000A
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_sbias_shift                                      (16)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_sbias_mask                                       (0x00030000)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_sbias(data)                                      (0x00030000&((data)<<16))
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_sbias_src(data)                                  ((0x00030000&(data))>>16)
+#define MIS_ST_LSADC_ANALOG_CTRL_get_jd_sbias(data)                                  ((0x00030000&(data))>>16)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_adsbias_shift                                    (12)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_adsbias_mask                                     (0x00003000)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_adsbias(data)                                    (0x00003000&((data)<<12))
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_adsbias_src(data)                                ((0x00003000&(data))>>12)
+#define MIS_ST_LSADC_ANALOG_CTRL_get_jd_adsbias(data)                                ((0x00003000&(data))>>12)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_dummy_shift                                      (10)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_dummy_mask                                       (0x00000C00)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_dummy(data)                                      (0x00000C00&((data)<<10))
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_dummy_src(data)                                  ((0x00000C00&(data))>>10)
+#define MIS_ST_LSADC_ANALOG_CTRL_get_jd_dummy(data)                                  ((0x00000C00&(data))>>10)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_svr_shift                                        (8)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_svr_mask                                         (0x00000100)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_svr(data)                                        (0x00000100&((data)<<8))
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_svr_src(data)                                    ((0x00000100&(data))>>8)
+#define MIS_ST_LSADC_ANALOG_CTRL_get_jd_svr(data)                                    ((0x00000100&(data))>>8)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_adcksel_shift                                    (4)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_adcksel_mask                                     (0x00000010)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_adcksel(data)                                    (0x00000010&((data)<<4))
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_adcksel_src(data)                                ((0x00000010&(data))>>4)
+#define MIS_ST_LSADC_ANALOG_CTRL_get_jd_adcksel(data)                                ((0x00000010&(data))>>4)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_power_shift                                      (0)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_power_mask                                       (0x00000001)
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_power(data)                                      (0x00000001&((data)<<0))
+#define MIS_ST_LSADC_ANALOG_CTRL_jd_power_src(data)                                  ((0x00000001&(data))>>0)
+#define MIS_ST_LSADC_ANALOG_CTRL_get_jd_power(data)                                  ((0x00000001&(data))>>0)
+
+
+#define MIS_ST_LSADC_PERI_TOP_DEBUG                                                  0x1801BC2C
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_reg_addr                                         "0xB801BC2C"
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_reg                                              0xB801BC2C
+#define set_MIS_ST_LSADC_PERI_TOP_DEBUG_reg(data)   (*((volatile unsigned int*) MIS_ST_LSADC_PERI_TOP_DEBUG_reg)=data)
+#define get_MIS_ST_LSADC_PERI_TOP_DEBUG_reg   (*((volatile unsigned int*) MIS_ST_LSADC_PERI_TOP_DEBUG_reg))
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_inst_adr                                         "0x000B"
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_inst                                             0x000B
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_lsadc_2_ifd_data_sel_shift                       (16)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_lsadc_2_ifd_data_sel_mask                        (0x00070000)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_lsadc_2_ifd_data_sel(data)                       (0x00070000&((data)<<16))
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_lsadc_2_ifd_data_sel_src(data)                   ((0x00070000&(data))>>16)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_get_lsadc_2_ifd_data_sel(data)                   ((0x00070000&(data))>>16)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_enable_shift                        (14)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_enable_mask                         (0x00004000)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_enable(data)                        (0x00004000&((data)<<14))
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_enable_src(data)                    ((0x00004000&(data))>>14)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_get_power_saving_enable(data)                    ((0x00004000&(data))>>14)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_cycle_time_shift                    (11)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_cycle_time_mask                     (0x00003800)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_cycle_time(data)                    (0x00003800&((data)<<11))
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_cycle_time_src(data)                ((0x00003800&(data))>>11)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_get_power_saving_cycle_time(data)                ((0x00003800&(data))>>11)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_disable_time_shift                  (8)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_disable_time_mask                   (0x00000700)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_disable_time(data)                  (0x00000700&((data)<<8))
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_power_saving_disable_time_src(data)              ((0x00000700&(data))>>8)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_get_power_saving_disable_time(data)              ((0x00000700&(data))>>8)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_peri_top_debug_shift                             (0)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_peri_top_debug_mask                              (0x000000FF)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_peri_top_debug(data)                             (0x000000FF&((data)<<0))
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_peri_top_debug_src(data)                         ((0x000000FF&(data))>>0)
+#define MIS_ST_LSADC_PERI_TOP_DEBUG_get_peri_top_debug(data)                         ((0x000000FF&(data))>>0)
+
+
+#define MIS_LSADC_PAD0_LEVEL_SET0                                                    0x1801BC30
+#define MIS_LSADC_PAD0_LEVEL_SET0_reg_addr                                           "0xB801BC30"
+#define MIS_LSADC_PAD0_LEVEL_SET0_reg                                                0xB801BC30
+#define set_MIS_LSADC_PAD0_LEVEL_SET0_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET0_reg)=data)
+#define get_MIS_LSADC_PAD0_LEVEL_SET0_reg   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET0_reg))
+#define MIS_LSADC_PAD0_LEVEL_SET0_inst_adr                                           "0x000C"
+#define MIS_LSADC_PAD0_LEVEL_SET0_inst                                               0x000C
+#define MIS_LSADC_PAD0_LEVEL_SET0_level_0_top_bound_shift                            (24)
+#define MIS_LSADC_PAD0_LEVEL_SET0_level_0_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD0_LEVEL_SET0_level_0_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD0_LEVEL_SET0_level_0_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET0_get_level_0_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET0_level_0_low_bound_shift                            (16)
+#define MIS_LSADC_PAD0_LEVEL_SET0_level_0_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD0_LEVEL_SET0_level_0_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD0_LEVEL_SET0_level_0_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET0_get_level_0_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET0_block0_en_shift                                    (15)
+#define MIS_LSADC_PAD0_LEVEL_SET0_block0_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD0_LEVEL_SET0_block0_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD0_LEVEL_SET0_block0_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET0_get_block0_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET0_int_en0_shift                                      (1)
+#define MIS_LSADC_PAD0_LEVEL_SET0_int_en0_mask                                       (0x00000002)
+#define MIS_LSADC_PAD0_LEVEL_SET0_int_en0(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD0_LEVEL_SET0_int_en0_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET0_get_int_en0(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET0_int_pending_bit0_shift                             (0)
+#define MIS_LSADC_PAD0_LEVEL_SET0_int_pending_bit0_mask                              (0x00000001)
+#define MIS_LSADC_PAD0_LEVEL_SET0_int_pending_bit0(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD0_LEVEL_SET0_int_pending_bit0_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD0_LEVEL_SET0_get_int_pending_bit0(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD0_LEVEL_SET1                                                    0x1801BC34
+#define MIS_LSADC_PAD0_LEVEL_SET1_reg_addr                                           "0xB801BC34"
+#define MIS_LSADC_PAD0_LEVEL_SET1_reg                                                0xB801BC34
+#define set_MIS_LSADC_PAD0_LEVEL_SET1_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET1_reg)=data)
+#define get_MIS_LSADC_PAD0_LEVEL_SET1_reg   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET1_reg))
+#define MIS_LSADC_PAD0_LEVEL_SET1_inst_adr                                           "0x000D"
+#define MIS_LSADC_PAD0_LEVEL_SET1_inst                                               0x000D
+#define MIS_LSADC_PAD0_LEVEL_SET1_level_1_top_bound_shift                            (24)
+#define MIS_LSADC_PAD0_LEVEL_SET1_level_1_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD0_LEVEL_SET1_level_1_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD0_LEVEL_SET1_level_1_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET1_get_level_1_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET1_level_0_low_bound_shift                            (16)
+#define MIS_LSADC_PAD0_LEVEL_SET1_level_0_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD0_LEVEL_SET1_level_0_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD0_LEVEL_SET1_level_0_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET1_get_level_0_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET1_block1_en_shift                                    (15)
+#define MIS_LSADC_PAD0_LEVEL_SET1_block1_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD0_LEVEL_SET1_block1_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD0_LEVEL_SET1_block1_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET1_get_block1_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET1_int_en1_shift                                      (1)
+#define MIS_LSADC_PAD0_LEVEL_SET1_int_en1_mask                                       (0x00000002)
+#define MIS_LSADC_PAD0_LEVEL_SET1_int_en1(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD0_LEVEL_SET1_int_en1_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET1_get_int_en1(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET1_int_pending_bit1_shift                             (0)
+#define MIS_LSADC_PAD0_LEVEL_SET1_int_pending_bit1_mask                              (0x00000001)
+#define MIS_LSADC_PAD0_LEVEL_SET1_int_pending_bit1(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD0_LEVEL_SET1_int_pending_bit1_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD0_LEVEL_SET1_get_int_pending_bit1(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD0_LEVEL_SET2                                                    0x1801BC38
+#define MIS_LSADC_PAD0_LEVEL_SET2_reg_addr                                           "0xB801BC38"
+#define MIS_LSADC_PAD0_LEVEL_SET2_reg                                                0xB801BC38
+#define set_MIS_LSADC_PAD0_LEVEL_SET2_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET2_reg)=data)
+#define get_MIS_LSADC_PAD0_LEVEL_SET2_reg   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET2_reg))
+#define MIS_LSADC_PAD0_LEVEL_SET2_inst_adr                                           "0x000E"
+#define MIS_LSADC_PAD0_LEVEL_SET2_inst                                               0x000E
+#define MIS_LSADC_PAD0_LEVEL_SET2_level_2_top_bound_shift                            (24)
+#define MIS_LSADC_PAD0_LEVEL_SET2_level_2_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD0_LEVEL_SET2_level_2_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD0_LEVEL_SET2_level_2_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET2_get_level_2_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET2_level_2_low_bound_shift                            (16)
+#define MIS_LSADC_PAD0_LEVEL_SET2_level_2_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD0_LEVEL_SET2_level_2_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD0_LEVEL_SET2_level_2_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET2_get_level_2_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET2_block2_en_shift                                    (15)
+#define MIS_LSADC_PAD0_LEVEL_SET2_block2_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD0_LEVEL_SET2_block2_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD0_LEVEL_SET2_block2_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET2_get_block2_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET2_int_en2_shift                                      (1)
+#define MIS_LSADC_PAD0_LEVEL_SET2_int_en2_mask                                       (0x00000002)
+#define MIS_LSADC_PAD0_LEVEL_SET2_int_en2(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD0_LEVEL_SET2_int_en2_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET2_get_int_en2(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET2_int_pending_bit2_shift                             (0)
+#define MIS_LSADC_PAD0_LEVEL_SET2_int_pending_bit2_mask                              (0x00000001)
+#define MIS_LSADC_PAD0_LEVEL_SET2_int_pending_bit2(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD0_LEVEL_SET2_int_pending_bit2_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD0_LEVEL_SET2_get_int_pending_bit2(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD0_LEVEL_SET3                                                    0x1801BC3C
+#define MIS_LSADC_PAD0_LEVEL_SET3_reg_addr                                           "0xB801BC3C"
+#define MIS_LSADC_PAD0_LEVEL_SET3_reg                                                0xB801BC3C
+#define set_MIS_LSADC_PAD0_LEVEL_SET3_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET3_reg)=data)
+#define get_MIS_LSADC_PAD0_LEVEL_SET3_reg   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET3_reg))
+#define MIS_LSADC_PAD0_LEVEL_SET3_inst_adr                                           "0x000F"
+#define MIS_LSADC_PAD0_LEVEL_SET3_inst                                               0x000F
+#define MIS_LSADC_PAD0_LEVEL_SET3_level_3_top_bound_shift                            (24)
+#define MIS_LSADC_PAD0_LEVEL_SET3_level_3_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD0_LEVEL_SET3_level_3_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD0_LEVEL_SET3_level_3_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET3_get_level_3_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET3_level_3_low_bound_shift                            (16)
+#define MIS_LSADC_PAD0_LEVEL_SET3_level_3_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD0_LEVEL_SET3_level_3_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD0_LEVEL_SET3_level_3_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET3_get_level_3_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET3_block3_en_shift                                    (15)
+#define MIS_LSADC_PAD0_LEVEL_SET3_block3_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD0_LEVEL_SET3_block3_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD0_LEVEL_SET3_block3_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET3_get_block3_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET3_int_en3_shift                                      (1)
+#define MIS_LSADC_PAD0_LEVEL_SET3_int_en3_mask                                       (0x00000002)
+#define MIS_LSADC_PAD0_LEVEL_SET3_int_en3(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD0_LEVEL_SET3_int_en3_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET3_get_int_en3(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET3_int_pending_bit3_shift                             (0)
+#define MIS_LSADC_PAD0_LEVEL_SET3_int_pending_bit3_mask                              (0x00000001)
+#define MIS_LSADC_PAD0_LEVEL_SET3_int_pending_bit3(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD0_LEVEL_SET3_int_pending_bit3_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD0_LEVEL_SET3_get_int_pending_bit3(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD0_LEVEL_SET4                                                    0x1801BC40
+#define MIS_LSADC_PAD0_LEVEL_SET4_reg_addr                                           "0xB801BC40"
+#define MIS_LSADC_PAD0_LEVEL_SET4_reg                                                0xB801BC40
+#define set_MIS_LSADC_PAD0_LEVEL_SET4_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET4_reg)=data)
+#define get_MIS_LSADC_PAD0_LEVEL_SET4_reg   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET4_reg))
+#define MIS_LSADC_PAD0_LEVEL_SET4_inst_adr                                           "0x0010"
+#define MIS_LSADC_PAD0_LEVEL_SET4_inst                                               0x0010
+#define MIS_LSADC_PAD0_LEVEL_SET4_level_4_top_bound_shift                            (24)
+#define MIS_LSADC_PAD0_LEVEL_SET4_level_4_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD0_LEVEL_SET4_level_4_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD0_LEVEL_SET4_level_4_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET4_get_level_4_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET4_level_4_low_bound_shift                            (16)
+#define MIS_LSADC_PAD0_LEVEL_SET4_level_4_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD0_LEVEL_SET4_level_4_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD0_LEVEL_SET4_level_4_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET4_get_level_4_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET4_block4_en_shift                                    (15)
+#define MIS_LSADC_PAD0_LEVEL_SET4_block4_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD0_LEVEL_SET4_block4_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD0_LEVEL_SET4_block4_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET4_get_block4_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET4_int_en4_shift                                      (1)
+#define MIS_LSADC_PAD0_LEVEL_SET4_int_en4_mask                                       (0x00000002)
+#define MIS_LSADC_PAD0_LEVEL_SET4_int_en4(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD0_LEVEL_SET4_int_en4_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET4_get_int_en4(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET4_int_pending_bit4_shift                             (0)
+#define MIS_LSADC_PAD0_LEVEL_SET4_int_pending_bit4_mask                              (0x00000001)
+#define MIS_LSADC_PAD0_LEVEL_SET4_int_pending_bit4(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD0_LEVEL_SET4_int_pending_bit4_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD0_LEVEL_SET4_get_int_pending_bit4(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD0_LEVEL_SET5                                                    0x1801BC44
+#define MIS_LSADC_PAD0_LEVEL_SET5_reg_addr                                           "0xB801BC44"
+#define MIS_LSADC_PAD0_LEVEL_SET5_reg                                                0xB801BC44
+#define set_MIS_LSADC_PAD0_LEVEL_SET5_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET5_reg)=data)
+#define get_MIS_LSADC_PAD0_LEVEL_SET5_reg   (*((volatile unsigned int*) MIS_LSADC_PAD0_LEVEL_SET5_reg))
+#define MIS_LSADC_PAD0_LEVEL_SET5_inst_adr                                           "0x0011"
+#define MIS_LSADC_PAD0_LEVEL_SET5_inst                                               0x0011
+#define MIS_LSADC_PAD0_LEVEL_SET5_level_5_top_bound_shift                            (24)
+#define MIS_LSADC_PAD0_LEVEL_SET5_level_5_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD0_LEVEL_SET5_level_5_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD0_LEVEL_SET5_level_5_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET5_get_level_5_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD0_LEVEL_SET5_level_5_low_bound_shift                            (16)
+#define MIS_LSADC_PAD0_LEVEL_SET5_level_5_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD0_LEVEL_SET5_level_5_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD0_LEVEL_SET5_level_5_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET5_get_level_5_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD0_LEVEL_SET5_block5_en_shift                                    (15)
+#define MIS_LSADC_PAD0_LEVEL_SET5_block5_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD0_LEVEL_SET5_block5_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD0_LEVEL_SET5_block5_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET5_get_block5_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD0_LEVEL_SET5_int_en5_shift                                      (1)
+#define MIS_LSADC_PAD0_LEVEL_SET5_int_en5_mask                                       (0x00000002)
+#define MIS_LSADC_PAD0_LEVEL_SET5_int_en5(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD0_LEVEL_SET5_int_en5_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET5_get_int_en5(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD0_LEVEL_SET5_int_pending_bit5_shift                             (0)
+#define MIS_LSADC_PAD0_LEVEL_SET5_int_pending_bit5_mask                              (0x00000001)
+#define MIS_LSADC_PAD0_LEVEL_SET5_int_pending_bit5(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD0_LEVEL_SET5_int_pending_bit5_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD0_LEVEL_SET5_get_int_pending_bit5(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD1_LEVEL_SET0                                                    0x1801BC48
+#define MIS_LSADC_PAD1_LEVEL_SET0_reg_addr                                           "0xB801BC48"
+#define MIS_LSADC_PAD1_LEVEL_SET0_reg                                                0xB801BC48
+#define set_MIS_LSADC_PAD1_LEVEL_SET0_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET0_reg)=data)
+#define get_MIS_LSADC_PAD1_LEVEL_SET0_reg   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET0_reg))
+#define MIS_LSADC_PAD1_LEVEL_SET0_inst_adr                                           "0x0012"
+#define MIS_LSADC_PAD1_LEVEL_SET0_inst                                               0x0012
+#define MIS_LSADC_PAD1_LEVEL_SET0_level_0_top_bound_shift                            (24)
+#define MIS_LSADC_PAD1_LEVEL_SET0_level_0_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD1_LEVEL_SET0_level_0_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD1_LEVEL_SET0_level_0_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET0_get_level_0_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET0_level_0_low_bound_shift                            (16)
+#define MIS_LSADC_PAD1_LEVEL_SET0_level_0_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD1_LEVEL_SET0_level_0_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD1_LEVEL_SET0_level_0_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET0_get_level_0_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET0_block0_en_shift                                    (15)
+#define MIS_LSADC_PAD1_LEVEL_SET0_block0_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD1_LEVEL_SET0_block0_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD1_LEVEL_SET0_block0_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET0_get_block0_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET0_int_en0_shift                                      (1)
+#define MIS_LSADC_PAD1_LEVEL_SET0_int_en0_mask                                       (0x00000002)
+#define MIS_LSADC_PAD1_LEVEL_SET0_int_en0(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD1_LEVEL_SET0_int_en0_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET0_get_int_en0(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET0_int_pending_bit0_shift                             (0)
+#define MIS_LSADC_PAD1_LEVEL_SET0_int_pending_bit0_mask                              (0x00000001)
+#define MIS_LSADC_PAD1_LEVEL_SET0_int_pending_bit0(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD1_LEVEL_SET0_int_pending_bit0_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD1_LEVEL_SET0_get_int_pending_bit0(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD1_LEVEL_SET1                                                    0x1801BC4C
+#define MIS_LSADC_PAD1_LEVEL_SET1_reg_addr                                           "0xB801BC4C"
+#define MIS_LSADC_PAD1_LEVEL_SET1_reg                                                0xB801BC4C
+#define set_MIS_LSADC_PAD1_LEVEL_SET1_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET1_reg)=data)
+#define get_MIS_LSADC_PAD1_LEVEL_SET1_reg   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET1_reg))
+#define MIS_LSADC_PAD1_LEVEL_SET1_inst_adr                                           "0x0013"
+#define MIS_LSADC_PAD1_LEVEL_SET1_inst                                               0x0013
+#define MIS_LSADC_PAD1_LEVEL_SET1_level_1_top_bound_shift                            (24)
+#define MIS_LSADC_PAD1_LEVEL_SET1_level_1_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD1_LEVEL_SET1_level_1_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD1_LEVEL_SET1_level_1_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET1_get_level_1_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET1_level_0_low_bound_shift                            (16)
+#define MIS_LSADC_PAD1_LEVEL_SET1_level_0_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD1_LEVEL_SET1_level_0_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD1_LEVEL_SET1_level_0_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET1_get_level_0_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET1_block1_en_shift                                    (15)
+#define MIS_LSADC_PAD1_LEVEL_SET1_block1_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD1_LEVEL_SET1_block1_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD1_LEVEL_SET1_block1_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET1_get_block1_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET1_int_en1_shift                                      (1)
+#define MIS_LSADC_PAD1_LEVEL_SET1_int_en1_mask                                       (0x00000002)
+#define MIS_LSADC_PAD1_LEVEL_SET1_int_en1(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD1_LEVEL_SET1_int_en1_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET1_get_int_en1(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET1_int_pending_bit1_shift                             (0)
+#define MIS_LSADC_PAD1_LEVEL_SET1_int_pending_bit1_mask                              (0x00000001)
+#define MIS_LSADC_PAD1_LEVEL_SET1_int_pending_bit1(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD1_LEVEL_SET1_int_pending_bit1_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD1_LEVEL_SET1_get_int_pending_bit1(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD1_LEVEL_SET2                                                    0x1801BC50
+#define MIS_LSADC_PAD1_LEVEL_SET2_reg_addr                                           "0xB801BC50"
+#define MIS_LSADC_PAD1_LEVEL_SET2_reg                                                0xB801BC50
+#define set_MIS_LSADC_PAD1_LEVEL_SET2_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET2_reg)=data)
+#define get_MIS_LSADC_PAD1_LEVEL_SET2_reg   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET2_reg))
+#define MIS_LSADC_PAD1_LEVEL_SET2_inst_adr                                           "0x0014"
+#define MIS_LSADC_PAD1_LEVEL_SET2_inst                                               0x0014
+#define MIS_LSADC_PAD1_LEVEL_SET2_level_2_top_bound_shift                            (24)
+#define MIS_LSADC_PAD1_LEVEL_SET2_level_2_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD1_LEVEL_SET2_level_2_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD1_LEVEL_SET2_level_2_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET2_get_level_2_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET2_level_2_low_bound_shift                            (16)
+#define MIS_LSADC_PAD1_LEVEL_SET2_level_2_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD1_LEVEL_SET2_level_2_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD1_LEVEL_SET2_level_2_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET2_get_level_2_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET2_block2_en_shift                                    (15)
+#define MIS_LSADC_PAD1_LEVEL_SET2_block2_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD1_LEVEL_SET2_block2_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD1_LEVEL_SET2_block2_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET2_get_block2_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET2_int_en2_shift                                      (1)
+#define MIS_LSADC_PAD1_LEVEL_SET2_int_en2_mask                                       (0x00000002)
+#define MIS_LSADC_PAD1_LEVEL_SET2_int_en2(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD1_LEVEL_SET2_int_en2_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET2_get_int_en2(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET2_int_pending_bit2_shift                             (0)
+#define MIS_LSADC_PAD1_LEVEL_SET2_int_pending_bit2_mask                              (0x00000001)
+#define MIS_LSADC_PAD1_LEVEL_SET2_int_pending_bit2(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD1_LEVEL_SET2_int_pending_bit2_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD1_LEVEL_SET2_get_int_pending_bit2(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD1_LEVEL_SET3                                                    0x1801BC54
+#define MIS_LSADC_PAD1_LEVEL_SET3_reg_addr                                           "0xB801BC54"
+#define MIS_LSADC_PAD1_LEVEL_SET3_reg                                                0xB801BC54
+#define set_MIS_LSADC_PAD1_LEVEL_SET3_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET3_reg)=data)
+#define get_MIS_LSADC_PAD1_LEVEL_SET3_reg   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET3_reg))
+#define MIS_LSADC_PAD1_LEVEL_SET3_inst_adr                                           "0x0015"
+#define MIS_LSADC_PAD1_LEVEL_SET3_inst                                               0x0015
+#define MIS_LSADC_PAD1_LEVEL_SET3_level_3_top_bound_shift                            (24)
+#define MIS_LSADC_PAD1_LEVEL_SET3_level_3_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD1_LEVEL_SET3_level_3_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD1_LEVEL_SET3_level_3_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET3_get_level_3_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET3_level_3_low_bound_shift                            (16)
+#define MIS_LSADC_PAD1_LEVEL_SET3_level_3_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD1_LEVEL_SET3_level_3_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD1_LEVEL_SET3_level_3_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET3_get_level_3_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET3_block3_en_shift                                    (15)
+#define MIS_LSADC_PAD1_LEVEL_SET3_block3_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD1_LEVEL_SET3_block3_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD1_LEVEL_SET3_block3_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET3_get_block3_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET3_int_en3_shift                                      (1)
+#define MIS_LSADC_PAD1_LEVEL_SET3_int_en3_mask                                       (0x00000002)
+#define MIS_LSADC_PAD1_LEVEL_SET3_int_en3(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD1_LEVEL_SET3_int_en3_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET3_get_int_en3(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET3_int_pending_bit3_shift                             (0)
+#define MIS_LSADC_PAD1_LEVEL_SET3_int_pending_bit3_mask                              (0x00000001)
+#define MIS_LSADC_PAD1_LEVEL_SET3_int_pending_bit3(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD1_LEVEL_SET3_int_pending_bit3_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD1_LEVEL_SET3_get_int_pending_bit3(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD1_LEVEL_SET4                                                    0x1801BC58
+#define MIS_LSADC_PAD1_LEVEL_SET4_reg_addr                                           "0xB801BC58"
+#define MIS_LSADC_PAD1_LEVEL_SET4_reg                                                0xB801BC58
+#define set_MIS_LSADC_PAD1_LEVEL_SET4_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET4_reg)=data)
+#define get_MIS_LSADC_PAD1_LEVEL_SET4_reg   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET4_reg))
+#define MIS_LSADC_PAD1_LEVEL_SET4_inst_adr                                           "0x0016"
+#define MIS_LSADC_PAD1_LEVEL_SET4_inst                                               0x0016
+#define MIS_LSADC_PAD1_LEVEL_SET4_level_4_top_bound_shift                            (24)
+#define MIS_LSADC_PAD1_LEVEL_SET4_level_4_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD1_LEVEL_SET4_level_4_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD1_LEVEL_SET4_level_4_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET4_get_level_4_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET4_level_4_low_bound_shift                            (16)
+#define MIS_LSADC_PAD1_LEVEL_SET4_level_4_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD1_LEVEL_SET4_level_4_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD1_LEVEL_SET4_level_4_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET4_get_level_4_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET4_block4_en_shift                                    (15)
+#define MIS_LSADC_PAD1_LEVEL_SET4_block4_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD1_LEVEL_SET4_block4_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD1_LEVEL_SET4_block4_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET4_get_block4_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET4_int_en4_shift                                      (1)
+#define MIS_LSADC_PAD1_LEVEL_SET4_int_en4_mask                                       (0x00000002)
+#define MIS_LSADC_PAD1_LEVEL_SET4_int_en4(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD1_LEVEL_SET4_int_en4_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET4_get_int_en4(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET4_int_pending_bit4_shift                             (0)
+#define MIS_LSADC_PAD1_LEVEL_SET4_int_pending_bit4_mask                              (0x00000001)
+#define MIS_LSADC_PAD1_LEVEL_SET4_int_pending_bit4(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD1_LEVEL_SET4_int_pending_bit4_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD1_LEVEL_SET4_get_int_pending_bit4(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_PAD1_LEVEL_SET5                                                    0x1801BC5C
+#define MIS_LSADC_PAD1_LEVEL_SET5_reg_addr                                           "0xB801BC5C"
+#define MIS_LSADC_PAD1_LEVEL_SET5_reg                                                0xB801BC5C
+#define set_MIS_LSADC_PAD1_LEVEL_SET5_reg(data)   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET5_reg)=data)
+#define get_MIS_LSADC_PAD1_LEVEL_SET5_reg   (*((volatile unsigned int*) MIS_LSADC_PAD1_LEVEL_SET5_reg))
+#define MIS_LSADC_PAD1_LEVEL_SET5_inst_adr                                           "0x0017"
+#define MIS_LSADC_PAD1_LEVEL_SET5_inst                                               0x0017
+#define MIS_LSADC_PAD1_LEVEL_SET5_level_5_top_bound_shift                            (24)
+#define MIS_LSADC_PAD1_LEVEL_SET5_level_5_top_bound_mask                             (0xFF000000)
+#define MIS_LSADC_PAD1_LEVEL_SET5_level_5_top_bound(data)                            (0xFF000000&((data)<<24))
+#define MIS_LSADC_PAD1_LEVEL_SET5_level_5_top_bound_src(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET5_get_level_5_top_bound(data)                        ((0xFF000000&(data))>>24)
+#define MIS_LSADC_PAD1_LEVEL_SET5_level_5_low_bound_shift                            (16)
+#define MIS_LSADC_PAD1_LEVEL_SET5_level_5_low_bound_mask                             (0x00FF0000)
+#define MIS_LSADC_PAD1_LEVEL_SET5_level_5_low_bound(data)                            (0x00FF0000&((data)<<16))
+#define MIS_LSADC_PAD1_LEVEL_SET5_level_5_low_bound_src(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET5_get_level_5_low_bound(data)                        ((0x00FF0000&(data))>>16)
+#define MIS_LSADC_PAD1_LEVEL_SET5_block5_en_shift                                    (15)
+#define MIS_LSADC_PAD1_LEVEL_SET5_block5_en_mask                                     (0x00008000)
+#define MIS_LSADC_PAD1_LEVEL_SET5_block5_en(data)                                    (0x00008000&((data)<<15))
+#define MIS_LSADC_PAD1_LEVEL_SET5_block5_en_src(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET5_get_block5_en(data)                                ((0x00008000&(data))>>15)
+#define MIS_LSADC_PAD1_LEVEL_SET5_int_en5_shift                                      (1)
+#define MIS_LSADC_PAD1_LEVEL_SET5_int_en5_mask                                       (0x00000002)
+#define MIS_LSADC_PAD1_LEVEL_SET5_int_en5(data)                                      (0x00000002&((data)<<1))
+#define MIS_LSADC_PAD1_LEVEL_SET5_int_en5_src(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET5_get_int_en5(data)                                  ((0x00000002&(data))>>1)
+#define MIS_LSADC_PAD1_LEVEL_SET5_int_pending_bit5_shift                             (0)
+#define MIS_LSADC_PAD1_LEVEL_SET5_int_pending_bit5_mask                              (0x00000001)
+#define MIS_LSADC_PAD1_LEVEL_SET5_int_pending_bit5(data)                             (0x00000001&((data)<<0))
+#define MIS_LSADC_PAD1_LEVEL_SET5_int_pending_bit5_src(data)                         ((0x00000001&(data))>>0)
+#define MIS_LSADC_PAD1_LEVEL_SET5_get_int_pending_bit5(data)                         ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_INT_PAD0                                                           0x1801BC78
+#define MIS_LSADC_INT_PAD0_reg_addr                                                  "0xB801BC78"
+#define MIS_LSADC_INT_PAD0_reg                                                       0xB801BC78
+#define set_MIS_LSADC_INT_PAD0_reg(data)   (*((volatile unsigned int*) MIS_LSADC_INT_PAD0_reg)=data)
+#define get_MIS_LSADC_INT_PAD0_reg   (*((volatile unsigned int*) MIS_LSADC_INT_PAD0_reg))
+#define MIS_LSADC_INT_PAD0_inst_adr                                                  "0x001E"
+#define MIS_LSADC_INT_PAD0_inst                                                      0x001E
+#define MIS_LSADC_INT_PAD0_adc_value0latch_shift                                     (8)
+#define MIS_LSADC_INT_PAD0_adc_value0latch_mask                                      (0x00003F00)
+#define MIS_LSADC_INT_PAD0_adc_value0latch(data)                                     (0x00003F00&((data)<<8))
+#define MIS_LSADC_INT_PAD0_adc_value0latch_src(data)                                 ((0x00003F00&(data))>>8)
+#define MIS_LSADC_INT_PAD0_get_adc_value0latch(data)                                 ((0x00003F00&(data))>>8)
+#define MIS_LSADC_INT_PAD0_int_latchstatus_shift                                     (0)
+#define MIS_LSADC_INT_PAD0_int_latchstatus_mask                                      (0x00000001)
+#define MIS_LSADC_INT_PAD0_int_latchstatus(data)                                     (0x00000001&((data)<<0))
+#define MIS_LSADC_INT_PAD0_int_latchstatus_src(data)                                 ((0x00000001&(data))>>0)
+#define MIS_LSADC_INT_PAD0_get_int_latchstatus(data)                                 ((0x00000001&(data))>>0)
+
+
+#define MIS_LSADC_INT_PAD1                                                           0x1801BC7C
+#define MIS_LSADC_INT_PAD1_reg_addr                                                  "0xB801BC7C"
+#define MIS_LSADC_INT_PAD1_reg                                                       0xB801BC7C
+#define set_MIS_LSADC_INT_PAD1_reg(data)   (*((volatile unsigned int*) MIS_LSADC_INT_PAD1_reg)=data)
+#define get_MIS_LSADC_INT_PAD1_reg   (*((volatile unsigned int*) MIS_LSADC_INT_PAD1_reg))
+#define MIS_LSADC_INT_PAD1_inst_adr                                                  "0x001F"
+#define MIS_LSADC_INT_PAD1_inst                                                      0x001F
+#define MIS_LSADC_INT_PAD1_adc_value1latch_shift                                     (8)
+#define MIS_LSADC_INT_PAD1_adc_value1latch_mask                                      (0x00003F00)
+#define MIS_LSADC_INT_PAD1_adc_value1latch(data)                                     (0x00003F00&((data)<<8))
+#define MIS_LSADC_INT_PAD1_adc_value1latch_src(data)                                 ((0x00003F00&(data))>>8)
+#define MIS_LSADC_INT_PAD1_get_adc_value1latch(data)                                 ((0x00003F00&(data))>>8)
+#define MIS_LSADC_INT_PAD1_int_latchstatus_shift                                     (0)
+#define MIS_LSADC_INT_PAD1_int_latchstatus_mask                                      (0x00000001)
+#define MIS_LSADC_INT_PAD1_int_latchstatus(data)                                     (0x00000001&((data)<<0))
+#define MIS_LSADC_INT_PAD1_int_latchstatus_src(data)                                 ((0x00000001&(data))>>0)
+#define MIS_LSADC_INT_PAD1_get_int_latchstatus(data)                                 ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/mvdblk_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mvdblk_reg.h
new file mode 100644
index 00000000..41a37e9
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/mvdblk_reg.h
@@ -0,0 +1,1621 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/6/22 11:40:33
+***************************************************************/
+
+
+#ifndef _MVDBLK_REG_H_INCLUDED_
+#define _MVDBLK_REG_H_INCLUDED_
+#ifdef  _MVDBLK_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     PicType:3;
+unsigned int     FirstMbOfPic:1;
+unsigned int     FirstMbOfSlice:1;
+}MVDBLK_COMM;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     LdPxmemCount:16;
+}MVDBLK_COMM1;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     DbgDumpCount:16;
+}MVDBLK_COMM2;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     SetAddr:1;
+unsigned int     MbAddrY:7;
+unsigned int     MbAddrX:7;
+unsigned int     MbAddr:13;
+}MVDBLK_COMM3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     HwCtrl:7;
+unsigned int     SoftReset:1;
+}MVDBLK_COMM4;
+
+typedef struct 
+{
+unsigned int     DbgWriteBuf:32;
+}MVDBLK_COMM5;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     DbgStoreCount:16;
+}MVDBLK_COMM6;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     RefPicList10Short:1;
+unsigned int     BotLeTopAbsDiffPOC:1;
+unsigned int     DirectSpatial:1;
+unsigned int     ColPicStruct:2;
+unsigned int     CurrPicStruct:2;
+unsigned int     Direct8x8Inf:1;
+}MVDBLK_H264PIC;
+
+typedef struct 
+{
+unsigned int     CurrFrmPoc:32;
+}MVDBLK_H264PIC1;
+
+typedef struct 
+{
+unsigned int     CurrTopPoc:32;
+}MVDBLK_H264PIC2;
+
+typedef struct 
+{
+unsigned int     CurrBotPoc:32;
+}MVDBLK_H264PIC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     CoMem8x8:1;
+}MVDBLK_H264CO;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     StCoMemSAddr:31;
+}MVDBLK_H264CO1;
+
+typedef struct 
+{
+unsigned int     MbaffAddr:1;
+unsigned int     LdCoMemSAddr:31;
+}MVDBLK_H264CO2;
+
+typedef struct 
+{
+unsigned int     EnableLdCoMem1:1;
+unsigned int     LdCoMemSAddr1:31;
+}MVDBLK_H264CO3;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     AutoLdStOff:1;
+unsigned int     InitNhMemCmd:1;
+unsigned int     LdNhMemCmd:1;
+unsigned int     StNhMemCmd:1;
+}MVDBLK_H264NH;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     StNhMemSAddr:31;
+}MVDBLK_H264NH1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     LdNhMemSAddr:31;
+}MVDBLK_H264NH2;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     StDiMemPicIndex:7;
+}MVDBLK_H264DI;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     StDiEnable:1;
+unsigned int     StDiMvThres:8;
+}MVDBLK_H264DI1;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     List1Size:5;
+unsigned int     List0Size:5;
+}MVDBLK_H264PX;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     FrmPocAddrL0:16;
+}MVDBLK_H264PX1;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     TopPocAddrL0:16;
+}MVDBLK_H264PX2;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     BotPocAddrL0:16;
+}MVDBLK_H264PX3;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     FrmPocAddrL1:16;
+}MVDBLK_H264PX4;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     TopPocAddrL1:16;
+}MVDBLK_H264PX5;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     BotPocAddrL1:16;
+}MVDBLK_H264PX6;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     PicInfoAddr:16;
+}MVDBLK_H264PX7;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     RefField:1;
+unsigned int     FastUVmc:1;
+unsigned int     ScaleFactor:11;
+}MVDBLK_VC1PIC;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     Scale_fw:8;
+unsigned int     Scale1_fw:12;
+unsigned int     Scale2_fw:8;
+}MVDBLK_VC1PIC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     ScaleUpOpp_fw:1;
+unsigned int     ScaleZone1X_fw:6;
+unsigned int     ScaleZone1Y_fw:4;
+unsigned int     Zone1OffsetX_fw:6;
+unsigned int     Zone1OffsetY_fw:4;
+}MVDBLK_VC1PIC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     Scale_bw:8;
+unsigned int     Scale1_bw:12;
+unsigned int     Scale2_bw:8;
+}MVDBLK_VC1PIC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     ScaleUpOpp_bw:1;
+unsigned int     ScaleZone1X_bw:6;
+unsigned int     ScaleZone1Y_bw:4;
+unsigned int     Zone1OffsetX_bw:6;
+unsigned int     Zone1OffsetY_bw:4;
+}MVDBLK_VC1PIC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     RangeY:12;
+unsigned int     RangeX:13;
+}MVDBLK_VC1PIC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     AecEnable:1;
+unsigned int     PFieldSkip:1;
+unsigned int     BFieldEnhanced:1;
+unsigned int     PicRefFlag:1;
+unsigned int     PicStructure:1;
+}MVDBLK_AVSPIC;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     BlockDist0:9;
+unsigned int     reserved_1:7;
+unsigned int     BlockDist1:9;
+}MVDBLK_AVSPIC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     BlockDist2:9;
+unsigned int     reserved_1:7;
+unsigned int     BlockDist3:9;
+}MVDBLK_AVSPIC2;
+
+typedef struct 
+{
+unsigned int     B16384DiviTRp0:16;
+unsigned int     B16384DiviTRp1:16;
+}MVDBLK_AVSPIC3;
+
+typedef struct 
+{
+unsigned int     B16384DiviTRp2:16;
+unsigned int     B16384DiviTRp3:16;
+}MVDBLK_AVSPIC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     iTRb0:9;
+unsigned int     reserved_1:7;
+unsigned int     iTRb1:9;
+}MVDBLK_AVSPIC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     iTRb2:9;
+unsigned int     reserved_1:7;
+unsigned int     iTRb3:9;
+}MVDBLK_AVSPIC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     iTRd:9;
+}MVDBLK_AVSPIC7;
+
+typedef struct 
+{
+unsigned int     iRatio0:32;
+}MVDBLK_RM89PIC;
+
+typedef struct 
+{
+unsigned int     iRatio1:32;
+}MVDBLK_RM89PIC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hix:14;
+unsigned int     reserved_1:2;
+unsigned int     lox:14;
+}MVDBLK_RM89DIRECT;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hiy:14;
+unsigned int     reserved_1:2;
+unsigned int     loy:14;
+}MVDBLK_RM89DIRECT1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hicx:14;
+unsigned int     reserved_1:2;
+unsigned int     locx:14;
+}MVDBLK_RM89DIRECT2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hicy:14;
+unsigned int     reserved_1:2;
+unsigned int     locy:14;
+}MVDBLK_RM89DIRECT3;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     ZeroMvd:1;
+}MVDBLK_RM89PIC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hix_4v:14;
+unsigned int     reserved_1:2;
+unsigned int     lox_4v:14;
+}MVDBLK_RM89DIRECT4;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hiy_4v:14;
+unsigned int     reserved_1:2;
+unsigned int     loy_4v:14;
+}MVDBLK_RM89DIRECT5;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hicx_4v:14;
+unsigned int     reserved_1:2;
+unsigned int     locx_4v:14;
+}MVDBLK_RM89DIRECT6;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hicy_4v:14;
+unsigned int     reserved_1:2;
+unsigned int     locy_4v:14;
+}MVDBLK_RM89DIRECT7;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     entry:28;
+}MVDBLK_SEPOOL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     SetNhAvail:1;
+}MVDBLK_H264BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     LeftAvail:1;
+unsigned int     TopAvail:1;
+unsigned int     TopRightAvail:1;
+unsigned int     TopLeftAvail:1;
+}MVDBLK_H264BASE1;
+
+typedef struct 
+{
+unsigned int     GenPulse:1;
+unsigned int     PicCount:15;
+unsigned int     DbgCtrl:3;
+unsigned int     MbAddr:13;
+}MVDBLK_DBG;
+
+#endif
+
+#define MVDBLK_COMM                                                                  0x1800e660
+#define MVDBLK_COMM_reg_addr                                                         "0xB800E660"
+#define MVDBLK_COMM_reg                                                              0xB800E660
+#define set_MVDBLK_COMM_reg(data)   (*((volatile unsigned int*) MVDBLK_COMM_reg)=data)
+#define get_MVDBLK_COMM_reg   (*((volatile unsigned int*) MVDBLK_COMM_reg))
+#define MVDBLK_COMM_inst_adr                                                         "0x0098"
+#define MVDBLK_COMM_inst                                                             0x0098
+#define MVDBLK_COMM_PicType_shift                                                    (2)
+#define MVDBLK_COMM_PicType_mask                                                     (0x0000001C)
+#define MVDBLK_COMM_PicType(data)                                                    (0x0000001C&((data)<<2))
+#define MVDBLK_COMM_PicType_src(data)                                                ((0x0000001C&(data))>>2)
+#define MVDBLK_COMM_get_PicType(data)                                                ((0x0000001C&(data))>>2)
+#define MVDBLK_COMM_FirstMbOfPic_shift                                               (1)
+#define MVDBLK_COMM_FirstMbOfPic_mask                                                (0x00000002)
+#define MVDBLK_COMM_FirstMbOfPic(data)                                               (0x00000002&((data)<<1))
+#define MVDBLK_COMM_FirstMbOfPic_src(data)                                           ((0x00000002&(data))>>1)
+#define MVDBLK_COMM_get_FirstMbOfPic(data)                                           ((0x00000002&(data))>>1)
+#define MVDBLK_COMM_FirstMbOfSlice_shift                                             (0)
+#define MVDBLK_COMM_FirstMbOfSlice_mask                                              (0x00000001)
+#define MVDBLK_COMM_FirstMbOfSlice(data)                                             (0x00000001&((data)<<0))
+#define MVDBLK_COMM_FirstMbOfSlice_src(data)                                         ((0x00000001&(data))>>0)
+#define MVDBLK_COMM_get_FirstMbOfSlice(data)                                         ((0x00000001&(data))>>0)
+
+
+#define MVDBLK_COMM1                                                                 0x1800e664
+#define MVDBLK_COMM1_reg_addr                                                        "0xB800E664"
+#define MVDBLK_COMM1_reg                                                             0xB800E664
+#define set_MVDBLK_COMM1_reg(data)   (*((volatile unsigned int*) MVDBLK_COMM1_reg)=data)
+#define get_MVDBLK_COMM1_reg   (*((volatile unsigned int*) MVDBLK_COMM1_reg))
+#define MVDBLK_COMM1_inst_adr                                                        "0x0099"
+#define MVDBLK_COMM1_inst                                                            0x0099
+#define MVDBLK_COMM1_LdPxmemCount_shift                                              (0)
+#define MVDBLK_COMM1_LdPxmemCount_mask                                               (0x0000FFFF)
+#define MVDBLK_COMM1_LdPxmemCount(data)                                              (0x0000FFFF&((data)<<0))
+#define MVDBLK_COMM1_LdPxmemCount_src(data)                                          ((0x0000FFFF&(data))>>0)
+#define MVDBLK_COMM1_get_LdPxmemCount(data)                                          ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_COMM2                                                                 0x1800e668
+#define MVDBLK_COMM2_reg_addr                                                        "0xB800E668"
+#define MVDBLK_COMM2_reg                                                             0xB800E668
+#define set_MVDBLK_COMM2_reg(data)   (*((volatile unsigned int*) MVDBLK_COMM2_reg)=data)
+#define get_MVDBLK_COMM2_reg   (*((volatile unsigned int*) MVDBLK_COMM2_reg))
+#define MVDBLK_COMM2_inst_adr                                                        "0x009A"
+#define MVDBLK_COMM2_inst                                                            0x009A
+#define MVDBLK_COMM2_DbgDumpCount_shift                                              (0)
+#define MVDBLK_COMM2_DbgDumpCount_mask                                               (0x0000FFFF)
+#define MVDBLK_COMM2_DbgDumpCount(data)                                              (0x0000FFFF&((data)<<0))
+#define MVDBLK_COMM2_DbgDumpCount_src(data)                                          ((0x0000FFFF&(data))>>0)
+#define MVDBLK_COMM2_get_DbgDumpCount(data)                                          ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_COMM3                                                                 0x1800e66c
+#define MVDBLK_COMM3_reg_addr                                                        "0xB800E66C"
+#define MVDBLK_COMM3_reg                                                             0xB800E66C
+#define set_MVDBLK_COMM3_reg(data)   (*((volatile unsigned int*) MVDBLK_COMM3_reg)=data)
+#define get_MVDBLK_COMM3_reg   (*((volatile unsigned int*) MVDBLK_COMM3_reg))
+#define MVDBLK_COMM3_inst_adr                                                        "0x009B"
+#define MVDBLK_COMM3_inst                                                            0x009B
+#define MVDBLK_COMM3_SetAddr_shift                                                   (27)
+#define MVDBLK_COMM3_SetAddr_mask                                                    (0x08000000)
+#define MVDBLK_COMM3_SetAddr(data)                                                   (0x08000000&((data)<<27))
+#define MVDBLK_COMM3_SetAddr_src(data)                                               ((0x08000000&(data))>>27)
+#define MVDBLK_COMM3_get_SetAddr(data)                                               ((0x08000000&(data))>>27)
+#define MVDBLK_COMM3_MbAddrY_shift                                                   (20)
+#define MVDBLK_COMM3_MbAddrY_mask                                                    (0x07F00000)
+#define MVDBLK_COMM3_MbAddrY(data)                                                   (0x07F00000&((data)<<20))
+#define MVDBLK_COMM3_MbAddrY_src(data)                                               ((0x07F00000&(data))>>20)
+#define MVDBLK_COMM3_get_MbAddrY(data)                                               ((0x07F00000&(data))>>20)
+#define MVDBLK_COMM3_MbAddrX_shift                                                   (13)
+#define MVDBLK_COMM3_MbAddrX_mask                                                    (0x000FE000)
+#define MVDBLK_COMM3_MbAddrX(data)                                                   (0x000FE000&((data)<<13))
+#define MVDBLK_COMM3_MbAddrX_src(data)                                               ((0x000FE000&(data))>>13)
+#define MVDBLK_COMM3_get_MbAddrX(data)                                               ((0x000FE000&(data))>>13)
+#define MVDBLK_COMM3_MbAddr_shift                                                    (0)
+#define MVDBLK_COMM3_MbAddr_mask                                                     (0x00001FFF)
+#define MVDBLK_COMM3_MbAddr(data)                                                    (0x00001FFF&((data)<<0))
+#define MVDBLK_COMM3_MbAddr_src(data)                                                ((0x00001FFF&(data))>>0)
+#define MVDBLK_COMM3_get_MbAddr(data)                                                ((0x00001FFF&(data))>>0)
+
+
+#define MVDBLK_COMM4                                                                 0x1800e670
+#define MVDBLK_COMM4_reg_addr                                                        "0xB800E670"
+#define MVDBLK_COMM4_reg                                                             0xB800E670
+#define set_MVDBLK_COMM4_reg(data)   (*((volatile unsigned int*) MVDBLK_COMM4_reg)=data)
+#define get_MVDBLK_COMM4_reg   (*((volatile unsigned int*) MVDBLK_COMM4_reg))
+#define MVDBLK_COMM4_inst_adr                                                        "0x009C"
+#define MVDBLK_COMM4_inst                                                            0x009C
+#define MVDBLK_COMM4_HwCtrl_shift                                                    (1)
+#define MVDBLK_COMM4_HwCtrl_mask                                                     (0x000000FE)
+#define MVDBLK_COMM4_HwCtrl(data)                                                    (0x000000FE&((data)<<1))
+#define MVDBLK_COMM4_HwCtrl_src(data)                                                ((0x000000FE&(data))>>1)
+#define MVDBLK_COMM4_get_HwCtrl(data)                                                ((0x000000FE&(data))>>1)
+#define MVDBLK_COMM4_SoftReset_shift                                                 (0)
+#define MVDBLK_COMM4_SoftReset_mask                                                  (0x00000001)
+#define MVDBLK_COMM4_SoftReset(data)                                                 (0x00000001&((data)<<0))
+#define MVDBLK_COMM4_SoftReset_src(data)                                             ((0x00000001&(data))>>0)
+#define MVDBLK_COMM4_get_SoftReset(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MVDBLK_COMM5_0                                                               0x1800E674
+#define MVDBLK_COMM5_1                                                               0x1800E678
+#define MVDBLK_COMM5_2                                                               0x1800E67C
+#define MVDBLK_COMM5_0_reg_addr                                                      "0xB800E674"
+#define MVDBLK_COMM5_1_reg_addr                                                      "0xB800E678"
+#define MVDBLK_COMM5_2_reg_addr                                                      "0xB800E67C"
+#define MVDBLK_COMM5_0_reg                                                           0xB800E674
+#define MVDBLK_COMM5_1_reg                                                           0xB800E678
+#define MVDBLK_COMM5_2_reg                                                           0xB800E67C
+#define set_MVDBLK_COMM5_0_reg(data)   (*((volatile unsigned int*) MVDBLK_COMM5_0_reg)=data)
+#define set_MVDBLK_COMM5_1_reg(data)   (*((volatile unsigned int*) MVDBLK_COMM5_1_reg)=data)
+#define set_MVDBLK_COMM5_2_reg(data)   (*((volatile unsigned int*) MVDBLK_COMM5_2_reg)=data)
+#define get_MVDBLK_COMM5_0_reg   (*((volatile unsigned int*) MVDBLK_COMM5_0_reg))
+#define get_MVDBLK_COMM5_1_reg   (*((volatile unsigned int*) MVDBLK_COMM5_1_reg))
+#define get_MVDBLK_COMM5_2_reg   (*((volatile unsigned int*) MVDBLK_COMM5_2_reg))
+#define MVDBLK_COMM5_0_inst_adr                                                      "0x009D"
+#define MVDBLK_COMM5_1_inst_adr                                                      "0x009E"
+#define MVDBLK_COMM5_2_inst_adr                                                      "0x009F"
+#define MVDBLK_COMM5_0_inst                                                          0x009D
+#define MVDBLK_COMM5_1_inst                                                          0x009E
+#define MVDBLK_COMM5_2_inst                                                          0x009F
+#define MVDBLK_COMM5_DbgWriteBuf_shift                                               (0)
+#define MVDBLK_COMM5_DbgWriteBuf_mask                                                (0xFFFFFFFF)
+#define MVDBLK_COMM5_DbgWriteBuf(data)                                               (0xFFFFFFFF&((data)<<0))
+#define MVDBLK_COMM5_DbgWriteBuf_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define MVDBLK_COMM5_get_DbgWriteBuf(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define MVDBLK_COMM6                                                                 0x1800e690
+#define MVDBLK_COMM6_reg_addr                                                        "0xB800E690"
+#define MVDBLK_COMM6_reg                                                             0xB800E690
+#define set_MVDBLK_COMM6_reg(data)   (*((volatile unsigned int*) MVDBLK_COMM6_reg)=data)
+#define get_MVDBLK_COMM6_reg   (*((volatile unsigned int*) MVDBLK_COMM6_reg))
+#define MVDBLK_COMM6_inst_adr                                                        "0x00A4"
+#define MVDBLK_COMM6_inst                                                            0x00A4
+#define MVDBLK_COMM6_DbgStoreCount_shift                                             (0)
+#define MVDBLK_COMM6_DbgStoreCount_mask                                              (0x0000FFFF)
+#define MVDBLK_COMM6_DbgStoreCount(data)                                             (0x0000FFFF&((data)<<0))
+#define MVDBLK_COMM6_DbgStoreCount_src(data)                                         ((0x0000FFFF&(data))>>0)
+#define MVDBLK_COMM6_get_DbgStoreCount(data)                                         ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_H264PIC                                                               0x1800e600
+#define MVDBLK_H264PIC_reg_addr                                                      "0xB800E600"
+#define MVDBLK_H264PIC_reg                                                           0xB800E600
+#define set_MVDBLK_H264PIC_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PIC_reg)=data)
+#define get_MVDBLK_H264PIC_reg   (*((volatile unsigned int*) MVDBLK_H264PIC_reg))
+#define MVDBLK_H264PIC_inst_adr                                                      "0x0080"
+#define MVDBLK_H264PIC_inst                                                          0x0080
+#define MVDBLK_H264PIC_RefPicList10Short_shift                                       (7)
+#define MVDBLK_H264PIC_RefPicList10Short_mask                                        (0x00000080)
+#define MVDBLK_H264PIC_RefPicList10Short(data)                                       (0x00000080&((data)<<7))
+#define MVDBLK_H264PIC_RefPicList10Short_src(data)                                   ((0x00000080&(data))>>7)
+#define MVDBLK_H264PIC_get_RefPicList10Short(data)                                   ((0x00000080&(data))>>7)
+#define MVDBLK_H264PIC_BotLeTopAbsDiffPOC_shift                                      (6)
+#define MVDBLK_H264PIC_BotLeTopAbsDiffPOC_mask                                       (0x00000040)
+#define MVDBLK_H264PIC_BotLeTopAbsDiffPOC(data)                                      (0x00000040&((data)<<6))
+#define MVDBLK_H264PIC_BotLeTopAbsDiffPOC_src(data)                                  ((0x00000040&(data))>>6)
+#define MVDBLK_H264PIC_get_BotLeTopAbsDiffPOC(data)                                  ((0x00000040&(data))>>6)
+#define MVDBLK_H264PIC_DirectSpatial_shift                                           (5)
+#define MVDBLK_H264PIC_DirectSpatial_mask                                            (0x00000020)
+#define MVDBLK_H264PIC_DirectSpatial(data)                                           (0x00000020&((data)<<5))
+#define MVDBLK_H264PIC_DirectSpatial_src(data)                                       ((0x00000020&(data))>>5)
+#define MVDBLK_H264PIC_get_DirectSpatial(data)                                       ((0x00000020&(data))>>5)
+#define MVDBLK_H264PIC_ColPicStruct_shift                                            (3)
+#define MVDBLK_H264PIC_ColPicStruct_mask                                             (0x00000018)
+#define MVDBLK_H264PIC_ColPicStruct(data)                                            (0x00000018&((data)<<3))
+#define MVDBLK_H264PIC_ColPicStruct_src(data)                                        ((0x00000018&(data))>>3)
+#define MVDBLK_H264PIC_get_ColPicStruct(data)                                        ((0x00000018&(data))>>3)
+#define MVDBLK_H264PIC_CurrPicStruct_shift                                           (1)
+#define MVDBLK_H264PIC_CurrPicStruct_mask                                            (0x00000006)
+#define MVDBLK_H264PIC_CurrPicStruct(data)                                           (0x00000006&((data)<<1))
+#define MVDBLK_H264PIC_CurrPicStruct_src(data)                                       ((0x00000006&(data))>>1)
+#define MVDBLK_H264PIC_get_CurrPicStruct(data)                                       ((0x00000006&(data))>>1)
+#define MVDBLK_H264PIC_Direct8x8Inf_shift                                            (0)
+#define MVDBLK_H264PIC_Direct8x8Inf_mask                                             (0x00000001)
+#define MVDBLK_H264PIC_Direct8x8Inf(data)                                            (0x00000001&((data)<<0))
+#define MVDBLK_H264PIC_Direct8x8Inf_src(data)                                        ((0x00000001&(data))>>0)
+#define MVDBLK_H264PIC_get_Direct8x8Inf(data)                                        ((0x00000001&(data))>>0)
+
+
+#define MVDBLK_H264PIC1                                                              0x1800e604
+#define MVDBLK_H264PIC1_reg_addr                                                     "0xB800E604"
+#define MVDBLK_H264PIC1_reg                                                          0xB800E604
+#define set_MVDBLK_H264PIC1_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PIC1_reg)=data)
+#define get_MVDBLK_H264PIC1_reg   (*((volatile unsigned int*) MVDBLK_H264PIC1_reg))
+#define MVDBLK_H264PIC1_inst_adr                                                     "0x0081"
+#define MVDBLK_H264PIC1_inst                                                         0x0081
+#define MVDBLK_H264PIC1_CurrFrmPoc_shift                                             (0)
+#define MVDBLK_H264PIC1_CurrFrmPoc_mask                                              (0xFFFFFFFF)
+#define MVDBLK_H264PIC1_CurrFrmPoc(data)                                             (0xFFFFFFFF&((data)<<0))
+#define MVDBLK_H264PIC1_CurrFrmPoc_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define MVDBLK_H264PIC1_get_CurrFrmPoc(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define MVDBLK_H264PIC2                                                              0x1800e608
+#define MVDBLK_H264PIC2_reg_addr                                                     "0xB800E608"
+#define MVDBLK_H264PIC2_reg                                                          0xB800E608
+#define set_MVDBLK_H264PIC2_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PIC2_reg)=data)
+#define get_MVDBLK_H264PIC2_reg   (*((volatile unsigned int*) MVDBLK_H264PIC2_reg))
+#define MVDBLK_H264PIC2_inst_adr                                                     "0x0082"
+#define MVDBLK_H264PIC2_inst                                                         0x0082
+#define MVDBLK_H264PIC2_CurrTopPoc_shift                                             (0)
+#define MVDBLK_H264PIC2_CurrTopPoc_mask                                              (0xFFFFFFFF)
+#define MVDBLK_H264PIC2_CurrTopPoc(data)                                             (0xFFFFFFFF&((data)<<0))
+#define MVDBLK_H264PIC2_CurrTopPoc_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define MVDBLK_H264PIC2_get_CurrTopPoc(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define MVDBLK_H264PIC3                                                              0x1800e60c
+#define MVDBLK_H264PIC3_reg_addr                                                     "0xB800E60C"
+#define MVDBLK_H264PIC3_reg                                                          0xB800E60C
+#define set_MVDBLK_H264PIC3_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PIC3_reg)=data)
+#define get_MVDBLK_H264PIC3_reg   (*((volatile unsigned int*) MVDBLK_H264PIC3_reg))
+#define MVDBLK_H264PIC3_inst_adr                                                     "0x0083"
+#define MVDBLK_H264PIC3_inst                                                         0x0083
+#define MVDBLK_H264PIC3_CurrBotPoc_shift                                             (0)
+#define MVDBLK_H264PIC3_CurrBotPoc_mask                                              (0xFFFFFFFF)
+#define MVDBLK_H264PIC3_CurrBotPoc(data)                                             (0xFFFFFFFF&((data)<<0))
+#define MVDBLK_H264PIC3_CurrBotPoc_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define MVDBLK_H264PIC3_get_CurrBotPoc(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define MVDBLK_H264CO                                                                0x1800e610
+#define MVDBLK_H264CO_reg_addr                                                       "0xB800E610"
+#define MVDBLK_H264CO_reg                                                            0xB800E610
+#define set_MVDBLK_H264CO_reg(data)   (*((volatile unsigned int*) MVDBLK_H264CO_reg)=data)
+#define get_MVDBLK_H264CO_reg   (*((volatile unsigned int*) MVDBLK_H264CO_reg))
+#define MVDBLK_H264CO_inst_adr                                                       "0x0084"
+#define MVDBLK_H264CO_inst                                                           0x0084
+#define MVDBLK_H264CO_CoMem8x8_shift                                                 (0)
+#define MVDBLK_H264CO_CoMem8x8_mask                                                  (0x00000001)
+#define MVDBLK_H264CO_CoMem8x8(data)                                                 (0x00000001&((data)<<0))
+#define MVDBLK_H264CO_CoMem8x8_src(data)                                             ((0x00000001&(data))>>0)
+#define MVDBLK_H264CO_get_CoMem8x8(data)                                             ((0x00000001&(data))>>0)
+
+
+#define MVDBLK_H264CO1                                                               0x1800e614
+#define MVDBLK_H264CO1_reg_addr                                                      "0xB800E614"
+#define MVDBLK_H264CO1_reg                                                           0xB800E614
+#define set_MVDBLK_H264CO1_reg(data)   (*((volatile unsigned int*) MVDBLK_H264CO1_reg)=data)
+#define get_MVDBLK_H264CO1_reg   (*((volatile unsigned int*) MVDBLK_H264CO1_reg))
+#define MVDBLK_H264CO1_inst_adr                                                      "0x0085"
+#define MVDBLK_H264CO1_inst                                                          0x0085
+#define MVDBLK_H264CO1_StCoMemSAddr_shift                                            (0)
+#define MVDBLK_H264CO1_StCoMemSAddr_mask                                             (0x7FFFFFFF)
+#define MVDBLK_H264CO1_StCoMemSAddr(data)                                            (0x7FFFFFFF&((data)<<0))
+#define MVDBLK_H264CO1_StCoMemSAddr_src(data)                                        ((0x7FFFFFFF&(data))>>0)
+#define MVDBLK_H264CO1_get_StCoMemSAddr(data)                                        ((0x7FFFFFFF&(data))>>0)
+
+
+#define MVDBLK_H264CO2                                                               0x1800e618
+#define MVDBLK_H264CO2_reg_addr                                                      "0xB800E618"
+#define MVDBLK_H264CO2_reg                                                           0xB800E618
+#define set_MVDBLK_H264CO2_reg(data)   (*((volatile unsigned int*) MVDBLK_H264CO2_reg)=data)
+#define get_MVDBLK_H264CO2_reg   (*((volatile unsigned int*) MVDBLK_H264CO2_reg))
+#define MVDBLK_H264CO2_inst_adr                                                      "0x0086"
+#define MVDBLK_H264CO2_inst                                                          0x0086
+#define MVDBLK_H264CO2_MbaffAddr_shift                                               (31)
+#define MVDBLK_H264CO2_MbaffAddr_mask                                                (0x80000000)
+#define MVDBLK_H264CO2_MbaffAddr(data)                                               (0x80000000&((data)<<31))
+#define MVDBLK_H264CO2_MbaffAddr_src(data)                                           ((0x80000000&(data))>>31)
+#define MVDBLK_H264CO2_get_MbaffAddr(data)                                           ((0x80000000&(data))>>31)
+#define MVDBLK_H264CO2_LdCoMemSAddr_shift                                            (0)
+#define MVDBLK_H264CO2_LdCoMemSAddr_mask                                             (0x7FFFFFFF)
+#define MVDBLK_H264CO2_LdCoMemSAddr(data)                                            (0x7FFFFFFF&((data)<<0))
+#define MVDBLK_H264CO2_LdCoMemSAddr_src(data)                                        ((0x7FFFFFFF&(data))>>0)
+#define MVDBLK_H264CO2_get_LdCoMemSAddr(data)                                        ((0x7FFFFFFF&(data))>>0)
+
+
+#define MVDBLK_H264CO3                                                               0x1800e61c
+#define MVDBLK_H264CO3_reg_addr                                                      "0xB800E61C"
+#define MVDBLK_H264CO3_reg                                                           0xB800E61C
+#define set_MVDBLK_H264CO3_reg(data)   (*((volatile unsigned int*) MVDBLK_H264CO3_reg)=data)
+#define get_MVDBLK_H264CO3_reg   (*((volatile unsigned int*) MVDBLK_H264CO3_reg))
+#define MVDBLK_H264CO3_inst_adr                                                      "0x0087"
+#define MVDBLK_H264CO3_inst                                                          0x0087
+#define MVDBLK_H264CO3_EnableLdCoMem1_shift                                          (31)
+#define MVDBLK_H264CO3_EnableLdCoMem1_mask                                           (0x80000000)
+#define MVDBLK_H264CO3_EnableLdCoMem1(data)                                          (0x80000000&((data)<<31))
+#define MVDBLK_H264CO3_EnableLdCoMem1_src(data)                                      ((0x80000000&(data))>>31)
+#define MVDBLK_H264CO3_get_EnableLdCoMem1(data)                                      ((0x80000000&(data))>>31)
+#define MVDBLK_H264CO3_LdCoMemSAddr1_shift                                           (0)
+#define MVDBLK_H264CO3_LdCoMemSAddr1_mask                                            (0x7FFFFFFF)
+#define MVDBLK_H264CO3_LdCoMemSAddr1(data)                                           (0x7FFFFFFF&((data)<<0))
+#define MVDBLK_H264CO3_LdCoMemSAddr1_src(data)                                       ((0x7FFFFFFF&(data))>>0)
+#define MVDBLK_H264CO3_get_LdCoMemSAddr1(data)                                       ((0x7FFFFFFF&(data))>>0)
+
+
+#define MVDBLK_H264NH                                                                0x1800e6d0
+#define MVDBLK_H264NH_reg_addr                                                       "0xB800E6D0"
+#define MVDBLK_H264NH_reg                                                            0xB800E6D0
+#define set_MVDBLK_H264NH_reg(data)   (*((volatile unsigned int*) MVDBLK_H264NH_reg)=data)
+#define get_MVDBLK_H264NH_reg   (*((volatile unsigned int*) MVDBLK_H264NH_reg))
+#define MVDBLK_H264NH_inst_adr                                                       "0x00B4"
+#define MVDBLK_H264NH_inst                                                           0x00B4
+#define MVDBLK_H264NH_AutoLdStOff_shift                                              (3)
+#define MVDBLK_H264NH_AutoLdStOff_mask                                               (0x00000008)
+#define MVDBLK_H264NH_AutoLdStOff(data)                                              (0x00000008&((data)<<3))
+#define MVDBLK_H264NH_AutoLdStOff_src(data)                                          ((0x00000008&(data))>>3)
+#define MVDBLK_H264NH_get_AutoLdStOff(data)                                          ((0x00000008&(data))>>3)
+#define MVDBLK_H264NH_InitNhMemCmd_shift                                             (2)
+#define MVDBLK_H264NH_InitNhMemCmd_mask                                              (0x00000004)
+#define MVDBLK_H264NH_InitNhMemCmd(data)                                             (0x00000004&((data)<<2))
+#define MVDBLK_H264NH_InitNhMemCmd_src(data)                                         ((0x00000004&(data))>>2)
+#define MVDBLK_H264NH_get_InitNhMemCmd(data)                                         ((0x00000004&(data))>>2)
+#define MVDBLK_H264NH_LdNhMemCmd_shift                                               (1)
+#define MVDBLK_H264NH_LdNhMemCmd_mask                                                (0x00000002)
+#define MVDBLK_H264NH_LdNhMemCmd(data)                                               (0x00000002&((data)<<1))
+#define MVDBLK_H264NH_LdNhMemCmd_src(data)                                           ((0x00000002&(data))>>1)
+#define MVDBLK_H264NH_get_LdNhMemCmd(data)                                           ((0x00000002&(data))>>1)
+#define MVDBLK_H264NH_StNhMemCmd_shift                                               (0)
+#define MVDBLK_H264NH_StNhMemCmd_mask                                                (0x00000001)
+#define MVDBLK_H264NH_StNhMemCmd(data)                                               (0x00000001&((data)<<0))
+#define MVDBLK_H264NH_StNhMemCmd_src(data)                                           ((0x00000001&(data))>>0)
+#define MVDBLK_H264NH_get_StNhMemCmd(data)                                           ((0x00000001&(data))>>0)
+
+
+#define MVDBLK_H264NH1                                                               0x1800e6d4
+#define MVDBLK_H264NH1_reg_addr                                                      "0xB800E6D4"
+#define MVDBLK_H264NH1_reg                                                           0xB800E6D4
+#define set_MVDBLK_H264NH1_reg(data)   (*((volatile unsigned int*) MVDBLK_H264NH1_reg)=data)
+#define get_MVDBLK_H264NH1_reg   (*((volatile unsigned int*) MVDBLK_H264NH1_reg))
+#define MVDBLK_H264NH1_inst_adr                                                      "0x00B5"
+#define MVDBLK_H264NH1_inst                                                          0x00B5
+#define MVDBLK_H264NH1_StNhMemSAddr_shift                                            (0)
+#define MVDBLK_H264NH1_StNhMemSAddr_mask                                             (0x7FFFFFFF)
+#define MVDBLK_H264NH1_StNhMemSAddr(data)                                            (0x7FFFFFFF&((data)<<0))
+#define MVDBLK_H264NH1_StNhMemSAddr_src(data)                                        ((0x7FFFFFFF&(data))>>0)
+#define MVDBLK_H264NH1_get_StNhMemSAddr(data)                                        ((0x7FFFFFFF&(data))>>0)
+
+
+#define MVDBLK_H264NH2                                                               0x1800e6d8
+#define MVDBLK_H264NH2_reg_addr                                                      "0xB800E6D8"
+#define MVDBLK_H264NH2_reg                                                           0xB800E6D8
+#define set_MVDBLK_H264NH2_reg(data)   (*((volatile unsigned int*) MVDBLK_H264NH2_reg)=data)
+#define get_MVDBLK_H264NH2_reg   (*((volatile unsigned int*) MVDBLK_H264NH2_reg))
+#define MVDBLK_H264NH2_inst_adr                                                      "0x00B6"
+#define MVDBLK_H264NH2_inst                                                          0x00B6
+#define MVDBLK_H264NH2_LdNhMemSAddr_shift                                            (0)
+#define MVDBLK_H264NH2_LdNhMemSAddr_mask                                             (0x7FFFFFFF)
+#define MVDBLK_H264NH2_LdNhMemSAddr(data)                                            (0x7FFFFFFF&((data)<<0))
+#define MVDBLK_H264NH2_LdNhMemSAddr_src(data)                                        ((0x7FFFFFFF&(data))>>0)
+#define MVDBLK_H264NH2_get_LdNhMemSAddr(data)                                        ((0x7FFFFFFF&(data))>>0)
+
+
+#define MVDBLK_H264DI                                                                0x1800e6dc
+#define MVDBLK_H264DI_reg_addr                                                       "0xB800E6DC"
+#define MVDBLK_H264DI_reg                                                            0xB800E6DC
+#define set_MVDBLK_H264DI_reg(data)   (*((volatile unsigned int*) MVDBLK_H264DI_reg)=data)
+#define get_MVDBLK_H264DI_reg   (*((volatile unsigned int*) MVDBLK_H264DI_reg))
+#define MVDBLK_H264DI_inst_adr                                                       "0x00B7"
+#define MVDBLK_H264DI_inst                                                           0x00B7
+#define MVDBLK_H264DI_StDiMemPicIndex_shift                                          (0)
+#define MVDBLK_H264DI_StDiMemPicIndex_mask                                           (0x0000007F)
+#define MVDBLK_H264DI_StDiMemPicIndex(data)                                          (0x0000007F&((data)<<0))
+#define MVDBLK_H264DI_StDiMemPicIndex_src(data)                                      ((0x0000007F&(data))>>0)
+#define MVDBLK_H264DI_get_StDiMemPicIndex(data)                                      ((0x0000007F&(data))>>0)
+
+
+#define MVDBLK_H264DI1                                                               0x1800e6e0
+#define MVDBLK_H264DI1_reg_addr                                                      "0xB800E6E0"
+#define MVDBLK_H264DI1_reg                                                           0xB800E6E0
+#define set_MVDBLK_H264DI1_reg(data)   (*((volatile unsigned int*) MVDBLK_H264DI1_reg)=data)
+#define get_MVDBLK_H264DI1_reg   (*((volatile unsigned int*) MVDBLK_H264DI1_reg))
+#define MVDBLK_H264DI1_inst_adr                                                      "0x00B8"
+#define MVDBLK_H264DI1_inst                                                          0x00B8
+#define MVDBLK_H264DI1_StDiEnable_shift                                              (8)
+#define MVDBLK_H264DI1_StDiEnable_mask                                               (0x00000100)
+#define MVDBLK_H264DI1_StDiEnable(data)                                              (0x00000100&((data)<<8))
+#define MVDBLK_H264DI1_StDiEnable_src(data)                                          ((0x00000100&(data))>>8)
+#define MVDBLK_H264DI1_get_StDiEnable(data)                                          ((0x00000100&(data))>>8)
+#define MVDBLK_H264DI1_StDiMvThres_shift                                             (0)
+#define MVDBLK_H264DI1_StDiMvThres_mask                                              (0x000000FF)
+#define MVDBLK_H264DI1_StDiMvThres(data)                                             (0x000000FF&((data)<<0))
+#define MVDBLK_H264DI1_StDiMvThres_src(data)                                         ((0x000000FF&(data))>>0)
+#define MVDBLK_H264DI1_get_StDiMvThres(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define MVDBLK_H264PX                                                                0x1800e620
+#define MVDBLK_H264PX_reg_addr                                                       "0xB800E620"
+#define MVDBLK_H264PX_reg                                                            0xB800E620
+#define set_MVDBLK_H264PX_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PX_reg)=data)
+#define get_MVDBLK_H264PX_reg   (*((volatile unsigned int*) MVDBLK_H264PX_reg))
+#define MVDBLK_H264PX_inst_adr                                                       "0x0088"
+#define MVDBLK_H264PX_inst                                                           0x0088
+#define MVDBLK_H264PX_List1Size_shift                                                (5)
+#define MVDBLK_H264PX_List1Size_mask                                                 (0x000003E0)
+#define MVDBLK_H264PX_List1Size(data)                                                (0x000003E0&((data)<<5))
+#define MVDBLK_H264PX_List1Size_src(data)                                            ((0x000003E0&(data))>>5)
+#define MVDBLK_H264PX_get_List1Size(data)                                            ((0x000003E0&(data))>>5)
+#define MVDBLK_H264PX_List0Size_shift                                                (0)
+#define MVDBLK_H264PX_List0Size_mask                                                 (0x0000001F)
+#define MVDBLK_H264PX_List0Size(data)                                                (0x0000001F&((data)<<0))
+#define MVDBLK_H264PX_List0Size_src(data)                                            ((0x0000001F&(data))>>0)
+#define MVDBLK_H264PX_get_List0Size(data)                                            ((0x0000001F&(data))>>0)
+
+
+#define MVDBLK_H264PX1                                                               0x1800e624
+#define MVDBLK_H264PX1_reg_addr                                                      "0xB800E624"
+#define MVDBLK_H264PX1_reg                                                           0xB800E624
+#define set_MVDBLK_H264PX1_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PX1_reg)=data)
+#define get_MVDBLK_H264PX1_reg   (*((volatile unsigned int*) MVDBLK_H264PX1_reg))
+#define MVDBLK_H264PX1_inst_adr                                                      "0x0089"
+#define MVDBLK_H264PX1_inst                                                          0x0089
+#define MVDBLK_H264PX1_FrmPocAddrL0_shift                                            (0)
+#define MVDBLK_H264PX1_FrmPocAddrL0_mask                                             (0x0000FFFF)
+#define MVDBLK_H264PX1_FrmPocAddrL0(data)                                            (0x0000FFFF&((data)<<0))
+#define MVDBLK_H264PX1_FrmPocAddrL0_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define MVDBLK_H264PX1_get_FrmPocAddrL0(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_H264PX2                                                               0x1800e628
+#define MVDBLK_H264PX2_reg_addr                                                      "0xB800E628"
+#define MVDBLK_H264PX2_reg                                                           0xB800E628
+#define set_MVDBLK_H264PX2_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PX2_reg)=data)
+#define get_MVDBLK_H264PX2_reg   (*((volatile unsigned int*) MVDBLK_H264PX2_reg))
+#define MVDBLK_H264PX2_inst_adr                                                      "0x008A"
+#define MVDBLK_H264PX2_inst                                                          0x008A
+#define MVDBLK_H264PX2_TopPocAddrL0_shift                                            (0)
+#define MVDBLK_H264PX2_TopPocAddrL0_mask                                             (0x0000FFFF)
+#define MVDBLK_H264PX2_TopPocAddrL0(data)                                            (0x0000FFFF&((data)<<0))
+#define MVDBLK_H264PX2_TopPocAddrL0_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define MVDBLK_H264PX2_get_TopPocAddrL0(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_H264PX3                                                               0x1800e62c
+#define MVDBLK_H264PX3_reg_addr                                                      "0xB800E62C"
+#define MVDBLK_H264PX3_reg                                                           0xB800E62C
+#define set_MVDBLK_H264PX3_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PX3_reg)=data)
+#define get_MVDBLK_H264PX3_reg   (*((volatile unsigned int*) MVDBLK_H264PX3_reg))
+#define MVDBLK_H264PX3_inst_adr                                                      "0x008B"
+#define MVDBLK_H264PX3_inst                                                          0x008B
+#define MVDBLK_H264PX3_BotPocAddrL0_shift                                            (0)
+#define MVDBLK_H264PX3_BotPocAddrL0_mask                                             (0x0000FFFF)
+#define MVDBLK_H264PX3_BotPocAddrL0(data)                                            (0x0000FFFF&((data)<<0))
+#define MVDBLK_H264PX3_BotPocAddrL0_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define MVDBLK_H264PX3_get_BotPocAddrL0(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_H264PX4                                                               0x1800e630
+#define MVDBLK_H264PX4_reg_addr                                                      "0xB800E630"
+#define MVDBLK_H264PX4_reg                                                           0xB800E630
+#define set_MVDBLK_H264PX4_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PX4_reg)=data)
+#define get_MVDBLK_H264PX4_reg   (*((volatile unsigned int*) MVDBLK_H264PX4_reg))
+#define MVDBLK_H264PX4_inst_adr                                                      "0x008C"
+#define MVDBLK_H264PX4_inst                                                          0x008C
+#define MVDBLK_H264PX4_FrmPocAddrL1_shift                                            (0)
+#define MVDBLK_H264PX4_FrmPocAddrL1_mask                                             (0x0000FFFF)
+#define MVDBLK_H264PX4_FrmPocAddrL1(data)                                            (0x0000FFFF&((data)<<0))
+#define MVDBLK_H264PX4_FrmPocAddrL1_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define MVDBLK_H264PX4_get_FrmPocAddrL1(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_H264PX5                                                               0x1800e634
+#define MVDBLK_H264PX5_reg_addr                                                      "0xB800E634"
+#define MVDBLK_H264PX5_reg                                                           0xB800E634
+#define set_MVDBLK_H264PX5_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PX5_reg)=data)
+#define get_MVDBLK_H264PX5_reg   (*((volatile unsigned int*) MVDBLK_H264PX5_reg))
+#define MVDBLK_H264PX5_inst_adr                                                      "0x008D"
+#define MVDBLK_H264PX5_inst                                                          0x008D
+#define MVDBLK_H264PX5_TopPocAddrL1_shift                                            (0)
+#define MVDBLK_H264PX5_TopPocAddrL1_mask                                             (0x0000FFFF)
+#define MVDBLK_H264PX5_TopPocAddrL1(data)                                            (0x0000FFFF&((data)<<0))
+#define MVDBLK_H264PX5_TopPocAddrL1_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define MVDBLK_H264PX5_get_TopPocAddrL1(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_H264PX6                                                               0x1800e638
+#define MVDBLK_H264PX6_reg_addr                                                      "0xB800E638"
+#define MVDBLK_H264PX6_reg                                                           0xB800E638
+#define set_MVDBLK_H264PX6_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PX6_reg)=data)
+#define get_MVDBLK_H264PX6_reg   (*((volatile unsigned int*) MVDBLK_H264PX6_reg))
+#define MVDBLK_H264PX6_inst_adr                                                      "0x008E"
+#define MVDBLK_H264PX6_inst                                                          0x008E
+#define MVDBLK_H264PX6_BotPocAddrL1_shift                                            (0)
+#define MVDBLK_H264PX6_BotPocAddrL1_mask                                             (0x0000FFFF)
+#define MVDBLK_H264PX6_BotPocAddrL1(data)                                            (0x0000FFFF&((data)<<0))
+#define MVDBLK_H264PX6_BotPocAddrL1_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define MVDBLK_H264PX6_get_BotPocAddrL1(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_H264PX7                                                               0x1800e63c
+#define MVDBLK_H264PX7_reg_addr                                                      "0xB800E63C"
+#define MVDBLK_H264PX7_reg                                                           0xB800E63C
+#define set_MVDBLK_H264PX7_reg(data)   (*((volatile unsigned int*) MVDBLK_H264PX7_reg)=data)
+#define get_MVDBLK_H264PX7_reg   (*((volatile unsigned int*) MVDBLK_H264PX7_reg))
+#define MVDBLK_H264PX7_inst_adr                                                      "0x008F"
+#define MVDBLK_H264PX7_inst                                                          0x008F
+#define MVDBLK_H264PX7_PicInfoAddr_shift                                             (0)
+#define MVDBLK_H264PX7_PicInfoAddr_mask                                              (0x0000FFFF)
+#define MVDBLK_H264PX7_PicInfoAddr(data)                                             (0x0000FFFF&((data)<<0))
+#define MVDBLK_H264PX7_PicInfoAddr_src(data)                                         ((0x0000FFFF&(data))>>0)
+#define MVDBLK_H264PX7_get_PicInfoAddr(data)                                         ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_VC1PIC                                                                0x1800e640
+#define MVDBLK_VC1PIC_reg_addr                                                       "0xB800E640"
+#define MVDBLK_VC1PIC_reg                                                            0xB800E640
+#define set_MVDBLK_VC1PIC_reg(data)   (*((volatile unsigned int*) MVDBLK_VC1PIC_reg)=data)
+#define get_MVDBLK_VC1PIC_reg   (*((volatile unsigned int*) MVDBLK_VC1PIC_reg))
+#define MVDBLK_VC1PIC_inst_adr                                                       "0x0090"
+#define MVDBLK_VC1PIC_inst                                                           0x0090
+#define MVDBLK_VC1PIC_RefField_shift                                                 (12)
+#define MVDBLK_VC1PIC_RefField_mask                                                  (0x00001000)
+#define MVDBLK_VC1PIC_RefField(data)                                                 (0x00001000&((data)<<12))
+#define MVDBLK_VC1PIC_RefField_src(data)                                             ((0x00001000&(data))>>12)
+#define MVDBLK_VC1PIC_get_RefField(data)                                             ((0x00001000&(data))>>12)
+#define MVDBLK_VC1PIC_FastUVmc_shift                                                 (11)
+#define MVDBLK_VC1PIC_FastUVmc_mask                                                  (0x00000800)
+#define MVDBLK_VC1PIC_FastUVmc(data)                                                 (0x00000800&((data)<<11))
+#define MVDBLK_VC1PIC_FastUVmc_src(data)                                             ((0x00000800&(data))>>11)
+#define MVDBLK_VC1PIC_get_FastUVmc(data)                                             ((0x00000800&(data))>>11)
+#define MVDBLK_VC1PIC_ScaleFactor_shift                                              (0)
+#define MVDBLK_VC1PIC_ScaleFactor_mask                                               (0x000007FF)
+#define MVDBLK_VC1PIC_ScaleFactor(data)                                              (0x000007FF&((data)<<0))
+#define MVDBLK_VC1PIC_ScaleFactor_src(data)                                          ((0x000007FF&(data))>>0)
+#define MVDBLK_VC1PIC_get_ScaleFactor(data)                                          ((0x000007FF&(data))>>0)
+
+
+#define MVDBLK_VC1PIC1                                                               0x1800e644
+#define MVDBLK_VC1PIC1_reg_addr                                                      "0xB800E644"
+#define MVDBLK_VC1PIC1_reg                                                           0xB800E644
+#define set_MVDBLK_VC1PIC1_reg(data)   (*((volatile unsigned int*) MVDBLK_VC1PIC1_reg)=data)
+#define get_MVDBLK_VC1PIC1_reg   (*((volatile unsigned int*) MVDBLK_VC1PIC1_reg))
+#define MVDBLK_VC1PIC1_inst_adr                                                      "0x0091"
+#define MVDBLK_VC1PIC1_inst                                                          0x0091
+#define MVDBLK_VC1PIC1_Scale_fw_shift                                                (20)
+#define MVDBLK_VC1PIC1_Scale_fw_mask                                                 (0x0FF00000)
+#define MVDBLK_VC1PIC1_Scale_fw(data)                                                (0x0FF00000&((data)<<20))
+#define MVDBLK_VC1PIC1_Scale_fw_src(data)                                            ((0x0FF00000&(data))>>20)
+#define MVDBLK_VC1PIC1_get_Scale_fw(data)                                            ((0x0FF00000&(data))>>20)
+#define MVDBLK_VC1PIC1_Scale1_fw_shift                                               (8)
+#define MVDBLK_VC1PIC1_Scale1_fw_mask                                                (0x000FFF00)
+#define MVDBLK_VC1PIC1_Scale1_fw(data)                                               (0x000FFF00&((data)<<8))
+#define MVDBLK_VC1PIC1_Scale1_fw_src(data)                                           ((0x000FFF00&(data))>>8)
+#define MVDBLK_VC1PIC1_get_Scale1_fw(data)                                           ((0x000FFF00&(data))>>8)
+#define MVDBLK_VC1PIC1_Scale2_fw_shift                                               (0)
+#define MVDBLK_VC1PIC1_Scale2_fw_mask                                                (0x000000FF)
+#define MVDBLK_VC1PIC1_Scale2_fw(data)                                               (0x000000FF&((data)<<0))
+#define MVDBLK_VC1PIC1_Scale2_fw_src(data)                                           ((0x000000FF&(data))>>0)
+#define MVDBLK_VC1PIC1_get_Scale2_fw(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define MVDBLK_VC1PIC2                                                               0x1800e648
+#define MVDBLK_VC1PIC2_reg_addr                                                      "0xB800E648"
+#define MVDBLK_VC1PIC2_reg                                                           0xB800E648
+#define set_MVDBLK_VC1PIC2_reg(data)   (*((volatile unsigned int*) MVDBLK_VC1PIC2_reg)=data)
+#define get_MVDBLK_VC1PIC2_reg   (*((volatile unsigned int*) MVDBLK_VC1PIC2_reg))
+#define MVDBLK_VC1PIC2_inst_adr                                                      "0x0092"
+#define MVDBLK_VC1PIC2_inst                                                          0x0092
+#define MVDBLK_VC1PIC2_ScaleUpOpp_fw_shift                                           (20)
+#define MVDBLK_VC1PIC2_ScaleUpOpp_fw_mask                                            (0x00100000)
+#define MVDBLK_VC1PIC2_ScaleUpOpp_fw(data)                                           (0x00100000&((data)<<20))
+#define MVDBLK_VC1PIC2_ScaleUpOpp_fw_src(data)                                       ((0x00100000&(data))>>20)
+#define MVDBLK_VC1PIC2_get_ScaleUpOpp_fw(data)                                       ((0x00100000&(data))>>20)
+#define MVDBLK_VC1PIC2_ScaleZone1X_fw_shift                                          (14)
+#define MVDBLK_VC1PIC2_ScaleZone1X_fw_mask                                           (0x000FC000)
+#define MVDBLK_VC1PIC2_ScaleZone1X_fw(data)                                          (0x000FC000&((data)<<14))
+#define MVDBLK_VC1PIC2_ScaleZone1X_fw_src(data)                                      ((0x000FC000&(data))>>14)
+#define MVDBLK_VC1PIC2_get_ScaleZone1X_fw(data)                                      ((0x000FC000&(data))>>14)
+#define MVDBLK_VC1PIC2_ScaleZone1Y_fw_shift                                          (10)
+#define MVDBLK_VC1PIC2_ScaleZone1Y_fw_mask                                           (0x00003C00)
+#define MVDBLK_VC1PIC2_ScaleZone1Y_fw(data)                                          (0x00003C00&((data)<<10))
+#define MVDBLK_VC1PIC2_ScaleZone1Y_fw_src(data)                                      ((0x00003C00&(data))>>10)
+#define MVDBLK_VC1PIC2_get_ScaleZone1Y_fw(data)                                      ((0x00003C00&(data))>>10)
+#define MVDBLK_VC1PIC2_Zone1OffsetX_fw_shift                                         (4)
+#define MVDBLK_VC1PIC2_Zone1OffsetX_fw_mask                                          (0x000003F0)
+#define MVDBLK_VC1PIC2_Zone1OffsetX_fw(data)                                         (0x000003F0&((data)<<4))
+#define MVDBLK_VC1PIC2_Zone1OffsetX_fw_src(data)                                     ((0x000003F0&(data))>>4)
+#define MVDBLK_VC1PIC2_get_Zone1OffsetX_fw(data)                                     ((0x000003F0&(data))>>4)
+#define MVDBLK_VC1PIC2_Zone1OffsetY_fw_shift                                         (0)
+#define MVDBLK_VC1PIC2_Zone1OffsetY_fw_mask                                          (0x0000000F)
+#define MVDBLK_VC1PIC2_Zone1OffsetY_fw(data)                                         (0x0000000F&((data)<<0))
+#define MVDBLK_VC1PIC2_Zone1OffsetY_fw_src(data)                                     ((0x0000000F&(data))>>0)
+#define MVDBLK_VC1PIC2_get_Zone1OffsetY_fw(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define MVDBLK_VC1PIC3                                                               0x1800e64c
+#define MVDBLK_VC1PIC3_reg_addr                                                      "0xB800E64C"
+#define MVDBLK_VC1PIC3_reg                                                           0xB800E64C
+#define set_MVDBLK_VC1PIC3_reg(data)   (*((volatile unsigned int*) MVDBLK_VC1PIC3_reg)=data)
+#define get_MVDBLK_VC1PIC3_reg   (*((volatile unsigned int*) MVDBLK_VC1PIC3_reg))
+#define MVDBLK_VC1PIC3_inst_adr                                                      "0x0093"
+#define MVDBLK_VC1PIC3_inst                                                          0x0093
+#define MVDBLK_VC1PIC3_Scale_bw_shift                                                (20)
+#define MVDBLK_VC1PIC3_Scale_bw_mask                                                 (0x0FF00000)
+#define MVDBLK_VC1PIC3_Scale_bw(data)                                                (0x0FF00000&((data)<<20))
+#define MVDBLK_VC1PIC3_Scale_bw_src(data)                                            ((0x0FF00000&(data))>>20)
+#define MVDBLK_VC1PIC3_get_Scale_bw(data)                                            ((0x0FF00000&(data))>>20)
+#define MVDBLK_VC1PIC3_Scale1_bw_shift                                               (8)
+#define MVDBLK_VC1PIC3_Scale1_bw_mask                                                (0x000FFF00)
+#define MVDBLK_VC1PIC3_Scale1_bw(data)                                               (0x000FFF00&((data)<<8))
+#define MVDBLK_VC1PIC3_Scale1_bw_src(data)                                           ((0x000FFF00&(data))>>8)
+#define MVDBLK_VC1PIC3_get_Scale1_bw(data)                                           ((0x000FFF00&(data))>>8)
+#define MVDBLK_VC1PIC3_Scale2_bw_shift                                               (0)
+#define MVDBLK_VC1PIC3_Scale2_bw_mask                                                (0x000000FF)
+#define MVDBLK_VC1PIC3_Scale2_bw(data)                                               (0x000000FF&((data)<<0))
+#define MVDBLK_VC1PIC3_Scale2_bw_src(data)                                           ((0x000000FF&(data))>>0)
+#define MVDBLK_VC1PIC3_get_Scale2_bw(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define MVDBLK_VC1PIC4                                                               0x1800e650
+#define MVDBLK_VC1PIC4_reg_addr                                                      "0xB800E650"
+#define MVDBLK_VC1PIC4_reg                                                           0xB800E650
+#define set_MVDBLK_VC1PIC4_reg(data)   (*((volatile unsigned int*) MVDBLK_VC1PIC4_reg)=data)
+#define get_MVDBLK_VC1PIC4_reg   (*((volatile unsigned int*) MVDBLK_VC1PIC4_reg))
+#define MVDBLK_VC1PIC4_inst_adr                                                      "0x0094"
+#define MVDBLK_VC1PIC4_inst                                                          0x0094
+#define MVDBLK_VC1PIC4_ScaleUpOpp_bw_shift                                           (20)
+#define MVDBLK_VC1PIC4_ScaleUpOpp_bw_mask                                            (0x00100000)
+#define MVDBLK_VC1PIC4_ScaleUpOpp_bw(data)                                           (0x00100000&((data)<<20))
+#define MVDBLK_VC1PIC4_ScaleUpOpp_bw_src(data)                                       ((0x00100000&(data))>>20)
+#define MVDBLK_VC1PIC4_get_ScaleUpOpp_bw(data)                                       ((0x00100000&(data))>>20)
+#define MVDBLK_VC1PIC4_ScaleZone1X_bw_shift                                          (14)
+#define MVDBLK_VC1PIC4_ScaleZone1X_bw_mask                                           (0x000FC000)
+#define MVDBLK_VC1PIC4_ScaleZone1X_bw(data)                                          (0x000FC000&((data)<<14))
+#define MVDBLK_VC1PIC4_ScaleZone1X_bw_src(data)                                      ((0x000FC000&(data))>>14)
+#define MVDBLK_VC1PIC4_get_ScaleZone1X_bw(data)                                      ((0x000FC000&(data))>>14)
+#define MVDBLK_VC1PIC4_ScaleZone1Y_bw_shift                                          (10)
+#define MVDBLK_VC1PIC4_ScaleZone1Y_bw_mask                                           (0x00003C00)
+#define MVDBLK_VC1PIC4_ScaleZone1Y_bw(data)                                          (0x00003C00&((data)<<10))
+#define MVDBLK_VC1PIC4_ScaleZone1Y_bw_src(data)                                      ((0x00003C00&(data))>>10)
+#define MVDBLK_VC1PIC4_get_ScaleZone1Y_bw(data)                                      ((0x00003C00&(data))>>10)
+#define MVDBLK_VC1PIC4_Zone1OffsetX_bw_shift                                         (4)
+#define MVDBLK_VC1PIC4_Zone1OffsetX_bw_mask                                          (0x000003F0)
+#define MVDBLK_VC1PIC4_Zone1OffsetX_bw(data)                                         (0x000003F0&((data)<<4))
+#define MVDBLK_VC1PIC4_Zone1OffsetX_bw_src(data)                                     ((0x000003F0&(data))>>4)
+#define MVDBLK_VC1PIC4_get_Zone1OffsetX_bw(data)                                     ((0x000003F0&(data))>>4)
+#define MVDBLK_VC1PIC4_Zone1OffsetY_bw_shift                                         (0)
+#define MVDBLK_VC1PIC4_Zone1OffsetY_bw_mask                                          (0x0000000F)
+#define MVDBLK_VC1PIC4_Zone1OffsetY_bw(data)                                         (0x0000000F&((data)<<0))
+#define MVDBLK_VC1PIC4_Zone1OffsetY_bw_src(data)                                     ((0x0000000F&(data))>>0)
+#define MVDBLK_VC1PIC4_get_Zone1OffsetY_bw(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define MVDBLK_VC1PIC5                                                               0x1800e654
+#define MVDBLK_VC1PIC5_reg_addr                                                      "0xB800E654"
+#define MVDBLK_VC1PIC5_reg                                                           0xB800E654
+#define set_MVDBLK_VC1PIC5_reg(data)   (*((volatile unsigned int*) MVDBLK_VC1PIC5_reg)=data)
+#define get_MVDBLK_VC1PIC5_reg   (*((volatile unsigned int*) MVDBLK_VC1PIC5_reg))
+#define MVDBLK_VC1PIC5_inst_adr                                                      "0x0095"
+#define MVDBLK_VC1PIC5_inst                                                          0x0095
+#define MVDBLK_VC1PIC5_RangeY_shift                                                  (13)
+#define MVDBLK_VC1PIC5_RangeY_mask                                                   (0x01FFE000)
+#define MVDBLK_VC1PIC5_RangeY(data)                                                  (0x01FFE000&((data)<<13))
+#define MVDBLK_VC1PIC5_RangeY_src(data)                                              ((0x01FFE000&(data))>>13)
+#define MVDBLK_VC1PIC5_get_RangeY(data)                                              ((0x01FFE000&(data))>>13)
+#define MVDBLK_VC1PIC5_RangeX_shift                                                  (0)
+#define MVDBLK_VC1PIC5_RangeX_mask                                                   (0x00001FFF)
+#define MVDBLK_VC1PIC5_RangeX(data)                                                  (0x00001FFF&((data)<<0))
+#define MVDBLK_VC1PIC5_RangeX_src(data)                                              ((0x00001FFF&(data))>>0)
+#define MVDBLK_VC1PIC5_get_RangeX(data)                                              ((0x00001FFF&(data))>>0)
+
+
+#define MVDBLK_AVSPIC                                                                0x1800e7d0
+#define MVDBLK_AVSPIC_reg_addr                                                       "0xB800E7D0"
+#define MVDBLK_AVSPIC_reg                                                            0xB800E7D0
+#define set_MVDBLK_AVSPIC_reg(data)   (*((volatile unsigned int*) MVDBLK_AVSPIC_reg)=data)
+#define get_MVDBLK_AVSPIC_reg   (*((volatile unsigned int*) MVDBLK_AVSPIC_reg))
+#define MVDBLK_AVSPIC_inst_adr                                                       "0x00F4"
+#define MVDBLK_AVSPIC_inst                                                           0x00F4
+#define MVDBLK_AVSPIC_AecEnable_shift                                                (4)
+#define MVDBLK_AVSPIC_AecEnable_mask                                                 (0x00000010)
+#define MVDBLK_AVSPIC_AecEnable(data)                                                (0x00000010&((data)<<4))
+#define MVDBLK_AVSPIC_AecEnable_src(data)                                            ((0x00000010&(data))>>4)
+#define MVDBLK_AVSPIC_get_AecEnable(data)                                            ((0x00000010&(data))>>4)
+#define MVDBLK_AVSPIC_PFieldSkip_shift                                               (3)
+#define MVDBLK_AVSPIC_PFieldSkip_mask                                                (0x00000008)
+#define MVDBLK_AVSPIC_PFieldSkip(data)                                               (0x00000008&((data)<<3))
+#define MVDBLK_AVSPIC_PFieldSkip_src(data)                                           ((0x00000008&(data))>>3)
+#define MVDBLK_AVSPIC_get_PFieldSkip(data)                                           ((0x00000008&(data))>>3)
+#define MVDBLK_AVSPIC_BFieldEnhanced_shift                                           (2)
+#define MVDBLK_AVSPIC_BFieldEnhanced_mask                                            (0x00000004)
+#define MVDBLK_AVSPIC_BFieldEnhanced(data)                                           (0x00000004&((data)<<2))
+#define MVDBLK_AVSPIC_BFieldEnhanced_src(data)                                       ((0x00000004&(data))>>2)
+#define MVDBLK_AVSPIC_get_BFieldEnhanced(data)                                       ((0x00000004&(data))>>2)
+#define MVDBLK_AVSPIC_PicRefFlag_shift                                               (1)
+#define MVDBLK_AVSPIC_PicRefFlag_mask                                                (0x00000002)
+#define MVDBLK_AVSPIC_PicRefFlag(data)                                               (0x00000002&((data)<<1))
+#define MVDBLK_AVSPIC_PicRefFlag_src(data)                                           ((0x00000002&(data))>>1)
+#define MVDBLK_AVSPIC_get_PicRefFlag(data)                                           ((0x00000002&(data))>>1)
+#define MVDBLK_AVSPIC_PicStructure_shift                                             (0)
+#define MVDBLK_AVSPIC_PicStructure_mask                                              (0x00000001)
+#define MVDBLK_AVSPIC_PicStructure(data)                                             (0x00000001&((data)<<0))
+#define MVDBLK_AVSPIC_PicStructure_src(data)                                         ((0x00000001&(data))>>0)
+#define MVDBLK_AVSPIC_get_PicStructure(data)                                         ((0x00000001&(data))>>0)
+
+
+#define MVDBLK_AVSPIC1                                                               0x1800e7d4
+#define MVDBLK_AVSPIC1_reg_addr                                                      "0xB800E7D4"
+#define MVDBLK_AVSPIC1_reg                                                           0xB800E7D4
+#define set_MVDBLK_AVSPIC1_reg(data)   (*((volatile unsigned int*) MVDBLK_AVSPIC1_reg)=data)
+#define get_MVDBLK_AVSPIC1_reg   (*((volatile unsigned int*) MVDBLK_AVSPIC1_reg))
+#define MVDBLK_AVSPIC1_inst_adr                                                      "0x00F5"
+#define MVDBLK_AVSPIC1_inst                                                          0x00F5
+#define MVDBLK_AVSPIC1_BlockDist0_shift                                              (16)
+#define MVDBLK_AVSPIC1_BlockDist0_mask                                               (0x01FF0000)
+#define MVDBLK_AVSPIC1_BlockDist0(data)                                              (0x01FF0000&((data)<<16))
+#define MVDBLK_AVSPIC1_BlockDist0_src(data)                                          ((0x01FF0000&(data))>>16)
+#define MVDBLK_AVSPIC1_get_BlockDist0(data)                                          ((0x01FF0000&(data))>>16)
+#define MVDBLK_AVSPIC1_BlockDist1_shift                                              (0)
+#define MVDBLK_AVSPIC1_BlockDist1_mask                                               (0x000001FF)
+#define MVDBLK_AVSPIC1_BlockDist1(data)                                              (0x000001FF&((data)<<0))
+#define MVDBLK_AVSPIC1_BlockDist1_src(data)                                          ((0x000001FF&(data))>>0)
+#define MVDBLK_AVSPIC1_get_BlockDist1(data)                                          ((0x000001FF&(data))>>0)
+
+
+#define MVDBLK_AVSPIC2                                                               0x1800e7d8
+#define MVDBLK_AVSPIC2_reg_addr                                                      "0xB800E7D8"
+#define MVDBLK_AVSPIC2_reg                                                           0xB800E7D8
+#define set_MVDBLK_AVSPIC2_reg(data)   (*((volatile unsigned int*) MVDBLK_AVSPIC2_reg)=data)
+#define get_MVDBLK_AVSPIC2_reg   (*((volatile unsigned int*) MVDBLK_AVSPIC2_reg))
+#define MVDBLK_AVSPIC2_inst_adr                                                      "0x00F6"
+#define MVDBLK_AVSPIC2_inst                                                          0x00F6
+#define MVDBLK_AVSPIC2_BlockDist2_shift                                              (16)
+#define MVDBLK_AVSPIC2_BlockDist2_mask                                               (0x01FF0000)
+#define MVDBLK_AVSPIC2_BlockDist2(data)                                              (0x01FF0000&((data)<<16))
+#define MVDBLK_AVSPIC2_BlockDist2_src(data)                                          ((0x01FF0000&(data))>>16)
+#define MVDBLK_AVSPIC2_get_BlockDist2(data)                                          ((0x01FF0000&(data))>>16)
+#define MVDBLK_AVSPIC2_BlockDist3_shift                                              (0)
+#define MVDBLK_AVSPIC2_BlockDist3_mask                                               (0x000001FF)
+#define MVDBLK_AVSPIC2_BlockDist3(data)                                              (0x000001FF&((data)<<0))
+#define MVDBLK_AVSPIC2_BlockDist3_src(data)                                          ((0x000001FF&(data))>>0)
+#define MVDBLK_AVSPIC2_get_BlockDist3(data)                                          ((0x000001FF&(data))>>0)
+
+
+#define MVDBLK_AVSPIC3                                                               0x1800e7dc
+#define MVDBLK_AVSPIC3_reg_addr                                                      "0xB800E7DC"
+#define MVDBLK_AVSPIC3_reg                                                           0xB800E7DC
+#define set_MVDBLK_AVSPIC3_reg(data)   (*((volatile unsigned int*) MVDBLK_AVSPIC3_reg)=data)
+#define get_MVDBLK_AVSPIC3_reg   (*((volatile unsigned int*) MVDBLK_AVSPIC3_reg))
+#define MVDBLK_AVSPIC3_inst_adr                                                      "0x00F7"
+#define MVDBLK_AVSPIC3_inst                                                          0x00F7
+#define MVDBLK_AVSPIC3_B16384DiviTRp0_shift                                          (16)
+#define MVDBLK_AVSPIC3_B16384DiviTRp0_mask                                           (0xFFFF0000)
+#define MVDBLK_AVSPIC3_B16384DiviTRp0(data)                                          (0xFFFF0000&((data)<<16))
+#define MVDBLK_AVSPIC3_B16384DiviTRp0_src(data)                                      ((0xFFFF0000&(data))>>16)
+#define MVDBLK_AVSPIC3_get_B16384DiviTRp0(data)                                      ((0xFFFF0000&(data))>>16)
+#define MVDBLK_AVSPIC3_B16384DiviTRp1_shift                                          (0)
+#define MVDBLK_AVSPIC3_B16384DiviTRp1_mask                                           (0x0000FFFF)
+#define MVDBLK_AVSPIC3_B16384DiviTRp1(data)                                          (0x0000FFFF&((data)<<0))
+#define MVDBLK_AVSPIC3_B16384DiviTRp1_src(data)                                      ((0x0000FFFF&(data))>>0)
+#define MVDBLK_AVSPIC3_get_B16384DiviTRp1(data)                                      ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_AVSPIC4                                                               0x1800e7e0
+#define MVDBLK_AVSPIC4_reg_addr                                                      "0xB800E7E0"
+#define MVDBLK_AVSPIC4_reg                                                           0xB800E7E0
+#define set_MVDBLK_AVSPIC4_reg(data)   (*((volatile unsigned int*) MVDBLK_AVSPIC4_reg)=data)
+#define get_MVDBLK_AVSPIC4_reg   (*((volatile unsigned int*) MVDBLK_AVSPIC4_reg))
+#define MVDBLK_AVSPIC4_inst_adr                                                      "0x00F8"
+#define MVDBLK_AVSPIC4_inst                                                          0x00F8
+#define MVDBLK_AVSPIC4_B16384DiviTRp2_shift                                          (16)
+#define MVDBLK_AVSPIC4_B16384DiviTRp2_mask                                           (0xFFFF0000)
+#define MVDBLK_AVSPIC4_B16384DiviTRp2(data)                                          (0xFFFF0000&((data)<<16))
+#define MVDBLK_AVSPIC4_B16384DiviTRp2_src(data)                                      ((0xFFFF0000&(data))>>16)
+#define MVDBLK_AVSPIC4_get_B16384DiviTRp2(data)                                      ((0xFFFF0000&(data))>>16)
+#define MVDBLK_AVSPIC4_B16384DiviTRp3_shift                                          (0)
+#define MVDBLK_AVSPIC4_B16384DiviTRp3_mask                                           (0x0000FFFF)
+#define MVDBLK_AVSPIC4_B16384DiviTRp3(data)                                          (0x0000FFFF&((data)<<0))
+#define MVDBLK_AVSPIC4_B16384DiviTRp3_src(data)                                      ((0x0000FFFF&(data))>>0)
+#define MVDBLK_AVSPIC4_get_B16384DiviTRp3(data)                                      ((0x0000FFFF&(data))>>0)
+
+
+#define MVDBLK_AVSPIC5                                                               0x1800e7e4
+#define MVDBLK_AVSPIC5_reg_addr                                                      "0xB800E7E4"
+#define MVDBLK_AVSPIC5_reg                                                           0xB800E7E4
+#define set_MVDBLK_AVSPIC5_reg(data)   (*((volatile unsigned int*) MVDBLK_AVSPIC5_reg)=data)
+#define get_MVDBLK_AVSPIC5_reg   (*((volatile unsigned int*) MVDBLK_AVSPIC5_reg))
+#define MVDBLK_AVSPIC5_inst_adr                                                      "0x00F9"
+#define MVDBLK_AVSPIC5_inst                                                          0x00F9
+#define MVDBLK_AVSPIC5_iTRb0_shift                                                   (16)
+#define MVDBLK_AVSPIC5_iTRb0_mask                                                    (0x01FF0000)
+#define MVDBLK_AVSPIC5_iTRb0(data)                                                   (0x01FF0000&((data)<<16))
+#define MVDBLK_AVSPIC5_iTRb0_src(data)                                               ((0x01FF0000&(data))>>16)
+#define MVDBLK_AVSPIC5_get_iTRb0(data)                                               ((0x01FF0000&(data))>>16)
+#define MVDBLK_AVSPIC5_iTRb1_shift                                                   (0)
+#define MVDBLK_AVSPIC5_iTRb1_mask                                                    (0x000001FF)
+#define MVDBLK_AVSPIC5_iTRb1(data)                                                   (0x000001FF&((data)<<0))
+#define MVDBLK_AVSPIC5_iTRb1_src(data)                                               ((0x000001FF&(data))>>0)
+#define MVDBLK_AVSPIC5_get_iTRb1(data)                                               ((0x000001FF&(data))>>0)
+
+
+#define MVDBLK_AVSPIC6                                                               0x1800e7e8
+#define MVDBLK_AVSPIC6_reg_addr                                                      "0xB800E7E8"
+#define MVDBLK_AVSPIC6_reg                                                           0xB800E7E8
+#define set_MVDBLK_AVSPIC6_reg(data)   (*((volatile unsigned int*) MVDBLK_AVSPIC6_reg)=data)
+#define get_MVDBLK_AVSPIC6_reg   (*((volatile unsigned int*) MVDBLK_AVSPIC6_reg))
+#define MVDBLK_AVSPIC6_inst_adr                                                      "0x00FA"
+#define MVDBLK_AVSPIC6_inst                                                          0x00FA
+#define MVDBLK_AVSPIC6_iTRb2_shift                                                   (16)
+#define MVDBLK_AVSPIC6_iTRb2_mask                                                    (0x01FF0000)
+#define MVDBLK_AVSPIC6_iTRb2(data)                                                   (0x01FF0000&((data)<<16))
+#define MVDBLK_AVSPIC6_iTRb2_src(data)                                               ((0x01FF0000&(data))>>16)
+#define MVDBLK_AVSPIC6_get_iTRb2(data)                                               ((0x01FF0000&(data))>>16)
+#define MVDBLK_AVSPIC6_iTRb3_shift                                                   (0)
+#define MVDBLK_AVSPIC6_iTRb3_mask                                                    (0x000001FF)
+#define MVDBLK_AVSPIC6_iTRb3(data)                                                   (0x000001FF&((data)<<0))
+#define MVDBLK_AVSPIC6_iTRb3_src(data)                                               ((0x000001FF&(data))>>0)
+#define MVDBLK_AVSPIC6_get_iTRb3(data)                                               ((0x000001FF&(data))>>0)
+
+
+#define MVDBLK_AVSPIC7                                                               0x1800e7ec
+#define MVDBLK_AVSPIC7_reg_addr                                                      "0xB800E7EC"
+#define MVDBLK_AVSPIC7_reg                                                           0xB800E7EC
+#define set_MVDBLK_AVSPIC7_reg(data)   (*((volatile unsigned int*) MVDBLK_AVSPIC7_reg)=data)
+#define get_MVDBLK_AVSPIC7_reg   (*((volatile unsigned int*) MVDBLK_AVSPIC7_reg))
+#define MVDBLK_AVSPIC7_inst_adr                                                      "0x00FB"
+#define MVDBLK_AVSPIC7_inst                                                          0x00FB
+#define MVDBLK_AVSPIC7_iTRd_shift                                                    (0)
+#define MVDBLK_AVSPIC7_iTRd_mask                                                     (0x000001FF)
+#define MVDBLK_AVSPIC7_iTRd(data)                                                    (0x000001FF&((data)<<0))
+#define MVDBLK_AVSPIC7_iTRd_src(data)                                                ((0x000001FF&(data))>>0)
+#define MVDBLK_AVSPIC7_get_iTRd(data)                                                ((0x000001FF&(data))>>0)
+
+
+#define MVDBLK_RM89PIC                                                               0x1800e7c0
+#define MVDBLK_RM89PIC_reg_addr                                                      "0xB800E7C0"
+#define MVDBLK_RM89PIC_reg                                                           0xB800E7C0
+#define set_MVDBLK_RM89PIC_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89PIC_reg)=data)
+#define get_MVDBLK_RM89PIC_reg   (*((volatile unsigned int*) MVDBLK_RM89PIC_reg))
+#define MVDBLK_RM89PIC_inst_adr                                                      "0x00F0"
+#define MVDBLK_RM89PIC_inst                                                          0x00F0
+#define MVDBLK_RM89PIC_iRatio0_shift                                                 (0)
+#define MVDBLK_RM89PIC_iRatio0_mask                                                  (0xFFFFFFFF)
+#define MVDBLK_RM89PIC_iRatio0(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define MVDBLK_RM89PIC_iRatio0_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define MVDBLK_RM89PIC_get_iRatio0(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define MVDBLK_RM89PIC1                                                              0x1800e7c4
+#define MVDBLK_RM89PIC1_reg_addr                                                     "0xB800E7C4"
+#define MVDBLK_RM89PIC1_reg                                                          0xB800E7C4
+#define set_MVDBLK_RM89PIC1_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89PIC1_reg)=data)
+#define get_MVDBLK_RM89PIC1_reg   (*((volatile unsigned int*) MVDBLK_RM89PIC1_reg))
+#define MVDBLK_RM89PIC1_inst_adr                                                     "0x00F1"
+#define MVDBLK_RM89PIC1_inst                                                         0x00F1
+#define MVDBLK_RM89PIC1_iRatio1_shift                                                (0)
+#define MVDBLK_RM89PIC1_iRatio1_mask                                                 (0xFFFFFFFF)
+#define MVDBLK_RM89PIC1_iRatio1(data)                                                (0xFFFFFFFF&((data)<<0))
+#define MVDBLK_RM89PIC1_iRatio1_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define MVDBLK_RM89PIC1_get_iRatio1(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define MVDBLK_RM89DIRECT                                                            0x1800e7c8
+#define MVDBLK_RM89DIRECT_reg_addr                                                   "0xB800E7C8"
+#define MVDBLK_RM89DIRECT_reg                                                        0xB800E7C8
+#define set_MVDBLK_RM89DIRECT_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89DIRECT_reg)=data)
+#define get_MVDBLK_RM89DIRECT_reg   (*((volatile unsigned int*) MVDBLK_RM89DIRECT_reg))
+#define MVDBLK_RM89DIRECT_inst_adr                                                   "0x00F2"
+#define MVDBLK_RM89DIRECT_inst                                                       0x00F2
+#define MVDBLK_RM89DIRECT_hix_shift                                                  (16)
+#define MVDBLK_RM89DIRECT_hix_mask                                                   (0x3FFF0000)
+#define MVDBLK_RM89DIRECT_hix(data)                                                  (0x3FFF0000&((data)<<16))
+#define MVDBLK_RM89DIRECT_hix_src(data)                                              ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT_get_hix(data)                                              ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT_lox_shift                                                  (0)
+#define MVDBLK_RM89DIRECT_lox_mask                                                   (0x00003FFF)
+#define MVDBLK_RM89DIRECT_lox(data)                                                  (0x00003FFF&((data)<<0))
+#define MVDBLK_RM89DIRECT_lox_src(data)                                              ((0x00003FFF&(data))>>0)
+#define MVDBLK_RM89DIRECT_get_lox(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define MVDBLK_RM89DIRECT1                                                           0x1800e7cc
+#define MVDBLK_RM89DIRECT1_reg_addr                                                  "0xB800E7CC"
+#define MVDBLK_RM89DIRECT1_reg                                                       0xB800E7CC
+#define set_MVDBLK_RM89DIRECT1_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89DIRECT1_reg)=data)
+#define get_MVDBLK_RM89DIRECT1_reg   (*((volatile unsigned int*) MVDBLK_RM89DIRECT1_reg))
+#define MVDBLK_RM89DIRECT1_inst_adr                                                  "0x00F3"
+#define MVDBLK_RM89DIRECT1_inst                                                      0x00F3
+#define MVDBLK_RM89DIRECT1_hiy_shift                                                 (16)
+#define MVDBLK_RM89DIRECT1_hiy_mask                                                  (0x3FFF0000)
+#define MVDBLK_RM89DIRECT1_hiy(data)                                                 (0x3FFF0000&((data)<<16))
+#define MVDBLK_RM89DIRECT1_hiy_src(data)                                             ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT1_get_hiy(data)                                             ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT1_loy_shift                                                 (0)
+#define MVDBLK_RM89DIRECT1_loy_mask                                                  (0x00003FFF)
+#define MVDBLK_RM89DIRECT1_loy(data)                                                 (0x00003FFF&((data)<<0))
+#define MVDBLK_RM89DIRECT1_loy_src(data)                                             ((0x00003FFF&(data))>>0)
+#define MVDBLK_RM89DIRECT1_get_loy(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define MVDBLK_RM89DIRECT2                                                           0x1800e7f0
+#define MVDBLK_RM89DIRECT2_reg_addr                                                  "0xB800E7F0"
+#define MVDBLK_RM89DIRECT2_reg                                                       0xB800E7F0
+#define set_MVDBLK_RM89DIRECT2_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89DIRECT2_reg)=data)
+#define get_MVDBLK_RM89DIRECT2_reg   (*((volatile unsigned int*) MVDBLK_RM89DIRECT2_reg))
+#define MVDBLK_RM89DIRECT2_inst_adr                                                  "0x00FC"
+#define MVDBLK_RM89DIRECT2_inst                                                      0x00FC
+#define MVDBLK_RM89DIRECT2_hicx_shift                                                (16)
+#define MVDBLK_RM89DIRECT2_hicx_mask                                                 (0x3FFF0000)
+#define MVDBLK_RM89DIRECT2_hicx(data)                                                (0x3FFF0000&((data)<<16))
+#define MVDBLK_RM89DIRECT2_hicx_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT2_get_hicx(data)                                            ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT2_locx_shift                                                (0)
+#define MVDBLK_RM89DIRECT2_locx_mask                                                 (0x00003FFF)
+#define MVDBLK_RM89DIRECT2_locx(data)                                                (0x00003FFF&((data)<<0))
+#define MVDBLK_RM89DIRECT2_locx_src(data)                                            ((0x00003FFF&(data))>>0)
+#define MVDBLK_RM89DIRECT2_get_locx(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define MVDBLK_RM89DIRECT3                                                           0x1800e7f4
+#define MVDBLK_RM89DIRECT3_reg_addr                                                  "0xB800E7F4"
+#define MVDBLK_RM89DIRECT3_reg                                                       0xB800E7F4
+#define set_MVDBLK_RM89DIRECT3_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89DIRECT3_reg)=data)
+#define get_MVDBLK_RM89DIRECT3_reg   (*((volatile unsigned int*) MVDBLK_RM89DIRECT3_reg))
+#define MVDBLK_RM89DIRECT3_inst_adr                                                  "0x00FD"
+#define MVDBLK_RM89DIRECT3_inst                                                      0x00FD
+#define MVDBLK_RM89DIRECT3_hicy_shift                                                (16)
+#define MVDBLK_RM89DIRECT3_hicy_mask                                                 (0x3FFF0000)
+#define MVDBLK_RM89DIRECT3_hicy(data)                                                (0x3FFF0000&((data)<<16))
+#define MVDBLK_RM89DIRECT3_hicy_src(data)                                            ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT3_get_hicy(data)                                            ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT3_locy_shift                                                (0)
+#define MVDBLK_RM89DIRECT3_locy_mask                                                 (0x00003FFF)
+#define MVDBLK_RM89DIRECT3_locy(data)                                                (0x00003FFF&((data)<<0))
+#define MVDBLK_RM89DIRECT3_locy_src(data)                                            ((0x00003FFF&(data))>>0)
+#define MVDBLK_RM89DIRECT3_get_locy(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define MVDBLK_RM89PIC2                                                              0x1800e7f8
+#define MVDBLK_RM89PIC2_reg_addr                                                     "0xB800E7F8"
+#define MVDBLK_RM89PIC2_reg                                                          0xB800E7F8
+#define set_MVDBLK_RM89PIC2_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89PIC2_reg)=data)
+#define get_MVDBLK_RM89PIC2_reg   (*((volatile unsigned int*) MVDBLK_RM89PIC2_reg))
+#define MVDBLK_RM89PIC2_inst_adr                                                     "0x00FE"
+#define MVDBLK_RM89PIC2_inst                                                         0x00FE
+#define MVDBLK_RM89PIC2_ZeroMvd_shift                                                (0)
+#define MVDBLK_RM89PIC2_ZeroMvd_mask                                                 (0x00000001)
+#define MVDBLK_RM89PIC2_ZeroMvd(data)                                                (0x00000001&((data)<<0))
+#define MVDBLK_RM89PIC2_ZeroMvd_src(data)                                            ((0x00000001&(data))>>0)
+#define MVDBLK_RM89PIC2_get_ZeroMvd(data)                                            ((0x00000001&(data))>>0)
+
+
+#define MVDBLK_RM89DIRECT4                                                           0x1800e7fc
+#define MVDBLK_RM89DIRECT4_reg_addr                                                  "0xB800E7FC"
+#define MVDBLK_RM89DIRECT4_reg                                                       0xB800E7FC
+#define set_MVDBLK_RM89DIRECT4_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89DIRECT4_reg)=data)
+#define get_MVDBLK_RM89DIRECT4_reg   (*((volatile unsigned int*) MVDBLK_RM89DIRECT4_reg))
+#define MVDBLK_RM89DIRECT4_inst_adr                                                  "0x00FF"
+#define MVDBLK_RM89DIRECT4_inst                                                      0x00FF
+#define MVDBLK_RM89DIRECT4_hix_4v_shift                                              (16)
+#define MVDBLK_RM89DIRECT4_hix_4v_mask                                               (0x3FFF0000)
+#define MVDBLK_RM89DIRECT4_hix_4v(data)                                              (0x3FFF0000&((data)<<16))
+#define MVDBLK_RM89DIRECT4_hix_4v_src(data)                                          ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT4_get_hix_4v(data)                                          ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT4_lox_4v_shift                                              (0)
+#define MVDBLK_RM89DIRECT4_lox_4v_mask                                               (0x00003FFF)
+#define MVDBLK_RM89DIRECT4_lox_4v(data)                                              (0x00003FFF&((data)<<0))
+#define MVDBLK_RM89DIRECT4_lox_4v_src(data)                                          ((0x00003FFF&(data))>>0)
+#define MVDBLK_RM89DIRECT4_get_lox_4v(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#define MVDBLK_RM89DIRECT5                                                           0x1800e6cc
+#define MVDBLK_RM89DIRECT5_reg_addr                                                  "0xB800E6CC"
+#define MVDBLK_RM89DIRECT5_reg                                                       0xB800E6CC
+#define set_MVDBLK_RM89DIRECT5_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89DIRECT5_reg)=data)
+#define get_MVDBLK_RM89DIRECT5_reg   (*((volatile unsigned int*) MVDBLK_RM89DIRECT5_reg))
+#define MVDBLK_RM89DIRECT5_inst_adr                                                  "0x00B3"
+#define MVDBLK_RM89DIRECT5_inst                                                      0x00B3
+#define MVDBLK_RM89DIRECT5_hiy_4v_shift                                              (16)
+#define MVDBLK_RM89DIRECT5_hiy_4v_mask                                               (0x3FFF0000)
+#define MVDBLK_RM89DIRECT5_hiy_4v(data)                                              (0x3FFF0000&((data)<<16))
+#define MVDBLK_RM89DIRECT5_hiy_4v_src(data)                                          ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT5_get_hiy_4v(data)                                          ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT5_loy_4v_shift                                              (0)
+#define MVDBLK_RM89DIRECT5_loy_4v_mask                                               (0x00003FFF)
+#define MVDBLK_RM89DIRECT5_loy_4v(data)                                              (0x00003FFF&((data)<<0))
+#define MVDBLK_RM89DIRECT5_loy_4v_src(data)                                          ((0x00003FFF&(data))>>0)
+#define MVDBLK_RM89DIRECT5_get_loy_4v(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#define MVDBLK_RM89DIRECT6                                                           0x1800e658
+#define MVDBLK_RM89DIRECT6_reg_addr                                                  "0xB800E658"
+#define MVDBLK_RM89DIRECT6_reg                                                       0xB800E658
+#define set_MVDBLK_RM89DIRECT6_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89DIRECT6_reg)=data)
+#define get_MVDBLK_RM89DIRECT6_reg   (*((volatile unsigned int*) MVDBLK_RM89DIRECT6_reg))
+#define MVDBLK_RM89DIRECT6_inst_adr                                                  "0x0096"
+#define MVDBLK_RM89DIRECT6_inst                                                      0x0096
+#define MVDBLK_RM89DIRECT6_hicx_4v_shift                                             (16)
+#define MVDBLK_RM89DIRECT6_hicx_4v_mask                                              (0x3FFF0000)
+#define MVDBLK_RM89DIRECT6_hicx_4v(data)                                             (0x3FFF0000&((data)<<16))
+#define MVDBLK_RM89DIRECT6_hicx_4v_src(data)                                         ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT6_get_hicx_4v(data)                                         ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT6_locx_4v_shift                                             (0)
+#define MVDBLK_RM89DIRECT6_locx_4v_mask                                              (0x00003FFF)
+#define MVDBLK_RM89DIRECT6_locx_4v(data)                                             (0x00003FFF&((data)<<0))
+#define MVDBLK_RM89DIRECT6_locx_4v_src(data)                                         ((0x00003FFF&(data))>>0)
+#define MVDBLK_RM89DIRECT6_get_locx_4v(data)                                         ((0x00003FFF&(data))>>0)
+
+
+#define MVDBLK_RM89DIRECT7                                                           0x1800e65c
+#define MVDBLK_RM89DIRECT7_reg_addr                                                  "0xB800E65C"
+#define MVDBLK_RM89DIRECT7_reg                                                       0xB800E65C
+#define set_MVDBLK_RM89DIRECT7_reg(data)   (*((volatile unsigned int*) MVDBLK_RM89DIRECT7_reg)=data)
+#define get_MVDBLK_RM89DIRECT7_reg   (*((volatile unsigned int*) MVDBLK_RM89DIRECT7_reg))
+#define MVDBLK_RM89DIRECT7_inst_adr                                                  "0x0097"
+#define MVDBLK_RM89DIRECT7_inst                                                      0x0097
+#define MVDBLK_RM89DIRECT7_hicy_4v_shift                                             (16)
+#define MVDBLK_RM89DIRECT7_hicy_4v_mask                                              (0x3FFF0000)
+#define MVDBLK_RM89DIRECT7_hicy_4v(data)                                             (0x3FFF0000&((data)<<16))
+#define MVDBLK_RM89DIRECT7_hicy_4v_src(data)                                         ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT7_get_hicy_4v(data)                                         ((0x3FFF0000&(data))>>16)
+#define MVDBLK_RM89DIRECT7_locy_4v_shift                                             (0)
+#define MVDBLK_RM89DIRECT7_locy_4v_mask                                              (0x00003FFF)
+#define MVDBLK_RM89DIRECT7_locy_4v(data)                                             (0x00003FFF&((data)<<0))
+#define MVDBLK_RM89DIRECT7_locy_4v_src(data)                                         ((0x00003FFF&(data))>>0)
+#define MVDBLK_RM89DIRECT7_get_locy_4v(data)                                         ((0x00003FFF&(data))>>0)
+
+
+#define MVDBLK_SEPOOL_0                                                              0x1800E700
+#define MVDBLK_SEPOOL_1                                                              0x1800E704
+#define MVDBLK_SEPOOL_2                                                              0x1800E708
+#define MVDBLK_SEPOOL_3                                                              0x1800E70C
+#define MVDBLK_SEPOOL_4                                                              0x1800E710
+#define MVDBLK_SEPOOL_5                                                              0x1800E714
+#define MVDBLK_SEPOOL_6                                                              0x1800E718
+#define MVDBLK_SEPOOL_7                                                              0x1800E71C
+#define MVDBLK_SEPOOL_8                                                              0x1800E720
+#define MVDBLK_SEPOOL_9                                                              0x1800E724
+#define MVDBLK_SEPOOL_10                                                              0x1800E728
+#define MVDBLK_SEPOOL_11                                                              0x1800E72C
+#define MVDBLK_SEPOOL_12                                                              0x1800E730
+#define MVDBLK_SEPOOL_13                                                              0x1800E734
+#define MVDBLK_SEPOOL_14                                                              0x1800E738
+#define MVDBLK_SEPOOL_15                                                              0x1800E73C
+#define MVDBLK_SEPOOL_0_reg_addr                                                     "0xB800E700"
+#define MVDBLK_SEPOOL_1_reg_addr                                                     "0xB800E704"
+#define MVDBLK_SEPOOL_2_reg_addr                                                     "0xB800E708"
+#define MVDBLK_SEPOOL_3_reg_addr                                                     "0xB800E70C"
+#define MVDBLK_SEPOOL_4_reg_addr                                                     "0xB800E710"
+#define MVDBLK_SEPOOL_5_reg_addr                                                     "0xB800E714"
+#define MVDBLK_SEPOOL_6_reg_addr                                                     "0xB800E718"
+#define MVDBLK_SEPOOL_7_reg_addr                                                     "0xB800E71C"
+#define MVDBLK_SEPOOL_8_reg_addr                                                     "0xB800E720"
+#define MVDBLK_SEPOOL_9_reg_addr                                                     "0xB800E724"
+#define MVDBLK_SEPOOL_10_reg_addr                                                     "0xB800E728"
+#define MVDBLK_SEPOOL_11_reg_addr                                                     "0xB800E72C"
+#define MVDBLK_SEPOOL_12_reg_addr                                                     "0xB800E730"
+#define MVDBLK_SEPOOL_13_reg_addr                                                     "0xB800E734"
+#define MVDBLK_SEPOOL_14_reg_addr                                                     "0xB800E738"
+#define MVDBLK_SEPOOL_15_reg_addr                                                     "0xB800E73C"
+#define MVDBLK_SEPOOL_0_reg                                                          0xB800E700
+#define MVDBLK_SEPOOL_1_reg                                                          0xB800E704
+#define MVDBLK_SEPOOL_2_reg                                                          0xB800E708
+#define MVDBLK_SEPOOL_3_reg                                                          0xB800E70C
+#define MVDBLK_SEPOOL_4_reg                                                          0xB800E710
+#define MVDBLK_SEPOOL_5_reg                                                          0xB800E714
+#define MVDBLK_SEPOOL_6_reg                                                          0xB800E718
+#define MVDBLK_SEPOOL_7_reg                                                          0xB800E71C
+#define MVDBLK_SEPOOL_8_reg                                                          0xB800E720
+#define MVDBLK_SEPOOL_9_reg                                                          0xB800E724
+#define MVDBLK_SEPOOL_10_reg                                                          0xB800E728
+#define MVDBLK_SEPOOL_11_reg                                                          0xB800E72C
+#define MVDBLK_SEPOOL_12_reg                                                          0xB800E730
+#define MVDBLK_SEPOOL_13_reg                                                          0xB800E734
+#define MVDBLK_SEPOOL_14_reg                                                          0xB800E738
+#define MVDBLK_SEPOOL_15_reg                                                          0xB800E73C
+#define set_MVDBLK_SEPOOL_0_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_0_reg)=data)
+#define set_MVDBLK_SEPOOL_1_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_1_reg)=data)
+#define set_MVDBLK_SEPOOL_2_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_2_reg)=data)
+#define set_MVDBLK_SEPOOL_3_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_3_reg)=data)
+#define set_MVDBLK_SEPOOL_4_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_4_reg)=data)
+#define set_MVDBLK_SEPOOL_5_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_5_reg)=data)
+#define set_MVDBLK_SEPOOL_6_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_6_reg)=data)
+#define set_MVDBLK_SEPOOL_7_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_7_reg)=data)
+#define set_MVDBLK_SEPOOL_8_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_8_reg)=data)
+#define set_MVDBLK_SEPOOL_9_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_9_reg)=data)
+#define set_MVDBLK_SEPOOL_10_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_10_reg)=data)
+#define set_MVDBLK_SEPOOL_11_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_11_reg)=data)
+#define set_MVDBLK_SEPOOL_12_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_12_reg)=data)
+#define set_MVDBLK_SEPOOL_13_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_13_reg)=data)
+#define set_MVDBLK_SEPOOL_14_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_14_reg)=data)
+#define set_MVDBLK_SEPOOL_15_reg(data)   (*((volatile unsigned int*) MVDBLK_SEPOOL_15_reg)=data)
+#define get_MVDBLK_SEPOOL_0_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_0_reg))
+#define get_MVDBLK_SEPOOL_1_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_1_reg))
+#define get_MVDBLK_SEPOOL_2_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_2_reg))
+#define get_MVDBLK_SEPOOL_3_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_3_reg))
+#define get_MVDBLK_SEPOOL_4_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_4_reg))
+#define get_MVDBLK_SEPOOL_5_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_5_reg))
+#define get_MVDBLK_SEPOOL_6_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_6_reg))
+#define get_MVDBLK_SEPOOL_7_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_7_reg))
+#define get_MVDBLK_SEPOOL_8_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_8_reg))
+#define get_MVDBLK_SEPOOL_9_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_9_reg))
+#define get_MVDBLK_SEPOOL_10_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_10_reg))
+#define get_MVDBLK_SEPOOL_11_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_11_reg))
+#define get_MVDBLK_SEPOOL_12_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_12_reg))
+#define get_MVDBLK_SEPOOL_13_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_13_reg))
+#define get_MVDBLK_SEPOOL_14_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_14_reg))
+#define get_MVDBLK_SEPOOL_15_reg   (*((volatile unsigned int*) MVDBLK_SEPOOL_15_reg))
+#define MVDBLK_SEPOOL_0_inst_adr                                                     "0x00C0"
+#define MVDBLK_SEPOOL_1_inst_adr                                                     "0x00C1"
+#define MVDBLK_SEPOOL_2_inst_adr                                                     "0x00C2"
+#define MVDBLK_SEPOOL_3_inst_adr                                                     "0x00C3"
+#define MVDBLK_SEPOOL_4_inst_adr                                                     "0x00C4"
+#define MVDBLK_SEPOOL_5_inst_adr                                                     "0x00C5"
+#define MVDBLK_SEPOOL_6_inst_adr                                                     "0x00C6"
+#define MVDBLK_SEPOOL_7_inst_adr                                                     "0x00C7"
+#define MVDBLK_SEPOOL_8_inst_adr                                                     "0x00C8"
+#define MVDBLK_SEPOOL_9_inst_adr                                                     "0x00C9"
+#define MVDBLK_SEPOOL_10_inst_adr                                                     "0x00CA"
+#define MVDBLK_SEPOOL_11_inst_adr                                                     "0x00CB"
+#define MVDBLK_SEPOOL_12_inst_adr                                                     "0x00CC"
+#define MVDBLK_SEPOOL_13_inst_adr                                                     "0x00CD"
+#define MVDBLK_SEPOOL_14_inst_adr                                                     "0x00CE"
+#define MVDBLK_SEPOOL_15_inst_adr                                                     "0x00CF"
+#define MVDBLK_SEPOOL_0_inst                                                         0x00C0
+#define MVDBLK_SEPOOL_1_inst                                                         0x00C1
+#define MVDBLK_SEPOOL_2_inst                                                         0x00C2
+#define MVDBLK_SEPOOL_3_inst                                                         0x00C3
+#define MVDBLK_SEPOOL_4_inst                                                         0x00C4
+#define MVDBLK_SEPOOL_5_inst                                                         0x00C5
+#define MVDBLK_SEPOOL_6_inst                                                         0x00C6
+#define MVDBLK_SEPOOL_7_inst                                                         0x00C7
+#define MVDBLK_SEPOOL_8_inst                                                         0x00C8
+#define MVDBLK_SEPOOL_9_inst                                                         0x00C9
+#define MVDBLK_SEPOOL_10_inst                                                         0x00CA
+#define MVDBLK_SEPOOL_11_inst                                                         0x00CB
+#define MVDBLK_SEPOOL_12_inst                                                         0x00CC
+#define MVDBLK_SEPOOL_13_inst                                                         0x00CD
+#define MVDBLK_SEPOOL_14_inst                                                         0x00CE
+#define MVDBLK_SEPOOL_15_inst                                                         0x00CF
+#define MVDBLK_SEPOOL_entry_shift                                                    (0)
+#define MVDBLK_SEPOOL_entry_mask                                                     (0x0FFFFFFF)
+#define MVDBLK_SEPOOL_entry(data)                                                    (0x0FFFFFFF&((data)<<0))
+#define MVDBLK_SEPOOL_entry_src(data)                                                ((0x0FFFFFFF&(data))>>0)
+#define MVDBLK_SEPOOL_get_entry(data)                                                ((0x0FFFFFFF&(data))>>0)
+
+
+#define MVDBLK_H264BASE                                                              0x1800e6c0
+#define MVDBLK_H264BASE_reg_addr                                                     "0xB800E6C0"
+#define MVDBLK_H264BASE_reg                                                          0xB800E6C0
+#define set_MVDBLK_H264BASE_reg(data)   (*((volatile unsigned int*) MVDBLK_H264BASE_reg)=data)
+#define get_MVDBLK_H264BASE_reg   (*((volatile unsigned int*) MVDBLK_H264BASE_reg))
+#define MVDBLK_H264BASE_inst_adr                                                     "0x00B0"
+#define MVDBLK_H264BASE_inst                                                         0x00B0
+#define MVDBLK_H264BASE_SetNhAvail_shift                                             (0)
+#define MVDBLK_H264BASE_SetNhAvail_mask                                              (0x00000001)
+#define MVDBLK_H264BASE_SetNhAvail(data)                                             (0x00000001&((data)<<0))
+#define MVDBLK_H264BASE_SetNhAvail_src(data)                                         ((0x00000001&(data))>>0)
+#define MVDBLK_H264BASE_get_SetNhAvail(data)                                         ((0x00000001&(data))>>0)
+
+
+#define MVDBLK_H264BASE1                                                             0x1800e6c4
+#define MVDBLK_H264BASE1_reg_addr                                                    "0xB800E6C4"
+#define MVDBLK_H264BASE1_reg                                                         0xB800E6C4
+#define set_MVDBLK_H264BASE1_reg(data)   (*((volatile unsigned int*) MVDBLK_H264BASE1_reg)=data)
+#define get_MVDBLK_H264BASE1_reg   (*((volatile unsigned int*) MVDBLK_H264BASE1_reg))
+#define MVDBLK_H264BASE1_inst_adr                                                    "0x00B1"
+#define MVDBLK_H264BASE1_inst                                                        0x00B1
+#define MVDBLK_H264BASE1_LeftAvail_shift                                             (3)
+#define MVDBLK_H264BASE1_LeftAvail_mask                                              (0x00000008)
+#define MVDBLK_H264BASE1_LeftAvail(data)                                             (0x00000008&((data)<<3))
+#define MVDBLK_H264BASE1_LeftAvail_src(data)                                         ((0x00000008&(data))>>3)
+#define MVDBLK_H264BASE1_get_LeftAvail(data)                                         ((0x00000008&(data))>>3)
+#define MVDBLK_H264BASE1_TopAvail_shift                                              (2)
+#define MVDBLK_H264BASE1_TopAvail_mask                                               (0x00000004)
+#define MVDBLK_H264BASE1_TopAvail(data)                                              (0x00000004&((data)<<2))
+#define MVDBLK_H264BASE1_TopAvail_src(data)                                          ((0x00000004&(data))>>2)
+#define MVDBLK_H264BASE1_get_TopAvail(data)                                          ((0x00000004&(data))>>2)
+#define MVDBLK_H264BASE1_TopRightAvail_shift                                         (1)
+#define MVDBLK_H264BASE1_TopRightAvail_mask                                          (0x00000002)
+#define MVDBLK_H264BASE1_TopRightAvail(data)                                         (0x00000002&((data)<<1))
+#define MVDBLK_H264BASE1_TopRightAvail_src(data)                                     ((0x00000002&(data))>>1)
+#define MVDBLK_H264BASE1_get_TopRightAvail(data)                                     ((0x00000002&(data))>>1)
+#define MVDBLK_H264BASE1_TopLeftAvail_shift                                          (0)
+#define MVDBLK_H264BASE1_TopLeftAvail_mask                                           (0x00000001)
+#define MVDBLK_H264BASE1_TopLeftAvail(data)                                          (0x00000001&((data)<<0))
+#define MVDBLK_H264BASE1_TopLeftAvail_src(data)                                      ((0x00000001&(data))>>0)
+#define MVDBLK_H264BASE1_get_TopLeftAvail(data)                                      ((0x00000001&(data))>>0)
+
+
+#define MVDBLK_DBG                                                                   0x1800e6c8
+#define MVDBLK_DBG_reg_addr                                                          "0xB800E6C8"
+#define MVDBLK_DBG_reg                                                               0xB800E6C8
+#define set_MVDBLK_DBG_reg(data)   (*((volatile unsigned int*) MVDBLK_DBG_reg)=data)
+#define get_MVDBLK_DBG_reg   (*((volatile unsigned int*) MVDBLK_DBG_reg))
+#define MVDBLK_DBG_inst_adr                                                          "0x00B2"
+#define MVDBLK_DBG_inst                                                              0x00B2
+#define MVDBLK_DBG_GenPulse_shift                                                    (31)
+#define MVDBLK_DBG_GenPulse_mask                                                     (0x80000000)
+#define MVDBLK_DBG_GenPulse(data)                                                    (0x80000000&((data)<<31))
+#define MVDBLK_DBG_GenPulse_src(data)                                                ((0x80000000&(data))>>31)
+#define MVDBLK_DBG_get_GenPulse(data)                                                ((0x80000000&(data))>>31)
+#define MVDBLK_DBG_PicCount_shift                                                    (16)
+#define MVDBLK_DBG_PicCount_mask                                                     (0x7FFF0000)
+#define MVDBLK_DBG_PicCount(data)                                                    (0x7FFF0000&((data)<<16))
+#define MVDBLK_DBG_PicCount_src(data)                                                ((0x7FFF0000&(data))>>16)
+#define MVDBLK_DBG_get_PicCount(data)                                                ((0x7FFF0000&(data))>>16)
+#define MVDBLK_DBG_DbgCtrl_shift                                                     (13)
+#define MVDBLK_DBG_DbgCtrl_mask                                                      (0x0000E000)
+#define MVDBLK_DBG_DbgCtrl(data)                                                     (0x0000E000&((data)<<13))
+#define MVDBLK_DBG_DbgCtrl_src(data)                                                 ((0x0000E000&(data))>>13)
+#define MVDBLK_DBG_get_DbgCtrl(data)                                                 ((0x0000E000&(data))>>13)
+#define MVDBLK_DBG_MbAddr_shift                                                      (0)
+#define MVDBLK_DBG_MbAddr_mask                                                       (0x00001FFF)
+#define MVDBLK_DBG_MbAddr(data)                                                      (0x00001FFF&((data)<<0))
+#define MVDBLK_DBG_MbAddr_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define MVDBLK_DBG_get_MbAddr(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/nf_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/nf_reg.h
new file mode 100644
index 00000000..ee172dd
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/nf_reg.h
@@ -0,0 +1,1882 @@
+/**************************************************************
+// Spec Version                  : 0.0.4
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/8/26 11:25:32
+***************************************************************/
+
+
+#ifndef _NF_REG_H_INCLUDED_
+#define _NF_REG_H_INCLUDED_
+#ifdef  _NF_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     page_addr0:8;
+}NF_ND_PA0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     page_addr1:8;
+}NF_ND_PA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     addr_mode:3;
+unsigned int     page_addr2:5;
+}NF_ND_PA2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     col_addr0:8;
+}NF_ND_CA0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cmd:8;
+}NF_ND_CMD;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dat:8;
+}NF_ND_DAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     xfer:1;
+unsigned int     ready_busy:1;
+unsigned int     ecc_tran:1;
+unsigned int     reserved_1:1;
+unsigned int     ecc_enable:1;
+unsigned int     tran_mode:3;
+}NF_ND_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     blank_zero_num:5;
+}NF_BLANK_ZERO_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cmd3:8;
+}NF_CMD3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     page_addr3:3;
+unsigned int     reserved_1:5;
+}NF_ND_PA3;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     bit_sel:3;
+unsigned int     trig_poll:1;
+}NF_POLL_FSTS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     blank_zero_over:1;
+unsigned int     read_ecc_xnor_ena:1;
+unsigned int     blank_all_one:1;
+unsigned int     blank_ena:1;
+}NF_BLANK_CHK;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     ecc_not_clr:1;
+unsigned int     ecc_err:1;
+unsigned int     reserved_1:2;
+}NF_ND_ECC;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     col_addr1:8;
+}NF_ND_CA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     length0:8;
+}NF_DATA_TL0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     access_mode:1;
+unsigned int     reserved_1:1;
+unsigned int     length1:6;
+}NF_DATA_TL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     eot_gen:1;
+unsigned int     dma_max_pkt:1;
+unsigned int     spec_pkt:1;
+unsigned int     reserved_1:1;
+}NF_DMA1_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     pp_start_addr:3;
+unsigned int     reserved_1:1;
+unsigned int     pp_busy:1;
+unsigned int     pp_reset:1;
+unsigned int     pp_enable:1;
+}NF_PP_CTL0;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     ecc_bch_72b_mode:3;
+unsigned int     ecc_bch_12b_ena:1;
+}NF_ECC_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     pp_start_addr:8;
+}NF_PP_CTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     pd:5;
+}NF_PD;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     pp_lp_mode:1;
+unsigned int     pp_lp_ena:1;
+unsigned int     ecc_clk_gate_ena:1;
+unsigned int     ip_clk_gate_ena:1;
+unsigned int     dma_clk_gate_ena:1;
+unsigned int     pp_sram_rdy_num:3;
+}NF_NF_LOW_PWR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Dmy1:8;
+}NF_DUMMY_NF1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Dmy2:8;
+}NF_DUMMY_NF2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Dmy3:8;
+}NF_DUMMY_NF3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Dmy4:8;
+}NF_DUMMY_NF4;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     auto_trig:1;
+unsigned int     addr_fbd:1;
+unsigned int     pp_empty:1;
+unsigned int     spec_auto_case:2;
+unsigned int     auto_case:3;
+}NF_AUTO_TRIG;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ecc_num:8;
+}NF_RSECC_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rnd_cmd1:8;
+}NF_RND_CMD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rnd_cmd2:8;
+}NF_RND_CMD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     data_col_msb:8;
+}NF_RND_DATASTR_COL_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     spr_col_msb:8;
+}NF_RND_SPR_STR_COL_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     spr_col_lsb:8;
+}NF_RND_SPR_STR_COL_L;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     rnd_rw_enable:1;
+}NF_RND_RW_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     read_by_pp:1;
+unsigned int     reserved_1:7;
+}NF_READ_BY_PP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     max_ecc_num:8;
+}NF_MAX_ECC_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     T3:8;
+}NF_TIME_PARA3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     T2:8;
+}NF_TIME_PARA2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     T1:8;
+}NF_TIME_PARA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     rand_ready:1;
+unsigned int     rand_en:1;
+}NF_RMZ_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rand_seed_low:8;
+}NF_RMZ_SEED_L;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     rand_seed_hi:7;
+}NF_RMZ_SEED_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     rand_seed_from_reg:1;
+unsigned int     reserved_1:1;
+unsigned int     rand_seed_num:3;
+}NF_RMZ_SEED_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     pin_stop:1;
+unsigned int     intlev_pin_ena:1;
+unsigned int     pin_mux_ena:1;
+}NF_PIN_MUX_STOP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     T_swait_busy:2;
+unsigned int     T_WHR_ADL:6;
+}NF_DELAY_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ecc_n_stop:1;
+unsigned int     reserved_1:7;
+}NF_ECC_STOP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ecc_page:8;
+}NF_ECC_PAGE;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     page_cnt:8;
+}NF_PAGE_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     page_len:8;
+}NF_PAGE_LEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cmd2:8;
+}NF_CMD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ecc_pass:1;
+unsigned int     ecc_no_check:1;
+unsigned int     edo:1;
+unsigned int     no_wait_busy:1;
+unsigned int     wait_ready:2;
+unsigned int     reserved_1:2;
+}NF_MULTI_CHNL_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     map_sel:1;
+unsigned int     access_en:1;
+unsigned int     mem_region:4;
+}NF_SRAM_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dram_sa:28;
+}NF_DMA_CTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     dma_len:16;
+}NF_DMA_CTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cp_first:1;
+unsigned int     cp_enable:1;
+unsigned int     ddr_wr:1;
+unsigned int     dma_xfer:1;
+}NF_DMA_CTL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mcu_pp_sram_lp_ena:1;
+unsigned int     sys_clk_gate_ena:1;
+unsigned int     cp_clk_gate_ena:1;
+unsigned int     dma_sram_lp_ena:1;
+unsigned int     dma_sram_rdy_num:4;
+}NF_SYS_LOW_PWR;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     Int8:1;
+unsigned int     Int7:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     Int4:1;
+unsigned int     Int3:1;
+unsigned int     Int2:1;
+unsigned int     Int1:1;
+unsigned int     write_data:1;
+}NF_NAND_ISR;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     Int8En:1;
+unsigned int     Int7En:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     Int4En:1;
+unsigned int     Int3En:1;
+unsigned int     Int2En:1;
+unsigned int     Int1En:1;
+unsigned int     write_data:1;
+}NF_NAND_ISREN;
+
+typedef struct 
+{
+unsigned int     dmy:32;
+}NF_DUMMY_SYS;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_enable3:1;
+unsigned int     sel1:3;
+unsigned int     write_enable2:1;
+unsigned int     sel0:3;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}NF_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     cr_nf_hw_pinmux_ena:1;
+unsigned int     spare_ddr_ena:1;
+unsigned int     per_2k_spr_ena:1;
+unsigned int     spare_dram_sa:28;
+}NF_SPR_DDR_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     cp_length:16;
+unsigned int     reserved_1:9;
+}NF_CP_LEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     bist2_drf_test_resume:1;
+unsigned int     bist2_drf_en:1;
+unsigned int     bist2_en:1;
+unsigned int     reserved_1:1;
+unsigned int     bist1_drf_test_resume:1;
+unsigned int     bist1_drf_en:1;
+unsigned int     bist1_en:1;
+}NF_BIST_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     RME:1;
+unsigned int     RM_3:1;
+unsigned int     RM_2:1;
+unsigned int     RM_1:1;
+unsigned int     RM_0:1;
+}NF_BIST_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     bist1_fail1:1;
+unsigned int     bist1_fail0:1;
+unsigned int     bist1_done:1;
+}NF_BIST_ST1;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     bist2_fail0:1;
+unsigned int     bist2_done:1;
+}NF_BIST_ST2;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_bist1_start_pause:1;
+unsigned int     reserved_1:13;
+unsigned int     drf_bist1_fail1:1;
+unsigned int     drf_bist1_fail0:1;
+unsigned int     drf_bist1_done:1;
+}NF_DRF_ST1;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_bist2_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_bist2_fail0:1;
+unsigned int     drf_bist2_done:1;
+}NF_DRF_ST2;
+
+#endif
+
+#define NF_ND_PA0                                                                0x18010000
+#define NF_ND_PA0_reg_addr                                                       "0xB8010000"
+#define NF_ND_PA0_reg                                                            0xB8010000
+#define set_NF_ND_PA0_reg(data)   (*((volatile unsigned int*) NF_ND_PA0_reg)=data)
+#define get_NF_ND_PA0_reg   (*((volatile unsigned int*) NF_ND_PA0_reg))
+#define NF_ND_PA0_inst_adr                                                       "0x0000"
+#define NF_ND_PA0_inst                                                           0x0000
+#define NF_ND_PA0_page_addr0_shift                                               (0)
+#define NF_ND_PA0_page_addr0_mask                                                (0x000000FF)
+#define NF_ND_PA0_page_addr0(data)                                               (0x000000FF&((data)<<0))
+#define NF_ND_PA0_page_addr0_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_ND_PA0_get_page_addr0(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_ND_PA1                                                                0x18010004
+#define NF_ND_PA1_reg_addr                                                       "0xB8010004"
+#define NF_ND_PA1_reg                                                            0xB8010004
+#define set_NF_ND_PA1_reg(data)   (*((volatile unsigned int*) NF_ND_PA1_reg)=data)
+#define get_NF_ND_PA1_reg   (*((volatile unsigned int*) NF_ND_PA1_reg))
+#define NF_ND_PA1_inst_adr                                                       "0x0001"
+#define NF_ND_PA1_inst                                                           0x0001
+#define NF_ND_PA1_page_addr1_shift                                               (0)
+#define NF_ND_PA1_page_addr1_mask                                                (0x000000FF)
+#define NF_ND_PA1_page_addr1(data)                                               (0x000000FF&((data)<<0))
+#define NF_ND_PA1_page_addr1_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_ND_PA1_get_page_addr1(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_ND_PA2                                                                0x18010008
+#define NF_ND_PA2_reg_addr                                                       "0xB8010008"
+#define NF_ND_PA2_reg                                                            0xB8010008
+#define set_NF_ND_PA2_reg(data)   (*((volatile unsigned int*) NF_ND_PA2_reg)=data)
+#define get_NF_ND_PA2_reg   (*((volatile unsigned int*) NF_ND_PA2_reg))
+#define NF_ND_PA2_inst_adr                                                       "0x0002"
+#define NF_ND_PA2_inst                                                           0x0002
+#define NF_ND_PA2_addr_mode_shift                                                (5)
+#define NF_ND_PA2_addr_mode_mask                                                 (0x000000E0)
+#define NF_ND_PA2_addr_mode(data)                                                (0x000000E0&((data)<<5))
+#define NF_ND_PA2_addr_mode_src(data)                                            ((0x000000E0&(data))>>5)
+#define NF_ND_PA2_get_addr_mode(data)                                            ((0x000000E0&(data))>>5)
+#define NF_ND_PA2_page_addr2_shift                                               (0)
+#define NF_ND_PA2_page_addr2_mask                                                (0x0000001F)
+#define NF_ND_PA2_page_addr2(data)                                               (0x0000001F&((data)<<0))
+#define NF_ND_PA2_page_addr2_src(data)                                           ((0x0000001F&(data))>>0)
+#define NF_ND_PA2_get_page_addr2(data)                                           ((0x0000001F&(data))>>0)
+
+
+#define NF_ND_CA0                                                                0x1801000C
+#define NF_ND_CA0_reg_addr                                                       "0xB801000C"
+#define NF_ND_CA0_reg                                                            0xB801000C
+#define set_NF_ND_CA0_reg(data)   (*((volatile unsigned int*) NF_ND_CA0_reg)=data)
+#define get_NF_ND_CA0_reg   (*((volatile unsigned int*) NF_ND_CA0_reg))
+#define NF_ND_CA0_inst_adr                                                       "0x0003"
+#define NF_ND_CA0_inst                                                           0x0003
+#define NF_ND_CA0_col_addr0_shift                                                (0)
+#define NF_ND_CA0_col_addr0_mask                                                 (0x000000FF)
+#define NF_ND_CA0_col_addr0(data)                                                (0x000000FF&((data)<<0))
+#define NF_ND_CA0_col_addr0_src(data)                                            ((0x000000FF&(data))>>0)
+#define NF_ND_CA0_get_col_addr0(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define NF_ND_CMD                                                                0x18010010
+#define NF_ND_CMD_reg_addr                                                       "0xB8010010"
+#define NF_ND_CMD_reg                                                            0xB8010010
+#define set_NF_ND_CMD_reg(data)   (*((volatile unsigned int*) NF_ND_CMD_reg)=data)
+#define get_NF_ND_CMD_reg   (*((volatile unsigned int*) NF_ND_CMD_reg))
+#define NF_ND_CMD_inst_adr                                                       "0x0004"
+#define NF_ND_CMD_inst                                                           0x0004
+#define NF_ND_CMD_cmd_shift                                                      (0)
+#define NF_ND_CMD_cmd_mask                                                       (0x000000FF)
+#define NF_ND_CMD_cmd(data)                                                      (0x000000FF&((data)<<0))
+#define NF_ND_CMD_cmd_src(data)                                                  ((0x000000FF&(data))>>0)
+#define NF_ND_CMD_get_cmd(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define NF_ND_DAT                                                                0x18010014
+#define NF_ND_DAT_reg_addr                                                       "0xB8010014"
+#define NF_ND_DAT_reg                                                            0xB8010014
+#define set_NF_ND_DAT_reg(data)   (*((volatile unsigned int*) NF_ND_DAT_reg)=data)
+#define get_NF_ND_DAT_reg   (*((volatile unsigned int*) NF_ND_DAT_reg))
+#define NF_ND_DAT_inst_adr                                                       "0x0005"
+#define NF_ND_DAT_inst                                                           0x0005
+#define NF_ND_DAT_dat_shift                                                      (0)
+#define NF_ND_DAT_dat_mask                                                       (0x000000FF)
+#define NF_ND_DAT_dat(data)                                                      (0x000000FF&((data)<<0))
+#define NF_ND_DAT_dat_src(data)                                                  ((0x000000FF&(data))>>0)
+#define NF_ND_DAT_get_dat(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define NF_ND_CTL                                                                0x18010018
+#define NF_ND_CTL_reg_addr                                                       "0xB8010018"
+#define NF_ND_CTL_reg                                                            0xB8010018
+#define set_NF_ND_CTL_reg(data)   (*((volatile unsigned int*) NF_ND_CTL_reg)=data)
+#define get_NF_ND_CTL_reg   (*((volatile unsigned int*) NF_ND_CTL_reg))
+#define NF_ND_CTL_inst_adr                                                       "0x0006"
+#define NF_ND_CTL_inst                                                           0x0006
+#define NF_ND_CTL_xfer_shift                                                     (7)
+#define NF_ND_CTL_xfer_mask                                                      (0x00000080)
+#define NF_ND_CTL_xfer(data)                                                     (0x00000080&((data)<<7))
+#define NF_ND_CTL_xfer_src(data)                                                 ((0x00000080&(data))>>7)
+#define NF_ND_CTL_get_xfer(data)                                                 ((0x00000080&(data))>>7)
+#define NF_ND_CTL_ready_busy_shift                                               (6)
+#define NF_ND_CTL_ready_busy_mask                                                (0x00000040)
+#define NF_ND_CTL_ready_busy(data)                                               (0x00000040&((data)<<6))
+#define NF_ND_CTL_ready_busy_src(data)                                           ((0x00000040&(data))>>6)
+#define NF_ND_CTL_get_ready_busy(data)                                           ((0x00000040&(data))>>6)
+#define NF_ND_CTL_ecc_tran_shift                                                 (5)
+#define NF_ND_CTL_ecc_tran_mask                                                  (0x00000020)
+#define NF_ND_CTL_ecc_tran(data)                                                 (0x00000020&((data)<<5))
+#define NF_ND_CTL_ecc_tran_src(data)                                             ((0x00000020&(data))>>5)
+#define NF_ND_CTL_get_ecc_tran(data)                                             ((0x00000020&(data))>>5)
+#define NF_ND_CTL_ecc_enable_shift                                               (3)
+#define NF_ND_CTL_ecc_enable_mask                                                (0x00000008)
+#define NF_ND_CTL_ecc_enable(data)                                               (0x00000008&((data)<<3))
+#define NF_ND_CTL_ecc_enable_src(data)                                           ((0x00000008&(data))>>3)
+#define NF_ND_CTL_get_ecc_enable(data)                                           ((0x00000008&(data))>>3)
+#define NF_ND_CTL_tran_mode_shift                                                (0)
+#define NF_ND_CTL_tran_mode_mask                                                 (0x00000007)
+#define NF_ND_CTL_tran_mode(data)                                                (0x00000007&((data)<<0))
+#define NF_ND_CTL_tran_mode_src(data)                                            ((0x00000007&(data))>>0)
+#define NF_ND_CTL_get_tran_mode(data)                                            ((0x00000007&(data))>>0)
+
+
+#define NF_BLANK_ZERO_NUM                                                        0x1801001C
+#define NF_BLANK_ZERO_NUM_reg_addr                                               "0xB801001C"
+#define NF_BLANK_ZERO_NUM_reg                                                    0xB801001C
+#define set_NF_BLANK_ZERO_NUM_reg(data)   (*((volatile unsigned int*) NF_BLANK_ZERO_NUM_reg)=data)
+#define get_NF_BLANK_ZERO_NUM_reg   (*((volatile unsigned int*) NF_BLANK_ZERO_NUM_reg))
+#define NF_BLANK_ZERO_NUM_inst_adr                                               "0x0007"
+#define NF_BLANK_ZERO_NUM_inst                                                   0x0007
+#define NF_BLANK_ZERO_NUM_blank_zero_num_shift                                   (0)
+#define NF_BLANK_ZERO_NUM_blank_zero_num_mask                                    (0x0000001F)
+#define NF_BLANK_ZERO_NUM_blank_zero_num(data)                                   (0x0000001F&((data)<<0))
+#define NF_BLANK_ZERO_NUM_blank_zero_num_src(data)                               ((0x0000001F&(data))>>0)
+#define NF_BLANK_ZERO_NUM_get_blank_zero_num(data)                               ((0x0000001F&(data))>>0)
+
+
+#define NF_CMD3                                                                  0x18010028
+#define NF_CMD3_reg_addr                                                         "0xB8010028"
+#define NF_CMD3_reg                                                              0xB8010028
+#define set_NF_CMD3_reg(data)   (*((volatile unsigned int*) NF_CMD3_reg)=data)
+#define get_NF_CMD3_reg   (*((volatile unsigned int*) NF_CMD3_reg))
+#define NF_CMD3_inst_adr                                                         "0x000A"
+#define NF_CMD3_inst                                                             0x000A
+#define NF_CMD3_cmd3_shift                                                       (0)
+#define NF_CMD3_cmd3_mask                                                        (0x000000FF)
+#define NF_CMD3_cmd3(data)                                                       (0x000000FF&((data)<<0))
+#define NF_CMD3_cmd3_src(data)                                                   ((0x000000FF&(data))>>0)
+#define NF_CMD3_get_cmd3(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define NF_ND_PA3                                                                0x1801002C
+#define NF_ND_PA3_reg_addr                                                       "0xB801002C"
+#define NF_ND_PA3_reg                                                            0xB801002C
+#define set_NF_ND_PA3_reg(data)   (*((volatile unsigned int*) NF_ND_PA3_reg)=data)
+#define get_NF_ND_PA3_reg   (*((volatile unsigned int*) NF_ND_PA3_reg))
+#define NF_ND_PA3_inst_adr                                                       "0x000B"
+#define NF_ND_PA3_inst                                                           0x000B
+#define NF_ND_PA3_page_addr3_shift                                               (5)
+#define NF_ND_PA3_page_addr3_mask                                                (0x000000E0)
+#define NF_ND_PA3_page_addr3(data)                                               (0x000000E0&((data)<<5))
+#define NF_ND_PA3_page_addr3_src(data)                                           ((0x000000E0&(data))>>5)
+#define NF_ND_PA3_get_page_addr3(data)                                           ((0x000000E0&(data))>>5)
+
+
+#define NF_POLL_FSTS                                                             0x18010030
+#define NF_POLL_FSTS_reg_addr                                                    "0xB8010030"
+#define NF_POLL_FSTS_reg                                                         0xB8010030
+#define set_NF_POLL_FSTS_reg(data)   (*((volatile unsigned int*) NF_POLL_FSTS_reg)=data)
+#define get_NF_POLL_FSTS_reg   (*((volatile unsigned int*) NF_POLL_FSTS_reg))
+#define NF_POLL_FSTS_inst_adr                                                    "0x000C"
+#define NF_POLL_FSTS_inst                                                        0x000C
+#define NF_POLL_FSTS_bit_sel_shift                                               (1)
+#define NF_POLL_FSTS_bit_sel_mask                                                (0x0000000E)
+#define NF_POLL_FSTS_bit_sel(data)                                               (0x0000000E&((data)<<1))
+#define NF_POLL_FSTS_bit_sel_src(data)                                           ((0x0000000E&(data))>>1)
+#define NF_POLL_FSTS_get_bit_sel(data)                                           ((0x0000000E&(data))>>1)
+#define NF_POLL_FSTS_trig_poll_shift                                             (0)
+#define NF_POLL_FSTS_trig_poll_mask                                              (0x00000001)
+#define NF_POLL_FSTS_trig_poll(data)                                             (0x00000001&((data)<<0))
+#define NF_POLL_FSTS_trig_poll_src(data)                                         ((0x00000001&(data))>>0)
+#define NF_POLL_FSTS_get_trig_poll(data)                                         ((0x00000001&(data))>>0)
+
+
+#define NF_BLANK_CHK                                                             0x18010034
+#define NF_BLANK_CHK_reg_addr                                                    "0xB8010034"
+#define NF_BLANK_CHK_reg                                                         0xB8010034
+#define set_NF_BLANK_CHK_reg(data)   (*((volatile unsigned int*) NF_BLANK_CHK_reg)=data)
+#define get_NF_BLANK_CHK_reg   (*((volatile unsigned int*) NF_BLANK_CHK_reg))
+#define NF_BLANK_CHK_inst_adr                                                    "0x000D"
+#define NF_BLANK_CHK_inst                                                        0x000D
+#define NF_BLANK_CHK_blank_zero_over_shift                                       (3)
+#define NF_BLANK_CHK_blank_zero_over_mask                                        (0x00000008)
+#define NF_BLANK_CHK_blank_zero_over(data)                                       (0x00000008&((data)<<3))
+#define NF_BLANK_CHK_blank_zero_over_src(data)                                   ((0x00000008&(data))>>3)
+#define NF_BLANK_CHK_get_blank_zero_over(data)                                   ((0x00000008&(data))>>3)
+#define NF_BLANK_CHK_read_ecc_xnor_ena_shift                                     (2)
+#define NF_BLANK_CHK_read_ecc_xnor_ena_mask                                      (0x00000004)
+#define NF_BLANK_CHK_read_ecc_xnor_ena(data)                                     (0x00000004&((data)<<2))
+#define NF_BLANK_CHK_read_ecc_xnor_ena_src(data)                                 ((0x00000004&(data))>>2)
+#define NF_BLANK_CHK_get_read_ecc_xnor_ena(data)                                 ((0x00000004&(data))>>2)
+#define NF_BLANK_CHK_blank_all_one_shift                                         (1)
+#define NF_BLANK_CHK_blank_all_one_mask                                          (0x00000002)
+#define NF_BLANK_CHK_blank_all_one(data)                                         (0x00000002&((data)<<1))
+#define NF_BLANK_CHK_blank_all_one_src(data)                                     ((0x00000002&(data))>>1)
+#define NF_BLANK_CHK_get_blank_all_one(data)                                     ((0x00000002&(data))>>1)
+#define NF_BLANK_CHK_blank_ena_shift                                             (0)
+#define NF_BLANK_CHK_blank_ena_mask                                              (0x00000001)
+#define NF_BLANK_CHK_blank_ena(data)                                             (0x00000001&((data)<<0))
+#define NF_BLANK_CHK_blank_ena_src(data)                                         ((0x00000001&(data))>>0)
+#define NF_BLANK_CHK_get_blank_ena(data)                                         ((0x00000001&(data))>>0)
+
+
+#define NF_ND_ECC                                                                0x18010038
+#define NF_ND_ECC_reg_addr                                                       "0xB8010038"
+#define NF_ND_ECC_reg                                                            0xB8010038
+#define set_NF_ND_ECC_reg(data)   (*((volatile unsigned int*) NF_ND_ECC_reg)=data)
+#define get_NF_ND_ECC_reg   (*((volatile unsigned int*) NF_ND_ECC_reg))
+#define NF_ND_ECC_inst_adr                                                       "0x000E"
+#define NF_ND_ECC_inst                                                           0x000E
+#define NF_ND_ECC_ecc_not_clr_shift                                              (3)
+#define NF_ND_ECC_ecc_not_clr_mask                                               (0x00000008)
+#define NF_ND_ECC_ecc_not_clr(data)                                              (0x00000008&((data)<<3))
+#define NF_ND_ECC_ecc_not_clr_src(data)                                          ((0x00000008&(data))>>3)
+#define NF_ND_ECC_get_ecc_not_clr(data)                                          ((0x00000008&(data))>>3)
+#define NF_ND_ECC_ecc_err_shift                                                  (2)
+#define NF_ND_ECC_ecc_err_mask                                                   (0x00000004)
+#define NF_ND_ECC_ecc_err(data)                                                  (0x00000004&((data)<<2))
+#define NF_ND_ECC_ecc_err_src(data)                                              ((0x00000004&(data))>>2)
+#define NF_ND_ECC_get_ecc_err(data)                                              ((0x00000004&(data))>>2)
+
+
+#define NF_ND_CA1                                                                0x1801003C
+#define NF_ND_CA1_reg_addr                                                       "0xB801003C"
+#define NF_ND_CA1_reg                                                            0xB801003C
+#define set_NF_ND_CA1_reg(data)   (*((volatile unsigned int*) NF_ND_CA1_reg)=data)
+#define get_NF_ND_CA1_reg   (*((volatile unsigned int*) NF_ND_CA1_reg))
+#define NF_ND_CA1_inst_adr                                                       "0x000F"
+#define NF_ND_CA1_inst                                                           0x000F
+#define NF_ND_CA1_col_addr1_shift                                                (0)
+#define NF_ND_CA1_col_addr1_mask                                                 (0x000000FF)
+#define NF_ND_CA1_col_addr1(data)                                                (0x000000FF&((data)<<0))
+#define NF_ND_CA1_col_addr1_src(data)                                            ((0x000000FF&(data))>>0)
+#define NF_ND_CA1_get_col_addr1(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define NF_DATA_TL0                                                              0x18010100
+#define NF_DATA_TL0_reg_addr                                                     "0xB8010100"
+#define NF_DATA_TL0_reg                                                          0xB8010100
+#define set_NF_DATA_TL0_reg(data)   (*((volatile unsigned int*) NF_DATA_TL0_reg)=data)
+#define get_NF_DATA_TL0_reg   (*((volatile unsigned int*) NF_DATA_TL0_reg))
+#define NF_DATA_TL0_inst_adr                                                     "0x0040"
+#define NF_DATA_TL0_inst                                                         0x0040
+#define NF_DATA_TL0_length0_shift                                                (0)
+#define NF_DATA_TL0_length0_mask                                                 (0x000000FF)
+#define NF_DATA_TL0_length0(data)                                                (0x000000FF&((data)<<0))
+#define NF_DATA_TL0_length0_src(data)                                            ((0x000000FF&(data))>>0)
+#define NF_DATA_TL0_get_length0(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define NF_DATA_TL1                                                              0x18010104
+#define NF_DATA_TL1_reg_addr                                                     "0xB8010104"
+#define NF_DATA_TL1_reg                                                          0xB8010104
+#define set_NF_DATA_TL1_reg(data)   (*((volatile unsigned int*) NF_DATA_TL1_reg)=data)
+#define get_NF_DATA_TL1_reg   (*((volatile unsigned int*) NF_DATA_TL1_reg))
+#define NF_DATA_TL1_inst_adr                                                     "0x0041"
+#define NF_DATA_TL1_inst                                                         0x0041
+#define NF_DATA_TL1_access_mode_shift                                            (7)
+#define NF_DATA_TL1_access_mode_mask                                             (0x00000080)
+#define NF_DATA_TL1_access_mode(data)                                            (0x00000080&((data)<<7))
+#define NF_DATA_TL1_access_mode_src(data)                                        ((0x00000080&(data))>>7)
+#define NF_DATA_TL1_get_access_mode(data)                                        ((0x00000080&(data))>>7)
+#define NF_DATA_TL1_length1_shift                                                (0)
+#define NF_DATA_TL1_length1_mask                                                 (0x0000003F)
+#define NF_DATA_TL1_length1(data)                                                (0x0000003F&((data)<<0))
+#define NF_DATA_TL1_length1_src(data)                                            ((0x0000003F&(data))>>0)
+#define NF_DATA_TL1_get_length1(data)                                            ((0x0000003F&(data))>>0)
+
+
+#define NF_DMA1_CTL                                                              0x1801010C
+#define NF_DMA1_CTL_reg_addr                                                     "0xB801010C"
+#define NF_DMA1_CTL_reg                                                          0xB801010C
+#define set_NF_DMA1_CTL_reg(data)   (*((volatile unsigned int*) NF_DMA1_CTL_reg)=data)
+#define get_NF_DMA1_CTL_reg   (*((volatile unsigned int*) NF_DMA1_CTL_reg))
+#define NF_DMA1_CTL_inst_adr                                                     "0x0043"
+#define NF_DMA1_CTL_inst                                                         0x0043
+#define NF_DMA1_CTL_eot_gen_shift                                                (3)
+#define NF_DMA1_CTL_eot_gen_mask                                                 (0x00000008)
+#define NF_DMA1_CTL_eot_gen(data)                                                (0x00000008&((data)<<3))
+#define NF_DMA1_CTL_eot_gen_src(data)                                            ((0x00000008&(data))>>3)
+#define NF_DMA1_CTL_get_eot_gen(data)                                            ((0x00000008&(data))>>3)
+#define NF_DMA1_CTL_dma_max_pkt_shift                                            (2)
+#define NF_DMA1_CTL_dma_max_pkt_mask                                             (0x00000004)
+#define NF_DMA1_CTL_dma_max_pkt(data)                                            (0x00000004&((data)<<2))
+#define NF_DMA1_CTL_dma_max_pkt_src(data)                                        ((0x00000004&(data))>>2)
+#define NF_DMA1_CTL_get_dma_max_pkt(data)                                        ((0x00000004&(data))>>2)
+#define NF_DMA1_CTL_spec_pkt_shift                                               (1)
+#define NF_DMA1_CTL_spec_pkt_mask                                                (0x00000002)
+#define NF_DMA1_CTL_spec_pkt(data)                                               (0x00000002&((data)<<1))
+#define NF_DMA1_CTL_spec_pkt_src(data)                                           ((0x00000002&(data))>>1)
+#define NF_DMA1_CTL_get_spec_pkt(data)                                           ((0x00000002&(data))>>1)
+
+
+#define NF_PP_CTL0                                                               0x18010110
+#define NF_PP_CTL0_reg_addr                                                      "0xB8010110"
+#define NF_PP_CTL0_reg                                                           0xB8010110
+#define set_NF_PP_CTL0_reg(data)   (*((volatile unsigned int*) NF_PP_CTL0_reg)=data)
+#define get_NF_PP_CTL0_reg   (*((volatile unsigned int*) NF_PP_CTL0_reg))
+#define NF_PP_CTL0_inst_adr                                                      "0x0044"
+#define NF_PP_CTL0_inst                                                          0x0044
+#define NF_PP_CTL0_pp_start_addr_shift                                           (4)
+#define NF_PP_CTL0_pp_start_addr_mask                                            (0x00000070)
+#define NF_PP_CTL0_pp_start_addr(data)                                           (0x00000070&((data)<<4))
+#define NF_PP_CTL0_pp_start_addr_src(data)                                       ((0x00000070&(data))>>4)
+#define NF_PP_CTL0_get_pp_start_addr(data)                                       ((0x00000070&(data))>>4)
+#define NF_PP_CTL0_pp_busy_shift                                                 (2)
+#define NF_PP_CTL0_pp_busy_mask                                                  (0x00000004)
+#define NF_PP_CTL0_pp_busy(data)                                                 (0x00000004&((data)<<2))
+#define NF_PP_CTL0_pp_busy_src(data)                                             ((0x00000004&(data))>>2)
+#define NF_PP_CTL0_get_pp_busy(data)                                             ((0x00000004&(data))>>2)
+#define NF_PP_CTL0_pp_reset_shift                                                (1)
+#define NF_PP_CTL0_pp_reset_mask                                                 (0x00000002)
+#define NF_PP_CTL0_pp_reset(data)                                                (0x00000002&((data)<<1))
+#define NF_PP_CTL0_pp_reset_src(data)                                            ((0x00000002&(data))>>1)
+#define NF_PP_CTL0_get_pp_reset(data)                                            ((0x00000002&(data))>>1)
+#define NF_PP_CTL0_pp_enable_shift                                               (0)
+#define NF_PP_CTL0_pp_enable_mask                                                (0x00000001)
+#define NF_PP_CTL0_pp_enable(data)                                               (0x00000001&((data)<<0))
+#define NF_PP_CTL0_pp_enable_src(data)                                           ((0x00000001&(data))>>0)
+#define NF_PP_CTL0_get_pp_enable(data)                                           ((0x00000001&(data))>>0)
+
+
+#define NF_ECC_SEL                                                               0x18010128
+#define NF_ECC_SEL_reg_addr                                                      "0xB8010128"
+#define NF_ECC_SEL_reg                                                           0xB8010128
+#define set_NF_ECC_SEL_reg(data)   (*((volatile unsigned int*) NF_ECC_SEL_reg)=data)
+#define get_NF_ECC_SEL_reg   (*((volatile unsigned int*) NF_ECC_SEL_reg))
+#define NF_ECC_SEL_inst_adr                                                      "0x004A"
+#define NF_ECC_SEL_inst                                                          0x004A
+#define NF_ECC_SEL_ecc_bch_72b_mode_shift                                        (1)
+#define NF_ECC_SEL_ecc_bch_72b_mode_mask                                         (0x0000000E)
+#define NF_ECC_SEL_ecc_bch_72b_mode(data)                                        (0x0000000E&((data)<<1))
+#define NF_ECC_SEL_ecc_bch_72b_mode_src(data)                                    ((0x0000000E&(data))>>1)
+#define NF_ECC_SEL_get_ecc_bch_72b_mode(data)                                    ((0x0000000E&(data))>>1)
+#define NF_ECC_SEL_ecc_bch_12b_ena_shift                                         (0)
+#define NF_ECC_SEL_ecc_bch_12b_ena_mask                                          (0x00000001)
+#define NF_ECC_SEL_ecc_bch_12b_ena(data)                                         (0x00000001&((data)<<0))
+#define NF_ECC_SEL_ecc_bch_12b_ena_src(data)                                     ((0x00000001&(data))>>0)
+#define NF_ECC_SEL_get_ecc_bch_12b_ena(data)                                     ((0x00000001&(data))>>0)
+
+
+#define NF_PP_CTL1                                                               0x1801012C
+#define NF_PP_CTL1_reg_addr                                                      "0xB801012C"
+#define NF_PP_CTL1_reg                                                           0xB801012C
+#define set_NF_PP_CTL1_reg(data)   (*((volatile unsigned int*) NF_PP_CTL1_reg)=data)
+#define get_NF_PP_CTL1_reg   (*((volatile unsigned int*) NF_PP_CTL1_reg))
+#define NF_PP_CTL1_inst_adr                                                      "0x004B"
+#define NF_PP_CTL1_inst                                                          0x004B
+#define NF_PP_CTL1_pp_start_addr_shift                                           (0)
+#define NF_PP_CTL1_pp_start_addr_mask                                            (0x000000FF)
+#define NF_PP_CTL1_pp_start_addr(data)                                           (0x000000FF&((data)<<0))
+#define NF_PP_CTL1_pp_start_addr_src(data)                                       ((0x000000FF&(data))>>0)
+#define NF_PP_CTL1_get_pp_start_addr(data)                                       ((0x000000FF&(data))>>0)
+
+
+#define NF_PD                                                                    0x18010130
+#define NF_PD_reg_addr                                                           "0xB8010130"
+#define NF_PD_reg                                                                0xB8010130
+#define set_NF_PD_reg(data)   (*((volatile unsigned int*) NF_PD_reg)=data)
+#define get_NF_PD_reg   (*((volatile unsigned int*) NF_PD_reg))
+#define NF_PD_inst_adr                                                           "0x004C"
+#define NF_PD_inst                                                               0x004C
+#define NF_PD_pd_shift                                                           (0)
+#define NF_PD_pd_mask                                                            (0x0000001F)
+#define NF_PD_pd(data)                                                           (0x0000001F&((data)<<0))
+#define NF_PD_pd_src(data)                                                       ((0x0000001F&(data))>>0)
+#define NF_PD_get_pd(data)                                                       ((0x0000001F&(data))>>0)
+
+
+#define NF_NF_LOW_PWR                                                            0x1801013C
+#define NF_NF_LOW_PWR_reg_addr                                                   "0xB801013C"
+#define NF_NF_LOW_PWR_reg                                                        0xB801013C
+#define set_NF_NF_LOW_PWR_reg(data)   (*((volatile unsigned int*) NF_NF_LOW_PWR_reg)=data)
+#define get_NF_NF_LOW_PWR_reg   (*((volatile unsigned int*) NF_NF_LOW_PWR_reg))
+#define NF_NF_LOW_PWR_inst_adr                                                   "0x004F"
+#define NF_NF_LOW_PWR_inst                                                       0x004F
+#define NF_NF_LOW_PWR_pp_lp_mode_shift                                           (7)
+#define NF_NF_LOW_PWR_pp_lp_mode_mask                                            (0x00000080)
+#define NF_NF_LOW_PWR_pp_lp_mode(data)                                           (0x00000080&((data)<<7))
+#define NF_NF_LOW_PWR_pp_lp_mode_src(data)                                       ((0x00000080&(data))>>7)
+#define NF_NF_LOW_PWR_get_pp_lp_mode(data)                                       ((0x00000080&(data))>>7)
+#define NF_NF_LOW_PWR_pp_lp_ena_shift                                            (6)
+#define NF_NF_LOW_PWR_pp_lp_ena_mask                                             (0x00000040)
+#define NF_NF_LOW_PWR_pp_lp_ena(data)                                            (0x00000040&((data)<<6))
+#define NF_NF_LOW_PWR_pp_lp_ena_src(data)                                        ((0x00000040&(data))>>6)
+#define NF_NF_LOW_PWR_get_pp_lp_ena(data)                                        ((0x00000040&(data))>>6)
+#define NF_NF_LOW_PWR_ecc_clk_gate_ena_shift                                     (5)
+#define NF_NF_LOW_PWR_ecc_clk_gate_ena_mask                                      (0x00000020)
+#define NF_NF_LOW_PWR_ecc_clk_gate_ena(data)                                     (0x00000020&((data)<<5))
+#define NF_NF_LOW_PWR_ecc_clk_gate_ena_src(data)                                 ((0x00000020&(data))>>5)
+#define NF_NF_LOW_PWR_get_ecc_clk_gate_ena(data)                                 ((0x00000020&(data))>>5)
+#define NF_NF_LOW_PWR_ip_clk_gate_ena_shift                                      (4)
+#define NF_NF_LOW_PWR_ip_clk_gate_ena_mask                                       (0x00000010)
+#define NF_NF_LOW_PWR_ip_clk_gate_ena(data)                                      (0x00000010&((data)<<4))
+#define NF_NF_LOW_PWR_ip_clk_gate_ena_src(data)                                  ((0x00000010&(data))>>4)
+#define NF_NF_LOW_PWR_get_ip_clk_gate_ena(data)                                  ((0x00000010&(data))>>4)
+#define NF_NF_LOW_PWR_dma_clk_gate_ena_shift                                     (3)
+#define NF_NF_LOW_PWR_dma_clk_gate_ena_mask                                      (0x00000008)
+#define NF_NF_LOW_PWR_dma_clk_gate_ena(data)                                     (0x00000008&((data)<<3))
+#define NF_NF_LOW_PWR_dma_clk_gate_ena_src(data)                                 ((0x00000008&(data))>>3)
+#define NF_NF_LOW_PWR_get_dma_clk_gate_ena(data)                                 ((0x00000008&(data))>>3)
+#define NF_NF_LOW_PWR_pp_sram_rdy_num_shift                                      (0)
+#define NF_NF_LOW_PWR_pp_sram_rdy_num_mask                                       (0x00000007)
+#define NF_NF_LOW_PWR_pp_sram_rdy_num(data)                                      (0x00000007&((data)<<0))
+#define NF_NF_LOW_PWR_pp_sram_rdy_num_src(data)                                  ((0x00000007&(data))>>0)
+#define NF_NF_LOW_PWR_get_pp_sram_rdy_num(data)                                  ((0x00000007&(data))>>0)
+
+
+#define NF_DUMMY_NF1                                                             0x18010158
+#define NF_DUMMY_NF1_reg_addr                                                    "0xB8010158"
+#define NF_DUMMY_NF1_reg                                                         0xB8010158
+#define set_NF_DUMMY_NF1_reg(data)   (*((volatile unsigned int*) NF_DUMMY_NF1_reg)=data)
+#define get_NF_DUMMY_NF1_reg   (*((volatile unsigned int*) NF_DUMMY_NF1_reg))
+#define NF_DUMMY_NF1_inst_adr                                                    "0x0056"
+#define NF_DUMMY_NF1_inst                                                        0x0056
+#define NF_DUMMY_NF1_Dmy1_shift                                                  (0)
+#define NF_DUMMY_NF1_Dmy1_mask                                                   (0x000000FF)
+#define NF_DUMMY_NF1_Dmy1(data)                                                  (0x000000FF&((data)<<0))
+#define NF_DUMMY_NF1_Dmy1_src(data)                                              ((0x000000FF&(data))>>0)
+#define NF_DUMMY_NF1_get_Dmy1(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define NF_DUMMY_NF2                                                             0x1801015C
+#define NF_DUMMY_NF2_reg_addr                                                    "0xB801015C"
+#define NF_DUMMY_NF2_reg                                                         0xB801015C
+#define set_NF_DUMMY_NF2_reg(data)   (*((volatile unsigned int*) NF_DUMMY_NF2_reg)=data)
+#define get_NF_DUMMY_NF2_reg   (*((volatile unsigned int*) NF_DUMMY_NF2_reg))
+#define NF_DUMMY_NF2_inst_adr                                                    "0x0057"
+#define NF_DUMMY_NF2_inst                                                        0x0057
+#define NF_DUMMY_NF2_Dmy2_shift                                                  (0)
+#define NF_DUMMY_NF2_Dmy2_mask                                                   (0x000000FF)
+#define NF_DUMMY_NF2_Dmy2(data)                                                  (0x000000FF&((data)<<0))
+#define NF_DUMMY_NF2_Dmy2_src(data)                                              ((0x000000FF&(data))>>0)
+#define NF_DUMMY_NF2_get_Dmy2(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define NF_DUMMY_NF3                                                             0x18010160
+#define NF_DUMMY_NF3_reg_addr                                                    "0xB8010160"
+#define NF_DUMMY_NF3_reg                                                         0xB8010160
+#define set_NF_DUMMY_NF3_reg(data)   (*((volatile unsigned int*) NF_DUMMY_NF3_reg)=data)
+#define get_NF_DUMMY_NF3_reg   (*((volatile unsigned int*) NF_DUMMY_NF3_reg))
+#define NF_DUMMY_NF3_inst_adr                                                    "0x0058"
+#define NF_DUMMY_NF3_inst                                                        0x0058
+#define NF_DUMMY_NF3_Dmy3_shift                                                  (0)
+#define NF_DUMMY_NF3_Dmy3_mask                                                   (0x000000FF)
+#define NF_DUMMY_NF3_Dmy3(data)                                                  (0x000000FF&((data)<<0))
+#define NF_DUMMY_NF3_Dmy3_src(data)                                              ((0x000000FF&(data))>>0)
+#define NF_DUMMY_NF3_get_Dmy3(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define NF_DUMMY_NF4                                                             0x18010164
+#define NF_DUMMY_NF4_reg_addr                                                    "0xB8010164"
+#define NF_DUMMY_NF4_reg                                                         0xB8010164
+#define set_NF_DUMMY_NF4_reg(data)   (*((volatile unsigned int*) NF_DUMMY_NF4_reg)=data)
+#define get_NF_DUMMY_NF4_reg   (*((volatile unsigned int*) NF_DUMMY_NF4_reg))
+#define NF_DUMMY_NF4_inst_adr                                                    "0x0059"
+#define NF_DUMMY_NF4_inst                                                        0x0059
+#define NF_DUMMY_NF4_Dmy4_shift                                                  (0)
+#define NF_DUMMY_NF4_Dmy4_mask                                                   (0x000000FF)
+#define NF_DUMMY_NF4_Dmy4(data)                                                  (0x000000FF&((data)<<0))
+#define NF_DUMMY_NF4_Dmy4_src(data)                                              ((0x000000FF&(data))>>0)
+#define NF_DUMMY_NF4_get_Dmy4(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define NF_AUTO_TRIG                                                             0x18010200
+#define NF_AUTO_TRIG_reg_addr                                                    "0xB8010200"
+#define NF_AUTO_TRIG_reg                                                         0xB8010200
+#define set_NF_AUTO_TRIG_reg(data)   (*((volatile unsigned int*) NF_AUTO_TRIG_reg)=data)
+#define get_NF_AUTO_TRIG_reg   (*((volatile unsigned int*) NF_AUTO_TRIG_reg))
+#define NF_AUTO_TRIG_inst_adr                                                    "0x0080"
+#define NF_AUTO_TRIG_inst                                                        0x0080
+#define NF_AUTO_TRIG_auto_trig_shift                                             (7)
+#define NF_AUTO_TRIG_auto_trig_mask                                              (0x00000080)
+#define NF_AUTO_TRIG_auto_trig(data)                                             (0x00000080&((data)<<7))
+#define NF_AUTO_TRIG_auto_trig_src(data)                                         ((0x00000080&(data))>>7)
+#define NF_AUTO_TRIG_get_auto_trig(data)                                         ((0x00000080&(data))>>7)
+#define NF_AUTO_TRIG_addr_fbd_shift                                              (6)
+#define NF_AUTO_TRIG_addr_fbd_mask                                               (0x00000040)
+#define NF_AUTO_TRIG_addr_fbd(data)                                              (0x00000040&((data)<<6))
+#define NF_AUTO_TRIG_addr_fbd_src(data)                                          ((0x00000040&(data))>>6)
+#define NF_AUTO_TRIG_get_addr_fbd(data)                                          ((0x00000040&(data))>>6)
+#define NF_AUTO_TRIG_pp_empty_shift                                              (5)
+#define NF_AUTO_TRIG_pp_empty_mask                                               (0x00000020)
+#define NF_AUTO_TRIG_pp_empty(data)                                              (0x00000020&((data)<<5))
+#define NF_AUTO_TRIG_pp_empty_src(data)                                          ((0x00000020&(data))>>5)
+#define NF_AUTO_TRIG_get_pp_empty(data)                                          ((0x00000020&(data))>>5)
+#define NF_AUTO_TRIG_spec_auto_case_shift                                        (3)
+#define NF_AUTO_TRIG_spec_auto_case_mask                                         (0x00000018)
+#define NF_AUTO_TRIG_spec_auto_case(data)                                        (0x00000018&((data)<<3))
+#define NF_AUTO_TRIG_spec_auto_case_src(data)                                    ((0x00000018&(data))>>3)
+#define NF_AUTO_TRIG_get_spec_auto_case(data)                                    ((0x00000018&(data))>>3)
+#define NF_AUTO_TRIG_auto_case_shift                                             (0)
+#define NF_AUTO_TRIG_auto_case_mask                                              (0x00000007)
+#define NF_AUTO_TRIG_auto_case(data)                                             (0x00000007&((data)<<0))
+#define NF_AUTO_TRIG_auto_case_src(data)                                         ((0x00000007&(data))>>0)
+#define NF_AUTO_TRIG_get_auto_case(data)                                         ((0x00000007&(data))>>0)
+
+
+#define NF_RSECC_NUM                                                             0x18010204
+#define NF_RSECC_NUM_reg_addr                                                    "0xB8010204"
+#define NF_RSECC_NUM_reg                                                         0xB8010204
+#define set_NF_RSECC_NUM_reg(data)   (*((volatile unsigned int*) NF_RSECC_NUM_reg)=data)
+#define get_NF_RSECC_NUM_reg   (*((volatile unsigned int*) NF_RSECC_NUM_reg))
+#define NF_RSECC_NUM_inst_adr                                                    "0x0081"
+#define NF_RSECC_NUM_inst                                                        0x0081
+#define NF_RSECC_NUM_ecc_num_shift                                               (0)
+#define NF_RSECC_NUM_ecc_num_mask                                                (0x000000FF)
+#define NF_RSECC_NUM_ecc_num(data)                                               (0x000000FF&((data)<<0))
+#define NF_RSECC_NUM_ecc_num_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_RSECC_NUM_get_ecc_num(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_RND_CMD1                                                              0x18010208
+#define NF_RND_CMD1_reg_addr                                                     "0xB8010208"
+#define NF_RND_CMD1_reg                                                          0xB8010208
+#define set_NF_RND_CMD1_reg(data)   (*((volatile unsigned int*) NF_RND_CMD1_reg)=data)
+#define get_NF_RND_CMD1_reg   (*((volatile unsigned int*) NF_RND_CMD1_reg))
+#define NF_RND_CMD1_inst_adr                                                     "0x0082"
+#define NF_RND_CMD1_inst                                                         0x0082
+#define NF_RND_CMD1_rnd_cmd1_shift                                               (0)
+#define NF_RND_CMD1_rnd_cmd1_mask                                                (0x000000FF)
+#define NF_RND_CMD1_rnd_cmd1(data)                                               (0x000000FF&((data)<<0))
+#define NF_RND_CMD1_rnd_cmd1_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_RND_CMD1_get_rnd_cmd1(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_RND_CMD2                                                              0x1801020C
+#define NF_RND_CMD2_reg_addr                                                     "0xB801020C"
+#define NF_RND_CMD2_reg                                                          0xB801020C
+#define set_NF_RND_CMD2_reg(data)   (*((volatile unsigned int*) NF_RND_CMD2_reg)=data)
+#define get_NF_RND_CMD2_reg   (*((volatile unsigned int*) NF_RND_CMD2_reg))
+#define NF_RND_CMD2_inst_adr                                                     "0x0083"
+#define NF_RND_CMD2_inst                                                         0x0083
+#define NF_RND_CMD2_rnd_cmd2_shift                                               (0)
+#define NF_RND_CMD2_rnd_cmd2_mask                                                (0x000000FF)
+#define NF_RND_CMD2_rnd_cmd2(data)                                               (0x000000FF&((data)<<0))
+#define NF_RND_CMD2_rnd_cmd2_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_RND_CMD2_get_rnd_cmd2(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_RND_DATASTR_COL_H                                                     0x18010210
+#define NF_RND_DATASTR_COL_H_reg_addr                                            "0xB8010210"
+#define NF_RND_DATASTR_COL_H_reg                                                 0xB8010210
+#define set_NF_RND_DATASTR_COL_H_reg(data)   (*((volatile unsigned int*) NF_RND_DATASTR_COL_H_reg)=data)
+#define get_NF_RND_DATASTR_COL_H_reg   (*((volatile unsigned int*) NF_RND_DATASTR_COL_H_reg))
+#define NF_RND_DATASTR_COL_H_inst_adr                                            "0x0084"
+#define NF_RND_DATASTR_COL_H_inst                                                0x0084
+#define NF_RND_DATASTR_COL_H_data_col_msb_shift                                  (0)
+#define NF_RND_DATASTR_COL_H_data_col_msb_mask                                   (0x000000FF)
+#define NF_RND_DATASTR_COL_H_data_col_msb(data)                                  (0x000000FF&((data)<<0))
+#define NF_RND_DATASTR_COL_H_data_col_msb_src(data)                              ((0x000000FF&(data))>>0)
+#define NF_RND_DATASTR_COL_H_get_data_col_msb(data)                              ((0x000000FF&(data))>>0)
+
+
+#define NF_RND_SPR_STR_COL_H                                                     0x18010214
+#define NF_RND_SPR_STR_COL_H_reg_addr                                            "0xB8010214"
+#define NF_RND_SPR_STR_COL_H_reg                                                 0xB8010214
+#define set_NF_RND_SPR_STR_COL_H_reg(data)   (*((volatile unsigned int*) NF_RND_SPR_STR_COL_H_reg)=data)
+#define get_NF_RND_SPR_STR_COL_H_reg   (*((volatile unsigned int*) NF_RND_SPR_STR_COL_H_reg))
+#define NF_RND_SPR_STR_COL_H_inst_adr                                            "0x0085"
+#define NF_RND_SPR_STR_COL_H_inst                                                0x0085
+#define NF_RND_SPR_STR_COL_H_spr_col_msb_shift                                   (0)
+#define NF_RND_SPR_STR_COL_H_spr_col_msb_mask                                    (0x000000FF)
+#define NF_RND_SPR_STR_COL_H_spr_col_msb(data)                                   (0x000000FF&((data)<<0))
+#define NF_RND_SPR_STR_COL_H_spr_col_msb_src(data)                               ((0x000000FF&(data))>>0)
+#define NF_RND_SPR_STR_COL_H_get_spr_col_msb(data)                               ((0x000000FF&(data))>>0)
+
+
+#define NF_RND_SPR_STR_COL_L                                                     0x18010218
+#define NF_RND_SPR_STR_COL_L_reg_addr                                            "0xB8010218"
+#define NF_RND_SPR_STR_COL_L_reg                                                 0xB8010218
+#define set_NF_RND_SPR_STR_COL_L_reg(data)   (*((volatile unsigned int*) NF_RND_SPR_STR_COL_L_reg)=data)
+#define get_NF_RND_SPR_STR_COL_L_reg   (*((volatile unsigned int*) NF_RND_SPR_STR_COL_L_reg))
+#define NF_RND_SPR_STR_COL_L_inst_adr                                            "0x0086"
+#define NF_RND_SPR_STR_COL_L_inst                                                0x0086
+#define NF_RND_SPR_STR_COL_L_spr_col_lsb_shift                                   (0)
+#define NF_RND_SPR_STR_COL_L_spr_col_lsb_mask                                    (0x000000FF)
+#define NF_RND_SPR_STR_COL_L_spr_col_lsb(data)                                   (0x000000FF&((data)<<0))
+#define NF_RND_SPR_STR_COL_L_spr_col_lsb_src(data)                               ((0x000000FF&(data))>>0)
+#define NF_RND_SPR_STR_COL_L_get_spr_col_lsb(data)                               ((0x000000FF&(data))>>0)
+
+
+#define NF_RND_RW_EN                                                             0x1801021C
+#define NF_RND_RW_EN_reg_addr                                                    "0xB801021C"
+#define NF_RND_RW_EN_reg                                                         0xB801021C
+#define set_NF_RND_RW_EN_reg(data)   (*((volatile unsigned int*) NF_RND_RW_EN_reg)=data)
+#define get_NF_RND_RW_EN_reg   (*((volatile unsigned int*) NF_RND_RW_EN_reg))
+#define NF_RND_RW_EN_inst_adr                                                    "0x0087"
+#define NF_RND_RW_EN_inst                                                        0x0087
+#define NF_RND_RW_EN_rnd_rw_enable_shift                                         (0)
+#define NF_RND_RW_EN_rnd_rw_enable_mask                                          (0x00000001)
+#define NF_RND_RW_EN_rnd_rw_enable(data)                                         (0x00000001&((data)<<0))
+#define NF_RND_RW_EN_rnd_rw_enable_src(data)                                     ((0x00000001&(data))>>0)
+#define NF_RND_RW_EN_get_rnd_rw_enable(data)                                     ((0x00000001&(data))>>0)
+
+
+#define NF_READ_BY_PP                                                            0x18010228
+#define NF_READ_BY_PP_reg_addr                                                   "0xB8010228"
+#define NF_READ_BY_PP_reg                                                        0xB8010228
+#define set_NF_READ_BY_PP_reg(data)   (*((volatile unsigned int*) NF_READ_BY_PP_reg)=data)
+#define get_NF_READ_BY_PP_reg   (*((volatile unsigned int*) NF_READ_BY_PP_reg))
+#define NF_READ_BY_PP_inst_adr                                                   "0x008A"
+#define NF_READ_BY_PP_inst                                                       0x008A
+#define NF_READ_BY_PP_read_by_pp_shift                                           (7)
+#define NF_READ_BY_PP_read_by_pp_mask                                            (0x00000080)
+#define NF_READ_BY_PP_read_by_pp(data)                                           (0x00000080&((data)<<7))
+#define NF_READ_BY_PP_read_by_pp_src(data)                                       ((0x00000080&(data))>>7)
+#define NF_READ_BY_PP_get_read_by_pp(data)                                       ((0x00000080&(data))>>7)
+
+
+#define NF_MAX_ECC_NUM                                                           0x1801022C
+#define NF_MAX_ECC_NUM_reg_addr                                                  "0xB801022C"
+#define NF_MAX_ECC_NUM_reg                                                       0xB801022C
+#define set_NF_MAX_ECC_NUM_reg(data)   (*((volatile unsigned int*) NF_MAX_ECC_NUM_reg)=data)
+#define get_NF_MAX_ECC_NUM_reg   (*((volatile unsigned int*) NF_MAX_ECC_NUM_reg))
+#define NF_MAX_ECC_NUM_inst_adr                                                  "0x008B"
+#define NF_MAX_ECC_NUM_inst                                                      0x008B
+#define NF_MAX_ECC_NUM_max_ecc_num_shift                                         (0)
+#define NF_MAX_ECC_NUM_max_ecc_num_mask                                          (0x000000FF)
+#define NF_MAX_ECC_NUM_max_ecc_num(data)                                         (0x000000FF&((data)<<0))
+#define NF_MAX_ECC_NUM_max_ecc_num_src(data)                                     ((0x000000FF&(data))>>0)
+#define NF_MAX_ECC_NUM_get_max_ecc_num(data)                                     ((0x000000FF&(data))>>0)
+
+
+#define NF_TIME_PARA3                                                            0x18010234
+#define NF_TIME_PARA3_reg_addr                                                   "0xB8010234"
+#define NF_TIME_PARA3_reg                                                        0xB8010234
+#define set_NF_TIME_PARA3_reg(data)   (*((volatile unsigned int*) NF_TIME_PARA3_reg)=data)
+#define get_NF_TIME_PARA3_reg   (*((volatile unsigned int*) NF_TIME_PARA3_reg))
+#define NF_TIME_PARA3_inst_adr                                                   "0x008D"
+#define NF_TIME_PARA3_inst                                                       0x008D
+#define NF_TIME_PARA3_T3_shift                                                   (0)
+#define NF_TIME_PARA3_T3_mask                                                    (0x000000FF)
+#define NF_TIME_PARA3_T3(data)                                                   (0x000000FF&((data)<<0))
+#define NF_TIME_PARA3_T3_src(data)                                               ((0x000000FF&(data))>>0)
+#define NF_TIME_PARA3_get_T3(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define NF_TIME_PARA2                                                            0x18010238
+#define NF_TIME_PARA2_reg_addr                                                   "0xB8010238"
+#define NF_TIME_PARA2_reg                                                        0xB8010238
+#define set_NF_TIME_PARA2_reg(data)   (*((volatile unsigned int*) NF_TIME_PARA2_reg)=data)
+#define get_NF_TIME_PARA2_reg   (*((volatile unsigned int*) NF_TIME_PARA2_reg))
+#define NF_TIME_PARA2_inst_adr                                                   "0x008E"
+#define NF_TIME_PARA2_inst                                                       0x008E
+#define NF_TIME_PARA2_T2_shift                                                   (0)
+#define NF_TIME_PARA2_T2_mask                                                    (0x000000FF)
+#define NF_TIME_PARA2_T2(data)                                                   (0x000000FF&((data)<<0))
+#define NF_TIME_PARA2_T2_src(data)                                               ((0x000000FF&(data))>>0)
+#define NF_TIME_PARA2_get_T2(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define NF_TIME_PARA1                                                            0x1801023C
+#define NF_TIME_PARA1_reg_addr                                                   "0xB801023C"
+#define NF_TIME_PARA1_reg                                                        0xB801023C
+#define set_NF_TIME_PARA1_reg(data)   (*((volatile unsigned int*) NF_TIME_PARA1_reg)=data)
+#define get_NF_TIME_PARA1_reg   (*((volatile unsigned int*) NF_TIME_PARA1_reg))
+#define NF_TIME_PARA1_inst_adr                                                   "0x008F"
+#define NF_TIME_PARA1_inst                                                       0x008F
+#define NF_TIME_PARA1_T1_shift                                                   (0)
+#define NF_TIME_PARA1_T1_mask                                                    (0x000000FF)
+#define NF_TIME_PARA1_T1(data)                                                   (0x000000FF&((data)<<0))
+#define NF_TIME_PARA1_T1_src(data)                                               ((0x000000FF&(data))>>0)
+#define NF_TIME_PARA1_get_T1(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define NF_RMZ_CTRL                                                              0x18010240
+#define NF_RMZ_CTRL_reg_addr                                                     "0xB8010240"
+#define NF_RMZ_CTRL_reg                                                          0xB8010240
+#define set_NF_RMZ_CTRL_reg(data)   (*((volatile unsigned int*) NF_RMZ_CTRL_reg)=data)
+#define get_NF_RMZ_CTRL_reg   (*((volatile unsigned int*) NF_RMZ_CTRL_reg))
+#define NF_RMZ_CTRL_inst_adr                                                     "0x0090"
+#define NF_RMZ_CTRL_inst                                                         0x0090
+#define NF_RMZ_CTRL_rand_ready_shift                                             (1)
+#define NF_RMZ_CTRL_rand_ready_mask                                              (0x00000002)
+#define NF_RMZ_CTRL_rand_ready(data)                                             (0x00000002&((data)<<1))
+#define NF_RMZ_CTRL_rand_ready_src(data)                                         ((0x00000002&(data))>>1)
+#define NF_RMZ_CTRL_get_rand_ready(data)                                         ((0x00000002&(data))>>1)
+#define NF_RMZ_CTRL_rand_en_shift                                                (0)
+#define NF_RMZ_CTRL_rand_en_mask                                                 (0x00000001)
+#define NF_RMZ_CTRL_rand_en(data)                                                (0x00000001&((data)<<0))
+#define NF_RMZ_CTRL_rand_en_src(data)                                            ((0x00000001&(data))>>0)
+#define NF_RMZ_CTRL_get_rand_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define NF_RMZ_SEED_L                                                            0x18010244
+#define NF_RMZ_SEED_L_reg_addr                                                   "0xB8010244"
+#define NF_RMZ_SEED_L_reg                                                        0xB8010244
+#define set_NF_RMZ_SEED_L_reg(data)   (*((volatile unsigned int*) NF_RMZ_SEED_L_reg)=data)
+#define get_NF_RMZ_SEED_L_reg   (*((volatile unsigned int*) NF_RMZ_SEED_L_reg))
+#define NF_RMZ_SEED_L_inst_adr                                                   "0x0091"
+#define NF_RMZ_SEED_L_inst                                                       0x0091
+#define NF_RMZ_SEED_L_rand_seed_low_shift                                        (0)
+#define NF_RMZ_SEED_L_rand_seed_low_mask                                         (0x000000FF)
+#define NF_RMZ_SEED_L_rand_seed_low(data)                                        (0x000000FF&((data)<<0))
+#define NF_RMZ_SEED_L_rand_seed_low_src(data)                                    ((0x000000FF&(data))>>0)
+#define NF_RMZ_SEED_L_get_rand_seed_low(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define NF_RMZ_SEED_H                                                            0x18010248
+#define NF_RMZ_SEED_H_reg_addr                                                   "0xB8010248"
+#define NF_RMZ_SEED_H_reg                                                        0xB8010248
+#define set_NF_RMZ_SEED_H_reg(data)   (*((volatile unsigned int*) NF_RMZ_SEED_H_reg)=data)
+#define get_NF_RMZ_SEED_H_reg   (*((volatile unsigned int*) NF_RMZ_SEED_H_reg))
+#define NF_RMZ_SEED_H_inst_adr                                                   "0x0092"
+#define NF_RMZ_SEED_H_inst                                                       0x0092
+#define NF_RMZ_SEED_H_rand_seed_hi_shift                                         (0)
+#define NF_RMZ_SEED_H_rand_seed_hi_mask                                          (0x0000007F)
+#define NF_RMZ_SEED_H_rand_seed_hi(data)                                         (0x0000007F&((data)<<0))
+#define NF_RMZ_SEED_H_rand_seed_hi_src(data)                                     ((0x0000007F&(data))>>0)
+#define NF_RMZ_SEED_H_get_rand_seed_hi(data)                                     ((0x0000007F&(data))>>0)
+
+
+#define NF_RMZ_SEED_NUM                                                          0x1801024C
+#define NF_RMZ_SEED_NUM_reg_addr                                                 "0xB801024C"
+#define NF_RMZ_SEED_NUM_reg                                                      0xB801024C
+#define set_NF_RMZ_SEED_NUM_reg(data)   (*((volatile unsigned int*) NF_RMZ_SEED_NUM_reg)=data)
+#define get_NF_RMZ_SEED_NUM_reg   (*((volatile unsigned int*) NF_RMZ_SEED_NUM_reg))
+#define NF_RMZ_SEED_NUM_inst_adr                                                 "0x0093"
+#define NF_RMZ_SEED_NUM_inst                                                     0x0093
+#define NF_RMZ_SEED_NUM_rand_seed_from_reg_shift                                 (4)
+#define NF_RMZ_SEED_NUM_rand_seed_from_reg_mask                                  (0x00000010)
+#define NF_RMZ_SEED_NUM_rand_seed_from_reg(data)                                 (0x00000010&((data)<<4))
+#define NF_RMZ_SEED_NUM_rand_seed_from_reg_src(data)                             ((0x00000010&(data))>>4)
+#define NF_RMZ_SEED_NUM_get_rand_seed_from_reg(data)                             ((0x00000010&(data))>>4)
+#define NF_RMZ_SEED_NUM_rand_seed_num_shift                                      (0)
+#define NF_RMZ_SEED_NUM_rand_seed_num_mask                                       (0x00000007)
+#define NF_RMZ_SEED_NUM_rand_seed_num(data)                                      (0x00000007&((data)<<0))
+#define NF_RMZ_SEED_NUM_rand_seed_num_src(data)                                  ((0x00000007&(data))>>0)
+#define NF_RMZ_SEED_NUM_get_rand_seed_num(data)                                  ((0x00000007&(data))>>0)
+
+
+#define NF_PIN_MUX_STOP                                                          0x1801025C
+#define NF_PIN_MUX_STOP_reg_addr                                                 "0xB801025C"
+#define NF_PIN_MUX_STOP_reg                                                      0xB801025C
+#define set_NF_PIN_MUX_STOP_reg(data)   (*((volatile unsigned int*) NF_PIN_MUX_STOP_reg)=data)
+#define get_NF_PIN_MUX_STOP_reg   (*((volatile unsigned int*) NF_PIN_MUX_STOP_reg))
+#define NF_PIN_MUX_STOP_inst_adr                                                 "0x0097"
+#define NF_PIN_MUX_STOP_inst                                                     0x0097
+#define NF_PIN_MUX_STOP_pin_stop_shift                                           (2)
+#define NF_PIN_MUX_STOP_pin_stop_mask                                            (0x00000004)
+#define NF_PIN_MUX_STOP_pin_stop(data)                                           (0x00000004&((data)<<2))
+#define NF_PIN_MUX_STOP_pin_stop_src(data)                                       ((0x00000004&(data))>>2)
+#define NF_PIN_MUX_STOP_get_pin_stop(data)                                       ((0x00000004&(data))>>2)
+#define NF_PIN_MUX_STOP_intlev_pin_ena_shift                                     (1)
+#define NF_PIN_MUX_STOP_intlev_pin_ena_mask                                      (0x00000002)
+#define NF_PIN_MUX_STOP_intlev_pin_ena(data)                                     (0x00000002&((data)<<1))
+#define NF_PIN_MUX_STOP_intlev_pin_ena_src(data)                                 ((0x00000002&(data))>>1)
+#define NF_PIN_MUX_STOP_get_intlev_pin_ena(data)                                 ((0x00000002&(data))>>1)
+#define NF_PIN_MUX_STOP_pin_mux_ena_shift                                        (0)
+#define NF_PIN_MUX_STOP_pin_mux_ena_mask                                         (0x00000001)
+#define NF_PIN_MUX_STOP_pin_mux_ena(data)                                        (0x00000001&((data)<<0))
+#define NF_PIN_MUX_STOP_pin_mux_ena_src(data)                                    ((0x00000001&(data))>>0)
+#define NF_PIN_MUX_STOP_get_pin_mux_ena(data)                                    ((0x00000001&(data))>>0)
+
+
+#define NF_DELAY_CTL                                                             0x18010260
+#define NF_DELAY_CTL_reg_addr                                                    "0xB8010260"
+#define NF_DELAY_CTL_reg                                                         0xB8010260
+#define set_NF_DELAY_CTL_reg(data)   (*((volatile unsigned int*) NF_DELAY_CTL_reg)=data)
+#define get_NF_DELAY_CTL_reg   (*((volatile unsigned int*) NF_DELAY_CTL_reg))
+#define NF_DELAY_CTL_inst_adr                                                    "0x0098"
+#define NF_DELAY_CTL_inst                                                        0x0098
+#define NF_DELAY_CTL_T_swait_busy_shift                                          (6)
+#define NF_DELAY_CTL_T_swait_busy_mask                                           (0x000000C0)
+#define NF_DELAY_CTL_T_swait_busy(data)                                          (0x000000C0&((data)<<6))
+#define NF_DELAY_CTL_T_swait_busy_src(data)                                      ((0x000000C0&(data))>>6)
+#define NF_DELAY_CTL_get_T_swait_busy(data)                                      ((0x000000C0&(data))>>6)
+#define NF_DELAY_CTL_T_WHR_ADL_shift                                             (0)
+#define NF_DELAY_CTL_T_WHR_ADL_mask                                              (0x0000003F)
+#define NF_DELAY_CTL_T_WHR_ADL(data)                                             (0x0000003F&((data)<<0))
+#define NF_DELAY_CTL_T_WHR_ADL_src(data)                                         ((0x0000003F&(data))>>0)
+#define NF_DELAY_CTL_get_T_WHR_ADL(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define NF_ECC_STOP                                                              0x18010264
+#define NF_ECC_STOP_reg_addr                                                     "0xB8010264"
+#define NF_ECC_STOP_reg                                                          0xB8010264
+#define set_NF_ECC_STOP_reg(data)   (*((volatile unsigned int*) NF_ECC_STOP_reg)=data)
+#define get_NF_ECC_STOP_reg   (*((volatile unsigned int*) NF_ECC_STOP_reg))
+#define NF_ECC_STOP_inst_adr                                                     "0x0099"
+#define NF_ECC_STOP_inst                                                         0x0099
+#define NF_ECC_STOP_ecc_n_stop_shift                                             (7)
+#define NF_ECC_STOP_ecc_n_stop_mask                                              (0x00000080)
+#define NF_ECC_STOP_ecc_n_stop(data)                                             (0x00000080&((data)<<7))
+#define NF_ECC_STOP_ecc_n_stop_src(data)                                         ((0x00000080&(data))>>7)
+#define NF_ECC_STOP_get_ecc_n_stop(data)                                         ((0x00000080&(data))>>7)
+
+
+#define NF_ECC_PAGE                                                              0x18010268
+#define NF_ECC_PAGE_reg_addr                                                     "0xB8010268"
+#define NF_ECC_PAGE_reg                                                          0xB8010268
+#define set_NF_ECC_PAGE_reg(data)   (*((volatile unsigned int*) NF_ECC_PAGE_reg)=data)
+#define get_NF_ECC_PAGE_reg   (*((volatile unsigned int*) NF_ECC_PAGE_reg))
+#define NF_ECC_PAGE_inst_adr                                                     "0x009A"
+#define NF_ECC_PAGE_inst                                                         0x009A
+#define NF_ECC_PAGE_ecc_page_shift                                               (0)
+#define NF_ECC_PAGE_ecc_page_mask                                                (0x000000FF)
+#define NF_ECC_PAGE_ecc_page(data)                                               (0x000000FF&((data)<<0))
+#define NF_ECC_PAGE_ecc_page_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_ECC_PAGE_get_ecc_page(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_PAGE_CNT                                                              0x1801026C
+#define NF_PAGE_CNT_reg_addr                                                     "0xB801026C"
+#define NF_PAGE_CNT_reg                                                          0xB801026C
+#define set_NF_PAGE_CNT_reg(data)   (*((volatile unsigned int*) NF_PAGE_CNT_reg)=data)
+#define get_NF_PAGE_CNT_reg   (*((volatile unsigned int*) NF_PAGE_CNT_reg))
+#define NF_PAGE_CNT_inst_adr                                                     "0x009B"
+#define NF_PAGE_CNT_inst                                                         0x009B
+#define NF_PAGE_CNT_page_cnt_shift                                               (0)
+#define NF_PAGE_CNT_page_cnt_mask                                                (0x000000FF)
+#define NF_PAGE_CNT_page_cnt(data)                                               (0x000000FF&((data)<<0))
+#define NF_PAGE_CNT_page_cnt_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_PAGE_CNT_get_page_cnt(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_PAGE_LEN                                                              0x18010270
+#define NF_PAGE_LEN_reg_addr                                                     "0xB8010270"
+#define NF_PAGE_LEN_reg                                                          0xB8010270
+#define set_NF_PAGE_LEN_reg(data)   (*((volatile unsigned int*) NF_PAGE_LEN_reg)=data)
+#define get_NF_PAGE_LEN_reg   (*((volatile unsigned int*) NF_PAGE_LEN_reg))
+#define NF_PAGE_LEN_inst_adr                                                     "0x009C"
+#define NF_PAGE_LEN_inst                                                         0x009C
+#define NF_PAGE_LEN_page_len_shift                                               (0)
+#define NF_PAGE_LEN_page_len_mask                                                (0x000000FF)
+#define NF_PAGE_LEN_page_len(data)                                               (0x000000FF&((data)<<0))
+#define NF_PAGE_LEN_page_len_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_PAGE_LEN_get_page_len(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_CMD2                                                                  0x18010274
+#define NF_CMD2_reg_addr                                                         "0xB8010274"
+#define NF_CMD2_reg                                                              0xB8010274
+#define set_NF_CMD2_reg(data)   (*((volatile unsigned int*) NF_CMD2_reg)=data)
+#define get_NF_CMD2_reg   (*((volatile unsigned int*) NF_CMD2_reg))
+#define NF_CMD2_inst_adr                                                         "0x009D"
+#define NF_CMD2_inst                                                             0x009D
+#define NF_CMD2_cmd2_shift                                                       (0)
+#define NF_CMD2_cmd2_mask                                                        (0x000000FF)
+#define NF_CMD2_cmd2(data)                                                       (0x000000FF&((data)<<0))
+#define NF_CMD2_cmd2_src(data)                                                   ((0x000000FF&(data))>>0)
+#define NF_CMD2_get_cmd2(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define NF_MULTI_CHNL_MODE                                                       0x1801027C
+#define NF_MULTI_CHNL_MODE_reg_addr                                              "0xB801027C"
+#define NF_MULTI_CHNL_MODE_reg                                                   0xB801027C
+#define set_NF_MULTI_CHNL_MODE_reg(data)   (*((volatile unsigned int*) NF_MULTI_CHNL_MODE_reg)=data)
+#define get_NF_MULTI_CHNL_MODE_reg   (*((volatile unsigned int*) NF_MULTI_CHNL_MODE_reg))
+#define NF_MULTI_CHNL_MODE_inst_adr                                              "0x009F"
+#define NF_MULTI_CHNL_MODE_inst                                                  0x009F
+#define NF_MULTI_CHNL_MODE_ecc_pass_shift                                        (7)
+#define NF_MULTI_CHNL_MODE_ecc_pass_mask                                         (0x00000080)
+#define NF_MULTI_CHNL_MODE_ecc_pass(data)                                        (0x00000080&((data)<<7))
+#define NF_MULTI_CHNL_MODE_ecc_pass_src(data)                                    ((0x00000080&(data))>>7)
+#define NF_MULTI_CHNL_MODE_get_ecc_pass(data)                                    ((0x00000080&(data))>>7)
+#define NF_MULTI_CHNL_MODE_ecc_no_check_shift                                    (6)
+#define NF_MULTI_CHNL_MODE_ecc_no_check_mask                                     (0x00000040)
+#define NF_MULTI_CHNL_MODE_ecc_no_check(data)                                    (0x00000040&((data)<<6))
+#define NF_MULTI_CHNL_MODE_ecc_no_check_src(data)                                ((0x00000040&(data))>>6)
+#define NF_MULTI_CHNL_MODE_get_ecc_no_check(data)                                ((0x00000040&(data))>>6)
+#define NF_MULTI_CHNL_MODE_edo_shift                                             (5)
+#define NF_MULTI_CHNL_MODE_edo_mask                                              (0x00000020)
+#define NF_MULTI_CHNL_MODE_edo(data)                                             (0x00000020&((data)<<5))
+#define NF_MULTI_CHNL_MODE_edo_src(data)                                         ((0x00000020&(data))>>5)
+#define NF_MULTI_CHNL_MODE_get_edo(data)                                         ((0x00000020&(data))>>5)
+#define NF_MULTI_CHNL_MODE_no_wait_busy_shift                                    (4)
+#define NF_MULTI_CHNL_MODE_no_wait_busy_mask                                     (0x00000010)
+#define NF_MULTI_CHNL_MODE_no_wait_busy(data)                                    (0x00000010&((data)<<4))
+#define NF_MULTI_CHNL_MODE_no_wait_busy_src(data)                                ((0x00000010&(data))>>4)
+#define NF_MULTI_CHNL_MODE_get_no_wait_busy(data)                                ((0x00000010&(data))>>4)
+#define NF_MULTI_CHNL_MODE_wait_ready_shift                                      (2)
+#define NF_MULTI_CHNL_MODE_wait_ready_mask                                       (0x0000000C)
+#define NF_MULTI_CHNL_MODE_wait_ready(data)                                      (0x0000000C&((data)<<2))
+#define NF_MULTI_CHNL_MODE_wait_ready_src(data)                                  ((0x0000000C&(data))>>2)
+#define NF_MULTI_CHNL_MODE_get_wait_ready(data)                                  ((0x0000000C&(data))>>2)
+
+
+#define NF_SRAM_CTL                                                              0x18010300
+#define NF_SRAM_CTL_reg_addr                                                     "0xB8010300"
+#define NF_SRAM_CTL_reg                                                          0xB8010300
+#define set_NF_SRAM_CTL_reg(data)   (*((volatile unsigned int*) NF_SRAM_CTL_reg)=data)
+#define get_NF_SRAM_CTL_reg   (*((volatile unsigned int*) NF_SRAM_CTL_reg))
+#define NF_SRAM_CTL_inst_adr                                                     "0x00C0"
+#define NF_SRAM_CTL_inst                                                         0x00C0
+#define NF_SRAM_CTL_map_sel_shift                                                (5)
+#define NF_SRAM_CTL_map_sel_mask                                                 (0x00000020)
+#define NF_SRAM_CTL_map_sel(data)                                                (0x00000020&((data)<<5))
+#define NF_SRAM_CTL_map_sel_src(data)                                            ((0x00000020&(data))>>5)
+#define NF_SRAM_CTL_get_map_sel(data)                                            ((0x00000020&(data))>>5)
+#define NF_SRAM_CTL_access_en_shift                                              (4)
+#define NF_SRAM_CTL_access_en_mask                                               (0x00000010)
+#define NF_SRAM_CTL_access_en(data)                                              (0x00000010&((data)<<4))
+#define NF_SRAM_CTL_access_en_src(data)                                          ((0x00000010&(data))>>4)
+#define NF_SRAM_CTL_get_access_en(data)                                          ((0x00000010&(data))>>4)
+#define NF_SRAM_CTL_mem_region_shift                                             (0)
+#define NF_SRAM_CTL_mem_region_mask                                              (0x0000000F)
+#define NF_SRAM_CTL_mem_region(data)                                             (0x0000000F&((data)<<0))
+#define NF_SRAM_CTL_mem_region_src(data)                                         ((0x0000000F&(data))>>0)
+#define NF_SRAM_CTL_get_mem_region(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define NF_DMA_CTL1                                                              0x18010304
+#define NF_DMA_CTL1_reg_addr                                                     "0xB8010304"
+#define NF_DMA_CTL1_reg                                                          0xB8010304
+#define set_NF_DMA_CTL1_reg(data)   (*((volatile unsigned int*) NF_DMA_CTL1_reg)=data)
+#define get_NF_DMA_CTL1_reg   (*((volatile unsigned int*) NF_DMA_CTL1_reg))
+#define NF_DMA_CTL1_inst_adr                                                     "0x00C1"
+#define NF_DMA_CTL1_inst                                                         0x00C1
+#define NF_DMA_CTL1_dram_sa_shift                                                (0)
+#define NF_DMA_CTL1_dram_sa_mask                                                 (0x0FFFFFFF)
+#define NF_DMA_CTL1_dram_sa(data)                                                (0x0FFFFFFF&((data)<<0))
+#define NF_DMA_CTL1_dram_sa_src(data)                                            ((0x0FFFFFFF&(data))>>0)
+#define NF_DMA_CTL1_get_dram_sa(data)                                            ((0x0FFFFFFF&(data))>>0)
+
+
+#define NF_DMA_CTL2                                                              0x18010308
+#define NF_DMA_CTL2_reg_addr                                                     "0xB8010308"
+#define NF_DMA_CTL2_reg                                                          0xB8010308
+#define set_NF_DMA_CTL2_reg(data)   (*((volatile unsigned int*) NF_DMA_CTL2_reg)=data)
+#define get_NF_DMA_CTL2_reg   (*((volatile unsigned int*) NF_DMA_CTL2_reg))
+#define NF_DMA_CTL2_inst_adr                                                     "0x00C2"
+#define NF_DMA_CTL2_inst                                                         0x00C2
+#define NF_DMA_CTL2_dma_len_shift                                                (0)
+#define NF_DMA_CTL2_dma_len_mask                                                 (0x0000FFFF)
+#define NF_DMA_CTL2_dma_len(data)                                                (0x0000FFFF&((data)<<0))
+#define NF_DMA_CTL2_dma_len_src(data)                                            ((0x0000FFFF&(data))>>0)
+#define NF_DMA_CTL2_get_dma_len(data)                                            ((0x0000FFFF&(data))>>0)
+
+
+#define NF_DMA_CTL3                                                              0x1801030C
+#define NF_DMA_CTL3_reg_addr                                                     "0xB801030C"
+#define NF_DMA_CTL3_reg                                                          0xB801030C
+#define set_NF_DMA_CTL3_reg(data)   (*((volatile unsigned int*) NF_DMA_CTL3_reg)=data)
+#define get_NF_DMA_CTL3_reg   (*((volatile unsigned int*) NF_DMA_CTL3_reg))
+#define NF_DMA_CTL3_inst_adr                                                     "0x00C3"
+#define NF_DMA_CTL3_inst                                                         0x00C3
+#define NF_DMA_CTL3_cp_first_shift                                               (3)
+#define NF_DMA_CTL3_cp_first_mask                                                (0x00000008)
+#define NF_DMA_CTL3_cp_first(data)                                               (0x00000008&((data)<<3))
+#define NF_DMA_CTL3_cp_first_src(data)                                           ((0x00000008&(data))>>3)
+#define NF_DMA_CTL3_get_cp_first(data)                                           ((0x00000008&(data))>>3)
+#define NF_DMA_CTL3_cp_enable_shift                                              (2)
+#define NF_DMA_CTL3_cp_enable_mask                                               (0x00000004)
+#define NF_DMA_CTL3_cp_enable(data)                                              (0x00000004&((data)<<2))
+#define NF_DMA_CTL3_cp_enable_src(data)                                          ((0x00000004&(data))>>2)
+#define NF_DMA_CTL3_get_cp_enable(data)                                          ((0x00000004&(data))>>2)
+#define NF_DMA_CTL3_ddr_wr_shift                                                 (1)
+#define NF_DMA_CTL3_ddr_wr_mask                                                  (0x00000002)
+#define NF_DMA_CTL3_ddr_wr(data)                                                 (0x00000002&((data)<<1))
+#define NF_DMA_CTL3_ddr_wr_src(data)                                             ((0x00000002&(data))>>1)
+#define NF_DMA_CTL3_get_ddr_wr(data)                                             ((0x00000002&(data))>>1)
+#define NF_DMA_CTL3_dma_xfer_shift                                               (0)
+#define NF_DMA_CTL3_dma_xfer_mask                                                (0x00000001)
+#define NF_DMA_CTL3_dma_xfer(data)                                               (0x00000001&((data)<<0))
+#define NF_DMA_CTL3_dma_xfer_src(data)                                           ((0x00000001&(data))>>0)
+#define NF_DMA_CTL3_get_dma_xfer(data)                                           ((0x00000001&(data))>>0)
+
+
+#define NF_SYS_LOW_PWR                                                           0x18010310
+#define NF_SYS_LOW_PWR_reg_addr                                                  "0xB8010310"
+#define NF_SYS_LOW_PWR_reg                                                       0xB8010310
+#define set_NF_SYS_LOW_PWR_reg(data)   (*((volatile unsigned int*) NF_SYS_LOW_PWR_reg)=data)
+#define get_NF_SYS_LOW_PWR_reg   (*((volatile unsigned int*) NF_SYS_LOW_PWR_reg))
+#define NF_SYS_LOW_PWR_inst_adr                                                  "0x00C4"
+#define NF_SYS_LOW_PWR_inst                                                      0x00C4
+#define NF_SYS_LOW_PWR_mcu_pp_sram_lp_ena_shift                                  (7)
+#define NF_SYS_LOW_PWR_mcu_pp_sram_lp_ena_mask                                   (0x00000080)
+#define NF_SYS_LOW_PWR_mcu_pp_sram_lp_ena(data)                                  (0x00000080&((data)<<7))
+#define NF_SYS_LOW_PWR_mcu_pp_sram_lp_ena_src(data)                              ((0x00000080&(data))>>7)
+#define NF_SYS_LOW_PWR_get_mcu_pp_sram_lp_ena(data)                              ((0x00000080&(data))>>7)
+#define NF_SYS_LOW_PWR_sys_clk_gate_ena_shift                                    (6)
+#define NF_SYS_LOW_PWR_sys_clk_gate_ena_mask                                     (0x00000040)
+#define NF_SYS_LOW_PWR_sys_clk_gate_ena(data)                                    (0x00000040&((data)<<6))
+#define NF_SYS_LOW_PWR_sys_clk_gate_ena_src(data)                                ((0x00000040&(data))>>6)
+#define NF_SYS_LOW_PWR_get_sys_clk_gate_ena(data)                                ((0x00000040&(data))>>6)
+#define NF_SYS_LOW_PWR_cp_clk_gate_ena_shift                                     (5)
+#define NF_SYS_LOW_PWR_cp_clk_gate_ena_mask                                      (0x00000020)
+#define NF_SYS_LOW_PWR_cp_clk_gate_ena(data)                                     (0x00000020&((data)<<5))
+#define NF_SYS_LOW_PWR_cp_clk_gate_ena_src(data)                                 ((0x00000020&(data))>>5)
+#define NF_SYS_LOW_PWR_get_cp_clk_gate_ena(data)                                 ((0x00000020&(data))>>5)
+#define NF_SYS_LOW_PWR_dma_sram_lp_ena_shift                                     (4)
+#define NF_SYS_LOW_PWR_dma_sram_lp_ena_mask                                      (0x00000010)
+#define NF_SYS_LOW_PWR_dma_sram_lp_ena(data)                                     (0x00000010&((data)<<4))
+#define NF_SYS_LOW_PWR_dma_sram_lp_ena_src(data)                                 ((0x00000010&(data))>>4)
+#define NF_SYS_LOW_PWR_get_dma_sram_lp_ena(data)                                 ((0x00000010&(data))>>4)
+#define NF_SYS_LOW_PWR_dma_sram_rdy_num_shift                                    (0)
+#define NF_SYS_LOW_PWR_dma_sram_rdy_num_mask                                     (0x0000000F)
+#define NF_SYS_LOW_PWR_dma_sram_rdy_num(data)                                    (0x0000000F&((data)<<0))
+#define NF_SYS_LOW_PWR_dma_sram_rdy_num_src(data)                                ((0x0000000F&(data))>>0)
+#define NF_SYS_LOW_PWR_get_dma_sram_rdy_num(data)                                ((0x0000000F&(data))>>0)
+
+
+#define NF_NAND_ISR                                                              0x18010324
+#define NF_NAND_ISR_reg_addr                                                     "0xB8010324"
+#define NF_NAND_ISR_reg                                                          0xB8010324
+#define set_NF_NAND_ISR_reg(data)   (*((volatile unsigned int*) NF_NAND_ISR_reg)=data)
+#define get_NF_NAND_ISR_reg   (*((volatile unsigned int*) NF_NAND_ISR_reg))
+#define NF_NAND_ISR_inst_adr                                                     "0x00C9"
+#define NF_NAND_ISR_inst                                                         0x00C9
+#define NF_NAND_ISR_Int8_shift                                                   (8)
+#define NF_NAND_ISR_Int8_mask                                                    (0x00000100)
+#define NF_NAND_ISR_Int8(data)                                                   (0x00000100&((data)<<8))
+#define NF_NAND_ISR_Int8_src(data)                                               ((0x00000100&(data))>>8)
+#define NF_NAND_ISR_get_Int8(data)                                               ((0x00000100&(data))>>8)
+#define NF_NAND_ISR_Int7_shift                                                   (7)
+#define NF_NAND_ISR_Int7_mask                                                    (0x00000080)
+#define NF_NAND_ISR_Int7(data)                                                   (0x00000080&((data)<<7))
+#define NF_NAND_ISR_Int7_src(data)                                               ((0x00000080&(data))>>7)
+#define NF_NAND_ISR_get_Int7(data)                                               ((0x00000080&(data))>>7)
+#define NF_NAND_ISR_Int4_shift                                                   (4)
+#define NF_NAND_ISR_Int4_mask                                                    (0x00000010)
+#define NF_NAND_ISR_Int4(data)                                                   (0x00000010&((data)<<4))
+#define NF_NAND_ISR_Int4_src(data)                                               ((0x00000010&(data))>>4)
+#define NF_NAND_ISR_get_Int4(data)                                               ((0x00000010&(data))>>4)
+#define NF_NAND_ISR_Int3_shift                                                   (3)
+#define NF_NAND_ISR_Int3_mask                                                    (0x00000008)
+#define NF_NAND_ISR_Int3(data)                                                   (0x00000008&((data)<<3))
+#define NF_NAND_ISR_Int3_src(data)                                               ((0x00000008&(data))>>3)
+#define NF_NAND_ISR_get_Int3(data)                                               ((0x00000008&(data))>>3)
+#define NF_NAND_ISR_Int2_shift                                                   (2)
+#define NF_NAND_ISR_Int2_mask                                                    (0x00000004)
+#define NF_NAND_ISR_Int2(data)                                                   (0x00000004&((data)<<2))
+#define NF_NAND_ISR_Int2_src(data)                                               ((0x00000004&(data))>>2)
+#define NF_NAND_ISR_get_Int2(data)                                               ((0x00000004&(data))>>2)
+#define NF_NAND_ISR_Int1_shift                                                   (1)
+#define NF_NAND_ISR_Int1_mask                                                    (0x00000002)
+#define NF_NAND_ISR_Int1(data)                                                   (0x00000002&((data)<<1))
+#define NF_NAND_ISR_Int1_src(data)                                               ((0x00000002&(data))>>1)
+#define NF_NAND_ISR_get_Int1(data)                                               ((0x00000002&(data))>>1)
+#define NF_NAND_ISR_write_data_shift                                             (0)
+#define NF_NAND_ISR_write_data_mask                                              (0x00000001)
+#define NF_NAND_ISR_write_data(data)                                             (0x00000001&((data)<<0))
+#define NF_NAND_ISR_write_data_src(data)                                         ((0x00000001&(data))>>0)
+#define NF_NAND_ISR_get_write_data(data)                                         ((0x00000001&(data))>>0)
+
+
+#define NF_NAND_ISREN                                                            0x18010328
+#define NF_NAND_ISREN_reg_addr                                                   "0xB8010328"
+#define NF_NAND_ISREN_reg                                                        0xB8010328
+#define set_NF_NAND_ISREN_reg(data)   (*((volatile unsigned int*) NF_NAND_ISREN_reg)=data)
+#define get_NF_NAND_ISREN_reg   (*((volatile unsigned int*) NF_NAND_ISREN_reg))
+#define NF_NAND_ISREN_inst_adr                                                   "0x00CA"
+#define NF_NAND_ISREN_inst                                                       0x00CA
+#define NF_NAND_ISREN_Int8En_shift                                               (8)
+#define NF_NAND_ISREN_Int8En_mask                                                (0x00000100)
+#define NF_NAND_ISREN_Int8En(data)                                               (0x00000100&((data)<<8))
+#define NF_NAND_ISREN_Int8En_src(data)                                           ((0x00000100&(data))>>8)
+#define NF_NAND_ISREN_get_Int8En(data)                                           ((0x00000100&(data))>>8)
+#define NF_NAND_ISREN_Int7En_shift                                               (7)
+#define NF_NAND_ISREN_Int7En_mask                                                (0x00000080)
+#define NF_NAND_ISREN_Int7En(data)                                               (0x00000080&((data)<<7))
+#define NF_NAND_ISREN_Int7En_src(data)                                           ((0x00000080&(data))>>7)
+#define NF_NAND_ISREN_get_Int7En(data)                                           ((0x00000080&(data))>>7)
+#define NF_NAND_ISREN_Int4En_shift                                               (4)
+#define NF_NAND_ISREN_Int4En_mask                                                (0x00000010)
+#define NF_NAND_ISREN_Int4En(data)                                               (0x00000010&((data)<<4))
+#define NF_NAND_ISREN_Int4En_src(data)                                           ((0x00000010&(data))>>4)
+#define NF_NAND_ISREN_get_Int4En(data)                                           ((0x00000010&(data))>>4)
+#define NF_NAND_ISREN_Int3En_shift                                               (3)
+#define NF_NAND_ISREN_Int3En_mask                                                (0x00000008)
+#define NF_NAND_ISREN_Int3En(data)                                               (0x00000008&((data)<<3))
+#define NF_NAND_ISREN_Int3En_src(data)                                           ((0x00000008&(data))>>3)
+#define NF_NAND_ISREN_get_Int3En(data)                                           ((0x00000008&(data))>>3)
+#define NF_NAND_ISREN_Int2En_shift                                               (2)
+#define NF_NAND_ISREN_Int2En_mask                                                (0x00000004)
+#define NF_NAND_ISREN_Int2En(data)                                               (0x00000004&((data)<<2))
+#define NF_NAND_ISREN_Int2En_src(data)                                           ((0x00000004&(data))>>2)
+#define NF_NAND_ISREN_get_Int2En(data)                                           ((0x00000004&(data))>>2)
+#define NF_NAND_ISREN_Int1En_shift                                               (1)
+#define NF_NAND_ISREN_Int1En_mask                                                (0x00000002)
+#define NF_NAND_ISREN_Int1En(data)                                               (0x00000002&((data)<<1))
+#define NF_NAND_ISREN_Int1En_src(data)                                           ((0x00000002&(data))>>1)
+#define NF_NAND_ISREN_get_Int1En(data)                                           ((0x00000002&(data))>>1)
+#define NF_NAND_ISREN_write_data_shift                                           (0)
+#define NF_NAND_ISREN_write_data_mask                                            (0x00000001)
+#define NF_NAND_ISREN_write_data(data)                                           (0x00000001&((data)<<0))
+#define NF_NAND_ISREN_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define NF_NAND_ISREN_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define NF_DUMMY_SYS                                                             0x1801032C
+#define NF_DUMMY_SYS_reg_addr                                                    "0xB801032C"
+#define NF_DUMMY_SYS_reg                                                         0xB801032C
+#define set_NF_DUMMY_SYS_reg(data)   (*((volatile unsigned int*) NF_DUMMY_SYS_reg)=data)
+#define get_NF_DUMMY_SYS_reg   (*((volatile unsigned int*) NF_DUMMY_SYS_reg))
+#define NF_DUMMY_SYS_inst_adr                                                    "0x00CB"
+#define NF_DUMMY_SYS_inst                                                        0x00CB
+#define NF_DUMMY_SYS_dmy_shift                                                   (0)
+#define NF_DUMMY_SYS_dmy_mask                                                    (0xFFFFFFFF)
+#define NF_DUMMY_SYS_dmy(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define NF_DUMMY_SYS_dmy_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define NF_DUMMY_SYS_get_dmy(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define NF_DBG                                                                   0x18010344
+#define NF_DBG_reg_addr                                                          "0xB8010344"
+#define NF_DBG_reg                                                               0xB8010344
+#define set_NF_DBG_reg(data)   (*((volatile unsigned int*) NF_DBG_reg)=data)
+#define get_NF_DBG_reg   (*((volatile unsigned int*) NF_DBG_reg))
+#define NF_DBG_inst_adr                                                          "0x00D1"
+#define NF_DBG_inst                                                              0x00D1
+#define NF_DBG_write_enable3_shift                                               (9)
+#define NF_DBG_write_enable3_mask                                                (0x00000200)
+#define NF_DBG_write_enable3(data)                                               (0x00000200&((data)<<9))
+#define NF_DBG_write_enable3_src(data)                                           ((0x00000200&(data))>>9)
+#define NF_DBG_get_write_enable3(data)                                           ((0x00000200&(data))>>9)
+#define NF_DBG_sel1_shift                                                        (6)
+#define NF_DBG_sel1_mask                                                         (0x000001C0)
+#define NF_DBG_sel1(data)                                                        (0x000001C0&((data)<<6))
+#define NF_DBG_sel1_src(data)                                                    ((0x000001C0&(data))>>6)
+#define NF_DBG_get_sel1(data)                                                    ((0x000001C0&(data))>>6)
+#define NF_DBG_write_enable2_shift                                               (5)
+#define NF_DBG_write_enable2_mask                                                (0x00000020)
+#define NF_DBG_write_enable2(data)                                               (0x00000020&((data)<<5))
+#define NF_DBG_write_enable2_src(data)                                           ((0x00000020&(data))>>5)
+#define NF_DBG_get_write_enable2(data)                                           ((0x00000020&(data))>>5)
+#define NF_DBG_sel0_shift                                                        (2)
+#define NF_DBG_sel0_mask                                                         (0x0000001C)
+#define NF_DBG_sel0(data)                                                        (0x0000001C&((data)<<2))
+#define NF_DBG_sel0_src(data)                                                    ((0x0000001C&(data))>>2)
+#define NF_DBG_get_sel0(data)                                                    ((0x0000001C&(data))>>2)
+#define NF_DBG_write_enable1_shift                                               (1)
+#define NF_DBG_write_enable1_mask                                                (0x00000002)
+#define NF_DBG_write_enable1(data)                                               (0x00000002&((data)<<1))
+#define NF_DBG_write_enable1_src(data)                                           ((0x00000002&(data))>>1)
+#define NF_DBG_get_write_enable1(data)                                           ((0x00000002&(data))>>1)
+#define NF_DBG_enable_shift                                                      (0)
+#define NF_DBG_enable_mask                                                       (0x00000001)
+#define NF_DBG_enable(data)                                                      (0x00000001&((data)<<0))
+#define NF_DBG_enable_src(data)                                                  ((0x00000001&(data))>>0)
+#define NF_DBG_get_enable(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define NF_SPR_DDR_CTL                                                           0x18010348
+#define NF_SPR_DDR_CTL_reg_addr                                                  "0xB8010348"
+#define NF_SPR_DDR_CTL_reg                                                       0xB8010348
+#define set_NF_SPR_DDR_CTL_reg(data)   (*((volatile unsigned int*) NF_SPR_DDR_CTL_reg)=data)
+#define get_NF_SPR_DDR_CTL_reg   (*((volatile unsigned int*) NF_SPR_DDR_CTL_reg))
+#define NF_SPR_DDR_CTL_inst_adr                                                  "0x00D2"
+#define NF_SPR_DDR_CTL_inst                                                      0x00D2
+#define NF_SPR_DDR_CTL_cr_nf_hw_pinmux_ena_shift                                 (30)
+#define NF_SPR_DDR_CTL_cr_nf_hw_pinmux_ena_mask                                  (0x40000000)
+#define NF_SPR_DDR_CTL_cr_nf_hw_pinmux_ena(data)                                 (0x40000000&((data)<<30))
+#define NF_SPR_DDR_CTL_cr_nf_hw_pinmux_ena_src(data)                             ((0x40000000&(data))>>30)
+#define NF_SPR_DDR_CTL_get_cr_nf_hw_pinmux_ena(data)                             ((0x40000000&(data))>>30)
+#define NF_SPR_DDR_CTL_spare_ddr_ena_shift                                       (29)
+#define NF_SPR_DDR_CTL_spare_ddr_ena_mask                                        (0x20000000)
+#define NF_SPR_DDR_CTL_spare_ddr_ena(data)                                       (0x20000000&((data)<<29))
+#define NF_SPR_DDR_CTL_spare_ddr_ena_src(data)                                   ((0x20000000&(data))>>29)
+#define NF_SPR_DDR_CTL_get_spare_ddr_ena(data)                                   ((0x20000000&(data))>>29)
+#define NF_SPR_DDR_CTL_per_2k_spr_ena_shift                                      (28)
+#define NF_SPR_DDR_CTL_per_2k_spr_ena_mask                                       (0x10000000)
+#define NF_SPR_DDR_CTL_per_2k_spr_ena(data)                                      (0x10000000&((data)<<28))
+#define NF_SPR_DDR_CTL_per_2k_spr_ena_src(data)                                  ((0x10000000&(data))>>28)
+#define NF_SPR_DDR_CTL_get_per_2k_spr_ena(data)                                  ((0x10000000&(data))>>28)
+#define NF_SPR_DDR_CTL_spare_dram_sa_shift                                       (0)
+#define NF_SPR_DDR_CTL_spare_dram_sa_mask                                        (0x0FFFFFFF)
+#define NF_SPR_DDR_CTL_spare_dram_sa(data)                                       (0x0FFFFFFF&((data)<<0))
+#define NF_SPR_DDR_CTL_spare_dram_sa_src(data)                                   ((0x0FFFFFFF&(data))>>0)
+#define NF_SPR_DDR_CTL_get_spare_dram_sa(data)                                   ((0x0FFFFFFF&(data))>>0)
+
+
+#define NF_CP_LEN                                                                0x1801034C
+#define NF_CP_LEN_reg_addr                                                       "0xB801034C"
+#define NF_CP_LEN_reg                                                            0xB801034C
+#define set_NF_CP_LEN_reg(data)   (*((volatile unsigned int*) NF_CP_LEN_reg)=data)
+#define get_NF_CP_LEN_reg   (*((volatile unsigned int*) NF_CP_LEN_reg))
+#define NF_CP_LEN_inst_adr                                                       "0x00D3"
+#define NF_CP_LEN_inst                                                           0x00D3
+#define NF_CP_LEN_cp_length_shift                                                (9)
+#define NF_CP_LEN_cp_length_mask                                                 (0x01FFFE00)
+#define NF_CP_LEN_cp_length(data)                                                (0x01FFFE00&((data)<<9))
+#define NF_CP_LEN_cp_length_src(data)                                            ((0x01FFFE00&(data))>>9)
+#define NF_CP_LEN_get_cp_length(data)                                            ((0x01FFFE00&(data))>>9)
+
+
+#define NF_BIST_CTRL                                                             0x18010360
+#define NF_BIST_CTRL_reg_addr                                                    "0xB8010360"
+#define NF_BIST_CTRL_reg                                                         0xB8010360
+#define set_NF_BIST_CTRL_reg(data)   (*((volatile unsigned int*) NF_BIST_CTRL_reg)=data)
+#define get_NF_BIST_CTRL_reg   (*((volatile unsigned int*) NF_BIST_CTRL_reg))
+#define NF_BIST_CTRL_inst_adr                                                    "0x00D8"
+#define NF_BIST_CTRL_inst                                                        0x00D8
+#define NF_BIST_CTRL_bist2_drf_test_resume_shift                                 (6)
+#define NF_BIST_CTRL_bist2_drf_test_resume_mask                                  (0x00000040)
+#define NF_BIST_CTRL_bist2_drf_test_resume(data)                                 (0x00000040&((data)<<6))
+#define NF_BIST_CTRL_bist2_drf_test_resume_src(data)                             ((0x00000040&(data))>>6)
+#define NF_BIST_CTRL_get_bist2_drf_test_resume(data)                             ((0x00000040&(data))>>6)
+#define NF_BIST_CTRL_bist2_drf_en_shift                                          (5)
+#define NF_BIST_CTRL_bist2_drf_en_mask                                           (0x00000020)
+#define NF_BIST_CTRL_bist2_drf_en(data)                                          (0x00000020&((data)<<5))
+#define NF_BIST_CTRL_bist2_drf_en_src(data)                                      ((0x00000020&(data))>>5)
+#define NF_BIST_CTRL_get_bist2_drf_en(data)                                      ((0x00000020&(data))>>5)
+#define NF_BIST_CTRL_bist2_en_shift                                              (4)
+#define NF_BIST_CTRL_bist2_en_mask                                               (0x00000010)
+#define NF_BIST_CTRL_bist2_en(data)                                              (0x00000010&((data)<<4))
+#define NF_BIST_CTRL_bist2_en_src(data)                                          ((0x00000010&(data))>>4)
+#define NF_BIST_CTRL_get_bist2_en(data)                                          ((0x00000010&(data))>>4)
+#define NF_BIST_CTRL_bist1_drf_test_resume_shift                                 (2)
+#define NF_BIST_CTRL_bist1_drf_test_resume_mask                                  (0x00000004)
+#define NF_BIST_CTRL_bist1_drf_test_resume(data)                                 (0x00000004&((data)<<2))
+#define NF_BIST_CTRL_bist1_drf_test_resume_src(data)                             ((0x00000004&(data))>>2)
+#define NF_BIST_CTRL_get_bist1_drf_test_resume(data)                             ((0x00000004&(data))>>2)
+#define NF_BIST_CTRL_bist1_drf_en_shift                                          (1)
+#define NF_BIST_CTRL_bist1_drf_en_mask                                           (0x00000002)
+#define NF_BIST_CTRL_bist1_drf_en(data)                                          (0x00000002&((data)<<1))
+#define NF_BIST_CTRL_bist1_drf_en_src(data)                                      ((0x00000002&(data))>>1)
+#define NF_BIST_CTRL_get_bist1_drf_en(data)                                      ((0x00000002&(data))>>1)
+#define NF_BIST_CTRL_bist1_en_shift                                              (0)
+#define NF_BIST_CTRL_bist1_en_mask                                               (0x00000001)
+#define NF_BIST_CTRL_bist1_en(data)                                              (0x00000001&((data)<<0))
+#define NF_BIST_CTRL_bist1_en_src(data)                                          ((0x00000001&(data))>>0)
+#define NF_BIST_CTRL_get_bist1_en(data)                                          ((0x00000001&(data))>>0)
+
+
+#define NF_BIST_RM                                                               0x18010364
+#define NF_BIST_RM_reg_addr                                                      "0xB8010364"
+#define NF_BIST_RM_reg                                                           0xB8010364
+#define set_NF_BIST_RM_reg(data)   (*((volatile unsigned int*) NF_BIST_RM_reg)=data)
+#define get_NF_BIST_RM_reg   (*((volatile unsigned int*) NF_BIST_RM_reg))
+#define NF_BIST_RM_inst_adr                                                      "0x00D9"
+#define NF_BIST_RM_inst                                                          0x00D9
+#define NF_BIST_RM_RME_shift                                                     (4)
+#define NF_BIST_RM_RME_mask                                                      (0x00000010)
+#define NF_BIST_RM_RME(data)                                                     (0x00000010&((data)<<4))
+#define NF_BIST_RM_RME_src(data)                                                 ((0x00000010&(data))>>4)
+#define NF_BIST_RM_get_RME(data)                                                 ((0x00000010&(data))>>4)
+#define NF_BIST_RM_RM_3_shift                                                    (3)
+#define NF_BIST_RM_RM_3_mask                                                     (0x00000008)
+#define NF_BIST_RM_RM_3(data)                                                    (0x00000008&((data)<<3))
+#define NF_BIST_RM_RM_3_src(data)                                                ((0x00000008&(data))>>3)
+#define NF_BIST_RM_get_RM_3(data)                                                ((0x00000008&(data))>>3)
+#define NF_BIST_RM_RM_2_shift                                                    (2)
+#define NF_BIST_RM_RM_2_mask                                                     (0x00000004)
+#define NF_BIST_RM_RM_2(data)                                                    (0x00000004&((data)<<2))
+#define NF_BIST_RM_RM_2_src(data)                                                ((0x00000004&(data))>>2)
+#define NF_BIST_RM_get_RM_2(data)                                                ((0x00000004&(data))>>2)
+#define NF_BIST_RM_RM_1_shift                                                    (1)
+#define NF_BIST_RM_RM_1_mask                                                     (0x00000002)
+#define NF_BIST_RM_RM_1(data)                                                    (0x00000002&((data)<<1))
+#define NF_BIST_RM_RM_1_src(data)                                                ((0x00000002&(data))>>1)
+#define NF_BIST_RM_get_RM_1(data)                                                ((0x00000002&(data))>>1)
+#define NF_BIST_RM_RM_0_shift                                                    (0)
+#define NF_BIST_RM_RM_0_mask                                                     (0x00000001)
+#define NF_BIST_RM_RM_0(data)                                                    (0x00000001&((data)<<0))
+#define NF_BIST_RM_RM_0_src(data)                                                ((0x00000001&(data))>>0)
+#define NF_BIST_RM_get_RM_0(data)                                                ((0x00000001&(data))>>0)
+
+
+#define NF_BIST_ST1                                                              0x18010368
+#define NF_BIST_ST1_reg_addr                                                     "0xB8010368"
+#define NF_BIST_ST1_reg                                                          0xB8010368
+#define set_NF_BIST_ST1_reg(data)   (*((volatile unsigned int*) NF_BIST_ST1_reg)=data)
+#define get_NF_BIST_ST1_reg   (*((volatile unsigned int*) NF_BIST_ST1_reg))
+#define NF_BIST_ST1_inst_adr                                                     "0x00DA"
+#define NF_BIST_ST1_inst                                                         0x00DA
+#define NF_BIST_ST1_bist1_fail1_shift                                            (2)
+#define NF_BIST_ST1_bist1_fail1_mask                                             (0x00000004)
+#define NF_BIST_ST1_bist1_fail1(data)                                            (0x00000004&((data)<<2))
+#define NF_BIST_ST1_bist1_fail1_src(data)                                        ((0x00000004&(data))>>2)
+#define NF_BIST_ST1_get_bist1_fail1(data)                                        ((0x00000004&(data))>>2)
+#define NF_BIST_ST1_bist1_fail0_shift                                            (1)
+#define NF_BIST_ST1_bist1_fail0_mask                                             (0x00000002)
+#define NF_BIST_ST1_bist1_fail0(data)                                            (0x00000002&((data)<<1))
+#define NF_BIST_ST1_bist1_fail0_src(data)                                        ((0x00000002&(data))>>1)
+#define NF_BIST_ST1_get_bist1_fail0(data)                                        ((0x00000002&(data))>>1)
+#define NF_BIST_ST1_bist1_done_shift                                             (0)
+#define NF_BIST_ST1_bist1_done_mask                                              (0x00000001)
+#define NF_BIST_ST1_bist1_done(data)                                             (0x00000001&((data)<<0))
+#define NF_BIST_ST1_bist1_done_src(data)                                         ((0x00000001&(data))>>0)
+#define NF_BIST_ST1_get_bist1_done(data)                                         ((0x00000001&(data))>>0)
+
+
+#define NF_BIST_ST2                                                              0x1801036C
+#define NF_BIST_ST2_reg_addr                                                     "0xB801036C"
+#define NF_BIST_ST2_reg                                                          0xB801036C
+#define set_NF_BIST_ST2_reg(data)   (*((volatile unsigned int*) NF_BIST_ST2_reg)=data)
+#define get_NF_BIST_ST2_reg   (*((volatile unsigned int*) NF_BIST_ST2_reg))
+#define NF_BIST_ST2_inst_adr                                                     "0x00DB"
+#define NF_BIST_ST2_inst                                                         0x00DB
+#define NF_BIST_ST2_bist2_fail0_shift                                            (1)
+#define NF_BIST_ST2_bist2_fail0_mask                                             (0x00000002)
+#define NF_BIST_ST2_bist2_fail0(data)                                            (0x00000002&((data)<<1))
+#define NF_BIST_ST2_bist2_fail0_src(data)                                        ((0x00000002&(data))>>1)
+#define NF_BIST_ST2_get_bist2_fail0(data)                                        ((0x00000002&(data))>>1)
+#define NF_BIST_ST2_bist2_done_shift                                             (0)
+#define NF_BIST_ST2_bist2_done_mask                                              (0x00000001)
+#define NF_BIST_ST2_bist2_done(data)                                             (0x00000001&((data)<<0))
+#define NF_BIST_ST2_bist2_done_src(data)                                         ((0x00000001&(data))>>0)
+#define NF_BIST_ST2_get_bist2_done(data)                                         ((0x00000001&(data))>>0)
+
+
+#define NF_DRF_ST1                                                               0x18010370
+#define NF_DRF_ST1_reg_addr                                                      "0xB8010370"
+#define NF_DRF_ST1_reg                                                           0xB8010370
+#define set_NF_DRF_ST1_reg(data)   (*((volatile unsigned int*) NF_DRF_ST1_reg)=data)
+#define get_NF_DRF_ST1_reg   (*((volatile unsigned int*) NF_DRF_ST1_reg))
+#define NF_DRF_ST1_inst_adr                                                      "0x00DC"
+#define NF_DRF_ST1_inst                                                          0x00DC
+#define NF_DRF_ST1_drf_bist1_start_pause_shift                                   (16)
+#define NF_DRF_ST1_drf_bist1_start_pause_mask                                    (0x00010000)
+#define NF_DRF_ST1_drf_bist1_start_pause(data)                                   (0x00010000&((data)<<16))
+#define NF_DRF_ST1_drf_bist1_start_pause_src(data)                               ((0x00010000&(data))>>16)
+#define NF_DRF_ST1_get_drf_bist1_start_pause(data)                               ((0x00010000&(data))>>16)
+#define NF_DRF_ST1_drf_bist1_fail1_shift                                         (2)
+#define NF_DRF_ST1_drf_bist1_fail1_mask                                          (0x00000004)
+#define NF_DRF_ST1_drf_bist1_fail1(data)                                         (0x00000004&((data)<<2))
+#define NF_DRF_ST1_drf_bist1_fail1_src(data)                                     ((0x00000004&(data))>>2)
+#define NF_DRF_ST1_get_drf_bist1_fail1(data)                                     ((0x00000004&(data))>>2)
+#define NF_DRF_ST1_drf_bist1_fail0_shift                                         (1)
+#define NF_DRF_ST1_drf_bist1_fail0_mask                                          (0x00000002)
+#define NF_DRF_ST1_drf_bist1_fail0(data)                                         (0x00000002&((data)<<1))
+#define NF_DRF_ST1_drf_bist1_fail0_src(data)                                     ((0x00000002&(data))>>1)
+#define NF_DRF_ST1_get_drf_bist1_fail0(data)                                     ((0x00000002&(data))>>1)
+#define NF_DRF_ST1_drf_bist1_done_shift                                          (0)
+#define NF_DRF_ST1_drf_bist1_done_mask                                           (0x00000001)
+#define NF_DRF_ST1_drf_bist1_done(data)                                          (0x00000001&((data)<<0))
+#define NF_DRF_ST1_drf_bist1_done_src(data)                                      ((0x00000001&(data))>>0)
+#define NF_DRF_ST1_get_drf_bist1_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#define NF_DRF_ST2                                                               0x18010374
+#define NF_DRF_ST2_reg_addr                                                      "0xB8010374"
+#define NF_DRF_ST2_reg                                                           0xB8010374
+#define set_NF_DRF_ST2_reg(data)   (*((volatile unsigned int*) NF_DRF_ST2_reg)=data)
+#define get_NF_DRF_ST2_reg   (*((volatile unsigned int*) NF_DRF_ST2_reg))
+#define NF_DRF_ST2_inst_adr                                                      "0x00DD"
+#define NF_DRF_ST2_inst                                                          0x00DD
+#define NF_DRF_ST2_drf_bist2_start_pause_shift                                   (16)
+#define NF_DRF_ST2_drf_bist2_start_pause_mask                                    (0x00010000)
+#define NF_DRF_ST2_drf_bist2_start_pause(data)                                   (0x00010000&((data)<<16))
+#define NF_DRF_ST2_drf_bist2_start_pause_src(data)                               ((0x00010000&(data))>>16)
+#define NF_DRF_ST2_get_drf_bist2_start_pause(data)                               ((0x00010000&(data))>>16)
+#define NF_DRF_ST2_drf_bist2_fail0_shift                                         (1)
+#define NF_DRF_ST2_drf_bist2_fail0_mask                                          (0x00000002)
+#define NF_DRF_ST2_drf_bist2_fail0(data)                                         (0x00000002&((data)<<1))
+#define NF_DRF_ST2_drf_bist2_fail0_src(data)                                     ((0x00000002&(data))>>1)
+#define NF_DRF_ST2_get_drf_bist2_fail0(data)                                     ((0x00000002&(data))>>1)
+#define NF_DRF_ST2_drf_bist2_done_shift                                          (0)
+#define NF_DRF_ST2_drf_bist2_done_mask                                           (0x00000001)
+#define NF_DRF_ST2_drf_bist2_done(data)                                          (0x00000001&((data)<<0))
+#define NF_DRF_ST2_drf_bist2_done_src(data)                                      ((0x00000001&(data))>>0)
+#define NF_DRF_ST2_get_drf_bist2_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/nf_swc_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/nf_swc_reg.h
new file mode 100644
index 00000000..6d5d335
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/nf_swc_reg.h
@@ -0,0 +1,1657 @@
+/**************************************************************
+// Spec Version                  : 0.0.4
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/8/26 11:25:32
+***************************************************************/
+
+
+#ifndef _NF_SWC_REG_H_INCLUDED_
+#define _NF_SWC_REG_H_INCLUDED_
+#ifdef  _NF_SWC_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     page_addr0:8;
+}NF_SWC_ND_PA0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     page_addr1:8;
+}NF_SWC_ND_PA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     addr_mode:3;
+unsigned int     page_addr2:5;
+}NF_SWC_ND_PA2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     col_addr0:8;
+}NF_SWC_ND_CA0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cmd:8;
+}NF_SWC_ND_CMD;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dat:8;
+}NF_SWC_ND_DAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     xfer:1;
+unsigned int     ready_busy:1;
+unsigned int     ecc_tran:1;
+unsigned int     reserved_1:1;
+unsigned int     ecc_enable:1;
+unsigned int     tran_mode:3;
+}NF_SWC_ND_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     blank_zero_num:5;
+}NF_SWC_BLANK_ZERO_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cmd3:8;
+}NF_SWC_CMD3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     page_addr3:3;
+unsigned int     reserved_1:5;
+}NF_SWC_ND_PA3;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     bit_sel:3;
+unsigned int     trig_poll:1;
+}NF_SWC_POLL_FSTS;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     blank_zero_over:1;
+unsigned int     read_ecc_xnor_ena:1;
+unsigned int     blank_all_one:1;
+unsigned int     blank_ena:1;
+}NF_SWC_BLANK_CHK;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     ecc_not_clr:1;
+unsigned int     ecc_err:1;
+unsigned int     reserved_1:2;
+}NF_SWC_ND_ECC;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     col_addr1:8;
+}NF_SWC_ND_CA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     length0:8;
+}NF_SWC_DATA_TL0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     access_mode:1;
+unsigned int     reserved_1:1;
+unsigned int     length1:6;
+}NF_SWC_DATA_TL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     eot_gen:1;
+unsigned int     dma_max_pkt:1;
+unsigned int     spec_pkt:1;
+unsigned int     reserved_1:1;
+}NF_SWC_DMA1_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     pp_start_addr:3;
+unsigned int     reserved_1:1;
+unsigned int     pp_busy:1;
+unsigned int     pp_reset:1;
+unsigned int     pp_enable:1;
+}NF_SWC_PP_CTL0;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     ecc_bch_72b_mode:3;
+unsigned int     ecc_bch_12b_ena:1;
+}NF_SWC_ECC_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     pp_start_addr:8;
+}NF_SWC_PP_CTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     pd:5;
+}NF_SWC_PD;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     pp_lp_mode:1;
+unsigned int     pp_lp_ena:1;
+unsigned int     ecc_clk_gate_ena:1;
+unsigned int     ip_clk_gate_ena:1;
+unsigned int     dma_clk_gate_ena:1;
+unsigned int     pp_sram_rdy_num:3;
+}NF_SWC_NF_LOW_PWR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Dmy1:8;
+}NF_SWC_DUMMY_NF1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Dmy2:8;
+}NF_SWC_DUMMY_NF2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Dmy3:8;
+}NF_SWC_DUMMY_NF3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     Dmy4:8;
+}NF_SWC_DUMMY_NF4;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     auto_trig:1;
+unsigned int     addr_fbd:1;
+unsigned int     pp_empty:1;
+unsigned int     spec_auto_case:2;
+unsigned int     auto_case:3;
+}NF_SWC_AUTO_TRIG;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ecc_num:8;
+}NF_SWC_RSECC_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rnd_cmd1:8;
+}NF_SWC_RND_CMD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rnd_cmd2:8;
+}NF_SWC_RND_CMD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     data_col_msb:8;
+}NF_SWC_RND_DATASTR_COL_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     spr_col_msb:8;
+}NF_SWC_RND_SPR_STR_COL_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     spr_col_lsb:8;
+}NF_SWC_RND_SPR_STR_COL_L;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     rnd_rw_enable:1;
+}NF_SWC_RND_RW_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     read_by_pp:1;
+unsigned int     reserved_1:7;
+}NF_SWC_READ_BY_PP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     max_ecc_num:8;
+}NF_SWC_MAX_ECC_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     T3:8;
+}NF_SWC_TIME_PARA3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     T2:8;
+}NF_SWC_TIME_PARA2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     T1:8;
+}NF_SWC_TIME_PARA1;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     rand_ready:1;
+unsigned int     rand_en:1;
+}NF_SWC_RMZ_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rand_seed_low:8;
+}NF_SWC_RMZ_SEED_L;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     rand_seed_hi:7;
+}NF_SWC_RMZ_SEED_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     rand_seed_from_reg:1;
+unsigned int     reserved_1:1;
+unsigned int     rand_seed_num:3;
+}NF_SWC_RMZ_SEED_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     pin_stop:1;
+unsigned int     intlev_pin_ena:1;
+unsigned int     pin_mux_ena:1;
+}NF_SWC_PIN_MUX_STOP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     T_swait_busy:2;
+unsigned int     T_WHR_ADL:6;
+}NF_SWC_DELAY_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ecc_n_stop:1;
+unsigned int     reserved_1:7;
+}NF_SWC_ECC_STOP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ecc_page:8;
+}NF_SWC_ECC_PAGE;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     page_cnt:8;
+}NF_SWC_PAGE_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     page_len:8;
+}NF_SWC_PAGE_LEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cmd2:8;
+}NF_SWC_CMD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ecc_pass:1;
+unsigned int     ecc_no_check:1;
+unsigned int     edo:1;
+unsigned int     no_wait_busy:1;
+unsigned int     wait_ready:2;
+unsigned int     reserved_1:2;
+}NF_SWC_MULTI_CHNL_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     map_sel:1;
+unsigned int     access_en:1;
+unsigned int     mem_region:4;
+}NF_SWC_SRAM_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dram_sa:28;
+}NF_SWC_DMA_CTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     dma_len:16;
+}NF_SWC_DMA_CTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cp_first:1;
+unsigned int     cp_enable:1;
+unsigned int     ddr_wr:1;
+unsigned int     dma_xfer:1;
+}NF_SWC_DMA_CTL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mcu_pp_sram_lp_ena:1;
+unsigned int     sys_clk_gate_ena:1;
+unsigned int     cp_clk_gate_ena:1;
+unsigned int     dma_sram_lp_ena:1;
+unsigned int     dma_sram_rdy_num:4;
+}NF_SWC_SYS_LOW_PWR;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     Int8:1;
+unsigned int     Int7:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     Int4:1;
+unsigned int     Int3:1;
+unsigned int     Int2:1;
+unsigned int     Int1:1;
+unsigned int     write_data:1;
+}NF_SWC_NAND_ISR;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     Int8En:1;
+unsigned int     Int7En:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     Int4En:1;
+unsigned int     Int3En:1;
+unsigned int     Int2En:1;
+unsigned int     Int1En:1;
+unsigned int     write_data:1;
+}NF_SWC_NAND_ISREN;
+
+typedef struct 
+{
+unsigned int     dmy:32;
+}NF_SWC_DUMMY_SYS;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_enable3:1;
+unsigned int     sel1:3;
+unsigned int     write_enable2:1;
+unsigned int     sel0:3;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}NF_SWC_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     cr_nf_hw_pinmux_ena:1;
+unsigned int     spare_ddr_ena:1;
+unsigned int     per_2k_spr_ena:1;
+unsigned int     spare_dram_sa:28;
+}NF_SWC_SPR_DDR_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     cp_length:16;
+unsigned int     reserved_1:9;
+}NF_SWC_CP_LEN;
+
+#endif
+
+#define NF_SWC_ND_PA0                                                                0x1802F000
+#define NF_SWC_ND_PA0_reg_addr                                                       "0xB802F000"
+#define NF_SWC_ND_PA0_reg                                                            0xB802F000
+#define set_NF_SWC_ND_PA0_reg(data)   (*((volatile unsigned int*) NF_SWC_ND_PA0_reg)=data)
+#define get_NF_SWC_ND_PA0_reg   (*((volatile unsigned int*) NF_SWC_ND_PA0_reg))
+#define NF_SWC_ND_PA0_inst_adr                                                       "0x0000"
+#define NF_SWC_ND_PA0_inst                                                           0x0000
+#define NF_SWC_ND_PA0_page_addr0_shift                                               (0)
+#define NF_SWC_ND_PA0_page_addr0_mask                                                (0x000000FF)
+#define NF_SWC_ND_PA0_page_addr0(data)                                               (0x000000FF&((data)<<0))
+#define NF_SWC_ND_PA0_page_addr0_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_SWC_ND_PA0_get_page_addr0(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_ND_PA1                                                                0x1802F004
+#define NF_SWC_ND_PA1_reg_addr                                                       "0xB802F004"
+#define NF_SWC_ND_PA1_reg                                                            0xB802F004
+#define set_NF_SWC_ND_PA1_reg(data)   (*((volatile unsigned int*) NF_SWC_ND_PA1_reg)=data)
+#define get_NF_SWC_ND_PA1_reg   (*((volatile unsigned int*) NF_SWC_ND_PA1_reg))
+#define NF_SWC_ND_PA1_inst_adr                                                       "0x0001"
+#define NF_SWC_ND_PA1_inst                                                           0x0001
+#define NF_SWC_ND_PA1_page_addr1_shift                                               (0)
+#define NF_SWC_ND_PA1_page_addr1_mask                                                (0x000000FF)
+#define NF_SWC_ND_PA1_page_addr1(data)                                               (0x000000FF&((data)<<0))
+#define NF_SWC_ND_PA1_page_addr1_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_SWC_ND_PA1_get_page_addr1(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_ND_PA2                                                                0x1802F008
+#define NF_SWC_ND_PA2_reg_addr                                                       "0xB802F008"
+#define NF_SWC_ND_PA2_reg                                                            0xB802F008
+#define set_NF_SWC_ND_PA2_reg(data)   (*((volatile unsigned int*) NF_SWC_ND_PA2_reg)=data)
+#define get_NF_SWC_ND_PA2_reg   (*((volatile unsigned int*) NF_SWC_ND_PA2_reg))
+#define NF_SWC_ND_PA2_inst_adr                                                       "0x0002"
+#define NF_SWC_ND_PA2_inst                                                           0x0002
+#define NF_SWC_ND_PA2_addr_mode_shift                                                (5)
+#define NF_SWC_ND_PA2_addr_mode_mask                                                 (0x000000E0)
+#define NF_SWC_ND_PA2_addr_mode(data)                                                (0x000000E0&((data)<<5))
+#define NF_SWC_ND_PA2_addr_mode_src(data)                                            ((0x000000E0&(data))>>5)
+#define NF_SWC_ND_PA2_get_addr_mode(data)                                            ((0x000000E0&(data))>>5)
+#define NF_SWC_ND_PA2_page_addr2_shift                                               (0)
+#define NF_SWC_ND_PA2_page_addr2_mask                                                (0x0000001F)
+#define NF_SWC_ND_PA2_page_addr2(data)                                               (0x0000001F&((data)<<0))
+#define NF_SWC_ND_PA2_page_addr2_src(data)                                           ((0x0000001F&(data))>>0)
+#define NF_SWC_ND_PA2_get_page_addr2(data)                                           ((0x0000001F&(data))>>0)
+
+
+#define NF_SWC_ND_CA0                                                                0x1802F00C
+#define NF_SWC_ND_CA0_reg_addr                                                       "0xB802F00C"
+#define NF_SWC_ND_CA0_reg                                                            0xB802F00C
+#define set_NF_SWC_ND_CA0_reg(data)   (*((volatile unsigned int*) NF_SWC_ND_CA0_reg)=data)
+#define get_NF_SWC_ND_CA0_reg   (*((volatile unsigned int*) NF_SWC_ND_CA0_reg))
+#define NF_SWC_ND_CA0_inst_adr                                                       "0x0003"
+#define NF_SWC_ND_CA0_inst                                                           0x0003
+#define NF_SWC_ND_CA0_col_addr0_shift                                                (0)
+#define NF_SWC_ND_CA0_col_addr0_mask                                                 (0x000000FF)
+#define NF_SWC_ND_CA0_col_addr0(data)                                                (0x000000FF&((data)<<0))
+#define NF_SWC_ND_CA0_col_addr0_src(data)                                            ((0x000000FF&(data))>>0)
+#define NF_SWC_ND_CA0_get_col_addr0(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_ND_CMD                                                                0x1802F010
+#define NF_SWC_ND_CMD_reg_addr                                                       "0xB802F010"
+#define NF_SWC_ND_CMD_reg                                                            0xB802F010
+#define set_NF_SWC_ND_CMD_reg(data)   (*((volatile unsigned int*) NF_SWC_ND_CMD_reg)=data)
+#define get_NF_SWC_ND_CMD_reg   (*((volatile unsigned int*) NF_SWC_ND_CMD_reg))
+#define NF_SWC_ND_CMD_inst_adr                                                       "0x0004"
+#define NF_SWC_ND_CMD_inst                                                           0x0004
+#define NF_SWC_ND_CMD_cmd_shift                                                      (0)
+#define NF_SWC_ND_CMD_cmd_mask                                                       (0x000000FF)
+#define NF_SWC_ND_CMD_cmd(data)                                                      (0x000000FF&((data)<<0))
+#define NF_SWC_ND_CMD_cmd_src(data)                                                  ((0x000000FF&(data))>>0)
+#define NF_SWC_ND_CMD_get_cmd(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_ND_DAT                                                                0x1802F014
+#define NF_SWC_ND_DAT_reg_addr                                                       "0xB802F014"
+#define NF_SWC_ND_DAT_reg                                                            0xB802F014
+#define set_NF_SWC_ND_DAT_reg(data)   (*((volatile unsigned int*) NF_SWC_ND_DAT_reg)=data)
+#define get_NF_SWC_ND_DAT_reg   (*((volatile unsigned int*) NF_SWC_ND_DAT_reg))
+#define NF_SWC_ND_DAT_inst_adr                                                       "0x0005"
+#define NF_SWC_ND_DAT_inst                                                           0x0005
+#define NF_SWC_ND_DAT_dat_shift                                                      (0)
+#define NF_SWC_ND_DAT_dat_mask                                                       (0x000000FF)
+#define NF_SWC_ND_DAT_dat(data)                                                      (0x000000FF&((data)<<0))
+#define NF_SWC_ND_DAT_dat_src(data)                                                  ((0x000000FF&(data))>>0)
+#define NF_SWC_ND_DAT_get_dat(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_ND_CTL                                                                0x1802F018
+#define NF_SWC_ND_CTL_reg_addr                                                       "0xB802F018"
+#define NF_SWC_ND_CTL_reg                                                            0xB802F018
+#define set_NF_SWC_ND_CTL_reg(data)   (*((volatile unsigned int*) NF_SWC_ND_CTL_reg)=data)
+#define get_NF_SWC_ND_CTL_reg   (*((volatile unsigned int*) NF_SWC_ND_CTL_reg))
+#define NF_SWC_ND_CTL_inst_adr                                                       "0x0006"
+#define NF_SWC_ND_CTL_inst                                                           0x0006
+#define NF_SWC_ND_CTL_xfer_shift                                                     (7)
+#define NF_SWC_ND_CTL_xfer_mask                                                      (0x00000080)
+#define NF_SWC_ND_CTL_xfer(data)                                                     (0x00000080&((data)<<7))
+#define NF_SWC_ND_CTL_xfer_src(data)                                                 ((0x00000080&(data))>>7)
+#define NF_SWC_ND_CTL_get_xfer(data)                                                 ((0x00000080&(data))>>7)
+#define NF_SWC_ND_CTL_ready_busy_shift                                               (6)
+#define NF_SWC_ND_CTL_ready_busy_mask                                                (0x00000040)
+#define NF_SWC_ND_CTL_ready_busy(data)                                               (0x00000040&((data)<<6))
+#define NF_SWC_ND_CTL_ready_busy_src(data)                                           ((0x00000040&(data))>>6)
+#define NF_SWC_ND_CTL_get_ready_busy(data)                                           ((0x00000040&(data))>>6)
+#define NF_SWC_ND_CTL_ecc_tran_shift                                                 (5)
+#define NF_SWC_ND_CTL_ecc_tran_mask                                                  (0x00000020)
+#define NF_SWC_ND_CTL_ecc_tran(data)                                                 (0x00000020&((data)<<5))
+#define NF_SWC_ND_CTL_ecc_tran_src(data)                                             ((0x00000020&(data))>>5)
+#define NF_SWC_ND_CTL_get_ecc_tran(data)                                             ((0x00000020&(data))>>5)
+#define NF_SWC_ND_CTL_ecc_enable_shift                                               (3)
+#define NF_SWC_ND_CTL_ecc_enable_mask                                                (0x00000008)
+#define NF_SWC_ND_CTL_ecc_enable(data)                                               (0x00000008&((data)<<3))
+#define NF_SWC_ND_CTL_ecc_enable_src(data)                                           ((0x00000008&(data))>>3)
+#define NF_SWC_ND_CTL_get_ecc_enable(data)                                           ((0x00000008&(data))>>3)
+#define NF_SWC_ND_CTL_tran_mode_shift                                                (0)
+#define NF_SWC_ND_CTL_tran_mode_mask                                                 (0x00000007)
+#define NF_SWC_ND_CTL_tran_mode(data)                                                (0x00000007&((data)<<0))
+#define NF_SWC_ND_CTL_tran_mode_src(data)                                            ((0x00000007&(data))>>0)
+#define NF_SWC_ND_CTL_get_tran_mode(data)                                            ((0x00000007&(data))>>0)
+
+
+#define NF_SWC_BLANK_ZERO_NUM                                                        0x1802F01C
+#define NF_SWC_BLANK_ZERO_NUM_reg_addr                                               "0xB802F01C"
+#define NF_SWC_BLANK_ZERO_NUM_reg                                                    0xB802F01C
+#define set_NF_SWC_BLANK_ZERO_NUM_reg(data)   (*((volatile unsigned int*) NF_SWC_BLANK_ZERO_NUM_reg)=data)
+#define get_NF_SWC_BLANK_ZERO_NUM_reg   (*((volatile unsigned int*) NF_SWC_BLANK_ZERO_NUM_reg))
+#define NF_SWC_BLANK_ZERO_NUM_inst_adr                                               "0x0007"
+#define NF_SWC_BLANK_ZERO_NUM_inst                                                   0x0007
+#define NF_SWC_BLANK_ZERO_NUM_blank_zero_num_shift                                   (0)
+#define NF_SWC_BLANK_ZERO_NUM_blank_zero_num_mask                                    (0x0000001F)
+#define NF_SWC_BLANK_ZERO_NUM_blank_zero_num(data)                                   (0x0000001F&((data)<<0))
+#define NF_SWC_BLANK_ZERO_NUM_blank_zero_num_src(data)                               ((0x0000001F&(data))>>0)
+#define NF_SWC_BLANK_ZERO_NUM_get_blank_zero_num(data)                               ((0x0000001F&(data))>>0)
+
+
+#define NF_SWC_CMD3                                                                  0x1802F028
+#define NF_SWC_CMD3_reg_addr                                                         "0xB802F028"
+#define NF_SWC_CMD3_reg                                                              0xB802F028
+#define set_NF_SWC_CMD3_reg(data)   (*((volatile unsigned int*) NF_SWC_CMD3_reg)=data)
+#define get_NF_SWC_CMD3_reg   (*((volatile unsigned int*) NF_SWC_CMD3_reg))
+#define NF_SWC_CMD3_inst_adr                                                         "0x000A"
+#define NF_SWC_CMD3_inst                                                             0x000A
+#define NF_SWC_CMD3_cmd3_shift                                                       (0)
+#define NF_SWC_CMD3_cmd3_mask                                                        (0x000000FF)
+#define NF_SWC_CMD3_cmd3(data)                                                       (0x000000FF&((data)<<0))
+#define NF_SWC_CMD3_cmd3_src(data)                                                   ((0x000000FF&(data))>>0)
+#define NF_SWC_CMD3_get_cmd3(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_ND_PA3                                                                0x1802F02C
+#define NF_SWC_ND_PA3_reg_addr                                                       "0xB802F02C"
+#define NF_SWC_ND_PA3_reg                                                            0xB802F02C
+#define set_NF_SWC_ND_PA3_reg(data)   (*((volatile unsigned int*) NF_SWC_ND_PA3_reg)=data)
+#define get_NF_SWC_ND_PA3_reg   (*((volatile unsigned int*) NF_SWC_ND_PA3_reg))
+#define NF_SWC_ND_PA3_inst_adr                                                       "0x000B"
+#define NF_SWC_ND_PA3_inst                                                           0x000B
+#define NF_SWC_ND_PA3_page_addr3_shift                                               (5)
+#define NF_SWC_ND_PA3_page_addr3_mask                                                (0x000000E0)
+#define NF_SWC_ND_PA3_page_addr3(data)                                               (0x000000E0&((data)<<5))
+#define NF_SWC_ND_PA3_page_addr3_src(data)                                           ((0x000000E0&(data))>>5)
+#define NF_SWC_ND_PA3_get_page_addr3(data)                                           ((0x000000E0&(data))>>5)
+
+
+#define NF_SWC_POLL_FSTS                                                             0x1802F030
+#define NF_SWC_POLL_FSTS_reg_addr                                                    "0xB802F030"
+#define NF_SWC_POLL_FSTS_reg                                                         0xB802F030
+#define set_NF_SWC_POLL_FSTS_reg(data)   (*((volatile unsigned int*) NF_SWC_POLL_FSTS_reg)=data)
+#define get_NF_SWC_POLL_FSTS_reg   (*((volatile unsigned int*) NF_SWC_POLL_FSTS_reg))
+#define NF_SWC_POLL_FSTS_inst_adr                                                    "0x000C"
+#define NF_SWC_POLL_FSTS_inst                                                        0x000C
+#define NF_SWC_POLL_FSTS_bit_sel_shift                                               (1)
+#define NF_SWC_POLL_FSTS_bit_sel_mask                                                (0x0000000E)
+#define NF_SWC_POLL_FSTS_bit_sel(data)                                               (0x0000000E&((data)<<1))
+#define NF_SWC_POLL_FSTS_bit_sel_src(data)                                           ((0x0000000E&(data))>>1)
+#define NF_SWC_POLL_FSTS_get_bit_sel(data)                                           ((0x0000000E&(data))>>1)
+#define NF_SWC_POLL_FSTS_trig_poll_shift                                             (0)
+#define NF_SWC_POLL_FSTS_trig_poll_mask                                              (0x00000001)
+#define NF_SWC_POLL_FSTS_trig_poll(data)                                             (0x00000001&((data)<<0))
+#define NF_SWC_POLL_FSTS_trig_poll_src(data)                                         ((0x00000001&(data))>>0)
+#define NF_SWC_POLL_FSTS_get_trig_poll(data)                                         ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_BLANK_CHK                                                             0x1802F034
+#define NF_SWC_BLANK_CHK_reg_addr                                                    "0xB802F034"
+#define NF_SWC_BLANK_CHK_reg                                                         0xB802F034
+#define set_NF_SWC_BLANK_CHK_reg(data)   (*((volatile unsigned int*) NF_SWC_BLANK_CHK_reg)=data)
+#define get_NF_SWC_BLANK_CHK_reg   (*((volatile unsigned int*) NF_SWC_BLANK_CHK_reg))
+#define NF_SWC_BLANK_CHK_inst_adr                                                    "0x000D"
+#define NF_SWC_BLANK_CHK_inst                                                        0x000D
+#define NF_SWC_BLANK_CHK_blank_zero_over_shift                                       (3)
+#define NF_SWC_BLANK_CHK_blank_zero_over_mask                                        (0x00000008)
+#define NF_SWC_BLANK_CHK_blank_zero_over(data)                                       (0x00000008&((data)<<3))
+#define NF_SWC_BLANK_CHK_blank_zero_over_src(data)                                   ((0x00000008&(data))>>3)
+#define NF_SWC_BLANK_CHK_get_blank_zero_over(data)                                   ((0x00000008&(data))>>3)
+#define NF_SWC_BLANK_CHK_read_ecc_xnor_ena_shift                                     (2)
+#define NF_SWC_BLANK_CHK_read_ecc_xnor_ena_mask                                      (0x00000004)
+#define NF_SWC_BLANK_CHK_read_ecc_xnor_ena(data)                                     (0x00000004&((data)<<2))
+#define NF_SWC_BLANK_CHK_read_ecc_xnor_ena_src(data)                                 ((0x00000004&(data))>>2)
+#define NF_SWC_BLANK_CHK_get_read_ecc_xnor_ena(data)                                 ((0x00000004&(data))>>2)
+#define NF_SWC_BLANK_CHK_blank_all_one_shift                                         (1)
+#define NF_SWC_BLANK_CHK_blank_all_one_mask                                          (0x00000002)
+#define NF_SWC_BLANK_CHK_blank_all_one(data)                                         (0x00000002&((data)<<1))
+#define NF_SWC_BLANK_CHK_blank_all_one_src(data)                                     ((0x00000002&(data))>>1)
+#define NF_SWC_BLANK_CHK_get_blank_all_one(data)                                     ((0x00000002&(data))>>1)
+#define NF_SWC_BLANK_CHK_blank_ena_shift                                             (0)
+#define NF_SWC_BLANK_CHK_blank_ena_mask                                              (0x00000001)
+#define NF_SWC_BLANK_CHK_blank_ena(data)                                             (0x00000001&((data)<<0))
+#define NF_SWC_BLANK_CHK_blank_ena_src(data)                                         ((0x00000001&(data))>>0)
+#define NF_SWC_BLANK_CHK_get_blank_ena(data)                                         ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_ND_ECC                                                                0x1802F038
+#define NF_SWC_ND_ECC_reg_addr                                                       "0xB802F038"
+#define NF_SWC_ND_ECC_reg                                                            0xB802F038
+#define set_NF_SWC_ND_ECC_reg(data)   (*((volatile unsigned int*) NF_SWC_ND_ECC_reg)=data)
+#define get_NF_SWC_ND_ECC_reg   (*((volatile unsigned int*) NF_SWC_ND_ECC_reg))
+#define NF_SWC_ND_ECC_inst_adr                                                       "0x000E"
+#define NF_SWC_ND_ECC_inst                                                           0x000E
+#define NF_SWC_ND_ECC_ecc_not_clr_shift                                              (3)
+#define NF_SWC_ND_ECC_ecc_not_clr_mask                                               (0x00000008)
+#define NF_SWC_ND_ECC_ecc_not_clr(data)                                              (0x00000008&((data)<<3))
+#define NF_SWC_ND_ECC_ecc_not_clr_src(data)                                          ((0x00000008&(data))>>3)
+#define NF_SWC_ND_ECC_get_ecc_not_clr(data)                                          ((0x00000008&(data))>>3)
+#define NF_SWC_ND_ECC_ecc_err_shift                                                  (2)
+#define NF_SWC_ND_ECC_ecc_err_mask                                                   (0x00000004)
+#define NF_SWC_ND_ECC_ecc_err(data)                                                  (0x00000004&((data)<<2))
+#define NF_SWC_ND_ECC_ecc_err_src(data)                                              ((0x00000004&(data))>>2)
+#define NF_SWC_ND_ECC_get_ecc_err(data)                                              ((0x00000004&(data))>>2)
+
+
+#define NF_SWC_ND_CA1                                                                0x1802F03C
+#define NF_SWC_ND_CA1_reg_addr                                                       "0xB802F03C"
+#define NF_SWC_ND_CA1_reg                                                            0xB802F03C
+#define set_NF_SWC_ND_CA1_reg(data)   (*((volatile unsigned int*) NF_SWC_ND_CA1_reg)=data)
+#define get_NF_SWC_ND_CA1_reg   (*((volatile unsigned int*) NF_SWC_ND_CA1_reg))
+#define NF_SWC_ND_CA1_inst_adr                                                       "0x000F"
+#define NF_SWC_ND_CA1_inst                                                           0x000F
+#define NF_SWC_ND_CA1_col_addr1_shift                                                (0)
+#define NF_SWC_ND_CA1_col_addr1_mask                                                 (0x000000FF)
+#define NF_SWC_ND_CA1_col_addr1(data)                                                (0x000000FF&((data)<<0))
+#define NF_SWC_ND_CA1_col_addr1_src(data)                                            ((0x000000FF&(data))>>0)
+#define NF_SWC_ND_CA1_get_col_addr1(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_DATA_TL0                                                              0x1802F100
+#define NF_SWC_DATA_TL0_reg_addr                                                     "0xB802F100"
+#define NF_SWC_DATA_TL0_reg                                                          0xB802F100
+#define set_NF_SWC_DATA_TL0_reg(data)   (*((volatile unsigned int*) NF_SWC_DATA_TL0_reg)=data)
+#define get_NF_SWC_DATA_TL0_reg   (*((volatile unsigned int*) NF_SWC_DATA_TL0_reg))
+#define NF_SWC_DATA_TL0_inst_adr                                                     "0x0040"
+#define NF_SWC_DATA_TL0_inst                                                         0x0040
+#define NF_SWC_DATA_TL0_length0_shift                                                (0)
+#define NF_SWC_DATA_TL0_length0_mask                                                 (0x000000FF)
+#define NF_SWC_DATA_TL0_length0(data)                                                (0x000000FF&((data)<<0))
+#define NF_SWC_DATA_TL0_length0_src(data)                                            ((0x000000FF&(data))>>0)
+#define NF_SWC_DATA_TL0_get_length0(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_DATA_TL1                                                              0x1802F104
+#define NF_SWC_DATA_TL1_reg_addr                                                     "0xB802F104"
+#define NF_SWC_DATA_TL1_reg                                                          0xB802F104
+#define set_NF_SWC_DATA_TL1_reg(data)   (*((volatile unsigned int*) NF_SWC_DATA_TL1_reg)=data)
+#define get_NF_SWC_DATA_TL1_reg   (*((volatile unsigned int*) NF_SWC_DATA_TL1_reg))
+#define NF_SWC_DATA_TL1_inst_adr                                                     "0x0041"
+#define NF_SWC_DATA_TL1_inst                                                         0x0041
+#define NF_SWC_DATA_TL1_access_mode_shift                                            (7)
+#define NF_SWC_DATA_TL1_access_mode_mask                                             (0x00000080)
+#define NF_SWC_DATA_TL1_access_mode(data)                                            (0x00000080&((data)<<7))
+#define NF_SWC_DATA_TL1_access_mode_src(data)                                        ((0x00000080&(data))>>7)
+#define NF_SWC_DATA_TL1_get_access_mode(data)                                        ((0x00000080&(data))>>7)
+#define NF_SWC_DATA_TL1_length1_shift                                                (0)
+#define NF_SWC_DATA_TL1_length1_mask                                                 (0x0000003F)
+#define NF_SWC_DATA_TL1_length1(data)                                                (0x0000003F&((data)<<0))
+#define NF_SWC_DATA_TL1_length1_src(data)                                            ((0x0000003F&(data))>>0)
+#define NF_SWC_DATA_TL1_get_length1(data)                                            ((0x0000003F&(data))>>0)
+
+
+#define NF_SWC_DMA1_CTL                                                              0x1802F10C
+#define NF_SWC_DMA1_CTL_reg_addr                                                     "0xB802F10C"
+#define NF_SWC_DMA1_CTL_reg                                                          0xB802F10C
+#define set_NF_SWC_DMA1_CTL_reg(data)   (*((volatile unsigned int*) NF_SWC_DMA1_CTL_reg)=data)
+#define get_NF_SWC_DMA1_CTL_reg   (*((volatile unsigned int*) NF_SWC_DMA1_CTL_reg))
+#define NF_SWC_DMA1_CTL_inst_adr                                                     "0x0043"
+#define NF_SWC_DMA1_CTL_inst                                                         0x0043
+#define NF_SWC_DMA1_CTL_eot_gen_shift                                                (3)
+#define NF_SWC_DMA1_CTL_eot_gen_mask                                                 (0x00000008)
+#define NF_SWC_DMA1_CTL_eot_gen(data)                                                (0x00000008&((data)<<3))
+#define NF_SWC_DMA1_CTL_eot_gen_src(data)                                            ((0x00000008&(data))>>3)
+#define NF_SWC_DMA1_CTL_get_eot_gen(data)                                            ((0x00000008&(data))>>3)
+#define NF_SWC_DMA1_CTL_dma_max_pkt_shift                                            (2)
+#define NF_SWC_DMA1_CTL_dma_max_pkt_mask                                             (0x00000004)
+#define NF_SWC_DMA1_CTL_dma_max_pkt(data)                                            (0x00000004&((data)<<2))
+#define NF_SWC_DMA1_CTL_dma_max_pkt_src(data)                                        ((0x00000004&(data))>>2)
+#define NF_SWC_DMA1_CTL_get_dma_max_pkt(data)                                        ((0x00000004&(data))>>2)
+#define NF_SWC_DMA1_CTL_spec_pkt_shift                                               (1)
+#define NF_SWC_DMA1_CTL_spec_pkt_mask                                                (0x00000002)
+#define NF_SWC_DMA1_CTL_spec_pkt(data)                                               (0x00000002&((data)<<1))
+#define NF_SWC_DMA1_CTL_spec_pkt_src(data)                                           ((0x00000002&(data))>>1)
+#define NF_SWC_DMA1_CTL_get_spec_pkt(data)                                           ((0x00000002&(data))>>1)
+
+
+#define NF_SWC_PP_CTL0                                                               0x1802F110
+#define NF_SWC_PP_CTL0_reg_addr                                                      "0xB802F110"
+#define NF_SWC_PP_CTL0_reg                                                           0xB802F110
+#define set_NF_SWC_PP_CTL0_reg(data)   (*((volatile unsigned int*) NF_SWC_PP_CTL0_reg)=data)
+#define get_NF_SWC_PP_CTL0_reg   (*((volatile unsigned int*) NF_SWC_PP_CTL0_reg))
+#define NF_SWC_PP_CTL0_inst_adr                                                      "0x0044"
+#define NF_SWC_PP_CTL0_inst                                                          0x0044
+#define NF_SWC_PP_CTL0_pp_start_addr_shift                                           (4)
+#define NF_SWC_PP_CTL0_pp_start_addr_mask                                            (0x00000070)
+#define NF_SWC_PP_CTL0_pp_start_addr(data)                                           (0x00000070&((data)<<4))
+#define NF_SWC_PP_CTL0_pp_start_addr_src(data)                                       ((0x00000070&(data))>>4)
+#define NF_SWC_PP_CTL0_get_pp_start_addr(data)                                       ((0x00000070&(data))>>4)
+#define NF_SWC_PP_CTL0_pp_busy_shift                                                 (2)
+#define NF_SWC_PP_CTL0_pp_busy_mask                                                  (0x00000004)
+#define NF_SWC_PP_CTL0_pp_busy(data)                                                 (0x00000004&((data)<<2))
+#define NF_SWC_PP_CTL0_pp_busy_src(data)                                             ((0x00000004&(data))>>2)
+#define NF_SWC_PP_CTL0_get_pp_busy(data)                                             ((0x00000004&(data))>>2)
+#define NF_SWC_PP_CTL0_pp_reset_shift                                                (1)
+#define NF_SWC_PP_CTL0_pp_reset_mask                                                 (0x00000002)
+#define NF_SWC_PP_CTL0_pp_reset(data)                                                (0x00000002&((data)<<1))
+#define NF_SWC_PP_CTL0_pp_reset_src(data)                                            ((0x00000002&(data))>>1)
+#define NF_SWC_PP_CTL0_get_pp_reset(data)                                            ((0x00000002&(data))>>1)
+#define NF_SWC_PP_CTL0_pp_enable_shift                                               (0)
+#define NF_SWC_PP_CTL0_pp_enable_mask                                                (0x00000001)
+#define NF_SWC_PP_CTL0_pp_enable(data)                                               (0x00000001&((data)<<0))
+#define NF_SWC_PP_CTL0_pp_enable_src(data)                                           ((0x00000001&(data))>>0)
+#define NF_SWC_PP_CTL0_get_pp_enable(data)                                           ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_ECC_SEL                                                               0x1802F128
+#define NF_SWC_ECC_SEL_reg_addr                                                      "0xB802F128"
+#define NF_SWC_ECC_SEL_reg                                                           0xB802F128
+#define set_NF_SWC_ECC_SEL_reg(data)   (*((volatile unsigned int*) NF_SWC_ECC_SEL_reg)=data)
+#define get_NF_SWC_ECC_SEL_reg   (*((volatile unsigned int*) NF_SWC_ECC_SEL_reg))
+#define NF_SWC_ECC_SEL_inst_adr                                                      "0x004A"
+#define NF_SWC_ECC_SEL_inst                                                          0x004A
+#define NF_SWC_ECC_SEL_ecc_bch_72b_mode_shift                                        (1)
+#define NF_SWC_ECC_SEL_ecc_bch_72b_mode_mask                                         (0x0000000E)
+#define NF_SWC_ECC_SEL_ecc_bch_72b_mode(data)                                        (0x0000000E&((data)<<1))
+#define NF_SWC_ECC_SEL_ecc_bch_72b_mode_src(data)                                    ((0x0000000E&(data))>>1)
+#define NF_SWC_ECC_SEL_get_ecc_bch_72b_mode(data)                                    ((0x0000000E&(data))>>1)
+#define NF_SWC_ECC_SEL_ecc_bch_12b_ena_shift                                         (0)
+#define NF_SWC_ECC_SEL_ecc_bch_12b_ena_mask                                          (0x00000001)
+#define NF_SWC_ECC_SEL_ecc_bch_12b_ena(data)                                         (0x00000001&((data)<<0))
+#define NF_SWC_ECC_SEL_ecc_bch_12b_ena_src(data)                                     ((0x00000001&(data))>>0)
+#define NF_SWC_ECC_SEL_get_ecc_bch_12b_ena(data)                                     ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_PP_CTL1                                                               0x1802F12C
+#define NF_SWC_PP_CTL1_reg_addr                                                      "0xB802F12C"
+#define NF_SWC_PP_CTL1_reg                                                           0xB802F12C
+#define set_NF_SWC_PP_CTL1_reg(data)   (*((volatile unsigned int*) NF_SWC_PP_CTL1_reg)=data)
+#define get_NF_SWC_PP_CTL1_reg   (*((volatile unsigned int*) NF_SWC_PP_CTL1_reg))
+#define NF_SWC_PP_CTL1_inst_adr                                                      "0x004B"
+#define NF_SWC_PP_CTL1_inst                                                          0x004B
+#define NF_SWC_PP_CTL1_pp_start_addr_shift                                           (0)
+#define NF_SWC_PP_CTL1_pp_start_addr_mask                                            (0x000000FF)
+#define NF_SWC_PP_CTL1_pp_start_addr(data)                                           (0x000000FF&((data)<<0))
+#define NF_SWC_PP_CTL1_pp_start_addr_src(data)                                       ((0x000000FF&(data))>>0)
+#define NF_SWC_PP_CTL1_get_pp_start_addr(data)                                       ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_PD                                                                    0x1802F130
+#define NF_SWC_PD_reg_addr                                                           "0xB802F130"
+#define NF_SWC_PD_reg                                                                0xB802F130
+#define set_NF_SWC_PD_reg(data)   (*((volatile unsigned int*) NF_SWC_PD_reg)=data)
+#define get_NF_SWC_PD_reg   (*((volatile unsigned int*) NF_SWC_PD_reg))
+#define NF_SWC_PD_inst_adr                                                           "0x004C"
+#define NF_SWC_PD_inst                                                               0x004C
+#define NF_SWC_PD_pd_shift                                                           (0)
+#define NF_SWC_PD_pd_mask                                                            (0x0000001F)
+#define NF_SWC_PD_pd(data)                                                           (0x0000001F&((data)<<0))
+#define NF_SWC_PD_pd_src(data)                                                       ((0x0000001F&(data))>>0)
+#define NF_SWC_PD_get_pd(data)                                                       ((0x0000001F&(data))>>0)
+
+
+#define NF_SWC_NF_LOW_PWR                                                            0x1802F13C
+#define NF_SWC_NF_LOW_PWR_reg_addr                                                   "0xB802F13C"
+#define NF_SWC_NF_LOW_PWR_reg                                                        0xB802F13C
+#define set_NF_SWC_NF_LOW_PWR_reg(data)   (*((volatile unsigned int*) NF_SWC_NF_LOW_PWR_reg)=data)
+#define get_NF_SWC_NF_LOW_PWR_reg   (*((volatile unsigned int*) NF_SWC_NF_LOW_PWR_reg))
+#define NF_SWC_NF_LOW_PWR_inst_adr                                                   "0x004F"
+#define NF_SWC_NF_LOW_PWR_inst                                                       0x004F
+#define NF_SWC_NF_LOW_PWR_pp_lp_mode_shift                                           (7)
+#define NF_SWC_NF_LOW_PWR_pp_lp_mode_mask                                            (0x00000080)
+#define NF_SWC_NF_LOW_PWR_pp_lp_mode(data)                                           (0x00000080&((data)<<7))
+#define NF_SWC_NF_LOW_PWR_pp_lp_mode_src(data)                                       ((0x00000080&(data))>>7)
+#define NF_SWC_NF_LOW_PWR_get_pp_lp_mode(data)                                       ((0x00000080&(data))>>7)
+#define NF_SWC_NF_LOW_PWR_pp_lp_ena_shift                                            (6)
+#define NF_SWC_NF_LOW_PWR_pp_lp_ena_mask                                             (0x00000040)
+#define NF_SWC_NF_LOW_PWR_pp_lp_ena(data)                                            (0x00000040&((data)<<6))
+#define NF_SWC_NF_LOW_PWR_pp_lp_ena_src(data)                                        ((0x00000040&(data))>>6)
+#define NF_SWC_NF_LOW_PWR_get_pp_lp_ena(data)                                        ((0x00000040&(data))>>6)
+#define NF_SWC_NF_LOW_PWR_ecc_clk_gate_ena_shift                                     (5)
+#define NF_SWC_NF_LOW_PWR_ecc_clk_gate_ena_mask                                      (0x00000020)
+#define NF_SWC_NF_LOW_PWR_ecc_clk_gate_ena(data)                                     (0x00000020&((data)<<5))
+#define NF_SWC_NF_LOW_PWR_ecc_clk_gate_ena_src(data)                                 ((0x00000020&(data))>>5)
+#define NF_SWC_NF_LOW_PWR_get_ecc_clk_gate_ena(data)                                 ((0x00000020&(data))>>5)
+#define NF_SWC_NF_LOW_PWR_ip_clk_gate_ena_shift                                      (4)
+#define NF_SWC_NF_LOW_PWR_ip_clk_gate_ena_mask                                       (0x00000010)
+#define NF_SWC_NF_LOW_PWR_ip_clk_gate_ena(data)                                      (0x00000010&((data)<<4))
+#define NF_SWC_NF_LOW_PWR_ip_clk_gate_ena_src(data)                                  ((0x00000010&(data))>>4)
+#define NF_SWC_NF_LOW_PWR_get_ip_clk_gate_ena(data)                                  ((0x00000010&(data))>>4)
+#define NF_SWC_NF_LOW_PWR_dma_clk_gate_ena_shift                                     (3)
+#define NF_SWC_NF_LOW_PWR_dma_clk_gate_ena_mask                                      (0x00000008)
+#define NF_SWC_NF_LOW_PWR_dma_clk_gate_ena(data)                                     (0x00000008&((data)<<3))
+#define NF_SWC_NF_LOW_PWR_dma_clk_gate_ena_src(data)                                 ((0x00000008&(data))>>3)
+#define NF_SWC_NF_LOW_PWR_get_dma_clk_gate_ena(data)                                 ((0x00000008&(data))>>3)
+#define NF_SWC_NF_LOW_PWR_pp_sram_rdy_num_shift                                      (0)
+#define NF_SWC_NF_LOW_PWR_pp_sram_rdy_num_mask                                       (0x00000007)
+#define NF_SWC_NF_LOW_PWR_pp_sram_rdy_num(data)                                      (0x00000007&((data)<<0))
+#define NF_SWC_NF_LOW_PWR_pp_sram_rdy_num_src(data)                                  ((0x00000007&(data))>>0)
+#define NF_SWC_NF_LOW_PWR_get_pp_sram_rdy_num(data)                                  ((0x00000007&(data))>>0)
+
+
+#define NF_SWC_DUMMY_NF1                                                             0x1802F158
+#define NF_SWC_DUMMY_NF1_reg_addr                                                    "0xB802F158"
+#define NF_SWC_DUMMY_NF1_reg                                                         0xB802F158
+#define set_NF_SWC_DUMMY_NF1_reg(data)   (*((volatile unsigned int*) NF_SWC_DUMMY_NF1_reg)=data)
+#define get_NF_SWC_DUMMY_NF1_reg   (*((volatile unsigned int*) NF_SWC_DUMMY_NF1_reg))
+#define NF_SWC_DUMMY_NF1_inst_adr                                                    "0x0056"
+#define NF_SWC_DUMMY_NF1_inst                                                        0x0056
+#define NF_SWC_DUMMY_NF1_Dmy1_shift                                                  (0)
+#define NF_SWC_DUMMY_NF1_Dmy1_mask                                                   (0x000000FF)
+#define NF_SWC_DUMMY_NF1_Dmy1(data)                                                  (0x000000FF&((data)<<0))
+#define NF_SWC_DUMMY_NF1_Dmy1_src(data)                                              ((0x000000FF&(data))>>0)
+#define NF_SWC_DUMMY_NF1_get_Dmy1(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_DUMMY_NF2                                                             0x1802F15C
+#define NF_SWC_DUMMY_NF2_reg_addr                                                    "0xB802F15C"
+#define NF_SWC_DUMMY_NF2_reg                                                         0xB802F15C
+#define set_NF_SWC_DUMMY_NF2_reg(data)   (*((volatile unsigned int*) NF_SWC_DUMMY_NF2_reg)=data)
+#define get_NF_SWC_DUMMY_NF2_reg   (*((volatile unsigned int*) NF_SWC_DUMMY_NF2_reg))
+#define NF_SWC_DUMMY_NF2_inst_adr                                                    "0x0057"
+#define NF_SWC_DUMMY_NF2_inst                                                        0x0057
+#define NF_SWC_DUMMY_NF2_Dmy2_shift                                                  (0)
+#define NF_SWC_DUMMY_NF2_Dmy2_mask                                                   (0x000000FF)
+#define NF_SWC_DUMMY_NF2_Dmy2(data)                                                  (0x000000FF&((data)<<0))
+#define NF_SWC_DUMMY_NF2_Dmy2_src(data)                                              ((0x000000FF&(data))>>0)
+#define NF_SWC_DUMMY_NF2_get_Dmy2(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_DUMMY_NF3                                                             0x1802F160
+#define NF_SWC_DUMMY_NF3_reg_addr                                                    "0xB802F160"
+#define NF_SWC_DUMMY_NF3_reg                                                         0xB802F160
+#define set_NF_SWC_DUMMY_NF3_reg(data)   (*((volatile unsigned int*) NF_SWC_DUMMY_NF3_reg)=data)
+#define get_NF_SWC_DUMMY_NF3_reg   (*((volatile unsigned int*) NF_SWC_DUMMY_NF3_reg))
+#define NF_SWC_DUMMY_NF3_inst_adr                                                    "0x0058"
+#define NF_SWC_DUMMY_NF3_inst                                                        0x0058
+#define NF_SWC_DUMMY_NF3_Dmy3_shift                                                  (0)
+#define NF_SWC_DUMMY_NF3_Dmy3_mask                                                   (0x000000FF)
+#define NF_SWC_DUMMY_NF3_Dmy3(data)                                                  (0x000000FF&((data)<<0))
+#define NF_SWC_DUMMY_NF3_Dmy3_src(data)                                              ((0x000000FF&(data))>>0)
+#define NF_SWC_DUMMY_NF3_get_Dmy3(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_DUMMY_NF4                                                             0x1802F164
+#define NF_SWC_DUMMY_NF4_reg_addr                                                    "0xB802F164"
+#define NF_SWC_DUMMY_NF4_reg                                                         0xB802F164
+#define set_NF_SWC_DUMMY_NF4_reg(data)   (*((volatile unsigned int*) NF_SWC_DUMMY_NF4_reg)=data)
+#define get_NF_SWC_DUMMY_NF4_reg   (*((volatile unsigned int*) NF_SWC_DUMMY_NF4_reg))
+#define NF_SWC_DUMMY_NF4_inst_adr                                                    "0x0059"
+#define NF_SWC_DUMMY_NF4_inst                                                        0x0059
+#define NF_SWC_DUMMY_NF4_Dmy4_shift                                                  (0)
+#define NF_SWC_DUMMY_NF4_Dmy4_mask                                                   (0x000000FF)
+#define NF_SWC_DUMMY_NF4_Dmy4(data)                                                  (0x000000FF&((data)<<0))
+#define NF_SWC_DUMMY_NF4_Dmy4_src(data)                                              ((0x000000FF&(data))>>0)
+#define NF_SWC_DUMMY_NF4_get_Dmy4(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_AUTO_TRIG                                                             0x1802F200
+#define NF_SWC_AUTO_TRIG_reg_addr                                                    "0xB802F200"
+#define NF_SWC_AUTO_TRIG_reg                                                         0xB802F200
+#define set_NF_SWC_AUTO_TRIG_reg(data)   (*((volatile unsigned int*) NF_SWC_AUTO_TRIG_reg)=data)
+#define get_NF_SWC_AUTO_TRIG_reg   (*((volatile unsigned int*) NF_SWC_AUTO_TRIG_reg))
+#define NF_SWC_AUTO_TRIG_inst_adr                                                    "0x0080"
+#define NF_SWC_AUTO_TRIG_inst                                                        0x0080
+#define NF_SWC_AUTO_TRIG_auto_trig_shift                                             (7)
+#define NF_SWC_AUTO_TRIG_auto_trig_mask                                              (0x00000080)
+#define NF_SWC_AUTO_TRIG_auto_trig(data)                                             (0x00000080&((data)<<7))
+#define NF_SWC_AUTO_TRIG_auto_trig_src(data)                                         ((0x00000080&(data))>>7)
+#define NF_SWC_AUTO_TRIG_get_auto_trig(data)                                         ((0x00000080&(data))>>7)
+#define NF_SWC_AUTO_TRIG_addr_fbd_shift                                              (6)
+#define NF_SWC_AUTO_TRIG_addr_fbd_mask                                               (0x00000040)
+#define NF_SWC_AUTO_TRIG_addr_fbd(data)                                              (0x00000040&((data)<<6))
+#define NF_SWC_AUTO_TRIG_addr_fbd_src(data)                                          ((0x00000040&(data))>>6)
+#define NF_SWC_AUTO_TRIG_get_addr_fbd(data)                                          ((0x00000040&(data))>>6)
+#define NF_SWC_AUTO_TRIG_pp_empty_shift                                              (5)
+#define NF_SWC_AUTO_TRIG_pp_empty_mask                                               (0x00000020)
+#define NF_SWC_AUTO_TRIG_pp_empty(data)                                              (0x00000020&((data)<<5))
+#define NF_SWC_AUTO_TRIG_pp_empty_src(data)                                          ((0x00000020&(data))>>5)
+#define NF_SWC_AUTO_TRIG_get_pp_empty(data)                                          ((0x00000020&(data))>>5)
+#define NF_SWC_AUTO_TRIG_spec_auto_case_shift                                        (3)
+#define NF_SWC_AUTO_TRIG_spec_auto_case_mask                                         (0x00000018)
+#define NF_SWC_AUTO_TRIG_spec_auto_case(data)                                        (0x00000018&((data)<<3))
+#define NF_SWC_AUTO_TRIG_spec_auto_case_src(data)                                    ((0x00000018&(data))>>3)
+#define NF_SWC_AUTO_TRIG_get_spec_auto_case(data)                                    ((0x00000018&(data))>>3)
+#define NF_SWC_AUTO_TRIG_auto_case_shift                                             (0)
+#define NF_SWC_AUTO_TRIG_auto_case_mask                                              (0x00000007)
+#define NF_SWC_AUTO_TRIG_auto_case(data)                                             (0x00000007&((data)<<0))
+#define NF_SWC_AUTO_TRIG_auto_case_src(data)                                         ((0x00000007&(data))>>0)
+#define NF_SWC_AUTO_TRIG_get_auto_case(data)                                         ((0x00000007&(data))>>0)
+
+
+#define NF_SWC_RSECC_NUM                                                             0x1802F204
+#define NF_SWC_RSECC_NUM_reg_addr                                                    "0xB802F204"
+#define NF_SWC_RSECC_NUM_reg                                                         0xB802F204
+#define set_NF_SWC_RSECC_NUM_reg(data)   (*((volatile unsigned int*) NF_SWC_RSECC_NUM_reg)=data)
+#define get_NF_SWC_RSECC_NUM_reg   (*((volatile unsigned int*) NF_SWC_RSECC_NUM_reg))
+#define NF_SWC_RSECC_NUM_inst_adr                                                    "0x0081"
+#define NF_SWC_RSECC_NUM_inst                                                        0x0081
+#define NF_SWC_RSECC_NUM_ecc_num_shift                                               (0)
+#define NF_SWC_RSECC_NUM_ecc_num_mask                                                (0x000000FF)
+#define NF_SWC_RSECC_NUM_ecc_num(data)                                               (0x000000FF&((data)<<0))
+#define NF_SWC_RSECC_NUM_ecc_num_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_SWC_RSECC_NUM_get_ecc_num(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_RND_CMD1                                                              0x1802F208
+#define NF_SWC_RND_CMD1_reg_addr                                                     "0xB802F208"
+#define NF_SWC_RND_CMD1_reg                                                          0xB802F208
+#define set_NF_SWC_RND_CMD1_reg(data)   (*((volatile unsigned int*) NF_SWC_RND_CMD1_reg)=data)
+#define get_NF_SWC_RND_CMD1_reg   (*((volatile unsigned int*) NF_SWC_RND_CMD1_reg))
+#define NF_SWC_RND_CMD1_inst_adr                                                     "0x0082"
+#define NF_SWC_RND_CMD1_inst                                                         0x0082
+#define NF_SWC_RND_CMD1_rnd_cmd1_shift                                               (0)
+#define NF_SWC_RND_CMD1_rnd_cmd1_mask                                                (0x000000FF)
+#define NF_SWC_RND_CMD1_rnd_cmd1(data)                                               (0x000000FF&((data)<<0))
+#define NF_SWC_RND_CMD1_rnd_cmd1_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_SWC_RND_CMD1_get_rnd_cmd1(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_RND_CMD2                                                              0x1802F20C
+#define NF_SWC_RND_CMD2_reg_addr                                                     "0xB802F20C"
+#define NF_SWC_RND_CMD2_reg                                                          0xB802F20C
+#define set_NF_SWC_RND_CMD2_reg(data)   (*((volatile unsigned int*) NF_SWC_RND_CMD2_reg)=data)
+#define get_NF_SWC_RND_CMD2_reg   (*((volatile unsigned int*) NF_SWC_RND_CMD2_reg))
+#define NF_SWC_RND_CMD2_inst_adr                                                     "0x0083"
+#define NF_SWC_RND_CMD2_inst                                                         0x0083
+#define NF_SWC_RND_CMD2_rnd_cmd2_shift                                               (0)
+#define NF_SWC_RND_CMD2_rnd_cmd2_mask                                                (0x000000FF)
+#define NF_SWC_RND_CMD2_rnd_cmd2(data)                                               (0x000000FF&((data)<<0))
+#define NF_SWC_RND_CMD2_rnd_cmd2_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_SWC_RND_CMD2_get_rnd_cmd2(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_RND_DATASTR_COL_H                                                     0x1802F210
+#define NF_SWC_RND_DATASTR_COL_H_reg_addr                                            "0xB802F210"
+#define NF_SWC_RND_DATASTR_COL_H_reg                                                 0xB802F210
+#define set_NF_SWC_RND_DATASTR_COL_H_reg(data)   (*((volatile unsigned int*) NF_SWC_RND_DATASTR_COL_H_reg)=data)
+#define get_NF_SWC_RND_DATASTR_COL_H_reg   (*((volatile unsigned int*) NF_SWC_RND_DATASTR_COL_H_reg))
+#define NF_SWC_RND_DATASTR_COL_H_inst_adr                                            "0x0084"
+#define NF_SWC_RND_DATASTR_COL_H_inst                                                0x0084
+#define NF_SWC_RND_DATASTR_COL_H_data_col_msb_shift                                  (0)
+#define NF_SWC_RND_DATASTR_COL_H_data_col_msb_mask                                   (0x000000FF)
+#define NF_SWC_RND_DATASTR_COL_H_data_col_msb(data)                                  (0x000000FF&((data)<<0))
+#define NF_SWC_RND_DATASTR_COL_H_data_col_msb_src(data)                              ((0x000000FF&(data))>>0)
+#define NF_SWC_RND_DATASTR_COL_H_get_data_col_msb(data)                              ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_RND_SPR_STR_COL_H                                                     0x1802F214
+#define NF_SWC_RND_SPR_STR_COL_H_reg_addr                                            "0xB802F214"
+#define NF_SWC_RND_SPR_STR_COL_H_reg                                                 0xB802F214
+#define set_NF_SWC_RND_SPR_STR_COL_H_reg(data)   (*((volatile unsigned int*) NF_SWC_RND_SPR_STR_COL_H_reg)=data)
+#define get_NF_SWC_RND_SPR_STR_COL_H_reg   (*((volatile unsigned int*) NF_SWC_RND_SPR_STR_COL_H_reg))
+#define NF_SWC_RND_SPR_STR_COL_H_inst_adr                                            "0x0085"
+#define NF_SWC_RND_SPR_STR_COL_H_inst                                                0x0085
+#define NF_SWC_RND_SPR_STR_COL_H_spr_col_msb_shift                                   (0)
+#define NF_SWC_RND_SPR_STR_COL_H_spr_col_msb_mask                                    (0x000000FF)
+#define NF_SWC_RND_SPR_STR_COL_H_spr_col_msb(data)                                   (0x000000FF&((data)<<0))
+#define NF_SWC_RND_SPR_STR_COL_H_spr_col_msb_src(data)                               ((0x000000FF&(data))>>0)
+#define NF_SWC_RND_SPR_STR_COL_H_get_spr_col_msb(data)                               ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_RND_SPR_STR_COL_L                                                     0x1802F218
+#define NF_SWC_RND_SPR_STR_COL_L_reg_addr                                            "0xB802F218"
+#define NF_SWC_RND_SPR_STR_COL_L_reg                                                 0xB802F218
+#define set_NF_SWC_RND_SPR_STR_COL_L_reg(data)   (*((volatile unsigned int*) NF_SWC_RND_SPR_STR_COL_L_reg)=data)
+#define get_NF_SWC_RND_SPR_STR_COL_L_reg   (*((volatile unsigned int*) NF_SWC_RND_SPR_STR_COL_L_reg))
+#define NF_SWC_RND_SPR_STR_COL_L_inst_adr                                            "0x0086"
+#define NF_SWC_RND_SPR_STR_COL_L_inst                                                0x0086
+#define NF_SWC_RND_SPR_STR_COL_L_spr_col_lsb_shift                                   (0)
+#define NF_SWC_RND_SPR_STR_COL_L_spr_col_lsb_mask                                    (0x000000FF)
+#define NF_SWC_RND_SPR_STR_COL_L_spr_col_lsb(data)                                   (0x000000FF&((data)<<0))
+#define NF_SWC_RND_SPR_STR_COL_L_spr_col_lsb_src(data)                               ((0x000000FF&(data))>>0)
+#define NF_SWC_RND_SPR_STR_COL_L_get_spr_col_lsb(data)                               ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_RND_RW_EN                                                             0x1802F21C
+#define NF_SWC_RND_RW_EN_reg_addr                                                    "0xB802F21C"
+#define NF_SWC_RND_RW_EN_reg                                                         0xB802F21C
+#define set_NF_SWC_RND_RW_EN_reg(data)   (*((volatile unsigned int*) NF_SWC_RND_RW_EN_reg)=data)
+#define get_NF_SWC_RND_RW_EN_reg   (*((volatile unsigned int*) NF_SWC_RND_RW_EN_reg))
+#define NF_SWC_RND_RW_EN_inst_adr                                                    "0x0087"
+#define NF_SWC_RND_RW_EN_inst                                                        0x0087
+#define NF_SWC_RND_RW_EN_rnd_rw_enable_shift                                         (0)
+#define NF_SWC_RND_RW_EN_rnd_rw_enable_mask                                          (0x00000001)
+#define NF_SWC_RND_RW_EN_rnd_rw_enable(data)                                         (0x00000001&((data)<<0))
+#define NF_SWC_RND_RW_EN_rnd_rw_enable_src(data)                                     ((0x00000001&(data))>>0)
+#define NF_SWC_RND_RW_EN_get_rnd_rw_enable(data)                                     ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_READ_BY_PP                                                            0x1802F228
+#define NF_SWC_READ_BY_PP_reg_addr                                                   "0xB802F228"
+#define NF_SWC_READ_BY_PP_reg                                                        0xB802F228
+#define set_NF_SWC_READ_BY_PP_reg(data)   (*((volatile unsigned int*) NF_SWC_READ_BY_PP_reg)=data)
+#define get_NF_SWC_READ_BY_PP_reg   (*((volatile unsigned int*) NF_SWC_READ_BY_PP_reg))
+#define NF_SWC_READ_BY_PP_inst_adr                                                   "0x008A"
+#define NF_SWC_READ_BY_PP_inst                                                       0x008A
+#define NF_SWC_READ_BY_PP_read_by_pp_shift                                           (7)
+#define NF_SWC_READ_BY_PP_read_by_pp_mask                                            (0x00000080)
+#define NF_SWC_READ_BY_PP_read_by_pp(data)                                           (0x00000080&((data)<<7))
+#define NF_SWC_READ_BY_PP_read_by_pp_src(data)                                       ((0x00000080&(data))>>7)
+#define NF_SWC_READ_BY_PP_get_read_by_pp(data)                                       ((0x00000080&(data))>>7)
+
+
+#define NF_SWC_MAX_ECC_NUM                                                           0x1802F22C
+#define NF_SWC_MAX_ECC_NUM_reg_addr                                                  "0xB802F22C"
+#define NF_SWC_MAX_ECC_NUM_reg                                                       0xB802F22C
+#define set_NF_SWC_MAX_ECC_NUM_reg(data)   (*((volatile unsigned int*) NF_SWC_MAX_ECC_NUM_reg)=data)
+#define get_NF_SWC_MAX_ECC_NUM_reg   (*((volatile unsigned int*) NF_SWC_MAX_ECC_NUM_reg))
+#define NF_SWC_MAX_ECC_NUM_inst_adr                                                  "0x008B"
+#define NF_SWC_MAX_ECC_NUM_inst                                                      0x008B
+#define NF_SWC_MAX_ECC_NUM_max_ecc_num_shift                                         (0)
+#define NF_SWC_MAX_ECC_NUM_max_ecc_num_mask                                          (0x000000FF)
+#define NF_SWC_MAX_ECC_NUM_max_ecc_num(data)                                         (0x000000FF&((data)<<0))
+#define NF_SWC_MAX_ECC_NUM_max_ecc_num_src(data)                                     ((0x000000FF&(data))>>0)
+#define NF_SWC_MAX_ECC_NUM_get_max_ecc_num(data)                                     ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_TIME_PARA3                                                            0x1802F234
+#define NF_SWC_TIME_PARA3_reg_addr                                                   "0xB802F234"
+#define NF_SWC_TIME_PARA3_reg                                                        0xB802F234
+#define set_NF_SWC_TIME_PARA3_reg(data)   (*((volatile unsigned int*) NF_SWC_TIME_PARA3_reg)=data)
+#define get_NF_SWC_TIME_PARA3_reg   (*((volatile unsigned int*) NF_SWC_TIME_PARA3_reg))
+#define NF_SWC_TIME_PARA3_inst_adr                                                   "0x008D"
+#define NF_SWC_TIME_PARA3_inst                                                       0x008D
+#define NF_SWC_TIME_PARA3_T3_shift                                                   (0)
+#define NF_SWC_TIME_PARA3_T3_mask                                                    (0x000000FF)
+#define NF_SWC_TIME_PARA3_T3(data)                                                   (0x000000FF&((data)<<0))
+#define NF_SWC_TIME_PARA3_T3_src(data)                                               ((0x000000FF&(data))>>0)
+#define NF_SWC_TIME_PARA3_get_T3(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_TIME_PARA2                                                            0x1802F238
+#define NF_SWC_TIME_PARA2_reg_addr                                                   "0xB802F238"
+#define NF_SWC_TIME_PARA2_reg                                                        0xB802F238
+#define set_NF_SWC_TIME_PARA2_reg(data)   (*((volatile unsigned int*) NF_SWC_TIME_PARA2_reg)=data)
+#define get_NF_SWC_TIME_PARA2_reg   (*((volatile unsigned int*) NF_SWC_TIME_PARA2_reg))
+#define NF_SWC_TIME_PARA2_inst_adr                                                   "0x008E"
+#define NF_SWC_TIME_PARA2_inst                                                       0x008E
+#define NF_SWC_TIME_PARA2_T2_shift                                                   (0)
+#define NF_SWC_TIME_PARA2_T2_mask                                                    (0x000000FF)
+#define NF_SWC_TIME_PARA2_T2(data)                                                   (0x000000FF&((data)<<0))
+#define NF_SWC_TIME_PARA2_T2_src(data)                                               ((0x000000FF&(data))>>0)
+#define NF_SWC_TIME_PARA2_get_T2(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_TIME_PARA1                                                            0x1802F23C
+#define NF_SWC_TIME_PARA1_reg_addr                                                   "0xB802F23C"
+#define NF_SWC_TIME_PARA1_reg                                                        0xB802F23C
+#define set_NF_SWC_TIME_PARA1_reg(data)   (*((volatile unsigned int*) NF_SWC_TIME_PARA1_reg)=data)
+#define get_NF_SWC_TIME_PARA1_reg   (*((volatile unsigned int*) NF_SWC_TIME_PARA1_reg))
+#define NF_SWC_TIME_PARA1_inst_adr                                                   "0x008F"
+#define NF_SWC_TIME_PARA1_inst                                                       0x008F
+#define NF_SWC_TIME_PARA1_T1_shift                                                   (0)
+#define NF_SWC_TIME_PARA1_T1_mask                                                    (0x000000FF)
+#define NF_SWC_TIME_PARA1_T1(data)                                                   (0x000000FF&((data)<<0))
+#define NF_SWC_TIME_PARA1_T1_src(data)                                               ((0x000000FF&(data))>>0)
+#define NF_SWC_TIME_PARA1_get_T1(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_RMZ_CTRL                                                              0x1802F240
+#define NF_SWC_RMZ_CTRL_reg_addr                                                     "0xB802F240"
+#define NF_SWC_RMZ_CTRL_reg                                                          0xB802F240
+#define set_NF_SWC_RMZ_CTRL_reg(data)   (*((volatile unsigned int*) NF_SWC_RMZ_CTRL_reg)=data)
+#define get_NF_SWC_RMZ_CTRL_reg   (*((volatile unsigned int*) NF_SWC_RMZ_CTRL_reg))
+#define NF_SWC_RMZ_CTRL_inst_adr                                                     "0x0090"
+#define NF_SWC_RMZ_CTRL_inst                                                         0x0090
+#define NF_SWC_RMZ_CTRL_rand_ready_shift                                             (1)
+#define NF_SWC_RMZ_CTRL_rand_ready_mask                                              (0x00000002)
+#define NF_SWC_RMZ_CTRL_rand_ready(data)                                             (0x00000002&((data)<<1))
+#define NF_SWC_RMZ_CTRL_rand_ready_src(data)                                         ((0x00000002&(data))>>1)
+#define NF_SWC_RMZ_CTRL_get_rand_ready(data)                                         ((0x00000002&(data))>>1)
+#define NF_SWC_RMZ_CTRL_rand_en_shift                                                (0)
+#define NF_SWC_RMZ_CTRL_rand_en_mask                                                 (0x00000001)
+#define NF_SWC_RMZ_CTRL_rand_en(data)                                                (0x00000001&((data)<<0))
+#define NF_SWC_RMZ_CTRL_rand_en_src(data)                                            ((0x00000001&(data))>>0)
+#define NF_SWC_RMZ_CTRL_get_rand_en(data)                                            ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_RMZ_SEED_L                                                            0x1802F244
+#define NF_SWC_RMZ_SEED_L_reg_addr                                                   "0xB802F244"
+#define NF_SWC_RMZ_SEED_L_reg                                                        0xB802F244
+#define set_NF_SWC_RMZ_SEED_L_reg(data)   (*((volatile unsigned int*) NF_SWC_RMZ_SEED_L_reg)=data)
+#define get_NF_SWC_RMZ_SEED_L_reg   (*((volatile unsigned int*) NF_SWC_RMZ_SEED_L_reg))
+#define NF_SWC_RMZ_SEED_L_inst_adr                                                   "0x0091"
+#define NF_SWC_RMZ_SEED_L_inst                                                       0x0091
+#define NF_SWC_RMZ_SEED_L_rand_seed_low_shift                                        (0)
+#define NF_SWC_RMZ_SEED_L_rand_seed_low_mask                                         (0x000000FF)
+#define NF_SWC_RMZ_SEED_L_rand_seed_low(data)                                        (0x000000FF&((data)<<0))
+#define NF_SWC_RMZ_SEED_L_rand_seed_low_src(data)                                    ((0x000000FF&(data))>>0)
+#define NF_SWC_RMZ_SEED_L_get_rand_seed_low(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_RMZ_SEED_H                                                            0x1802F248
+#define NF_SWC_RMZ_SEED_H_reg_addr                                                   "0xB802F248"
+#define NF_SWC_RMZ_SEED_H_reg                                                        0xB802F248
+#define set_NF_SWC_RMZ_SEED_H_reg(data)   (*((volatile unsigned int*) NF_SWC_RMZ_SEED_H_reg)=data)
+#define get_NF_SWC_RMZ_SEED_H_reg   (*((volatile unsigned int*) NF_SWC_RMZ_SEED_H_reg))
+#define NF_SWC_RMZ_SEED_H_inst_adr                                                   "0x0092"
+#define NF_SWC_RMZ_SEED_H_inst                                                       0x0092
+#define NF_SWC_RMZ_SEED_H_rand_seed_hi_shift                                         (0)
+#define NF_SWC_RMZ_SEED_H_rand_seed_hi_mask                                          (0x0000007F)
+#define NF_SWC_RMZ_SEED_H_rand_seed_hi(data)                                         (0x0000007F&((data)<<0))
+#define NF_SWC_RMZ_SEED_H_rand_seed_hi_src(data)                                     ((0x0000007F&(data))>>0)
+#define NF_SWC_RMZ_SEED_H_get_rand_seed_hi(data)                                     ((0x0000007F&(data))>>0)
+
+
+#define NF_SWC_RMZ_SEED_NUM                                                          0x1802F24c
+#define NF_SWC_RMZ_SEED_NUM_reg_addr                                                 "0xB802F24c"
+#define NF_SWC_RMZ_SEED_NUM_reg                                                      0xB802F24c
+#define set_NF_SWC_RMZ_SEED_NUM_reg(data)   (*((volatile unsigned int*) NF_SWC_RMZ_SEED_NUM_reg)=data)
+#define get_NF_SWC_RMZ_SEED_NUM_reg   (*((volatile unsigned int*) NF_SWC_RMZ_SEED_NUM_reg))
+#define NF_SWC_RMZ_SEED_NUM_inst_adr                                                 "0x0093"
+#define NF_SWC_RMZ_SEED_NUM_inst                                                     0x0093
+#define NF_SWC_RMZ_SEED_NUM_rand_seed_from_reg_shift                                 (4)
+#define NF_SWC_RMZ_SEED_NUM_rand_seed_from_reg_mask                                  (0x00000010)
+#define NF_SWC_RMZ_SEED_NUM_rand_seed_from_reg(data)                                 (0x00000010&((data)<<4))
+#define NF_SWC_RMZ_SEED_NUM_rand_seed_from_reg_src(data)                             ((0x00000010&(data))>>4)
+#define NF_SWC_RMZ_SEED_NUM_get_rand_seed_from_reg(data)                             ((0x00000010&(data))>>4)
+#define NF_SWC_RMZ_SEED_NUM_rand_seed_num_shift                                      (0)
+#define NF_SWC_RMZ_SEED_NUM_rand_seed_num_mask                                       (0x00000007)
+#define NF_SWC_RMZ_SEED_NUM_rand_seed_num(data)                                      (0x00000007&((data)<<0))
+#define NF_SWC_RMZ_SEED_NUM_rand_seed_num_src(data)                                  ((0x00000007&(data))>>0)
+#define NF_SWC_RMZ_SEED_NUM_get_rand_seed_num(data)                                  ((0x00000007&(data))>>0)
+
+
+#define NF_SWC_PIN_MUX_STOP                                                          0x1802F25C
+#define NF_SWC_PIN_MUX_STOP_reg_addr                                                 "0xB802F25C"
+#define NF_SWC_PIN_MUX_STOP_reg                                                      0xB802F25C
+#define set_NF_SWC_PIN_MUX_STOP_reg(data)   (*((volatile unsigned int*) NF_SWC_PIN_MUX_STOP_reg)=data)
+#define get_NF_SWC_PIN_MUX_STOP_reg   (*((volatile unsigned int*) NF_SWC_PIN_MUX_STOP_reg))
+#define NF_SWC_PIN_MUX_STOP_inst_adr                                                 "0x0097"
+#define NF_SWC_PIN_MUX_STOP_inst                                                     0x0097
+#define NF_SWC_PIN_MUX_STOP_pin_stop_shift                                           (2)
+#define NF_SWC_PIN_MUX_STOP_pin_stop_mask                                            (0x00000004)
+#define NF_SWC_PIN_MUX_STOP_pin_stop(data)                                           (0x00000004&((data)<<2))
+#define NF_SWC_PIN_MUX_STOP_pin_stop_src(data)                                       ((0x00000004&(data))>>2)
+#define NF_SWC_PIN_MUX_STOP_get_pin_stop(data)                                       ((0x00000004&(data))>>2)
+#define NF_SWC_PIN_MUX_STOP_intlev_pin_ena_shift                                     (1)
+#define NF_SWC_PIN_MUX_STOP_intlev_pin_ena_mask                                      (0x00000002)
+#define NF_SWC_PIN_MUX_STOP_intlev_pin_ena(data)                                     (0x00000002&((data)<<1))
+#define NF_SWC_PIN_MUX_STOP_intlev_pin_ena_src(data)                                 ((0x00000002&(data))>>1)
+#define NF_SWC_PIN_MUX_STOP_get_intlev_pin_ena(data)                                 ((0x00000002&(data))>>1)
+#define NF_SWC_PIN_MUX_STOP_pin_mux_ena_shift                                        (0)
+#define NF_SWC_PIN_MUX_STOP_pin_mux_ena_mask                                         (0x00000001)
+#define NF_SWC_PIN_MUX_STOP_pin_mux_ena(data)                                        (0x00000001&((data)<<0))
+#define NF_SWC_PIN_MUX_STOP_pin_mux_ena_src(data)                                    ((0x00000001&(data))>>0)
+#define NF_SWC_PIN_MUX_STOP_get_pin_mux_ena(data)                                    ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_DELAY_CTL                                                             0x1802F260
+#define NF_SWC_DELAY_CTL_reg_addr                                                    "0xB802F260"
+#define NF_SWC_DELAY_CTL_reg                                                         0xB802F260
+#define set_NF_SWC_DELAY_CTL_reg(data)   (*((volatile unsigned int*) NF_SWC_DELAY_CTL_reg)=data)
+#define get_NF_SWC_DELAY_CTL_reg   (*((volatile unsigned int*) NF_SWC_DELAY_CTL_reg))
+#define NF_SWC_DELAY_CTL_inst_adr                                                    "0x0098"
+#define NF_SWC_DELAY_CTL_inst                                                        0x0098
+#define NF_SWC_DELAY_CTL_T_swait_busy_shift                                          (6)
+#define NF_SWC_DELAY_CTL_T_swait_busy_mask                                           (0x000000C0)
+#define NF_SWC_DELAY_CTL_T_swait_busy(data)                                          (0x000000C0&((data)<<6))
+#define NF_SWC_DELAY_CTL_T_swait_busy_src(data)                                      ((0x000000C0&(data))>>6)
+#define NF_SWC_DELAY_CTL_get_T_swait_busy(data)                                      ((0x000000C0&(data))>>6)
+#define NF_SWC_DELAY_CTL_T_WHR_ADL_shift                                             (0)
+#define NF_SWC_DELAY_CTL_T_WHR_ADL_mask                                              (0x0000003F)
+#define NF_SWC_DELAY_CTL_T_WHR_ADL(data)                                             (0x0000003F&((data)<<0))
+#define NF_SWC_DELAY_CTL_T_WHR_ADL_src(data)                                         ((0x0000003F&(data))>>0)
+#define NF_SWC_DELAY_CTL_get_T_WHR_ADL(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define NF_SWC_ECC_STOP                                                              0x1802F264
+#define NF_SWC_ECC_STOP_reg_addr                                                     "0xB802F264"
+#define NF_SWC_ECC_STOP_reg                                                          0xB802F264
+#define set_NF_SWC_ECC_STOP_reg(data)   (*((volatile unsigned int*) NF_SWC_ECC_STOP_reg)=data)
+#define get_NF_SWC_ECC_STOP_reg   (*((volatile unsigned int*) NF_SWC_ECC_STOP_reg))
+#define NF_SWC_ECC_STOP_inst_adr                                                     "0x0099"
+#define NF_SWC_ECC_STOP_inst                                                         0x0099
+#define NF_SWC_ECC_STOP_ecc_n_stop_shift                                             (7)
+#define NF_SWC_ECC_STOP_ecc_n_stop_mask                                              (0x00000080)
+#define NF_SWC_ECC_STOP_ecc_n_stop(data)                                             (0x00000080&((data)<<7))
+#define NF_SWC_ECC_STOP_ecc_n_stop_src(data)                                         ((0x00000080&(data))>>7)
+#define NF_SWC_ECC_STOP_get_ecc_n_stop(data)                                         ((0x00000080&(data))>>7)
+
+
+#define NF_SWC_ECC_PAGE                                                              0x1802F268
+#define NF_SWC_ECC_PAGE_reg_addr                                                     "0xB802F268"
+#define NF_SWC_ECC_PAGE_reg                                                          0xB802F268
+#define set_NF_SWC_ECC_PAGE_reg(data)   (*((volatile unsigned int*) NF_SWC_ECC_PAGE_reg)=data)
+#define get_NF_SWC_ECC_PAGE_reg   (*((volatile unsigned int*) NF_SWC_ECC_PAGE_reg))
+#define NF_SWC_ECC_PAGE_inst_adr                                                     "0x009A"
+#define NF_SWC_ECC_PAGE_inst                                                         0x009A
+#define NF_SWC_ECC_PAGE_ecc_page_shift                                               (0)
+#define NF_SWC_ECC_PAGE_ecc_page_mask                                                (0x000000FF)
+#define NF_SWC_ECC_PAGE_ecc_page(data)                                               (0x000000FF&((data)<<0))
+#define NF_SWC_ECC_PAGE_ecc_page_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_SWC_ECC_PAGE_get_ecc_page(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_PAGE_CNT                                                              0x1802F26C
+#define NF_SWC_PAGE_CNT_reg_addr                                                     "0xB802F26C"
+#define NF_SWC_PAGE_CNT_reg                                                          0xB802F26C
+#define set_NF_SWC_PAGE_CNT_reg(data)   (*((volatile unsigned int*) NF_SWC_PAGE_CNT_reg)=data)
+#define get_NF_SWC_PAGE_CNT_reg   (*((volatile unsigned int*) NF_SWC_PAGE_CNT_reg))
+#define NF_SWC_PAGE_CNT_inst_adr                                                     "0x009B"
+#define NF_SWC_PAGE_CNT_inst                                                         0x009B
+#define NF_SWC_PAGE_CNT_page_cnt_shift                                               (0)
+#define NF_SWC_PAGE_CNT_page_cnt_mask                                                (0x000000FF)
+#define NF_SWC_PAGE_CNT_page_cnt(data)                                               (0x000000FF&((data)<<0))
+#define NF_SWC_PAGE_CNT_page_cnt_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_SWC_PAGE_CNT_get_page_cnt(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_PAGE_LEN                                                              0x1802F270
+#define NF_SWC_PAGE_LEN_reg_addr                                                     "0xB802F270"
+#define NF_SWC_PAGE_LEN_reg                                                          0xB802F270
+#define set_NF_SWC_PAGE_LEN_reg(data)   (*((volatile unsigned int*) NF_SWC_PAGE_LEN_reg)=data)
+#define get_NF_SWC_PAGE_LEN_reg   (*((volatile unsigned int*) NF_SWC_PAGE_LEN_reg))
+#define NF_SWC_PAGE_LEN_inst_adr                                                     "0x009C"
+#define NF_SWC_PAGE_LEN_inst                                                         0x009C
+#define NF_SWC_PAGE_LEN_page_len_shift                                               (0)
+#define NF_SWC_PAGE_LEN_page_len_mask                                                (0x000000FF)
+#define NF_SWC_PAGE_LEN_page_len(data)                                               (0x000000FF&((data)<<0))
+#define NF_SWC_PAGE_LEN_page_len_src(data)                                           ((0x000000FF&(data))>>0)
+#define NF_SWC_PAGE_LEN_get_page_len(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_CMD2                                                                  0x1802F274
+#define NF_SWC_CMD2_reg_addr                                                         "0xB802F274"
+#define NF_SWC_CMD2_reg                                                              0xB802F274
+#define set_NF_SWC_CMD2_reg(data)   (*((volatile unsigned int*) NF_SWC_CMD2_reg)=data)
+#define get_NF_SWC_CMD2_reg   (*((volatile unsigned int*) NF_SWC_CMD2_reg))
+#define NF_SWC_CMD2_inst_adr                                                         "0x009D"
+#define NF_SWC_CMD2_inst                                                             0x009D
+#define NF_SWC_CMD2_cmd2_shift                                                       (0)
+#define NF_SWC_CMD2_cmd2_mask                                                        (0x000000FF)
+#define NF_SWC_CMD2_cmd2(data)                                                       (0x000000FF&((data)<<0))
+#define NF_SWC_CMD2_cmd2_src(data)                                                   ((0x000000FF&(data))>>0)
+#define NF_SWC_CMD2_get_cmd2(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define NF_SWC_MULTI_CHNL_MODE                                                       0x1802F27C
+#define NF_SWC_MULTI_CHNL_MODE_reg_addr                                              "0xB802F27C"
+#define NF_SWC_MULTI_CHNL_MODE_reg                                                   0xB802F27C
+#define set_NF_SWC_MULTI_CHNL_MODE_reg(data)   (*((volatile unsigned int*) NF_SWC_MULTI_CHNL_MODE_reg)=data)
+#define get_NF_SWC_MULTI_CHNL_MODE_reg   (*((volatile unsigned int*) NF_SWC_MULTI_CHNL_MODE_reg))
+#define NF_SWC_MULTI_CHNL_MODE_inst_adr                                              "0x009F"
+#define NF_SWC_MULTI_CHNL_MODE_inst                                                  0x009F
+#define NF_SWC_MULTI_CHNL_MODE_ecc_pass_shift                                        (7)
+#define NF_SWC_MULTI_CHNL_MODE_ecc_pass_mask                                         (0x00000080)
+#define NF_SWC_MULTI_CHNL_MODE_ecc_pass(data)                                        (0x00000080&((data)<<7))
+#define NF_SWC_MULTI_CHNL_MODE_ecc_pass_src(data)                                    ((0x00000080&(data))>>7)
+#define NF_SWC_MULTI_CHNL_MODE_get_ecc_pass(data)                                    ((0x00000080&(data))>>7)
+#define NF_SWC_MULTI_CHNL_MODE_ecc_no_check_shift                                    (6)
+#define NF_SWC_MULTI_CHNL_MODE_ecc_no_check_mask                                     (0x00000040)
+#define NF_SWC_MULTI_CHNL_MODE_ecc_no_check(data)                                    (0x00000040&((data)<<6))
+#define NF_SWC_MULTI_CHNL_MODE_ecc_no_check_src(data)                                ((0x00000040&(data))>>6)
+#define NF_SWC_MULTI_CHNL_MODE_get_ecc_no_check(data)                                ((0x00000040&(data))>>6)
+#define NF_SWC_MULTI_CHNL_MODE_edo_shift                                             (5)
+#define NF_SWC_MULTI_CHNL_MODE_edo_mask                                              (0x00000020)
+#define NF_SWC_MULTI_CHNL_MODE_edo(data)                                             (0x00000020&((data)<<5))
+#define NF_SWC_MULTI_CHNL_MODE_edo_src(data)                                         ((0x00000020&(data))>>5)
+#define NF_SWC_MULTI_CHNL_MODE_get_edo(data)                                         ((0x00000020&(data))>>5)
+#define NF_SWC_MULTI_CHNL_MODE_no_wait_busy_shift                                    (4)
+#define NF_SWC_MULTI_CHNL_MODE_no_wait_busy_mask                                     (0x00000010)
+#define NF_SWC_MULTI_CHNL_MODE_no_wait_busy(data)                                    (0x00000010&((data)<<4))
+#define NF_SWC_MULTI_CHNL_MODE_no_wait_busy_src(data)                                ((0x00000010&(data))>>4)
+#define NF_SWC_MULTI_CHNL_MODE_get_no_wait_busy(data)                                ((0x00000010&(data))>>4)
+#define NF_SWC_MULTI_CHNL_MODE_wait_ready_shift                                      (2)
+#define NF_SWC_MULTI_CHNL_MODE_wait_ready_mask                                       (0x0000000C)
+#define NF_SWC_MULTI_CHNL_MODE_wait_ready(data)                                      (0x0000000C&((data)<<2))
+#define NF_SWC_MULTI_CHNL_MODE_wait_ready_src(data)                                  ((0x0000000C&(data))>>2)
+#define NF_SWC_MULTI_CHNL_MODE_get_wait_ready(data)                                  ((0x0000000C&(data))>>2)
+
+
+#define NF_SWC_SRAM_CTL                                                              0x1802F300
+#define NF_SWC_SRAM_CTL_reg_addr                                                     "0xB802F300"
+#define NF_SWC_SRAM_CTL_reg                                                          0xB802F300
+#define set_NF_SWC_SRAM_CTL_reg(data)   (*((volatile unsigned int*) NF_SWC_SRAM_CTL_reg)=data)
+#define get_NF_SWC_SRAM_CTL_reg   (*((volatile unsigned int*) NF_SWC_SRAM_CTL_reg))
+#define NF_SWC_SRAM_CTL_inst_adr                                                     "0x00C0"
+#define NF_SWC_SRAM_CTL_inst                                                         0x00C0
+#define NF_SWC_SRAM_CTL_map_sel_shift                                                (5)
+#define NF_SWC_SRAM_CTL_map_sel_mask                                                 (0x00000020)
+#define NF_SWC_SRAM_CTL_map_sel(data)                                                (0x00000020&((data)<<5))
+#define NF_SWC_SRAM_CTL_map_sel_src(data)                                            ((0x00000020&(data))>>5)
+#define NF_SWC_SRAM_CTL_get_map_sel(data)                                            ((0x00000020&(data))>>5)
+#define NF_SWC_SRAM_CTL_access_en_shift                                              (4)
+#define NF_SWC_SRAM_CTL_access_en_mask                                               (0x00000010)
+#define NF_SWC_SRAM_CTL_access_en(data)                                              (0x00000010&((data)<<4))
+#define NF_SWC_SRAM_CTL_access_en_src(data)                                          ((0x00000010&(data))>>4)
+#define NF_SWC_SRAM_CTL_get_access_en(data)                                          ((0x00000010&(data))>>4)
+#define NF_SWC_SRAM_CTL_mem_region_shift                                             (0)
+#define NF_SWC_SRAM_CTL_mem_region_mask                                              (0x0000000F)
+#define NF_SWC_SRAM_CTL_mem_region(data)                                             (0x0000000F&((data)<<0))
+#define NF_SWC_SRAM_CTL_mem_region_src(data)                                         ((0x0000000F&(data))>>0)
+#define NF_SWC_SRAM_CTL_get_mem_region(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define NF_SWC_DMA_CTL1                                                              0x1802F304
+#define NF_SWC_DMA_CTL1_reg_addr                                                     "0xB802F304"
+#define NF_SWC_DMA_CTL1_reg                                                          0xB802F304
+#define set_NF_SWC_DMA_CTL1_reg(data)   (*((volatile unsigned int*) NF_SWC_DMA_CTL1_reg)=data)
+#define get_NF_SWC_DMA_CTL1_reg   (*((volatile unsigned int*) NF_SWC_DMA_CTL1_reg))
+#define NF_SWC_DMA_CTL1_inst_adr                                                     "0x00C1"
+#define NF_SWC_DMA_CTL1_inst                                                         0x00C1
+#define NF_SWC_DMA_CTL1_dram_sa_shift                                                (0)
+#define NF_SWC_DMA_CTL1_dram_sa_mask                                                 (0x0FFFFFFF)
+#define NF_SWC_DMA_CTL1_dram_sa(data)                                                (0x0FFFFFFF&((data)<<0))
+#define NF_SWC_DMA_CTL1_dram_sa_src(data)                                            ((0x0FFFFFFF&(data))>>0)
+#define NF_SWC_DMA_CTL1_get_dram_sa(data)                                            ((0x0FFFFFFF&(data))>>0)
+
+
+#define NF_SWC_DMA_CTL2                                                              0x1802F308
+#define NF_SWC_DMA_CTL2_reg_addr                                                     "0xB802F308"
+#define NF_SWC_DMA_CTL2_reg                                                          0xB802F308
+#define set_NF_SWC_DMA_CTL2_reg(data)   (*((volatile unsigned int*) NF_SWC_DMA_CTL2_reg)=data)
+#define get_NF_SWC_DMA_CTL2_reg   (*((volatile unsigned int*) NF_SWC_DMA_CTL2_reg))
+#define NF_SWC_DMA_CTL2_inst_adr                                                     "0x00C2"
+#define NF_SWC_DMA_CTL2_inst                                                         0x00C2
+#define NF_SWC_DMA_CTL2_dma_len_shift                                                (0)
+#define NF_SWC_DMA_CTL2_dma_len_mask                                                 (0x0000FFFF)
+#define NF_SWC_DMA_CTL2_dma_len(data)                                                (0x0000FFFF&((data)<<0))
+#define NF_SWC_DMA_CTL2_dma_len_src(data)                                            ((0x0000FFFF&(data))>>0)
+#define NF_SWC_DMA_CTL2_get_dma_len(data)                                            ((0x0000FFFF&(data))>>0)
+
+
+#define NF_SWC_DMA_CTL3                                                              0x1802F30C
+#define NF_SWC_DMA_CTL3_reg_addr                                                     "0xB802F30C"
+#define NF_SWC_DMA_CTL3_reg                                                          0xB802F30C
+#define set_NF_SWC_DMA_CTL3_reg(data)   (*((volatile unsigned int*) NF_SWC_DMA_CTL3_reg)=data)
+#define get_NF_SWC_DMA_CTL3_reg   (*((volatile unsigned int*) NF_SWC_DMA_CTL3_reg))
+#define NF_SWC_DMA_CTL3_inst_adr                                                     "0x00C3"
+#define NF_SWC_DMA_CTL3_inst                                                         0x00C3
+#define NF_SWC_DMA_CTL3_cp_first_shift                                               (3)
+#define NF_SWC_DMA_CTL3_cp_first_mask                                                (0x00000008)
+#define NF_SWC_DMA_CTL3_cp_first(data)                                               (0x00000008&((data)<<3))
+#define NF_SWC_DMA_CTL3_cp_first_src(data)                                           ((0x00000008&(data))>>3)
+#define NF_SWC_DMA_CTL3_get_cp_first(data)                                           ((0x00000008&(data))>>3)
+#define NF_SWC_DMA_CTL3_cp_enable_shift                                              (2)
+#define NF_SWC_DMA_CTL3_cp_enable_mask                                               (0x00000004)
+#define NF_SWC_DMA_CTL3_cp_enable(data)                                              (0x00000004&((data)<<2))
+#define NF_SWC_DMA_CTL3_cp_enable_src(data)                                          ((0x00000004&(data))>>2)
+#define NF_SWC_DMA_CTL3_get_cp_enable(data)                                          ((0x00000004&(data))>>2)
+#define NF_SWC_DMA_CTL3_ddr_wr_shift                                                 (1)
+#define NF_SWC_DMA_CTL3_ddr_wr_mask                                                  (0x00000002)
+#define NF_SWC_DMA_CTL3_ddr_wr(data)                                                 (0x00000002&((data)<<1))
+#define NF_SWC_DMA_CTL3_ddr_wr_src(data)                                             ((0x00000002&(data))>>1)
+#define NF_SWC_DMA_CTL3_get_ddr_wr(data)                                             ((0x00000002&(data))>>1)
+#define NF_SWC_DMA_CTL3_dma_xfer_shift                                               (0)
+#define NF_SWC_DMA_CTL3_dma_xfer_mask                                                (0x00000001)
+#define NF_SWC_DMA_CTL3_dma_xfer(data)                                               (0x00000001&((data)<<0))
+#define NF_SWC_DMA_CTL3_dma_xfer_src(data)                                           ((0x00000001&(data))>>0)
+#define NF_SWC_DMA_CTL3_get_dma_xfer(data)                                           ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_SYS_LOW_PWR                                                           0x1802F310
+#define NF_SWC_SYS_LOW_PWR_reg_addr                                                  "0xB802F310"
+#define NF_SWC_SYS_LOW_PWR_reg                                                       0xB802F310
+#define set_NF_SWC_SYS_LOW_PWR_reg(data)   (*((volatile unsigned int*) NF_SWC_SYS_LOW_PWR_reg)=data)
+#define get_NF_SWC_SYS_LOW_PWR_reg   (*((volatile unsigned int*) NF_SWC_SYS_LOW_PWR_reg))
+#define NF_SWC_SYS_LOW_PWR_inst_adr                                                  "0x00C4"
+#define NF_SWC_SYS_LOW_PWR_inst                                                      0x00C4
+#define NF_SWC_SYS_LOW_PWR_mcu_pp_sram_lp_ena_shift                                  (7)
+#define NF_SWC_SYS_LOW_PWR_mcu_pp_sram_lp_ena_mask                                   (0x00000080)
+#define NF_SWC_SYS_LOW_PWR_mcu_pp_sram_lp_ena(data)                                  (0x00000080&((data)<<7))
+#define NF_SWC_SYS_LOW_PWR_mcu_pp_sram_lp_ena_src(data)                              ((0x00000080&(data))>>7)
+#define NF_SWC_SYS_LOW_PWR_get_mcu_pp_sram_lp_ena(data)                              ((0x00000080&(data))>>7)
+#define NF_SWC_SYS_LOW_PWR_sys_clk_gate_ena_shift                                    (6)
+#define NF_SWC_SYS_LOW_PWR_sys_clk_gate_ena_mask                                     (0x00000040)
+#define NF_SWC_SYS_LOW_PWR_sys_clk_gate_ena(data)                                    (0x00000040&((data)<<6))
+#define NF_SWC_SYS_LOW_PWR_sys_clk_gate_ena_src(data)                                ((0x00000040&(data))>>6)
+#define NF_SWC_SYS_LOW_PWR_get_sys_clk_gate_ena(data)                                ((0x00000040&(data))>>6)
+#define NF_SWC_SYS_LOW_PWR_cp_clk_gate_ena_shift                                     (5)
+#define NF_SWC_SYS_LOW_PWR_cp_clk_gate_ena_mask                                      (0x00000020)
+#define NF_SWC_SYS_LOW_PWR_cp_clk_gate_ena(data)                                     (0x00000020&((data)<<5))
+#define NF_SWC_SYS_LOW_PWR_cp_clk_gate_ena_src(data)                                 ((0x00000020&(data))>>5)
+#define NF_SWC_SYS_LOW_PWR_get_cp_clk_gate_ena(data)                                 ((0x00000020&(data))>>5)
+#define NF_SWC_SYS_LOW_PWR_dma_sram_lp_ena_shift                                     (4)
+#define NF_SWC_SYS_LOW_PWR_dma_sram_lp_ena_mask                                      (0x00000010)
+#define NF_SWC_SYS_LOW_PWR_dma_sram_lp_ena(data)                                     (0x00000010&((data)<<4))
+#define NF_SWC_SYS_LOW_PWR_dma_sram_lp_ena_src(data)                                 ((0x00000010&(data))>>4)
+#define NF_SWC_SYS_LOW_PWR_get_dma_sram_lp_ena(data)                                 ((0x00000010&(data))>>4)
+#define NF_SWC_SYS_LOW_PWR_dma_sram_rdy_num_shift                                    (0)
+#define NF_SWC_SYS_LOW_PWR_dma_sram_rdy_num_mask                                     (0x0000000F)
+#define NF_SWC_SYS_LOW_PWR_dma_sram_rdy_num(data)                                    (0x0000000F&((data)<<0))
+#define NF_SWC_SYS_LOW_PWR_dma_sram_rdy_num_src(data)                                ((0x0000000F&(data))>>0)
+#define NF_SWC_SYS_LOW_PWR_get_dma_sram_rdy_num(data)                                ((0x0000000F&(data))>>0)
+
+
+#define NF_SWC_NAND_ISR                                                              0x1802F324
+#define NF_SWC_NAND_ISR_reg_addr                                                     "0xB802F324"
+#define NF_SWC_NAND_ISR_reg                                                          0xB802F324
+#define set_NF_SWC_NAND_ISR_reg(data)   (*((volatile unsigned int*) NF_SWC_NAND_ISR_reg)=data)
+#define get_NF_SWC_NAND_ISR_reg   (*((volatile unsigned int*) NF_SWC_NAND_ISR_reg))
+#define NF_SWC_NAND_ISR_inst_adr                                                     "0x00C9"
+#define NF_SWC_NAND_ISR_inst                                                         0x00C9
+#define NF_SWC_NAND_ISR_Int8_shift                                                   (8)
+#define NF_SWC_NAND_ISR_Int8_mask                                                    (0x00000100)
+#define NF_SWC_NAND_ISR_Int8(data)                                                   (0x00000100&((data)<<8))
+#define NF_SWC_NAND_ISR_Int8_src(data)                                               ((0x00000100&(data))>>8)
+#define NF_SWC_NAND_ISR_get_Int8(data)                                               ((0x00000100&(data))>>8)
+#define NF_SWC_NAND_ISR_Int7_shift                                                   (7)
+#define NF_SWC_NAND_ISR_Int7_mask                                                    (0x00000080)
+#define NF_SWC_NAND_ISR_Int7(data)                                                   (0x00000080&((data)<<7))
+#define NF_SWC_NAND_ISR_Int7_src(data)                                               ((0x00000080&(data))>>7)
+#define NF_SWC_NAND_ISR_get_Int7(data)                                               ((0x00000080&(data))>>7)
+#define NF_SWC_NAND_ISR_Int4_shift                                                   (4)
+#define NF_SWC_NAND_ISR_Int4_mask                                                    (0x00000010)
+#define NF_SWC_NAND_ISR_Int4(data)                                                   (0x00000010&((data)<<4))
+#define NF_SWC_NAND_ISR_Int4_src(data)                                               ((0x00000010&(data))>>4)
+#define NF_SWC_NAND_ISR_get_Int4(data)                                               ((0x00000010&(data))>>4)
+#define NF_SWC_NAND_ISR_Int3_shift                                                   (3)
+#define NF_SWC_NAND_ISR_Int3_mask                                                    (0x00000008)
+#define NF_SWC_NAND_ISR_Int3(data)                                                   (0x00000008&((data)<<3))
+#define NF_SWC_NAND_ISR_Int3_src(data)                                               ((0x00000008&(data))>>3)
+#define NF_SWC_NAND_ISR_get_Int3(data)                                               ((0x00000008&(data))>>3)
+#define NF_SWC_NAND_ISR_Int2_shift                                                   (2)
+#define NF_SWC_NAND_ISR_Int2_mask                                                    (0x00000004)
+#define NF_SWC_NAND_ISR_Int2(data)                                                   (0x00000004&((data)<<2))
+#define NF_SWC_NAND_ISR_Int2_src(data)                                               ((0x00000004&(data))>>2)
+#define NF_SWC_NAND_ISR_get_Int2(data)                                               ((0x00000004&(data))>>2)
+#define NF_SWC_NAND_ISR_Int1_shift                                                   (1)
+#define NF_SWC_NAND_ISR_Int1_mask                                                    (0x00000002)
+#define NF_SWC_NAND_ISR_Int1(data)                                                   (0x00000002&((data)<<1))
+#define NF_SWC_NAND_ISR_Int1_src(data)                                               ((0x00000002&(data))>>1)
+#define NF_SWC_NAND_ISR_get_Int1(data)                                               ((0x00000002&(data))>>1)
+#define NF_SWC_NAND_ISR_write_data_shift                                             (0)
+#define NF_SWC_NAND_ISR_write_data_mask                                              (0x00000001)
+#define NF_SWC_NAND_ISR_write_data(data)                                             (0x00000001&((data)<<0))
+#define NF_SWC_NAND_ISR_write_data_src(data)                                         ((0x00000001&(data))>>0)
+#define NF_SWC_NAND_ISR_get_write_data(data)                                         ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_NAND_ISREN                                                            0x1802F328
+#define NF_SWC_NAND_ISREN_reg_addr                                                   "0xB802F328"
+#define NF_SWC_NAND_ISREN_reg                                                        0xB802F328
+#define set_NF_SWC_NAND_ISREN_reg(data)   (*((volatile unsigned int*) NF_SWC_NAND_ISREN_reg)=data)
+#define get_NF_SWC_NAND_ISREN_reg   (*((volatile unsigned int*) NF_SWC_NAND_ISREN_reg))
+#define NF_SWC_NAND_ISREN_inst_adr                                                   "0x00CA"
+#define NF_SWC_NAND_ISREN_inst                                                       0x00CA
+#define NF_SWC_NAND_ISREN_Int8En_shift                                               (8)
+#define NF_SWC_NAND_ISREN_Int8En_mask                                                (0x00000100)
+#define NF_SWC_NAND_ISREN_Int8En(data)                                               (0x00000100&((data)<<8))
+#define NF_SWC_NAND_ISREN_Int8En_src(data)                                           ((0x00000100&(data))>>8)
+#define NF_SWC_NAND_ISREN_get_Int8En(data)                                           ((0x00000100&(data))>>8)
+#define NF_SWC_NAND_ISREN_Int7En_shift                                               (7)
+#define NF_SWC_NAND_ISREN_Int7En_mask                                                (0x00000080)
+#define NF_SWC_NAND_ISREN_Int7En(data)                                               (0x00000080&((data)<<7))
+#define NF_SWC_NAND_ISREN_Int7En_src(data)                                           ((0x00000080&(data))>>7)
+#define NF_SWC_NAND_ISREN_get_Int7En(data)                                           ((0x00000080&(data))>>7)
+#define NF_SWC_NAND_ISREN_Int4En_shift                                               (4)
+#define NF_SWC_NAND_ISREN_Int4En_mask                                                (0x00000010)
+#define NF_SWC_NAND_ISREN_Int4En(data)                                               (0x00000010&((data)<<4))
+#define NF_SWC_NAND_ISREN_Int4En_src(data)                                           ((0x00000010&(data))>>4)
+#define NF_SWC_NAND_ISREN_get_Int4En(data)                                           ((0x00000010&(data))>>4)
+#define NF_SWC_NAND_ISREN_Int3En_shift                                               (3)
+#define NF_SWC_NAND_ISREN_Int3En_mask                                                (0x00000008)
+#define NF_SWC_NAND_ISREN_Int3En(data)                                               (0x00000008&((data)<<3))
+#define NF_SWC_NAND_ISREN_Int3En_src(data)                                           ((0x00000008&(data))>>3)
+#define NF_SWC_NAND_ISREN_get_Int3En(data)                                           ((0x00000008&(data))>>3)
+#define NF_SWC_NAND_ISREN_Int2En_shift                                               (2)
+#define NF_SWC_NAND_ISREN_Int2En_mask                                                (0x00000004)
+#define NF_SWC_NAND_ISREN_Int2En(data)                                               (0x00000004&((data)<<2))
+#define NF_SWC_NAND_ISREN_Int2En_src(data)                                           ((0x00000004&(data))>>2)
+#define NF_SWC_NAND_ISREN_get_Int2En(data)                                           ((0x00000004&(data))>>2)
+#define NF_SWC_NAND_ISREN_Int1En_shift                                               (1)
+#define NF_SWC_NAND_ISREN_Int1En_mask                                                (0x00000002)
+#define NF_SWC_NAND_ISREN_Int1En(data)                                               (0x00000002&((data)<<1))
+#define NF_SWC_NAND_ISREN_Int1En_src(data)                                           ((0x00000002&(data))>>1)
+#define NF_SWC_NAND_ISREN_get_Int1En(data)                                           ((0x00000002&(data))>>1)
+#define NF_SWC_NAND_ISREN_write_data_shift                                           (0)
+#define NF_SWC_NAND_ISREN_write_data_mask                                            (0x00000001)
+#define NF_SWC_NAND_ISREN_write_data(data)                                           (0x00000001&((data)<<0))
+#define NF_SWC_NAND_ISREN_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define NF_SWC_NAND_ISREN_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_DUMMY_SYS                                                             0x1802F32C
+#define NF_SWC_DUMMY_SYS_reg_addr                                                    "0xB802F32C"
+#define NF_SWC_DUMMY_SYS_reg                                                         0xB802F32C
+#define set_NF_SWC_DUMMY_SYS_reg(data)   (*((volatile unsigned int*) NF_SWC_DUMMY_SYS_reg)=data)
+#define get_NF_SWC_DUMMY_SYS_reg   (*((volatile unsigned int*) NF_SWC_DUMMY_SYS_reg))
+#define NF_SWC_DUMMY_SYS_inst_adr                                                    "0x00CB"
+#define NF_SWC_DUMMY_SYS_inst                                                        0x00CB
+#define NF_SWC_DUMMY_SYS_dmy_shift                                                   (0)
+#define NF_SWC_DUMMY_SYS_dmy_mask                                                    (0xFFFFFFFF)
+#define NF_SWC_DUMMY_SYS_dmy(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define NF_SWC_DUMMY_SYS_dmy_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define NF_SWC_DUMMY_SYS_get_dmy(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define NF_SWC_DBG                                                                   0x1802F344
+#define NF_SWC_DBG_reg_addr                                                          "0xB802F344"
+#define NF_SWC_DBG_reg                                                               0xB802F344
+#define set_NF_SWC_DBG_reg(data)   (*((volatile unsigned int*) NF_SWC_DBG_reg)=data)
+#define get_NF_SWC_DBG_reg   (*((volatile unsigned int*) NF_SWC_DBG_reg))
+#define NF_SWC_DBG_inst_adr                                                          "0x00D1"
+#define NF_SWC_DBG_inst                                                              0x00D1
+#define NF_SWC_DBG_write_enable3_shift                                               (9)
+#define NF_SWC_DBG_write_enable3_mask                                                (0x00000200)
+#define NF_SWC_DBG_write_enable3(data)                                               (0x00000200&((data)<<9))
+#define NF_SWC_DBG_write_enable3_src(data)                                           ((0x00000200&(data))>>9)
+#define NF_SWC_DBG_get_write_enable3(data)                                           ((0x00000200&(data))>>9)
+#define NF_SWC_DBG_sel1_shift                                                        (6)
+#define NF_SWC_DBG_sel1_mask                                                         (0x000001C0)
+#define NF_SWC_DBG_sel1(data)                                                        (0x000001C0&((data)<<6))
+#define NF_SWC_DBG_sel1_src(data)                                                    ((0x000001C0&(data))>>6)
+#define NF_SWC_DBG_get_sel1(data)                                                    ((0x000001C0&(data))>>6)
+#define NF_SWC_DBG_write_enable2_shift                                               (5)
+#define NF_SWC_DBG_write_enable2_mask                                                (0x00000020)
+#define NF_SWC_DBG_write_enable2(data)                                               (0x00000020&((data)<<5))
+#define NF_SWC_DBG_write_enable2_src(data)                                           ((0x00000020&(data))>>5)
+#define NF_SWC_DBG_get_write_enable2(data)                                           ((0x00000020&(data))>>5)
+#define NF_SWC_DBG_sel0_shift                                                        (2)
+#define NF_SWC_DBG_sel0_mask                                                         (0x0000001C)
+#define NF_SWC_DBG_sel0(data)                                                        (0x0000001C&((data)<<2))
+#define NF_SWC_DBG_sel0_src(data)                                                    ((0x0000001C&(data))>>2)
+#define NF_SWC_DBG_get_sel0(data)                                                    ((0x0000001C&(data))>>2)
+#define NF_SWC_DBG_write_enable1_shift                                               (1)
+#define NF_SWC_DBG_write_enable1_mask                                                (0x00000002)
+#define NF_SWC_DBG_write_enable1(data)                                               (0x00000002&((data)<<1))
+#define NF_SWC_DBG_write_enable1_src(data)                                           ((0x00000002&(data))>>1)
+#define NF_SWC_DBG_get_write_enable1(data)                                           ((0x00000002&(data))>>1)
+#define NF_SWC_DBG_enable_shift                                                      (0)
+#define NF_SWC_DBG_enable_mask                                                       (0x00000001)
+#define NF_SWC_DBG_enable(data)                                                      (0x00000001&((data)<<0))
+#define NF_SWC_DBG_enable_src(data)                                                  ((0x00000001&(data))>>0)
+#define NF_SWC_DBG_get_enable(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define NF_SWC_SPR_DDR_CTL                                                           0x1802F348
+#define NF_SWC_SPR_DDR_CTL_reg_addr                                                  "0xB802F348"
+#define NF_SWC_SPR_DDR_CTL_reg                                                       0xB802F348
+#define set_NF_SWC_SPR_DDR_CTL_reg(data)   (*((volatile unsigned int*) NF_SWC_SPR_DDR_CTL_reg)=data)
+#define get_NF_SWC_SPR_DDR_CTL_reg   (*((volatile unsigned int*) NF_SWC_SPR_DDR_CTL_reg))
+#define NF_SWC_SPR_DDR_CTL_inst_adr                                                  "0x00D2"
+#define NF_SWC_SPR_DDR_CTL_inst                                                      0x00D2
+#define NF_SWC_SPR_DDR_CTL_cr_nf_hw_pinmux_ena_shift                                 (30)
+#define NF_SWC_SPR_DDR_CTL_cr_nf_hw_pinmux_ena_mask                                  (0x40000000)
+#define NF_SWC_SPR_DDR_CTL_cr_nf_hw_pinmux_ena(data)                                 (0x40000000&((data)<<30))
+#define NF_SWC_SPR_DDR_CTL_cr_nf_hw_pinmux_ena_src(data)                             ((0x40000000&(data))>>30)
+#define NF_SWC_SPR_DDR_CTL_get_cr_nf_hw_pinmux_ena(data)                             ((0x40000000&(data))>>30)
+#define NF_SWC_SPR_DDR_CTL_spare_ddr_ena_shift                                       (29)
+#define NF_SWC_SPR_DDR_CTL_spare_ddr_ena_mask                                        (0x20000000)
+#define NF_SWC_SPR_DDR_CTL_spare_ddr_ena(data)                                       (0x20000000&((data)<<29))
+#define NF_SWC_SPR_DDR_CTL_spare_ddr_ena_src(data)                                   ((0x20000000&(data))>>29)
+#define NF_SWC_SPR_DDR_CTL_get_spare_ddr_ena(data)                                   ((0x20000000&(data))>>29)
+#define NF_SWC_SPR_DDR_CTL_per_2k_spr_ena_shift                                      (28)
+#define NF_SWC_SPR_DDR_CTL_per_2k_spr_ena_mask                                       (0x10000000)
+#define NF_SWC_SPR_DDR_CTL_per_2k_spr_ena(data)                                      (0x10000000&((data)<<28))
+#define NF_SWC_SPR_DDR_CTL_per_2k_spr_ena_src(data)                                  ((0x10000000&(data))>>28)
+#define NF_SWC_SPR_DDR_CTL_get_per_2k_spr_ena(data)                                  ((0x10000000&(data))>>28)
+#define NF_SWC_SPR_DDR_CTL_spare_dram_sa_shift                                       (0)
+#define NF_SWC_SPR_DDR_CTL_spare_dram_sa_mask                                        (0x0FFFFFFF)
+#define NF_SWC_SPR_DDR_CTL_spare_dram_sa(data)                                       (0x0FFFFFFF&((data)<<0))
+#define NF_SWC_SPR_DDR_CTL_spare_dram_sa_src(data)                                   ((0x0FFFFFFF&(data))>>0)
+#define NF_SWC_SPR_DDR_CTL_get_spare_dram_sa(data)                                   ((0x0FFFFFFF&(data))>>0)
+
+
+#define NF_SWC_CP_LEN                                                                0x1802F34C
+#define NF_SWC_CP_LEN_reg_addr                                                       "0xB802F34C"
+#define NF_SWC_CP_LEN_reg                                                            0xB802F34C
+#define set_NF_SWC_CP_LEN_reg(data)   (*((volatile unsigned int*) NF_SWC_CP_LEN_reg)=data)
+#define get_NF_SWC_CP_LEN_reg   (*((volatile unsigned int*) NF_SWC_CP_LEN_reg))
+#define NF_SWC_CP_LEN_inst_adr                                                       "0x00D3"
+#define NF_SWC_CP_LEN_inst                                                           0x00D3
+#define NF_SWC_CP_LEN_cp_length_shift                                                (9)
+#define NF_SWC_CP_LEN_cp_length_mask                                                 (0x01FFFE00)
+#define NF_SWC_CP_LEN_cp_length(data)                                                (0x01FFFE00&((data)<<9))
+#define NF_SWC_CP_LEN_cp_length_src(data)                                            ((0x01FFFE00&(data))>>9)
+#define NF_SWC_CP_LEN_get_cp_length(data)                                            ((0x01FFFE00&(data))>>9)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/os/type.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/os/type.h
new file mode 100644
index 00000000..d869532
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/os/type.h
@@ -0,0 +1,15 @@
+#ifndef __FPGA_OS_TYPE_H__
+#define __FPGA_OS_TYPE_H__
+#include <rbus/reg.h>
+
+
+#define RTK_VIRT_ADDR_MAP(addr) (RBUS_BASE_VIRT + ((unsigned int)addr - RBUS_BASE_PHYS))
+
+#define WRITE_REG_INT32U(addr,val)  *(volatile unsigned int *) RTK_VIRT_ADDR_MAP(addr) = (unsigned int)(val)
+#define READ_REG_INT32U(addr)       *(volatile unsigned int *) RTK_VIRT_ADDR_MAP(addr)
+
+#define INT8U unsigned short int
+#define INT32U unsigned int
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/otp_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/otp_reg.h
new file mode 100644
index 00000000..79b7c5f
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/otp_reg.h
@@ -0,0 +1,1387 @@
+/**************************************************************
+// Spec Version                  : 1.4
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/3/15 11:19:38
+***************************************************************/
+
+
+#ifndef _OTP_REG_H_INCLUDED_
+#define _OTP_REG_H_INCLUDED_
+#ifdef  _OTP_USE_STRUCT
+typedef struct 
+{
+unsigned int     datao:32;
+}OTP_DATA;
+
+typedef struct 
+{
+unsigned int     write_en2:1;
+unsigned int     rvd3:6;
+unsigned int     auto_rd_otp_all:1;
+unsigned int     write_en1:1;
+unsigned int     rvd2:2;
+unsigned int     max_prog_num:5;
+unsigned int     rvd1:2;
+unsigned int     prog:1;
+unsigned int     a:13;
+}OTP_CTRL;
+
+typedef struct 
+{
+unsigned int     write_en3:1;
+unsigned int     rvd2:17;
+unsigned int     write_en2:1;
+unsigned int     crc_en:1;
+unsigned int     rvd1:3;
+unsigned int     write_en1:1;
+unsigned int     en_prog_func:8;
+}OTP_CTRL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     backdoor_allkeys_1:1;
+unsigned int     backdoor_f:1;
+unsigned int     reserved_1:2;
+unsigned int     ate_prog_otp_a_ov:1;
+unsigned int     reg_prog_otp_a_ov:1;
+unsigned int     otp_fail:1;
+unsigned int     otp_done:1;
+unsigned int     rd_hw_info_done:1;
+unsigned int     rd_boot_info_done:1;
+}OTP_STATUS;
+
+typedef struct 
+{
+unsigned int     crc_ini:16;
+unsigned int     crc_out:16;
+}OTP_CRC;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     trs:7;
+unsigned int     reserved_1:1;
+unsigned int     tcsrst:7;
+unsigned int     op_hold:16;
+}OTP_RW1;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     twcad:10;
+}OTP_RW2;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     treaden:4;
+}OTP_RD;
+
+typedef struct 
+{
+unsigned int     tcph:8;
+unsigned int     tpw:8;
+unsigned int     tcps:8;
+unsigned int     tpes:8;
+}OTP_PROG1;
+
+typedef struct 
+{
+unsigned int     tpvsa:4;
+unsigned int     tpvhr:4;
+unsigned int     trwh:4;
+unsigned int     tpgsv:4;
+unsigned int     tpvsr:8;
+unsigned int     tpeh:8;
+}OTP_PROG2;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     tbcacc:4;
+unsigned int     tcpes:4;
+unsigned int     reserved_1:2;
+unsigned int     tcprd:6;
+}OTP_BC;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     tacct:4;
+unsigned int     trdes:4;
+}OTP_TD;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     enable:1;
+unsigned int     sel1:4;
+unsigned int     sel0:4;
+}OTP_DBG;
+
+#endif
+
+#define OTP_DATA_0                                                                   0x18017000
+#define OTP_DATA_1                                                                   0x18017004
+#define OTP_DATA_2                                                                   0x18017008
+#define OTP_DATA_3                                                                   0x1801700C
+#define OTP_DATA_4                                                                   0x18017010
+#define OTP_DATA_5                                                                   0x18017014
+#define OTP_DATA_6                                                                   0x18017018
+#define OTP_DATA_7                                                                   0x1801701C
+#define OTP_DATA_8                                                                   0x18017020
+#define OTP_DATA_9                                                                   0x18017024
+#define OTP_DATA_10                                                                   0x18017028
+#define OTP_DATA_11                                                                   0x1801702C
+#define OTP_DATA_12                                                                   0x18017030
+#define OTP_DATA_13                                                                   0x18017034
+#define OTP_DATA_14                                                                   0x18017038
+#define OTP_DATA_15                                                                   0x1801703C
+#define OTP_DATA_16                                                                   0x18017040
+#define OTP_DATA_17                                                                   0x18017044
+#define OTP_DATA_18                                                                   0x18017048
+#define OTP_DATA_19                                                                   0x1801704C
+#define OTP_DATA_20                                                                   0x18017050
+#define OTP_DATA_21                                                                   0x18017054
+#define OTP_DATA_22                                                                   0x18017058
+#define OTP_DATA_23                                                                   0x1801705C
+#define OTP_DATA_24                                                                   0x18017060
+#define OTP_DATA_25                                                                   0x18017064
+#define OTP_DATA_26                                                                   0x18017068
+#define OTP_DATA_27                                                                   0x1801706C
+#define OTP_DATA_28                                                                   0x18017070
+#define OTP_DATA_29                                                                   0x18017074
+#define OTP_DATA_30                                                                   0x18017078
+#define OTP_DATA_31                                                                   0x1801707C
+#define OTP_DATA_32                                                                   0x18017080
+#define OTP_DATA_33                                                                   0x18017084
+#define OTP_DATA_34                                                                   0x18017088
+#define OTP_DATA_35                                                                   0x1801708C
+#define OTP_DATA_36                                                                   0x18017090
+#define OTP_DATA_37                                                                   0x18017094
+#define OTP_DATA_38                                                                   0x18017098
+#define OTP_DATA_39                                                                   0x1801709C
+#define OTP_DATA_40                                                                   0x180170A0
+#define OTP_DATA_41                                                                   0x180170A4
+#define OTP_DATA_42                                                                   0x180170A8
+#define OTP_DATA_43                                                                   0x180170AC
+#define OTP_DATA_44                                                                   0x180170B0
+#define OTP_DATA_45                                                                   0x180170B4
+#define OTP_DATA_46                                                                   0x180170B8
+#define OTP_DATA_47                                                                   0x180170BC
+#define OTP_DATA_48                                                                   0x180170C0
+#define OTP_DATA_49                                                                   0x180170C4
+#define OTP_DATA_50                                                                   0x180170C8
+#define OTP_DATA_51                                                                   0x180170CC
+#define OTP_DATA_52                                                                   0x180170D0
+#define OTP_DATA_53                                                                   0x180170D4
+#define OTP_DATA_54                                                                   0x180170D8
+#define OTP_DATA_55                                                                   0x180170DC
+#define OTP_DATA_56                                                                   0x180170E0
+#define OTP_DATA_57                                                                   0x180170E4
+#define OTP_DATA_58                                                                   0x180170E8
+#define OTP_DATA_59                                                                   0x180170EC
+#define OTP_DATA_60                                                                   0x180170F0
+#define OTP_DATA_61                                                                   0x180170F4
+#define OTP_DATA_62                                                                   0x180170F8
+#define OTP_DATA_63                                                                   0x180170FC
+#define OTP_DATA_64                                                                   0x18017100
+#define OTP_DATA_65                                                                   0x18017104
+#define OTP_DATA_66                                                                   0x18017108
+#define OTP_DATA_67                                                                   0x1801710C
+#define OTP_DATA_68                                                                   0x18017110
+#define OTP_DATA_69                                                                   0x18017114
+#define OTP_DATA_70                                                                   0x18017118
+#define OTP_DATA_71                                                                   0x1801711C
+#define OTP_DATA_72                                                                   0x18017120
+#define OTP_DATA_73                                                                   0x18017124
+#define OTP_DATA_74                                                                   0x18017128
+#define OTP_DATA_75                                                                   0x1801712C
+#define OTP_DATA_76                                                                   0x18017130
+#define OTP_DATA_77                                                                   0x18017134
+#define OTP_DATA_78                                                                   0x18017138
+#define OTP_DATA_79                                                                   0x1801713C
+#define OTP_DATA_80                                                                   0x18017140
+#define OTP_DATA_81                                                                   0x18017144
+#define OTP_DATA_82                                                                   0x18017148
+#define OTP_DATA_83                                                                   0x1801714C
+#define OTP_DATA_84                                                                   0x18017150
+#define OTP_DATA_85                                                                   0x18017154
+#define OTP_DATA_86                                                                   0x18017158
+#define OTP_DATA_87                                                                   0x1801715C
+#define OTP_DATA_88                                                                   0x18017160
+#define OTP_DATA_89                                                                   0x18017164
+#define OTP_DATA_90                                                                   0x18017168
+#define OTP_DATA_91                                                                   0x1801716C
+#define OTP_DATA_92                                                                   0x18017170
+#define OTP_DATA_93                                                                   0x18017174
+#define OTP_DATA_94                                                                   0x18017178
+#define OTP_DATA_95                                                                   0x1801717C
+#define OTP_DATA_96                                                                   0x18017180
+#define OTP_DATA_97                                                                   0x18017184
+#define OTP_DATA_98                                                                   0x18017188
+#define OTP_DATA_99                                                                   0x1801718C
+#define OTP_DATA_100                                                                   0x18017190
+#define OTP_DATA_101                                                                   0x18017194
+#define OTP_DATA_102                                                                   0x18017198
+#define OTP_DATA_103                                                                   0x1801719C
+#define OTP_DATA_104                                                                   0x180171A0
+#define OTP_DATA_105                                                                   0x180171A4
+#define OTP_DATA_106                                                                   0x180171A8
+#define OTP_DATA_107                                                                   0x180171AC
+#define OTP_DATA_108                                                                   0x180171B0
+#define OTP_DATA_109                                                                   0x180171B4
+#define OTP_DATA_110                                                                   0x180171B8
+#define OTP_DATA_111                                                                   0x180171BC
+#define OTP_DATA_112                                                                   0x180171C0
+#define OTP_DATA_113                                                                   0x180171C4
+#define OTP_DATA_114                                                                   0x180171C8
+#define OTP_DATA_115                                                                   0x180171CC
+#define OTP_DATA_116                                                                   0x180171D0
+#define OTP_DATA_117                                                                   0x180171D4
+#define OTP_DATA_118                                                                   0x180171D8
+#define OTP_DATA_119                                                                   0x180171DC
+#define OTP_DATA_120                                                                   0x180171E0
+#define OTP_DATA_121                                                                   0x180171E4
+#define OTP_DATA_122                                                                   0x180171E8
+#define OTP_DATA_123                                                                   0x180171EC
+#define OTP_DATA_124                                                                   0x180171F0
+#define OTP_DATA_125                                                                   0x180171F4
+#define OTP_DATA_126                                                                   0x180171F8
+#define OTP_DATA_127                                                                   0x180171FC
+#define OTP_DATA_0_reg_addr                                                          "0xB8017000"
+#define OTP_DATA_1_reg_addr                                                          "0xB8017004"
+#define OTP_DATA_2_reg_addr                                                          "0xB8017008"
+#define OTP_DATA_3_reg_addr                                                          "0xB801700C"
+#define OTP_DATA_4_reg_addr                                                          "0xB8017010"
+#define OTP_DATA_5_reg_addr                                                          "0xB8017014"
+#define OTP_DATA_6_reg_addr                                                          "0xB8017018"
+#define OTP_DATA_7_reg_addr                                                          "0xB801701C"
+#define OTP_DATA_8_reg_addr                                                          "0xB8017020"
+#define OTP_DATA_9_reg_addr                                                          "0xB8017024"
+#define OTP_DATA_10_reg_addr                                                          "0xB8017028"
+#define OTP_DATA_11_reg_addr                                                          "0xB801702C"
+#define OTP_DATA_12_reg_addr                                                          "0xB8017030"
+#define OTP_DATA_13_reg_addr                                                          "0xB8017034"
+#define OTP_DATA_14_reg_addr                                                          "0xB8017038"
+#define OTP_DATA_15_reg_addr                                                          "0xB801703C"
+#define OTP_DATA_16_reg_addr                                                          "0xB8017040"
+#define OTP_DATA_17_reg_addr                                                          "0xB8017044"
+#define OTP_DATA_18_reg_addr                                                          "0xB8017048"
+#define OTP_DATA_19_reg_addr                                                          "0xB801704C"
+#define OTP_DATA_20_reg_addr                                                          "0xB8017050"
+#define OTP_DATA_21_reg_addr                                                          "0xB8017054"
+#define OTP_DATA_22_reg_addr                                                          "0xB8017058"
+#define OTP_DATA_23_reg_addr                                                          "0xB801705C"
+#define OTP_DATA_24_reg_addr                                                          "0xB8017060"
+#define OTP_DATA_25_reg_addr                                                          "0xB8017064"
+#define OTP_DATA_26_reg_addr                                                          "0xB8017068"
+#define OTP_DATA_27_reg_addr                                                          "0xB801706C"
+#define OTP_DATA_28_reg_addr                                                          "0xB8017070"
+#define OTP_DATA_29_reg_addr                                                          "0xB8017074"
+#define OTP_DATA_30_reg_addr                                                          "0xB8017078"
+#define OTP_DATA_31_reg_addr                                                          "0xB801707C"
+#define OTP_DATA_32_reg_addr                                                          "0xB8017080"
+#define OTP_DATA_33_reg_addr                                                          "0xB8017084"
+#define OTP_DATA_34_reg_addr                                                          "0xB8017088"
+#define OTP_DATA_35_reg_addr                                                          "0xB801708C"
+#define OTP_DATA_36_reg_addr                                                          "0xB8017090"
+#define OTP_DATA_37_reg_addr                                                          "0xB8017094"
+#define OTP_DATA_38_reg_addr                                                          "0xB8017098"
+#define OTP_DATA_39_reg_addr                                                          "0xB801709C"
+#define OTP_DATA_40_reg_addr                                                          "0xB80170A0"
+#define OTP_DATA_41_reg_addr                                                          "0xB80170A4"
+#define OTP_DATA_42_reg_addr                                                          "0xB80170A8"
+#define OTP_DATA_43_reg_addr                                                          "0xB80170AC"
+#define OTP_DATA_44_reg_addr                                                          "0xB80170B0"
+#define OTP_DATA_45_reg_addr                                                          "0xB80170B4"
+#define OTP_DATA_46_reg_addr                                                          "0xB80170B8"
+#define OTP_DATA_47_reg_addr                                                          "0xB80170BC"
+#define OTP_DATA_48_reg_addr                                                          "0xB80170C0"
+#define OTP_DATA_49_reg_addr                                                          "0xB80170C4"
+#define OTP_DATA_50_reg_addr                                                          "0xB80170C8"
+#define OTP_DATA_51_reg_addr                                                          "0xB80170CC"
+#define OTP_DATA_52_reg_addr                                                          "0xB80170D0"
+#define OTP_DATA_53_reg_addr                                                          "0xB80170D4"
+#define OTP_DATA_54_reg_addr                                                          "0xB80170D8"
+#define OTP_DATA_55_reg_addr                                                          "0xB80170DC"
+#define OTP_DATA_56_reg_addr                                                          "0xB80170E0"
+#define OTP_DATA_57_reg_addr                                                          "0xB80170E4"
+#define OTP_DATA_58_reg_addr                                                          "0xB80170E8"
+#define OTP_DATA_59_reg_addr                                                          "0xB80170EC"
+#define OTP_DATA_60_reg_addr                                                          "0xB80170F0"
+#define OTP_DATA_61_reg_addr                                                          "0xB80170F4"
+#define OTP_DATA_62_reg_addr                                                          "0xB80170F8"
+#define OTP_DATA_63_reg_addr                                                          "0xB80170FC"
+#define OTP_DATA_64_reg_addr                                                          "0xB8017100"
+#define OTP_DATA_65_reg_addr                                                          "0xB8017104"
+#define OTP_DATA_66_reg_addr                                                          "0xB8017108"
+#define OTP_DATA_67_reg_addr                                                          "0xB801710C"
+#define OTP_DATA_68_reg_addr                                                          "0xB8017110"
+#define OTP_DATA_69_reg_addr                                                          "0xB8017114"
+#define OTP_DATA_70_reg_addr                                                          "0xB8017118"
+#define OTP_DATA_71_reg_addr                                                          "0xB801711C"
+#define OTP_DATA_72_reg_addr                                                          "0xB8017120"
+#define OTP_DATA_73_reg_addr                                                          "0xB8017124"
+#define OTP_DATA_74_reg_addr                                                          "0xB8017128"
+#define OTP_DATA_75_reg_addr                                                          "0xB801712C"
+#define OTP_DATA_76_reg_addr                                                          "0xB8017130"
+#define OTP_DATA_77_reg_addr                                                          "0xB8017134"
+#define OTP_DATA_78_reg_addr                                                          "0xB8017138"
+#define OTP_DATA_79_reg_addr                                                          "0xB801713C"
+#define OTP_DATA_80_reg_addr                                                          "0xB8017140"
+#define OTP_DATA_81_reg_addr                                                          "0xB8017144"
+#define OTP_DATA_82_reg_addr                                                          "0xB8017148"
+#define OTP_DATA_83_reg_addr                                                          "0xB801714C"
+#define OTP_DATA_84_reg_addr                                                          "0xB8017150"
+#define OTP_DATA_85_reg_addr                                                          "0xB8017154"
+#define OTP_DATA_86_reg_addr                                                          "0xB8017158"
+#define OTP_DATA_87_reg_addr                                                          "0xB801715C"
+#define OTP_DATA_88_reg_addr                                                          "0xB8017160"
+#define OTP_DATA_89_reg_addr                                                          "0xB8017164"
+#define OTP_DATA_90_reg_addr                                                          "0xB8017168"
+#define OTP_DATA_91_reg_addr                                                          "0xB801716C"
+#define OTP_DATA_92_reg_addr                                                          "0xB8017170"
+#define OTP_DATA_93_reg_addr                                                          "0xB8017174"
+#define OTP_DATA_94_reg_addr                                                          "0xB8017178"
+#define OTP_DATA_95_reg_addr                                                          "0xB801717C"
+#define OTP_DATA_96_reg_addr                                                          "0xB8017180"
+#define OTP_DATA_97_reg_addr                                                          "0xB8017184"
+#define OTP_DATA_98_reg_addr                                                          "0xB8017188"
+#define OTP_DATA_99_reg_addr                                                          "0xB801718C"
+#define OTP_DATA_100_reg_addr                                                          "0xB8017190"
+#define OTP_DATA_101_reg_addr                                                          "0xB8017194"
+#define OTP_DATA_102_reg_addr                                                          "0xB8017198"
+#define OTP_DATA_103_reg_addr                                                          "0xB801719C"
+#define OTP_DATA_104_reg_addr                                                          "0xB80171A0"
+#define OTP_DATA_105_reg_addr                                                          "0xB80171A4"
+#define OTP_DATA_106_reg_addr                                                          "0xB80171A8"
+#define OTP_DATA_107_reg_addr                                                          "0xB80171AC"
+#define OTP_DATA_108_reg_addr                                                          "0xB80171B0"
+#define OTP_DATA_109_reg_addr                                                          "0xB80171B4"
+#define OTP_DATA_110_reg_addr                                                          "0xB80171B8"
+#define OTP_DATA_111_reg_addr                                                          "0xB80171BC"
+#define OTP_DATA_112_reg_addr                                                          "0xB80171C0"
+#define OTP_DATA_113_reg_addr                                                          "0xB80171C4"
+#define OTP_DATA_114_reg_addr                                                          "0xB80171C8"
+#define OTP_DATA_115_reg_addr                                                          "0xB80171CC"
+#define OTP_DATA_116_reg_addr                                                          "0xB80171D0"
+#define OTP_DATA_117_reg_addr                                                          "0xB80171D4"
+#define OTP_DATA_118_reg_addr                                                          "0xB80171D8"
+#define OTP_DATA_119_reg_addr                                                          "0xB80171DC"
+#define OTP_DATA_120_reg_addr                                                          "0xB80171E0"
+#define OTP_DATA_121_reg_addr                                                          "0xB80171E4"
+#define OTP_DATA_122_reg_addr                                                          "0xB80171E8"
+#define OTP_DATA_123_reg_addr                                                          "0xB80171EC"
+#define OTP_DATA_124_reg_addr                                                          "0xB80171F0"
+#define OTP_DATA_125_reg_addr                                                          "0xB80171F4"
+#define OTP_DATA_126_reg_addr                                                          "0xB80171F8"
+#define OTP_DATA_127_reg_addr                                                          "0xB80171FC"
+#define OTP_DATA_0_reg                                                               0xB8017000
+#define OTP_DATA_1_reg                                                               0xB8017004
+#define OTP_DATA_2_reg                                                               0xB8017008
+#define OTP_DATA_3_reg                                                               0xB801700C
+#define OTP_DATA_4_reg                                                               0xB8017010
+#define OTP_DATA_5_reg                                                               0xB8017014
+#define OTP_DATA_6_reg                                                               0xB8017018
+#define OTP_DATA_7_reg                                                               0xB801701C
+#define OTP_DATA_8_reg                                                               0xB8017020
+#define OTP_DATA_9_reg                                                               0xB8017024
+#define OTP_DATA_10_reg                                                               0xB8017028
+#define OTP_DATA_11_reg                                                               0xB801702C
+#define OTP_DATA_12_reg                                                               0xB8017030
+#define OTP_DATA_13_reg                                                               0xB8017034
+#define OTP_DATA_14_reg                                                               0xB8017038
+#define OTP_DATA_15_reg                                                               0xB801703C
+#define OTP_DATA_16_reg                                                               0xB8017040
+#define OTP_DATA_17_reg                                                               0xB8017044
+#define OTP_DATA_18_reg                                                               0xB8017048
+#define OTP_DATA_19_reg                                                               0xB801704C
+#define OTP_DATA_20_reg                                                               0xB8017050
+#define OTP_DATA_21_reg                                                               0xB8017054
+#define OTP_DATA_22_reg                                                               0xB8017058
+#define OTP_DATA_23_reg                                                               0xB801705C
+#define OTP_DATA_24_reg                                                               0xB8017060
+#define OTP_DATA_25_reg                                                               0xB8017064
+#define OTP_DATA_26_reg                                                               0xB8017068
+#define OTP_DATA_27_reg                                                               0xB801706C
+#define OTP_DATA_28_reg                                                               0xB8017070
+#define OTP_DATA_29_reg                                                               0xB8017074
+#define OTP_DATA_30_reg                                                               0xB8017078
+#define OTP_DATA_31_reg                                                               0xB801707C
+#define OTP_DATA_32_reg                                                               0xB8017080
+#define OTP_DATA_33_reg                                                               0xB8017084
+#define OTP_DATA_34_reg                                                               0xB8017088
+#define OTP_DATA_35_reg                                                               0xB801708C
+#define OTP_DATA_36_reg                                                               0xB8017090
+#define OTP_DATA_37_reg                                                               0xB8017094
+#define OTP_DATA_38_reg                                                               0xB8017098
+#define OTP_DATA_39_reg                                                               0xB801709C
+#define OTP_DATA_40_reg                                                               0xB80170A0
+#define OTP_DATA_41_reg                                                               0xB80170A4
+#define OTP_DATA_42_reg                                                               0xB80170A8
+#define OTP_DATA_43_reg                                                               0xB80170AC
+#define OTP_DATA_44_reg                                                               0xB80170B0
+#define OTP_DATA_45_reg                                                               0xB80170B4
+#define OTP_DATA_46_reg                                                               0xB80170B8
+#define OTP_DATA_47_reg                                                               0xB80170BC
+#define OTP_DATA_48_reg                                                               0xB80170C0
+#define OTP_DATA_49_reg                                                               0xB80170C4
+#define OTP_DATA_50_reg                                                               0xB80170C8
+#define OTP_DATA_51_reg                                                               0xB80170CC
+#define OTP_DATA_52_reg                                                               0xB80170D0
+#define OTP_DATA_53_reg                                                               0xB80170D4
+#define OTP_DATA_54_reg                                                               0xB80170D8
+#define OTP_DATA_55_reg                                                               0xB80170DC
+#define OTP_DATA_56_reg                                                               0xB80170E0
+#define OTP_DATA_57_reg                                                               0xB80170E4
+#define OTP_DATA_58_reg                                                               0xB80170E8
+#define OTP_DATA_59_reg                                                               0xB80170EC
+#define OTP_DATA_60_reg                                                               0xB80170F0
+#define OTP_DATA_61_reg                                                               0xB80170F4
+#define OTP_DATA_62_reg                                                               0xB80170F8
+#define OTP_DATA_63_reg                                                               0xB80170FC
+#define OTP_DATA_64_reg                                                               0xB8017100
+#define OTP_DATA_65_reg                                                               0xB8017104
+#define OTP_DATA_66_reg                                                               0xB8017108
+#define OTP_DATA_67_reg                                                               0xB801710C
+#define OTP_DATA_68_reg                                                               0xB8017110
+#define OTP_DATA_69_reg                                                               0xB8017114
+#define OTP_DATA_70_reg                                                               0xB8017118
+#define OTP_DATA_71_reg                                                               0xB801711C
+#define OTP_DATA_72_reg                                                               0xB8017120
+#define OTP_DATA_73_reg                                                               0xB8017124
+#define OTP_DATA_74_reg                                                               0xB8017128
+#define OTP_DATA_75_reg                                                               0xB801712C
+#define OTP_DATA_76_reg                                                               0xB8017130
+#define OTP_DATA_77_reg                                                               0xB8017134
+#define OTP_DATA_78_reg                                                               0xB8017138
+#define OTP_DATA_79_reg                                                               0xB801713C
+#define OTP_DATA_80_reg                                                               0xB8017140
+#define OTP_DATA_81_reg                                                               0xB8017144
+#define OTP_DATA_82_reg                                                               0xB8017148
+#define OTP_DATA_83_reg                                                               0xB801714C
+#define OTP_DATA_84_reg                                                               0xB8017150
+#define OTP_DATA_85_reg                                                               0xB8017154
+#define OTP_DATA_86_reg                                                               0xB8017158
+#define OTP_DATA_87_reg                                                               0xB801715C
+#define OTP_DATA_88_reg                                                               0xB8017160
+#define OTP_DATA_89_reg                                                               0xB8017164
+#define OTP_DATA_90_reg                                                               0xB8017168
+#define OTP_DATA_91_reg                                                               0xB801716C
+#define OTP_DATA_92_reg                                                               0xB8017170
+#define OTP_DATA_93_reg                                                               0xB8017174
+#define OTP_DATA_94_reg                                                               0xB8017178
+#define OTP_DATA_95_reg                                                               0xB801717C
+#define OTP_DATA_96_reg                                                               0xB8017180
+#define OTP_DATA_97_reg                                                               0xB8017184
+#define OTP_DATA_98_reg                                                               0xB8017188
+#define OTP_DATA_99_reg                                                               0xB801718C
+#define OTP_DATA_100_reg                                                               0xB8017190
+#define OTP_DATA_101_reg                                                               0xB8017194
+#define OTP_DATA_102_reg                                                               0xB8017198
+#define OTP_DATA_103_reg                                                               0xB801719C
+#define OTP_DATA_104_reg                                                               0xB80171A0
+#define OTP_DATA_105_reg                                                               0xB80171A4
+#define OTP_DATA_106_reg                                                               0xB80171A8
+#define OTP_DATA_107_reg                                                               0xB80171AC
+#define OTP_DATA_108_reg                                                               0xB80171B0
+#define OTP_DATA_109_reg                                                               0xB80171B4
+#define OTP_DATA_110_reg                                                               0xB80171B8
+#define OTP_DATA_111_reg                                                               0xB80171BC
+#define OTP_DATA_112_reg                                                               0xB80171C0
+#define OTP_DATA_113_reg                                                               0xB80171C4
+#define OTP_DATA_114_reg                                                               0xB80171C8
+#define OTP_DATA_115_reg                                                               0xB80171CC
+#define OTP_DATA_116_reg                                                               0xB80171D0
+#define OTP_DATA_117_reg                                                               0xB80171D4
+#define OTP_DATA_118_reg                                                               0xB80171D8
+#define OTP_DATA_119_reg                                                               0xB80171DC
+#define OTP_DATA_120_reg                                                               0xB80171E0
+#define OTP_DATA_121_reg                                                               0xB80171E4
+#define OTP_DATA_122_reg                                                               0xB80171E8
+#define OTP_DATA_123_reg                                                               0xB80171EC
+#define OTP_DATA_124_reg                                                               0xB80171F0
+#define OTP_DATA_125_reg                                                               0xB80171F4
+#define OTP_DATA_126_reg                                                               0xB80171F8
+#define OTP_DATA_127_reg                                                               0xB80171FC
+#define set_OTP_DATA_0_reg(data)   (*((volatile unsigned int*) OTP_DATA_0_reg)=data)
+#define set_OTP_DATA_1_reg(data)   (*((volatile unsigned int*) OTP_DATA_1_reg)=data)
+#define set_OTP_DATA_2_reg(data)   (*((volatile unsigned int*) OTP_DATA_2_reg)=data)
+#define set_OTP_DATA_3_reg(data)   (*((volatile unsigned int*) OTP_DATA_3_reg)=data)
+#define set_OTP_DATA_4_reg(data)   (*((volatile unsigned int*) OTP_DATA_4_reg)=data)
+#define set_OTP_DATA_5_reg(data)   (*((volatile unsigned int*) OTP_DATA_5_reg)=data)
+#define set_OTP_DATA_6_reg(data)   (*((volatile unsigned int*) OTP_DATA_6_reg)=data)
+#define set_OTP_DATA_7_reg(data)   (*((volatile unsigned int*) OTP_DATA_7_reg)=data)
+#define set_OTP_DATA_8_reg(data)   (*((volatile unsigned int*) OTP_DATA_8_reg)=data)
+#define set_OTP_DATA_9_reg(data)   (*((volatile unsigned int*) OTP_DATA_9_reg)=data)
+#define set_OTP_DATA_10_reg(data)   (*((volatile unsigned int*) OTP_DATA_10_reg)=data)
+#define set_OTP_DATA_11_reg(data)   (*((volatile unsigned int*) OTP_DATA_11_reg)=data)
+#define set_OTP_DATA_12_reg(data)   (*((volatile unsigned int*) OTP_DATA_12_reg)=data)
+#define set_OTP_DATA_13_reg(data)   (*((volatile unsigned int*) OTP_DATA_13_reg)=data)
+#define set_OTP_DATA_14_reg(data)   (*((volatile unsigned int*) OTP_DATA_14_reg)=data)
+#define set_OTP_DATA_15_reg(data)   (*((volatile unsigned int*) OTP_DATA_15_reg)=data)
+#define set_OTP_DATA_16_reg(data)   (*((volatile unsigned int*) OTP_DATA_16_reg)=data)
+#define set_OTP_DATA_17_reg(data)   (*((volatile unsigned int*) OTP_DATA_17_reg)=data)
+#define set_OTP_DATA_18_reg(data)   (*((volatile unsigned int*) OTP_DATA_18_reg)=data)
+#define set_OTP_DATA_19_reg(data)   (*((volatile unsigned int*) OTP_DATA_19_reg)=data)
+#define set_OTP_DATA_20_reg(data)   (*((volatile unsigned int*) OTP_DATA_20_reg)=data)
+#define set_OTP_DATA_21_reg(data)   (*((volatile unsigned int*) OTP_DATA_21_reg)=data)
+#define set_OTP_DATA_22_reg(data)   (*((volatile unsigned int*) OTP_DATA_22_reg)=data)
+#define set_OTP_DATA_23_reg(data)   (*((volatile unsigned int*) OTP_DATA_23_reg)=data)
+#define set_OTP_DATA_24_reg(data)   (*((volatile unsigned int*) OTP_DATA_24_reg)=data)
+#define set_OTP_DATA_25_reg(data)   (*((volatile unsigned int*) OTP_DATA_25_reg)=data)
+#define set_OTP_DATA_26_reg(data)   (*((volatile unsigned int*) OTP_DATA_26_reg)=data)
+#define set_OTP_DATA_27_reg(data)   (*((volatile unsigned int*) OTP_DATA_27_reg)=data)
+#define set_OTP_DATA_28_reg(data)   (*((volatile unsigned int*) OTP_DATA_28_reg)=data)
+#define set_OTP_DATA_29_reg(data)   (*((volatile unsigned int*) OTP_DATA_29_reg)=data)
+#define set_OTP_DATA_30_reg(data)   (*((volatile unsigned int*) OTP_DATA_30_reg)=data)
+#define set_OTP_DATA_31_reg(data)   (*((volatile unsigned int*) OTP_DATA_31_reg)=data)
+#define set_OTP_DATA_32_reg(data)   (*((volatile unsigned int*) OTP_DATA_32_reg)=data)
+#define set_OTP_DATA_33_reg(data)   (*((volatile unsigned int*) OTP_DATA_33_reg)=data)
+#define set_OTP_DATA_34_reg(data)   (*((volatile unsigned int*) OTP_DATA_34_reg)=data)
+#define set_OTP_DATA_35_reg(data)   (*((volatile unsigned int*) OTP_DATA_35_reg)=data)
+#define set_OTP_DATA_36_reg(data)   (*((volatile unsigned int*) OTP_DATA_36_reg)=data)
+#define set_OTP_DATA_37_reg(data)   (*((volatile unsigned int*) OTP_DATA_37_reg)=data)
+#define set_OTP_DATA_38_reg(data)   (*((volatile unsigned int*) OTP_DATA_38_reg)=data)
+#define set_OTP_DATA_39_reg(data)   (*((volatile unsigned int*) OTP_DATA_39_reg)=data)
+#define set_OTP_DATA_40_reg(data)   (*((volatile unsigned int*) OTP_DATA_40_reg)=data)
+#define set_OTP_DATA_41_reg(data)   (*((volatile unsigned int*) OTP_DATA_41_reg)=data)
+#define set_OTP_DATA_42_reg(data)   (*((volatile unsigned int*) OTP_DATA_42_reg)=data)
+#define set_OTP_DATA_43_reg(data)   (*((volatile unsigned int*) OTP_DATA_43_reg)=data)
+#define set_OTP_DATA_44_reg(data)   (*((volatile unsigned int*) OTP_DATA_44_reg)=data)
+#define set_OTP_DATA_45_reg(data)   (*((volatile unsigned int*) OTP_DATA_45_reg)=data)
+#define set_OTP_DATA_46_reg(data)   (*((volatile unsigned int*) OTP_DATA_46_reg)=data)
+#define set_OTP_DATA_47_reg(data)   (*((volatile unsigned int*) OTP_DATA_47_reg)=data)
+#define set_OTP_DATA_48_reg(data)   (*((volatile unsigned int*) OTP_DATA_48_reg)=data)
+#define set_OTP_DATA_49_reg(data)   (*((volatile unsigned int*) OTP_DATA_49_reg)=data)
+#define set_OTP_DATA_50_reg(data)   (*((volatile unsigned int*) OTP_DATA_50_reg)=data)
+#define set_OTP_DATA_51_reg(data)   (*((volatile unsigned int*) OTP_DATA_51_reg)=data)
+#define set_OTP_DATA_52_reg(data)   (*((volatile unsigned int*) OTP_DATA_52_reg)=data)
+#define set_OTP_DATA_53_reg(data)   (*((volatile unsigned int*) OTP_DATA_53_reg)=data)
+#define set_OTP_DATA_54_reg(data)   (*((volatile unsigned int*) OTP_DATA_54_reg)=data)
+#define set_OTP_DATA_55_reg(data)   (*((volatile unsigned int*) OTP_DATA_55_reg)=data)
+#define set_OTP_DATA_56_reg(data)   (*((volatile unsigned int*) OTP_DATA_56_reg)=data)
+#define set_OTP_DATA_57_reg(data)   (*((volatile unsigned int*) OTP_DATA_57_reg)=data)
+#define set_OTP_DATA_58_reg(data)   (*((volatile unsigned int*) OTP_DATA_58_reg)=data)
+#define set_OTP_DATA_59_reg(data)   (*((volatile unsigned int*) OTP_DATA_59_reg)=data)
+#define set_OTP_DATA_60_reg(data)   (*((volatile unsigned int*) OTP_DATA_60_reg)=data)
+#define set_OTP_DATA_61_reg(data)   (*((volatile unsigned int*) OTP_DATA_61_reg)=data)
+#define set_OTP_DATA_62_reg(data)   (*((volatile unsigned int*) OTP_DATA_62_reg)=data)
+#define set_OTP_DATA_63_reg(data)   (*((volatile unsigned int*) OTP_DATA_63_reg)=data)
+#define set_OTP_DATA_64_reg(data)   (*((volatile unsigned int*) OTP_DATA_64_reg)=data)
+#define set_OTP_DATA_65_reg(data)   (*((volatile unsigned int*) OTP_DATA_65_reg)=data)
+#define set_OTP_DATA_66_reg(data)   (*((volatile unsigned int*) OTP_DATA_66_reg)=data)
+#define set_OTP_DATA_67_reg(data)   (*((volatile unsigned int*) OTP_DATA_67_reg)=data)
+#define set_OTP_DATA_68_reg(data)   (*((volatile unsigned int*) OTP_DATA_68_reg)=data)
+#define set_OTP_DATA_69_reg(data)   (*((volatile unsigned int*) OTP_DATA_69_reg)=data)
+#define set_OTP_DATA_70_reg(data)   (*((volatile unsigned int*) OTP_DATA_70_reg)=data)
+#define set_OTP_DATA_71_reg(data)   (*((volatile unsigned int*) OTP_DATA_71_reg)=data)
+#define set_OTP_DATA_72_reg(data)   (*((volatile unsigned int*) OTP_DATA_72_reg)=data)
+#define set_OTP_DATA_73_reg(data)   (*((volatile unsigned int*) OTP_DATA_73_reg)=data)
+#define set_OTP_DATA_74_reg(data)   (*((volatile unsigned int*) OTP_DATA_74_reg)=data)
+#define set_OTP_DATA_75_reg(data)   (*((volatile unsigned int*) OTP_DATA_75_reg)=data)
+#define set_OTP_DATA_76_reg(data)   (*((volatile unsigned int*) OTP_DATA_76_reg)=data)
+#define set_OTP_DATA_77_reg(data)   (*((volatile unsigned int*) OTP_DATA_77_reg)=data)
+#define set_OTP_DATA_78_reg(data)   (*((volatile unsigned int*) OTP_DATA_78_reg)=data)
+#define set_OTP_DATA_79_reg(data)   (*((volatile unsigned int*) OTP_DATA_79_reg)=data)
+#define set_OTP_DATA_80_reg(data)   (*((volatile unsigned int*) OTP_DATA_80_reg)=data)
+#define set_OTP_DATA_81_reg(data)   (*((volatile unsigned int*) OTP_DATA_81_reg)=data)
+#define set_OTP_DATA_82_reg(data)   (*((volatile unsigned int*) OTP_DATA_82_reg)=data)
+#define set_OTP_DATA_83_reg(data)   (*((volatile unsigned int*) OTP_DATA_83_reg)=data)
+#define set_OTP_DATA_84_reg(data)   (*((volatile unsigned int*) OTP_DATA_84_reg)=data)
+#define set_OTP_DATA_85_reg(data)   (*((volatile unsigned int*) OTP_DATA_85_reg)=data)
+#define set_OTP_DATA_86_reg(data)   (*((volatile unsigned int*) OTP_DATA_86_reg)=data)
+#define set_OTP_DATA_87_reg(data)   (*((volatile unsigned int*) OTP_DATA_87_reg)=data)
+#define set_OTP_DATA_88_reg(data)   (*((volatile unsigned int*) OTP_DATA_88_reg)=data)
+#define set_OTP_DATA_89_reg(data)   (*((volatile unsigned int*) OTP_DATA_89_reg)=data)
+#define set_OTP_DATA_90_reg(data)   (*((volatile unsigned int*) OTP_DATA_90_reg)=data)
+#define set_OTP_DATA_91_reg(data)   (*((volatile unsigned int*) OTP_DATA_91_reg)=data)
+#define set_OTP_DATA_92_reg(data)   (*((volatile unsigned int*) OTP_DATA_92_reg)=data)
+#define set_OTP_DATA_93_reg(data)   (*((volatile unsigned int*) OTP_DATA_93_reg)=data)
+#define set_OTP_DATA_94_reg(data)   (*((volatile unsigned int*) OTP_DATA_94_reg)=data)
+#define set_OTP_DATA_95_reg(data)   (*((volatile unsigned int*) OTP_DATA_95_reg)=data)
+#define set_OTP_DATA_96_reg(data)   (*((volatile unsigned int*) OTP_DATA_96_reg)=data)
+#define set_OTP_DATA_97_reg(data)   (*((volatile unsigned int*) OTP_DATA_97_reg)=data)
+#define set_OTP_DATA_98_reg(data)   (*((volatile unsigned int*) OTP_DATA_98_reg)=data)
+#define set_OTP_DATA_99_reg(data)   (*((volatile unsigned int*) OTP_DATA_99_reg)=data)
+#define set_OTP_DATA_100_reg(data)   (*((volatile unsigned int*) OTP_DATA_100_reg)=data)
+#define set_OTP_DATA_101_reg(data)   (*((volatile unsigned int*) OTP_DATA_101_reg)=data)
+#define set_OTP_DATA_102_reg(data)   (*((volatile unsigned int*) OTP_DATA_102_reg)=data)
+#define set_OTP_DATA_103_reg(data)   (*((volatile unsigned int*) OTP_DATA_103_reg)=data)
+#define set_OTP_DATA_104_reg(data)   (*((volatile unsigned int*) OTP_DATA_104_reg)=data)
+#define set_OTP_DATA_105_reg(data)   (*((volatile unsigned int*) OTP_DATA_105_reg)=data)
+#define set_OTP_DATA_106_reg(data)   (*((volatile unsigned int*) OTP_DATA_106_reg)=data)
+#define set_OTP_DATA_107_reg(data)   (*((volatile unsigned int*) OTP_DATA_107_reg)=data)
+#define set_OTP_DATA_108_reg(data)   (*((volatile unsigned int*) OTP_DATA_108_reg)=data)
+#define set_OTP_DATA_109_reg(data)   (*((volatile unsigned int*) OTP_DATA_109_reg)=data)
+#define set_OTP_DATA_110_reg(data)   (*((volatile unsigned int*) OTP_DATA_110_reg)=data)
+#define set_OTP_DATA_111_reg(data)   (*((volatile unsigned int*) OTP_DATA_111_reg)=data)
+#define set_OTP_DATA_112_reg(data)   (*((volatile unsigned int*) OTP_DATA_112_reg)=data)
+#define set_OTP_DATA_113_reg(data)   (*((volatile unsigned int*) OTP_DATA_113_reg)=data)
+#define set_OTP_DATA_114_reg(data)   (*((volatile unsigned int*) OTP_DATA_114_reg)=data)
+#define set_OTP_DATA_115_reg(data)   (*((volatile unsigned int*) OTP_DATA_115_reg)=data)
+#define set_OTP_DATA_116_reg(data)   (*((volatile unsigned int*) OTP_DATA_116_reg)=data)
+#define set_OTP_DATA_117_reg(data)   (*((volatile unsigned int*) OTP_DATA_117_reg)=data)
+#define set_OTP_DATA_118_reg(data)   (*((volatile unsigned int*) OTP_DATA_118_reg)=data)
+#define set_OTP_DATA_119_reg(data)   (*((volatile unsigned int*) OTP_DATA_119_reg)=data)
+#define set_OTP_DATA_120_reg(data)   (*((volatile unsigned int*) OTP_DATA_120_reg)=data)
+#define set_OTP_DATA_121_reg(data)   (*((volatile unsigned int*) OTP_DATA_121_reg)=data)
+#define set_OTP_DATA_122_reg(data)   (*((volatile unsigned int*) OTP_DATA_122_reg)=data)
+#define set_OTP_DATA_123_reg(data)   (*((volatile unsigned int*) OTP_DATA_123_reg)=data)
+#define set_OTP_DATA_124_reg(data)   (*((volatile unsigned int*) OTP_DATA_124_reg)=data)
+#define set_OTP_DATA_125_reg(data)   (*((volatile unsigned int*) OTP_DATA_125_reg)=data)
+#define set_OTP_DATA_126_reg(data)   (*((volatile unsigned int*) OTP_DATA_126_reg)=data)
+#define set_OTP_DATA_127_reg(data)   (*((volatile unsigned int*) OTP_DATA_127_reg)=data)
+#define get_OTP_DATA_0_reg   (*((volatile unsigned int*) OTP_DATA_0_reg))
+#define get_OTP_DATA_1_reg   (*((volatile unsigned int*) OTP_DATA_1_reg))
+#define get_OTP_DATA_2_reg   (*((volatile unsigned int*) OTP_DATA_2_reg))
+#define get_OTP_DATA_3_reg   (*((volatile unsigned int*) OTP_DATA_3_reg))
+#define get_OTP_DATA_4_reg   (*((volatile unsigned int*) OTP_DATA_4_reg))
+#define get_OTP_DATA_5_reg   (*((volatile unsigned int*) OTP_DATA_5_reg))
+#define get_OTP_DATA_6_reg   (*((volatile unsigned int*) OTP_DATA_6_reg))
+#define get_OTP_DATA_7_reg   (*((volatile unsigned int*) OTP_DATA_7_reg))
+#define get_OTP_DATA_8_reg   (*((volatile unsigned int*) OTP_DATA_8_reg))
+#define get_OTP_DATA_9_reg   (*((volatile unsigned int*) OTP_DATA_9_reg))
+#define get_OTP_DATA_10_reg   (*((volatile unsigned int*) OTP_DATA_10_reg))
+#define get_OTP_DATA_11_reg   (*((volatile unsigned int*) OTP_DATA_11_reg))
+#define get_OTP_DATA_12_reg   (*((volatile unsigned int*) OTP_DATA_12_reg))
+#define get_OTP_DATA_13_reg   (*((volatile unsigned int*) OTP_DATA_13_reg))
+#define get_OTP_DATA_14_reg   (*((volatile unsigned int*) OTP_DATA_14_reg))
+#define get_OTP_DATA_15_reg   (*((volatile unsigned int*) OTP_DATA_15_reg))
+#define get_OTP_DATA_16_reg   (*((volatile unsigned int*) OTP_DATA_16_reg))
+#define get_OTP_DATA_17_reg   (*((volatile unsigned int*) OTP_DATA_17_reg))
+#define get_OTP_DATA_18_reg   (*((volatile unsigned int*) OTP_DATA_18_reg))
+#define get_OTP_DATA_19_reg   (*((volatile unsigned int*) OTP_DATA_19_reg))
+#define get_OTP_DATA_20_reg   (*((volatile unsigned int*) OTP_DATA_20_reg))
+#define get_OTP_DATA_21_reg   (*((volatile unsigned int*) OTP_DATA_21_reg))
+#define get_OTP_DATA_22_reg   (*((volatile unsigned int*) OTP_DATA_22_reg))
+#define get_OTP_DATA_23_reg   (*((volatile unsigned int*) OTP_DATA_23_reg))
+#define get_OTP_DATA_24_reg   (*((volatile unsigned int*) OTP_DATA_24_reg))
+#define get_OTP_DATA_25_reg   (*((volatile unsigned int*) OTP_DATA_25_reg))
+#define get_OTP_DATA_26_reg   (*((volatile unsigned int*) OTP_DATA_26_reg))
+#define get_OTP_DATA_27_reg   (*((volatile unsigned int*) OTP_DATA_27_reg))
+#define get_OTP_DATA_28_reg   (*((volatile unsigned int*) OTP_DATA_28_reg))
+#define get_OTP_DATA_29_reg   (*((volatile unsigned int*) OTP_DATA_29_reg))
+#define get_OTP_DATA_30_reg   (*((volatile unsigned int*) OTP_DATA_30_reg))
+#define get_OTP_DATA_31_reg   (*((volatile unsigned int*) OTP_DATA_31_reg))
+#define get_OTP_DATA_32_reg   (*((volatile unsigned int*) OTP_DATA_32_reg))
+#define get_OTP_DATA_33_reg   (*((volatile unsigned int*) OTP_DATA_33_reg))
+#define get_OTP_DATA_34_reg   (*((volatile unsigned int*) OTP_DATA_34_reg))
+#define get_OTP_DATA_35_reg   (*((volatile unsigned int*) OTP_DATA_35_reg))
+#define get_OTP_DATA_36_reg   (*((volatile unsigned int*) OTP_DATA_36_reg))
+#define get_OTP_DATA_37_reg   (*((volatile unsigned int*) OTP_DATA_37_reg))
+#define get_OTP_DATA_38_reg   (*((volatile unsigned int*) OTP_DATA_38_reg))
+#define get_OTP_DATA_39_reg   (*((volatile unsigned int*) OTP_DATA_39_reg))
+#define get_OTP_DATA_40_reg   (*((volatile unsigned int*) OTP_DATA_40_reg))
+#define get_OTP_DATA_41_reg   (*((volatile unsigned int*) OTP_DATA_41_reg))
+#define get_OTP_DATA_42_reg   (*((volatile unsigned int*) OTP_DATA_42_reg))
+#define get_OTP_DATA_43_reg   (*((volatile unsigned int*) OTP_DATA_43_reg))
+#define get_OTP_DATA_44_reg   (*((volatile unsigned int*) OTP_DATA_44_reg))
+#define get_OTP_DATA_45_reg   (*((volatile unsigned int*) OTP_DATA_45_reg))
+#define get_OTP_DATA_46_reg   (*((volatile unsigned int*) OTP_DATA_46_reg))
+#define get_OTP_DATA_47_reg   (*((volatile unsigned int*) OTP_DATA_47_reg))
+#define get_OTP_DATA_48_reg   (*((volatile unsigned int*) OTP_DATA_48_reg))
+#define get_OTP_DATA_49_reg   (*((volatile unsigned int*) OTP_DATA_49_reg))
+#define get_OTP_DATA_50_reg   (*((volatile unsigned int*) OTP_DATA_50_reg))
+#define get_OTP_DATA_51_reg   (*((volatile unsigned int*) OTP_DATA_51_reg))
+#define get_OTP_DATA_52_reg   (*((volatile unsigned int*) OTP_DATA_52_reg))
+#define get_OTP_DATA_53_reg   (*((volatile unsigned int*) OTP_DATA_53_reg))
+#define get_OTP_DATA_54_reg   (*((volatile unsigned int*) OTP_DATA_54_reg))
+#define get_OTP_DATA_55_reg   (*((volatile unsigned int*) OTP_DATA_55_reg))
+#define get_OTP_DATA_56_reg   (*((volatile unsigned int*) OTP_DATA_56_reg))
+#define get_OTP_DATA_57_reg   (*((volatile unsigned int*) OTP_DATA_57_reg))
+#define get_OTP_DATA_58_reg   (*((volatile unsigned int*) OTP_DATA_58_reg))
+#define get_OTP_DATA_59_reg   (*((volatile unsigned int*) OTP_DATA_59_reg))
+#define get_OTP_DATA_60_reg   (*((volatile unsigned int*) OTP_DATA_60_reg))
+#define get_OTP_DATA_61_reg   (*((volatile unsigned int*) OTP_DATA_61_reg))
+#define get_OTP_DATA_62_reg   (*((volatile unsigned int*) OTP_DATA_62_reg))
+#define get_OTP_DATA_63_reg   (*((volatile unsigned int*) OTP_DATA_63_reg))
+#define get_OTP_DATA_64_reg   (*((volatile unsigned int*) OTP_DATA_64_reg))
+#define get_OTP_DATA_65_reg   (*((volatile unsigned int*) OTP_DATA_65_reg))
+#define get_OTP_DATA_66_reg   (*((volatile unsigned int*) OTP_DATA_66_reg))
+#define get_OTP_DATA_67_reg   (*((volatile unsigned int*) OTP_DATA_67_reg))
+#define get_OTP_DATA_68_reg   (*((volatile unsigned int*) OTP_DATA_68_reg))
+#define get_OTP_DATA_69_reg   (*((volatile unsigned int*) OTP_DATA_69_reg))
+#define get_OTP_DATA_70_reg   (*((volatile unsigned int*) OTP_DATA_70_reg))
+#define get_OTP_DATA_71_reg   (*((volatile unsigned int*) OTP_DATA_71_reg))
+#define get_OTP_DATA_72_reg   (*((volatile unsigned int*) OTP_DATA_72_reg))
+#define get_OTP_DATA_73_reg   (*((volatile unsigned int*) OTP_DATA_73_reg))
+#define get_OTP_DATA_74_reg   (*((volatile unsigned int*) OTP_DATA_74_reg))
+#define get_OTP_DATA_75_reg   (*((volatile unsigned int*) OTP_DATA_75_reg))
+#define get_OTP_DATA_76_reg   (*((volatile unsigned int*) OTP_DATA_76_reg))
+#define get_OTP_DATA_77_reg   (*((volatile unsigned int*) OTP_DATA_77_reg))
+#define get_OTP_DATA_78_reg   (*((volatile unsigned int*) OTP_DATA_78_reg))
+#define get_OTP_DATA_79_reg   (*((volatile unsigned int*) OTP_DATA_79_reg))
+#define get_OTP_DATA_80_reg   (*((volatile unsigned int*) OTP_DATA_80_reg))
+#define get_OTP_DATA_81_reg   (*((volatile unsigned int*) OTP_DATA_81_reg))
+#define get_OTP_DATA_82_reg   (*((volatile unsigned int*) OTP_DATA_82_reg))
+#define get_OTP_DATA_83_reg   (*((volatile unsigned int*) OTP_DATA_83_reg))
+#define get_OTP_DATA_84_reg   (*((volatile unsigned int*) OTP_DATA_84_reg))
+#define get_OTP_DATA_85_reg   (*((volatile unsigned int*) OTP_DATA_85_reg))
+#define get_OTP_DATA_86_reg   (*((volatile unsigned int*) OTP_DATA_86_reg))
+#define get_OTP_DATA_87_reg   (*((volatile unsigned int*) OTP_DATA_87_reg))
+#define get_OTP_DATA_88_reg   (*((volatile unsigned int*) OTP_DATA_88_reg))
+#define get_OTP_DATA_89_reg   (*((volatile unsigned int*) OTP_DATA_89_reg))
+#define get_OTP_DATA_90_reg   (*((volatile unsigned int*) OTP_DATA_90_reg))
+#define get_OTP_DATA_91_reg   (*((volatile unsigned int*) OTP_DATA_91_reg))
+#define get_OTP_DATA_92_reg   (*((volatile unsigned int*) OTP_DATA_92_reg))
+#define get_OTP_DATA_93_reg   (*((volatile unsigned int*) OTP_DATA_93_reg))
+#define get_OTP_DATA_94_reg   (*((volatile unsigned int*) OTP_DATA_94_reg))
+#define get_OTP_DATA_95_reg   (*((volatile unsigned int*) OTP_DATA_95_reg))
+#define get_OTP_DATA_96_reg   (*((volatile unsigned int*) OTP_DATA_96_reg))
+#define get_OTP_DATA_97_reg   (*((volatile unsigned int*) OTP_DATA_97_reg))
+#define get_OTP_DATA_98_reg   (*((volatile unsigned int*) OTP_DATA_98_reg))
+#define get_OTP_DATA_99_reg   (*((volatile unsigned int*) OTP_DATA_99_reg))
+#define get_OTP_DATA_100_reg   (*((volatile unsigned int*) OTP_DATA_100_reg))
+#define get_OTP_DATA_101_reg   (*((volatile unsigned int*) OTP_DATA_101_reg))
+#define get_OTP_DATA_102_reg   (*((volatile unsigned int*) OTP_DATA_102_reg))
+#define get_OTP_DATA_103_reg   (*((volatile unsigned int*) OTP_DATA_103_reg))
+#define get_OTP_DATA_104_reg   (*((volatile unsigned int*) OTP_DATA_104_reg))
+#define get_OTP_DATA_105_reg   (*((volatile unsigned int*) OTP_DATA_105_reg))
+#define get_OTP_DATA_106_reg   (*((volatile unsigned int*) OTP_DATA_106_reg))
+#define get_OTP_DATA_107_reg   (*((volatile unsigned int*) OTP_DATA_107_reg))
+#define get_OTP_DATA_108_reg   (*((volatile unsigned int*) OTP_DATA_108_reg))
+#define get_OTP_DATA_109_reg   (*((volatile unsigned int*) OTP_DATA_109_reg))
+#define get_OTP_DATA_110_reg   (*((volatile unsigned int*) OTP_DATA_110_reg))
+#define get_OTP_DATA_111_reg   (*((volatile unsigned int*) OTP_DATA_111_reg))
+#define get_OTP_DATA_112_reg   (*((volatile unsigned int*) OTP_DATA_112_reg))
+#define get_OTP_DATA_113_reg   (*((volatile unsigned int*) OTP_DATA_113_reg))
+#define get_OTP_DATA_114_reg   (*((volatile unsigned int*) OTP_DATA_114_reg))
+#define get_OTP_DATA_115_reg   (*((volatile unsigned int*) OTP_DATA_115_reg))
+#define get_OTP_DATA_116_reg   (*((volatile unsigned int*) OTP_DATA_116_reg))
+#define get_OTP_DATA_117_reg   (*((volatile unsigned int*) OTP_DATA_117_reg))
+#define get_OTP_DATA_118_reg   (*((volatile unsigned int*) OTP_DATA_118_reg))
+#define get_OTP_DATA_119_reg   (*((volatile unsigned int*) OTP_DATA_119_reg))
+#define get_OTP_DATA_120_reg   (*((volatile unsigned int*) OTP_DATA_120_reg))
+#define get_OTP_DATA_121_reg   (*((volatile unsigned int*) OTP_DATA_121_reg))
+#define get_OTP_DATA_122_reg   (*((volatile unsigned int*) OTP_DATA_122_reg))
+#define get_OTP_DATA_123_reg   (*((volatile unsigned int*) OTP_DATA_123_reg))
+#define get_OTP_DATA_124_reg   (*((volatile unsigned int*) OTP_DATA_124_reg))
+#define get_OTP_DATA_125_reg   (*((volatile unsigned int*) OTP_DATA_125_reg))
+#define get_OTP_DATA_126_reg   (*((volatile unsigned int*) OTP_DATA_126_reg))
+#define get_OTP_DATA_127_reg   (*((volatile unsigned int*) OTP_DATA_127_reg))
+#define OTP_DATA_0_inst_adr                                                          "0x0000"
+#define OTP_DATA_1_inst_adr                                                          "0x0001"
+#define OTP_DATA_2_inst_adr                                                          "0x0002"
+#define OTP_DATA_3_inst_adr                                                          "0x0003"
+#define OTP_DATA_4_inst_adr                                                          "0x0004"
+#define OTP_DATA_5_inst_adr                                                          "0x0005"
+#define OTP_DATA_6_inst_adr                                                          "0x0006"
+#define OTP_DATA_7_inst_adr                                                          "0x0007"
+#define OTP_DATA_8_inst_adr                                                          "0x0008"
+#define OTP_DATA_9_inst_adr                                                          "0x0009"
+#define OTP_DATA_10_inst_adr                                                          "0x000A"
+#define OTP_DATA_11_inst_adr                                                          "0x000B"
+#define OTP_DATA_12_inst_adr                                                          "0x000C"
+#define OTP_DATA_13_inst_adr                                                          "0x000D"
+#define OTP_DATA_14_inst_adr                                                          "0x000E"
+#define OTP_DATA_15_inst_adr                                                          "0x000F"
+#define OTP_DATA_16_inst_adr                                                          "0x0010"
+#define OTP_DATA_17_inst_adr                                                          "0x0011"
+#define OTP_DATA_18_inst_adr                                                          "0x0012"
+#define OTP_DATA_19_inst_adr                                                          "0x0013"
+#define OTP_DATA_20_inst_adr                                                          "0x0014"
+#define OTP_DATA_21_inst_adr                                                          "0x0015"
+#define OTP_DATA_22_inst_adr                                                          "0x0016"
+#define OTP_DATA_23_inst_adr                                                          "0x0017"
+#define OTP_DATA_24_inst_adr                                                          "0x0018"
+#define OTP_DATA_25_inst_adr                                                          "0x0019"
+#define OTP_DATA_26_inst_adr                                                          "0x001A"
+#define OTP_DATA_27_inst_adr                                                          "0x001B"
+#define OTP_DATA_28_inst_adr                                                          "0x001C"
+#define OTP_DATA_29_inst_adr                                                          "0x001D"
+#define OTP_DATA_30_inst_adr                                                          "0x001E"
+#define OTP_DATA_31_inst_adr                                                          "0x001F"
+#define OTP_DATA_32_inst_adr                                                          "0x0020"
+#define OTP_DATA_33_inst_adr                                                          "0x0021"
+#define OTP_DATA_34_inst_adr                                                          "0x0022"
+#define OTP_DATA_35_inst_adr                                                          "0x0023"
+#define OTP_DATA_36_inst_adr                                                          "0x0024"
+#define OTP_DATA_37_inst_adr                                                          "0x0025"
+#define OTP_DATA_38_inst_adr                                                          "0x0026"
+#define OTP_DATA_39_inst_adr                                                          "0x0027"
+#define OTP_DATA_40_inst_adr                                                          "0x0028"
+#define OTP_DATA_41_inst_adr                                                          "0x0029"
+#define OTP_DATA_42_inst_adr                                                          "0x002A"
+#define OTP_DATA_43_inst_adr                                                          "0x002B"
+#define OTP_DATA_44_inst_adr                                                          "0x002C"
+#define OTP_DATA_45_inst_adr                                                          "0x002D"
+#define OTP_DATA_46_inst_adr                                                          "0x002E"
+#define OTP_DATA_47_inst_adr                                                          "0x002F"
+#define OTP_DATA_48_inst_adr                                                          "0x0030"
+#define OTP_DATA_49_inst_adr                                                          "0x0031"
+#define OTP_DATA_50_inst_adr                                                          "0x0032"
+#define OTP_DATA_51_inst_adr                                                          "0x0033"
+#define OTP_DATA_52_inst_adr                                                          "0x0034"
+#define OTP_DATA_53_inst_adr                                                          "0x0035"
+#define OTP_DATA_54_inst_adr                                                          "0x0036"
+#define OTP_DATA_55_inst_adr                                                          "0x0037"
+#define OTP_DATA_56_inst_adr                                                          "0x0038"
+#define OTP_DATA_57_inst_adr                                                          "0x0039"
+#define OTP_DATA_58_inst_adr                                                          "0x003A"
+#define OTP_DATA_59_inst_adr                                                          "0x003B"
+#define OTP_DATA_60_inst_adr                                                          "0x003C"
+#define OTP_DATA_61_inst_adr                                                          "0x003D"
+#define OTP_DATA_62_inst_adr                                                          "0x003E"
+#define OTP_DATA_63_inst_adr                                                          "0x003F"
+#define OTP_DATA_64_inst_adr                                                          "0x0040"
+#define OTP_DATA_65_inst_adr                                                          "0x0041"
+#define OTP_DATA_66_inst_adr                                                          "0x0042"
+#define OTP_DATA_67_inst_adr                                                          "0x0043"
+#define OTP_DATA_68_inst_adr                                                          "0x0044"
+#define OTP_DATA_69_inst_adr                                                          "0x0045"
+#define OTP_DATA_70_inst_adr                                                          "0x0046"
+#define OTP_DATA_71_inst_adr                                                          "0x0047"
+#define OTP_DATA_72_inst_adr                                                          "0x0048"
+#define OTP_DATA_73_inst_adr                                                          "0x0049"
+#define OTP_DATA_74_inst_adr                                                          "0x004A"
+#define OTP_DATA_75_inst_adr                                                          "0x004B"
+#define OTP_DATA_76_inst_adr                                                          "0x004C"
+#define OTP_DATA_77_inst_adr                                                          "0x004D"
+#define OTP_DATA_78_inst_adr                                                          "0x004E"
+#define OTP_DATA_79_inst_adr                                                          "0x004F"
+#define OTP_DATA_80_inst_adr                                                          "0x0050"
+#define OTP_DATA_81_inst_adr                                                          "0x0051"
+#define OTP_DATA_82_inst_adr                                                          "0x0052"
+#define OTP_DATA_83_inst_adr                                                          "0x0053"
+#define OTP_DATA_84_inst_adr                                                          "0x0054"
+#define OTP_DATA_85_inst_adr                                                          "0x0055"
+#define OTP_DATA_86_inst_adr                                                          "0x0056"
+#define OTP_DATA_87_inst_adr                                                          "0x0057"
+#define OTP_DATA_88_inst_adr                                                          "0x0058"
+#define OTP_DATA_89_inst_adr                                                          "0x0059"
+#define OTP_DATA_90_inst_adr                                                          "0x005A"
+#define OTP_DATA_91_inst_adr                                                          "0x005B"
+#define OTP_DATA_92_inst_adr                                                          "0x005C"
+#define OTP_DATA_93_inst_adr                                                          "0x005D"
+#define OTP_DATA_94_inst_adr                                                          "0x005E"
+#define OTP_DATA_95_inst_adr                                                          "0x005F"
+#define OTP_DATA_96_inst_adr                                                          "0x0060"
+#define OTP_DATA_97_inst_adr                                                          "0x0061"
+#define OTP_DATA_98_inst_adr                                                          "0x0062"
+#define OTP_DATA_99_inst_adr                                                          "0x0063"
+#define OTP_DATA_100_inst_adr                                                          "0x0064"
+#define OTP_DATA_101_inst_adr                                                          "0x0065"
+#define OTP_DATA_102_inst_adr                                                          "0x0066"
+#define OTP_DATA_103_inst_adr                                                          "0x0067"
+#define OTP_DATA_104_inst_adr                                                          "0x0068"
+#define OTP_DATA_105_inst_adr                                                          "0x0069"
+#define OTP_DATA_106_inst_adr                                                          "0x006A"
+#define OTP_DATA_107_inst_adr                                                          "0x006B"
+#define OTP_DATA_108_inst_adr                                                          "0x006C"
+#define OTP_DATA_109_inst_adr                                                          "0x006D"
+#define OTP_DATA_110_inst_adr                                                          "0x006E"
+#define OTP_DATA_111_inst_adr                                                          "0x006F"
+#define OTP_DATA_112_inst_adr                                                          "0x0070"
+#define OTP_DATA_113_inst_adr                                                          "0x0071"
+#define OTP_DATA_114_inst_adr                                                          "0x0072"
+#define OTP_DATA_115_inst_adr                                                          "0x0073"
+#define OTP_DATA_116_inst_adr                                                          "0x0074"
+#define OTP_DATA_117_inst_adr                                                          "0x0075"
+#define OTP_DATA_118_inst_adr                                                          "0x0076"
+#define OTP_DATA_119_inst_adr                                                          "0x0077"
+#define OTP_DATA_120_inst_adr                                                          "0x0078"
+#define OTP_DATA_121_inst_adr                                                          "0x0079"
+#define OTP_DATA_122_inst_adr                                                          "0x007A"
+#define OTP_DATA_123_inst_adr                                                          "0x007B"
+#define OTP_DATA_124_inst_adr                                                          "0x007C"
+#define OTP_DATA_125_inst_adr                                                          "0x007D"
+#define OTP_DATA_126_inst_adr                                                          "0x007E"
+#define OTP_DATA_127_inst_adr                                                          "0x007F"
+#define OTP_DATA_0_inst                                                              0x0000
+#define OTP_DATA_1_inst                                                              0x0001
+#define OTP_DATA_2_inst                                                              0x0002
+#define OTP_DATA_3_inst                                                              0x0003
+#define OTP_DATA_4_inst                                                              0x0004
+#define OTP_DATA_5_inst                                                              0x0005
+#define OTP_DATA_6_inst                                                              0x0006
+#define OTP_DATA_7_inst                                                              0x0007
+#define OTP_DATA_8_inst                                                              0x0008
+#define OTP_DATA_9_inst                                                              0x0009
+#define OTP_DATA_10_inst                                                              0x000A
+#define OTP_DATA_11_inst                                                              0x000B
+#define OTP_DATA_12_inst                                                              0x000C
+#define OTP_DATA_13_inst                                                              0x000D
+#define OTP_DATA_14_inst                                                              0x000E
+#define OTP_DATA_15_inst                                                              0x000F
+#define OTP_DATA_16_inst                                                              0x0010
+#define OTP_DATA_17_inst                                                              0x0011
+#define OTP_DATA_18_inst                                                              0x0012
+#define OTP_DATA_19_inst                                                              0x0013
+#define OTP_DATA_20_inst                                                              0x0014
+#define OTP_DATA_21_inst                                                              0x0015
+#define OTP_DATA_22_inst                                                              0x0016
+#define OTP_DATA_23_inst                                                              0x0017
+#define OTP_DATA_24_inst                                                              0x0018
+#define OTP_DATA_25_inst                                                              0x0019
+#define OTP_DATA_26_inst                                                              0x001A
+#define OTP_DATA_27_inst                                                              0x001B
+#define OTP_DATA_28_inst                                                              0x001C
+#define OTP_DATA_29_inst                                                              0x001D
+#define OTP_DATA_30_inst                                                              0x001E
+#define OTP_DATA_31_inst                                                              0x001F
+#define OTP_DATA_32_inst                                                              0x0020
+#define OTP_DATA_33_inst                                                              0x0021
+#define OTP_DATA_34_inst                                                              0x0022
+#define OTP_DATA_35_inst                                                              0x0023
+#define OTP_DATA_36_inst                                                              0x0024
+#define OTP_DATA_37_inst                                                              0x0025
+#define OTP_DATA_38_inst                                                              0x0026
+#define OTP_DATA_39_inst                                                              0x0027
+#define OTP_DATA_40_inst                                                              0x0028
+#define OTP_DATA_41_inst                                                              0x0029
+#define OTP_DATA_42_inst                                                              0x002A
+#define OTP_DATA_43_inst                                                              0x002B
+#define OTP_DATA_44_inst                                                              0x002C
+#define OTP_DATA_45_inst                                                              0x002D
+#define OTP_DATA_46_inst                                                              0x002E
+#define OTP_DATA_47_inst                                                              0x002F
+#define OTP_DATA_48_inst                                                              0x0030
+#define OTP_DATA_49_inst                                                              0x0031
+#define OTP_DATA_50_inst                                                              0x0032
+#define OTP_DATA_51_inst                                                              0x0033
+#define OTP_DATA_52_inst                                                              0x0034
+#define OTP_DATA_53_inst                                                              0x0035
+#define OTP_DATA_54_inst                                                              0x0036
+#define OTP_DATA_55_inst                                                              0x0037
+#define OTP_DATA_56_inst                                                              0x0038
+#define OTP_DATA_57_inst                                                              0x0039
+#define OTP_DATA_58_inst                                                              0x003A
+#define OTP_DATA_59_inst                                                              0x003B
+#define OTP_DATA_60_inst                                                              0x003C
+#define OTP_DATA_61_inst                                                              0x003D
+#define OTP_DATA_62_inst                                                              0x003E
+#define OTP_DATA_63_inst                                                              0x003F
+#define OTP_DATA_64_inst                                                              0x0040
+#define OTP_DATA_65_inst                                                              0x0041
+#define OTP_DATA_66_inst                                                              0x0042
+#define OTP_DATA_67_inst                                                              0x0043
+#define OTP_DATA_68_inst                                                              0x0044
+#define OTP_DATA_69_inst                                                              0x0045
+#define OTP_DATA_70_inst                                                              0x0046
+#define OTP_DATA_71_inst                                                              0x0047
+#define OTP_DATA_72_inst                                                              0x0048
+#define OTP_DATA_73_inst                                                              0x0049
+#define OTP_DATA_74_inst                                                              0x004A
+#define OTP_DATA_75_inst                                                              0x004B
+#define OTP_DATA_76_inst                                                              0x004C
+#define OTP_DATA_77_inst                                                              0x004D
+#define OTP_DATA_78_inst                                                              0x004E
+#define OTP_DATA_79_inst                                                              0x004F
+#define OTP_DATA_80_inst                                                              0x0050
+#define OTP_DATA_81_inst                                                              0x0051
+#define OTP_DATA_82_inst                                                              0x0052
+#define OTP_DATA_83_inst                                                              0x0053
+#define OTP_DATA_84_inst                                                              0x0054
+#define OTP_DATA_85_inst                                                              0x0055
+#define OTP_DATA_86_inst                                                              0x0056
+#define OTP_DATA_87_inst                                                              0x0057
+#define OTP_DATA_88_inst                                                              0x0058
+#define OTP_DATA_89_inst                                                              0x0059
+#define OTP_DATA_90_inst                                                              0x005A
+#define OTP_DATA_91_inst                                                              0x005B
+#define OTP_DATA_92_inst                                                              0x005C
+#define OTP_DATA_93_inst                                                              0x005D
+#define OTP_DATA_94_inst                                                              0x005E
+#define OTP_DATA_95_inst                                                              0x005F
+#define OTP_DATA_96_inst                                                              0x0060
+#define OTP_DATA_97_inst                                                              0x0061
+#define OTP_DATA_98_inst                                                              0x0062
+#define OTP_DATA_99_inst                                                              0x0063
+#define OTP_DATA_100_inst                                                              0x0064
+#define OTP_DATA_101_inst                                                              0x0065
+#define OTP_DATA_102_inst                                                              0x0066
+#define OTP_DATA_103_inst                                                              0x0067
+#define OTP_DATA_104_inst                                                              0x0068
+#define OTP_DATA_105_inst                                                              0x0069
+#define OTP_DATA_106_inst                                                              0x006A
+#define OTP_DATA_107_inst                                                              0x006B
+#define OTP_DATA_108_inst                                                              0x006C
+#define OTP_DATA_109_inst                                                              0x006D
+#define OTP_DATA_110_inst                                                              0x006E
+#define OTP_DATA_111_inst                                                              0x006F
+#define OTP_DATA_112_inst                                                              0x0070
+#define OTP_DATA_113_inst                                                              0x0071
+#define OTP_DATA_114_inst                                                              0x0072
+#define OTP_DATA_115_inst                                                              0x0073
+#define OTP_DATA_116_inst                                                              0x0074
+#define OTP_DATA_117_inst                                                              0x0075
+#define OTP_DATA_118_inst                                                              0x0076
+#define OTP_DATA_119_inst                                                              0x0077
+#define OTP_DATA_120_inst                                                              0x0078
+#define OTP_DATA_121_inst                                                              0x0079
+#define OTP_DATA_122_inst                                                              0x007A
+#define OTP_DATA_123_inst                                                              0x007B
+#define OTP_DATA_124_inst                                                              0x007C
+#define OTP_DATA_125_inst                                                              0x007D
+#define OTP_DATA_126_inst                                                              0x007E
+#define OTP_DATA_127_inst                                                              0x007F
+#define OTP_DATA_datao_shift                                                         (0)
+#define OTP_DATA_datao_mask                                                          (0xFFFFFFFF)
+#define OTP_DATA_datao(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define OTP_DATA_datao_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define OTP_DATA_get_datao(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define OTP_CTRL                                                                     0x18017300
+#define OTP_CTRL_reg_addr                                                            "0xB8017300"
+#define OTP_CTRL_reg                                                                 0xB8017300
+#define set_OTP_CTRL_reg(data)   (*((volatile unsigned int*) OTP_CTRL_reg)=data)
+#define get_OTP_CTRL_reg   (*((volatile unsigned int*) OTP_CTRL_reg))
+#define OTP_CTRL_inst_adr                                                            "0x00C0"
+#define OTP_CTRL_inst                                                                0x00C0
+#define OTP_CTRL_write_en2_shift                                                     (31)
+#define OTP_CTRL_write_en2_mask                                                      (0x80000000)
+#define OTP_CTRL_write_en2(data)                                                     (0x80000000&((data)<<31))
+#define OTP_CTRL_write_en2_src(data)                                                 ((0x80000000&(data))>>31)
+#define OTP_CTRL_get_write_en2(data)                                                 ((0x80000000&(data))>>31)
+#define OTP_CTRL_rvd3_shift                                                          (25)
+#define OTP_CTRL_rvd3_mask                                                           (0x7E000000)
+#define OTP_CTRL_rvd3(data)                                                          (0x7E000000&((data)<<25))
+#define OTP_CTRL_rvd3_src(data)                                                      ((0x7E000000&(data))>>25)
+#define OTP_CTRL_get_rvd3(data)                                                      ((0x7E000000&(data))>>25)
+#define OTP_CTRL_auto_rd_otp_all_shift                                               (24)
+#define OTP_CTRL_auto_rd_otp_all_mask                                                (0x01000000)
+#define OTP_CTRL_auto_rd_otp_all(data)                                               (0x01000000&((data)<<24))
+#define OTP_CTRL_auto_rd_otp_all_src(data)                                           ((0x01000000&(data))>>24)
+#define OTP_CTRL_get_auto_rd_otp_all(data)                                           ((0x01000000&(data))>>24)
+#define OTP_CTRL_write_en1_shift                                                     (23)
+#define OTP_CTRL_write_en1_mask                                                      (0x00800000)
+#define OTP_CTRL_write_en1(data)                                                     (0x00800000&((data)<<23))
+#define OTP_CTRL_write_en1_src(data)                                                 ((0x00800000&(data))>>23)
+#define OTP_CTRL_get_write_en1(data)                                                 ((0x00800000&(data))>>23)
+#define OTP_CTRL_rvd2_shift                                                          (21)
+#define OTP_CTRL_rvd2_mask                                                           (0x00600000)
+#define OTP_CTRL_rvd2(data)                                                          (0x00600000&((data)<<21))
+#define OTP_CTRL_rvd2_src(data)                                                      ((0x00600000&(data))>>21)
+#define OTP_CTRL_get_rvd2(data)                                                      ((0x00600000&(data))>>21)
+#define OTP_CTRL_max_prog_num_shift                                                  (16)
+#define OTP_CTRL_max_prog_num_mask                                                   (0x001F0000)
+#define OTP_CTRL_max_prog_num(data)                                                  (0x001F0000&((data)<<16))
+#define OTP_CTRL_max_prog_num_src(data)                                              ((0x001F0000&(data))>>16)
+#define OTP_CTRL_get_max_prog_num(data)                                              ((0x001F0000&(data))>>16)
+#define OTP_CTRL_rvd1_shift                                                          (14)
+#define OTP_CTRL_rvd1_mask                                                           (0x0000C000)
+#define OTP_CTRL_rvd1(data)                                                          (0x0000C000&((data)<<14))
+#define OTP_CTRL_rvd1_src(data)                                                      ((0x0000C000&(data))>>14)
+#define OTP_CTRL_get_rvd1(data)                                                      ((0x0000C000&(data))>>14)
+#define OTP_CTRL_prog_shift                                                          (13)
+#define OTP_CTRL_prog_mask                                                           (0x00002000)
+#define OTP_CTRL_prog(data)                                                          (0x00002000&((data)<<13))
+#define OTP_CTRL_prog_src(data)                                                      ((0x00002000&(data))>>13)
+#define OTP_CTRL_get_prog(data)                                                      ((0x00002000&(data))>>13)
+#define OTP_CTRL_a_shift                                                             (0)
+#define OTP_CTRL_a_mask                                                              (0x00001FFF)
+#define OTP_CTRL_a(data)                                                             (0x00001FFF&((data)<<0))
+#define OTP_CTRL_a_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define OTP_CTRL_get_a(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define OTP_CTRL1                                                                    0x18017304
+#define OTP_CTRL1_reg_addr                                                           "0xB8017304"
+#define OTP_CTRL1_reg                                                                0xB8017304
+#define set_OTP_CTRL1_reg(data)   (*((volatile unsigned int*) OTP_CTRL1_reg)=data)
+#define get_OTP_CTRL1_reg   (*((volatile unsigned int*) OTP_CTRL1_reg))
+#define OTP_CTRL1_inst_adr                                                           "0x00C1"
+#define OTP_CTRL1_inst                                                               0x00C1
+#define OTP_CTRL1_write_en3_shift                                                    (31)
+#define OTP_CTRL1_write_en3_mask                                                     (0x80000000)
+#define OTP_CTRL1_write_en3(data)                                                    (0x80000000&((data)<<31))
+#define OTP_CTRL1_write_en3_src(data)                                                ((0x80000000&(data))>>31)
+#define OTP_CTRL1_get_write_en3(data)                                                ((0x80000000&(data))>>31)
+#define OTP_CTRL1_rvd2_shift                                                         (14)
+#define OTP_CTRL1_rvd2_mask                                                          (0x7FFFC000)
+#define OTP_CTRL1_rvd2(data)                                                         (0x7FFFC000&((data)<<14))
+#define OTP_CTRL1_rvd2_src(data)                                                     ((0x7FFFC000&(data))>>14)
+#define OTP_CTRL1_get_rvd2(data)                                                     ((0x7FFFC000&(data))>>14)
+#define OTP_CTRL1_write_en2_shift                                                    (13)
+#define OTP_CTRL1_write_en2_mask                                                     (0x00002000)
+#define OTP_CTRL1_write_en2(data)                                                    (0x00002000&((data)<<13))
+#define OTP_CTRL1_write_en2_src(data)                                                ((0x00002000&(data))>>13)
+#define OTP_CTRL1_get_write_en2(data)                                                ((0x00002000&(data))>>13)
+#define OTP_CTRL1_crc_en_shift                                                       (12)
+#define OTP_CTRL1_crc_en_mask                                                        (0x00001000)
+#define OTP_CTRL1_crc_en(data)                                                       (0x00001000&((data)<<12))
+#define OTP_CTRL1_crc_en_src(data)                                                   ((0x00001000&(data))>>12)
+#define OTP_CTRL1_get_crc_en(data)                                                   ((0x00001000&(data))>>12)
+#define OTP_CTRL1_rvd1_shift                                                         (9)
+#define OTP_CTRL1_rvd1_mask                                                          (0x00000E00)
+#define OTP_CTRL1_rvd1(data)                                                         (0x00000E00&((data)<<9))
+#define OTP_CTRL1_rvd1_src(data)                                                     ((0x00000E00&(data))>>9)
+#define OTP_CTRL1_get_rvd1(data)                                                     ((0x00000E00&(data))>>9)
+#define OTP_CTRL1_write_en1_shift                                                    (8)
+#define OTP_CTRL1_write_en1_mask                                                     (0x00000100)
+#define OTP_CTRL1_write_en1(data)                                                    (0x00000100&((data)<<8))
+#define OTP_CTRL1_write_en1_src(data)                                                ((0x00000100&(data))>>8)
+#define OTP_CTRL1_get_write_en1(data)                                                ((0x00000100&(data))>>8)
+#define OTP_CTRL1_en_prog_func_shift                                                 (0)
+#define OTP_CTRL1_en_prog_func_mask                                                  (0x000000FF)
+#define OTP_CTRL1_en_prog_func(data)                                                 (0x000000FF&((data)<<0))
+#define OTP_CTRL1_en_prog_func_src(data)                                             ((0x000000FF&(data))>>0)
+#define OTP_CTRL1_get_en_prog_func(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define OTP_STATUS                                                                   0x18017308
+#define OTP_STATUS_reg_addr                                                          "0xB8017308"
+#define OTP_STATUS_reg                                                               0xB8017308
+#define set_OTP_STATUS_reg(data)   (*((volatile unsigned int*) OTP_STATUS_reg)=data)
+#define get_OTP_STATUS_reg   (*((volatile unsigned int*) OTP_STATUS_reg))
+#define OTP_STATUS_inst_adr                                                          "0x00C2"
+#define OTP_STATUS_inst                                                              0x00C2
+#define OTP_STATUS_backdoor_allkeys_1_shift                                          (9)
+#define OTP_STATUS_backdoor_allkeys_1_mask                                           (0x00000200)
+#define OTP_STATUS_backdoor_allkeys_1(data)                                          (0x00000200&((data)<<9))
+#define OTP_STATUS_backdoor_allkeys_1_src(data)                                      ((0x00000200&(data))>>9)
+#define OTP_STATUS_get_backdoor_allkeys_1(data)                                      ((0x00000200&(data))>>9)
+#define OTP_STATUS_backdoor_f_shift                                                  (8)
+#define OTP_STATUS_backdoor_f_mask                                                   (0x00000100)
+#define OTP_STATUS_backdoor_f(data)                                                  (0x00000100&((data)<<8))
+#define OTP_STATUS_backdoor_f_src(data)                                              ((0x00000100&(data))>>8)
+#define OTP_STATUS_get_backdoor_f(data)                                              ((0x00000100&(data))>>8)
+#define OTP_STATUS_ate_prog_otp_a_ov_shift                                           (5)
+#define OTP_STATUS_ate_prog_otp_a_ov_mask                                            (0x00000020)
+#define OTP_STATUS_ate_prog_otp_a_ov(data)                                           (0x00000020&((data)<<5))
+#define OTP_STATUS_ate_prog_otp_a_ov_src(data)                                       ((0x00000020&(data))>>5)
+#define OTP_STATUS_get_ate_prog_otp_a_ov(data)                                       ((0x00000020&(data))>>5)
+#define OTP_STATUS_reg_prog_otp_a_ov_shift                                           (4)
+#define OTP_STATUS_reg_prog_otp_a_ov_mask                                            (0x00000010)
+#define OTP_STATUS_reg_prog_otp_a_ov(data)                                           (0x00000010&((data)<<4))
+#define OTP_STATUS_reg_prog_otp_a_ov_src(data)                                       ((0x00000010&(data))>>4)
+#define OTP_STATUS_get_reg_prog_otp_a_ov(data)                                       ((0x00000010&(data))>>4)
+#define OTP_STATUS_otp_fail_shift                                                    (3)
+#define OTP_STATUS_otp_fail_mask                                                     (0x00000008)
+#define OTP_STATUS_otp_fail(data)                                                    (0x00000008&((data)<<3))
+#define OTP_STATUS_otp_fail_src(data)                                                ((0x00000008&(data))>>3)
+#define OTP_STATUS_get_otp_fail(data)                                                ((0x00000008&(data))>>3)
+#define OTP_STATUS_otp_done_shift                                                    (2)
+#define OTP_STATUS_otp_done_mask                                                     (0x00000004)
+#define OTP_STATUS_otp_done(data)                                                    (0x00000004&((data)<<2))
+#define OTP_STATUS_otp_done_src(data)                                                ((0x00000004&(data))>>2)
+#define OTP_STATUS_get_otp_done(data)                                                ((0x00000004&(data))>>2)
+#define OTP_STATUS_rd_hw_info_done_shift                                             (1)
+#define OTP_STATUS_rd_hw_info_done_mask                                              (0x00000002)
+#define OTP_STATUS_rd_hw_info_done(data)                                             (0x00000002&((data)<<1))
+#define OTP_STATUS_rd_hw_info_done_src(data)                                         ((0x00000002&(data))>>1)
+#define OTP_STATUS_get_rd_hw_info_done(data)                                         ((0x00000002&(data))>>1)
+#define OTP_STATUS_rd_boot_info_done_shift                                           (0)
+#define OTP_STATUS_rd_boot_info_done_mask                                            (0x00000001)
+#define OTP_STATUS_rd_boot_info_done(data)                                           (0x00000001&((data)<<0))
+#define OTP_STATUS_rd_boot_info_done_src(data)                                       ((0x00000001&(data))>>0)
+#define OTP_STATUS_get_rd_boot_info_done(data)                                       ((0x00000001&(data))>>0)
+
+
+#define OTP_CRC                                                                      0x1801730C
+#define OTP_CRC_reg_addr                                                             "0xB801730C"
+#define OTP_CRC_reg                                                                  0xB801730C
+#define set_OTP_CRC_reg(data)   (*((volatile unsigned int*) OTP_CRC_reg)=data)
+#define get_OTP_CRC_reg   (*((volatile unsigned int*) OTP_CRC_reg))
+#define OTP_CRC_inst_adr                                                             "0x00C3"
+#define OTP_CRC_inst                                                                 0x00C3
+#define OTP_CRC_crc_ini_shift                                                        (16)
+#define OTP_CRC_crc_ini_mask                                                         (0xFFFF0000)
+#define OTP_CRC_crc_ini(data)                                                        (0xFFFF0000&((data)<<16))
+#define OTP_CRC_crc_ini_src(data)                                                    ((0xFFFF0000&(data))>>16)
+#define OTP_CRC_get_crc_ini(data)                                                    ((0xFFFF0000&(data))>>16)
+#define OTP_CRC_crc_out_shift                                                        (0)
+#define OTP_CRC_crc_out_mask                                                         (0x0000FFFF)
+#define OTP_CRC_crc_out(data)                                                        (0x0000FFFF&((data)<<0))
+#define OTP_CRC_crc_out_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define OTP_CRC_get_crc_out(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define OTP_RW1                                                                      0x18017310
+#define OTP_RW1_reg_addr                                                             "0xB8017310"
+#define OTP_RW1_reg                                                                  0xB8017310
+#define set_OTP_RW1_reg(data)   (*((volatile unsigned int*) OTP_RW1_reg)=data)
+#define get_OTP_RW1_reg   (*((volatile unsigned int*) OTP_RW1_reg))
+#define OTP_RW1_inst_adr                                                             "0x00C4"
+#define OTP_RW1_inst                                                                 0x00C4
+#define OTP_RW1_trs_shift                                                            (24)
+#define OTP_RW1_trs_mask                                                             (0x7F000000)
+#define OTP_RW1_trs(data)                                                            (0x7F000000&((data)<<24))
+#define OTP_RW1_trs_src(data)                                                        ((0x7F000000&(data))>>24)
+#define OTP_RW1_get_trs(data)                                                        ((0x7F000000&(data))>>24)
+#define OTP_RW1_tcsrst_shift                                                         (16)
+#define OTP_RW1_tcsrst_mask                                                          (0x007F0000)
+#define OTP_RW1_tcsrst(data)                                                         (0x007F0000&((data)<<16))
+#define OTP_RW1_tcsrst_src(data)                                                     ((0x007F0000&(data))>>16)
+#define OTP_RW1_get_tcsrst(data)                                                     ((0x007F0000&(data))>>16)
+#define OTP_RW1_op_hold_shift                                                        (0)
+#define OTP_RW1_op_hold_mask                                                         (0x0000FFFF)
+#define OTP_RW1_op_hold(data)                                                        (0x0000FFFF&((data)<<0))
+#define OTP_RW1_op_hold_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define OTP_RW1_get_op_hold(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define OTP_RW2                                                                      0x18017314
+#define OTP_RW2_reg_addr                                                             "0xB8017314"
+#define OTP_RW2_reg                                                                  0xB8017314
+#define set_OTP_RW2_reg(data)   (*((volatile unsigned int*) OTP_RW2_reg)=data)
+#define get_OTP_RW2_reg   (*((volatile unsigned int*) OTP_RW2_reg))
+#define OTP_RW2_inst_adr                                                             "0x00C5"
+#define OTP_RW2_inst                                                                 0x00C5
+#define OTP_RW2_twcad_shift                                                          (0)
+#define OTP_RW2_twcad_mask                                                           (0x000003FF)
+#define OTP_RW2_twcad(data)                                                          (0x000003FF&((data)<<0))
+#define OTP_RW2_twcad_src(data)                                                      ((0x000003FF&(data))>>0)
+#define OTP_RW2_get_twcad(data)                                                      ((0x000003FF&(data))>>0)
+
+
+#define OTP_RD                                                                       0x18017318
+#define OTP_RD_reg_addr                                                              "0xB8017318"
+#define OTP_RD_reg                                                                   0xB8017318
+#define set_OTP_RD_reg(data)   (*((volatile unsigned int*) OTP_RD_reg)=data)
+#define get_OTP_RD_reg   (*((volatile unsigned int*) OTP_RD_reg))
+#define OTP_RD_inst_adr                                                              "0x00C6"
+#define OTP_RD_inst                                                                  0x00C6
+#define OTP_RD_treaden_shift                                                         (0)
+#define OTP_RD_treaden_mask                                                          (0x0000000F)
+#define OTP_RD_treaden(data)                                                         (0x0000000F&((data)<<0))
+#define OTP_RD_treaden_src(data)                                                     ((0x0000000F&(data))>>0)
+#define OTP_RD_get_treaden(data)                                                     ((0x0000000F&(data))>>0)
+
+
+#define OTP_PROG1                                                                    0x1801731C
+#define OTP_PROG1_reg_addr                                                           "0xB801731C"
+#define OTP_PROG1_reg                                                                0xB801731C
+#define set_OTP_PROG1_reg(data)   (*((volatile unsigned int*) OTP_PROG1_reg)=data)
+#define get_OTP_PROG1_reg   (*((volatile unsigned int*) OTP_PROG1_reg))
+#define OTP_PROG1_inst_adr                                                           "0x00C7"
+#define OTP_PROG1_inst                                                               0x00C7
+#define OTP_PROG1_tcph_shift                                                         (24)
+#define OTP_PROG1_tcph_mask                                                          (0xFF000000)
+#define OTP_PROG1_tcph(data)                                                         (0xFF000000&((data)<<24))
+#define OTP_PROG1_tcph_src(data)                                                     ((0xFF000000&(data))>>24)
+#define OTP_PROG1_get_tcph(data)                                                     ((0xFF000000&(data))>>24)
+#define OTP_PROG1_tpw_shift                                                          (16)
+#define OTP_PROG1_tpw_mask                                                           (0x00FF0000)
+#define OTP_PROG1_tpw(data)                                                          (0x00FF0000&((data)<<16))
+#define OTP_PROG1_tpw_src(data)                                                      ((0x00FF0000&(data))>>16)
+#define OTP_PROG1_get_tpw(data)                                                      ((0x00FF0000&(data))>>16)
+#define OTP_PROG1_tcps_shift                                                         (8)
+#define OTP_PROG1_tcps_mask                                                          (0x0000FF00)
+#define OTP_PROG1_tcps(data)                                                         (0x0000FF00&((data)<<8))
+#define OTP_PROG1_tcps_src(data)                                                     ((0x0000FF00&(data))>>8)
+#define OTP_PROG1_get_tcps(data)                                                     ((0x0000FF00&(data))>>8)
+#define OTP_PROG1_tpes_shift                                                         (0)
+#define OTP_PROG1_tpes_mask                                                          (0x000000FF)
+#define OTP_PROG1_tpes(data)                                                         (0x000000FF&((data)<<0))
+#define OTP_PROG1_tpes_src(data)                                                     ((0x000000FF&(data))>>0)
+#define OTP_PROG1_get_tpes(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define OTP_PROG2                                                                    0x18017320
+#define OTP_PROG2_reg_addr                                                           "0xB8017320"
+#define OTP_PROG2_reg                                                                0xB8017320
+#define set_OTP_PROG2_reg(data)   (*((volatile unsigned int*) OTP_PROG2_reg)=data)
+#define get_OTP_PROG2_reg   (*((volatile unsigned int*) OTP_PROG2_reg))
+#define OTP_PROG2_inst_adr                                                           "0x00C8"
+#define OTP_PROG2_inst                                                               0x00C8
+#define OTP_PROG2_tpvsa_shift                                                        (28)
+#define OTP_PROG2_tpvsa_mask                                                         (0xF0000000)
+#define OTP_PROG2_tpvsa(data)                                                        (0xF0000000&((data)<<28))
+#define OTP_PROG2_tpvsa_src(data)                                                    ((0xF0000000&(data))>>28)
+#define OTP_PROG2_get_tpvsa(data)                                                    ((0xF0000000&(data))>>28)
+#define OTP_PROG2_tpvhr_shift                                                        (24)
+#define OTP_PROG2_tpvhr_mask                                                         (0x0F000000)
+#define OTP_PROG2_tpvhr(data)                                                        (0x0F000000&((data)<<24))
+#define OTP_PROG2_tpvhr_src(data)                                                    ((0x0F000000&(data))>>24)
+#define OTP_PROG2_get_tpvhr(data)                                                    ((0x0F000000&(data))>>24)
+#define OTP_PROG2_trwh_shift                                                         (20)
+#define OTP_PROG2_trwh_mask                                                          (0x00F00000)
+#define OTP_PROG2_trwh(data)                                                         (0x00F00000&((data)<<20))
+#define OTP_PROG2_trwh_src(data)                                                     ((0x00F00000&(data))>>20)
+#define OTP_PROG2_get_trwh(data)                                                     ((0x00F00000&(data))>>20)
+#define OTP_PROG2_tpgsv_shift                                                        (16)
+#define OTP_PROG2_tpgsv_mask                                                         (0x000F0000)
+#define OTP_PROG2_tpgsv(data)                                                        (0x000F0000&((data)<<16))
+#define OTP_PROG2_tpgsv_src(data)                                                    ((0x000F0000&(data))>>16)
+#define OTP_PROG2_get_tpgsv(data)                                                    ((0x000F0000&(data))>>16)
+#define OTP_PROG2_tpvsr_shift                                                        (8)
+#define OTP_PROG2_tpvsr_mask                                                         (0x0000FF00)
+#define OTP_PROG2_tpvsr(data)                                                        (0x0000FF00&((data)<<8))
+#define OTP_PROG2_tpvsr_src(data)                                                    ((0x0000FF00&(data))>>8)
+#define OTP_PROG2_get_tpvsr(data)                                                    ((0x0000FF00&(data))>>8)
+#define OTP_PROG2_tpeh_shift                                                         (0)
+#define OTP_PROG2_tpeh_mask                                                          (0x000000FF)
+#define OTP_PROG2_tpeh(data)                                                         (0x000000FF&((data)<<0))
+#define OTP_PROG2_tpeh_src(data)                                                     ((0x000000FF&(data))>>0)
+#define OTP_PROG2_get_tpeh(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define OTP_BC                                                                       0x18017324
+#define OTP_BC_reg_addr                                                              "0xB8017324"
+#define OTP_BC_reg                                                                   0xB8017324
+#define set_OTP_BC_reg(data)   (*((volatile unsigned int*) OTP_BC_reg)=data)
+#define get_OTP_BC_reg   (*((volatile unsigned int*) OTP_BC_reg))
+#define OTP_BC_inst_adr                                                              "0x00C9"
+#define OTP_BC_inst                                                                  0x00C9
+#define OTP_BC_tbcacc_shift                                                          (12)
+#define OTP_BC_tbcacc_mask                                                           (0x0000F000)
+#define OTP_BC_tbcacc(data)                                                          (0x0000F000&((data)<<12))
+#define OTP_BC_tbcacc_src(data)                                                      ((0x0000F000&(data))>>12)
+#define OTP_BC_get_tbcacc(data)                                                      ((0x0000F000&(data))>>12)
+#define OTP_BC_tcpes_shift                                                           (8)
+#define OTP_BC_tcpes_mask                                                            (0x00000F00)
+#define OTP_BC_tcpes(data)                                                           (0x00000F00&((data)<<8))
+#define OTP_BC_tcpes_src(data)                                                       ((0x00000F00&(data))>>8)
+#define OTP_BC_get_tcpes(data)                                                       ((0x00000F00&(data))>>8)
+#define OTP_BC_tcprd_shift                                                           (0)
+#define OTP_BC_tcprd_mask                                                            (0x0000003F)
+#define OTP_BC_tcprd(data)                                                           (0x0000003F&((data)<<0))
+#define OTP_BC_tcprd_src(data)                                                       ((0x0000003F&(data))>>0)
+#define OTP_BC_get_tcprd(data)                                                       ((0x0000003F&(data))>>0)
+
+
+#define OTP_TD                                                                       0x18017328
+#define OTP_TD_reg_addr                                                              "0xB8017328"
+#define OTP_TD_reg                                                                   0xB8017328
+#define set_OTP_TD_reg(data)   (*((volatile unsigned int*) OTP_TD_reg)=data)
+#define get_OTP_TD_reg   (*((volatile unsigned int*) OTP_TD_reg))
+#define OTP_TD_inst_adr                                                              "0x00CA"
+#define OTP_TD_inst                                                                  0x00CA
+#define OTP_TD_tacct_shift                                                           (4)
+#define OTP_TD_tacct_mask                                                            (0x000000F0)
+#define OTP_TD_tacct(data)                                                           (0x000000F0&((data)<<4))
+#define OTP_TD_tacct_src(data)                                                       ((0x000000F0&(data))>>4)
+#define OTP_TD_get_tacct(data)                                                       ((0x000000F0&(data))>>4)
+#define OTP_TD_trdes_shift                                                           (0)
+#define OTP_TD_trdes_mask                                                            (0x0000000F)
+#define OTP_TD_trdes(data)                                                           (0x0000000F&((data)<<0))
+#define OTP_TD_trdes_src(data)                                                       ((0x0000000F&(data))>>0)
+#define OTP_TD_get_trdes(data)                                                       ((0x0000000F&(data))>>0)
+
+
+#define OTP_DBG                                                                      0x18017330
+#define OTP_DBG_reg_addr                                                             "0xB8017330"
+#define OTP_DBG_reg                                                                  0xB8017330
+#define set_OTP_DBG_reg(data)   (*((volatile unsigned int*) OTP_DBG_reg)=data)
+#define get_OTP_DBG_reg   (*((volatile unsigned int*) OTP_DBG_reg))
+#define OTP_DBG_inst_adr                                                             "0x00CC"
+#define OTP_DBG_inst                                                                 0x00CC
+#define OTP_DBG_enable_shift                                                         (8)
+#define OTP_DBG_enable_mask                                                          (0x00000100)
+#define OTP_DBG_enable(data)                                                         (0x00000100&((data)<<8))
+#define OTP_DBG_enable_src(data)                                                     ((0x00000100&(data))>>8)
+#define OTP_DBG_get_enable(data)                                                     ((0x00000100&(data))>>8)
+#define OTP_DBG_sel1_shift                                                           (4)
+#define OTP_DBG_sel1_mask                                                            (0x000000F0)
+#define OTP_DBG_sel1(data)                                                           (0x000000F0&((data)<<4))
+#define OTP_DBG_sel1_src(data)                                                       ((0x000000F0&(data))>>4)
+#define OTP_DBG_get_sel1(data)                                                       ((0x000000F0&(data))>>4)
+#define OTP_DBG_sel0_shift                                                           (0)
+#define OTP_DBG_sel0_mask                                                            (0x0000000F)
+#define OTP_DBG_sel0(data)                                                           (0x0000000F&((data)<<0))
+#define OTP_DBG_sel0_src(data)                                                       ((0x0000000F&(data))>>0)
+#define OTP_DBG_get_sel0(data)                                                       ((0x0000000F&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/pci_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/pci_reg.h
new file mode 100644
index 00000000..e321bdf
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/pci_reg.h
@@ -0,0 +1,1851 @@
+/**************************************************************
+// Spec Version                  : 0.0.3
+// Parser Version                : MAR_Parser_1.0
+// CModelGen Version             : 1.0 2006.04.18
+// Naming Rule                   : Module_Register_Name
+// Firmware Header Generate Date : 2007/11/25
+***************************************************************/
+
+
+#ifndef _PCI_REG_H_INCLUDED_
+#define _PCI_REG_H_INCLUDED_
+#ifdef  _PCI_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     slave_on_16_00:1;
+unsigned int     reserved_1:15;
+unsigned int     bridge_mode_0_00:1;
+}DVR_GNR_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     loopback_cmd_22_04:1;
+unsigned int     loopback_en_21_04:1;
+unsigned int     neg_sample_en_20_04:1;
+unsigned int     clk_run_en_19_04:1;
+unsigned int     pci_inta_en_18_04:1;
+unsigned int     intp_dev_en_17_04:1;
+unsigned int     config_en_16_04:1;
+unsigned int     reserved_1:6;
+unsigned int     slave_unlimit_rd_9_04:1;
+unsigned int     slave_unlimit_wr_8_04:1;
+unsigned int     reserved_2:1;
+unsigned int     master_read_size_6to4_04:3;
+unsigned int     reserved_3:2;
+unsigned int     master_unlimit_rd_1_04:1;
+unsigned int     master_unlimit_wr_0_04:1;
+}DVR_GNR_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     intp_rdir_7_08:1;
+unsigned int     intp_wdir_6_08:1;
+unsigned int     intp_mst_5_08:1;
+unsigned int     intp_slv_4_08:1;
+unsigned int     intp_pci_3_08:1;
+unsigned int     intp_cfg_2_08:1;
+unsigned int     intp_mio_1_08:1;
+unsigned int     intp_dma_0_08:1;
+}DVR_GNR_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     go_ct_0_0c:1;
+}DVR_CFG_CT;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     type_en_8_10:1;
+unsigned int     byte_cnt_7to4_10:4;
+unsigned int     intp_en_3_10:1;
+unsigned int     error_en_2_10:1;
+unsigned int     byte_en_1_10:1;
+unsigned int     wrrd_en_0_10:1;
+}DVR_CFG_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     error_st_1_14:1;
+unsigned int     done_st_0_14:1;
+}DVR_CFG_ST;
+
+typedef struct 
+{
+unsigned int     space_addr_31to0_18:32;
+}DVR_CFG_ADDR;
+
+typedef struct 
+{
+unsigned int     space_wdata_31to0_1c:32;
+}DVR_CFG_WDATA;
+
+typedef struct 
+{
+unsigned int     space_rdata_31to0_20:32;
+}DVR_CFG_RDATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     go_ct_0_24:1;
+}DVR_MIO_CT;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     error_st_1_28:1;
+unsigned int     done_st_0_28:1;
+}DVR_MIO_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     byte_cnt_8to5_2c:4;
+unsigned int     intp_en_4_2c:1;
+unsigned int     error_en_3_2c:1;
+unsigned int     byte_en_2_2c:1;
+unsigned int     wrrd_en_1_2c:1;
+unsigned int     type_en_0_2c:1;
+}DVR_MIO_EN;
+
+typedef struct 
+{
+unsigned int     pci_addr_31to0_30:32;
+}DVR_MIO_ADDR;
+
+typedef struct 
+{
+unsigned int     pci_wdata_31to0_34:32;
+}DVR_MIO_WDATA;
+
+typedef struct 
+{
+unsigned int     pci_rdata_31to0_38:32;
+}DVR_MIO_RDATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     go_ct_0_3c:1;
+}DVR_DMA_CT;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     idle_st_5_40:1;
+unsigned int     sin_dma_done_st_4_40:1;
+unsigned int     desc_dma_done_st_3_40:1;
+unsigned int     desc_empty_st_2_40:1;
+unsigned int     pci_error_st_1_40:1;
+unsigned int     desc_error_st_0_40:1;
+}DVR_DMA_ST;
+
+typedef struct 
+{
+unsigned int     intv_cnt_31to16_44:16;
+unsigned int     reserved_0:4;
+unsigned int     intp_done_en_11_44:1;
+unsigned int     intp_empty_en_10_44:1;
+unsigned int     intp_pci_error_en_9_44:1;
+unsigned int     intp_desc_error_en_8_44:1;
+unsigned int     reserved_1:4;
+unsigned int     intv_en_3_44:1;
+unsigned int     go_en_2_44:1;
+unsigned int     mode_en_1_44:1;
+unsigned int     desc_en_0_44:1;
+}DVR_DMA_EN;
+
+typedef struct 
+{
+unsigned int     addr_31to0_48:32;
+}DVR_DMA_PCI;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr_27to0_4c:28;
+}DVR_DMA_DDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     byte_cnt_23to0_50:24;
+}DVR_DMA_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     base_ptr_27to0_54:28;
+}DVR_DMA_DES0;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     limit_ptr_27to0_58:28;
+}DVR_DMA_DES1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     wr_ptr_27to0_5c:28;
+}DVR_DMA_DES2;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     rd_ptr_27to0_60:28;
+}DVR_DMA_DES3;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     stop_ct_8_64:1;
+unsigned int     reserved_1:7;
+unsigned int     idle_st_0_64:1;
+}DVR_SOFT_RST;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     pci_master_busy_st_7_68:1;
+unsigned int     pci_slave_busy_st_6_68:1;
+unsigned int     mio_cfg_busy_st_5_68:1;
+unsigned int     dma_busy_st_4_68:1;
+unsigned int     reserved_1:2;
+unsigned int     pci_clk_lock_st_1_68:1;
+unsigned int     pci_clk_st_0_68:1;
+}DVR_CLK_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     pci_int_req_8_6c:1;
+unsigned int     reserved_1:3;
+unsigned int     clk_run_req_4_6c:1;
+unsigned int     reserved_2:3;
+unsigned int     pci_clk_lock_en_0_6c:1;
+}DVR_SPC_CT;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     pci_int_st_16_70:1;
+unsigned int     reserved_1:15;
+unsigned int     clk_run_st_0_70:1;
+}DVR_SPC_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     dbg_sel1:6;
+unsigned int     dbg_sel0:6;
+unsigned int     dbg_en:1;
+}DVR_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     rerror_st_1_78:1;
+unsigned int     werror_st_0_78:1;
+}DVR_DIR_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     error_ack_read_1_7c:1;
+unsigned int     intp_en_0_7c:1;
+}DVR_DIR_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     dev_ddr_done_st_0_80:1;
+}DVR_DEV_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     dev_start_0_84:1;
+}DVR_DEV_CT;
+
+typedef struct 
+{
+unsigned int     dev_ddr_addr_31to0_88:32;
+}DVR_DEV_DDR;
+
+typedef struct 
+{
+unsigned int     dev_pci_addr_31to0_8c:32;
+}DVR_DEV_PCI;
+
+typedef struct 
+{
+unsigned int     dev_ddr_cnt_31to0_90:32;
+}DVR_DEV_CNT;
+
+typedef struct 
+{
+unsigned int     test_reg:32;
+}DVR_TMP0_REG;
+
+typedef struct 
+{
+unsigned int     test_reg:32;
+}DVR_TMP1_REG;
+
+typedef struct 
+{
+unsigned int     reg1:16;
+unsigned int     reg0:16;
+}DVR_SCTCH;
+
+typedef struct 
+{
+unsigned int     reg1_16to31_00:16;
+unsigned int     reg0_0to15_00:16;
+}PCI_SCTCH;
+
+typedef struct 
+{
+unsigned int     retry_cnt_0to15_04:16;
+unsigned int     reserved_0:15;
+unsigned int     retry_cnt_en_0_04:1;
+}PCI_GNR_EN1;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     master_rd_burst_25to26_08:2;
+unsigned int     master_wr_inv_24_08:1;
+unsigned int     reserved_1:1;
+unsigned int     spc_cyc_en_22_08:1;
+unsigned int     retry_int_en_21_08:1;
+unsigned int     mon_int_en_20_08:1;
+unsigned int     pme_int_en_19_08:1;
+unsigned int     inta_int_en_18_08:1;
+unsigned int     serr_int_en_17_08:1;
+unsigned int     perr_int_en_16_08:1;
+unsigned int     reserved_2:1;
+unsigned int     lat_timer_en_14_08:1;
+unsigned int     pci_mon_en_13_08:1;
+unsigned int     park_dev_12o11_08:2;
+unsigned int     bus_park_en_10_08:1;
+unsigned int     slave_b2b_en_9_08:1;
+unsigned int     66mhz_en_8_08:1;
+unsigned int     reserved_3:1;
+unsigned int     xbus_ba_en_6_08:1;
+unsigned int     sbus_tran_en_5_08:1;
+unsigned int     sbus_ba_en_4_08:1;
+unsigned int     dbus_tran_en_3_08:1;
+unsigned int     dbus_ba_en_2_08:1;
+unsigned int     rbus_tran_en_1_08:1;
+unsigned int     rbus_ba_en_0_08:1;
+}PCI_GNR_EN2;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     spc_cyc_msn_17to16_0c:2;
+unsigned int     reserved_1:9;
+unsigned int     spc_cyc_erro_6_0c:1;
+unsigned int     retry_error_5_0c:1;
+unsigned int     mon_error_4_0c:1;
+unsigned int     serr_error_3_0c:1;
+unsigned int     perr_error_2_0c:1;
+unsigned int     slave_error_1_0c:1;
+unsigned int     master_error_0_0c:1;
+}PCI_GNR_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     intp_spc_cyc_6_10:1;
+unsigned int     intp_retry_5_10:1;
+unsigned int     intp_mon_4_10:1;
+unsigned int     intp_pme_3_10:1;
+unsigned int     intp_genr_2_10:1;
+unsigned int     intp_serr_1_10:1;
+unsigned int     intp_perr_0_10:1;
+}PCI_GNR_INT;
+
+typedef struct 
+{
+unsigned int     rbus_mask_31to28_14:4;
+unsigned int     rbus_mask_27to8_14:20;
+unsigned int     reserved_0:8;
+}PCI_MASK0;
+
+typedef struct 
+{
+unsigned int     rbus_transl_31to8_18:24;
+unsigned int     reserved_0:8;
+}PCI_TRANSL0;
+
+typedef struct 
+{
+unsigned int     dbus_mask_31to28_1c:4;
+unsigned int     dbus_mask_27to8_1c:20;
+unsigned int     reserved_0:8;
+}PCI_MASK1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dbus_transl_27to8_20:20;
+unsigned int     reserved_1:8;
+}PCI_TRANSL1;
+
+typedef struct 
+{
+unsigned int     sbus_mask_31to28_24:4;
+unsigned int     sbus_mask_27to8_24:20;
+unsigned int     reserved_0:8;
+}PCI_MASK2;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     sbus_transl_27to8_28:20;
+unsigned int     reserved_1:8;
+}PCI_TRANSL2;
+
+typedef struct 
+{
+unsigned int     addr_error_31to0_2c:32;
+}PCI_MST_ERR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cmd_error_3to0_30:4;
+}PCI_MST_ERR1;
+
+typedef struct 
+{
+unsigned int     addr_error_31to0_34:32;
+}PCI_SLV_ERR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cmd_error_3to0_38:4;
+}PCI_SLV_ERR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     error_clear_16_40:1;
+unsigned int     reserved_1:1;
+unsigned int     erro_msn_14to13_40:2;
+unsigned int     pci_stop_12_3c:1;
+unsigned int     pci_trdy_11_3c:1;
+unsigned int     pci_devsel_10_3c:1;
+unsigned int     pci_irdy_9_3c:1;
+unsigned int     pci_frame_8_3c:1;
+unsigned int     reserved_2:8;
+}PCI_MON_ST;
+
+typedef struct 
+{
+unsigned int     test_reg:32;
+}PCI_TMP_REG;
+
+typedef struct 
+{
+unsigned int     dev_id:16;
+unsigned int     ven_id:16;
+}CFG_00H;
+
+typedef struct 
+{
+unsigned int     detec_par_error:1;
+unsigned int     signal_sys_error:1;
+unsigned int     rec_master_abort:1;
+unsigned int     rec_target_abort:1;
+unsigned int     sig_tar_abort:1;
+unsigned int     devsel_timer:2;
+unsigned int     master_par_error:1;
+unsigned int     fast_b2b_cap:1;
+unsigned int     reserved_0:1;
+unsigned int     a66mhz:1;
+unsigned int     capability_list:1;
+unsigned int     int_status:1;
+unsigned int     reserved_1:8;
+unsigned int     interrupt_disable:1;
+unsigned int     fast_b2b:1;
+unsigned int     serr_enable:1;
+unsigned int     reserved_2:1;
+unsigned int     parity_error_resp:1;
+unsigned int     reserved_3:1;
+unsigned int     mwie:1;
+unsigned int     reserved_4:1;
+unsigned int     bus_master:1;
+unsigned int     mm_space:1;
+unsigned int     io_space:1;
+}CFG_04H;
+
+typedef struct 
+{
+unsigned int     class_code:24;
+unsigned int     Rev_id:8;
+}CFG_08H;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     reserved_1:8;
+unsigned int     latency_timer:8;
+unsigned int     cacheline_size:8;
+}CFG_0CH;
+
+typedef struct 
+{
+unsigned int     reg_ba:27;
+unsigned int     reserved_0:4;
+unsigned int     space_bit:1;
+}CFG_10H;
+
+typedef struct 
+{
+unsigned int     dbus_ba:24;
+unsigned int     reserved_0:7;
+unsigned int     space_bit:1;
+}CFG_14H;
+
+typedef struct 
+{
+unsigned int     rbus_ba:24;
+unsigned int     reserved_0:7;
+unsigned int     space_bit:1;
+}CFG_18H;
+
+typedef struct 
+{
+unsigned int     sbus_ba:24;
+unsigned int     reserved_0:7;
+unsigned int     space_bit:1;
+}CFG_1CH;
+
+typedef struct 
+{
+unsigned int     sub_id:16;
+unsigned int     sub_ven_id:16;
+}CFG_2CH;
+
+typedef struct 
+{
+unsigned int     max_Lat:8;
+unsigned int     min_gnt:8;
+unsigned int     interrupt_pin:8;
+unsigned int     interrupt_line:8;
+}CFG_3CH;
+
+#endif
+
+#define DVR_GNR_MODE                                                                 0x18017000
+#define DVR_GNR_MODE_reg_addr                                                        "0xB8017000"
+#define DVR_GNR_MODE_reg                                                             0xB8017000
+#define DVR_GNR_MODE_inst_adr                                                        "0x0000"
+#define DVR_GNR_MODE_inst                                                            0x0000
+#define DVR_GNR_MODE_slave_on_16_00_shift                                            (16)
+#define DVR_GNR_MODE_slave_on_16_00_mask                                             (0x00010000)
+#define DVR_GNR_MODE_slave_on_16_00(data)                                            (0x00010000&((data)<<16))
+#define DVR_GNR_MODE_slave_on_16_00_src(data)                                        ((0x00010000&(data))>>16)
+#define DVR_GNR_MODE_bridge_mode_0_00_shift                                          (0)
+#define DVR_GNR_MODE_bridge_mode_0_00_mask                                           (0x00000001)
+#define DVR_GNR_MODE_bridge_mode_0_00(data)                                          (0x00000001&((data)<<0))
+#define DVR_GNR_MODE_bridge_mode_0_00_src(data)                                      ((0x00000001&(data))>>0)
+
+
+#define DVR_GNR_EN                                                                   0x18017004
+#define DVR_GNR_EN_reg_addr                                                          "0xB8017004"
+#define DVR_GNR_EN_reg                                                               0xB8017004
+#define DVR_GNR_EN_inst_adr                                                          "0x0001"
+#define DVR_GNR_EN_inst                                                              0x0001
+#define DVR_GNR_EN_loopback_cmd_22_04_shift                                          (22)
+#define DVR_GNR_EN_loopback_cmd_22_04_mask                                           (0x00400000)
+#define DVR_GNR_EN_loopback_cmd_22_04(data)                                          (0x00400000&((data)<<22))
+#define DVR_GNR_EN_loopback_cmd_22_04_src(data)                                      ((0x00400000&(data))>>22)
+#define DVR_GNR_EN_loopback_en_21_04_shift                                           (21)
+#define DVR_GNR_EN_loopback_en_21_04_mask                                            (0x00200000)
+#define DVR_GNR_EN_loopback_en_21_04(data)                                           (0x00200000&((data)<<21))
+#define DVR_GNR_EN_loopback_en_21_04_src(data)                                       ((0x00200000&(data))>>21)
+#define DVR_GNR_EN_neg_sample_en_20_04_shift                                         (20)
+#define DVR_GNR_EN_neg_sample_en_20_04_mask                                          (0x00100000)
+#define DVR_GNR_EN_neg_sample_en_20_04(data)                                         (0x00100000&((data)<<20))
+#define DVR_GNR_EN_neg_sample_en_20_04_src(data)                                     ((0x00100000&(data))>>20)
+#define DVR_GNR_EN_clk_run_en_19_04_shift                                            (19)
+#define DVR_GNR_EN_clk_run_en_19_04_mask                                             (0x00080000)
+#define DVR_GNR_EN_clk_run_en_19_04(data)                                            (0x00080000&((data)<<19))
+#define DVR_GNR_EN_clk_run_en_19_04_src(data)                                        ((0x00080000&(data))>>19)
+#define DVR_GNR_EN_pci_inta_en_18_04_shift                                           (18)
+#define DVR_GNR_EN_pci_inta_en_18_04_mask                                            (0x00040000)
+#define DVR_GNR_EN_pci_inta_en_18_04(data)                                           (0x00040000&((data)<<18))
+#define DVR_GNR_EN_pci_inta_en_18_04_src(data)                                       ((0x00040000&(data))>>18)
+#define DVR_GNR_EN_intp_dev_en_17_04_shift                                           (17)
+#define DVR_GNR_EN_intp_dev_en_17_04_mask                                            (0x00020000)
+#define DVR_GNR_EN_intp_dev_en_17_04(data)                                           (0x00020000&((data)<<17))
+#define DVR_GNR_EN_intp_dev_en_17_04_src(data)                                       ((0x00020000&(data))>>17)
+#define DVR_GNR_EN_config_en_16_04_shift                                             (16)
+#define DVR_GNR_EN_config_en_16_04_mask                                              (0x00010000)
+#define DVR_GNR_EN_config_en_16_04(data)                                             (0x00010000&((data)<<16))
+#define DVR_GNR_EN_config_en_16_04_src(data)                                         ((0x00010000&(data))>>16)
+#define DVR_GNR_EN_slave_unlimit_rd_9_04_shift                                       (9)
+#define DVR_GNR_EN_slave_unlimit_rd_9_04_mask                                        (0x00000200)
+#define DVR_GNR_EN_slave_unlimit_rd_9_04(data)                                       (0x00000200&((data)<<9))
+#define DVR_GNR_EN_slave_unlimit_rd_9_04_src(data)                                   ((0x00000200&(data))>>9)
+#define DVR_GNR_EN_slave_unlimit_wr_8_04_shift                                       (8)
+#define DVR_GNR_EN_slave_unlimit_wr_8_04_mask                                        (0x00000100)
+#define DVR_GNR_EN_slave_unlimit_wr_8_04(data)                                       (0x00000100&((data)<<8))
+#define DVR_GNR_EN_slave_unlimit_wr_8_04_src(data)                                   ((0x00000100&(data))>>8)
+#define DVR_GNR_EN_master_read_size_6to4_04_shift                                    (4)
+#define DVR_GNR_EN_master_read_size_6to4_04_mask                                     (0x00000070)
+#define DVR_GNR_EN_master_read_size_6to4_04(data)                                    (0x00000070&((data)<<4))
+#define DVR_GNR_EN_master_read_size_6to4_04_src(data)                                ((0x00000070&(data))>>4)
+#define DVR_GNR_EN_master_unlimit_rd_1_04_shift                                      (1)
+#define DVR_GNR_EN_master_unlimit_rd_1_04_mask                                       (0x00000002)
+#define DVR_GNR_EN_master_unlimit_rd_1_04(data)                                      (0x00000002&((data)<<1))
+#define DVR_GNR_EN_master_unlimit_rd_1_04_src(data)                                  ((0x00000002&(data))>>1)
+#define DVR_GNR_EN_master_unlimit_wr_0_04_shift                                      (0)
+#define DVR_GNR_EN_master_unlimit_wr_0_04_mask                                       (0x00000001)
+#define DVR_GNR_EN_master_unlimit_wr_0_04(data)                                      (0x00000001&((data)<<0))
+#define DVR_GNR_EN_master_unlimit_wr_0_04_src(data)                                  ((0x00000001&(data))>>0)
+
+
+#define DVR_GNR_INT                                                                  0x18017008
+#define DVR_GNR_INT_reg_addr                                                         "0xB8017008"
+#define DVR_GNR_INT_reg                                                              0xB8017008
+#define DVR_GNR_INT_inst_adr                                                         "0x0002"
+#define DVR_GNR_INT_inst                                                             0x0002
+#define DVR_GNR_INT_intp_rdir_7_08_shift                                             (7)
+#define DVR_GNR_INT_intp_rdir_7_08_mask                                              (0x00000080)
+#define DVR_GNR_INT_intp_rdir_7_08(data)                                             (0x00000080&((data)<<7))
+#define DVR_GNR_INT_intp_rdir_7_08_src(data)                                         ((0x00000080&(data))>>7)
+#define DVR_GNR_INT_intp_wdir_6_08_shift                                             (6)
+#define DVR_GNR_INT_intp_wdir_6_08_mask                                              (0x00000040)
+#define DVR_GNR_INT_intp_wdir_6_08(data)                                             (0x00000040&((data)<<6))
+#define DVR_GNR_INT_intp_wdir_6_08_src(data)                                         ((0x00000040&(data))>>6)
+#define DVR_GNR_INT_intp_mst_5_08_shift                                              (5)
+#define DVR_GNR_INT_intp_mst_5_08_mask                                               (0x00000020)
+#define DVR_GNR_INT_intp_mst_5_08(data)                                              (0x00000020&((data)<<5))
+#define DVR_GNR_INT_intp_mst_5_08_src(data)                                          ((0x00000020&(data))>>5)
+#define DVR_GNR_INT_intp_slv_4_08_shift                                              (4)
+#define DVR_GNR_INT_intp_slv_4_08_mask                                               (0x00000010)
+#define DVR_GNR_INT_intp_slv_4_08(data)                                              (0x00000010&((data)<<4))
+#define DVR_GNR_INT_intp_slv_4_08_src(data)                                          ((0x00000010&(data))>>4)
+#define DVR_GNR_INT_intp_pci_3_08_shift                                              (3)
+#define DVR_GNR_INT_intp_pci_3_08_mask                                               (0x00000008)
+#define DVR_GNR_INT_intp_pci_3_08(data)                                              (0x00000008&((data)<<3))
+#define DVR_GNR_INT_intp_pci_3_08_src(data)                                          ((0x00000008&(data))>>3)
+#define DVR_GNR_INT_intp_cfg_2_08_shift                                              (2)
+#define DVR_GNR_INT_intp_cfg_2_08_mask                                               (0x00000004)
+#define DVR_GNR_INT_intp_cfg_2_08(data)                                              (0x00000004&((data)<<2))
+#define DVR_GNR_INT_intp_cfg_2_08_src(data)                                          ((0x00000004&(data))>>2)
+#define DVR_GNR_INT_intp_mio_1_08_shift                                              (1)
+#define DVR_GNR_INT_intp_mio_1_08_mask                                               (0x00000002)
+#define DVR_GNR_INT_intp_mio_1_08(data)                                              (0x00000002&((data)<<1))
+#define DVR_GNR_INT_intp_mio_1_08_src(data)                                          ((0x00000002&(data))>>1)
+#define DVR_GNR_INT_intp_dma_0_08_shift                                              (0)
+#define DVR_GNR_INT_intp_dma_0_08_mask                                               (0x00000001)
+#define DVR_GNR_INT_intp_dma_0_08(data)                                              (0x00000001&((data)<<0))
+#define DVR_GNR_INT_intp_dma_0_08_src(data)                                          ((0x00000001&(data))>>0)
+
+
+#define DVR_CFG_CT                                                                   0x1801700C
+#define DVR_CFG_CT_reg_addr                                                          "0xB801700C"
+#define DVR_CFG_CT_reg                                                               0xB801700C
+#define DVR_CFG_CT_inst_adr                                                          "0x0003"
+#define DVR_CFG_CT_inst                                                              0x0003
+#define DVR_CFG_CT_go_ct_0_0c_shift                                                  (0)
+#define DVR_CFG_CT_go_ct_0_0c_mask                                                   (0x00000001)
+#define DVR_CFG_CT_go_ct_0_0c(data)                                                  (0x00000001&((data)<<0))
+#define DVR_CFG_CT_go_ct_0_0c_src(data)                                              ((0x00000001&(data))>>0)
+
+
+#define DVR_CFG_EN                                                                   0x18017010
+#define DVR_CFG_EN_reg_addr                                                          "0xB8017010"
+#define DVR_CFG_EN_reg                                                               0xB8017010
+#define DVR_CFG_EN_inst_adr                                                          "0x0004"
+#define DVR_CFG_EN_inst                                                              0x0004
+#define DVR_CFG_EN_type_en_8_10_shift                                                (8)
+#define DVR_CFG_EN_type_en_8_10_mask                                                 (0x00000100)
+#define DVR_CFG_EN_type_en_8_10(data)                                                (0x00000100&((data)<<8))
+#define DVR_CFG_EN_type_en_8_10_src(data)                                            ((0x00000100&(data))>>8)
+#define DVR_CFG_EN_byte_cnt_7to4_10_shift                                            (4)
+#define DVR_CFG_EN_byte_cnt_7to4_10_mask                                             (0x000000F0)
+#define DVR_CFG_EN_byte_cnt_7to4_10(data)                                            (0x000000F0&((data)<<4))
+#define DVR_CFG_EN_byte_cnt_7to4_10_src(data)                                        ((0x000000F0&(data))>>4)
+#define DVR_CFG_EN_intp_en_3_10_shift                                                (3)
+#define DVR_CFG_EN_intp_en_3_10_mask                                                 (0x00000008)
+#define DVR_CFG_EN_intp_en_3_10(data)                                                (0x00000008&((data)<<3))
+#define DVR_CFG_EN_intp_en_3_10_src(data)                                            ((0x00000008&(data))>>3)
+#define DVR_CFG_EN_error_en_2_10_shift                                               (2)
+#define DVR_CFG_EN_error_en_2_10_mask                                                (0x00000004)
+#define DVR_CFG_EN_error_en_2_10(data)                                               (0x00000004&((data)<<2))
+#define DVR_CFG_EN_error_en_2_10_src(data)                                           ((0x00000004&(data))>>2)
+#define DVR_CFG_EN_byte_en_1_10_shift                                                (1)
+#define DVR_CFG_EN_byte_en_1_10_mask                                                 (0x00000002)
+#define DVR_CFG_EN_byte_en_1_10(data)                                                (0x00000002&((data)<<1))
+#define DVR_CFG_EN_byte_en_1_10_src(data)                                            ((0x00000002&(data))>>1)
+#define DVR_CFG_EN_wrrd_en_0_10_shift                                                (0)
+#define DVR_CFG_EN_wrrd_en_0_10_mask                                                 (0x00000001)
+#define DVR_CFG_EN_wrrd_en_0_10(data)                                                (0x00000001&((data)<<0))
+#define DVR_CFG_EN_wrrd_en_0_10_src(data)                                            ((0x00000001&(data))>>0)
+
+
+#define DVR_CFG_ST                                                                   0x18017014
+#define DVR_CFG_ST_reg_addr                                                          "0xB8017014"
+#define DVR_CFG_ST_reg                                                               0xB8017014
+#define DVR_CFG_ST_inst_adr                                                          "0x0005"
+#define DVR_CFG_ST_inst                                                              0x0005
+#define DVR_CFG_ST_error_st_1_14_shift                                               (1)
+#define DVR_CFG_ST_error_st_1_14_mask                                                (0x00000002)
+#define DVR_CFG_ST_error_st_1_14(data)                                               (0x00000002&((data)<<1))
+#define DVR_CFG_ST_error_st_1_14_src(data)                                           ((0x00000002&(data))>>1)
+#define DVR_CFG_ST_done_st_0_14_shift                                                (0)
+#define DVR_CFG_ST_done_st_0_14_mask                                                 (0x00000001)
+#define DVR_CFG_ST_done_st_0_14(data)                                                (0x00000001&((data)<<0))
+#define DVR_CFG_ST_done_st_0_14_src(data)                                            ((0x00000001&(data))>>0)
+
+
+#define DVR_CFG_ADDR                                                                 0x18017018
+#define DVR_CFG_ADDR_reg_addr                                                        "0xB8017018"
+#define DVR_CFG_ADDR_reg                                                             0xB8017018
+#define DVR_CFG_ADDR_inst_adr                                                        "0x0006"
+#define DVR_CFG_ADDR_inst                                                            0x0006
+#define DVR_CFG_ADDR_space_addr_31to0_18_shift                                       (0)
+#define DVR_CFG_ADDR_space_addr_31to0_18_mask                                        (0xFFFFFFFF)
+#define DVR_CFG_ADDR_space_addr_31to0_18(data)                                       (0xFFFFFFFF&((data)<<0))
+#define DVR_CFG_ADDR_space_addr_31to0_18_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_CFG_WDATA                                                                0x1801701C
+#define DVR_CFG_WDATA_reg_addr                                                       "0xB801701C"
+#define DVR_CFG_WDATA_reg                                                            0xB801701C
+#define DVR_CFG_WDATA_inst_adr                                                       "0x0007"
+#define DVR_CFG_WDATA_inst                                                           0x0007
+#define DVR_CFG_WDATA_space_wdata_31to0_1c_shift                                     (0)
+#define DVR_CFG_WDATA_space_wdata_31to0_1c_mask                                      (0xFFFFFFFF)
+#define DVR_CFG_WDATA_space_wdata_31to0_1c(data)                                     (0xFFFFFFFF&((data)<<0))
+#define DVR_CFG_WDATA_space_wdata_31to0_1c_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_CFG_RDATA                                                                0x18017020
+#define DVR_CFG_RDATA_reg_addr                                                       "0xB8017020"
+#define DVR_CFG_RDATA_reg                                                            0xB8017020
+#define DVR_CFG_RDATA_inst_adr                                                       "0x0008"
+#define DVR_CFG_RDATA_inst                                                           0x0008
+#define DVR_CFG_RDATA_space_rdata_31to0_20_shift                                     (0)
+#define DVR_CFG_RDATA_space_rdata_31to0_20_mask                                      (0xFFFFFFFF)
+#define DVR_CFG_RDATA_space_rdata_31to0_20(data)                                     (0xFFFFFFFF&((data)<<0))
+#define DVR_CFG_RDATA_space_rdata_31to0_20_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_MIO_CT                                                                   0x18017024
+#define DVR_MIO_CT_reg_addr                                                          "0xB8017024"
+#define DVR_MIO_CT_reg                                                               0xB8017024
+#define DVR_MIO_CT_inst_adr                                                          "0x0009"
+#define DVR_MIO_CT_inst                                                              0x0009
+#define DVR_MIO_CT_go_ct_0_24_shift                                                  (0)
+#define DVR_MIO_CT_go_ct_0_24_mask                                                   (0x00000001)
+#define DVR_MIO_CT_go_ct_0_24(data)                                                  (0x00000001&((data)<<0))
+#define DVR_MIO_CT_go_ct_0_24_src(data)                                              ((0x00000001&(data))>>0)
+
+
+#define DVR_MIO_ST                                                                   0x18017028
+#define DVR_MIO_ST_reg_addr                                                          "0xB8017028"
+#define DVR_MIO_ST_reg                                                               0xB8017028
+#define DVR_MIO_ST_inst_adr                                                          "0x000A"
+#define DVR_MIO_ST_inst                                                              0x000A
+#define DVR_MIO_ST_error_st_1_28_shift                                               (1)
+#define DVR_MIO_ST_error_st_1_28_mask                                                (0x00000002)
+#define DVR_MIO_ST_error_st_1_28(data)                                               (0x00000002&((data)<<1))
+#define DVR_MIO_ST_error_st_1_28_src(data)                                           ((0x00000002&(data))>>1)
+#define DVR_MIO_ST_done_st_0_28_shift                                                (0)
+#define DVR_MIO_ST_done_st_0_28_mask                                                 (0x00000001)
+#define DVR_MIO_ST_done_st_0_28(data)                                                (0x00000001&((data)<<0))
+#define DVR_MIO_ST_done_st_0_28_src(data)                                            ((0x00000001&(data))>>0)
+
+
+#define DVR_MIO_EN                                                                   0x1801702C
+#define DVR_MIO_EN_reg_addr                                                          "0xB801702C"
+#define DVR_MIO_EN_reg                                                               0xB801702C
+#define DVR_MIO_EN_inst_adr                                                          "0x000B"
+#define DVR_MIO_EN_inst                                                              0x000B
+#define DVR_MIO_EN_byte_cnt_8to5_2c_shift                                            (5)
+#define DVR_MIO_EN_byte_cnt_8to5_2c_mask                                             (0x000001E0)
+#define DVR_MIO_EN_byte_cnt_8to5_2c(data)                                            (0x000001E0&((data)<<5))
+#define DVR_MIO_EN_byte_cnt_8to5_2c_src(data)                                        ((0x000001E0&(data))>>5)
+#define DVR_MIO_EN_intp_en_4_2c_shift                                                (4)
+#define DVR_MIO_EN_intp_en_4_2c_mask                                                 (0x00000010)
+#define DVR_MIO_EN_intp_en_4_2c(data)                                                (0x00000010&((data)<<4))
+#define DVR_MIO_EN_intp_en_4_2c_src(data)                                            ((0x00000010&(data))>>4)
+#define DVR_MIO_EN_error_en_3_2c_shift                                               (3)
+#define DVR_MIO_EN_error_en_3_2c_mask                                                (0x00000008)
+#define DVR_MIO_EN_error_en_3_2c(data)                                               (0x00000008&((data)<<3))
+#define DVR_MIO_EN_error_en_3_2c_src(data)                                           ((0x00000008&(data))>>3)
+#define DVR_MIO_EN_byte_en_2_2c_shift                                                (2)
+#define DVR_MIO_EN_byte_en_2_2c_mask                                                 (0x00000004)
+#define DVR_MIO_EN_byte_en_2_2c(data)                                                (0x00000004&((data)<<2))
+#define DVR_MIO_EN_byte_en_2_2c_src(data)                                            ((0x00000004&(data))>>2)
+#define DVR_MIO_EN_wrrd_en_1_2c_shift                                                (1)
+#define DVR_MIO_EN_wrrd_en_1_2c_mask                                                 (0x00000002)
+#define DVR_MIO_EN_wrrd_en_1_2c(data)                                                (0x00000002&((data)<<1))
+#define DVR_MIO_EN_wrrd_en_1_2c_src(data)                                            ((0x00000002&(data))>>1)
+#define DVR_MIO_EN_type_en_0_2c_shift                                                (0)
+#define DVR_MIO_EN_type_en_0_2c_mask                                                 (0x00000001)
+#define DVR_MIO_EN_type_en_0_2c(data)                                                (0x00000001&((data)<<0))
+#define DVR_MIO_EN_type_en_0_2c_src(data)                                            ((0x00000001&(data))>>0)
+
+
+#define DVR_MIO_ADDR                                                                 0x18017030
+#define DVR_MIO_ADDR_reg_addr                                                        "0xB8017030"
+#define DVR_MIO_ADDR_reg                                                             0xB8017030
+#define DVR_MIO_ADDR_inst_adr                                                        "0x000C"
+#define DVR_MIO_ADDR_inst                                                            0x000C
+#define DVR_MIO_ADDR_pci_addr_31to0_30_shift                                         (0)
+#define DVR_MIO_ADDR_pci_addr_31to0_30_mask                                          (0xFFFFFFFF)
+#define DVR_MIO_ADDR_pci_addr_31to0_30(data)                                         (0xFFFFFFFF&((data)<<0))
+#define DVR_MIO_ADDR_pci_addr_31to0_30_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_MIO_WDATA                                                                0x18017034
+#define DVR_MIO_WDATA_reg_addr                                                       "0xB8017034"
+#define DVR_MIO_WDATA_reg                                                            0xB8017034
+#define DVR_MIO_WDATA_inst_adr                                                       "0x000D"
+#define DVR_MIO_WDATA_inst                                                           0x000D
+#define DVR_MIO_WDATA_pci_wdata_31to0_34_shift                                       (0)
+#define DVR_MIO_WDATA_pci_wdata_31to0_34_mask                                        (0xFFFFFFFF)
+#define DVR_MIO_WDATA_pci_wdata_31to0_34(data)                                       (0xFFFFFFFF&((data)<<0))
+#define DVR_MIO_WDATA_pci_wdata_31to0_34_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_MIO_RDATA                                                                0x18017038
+#define DVR_MIO_RDATA_reg_addr                                                       "0xB8017038"
+#define DVR_MIO_RDATA_reg                                                            0xB8017038
+#define DVR_MIO_RDATA_inst_adr                                                       "0x000E"
+#define DVR_MIO_RDATA_inst                                                           0x000E
+#define DVR_MIO_RDATA_pci_rdata_31to0_38_shift                                       (0)
+#define DVR_MIO_RDATA_pci_rdata_31to0_38_mask                                        (0xFFFFFFFF)
+#define DVR_MIO_RDATA_pci_rdata_31to0_38(data)                                       (0xFFFFFFFF&((data)<<0))
+#define DVR_MIO_RDATA_pci_rdata_31to0_38_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_DMA_CT                                                                   0x1801703C
+#define DVR_DMA_CT_reg_addr                                                          "0xB801703C"
+#define DVR_DMA_CT_reg                                                               0xB801703C
+#define DVR_DMA_CT_inst_adr                                                          "0x000F"
+#define DVR_DMA_CT_inst                                                              0x000F
+#define DVR_DMA_CT_go_ct_0_3c_shift                                                  (0)
+#define DVR_DMA_CT_go_ct_0_3c_mask                                                   (0x00000001)
+#define DVR_DMA_CT_go_ct_0_3c(data)                                                  (0x00000001&((data)<<0))
+#define DVR_DMA_CT_go_ct_0_3c_src(data)                                              ((0x00000001&(data))>>0)
+
+
+#define DVR_DMA_ST                                                                   0x18017040
+#define DVR_DMA_ST_reg_addr                                                          "0xB8017040"
+#define DVR_DMA_ST_reg                                                               0xB8017040
+#define DVR_DMA_ST_inst_adr                                                          "0x0010"
+#define DVR_DMA_ST_inst                                                              0x0010
+#define DVR_DMA_ST_idle_st_5_40_shift                                                (5)
+#define DVR_DMA_ST_idle_st_5_40_mask                                                 (0x00000020)
+#define DVR_DMA_ST_idle_st_5_40(data)                                                (0x00000020&((data)<<5))
+#define DVR_DMA_ST_idle_st_5_40_src(data)                                            ((0x00000020&(data))>>5)
+#define DVR_DMA_ST_sin_dma_done_st_4_40_shift                                        (4)
+#define DVR_DMA_ST_sin_dma_done_st_4_40_mask                                         (0x00000010)
+#define DVR_DMA_ST_sin_dma_done_st_4_40(data)                                        (0x00000010&((data)<<4))
+#define DVR_DMA_ST_sin_dma_done_st_4_40_src(data)                                    ((0x00000010&(data))>>4)
+#define DVR_DMA_ST_desc_dma_done_st_3_40_shift                                       (3)
+#define DVR_DMA_ST_desc_dma_done_st_3_40_mask                                        (0x00000008)
+#define DVR_DMA_ST_desc_dma_done_st_3_40(data)                                       (0x00000008&((data)<<3))
+#define DVR_DMA_ST_desc_dma_done_st_3_40_src(data)                                   ((0x00000008&(data))>>3)
+#define DVR_DMA_ST_desc_empty_st_2_40_shift                                          (2)
+#define DVR_DMA_ST_desc_empty_st_2_40_mask                                           (0x00000004)
+#define DVR_DMA_ST_desc_empty_st_2_40(data)                                          (0x00000004&((data)<<2))
+#define DVR_DMA_ST_desc_empty_st_2_40_src(data)                                      ((0x00000004&(data))>>2)
+#define DVR_DMA_ST_pci_error_st_1_40_shift                                           (1)
+#define DVR_DMA_ST_pci_error_st_1_40_mask                                            (0x00000002)
+#define DVR_DMA_ST_pci_error_st_1_40(data)                                           (0x00000002&((data)<<1))
+#define DVR_DMA_ST_pci_error_st_1_40_src(data)                                       ((0x00000002&(data))>>1)
+#define DVR_DMA_ST_desc_error_st_0_40_shift                                          (0)
+#define DVR_DMA_ST_desc_error_st_0_40_mask                                           (0x00000001)
+#define DVR_DMA_ST_desc_error_st_0_40(data)                                          (0x00000001&((data)<<0))
+#define DVR_DMA_ST_desc_error_st_0_40_src(data)                                      ((0x00000001&(data))>>0)
+
+
+#define DVR_DMA_EN                                                                   0x18017044
+#define DVR_DMA_EN_reg_addr                                                          "0xB8017044"
+#define DVR_DMA_EN_reg                                                               0xB8017044
+#define DVR_DMA_EN_inst_adr                                                          "0x0011"
+#define DVR_DMA_EN_inst                                                              0x0011
+#define DVR_DMA_EN_intv_cnt_31to16_44_shift                                          (16)
+#define DVR_DMA_EN_intv_cnt_31to16_44_mask                                           (0xFFFF0000)
+#define DVR_DMA_EN_intv_cnt_31to16_44(data)                                          (0xFFFF0000&((data)<<16))
+#define DVR_DMA_EN_intv_cnt_31to16_44_src(data)                                      ((0xFFFF0000&(data))>>16)
+#define DVR_DMA_EN_intp_done_en_11_44_shift                                          (11)
+#define DVR_DMA_EN_intp_done_en_11_44_mask                                           (0x00000800)
+#define DVR_DMA_EN_intp_done_en_11_44(data)                                          (0x00000800&((data)<<11))
+#define DVR_DMA_EN_intp_done_en_11_44_src(data)                                      ((0x00000800&(data))>>11)
+#define DVR_DMA_EN_intp_empty_en_10_44_shift                                         (10)
+#define DVR_DMA_EN_intp_empty_en_10_44_mask                                          (0x00000400)
+#define DVR_DMA_EN_intp_empty_en_10_44(data)                                         (0x00000400&((data)<<10))
+#define DVR_DMA_EN_intp_empty_en_10_44_src(data)                                     ((0x00000400&(data))>>10)
+#define DVR_DMA_EN_intp_pci_error_en_9_44_shift                                      (9)
+#define DVR_DMA_EN_intp_pci_error_en_9_44_mask                                       (0x00000200)
+#define DVR_DMA_EN_intp_pci_error_en_9_44(data)                                      (0x00000200&((data)<<9))
+#define DVR_DMA_EN_intp_pci_error_en_9_44_src(data)                                  ((0x00000200&(data))>>9)
+#define DVR_DMA_EN_intp_desc_error_en_8_44_shift                                     (8)
+#define DVR_DMA_EN_intp_desc_error_en_8_44_mask                                      (0x00000100)
+#define DVR_DMA_EN_intp_desc_error_en_8_44(data)                                     (0x00000100&((data)<<8))
+#define DVR_DMA_EN_intp_desc_error_en_8_44_src(data)                                 ((0x00000100&(data))>>8)
+#define DVR_DMA_EN_intv_en_3_44_shift                                                (3)
+#define DVR_DMA_EN_intv_en_3_44_mask                                                 (0x00000008)
+#define DVR_DMA_EN_intv_en_3_44(data)                                                (0x00000008&((data)<<3))
+#define DVR_DMA_EN_intv_en_3_44_src(data)                                            ((0x00000008&(data))>>3)
+#define DVR_DMA_EN_go_en_2_44_shift                                                  (2)
+#define DVR_DMA_EN_go_en_2_44_mask                                                   (0x00000004)
+#define DVR_DMA_EN_go_en_2_44(data)                                                  (0x00000004&((data)<<2))
+#define DVR_DMA_EN_go_en_2_44_src(data)                                              ((0x00000004&(data))>>2)
+#define DVR_DMA_EN_mode_en_1_44_shift                                                (1)
+#define DVR_DMA_EN_mode_en_1_44_mask                                                 (0x00000002)
+#define DVR_DMA_EN_mode_en_1_44(data)                                                (0x00000002&((data)<<1))
+#define DVR_DMA_EN_mode_en_1_44_src(data)                                            ((0x00000002&(data))>>1)
+#define DVR_DMA_EN_desc_en_0_44_shift                                                (0)
+#define DVR_DMA_EN_desc_en_0_44_mask                                                 (0x00000001)
+#define DVR_DMA_EN_desc_en_0_44(data)                                                (0x00000001&((data)<<0))
+#define DVR_DMA_EN_desc_en_0_44_src(data)                                            ((0x00000001&(data))>>0)
+
+
+#define DVR_DMA_PCI                                                                  0x18017048
+#define DVR_DMA_PCI_reg_addr                                                         "0xB8017048"
+#define DVR_DMA_PCI_reg                                                              0xB8017048
+#define DVR_DMA_PCI_inst_adr                                                         "0x0012"
+#define DVR_DMA_PCI_inst                                                             0x0012
+#define DVR_DMA_PCI_addr_31to0_48_shift                                              (0)
+#define DVR_DMA_PCI_addr_31to0_48_mask                                               (0xFFFFFFFF)
+#define DVR_DMA_PCI_addr_31to0_48(data)                                              (0xFFFFFFFF&((data)<<0))
+#define DVR_DMA_PCI_addr_31to0_48_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_DMA_DDR                                                                  0x1801704C
+#define DVR_DMA_DDR_reg_addr                                                         "0xB801704C"
+#define DVR_DMA_DDR_reg                                                              0xB801704C
+#define DVR_DMA_DDR_inst_adr                                                         "0x0013"
+#define DVR_DMA_DDR_inst                                                             0x0013
+#define DVR_DMA_DDR_addr_27to0_4c_shift                                              (0)
+#define DVR_DMA_DDR_addr_27to0_4c_mask                                               (0x0FFFFFFF)
+#define DVR_DMA_DDR_addr_27to0_4c(data)                                              (0x0FFFFFFF&((data)<<0))
+#define DVR_DMA_DDR_addr_27to0_4c_src(data)                                          ((0x0FFFFFFF&(data))>>0)
+
+
+#define DVR_DMA_CNT                                                                  0x18017050
+#define DVR_DMA_CNT_reg_addr                                                         "0xB8017050"
+#define DVR_DMA_CNT_reg                                                              0xB8017050
+#define DVR_DMA_CNT_inst_adr                                                         "0x0014"
+#define DVR_DMA_CNT_inst                                                             0x0014
+#define DVR_DMA_CNT_byte_cnt_23to0_50_shift                                          (0)
+#define DVR_DMA_CNT_byte_cnt_23to0_50_mask                                           (0x00FFFFFF)
+#define DVR_DMA_CNT_byte_cnt_23to0_50(data)                                          (0x00FFFFFF&((data)<<0))
+#define DVR_DMA_CNT_byte_cnt_23to0_50_src(data)                                      ((0x00FFFFFF&(data))>>0)
+
+
+#define DVR_DMA_DES0                                                                 0x18017054
+#define DVR_DMA_DES0_reg_addr                                                        "0xB8017054"
+#define DVR_DMA_DES0_reg                                                             0xB8017054
+#define DVR_DMA_DES0_inst_adr                                                        "0x0015"
+#define DVR_DMA_DES0_inst                                                            0x0015
+#define DVR_DMA_DES0_base_ptr_27to0_54_shift                                         (0)
+#define DVR_DMA_DES0_base_ptr_27to0_54_mask                                          (0x0FFFFFFF)
+#define DVR_DMA_DES0_base_ptr_27to0_54(data)                                         (0x0FFFFFFF&((data)<<0))
+#define DVR_DMA_DES0_base_ptr_27to0_54_src(data)                                     ((0x0FFFFFFF&(data))>>0)
+
+
+#define DVR_DMA_DES1                                                                 0x18017058
+#define DVR_DMA_DES1_reg_addr                                                        "0xB8017058"
+#define DVR_DMA_DES1_reg                                                             0xB8017058
+#define DVR_DMA_DES1_inst_adr                                                        "0x0016"
+#define DVR_DMA_DES1_inst                                                            0x0016
+#define DVR_DMA_DES1_limit_ptr_27to0_58_shift                                        (0)
+#define DVR_DMA_DES1_limit_ptr_27to0_58_mask                                         (0x0FFFFFFF)
+#define DVR_DMA_DES1_limit_ptr_27to0_58(data)                                        (0x0FFFFFFF&((data)<<0))
+#define DVR_DMA_DES1_limit_ptr_27to0_58_src(data)                                    ((0x0FFFFFFF&(data))>>0)
+
+
+#define DVR_DMA_DES2                                                                 0x1801705C
+#define DVR_DMA_DES2_reg_addr                                                        "0xB801705C"
+#define DVR_DMA_DES2_reg                                                             0xB801705C
+#define DVR_DMA_DES2_inst_adr                                                        "0x0017"
+#define DVR_DMA_DES2_inst                                                            0x0017
+#define DVR_DMA_DES2_wr_ptr_27to0_5c_shift                                           (0)
+#define DVR_DMA_DES2_wr_ptr_27to0_5c_mask                                            (0x0FFFFFFF)
+#define DVR_DMA_DES2_wr_ptr_27to0_5c(data)                                           (0x0FFFFFFF&((data)<<0))
+#define DVR_DMA_DES2_wr_ptr_27to0_5c_src(data)                                       ((0x0FFFFFFF&(data))>>0)
+
+
+#define DVR_DMA_DES3                                                                 0x18017060
+#define DVR_DMA_DES3_reg_addr                                                        "0xB8017060"
+#define DVR_DMA_DES3_reg                                                             0xB8017060
+#define DVR_DMA_DES3_inst_adr                                                        "0x0018"
+#define DVR_DMA_DES3_inst                                                            0x0018
+#define DVR_DMA_DES3_rd_ptr_27to0_60_shift                                           (0)
+#define DVR_DMA_DES3_rd_ptr_27to0_60_mask                                            (0x0FFFFFFF)
+#define DVR_DMA_DES3_rd_ptr_27to0_60(data)                                           (0x0FFFFFFF&((data)<<0))
+#define DVR_DMA_DES3_rd_ptr_27to0_60_src(data)                                       ((0x0FFFFFFF&(data))>>0)
+
+
+#define DVR_SOFT_RST                                                                 0x18017064
+#define DVR_SOFT_RST_reg_addr                                                        "0xB8017064"
+#define DVR_SOFT_RST_reg                                                             0xB8017064
+#define DVR_SOFT_RST_inst_adr                                                        "0x0019"
+#define DVR_SOFT_RST_inst                                                            0x0019
+#define DVR_SOFT_RST_stop_ct_8_64_shift                                              (8)
+#define DVR_SOFT_RST_stop_ct_8_64_mask                                               (0x00000100)
+#define DVR_SOFT_RST_stop_ct_8_64(data)                                              (0x00000100&((data)<<8))
+#define DVR_SOFT_RST_stop_ct_8_64_src(data)                                          ((0x00000100&(data))>>8)
+#define DVR_SOFT_RST_idle_st_0_64_shift                                              (0)
+#define DVR_SOFT_RST_idle_st_0_64_mask                                               (0x00000001)
+#define DVR_SOFT_RST_idle_st_0_64(data)                                              (0x00000001&((data)<<0))
+#define DVR_SOFT_RST_idle_st_0_64_src(data)                                          ((0x00000001&(data))>>0)
+
+
+#define DVR_CLK_ST                                                                   0x18017068
+#define DVR_CLK_ST_reg_addr                                                          "0xB8017068"
+#define DVR_CLK_ST_reg                                                               0xB8017068
+#define DVR_CLK_ST_inst_adr                                                          "0x001A"
+#define DVR_CLK_ST_inst                                                              0x001A
+#define DVR_CLK_ST_pci_master_busy_st_7_68_shift                                     (7)
+#define DVR_CLK_ST_pci_master_busy_st_7_68_mask                                      (0x00000080)
+#define DVR_CLK_ST_pci_master_busy_st_7_68(data)                                     (0x00000080&((data)<<7))
+#define DVR_CLK_ST_pci_master_busy_st_7_68_src(data)                                 ((0x00000080&(data))>>7)
+#define DVR_CLK_ST_pci_slave_busy_st_6_68_shift                                      (6)
+#define DVR_CLK_ST_pci_slave_busy_st_6_68_mask                                       (0x00000040)
+#define DVR_CLK_ST_pci_slave_busy_st_6_68(data)                                      (0x00000040&((data)<<6))
+#define DVR_CLK_ST_pci_slave_busy_st_6_68_src(data)                                  ((0x00000040&(data))>>6)
+#define DVR_CLK_ST_mio_cfg_busy_st_5_68_shift                                        (5)
+#define DVR_CLK_ST_mio_cfg_busy_st_5_68_mask                                         (0x00000020)
+#define DVR_CLK_ST_mio_cfg_busy_st_5_68(data)                                        (0x00000020&((data)<<5))
+#define DVR_CLK_ST_mio_cfg_busy_st_5_68_src(data)                                    ((0x00000020&(data))>>5)
+#define DVR_CLK_ST_dma_busy_st_4_68_shift                                            (4)
+#define DVR_CLK_ST_dma_busy_st_4_68_mask                                             (0x00000010)
+#define DVR_CLK_ST_dma_busy_st_4_68(data)                                            (0x00000010&((data)<<4))
+#define DVR_CLK_ST_dma_busy_st_4_68_src(data)                                        ((0x00000010&(data))>>4)
+#define DVR_CLK_ST_pci_clk_lock_st_1_68_shift                                        (1)
+#define DVR_CLK_ST_pci_clk_lock_st_1_68_mask                                         (0x00000002)
+#define DVR_CLK_ST_pci_clk_lock_st_1_68(data)                                        (0x00000002&((data)<<1))
+#define DVR_CLK_ST_pci_clk_lock_st_1_68_src(data)                                    ((0x00000002&(data))>>1)
+#define DVR_CLK_ST_pci_clk_st_0_68_shift                                             (0)
+#define DVR_CLK_ST_pci_clk_st_0_68_mask                                              (0x00000001)
+#define DVR_CLK_ST_pci_clk_st_0_68(data)                                             (0x00000001&((data)<<0))
+#define DVR_CLK_ST_pci_clk_st_0_68_src(data)                                         ((0x00000001&(data))>>0)
+
+
+#define DVR_SPC_CT                                                                   0x1801706C
+#define DVR_SPC_CT_reg_addr                                                          "0xB801706C"
+#define DVR_SPC_CT_reg                                                               0xB801706C
+#define DVR_SPC_CT_inst_adr                                                          "0x001B"
+#define DVR_SPC_CT_inst                                                              0x001B
+#define DVR_SPC_CT_pci_int_req_8_6c_shift                                            (8)
+#define DVR_SPC_CT_pci_int_req_8_6c_mask                                             (0x00000100)
+#define DVR_SPC_CT_pci_int_req_8_6c(data)                                            (0x00000100&((data)<<8))
+#define DVR_SPC_CT_pci_int_req_8_6c_src(data)                                        ((0x00000100&(data))>>8)
+#define DVR_SPC_CT_clk_run_req_4_6c_shift                                            (4)
+#define DVR_SPC_CT_clk_run_req_4_6c_mask                                             (0x00000010)
+#define DVR_SPC_CT_clk_run_req_4_6c(data)                                            (0x00000010&((data)<<4))
+#define DVR_SPC_CT_clk_run_req_4_6c_src(data)                                        ((0x00000010&(data))>>4)
+#define DVR_SPC_CT_pci_clk_lock_en_0_6c_shift                                        (0)
+#define DVR_SPC_CT_pci_clk_lock_en_0_6c_mask                                         (0x00000001)
+#define DVR_SPC_CT_pci_clk_lock_en_0_6c(data)                                        (0x00000001&((data)<<0))
+#define DVR_SPC_CT_pci_clk_lock_en_0_6c_src(data)                                    ((0x00000001&(data))>>0)
+
+
+#define DVR_SPC_ST                                                                   0x18017070
+#define DVR_SPC_ST_reg_addr                                                          "0xB8017070"
+#define DVR_SPC_ST_reg                                                               0xB8017070
+#define DVR_SPC_ST_inst_adr                                                          "0x001C"
+#define DVR_SPC_ST_inst                                                              0x001C
+#define DVR_SPC_ST_pci_int_st_16_70_shift                                            (16)
+#define DVR_SPC_ST_pci_int_st_16_70_mask                                             (0x00010000)
+#define DVR_SPC_ST_pci_int_st_16_70(data)                                            (0x00010000&((data)<<16))
+#define DVR_SPC_ST_pci_int_st_16_70_src(data)                                        ((0x00010000&(data))>>16)
+#define DVR_SPC_ST_clk_run_st_0_70_shift                                             (0)
+#define DVR_SPC_ST_clk_run_st_0_70_mask                                              (0x00000001)
+#define DVR_SPC_ST_clk_run_st_0_70(data)                                             (0x00000001&((data)<<0))
+#define DVR_SPC_ST_clk_run_st_0_70_src(data)                                         ((0x00000001&(data))>>0)
+
+
+#define DVR_DBG                                                                      0x18017074
+#define DVR_DBG_reg_addr                                                             "0xB8017074"
+#define DVR_DBG_reg                                                                  0xB8017074
+#define DVR_DBG_inst_adr                                                             "0x001D"
+#define DVR_DBG_inst                                                                 0x001D
+#define DVR_DBG_dbg_sel1_shift                                                       (7)
+#define DVR_DBG_dbg_sel1_mask                                                        (0x00001F80)
+#define DVR_DBG_dbg_sel1(data)                                                       (0x00001F80&((data)<<7))
+#define DVR_DBG_dbg_sel1_src(data)                                                   ((0x00001F80&(data))>>7)
+#define DVR_DBG_dbg_sel0_shift                                                       (1)
+#define DVR_DBG_dbg_sel0_mask                                                        (0x0000007E)
+#define DVR_DBG_dbg_sel0(data)                                                       (0x0000007E&((data)<<1))
+#define DVR_DBG_dbg_sel0_src(data)                                                   ((0x0000007E&(data))>>1)
+#define DVR_DBG_dbg_en_shift                                                         (0)
+#define DVR_DBG_dbg_en_mask                                                          (0x00000001)
+#define DVR_DBG_dbg_en(data)                                                         (0x00000001&((data)<<0))
+#define DVR_DBG_dbg_en_src(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define DVR_DIR_ST                                                                   0x18017078
+#define DVR_DIR_ST_reg_addr                                                          "0xB8017078"
+#define DVR_DIR_ST_reg                                                               0xB8017078
+#define DVR_DIR_ST_inst_adr                                                          "0x001E"
+#define DVR_DIR_ST_inst                                                              0x001E
+#define DVR_DIR_ST_rerror_st_1_78_shift                                              (1)
+#define DVR_DIR_ST_rerror_st_1_78_mask                                               (0x00000002)
+#define DVR_DIR_ST_rerror_st_1_78(data)                                              (0x00000002&((data)<<1))
+#define DVR_DIR_ST_rerror_st_1_78_src(data)                                          ((0x00000002&(data))>>1)
+#define DVR_DIR_ST_werror_st_0_78_shift                                              (0)
+#define DVR_DIR_ST_werror_st_0_78_mask                                               (0x00000001)
+#define DVR_DIR_ST_werror_st_0_78(data)                                              (0x00000001&((data)<<0))
+#define DVR_DIR_ST_werror_st_0_78_src(data)                                          ((0x00000001&(data))>>0)
+
+
+#define DVR_DIR_EN                                                                   0x1801707C
+#define DVR_DIR_EN_reg_addr                                                          "0xB801707C"
+#define DVR_DIR_EN_reg                                                               0xB801707C
+#define DVR_DIR_EN_inst_adr                                                          "0x001F"
+#define DVR_DIR_EN_inst                                                              0x001F
+#define DVR_DIR_EN_error_ack_read_1_7c_shift                                         (1)
+#define DVR_DIR_EN_error_ack_read_1_7c_mask                                          (0x00000002)
+#define DVR_DIR_EN_error_ack_read_1_7c(data)                                         (0x00000002&((data)<<1))
+#define DVR_DIR_EN_error_ack_read_1_7c_src(data)                                     ((0x00000002&(data))>>1)
+#define DVR_DIR_EN_intp_en_0_7c_shift                                                (0)
+#define DVR_DIR_EN_intp_en_0_7c_mask                                                 (0x00000001)
+#define DVR_DIR_EN_intp_en_0_7c(data)                                                (0x00000001&((data)<<0))
+#define DVR_DIR_EN_intp_en_0_7c_src(data)                                            ((0x00000001&(data))>>0)
+
+
+#define DVR_DEV_ST                                                                   0x18017080
+#define DVR_DEV_ST_reg_addr                                                          "0xB8017080"
+#define DVR_DEV_ST_reg                                                               0xB8017080
+#define DVR_DEV_ST_inst_adr                                                          "0x0020"
+#define DVR_DEV_ST_inst                                                              0x0020
+#define DVR_DEV_ST_dev_ddr_done_st_0_80_shift                                        (0)
+#define DVR_DEV_ST_dev_ddr_done_st_0_80_mask                                         (0x00000001)
+#define DVR_DEV_ST_dev_ddr_done_st_0_80(data)                                        (0x00000001&((data)<<0))
+#define DVR_DEV_ST_dev_ddr_done_st_0_80_src(data)                                    ((0x00000001&(data))>>0)
+
+
+#define DVR_DEV_CT                                                                   0x18017084
+#define DVR_DEV_CT_reg_addr                                                          "0xB8017084"
+#define DVR_DEV_CT_reg                                                               0xB8017084
+#define DVR_DEV_CT_inst_adr                                                          "0x0021"
+#define DVR_DEV_CT_inst                                                              0x0021
+#define DVR_DEV_CT_dev_start_0_84_shift                                              (0)
+#define DVR_DEV_CT_dev_start_0_84_mask                                               (0x00000001)
+#define DVR_DEV_CT_dev_start_0_84(data)                                              (0x00000001&((data)<<0))
+#define DVR_DEV_CT_dev_start_0_84_src(data)                                          ((0x00000001&(data))>>0)
+
+
+#define DVR_DEV_DDR                                                                  0x18017088
+#define DVR_DEV_DDR_reg_addr                                                         "0xB8017088"
+#define DVR_DEV_DDR_reg                                                              0xB8017088
+#define DVR_DEV_DDR_inst_adr                                                         "0x0022"
+#define DVR_DEV_DDR_inst                                                             0x0022
+#define DVR_DEV_DDR_dev_ddr_addr_31to0_88_shift                                      (0)
+#define DVR_DEV_DDR_dev_ddr_addr_31to0_88_mask                                       (0xFFFFFFFF)
+#define DVR_DEV_DDR_dev_ddr_addr_31to0_88(data)                                      (0xFFFFFFFF&((data)<<0))
+#define DVR_DEV_DDR_dev_ddr_addr_31to0_88_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_DEV_PCI                                                                  0x1801708C
+#define DVR_DEV_PCI_reg_addr                                                         "0xB801708C"
+#define DVR_DEV_PCI_reg                                                              0xB801708C
+#define DVR_DEV_PCI_inst_adr                                                         "0x0023"
+#define DVR_DEV_PCI_inst                                                             0x0023
+#define DVR_DEV_PCI_dev_pci_addr_31to0_8c_shift                                      (0)
+#define DVR_DEV_PCI_dev_pci_addr_31to0_8c_mask                                       (0xFFFFFFFF)
+#define DVR_DEV_PCI_dev_pci_addr_31to0_8c(data)                                      (0xFFFFFFFF&((data)<<0))
+#define DVR_DEV_PCI_dev_pci_addr_31to0_8c_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_DEV_CNT                                                                  0x18017090
+#define DVR_DEV_CNT_reg_addr                                                         "0xB8017090"
+#define DVR_DEV_CNT_reg                                                              0xB8017090
+#define DVR_DEV_CNT_inst_adr                                                         "0x0024"
+#define DVR_DEV_CNT_inst                                                             0x0024
+#define DVR_DEV_CNT_dev_ddr_cnt_31to0_90_shift                                       (0)
+#define DVR_DEV_CNT_dev_ddr_cnt_31to0_90_mask                                        (0xFFFFFFFF)
+#define DVR_DEV_CNT_dev_ddr_cnt_31to0_90(data)                                       (0xFFFFFFFF&((data)<<0))
+#define DVR_DEV_CNT_dev_ddr_cnt_31to0_90_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_TMP0_REG_0                                                               0x18017094
+#define DVR_TMP0_REG_1                                                               0x18017098
+#define DVR_TMP0_REG_2                                                               0x1801709C
+#define DVR_TMP0_REG_0_reg_addr                                                      "0xB8017094"
+#define DVR_TMP0_REG_1_reg_addr                                                      "0xB8017098"
+#define DVR_TMP0_REG_2_reg_addr                                                      "0xB801709C"
+#define DVR_TMP0_REG_0_reg                                                           0xB8017094
+#define DVR_TMP0_REG_1_reg                                                           0xB8017098
+#define DVR_TMP0_REG_2_reg                                                           0xB801709C
+#define DVR_TMP0_REG_0_inst_adr                                                      "0x0025"
+#define DVR_TMP0_REG_1_inst_adr                                                      "0x0026"
+#define DVR_TMP0_REG_2_inst_adr                                                      "0x0027"
+#define DVR_TMP0_REG_0_inst                                                          0x0025
+#define DVR_TMP0_REG_1_inst                                                          0x0026
+#define DVR_TMP0_REG_2_inst                                                          0x0027
+#define DVR_TMP0_REG_test_reg_shift                                                  (0)
+#define DVR_TMP0_REG_test_reg_mask                                                   (0xFFFFFFFF)
+#define DVR_TMP0_REG_test_reg(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define DVR_TMP0_REG_test_reg_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_TMP1_REG_0                                                               0x180170A0
+#define DVR_TMP1_REG_1                                                               0x180170A4
+#define DVR_TMP1_REG_2                                                               0x180170A8
+#define DVR_TMP1_REG_0_reg_addr                                                      "0xB80170A0"
+#define DVR_TMP1_REG_1_reg_addr                                                      "0xB80170A4"
+#define DVR_TMP1_REG_2_reg_addr                                                      "0xB80170A8"
+#define DVR_TMP1_REG_0_reg                                                           0xB80170A0
+#define DVR_TMP1_REG_1_reg                                                           0xB80170A4
+#define DVR_TMP1_REG_2_reg                                                           0xB80170A8
+#define DVR_TMP1_REG_0_inst_adr                                                      "0x0028"
+#define DVR_TMP1_REG_1_inst_adr                                                      "0x0029"
+#define DVR_TMP1_REG_2_inst_adr                                                      "0x002A"
+#define DVR_TMP1_REG_0_inst                                                          0x0028
+#define DVR_TMP1_REG_1_inst                                                          0x0029
+#define DVR_TMP1_REG_2_inst                                                          0x002A
+#define DVR_TMP1_REG_test_reg_shift                                                  (0)
+#define DVR_TMP1_REG_test_reg_mask                                                   (0xFFFFFFFF)
+#define DVR_TMP1_REG_test_reg(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define DVR_TMP1_REG_test_reg_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define DVR_SCTCH                                                                    0x180170AC
+#define DVR_SCTCH_reg_addr                                                           "0xB80170AC"
+#define DVR_SCTCH_reg                                                                0xB80170AC
+#define DVR_SCTCH_inst_adr                                                           "0x002B"
+#define DVR_SCTCH_inst                                                               0x002B
+#define DVR_SCTCH_reg1_shift                                                         (16)
+#define DVR_SCTCH_reg1_mask                                                          (0xFFFF0000)
+#define DVR_SCTCH_reg1(data)                                                         (0xFFFF0000&((data)<<16))
+#define DVR_SCTCH_reg1_src(data)                                                     ((0xFFFF0000&(data))>>16)
+#define DVR_SCTCH_reg0_shift                                                         (0)
+#define DVR_SCTCH_reg0_mask                                                          (0x0000FFFF)
+#define DVR_SCTCH_reg0(data)                                                         (0x0000FFFF&((data)<<0))
+#define DVR_SCTCH_reg0_src(data)                                                     ((0x0000FFFF&(data))>>0)
+
+
+#define PCI_SCTCH                                                                    0x18017100
+#define PCI_SCTCH_reg_addr                                                           "0xB8017100"
+#define PCI_SCTCH_reg                                                                0xB8017100
+#define PCI_SCTCH_inst_adr                                                           "0x0040"
+#define PCI_SCTCH_inst                                                               0x0040
+#define PCI_SCTCH_reg1_16to31_00_shift                                               (16)
+#define PCI_SCTCH_reg1_16to31_00_mask                                                (0xFFFF0000)
+#define PCI_SCTCH_reg1_16to31_00(data)                                               (0xFFFF0000&((data)<<16))
+#define PCI_SCTCH_reg1_16to31_00_src(data)                                           ((0xFFFF0000&(data))>>16)
+#define PCI_SCTCH_reg0_0to15_00_shift                                                (0)
+#define PCI_SCTCH_reg0_0to15_00_mask                                                 (0x0000FFFF)
+#define PCI_SCTCH_reg0_0to15_00(data)                                                (0x0000FFFF&((data)<<0))
+#define PCI_SCTCH_reg0_0to15_00_src(data)                                            ((0x0000FFFF&(data))>>0)
+
+
+#define PCI_GNR_EN1                                                                  0x18017104
+#define PCI_GNR_EN1_reg_addr                                                         "0xB8017104"
+#define PCI_GNR_EN1_reg                                                              0xB8017104
+#define PCI_GNR_EN1_inst_adr                                                         "0x0041"
+#define PCI_GNR_EN1_inst                                                             0x0041
+#define PCI_GNR_EN1_retry_cnt_0to15_04_shift                                         (16)
+#define PCI_GNR_EN1_retry_cnt_0to15_04_mask                                          (0xFFFF0000)
+#define PCI_GNR_EN1_retry_cnt_0to15_04(data)                                         (0xFFFF0000&((data)<<16))
+#define PCI_GNR_EN1_retry_cnt_0to15_04_src(data)                                     ((0xFFFF0000&(data))>>16)
+#define PCI_GNR_EN1_retry_cnt_en_0_04_shift                                          (0)
+#define PCI_GNR_EN1_retry_cnt_en_0_04_mask                                           (0x00000001)
+#define PCI_GNR_EN1_retry_cnt_en_0_04(data)                                          (0x00000001&((data)<<0))
+#define PCI_GNR_EN1_retry_cnt_en_0_04_src(data)                                      ((0x00000001&(data))>>0)
+
+
+#define PCI_GNR_EN2                                                                  0x18017108
+#define PCI_GNR_EN2_reg_addr                                                         "0xB8017108"
+#define PCI_GNR_EN2_reg                                                              0xB8017108
+#define PCI_GNR_EN2_inst_adr                                                         "0x0042"
+#define PCI_GNR_EN2_inst                                                             0x0042
+#define PCI_GNR_EN2_master_rd_burst_25to26_08_shift                                  (25)
+#define PCI_GNR_EN2_master_rd_burst_25to26_08_mask                                   (0x06000000)
+#define PCI_GNR_EN2_master_rd_burst_25to26_08(data)                                  (0x06000000&((data)<<25))
+#define PCI_GNR_EN2_master_rd_burst_25to26_08_src(data)                              ((0x06000000&(data))>>25)
+#define PCI_GNR_EN2_master_wr_inv_24_08_shift                                        (24)
+#define PCI_GNR_EN2_master_wr_inv_24_08_mask                                         (0x01000000)
+#define PCI_GNR_EN2_master_wr_inv_24_08(data)                                        (0x01000000&((data)<<24))
+#define PCI_GNR_EN2_master_wr_inv_24_08_src(data)                                    ((0x01000000&(data))>>24)
+#define PCI_GNR_EN2_spc_cyc_en_22_08_shift                                           (22)
+#define PCI_GNR_EN2_spc_cyc_en_22_08_mask                                            (0x00400000)
+#define PCI_GNR_EN2_spc_cyc_en_22_08(data)                                           (0x00400000&((data)<<22))
+#define PCI_GNR_EN2_spc_cyc_en_22_08_src(data)                                       ((0x00400000&(data))>>22)
+#define PCI_GNR_EN2_retry_int_en_21_08_shift                                         (21)
+#define PCI_GNR_EN2_retry_int_en_21_08_mask                                          (0x00200000)
+#define PCI_GNR_EN2_retry_int_en_21_08(data)                                         (0x00200000&((data)<<21))
+#define PCI_GNR_EN2_retry_int_en_21_08_src(data)                                     ((0x00200000&(data))>>21)
+#define PCI_GNR_EN2_mon_int_en_20_08_shift                                           (20)
+#define PCI_GNR_EN2_mon_int_en_20_08_mask                                            (0x00100000)
+#define PCI_GNR_EN2_mon_int_en_20_08(data)                                           (0x00100000&((data)<<20))
+#define PCI_GNR_EN2_mon_int_en_20_08_src(data)                                       ((0x00100000&(data))>>20)
+#define PCI_GNR_EN2_pme_int_en_19_08_shift                                           (19)
+#define PCI_GNR_EN2_pme_int_en_19_08_mask                                            (0x00080000)
+#define PCI_GNR_EN2_pme_int_en_19_08(data)                                           (0x00080000&((data)<<19))
+#define PCI_GNR_EN2_pme_int_en_19_08_src(data)                                       ((0x00080000&(data))>>19)
+#define PCI_GNR_EN2_inta_int_en_18_08_shift                                          (18)
+#define PCI_GNR_EN2_inta_int_en_18_08_mask                                           (0x00040000)
+#define PCI_GNR_EN2_inta_int_en_18_08(data)                                          (0x00040000&((data)<<18))
+#define PCI_GNR_EN2_inta_int_en_18_08_src(data)                                      ((0x00040000&(data))>>18)
+#define PCI_GNR_EN2_serr_int_en_17_08_shift                                          (17)
+#define PCI_GNR_EN2_serr_int_en_17_08_mask                                           (0x00020000)
+#define PCI_GNR_EN2_serr_int_en_17_08(data)                                          (0x00020000&((data)<<17))
+#define PCI_GNR_EN2_serr_int_en_17_08_src(data)                                      ((0x00020000&(data))>>17)
+#define PCI_GNR_EN2_perr_int_en_16_08_shift                                          (16)
+#define PCI_GNR_EN2_perr_int_en_16_08_mask                                           (0x00010000)
+#define PCI_GNR_EN2_perr_int_en_16_08(data)                                          (0x00010000&((data)<<16))
+#define PCI_GNR_EN2_perr_int_en_16_08_src(data)                                      ((0x00010000&(data))>>16)
+#define PCI_GNR_EN2_lat_timer_en_14_08_shift                                         (14)
+#define PCI_GNR_EN2_lat_timer_en_14_08_mask                                          (0x00004000)
+#define PCI_GNR_EN2_lat_timer_en_14_08(data)                                         (0x00004000&((data)<<14))
+#define PCI_GNR_EN2_lat_timer_en_14_08_src(data)                                     ((0x00004000&(data))>>14)
+#define PCI_GNR_EN2_pci_mon_en_13_08_shift                                           (13)
+#define PCI_GNR_EN2_pci_mon_en_13_08_mask                                            (0x00002000)
+#define PCI_GNR_EN2_pci_mon_en_13_08(data)                                           (0x00002000&((data)<<13))
+#define PCI_GNR_EN2_pci_mon_en_13_08_src(data)                                       ((0x00002000&(data))>>13)
+#define PCI_GNR_EN2_park_dev_12o11_08_shift                                          (11)
+#define PCI_GNR_EN2_park_dev_12o11_08_mask                                           (0x00001800)
+#define PCI_GNR_EN2_park_dev_12o11_08(data)                                          (0x00001800&((data)<<11))
+#define PCI_GNR_EN2_park_dev_12o11_08_src(data)                                      ((0x00001800&(data))>>11)
+#define PCI_GNR_EN2_bus_park_en_10_08_shift                                          (10)
+#define PCI_GNR_EN2_bus_park_en_10_08_mask                                           (0x00000400)
+#define PCI_GNR_EN2_bus_park_en_10_08(data)                                          (0x00000400&((data)<<10))
+#define PCI_GNR_EN2_bus_park_en_10_08_src(data)                                      ((0x00000400&(data))>>10)
+#define PCI_GNR_EN2_slave_b2b_en_9_08_shift                                          (9)
+#define PCI_GNR_EN2_slave_b2b_en_9_08_mask                                           (0x00000200)
+#define PCI_GNR_EN2_slave_b2b_en_9_08(data)                                          (0x00000200&((data)<<9))
+#define PCI_GNR_EN2_slave_b2b_en_9_08_src(data)                                      ((0x00000200&(data))>>9)
+#define PCI_GNR_EN2_66mhz_en_8_08_shift                                              (8)
+#define PCI_GNR_EN2_66mhz_en_8_08_mask                                               (0x00000100)
+#define PCI_GNR_EN2_66mhz_en_8_08(data)                                              (0x00000100&((data)<<8))
+#define PCI_GNR_EN2_66mhz_en_8_08_src(data)                                          ((0x00000100&(data))>>8)
+#define PCI_GNR_EN2_xbus_ba_en_6_08_shift                                            (6)
+#define PCI_GNR_EN2_xbus_ba_en_6_08_mask                                             (0x00000040)
+#define PCI_GNR_EN2_xbus_ba_en_6_08(data)                                            (0x00000040&((data)<<6))
+#define PCI_GNR_EN2_xbus_ba_en_6_08_src(data)                                        ((0x00000040&(data))>>6)
+#define PCI_GNR_EN2_sbus_tran_en_5_08_shift                                          (5)
+#define PCI_GNR_EN2_sbus_tran_en_5_08_mask                                           (0x00000020)
+#define PCI_GNR_EN2_sbus_tran_en_5_08(data)                                          (0x00000020&((data)<<5))
+#define PCI_GNR_EN2_sbus_tran_en_5_08_src(data)                                      ((0x00000020&(data))>>5)
+#define PCI_GNR_EN2_sbus_ba_en_4_08_shift                                            (4)
+#define PCI_GNR_EN2_sbus_ba_en_4_08_mask                                             (0x00000010)
+#define PCI_GNR_EN2_sbus_ba_en_4_08(data)                                            (0x00000010&((data)<<4))
+#define PCI_GNR_EN2_sbus_ba_en_4_08_src(data)                                        ((0x00000010&(data))>>4)
+#define PCI_GNR_EN2_dbus_tran_en_3_08_shift                                          (3)
+#define PCI_GNR_EN2_dbus_tran_en_3_08_mask                                           (0x00000008)
+#define PCI_GNR_EN2_dbus_tran_en_3_08(data)                                          (0x00000008&((data)<<3))
+#define PCI_GNR_EN2_dbus_tran_en_3_08_src(data)                                      ((0x00000008&(data))>>3)
+#define PCI_GNR_EN2_dbus_ba_en_2_08_shift                                            (2)
+#define PCI_GNR_EN2_dbus_ba_en_2_08_mask                                             (0x00000004)
+#define PCI_GNR_EN2_dbus_ba_en_2_08(data)                                            (0x00000004&((data)<<2))
+#define PCI_GNR_EN2_dbus_ba_en_2_08_src(data)                                        ((0x00000004&(data))>>2)
+#define PCI_GNR_EN2_rbus_tran_en_1_08_shift                                          (1)
+#define PCI_GNR_EN2_rbus_tran_en_1_08_mask                                           (0x00000002)
+#define PCI_GNR_EN2_rbus_tran_en_1_08(data)                                          (0x00000002&((data)<<1))
+#define PCI_GNR_EN2_rbus_tran_en_1_08_src(data)                                      ((0x00000002&(data))>>1)
+#define PCI_GNR_EN2_rbus_ba_en_0_08_shift                                            (0)
+#define PCI_GNR_EN2_rbus_ba_en_0_08_mask                                             (0x00000001)
+#define PCI_GNR_EN2_rbus_ba_en_0_08(data)                                            (0x00000001&((data)<<0))
+#define PCI_GNR_EN2_rbus_ba_en_0_08_src(data)                                        ((0x00000001&(data))>>0)
+
+
+#define PCI_GNR_ST                                                                   0x1801710C
+#define PCI_GNR_ST_reg_addr                                                          "0xB801710C"
+#define PCI_GNR_ST_reg                                                               0xB801710C
+#define PCI_GNR_ST_inst_adr                                                          "0x0043"
+#define PCI_GNR_ST_inst                                                              0x0043
+#define PCI_GNR_ST_spc_cyc_msn_17to16_0c_shift                                       (16)
+#define PCI_GNR_ST_spc_cyc_msn_17to16_0c_mask                                        (0x00030000)
+#define PCI_GNR_ST_spc_cyc_msn_17to16_0c(data)                                       (0x00030000&((data)<<16))
+#define PCI_GNR_ST_spc_cyc_msn_17to16_0c_src(data)                                   ((0x00030000&(data))>>16)
+#define PCI_GNR_ST_spc_cyc_erro_6_0c_shift                                           (6)
+#define PCI_GNR_ST_spc_cyc_erro_6_0c_mask                                            (0x00000040)
+#define PCI_GNR_ST_spc_cyc_erro_6_0c(data)                                           (0x00000040&((data)<<6))
+#define PCI_GNR_ST_spc_cyc_erro_6_0c_src(data)                                       ((0x00000040&(data))>>6)
+#define PCI_GNR_ST_retry_error_5_0c_shift                                            (5)
+#define PCI_GNR_ST_retry_error_5_0c_mask                                             (0x00000020)
+#define PCI_GNR_ST_retry_error_5_0c(data)                                            (0x00000020&((data)<<5))
+#define PCI_GNR_ST_retry_error_5_0c_src(data)                                        ((0x00000020&(data))>>5)
+#define PCI_GNR_ST_mon_error_4_0c_shift                                              (4)
+#define PCI_GNR_ST_mon_error_4_0c_mask                                               (0x00000010)
+#define PCI_GNR_ST_mon_error_4_0c(data)                                              (0x00000010&((data)<<4))
+#define PCI_GNR_ST_mon_error_4_0c_src(data)                                          ((0x00000010&(data))>>4)
+#define PCI_GNR_ST_serr_error_3_0c_shift                                             (3)
+#define PCI_GNR_ST_serr_error_3_0c_mask                                              (0x00000008)
+#define PCI_GNR_ST_serr_error_3_0c(data)                                             (0x00000008&((data)<<3))
+#define PCI_GNR_ST_serr_error_3_0c_src(data)                                         ((0x00000008&(data))>>3)
+#define PCI_GNR_ST_perr_error_2_0c_shift                                             (2)
+#define PCI_GNR_ST_perr_error_2_0c_mask                                              (0x00000004)
+#define PCI_GNR_ST_perr_error_2_0c(data)                                             (0x00000004&((data)<<2))
+#define PCI_GNR_ST_perr_error_2_0c_src(data)                                         ((0x00000004&(data))>>2)
+#define PCI_GNR_ST_slave_error_1_0c_shift                                            (1)
+#define PCI_GNR_ST_slave_error_1_0c_mask                                             (0x00000002)
+#define PCI_GNR_ST_slave_error_1_0c(data)                                            (0x00000002&((data)<<1))
+#define PCI_GNR_ST_slave_error_1_0c_src(data)                                        ((0x00000002&(data))>>1)
+#define PCI_GNR_ST_master_error_0_0c_shift                                           (0)
+#define PCI_GNR_ST_master_error_0_0c_mask                                            (0x00000001)
+#define PCI_GNR_ST_master_error_0_0c(data)                                           (0x00000001&((data)<<0))
+#define PCI_GNR_ST_master_error_0_0c_src(data)                                       ((0x00000001&(data))>>0)
+
+
+#define PCI_GNR_INT                                                                  0x18017110
+#define PCI_GNR_INT_reg_addr                                                         "0xB8017110"
+#define PCI_GNR_INT_reg                                                              0xB8017110
+#define PCI_GNR_INT_inst_adr                                                         "0x0044"
+#define PCI_GNR_INT_inst                                                             0x0044
+#define PCI_GNR_INT_intp_spc_cyc_6_10_shift                                          (6)
+#define PCI_GNR_INT_intp_spc_cyc_6_10_mask                                           (0x00000040)
+#define PCI_GNR_INT_intp_spc_cyc_6_10(data)                                          (0x00000040&((data)<<6))
+#define PCI_GNR_INT_intp_spc_cyc_6_10_src(data)                                      ((0x00000040&(data))>>6)
+#define PCI_GNR_INT_intp_retry_5_10_shift                                            (5)
+#define PCI_GNR_INT_intp_retry_5_10_mask                                             (0x00000020)
+#define PCI_GNR_INT_intp_retry_5_10(data)                                            (0x00000020&((data)<<5))
+#define PCI_GNR_INT_intp_retry_5_10_src(data)                                        ((0x00000020&(data))>>5)
+#define PCI_GNR_INT_intp_mon_4_10_shift                                              (4)
+#define PCI_GNR_INT_intp_mon_4_10_mask                                               (0x00000010)
+#define PCI_GNR_INT_intp_mon_4_10(data)                                              (0x00000010&((data)<<4))
+#define PCI_GNR_INT_intp_mon_4_10_src(data)                                          ((0x00000010&(data))>>4)
+#define PCI_GNR_INT_intp_pme_3_10_shift                                              (3)
+#define PCI_GNR_INT_intp_pme_3_10_mask                                               (0x00000008)
+#define PCI_GNR_INT_intp_pme_3_10(data)                                              (0x00000008&((data)<<3))
+#define PCI_GNR_INT_intp_pme_3_10_src(data)                                          ((0x00000008&(data))>>3)
+#define PCI_GNR_INT_intp_genr_2_10_shift                                             (2)
+#define PCI_GNR_INT_intp_genr_2_10_mask                                              (0x00000004)
+#define PCI_GNR_INT_intp_genr_2_10(data)                                             (0x00000004&((data)<<2))
+#define PCI_GNR_INT_intp_genr_2_10_src(data)                                         ((0x00000004&(data))>>2)
+#define PCI_GNR_INT_intp_serr_1_10_shift                                             (1)
+#define PCI_GNR_INT_intp_serr_1_10_mask                                              (0x00000002)
+#define PCI_GNR_INT_intp_serr_1_10(data)                                             (0x00000002&((data)<<1))
+#define PCI_GNR_INT_intp_serr_1_10_src(data)                                         ((0x00000002&(data))>>1)
+#define PCI_GNR_INT_intp_perr_0_10_shift                                             (0)
+#define PCI_GNR_INT_intp_perr_0_10_mask                                              (0x00000001)
+#define PCI_GNR_INT_intp_perr_0_10(data)                                             (0x00000001&((data)<<0))
+#define PCI_GNR_INT_intp_perr_0_10_src(data)                                         ((0x00000001&(data))>>0)
+
+
+#define PCI_MASK0                                                                    0x18017114
+#define PCI_MASK0_reg_addr                                                           "0xB8017114"
+#define PCI_MASK0_reg                                                                0xB8017114
+#define PCI_MASK0_inst_adr                                                           "0x0045"
+#define PCI_MASK0_inst                                                               0x0045
+#define PCI_MASK0_rbus_mask_31to28_14_shift                                          (28)
+#define PCI_MASK0_rbus_mask_31to28_14_mask                                           (0xF0000000)
+#define PCI_MASK0_rbus_mask_31to28_14(data)                                          (0xF0000000&((data)<<28))
+#define PCI_MASK0_rbus_mask_31to28_14_src(data)                                      ((0xF0000000&(data))>>28)
+#define PCI_MASK0_rbus_mask_27to8_14_shift                                           (8)
+#define PCI_MASK0_rbus_mask_27to8_14_mask                                            (0x0FFFFF00)
+#define PCI_MASK0_rbus_mask_27to8_14(data)                                           (0x0FFFFF00&((data)<<8))
+#define PCI_MASK0_rbus_mask_27to8_14_src(data)                                       ((0x0FFFFF00&(data))>>8)
+
+
+#define PCI_TRANSL0                                                                  0x18017118
+#define PCI_TRANSL0_reg_addr                                                         "0xB8017118"
+#define PCI_TRANSL0_reg                                                              0xB8017118
+#define PCI_TRANSL0_inst_adr                                                         "0x0046"
+#define PCI_TRANSL0_inst                                                             0x0046
+#define PCI_TRANSL0_rbus_transl_31to8_18_shift                                       (8)
+#define PCI_TRANSL0_rbus_transl_31to8_18_mask                                        (0xFFFFFF00)
+#define PCI_TRANSL0_rbus_transl_31to8_18(data)                                       (0xFFFFFF00&((data)<<8))
+#define PCI_TRANSL0_rbus_transl_31to8_18_src(data)                                   ((0xFFFFFF00&(data))>>8)
+
+
+#define PCI_MASK1                                                                    0x1801711C
+#define PCI_MASK1_reg_addr                                                           "0xB801711C"
+#define PCI_MASK1_reg                                                                0xB801711C
+#define PCI_MASK1_inst_adr                                                           "0x0047"
+#define PCI_MASK1_inst                                                               0x0047
+#define PCI_MASK1_dbus_mask_31to28_1c_shift                                          (28)
+#define PCI_MASK1_dbus_mask_31to28_1c_mask                                           (0xF0000000)
+#define PCI_MASK1_dbus_mask_31to28_1c(data)                                          (0xF0000000&((data)<<28))
+#define PCI_MASK1_dbus_mask_31to28_1c_src(data)                                      ((0xF0000000&(data))>>28)
+#define PCI_MASK1_dbus_mask_27to8_1c_shift                                           (8)
+#define PCI_MASK1_dbus_mask_27to8_1c_mask                                            (0x0FFFFF00)
+#define PCI_MASK1_dbus_mask_27to8_1c(data)                                           (0x0FFFFF00&((data)<<8))
+#define PCI_MASK1_dbus_mask_27to8_1c_src(data)                                       ((0x0FFFFF00&(data))>>8)
+
+
+#define PCI_TRANSL1                                                                  0x18017120
+#define PCI_TRANSL1_reg_addr                                                         "0xB8017120"
+#define PCI_TRANSL1_reg                                                              0xB8017120
+#define PCI_TRANSL1_inst_adr                                                         "0x0048"
+#define PCI_TRANSL1_inst                                                             0x0048
+#define PCI_TRANSL1_dbus_transl_27to8_20_shift                                       (8)
+#define PCI_TRANSL1_dbus_transl_27to8_20_mask                                        (0x0FFFFF00)
+#define PCI_TRANSL1_dbus_transl_27to8_20(data)                                       (0x0FFFFF00&((data)<<8))
+#define PCI_TRANSL1_dbus_transl_27to8_20_src(data)                                   ((0x0FFFFF00&(data))>>8)
+
+
+#define PCI_MASK2                                                                    0x18017124
+#define PCI_MASK2_reg_addr                                                           "0xB8017124"
+#define PCI_MASK2_reg                                                                0xB8017124
+#define PCI_MASK2_inst_adr                                                           "0x0049"
+#define PCI_MASK2_inst                                                               0x0049
+#define PCI_MASK2_sbus_mask_31to28_24_shift                                          (28)
+#define PCI_MASK2_sbus_mask_31to28_24_mask                                           (0xF0000000)
+#define PCI_MASK2_sbus_mask_31to28_24(data)                                          (0xF0000000&((data)<<28))
+#define PCI_MASK2_sbus_mask_31to28_24_src(data)                                      ((0xF0000000&(data))>>28)
+#define PCI_MASK2_sbus_mask_27to8_24_shift                                           (8)
+#define PCI_MASK2_sbus_mask_27to8_24_mask                                            (0x0FFFFF00)
+#define PCI_MASK2_sbus_mask_27to8_24(data)                                           (0x0FFFFF00&((data)<<8))
+#define PCI_MASK2_sbus_mask_27to8_24_src(data)                                       ((0x0FFFFF00&(data))>>8)
+
+
+#define PCI_TRANSL2                                                                  0x18017128
+#define PCI_TRANSL2_reg_addr                                                         "0xB8017128"
+#define PCI_TRANSL2_reg                                                              0xB8017128
+#define PCI_TRANSL2_inst_adr                                                         "0x004A"
+#define PCI_TRANSL2_inst                                                             0x004A
+#define PCI_TRANSL2_sbus_transl_27to8_28_shift                                       (8)
+#define PCI_TRANSL2_sbus_transl_27to8_28_mask                                        (0x0FFFFF00)
+#define PCI_TRANSL2_sbus_transl_27to8_28(data)                                       (0x0FFFFF00&((data)<<8))
+#define PCI_TRANSL2_sbus_transl_27to8_28_src(data)                                   ((0x0FFFFF00&(data))>>8)
+
+
+#define PCI_MST_ERR0                                                                 0x1801712C
+#define PCI_MST_ERR0_reg_addr                                                        "0xB801712C"
+#define PCI_MST_ERR0_reg                                                             0xB801712C
+#define PCI_MST_ERR0_inst_adr                                                        "0x004B"
+#define PCI_MST_ERR0_inst                                                            0x004B
+#define PCI_MST_ERR0_addr_error_31to0_2c_shift                                       (0)
+#define PCI_MST_ERR0_addr_error_31to0_2c_mask                                        (0xFFFFFFFF)
+#define PCI_MST_ERR0_addr_error_31to0_2c(data)                                       (0xFFFFFFFF&((data)<<0))
+#define PCI_MST_ERR0_addr_error_31to0_2c_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCI_MST_ERR1                                                                 0x18017130
+#define PCI_MST_ERR1_reg_addr                                                        "0xB8017130"
+#define PCI_MST_ERR1_reg                                                             0xB8017130
+#define PCI_MST_ERR1_inst_adr                                                        "0x004C"
+#define PCI_MST_ERR1_inst                                                            0x004C
+#define PCI_MST_ERR1_cmd_error_3to0_30_shift                                         (0)
+#define PCI_MST_ERR1_cmd_error_3to0_30_mask                                          (0x0000000F)
+#define PCI_MST_ERR1_cmd_error_3to0_30(data)                                         (0x0000000F&((data)<<0))
+#define PCI_MST_ERR1_cmd_error_3to0_30_src(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define PCI_SLV_ERR0                                                                 0x18017134
+#define PCI_SLV_ERR0_reg_addr                                                        "0xB8017134"
+#define PCI_SLV_ERR0_reg                                                             0xB8017134
+#define PCI_SLV_ERR0_inst_adr                                                        "0x004D"
+#define PCI_SLV_ERR0_inst                                                            0x004D
+#define PCI_SLV_ERR0_addr_error_31to0_34_shift                                       (0)
+#define PCI_SLV_ERR0_addr_error_31to0_34_mask                                        (0xFFFFFFFF)
+#define PCI_SLV_ERR0_addr_error_31to0_34(data)                                       (0xFFFFFFFF&((data)<<0))
+#define PCI_SLV_ERR0_addr_error_31to0_34_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCI_SLV_ERR1                                                                 0x18017138
+#define PCI_SLV_ERR1_reg_addr                                                        "0xB8017138"
+#define PCI_SLV_ERR1_reg                                                             0xB8017138
+#define PCI_SLV_ERR1_inst_adr                                                        "0x004E"
+#define PCI_SLV_ERR1_inst                                                            0x004E
+#define PCI_SLV_ERR1_cmd_error_3to0_38_shift                                         (0)
+#define PCI_SLV_ERR1_cmd_error_3to0_38_mask                                          (0x0000000F)
+#define PCI_SLV_ERR1_cmd_error_3to0_38(data)                                         (0x0000000F&((data)<<0))
+#define PCI_SLV_ERR1_cmd_error_3to0_38_src(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define PCI_MON_ST                                                                   0x1801713C
+#define PCI_MON_ST_reg_addr                                                          "0xB801713C"
+#define PCI_MON_ST_reg                                                               0xB801713C
+#define PCI_MON_ST_inst_adr                                                          "0x004F"
+#define PCI_MON_ST_inst                                                              0x004F
+#define PCI_MON_ST_error_clear_16_40_shift                                           (16)
+#define PCI_MON_ST_error_clear_16_40_mask                                            (0x00010000)
+#define PCI_MON_ST_error_clear_16_40(data)                                           (0x00010000&((data)<<16))
+#define PCI_MON_ST_error_clear_16_40_src(data)                                       ((0x00010000&(data))>>16)
+#define PCI_MON_ST_erro_msn_14to13_40_shift                                          (13)
+#define PCI_MON_ST_erro_msn_14to13_40_mask                                           (0x00006000)
+#define PCI_MON_ST_erro_msn_14to13_40(data)                                          (0x00006000&((data)<<13))
+#define PCI_MON_ST_erro_msn_14to13_40_src(data)                                      ((0x00006000&(data))>>13)
+#define PCI_MON_ST_pci_stop_12_3c_shift                                              (12)
+#define PCI_MON_ST_pci_stop_12_3c_mask                                               (0x00001000)
+#define PCI_MON_ST_pci_stop_12_3c(data)                                              (0x00001000&((data)<<12))
+#define PCI_MON_ST_pci_stop_12_3c_src(data)                                          ((0x00001000&(data))>>12)
+#define PCI_MON_ST_pci_trdy_11_3c_shift                                              (11)
+#define PCI_MON_ST_pci_trdy_11_3c_mask                                               (0x00000800)
+#define PCI_MON_ST_pci_trdy_11_3c(data)                                              (0x00000800&((data)<<11))
+#define PCI_MON_ST_pci_trdy_11_3c_src(data)                                          ((0x00000800&(data))>>11)
+#define PCI_MON_ST_pci_devsel_10_3c_shift                                            (10)
+#define PCI_MON_ST_pci_devsel_10_3c_mask                                             (0x00000400)
+#define PCI_MON_ST_pci_devsel_10_3c(data)                                            (0x00000400&((data)<<10))
+#define PCI_MON_ST_pci_devsel_10_3c_src(data)                                        ((0x00000400&(data))>>10)
+#define PCI_MON_ST_pci_irdy_9_3c_shift                                               (9)
+#define PCI_MON_ST_pci_irdy_9_3c_mask                                                (0x00000200)
+#define PCI_MON_ST_pci_irdy_9_3c(data)                                               (0x00000200&((data)<<9))
+#define PCI_MON_ST_pci_irdy_9_3c_src(data)                                           ((0x00000200&(data))>>9)
+#define PCI_MON_ST_pci_frame_8_3c_shift                                              (8)
+#define PCI_MON_ST_pci_frame_8_3c_mask                                               (0x00000100)
+#define PCI_MON_ST_pci_frame_8_3c(data)                                              (0x00000100&((data)<<8))
+#define PCI_MON_ST_pci_frame_8_3c_src(data)                                          ((0x00000100&(data))>>8)
+
+
+#define PCI_TMP_REG_0                                                                0x18017140
+#define PCI_TMP_REG_1                                                                0x18017144
+#define PCI_TMP_REG_2                                                                0x18017148
+#define PCI_TMP_REG_3                                                                0x1801714C
+#define PCI_TMP_REG_0_reg_addr                                                       "0xB8017140"
+#define PCI_TMP_REG_1_reg_addr                                                       "0xB8017144"
+#define PCI_TMP_REG_2_reg_addr                                                       "0xB8017148"
+#define PCI_TMP_REG_3_reg_addr                                                       "0xB801714C"
+#define PCI_TMP_REG_0_reg                                                            0xB8017140
+#define PCI_TMP_REG_1_reg                                                            0xB8017144
+#define PCI_TMP_REG_2_reg                                                            0xB8017148
+#define PCI_TMP_REG_3_reg                                                            0xB801714C
+#define PCI_TMP_REG_0_inst_adr                                                       "0x0050"
+#define PCI_TMP_REG_1_inst_adr                                                       "0x0051"
+#define PCI_TMP_REG_2_inst_adr                                                       "0x0052"
+#define PCI_TMP_REG_3_inst_adr                                                       "0x0053"
+#define PCI_TMP_REG_0_inst                                                           0x0050
+#define PCI_TMP_REG_1_inst                                                           0x0051
+#define PCI_TMP_REG_2_inst                                                           0x0052
+#define PCI_TMP_REG_3_inst                                                           0x0053
+#define PCI_TMP_REG_test_reg_shift                                                   (0)
+#define PCI_TMP_REG_test_reg_mask                                                    (0xFFFFFFFF)
+#define PCI_TMP_REG_test_reg(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define PCI_TMP_REG_test_reg_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define CFG_00H                                                                      0x18017200
+#define CFG_00H_reg_addr                                                             "0xB8017200"
+#define CFG_00H_reg                                                                  0xB8017200
+#define CFG_00H_inst_adr                                                             "0x0080"
+#define CFG_00H_inst                                                                 0x0080
+#define CFG_00H_dev_id_shift                                                         (16)
+#define CFG_00H_dev_id_mask                                                          (0xFFFF0000)
+#define CFG_00H_dev_id(data)                                                         (0xFFFF0000&((data)<<16))
+#define CFG_00H_dev_id_src(data)                                                     ((0xFFFF0000&(data))>>16)
+#define CFG_00H_ven_id_shift                                                         (0)
+#define CFG_00H_ven_id_mask                                                          (0x0000FFFF)
+#define CFG_00H_ven_id(data)                                                         (0x0000FFFF&((data)<<0))
+#define CFG_00H_ven_id_src(data)                                                     ((0x0000FFFF&(data))>>0)
+
+
+#define CFG_04H                                                                      0x18017204
+#define CFG_04H_reg_addr                                                             "0xB8017204"
+#define CFG_04H_reg                                                                  0xB8017204
+#define CFG_04H_inst_adr                                                             "0x0081"
+#define CFG_04H_inst                                                                 0x0081
+#define CFG_04H_detec_par_error_shift                                                (31)
+#define CFG_04H_detec_par_error_mask                                                 (0x80000000)
+#define CFG_04H_detec_par_error(data)                                                (0x80000000&((data)<<31))
+#define CFG_04H_detec_par_error_src(data)                                            ((0x80000000&(data))>>31)
+#define CFG_04H_signal_sys_error_shift                                               (30)
+#define CFG_04H_signal_sys_error_mask                                                (0x40000000)
+#define CFG_04H_signal_sys_error(data)                                               (0x40000000&((data)<<30))
+#define CFG_04H_signal_sys_error_src(data)                                           ((0x40000000&(data))>>30)
+#define CFG_04H_rec_master_abort_shift                                               (29)
+#define CFG_04H_rec_master_abort_mask                                                (0x20000000)
+#define CFG_04H_rec_master_abort(data)                                               (0x20000000&((data)<<29))
+#define CFG_04H_rec_master_abort_src(data)                                           ((0x20000000&(data))>>29)
+#define CFG_04H_rec_target_abort_shift                                               (28)
+#define CFG_04H_rec_target_abort_mask                                                (0x10000000)
+#define CFG_04H_rec_target_abort(data)                                               (0x10000000&((data)<<28))
+#define CFG_04H_rec_target_abort_src(data)                                           ((0x10000000&(data))>>28)
+#define CFG_04H_sig_tar_abort_shift                                                  (27)
+#define CFG_04H_sig_tar_abort_mask                                                   (0x08000000)
+#define CFG_04H_sig_tar_abort(data)                                                  (0x08000000&((data)<<27))
+#define CFG_04H_sig_tar_abort_src(data)                                              ((0x08000000&(data))>>27)
+#define CFG_04H_devsel_timer_shift                                                   (25)
+#define CFG_04H_devsel_timer_mask                                                    (0x06000000)
+#define CFG_04H_devsel_timer(data)                                                   (0x06000000&((data)<<25))
+#define CFG_04H_devsel_timer_src(data)                                               ((0x06000000&(data))>>25)
+#define CFG_04H_master_par_error_shift                                               (24)
+#define CFG_04H_master_par_error_mask                                                (0x01000000)
+#define CFG_04H_master_par_error(data)                                               (0x01000000&((data)<<24))
+#define CFG_04H_master_par_error_src(data)                                           ((0x01000000&(data))>>24)
+#define CFG_04H_fast_b2b_cap_shift                                                   (23)
+#define CFG_04H_fast_b2b_cap_mask                                                    (0x00800000)
+#define CFG_04H_fast_b2b_cap(data)                                                   (0x00800000&((data)<<23))
+#define CFG_04H_fast_b2b_cap_src(data)                                               ((0x00800000&(data))>>23)
+#define CFG_04H_a66mhz_shift                                                         (21)
+#define CFG_04H_a66mhz_mask                                                          (0x00200000)
+#define CFG_04H_a66mhz(data)                                                         (0x00200000&((data)<<21))
+#define CFG_04H_a66mhz_src(data)                                                     ((0x00200000&(data))>>21)
+#define CFG_04H_capability_list_shift                                                (20)
+#define CFG_04H_capability_list_mask                                                 (0x00100000)
+#define CFG_04H_capability_list(data)                                                (0x00100000&((data)<<20))
+#define CFG_04H_capability_list_src(data)                                            ((0x00100000&(data))>>20)
+#define CFG_04H_int_status_shift                                                     (19)
+#define CFG_04H_int_status_mask                                                      (0x00080000)
+#define CFG_04H_int_status(data)                                                     (0x00080000&((data)<<19))
+#define CFG_04H_int_status_src(data)                                                 ((0x00080000&(data))>>19)
+#define CFG_04H_interrupt_disable_shift                                              (10)
+#define CFG_04H_interrupt_disable_mask                                               (0x00000400)
+#define CFG_04H_interrupt_disable(data)                                              (0x00000400&((data)<<10))
+#define CFG_04H_interrupt_disable_src(data)                                          ((0x00000400&(data))>>10)
+#define CFG_04H_fast_b2b_shift                                                       (9)
+#define CFG_04H_fast_b2b_mask                                                        (0x00000200)
+#define CFG_04H_fast_b2b(data)                                                       (0x00000200&((data)<<9))
+#define CFG_04H_fast_b2b_src(data)                                                   ((0x00000200&(data))>>9)
+#define CFG_04H_serr_enable_shift                                                    (8)
+#define CFG_04H_serr_enable_mask                                                     (0x00000100)
+#define CFG_04H_serr_enable(data)                                                    (0x00000100&((data)<<8))
+#define CFG_04H_serr_enable_src(data)                                                ((0x00000100&(data))>>8)
+#define CFG_04H_parity_error_resp_shift                                              (6)
+#define CFG_04H_parity_error_resp_mask                                               (0x00000040)
+#define CFG_04H_parity_error_resp(data)                                              (0x00000040&((data)<<6))
+#define CFG_04H_parity_error_resp_src(data)                                          ((0x00000040&(data))>>6)
+#define CFG_04H_mwie_shift                                                           (4)
+#define CFG_04H_mwie_mask                                                            (0x00000010)
+#define CFG_04H_mwie(data)                                                           (0x00000010&((data)<<4))
+#define CFG_04H_mwie_src(data)                                                       ((0x00000010&(data))>>4)
+#define CFG_04H_bus_master_shift                                                     (2)
+#define CFG_04H_bus_master_mask                                                      (0x00000004)
+#define CFG_04H_bus_master(data)                                                     (0x00000004&((data)<<2))
+#define CFG_04H_bus_master_src(data)                                                 ((0x00000004&(data))>>2)
+#define CFG_04H_mm_space_shift                                                       (1)
+#define CFG_04H_mm_space_mask                                                        (0x00000002)
+#define CFG_04H_mm_space(data)                                                       (0x00000002&((data)<<1))
+#define CFG_04H_mm_space_src(data)                                                   ((0x00000002&(data))>>1)
+#define CFG_04H_io_space_shift                                                       (0)
+#define CFG_04H_io_space_mask                                                        (0x00000001)
+#define CFG_04H_io_space(data)                                                       (0x00000001&((data)<<0))
+#define CFG_04H_io_space_src(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define CFG_08H                                                                      0x18017208
+#define CFG_08H_reg_addr                                                             "0xB8017208"
+#define CFG_08H_reg                                                                  0xB8017208
+#define CFG_08H_inst_adr                                                             "0x0082"
+#define CFG_08H_inst                                                                 0x0082
+#define CFG_08H_class_code_shift                                                     (8)
+#define CFG_08H_class_code_mask                                                      (0xFFFFFF00)
+#define CFG_08H_class_code(data)                                                     (0xFFFFFF00&((data)<<8))
+#define CFG_08H_class_code_src(data)                                                 ((0xFFFFFF00&(data))>>8)
+#define CFG_08H_Rev_id_shift                                                         (0)
+#define CFG_08H_Rev_id_mask                                                          (0x000000FF)
+#define CFG_08H_Rev_id(data)                                                         (0x000000FF&((data)<<0))
+#define CFG_08H_Rev_id_src(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define CFG_0CH                                                                      0x1801720C
+#define CFG_0CH_reg_addr                                                             "0xB801720C"
+#define CFG_0CH_reg                                                                  0xB801720C
+#define CFG_0CH_inst_adr                                                             "0x0083"
+#define CFG_0CH_inst                                                                 0x0083
+#define CFG_0CH_latency_timer_shift                                                  (8)
+#define CFG_0CH_latency_timer_mask                                                   (0x0000FF00)
+#define CFG_0CH_latency_timer(data)                                                  (0x0000FF00&((data)<<8))
+#define CFG_0CH_latency_timer_src(data)                                              ((0x0000FF00&(data))>>8)
+#define CFG_0CH_cacheline_size_shift                                                 (0)
+#define CFG_0CH_cacheline_size_mask                                                  (0x000000FF)
+#define CFG_0CH_cacheline_size(data)                                                 (0x000000FF&((data)<<0))
+#define CFG_0CH_cacheline_size_src(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define CFG_10H                                                                      0x18017210
+#define CFG_10H_reg_addr                                                             "0xB8017210"
+#define CFG_10H_reg                                                                  0xB8017210
+#define CFG_10H_inst_adr                                                             "0x0084"
+#define CFG_10H_inst                                                                 0x0084
+#define CFG_10H_reg_ba_shift                                                         (5)
+#define CFG_10H_reg_ba_mask                                                          (0xFFFFFFE0)
+#define CFG_10H_reg_ba(data)                                                         (0xFFFFFFE0&((data)<<5))
+#define CFG_10H_reg_ba_src(data)                                                     ((0xFFFFFFE0&(data))>>5)
+#define CFG_10H_space_bit_shift                                                      (0)
+#define CFG_10H_space_bit_mask                                                       (0x00000001)
+#define CFG_10H_space_bit(data)                                                      (0x00000001&((data)<<0))
+#define CFG_10H_space_bit_src(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define CFG_14H                                                                      0x18017214
+#define CFG_14H_reg_addr                                                             "0xB8017214"
+#define CFG_14H_reg                                                                  0xB8017214
+#define CFG_14H_inst_adr                                                             "0x0085"
+#define CFG_14H_inst                                                                 0x0085
+#define CFG_14H_dbus_ba_shift                                                        (8)
+#define CFG_14H_dbus_ba_mask                                                         (0xFFFFFF00)
+#define CFG_14H_dbus_ba(data)                                                        (0xFFFFFF00&((data)<<8))
+#define CFG_14H_dbus_ba_src(data)                                                    ((0xFFFFFF00&(data))>>8)
+#define CFG_14H_space_bit_shift                                                      (0)
+#define CFG_14H_space_bit_mask                                                       (0x00000001)
+#define CFG_14H_space_bit(data)                                                      (0x00000001&((data)<<0))
+#define CFG_14H_space_bit_src(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define CFG_18H                                                                      0x18017218
+#define CFG_18H_reg_addr                                                             "0xB8017218"
+#define CFG_18H_reg                                                                  0xB8017218
+#define CFG_18H_inst_adr                                                             "0x0086"
+#define CFG_18H_inst                                                                 0x0086
+#define CFG_18H_rbus_ba_shift                                                        (8)
+#define CFG_18H_rbus_ba_mask                                                         (0xFFFFFF00)
+#define CFG_18H_rbus_ba(data)                                                        (0xFFFFFF00&((data)<<8))
+#define CFG_18H_rbus_ba_src(data)                                                    ((0xFFFFFF00&(data))>>8)
+#define CFG_18H_space_bit_shift                                                      (0)
+#define CFG_18H_space_bit_mask                                                       (0x00000001)
+#define CFG_18H_space_bit(data)                                                      (0x00000001&((data)<<0))
+#define CFG_18H_space_bit_src(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define CFG_1CH                                                                      0x1801721C
+#define CFG_1CH_reg_addr                                                             "0xB801721C"
+#define CFG_1CH_reg                                                                  0xB801721C
+#define CFG_1CH_inst_adr                                                             "0x0087"
+#define CFG_1CH_inst                                                                 0x0087
+#define CFG_1CH_sbus_ba_shift                                                        (8)
+#define CFG_1CH_sbus_ba_mask                                                         (0xFFFFFF00)
+#define CFG_1CH_sbus_ba(data)                                                        (0xFFFFFF00&((data)<<8))
+#define CFG_1CH_sbus_ba_src(data)                                                    ((0xFFFFFF00&(data))>>8)
+#define CFG_1CH_space_bit_shift                                                      (0)
+#define CFG_1CH_space_bit_mask                                                       (0x00000001)
+#define CFG_1CH_space_bit(data)                                                      (0x00000001&((data)<<0))
+#define CFG_1CH_space_bit_src(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define CFG_2CH                                                                      0x1801722C
+#define CFG_2CH_reg_addr                                                             "0xB801722C"
+#define CFG_2CH_reg                                                                  0xB801722C
+#define CFG_2CH_inst_adr                                                             "0x008B"
+#define CFG_2CH_inst                                                                 0x008B
+#define CFG_2CH_sub_id_shift                                                         (16)
+#define CFG_2CH_sub_id_mask                                                          (0xFFFF0000)
+#define CFG_2CH_sub_id(data)                                                         (0xFFFF0000&((data)<<16))
+#define CFG_2CH_sub_id_src(data)                                                     ((0xFFFF0000&(data))>>16)
+#define CFG_2CH_sub_ven_id_shift                                                     (0)
+#define CFG_2CH_sub_ven_id_mask                                                      (0x0000FFFF)
+#define CFG_2CH_sub_ven_id(data)                                                     (0x0000FFFF&((data)<<0))
+#define CFG_2CH_sub_ven_id_src(data)                                                 ((0x0000FFFF&(data))>>0)
+
+
+#define CFG_3CH                                                                      0x1801723C
+#define CFG_3CH_reg_addr                                                             "0xB801723C"
+#define CFG_3CH_reg                                                                  0xB801723C
+#define CFG_3CH_inst_adr                                                             "0x008F"
+#define CFG_3CH_inst                                                                 0x008F
+#define CFG_3CH_max_Lat_shift                                                        (24)
+#define CFG_3CH_max_Lat_mask                                                         (0xFF000000)
+#define CFG_3CH_max_Lat(data)                                                        (0xFF000000&((data)<<24))
+#define CFG_3CH_max_Lat_src(data)                                                    ((0xFF000000&(data))>>24)
+#define CFG_3CH_min_gnt_shift                                                        (16)
+#define CFG_3CH_min_gnt_mask                                                         (0x00FF0000)
+#define CFG_3CH_min_gnt(data)                                                        (0x00FF0000&((data)<<16))
+#define CFG_3CH_min_gnt_src(data)                                                    ((0x00FF0000&(data))>>16)
+#define CFG_3CH_interrupt_pin_shift                                                  (8)
+#define CFG_3CH_interrupt_pin_mask                                                   (0x0000FF00)
+#define CFG_3CH_interrupt_pin(data)                                                  (0x0000FF00&((data)<<8))
+#define CFG_3CH_interrupt_pin_src(data)                                              ((0x0000FF00&(data))>>8)
+#define CFG_3CH_interrupt_line_shift                                                 (0)
+#define CFG_3CH_interrupt_line_mask                                                  (0x000000FF)
+#define CFG_3CH_interrupt_line(data)                                                 (0x000000FF&((data)<<0))
+#define CFG_3CH_interrupt_line_src(data)                                             ((0x000000FF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/pcie_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/pcie_reg.h
new file mode 100644
index 00000000..6eff7b6
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/pcie_reg.h
@@ -0,0 +1,1798 @@
+/**************************************************************
+// Spec Version                  : 0.0.1
+// Parser Version                : MAR_Parser_1.0
+// CModelGen Version             : 4.1 2009.03.10
+// Naming Rule                   : Register_Name_reg
+// Firmware Header Generate Date : 2009/5/9
+***************************************************************/
+
+
+#ifndef _PCIE_REG_H_INCLUDED_
+#define _PCIE_REG_H_INCLUDED_
+#ifdef  _PCIE_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     phy_mdio_oe:1;
+unsigned int     phy_mdio_rstN:1;
+unsigned int     app_init_rst:1;
+unsigned int     reserved_1:6;
+unsigned int     loopback_en:1;
+unsigned int     dir_req_info_en:1;
+unsigned int     rx_lane_reversal_en:1;
+unsigned int     tx_lane_reversal_en:1;
+unsigned int     indir_cfg_en:1;
+unsigned int     dir_cfg_en:1;
+unsigned int     rcv_addr0_en:1;
+unsigned int     rcv_addr1_en:1;
+unsigned int     app_ltssm_en:1;
+unsigned int     rcv_trans_en:1;
+}PCIE_SYS_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     pcie_legacy_msi_en:1;
+unsigned int     pme_msi_intp_en:1;
+unsigned int     aer_rc_err_msi_intp_en:1;
+unsigned int     cfg_sys_err_rc_intp_en:1;
+unsigned int     pm_to_ack_intp_en:1;
+unsigned int     vendor_msg_intp_en:1;
+unsigned int     rtgt_error_intp_en:1;
+unsigned int     rtgt_timeout_intp_en:1;
+unsigned int     rcpl_error_intp_en:1;
+unsigned int     rcpl_timeout_intp_en:1;
+unsigned int     dir_error_intp_en:1;
+unsigned int     indir_cfg_intp_en:1;
+unsigned int     indir_mio_intp_en:1;
+}PCIE_INT_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     pcie_legacy_msi_int:1;
+unsigned int     pm_to_ack_int:1;
+unsigned int     cfg_sys_err_rc_int:1;
+unsigned int     pcie_legacy_int:1;
+unsigned int     cfg_radm_vendor_msg_int:1;
+unsigned int     cfg_pme_msi:1;
+unsigned int     cfg_pme_int:1;
+unsigned int     cfg_aer_rc_err_msi:1;
+unsigned int     cfg_aer_rc_err_int:1;
+unsigned int     intp_rtgt:1;
+unsigned int     intp_rcpl:1;
+unsigned int     intp_dir_cfg:1;
+unsigned int     intp_dir_mio:1;
+unsigned int     intp_cfg:1;
+unsigned int     intp_mio:1;
+}PCIE_GNR_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     intp_intd:1;
+unsigned int     intp_intc:1;
+unsigned int     intp_intb:1;
+unsigned int     intp_inta:1;
+}PCIE_PCIE_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     dbi_io_access:1;
+unsigned int     dbi_rom_access:1;
+unsigned int     dbi_bar_num:3;
+unsigned int     dbi_func_num:3;
+unsigned int     dbi_cs2_access:1;
+unsigned int     dbi_cmd_access:1;
+}PCIE_DBI_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     req_info_align:1;
+unsigned int     req_info_attr:2;
+unsigned int     req_info_ep:1;
+unsigned int     req_info_tc:3;
+unsigned int     req_info_type:5;
+unsigned int     req_info_fmt:2;
+}PCIE_INDIR_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     req_info_align:1;
+unsigned int     req_info_attr:2;
+unsigned int     req_info_ep:1;
+unsigned int     req_info_tc:3;
+unsigned int     req_info_type:5;
+unsigned int     req_info_fmt:2;
+}PCIE_DIR_CTR;
+
+typedef struct 
+{
+unsigned int     data:16;
+unsigned int     phy_addr:3;
+unsigned int     phy_reg_addr:5;
+unsigned int     mdio_busy:1;
+unsigned int     mdio_st:2;
+unsigned int     mdio_rdy:1;
+unsigned int     mclk_rate:2;
+unsigned int     mdio_srst:1;
+unsigned int     mdio_rdwr:1;
+}PCIE_MDIO_CTR;
+
+typedef struct 
+{
+unsigned int     rtrans_base_addr:32;
+}PCIE_PCIE_BASE0;
+
+typedef struct 
+{
+unsigned int     rtrans_base_addr:32;
+}PCIE_PCIE_BASE1;
+
+typedef struct 
+{
+unsigned int     rtrans_mask:32;
+}PCIE_PCIE_MASK0;
+
+typedef struct 
+{
+unsigned int     rtrans_mask:32;
+}PCIE_PCIE_MASK1;
+
+typedef struct 
+{
+unsigned int     rtrans_addr_in:32;
+}PCIE_PCIE_TRAN0;
+
+typedef struct 
+{
+unsigned int     rtrans_addr_in:32;
+}PCIE_PCIE_TRAN1;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     go_ct:1;
+}PCIE_CFG_CT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     bus_num:8;
+unsigned int     dev_num:5;
+unsigned int     fun_num:3;
+unsigned int     byte_cnt:4;
+unsigned int     reserved_1:1;
+unsigned int     error_en:1;
+unsigned int     byte_en:1;
+unsigned int     wrrd_en:1;
+}PCIE_CFG_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     error_st:1;
+unsigned int     done_st:1;
+}PCIE_CFG_ST;
+
+typedef struct 
+{
+unsigned int     space_addr:32;
+}PCIE_CFG_ADDR;
+
+typedef struct 
+{
+unsigned int     space_wdata:32;
+}PCIE_CFG_WDATA;
+
+typedef struct 
+{
+unsigned int     space_rdata:32;
+}PCIE_CFG_RDATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     go_ct:1;
+}PCIE_MIO_CT;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     error_st:1;
+unsigned int     done_st:1;
+}PCIE_MIO_ST;
+
+typedef struct 
+{
+unsigned int     timeout_cnt_value:24;
+unsigned int     byte_cnt:4;
+unsigned int     reserved_0:1;
+unsigned int     error_en:1;
+unsigned int     byte_en:1;
+unsigned int     wrrd_en:1;
+}PCIE_MIO_EN;
+
+typedef struct 
+{
+unsigned int     pcie_addr:32;
+}PCIE_MIO_ADDR;
+
+typedef struct 
+{
+unsigned int     pcie_wdata:32;
+}PCIE_MIO_WDATA;
+
+typedef struct 
+{
+unsigned int     pcie_rdata:32;
+}PCIE_MIO_RDATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     RX50_LINK:1;
+unsigned int     POW_PCIEX:1;
+unsigned int     SEL0_125M:1;
+unsigned int     REG_PLLDVR:3;
+unsigned int     CLK_SEL:1;
+}PCIE_PHY_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     app_pmxmt_turnoff:1;
+unsigned int     p1_clk_req_en:1;
+unsigned int     low_power_enable:1;
+unsigned int     sys_aux_pwr_det:1;
+unsigned int     app_ready_enter_123:1;
+unsigned int     app_req_exit_11:1;
+unsigned int     app_req_enter_11:1;
+}PCIE_PWR_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     dbg_sel1:6;
+unsigned int     dbg_sel0:6;
+unsigned int     dbg_en:1;
+}PCIE_PCIE_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cfg_rerror_st:1;
+unsigned int     mio_rerror_st:1;
+}PCIE_DIR_ST;
+
+typedef struct 
+{
+unsigned int     timeout_cnt_value:24;
+unsigned int     reserved_0:7;
+unsigned int     timeout_en:1;
+}PCIE_DIR_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rcpl_status:3;
+unsigned int     rcpl_error_st:1;
+unsigned int     tlp_abort_st:1;
+unsigned int     dllp_abort_st:1;
+unsigned int     ecrc_error_st:1;
+unsigned int     rcpl_timeout_st:1;
+}PCIE_RCPL_ST;
+
+typedef struct 
+{
+unsigned int     nor_error_addr:32;
+}PCIE_RCPL_ADR;
+
+typedef struct 
+{
+unsigned int     to_error_addr:32;
+}PCIE_RCPL_TOUT0;
+
+typedef struct 
+{
+unsigned int     timeout_num:3;
+unsigned int     timeout_tc:3;
+unsigned int     timeout_attr:2;
+unsigned int     timeout_len:12;
+unsigned int     reserved_0:4;
+unsigned int     timeout_tag:8;
+}PCIE_RCPL_TOUT1;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     rcpl_compl_st:1;
+unsigned int     tlp_abort_st:1;
+unsigned int     dllp_abort_st:1;
+unsigned int     ecrc_error_st:1;
+unsigned int     rcpl_timeout_st:1;
+}PCIE_RTGT_ST;
+
+typedef struct 
+{
+unsigned int     nor_error_addr:32;
+}PCIE_RTGT_ADR;
+
+typedef struct 
+{
+unsigned int     to_error_addr:32;
+}PCIE_RTGT_TOUT0;
+
+typedef struct 
+{
+unsigned int     timeout_num:3;
+unsigned int     timeout_tc:3;
+unsigned int     timeout_attr:2;
+unsigned int     timeout_len:12;
+unsigned int     reserved_0:4;
+unsigned int     timeout_tag:8;
+}PCIE_RTGT_TOUT1;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     cfg_sys_err_rc:1;
+}PCIE_AERRO_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     cfg_aer_int_msg_num:5;
+unsigned int     cfg_aer_rc_err_msi:1;
+}PCIE_AEMSI_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     radm_pm_to_ack:1;
+}PCIE_PME_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     cfg_cap_int_msg_num:5;
+unsigned int     cfg_pme_msi:1;
+}PCIE_PMMSI_ST;
+
+typedef struct 
+{
+unsigned int     radm_msg_req_id:16;
+unsigned int     reserved_0:15;
+unsigned int     radm_vendor_msg:1;
+}PCIE_VEN_MSG0;
+
+typedef struct 
+{
+unsigned int     radm_msg_payload:32;
+}PCIE_VEN_MSG1;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     rdlh_link_up:1;
+unsigned int     pm_xtlh_block_tlp:1;
+unsigned int     cfg_bus_master_en:1;
+unsigned int     cfg_pm_no_soft_rst:1;
+unsigned int     xmlh_link_up:1;
+unsigned int     link_req_rst_not:1;
+unsigned int     xmlh_ltssm_state:5;
+unsigned int     pm_curnt_state:3;
+unsigned int     clk_req_n:1;
+}PCIE_MAC_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     unlock_msg_trigger:1;
+}PCIE_UNLOCK_MSG;
+
+typedef struct 
+{
+unsigned int     reg1:16;
+unsigned int     reg0:16;
+}PCIE_SCTCH;
+
+typedef struct 
+{
+unsigned int     rw_data:32;
+}PCIE_LOOP_DATA;
+
+typedef struct 
+{
+unsigned int     msi_check_addr:30;
+unsigned int     reserved_0:2;
+}PCIE_MSI_TRAN;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     msi_data_st:1;
+unsigned int     msi_data:16;
+}PCIE_MSI_DATA;
+
+typedef struct 
+{
+unsigned int     test_reg:32;
+}PCIE_TMP_REG;
+
+#endif
+
+#define PCIE_SYS_CTR                                                                 0x18017A00
+#define PCIE_SYS_CTR_reg_addr                                                        "0xB8017A00"
+#define PCIE_SYS_CTR_reg                                                             0xB8017A00
+#define set_PCIE_SYS_CTR_reg(data)   (*((volatile unsigned int*) PCIE_SYS_CTR_reg)=data)
+#define get_PCIE_SYS_CTR_reg   (*((volatile unsigned int*) PCIE_SYS_CTR_reg))
+#define PCIE_SYS_CTR_inst_adr                                                        "0x0080"
+#define PCIE_SYS_CTR_inst                                                            0x0080
+#define PCIE_SYS_CTR_phy_mdio_oe_shift                                               (18)
+#define PCIE_SYS_CTR_phy_mdio_oe_mask                                                (0x00040000)
+#define PCIE_SYS_CTR_phy_mdio_oe(data)                                               (0x00040000&((data)<<18))
+#define PCIE_SYS_CTR_phy_mdio_oe_src(data)                                           ((0x00040000&(data))>>18)
+#define PCIE_SYS_CTR_get_phy_mdio_oe(data)                                           ((0x00040000&(data))>>18)
+#define PCIE_SYS_CTR_phy_mdio_rstN_shift                                             (17)
+#define PCIE_SYS_CTR_phy_mdio_rstN_mask                                              (0x00020000)
+#define PCIE_SYS_CTR_phy_mdio_rstN(data)                                             (0x00020000&((data)<<17))
+#define PCIE_SYS_CTR_phy_mdio_rstN_src(data)                                         ((0x00020000&(data))>>17)
+#define PCIE_SYS_CTR_get_phy_mdio_rstN(data)                                         ((0x00020000&(data))>>17)
+#define PCIE_SYS_CTR_app_init_rst_shift                                              (16)
+#define PCIE_SYS_CTR_app_init_rst_mask                                               (0x00010000)
+#define PCIE_SYS_CTR_app_init_rst(data)                                              (0x00010000&((data)<<16))
+#define PCIE_SYS_CTR_app_init_rst_src(data)                                          ((0x00010000&(data))>>16)
+#define PCIE_SYS_CTR_get_app_init_rst(data)                                          ((0x00010000&(data))>>16)
+#define PCIE_SYS_CTR_loopback_en_shift                                               (9)
+#define PCIE_SYS_CTR_loopback_en_mask                                                (0x00000200)
+#define PCIE_SYS_CTR_loopback_en(data)                                               (0x00000200&((data)<<9))
+#define PCIE_SYS_CTR_loopback_en_src(data)                                           ((0x00000200&(data))>>9)
+#define PCIE_SYS_CTR_get_loopback_en(data)                                           ((0x00000200&(data))>>9)
+#define PCIE_SYS_CTR_dir_req_info_en_shift                                           (8)
+#define PCIE_SYS_CTR_dir_req_info_en_mask                                            (0x00000100)
+#define PCIE_SYS_CTR_dir_req_info_en(data)                                           (0x00000100&((data)<<8))
+#define PCIE_SYS_CTR_dir_req_info_en_src(data)                                       ((0x00000100&(data))>>8)
+#define PCIE_SYS_CTR_get_dir_req_info_en(data)                                       ((0x00000100&(data))>>8)
+#define PCIE_SYS_CTR_rx_lane_reversal_en_shift                                       (7)
+#define PCIE_SYS_CTR_rx_lane_reversal_en_mask                                        (0x00000080)
+#define PCIE_SYS_CTR_rx_lane_reversal_en(data)                                       (0x00000080&((data)<<7))
+#define PCIE_SYS_CTR_rx_lane_reversal_en_src(data)                                   ((0x00000080&(data))>>7)
+#define PCIE_SYS_CTR_get_rx_lane_reversal_en(data)                                   ((0x00000080&(data))>>7)
+#define PCIE_SYS_CTR_tx_lane_reversal_en_shift                                       (6)
+#define PCIE_SYS_CTR_tx_lane_reversal_en_mask                                        (0x00000040)
+#define PCIE_SYS_CTR_tx_lane_reversal_en(data)                                       (0x00000040&((data)<<6))
+#define PCIE_SYS_CTR_tx_lane_reversal_en_src(data)                                   ((0x00000040&(data))>>6)
+#define PCIE_SYS_CTR_get_tx_lane_reversal_en(data)                                   ((0x00000040&(data))>>6)
+#define PCIE_SYS_CTR_indir_cfg_en_shift                                              (5)
+#define PCIE_SYS_CTR_indir_cfg_en_mask                                               (0x00000020)
+#define PCIE_SYS_CTR_indir_cfg_en(data)                                              (0x00000020&((data)<<5))
+#define PCIE_SYS_CTR_indir_cfg_en_src(data)                                          ((0x00000020&(data))>>5)
+#define PCIE_SYS_CTR_get_indir_cfg_en(data)                                          ((0x00000020&(data))>>5)
+#define PCIE_SYS_CTR_dir_cfg_en_shift                                                (4)
+#define PCIE_SYS_CTR_dir_cfg_en_mask                                                 (0x00000010)
+#define PCIE_SYS_CTR_dir_cfg_en(data)                                                (0x00000010&((data)<<4))
+#define PCIE_SYS_CTR_dir_cfg_en_src(data)                                            ((0x00000010&(data))>>4)
+#define PCIE_SYS_CTR_get_dir_cfg_en(data)                                            ((0x00000010&(data))>>4)
+#define PCIE_SYS_CTR_rcv_addr0_en_shift                                              (3)
+#define PCIE_SYS_CTR_rcv_addr0_en_mask                                               (0x00000008)
+#define PCIE_SYS_CTR_rcv_addr0_en(data)                                              (0x00000008&((data)<<3))
+#define PCIE_SYS_CTR_rcv_addr0_en_src(data)                                          ((0x00000008&(data))>>3)
+#define PCIE_SYS_CTR_get_rcv_addr0_en(data)                                          ((0x00000008&(data))>>3)
+#define PCIE_SYS_CTR_rcv_addr1_en_shift                                              (2)
+#define PCIE_SYS_CTR_rcv_addr1_en_mask                                               (0x00000004)
+#define PCIE_SYS_CTR_rcv_addr1_en(data)                                              (0x00000004&((data)<<2))
+#define PCIE_SYS_CTR_rcv_addr1_en_src(data)                                          ((0x00000004&(data))>>2)
+#define PCIE_SYS_CTR_get_rcv_addr1_en(data)                                          ((0x00000004&(data))>>2)
+#define PCIE_SYS_CTR_app_ltssm_en_shift                                              (1)
+#define PCIE_SYS_CTR_app_ltssm_en_mask                                               (0x00000002)
+#define PCIE_SYS_CTR_app_ltssm_en(data)                                              (0x00000002&((data)<<1))
+#define PCIE_SYS_CTR_app_ltssm_en_src(data)                                          ((0x00000002&(data))>>1)
+#define PCIE_SYS_CTR_get_app_ltssm_en(data)                                          ((0x00000002&(data))>>1)
+#define PCIE_SYS_CTR_rcv_trans_en_shift                                              (0)
+#define PCIE_SYS_CTR_rcv_trans_en_mask                                               (0x00000001)
+#define PCIE_SYS_CTR_rcv_trans_en(data)                                              (0x00000001&((data)<<0))
+#define PCIE_SYS_CTR_rcv_trans_en_src(data)                                          ((0x00000001&(data))>>0)
+#define PCIE_SYS_CTR_get_rcv_trans_en(data)                                          ((0x00000001&(data))>>0)
+
+
+#define PCIE_INT_CTR                                                                 0x18017A04
+#define PCIE_INT_CTR_reg_addr                                                        "0xB8017A04"
+#define PCIE_INT_CTR_reg                                                             0xB8017A04
+#define set_PCIE_INT_CTR_reg(data)   (*((volatile unsigned int*) PCIE_INT_CTR_reg)=data)
+#define get_PCIE_INT_CTR_reg   (*((volatile unsigned int*) PCIE_INT_CTR_reg))
+#define PCIE_INT_CTR_inst_adr                                                        "0x0081"
+#define PCIE_INT_CTR_inst                                                            0x0081
+#define PCIE_INT_CTR_pcie_legacy_msi_en_shift                                        (12)
+#define PCIE_INT_CTR_pcie_legacy_msi_en_mask                                         (0x00001000)
+#define PCIE_INT_CTR_pcie_legacy_msi_en(data)                                        (0x00001000&((data)<<12))
+#define PCIE_INT_CTR_pcie_legacy_msi_en_src(data)                                    ((0x00001000&(data))>>12)
+#define PCIE_INT_CTR_get_pcie_legacy_msi_en(data)                                    ((0x00001000&(data))>>12)
+#define PCIE_INT_CTR_pme_msi_intp_en_shift                                           (11)
+#define PCIE_INT_CTR_pme_msi_intp_en_mask                                            (0x00000800)
+#define PCIE_INT_CTR_pme_msi_intp_en(data)                                           (0x00000800&((data)<<11))
+#define PCIE_INT_CTR_pme_msi_intp_en_src(data)                                       ((0x00000800&(data))>>11)
+#define PCIE_INT_CTR_get_pme_msi_intp_en(data)                                       ((0x00000800&(data))>>11)
+#define PCIE_INT_CTR_aer_rc_err_msi_intp_en_shift                                    (10)
+#define PCIE_INT_CTR_aer_rc_err_msi_intp_en_mask                                     (0x00000400)
+#define PCIE_INT_CTR_aer_rc_err_msi_intp_en(data)                                    (0x00000400&((data)<<10))
+#define PCIE_INT_CTR_aer_rc_err_msi_intp_en_src(data)                                ((0x00000400&(data))>>10)
+#define PCIE_INT_CTR_get_aer_rc_err_msi_intp_en(data)                                ((0x00000400&(data))>>10)
+#define PCIE_INT_CTR_cfg_sys_err_rc_intp_en_shift                                    (9)
+#define PCIE_INT_CTR_cfg_sys_err_rc_intp_en_mask                                     (0x00000200)
+#define PCIE_INT_CTR_cfg_sys_err_rc_intp_en(data)                                    (0x00000200&((data)<<9))
+#define PCIE_INT_CTR_cfg_sys_err_rc_intp_en_src(data)                                ((0x00000200&(data))>>9)
+#define PCIE_INT_CTR_get_cfg_sys_err_rc_intp_en(data)                                ((0x00000200&(data))>>9)
+#define PCIE_INT_CTR_pm_to_ack_intp_en_shift                                         (8)
+#define PCIE_INT_CTR_pm_to_ack_intp_en_mask                                          (0x00000100)
+#define PCIE_INT_CTR_pm_to_ack_intp_en(data)                                         (0x00000100&((data)<<8))
+#define PCIE_INT_CTR_pm_to_ack_intp_en_src(data)                                     ((0x00000100&(data))>>8)
+#define PCIE_INT_CTR_get_pm_to_ack_intp_en(data)                                     ((0x00000100&(data))>>8)
+#define PCIE_INT_CTR_vendor_msg_intp_en_shift                                        (7)
+#define PCIE_INT_CTR_vendor_msg_intp_en_mask                                         (0x00000080)
+#define PCIE_INT_CTR_vendor_msg_intp_en(data)                                        (0x00000080&((data)<<7))
+#define PCIE_INT_CTR_vendor_msg_intp_en_src(data)                                    ((0x00000080&(data))>>7)
+#define PCIE_INT_CTR_get_vendor_msg_intp_en(data)                                    ((0x00000080&(data))>>7)
+#define PCIE_INT_CTR_rtgt_error_intp_en_shift                                        (6)
+#define PCIE_INT_CTR_rtgt_error_intp_en_mask                                         (0x00000040)
+#define PCIE_INT_CTR_rtgt_error_intp_en(data)                                        (0x00000040&((data)<<6))
+#define PCIE_INT_CTR_rtgt_error_intp_en_src(data)                                    ((0x00000040&(data))>>6)
+#define PCIE_INT_CTR_get_rtgt_error_intp_en(data)                                    ((0x00000040&(data))>>6)
+#define PCIE_INT_CTR_rtgt_timeout_intp_en_shift                                      (5)
+#define PCIE_INT_CTR_rtgt_timeout_intp_en_mask                                       (0x00000020)
+#define PCIE_INT_CTR_rtgt_timeout_intp_en(data)                                      (0x00000020&((data)<<5))
+#define PCIE_INT_CTR_rtgt_timeout_intp_en_src(data)                                  ((0x00000020&(data))>>5)
+#define PCIE_INT_CTR_get_rtgt_timeout_intp_en(data)                                  ((0x00000020&(data))>>5)
+#define PCIE_INT_CTR_rcpl_error_intp_en_shift                                        (4)
+#define PCIE_INT_CTR_rcpl_error_intp_en_mask                                         (0x00000010)
+#define PCIE_INT_CTR_rcpl_error_intp_en(data)                                        (0x00000010&((data)<<4))
+#define PCIE_INT_CTR_rcpl_error_intp_en_src(data)                                    ((0x00000010&(data))>>4)
+#define PCIE_INT_CTR_get_rcpl_error_intp_en(data)                                    ((0x00000010&(data))>>4)
+#define PCIE_INT_CTR_rcpl_timeout_intp_en_shift                                      (3)
+#define PCIE_INT_CTR_rcpl_timeout_intp_en_mask                                       (0x00000008)
+#define PCIE_INT_CTR_rcpl_timeout_intp_en(data)                                      (0x00000008&((data)<<3))
+#define PCIE_INT_CTR_rcpl_timeout_intp_en_src(data)                                  ((0x00000008&(data))>>3)
+#define PCIE_INT_CTR_get_rcpl_timeout_intp_en(data)                                  ((0x00000008&(data))>>3)
+#define PCIE_INT_CTR_dir_error_intp_en_shift                                         (2)
+#define PCIE_INT_CTR_dir_error_intp_en_mask                                          (0x00000004)
+#define PCIE_INT_CTR_dir_error_intp_en(data)                                         (0x00000004&((data)<<2))
+#define PCIE_INT_CTR_dir_error_intp_en_src(data)                                     ((0x00000004&(data))>>2)
+#define PCIE_INT_CTR_get_dir_error_intp_en(data)                                     ((0x00000004&(data))>>2)
+#define PCIE_INT_CTR_indir_cfg_intp_en_shift                                         (1)
+#define PCIE_INT_CTR_indir_cfg_intp_en_mask                                          (0x00000002)
+#define PCIE_INT_CTR_indir_cfg_intp_en(data)                                         (0x00000002&((data)<<1))
+#define PCIE_INT_CTR_indir_cfg_intp_en_src(data)                                     ((0x00000002&(data))>>1)
+#define PCIE_INT_CTR_get_indir_cfg_intp_en(data)                                     ((0x00000002&(data))>>1)
+#define PCIE_INT_CTR_indir_mio_intp_en_shift                                         (0)
+#define PCIE_INT_CTR_indir_mio_intp_en_mask                                          (0x00000001)
+#define PCIE_INT_CTR_indir_mio_intp_en(data)                                         (0x00000001&((data)<<0))
+#define PCIE_INT_CTR_indir_mio_intp_en_src(data)                                     ((0x00000001&(data))>>0)
+#define PCIE_INT_CTR_get_indir_mio_intp_en(data)                                     ((0x00000001&(data))>>0)
+
+
+#define PCIE_GNR_INT                                                                 0x18017A08
+#define PCIE_GNR_INT_reg_addr                                                        "0xB8017A08"
+#define PCIE_GNR_INT_reg                                                             0xB8017A08
+#define set_PCIE_GNR_INT_reg(data)   (*((volatile unsigned int*) PCIE_GNR_INT_reg)=data)
+#define get_PCIE_GNR_INT_reg   (*((volatile unsigned int*) PCIE_GNR_INT_reg))
+#define PCIE_GNR_INT_inst_adr                                                        "0x0082"
+#define PCIE_GNR_INT_inst                                                            0x0082
+#define PCIE_GNR_INT_pcie_legacy_msi_int_shift                                       (14)
+#define PCIE_GNR_INT_pcie_legacy_msi_int_mask                                        (0x00004000)
+#define PCIE_GNR_INT_pcie_legacy_msi_int(data)                                       (0x00004000&((data)<<14))
+#define PCIE_GNR_INT_pcie_legacy_msi_int_src(data)                                   ((0x00004000&(data))>>14)
+#define PCIE_GNR_INT_get_pcie_legacy_msi_int(data)                                   ((0x00004000&(data))>>14)
+#define PCIE_GNR_INT_pm_to_ack_int_shift                                             (13)
+#define PCIE_GNR_INT_pm_to_ack_int_mask                                              (0x00002000)
+#define PCIE_GNR_INT_pm_to_ack_int(data)                                             (0x00002000&((data)<<13))
+#define PCIE_GNR_INT_pm_to_ack_int_src(data)                                         ((0x00002000&(data))>>13)
+#define PCIE_GNR_INT_get_pm_to_ack_int(data)                                         ((0x00002000&(data))>>13)
+#define PCIE_GNR_INT_cfg_sys_err_rc_int_shift                                        (12)
+#define PCIE_GNR_INT_cfg_sys_err_rc_int_mask                                         (0x00001000)
+#define PCIE_GNR_INT_cfg_sys_err_rc_int(data)                                        (0x00001000&((data)<<12))
+#define PCIE_GNR_INT_cfg_sys_err_rc_int_src(data)                                    ((0x00001000&(data))>>12)
+#define PCIE_GNR_INT_get_cfg_sys_err_rc_int(data)                                    ((0x00001000&(data))>>12)
+#define PCIE_GNR_INT_pcie_legacy_int_shift                                           (11)
+#define PCIE_GNR_INT_pcie_legacy_int_mask                                            (0x00000800)
+#define PCIE_GNR_INT_pcie_legacy_int(data)                                           (0x00000800&((data)<<11))
+#define PCIE_GNR_INT_pcie_legacy_int_src(data)                                       ((0x00000800&(data))>>11)
+#define PCIE_GNR_INT_get_pcie_legacy_int(data)                                       ((0x00000800&(data))>>11)
+#define PCIE_GNR_INT_cfg_radm_vendor_msg_int_shift                                   (10)
+#define PCIE_GNR_INT_cfg_radm_vendor_msg_int_mask                                    (0x00000400)
+#define PCIE_GNR_INT_cfg_radm_vendor_msg_int(data)                                   (0x00000400&((data)<<10))
+#define PCIE_GNR_INT_cfg_radm_vendor_msg_int_src(data)                               ((0x00000400&(data))>>10)
+#define PCIE_GNR_INT_get_cfg_radm_vendor_msg_int(data)                               ((0x00000400&(data))>>10)
+#define PCIE_GNR_INT_cfg_pme_msi_shift                                               (9)
+#define PCIE_GNR_INT_cfg_pme_msi_mask                                                (0x00000200)
+#define PCIE_GNR_INT_cfg_pme_msi(data)                                               (0x00000200&((data)<<9))
+#define PCIE_GNR_INT_cfg_pme_msi_src(data)                                           ((0x00000200&(data))>>9)
+#define PCIE_GNR_INT_get_cfg_pme_msi(data)                                           ((0x00000200&(data))>>9)
+#define PCIE_GNR_INT_cfg_pme_int_shift                                               (8)
+#define PCIE_GNR_INT_cfg_pme_int_mask                                                (0x00000100)
+#define PCIE_GNR_INT_cfg_pme_int(data)                                               (0x00000100&((data)<<8))
+#define PCIE_GNR_INT_cfg_pme_int_src(data)                                           ((0x00000100&(data))>>8)
+#define PCIE_GNR_INT_get_cfg_pme_int(data)                                           ((0x00000100&(data))>>8)
+#define PCIE_GNR_INT_cfg_aer_rc_err_msi_shift                                        (7)
+#define PCIE_GNR_INT_cfg_aer_rc_err_msi_mask                                         (0x00000080)
+#define PCIE_GNR_INT_cfg_aer_rc_err_msi(data)                                        (0x00000080&((data)<<7))
+#define PCIE_GNR_INT_cfg_aer_rc_err_msi_src(data)                                    ((0x00000080&(data))>>7)
+#define PCIE_GNR_INT_get_cfg_aer_rc_err_msi(data)                                    ((0x00000080&(data))>>7)
+#define PCIE_GNR_INT_cfg_aer_rc_err_int_shift                                        (6)
+#define PCIE_GNR_INT_cfg_aer_rc_err_int_mask                                         (0x00000040)
+#define PCIE_GNR_INT_cfg_aer_rc_err_int(data)                                        (0x00000040&((data)<<6))
+#define PCIE_GNR_INT_cfg_aer_rc_err_int_src(data)                                    ((0x00000040&(data))>>6)
+#define PCIE_GNR_INT_get_cfg_aer_rc_err_int(data)                                    ((0x00000040&(data))>>6)
+#define PCIE_GNR_INT_intp_rtgt_shift                                                 (5)
+#define PCIE_GNR_INT_intp_rtgt_mask                                                  (0x00000020)
+#define PCIE_GNR_INT_intp_rtgt(data)                                                 (0x00000020&((data)<<5))
+#define PCIE_GNR_INT_intp_rtgt_src(data)                                             ((0x00000020&(data))>>5)
+#define PCIE_GNR_INT_get_intp_rtgt(data)                                             ((0x00000020&(data))>>5)
+#define PCIE_GNR_INT_intp_rcpl_shift                                                 (4)
+#define PCIE_GNR_INT_intp_rcpl_mask                                                  (0x00000010)
+#define PCIE_GNR_INT_intp_rcpl(data)                                                 (0x00000010&((data)<<4))
+#define PCIE_GNR_INT_intp_rcpl_src(data)                                             ((0x00000010&(data))>>4)
+#define PCIE_GNR_INT_get_intp_rcpl(data)                                             ((0x00000010&(data))>>4)
+#define PCIE_GNR_INT_intp_dir_cfg_shift                                              (3)
+#define PCIE_GNR_INT_intp_dir_cfg_mask                                               (0x00000008)
+#define PCIE_GNR_INT_intp_dir_cfg(data)                                              (0x00000008&((data)<<3))
+#define PCIE_GNR_INT_intp_dir_cfg_src(data)                                          ((0x00000008&(data))>>3)
+#define PCIE_GNR_INT_get_intp_dir_cfg(data)                                          ((0x00000008&(data))>>3)
+#define PCIE_GNR_INT_intp_dir_mio_shift                                              (2)
+#define PCIE_GNR_INT_intp_dir_mio_mask                                               (0x00000004)
+#define PCIE_GNR_INT_intp_dir_mio(data)                                              (0x00000004&((data)<<2))
+#define PCIE_GNR_INT_intp_dir_mio_src(data)                                          ((0x00000004&(data))>>2)
+#define PCIE_GNR_INT_get_intp_dir_mio(data)                                          ((0x00000004&(data))>>2)
+#define PCIE_GNR_INT_intp_cfg_shift                                                  (1)
+#define PCIE_GNR_INT_intp_cfg_mask                                                   (0x00000002)
+#define PCIE_GNR_INT_intp_cfg(data)                                                  (0x00000002&((data)<<1))
+#define PCIE_GNR_INT_intp_cfg_src(data)                                              ((0x00000002&(data))>>1)
+#define PCIE_GNR_INT_get_intp_cfg(data)                                              ((0x00000002&(data))>>1)
+#define PCIE_GNR_INT_intp_mio_shift                                                  (0)
+#define PCIE_GNR_INT_intp_mio_mask                                                   (0x00000001)
+#define PCIE_GNR_INT_intp_mio(data)                                                  (0x00000001&((data)<<0))
+#define PCIE_GNR_INT_intp_mio_src(data)                                              ((0x00000001&(data))>>0)
+#define PCIE_GNR_INT_get_intp_mio(data)                                              ((0x00000001&(data))>>0)
+
+
+#define PCIE_PCIE_INT                                                                0x18017A0C
+#define PCIE_PCIE_INT_reg_addr                                                       "0xB8017A0C"
+#define PCIE_PCIE_INT_reg                                                            0xB8017A0C
+#define set_PCIE_PCIE_INT_reg(data)   (*((volatile unsigned int*) PCIE_PCIE_INT_reg)=data)
+#define get_PCIE_PCIE_INT_reg   (*((volatile unsigned int*) PCIE_PCIE_INT_reg))
+#define PCIE_PCIE_INT_inst_adr                                                       "0x0083"
+#define PCIE_PCIE_INT_inst                                                           0x0083
+#define PCIE_PCIE_INT_intp_intd_shift                                                (3)
+#define PCIE_PCIE_INT_intp_intd_mask                                                 (0x00000008)
+#define PCIE_PCIE_INT_intp_intd(data)                                                (0x00000008&((data)<<3))
+#define PCIE_PCIE_INT_intp_intd_src(data)                                            ((0x00000008&(data))>>3)
+#define PCIE_PCIE_INT_get_intp_intd(data)                                            ((0x00000008&(data))>>3)
+#define PCIE_PCIE_INT_intp_intc_shift                                                (2)
+#define PCIE_PCIE_INT_intp_intc_mask                                                 (0x00000004)
+#define PCIE_PCIE_INT_intp_intc(data)                                                (0x00000004&((data)<<2))
+#define PCIE_PCIE_INT_intp_intc_src(data)                                            ((0x00000004&(data))>>2)
+#define PCIE_PCIE_INT_get_intp_intc(data)                                            ((0x00000004&(data))>>2)
+#define PCIE_PCIE_INT_intp_intb_shift                                                (1)
+#define PCIE_PCIE_INT_intp_intb_mask                                                 (0x00000002)
+#define PCIE_PCIE_INT_intp_intb(data)                                                (0x00000002&((data)<<1))
+#define PCIE_PCIE_INT_intp_intb_src(data)                                            ((0x00000002&(data))>>1)
+#define PCIE_PCIE_INT_get_intp_intb(data)                                            ((0x00000002&(data))>>1)
+#define PCIE_PCIE_INT_intp_inta_shift                                                (0)
+#define PCIE_PCIE_INT_intp_inta_mask                                                 (0x00000001)
+#define PCIE_PCIE_INT_intp_inta(data)                                                (0x00000001&((data)<<0))
+#define PCIE_PCIE_INT_intp_inta_src(data)                                            ((0x00000001&(data))>>0)
+#define PCIE_PCIE_INT_get_intp_inta(data)                                            ((0x00000001&(data))>>0)
+
+
+#define PCIE_DBI_CTR                                                                 0x18017A10
+#define PCIE_DBI_CTR_reg_addr                                                        "0xB8017A10"
+#define PCIE_DBI_CTR_reg                                                             0xB8017A10
+#define set_PCIE_DBI_CTR_reg(data)   (*((volatile unsigned int*) PCIE_DBI_CTR_reg)=data)
+#define get_PCIE_DBI_CTR_reg   (*((volatile unsigned int*) PCIE_DBI_CTR_reg))
+#define PCIE_DBI_CTR_inst_adr                                                        "0x0084"
+#define PCIE_DBI_CTR_inst                                                            0x0084
+#define PCIE_DBI_CTR_dbi_io_access_shift                                             (9)
+#define PCIE_DBI_CTR_dbi_io_access_mask                                              (0x00000200)
+#define PCIE_DBI_CTR_dbi_io_access(data)                                             (0x00000200&((data)<<9))
+#define PCIE_DBI_CTR_dbi_io_access_src(data)                                         ((0x00000200&(data))>>9)
+#define PCIE_DBI_CTR_get_dbi_io_access(data)                                         ((0x00000200&(data))>>9)
+#define PCIE_DBI_CTR_dbi_rom_access_shift                                            (8)
+#define PCIE_DBI_CTR_dbi_rom_access_mask                                             (0x00000100)
+#define PCIE_DBI_CTR_dbi_rom_access(data)                                            (0x00000100&((data)<<8))
+#define PCIE_DBI_CTR_dbi_rom_access_src(data)                                        ((0x00000100&(data))>>8)
+#define PCIE_DBI_CTR_get_dbi_rom_access(data)                                        ((0x00000100&(data))>>8)
+#define PCIE_DBI_CTR_dbi_bar_num_shift                                               (5)
+#define PCIE_DBI_CTR_dbi_bar_num_mask                                                (0x000000E0)
+#define PCIE_DBI_CTR_dbi_bar_num(data)                                               (0x000000E0&((data)<<5))
+#define PCIE_DBI_CTR_dbi_bar_num_src(data)                                           ((0x000000E0&(data))>>5)
+#define PCIE_DBI_CTR_get_dbi_bar_num(data)                                           ((0x000000E0&(data))>>5)
+#define PCIE_DBI_CTR_dbi_func_num_shift                                              (2)
+#define PCIE_DBI_CTR_dbi_func_num_mask                                               (0x0000001C)
+#define PCIE_DBI_CTR_dbi_func_num(data)                                              (0x0000001C&((data)<<2))
+#define PCIE_DBI_CTR_dbi_func_num_src(data)                                          ((0x0000001C&(data))>>2)
+#define PCIE_DBI_CTR_get_dbi_func_num(data)                                          ((0x0000001C&(data))>>2)
+#define PCIE_DBI_CTR_dbi_cs2_access_shift                                            (1)
+#define PCIE_DBI_CTR_dbi_cs2_access_mask                                             (0x00000002)
+#define PCIE_DBI_CTR_dbi_cs2_access(data)                                            (0x00000002&((data)<<1))
+#define PCIE_DBI_CTR_dbi_cs2_access_src(data)                                        ((0x00000002&(data))>>1)
+#define PCIE_DBI_CTR_get_dbi_cs2_access(data)                                        ((0x00000002&(data))>>1)
+#define PCIE_DBI_CTR_dbi_cmd_access_shift                                            (0)
+#define PCIE_DBI_CTR_dbi_cmd_access_mask                                             (0x00000001)
+#define PCIE_DBI_CTR_dbi_cmd_access(data)                                            (0x00000001&((data)<<0))
+#define PCIE_DBI_CTR_dbi_cmd_access_src(data)                                        ((0x00000001&(data))>>0)
+#define PCIE_DBI_CTR_get_dbi_cmd_access(data)                                        ((0x00000001&(data))>>0)
+
+
+#define PCIE_INDIR_CTR                                                               0x18017A14
+#define PCIE_INDIR_CTR_reg_addr                                                      "0xB8017A14"
+#define PCIE_INDIR_CTR_reg                                                           0xB8017A14
+#define set_PCIE_INDIR_CTR_reg(data)   (*((volatile unsigned int*) PCIE_INDIR_CTR_reg)=data)
+#define get_PCIE_INDIR_CTR_reg   (*((volatile unsigned int*) PCIE_INDIR_CTR_reg))
+#define PCIE_INDIR_CTR_inst_adr                                                      "0x0085"
+#define PCIE_INDIR_CTR_inst                                                          0x0085
+#define PCIE_INDIR_CTR_req_info_align_shift                                          (13)
+#define PCIE_INDIR_CTR_req_info_align_mask                                           (0x00002000)
+#define PCIE_INDIR_CTR_req_info_align(data)                                          (0x00002000&((data)<<13))
+#define PCIE_INDIR_CTR_req_info_align_src(data)                                      ((0x00002000&(data))>>13)
+#define PCIE_INDIR_CTR_get_req_info_align(data)                                      ((0x00002000&(data))>>13)
+#define PCIE_INDIR_CTR_req_info_attr_shift                                           (11)
+#define PCIE_INDIR_CTR_req_info_attr_mask                                            (0x00001800)
+#define PCIE_INDIR_CTR_req_info_attr(data)                                           (0x00001800&((data)<<11))
+#define PCIE_INDIR_CTR_req_info_attr_src(data)                                       ((0x00001800&(data))>>11)
+#define PCIE_INDIR_CTR_get_req_info_attr(data)                                       ((0x00001800&(data))>>11)
+#define PCIE_INDIR_CTR_req_info_ep_shift                                             (10)
+#define PCIE_INDIR_CTR_req_info_ep_mask                                              (0x00000400)
+#define PCIE_INDIR_CTR_req_info_ep(data)                                             (0x00000400&((data)<<10))
+#define PCIE_INDIR_CTR_req_info_ep_src(data)                                         ((0x00000400&(data))>>10)
+#define PCIE_INDIR_CTR_get_req_info_ep(data)                                         ((0x00000400&(data))>>10)
+#define PCIE_INDIR_CTR_req_info_tc_shift                                             (7)
+#define PCIE_INDIR_CTR_req_info_tc_mask                                              (0x00000380)
+#define PCIE_INDIR_CTR_req_info_tc(data)                                             (0x00000380&((data)<<7))
+#define PCIE_INDIR_CTR_req_info_tc_src(data)                                         ((0x00000380&(data))>>7)
+#define PCIE_INDIR_CTR_get_req_info_tc(data)                                         ((0x00000380&(data))>>7)
+#define PCIE_INDIR_CTR_req_info_type_shift                                           (2)
+#define PCIE_INDIR_CTR_req_info_type_mask                                            (0x0000007C)
+#define PCIE_INDIR_CTR_req_info_type(data)                                           (0x0000007C&((data)<<2))
+#define PCIE_INDIR_CTR_req_info_type_src(data)                                       ((0x0000007C&(data))>>2)
+#define PCIE_INDIR_CTR_get_req_info_type(data)                                       ((0x0000007C&(data))>>2)
+#define PCIE_INDIR_CTR_req_info_fmt_shift                                            (0)
+#define PCIE_INDIR_CTR_req_info_fmt_mask                                             (0x00000003)
+#define PCIE_INDIR_CTR_req_info_fmt(data)                                            (0x00000003&((data)<<0))
+#define PCIE_INDIR_CTR_req_info_fmt_src(data)                                        ((0x00000003&(data))>>0)
+#define PCIE_INDIR_CTR_get_req_info_fmt(data)                                        ((0x00000003&(data))>>0)
+
+
+#define PCIE_DIR_CTR                                                                 0x18017A18
+#define PCIE_DIR_CTR_reg_addr                                                        "0xB8017A18"
+#define PCIE_DIR_CTR_reg                                                             0xB8017A18
+#define set_PCIE_DIR_CTR_reg(data)   (*((volatile unsigned int*) PCIE_DIR_CTR_reg)=data)
+#define get_PCIE_DIR_CTR_reg   (*((volatile unsigned int*) PCIE_DIR_CTR_reg))
+#define PCIE_DIR_CTR_inst_adr                                                        "0x0086"
+#define PCIE_DIR_CTR_inst                                                            0x0086
+#define PCIE_DIR_CTR_req_info_align_shift                                            (13)
+#define PCIE_DIR_CTR_req_info_align_mask                                             (0x00002000)
+#define PCIE_DIR_CTR_req_info_align(data)                                            (0x00002000&((data)<<13))
+#define PCIE_DIR_CTR_req_info_align_src(data)                                        ((0x00002000&(data))>>13)
+#define PCIE_DIR_CTR_get_req_info_align(data)                                        ((0x00002000&(data))>>13)
+#define PCIE_DIR_CTR_req_info_attr_shift                                             (11)
+#define PCIE_DIR_CTR_req_info_attr_mask                                              (0x00001800)
+#define PCIE_DIR_CTR_req_info_attr(data)                                             (0x00001800&((data)<<11))
+#define PCIE_DIR_CTR_req_info_attr_src(data)                                         ((0x00001800&(data))>>11)
+#define PCIE_DIR_CTR_get_req_info_attr(data)                                         ((0x00001800&(data))>>11)
+#define PCIE_DIR_CTR_req_info_ep_shift                                               (10)
+#define PCIE_DIR_CTR_req_info_ep_mask                                                (0x00000400)
+#define PCIE_DIR_CTR_req_info_ep(data)                                               (0x00000400&((data)<<10))
+#define PCIE_DIR_CTR_req_info_ep_src(data)                                           ((0x00000400&(data))>>10)
+#define PCIE_DIR_CTR_get_req_info_ep(data)                                           ((0x00000400&(data))>>10)
+#define PCIE_DIR_CTR_req_info_tc_shift                                               (7)
+#define PCIE_DIR_CTR_req_info_tc_mask                                                (0x00000380)
+#define PCIE_DIR_CTR_req_info_tc(data)                                               (0x00000380&((data)<<7))
+#define PCIE_DIR_CTR_req_info_tc_src(data)                                           ((0x00000380&(data))>>7)
+#define PCIE_DIR_CTR_get_req_info_tc(data)                                           ((0x00000380&(data))>>7)
+#define PCIE_DIR_CTR_req_info_type_shift                                             (2)
+#define PCIE_DIR_CTR_req_info_type_mask                                              (0x0000007C)
+#define PCIE_DIR_CTR_req_info_type(data)                                             (0x0000007C&((data)<<2))
+#define PCIE_DIR_CTR_req_info_type_src(data)                                         ((0x0000007C&(data))>>2)
+#define PCIE_DIR_CTR_get_req_info_type(data)                                         ((0x0000007C&(data))>>2)
+#define PCIE_DIR_CTR_req_info_fmt_shift                                              (0)
+#define PCIE_DIR_CTR_req_info_fmt_mask                                               (0x00000003)
+#define PCIE_DIR_CTR_req_info_fmt(data)                                              (0x00000003&((data)<<0))
+#define PCIE_DIR_CTR_req_info_fmt_src(data)                                          ((0x00000003&(data))>>0)
+#define PCIE_DIR_CTR_get_req_info_fmt(data)                                          ((0x00000003&(data))>>0)
+
+
+#define PCIE_MDIO_CTR                                                                0x18017A1C
+#define PCIE_MDIO_CTR_reg_addr                                                       "0xB8017A1C"
+#define PCIE_MDIO_CTR_reg                                                            0xB8017A1C
+#define set_PCIE_MDIO_CTR_reg(data)   (*((volatile unsigned int*) PCIE_MDIO_CTR_reg)=data)
+#define get_PCIE_MDIO_CTR_reg   (*((volatile unsigned int*) PCIE_MDIO_CTR_reg))
+#define PCIE_MDIO_CTR_inst_adr                                                       "0x0087"
+#define PCIE_MDIO_CTR_inst                                                           0x0087
+#define PCIE_MDIO_CTR_data_shift                                                     (16)
+#define PCIE_MDIO_CTR_data_mask                                                      (0xFFFF0000)
+#define PCIE_MDIO_CTR_data(data)                                                     (0xFFFF0000&((data)<<16))
+#define PCIE_MDIO_CTR_data_src(data)                                                 ((0xFFFF0000&(data))>>16)
+#define PCIE_MDIO_CTR_get_data(data)                                                 ((0xFFFF0000&(data))>>16)
+#define PCIE_MDIO_CTR_phy_addr_shift                                                 (13)
+#define PCIE_MDIO_CTR_phy_addr_mask                                                  (0x0000E000)
+#define PCIE_MDIO_CTR_phy_addr(data)                                                 (0x0000E000&((data)<<13))
+#define PCIE_MDIO_CTR_phy_addr_src(data)                                             ((0x0000E000&(data))>>13)
+#define PCIE_MDIO_CTR_get_phy_addr(data)                                             ((0x0000E000&(data))>>13)
+#define PCIE_MDIO_CTR_phy_reg_addr_shift                                             (8)
+#define PCIE_MDIO_CTR_phy_reg_addr_mask                                              (0x00001F00)
+#define PCIE_MDIO_CTR_phy_reg_addr(data)                                             (0x00001F00&((data)<<8))
+#define PCIE_MDIO_CTR_phy_reg_addr_src(data)                                         ((0x00001F00&(data))>>8)
+#define PCIE_MDIO_CTR_get_phy_reg_addr(data)                                         ((0x00001F00&(data))>>8)
+#define PCIE_MDIO_CTR_mdio_busy_shift                                                (7)
+#define PCIE_MDIO_CTR_mdio_busy_mask                                                 (0x00000080)
+#define PCIE_MDIO_CTR_mdio_busy(data)                                                (0x00000080&((data)<<7))
+#define PCIE_MDIO_CTR_mdio_busy_src(data)                                            ((0x00000080&(data))>>7)
+#define PCIE_MDIO_CTR_get_mdio_busy(data)                                            ((0x00000080&(data))>>7)
+#define PCIE_MDIO_CTR_mdio_st_shift                                                  (5)
+#define PCIE_MDIO_CTR_mdio_st_mask                                                   (0x00000060)
+#define PCIE_MDIO_CTR_mdio_st(data)                                                  (0x00000060&((data)<<5))
+#define PCIE_MDIO_CTR_mdio_st_src(data)                                              ((0x00000060&(data))>>5)
+#define PCIE_MDIO_CTR_get_mdio_st(data)                                              ((0x00000060&(data))>>5)
+#define PCIE_MDIO_CTR_mdio_rdy_shift                                                 (4)
+#define PCIE_MDIO_CTR_mdio_rdy_mask                                                  (0x00000010)
+#define PCIE_MDIO_CTR_mdio_rdy(data)                                                 (0x00000010&((data)<<4))
+#define PCIE_MDIO_CTR_mdio_rdy_src(data)                                             ((0x00000010&(data))>>4)
+#define PCIE_MDIO_CTR_get_mdio_rdy(data)                                             ((0x00000010&(data))>>4)
+#define PCIE_MDIO_CTR_mclk_rate_shift                                                (2)
+#define PCIE_MDIO_CTR_mclk_rate_mask                                                 (0x0000000C)
+#define PCIE_MDIO_CTR_mclk_rate(data)                                                (0x0000000C&((data)<<2))
+#define PCIE_MDIO_CTR_mclk_rate_src(data)                                            ((0x0000000C&(data))>>2)
+#define PCIE_MDIO_CTR_get_mclk_rate(data)                                            ((0x0000000C&(data))>>2)
+#define PCIE_MDIO_CTR_mdio_srst_shift                                                (1)
+#define PCIE_MDIO_CTR_mdio_srst_mask                                                 (0x00000002)
+#define PCIE_MDIO_CTR_mdio_srst(data)                                                (0x00000002&((data)<<1))
+#define PCIE_MDIO_CTR_mdio_srst_src(data)                                            ((0x00000002&(data))>>1)
+#define PCIE_MDIO_CTR_get_mdio_srst(data)                                            ((0x00000002&(data))>>1)
+#define PCIE_MDIO_CTR_mdio_rdwr_shift                                                (0)
+#define PCIE_MDIO_CTR_mdio_rdwr_mask                                                 (0x00000001)
+#define PCIE_MDIO_CTR_mdio_rdwr(data)                                                (0x00000001&((data)<<0))
+#define PCIE_MDIO_CTR_mdio_rdwr_src(data)                                            ((0x00000001&(data))>>0)
+#define PCIE_MDIO_CTR_get_mdio_rdwr(data)                                            ((0x00000001&(data))>>0)
+
+
+#define PCIE_PCIE_BASE0                                                              0x18017A20
+#define PCIE_PCIE_BASE0_reg_addr                                                     "0xB8017A20"
+#define PCIE_PCIE_BASE0_reg                                                          0xB8017A20
+#define set_PCIE_PCIE_BASE0_reg(data)   (*((volatile unsigned int*) PCIE_PCIE_BASE0_reg)=data)
+#define get_PCIE_PCIE_BASE0_reg   (*((volatile unsigned int*) PCIE_PCIE_BASE0_reg))
+#define PCIE_PCIE_BASE0_inst_adr                                                     "0x0088"
+#define PCIE_PCIE_BASE0_inst                                                         0x0088
+#define PCIE_PCIE_BASE0_rtrans_base_addr_shift                                       (0)
+#define PCIE_PCIE_BASE0_rtrans_base_addr_mask                                        (0xFFFFFFFF)
+#define PCIE_PCIE_BASE0_rtrans_base_addr(data)                                       (0xFFFFFFFF&((data)<<0))
+#define PCIE_PCIE_BASE0_rtrans_base_addr_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define PCIE_PCIE_BASE0_get_rtrans_base_addr(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_PCIE_BASE1                                                              0x18017A24
+#define PCIE_PCIE_BASE1_reg_addr                                                     "0xB8017A24"
+#define PCIE_PCIE_BASE1_reg                                                          0xB8017A24
+#define set_PCIE_PCIE_BASE1_reg(data)   (*((volatile unsigned int*) PCIE_PCIE_BASE1_reg)=data)
+#define get_PCIE_PCIE_BASE1_reg   (*((volatile unsigned int*) PCIE_PCIE_BASE1_reg))
+#define PCIE_PCIE_BASE1_inst_adr                                                     "0x0089"
+#define PCIE_PCIE_BASE1_inst                                                         0x0089
+#define PCIE_PCIE_BASE1_rtrans_base_addr_shift                                       (0)
+#define PCIE_PCIE_BASE1_rtrans_base_addr_mask                                        (0xFFFFFFFF)
+#define PCIE_PCIE_BASE1_rtrans_base_addr(data)                                       (0xFFFFFFFF&((data)<<0))
+#define PCIE_PCIE_BASE1_rtrans_base_addr_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define PCIE_PCIE_BASE1_get_rtrans_base_addr(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_PCIE_MASK0                                                              0x18017A28
+#define PCIE_PCIE_MASK0_reg_addr                                                     "0xB8017A28"
+#define PCIE_PCIE_MASK0_reg                                                          0xB8017A28
+#define set_PCIE_PCIE_MASK0_reg(data)   (*((volatile unsigned int*) PCIE_PCIE_MASK0_reg)=data)
+#define get_PCIE_PCIE_MASK0_reg   (*((volatile unsigned int*) PCIE_PCIE_MASK0_reg))
+#define PCIE_PCIE_MASK0_inst_adr                                                     "0x008A"
+#define PCIE_PCIE_MASK0_inst                                                         0x008A
+#define PCIE_PCIE_MASK0_rtrans_mask_shift                                            (0)
+#define PCIE_PCIE_MASK0_rtrans_mask_mask                                             (0xFFFFFFFF)
+#define PCIE_PCIE_MASK0_rtrans_mask(data)                                            (0xFFFFFFFF&((data)<<0))
+#define PCIE_PCIE_MASK0_rtrans_mask_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define PCIE_PCIE_MASK0_get_rtrans_mask(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_PCIE_MASK1                                                              0x18017A2C
+#define PCIE_PCIE_MASK1_reg_addr                                                     "0xB8017A2C"
+#define PCIE_PCIE_MASK1_reg                                                          0xB8017A2C
+#define set_PCIE_PCIE_MASK1_reg(data)   (*((volatile unsigned int*) PCIE_PCIE_MASK1_reg)=data)
+#define get_PCIE_PCIE_MASK1_reg   (*((volatile unsigned int*) PCIE_PCIE_MASK1_reg))
+#define PCIE_PCIE_MASK1_inst_adr                                                     "0x008B"
+#define PCIE_PCIE_MASK1_inst                                                         0x008B
+#define PCIE_PCIE_MASK1_rtrans_mask_shift                                            (0)
+#define PCIE_PCIE_MASK1_rtrans_mask_mask                                             (0xFFFFFFFF)
+#define PCIE_PCIE_MASK1_rtrans_mask(data)                                            (0xFFFFFFFF&((data)<<0))
+#define PCIE_PCIE_MASK1_rtrans_mask_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define PCIE_PCIE_MASK1_get_rtrans_mask(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_PCIE_TRAN0                                                              0x18017A30
+#define PCIE_PCIE_TRAN0_reg_addr                                                     "0xB8017A30"
+#define PCIE_PCIE_TRAN0_reg                                                          0xB8017A30
+#define set_PCIE_PCIE_TRAN0_reg(data)   (*((volatile unsigned int*) PCIE_PCIE_TRAN0_reg)=data)
+#define get_PCIE_PCIE_TRAN0_reg   (*((volatile unsigned int*) PCIE_PCIE_TRAN0_reg))
+#define PCIE_PCIE_TRAN0_inst_adr                                                     "0x008C"
+#define PCIE_PCIE_TRAN0_inst                                                         0x008C
+#define PCIE_PCIE_TRAN0_rtrans_addr_in_shift                                         (0)
+#define PCIE_PCIE_TRAN0_rtrans_addr_in_mask                                          (0xFFFFFFFF)
+#define PCIE_PCIE_TRAN0_rtrans_addr_in(data)                                         (0xFFFFFFFF&((data)<<0))
+#define PCIE_PCIE_TRAN0_rtrans_addr_in_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define PCIE_PCIE_TRAN0_get_rtrans_addr_in(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_PCIE_TRAN1                                                              0x18017A34
+#define PCIE_PCIE_TRAN1_reg_addr                                                     "0xB8017A34"
+#define PCIE_PCIE_TRAN1_reg                                                          0xB8017A34
+#define set_PCIE_PCIE_TRAN1_reg(data)   (*((volatile unsigned int*) PCIE_PCIE_TRAN1_reg)=data)
+#define get_PCIE_PCIE_TRAN1_reg   (*((volatile unsigned int*) PCIE_PCIE_TRAN1_reg))
+#define PCIE_PCIE_TRAN1_inst_adr                                                     "0x008D"
+#define PCIE_PCIE_TRAN1_inst                                                         0x008D
+#define PCIE_PCIE_TRAN1_rtrans_addr_in_shift                                         (0)
+#define PCIE_PCIE_TRAN1_rtrans_addr_in_mask                                          (0xFFFFFFFF)
+#define PCIE_PCIE_TRAN1_rtrans_addr_in(data)                                         (0xFFFFFFFF&((data)<<0))
+#define PCIE_PCIE_TRAN1_rtrans_addr_in_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define PCIE_PCIE_TRAN1_get_rtrans_addr_in(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_CFG_CT                                                                  0x18017A38
+#define PCIE_CFG_CT_reg_addr                                                         "0xB8017A38"
+#define PCIE_CFG_CT_reg                                                              0xB8017A38
+#define set_PCIE_CFG_CT_reg(data)   (*((volatile unsigned int*) PCIE_CFG_CT_reg)=data)
+#define get_PCIE_CFG_CT_reg   (*((volatile unsigned int*) PCIE_CFG_CT_reg))
+#define PCIE_CFG_CT_inst_adr                                                         "0x008E"
+#define PCIE_CFG_CT_inst                                                             0x008E
+#define PCIE_CFG_CT_go_ct_shift                                                      (0)
+#define PCIE_CFG_CT_go_ct_mask                                                       (0x00000001)
+#define PCIE_CFG_CT_go_ct(data)                                                      (0x00000001&((data)<<0))
+#define PCIE_CFG_CT_go_ct_src(data)                                                  ((0x00000001&(data))>>0)
+#define PCIE_CFG_CT_get_go_ct(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define PCIE_CFG_EN                                                                  0x18017A3C
+#define PCIE_CFG_EN_reg_addr                                                         "0xB8017A3C"
+#define PCIE_CFG_EN_reg                                                              0xB8017A3C
+#define set_PCIE_CFG_EN_reg(data)   (*((volatile unsigned int*) PCIE_CFG_EN_reg)=data)
+#define get_PCIE_CFG_EN_reg   (*((volatile unsigned int*) PCIE_CFG_EN_reg))
+#define PCIE_CFG_EN_inst_adr                                                         "0x008F"
+#define PCIE_CFG_EN_inst                                                             0x008F
+#define PCIE_CFG_EN_bus_num_shift                                                    (16)
+#define PCIE_CFG_EN_bus_num_mask                                                     (0x00FF0000)
+#define PCIE_CFG_EN_bus_num(data)                                                    (0x00FF0000&((data)<<16))
+#define PCIE_CFG_EN_bus_num_src(data)                                                ((0x00FF0000&(data))>>16)
+#define PCIE_CFG_EN_get_bus_num(data)                                                ((0x00FF0000&(data))>>16)
+#define PCIE_CFG_EN_dev_num_shift                                                    (11)
+#define PCIE_CFG_EN_dev_num_mask                                                     (0x0000F800)
+#define PCIE_CFG_EN_dev_num(data)                                                    (0x0000F800&((data)<<11))
+#define PCIE_CFG_EN_dev_num_src(data)                                                ((0x0000F800&(data))>>11)
+#define PCIE_CFG_EN_get_dev_num(data)                                                ((0x0000F800&(data))>>11)
+#define PCIE_CFG_EN_fun_num_shift                                                    (8)
+#define PCIE_CFG_EN_fun_num_mask                                                     (0x00000700)
+#define PCIE_CFG_EN_fun_num(data)                                                    (0x00000700&((data)<<8))
+#define PCIE_CFG_EN_fun_num_src(data)                                                ((0x00000700&(data))>>8)
+#define PCIE_CFG_EN_get_fun_num(data)                                                ((0x00000700&(data))>>8)
+#define PCIE_CFG_EN_byte_cnt_shift                                                   (4)
+#define PCIE_CFG_EN_byte_cnt_mask                                                    (0x000000F0)
+#define PCIE_CFG_EN_byte_cnt(data)                                                   (0x000000F0&((data)<<4))
+#define PCIE_CFG_EN_byte_cnt_src(data)                                               ((0x000000F0&(data))>>4)
+#define PCIE_CFG_EN_get_byte_cnt(data)                                               ((0x000000F0&(data))>>4)
+#define PCIE_CFG_EN_error_en_shift                                                   (2)
+#define PCIE_CFG_EN_error_en_mask                                                    (0x00000004)
+#define PCIE_CFG_EN_error_en(data)                                                   (0x00000004&((data)<<2))
+#define PCIE_CFG_EN_error_en_src(data)                                               ((0x00000004&(data))>>2)
+#define PCIE_CFG_EN_get_error_en(data)                                               ((0x00000004&(data))>>2)
+#define PCIE_CFG_EN_byte_en_shift                                                    (1)
+#define PCIE_CFG_EN_byte_en_mask                                                     (0x00000002)
+#define PCIE_CFG_EN_byte_en(data)                                                    (0x00000002&((data)<<1))
+#define PCIE_CFG_EN_byte_en_src(data)                                                ((0x00000002&(data))>>1)
+#define PCIE_CFG_EN_get_byte_en(data)                                                ((0x00000002&(data))>>1)
+#define PCIE_CFG_EN_wrrd_en_shift                                                    (0)
+#define PCIE_CFG_EN_wrrd_en_mask                                                     (0x00000001)
+#define PCIE_CFG_EN_wrrd_en(data)                                                    (0x00000001&((data)<<0))
+#define PCIE_CFG_EN_wrrd_en_src(data)                                                ((0x00000001&(data))>>0)
+#define PCIE_CFG_EN_get_wrrd_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define PCIE_CFG_ST                                                                  0x18017A40
+#define PCIE_CFG_ST_reg_addr                                                         "0xB8017A40"
+#define PCIE_CFG_ST_reg                                                              0xB8017A40
+#define set_PCIE_CFG_ST_reg(data)   (*((volatile unsigned int*) PCIE_CFG_ST_reg)=data)
+#define get_PCIE_CFG_ST_reg   (*((volatile unsigned int*) PCIE_CFG_ST_reg))
+#define PCIE_CFG_ST_inst_adr                                                         "0x0090"
+#define PCIE_CFG_ST_inst                                                             0x0090
+#define PCIE_CFG_ST_error_st_shift                                                   (1)
+#define PCIE_CFG_ST_error_st_mask                                                    (0x00000002)
+#define PCIE_CFG_ST_error_st(data)                                                   (0x00000002&((data)<<1))
+#define PCIE_CFG_ST_error_st_src(data)                                               ((0x00000002&(data))>>1)
+#define PCIE_CFG_ST_get_error_st(data)                                               ((0x00000002&(data))>>1)
+#define PCIE_CFG_ST_done_st_shift                                                    (0)
+#define PCIE_CFG_ST_done_st_mask                                                     (0x00000001)
+#define PCIE_CFG_ST_done_st(data)                                                    (0x00000001&((data)<<0))
+#define PCIE_CFG_ST_done_st_src(data)                                                ((0x00000001&(data))>>0)
+#define PCIE_CFG_ST_get_done_st(data)                                                ((0x00000001&(data))>>0)
+
+
+#define PCIE_CFG_ADDR                                                                0x18017A44
+#define PCIE_CFG_ADDR_reg_addr                                                       "0xB8017A44"
+#define PCIE_CFG_ADDR_reg                                                            0xB8017A44
+#define set_PCIE_CFG_ADDR_reg(data)   (*((volatile unsigned int*) PCIE_CFG_ADDR_reg)=data)
+#define get_PCIE_CFG_ADDR_reg   (*((volatile unsigned int*) PCIE_CFG_ADDR_reg))
+#define PCIE_CFG_ADDR_inst_adr                                                       "0x0091"
+#define PCIE_CFG_ADDR_inst                                                           0x0091
+#define PCIE_CFG_ADDR_space_addr_shift                                               (0)
+#define PCIE_CFG_ADDR_space_addr_mask                                                (0xFFFFFFFF)
+#define PCIE_CFG_ADDR_space_addr(data)                                               (0xFFFFFFFF&((data)<<0))
+#define PCIE_CFG_ADDR_space_addr_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define PCIE_CFG_ADDR_get_space_addr(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_CFG_WDATA                                                               0x18017A48
+#define PCIE_CFG_WDATA_reg_addr                                                      "0xB8017A48"
+#define PCIE_CFG_WDATA_reg                                                           0xB8017A48
+#define set_PCIE_CFG_WDATA_reg(data)   (*((volatile unsigned int*) PCIE_CFG_WDATA_reg)=data)
+#define get_PCIE_CFG_WDATA_reg   (*((volatile unsigned int*) PCIE_CFG_WDATA_reg))
+#define PCIE_CFG_WDATA_inst_adr                                                      "0x0092"
+#define PCIE_CFG_WDATA_inst                                                          0x0092
+#define PCIE_CFG_WDATA_space_wdata_shift                                             (0)
+#define PCIE_CFG_WDATA_space_wdata_mask                                              (0xFFFFFFFF)
+#define PCIE_CFG_WDATA_space_wdata(data)                                             (0xFFFFFFFF&((data)<<0))
+#define PCIE_CFG_WDATA_space_wdata_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define PCIE_CFG_WDATA_get_space_wdata(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_CFG_RDATA                                                               0x18017A4C
+#define PCIE_CFG_RDATA_reg_addr                                                      "0xB8017A4C"
+#define PCIE_CFG_RDATA_reg                                                           0xB8017A4C
+#define set_PCIE_CFG_RDATA_reg(data)   (*((volatile unsigned int*) PCIE_CFG_RDATA_reg)=data)
+#define get_PCIE_CFG_RDATA_reg   (*((volatile unsigned int*) PCIE_CFG_RDATA_reg))
+#define PCIE_CFG_RDATA_inst_adr                                                      "0x0093"
+#define PCIE_CFG_RDATA_inst                                                          0x0093
+#define PCIE_CFG_RDATA_space_rdata_shift                                             (0)
+#define PCIE_CFG_RDATA_space_rdata_mask                                              (0xFFFFFFFF)
+#define PCIE_CFG_RDATA_space_rdata(data)                                             (0xFFFFFFFF&((data)<<0))
+#define PCIE_CFG_RDATA_space_rdata_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define PCIE_CFG_RDATA_get_space_rdata(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_MIO_CT                                                                  0x18017A50
+#define PCIE_MIO_CT_reg_addr                                                         "0xB8017A50"
+#define PCIE_MIO_CT_reg                                                              0xB8017A50
+#define set_PCIE_MIO_CT_reg(data)   (*((volatile unsigned int*) PCIE_MIO_CT_reg)=data)
+#define get_PCIE_MIO_CT_reg   (*((volatile unsigned int*) PCIE_MIO_CT_reg))
+#define PCIE_MIO_CT_inst_adr                                                         "0x0094"
+#define PCIE_MIO_CT_inst                                                             0x0094
+#define PCIE_MIO_CT_go_ct_shift                                                      (0)
+#define PCIE_MIO_CT_go_ct_mask                                                       (0x00000001)
+#define PCIE_MIO_CT_go_ct(data)                                                      (0x00000001&((data)<<0))
+#define PCIE_MIO_CT_go_ct_src(data)                                                  ((0x00000001&(data))>>0)
+#define PCIE_MIO_CT_get_go_ct(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define PCIE_MIO_ST                                                                  0x18017A54
+#define PCIE_MIO_ST_reg_addr                                                         "0xB8017A54"
+#define PCIE_MIO_ST_reg                                                              0xB8017A54
+#define set_PCIE_MIO_ST_reg(data)   (*((volatile unsigned int*) PCIE_MIO_ST_reg)=data)
+#define get_PCIE_MIO_ST_reg   (*((volatile unsigned int*) PCIE_MIO_ST_reg))
+#define PCIE_MIO_ST_inst_adr                                                         "0x0095"
+#define PCIE_MIO_ST_inst                                                             0x0095
+#define PCIE_MIO_ST_error_st_shift                                                   (1)
+#define PCIE_MIO_ST_error_st_mask                                                    (0x00000002)
+#define PCIE_MIO_ST_error_st(data)                                                   (0x00000002&((data)<<1))
+#define PCIE_MIO_ST_error_st_src(data)                                               ((0x00000002&(data))>>1)
+#define PCIE_MIO_ST_get_error_st(data)                                               ((0x00000002&(data))>>1)
+#define PCIE_MIO_ST_done_st_shift                                                    (0)
+#define PCIE_MIO_ST_done_st_mask                                                     (0x00000001)
+#define PCIE_MIO_ST_done_st(data)                                                    (0x00000001&((data)<<0))
+#define PCIE_MIO_ST_done_st_src(data)                                                ((0x00000001&(data))>>0)
+#define PCIE_MIO_ST_get_done_st(data)                                                ((0x00000001&(data))>>0)
+
+
+#define PCIE_MIO_EN                                                                  0x18017A58
+#define PCIE_MIO_EN_reg_addr                                                         "0xB8017A58"
+#define PCIE_MIO_EN_reg                                                              0xB8017A58
+#define set_PCIE_MIO_EN_reg(data)   (*((volatile unsigned int*) PCIE_MIO_EN_reg)=data)
+#define get_PCIE_MIO_EN_reg   (*((volatile unsigned int*) PCIE_MIO_EN_reg))
+#define PCIE_MIO_EN_inst_adr                                                         "0x0096"
+#define PCIE_MIO_EN_inst                                                             0x0096
+#define PCIE_MIO_EN_timeout_cnt_value_shift                                          (8)
+#define PCIE_MIO_EN_timeout_cnt_value_mask                                           (0xFFFFFF00)
+#define PCIE_MIO_EN_timeout_cnt_value(data)                                          (0xFFFFFF00&((data)<<8))
+#define PCIE_MIO_EN_timeout_cnt_value_src(data)                                      ((0xFFFFFF00&(data))>>8)
+#define PCIE_MIO_EN_get_timeout_cnt_value(data)                                      ((0xFFFFFF00&(data))>>8)
+#define PCIE_MIO_EN_byte_cnt_shift                                                   (4)
+#define PCIE_MIO_EN_byte_cnt_mask                                                    (0x000000F0)
+#define PCIE_MIO_EN_byte_cnt(data)                                                   (0x000000F0&((data)<<4))
+#define PCIE_MIO_EN_byte_cnt_src(data)                                               ((0x000000F0&(data))>>4)
+#define PCIE_MIO_EN_get_byte_cnt(data)                                               ((0x000000F0&(data))>>4)
+#define PCIE_MIO_EN_error_en_shift                                                   (2)
+#define PCIE_MIO_EN_error_en_mask                                                    (0x00000004)
+#define PCIE_MIO_EN_error_en(data)                                                   (0x00000004&((data)<<2))
+#define PCIE_MIO_EN_error_en_src(data)                                               ((0x00000004&(data))>>2)
+#define PCIE_MIO_EN_get_error_en(data)                                               ((0x00000004&(data))>>2)
+#define PCIE_MIO_EN_byte_en_shift                                                    (1)
+#define PCIE_MIO_EN_byte_en_mask                                                     (0x00000002)
+#define PCIE_MIO_EN_byte_en(data)                                                    (0x00000002&((data)<<1))
+#define PCIE_MIO_EN_byte_en_src(data)                                                ((0x00000002&(data))>>1)
+#define PCIE_MIO_EN_get_byte_en(data)                                                ((0x00000002&(data))>>1)
+#define PCIE_MIO_EN_wrrd_en_shift                                                    (0)
+#define PCIE_MIO_EN_wrrd_en_mask                                                     (0x00000001)
+#define PCIE_MIO_EN_wrrd_en(data)                                                    (0x00000001&((data)<<0))
+#define PCIE_MIO_EN_wrrd_en_src(data)                                                ((0x00000001&(data))>>0)
+#define PCIE_MIO_EN_get_wrrd_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define PCIE_MIO_ADDR                                                                0x18017A5C
+#define PCIE_MIO_ADDR_reg_addr                                                       "0xB8017A5C"
+#define PCIE_MIO_ADDR_reg                                                            0xB8017A5C
+#define set_PCIE_MIO_ADDR_reg(data)   (*((volatile unsigned int*) PCIE_MIO_ADDR_reg)=data)
+#define get_PCIE_MIO_ADDR_reg   (*((volatile unsigned int*) PCIE_MIO_ADDR_reg))
+#define PCIE_MIO_ADDR_inst_adr                                                       "0x0097"
+#define PCIE_MIO_ADDR_inst                                                           0x0097
+#define PCIE_MIO_ADDR_pcie_addr_shift                                                (0)
+#define PCIE_MIO_ADDR_pcie_addr_mask                                                 (0xFFFFFFFF)
+#define PCIE_MIO_ADDR_pcie_addr(data)                                                (0xFFFFFFFF&((data)<<0))
+#define PCIE_MIO_ADDR_pcie_addr_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define PCIE_MIO_ADDR_get_pcie_addr(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_MIO_WDATA                                                               0x18017A60
+#define PCIE_MIO_WDATA_reg_addr                                                      "0xB8017A60"
+#define PCIE_MIO_WDATA_reg                                                           0xB8017A60
+#define set_PCIE_MIO_WDATA_reg(data)   (*((volatile unsigned int*) PCIE_MIO_WDATA_reg)=data)
+#define get_PCIE_MIO_WDATA_reg   (*((volatile unsigned int*) PCIE_MIO_WDATA_reg))
+#define PCIE_MIO_WDATA_inst_adr                                                      "0x0098"
+#define PCIE_MIO_WDATA_inst                                                          0x0098
+#define PCIE_MIO_WDATA_pcie_wdata_shift                                              (0)
+#define PCIE_MIO_WDATA_pcie_wdata_mask                                               (0xFFFFFFFF)
+#define PCIE_MIO_WDATA_pcie_wdata(data)                                              (0xFFFFFFFF&((data)<<0))
+#define PCIE_MIO_WDATA_pcie_wdata_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define PCIE_MIO_WDATA_get_pcie_wdata(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_MIO_RDATA                                                               0x18017A64
+#define PCIE_MIO_RDATA_reg_addr                                                      "0xB8017A64"
+#define PCIE_MIO_RDATA_reg                                                           0xB8017A64
+#define set_PCIE_MIO_RDATA_reg(data)   (*((volatile unsigned int*) PCIE_MIO_RDATA_reg)=data)
+#define get_PCIE_MIO_RDATA_reg   (*((volatile unsigned int*) PCIE_MIO_RDATA_reg))
+#define PCIE_MIO_RDATA_inst_adr                                                      "0x0099"
+#define PCIE_MIO_RDATA_inst                                                          0x0099
+#define PCIE_MIO_RDATA_pcie_rdata_shift                                              (0)
+#define PCIE_MIO_RDATA_pcie_rdata_mask                                               (0xFFFFFFFF)
+#define PCIE_MIO_RDATA_pcie_rdata(data)                                              (0xFFFFFFFF&((data)<<0))
+#define PCIE_MIO_RDATA_pcie_rdata_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define PCIE_MIO_RDATA_get_pcie_rdata(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_PHY_CTR                                                                 0x18017A68
+#define PCIE_PHY_CTR_reg_addr                                                        "0xB8017A68"
+#define PCIE_PHY_CTR_reg                                                             0xB8017A68
+#define set_PCIE_PHY_CTR_reg(data)   (*((volatile unsigned int*) PCIE_PHY_CTR_reg)=data)
+#define get_PCIE_PHY_CTR_reg   (*((volatile unsigned int*) PCIE_PHY_CTR_reg))
+#define PCIE_PHY_CTR_inst_adr                                                        "0x009A"
+#define PCIE_PHY_CTR_inst                                                            0x009A
+#define PCIE_PHY_CTR_RX50_LINK_shift                                                 (6)
+#define PCIE_PHY_CTR_RX50_LINK_mask                                                  (0x00000040)
+#define PCIE_PHY_CTR_RX50_LINK(data)                                                 (0x00000040&((data)<<6))
+#define PCIE_PHY_CTR_RX50_LINK_src(data)                                             ((0x00000040&(data))>>6)
+#define PCIE_PHY_CTR_get_RX50_LINK(data)                                             ((0x00000040&(data))>>6)
+#define PCIE_PHY_CTR_POW_PCIEX_shift                                                 (5)
+#define PCIE_PHY_CTR_POW_PCIEX_mask                                                  (0x00000020)
+#define PCIE_PHY_CTR_POW_PCIEX(data)                                                 (0x00000020&((data)<<5))
+#define PCIE_PHY_CTR_POW_PCIEX_src(data)                                             ((0x00000020&(data))>>5)
+#define PCIE_PHY_CTR_get_POW_PCIEX(data)                                             ((0x00000020&(data))>>5)
+#define PCIE_PHY_CTR_SEL0_125M_shift                                                 (4)
+#define PCIE_PHY_CTR_SEL0_125M_mask                                                  (0x00000010)
+#define PCIE_PHY_CTR_SEL0_125M(data)                                                 (0x00000010&((data)<<4))
+#define PCIE_PHY_CTR_SEL0_125M_src(data)                                             ((0x00000010&(data))>>4)
+#define PCIE_PHY_CTR_get_SEL0_125M(data)                                             ((0x00000010&(data))>>4)
+#define PCIE_PHY_CTR_REG_PLLDVR_shift                                                (1)
+#define PCIE_PHY_CTR_REG_PLLDVR_mask                                                 (0x0000000E)
+#define PCIE_PHY_CTR_REG_PLLDVR(data)                                                (0x0000000E&((data)<<1))
+#define PCIE_PHY_CTR_REG_PLLDVR_src(data)                                            ((0x0000000E&(data))>>1)
+#define PCIE_PHY_CTR_get_REG_PLLDVR(data)                                            ((0x0000000E&(data))>>1)
+#define PCIE_PHY_CTR_CLK_SEL_shift                                                   (0)
+#define PCIE_PHY_CTR_CLK_SEL_mask                                                    (0x00000001)
+#define PCIE_PHY_CTR_CLK_SEL(data)                                                   (0x00000001&((data)<<0))
+#define PCIE_PHY_CTR_CLK_SEL_src(data)                                               ((0x00000001&(data))>>0)
+#define PCIE_PHY_CTR_get_CLK_SEL(data)                                               ((0x00000001&(data))>>0)
+
+
+#define PCIE_PWR_CTR                                                                 0x18017A6C
+#define PCIE_PWR_CTR_reg_addr                                                        "0xB8017A6C"
+#define PCIE_PWR_CTR_reg                                                             0xB8017A6C
+#define set_PCIE_PWR_CTR_reg(data)   (*((volatile unsigned int*) PCIE_PWR_CTR_reg)=data)
+#define get_PCIE_PWR_CTR_reg   (*((volatile unsigned int*) PCIE_PWR_CTR_reg))
+#define PCIE_PWR_CTR_inst_adr                                                        "0x009B"
+#define PCIE_PWR_CTR_inst                                                            0x009B
+#define PCIE_PWR_CTR_app_pmxmt_turnoff_shift                                         (6)
+#define PCIE_PWR_CTR_app_pmxmt_turnoff_mask                                          (0x00000040)
+#define PCIE_PWR_CTR_app_pmxmt_turnoff(data)                                         (0x00000040&((data)<<6))
+#define PCIE_PWR_CTR_app_pmxmt_turnoff_src(data)                                     ((0x00000040&(data))>>6)
+#define PCIE_PWR_CTR_get_app_pmxmt_turnoff(data)                                     ((0x00000040&(data))>>6)
+#define PCIE_PWR_CTR_p1_clk_req_en_shift                                             (5)
+#define PCIE_PWR_CTR_p1_clk_req_en_mask                                              (0x00000020)
+#define PCIE_PWR_CTR_p1_clk_req_en(data)                                             (0x00000020&((data)<<5))
+#define PCIE_PWR_CTR_p1_clk_req_en_src(data)                                         ((0x00000020&(data))>>5)
+#define PCIE_PWR_CTR_get_p1_clk_req_en(data)                                         ((0x00000020&(data))>>5)
+#define PCIE_PWR_CTR_low_power_enable_shift                                          (4)
+#define PCIE_PWR_CTR_low_power_enable_mask                                           (0x00000010)
+#define PCIE_PWR_CTR_low_power_enable(data)                                          (0x00000010&((data)<<4))
+#define PCIE_PWR_CTR_low_power_enable_src(data)                                      ((0x00000010&(data))>>4)
+#define PCIE_PWR_CTR_get_low_power_enable(data)                                      ((0x00000010&(data))>>4)
+#define PCIE_PWR_CTR_sys_aux_pwr_det_shift                                           (3)
+#define PCIE_PWR_CTR_sys_aux_pwr_det_mask                                            (0x00000008)
+#define PCIE_PWR_CTR_sys_aux_pwr_det(data)                                           (0x00000008&((data)<<3))
+#define PCIE_PWR_CTR_sys_aux_pwr_det_src(data)                                       ((0x00000008&(data))>>3)
+#define PCIE_PWR_CTR_get_sys_aux_pwr_det(data)                                       ((0x00000008&(data))>>3)
+#define PCIE_PWR_CTR_app_ready_enter_123_shift                                       (2)
+#define PCIE_PWR_CTR_app_ready_enter_123_mask                                        (0x00000004)
+#define PCIE_PWR_CTR_app_ready_enter_123(data)                                       (0x00000004&((data)<<2))
+#define PCIE_PWR_CTR_app_ready_enter_123_src(data)                                   ((0x00000004&(data))>>2)
+#define PCIE_PWR_CTR_get_app_ready_enter_123(data)                                   ((0x00000004&(data))>>2)
+#define PCIE_PWR_CTR_app_req_exit_11_shift                                           (1)
+#define PCIE_PWR_CTR_app_req_exit_11_mask                                            (0x00000002)
+#define PCIE_PWR_CTR_app_req_exit_11(data)                                           (0x00000002&((data)<<1))
+#define PCIE_PWR_CTR_app_req_exit_11_src(data)                                       ((0x00000002&(data))>>1)
+#define PCIE_PWR_CTR_get_app_req_exit_11(data)                                       ((0x00000002&(data))>>1)
+#define PCIE_PWR_CTR_app_req_enter_11_shift                                          (0)
+#define PCIE_PWR_CTR_app_req_enter_11_mask                                           (0x00000001)
+#define PCIE_PWR_CTR_app_req_enter_11(data)                                          (0x00000001&((data)<<0))
+#define PCIE_PWR_CTR_app_req_enter_11_src(data)                                      ((0x00000001&(data))>>0)
+#define PCIE_PWR_CTR_get_app_req_enter_11(data)                                      ((0x00000001&(data))>>0)
+
+
+#define PCIE_PCIE_DBG                                                                0x18017A70
+#define PCIE_PCIE_DBG_reg_addr                                                       "0xB8017A70"
+#define PCIE_PCIE_DBG_reg                                                            0xB8017A70
+#define set_PCIE_PCIE_DBG_reg(data)   (*((volatile unsigned int*) PCIE_PCIE_DBG_reg)=data)
+#define get_PCIE_PCIE_DBG_reg   (*((volatile unsigned int*) PCIE_PCIE_DBG_reg))
+#define PCIE_PCIE_DBG_inst_adr                                                       "0x009C"
+#define PCIE_PCIE_DBG_inst                                                           0x009C
+#define PCIE_PCIE_DBG_dbg_sel1_shift                                                 (7)
+#define PCIE_PCIE_DBG_dbg_sel1_mask                                                  (0x00001F80)
+#define PCIE_PCIE_DBG_dbg_sel1(data)                                                 (0x00001F80&((data)<<7))
+#define PCIE_PCIE_DBG_dbg_sel1_src(data)                                             ((0x00001F80&(data))>>7)
+#define PCIE_PCIE_DBG_get_dbg_sel1(data)                                             ((0x00001F80&(data))>>7)
+#define PCIE_PCIE_DBG_dbg_sel0_shift                                                 (1)
+#define PCIE_PCIE_DBG_dbg_sel0_mask                                                  (0x0000007E)
+#define PCIE_PCIE_DBG_dbg_sel0(data)                                                 (0x0000007E&((data)<<1))
+#define PCIE_PCIE_DBG_dbg_sel0_src(data)                                             ((0x0000007E&(data))>>1)
+#define PCIE_PCIE_DBG_get_dbg_sel0(data)                                             ((0x0000007E&(data))>>1)
+#define PCIE_PCIE_DBG_dbg_en_shift                                                   (0)
+#define PCIE_PCIE_DBG_dbg_en_mask                                                    (0x00000001)
+#define PCIE_PCIE_DBG_dbg_en(data)                                                   (0x00000001&((data)<<0))
+#define PCIE_PCIE_DBG_dbg_en_src(data)                                               ((0x00000001&(data))>>0)
+#define PCIE_PCIE_DBG_get_dbg_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define PCIE_DIR_ST                                                                  0x18017A74
+#define PCIE_DIR_ST_reg_addr                                                         "0xB8017A74"
+#define PCIE_DIR_ST_reg                                                              0xB8017A74
+#define set_PCIE_DIR_ST_reg(data)   (*((volatile unsigned int*) PCIE_DIR_ST_reg)=data)
+#define get_PCIE_DIR_ST_reg   (*((volatile unsigned int*) PCIE_DIR_ST_reg))
+#define PCIE_DIR_ST_inst_adr                                                         "0x009D"
+#define PCIE_DIR_ST_inst                                                             0x009D
+#define PCIE_DIR_ST_cfg_rerror_st_shift                                              (1)
+#define PCIE_DIR_ST_cfg_rerror_st_mask                                               (0x00000002)
+#define PCIE_DIR_ST_cfg_rerror_st(data)                                              (0x00000002&((data)<<1))
+#define PCIE_DIR_ST_cfg_rerror_st_src(data)                                          ((0x00000002&(data))>>1)
+#define PCIE_DIR_ST_get_cfg_rerror_st(data)                                          ((0x00000002&(data))>>1)
+#define PCIE_DIR_ST_mio_rerror_st_shift                                              (0)
+#define PCIE_DIR_ST_mio_rerror_st_mask                                               (0x00000001)
+#define PCIE_DIR_ST_mio_rerror_st(data)                                              (0x00000001&((data)<<0))
+#define PCIE_DIR_ST_mio_rerror_st_src(data)                                          ((0x00000001&(data))>>0)
+#define PCIE_DIR_ST_get_mio_rerror_st(data)                                          ((0x00000001&(data))>>0)
+
+
+#define PCIE_DIR_EN                                                                  0x18017A78
+#define PCIE_DIR_EN_reg_addr                                                         "0xB8017A78"
+#define PCIE_DIR_EN_reg                                                              0xB8017A78
+#define set_PCIE_DIR_EN_reg(data)   (*((volatile unsigned int*) PCIE_DIR_EN_reg)=data)
+#define get_PCIE_DIR_EN_reg   (*((volatile unsigned int*) PCIE_DIR_EN_reg))
+#define PCIE_DIR_EN_inst_adr                                                         "0x009E"
+#define PCIE_DIR_EN_inst                                                             0x009E
+#define PCIE_DIR_EN_timeout_cnt_value_shift                                          (8)
+#define PCIE_DIR_EN_timeout_cnt_value_mask                                           (0xFFFFFF00)
+#define PCIE_DIR_EN_timeout_cnt_value(data)                                          (0xFFFFFF00&((data)<<8))
+#define PCIE_DIR_EN_timeout_cnt_value_src(data)                                      ((0xFFFFFF00&(data))>>8)
+#define PCIE_DIR_EN_get_timeout_cnt_value(data)                                      ((0xFFFFFF00&(data))>>8)
+#define PCIE_DIR_EN_timeout_en_shift                                                 (0)
+#define PCIE_DIR_EN_timeout_en_mask                                                  (0x00000001)
+#define PCIE_DIR_EN_timeout_en(data)                                                 (0x00000001&((data)<<0))
+#define PCIE_DIR_EN_timeout_en_src(data)                                             ((0x00000001&(data))>>0)
+#define PCIE_DIR_EN_get_timeout_en(data)                                             ((0x00000001&(data))>>0)
+
+
+#define PCIE_RCPL_ST                                                                 0x18017A7C
+#define PCIE_RCPL_ST_reg_addr                                                        "0xB8017A7C"
+#define PCIE_RCPL_ST_reg                                                             0xB8017A7C
+#define set_PCIE_RCPL_ST_reg(data)   (*((volatile unsigned int*) PCIE_RCPL_ST_reg)=data)
+#define get_PCIE_RCPL_ST_reg   (*((volatile unsigned int*) PCIE_RCPL_ST_reg))
+#define PCIE_RCPL_ST_inst_adr                                                        "0x009F"
+#define PCIE_RCPL_ST_inst                                                            0x009F
+#define PCIE_RCPL_ST_rcpl_status_shift                                               (5)
+#define PCIE_RCPL_ST_rcpl_status_mask                                                (0x000000E0)
+#define PCIE_RCPL_ST_rcpl_status(data)                                               (0x000000E0&((data)<<5))
+#define PCIE_RCPL_ST_rcpl_status_src(data)                                           ((0x000000E0&(data))>>5)
+#define PCIE_RCPL_ST_get_rcpl_status(data)                                           ((0x000000E0&(data))>>5)
+#define PCIE_RCPL_ST_rcpl_error_st_shift                                             (4)
+#define PCIE_RCPL_ST_rcpl_error_st_mask                                              (0x00000010)
+#define PCIE_RCPL_ST_rcpl_error_st(data)                                             (0x00000010&((data)<<4))
+#define PCIE_RCPL_ST_rcpl_error_st_src(data)                                         ((0x00000010&(data))>>4)
+#define PCIE_RCPL_ST_get_rcpl_error_st(data)                                         ((0x00000010&(data))>>4)
+#define PCIE_RCPL_ST_tlp_abort_st_shift                                              (3)
+#define PCIE_RCPL_ST_tlp_abort_st_mask                                               (0x00000008)
+#define PCIE_RCPL_ST_tlp_abort_st(data)                                              (0x00000008&((data)<<3))
+#define PCIE_RCPL_ST_tlp_abort_st_src(data)                                          ((0x00000008&(data))>>3)
+#define PCIE_RCPL_ST_get_tlp_abort_st(data)                                          ((0x00000008&(data))>>3)
+#define PCIE_RCPL_ST_dllp_abort_st_shift                                             (2)
+#define PCIE_RCPL_ST_dllp_abort_st_mask                                              (0x00000004)
+#define PCIE_RCPL_ST_dllp_abort_st(data)                                             (0x00000004&((data)<<2))
+#define PCIE_RCPL_ST_dllp_abort_st_src(data)                                         ((0x00000004&(data))>>2)
+#define PCIE_RCPL_ST_get_dllp_abort_st(data)                                         ((0x00000004&(data))>>2)
+#define PCIE_RCPL_ST_ecrc_error_st_shift                                             (1)
+#define PCIE_RCPL_ST_ecrc_error_st_mask                                              (0x00000002)
+#define PCIE_RCPL_ST_ecrc_error_st(data)                                             (0x00000002&((data)<<1))
+#define PCIE_RCPL_ST_ecrc_error_st_src(data)                                         ((0x00000002&(data))>>1)
+#define PCIE_RCPL_ST_get_ecrc_error_st(data)                                         ((0x00000002&(data))>>1)
+#define PCIE_RCPL_ST_rcpl_timeout_st_shift                                           (0)
+#define PCIE_RCPL_ST_rcpl_timeout_st_mask                                            (0x00000001)
+#define PCIE_RCPL_ST_rcpl_timeout_st(data)                                           (0x00000001&((data)<<0))
+#define PCIE_RCPL_ST_rcpl_timeout_st_src(data)                                       ((0x00000001&(data))>>0)
+#define PCIE_RCPL_ST_get_rcpl_timeout_st(data)                                       ((0x00000001&(data))>>0)
+
+
+#define PCIE_RCPL_ADR                                                                0x18017A80
+#define PCIE_RCPL_ADR_reg_addr                                                       "0xB8017A80"
+#define PCIE_RCPL_ADR_reg                                                            0xB8017A80
+#define set_PCIE_RCPL_ADR_reg(data)   (*((volatile unsigned int*) PCIE_RCPL_ADR_reg)=data)
+#define get_PCIE_RCPL_ADR_reg   (*((volatile unsigned int*) PCIE_RCPL_ADR_reg))
+#define PCIE_RCPL_ADR_inst_adr                                                       "0x00A0"
+#define PCIE_RCPL_ADR_inst                                                           0x00A0
+#define PCIE_RCPL_ADR_nor_error_addr_shift                                           (0)
+#define PCIE_RCPL_ADR_nor_error_addr_mask                                            (0xFFFFFFFF)
+#define PCIE_RCPL_ADR_nor_error_addr(data)                                           (0xFFFFFFFF&((data)<<0))
+#define PCIE_RCPL_ADR_nor_error_addr_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define PCIE_RCPL_ADR_get_nor_error_addr(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_RCPL_TOUT0                                                              0x18017A84
+#define PCIE_RCPL_TOUT0_reg_addr                                                     "0xB8017A84"
+#define PCIE_RCPL_TOUT0_reg                                                          0xB8017A84
+#define set_PCIE_RCPL_TOUT0_reg(data)   (*((volatile unsigned int*) PCIE_RCPL_TOUT0_reg)=data)
+#define get_PCIE_RCPL_TOUT0_reg   (*((volatile unsigned int*) PCIE_RCPL_TOUT0_reg))
+#define PCIE_RCPL_TOUT0_inst_adr                                                     "0x00A1"
+#define PCIE_RCPL_TOUT0_inst                                                         0x00A1
+#define PCIE_RCPL_TOUT0_to_error_addr_shift                                          (0)
+#define PCIE_RCPL_TOUT0_to_error_addr_mask                                           (0xFFFFFFFF)
+#define PCIE_RCPL_TOUT0_to_error_addr(data)                                          (0xFFFFFFFF&((data)<<0))
+#define PCIE_RCPL_TOUT0_to_error_addr_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define PCIE_RCPL_TOUT0_get_to_error_addr(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_RCPL_TOUT1                                                              0x18017A88
+#define PCIE_RCPL_TOUT1_reg_addr                                                     "0xB8017A88"
+#define PCIE_RCPL_TOUT1_reg                                                          0xB8017A88
+#define set_PCIE_RCPL_TOUT1_reg(data)   (*((volatile unsigned int*) PCIE_RCPL_TOUT1_reg)=data)
+#define get_PCIE_RCPL_TOUT1_reg   (*((volatile unsigned int*) PCIE_RCPL_TOUT1_reg))
+#define PCIE_RCPL_TOUT1_inst_adr                                                     "0x00A2"
+#define PCIE_RCPL_TOUT1_inst                                                         0x00A2
+#define PCIE_RCPL_TOUT1_timeout_num_shift                                            (29)
+#define PCIE_RCPL_TOUT1_timeout_num_mask                                             (0xE0000000)
+#define PCIE_RCPL_TOUT1_timeout_num(data)                                            (0xE0000000&((data)<<29))
+#define PCIE_RCPL_TOUT1_timeout_num_src(data)                                        ((0xE0000000&(data))>>29)
+#define PCIE_RCPL_TOUT1_get_timeout_num(data)                                        ((0xE0000000&(data))>>29)
+#define PCIE_RCPL_TOUT1_timeout_tc_shift                                             (26)
+#define PCIE_RCPL_TOUT1_timeout_tc_mask                                              (0x1C000000)
+#define PCIE_RCPL_TOUT1_timeout_tc(data)                                             (0x1C000000&((data)<<26))
+#define PCIE_RCPL_TOUT1_timeout_tc_src(data)                                         ((0x1C000000&(data))>>26)
+#define PCIE_RCPL_TOUT1_get_timeout_tc(data)                                         ((0x1C000000&(data))>>26)
+#define PCIE_RCPL_TOUT1_timeout_attr_shift                                           (24)
+#define PCIE_RCPL_TOUT1_timeout_attr_mask                                            (0x03000000)
+#define PCIE_RCPL_TOUT1_timeout_attr(data)                                           (0x03000000&((data)<<24))
+#define PCIE_RCPL_TOUT1_timeout_attr_src(data)                                       ((0x03000000&(data))>>24)
+#define PCIE_RCPL_TOUT1_get_timeout_attr(data)                                       ((0x03000000&(data))>>24)
+#define PCIE_RCPL_TOUT1_timeout_len_shift                                            (12)
+#define PCIE_RCPL_TOUT1_timeout_len_mask                                             (0x00FFF000)
+#define PCIE_RCPL_TOUT1_timeout_len(data)                                            (0x00FFF000&((data)<<12))
+#define PCIE_RCPL_TOUT1_timeout_len_src(data)                                        ((0x00FFF000&(data))>>12)
+#define PCIE_RCPL_TOUT1_get_timeout_len(data)                                        ((0x00FFF000&(data))>>12)
+#define PCIE_RCPL_TOUT1_timeout_tag_shift                                            (0)
+#define PCIE_RCPL_TOUT1_timeout_tag_mask                                             (0x000000FF)
+#define PCIE_RCPL_TOUT1_timeout_tag(data)                                            (0x000000FF&((data)<<0))
+#define PCIE_RCPL_TOUT1_timeout_tag_src(data)                                        ((0x000000FF&(data))>>0)
+#define PCIE_RCPL_TOUT1_get_timeout_tag(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define PCIE_RTGT_ST                                                                 0x18017A8C
+#define PCIE_RTGT_ST_reg_addr                                                        "0xB8017A8C"
+#define PCIE_RTGT_ST_reg                                                             0xB8017A8C
+#define set_PCIE_RTGT_ST_reg(data)   (*((volatile unsigned int*) PCIE_RTGT_ST_reg)=data)
+#define get_PCIE_RTGT_ST_reg   (*((volatile unsigned int*) PCIE_RTGT_ST_reg))
+#define PCIE_RTGT_ST_inst_adr                                                        "0x00A3"
+#define PCIE_RTGT_ST_inst                                                            0x00A3
+#define PCIE_RTGT_ST_rcpl_compl_st_shift                                             (4)
+#define PCIE_RTGT_ST_rcpl_compl_st_mask                                              (0x00000010)
+#define PCIE_RTGT_ST_rcpl_compl_st(data)                                             (0x00000010&((data)<<4))
+#define PCIE_RTGT_ST_rcpl_compl_st_src(data)                                         ((0x00000010&(data))>>4)
+#define PCIE_RTGT_ST_get_rcpl_compl_st(data)                                         ((0x00000010&(data))>>4)
+#define PCIE_RTGT_ST_tlp_abort_st_shift                                              (3)
+#define PCIE_RTGT_ST_tlp_abort_st_mask                                               (0x00000008)
+#define PCIE_RTGT_ST_tlp_abort_st(data)                                              (0x00000008&((data)<<3))
+#define PCIE_RTGT_ST_tlp_abort_st_src(data)                                          ((0x00000008&(data))>>3)
+#define PCIE_RTGT_ST_get_tlp_abort_st(data)                                          ((0x00000008&(data))>>3)
+#define PCIE_RTGT_ST_dllp_abort_st_shift                                             (2)
+#define PCIE_RTGT_ST_dllp_abort_st_mask                                              (0x00000004)
+#define PCIE_RTGT_ST_dllp_abort_st(data)                                             (0x00000004&((data)<<2))
+#define PCIE_RTGT_ST_dllp_abort_st_src(data)                                         ((0x00000004&(data))>>2)
+#define PCIE_RTGT_ST_get_dllp_abort_st(data)                                         ((0x00000004&(data))>>2)
+#define PCIE_RTGT_ST_ecrc_error_st_shift                                             (1)
+#define PCIE_RTGT_ST_ecrc_error_st_mask                                              (0x00000002)
+#define PCIE_RTGT_ST_ecrc_error_st(data)                                             (0x00000002&((data)<<1))
+#define PCIE_RTGT_ST_ecrc_error_st_src(data)                                         ((0x00000002&(data))>>1)
+#define PCIE_RTGT_ST_get_ecrc_error_st(data)                                         ((0x00000002&(data))>>1)
+#define PCIE_RTGT_ST_rcpl_timeout_st_shift                                           (0)
+#define PCIE_RTGT_ST_rcpl_timeout_st_mask                                            (0x00000001)
+#define PCIE_RTGT_ST_rcpl_timeout_st(data)                                           (0x00000001&((data)<<0))
+#define PCIE_RTGT_ST_rcpl_timeout_st_src(data)                                       ((0x00000001&(data))>>0)
+#define PCIE_RTGT_ST_get_rcpl_timeout_st(data)                                       ((0x00000001&(data))>>0)
+
+
+#define PCIE_RTGT_ADR                                                                0x18017A90
+#define PCIE_RTGT_ADR_reg_addr                                                       "0xB8017A90"
+#define PCIE_RTGT_ADR_reg                                                            0xB8017A90
+#define set_PCIE_RTGT_ADR_reg(data)   (*((volatile unsigned int*) PCIE_RTGT_ADR_reg)=data)
+#define get_PCIE_RTGT_ADR_reg   (*((volatile unsigned int*) PCIE_RTGT_ADR_reg))
+#define PCIE_RTGT_ADR_inst_adr                                                       "0x00A4"
+#define PCIE_RTGT_ADR_inst                                                           0x00A4
+#define PCIE_RTGT_ADR_nor_error_addr_shift                                           (0)
+#define PCIE_RTGT_ADR_nor_error_addr_mask                                            (0xFFFFFFFF)
+#define PCIE_RTGT_ADR_nor_error_addr(data)                                           (0xFFFFFFFF&((data)<<0))
+#define PCIE_RTGT_ADR_nor_error_addr_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define PCIE_RTGT_ADR_get_nor_error_addr(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_RTGT_TOUT0                                                              0x18017A94
+#define PCIE_RTGT_TOUT0_reg_addr                                                     "0xB8017A94"
+#define PCIE_RTGT_TOUT0_reg                                                          0xB8017A94
+#define set_PCIE_RTGT_TOUT0_reg(data)   (*((volatile unsigned int*) PCIE_RTGT_TOUT0_reg)=data)
+#define get_PCIE_RTGT_TOUT0_reg   (*((volatile unsigned int*) PCIE_RTGT_TOUT0_reg))
+#define PCIE_RTGT_TOUT0_inst_adr                                                     "0x00A5"
+#define PCIE_RTGT_TOUT0_inst                                                         0x00A5
+#define PCIE_RTGT_TOUT0_to_error_addr_shift                                          (0)
+#define PCIE_RTGT_TOUT0_to_error_addr_mask                                           (0xFFFFFFFF)
+#define PCIE_RTGT_TOUT0_to_error_addr(data)                                          (0xFFFFFFFF&((data)<<0))
+#define PCIE_RTGT_TOUT0_to_error_addr_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define PCIE_RTGT_TOUT0_get_to_error_addr(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_RTGT_TOUT1                                                              0x18017A98
+#define PCIE_RTGT_TOUT1_reg_addr                                                     "0xB8017A98"
+#define PCIE_RTGT_TOUT1_reg                                                          0xB8017A98
+#define set_PCIE_RTGT_TOUT1_reg(data)   (*((volatile unsigned int*) PCIE_RTGT_TOUT1_reg)=data)
+#define get_PCIE_RTGT_TOUT1_reg   (*((volatile unsigned int*) PCIE_RTGT_TOUT1_reg))
+#define PCIE_RTGT_TOUT1_inst_adr                                                     "0x00A6"
+#define PCIE_RTGT_TOUT1_inst                                                         0x00A6
+#define PCIE_RTGT_TOUT1_timeout_num_shift                                            (29)
+#define PCIE_RTGT_TOUT1_timeout_num_mask                                             (0xE0000000)
+#define PCIE_RTGT_TOUT1_timeout_num(data)                                            (0xE0000000&((data)<<29))
+#define PCIE_RTGT_TOUT1_timeout_num_src(data)                                        ((0xE0000000&(data))>>29)
+#define PCIE_RTGT_TOUT1_get_timeout_num(data)                                        ((0xE0000000&(data))>>29)
+#define PCIE_RTGT_TOUT1_timeout_tc_shift                                             (26)
+#define PCIE_RTGT_TOUT1_timeout_tc_mask                                              (0x1C000000)
+#define PCIE_RTGT_TOUT1_timeout_tc(data)                                             (0x1C000000&((data)<<26))
+#define PCIE_RTGT_TOUT1_timeout_tc_src(data)                                         ((0x1C000000&(data))>>26)
+#define PCIE_RTGT_TOUT1_get_timeout_tc(data)                                         ((0x1C000000&(data))>>26)
+#define PCIE_RTGT_TOUT1_timeout_attr_shift                                           (24)
+#define PCIE_RTGT_TOUT1_timeout_attr_mask                                            (0x03000000)
+#define PCIE_RTGT_TOUT1_timeout_attr(data)                                           (0x03000000&((data)<<24))
+#define PCIE_RTGT_TOUT1_timeout_attr_src(data)                                       ((0x03000000&(data))>>24)
+#define PCIE_RTGT_TOUT1_get_timeout_attr(data)                                       ((0x03000000&(data))>>24)
+#define PCIE_RTGT_TOUT1_timeout_len_shift                                            (12)
+#define PCIE_RTGT_TOUT1_timeout_len_mask                                             (0x00FFF000)
+#define PCIE_RTGT_TOUT1_timeout_len(data)                                            (0x00FFF000&((data)<<12))
+#define PCIE_RTGT_TOUT1_timeout_len_src(data)                                        ((0x00FFF000&(data))>>12)
+#define PCIE_RTGT_TOUT1_get_timeout_len(data)                                        ((0x00FFF000&(data))>>12)
+#define PCIE_RTGT_TOUT1_timeout_tag_shift                                            (0)
+#define PCIE_RTGT_TOUT1_timeout_tag_mask                                             (0x000000FF)
+#define PCIE_RTGT_TOUT1_timeout_tag(data)                                            (0x000000FF&((data)<<0))
+#define PCIE_RTGT_TOUT1_timeout_tag_src(data)                                        ((0x000000FF&(data))>>0)
+#define PCIE_RTGT_TOUT1_get_timeout_tag(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define PCIE_AERRO_ST                                                                0x18017A9C
+#define PCIE_AERRO_ST_reg_addr                                                       "0xB8017A9C"
+#define PCIE_AERRO_ST_reg                                                            0xB8017A9C
+#define set_PCIE_AERRO_ST_reg(data)   (*((volatile unsigned int*) PCIE_AERRO_ST_reg)=data)
+#define get_PCIE_AERRO_ST_reg   (*((volatile unsigned int*) PCIE_AERRO_ST_reg))
+#define PCIE_AERRO_ST_inst_adr                                                       "0x00A7"
+#define PCIE_AERRO_ST_inst                                                           0x00A7
+#define PCIE_AERRO_ST_cfg_sys_err_rc_shift                                           (0)
+#define PCIE_AERRO_ST_cfg_sys_err_rc_mask                                            (0x00000001)
+#define PCIE_AERRO_ST_cfg_sys_err_rc(data)                                           (0x00000001&((data)<<0))
+#define PCIE_AERRO_ST_cfg_sys_err_rc_src(data)                                       ((0x00000001&(data))>>0)
+#define PCIE_AERRO_ST_get_cfg_sys_err_rc(data)                                       ((0x00000001&(data))>>0)
+
+
+#define PCIE_AEMSI_ST                                                                0x18017AA0
+#define PCIE_AEMSI_ST_reg_addr                                                       "0xB8017AA0"
+#define PCIE_AEMSI_ST_reg                                                            0xB8017AA0
+#define set_PCIE_AEMSI_ST_reg(data)   (*((volatile unsigned int*) PCIE_AEMSI_ST_reg)=data)
+#define get_PCIE_AEMSI_ST_reg   (*((volatile unsigned int*) PCIE_AEMSI_ST_reg))
+#define PCIE_AEMSI_ST_inst_adr                                                       "0x00A8"
+#define PCIE_AEMSI_ST_inst                                                           0x00A8
+#define PCIE_AEMSI_ST_cfg_aer_int_msg_num_shift                                      (1)
+#define PCIE_AEMSI_ST_cfg_aer_int_msg_num_mask                                       (0x0000003E)
+#define PCIE_AEMSI_ST_cfg_aer_int_msg_num(data)                                      (0x0000003E&((data)<<1))
+#define PCIE_AEMSI_ST_cfg_aer_int_msg_num_src(data)                                  ((0x0000003E&(data))>>1)
+#define PCIE_AEMSI_ST_get_cfg_aer_int_msg_num(data)                                  ((0x0000003E&(data))>>1)
+#define PCIE_AEMSI_ST_cfg_aer_rc_err_msi_shift                                       (0)
+#define PCIE_AEMSI_ST_cfg_aer_rc_err_msi_mask                                        (0x00000001)
+#define PCIE_AEMSI_ST_cfg_aer_rc_err_msi(data)                                       (0x00000001&((data)<<0))
+#define PCIE_AEMSI_ST_cfg_aer_rc_err_msi_src(data)                                   ((0x00000001&(data))>>0)
+#define PCIE_AEMSI_ST_get_cfg_aer_rc_err_msi(data)                                   ((0x00000001&(data))>>0)
+
+
+#define PCIE_PME_ST                                                                  0x18017AA4
+#define PCIE_PME_ST_reg_addr                                                         "0xB8017AA4"
+#define PCIE_PME_ST_reg                                                              0xB8017AA4
+#define set_PCIE_PME_ST_reg(data)   (*((volatile unsigned int*) PCIE_PME_ST_reg)=data)
+#define get_PCIE_PME_ST_reg   (*((volatile unsigned int*) PCIE_PME_ST_reg))
+#define PCIE_PME_ST_inst_adr                                                         "0x00A9"
+#define PCIE_PME_ST_inst                                                             0x00A9
+#define PCIE_PME_ST_radm_pm_to_ack_shift                                             (0)
+#define PCIE_PME_ST_radm_pm_to_ack_mask                                              (0x00000001)
+#define PCIE_PME_ST_radm_pm_to_ack(data)                                             (0x00000001&((data)<<0))
+#define PCIE_PME_ST_radm_pm_to_ack_src(data)                                         ((0x00000001&(data))>>0)
+#define PCIE_PME_ST_get_radm_pm_to_ack(data)                                         ((0x00000001&(data))>>0)
+
+
+#define PCIE_PMMSI_ST                                                                0x18017AA8
+#define PCIE_PMMSI_ST_reg_addr                                                       "0xB8017AA8"
+#define PCIE_PMMSI_ST_reg                                                            0xB8017AA8
+#define set_PCIE_PMMSI_ST_reg(data)   (*((volatile unsigned int*) PCIE_PMMSI_ST_reg)=data)
+#define get_PCIE_PMMSI_ST_reg   (*((volatile unsigned int*) PCIE_PMMSI_ST_reg))
+#define PCIE_PMMSI_ST_inst_adr                                                       "0x00AA"
+#define PCIE_PMMSI_ST_inst                                                           0x00AA
+#define PCIE_PMMSI_ST_cfg_cap_int_msg_num_shift                                      (1)
+#define PCIE_PMMSI_ST_cfg_cap_int_msg_num_mask                                       (0x0000003E)
+#define PCIE_PMMSI_ST_cfg_cap_int_msg_num(data)                                      (0x0000003E&((data)<<1))
+#define PCIE_PMMSI_ST_cfg_cap_int_msg_num_src(data)                                  ((0x0000003E&(data))>>1)
+#define PCIE_PMMSI_ST_get_cfg_cap_int_msg_num(data)                                  ((0x0000003E&(data))>>1)
+#define PCIE_PMMSI_ST_cfg_pme_msi_shift                                              (0)
+#define PCIE_PMMSI_ST_cfg_pme_msi_mask                                               (0x00000001)
+#define PCIE_PMMSI_ST_cfg_pme_msi(data)                                              (0x00000001&((data)<<0))
+#define PCIE_PMMSI_ST_cfg_pme_msi_src(data)                                          ((0x00000001&(data))>>0)
+#define PCIE_PMMSI_ST_get_cfg_pme_msi(data)                                          ((0x00000001&(data))>>0)
+
+
+#define PCIE_VEN_MSG0                                                                0x18017AAC
+#define PCIE_VEN_MSG0_reg_addr                                                       "0xB8017AAC"
+#define PCIE_VEN_MSG0_reg                                                            0xB8017AAC
+#define set_PCIE_VEN_MSG0_reg(data)   (*((volatile unsigned int*) PCIE_VEN_MSG0_reg)=data)
+#define get_PCIE_VEN_MSG0_reg   (*((volatile unsigned int*) PCIE_VEN_MSG0_reg))
+#define PCIE_VEN_MSG0_inst_adr                                                       "0x00AB"
+#define PCIE_VEN_MSG0_inst                                                           0x00AB
+#define PCIE_VEN_MSG0_radm_msg_req_id_shift                                          (16)
+#define PCIE_VEN_MSG0_radm_msg_req_id_mask                                           (0xFFFF0000)
+#define PCIE_VEN_MSG0_radm_msg_req_id(data)                                          (0xFFFF0000&((data)<<16))
+#define PCIE_VEN_MSG0_radm_msg_req_id_src(data)                                      ((0xFFFF0000&(data))>>16)
+#define PCIE_VEN_MSG0_get_radm_msg_req_id(data)                                      ((0xFFFF0000&(data))>>16)
+#define PCIE_VEN_MSG0_radm_vendor_msg_shift                                          (0)
+#define PCIE_VEN_MSG0_radm_vendor_msg_mask                                           (0x00000001)
+#define PCIE_VEN_MSG0_radm_vendor_msg(data)                                          (0x00000001&((data)<<0))
+#define PCIE_VEN_MSG0_radm_vendor_msg_src(data)                                      ((0x00000001&(data))>>0)
+#define PCIE_VEN_MSG0_get_radm_vendor_msg(data)                                      ((0x00000001&(data))>>0)
+
+
+#define PCIE_VEN_MSG1                                                                0x18017AB0
+#define PCIE_VEN_MSG1_reg_addr                                                       "0xB8017AB0"
+#define PCIE_VEN_MSG1_reg                                                            0xB8017AB0
+#define set_PCIE_VEN_MSG1_reg(data)   (*((volatile unsigned int*) PCIE_VEN_MSG1_reg)=data)
+#define get_PCIE_VEN_MSG1_reg   (*((volatile unsigned int*) PCIE_VEN_MSG1_reg))
+#define PCIE_VEN_MSG1_inst_adr                                                       "0x00AC"
+#define PCIE_VEN_MSG1_inst                                                           0x00AC
+#define PCIE_VEN_MSG1_radm_msg_payload_shift                                         (0)
+#define PCIE_VEN_MSG1_radm_msg_payload_mask                                          (0xFFFFFFFF)
+#define PCIE_VEN_MSG1_radm_msg_payload(data)                                         (0xFFFFFFFF&((data)<<0))
+#define PCIE_VEN_MSG1_radm_msg_payload_src(data)                                     ((0xFFFFFFFF&(data))>>0)
+#define PCIE_VEN_MSG1_get_radm_msg_payload(data)                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_MAC_ST                                                                  0x18017AB4
+#define PCIE_MAC_ST_reg_addr                                                         "0xB8017AB4"
+#define PCIE_MAC_ST_reg                                                              0xB8017AB4
+#define set_PCIE_MAC_ST_reg(data)   (*((volatile unsigned int*) PCIE_MAC_ST_reg)=data)
+#define get_PCIE_MAC_ST_reg   (*((volatile unsigned int*) PCIE_MAC_ST_reg))
+#define PCIE_MAC_ST_inst_adr                                                         "0x00AD"
+#define PCIE_MAC_ST_inst                                                             0x00AD
+#define PCIE_MAC_ST_rdlh_link_up_shift                                               (14)
+#define PCIE_MAC_ST_rdlh_link_up_mask                                                (0x00004000)
+#define PCIE_MAC_ST_rdlh_link_up(data)                                               (0x00004000&((data)<<14))
+#define PCIE_MAC_ST_rdlh_link_up_src(data)                                           ((0x00004000&(data))>>14)
+#define PCIE_MAC_ST_get_rdlh_link_up(data)                                           ((0x00004000&(data))>>14)
+#define PCIE_MAC_ST_pm_xtlh_block_tlp_shift                                          (13)
+#define PCIE_MAC_ST_pm_xtlh_block_tlp_mask                                           (0x00002000)
+#define PCIE_MAC_ST_pm_xtlh_block_tlp(data)                                          (0x00002000&((data)<<13))
+#define PCIE_MAC_ST_pm_xtlh_block_tlp_src(data)                                      ((0x00002000&(data))>>13)
+#define PCIE_MAC_ST_get_pm_xtlh_block_tlp(data)                                      ((0x00002000&(data))>>13)
+#define PCIE_MAC_ST_cfg_bus_master_en_shift                                          (12)
+#define PCIE_MAC_ST_cfg_bus_master_en_mask                                           (0x00001000)
+#define PCIE_MAC_ST_cfg_bus_master_en(data)                                          (0x00001000&((data)<<12))
+#define PCIE_MAC_ST_cfg_bus_master_en_src(data)                                      ((0x00001000&(data))>>12)
+#define PCIE_MAC_ST_get_cfg_bus_master_en(data)                                      ((0x00001000&(data))>>12)
+#define PCIE_MAC_ST_cfg_pm_no_soft_rst_shift                                         (11)
+#define PCIE_MAC_ST_cfg_pm_no_soft_rst_mask                                          (0x00000800)
+#define PCIE_MAC_ST_cfg_pm_no_soft_rst(data)                                         (0x00000800&((data)<<11))
+#define PCIE_MAC_ST_cfg_pm_no_soft_rst_src(data)                                     ((0x00000800&(data))>>11)
+#define PCIE_MAC_ST_get_cfg_pm_no_soft_rst(data)                                     ((0x00000800&(data))>>11)
+#define PCIE_MAC_ST_xmlh_link_up_shift                                               (10)
+#define PCIE_MAC_ST_xmlh_link_up_mask                                                (0x00000400)
+#define PCIE_MAC_ST_xmlh_link_up(data)                                               (0x00000400&((data)<<10))
+#define PCIE_MAC_ST_xmlh_link_up_src(data)                                           ((0x00000400&(data))>>10)
+#define PCIE_MAC_ST_get_xmlh_link_up(data)                                           ((0x00000400&(data))>>10)
+#define PCIE_MAC_ST_link_req_rst_not_shift                                           (9)
+#define PCIE_MAC_ST_link_req_rst_not_mask                                            (0x00000200)
+#define PCIE_MAC_ST_link_req_rst_not(data)                                           (0x00000200&((data)<<9))
+#define PCIE_MAC_ST_link_req_rst_not_src(data)                                       ((0x00000200&(data))>>9)
+#define PCIE_MAC_ST_get_link_req_rst_not(data)                                       ((0x00000200&(data))>>9)
+#define PCIE_MAC_ST_xmlh_ltssm_state_shift                                           (4)
+#define PCIE_MAC_ST_xmlh_ltssm_state_mask                                            (0x000001F0)
+#define PCIE_MAC_ST_xmlh_ltssm_state(data)                                           (0x000001F0&((data)<<4))
+#define PCIE_MAC_ST_xmlh_ltssm_state_src(data)                                       ((0x000001F0&(data))>>4)
+#define PCIE_MAC_ST_get_xmlh_ltssm_state(data)                                       ((0x000001F0&(data))>>4)
+#define PCIE_MAC_ST_pm_curnt_state_shift                                             (1)
+#define PCIE_MAC_ST_pm_curnt_state_mask                                              (0x0000000E)
+#define PCIE_MAC_ST_pm_curnt_state(data)                                             (0x0000000E&((data)<<1))
+#define PCIE_MAC_ST_pm_curnt_state_src(data)                                         ((0x0000000E&(data))>>1)
+#define PCIE_MAC_ST_get_pm_curnt_state(data)                                         ((0x0000000E&(data))>>1)
+#define PCIE_MAC_ST_clk_req_n_shift                                                  (0)
+#define PCIE_MAC_ST_clk_req_n_mask                                                   (0x00000001)
+#define PCIE_MAC_ST_clk_req_n(data)                                                  (0x00000001&((data)<<0))
+#define PCIE_MAC_ST_clk_req_n_src(data)                                              ((0x00000001&(data))>>0)
+#define PCIE_MAC_ST_get_clk_req_n(data)                                              ((0x00000001&(data))>>0)
+
+
+#define PCIE_UNLOCK_MSG                                                              0x18017AB8
+#define PCIE_UNLOCK_MSG_reg_addr                                                     "0xB8017AB8"
+#define PCIE_UNLOCK_MSG_reg                                                          0xB8017AB8
+#define set_PCIE_UNLOCK_MSG_reg(data)   (*((volatile unsigned int*) PCIE_UNLOCK_MSG_reg)=data)
+#define get_PCIE_UNLOCK_MSG_reg   (*((volatile unsigned int*) PCIE_UNLOCK_MSG_reg))
+#define PCIE_UNLOCK_MSG_inst_adr                                                     "0x00AE"
+#define PCIE_UNLOCK_MSG_inst                                                         0x00AE
+#define PCIE_UNLOCK_MSG_unlock_msg_trigger_shift                                     (0)
+#define PCIE_UNLOCK_MSG_unlock_msg_trigger_mask                                      (0x00000001)
+#define PCIE_UNLOCK_MSG_unlock_msg_trigger(data)                                     (0x00000001&((data)<<0))
+#define PCIE_UNLOCK_MSG_unlock_msg_trigger_src(data)                                 ((0x00000001&(data))>>0)
+#define PCIE_UNLOCK_MSG_get_unlock_msg_trigger(data)                                 ((0x00000001&(data))>>0)
+
+
+#define PCIE_SCTCH                                                                   0x18017ABC
+#define PCIE_SCTCH_reg_addr                                                          "0xB8017ABC"
+#define PCIE_SCTCH_reg                                                               0xB8017ABC
+#define set_PCIE_SCTCH_reg(data)   (*((volatile unsigned int*) PCIE_SCTCH_reg)=data)
+#define get_PCIE_SCTCH_reg   (*((volatile unsigned int*) PCIE_SCTCH_reg))
+#define PCIE_SCTCH_inst_adr                                                          "0x00AF"
+#define PCIE_SCTCH_inst                                                              0x00AF
+#define PCIE_SCTCH_reg1_shift                                                        (16)
+#define PCIE_SCTCH_reg1_mask                                                         (0xFFFF0000)
+#define PCIE_SCTCH_reg1(data)                                                        (0xFFFF0000&((data)<<16))
+#define PCIE_SCTCH_reg1_src(data)                                                    ((0xFFFF0000&(data))>>16)
+#define PCIE_SCTCH_get_reg1(data)                                                    ((0xFFFF0000&(data))>>16)
+#define PCIE_SCTCH_reg0_shift                                                        (0)
+#define PCIE_SCTCH_reg0_mask                                                         (0x0000FFFF)
+#define PCIE_SCTCH_reg0(data)                                                        (0x0000FFFF&((data)<<0))
+#define PCIE_SCTCH_reg0_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define PCIE_SCTCH_get_reg0(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define PCIE_LOOP_DATA_0                                                             0x18017AC0
+#define PCIE_LOOP_DATA_1                                                             0x18017AC4
+#define PCIE_LOOP_DATA_2                                                             0x18017AC8
+#define PCIE_LOOP_DATA_3                                                             0x18017ACC
+#define PCIE_LOOP_DATA_0_reg_addr                                                    "0xB8017AC0"
+#define PCIE_LOOP_DATA_1_reg_addr                                                    "0xB8017AC4"
+#define PCIE_LOOP_DATA_2_reg_addr                                                    "0xB8017AC8"
+#define PCIE_LOOP_DATA_3_reg_addr                                                    "0xB8017ACC"
+#define PCIE_LOOP_DATA_0_reg                                                         0xB8017AC0
+#define PCIE_LOOP_DATA_1_reg                                                         0xB8017AC4
+#define PCIE_LOOP_DATA_2_reg                                                         0xB8017AC8
+#define PCIE_LOOP_DATA_3_reg                                                         0xB8017ACC
+#define set_PCIE_LOOP_DATA_0_reg(data)   (*((volatile unsigned int*) PCIE_LOOP_DATA_0_reg)=data)
+#define set_PCIE_LOOP_DATA_1_reg(data)   (*((volatile unsigned int*) PCIE_LOOP_DATA_1_reg)=data)
+#define set_PCIE_LOOP_DATA_2_reg(data)   (*((volatile unsigned int*) PCIE_LOOP_DATA_2_reg)=data)
+#define set_PCIE_LOOP_DATA_3_reg(data)   (*((volatile unsigned int*) PCIE_LOOP_DATA_3_reg)=data)
+#define get_PCIE_LOOP_DATA_0_reg   (*((volatile unsigned int*) PCIE_LOOP_DATA_0_reg))
+#define get_PCIE_LOOP_DATA_1_reg   (*((volatile unsigned int*) PCIE_LOOP_DATA_1_reg))
+#define get_PCIE_LOOP_DATA_2_reg   (*((volatile unsigned int*) PCIE_LOOP_DATA_2_reg))
+#define get_PCIE_LOOP_DATA_3_reg   (*((volatile unsigned int*) PCIE_LOOP_DATA_3_reg))
+#define PCIE_LOOP_DATA_0_inst_adr                                                    "0x00B0"
+#define PCIE_LOOP_DATA_1_inst_adr                                                    "0x00B1"
+#define PCIE_LOOP_DATA_2_inst_adr                                                    "0x00B2"
+#define PCIE_LOOP_DATA_3_inst_adr                                                    "0x00B3"
+#define PCIE_LOOP_DATA_0_inst                                                        0x00B0
+#define PCIE_LOOP_DATA_1_inst                                                        0x00B1
+#define PCIE_LOOP_DATA_2_inst                                                        0x00B2
+#define PCIE_LOOP_DATA_3_inst                                                        0x00B3
+#define PCIE_LOOP_DATA_rw_data_shift                                                 (0)
+#define PCIE_LOOP_DATA_rw_data_mask                                                  (0xFFFFFFFF)
+#define PCIE_LOOP_DATA_rw_data(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define PCIE_LOOP_DATA_rw_data_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define PCIE_LOOP_DATA_get_rw_data(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define PCIE_MSI_TRAN                                                                0x18017AD0
+#define PCIE_MSI_TRAN_reg_addr                                                       "0xB8017AD0"
+#define PCIE_MSI_TRAN_reg                                                            0xB8017AD0
+#define set_PCIE_MSI_TRAN_reg(data)   (*((volatile unsigned int*) PCIE_MSI_TRAN_reg)=data)
+#define get_PCIE_MSI_TRAN_reg   (*((volatile unsigned int*) PCIE_MSI_TRAN_reg))
+#define PCIE_MSI_TRAN_inst_adr                                                       "0x00B4"
+#define PCIE_MSI_TRAN_inst                                                           0x00B4
+#define PCIE_MSI_TRAN_msi_check_addr_shift                                           (2)
+#define PCIE_MSI_TRAN_msi_check_addr_mask                                            (0xFFFFFFFC)
+#define PCIE_MSI_TRAN_msi_check_addr(data)                                           (0xFFFFFFFC&((data)<<2))
+#define PCIE_MSI_TRAN_msi_check_addr_src(data)                                       ((0xFFFFFFFC&(data))>>2)
+#define PCIE_MSI_TRAN_get_msi_check_addr(data)                                       ((0xFFFFFFFC&(data))>>2)
+
+
+#define PCIE_MSI_DATA                                                                0x18017AD4
+#define PCIE_MSI_DATA_reg_addr                                                       "0xB8017AD4"
+#define PCIE_MSI_DATA_reg                                                            0xB8017AD4
+#define set_PCIE_MSI_DATA_reg(data)   (*((volatile unsigned int*) PCIE_MSI_DATA_reg)=data)
+#define get_PCIE_MSI_DATA_reg   (*((volatile unsigned int*) PCIE_MSI_DATA_reg))
+#define PCIE_MSI_DATA_inst_adr                                                       "0x00B5"
+#define PCIE_MSI_DATA_inst                                                           0x00B5
+#define PCIE_MSI_DATA_msi_data_st_shift                                              (16)
+#define PCIE_MSI_DATA_msi_data_st_mask                                               (0x00010000)
+#define PCIE_MSI_DATA_msi_data_st(data)                                              (0x00010000&((data)<<16))
+#define PCIE_MSI_DATA_msi_data_st_src(data)                                          ((0x00010000&(data))>>16)
+#define PCIE_MSI_DATA_get_msi_data_st(data)                                          ((0x00010000&(data))>>16)
+#define PCIE_MSI_DATA_msi_data_shift                                                 (0)
+#define PCIE_MSI_DATA_msi_data_mask                                                  (0x0000FFFF)
+#define PCIE_MSI_DATA_msi_data(data)                                                 (0x0000FFFF&((data)<<0))
+#define PCIE_MSI_DATA_msi_data_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define PCIE_MSI_DATA_get_msi_data(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define PCIE_TMP_REG_0                                                               0x18017AD8
+#define PCIE_TMP_REG_1                                                               0x18017ADC
+#define PCIE_TMP_REG_2                                                               0x18017AE0
+#define PCIE_TMP_REG_3                                                               0x18017AE4
+#define PCIE_TMP_REG_0_reg_addr                                                      "0xB8017AD8"
+#define PCIE_TMP_REG_1_reg_addr                                                      "0xB8017ADC"
+#define PCIE_TMP_REG_2_reg_addr                                                      "0xB8017AE0"
+#define PCIE_TMP_REG_3_reg_addr                                                      "0xB8017AE4"
+#define PCIE_TMP_REG_0_reg                                                           0xB8017AD8
+#define PCIE_TMP_REG_1_reg                                                           0xB8017ADC
+#define PCIE_TMP_REG_2_reg                                                           0xB8017AE0
+#define PCIE_TMP_REG_3_reg                                                           0xB8017AE4
+#define set_PCIE_TMP_REG_0_reg(data)   (*((volatile unsigned int*) PCIE_TMP_REG_0_reg)=data)
+#define set_PCIE_TMP_REG_1_reg(data)   (*((volatile unsigned int*) PCIE_TMP_REG_1_reg)=data)
+#define set_PCIE_TMP_REG_2_reg(data)   (*((volatile unsigned int*) PCIE_TMP_REG_2_reg)=data)
+#define set_PCIE_TMP_REG_3_reg(data)   (*((volatile unsigned int*) PCIE_TMP_REG_3_reg)=data)
+#define get_PCIE_TMP_REG_0_reg   (*((volatile unsigned int*) PCIE_TMP_REG_0_reg))
+#define get_PCIE_TMP_REG_1_reg   (*((volatile unsigned int*) PCIE_TMP_REG_1_reg))
+#define get_PCIE_TMP_REG_2_reg   (*((volatile unsigned int*) PCIE_TMP_REG_2_reg))
+#define get_PCIE_TMP_REG_3_reg   (*((volatile unsigned int*) PCIE_TMP_REG_3_reg))
+#define PCIE_TMP_REG_0_inst_adr                                                      "0x00B6"
+#define PCIE_TMP_REG_1_inst_adr                                                      "0x00B7"
+#define PCIE_TMP_REG_2_inst_adr                                                      "0x00B8"
+#define PCIE_TMP_REG_3_inst_adr                                                      "0x00B9"
+#define PCIE_TMP_REG_0_inst                                                          0x00B6
+#define PCIE_TMP_REG_1_inst                                                          0x00B7
+#define PCIE_TMP_REG_2_inst                                                          0x00B8
+#define PCIE_TMP_REG_3_inst                                                          0x00B9
+#define PCIE_TMP_REG_test_reg_shift                                                  (0)
+#define PCIE_TMP_REG_test_reg_mask                                                   (0xFFFFFFFF)
+#define PCIE_TMP_REG_test_reg(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define PCIE_TMP_REG_test_reg_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define PCIE_TMP_REG_get_test_reg(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/predblk_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/predblk_reg.h
new file mode 100644
index 00000000..650dcdf
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/predblk_reg.h
@@ -0,0 +1,1687 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/6/22 11:40:33
+***************************************************************/
+
+
+#ifndef _PREDBLK_REG_H_INCLUDED_
+#define _PREDBLK_REG_H_INCLUDED_
+#ifdef  _PREDBLK_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     Nhmem_Flush:1;
+unsigned int     RMEM_Rst:1;
+unsigned int     Deblk_xsfer_mode:1;
+unsigned int     Debug_mode:1;
+unsigned int     fmo:1;
+unsigned int     reserved_1:4;
+unsigned int     Softrst_disable:1;
+unsigned int     New_slice_row:1;
+unsigned int     New_slice_mb_x:9;
+unsigned int     Sw_neighbor_enable:1;
+unsigned int     MbAddrA_available:1;
+unsigned int     MbAddrB_available:1;
+unsigned int     MbAddrC_available:1;
+unsigned int     MbAddrD_available:1;
+}PREDBLK_NEIGHBOR;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     ic_mix_fcm_enable:1;
+unsigned int     CONDOVER:2;
+unsigned int     Rnd_ctrl_ovt:1;
+unsigned int     RND:1;
+unsigned int     INTCOMP:1;
+unsigned int     LUMSCALE0:6;
+unsigned int     LUMSHIFT0:6;
+}PREDBLK_VC1INTC1;
+
+typedef struct 
+{
+unsigned int     Ic_pass0_of_fwd:4;
+unsigned int     Ic_pass1_of_fwd:4;
+unsigned int     Ic_pass0_sf_fwd:4;
+unsigned int     Ic_pass1_sf_fwd:4;
+unsigned int     Ic_pass0_of_bwd:4;
+unsigned int     Ic_pass1_of_bwd:4;
+unsigned int     Ic_pass0_sf_bwd:4;
+unsigned int     Ic_pass1_sf_bwd:4;
+}PREDBLK_VC1INTC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     LUMSCALE1:6;
+unsigned int     LUMSHIFT1:6;
+unsigned int     LUMSCALE2:6;
+unsigned int     LUMSHIFT2:6;
+}PREDBLK_VC1INTC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     LUMSCALE3:6;
+unsigned int     LUMSHIFT3:6;
+unsigned int     LUMSCALE4:6;
+unsigned int     LUMSHIFT4:6;
+}PREDBLK_VC1INTC4;
+
+typedef struct 
+{
+unsigned int     intra_flag:32;
+}PREDBLK_NBINTRA0;
+
+typedef struct 
+{
+unsigned int     intra_flag:32;
+}PREDBLK_NBINTRA1;
+
+typedef struct 
+{
+unsigned int     intra_flag:32;
+}PREDBLK_NBINTRACH;
+
+typedef struct 
+{
+unsigned int     Field_overflag_flag:32;
+}PREDBLK_NBFIELDOV;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     Intra0:1;
+unsigned int     Intra1:1;
+unsigned int     IntraChroma:1;
+unsigned int     IntraField:1;
+}PREDBLK_NBEXTRA;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     WTBL_StartA:10;
+}PREDBLK_WTBLSA;
+
+typedef struct 
+{
+unsigned int     wt_flag:32;
+}PREDBLK_WTFLAG;
+
+typedef struct 
+{
+unsigned int     Wdone_enable:1;
+unsigned int     Mem_eng_busy:1;
+unsigned int     reserved_0:1;
+unsigned int     seq_line_addr:29;
+}PREDBLK_SDMAADR;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     Value:28;
+}PREDBLK_INTR_THRESH;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     Reach_Thresh:1;
+unsigned int     Count:28;
+}PREDBLK_BUSY;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     BaseA0:7;
+unsigned int     reserved_1:6;
+unsigned int     BaseA1:7;
+unsigned int     reserved_2:3;
+}PREDBLK_BASEA;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     OffsetA:7;
+unsigned int     reserved_1:3;
+}PREDBLK_OFFSETA;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     StartA:7;
+}PREDBLK_DEBPAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     Rounding_Control:1;
+unsigned int     Quarter_Sample:1;
+}PREDBLK_MPEGCTL;
+
+typedef struct 
+{
+unsigned int     Valid:1;
+unsigned int     reserved_0:2;
+unsigned int     Base_addr:26;
+unsigned int     reserved_1:3;
+}PREDBLK_RMEMDDR1;
+
+typedef struct 
+{
+unsigned int     MBCnt_threshold:32;
+}PREDBLK_RMEMDDR2;
+
+typedef struct 
+{
+unsigned int     Valid:1;
+unsigned int     reserved_0:17;
+unsigned int     Start_Addr:7;
+unsigned int     End_Addr:7;
+}PREDBLK_RMEMCTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     URatio:15;
+}PREDBLK_URATIO;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     VP6_1:1;
+unsigned int     AutoSelectPMFlag:1;
+unsigned int     BicubicFiltFlag:1;
+unsigned int     Sample_var_thresh:10;
+unsigned int     Max_vec_length:9;
+unsigned int     Bicubic_filt_sel:4;
+}PREDBLK_VP6CTRL;
+
+typedef struct 
+{
+unsigned int     GenPulse:1;
+unsigned int     PicCount:14;
+unsigned int     MbAddrX:9;
+unsigned int     MbAddrY:8;
+}PREDBLK_DBUS;
+
+typedef struct 
+{
+unsigned int     DbgCtrl:32;
+}PREDBLK_DBUS2;
+
+typedef struct 
+{
+unsigned int     DbgCtrl3:29;
+unsigned int     DbgCtrl:3;
+}PREDBLK_DBUS3;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     SDMA2MSB:2;
+unsigned int     RMEM2MSB:2;
+}PREDBLK_DMAMSB;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     BaseAddr:12;
+}PREDBLK_DMEMADR;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     DC_Quant:6;
+unsigned int     reserved_1:7;
+unsigned int     Div_Quant:17;
+}PREDBLK_X8ILUQU;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     DC_Quant:7;
+unsigned int     reserved_1:7;
+unsigned int     Div_Quant:17;
+}PREDBLK_X8ICHQU;
+
+typedef struct 
+{
+unsigned int     TL:8;
+unsigned int     TR:8;
+unsigned int     BL:8;
+unsigned int     BR:8;
+}PREDBLK_X8ILFLT;
+
+typedef struct 
+{
+unsigned int     TL:8;
+unsigned int     TR:8;
+unsigned int     BL:8;
+unsigned int     BR:8;
+}PREDBLK_X8ILFCR;
+
+typedef struct 
+{
+unsigned int     TL:8;
+unsigned int     TR:8;
+unsigned int     BL:8;
+unsigned int     BR:8;
+}PREDBLK_X8ILFCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     BR:8;
+}PREDBLK_X8ILFTP;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     Count:28;
+}PREDBLK_DMEMOP;
+
+typedef struct 
+{
+unsigned int     hw_enable:1;
+unsigned int     reserved_0:30;
+unsigned int     Pmem_idle:1;
+}PREDBLK_SLICE_RESTART;
+
+typedef struct 
+{
+unsigned int     sw_override:1;
+unsigned int     reserved_0:8;
+unsigned int     ddr_inb_rdadr:3;
+unsigned int     ddr_out_rdadr:6;
+unsigned int     inb_mbcnt:4;
+unsigned int     out_mbcnt:4;
+unsigned int     pmem_inb_mbptr:3;
+unsigned int     pmem_out_mbptr:3;
+}PREDBLK_SLICE_DBG0;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ddr_rng_rdptr:10;
+unsigned int     ddr_rng_wrptr:10;
+unsigned int     ddr_rng_size:10;
+}PREDBLK_SLICE_DBG1;
+
+#endif
+
+#define PREDBLK_NEIGHBOR                                                             0x1800E800
+#define PREDBLK_NEIGHBOR_reg_addr                                                    "0xB800E800"
+#define PREDBLK_NEIGHBOR_reg                                                         0xB800E800
+#define set_PREDBLK_NEIGHBOR_reg(data)   (*((volatile unsigned int*) PREDBLK_NEIGHBOR_reg)=data)
+#define get_PREDBLK_NEIGHBOR_reg   (*((volatile unsigned int*) PREDBLK_NEIGHBOR_reg))
+#define PREDBLK_NEIGHBOR_inst_adr                                                    "0x0000"
+#define PREDBLK_NEIGHBOR_inst                                                        0x0000
+#define PREDBLK_NEIGHBOR_Nhmem_Flush_shift                                           (24)
+#define PREDBLK_NEIGHBOR_Nhmem_Flush_mask                                            (0x01000000)
+#define PREDBLK_NEIGHBOR_Nhmem_Flush(data)                                           (0x01000000&((data)<<24))
+#define PREDBLK_NEIGHBOR_Nhmem_Flush_src(data)                                       ((0x01000000&(data))>>24)
+#define PREDBLK_NEIGHBOR_get_Nhmem_Flush(data)                                       ((0x01000000&(data))>>24)
+#define PREDBLK_NEIGHBOR_RMEM_Rst_shift                                              (23)
+#define PREDBLK_NEIGHBOR_RMEM_Rst_mask                                               (0x00800000)
+#define PREDBLK_NEIGHBOR_RMEM_Rst(data)                                              (0x00800000&((data)<<23))
+#define PREDBLK_NEIGHBOR_RMEM_Rst_src(data)                                          ((0x00800000&(data))>>23)
+#define PREDBLK_NEIGHBOR_get_RMEM_Rst(data)                                          ((0x00800000&(data))>>23)
+#define PREDBLK_NEIGHBOR_Deblk_xsfer_mode_shift                                      (22)
+#define PREDBLK_NEIGHBOR_Deblk_xsfer_mode_mask                                       (0x00400000)
+#define PREDBLK_NEIGHBOR_Deblk_xsfer_mode(data)                                      (0x00400000&((data)<<22))
+#define PREDBLK_NEIGHBOR_Deblk_xsfer_mode_src(data)                                  ((0x00400000&(data))>>22)
+#define PREDBLK_NEIGHBOR_get_Deblk_xsfer_mode(data)                                  ((0x00400000&(data))>>22)
+#define PREDBLK_NEIGHBOR_Debug_mode_shift                                            (21)
+#define PREDBLK_NEIGHBOR_Debug_mode_mask                                             (0x00200000)
+#define PREDBLK_NEIGHBOR_Debug_mode(data)                                            (0x00200000&((data)<<21))
+#define PREDBLK_NEIGHBOR_Debug_mode_src(data)                                        ((0x00200000&(data))>>21)
+#define PREDBLK_NEIGHBOR_get_Debug_mode(data)                                        ((0x00200000&(data))>>21)
+#define PREDBLK_NEIGHBOR_fmo_shift                                                   (20)
+#define PREDBLK_NEIGHBOR_fmo_mask                                                    (0x00100000)
+#define PREDBLK_NEIGHBOR_fmo(data)                                                   (0x00100000&((data)<<20))
+#define PREDBLK_NEIGHBOR_fmo_src(data)                                               ((0x00100000&(data))>>20)
+#define PREDBLK_NEIGHBOR_get_fmo(data)                                               ((0x00100000&(data))>>20)
+#define PREDBLK_NEIGHBOR_Softrst_disable_shift                                       (15)
+#define PREDBLK_NEIGHBOR_Softrst_disable_mask                                        (0x00008000)
+#define PREDBLK_NEIGHBOR_Softrst_disable(data)                                       (0x00008000&((data)<<15))
+#define PREDBLK_NEIGHBOR_Softrst_disable_src(data)                                   ((0x00008000&(data))>>15)
+#define PREDBLK_NEIGHBOR_get_Softrst_disable(data)                                   ((0x00008000&(data))>>15)
+#define PREDBLK_NEIGHBOR_New_slice_row_shift                                         (14)
+#define PREDBLK_NEIGHBOR_New_slice_row_mask                                          (0x00004000)
+#define PREDBLK_NEIGHBOR_New_slice_row(data)                                         (0x00004000&((data)<<14))
+#define PREDBLK_NEIGHBOR_New_slice_row_src(data)                                     ((0x00004000&(data))>>14)
+#define PREDBLK_NEIGHBOR_get_New_slice_row(data)                                     ((0x00004000&(data))>>14)
+#define PREDBLK_NEIGHBOR_New_slice_mb_x_shift                                        (5)
+#define PREDBLK_NEIGHBOR_New_slice_mb_x_mask                                         (0x00003FE0)
+#define PREDBLK_NEIGHBOR_New_slice_mb_x(data)                                        (0x00003FE0&((data)<<5))
+#define PREDBLK_NEIGHBOR_New_slice_mb_x_src(data)                                    ((0x00003FE0&(data))>>5)
+#define PREDBLK_NEIGHBOR_get_New_slice_mb_x(data)                                    ((0x00003FE0&(data))>>5)
+#define PREDBLK_NEIGHBOR_Sw_neighbor_enable_shift                                    (4)
+#define PREDBLK_NEIGHBOR_Sw_neighbor_enable_mask                                     (0x00000010)
+#define PREDBLK_NEIGHBOR_Sw_neighbor_enable(data)                                    (0x00000010&((data)<<4))
+#define PREDBLK_NEIGHBOR_Sw_neighbor_enable_src(data)                                ((0x00000010&(data))>>4)
+#define PREDBLK_NEIGHBOR_get_Sw_neighbor_enable(data)                                ((0x00000010&(data))>>4)
+#define PREDBLK_NEIGHBOR_MbAddrA_available_shift                                     (3)
+#define PREDBLK_NEIGHBOR_MbAddrA_available_mask                                      (0x00000008)
+#define PREDBLK_NEIGHBOR_MbAddrA_available(data)                                     (0x00000008&((data)<<3))
+#define PREDBLK_NEIGHBOR_MbAddrA_available_src(data)                                 ((0x00000008&(data))>>3)
+#define PREDBLK_NEIGHBOR_get_MbAddrA_available(data)                                 ((0x00000008&(data))>>3)
+#define PREDBLK_NEIGHBOR_MbAddrB_available_shift                                     (2)
+#define PREDBLK_NEIGHBOR_MbAddrB_available_mask                                      (0x00000004)
+#define PREDBLK_NEIGHBOR_MbAddrB_available(data)                                     (0x00000004&((data)<<2))
+#define PREDBLK_NEIGHBOR_MbAddrB_available_src(data)                                 ((0x00000004&(data))>>2)
+#define PREDBLK_NEIGHBOR_get_MbAddrB_available(data)                                 ((0x00000004&(data))>>2)
+#define PREDBLK_NEIGHBOR_MbAddrC_available_shift                                     (1)
+#define PREDBLK_NEIGHBOR_MbAddrC_available_mask                                      (0x00000002)
+#define PREDBLK_NEIGHBOR_MbAddrC_available(data)                                     (0x00000002&((data)<<1))
+#define PREDBLK_NEIGHBOR_MbAddrC_available_src(data)                                 ((0x00000002&(data))>>1)
+#define PREDBLK_NEIGHBOR_get_MbAddrC_available(data)                                 ((0x00000002&(data))>>1)
+#define PREDBLK_NEIGHBOR_MbAddrD_available_shift                                     (0)
+#define PREDBLK_NEIGHBOR_MbAddrD_available_mask                                      (0x00000001)
+#define PREDBLK_NEIGHBOR_MbAddrD_available(data)                                     (0x00000001&((data)<<0))
+#define PREDBLK_NEIGHBOR_MbAddrD_available_src(data)                                 ((0x00000001&(data))>>0)
+#define PREDBLK_NEIGHBOR_get_MbAddrD_available(data)                                 ((0x00000001&(data))>>0)
+
+
+#define PREDBLK_VC1INTC1                                                             0x1800E804
+#define PREDBLK_VC1INTC1_reg_addr                                                    "0xB800E804"
+#define PREDBLK_VC1INTC1_reg                                                         0xB800E804
+#define set_PREDBLK_VC1INTC1_reg(data)   (*((volatile unsigned int*) PREDBLK_VC1INTC1_reg)=data)
+#define get_PREDBLK_VC1INTC1_reg   (*((volatile unsigned int*) PREDBLK_VC1INTC1_reg))
+#define PREDBLK_VC1INTC1_inst_adr                                                    "0x0001"
+#define PREDBLK_VC1INTC1_inst                                                        0x0001
+#define PREDBLK_VC1INTC1_ic_mix_fcm_enable_shift                                     (17)
+#define PREDBLK_VC1INTC1_ic_mix_fcm_enable_mask                                      (0x00020000)
+#define PREDBLK_VC1INTC1_ic_mix_fcm_enable(data)                                     (0x00020000&((data)<<17))
+#define PREDBLK_VC1INTC1_ic_mix_fcm_enable_src(data)                                 ((0x00020000&(data))>>17)
+#define PREDBLK_VC1INTC1_get_ic_mix_fcm_enable(data)                                 ((0x00020000&(data))>>17)
+#define PREDBLK_VC1INTC1_CONDOVER_shift                                              (15)
+#define PREDBLK_VC1INTC1_CONDOVER_mask                                               (0x00018000)
+#define PREDBLK_VC1INTC1_CONDOVER(data)                                              (0x00018000&((data)<<15))
+#define PREDBLK_VC1INTC1_CONDOVER_src(data)                                          ((0x00018000&(data))>>15)
+#define PREDBLK_VC1INTC1_get_CONDOVER(data)                                          ((0x00018000&(data))>>15)
+#define PREDBLK_VC1INTC1_Rnd_ctrl_ovt_shift                                          (14)
+#define PREDBLK_VC1INTC1_Rnd_ctrl_ovt_mask                                           (0x00004000)
+#define PREDBLK_VC1INTC1_Rnd_ctrl_ovt(data)                                          (0x00004000&((data)<<14))
+#define PREDBLK_VC1INTC1_Rnd_ctrl_ovt_src(data)                                      ((0x00004000&(data))>>14)
+#define PREDBLK_VC1INTC1_get_Rnd_ctrl_ovt(data)                                      ((0x00004000&(data))>>14)
+#define PREDBLK_VC1INTC1_RND_shift                                                   (13)
+#define PREDBLK_VC1INTC1_RND_mask                                                    (0x00002000)
+#define PREDBLK_VC1INTC1_RND(data)                                                   (0x00002000&((data)<<13))
+#define PREDBLK_VC1INTC1_RND_src(data)                                               ((0x00002000&(data))>>13)
+#define PREDBLK_VC1INTC1_get_RND(data)                                               ((0x00002000&(data))>>13)
+#define PREDBLK_VC1INTC1_INTCOMP_shift                                               (12)
+#define PREDBLK_VC1INTC1_INTCOMP_mask                                                (0x00001000)
+#define PREDBLK_VC1INTC1_INTCOMP(data)                                               (0x00001000&((data)<<12))
+#define PREDBLK_VC1INTC1_INTCOMP_src(data)                                           ((0x00001000&(data))>>12)
+#define PREDBLK_VC1INTC1_get_INTCOMP(data)                                           ((0x00001000&(data))>>12)
+#define PREDBLK_VC1INTC1_LUMSCALE0_shift                                             (6)
+#define PREDBLK_VC1INTC1_LUMSCALE0_mask                                              (0x00000FC0)
+#define PREDBLK_VC1INTC1_LUMSCALE0(data)                                             (0x00000FC0&((data)<<6))
+#define PREDBLK_VC1INTC1_LUMSCALE0_src(data)                                         ((0x00000FC0&(data))>>6)
+#define PREDBLK_VC1INTC1_get_LUMSCALE0(data)                                         ((0x00000FC0&(data))>>6)
+#define PREDBLK_VC1INTC1_LUMSHIFT0_shift                                             (0)
+#define PREDBLK_VC1INTC1_LUMSHIFT0_mask                                              (0x0000003F)
+#define PREDBLK_VC1INTC1_LUMSHIFT0(data)                                             (0x0000003F&((data)<<0))
+#define PREDBLK_VC1INTC1_LUMSHIFT0_src(data)                                         ((0x0000003F&(data))>>0)
+#define PREDBLK_VC1INTC1_get_LUMSHIFT0(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define PREDBLK_VC1INTC2                                                             0x1800E808
+#define PREDBLK_VC1INTC2_reg_addr                                                    "0xB800E808"
+#define PREDBLK_VC1INTC2_reg                                                         0xB800E808
+#define set_PREDBLK_VC1INTC2_reg(data)   (*((volatile unsigned int*) PREDBLK_VC1INTC2_reg)=data)
+#define get_PREDBLK_VC1INTC2_reg   (*((volatile unsigned int*) PREDBLK_VC1INTC2_reg))
+#define PREDBLK_VC1INTC2_inst_adr                                                    "0x0002"
+#define PREDBLK_VC1INTC2_inst                                                        0x0002
+#define PREDBLK_VC1INTC2_Ic_pass0_of_fwd_shift                                       (28)
+#define PREDBLK_VC1INTC2_Ic_pass0_of_fwd_mask                                        (0xF0000000)
+#define PREDBLK_VC1INTC2_Ic_pass0_of_fwd(data)                                       (0xF0000000&((data)<<28))
+#define PREDBLK_VC1INTC2_Ic_pass0_of_fwd_src(data)                                   ((0xF0000000&(data))>>28)
+#define PREDBLK_VC1INTC2_get_Ic_pass0_of_fwd(data)                                   ((0xF0000000&(data))>>28)
+#define PREDBLK_VC1INTC2_Ic_pass1_of_fwd_shift                                       (24)
+#define PREDBLK_VC1INTC2_Ic_pass1_of_fwd_mask                                        (0x0F000000)
+#define PREDBLK_VC1INTC2_Ic_pass1_of_fwd(data)                                       (0x0F000000&((data)<<24))
+#define PREDBLK_VC1INTC2_Ic_pass1_of_fwd_src(data)                                   ((0x0F000000&(data))>>24)
+#define PREDBLK_VC1INTC2_get_Ic_pass1_of_fwd(data)                                   ((0x0F000000&(data))>>24)
+#define PREDBLK_VC1INTC2_Ic_pass0_sf_fwd_shift                                       (20)
+#define PREDBLK_VC1INTC2_Ic_pass0_sf_fwd_mask                                        (0x00F00000)
+#define PREDBLK_VC1INTC2_Ic_pass0_sf_fwd(data)                                       (0x00F00000&((data)<<20))
+#define PREDBLK_VC1INTC2_Ic_pass0_sf_fwd_src(data)                                   ((0x00F00000&(data))>>20)
+#define PREDBLK_VC1INTC2_get_Ic_pass0_sf_fwd(data)                                   ((0x00F00000&(data))>>20)
+#define PREDBLK_VC1INTC2_Ic_pass1_sf_fwd_shift                                       (16)
+#define PREDBLK_VC1INTC2_Ic_pass1_sf_fwd_mask                                        (0x000F0000)
+#define PREDBLK_VC1INTC2_Ic_pass1_sf_fwd(data)                                       (0x000F0000&((data)<<16))
+#define PREDBLK_VC1INTC2_Ic_pass1_sf_fwd_src(data)                                   ((0x000F0000&(data))>>16)
+#define PREDBLK_VC1INTC2_get_Ic_pass1_sf_fwd(data)                                   ((0x000F0000&(data))>>16)
+#define PREDBLK_VC1INTC2_Ic_pass0_of_bwd_shift                                       (12)
+#define PREDBLK_VC1INTC2_Ic_pass0_of_bwd_mask                                        (0x0000F000)
+#define PREDBLK_VC1INTC2_Ic_pass0_of_bwd(data)                                       (0x0000F000&((data)<<12))
+#define PREDBLK_VC1INTC2_Ic_pass0_of_bwd_src(data)                                   ((0x0000F000&(data))>>12)
+#define PREDBLK_VC1INTC2_get_Ic_pass0_of_bwd(data)                                   ((0x0000F000&(data))>>12)
+#define PREDBLK_VC1INTC2_Ic_pass1_of_bwd_shift                                       (8)
+#define PREDBLK_VC1INTC2_Ic_pass1_of_bwd_mask                                        (0x00000F00)
+#define PREDBLK_VC1INTC2_Ic_pass1_of_bwd(data)                                       (0x00000F00&((data)<<8))
+#define PREDBLK_VC1INTC2_Ic_pass1_of_bwd_src(data)                                   ((0x00000F00&(data))>>8)
+#define PREDBLK_VC1INTC2_get_Ic_pass1_of_bwd(data)                                   ((0x00000F00&(data))>>8)
+#define PREDBLK_VC1INTC2_Ic_pass0_sf_bwd_shift                                       (4)
+#define PREDBLK_VC1INTC2_Ic_pass0_sf_bwd_mask                                        (0x000000F0)
+#define PREDBLK_VC1INTC2_Ic_pass0_sf_bwd(data)                                       (0x000000F0&((data)<<4))
+#define PREDBLK_VC1INTC2_Ic_pass0_sf_bwd_src(data)                                   ((0x000000F0&(data))>>4)
+#define PREDBLK_VC1INTC2_get_Ic_pass0_sf_bwd(data)                                   ((0x000000F0&(data))>>4)
+#define PREDBLK_VC1INTC2_Ic_pass1_sf_bwd_shift                                       (0)
+#define PREDBLK_VC1INTC2_Ic_pass1_sf_bwd_mask                                        (0x0000000F)
+#define PREDBLK_VC1INTC2_Ic_pass1_sf_bwd(data)                                       (0x0000000F&((data)<<0))
+#define PREDBLK_VC1INTC2_Ic_pass1_sf_bwd_src(data)                                   ((0x0000000F&(data))>>0)
+#define PREDBLK_VC1INTC2_get_Ic_pass1_sf_bwd(data)                                   ((0x0000000F&(data))>>0)
+
+
+#define PREDBLK_VC1INTC3                                                             0x1800E80C
+#define PREDBLK_VC1INTC3_reg_addr                                                    "0xB800E80C"
+#define PREDBLK_VC1INTC3_reg                                                         0xB800E80C
+#define set_PREDBLK_VC1INTC3_reg(data)   (*((volatile unsigned int*) PREDBLK_VC1INTC3_reg)=data)
+#define get_PREDBLK_VC1INTC3_reg   (*((volatile unsigned int*) PREDBLK_VC1INTC3_reg))
+#define PREDBLK_VC1INTC3_inst_adr                                                    "0x0003"
+#define PREDBLK_VC1INTC3_inst                                                        0x0003
+#define PREDBLK_VC1INTC3_LUMSCALE1_shift                                             (18)
+#define PREDBLK_VC1INTC3_LUMSCALE1_mask                                              (0x00FC0000)
+#define PREDBLK_VC1INTC3_LUMSCALE1(data)                                             (0x00FC0000&((data)<<18))
+#define PREDBLK_VC1INTC3_LUMSCALE1_src(data)                                         ((0x00FC0000&(data))>>18)
+#define PREDBLK_VC1INTC3_get_LUMSCALE1(data)                                         ((0x00FC0000&(data))>>18)
+#define PREDBLK_VC1INTC3_LUMSHIFT1_shift                                             (12)
+#define PREDBLK_VC1INTC3_LUMSHIFT1_mask                                              (0x0003F000)
+#define PREDBLK_VC1INTC3_LUMSHIFT1(data)                                             (0x0003F000&((data)<<12))
+#define PREDBLK_VC1INTC3_LUMSHIFT1_src(data)                                         ((0x0003F000&(data))>>12)
+#define PREDBLK_VC1INTC3_get_LUMSHIFT1(data)                                         ((0x0003F000&(data))>>12)
+#define PREDBLK_VC1INTC3_LUMSCALE2_shift                                             (6)
+#define PREDBLK_VC1INTC3_LUMSCALE2_mask                                              (0x00000FC0)
+#define PREDBLK_VC1INTC3_LUMSCALE2(data)                                             (0x00000FC0&((data)<<6))
+#define PREDBLK_VC1INTC3_LUMSCALE2_src(data)                                         ((0x00000FC0&(data))>>6)
+#define PREDBLK_VC1INTC3_get_LUMSCALE2(data)                                         ((0x00000FC0&(data))>>6)
+#define PREDBLK_VC1INTC3_LUMSHIFT2_shift                                             (0)
+#define PREDBLK_VC1INTC3_LUMSHIFT2_mask                                              (0x0000003F)
+#define PREDBLK_VC1INTC3_LUMSHIFT2(data)                                             (0x0000003F&((data)<<0))
+#define PREDBLK_VC1INTC3_LUMSHIFT2_src(data)                                         ((0x0000003F&(data))>>0)
+#define PREDBLK_VC1INTC3_get_LUMSHIFT2(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define PREDBLK_VC1INTC4                                                             0x1800E810
+#define PREDBLK_VC1INTC4_reg_addr                                                    "0xB800E810"
+#define PREDBLK_VC1INTC4_reg                                                         0xB800E810
+#define set_PREDBLK_VC1INTC4_reg(data)   (*((volatile unsigned int*) PREDBLK_VC1INTC4_reg)=data)
+#define get_PREDBLK_VC1INTC4_reg   (*((volatile unsigned int*) PREDBLK_VC1INTC4_reg))
+#define PREDBLK_VC1INTC4_inst_adr                                                    "0x0004"
+#define PREDBLK_VC1INTC4_inst                                                        0x0004
+#define PREDBLK_VC1INTC4_LUMSCALE3_shift                                             (18)
+#define PREDBLK_VC1INTC4_LUMSCALE3_mask                                              (0x00FC0000)
+#define PREDBLK_VC1INTC4_LUMSCALE3(data)                                             (0x00FC0000&((data)<<18))
+#define PREDBLK_VC1INTC4_LUMSCALE3_src(data)                                         ((0x00FC0000&(data))>>18)
+#define PREDBLK_VC1INTC4_get_LUMSCALE3(data)                                         ((0x00FC0000&(data))>>18)
+#define PREDBLK_VC1INTC4_LUMSHIFT3_shift                                             (12)
+#define PREDBLK_VC1INTC4_LUMSHIFT3_mask                                              (0x0003F000)
+#define PREDBLK_VC1INTC4_LUMSHIFT3(data)                                             (0x0003F000&((data)<<12))
+#define PREDBLK_VC1INTC4_LUMSHIFT3_src(data)                                         ((0x0003F000&(data))>>12)
+#define PREDBLK_VC1INTC4_get_LUMSHIFT3(data)                                         ((0x0003F000&(data))>>12)
+#define PREDBLK_VC1INTC4_LUMSCALE4_shift                                             (6)
+#define PREDBLK_VC1INTC4_LUMSCALE4_mask                                              (0x00000FC0)
+#define PREDBLK_VC1INTC4_LUMSCALE4(data)                                             (0x00000FC0&((data)<<6))
+#define PREDBLK_VC1INTC4_LUMSCALE4_src(data)                                         ((0x00000FC0&(data))>>6)
+#define PREDBLK_VC1INTC4_get_LUMSCALE4(data)                                         ((0x00000FC0&(data))>>6)
+#define PREDBLK_VC1INTC4_LUMSHIFT4_shift                                             (0)
+#define PREDBLK_VC1INTC4_LUMSHIFT4_mask                                              (0x0000003F)
+#define PREDBLK_VC1INTC4_LUMSHIFT4(data)                                             (0x0000003F&((data)<<0))
+#define PREDBLK_VC1INTC4_LUMSHIFT4_src(data)                                         ((0x0000003F&(data))>>0)
+#define PREDBLK_VC1INTC4_get_LUMSHIFT4(data)                                         ((0x0000003F&(data))>>0)
+
+
+#define PREDBLK_NBINTRA0_0                                                           0x1800E814
+#define PREDBLK_NBINTRA0_1                                                           0x1800E818
+#define PREDBLK_NBINTRA0_2                                                           0x1800E81C
+#define PREDBLK_NBINTRA0_3                                                           0x1800E820
+#define PREDBLK_NBINTRA0_4                                                           0x1800E824
+#define PREDBLK_NBINTRA0_5                                                           0x1800E828
+#define PREDBLK_NBINTRA0_6                                                           0x1800E82C
+#define PREDBLK_NBINTRA0_7                                                           0x1800E830
+#define PREDBLK_NBINTRA0_8                                                           0x1800E834
+#define PREDBLK_NBINTRA0_9                                                           0x1800E838
+#define PREDBLK_NBINTRA0_10                                                           0x1800E83C
+#define PREDBLK_NBINTRA0_11                                                           0x1800E840
+#define PREDBLK_NBINTRA0_12                                                           0x1800E844
+#define PREDBLK_NBINTRA0_13                                                           0x1800E848
+#define PREDBLK_NBINTRA0_14                                                           0x1800E84C
+#define PREDBLK_NBINTRA0_15                                                           0x1800E850
+#define PREDBLK_NBINTRA0_0_reg_addr                                                  "0xB800E814"
+#define PREDBLK_NBINTRA0_1_reg_addr                                                  "0xB800E818"
+#define PREDBLK_NBINTRA0_2_reg_addr                                                  "0xB800E81C"
+#define PREDBLK_NBINTRA0_3_reg_addr                                                  "0xB800E820"
+#define PREDBLK_NBINTRA0_4_reg_addr                                                  "0xB800E824"
+#define PREDBLK_NBINTRA0_5_reg_addr                                                  "0xB800E828"
+#define PREDBLK_NBINTRA0_6_reg_addr                                                  "0xB800E82C"
+#define PREDBLK_NBINTRA0_7_reg_addr                                                  "0xB800E830"
+#define PREDBLK_NBINTRA0_8_reg_addr                                                  "0xB800E834"
+#define PREDBLK_NBINTRA0_9_reg_addr                                                  "0xB800E838"
+#define PREDBLK_NBINTRA0_10_reg_addr                                                  "0xB800E83C"
+#define PREDBLK_NBINTRA0_11_reg_addr                                                  "0xB800E840"
+#define PREDBLK_NBINTRA0_12_reg_addr                                                  "0xB800E844"
+#define PREDBLK_NBINTRA0_13_reg_addr                                                  "0xB800E848"
+#define PREDBLK_NBINTRA0_14_reg_addr                                                  "0xB800E84C"
+#define PREDBLK_NBINTRA0_15_reg_addr                                                  "0xB800E850"
+#define PREDBLK_NBINTRA0_0_reg                                                       0xB800E814
+#define PREDBLK_NBINTRA0_1_reg                                                       0xB800E818
+#define PREDBLK_NBINTRA0_2_reg                                                       0xB800E81C
+#define PREDBLK_NBINTRA0_3_reg                                                       0xB800E820
+#define PREDBLK_NBINTRA0_4_reg                                                       0xB800E824
+#define PREDBLK_NBINTRA0_5_reg                                                       0xB800E828
+#define PREDBLK_NBINTRA0_6_reg                                                       0xB800E82C
+#define PREDBLK_NBINTRA0_7_reg                                                       0xB800E830
+#define PREDBLK_NBINTRA0_8_reg                                                       0xB800E834
+#define PREDBLK_NBINTRA0_9_reg                                                       0xB800E838
+#define PREDBLK_NBINTRA0_10_reg                                                       0xB800E83C
+#define PREDBLK_NBINTRA0_11_reg                                                       0xB800E840
+#define PREDBLK_NBINTRA0_12_reg                                                       0xB800E844
+#define PREDBLK_NBINTRA0_13_reg                                                       0xB800E848
+#define PREDBLK_NBINTRA0_14_reg                                                       0xB800E84C
+#define PREDBLK_NBINTRA0_15_reg                                                       0xB800E850
+#define set_PREDBLK_NBINTRA0_0_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_0_reg)=data)
+#define set_PREDBLK_NBINTRA0_1_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_1_reg)=data)
+#define set_PREDBLK_NBINTRA0_2_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_2_reg)=data)
+#define set_PREDBLK_NBINTRA0_3_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_3_reg)=data)
+#define set_PREDBLK_NBINTRA0_4_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_4_reg)=data)
+#define set_PREDBLK_NBINTRA0_5_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_5_reg)=data)
+#define set_PREDBLK_NBINTRA0_6_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_6_reg)=data)
+#define set_PREDBLK_NBINTRA0_7_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_7_reg)=data)
+#define set_PREDBLK_NBINTRA0_8_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_8_reg)=data)
+#define set_PREDBLK_NBINTRA0_9_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_9_reg)=data)
+#define set_PREDBLK_NBINTRA0_10_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_10_reg)=data)
+#define set_PREDBLK_NBINTRA0_11_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_11_reg)=data)
+#define set_PREDBLK_NBINTRA0_12_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_12_reg)=data)
+#define set_PREDBLK_NBINTRA0_13_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_13_reg)=data)
+#define set_PREDBLK_NBINTRA0_14_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_14_reg)=data)
+#define set_PREDBLK_NBINTRA0_15_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA0_15_reg)=data)
+#define get_PREDBLK_NBINTRA0_0_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_0_reg))
+#define get_PREDBLK_NBINTRA0_1_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_1_reg))
+#define get_PREDBLK_NBINTRA0_2_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_2_reg))
+#define get_PREDBLK_NBINTRA0_3_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_3_reg))
+#define get_PREDBLK_NBINTRA0_4_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_4_reg))
+#define get_PREDBLK_NBINTRA0_5_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_5_reg))
+#define get_PREDBLK_NBINTRA0_6_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_6_reg))
+#define get_PREDBLK_NBINTRA0_7_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_7_reg))
+#define get_PREDBLK_NBINTRA0_8_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_8_reg))
+#define get_PREDBLK_NBINTRA0_9_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_9_reg))
+#define get_PREDBLK_NBINTRA0_10_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_10_reg))
+#define get_PREDBLK_NBINTRA0_11_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_11_reg))
+#define get_PREDBLK_NBINTRA0_12_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_12_reg))
+#define get_PREDBLK_NBINTRA0_13_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_13_reg))
+#define get_PREDBLK_NBINTRA0_14_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_14_reg))
+#define get_PREDBLK_NBINTRA0_15_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA0_15_reg))
+#define PREDBLK_NBINTRA0_0_inst_adr                                                  "0x0005"
+#define PREDBLK_NBINTRA0_1_inst_adr                                                  "0x0006"
+#define PREDBLK_NBINTRA0_2_inst_adr                                                  "0x0007"
+#define PREDBLK_NBINTRA0_3_inst_adr                                                  "0x0008"
+#define PREDBLK_NBINTRA0_4_inst_adr                                                  "0x0009"
+#define PREDBLK_NBINTRA0_5_inst_adr                                                  "0x000A"
+#define PREDBLK_NBINTRA0_6_inst_adr                                                  "0x000B"
+#define PREDBLK_NBINTRA0_7_inst_adr                                                  "0x000C"
+#define PREDBLK_NBINTRA0_8_inst_adr                                                  "0x000D"
+#define PREDBLK_NBINTRA0_9_inst_adr                                                  "0x000E"
+#define PREDBLK_NBINTRA0_10_inst_adr                                                  "0x000F"
+#define PREDBLK_NBINTRA0_11_inst_adr                                                  "0x0010"
+#define PREDBLK_NBINTRA0_12_inst_adr                                                  "0x0011"
+#define PREDBLK_NBINTRA0_13_inst_adr                                                  "0x0012"
+#define PREDBLK_NBINTRA0_14_inst_adr                                                  "0x0013"
+#define PREDBLK_NBINTRA0_15_inst_adr                                                  "0x0014"
+#define PREDBLK_NBINTRA0_0_inst                                                      0x0005
+#define PREDBLK_NBINTRA0_1_inst                                                      0x0006
+#define PREDBLK_NBINTRA0_2_inst                                                      0x0007
+#define PREDBLK_NBINTRA0_3_inst                                                      0x0008
+#define PREDBLK_NBINTRA0_4_inst                                                      0x0009
+#define PREDBLK_NBINTRA0_5_inst                                                      0x000A
+#define PREDBLK_NBINTRA0_6_inst                                                      0x000B
+#define PREDBLK_NBINTRA0_7_inst                                                      0x000C
+#define PREDBLK_NBINTRA0_8_inst                                                      0x000D
+#define PREDBLK_NBINTRA0_9_inst                                                      0x000E
+#define PREDBLK_NBINTRA0_10_inst                                                      0x000F
+#define PREDBLK_NBINTRA0_11_inst                                                      0x0010
+#define PREDBLK_NBINTRA0_12_inst                                                      0x0011
+#define PREDBLK_NBINTRA0_13_inst                                                      0x0012
+#define PREDBLK_NBINTRA0_14_inst                                                      0x0013
+#define PREDBLK_NBINTRA0_15_inst                                                      0x0014
+#define PREDBLK_NBINTRA0_intra_flag_shift                                            (0)
+#define PREDBLK_NBINTRA0_intra_flag_mask                                             (0xFFFFFFFF)
+#define PREDBLK_NBINTRA0_intra_flag(data)                                            (0xFFFFFFFF&((data)<<0))
+#define PREDBLK_NBINTRA0_intra_flag_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define PREDBLK_NBINTRA0_get_intra_flag(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define PREDBLK_NBINTRA1_0                                                           0x1800E854
+#define PREDBLK_NBINTRA1_1                                                           0x1800E858
+#define PREDBLK_NBINTRA1_2                                                           0x1800E85C
+#define PREDBLK_NBINTRA1_3                                                           0x1800E860
+#define PREDBLK_NBINTRA1_4                                                           0x1800E864
+#define PREDBLK_NBINTRA1_5                                                           0x1800E868
+#define PREDBLK_NBINTRA1_6                                                           0x1800E86C
+#define PREDBLK_NBINTRA1_7                                                           0x1800E870
+#define PREDBLK_NBINTRA1_8                                                           0x1800E874
+#define PREDBLK_NBINTRA1_9                                                           0x1800E878
+#define PREDBLK_NBINTRA1_10                                                           0x1800E87C
+#define PREDBLK_NBINTRA1_11                                                           0x1800E880
+#define PREDBLK_NBINTRA1_12                                                           0x1800E884
+#define PREDBLK_NBINTRA1_13                                                           0x1800E888
+#define PREDBLK_NBINTRA1_14                                                           0x1800E88C
+#define PREDBLK_NBINTRA1_15                                                           0x1800E890
+#define PREDBLK_NBINTRA1_0_reg_addr                                                  "0xB800E854"
+#define PREDBLK_NBINTRA1_1_reg_addr                                                  "0xB800E858"
+#define PREDBLK_NBINTRA1_2_reg_addr                                                  "0xB800E85C"
+#define PREDBLK_NBINTRA1_3_reg_addr                                                  "0xB800E860"
+#define PREDBLK_NBINTRA1_4_reg_addr                                                  "0xB800E864"
+#define PREDBLK_NBINTRA1_5_reg_addr                                                  "0xB800E868"
+#define PREDBLK_NBINTRA1_6_reg_addr                                                  "0xB800E86C"
+#define PREDBLK_NBINTRA1_7_reg_addr                                                  "0xB800E870"
+#define PREDBLK_NBINTRA1_8_reg_addr                                                  "0xB800E874"
+#define PREDBLK_NBINTRA1_9_reg_addr                                                  "0xB800E878"
+#define PREDBLK_NBINTRA1_10_reg_addr                                                  "0xB800E87C"
+#define PREDBLK_NBINTRA1_11_reg_addr                                                  "0xB800E880"
+#define PREDBLK_NBINTRA1_12_reg_addr                                                  "0xB800E884"
+#define PREDBLK_NBINTRA1_13_reg_addr                                                  "0xB800E888"
+#define PREDBLK_NBINTRA1_14_reg_addr                                                  "0xB800E88C"
+#define PREDBLK_NBINTRA1_15_reg_addr                                                  "0xB800E890"
+#define PREDBLK_NBINTRA1_0_reg                                                       0xB800E854
+#define PREDBLK_NBINTRA1_1_reg                                                       0xB800E858
+#define PREDBLK_NBINTRA1_2_reg                                                       0xB800E85C
+#define PREDBLK_NBINTRA1_3_reg                                                       0xB800E860
+#define PREDBLK_NBINTRA1_4_reg                                                       0xB800E864
+#define PREDBLK_NBINTRA1_5_reg                                                       0xB800E868
+#define PREDBLK_NBINTRA1_6_reg                                                       0xB800E86C
+#define PREDBLK_NBINTRA1_7_reg                                                       0xB800E870
+#define PREDBLK_NBINTRA1_8_reg                                                       0xB800E874
+#define PREDBLK_NBINTRA1_9_reg                                                       0xB800E878
+#define PREDBLK_NBINTRA1_10_reg                                                       0xB800E87C
+#define PREDBLK_NBINTRA1_11_reg                                                       0xB800E880
+#define PREDBLK_NBINTRA1_12_reg                                                       0xB800E884
+#define PREDBLK_NBINTRA1_13_reg                                                       0xB800E888
+#define PREDBLK_NBINTRA1_14_reg                                                       0xB800E88C
+#define PREDBLK_NBINTRA1_15_reg                                                       0xB800E890
+#define set_PREDBLK_NBINTRA1_0_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_0_reg)=data)
+#define set_PREDBLK_NBINTRA1_1_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_1_reg)=data)
+#define set_PREDBLK_NBINTRA1_2_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_2_reg)=data)
+#define set_PREDBLK_NBINTRA1_3_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_3_reg)=data)
+#define set_PREDBLK_NBINTRA1_4_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_4_reg)=data)
+#define set_PREDBLK_NBINTRA1_5_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_5_reg)=data)
+#define set_PREDBLK_NBINTRA1_6_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_6_reg)=data)
+#define set_PREDBLK_NBINTRA1_7_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_7_reg)=data)
+#define set_PREDBLK_NBINTRA1_8_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_8_reg)=data)
+#define set_PREDBLK_NBINTRA1_9_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_9_reg)=data)
+#define set_PREDBLK_NBINTRA1_10_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_10_reg)=data)
+#define set_PREDBLK_NBINTRA1_11_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_11_reg)=data)
+#define set_PREDBLK_NBINTRA1_12_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_12_reg)=data)
+#define set_PREDBLK_NBINTRA1_13_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_13_reg)=data)
+#define set_PREDBLK_NBINTRA1_14_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_14_reg)=data)
+#define set_PREDBLK_NBINTRA1_15_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRA1_15_reg)=data)
+#define get_PREDBLK_NBINTRA1_0_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_0_reg))
+#define get_PREDBLK_NBINTRA1_1_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_1_reg))
+#define get_PREDBLK_NBINTRA1_2_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_2_reg))
+#define get_PREDBLK_NBINTRA1_3_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_3_reg))
+#define get_PREDBLK_NBINTRA1_4_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_4_reg))
+#define get_PREDBLK_NBINTRA1_5_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_5_reg))
+#define get_PREDBLK_NBINTRA1_6_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_6_reg))
+#define get_PREDBLK_NBINTRA1_7_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_7_reg))
+#define get_PREDBLK_NBINTRA1_8_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_8_reg))
+#define get_PREDBLK_NBINTRA1_9_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_9_reg))
+#define get_PREDBLK_NBINTRA1_10_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_10_reg))
+#define get_PREDBLK_NBINTRA1_11_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_11_reg))
+#define get_PREDBLK_NBINTRA1_12_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_12_reg))
+#define get_PREDBLK_NBINTRA1_13_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_13_reg))
+#define get_PREDBLK_NBINTRA1_14_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_14_reg))
+#define get_PREDBLK_NBINTRA1_15_reg   (*((volatile unsigned int*) PREDBLK_NBINTRA1_15_reg))
+#define PREDBLK_NBINTRA1_0_inst_adr                                                  "0x0015"
+#define PREDBLK_NBINTRA1_1_inst_adr                                                  "0x0016"
+#define PREDBLK_NBINTRA1_2_inst_adr                                                  "0x0017"
+#define PREDBLK_NBINTRA1_3_inst_adr                                                  "0x0018"
+#define PREDBLK_NBINTRA1_4_inst_adr                                                  "0x0019"
+#define PREDBLK_NBINTRA1_5_inst_adr                                                  "0x001A"
+#define PREDBLK_NBINTRA1_6_inst_adr                                                  "0x001B"
+#define PREDBLK_NBINTRA1_7_inst_adr                                                  "0x001C"
+#define PREDBLK_NBINTRA1_8_inst_adr                                                  "0x001D"
+#define PREDBLK_NBINTRA1_9_inst_adr                                                  "0x001E"
+#define PREDBLK_NBINTRA1_10_inst_adr                                                  "0x001F"
+#define PREDBLK_NBINTRA1_11_inst_adr                                                  "0x0020"
+#define PREDBLK_NBINTRA1_12_inst_adr                                                  "0x0021"
+#define PREDBLK_NBINTRA1_13_inst_adr                                                  "0x0022"
+#define PREDBLK_NBINTRA1_14_inst_adr                                                  "0x0023"
+#define PREDBLK_NBINTRA1_15_inst_adr                                                  "0x0024"
+#define PREDBLK_NBINTRA1_0_inst                                                      0x0015
+#define PREDBLK_NBINTRA1_1_inst                                                      0x0016
+#define PREDBLK_NBINTRA1_2_inst                                                      0x0017
+#define PREDBLK_NBINTRA1_3_inst                                                      0x0018
+#define PREDBLK_NBINTRA1_4_inst                                                      0x0019
+#define PREDBLK_NBINTRA1_5_inst                                                      0x001A
+#define PREDBLK_NBINTRA1_6_inst                                                      0x001B
+#define PREDBLK_NBINTRA1_7_inst                                                      0x001C
+#define PREDBLK_NBINTRA1_8_inst                                                      0x001D
+#define PREDBLK_NBINTRA1_9_inst                                                      0x001E
+#define PREDBLK_NBINTRA1_10_inst                                                      0x001F
+#define PREDBLK_NBINTRA1_11_inst                                                      0x0020
+#define PREDBLK_NBINTRA1_12_inst                                                      0x0021
+#define PREDBLK_NBINTRA1_13_inst                                                      0x0022
+#define PREDBLK_NBINTRA1_14_inst                                                      0x0023
+#define PREDBLK_NBINTRA1_15_inst                                                      0x0024
+#define PREDBLK_NBINTRA1_intra_flag_shift                                            (0)
+#define PREDBLK_NBINTRA1_intra_flag_mask                                             (0xFFFFFFFF)
+#define PREDBLK_NBINTRA1_intra_flag(data)                                            (0xFFFFFFFF&((data)<<0))
+#define PREDBLK_NBINTRA1_intra_flag_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define PREDBLK_NBINTRA1_get_intra_flag(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define PREDBLK_NBINTRACH_0                                                          0x1800E894
+#define PREDBLK_NBINTRACH_1                                                          0x1800E898
+#define PREDBLK_NBINTRACH_2                                                          0x1800E89C
+#define PREDBLK_NBINTRACH_3                                                          0x1800E8A0
+#define PREDBLK_NBINTRACH_4                                                          0x1800E8A4
+#define PREDBLK_NBINTRACH_5                                                          0x1800E8A8
+#define PREDBLK_NBINTRACH_6                                                          0x1800E8AC
+#define PREDBLK_NBINTRACH_7                                                          0x1800E8B0
+#define PREDBLK_NBINTRACH_8                                                          0x1800E8B4
+#define PREDBLK_NBINTRACH_9                                                          0x1800E8B8
+#define PREDBLK_NBINTRACH_10                                                          0x1800E8BC
+#define PREDBLK_NBINTRACH_11                                                          0x1800E8C0
+#define PREDBLK_NBINTRACH_12                                                          0x1800E8C4
+#define PREDBLK_NBINTRACH_13                                                          0x1800E8C8
+#define PREDBLK_NBINTRACH_14                                                          0x1800E8CC
+#define PREDBLK_NBINTRACH_15                                                          0x1800E8D0
+#define PREDBLK_NBINTRACH_0_reg_addr                                                 "0xB800E894"
+#define PREDBLK_NBINTRACH_1_reg_addr                                                 "0xB800E898"
+#define PREDBLK_NBINTRACH_2_reg_addr                                                 "0xB800E89C"
+#define PREDBLK_NBINTRACH_3_reg_addr                                                 "0xB800E8A0"
+#define PREDBLK_NBINTRACH_4_reg_addr                                                 "0xB800E8A4"
+#define PREDBLK_NBINTRACH_5_reg_addr                                                 "0xB800E8A8"
+#define PREDBLK_NBINTRACH_6_reg_addr                                                 "0xB800E8AC"
+#define PREDBLK_NBINTRACH_7_reg_addr                                                 "0xB800E8B0"
+#define PREDBLK_NBINTRACH_8_reg_addr                                                 "0xB800E8B4"
+#define PREDBLK_NBINTRACH_9_reg_addr                                                 "0xB800E8B8"
+#define PREDBLK_NBINTRACH_10_reg_addr                                                 "0xB800E8BC"
+#define PREDBLK_NBINTRACH_11_reg_addr                                                 "0xB800E8C0"
+#define PREDBLK_NBINTRACH_12_reg_addr                                                 "0xB800E8C4"
+#define PREDBLK_NBINTRACH_13_reg_addr                                                 "0xB800E8C8"
+#define PREDBLK_NBINTRACH_14_reg_addr                                                 "0xB800E8CC"
+#define PREDBLK_NBINTRACH_15_reg_addr                                                 "0xB800E8D0"
+#define PREDBLK_NBINTRACH_0_reg                                                      0xB800E894
+#define PREDBLK_NBINTRACH_1_reg                                                      0xB800E898
+#define PREDBLK_NBINTRACH_2_reg                                                      0xB800E89C
+#define PREDBLK_NBINTRACH_3_reg                                                      0xB800E8A0
+#define PREDBLK_NBINTRACH_4_reg                                                      0xB800E8A4
+#define PREDBLK_NBINTRACH_5_reg                                                      0xB800E8A8
+#define PREDBLK_NBINTRACH_6_reg                                                      0xB800E8AC
+#define PREDBLK_NBINTRACH_7_reg                                                      0xB800E8B0
+#define PREDBLK_NBINTRACH_8_reg                                                      0xB800E8B4
+#define PREDBLK_NBINTRACH_9_reg                                                      0xB800E8B8
+#define PREDBLK_NBINTRACH_10_reg                                                      0xB800E8BC
+#define PREDBLK_NBINTRACH_11_reg                                                      0xB800E8C0
+#define PREDBLK_NBINTRACH_12_reg                                                      0xB800E8C4
+#define PREDBLK_NBINTRACH_13_reg                                                      0xB800E8C8
+#define PREDBLK_NBINTRACH_14_reg                                                      0xB800E8CC
+#define PREDBLK_NBINTRACH_15_reg                                                      0xB800E8D0
+#define set_PREDBLK_NBINTRACH_0_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_0_reg)=data)
+#define set_PREDBLK_NBINTRACH_1_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_1_reg)=data)
+#define set_PREDBLK_NBINTRACH_2_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_2_reg)=data)
+#define set_PREDBLK_NBINTRACH_3_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_3_reg)=data)
+#define set_PREDBLK_NBINTRACH_4_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_4_reg)=data)
+#define set_PREDBLK_NBINTRACH_5_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_5_reg)=data)
+#define set_PREDBLK_NBINTRACH_6_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_6_reg)=data)
+#define set_PREDBLK_NBINTRACH_7_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_7_reg)=data)
+#define set_PREDBLK_NBINTRACH_8_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_8_reg)=data)
+#define set_PREDBLK_NBINTRACH_9_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_9_reg)=data)
+#define set_PREDBLK_NBINTRACH_10_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_10_reg)=data)
+#define set_PREDBLK_NBINTRACH_11_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_11_reg)=data)
+#define set_PREDBLK_NBINTRACH_12_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_12_reg)=data)
+#define set_PREDBLK_NBINTRACH_13_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_13_reg)=data)
+#define set_PREDBLK_NBINTRACH_14_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_14_reg)=data)
+#define set_PREDBLK_NBINTRACH_15_reg(data)   (*((volatile unsigned int*) PREDBLK_NBINTRACH_15_reg)=data)
+#define get_PREDBLK_NBINTRACH_0_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_0_reg))
+#define get_PREDBLK_NBINTRACH_1_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_1_reg))
+#define get_PREDBLK_NBINTRACH_2_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_2_reg))
+#define get_PREDBLK_NBINTRACH_3_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_3_reg))
+#define get_PREDBLK_NBINTRACH_4_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_4_reg))
+#define get_PREDBLK_NBINTRACH_5_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_5_reg))
+#define get_PREDBLK_NBINTRACH_6_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_6_reg))
+#define get_PREDBLK_NBINTRACH_7_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_7_reg))
+#define get_PREDBLK_NBINTRACH_8_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_8_reg))
+#define get_PREDBLK_NBINTRACH_9_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_9_reg))
+#define get_PREDBLK_NBINTRACH_10_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_10_reg))
+#define get_PREDBLK_NBINTRACH_11_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_11_reg))
+#define get_PREDBLK_NBINTRACH_12_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_12_reg))
+#define get_PREDBLK_NBINTRACH_13_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_13_reg))
+#define get_PREDBLK_NBINTRACH_14_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_14_reg))
+#define get_PREDBLK_NBINTRACH_15_reg   (*((volatile unsigned int*) PREDBLK_NBINTRACH_15_reg))
+#define PREDBLK_NBINTRACH_0_inst_adr                                                 "0x0025"
+#define PREDBLK_NBINTRACH_1_inst_adr                                                 "0x0026"
+#define PREDBLK_NBINTRACH_2_inst_adr                                                 "0x0027"
+#define PREDBLK_NBINTRACH_3_inst_adr                                                 "0x0028"
+#define PREDBLK_NBINTRACH_4_inst_adr                                                 "0x0029"
+#define PREDBLK_NBINTRACH_5_inst_adr                                                 "0x002A"
+#define PREDBLK_NBINTRACH_6_inst_adr                                                 "0x002B"
+#define PREDBLK_NBINTRACH_7_inst_adr                                                 "0x002C"
+#define PREDBLK_NBINTRACH_8_inst_adr                                                 "0x002D"
+#define PREDBLK_NBINTRACH_9_inst_adr                                                 "0x002E"
+#define PREDBLK_NBINTRACH_10_inst_adr                                                 "0x002F"
+#define PREDBLK_NBINTRACH_11_inst_adr                                                 "0x0030"
+#define PREDBLK_NBINTRACH_12_inst_adr                                                 "0x0031"
+#define PREDBLK_NBINTRACH_13_inst_adr                                                 "0x0032"
+#define PREDBLK_NBINTRACH_14_inst_adr                                                 "0x0033"
+#define PREDBLK_NBINTRACH_15_inst_adr                                                 "0x0034"
+#define PREDBLK_NBINTRACH_0_inst                                                     0x0025
+#define PREDBLK_NBINTRACH_1_inst                                                     0x0026
+#define PREDBLK_NBINTRACH_2_inst                                                     0x0027
+#define PREDBLK_NBINTRACH_3_inst                                                     0x0028
+#define PREDBLK_NBINTRACH_4_inst                                                     0x0029
+#define PREDBLK_NBINTRACH_5_inst                                                     0x002A
+#define PREDBLK_NBINTRACH_6_inst                                                     0x002B
+#define PREDBLK_NBINTRACH_7_inst                                                     0x002C
+#define PREDBLK_NBINTRACH_8_inst                                                     0x002D
+#define PREDBLK_NBINTRACH_9_inst                                                     0x002E
+#define PREDBLK_NBINTRACH_10_inst                                                     0x002F
+#define PREDBLK_NBINTRACH_11_inst                                                     0x0030
+#define PREDBLK_NBINTRACH_12_inst                                                     0x0031
+#define PREDBLK_NBINTRACH_13_inst                                                     0x0032
+#define PREDBLK_NBINTRACH_14_inst                                                     0x0033
+#define PREDBLK_NBINTRACH_15_inst                                                     0x0034
+#define PREDBLK_NBINTRACH_intra_flag_shift                                           (0)
+#define PREDBLK_NBINTRACH_intra_flag_mask                                            (0xFFFFFFFF)
+#define PREDBLK_NBINTRACH_intra_flag(data)                                           (0xFFFFFFFF&((data)<<0))
+#define PREDBLK_NBINTRACH_intra_flag_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define PREDBLK_NBINTRACH_get_intra_flag(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define PREDBLK_NBFIELDOV_0                                                          0x1800E8D4
+#define PREDBLK_NBFIELDOV_1                                                          0x1800E8D8
+#define PREDBLK_NBFIELDOV_2                                                          0x1800E8DC
+#define PREDBLK_NBFIELDOV_3                                                          0x1800E8E0
+#define PREDBLK_NBFIELDOV_4                                                          0x1800E8E4
+#define PREDBLK_NBFIELDOV_5                                                          0x1800E8E8
+#define PREDBLK_NBFIELDOV_6                                                          0x1800E8EC
+#define PREDBLK_NBFIELDOV_7                                                          0x1800E8F0
+#define PREDBLK_NBFIELDOV_8                                                          0x1800E8F4
+#define PREDBLK_NBFIELDOV_9                                                          0x1800E8F8
+#define PREDBLK_NBFIELDOV_10                                                          0x1800E8FC
+#define PREDBLK_NBFIELDOV_11                                                          0x1800E900
+#define PREDBLK_NBFIELDOV_12                                                          0x1800E904
+#define PREDBLK_NBFIELDOV_13                                                          0x1800E908
+#define PREDBLK_NBFIELDOV_14                                                          0x1800E90C
+#define PREDBLK_NBFIELDOV_15                                                          0x1800E910
+#define PREDBLK_NBFIELDOV_0_reg_addr                                                 "0xB800E8D4"
+#define PREDBLK_NBFIELDOV_1_reg_addr                                                 "0xB800E8D8"
+#define PREDBLK_NBFIELDOV_2_reg_addr                                                 "0xB800E8DC"
+#define PREDBLK_NBFIELDOV_3_reg_addr                                                 "0xB800E8E0"
+#define PREDBLK_NBFIELDOV_4_reg_addr                                                 "0xB800E8E4"
+#define PREDBLK_NBFIELDOV_5_reg_addr                                                 "0xB800E8E8"
+#define PREDBLK_NBFIELDOV_6_reg_addr                                                 "0xB800E8EC"
+#define PREDBLK_NBFIELDOV_7_reg_addr                                                 "0xB800E8F0"
+#define PREDBLK_NBFIELDOV_8_reg_addr                                                 "0xB800E8F4"
+#define PREDBLK_NBFIELDOV_9_reg_addr                                                 "0xB800E8F8"
+#define PREDBLK_NBFIELDOV_10_reg_addr                                                 "0xB800E8FC"
+#define PREDBLK_NBFIELDOV_11_reg_addr                                                 "0xB800E900"
+#define PREDBLK_NBFIELDOV_12_reg_addr                                                 "0xB800E904"
+#define PREDBLK_NBFIELDOV_13_reg_addr                                                 "0xB800E908"
+#define PREDBLK_NBFIELDOV_14_reg_addr                                                 "0xB800E90C"
+#define PREDBLK_NBFIELDOV_15_reg_addr                                                 "0xB800E910"
+#define PREDBLK_NBFIELDOV_0_reg                                                      0xB800E8D4
+#define PREDBLK_NBFIELDOV_1_reg                                                      0xB800E8D8
+#define PREDBLK_NBFIELDOV_2_reg                                                      0xB800E8DC
+#define PREDBLK_NBFIELDOV_3_reg                                                      0xB800E8E0
+#define PREDBLK_NBFIELDOV_4_reg                                                      0xB800E8E4
+#define PREDBLK_NBFIELDOV_5_reg                                                      0xB800E8E8
+#define PREDBLK_NBFIELDOV_6_reg                                                      0xB800E8EC
+#define PREDBLK_NBFIELDOV_7_reg                                                      0xB800E8F0
+#define PREDBLK_NBFIELDOV_8_reg                                                      0xB800E8F4
+#define PREDBLK_NBFIELDOV_9_reg                                                      0xB800E8F8
+#define PREDBLK_NBFIELDOV_10_reg                                                      0xB800E8FC
+#define PREDBLK_NBFIELDOV_11_reg                                                      0xB800E900
+#define PREDBLK_NBFIELDOV_12_reg                                                      0xB800E904
+#define PREDBLK_NBFIELDOV_13_reg                                                      0xB800E908
+#define PREDBLK_NBFIELDOV_14_reg                                                      0xB800E90C
+#define PREDBLK_NBFIELDOV_15_reg                                                      0xB800E910
+#define set_PREDBLK_NBFIELDOV_0_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_0_reg)=data)
+#define set_PREDBLK_NBFIELDOV_1_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_1_reg)=data)
+#define set_PREDBLK_NBFIELDOV_2_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_2_reg)=data)
+#define set_PREDBLK_NBFIELDOV_3_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_3_reg)=data)
+#define set_PREDBLK_NBFIELDOV_4_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_4_reg)=data)
+#define set_PREDBLK_NBFIELDOV_5_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_5_reg)=data)
+#define set_PREDBLK_NBFIELDOV_6_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_6_reg)=data)
+#define set_PREDBLK_NBFIELDOV_7_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_7_reg)=data)
+#define set_PREDBLK_NBFIELDOV_8_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_8_reg)=data)
+#define set_PREDBLK_NBFIELDOV_9_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_9_reg)=data)
+#define set_PREDBLK_NBFIELDOV_10_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_10_reg)=data)
+#define set_PREDBLK_NBFIELDOV_11_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_11_reg)=data)
+#define set_PREDBLK_NBFIELDOV_12_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_12_reg)=data)
+#define set_PREDBLK_NBFIELDOV_13_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_13_reg)=data)
+#define set_PREDBLK_NBFIELDOV_14_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_14_reg)=data)
+#define set_PREDBLK_NBFIELDOV_15_reg(data)   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_15_reg)=data)
+#define get_PREDBLK_NBFIELDOV_0_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_0_reg))
+#define get_PREDBLK_NBFIELDOV_1_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_1_reg))
+#define get_PREDBLK_NBFIELDOV_2_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_2_reg))
+#define get_PREDBLK_NBFIELDOV_3_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_3_reg))
+#define get_PREDBLK_NBFIELDOV_4_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_4_reg))
+#define get_PREDBLK_NBFIELDOV_5_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_5_reg))
+#define get_PREDBLK_NBFIELDOV_6_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_6_reg))
+#define get_PREDBLK_NBFIELDOV_7_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_7_reg))
+#define get_PREDBLK_NBFIELDOV_8_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_8_reg))
+#define get_PREDBLK_NBFIELDOV_9_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_9_reg))
+#define get_PREDBLK_NBFIELDOV_10_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_10_reg))
+#define get_PREDBLK_NBFIELDOV_11_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_11_reg))
+#define get_PREDBLK_NBFIELDOV_12_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_12_reg))
+#define get_PREDBLK_NBFIELDOV_13_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_13_reg))
+#define get_PREDBLK_NBFIELDOV_14_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_14_reg))
+#define get_PREDBLK_NBFIELDOV_15_reg   (*((volatile unsigned int*) PREDBLK_NBFIELDOV_15_reg))
+#define PREDBLK_NBFIELDOV_0_inst_adr                                                 "0x0035"
+#define PREDBLK_NBFIELDOV_1_inst_adr                                                 "0x0036"
+#define PREDBLK_NBFIELDOV_2_inst_adr                                                 "0x0037"
+#define PREDBLK_NBFIELDOV_3_inst_adr                                                 "0x0038"
+#define PREDBLK_NBFIELDOV_4_inst_adr                                                 "0x0039"
+#define PREDBLK_NBFIELDOV_5_inst_adr                                                 "0x003A"
+#define PREDBLK_NBFIELDOV_6_inst_adr                                                 "0x003B"
+#define PREDBLK_NBFIELDOV_7_inst_adr                                                 "0x003C"
+#define PREDBLK_NBFIELDOV_8_inst_adr                                                 "0x003D"
+#define PREDBLK_NBFIELDOV_9_inst_adr                                                 "0x003E"
+#define PREDBLK_NBFIELDOV_10_inst_adr                                                 "0x003F"
+#define PREDBLK_NBFIELDOV_11_inst_adr                                                 "0x0040"
+#define PREDBLK_NBFIELDOV_12_inst_adr                                                 "0x0041"
+#define PREDBLK_NBFIELDOV_13_inst_adr                                                 "0x0042"
+#define PREDBLK_NBFIELDOV_14_inst_adr                                                 "0x0043"
+#define PREDBLK_NBFIELDOV_15_inst_adr                                                 "0x0044"
+#define PREDBLK_NBFIELDOV_0_inst                                                     0x0035
+#define PREDBLK_NBFIELDOV_1_inst                                                     0x0036
+#define PREDBLK_NBFIELDOV_2_inst                                                     0x0037
+#define PREDBLK_NBFIELDOV_3_inst                                                     0x0038
+#define PREDBLK_NBFIELDOV_4_inst                                                     0x0039
+#define PREDBLK_NBFIELDOV_5_inst                                                     0x003A
+#define PREDBLK_NBFIELDOV_6_inst                                                     0x003B
+#define PREDBLK_NBFIELDOV_7_inst                                                     0x003C
+#define PREDBLK_NBFIELDOV_8_inst                                                     0x003D
+#define PREDBLK_NBFIELDOV_9_inst                                                     0x003E
+#define PREDBLK_NBFIELDOV_10_inst                                                     0x003F
+#define PREDBLK_NBFIELDOV_11_inst                                                     0x0040
+#define PREDBLK_NBFIELDOV_12_inst                                                     0x0041
+#define PREDBLK_NBFIELDOV_13_inst                                                     0x0042
+#define PREDBLK_NBFIELDOV_14_inst                                                     0x0043
+#define PREDBLK_NBFIELDOV_15_inst                                                     0x0044
+#define PREDBLK_NBFIELDOV_Field_overflag_flag_shift                                  (0)
+#define PREDBLK_NBFIELDOV_Field_overflag_flag_mask                                   (0xFFFFFFFF)
+#define PREDBLK_NBFIELDOV_Field_overflag_flag(data)                                  (0xFFFFFFFF&((data)<<0))
+#define PREDBLK_NBFIELDOV_Field_overflag_flag_src(data)                              ((0xFFFFFFFF&(data))>>0)
+#define PREDBLK_NBFIELDOV_get_Field_overflag_flag(data)                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define PREDBLK_NBEXTRA                                                              0x1800E914
+#define PREDBLK_NBEXTRA_reg_addr                                                     "0xB800E914"
+#define PREDBLK_NBEXTRA_reg                                                          0xB800E914
+#define set_PREDBLK_NBEXTRA_reg(data)   (*((volatile unsigned int*) PREDBLK_NBEXTRA_reg)=data)
+#define get_PREDBLK_NBEXTRA_reg   (*((volatile unsigned int*) PREDBLK_NBEXTRA_reg))
+#define PREDBLK_NBEXTRA_inst_adr                                                     "0x0045"
+#define PREDBLK_NBEXTRA_inst                                                         0x0045
+#define PREDBLK_NBEXTRA_Intra0_shift                                                 (3)
+#define PREDBLK_NBEXTRA_Intra0_mask                                                  (0x00000008)
+#define PREDBLK_NBEXTRA_Intra0(data)                                                 (0x00000008&((data)<<3))
+#define PREDBLK_NBEXTRA_Intra0_src(data)                                             ((0x00000008&(data))>>3)
+#define PREDBLK_NBEXTRA_get_Intra0(data)                                             ((0x00000008&(data))>>3)
+#define PREDBLK_NBEXTRA_Intra1_shift                                                 (2)
+#define PREDBLK_NBEXTRA_Intra1_mask                                                  (0x00000004)
+#define PREDBLK_NBEXTRA_Intra1(data)                                                 (0x00000004&((data)<<2))
+#define PREDBLK_NBEXTRA_Intra1_src(data)                                             ((0x00000004&(data))>>2)
+#define PREDBLK_NBEXTRA_get_Intra1(data)                                             ((0x00000004&(data))>>2)
+#define PREDBLK_NBEXTRA_IntraChroma_shift                                            (1)
+#define PREDBLK_NBEXTRA_IntraChroma_mask                                             (0x00000002)
+#define PREDBLK_NBEXTRA_IntraChroma(data)                                            (0x00000002&((data)<<1))
+#define PREDBLK_NBEXTRA_IntraChroma_src(data)                                        ((0x00000002&(data))>>1)
+#define PREDBLK_NBEXTRA_get_IntraChroma(data)                                        ((0x00000002&(data))>>1)
+#define PREDBLK_NBEXTRA_IntraField_shift                                             (0)
+#define PREDBLK_NBEXTRA_IntraField_mask                                              (0x00000001)
+#define PREDBLK_NBEXTRA_IntraField(data)                                             (0x00000001&((data)<<0))
+#define PREDBLK_NBEXTRA_IntraField_src(data)                                         ((0x00000001&(data))>>0)
+#define PREDBLK_NBEXTRA_get_IntraField(data)                                         ((0x00000001&(data))>>0)
+
+
+#define PREDBLK_WTBLSA                                                               0x1800E918
+#define PREDBLK_WTBLSA_reg_addr                                                      "0xB800E918"
+#define PREDBLK_WTBLSA_reg                                                           0xB800E918
+#define set_PREDBLK_WTBLSA_reg(data)   (*((volatile unsigned int*) PREDBLK_WTBLSA_reg)=data)
+#define get_PREDBLK_WTBLSA_reg   (*((volatile unsigned int*) PREDBLK_WTBLSA_reg))
+#define PREDBLK_WTBLSA_inst_adr                                                      "0x0046"
+#define PREDBLK_WTBLSA_inst                                                          0x0046
+#define PREDBLK_WTBLSA_WTBL_StartA_shift                                             (0)
+#define PREDBLK_WTBLSA_WTBL_StartA_mask                                              (0x000003FF)
+#define PREDBLK_WTBLSA_WTBL_StartA(data)                                             (0x000003FF&((data)<<0))
+#define PREDBLK_WTBLSA_WTBL_StartA_src(data)                                         ((0x000003FF&(data))>>0)
+#define PREDBLK_WTBLSA_get_WTBL_StartA(data)                                         ((0x000003FF&(data))>>0)
+
+
+#define PREDBLK_WTFLAG_0                                                             0x1800E91C
+#define PREDBLK_WTFLAG_1                                                             0x1800E920
+#define PREDBLK_WTFLAG_2                                                             0x1800E924
+#define PREDBLK_WTFLAG_3                                                             0x1800E928
+#define PREDBLK_WTFLAG_0_reg_addr                                                    "0xB800E91C"
+#define PREDBLK_WTFLAG_1_reg_addr                                                    "0xB800E920"
+#define PREDBLK_WTFLAG_2_reg_addr                                                    "0xB800E924"
+#define PREDBLK_WTFLAG_3_reg_addr                                                    "0xB800E928"
+#define PREDBLK_WTFLAG_0_reg                                                         0xB800E91C
+#define PREDBLK_WTFLAG_1_reg                                                         0xB800E920
+#define PREDBLK_WTFLAG_2_reg                                                         0xB800E924
+#define PREDBLK_WTFLAG_3_reg                                                         0xB800E928
+#define set_PREDBLK_WTFLAG_0_reg(data)   (*((volatile unsigned int*) PREDBLK_WTFLAG_0_reg)=data)
+#define set_PREDBLK_WTFLAG_1_reg(data)   (*((volatile unsigned int*) PREDBLK_WTFLAG_1_reg)=data)
+#define set_PREDBLK_WTFLAG_2_reg(data)   (*((volatile unsigned int*) PREDBLK_WTFLAG_2_reg)=data)
+#define set_PREDBLK_WTFLAG_3_reg(data)   (*((volatile unsigned int*) PREDBLK_WTFLAG_3_reg)=data)
+#define get_PREDBLK_WTFLAG_0_reg   (*((volatile unsigned int*) PREDBLK_WTFLAG_0_reg))
+#define get_PREDBLK_WTFLAG_1_reg   (*((volatile unsigned int*) PREDBLK_WTFLAG_1_reg))
+#define get_PREDBLK_WTFLAG_2_reg   (*((volatile unsigned int*) PREDBLK_WTFLAG_2_reg))
+#define get_PREDBLK_WTFLAG_3_reg   (*((volatile unsigned int*) PREDBLK_WTFLAG_3_reg))
+#define PREDBLK_WTFLAG_0_inst_adr                                                    "0x0047"
+#define PREDBLK_WTFLAG_1_inst_adr                                                    "0x0048"
+#define PREDBLK_WTFLAG_2_inst_adr                                                    "0x0049"
+#define PREDBLK_WTFLAG_3_inst_adr                                                    "0x004A"
+#define PREDBLK_WTFLAG_0_inst                                                        0x0047
+#define PREDBLK_WTFLAG_1_inst                                                        0x0048
+#define PREDBLK_WTFLAG_2_inst                                                        0x0049
+#define PREDBLK_WTFLAG_3_inst                                                        0x004A
+#define PREDBLK_WTFLAG_wt_flag_shift                                                 (0)
+#define PREDBLK_WTFLAG_wt_flag_mask                                                  (0xFFFFFFFF)
+#define PREDBLK_WTFLAG_wt_flag(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define PREDBLK_WTFLAG_wt_flag_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define PREDBLK_WTFLAG_get_wt_flag(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define PREDBLK_SDMAADR                                                              0x1800E92C
+#define PREDBLK_SDMAADR_reg_addr                                                     "0xB800E92C"
+#define PREDBLK_SDMAADR_reg                                                          0xB800E92C
+#define set_PREDBLK_SDMAADR_reg(data)   (*((volatile unsigned int*) PREDBLK_SDMAADR_reg)=data)
+#define get_PREDBLK_SDMAADR_reg   (*((volatile unsigned int*) PREDBLK_SDMAADR_reg))
+#define PREDBLK_SDMAADR_inst_adr                                                     "0x004B"
+#define PREDBLK_SDMAADR_inst                                                         0x004B
+#define PREDBLK_SDMAADR_Wdone_enable_shift                                           (31)
+#define PREDBLK_SDMAADR_Wdone_enable_mask                                            (0x80000000)
+#define PREDBLK_SDMAADR_Wdone_enable(data)                                           (0x80000000&((data)<<31))
+#define PREDBLK_SDMAADR_Wdone_enable_src(data)                                       ((0x80000000&(data))>>31)
+#define PREDBLK_SDMAADR_get_Wdone_enable(data)                                       ((0x80000000&(data))>>31)
+#define PREDBLK_SDMAADR_Mem_eng_busy_shift                                           (30)
+#define PREDBLK_SDMAADR_Mem_eng_busy_mask                                            (0x40000000)
+#define PREDBLK_SDMAADR_Mem_eng_busy(data)                                           (0x40000000&((data)<<30))
+#define PREDBLK_SDMAADR_Mem_eng_busy_src(data)                                       ((0x40000000&(data))>>30)
+#define PREDBLK_SDMAADR_get_Mem_eng_busy(data)                                       ((0x40000000&(data))>>30)
+#define PREDBLK_SDMAADR_seq_line_addr_shift                                          (0)
+#define PREDBLK_SDMAADR_seq_line_addr_mask                                           (0x1FFFFFFF)
+#define PREDBLK_SDMAADR_seq_line_addr(data)                                          (0x1FFFFFFF&((data)<<0))
+#define PREDBLK_SDMAADR_seq_line_addr_src(data)                                      ((0x1FFFFFFF&(data))>>0)
+#define PREDBLK_SDMAADR_get_seq_line_addr(data)                                      ((0x1FFFFFFF&(data))>>0)
+
+
+#define PREDBLK_INTR_THRESH                                                          0x1800E930
+#define PREDBLK_INTR_THRESH_reg_addr                                                 "0xB800E930"
+#define PREDBLK_INTR_THRESH_reg                                                      0xB800E930
+#define set_PREDBLK_INTR_THRESH_reg(data)   (*((volatile unsigned int*) PREDBLK_INTR_THRESH_reg)=data)
+#define get_PREDBLK_INTR_THRESH_reg   (*((volatile unsigned int*) PREDBLK_INTR_THRESH_reg))
+#define PREDBLK_INTR_THRESH_inst_adr                                                 "0x004C"
+#define PREDBLK_INTR_THRESH_inst                                                     0x004C
+#define PREDBLK_INTR_THRESH_Value_shift                                              (0)
+#define PREDBLK_INTR_THRESH_Value_mask                                               (0x0FFFFFFF)
+#define PREDBLK_INTR_THRESH_Value(data)                                              (0x0FFFFFFF&((data)<<0))
+#define PREDBLK_INTR_THRESH_Value_src(data)                                          ((0x0FFFFFFF&(data))>>0)
+#define PREDBLK_INTR_THRESH_get_Value(data)                                          ((0x0FFFFFFF&(data))>>0)
+
+
+#define PREDBLK_BUSY                                                                 0x1800E934
+#define PREDBLK_BUSY_reg_addr                                                        "0xB800E934"
+#define PREDBLK_BUSY_reg                                                             0xB800E934
+#define set_PREDBLK_BUSY_reg(data)   (*((volatile unsigned int*) PREDBLK_BUSY_reg)=data)
+#define get_PREDBLK_BUSY_reg   (*((volatile unsigned int*) PREDBLK_BUSY_reg))
+#define PREDBLK_BUSY_inst_adr                                                        "0x004D"
+#define PREDBLK_BUSY_inst                                                            0x004D
+#define PREDBLK_BUSY_Reach_Thresh_shift                                              (28)
+#define PREDBLK_BUSY_Reach_Thresh_mask                                               (0x10000000)
+#define PREDBLK_BUSY_Reach_Thresh(data)                                              (0x10000000&((data)<<28))
+#define PREDBLK_BUSY_Reach_Thresh_src(data)                                          ((0x10000000&(data))>>28)
+#define PREDBLK_BUSY_get_Reach_Thresh(data)                                          ((0x10000000&(data))>>28)
+#define PREDBLK_BUSY_Count_shift                                                     (0)
+#define PREDBLK_BUSY_Count_mask                                                      (0x0FFFFFFF)
+#define PREDBLK_BUSY_Count(data)                                                     (0x0FFFFFFF&((data)<<0))
+#define PREDBLK_BUSY_Count_src(data)                                                 ((0x0FFFFFFF&(data))>>0)
+#define PREDBLK_BUSY_get_Count(data)                                                 ((0x0FFFFFFF&(data))>>0)
+
+
+#define PREDBLK_BASEA                                                                0x1800E938
+#define PREDBLK_BASEA_reg_addr                                                       "0xB800E938"
+#define PREDBLK_BASEA_reg                                                            0xB800E938
+#define set_PREDBLK_BASEA_reg(data)   (*((volatile unsigned int*) PREDBLK_BASEA_reg)=data)
+#define get_PREDBLK_BASEA_reg   (*((volatile unsigned int*) PREDBLK_BASEA_reg))
+#define PREDBLK_BASEA_inst_adr                                                       "0x004E"
+#define PREDBLK_BASEA_inst                                                           0x004E
+#define PREDBLK_BASEA_BaseA0_shift                                                   (16)
+#define PREDBLK_BASEA_BaseA0_mask                                                    (0x007F0000)
+#define PREDBLK_BASEA_BaseA0(data)                                                   (0x007F0000&((data)<<16))
+#define PREDBLK_BASEA_BaseA0_src(data)                                               ((0x007F0000&(data))>>16)
+#define PREDBLK_BASEA_get_BaseA0(data)                                               ((0x007F0000&(data))>>16)
+#define PREDBLK_BASEA_BaseA1_shift                                                   (3)
+#define PREDBLK_BASEA_BaseA1_mask                                                    (0x000003F8)
+#define PREDBLK_BASEA_BaseA1(data)                                                   (0x000003F8&((data)<<3))
+#define PREDBLK_BASEA_BaseA1_src(data)                                               ((0x000003F8&(data))>>3)
+#define PREDBLK_BASEA_get_BaseA1(data)                                               ((0x000003F8&(data))>>3)
+
+
+#define PREDBLK_OFFSETA_0                                                            0x1800E93C
+#define PREDBLK_OFFSETA_1                                                            0x1800E940
+#define PREDBLK_OFFSETA_2                                                            0x1800E944
+#define PREDBLK_OFFSETA_0_reg_addr                                                   "0xB800E93C"
+#define PREDBLK_OFFSETA_1_reg_addr                                                   "0xB800E940"
+#define PREDBLK_OFFSETA_2_reg_addr                                                   "0xB800E944"
+#define PREDBLK_OFFSETA_0_reg                                                        0xB800E93C
+#define PREDBLK_OFFSETA_1_reg                                                        0xB800E940
+#define PREDBLK_OFFSETA_2_reg                                                        0xB800E944
+#define set_PREDBLK_OFFSETA_0_reg(data)   (*((volatile unsigned int*) PREDBLK_OFFSETA_0_reg)=data)
+#define set_PREDBLK_OFFSETA_1_reg(data)   (*((volatile unsigned int*) PREDBLK_OFFSETA_1_reg)=data)
+#define set_PREDBLK_OFFSETA_2_reg(data)   (*((volatile unsigned int*) PREDBLK_OFFSETA_2_reg)=data)
+#define get_PREDBLK_OFFSETA_0_reg   (*((volatile unsigned int*) PREDBLK_OFFSETA_0_reg))
+#define get_PREDBLK_OFFSETA_1_reg   (*((volatile unsigned int*) PREDBLK_OFFSETA_1_reg))
+#define get_PREDBLK_OFFSETA_2_reg   (*((volatile unsigned int*) PREDBLK_OFFSETA_2_reg))
+#define PREDBLK_OFFSETA_0_inst_adr                                                   "0x004F"
+#define PREDBLK_OFFSETA_1_inst_adr                                                   "0x0050"
+#define PREDBLK_OFFSETA_2_inst_adr                                                   "0x0051"
+#define PREDBLK_OFFSETA_0_inst                                                       0x004F
+#define PREDBLK_OFFSETA_1_inst                                                       0x0050
+#define PREDBLK_OFFSETA_2_inst                                                       0x0051
+#define PREDBLK_OFFSETA_OffsetA_shift                                                (3)
+#define PREDBLK_OFFSETA_OffsetA_mask                                                 (0x000003F8)
+#define PREDBLK_OFFSETA_OffsetA(data)                                                (0x000003F8&((data)<<3))
+#define PREDBLK_OFFSETA_OffsetA_src(data)                                            ((0x000003F8&(data))>>3)
+#define PREDBLK_OFFSETA_get_OffsetA(data)                                            ((0x000003F8&(data))>>3)
+
+
+#define PREDBLK_DEBPAR                                                               0x1800E948
+#define PREDBLK_DEBPAR_reg_addr                                                      "0xB800E948"
+#define PREDBLK_DEBPAR_reg                                                           0xB800E948
+#define set_PREDBLK_DEBPAR_reg(data)   (*((volatile unsigned int*) PREDBLK_DEBPAR_reg)=data)
+#define get_PREDBLK_DEBPAR_reg   (*((volatile unsigned int*) PREDBLK_DEBPAR_reg))
+#define PREDBLK_DEBPAR_inst_adr                                                      "0x0052"
+#define PREDBLK_DEBPAR_inst                                                          0x0052
+#define PREDBLK_DEBPAR_StartA_shift                                                  (0)
+#define PREDBLK_DEBPAR_StartA_mask                                                   (0x0000007F)
+#define PREDBLK_DEBPAR_StartA(data)                                                  (0x0000007F&((data)<<0))
+#define PREDBLK_DEBPAR_StartA_src(data)                                              ((0x0000007F&(data))>>0)
+#define PREDBLK_DEBPAR_get_StartA(data)                                              ((0x0000007F&(data))>>0)
+
+
+#define PREDBLK_MPEGCTL                                                              0x1800E94C
+#define PREDBLK_MPEGCTL_reg_addr                                                     "0xB800E94C"
+#define PREDBLK_MPEGCTL_reg                                                          0xB800E94C
+#define set_PREDBLK_MPEGCTL_reg(data)   (*((volatile unsigned int*) PREDBLK_MPEGCTL_reg)=data)
+#define get_PREDBLK_MPEGCTL_reg   (*((volatile unsigned int*) PREDBLK_MPEGCTL_reg))
+#define PREDBLK_MPEGCTL_inst_adr                                                     "0x0053"
+#define PREDBLK_MPEGCTL_inst                                                         0x0053
+#define PREDBLK_MPEGCTL_Rounding_Control_shift                                       (1)
+#define PREDBLK_MPEGCTL_Rounding_Control_mask                                        (0x00000002)
+#define PREDBLK_MPEGCTL_Rounding_Control(data)                                       (0x00000002&((data)<<1))
+#define PREDBLK_MPEGCTL_Rounding_Control_src(data)                                   ((0x00000002&(data))>>1)
+#define PREDBLK_MPEGCTL_get_Rounding_Control(data)                                   ((0x00000002&(data))>>1)
+#define PREDBLK_MPEGCTL_Quarter_Sample_shift                                         (0)
+#define PREDBLK_MPEGCTL_Quarter_Sample_mask                                          (0x00000001)
+#define PREDBLK_MPEGCTL_Quarter_Sample(data)                                         (0x00000001&((data)<<0))
+#define PREDBLK_MPEGCTL_Quarter_Sample_src(data)                                     ((0x00000001&(data))>>0)
+#define PREDBLK_MPEGCTL_get_Quarter_Sample(data)                                     ((0x00000001&(data))>>0)
+
+
+#define PREDBLK_RMEMDDR1                                                             0x1800E950
+#define PREDBLK_RMEMDDR1_reg_addr                                                    "0xB800E950"
+#define PREDBLK_RMEMDDR1_reg                                                         0xB800E950
+#define set_PREDBLK_RMEMDDR1_reg(data)   (*((volatile unsigned int*) PREDBLK_RMEMDDR1_reg)=data)
+#define get_PREDBLK_RMEMDDR1_reg   (*((volatile unsigned int*) PREDBLK_RMEMDDR1_reg))
+#define PREDBLK_RMEMDDR1_inst_adr                                                    "0x0054"
+#define PREDBLK_RMEMDDR1_inst                                                        0x0054
+#define PREDBLK_RMEMDDR1_Valid_shift                                                 (31)
+#define PREDBLK_RMEMDDR1_Valid_mask                                                  (0x80000000)
+#define PREDBLK_RMEMDDR1_Valid(data)                                                 (0x80000000&((data)<<31))
+#define PREDBLK_RMEMDDR1_Valid_src(data)                                             ((0x80000000&(data))>>31)
+#define PREDBLK_RMEMDDR1_get_Valid(data)                                             ((0x80000000&(data))>>31)
+#define PREDBLK_RMEMDDR1_Base_addr_shift                                             (3)
+#define PREDBLK_RMEMDDR1_Base_addr_mask                                              (0x1FFFFFF8)
+#define PREDBLK_RMEMDDR1_Base_addr(data)                                             (0x1FFFFFF8&((data)<<3))
+#define PREDBLK_RMEMDDR1_Base_addr_src(data)                                         ((0x1FFFFFF8&(data))>>3)
+#define PREDBLK_RMEMDDR1_get_Base_addr(data)                                         ((0x1FFFFFF8&(data))>>3)
+
+
+#define PREDBLK_RMEMDDR2                                                             0x1800E954
+#define PREDBLK_RMEMDDR2_reg_addr                                                    "0xB800E954"
+#define PREDBLK_RMEMDDR2_reg                                                         0xB800E954
+#define set_PREDBLK_RMEMDDR2_reg(data)   (*((volatile unsigned int*) PREDBLK_RMEMDDR2_reg)=data)
+#define get_PREDBLK_RMEMDDR2_reg   (*((volatile unsigned int*) PREDBLK_RMEMDDR2_reg))
+#define PREDBLK_RMEMDDR2_inst_adr                                                    "0x0055"
+#define PREDBLK_RMEMDDR2_inst                                                        0x0055
+#define PREDBLK_RMEMDDR2_MBCnt_threshold_shift                                       (0)
+#define PREDBLK_RMEMDDR2_MBCnt_threshold_mask                                        (0xFFFFFFFF)
+#define PREDBLK_RMEMDDR2_MBCnt_threshold(data)                                       (0xFFFFFFFF&((data)<<0))
+#define PREDBLK_RMEMDDR2_MBCnt_threshold_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define PREDBLK_RMEMDDR2_get_MBCnt_threshold(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define PREDBLK_RMEMCTL                                                              0x1800E958
+#define PREDBLK_RMEMCTL_reg_addr                                                     "0xB800E958"
+#define PREDBLK_RMEMCTL_reg                                                          0xB800E958
+#define set_PREDBLK_RMEMCTL_reg(data)   (*((volatile unsigned int*) PREDBLK_RMEMCTL_reg)=data)
+#define get_PREDBLK_RMEMCTL_reg   (*((volatile unsigned int*) PREDBLK_RMEMCTL_reg))
+#define PREDBLK_RMEMCTL_inst_adr                                                     "0x0056"
+#define PREDBLK_RMEMCTL_inst                                                         0x0056
+#define PREDBLK_RMEMCTL_Valid_shift                                                  (31)
+#define PREDBLK_RMEMCTL_Valid_mask                                                   (0x80000000)
+#define PREDBLK_RMEMCTL_Valid(data)                                                  (0x80000000&((data)<<31))
+#define PREDBLK_RMEMCTL_Valid_src(data)                                              ((0x80000000&(data))>>31)
+#define PREDBLK_RMEMCTL_get_Valid(data)                                              ((0x80000000&(data))>>31)
+#define PREDBLK_RMEMCTL_Start_Addr_shift                                             (7)
+#define PREDBLK_RMEMCTL_Start_Addr_mask                                              (0x00003F80)
+#define PREDBLK_RMEMCTL_Start_Addr(data)                                             (0x00003F80&((data)<<7))
+#define PREDBLK_RMEMCTL_Start_Addr_src(data)                                         ((0x00003F80&(data))>>7)
+#define PREDBLK_RMEMCTL_get_Start_Addr(data)                                         ((0x00003F80&(data))>>7)
+#define PREDBLK_RMEMCTL_End_Addr_shift                                               (0)
+#define PREDBLK_RMEMCTL_End_Addr_mask                                                (0x0000007F)
+#define PREDBLK_RMEMCTL_End_Addr(data)                                               (0x0000007F&((data)<<0))
+#define PREDBLK_RMEMCTL_End_Addr_src(data)                                           ((0x0000007F&(data))>>0)
+#define PREDBLK_RMEMCTL_get_End_Addr(data)                                           ((0x0000007F&(data))>>0)
+
+
+#define PREDBLK_URATIO_0                                                             0x1800E95C
+#define PREDBLK_URATIO_1                                                             0x1800E960
+#define PREDBLK_URATIO_0_reg_addr                                                    "0xB800E95C"
+#define PREDBLK_URATIO_1_reg_addr                                                    "0xB800E960"
+#define PREDBLK_URATIO_0_reg                                                         0xB800E95C
+#define PREDBLK_URATIO_1_reg                                                         0xB800E960
+#define set_PREDBLK_URATIO_0_reg(data)   (*((volatile unsigned int*) PREDBLK_URATIO_0_reg)=data)
+#define set_PREDBLK_URATIO_1_reg(data)   (*((volatile unsigned int*) PREDBLK_URATIO_1_reg)=data)
+#define get_PREDBLK_URATIO_0_reg   (*((volatile unsigned int*) PREDBLK_URATIO_0_reg))
+#define get_PREDBLK_URATIO_1_reg   (*((volatile unsigned int*) PREDBLK_URATIO_1_reg))
+#define PREDBLK_URATIO_0_inst_adr                                                    "0x0057"
+#define PREDBLK_URATIO_1_inst_adr                                                    "0x0058"
+#define PREDBLK_URATIO_0_inst                                                        0x0057
+#define PREDBLK_URATIO_1_inst                                                        0x0058
+#define PREDBLK_URATIO_URatio_shift                                                  (0)
+#define PREDBLK_URATIO_URatio_mask                                                   (0x00007FFF)
+#define PREDBLK_URATIO_URatio(data)                                                  (0x00007FFF&((data)<<0))
+#define PREDBLK_URATIO_URatio_src(data)                                              ((0x00007FFF&(data))>>0)
+#define PREDBLK_URATIO_get_URatio(data)                                              ((0x00007FFF&(data))>>0)
+
+
+#define PREDBLK_VP6CTRL                                                              0x1800E964
+#define PREDBLK_VP6CTRL_reg_addr                                                     "0xB800E964"
+#define PREDBLK_VP6CTRL_reg                                                          0xB800E964
+#define set_PREDBLK_VP6CTRL_reg(data)   (*((volatile unsigned int*) PREDBLK_VP6CTRL_reg)=data)
+#define get_PREDBLK_VP6CTRL_reg   (*((volatile unsigned int*) PREDBLK_VP6CTRL_reg))
+#define PREDBLK_VP6CTRL_inst_adr                                                     "0x0059"
+#define PREDBLK_VP6CTRL_inst                                                         0x0059
+#define PREDBLK_VP6CTRL_VP6_1_shift                                                  (25)
+#define PREDBLK_VP6CTRL_VP6_1_mask                                                   (0x02000000)
+#define PREDBLK_VP6CTRL_VP6_1(data)                                                  (0x02000000&((data)<<25))
+#define PREDBLK_VP6CTRL_VP6_1_src(data)                                              ((0x02000000&(data))>>25)
+#define PREDBLK_VP6CTRL_get_VP6_1(data)                                              ((0x02000000&(data))>>25)
+#define PREDBLK_VP6CTRL_AutoSelectPMFlag_shift                                       (24)
+#define PREDBLK_VP6CTRL_AutoSelectPMFlag_mask                                        (0x01000000)
+#define PREDBLK_VP6CTRL_AutoSelectPMFlag(data)                                       (0x01000000&((data)<<24))
+#define PREDBLK_VP6CTRL_AutoSelectPMFlag_src(data)                                   ((0x01000000&(data))>>24)
+#define PREDBLK_VP6CTRL_get_AutoSelectPMFlag(data)                                   ((0x01000000&(data))>>24)
+#define PREDBLK_VP6CTRL_BicubicFiltFlag_shift                                        (23)
+#define PREDBLK_VP6CTRL_BicubicFiltFlag_mask                                         (0x00800000)
+#define PREDBLK_VP6CTRL_BicubicFiltFlag(data)                                        (0x00800000&((data)<<23))
+#define PREDBLK_VP6CTRL_BicubicFiltFlag_src(data)                                    ((0x00800000&(data))>>23)
+#define PREDBLK_VP6CTRL_get_BicubicFiltFlag(data)                                    ((0x00800000&(data))>>23)
+#define PREDBLK_VP6CTRL_Sample_var_thresh_shift                                      (13)
+#define PREDBLK_VP6CTRL_Sample_var_thresh_mask                                       (0x007FE000)
+#define PREDBLK_VP6CTRL_Sample_var_thresh(data)                                      (0x007FE000&((data)<<13))
+#define PREDBLK_VP6CTRL_Sample_var_thresh_src(data)                                  ((0x007FE000&(data))>>13)
+#define PREDBLK_VP6CTRL_get_Sample_var_thresh(data)                                  ((0x007FE000&(data))>>13)
+#define PREDBLK_VP6CTRL_Max_vec_length_shift                                         (4)
+#define PREDBLK_VP6CTRL_Max_vec_length_mask                                          (0x00001FF0)
+#define PREDBLK_VP6CTRL_Max_vec_length(data)                                         (0x00001FF0&((data)<<4))
+#define PREDBLK_VP6CTRL_Max_vec_length_src(data)                                     ((0x00001FF0&(data))>>4)
+#define PREDBLK_VP6CTRL_get_Max_vec_length(data)                                     ((0x00001FF0&(data))>>4)
+#define PREDBLK_VP6CTRL_Bicubic_filt_sel_shift                                       (0)
+#define PREDBLK_VP6CTRL_Bicubic_filt_sel_mask                                        (0x0000000F)
+#define PREDBLK_VP6CTRL_Bicubic_filt_sel(data)                                       (0x0000000F&((data)<<0))
+#define PREDBLK_VP6CTRL_Bicubic_filt_sel_src(data)                                   ((0x0000000F&(data))>>0)
+#define PREDBLK_VP6CTRL_get_Bicubic_filt_sel(data)                                   ((0x0000000F&(data))>>0)
+
+
+#define PREDBLK_DBUS                                                                 0x1800E968
+#define PREDBLK_DBUS_reg_addr                                                        "0xB800E968"
+#define PREDBLK_DBUS_reg                                                             0xB800E968
+#define set_PREDBLK_DBUS_reg(data)   (*((volatile unsigned int*) PREDBLK_DBUS_reg)=data)
+#define get_PREDBLK_DBUS_reg   (*((volatile unsigned int*) PREDBLK_DBUS_reg))
+#define PREDBLK_DBUS_inst_adr                                                        "0x005A"
+#define PREDBLK_DBUS_inst                                                            0x005A
+#define PREDBLK_DBUS_GenPulse_shift                                                  (31)
+#define PREDBLK_DBUS_GenPulse_mask                                                   (0x80000000)
+#define PREDBLK_DBUS_GenPulse(data)                                                  (0x80000000&((data)<<31))
+#define PREDBLK_DBUS_GenPulse_src(data)                                              ((0x80000000&(data))>>31)
+#define PREDBLK_DBUS_get_GenPulse(data)                                              ((0x80000000&(data))>>31)
+#define PREDBLK_DBUS_PicCount_shift                                                  (17)
+#define PREDBLK_DBUS_PicCount_mask                                                   (0x7FFE0000)
+#define PREDBLK_DBUS_PicCount(data)                                                  (0x7FFE0000&((data)<<17))
+#define PREDBLK_DBUS_PicCount_src(data)                                              ((0x7FFE0000&(data))>>17)
+#define PREDBLK_DBUS_get_PicCount(data)                                              ((0x7FFE0000&(data))>>17)
+#define PREDBLK_DBUS_MbAddrX_shift                                                   (8)
+#define PREDBLK_DBUS_MbAddrX_mask                                                    (0x0001FF00)
+#define PREDBLK_DBUS_MbAddrX(data)                                                   (0x0001FF00&((data)<<8))
+#define PREDBLK_DBUS_MbAddrX_src(data)                                               ((0x0001FF00&(data))>>8)
+#define PREDBLK_DBUS_get_MbAddrX(data)                                               ((0x0001FF00&(data))>>8)
+#define PREDBLK_DBUS_MbAddrY_shift                                                   (0)
+#define PREDBLK_DBUS_MbAddrY_mask                                                    (0x000000FF)
+#define PREDBLK_DBUS_MbAddrY(data)                                                   (0x000000FF&((data)<<0))
+#define PREDBLK_DBUS_MbAddrY_src(data)                                               ((0x000000FF&(data))>>0)
+#define PREDBLK_DBUS_get_MbAddrY(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define PREDBLK_DBUS2                                                                0x1800E96C
+#define PREDBLK_DBUS2_reg_addr                                                       "0xB800E96C"
+#define PREDBLK_DBUS2_reg                                                            0xB800E96C
+#define set_PREDBLK_DBUS2_reg(data)   (*((volatile unsigned int*) PREDBLK_DBUS2_reg)=data)
+#define get_PREDBLK_DBUS2_reg   (*((volatile unsigned int*) PREDBLK_DBUS2_reg))
+#define PREDBLK_DBUS2_inst_adr                                                       "0x005B"
+#define PREDBLK_DBUS2_inst                                                           0x005B
+#define PREDBLK_DBUS2_DbgCtrl_shift                                                  (0)
+#define PREDBLK_DBUS2_DbgCtrl_mask                                                   (0xFFFFFFFF)
+#define PREDBLK_DBUS2_DbgCtrl(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define PREDBLK_DBUS2_DbgCtrl_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define PREDBLK_DBUS2_get_DbgCtrl(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define PREDBLK_DBUS3                                                                0x1800E9A8
+#define PREDBLK_DBUS3_reg_addr                                                       "0xB800E9A8"
+#define PREDBLK_DBUS3_reg                                                            0xB800E9A8
+#define set_PREDBLK_DBUS3_reg(data)   (*((volatile unsigned int*) PREDBLK_DBUS3_reg)=data)
+#define get_PREDBLK_DBUS3_reg   (*((volatile unsigned int*) PREDBLK_DBUS3_reg))
+#define PREDBLK_DBUS3_inst_adr                                                       "0x006A"
+#define PREDBLK_DBUS3_inst                                                           0x006A
+#define PREDBLK_DBUS3_DbgCtrl3_shift                                                 (3)
+#define PREDBLK_DBUS3_DbgCtrl3_mask                                                  (0xFFFFFFF8)
+#define PREDBLK_DBUS3_DbgCtrl3(data)                                                 (0xFFFFFFF8&((data)<<3))
+#define PREDBLK_DBUS3_DbgCtrl3_src(data)                                             ((0xFFFFFFF8&(data))>>3)
+#define PREDBLK_DBUS3_get_DbgCtrl3(data)                                             ((0xFFFFFFF8&(data))>>3)
+#define PREDBLK_DBUS3_DbgCtrl_shift                                                  (0)
+#define PREDBLK_DBUS3_DbgCtrl_mask                                                   (0x00000007)
+#define PREDBLK_DBUS3_DbgCtrl(data)                                                  (0x00000007&((data)<<0))
+#define PREDBLK_DBUS3_DbgCtrl_src(data)                                              ((0x00000007&(data))>>0)
+#define PREDBLK_DBUS3_get_DbgCtrl(data)                                              ((0x00000007&(data))>>0)
+
+
+#define PREDBLK_DMAMSB                                                               0x1800E970
+#define PREDBLK_DMAMSB_reg_addr                                                      "0xB800E970"
+#define PREDBLK_DMAMSB_reg                                                           0xB800E970
+#define set_PREDBLK_DMAMSB_reg(data)   (*((volatile unsigned int*) PREDBLK_DMAMSB_reg)=data)
+#define get_PREDBLK_DMAMSB_reg   (*((volatile unsigned int*) PREDBLK_DMAMSB_reg))
+#define PREDBLK_DMAMSB_inst_adr                                                      "0x005C"
+#define PREDBLK_DMAMSB_inst                                                          0x005C
+#define PREDBLK_DMAMSB_SDMA2MSB_shift                                                (2)
+#define PREDBLK_DMAMSB_SDMA2MSB_mask                                                 (0x0000000C)
+#define PREDBLK_DMAMSB_SDMA2MSB(data)                                                (0x0000000C&((data)<<2))
+#define PREDBLK_DMAMSB_SDMA2MSB_src(data)                                            ((0x0000000C&(data))>>2)
+#define PREDBLK_DMAMSB_get_SDMA2MSB(data)                                            ((0x0000000C&(data))>>2)
+#define PREDBLK_DMAMSB_RMEM2MSB_shift                                                (0)
+#define PREDBLK_DMAMSB_RMEM2MSB_mask                                                 (0x00000003)
+#define PREDBLK_DMAMSB_RMEM2MSB(data)                                                (0x00000003&((data)<<0))
+#define PREDBLK_DMAMSB_RMEM2MSB_src(data)                                            ((0x00000003&(data))>>0)
+#define PREDBLK_DMAMSB_get_RMEM2MSB(data)                                            ((0x00000003&(data))>>0)
+
+
+#define PREDBLK_DMEMADR                                                              0x1800E974
+#define PREDBLK_DMEMADR_reg_addr                                                     "0xB800E974"
+#define PREDBLK_DMEMADR_reg                                                          0xB800E974
+#define set_PREDBLK_DMEMADR_reg(data)   (*((volatile unsigned int*) PREDBLK_DMEMADR_reg)=data)
+#define get_PREDBLK_DMEMADR_reg   (*((volatile unsigned int*) PREDBLK_DMEMADR_reg))
+#define PREDBLK_DMEMADR_inst_adr                                                     "0x005D"
+#define PREDBLK_DMEMADR_inst                                                         0x005D
+#define PREDBLK_DMEMADR_BaseAddr_shift                                               (0)
+#define PREDBLK_DMEMADR_BaseAddr_mask                                                (0x00000FFF)
+#define PREDBLK_DMEMADR_BaseAddr(data)                                               (0x00000FFF&((data)<<0))
+#define PREDBLK_DMEMADR_BaseAddr_src(data)                                           ((0x00000FFF&(data))>>0)
+#define PREDBLK_DMEMADR_get_BaseAddr(data)                                           ((0x00000FFF&(data))>>0)
+
+
+#define PREDBLK_X8ILUQU                                                              0x1800E978
+#define PREDBLK_X8ILUQU_reg_addr                                                     "0xB800E978"
+#define PREDBLK_X8ILUQU_reg                                                          0xB800E978
+#define set_PREDBLK_X8ILUQU_reg(data)   (*((volatile unsigned int*) PREDBLK_X8ILUQU_reg)=data)
+#define get_PREDBLK_X8ILUQU_reg   (*((volatile unsigned int*) PREDBLK_X8ILUQU_reg))
+#define PREDBLK_X8ILUQU_inst_adr                                                     "0x005E"
+#define PREDBLK_X8ILUQU_inst                                                         0x005E
+#define PREDBLK_X8ILUQU_DC_Quant_shift                                               (24)
+#define PREDBLK_X8ILUQU_DC_Quant_mask                                                (0x3F000000)
+#define PREDBLK_X8ILUQU_DC_Quant(data)                                               (0x3F000000&((data)<<24))
+#define PREDBLK_X8ILUQU_DC_Quant_src(data)                                           ((0x3F000000&(data))>>24)
+#define PREDBLK_X8ILUQU_get_DC_Quant(data)                                           ((0x3F000000&(data))>>24)
+#define PREDBLK_X8ILUQU_Div_Quant_shift                                              (0)
+#define PREDBLK_X8ILUQU_Div_Quant_mask                                               (0x0001FFFF)
+#define PREDBLK_X8ILUQU_Div_Quant(data)                                              (0x0001FFFF&((data)<<0))
+#define PREDBLK_X8ILUQU_Div_Quant_src(data)                                          ((0x0001FFFF&(data))>>0)
+#define PREDBLK_X8ILUQU_get_Div_Quant(data)                                          ((0x0001FFFF&(data))>>0)
+
+
+#define PREDBLK_X8ICHQU                                                              0x1800E97C
+#define PREDBLK_X8ICHQU_reg_addr                                                     "0xB800E97C"
+#define PREDBLK_X8ICHQU_reg                                                          0xB800E97C
+#define set_PREDBLK_X8ICHQU_reg(data)   (*((volatile unsigned int*) PREDBLK_X8ICHQU_reg)=data)
+#define get_PREDBLK_X8ICHQU_reg   (*((volatile unsigned int*) PREDBLK_X8ICHQU_reg))
+#define PREDBLK_X8ICHQU_inst_adr                                                     "0x005F"
+#define PREDBLK_X8ICHQU_inst                                                         0x005F
+#define PREDBLK_X8ICHQU_DC_Quant_shift                                               (24)
+#define PREDBLK_X8ICHQU_DC_Quant_mask                                                (0x7F000000)
+#define PREDBLK_X8ICHQU_DC_Quant(data)                                               (0x7F000000&((data)<<24))
+#define PREDBLK_X8ICHQU_DC_Quant_src(data)                                           ((0x7F000000&(data))>>24)
+#define PREDBLK_X8ICHQU_get_DC_Quant(data)                                           ((0x7F000000&(data))>>24)
+#define PREDBLK_X8ICHQU_Div_Quant_shift                                              (0)
+#define PREDBLK_X8ICHQU_Div_Quant_mask                                               (0x0001FFFF)
+#define PREDBLK_X8ICHQU_Div_Quant(data)                                              (0x0001FFFF&((data)<<0))
+#define PREDBLK_X8ICHQU_Div_Quant_src(data)                                          ((0x0001FFFF&(data))>>0)
+#define PREDBLK_X8ICHQU_get_Div_Quant(data)                                          ((0x0001FFFF&(data))>>0)
+
+
+#define PREDBLK_X8ILFLT                                                              0x1800E980
+#define PREDBLK_X8ILFLT_reg_addr                                                     "0xB800E980"
+#define PREDBLK_X8ILFLT_reg                                                          0xB800E980
+#define set_PREDBLK_X8ILFLT_reg(data)   (*((volatile unsigned int*) PREDBLK_X8ILFLT_reg)=data)
+#define get_PREDBLK_X8ILFLT_reg   (*((volatile unsigned int*) PREDBLK_X8ILFLT_reg))
+#define PREDBLK_X8ILFLT_inst_adr                                                     "0x0060"
+#define PREDBLK_X8ILFLT_inst                                                         0x0060
+#define PREDBLK_X8ILFLT_TL_shift                                                     (24)
+#define PREDBLK_X8ILFLT_TL_mask                                                      (0xFF000000)
+#define PREDBLK_X8ILFLT_TL(data)                                                     (0xFF000000&((data)<<24))
+#define PREDBLK_X8ILFLT_TL_src(data)                                                 ((0xFF000000&(data))>>24)
+#define PREDBLK_X8ILFLT_get_TL(data)                                                 ((0xFF000000&(data))>>24)
+#define PREDBLK_X8ILFLT_TR_shift                                                     (16)
+#define PREDBLK_X8ILFLT_TR_mask                                                      (0x00FF0000)
+#define PREDBLK_X8ILFLT_TR(data)                                                     (0x00FF0000&((data)<<16))
+#define PREDBLK_X8ILFLT_TR_src(data)                                                 ((0x00FF0000&(data))>>16)
+#define PREDBLK_X8ILFLT_get_TR(data)                                                 ((0x00FF0000&(data))>>16)
+#define PREDBLK_X8ILFLT_BL_shift                                                     (8)
+#define PREDBLK_X8ILFLT_BL_mask                                                      (0x0000FF00)
+#define PREDBLK_X8ILFLT_BL(data)                                                     (0x0000FF00&((data)<<8))
+#define PREDBLK_X8ILFLT_BL_src(data)                                                 ((0x0000FF00&(data))>>8)
+#define PREDBLK_X8ILFLT_get_BL(data)                                                 ((0x0000FF00&(data))>>8)
+#define PREDBLK_X8ILFLT_BR_shift                                                     (0)
+#define PREDBLK_X8ILFLT_BR_mask                                                      (0x000000FF)
+#define PREDBLK_X8ILFLT_BR(data)                                                     (0x000000FF&((data)<<0))
+#define PREDBLK_X8ILFLT_BR_src(data)                                                 ((0x000000FF&(data))>>0)
+#define PREDBLK_X8ILFLT_get_BR(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define PREDBLK_X8ILFCR                                                              0x1800E984
+#define PREDBLK_X8ILFCR_reg_addr                                                     "0xB800E984"
+#define PREDBLK_X8ILFCR_reg                                                          0xB800E984
+#define set_PREDBLK_X8ILFCR_reg(data)   (*((volatile unsigned int*) PREDBLK_X8ILFCR_reg)=data)
+#define get_PREDBLK_X8ILFCR_reg   (*((volatile unsigned int*) PREDBLK_X8ILFCR_reg))
+#define PREDBLK_X8ILFCR_inst_adr                                                     "0x0061"
+#define PREDBLK_X8ILFCR_inst                                                         0x0061
+#define PREDBLK_X8ILFCR_TL_shift                                                     (24)
+#define PREDBLK_X8ILFCR_TL_mask                                                      (0xFF000000)
+#define PREDBLK_X8ILFCR_TL(data)                                                     (0xFF000000&((data)<<24))
+#define PREDBLK_X8ILFCR_TL_src(data)                                                 ((0xFF000000&(data))>>24)
+#define PREDBLK_X8ILFCR_get_TL(data)                                                 ((0xFF000000&(data))>>24)
+#define PREDBLK_X8ILFCR_TR_shift                                                     (16)
+#define PREDBLK_X8ILFCR_TR_mask                                                      (0x00FF0000)
+#define PREDBLK_X8ILFCR_TR(data)                                                     (0x00FF0000&((data)<<16))
+#define PREDBLK_X8ILFCR_TR_src(data)                                                 ((0x00FF0000&(data))>>16)
+#define PREDBLK_X8ILFCR_get_TR(data)                                                 ((0x00FF0000&(data))>>16)
+#define PREDBLK_X8ILFCR_BL_shift                                                     (8)
+#define PREDBLK_X8ILFCR_BL_mask                                                      (0x0000FF00)
+#define PREDBLK_X8ILFCR_BL(data)                                                     (0x0000FF00&((data)<<8))
+#define PREDBLK_X8ILFCR_BL_src(data)                                                 ((0x0000FF00&(data))>>8)
+#define PREDBLK_X8ILFCR_get_BL(data)                                                 ((0x0000FF00&(data))>>8)
+#define PREDBLK_X8ILFCR_BR_shift                                                     (0)
+#define PREDBLK_X8ILFCR_BR_mask                                                      (0x000000FF)
+#define PREDBLK_X8ILFCR_BR(data)                                                     (0x000000FF&((data)<<0))
+#define PREDBLK_X8ILFCR_BR_src(data)                                                 ((0x000000FF&(data))>>0)
+#define PREDBLK_X8ILFCR_get_BR(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define PREDBLK_X8ILFCC                                                              0x1800E988
+#define PREDBLK_X8ILFCC_reg_addr                                                     "0xB800E988"
+#define PREDBLK_X8ILFCC_reg                                                          0xB800E988
+#define set_PREDBLK_X8ILFCC_reg(data)   (*((volatile unsigned int*) PREDBLK_X8ILFCC_reg)=data)
+#define get_PREDBLK_X8ILFCC_reg   (*((volatile unsigned int*) PREDBLK_X8ILFCC_reg))
+#define PREDBLK_X8ILFCC_inst_adr                                                     "0x0062"
+#define PREDBLK_X8ILFCC_inst                                                         0x0062
+#define PREDBLK_X8ILFCC_TL_shift                                                     (24)
+#define PREDBLK_X8ILFCC_TL_mask                                                      (0xFF000000)
+#define PREDBLK_X8ILFCC_TL(data)                                                     (0xFF000000&((data)<<24))
+#define PREDBLK_X8ILFCC_TL_src(data)                                                 ((0xFF000000&(data))>>24)
+#define PREDBLK_X8ILFCC_get_TL(data)                                                 ((0xFF000000&(data))>>24)
+#define PREDBLK_X8ILFCC_TR_shift                                                     (16)
+#define PREDBLK_X8ILFCC_TR_mask                                                      (0x00FF0000)
+#define PREDBLK_X8ILFCC_TR(data)                                                     (0x00FF0000&((data)<<16))
+#define PREDBLK_X8ILFCC_TR_src(data)                                                 ((0x00FF0000&(data))>>16)
+#define PREDBLK_X8ILFCC_get_TR(data)                                                 ((0x00FF0000&(data))>>16)
+#define PREDBLK_X8ILFCC_BL_shift                                                     (8)
+#define PREDBLK_X8ILFCC_BL_mask                                                      (0x0000FF00)
+#define PREDBLK_X8ILFCC_BL(data)                                                     (0x0000FF00&((data)<<8))
+#define PREDBLK_X8ILFCC_BL_src(data)                                                 ((0x0000FF00&(data))>>8)
+#define PREDBLK_X8ILFCC_get_BL(data)                                                 ((0x0000FF00&(data))>>8)
+#define PREDBLK_X8ILFCC_BR_shift                                                     (0)
+#define PREDBLK_X8ILFCC_BR_mask                                                      (0x000000FF)
+#define PREDBLK_X8ILFCC_BR(data)                                                     (0x000000FF&((data)<<0))
+#define PREDBLK_X8ILFCC_BR_src(data)                                                 ((0x000000FF&(data))>>0)
+#define PREDBLK_X8ILFCC_get_BR(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define PREDBLK_X8ILFTP                                                              0x1800E98C
+#define PREDBLK_X8ILFTP_reg_addr                                                     "0xB800E98C"
+#define PREDBLK_X8ILFTP_reg                                                          0xB800E98C
+#define set_PREDBLK_X8ILFTP_reg(data)   (*((volatile unsigned int*) PREDBLK_X8ILFTP_reg)=data)
+#define get_PREDBLK_X8ILFTP_reg   (*((volatile unsigned int*) PREDBLK_X8ILFTP_reg))
+#define PREDBLK_X8ILFTP_inst_adr                                                     "0x0063"
+#define PREDBLK_X8ILFTP_inst                                                         0x0063
+#define PREDBLK_X8ILFTP_BR_shift                                                     (0)
+#define PREDBLK_X8ILFTP_BR_mask                                                      (0x000000FF)
+#define PREDBLK_X8ILFTP_BR(data)                                                     (0x000000FF&((data)<<0))
+#define PREDBLK_X8ILFTP_BR_src(data)                                                 ((0x000000FF&(data))>>0)
+#define PREDBLK_X8ILFTP_get_BR(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define PREDBLK_DMEMOP                                                               0x1800E990
+#define PREDBLK_DMEMOP_reg_addr                                                      "0xB800E990"
+#define PREDBLK_DMEMOP_reg                                                           0xB800E990
+#define set_PREDBLK_DMEMOP_reg(data)   (*((volatile unsigned int*) PREDBLK_DMEMOP_reg)=data)
+#define get_PREDBLK_DMEMOP_reg   (*((volatile unsigned int*) PREDBLK_DMEMOP_reg))
+#define PREDBLK_DMEMOP_inst_adr                                                      "0x0064"
+#define PREDBLK_DMEMOP_inst                                                          0x0064
+#define PREDBLK_DMEMOP_Count_shift                                                   (0)
+#define PREDBLK_DMEMOP_Count_mask                                                    (0x0FFFFFFF)
+#define PREDBLK_DMEMOP_Count(data)                                                   (0x0FFFFFFF&((data)<<0))
+#define PREDBLK_DMEMOP_Count_src(data)                                               ((0x0FFFFFFF&(data))>>0)
+#define PREDBLK_DMEMOP_get_Count(data)                                               ((0x0FFFFFFF&(data))>>0)
+
+
+#define PREDBLK_SLICE_RESTART                                                        0x1800E994
+#define PREDBLK_SLICE_RESTART_reg_addr                                               "0xB800E994"
+#define PREDBLK_SLICE_RESTART_reg                                                    0xB800E994
+#define set_PREDBLK_SLICE_RESTART_reg(data)   (*((volatile unsigned int*) PREDBLK_SLICE_RESTART_reg)=data)
+#define get_PREDBLK_SLICE_RESTART_reg   (*((volatile unsigned int*) PREDBLK_SLICE_RESTART_reg))
+#define PREDBLK_SLICE_RESTART_inst_adr                                               "0x0065"
+#define PREDBLK_SLICE_RESTART_inst                                                   0x0065
+#define PREDBLK_SLICE_RESTART_hw_enable_shift                                        (31)
+#define PREDBLK_SLICE_RESTART_hw_enable_mask                                         (0x80000000)
+#define PREDBLK_SLICE_RESTART_hw_enable(data)                                        (0x80000000&((data)<<31))
+#define PREDBLK_SLICE_RESTART_hw_enable_src(data)                                    ((0x80000000&(data))>>31)
+#define PREDBLK_SLICE_RESTART_get_hw_enable(data)                                    ((0x80000000&(data))>>31)
+#define PREDBLK_SLICE_RESTART_Pmem_idle_shift                                        (0)
+#define PREDBLK_SLICE_RESTART_Pmem_idle_mask                                         (0x00000001)
+#define PREDBLK_SLICE_RESTART_Pmem_idle(data)                                        (0x00000001&((data)<<0))
+#define PREDBLK_SLICE_RESTART_Pmem_idle_src(data)                                    ((0x00000001&(data))>>0)
+#define PREDBLK_SLICE_RESTART_get_Pmem_idle(data)                                    ((0x00000001&(data))>>0)
+
+
+#define PREDBLK_SLICE_DBG0                                                           0x1800E998
+#define PREDBLK_SLICE_DBG0_reg_addr                                                  "0xB800E998"
+#define PREDBLK_SLICE_DBG0_reg                                                       0xB800E998
+#define set_PREDBLK_SLICE_DBG0_reg(data)   (*((volatile unsigned int*) PREDBLK_SLICE_DBG0_reg)=data)
+#define get_PREDBLK_SLICE_DBG0_reg   (*((volatile unsigned int*) PREDBLK_SLICE_DBG0_reg))
+#define PREDBLK_SLICE_DBG0_inst_adr                                                  "0x0066"
+#define PREDBLK_SLICE_DBG0_inst                                                      0x0066
+#define PREDBLK_SLICE_DBG0_sw_override_shift                                         (31)
+#define PREDBLK_SLICE_DBG0_sw_override_mask                                          (0x80000000)
+#define PREDBLK_SLICE_DBG0_sw_override(data)                                         (0x80000000&((data)<<31))
+#define PREDBLK_SLICE_DBG0_sw_override_src(data)                                     ((0x80000000&(data))>>31)
+#define PREDBLK_SLICE_DBG0_get_sw_override(data)                                     ((0x80000000&(data))>>31)
+#define PREDBLK_SLICE_DBG0_ddr_inb_rdadr_shift                                       (20)
+#define PREDBLK_SLICE_DBG0_ddr_inb_rdadr_mask                                        (0x00700000)
+#define PREDBLK_SLICE_DBG0_ddr_inb_rdadr(data)                                       (0x00700000&((data)<<20))
+#define PREDBLK_SLICE_DBG0_ddr_inb_rdadr_src(data)                                   ((0x00700000&(data))>>20)
+#define PREDBLK_SLICE_DBG0_get_ddr_inb_rdadr(data)                                   ((0x00700000&(data))>>20)
+#define PREDBLK_SLICE_DBG0_ddr_out_rdadr_shift                                       (14)
+#define PREDBLK_SLICE_DBG0_ddr_out_rdadr_mask                                        (0x000FC000)
+#define PREDBLK_SLICE_DBG0_ddr_out_rdadr(data)                                       (0x000FC000&((data)<<14))
+#define PREDBLK_SLICE_DBG0_ddr_out_rdadr_src(data)                                   ((0x000FC000&(data))>>14)
+#define PREDBLK_SLICE_DBG0_get_ddr_out_rdadr(data)                                   ((0x000FC000&(data))>>14)
+#define PREDBLK_SLICE_DBG0_inb_mbcnt_shift                                           (10)
+#define PREDBLK_SLICE_DBG0_inb_mbcnt_mask                                            (0x00003C00)
+#define PREDBLK_SLICE_DBG0_inb_mbcnt(data)                                           (0x00003C00&((data)<<10))
+#define PREDBLK_SLICE_DBG0_inb_mbcnt_src(data)                                       ((0x00003C00&(data))>>10)
+#define PREDBLK_SLICE_DBG0_get_inb_mbcnt(data)                                       ((0x00003C00&(data))>>10)
+#define PREDBLK_SLICE_DBG0_out_mbcnt_shift                                           (6)
+#define PREDBLK_SLICE_DBG0_out_mbcnt_mask                                            (0x000003C0)
+#define PREDBLK_SLICE_DBG0_out_mbcnt(data)                                           (0x000003C0&((data)<<6))
+#define PREDBLK_SLICE_DBG0_out_mbcnt_src(data)                                       ((0x000003C0&(data))>>6)
+#define PREDBLK_SLICE_DBG0_get_out_mbcnt(data)                                       ((0x000003C0&(data))>>6)
+#define PREDBLK_SLICE_DBG0_pmem_inb_mbptr_shift                                      (3)
+#define PREDBLK_SLICE_DBG0_pmem_inb_mbptr_mask                                       (0x00000038)
+#define PREDBLK_SLICE_DBG0_pmem_inb_mbptr(data)                                      (0x00000038&((data)<<3))
+#define PREDBLK_SLICE_DBG0_pmem_inb_mbptr_src(data)                                  ((0x00000038&(data))>>3)
+#define PREDBLK_SLICE_DBG0_get_pmem_inb_mbptr(data)                                  ((0x00000038&(data))>>3)
+#define PREDBLK_SLICE_DBG0_pmem_out_mbptr_shift                                      (0)
+#define PREDBLK_SLICE_DBG0_pmem_out_mbptr_mask                                       (0x00000007)
+#define PREDBLK_SLICE_DBG0_pmem_out_mbptr(data)                                      (0x00000007&((data)<<0))
+#define PREDBLK_SLICE_DBG0_pmem_out_mbptr_src(data)                                  ((0x00000007&(data))>>0)
+#define PREDBLK_SLICE_DBG0_get_pmem_out_mbptr(data)                                  ((0x00000007&(data))>>0)
+
+
+#define PREDBLK_SLICE_DBG1                                                           0x1800E99C
+#define PREDBLK_SLICE_DBG1_reg_addr                                                  "0xB800E99C"
+#define PREDBLK_SLICE_DBG1_reg                                                       0xB800E99C
+#define set_PREDBLK_SLICE_DBG1_reg(data)   (*((volatile unsigned int*) PREDBLK_SLICE_DBG1_reg)=data)
+#define get_PREDBLK_SLICE_DBG1_reg   (*((volatile unsigned int*) PREDBLK_SLICE_DBG1_reg))
+#define PREDBLK_SLICE_DBG1_inst_adr                                                  "0x0067"
+#define PREDBLK_SLICE_DBG1_inst                                                      0x0067
+#define PREDBLK_SLICE_DBG1_ddr_rng_rdptr_shift                                       (20)
+#define PREDBLK_SLICE_DBG1_ddr_rng_rdptr_mask                                        (0x3FF00000)
+#define PREDBLK_SLICE_DBG1_ddr_rng_rdptr(data)                                       (0x3FF00000&((data)<<20))
+#define PREDBLK_SLICE_DBG1_ddr_rng_rdptr_src(data)                                   ((0x3FF00000&(data))>>20)
+#define PREDBLK_SLICE_DBG1_get_ddr_rng_rdptr(data)                                   ((0x3FF00000&(data))>>20)
+#define PREDBLK_SLICE_DBG1_ddr_rng_wrptr_shift                                       (10)
+#define PREDBLK_SLICE_DBG1_ddr_rng_wrptr_mask                                        (0x000FFC00)
+#define PREDBLK_SLICE_DBG1_ddr_rng_wrptr(data)                                       (0x000FFC00&((data)<<10))
+#define PREDBLK_SLICE_DBG1_ddr_rng_wrptr_src(data)                                   ((0x000FFC00&(data))>>10)
+#define PREDBLK_SLICE_DBG1_get_ddr_rng_wrptr(data)                                   ((0x000FFC00&(data))>>10)
+#define PREDBLK_SLICE_DBG1_ddr_rng_size_shift                                        (0)
+#define PREDBLK_SLICE_DBG1_ddr_rng_size_mask                                         (0x000003FF)
+#define PREDBLK_SLICE_DBG1_ddr_rng_size(data)                                        (0x000003FF&((data)<<0))
+#define PREDBLK_SLICE_DBG1_ddr_rng_size_src(data)                                    ((0x000003FF&(data))>>0)
+#define PREDBLK_SLICE_DBG1_get_ddr_rng_size(data)                                    ((0x000003FF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/regdef.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/regdef.h
new file mode 100644
index 00000000..91d8658
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/regdef.h
@@ -0,0 +1,108 @@
+/*
+ * Copyright (c) 1996-2003 MIPS Technologies, Inc.  All rights reserved.
+ * 
+ * Unpublished rights (if any) reserved under the copyright laws of the
+ * United States of America and other countries.
+ * 
+ * This code is proprietary to MIPS Technologies, Inc. ("MIPS
+ * Technologies").  Any copying, reproducing, modifying or use of this
+ * code (in whole or in part) that is not expressly permitted in writing
+ * by MIPS Technologies or an authorized third party is strictly
+ * prohibited.  At a minimum, this code is protected under unfair
+ * competition and copyright laws.  Violations thereof may result in
+ * criminal penalties and fines.
+ * 
+ * MIPS Technologies reserves the right to change this code to improve
+ * function, design or otherwise.  MIPS Technologies does not assume any
+ * liability arising out of the application or use of this code, or of
+ * any error or omission in such code.  Any warranties, whether express,
+ * statutory, implied or otherwise, including but not limited to the
+ * implied warranties of merchantability or fitness for a particular
+ * purpose, are excluded.  Except as expressly provided in any written
+ * license agreement from MIPS Technologies or an authorized third party,
+ * the furnishing of this code does not give recipient any license to any
+ * intellectual property rights, including any patent rights, that cover
+ * this code.
+ * 
+ * This code shall not be exported or transferred for the purpose of
+ * reexporting in violation of any U.S. or non-U.S. regulation, treaty,
+ * Executive Order, law, statute, amendment or supplement thereto.
+ * 
+ * This code constitutes one or more of the following: commercial
+ * computer software, commercial computer software documentation or other
+ * commercial items.  If the user of this code, or any related
+ * documentation of any kind, including related technical data or
+ * manuals, is an agency, department, or other entity of the United
+ * States government ("Government"), the use, duplication, reproduction,
+ * release, modification, disclosure, or transfer of this code, or any
+ * related documentation of any kind, is restricted in accordance with
+ * Federal Acquisition Regulation 12.212 for civilian agencies and
+ * Defense Federal Acquisition Regulation Supplement 227.7202 for
+ * military agencies.  The use of this code by the Government is further
+ * restricted in accordance with the terms of the license agreement(s)
+ * and/or applicable contract terms and conditions covering this code
+ * from MIPS Technologies or an authorized third party.
+ */
+
+/*
+ * regdef.h : MIPS Rx000 symbolic register names for assembler
+ */
+
+
+#define zero	$0
+
+#define AT	$1
+
+#define v0 	$2
+#define v1	$3
+
+#define a0	$4
+#define a1	$5
+#define a2	$6
+#define	a3	$7
+
+#if #abi(n32) || #abi(n64) || #abi(64)
+#define a4	$8
+#define a5	$9
+#define a6	$10
+#define	a7	$11
+#define ta0	$8	/* alias for $a4 */
+#define ta1	$9	/* alias for $a5 */
+#define ta2	$10	/* alias for $a6 */
+#define ta3	$11	/* alias for $a7 */
+#else
+#define t0	$8
+#define t1	$9
+#define t2	$10
+#define t3	$11
+#define ta0	$12	/* alias for $t4 */
+#define ta1	$13	/* alias for $t5 */
+#define ta2	$14	/* alias for $t6 */
+#define ta3	$15	/* alias for $t7 */
+#endif
+
+#define t4	$12
+#define t5	$13
+#define t6	$14
+#define t7	$15
+
+#define s0	$16
+#define s1	$17
+#define s2	$18
+#define s3	$19
+#define s4	$20
+#define s5	$21
+#define s6	$22
+#define s7	$23
+#define s8	$30		/* == fp */
+
+#define t8	$24
+#define t9	$25
+#define k0	$26
+#define k1	$27
+
+#define gp	$28
+
+#define sp	$29
+#define fp	$30
+#define ra	$31
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/rif_reg_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/rif_reg_reg.h
new file mode 100644
index 00000000..51dc3f7
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/rif_reg_reg.h
@@ -0,0 +1,1508 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/6/22 11:40:33
+***************************************************************/
+
+
+#ifndef _RIF_REG_REG_H_INCLUDED_
+#define _RIF_REG_REG_H_INCLUDED_
+#ifdef  _RIF_REG_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ve_fpga_reset:1;
+unsigned int     reserved_1:2;
+unsigned int     dbg_out_sel1:5;
+unsigned int     dbg_out_sel0:5;
+unsigned int     dbg_out_en:1;
+unsigned int     reserved_2:8;
+unsigned int     ve_soft_reset:1;
+unsigned int     vm_idle:1;
+unsigned int     decode_en:1;
+unsigned int     haltVE_done:1;
+unsigned int     HaltVE:1;
+unsigned int     Veidle:1;
+unsigned int     IntEn:1;
+unsigned int     Reset_ptr:1;
+}RIF_REG_VE_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     first_error:4;
+unsigned int     cmd_fifo_full_int:1;
+unsigned int     rd_rslt_hang_int:1;
+unsigned int     rl_hang_int:1;
+unsigned int     pred_hang_int:1;
+unsigned int     mb_last_int:1;
+unsigned int     mvd_vc1_intfd_err:1;
+unsigned int     mvd_h264_direct_err:1;
+unsigned int     mvd_h264_mv_err:1;
+unsigned int     reserved_1:1;
+unsigned int     m64coeff:1;
+unsigned int     rstff_oflow:1;
+unsigned int     rstff_empty:1;
+unsigned int     bitst_fifo:1;
+unsigned int     scode_limit:1;
+unsigned int     dec_err:1;
+unsigned int     write_data:1;
+}RIF_REG_VE_INT_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     cmd_fifo_full_int_ie:1;
+unsigned int     rd_rslt_hang_int_ie:1;
+unsigned int     rl_hang_int_ie:1;
+unsigned int     pred_hang_int_ie:1;
+unsigned int     mb_last_int_ie:1;
+unsigned int     mvd_vc1_intfd_ie:1;
+unsigned int     mvd_h264_direct_ie:1;
+unsigned int     mvd_h264_mv_ie:1;
+unsigned int     reserved_1:1;
+unsigned int     m64coeff_ie:1;
+unsigned int     rstff_oflow_ie:1;
+unsigned int     rstff_empty_ie:1;
+unsigned int     bitst_fifo_ie:1;
+unsigned int     scode_limit_ie:1;
+unsigned int     dec_err_ie:1;
+unsigned int     write_data:1;
+}RIF_REG_VE_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     debk_inst_cnt:6;
+unsigned int     reserved_1:2;
+unsigned int     pred_inst_cnt:6;
+unsigned int     reserved_2:10;
+unsigned int     dmaa_inst_cnt:6;
+}RIF_REG_VE_FIFOSTATUS;
+
+typedef struct 
+{
+unsigned int     act_rslt_in_fifo:5;
+unsigned int     rslt_fifo_cnt:5;
+unsigned int     img_fifo_cnt:6;
+unsigned int     reserved_0:2;
+unsigned int     dec_inst_cnt:6;
+unsigned int     reserved_1:8;
+}RIF_REG_VE_FIFOSTAT2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     rslt_timer:24;
+}RIF_REG_VE_RSLT_TIMER;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     cmd_timer:24;
+}RIF_REG_VE_CMD_TIMER;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     ve_img_bnk:3;
+unsigned int     reserved_1:1;
+unsigned int     ve_deb_bnk:3;
+unsigned int     reserved_2:1;
+unsigned int     ve_prd_bnk:3;
+unsigned int     reserved_3:5;
+unsigned int     ve_dmaa_bnk:3;
+}RIF_REG_VMBANKSEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     monochrome:1;
+unsigned int     level:1;
+unsigned int     profile:2;
+unsigned int     coding_type:4;
+}RIF_REG_DEC_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     vp8_bicubic_filtering:1;
+unsigned int     bottom_field_flag:1;
+unsigned int     field_pic_flag:1;
+unsigned int     picmb_h:7;
+unsigned int     picmb_w:7;
+}RIF_REG_PICINFO1;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     Constrainted_intra_pred_flag:1;
+unsigned int     Weighted_pred_flag:1;
+unsigned int     Weighted_bipred_idc:2;
+unsigned int     frame_mbs_only_flag:1;
+unsigned int     mb_adaptive_frame_field_flag:1;
+}RIF_REG_H264PICCNTL;
+
+typedef struct 
+{
+unsigned int     Overlap_enable:1;
+unsigned int     field_pictype:3;
+unsigned int     mvmode:2;
+unsigned int     fcm:2;
+unsigned int     disppic_h:12;
+unsigned int     disppic_w:12;
+}RIF_REG_VC1PICCNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     wmv9_bug_rtmflag:1;
+unsigned int     wmv9_bug_it:1;
+unsigned int     loopfilter:1;
+unsigned int     numref:1;
+unsigned int     pquant:5;
+}RIF_REG_VC1PICCNTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     priority_thd2:8;
+unsigned int     priority_thd1:8;
+unsigned int     reserved_1:4;
+unsigned int     srg_mode:1;
+unsigned int     ddr_page:2;
+unsigned int     srg_enable:1;
+}RIF_REG_BRG_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     vm1:8;
+}RIF_REG_RD_PRIORITY0;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     deblk:8;
+unsigned int     reserved_1:8;
+unsigned int     predblk:8;
+}RIF_REG_RD_PRIORITY1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     nm:8;
+unsigned int     reserved_1:8;
+unsigned int     mvd:8;
+}RIF_REG_RD_PRIORITY2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     bs:8;
+}RIF_REG_RD_PRIORITY3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rl:8;
+}RIF_REG_RD_PRIORITY4;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     vm1:8;
+}RIF_REG_WT_PRIORITY0;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     deblk:8;
+unsigned int     reserved_1:8;
+unsigned int     predblk:8;
+}RIF_REG_WT_PRIORITY1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     nm:8;
+unsigned int     reserved_1:8;
+unsigned int     mvd:8;
+}RIF_REG_WT_PRIORITY2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     bs:8;
+}RIF_REG_WT_PRIORITY3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     it:8;
+}RIF_REG_WT_PRIORITY4;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     cache_gated_en:1;
+unsigned int     rl_gated_en:1;
+unsigned int     mvd_gated_en:1;
+unsigned int     ndbp2_gated_en:1;
+unsigned int     ndb_gated_en:1;
+unsigned int     brg_gated_en:1;
+unsigned int     cm_gated_en:1;
+unsigned int     arb_gated_en:1;
+unsigned int     bsfifop2_gated_en:1;
+unsigned int     bsfifo_gated_en:1;
+unsigned int     deblk_gated_en:1;
+unsigned int     pred_gated_en:1;
+unsigned int     vm1_gated_en:1;
+unsigned int     it_gated_en:1;
+unsigned int     cabac_gated_en:1;
+unsigned int     vp8p2_gated_en:1;
+unsigned int     cabacp2_gated_en:1;
+unsigned int     vld_gated_en:1;
+unsigned int     acdc_gated_en:1;
+}RIF_REG_CLKGATED;
+
+typedef struct 
+{
+unsigned int     ve_dbg_out1:16;
+unsigned int     ve_dbg_out0:16;
+}RIF_REG_DBG_OUT;
+
+typedef struct 
+{
+unsigned int     cache_dbg_sel1:4;
+unsigned int     cache_dbg_sel0:4;
+unsigned int     bs_dbg_sel1:4;
+unsigned int     bs_dbg_sel0:4;
+unsigned int     brg_dbg_sel1:4;
+unsigned int     brg_dbg_sel0:4;
+unsigned int     acdc_dbg_sel1:4;
+unsigned int     acdc_dbg_sel0:4;
+}RIF_REG_DBG_CTRL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     cm_dbg_sel1:4;
+unsigned int     cm_dbg_sel0:4;
+unsigned int     cabacp3_dbg_sel1:4;
+unsigned int     cabacp3_dbg_sel0:4;
+unsigned int     cabacp2_dbg_sel1:4;
+unsigned int     cabacp2_dbg_sel0:4;
+}RIF_REG_DBG_CTRL2;
+
+typedef struct 
+{
+unsigned int     ndb_dbg_sel1:4;
+unsigned int     ndb_dbg_sel0:4;
+unsigned int     rif_dbg_sel1:4;
+unsigned int     rif_dbg_sel0:4;
+unsigned int     itblk_dbg_sel1:4;
+unsigned int     itblk_dbg_sel0:4;
+unsigned int     img_dbg_sel1:4;
+unsigned int     img_dbg_sel0:4;
+}RIF_REG_DBG_CTRL3;
+
+typedef struct 
+{
+unsigned int     rl_dbg_sel1:4;
+unsigned int     rl_dbg_sel0:4;
+unsigned int     vld_dbg_sel1:4;
+unsigned int     vld_dbg_sel0:4;
+unsigned int     arb_dbg_sel1:4;
+unsigned int     arb_dbg_sel0:4;
+unsigned int     vm1_dbg_sel1:4;
+unsigned int     vm1_dbg_sel0:4;
+}RIF_REG_DBG_CTRL4;
+
+typedef struct 
+{
+unsigned int     deblk_dbg_sel1:6;
+unsigned int     deblk_dbg_sel0:6;
+unsigned int     mvd_dbg_sel1:4;
+unsigned int     mvd_dbg_sel0:4;
+unsigned int     prd_dbg_sel1:6;
+unsigned int     prd_dbg_sel0:6;
+}RIF_REG_DBG_CTRL5;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     cache_busy:1;
+unsigned int     brg_busy:1;
+unsigned int     ndb_busy:1;
+unsigned int     bsfifo_busy:1;
+unsigned int     img_busy:1;
+unsigned int     vm1_busy:1;
+unsigned int     deblk_busy:1;
+unsigned int     rl_busy:1;
+unsigned int     pred_busy:1;
+unsigned int     mvd_busy:1;
+unsigned int     itblk_busy:1;
+unsigned int     acdc_busy:1;
+unsigned int     cabacp2_busy:1;
+unsigned int     vld_busy:1;
+unsigned int     rifvld_busy:1;
+}RIF_REG_FPGA_DBG1;
+
+#endif
+
+#define RIF_REG_VE_CTRL                                                              0x1800E400
+#define RIF_REG_VE_CTRL_reg_addr                                                     "0xB800E400"
+#define RIF_REG_VE_CTRL_reg                                                          0xB800E400
+#define set_RIF_REG_VE_CTRL_reg(data)   (*((volatile unsigned int*) RIF_REG_VE_CTRL_reg)=data)
+#define get_RIF_REG_VE_CTRL_reg   (*((volatile unsigned int*) RIF_REG_VE_CTRL_reg))
+#define RIF_REG_VE_CTRL_inst_adr                                                     "0x0000"
+#define RIF_REG_VE_CTRL_inst                                                         0x0000
+#define RIF_REG_VE_CTRL_ve_fpga_reset_shift                                          (29)
+#define RIF_REG_VE_CTRL_ve_fpga_reset_mask                                           (0x20000000)
+#define RIF_REG_VE_CTRL_ve_fpga_reset(data)                                          (0x20000000&((data)<<29))
+#define RIF_REG_VE_CTRL_ve_fpga_reset_src(data)                                      ((0x20000000&(data))>>29)
+#define RIF_REG_VE_CTRL_get_ve_fpga_reset(data)                                      ((0x20000000&(data))>>29)
+#define RIF_REG_VE_CTRL_dbg_out_sel1_shift                                           (22)
+#define RIF_REG_VE_CTRL_dbg_out_sel1_mask                                            (0x07C00000)
+#define RIF_REG_VE_CTRL_dbg_out_sel1(data)                                           (0x07C00000&((data)<<22))
+#define RIF_REG_VE_CTRL_dbg_out_sel1_src(data)                                       ((0x07C00000&(data))>>22)
+#define RIF_REG_VE_CTRL_get_dbg_out_sel1(data)                                       ((0x07C00000&(data))>>22)
+#define RIF_REG_VE_CTRL_dbg_out_sel0_shift                                           (17)
+#define RIF_REG_VE_CTRL_dbg_out_sel0_mask                                            (0x003E0000)
+#define RIF_REG_VE_CTRL_dbg_out_sel0(data)                                           (0x003E0000&((data)<<17))
+#define RIF_REG_VE_CTRL_dbg_out_sel0_src(data)                                       ((0x003E0000&(data))>>17)
+#define RIF_REG_VE_CTRL_get_dbg_out_sel0(data)                                       ((0x003E0000&(data))>>17)
+#define RIF_REG_VE_CTRL_dbg_out_en_shift                                             (16)
+#define RIF_REG_VE_CTRL_dbg_out_en_mask                                              (0x00010000)
+#define RIF_REG_VE_CTRL_dbg_out_en(data)                                             (0x00010000&((data)<<16))
+#define RIF_REG_VE_CTRL_dbg_out_en_src(data)                                         ((0x00010000&(data))>>16)
+#define RIF_REG_VE_CTRL_get_dbg_out_en(data)                                         ((0x00010000&(data))>>16)
+#define RIF_REG_VE_CTRL_ve_soft_reset_shift                                          (7)
+#define RIF_REG_VE_CTRL_ve_soft_reset_mask                                           (0x00000080)
+#define RIF_REG_VE_CTRL_ve_soft_reset(data)                                          (0x00000080&((data)<<7))
+#define RIF_REG_VE_CTRL_ve_soft_reset_src(data)                                      ((0x00000080&(data))>>7)
+#define RIF_REG_VE_CTRL_get_ve_soft_reset(data)                                      ((0x00000080&(data))>>7)
+#define RIF_REG_VE_CTRL_vm_idle_shift                                                (6)
+#define RIF_REG_VE_CTRL_vm_idle_mask                                                 (0x00000040)
+#define RIF_REG_VE_CTRL_vm_idle(data)                                                (0x00000040&((data)<<6))
+#define RIF_REG_VE_CTRL_vm_idle_src(data)                                            ((0x00000040&(data))>>6)
+#define RIF_REG_VE_CTRL_get_vm_idle(data)                                            ((0x00000040&(data))>>6)
+#define RIF_REG_VE_CTRL_decode_en_shift                                              (5)
+#define RIF_REG_VE_CTRL_decode_en_mask                                               (0x00000020)
+#define RIF_REG_VE_CTRL_decode_en(data)                                              (0x00000020&((data)<<5))
+#define RIF_REG_VE_CTRL_decode_en_src(data)                                          ((0x00000020&(data))>>5)
+#define RIF_REG_VE_CTRL_get_decode_en(data)                                          ((0x00000020&(data))>>5)
+#define RIF_REG_VE_CTRL_haltVE_done_shift                                            (4)
+#define RIF_REG_VE_CTRL_haltVE_done_mask                                             (0x00000010)
+#define RIF_REG_VE_CTRL_haltVE_done(data)                                            (0x00000010&((data)<<4))
+#define RIF_REG_VE_CTRL_haltVE_done_src(data)                                        ((0x00000010&(data))>>4)
+#define RIF_REG_VE_CTRL_get_haltVE_done(data)                                        ((0x00000010&(data))>>4)
+#define RIF_REG_VE_CTRL_HaltVE_shift                                                 (3)
+#define RIF_REG_VE_CTRL_HaltVE_mask                                                  (0x00000008)
+#define RIF_REG_VE_CTRL_HaltVE(data)                                                 (0x00000008&((data)<<3))
+#define RIF_REG_VE_CTRL_HaltVE_src(data)                                             ((0x00000008&(data))>>3)
+#define RIF_REG_VE_CTRL_get_HaltVE(data)                                             ((0x00000008&(data))>>3)
+#define RIF_REG_VE_CTRL_Veidle_shift                                                 (2)
+#define RIF_REG_VE_CTRL_Veidle_mask                                                  (0x00000004)
+#define RIF_REG_VE_CTRL_Veidle(data)                                                 (0x00000004&((data)<<2))
+#define RIF_REG_VE_CTRL_Veidle_src(data)                                             ((0x00000004&(data))>>2)
+#define RIF_REG_VE_CTRL_get_Veidle(data)                                             ((0x00000004&(data))>>2)
+#define RIF_REG_VE_CTRL_IntEn_shift                                                  (1)
+#define RIF_REG_VE_CTRL_IntEn_mask                                                   (0x00000002)
+#define RIF_REG_VE_CTRL_IntEn(data)                                                  (0x00000002&((data)<<1))
+#define RIF_REG_VE_CTRL_IntEn_src(data)                                              ((0x00000002&(data))>>1)
+#define RIF_REG_VE_CTRL_get_IntEn(data)                                              ((0x00000002&(data))>>1)
+#define RIF_REG_VE_CTRL_Reset_ptr_shift                                              (0)
+#define RIF_REG_VE_CTRL_Reset_ptr_mask                                               (0x00000001)
+#define RIF_REG_VE_CTRL_Reset_ptr(data)                                              (0x00000001&((data)<<0))
+#define RIF_REG_VE_CTRL_Reset_ptr_src(data)                                          ((0x00000001&(data))>>0)
+#define RIF_REG_VE_CTRL_get_Reset_ptr(data)                                          ((0x00000001&(data))>>0)
+
+
+#define RIF_REG_VE_INT_STATUS                                                        0x1800E404
+#define RIF_REG_VE_INT_STATUS_reg_addr                                               "0xB800E404"
+#define RIF_REG_VE_INT_STATUS_reg                                                    0xB800E404
+#define set_RIF_REG_VE_INT_STATUS_reg(data)   (*((volatile unsigned int*) RIF_REG_VE_INT_STATUS_reg)=data)
+#define get_RIF_REG_VE_INT_STATUS_reg   (*((volatile unsigned int*) RIF_REG_VE_INT_STATUS_reg))
+#define RIF_REG_VE_INT_STATUS_inst_adr                                               "0x0001"
+#define RIF_REG_VE_INT_STATUS_inst                                                   0x0001
+#define RIF_REG_VE_INT_STATUS_first_error_shift                                      (16)
+#define RIF_REG_VE_INT_STATUS_first_error_mask                                       (0x000F0000)
+#define RIF_REG_VE_INT_STATUS_first_error(data)                                      (0x000F0000&((data)<<16))
+#define RIF_REG_VE_INT_STATUS_first_error_src(data)                                  ((0x000F0000&(data))>>16)
+#define RIF_REG_VE_INT_STATUS_get_first_error(data)                                  ((0x000F0000&(data))>>16)
+#define RIF_REG_VE_INT_STATUS_cmd_fifo_full_int_shift                                (15)
+#define RIF_REG_VE_INT_STATUS_cmd_fifo_full_int_mask                                 (0x00008000)
+#define RIF_REG_VE_INT_STATUS_cmd_fifo_full_int(data)                                (0x00008000&((data)<<15))
+#define RIF_REG_VE_INT_STATUS_cmd_fifo_full_int_src(data)                            ((0x00008000&(data))>>15)
+#define RIF_REG_VE_INT_STATUS_get_cmd_fifo_full_int(data)                            ((0x00008000&(data))>>15)
+#define RIF_REG_VE_INT_STATUS_rd_rslt_hang_int_shift                                 (14)
+#define RIF_REG_VE_INT_STATUS_rd_rslt_hang_int_mask                                  (0x00004000)
+#define RIF_REG_VE_INT_STATUS_rd_rslt_hang_int(data)                                 (0x00004000&((data)<<14))
+#define RIF_REG_VE_INT_STATUS_rd_rslt_hang_int_src(data)                             ((0x00004000&(data))>>14)
+#define RIF_REG_VE_INT_STATUS_get_rd_rslt_hang_int(data)                             ((0x00004000&(data))>>14)
+#define RIF_REG_VE_INT_STATUS_rl_hang_int_shift                                      (13)
+#define RIF_REG_VE_INT_STATUS_rl_hang_int_mask                                       (0x00002000)
+#define RIF_REG_VE_INT_STATUS_rl_hang_int(data)                                      (0x00002000&((data)<<13))
+#define RIF_REG_VE_INT_STATUS_rl_hang_int_src(data)                                  ((0x00002000&(data))>>13)
+#define RIF_REG_VE_INT_STATUS_get_rl_hang_int(data)                                  ((0x00002000&(data))>>13)
+#define RIF_REG_VE_INT_STATUS_pred_hang_int_shift                                    (12)
+#define RIF_REG_VE_INT_STATUS_pred_hang_int_mask                                     (0x00001000)
+#define RIF_REG_VE_INT_STATUS_pred_hang_int(data)                                    (0x00001000&((data)<<12))
+#define RIF_REG_VE_INT_STATUS_pred_hang_int_src(data)                                ((0x00001000&(data))>>12)
+#define RIF_REG_VE_INT_STATUS_get_pred_hang_int(data)                                ((0x00001000&(data))>>12)
+#define RIF_REG_VE_INT_STATUS_mb_last_int_shift                                      (11)
+#define RIF_REG_VE_INT_STATUS_mb_last_int_mask                                       (0x00000800)
+#define RIF_REG_VE_INT_STATUS_mb_last_int(data)                                      (0x00000800&((data)<<11))
+#define RIF_REG_VE_INT_STATUS_mb_last_int_src(data)                                  ((0x00000800&(data))>>11)
+#define RIF_REG_VE_INT_STATUS_get_mb_last_int(data)                                  ((0x00000800&(data))>>11)
+#define RIF_REG_VE_INT_STATUS_mvd_vc1_intfd_err_shift                                (10)
+#define RIF_REG_VE_INT_STATUS_mvd_vc1_intfd_err_mask                                 (0x00000400)
+#define RIF_REG_VE_INT_STATUS_mvd_vc1_intfd_err(data)                                (0x00000400&((data)<<10))
+#define RIF_REG_VE_INT_STATUS_mvd_vc1_intfd_err_src(data)                            ((0x00000400&(data))>>10)
+#define RIF_REG_VE_INT_STATUS_get_mvd_vc1_intfd_err(data)                            ((0x00000400&(data))>>10)
+#define RIF_REG_VE_INT_STATUS_mvd_h264_direct_err_shift                              (9)
+#define RIF_REG_VE_INT_STATUS_mvd_h264_direct_err_mask                               (0x00000200)
+#define RIF_REG_VE_INT_STATUS_mvd_h264_direct_err(data)                              (0x00000200&((data)<<9))
+#define RIF_REG_VE_INT_STATUS_mvd_h264_direct_err_src(data)                          ((0x00000200&(data))>>9)
+#define RIF_REG_VE_INT_STATUS_get_mvd_h264_direct_err(data)                          ((0x00000200&(data))>>9)
+#define RIF_REG_VE_INT_STATUS_mvd_h264_mv_err_shift                                  (8)
+#define RIF_REG_VE_INT_STATUS_mvd_h264_mv_err_mask                                   (0x00000100)
+#define RIF_REG_VE_INT_STATUS_mvd_h264_mv_err(data)                                  (0x00000100&((data)<<8))
+#define RIF_REG_VE_INT_STATUS_mvd_h264_mv_err_src(data)                              ((0x00000100&(data))>>8)
+#define RIF_REG_VE_INT_STATUS_get_mvd_h264_mv_err(data)                              ((0x00000100&(data))>>8)
+#define RIF_REG_VE_INT_STATUS_m64coeff_shift                                         (6)
+#define RIF_REG_VE_INT_STATUS_m64coeff_mask                                          (0x00000040)
+#define RIF_REG_VE_INT_STATUS_m64coeff(data)                                         (0x00000040&((data)<<6))
+#define RIF_REG_VE_INT_STATUS_m64coeff_src(data)                                     ((0x00000040&(data))>>6)
+#define RIF_REG_VE_INT_STATUS_get_m64coeff(data)                                     ((0x00000040&(data))>>6)
+#define RIF_REG_VE_INT_STATUS_rstff_oflow_shift                                      (5)
+#define RIF_REG_VE_INT_STATUS_rstff_oflow_mask                                       (0x00000020)
+#define RIF_REG_VE_INT_STATUS_rstff_oflow(data)                                      (0x00000020&((data)<<5))
+#define RIF_REG_VE_INT_STATUS_rstff_oflow_src(data)                                  ((0x00000020&(data))>>5)
+#define RIF_REG_VE_INT_STATUS_get_rstff_oflow(data)                                  ((0x00000020&(data))>>5)
+#define RIF_REG_VE_INT_STATUS_rstff_empty_shift                                      (4)
+#define RIF_REG_VE_INT_STATUS_rstff_empty_mask                                       (0x00000010)
+#define RIF_REG_VE_INT_STATUS_rstff_empty(data)                                      (0x00000010&((data)<<4))
+#define RIF_REG_VE_INT_STATUS_rstff_empty_src(data)                                  ((0x00000010&(data))>>4)
+#define RIF_REG_VE_INT_STATUS_get_rstff_empty(data)                                  ((0x00000010&(data))>>4)
+#define RIF_REG_VE_INT_STATUS_bitst_fifo_shift                                       (3)
+#define RIF_REG_VE_INT_STATUS_bitst_fifo_mask                                        (0x00000008)
+#define RIF_REG_VE_INT_STATUS_bitst_fifo(data)                                       (0x00000008&((data)<<3))
+#define RIF_REG_VE_INT_STATUS_bitst_fifo_src(data)                                   ((0x00000008&(data))>>3)
+#define RIF_REG_VE_INT_STATUS_get_bitst_fifo(data)                                   ((0x00000008&(data))>>3)
+#define RIF_REG_VE_INT_STATUS_scode_limit_shift                                      (2)
+#define RIF_REG_VE_INT_STATUS_scode_limit_mask                                       (0x00000004)
+#define RIF_REG_VE_INT_STATUS_scode_limit(data)                                      (0x00000004&((data)<<2))
+#define RIF_REG_VE_INT_STATUS_scode_limit_src(data)                                  ((0x00000004&(data))>>2)
+#define RIF_REG_VE_INT_STATUS_get_scode_limit(data)                                  ((0x00000004&(data))>>2)
+#define RIF_REG_VE_INT_STATUS_dec_err_shift                                          (1)
+#define RIF_REG_VE_INT_STATUS_dec_err_mask                                           (0x00000002)
+#define RIF_REG_VE_INT_STATUS_dec_err(data)                                          (0x00000002&((data)<<1))
+#define RIF_REG_VE_INT_STATUS_dec_err_src(data)                                      ((0x00000002&(data))>>1)
+#define RIF_REG_VE_INT_STATUS_get_dec_err(data)                                      ((0x00000002&(data))>>1)
+#define RIF_REG_VE_INT_STATUS_write_data_shift                                       (0)
+#define RIF_REG_VE_INT_STATUS_write_data_mask                                        (0x00000001)
+#define RIF_REG_VE_INT_STATUS_write_data(data)                                       (0x00000001&((data)<<0))
+#define RIF_REG_VE_INT_STATUS_write_data_src(data)                                   ((0x00000001&(data))>>0)
+#define RIF_REG_VE_INT_STATUS_get_write_data(data)                                   ((0x00000001&(data))>>0)
+
+
+#define RIF_REG_VE_INT_EN                                                            0x1800E408
+#define RIF_REG_VE_INT_EN_reg_addr                                                   "0xB800E408"
+#define RIF_REG_VE_INT_EN_reg                                                        0xB800E408
+#define set_RIF_REG_VE_INT_EN_reg(data)   (*((volatile unsigned int*) RIF_REG_VE_INT_EN_reg)=data)
+#define get_RIF_REG_VE_INT_EN_reg   (*((volatile unsigned int*) RIF_REG_VE_INT_EN_reg))
+#define RIF_REG_VE_INT_EN_inst_adr                                                   "0x0002"
+#define RIF_REG_VE_INT_EN_inst                                                       0x0002
+#define RIF_REG_VE_INT_EN_cmd_fifo_full_int_ie_shift                                 (15)
+#define RIF_REG_VE_INT_EN_cmd_fifo_full_int_ie_mask                                  (0x00008000)
+#define RIF_REG_VE_INT_EN_cmd_fifo_full_int_ie(data)                                 (0x00008000&((data)<<15))
+#define RIF_REG_VE_INT_EN_cmd_fifo_full_int_ie_src(data)                             ((0x00008000&(data))>>15)
+#define RIF_REG_VE_INT_EN_get_cmd_fifo_full_int_ie(data)                             ((0x00008000&(data))>>15)
+#define RIF_REG_VE_INT_EN_rd_rslt_hang_int_ie_shift                                  (14)
+#define RIF_REG_VE_INT_EN_rd_rslt_hang_int_ie_mask                                   (0x00004000)
+#define RIF_REG_VE_INT_EN_rd_rslt_hang_int_ie(data)                                  (0x00004000&((data)<<14))
+#define RIF_REG_VE_INT_EN_rd_rslt_hang_int_ie_src(data)                              ((0x00004000&(data))>>14)
+#define RIF_REG_VE_INT_EN_get_rd_rslt_hang_int_ie(data)                              ((0x00004000&(data))>>14)
+#define RIF_REG_VE_INT_EN_rl_hang_int_ie_shift                                       (13)
+#define RIF_REG_VE_INT_EN_rl_hang_int_ie_mask                                        (0x00002000)
+#define RIF_REG_VE_INT_EN_rl_hang_int_ie(data)                                       (0x00002000&((data)<<13))
+#define RIF_REG_VE_INT_EN_rl_hang_int_ie_src(data)                                   ((0x00002000&(data))>>13)
+#define RIF_REG_VE_INT_EN_get_rl_hang_int_ie(data)                                   ((0x00002000&(data))>>13)
+#define RIF_REG_VE_INT_EN_pred_hang_int_ie_shift                                     (12)
+#define RIF_REG_VE_INT_EN_pred_hang_int_ie_mask                                      (0x00001000)
+#define RIF_REG_VE_INT_EN_pred_hang_int_ie(data)                                     (0x00001000&((data)<<12))
+#define RIF_REG_VE_INT_EN_pred_hang_int_ie_src(data)                                 ((0x00001000&(data))>>12)
+#define RIF_REG_VE_INT_EN_get_pred_hang_int_ie(data)                                 ((0x00001000&(data))>>12)
+#define RIF_REG_VE_INT_EN_mb_last_int_ie_shift                                       (11)
+#define RIF_REG_VE_INT_EN_mb_last_int_ie_mask                                        (0x00000800)
+#define RIF_REG_VE_INT_EN_mb_last_int_ie(data)                                       (0x00000800&((data)<<11))
+#define RIF_REG_VE_INT_EN_mb_last_int_ie_src(data)                                   ((0x00000800&(data))>>11)
+#define RIF_REG_VE_INT_EN_get_mb_last_int_ie(data)                                   ((0x00000800&(data))>>11)
+#define RIF_REG_VE_INT_EN_mvd_vc1_intfd_ie_shift                                     (10)
+#define RIF_REG_VE_INT_EN_mvd_vc1_intfd_ie_mask                                      (0x00000400)
+#define RIF_REG_VE_INT_EN_mvd_vc1_intfd_ie(data)                                     (0x00000400&((data)<<10))
+#define RIF_REG_VE_INT_EN_mvd_vc1_intfd_ie_src(data)                                 ((0x00000400&(data))>>10)
+#define RIF_REG_VE_INT_EN_get_mvd_vc1_intfd_ie(data)                                 ((0x00000400&(data))>>10)
+#define RIF_REG_VE_INT_EN_mvd_h264_direct_ie_shift                                   (9)
+#define RIF_REG_VE_INT_EN_mvd_h264_direct_ie_mask                                    (0x00000200)
+#define RIF_REG_VE_INT_EN_mvd_h264_direct_ie(data)                                   (0x00000200&((data)<<9))
+#define RIF_REG_VE_INT_EN_mvd_h264_direct_ie_src(data)                               ((0x00000200&(data))>>9)
+#define RIF_REG_VE_INT_EN_get_mvd_h264_direct_ie(data)                               ((0x00000200&(data))>>9)
+#define RIF_REG_VE_INT_EN_mvd_h264_mv_ie_shift                                       (8)
+#define RIF_REG_VE_INT_EN_mvd_h264_mv_ie_mask                                        (0x00000100)
+#define RIF_REG_VE_INT_EN_mvd_h264_mv_ie(data)                                       (0x00000100&((data)<<8))
+#define RIF_REG_VE_INT_EN_mvd_h264_mv_ie_src(data)                                   ((0x00000100&(data))>>8)
+#define RIF_REG_VE_INT_EN_get_mvd_h264_mv_ie(data)                                   ((0x00000100&(data))>>8)
+#define RIF_REG_VE_INT_EN_m64coeff_ie_shift                                          (6)
+#define RIF_REG_VE_INT_EN_m64coeff_ie_mask                                           (0x00000040)
+#define RIF_REG_VE_INT_EN_m64coeff_ie(data)                                          (0x00000040&((data)<<6))
+#define RIF_REG_VE_INT_EN_m64coeff_ie_src(data)                                      ((0x00000040&(data))>>6)
+#define RIF_REG_VE_INT_EN_get_m64coeff_ie(data)                                      ((0x00000040&(data))>>6)
+#define RIF_REG_VE_INT_EN_rstff_oflow_ie_shift                                       (5)
+#define RIF_REG_VE_INT_EN_rstff_oflow_ie_mask                                        (0x00000020)
+#define RIF_REG_VE_INT_EN_rstff_oflow_ie(data)                                       (0x00000020&((data)<<5))
+#define RIF_REG_VE_INT_EN_rstff_oflow_ie_src(data)                                   ((0x00000020&(data))>>5)
+#define RIF_REG_VE_INT_EN_get_rstff_oflow_ie(data)                                   ((0x00000020&(data))>>5)
+#define RIF_REG_VE_INT_EN_rstff_empty_ie_shift                                       (4)
+#define RIF_REG_VE_INT_EN_rstff_empty_ie_mask                                        (0x00000010)
+#define RIF_REG_VE_INT_EN_rstff_empty_ie(data)                                       (0x00000010&((data)<<4))
+#define RIF_REG_VE_INT_EN_rstff_empty_ie_src(data)                                   ((0x00000010&(data))>>4)
+#define RIF_REG_VE_INT_EN_get_rstff_empty_ie(data)                                   ((0x00000010&(data))>>4)
+#define RIF_REG_VE_INT_EN_bitst_fifo_ie_shift                                        (3)
+#define RIF_REG_VE_INT_EN_bitst_fifo_ie_mask                                         (0x00000008)
+#define RIF_REG_VE_INT_EN_bitst_fifo_ie(data)                                        (0x00000008&((data)<<3))
+#define RIF_REG_VE_INT_EN_bitst_fifo_ie_src(data)                                    ((0x00000008&(data))>>3)
+#define RIF_REG_VE_INT_EN_get_bitst_fifo_ie(data)                                    ((0x00000008&(data))>>3)
+#define RIF_REG_VE_INT_EN_scode_limit_ie_shift                                       (2)
+#define RIF_REG_VE_INT_EN_scode_limit_ie_mask                                        (0x00000004)
+#define RIF_REG_VE_INT_EN_scode_limit_ie(data)                                       (0x00000004&((data)<<2))
+#define RIF_REG_VE_INT_EN_scode_limit_ie_src(data)                                   ((0x00000004&(data))>>2)
+#define RIF_REG_VE_INT_EN_get_scode_limit_ie(data)                                   ((0x00000004&(data))>>2)
+#define RIF_REG_VE_INT_EN_dec_err_ie_shift                                           (1)
+#define RIF_REG_VE_INT_EN_dec_err_ie_mask                                            (0x00000002)
+#define RIF_REG_VE_INT_EN_dec_err_ie(data)                                           (0x00000002&((data)<<1))
+#define RIF_REG_VE_INT_EN_dec_err_ie_src(data)                                       ((0x00000002&(data))>>1)
+#define RIF_REG_VE_INT_EN_get_dec_err_ie(data)                                       ((0x00000002&(data))>>1)
+#define RIF_REG_VE_INT_EN_write_data_shift                                           (0)
+#define RIF_REG_VE_INT_EN_write_data_mask                                            (0x00000001)
+#define RIF_REG_VE_INT_EN_write_data(data)                                           (0x00000001&((data)<<0))
+#define RIF_REG_VE_INT_EN_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define RIF_REG_VE_INT_EN_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define RIF_REG_VE_FIFOSTATUS                                                        0x1800E410
+#define RIF_REG_VE_FIFOSTATUS_reg_addr                                               "0xB800E410"
+#define RIF_REG_VE_FIFOSTATUS_reg                                                    0xB800E410
+#define set_RIF_REG_VE_FIFOSTATUS_reg(data)   (*((volatile unsigned int*) RIF_REG_VE_FIFOSTATUS_reg)=data)
+#define get_RIF_REG_VE_FIFOSTATUS_reg   (*((volatile unsigned int*) RIF_REG_VE_FIFOSTATUS_reg))
+#define RIF_REG_VE_FIFOSTATUS_inst_adr                                               "0x0004"
+#define RIF_REG_VE_FIFOSTATUS_inst                                                   0x0004
+#define RIF_REG_VE_FIFOSTATUS_debk_inst_cnt_shift                                    (24)
+#define RIF_REG_VE_FIFOSTATUS_debk_inst_cnt_mask                                     (0x3F000000)
+#define RIF_REG_VE_FIFOSTATUS_debk_inst_cnt(data)                                    (0x3F000000&((data)<<24))
+#define RIF_REG_VE_FIFOSTATUS_debk_inst_cnt_src(data)                                ((0x3F000000&(data))>>24)
+#define RIF_REG_VE_FIFOSTATUS_get_debk_inst_cnt(data)                                ((0x3F000000&(data))>>24)
+#define RIF_REG_VE_FIFOSTATUS_pred_inst_cnt_shift                                    (16)
+#define RIF_REG_VE_FIFOSTATUS_pred_inst_cnt_mask                                     (0x003F0000)
+#define RIF_REG_VE_FIFOSTATUS_pred_inst_cnt(data)                                    (0x003F0000&((data)<<16))
+#define RIF_REG_VE_FIFOSTATUS_pred_inst_cnt_src(data)                                ((0x003F0000&(data))>>16)
+#define RIF_REG_VE_FIFOSTATUS_get_pred_inst_cnt(data)                                ((0x003F0000&(data))>>16)
+#define RIF_REG_VE_FIFOSTATUS_dmaa_inst_cnt_shift                                    (0)
+#define RIF_REG_VE_FIFOSTATUS_dmaa_inst_cnt_mask                                     (0x0000003F)
+#define RIF_REG_VE_FIFOSTATUS_dmaa_inst_cnt(data)                                    (0x0000003F&((data)<<0))
+#define RIF_REG_VE_FIFOSTATUS_dmaa_inst_cnt_src(data)                                ((0x0000003F&(data))>>0)
+#define RIF_REG_VE_FIFOSTATUS_get_dmaa_inst_cnt(data)                                ((0x0000003F&(data))>>0)
+
+
+#define RIF_REG_VE_FIFOSTAT2                                                         0x1800E414
+#define RIF_REG_VE_FIFOSTAT2_reg_addr                                                "0xB800E414"
+#define RIF_REG_VE_FIFOSTAT2_reg                                                     0xB800E414
+#define set_RIF_REG_VE_FIFOSTAT2_reg(data)   (*((volatile unsigned int*) RIF_REG_VE_FIFOSTAT2_reg)=data)
+#define get_RIF_REG_VE_FIFOSTAT2_reg   (*((volatile unsigned int*) RIF_REG_VE_FIFOSTAT2_reg))
+#define RIF_REG_VE_FIFOSTAT2_inst_adr                                                "0x0005"
+#define RIF_REG_VE_FIFOSTAT2_inst                                                    0x0005
+#define RIF_REG_VE_FIFOSTAT2_act_rslt_in_fifo_shift                                  (27)
+#define RIF_REG_VE_FIFOSTAT2_act_rslt_in_fifo_mask                                   (0xF8000000)
+#define RIF_REG_VE_FIFOSTAT2_act_rslt_in_fifo(data)                                  (0xF8000000&((data)<<27))
+#define RIF_REG_VE_FIFOSTAT2_act_rslt_in_fifo_src(data)                              ((0xF8000000&(data))>>27)
+#define RIF_REG_VE_FIFOSTAT2_get_act_rslt_in_fifo(data)                              ((0xF8000000&(data))>>27)
+#define RIF_REG_VE_FIFOSTAT2_rslt_fifo_cnt_shift                                     (22)
+#define RIF_REG_VE_FIFOSTAT2_rslt_fifo_cnt_mask                                      (0x07C00000)
+#define RIF_REG_VE_FIFOSTAT2_rslt_fifo_cnt(data)                                     (0x07C00000&((data)<<22))
+#define RIF_REG_VE_FIFOSTAT2_rslt_fifo_cnt_src(data)                                 ((0x07C00000&(data))>>22)
+#define RIF_REG_VE_FIFOSTAT2_get_rslt_fifo_cnt(data)                                 ((0x07C00000&(data))>>22)
+#define RIF_REG_VE_FIFOSTAT2_img_fifo_cnt_shift                                      (16)
+#define RIF_REG_VE_FIFOSTAT2_img_fifo_cnt_mask                                       (0x003F0000)
+#define RIF_REG_VE_FIFOSTAT2_img_fifo_cnt(data)                                      (0x003F0000&((data)<<16))
+#define RIF_REG_VE_FIFOSTAT2_img_fifo_cnt_src(data)                                  ((0x003F0000&(data))>>16)
+#define RIF_REG_VE_FIFOSTAT2_get_img_fifo_cnt(data)                                  ((0x003F0000&(data))>>16)
+#define RIF_REG_VE_FIFOSTAT2_dec_inst_cnt_shift                                      (8)
+#define RIF_REG_VE_FIFOSTAT2_dec_inst_cnt_mask                                       (0x00003F00)
+#define RIF_REG_VE_FIFOSTAT2_dec_inst_cnt(data)                                      (0x00003F00&((data)<<8))
+#define RIF_REG_VE_FIFOSTAT2_dec_inst_cnt_src(data)                                  ((0x00003F00&(data))>>8)
+#define RIF_REG_VE_FIFOSTAT2_get_dec_inst_cnt(data)                                  ((0x00003F00&(data))>>8)
+
+
+#define RIF_REG_VE_RSLT_TIMER                                                        0x1800E418
+#define RIF_REG_VE_RSLT_TIMER_reg_addr                                               "0xB800E418"
+#define RIF_REG_VE_RSLT_TIMER_reg                                                    0xB800E418
+#define set_RIF_REG_VE_RSLT_TIMER_reg(data)   (*((volatile unsigned int*) RIF_REG_VE_RSLT_TIMER_reg)=data)
+#define get_RIF_REG_VE_RSLT_TIMER_reg   (*((volatile unsigned int*) RIF_REG_VE_RSLT_TIMER_reg))
+#define RIF_REG_VE_RSLT_TIMER_inst_adr                                               "0x0006"
+#define RIF_REG_VE_RSLT_TIMER_inst                                                   0x0006
+#define RIF_REG_VE_RSLT_TIMER_rslt_timer_shift                                       (0)
+#define RIF_REG_VE_RSLT_TIMER_rslt_timer_mask                                        (0x00FFFFFF)
+#define RIF_REG_VE_RSLT_TIMER_rslt_timer(data)                                       (0x00FFFFFF&((data)<<0))
+#define RIF_REG_VE_RSLT_TIMER_rslt_timer_src(data)                                   ((0x00FFFFFF&(data))>>0)
+#define RIF_REG_VE_RSLT_TIMER_get_rslt_timer(data)                                   ((0x00FFFFFF&(data))>>0)
+
+
+#define RIF_REG_VE_CMD_TIMER                                                         0x1800E41C
+#define RIF_REG_VE_CMD_TIMER_reg_addr                                                "0xB800E41C"
+#define RIF_REG_VE_CMD_TIMER_reg                                                     0xB800E41C
+#define set_RIF_REG_VE_CMD_TIMER_reg(data)   (*((volatile unsigned int*) RIF_REG_VE_CMD_TIMER_reg)=data)
+#define get_RIF_REG_VE_CMD_TIMER_reg   (*((volatile unsigned int*) RIF_REG_VE_CMD_TIMER_reg))
+#define RIF_REG_VE_CMD_TIMER_inst_adr                                                "0x0007"
+#define RIF_REG_VE_CMD_TIMER_inst                                                    0x0007
+#define RIF_REG_VE_CMD_TIMER_cmd_timer_shift                                         (0)
+#define RIF_REG_VE_CMD_TIMER_cmd_timer_mask                                          (0x00FFFFFF)
+#define RIF_REG_VE_CMD_TIMER_cmd_timer(data)                                         (0x00FFFFFF&((data)<<0))
+#define RIF_REG_VE_CMD_TIMER_cmd_timer_src(data)                                     ((0x00FFFFFF&(data))>>0)
+#define RIF_REG_VE_CMD_TIMER_get_cmd_timer(data)                                     ((0x00FFFFFF&(data))>>0)
+
+
+#define RIF_REG_VMBANKSEL                                                            0x1800E420
+#define RIF_REG_VMBANKSEL_reg_addr                                                   "0xB800E420"
+#define RIF_REG_VMBANKSEL_reg                                                        0xB800E420
+#define set_RIF_REG_VMBANKSEL_reg(data)   (*((volatile unsigned int*) RIF_REG_VMBANKSEL_reg)=data)
+#define get_RIF_REG_VMBANKSEL_reg   (*((volatile unsigned int*) RIF_REG_VMBANKSEL_reg))
+#define RIF_REG_VMBANKSEL_inst_adr                                                   "0x0008"
+#define RIF_REG_VMBANKSEL_inst                                                       0x0008
+#define RIF_REG_VMBANKSEL_ve_img_bnk_shift                                           (16)
+#define RIF_REG_VMBANKSEL_ve_img_bnk_mask                                            (0x00070000)
+#define RIF_REG_VMBANKSEL_ve_img_bnk(data)                                           (0x00070000&((data)<<16))
+#define RIF_REG_VMBANKSEL_ve_img_bnk_src(data)                                       ((0x00070000&(data))>>16)
+#define RIF_REG_VMBANKSEL_get_ve_img_bnk(data)                                       ((0x00070000&(data))>>16)
+#define RIF_REG_VMBANKSEL_ve_deb_bnk_shift                                           (12)
+#define RIF_REG_VMBANKSEL_ve_deb_bnk_mask                                            (0x00007000)
+#define RIF_REG_VMBANKSEL_ve_deb_bnk(data)                                           (0x00007000&((data)<<12))
+#define RIF_REG_VMBANKSEL_ve_deb_bnk_src(data)                                       ((0x00007000&(data))>>12)
+#define RIF_REG_VMBANKSEL_get_ve_deb_bnk(data)                                       ((0x00007000&(data))>>12)
+#define RIF_REG_VMBANKSEL_ve_prd_bnk_shift                                           (8)
+#define RIF_REG_VMBANKSEL_ve_prd_bnk_mask                                            (0x00000700)
+#define RIF_REG_VMBANKSEL_ve_prd_bnk(data)                                           (0x00000700&((data)<<8))
+#define RIF_REG_VMBANKSEL_ve_prd_bnk_src(data)                                       ((0x00000700&(data))>>8)
+#define RIF_REG_VMBANKSEL_get_ve_prd_bnk(data)                                       ((0x00000700&(data))>>8)
+#define RIF_REG_VMBANKSEL_ve_dmaa_bnk_shift                                          (0)
+#define RIF_REG_VMBANKSEL_ve_dmaa_bnk_mask                                           (0x00000007)
+#define RIF_REG_VMBANKSEL_ve_dmaa_bnk(data)                                          (0x00000007&((data)<<0))
+#define RIF_REG_VMBANKSEL_ve_dmaa_bnk_src(data)                                      ((0x00000007&(data))>>0)
+#define RIF_REG_VMBANKSEL_get_ve_dmaa_bnk(data)                                      ((0x00000007&(data))>>0)
+
+
+#define RIF_REG_DEC_CNTL                                                             0x1800E450
+#define RIF_REG_DEC_CNTL_reg_addr                                                    "0xB800E450"
+#define RIF_REG_DEC_CNTL_reg                                                         0xB800E450
+#define set_RIF_REG_DEC_CNTL_reg(data)   (*((volatile unsigned int*) RIF_REG_DEC_CNTL_reg)=data)
+#define get_RIF_REG_DEC_CNTL_reg   (*((volatile unsigned int*) RIF_REG_DEC_CNTL_reg))
+#define RIF_REG_DEC_CNTL_inst_adr                                                    "0x0014"
+#define RIF_REG_DEC_CNTL_inst                                                        0x0014
+#define RIF_REG_DEC_CNTL_monochrome_shift                                            (7)
+#define RIF_REG_DEC_CNTL_monochrome_mask                                             (0x00000080)
+#define RIF_REG_DEC_CNTL_monochrome(data)                                            (0x00000080&((data)<<7))
+#define RIF_REG_DEC_CNTL_monochrome_src(data)                                        ((0x00000080&(data))>>7)
+#define RIF_REG_DEC_CNTL_get_monochrome(data)                                        ((0x00000080&(data))>>7)
+#define RIF_REG_DEC_CNTL_level_shift                                                 (6)
+#define RIF_REG_DEC_CNTL_level_mask                                                  (0x00000040)
+#define RIF_REG_DEC_CNTL_level(data)                                                 (0x00000040&((data)<<6))
+#define RIF_REG_DEC_CNTL_level_src(data)                                             ((0x00000040&(data))>>6)
+#define RIF_REG_DEC_CNTL_get_level(data)                                             ((0x00000040&(data))>>6)
+#define RIF_REG_DEC_CNTL_profile_shift                                               (4)
+#define RIF_REG_DEC_CNTL_profile_mask                                                (0x00000030)
+#define RIF_REG_DEC_CNTL_profile(data)                                               (0x00000030&((data)<<4))
+#define RIF_REG_DEC_CNTL_profile_src(data)                                           ((0x00000030&(data))>>4)
+#define RIF_REG_DEC_CNTL_get_profile(data)                                           ((0x00000030&(data))>>4)
+#define RIF_REG_DEC_CNTL_coding_type_shift                                           (0)
+#define RIF_REG_DEC_CNTL_coding_type_mask                                            (0x0000000F)
+#define RIF_REG_DEC_CNTL_coding_type(data)                                           (0x0000000F&((data)<<0))
+#define RIF_REG_DEC_CNTL_coding_type_src(data)                                       ((0x0000000F&(data))>>0)
+#define RIF_REG_DEC_CNTL_get_coding_type(data)                                       ((0x0000000F&(data))>>0)
+
+
+#define RIF_REG_PICINFO1                                                             0x1800E454
+#define RIF_REG_PICINFO1_reg_addr                                                    "0xB800E454"
+#define RIF_REG_PICINFO1_reg                                                         0xB800E454
+#define set_RIF_REG_PICINFO1_reg(data)   (*((volatile unsigned int*) RIF_REG_PICINFO1_reg)=data)
+#define get_RIF_REG_PICINFO1_reg   (*((volatile unsigned int*) RIF_REG_PICINFO1_reg))
+#define RIF_REG_PICINFO1_inst_adr                                                    "0x0015"
+#define RIF_REG_PICINFO1_inst                                                        0x0015
+#define RIF_REG_PICINFO1_vp8_bicubic_filtering_shift                                 (16)
+#define RIF_REG_PICINFO1_vp8_bicubic_filtering_mask                                  (0x00010000)
+#define RIF_REG_PICINFO1_vp8_bicubic_filtering(data)                                 (0x00010000&((data)<<16))
+#define RIF_REG_PICINFO1_vp8_bicubic_filtering_src(data)                             ((0x00010000&(data))>>16)
+#define RIF_REG_PICINFO1_get_vp8_bicubic_filtering(data)                             ((0x00010000&(data))>>16)
+#define RIF_REG_PICINFO1_bottom_field_flag_shift                                     (15)
+#define RIF_REG_PICINFO1_bottom_field_flag_mask                                      (0x00008000)
+#define RIF_REG_PICINFO1_bottom_field_flag(data)                                     (0x00008000&((data)<<15))
+#define RIF_REG_PICINFO1_bottom_field_flag_src(data)                                 ((0x00008000&(data))>>15)
+#define RIF_REG_PICINFO1_get_bottom_field_flag(data)                                 ((0x00008000&(data))>>15)
+#define RIF_REG_PICINFO1_field_pic_flag_shift                                        (14)
+#define RIF_REG_PICINFO1_field_pic_flag_mask                                         (0x00004000)
+#define RIF_REG_PICINFO1_field_pic_flag(data)                                        (0x00004000&((data)<<14))
+#define RIF_REG_PICINFO1_field_pic_flag_src(data)                                    ((0x00004000&(data))>>14)
+#define RIF_REG_PICINFO1_get_field_pic_flag(data)                                    ((0x00004000&(data))>>14)
+#define RIF_REG_PICINFO1_picmb_h_shift                                               (7)
+#define RIF_REG_PICINFO1_picmb_h_mask                                                (0x00003F80)
+#define RIF_REG_PICINFO1_picmb_h(data)                                               (0x00003F80&((data)<<7))
+#define RIF_REG_PICINFO1_picmb_h_src(data)                                           ((0x00003F80&(data))>>7)
+#define RIF_REG_PICINFO1_get_picmb_h(data)                                           ((0x00003F80&(data))>>7)
+#define RIF_REG_PICINFO1_picmb_w_shift                                               (0)
+#define RIF_REG_PICINFO1_picmb_w_mask                                                (0x0000007F)
+#define RIF_REG_PICINFO1_picmb_w(data)                                               (0x0000007F&((data)<<0))
+#define RIF_REG_PICINFO1_picmb_w_src(data)                                           ((0x0000007F&(data))>>0)
+#define RIF_REG_PICINFO1_get_picmb_w(data)                                           ((0x0000007F&(data))>>0)
+
+
+#define RIF_REG_H264PICCNTL                                                          0x1800E460
+#define RIF_REG_H264PICCNTL_reg_addr                                                 "0xB800E460"
+#define RIF_REG_H264PICCNTL_reg                                                      0xB800E460
+#define set_RIF_REG_H264PICCNTL_reg(data)   (*((volatile unsigned int*) RIF_REG_H264PICCNTL_reg)=data)
+#define get_RIF_REG_H264PICCNTL_reg   (*((volatile unsigned int*) RIF_REG_H264PICCNTL_reg))
+#define RIF_REG_H264PICCNTL_inst_adr                                                 "0x0018"
+#define RIF_REG_H264PICCNTL_inst                                                     0x0018
+#define RIF_REG_H264PICCNTL_Constrainted_intra_pred_flag_shift                       (5)
+#define RIF_REG_H264PICCNTL_Constrainted_intra_pred_flag_mask                        (0x00000020)
+#define RIF_REG_H264PICCNTL_Constrainted_intra_pred_flag(data)                       (0x00000020&((data)<<5))
+#define RIF_REG_H264PICCNTL_Constrainted_intra_pred_flag_src(data)                   ((0x00000020&(data))>>5)
+#define RIF_REG_H264PICCNTL_get_Constrainted_intra_pred_flag(data)                   ((0x00000020&(data))>>5)
+#define RIF_REG_H264PICCNTL_Weighted_pred_flag_shift                                 (4)
+#define RIF_REG_H264PICCNTL_Weighted_pred_flag_mask                                  (0x00000010)
+#define RIF_REG_H264PICCNTL_Weighted_pred_flag(data)                                 (0x00000010&((data)<<4))
+#define RIF_REG_H264PICCNTL_Weighted_pred_flag_src(data)                             ((0x00000010&(data))>>4)
+#define RIF_REG_H264PICCNTL_get_Weighted_pred_flag(data)                             ((0x00000010&(data))>>4)
+#define RIF_REG_H264PICCNTL_Weighted_bipred_idc_shift                                (2)
+#define RIF_REG_H264PICCNTL_Weighted_bipred_idc_mask                                 (0x0000000C)
+#define RIF_REG_H264PICCNTL_Weighted_bipred_idc(data)                                (0x0000000C&((data)<<2))
+#define RIF_REG_H264PICCNTL_Weighted_bipred_idc_src(data)                            ((0x0000000C&(data))>>2)
+#define RIF_REG_H264PICCNTL_get_Weighted_bipred_idc(data)                            ((0x0000000C&(data))>>2)
+#define RIF_REG_H264PICCNTL_frame_mbs_only_flag_shift                                (1)
+#define RIF_REG_H264PICCNTL_frame_mbs_only_flag_mask                                 (0x00000002)
+#define RIF_REG_H264PICCNTL_frame_mbs_only_flag(data)                                (0x00000002&((data)<<1))
+#define RIF_REG_H264PICCNTL_frame_mbs_only_flag_src(data)                            ((0x00000002&(data))>>1)
+#define RIF_REG_H264PICCNTL_get_frame_mbs_only_flag(data)                            ((0x00000002&(data))>>1)
+#define RIF_REG_H264PICCNTL_mb_adaptive_frame_field_flag_shift                       (0)
+#define RIF_REG_H264PICCNTL_mb_adaptive_frame_field_flag_mask                        (0x00000001)
+#define RIF_REG_H264PICCNTL_mb_adaptive_frame_field_flag(data)                       (0x00000001&((data)<<0))
+#define RIF_REG_H264PICCNTL_mb_adaptive_frame_field_flag_src(data)                   ((0x00000001&(data))>>0)
+#define RIF_REG_H264PICCNTL_get_mb_adaptive_frame_field_flag(data)                   ((0x00000001&(data))>>0)
+
+
+#define RIF_REG_VC1PICCNTL                                                           0x1800E470
+#define RIF_REG_VC1PICCNTL_reg_addr                                                  "0xB800E470"
+#define RIF_REG_VC1PICCNTL_reg                                                       0xB800E470
+#define set_RIF_REG_VC1PICCNTL_reg(data)   (*((volatile unsigned int*) RIF_REG_VC1PICCNTL_reg)=data)
+#define get_RIF_REG_VC1PICCNTL_reg   (*((volatile unsigned int*) RIF_REG_VC1PICCNTL_reg))
+#define RIF_REG_VC1PICCNTL_inst_adr                                                  "0x001C"
+#define RIF_REG_VC1PICCNTL_inst                                                      0x001C
+#define RIF_REG_VC1PICCNTL_Overlap_enable_shift                                      (31)
+#define RIF_REG_VC1PICCNTL_Overlap_enable_mask                                       (0x80000000)
+#define RIF_REG_VC1PICCNTL_Overlap_enable(data)                                      (0x80000000&((data)<<31))
+#define RIF_REG_VC1PICCNTL_Overlap_enable_src(data)                                  ((0x80000000&(data))>>31)
+#define RIF_REG_VC1PICCNTL_get_Overlap_enable(data)                                  ((0x80000000&(data))>>31)
+#define RIF_REG_VC1PICCNTL_field_pictype_shift                                       (28)
+#define RIF_REG_VC1PICCNTL_field_pictype_mask                                        (0x70000000)
+#define RIF_REG_VC1PICCNTL_field_pictype(data)                                       (0x70000000&((data)<<28))
+#define RIF_REG_VC1PICCNTL_field_pictype_src(data)                                   ((0x70000000&(data))>>28)
+#define RIF_REG_VC1PICCNTL_get_field_pictype(data)                                   ((0x70000000&(data))>>28)
+#define RIF_REG_VC1PICCNTL_mvmode_shift                                              (26)
+#define RIF_REG_VC1PICCNTL_mvmode_mask                                               (0x0C000000)
+#define RIF_REG_VC1PICCNTL_mvmode(data)                                              (0x0C000000&((data)<<26))
+#define RIF_REG_VC1PICCNTL_mvmode_src(data)                                          ((0x0C000000&(data))>>26)
+#define RIF_REG_VC1PICCNTL_get_mvmode(data)                                          ((0x0C000000&(data))>>26)
+#define RIF_REG_VC1PICCNTL_fcm_shift                                                 (24)
+#define RIF_REG_VC1PICCNTL_fcm_mask                                                  (0x03000000)
+#define RIF_REG_VC1PICCNTL_fcm(data)                                                 (0x03000000&((data)<<24))
+#define RIF_REG_VC1PICCNTL_fcm_src(data)                                             ((0x03000000&(data))>>24)
+#define RIF_REG_VC1PICCNTL_get_fcm(data)                                             ((0x03000000&(data))>>24)
+#define RIF_REG_VC1PICCNTL_disppic_h_shift                                           (12)
+#define RIF_REG_VC1PICCNTL_disppic_h_mask                                            (0x00FFF000)
+#define RIF_REG_VC1PICCNTL_disppic_h(data)                                           (0x00FFF000&((data)<<12))
+#define RIF_REG_VC1PICCNTL_disppic_h_src(data)                                       ((0x00FFF000&(data))>>12)
+#define RIF_REG_VC1PICCNTL_get_disppic_h(data)                                       ((0x00FFF000&(data))>>12)
+#define RIF_REG_VC1PICCNTL_disppic_w_shift                                           (0)
+#define RIF_REG_VC1PICCNTL_disppic_w_mask                                            (0x00000FFF)
+#define RIF_REG_VC1PICCNTL_disppic_w(data)                                           (0x00000FFF&((data)<<0))
+#define RIF_REG_VC1PICCNTL_disppic_w_src(data)                                       ((0x00000FFF&(data))>>0)
+#define RIF_REG_VC1PICCNTL_get_disppic_w(data)                                       ((0x00000FFF&(data))>>0)
+
+
+#define RIF_REG_VC1PICCNTL2                                                          0x1800E474
+#define RIF_REG_VC1PICCNTL2_reg_addr                                                 "0xB800E474"
+#define RIF_REG_VC1PICCNTL2_reg                                                      0xB800E474
+#define set_RIF_REG_VC1PICCNTL2_reg(data)   (*((volatile unsigned int*) RIF_REG_VC1PICCNTL2_reg)=data)
+#define get_RIF_REG_VC1PICCNTL2_reg   (*((volatile unsigned int*) RIF_REG_VC1PICCNTL2_reg))
+#define RIF_REG_VC1PICCNTL2_inst_adr                                                 "0x001D"
+#define RIF_REG_VC1PICCNTL2_inst                                                     0x001D
+#define RIF_REG_VC1PICCNTL2_wmv9_bug_rtmflag_shift                                   (8)
+#define RIF_REG_VC1PICCNTL2_wmv9_bug_rtmflag_mask                                    (0x00000100)
+#define RIF_REG_VC1PICCNTL2_wmv9_bug_rtmflag(data)                                   (0x00000100&((data)<<8))
+#define RIF_REG_VC1PICCNTL2_wmv9_bug_rtmflag_src(data)                               ((0x00000100&(data))>>8)
+#define RIF_REG_VC1PICCNTL2_get_wmv9_bug_rtmflag(data)                               ((0x00000100&(data))>>8)
+#define RIF_REG_VC1PICCNTL2_wmv9_bug_it_shift                                        (7)
+#define RIF_REG_VC1PICCNTL2_wmv9_bug_it_mask                                         (0x00000080)
+#define RIF_REG_VC1PICCNTL2_wmv9_bug_it(data)                                        (0x00000080&((data)<<7))
+#define RIF_REG_VC1PICCNTL2_wmv9_bug_it_src(data)                                    ((0x00000080&(data))>>7)
+#define RIF_REG_VC1PICCNTL2_get_wmv9_bug_it(data)                                    ((0x00000080&(data))>>7)
+#define RIF_REG_VC1PICCNTL2_loopfilter_shift                                         (6)
+#define RIF_REG_VC1PICCNTL2_loopfilter_mask                                          (0x00000040)
+#define RIF_REG_VC1PICCNTL2_loopfilter(data)                                         (0x00000040&((data)<<6))
+#define RIF_REG_VC1PICCNTL2_loopfilter_src(data)                                     ((0x00000040&(data))>>6)
+#define RIF_REG_VC1PICCNTL2_get_loopfilter(data)                                     ((0x00000040&(data))>>6)
+#define RIF_REG_VC1PICCNTL2_numref_shift                                             (5)
+#define RIF_REG_VC1PICCNTL2_numref_mask                                              (0x00000020)
+#define RIF_REG_VC1PICCNTL2_numref(data)                                             (0x00000020&((data)<<5))
+#define RIF_REG_VC1PICCNTL2_numref_src(data)                                         ((0x00000020&(data))>>5)
+#define RIF_REG_VC1PICCNTL2_get_numref(data)                                         ((0x00000020&(data))>>5)
+#define RIF_REG_VC1PICCNTL2_pquant_shift                                             (0)
+#define RIF_REG_VC1PICCNTL2_pquant_mask                                              (0x0000001F)
+#define RIF_REG_VC1PICCNTL2_pquant(data)                                             (0x0000001F&((data)<<0))
+#define RIF_REG_VC1PICCNTL2_pquant_src(data)                                         ((0x0000001F&(data))>>0)
+#define RIF_REG_VC1PICCNTL2_get_pquant(data)                                         ((0x0000001F&(data))>>0)
+
+
+#define RIF_REG_BRG_CTRL                                                             0x1800E490
+#define RIF_REG_BRG_CTRL_reg_addr                                                    "0xB800E490"
+#define RIF_REG_BRG_CTRL_reg                                                         0xB800E490
+#define set_RIF_REG_BRG_CTRL_reg(data)   (*((volatile unsigned int*) RIF_REG_BRG_CTRL_reg)=data)
+#define get_RIF_REG_BRG_CTRL_reg   (*((volatile unsigned int*) RIF_REG_BRG_CTRL_reg))
+#define RIF_REG_BRG_CTRL_inst_adr                                                    "0x0024"
+#define RIF_REG_BRG_CTRL_inst                                                        0x0024
+#define RIF_REG_BRG_CTRL_priority_thd2_shift                                         (16)
+#define RIF_REG_BRG_CTRL_priority_thd2_mask                                          (0x00FF0000)
+#define RIF_REG_BRG_CTRL_priority_thd2(data)                                         (0x00FF0000&((data)<<16))
+#define RIF_REG_BRG_CTRL_priority_thd2_src(data)                                     ((0x00FF0000&(data))>>16)
+#define RIF_REG_BRG_CTRL_get_priority_thd2(data)                                     ((0x00FF0000&(data))>>16)
+#define RIF_REG_BRG_CTRL_priority_thd1_shift                                         (8)
+#define RIF_REG_BRG_CTRL_priority_thd1_mask                                          (0x0000FF00)
+#define RIF_REG_BRG_CTRL_priority_thd1(data)                                         (0x0000FF00&((data)<<8))
+#define RIF_REG_BRG_CTRL_priority_thd1_src(data)                                     ((0x0000FF00&(data))>>8)
+#define RIF_REG_BRG_CTRL_get_priority_thd1(data)                                     ((0x0000FF00&(data))>>8)
+#define RIF_REG_BRG_CTRL_srg_mode_shift                                              (3)
+#define RIF_REG_BRG_CTRL_srg_mode_mask                                               (0x00000008)
+#define RIF_REG_BRG_CTRL_srg_mode(data)                                              (0x00000008&((data)<<3))
+#define RIF_REG_BRG_CTRL_srg_mode_src(data)                                          ((0x00000008&(data))>>3)
+#define RIF_REG_BRG_CTRL_get_srg_mode(data)                                          ((0x00000008&(data))>>3)
+#define RIF_REG_BRG_CTRL_ddr_page_shift                                              (1)
+#define RIF_REG_BRG_CTRL_ddr_page_mask                                               (0x00000006)
+#define RIF_REG_BRG_CTRL_ddr_page(data)                                              (0x00000006&((data)<<1))
+#define RIF_REG_BRG_CTRL_ddr_page_src(data)                                          ((0x00000006&(data))>>1)
+#define RIF_REG_BRG_CTRL_get_ddr_page(data)                                          ((0x00000006&(data))>>1)
+#define RIF_REG_BRG_CTRL_srg_enable_shift                                            (0)
+#define RIF_REG_BRG_CTRL_srg_enable_mask                                             (0x00000001)
+#define RIF_REG_BRG_CTRL_srg_enable(data)                                            (0x00000001&((data)<<0))
+#define RIF_REG_BRG_CTRL_srg_enable_src(data)                                        ((0x00000001&(data))>>0)
+#define RIF_REG_BRG_CTRL_get_srg_enable(data)                                        ((0x00000001&(data))>>0)
+
+
+#define RIF_REG_RD_PRIORITY0                                                         0x1800E494
+#define RIF_REG_RD_PRIORITY0_reg_addr                                                "0xB800E494"
+#define RIF_REG_RD_PRIORITY0_reg                                                     0xB800E494
+#define set_RIF_REG_RD_PRIORITY0_reg(data)   (*((volatile unsigned int*) RIF_REG_RD_PRIORITY0_reg)=data)
+#define get_RIF_REG_RD_PRIORITY0_reg   (*((volatile unsigned int*) RIF_REG_RD_PRIORITY0_reg))
+#define RIF_REG_RD_PRIORITY0_inst_adr                                                "0x0025"
+#define RIF_REG_RD_PRIORITY0_inst                                                    0x0025
+#define RIF_REG_RD_PRIORITY0_vm1_shift                                               (0)
+#define RIF_REG_RD_PRIORITY0_vm1_mask                                                (0x000000FF)
+#define RIF_REG_RD_PRIORITY0_vm1(data)                                               (0x000000FF&((data)<<0))
+#define RIF_REG_RD_PRIORITY0_vm1_src(data)                                           ((0x000000FF&(data))>>0)
+#define RIF_REG_RD_PRIORITY0_get_vm1(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define RIF_REG_RD_PRIORITY1                                                         0x1800E498
+#define RIF_REG_RD_PRIORITY1_reg_addr                                                "0xB800E498"
+#define RIF_REG_RD_PRIORITY1_reg                                                     0xB800E498
+#define set_RIF_REG_RD_PRIORITY1_reg(data)   (*((volatile unsigned int*) RIF_REG_RD_PRIORITY1_reg)=data)
+#define get_RIF_REG_RD_PRIORITY1_reg   (*((volatile unsigned int*) RIF_REG_RD_PRIORITY1_reg))
+#define RIF_REG_RD_PRIORITY1_inst_adr                                                "0x0026"
+#define RIF_REG_RD_PRIORITY1_inst                                                    0x0026
+#define RIF_REG_RD_PRIORITY1_deblk_shift                                             (16)
+#define RIF_REG_RD_PRIORITY1_deblk_mask                                              (0x00FF0000)
+#define RIF_REG_RD_PRIORITY1_deblk(data)                                             (0x00FF0000&((data)<<16))
+#define RIF_REG_RD_PRIORITY1_deblk_src(data)                                         ((0x00FF0000&(data))>>16)
+#define RIF_REG_RD_PRIORITY1_get_deblk(data)                                         ((0x00FF0000&(data))>>16)
+#define RIF_REG_RD_PRIORITY1_predblk_shift                                           (0)
+#define RIF_REG_RD_PRIORITY1_predblk_mask                                            (0x000000FF)
+#define RIF_REG_RD_PRIORITY1_predblk(data)                                           (0x000000FF&((data)<<0))
+#define RIF_REG_RD_PRIORITY1_predblk_src(data)                                       ((0x000000FF&(data))>>0)
+#define RIF_REG_RD_PRIORITY1_get_predblk(data)                                       ((0x000000FF&(data))>>0)
+
+
+#define RIF_REG_RD_PRIORITY2                                                         0x1800E49C
+#define RIF_REG_RD_PRIORITY2_reg_addr                                                "0xB800E49C"
+#define RIF_REG_RD_PRIORITY2_reg                                                     0xB800E49C
+#define set_RIF_REG_RD_PRIORITY2_reg(data)   (*((volatile unsigned int*) RIF_REG_RD_PRIORITY2_reg)=data)
+#define get_RIF_REG_RD_PRIORITY2_reg   (*((volatile unsigned int*) RIF_REG_RD_PRIORITY2_reg))
+#define RIF_REG_RD_PRIORITY2_inst_adr                                                "0x0027"
+#define RIF_REG_RD_PRIORITY2_inst                                                    0x0027
+#define RIF_REG_RD_PRIORITY2_nm_shift                                                (16)
+#define RIF_REG_RD_PRIORITY2_nm_mask                                                 (0x00FF0000)
+#define RIF_REG_RD_PRIORITY2_nm(data)                                                (0x00FF0000&((data)<<16))
+#define RIF_REG_RD_PRIORITY2_nm_src(data)                                            ((0x00FF0000&(data))>>16)
+#define RIF_REG_RD_PRIORITY2_get_nm(data)                                            ((0x00FF0000&(data))>>16)
+#define RIF_REG_RD_PRIORITY2_mvd_shift                                               (0)
+#define RIF_REG_RD_PRIORITY2_mvd_mask                                                (0x000000FF)
+#define RIF_REG_RD_PRIORITY2_mvd(data)                                               (0x000000FF&((data)<<0))
+#define RIF_REG_RD_PRIORITY2_mvd_src(data)                                           ((0x000000FF&(data))>>0)
+#define RIF_REG_RD_PRIORITY2_get_mvd(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define RIF_REG_RD_PRIORITY3                                                         0x1800E4A0
+#define RIF_REG_RD_PRIORITY3_reg_addr                                                "0xB800E4A0"
+#define RIF_REG_RD_PRIORITY3_reg                                                     0xB800E4A0
+#define set_RIF_REG_RD_PRIORITY3_reg(data)   (*((volatile unsigned int*) RIF_REG_RD_PRIORITY3_reg)=data)
+#define get_RIF_REG_RD_PRIORITY3_reg   (*((volatile unsigned int*) RIF_REG_RD_PRIORITY3_reg))
+#define RIF_REG_RD_PRIORITY3_inst_adr                                                "0x0028"
+#define RIF_REG_RD_PRIORITY3_inst                                                    0x0028
+#define RIF_REG_RD_PRIORITY3_bs_shift                                                (0)
+#define RIF_REG_RD_PRIORITY3_bs_mask                                                 (0x000000FF)
+#define RIF_REG_RD_PRIORITY3_bs(data)                                                (0x000000FF&((data)<<0))
+#define RIF_REG_RD_PRIORITY3_bs_src(data)                                            ((0x000000FF&(data))>>0)
+#define RIF_REG_RD_PRIORITY3_get_bs(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define RIF_REG_RD_PRIORITY4                                                         0x1800E4A4
+#define RIF_REG_RD_PRIORITY4_reg_addr                                                "0xB800E4A4"
+#define RIF_REG_RD_PRIORITY4_reg                                                     0xB800E4A4
+#define set_RIF_REG_RD_PRIORITY4_reg(data)   (*((volatile unsigned int*) RIF_REG_RD_PRIORITY4_reg)=data)
+#define get_RIF_REG_RD_PRIORITY4_reg   (*((volatile unsigned int*) RIF_REG_RD_PRIORITY4_reg))
+#define RIF_REG_RD_PRIORITY4_inst_adr                                                "0x0029"
+#define RIF_REG_RD_PRIORITY4_inst                                                    0x0029
+#define RIF_REG_RD_PRIORITY4_rl_shift                                                (0)
+#define RIF_REG_RD_PRIORITY4_rl_mask                                                 (0x000000FF)
+#define RIF_REG_RD_PRIORITY4_rl(data)                                                (0x000000FF&((data)<<0))
+#define RIF_REG_RD_PRIORITY4_rl_src(data)                                            ((0x000000FF&(data))>>0)
+#define RIF_REG_RD_PRIORITY4_get_rl(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define RIF_REG_WT_PRIORITY0                                                         0x1800E4B0
+#define RIF_REG_WT_PRIORITY0_reg_addr                                                "0xB800E4B0"
+#define RIF_REG_WT_PRIORITY0_reg                                                     0xB800E4B0
+#define set_RIF_REG_WT_PRIORITY0_reg(data)   (*((volatile unsigned int*) RIF_REG_WT_PRIORITY0_reg)=data)
+#define get_RIF_REG_WT_PRIORITY0_reg   (*((volatile unsigned int*) RIF_REG_WT_PRIORITY0_reg))
+#define RIF_REG_WT_PRIORITY0_inst_adr                                                "0x002C"
+#define RIF_REG_WT_PRIORITY0_inst                                                    0x002C
+#define RIF_REG_WT_PRIORITY0_vm1_shift                                               (0)
+#define RIF_REG_WT_PRIORITY0_vm1_mask                                                (0x000000FF)
+#define RIF_REG_WT_PRIORITY0_vm1(data)                                               (0x000000FF&((data)<<0))
+#define RIF_REG_WT_PRIORITY0_vm1_src(data)                                           ((0x000000FF&(data))>>0)
+#define RIF_REG_WT_PRIORITY0_get_vm1(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define RIF_REG_WT_PRIORITY1                                                         0x1800E4B4
+#define RIF_REG_WT_PRIORITY1_reg_addr                                                "0xB800E4B4"
+#define RIF_REG_WT_PRIORITY1_reg                                                     0xB800E4B4
+#define set_RIF_REG_WT_PRIORITY1_reg(data)   (*((volatile unsigned int*) RIF_REG_WT_PRIORITY1_reg)=data)
+#define get_RIF_REG_WT_PRIORITY1_reg   (*((volatile unsigned int*) RIF_REG_WT_PRIORITY1_reg))
+#define RIF_REG_WT_PRIORITY1_inst_adr                                                "0x002D"
+#define RIF_REG_WT_PRIORITY1_inst                                                    0x002D
+#define RIF_REG_WT_PRIORITY1_deblk_shift                                             (16)
+#define RIF_REG_WT_PRIORITY1_deblk_mask                                              (0x00FF0000)
+#define RIF_REG_WT_PRIORITY1_deblk(data)                                             (0x00FF0000&((data)<<16))
+#define RIF_REG_WT_PRIORITY1_deblk_src(data)                                         ((0x00FF0000&(data))>>16)
+#define RIF_REG_WT_PRIORITY1_get_deblk(data)                                         ((0x00FF0000&(data))>>16)
+#define RIF_REG_WT_PRIORITY1_predblk_shift                                           (0)
+#define RIF_REG_WT_PRIORITY1_predblk_mask                                            (0x000000FF)
+#define RIF_REG_WT_PRIORITY1_predblk(data)                                           (0x000000FF&((data)<<0))
+#define RIF_REG_WT_PRIORITY1_predblk_src(data)                                       ((0x000000FF&(data))>>0)
+#define RIF_REG_WT_PRIORITY1_get_predblk(data)                                       ((0x000000FF&(data))>>0)
+
+
+#define RIF_REG_WT_PRIORITY2                                                         0x1800E4B8
+#define RIF_REG_WT_PRIORITY2_reg_addr                                                "0xB800E4B8"
+#define RIF_REG_WT_PRIORITY2_reg                                                     0xB800E4B8
+#define set_RIF_REG_WT_PRIORITY2_reg(data)   (*((volatile unsigned int*) RIF_REG_WT_PRIORITY2_reg)=data)
+#define get_RIF_REG_WT_PRIORITY2_reg   (*((volatile unsigned int*) RIF_REG_WT_PRIORITY2_reg))
+#define RIF_REG_WT_PRIORITY2_inst_adr                                                "0x002E"
+#define RIF_REG_WT_PRIORITY2_inst                                                    0x002E
+#define RIF_REG_WT_PRIORITY2_nm_shift                                                (16)
+#define RIF_REG_WT_PRIORITY2_nm_mask                                                 (0x00FF0000)
+#define RIF_REG_WT_PRIORITY2_nm(data)                                                (0x00FF0000&((data)<<16))
+#define RIF_REG_WT_PRIORITY2_nm_src(data)                                            ((0x00FF0000&(data))>>16)
+#define RIF_REG_WT_PRIORITY2_get_nm(data)                                            ((0x00FF0000&(data))>>16)
+#define RIF_REG_WT_PRIORITY2_mvd_shift                                               (0)
+#define RIF_REG_WT_PRIORITY2_mvd_mask                                                (0x000000FF)
+#define RIF_REG_WT_PRIORITY2_mvd(data)                                               (0x000000FF&((data)<<0))
+#define RIF_REG_WT_PRIORITY2_mvd_src(data)                                           ((0x000000FF&(data))>>0)
+#define RIF_REG_WT_PRIORITY2_get_mvd(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define RIF_REG_WT_PRIORITY3                                                         0x1800E4BC
+#define RIF_REG_WT_PRIORITY3_reg_addr                                                "0xB800E4BC"
+#define RIF_REG_WT_PRIORITY3_reg                                                     0xB800E4BC
+#define set_RIF_REG_WT_PRIORITY3_reg(data)   (*((volatile unsigned int*) RIF_REG_WT_PRIORITY3_reg)=data)
+#define get_RIF_REG_WT_PRIORITY3_reg   (*((volatile unsigned int*) RIF_REG_WT_PRIORITY3_reg))
+#define RIF_REG_WT_PRIORITY3_inst_adr                                                "0x002F"
+#define RIF_REG_WT_PRIORITY3_inst                                                    0x002F
+#define RIF_REG_WT_PRIORITY3_bs_shift                                                (0)
+#define RIF_REG_WT_PRIORITY3_bs_mask                                                 (0x000000FF)
+#define RIF_REG_WT_PRIORITY3_bs(data)                                                (0x000000FF&((data)<<0))
+#define RIF_REG_WT_PRIORITY3_bs_src(data)                                            ((0x000000FF&(data))>>0)
+#define RIF_REG_WT_PRIORITY3_get_bs(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define RIF_REG_WT_PRIORITY4                                                         0x1800E4C0
+#define RIF_REG_WT_PRIORITY4_reg_addr                                                "0xB800E4C0"
+#define RIF_REG_WT_PRIORITY4_reg                                                     0xB800E4C0
+#define set_RIF_REG_WT_PRIORITY4_reg(data)   (*((volatile unsigned int*) RIF_REG_WT_PRIORITY4_reg)=data)
+#define get_RIF_REG_WT_PRIORITY4_reg   (*((volatile unsigned int*) RIF_REG_WT_PRIORITY4_reg))
+#define RIF_REG_WT_PRIORITY4_inst_adr                                                "0x0030"
+#define RIF_REG_WT_PRIORITY4_inst                                                    0x0030
+#define RIF_REG_WT_PRIORITY4_it_shift                                                (0)
+#define RIF_REG_WT_PRIORITY4_it_mask                                                 (0x000000FF)
+#define RIF_REG_WT_PRIORITY4_it(data)                                                (0x000000FF&((data)<<0))
+#define RIF_REG_WT_PRIORITY4_it_src(data)                                            ((0x000000FF&(data))>>0)
+#define RIF_REG_WT_PRIORITY4_get_it(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define RIF_REG_CLKGATED                                                             0x1800E4D8
+#define RIF_REG_CLKGATED_reg_addr                                                    "0xB800E4D8"
+#define RIF_REG_CLKGATED_reg                                                         0xB800E4D8
+#define set_RIF_REG_CLKGATED_reg(data)   (*((volatile unsigned int*) RIF_REG_CLKGATED_reg)=data)
+#define get_RIF_REG_CLKGATED_reg   (*((volatile unsigned int*) RIF_REG_CLKGATED_reg))
+#define RIF_REG_CLKGATED_inst_adr                                                    "0x0036"
+#define RIF_REG_CLKGATED_inst                                                        0x0036
+#define RIF_REG_CLKGATED_cache_gated_en_shift                                        (18)
+#define RIF_REG_CLKGATED_cache_gated_en_mask                                         (0x00040000)
+#define RIF_REG_CLKGATED_cache_gated_en(data)                                        (0x00040000&((data)<<18))
+#define RIF_REG_CLKGATED_cache_gated_en_src(data)                                    ((0x00040000&(data))>>18)
+#define RIF_REG_CLKGATED_get_cache_gated_en(data)                                    ((0x00040000&(data))>>18)
+#define RIF_REG_CLKGATED_rl_gated_en_shift                                           (17)
+#define RIF_REG_CLKGATED_rl_gated_en_mask                                            (0x00020000)
+#define RIF_REG_CLKGATED_rl_gated_en(data)                                           (0x00020000&((data)<<17))
+#define RIF_REG_CLKGATED_rl_gated_en_src(data)                                       ((0x00020000&(data))>>17)
+#define RIF_REG_CLKGATED_get_rl_gated_en(data)                                       ((0x00020000&(data))>>17)
+#define RIF_REG_CLKGATED_mvd_gated_en_shift                                          (16)
+#define RIF_REG_CLKGATED_mvd_gated_en_mask                                           (0x00010000)
+#define RIF_REG_CLKGATED_mvd_gated_en(data)                                          (0x00010000&((data)<<16))
+#define RIF_REG_CLKGATED_mvd_gated_en_src(data)                                      ((0x00010000&(data))>>16)
+#define RIF_REG_CLKGATED_get_mvd_gated_en(data)                                      ((0x00010000&(data))>>16)
+#define RIF_REG_CLKGATED_ndbp2_gated_en_shift                                        (15)
+#define RIF_REG_CLKGATED_ndbp2_gated_en_mask                                         (0x00008000)
+#define RIF_REG_CLKGATED_ndbp2_gated_en(data)                                        (0x00008000&((data)<<15))
+#define RIF_REG_CLKGATED_ndbp2_gated_en_src(data)                                    ((0x00008000&(data))>>15)
+#define RIF_REG_CLKGATED_get_ndbp2_gated_en(data)                                    ((0x00008000&(data))>>15)
+#define RIF_REG_CLKGATED_ndb_gated_en_shift                                          (14)
+#define RIF_REG_CLKGATED_ndb_gated_en_mask                                           (0x00004000)
+#define RIF_REG_CLKGATED_ndb_gated_en(data)                                          (0x00004000&((data)<<14))
+#define RIF_REG_CLKGATED_ndb_gated_en_src(data)                                      ((0x00004000&(data))>>14)
+#define RIF_REG_CLKGATED_get_ndb_gated_en(data)                                      ((0x00004000&(data))>>14)
+#define RIF_REG_CLKGATED_brg_gated_en_shift                                          (13)
+#define RIF_REG_CLKGATED_brg_gated_en_mask                                           (0x00002000)
+#define RIF_REG_CLKGATED_brg_gated_en(data)                                          (0x00002000&((data)<<13))
+#define RIF_REG_CLKGATED_brg_gated_en_src(data)                                      ((0x00002000&(data))>>13)
+#define RIF_REG_CLKGATED_get_brg_gated_en(data)                                      ((0x00002000&(data))>>13)
+#define RIF_REG_CLKGATED_cm_gated_en_shift                                           (12)
+#define RIF_REG_CLKGATED_cm_gated_en_mask                                            (0x00001000)
+#define RIF_REG_CLKGATED_cm_gated_en(data)                                           (0x00001000&((data)<<12))
+#define RIF_REG_CLKGATED_cm_gated_en_src(data)                                       ((0x00001000&(data))>>12)
+#define RIF_REG_CLKGATED_get_cm_gated_en(data)                                       ((0x00001000&(data))>>12)
+#define RIF_REG_CLKGATED_arb_gated_en_shift                                          (11)
+#define RIF_REG_CLKGATED_arb_gated_en_mask                                           (0x00000800)
+#define RIF_REG_CLKGATED_arb_gated_en(data)                                          (0x00000800&((data)<<11))
+#define RIF_REG_CLKGATED_arb_gated_en_src(data)                                      ((0x00000800&(data))>>11)
+#define RIF_REG_CLKGATED_get_arb_gated_en(data)                                      ((0x00000800&(data))>>11)
+#define RIF_REG_CLKGATED_bsfifop2_gated_en_shift                                     (10)
+#define RIF_REG_CLKGATED_bsfifop2_gated_en_mask                                      (0x00000400)
+#define RIF_REG_CLKGATED_bsfifop2_gated_en(data)                                     (0x00000400&((data)<<10))
+#define RIF_REG_CLKGATED_bsfifop2_gated_en_src(data)                                 ((0x00000400&(data))>>10)
+#define RIF_REG_CLKGATED_get_bsfifop2_gated_en(data)                                 ((0x00000400&(data))>>10)
+#define RIF_REG_CLKGATED_bsfifo_gated_en_shift                                       (9)
+#define RIF_REG_CLKGATED_bsfifo_gated_en_mask                                        (0x00000200)
+#define RIF_REG_CLKGATED_bsfifo_gated_en(data)                                       (0x00000200&((data)<<9))
+#define RIF_REG_CLKGATED_bsfifo_gated_en_src(data)                                   ((0x00000200&(data))>>9)
+#define RIF_REG_CLKGATED_get_bsfifo_gated_en(data)                                   ((0x00000200&(data))>>9)
+#define RIF_REG_CLKGATED_deblk_gated_en_shift                                        (8)
+#define RIF_REG_CLKGATED_deblk_gated_en_mask                                         (0x00000100)
+#define RIF_REG_CLKGATED_deblk_gated_en(data)                                        (0x00000100&((data)<<8))
+#define RIF_REG_CLKGATED_deblk_gated_en_src(data)                                    ((0x00000100&(data))>>8)
+#define RIF_REG_CLKGATED_get_deblk_gated_en(data)                                    ((0x00000100&(data))>>8)
+#define RIF_REG_CLKGATED_pred_gated_en_shift                                         (7)
+#define RIF_REG_CLKGATED_pred_gated_en_mask                                          (0x00000080)
+#define RIF_REG_CLKGATED_pred_gated_en(data)                                         (0x00000080&((data)<<7))
+#define RIF_REG_CLKGATED_pred_gated_en_src(data)                                     ((0x00000080&(data))>>7)
+#define RIF_REG_CLKGATED_get_pred_gated_en(data)                                     ((0x00000080&(data))>>7)
+#define RIF_REG_CLKGATED_vm1_gated_en_shift                                          (6)
+#define RIF_REG_CLKGATED_vm1_gated_en_mask                                           (0x00000040)
+#define RIF_REG_CLKGATED_vm1_gated_en(data)                                          (0x00000040&((data)<<6))
+#define RIF_REG_CLKGATED_vm1_gated_en_src(data)                                      ((0x00000040&(data))>>6)
+#define RIF_REG_CLKGATED_get_vm1_gated_en(data)                                      ((0x00000040&(data))>>6)
+#define RIF_REG_CLKGATED_it_gated_en_shift                                           (5)
+#define RIF_REG_CLKGATED_it_gated_en_mask                                            (0x00000020)
+#define RIF_REG_CLKGATED_it_gated_en(data)                                           (0x00000020&((data)<<5))
+#define RIF_REG_CLKGATED_it_gated_en_src(data)                                       ((0x00000020&(data))>>5)
+#define RIF_REG_CLKGATED_get_it_gated_en(data)                                       ((0x00000020&(data))>>5)
+#define RIF_REG_CLKGATED_cabac_gated_en_shift                                        (4)
+#define RIF_REG_CLKGATED_cabac_gated_en_mask                                         (0x00000010)
+#define RIF_REG_CLKGATED_cabac_gated_en(data)                                        (0x00000010&((data)<<4))
+#define RIF_REG_CLKGATED_cabac_gated_en_src(data)                                    ((0x00000010&(data))>>4)
+#define RIF_REG_CLKGATED_get_cabac_gated_en(data)                                    ((0x00000010&(data))>>4)
+#define RIF_REG_CLKGATED_vp8p2_gated_en_shift                                        (3)
+#define RIF_REG_CLKGATED_vp8p2_gated_en_mask                                         (0x00000008)
+#define RIF_REG_CLKGATED_vp8p2_gated_en(data)                                        (0x00000008&((data)<<3))
+#define RIF_REG_CLKGATED_vp8p2_gated_en_src(data)                                    ((0x00000008&(data))>>3)
+#define RIF_REG_CLKGATED_get_vp8p2_gated_en(data)                                    ((0x00000008&(data))>>3)
+#define RIF_REG_CLKGATED_cabacp2_gated_en_shift                                      (2)
+#define RIF_REG_CLKGATED_cabacp2_gated_en_mask                                       (0x00000004)
+#define RIF_REG_CLKGATED_cabacp2_gated_en(data)                                      (0x00000004&((data)<<2))
+#define RIF_REG_CLKGATED_cabacp2_gated_en_src(data)                                  ((0x00000004&(data))>>2)
+#define RIF_REG_CLKGATED_get_cabacp2_gated_en(data)                                  ((0x00000004&(data))>>2)
+#define RIF_REG_CLKGATED_vld_gated_en_shift                                          (1)
+#define RIF_REG_CLKGATED_vld_gated_en_mask                                           (0x00000002)
+#define RIF_REG_CLKGATED_vld_gated_en(data)                                          (0x00000002&((data)<<1))
+#define RIF_REG_CLKGATED_vld_gated_en_src(data)                                      ((0x00000002&(data))>>1)
+#define RIF_REG_CLKGATED_get_vld_gated_en(data)                                      ((0x00000002&(data))>>1)
+#define RIF_REG_CLKGATED_acdc_gated_en_shift                                         (0)
+#define RIF_REG_CLKGATED_acdc_gated_en_mask                                          (0x00000001)
+#define RIF_REG_CLKGATED_acdc_gated_en(data)                                         (0x00000001&((data)<<0))
+#define RIF_REG_CLKGATED_acdc_gated_en_src(data)                                     ((0x00000001&(data))>>0)
+#define RIF_REG_CLKGATED_get_acdc_gated_en(data)                                     ((0x00000001&(data))>>0)
+
+
+#define RIF_REG_DBG_OUT                                                              0x1800E4E0
+#define RIF_REG_DBG_OUT_reg_addr                                                     "0xB800E4E0"
+#define RIF_REG_DBG_OUT_reg                                                          0xB800E4E0
+#define set_RIF_REG_DBG_OUT_reg(data)   (*((volatile unsigned int*) RIF_REG_DBG_OUT_reg)=data)
+#define get_RIF_REG_DBG_OUT_reg   (*((volatile unsigned int*) RIF_REG_DBG_OUT_reg))
+#define RIF_REG_DBG_OUT_inst_adr                                                     "0x0038"
+#define RIF_REG_DBG_OUT_inst                                                         0x0038
+#define RIF_REG_DBG_OUT_ve_dbg_out1_shift                                            (16)
+#define RIF_REG_DBG_OUT_ve_dbg_out1_mask                                             (0xFFFF0000)
+#define RIF_REG_DBG_OUT_ve_dbg_out1(data)                                            (0xFFFF0000&((data)<<16))
+#define RIF_REG_DBG_OUT_ve_dbg_out1_src(data)                                        ((0xFFFF0000&(data))>>16)
+#define RIF_REG_DBG_OUT_get_ve_dbg_out1(data)                                        ((0xFFFF0000&(data))>>16)
+#define RIF_REG_DBG_OUT_ve_dbg_out0_shift                                            (0)
+#define RIF_REG_DBG_OUT_ve_dbg_out0_mask                                             (0x0000FFFF)
+#define RIF_REG_DBG_OUT_ve_dbg_out0(data)                                            (0x0000FFFF&((data)<<0))
+#define RIF_REG_DBG_OUT_ve_dbg_out0_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define RIF_REG_DBG_OUT_get_ve_dbg_out0(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define RIF_REG_DBG_CTRL1                                                            0x1800E4E4
+#define RIF_REG_DBG_CTRL1_reg_addr                                                   "0xB800E4E4"
+#define RIF_REG_DBG_CTRL1_reg                                                        0xB800E4E4
+#define set_RIF_REG_DBG_CTRL1_reg(data)   (*((volatile unsigned int*) RIF_REG_DBG_CTRL1_reg)=data)
+#define get_RIF_REG_DBG_CTRL1_reg   (*((volatile unsigned int*) RIF_REG_DBG_CTRL1_reg))
+#define RIF_REG_DBG_CTRL1_inst_adr                                                   "0x0039"
+#define RIF_REG_DBG_CTRL1_inst                                                       0x0039
+#define RIF_REG_DBG_CTRL1_cache_dbg_sel1_shift                                       (28)
+#define RIF_REG_DBG_CTRL1_cache_dbg_sel1_mask                                        (0xF0000000)
+#define RIF_REG_DBG_CTRL1_cache_dbg_sel1(data)                                       (0xF0000000&((data)<<28))
+#define RIF_REG_DBG_CTRL1_cache_dbg_sel1_src(data)                                   ((0xF0000000&(data))>>28)
+#define RIF_REG_DBG_CTRL1_get_cache_dbg_sel1(data)                                   ((0xF0000000&(data))>>28)
+#define RIF_REG_DBG_CTRL1_cache_dbg_sel0_shift                                       (24)
+#define RIF_REG_DBG_CTRL1_cache_dbg_sel0_mask                                        (0x0F000000)
+#define RIF_REG_DBG_CTRL1_cache_dbg_sel0(data)                                       (0x0F000000&((data)<<24))
+#define RIF_REG_DBG_CTRL1_cache_dbg_sel0_src(data)                                   ((0x0F000000&(data))>>24)
+#define RIF_REG_DBG_CTRL1_get_cache_dbg_sel0(data)                                   ((0x0F000000&(data))>>24)
+#define RIF_REG_DBG_CTRL1_bs_dbg_sel1_shift                                          (20)
+#define RIF_REG_DBG_CTRL1_bs_dbg_sel1_mask                                           (0x00F00000)
+#define RIF_REG_DBG_CTRL1_bs_dbg_sel1(data)                                          (0x00F00000&((data)<<20))
+#define RIF_REG_DBG_CTRL1_bs_dbg_sel1_src(data)                                      ((0x00F00000&(data))>>20)
+#define RIF_REG_DBG_CTRL1_get_bs_dbg_sel1(data)                                      ((0x00F00000&(data))>>20)
+#define RIF_REG_DBG_CTRL1_bs_dbg_sel0_shift                                          (16)
+#define RIF_REG_DBG_CTRL1_bs_dbg_sel0_mask                                           (0x000F0000)
+#define RIF_REG_DBG_CTRL1_bs_dbg_sel0(data)                                          (0x000F0000&((data)<<16))
+#define RIF_REG_DBG_CTRL1_bs_dbg_sel0_src(data)                                      ((0x000F0000&(data))>>16)
+#define RIF_REG_DBG_CTRL1_get_bs_dbg_sel0(data)                                      ((0x000F0000&(data))>>16)
+#define RIF_REG_DBG_CTRL1_brg_dbg_sel1_shift                                         (12)
+#define RIF_REG_DBG_CTRL1_brg_dbg_sel1_mask                                          (0x0000F000)
+#define RIF_REG_DBG_CTRL1_brg_dbg_sel1(data)                                         (0x0000F000&((data)<<12))
+#define RIF_REG_DBG_CTRL1_brg_dbg_sel1_src(data)                                     ((0x0000F000&(data))>>12)
+#define RIF_REG_DBG_CTRL1_get_brg_dbg_sel1(data)                                     ((0x0000F000&(data))>>12)
+#define RIF_REG_DBG_CTRL1_brg_dbg_sel0_shift                                         (8)
+#define RIF_REG_DBG_CTRL1_brg_dbg_sel0_mask                                          (0x00000F00)
+#define RIF_REG_DBG_CTRL1_brg_dbg_sel0(data)                                         (0x00000F00&((data)<<8))
+#define RIF_REG_DBG_CTRL1_brg_dbg_sel0_src(data)                                     ((0x00000F00&(data))>>8)
+#define RIF_REG_DBG_CTRL1_get_brg_dbg_sel0(data)                                     ((0x00000F00&(data))>>8)
+#define RIF_REG_DBG_CTRL1_acdc_dbg_sel1_shift                                        (4)
+#define RIF_REG_DBG_CTRL1_acdc_dbg_sel1_mask                                         (0x000000F0)
+#define RIF_REG_DBG_CTRL1_acdc_dbg_sel1(data)                                        (0x000000F0&((data)<<4))
+#define RIF_REG_DBG_CTRL1_acdc_dbg_sel1_src(data)                                    ((0x000000F0&(data))>>4)
+#define RIF_REG_DBG_CTRL1_get_acdc_dbg_sel1(data)                                    ((0x000000F0&(data))>>4)
+#define RIF_REG_DBG_CTRL1_acdc_dbg_sel0_shift                                        (0)
+#define RIF_REG_DBG_CTRL1_acdc_dbg_sel0_mask                                         (0x0000000F)
+#define RIF_REG_DBG_CTRL1_acdc_dbg_sel0(data)                                        (0x0000000F&((data)<<0))
+#define RIF_REG_DBG_CTRL1_acdc_dbg_sel0_src(data)                                    ((0x0000000F&(data))>>0)
+#define RIF_REG_DBG_CTRL1_get_acdc_dbg_sel0(data)                                    ((0x0000000F&(data))>>0)
+
+
+#define RIF_REG_DBG_CTRL2                                                            0x1800E4E8
+#define RIF_REG_DBG_CTRL2_reg_addr                                                   "0xB800E4E8"
+#define RIF_REG_DBG_CTRL2_reg                                                        0xB800E4E8
+#define set_RIF_REG_DBG_CTRL2_reg(data)   (*((volatile unsigned int*) RIF_REG_DBG_CTRL2_reg)=data)
+#define get_RIF_REG_DBG_CTRL2_reg   (*((volatile unsigned int*) RIF_REG_DBG_CTRL2_reg))
+#define RIF_REG_DBG_CTRL2_inst_adr                                                   "0x003A"
+#define RIF_REG_DBG_CTRL2_inst                                                       0x003A
+#define RIF_REG_DBG_CTRL2_cm_dbg_sel1_shift                                          (20)
+#define RIF_REG_DBG_CTRL2_cm_dbg_sel1_mask                                           (0x00F00000)
+#define RIF_REG_DBG_CTRL2_cm_dbg_sel1(data)                                          (0x00F00000&((data)<<20))
+#define RIF_REG_DBG_CTRL2_cm_dbg_sel1_src(data)                                      ((0x00F00000&(data))>>20)
+#define RIF_REG_DBG_CTRL2_get_cm_dbg_sel1(data)                                      ((0x00F00000&(data))>>20)
+#define RIF_REG_DBG_CTRL2_cm_dbg_sel0_shift                                          (16)
+#define RIF_REG_DBG_CTRL2_cm_dbg_sel0_mask                                           (0x000F0000)
+#define RIF_REG_DBG_CTRL2_cm_dbg_sel0(data)                                          (0x000F0000&((data)<<16))
+#define RIF_REG_DBG_CTRL2_cm_dbg_sel0_src(data)                                      ((0x000F0000&(data))>>16)
+#define RIF_REG_DBG_CTRL2_get_cm_dbg_sel0(data)                                      ((0x000F0000&(data))>>16)
+#define RIF_REG_DBG_CTRL2_cabacp3_dbg_sel1_shift                                     (12)
+#define RIF_REG_DBG_CTRL2_cabacp3_dbg_sel1_mask                                      (0x0000F000)
+#define RIF_REG_DBG_CTRL2_cabacp3_dbg_sel1(data)                                     (0x0000F000&((data)<<12))
+#define RIF_REG_DBG_CTRL2_cabacp3_dbg_sel1_src(data)                                 ((0x0000F000&(data))>>12)
+#define RIF_REG_DBG_CTRL2_get_cabacp3_dbg_sel1(data)                                 ((0x0000F000&(data))>>12)
+#define RIF_REG_DBG_CTRL2_cabacp3_dbg_sel0_shift                                     (8)
+#define RIF_REG_DBG_CTRL2_cabacp3_dbg_sel0_mask                                      (0x00000F00)
+#define RIF_REG_DBG_CTRL2_cabacp3_dbg_sel0(data)                                     (0x00000F00&((data)<<8))
+#define RIF_REG_DBG_CTRL2_cabacp3_dbg_sel0_src(data)                                 ((0x00000F00&(data))>>8)
+#define RIF_REG_DBG_CTRL2_get_cabacp3_dbg_sel0(data)                                 ((0x00000F00&(data))>>8)
+#define RIF_REG_DBG_CTRL2_cabacp2_dbg_sel1_shift                                     (4)
+#define RIF_REG_DBG_CTRL2_cabacp2_dbg_sel1_mask                                      (0x000000F0)
+#define RIF_REG_DBG_CTRL2_cabacp2_dbg_sel1(data)                                     (0x000000F0&((data)<<4))
+#define RIF_REG_DBG_CTRL2_cabacp2_dbg_sel1_src(data)                                 ((0x000000F0&(data))>>4)
+#define RIF_REG_DBG_CTRL2_get_cabacp2_dbg_sel1(data)                                 ((0x000000F0&(data))>>4)
+#define RIF_REG_DBG_CTRL2_cabacp2_dbg_sel0_shift                                     (0)
+#define RIF_REG_DBG_CTRL2_cabacp2_dbg_sel0_mask                                      (0x0000000F)
+#define RIF_REG_DBG_CTRL2_cabacp2_dbg_sel0(data)                                     (0x0000000F&((data)<<0))
+#define RIF_REG_DBG_CTRL2_cabacp2_dbg_sel0_src(data)                                 ((0x0000000F&(data))>>0)
+#define RIF_REG_DBG_CTRL2_get_cabacp2_dbg_sel0(data)                                 ((0x0000000F&(data))>>0)
+
+
+#define RIF_REG_DBG_CTRL3                                                            0x1800E4EC
+#define RIF_REG_DBG_CTRL3_reg_addr                                                   "0xB800E4EC"
+#define RIF_REG_DBG_CTRL3_reg                                                        0xB800E4EC
+#define set_RIF_REG_DBG_CTRL3_reg(data)   (*((volatile unsigned int*) RIF_REG_DBG_CTRL3_reg)=data)
+#define get_RIF_REG_DBG_CTRL3_reg   (*((volatile unsigned int*) RIF_REG_DBG_CTRL3_reg))
+#define RIF_REG_DBG_CTRL3_inst_adr                                                   "0x003B"
+#define RIF_REG_DBG_CTRL3_inst                                                       0x003B
+#define RIF_REG_DBG_CTRL3_ndb_dbg_sel1_shift                                         (28)
+#define RIF_REG_DBG_CTRL3_ndb_dbg_sel1_mask                                          (0xF0000000)
+#define RIF_REG_DBG_CTRL3_ndb_dbg_sel1(data)                                         (0xF0000000&((data)<<28))
+#define RIF_REG_DBG_CTRL3_ndb_dbg_sel1_src(data)                                     ((0xF0000000&(data))>>28)
+#define RIF_REG_DBG_CTRL3_get_ndb_dbg_sel1(data)                                     ((0xF0000000&(data))>>28)
+#define RIF_REG_DBG_CTRL3_ndb_dbg_sel0_shift                                         (24)
+#define RIF_REG_DBG_CTRL3_ndb_dbg_sel0_mask                                          (0x0F000000)
+#define RIF_REG_DBG_CTRL3_ndb_dbg_sel0(data)                                         (0x0F000000&((data)<<24))
+#define RIF_REG_DBG_CTRL3_ndb_dbg_sel0_src(data)                                     ((0x0F000000&(data))>>24)
+#define RIF_REG_DBG_CTRL3_get_ndb_dbg_sel0(data)                                     ((0x0F000000&(data))>>24)
+#define RIF_REG_DBG_CTRL3_rif_dbg_sel1_shift                                         (20)
+#define RIF_REG_DBG_CTRL3_rif_dbg_sel1_mask                                          (0x00F00000)
+#define RIF_REG_DBG_CTRL3_rif_dbg_sel1(data)                                         (0x00F00000&((data)<<20))
+#define RIF_REG_DBG_CTRL3_rif_dbg_sel1_src(data)                                     ((0x00F00000&(data))>>20)
+#define RIF_REG_DBG_CTRL3_get_rif_dbg_sel1(data)                                     ((0x00F00000&(data))>>20)
+#define RIF_REG_DBG_CTRL3_rif_dbg_sel0_shift                                         (16)
+#define RIF_REG_DBG_CTRL3_rif_dbg_sel0_mask                                          (0x000F0000)
+#define RIF_REG_DBG_CTRL3_rif_dbg_sel0(data)                                         (0x000F0000&((data)<<16))
+#define RIF_REG_DBG_CTRL3_rif_dbg_sel0_src(data)                                     ((0x000F0000&(data))>>16)
+#define RIF_REG_DBG_CTRL3_get_rif_dbg_sel0(data)                                     ((0x000F0000&(data))>>16)
+#define RIF_REG_DBG_CTRL3_itblk_dbg_sel1_shift                                       (12)
+#define RIF_REG_DBG_CTRL3_itblk_dbg_sel1_mask                                        (0x0000F000)
+#define RIF_REG_DBG_CTRL3_itblk_dbg_sel1(data)                                       (0x0000F000&((data)<<12))
+#define RIF_REG_DBG_CTRL3_itblk_dbg_sel1_src(data)                                   ((0x0000F000&(data))>>12)
+#define RIF_REG_DBG_CTRL3_get_itblk_dbg_sel1(data)                                   ((0x0000F000&(data))>>12)
+#define RIF_REG_DBG_CTRL3_itblk_dbg_sel0_shift                                       (8)
+#define RIF_REG_DBG_CTRL3_itblk_dbg_sel0_mask                                        (0x00000F00)
+#define RIF_REG_DBG_CTRL3_itblk_dbg_sel0(data)                                       (0x00000F00&((data)<<8))
+#define RIF_REG_DBG_CTRL3_itblk_dbg_sel0_src(data)                                   ((0x00000F00&(data))>>8)
+#define RIF_REG_DBG_CTRL3_get_itblk_dbg_sel0(data)                                   ((0x00000F00&(data))>>8)
+#define RIF_REG_DBG_CTRL3_img_dbg_sel1_shift                                         (4)
+#define RIF_REG_DBG_CTRL3_img_dbg_sel1_mask                                          (0x000000F0)
+#define RIF_REG_DBG_CTRL3_img_dbg_sel1(data)                                         (0x000000F0&((data)<<4))
+#define RIF_REG_DBG_CTRL3_img_dbg_sel1_src(data)                                     ((0x000000F0&(data))>>4)
+#define RIF_REG_DBG_CTRL3_get_img_dbg_sel1(data)                                     ((0x000000F0&(data))>>4)
+#define RIF_REG_DBG_CTRL3_img_dbg_sel0_shift                                         (0)
+#define RIF_REG_DBG_CTRL3_img_dbg_sel0_mask                                          (0x0000000F)
+#define RIF_REG_DBG_CTRL3_img_dbg_sel0(data)                                         (0x0000000F&((data)<<0))
+#define RIF_REG_DBG_CTRL3_img_dbg_sel0_src(data)                                     ((0x0000000F&(data))>>0)
+#define RIF_REG_DBG_CTRL3_get_img_dbg_sel0(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define RIF_REG_DBG_CTRL4                                                            0x1800E4F0
+#define RIF_REG_DBG_CTRL4_reg_addr                                                   "0xB800E4F0"
+#define RIF_REG_DBG_CTRL4_reg                                                        0xB800E4F0
+#define set_RIF_REG_DBG_CTRL4_reg(data)   (*((volatile unsigned int*) RIF_REG_DBG_CTRL4_reg)=data)
+#define get_RIF_REG_DBG_CTRL4_reg   (*((volatile unsigned int*) RIF_REG_DBG_CTRL4_reg))
+#define RIF_REG_DBG_CTRL4_inst_adr                                                   "0x003C"
+#define RIF_REG_DBG_CTRL4_inst                                                       0x003C
+#define RIF_REG_DBG_CTRL4_rl_dbg_sel1_shift                                          (28)
+#define RIF_REG_DBG_CTRL4_rl_dbg_sel1_mask                                           (0xF0000000)
+#define RIF_REG_DBG_CTRL4_rl_dbg_sel1(data)                                          (0xF0000000&((data)<<28))
+#define RIF_REG_DBG_CTRL4_rl_dbg_sel1_src(data)                                      ((0xF0000000&(data))>>28)
+#define RIF_REG_DBG_CTRL4_get_rl_dbg_sel1(data)                                      ((0xF0000000&(data))>>28)
+#define RIF_REG_DBG_CTRL4_rl_dbg_sel0_shift                                          (24)
+#define RIF_REG_DBG_CTRL4_rl_dbg_sel0_mask                                           (0x0F000000)
+#define RIF_REG_DBG_CTRL4_rl_dbg_sel0(data)                                          (0x0F000000&((data)<<24))
+#define RIF_REG_DBG_CTRL4_rl_dbg_sel0_src(data)                                      ((0x0F000000&(data))>>24)
+#define RIF_REG_DBG_CTRL4_get_rl_dbg_sel0(data)                                      ((0x0F000000&(data))>>24)
+#define RIF_REG_DBG_CTRL4_vld_dbg_sel1_shift                                         (20)
+#define RIF_REG_DBG_CTRL4_vld_dbg_sel1_mask                                          (0x00F00000)
+#define RIF_REG_DBG_CTRL4_vld_dbg_sel1(data)                                         (0x00F00000&((data)<<20))
+#define RIF_REG_DBG_CTRL4_vld_dbg_sel1_src(data)                                     ((0x00F00000&(data))>>20)
+#define RIF_REG_DBG_CTRL4_get_vld_dbg_sel1(data)                                     ((0x00F00000&(data))>>20)
+#define RIF_REG_DBG_CTRL4_vld_dbg_sel0_shift                                         (16)
+#define RIF_REG_DBG_CTRL4_vld_dbg_sel0_mask                                          (0x000F0000)
+#define RIF_REG_DBG_CTRL4_vld_dbg_sel0(data)                                         (0x000F0000&((data)<<16))
+#define RIF_REG_DBG_CTRL4_vld_dbg_sel0_src(data)                                     ((0x000F0000&(data))>>16)
+#define RIF_REG_DBG_CTRL4_get_vld_dbg_sel0(data)                                     ((0x000F0000&(data))>>16)
+#define RIF_REG_DBG_CTRL4_arb_dbg_sel1_shift                                         (12)
+#define RIF_REG_DBG_CTRL4_arb_dbg_sel1_mask                                          (0x0000F000)
+#define RIF_REG_DBG_CTRL4_arb_dbg_sel1(data)                                         (0x0000F000&((data)<<12))
+#define RIF_REG_DBG_CTRL4_arb_dbg_sel1_src(data)                                     ((0x0000F000&(data))>>12)
+#define RIF_REG_DBG_CTRL4_get_arb_dbg_sel1(data)                                     ((0x0000F000&(data))>>12)
+#define RIF_REG_DBG_CTRL4_arb_dbg_sel0_shift                                         (8)
+#define RIF_REG_DBG_CTRL4_arb_dbg_sel0_mask                                          (0x00000F00)
+#define RIF_REG_DBG_CTRL4_arb_dbg_sel0(data)                                         (0x00000F00&((data)<<8))
+#define RIF_REG_DBG_CTRL4_arb_dbg_sel0_src(data)                                     ((0x00000F00&(data))>>8)
+#define RIF_REG_DBG_CTRL4_get_arb_dbg_sel0(data)                                     ((0x00000F00&(data))>>8)
+#define RIF_REG_DBG_CTRL4_vm1_dbg_sel1_shift                                         (4)
+#define RIF_REG_DBG_CTRL4_vm1_dbg_sel1_mask                                          (0x000000F0)
+#define RIF_REG_DBG_CTRL4_vm1_dbg_sel1(data)                                         (0x000000F0&((data)<<4))
+#define RIF_REG_DBG_CTRL4_vm1_dbg_sel1_src(data)                                     ((0x000000F0&(data))>>4)
+#define RIF_REG_DBG_CTRL4_get_vm1_dbg_sel1(data)                                     ((0x000000F0&(data))>>4)
+#define RIF_REG_DBG_CTRL4_vm1_dbg_sel0_shift                                         (0)
+#define RIF_REG_DBG_CTRL4_vm1_dbg_sel0_mask                                          (0x0000000F)
+#define RIF_REG_DBG_CTRL4_vm1_dbg_sel0(data)                                         (0x0000000F&((data)<<0))
+#define RIF_REG_DBG_CTRL4_vm1_dbg_sel0_src(data)                                     ((0x0000000F&(data))>>0)
+#define RIF_REG_DBG_CTRL4_get_vm1_dbg_sel0(data)                                     ((0x0000000F&(data))>>0)
+
+
+#define RIF_REG_DBG_CTRL5                                                            0x1800E4F4
+#define RIF_REG_DBG_CTRL5_reg_addr                                                   "0xB800E4F4"
+#define RIF_REG_DBG_CTRL5_reg                                                        0xB800E4F4
+#define set_RIF_REG_DBG_CTRL5_reg(data)   (*((volatile unsigned int*) RIF_REG_DBG_CTRL5_reg)=data)
+#define get_RIF_REG_DBG_CTRL5_reg   (*((volatile unsigned int*) RIF_REG_DBG_CTRL5_reg))
+#define RIF_REG_DBG_CTRL5_inst_adr                                                   "0x003D"
+#define RIF_REG_DBG_CTRL5_inst                                                       0x003D
+#define RIF_REG_DBG_CTRL5_deblk_dbg_sel1_shift                                       (26)
+#define RIF_REG_DBG_CTRL5_deblk_dbg_sel1_mask                                        (0xFC000000)
+#define RIF_REG_DBG_CTRL5_deblk_dbg_sel1(data)                                       (0xFC000000&((data)<<26))
+#define RIF_REG_DBG_CTRL5_deblk_dbg_sel1_src(data)                                   ((0xFC000000&(data))>>26)
+#define RIF_REG_DBG_CTRL5_get_deblk_dbg_sel1(data)                                   ((0xFC000000&(data))>>26)
+#define RIF_REG_DBG_CTRL5_deblk_dbg_sel0_shift                                       (20)
+#define RIF_REG_DBG_CTRL5_deblk_dbg_sel0_mask                                        (0x03F00000)
+#define RIF_REG_DBG_CTRL5_deblk_dbg_sel0(data)                                       (0x03F00000&((data)<<20))
+#define RIF_REG_DBG_CTRL5_deblk_dbg_sel0_src(data)                                   ((0x03F00000&(data))>>20)
+#define RIF_REG_DBG_CTRL5_get_deblk_dbg_sel0(data)                                   ((0x03F00000&(data))>>20)
+#define RIF_REG_DBG_CTRL5_mvd_dbg_sel1_shift                                         (16)
+#define RIF_REG_DBG_CTRL5_mvd_dbg_sel1_mask                                          (0x000F0000)
+#define RIF_REG_DBG_CTRL5_mvd_dbg_sel1(data)                                         (0x000F0000&((data)<<16))
+#define RIF_REG_DBG_CTRL5_mvd_dbg_sel1_src(data)                                     ((0x000F0000&(data))>>16)
+#define RIF_REG_DBG_CTRL5_get_mvd_dbg_sel1(data)                                     ((0x000F0000&(data))>>16)
+#define RIF_REG_DBG_CTRL5_mvd_dbg_sel0_shift                                         (12)
+#define RIF_REG_DBG_CTRL5_mvd_dbg_sel0_mask                                          (0x0000F000)
+#define RIF_REG_DBG_CTRL5_mvd_dbg_sel0(data)                                         (0x0000F000&((data)<<12))
+#define RIF_REG_DBG_CTRL5_mvd_dbg_sel0_src(data)                                     ((0x0000F000&(data))>>12)
+#define RIF_REG_DBG_CTRL5_get_mvd_dbg_sel0(data)                                     ((0x0000F000&(data))>>12)
+#define RIF_REG_DBG_CTRL5_prd_dbg_sel1_shift                                         (6)
+#define RIF_REG_DBG_CTRL5_prd_dbg_sel1_mask                                          (0x00000FC0)
+#define RIF_REG_DBG_CTRL5_prd_dbg_sel1(data)                                         (0x00000FC0&((data)<<6))
+#define RIF_REG_DBG_CTRL5_prd_dbg_sel1_src(data)                                     ((0x00000FC0&(data))>>6)
+#define RIF_REG_DBG_CTRL5_get_prd_dbg_sel1(data)                                     ((0x00000FC0&(data))>>6)
+#define RIF_REG_DBG_CTRL5_prd_dbg_sel0_shift                                         (0)
+#define RIF_REG_DBG_CTRL5_prd_dbg_sel0_mask                                          (0x0000003F)
+#define RIF_REG_DBG_CTRL5_prd_dbg_sel0(data)                                         (0x0000003F&((data)<<0))
+#define RIF_REG_DBG_CTRL5_prd_dbg_sel0_src(data)                                     ((0x0000003F&(data))>>0)
+#define RIF_REG_DBG_CTRL5_get_prd_dbg_sel0(data)                                     ((0x0000003F&(data))>>0)
+
+
+#define RIF_REG_FPGA_DBG1                                                            0x1800E4F8
+#define RIF_REG_FPGA_DBG1_reg_addr                                                   "0xB800E4F8"
+#define RIF_REG_FPGA_DBG1_reg                                                        0xB800E4F8
+#define set_RIF_REG_FPGA_DBG1_reg(data)   (*((volatile unsigned int*) RIF_REG_FPGA_DBG1_reg)=data)
+#define get_RIF_REG_FPGA_DBG1_reg   (*((volatile unsigned int*) RIF_REG_FPGA_DBG1_reg))
+#define RIF_REG_FPGA_DBG1_inst_adr                                                   "0x003E"
+#define RIF_REG_FPGA_DBG1_inst                                                       0x003E
+#define RIF_REG_FPGA_DBG1_cache_busy_shift                                           (14)
+#define RIF_REG_FPGA_DBG1_cache_busy_mask                                            (0x00004000)
+#define RIF_REG_FPGA_DBG1_cache_busy(data)                                           (0x00004000&((data)<<14))
+#define RIF_REG_FPGA_DBG1_cache_busy_src(data)                                       ((0x00004000&(data))>>14)
+#define RIF_REG_FPGA_DBG1_get_cache_busy(data)                                       ((0x00004000&(data))>>14)
+#define RIF_REG_FPGA_DBG1_brg_busy_shift                                             (13)
+#define RIF_REG_FPGA_DBG1_brg_busy_mask                                              (0x00002000)
+#define RIF_REG_FPGA_DBG1_brg_busy(data)                                             (0x00002000&((data)<<13))
+#define RIF_REG_FPGA_DBG1_brg_busy_src(data)                                         ((0x00002000&(data))>>13)
+#define RIF_REG_FPGA_DBG1_get_brg_busy(data)                                         ((0x00002000&(data))>>13)
+#define RIF_REG_FPGA_DBG1_ndb_busy_shift                                             (12)
+#define RIF_REG_FPGA_DBG1_ndb_busy_mask                                              (0x00001000)
+#define RIF_REG_FPGA_DBG1_ndb_busy(data)                                             (0x00001000&((data)<<12))
+#define RIF_REG_FPGA_DBG1_ndb_busy_src(data)                                         ((0x00001000&(data))>>12)
+#define RIF_REG_FPGA_DBG1_get_ndb_busy(data)                                         ((0x00001000&(data))>>12)
+#define RIF_REG_FPGA_DBG1_bsfifo_busy_shift                                          (11)
+#define RIF_REG_FPGA_DBG1_bsfifo_busy_mask                                           (0x00000800)
+#define RIF_REG_FPGA_DBG1_bsfifo_busy(data)                                          (0x00000800&((data)<<11))
+#define RIF_REG_FPGA_DBG1_bsfifo_busy_src(data)                                      ((0x00000800&(data))>>11)
+#define RIF_REG_FPGA_DBG1_get_bsfifo_busy(data)                                      ((0x00000800&(data))>>11)
+#define RIF_REG_FPGA_DBG1_img_busy_shift                                             (10)
+#define RIF_REG_FPGA_DBG1_img_busy_mask                                              (0x00000400)
+#define RIF_REG_FPGA_DBG1_img_busy(data)                                             (0x00000400&((data)<<10))
+#define RIF_REG_FPGA_DBG1_img_busy_src(data)                                         ((0x00000400&(data))>>10)
+#define RIF_REG_FPGA_DBG1_get_img_busy(data)                                         ((0x00000400&(data))>>10)
+#define RIF_REG_FPGA_DBG1_vm1_busy_shift                                             (9)
+#define RIF_REG_FPGA_DBG1_vm1_busy_mask                                              (0x00000200)
+#define RIF_REG_FPGA_DBG1_vm1_busy(data)                                             (0x00000200&((data)<<9))
+#define RIF_REG_FPGA_DBG1_vm1_busy_src(data)                                         ((0x00000200&(data))>>9)
+#define RIF_REG_FPGA_DBG1_get_vm1_busy(data)                                         ((0x00000200&(data))>>9)
+#define RIF_REG_FPGA_DBG1_deblk_busy_shift                                           (8)
+#define RIF_REG_FPGA_DBG1_deblk_busy_mask                                            (0x00000100)
+#define RIF_REG_FPGA_DBG1_deblk_busy(data)                                           (0x00000100&((data)<<8))
+#define RIF_REG_FPGA_DBG1_deblk_busy_src(data)                                       ((0x00000100&(data))>>8)
+#define RIF_REG_FPGA_DBG1_get_deblk_busy(data)                                       ((0x00000100&(data))>>8)
+#define RIF_REG_FPGA_DBG1_rl_busy_shift                                              (7)
+#define RIF_REG_FPGA_DBG1_rl_busy_mask                                               (0x00000080)
+#define RIF_REG_FPGA_DBG1_rl_busy(data)                                              (0x00000080&((data)<<7))
+#define RIF_REG_FPGA_DBG1_rl_busy_src(data)                                          ((0x00000080&(data))>>7)
+#define RIF_REG_FPGA_DBG1_get_rl_busy(data)                                          ((0x00000080&(data))>>7)
+#define RIF_REG_FPGA_DBG1_pred_busy_shift                                            (6)
+#define RIF_REG_FPGA_DBG1_pred_busy_mask                                             (0x00000040)
+#define RIF_REG_FPGA_DBG1_pred_busy(data)                                            (0x00000040&((data)<<6))
+#define RIF_REG_FPGA_DBG1_pred_busy_src(data)                                        ((0x00000040&(data))>>6)
+#define RIF_REG_FPGA_DBG1_get_pred_busy(data)                                        ((0x00000040&(data))>>6)
+#define RIF_REG_FPGA_DBG1_mvd_busy_shift                                             (5)
+#define RIF_REG_FPGA_DBG1_mvd_busy_mask                                              (0x00000020)
+#define RIF_REG_FPGA_DBG1_mvd_busy(data)                                             (0x00000020&((data)<<5))
+#define RIF_REG_FPGA_DBG1_mvd_busy_src(data)                                         ((0x00000020&(data))>>5)
+#define RIF_REG_FPGA_DBG1_get_mvd_busy(data)                                         ((0x00000020&(data))>>5)
+#define RIF_REG_FPGA_DBG1_itblk_busy_shift                                           (4)
+#define RIF_REG_FPGA_DBG1_itblk_busy_mask                                            (0x00000010)
+#define RIF_REG_FPGA_DBG1_itblk_busy(data)                                           (0x00000010&((data)<<4))
+#define RIF_REG_FPGA_DBG1_itblk_busy_src(data)                                       ((0x00000010&(data))>>4)
+#define RIF_REG_FPGA_DBG1_get_itblk_busy(data)                                       ((0x00000010&(data))>>4)
+#define RIF_REG_FPGA_DBG1_acdc_busy_shift                                            (3)
+#define RIF_REG_FPGA_DBG1_acdc_busy_mask                                             (0x00000008)
+#define RIF_REG_FPGA_DBG1_acdc_busy(data)                                            (0x00000008&((data)<<3))
+#define RIF_REG_FPGA_DBG1_acdc_busy_src(data)                                        ((0x00000008&(data))>>3)
+#define RIF_REG_FPGA_DBG1_get_acdc_busy(data)                                        ((0x00000008&(data))>>3)
+#define RIF_REG_FPGA_DBG1_cabacp2_busy_shift                                         (2)
+#define RIF_REG_FPGA_DBG1_cabacp2_busy_mask                                          (0x00000004)
+#define RIF_REG_FPGA_DBG1_cabacp2_busy(data)                                         (0x00000004&((data)<<2))
+#define RIF_REG_FPGA_DBG1_cabacp2_busy_src(data)                                     ((0x00000004&(data))>>2)
+#define RIF_REG_FPGA_DBG1_get_cabacp2_busy(data)                                     ((0x00000004&(data))>>2)
+#define RIF_REG_FPGA_DBG1_vld_busy_shift                                             (1)
+#define RIF_REG_FPGA_DBG1_vld_busy_mask                                              (0x00000002)
+#define RIF_REG_FPGA_DBG1_vld_busy(data)                                             (0x00000002&((data)<<1))
+#define RIF_REG_FPGA_DBG1_vld_busy_src(data)                                         ((0x00000002&(data))>>1)
+#define RIF_REG_FPGA_DBG1_get_vld_busy(data)                                         ((0x00000002&(data))>>1)
+#define RIF_REG_FPGA_DBG1_rifvld_busy_shift                                          (0)
+#define RIF_REG_FPGA_DBG1_rifvld_busy_mask                                           (0x00000001)
+#define RIF_REG_FPGA_DBG1_rifvld_busy(data)                                          (0x00000001&((data)<<0))
+#define RIF_REG_FPGA_DBG1_rifvld_busy_src(data)                                      ((0x00000001&(data))>>0)
+#define RIF_REG_FPGA_DBG1_get_rifvld_busy(data)                                      ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/rl_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/rl_reg.h
new file mode 100644
index 00000000..afedf45
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/rl_reg.h
@@ -0,0 +1,1230 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/6/22 11:40:34
+***************************************************************/
+
+
+#ifndef _RL_REG_H_INCLUDED_
+#define _RL_REG_H_INCLUDED_
+#ifdef  _RL_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     disppic_h:13;
+unsigned int     reserved_1:1;
+unsigned int     disppic_w:14;
+unsigned int     Cur_RANGEREDFRM:1;
+}RL_RLCNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     write_enable3:1;
+unsigned int     rmem_wptr_rst:1;
+unsigned int     write_enable2:1;
+unsigned int     ldmc_bypass:1;
+unsigned int     pred_enable:1;
+unsigned int     ldmc_enable:1;
+unsigned int     write_enable1:1;
+unsigned int     manual_thresh_ena:1;
+unsigned int     RM_threshold:6;
+}RL_RLCNTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     PicType:3;
+unsigned int     reserved_1:3;
+unsigned int     First_mb:1;
+unsigned int     reserved_2:3;
+unsigned int     Cur_mb_x:9;
+unsigned int     Cur_mb_y:8;
+}RL_CCPAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     mb_field_decoding_flag:1;
+unsigned int     Mb_partition:9;
+}RL_H264CCPAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     IntraMB_flag:1;
+unsigned int     Intra_flag:5;
+unsigned int     SubMB_partition:12;
+unsigned int     mvtype:2;
+unsigned int     FIELDTX:1;
+unsigned int     OVERFLAG:1;
+}RL_VC1CCPAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     Chroma_predict_part0:2;
+unsigned int     Chroma_predict_part1:2;
+unsigned int     Chroma_predict_part2:2;
+unsigned int     Chroma_predict_part3:2;
+unsigned int     Inter_predict_part0:2;
+unsigned int     Inter_predict_part1:2;
+unsigned int     Inter_predict_part2:2;
+unsigned int     Inter_predict_part3:2;
+}RL_POPAR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ref_RANGEREDFRM:1;
+unsigned int     bottom_field_flag:1;
+unsigned int     lu_addr_index:7;
+unsigned int     ch_addr_index:7;
+}RL_L0REFDMA;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     ref_RANGEREDFRM:1;
+unsigned int     bottom_field_flag:1;
+unsigned int     lu_addr_index:7;
+unsigned int     ch_addr_index:7;
+}RL_L1REFDMA;
+
+typedef struct 
+{
+unsigned int     write_enable3:1;
+unsigned int     Trigger_status:1;
+unsigned int     Zero_w_lr:2;
+unsigned int     write_enable2:1;
+unsigned int     Trigger_select:4;
+unsigned int     reserved_0:2;
+unsigned int     Trigger_cond_mb_x:9;
+unsigned int     Trigger_cond_mb_y:8;
+unsigned int     write_enable1:1;
+unsigned int     Debug_port_sel:3;
+}RL_DBG_SEL;
+
+typedef struct 
+{
+unsigned int     Tbl_cnt:16;
+unsigned int     Trigger_tbl_cnt:16;
+}RL_DBG_STS0;
+
+typedef struct 
+{
+unsigned int     DBG_STS:32;
+}RL_DBG_STS1;
+
+typedef struct 
+{
+unsigned int     DBG_STS:32;
+}RL_DBG_STS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     Intr:1;
+unsigned int     Value:28;
+}RL_INTR_THRES;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     MVBUF_write_address:7;
+}RL_MVBUF_WADD;
+
+typedef struct 
+{
+unsigned int     MVBUF_read_write_data:32;
+}RL_MVBUF_DATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     MVBUF_read_address:7;
+}RL_MVBUF_RADD;
+
+typedef struct 
+{
+unsigned int     write_enable3:1;
+unsigned int     MVBUF_hdr:7;
+unsigned int     reserved_0:3;
+unsigned int     write_enable2:1;
+unsigned int     MVBUF_pred_rptr:8;
+unsigned int     reserved_1:3;
+unsigned int     write_enable1:1;
+unsigned int     MVBUF_mvd_wptr:8;
+}RL_MVBUF_STS0;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     write_enable1:1;
+unsigned int     MVBUF_rl_rptr:8;
+}RL_MVBUF_STS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     write_enable2:1;
+unsigned int     Vg_en:2;
+unsigned int     write_enable1:1;
+unsigned int     Ref_pic_cnt:1;
+}RL_CACHE_SET;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     Cah_en:1;
+}RL_CACHE_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     Cah_inv:1;
+}RL_CACHE_INV;
+
+typedef struct 
+{
+unsigned int     Cah_pindx0_LumL0:8;
+unsigned int     Cah_pindx1_LumL1:8;
+unsigned int     Cah_pindx2_ChrL0:8;
+unsigned int     Cah_pindx3_ChrL1:8;
+}RL_CAH_PINDX;
+
+#endif
+
+#define RL_RLCNTL                                                                    0x1800EC00
+#define RL_RLCNTL_reg_addr                                                           "0xB800EC00"
+#define RL_RLCNTL_reg                                                                0xB800EC00
+#define set_RL_RLCNTL_reg(data)   (*((volatile unsigned int*) RL_RLCNTL_reg)=data)
+#define get_RL_RLCNTL_reg   (*((volatile unsigned int*) RL_RLCNTL_reg))
+#define RL_RLCNTL_inst_adr                                                           "0x0000"
+#define RL_RLCNTL_inst                                                               0x0000
+#define RL_RLCNTL_disppic_h_shift                                                    (16)
+#define RL_RLCNTL_disppic_h_mask                                                     (0x1FFF0000)
+#define RL_RLCNTL_disppic_h(data)                                                    (0x1FFF0000&((data)<<16))
+#define RL_RLCNTL_disppic_h_src(data)                                                ((0x1FFF0000&(data))>>16)
+#define RL_RLCNTL_get_disppic_h(data)                                                ((0x1FFF0000&(data))>>16)
+#define RL_RLCNTL_disppic_w_shift                                                    (1)
+#define RL_RLCNTL_disppic_w_mask                                                     (0x00007FFE)
+#define RL_RLCNTL_disppic_w(data)                                                    (0x00007FFE&((data)<<1))
+#define RL_RLCNTL_disppic_w_src(data)                                                ((0x00007FFE&(data))>>1)
+#define RL_RLCNTL_get_disppic_w(data)                                                ((0x00007FFE&(data))>>1)
+#define RL_RLCNTL_Cur_RANGEREDFRM_shift                                              (0)
+#define RL_RLCNTL_Cur_RANGEREDFRM_mask                                               (0x00000001)
+#define RL_RLCNTL_Cur_RANGEREDFRM(data)                                              (0x00000001&((data)<<0))
+#define RL_RLCNTL_Cur_RANGEREDFRM_src(data)                                          ((0x00000001&(data))>>0)
+#define RL_RLCNTL_get_Cur_RANGEREDFRM(data)                                          ((0x00000001&(data))>>0)
+
+
+#define RL_RLCNTL2                                                                   0x1800EC04
+#define RL_RLCNTL2_reg_addr                                                          "0xB800EC04"
+#define RL_RLCNTL2_reg                                                               0xB800EC04
+#define set_RL_RLCNTL2_reg(data)   (*((volatile unsigned int*) RL_RLCNTL2_reg)=data)
+#define get_RL_RLCNTL2_reg   (*((volatile unsigned int*) RL_RLCNTL2_reg))
+#define RL_RLCNTL2_inst_adr                                                          "0x0001"
+#define RL_RLCNTL2_inst                                                              0x0001
+#define RL_RLCNTL2_write_enable3_shift                                               (13)
+#define RL_RLCNTL2_write_enable3_mask                                                (0x00002000)
+#define RL_RLCNTL2_write_enable3(data)                                               (0x00002000&((data)<<13))
+#define RL_RLCNTL2_write_enable3_src(data)                                           ((0x00002000&(data))>>13)
+#define RL_RLCNTL2_get_write_enable3(data)                                           ((0x00002000&(data))>>13)
+#define RL_RLCNTL2_rmem_wptr_rst_shift                                               (12)
+#define RL_RLCNTL2_rmem_wptr_rst_mask                                                (0x00001000)
+#define RL_RLCNTL2_rmem_wptr_rst(data)                                               (0x00001000&((data)<<12))
+#define RL_RLCNTL2_rmem_wptr_rst_src(data)                                           ((0x00001000&(data))>>12)
+#define RL_RLCNTL2_get_rmem_wptr_rst(data)                                           ((0x00001000&(data))>>12)
+#define RL_RLCNTL2_write_enable2_shift                                               (11)
+#define RL_RLCNTL2_write_enable2_mask                                                (0x00000800)
+#define RL_RLCNTL2_write_enable2(data)                                               (0x00000800&((data)<<11))
+#define RL_RLCNTL2_write_enable2_src(data)                                           ((0x00000800&(data))>>11)
+#define RL_RLCNTL2_get_write_enable2(data)                                           ((0x00000800&(data))>>11)
+#define RL_RLCNTL2_ldmc_bypass_shift                                                 (10)
+#define RL_RLCNTL2_ldmc_bypass_mask                                                  (0x00000400)
+#define RL_RLCNTL2_ldmc_bypass(data)                                                 (0x00000400&((data)<<10))
+#define RL_RLCNTL2_ldmc_bypass_src(data)                                             ((0x00000400&(data))>>10)
+#define RL_RLCNTL2_get_ldmc_bypass(data)                                             ((0x00000400&(data))>>10)
+#define RL_RLCNTL2_pred_enable_shift                                                 (9)
+#define RL_RLCNTL2_pred_enable_mask                                                  (0x00000200)
+#define RL_RLCNTL2_pred_enable(data)                                                 (0x00000200&((data)<<9))
+#define RL_RLCNTL2_pred_enable_src(data)                                             ((0x00000200&(data))>>9)
+#define RL_RLCNTL2_get_pred_enable(data)                                             ((0x00000200&(data))>>9)
+#define RL_RLCNTL2_ldmc_enable_shift                                                 (8)
+#define RL_RLCNTL2_ldmc_enable_mask                                                  (0x00000100)
+#define RL_RLCNTL2_ldmc_enable(data)                                                 (0x00000100&((data)<<8))
+#define RL_RLCNTL2_ldmc_enable_src(data)                                             ((0x00000100&(data))>>8)
+#define RL_RLCNTL2_get_ldmc_enable(data)                                             ((0x00000100&(data))>>8)
+#define RL_RLCNTL2_write_enable1_shift                                               (7)
+#define RL_RLCNTL2_write_enable1_mask                                                (0x00000080)
+#define RL_RLCNTL2_write_enable1(data)                                               (0x00000080&((data)<<7))
+#define RL_RLCNTL2_write_enable1_src(data)                                           ((0x00000080&(data))>>7)
+#define RL_RLCNTL2_get_write_enable1(data)                                           ((0x00000080&(data))>>7)
+#define RL_RLCNTL2_manual_thresh_ena_shift                                           (6)
+#define RL_RLCNTL2_manual_thresh_ena_mask                                            (0x00000040)
+#define RL_RLCNTL2_manual_thresh_ena(data)                                           (0x00000040&((data)<<6))
+#define RL_RLCNTL2_manual_thresh_ena_src(data)                                       ((0x00000040&(data))>>6)
+#define RL_RLCNTL2_get_manual_thresh_ena(data)                                       ((0x00000040&(data))>>6)
+#define RL_RLCNTL2_RM_threshold_shift                                                (0)
+#define RL_RLCNTL2_RM_threshold_mask                                                 (0x0000003F)
+#define RL_RLCNTL2_RM_threshold(data)                                                (0x0000003F&((data)<<0))
+#define RL_RLCNTL2_RM_threshold_src(data)                                            ((0x0000003F&(data))>>0)
+#define RL_RLCNTL2_get_RM_threshold(data)                                            ((0x0000003F&(data))>>0)
+
+
+#define RL_CCPAR                                                                     0x1800EC08
+#define RL_CCPAR_reg_addr                                                            "0xB800EC08"
+#define RL_CCPAR_reg                                                                 0xB800EC08
+#define set_RL_CCPAR_reg(data)   (*((volatile unsigned int*) RL_CCPAR_reg)=data)
+#define get_RL_CCPAR_reg   (*((volatile unsigned int*) RL_CCPAR_reg))
+#define RL_CCPAR_inst_adr                                                            "0x0002"
+#define RL_CCPAR_inst                                                                0x0002
+#define RL_CCPAR_PicType_shift                                                       (24)
+#define RL_CCPAR_PicType_mask                                                        (0x07000000)
+#define RL_CCPAR_PicType(data)                                                       (0x07000000&((data)<<24))
+#define RL_CCPAR_PicType_src(data)                                                   ((0x07000000&(data))>>24)
+#define RL_CCPAR_get_PicType(data)                                                   ((0x07000000&(data))>>24)
+#define RL_CCPAR_First_mb_shift                                                      (20)
+#define RL_CCPAR_First_mb_mask                                                       (0x00100000)
+#define RL_CCPAR_First_mb(data)                                                      (0x00100000&((data)<<20))
+#define RL_CCPAR_First_mb_src(data)                                                  ((0x00100000&(data))>>20)
+#define RL_CCPAR_get_First_mb(data)                                                  ((0x00100000&(data))>>20)
+#define RL_CCPAR_Cur_mb_x_shift                                                      (8)
+#define RL_CCPAR_Cur_mb_x_mask                                                       (0x0001FF00)
+#define RL_CCPAR_Cur_mb_x(data)                                                      (0x0001FF00&((data)<<8))
+#define RL_CCPAR_Cur_mb_x_src(data)                                                  ((0x0001FF00&(data))>>8)
+#define RL_CCPAR_get_Cur_mb_x(data)                                                  ((0x0001FF00&(data))>>8)
+#define RL_CCPAR_Cur_mb_y_shift                                                      (0)
+#define RL_CCPAR_Cur_mb_y_mask                                                       (0x000000FF)
+#define RL_CCPAR_Cur_mb_y(data)                                                      (0x000000FF&((data)<<0))
+#define RL_CCPAR_Cur_mb_y_src(data)                                                  ((0x000000FF&(data))>>0)
+#define RL_CCPAR_get_Cur_mb_y(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define RL_H264CCPAR                                                                 0x1800EC0C
+#define RL_H264CCPAR_reg_addr                                                        "0xB800EC0C"
+#define RL_H264CCPAR_reg                                                             0xB800EC0C
+#define set_RL_H264CCPAR_reg(data)   (*((volatile unsigned int*) RL_H264CCPAR_reg)=data)
+#define get_RL_H264CCPAR_reg   (*((volatile unsigned int*) RL_H264CCPAR_reg))
+#define RL_H264CCPAR_inst_adr                                                        "0x0003"
+#define RL_H264CCPAR_inst                                                            0x0003
+#define RL_H264CCPAR_mb_field_decoding_flag_shift                                    (9)
+#define RL_H264CCPAR_mb_field_decoding_flag_mask                                     (0x00000200)
+#define RL_H264CCPAR_mb_field_decoding_flag(data)                                    (0x00000200&((data)<<9))
+#define RL_H264CCPAR_mb_field_decoding_flag_src(data)                                ((0x00000200&(data))>>9)
+#define RL_H264CCPAR_get_mb_field_decoding_flag(data)                                ((0x00000200&(data))>>9)
+#define RL_H264CCPAR_Mb_partition_shift                                              (0)
+#define RL_H264CCPAR_Mb_partition_mask                                               (0x000001FF)
+#define RL_H264CCPAR_Mb_partition(data)                                              (0x000001FF&((data)<<0))
+#define RL_H264CCPAR_Mb_partition_src(data)                                          ((0x000001FF&(data))>>0)
+#define RL_H264CCPAR_get_Mb_partition(data)                                          ((0x000001FF&(data))>>0)
+
+
+#define RL_VC1CCPAR                                                                  0x1800EC10
+#define RL_VC1CCPAR_reg_addr                                                         "0xB800EC10"
+#define RL_VC1CCPAR_reg                                                              0xB800EC10
+#define set_RL_VC1CCPAR_reg(data)   (*((volatile unsigned int*) RL_VC1CCPAR_reg)=data)
+#define get_RL_VC1CCPAR_reg   (*((volatile unsigned int*) RL_VC1CCPAR_reg))
+#define RL_VC1CCPAR_inst_adr                                                         "0x0004"
+#define RL_VC1CCPAR_inst                                                             0x0004
+#define RL_VC1CCPAR_IntraMB_flag_shift                                               (21)
+#define RL_VC1CCPAR_IntraMB_flag_mask                                                (0x00200000)
+#define RL_VC1CCPAR_IntraMB_flag(data)                                               (0x00200000&((data)<<21))
+#define RL_VC1CCPAR_IntraMB_flag_src(data)                                           ((0x00200000&(data))>>21)
+#define RL_VC1CCPAR_get_IntraMB_flag(data)                                           ((0x00200000&(data))>>21)
+#define RL_VC1CCPAR_Intra_flag_shift                                                 (16)
+#define RL_VC1CCPAR_Intra_flag_mask                                                  (0x001F0000)
+#define RL_VC1CCPAR_Intra_flag(data)                                                 (0x001F0000&((data)<<16))
+#define RL_VC1CCPAR_Intra_flag_src(data)                                             ((0x001F0000&(data))>>16)
+#define RL_VC1CCPAR_get_Intra_flag(data)                                             ((0x001F0000&(data))>>16)
+#define RL_VC1CCPAR_SubMB_partition_shift                                            (4)
+#define RL_VC1CCPAR_SubMB_partition_mask                                             (0x0000FFF0)
+#define RL_VC1CCPAR_SubMB_partition(data)                                            (0x0000FFF0&((data)<<4))
+#define RL_VC1CCPAR_SubMB_partition_src(data)                                        ((0x0000FFF0&(data))>>4)
+#define RL_VC1CCPAR_get_SubMB_partition(data)                                        ((0x0000FFF0&(data))>>4)
+#define RL_VC1CCPAR_mvtype_shift                                                     (2)
+#define RL_VC1CCPAR_mvtype_mask                                                      (0x0000000C)
+#define RL_VC1CCPAR_mvtype(data)                                                     (0x0000000C&((data)<<2))
+#define RL_VC1CCPAR_mvtype_src(data)                                                 ((0x0000000C&(data))>>2)
+#define RL_VC1CCPAR_get_mvtype(data)                                                 ((0x0000000C&(data))>>2)
+#define RL_VC1CCPAR_FIELDTX_shift                                                    (1)
+#define RL_VC1CCPAR_FIELDTX_mask                                                     (0x00000002)
+#define RL_VC1CCPAR_FIELDTX(data)                                                    (0x00000002&((data)<<1))
+#define RL_VC1CCPAR_FIELDTX_src(data)                                                ((0x00000002&(data))>>1)
+#define RL_VC1CCPAR_get_FIELDTX(data)                                                ((0x00000002&(data))>>1)
+#define RL_VC1CCPAR_OVERFLAG_shift                                                   (0)
+#define RL_VC1CCPAR_OVERFLAG_mask                                                    (0x00000001)
+#define RL_VC1CCPAR_OVERFLAG(data)                                                   (0x00000001&((data)<<0))
+#define RL_VC1CCPAR_OVERFLAG_src(data)                                               ((0x00000001&(data))>>0)
+#define RL_VC1CCPAR_get_OVERFLAG(data)                                               ((0x00000001&(data))>>0)
+
+
+#define RL_POPAR                                                                     0x1800EC14
+#define RL_POPAR_reg_addr                                                            "0xB800EC14"
+#define RL_POPAR_reg                                                                 0xB800EC14
+#define set_RL_POPAR_reg(data)   (*((volatile unsigned int*) RL_POPAR_reg)=data)
+#define get_RL_POPAR_reg   (*((volatile unsigned int*) RL_POPAR_reg))
+#define RL_POPAR_inst_adr                                                            "0x0005"
+#define RL_POPAR_inst                                                                0x0005
+#define RL_POPAR_Chroma_predict_part0_shift                                          (14)
+#define RL_POPAR_Chroma_predict_part0_mask                                           (0x0000C000)
+#define RL_POPAR_Chroma_predict_part0(data)                                          (0x0000C000&((data)<<14))
+#define RL_POPAR_Chroma_predict_part0_src(data)                                      ((0x0000C000&(data))>>14)
+#define RL_POPAR_get_Chroma_predict_part0(data)                                      ((0x0000C000&(data))>>14)
+#define RL_POPAR_Chroma_predict_part1_shift                                          (12)
+#define RL_POPAR_Chroma_predict_part1_mask                                           (0x00003000)
+#define RL_POPAR_Chroma_predict_part1(data)                                          (0x00003000&((data)<<12))
+#define RL_POPAR_Chroma_predict_part1_src(data)                                      ((0x00003000&(data))>>12)
+#define RL_POPAR_get_Chroma_predict_part1(data)                                      ((0x00003000&(data))>>12)
+#define RL_POPAR_Chroma_predict_part2_shift                                          (10)
+#define RL_POPAR_Chroma_predict_part2_mask                                           (0x00000C00)
+#define RL_POPAR_Chroma_predict_part2(data)                                          (0x00000C00&((data)<<10))
+#define RL_POPAR_Chroma_predict_part2_src(data)                                      ((0x00000C00&(data))>>10)
+#define RL_POPAR_get_Chroma_predict_part2(data)                                      ((0x00000C00&(data))>>10)
+#define RL_POPAR_Chroma_predict_part3_shift                                          (8)
+#define RL_POPAR_Chroma_predict_part3_mask                                           (0x00000300)
+#define RL_POPAR_Chroma_predict_part3(data)                                          (0x00000300&((data)<<8))
+#define RL_POPAR_Chroma_predict_part3_src(data)                                      ((0x00000300&(data))>>8)
+#define RL_POPAR_get_Chroma_predict_part3(data)                                      ((0x00000300&(data))>>8)
+#define RL_POPAR_Inter_predict_part0_shift                                           (6)
+#define RL_POPAR_Inter_predict_part0_mask                                            (0x000000C0)
+#define RL_POPAR_Inter_predict_part0(data)                                           (0x000000C0&((data)<<6))
+#define RL_POPAR_Inter_predict_part0_src(data)                                       ((0x000000C0&(data))>>6)
+#define RL_POPAR_get_Inter_predict_part0(data)                                       ((0x000000C0&(data))>>6)
+#define RL_POPAR_Inter_predict_part1_shift                                           (4)
+#define RL_POPAR_Inter_predict_part1_mask                                            (0x00000030)
+#define RL_POPAR_Inter_predict_part1(data)                                           (0x00000030&((data)<<4))
+#define RL_POPAR_Inter_predict_part1_src(data)                                       ((0x00000030&(data))>>4)
+#define RL_POPAR_get_Inter_predict_part1(data)                                       ((0x00000030&(data))>>4)
+#define RL_POPAR_Inter_predict_part2_shift                                           (2)
+#define RL_POPAR_Inter_predict_part2_mask                                            (0x0000000C)
+#define RL_POPAR_Inter_predict_part2(data)                                           (0x0000000C&((data)<<2))
+#define RL_POPAR_Inter_predict_part2_src(data)                                       ((0x0000000C&(data))>>2)
+#define RL_POPAR_get_Inter_predict_part2(data)                                       ((0x0000000C&(data))>>2)
+#define RL_POPAR_Inter_predict_part3_shift                                           (0)
+#define RL_POPAR_Inter_predict_part3_mask                                            (0x00000003)
+#define RL_POPAR_Inter_predict_part3(data)                                           (0x00000003&((data)<<0))
+#define RL_POPAR_Inter_predict_part3_src(data)                                       ((0x00000003&(data))>>0)
+#define RL_POPAR_get_Inter_predict_part3(data)                                       ((0x00000003&(data))>>0)
+
+
+#define RL_L0REFDMA_0                                                                0x1800E500
+#define RL_L0REFDMA_1                                                                0x1800E504
+#define RL_L0REFDMA_2                                                                0x1800E508
+#define RL_L0REFDMA_3                                                                0x1800E50C
+#define RL_L0REFDMA_4                                                                0x1800E510
+#define RL_L0REFDMA_5                                                                0x1800E514
+#define RL_L0REFDMA_6                                                                0x1800E518
+#define RL_L0REFDMA_7                                                                0x1800E51C
+#define RL_L0REFDMA_8                                                                0x1800E520
+#define RL_L0REFDMA_9                                                                0x1800E524
+#define RL_L0REFDMA_10                                                                0x1800E528
+#define RL_L0REFDMA_11                                                                0x1800E52C
+#define RL_L0REFDMA_12                                                                0x1800E530
+#define RL_L0REFDMA_13                                                                0x1800E534
+#define RL_L0REFDMA_14                                                                0x1800E538
+#define RL_L0REFDMA_15                                                                0x1800E53C
+#define RL_L0REFDMA_16                                                                0x1800E540
+#define RL_L0REFDMA_17                                                                0x1800E544
+#define RL_L0REFDMA_18                                                                0x1800E548
+#define RL_L0REFDMA_19                                                                0x1800E54C
+#define RL_L0REFDMA_20                                                                0x1800E550
+#define RL_L0REFDMA_21                                                                0x1800E554
+#define RL_L0REFDMA_22                                                                0x1800E558
+#define RL_L0REFDMA_23                                                                0x1800E55C
+#define RL_L0REFDMA_24                                                                0x1800E560
+#define RL_L0REFDMA_25                                                                0x1800E564
+#define RL_L0REFDMA_26                                                                0x1800E568
+#define RL_L0REFDMA_27                                                                0x1800E56C
+#define RL_L0REFDMA_28                                                                0x1800E570
+#define RL_L0REFDMA_29                                                                0x1800E574
+#define RL_L0REFDMA_30                                                                0x1800E578
+#define RL_L0REFDMA_31                                                                0x1800E57C
+#define RL_L0REFDMA_0_reg_addr                                                       "0xB800E500"
+#define RL_L0REFDMA_1_reg_addr                                                       "0xB800E504"
+#define RL_L0REFDMA_2_reg_addr                                                       "0xB800E508"
+#define RL_L0REFDMA_3_reg_addr                                                       "0xB800E50C"
+#define RL_L0REFDMA_4_reg_addr                                                       "0xB800E510"
+#define RL_L0REFDMA_5_reg_addr                                                       "0xB800E514"
+#define RL_L0REFDMA_6_reg_addr                                                       "0xB800E518"
+#define RL_L0REFDMA_7_reg_addr                                                       "0xB800E51C"
+#define RL_L0REFDMA_8_reg_addr                                                       "0xB800E520"
+#define RL_L0REFDMA_9_reg_addr                                                       "0xB800E524"
+#define RL_L0REFDMA_10_reg_addr                                                       "0xB800E528"
+#define RL_L0REFDMA_11_reg_addr                                                       "0xB800E52C"
+#define RL_L0REFDMA_12_reg_addr                                                       "0xB800E530"
+#define RL_L0REFDMA_13_reg_addr                                                       "0xB800E534"
+#define RL_L0REFDMA_14_reg_addr                                                       "0xB800E538"
+#define RL_L0REFDMA_15_reg_addr                                                       "0xB800E53C"
+#define RL_L0REFDMA_16_reg_addr                                                       "0xB800E540"
+#define RL_L0REFDMA_17_reg_addr                                                       "0xB800E544"
+#define RL_L0REFDMA_18_reg_addr                                                       "0xB800E548"
+#define RL_L0REFDMA_19_reg_addr                                                       "0xB800E54C"
+#define RL_L0REFDMA_20_reg_addr                                                       "0xB800E550"
+#define RL_L0REFDMA_21_reg_addr                                                       "0xB800E554"
+#define RL_L0REFDMA_22_reg_addr                                                       "0xB800E558"
+#define RL_L0REFDMA_23_reg_addr                                                       "0xB800E55C"
+#define RL_L0REFDMA_24_reg_addr                                                       "0xB800E560"
+#define RL_L0REFDMA_25_reg_addr                                                       "0xB800E564"
+#define RL_L0REFDMA_26_reg_addr                                                       "0xB800E568"
+#define RL_L0REFDMA_27_reg_addr                                                       "0xB800E56C"
+#define RL_L0REFDMA_28_reg_addr                                                       "0xB800E570"
+#define RL_L0REFDMA_29_reg_addr                                                       "0xB800E574"
+#define RL_L0REFDMA_30_reg_addr                                                       "0xB800E578"
+#define RL_L0REFDMA_31_reg_addr                                                       "0xB800E57C"
+#define RL_L0REFDMA_0_reg                                                            0xB800E500
+#define RL_L0REFDMA_1_reg                                                            0xB800E504
+#define RL_L0REFDMA_2_reg                                                            0xB800E508
+#define RL_L0REFDMA_3_reg                                                            0xB800E50C
+#define RL_L0REFDMA_4_reg                                                            0xB800E510
+#define RL_L0REFDMA_5_reg                                                            0xB800E514
+#define RL_L0REFDMA_6_reg                                                            0xB800E518
+#define RL_L0REFDMA_7_reg                                                            0xB800E51C
+#define RL_L0REFDMA_8_reg                                                            0xB800E520
+#define RL_L0REFDMA_9_reg                                                            0xB800E524
+#define RL_L0REFDMA_10_reg                                                            0xB800E528
+#define RL_L0REFDMA_11_reg                                                            0xB800E52C
+#define RL_L0REFDMA_12_reg                                                            0xB800E530
+#define RL_L0REFDMA_13_reg                                                            0xB800E534
+#define RL_L0REFDMA_14_reg                                                            0xB800E538
+#define RL_L0REFDMA_15_reg                                                            0xB800E53C
+#define RL_L0REFDMA_16_reg                                                            0xB800E540
+#define RL_L0REFDMA_17_reg                                                            0xB800E544
+#define RL_L0REFDMA_18_reg                                                            0xB800E548
+#define RL_L0REFDMA_19_reg                                                            0xB800E54C
+#define RL_L0REFDMA_20_reg                                                            0xB800E550
+#define RL_L0REFDMA_21_reg                                                            0xB800E554
+#define RL_L0REFDMA_22_reg                                                            0xB800E558
+#define RL_L0REFDMA_23_reg                                                            0xB800E55C
+#define RL_L0REFDMA_24_reg                                                            0xB800E560
+#define RL_L0REFDMA_25_reg                                                            0xB800E564
+#define RL_L0REFDMA_26_reg                                                            0xB800E568
+#define RL_L0REFDMA_27_reg                                                            0xB800E56C
+#define RL_L0REFDMA_28_reg                                                            0xB800E570
+#define RL_L0REFDMA_29_reg                                                            0xB800E574
+#define RL_L0REFDMA_30_reg                                                            0xB800E578
+#define RL_L0REFDMA_31_reg                                                            0xB800E57C
+#define set_RL_L0REFDMA_0_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_0_reg)=data)
+#define set_RL_L0REFDMA_1_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_1_reg)=data)
+#define set_RL_L0REFDMA_2_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_2_reg)=data)
+#define set_RL_L0REFDMA_3_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_3_reg)=data)
+#define set_RL_L0REFDMA_4_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_4_reg)=data)
+#define set_RL_L0REFDMA_5_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_5_reg)=data)
+#define set_RL_L0REFDMA_6_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_6_reg)=data)
+#define set_RL_L0REFDMA_7_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_7_reg)=data)
+#define set_RL_L0REFDMA_8_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_8_reg)=data)
+#define set_RL_L0REFDMA_9_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_9_reg)=data)
+#define set_RL_L0REFDMA_10_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_10_reg)=data)
+#define set_RL_L0REFDMA_11_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_11_reg)=data)
+#define set_RL_L0REFDMA_12_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_12_reg)=data)
+#define set_RL_L0REFDMA_13_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_13_reg)=data)
+#define set_RL_L0REFDMA_14_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_14_reg)=data)
+#define set_RL_L0REFDMA_15_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_15_reg)=data)
+#define set_RL_L0REFDMA_16_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_16_reg)=data)
+#define set_RL_L0REFDMA_17_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_17_reg)=data)
+#define set_RL_L0REFDMA_18_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_18_reg)=data)
+#define set_RL_L0REFDMA_19_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_19_reg)=data)
+#define set_RL_L0REFDMA_20_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_20_reg)=data)
+#define set_RL_L0REFDMA_21_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_21_reg)=data)
+#define set_RL_L0REFDMA_22_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_22_reg)=data)
+#define set_RL_L0REFDMA_23_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_23_reg)=data)
+#define set_RL_L0REFDMA_24_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_24_reg)=data)
+#define set_RL_L0REFDMA_25_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_25_reg)=data)
+#define set_RL_L0REFDMA_26_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_26_reg)=data)
+#define set_RL_L0REFDMA_27_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_27_reg)=data)
+#define set_RL_L0REFDMA_28_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_28_reg)=data)
+#define set_RL_L0REFDMA_29_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_29_reg)=data)
+#define set_RL_L0REFDMA_30_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_30_reg)=data)
+#define set_RL_L0REFDMA_31_reg(data)   (*((volatile unsigned int*) RL_L0REFDMA_31_reg)=data)
+#define get_RL_L0REFDMA_0_reg   (*((volatile unsigned int*) RL_L0REFDMA_0_reg))
+#define get_RL_L0REFDMA_1_reg   (*((volatile unsigned int*) RL_L0REFDMA_1_reg))
+#define get_RL_L0REFDMA_2_reg   (*((volatile unsigned int*) RL_L0REFDMA_2_reg))
+#define get_RL_L0REFDMA_3_reg   (*((volatile unsigned int*) RL_L0REFDMA_3_reg))
+#define get_RL_L0REFDMA_4_reg   (*((volatile unsigned int*) RL_L0REFDMA_4_reg))
+#define get_RL_L0REFDMA_5_reg   (*((volatile unsigned int*) RL_L0REFDMA_5_reg))
+#define get_RL_L0REFDMA_6_reg   (*((volatile unsigned int*) RL_L0REFDMA_6_reg))
+#define get_RL_L0REFDMA_7_reg   (*((volatile unsigned int*) RL_L0REFDMA_7_reg))
+#define get_RL_L0REFDMA_8_reg   (*((volatile unsigned int*) RL_L0REFDMA_8_reg))
+#define get_RL_L0REFDMA_9_reg   (*((volatile unsigned int*) RL_L0REFDMA_9_reg))
+#define get_RL_L0REFDMA_10_reg   (*((volatile unsigned int*) RL_L0REFDMA_10_reg))
+#define get_RL_L0REFDMA_11_reg   (*((volatile unsigned int*) RL_L0REFDMA_11_reg))
+#define get_RL_L0REFDMA_12_reg   (*((volatile unsigned int*) RL_L0REFDMA_12_reg))
+#define get_RL_L0REFDMA_13_reg   (*((volatile unsigned int*) RL_L0REFDMA_13_reg))
+#define get_RL_L0REFDMA_14_reg   (*((volatile unsigned int*) RL_L0REFDMA_14_reg))
+#define get_RL_L0REFDMA_15_reg   (*((volatile unsigned int*) RL_L0REFDMA_15_reg))
+#define get_RL_L0REFDMA_16_reg   (*((volatile unsigned int*) RL_L0REFDMA_16_reg))
+#define get_RL_L0REFDMA_17_reg   (*((volatile unsigned int*) RL_L0REFDMA_17_reg))
+#define get_RL_L0REFDMA_18_reg   (*((volatile unsigned int*) RL_L0REFDMA_18_reg))
+#define get_RL_L0REFDMA_19_reg   (*((volatile unsigned int*) RL_L0REFDMA_19_reg))
+#define get_RL_L0REFDMA_20_reg   (*((volatile unsigned int*) RL_L0REFDMA_20_reg))
+#define get_RL_L0REFDMA_21_reg   (*((volatile unsigned int*) RL_L0REFDMA_21_reg))
+#define get_RL_L0REFDMA_22_reg   (*((volatile unsigned int*) RL_L0REFDMA_22_reg))
+#define get_RL_L0REFDMA_23_reg   (*((volatile unsigned int*) RL_L0REFDMA_23_reg))
+#define get_RL_L0REFDMA_24_reg   (*((volatile unsigned int*) RL_L0REFDMA_24_reg))
+#define get_RL_L0REFDMA_25_reg   (*((volatile unsigned int*) RL_L0REFDMA_25_reg))
+#define get_RL_L0REFDMA_26_reg   (*((volatile unsigned int*) RL_L0REFDMA_26_reg))
+#define get_RL_L0REFDMA_27_reg   (*((volatile unsigned int*) RL_L0REFDMA_27_reg))
+#define get_RL_L0REFDMA_28_reg   (*((volatile unsigned int*) RL_L0REFDMA_28_reg))
+#define get_RL_L0REFDMA_29_reg   (*((volatile unsigned int*) RL_L0REFDMA_29_reg))
+#define get_RL_L0REFDMA_30_reg   (*((volatile unsigned int*) RL_L0REFDMA_30_reg))
+#define get_RL_L0REFDMA_31_reg   (*((volatile unsigned int*) RL_L0REFDMA_31_reg))
+#define RL_L0REFDMA_0_inst_adr                                                       "0x0040"
+#define RL_L0REFDMA_1_inst_adr                                                       "0x0041"
+#define RL_L0REFDMA_2_inst_adr                                                       "0x0042"
+#define RL_L0REFDMA_3_inst_adr                                                       "0x0043"
+#define RL_L0REFDMA_4_inst_adr                                                       "0x0044"
+#define RL_L0REFDMA_5_inst_adr                                                       "0x0045"
+#define RL_L0REFDMA_6_inst_adr                                                       "0x0046"
+#define RL_L0REFDMA_7_inst_adr                                                       "0x0047"
+#define RL_L0REFDMA_8_inst_adr                                                       "0x0048"
+#define RL_L0REFDMA_9_inst_adr                                                       "0x0049"
+#define RL_L0REFDMA_10_inst_adr                                                       "0x004A"
+#define RL_L0REFDMA_11_inst_adr                                                       "0x004B"
+#define RL_L0REFDMA_12_inst_adr                                                       "0x004C"
+#define RL_L0REFDMA_13_inst_adr                                                       "0x004D"
+#define RL_L0REFDMA_14_inst_adr                                                       "0x004E"
+#define RL_L0REFDMA_15_inst_adr                                                       "0x004F"
+#define RL_L0REFDMA_16_inst_adr                                                       "0x0050"
+#define RL_L0REFDMA_17_inst_adr                                                       "0x0051"
+#define RL_L0REFDMA_18_inst_adr                                                       "0x0052"
+#define RL_L0REFDMA_19_inst_adr                                                       "0x0053"
+#define RL_L0REFDMA_20_inst_adr                                                       "0x0054"
+#define RL_L0REFDMA_21_inst_adr                                                       "0x0055"
+#define RL_L0REFDMA_22_inst_adr                                                       "0x0056"
+#define RL_L0REFDMA_23_inst_adr                                                       "0x0057"
+#define RL_L0REFDMA_24_inst_adr                                                       "0x0058"
+#define RL_L0REFDMA_25_inst_adr                                                       "0x0059"
+#define RL_L0REFDMA_26_inst_adr                                                       "0x005A"
+#define RL_L0REFDMA_27_inst_adr                                                       "0x005B"
+#define RL_L0REFDMA_28_inst_adr                                                       "0x005C"
+#define RL_L0REFDMA_29_inst_adr                                                       "0x005D"
+#define RL_L0REFDMA_30_inst_adr                                                       "0x005E"
+#define RL_L0REFDMA_31_inst_adr                                                       "0x005F"
+#define RL_L0REFDMA_0_inst                                                           0x0040
+#define RL_L0REFDMA_1_inst                                                           0x0041
+#define RL_L0REFDMA_2_inst                                                           0x0042
+#define RL_L0REFDMA_3_inst                                                           0x0043
+#define RL_L0REFDMA_4_inst                                                           0x0044
+#define RL_L0REFDMA_5_inst                                                           0x0045
+#define RL_L0REFDMA_6_inst                                                           0x0046
+#define RL_L0REFDMA_7_inst                                                           0x0047
+#define RL_L0REFDMA_8_inst                                                           0x0048
+#define RL_L0REFDMA_9_inst                                                           0x0049
+#define RL_L0REFDMA_10_inst                                                           0x004A
+#define RL_L0REFDMA_11_inst                                                           0x004B
+#define RL_L0REFDMA_12_inst                                                           0x004C
+#define RL_L0REFDMA_13_inst                                                           0x004D
+#define RL_L0REFDMA_14_inst                                                           0x004E
+#define RL_L0REFDMA_15_inst                                                           0x004F
+#define RL_L0REFDMA_16_inst                                                           0x0050
+#define RL_L0REFDMA_17_inst                                                           0x0051
+#define RL_L0REFDMA_18_inst                                                           0x0052
+#define RL_L0REFDMA_19_inst                                                           0x0053
+#define RL_L0REFDMA_20_inst                                                           0x0054
+#define RL_L0REFDMA_21_inst                                                           0x0055
+#define RL_L0REFDMA_22_inst                                                           0x0056
+#define RL_L0REFDMA_23_inst                                                           0x0057
+#define RL_L0REFDMA_24_inst                                                           0x0058
+#define RL_L0REFDMA_25_inst                                                           0x0059
+#define RL_L0REFDMA_26_inst                                                           0x005A
+#define RL_L0REFDMA_27_inst                                                           0x005B
+#define RL_L0REFDMA_28_inst                                                           0x005C
+#define RL_L0REFDMA_29_inst                                                           0x005D
+#define RL_L0REFDMA_30_inst                                                           0x005E
+#define RL_L0REFDMA_31_inst                                                           0x005F
+#define RL_L0REFDMA_ref_RANGEREDFRM_shift                                            (15)
+#define RL_L0REFDMA_ref_RANGEREDFRM_mask                                             (0x00008000)
+#define RL_L0REFDMA_ref_RANGEREDFRM(data)                                            (0x00008000&((data)<<15))
+#define RL_L0REFDMA_ref_RANGEREDFRM_src(data)                                        ((0x00008000&(data))>>15)
+#define RL_L0REFDMA_get_ref_RANGEREDFRM(data)                                        ((0x00008000&(data))>>15)
+#define RL_L0REFDMA_bottom_field_flag_shift                                          (14)
+#define RL_L0REFDMA_bottom_field_flag_mask                                           (0x00004000)
+#define RL_L0REFDMA_bottom_field_flag(data)                                          (0x00004000&((data)<<14))
+#define RL_L0REFDMA_bottom_field_flag_src(data)                                      ((0x00004000&(data))>>14)
+#define RL_L0REFDMA_get_bottom_field_flag(data)                                      ((0x00004000&(data))>>14)
+#define RL_L0REFDMA_lu_addr_index_shift                                              (7)
+#define RL_L0REFDMA_lu_addr_index_mask                                               (0x00003F80)
+#define RL_L0REFDMA_lu_addr_index(data)                                              (0x00003F80&((data)<<7))
+#define RL_L0REFDMA_lu_addr_index_src(data)                                          ((0x00003F80&(data))>>7)
+#define RL_L0REFDMA_get_lu_addr_index(data)                                          ((0x00003F80&(data))>>7)
+#define RL_L0REFDMA_ch_addr_index_shift                                              (0)
+#define RL_L0REFDMA_ch_addr_index_mask                                               (0x0000007F)
+#define RL_L0REFDMA_ch_addr_index(data)                                              (0x0000007F&((data)<<0))
+#define RL_L0REFDMA_ch_addr_index_src(data)                                          ((0x0000007F&(data))>>0)
+#define RL_L0REFDMA_get_ch_addr_index(data)                                          ((0x0000007F&(data))>>0)
+
+
+#define RL_L1REFDMA_0                                                                0x1800E580
+#define RL_L1REFDMA_1                                                                0x1800E584
+#define RL_L1REFDMA_2                                                                0x1800E588
+#define RL_L1REFDMA_3                                                                0x1800E58C
+#define RL_L1REFDMA_4                                                                0x1800E590
+#define RL_L1REFDMA_5                                                                0x1800E594
+#define RL_L1REFDMA_6                                                                0x1800E598
+#define RL_L1REFDMA_7                                                                0x1800E59C
+#define RL_L1REFDMA_8                                                                0x1800E5A0
+#define RL_L1REFDMA_9                                                                0x1800E5A4
+#define RL_L1REFDMA_10                                                                0x1800E5A8
+#define RL_L1REFDMA_11                                                                0x1800E5AC
+#define RL_L1REFDMA_12                                                                0x1800E5B0
+#define RL_L1REFDMA_13                                                                0x1800E5B4
+#define RL_L1REFDMA_14                                                                0x1800E5B8
+#define RL_L1REFDMA_15                                                                0x1800E5BC
+#define RL_L1REFDMA_16                                                                0x1800E5C0
+#define RL_L1REFDMA_17                                                                0x1800E5C4
+#define RL_L1REFDMA_18                                                                0x1800E5C8
+#define RL_L1REFDMA_19                                                                0x1800E5CC
+#define RL_L1REFDMA_20                                                                0x1800E5D0
+#define RL_L1REFDMA_21                                                                0x1800E5D4
+#define RL_L1REFDMA_22                                                                0x1800E5D8
+#define RL_L1REFDMA_23                                                                0x1800E5DC
+#define RL_L1REFDMA_24                                                                0x1800E5E0
+#define RL_L1REFDMA_25                                                                0x1800E5E4
+#define RL_L1REFDMA_26                                                                0x1800E5E8
+#define RL_L1REFDMA_27                                                                0x1800E5EC
+#define RL_L1REFDMA_28                                                                0x1800E5F0
+#define RL_L1REFDMA_29                                                                0x1800E5F4
+#define RL_L1REFDMA_30                                                                0x1800E5F8
+#define RL_L1REFDMA_31                                                                0x1800E5FC
+#define RL_L1REFDMA_0_reg_addr                                                       "0xB800E580"
+#define RL_L1REFDMA_1_reg_addr                                                       "0xB800E584"
+#define RL_L1REFDMA_2_reg_addr                                                       "0xB800E588"
+#define RL_L1REFDMA_3_reg_addr                                                       "0xB800E58C"
+#define RL_L1REFDMA_4_reg_addr                                                       "0xB800E590"
+#define RL_L1REFDMA_5_reg_addr                                                       "0xB800E594"
+#define RL_L1REFDMA_6_reg_addr                                                       "0xB800E598"
+#define RL_L1REFDMA_7_reg_addr                                                       "0xB800E59C"
+#define RL_L1REFDMA_8_reg_addr                                                       "0xB800E5A0"
+#define RL_L1REFDMA_9_reg_addr                                                       "0xB800E5A4"
+#define RL_L1REFDMA_10_reg_addr                                                       "0xB800E5A8"
+#define RL_L1REFDMA_11_reg_addr                                                       "0xB800E5AC"
+#define RL_L1REFDMA_12_reg_addr                                                       "0xB800E5B0"
+#define RL_L1REFDMA_13_reg_addr                                                       "0xB800E5B4"
+#define RL_L1REFDMA_14_reg_addr                                                       "0xB800E5B8"
+#define RL_L1REFDMA_15_reg_addr                                                       "0xB800E5BC"
+#define RL_L1REFDMA_16_reg_addr                                                       "0xB800E5C0"
+#define RL_L1REFDMA_17_reg_addr                                                       "0xB800E5C4"
+#define RL_L1REFDMA_18_reg_addr                                                       "0xB800E5C8"
+#define RL_L1REFDMA_19_reg_addr                                                       "0xB800E5CC"
+#define RL_L1REFDMA_20_reg_addr                                                       "0xB800E5D0"
+#define RL_L1REFDMA_21_reg_addr                                                       "0xB800E5D4"
+#define RL_L1REFDMA_22_reg_addr                                                       "0xB800E5D8"
+#define RL_L1REFDMA_23_reg_addr                                                       "0xB800E5DC"
+#define RL_L1REFDMA_24_reg_addr                                                       "0xB800E5E0"
+#define RL_L1REFDMA_25_reg_addr                                                       "0xB800E5E4"
+#define RL_L1REFDMA_26_reg_addr                                                       "0xB800E5E8"
+#define RL_L1REFDMA_27_reg_addr                                                       "0xB800E5EC"
+#define RL_L1REFDMA_28_reg_addr                                                       "0xB800E5F0"
+#define RL_L1REFDMA_29_reg_addr                                                       "0xB800E5F4"
+#define RL_L1REFDMA_30_reg_addr                                                       "0xB800E5F8"
+#define RL_L1REFDMA_31_reg_addr                                                       "0xB800E5FC"
+#define RL_L1REFDMA_0_reg                                                            0xB800E580
+#define RL_L1REFDMA_1_reg                                                            0xB800E584
+#define RL_L1REFDMA_2_reg                                                            0xB800E588
+#define RL_L1REFDMA_3_reg                                                            0xB800E58C
+#define RL_L1REFDMA_4_reg                                                            0xB800E590
+#define RL_L1REFDMA_5_reg                                                            0xB800E594
+#define RL_L1REFDMA_6_reg                                                            0xB800E598
+#define RL_L1REFDMA_7_reg                                                            0xB800E59C
+#define RL_L1REFDMA_8_reg                                                            0xB800E5A0
+#define RL_L1REFDMA_9_reg                                                            0xB800E5A4
+#define RL_L1REFDMA_10_reg                                                            0xB800E5A8
+#define RL_L1REFDMA_11_reg                                                            0xB800E5AC
+#define RL_L1REFDMA_12_reg                                                            0xB800E5B0
+#define RL_L1REFDMA_13_reg                                                            0xB800E5B4
+#define RL_L1REFDMA_14_reg                                                            0xB800E5B8
+#define RL_L1REFDMA_15_reg                                                            0xB800E5BC
+#define RL_L1REFDMA_16_reg                                                            0xB800E5C0
+#define RL_L1REFDMA_17_reg                                                            0xB800E5C4
+#define RL_L1REFDMA_18_reg                                                            0xB800E5C8
+#define RL_L1REFDMA_19_reg                                                            0xB800E5CC
+#define RL_L1REFDMA_20_reg                                                            0xB800E5D0
+#define RL_L1REFDMA_21_reg                                                            0xB800E5D4
+#define RL_L1REFDMA_22_reg                                                            0xB800E5D8
+#define RL_L1REFDMA_23_reg                                                            0xB800E5DC
+#define RL_L1REFDMA_24_reg                                                            0xB800E5E0
+#define RL_L1REFDMA_25_reg                                                            0xB800E5E4
+#define RL_L1REFDMA_26_reg                                                            0xB800E5E8
+#define RL_L1REFDMA_27_reg                                                            0xB800E5EC
+#define RL_L1REFDMA_28_reg                                                            0xB800E5F0
+#define RL_L1REFDMA_29_reg                                                            0xB800E5F4
+#define RL_L1REFDMA_30_reg                                                            0xB800E5F8
+#define RL_L1REFDMA_31_reg                                                            0xB800E5FC
+#define set_RL_L1REFDMA_0_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_0_reg)=data)
+#define set_RL_L1REFDMA_1_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_1_reg)=data)
+#define set_RL_L1REFDMA_2_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_2_reg)=data)
+#define set_RL_L1REFDMA_3_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_3_reg)=data)
+#define set_RL_L1REFDMA_4_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_4_reg)=data)
+#define set_RL_L1REFDMA_5_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_5_reg)=data)
+#define set_RL_L1REFDMA_6_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_6_reg)=data)
+#define set_RL_L1REFDMA_7_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_7_reg)=data)
+#define set_RL_L1REFDMA_8_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_8_reg)=data)
+#define set_RL_L1REFDMA_9_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_9_reg)=data)
+#define set_RL_L1REFDMA_10_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_10_reg)=data)
+#define set_RL_L1REFDMA_11_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_11_reg)=data)
+#define set_RL_L1REFDMA_12_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_12_reg)=data)
+#define set_RL_L1REFDMA_13_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_13_reg)=data)
+#define set_RL_L1REFDMA_14_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_14_reg)=data)
+#define set_RL_L1REFDMA_15_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_15_reg)=data)
+#define set_RL_L1REFDMA_16_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_16_reg)=data)
+#define set_RL_L1REFDMA_17_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_17_reg)=data)
+#define set_RL_L1REFDMA_18_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_18_reg)=data)
+#define set_RL_L1REFDMA_19_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_19_reg)=data)
+#define set_RL_L1REFDMA_20_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_20_reg)=data)
+#define set_RL_L1REFDMA_21_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_21_reg)=data)
+#define set_RL_L1REFDMA_22_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_22_reg)=data)
+#define set_RL_L1REFDMA_23_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_23_reg)=data)
+#define set_RL_L1REFDMA_24_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_24_reg)=data)
+#define set_RL_L1REFDMA_25_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_25_reg)=data)
+#define set_RL_L1REFDMA_26_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_26_reg)=data)
+#define set_RL_L1REFDMA_27_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_27_reg)=data)
+#define set_RL_L1REFDMA_28_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_28_reg)=data)
+#define set_RL_L1REFDMA_29_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_29_reg)=data)
+#define set_RL_L1REFDMA_30_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_30_reg)=data)
+#define set_RL_L1REFDMA_31_reg(data)   (*((volatile unsigned int*) RL_L1REFDMA_31_reg)=data)
+#define get_RL_L1REFDMA_0_reg   (*((volatile unsigned int*) RL_L1REFDMA_0_reg))
+#define get_RL_L1REFDMA_1_reg   (*((volatile unsigned int*) RL_L1REFDMA_1_reg))
+#define get_RL_L1REFDMA_2_reg   (*((volatile unsigned int*) RL_L1REFDMA_2_reg))
+#define get_RL_L1REFDMA_3_reg   (*((volatile unsigned int*) RL_L1REFDMA_3_reg))
+#define get_RL_L1REFDMA_4_reg   (*((volatile unsigned int*) RL_L1REFDMA_4_reg))
+#define get_RL_L1REFDMA_5_reg   (*((volatile unsigned int*) RL_L1REFDMA_5_reg))
+#define get_RL_L1REFDMA_6_reg   (*((volatile unsigned int*) RL_L1REFDMA_6_reg))
+#define get_RL_L1REFDMA_7_reg   (*((volatile unsigned int*) RL_L1REFDMA_7_reg))
+#define get_RL_L1REFDMA_8_reg   (*((volatile unsigned int*) RL_L1REFDMA_8_reg))
+#define get_RL_L1REFDMA_9_reg   (*((volatile unsigned int*) RL_L1REFDMA_9_reg))
+#define get_RL_L1REFDMA_10_reg   (*((volatile unsigned int*) RL_L1REFDMA_10_reg))
+#define get_RL_L1REFDMA_11_reg   (*((volatile unsigned int*) RL_L1REFDMA_11_reg))
+#define get_RL_L1REFDMA_12_reg   (*((volatile unsigned int*) RL_L1REFDMA_12_reg))
+#define get_RL_L1REFDMA_13_reg   (*((volatile unsigned int*) RL_L1REFDMA_13_reg))
+#define get_RL_L1REFDMA_14_reg   (*((volatile unsigned int*) RL_L1REFDMA_14_reg))
+#define get_RL_L1REFDMA_15_reg   (*((volatile unsigned int*) RL_L1REFDMA_15_reg))
+#define get_RL_L1REFDMA_16_reg   (*((volatile unsigned int*) RL_L1REFDMA_16_reg))
+#define get_RL_L1REFDMA_17_reg   (*((volatile unsigned int*) RL_L1REFDMA_17_reg))
+#define get_RL_L1REFDMA_18_reg   (*((volatile unsigned int*) RL_L1REFDMA_18_reg))
+#define get_RL_L1REFDMA_19_reg   (*((volatile unsigned int*) RL_L1REFDMA_19_reg))
+#define get_RL_L1REFDMA_20_reg   (*((volatile unsigned int*) RL_L1REFDMA_20_reg))
+#define get_RL_L1REFDMA_21_reg   (*((volatile unsigned int*) RL_L1REFDMA_21_reg))
+#define get_RL_L1REFDMA_22_reg   (*((volatile unsigned int*) RL_L1REFDMA_22_reg))
+#define get_RL_L1REFDMA_23_reg   (*((volatile unsigned int*) RL_L1REFDMA_23_reg))
+#define get_RL_L1REFDMA_24_reg   (*((volatile unsigned int*) RL_L1REFDMA_24_reg))
+#define get_RL_L1REFDMA_25_reg   (*((volatile unsigned int*) RL_L1REFDMA_25_reg))
+#define get_RL_L1REFDMA_26_reg   (*((volatile unsigned int*) RL_L1REFDMA_26_reg))
+#define get_RL_L1REFDMA_27_reg   (*((volatile unsigned int*) RL_L1REFDMA_27_reg))
+#define get_RL_L1REFDMA_28_reg   (*((volatile unsigned int*) RL_L1REFDMA_28_reg))
+#define get_RL_L1REFDMA_29_reg   (*((volatile unsigned int*) RL_L1REFDMA_29_reg))
+#define get_RL_L1REFDMA_30_reg   (*((volatile unsigned int*) RL_L1REFDMA_30_reg))
+#define get_RL_L1REFDMA_31_reg   (*((volatile unsigned int*) RL_L1REFDMA_31_reg))
+#define RL_L1REFDMA_0_inst_adr                                                       "0x0060"
+#define RL_L1REFDMA_1_inst_adr                                                       "0x0061"
+#define RL_L1REFDMA_2_inst_adr                                                       "0x0062"
+#define RL_L1REFDMA_3_inst_adr                                                       "0x0063"
+#define RL_L1REFDMA_4_inst_adr                                                       "0x0064"
+#define RL_L1REFDMA_5_inst_adr                                                       "0x0065"
+#define RL_L1REFDMA_6_inst_adr                                                       "0x0066"
+#define RL_L1REFDMA_7_inst_adr                                                       "0x0067"
+#define RL_L1REFDMA_8_inst_adr                                                       "0x0068"
+#define RL_L1REFDMA_9_inst_adr                                                       "0x0069"
+#define RL_L1REFDMA_10_inst_adr                                                       "0x006A"
+#define RL_L1REFDMA_11_inst_adr                                                       "0x006B"
+#define RL_L1REFDMA_12_inst_adr                                                       "0x006C"
+#define RL_L1REFDMA_13_inst_adr                                                       "0x006D"
+#define RL_L1REFDMA_14_inst_adr                                                       "0x006E"
+#define RL_L1REFDMA_15_inst_adr                                                       "0x006F"
+#define RL_L1REFDMA_16_inst_adr                                                       "0x0070"
+#define RL_L1REFDMA_17_inst_adr                                                       "0x0071"
+#define RL_L1REFDMA_18_inst_adr                                                       "0x0072"
+#define RL_L1REFDMA_19_inst_adr                                                       "0x0073"
+#define RL_L1REFDMA_20_inst_adr                                                       "0x0074"
+#define RL_L1REFDMA_21_inst_adr                                                       "0x0075"
+#define RL_L1REFDMA_22_inst_adr                                                       "0x0076"
+#define RL_L1REFDMA_23_inst_adr                                                       "0x0077"
+#define RL_L1REFDMA_24_inst_adr                                                       "0x0078"
+#define RL_L1REFDMA_25_inst_adr                                                       "0x0079"
+#define RL_L1REFDMA_26_inst_adr                                                       "0x007A"
+#define RL_L1REFDMA_27_inst_adr                                                       "0x007B"
+#define RL_L1REFDMA_28_inst_adr                                                       "0x007C"
+#define RL_L1REFDMA_29_inst_adr                                                       "0x007D"
+#define RL_L1REFDMA_30_inst_adr                                                       "0x007E"
+#define RL_L1REFDMA_31_inst_adr                                                       "0x007F"
+#define RL_L1REFDMA_0_inst                                                           0x0060
+#define RL_L1REFDMA_1_inst                                                           0x0061
+#define RL_L1REFDMA_2_inst                                                           0x0062
+#define RL_L1REFDMA_3_inst                                                           0x0063
+#define RL_L1REFDMA_4_inst                                                           0x0064
+#define RL_L1REFDMA_5_inst                                                           0x0065
+#define RL_L1REFDMA_6_inst                                                           0x0066
+#define RL_L1REFDMA_7_inst                                                           0x0067
+#define RL_L1REFDMA_8_inst                                                           0x0068
+#define RL_L1REFDMA_9_inst                                                           0x0069
+#define RL_L1REFDMA_10_inst                                                           0x006A
+#define RL_L1REFDMA_11_inst                                                           0x006B
+#define RL_L1REFDMA_12_inst                                                           0x006C
+#define RL_L1REFDMA_13_inst                                                           0x006D
+#define RL_L1REFDMA_14_inst                                                           0x006E
+#define RL_L1REFDMA_15_inst                                                           0x006F
+#define RL_L1REFDMA_16_inst                                                           0x0070
+#define RL_L1REFDMA_17_inst                                                           0x0071
+#define RL_L1REFDMA_18_inst                                                           0x0072
+#define RL_L1REFDMA_19_inst                                                           0x0073
+#define RL_L1REFDMA_20_inst                                                           0x0074
+#define RL_L1REFDMA_21_inst                                                           0x0075
+#define RL_L1REFDMA_22_inst                                                           0x0076
+#define RL_L1REFDMA_23_inst                                                           0x0077
+#define RL_L1REFDMA_24_inst                                                           0x0078
+#define RL_L1REFDMA_25_inst                                                           0x0079
+#define RL_L1REFDMA_26_inst                                                           0x007A
+#define RL_L1REFDMA_27_inst                                                           0x007B
+#define RL_L1REFDMA_28_inst                                                           0x007C
+#define RL_L1REFDMA_29_inst                                                           0x007D
+#define RL_L1REFDMA_30_inst                                                           0x007E
+#define RL_L1REFDMA_31_inst                                                           0x007F
+#define RL_L1REFDMA_ref_RANGEREDFRM_shift                                            (15)
+#define RL_L1REFDMA_ref_RANGEREDFRM_mask                                             (0x00008000)
+#define RL_L1REFDMA_ref_RANGEREDFRM(data)                                            (0x00008000&((data)<<15))
+#define RL_L1REFDMA_ref_RANGEREDFRM_src(data)                                        ((0x00008000&(data))>>15)
+#define RL_L1REFDMA_get_ref_RANGEREDFRM(data)                                        ((0x00008000&(data))>>15)
+#define RL_L1REFDMA_bottom_field_flag_shift                                          (14)
+#define RL_L1REFDMA_bottom_field_flag_mask                                           (0x00004000)
+#define RL_L1REFDMA_bottom_field_flag(data)                                          (0x00004000&((data)<<14))
+#define RL_L1REFDMA_bottom_field_flag_src(data)                                      ((0x00004000&(data))>>14)
+#define RL_L1REFDMA_get_bottom_field_flag(data)                                      ((0x00004000&(data))>>14)
+#define RL_L1REFDMA_lu_addr_index_shift                                              (7)
+#define RL_L1REFDMA_lu_addr_index_mask                                               (0x00003F80)
+#define RL_L1REFDMA_lu_addr_index(data)                                              (0x00003F80&((data)<<7))
+#define RL_L1REFDMA_lu_addr_index_src(data)                                          ((0x00003F80&(data))>>7)
+#define RL_L1REFDMA_get_lu_addr_index(data)                                          ((0x00003F80&(data))>>7)
+#define RL_L1REFDMA_ch_addr_index_shift                                              (0)
+#define RL_L1REFDMA_ch_addr_index_mask                                               (0x0000007F)
+#define RL_L1REFDMA_ch_addr_index(data)                                              (0x0000007F&((data)<<0))
+#define RL_L1REFDMA_ch_addr_index_src(data)                                          ((0x0000007F&(data))>>0)
+#define RL_L1REFDMA_get_ch_addr_index(data)                                          ((0x0000007F&(data))>>0)
+
+
+#define RL_DBG_SEL                                                                   0x1800EC18
+#define RL_DBG_SEL_reg_addr                                                          "0xB800EC18"
+#define RL_DBG_SEL_reg                                                               0xB800EC18
+#define set_RL_DBG_SEL_reg(data)   (*((volatile unsigned int*) RL_DBG_SEL_reg)=data)
+#define get_RL_DBG_SEL_reg   (*((volatile unsigned int*) RL_DBG_SEL_reg))
+#define RL_DBG_SEL_inst_adr                                                          "0x0006"
+#define RL_DBG_SEL_inst                                                              0x0006
+#define RL_DBG_SEL_write_enable3_shift                                               (31)
+#define RL_DBG_SEL_write_enable3_mask                                                (0x80000000)
+#define RL_DBG_SEL_write_enable3(data)                                               (0x80000000&((data)<<31))
+#define RL_DBG_SEL_write_enable3_src(data)                                           ((0x80000000&(data))>>31)
+#define RL_DBG_SEL_get_write_enable3(data)                                           ((0x80000000&(data))>>31)
+#define RL_DBG_SEL_Trigger_status_shift                                              (30)
+#define RL_DBG_SEL_Trigger_status_mask                                               (0x40000000)
+#define RL_DBG_SEL_Trigger_status(data)                                              (0x40000000&((data)<<30))
+#define RL_DBG_SEL_Trigger_status_src(data)                                          ((0x40000000&(data))>>30)
+#define RL_DBG_SEL_get_Trigger_status(data)                                          ((0x40000000&(data))>>30)
+#define RL_DBG_SEL_Zero_w_lr_shift                                                   (28)
+#define RL_DBG_SEL_Zero_w_lr_mask                                                    (0x30000000)
+#define RL_DBG_SEL_Zero_w_lr(data)                                                   (0x30000000&((data)<<28))
+#define RL_DBG_SEL_Zero_w_lr_src(data)                                               ((0x30000000&(data))>>28)
+#define RL_DBG_SEL_get_Zero_w_lr(data)                                               ((0x30000000&(data))>>28)
+#define RL_DBG_SEL_write_enable2_shift                                               (27)
+#define RL_DBG_SEL_write_enable2_mask                                                (0x08000000)
+#define RL_DBG_SEL_write_enable2(data)                                               (0x08000000&((data)<<27))
+#define RL_DBG_SEL_write_enable2_src(data)                                           ((0x08000000&(data))>>27)
+#define RL_DBG_SEL_get_write_enable2(data)                                           ((0x08000000&(data))>>27)
+#define RL_DBG_SEL_Trigger_select_shift                                              (23)
+#define RL_DBG_SEL_Trigger_select_mask                                               (0x07800000)
+#define RL_DBG_SEL_Trigger_select(data)                                              (0x07800000&((data)<<23))
+#define RL_DBG_SEL_Trigger_select_src(data)                                          ((0x07800000&(data))>>23)
+#define RL_DBG_SEL_get_Trigger_select(data)                                          ((0x07800000&(data))>>23)
+#define RL_DBG_SEL_Trigger_cond_mb_x_shift                                           (12)
+#define RL_DBG_SEL_Trigger_cond_mb_x_mask                                            (0x001FF000)
+#define RL_DBG_SEL_Trigger_cond_mb_x(data)                                           (0x001FF000&((data)<<12))
+#define RL_DBG_SEL_Trigger_cond_mb_x_src(data)                                       ((0x001FF000&(data))>>12)
+#define RL_DBG_SEL_get_Trigger_cond_mb_x(data)                                       ((0x001FF000&(data))>>12)
+#define RL_DBG_SEL_Trigger_cond_mb_y_shift                                           (4)
+#define RL_DBG_SEL_Trigger_cond_mb_y_mask                                            (0x00000FF0)
+#define RL_DBG_SEL_Trigger_cond_mb_y(data)                                           (0x00000FF0&((data)<<4))
+#define RL_DBG_SEL_Trigger_cond_mb_y_src(data)                                       ((0x00000FF0&(data))>>4)
+#define RL_DBG_SEL_get_Trigger_cond_mb_y(data)                                       ((0x00000FF0&(data))>>4)
+#define RL_DBG_SEL_write_enable1_shift                                               (3)
+#define RL_DBG_SEL_write_enable1_mask                                                (0x00000008)
+#define RL_DBG_SEL_write_enable1(data)                                               (0x00000008&((data)<<3))
+#define RL_DBG_SEL_write_enable1_src(data)                                           ((0x00000008&(data))>>3)
+#define RL_DBG_SEL_get_write_enable1(data)                                           ((0x00000008&(data))>>3)
+#define RL_DBG_SEL_Debug_port_sel_shift                                              (0)
+#define RL_DBG_SEL_Debug_port_sel_mask                                               (0x00000007)
+#define RL_DBG_SEL_Debug_port_sel(data)                                              (0x00000007&((data)<<0))
+#define RL_DBG_SEL_Debug_port_sel_src(data)                                          ((0x00000007&(data))>>0)
+#define RL_DBG_SEL_get_Debug_port_sel(data)                                          ((0x00000007&(data))>>0)
+
+
+#define RL_DBG_STS0                                                                  0x1800EC1C
+#define RL_DBG_STS0_reg_addr                                                         "0xB800EC1C"
+#define RL_DBG_STS0_reg                                                              0xB800EC1C
+#define set_RL_DBG_STS0_reg(data)   (*((volatile unsigned int*) RL_DBG_STS0_reg)=data)
+#define get_RL_DBG_STS0_reg   (*((volatile unsigned int*) RL_DBG_STS0_reg))
+#define RL_DBG_STS0_inst_adr                                                         "0x0007"
+#define RL_DBG_STS0_inst                                                             0x0007
+#define RL_DBG_STS0_Tbl_cnt_shift                                                    (16)
+#define RL_DBG_STS0_Tbl_cnt_mask                                                     (0xFFFF0000)
+#define RL_DBG_STS0_Tbl_cnt(data)                                                    (0xFFFF0000&((data)<<16))
+#define RL_DBG_STS0_Tbl_cnt_src(data)                                                ((0xFFFF0000&(data))>>16)
+#define RL_DBG_STS0_get_Tbl_cnt(data)                                                ((0xFFFF0000&(data))>>16)
+#define RL_DBG_STS0_Trigger_tbl_cnt_shift                                            (0)
+#define RL_DBG_STS0_Trigger_tbl_cnt_mask                                             (0x0000FFFF)
+#define RL_DBG_STS0_Trigger_tbl_cnt(data)                                            (0x0000FFFF&((data)<<0))
+#define RL_DBG_STS0_Trigger_tbl_cnt_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define RL_DBG_STS0_get_Trigger_tbl_cnt(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define RL_DBG_STS1                                                                  0x1800EC20
+#define RL_DBG_STS1_reg_addr                                                         "0xB800EC20"
+#define RL_DBG_STS1_reg                                                              0xB800EC20
+#define set_RL_DBG_STS1_reg(data)   (*((volatile unsigned int*) RL_DBG_STS1_reg)=data)
+#define get_RL_DBG_STS1_reg   (*((volatile unsigned int*) RL_DBG_STS1_reg))
+#define RL_DBG_STS1_inst_adr                                                         "0x0008"
+#define RL_DBG_STS1_inst                                                             0x0008
+#define RL_DBG_STS1_DBG_STS_shift                                                    (0)
+#define RL_DBG_STS1_DBG_STS_mask                                                     (0xFFFFFFFF)
+#define RL_DBG_STS1_DBG_STS(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define RL_DBG_STS1_DBG_STS_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define RL_DBG_STS1_get_DBG_STS(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define RL_DBG_STS2                                                                  0x1800EC24
+#define RL_DBG_STS2_reg_addr                                                         "0xB800EC24"
+#define RL_DBG_STS2_reg                                                              0xB800EC24
+#define set_RL_DBG_STS2_reg(data)   (*((volatile unsigned int*) RL_DBG_STS2_reg)=data)
+#define get_RL_DBG_STS2_reg   (*((volatile unsigned int*) RL_DBG_STS2_reg))
+#define RL_DBG_STS2_inst_adr                                                         "0x0009"
+#define RL_DBG_STS2_inst                                                             0x0009
+#define RL_DBG_STS2_DBG_STS_shift                                                    (0)
+#define RL_DBG_STS2_DBG_STS_mask                                                     (0xFFFFFFFF)
+#define RL_DBG_STS2_DBG_STS(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define RL_DBG_STS2_DBG_STS_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define RL_DBG_STS2_get_DBG_STS(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define RL_INTR_THRES                                                                0x1800EC28
+#define RL_INTR_THRES_reg_addr                                                       "0xB800EC28"
+#define RL_INTR_THRES_reg                                                            0xB800EC28
+#define set_RL_INTR_THRES_reg(data)   (*((volatile unsigned int*) RL_INTR_THRES_reg)=data)
+#define get_RL_INTR_THRES_reg   (*((volatile unsigned int*) RL_INTR_THRES_reg))
+#define RL_INTR_THRES_inst_adr                                                       "0x000A"
+#define RL_INTR_THRES_inst                                                           0x000A
+#define RL_INTR_THRES_Intr_shift                                                     (28)
+#define RL_INTR_THRES_Intr_mask                                                      (0x10000000)
+#define RL_INTR_THRES_Intr(data)                                                     (0x10000000&((data)<<28))
+#define RL_INTR_THRES_Intr_src(data)                                                 ((0x10000000&(data))>>28)
+#define RL_INTR_THRES_get_Intr(data)                                                 ((0x10000000&(data))>>28)
+#define RL_INTR_THRES_Value_shift                                                    (0)
+#define RL_INTR_THRES_Value_mask                                                     (0x0FFFFFFF)
+#define RL_INTR_THRES_Value(data)                                                    (0x0FFFFFFF&((data)<<0))
+#define RL_INTR_THRES_Value_src(data)                                                ((0x0FFFFFFF&(data))>>0)
+#define RL_INTR_THRES_get_Value(data)                                                ((0x0FFFFFFF&(data))>>0)
+
+
+#define RL_MVBUF_WADD                                                                0x1800EC80
+#define RL_MVBUF_WADD_reg_addr                                                       "0xB800EC80"
+#define RL_MVBUF_WADD_reg                                                            0xB800EC80
+#define set_RL_MVBUF_WADD_reg(data)   (*((volatile unsigned int*) RL_MVBUF_WADD_reg)=data)
+#define get_RL_MVBUF_WADD_reg   (*((volatile unsigned int*) RL_MVBUF_WADD_reg))
+#define RL_MVBUF_WADD_inst_adr                                                       "0x0020"
+#define RL_MVBUF_WADD_inst                                                           0x0020
+#define RL_MVBUF_WADD_MVBUF_write_address_shift                                      (0)
+#define RL_MVBUF_WADD_MVBUF_write_address_mask                                       (0x0000007F)
+#define RL_MVBUF_WADD_MVBUF_write_address(data)                                      (0x0000007F&((data)<<0))
+#define RL_MVBUF_WADD_MVBUF_write_address_src(data)                                  ((0x0000007F&(data))>>0)
+#define RL_MVBUF_WADD_get_MVBUF_write_address(data)                                  ((0x0000007F&(data))>>0)
+
+
+#define RL_MVBUF_DATA_0                                                              0x1800EC84
+#define RL_MVBUF_DATA_1                                                              0x1800EC88
+#define RL_MVBUF_DATA_2                                                              0x1800EC8C
+#define RL_MVBUF_DATA_0_reg_addr                                                     "0xB800EC84"
+#define RL_MVBUF_DATA_1_reg_addr                                                     "0xB800EC88"
+#define RL_MVBUF_DATA_2_reg_addr                                                     "0xB800EC8C"
+#define RL_MVBUF_DATA_0_reg                                                          0xB800EC84
+#define RL_MVBUF_DATA_1_reg                                                          0xB800EC88
+#define RL_MVBUF_DATA_2_reg                                                          0xB800EC8C
+#define set_RL_MVBUF_DATA_0_reg(data)   (*((volatile unsigned int*) RL_MVBUF_DATA_0_reg)=data)
+#define set_RL_MVBUF_DATA_1_reg(data)   (*((volatile unsigned int*) RL_MVBUF_DATA_1_reg)=data)
+#define set_RL_MVBUF_DATA_2_reg(data)   (*((volatile unsigned int*) RL_MVBUF_DATA_2_reg)=data)
+#define get_RL_MVBUF_DATA_0_reg   (*((volatile unsigned int*) RL_MVBUF_DATA_0_reg))
+#define get_RL_MVBUF_DATA_1_reg   (*((volatile unsigned int*) RL_MVBUF_DATA_1_reg))
+#define get_RL_MVBUF_DATA_2_reg   (*((volatile unsigned int*) RL_MVBUF_DATA_2_reg))
+#define RL_MVBUF_DATA_0_inst_adr                                                     "0x0021"
+#define RL_MVBUF_DATA_1_inst_adr                                                     "0x0022"
+#define RL_MVBUF_DATA_2_inst_adr                                                     "0x0023"
+#define RL_MVBUF_DATA_0_inst                                                         0x0021
+#define RL_MVBUF_DATA_1_inst                                                         0x0022
+#define RL_MVBUF_DATA_2_inst                                                         0x0023
+#define RL_MVBUF_DATA_MVBUF_read_write_data_shift                                    (0)
+#define RL_MVBUF_DATA_MVBUF_read_write_data_mask                                     (0xFFFFFFFF)
+#define RL_MVBUF_DATA_MVBUF_read_write_data(data)                                    (0xFFFFFFFF&((data)<<0))
+#define RL_MVBUF_DATA_MVBUF_read_write_data_src(data)                                ((0xFFFFFFFF&(data))>>0)
+#define RL_MVBUF_DATA_get_MVBUF_read_write_data(data)                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define RL_MVBUF_RADD                                                                0x1800EC90
+#define RL_MVBUF_RADD_reg_addr                                                       "0xB800EC90"
+#define RL_MVBUF_RADD_reg                                                            0xB800EC90
+#define set_RL_MVBUF_RADD_reg(data)   (*((volatile unsigned int*) RL_MVBUF_RADD_reg)=data)
+#define get_RL_MVBUF_RADD_reg   (*((volatile unsigned int*) RL_MVBUF_RADD_reg))
+#define RL_MVBUF_RADD_inst_adr                                                       "0x0024"
+#define RL_MVBUF_RADD_inst                                                           0x0024
+#define RL_MVBUF_RADD_MVBUF_read_address_shift                                       (0)
+#define RL_MVBUF_RADD_MVBUF_read_address_mask                                        (0x0000007F)
+#define RL_MVBUF_RADD_MVBUF_read_address(data)                                       (0x0000007F&((data)<<0))
+#define RL_MVBUF_RADD_MVBUF_read_address_src(data)                                   ((0x0000007F&(data))>>0)
+#define RL_MVBUF_RADD_get_MVBUF_read_address(data)                                   ((0x0000007F&(data))>>0)
+
+
+#define RL_MVBUF_STS0                                                                0x1800EC94
+#define RL_MVBUF_STS0_reg_addr                                                       "0xB800EC94"
+#define RL_MVBUF_STS0_reg                                                            0xB800EC94
+#define set_RL_MVBUF_STS0_reg(data)   (*((volatile unsigned int*) RL_MVBUF_STS0_reg)=data)
+#define get_RL_MVBUF_STS0_reg   (*((volatile unsigned int*) RL_MVBUF_STS0_reg))
+#define RL_MVBUF_STS0_inst_adr                                                       "0x0025"
+#define RL_MVBUF_STS0_inst                                                           0x0025
+#define RL_MVBUF_STS0_write_enable3_shift                                            (31)
+#define RL_MVBUF_STS0_write_enable3_mask                                             (0x80000000)
+#define RL_MVBUF_STS0_write_enable3(data)                                            (0x80000000&((data)<<31))
+#define RL_MVBUF_STS0_write_enable3_src(data)                                        ((0x80000000&(data))>>31)
+#define RL_MVBUF_STS0_get_write_enable3(data)                                        ((0x80000000&(data))>>31)
+#define RL_MVBUF_STS0_MVBUF_hdr_shift                                                (24)
+#define RL_MVBUF_STS0_MVBUF_hdr_mask                                                 (0x7F000000)
+#define RL_MVBUF_STS0_MVBUF_hdr(data)                                                (0x7F000000&((data)<<24))
+#define RL_MVBUF_STS0_MVBUF_hdr_src(data)                                            ((0x7F000000&(data))>>24)
+#define RL_MVBUF_STS0_get_MVBUF_hdr(data)                                            ((0x7F000000&(data))>>24)
+#define RL_MVBUF_STS0_write_enable2_shift                                            (20)
+#define RL_MVBUF_STS0_write_enable2_mask                                             (0x00100000)
+#define RL_MVBUF_STS0_write_enable2(data)                                            (0x00100000&((data)<<20))
+#define RL_MVBUF_STS0_write_enable2_src(data)                                        ((0x00100000&(data))>>20)
+#define RL_MVBUF_STS0_get_write_enable2(data)                                        ((0x00100000&(data))>>20)
+#define RL_MVBUF_STS0_MVBUF_pred_rptr_shift                                          (12)
+#define RL_MVBUF_STS0_MVBUF_pred_rptr_mask                                           (0x000FF000)
+#define RL_MVBUF_STS0_MVBUF_pred_rptr(data)                                          (0x000FF000&((data)<<12))
+#define RL_MVBUF_STS0_MVBUF_pred_rptr_src(data)                                      ((0x000FF000&(data))>>12)
+#define RL_MVBUF_STS0_get_MVBUF_pred_rptr(data)                                      ((0x000FF000&(data))>>12)
+#define RL_MVBUF_STS0_write_enable1_shift                                            (8)
+#define RL_MVBUF_STS0_write_enable1_mask                                             (0x00000100)
+#define RL_MVBUF_STS0_write_enable1(data)                                            (0x00000100&((data)<<8))
+#define RL_MVBUF_STS0_write_enable1_src(data)                                        ((0x00000100&(data))>>8)
+#define RL_MVBUF_STS0_get_write_enable1(data)                                        ((0x00000100&(data))>>8)
+#define RL_MVBUF_STS0_MVBUF_mvd_wptr_shift                                           (0)
+#define RL_MVBUF_STS0_MVBUF_mvd_wptr_mask                                            (0x000000FF)
+#define RL_MVBUF_STS0_MVBUF_mvd_wptr(data)                                           (0x000000FF&((data)<<0))
+#define RL_MVBUF_STS0_MVBUF_mvd_wptr_src(data)                                       ((0x000000FF&(data))>>0)
+#define RL_MVBUF_STS0_get_MVBUF_mvd_wptr(data)                                       ((0x000000FF&(data))>>0)
+
+
+#define RL_MVBUF_STS1                                                                0x1800EC98
+#define RL_MVBUF_STS1_reg_addr                                                       "0xB800EC98"
+#define RL_MVBUF_STS1_reg                                                            0xB800EC98
+#define set_RL_MVBUF_STS1_reg(data)   (*((volatile unsigned int*) RL_MVBUF_STS1_reg)=data)
+#define get_RL_MVBUF_STS1_reg   (*((volatile unsigned int*) RL_MVBUF_STS1_reg))
+#define RL_MVBUF_STS1_inst_adr                                                       "0x0026"
+#define RL_MVBUF_STS1_inst                                                           0x0026
+#define RL_MVBUF_STS1_write_enable1_shift                                            (8)
+#define RL_MVBUF_STS1_write_enable1_mask                                             (0x00000100)
+#define RL_MVBUF_STS1_write_enable1(data)                                            (0x00000100&((data)<<8))
+#define RL_MVBUF_STS1_write_enable1_src(data)                                        ((0x00000100&(data))>>8)
+#define RL_MVBUF_STS1_get_write_enable1(data)                                        ((0x00000100&(data))>>8)
+#define RL_MVBUF_STS1_MVBUF_rl_rptr_shift                                            (0)
+#define RL_MVBUF_STS1_MVBUF_rl_rptr_mask                                             (0x000000FF)
+#define RL_MVBUF_STS1_MVBUF_rl_rptr(data)                                            (0x000000FF&((data)<<0))
+#define RL_MVBUF_STS1_MVBUF_rl_rptr_src(data)                                        ((0x000000FF&(data))>>0)
+#define RL_MVBUF_STS1_get_MVBUF_rl_rptr(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define RL_CACHE_SET                                                                 0x1800EC9C
+#define RL_CACHE_SET_reg_addr                                                        "0xB800EC9C"
+#define RL_CACHE_SET_reg                                                             0xB800EC9C
+#define set_RL_CACHE_SET_reg(data)   (*((volatile unsigned int*) RL_CACHE_SET_reg)=data)
+#define get_RL_CACHE_SET_reg   (*((volatile unsigned int*) RL_CACHE_SET_reg))
+#define RL_CACHE_SET_inst_adr                                                        "0x0027"
+#define RL_CACHE_SET_inst                                                            0x0027
+#define RL_CACHE_SET_write_enable2_shift                                             (4)
+#define RL_CACHE_SET_write_enable2_mask                                              (0x00000010)
+#define RL_CACHE_SET_write_enable2(data)                                             (0x00000010&((data)<<4))
+#define RL_CACHE_SET_write_enable2_src(data)                                         ((0x00000010&(data))>>4)
+#define RL_CACHE_SET_get_write_enable2(data)                                         ((0x00000010&(data))>>4)
+#define RL_CACHE_SET_Vg_en_shift                                                     (2)
+#define RL_CACHE_SET_Vg_en_mask                                                      (0x0000000C)
+#define RL_CACHE_SET_Vg_en(data)                                                     (0x0000000C&((data)<<2))
+#define RL_CACHE_SET_Vg_en_src(data)                                                 ((0x0000000C&(data))>>2)
+#define RL_CACHE_SET_get_Vg_en(data)                                                 ((0x0000000C&(data))>>2)
+#define RL_CACHE_SET_write_enable1_shift                                             (1)
+#define RL_CACHE_SET_write_enable1_mask                                              (0x00000002)
+#define RL_CACHE_SET_write_enable1(data)                                             (0x00000002&((data)<<1))
+#define RL_CACHE_SET_write_enable1_src(data)                                         ((0x00000002&(data))>>1)
+#define RL_CACHE_SET_get_write_enable1(data)                                         ((0x00000002&(data))>>1)
+#define RL_CACHE_SET_Ref_pic_cnt_shift                                               (0)
+#define RL_CACHE_SET_Ref_pic_cnt_mask                                                (0x00000001)
+#define RL_CACHE_SET_Ref_pic_cnt(data)                                               (0x00000001&((data)<<0))
+#define RL_CACHE_SET_Ref_pic_cnt_src(data)                                           ((0x00000001&(data))>>0)
+#define RL_CACHE_SET_get_Ref_pic_cnt(data)                                           ((0x00000001&(data))>>0)
+
+
+#define RL_CACHE_EN                                                                  0x1800ECA0
+#define RL_CACHE_EN_reg_addr                                                         "0xB800ECA0"
+#define RL_CACHE_EN_reg                                                              0xB800ECA0
+#define set_RL_CACHE_EN_reg(data)   (*((volatile unsigned int*) RL_CACHE_EN_reg)=data)
+#define get_RL_CACHE_EN_reg   (*((volatile unsigned int*) RL_CACHE_EN_reg))
+#define RL_CACHE_EN_inst_adr                                                         "0x0028"
+#define RL_CACHE_EN_inst                                                             0x0028
+#define RL_CACHE_EN_Cah_en_shift                                                     (0)
+#define RL_CACHE_EN_Cah_en_mask                                                      (0x00000001)
+#define RL_CACHE_EN_Cah_en(data)                                                     (0x00000001&((data)<<0))
+#define RL_CACHE_EN_Cah_en_src(data)                                                 ((0x00000001&(data))>>0)
+#define RL_CACHE_EN_get_Cah_en(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define RL_CACHE_INV                                                                 0x1800ECA4
+#define RL_CACHE_INV_reg_addr                                                        "0xB800ECA4"
+#define RL_CACHE_INV_reg                                                             0xB800ECA4
+#define set_RL_CACHE_INV_reg(data)   (*((volatile unsigned int*) RL_CACHE_INV_reg)=data)
+#define get_RL_CACHE_INV_reg   (*((volatile unsigned int*) RL_CACHE_INV_reg))
+#define RL_CACHE_INV_inst_adr                                                        "0x0029"
+#define RL_CACHE_INV_inst                                                            0x0029
+#define RL_CACHE_INV_Cah_inv_shift                                                   (0)
+#define RL_CACHE_INV_Cah_inv_mask                                                    (0x00000001)
+#define RL_CACHE_INV_Cah_inv(data)                                                   (0x00000001&((data)<<0))
+#define RL_CACHE_INV_Cah_inv_src(data)                                               ((0x00000001&(data))>>0)
+#define RL_CACHE_INV_get_Cah_inv(data)                                               ((0x00000001&(data))>>0)
+
+
+#define RL_CAH_PINDX                                                                 0x1800ECA8
+#define RL_CAH_PINDX_reg_addr                                                        "0xB800ECA8"
+#define RL_CAH_PINDX_reg                                                             0xB800ECA8
+#define set_RL_CAH_PINDX_reg(data)   (*((volatile unsigned int*) RL_CAH_PINDX_reg)=data)
+#define get_RL_CAH_PINDX_reg   (*((volatile unsigned int*) RL_CAH_PINDX_reg))
+#define RL_CAH_PINDX_inst_adr                                                        "0x002A"
+#define RL_CAH_PINDX_inst                                                            0x002A
+#define RL_CAH_PINDX_Cah_pindx0_LumL0_shift                                          (24)
+#define RL_CAH_PINDX_Cah_pindx0_LumL0_mask                                           (0xFF000000)
+#define RL_CAH_PINDX_Cah_pindx0_LumL0(data)                                          (0xFF000000&((data)<<24))
+#define RL_CAH_PINDX_Cah_pindx0_LumL0_src(data)                                      ((0xFF000000&(data))>>24)
+#define RL_CAH_PINDX_get_Cah_pindx0_LumL0(data)                                      ((0xFF000000&(data))>>24)
+#define RL_CAH_PINDX_Cah_pindx1_LumL1_shift                                          (16)
+#define RL_CAH_PINDX_Cah_pindx1_LumL1_mask                                           (0x00FF0000)
+#define RL_CAH_PINDX_Cah_pindx1_LumL1(data)                                          (0x00FF0000&((data)<<16))
+#define RL_CAH_PINDX_Cah_pindx1_LumL1_src(data)                                      ((0x00FF0000&(data))>>16)
+#define RL_CAH_PINDX_get_Cah_pindx1_LumL1(data)                                      ((0x00FF0000&(data))>>16)
+#define RL_CAH_PINDX_Cah_pindx2_ChrL0_shift                                          (8)
+#define RL_CAH_PINDX_Cah_pindx2_ChrL0_mask                                           (0x0000FF00)
+#define RL_CAH_PINDX_Cah_pindx2_ChrL0(data)                                          (0x0000FF00&((data)<<8))
+#define RL_CAH_PINDX_Cah_pindx2_ChrL0_src(data)                                      ((0x0000FF00&(data))>>8)
+#define RL_CAH_PINDX_get_Cah_pindx2_ChrL0(data)                                      ((0x0000FF00&(data))>>8)
+#define RL_CAH_PINDX_Cah_pindx3_ChrL1_shift                                          (0)
+#define RL_CAH_PINDX_Cah_pindx3_ChrL1_mask                                           (0x000000FF)
+#define RL_CAH_PINDX_Cah_pindx3_ChrL1(data)                                          (0x000000FF&((data)<<0))
+#define RL_CAH_PINDX_Cah_pindx3_ChrL1_src(data)                                      ((0x000000FF&(data))>>0)
+#define RL_CAH_PINDX_get_Cah_pindx3_ChrL1(data)                                      ((0x000000FF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/rng_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/rng_reg.h
new file mode 100644
index 00000000..4e9021f
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/rng_reg.h
@@ -0,0 +1,464 @@
+/**************************************************************
+// Spec Version                  : unknown
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/8/8 16:36:29
+***************************************************************/
+
+
+#ifndef _RNG_REG_H_INCLUDED_
+#define _RNG_REG_H_INCLUDED_
+#ifdef  _RNG_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     lfsr_mode:1;
+unsigned int     lfsr_bypass_1:1;
+unsigned int     dbg1_sel:4;
+unsigned int     dbg0_sel:4;
+unsigned int     reserved_1:2;
+unsigned int     corrector_imode:1;
+unsigned int     reserved_2:1;
+unsigned int     rng_cali_srst:1;
+unsigned int     corrector_bypass:1;
+unsigned int     clk_hf_sel:1;
+unsigned int     rng_srst:1;
+}CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     rosc_d:4;
+unsigned int     rosc_res:2;
+unsigned int     rosc_div:2;
+unsigned int     rosc_gain:2;
+unsigned int     rosc_fs:2;
+unsigned int     reserved_1:2;
+unsigned int     rosc_test:1;
+unsigned int     rosc_pow:1;
+}ANALOG;
+
+typedef struct 
+{
+unsigned int     prd_ub:16;
+unsigned int     prd_lb:16;
+}CALI_CHK;
+
+typedef struct 
+{
+unsigned int     shot_num:12;
+unsigned int     cyc_num:3;
+unsigned int     wait_num:5;
+unsigned int     reserved_0:3;
+unsigned int     trig_num:5;
+unsigned int     lock:1;
+unsigned int     shot_mode:1;
+unsigned int     pol:1;
+unsigned int     hw_en:1;
+}CALI_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     hw_d:4;
+unsigned int     reserved_1:2;
+unsigned int     rosc_lock:1;
+unsigned int     cnt_ovflw:1;
+unsigned int     cnt:16;
+}CALI_RETURN;
+
+typedef struct 
+{
+unsigned int     prd_ub:16;
+unsigned int     prd_lb:16;
+}LOCK_CHK;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     exit_num:4;
+unsigned int     reserved_1:12;
+unsigned int     enter_num:4;
+}LOCK_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     out_ready:1;
+}RETURN3;
+
+typedef struct 
+{
+unsigned int     valid_bit_num:32;
+}RETURN4;
+
+typedef struct 
+{
+unsigned int     drop_num:32;
+}RETURN5;
+
+typedef struct 
+{
+unsigned int     random_out:32;
+}RESULTR;
+
+typedef struct 
+{
+unsigned int     lfsr_poly_lsb:32;
+}LFSR_POLY_LSB;
+
+typedef struct 
+{
+unsigned int     lfsr_poly_msb:32;
+}LFSR_POLY_MSB;
+
+typedef struct 
+{
+unsigned int     dummy_msb:16;
+unsigned int     dummy_lsb:16;
+}DUMMY;
+
+#endif
+
+#define CTRL                                                                         0x18001800
+#define CTRL_reg_addr                                                                "0xB8001800"
+#define CTRL_reg                                                                     0xB8001800
+#define set_CTRL_reg(data)   (*((volatile unsigned int*) CTRL_reg)=data)
+#define get_CTRL_reg   (*((volatile unsigned int*) CTRL_reg))
+#define CTRL_inst_adr                                                                "0x0000"
+#define CTRL_inst                                                                    0x0000
+#define CTRL_lfsr_mode_shift                                                         (17)
+#define CTRL_lfsr_mode_mask                                                          (0x00020000)
+#define CTRL_lfsr_mode(data)                                                         (0x00020000&((data)<<17))
+#define CTRL_lfsr_mode_src(data)                                                     ((0x00020000&(data))>>17)
+#define CTRL_get_lfsr_mode(data)                                                     ((0x00020000&(data))>>17)
+#define CTRL_lfsr_bypass_1_shift                                                     (16)
+#define CTRL_lfsr_bypass_1_mask                                                      (0x00010000)
+#define CTRL_lfsr_bypass_1(data)                                                     (0x00010000&((data)<<16))
+#define CTRL_lfsr_bypass_1_src(data)                                                 ((0x00010000&(data))>>16)
+#define CTRL_get_lfsr_bypass_1(data)                                                 ((0x00010000&(data))>>16)
+#define CTRL_dbg1_sel_shift                                                          (12)
+#define CTRL_dbg1_sel_mask                                                           (0x0000F000)
+#define CTRL_dbg1_sel(data)                                                          (0x0000F000&((data)<<12))
+#define CTRL_dbg1_sel_src(data)                                                      ((0x0000F000&(data))>>12)
+#define CTRL_get_dbg1_sel(data)                                                      ((0x0000F000&(data))>>12)
+#define CTRL_dbg0_sel_shift                                                          (8)
+#define CTRL_dbg0_sel_mask                                                           (0x00000F00)
+#define CTRL_dbg0_sel(data)                                                          (0x00000F00&((data)<<8))
+#define CTRL_dbg0_sel_src(data)                                                      ((0x00000F00&(data))>>8)
+#define CTRL_get_dbg0_sel(data)                                                      ((0x00000F00&(data))>>8)
+#define CTRL_corrector_imode_shift                                                   (5)
+#define CTRL_corrector_imode_mask                                                    (0x00000020)
+#define CTRL_corrector_imode(data)                                                   (0x00000020&((data)<<5))
+#define CTRL_corrector_imode_src(data)                                               ((0x00000020&(data))>>5)
+#define CTRL_get_corrector_imode(data)                                               ((0x00000020&(data))>>5)
+#define CTRL_rng_cali_srst_shift                                                     (3)
+#define CTRL_rng_cali_srst_mask                                                      (0x00000008)
+#define CTRL_rng_cali_srst(data)                                                     (0x00000008&((data)<<3))
+#define CTRL_rng_cali_srst_src(data)                                                 ((0x00000008&(data))>>3)
+#define CTRL_get_rng_cali_srst(data)                                                 ((0x00000008&(data))>>3)
+#define CTRL_corrector_bypass_shift                                                  (2)
+#define CTRL_corrector_bypass_mask                                                   (0x00000004)
+#define CTRL_corrector_bypass(data)                                                  (0x00000004&((data)<<2))
+#define CTRL_corrector_bypass_src(data)                                              ((0x00000004&(data))>>2)
+#define CTRL_get_corrector_bypass(data)                                              ((0x00000004&(data))>>2)
+#define CTRL_clk_hf_sel_shift                                                        (1)
+#define CTRL_clk_hf_sel_mask                                                         (0x00000002)
+#define CTRL_clk_hf_sel(data)                                                        (0x00000002&((data)<<1))
+#define CTRL_clk_hf_sel_src(data)                                                    ((0x00000002&(data))>>1)
+#define CTRL_get_clk_hf_sel(data)                                                    ((0x00000002&(data))>>1)
+#define CTRL_rng_srst_shift                                                          (0)
+#define CTRL_rng_srst_mask                                                           (0x00000001)
+#define CTRL_rng_srst(data)                                                          (0x00000001&((data)<<0))
+#define CTRL_rng_srst_src(data)                                                      ((0x00000001&(data))>>0)
+#define CTRL_get_rng_srst(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define ANALOG                                                                       0x18001814
+#define ANALOG_reg_addr                                                              "0xB8001814"
+#define ANALOG_reg                                                                   0xB8001814
+#define set_ANALOG_reg(data)   (*((volatile unsigned int*) ANALOG_reg)=data)
+#define get_ANALOG_reg   (*((volatile unsigned int*) ANALOG_reg))
+#define ANALOG_inst_adr                                                              "0x0005"
+#define ANALOG_inst                                                                  0x0005
+#define ANALOG_rosc_d_shift                                                          (12)
+#define ANALOG_rosc_d_mask                                                           (0x0000F000)
+#define ANALOG_rosc_d(data)                                                          (0x0000F000&((data)<<12))
+#define ANALOG_rosc_d_src(data)                                                      ((0x0000F000&(data))>>12)
+#define ANALOG_get_rosc_d(data)                                                      ((0x0000F000&(data))>>12)
+#define ANALOG_rosc_res_shift                                                        (10)
+#define ANALOG_rosc_res_mask                                                         (0x00000C00)
+#define ANALOG_rosc_res(data)                                                        (0x00000C00&((data)<<10))
+#define ANALOG_rosc_res_src(data)                                                    ((0x00000C00&(data))>>10)
+#define ANALOG_get_rosc_res(data)                                                    ((0x00000C00&(data))>>10)
+#define ANALOG_rosc_div_shift                                                        (8)
+#define ANALOG_rosc_div_mask                                                         (0x00000300)
+#define ANALOG_rosc_div(data)                                                        (0x00000300&((data)<<8))
+#define ANALOG_rosc_div_src(data)                                                    ((0x00000300&(data))>>8)
+#define ANALOG_get_rosc_div(data)                                                    ((0x00000300&(data))>>8)
+#define ANALOG_rosc_gain_shift                                                       (6)
+#define ANALOG_rosc_gain_mask                                                        (0x000000C0)
+#define ANALOG_rosc_gain(data)                                                       (0x000000C0&((data)<<6))
+#define ANALOG_rosc_gain_src(data)                                                   ((0x000000C0&(data))>>6)
+#define ANALOG_get_rosc_gain(data)                                                   ((0x000000C0&(data))>>6)
+#define ANALOG_rosc_fs_shift                                                         (4)
+#define ANALOG_rosc_fs_mask                                                          (0x00000030)
+#define ANALOG_rosc_fs(data)                                                         (0x00000030&((data)<<4))
+#define ANALOG_rosc_fs_src(data)                                                     ((0x00000030&(data))>>4)
+#define ANALOG_get_rosc_fs(data)                                                     ((0x00000030&(data))>>4)
+#define ANALOG_rosc_test_shift                                                       (1)
+#define ANALOG_rosc_test_mask                                                        (0x00000002)
+#define ANALOG_rosc_test(data)                                                       (0x00000002&((data)<<1))
+#define ANALOG_rosc_test_src(data)                                                   ((0x00000002&(data))>>1)
+#define ANALOG_get_rosc_test(data)                                                   ((0x00000002&(data))>>1)
+#define ANALOG_rosc_pow_shift                                                        (0)
+#define ANALOG_rosc_pow_mask                                                         (0x00000001)
+#define ANALOG_rosc_pow(data)                                                        (0x00000001&((data)<<0))
+#define ANALOG_rosc_pow_src(data)                                                    ((0x00000001&(data))>>0)
+#define ANALOG_get_rosc_pow(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define CALI_CHK                                                                     0x18001818
+#define CALI_CHK_reg_addr                                                            "0xB8001818"
+#define CALI_CHK_reg                                                                 0xB8001818
+#define set_CALI_CHK_reg(data)   (*((volatile unsigned int*) CALI_CHK_reg)=data)
+#define get_CALI_CHK_reg   (*((volatile unsigned int*) CALI_CHK_reg))
+#define CALI_CHK_inst_adr                                                            "0x0006"
+#define CALI_CHK_inst                                                                0x0006
+#define CALI_CHK_prd_ub_shift                                                        (16)
+#define CALI_CHK_prd_ub_mask                                                         (0xFFFF0000)
+#define CALI_CHK_prd_ub(data)                                                        (0xFFFF0000&((data)<<16))
+#define CALI_CHK_prd_ub_src(data)                                                    ((0xFFFF0000&(data))>>16)
+#define CALI_CHK_get_prd_ub(data)                                                    ((0xFFFF0000&(data))>>16)
+#define CALI_CHK_prd_lb_shift                                                        (0)
+#define CALI_CHK_prd_lb_mask                                                         (0x0000FFFF)
+#define CALI_CHK_prd_lb(data)                                                        (0x0000FFFF&((data)<<0))
+#define CALI_CHK_prd_lb_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define CALI_CHK_get_prd_lb(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define CALI_CTRL                                                                    0x1800181C
+#define CALI_CTRL_reg_addr                                                           "0xB800181C"
+#define CALI_CTRL_reg                                                                0xB800181C
+#define set_CALI_CTRL_reg(data)   (*((volatile unsigned int*) CALI_CTRL_reg)=data)
+#define get_CALI_CTRL_reg   (*((volatile unsigned int*) CALI_CTRL_reg))
+#define CALI_CTRL_inst_adr                                                           "0x0007"
+#define CALI_CTRL_inst                                                               0x0007
+#define CALI_CTRL_shot_num_shift                                                     (20)
+#define CALI_CTRL_shot_num_mask                                                      (0xFFF00000)
+#define CALI_CTRL_shot_num(data)                                                     (0xFFF00000&((data)<<20))
+#define CALI_CTRL_shot_num_src(data)                                                 ((0xFFF00000&(data))>>20)
+#define CALI_CTRL_get_shot_num(data)                                                 ((0xFFF00000&(data))>>20)
+#define CALI_CTRL_cyc_num_shift                                                      (17)
+#define CALI_CTRL_cyc_num_mask                                                       (0x000E0000)
+#define CALI_CTRL_cyc_num(data)                                                      (0x000E0000&((data)<<17))
+#define CALI_CTRL_cyc_num_src(data)                                                  ((0x000E0000&(data))>>17)
+#define CALI_CTRL_get_cyc_num(data)                                                  ((0x000E0000&(data))>>17)
+#define CALI_CTRL_wait_num_shift                                                     (12)
+#define CALI_CTRL_wait_num_mask                                                      (0x0001F000)
+#define CALI_CTRL_wait_num(data)                                                     (0x0001F000&((data)<<12))
+#define CALI_CTRL_wait_num_src(data)                                                 ((0x0001F000&(data))>>12)
+#define CALI_CTRL_get_wait_num(data)                                                 ((0x0001F000&(data))>>12)
+#define CALI_CTRL_trig_num_shift                                                     (4)
+#define CALI_CTRL_trig_num_mask                                                      (0x000001F0)
+#define CALI_CTRL_trig_num(data)                                                     (0x000001F0&((data)<<4))
+#define CALI_CTRL_trig_num_src(data)                                                 ((0x000001F0&(data))>>4)
+#define CALI_CTRL_get_trig_num(data)                                                 ((0x000001F0&(data))>>4)
+#define CALI_CTRL_lock_shift                                                         (3)
+#define CALI_CTRL_lock_mask                                                          (0x00000008)
+#define CALI_CTRL_lock(data)                                                         (0x00000008&((data)<<3))
+#define CALI_CTRL_lock_src(data)                                                     ((0x00000008&(data))>>3)
+#define CALI_CTRL_get_lock(data)                                                     ((0x00000008&(data))>>3)
+#define CALI_CTRL_shot_mode_shift                                                    (2)
+#define CALI_CTRL_shot_mode_mask                                                     (0x00000004)
+#define CALI_CTRL_shot_mode(data)                                                    (0x00000004&((data)<<2))
+#define CALI_CTRL_shot_mode_src(data)                                                ((0x00000004&(data))>>2)
+#define CALI_CTRL_get_shot_mode(data)                                                ((0x00000004&(data))>>2)
+#define CALI_CTRL_pol_shift                                                          (1)
+#define CALI_CTRL_pol_mask                                                           (0x00000002)
+#define CALI_CTRL_pol(data)                                                          (0x00000002&((data)<<1))
+#define CALI_CTRL_pol_src(data)                                                      ((0x00000002&(data))>>1)
+#define CALI_CTRL_get_pol(data)                                                      ((0x00000002&(data))>>1)
+#define CALI_CTRL_hw_en_shift                                                        (0)
+#define CALI_CTRL_hw_en_mask                                                         (0x00000001)
+#define CALI_CTRL_hw_en(data)                                                        (0x00000001&((data)<<0))
+#define CALI_CTRL_hw_en_src(data)                                                    ((0x00000001&(data))>>0)
+#define CALI_CTRL_get_hw_en(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define CALI_RETURN                                                                  0x18001820
+#define CALI_RETURN_reg_addr                                                         "0xB8001820"
+#define CALI_RETURN_reg                                                              0xB8001820
+#define set_CALI_RETURN_reg(data)   (*((volatile unsigned int*) CALI_RETURN_reg)=data)
+#define get_CALI_RETURN_reg   (*((volatile unsigned int*) CALI_RETURN_reg))
+#define CALI_RETURN_inst_adr                                                         "0x0008"
+#define CALI_RETURN_inst                                                             0x0008
+#define CALI_RETURN_hw_d_shift                                                       (20)
+#define CALI_RETURN_hw_d_mask                                                        (0x00F00000)
+#define CALI_RETURN_hw_d(data)                                                       (0x00F00000&((data)<<20))
+#define CALI_RETURN_hw_d_src(data)                                                   ((0x00F00000&(data))>>20)
+#define CALI_RETURN_get_hw_d(data)                                                   ((0x00F00000&(data))>>20)
+#define CALI_RETURN_rosc_lock_shift                                                  (17)
+#define CALI_RETURN_rosc_lock_mask                                                   (0x00020000)
+#define CALI_RETURN_rosc_lock(data)                                                  (0x00020000&((data)<<17))
+#define CALI_RETURN_rosc_lock_src(data)                                              ((0x00020000&(data))>>17)
+#define CALI_RETURN_get_rosc_lock(data)                                              ((0x00020000&(data))>>17)
+#define CALI_RETURN_cnt_ovflw_shift                                                  (16)
+#define CALI_RETURN_cnt_ovflw_mask                                                   (0x00010000)
+#define CALI_RETURN_cnt_ovflw(data)                                                  (0x00010000&((data)<<16))
+#define CALI_RETURN_cnt_ovflw_src(data)                                              ((0x00010000&(data))>>16)
+#define CALI_RETURN_get_cnt_ovflw(data)                                              ((0x00010000&(data))>>16)
+#define CALI_RETURN_cnt_shift                                                        (0)
+#define CALI_RETURN_cnt_mask                                                         (0x0000FFFF)
+#define CALI_RETURN_cnt(data)                                                        (0x0000FFFF&((data)<<0))
+#define CALI_RETURN_cnt_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define CALI_RETURN_get_cnt(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define LOCK_CHK                                                                     0x18001824
+#define LOCK_CHK_reg_addr                                                            "0xB8001824"
+#define LOCK_CHK_reg                                                                 0xB8001824
+#define set_LOCK_CHK_reg(data)   (*((volatile unsigned int*) LOCK_CHK_reg)=data)
+#define get_LOCK_CHK_reg   (*((volatile unsigned int*) LOCK_CHK_reg))
+#define LOCK_CHK_inst_adr                                                            "0x0009"
+#define LOCK_CHK_inst                                                                0x0009
+#define LOCK_CHK_prd_ub_shift                                                        (16)
+#define LOCK_CHK_prd_ub_mask                                                         (0xFFFF0000)
+#define LOCK_CHK_prd_ub(data)                                                        (0xFFFF0000&((data)<<16))
+#define LOCK_CHK_prd_ub_src(data)                                                    ((0xFFFF0000&(data))>>16)
+#define LOCK_CHK_get_prd_ub(data)                                                    ((0xFFFF0000&(data))>>16)
+#define LOCK_CHK_prd_lb_shift                                                        (0)
+#define LOCK_CHK_prd_lb_mask                                                         (0x0000FFFF)
+#define LOCK_CHK_prd_lb(data)                                                        (0x0000FFFF&((data)<<0))
+#define LOCK_CHK_prd_lb_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define LOCK_CHK_get_prd_lb(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define LOCK_CTRL                                                                    0x18001828
+#define LOCK_CTRL_reg_addr                                                           "0xB8001828"
+#define LOCK_CTRL_reg                                                                0xB8001828
+#define set_LOCK_CTRL_reg(data)   (*((volatile unsigned int*) LOCK_CTRL_reg)=data)
+#define get_LOCK_CTRL_reg   (*((volatile unsigned int*) LOCK_CTRL_reg))
+#define LOCK_CTRL_inst_adr                                                           "0x000A"
+#define LOCK_CTRL_inst                                                               0x000A
+#define LOCK_CTRL_exit_num_shift                                                     (16)
+#define LOCK_CTRL_exit_num_mask                                                      (0x000F0000)
+#define LOCK_CTRL_exit_num(data)                                                     (0x000F0000&((data)<<16))
+#define LOCK_CTRL_exit_num_src(data)                                                 ((0x000F0000&(data))>>16)
+#define LOCK_CTRL_get_exit_num(data)                                                 ((0x000F0000&(data))>>16)
+#define LOCK_CTRL_enter_num_shift                                                    (0)
+#define LOCK_CTRL_enter_num_mask                                                     (0x0000000F)
+#define LOCK_CTRL_enter_num(data)                                                    (0x0000000F&((data)<<0))
+#define LOCK_CTRL_enter_num_src(data)                                                ((0x0000000F&(data))>>0)
+#define LOCK_CTRL_get_enter_num(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define RETURN3                                                                      0x1800182C
+#define RETURN3_reg_addr                                                             "0xB800182C"
+#define RETURN3_reg                                                                  0xB800182C
+#define set_RETURN3_reg(data)   (*((volatile unsigned int*) RETURN3_reg)=data)
+#define get_RETURN3_reg   (*((volatile unsigned int*) RETURN3_reg))
+#define RETURN3_inst_adr                                                             "0x000B"
+#define RETURN3_inst                                                                 0x000B
+#define RETURN3_out_ready_shift                                                      (0)
+#define RETURN3_out_ready_mask                                                       (0x00000001)
+#define RETURN3_out_ready(data)                                                      (0x00000001&((data)<<0))
+#define RETURN3_out_ready_src(data)                                                  ((0x00000001&(data))>>0)
+#define RETURN3_get_out_ready(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define RETURN4                                                                      0x18001830
+#define RETURN4_reg_addr                                                             "0xB8001830"
+#define RETURN4_reg                                                                  0xB8001830
+#define set_RETURN4_reg(data)   (*((volatile unsigned int*) RETURN4_reg)=data)
+#define get_RETURN4_reg   (*((volatile unsigned int*) RETURN4_reg))
+#define RETURN4_inst_adr                                                             "0x000C"
+#define RETURN4_inst                                                                 0x000C
+#define RETURN4_valid_bit_num_shift                                                  (0)
+#define RETURN4_valid_bit_num_mask                                                   (0xFFFFFFFF)
+#define RETURN4_valid_bit_num(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define RETURN4_valid_bit_num_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define RETURN4_get_valid_bit_num(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define RETURN5                                                                      0x18001834
+#define RETURN5_reg_addr                                                             "0xB8001834"
+#define RETURN5_reg                                                                  0xB8001834
+#define set_RETURN5_reg(data)   (*((volatile unsigned int*) RETURN5_reg)=data)
+#define get_RETURN5_reg   (*((volatile unsigned int*) RETURN5_reg))
+#define RETURN5_inst_adr                                                             "0x000D"
+#define RETURN5_inst                                                                 0x000D
+#define RETURN5_drop_num_shift                                                       (0)
+#define RETURN5_drop_num_mask                                                        (0xFFFFFFFF)
+#define RETURN5_drop_num(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define RETURN5_drop_num_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define RETURN5_get_drop_num(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define RESULTR                                                                      0x18001838
+#define RESULTR_reg_addr                                                             "0xB8001838"
+#define RESULTR_reg                                                                  0xB8001838
+#define set_RESULTR_reg(data)   (*((volatile unsigned int*) RESULTR_reg)=data)
+#define get_RESULTR_reg   (*((volatile unsigned int*) RESULTR_reg))
+#define RESULTR_inst_adr                                                             "0x000E"
+#define RESULTR_inst                                                                 0x000E
+#define RESULTR_random_out_shift                                                     (0)
+#define RESULTR_random_out_mask                                                      (0xFFFFFFFF)
+#define RESULTR_random_out(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define RESULTR_random_out_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define RESULTR_get_random_out(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define LFSR_POLY_LSB                                                                0x1800183C
+#define LFSR_POLY_LSB_reg_addr                                                       "0xB800183C"
+#define LFSR_POLY_LSB_reg                                                            0xB800183C
+#define set_LFSR_POLY_LSB_reg(data)   (*((volatile unsigned int*) LFSR_POLY_LSB_reg)=data)
+#define get_LFSR_POLY_LSB_reg   (*((volatile unsigned int*) LFSR_POLY_LSB_reg))
+#define LFSR_POLY_LSB_inst_adr                                                       "0x000F"
+#define LFSR_POLY_LSB_inst                                                           0x000F
+#define LFSR_POLY_LSB_lfsr_poly_lsb_shift                                            (0)
+#define LFSR_POLY_LSB_lfsr_poly_lsb_mask                                             (0xFFFFFFFF)
+#define LFSR_POLY_LSB_lfsr_poly_lsb(data)                                            (0xFFFFFFFF&((data)<<0))
+#define LFSR_POLY_LSB_lfsr_poly_lsb_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define LFSR_POLY_LSB_get_lfsr_poly_lsb(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define LFSR_POLY_MSB                                                                0x18001840
+#define LFSR_POLY_MSB_reg_addr                                                       "0xB8001840"
+#define LFSR_POLY_MSB_reg                                                            0xB8001840
+#define set_LFSR_POLY_MSB_reg(data)   (*((volatile unsigned int*) LFSR_POLY_MSB_reg)=data)
+#define get_LFSR_POLY_MSB_reg   (*((volatile unsigned int*) LFSR_POLY_MSB_reg))
+#define LFSR_POLY_MSB_inst_adr                                                       "0x0010"
+#define LFSR_POLY_MSB_inst                                                           0x0010
+#define LFSR_POLY_MSB_lfsr_poly_msb_shift                                            (0)
+#define LFSR_POLY_MSB_lfsr_poly_msb_mask                                             (0xFFFFFFFF)
+#define LFSR_POLY_MSB_lfsr_poly_msb(data)                                            (0xFFFFFFFF&((data)<<0))
+#define LFSR_POLY_MSB_lfsr_poly_msb_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define LFSR_POLY_MSB_get_lfsr_poly_msb(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define DUMMY                                                                        0x18001844
+#define DUMMY_reg_addr                                                               "0xB8001844"
+#define DUMMY_reg                                                                    0xB8001844
+#define set_DUMMY_reg(data)   (*((volatile unsigned int*) DUMMY_reg)=data)
+#define get_DUMMY_reg   (*((volatile unsigned int*) DUMMY_reg))
+#define DUMMY_inst_adr                                                               "0x0011"
+#define DUMMY_inst                                                                   0x0011
+#define DUMMY_dummy_msb_shift                                                        (16)
+#define DUMMY_dummy_msb_mask                                                         (0xFFFF0000)
+#define DUMMY_dummy_msb(data)                                                        (0xFFFF0000&((data)<<16))
+#define DUMMY_dummy_msb_src(data)                                                    ((0xFFFF0000&(data))>>16)
+#define DUMMY_get_dummy_msb(data)                                                    ((0xFFFF0000&(data))>>16)
+#define DUMMY_dummy_lsb_shift                                                        (0)
+#define DUMMY_dummy_lsb_mask                                                         (0x0000FFFF)
+#define DUMMY_dummy_lsb(data)                                                        (0x0000FFFF&((data)<<0))
+#define DUMMY_dummy_lsb_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define DUMMY_get_dummy_lsb(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/rtd_2880.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/rtd_2880.h
new file mode 100644
index 00000000..578723d
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/rtd_2880.h
@@ -0,0 +1,924 @@
+
+/*=============================================================
+ * Copyright C        Realtek Semiconductor Corporation, 2004 *
+ * All rights reserved.                                       *
+ *============================================================*/
+
+/*======================= Description ========================*/
+/**
+ * @file
+ *   This header file for RTD2880's registers define.
+ * @Author Moya
+ * @date 2003/05/07
+ * @version { 1.0 }
+ *
+ */
+
+/*======================= CVS Headers =========================
+  $Header: /cvsroot/dtv/include/rtd_2880.h,v 1.46 2005/12/20 15:09:38 andy Exp $
+
+  $Log: rtd_2880.h,v $
+  Revision 1.46  2005/12/20 15:09:38  andy
+  *: Enable ROS UART output for default setup
+
+  Revision 1.45  2005/12/14 02:53:11  andy
+  +: add UART disable for ROS platform
+
+  Revision 1.44  2005/11/03 02:03:46  ray
+  add error recovery function
+
+  Revision 1.43  2005/10/28 09:33:45  ghyu
+  +: Add AVCPUMBCR define.
+
+  Revision 1.42  2005/10/26 06:55:00  frankcheng
+  add pcmaia reset pin
+
+  Revision 1.41  2005/10/26 06:53:41  frankcheng
+  add pcmaia reset pin
+
+  Revision 1.40  2005/10/25 06:59:51  ycchen
+  +: add PC_HW_RESET1 and PC_HW_RESET2 definition
+
+  Revision 1.39  2005/04/06 02:26:13  ghyu
+  +: Remark definition of RTD2880_NEW.
+
+  Revision 1.38  2005/03/23 01:53:55  andy
+  *: restore MVD IRQ control field definition
+
+  Revision 1.37  2005/03/22 14:07:15  andy
+  *: update MVD IRQ
+
+  Revision 1.36  2005/03/22 12:11:11  andy
+  *: update for Dual OS & new HW Timer
+
+  Revision 1.35  2005/03/17 01:12:21  temin
+  +: Add IH-specific interrupt enable/pending bits
+
+  Revision 1.34  2005/03/07 05:41:20  yoda
+  +: add lcd control interface definition
+
+  Revision 1.33  2005/01/19 06:47:04  andy
+  +: support New HW timer, ROS run on system RISC
+
+  Revision 1.32  2005/01/14 10:04:47  ghyu
+  *: Redefine CCICR1 for new FPGA.
+
+  Revision 1.31  2005/01/06 01:15:42  ghyu
+  +: Add memory control registers.
+
+  Revision 1.30  2005/01/03 06:54:59  yoda
+  modify gpio definition
+
+  Revision 1.29  2004/12/24 08:48:39  yoda
+  *: for pwm definition
+
+  Revision 1.28  2004/12/24 08:42:38  yoda
+  *:add something
+
+  Revision 1.27  2004/12/24 08:39:34  yoda
+  +: add mux control definition
+
+  Revision 1.26  2004/12/24 07:18:26  ghyu
+  +: Add WDTEST_EN definition.
+
+  Revision 1.25  2004/12/22 08:07:37  yoda
+  *: modify gpio definition
+
+  Revision 1.24  2004/12/13 02:45:01  timhuang
+  +:  Dispaly engine interrupt control field definitions
+
+  Revision 1.23  2004/12/08 11:57:46  ghyu
+  +: Add _SYSTEM_RISC and _RTD2880_NEW for new FPGA board.
+
+  Revision 1.22  2004/12/07 10:25:21  yoda
+  *:resolve conflict
+
+  Revision 1.21  2004/12/07 09:01:47  ghyu
+  +: Resolve conflict.
+
+  Revision 1.20  2004/12/07 08:52:12  ghyu
+  +: Add PCMCIA register.
+
+  Revision 1.16  2004/11/26 07:03:18  tzungder
+  +add definitions for PLL
+
+  Revision 1.15  2004/11/12 09:56:53  ghyu
+  +: PCMCIA's definition.
+
+  Revision 1.14  2004/11/10 03:25:37  ghyu
+  +: PCMCIA declaration.
+
+  Revision 1.13  2004/11/02 08:42:59  ghyu
+  +: Slave definition.
+
+  Revision 1.12  2004/10/27 03:20:01  tzungder
+  refine rtd_types.h definitions and apply to all
+
+  Revision 1.11  2004/10/26 05:17:48  ghyu
+  +: I2C slave regiesters.
+
+  Revision 1.10  2004/10/15 11:06:20  ghyu
+  +: Add I2C slave registers define.
+
+  Revision 1.9  2004/10/14 12:11:00  ghyu
+  :+ Add definition for I2C module.
+
+  Revision 1.8  2004/10/05 15:04:06  tzungder
+  flash ROS and boot OK
+
+  Revision 1.7  2004/08/27 09:04:59  yoda
+  add pwm definition
+
+  Revision 1.6  2004/08/20 02:16:07  yoda
+  add gpio definition
+
+  Revision 1.5  2004/08/16 05:19:59  ghyu
+  *** empty log message ***
+
+  Revision 1.4  2004/08/11 06:20:44  ghyu
+  	Add definition for ICR.
+
+  Revision 1.3  2004/08/09 04:24:53  tzungder
+  add defines for NIC
+
+  Revision 1.2  2004/08/06 05:05:43  ghyu
+  	Add interrupt registration and release function.
+
+  Revision 1.1  2004/08/05 08:29:05  ghyu
+  	This file for RTD2880 register declare.
+
+  Revision 1.1  2004/07/19 07:33:47  ghyu
+  Boot loader draw up.
+
+ *=============================================================*/
+
+#ifndef _RTD2880_H
+
+#define _RTD2880_H
+
+//#define UART_DISABLE_FOR_ROS_PLATFORM		// Disable UART for GDB server -- hyc 2005-12-13
+#ifdef CONFIG_UART_FOR_ROS
+  #warning "WARNING: ROS NO UART SUPPORT!!"
+#endif
+
+#ifdef CONFIG_SYS_14500
+#define CPU_CLOCK		(14500*1000)
+#endif
+
+#ifdef CONFIG_SYS_27000
+#define CPU_CLOCK		(27000*1000)
+#endif
+
+#ifdef CONFIG_SYS_162000
+#define CPU_CLOCK		(162000*1000)
+#endif
+
+#ifdef CONFIG_SYS_189000
+#define CPU_CLOCK       (189000*1000)
+#endif
+
+#ifdef CONFIG_SYS_202000
+#define CPU_CLOCK       (202000*1000)
+#endif
+
+
+#ifndef CPU_CLOCK
+#define CPU_CLOCK		(27000*1000)
+#endif
+
+
+#define BIT(x)	(1 << (x))
+
+#define UART0_BASE                          0xBD021000
+#define UART1_BASE                          0xBD021100
+
+#define rtd_inb(offset)		(*(volatile unsigned char *)( offset))
+#define rtd_inw(offset)	(*(volatile unsigned short *)(offset))
+#define rtd_inl(offset)		(*(volatile unsigned long *)(offset))
+
+#define rtd_outb(offset,val)	(*(volatile unsigned char *)(offset) = val)
+#define rtd_outw(offset,val)	(*(volatile unsigned short *)(offset) = val)
+#define rtd_outl(offset,val)		(*(volatile unsigned long *)(offset) = val)
+
+/// ****************************
+
+//For Memory Controller
+#if 0
+#define MC_BASE			0xbd010004
+#define MCMCR			(0x00 + MC_BASE) /*Memory Control Register*/
+#define MCDTCRVB			(0x04 + MC_BASE) /*DDR-RAM Timing Control Register - Video Bank*/
+#define MCDTCRSB			(0x08 + MC_BASE) /*DDR-RAM Timing Control Register - System Bank*/
+#define MCDICR0VB		(0x0C + MC_BASE) /*DDR-RAM Internal Control Register0 - Video Bank*/
+#define MCDICR1VB		(0x10 + MC_BASE) /*DDR-RAM Internal Control Register1 - Video Bank*/
+#define MCDICR0SB		(0x14 + MC_BASE) /*DDR-RAM Internal Control Register0 - System Bank*/
+#define MCDICR1SB		(0x18 + MC_BASE) /*DDR-RAM Internal Control Register1 - System Bank*/
+#define MCRTCR			(0x1C + MC_BASE) /*ROM Timing Control Register*/
+#define MCFSR				(0x20 + MC_BASE) /*Flash Status Register*/
+#endif
+
+
+#ifdef _RTD2880_NEW
+#define VBMC_BASE	0xbd010000
+#define MCMCRVB	(VBMC_BASE + 0x00)     // Memory Control Register - Video Bank
+#define MCDTCRVB	(VBMC_BASE + 0x04)     // DDR-RAM Timing Control Register - Video Bank
+#define MCDICR0VB	(VBMC_BASE + 0x08)     // DDR-RAM Internal Control Register 0 - Video Bank
+#define MCDICR1VB 	(VBMC_BASE + 0x0c)     // DDR-RAM Internal Control Register 1 - Video Bank
+#define MCVBACR1     	(VBMC_BASE + 0x10)     // Video Bus Arbitration Control Register 1
+#define DLLCRVB     	(VBMC_BASE + 0x14)     // DLL Control Register - Video Bank
+#define MCVBAMR1     (VBMC_BASE + 0x18)     // Video Bus Arbitration Monitor Register 1
+#define MCVBAMR2     (VBMC_BASE + 0x1c)     // Video Bus Arbitration Monitor Register 2
+#define MCVBCRCCR   (VBMC_BASE + 0x20)     // Video Bus CRC Control Register
+#define MCVBCRCOR   (VBMC_BASE + 0x24)     // Video Bus CRC Output Register
+#define MCVDMBCR    	(VBMC_BASE + 0x28)     // Video-DDR Controller Memory BIST Control Register
+#define MCVDMBSR    	(VBMC_BASE + 0x2c)     // Video-DDR Controller Memory BIST Status Register
+#define MCDBPRVB    	(VBMC_BASE + 0x30)     // DDR-RAM Best Phase Register - Video Bank
+
+#define LBMC_BASE	0xbd010100
+#define MCMCRSB      	(LBMC_BASE + 0x00)     // Memory Control Register - System Bank
+#define MCDTCRSB     (LBMC_BASE + 0x04)     // DDR-RAM Timing Control Register - System Bank
+#define MCDICR0SB    (LBMC_BASE + 0x08)     // DDR-RAM Internal Control Register 0 - System Bank
+#define MCDICR1SB    (LBMC_BASE + 0x0c)     // DDR-RAM Internal Control Register 1 - System Bank
+#define MCLBTCR        (LBMC_BASE + 0x10)     // Lexra Bus Timeout Control Register
+#define MCLBTSR        (LBMC_BASE + 0x14)     // Lexra Bus Timeout Status Register
+#define MCLBACR1      (LBMC_BASE + 0x18)     // Lexra Bus Arbitration Control Register 1
+#define MCLBACR2   	(LBMC_BASE + 0x1c)     // Lexra Bus Arbitration Control Register 2
+#define MCLBACR3      (LBMC_BASE + 0x20)     // Lexra Bus Arbitration Control Register 3
+#define MCLBAMR1     (LBMC_BASE + 0x24)     // Lexra Bus Arbitration Monitor Register 1
+#define MCLBAMR2     (LBMC_BASE + 0x28)     // Lexra Bus Arbitration Monitor Register 2
+#define MCLBAMR3     (LBMC_BASE + 0x2c)     // Lexra Bus Arbitration Monitor Register 3
+#define MCLBCRCCR   (LBMC_BASE + 0x30)     // Lexra Bus CRC Control Register
+#define MCLBCRCOR   (LBMC_BASE + 0x34)     // Lexra Bus CRC Output Register
+#define MCDBPRSB     (LBMC_BASE + 0x38)     // DDR-RAM Best Phase Register - System Bank
+#define MCBBCR         (LBMC_BASE + 0x3c)     // Bus Bridge Control Register
+#define MCBBMBCR     (LBMC_BASE + 0x40)     // Bus Bridge Memory BIST Control Register
+#define MCBBMBSR     (LBMC_BASE + 0x44)     // Bus Bridge Memory BIST Status Register
+#define DLLCRSB         (LBMC_BASE + 0x48)     // DLL Control Register - System Bank
+
+
+// For Video Bus Arbitration Control Register 1 (SCIU_MCVBACR1)
+/*#define VBMPCS		  ((UINT32)1 << 31)
+#define VBMVDMPC 	24
+#define VBDPMPC		16
+#define VBLB2VBBMPC	8
+#define VBDDRCMPC	0
+
+
+// For Lexra Bus Arbitration Control Register (SCIU_MCLBACR)
+#define LBMPCS		((UINT32)1 << 31)
+#define LBMCPUMPC	24
+#define LBAVCPUMPC	16
+#define LBNANDMPC	8
+#define LBAVDMAMPC	0
+#define LBDPMPC		24
+#define LBMVDMPC	16
+#define LBTPMPC		8
+#define LBAIMPC		0
+#define LBPCIMPC	0*/
+
+
+#endif
+
+// For Video Bus Arbitration Control Register 1 (SCIU_MCVBACR1)
+#define VBMPCS		  ((UINT32)1 << 31)
+#define VBMVDMPC 	24
+#define VBDPMPC		16
+#define VBLB2VBBMPC	8
+#define VBDDRCMPC	0
+
+
+// For Lexra Bus Arbitration Control Register (SCIU_MCLBACR)
+#define LBMPCS		((UINT32)1 << 31)
+#define LBMCPUMPC	24
+#define LBAVCPUMPC	16
+#define LBNANDMPC	8
+#define LBAVDMAMPC	0
+#define LBDPMPC		24
+#define LBMVDMPC	16
+#define LBTPMPC		8
+#define LBAIMPC		0
+#define LBPCIMPC	0
+
+#define MC_BASE      	0xBD010000
+// For Flash
+#define MCRTCR		(MC_BASE + 0x04)  // ROM Timing Control Register
+#define MCFSR		(MC_BASE + 0x24) // Flash Status Register
+
+
+
+#define AVCPUMBCR  	MC_BASE+0x1130
+#define AVCPUMBSR  	MC_BASE+0x1134
+#define AVCPUDMAMBCR  	MC_BASE+0x1150
+#define AVCPUDMAMBSR  	MC_BASE+0x1154
+// For BUS_MASTER
+
+#ifndef _LINUX_CONFIG_H
+
+#define UART_RBR    0x00    //Chuck add this for bootcode on 20060109
+#define UART_THR	0x00
+#define UART_DLL	0x00
+#define UART_DLM	0x04
+#define UART_FCR	0x08
+#define UART_LCR	0x0C
+#define UART_MCR	0x10
+#define UART_LSR	0x14	//Chuck add this for bootcode on 20060109
+#define UART_MSR	0x18
+#define UART_SCR	0x1C
+
+#endif
+
+/* Global interrupt control registers */
+
+#define GICR_BASE                           0xBD011000
+
+#ifdef _SYSTEM_RISC
+#define GICR                                (0x010 + GICR_BASE)       /* Global interrupt mask */
+#define GISR                                (0x014 + GICR_BASE)       /* Global interrupt status */
+#define IRR0R0                              (0x018 + GICR_BASE)       /* Interrupt routing 0 - RISC 0 */
+#define IRR1R0                              (0x01C + GICR_BASE)       /* Interrupt routing 1 - RISC 0 */
+#define GISR1                                (0x004 + GICR_BASE)       /* Global interrupt status */
+#define CCICR1                              (0x020 + GICR_BASE)       /* CPU Communication Interrupt Control Register - RISC 0 */
+#define CCICR0                              (0x024 + GICR_BASE)       /* CPU Communication Interrupt Control Register - RISC 1 */
+#define CNL_UART 	UART0_BASE //tdl for dual CPU booting test
+#define GDB_UART 	UART0_BASE
+#else
+#define GICR                                (0x000 + GICR_BASE)       /* Global interrupt mask */
+#define GISR                                (0x004 + GICR_BASE)       /* Global interrupt status */
+#define IRR0R0                              (0x008 + GICR_BASE)       /* Interrupt routing 0 - RISC 0 */
+#define IRR1R0                              (0x00C + GICR_BASE)       /* Interrupt routing 1 - RISC 0 */
+#define GISR1                                (0x014 + GICR_BASE)       /* Global interrupt status */
+#define CCICR0                              (0x020 + GICR_BASE)       /* CPU Communication Interrupt Control Register - RISC 0 */
+#define CCICR1                              (0x024 + GICR_BASE)       /* CPU Communication Interrupt Control Register - RISC 1 */
+#define CNL_UART 	UART1_BASE //tdl for dual CPU booting test
+#define GDB_UART 	UART1_BASE
+#endif
+
+#define IRR0R1                              (0x018 + GICR_BASE)       /* Interrupt routing 0 - RISC 1 */
+#define IRR1R1                              (0x01C + GICR_BASE)       /* Interrupt routing 1 - RISC 1 */
+
+#define ENRR0                               (0x028 + GICR_BASE)       /* RISC 0 Enable Register */
+#define EXVORR0                             (0x02C + GICR_BASE)       /* RISC 0 Exception Vector Offset Register */
+
+/* Global interrupt mask register field definitions
+*/
+#define TC01IE                              ((UINT32)1 << 31)       /* Timers/Counters 0 & 1 interrupt enable */
+#define TC23IE                              (1 << 30)       /* Timers/Counters 2 & 3 interrupt enable */
+#define UART0IE                             (1 << 29)       /* UART 0 interrupt enable */
+#define UART1IE                             (1 << 28)       /* UART 1 interrupt enable */
+#define I2C0IE                               (1 << 27)       /* I2C interrupt enable */
+#define I2C1IE                               (1 << 26)       /* I2C interrupt enable */
+#define I2C2IE                               (1 << 25)       /* I2C interrupt enable */
+#define I2CSIE                               (1 << 24)       /* PWM interrupt enable */
+#define SMC0IE                              (1 << 23)       /* Smartcard 0 interrupt enable */
+#define SMC1IE                              (1 << 22)       /* Smartcard 1 interrupt enable */
+#define GPIOAIE                             (1 << 21)       /* GPIO port A interrupt enable */
+#define GPIOBIE                             (1 << 20)       /* GPIO port B interrupt enable */
+#define GPIOCIE                             (1 << 19)       /* GPIO port C interrupt enable */
+#define GPIODIE                             (1 << 18)       /* GPIO port D interrupt enable */
+#define GPIOEIE                             (1 << 17)       /* GPIO port E interrupt enable */
+#define GPIOFIE                             (1 << 16)       /* GPIO port F interrupt enable */
+#define GPIOGIE                             (1 << 15)       /* GPIO port G interrupt enable */
+#define GPIOHIE                             (1 << 14)       /* GPIO port H interrupt enable */
+#define TPIE                                   (1 << 13)       /* Transport Parser interrupt enable */
+#define MVDIE                                (1 << 12)       /* MVD interrupt enable */
+#define AUDIOIE                             (1 << 11)       /* Audio interrupt enable */
+#define DEIE                                   (1 << 10)       /* Display Engine interrupt enable */
+#define TVEIE                                 (1 << 9)       /* TV encooder interrupt enable */
+#define PCMIE                               	(1 << 8)       /* PCMCIA interrupt enable */
+#define DMAIE                                (1 << 7)       /* DMA interrupt enable */
+#define GEIE                                  	(1 << 6)       /* Graphic engine interrupt enable */
+#define OSDIE                                	(1 << 5)       /* OSD interrupt enable */
+#define ROMRRIE                           (1 << 4)       /* ROM read operation ready interrupt enable */
+#define IRIE                               	(1 << 3)       /* IrDA interrupt enable */
+#define LBCTMOIE                          (1 << 2)       /* Lexra Bus Timeout Interrupt Enable */
+#define IRC1IE                            	(1 << 1)       /* IRC1 Interrupt Enable (Interrupt from RISC1) */
+#define IHIE                  			(1 << 0)       /* IH Interrupt Enable */
+
+/* Global interrupt status register field definitions */
+
+#define TC01IP                              ((UINT32)1 << 31)       /* Timers/Counters 0 & 1 interrupt pending */
+#define TC23IP                              (1 << 30)       /* Timers/Counters 2 & 3 interrupt pending */
+#define UART0IP                             (1 << 29)       /* UART 0 interrupt pending */
+#define UART1IP                             (1 << 28)       /* UART 1 interrupt pending */
+#define I2C0IP                               (1 << 27)       /* I2C interrupt pending */
+#define I2C1IP                               (1 << 26)       /* I2C interrupt pending */
+#define I2C2IP                               (1 << 25)       /* I2C interrupt pending */
+#define I2CSIP                               (1 << 24)       /* PWM interrupt pending */
+#define SMC0IP                              (1 << 23)       /* Smartcard 0 interrupt pending */
+#define SMC1IP                              (1 << 22)       /* Smartcard 1 interrupt pending */
+#define GPIOAIP                             (1 << 21)       /* GPIO port A interrupt pending */
+#define GPIOBIP                             (1 << 20)       /* GPIO port B interrupt pending */
+#define GPIOCIP                             (1 << 19)       /* GPIO port C interrupt pending */
+#define GPIODIP                             (1 << 18)       /* GPIO port D interrupt pending */
+#define GPIOEIP                             (1 << 17)       /* GPIO port E interrupt pending */
+#define GPIOFIP                             (1 << 16)       /* GPIO port F interrupt pending */
+#define GPIOGIP                             (1 << 15)       /* GPIO port G interrupt pending */
+#define GPIOHIP                             (1 << 14)       /* GPIO port H interrupt pending */
+#define TPIP                                	(1 << 13)       /* Transport Parser interrupt pending */
+#define MVDIP                               	(1 << 12)       /* MVD interrupt pending */
+#define AUDIOIP                           	(1 << 11)       /* Audio interrupt pending */
+#define DEIP                                	(1 << 10)       /* Display Engine interrupt pending */
+#define TVEIP                               	(1 << 9)       /* TV encooder interrupt pending */
+#define PCMIP                               	(1 << 8)       /* PCMCIA interrupt pending */
+#define DMAIP                                (1 << 7)       /* DMA interrupt pending */
+#define GEIP                                 	(1 << 6)       /* Graphic engine interrupt pending */
+#define OSDIP                                (1 << 5)       /* OSD interrupt pending */
+#define ROMRRIP                           (1 << 4)       /* ROM read operation ready interrupt pending */
+#define IRIP                               	(1 << 3)       /* IrDA interrupt pending */
+#define LBCTMOIP                          (1 << 2)       /* Lexra Bus Timeout Interrupt pending */
+#define IRC1IP                  (UINT32) (1 << 1)       /* IRC1 Interrupt pending (Interrupt from RISC1) */
+#define IHIP                  			(1 << 0)       /* IH Interrupt pending */
+
+/* Interrupt routing register 0 - RISC0 field definitions */
+#define TCIE01IRS_OFFSET               30            /* Timers/Counters 0 & 1 interrupt Route Select Offset */
+#define TCIE23IRS_OFFSET               28            /* Timers/Counters 2 & 3 interrupt Route Select Offset */
+#define UART0IRS_OFFSET                26            /* UART 0 interrupt Route Select Offset */
+#define UART1IRS_OFFSET                24            /* UART 1 interrupt Route Select Offset */
+#define I2C0IRS_OFFSET                   22            /* I2C0 interrupt Route Select Offset */
+#define I2C1IRS_OFFSET                   20            /* I2C1 interrupt Route Select Offset */
+#define I2C2IRS_OFFSET                   18            /* I2C2 interrupt Route Select Offset */
+#define I2CSIRS_OFFSET                  16            /* PWM interrupt Route Select Offset */
+#define SMC0IRS_OFFSET                  14            /* Smartcard 0 interrupt Route Select Offset */
+#define SMC1IRS_OFFSET                  12            /* Smartcard 1 interrupt Route Select Offset */
+#define GPIOAIRS_OFFSET                 10            /* GPIO port A interrupt Route Select Offset */
+#define GPIOBIRS_OFFSET                  8            /* GPIO port B interrupt Route Select Offset */
+#define GPIOCIRS_OFFSET                  6            /* GPIO port C interrupt Route Select Offset */
+#define GPIODIRS_OFFSET                  4            /* GPIO port D interrupt Route Select Offset */
+#define GPIOEIRS_OFFSET                   2            /* GPIO port E interrupt Route Select Offset */
+#define GPIOFIRS_OFFSET                    0            /* GPIO port F interrupt Route Select Offset */
+
+
+/* Interrupt routing register 1 - RISC0 field definitions */
+#define GPIOGIRS_OFFSET           	30            /* GPIO port G interrupt Route Select Offset */
+#define GPIOHIRS_OFFSET             28            /* GPIO port H interrupt Route Select Offset */
+#define TPIRS_OFFSET                  	26            /* Transport Parser interrupt Route Select Offset */
+#define MVDIRS_OFFSET                	24            /* MVD interrupt Route Select Offset */
+#define AUDIOIRS_OFFSET           	22            /* Audio interrupt Route Select Offset */
+#define DEIRS_OFFSET                  	20            /* Display Engine interrupt Route Select Offset */
+#define TVEIRS_OFFSET                	18            /* TV encooder interrupt Route Select Offset */
+#define PCMIRS_OFFSET                	16            /* PCMCIA interrupt Route Select Offset */
+#define DMAIRS_OFFSET            	14		  /* DMA interrupt pending */
+#define GEIRS_OFFSET                  	12            /* Graphic engine interrupt pending */
+#define OSDIRS_OFFSET                	10            /* OSD interrupt pending */
+#define ROMRRIRS_OFFSET          	8		  /* ROM read operation ready interrupt pending */
+#define IRIRS_OFFSET                  	6	         /* IrDA interrupt pending */
+#define LBCTMOIRS_OFFSET        	4              /* Lexra Bus Timeout Interrupt pending */
+//#define IRC1IRS_OFFSET               	2		   /* IRC1 Interrupt pending (Interrupt from RISC1) */
+#define IHIRS_OFFSET               	0		   /* Interface handler Interrupt pending */
+
+#define I2C_IRQ1(x)             I2C_IRQ##x
+#define I2C_IRQ(x)               I2C_IRQ1(x)
+#define I2C_IRQ3                 0
+#define I2C_IRQ4                 1
+#define I2C_IRQ8                 2
+#define I2C_IRQ9                 3
+
+#define I2CS_IRQ1(x)             I2CS_IRQ##x
+#define I2CS_IRQ(x)               I2CS_IRQ1(x)
+#define I2CS_IRQ4                 0
+#define I2CS_IRQ5                 1
+#define I2CS_IRQ10               2
+#define I2CS_IRQ11               3
+
+#define TIMER01_IRQ1(x)        	TIMER01_IRQ##x
+#define TIMER01_IRQ(x)        		TIMER01_IRQ1(x)
+#define TIMER01_IRQ3                 0
+#define TIMER01_IRQ4                 1
+#define TIMER01_IRQ8                 2
+#define TIMER01_IRQ9                 3
+
+#define PCM_IRQ1(x)      		PCM_IRQ##x
+#define PCM_IRQ(x)        		PCM_IRQ1(x)
+#define PCM_IRQ6			0
+#define PCM_IRQ7			1
+#define PCM_IRQ12			2
+#define PCM_IRQ13			3
+
+#define LBTO_IRQ1(x)      		LBTO_IRQ##x
+#define LBTO_IRQ(x)        		LBTO_IRQ1(x)
+#define LBTO_IRQ6			0
+#define LBTO_IRQ7			1
+#define LBTO_IRQ14			2
+#define LBTO_IRQ15			3
+
+#define UART01_IRQ1(x)        		UART01_IRQ##x
+#define UART01_IRQ(x)        		UART01_IRQ1(x)
+#define UART01_IRQ3			0
+#define UART01_IRQ4			1
+#define UART01_IRQ8			2
+#define UART01_IRQ9			3
+
+/* Dispaly engine interrupt control field definitions
+ * */
+#define DE_IRQ(x)                               DE_##x
+#define DE_IRQ4                                 (0)
+#define DE_IRQ5                                 (1)
+#define DE_IRQ12                                (2)
+#define DE_IRQ13                                (3)
+
+#define IH_IRQ(x)                               IH_##x
+#define IH_IRQ6                                 (0)
+#define IH_IRQ7                                 (1)
+#define IH_IRQ14                                (2)
+#define IH_IRQ15                                (3)
+
+#define MVD_IRQ(x)                              MVD_##x
+#define MVD_IRQ4                                (0)
+#define MVD_IRQ5                                (1)
+#define MVD_IRQ10                               (2)
+#define MVD_IRQ11                               (3)
+
+// For I2C interface
+#define G_I2CBASE            0xBD022000
+#define I2CCR                   (0x000 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMCR0                 (0x020 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMSTR0                (0x024 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMSR0                 (0x028 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMFR0                 (0x02c + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMCR1                 (0x040 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMSTR1                (0x044 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMSR1                 (0x048 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMFR1                 (0x04c + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMCR2                 (0x060 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMSTR2                (0x064 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMSR2                 (0x068 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CMFR2                 (0x06c + G_I2CBASE)       /* I2C Clock Register */
+#define I2CSRR                  (0x080 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CSCR                  (0x084 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CSSAR                 (0x088 + G_I2CBASE)       /* I2C Clock Register */
+#define I2CSDFR                 (0x08c + G_I2CBASE)       /* I2C Clock Register */
+
+#define I2CS_ID_OFFSET		7
+#define I2CS_RESET			(1<<2)
+#define I2CS_RCDRIE			(1<<1)
+#define I2CS_WCDRIE			(1<<0)
+#define I2CS_RCDRIF			(1<<1)
+#define I2CS_WCDRIF			(1<<0)
+#define I2CS_CDIB			(1<<7)
+#define I2CS_CT_WRITE             (1 << 6)
+#define I2CS_CT_READ             (0 << 6)
+#define I2CS_RL_OFF           	2
+
+
+#define I2C_RESET                     (UINT32) (1<<31)       /* Transaction complete pending bit */
+#define I2C_TEIF                        (1<<2)       /* Transaction error pending bit */
+#define I2C_RCIF                        (1<<1)       /* Receive complete pending bit */
+#define I2C_TCIF                        (1<<0)       /* Transaction complete pending bit */
+#define I2CSCR_OFFS                0x1             /* I2C slave regisger offset */
+#define I2CSSAR_OFFS                0x2             /* I2C slave regisger offset */
+#define I2CSDFR_OFFS                0x3             /* I2C slave regisger offset */
+
+
+// For PCMCIA interface
+
+#ifndef _RTD2880_NEW
+#define GICR_PCBASE                         0xBD010300
+#else
+#define GICR_PCBASE                         0xBD010700
+#endif
+
+#define PC_PCFR  	(0x000 + GICR_PCBASE)
+#define PC_PCR   	(0x004 + GICR_PCBASE)
+#define PC_PSR   		(0x008 + GICR_PCBASE)
+#define PC_PAMTCR   	(0x00c + GICR_PCBASE)
+#define PC_PIMTCR   	(0x010 + GICR_PCBASE)
+#define PC_PMATCR   	(0x014 + GICR_PCBASE)
+
+#define PC_PSRESET  	((UINT32)1 << 31)  //!< PCMCIA software reset
+#define PC_CS2 	  	(1 << 30)  //!< PCMCIA chip select 2 enable
+#define PC_CS3 	  	(1 << 29)  //!< PCMCIA chip select 3 enable
+#define PC_CS5 	  	(1 << 28)  //!< PCMCIA chip select 5 enable
+#define PC_CS6	  	(1 << 27)  //!< PCMCIA chip select 6 enable
+
+//Chuck add this definition on 20051025
+#define PC_HW_RESET1	(1 << 26)	//!< PCMCIA card 1 reset
+#define PC_HW_RESET2	(1 << 25)	//!< PCMCIA card 2 reset
+
+#define PC_CT_READ 		(0 << 24)  //!< PCMCIA read command tyep
+#define PC_CT_WRITE 	(1 << 24)  //!< PCMCIA write command tyep
+#define PC_AT_IO_DRFR	0xfefe 	  //!< Access type as IO access & waiting DRFR interrupt
+#define PC_AT_IO 		(0 << 23)  //!< Access type as IO access
+#define PC_AT_ATTR 		(1 << 23)  //!< Access type as Attribute memory
+#define PC_PA_OFFSET		8	  //!< PCMCIA address's offset
+
+#define PC_PRES1	(1 << 9)	  //!< PCMCIA card 1 present bit
+#define PC_PRES2	(1 << 8)	  //!< PCMCIA card 2 present bit
+#define PC_PII1		(1 << 7)	  //!< PCMCIA card 1 IRQ1# interrupt
+#define PC_PCII1		(1 << 6)	  //!< PCMCIA card 1 insert interrupt
+#define PC_PCRI1	(1 << 5)	  //!< PCMCIA card 1 remove interrupt
+#define PC_PII2		(1 << 4)	  //!< PCMCIA card 2 IRQ2# interrupt
+#define PC_PCII2		(1 << 3)	  //!< PCMCIA card 2 insert interrupt
+#define PC_PCRI2	(1 << 2)	  //!< PCMCIA card 2 remove interrupt
+#define PC_AFI		(1 << 1)	  //!< PCMCIA address fault interrupt
+#define PC_APFI		(1 << 0)	  //!< PCMCIA address pending flag interrupt
+
+// For General Purpose Timer/Counter
+
+#ifndef _RTD2880_NEW
+#define GICR_TCBASE                         0xBD012000
+#else
+#define GICR_TCBASE                         0xBD010400
+#endif
+
+/* Timer/Counter data register field definitions
+*/
+#define TCD_OFFSET                          8
+
+/* Timer control registers
+*/
+#define TC0DATA                             (0x000 + GICR_TCBASE)       /* Timer/Counter 0 data */
+#define TC0CNT                              (0x004 + GICR_TCBASE)       /* Timer/Counter 0 count */
+#define TC1DATA                             (0x008 + GICR_TCBASE)       /* Timer/Counter 1 data */
+#define TC1CNT                              (0x00C + GICR_TCBASE)       /* Timer/Counter 1 count */
+#define TC2DATA                             (0x010 + GICR_TCBASE)       /* Timer/Counter 2 data */
+#define TC2CNT                              (0x014 + GICR_TCBASE)       /* Timer/Counter 2 count */
+#define TC3DATA                             (0x018 + GICR_TCBASE)       /* Timer/Counter 3 data */
+#define TC3CNT                              (0x01C + GICR_TCBASE)       /* Timer/Counter 3 count */
+
+
+#define TCCNR01                             (0x040 + GICR_TCBASE)       /* Timer/Counter control - Timer 0 & 1 */
+#define TCCNR23                             (0x044 + GICR_TCBASE)       /* Timer/Counter control - Timer 2 & 3 */
+#define TCICR01                             (0x050 + GICR_TCBASE)       /* Timer/Counter intertupt - Timer 0 & 1 */
+#define TCICR23                             (0x054 + GICR_TCBASE)       /* Timer/Counter intertupt - Timer 2 & 3 */
+#define TCCDBR01                            (0x060 + GICR_TCBASE)       /* Clock division base - Timer 0 & 1 */
+#define TCCDBR23                            (0x064 + GICR_TCBASE)       /* Clock division base - Timer 2 & 3 */
+#define TCWCR                               (0x70 + GICR_TCBASE)       /* Watchdog timer control */
+#define TCWTR                            (0x074 + GICR_TCBASE)       /* Watchdog Trigger  Register */
+#define TCWMR                              (0x78 + GICR_TCBASE)       /* Watchdog timer control */
+
+#ifndef _RTD2880_NEW
+
+#else
+#define TCWDMR                              (0x078 + GICR_TCBASE)       /* Watchdog Monitor Register */
+#endif
+
+#define TC4DATA                             (0x020 + GICR_TCBASE)       /* Timer/Counter 0 data */
+#define TC4CNT                              (0x024 + GICR_TCBASE)       /* Timer/Counter 0 count */
+#define TC5DATA                             (0x028 + GICR_TCBASE)       /* Timer/Counter 1 data */
+#define TC5CNT                              (0x02C + GICR_TCBASE)       /* Timer/Counter 1 count */
+#define TC6DATA                             (0x030 + GICR_TCBASE)       /* Timer/Counter 2 data */
+#define TC6CNT                              (0x034 + GICR_TCBASE)       /* Timer/Counter 2 count */
+#define TC7DATA                             (0x038 + GICR_TCBASE)       /* Timer/Counter 3 data */
+#define TC7CNT                              (0x03C + GICR_TCBASE)       /* Timer/Counter 3 count */
+
+#define TCCNR45                             (0x048 + GICR_TCBASE)       /* Timer/Counter control - Timer 0 & 1 */
+#define TCCNR67                             (0x04c + GICR_TCBASE)       /* Timer/Counter control - Timer 2 & 3 */
+#define TCICR45                             (0x058 + GICR_TCBASE)       /* Timer/Counter intertupt - Timer 0 & 1 */
+#define TCICR67                             (0x05c + GICR_TCBASE)       /* Timer/Counter intertupt - Timer 2 & 3 */
+#define TCCDBR45                            (0x068 + GICR_TCBASE)       /* Clock division base - Timer 0 & 1 */
+#define TCCDBR67                            (0x06c + GICR_TCBASE)       /* Clock division base - Timer 2 & 3 */
+
+
+/* Timer/Counter control register field defintions
+*/
+#define TC0EN                               ((UINT32)1 << 31)       /* Timer/Counter 0 enable */
+#define TC0MODE_COUNTER                     0               /* Timer/Counter 0 counter mode */
+#define TC0MODE_TIMER                       (1 << 30)       /* Timer/Counter 0 timer mode */
+#define TC1EN                               (1 << 29)       /* Timer/Counter 1 enable */
+#define TC1MODE_COUNTER                     0               /* Timer/Counter 1 counter mode */
+#define TC1MODE_TIMER                       (1 << 28)       /* Timer/Counter 1 timer mode */
+#define TC2EN                               ((UINT32)1 << 31)       /* Timer/Counter 2 enable */
+#define TC2MODE_COUNTER                     0               /* Timer/Counter 2 counter mode */
+#define TC2MODE_TIMER                       (1 << 30)       /* Timer/Counter 2 timer mode */
+#define TC3EN                               (1 << 29)       /* Timer/Counter 3 enable */
+#define TC3MODE_COUNTER                     0               /* Timer/Counter 3 counter mode */
+#define TC3MODE_TIMER                       (1 << 28)       /* Timer/Counter 3 timer mode */
+/* Timer/Counter interrupt register field definitions
+*/
+#define TC0IE                               ((UINT32)1 << 31)       /* Timer/Counter 0 interrupt enable */
+#define TC1IE                               (1 << 30)       /* Timer/Counter 1 interrupt enable */
+#define TC0IP                               (1 << 29)       /* Timer/Counter 0 interrupt pending */
+#define TC1IP                               (1 << 28)       /* Timer/Counter 1 interrupt pending */
+#define TC2IE                               ((UINT32)1 << 31)       /* Timer/Counter 2 interrupt enable */
+#define TC3IE                               (1 << 30)       /* Timer/Counter 3 interrupt enable */
+#define TC2IP                               (1 << 29)       /* Timer/Counter 2 interrupt pending */
+#define TC3IP                               (1 << 28)       /* Timer/Counter 3 interrupt pending */
+/* Clock division base register field definitions
+*/
+#define DIVF01_OFFSET                       16
+#define DIVF23_OFFSET                       16
+/* Watchdog control register field definitions
+*/
+#define OVSEL_15                            0               /* Overflow select count 2^15 */
+#define OVSEL_16                            (1 << 29)       /* Overflow select count 2^16 */
+#define OVSEL_17                            (2 << 29)       /* Overflow select count 2^17 */
+#define OVSEL_18                            (3 << 29)       /* Overflow select count 2^18 */
+#define OVSEL_19                            (4 << 29)       /* Overflow select count 2^19 */
+#define OVSEL_20                            (5 << 29)       /* Overflow select count 2^20 */
+#define OVSEL_21                            (6 << 29)       /* Overflow select count 2^21 */
+#define OVSEL_22                            (7 << 29)       /* Overflow select count 2^22 */
+#define WDTEST_EN 	                     ( 1 << 28)      /* Watchdog stop test mode enable bit */
+#define WDSTOP_PATTERN                      0xA5            /* Watchdog stop pattern */
+#define WDTE_OFFSET                         0               /* Watchdog enable */
+#define WDC_OFFSET                          25              /* Indicate whether watchdog ever occurs */
+#define WDTCLR_PATTERN                      0xFF<<WDC_OFFSET/* Watchdog clear pattern */
+
+
+/*GPIO control registers definition
+*/
+#define GPIO_BASE           0xbd020000
+
+//#ifndef _RTD2880_NEW
+#define GPIO_C_CR		(GPIO_BASE)			/*Port C Configuration Register*/
+#define GPIO_C_IMR		(GPIO_BASE+0x004)	/*Port C Interrupt Mask Register*/
+#define GPIO_D_CR		(GPIO_BASE+0x008)	/*Port D Configuration Register*/
+#define GPIO_D_IMR		(GPIO_BASE+0x00c)	/*Port D Interrupt Mask Register*/
+#define GPIO_E_CR		(GPIO_BASE+0x010)	/*Port E Configuration Register*/
+#define GPIO_E_IMR		(GPIO_BASE+0x014)	/*Port E Interrupt Mask Register*/
+#define GPIO_F_CR		(GPIO_BASE+0x018)	/*Port F Configuration Register*/
+#define GPIO_F_IMR		(GPIO_BASE+0x01c)	/*Port F Interrupt Mask Register*/
+#define GPIO_G_CR		(GPIO_BASE+0x020)	/*Port G Configuration Register*/
+#define GPIO_G_IMR		(GPIO_BASE+0x024)	/*Port G Interrupt Mask Register*/
+#define GPIO_H_CR		(GPIO_BASE+0x028)	/*Port H Configuration Register*/
+#define GPIO_H_IMR		(GPIO_BASE+0x02c)	/*Port H Interrupt Mask Register*/
+#define GPIO_I_CR		(GPIO_BASE+0x030)	/*Port I Configuration Register*/
+#define GPIO_I_IMR		(GPIO_BASE+0x034)	/*Port I Interrupt Mask Register*/
+#define GPIO_J_CR		(GPIO_BASE+0x038)	/*Port J Configuration Register*/
+#define GPIO_J_IMR		(GPIO_BASE+0x03c)	/*Port J Interrupt Mask Register*/
+#define GPIO_K_CR		(GPIO_BASE+0x040)	/*Port K Configuration Register*/
+#define GPIO_K_IMR		(GPIO_BASE+0x044)	/*Port K Interrupt Mask Register*/
+#define GPIO_L_CR		(GPIO_BASE+0x048)	/*Port L Configuration Register*/
+#define GPIO_L_IMR		(GPIO_BASE+0x04c)	/*Port L Interrupt Mask Register*/
+#define GPIO_ER 			(GPIO_BASE+0x050)	/*GPIO Extension Register*/
+//#endif
+#define MUX_CTL_1	0xbd011110
+#define MUX_CTL_2	0xbd011114
+#define MUX_CTL_3	0xbd011118
+
+/*PWM control register definition
+*/
+#define PWM_BASE	0xbd025000
+#define PWM_C_CBR		(PWM_BASE)			/* Port C PWM clock base register */
+#define PWM_C_CDR		(PWM_BASE+0x04)	/* Port C PWM clock duty register */
+#define PWM_E_CBR		(PWM_BASE+0x08)			/* Port E PWM clock base register */
+#define PWM_E_CDR		(PWM_BASE+0x0c)	/* Port E PWM clock duty register */
+#define PWM_ER		(PWM_BASE+0x10)	/* PWM extension register */
+
+//For Nor flash
+#define NOR_REG_BASE               0xbd010500
+#define MCMCRNF            		   (NOR_REG_BASE + 0x00)
+#define MCRTCRNF           		   (NOR_REG_BASE + 0x04)
+#define MCNFSR            		   (NOR_REG_BASE + 0x08)
+#define MCB1MMSASR       		   (NOR_REG_BASE + 0x0c)
+#define MCEBMMSAR       		   (NOR_REG_BASE + 0x10)
+
+//For NAND flash
+
+#ifndef _RTD2880_NEW
+#define NAND_BASE               0xbd010100
+#else
+#define NAND_BASE               0xbd010600
+#endif
+
+#define NAND_ACR                (NAND_BASE)                     //NAND Flash Access Control Register
+#define NAND_TCR                (NAND_BASE+0x04)        //NAND Flash Timing Control Register
+#define NAND_ATCR               (NAND_BASE+0x08)        //NAND Flash Access Timing Control Register
+#define NAND_RWDLR              (NAND_BASE+0x0c)        //NAND Flash R/W Data Length Register
+#define NAND_DAIDR             (NAND_BASE+0x10) //NAND Flash Data Address IN DDR Register
+#define NAND_SDAIDR     (NAND_BASE+0x14)     //NAND Flash Spare Address IN DDR Register
+#define NAND_CR                 (NAND_BASE+0x18)        //NAND Flash Command Register
+#define NAND_CBCR               (NAND_BASE+0x1c)        //NAND Flash Copy Back Command Register
+#define NAND_CAR                (NAND_BASE+0x20)        //NAND Flash Column Address Register
+#define NAND_RAR                (NAND_BASE+0x24)        //NAND Flash Row Address Register
+#define NAND_DCAR               (NAND_BASE+0x28)        //NAND Flash Destination Column Address Register
+#define NAND_DRAR               (NAND_BASE+0x2c)        //NAND Flash Destination Row Address Register
+#define NAND_ICR                (NAND_BASE+0x30)        //NAND Flash Interrupt Control Register
+#define NAND_SR                 (NAND_BASE+0x34)        //NAND Flash Status Register
+#define NAND_SDR                (NAND_BASE+0x38)        //NAND Flash ID/Flash Status Data Register
+
+#define LCD_PARAL_BASE	0xbd010a00			   // lcd parallel interface controller base
+#define LCD_PARAL_ALE	(LCD_PARAL_BASE)	   // lcd parallel interface address latch control
+#define LCD_PARAL_WR	(LCD_PARAL_BASE+0x04) // lcd parallel interface write control
+#define LCD_PARAL_RD	(LCD_PARAL_BASE+0x08) //lcd parallel interface read control
+#define LCD_PARAL_CON0	(LCD_PARAL_BASE+0x0c) //lcd parallel interface control register 0
+#define LCD_PARAL_CON1	(LCD_PARAL_BASE+0x10) //lcd parallel interface control register 1
+#define LCD_PARAL_SR	(LCD_PARAL_BASE+0x14) //lcd parallel interface status register
+
+
+#ifndef _RTD2880_NEW
+#define ICENRR0               0xbd011030     /* Enable Register - RISC0*/
+#define ICEXVORR0          0xbd011034     /* Exception Vector Offset Register - RISC0 */
+#else
+#define ICENRR0               0xbd011028     /* Enable Register - RISC0*/
+#define ICEXVORR0          0xbd01102c     /* Exception Vector Offset Register - RISC0 */
+#endif
+
+#define FLASH_MAP_BEGIN		0xbf000000
+#define FLASH_MAP_END		0xc0000000
+#define FLASH_BASE 			0xbfc00000
+
+//For PLL Controller
+#define PLL_BASE				0xbd011200
+#define PLL_CPUCR			(0x00 + PLL_BASE) /*PLL_CPU Control Register*/
+#define PLL_DDSCR			(0x04 + PLL_BASE) /*PLL_DDS Control Register*/
+#define PLL_DDSCR2			(0x08 + PLL_BASE) /*PLL_DDS Control Register2*/
+#define PLL_DDSCR3			(0x0C + PLL_BASE) /*PLL_DDS Control Register3*/
+#define PLL_DDSSR			(0x10 + PLL_BASE) /*PLL_DDS Status Register*/
+#define PLL_DDSSR2			(0x14 + PLL_BASE) /*PLL_DDS Status Register2*/
+#define PLL_BUSCR			(0x18 + PLL_BASE) /*PLL_BUS Control Register*/
+#define PLL_BUSCR2			(0x1C + PLL_BASE) /*PLL_BUS Control Register2*/
+#define PLL_BUSCR3 			(0x20 + PLL_BASE) /*PLL_BUS Control Register3*/
+#define PLL_DISPCR			(0x24 + PLL_BASE) /*PLL_DISP Control Register*/
+#define PLL_DISPCR2			(0x28 + PLL_BASE) /*PLL_DISP Control Register2*/
+#define PLL_OTHERCR			(0x2C + PLL_BASE) /*PLL_OTHER Control Register*/
+
+#define SCIU_CDCR			(0x60 + PLL_BASE) /* Clock Domain control Register */
+// For NIC
+#define NIC_CNR1	0x000
+#define NIC_ID		0x000
+#define NIC_MAR		0x008
+#define NIC_TSAD		0x014
+#define NIC_RSAD	0x018
+#define NIC_IMTR		0x01C
+#define NIC_CR		0x03b
+#define NIC_IMR		0x03c
+#define NIC_ISR		0x03e
+#define NIC_MSR		0x058
+#define NIC_TMF0	0x028
+#define NIC_TMF1	0x02C
+#define NIC_TMF2	0x030
+#define NIC_TMF3	0x034
+#define NIC_MII		0x05C
+#define NIC_CNR2	0x03C
+#define NIC_TCR		0x040
+#define NIC_RCR		0x044
+#define NIC_MPC		0x080
+#define NIC_TXCOL	0x084
+#define NIC_RXERR	0x088
+#define NIC_BIST		0x08C
+
+#define MII_W		0x80000000
+#define MII_R		0x00000000
+#define MII_PHY_ADDR	0x01
+
+#define PHY_REG0	0x00
+#define PHY_LOOPBACK 0x4000
+#define PHY_100M	0x2000
+#define PHY_10M		0x0000
+#define PHY_AUTONEO 0x1000
+#define PHY_F_DUP	0x0100
+#define PHY_H_DUP	0x0000
+
+
+#define	TxFDP1		0x1300
+#define	TxCDO1		0x1304
+#define	RxFDP		0x13F0
+#define	RxCDO		0x13F4
+#define RxRingSize	0x13f6
+#define EthrntRxCPU_Des_Num	0x1430
+#define Rx_Pse_Des_Thres		0x1432
+#define	IO_CMD		0x1434
+
+#define TX_EN		BIT(2)
+#define RX_EN		BIT(3)
+
+#define DEFAULT_CONSOLE            CNL_UART
+
+#define Def_UARTBaudRate 115200
+#define Fast_UARTBaudRate 115200
+#define BAUDRATE_DEF (CPU_CLOCK / Def_UARTBaudRate / 16) - 1
+//#define Timer_Tick CPU_CLOCK /Fast_UARTBaudRate * 8
+//#define Timer_Tick 27000*1000 /Fast_UARTBaudRate * 8
+
+#define Timer_Tick CPU_CLOCK / (Fast_UARTBaudRate / 8)
+#define Timer_Data  (Fast_UARTBaudRate / 8 /10)
+//#define Timer_Tick 27000* 8
+
+#define TICK_10MS_FREQ    100 /* 100 Hz */
+#define TICK_5MS_FREQ      200 /* 200 Hz */
+#define ROS_TICK_FREQ  	TICK_5MS_FREQ
+
+
+///////////////////////////////////////////////////////
+//
+// Memory Mapping Area (Linux, IP, ROS)
+//
+///////////////////////////////////////////////////////
+
+#define MMA_LINUX_START 0x0
+#define MMA_LINUX_SIZE (7 << 20)
+
+#define MMA_TP0_START 0x700000
+//#define MMA_TP0_SIZE (3 << 20)
+#define MMA_TP0_SIZE (7*512*1024)
+
+#define MMA_TP1_START 0x1000000
+#define MMA_TP1_SIZE (3 << 20)
+
+#define MMA_GDE_START 0x1300000
+#define MMA_GDE_SIZE (8 << 20)
+
+#define MMA_DISP_MVD_SHARED_START (0xa1cffc00)   ///< KSEG1 virtual addr
+#define MMA_DISP_MVD_SHARED_0	MMA_DISP_MVD_SHARED_START
+#define MMA_DISP_MVD_SHARED_1	(0x100+MMA_DISP_MVD_SHARED_0)
+#define MMA_DISP_MVD_SHARED_SIZE (1 << 10)
+
+#define MMA_AI_FIFO_START 0x1d00000
+#define MMA_AI_FIFO_SIZE (672 << 10)
+
+#define MMA_ROS_START 0x1e00000
+#define MMA_ROS_SIZE (2 << 20)
+
+#define MMA_MVD_BUFFER_START 0x2600000
+#define MMA_MVD_BUFFER_SIZE (17 << 20)
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/rtd_types.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/rtd_types.h
new file mode 100644
index 00000000..793e1c9
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/rtd_types.h
@@ -0,0 +1,165 @@
+/*=============================================================
+ * Copyright (c)      Realtek Semiconductor Corporation, 2004 *
+ * All rights reserved.                                       *
+ *============================================================*/
+/*======================= Description ========================*/
+/**
+  * @file 
+ * We define the usual types in this file.
+ * We define the usual types in this file such as INT8,uin8,etc.
+ * Please include this file in all source file. And declare your
+ * variables with this re-defined type.
+ * @Author Moya Yu
+ * @date  2004/4/7
+ * @version 1.0
+ */
+
+/*======================= CVS Headers =========================
+  $Header: /cvsroot/dtv/include/rtd_types.h,v 1.20 2004/10/29 07:46:14 tzungder Exp $
+  
+  $Log: rtd_types.h,v $
+  Revision 1.20  2004/10/29 07:46:14  tzungder
+  +add #ifdef _WIN32 for models which compiled by VC on windows platform
+
+  Revision 1.19  2004/10/27 08:52:26  waynelee
+  +: <waynelee> FLOAT32, FLOAT64
+
+  Revision 1.18  2004/10/27 03:20:01  tzungder
+  refine rtd_types.h definitions and apply to all
+
+  Revision 1.17  2004/10/26 14:22:57  waynelee
+  -: remove bool define
+
+  Revision 1.16  2004/10/26 12:52:04  ljshuenn
+  *: <ljshuenn> Remove the definition for BOOL because it is definited in
+  previous.
+
+  Revision 1.15  2004/10/26 12:37:15  ljshuenn
+  +: <ljshuenn> Add the definition for Boolean declaration
+
+  Revision 1.14  2004/08/11 06:26:05  ghyu
+  	Add definition of memaddr.
+
+  Revision 1.13  2004/08/09 05:38:08  ghyu
+  	Redefine _SIZE_T
+
+  Revision 1.12  2004/08/09 04:24:54  tzungder
+  add defines for NIC
+
+  Revision 1.11  2004/08/05 08:11:41  ghyu
+  	Loader code includes real header file here.
+
+  Revision 1.10  2004/07/13 03:31:59  ghyu
+  add flash control module
+
+  Revision 1.9  2004/07/09 10:23:22  ghyu
+
+    add drTPcontrol Module
+
+  Revision 1.8  2004/06/18 07:14:26  ghyu
+  Doc Tree Refine.
+
+  Revision 1.7  2004/06/10 10:44:18  ghyu
+  rearrange doc's architecture
+
+  Revision 1.6  2004/06/09 12:37:19  ghyu
+  add some file for models document
+
+  Revision 1.5  2004/06/09 02:22:45  herman
+  Add Audio Interface API
+
+  Revision 1.4  2004/06/08 03:26:57  tzungder
+  move ir.h, scd.h to peripheral moudule
+
+  Revision 1.3  2004/05/07 09:03:09  ghyu
+  add i2c & uart APIs
+
+  Revision 1.2  2004/04/22 03:23:54  swchen
+  Add MVD Functions
+
+  Revision 1.1  2004/04/12 09:22:01  ghyu
+  add rtd_types.h
+
+  Revision 1.2  2004/04/06 10:58:36  waynelee
+  +add ds defgroup and describes it
+
+  Revision 1.1.1.1  2004/04/01 03:25:11  ghyu
+  DTV Project Start
+  
+ *=============================================================*/
+
+
+#ifndef _RTD_TYPES_H
+#define _RTD_TYPES_H
+
+/*
+ * Internal names for basic integral types.  Omit the typedef if
+ * not possible for a machine/compiler combination.
+ */
+#ifdef _WIN32 //for platform-acrossing of models, _WIN32: the pre-defined keyword of VC compiler
+typedef 	unsigned __int64         UINT64; //!<for unsigned 64 bits integer in VC windows platform
+typedef  __int64				INT64;//!<for signed 64 bits integer in VC windows platform
+#else
+typedef unsigned long long		UINT64; //!< for unsigned 64 bits integer
+typedef long long				INT64;     //!< for signed 64 bits integer
+#endif
+typedef unsigned int			UINT32;   //!< for unsigned integer (32 bits)
+typedef int					INT32;    //!< for signed integer (32 bits)
+typedef unsigned short			UINT16;  //!< for unsigned short (16 bits)
+typedef short					INT16;    //!< for signed short (16 bits)
+typedef unsigned char			UINT8;   //!< for unsigned character (8 bits)
+typedef char					INT8;    //!< for character (8 bits)
+//typedef int BOOL;  //!< for boolean value
+typedef float					FLOAT32;	//!< for float point (32 bits)
+typedef double				FLOAT64;	//!< for float point (64 bits)
+
+typedef unsigned int size_t;
+
+#ifndef bool
+//typedef unsigned char	bool ;	//!< For Boolean declaration
+typedef enum{FALSE = 0, TRUE} bool;
+#endif
+
+#ifndef BOOL
+#define BOOL bool
+#endif
+
+#ifndef NULL
+#define NULL (void *)0
+#endif
+/*
+#ifndef TRUE
+#define TRUE 1
+#endif
+#ifndef FALSE
+#define FALSE 0
+#endif
+*/
+#ifndef SUCCESS
+#define SUCCESS 0
+#endif
+
+#ifndef FAILED
+#define FAILED -1
+#endif
+
+#define CLEARBITS(a,b)	((a) &= ~(b))
+#define SETBITS(a,b)		((a) |= (b))
+#define ISSET(a,b)		(((a) & (b))!=0)
+#define ISCLEARED(a,b)	(((a) & (b))==0)
+
+
+#ifndef MAX
+#define MAX(a,b)  (((a) > (b)) ? (a) : (b))
+#endif			   /* max */
+
+#ifndef MIN
+#define MIN(a,b)  (((a) < (b)) ? (a) : (b))
+#endif			   /* min */
+
+#define ASSERT_CSP(x) if (!(x)) {printk("\nAssertion fail at file %s, function %s, line number %d:, expression '%s'", __FILE__, __FUNCTION__, __LINE__, #x); while(1);}
+#define ASSERT_ISR(x) if (!(x)) {printk("\nAssertion fail at file %s, function %s, line number %d:, expression '%s'", __FILE__, __FUNCTION__, __LINE__, #x); while(1);}
+
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sata0_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sata0_reg.h
new file mode 100644
index 00000000..5b8e171
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sata0_reg.h
@@ -0,0 +1,635 @@
+// This file is generated using the spec version 2.0, firmware template version 1.39and DVR_Parser_0.46
+#ifndef _SATA0_REG_H_INCLUDED_
+#define _SATA0_REG_H_INCLUDED_
+
+//#define  _SATA0_USE_STRUCT
+#ifdef _SATA0_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data:16;
+}sata0_CDR0;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data_p:8;
+    unsigned int    data:8;
+}sata0_CDR1;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data_p:8;
+    unsigned int    data:8;
+}sata0_CDR2;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data_p:8;
+    unsigned int    data:8;
+}sata0_CDR3;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data_p:8;
+    unsigned int    data:8;
+}sata0_CDR4;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data_p:8;
+    unsigned int    data:8;
+}sata0_CDR5;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}sata0_CDR6;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}sata0_CDR7;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}sata0_CLR0;
+
+typedef struct
+{
+    unsigned int    sstatus:32;
+}sata0_SCR0;
+
+typedef struct
+{
+    unsigned int    serror:32;
+}sata0_SCR1;
+
+typedef struct
+{
+    unsigned int    scontrol:32;
+}sata0_SCR2;
+
+typedef struct
+{
+    unsigned int    sactive:32;
+}sata0_SCR3;
+
+typedef struct
+{
+    unsigned int    snotification:32;
+}sata0_SCR4;
+
+typedef struct
+{
+    unsigned int    reserved_0:32;
+}sata0_SCR5;
+
+typedef struct
+{
+    unsigned int    reserved_0:15;
+    unsigned int    reg_mode:1;
+    unsigned int    prd_num:8;
+    unsigned int    reserved_1:1;
+    unsigned int    cpen:1;
+    unsigned int    srst:1;
+    unsigned int    self_test:1;
+    unsigned int    write:1;
+    unsigned int    reserved_2:2;
+    unsigned int    go:1;
+}sata0_DMACTRL;
+
+typedef struct
+{
+    unsigned int    prd_ptr:30;
+    unsigned int    reserved_0:2;
+}sata0_PRDPTR;
+
+typedef struct
+{
+    unsigned int    prd_pba:30;
+    unsigned int    reserved_0:2;
+}sata0_PRDEty0;
+
+typedef struct
+{
+    unsigned int    eot:1;
+    unsigned int    reserved_0:7;
+    unsigned int    prd_bycnt:22;
+    unsigned int    reserved_1:2;
+}sata0_PRDEty1;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    intrq_en:1;
+}sata0_enable;
+
+typedef struct
+{
+    unsigned int    reserved_0:12;
+    unsigned int    bridge_rlevel:4;
+    unsigned int    bridge_wlevel:4;
+    unsigned int    dma_flevel:4;
+    unsigned int    reserved_1:5;
+    unsigned int    cmd_swap:2;
+    unsigned int    data_swap:1;
+}sata0_DMAMisc;
+
+typedef struct
+{
+    unsigned int    data:16;
+    unsigned int    phy_adr:3;
+    unsigned int    reg_adr:5;
+    unsigned int    reserved_0:1;
+    unsigned int    mdio_st:2;
+    unsigned int    mdio_rdy:1;
+    unsigned int    mclk_rate:2;
+    unsigned int    mdio_srst:1;
+    unsigned int    mdio_rdwr:1;
+}sata0_MDIOCtrl;
+
+typedef struct
+{
+    unsigned int    crc:32;
+}sata0_DMACrc;
+
+typedef struct
+{
+    unsigned int    req_cnt:16;
+    unsigned int    reserved_0:3;
+    unsigned int    req_cnt_en:1;
+    unsigned int    reserved_1:2;
+    unsigned int    tx_data_vld:1;
+    unsigned int    rx_enable:1;
+    unsigned int    tx_enable:1;
+    unsigned int    reset_n:1;
+    unsigned int    slumber:1;
+    unsigned int    partial:1;
+    unsigned int    farafelb:1;
+    unsigned int    nearafelb:1;
+    unsigned int    spdsel:1;
+    unsigned int    enable:1;
+}sata0_pinout;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    timeout_flg:1;
+    unsigned int    reserved_1:11;
+    unsigned int    timeout_en:1;
+    unsigned int    timeout_cnt:16;
+}sata0_timeout;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    write_enable4:1;
+    unsigned int    test_key:16;
+    unsigned int    reserved_1:2;
+    unsigned int    write_enable3:1;
+    unsigned int    sel1:3;
+    unsigned int    write_enable2:1;
+    unsigned int    sel0:3;
+    unsigned int    write_enable1:1;
+    unsigned int    enable:1;
+}sata0_dbg;
+#endif
+
+#define SATA0_CDR0                                                    0x18012B00
+#define SATA0_CDR0_reg_addr                                           "0xB8012B00"
+#define SATA0_CDR0_reg                                                0xB8012B00
+#define SATA0_CDR0_inst_addr                                          "0x02C0"
+#define SATA0_CDR0_inst                                               0x02C0
+#define SATA0_CDR0_data_shift                                         (0)
+#define SATA0_CDR0_data_mask                                          (0x0000FFFF)
+#define SATA0_CDR0_data(data)                                         (0x0000FFFF&(data))
+#define SATA0_CDR0_get_data(data)                                     (0x0000FFFF&(data))
+
+#define SATA0_CDR1                                                    0x18012B04
+#define SATA0_CDR1_reg_addr                                           "0xB8012B04"
+#define SATA0_CDR1_reg                                                0xB8012B04
+#define SATA0_CDR1_inst_addr                                          "0x02C1"
+#define SATA0_CDR1_inst                                               0x02C1
+#define SATA0_CDR1_data_p_shift                                       (8)
+#define SATA0_CDR1_data_shift                                         (0)
+#define SATA0_CDR1_data_p_mask                                        (0x0000FF00)
+#define SATA0_CDR1_data_mask                                          (0x000000FF)
+#define SATA0_CDR1_data_p(data)                                       (0x0000FF00&((data)<<8))
+#define SATA0_CDR1_data(data)                                         (0x000000FF&(data))
+#define SATA0_CDR1_get_data_p(data)                                   ((0x0000FF00&(data))>>8)
+#define SATA0_CDR1_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA0_CDR2                                                    0x18012B08
+#define SATA0_CDR2_reg_addr                                           "0xB8012B08"
+#define SATA0_CDR2_reg                                                0xB8012B08
+#define SATA0_CDR2_inst_addr                                          "0x02C2"
+#define SATA0_CDR2_inst                                               0x02C2
+#define SATA0_CDR2_data_p_shift                                       (8)
+#define SATA0_CDR2_data_shift                                         (0)
+#define SATA0_CDR2_data_p_mask                                        (0x0000FF00)
+#define SATA0_CDR2_data_mask                                          (0x000000FF)
+#define SATA0_CDR2_data_p(data)                                       (0x0000FF00&((data)<<8))
+#define SATA0_CDR2_data(data)                                         (0x000000FF&(data))
+#define SATA0_CDR2_get_data_p(data)                                   ((0x0000FF00&(data))>>8)
+#define SATA0_CDR2_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA0_CDR3                                                    0x18012B0C
+#define SATA0_CDR3_reg_addr                                           "0xB8012B0C"
+#define SATA0_CDR3_reg                                                0xB8012B0C
+#define SATA0_CDR3_inst_addr                                          "0x02C3"
+#define SATA0_CDR3_inst                                               0x02C3
+#define SATA0_CDR3_data_p_shift                                       (8)
+#define SATA0_CDR3_data_shift                                         (0)
+#define SATA0_CDR3_data_p_mask                                        (0x0000FF00)
+#define SATA0_CDR3_data_mask                                          (0x000000FF)
+#define SATA0_CDR3_data_p(data)                                       (0x0000FF00&((data)<<8))
+#define SATA0_CDR3_data(data)                                         (0x000000FF&(data))
+#define SATA0_CDR3_get_data_p(data)                                   ((0x0000FF00&(data))>>8)
+#define SATA0_CDR3_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA0_CDR4                                                    0x18012B10
+#define SATA0_CDR4_reg_addr                                           "0xB8012B10"
+#define SATA0_CDR4_reg                                                0xB8012B10
+#define SATA0_CDR4_inst_addr                                          "0x02C4"
+#define SATA0_CDR4_inst                                               0x02C4
+#define SATA0_CDR4_data_p_shift                                       (8)
+#define SATA0_CDR4_data_shift                                         (0)
+#define SATA0_CDR4_data_p_mask                                        (0x0000FF00)
+#define SATA0_CDR4_data_mask                                          (0x000000FF)
+#define SATA0_CDR4_data_p(data)                                       (0x0000FF00&((data)<<8))
+#define SATA0_CDR4_data(data)                                         (0x000000FF&(data))
+#define SATA0_CDR4_get_data_p(data)                                   ((0x0000FF00&(data))>>8)
+#define SATA0_CDR4_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA0_CDR5                                                    0x18012B14
+#define SATA0_CDR5_reg_addr                                           "0xB8012B14"
+#define SATA0_CDR5_reg                                                0xB8012B14
+#define SATA0_CDR5_inst_addr                                          "0x02C5"
+#define SATA0_CDR5_inst                                               0x02C5
+#define SATA0_CDR5_data_p_shift                                       (8)
+#define SATA0_CDR5_data_shift                                         (0)
+#define SATA0_CDR5_data_p_mask                                        (0x0000FF00)
+#define SATA0_CDR5_data_mask                                          (0x000000FF)
+#define SATA0_CDR5_data_p(data)                                       (0x0000FF00&((data)<<8))
+#define SATA0_CDR5_data(data)                                         (0x000000FF&(data))
+#define SATA0_CDR5_get_data_p(data)                                   ((0x0000FF00&(data))>>8)
+#define SATA0_CDR5_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA0_CDR6                                                    0x18012B18
+#define SATA0_CDR6_reg_addr                                           "0xB8012B18"
+#define SATA0_CDR6_reg                                                0xB8012B18
+#define SATA0_CDR6_inst_addr                                          "0x02C6"
+#define SATA0_CDR6_inst                                               0x02C6
+#define SATA0_CDR6_data_shift                                         (0)
+#define SATA0_CDR6_data_mask                                          (0x000000FF)
+#define SATA0_CDR6_data(data)                                         (0x000000FF&(data))
+#define SATA0_CDR6_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA0_CDR7                                                    0x18012B1C
+#define SATA0_CDR7_reg_addr                                           "0xB8012B1C"
+#define SATA0_CDR7_reg                                                0xB8012B1C
+#define SATA0_CDR7_inst_addr                                          "0x02C7"
+#define SATA0_CDR7_inst                                               0x02C7
+#define SATA0_CDR7_data_shift                                         (0)
+#define SATA0_CDR7_data_mask                                          (0x000000FF)
+#define SATA0_CDR7_data(data)                                         (0x000000FF&(data))
+#define SATA0_CDR7_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA0_CLR0                                                    0x18012B20
+#define SATA0_CLR0_reg_addr                                           "0xB8012B20"
+#define SATA0_CLR0_reg                                                0xB8012B20
+#define SATA0_CLR0_inst_addr                                          "0x02C8"
+#define SATA0_CLR0_inst                                               0x02C8
+#define SATA0_CLR0_data_shift                                         (0)
+#define SATA0_CLR0_data_mask                                          (0x000000FF)
+#define SATA0_CLR0_data(data)                                         (0x000000FF&(data))
+#define SATA0_CLR0_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA0_SCR0                                                    0x18012B24
+#define SATA0_SCR0_reg_addr                                           "0xB8012B24"
+#define SATA0_SCR0_reg                                                0xB8012B24
+#define SATA0_SCR0_inst_addr                                          "0x02C9"
+#define SATA0_SCR0_inst                                               0x02C9
+#define SATA0_SCR0_sstatus_shift                                      (0)
+#define SATA0_SCR0_sstatus_mask                                       (0xFFFFFFFF)
+#define SATA0_SCR0_sstatus(data)                                      (0xFFFFFFFF&(data))
+#define SATA0_SCR0_get_sstatus(data)                                  (0xFFFFFFFF&(data))
+
+#define SATA0_SCR1                                                    0x18012B28
+#define SATA0_SCR1_reg_addr                                           "0xB8012B28"
+#define SATA0_SCR1_reg                                                0xB8012B28
+#define SATA0_SCR1_inst_addr                                          "0x02CA"
+#define SATA0_SCR1_inst                                               0x02CA
+#define SATA0_SCR1_serror_shift                                       (0)
+#define SATA0_SCR1_serror_mask                                        (0xFFFFFFFF)
+#define SATA0_SCR1_serror(data)                                       (0xFFFFFFFF&(data))
+#define SATA0_SCR1_get_serror(data)                                   (0xFFFFFFFF&(data))
+
+#define SATA0_SCR2                                                    0x18012B2C
+#define SATA0_SCR2_reg_addr                                           "0xB8012B2C"
+#define SATA0_SCR2_reg                                                0xB8012B2C
+#define SATA0_SCR2_inst_addr                                          "0x02CB"
+#define SATA0_SCR2_inst                                               0x02CB
+#define SATA0_SCR2_scontrol_shift                                     (0)
+#define SATA0_SCR2_scontrol_mask                                      (0xFFFFFFFF)
+#define SATA0_SCR2_scontrol(data)                                     (0xFFFFFFFF&(data))
+#define SATA0_SCR2_get_scontrol(data)                                 (0xFFFFFFFF&(data))
+
+#define SATA0_SCR3                                                    0x18012B30
+#define SATA0_SCR3_reg_addr                                           "0xB8012B30"
+#define SATA0_SCR3_reg                                                0xB8012B30
+#define SATA0_SCR3_inst_addr                                          "0x02CC"
+#define SATA0_SCR3_inst                                               0x02CC
+#define SATA0_SCR3_sactive_shift                                      (0)
+#define SATA0_SCR3_sactive_mask                                       (0xFFFFFFFF)
+#define SATA0_SCR3_sactive(data)                                      (0xFFFFFFFF&(data))
+#define SATA0_SCR3_get_sactive(data)                                  (0xFFFFFFFF&(data))
+
+#define SATA0_SCR4                                                    0x18012B34
+#define SATA0_SCR4_reg_addr                                           "0xB8012B34"
+#define SATA0_SCR4_reg                                                0xB8012B34
+#define SATA0_SCR4_inst_addr                                          "0x02CD"
+#define SATA0_SCR4_inst                                               0x02CD
+#define SATA0_SCR4_snotification_shift                                (0)
+#define SATA0_SCR4_snotification_mask                                 (0xFFFFFFFF)
+#define SATA0_SCR4_snotification(data)                                (0xFFFFFFFF&(data))
+#define SATA0_SCR4_get_snotification(data)                            (0xFFFFFFFF&(data))
+
+#define SATA0_SCR5                                                    0x18012B38
+#define SATA0_SCR5_reg_addr                                           "0xB8012B38"
+#define SATA0_SCR5_reg                                                0xB8012B38
+#define SATA0_SCR5_inst_addr                                          "0x02CE"
+#define SATA0_SCR5_inst                                               0x02CE
+
+#define SATA0_DMACTRL                                                 0x18012BD0
+#define SATA0_DMACTRL_reg_addr                                        "0xB8012BD0"
+#define SATA0_DMACTRL_reg                                             0xB8012BD0
+#define SATA0_DMACTRL_inst_addr                                       "0x02F4"
+#define SATA0_DMACTRL_inst                                            0x02F4
+#define SATA0_DMACTRL_reg_mode_shift                                  (16)
+#define SATA0_DMACTRL_prd_num_shift                                   (8)
+#define SATA0_DMACTRL_cpen_shift                                      (6)
+#define SATA0_DMACTRL_srst_shift                                      (5)
+#define SATA0_DMACTRL_self_test_shift                                 (4)
+#define SATA0_DMACTRL_write_shift                                     (3)
+#define SATA0_DMACTRL_go_shift                                        (0)
+#define SATA0_DMACTRL_reg_mode_mask                                   (0x00010000)
+#define SATA0_DMACTRL_prd_num_mask                                    (0x0000FF00)
+#define SATA0_DMACTRL_cpen_mask                                       (0x00000040)
+#define SATA0_DMACTRL_srst_mask                                       (0x00000020)
+#define SATA0_DMACTRL_self_test_mask                                  (0x00000010)
+#define SATA0_DMACTRL_write_mask                                      (0x00000008)
+#define SATA0_DMACTRL_go_mask                                         (0x00000001)
+#define SATA0_DMACTRL_reg_mode(data)                                  (0x00010000&((data)<<16))
+#define SATA0_DMACTRL_prd_num(data)                                   (0x0000FF00&((data)<<8))
+#define SATA0_DMACTRL_cpen(data)                                      (0x00000040&((data)<<6))
+#define SATA0_DMACTRL_srst(data)                                      (0x00000020&((data)<<5))
+#define SATA0_DMACTRL_self_test(data)                                 (0x00000010&((data)<<4))
+#define SATA0_DMACTRL_write(data)                                     (0x00000008&((data)<<3))
+#define SATA0_DMACTRL_go(data)                                        (0x00000001&(data))
+#define SATA0_DMACTRL_get_reg_mode(data)                              ((0x00010000&(data))>>16)
+#define SATA0_DMACTRL_get_prd_num(data)                               ((0x0000FF00&(data))>>8)
+#define SATA0_DMACTRL_get_cpen(data)                                  ((0x00000040&(data))>>6)
+#define SATA0_DMACTRL_get_srst(data)                                  ((0x00000020&(data))>>5)
+#define SATA0_DMACTRL_get_self_test(data)                             ((0x00000010&(data))>>4)
+#define SATA0_DMACTRL_get_write(data)                                 ((0x00000008&(data))>>3)
+#define SATA0_DMACTRL_get_go(data)                                    (0x00000001&(data))
+
+#define SATA0_PRDPTR                                                  0x18012BD4
+#define SATA0_PRDPTR_reg_addr                                         "0xB8012BD4"
+#define SATA0_PRDPTR_reg                                              0xB8012BD4
+#define SATA0_PRDPTR_inst_addr                                        "0x02F5"
+#define SATA0_PRDPTR_inst                                             0x02F5
+#define SATA0_PRDPTR_prd_ptr_shift                                    (2)
+#define SATA0_PRDPTR_prd_ptr_mask                                     (0xFFFFFFFC)
+#define SATA0_PRDPTR_prd_ptr(data)                                    (0xFFFFFFFC&((data)<<2))
+#define SATA0_PRDPTR_get_prd_ptr(data)                                ((0xFFFFFFFC&(data))>>2)
+
+#define SATA0_PRDEty0                                                 0x18012BD8
+#define SATA0_PRDEty0_reg_addr                                        "0xB8012BD8"
+#define SATA0_PRDEty0_reg                                             0xB8012BD8
+#define SATA0_PRDEty0_inst_addr                                       "0x02F6"
+#define SATA0_PRDEty0_inst                                            0x02F6
+#define SATA0_PRDEty0_prd_pba_shift                                   (2)
+#define SATA0_PRDEty0_prd_pba_mask                                    (0xFFFFFFFC)
+#define SATA0_PRDEty0_prd_pba(data)                                   (0xFFFFFFFC&((data)<<2))
+#define SATA0_PRDEty0_get_prd_pba(data)                               ((0xFFFFFFFC&(data))>>2)
+
+#define SATA0_PRDEty1                                                 0x18012BDC
+#define SATA0_PRDEty1_reg_addr                                        "0xB8012BDC"
+#define SATA0_PRDEty1_reg                                             0xB8012BDC
+#define SATA0_PRDEty1_inst_addr                                       "0x02F7"
+#define SATA0_PRDEty1_inst                                            0x02F7
+#define SATA0_PRDEty1_eot_shift                                       (31)
+#define SATA0_PRDEty1_prd_bycnt_shift                                 (2)
+#define SATA0_PRDEty1_eot_mask                                        (0x80000000)
+#define SATA0_PRDEty1_prd_bycnt_mask                                  (0x00FFFFFC)
+#define SATA0_PRDEty1_eot(data)                                       (0x80000000&((data)<<31))
+#define SATA0_PRDEty1_prd_bycnt(data)                                 (0x00FFFFFC&((data)<<2))
+#define SATA0_PRDEty1_get_eot(data)                                   ((0x80000000&(data))>>31)
+#define SATA0_PRDEty1_get_prd_bycnt(data)                             ((0x00FFFFFC&(data))>>2)
+
+#define SATA0_enable                                                  0x18012BE0
+#define SATA0_enable_reg_addr                                         "0xB8012BE0"
+#define SATA0_enable_reg                                              0xB8012BE0
+#define SATA0_enable_inst_addr                                        "0x02F8"
+#define SATA0_enable_inst                                             0x02F8
+#define SATA0_enable_intrq_en_shift                                   (0)
+#define SATA0_enable_intrq_en_mask                                    (0x00000001)
+#define SATA0_enable_intrq_en(data)                                   (0x00000001&(data))
+#define SATA0_enable_get_intrq_en(data)                               (0x00000001&(data))
+
+#define SATA0_DMAMisc                                                 0x18012BE4
+#define SATA0_DMAMisc_reg_addr                                        "0xB8012BE4"
+#define SATA0_DMAMisc_reg                                             0xB8012BE4
+#define SATA0_DMAMisc_inst_addr                                       "0x02F9"
+#define SATA0_DMAMisc_inst                                            0x02F9
+#define SATA0_DMAMisc_bridge_rlevel_shift                             (16)
+#define SATA0_DMAMisc_bridge_wlevel_shift                             (12)
+#define SATA0_DMAMisc_dma_flevel_shift                                (8)
+#define SATA0_DMAMisc_cmd_swap_shift                                  (1)
+#define SATA0_DMAMisc_data_swap_shift                                 (0)
+#define SATA0_DMAMisc_bridge_rlevel_mask                              (0x000F0000)
+#define SATA0_DMAMisc_bridge_wlevel_mask                              (0x0000F000)
+#define SATA0_DMAMisc_dma_flevel_mask                                 (0x00000F00)
+#define SATA0_DMAMisc_cmd_swap_mask                                   (0x00000006)
+#define SATA0_DMAMisc_data_swap_mask                                  (0x00000001)
+#define SATA0_DMAMisc_bridge_rlevel(data)                             (0x000F0000&((data)<<16))
+#define SATA0_DMAMisc_bridge_wlevel(data)                             (0x0000F000&((data)<<12))
+#define SATA0_DMAMisc_dma_flevel(data)                                (0x00000F00&((data)<<8))
+#define SATA0_DMAMisc_cmd_swap(data)                                  (0x00000006&((data)<<1))
+#define SATA0_DMAMisc_data_swap(data)                                 (0x00000001&(data))
+#define SATA0_DMAMisc_get_bridge_rlevel(data)                         ((0x000F0000&(data))>>16)
+#define SATA0_DMAMisc_get_bridge_wlevel(data)                         ((0x0000F000&(data))>>12)
+#define SATA0_DMAMisc_get_dma_flevel(data)                            ((0x00000F00&(data))>>8)
+#define SATA0_DMAMisc_get_cmd_swap(data)                              ((0x00000006&(data))>>1)
+#define SATA0_DMAMisc_get_data_swap(data)                             (0x00000001&(data))
+
+#define SATA0_MDIOCtrl                                                0x18012BE8
+#define SATA0_MDIOCtrl_reg_addr                                       "0xB8012BE8"
+#define SATA0_MDIOCtrl_reg                                            0xB8012BE8
+#define SATA0_MDIOCtrl_inst_addr                                      "0x02FA"
+#define SATA0_MDIOCtrl_inst                                           0x02FA
+#define SATA0_MDIOCtrl_data_shift                                     (16)
+#define SATA0_MDIOCtrl_phy_adr_shift                                  (13)
+#define SATA0_MDIOCtrl_reg_adr_shift                                  (8)
+#define SATA0_MDIOCtrl_mdio_st_shift                                  (5)
+#define SATA0_MDIOCtrl_mdio_rdy_shift                                 (4)
+#define SATA0_MDIOCtrl_mclk_rate_shift                                (2)
+#define SATA0_MDIOCtrl_mdio_srst_shift                                (1)
+#define SATA0_MDIOCtrl_mdio_rdwr_shift                                (0)
+#define SATA0_MDIOCtrl_data_mask                                      (0xFFFF0000)
+#define SATA0_MDIOCtrl_phy_adr_mask                                   (0x0000E000)
+#define SATA0_MDIOCtrl_reg_adr_mask                                   (0x00001F00)
+#define SATA0_MDIOCtrl_mdio_st_mask                                   (0x00000060)
+#define SATA0_MDIOCtrl_mdio_rdy_mask                                  (0x00000010)
+#define SATA0_MDIOCtrl_mclk_rate_mask                                 (0x0000000C)
+#define SATA0_MDIOCtrl_mdio_srst_mask                                 (0x00000002)
+#define SATA0_MDIOCtrl_mdio_rdwr_mask                                 (0x00000001)
+#define SATA0_MDIOCtrl_data(data)                                     (0xFFFF0000&((data)<<16))
+#define SATA0_MDIOCtrl_phy_adr(data)                                  (0x0000E000&((data)<<13))
+#define SATA0_MDIOCtrl_reg_adr(data)                                  (0x00001F00&((data)<<8))
+#define SATA0_MDIOCtrl_mdio_st(data)                                  (0x00000060&((data)<<5))
+#define SATA0_MDIOCtrl_mdio_rdy(data)                                 (0x00000010&((data)<<4))
+#define SATA0_MDIOCtrl_mclk_rate(data)                                (0x0000000C&((data)<<2))
+#define SATA0_MDIOCtrl_mdio_srst(data)                                (0x00000002&((data)<<1))
+#define SATA0_MDIOCtrl_mdio_rdwr(data)                                (0x00000001&(data))
+#define SATA0_MDIOCtrl_get_data(data)                                 ((0xFFFF0000&(data))>>16)
+#define SATA0_MDIOCtrl_get_phy_adr(data)                              ((0x0000E000&(data))>>13)
+#define SATA0_MDIOCtrl_get_reg_adr(data)                              ((0x00001F00&(data))>>8)
+#define SATA0_MDIOCtrl_get_mdio_st(data)                              ((0x00000060&(data))>>5)
+#define SATA0_MDIOCtrl_get_mdio_rdy(data)                             ((0x00000010&(data))>>4)
+#define SATA0_MDIOCtrl_get_mclk_rate(data)                            ((0x0000000C&(data))>>2)
+#define SATA0_MDIOCtrl_get_mdio_srst(data)                            ((0x00000002&(data))>>1)
+#define SATA0_MDIOCtrl_get_mdio_rdwr(data)                            (0x00000001&(data))
+
+#define SATA0_DMACrc                                                  0x18012BEC
+#define SATA0_DMACrc_reg_addr                                         "0xB8012BEC"
+#define SATA0_DMACrc_reg                                              0xB8012BEC
+#define SATA0_DMACrc_inst_addr                                        "0x02FB"
+#define SATA0_DMACrc_inst                                             0x02FB
+#define SATA0_DMACrc_crc_shift                                        (0)
+#define SATA0_DMACrc_crc_mask                                         (0xFFFFFFFF)
+#define SATA0_DMACrc_crc(data)                                        (0xFFFFFFFF&(data))
+#define SATA0_DMACrc_get_crc(data)                                    (0xFFFFFFFF&(data))
+
+#define SATA0_pinout                                                  0x18012BF0
+#define SATA0_pinout_reg_addr                                         "0xB8012BF0"
+#define SATA0_pinout_reg                                              0xB8012BF0
+#define SATA0_pinout_inst_addr                                        "0x02FC"
+#define SATA0_pinout_inst                                             0x02FC
+#define SATA0_pinout_req_cnt_shift                                    (16)
+#define SATA0_pinout_req_cnt_en_shift                                 (12)
+#define SATA0_pinout_tx_data_vld_shift                                (9)
+#define SATA0_pinout_rx_enable_shift                                  (8)
+#define SATA0_pinout_tx_enable_shift                                  (7)
+#define SATA0_pinout_reset_n_shift                                    (6)
+#define SATA0_pinout_slumber_shift                                    (5)
+#define SATA0_pinout_partial_shift                                    (4)
+#define SATA0_pinout_farafelb_shift                                   (3)
+#define SATA0_pinout_nearafelb_shift                                  (2)
+#define SATA0_pinout_spdsel_shift                                     (1)
+#define SATA0_pinout_enable_shift                                     (0)
+#define SATA0_pinout_req_cnt_mask                                     (0xFFFF0000)
+#define SATA0_pinout_req_cnt_en_mask                                  (0x00001000)
+#define SATA0_pinout_tx_data_vld_mask                                 (0x00000200)
+#define SATA0_pinout_rx_enable_mask                                   (0x00000100)
+#define SATA0_pinout_tx_enable_mask                                   (0x00000080)
+#define SATA0_pinout_reset_n_mask                                     (0x00000040)
+#define SATA0_pinout_slumber_mask                                     (0x00000020)
+#define SATA0_pinout_partial_mask                                     (0x00000010)
+#define SATA0_pinout_farafelb_mask                                    (0x00000008)
+#define SATA0_pinout_nearafelb_mask                                   (0x00000004)
+#define SATA0_pinout_spdsel_mask                                      (0x00000002)
+#define SATA0_pinout_enable_mask                                      (0x00000001)
+#define SATA0_pinout_req_cnt(data)                                    (0xFFFF0000&((data)<<16))
+#define SATA0_pinout_req_cnt_en(data)                                 (0x00001000&((data)<<12))
+#define SATA0_pinout_tx_data_vld(data)                                (0x00000200&((data)<<9))
+#define SATA0_pinout_rx_enable(data)                                  (0x00000100&((data)<<8))
+#define SATA0_pinout_tx_enable(data)                                  (0x00000080&((data)<<7))
+#define SATA0_pinout_reset_n(data)                                    (0x00000040&((data)<<6))
+#define SATA0_pinout_slumber(data)                                    (0x00000020&((data)<<5))
+#define SATA0_pinout_partial(data)                                    (0x00000010&((data)<<4))
+#define SATA0_pinout_farafelb(data)                                   (0x00000008&((data)<<3))
+#define SATA0_pinout_nearafelb(data)                                  (0x00000004&((data)<<2))
+#define SATA0_pinout_spdsel(data)                                     (0x00000002&((data)<<1))
+#define SATA0_pinout_enable(data)                                     (0x00000001&(data))
+#define SATA0_pinout_get_req_cnt(data)                                ((0xFFFF0000&(data))>>16)
+#define SATA0_pinout_get_req_cnt_en(data)                             ((0x00001000&(data))>>12)
+#define SATA0_pinout_get_tx_data_vld(data)                            ((0x00000200&(data))>>9)
+#define SATA0_pinout_get_rx_enable(data)                              ((0x00000100&(data))>>8)
+#define SATA0_pinout_get_tx_enable(data)                              ((0x00000080&(data))>>7)
+#define SATA0_pinout_get_reset_n(data)                                ((0x00000040&(data))>>6)
+#define SATA0_pinout_get_slumber(data)                                ((0x00000020&(data))>>5)
+#define SATA0_pinout_get_partial(data)                                ((0x00000010&(data))>>4)
+#define SATA0_pinout_get_farafelb(data)                               ((0x00000008&(data))>>3)
+#define SATA0_pinout_get_nearafelb(data)                              ((0x00000004&(data))>>2)
+#define SATA0_pinout_get_spdsel(data)                                 ((0x00000002&(data))>>1)
+#define SATA0_pinout_get_enable(data)                                 (0x00000001&(data))
+
+#define SATA0_timeout                                                 0x18012BF4
+#define SATA0_timeout_reg_addr                                        "0xB8012BF4"
+#define SATA0_timeout_reg                                             0xB8012BF4
+#define SATA0_timeout_inst_addr                                       "0x02FD"
+#define SATA0_timeout_inst                                            0x02FD
+#define SATA0_timeout_timeout_flg_shift                               (28)
+#define SATA0_timeout_timeout_en_shift                                (16)
+#define SATA0_timeout_timeout_cnt_shift                               (0)
+#define SATA0_timeout_timeout_flg_mask                                (0x10000000)
+#define SATA0_timeout_timeout_en_mask                                 (0x00010000)
+#define SATA0_timeout_timeout_cnt_mask                                (0x0000FFFF)
+#define SATA0_timeout_timeout_flg(data)                               (0x10000000&((data)<<28))
+#define SATA0_timeout_timeout_en(data)                                (0x00010000&((data)<<16))
+#define SATA0_timeout_timeout_cnt(data)                               (0x0000FFFF&(data))
+#define SATA0_timeout_get_timeout_flg(data)                           ((0x10000000&(data))>>28)
+#define SATA0_timeout_get_timeout_en(data)                            ((0x00010000&(data))>>16)
+#define SATA0_timeout_get_timeout_cnt(data)                           (0x0000FFFF&(data))
+
+#define SATA0_dbg                                                     0x18012BF8
+#define SATA0_dbg_reg_addr                                            "0xB8012BF8"
+#define SATA0_dbg_reg                                                 0xB8012BF8
+#define SATA0_dbg_inst_addr                                           "0x02FE"
+#define SATA0_dbg_inst                                                0x02FE
+#define SATA0_dbg_write_enable4_shift                                 (28)
+#define SATA0_dbg_test_key_shift                                      (12)
+#define SATA0_dbg_write_enable3_shift                                 (9)
+#define SATA0_dbg_sel1_shift                                          (6)
+#define SATA0_dbg_write_enable2_shift                                 (5)
+#define SATA0_dbg_sel0_shift                                          (2)
+#define SATA0_dbg_write_enable1_shift                                 (1)
+#define SATA0_dbg_enable_shift                                        (0)
+#define SATA0_dbg_write_enable4_mask                                  (0x10000000)
+#define SATA0_dbg_test_key_mask                                       (0x0FFFF000)
+#define SATA0_dbg_write_enable3_mask                                  (0x00000200)
+#define SATA0_dbg_sel1_mask                                           (0x000001C0)
+#define SATA0_dbg_write_enable2_mask                                  (0x00000020)
+#define SATA0_dbg_sel0_mask                                           (0x0000001C)
+#define SATA0_dbg_write_enable1_mask                                  (0x00000002)
+#define SATA0_dbg_enable_mask                                         (0x00000001)
+#define SATA0_dbg_write_enable4(data)                                 (0x10000000&((data)<<28))
+#define SATA0_dbg_test_key(data)                                      (0x0FFFF000&((data)<<12))
+#define SATA0_dbg_write_enable3(data)                                 (0x00000200&((data)<<9))
+#define SATA0_dbg_sel1(data)                                          (0x000001C0&((data)<<6))
+#define SATA0_dbg_write_enable2(data)                                 (0x00000020&((data)<<5))
+#define SATA0_dbg_sel0(data)                                          (0x0000001C&((data)<<2))
+#define SATA0_dbg_write_enable1(data)                                 (0x00000002&((data)<<1))
+#define SATA0_dbg_enable(data)                                        (0x00000001&(data))
+#define SATA0_dbg_get_write_enable4(data)                             ((0x10000000&(data))>>28)
+#define SATA0_dbg_get_test_key(data)                                  ((0x0FFFF000&(data))>>12)
+#define SATA0_dbg_get_write_enable3(data)                             ((0x00000200&(data))>>9)
+#define SATA0_dbg_get_sel1(data)                                      ((0x000001C0&(data))>>6)
+#define SATA0_dbg_get_write_enable2(data)                             ((0x00000020&(data))>>5)
+#define SATA0_dbg_get_sel0(data)                                      ((0x0000001C&(data))>>2)
+#define SATA0_dbg_get_write_enable1(data)                             ((0x00000002&(data))>>1)
+#define SATA0_dbg_get_enable(data)                                    (0x00000001&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sata1_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sata1_reg.h
new file mode 100644
index 00000000..dbb8f53
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sata1_reg.h
@@ -0,0 +1,635 @@
+// This file is generated using the spec version 2.0, firmware template version 1.39and DVR_Parser_0.46
+#ifndef _SATA1_REG_H_INCLUDED_
+#define _SATA1_REG_H_INCLUDED_
+
+//#define  _SATA1_USE_STRUCT
+#ifdef _SATA1_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data:16;
+}sata1_CDR0;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data_p:8;
+    unsigned int    data:8;
+}sata1_CDR1;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data_p:8;
+    unsigned int    data:8;
+}sata1_CDR2;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data_p:8;
+    unsigned int    data:8;
+}sata1_CDR3;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data_p:8;
+    unsigned int    data:8;
+}sata1_CDR4;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    data_p:8;
+    unsigned int    data:8;
+}sata1_CDR5;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}sata1_CDR6;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}sata1_CDR7;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    data:8;
+}sata1_CLR0;
+
+typedef struct
+{
+    unsigned int    sstatus:32;
+}sata1_SCR0;
+
+typedef struct
+{
+    unsigned int    serror:32;
+}sata1_SCR1;
+
+typedef struct
+{
+    unsigned int    scontrol:32;
+}sata1_SCR2;
+
+typedef struct
+{
+    unsigned int    sactive:32;
+}sata1_SCR3;
+
+typedef struct
+{
+    unsigned int    snotification:32;
+}sata1_SCR4;
+
+typedef struct
+{
+    unsigned int    reserved_0:32;
+}sata1_SCR5;
+
+typedef struct
+{
+    unsigned int    reserved_0:15;
+    unsigned int    reg_mode:1;
+    unsigned int    prd_num:8;
+    unsigned int    reserved_1:1;
+    unsigned int    cpen:1;
+    unsigned int    srst:1;
+    unsigned int    self_test:1;
+    unsigned int    write:1;
+    unsigned int    reserved_2:2;
+    unsigned int    go:1;
+}sata1_DMACTRL;
+
+typedef struct
+{
+    unsigned int    prd_ptr:30;
+    unsigned int    reserved_0:2;
+}sata1_PRDPTR;
+
+typedef struct
+{
+    unsigned int    prd_pba:30;
+    unsigned int    reserved_0:2;
+}sata1_PRDEty0;
+
+typedef struct
+{
+    unsigned int    eot:1;
+    unsigned int    reserved_0:7;
+    unsigned int    prd_bycnt:22;
+    unsigned int    reserved_1:2;
+}sata1_PRDEty1;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    intrq_en:1;
+}sata1_enable;
+
+typedef struct
+{
+    unsigned int    reserved_0:12;
+    unsigned int    bridge_rlevel:4;
+    unsigned int    bridge_wlevel:4;
+    unsigned int    dma_flevel:4;
+    unsigned int    reserved_1:5;
+    unsigned int    cmd_swap:2;
+    unsigned int    data_swap:1;
+}sata1_DMAMisc;
+
+typedef struct
+{
+    unsigned int    data:16;
+    unsigned int    phy_adr:3;
+    unsigned int    reg_adr:5;
+    unsigned int    reserved_0:1;
+    unsigned int    mdio_st:2;
+    unsigned int    mdio_rdy:1;
+    unsigned int    mclk_rate:2;
+    unsigned int    mdio_srst:1;
+    unsigned int    mdio_rdwr:1;
+}sata1_MDIOCtrl;
+
+typedef struct
+{
+    unsigned int    crc:32;
+}sata1_DMACrc;
+
+typedef struct
+{
+    unsigned int    req_cnt:16;
+    unsigned int    reserved_0:3;
+    unsigned int    req_cnt_en:1;
+    unsigned int    reserved_1:2;
+    unsigned int    tx_data_vld:1;
+    unsigned int    rx_enable:1;
+    unsigned int    tx_enable:1;
+    unsigned int    reset_n:1;
+    unsigned int    slumber:1;
+    unsigned int    partial:1;
+    unsigned int    farafelb:1;
+    unsigned int    nearafelb:1;
+    unsigned int    spdsel:1;
+    unsigned int    enable:1;
+}sata1_pinout;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    timeout_flg:1;
+    unsigned int    reserved_1:11;
+    unsigned int    timeout_en:1;
+    unsigned int    timeout_cnt:16;
+}sata1_timeout;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    write_enable4:1;
+    unsigned int    test_key:16;
+    unsigned int    reserved_1:2;
+    unsigned int    write_enable3:1;
+    unsigned int    sel1:3;
+    unsigned int    write_enable2:1;
+    unsigned int    sel0:3;
+    unsigned int    write_enable1:1;
+    unsigned int    enable:1;
+}sata1_dbg;
+#endif
+
+#define SATA1_CDR0                                                    0x18012C00
+#define SATA1_CDR0_reg_addr                                           "0xB8012C00"
+#define SATA1_CDR0_reg                                                0xB8012C00
+#define SATA1_CDR0_inst_addr                                          "0x0300"
+#define SATA1_CDR0_inst                                               0x0300
+#define SATA1_CDR0_data_shift                                         (0)
+#define SATA1_CDR0_data_mask                                          (0x0000FFFF)
+#define SATA1_CDR0_data(data)                                         (0x0000FFFF&(data))
+#define SATA1_CDR0_get_data(data)                                     (0x0000FFFF&(data))
+
+#define SATA1_CDR1                                                    0x18012C04
+#define SATA1_CDR1_reg_addr                                           "0xB8012C04"
+#define SATA1_CDR1_reg                                                0xB8012C04
+#define SATA1_CDR1_inst_addr                                          "0x0301"
+#define SATA1_CDR1_inst                                               0x0301
+#define SATA1_CDR1_data_p_shift                                       (8)
+#define SATA1_CDR1_data_shift                                         (0)
+#define SATA1_CDR1_data_p_mask                                        (0x0000FF00)
+#define SATA1_CDR1_data_mask                                          (0x000000FF)
+#define SATA1_CDR1_data_p(data)                                       (0x0000FF00&((data)<<8))
+#define SATA1_CDR1_data(data)                                         (0x000000FF&(data))
+#define SATA1_CDR1_get_data_p(data)                                   ((0x0000FF00&(data))>>8)
+#define SATA1_CDR1_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA1_CDR2                                                    0x18012C08
+#define SATA1_CDR2_reg_addr                                           "0xB8012C08"
+#define SATA1_CDR2_reg                                                0xB8012C08
+#define SATA1_CDR2_inst_addr                                          "0x0302"
+#define SATA1_CDR2_inst                                               0x0302
+#define SATA1_CDR2_data_p_shift                                       (8)
+#define SATA1_CDR2_data_shift                                         (0)
+#define SATA1_CDR2_data_p_mask                                        (0x0000FF00)
+#define SATA1_CDR2_data_mask                                          (0x000000FF)
+#define SATA1_CDR2_data_p(data)                                       (0x0000FF00&((data)<<8))
+#define SATA1_CDR2_data(data)                                         (0x000000FF&(data))
+#define SATA1_CDR2_get_data_p(data)                                   ((0x0000FF00&(data))>>8)
+#define SATA1_CDR2_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA1_CDR3                                                    0x18012C0C
+#define SATA1_CDR3_reg_addr                                           "0xB8012C0C"
+#define SATA1_CDR3_reg                                                0xB8012C0C
+#define SATA1_CDR3_inst_addr                                          "0x0303"
+#define SATA1_CDR3_inst                                               0x0303
+#define SATA1_CDR3_data_p_shift                                       (8)
+#define SATA1_CDR3_data_shift                                         (0)
+#define SATA1_CDR3_data_p_mask                                        (0x0000FF00)
+#define SATA1_CDR3_data_mask                                          (0x000000FF)
+#define SATA1_CDR3_data_p(data)                                       (0x0000FF00&((data)<<8))
+#define SATA1_CDR3_data(data)                                         (0x000000FF&(data))
+#define SATA1_CDR3_get_data_p(data)                                   ((0x0000FF00&(data))>>8)
+#define SATA1_CDR3_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA1_CDR4                                                    0x18012C10
+#define SATA1_CDR4_reg_addr                                           "0xB8012C10"
+#define SATA1_CDR4_reg                                                0xB8012C10
+#define SATA1_CDR4_inst_addr                                          "0x0304"
+#define SATA1_CDR4_inst                                               0x0304
+#define SATA1_CDR4_data_p_shift                                       (8)
+#define SATA1_CDR4_data_shift                                         (0)
+#define SATA1_CDR4_data_p_mask                                        (0x0000FF00)
+#define SATA1_CDR4_data_mask                                          (0x000000FF)
+#define SATA1_CDR4_data_p(data)                                       (0x0000FF00&((data)<<8))
+#define SATA1_CDR4_data(data)                                         (0x000000FF&(data))
+#define SATA1_CDR4_get_data_p(data)                                   ((0x0000FF00&(data))>>8)
+#define SATA1_CDR4_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA1_CDR5                                                    0x18012C14
+#define SATA1_CDR5_reg_addr                                           "0xB8012C14"
+#define SATA1_CDR5_reg                                                0xB8012C14
+#define SATA1_CDR5_inst_addr                                          "0x0305"
+#define SATA1_CDR5_inst                                               0x0305
+#define SATA1_CDR5_data_p_shift                                       (8)
+#define SATA1_CDR5_data_shift                                         (0)
+#define SATA1_CDR5_data_p_mask                                        (0x0000FF00)
+#define SATA1_CDR5_data_mask                                          (0x000000FF)
+#define SATA1_CDR5_data_p(data)                                       (0x0000FF00&((data)<<8))
+#define SATA1_CDR5_data(data)                                         (0x000000FF&(data))
+#define SATA1_CDR5_get_data_p(data)                                   ((0x0000FF00&(data))>>8)
+#define SATA1_CDR5_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA1_CDR6                                                    0x18012C18
+#define SATA1_CDR6_reg_addr                                           "0xB8012C18"
+#define SATA1_CDR6_reg                                                0xB8012C18
+#define SATA1_CDR6_inst_addr                                          "0x0306"
+#define SATA1_CDR6_inst                                               0x0306
+#define SATA1_CDR6_data_shift                                         (0)
+#define SATA1_CDR6_data_mask                                          (0x000000FF)
+#define SATA1_CDR6_data(data)                                         (0x000000FF&(data))
+#define SATA1_CDR6_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA1_CDR7                                                    0x18012C1C
+#define SATA1_CDR7_reg_addr                                           "0xB8012C1C"
+#define SATA1_CDR7_reg                                                0xB8012C1C
+#define SATA1_CDR7_inst_addr                                          "0x0307"
+#define SATA1_CDR7_inst                                               0x0307
+#define SATA1_CDR7_data_shift                                         (0)
+#define SATA1_CDR7_data_mask                                          (0x000000FF)
+#define SATA1_CDR7_data(data)                                         (0x000000FF&(data))
+#define SATA1_CDR7_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA1_CLR0                                                    0x18012C20
+#define SATA1_CLR0_reg_addr                                           "0xB8012C20"
+#define SATA1_CLR0_reg                                                0xB8012C20
+#define SATA1_CLR0_inst_addr                                          "0x0308"
+#define SATA1_CLR0_inst                                               0x0308
+#define SATA1_CLR0_data_shift                                         (0)
+#define SATA1_CLR0_data_mask                                          (0x000000FF)
+#define SATA1_CLR0_data(data)                                         (0x000000FF&(data))
+#define SATA1_CLR0_get_data(data)                                     (0x000000FF&(data))
+
+#define SATA1_SCR0                                                    0x18012C24
+#define SATA1_SCR0_reg_addr                                           "0xB8012C24"
+#define SATA1_SCR0_reg                                                0xB8012C24
+#define SATA1_SCR0_inst_addr                                          "0x0309"
+#define SATA1_SCR0_inst                                               0x0309
+#define SATA1_SCR0_sstatus_shift                                      (0)
+#define SATA1_SCR0_sstatus_mask                                       (0xFFFFFFFF)
+#define SATA1_SCR0_sstatus(data)                                      (0xFFFFFFFF&(data))
+#define SATA1_SCR0_get_sstatus(data)                                  (0xFFFFFFFF&(data))
+
+#define SATA1_SCR1                                                    0x18012C28
+#define SATA1_SCR1_reg_addr                                           "0xB8012C28"
+#define SATA1_SCR1_reg                                                0xB8012C28
+#define SATA1_SCR1_inst_addr                                          "0x030A"
+#define SATA1_SCR1_inst                                               0x030A
+#define SATA1_SCR1_serror_shift                                       (0)
+#define SATA1_SCR1_serror_mask                                        (0xFFFFFFFF)
+#define SATA1_SCR1_serror(data)                                       (0xFFFFFFFF&(data))
+#define SATA1_SCR1_get_serror(data)                                   (0xFFFFFFFF&(data))
+
+#define SATA1_SCR2                                                    0x18012C2C
+#define SATA1_SCR2_reg_addr                                           "0xB8012C2C"
+#define SATA1_SCR2_reg                                                0xB8012C2C
+#define SATA1_SCR2_inst_addr                                          "0x030B"
+#define SATA1_SCR2_inst                                               0x030B
+#define SATA1_SCR2_scontrol_shift                                     (0)
+#define SATA1_SCR2_scontrol_mask                                      (0xFFFFFFFF)
+#define SATA1_SCR2_scontrol(data)                                     (0xFFFFFFFF&(data))
+#define SATA1_SCR2_get_scontrol(data)                                 (0xFFFFFFFF&(data))
+
+#define SATA1_SCR3                                                    0x18012C30
+#define SATA1_SCR3_reg_addr                                           "0xB8012C30"
+#define SATA1_SCR3_reg                                                0xB8012C30
+#define SATA1_SCR3_inst_addr                                          "0x030C"
+#define SATA1_SCR3_inst                                               0x030C
+#define SATA1_SCR3_sactive_shift                                      (0)
+#define SATA1_SCR3_sactive_mask                                       (0xFFFFFFFF)
+#define SATA1_SCR3_sactive(data)                                      (0xFFFFFFFF&(data))
+#define SATA1_SCR3_get_sactive(data)                                  (0xFFFFFFFF&(data))
+
+#define SATA1_SCR4                                                    0x18012C34
+#define SATA1_SCR4_reg_addr                                           "0xB8012C34"
+#define SATA1_SCR4_reg                                                0xB8012C34
+#define SATA1_SCR4_inst_addr                                          "0x030D"
+#define SATA1_SCR4_inst                                               0x030D
+#define SATA1_SCR4_snotification_shift                                (0)
+#define SATA1_SCR4_snotification_mask                                 (0xFFFFFFFF)
+#define SATA1_SCR4_snotification(data)                                (0xFFFFFFFF&(data))
+#define SATA1_SCR4_get_snotification(data)                            (0xFFFFFFFF&(data))
+
+#define SATA1_SCR5                                                    0x18012C38
+#define SATA1_SCR5_reg_addr                                           "0xB8012C38"
+#define SATA1_SCR5_reg                                                0xB8012C38
+#define SATA1_SCR5_inst_addr                                          "0x030E"
+#define SATA1_SCR5_inst                                               0x030E
+
+#define SATA1_DMACTRL                                                 0x18012CD0
+#define SATA1_DMACTRL_reg_addr                                        "0xB8012CD0"
+#define SATA1_DMACTRL_reg                                             0xB8012CD0
+#define SATA1_DMACTRL_inst_addr                                       "0x0334"
+#define SATA1_DMACTRL_inst                                            0x0334
+#define SATA1_DMACTRL_reg_mode_shift                                  (16)
+#define SATA1_DMACTRL_prd_num_shift                                   (8)
+#define SATA1_DMACTRL_cpen_shift                                      (6)
+#define SATA1_DMACTRL_srst_shift                                      (5)
+#define SATA1_DMACTRL_self_test_shift                                 (4)
+#define SATA1_DMACTRL_write_shift                                     (3)
+#define SATA1_DMACTRL_go_shift                                        (0)
+#define SATA1_DMACTRL_reg_mode_mask                                   (0x00010000)
+#define SATA1_DMACTRL_prd_num_mask                                    (0x0000FF00)
+#define SATA1_DMACTRL_cpen_mask                                       (0x00000040)
+#define SATA1_DMACTRL_srst_mask                                       (0x00000020)
+#define SATA1_DMACTRL_self_test_mask                                  (0x00000010)
+#define SATA1_DMACTRL_write_mask                                      (0x00000008)
+#define SATA1_DMACTRL_go_mask                                         (0x00000001)
+#define SATA1_DMACTRL_reg_mode(data)                                  (0x00010000&((data)<<16))
+#define SATA1_DMACTRL_prd_num(data)                                   (0x0000FF00&((data)<<8))
+#define SATA1_DMACTRL_cpen(data)                                      (0x00000040&((data)<<6))
+#define SATA1_DMACTRL_srst(data)                                      (0x00000020&((data)<<5))
+#define SATA1_DMACTRL_self_test(data)                                 (0x00000010&((data)<<4))
+#define SATA1_DMACTRL_write(data)                                     (0x00000008&((data)<<3))
+#define SATA1_DMACTRL_go(data)                                        (0x00000001&(data))
+#define SATA1_DMACTRL_get_reg_mode(data)                              ((0x00010000&(data))>>16)
+#define SATA1_DMACTRL_get_prd_num(data)                               ((0x0000FF00&(data))>>8)
+#define SATA1_DMACTRL_get_cpen(data)                                  ((0x00000040&(data))>>6)
+#define SATA1_DMACTRL_get_srst(data)                                  ((0x00000020&(data))>>5)
+#define SATA1_DMACTRL_get_self_test(data)                             ((0x00000010&(data))>>4)
+#define SATA1_DMACTRL_get_write(data)                                 ((0x00000008&(data))>>3)
+#define SATA1_DMACTRL_get_go(data)                                    (0x00000001&(data))
+
+#define SATA1_PRDPTR                                                  0x18012CD4
+#define SATA1_PRDPTR_reg_addr                                         "0xB8012CD4"
+#define SATA1_PRDPTR_reg                                              0xB8012CD4
+#define SATA1_PRDPTR_inst_addr                                        "0x0335"
+#define SATA1_PRDPTR_inst                                             0x0335
+#define SATA1_PRDPTR_prd_ptr_shift                                    (2)
+#define SATA1_PRDPTR_prd_ptr_mask                                     (0xFFFFFFFC)
+#define SATA1_PRDPTR_prd_ptr(data)                                    (0xFFFFFFFC&((data)<<2))
+#define SATA1_PRDPTR_get_prd_ptr(data)                                ((0xFFFFFFFC&(data))>>2)
+
+#define SATA1_PRDEty0                                                 0x18012CD8
+#define SATA1_PRDEty0_reg_addr                                        "0xB8012CD8"
+#define SATA1_PRDEty0_reg                                             0xB8012CD8
+#define SATA1_PRDEty0_inst_addr                                       "0x0336"
+#define SATA1_PRDEty0_inst                                            0x0336
+#define SATA1_PRDEty0_prd_pba_shift                                   (2)
+#define SATA1_PRDEty0_prd_pba_mask                                    (0xFFFFFFFC)
+#define SATA1_PRDEty0_prd_pba(data)                                   (0xFFFFFFFC&((data)<<2))
+#define SATA1_PRDEty0_get_prd_pba(data)                               ((0xFFFFFFFC&(data))>>2)
+
+#define SATA1_PRDEty1                                                 0x18012CDC
+#define SATA1_PRDEty1_reg_addr                                        "0xB8012CDC"
+#define SATA1_PRDEty1_reg                                             0xB8012CDC
+#define SATA1_PRDEty1_inst_addr                                       "0x0337"
+#define SATA1_PRDEty1_inst                                            0x0337
+#define SATA1_PRDEty1_eot_shift                                       (31)
+#define SATA1_PRDEty1_prd_bycnt_shift                                 (2)
+#define SATA1_PRDEty1_eot_mask                                        (0x80000000)
+#define SATA1_PRDEty1_prd_bycnt_mask                                  (0x00FFFFFC)
+#define SATA1_PRDEty1_eot(data)                                       (0x80000000&((data)<<31))
+#define SATA1_PRDEty1_prd_bycnt(data)                                 (0x00FFFFFC&((data)<<2))
+#define SATA1_PRDEty1_get_eot(data)                                   ((0x80000000&(data))>>31)
+#define SATA1_PRDEty1_get_prd_bycnt(data)                             ((0x00FFFFFC&(data))>>2)
+
+#define SATA1_enable                                                  0x18012CE0
+#define SATA1_enable_reg_addr                                         "0xB8012CE0"
+#define SATA1_enable_reg                                              0xB8012CE0
+#define SATA1_enable_inst_addr                                        "0x0338"
+#define SATA1_enable_inst                                             0x0338
+#define SATA1_enable_intrq_en_shift                                   (0)
+#define SATA1_enable_intrq_en_mask                                    (0x00000001)
+#define SATA1_enable_intrq_en(data)                                   (0x00000001&(data))
+#define SATA1_enable_get_intrq_en(data)                               (0x00000001&(data))
+
+#define SATA1_DMAMisc                                                 0x18012CE4
+#define SATA1_DMAMisc_reg_addr                                        "0xB8012CE4"
+#define SATA1_DMAMisc_reg                                             0xB8012CE4
+#define SATA1_DMAMisc_inst_addr                                       "0x0339"
+#define SATA1_DMAMisc_inst                                            0x0339
+#define SATA1_DMAMisc_bridge_rlevel_shift                             (16)
+#define SATA1_DMAMisc_bridge_wlevel_shift                             (12)
+#define SATA1_DMAMisc_dma_flevel_shift                                (8)
+#define SATA1_DMAMisc_cmd_swap_shift                                  (1)
+#define SATA1_DMAMisc_data_swap_shift                                 (0)
+#define SATA1_DMAMisc_bridge_rlevel_mask                              (0x000F0000)
+#define SATA1_DMAMisc_bridge_wlevel_mask                              (0x0000F000)
+#define SATA1_DMAMisc_dma_flevel_mask                                 (0x00000F00)
+#define SATA1_DMAMisc_cmd_swap_mask                                   (0x00000006)
+#define SATA1_DMAMisc_data_swap_mask                                  (0x00000001)
+#define SATA1_DMAMisc_bridge_rlevel(data)                             (0x000F0000&((data)<<16))
+#define SATA1_DMAMisc_bridge_wlevel(data)                             (0x0000F000&((data)<<12))
+#define SATA1_DMAMisc_dma_flevel(data)                                (0x00000F00&((data)<<8))
+#define SATA1_DMAMisc_cmd_swap(data)                                  (0x00000006&((data)<<1))
+#define SATA1_DMAMisc_data_swap(data)                                 (0x00000001&(data))
+#define SATA1_DMAMisc_get_bridge_rlevel(data)                         ((0x000F0000&(data))>>16)
+#define SATA1_DMAMisc_get_bridge_wlevel(data)                         ((0x0000F000&(data))>>12)
+#define SATA1_DMAMisc_get_dma_flevel(data)                            ((0x00000F00&(data))>>8)
+#define SATA1_DMAMisc_get_cmd_swap(data)                              ((0x00000006&(data))>>1)
+#define SATA1_DMAMisc_get_data_swap(data)                             (0x00000001&(data))
+
+#define SATA1_MDIOCtrl                                                0x18012CE8
+#define SATA1_MDIOCtrl_reg_addr                                       "0xB8012CE8"
+#define SATA1_MDIOCtrl_reg                                            0xB8012CE8
+#define SATA1_MDIOCtrl_inst_addr                                      "0x033A"
+#define SATA1_MDIOCtrl_inst                                           0x033A
+#define SATA1_MDIOCtrl_data_shift                                     (16)
+#define SATA1_MDIOCtrl_phy_adr_shift                                  (13)
+#define SATA1_MDIOCtrl_reg_adr_shift                                  (8)
+#define SATA1_MDIOCtrl_mdio_st_shift                                  (5)
+#define SATA1_MDIOCtrl_mdio_rdy_shift                                 (4)
+#define SATA1_MDIOCtrl_mclk_rate_shift                                (2)
+#define SATA1_MDIOCtrl_mdio_srst_shift                                (1)
+#define SATA1_MDIOCtrl_mdio_rdwr_shift                                (0)
+#define SATA1_MDIOCtrl_data_mask                                      (0xFFFF0000)
+#define SATA1_MDIOCtrl_phy_adr_mask                                   (0x0000E000)
+#define SATA1_MDIOCtrl_reg_adr_mask                                   (0x00001F00)
+#define SATA1_MDIOCtrl_mdio_st_mask                                   (0x00000060)
+#define SATA1_MDIOCtrl_mdio_rdy_mask                                  (0x00000010)
+#define SATA1_MDIOCtrl_mclk_rate_mask                                 (0x0000000C)
+#define SATA1_MDIOCtrl_mdio_srst_mask                                 (0x00000002)
+#define SATA1_MDIOCtrl_mdio_rdwr_mask                                 (0x00000001)
+#define SATA1_MDIOCtrl_data(data)                                     (0xFFFF0000&((data)<<16))
+#define SATA1_MDIOCtrl_phy_adr(data)                                  (0x0000E000&((data)<<13))
+#define SATA1_MDIOCtrl_reg_adr(data)                                  (0x00001F00&((data)<<8))
+#define SATA1_MDIOCtrl_mdio_st(data)                                  (0x00000060&((data)<<5))
+#define SATA1_MDIOCtrl_mdio_rdy(data)                                 (0x00000010&((data)<<4))
+#define SATA1_MDIOCtrl_mclk_rate(data)                                (0x0000000C&((data)<<2))
+#define SATA1_MDIOCtrl_mdio_srst(data)                                (0x00000002&((data)<<1))
+#define SATA1_MDIOCtrl_mdio_rdwr(data)                                (0x00000001&(data))
+#define SATA1_MDIOCtrl_get_data(data)                                 ((0xFFFF0000&(data))>>16)
+#define SATA1_MDIOCtrl_get_phy_adr(data)                              ((0x0000E000&(data))>>13)
+#define SATA1_MDIOCtrl_get_reg_adr(data)                              ((0x00001F00&(data))>>8)
+#define SATA1_MDIOCtrl_get_mdio_st(data)                              ((0x00000060&(data))>>5)
+#define SATA1_MDIOCtrl_get_mdio_rdy(data)                             ((0x00000010&(data))>>4)
+#define SATA1_MDIOCtrl_get_mclk_rate(data)                            ((0x0000000C&(data))>>2)
+#define SATA1_MDIOCtrl_get_mdio_srst(data)                            ((0x00000002&(data))>>1)
+#define SATA1_MDIOCtrl_get_mdio_rdwr(data)                            (0x00000001&(data))
+
+#define SATA1_DMACrc                                                  0x18012CEC
+#define SATA1_DMACrc_reg_addr                                         "0xB8012CEC"
+#define SATA1_DMACrc_reg                                              0xB8012CEC
+#define SATA1_DMACrc_inst_addr                                        "0x033B"
+#define SATA1_DMACrc_inst                                             0x033B
+#define SATA1_DMACrc_crc_shift                                        (0)
+#define SATA1_DMACrc_crc_mask                                         (0xFFFFFFFF)
+#define SATA1_DMACrc_crc(data)                                        (0xFFFFFFFF&(data))
+#define SATA1_DMACrc_get_crc(data)                                    (0xFFFFFFFF&(data))
+
+#define SATA1_pinout                                                  0x18012CF0
+#define SATA1_pinout_reg_addr                                         "0xB8012CF0"
+#define SATA1_pinout_reg                                              0xB8012CF0
+#define SATA1_pinout_inst_addr                                        "0x033C"
+#define SATA1_pinout_inst                                             0x033C
+#define SATA1_pinout_req_cnt_shift                                    (16)
+#define SATA1_pinout_req_cnt_en_shift                                 (12)
+#define SATA1_pinout_tx_data_vld_shift                                (9)
+#define SATA1_pinout_rx_enable_shift                                  (8)
+#define SATA1_pinout_tx_enable_shift                                  (7)
+#define SATA1_pinout_reset_n_shift                                    (6)
+#define SATA1_pinout_slumber_shift                                    (5)
+#define SATA1_pinout_partial_shift                                    (4)
+#define SATA1_pinout_farafelb_shift                                   (3)
+#define SATA1_pinout_nearafelb_shift                                  (2)
+#define SATA1_pinout_spdsel_shift                                     (1)
+#define SATA1_pinout_enable_shift                                     (0)
+#define SATA1_pinout_req_cnt_mask                                     (0xFFFF0000)
+#define SATA1_pinout_req_cnt_en_mask                                  (0x00001000)
+#define SATA1_pinout_tx_data_vld_mask                                 (0x00000200)
+#define SATA1_pinout_rx_enable_mask                                   (0x00000100)
+#define SATA1_pinout_tx_enable_mask                                   (0x00000080)
+#define SATA1_pinout_reset_n_mask                                     (0x00000040)
+#define SATA1_pinout_slumber_mask                                     (0x00000020)
+#define SATA1_pinout_partial_mask                                     (0x00000010)
+#define SATA1_pinout_farafelb_mask                                    (0x00000008)
+#define SATA1_pinout_nearafelb_mask                                   (0x00000004)
+#define SATA1_pinout_spdsel_mask                                      (0x00000002)
+#define SATA1_pinout_enable_mask                                      (0x00000001)
+#define SATA1_pinout_req_cnt(data)                                    (0xFFFF0000&((data)<<16))
+#define SATA1_pinout_req_cnt_en(data)                                 (0x00001000&((data)<<12))
+#define SATA1_pinout_tx_data_vld(data)                                (0x00000200&((data)<<9))
+#define SATA1_pinout_rx_enable(data)                                  (0x00000100&((data)<<8))
+#define SATA1_pinout_tx_enable(data)                                  (0x00000080&((data)<<7))
+#define SATA1_pinout_reset_n(data)                                    (0x00000040&((data)<<6))
+#define SATA1_pinout_slumber(data)                                    (0x00000020&((data)<<5))
+#define SATA1_pinout_partial(data)                                    (0x00000010&((data)<<4))
+#define SATA1_pinout_farafelb(data)                                   (0x00000008&((data)<<3))
+#define SATA1_pinout_nearafelb(data)                                  (0x00000004&((data)<<2))
+#define SATA1_pinout_spdsel(data)                                     (0x00000002&((data)<<1))
+#define SATA1_pinout_enable(data)                                     (0x00000001&(data))
+#define SATA1_pinout_get_req_cnt(data)                                ((0xFFFF0000&(data))>>16)
+#define SATA1_pinout_get_req_cnt_en(data)                             ((0x00001000&(data))>>12)
+#define SATA1_pinout_get_tx_data_vld(data)                            ((0x00000200&(data))>>9)
+#define SATA1_pinout_get_rx_enable(data)                              ((0x00000100&(data))>>8)
+#define SATA1_pinout_get_tx_enable(data)                              ((0x00000080&(data))>>7)
+#define SATA1_pinout_get_reset_n(data)                                ((0x00000040&(data))>>6)
+#define SATA1_pinout_get_slumber(data)                                ((0x00000020&(data))>>5)
+#define SATA1_pinout_get_partial(data)                                ((0x00000010&(data))>>4)
+#define SATA1_pinout_get_farafelb(data)                               ((0x00000008&(data))>>3)
+#define SATA1_pinout_get_nearafelb(data)                              ((0x00000004&(data))>>2)
+#define SATA1_pinout_get_spdsel(data)                                 ((0x00000002&(data))>>1)
+#define SATA1_pinout_get_enable(data)                                 (0x00000001&(data))
+
+#define SATA1_timeout                                                 0x18012CF4
+#define SATA1_timeout_reg_addr                                        "0xB8012CF4"
+#define SATA1_timeout_reg                                             0xB8012CF4
+#define SATA1_timeout_inst_addr                                       "0x033D"
+#define SATA1_timeout_inst                                            0x033D
+#define SATA1_timeout_timeout_flg_shift                               (28)
+#define SATA1_timeout_timeout_en_shift                                (16)
+#define SATA1_timeout_timeout_cnt_shift                               (0)
+#define SATA1_timeout_timeout_flg_mask                                (0x10000000)
+#define SATA1_timeout_timeout_en_mask                                 (0x00010000)
+#define SATA1_timeout_timeout_cnt_mask                                (0x0000FFFF)
+#define SATA1_timeout_timeout_flg(data)                               (0x10000000&((data)<<28))
+#define SATA1_timeout_timeout_en(data)                                (0x00010000&((data)<<16))
+#define SATA1_timeout_timeout_cnt(data)                               (0x0000FFFF&(data))
+#define SATA1_timeout_get_timeout_flg(data)                           ((0x10000000&(data))>>28)
+#define SATA1_timeout_get_timeout_en(data)                            ((0x00010000&(data))>>16)
+#define SATA1_timeout_get_timeout_cnt(data)                           (0x0000FFFF&(data))
+
+#define SATA1_dbg                                                     0x18012CF8
+#define SATA1_dbg_reg_addr                                            "0xB8012CF8"
+#define SATA1_dbg_reg                                                 0xB8012CF8
+#define SATA1_dbg_inst_addr                                           "0x033E"
+#define SATA1_dbg_inst                                                0x033E
+#define SATA1_dbg_write_enable4_shift                                 (28)
+#define SATA1_dbg_test_key_shift                                      (12)
+#define SATA1_dbg_write_enable3_shift                                 (9)
+#define SATA1_dbg_sel1_shift                                          (6)
+#define SATA1_dbg_write_enable2_shift                                 (5)
+#define SATA1_dbg_sel0_shift                                          (2)
+#define SATA1_dbg_write_enable1_shift                                 (1)
+#define SATA1_dbg_enable_shift                                        (0)
+#define SATA1_dbg_write_enable4_mask                                  (0x10000000)
+#define SATA1_dbg_test_key_mask                                       (0x0FFFF000)
+#define SATA1_dbg_write_enable3_mask                                  (0x00000200)
+#define SATA1_dbg_sel1_mask                                           (0x000001C0)
+#define SATA1_dbg_write_enable2_mask                                  (0x00000020)
+#define SATA1_dbg_sel0_mask                                           (0x0000001C)
+#define SATA1_dbg_write_enable1_mask                                  (0x00000002)
+#define SATA1_dbg_enable_mask                                         (0x00000001)
+#define SATA1_dbg_write_enable4(data)                                 (0x10000000&((data)<<28))
+#define SATA1_dbg_test_key(data)                                      (0x0FFFF000&((data)<<12))
+#define SATA1_dbg_write_enable3(data)                                 (0x00000200&((data)<<9))
+#define SATA1_dbg_sel1(data)                                          (0x000001C0&((data)<<6))
+#define SATA1_dbg_write_enable2(data)                                 (0x00000020&((data)<<5))
+#define SATA1_dbg_sel0(data)                                          (0x0000001C&((data)<<2))
+#define SATA1_dbg_write_enable1(data)                                 (0x00000002&((data)<<1))
+#define SATA1_dbg_enable(data)                                        (0x00000001&(data))
+#define SATA1_dbg_get_write_enable4(data)                             ((0x10000000&(data))>>28)
+#define SATA1_dbg_get_test_key(data)                                  ((0x0FFFF000&(data))>>12)
+#define SATA1_dbg_get_write_enable3(data)                             ((0x00000200&(data))>>9)
+#define SATA1_dbg_get_sel1(data)                                      ((0x000001C0&(data))>>6)
+#define SATA1_dbg_get_write_enable2(data)                             ((0x00000020&(data))>>5)
+#define SATA1_dbg_get_sel0(data)                                      ((0x0000001C&(data))>>2)
+#define SATA1_dbg_get_write_enable1(data)                             ((0x00000002&(data))>>1)
+#define SATA1_dbg_get_enable(data)                                    (0x00000001&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/saturn.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/saturn.h
new file mode 100644
index 00000000..0af9b32
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/saturn.h
@@ -0,0 +1,1098 @@
+#ifndef _SYSTEM_H_20130219
+#define _SYSTEM_H_20130219
+
+#ifdef SCPU_ARM
+#ifndef ARM_ASM
+#include "diag.h"
+#include "arm_misc.h"
+#endif
+#endif
+#ifndef MIPS
+
+  #include "eregdef.h"
+
+  #define eret \
+      mfc0 k0,C0_EPC;\
+      jr   k0;\
+      rfe;
+  
+  #define sync \
+      lw  r0, 0xb801a020;
+  
+  #define CR_IP2    0x00000400
+  #define CR_IP3    0x00000800
+  #define CR_IP4    0x00001000
+  #define CR_IP5    0x00002000
+  #define CR_IP6    0x00004000
+  #define CR_IP7    0x00008000
+  
+#else
+  
+  #include "regdef.h"
+  #include "m32c0.h"
+
+  /*----- hardware registers names ---------------------*/
+  #define r0     $0    
+  #define r1     $at    
+  #define r2     $2    
+  #define r3     $3
+  #define r4     $4    
+  #define r5     $5
+  #define r6     $6
+  #define r7     $7
+  #define r8     $8    
+  #define r9     $9
+  #define r10    $10
+  #define r11    $11
+  #define r12    $12
+  #define r13    $13
+  #define r14    $14
+  #define r15    $15
+  #define r16    $16        
+  #define r17    $17
+  #define r18    $18
+  #define r19    $19
+  #define r20    $20
+  #define r21    $21
+  #define r22    $22
+  #define r23    $23
+  #define r24    $24        
+  #define r25    $25
+  #define r26    $26        
+  #define r27    $27
+  #define r28    $28        
+  #define r29    $29        
+  #define r30    $30        
+  #define r31    $31        
+#endif
+
+#define EXCP_BEV0_COMMON       0x80000100
+#define GIC_CONFIG_START       0x80000A00
+#define USER_PROG_START        0x80004000
+
+#define TEST_PASS              0x80003000
+#define TEST_FAIL              0x80003020
+#define TEST_PASS_SCPU         TEST_PASS
+#define TEST_FAIL_SCPU         TEST_FAIL
+#define TEST_PASS_VCPU         0x80103000
+#define TEST_FAIL_VCPU         0x80103020
+#define TEST_PASS_ACPU         0x80203000
+#define TEST_FAIL_ACPU         0x80203020
+#define TEST_PASS_KCPU         0x80303000
+#define TEST_FAIL_KCPU         0x80303020
+#define TEST_PASS_SCPU1        0x80303000
+#define TEST_FAIL_SCPU1        0x80303020
+
+#define STACK_START            0x80004000
+#define STACK_START_VCPU       0x80104000
+#define STACK_START_ACPU       0x80204000
+#define STACK_START_KCPU       0x80304000
+#define STACK_START_SCPU1      0x80304000
+
+#define USER_PROG_START_SCPU   0x80004000
+#define USER_PROG_START_VCPU   0x80104000
+#define USER_PROG_START_ACPU   0x80204000
+#define USER_PROG_START_KCPU   0x80304000
+#define USER_PROG_START_SCPU1  0x80304000
+
+#define INIT_MIPS_CACHE        0x80000400  /* whole-chip gatesim */
+
+/**********************************************************/
+/* single CPU - IRQ                                       */
+/**********************************************************/
+#define HW_INTVEC_BASE         0x80001000
+#define HW_INTVEC_ADDR8        0x80001040                      //IP8
+#define HW_INTVEC_ADDR9        (HW_INTVEC_ADDR8  + 0x04)       //IP9
+#define HW_INTVEC_ADDR10       (HW_INTVEC_ADDR9  + 0x04)       //IP10
+#define HW_INTVEC_ADDR11       (HW_INTVEC_ADDR10 + 0x04)       //IP11
+#define HW_INTVEC_ADDR12       (HW_INTVEC_ADDR11 + 0x04)       //IP12
+#define HW_INTVEC_ADDR13       (HW_INTVEC_ADDR12 + 0x04)       //IP13
+#define HW_INTVEC_ADDR14       (HW_INTVEC_ADDR13 + 0x04)       //IP14
+#define HW_INTVEC_ADDR15       (HW_INTVEC_ADDR14 + 0x04)       //IP15
+#define SW_INT_RET_ADDR        (HW_INTVEC_ADDR15 + 0x04)       //IP0..7
+
+/**********************************************************/
+/* whole system - IRQ                                     */
+/**********************************************************/
+/*SCPU*/
+#define HW_INTVEC_ADDR0_SCPU   0x80000300                      //IP0
+#define HW_INTVEC_ADDR1_SCPU   (HW_INTVEC_ADDR0_SCPU + 0x04)   //IP1
+#define HW_INTVEC_ADDR2_SCPU   (HW_INTVEC_ADDR1_SCPU + 0x04)   //IP2
+#define HW_INTVEC_ADDR3_SCPU   (HW_INTVEC_ADDR2_SCPU + 0x04)   //IP3
+#define HW_INTVEC_ADDR4_SCPU   (HW_INTVEC_ADDR3_SCPU + 0x04)   //IP4
+#define HW_INTVEC_ADDR5_SCPU   (HW_INTVEC_ADDR4_SCPU + 0x04)   //IP5
+#define HW_INTVEC_ADDR6_SCPU   (HW_INTVEC_ADDR5_SCPU + 0x04)   //IP6
+#define HW_INTVEC_ADDR7_SCPU   (HW_INTVEC_ADDR6_SCPU + 0x04)   //IP7
+
+#define HW_INTVEC_ADDR0        HW_INTVEC_ADDR0_SCPU
+#define HW_INTVEC_ADDR1        HW_INTVEC_ADDR1_SCPU
+#define HW_INTVEC_ADDR2        HW_INTVEC_ADDR2_SCPU
+#define HW_INTVEC_ADDR3        HW_INTVEC_ADDR3_SCPU
+#define HW_INTVEC_ADDR4        HW_INTVEC_ADDR4_SCPU
+#define HW_INTVEC_ADDR5        HW_INTVEC_ADDR5_SCPU
+#define HW_INTVEC_ADDR6        HW_INTVEC_ADDR6_SCPU
+#define HW_INTVEC_ADDR7        HW_INTVEC_ADDR7_SCPU
+
+#ifdef SCPU_ARM
+  #include "interrupts.h"
+  //extern unsigned int IntHandlers ;
+  //#define SET_INT(id, scpu_isr)  ((*((volatile*) ( ((unsigned int*)0x03f88000)+ id))) = (void*) scpu_isr)
+  #define SET_INT(id, scpu_isr)  ((*((volatile*) ( ((unsigned int*)0x8000B000)+ id))) = (void*) scpu_isr)
+#endif
+
+/*VCPU*/
+#define HW_INTVEC_BASE_VCPU    0x80101000
+#define HW_INTVEC_ADDR0_VCPU   0x80101040                      //IP0
+#define HW_INTVEC_ADDR1_VCPU   (HW_INTVEC_ADDR0_VCPU  + 0x04)  //IP1
+#define HW_INTVEC_ADDR2_VCPU   (HW_INTVEC_ADDR1_VCPU  + 0x04)  //IP2
+#define HW_INTVEC_ADDR3_VCPU   (HW_INTVEC_ADDR2_VCPU  + 0x04)  //IP3
+#define HW_INTVEC_ADDR4_VCPU   (HW_INTVEC_ADDR3_VCPU  + 0x04)  //IP4
+#define HW_INTVEC_ADDR5_VCPU   (HW_INTVEC_ADDR4_VCPU  + 0x04)  //IP5
+#define HW_INTVEC_ADDR6_VCPU   (HW_INTVEC_ADDR5_VCPU  + 0x04)  //IP6
+#define HW_INTVEC_ADDR7_VCPU   (HW_INTVEC_ADDR6_VCPU  + 0x04)  //IP7
+#define HW_INTVEC_ADDR8_VCPU   (HW_INTVEC_ADDR7_VCPU  + 0x04)  //IP8
+#define HW_INTVEC_ADDR9_VCPU   (HW_INTVEC_ADDR8_VCPU  + 0x04)  //IP9
+#define HW_INTVEC_ADDR10_VCPU  (HW_INTVEC_ADDR9_VCPU  + 0x04)  //IP10
+#define HW_INTVEC_ADDR11_VCPU  (HW_INTVEC_ADDR10_VCPU + 0x04)  //IP11
+#define HW_INTVEC_ADDR12_VCPU  (HW_INTVEC_ADDR11_VCPU + 0x04)  //IP12
+#define HW_INTVEC_ADDR13_VCPU  (HW_INTVEC_ADDR12_VCPU + 0x04)  //IP13
+#define HW_INTVEC_ADDR14_VCPU  (HW_INTVEC_ADDR13_VCPU + 0x04)  //IP14
+#define HW_INTVEC_ADDR15_VCPU  (HW_INTVEC_ADDR14_VCPU + 0x04)  //IP15
+#define SW_INT_RET_ADDR_VCPU   (HW_INTVEC_ADDR15_VCPU + 0x04)  //SW
+
+/*ACPU*/
+#define HW_INTVEC_BASE_ACPU    0x80201000
+#define HW_INTVEC_ADDR0_ACPU   0x80201040                      //IP0
+#define HW_INTVEC_ADDR1_ACPU   (HW_INTVEC_ADDR0_ACPU  + 0x04)  //IP1
+#define HW_INTVEC_ADDR2_ACPU   (HW_INTVEC_ADDR1_ACPU  + 0x04)  //IP2
+#define HW_INTVEC_ADDR3_ACPU   (HW_INTVEC_ADDR2_ACPU  + 0x04)  //IP3
+#define HW_INTVEC_ADDR4_ACPU   (HW_INTVEC_ADDR3_ACPU  + 0x04)  //IP4
+#define HW_INTVEC_ADDR5_ACPU   (HW_INTVEC_ADDR4_ACPU  + 0x04)  //IP5
+#define HW_INTVEC_ADDR6_ACPU   (HW_INTVEC_ADDR5_ACPU  + 0x04)  //IP6
+#define HW_INTVEC_ADDR7_ACPU   (HW_INTVEC_ADDR6_ACPU  + 0x04)  //IP7
+#define HW_INTVEC_ADDR8_ACPU   (HW_INTVEC_ADDR7_ACPU  + 0x04)  //IP8
+#define HW_INTVEC_ADDR9_ACPU   (HW_INTVEC_ADDR8_ACPU  + 0x04)  //IP9
+#define HW_INTVEC_ADDR10_ACPU  (HW_INTVEC_ADDR9_ACPU  + 0x04)  //IP10
+#define HW_INTVEC_ADDR11_ACPU  (HW_INTVEC_ADDR10_ACPU + 0x04)  //IP11
+#define HW_INTVEC_ADDR12_ACPU  (HW_INTVEC_ADDR11_ACPU + 0x04)  //IP12
+#define HW_INTVEC_ADDR13_ACPU  (HW_INTVEC_ADDR12_ACPU + 0x04)  //IP13
+#define HW_INTVEC_ADDR14_ACPU  (HW_INTVEC_ADDR13_ACPU + 0x04)  //IP14
+#define HW_INTVEC_ADDR15_ACPU  (HW_INTVEC_ADDR14_ACPU + 0x04)  //IP15
+#define SW_INT_RET_ADDR_ACPU   (HW_INTVEC_ADDR15_ACPU + 0x04)  //SW
+
+/*KCPU*/
+#define HW_INTVEC_ADDR0_KCPU   0x80300300                      //IP0
+#define HW_INTVEC_ADDR1_KCPU   (HW_INTVEC_ADDR0_KCPU + 0x04)   //IP1
+#define HW_INTVEC_ADDR2_KCPU   (HW_INTVEC_ADDR1_KCPU + 0x04)   //IP2
+#define HW_INTVEC_ADDR3_KCPU   (HW_INTVEC_ADDR2_KCPU + 0x04)   //IP3
+#define HW_INTVEC_ADDR4_KCPU   (HW_INTVEC_ADDR3_KCPU + 0x04)   //IP4
+#define HW_INTVEC_ADDR5_KCPU   (HW_INTVEC_ADDR4_KCPU + 0x04)   //IP5
+#define HW_INTVEC_ADDR6_KCPU   (HW_INTVEC_ADDR5_KCPU + 0x04)   //IP6
+#define HW_INTVEC_ADDR7_KCPU   (HW_INTVEC_ADDR6_KCPU + 0x04)   //IP7
+
+/**********************************************************/
+/* End of IRQ Definition                                  */
+/**********************************************************/
+
+#define C0_ESTATUS  $0
+#define C0_ECAUSE   $1
+#define C0_INTVEC   $2
+#define C3_CPUTAG   $16
+
+#include "mipi_aphy_reg.h"
+#include "mipi_dphy_reg.h"
+#include "mipi_wrapper_reg.h"
+#include "wrap_a7_reg.h"
+#include "sbx_reg.h"
+#include "me_reg.h"
+#include "ve_reg.h"
+#include "dc_reg.h"
+#include "dc_phy_reg.h"
+#include "se_reg.h"
+#include "vo_reg.h"
+#include "voregsram_reg.h"
+#include "vi_reg.h"
+#include "tvd_reg.h"
+#include "tve_reg.h"
+#include "hdmi_reg.h"
+#include "TV_IP/hdmi_rx_reg.h"
+#include "hdmirx_wrapper_reg.h"
+#include "cbus_wrapper_reg.h"
+#include "cbus_tx_reg.h"
+#include "aio_reg.h"
+#include "adsp_reg.h"
+#include "mcp_reg.h"
+#ifdef MCP_DEFINE
+#include "mcp_defines.h"
+#endif
+#include "m2m_reg.h"
+#include "ata0_reg.h"
+#include "ata1_reg.h"
+#include "cp_reg.h"
+#include "usb_reg.h"
+#include "sb1_reg.h"
+#include "sb2_reg.h"
+#include "rng_reg.h"
+#include "mis_reg.h"
+#include "otp_reg.h"
+#include "dp_reg.h"
+#include "gspi_reg.h"
+#include "iso_reg.h"
+#include "crt_sys_reg.h"
+#include "md_reg.h"
+#include "codeblkreg_reg.h"
+#include "cabac_p2_reg.h"
+#include "mvdblk_reg.h"
+#include "img_reg.h"
+#include "rif_reg_reg.h"
+#include "predblk_reg.h"
+#include "vma_reg.h"
+#include "deblk_reg.h"
+#include "rl_reg.h"
+#include "vp8_p2_reg.h"
+#include "efuse_reg.h"
+
+#include "sde_reg.h"
+#include "vde_reg.h"
+#include "sata0_reg.h"
+#include "sata1_reg.h"
+#include "nf_reg.h"
+#include "nf_swc_reg.h"
+#include "pcie_reg.h"
+#include "tp_reg.h"
+#include "cam_emm_reg.h"
+#include "sb0_reg.h"
+#include "sb3_reg.h"
+#include "sb4_reg.h"
+#include "icam_reg.h"
+
+
+#include "lvds_aif_reg.h"
+#include "lvds_dither_reg.h"
+#include "lvds_gamma_reg.h"
+#include "lvds_lvdsout_reg.h"
+#include "lvds_pif_reg.h"
+#include "lvds_sfdf_reg.h"
+
+
+/* Physical Memory Map */
+/*
+  virtual address
+bfc0_0180 - xxxx_xxxx exception handler bev=1 (uncached)in flash memory
+bfc0_0160 - bfc0_017f sdram parameters
+bfc0_0000 - xxxx_xxxx boot code (uncached) in flash memory
+
+
+
+8000_4000 - xxxx_xxxx diag code
+8000_3040 - 8000_4000 stack for C program
+8000_3020 - 8000_303f test_fail
+8000_3000 - 8000_301f test_pass
+8000_1000 - xxxx_xxxx vectored interrupts
+8000_0100 - 8000_017f exception handler bev=0 (shared)
+8000_00c0 - 8000_00df exception handler bev=0 (ACPU)
+8000_00a0 - 8000_00bf exception handler bev=0 (VCPU)
+8000_0080 - 8000_009f exception handler bev=0 (MIPS)
+8000_0000 - 
+*/
+
+/* bringup */
+#define BU_TEST_GO_SCPU        0xa0002000
+#define BU_TEST_GO_VCPU        0xa0002100
+#define BU_TEST_GO_ACPU        0xa0002200
+#define BU_TEST_GO_KCPU        0xa0002300
+#define BU_TEST_GO_SCPU2       0xa0002300
+
+#define BU_TEST_RESULT_SCPU    0xa0002004
+#define BU_TEST_RESULT_VCPU    0xa0002104
+#define BU_TEST_RESULT_ACPU    0xa0002204
+#define BU_TEST_RESULT_KCPU    0xa0002304
+#define BU_TEST_RESULT_SCPU2   0xa0002304
+
+#define BU_COUNTER_SCPU        0xa0002008
+#define BU_COUNTER_VCPU        0xa0002108
+#define BU_COUNTER_ACPU        0xa0002208
+#define BU_COUNTER_KCPU        0xa0002308
+#define BU_COUNTER_SCPU2       0xa0002308
+
+#define BU_RETURN_ADDR_SCPU    0xa000200c
+#define BU_RETURN_ADDR_VCPU    0xa000210c
+#define BU_RETURN_ADDR_ACPU    0xa000220c
+#define BU_RETURN_ADDR_KCPU    0xa000230c
+#define BU_RETURN_ADDR_SCPU2   0xa000230c
+
+#define BU_VO_DISP_FRAME_CNT   0xa0102100
+#define BU_VI_FIELD_CNT        0xa0102104
+
+/**********************************************************/
+/* DC Dummy Transactor Flags                              */
+/**********************************************************/
+#define VO0_DUMMY_BIT          0x10
+#define VO1_DUMMY_BIT          0x20
+#define VO2_DUMMY_BIT          0x40
+#define VO3_DUMMY_BIT          0x80
+#define SE_DUMMY_BIT           0x100
+#define AEE_DUMMY_BIT          0x200
+#define MD_DUMMY_BIT           0x400
+#define ETN_DUMMY_BIT          0x800
+#define CP_DUMMY_BIT           0x1000
+#define TP_DUMMY_BIT           0x2000
+#define AO_DUMMY_BIT           0x4000
+#define ADE_DUMMY_BIT          0x8000
+#define NF_DUMMY_BIT           0x10000
+#define SATA_DUMMY_BIT         0x20000
+#define CR_DUMMY_BIT           0x40000
+#define VDE_DUMMY_BIT          0x80000
+#define ME_DUMMY_BIT           0x100000
+#define VI_DUMMY_BIT           0x200000
+#define VE_DUMMY_BIT           0x400000
+#define ETN_MAC_DUMMY_BIT      0x800000
+#define USB_DUMMY_BIT          0x1000000
+#define MIPI_DUMMY_BIT         0x2000000
+#define GPU_DUMMY_BIT          0x4000000
+#define SCPU_DUMMY_BIT         0x8000000
+
+#define DC_TEST_GO_VO0         la reg1, SB2_DUMMY_0_reg; li reg2  0x0010; sw reg2,0(reg1)
+#define DC_TEST_GO_VO1         la reg1, SB2_DUMMY_0_reg; li reg2  0x0020; sw reg2,0(reg1)
+#define DC_TEST_GO_VO2         la reg1, SB2_DUMMY_0_reg; li reg2  0x0040; sw reg2,0(reg1)
+#define DC_TEST_GO_VO3         la reg1, SB2_DUMMY_0_reg; li reg2  0x0080; sw reg2,0(reg1)
+#define DC_TEST_GO_SE          la reg1, SB2_DUMMY_0_reg; li reg2  0x0100; sw reg2,0(reg1)
+#define DC_TEST_GO_AEE         la reg1, SB2_DUMMY_0_reg; li reg2  0x0200; sw reg2,0(reg1)
+#define DC_TEST_GO_MD          la reg1, SB2_DUMMY_0_reg; li reg2  0x0400; sw reg2,0(reg1)
+#define DC_TEST_GO_ETN         la reg1, SB2_DUMMY_0_reg; li reg2  0x0800; sw reg2,0(reg1)
+#define DC_TEST_GO_CP          la reg1, SB2_DUMMY_0_reg; li reg2  0x1000; sw reg2,0(reg1)
+#define DC_TEST_GO_TP          la reg1, SB2_DUMMY_0_reg; li reg2  0x2000; sw reg2,0(reg1)
+#define DC_TEST_GO_AO          la reg1, SB2_DUMMY_0_reg; li reg2  0x4000; sw reg2,0(reg1)
+#define DC_TEST_GO_ADE         la reg1, SB2_DUMMY_0_reg; li reg2  0x8000; sw reg2,0(reg1)
+
+#define DC_TEST_GO_NF          la reg1, SB2_DUMMY_0_reg; lui reg2 0x0001; sw reg2,0(reg1)
+#define DC_TEST_GO_SATA        la reg1, SB2_DUMMY_0_reg; lui reg2 0x0002; sw reg2,0(reg1)
+#define DC_TEST_GO_CR          la reg1, SB2_DUMMY_0_reg; lui reg2 0x0004; sw reg2,0(reg1)
+#define DC_TEST_GO_VDE         la reg1, SB2_DUMMY_0_reg; lui reg2 0x0008; sw reg2,0(reg1)
+#define DC_TEST_GO_ME          la reg1, SB2_DUMMY_0_reg; lui reg2 0x0010; sw reg2,0(reg1)
+#define DC_TEST_GO_VI          la reg1, SB2_DUMMY_0_reg; lui reg2 0x0020; sw reg2,0(reg1)
+#define DC_TEST_GO_VE          la reg1, SB2_DUMMY_0_reg; lui reg2 0x0040; sw reg2,0(reg1)
+#define DC_TEST_GO_ETN_MAC     la reg1, SB2_DUMMY_0_reg; lui reg2 0x0080; sw reg2,0(reg1)
+#define DC_TEST_GO_USB         la reg1, SB2_DUMMY_0_reg; lui reg2 0x0100; sw reg2,0(reg1)
+#define DC_TEST_GO_MIPI        la reg1, SB2_DUMMY_0_reg; lui reg2 0x0200; sw reg2,0(reg1)
+#define DC_TEST_GO_GPU         la reg1, SB2_DUMMY_0_reg; lui reg2 0x0400; sw reg2,0(reg1)
+#define DC_TEST_GO_SCPU        la reg1, SB2_DUMMY_0_reg; lui reg2 0x0800; sw reg2,0(reg1)
+
+/**********************************************************/
+/* End of DC Dummy Transactor Flags                       */
+/**********************************************************/
+
+//Note: this macro will check CPU type.
+#define BU_CHECK_CPU(index, reg1, reg2, reg3) \
+     beq reg1, reg2, 1f; \
+     nop; \
+     mfc0 reg3, C0_PRID; \
+     bne  reg3, 0xc601, 2f; \
+     lui  r1, 0xa000; \
+     mfc3 reg3, C3_CPUTAG; \
+     bne reg3, 0x6b656e68, 2f; \
+     ori  r1, 0x2210; \
+     ori  r1, 0x2110; \
+2:   ori r1, 0x2010; \
+     sw  reg1, (r1); \
+     sw  reg2, 4(r1); \
+     li  reg1, index; \
+     sw  reg1, 8(r1); \
+     lw  reg1, (r1); \
+     b DIAG_FAIL; \
+     nop; \
+1:   nop
+
+//BU_PRINT_REG (reg1, tmpreg) 
+// print reg1 value to address MSG_END.
+#define BU_PRINT_REG(reg1, tmpreg) \
+     mfc0 tmpreg, C0_PRID; \
+     bne  tmpreg, 0xc601, 2f; \
+     lui  r1, 0xa000; \
+     mfc3 tmpreg, C3_CPUTAG; \
+     bne tmpreg, 0x6b656e68, 2f; \
+     ori  r1, 0x2224; \
+     ori  r1, 0x2124; \
+2:   ori r1, 0x2024; /*MSG_REG*/\
+     sw  reg1, (r1); \
+     nop
+
+//BU_PRINT_INT (value, tmpreg) 
+// print value to address MSG_END.
+#define BU_PRINT_INT(value, tmpreg) \
+     mfc0 tmpreg, C0_PRID; \
+     bne  tmpreg, 0xc601, 2f; \
+     lui  r1, 0xa000; \
+     mfc3 tmpreg, C3_CPUTAG; \
+     bne tmpreg, 0x6b656e68, 2f; \
+     ori  r1, 0x2230; \
+     ori  r1, 0x2130; \
+2:   ori r1, 0x2030; /*MSG_INT*/\
+     li  tmpreg, value; \
+     sw  tmpreg, (r1); \
+     nop
+
+//Note: 2010 & 2014 is used for expected and actual data.
+// 2018 is for index.
+#define BU_CHECK_SCPU(index, reg1, reg2) \
+     beq reg1, reg2, 1f; \
+     nop; \
+     la  r1, 0xa0002010; \
+     sw  reg1, (r1); \
+     sw  reg2, 4(r1); \
+     li  reg1, index; \
+     sw  reg1, 8(r1); \
+     lw  reg1, (r1); \
+     b DIAG_FAIL; \
+     nop; \
+1:   nop
+     
+#define BU_CHECK_VCPU(index, reg1, reg2) \
+     beq reg1, reg2, 1f; \
+     nop; \
+     la  r1, 0xa0002110; \
+     sw  reg1, (r1); \
+     sw  reg2, 4(r1); \
+     li  reg1, index; \
+     sw  reg1, 8(r1); \
+     lw  reg1, (r1); \
+     b DIAG_FAIL; \
+     nop; \
+1:   nop
+     
+#define BU_CHECK_ACPU(index, reg1, reg2) \
+     beq reg1, reg2, 1f; \
+     nop; \
+     la  r1, 0xa0002210; \
+     sw  reg1, (r1); \
+     sw  reg2, 4(r1); \
+     li  reg1, index; \
+     sw  reg1, 8(r1); \
+     lw  reg1, (r1); \
+     b DIAG_FAIL; \
+     nop; \
+1:   nop
+     
+#define BU_CHECK_KCPU(index, reg1, reg2) \
+     beq reg1, reg2, 1f; \
+     nop; \
+     la  r1, 0xa0002310; \
+     sw  reg1, (r1); \
+     sw  reg2, 4(r1); \
+     li  reg1, index; \
+     sw  reg1, 8(r1); \
+     lw  reg1, (r1); \
+     b DIAG_FAIL; \
+     nop; \
+1:   nop
+
+#define BU_CHECK_SCPU2(index, reg1, reg2) \
+     beq reg1, reg2, 1f; \
+     nop; \
+     la  r1, 0xa0002310; \
+     sw  reg1, (r1); \
+     sw  reg2, 4(r1); \
+     li  reg1, index; \
+     sw  reg1, 8(r1); \
+     lw  reg1, (r1); \
+     b DIAG_FAIL; \
+     nop; \
+1:   nop
+
+/**/
+
+#define FILL_CACHE_LINE .rept 8; .word 0x0; .endr;
+
+#define DELAY_C(count) \
+    {int i; for(i=count; i>0; i--);}
+
+#ifndef SCPU_ARM
+  #define DELAY(count,reg) \
+          li   reg,count;\
+       9: sub  reg,1;\
+          bne  reg,r0,9b;\
+          nop;
+#endif
+// wait until reg shows matched value.
+//use "ori zero, 0x8898" op=34008898 to distinguish
+
+#ifdef SCPU_ARM
+  #define WAIT_C(addr,mask,value) \
+  	  asm(" nop; nop; nop; nop;"); \
+          while( ((*((unsigned int*) addr))&mask)!=value );
+  
+  #define WAIT_C_BE(addr,mask,value) \
+  	  asm(" nop; nop; nop; nop;"); \
+          while( ((*((unsigned int*) addr))&mask)<value );
+  
+  #define CPU_TRACE_COMPARE_OFF_C \
+  	  asm("nop; nop; nop; nop; nop; nop;");
+  
+  #define CPU_TRACE_COMPARE_ON_C \
+  	  asm("nop; nop; nop; nop; nop; nop;");
+  
+#else
+  #define WAIT_C(addr,mask,value) \
+  	  asm(" nop; nop; nop; nop; ori $0,0x8898;"); \
+          while( ((*((unsigned int*) addr))&mask)!=value );
+  
+  #define WAIT_C_BE(addr,mask,value) \
+  	  asm(" nop; nop; nop; nop; ori $0,0x8898;"); \
+          while( ((*((unsigned int*) addr))&mask)<value );
+  
+  #define CPU_TRACE_COMPARE_OFF_C \
+  	  asm("nop; nop; nop; nop; nop; ori $0, 0x00ff; nop;");
+  
+  #define CPU_TRACE_COMPARE_ON_C \
+  	  asm("nop; nop; nop; nop; nop; ori $0, 0x0011; nop;");
+  
+#endif
+
+#define WAIT_BE(addr,mask,value,reg1,reg2) \
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    ori zero, 0x8898;\
+8:    lw reg1, addr;\
+    nop;\
+    and reg1, mask;\
+    li reg2, value;\
+    blt reg1, reg2, 8b;\
+    nop;\
+
+#define WAIT(addr,mask,value,reg1,reg2) \
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    ori zero, 0x8898;\
+8:    lw reg1, addr;\
+    nop;\
+    and reg1, mask;\
+    li reg2, value;\
+    bne reg1, reg2, 8b;\
+    nop;\
+
+#define INF_LOOP \
+    ori    zero, 0x8898;\
+7:    b    7b; \
+    nop;    
+
+#define INF_LOOP2 \
+    nop;\
+    ori    zero, 0x8898;\
+7:    b    7b; \
+    nop;    
+
+        
+#define CPU_TRACE_COMPARE_OFF_C \
+    asm("nop; nop; nop; nop; nop; ori $0, 0x00ff; nop;");
+
+#define CPU_TRACE_COMPARE_ON_C \
+    asm("nop; nop; nop; nop; nop; ori $0, 0x0011; nop;");
+
+
+#define CPU_TRACE_COMPARE_OFF \
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    ori    zero, 0x00ff;\
+    nop;\
+    nop;\
+    nop;\
+    nop;
+
+#define CPU_TRACE_COMPARE_ON \
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    ori    zero, 0x0011;\
+    nop;\
+    nop;\
+    nop;\
+    nop;
+   
+#define REG_WR(addr,addr_reg,data,data_reg) \
+    la    addr_reg,addr;          \
+    li    data_reg,data;          \
+    sw    data_reg,(addr_reg);          \
+
+#define REG_RD(addr,addr_reg,data_reg) \
+    la    addr_reg,addr;          \
+    lw    data_reg,(addr_reg);        \
+    nop;\
+
+#define PUSH_STACK() \
+      sw      t0, -4(sp);  \
+      sw      t1, -8(sp);  \
+      sw      t2, -12(sp); \
+      sw      t3, -16(sp); \
+      sw      t4, -20(sp); \
+      sw      t5, -24(sp); \
+      sw      t6, -28(sp); \
+      sw      t7, -32(sp); \
+      sw      t8, -36(sp); \
+      sw      t9, -40(sp); \
+      sw      s0, -44(sp); \
+      sw      s1, -48(sp); \
+      sw      s2, -52(sp); \
+      sw      s3, -56(sp); \
+      sw      s4, -60(sp); \
+      sw      s5, -64(sp); \
+      sw      s6, -68(sp); \
+      sw      s7, -72(sp); \
+      sw      a0, -76(sp); \
+      sw      a1, -80(sp); \
+      sw      a2, -84(sp); \
+      sw      a3, -88(sp); \
+      sw      v0, -92(sp); \
+      sw      v1, -96(sp); \
+      sw      AT, -100(sp);\
+      sw      ra, -104(sp);
+    // ISR won't touch $sp and no need to save k0 and k1.
+
+#define POP_STACK() \
+      lw      t0, -4(sp);  \
+      lw      t1, -8(sp);  \
+      lw      t2, -12(sp); \
+      lw      t3, -16(sp); \
+      lw      t4, -20(sp); \
+      lw      t5, -24(sp); \
+      lw      t6, -28(sp); \
+      lw      t7, -32(sp); \
+      lw      t8, -36(sp); \
+      lw      t9, -40(sp); \
+      lw      s0, -44(sp); \
+      lw      s1, -48(sp); \
+      lw      s2, -52(sp); \
+      lw      s3, -56(sp); \
+      lw      s4, -60(sp); \
+      lw      s5, -64(sp); \
+      lw      s6, -68(sp); \
+      lw      s7, -72(sp); \
+      lw      a0, -76(sp); \
+      lw      a1, -80(sp); \
+      lw      a2, -84(sp); \
+      lw      a3, -88(sp); \
+      lw      v0, -92(sp); \
+      lw      v1, -96(sp); \
+      lw      AT, -100(sp);\
+      lw      ra, -104(sp);
+
+// write wr_val to reg, then read it back, compare with rd_val.
+#define CHECK_WR_REG(addr, wr_val, rd_val, mask, reg1, reg2, reg3) \
+    la    reg1, addr;              \
+    li    reg2, wr_val;            \
+    sw    reg2, (reg1);            \
+    li    reg3, rd_val;            \
+    lw    reg2, (reg1);            \
+    nop;                           \
+    and    reg2, mask;             \
+    bne    reg2, reg3, DIAG_FAIL;  \
+    nop
+    
+#define BU_CHECK_WR_REG(addr, wr_val, rd_val, mask, reg1, reg2, reg3) \
+    la    reg1, addr;              \
+    li    reg2, wr_val;            \
+    sw    reg2, (reg1);            \
+    li    reg3, rd_val;            \
+    lw    reg2, (reg1);            \
+    nop;                           \
+    and    reg2, mask;             \
+    BU_CHECK_CPU(addr&0xffff, reg2, reg3, reg1); \
+    nop
+           
+#define CHECK_SECURED_REG(addr, wr_val, reg1, reg2, reg3) \
+    la   reg1, addr;               \
+    li   reg2, wr_val;             \
+    sw   reg2, (reg1);             \
+    li   reg3, 0xDEADDEAD;         \
+    lw   reg2, (reg1);             \
+    nop;                           \
+    and  reg2, 0xFFFFFFFF;         \
+    bne  reg2, reg3, DIAG_FAIL;    \
+    nop
+
+#define PROTECTED_RD(addr, reg1, reg2, reg3) \
+    la   reg1, addr;                         \
+    li   reg2, 0x00000000;                   \
+    lw   reg3, (reg1);                       \
+    bne  reg2, reg3, DIAG_FAIL;              \
+    nop
+
+// from from reg, then compare with rd_val.
+// good for R/O reg, and Reset value check.
+#define CHECK_RD_REG(addr, rd_val, mask, reg1, reg2, reg3) \
+        la    reg1, addr;                     \
+        lw    reg2, (reg1);                   \
+        nop;                                  \
+        and   reg2, mask;                     \
+        li    reg3, rd_val;                   \
+        bne   reg2, reg3, DIAG_FAIL;          \
+        nop
+    
+#define BU_CHECK_RD_REG(addr, rd_val, mask, reg1, reg2, reg3) \
+        la    reg1, addr;                     \
+        lw    reg2, (reg1);                   \
+        nop;                                  \
+        and   reg2, mask;                     \
+        li    reg3, rd_val;                   \
+        BU_CHECK_CPU(addr&0xffff, reg2, reg3, reg1); \
+        nop
+
+#define CHECK_RD_REG_JB(addr, mask, reg1, reg2, jump_label) \
+        la    reg1, addr;                     \
+        lw    reg2, (reg1);                   \
+        nop;                                  \
+        and   reg2, mask;                     \
+        bgtz  reg2, jump_label;               \
+        nop
+
+#define CHECK_RD_REG_JNB(addr, mask, reg1, reg2, jump_label) \
+        la    reg1, addr;                     \
+        lw    reg2, (reg1);                   \
+        nop;                                  \
+        not   reg2, reg2;                     \
+        and   reg2, mask;                     \
+        bgtz  reg2, jump_label;               \
+        nop
+
+#define CHECK_RD_REG_JE(addr, rd_val, mask, reg1, reg2, jump_label) \
+        la    reg1, addr;                     \
+        lw    reg2, (reg1);                   \
+        nop;                                  \
+        and   reg2, mask;                     \
+        li    reg1, rd_val;                   \
+        beq   reg2, reg1, jump_label;         \
+        nop
+
+#define CHECK_RD_REG_JNE(addr, rd_val, mask, reg1, reg2, jump_label) \
+        la    reg1, addr;                     \
+        lw    reg2, (reg1);                   \
+        nop;                                  \
+        and   reg2, mask;                     \
+        li    reg1, rd_val;                   \
+        bne   reg2, reg1, jump_label;         \
+        nop
+
+    
+//for whole-chip, multiple-CPUs: SCPU_SYNC_START
+//assume SCPU is the first out of boot.
+#define SYNC_START_ADDR  0xa0300000 //assume the 8 bytes starting from it is available.
+
+#define SCPU_SYNC_START(addr, reg1, reg2) \
+    la    reg1, addr;                     \
+    sw    zero, (reg1);                   \
+    sw    zero, 4(reg1);                  \
+1:  lw    reg2, (reg1);                   \
+    nop;                                  \
+    beq   reg2, zero, 1b;                 \
+    nop;                                  \
+1:  lw    reg2, 4(reg1);                  \
+    nop;                                  \
+    beq   reg2, zero, 1b;                 \
+    nop
+
+//for whole-chip, multiple-CPUs: ACPU_SYNC_START
+#define ACPU_SYNC_START(addr, reg1, reg2)       \
+    WAIT(SB2_HD_SEM_reg, 0x1, 0x1, reg1, reg2); \
+    la    reg1, addr;                           \
+    li    reg2, 0x1;                            \
+    sw    reg2, (reg1);                         \
+    la    reg2, SB2_HD_SEM_reg;                 \
+    sw    zero, (reg2);                         \
+1:  lw    reg2, 4(reg1);                        \
+    nop;                                        \
+    beq   reg2, zero, 1b;                       \
+    nop
+
+//WAIT2: for some loop, the program only interested
+    //in some fields, while other fields might
+    //be different between C-model and RTL. In that
+    //case, the cpu compare need to be turned off
+    //temporarily. E.g., ACPU dma done register.
+#define WAIT2(addr,mask,value,reg1,reg2) \
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    ori zero, 0x00ff;\
+8:  lw reg1, addr;\
+    nop;\
+    and reg1, mask;\
+    li reg2, value;\
+    bne reg1, reg2, 8b;\
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    nop;\
+    ori zero, 0x0011;\
+    nop;\
+
+//for whole-chip, multiple-CPUs: VCPU_SYNC_START
+#define VCPU_SYNC_START(addr, reg1, reg2)       \
+    WAIT(SB2_HD_SEM_reg, 0x1, 0x1, reg1, reg2); \
+    la    reg1, addr;                           \
+    li    reg2, 0x1;                            \
+    sw    reg2, 4(reg1);                        \
+    la    reg2, SB2_HD_SEM_reg;                 \
+    sw    zero, (reg2);                         \
+1:  lw    reg2, (reg1);                         \
+    nop;                                        \
+    beq   reg2, zero, 1b;                       \
+    nop
+
+//global sync for all CPUs
+#define SYNC_ALL_CPU_START(reg1, reg2, num_of_cpu) \
+    WAIT(SB2_HD_SEM_reg, 0x1, 0x1, reg1, reg2);    \
+    la    reg1, 0xb801a024;                        \
+    lw    reg2, (reg1);                            \
+    nop;                                           \
+    li    reg1, num_of_cpu;                        \
+    bne   reg2, reg1, 1f;                          \
+    nop;                                           \
+    and   reg2, zero;                              \
+1:  add   reg2, 1;                                 \
+    la    reg1, 0xb801a024;                        \
+    sw    reg2, (reg1);                            \
+    la    reg2, SB2_HD_SEM_reg;                    \
+    sw    zero, (reg2);                            \
+    WAIT(0xb801a024, 0x1f, num_of_cpu, reg1, reg2);
+
+//global sync for all 3 CPUs
+#define CPU_SYNC_START(reg1, reg2)              \
+    WAIT(SB2_HD_SEM_reg, 0x1, 0x1, reg1, reg2); \
+    la    reg1, 0xb801a024;                     \
+    lw    reg2, (reg1);                         \
+    nop;                                        \
+    li    reg1, 0x3;                            \
+    bne   reg2, reg1, 1f;                       \
+    nop;                                        \
+    and   reg2, zero;                           \
+1:  add   reg2, 1;                              \
+    la    reg1, 0xb801a024;                     \
+    sw    reg2, (reg1);                         \
+    la    reg2, SB2_HD_SEM_reg;                 \
+    sw    zero, (reg2);                         \
+    WAIT(0xb801a024, 0x3, 0x3, reg1, reg2);
+
+//reset VE registers
+#define RESET_VE_REG() \
+        REG_WR(VE_CNTL_reg,       t2, 0xfffffffe, t4);  \
+        REG_WR(VE_INT_STATUS_reg, t2, 0xfffffffe, t4);  \
+        REG_WR(VE_INTEN_reg,       t2, 0xfffffffe, t4); \
+        REG_WR(VE_PCCNTL_reg,       t2, 0xa48888, t4);  \
+        REG_WR(VE_PC0_reg,        t2, 0, t4);           \
+        REG_WR(VE_PC1_reg,        t2, 0, t4);           \
+        REG_WR(VE_PC2_reg,        t2, 0, t4);           \
+        REG_WR(VE_DCTCNTL_reg,    t2, 0x6420, t4);      \
+        REG_WR(VE_CODECPARAM_reg, t2, 0x7f, t4);        \
+        REG_WR(VE_CODECCNTL_reg, t2, 0xbb1, t4);        \
+        REG_WR(VE_CODECCNTL1_reg, t2, 0xfffffffe, t4);  \
+        REG_WR(VE_CODECCNTL1_reg, t2, 0x41, t4);        \
+        REG_WR(VE_DVPARAM_reg   , t2, 0, t4);           \
+        REG_WR(VE_VLDTBLPTR_0_reg, t2, 0, t4);          \
+        REG_WR(VE_VLDTBLPTR_1_reg, t2, 0, t4);          \
+        REG_WR(VE_VLDTBLPTR_2_reg, t2, 0, t4);          \
+        REG_WR(VE_VLDTBLPTR_3_reg, t2, 0, t4);          \
+        REG_WR(VE_VLDESPPTR_0_reg, t2, 0, t4);          \
+        REG_WR(VE_VLDESPPTR_1_reg, t2, 0, t4);          \
+        REG_WR(VE_VLDESPPTR_2_reg, t2, 0, t4);          \
+        REG_WR(VE_VLDESPPTR_3_reg, t2, 0, t4);          \
+        REG_WR(VE_DECBITCNT_reg, t2, 0x400, t4);        \
+        REG_WR(VE_BITSTCNT_reg, t2, 0, t4);             \
+        REG_WR(VE_FILTCNTL_reg, t2, 0x8102108, t4);     \
+        REG_WR(VE_FILTINIT_reg, t2, 0, t4);             \
+        REG_WR(VE_CKCNTL_reg, t2, 0, t4);               \
+        REG_WR(VE_CKDATA_reg, t2, 0, t4);               \
+        REG_WR(VE_ADAPCNTL_reg, t2, 0, t4);             \
+        REG_WR(VE_ALPHA_reg, t2, 0, t4);                \
+        REG_WR(VE_DEBLKCNTL_reg, t2, 0x62, t4);         \
+        REG_WR(VE_DCVAL_reg, t2, 0, t4);                \
+        REG_WR(VE_BLKD_THR_reg, t2, 0, t4);             \
+        REG_WR(VE_BLKD_WEIGHT_reg, t2, 0, t4);          \
+        REG_WR(VE_TAPCOEFF_0_reg, t2, 0, t4);           \
+        REG_WR(VE_TAPCOEFF_1_reg, t2, 0, t4);           \
+        REG_WR(VE_TAPCOEFF_2_reg, t2, 0, t4);           \
+        REG_WR(VE_TAPCOEFF_3_reg, t2, 0, t4);           \
+        REG_WR(VE_TAPCOEFF_4_reg, t2, 0, t4);           \
+        REG_WR(VE_TAPCOEFF_5_reg, t2, 0, t4);           \
+        REG_WR(VE_TAPCOEFF_6_reg, t2, 0, t4);           \
+        REG_WR(VE_TAPCOEFF_7_reg, t2, 0, t4);           \
+        li       t0, VE_CNTL_codblk_mode(0x3)|VE_CNTL_write_data(0); \
+        wrcodreg t0, VE_CNTL_inst;                                   \
+        li       t0, VE_CNTL_reset_ptr(1)|VE_CNTL_write_data(1);     \
+        wrcodreg t0, VE_CNTL_inst;                                   \
+        li       t0, VE_CNTL_reset_ptr(1)|VE_CNTL_write_data(0);     \
+        wrcodreg t0, VE_CNTL_inst
+
+#define MD_REG_WR(Addr,DataReg,Mask)  \
+        and t0, DataReg, Mask;        \
+        la  t4, Addr;                 \
+        sw  t0, (t4);                 \
+        nop
+#define    MD_REG_RD(RegAddr,CmpVal,SelBits,Reg1,Reg2) \
+        la   Reg1, RegAddr;             \
+        lw   Reg2, (Reg1);              \
+        nop;                            \
+        and  Reg2, Reg2, SelBits;       \
+        bne  Reg2, CmpVal, DIAG_FAIL;   \
+        nop
+#define    MD_REG_NM_WRITE(RegAddr,WrtVal,Reg1,Reg2) \
+        la   Reg1, RegAddr;             \
+        li   Reg2 ,WrtVal;              \
+        sw   Reg2,(Reg1);               \
+        nop
+#define    MD_REG_WD_WRITE(RegAddr,WrtDatVal,Reg1,Reg2) \
+        la   Reg1, RegAddr;             \
+        li   Reg2, WrtDatVal;           \
+        sw   Reg2, (Reg1);              \
+        nop
+
+#define WAIT_LOOP_JE(addr, rd_val, mask, loop, delay, reg1, reg2, reg3,reg4) \
+        li      reg1,loop;\
+7:      sub     reg1,1;\
+        DELAY(delay,reg2);\
+        CHECK_RD_REG_JE(addr,rd_val,mask,reg3,reg4,6f);\
+        bne     reg1,r0,7b;\
+        nop;\
+        b       DIAG_FAIL;\
+        nop;\
+6:      nop
+
+#define WAIT_LOOP_JNE(addr, rd_val, mask, loop, delay, reg1, reg2, reg3,reg4) \
+        li      reg1,loop;\
+7:      sub     reg1,1;\
+        DELAY(delay,reg2);\
+        CHECK_RD_REG_JNE(addr,rd_val,mask,reg3,reg4,6f);\
+        bne     reg1,r0,7b;\
+        nop;\
+        b       DIAG_FAIL;\
+        nop;\
+6:      nop
+
+#define DC_TEST_GO(val2, val1, reg1, reg2) \
+        la reg1, SB2_DUMMY_0_reg; \
+        li reg2, val1; \
+        sw reg2, 0(reg1); \
+        li reg2, val2; \
+        sw reg2, 4(reg1);
+
+#define DC_TEST_GO_C(val2, val1) \
+        set_SB2_DUMMY_0_reg(val1); \
+        set_SB2_DUMMY_1_reg(val2);
+
+#define set_DMEM_VALUE(addr,data)   (*((volatile unsigned int*) addr)=data)
+#define get_DMEM_VALUE(addr)        (*((volatile unsigned int*) addr))
+        
+#define ad_initial        ad_initial  
+#define ad_mbskip         ad_mbskip
+#define ad_fieldflg       ad_fieldflg     r0, 0
+#define ad_eos            ad_eos          r0, 0
+#define ad_mbtype         ad_mbtype       r0, 0
+//#define ad_mbpred         ad_mbpred       r0, 0
+#define ad_quant          ad_quant        r0, 0
+//#define ad_mbdec          ad_mbdec        r0, 0
+#define dec_skiprun       dec_skiprun      r0, 0
+#define dec_fieldflg      dec_fieldflg     r0, 0
+#define dec_mbtype        dec_mbtype       
+#define dec_pcm           dec_pcm
+#define dec_mbpred        dec_mbpred
+#define dec_quant         dec_quant        r0, 0
+#define dec_mbdec         dec_mbdec
+#define dec_pred_weight   dec_pred_weight  r0, 0
+#define dec_acpred        dec_acpred       r0, 0
+#define dec_cbp           dec_cbp          r0, 0
+#define dec_bmvtype       dec_bmvtype      r0, 0
+#define dec_2mvbp         dec_2mvbp        r0, 0
+#define dec_4mvbp         dec_4mvbp        r0, 0
+#define dec_mbmode        dec_mbmode       r0, 0
+#define dec_overflg       dec_overflg
+#define dec_bitpln        dec_bitpln       r0, 0
+#define cond_dec_quant    cond_dec_quant   r0, 0
+#define cond_dec_acpred   cond_dec_acpred  r0, 0
+#define mbadec            mbadec           r0, 0
+#define mb_last           mb_last
+#define getbits           getbits
+#define peekbits          peekbits
+#define decstartcode      decstartcode
+#define wrcodreg          wrcodreg
+#define rdcodreg          rdcodreg
+#define slice_start       slice_start      r0, 0
+#define ldvldtbl          ldvldtbl
+#define stvldtbl          stvldtbl
+#define mvxdec            mvxdec           r0,
+#define mvydec            mvydec           r0,
+#define dec_ue            dec_ue           r0, 0
+#define dec_se            dec_se           r0, 0
+//#define ldbmem            ldbmem           r0, 0
+//#define stbmem            stbmem           r0, 0
+#define patsearch         patsearch
+#define struvlcdecrv      struvlcdecrv     r0, 0
+#define mvxydecrv         mvxydecrv        
+#define getsync           getsync          
+#define bkdec             bkdec               
+
+#define AD_INITIAL        AD_INITIAL  
+#define AD_MBSKIP         AD_MBSKIP
+#define AD_FIELDFLG       AD_FIELDFLG     r0, 0
+#define AD_EOS            AD_EOs          r0, 0
+#define AD_MBTYPE         AD_MBTYPE       r0, 0
+//#define AD_MBPRED         AD_MBPRED       r0, 0
+#define AD_QUANT          AD_QUANT        r0, 0
+//#define AD_MBDEC          AD_MBDEC        r0, 0
+#define DEC_SKIPRUN       DEC_SKIPRUN      r0, 0
+#define DEC_FIELDFLG      DEC_FIELDFLG     r0, 0
+#define DEC_MBTYPE        DEC_MBTYPE       
+#define DEC_PCM           DEC_PCM
+#define DEC_MBPRED        DEC_MBPRED
+#define DEC_QUANT         DEC_QUANT        r0, 0
+#define DEC_MBDEC         DEC_MBDEC
+#define DEC_PRED_WEIGHT   DEC_PRED_WEIGHT  r0, 0
+#define DEC_ACPRED        DEC_ACPRED       r0, 0
+#define DEC_CBP           DEC_CBP          r0, 0
+#define DEC_BMVTYPE       DEC_BMVTYPE      r0, 0
+#define DEC_2MVBP         DEC_2MVBP        r0, 0
+#define DEC_4MVBP         DEC_4MVBP        r0, 0
+#define DEC_MBMODE        DEC_MBMODE       r0, 0
+#define DEC_OVERFLG       DEC_OVERFLG
+#define DEC_BITPLN        DEC_BITPLN       r0, 0
+#define COND_DEC_QUANT    COND_DEC_QUANT   r0, 0
+#define COND_DEC_ACPRED   COND_DEC_ACPRED  r0, 0
+#define MBADEC            MBADEC           r0, 0
+#define MB_LAST           MB_LAST
+#define GETBITS           GETBITS
+#define PEEKBITS          PEEKBITS
+#define DECSTARTCODE      DECSTARTCODE
+#define WRCODREG          WRCODREG
+#define RDCODREG          RDCODREG
+#define SLICE_START       SLICE_START      r0, 0
+#define LDVLDTBL          LDVLDTBL
+#define STVLDTBL          STVLDTBL
+#define MVXDEC            MVXDEC           r0,
+#define MVYDEC            MVYDEC           r0,
+#define DEC_UE            DEC_UE           r0, 0
+#define DEC_SE            DEC_SE           r0, 0
+//#define LDBMEM            LDBMEM           r0, 0
+//#define STBMEM            STBMEM           r0, 0
+#define PATSEARCH         PATSEARCH
+#define STRUVLCDECRV      STRUVLCDECRV     r0, 0
+#define MVXYDECRV         MVXYDECRV        
+#define GETSYNC           GETSYNC          
+#define BKDEC             BKDEC           
+
+#define PREDBLK_BASEA_0_inst PREDBLK_BASEA_inst
+#define PREDBLK_BASEA_1_inst PREDBLK_BASEA_inst
+#define PREDBLK_OFFSETA_3_inst PREDBLK_OFFSETA_2_inst
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb0_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb0_reg.h
new file mode 100644
index 00000000..122bc03
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb0_reg.h
@@ -0,0 +1,106 @@
+/**************************************************************
+// Spec Version                  : 0.0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/4/10 16:22:10
+***************************************************************/
+
+
+#ifndef _SBX_REG_H_INCLUDED_
+#define _SBX_REG_H_INCLUDED_
+#ifdef  _SBX_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     vi:4;
+unsigned int     reserved_1:4;
+unsigned int     aio:4;
+}SB0_PRIORITY_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB0_CHANNEL_REQ_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB0_CHANNEL_REQ_BUSY;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     allow_cmd_cnt:3;
+}SB0_MISC_CTRL;
+
+#endif
+
+#define SB0_PRIORITY_1                                                               0x1801C400
+#define SB0_PRIORITY_1_reg_addr                                                      "0xB801C400"
+#define SB0_PRIORITY_1_reg                                                           0xB801C400
+#define set_SB0_PRIORITY_1_reg(data)   (*((volatile unsigned int*) SB0_PRIORITY_1_reg)=data)
+#define get_SB0_PRIORITY_1_reg   (*((volatile unsigned int*) SB0_PRIORITY_1_reg))
+#define SB0_PRIORITY_1_inst_adr                                                      "0x0000"
+#define SB0_PRIORITY_1_inst                                                          0x0000
+#define SB0_PRIORITY_1_vi_shift                                                      (8)
+#define SB0_PRIORITY_1_vi_mask                                                       (0x00000F00)
+#define SB0_PRIORITY_1_vi(data)                                                      (0x00000F00&((data)<<8))
+#define SB0_PRIORITY_1_vi_src(data)                                                  ((0x00000F00&(data))>>8)
+#define SB0_PRIORITY_1_get_vi(data)                                                  ((0x00000F00&(data))>>8)
+#define SB0_PRIORITY_1_aio_shift                                                     (0)
+#define SB0_PRIORITY_1_aio_mask                                                      (0x0000000F)
+#define SB0_PRIORITY_1_aio(data)                                                     (0x0000000F&((data)<<0))
+#define SB0_PRIORITY_1_aio_src(data)                                                 ((0x0000000F&(data))>>0)
+#define SB0_PRIORITY_1_get_aio(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define SB0_CHANNEL_REQ_MASK                                                         0x1801C408
+#define SB0_CHANNEL_REQ_MASK_reg_addr                                                "0xB801C408"
+#define SB0_CHANNEL_REQ_MASK_reg                                                     0xB801C408
+#define set_SB0_CHANNEL_REQ_MASK_reg(data)   (*((volatile unsigned int*) SB0_CHANNEL_REQ_MASK_reg)=data)
+#define get_SB0_CHANNEL_REQ_MASK_reg   (*((volatile unsigned int*) SB0_CHANNEL_REQ_MASK_reg))
+#define SB0_CHANNEL_REQ_MASK_inst_adr                                                "0x0002"
+#define SB0_CHANNEL_REQ_MASK_inst                                                    0x0002
+#define SB0_CHANNEL_REQ_MASK_index_shift                                             (0)
+#define SB0_CHANNEL_REQ_MASK_index_mask                                              (0x000000FF)
+#define SB0_CHANNEL_REQ_MASK_index(data)                                             (0x000000FF&((data)<<0))
+#define SB0_CHANNEL_REQ_MASK_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB0_CHANNEL_REQ_MASK_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB0_CHANNEL_REQ_BUSY                                                         0x1801C40C
+#define SB0_CHANNEL_REQ_BUSY_reg_addr                                                "0xB801C40C"
+#define SB0_CHANNEL_REQ_BUSY_reg                                                     0xB801C40C
+#define set_SB0_CHANNEL_REQ_BUSY_reg(data)   (*((volatile unsigned int*) SB0_CHANNEL_REQ_BUSY_reg)=data)
+#define get_SB0_CHANNEL_REQ_BUSY_reg   (*((volatile unsigned int*) SB0_CHANNEL_REQ_BUSY_reg))
+#define SB0_CHANNEL_REQ_BUSY_inst_adr                                                "0x0003"
+#define SB0_CHANNEL_REQ_BUSY_inst                                                    0x0003
+#define SB0_CHANNEL_REQ_BUSY_index_shift                                             (0)
+#define SB0_CHANNEL_REQ_BUSY_index_mask                                              (0x000000FF)
+#define SB0_CHANNEL_REQ_BUSY_index(data)                                             (0x000000FF&((data)<<0))
+#define SB0_CHANNEL_REQ_BUSY_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB0_CHANNEL_REQ_BUSY_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB0_MISC_CTRL                                                                0x1801C410
+#define SB0_MISC_CTRL_reg_addr                                                       "0xB801C410"
+#define SB0_MISC_CTRL_reg                                                            0xB801C410
+#define set_SB0_MISC_CTRL_reg(data)   (*((volatile unsigned int*) SB0_MISC_CTRL_reg)=data)
+#define get_SB0_MISC_CTRL_reg   (*((volatile unsigned int*) SB0_MISC_CTRL_reg))
+#define SB0_MISC_CTRL_inst_adr                                                       "0x0004"
+#define SB0_MISC_CTRL_inst                                                           0x0004
+#define SB0_MISC_CTRL_allow_cmd_cnt_shift                                            (0)
+#define SB0_MISC_CTRL_allow_cmd_cnt_mask                                             (0x00000007)
+#define SB0_MISC_CTRL_allow_cmd_cnt(data)                                            (0x00000007&((data)<<0))
+#define SB0_MISC_CTRL_allow_cmd_cnt_src(data)                                        ((0x00000007&(data))>>0)
+#define SB0_MISC_CTRL_get_allow_cmd_cnt(data)                                        ((0x00000007&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb1_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb1_reg.h
new file mode 100644
index 00000000..422aa71
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb1_reg.h
@@ -0,0 +1,181 @@
+/**************************************************************
+// Spec Version                  : 0.0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/4/10 16:22:10
+***************************************************************/
+
+
+#ifndef _SB1_REG_H_INCLUDED_
+#define _SB1_REG_H_INCLUDED_
+#ifdef  _SB1_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     tp:4;
+unsigned int     reserved_1:4;
+unsigned int     etn:4;
+unsigned int     reserved_2:4;
+unsigned int     etn2:4;
+unsigned int     reserved_3:4;
+unsigned int     sata:4;
+}SB1_PRIORITY_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     nf:4;
+unsigned int     reserved_1:4;
+unsigned int     usb:4;
+unsigned int     reserved_2:4;
+unsigned int     cp:4;
+unsigned int     reserved_3:4;
+unsigned int     cr:4;
+}SB1_PRIORITY_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB1_CHANNEL_HIGH_PRIORITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB1_CHANNEL_REQ_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB1_CHANNEL_REQ_BUSY;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     allow_cmd_cnt:3;
+}SB1_MISC_CTRL;
+
+#endif
+
+#define SB1_PRIORITY_1                                                               0x1801C000
+#define SB1_PRIORITY_1_reg_addr                                                      "0xB801C000"
+#define SB1_PRIORITY_1_reg                                                           0xB801C000
+#define set_SB1_PRIORITY_1_reg(data)   (*((volatile unsigned int*) SB1_PRIORITY_1_reg)=data)
+#define get_SB1_PRIORITY_1_reg   (*((volatile unsigned int*) SB1_PRIORITY_1_reg))
+#define SB1_PRIORITY_1_inst_adr                                                      "0x0000"
+#define SB1_PRIORITY_1_inst                                                          0x0000
+#define SB1_PRIORITY_1_tp_shift                                                      (24)
+#define SB1_PRIORITY_1_tp_mask                                                       (0x0F000000)
+#define SB1_PRIORITY_1_tp(data)                                                      (0x0F000000&((data)<<24))
+#define SB1_PRIORITY_1_tp_src(data)                                                  ((0x0F000000&(data))>>24)
+#define SB1_PRIORITY_1_get_tp(data)                                                  ((0x0F000000&(data))>>24)
+#define SB1_PRIORITY_1_etn_shift                                                     (16)
+#define SB1_PRIORITY_1_etn_mask                                                      (0x000F0000)
+#define SB1_PRIORITY_1_etn(data)                                                     (0x000F0000&((data)<<16))
+#define SB1_PRIORITY_1_etn_src(data)                                                 ((0x000F0000&(data))>>16)
+#define SB1_PRIORITY_1_get_etn(data)                                                 ((0x000F0000&(data))>>16)
+#define SB1_PRIORITY_1_etn2_shift                                                    (8)
+#define SB1_PRIORITY_1_etn2_mask                                                     (0x00000F00)
+#define SB1_PRIORITY_1_etn2(data)                                                    (0x00000F00&((data)<<8))
+#define SB1_PRIORITY_1_etn2_src(data)                                                ((0x00000F00&(data))>>8)
+#define SB1_PRIORITY_1_get_etn2(data)                                                ((0x00000F00&(data))>>8)
+#define SB1_PRIORITY_1_sata_shift                                                    (0)
+#define SB1_PRIORITY_1_sata_mask                                                     (0x0000000F)
+#define SB1_PRIORITY_1_sata(data)                                                    (0x0000000F&((data)<<0))
+#define SB1_PRIORITY_1_sata_src(data)                                                ((0x0000000F&(data))>>0)
+#define SB1_PRIORITY_1_get_sata(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define SB1_PRIORITY_2                                                               0x1801C004
+#define SB1_PRIORITY_2_reg_addr                                                      "0xB801C004"
+#define SB1_PRIORITY_2_reg                                                           0xB801C004
+#define set_SB1_PRIORITY_2_reg(data)   (*((volatile unsigned int*) SB1_PRIORITY_2_reg)=data)
+#define get_SB1_PRIORITY_2_reg   (*((volatile unsigned int*) SB1_PRIORITY_2_reg))
+#define SB1_PRIORITY_2_inst_adr                                                      "0x0001"
+#define SB1_PRIORITY_2_inst                                                          0x0001
+#define SB1_PRIORITY_2_nf_shift                                                      (24)
+#define SB1_PRIORITY_2_nf_mask                                                       (0x0F000000)
+#define SB1_PRIORITY_2_nf(data)                                                      (0x0F000000&((data)<<24))
+#define SB1_PRIORITY_2_nf_src(data)                                                  ((0x0F000000&(data))>>24)
+#define SB1_PRIORITY_2_get_nf(data)                                                  ((0x0F000000&(data))>>24)
+#define SB1_PRIORITY_2_usb_shift                                                     (16)
+#define SB1_PRIORITY_2_usb_mask                                                      (0x000F0000)
+#define SB1_PRIORITY_2_usb(data)                                                     (0x000F0000&((data)<<16))
+#define SB1_PRIORITY_2_usb_src(data)                                                 ((0x000F0000&(data))>>16)
+#define SB1_PRIORITY_2_get_usb(data)                                                 ((0x000F0000&(data))>>16)
+#define SB1_PRIORITY_2_cp_shift                                                      (8)
+#define SB1_PRIORITY_2_cp_mask                                                       (0x00000F00)
+#define SB1_PRIORITY_2_cp(data)                                                      (0x00000F00&((data)<<8))
+#define SB1_PRIORITY_2_cp_src(data)                                                  ((0x00000F00&(data))>>8)
+#define SB1_PRIORITY_2_get_cp(data)                                                  ((0x00000F00&(data))>>8)
+#define SB1_PRIORITY_2_cr_shift                                                      (0)
+#define SB1_PRIORITY_2_cr_mask                                                       (0x0000000F)
+#define SB1_PRIORITY_2_cr(data)                                                      (0x0000000F&((data)<<0))
+#define SB1_PRIORITY_2_cr_src(data)                                                  ((0x0000000F&(data))>>0)
+#define SB1_PRIORITY_2_get_cr(data)                                                  ((0x0000000F&(data))>>0)
+
+
+#define SB1_CHANNEL_HIGH_PRIORITY                                                    0x1801C008
+#define SB1_CHANNEL_HIGH_PRIORITY_reg_addr                                           "0xB801C008"
+#define SB1_CHANNEL_HIGH_PRIORITY_reg                                                0xB801C008
+#define set_SB1_CHANNEL_HIGH_PRIORITY_reg(data)   (*((volatile unsigned int*) SB1_CHANNEL_HIGH_PRIORITY_reg)=data)
+#define get_SB1_CHANNEL_HIGH_PRIORITY_reg   (*((volatile unsigned int*) SB1_CHANNEL_HIGH_PRIORITY_reg))
+#define SB1_CHANNEL_HIGH_PRIORITY_inst_adr                                           "0x0002"
+#define SB1_CHANNEL_HIGH_PRIORITY_inst                                               0x0002
+#define SB1_CHANNEL_HIGH_PRIORITY_index_shift                                        (0)
+#define SB1_CHANNEL_HIGH_PRIORITY_index_mask                                         (0x000000FF)
+#define SB1_CHANNEL_HIGH_PRIORITY_index(data)                                        (0x000000FF&((data)<<0))
+#define SB1_CHANNEL_HIGH_PRIORITY_index_src(data)                                    ((0x000000FF&(data))>>0)
+#define SB1_CHANNEL_HIGH_PRIORITY_get_index(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define SB1_CHANNEL_REQ_MASK                                                         0x1801C00C
+#define SB1_CHANNEL_REQ_MASK_reg_addr                                                "0xB801C00C"
+#define SB1_CHANNEL_REQ_MASK_reg                                                     0xB801C00C
+#define set_SB1_CHANNEL_REQ_MASK_reg(data)   (*((volatile unsigned int*) SB1_CHANNEL_REQ_MASK_reg)=data)
+#define get_SB1_CHANNEL_REQ_MASK_reg   (*((volatile unsigned int*) SB1_CHANNEL_REQ_MASK_reg))
+#define SB1_CHANNEL_REQ_MASK_inst_adr                                                "0x0003"
+#define SB1_CHANNEL_REQ_MASK_inst                                                    0x0003
+#define SB1_CHANNEL_REQ_MASK_index_shift                                             (0)
+#define SB1_CHANNEL_REQ_MASK_index_mask                                              (0x000000FF)
+#define SB1_CHANNEL_REQ_MASK_index(data)                                             (0x000000FF&((data)<<0))
+#define SB1_CHANNEL_REQ_MASK_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB1_CHANNEL_REQ_MASK_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB1_CHANNEL_REQ_BUSY                                                         0x1801C010
+#define SB1_CHANNEL_REQ_BUSY_reg_addr                                                "0xB801C010"
+#define SB1_CHANNEL_REQ_BUSY_reg                                                     0xB801C010
+#define set_SB1_CHANNEL_REQ_BUSY_reg(data)   (*((volatile unsigned int*) SB1_CHANNEL_REQ_BUSY_reg)=data)
+#define get_SB1_CHANNEL_REQ_BUSY_reg   (*((volatile unsigned int*) SB1_CHANNEL_REQ_BUSY_reg))
+#define SB1_CHANNEL_REQ_BUSY_inst_adr                                                "0x0004"
+#define SB1_CHANNEL_REQ_BUSY_inst                                                    0x0004
+#define SB1_CHANNEL_REQ_BUSY_index_shift                                             (0)
+#define SB1_CHANNEL_REQ_BUSY_index_mask                                              (0x000000FF)
+#define SB1_CHANNEL_REQ_BUSY_index(data)                                             (0x000000FF&((data)<<0))
+#define SB1_CHANNEL_REQ_BUSY_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB1_CHANNEL_REQ_BUSY_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB1_MISC_CTRL                                                                0x1801C014
+#define SB1_MISC_CTRL_reg_addr                                                       "0xB801C014"
+#define SB1_MISC_CTRL_reg                                                            0xB801C014
+#define set_SB1_MISC_CTRL_reg(data)   (*((volatile unsigned int*) SB1_MISC_CTRL_reg)=data)
+#define get_SB1_MISC_CTRL_reg   (*((volatile unsigned int*) SB1_MISC_CTRL_reg))
+#define SB1_MISC_CTRL_inst_adr                                                       "0x0005"
+#define SB1_MISC_CTRL_inst                                                           0x0005
+#define SB1_MISC_CTRL_allow_cmd_cnt_shift                                            (0)
+#define SB1_MISC_CTRL_allow_cmd_cnt_mask                                             (0x00000007)
+#define SB1_MISC_CTRL_allow_cmd_cnt(data)                                            (0x00000007&((data)<<0))
+#define SB1_MISC_CTRL_allow_cmd_cnt_src(data)                                        ((0x00000007&(data))>>0)
+#define SB1_MISC_CTRL_get_allow_cmd_cnt(data)                                        ((0x00000007&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb2_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb2_reg.h
new file mode 100644
index 00000000..067aafd
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb2_reg.h
@@ -0,0 +1,1873 @@
+/**************************************************************
+// Spec Version                  : 0.1
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/5/7 16:0:55
+***************************************************************/
+
+
+#ifndef _SB2_REG_H_INCLUDED_
+#define _SB2_REG_H_INCLUDED_
+#ifdef  _SB2_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     Semaphore:1;
+}SB2_HD_SEM;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     swcivairq_en:1;
+unsigned int     To_en1:1;
+unsigned int     To_en:1;
+unsigned int     acivairq_en:1;
+unsigned int     reserved_1:1;
+unsigned int     scivairq_en:1;
+unsigned int     write_data:1;
+}SB2_INV_INTEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     swciva_int:1;
+unsigned int     Aciva_int:1;
+unsigned int     reserved_1:1;
+unsigned int     Sciva_int:1;
+unsigned int     write_data:1;
+}SB2_INV_INTSTAT;
+
+typedef struct 
+{
+unsigned int     Inv_adr:32;
+}SB2_INV_ADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     To_thr1:3;
+unsigned int     To_thr:2;
+}SB2_DEBUG_REG;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     Wr_hold_cyc:4;
+unsigned int     reserved_1:3;
+unsigned int     Wwr_cyc:5;
+unsigned int     Wr_cyc:5;
+unsigned int     Rd_cyc:5;
+}SB2_FLASH_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     write_en13:1;
+unsigned int     mult_wr_en:1;
+unsigned int     write_en11:1;
+unsigned int     ac_in_order:1;
+unsigned int     write_en9:1;
+unsigned int     ac_bypass:1;
+unsigned int     write_en7:1;
+unsigned int     ac_merge:1;
+unsigned int     reserved_1:3;
+unsigned int     write_en2:1;
+unsigned int     sc_in_order:1;
+unsigned int     reserved_2:2;
+}SB2_WRAPPER_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     enable:1;
+}SB2_SCPU_INT_CHECK;
+
+typedef struct 
+{
+unsigned int     Sync:32;
+}SB2_SYNC;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     Dbg_mode:5;
+}SB2_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_enable3:1;
+unsigned int     sel1:6;
+unsigned int     write_enable2:1;
+unsigned int     sel0:6;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}SB2_DEBUG;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     speed_up:1;
+}SB2_LEXRA_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     int_aswc:1;
+unsigned int     int_swca:1;
+unsigned int     reserved_1:6;
+unsigned int     int_as:1;
+unsigned int     reserved_2:1;
+unsigned int     int_sa:1;
+unsigned int     write_data:1;
+}SB2_CPU_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     int_aswc_en:1;
+unsigned int     int_swca_en:1;
+unsigned int     reserved_1:6;
+unsigned int     int_as_en:1;
+unsigned int     reserved_2:1;
+unsigned int     int_sa_en:1;
+unsigned int     write_data:1;
+}SB2_CPU_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     pending:1;
+unsigned int     reserved_1:2;
+unsigned int     mask_id:3;
+}SB2_DREQ_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     Chip_id:16;
+}SB2_CHIP_ID;
+
+typedef struct 
+{
+unsigned int     Revise_id:16;
+unsigned int     reserved_0:16;
+}SB2_CHIP_INFO;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en6:1;
+unsigned int     acpu_rbus_go:1;
+unsigned int     reserved_1:2;
+unsigned int     write_en4:1;
+unsigned int     scpu_rbus_go:1;
+unsigned int     write_en3:1;
+unsigned int     acpu_dbus_go:1;
+unsigned int     reserved_2:4;
+}SB2_PC_CTRL;
+
+typedef struct 
+{
+unsigned int     acpu_dbus_acc:32;
+}SB2_ACPU_DACC;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     acpu_dreq_num:24;
+}SB2_ACPU_DREQ_NUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     acpu_dreq_max:16;
+}SB2_ACPU_DREQ_MAX;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     acpu_dreq_ack:26;
+}SB2_ACPU_DREQ_ACK;
+
+typedef struct 
+{
+unsigned int     scpu_rbus_acc:32;
+}SB2_SCPU_RACC;
+
+typedef struct 
+{
+unsigned int     scpu_rreq_max:8;
+unsigned int     scpu_rreq_num:24;
+}SB2_SCPU_RREQ_RLT;
+
+typedef struct 
+{
+unsigned int     acpu_rbus_acc:32;
+}SB2_ACPU_RACC;
+
+typedef struct 
+{
+unsigned int     acpu_rreq_max:8;
+unsigned int     acpu_rreq_num:24;
+}SB2_ACPU_RREQ_RLT;
+
+typedef struct 
+{
+unsigned int     Dbg_start_addr:32;
+}SB2_DBG_START;
+
+typedef struct 
+{
+unsigned int     Dbg_end_addr:32;
+}SB2_DBG_END;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     write_en6:1;
+unsigned int     Dbg_acpu_chk_en:1;
+unsigned int     reserved_1:2;
+unsigned int     write_en4:1;
+unsigned int     Dbg_scpu_chk_en:1;
+unsigned int     write_en3:1;
+unsigned int     Dbg_wr_chk:2;
+unsigned int     write_en2:1;
+unsigned int     Dbg_id_chk:2;
+unsigned int     write_en1:1;
+unsigned int     Dbg_en:1;
+}SB2_DBG_CTRL;
+
+typedef struct 
+{
+unsigned int     dbg_addr:32;
+}SB2_DBG_ADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     acpu_dbg_write:1;
+unsigned int     acpu_dbg_dacc:1;
+unsigned int     scpu_dbg_write:1;
+unsigned int     scpu_dbg_dacc:1;
+unsigned int     reserved_1:2;
+}SB2_DBG_ADDR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     acpu_int:1;
+unsigned int     reserved_1:1;
+unsigned int     scpu_int:1;
+unsigned int     acpu_int_en:1;
+unsigned int     reserved_2:1;
+unsigned int     scpu_int_en:1;
+unsigned int     acpu_neg_int:1;
+unsigned int     reserved_3:1;
+unsigned int     scpu_neg_int:1;
+unsigned int     acpu_neg_int_en:1;
+unsigned int     reserved_4:1;
+unsigned int     scpu_neg_int_en:1;
+unsigned int     write_data:1;
+}SB2_DBG_INT;
+
+typedef struct 
+{
+unsigned int     data:32;
+}SB2_DUMMY;
+
+typedef struct 
+{
+unsigned int     data:32;
+}SB2_SHADOW;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     Semaphore:1;
+}SB2_HD_SEM_NEW;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     inva_wr_sec2_en:1;
+unsigned int     reserved_1:1;
+unsigned int     inva_wr_sec1_en:1;
+}SB2_RBUS_INVA_ACC_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     sec1_start:17;
+unsigned int     reserved_1:2;
+}SB2_RBUS_INVA_ACC_SEC1_START;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     sec1_end:17;
+unsigned int     reserved_1:2;
+}SB2_RBUS_INVA_ACC_SEC1_END;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     sec2_start:17;
+unsigned int     reserved_1:2;
+}SB2_RBUS_INVA_ACC_SEC2_START;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     sec2_end:17;
+unsigned int     reserved_1:2;
+}SB2_RBUS_INVA_ACC_SEC2_END;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     crc_cmp_latch_en:1;
+}SB2_RBUS_CMP_CTRL;
+
+typedef struct 
+{
+unsigned int     crc_cmp_expect:32;
+}SB2_RBUS_CMP_DATA;
+
+typedef struct 
+{
+unsigned int     crc_cmp_result:32;
+}SB2_RBUS_CMP_RESULT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sb2_bist_rstn:1;
+unsigned int     sb2_bist_en:1;
+unsigned int     sb2_rom_ls:1;
+unsigned int     sb2_rom_rme:1;
+unsigned int     sb2_rom_rm:4;
+}SB2_BIST_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     sb2_rom_bist_done:1;
+unsigned int     sb2_misr_dataout_0:16;
+}SB2_BIST_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     dual_mode:2;
+unsigned int     fat_mode:1;
+unsigned int     opc:8;
+}SB2_SFC_OPCODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     reserved_1:11;
+unsigned int     dataen:1;
+unsigned int     adren:1;
+unsigned int     dmycnt:3;
+}SB2_SFC_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     reserved_1:7;
+unsigned int     mode:1;
+unsigned int     fdiv:8;
+}SB2_SFC_SCK;
+
+typedef struct 
+{
+unsigned int     tdt:16;
+unsigned int     Phcnt:8;
+unsigned int     Plcnt:8;
+}SB2_SFC_CE;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en5:1;
+unsigned int     rdy:1;
+unsigned int     reserved_1:24;
+unsigned int     write_en1:1;
+unsigned int     wp_n:1;
+}SB2_SFC_WP;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     pos_latch:1;
+}SB2_SFC_POS_LATCH;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     wt_prog_done:1;
+unsigned int     rdsr_op:8;
+}SB2_SFC_WAIT_WR;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     wt_prog_en:1;
+unsigned int     wr_en_op:8;
+}SB2_SFC_EN_WR;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     sf_dclk_sel:1;
+unsigned int     fifo_write_tap:3;
+unsigned int     fast_read_en:1;
+}SB2_SFC_FAST_RD;
+
+typedef struct 
+{
+unsigned int     delay_clk_tap:32;
+}SB2_SFC_SCK_TAP;
+
+#endif
+
+#define SB2_HD_SEM                                                                   0x1801A000
+#define SB2_HD_SEM_reg_addr                                                          "0xB801A000"
+#define SB2_HD_SEM_reg                                                               0xB801A000
+#define set_SB2_HD_SEM_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_reg)=data)
+#define get_SB2_HD_SEM_reg   (*((volatile unsigned int*) SB2_HD_SEM_reg))
+#define SB2_HD_SEM_inst_adr                                                          "0x0000"
+#define SB2_HD_SEM_inst                                                              0x0000
+#define SB2_HD_SEM_Semaphore_shift                                                   (0)
+#define SB2_HD_SEM_Semaphore_mask                                                    (0x00000001)
+#define SB2_HD_SEM_Semaphore(data)                                                   (0x00000001&((data)<<0))
+#define SB2_HD_SEM_Semaphore_src(data)                                               ((0x00000001&(data))>>0)
+#define SB2_HD_SEM_get_Semaphore(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SB2_INV_INTEN                                                                0x1801A004
+#define SB2_INV_INTEN_reg_addr                                                       "0xB801A004"
+#define SB2_INV_INTEN_reg                                                            0xB801A004
+#define set_SB2_INV_INTEN_reg(data)   (*((volatile unsigned int*) SB2_INV_INTEN_reg)=data)
+#define get_SB2_INV_INTEN_reg   (*((volatile unsigned int*) SB2_INV_INTEN_reg))
+#define SB2_INV_INTEN_inst_adr                                                       "0x0001"
+#define SB2_INV_INTEN_inst                                                           0x0001
+#define SB2_INV_INTEN_swcivairq_en_shift                                             (6)
+#define SB2_INV_INTEN_swcivairq_en_mask                                              (0x00000040)
+#define SB2_INV_INTEN_swcivairq_en(data)                                             (0x00000040&((data)<<6))
+#define SB2_INV_INTEN_swcivairq_en_src(data)                                         ((0x00000040&(data))>>6)
+#define SB2_INV_INTEN_get_swcivairq_en(data)                                         ((0x00000040&(data))>>6)
+#define SB2_INV_INTEN_To_en1_shift                                                   (5)
+#define SB2_INV_INTEN_To_en1_mask                                                    (0x00000020)
+#define SB2_INV_INTEN_To_en1(data)                                                   (0x00000020&((data)<<5))
+#define SB2_INV_INTEN_To_en1_src(data)                                               ((0x00000020&(data))>>5)
+#define SB2_INV_INTEN_get_To_en1(data)                                               ((0x00000020&(data))>>5)
+#define SB2_INV_INTEN_To_en_shift                                                    (4)
+#define SB2_INV_INTEN_To_en_mask                                                     (0x00000010)
+#define SB2_INV_INTEN_To_en(data)                                                    (0x00000010&((data)<<4))
+#define SB2_INV_INTEN_To_en_src(data)                                                ((0x00000010&(data))>>4)
+#define SB2_INV_INTEN_get_To_en(data)                                                ((0x00000010&(data))>>4)
+#define SB2_INV_INTEN_acivairq_en_shift                                              (3)
+#define SB2_INV_INTEN_acivairq_en_mask                                               (0x00000008)
+#define SB2_INV_INTEN_acivairq_en(data)                                              (0x00000008&((data)<<3))
+#define SB2_INV_INTEN_acivairq_en_src(data)                                          ((0x00000008&(data))>>3)
+#define SB2_INV_INTEN_get_acivairq_en(data)                                          ((0x00000008&(data))>>3)
+#define SB2_INV_INTEN_scivairq_en_shift                                              (1)
+#define SB2_INV_INTEN_scivairq_en_mask                                               (0x00000002)
+#define SB2_INV_INTEN_scivairq_en(data)                                              (0x00000002&((data)<<1))
+#define SB2_INV_INTEN_scivairq_en_src(data)                                          ((0x00000002&(data))>>1)
+#define SB2_INV_INTEN_get_scivairq_en(data)                                          ((0x00000002&(data))>>1)
+#define SB2_INV_INTEN_write_data_shift                                               (0)
+#define SB2_INV_INTEN_write_data_mask                                                (0x00000001)
+#define SB2_INV_INTEN_write_data(data)                                               (0x00000001&((data)<<0))
+#define SB2_INV_INTEN_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define SB2_INV_INTEN_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SB2_INV_INTSTAT                                                              0x1801A008
+#define SB2_INV_INTSTAT_reg_addr                                                     "0xB801A008"
+#define SB2_INV_INTSTAT_reg                                                          0xB801A008
+#define set_SB2_INV_INTSTAT_reg(data)   (*((volatile unsigned int*) SB2_INV_INTSTAT_reg)=data)
+#define get_SB2_INV_INTSTAT_reg   (*((volatile unsigned int*) SB2_INV_INTSTAT_reg))
+#define SB2_INV_INTSTAT_inst_adr                                                     "0x0002"
+#define SB2_INV_INTSTAT_inst                                                         0x0002
+#define SB2_INV_INTSTAT_swciva_int_shift                                             (4)
+#define SB2_INV_INTSTAT_swciva_int_mask                                              (0x00000010)
+#define SB2_INV_INTSTAT_swciva_int(data)                                             (0x00000010&((data)<<4))
+#define SB2_INV_INTSTAT_swciva_int_src(data)                                         ((0x00000010&(data))>>4)
+#define SB2_INV_INTSTAT_get_swciva_int(data)                                         ((0x00000010&(data))>>4)
+#define SB2_INV_INTSTAT_Aciva_int_shift                                              (3)
+#define SB2_INV_INTSTAT_Aciva_int_mask                                               (0x00000008)
+#define SB2_INV_INTSTAT_Aciva_int(data)                                              (0x00000008&((data)<<3))
+#define SB2_INV_INTSTAT_Aciva_int_src(data)                                          ((0x00000008&(data))>>3)
+#define SB2_INV_INTSTAT_get_Aciva_int(data)                                          ((0x00000008&(data))>>3)
+#define SB2_INV_INTSTAT_Sciva_int_shift                                              (1)
+#define SB2_INV_INTSTAT_Sciva_int_mask                                               (0x00000002)
+#define SB2_INV_INTSTAT_Sciva_int(data)                                              (0x00000002&((data)<<1))
+#define SB2_INV_INTSTAT_Sciva_int_src(data)                                          ((0x00000002&(data))>>1)
+#define SB2_INV_INTSTAT_get_Sciva_int(data)                                          ((0x00000002&(data))>>1)
+#define SB2_INV_INTSTAT_write_data_shift                                             (0)
+#define SB2_INV_INTSTAT_write_data_mask                                              (0x00000001)
+#define SB2_INV_INTSTAT_write_data(data)                                             (0x00000001&((data)<<0))
+#define SB2_INV_INTSTAT_write_data_src(data)                                         ((0x00000001&(data))>>0)
+#define SB2_INV_INTSTAT_get_write_data(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SB2_INV_ADDR                                                                 0x1801A00C
+#define SB2_INV_ADDR_reg_addr                                                        "0xB801A00C"
+#define SB2_INV_ADDR_reg                                                             0xB801A00C
+#define set_SB2_INV_ADDR_reg(data)   (*((volatile unsigned int*) SB2_INV_ADDR_reg)=data)
+#define get_SB2_INV_ADDR_reg   (*((volatile unsigned int*) SB2_INV_ADDR_reg))
+#define SB2_INV_ADDR_inst_adr                                                        "0x0003"
+#define SB2_INV_ADDR_inst                                                            0x0003
+#define SB2_INV_ADDR_Inv_adr_shift                                                   (0)
+#define SB2_INV_ADDR_Inv_adr_mask                                                    (0xFFFFFFFF)
+#define SB2_INV_ADDR_Inv_adr(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define SB2_INV_ADDR_Inv_adr_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define SB2_INV_ADDR_get_Inv_adr(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DEBUG_REG                                                                0x1801A010
+#define SB2_DEBUG_REG_reg_addr                                                       "0xB801A010"
+#define SB2_DEBUG_REG_reg                                                            0xB801A010
+#define set_SB2_DEBUG_REG_reg(data)   (*((volatile unsigned int*) SB2_DEBUG_REG_reg)=data)
+#define get_SB2_DEBUG_REG_reg   (*((volatile unsigned int*) SB2_DEBUG_REG_reg))
+#define SB2_DEBUG_REG_inst_adr                                                       "0x0004"
+#define SB2_DEBUG_REG_inst                                                           0x0004
+#define SB2_DEBUG_REG_To_thr1_shift                                                  (2)
+#define SB2_DEBUG_REG_To_thr1_mask                                                   (0x0000001C)
+#define SB2_DEBUG_REG_To_thr1(data)                                                  (0x0000001C&((data)<<2))
+#define SB2_DEBUG_REG_To_thr1_src(data)                                              ((0x0000001C&(data))>>2)
+#define SB2_DEBUG_REG_get_To_thr1(data)                                              ((0x0000001C&(data))>>2)
+#define SB2_DEBUG_REG_To_thr_shift                                                   (0)
+#define SB2_DEBUG_REG_To_thr_mask                                                    (0x00000003)
+#define SB2_DEBUG_REG_To_thr(data)                                                   (0x00000003&((data)<<0))
+#define SB2_DEBUG_REG_To_thr_src(data)                                               ((0x00000003&(data))>>0)
+#define SB2_DEBUG_REG_get_To_thr(data)                                               ((0x00000003&(data))>>0)
+
+
+#define SB2_FLASH_CTRL                                                               0x1801A014
+#define SB2_FLASH_CTRL_reg_addr                                                      "0xB801A014"
+#define SB2_FLASH_CTRL_reg                                                           0xB801A014
+#define set_SB2_FLASH_CTRL_reg(data)   (*((volatile unsigned int*) SB2_FLASH_CTRL_reg)=data)
+#define get_SB2_FLASH_CTRL_reg   (*((volatile unsigned int*) SB2_FLASH_CTRL_reg))
+#define SB2_FLASH_CTRL_inst_adr                                                      "0x0005"
+#define SB2_FLASH_CTRL_inst                                                          0x0005
+#define SB2_FLASH_CTRL_Wr_hold_cyc_shift                                             (18)
+#define SB2_FLASH_CTRL_Wr_hold_cyc_mask                                              (0x003C0000)
+#define SB2_FLASH_CTRL_Wr_hold_cyc(data)                                             (0x003C0000&((data)<<18))
+#define SB2_FLASH_CTRL_Wr_hold_cyc_src(data)                                         ((0x003C0000&(data))>>18)
+#define SB2_FLASH_CTRL_get_Wr_hold_cyc(data)                                         ((0x003C0000&(data))>>18)
+#define SB2_FLASH_CTRL_Wwr_cyc_shift                                                 (10)
+#define SB2_FLASH_CTRL_Wwr_cyc_mask                                                  (0x00007C00)
+#define SB2_FLASH_CTRL_Wwr_cyc(data)                                                 (0x00007C00&((data)<<10))
+#define SB2_FLASH_CTRL_Wwr_cyc_src(data)                                             ((0x00007C00&(data))>>10)
+#define SB2_FLASH_CTRL_get_Wwr_cyc(data)                                             ((0x00007C00&(data))>>10)
+#define SB2_FLASH_CTRL_Wr_cyc_shift                                                  (5)
+#define SB2_FLASH_CTRL_Wr_cyc_mask                                                   (0x000003E0)
+#define SB2_FLASH_CTRL_Wr_cyc(data)                                                  (0x000003E0&((data)<<5))
+#define SB2_FLASH_CTRL_Wr_cyc_src(data)                                              ((0x000003E0&(data))>>5)
+#define SB2_FLASH_CTRL_get_Wr_cyc(data)                                              ((0x000003E0&(data))>>5)
+#define SB2_FLASH_CTRL_Rd_cyc_shift                                                  (0)
+#define SB2_FLASH_CTRL_Rd_cyc_mask                                                   (0x0000001F)
+#define SB2_FLASH_CTRL_Rd_cyc(data)                                                  (0x0000001F&((data)<<0))
+#define SB2_FLASH_CTRL_Rd_cyc_src(data)                                              ((0x0000001F&(data))>>0)
+#define SB2_FLASH_CTRL_get_Rd_cyc(data)                                              ((0x0000001F&(data))>>0)
+
+
+#define SB2_WRAPPER_CTRL                                                             0x1801A018
+#define SB2_WRAPPER_CTRL_reg_addr                                                    "0xB801A018"
+#define SB2_WRAPPER_CTRL_reg                                                         0xB801A018
+#define set_SB2_WRAPPER_CTRL_reg(data)   (*((volatile unsigned int*) SB2_WRAPPER_CTRL_reg)=data)
+#define get_SB2_WRAPPER_CTRL_reg   (*((volatile unsigned int*) SB2_WRAPPER_CTRL_reg))
+#define SB2_WRAPPER_CTRL_inst_adr                                                    "0x0006"
+#define SB2_WRAPPER_CTRL_inst                                                        0x0006
+#define SB2_WRAPPER_CTRL_write_en13_shift                                            (14)
+#define SB2_WRAPPER_CTRL_write_en13_mask                                             (0x00004000)
+#define SB2_WRAPPER_CTRL_write_en13(data)                                            (0x00004000&((data)<<14))
+#define SB2_WRAPPER_CTRL_write_en13_src(data)                                        ((0x00004000&(data))>>14)
+#define SB2_WRAPPER_CTRL_get_write_en13(data)                                        ((0x00004000&(data))>>14)
+#define SB2_WRAPPER_CTRL_mult_wr_en_shift                                            (13)
+#define SB2_WRAPPER_CTRL_mult_wr_en_mask                                             (0x00002000)
+#define SB2_WRAPPER_CTRL_mult_wr_en(data)                                            (0x00002000&((data)<<13))
+#define SB2_WRAPPER_CTRL_mult_wr_en_src(data)                                        ((0x00002000&(data))>>13)
+#define SB2_WRAPPER_CTRL_get_mult_wr_en(data)                                        ((0x00002000&(data))>>13)
+#define SB2_WRAPPER_CTRL_write_en11_shift                                            (12)
+#define SB2_WRAPPER_CTRL_write_en11_mask                                             (0x00001000)
+#define SB2_WRAPPER_CTRL_write_en11(data)                                            (0x00001000&((data)<<12))
+#define SB2_WRAPPER_CTRL_write_en11_src(data)                                        ((0x00001000&(data))>>12)
+#define SB2_WRAPPER_CTRL_get_write_en11(data)                                        ((0x00001000&(data))>>12)
+#define SB2_WRAPPER_CTRL_ac_in_order_shift                                           (11)
+#define SB2_WRAPPER_CTRL_ac_in_order_mask                                            (0x00000800)
+#define SB2_WRAPPER_CTRL_ac_in_order(data)                                           (0x00000800&((data)<<11))
+#define SB2_WRAPPER_CTRL_ac_in_order_src(data)                                       ((0x00000800&(data))>>11)
+#define SB2_WRAPPER_CTRL_get_ac_in_order(data)                                       ((0x00000800&(data))>>11)
+#define SB2_WRAPPER_CTRL_write_en9_shift                                             (10)
+#define SB2_WRAPPER_CTRL_write_en9_mask                                              (0x00000400)
+#define SB2_WRAPPER_CTRL_write_en9(data)                                             (0x00000400&((data)<<10))
+#define SB2_WRAPPER_CTRL_write_en9_src(data)                                         ((0x00000400&(data))>>10)
+#define SB2_WRAPPER_CTRL_get_write_en9(data)                                         ((0x00000400&(data))>>10)
+#define SB2_WRAPPER_CTRL_ac_bypass_shift                                             (9)
+#define SB2_WRAPPER_CTRL_ac_bypass_mask                                              (0x00000200)
+#define SB2_WRAPPER_CTRL_ac_bypass(data)                                             (0x00000200&((data)<<9))
+#define SB2_WRAPPER_CTRL_ac_bypass_src(data)                                         ((0x00000200&(data))>>9)
+#define SB2_WRAPPER_CTRL_get_ac_bypass(data)                                         ((0x00000200&(data))>>9)
+#define SB2_WRAPPER_CTRL_write_en7_shift                                             (8)
+#define SB2_WRAPPER_CTRL_write_en7_mask                                              (0x00000100)
+#define SB2_WRAPPER_CTRL_write_en7(data)                                             (0x00000100&((data)<<8))
+#define SB2_WRAPPER_CTRL_write_en7_src(data)                                         ((0x00000100&(data))>>8)
+#define SB2_WRAPPER_CTRL_get_write_en7(data)                                         ((0x00000100&(data))>>8)
+#define SB2_WRAPPER_CTRL_ac_merge_shift                                              (7)
+#define SB2_WRAPPER_CTRL_ac_merge_mask                                               (0x00000080)
+#define SB2_WRAPPER_CTRL_ac_merge(data)                                              (0x00000080&((data)<<7))
+#define SB2_WRAPPER_CTRL_ac_merge_src(data)                                          ((0x00000080&(data))>>7)
+#define SB2_WRAPPER_CTRL_get_ac_merge(data)                                          ((0x00000080&(data))>>7)
+#define SB2_WRAPPER_CTRL_write_en2_shift                                             (3)
+#define SB2_WRAPPER_CTRL_write_en2_mask                                              (0x00000008)
+#define SB2_WRAPPER_CTRL_write_en2(data)                                             (0x00000008&((data)<<3))
+#define SB2_WRAPPER_CTRL_write_en2_src(data)                                         ((0x00000008&(data))>>3)
+#define SB2_WRAPPER_CTRL_get_write_en2(data)                                         ((0x00000008&(data))>>3)
+#define SB2_WRAPPER_CTRL_sc_in_order_shift                                           (2)
+#define SB2_WRAPPER_CTRL_sc_in_order_mask                                            (0x00000004)
+#define SB2_WRAPPER_CTRL_sc_in_order(data)                                           (0x00000004&((data)<<2))
+#define SB2_WRAPPER_CTRL_sc_in_order_src(data)                                       ((0x00000004&(data))>>2)
+#define SB2_WRAPPER_CTRL_get_sc_in_order(data)                                       ((0x00000004&(data))>>2)
+
+
+#define SB2_SCPU_INT_CHECK                                                           0x1801A01C
+#define SB2_SCPU_INT_CHECK_reg_addr                                                  "0xB801A01C"
+#define SB2_SCPU_INT_CHECK_reg                                                       0xB801A01C
+#define set_SB2_SCPU_INT_CHECK_reg(data)   (*((volatile unsigned int*) SB2_SCPU_INT_CHECK_reg)=data)
+#define get_SB2_SCPU_INT_CHECK_reg   (*((volatile unsigned int*) SB2_SCPU_INT_CHECK_reg))
+#define SB2_SCPU_INT_CHECK_inst_adr                                                  "0x0007"
+#define SB2_SCPU_INT_CHECK_inst                                                      0x0007
+#define SB2_SCPU_INT_CHECK_enable_shift                                              (0)
+#define SB2_SCPU_INT_CHECK_enable_mask                                               (0x00000001)
+#define SB2_SCPU_INT_CHECK_enable(data)                                              (0x00000001&((data)<<0))
+#define SB2_SCPU_INT_CHECK_enable_src(data)                                          ((0x00000001&(data))>>0)
+#define SB2_SCPU_INT_CHECK_get_enable(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SB2_SYNC                                                                     0x1801A020
+#define SB2_SYNC_reg_addr                                                            "0xB801A020"
+#define SB2_SYNC_reg                                                                 0xB801A020
+#define set_SB2_SYNC_reg(data)   (*((volatile unsigned int*) SB2_SYNC_reg)=data)
+#define get_SB2_SYNC_reg   (*((volatile unsigned int*) SB2_SYNC_reg))
+#define SB2_SYNC_inst_adr                                                            "0x0008"
+#define SB2_SYNC_inst                                                                0x0008
+#define SB2_SYNC_Sync_shift                                                          (0)
+#define SB2_SYNC_Sync_mask                                                           (0xFFFFFFFF)
+#define SB2_SYNC_Sync(data)                                                          (0xFFFFFFFF&((data)<<0))
+#define SB2_SYNC_Sync_src(data)                                                      ((0xFFFFFFFF&(data))>>0)
+#define SB2_SYNC_get_Sync(data)                                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DBG                                                                      0x1801A024
+#define SB2_DBG_reg_addr                                                             "0xB801A024"
+#define SB2_DBG_reg                                                                  0xB801A024
+#define set_SB2_DBG_reg(data)   (*((volatile unsigned int*) SB2_DBG_reg)=data)
+#define get_SB2_DBG_reg   (*((volatile unsigned int*) SB2_DBG_reg))
+#define SB2_DBG_inst_adr                                                             "0x0009"
+#define SB2_DBG_inst                                                                 0x0009
+#define SB2_DBG_Dbg_mode_shift                                                       (0)
+#define SB2_DBG_Dbg_mode_mask                                                        (0x0000001F)
+#define SB2_DBG_Dbg_mode(data)                                                       (0x0000001F&((data)<<0))
+#define SB2_DBG_Dbg_mode_src(data)                                                   ((0x0000001F&(data))>>0)
+#define SB2_DBG_get_Dbg_mode(data)                                                   ((0x0000001F&(data))>>0)
+
+
+#define SB2_DEBUG                                                                    0x1801A028
+#define SB2_DEBUG_reg_addr                                                           "0xB801A028"
+#define SB2_DEBUG_reg                                                                0xB801A028
+#define set_SB2_DEBUG_reg(data)   (*((volatile unsigned int*) SB2_DEBUG_reg)=data)
+#define get_SB2_DEBUG_reg   (*((volatile unsigned int*) SB2_DEBUG_reg))
+#define SB2_DEBUG_inst_adr                                                           "0x000A"
+#define SB2_DEBUG_inst                                                               0x000A
+#define SB2_DEBUG_write_enable3_shift                                                (15)
+#define SB2_DEBUG_write_enable3_mask                                                 (0x00008000)
+#define SB2_DEBUG_write_enable3(data)                                                (0x00008000&((data)<<15))
+#define SB2_DEBUG_write_enable3_src(data)                                            ((0x00008000&(data))>>15)
+#define SB2_DEBUG_get_write_enable3(data)                                            ((0x00008000&(data))>>15)
+#define SB2_DEBUG_sel1_shift                                                         (9)
+#define SB2_DEBUG_sel1_mask                                                          (0x00007E00)
+#define SB2_DEBUG_sel1(data)                                                         (0x00007E00&((data)<<9))
+#define SB2_DEBUG_sel1_src(data)                                                     ((0x00007E00&(data))>>9)
+#define SB2_DEBUG_get_sel1(data)                                                     ((0x00007E00&(data))>>9)
+#define SB2_DEBUG_write_enable2_shift                                                (8)
+#define SB2_DEBUG_write_enable2_mask                                                 (0x00000100)
+#define SB2_DEBUG_write_enable2(data)                                                (0x00000100&((data)<<8))
+#define SB2_DEBUG_write_enable2_src(data)                                            ((0x00000100&(data))>>8)
+#define SB2_DEBUG_get_write_enable2(data)                                            ((0x00000100&(data))>>8)
+#define SB2_DEBUG_sel0_shift                                                         (2)
+#define SB2_DEBUG_sel0_mask                                                          (0x000000FC)
+#define SB2_DEBUG_sel0(data)                                                         (0x000000FC&((data)<<2))
+#define SB2_DEBUG_sel0_src(data)                                                     ((0x000000FC&(data))>>2)
+#define SB2_DEBUG_get_sel0(data)                                                     ((0x000000FC&(data))>>2)
+#define SB2_DEBUG_write_enable1_shift                                                (1)
+#define SB2_DEBUG_write_enable1_mask                                                 (0x00000002)
+#define SB2_DEBUG_write_enable1(data)                                                (0x00000002&((data)<<1))
+#define SB2_DEBUG_write_enable1_src(data)                                            ((0x00000002&(data))>>1)
+#define SB2_DEBUG_get_write_enable1(data)                                            ((0x00000002&(data))>>1)
+#define SB2_DEBUG_enable_shift                                                       (0)
+#define SB2_DEBUG_enable_mask                                                        (0x00000001)
+#define SB2_DEBUG_enable(data)                                                       (0x00000001&((data)<<0))
+#define SB2_DEBUG_enable_src(data)                                                   ((0x00000001&(data))>>0)
+#define SB2_DEBUG_get_enable(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define SB2_LEXRA_CTRL                                                               0x1801A070
+#define SB2_LEXRA_CTRL_reg_addr                                                      "0xB801A070"
+#define SB2_LEXRA_CTRL_reg                                                           0xB801A070
+#define set_SB2_LEXRA_CTRL_reg(data)   (*((volatile unsigned int*) SB2_LEXRA_CTRL_reg)=data)
+#define get_SB2_LEXRA_CTRL_reg   (*((volatile unsigned int*) SB2_LEXRA_CTRL_reg))
+#define SB2_LEXRA_CTRL_inst_adr                                                      "0x001C"
+#define SB2_LEXRA_CTRL_inst                                                          0x001C
+#define SB2_LEXRA_CTRL_speed_up_shift                                                (0)
+#define SB2_LEXRA_CTRL_speed_up_mask                                                 (0x00000001)
+#define SB2_LEXRA_CTRL_speed_up(data)                                                (0x00000001&((data)<<0))
+#define SB2_LEXRA_CTRL_speed_up_src(data)                                            ((0x00000001&(data))>>0)
+#define SB2_LEXRA_CTRL_get_speed_up(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SB2_CPU_INT                                                                  0x1801A104
+#define SB2_CPU_INT_reg_addr                                                         "0xB801A104"
+#define SB2_CPU_INT_reg                                                              0xB801A104
+#define set_SB2_CPU_INT_reg(data)   (*((volatile unsigned int*) SB2_CPU_INT_reg)=data)
+#define get_SB2_CPU_INT_reg   (*((volatile unsigned int*) SB2_CPU_INT_reg))
+#define SB2_CPU_INT_inst_adr                                                         "0x0041"
+#define SB2_CPU_INT_inst                                                             0x0041
+#define SB2_CPU_INT_int_aswc_shift                                                   (11)
+#define SB2_CPU_INT_int_aswc_mask                                                    (0x00000800)
+#define SB2_CPU_INT_int_aswc(data)                                                   (0x00000800&((data)<<11))
+#define SB2_CPU_INT_int_aswc_src(data)                                               ((0x00000800&(data))>>11)
+#define SB2_CPU_INT_get_int_aswc(data)                                               ((0x00000800&(data))>>11)
+#define SB2_CPU_INT_int_swca_shift                                                   (10)
+#define SB2_CPU_INT_int_swca_mask                                                    (0x00000400)
+#define SB2_CPU_INT_int_swca(data)                                                   (0x00000400&((data)<<10))
+#define SB2_CPU_INT_int_swca_src(data)                                               ((0x00000400&(data))>>10)
+#define SB2_CPU_INT_get_int_swca(data)                                               ((0x00000400&(data))>>10)
+#define SB2_CPU_INT_int_as_shift                                                     (3)
+#define SB2_CPU_INT_int_as_mask                                                      (0x00000008)
+#define SB2_CPU_INT_int_as(data)                                                     (0x00000008&((data)<<3))
+#define SB2_CPU_INT_int_as_src(data)                                                 ((0x00000008&(data))>>3)
+#define SB2_CPU_INT_get_int_as(data)                                                 ((0x00000008&(data))>>3)
+#define SB2_CPU_INT_int_sa_shift                                                     (1)
+#define SB2_CPU_INT_int_sa_mask                                                      (0x00000002)
+#define SB2_CPU_INT_int_sa(data)                                                     (0x00000002&((data)<<1))
+#define SB2_CPU_INT_int_sa_src(data)                                                 ((0x00000002&(data))>>1)
+#define SB2_CPU_INT_get_int_sa(data)                                                 ((0x00000002&(data))>>1)
+#define SB2_CPU_INT_write_data_shift                                                 (0)
+#define SB2_CPU_INT_write_data_mask                                                  (0x00000001)
+#define SB2_CPU_INT_write_data(data)                                                 (0x00000001&((data)<<0))
+#define SB2_CPU_INT_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define SB2_CPU_INT_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SB2_CPU_INT_EN                                                               0x1801A108
+#define SB2_CPU_INT_EN_reg_addr                                                      "0xB801A108"
+#define SB2_CPU_INT_EN_reg                                                           0xB801A108
+#define set_SB2_CPU_INT_EN_reg(data)   (*((volatile unsigned int*) SB2_CPU_INT_EN_reg)=data)
+#define get_SB2_CPU_INT_EN_reg   (*((volatile unsigned int*) SB2_CPU_INT_EN_reg))
+#define SB2_CPU_INT_EN_inst_adr                                                      "0x0042"
+#define SB2_CPU_INT_EN_inst                                                          0x0042
+#define SB2_CPU_INT_EN_int_aswc_en_shift                                             (11)
+#define SB2_CPU_INT_EN_int_aswc_en_mask                                              (0x00000800)
+#define SB2_CPU_INT_EN_int_aswc_en(data)                                             (0x00000800&((data)<<11))
+#define SB2_CPU_INT_EN_int_aswc_en_src(data)                                         ((0x00000800&(data))>>11)
+#define SB2_CPU_INT_EN_get_int_aswc_en(data)                                         ((0x00000800&(data))>>11)
+#define SB2_CPU_INT_EN_int_swca_en_shift                                             (10)
+#define SB2_CPU_INT_EN_int_swca_en_mask                                              (0x00000400)
+#define SB2_CPU_INT_EN_int_swca_en(data)                                             (0x00000400&((data)<<10))
+#define SB2_CPU_INT_EN_int_swca_en_src(data)                                         ((0x00000400&(data))>>10)
+#define SB2_CPU_INT_EN_get_int_swca_en(data)                                         ((0x00000400&(data))>>10)
+#define SB2_CPU_INT_EN_int_as_en_shift                                               (3)
+#define SB2_CPU_INT_EN_int_as_en_mask                                                (0x00000008)
+#define SB2_CPU_INT_EN_int_as_en(data)                                               (0x00000008&((data)<<3))
+#define SB2_CPU_INT_EN_int_as_en_src(data)                                           ((0x00000008&(data))>>3)
+#define SB2_CPU_INT_EN_get_int_as_en(data)                                           ((0x00000008&(data))>>3)
+#define SB2_CPU_INT_EN_int_sa_en_shift                                               (1)
+#define SB2_CPU_INT_EN_int_sa_en_mask                                                (0x00000002)
+#define SB2_CPU_INT_EN_int_sa_en(data)                                               (0x00000002&((data)<<1))
+#define SB2_CPU_INT_EN_int_sa_en_src(data)                                           ((0x00000002&(data))>>1)
+#define SB2_CPU_INT_EN_get_int_sa_en(data)                                           ((0x00000002&(data))>>1)
+#define SB2_CPU_INT_EN_write_data_shift                                              (0)
+#define SB2_CPU_INT_EN_write_data_mask                                               (0x00000001)
+#define SB2_CPU_INT_EN_write_data(data)                                              (0x00000001&((data)<<0))
+#define SB2_CPU_INT_EN_write_data_src(data)                                          ((0x00000001&(data))>>0)
+#define SB2_CPU_INT_EN_get_write_data(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SB2_DREQ_MASK                                                                0x1801A138
+#define SB2_DREQ_MASK_reg_addr                                                       "0xB801A138"
+#define SB2_DREQ_MASK_reg                                                            0xB801A138
+#define set_SB2_DREQ_MASK_reg(data)   (*((volatile unsigned int*) SB2_DREQ_MASK_reg)=data)
+#define get_SB2_DREQ_MASK_reg   (*((volatile unsigned int*) SB2_DREQ_MASK_reg))
+#define SB2_DREQ_MASK_inst_adr                                                       "0x004E"
+#define SB2_DREQ_MASK_inst                                                           0x004E
+#define SB2_DREQ_MASK_pending_shift                                                  (5)
+#define SB2_DREQ_MASK_pending_mask                                                   (0x00000020)
+#define SB2_DREQ_MASK_pending(data)                                                  (0x00000020&((data)<<5))
+#define SB2_DREQ_MASK_pending_src(data)                                              ((0x00000020&(data))>>5)
+#define SB2_DREQ_MASK_get_pending(data)                                              ((0x00000020&(data))>>5)
+#define SB2_DREQ_MASK_mask_id_shift                                                  (0)
+#define SB2_DREQ_MASK_mask_id_mask                                                   (0x00000007)
+#define SB2_DREQ_MASK_mask_id(data)                                                  (0x00000007&((data)<<0))
+#define SB2_DREQ_MASK_mask_id_src(data)                                              ((0x00000007&(data))>>0)
+#define SB2_DREQ_MASK_get_mask_id(data)                                              ((0x00000007&(data))>>0)
+
+
+#define SB2_CHIP_ID                                                                  0x1801A200
+#define SB2_CHIP_ID_reg_addr                                                         "0xB801A200"
+#define SB2_CHIP_ID_reg                                                              0xB801A200
+#define set_SB2_CHIP_ID_reg(data)   (*((volatile unsigned int*) SB2_CHIP_ID_reg)=data)
+#define get_SB2_CHIP_ID_reg   (*((volatile unsigned int*) SB2_CHIP_ID_reg))
+#define SB2_CHIP_ID_inst_adr                                                         "0x0080"
+#define SB2_CHIP_ID_inst                                                             0x0080
+#define SB2_CHIP_ID_Chip_id_shift                                                    (0)
+#define SB2_CHIP_ID_Chip_id_mask                                                     (0x0000FFFF)
+#define SB2_CHIP_ID_Chip_id(data)                                                    (0x0000FFFF&((data)<<0))
+#define SB2_CHIP_ID_Chip_id_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define SB2_CHIP_ID_get_Chip_id(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define SB2_CHIP_INFO                                                                0x1801A204
+#define SB2_CHIP_INFO_reg_addr                                                       "0xB801A204"
+#define SB2_CHIP_INFO_reg                                                            0xB801A204
+#define set_SB2_CHIP_INFO_reg(data)   (*((volatile unsigned int*) SB2_CHIP_INFO_reg)=data)
+#define get_SB2_CHIP_INFO_reg   (*((volatile unsigned int*) SB2_CHIP_INFO_reg))
+#define SB2_CHIP_INFO_inst_adr                                                       "0x0081"
+#define SB2_CHIP_INFO_inst                                                           0x0081
+#define SB2_CHIP_INFO_Revise_id_shift                                                (16)
+#define SB2_CHIP_INFO_Revise_id_mask                                                 (0xFFFF0000)
+#define SB2_CHIP_INFO_Revise_id(data)                                                (0xFFFF0000&((data)<<16))
+#define SB2_CHIP_INFO_Revise_id_src(data)                                            ((0xFFFF0000&(data))>>16)
+#define SB2_CHIP_INFO_get_Revise_id(data)                                            ((0xFFFF0000&(data))>>16)
+
+
+#define SB2_PC_CTRL                                                                  0x1801A400
+#define SB2_PC_CTRL_reg_addr                                                         "0xB801A400"
+#define SB2_PC_CTRL_reg                                                              0xB801A400
+#define set_SB2_PC_CTRL_reg(data)   (*((volatile unsigned int*) SB2_PC_CTRL_reg)=data)
+#define get_SB2_PC_CTRL_reg   (*((volatile unsigned int*) SB2_PC_CTRL_reg))
+#define SB2_PC_CTRL_inst_adr                                                         "0x0000"
+#define SB2_PC_CTRL_inst                                                             0x0000
+#define SB2_PC_CTRL_write_en6_shift                                                  (11)
+#define SB2_PC_CTRL_write_en6_mask                                                   (0x00000800)
+#define SB2_PC_CTRL_write_en6(data)                                                  (0x00000800&((data)<<11))
+#define SB2_PC_CTRL_write_en6_src(data)                                              ((0x00000800&(data))>>11)
+#define SB2_PC_CTRL_get_write_en6(data)                                              ((0x00000800&(data))>>11)
+#define SB2_PC_CTRL_acpu_rbus_go_shift                                               (10)
+#define SB2_PC_CTRL_acpu_rbus_go_mask                                                (0x00000400)
+#define SB2_PC_CTRL_acpu_rbus_go(data)                                               (0x00000400&((data)<<10))
+#define SB2_PC_CTRL_acpu_rbus_go_src(data)                                           ((0x00000400&(data))>>10)
+#define SB2_PC_CTRL_get_acpu_rbus_go(data)                                           ((0x00000400&(data))>>10)
+#define SB2_PC_CTRL_write_en4_shift                                                  (7)
+#define SB2_PC_CTRL_write_en4_mask                                                   (0x00000080)
+#define SB2_PC_CTRL_write_en4(data)                                                  (0x00000080&((data)<<7))
+#define SB2_PC_CTRL_write_en4_src(data)                                              ((0x00000080&(data))>>7)
+#define SB2_PC_CTRL_get_write_en4(data)                                              ((0x00000080&(data))>>7)
+#define SB2_PC_CTRL_scpu_rbus_go_shift                                               (6)
+#define SB2_PC_CTRL_scpu_rbus_go_mask                                                (0x00000040)
+#define SB2_PC_CTRL_scpu_rbus_go(data)                                               (0x00000040&((data)<<6))
+#define SB2_PC_CTRL_scpu_rbus_go_src(data)                                           ((0x00000040&(data))>>6)
+#define SB2_PC_CTRL_get_scpu_rbus_go(data)                                           ((0x00000040&(data))>>6)
+#define SB2_PC_CTRL_write_en3_shift                                                  (5)
+#define SB2_PC_CTRL_write_en3_mask                                                   (0x00000020)
+#define SB2_PC_CTRL_write_en3(data)                                                  (0x00000020&((data)<<5))
+#define SB2_PC_CTRL_write_en3_src(data)                                              ((0x00000020&(data))>>5)
+#define SB2_PC_CTRL_get_write_en3(data)                                              ((0x00000020&(data))>>5)
+#define SB2_PC_CTRL_acpu_dbus_go_shift                                               (4)
+#define SB2_PC_CTRL_acpu_dbus_go_mask                                                (0x00000010)
+#define SB2_PC_CTRL_acpu_dbus_go(data)                                               (0x00000010&((data)<<4))
+#define SB2_PC_CTRL_acpu_dbus_go_src(data)                                           ((0x00000010&(data))>>4)
+#define SB2_PC_CTRL_get_acpu_dbus_go(data)                                           ((0x00000010&(data))>>4)
+
+
+#define SB2_ACPU_DACC                                                                0x1801A42C
+#define SB2_ACPU_DACC_reg_addr                                                       "0xB801A42C"
+#define SB2_ACPU_DACC_reg                                                            0xB801A42C
+#define set_SB2_ACPU_DACC_reg(data)   (*((volatile unsigned int*) SB2_ACPU_DACC_reg)=data)
+#define get_SB2_ACPU_DACC_reg   (*((volatile unsigned int*) SB2_ACPU_DACC_reg))
+#define SB2_ACPU_DACC_inst_adr                                                       "0x000B"
+#define SB2_ACPU_DACC_inst                                                           0x000B
+#define SB2_ACPU_DACC_acpu_dbus_acc_shift                                            (0)
+#define SB2_ACPU_DACC_acpu_dbus_acc_mask                                             (0xFFFFFFFF)
+#define SB2_ACPU_DACC_acpu_dbus_acc(data)                                            (0xFFFFFFFF&((data)<<0))
+#define SB2_ACPU_DACC_acpu_dbus_acc_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define SB2_ACPU_DACC_get_acpu_dbus_acc(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_ACPU_DREQ_NUM                                                            0x1801A430
+#define SB2_ACPU_DREQ_NUM_reg_addr                                                   "0xB801A430"
+#define SB2_ACPU_DREQ_NUM_reg                                                        0xB801A430
+#define set_SB2_ACPU_DREQ_NUM_reg(data)   (*((volatile unsigned int*) SB2_ACPU_DREQ_NUM_reg)=data)
+#define get_SB2_ACPU_DREQ_NUM_reg   (*((volatile unsigned int*) SB2_ACPU_DREQ_NUM_reg))
+#define SB2_ACPU_DREQ_NUM_inst_adr                                                   "0x000C"
+#define SB2_ACPU_DREQ_NUM_inst                                                       0x000C
+#define SB2_ACPU_DREQ_NUM_acpu_dreq_num_shift                                        (0)
+#define SB2_ACPU_DREQ_NUM_acpu_dreq_num_mask                                         (0x00FFFFFF)
+#define SB2_ACPU_DREQ_NUM_acpu_dreq_num(data)                                        (0x00FFFFFF&((data)<<0))
+#define SB2_ACPU_DREQ_NUM_acpu_dreq_num_src(data)                                    ((0x00FFFFFF&(data))>>0)
+#define SB2_ACPU_DREQ_NUM_get_acpu_dreq_num(data)                                    ((0x00FFFFFF&(data))>>0)
+
+
+#define SB2_ACPU_DREQ_MAX                                                            0x1801A434
+#define SB2_ACPU_DREQ_MAX_reg_addr                                                   "0xB801A434"
+#define SB2_ACPU_DREQ_MAX_reg                                                        0xB801A434
+#define set_SB2_ACPU_DREQ_MAX_reg(data)   (*((volatile unsigned int*) SB2_ACPU_DREQ_MAX_reg)=data)
+#define get_SB2_ACPU_DREQ_MAX_reg   (*((volatile unsigned int*) SB2_ACPU_DREQ_MAX_reg))
+#define SB2_ACPU_DREQ_MAX_inst_adr                                                   "0x000D"
+#define SB2_ACPU_DREQ_MAX_inst                                                       0x000D
+#define SB2_ACPU_DREQ_MAX_acpu_dreq_max_shift                                        (0)
+#define SB2_ACPU_DREQ_MAX_acpu_dreq_max_mask                                         (0x0000FFFF)
+#define SB2_ACPU_DREQ_MAX_acpu_dreq_max(data)                                        (0x0000FFFF&((data)<<0))
+#define SB2_ACPU_DREQ_MAX_acpu_dreq_max_src(data)                                    ((0x0000FFFF&(data))>>0)
+#define SB2_ACPU_DREQ_MAX_get_acpu_dreq_max(data)                                    ((0x0000FFFF&(data))>>0)
+
+
+#define SB2_ACPU_DREQ_ACK                                                            0x1801A438
+#define SB2_ACPU_DREQ_ACK_reg_addr                                                   "0xB801A438"
+#define SB2_ACPU_DREQ_ACK_reg                                                        0xB801A438
+#define set_SB2_ACPU_DREQ_ACK_reg(data)   (*((volatile unsigned int*) SB2_ACPU_DREQ_ACK_reg)=data)
+#define get_SB2_ACPU_DREQ_ACK_reg   (*((volatile unsigned int*) SB2_ACPU_DREQ_ACK_reg))
+#define SB2_ACPU_DREQ_ACK_inst_adr                                                   "0x000E"
+#define SB2_ACPU_DREQ_ACK_inst                                                       0x000E
+#define SB2_ACPU_DREQ_ACK_acpu_dreq_ack_shift                                        (0)
+#define SB2_ACPU_DREQ_ACK_acpu_dreq_ack_mask                                         (0x03FFFFFF)
+#define SB2_ACPU_DREQ_ACK_acpu_dreq_ack(data)                                        (0x03FFFFFF&((data)<<0))
+#define SB2_ACPU_DREQ_ACK_acpu_dreq_ack_src(data)                                    ((0x03FFFFFF&(data))>>0)
+#define SB2_ACPU_DREQ_ACK_get_acpu_dreq_ack(data)                                    ((0x03FFFFFF&(data))>>0)
+
+
+#define SB2_SCPU_RACC                                                                0x1801A440
+#define SB2_SCPU_RACC_reg_addr                                                       "0xB801A440"
+#define SB2_SCPU_RACC_reg                                                            0xB801A440
+#define set_SB2_SCPU_RACC_reg(data)   (*((volatile unsigned int*) SB2_SCPU_RACC_reg)=data)
+#define get_SB2_SCPU_RACC_reg   (*((volatile unsigned int*) SB2_SCPU_RACC_reg))
+#define SB2_SCPU_RACC_inst_adr                                                       "0x0010"
+#define SB2_SCPU_RACC_inst                                                           0x0010
+#define SB2_SCPU_RACC_scpu_rbus_acc_shift                                            (0)
+#define SB2_SCPU_RACC_scpu_rbus_acc_mask                                             (0xFFFFFFFF)
+#define SB2_SCPU_RACC_scpu_rbus_acc(data)                                            (0xFFFFFFFF&((data)<<0))
+#define SB2_SCPU_RACC_scpu_rbus_acc_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define SB2_SCPU_RACC_get_scpu_rbus_acc(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_SCPU_RREQ_RLT                                                            0x1801A444
+#define SB2_SCPU_RREQ_RLT_reg_addr                                                   "0xB801A444"
+#define SB2_SCPU_RREQ_RLT_reg                                                        0xB801A444
+#define set_SB2_SCPU_RREQ_RLT_reg(data)   (*((volatile unsigned int*) SB2_SCPU_RREQ_RLT_reg)=data)
+#define get_SB2_SCPU_RREQ_RLT_reg   (*((volatile unsigned int*) SB2_SCPU_RREQ_RLT_reg))
+#define SB2_SCPU_RREQ_RLT_inst_adr                                                   "0x0011"
+#define SB2_SCPU_RREQ_RLT_inst                                                       0x0011
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_max_shift                                        (24)
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_max_mask                                         (0xFF000000)
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_max(data)                                        (0xFF000000&((data)<<24))
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_max_src(data)                                    ((0xFF000000&(data))>>24)
+#define SB2_SCPU_RREQ_RLT_get_scpu_rreq_max(data)                                    ((0xFF000000&(data))>>24)
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_num_shift                                        (0)
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_num_mask                                         (0x00FFFFFF)
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_num(data)                                        (0x00FFFFFF&((data)<<0))
+#define SB2_SCPU_RREQ_RLT_scpu_rreq_num_src(data)                                    ((0x00FFFFFF&(data))>>0)
+#define SB2_SCPU_RREQ_RLT_get_scpu_rreq_num(data)                                    ((0x00FFFFFF&(data))>>0)
+
+
+#define SB2_ACPU_RACC                                                                0x1801A450
+#define SB2_ACPU_RACC_reg_addr                                                       "0xB801A450"
+#define SB2_ACPU_RACC_reg                                                            0xB801A450
+#define set_SB2_ACPU_RACC_reg(data)   (*((volatile unsigned int*) SB2_ACPU_RACC_reg)=data)
+#define get_SB2_ACPU_RACC_reg   (*((volatile unsigned int*) SB2_ACPU_RACC_reg))
+#define SB2_ACPU_RACC_inst_adr                                                       "0x0014"
+#define SB2_ACPU_RACC_inst                                                           0x0014
+#define SB2_ACPU_RACC_acpu_rbus_acc_shift                                            (0)
+#define SB2_ACPU_RACC_acpu_rbus_acc_mask                                             (0xFFFFFFFF)
+#define SB2_ACPU_RACC_acpu_rbus_acc(data)                                            (0xFFFFFFFF&((data)<<0))
+#define SB2_ACPU_RACC_acpu_rbus_acc_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define SB2_ACPU_RACC_get_acpu_rbus_acc(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_ACPU_RREQ_RLT                                                            0x1801A454
+#define SB2_ACPU_RREQ_RLT_reg_addr                                                   "0xB801A454"
+#define SB2_ACPU_RREQ_RLT_reg                                                        0xB801A454
+#define set_SB2_ACPU_RREQ_RLT_reg(data)   (*((volatile unsigned int*) SB2_ACPU_RREQ_RLT_reg)=data)
+#define get_SB2_ACPU_RREQ_RLT_reg   (*((volatile unsigned int*) SB2_ACPU_RREQ_RLT_reg))
+#define SB2_ACPU_RREQ_RLT_inst_adr                                                   "0x0015"
+#define SB2_ACPU_RREQ_RLT_inst                                                       0x0015
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_max_shift                                        (24)
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_max_mask                                         (0xFF000000)
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_max(data)                                        (0xFF000000&((data)<<24))
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_max_src(data)                                    ((0xFF000000&(data))>>24)
+#define SB2_ACPU_RREQ_RLT_get_acpu_rreq_max(data)                                    ((0xFF000000&(data))>>24)
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_num_shift                                        (0)
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_num_mask                                         (0x00FFFFFF)
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_num(data)                                        (0x00FFFFFF&((data)<<0))
+#define SB2_ACPU_RREQ_RLT_acpu_rreq_num_src(data)                                    ((0x00FFFFFF&(data))>>0)
+#define SB2_ACPU_RREQ_RLT_get_acpu_rreq_num(data)                                    ((0x00FFFFFF&(data))>>0)
+
+
+#define SB2_DBG_START_0                                                              0x1801A458
+#define SB2_DBG_START_1                                                              0x1801A45C
+#define SB2_DBG_START_2                                                              0x1801A460
+#define SB2_DBG_START_3                                                              0x1801A464
+#define SB2_DBG_START_4                                                              0x1801A468
+#define SB2_DBG_START_5                                                              0x1801A46C
+#define SB2_DBG_START_6                                                              0x1801A470
+#define SB2_DBG_START_7                                                              0x1801A474
+#define SB2_DBG_START_0_reg_addr                                                     "0xB801A458"
+#define SB2_DBG_START_1_reg_addr                                                     "0xB801A45C"
+#define SB2_DBG_START_2_reg_addr                                                     "0xB801A460"
+#define SB2_DBG_START_3_reg_addr                                                     "0xB801A464"
+#define SB2_DBG_START_4_reg_addr                                                     "0xB801A468"
+#define SB2_DBG_START_5_reg_addr                                                     "0xB801A46C"
+#define SB2_DBG_START_6_reg_addr                                                     "0xB801A470"
+#define SB2_DBG_START_7_reg_addr                                                     "0xB801A474"
+#define SB2_DBG_START_0_reg                                                          0xB801A458
+#define SB2_DBG_START_1_reg                                                          0xB801A45C
+#define SB2_DBG_START_2_reg                                                          0xB801A460
+#define SB2_DBG_START_3_reg                                                          0xB801A464
+#define SB2_DBG_START_4_reg                                                          0xB801A468
+#define SB2_DBG_START_5_reg                                                          0xB801A46C
+#define SB2_DBG_START_6_reg                                                          0xB801A470
+#define SB2_DBG_START_7_reg                                                          0xB801A474
+#define set_SB2_DBG_START_0_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_0_reg)=data)
+#define set_SB2_DBG_START_1_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_1_reg)=data)
+#define set_SB2_DBG_START_2_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_2_reg)=data)
+#define set_SB2_DBG_START_3_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_3_reg)=data)
+#define set_SB2_DBG_START_4_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_4_reg)=data)
+#define set_SB2_DBG_START_5_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_5_reg)=data)
+#define set_SB2_DBG_START_6_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_6_reg)=data)
+#define set_SB2_DBG_START_7_reg(data)   (*((volatile unsigned int*) SB2_DBG_START_7_reg)=data)
+#define get_SB2_DBG_START_0_reg   (*((volatile unsigned int*) SB2_DBG_START_0_reg))
+#define get_SB2_DBG_START_1_reg   (*((volatile unsigned int*) SB2_DBG_START_1_reg))
+#define get_SB2_DBG_START_2_reg   (*((volatile unsigned int*) SB2_DBG_START_2_reg))
+#define get_SB2_DBG_START_3_reg   (*((volatile unsigned int*) SB2_DBG_START_3_reg))
+#define get_SB2_DBG_START_4_reg   (*((volatile unsigned int*) SB2_DBG_START_4_reg))
+#define get_SB2_DBG_START_5_reg   (*((volatile unsigned int*) SB2_DBG_START_5_reg))
+#define get_SB2_DBG_START_6_reg   (*((volatile unsigned int*) SB2_DBG_START_6_reg))
+#define get_SB2_DBG_START_7_reg   (*((volatile unsigned int*) SB2_DBG_START_7_reg))
+#define SB2_DBG_START_0_inst_adr                                                     "0x0016"
+#define SB2_DBG_START_1_inst_adr                                                     "0x0017"
+#define SB2_DBG_START_2_inst_adr                                                     "0x0018"
+#define SB2_DBG_START_3_inst_adr                                                     "0x0019"
+#define SB2_DBG_START_4_inst_adr                                                     "0x001A"
+#define SB2_DBG_START_5_inst_adr                                                     "0x001B"
+#define SB2_DBG_START_6_inst_adr                                                     "0x001C"
+#define SB2_DBG_START_7_inst_adr                                                     "0x001D"
+#define SB2_DBG_START_0_inst                                                         0x0016
+#define SB2_DBG_START_1_inst                                                         0x0017
+#define SB2_DBG_START_2_inst                                                         0x0018
+#define SB2_DBG_START_3_inst                                                         0x0019
+#define SB2_DBG_START_4_inst                                                         0x001A
+#define SB2_DBG_START_5_inst                                                         0x001B
+#define SB2_DBG_START_6_inst                                                         0x001C
+#define SB2_DBG_START_7_inst                                                         0x001D
+#define SB2_DBG_START_Dbg_start_addr_shift                                           (0)
+#define SB2_DBG_START_Dbg_start_addr_mask                                            (0xFFFFFFFF)
+#define SB2_DBG_START_Dbg_start_addr(data)                                           (0xFFFFFFFF&((data)<<0))
+#define SB2_DBG_START_Dbg_start_addr_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define SB2_DBG_START_get_Dbg_start_addr(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DBG_END_0                                                                0x1801A478
+#define SB2_DBG_END_1                                                                0x1801A47C
+#define SB2_DBG_END_2                                                                0x1801A480
+#define SB2_DBG_END_3                                                                0x1801A484
+#define SB2_DBG_END_4                                                                0x1801A488
+#define SB2_DBG_END_5                                                                0x1801A48C
+#define SB2_DBG_END_6                                                                0x1801A490
+#define SB2_DBG_END_7                                                                0x1801A494
+#define SB2_DBG_END_0_reg_addr                                                       "0xB801A478"
+#define SB2_DBG_END_1_reg_addr                                                       "0xB801A47C"
+#define SB2_DBG_END_2_reg_addr                                                       "0xB801A480"
+#define SB2_DBG_END_3_reg_addr                                                       "0xB801A484"
+#define SB2_DBG_END_4_reg_addr                                                       "0xB801A488"
+#define SB2_DBG_END_5_reg_addr                                                       "0xB801A48C"
+#define SB2_DBG_END_6_reg_addr                                                       "0xB801A490"
+#define SB2_DBG_END_7_reg_addr                                                       "0xB801A494"
+#define SB2_DBG_END_0_reg                                                            0xB801A478
+#define SB2_DBG_END_1_reg                                                            0xB801A47C
+#define SB2_DBG_END_2_reg                                                            0xB801A480
+#define SB2_DBG_END_3_reg                                                            0xB801A484
+#define SB2_DBG_END_4_reg                                                            0xB801A488
+#define SB2_DBG_END_5_reg                                                            0xB801A48C
+#define SB2_DBG_END_6_reg                                                            0xB801A490
+#define SB2_DBG_END_7_reg                                                            0xB801A494
+#define set_SB2_DBG_END_0_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_0_reg)=data)
+#define set_SB2_DBG_END_1_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_1_reg)=data)
+#define set_SB2_DBG_END_2_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_2_reg)=data)
+#define set_SB2_DBG_END_3_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_3_reg)=data)
+#define set_SB2_DBG_END_4_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_4_reg)=data)
+#define set_SB2_DBG_END_5_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_5_reg)=data)
+#define set_SB2_DBG_END_6_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_6_reg)=data)
+#define set_SB2_DBG_END_7_reg(data)   (*((volatile unsigned int*) SB2_DBG_END_7_reg)=data)
+#define get_SB2_DBG_END_0_reg   (*((volatile unsigned int*) SB2_DBG_END_0_reg))
+#define get_SB2_DBG_END_1_reg   (*((volatile unsigned int*) SB2_DBG_END_1_reg))
+#define get_SB2_DBG_END_2_reg   (*((volatile unsigned int*) SB2_DBG_END_2_reg))
+#define get_SB2_DBG_END_3_reg   (*((volatile unsigned int*) SB2_DBG_END_3_reg))
+#define get_SB2_DBG_END_4_reg   (*((volatile unsigned int*) SB2_DBG_END_4_reg))
+#define get_SB2_DBG_END_5_reg   (*((volatile unsigned int*) SB2_DBG_END_5_reg))
+#define get_SB2_DBG_END_6_reg   (*((volatile unsigned int*) SB2_DBG_END_6_reg))
+#define get_SB2_DBG_END_7_reg   (*((volatile unsigned int*) SB2_DBG_END_7_reg))
+#define SB2_DBG_END_0_inst_adr                                                       "0x001E"
+#define SB2_DBG_END_1_inst_adr                                                       "0x001F"
+#define SB2_DBG_END_2_inst_adr                                                       "0x0020"
+#define SB2_DBG_END_3_inst_adr                                                       "0x0021"
+#define SB2_DBG_END_4_inst_adr                                                       "0x0022"
+#define SB2_DBG_END_5_inst_adr                                                       "0x0023"
+#define SB2_DBG_END_6_inst_adr                                                       "0x0024"
+#define SB2_DBG_END_7_inst_adr                                                       "0x0025"
+#define SB2_DBG_END_0_inst                                                           0x001E
+#define SB2_DBG_END_1_inst                                                           0x001F
+#define SB2_DBG_END_2_inst                                                           0x0020
+#define SB2_DBG_END_3_inst                                                           0x0021
+#define SB2_DBG_END_4_inst                                                           0x0022
+#define SB2_DBG_END_5_inst                                                           0x0023
+#define SB2_DBG_END_6_inst                                                           0x0024
+#define SB2_DBG_END_7_inst                                                           0x0025
+#define SB2_DBG_END_Dbg_end_addr_shift                                               (0)
+#define SB2_DBG_END_Dbg_end_addr_mask                                                (0xFFFFFFFF)
+#define SB2_DBG_END_Dbg_end_addr(data)                                               (0xFFFFFFFF&((data)<<0))
+#define SB2_DBG_END_Dbg_end_addr_src(data)                                           ((0xFFFFFFFF&(data))>>0)
+#define SB2_DBG_END_get_Dbg_end_addr(data)                                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DBG_CTRL_0                                                               0x1801A498
+#define SB2_DBG_CTRL_1                                                               0x1801A49C
+#define SB2_DBG_CTRL_2                                                               0x1801A4A0
+#define SB2_DBG_CTRL_3                                                               0x1801A4A4
+#define SB2_DBG_CTRL_4                                                               0x1801A4A8
+#define SB2_DBG_CTRL_5                                                               0x1801A4AC
+#define SB2_DBG_CTRL_6                                                               0x1801A4B0
+#define SB2_DBG_CTRL_7                                                               0x1801A4B4
+#define SB2_DBG_CTRL_0_reg_addr                                                      "0xB801A498"
+#define SB2_DBG_CTRL_1_reg_addr                                                      "0xB801A49C"
+#define SB2_DBG_CTRL_2_reg_addr                                                      "0xB801A4A0"
+#define SB2_DBG_CTRL_3_reg_addr                                                      "0xB801A4A4"
+#define SB2_DBG_CTRL_4_reg_addr                                                      "0xB801A4A8"
+#define SB2_DBG_CTRL_5_reg_addr                                                      "0xB801A4AC"
+#define SB2_DBG_CTRL_6_reg_addr                                                      "0xB801A4B0"
+#define SB2_DBG_CTRL_7_reg_addr                                                      "0xB801A4B4"
+#define SB2_DBG_CTRL_0_reg                                                           0xB801A498
+#define SB2_DBG_CTRL_1_reg                                                           0xB801A49C
+#define SB2_DBG_CTRL_2_reg                                                           0xB801A4A0
+#define SB2_DBG_CTRL_3_reg                                                           0xB801A4A4
+#define SB2_DBG_CTRL_4_reg                                                           0xB801A4A8
+#define SB2_DBG_CTRL_5_reg                                                           0xB801A4AC
+#define SB2_DBG_CTRL_6_reg                                                           0xB801A4B0
+#define SB2_DBG_CTRL_7_reg                                                           0xB801A4B4
+#define set_SB2_DBG_CTRL_0_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_0_reg)=data)
+#define set_SB2_DBG_CTRL_1_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_1_reg)=data)
+#define set_SB2_DBG_CTRL_2_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_2_reg)=data)
+#define set_SB2_DBG_CTRL_3_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_3_reg)=data)
+#define set_SB2_DBG_CTRL_4_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_4_reg)=data)
+#define set_SB2_DBG_CTRL_5_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_5_reg)=data)
+#define set_SB2_DBG_CTRL_6_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_6_reg)=data)
+#define set_SB2_DBG_CTRL_7_reg(data)   (*((volatile unsigned int*) SB2_DBG_CTRL_7_reg)=data)
+#define get_SB2_DBG_CTRL_0_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_0_reg))
+#define get_SB2_DBG_CTRL_1_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_1_reg))
+#define get_SB2_DBG_CTRL_2_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_2_reg))
+#define get_SB2_DBG_CTRL_3_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_3_reg))
+#define get_SB2_DBG_CTRL_4_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_4_reg))
+#define get_SB2_DBG_CTRL_5_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_5_reg))
+#define get_SB2_DBG_CTRL_6_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_6_reg))
+#define get_SB2_DBG_CTRL_7_reg   (*((volatile unsigned int*) SB2_DBG_CTRL_7_reg))
+#define SB2_DBG_CTRL_0_inst_adr                                                      "0x0026"
+#define SB2_DBG_CTRL_1_inst_adr                                                      "0x0027"
+#define SB2_DBG_CTRL_2_inst_adr                                                      "0x0028"
+#define SB2_DBG_CTRL_3_inst_adr                                                      "0x0029"
+#define SB2_DBG_CTRL_4_inst_adr                                                      "0x002A"
+#define SB2_DBG_CTRL_5_inst_adr                                                      "0x002B"
+#define SB2_DBG_CTRL_6_inst_adr                                                      "0x002C"
+#define SB2_DBG_CTRL_7_inst_adr                                                      "0x002D"
+#define SB2_DBG_CTRL_0_inst                                                          0x0026
+#define SB2_DBG_CTRL_1_inst                                                          0x0027
+#define SB2_DBG_CTRL_2_inst                                                          0x0028
+#define SB2_DBG_CTRL_3_inst                                                          0x0029
+#define SB2_DBG_CTRL_4_inst                                                          0x002A
+#define SB2_DBG_CTRL_5_inst                                                          0x002B
+#define SB2_DBG_CTRL_6_inst                                                          0x002C
+#define SB2_DBG_CTRL_7_inst                                                          0x002D
+#define SB2_DBG_CTRL_write_en6_shift                                                 (13)
+#define SB2_DBG_CTRL_write_en6_mask                                                  (0x00002000)
+#define SB2_DBG_CTRL_write_en6(data)                                                 (0x00002000&((data)<<13))
+#define SB2_DBG_CTRL_write_en6_src(data)                                             ((0x00002000&(data))>>13)
+#define SB2_DBG_CTRL_get_write_en6(data)                                             ((0x00002000&(data))>>13)
+#define SB2_DBG_CTRL_Dbg_acpu_chk_en_shift                                           (12)
+#define SB2_DBG_CTRL_Dbg_acpu_chk_en_mask                                            (0x00001000)
+#define SB2_DBG_CTRL_Dbg_acpu_chk_en(data)                                           (0x00001000&((data)<<12))
+#define SB2_DBG_CTRL_Dbg_acpu_chk_en_src(data)                                       ((0x00001000&(data))>>12)
+#define SB2_DBG_CTRL_get_Dbg_acpu_chk_en(data)                                       ((0x00001000&(data))>>12)
+#define SB2_DBG_CTRL_write_en4_shift                                                 (9)
+#define SB2_DBG_CTRL_write_en4_mask                                                  (0x00000200)
+#define SB2_DBG_CTRL_write_en4(data)                                                 (0x00000200&((data)<<9))
+#define SB2_DBG_CTRL_write_en4_src(data)                                             ((0x00000200&(data))>>9)
+#define SB2_DBG_CTRL_get_write_en4(data)                                             ((0x00000200&(data))>>9)
+#define SB2_DBG_CTRL_Dbg_scpu_chk_en_shift                                           (8)
+#define SB2_DBG_CTRL_Dbg_scpu_chk_en_mask                                            (0x00000100)
+#define SB2_DBG_CTRL_Dbg_scpu_chk_en(data)                                           (0x00000100&((data)<<8))
+#define SB2_DBG_CTRL_Dbg_scpu_chk_en_src(data)                                       ((0x00000100&(data))>>8)
+#define SB2_DBG_CTRL_get_Dbg_scpu_chk_en(data)                                       ((0x00000100&(data))>>8)
+#define SB2_DBG_CTRL_write_en3_shift                                                 (7)
+#define SB2_DBG_CTRL_write_en3_mask                                                  (0x00000080)
+#define SB2_DBG_CTRL_write_en3(data)                                                 (0x00000080&((data)<<7))
+#define SB2_DBG_CTRL_write_en3_src(data)                                             ((0x00000080&(data))>>7)
+#define SB2_DBG_CTRL_get_write_en3(data)                                             ((0x00000080&(data))>>7)
+#define SB2_DBG_CTRL_Dbg_wr_chk_shift                                                (5)
+#define SB2_DBG_CTRL_Dbg_wr_chk_mask                                                 (0x00000060)
+#define SB2_DBG_CTRL_Dbg_wr_chk(data)                                                (0x00000060&((data)<<5))
+#define SB2_DBG_CTRL_Dbg_wr_chk_src(data)                                            ((0x00000060&(data))>>5)
+#define SB2_DBG_CTRL_get_Dbg_wr_chk(data)                                            ((0x00000060&(data))>>5)
+#define SB2_DBG_CTRL_write_en2_shift                                                 (4)
+#define SB2_DBG_CTRL_write_en2_mask                                                  (0x00000010)
+#define SB2_DBG_CTRL_write_en2(data)                                                 (0x00000010&((data)<<4))
+#define SB2_DBG_CTRL_write_en2_src(data)                                             ((0x00000010&(data))>>4)
+#define SB2_DBG_CTRL_get_write_en2(data)                                             ((0x00000010&(data))>>4)
+#define SB2_DBG_CTRL_Dbg_id_chk_shift                                                (2)
+#define SB2_DBG_CTRL_Dbg_id_chk_mask                                                 (0x0000000C)
+#define SB2_DBG_CTRL_Dbg_id_chk(data)                                                (0x0000000C&((data)<<2))
+#define SB2_DBG_CTRL_Dbg_id_chk_src(data)                                            ((0x0000000C&(data))>>2)
+#define SB2_DBG_CTRL_get_Dbg_id_chk(data)                                            ((0x0000000C&(data))>>2)
+#define SB2_DBG_CTRL_write_en1_shift                                                 (1)
+#define SB2_DBG_CTRL_write_en1_mask                                                  (0x00000002)
+#define SB2_DBG_CTRL_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define SB2_DBG_CTRL_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define SB2_DBG_CTRL_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define SB2_DBG_CTRL_Dbg_en_shift                                                    (0)
+#define SB2_DBG_CTRL_Dbg_en_mask                                                     (0x00000001)
+#define SB2_DBG_CTRL_Dbg_en(data)                                                    (0x00000001&((data)<<0))
+#define SB2_DBG_CTRL_Dbg_en_src(data)                                                ((0x00000001&(data))>>0)
+#define SB2_DBG_CTRL_get_Dbg_en(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SB2_DBG_ADDR_0                                                               0x1801A4B8
+#define SB2_DBG_ADDR_1                                                               0x1801A4BC
+#define SB2_DBG_ADDR_2                                                               0x1801A4C0
+#define SB2_DBG_ADDR_0_reg_addr                                                      "0xB801A4B8"
+#define SB2_DBG_ADDR_1_reg_addr                                                      "0xB801A4BC"
+#define SB2_DBG_ADDR_2_reg_addr                                                      "0xB801A4C0"
+#define SB2_DBG_ADDR_0_reg                                                           0xB801A4B8
+#define SB2_DBG_ADDR_1_reg                                                           0xB801A4BC
+#define SB2_DBG_ADDR_2_reg                                                           0xB801A4C0
+#define set_SB2_DBG_ADDR_0_reg(data)   (*((volatile unsigned int*) SB2_DBG_ADDR_0_reg)=data)
+#define set_SB2_DBG_ADDR_1_reg(data)   (*((volatile unsigned int*) SB2_DBG_ADDR_1_reg)=data)
+#define set_SB2_DBG_ADDR_2_reg(data)   (*((volatile unsigned int*) SB2_DBG_ADDR_2_reg)=data)
+#define get_SB2_DBG_ADDR_0_reg   (*((volatile unsigned int*) SB2_DBG_ADDR_0_reg))
+#define get_SB2_DBG_ADDR_1_reg   (*((volatile unsigned int*) SB2_DBG_ADDR_1_reg))
+#define get_SB2_DBG_ADDR_2_reg   (*((volatile unsigned int*) SB2_DBG_ADDR_2_reg))
+#define SB2_DBG_ADDR_0_inst_adr                                                      "0x002E"
+#define SB2_DBG_ADDR_1_inst_adr                                                      "0x002F"
+#define SB2_DBG_ADDR_2_inst_adr                                                      "0x0030"
+#define SB2_DBG_ADDR_0_inst                                                          0x002E
+#define SB2_DBG_ADDR_1_inst                                                          0x002F
+#define SB2_DBG_ADDR_2_inst                                                          0x0030
+#define SB2_DBG_ADDR_dbg_addr_shift                                                  (0)
+#define SB2_DBG_ADDR_dbg_addr_mask                                                   (0xFFFFFFFF)
+#define SB2_DBG_ADDR_dbg_addr(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define SB2_DBG_ADDR_dbg_addr_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define SB2_DBG_ADDR_get_dbg_addr(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_DBG_ADDR1                                                                0x1801A4C8
+#define SB2_DBG_ADDR1_reg_addr                                                       "0xB801A4C8"
+#define SB2_DBG_ADDR1_reg                                                            0xB801A4C8
+#define set_SB2_DBG_ADDR1_reg(data)   (*((volatile unsigned int*) SB2_DBG_ADDR1_reg)=data)
+#define get_SB2_DBG_ADDR1_reg   (*((volatile unsigned int*) SB2_DBG_ADDR1_reg))
+#define SB2_DBG_ADDR1_inst_adr                                                       "0x0032"
+#define SB2_DBG_ADDR1_inst                                                           0x0032
+#define SB2_DBG_ADDR1_acpu_dbg_write_shift                                           (5)
+#define SB2_DBG_ADDR1_acpu_dbg_write_mask                                            (0x00000020)
+#define SB2_DBG_ADDR1_acpu_dbg_write(data)                                           (0x00000020&((data)<<5))
+#define SB2_DBG_ADDR1_acpu_dbg_write_src(data)                                       ((0x00000020&(data))>>5)
+#define SB2_DBG_ADDR1_get_acpu_dbg_write(data)                                       ((0x00000020&(data))>>5)
+#define SB2_DBG_ADDR1_acpu_dbg_dacc_shift                                            (4)
+#define SB2_DBG_ADDR1_acpu_dbg_dacc_mask                                             (0x00000010)
+#define SB2_DBG_ADDR1_acpu_dbg_dacc(data)                                            (0x00000010&((data)<<4))
+#define SB2_DBG_ADDR1_acpu_dbg_dacc_src(data)                                        ((0x00000010&(data))>>4)
+#define SB2_DBG_ADDR1_get_acpu_dbg_dacc(data)                                        ((0x00000010&(data))>>4)
+#define SB2_DBG_ADDR1_scpu_dbg_write_shift                                           (3)
+#define SB2_DBG_ADDR1_scpu_dbg_write_mask                                            (0x00000008)
+#define SB2_DBG_ADDR1_scpu_dbg_write(data)                                           (0x00000008&((data)<<3))
+#define SB2_DBG_ADDR1_scpu_dbg_write_src(data)                                       ((0x00000008&(data))>>3)
+#define SB2_DBG_ADDR1_get_scpu_dbg_write(data)                                       ((0x00000008&(data))>>3)
+#define SB2_DBG_ADDR1_scpu_dbg_dacc_shift                                            (2)
+#define SB2_DBG_ADDR1_scpu_dbg_dacc_mask                                             (0x00000004)
+#define SB2_DBG_ADDR1_scpu_dbg_dacc(data)                                            (0x00000004&((data)<<2))
+#define SB2_DBG_ADDR1_scpu_dbg_dacc_src(data)                                        ((0x00000004&(data))>>2)
+#define SB2_DBG_ADDR1_get_scpu_dbg_dacc(data)                                        ((0x00000004&(data))>>2)
+
+
+#define SB2_DBG_INT                                                                  0x1801A4E0
+#define SB2_DBG_INT_reg_addr                                                         "0xB801A4E0"
+#define SB2_DBG_INT_reg                                                              0xB801A4E0
+#define set_SB2_DBG_INT_reg(data)   (*((volatile unsigned int*) SB2_DBG_INT_reg)=data)
+#define get_SB2_DBG_INT_reg   (*((volatile unsigned int*) SB2_DBG_INT_reg))
+#define SB2_DBG_INT_inst_adr                                                         "0x0038"
+#define SB2_DBG_INT_inst                                                             0x0038
+#define SB2_DBG_INT_acpu_int_shift                                                   (12)
+#define SB2_DBG_INT_acpu_int_mask                                                    (0x00001000)
+#define SB2_DBG_INT_acpu_int(data)                                                   (0x00001000&((data)<<12))
+#define SB2_DBG_INT_acpu_int_src(data)                                               ((0x00001000&(data))>>12)
+#define SB2_DBG_INT_get_acpu_int(data)                                               ((0x00001000&(data))>>12)
+#define SB2_DBG_INT_scpu_int_shift                                                   (10)
+#define SB2_DBG_INT_scpu_int_mask                                                    (0x00000400)
+#define SB2_DBG_INT_scpu_int(data)                                                   (0x00000400&((data)<<10))
+#define SB2_DBG_INT_scpu_int_src(data)                                               ((0x00000400&(data))>>10)
+#define SB2_DBG_INT_get_scpu_int(data)                                               ((0x00000400&(data))>>10)
+#define SB2_DBG_INT_acpu_int_en_shift                                                (9)
+#define SB2_DBG_INT_acpu_int_en_mask                                                 (0x00000200)
+#define SB2_DBG_INT_acpu_int_en(data)                                                (0x00000200&((data)<<9))
+#define SB2_DBG_INT_acpu_int_en_src(data)                                            ((0x00000200&(data))>>9)
+#define SB2_DBG_INT_get_acpu_int_en(data)                                            ((0x00000200&(data))>>9)
+#define SB2_DBG_INT_scpu_int_en_shift                                                (7)
+#define SB2_DBG_INT_scpu_int_en_mask                                                 (0x00000080)
+#define SB2_DBG_INT_scpu_int_en(data)                                                (0x00000080&((data)<<7))
+#define SB2_DBG_INT_scpu_int_en_src(data)                                            ((0x00000080&(data))>>7)
+#define SB2_DBG_INT_get_scpu_int_en(data)                                            ((0x00000080&(data))>>7)
+#define SB2_DBG_INT_acpu_neg_int_shift                                               (6)
+#define SB2_DBG_INT_acpu_neg_int_mask                                                (0x00000040)
+#define SB2_DBG_INT_acpu_neg_int(data)                                               (0x00000040&((data)<<6))
+#define SB2_DBG_INT_acpu_neg_int_src(data)                                           ((0x00000040&(data))>>6)
+#define SB2_DBG_INT_get_acpu_neg_int(data)                                           ((0x00000040&(data))>>6)
+#define SB2_DBG_INT_scpu_neg_int_shift                                               (4)
+#define SB2_DBG_INT_scpu_neg_int_mask                                                (0x00000010)
+#define SB2_DBG_INT_scpu_neg_int(data)                                               (0x00000010&((data)<<4))
+#define SB2_DBG_INT_scpu_neg_int_src(data)                                           ((0x00000010&(data))>>4)
+#define SB2_DBG_INT_get_scpu_neg_int(data)                                           ((0x00000010&(data))>>4)
+#define SB2_DBG_INT_acpu_neg_int_en_shift                                            (3)
+#define SB2_DBG_INT_acpu_neg_int_en_mask                                             (0x00000008)
+#define SB2_DBG_INT_acpu_neg_int_en(data)                                            (0x00000008&((data)<<3))
+#define SB2_DBG_INT_acpu_neg_int_en_src(data)                                        ((0x00000008&(data))>>3)
+#define SB2_DBG_INT_get_acpu_neg_int_en(data)                                        ((0x00000008&(data))>>3)
+#define SB2_DBG_INT_scpu_neg_int_en_shift                                            (1)
+#define SB2_DBG_INT_scpu_neg_int_en_mask                                             (0x00000002)
+#define SB2_DBG_INT_scpu_neg_int_en(data)                                            (0x00000002&((data)<<1))
+#define SB2_DBG_INT_scpu_neg_int_en_src(data)                                        ((0x00000002&(data))>>1)
+#define SB2_DBG_INT_get_scpu_neg_int_en(data)                                        ((0x00000002&(data))>>1)
+#define SB2_DBG_INT_write_data_shift                                                 (0)
+#define SB2_DBG_INT_write_data_mask                                                  (0x00000001)
+#define SB2_DBG_INT_write_data(data)                                                 (0x00000001&((data)<<0))
+#define SB2_DBG_INT_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define SB2_DBG_INT_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SB2_DUMMY_0                                                                  0x1801A600
+#define SB2_DUMMY_1                                                                  0x1801A604
+#define SB2_DUMMY_2                                                                  0x1801A608
+#define SB2_DUMMY_3                                                                  0x1801A60C
+#define SB2_DUMMY_0_reg_addr                                                         "0xB801A600"
+#define SB2_DUMMY_1_reg_addr                                                         "0xB801A604"
+#define SB2_DUMMY_2_reg_addr                                                         "0xB801A608"
+#define SB2_DUMMY_3_reg_addr                                                         "0xB801A60C"
+#define SB2_DUMMY_0_reg                                                              0xB801A600
+#define SB2_DUMMY_1_reg                                                              0xB801A604
+#define SB2_DUMMY_2_reg                                                              0xB801A608
+#define SB2_DUMMY_3_reg                                                              0xB801A60C
+#define set_SB2_DUMMY_0_reg(data)   (*((volatile unsigned int*) SB2_DUMMY_0_reg)=data)
+#define set_SB2_DUMMY_1_reg(data)   (*((volatile unsigned int*) SB2_DUMMY_1_reg)=data)
+#define set_SB2_DUMMY_2_reg(data)   (*((volatile unsigned int*) SB2_DUMMY_2_reg)=data)
+#define set_SB2_DUMMY_3_reg(data)   (*((volatile unsigned int*) SB2_DUMMY_3_reg)=data)
+#define get_SB2_DUMMY_0_reg   (*((volatile unsigned int*) SB2_DUMMY_0_reg))
+#define get_SB2_DUMMY_1_reg   (*((volatile unsigned int*) SB2_DUMMY_1_reg))
+#define get_SB2_DUMMY_2_reg   (*((volatile unsigned int*) SB2_DUMMY_2_reg))
+#define get_SB2_DUMMY_3_reg   (*((volatile unsigned int*) SB2_DUMMY_3_reg))
+#define SB2_DUMMY_0_inst_adr                                                         "0x0080"
+#define SB2_DUMMY_1_inst_adr                                                         "0x0081"
+#define SB2_DUMMY_2_inst_adr                                                         "0x0082"
+#define SB2_DUMMY_3_inst_adr                                                         "0x0083"
+#define SB2_DUMMY_0_inst                                                             0x0080
+#define SB2_DUMMY_1_inst                                                             0x0081
+#define SB2_DUMMY_2_inst                                                             0x0082
+#define SB2_DUMMY_3_inst                                                             0x0083
+#define SB2_DUMMY_data_shift                                                         (0)
+#define SB2_DUMMY_data_mask                                                          (0xFFFFFFFF)
+#define SB2_DUMMY_data(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define SB2_DUMMY_data_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define SB2_DUMMY_get_data(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_SHADOW_0                                                                 0x1801A610
+#define SB2_SHADOW_1                                                                 0x1801A614
+#define SB2_SHADOW_2                                                                 0x1801A618
+#define SB2_SHADOW_3                                                                 0x1801A61C
+#define SB2_SHADOW_0_reg_addr                                                        "0xB801A610"
+#define SB2_SHADOW_1_reg_addr                                                        "0xB801A614"
+#define SB2_SHADOW_2_reg_addr                                                        "0xB801A618"
+#define SB2_SHADOW_3_reg_addr                                                        "0xB801A61C"
+#define SB2_SHADOW_0_reg                                                             0xB801A610
+#define SB2_SHADOW_1_reg                                                             0xB801A614
+#define SB2_SHADOW_2_reg                                                             0xB801A618
+#define SB2_SHADOW_3_reg                                                             0xB801A61C
+#define set_SB2_SHADOW_0_reg(data)   (*((volatile unsigned int*) SB2_SHADOW_0_reg)=data)
+#define set_SB2_SHADOW_1_reg(data)   (*((volatile unsigned int*) SB2_SHADOW_1_reg)=data)
+#define set_SB2_SHADOW_2_reg(data)   (*((volatile unsigned int*) SB2_SHADOW_2_reg)=data)
+#define set_SB2_SHADOW_3_reg(data)   (*((volatile unsigned int*) SB2_SHADOW_3_reg)=data)
+#define get_SB2_SHADOW_0_reg   (*((volatile unsigned int*) SB2_SHADOW_0_reg))
+#define get_SB2_SHADOW_1_reg   (*((volatile unsigned int*) SB2_SHADOW_1_reg))
+#define get_SB2_SHADOW_2_reg   (*((volatile unsigned int*) SB2_SHADOW_2_reg))
+#define get_SB2_SHADOW_3_reg   (*((volatile unsigned int*) SB2_SHADOW_3_reg))
+#define SB2_SHADOW_0_inst_adr                                                        "0x0084"
+#define SB2_SHADOW_1_inst_adr                                                        "0x0085"
+#define SB2_SHADOW_2_inst_adr                                                        "0x0086"
+#define SB2_SHADOW_3_inst_adr                                                        "0x0087"
+#define SB2_SHADOW_0_inst                                                            0x0084
+#define SB2_SHADOW_1_inst                                                            0x0085
+#define SB2_SHADOW_2_inst                                                            0x0086
+#define SB2_SHADOW_3_inst                                                            0x0087
+#define SB2_SHADOW_data_shift                                                        (0)
+#define SB2_SHADOW_data_mask                                                         (0xFFFFFFFF)
+#define SB2_SHADOW_data(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define SB2_SHADOW_data_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define SB2_SHADOW_get_data(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_HD_SEM_NEW_0                                                             0x1801A620
+#define SB2_HD_SEM_NEW_1                                                             0x1801A624
+#define SB2_HD_SEM_NEW_2                                                             0x1801A628
+#define SB2_HD_SEM_NEW_3                                                             0x1801A62C
+#define SB2_HD_SEM_NEW_4                                                             0x1801A630
+#define SB2_HD_SEM_NEW_5                                                             0x1801A634
+#define SB2_HD_SEM_NEW_6                                                             0x1801A638
+#define SB2_HD_SEM_NEW_7                                                             0x1801A63C
+#define SB2_HD_SEM_NEW_0_reg_addr                                                    "0xB801A620"
+#define SB2_HD_SEM_NEW_1_reg_addr                                                    "0xB801A624"
+#define SB2_HD_SEM_NEW_2_reg_addr                                                    "0xB801A628"
+#define SB2_HD_SEM_NEW_3_reg_addr                                                    "0xB801A62C"
+#define SB2_HD_SEM_NEW_4_reg_addr                                                    "0xB801A630"
+#define SB2_HD_SEM_NEW_5_reg_addr                                                    "0xB801A634"
+#define SB2_HD_SEM_NEW_6_reg_addr                                                    "0xB801A638"
+#define SB2_HD_SEM_NEW_7_reg_addr                                                    "0xB801A63C"
+#define SB2_HD_SEM_NEW_0_reg                                                         0xB801A620
+#define SB2_HD_SEM_NEW_1_reg                                                         0xB801A624
+#define SB2_HD_SEM_NEW_2_reg                                                         0xB801A628
+#define SB2_HD_SEM_NEW_3_reg                                                         0xB801A62C
+#define SB2_HD_SEM_NEW_4_reg                                                         0xB801A630
+#define SB2_HD_SEM_NEW_5_reg                                                         0xB801A634
+#define SB2_HD_SEM_NEW_6_reg                                                         0xB801A638
+#define SB2_HD_SEM_NEW_7_reg                                                         0xB801A63C
+#define set_SB2_HD_SEM_NEW_0_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_0_reg)=data)
+#define set_SB2_HD_SEM_NEW_1_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_1_reg)=data)
+#define set_SB2_HD_SEM_NEW_2_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_2_reg)=data)
+#define set_SB2_HD_SEM_NEW_3_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_3_reg)=data)
+#define set_SB2_HD_SEM_NEW_4_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_4_reg)=data)
+#define set_SB2_HD_SEM_NEW_5_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_5_reg)=data)
+#define set_SB2_HD_SEM_NEW_6_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_6_reg)=data)
+#define set_SB2_HD_SEM_NEW_7_reg(data)   (*((volatile unsigned int*) SB2_HD_SEM_NEW_7_reg)=data)
+#define get_SB2_HD_SEM_NEW_0_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_0_reg))
+#define get_SB2_HD_SEM_NEW_1_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_1_reg))
+#define get_SB2_HD_SEM_NEW_2_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_2_reg))
+#define get_SB2_HD_SEM_NEW_3_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_3_reg))
+#define get_SB2_HD_SEM_NEW_4_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_4_reg))
+#define get_SB2_HD_SEM_NEW_5_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_5_reg))
+#define get_SB2_HD_SEM_NEW_6_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_6_reg))
+#define get_SB2_HD_SEM_NEW_7_reg   (*((volatile unsigned int*) SB2_HD_SEM_NEW_7_reg))
+#define SB2_HD_SEM_NEW_0_inst_adr                                                    "0x0088"
+#define SB2_HD_SEM_NEW_1_inst_adr                                                    "0x0089"
+#define SB2_HD_SEM_NEW_2_inst_adr                                                    "0x008A"
+#define SB2_HD_SEM_NEW_3_inst_adr                                                    "0x008B"
+#define SB2_HD_SEM_NEW_4_inst_adr                                                    "0x008C"
+#define SB2_HD_SEM_NEW_5_inst_adr                                                    "0x008D"
+#define SB2_HD_SEM_NEW_6_inst_adr                                                    "0x008E"
+#define SB2_HD_SEM_NEW_7_inst_adr                                                    "0x008F"
+#define SB2_HD_SEM_NEW_0_inst                                                        0x0088
+#define SB2_HD_SEM_NEW_1_inst                                                        0x0089
+#define SB2_HD_SEM_NEW_2_inst                                                        0x008A
+#define SB2_HD_SEM_NEW_3_inst                                                        0x008B
+#define SB2_HD_SEM_NEW_4_inst                                                        0x008C
+#define SB2_HD_SEM_NEW_5_inst                                                        0x008D
+#define SB2_HD_SEM_NEW_6_inst                                                        0x008E
+#define SB2_HD_SEM_NEW_7_inst                                                        0x008F
+#define SB2_HD_SEM_NEW_Semaphore_shift                                               (0)
+#define SB2_HD_SEM_NEW_Semaphore_mask                                                (0x00000001)
+#define SB2_HD_SEM_NEW_Semaphore(data)                                               (0x00000001&((data)<<0))
+#define SB2_HD_SEM_NEW_Semaphore_src(data)                                           ((0x00000001&(data))>>0)
+#define SB2_HD_SEM_NEW_get_Semaphore(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SB2_RBUS_INVA_ACC_CTRL                                                       0x1801A650
+#define SB2_RBUS_INVA_ACC_CTRL_reg_addr                                              "0xB801A650"
+#define SB2_RBUS_INVA_ACC_CTRL_reg                                                   0xB801A650
+#define set_SB2_RBUS_INVA_ACC_CTRL_reg(data)   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_CTRL_reg)=data)
+#define get_SB2_RBUS_INVA_ACC_CTRL_reg   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_CTRL_reg))
+#define SB2_RBUS_INVA_ACC_CTRL_inst_adr                                              "0x0094"
+#define SB2_RBUS_INVA_ACC_CTRL_inst                                                  0x0094
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec2_en_shift                                 (2)
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec2_en_mask                                  (0x00000004)
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec2_en(data)                                 (0x00000004&((data)<<2))
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec2_en_src(data)                             ((0x00000004&(data))>>2)
+#define SB2_RBUS_INVA_ACC_CTRL_get_inva_wr_sec2_en(data)                             ((0x00000004&(data))>>2)
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec1_en_shift                                 (0)
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec1_en_mask                                  (0x00000001)
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec1_en(data)                                 (0x00000001&((data)<<0))
+#define SB2_RBUS_INVA_ACC_CTRL_inva_wr_sec1_en_src(data)                             ((0x00000001&(data))>>0)
+#define SB2_RBUS_INVA_ACC_CTRL_get_inva_wr_sec1_en(data)                             ((0x00000001&(data))>>0)
+
+
+#define SB2_RBUS_INVA_ACC_SEC1_START                                                 0x1801A654
+#define SB2_RBUS_INVA_ACC_SEC1_START_reg_addr                                        "0xB801A654"
+#define SB2_RBUS_INVA_ACC_SEC1_START_reg                                             0xB801A654
+#define set_SB2_RBUS_INVA_ACC_SEC1_START_reg(data)   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC1_START_reg)=data)
+#define get_SB2_RBUS_INVA_ACC_SEC1_START_reg   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC1_START_reg))
+#define SB2_RBUS_INVA_ACC_SEC1_START_inst_adr                                        "0x0095"
+#define SB2_RBUS_INVA_ACC_SEC1_START_inst                                            0x0095
+#define SB2_RBUS_INVA_ACC_SEC1_START_sec1_start_shift                                (2)
+#define SB2_RBUS_INVA_ACC_SEC1_START_sec1_start_mask                                 (0x0007FFFC)
+#define SB2_RBUS_INVA_ACC_SEC1_START_sec1_start(data)                                (0x0007FFFC&((data)<<2))
+#define SB2_RBUS_INVA_ACC_SEC1_START_sec1_start_src(data)                            ((0x0007FFFC&(data))>>2)
+#define SB2_RBUS_INVA_ACC_SEC1_START_get_sec1_start(data)                            ((0x0007FFFC&(data))>>2)
+
+
+#define SB2_RBUS_INVA_ACC_SEC1_END                                                   0x1801A658
+#define SB2_RBUS_INVA_ACC_SEC1_END_reg_addr                                          "0xB801A658"
+#define SB2_RBUS_INVA_ACC_SEC1_END_reg                                               0xB801A658
+#define set_SB2_RBUS_INVA_ACC_SEC1_END_reg(data)   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC1_END_reg)=data)
+#define get_SB2_RBUS_INVA_ACC_SEC1_END_reg   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC1_END_reg))
+#define SB2_RBUS_INVA_ACC_SEC1_END_inst_adr                                          "0x0096"
+#define SB2_RBUS_INVA_ACC_SEC1_END_inst                                              0x0096
+#define SB2_RBUS_INVA_ACC_SEC1_END_sec1_end_shift                                    (2)
+#define SB2_RBUS_INVA_ACC_SEC1_END_sec1_end_mask                                     (0x0007FFFC)
+#define SB2_RBUS_INVA_ACC_SEC1_END_sec1_end(data)                                    (0x0007FFFC&((data)<<2))
+#define SB2_RBUS_INVA_ACC_SEC1_END_sec1_end_src(data)                                ((0x0007FFFC&(data))>>2)
+#define SB2_RBUS_INVA_ACC_SEC1_END_get_sec1_end(data)                                ((0x0007FFFC&(data))>>2)
+
+
+#define SB2_RBUS_INVA_ACC_SEC2_START                                                 0x1801A65C
+#define SB2_RBUS_INVA_ACC_SEC2_START_reg_addr                                        "0xB801A65C"
+#define SB2_RBUS_INVA_ACC_SEC2_START_reg                                             0xB801A65C
+#define set_SB2_RBUS_INVA_ACC_SEC2_START_reg(data)   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC2_START_reg)=data)
+#define get_SB2_RBUS_INVA_ACC_SEC2_START_reg   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC2_START_reg))
+#define SB2_RBUS_INVA_ACC_SEC2_START_inst_adr                                        "0x0097"
+#define SB2_RBUS_INVA_ACC_SEC2_START_inst                                            0x0097
+#define SB2_RBUS_INVA_ACC_SEC2_START_sec2_start_shift                                (2)
+#define SB2_RBUS_INVA_ACC_SEC2_START_sec2_start_mask                                 (0x0007FFFC)
+#define SB2_RBUS_INVA_ACC_SEC2_START_sec2_start(data)                                (0x0007FFFC&((data)<<2))
+#define SB2_RBUS_INVA_ACC_SEC2_START_sec2_start_src(data)                            ((0x0007FFFC&(data))>>2)
+#define SB2_RBUS_INVA_ACC_SEC2_START_get_sec2_start(data)                            ((0x0007FFFC&(data))>>2)
+
+
+#define SB2_RBUS_INVA_ACC_SEC2_END                                                   0x1801A660
+#define SB2_RBUS_INVA_ACC_SEC2_END_reg_addr                                          "0xB801A660"
+#define SB2_RBUS_INVA_ACC_SEC2_END_reg                                               0xB801A660
+#define set_SB2_RBUS_INVA_ACC_SEC2_END_reg(data)   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC2_END_reg)=data)
+#define get_SB2_RBUS_INVA_ACC_SEC2_END_reg   (*((volatile unsigned int*) SB2_RBUS_INVA_ACC_SEC2_END_reg))
+#define SB2_RBUS_INVA_ACC_SEC2_END_inst_adr                                          "0x0098"
+#define SB2_RBUS_INVA_ACC_SEC2_END_inst                                              0x0098
+#define SB2_RBUS_INVA_ACC_SEC2_END_sec2_end_shift                                    (2)
+#define SB2_RBUS_INVA_ACC_SEC2_END_sec2_end_mask                                     (0x0007FFFC)
+#define SB2_RBUS_INVA_ACC_SEC2_END_sec2_end(data)                                    (0x0007FFFC&((data)<<2))
+#define SB2_RBUS_INVA_ACC_SEC2_END_sec2_end_src(data)                                ((0x0007FFFC&(data))>>2)
+#define SB2_RBUS_INVA_ACC_SEC2_END_get_sec2_end(data)                                ((0x0007FFFC&(data))>>2)
+
+
+#define SB2_RBUS_CMP_CTRL                                                            0x1801A664
+#define SB2_RBUS_CMP_CTRL_reg_addr                                                   "0xB801A664"
+#define SB2_RBUS_CMP_CTRL_reg                                                        0xB801A664
+#define set_SB2_RBUS_CMP_CTRL_reg(data)   (*((volatile unsigned int*) SB2_RBUS_CMP_CTRL_reg)=data)
+#define get_SB2_RBUS_CMP_CTRL_reg   (*((volatile unsigned int*) SB2_RBUS_CMP_CTRL_reg))
+#define SB2_RBUS_CMP_CTRL_inst_adr                                                   "0x0099"
+#define SB2_RBUS_CMP_CTRL_inst                                                       0x0099
+#define SB2_RBUS_CMP_CTRL_crc_cmp_latch_en_shift                                     (0)
+#define SB2_RBUS_CMP_CTRL_crc_cmp_latch_en_mask                                      (0x00000001)
+#define SB2_RBUS_CMP_CTRL_crc_cmp_latch_en(data)                                     (0x00000001&((data)<<0))
+#define SB2_RBUS_CMP_CTRL_crc_cmp_latch_en_src(data)                                 ((0x00000001&(data))>>0)
+#define SB2_RBUS_CMP_CTRL_get_crc_cmp_latch_en(data)                                 ((0x00000001&(data))>>0)
+
+
+#define SB2_RBUS_CMP_DATA                                                            0x1801A668
+#define SB2_RBUS_CMP_DATA_reg_addr                                                   "0xB801A668"
+#define SB2_RBUS_CMP_DATA_reg                                                        0xB801A668
+#define set_SB2_RBUS_CMP_DATA_reg(data)   (*((volatile unsigned int*) SB2_RBUS_CMP_DATA_reg)=data)
+#define get_SB2_RBUS_CMP_DATA_reg   (*((volatile unsigned int*) SB2_RBUS_CMP_DATA_reg))
+#define SB2_RBUS_CMP_DATA_inst_adr                                                   "0x009A"
+#define SB2_RBUS_CMP_DATA_inst                                                       0x009A
+#define SB2_RBUS_CMP_DATA_crc_cmp_expect_shift                                       (0)
+#define SB2_RBUS_CMP_DATA_crc_cmp_expect_mask                                        (0xFFFFFFFF)
+#define SB2_RBUS_CMP_DATA_crc_cmp_expect(data)                                       (0xFFFFFFFF&((data)<<0))
+#define SB2_RBUS_CMP_DATA_crc_cmp_expect_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define SB2_RBUS_CMP_DATA_get_crc_cmp_expect(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_RBUS_CMP_RESULT                                                          0x1801A66C
+#define SB2_RBUS_CMP_RESULT_reg_addr                                                 "0xB801A66C"
+#define SB2_RBUS_CMP_RESULT_reg                                                      0xB801A66C
+#define set_SB2_RBUS_CMP_RESULT_reg(data)   (*((volatile unsigned int*) SB2_RBUS_CMP_RESULT_reg)=data)
+#define get_SB2_RBUS_CMP_RESULT_reg   (*((volatile unsigned int*) SB2_RBUS_CMP_RESULT_reg))
+#define SB2_RBUS_CMP_RESULT_inst_adr                                                 "0x009B"
+#define SB2_RBUS_CMP_RESULT_inst                                                     0x009B
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result_shift                                     (0)
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result_mask                                      (0xFFFFFFFF)
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result(data)                                     (0xFFFFFFFF&((data)<<0))
+#define SB2_RBUS_CMP_RESULT_crc_cmp_result_src(data)                                 ((0xFFFFFFFF&(data))>>0)
+#define SB2_RBUS_CMP_RESULT_get_crc_cmp_result(data)                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB2_BIST_CTRL                                                                0x1801A674
+#define SB2_BIST_CTRL_reg_addr                                                       "0xB801A674"
+#define SB2_BIST_CTRL_reg                                                            0xB801A674
+#define set_SB2_BIST_CTRL_reg(data)   (*((volatile unsigned int*) SB2_BIST_CTRL_reg)=data)
+#define get_SB2_BIST_CTRL_reg   (*((volatile unsigned int*) SB2_BIST_CTRL_reg))
+#define SB2_BIST_CTRL_inst_adr                                                       "0x009D"
+#define SB2_BIST_CTRL_inst                                                           0x009D
+#define SB2_BIST_CTRL_sb2_bist_rstn_shift                                            (7)
+#define SB2_BIST_CTRL_sb2_bist_rstn_mask                                             (0x00000080)
+#define SB2_BIST_CTRL_sb2_bist_rstn(data)                                            (0x00000080&((data)<<7))
+#define SB2_BIST_CTRL_sb2_bist_rstn_src(data)                                        ((0x00000080&(data))>>7)
+#define SB2_BIST_CTRL_get_sb2_bist_rstn(data)                                        ((0x00000080&(data))>>7)
+#define SB2_BIST_CTRL_sb2_bist_en_shift                                              (6)
+#define SB2_BIST_CTRL_sb2_bist_en_mask                                               (0x00000040)
+#define SB2_BIST_CTRL_sb2_bist_en(data)                                              (0x00000040&((data)<<6))
+#define SB2_BIST_CTRL_sb2_bist_en_src(data)                                          ((0x00000040&(data))>>6)
+#define SB2_BIST_CTRL_get_sb2_bist_en(data)                                          ((0x00000040&(data))>>6)
+#define SB2_BIST_CTRL_sb2_rom_ls_shift                                               (5)
+#define SB2_BIST_CTRL_sb2_rom_ls_mask                                                (0x00000020)
+#define SB2_BIST_CTRL_sb2_rom_ls(data)                                               (0x00000020&((data)<<5))
+#define SB2_BIST_CTRL_sb2_rom_ls_src(data)                                           ((0x00000020&(data))>>5)
+#define SB2_BIST_CTRL_get_sb2_rom_ls(data)                                           ((0x00000020&(data))>>5)
+#define SB2_BIST_CTRL_sb2_rom_rme_shift                                              (4)
+#define SB2_BIST_CTRL_sb2_rom_rme_mask                                               (0x00000010)
+#define SB2_BIST_CTRL_sb2_rom_rme(data)                                              (0x00000010&((data)<<4))
+#define SB2_BIST_CTRL_sb2_rom_rme_src(data)                                          ((0x00000010&(data))>>4)
+#define SB2_BIST_CTRL_get_sb2_rom_rme(data)                                          ((0x00000010&(data))>>4)
+#define SB2_BIST_CTRL_sb2_rom_rm_shift                                               (0)
+#define SB2_BIST_CTRL_sb2_rom_rm_mask                                                (0x0000000F)
+#define SB2_BIST_CTRL_sb2_rom_rm(data)                                               (0x0000000F&((data)<<0))
+#define SB2_BIST_CTRL_sb2_rom_rm_src(data)                                           ((0x0000000F&(data))>>0)
+#define SB2_BIST_CTRL_get_sb2_rom_rm(data)                                           ((0x0000000F&(data))>>0)
+
+
+#define SB2_BIST_STATUS                                                              0x1801A678
+#define SB2_BIST_STATUS_reg_addr                                                     "0xB801A678"
+#define SB2_BIST_STATUS_reg                                                          0xB801A678
+#define set_SB2_BIST_STATUS_reg(data)   (*((volatile unsigned int*) SB2_BIST_STATUS_reg)=data)
+#define get_SB2_BIST_STATUS_reg   (*((volatile unsigned int*) SB2_BIST_STATUS_reg))
+#define SB2_BIST_STATUS_inst_adr                                                     "0x009E"
+#define SB2_BIST_STATUS_inst                                                         0x009E
+#define SB2_BIST_STATUS_sb2_rom_bist_done_shift                                      (16)
+#define SB2_BIST_STATUS_sb2_rom_bist_done_mask                                       (0x00010000)
+#define SB2_BIST_STATUS_sb2_rom_bist_done(data)                                      (0x00010000&((data)<<16))
+#define SB2_BIST_STATUS_sb2_rom_bist_done_src(data)                                  ((0x00010000&(data))>>16)
+#define SB2_BIST_STATUS_get_sb2_rom_bist_done(data)                                  ((0x00010000&(data))>>16)
+#define SB2_BIST_STATUS_sb2_misr_dataout_0_shift                                     (0)
+#define SB2_BIST_STATUS_sb2_misr_dataout_0_mask                                      (0x0000FFFF)
+#define SB2_BIST_STATUS_sb2_misr_dataout_0(data)                                     (0x0000FFFF&((data)<<0))
+#define SB2_BIST_STATUS_sb2_misr_dataout_0_src(data)                                 ((0x0000FFFF&(data))>>0)
+#define SB2_BIST_STATUS_get_sb2_misr_dataout_0(data)                                 ((0x0000FFFF&(data))>>0)
+
+
+#define SB2_SFC_OPCODE                                                               0x1801A800
+#define SB2_SFC_OPCODE_reg_addr                                                      "0xB801A800"
+#define SB2_SFC_OPCODE_reg                                                           0xB801A800
+#define set_SB2_SFC_OPCODE_reg(data)   (*((volatile unsigned int*) SB2_SFC_OPCODE_reg)=data)
+#define get_SB2_SFC_OPCODE_reg   (*((volatile unsigned int*) SB2_SFC_OPCODE_reg))
+#define SB2_SFC_OPCODE_inst_adr                                                      "0x0000"
+#define SB2_SFC_OPCODE_inst                                                          0x0000
+#define SB2_SFC_OPCODE_dual_mode_shift                                               (9)
+#define SB2_SFC_OPCODE_dual_mode_mask                                                (0x00000600)
+#define SB2_SFC_OPCODE_dual_mode(data)                                               (0x00000600&((data)<<9))
+#define SB2_SFC_OPCODE_dual_mode_src(data)                                           ((0x00000600&(data))>>9)
+#define SB2_SFC_OPCODE_get_dual_mode(data)                                           ((0x00000600&(data))>>9)
+#define SB2_SFC_OPCODE_fat_mode_shift                                                (8)
+#define SB2_SFC_OPCODE_fat_mode_mask                                                 (0x00000100)
+#define SB2_SFC_OPCODE_fat_mode(data)                                                (0x00000100&((data)<<8))
+#define SB2_SFC_OPCODE_fat_mode_src(data)                                            ((0x00000100&(data))>>8)
+#define SB2_SFC_OPCODE_get_fat_mode(data)                                            ((0x00000100&(data))>>8)
+#define SB2_SFC_OPCODE_opc_shift                                                     (0)
+#define SB2_SFC_OPCODE_opc_mask                                                      (0x000000FF)
+#define SB2_SFC_OPCODE_opc(data)                                                     (0x000000FF&((data)<<0))
+#define SB2_SFC_OPCODE_opc_src(data)                                                 ((0x000000FF&(data))>>0)
+#define SB2_SFC_OPCODE_get_opc(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define SB2_SFC_CTL                                                                  0x1801A804
+#define SB2_SFC_CTL_reg_addr                                                         "0xB801A804"
+#define SB2_SFC_CTL_reg                                                              0xB801A804
+#define set_SB2_SFC_CTL_reg(data)   (*((volatile unsigned int*) SB2_SFC_CTL_reg)=data)
+#define get_SB2_SFC_CTL_reg   (*((volatile unsigned int*) SB2_SFC_CTL_reg))
+#define SB2_SFC_CTL_inst_adr                                                         "0x0001"
+#define SB2_SFC_CTL_inst                                                             0x0001
+#define SB2_SFC_CTL_dataen_shift                                                     (4)
+#define SB2_SFC_CTL_dataen_mask                                                      (0x00000010)
+#define SB2_SFC_CTL_dataen(data)                                                     (0x00000010&((data)<<4))
+#define SB2_SFC_CTL_dataen_src(data)                                                 ((0x00000010&(data))>>4)
+#define SB2_SFC_CTL_get_dataen(data)                                                 ((0x00000010&(data))>>4)
+#define SB2_SFC_CTL_adren_shift                                                      (3)
+#define SB2_SFC_CTL_adren_mask                                                       (0x00000008)
+#define SB2_SFC_CTL_adren(data)                                                      (0x00000008&((data)<<3))
+#define SB2_SFC_CTL_adren_src(data)                                                  ((0x00000008&(data))>>3)
+#define SB2_SFC_CTL_get_adren(data)                                                  ((0x00000008&(data))>>3)
+#define SB2_SFC_CTL_dmycnt_shift                                                     (0)
+#define SB2_SFC_CTL_dmycnt_mask                                                      (0x00000007)
+#define SB2_SFC_CTL_dmycnt(data)                                                     (0x00000007&((data)<<0))
+#define SB2_SFC_CTL_dmycnt_src(data)                                                 ((0x00000007&(data))>>0)
+#define SB2_SFC_CTL_get_dmycnt(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define SB2_SFC_SCK                                                                  0x1801A808
+#define SB2_SFC_SCK_reg_addr                                                         "0xB801A808"
+#define SB2_SFC_SCK_reg                                                              0xB801A808
+#define set_SB2_SFC_SCK_reg(data)   (*((volatile unsigned int*) SB2_SFC_SCK_reg)=data)
+#define get_SB2_SFC_SCK_reg   (*((volatile unsigned int*) SB2_SFC_SCK_reg))
+#define SB2_SFC_SCK_inst_adr                                                         "0x0002"
+#define SB2_SFC_SCK_inst                                                             0x0002
+#define SB2_SFC_SCK_mode_shift                                                       (8)
+#define SB2_SFC_SCK_mode_mask                                                        (0x00000100)
+#define SB2_SFC_SCK_mode(data)                                                       (0x00000100&((data)<<8))
+#define SB2_SFC_SCK_mode_src(data)                                                   ((0x00000100&(data))>>8)
+#define SB2_SFC_SCK_get_mode(data)                                                   ((0x00000100&(data))>>8)
+#define SB2_SFC_SCK_fdiv_shift                                                       (0)
+#define SB2_SFC_SCK_fdiv_mask                                                        (0x000000FF)
+#define SB2_SFC_SCK_fdiv(data)                                                       (0x000000FF&((data)<<0))
+#define SB2_SFC_SCK_fdiv_src(data)                                                   ((0x000000FF&(data))>>0)
+#define SB2_SFC_SCK_get_fdiv(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define SB2_SFC_CE                                                                   0x1801A80C
+#define SB2_SFC_CE_reg_addr                                                          "0xB801A80C"
+#define SB2_SFC_CE_reg                                                               0xB801A80C
+#define set_SB2_SFC_CE_reg(data)   (*((volatile unsigned int*) SB2_SFC_CE_reg)=data)
+#define get_SB2_SFC_CE_reg   (*((volatile unsigned int*) SB2_SFC_CE_reg))
+#define SB2_SFC_CE_inst_adr                                                          "0x0003"
+#define SB2_SFC_CE_inst                                                              0x0003
+#define SB2_SFC_CE_tdt_shift                                                         (16)
+#define SB2_SFC_CE_tdt_mask                                                          (0xFFFF0000)
+#define SB2_SFC_CE_tdt(data)                                                         (0xFFFF0000&((data)<<16))
+#define SB2_SFC_CE_tdt_src(data)                                                     ((0xFFFF0000&(data))>>16)
+#define SB2_SFC_CE_get_tdt(data)                                                     ((0xFFFF0000&(data))>>16)
+#define SB2_SFC_CE_Phcnt_shift                                                       (8)
+#define SB2_SFC_CE_Phcnt_mask                                                        (0x0000FF00)
+#define SB2_SFC_CE_Phcnt(data)                                                       (0x0000FF00&((data)<<8))
+#define SB2_SFC_CE_Phcnt_src(data)                                                   ((0x0000FF00&(data))>>8)
+#define SB2_SFC_CE_get_Phcnt(data)                                                   ((0x0000FF00&(data))>>8)
+#define SB2_SFC_CE_Plcnt_shift                                                       (0)
+#define SB2_SFC_CE_Plcnt_mask                                                        (0x000000FF)
+#define SB2_SFC_CE_Plcnt(data)                                                       (0x000000FF&((data)<<0))
+#define SB2_SFC_CE_Plcnt_src(data)                                                   ((0x000000FF&(data))>>0)
+#define SB2_SFC_CE_get_Plcnt(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define SB2_SFC_WP                                                                   0x1801A810
+#define SB2_SFC_WP_reg_addr                                                          "0xB801A810"
+#define SB2_SFC_WP_reg                                                               0xB801A810
+#define set_SB2_SFC_WP_reg(data)   (*((volatile unsigned int*) SB2_SFC_WP_reg)=data)
+#define get_SB2_SFC_WP_reg   (*((volatile unsigned int*) SB2_SFC_WP_reg))
+#define SB2_SFC_WP_inst_adr                                                          "0x0004"
+#define SB2_SFC_WP_inst                                                              0x0004
+#define SB2_SFC_WP_write_en5_shift                                                   (27)
+#define SB2_SFC_WP_write_en5_mask                                                    (0x08000000)
+#define SB2_SFC_WP_write_en5(data)                                                   (0x08000000&((data)<<27))
+#define SB2_SFC_WP_write_en5_src(data)                                               ((0x08000000&(data))>>27)
+#define SB2_SFC_WP_get_write_en5(data)                                               ((0x08000000&(data))>>27)
+#define SB2_SFC_WP_rdy_shift                                                         (26)
+#define SB2_SFC_WP_rdy_mask                                                          (0x04000000)
+#define SB2_SFC_WP_rdy(data)                                                         (0x04000000&((data)<<26))
+#define SB2_SFC_WP_rdy_src(data)                                                     ((0x04000000&(data))>>26)
+#define SB2_SFC_WP_get_rdy(data)                                                     ((0x04000000&(data))>>26)
+#define SB2_SFC_WP_write_en1_shift                                                   (1)
+#define SB2_SFC_WP_write_en1_mask                                                    (0x00000002)
+#define SB2_SFC_WP_write_en1(data)                                                   (0x00000002&((data)<<1))
+#define SB2_SFC_WP_write_en1_src(data)                                               ((0x00000002&(data))>>1)
+#define SB2_SFC_WP_get_write_en1(data)                                               ((0x00000002&(data))>>1)
+#define SB2_SFC_WP_wp_n_shift                                                        (0)
+#define SB2_SFC_WP_wp_n_mask                                                         (0x00000001)
+#define SB2_SFC_WP_wp_n(data)                                                        (0x00000001&((data)<<0))
+#define SB2_SFC_WP_wp_n_src(data)                                                    ((0x00000001&(data))>>0)
+#define SB2_SFC_WP_get_wp_n(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define SB2_SFC_POS_LATCH                                                            0x1801A814
+#define SB2_SFC_POS_LATCH_reg_addr                                                   "0xB801A814"
+#define SB2_SFC_POS_LATCH_reg                                                        0xB801A814
+#define set_SB2_SFC_POS_LATCH_reg(data)   (*((volatile unsigned int*) SB2_SFC_POS_LATCH_reg)=data)
+#define get_SB2_SFC_POS_LATCH_reg   (*((volatile unsigned int*) SB2_SFC_POS_LATCH_reg))
+#define SB2_SFC_POS_LATCH_inst_adr                                                   "0x0005"
+#define SB2_SFC_POS_LATCH_inst                                                       0x0005
+#define SB2_SFC_POS_LATCH_pos_latch_shift                                            (0)
+#define SB2_SFC_POS_LATCH_pos_latch_mask                                             (0x00000001)
+#define SB2_SFC_POS_LATCH_pos_latch(data)                                            (0x00000001&((data)<<0))
+#define SB2_SFC_POS_LATCH_pos_latch_src(data)                                        ((0x00000001&(data))>>0)
+#define SB2_SFC_POS_LATCH_get_pos_latch(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SB2_SFC_WAIT_WR                                                              0x1801A818
+#define SB2_SFC_WAIT_WR_reg_addr                                                     "0xB801A818"
+#define SB2_SFC_WAIT_WR_reg                                                          0xB801A818
+#define set_SB2_SFC_WAIT_WR_reg(data)   (*((volatile unsigned int*) SB2_SFC_WAIT_WR_reg)=data)
+#define get_SB2_SFC_WAIT_WR_reg   (*((volatile unsigned int*) SB2_SFC_WAIT_WR_reg))
+#define SB2_SFC_WAIT_WR_inst_adr                                                     "0x0006"
+#define SB2_SFC_WAIT_WR_inst                                                         0x0006
+#define SB2_SFC_WAIT_WR_wt_prog_done_shift                                           (8)
+#define SB2_SFC_WAIT_WR_wt_prog_done_mask                                            (0x00000100)
+#define SB2_SFC_WAIT_WR_wt_prog_done(data)                                           (0x00000100&((data)<<8))
+#define SB2_SFC_WAIT_WR_wt_prog_done_src(data)                                       ((0x00000100&(data))>>8)
+#define SB2_SFC_WAIT_WR_get_wt_prog_done(data)                                       ((0x00000100&(data))>>8)
+#define SB2_SFC_WAIT_WR_rdsr_op_shift                                                (0)
+#define SB2_SFC_WAIT_WR_rdsr_op_mask                                                 (0x000000FF)
+#define SB2_SFC_WAIT_WR_rdsr_op(data)                                                (0x000000FF&((data)<<0))
+#define SB2_SFC_WAIT_WR_rdsr_op_src(data)                                            ((0x000000FF&(data))>>0)
+#define SB2_SFC_WAIT_WR_get_rdsr_op(data)                                            ((0x000000FF&(data))>>0)
+
+
+#define SB2_SFC_EN_WR                                                                0x1801A81C
+#define SB2_SFC_EN_WR_reg_addr                                                       "0xB801A81C"
+#define SB2_SFC_EN_WR_reg                                                            0xB801A81C
+#define set_SB2_SFC_EN_WR_reg(data)   (*((volatile unsigned int*) SB2_SFC_EN_WR_reg)=data)
+#define get_SB2_SFC_EN_WR_reg   (*((volatile unsigned int*) SB2_SFC_EN_WR_reg))
+#define SB2_SFC_EN_WR_inst_adr                                                       "0x0007"
+#define SB2_SFC_EN_WR_inst                                                           0x0007
+#define SB2_SFC_EN_WR_wt_prog_en_shift                                               (8)
+#define SB2_SFC_EN_WR_wt_prog_en_mask                                                (0x00000100)
+#define SB2_SFC_EN_WR_wt_prog_en(data)                                               (0x00000100&((data)<<8))
+#define SB2_SFC_EN_WR_wt_prog_en_src(data)                                           ((0x00000100&(data))>>8)
+#define SB2_SFC_EN_WR_get_wt_prog_en(data)                                           ((0x00000100&(data))>>8)
+#define SB2_SFC_EN_WR_wr_en_op_shift                                                 (0)
+#define SB2_SFC_EN_WR_wr_en_op_mask                                                  (0x000000FF)
+#define SB2_SFC_EN_WR_wr_en_op(data)                                                 (0x000000FF&((data)<<0))
+#define SB2_SFC_EN_WR_wr_en_op_src(data)                                             ((0x000000FF&(data))>>0)
+#define SB2_SFC_EN_WR_get_wr_en_op(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define SB2_SFC_FAST_RD                                                              0x1801A820
+#define SB2_SFC_FAST_RD_reg_addr                                                     "0xB801A820"
+#define SB2_SFC_FAST_RD_reg                                                          0xB801A820
+#define set_SB2_SFC_FAST_RD_reg(data)   (*((volatile unsigned int*) SB2_SFC_FAST_RD_reg)=data)
+#define get_SB2_SFC_FAST_RD_reg   (*((volatile unsigned int*) SB2_SFC_FAST_RD_reg))
+#define SB2_SFC_FAST_RD_inst_adr                                                     "0x0008"
+#define SB2_SFC_FAST_RD_inst                                                         0x0008
+#define SB2_SFC_FAST_RD_sf_dclk_sel_shift                                            (4)
+#define SB2_SFC_FAST_RD_sf_dclk_sel_mask                                             (0x00000010)
+#define SB2_SFC_FAST_RD_sf_dclk_sel(data)                                            (0x00000010&((data)<<4))
+#define SB2_SFC_FAST_RD_sf_dclk_sel_src(data)                                        ((0x00000010&(data))>>4)
+#define SB2_SFC_FAST_RD_get_sf_dclk_sel(data)                                        ((0x00000010&(data))>>4)
+#define SB2_SFC_FAST_RD_fifo_write_tap_shift                                         (1)
+#define SB2_SFC_FAST_RD_fifo_write_tap_mask                                          (0x0000000E)
+#define SB2_SFC_FAST_RD_fifo_write_tap(data)                                         (0x0000000E&((data)<<1))
+#define SB2_SFC_FAST_RD_fifo_write_tap_src(data)                                     ((0x0000000E&(data))>>1)
+#define SB2_SFC_FAST_RD_get_fifo_write_tap(data)                                     ((0x0000000E&(data))>>1)
+#define SB2_SFC_FAST_RD_fast_read_en_shift                                           (0)
+#define SB2_SFC_FAST_RD_fast_read_en_mask                                            (0x00000001)
+#define SB2_SFC_FAST_RD_fast_read_en(data)                                           (0x00000001&((data)<<0))
+#define SB2_SFC_FAST_RD_fast_read_en_src(data)                                       ((0x00000001&(data))>>0)
+#define SB2_SFC_FAST_RD_get_fast_read_en(data)                                       ((0x00000001&(data))>>0)
+
+
+#define SB2_SFC_SCK_TAP                                                              0x1801A824
+#define SB2_SFC_SCK_TAP_reg_addr                                                     "0xB801A824"
+#define SB2_SFC_SCK_TAP_reg                                                          0xB801A824
+#define set_SB2_SFC_SCK_TAP_reg(data)   (*((volatile unsigned int*) SB2_SFC_SCK_TAP_reg)=data)
+#define get_SB2_SFC_SCK_TAP_reg   (*((volatile unsigned int*) SB2_SFC_SCK_TAP_reg))
+#define SB2_SFC_SCK_TAP_inst_adr                                                     "0x0009"
+#define SB2_SFC_SCK_TAP_inst                                                         0x0009
+#define SB2_SFC_SCK_TAP_delay_clk_tap_shift                                          (0)
+#define SB2_SFC_SCK_TAP_delay_clk_tap_mask                                           (0xFFFFFFFF)
+#define SB2_SFC_SCK_TAP_delay_clk_tap(data)                                          (0xFFFFFFFF&((data)<<0))
+#define SB2_SFC_SCK_TAP_delay_clk_tap_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define SB2_SFC_SCK_TAP_get_delay_clk_tap(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb3_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb3_reg.h
new file mode 100644
index 00000000..6a5d21a
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb3_reg.h
@@ -0,0 +1,176 @@
+/**************************************************************
+// Spec Version                  : 0.0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/4/10 16:22:10
+***************************************************************/
+
+
+#ifndef _SB3_REG_H_INCLUDED_
+#define _SB3_REG_H_INCLUDED_
+#ifdef  _SB3_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     md:4;
+unsigned int     reserved_1:4;
+unsigned int     reserved_2:4;
+unsigned int     reserved_3:4;
+unsigned int     ade:4;
+unsigned int     reserved_4:4;
+unsigned int     aee:4;
+}SB3_PRIORITY_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     me:4;
+unsigned int     reserved_1:4;
+unsigned int     hif:4;
+unsigned int     reserved_2:4;
+unsigned int     vde:4;
+unsigned int     reserved_3:4;
+unsigned int     ve:4;
+}SB3_PRIORITY_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB3_CHANNEL_HIGH_PRIORITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB3_CHANNEL_REQ_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB3_CHANNEL_REQ_BUSY;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     allow_cmd_cnt:3;
+}SB3_MISC_CTRL;
+
+#endif
+
+#define SB3_PRIORITY_1                                                               0x1801C200
+#define SB3_PRIORITY_1_reg_addr                                                      "0xB801C200"
+#define SB3_PRIORITY_1_reg                                                           0xB801C200
+#define set_SB3_PRIORITY_1_reg(data)   (*((volatile unsigned int*) SB3_PRIORITY_1_reg)=data)
+#define get_SB3_PRIORITY_1_reg   (*((volatile unsigned int*) SB3_PRIORITY_1_reg))
+#define SB3_PRIORITY_1_inst_adr                                                      "0x0080"
+#define SB3_PRIORITY_1_inst                                                          0x0080
+#define SB3_PRIORITY_1_md_shift                                                      (24)
+#define SB3_PRIORITY_1_md_mask                                                       (0x0F000000)
+#define SB3_PRIORITY_1_md(data)                                                      (0x0F000000&((data)<<24))
+#define SB3_PRIORITY_1_md_src(data)                                                  ((0x0F000000&(data))>>24)
+#define SB3_PRIORITY_1_get_md(data)                                                  ((0x0F000000&(data))>>24)
+#define SB3_PRIORITY_1_ade_shift                                                     (8)
+#define SB3_PRIORITY_1_ade_mask                                                      (0x00000F00)
+#define SB3_PRIORITY_1_ade(data)                                                     (0x00000F00&((data)<<8))
+#define SB3_PRIORITY_1_ade_src(data)                                                 ((0x00000F00&(data))>>8)
+#define SB3_PRIORITY_1_get_ade(data)                                                 ((0x00000F00&(data))>>8)
+#define SB3_PRIORITY_1_aee_shift                                                     (0)
+#define SB3_PRIORITY_1_aee_mask                                                      (0x0000000F)
+#define SB3_PRIORITY_1_aee(data)                                                     (0x0000000F&((data)<<0))
+#define SB3_PRIORITY_1_aee_src(data)                                                 ((0x0000000F&(data))>>0)
+#define SB3_PRIORITY_1_get_aee(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define SB3_PRIORITY_2                                                               0x1801C214
+#define SB3_PRIORITY_2_reg_addr                                                      "0xB801C214"
+#define SB3_PRIORITY_2_reg                                                           0xB801C214
+#define set_SB3_PRIORITY_2_reg(data)   (*((volatile unsigned int*) SB3_PRIORITY_2_reg)=data)
+#define get_SB3_PRIORITY_2_reg   (*((volatile unsigned int*) SB3_PRIORITY_2_reg))
+#define SB3_PRIORITY_2_inst_adr                                                      "0x0085"
+#define SB3_PRIORITY_2_inst                                                          0x0085
+#define SB3_PRIORITY_2_me_shift                                                      (24)
+#define SB3_PRIORITY_2_me_mask                                                       (0x0F000000)
+#define SB3_PRIORITY_2_me(data)                                                      (0x0F000000&((data)<<24))
+#define SB3_PRIORITY_2_me_src(data)                                                  ((0x0F000000&(data))>>24)
+#define SB3_PRIORITY_2_get_me(data)                                                  ((0x0F000000&(data))>>24)
+#define SB3_PRIORITY_2_hif_shift                                                     (16)
+#define SB3_PRIORITY_2_hif_mask                                                      (0x000F0000)
+#define SB3_PRIORITY_2_hif(data)                                                     (0x000F0000&((data)<<16))
+#define SB3_PRIORITY_2_hif_src(data)                                                 ((0x000F0000&(data))>>16)
+#define SB3_PRIORITY_2_get_hif(data)                                                 ((0x000F0000&(data))>>16)
+#define SB3_PRIORITY_2_vde_shift                                                     (8)
+#define SB3_PRIORITY_2_vde_mask                                                      (0x00000F00)
+#define SB3_PRIORITY_2_vde(data)                                                     (0x00000F00&((data)<<8))
+#define SB3_PRIORITY_2_vde_src(data)                                                 ((0x00000F00&(data))>>8)
+#define SB3_PRIORITY_2_get_vde(data)                                                 ((0x00000F00&(data))>>8)
+#define SB3_PRIORITY_2_ve_shift                                                      (0)
+#define SB3_PRIORITY_2_ve_mask                                                       (0x0000000F)
+#define SB3_PRIORITY_2_ve(data)                                                      (0x0000000F&((data)<<0))
+#define SB3_PRIORITY_2_ve_src(data)                                                  ((0x0000000F&(data))>>0)
+#define SB3_PRIORITY_2_get_ve(data)                                                  ((0x0000000F&(data))>>0)
+
+
+#define SB3_CHANNEL_HIGH_PRIORITY                                                    0x1801C218
+#define SB3_CHANNEL_HIGH_PRIORITY_reg_addr                                           "0xB801C218"
+#define SB3_CHANNEL_HIGH_PRIORITY_reg                                                0xB801C218
+#define set_SB3_CHANNEL_HIGH_PRIORITY_reg(data)   (*((volatile unsigned int*) SB3_CHANNEL_HIGH_PRIORITY_reg)=data)
+#define get_SB3_CHANNEL_HIGH_PRIORITY_reg   (*((volatile unsigned int*) SB3_CHANNEL_HIGH_PRIORITY_reg))
+#define SB3_CHANNEL_HIGH_PRIORITY_inst_adr                                           "0x0086"
+#define SB3_CHANNEL_HIGH_PRIORITY_inst                                               0x0086
+#define SB3_CHANNEL_HIGH_PRIORITY_index_shift                                        (0)
+#define SB3_CHANNEL_HIGH_PRIORITY_index_mask                                         (0x000000FF)
+#define SB3_CHANNEL_HIGH_PRIORITY_index(data)                                        (0x000000FF&((data)<<0))
+#define SB3_CHANNEL_HIGH_PRIORITY_index_src(data)                                    ((0x000000FF&(data))>>0)
+#define SB3_CHANNEL_HIGH_PRIORITY_get_index(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define SB3_CHANNEL_REQ_MASK                                                         0x1801C208
+#define SB3_CHANNEL_REQ_MASK_reg_addr                                                "0xB801C208"
+#define SB3_CHANNEL_REQ_MASK_reg                                                     0xB801C208
+#define set_SB3_CHANNEL_REQ_MASK_reg(data)   (*((volatile unsigned int*) SB3_CHANNEL_REQ_MASK_reg)=data)
+#define get_SB3_CHANNEL_REQ_MASK_reg   (*((volatile unsigned int*) SB3_CHANNEL_REQ_MASK_reg))
+#define SB3_CHANNEL_REQ_MASK_inst_adr                                                "0x0082"
+#define SB3_CHANNEL_REQ_MASK_inst                                                    0x0082
+#define SB3_CHANNEL_REQ_MASK_index_shift                                             (0)
+#define SB3_CHANNEL_REQ_MASK_index_mask                                              (0x000000FF)
+#define SB3_CHANNEL_REQ_MASK_index(data)                                             (0x000000FF&((data)<<0))
+#define SB3_CHANNEL_REQ_MASK_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB3_CHANNEL_REQ_MASK_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB3_CHANNEL_REQ_BUSY                                                         0x1801C20C
+#define SB3_CHANNEL_REQ_BUSY_reg_addr                                                "0xB801C20C"
+#define SB3_CHANNEL_REQ_BUSY_reg                                                     0xB801C20C
+#define set_SB3_CHANNEL_REQ_BUSY_reg(data)   (*((volatile unsigned int*) SB3_CHANNEL_REQ_BUSY_reg)=data)
+#define get_SB3_CHANNEL_REQ_BUSY_reg   (*((volatile unsigned int*) SB3_CHANNEL_REQ_BUSY_reg))
+#define SB3_CHANNEL_REQ_BUSY_inst_adr                                                "0x0083"
+#define SB3_CHANNEL_REQ_BUSY_inst                                                    0x0083
+#define SB3_CHANNEL_REQ_BUSY_index_shift                                             (0)
+#define SB3_CHANNEL_REQ_BUSY_index_mask                                              (0x000000FF)
+#define SB3_CHANNEL_REQ_BUSY_index(data)                                             (0x000000FF&((data)<<0))
+#define SB3_CHANNEL_REQ_BUSY_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB3_CHANNEL_REQ_BUSY_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB3_MISC_CTRL                                                                0x1801C210
+#define SB3_MISC_CTRL_reg_addr                                                       "0xB801C210"
+#define SB3_MISC_CTRL_reg                                                            0xB801C210
+#define set_SB3_MISC_CTRL_reg(data)   (*((volatile unsigned int*) SB3_MISC_CTRL_reg)=data)
+#define get_SB3_MISC_CTRL_reg   (*((volatile unsigned int*) SB3_MISC_CTRL_reg))
+#define SB3_MISC_CTRL_inst_adr                                                       "0x0084"
+#define SB3_MISC_CTRL_inst                                                           0x0084
+#define SB3_MISC_CTRL_allow_cmd_cnt_shift                                            (0)
+#define SB3_MISC_CTRL_allow_cmd_cnt_mask                                             (0x00000007)
+#define SB3_MISC_CTRL_allow_cmd_cnt(data)                                            (0x00000007&((data)<<0))
+#define SB3_MISC_CTRL_allow_cmd_cnt_src(data)                                        ((0x00000007&(data))>>0)
+#define SB3_MISC_CTRL_get_allow_cmd_cnt(data)                                        ((0x00000007&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb4_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb4_reg.h
new file mode 100644
index 00000000..f2b14c8
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sb4_reg.h
@@ -0,0 +1,379 @@
+/**************************************************************
+// Spec Version                  : 0.1.2
+// Parser Version                : MAR_Parser_1.0
+// CModelGen Version             : 1.0 2006.04.18
+// Naming Rule                   : Module_Register_Name
+// Firmware Header Generate Date : 2007/12/7
+***************************************************************/
+
+
+#ifndef _SB4_REG_H_INCLUDED_
+#define _SB4_REG_H_INCLUDED_
+#ifdef  _SB4_USE_STRUCT
+typedef struct 
+{
+unsigned int     write_enable4:1;
+unsigned int     dmy:18;
+unsigned int     write_enable3:1;
+unsigned int     wl:6;
+unsigned int     write_enable2:1;
+unsigned int     en_me2_mreq:1;
+unsigned int     en_me1_mreq:1;
+unsigned int     en_ve1b_mreq:1;
+unsigned int     write_enable1:1;
+unsigned int     rr:1;
+}SB4_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ve2:6;
+unsigned int     reserved_1:2;
+unsigned int     ve1s:6;
+unsigned int     reserved_2:2;
+unsigned int     ve1b:6;
+unsigned int     reserved_3:2;
+unsigned int     se:6;
+}SB4_PRIORITY1;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     me2:6;
+unsigned int     reserved_1:2;
+unsigned int     me1:6;
+}SB4_PRIORITY2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     status_id:6;
+unsigned int     reserved_1:2;
+unsigned int     mask_id:6;
+}SB4_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_enable2:1;
+unsigned int     pc2_go:1;
+unsigned int     pc2_sel:6;
+unsigned int     write_enable1:1;
+unsigned int     pc1_go:1;
+unsigned int     pc1_sel:6;
+}SB4_PC_CTRL;
+
+typedef struct 
+{
+unsigned int     tol:32;
+}SB4_PC1_CYC;
+
+typedef struct 
+{
+unsigned int     tol_cyc:32;
+}SB4_PC1_ACK;
+
+typedef struct 
+{
+unsigned int     req_lat:32;
+}SB4_PC1_ACC;
+
+typedef struct 
+{
+unsigned int     max_lat:16;
+unsigned int     tol_num:16;
+}SB4_PC1_REQ;
+
+typedef struct 
+{
+unsigned int     tol:32;
+}SB4_PC2_CYC;
+
+typedef struct 
+{
+unsigned int     tol_cyc:32;
+}SB4_PC2_ACK;
+
+typedef struct 
+{
+unsigned int     req_lat:32;
+}SB4_PC2_ACC;
+
+typedef struct 
+{
+unsigned int     max_lat:16;
+unsigned int     tol_num:16;
+}SB4_PC2_REQ;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     write_enable3:1;
+unsigned int     sel1:5;
+unsigned int     write_enable2:1;
+unsigned int     sel0:5;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}SB4_DBG;
+
+#endif
+
+#define SB4_CTRL                                                                     0x1801C600
+#define SB4_CTRL_reg_addr                                                            "0xB801C600"
+#define SB4_CTRL_reg                                                                 0xB801C600
+#define SB4_CTRL_inst_adr                                                            "0x0080"
+#define SB4_CTRL_inst                                                                0x0080
+#define SB4_CTRL_write_enable4_shift                                                 (31)
+#define SB4_CTRL_write_enable4_mask                                                  (0x80000000)
+#define SB4_CTRL_write_enable4(data)                                                 (0x80000000&((data)<<31))
+#define SB4_CTRL_write_enable4_src(data)                                             ((0x80000000&(data))>>31)
+#define SB4_CTRL_dmy_shift                                                           (13)
+#define SB4_CTRL_dmy_mask                                                            (0x7FFFE000)
+#define SB4_CTRL_dmy(data)                                                           (0x7FFFE000&((data)<<13))
+#define SB4_CTRL_dmy_src(data)                                                       ((0x7FFFE000&(data))>>13)
+#define SB4_CTRL_write_enable3_shift                                                 (12)
+#define SB4_CTRL_write_enable3_mask                                                  (0x00001000)
+#define SB4_CTRL_write_enable3(data)                                                 (0x00001000&((data)<<12))
+#define SB4_CTRL_write_enable3_src(data)                                             ((0x00001000&(data))>>12)
+#define SB4_CTRL_wl_shift                                                            (6)
+#define SB4_CTRL_wl_mask                                                             (0x00000FC0)
+#define SB4_CTRL_wl(data)                                                            (0x00000FC0&((data)<<6))
+#define SB4_CTRL_wl_src(data)                                                        ((0x00000FC0&(data))>>6)
+#define SB4_CTRL_write_enable2_shift                                                 (5)
+#define SB4_CTRL_write_enable2_mask                                                  (0x00000020)
+#define SB4_CTRL_write_enable2(data)                                                 (0x00000020&((data)<<5))
+#define SB4_CTRL_write_enable2_src(data)                                             ((0x00000020&(data))>>5)
+#define SB4_CTRL_en_me2_mreq_shift                                                   (4)
+#define SB4_CTRL_en_me2_mreq_mask                                                    (0x00000010)
+#define SB4_CTRL_en_me2_mreq(data)                                                   (0x00000010&((data)<<4))
+#define SB4_CTRL_en_me2_mreq_src(data)                                               ((0x00000010&(data))>>4)
+#define SB4_CTRL_en_me1_mreq_shift                                                   (3)
+#define SB4_CTRL_en_me1_mreq_mask                                                    (0x00000008)
+#define SB4_CTRL_en_me1_mreq(data)                                                   (0x00000008&((data)<<3))
+#define SB4_CTRL_en_me1_mreq_src(data)                                               ((0x00000008&(data))>>3)
+#define SB4_CTRL_en_ve1b_mreq_shift                                                  (2)
+#define SB4_CTRL_en_ve1b_mreq_mask                                                   (0x00000004)
+#define SB4_CTRL_en_ve1b_mreq(data)                                                  (0x00000004&((data)<<2))
+#define SB4_CTRL_en_ve1b_mreq_src(data)                                              ((0x00000004&(data))>>2)
+#define SB4_CTRL_write_enable1_shift                                                 (1)
+#define SB4_CTRL_write_enable1_mask                                                  (0x00000002)
+#define SB4_CTRL_write_enable1(data)                                                 (0x00000002&((data)<<1))
+#define SB4_CTRL_write_enable1_src(data)                                             ((0x00000002&(data))>>1)
+#define SB4_CTRL_rr_shift                                                            (0)
+#define SB4_CTRL_rr_mask                                                             (0x00000001)
+#define SB4_CTRL_rr(data)                                                            (0x00000001&((data)<<0))
+#define SB4_CTRL_rr_src(data)                                                        ((0x00000001&(data))>>0)
+
+
+#define SB4_PRIORITY1                                                                0x1801C604
+#define SB4_PRIORITY1_reg_addr                                                       "0xB801C604"
+#define SB4_PRIORITY1_reg                                                            0xB801C604
+#define SB4_PRIORITY1_inst_adr                                                       "0x0081"
+#define SB4_PRIORITY1_inst                                                           0x0081
+#define SB4_PRIORITY1_ve2_shift                                                      (24)
+#define SB4_PRIORITY1_ve2_mask                                                       (0x3F000000)
+#define SB4_PRIORITY1_ve2(data)                                                      (0x3F000000&((data)<<24))
+#define SB4_PRIORITY1_ve2_src(data)                                                  ((0x3F000000&(data))>>24)
+#define SB4_PRIORITY1_ve1s_shift                                                     (16)
+#define SB4_PRIORITY1_ve1s_mask                                                      (0x003F0000)
+#define SB4_PRIORITY1_ve1s(data)                                                     (0x003F0000&((data)<<16))
+#define SB4_PRIORITY1_ve1s_src(data)                                                 ((0x003F0000&(data))>>16)
+#define SB4_PRIORITY1_ve1b_shift                                                     (8)
+#define SB4_PRIORITY1_ve1b_mask                                                      (0x00003F00)
+#define SB4_PRIORITY1_ve1b(data)                                                     (0x00003F00&((data)<<8))
+#define SB4_PRIORITY1_ve1b_src(data)                                                 ((0x00003F00&(data))>>8)
+#define SB4_PRIORITY1_se_shift                                                       (0)
+#define SB4_PRIORITY1_se_mask                                                        (0x0000003F)
+#define SB4_PRIORITY1_se(data)                                                       (0x0000003F&((data)<<0))
+#define SB4_PRIORITY1_se_src(data)                                                   ((0x0000003F&(data))>>0)
+
+
+#define SB4_PRIORITY2                                                                0x1801C608
+#define SB4_PRIORITY2_reg_addr                                                       "0xB801C608"
+#define SB4_PRIORITY2_reg                                                            0xB801C608
+#define SB4_PRIORITY2_inst_adr                                                       "0x0082"
+#define SB4_PRIORITY2_inst                                                           0x0082
+#define SB4_PRIORITY2_me2_shift                                                      (8)
+#define SB4_PRIORITY2_me2_mask                                                       (0x00003F00)
+#define SB4_PRIORITY2_me2(data)                                                      (0x00003F00&((data)<<8))
+#define SB4_PRIORITY2_me2_src(data)                                                  ((0x00003F00&(data))>>8)
+#define SB4_PRIORITY2_me1_shift                                                      (0)
+#define SB4_PRIORITY2_me1_mask                                                       (0x0000003F)
+#define SB4_PRIORITY2_me1(data)                                                      (0x0000003F&((data)<<0))
+#define SB4_PRIORITY2_me1_src(data)                                                  ((0x0000003F&(data))>>0)
+
+
+#define SB4_MASK                                                                     0x1801C60C
+#define SB4_MASK_reg_addr                                                            "0xB801C60C"
+#define SB4_MASK_reg                                                                 0xB801C60C
+#define SB4_MASK_inst_adr                                                            "0x0083"
+#define SB4_MASK_inst                                                                0x0083
+#define SB4_MASK_status_id_shift                                                     (8)
+#define SB4_MASK_status_id_mask                                                      (0x00003F00)
+#define SB4_MASK_status_id(data)                                                     (0x00003F00&((data)<<8))
+#define SB4_MASK_status_id_src(data)                                                 ((0x00003F00&(data))>>8)
+#define SB4_MASK_mask_id_shift                                                       (0)
+#define SB4_MASK_mask_id_mask                                                        (0x0000003F)
+#define SB4_MASK_mask_id(data)                                                       (0x0000003F&((data)<<0))
+#define SB4_MASK_mask_id_src(data)                                                   ((0x0000003F&(data))>>0)
+
+
+#define SB4_PC_CTRL                                                                  0x1801C610
+#define SB4_PC_CTRL_reg_addr                                                         "0xB801C610"
+#define SB4_PC_CTRL_reg                                                              0xB801C610
+#define SB4_PC_CTRL_inst_adr                                                         "0x0084"
+#define SB4_PC_CTRL_inst                                                             0x0084
+#define SB4_PC_CTRL_write_enable2_shift                                              (15)
+#define SB4_PC_CTRL_write_enable2_mask                                               (0x00008000)
+#define SB4_PC_CTRL_write_enable2(data)                                              (0x00008000&((data)<<15))
+#define SB4_PC_CTRL_write_enable2_src(data)                                          ((0x00008000&(data))>>15)
+#define SB4_PC_CTRL_pc2_go_shift                                                     (14)
+#define SB4_PC_CTRL_pc2_go_mask                                                      (0x00004000)
+#define SB4_PC_CTRL_pc2_go(data)                                                     (0x00004000&((data)<<14))
+#define SB4_PC_CTRL_pc2_go_src(data)                                                 ((0x00004000&(data))>>14)
+#define SB4_PC_CTRL_pc2_sel_shift                                                    (8)
+#define SB4_PC_CTRL_pc2_sel_mask                                                     (0x00003F00)
+#define SB4_PC_CTRL_pc2_sel(data)                                                    (0x00003F00&((data)<<8))
+#define SB4_PC_CTRL_pc2_sel_src(data)                                                ((0x00003F00&(data))>>8)
+#define SB4_PC_CTRL_write_enable1_shift                                              (7)
+#define SB4_PC_CTRL_write_enable1_mask                                               (0x00000080)
+#define SB4_PC_CTRL_write_enable1(data)                                              (0x00000080&((data)<<7))
+#define SB4_PC_CTRL_write_enable1_src(data)                                          ((0x00000080&(data))>>7)
+#define SB4_PC_CTRL_pc1_go_shift                                                     (6)
+#define SB4_PC_CTRL_pc1_go_mask                                                      (0x00000040)
+#define SB4_PC_CTRL_pc1_go(data)                                                     (0x00000040&((data)<<6))
+#define SB4_PC_CTRL_pc1_go_src(data)                                                 ((0x00000040&(data))>>6)
+#define SB4_PC_CTRL_pc1_sel_shift                                                    (0)
+#define SB4_PC_CTRL_pc1_sel_mask                                                     (0x0000003F)
+#define SB4_PC_CTRL_pc1_sel(data)                                                    (0x0000003F&((data)<<0))
+#define SB4_PC_CTRL_pc1_sel_src(data)                                                ((0x0000003F&(data))>>0)
+
+
+#define SB4_PC1_CYC                                                                  0x1801C614
+#define SB4_PC1_CYC_reg_addr                                                         "0xB801C614"
+#define SB4_PC1_CYC_reg                                                              0xB801C614
+#define SB4_PC1_CYC_inst_adr                                                         "0x0085"
+#define SB4_PC1_CYC_inst                                                             0x0085
+#define SB4_PC1_CYC_tol_shift                                                        (0)
+#define SB4_PC1_CYC_tol_mask                                                         (0xFFFFFFFF)
+#define SB4_PC1_CYC_tol(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define SB4_PC1_CYC_tol_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB4_PC1_ACK                                                                  0x1801C618
+#define SB4_PC1_ACK_reg_addr                                                         "0xB801C618"
+#define SB4_PC1_ACK_reg                                                              0xB801C618
+#define SB4_PC1_ACK_inst_adr                                                         "0x0086"
+#define SB4_PC1_ACK_inst                                                             0x0086
+#define SB4_PC1_ACK_tol_cyc_shift                                                    (0)
+#define SB4_PC1_ACK_tol_cyc_mask                                                     (0xFFFFFFFF)
+#define SB4_PC1_ACK_tol_cyc(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define SB4_PC1_ACK_tol_cyc_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB4_PC1_ACC                                                                  0x1801C61C
+#define SB4_PC1_ACC_reg_addr                                                         "0xB801C61C"
+#define SB4_PC1_ACC_reg                                                              0xB801C61C
+#define SB4_PC1_ACC_inst_adr                                                         "0x0087"
+#define SB4_PC1_ACC_inst                                                             0x0087
+#define SB4_PC1_ACC_req_lat_shift                                                    (0)
+#define SB4_PC1_ACC_req_lat_mask                                                     (0xFFFFFFFF)
+#define SB4_PC1_ACC_req_lat(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define SB4_PC1_ACC_req_lat_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB4_PC1_REQ                                                                  0x1801C620
+#define SB4_PC1_REQ_reg_addr                                                         "0xB801C620"
+#define SB4_PC1_REQ_reg                                                              0xB801C620
+#define SB4_PC1_REQ_inst_adr                                                         "0x0088"
+#define SB4_PC1_REQ_inst                                                             0x0088
+#define SB4_PC1_REQ_max_lat_shift                                                    (16)
+#define SB4_PC1_REQ_max_lat_mask                                                     (0xFFFF0000)
+#define SB4_PC1_REQ_max_lat(data)                                                    (0xFFFF0000&((data)<<16))
+#define SB4_PC1_REQ_max_lat_src(data)                                                ((0xFFFF0000&(data))>>16)
+#define SB4_PC1_REQ_tol_num_shift                                                    (0)
+#define SB4_PC1_REQ_tol_num_mask                                                     (0x0000FFFF)
+#define SB4_PC1_REQ_tol_num(data)                                                    (0x0000FFFF&((data)<<0))
+#define SB4_PC1_REQ_tol_num_src(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define SB4_PC2_CYC                                                                  0x1801C624
+#define SB4_PC2_CYC_reg_addr                                                         "0xB801C624"
+#define SB4_PC2_CYC_reg                                                              0xB801C624
+#define SB4_PC2_CYC_inst_adr                                                         "0x0089"
+#define SB4_PC2_CYC_inst                                                             0x0089
+#define SB4_PC2_CYC_tol_shift                                                        (0)
+#define SB4_PC2_CYC_tol_mask                                                         (0xFFFFFFFF)
+#define SB4_PC2_CYC_tol(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define SB4_PC2_CYC_tol_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB4_PC2_ACK                                                                  0x1801C628
+#define SB4_PC2_ACK_reg_addr                                                         "0xB801C628"
+#define SB4_PC2_ACK_reg                                                              0xB801C628
+#define SB4_PC2_ACK_inst_adr                                                         "0x008A"
+#define SB4_PC2_ACK_inst                                                             0x008A
+#define SB4_PC2_ACK_tol_cyc_shift                                                    (0)
+#define SB4_PC2_ACK_tol_cyc_mask                                                     (0xFFFFFFFF)
+#define SB4_PC2_ACK_tol_cyc(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define SB4_PC2_ACK_tol_cyc_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB4_PC2_ACC                                                                  0x1801C62C
+#define SB4_PC2_ACC_reg_addr                                                         "0xB801C62C"
+#define SB4_PC2_ACC_reg                                                              0xB801C62C
+#define SB4_PC2_ACC_inst_adr                                                         "0x008B"
+#define SB4_PC2_ACC_inst                                                             0x008B
+#define SB4_PC2_ACC_req_lat_shift                                                    (0)
+#define SB4_PC2_ACC_req_lat_mask                                                     (0xFFFFFFFF)
+#define SB4_PC2_ACC_req_lat(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define SB4_PC2_ACC_req_lat_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SB4_PC2_REQ                                                                  0x1801C630
+#define SB4_PC2_REQ_reg_addr                                                         "0xB801C630"
+#define SB4_PC2_REQ_reg                                                              0xB801C630
+#define SB4_PC2_REQ_inst_adr                                                         "0x008C"
+#define SB4_PC2_REQ_inst                                                             0x008C
+#define SB4_PC2_REQ_max_lat_shift                                                    (16)
+#define SB4_PC2_REQ_max_lat_mask                                                     (0xFFFF0000)
+#define SB4_PC2_REQ_max_lat(data)                                                    (0xFFFF0000&((data)<<16))
+#define SB4_PC2_REQ_max_lat_src(data)                                                ((0xFFFF0000&(data))>>16)
+#define SB4_PC2_REQ_tol_num_shift                                                    (0)
+#define SB4_PC2_REQ_tol_num_mask                                                     (0x0000FFFF)
+#define SB4_PC2_REQ_tol_num(data)                                                    (0x0000FFFF&((data)<<0))
+#define SB4_PC2_REQ_tol_num_src(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define SB4_DBG                                                                      0x1801C634
+#define SB4_DBG_reg_addr                                                             "0xB801C634"
+#define SB4_DBG_reg                                                                  0xB801C634
+#define SB4_DBG_inst_adr                                                             "0x008D"
+#define SB4_DBG_inst                                                                 0x008D
+#define SB4_DBG_write_enable3_shift                                                  (13)
+#define SB4_DBG_write_enable3_mask                                                   (0x00002000)
+#define SB4_DBG_write_enable3(data)                                                  (0x00002000&((data)<<13))
+#define SB4_DBG_write_enable3_src(data)                                              ((0x00002000&(data))>>13)
+#define SB4_DBG_sel1_shift                                                           (8)
+#define SB4_DBG_sel1_mask                                                            (0x00001F00)
+#define SB4_DBG_sel1(data)                                                           (0x00001F00&((data)<<8))
+#define SB4_DBG_sel1_src(data)                                                       ((0x00001F00&(data))>>8)
+#define SB4_DBG_write_enable2_shift                                                  (7)
+#define SB4_DBG_write_enable2_mask                                                   (0x00000080)
+#define SB4_DBG_write_enable2(data)                                                  (0x00000080&((data)<<7))
+#define SB4_DBG_write_enable2_src(data)                                              ((0x00000080&(data))>>7)
+#define SB4_DBG_sel0_shift                                                           (2)
+#define SB4_DBG_sel0_mask                                                            (0x0000007C)
+#define SB4_DBG_sel0(data)                                                           (0x0000007C&((data)<<2))
+#define SB4_DBG_sel0_src(data)                                                       ((0x0000007C&(data))>>2)
+#define SB4_DBG_write_enable1_shift                                                  (1)
+#define SB4_DBG_write_enable1_mask                                                   (0x00000002)
+#define SB4_DBG_write_enable1(data)                                                  (0x00000002&((data)<<1))
+#define SB4_DBG_write_enable1_src(data)                                              ((0x00000002&(data))>>1)
+#define SB4_DBG_enable_shift                                                         (0)
+#define SB4_DBG_enable_mask                                                          (0x00000001)
+#define SB4_DBG_enable(data)                                                         (0x00000001&((data)<<0))
+#define SB4_DBG_enable_src(data)                                                     ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sbx_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sbx_reg.h
new file mode 100644
index 00000000..7142aa6
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sbx_reg.h
@@ -0,0 +1,425 @@
+/**************************************************************
+// Spec Version                  : 0.0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/8/12 12:49:48
+***************************************************************/
+
+
+#ifndef _SBX_REG_H_INCLUDED_
+#define _SBX_REG_H_INCLUDED_
+#ifdef  _SBX_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     tp:4;
+unsigned int     reserved_1:4;
+unsigned int     etn:4;
+unsigned int     reserved_2:4;
+unsigned int     etn2:4;
+unsigned int     reserved_3:4;
+unsigned int     sata:4;
+}SB1_PRIORITY_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     nf:4;
+unsigned int     reserved_1:4;
+unsigned int     usb:4;
+unsigned int     reserved_2:4;
+unsigned int     cp:4;
+unsigned int     reserved_3:4;
+unsigned int     cr:4;
+}SB1_PRIORITY_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB1_CHANNEL_HIGH_PRIORITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB1_CHANNEL_REQ_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB1_CHANNEL_REQ_BUSY;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     allow_cmd_cnt:3;
+}SB1_MISC_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     md:4;
+unsigned int     reserved_1:4;
+unsigned int     reserved_2:4;
+unsigned int     reserved_3:4;
+unsigned int     ade:4;
+unsigned int     reserved_4:4;
+unsigned int     aee:4;
+}SB3_PRIORITY_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     me:4;
+unsigned int     reserved_1:4;
+unsigned int     hif:4;
+unsigned int     reserved_2:4;
+unsigned int     jpeg:4;
+unsigned int     reserved_3:4;
+unsigned int     ve:4;
+}SB3_PRIORITY_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB3_CHANNEL_HIGH_PRIORITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB3_CHANNEL_REQ_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB3_CHANNEL_REQ_BUSY;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     allow_cmd_cnt:3;
+}SB3_MISC_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     vi:4;
+unsigned int     reserved_1:4;
+unsigned int     aio:4;
+}SB0_PRIORITY_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB0_CHANNEL_REQ_MASK;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     index:8;
+}SB0_CHANNEL_REQ_BUSY;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     allow_cmd_cnt:3;
+}SB0_MISC_CTRL;
+
+#endif
+
+#define SB1_PRIORITY_1                                                               0x1801C000
+#define SB1_PRIORITY_1_reg_addr                                                      "0xB801C000"
+#define SB1_PRIORITY_1_reg                                                           0xB801C000
+#define set_SB1_PRIORITY_1_reg(data)   (*((volatile unsigned int*) SB1_PRIORITY_1_reg)=data)
+#define get_SB1_PRIORITY_1_reg   (*((volatile unsigned int*) SB1_PRIORITY_1_reg))
+#define SB1_PRIORITY_1_inst_adr                                                      "0x0000"
+#define SB1_PRIORITY_1_inst                                                          0x0000
+#define SB1_PRIORITY_1_tp_shift                                                      (24)
+#define SB1_PRIORITY_1_tp_mask                                                       (0x0F000000)
+#define SB1_PRIORITY_1_tp(data)                                                      (0x0F000000&((data)<<24))
+#define SB1_PRIORITY_1_tp_src(data)                                                  ((0x0F000000&(data))>>24)
+#define SB1_PRIORITY_1_get_tp(data)                                                  ((0x0F000000&(data))>>24)
+#define SB1_PRIORITY_1_etn_shift                                                     (16)
+#define SB1_PRIORITY_1_etn_mask                                                      (0x000F0000)
+#define SB1_PRIORITY_1_etn(data)                                                     (0x000F0000&((data)<<16))
+#define SB1_PRIORITY_1_etn_src(data)                                                 ((0x000F0000&(data))>>16)
+#define SB1_PRIORITY_1_get_etn(data)                                                 ((0x000F0000&(data))>>16)
+#define SB1_PRIORITY_1_etn2_shift                                                    (8)
+#define SB1_PRIORITY_1_etn2_mask                                                     (0x00000F00)
+#define SB1_PRIORITY_1_etn2(data)                                                    (0x00000F00&((data)<<8))
+#define SB1_PRIORITY_1_etn2_src(data)                                                ((0x00000F00&(data))>>8)
+#define SB1_PRIORITY_1_get_etn2(data)                                                ((0x00000F00&(data))>>8)
+#define SB1_PRIORITY_1_sata_shift                                                    (0)
+#define SB1_PRIORITY_1_sata_mask                                                     (0x0000000F)
+#define SB1_PRIORITY_1_sata(data)                                                    (0x0000000F&((data)<<0))
+#define SB1_PRIORITY_1_sata_src(data)                                                ((0x0000000F&(data))>>0)
+#define SB1_PRIORITY_1_get_sata(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define SB1_PRIORITY_2                                                               0x1801C004
+#define SB1_PRIORITY_2_reg_addr                                                      "0xB801C004"
+#define SB1_PRIORITY_2_reg                                                           0xB801C004
+#define set_SB1_PRIORITY_2_reg(data)   (*((volatile unsigned int*) SB1_PRIORITY_2_reg)=data)
+#define get_SB1_PRIORITY_2_reg   (*((volatile unsigned int*) SB1_PRIORITY_2_reg))
+#define SB1_PRIORITY_2_inst_adr                                                      "0x0001"
+#define SB1_PRIORITY_2_inst                                                          0x0001
+#define SB1_PRIORITY_2_nf_shift                                                      (24)
+#define SB1_PRIORITY_2_nf_mask                                                       (0x0F000000)
+#define SB1_PRIORITY_2_nf(data)                                                      (0x0F000000&((data)<<24))
+#define SB1_PRIORITY_2_nf_src(data)                                                  ((0x0F000000&(data))>>24)
+#define SB1_PRIORITY_2_get_nf(data)                                                  ((0x0F000000&(data))>>24)
+#define SB1_PRIORITY_2_usb_shift                                                     (16)
+#define SB1_PRIORITY_2_usb_mask                                                      (0x000F0000)
+#define SB1_PRIORITY_2_usb(data)                                                     (0x000F0000&((data)<<16))
+#define SB1_PRIORITY_2_usb_src(data)                                                 ((0x000F0000&(data))>>16)
+#define SB1_PRIORITY_2_get_usb(data)                                                 ((0x000F0000&(data))>>16)
+#define SB1_PRIORITY_2_cp_shift                                                      (8)
+#define SB1_PRIORITY_2_cp_mask                                                       (0x00000F00)
+#define SB1_PRIORITY_2_cp(data)                                                      (0x00000F00&((data)<<8))
+#define SB1_PRIORITY_2_cp_src(data)                                                  ((0x00000F00&(data))>>8)
+#define SB1_PRIORITY_2_get_cp(data)                                                  ((0x00000F00&(data))>>8)
+#define SB1_PRIORITY_2_cr_shift                                                      (0)
+#define SB1_PRIORITY_2_cr_mask                                                       (0x0000000F)
+#define SB1_PRIORITY_2_cr(data)                                                      (0x0000000F&((data)<<0))
+#define SB1_PRIORITY_2_cr_src(data)                                                  ((0x0000000F&(data))>>0)
+#define SB1_PRIORITY_2_get_cr(data)                                                  ((0x0000000F&(data))>>0)
+
+
+#define SB1_CHANNEL_HIGH_PRIORITY                                                    0x1801C008
+#define SB1_CHANNEL_HIGH_PRIORITY_reg_addr                                           "0xB801C008"
+#define SB1_CHANNEL_HIGH_PRIORITY_reg                                                0xB801C008
+#define set_SB1_CHANNEL_HIGH_PRIORITY_reg(data)   (*((volatile unsigned int*) SB1_CHANNEL_HIGH_PRIORITY_reg)=data)
+#define get_SB1_CHANNEL_HIGH_PRIORITY_reg   (*((volatile unsigned int*) SB1_CHANNEL_HIGH_PRIORITY_reg))
+#define SB1_CHANNEL_HIGH_PRIORITY_inst_adr                                           "0x0002"
+#define SB1_CHANNEL_HIGH_PRIORITY_inst                                               0x0002
+#define SB1_CHANNEL_HIGH_PRIORITY_index_shift                                        (0)
+#define SB1_CHANNEL_HIGH_PRIORITY_index_mask                                         (0x000000FF)
+#define SB1_CHANNEL_HIGH_PRIORITY_index(data)                                        (0x000000FF&((data)<<0))
+#define SB1_CHANNEL_HIGH_PRIORITY_index_src(data)                                    ((0x000000FF&(data))>>0)
+#define SB1_CHANNEL_HIGH_PRIORITY_get_index(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define SB1_CHANNEL_REQ_MASK                                                         0x1801C00C
+#define SB1_CHANNEL_REQ_MASK_reg_addr                                                "0xB801C00C"
+#define SB1_CHANNEL_REQ_MASK_reg                                                     0xB801C00C
+#define set_SB1_CHANNEL_REQ_MASK_reg(data)   (*((volatile unsigned int*) SB1_CHANNEL_REQ_MASK_reg)=data)
+#define get_SB1_CHANNEL_REQ_MASK_reg   (*((volatile unsigned int*) SB1_CHANNEL_REQ_MASK_reg))
+#define SB1_CHANNEL_REQ_MASK_inst_adr                                                "0x0003"
+#define SB1_CHANNEL_REQ_MASK_inst                                                    0x0003
+#define SB1_CHANNEL_REQ_MASK_index_shift                                             (0)
+#define SB1_CHANNEL_REQ_MASK_index_mask                                              (0x000000FF)
+#define SB1_CHANNEL_REQ_MASK_index(data)                                             (0x000000FF&((data)<<0))
+#define SB1_CHANNEL_REQ_MASK_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB1_CHANNEL_REQ_MASK_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB1_CHANNEL_REQ_BUSY                                                         0x1801C010
+#define SB1_CHANNEL_REQ_BUSY_reg_addr                                                "0xB801C010"
+#define SB1_CHANNEL_REQ_BUSY_reg                                                     0xB801C010
+#define set_SB1_CHANNEL_REQ_BUSY_reg(data)   (*((volatile unsigned int*) SB1_CHANNEL_REQ_BUSY_reg)=data)
+#define get_SB1_CHANNEL_REQ_BUSY_reg   (*((volatile unsigned int*) SB1_CHANNEL_REQ_BUSY_reg))
+#define SB1_CHANNEL_REQ_BUSY_inst_adr                                                "0x0004"
+#define SB1_CHANNEL_REQ_BUSY_inst                                                    0x0004
+#define SB1_CHANNEL_REQ_BUSY_index_shift                                             (0)
+#define SB1_CHANNEL_REQ_BUSY_index_mask                                              (0x000000FF)
+#define SB1_CHANNEL_REQ_BUSY_index(data)                                             (0x000000FF&((data)<<0))
+#define SB1_CHANNEL_REQ_BUSY_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB1_CHANNEL_REQ_BUSY_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB1_MISC_CTRL                                                                0x1801C014
+#define SB1_MISC_CTRL_reg_addr                                                       "0xB801C014"
+#define SB1_MISC_CTRL_reg                                                            0xB801C014
+#define set_SB1_MISC_CTRL_reg(data)   (*((volatile unsigned int*) SB1_MISC_CTRL_reg)=data)
+#define get_SB1_MISC_CTRL_reg   (*((volatile unsigned int*) SB1_MISC_CTRL_reg))
+#define SB1_MISC_CTRL_inst_adr                                                       "0x0005"
+#define SB1_MISC_CTRL_inst                                                           0x0005
+#define SB1_MISC_CTRL_allow_cmd_cnt_shift                                            (0)
+#define SB1_MISC_CTRL_allow_cmd_cnt_mask                                             (0x00000007)
+#define SB1_MISC_CTRL_allow_cmd_cnt(data)                                            (0x00000007&((data)<<0))
+#define SB1_MISC_CTRL_allow_cmd_cnt_src(data)                                        ((0x00000007&(data))>>0)
+#define SB1_MISC_CTRL_get_allow_cmd_cnt(data)                                        ((0x00000007&(data))>>0)
+
+
+#define SB3_PRIORITY_1                                                               0x1801C200
+#define SB3_PRIORITY_1_reg_addr                                                      "0xB801C200"
+#define SB3_PRIORITY_1_reg                                                           0xB801C200
+#define set_SB3_PRIORITY_1_reg(data)   (*((volatile unsigned int*) SB3_PRIORITY_1_reg)=data)
+#define get_SB3_PRIORITY_1_reg   (*((volatile unsigned int*) SB3_PRIORITY_1_reg))
+#define SB3_PRIORITY_1_inst_adr                                                      "0x0080"
+#define SB3_PRIORITY_1_inst                                                          0x0080
+#define SB3_PRIORITY_1_md_shift                                                      (24)
+#define SB3_PRIORITY_1_md_mask                                                       (0x0F000000)
+#define SB3_PRIORITY_1_md(data)                                                      (0x0F000000&((data)<<24))
+#define SB3_PRIORITY_1_md_src(data)                                                  ((0x0F000000&(data))>>24)
+#define SB3_PRIORITY_1_get_md(data)                                                  ((0x0F000000&(data))>>24)
+#define SB3_PRIORITY_1_ade_shift                                                     (8)
+#define SB3_PRIORITY_1_ade_mask                                                      (0x00000F00)
+#define SB3_PRIORITY_1_ade(data)                                                     (0x00000F00&((data)<<8))
+#define SB3_PRIORITY_1_ade_src(data)                                                 ((0x00000F00&(data))>>8)
+#define SB3_PRIORITY_1_get_ade(data)                                                 ((0x00000F00&(data))>>8)
+#define SB3_PRIORITY_1_aee_shift                                                     (0)
+#define SB3_PRIORITY_1_aee_mask                                                      (0x0000000F)
+#define SB3_PRIORITY_1_aee(data)                                                     (0x0000000F&((data)<<0))
+#define SB3_PRIORITY_1_aee_src(data)                                                 ((0x0000000F&(data))>>0)
+#define SB3_PRIORITY_1_get_aee(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define SB3_PRIORITY_2                                                               0x1801C214
+#define SB3_PRIORITY_2_reg_addr                                                      "0xB801C214"
+#define SB3_PRIORITY_2_reg                                                           0xB801C214
+#define set_SB3_PRIORITY_2_reg(data)   (*((volatile unsigned int*) SB3_PRIORITY_2_reg)=data)
+#define get_SB3_PRIORITY_2_reg   (*((volatile unsigned int*) SB3_PRIORITY_2_reg))
+#define SB3_PRIORITY_2_inst_adr                                                      "0x0085"
+#define SB3_PRIORITY_2_inst                                                          0x0085
+#define SB3_PRIORITY_2_me_shift                                                      (24)
+#define SB3_PRIORITY_2_me_mask                                                       (0x0F000000)
+#define SB3_PRIORITY_2_me(data)                                                      (0x0F000000&((data)<<24))
+#define SB3_PRIORITY_2_me_src(data)                                                  ((0x0F000000&(data))>>24)
+#define SB3_PRIORITY_2_get_me(data)                                                  ((0x0F000000&(data))>>24)
+#define SB3_PRIORITY_2_hif_shift                                                     (16)
+#define SB3_PRIORITY_2_hif_mask                                                      (0x000F0000)
+#define SB3_PRIORITY_2_hif(data)                                                     (0x000F0000&((data)<<16))
+#define SB3_PRIORITY_2_hif_src(data)                                                 ((0x000F0000&(data))>>16)
+#define SB3_PRIORITY_2_get_hif(data)                                                 ((0x000F0000&(data))>>16)
+#define SB3_PRIORITY_2_jpeg_shift                                                    (8)
+#define SB3_PRIORITY_2_jpeg_mask                                                     (0x00000F00)
+#define SB3_PRIORITY_2_jpeg(data)                                                    (0x00000F00&((data)<<8))
+#define SB3_PRIORITY_2_jpeg_src(data)                                                ((0x00000F00&(data))>>8)
+#define SB3_PRIORITY_2_get_jpeg(data)                                                ((0x00000F00&(data))>>8)
+#define SB3_PRIORITY_2_ve_shift                                                      (0)
+#define SB3_PRIORITY_2_ve_mask                                                       (0x0000000F)
+#define SB3_PRIORITY_2_ve(data)                                                      (0x0000000F&((data)<<0))
+#define SB3_PRIORITY_2_ve_src(data)                                                  ((0x0000000F&(data))>>0)
+#define SB3_PRIORITY_2_get_ve(data)                                                  ((0x0000000F&(data))>>0)
+
+
+#define SB3_CHANNEL_HIGH_PRIORITY                                                    0x1801C218
+#define SB3_CHANNEL_HIGH_PRIORITY_reg_addr                                           "0xB801C218"
+#define SB3_CHANNEL_HIGH_PRIORITY_reg                                                0xB801C218
+#define set_SB3_CHANNEL_HIGH_PRIORITY_reg(data)   (*((volatile unsigned int*) SB3_CHANNEL_HIGH_PRIORITY_reg)=data)
+#define get_SB3_CHANNEL_HIGH_PRIORITY_reg   (*((volatile unsigned int*) SB3_CHANNEL_HIGH_PRIORITY_reg))
+#define SB3_CHANNEL_HIGH_PRIORITY_inst_adr                                           "0x0086"
+#define SB3_CHANNEL_HIGH_PRIORITY_inst                                               0x0086
+#define SB3_CHANNEL_HIGH_PRIORITY_index_shift                                        (0)
+#define SB3_CHANNEL_HIGH_PRIORITY_index_mask                                         (0x000000FF)
+#define SB3_CHANNEL_HIGH_PRIORITY_index(data)                                        (0x000000FF&((data)<<0))
+#define SB3_CHANNEL_HIGH_PRIORITY_index_src(data)                                    ((0x000000FF&(data))>>0)
+#define SB3_CHANNEL_HIGH_PRIORITY_get_index(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define SB3_CHANNEL_REQ_MASK                                                         0x1801C208
+#define SB3_CHANNEL_REQ_MASK_reg_addr                                                "0xB801C208"
+#define SB3_CHANNEL_REQ_MASK_reg                                                     0xB801C208
+#define set_SB3_CHANNEL_REQ_MASK_reg(data)   (*((volatile unsigned int*) SB3_CHANNEL_REQ_MASK_reg)=data)
+#define get_SB3_CHANNEL_REQ_MASK_reg   (*((volatile unsigned int*) SB3_CHANNEL_REQ_MASK_reg))
+#define SB3_CHANNEL_REQ_MASK_inst_adr                                                "0x0082"
+#define SB3_CHANNEL_REQ_MASK_inst                                                    0x0082
+#define SB3_CHANNEL_REQ_MASK_index_shift                                             (0)
+#define SB3_CHANNEL_REQ_MASK_index_mask                                              (0x000000FF)
+#define SB3_CHANNEL_REQ_MASK_index(data)                                             (0x000000FF&((data)<<0))
+#define SB3_CHANNEL_REQ_MASK_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB3_CHANNEL_REQ_MASK_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB3_CHANNEL_REQ_BUSY                                                         0x1801C20C
+#define SB3_CHANNEL_REQ_BUSY_reg_addr                                                "0xB801C20C"
+#define SB3_CHANNEL_REQ_BUSY_reg                                                     0xB801C20C
+#define set_SB3_CHANNEL_REQ_BUSY_reg(data)   (*((volatile unsigned int*) SB3_CHANNEL_REQ_BUSY_reg)=data)
+#define get_SB3_CHANNEL_REQ_BUSY_reg   (*((volatile unsigned int*) SB3_CHANNEL_REQ_BUSY_reg))
+#define SB3_CHANNEL_REQ_BUSY_inst_adr                                                "0x0083"
+#define SB3_CHANNEL_REQ_BUSY_inst                                                    0x0083
+#define SB3_CHANNEL_REQ_BUSY_index_shift                                             (0)
+#define SB3_CHANNEL_REQ_BUSY_index_mask                                              (0x000000FF)
+#define SB3_CHANNEL_REQ_BUSY_index(data)                                             (0x000000FF&((data)<<0))
+#define SB3_CHANNEL_REQ_BUSY_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB3_CHANNEL_REQ_BUSY_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB3_MISC_CTRL                                                                0x1801C210
+#define SB3_MISC_CTRL_reg_addr                                                       "0xB801C210"
+#define SB3_MISC_CTRL_reg                                                            0xB801C210
+#define set_SB3_MISC_CTRL_reg(data)   (*((volatile unsigned int*) SB3_MISC_CTRL_reg)=data)
+#define get_SB3_MISC_CTRL_reg   (*((volatile unsigned int*) SB3_MISC_CTRL_reg))
+#define SB3_MISC_CTRL_inst_adr                                                       "0x0084"
+#define SB3_MISC_CTRL_inst                                                           0x0084
+#define SB3_MISC_CTRL_allow_cmd_cnt_shift                                            (0)
+#define SB3_MISC_CTRL_allow_cmd_cnt_mask                                             (0x00000007)
+#define SB3_MISC_CTRL_allow_cmd_cnt(data)                                            (0x00000007&((data)<<0))
+#define SB3_MISC_CTRL_allow_cmd_cnt_src(data)                                        ((0x00000007&(data))>>0)
+#define SB3_MISC_CTRL_get_allow_cmd_cnt(data)                                        ((0x00000007&(data))>>0)
+
+
+#define SB0_PRIORITY_1                                                               0x1801C400
+#define SB0_PRIORITY_1_reg_addr                                                      "0xB801C400"
+#define SB0_PRIORITY_1_reg                                                           0xB801C400
+#define set_SB0_PRIORITY_1_reg(data)   (*((volatile unsigned int*) SB0_PRIORITY_1_reg)=data)
+#define get_SB0_PRIORITY_1_reg   (*((volatile unsigned int*) SB0_PRIORITY_1_reg))
+#define SB0_PRIORITY_1_inst_adr                                                      "0x0000"
+#define SB0_PRIORITY_1_inst                                                          0x0000
+#define SB0_PRIORITY_1_vi_shift                                                      (8)
+#define SB0_PRIORITY_1_vi_mask                                                       (0x00000F00)
+#define SB0_PRIORITY_1_vi(data)                                                      (0x00000F00&((data)<<8))
+#define SB0_PRIORITY_1_vi_src(data)                                                  ((0x00000F00&(data))>>8)
+#define SB0_PRIORITY_1_get_vi(data)                                                  ((0x00000F00&(data))>>8)
+#define SB0_PRIORITY_1_aio_shift                                                     (0)
+#define SB0_PRIORITY_1_aio_mask                                                      (0x0000000F)
+#define SB0_PRIORITY_1_aio(data)                                                     (0x0000000F&((data)<<0))
+#define SB0_PRIORITY_1_aio_src(data)                                                 ((0x0000000F&(data))>>0)
+#define SB0_PRIORITY_1_get_aio(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define SB0_CHANNEL_REQ_MASK                                                         0x1801C408
+#define SB0_CHANNEL_REQ_MASK_reg_addr                                                "0xB801C408"
+#define SB0_CHANNEL_REQ_MASK_reg                                                     0xB801C408
+#define set_SB0_CHANNEL_REQ_MASK_reg(data)   (*((volatile unsigned int*) SB0_CHANNEL_REQ_MASK_reg)=data)
+#define get_SB0_CHANNEL_REQ_MASK_reg   (*((volatile unsigned int*) SB0_CHANNEL_REQ_MASK_reg))
+#define SB0_CHANNEL_REQ_MASK_inst_adr                                                "0x0002"
+#define SB0_CHANNEL_REQ_MASK_inst                                                    0x0002
+#define SB0_CHANNEL_REQ_MASK_index_shift                                             (0)
+#define SB0_CHANNEL_REQ_MASK_index_mask                                              (0x000000FF)
+#define SB0_CHANNEL_REQ_MASK_index(data)                                             (0x000000FF&((data)<<0))
+#define SB0_CHANNEL_REQ_MASK_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB0_CHANNEL_REQ_MASK_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB0_CHANNEL_REQ_BUSY                                                         0x1801C40C
+#define SB0_CHANNEL_REQ_BUSY_reg_addr                                                "0xB801C40C"
+#define SB0_CHANNEL_REQ_BUSY_reg                                                     0xB801C40C
+#define set_SB0_CHANNEL_REQ_BUSY_reg(data)   (*((volatile unsigned int*) SB0_CHANNEL_REQ_BUSY_reg)=data)
+#define get_SB0_CHANNEL_REQ_BUSY_reg   (*((volatile unsigned int*) SB0_CHANNEL_REQ_BUSY_reg))
+#define SB0_CHANNEL_REQ_BUSY_inst_adr                                                "0x0003"
+#define SB0_CHANNEL_REQ_BUSY_inst                                                    0x0003
+#define SB0_CHANNEL_REQ_BUSY_index_shift                                             (0)
+#define SB0_CHANNEL_REQ_BUSY_index_mask                                              (0x000000FF)
+#define SB0_CHANNEL_REQ_BUSY_index(data)                                             (0x000000FF&((data)<<0))
+#define SB0_CHANNEL_REQ_BUSY_index_src(data)                                         ((0x000000FF&(data))>>0)
+#define SB0_CHANNEL_REQ_BUSY_get_index(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define SB0_MISC_CTRL                                                                0x1801C410
+#define SB0_MISC_CTRL_reg_addr                                                       "0xB801C410"
+#define SB0_MISC_CTRL_reg                                                            0xB801C410
+#define set_SB0_MISC_CTRL_reg(data)   (*((volatile unsigned int*) SB0_MISC_CTRL_reg)=data)
+#define get_SB0_MISC_CTRL_reg   (*((volatile unsigned int*) SB0_MISC_CTRL_reg))
+#define SB0_MISC_CTRL_inst_adr                                                       "0x0004"
+#define SB0_MISC_CTRL_inst                                                           0x0004
+#define SB0_MISC_CTRL_allow_cmd_cnt_shift                                            (0)
+#define SB0_MISC_CTRL_allow_cmd_cnt_mask                                             (0x00000007)
+#define SB0_MISC_CTRL_allow_cmd_cnt(data)                                            (0x00000007&((data)<<0))
+#define SB0_MISC_CTRL_allow_cmd_cnt_src(data)                                        ((0x00000007&(data))>>0)
+#define SB0_MISC_CTRL_get_allow_cmd_cnt(data)                                        ((0x00000007&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sd_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sd_reg.h
new file mode 100644
index 00000000..49c5ee2
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sd_reg.h
@@ -0,0 +1,1049 @@
+/**************************************************************
+// Spec Version                  : 0.8
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/7/31 14:4:24
+***************************************************************/
+
+
+#ifndef _SD_REG_H_INCLUDED_
+#define _SD_REG_H_INCLUDED_
+#ifdef  _SD_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     map_sel:1;
+unsigned int     access_en:1;
+unsigned int     mem_region:4;
+}SD_SRAM_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     dram_sa:28;
+}SD_DMA_CTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     dma_len:16;
+}SD_DMA_CTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     dat64_sel:1;
+unsigned int     rsp17_sel:1;
+unsigned int     reserved_1:2;
+unsigned int     ddr_wr:1;
+unsigned int     dma_xfer:1;
+}SD_DMA_CTL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mcu_pp_sram_lp_ena:1;
+unsigned int     sys_clk_gate_ena:1;
+unsigned int     cp_clk_gate_ena:1;
+unsigned int     dma_sram_lp_ena:1;
+unsigned int     dma_sram_rdy_num:4;
+}SD_SYS_LOW_PWR;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     Int4:1;
+unsigned int     reserved_1:1;
+unsigned int     Int2:1;
+unsigned int     Int1:1;
+unsigned int     write_data:1;
+}SD_SD_ISR;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     reserved_1:4;
+unsigned int     Int4En:1;
+unsigned int     reserved_2:1;
+unsigned int     Int2En:1;
+unsigned int     Int1En:1;
+unsigned int     write_data:1;
+}SD_SD_ISREN;
+
+typedef struct 
+{
+unsigned int     dmy:32;
+}SD_DUMMY_SYS;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     write_enable4:1;
+unsigned int     cr_dbg_sel:2;
+unsigned int     write_enable3:1;
+unsigned int     sel1:3;
+unsigned int     write_enable2:1;
+unsigned int     sel0:3;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}SD_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     bist_cr_ppb_rme_1:1;
+unsigned int     bist_cr_ppb_rm_1:4;
+unsigned int     bist_cr_ppb_rme_0:1;
+unsigned int     bist_cr_ppb_rm_0:4;
+unsigned int     bist_clk_en:1;
+unsigned int     bist_drf_test_resume:1;
+unsigned int     bist_drf_mode:1;
+unsigned int     bist_en:1;
+unsigned int     bist_rstn:1;
+}SD_IP_BIST_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     bist_drf_start_pause:1;
+unsigned int     bist_drf_fail_1:1;
+unsigned int     bist_drf_fail_0:1;
+unsigned int     bist_drf_done:1;
+unsigned int     bist_1_fail:1;
+unsigned int     bist_0_fail:1;
+unsigned int     bist_done:1;
+}SD_IP_BIST_STS;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     cr_bist2_rme_1:1;
+unsigned int     cr_bist2_rm_1:4;
+unsigned int     cr_bist2_rme_0:1;
+unsigned int     cr_bist2_rm_0:4;
+unsigned int     cr_bist2_drf_test_resume:1;
+unsigned int     cr_drf_bist2_mode:1;
+unsigned int     cr_bist2_mode:1;
+unsigned int     cr_bist2_rstn:1;
+}SD_BIST_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     drf_bist2_fail_3:1;
+unsigned int     drf_bist2_fail_2:1;
+unsigned int     drf_bist2_fail_1:1;
+unsigned int     drf_bist2_fail_0:1;
+unsigned int     bist2_drf_start_pause:1;
+unsigned int     drf_bist2_done:1;
+unsigned int     reserved_1:11;
+unsigned int     bist2_fail_3:1;
+unsigned int     bist2_fail_2:1;
+unsigned int     bist2_fail_1:1;
+unsigned int     bist2_fail_0:1;
+unsigned int     bist2_done:1;
+}SD_BIST_STS;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     asic_crc_dbgo_sel:8;
+unsigned int     reserved_1:1;
+unsigned int     crc_dbgo_sel:4;
+unsigned int     ip_ea_flash:1;
+unsigned int     crc_clk_disable_trig:1;
+unsigned int     mcu_time_1_us:1;
+}SD_IP_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     tune3318:1;
+}SD_PAD_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     sd30_sample_change:1;
+unsigned int     sd30_push_change:1;
+unsigned int     crc_clk_change:1;
+unsigned int     reserved_1:2;
+unsigned int     sd30_sample_clk_src:2;
+unsigned int     reserved_2:2;
+unsigned int     sd30_push_clk_src:2;
+unsigned int     reserved_3:2;
+unsigned int     crc_clk_src:2;
+unsigned int     reserved_4:1;
+unsigned int     clk_div:3;
+}SD_CKGEN_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     bist_dbus_buf_rme:1;
+unsigned int     bist_dbus_buf_rm:4;
+unsigned int     bist_clk_en:1;
+unsigned int     bist_drf_test_resume:1;
+unsigned int     bist_drf_mode:1;
+unsigned int     bist_en:1;
+}SD_SDIO_BIST_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     bist_drf_start_pause:1;
+unsigned int     bist_drf_fail_1:1;
+unsigned int     bist_drf_fail_0:1;
+unsigned int     bist_drf_done:1;
+unsigned int     bist_1_fail:1;
+unsigned int     bist_0_fail:1;
+unsigned int     bist_done:1;
+}SD_SDIO_BIST_STS;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     bist_ring_buf_rme_0:1;
+unsigned int     bist_ring_buf_rm_0:4;
+unsigned int     bist_clk_en:1;
+unsigned int     bist_drf_test_resume:1;
+unsigned int     bist_drf_mode:1;
+unsigned int     bist_en:1;
+}SD_SDIO_IP_BIST_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     bist_drf_start_pause:1;
+unsigned int     bist_drf_fail:1;
+unsigned int     bist_drf_done:1;
+unsigned int     bist_fail:1;
+unsigned int     bist_done:1;
+}SD_SDIO_IP_BIST_STS;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     sensor_clk_en:1;
+unsigned int     speed_en:1;
+unsigned int     daya_in:20;
+unsigned int     wire_sel:1;
+unsigned int     ro_sel:3;
+unsigned int     rstn:1;
+}SD_SPEED_SENSOR_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     count_out:20;
+unsigned int     ready:1;
+}SD_SPEED_SENSOR_OUT1;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     dbgo:16;
+unsigned int     wsort_go:1;
+}SD_SPEED_SENSOR_OUT2;
+
+#endif
+
+#define SD_SRAM_CTL                                                                  0x18010400
+#define SD_SRAM_CTL_reg_addr                                                         "0xB8010400"
+#define SD_SRAM_CTL_reg                                                              0xB8010400
+#define set_SD_SRAM_CTL_reg(data)   (*((volatile unsigned int*) SD_SRAM_CTL_reg)=data)
+#define get_SD_SRAM_CTL_reg   (*((volatile unsigned int*) SD_SRAM_CTL_reg))
+#define SD_SRAM_CTL_inst_adr                                                         "0x0000"
+#define SD_SRAM_CTL_inst                                                             0x0000
+#define SD_SRAM_CTL_map_sel_shift                                                    (5)
+#define SD_SRAM_CTL_map_sel_mask                                                     (0x00000020)
+#define SD_SRAM_CTL_map_sel(data)                                                    (0x00000020&((data)<<5))
+#define SD_SRAM_CTL_map_sel_src(data)                                                ((0x00000020&(data))>>5)
+#define SD_SRAM_CTL_get_map_sel(data)                                                ((0x00000020&(data))>>5)
+#define SD_SRAM_CTL_access_en_shift                                                  (4)
+#define SD_SRAM_CTL_access_en_mask                                                   (0x00000010)
+#define SD_SRAM_CTL_access_en(data)                                                  (0x00000010&((data)<<4))
+#define SD_SRAM_CTL_access_en_src(data)                                              ((0x00000010&(data))>>4)
+#define SD_SRAM_CTL_get_access_en(data)                                              ((0x00000010&(data))>>4)
+#define SD_SRAM_CTL_mem_region_shift                                                 (0)
+#define SD_SRAM_CTL_mem_region_mask                                                  (0x0000000F)
+#define SD_SRAM_CTL_mem_region(data)                                                 (0x0000000F&((data)<<0))
+#define SD_SRAM_CTL_mem_region_src(data)                                             ((0x0000000F&(data))>>0)
+#define SD_SRAM_CTL_get_mem_region(data)                                             ((0x0000000F&(data))>>0)
+
+
+#define SD_DMA_CTL1                                                                  0x18010404
+#define SD_DMA_CTL1_reg_addr                                                         "0xB8010404"
+#define SD_DMA_CTL1_reg                                                              0xB8010404
+#define set_SD_DMA_CTL1_reg(data)   (*((volatile unsigned int*) SD_DMA_CTL1_reg)=data)
+#define get_SD_DMA_CTL1_reg   (*((volatile unsigned int*) SD_DMA_CTL1_reg))
+#define SD_DMA_CTL1_inst_adr                                                         "0x0001"
+#define SD_DMA_CTL1_inst                                                             0x0001
+#define SD_DMA_CTL1_dram_sa_shift                                                    (0)
+#define SD_DMA_CTL1_dram_sa_mask                                                     (0x0FFFFFFF)
+#define SD_DMA_CTL1_dram_sa(data)                                                    (0x0FFFFFFF&((data)<<0))
+#define SD_DMA_CTL1_dram_sa_src(data)                                                ((0x0FFFFFFF&(data))>>0)
+#define SD_DMA_CTL1_get_dram_sa(data)                                                ((0x0FFFFFFF&(data))>>0)
+
+
+#define SD_DMA_CTL2                                                                  0x18010408
+#define SD_DMA_CTL2_reg_addr                                                         "0xB8010408"
+#define SD_DMA_CTL2_reg                                                              0xB8010408
+#define set_SD_DMA_CTL2_reg(data)   (*((volatile unsigned int*) SD_DMA_CTL2_reg)=data)
+#define get_SD_DMA_CTL2_reg   (*((volatile unsigned int*) SD_DMA_CTL2_reg))
+#define SD_DMA_CTL2_inst_adr                                                         "0x0002"
+#define SD_DMA_CTL2_inst                                                             0x0002
+#define SD_DMA_CTL2_dma_len_shift                                                    (0)
+#define SD_DMA_CTL2_dma_len_mask                                                     (0x0000FFFF)
+#define SD_DMA_CTL2_dma_len(data)                                                    (0x0000FFFF&((data)<<0))
+#define SD_DMA_CTL2_dma_len_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define SD_DMA_CTL2_get_dma_len(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define SD_DMA_CTL3                                                                  0x1801040C
+#define SD_DMA_CTL3_reg_addr                                                         "0xB801040C"
+#define SD_DMA_CTL3_reg                                                              0xB801040C
+#define set_SD_DMA_CTL3_reg(data)   (*((volatile unsigned int*) SD_DMA_CTL3_reg)=data)
+#define get_SD_DMA_CTL3_reg   (*((volatile unsigned int*) SD_DMA_CTL3_reg))
+#define SD_DMA_CTL3_inst_adr                                                         "0x0003"
+#define SD_DMA_CTL3_inst                                                             0x0003
+#define SD_DMA_CTL3_dat64_sel_shift                                                  (5)
+#define SD_DMA_CTL3_dat64_sel_mask                                                   (0x00000020)
+#define SD_DMA_CTL3_dat64_sel(data)                                                  (0x00000020&((data)<<5))
+#define SD_DMA_CTL3_dat64_sel_src(data)                                              ((0x00000020&(data))>>5)
+#define SD_DMA_CTL3_get_dat64_sel(data)                                              ((0x00000020&(data))>>5)
+#define SD_DMA_CTL3_rsp17_sel_shift                                                  (4)
+#define SD_DMA_CTL3_rsp17_sel_mask                                                   (0x00000010)
+#define SD_DMA_CTL3_rsp17_sel(data)                                                  (0x00000010&((data)<<4))
+#define SD_DMA_CTL3_rsp17_sel_src(data)                                              ((0x00000010&(data))>>4)
+#define SD_DMA_CTL3_get_rsp17_sel(data)                                              ((0x00000010&(data))>>4)
+#define SD_DMA_CTL3_ddr_wr_shift                                                     (1)
+#define SD_DMA_CTL3_ddr_wr_mask                                                      (0x00000002)
+#define SD_DMA_CTL3_ddr_wr(data)                                                     (0x00000002&((data)<<1))
+#define SD_DMA_CTL3_ddr_wr_src(data)                                                 ((0x00000002&(data))>>1)
+#define SD_DMA_CTL3_get_ddr_wr(data)                                                 ((0x00000002&(data))>>1)
+#define SD_DMA_CTL3_dma_xfer_shift                                                   (0)
+#define SD_DMA_CTL3_dma_xfer_mask                                                    (0x00000001)
+#define SD_DMA_CTL3_dma_xfer(data)                                                   (0x00000001&((data)<<0))
+#define SD_DMA_CTL3_dma_xfer_src(data)                                               ((0x00000001&(data))>>0)
+#define SD_DMA_CTL3_get_dma_xfer(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SD_SYS_LOW_PWR                                                               0x18010410
+#define SD_SYS_LOW_PWR_reg_addr                                                      "0xB8010410"
+#define SD_SYS_LOW_PWR_reg                                                           0xB8010410
+#define set_SD_SYS_LOW_PWR_reg(data)   (*((volatile unsigned int*) SD_SYS_LOW_PWR_reg)=data)
+#define get_SD_SYS_LOW_PWR_reg   (*((volatile unsigned int*) SD_SYS_LOW_PWR_reg))
+#define SD_SYS_LOW_PWR_inst_adr                                                      "0x0004"
+#define SD_SYS_LOW_PWR_inst                                                          0x0004
+#define SD_SYS_LOW_PWR_mcu_pp_sram_lp_ena_shift                                      (7)
+#define SD_SYS_LOW_PWR_mcu_pp_sram_lp_ena_mask                                       (0x00000080)
+#define SD_SYS_LOW_PWR_mcu_pp_sram_lp_ena(data)                                      (0x00000080&((data)<<7))
+#define SD_SYS_LOW_PWR_mcu_pp_sram_lp_ena_src(data)                                  ((0x00000080&(data))>>7)
+#define SD_SYS_LOW_PWR_get_mcu_pp_sram_lp_ena(data)                                  ((0x00000080&(data))>>7)
+#define SD_SYS_LOW_PWR_sys_clk_gate_ena_shift                                        (6)
+#define SD_SYS_LOW_PWR_sys_clk_gate_ena_mask                                         (0x00000040)
+#define SD_SYS_LOW_PWR_sys_clk_gate_ena(data)                                        (0x00000040&((data)<<6))
+#define SD_SYS_LOW_PWR_sys_clk_gate_ena_src(data)                                    ((0x00000040&(data))>>6)
+#define SD_SYS_LOW_PWR_get_sys_clk_gate_ena(data)                                    ((0x00000040&(data))>>6)
+#define SD_SYS_LOW_PWR_cp_clk_gate_ena_shift                                         (5)
+#define SD_SYS_LOW_PWR_cp_clk_gate_ena_mask                                          (0x00000020)
+#define SD_SYS_LOW_PWR_cp_clk_gate_ena(data)                                         (0x00000020&((data)<<5))
+#define SD_SYS_LOW_PWR_cp_clk_gate_ena_src(data)                                     ((0x00000020&(data))>>5)
+#define SD_SYS_LOW_PWR_get_cp_clk_gate_ena(data)                                     ((0x00000020&(data))>>5)
+#define SD_SYS_LOW_PWR_dma_sram_lp_ena_shift                                         (4)
+#define SD_SYS_LOW_PWR_dma_sram_lp_ena_mask                                          (0x00000010)
+#define SD_SYS_LOW_PWR_dma_sram_lp_ena(data)                                         (0x00000010&((data)<<4))
+#define SD_SYS_LOW_PWR_dma_sram_lp_ena_src(data)                                     ((0x00000010&(data))>>4)
+#define SD_SYS_LOW_PWR_get_dma_sram_lp_ena(data)                                     ((0x00000010&(data))>>4)
+#define SD_SYS_LOW_PWR_dma_sram_rdy_num_shift                                        (0)
+#define SD_SYS_LOW_PWR_dma_sram_rdy_num_mask                                         (0x0000000F)
+#define SD_SYS_LOW_PWR_dma_sram_rdy_num(data)                                        (0x0000000F&((data)<<0))
+#define SD_SYS_LOW_PWR_dma_sram_rdy_num_src(data)                                    ((0x0000000F&(data))>>0)
+#define SD_SYS_LOW_PWR_get_dma_sram_rdy_num(data)                                    ((0x0000000F&(data))>>0)
+
+
+#define SD_SD_ISR                                                                    0x18010424
+#define SD_SD_ISR_reg_addr                                                           "0xB8010424"
+#define SD_SD_ISR_reg                                                                0xB8010424
+#define set_SD_SD_ISR_reg(data)   (*((volatile unsigned int*) SD_SD_ISR_reg)=data)
+#define get_SD_SD_ISR_reg   (*((volatile unsigned int*) SD_SD_ISR_reg))
+#define SD_SD_ISR_inst_adr                                                           "0x0009"
+#define SD_SD_ISR_inst                                                               0x0009
+#define SD_SD_ISR_Int4_shift                                                         (4)
+#define SD_SD_ISR_Int4_mask                                                          (0x00000010)
+#define SD_SD_ISR_Int4(data)                                                         (0x00000010&((data)<<4))
+#define SD_SD_ISR_Int4_src(data)                                                     ((0x00000010&(data))>>4)
+#define SD_SD_ISR_get_Int4(data)                                                     ((0x00000010&(data))>>4)
+#define SD_SD_ISR_Int2_shift                                                         (2)
+#define SD_SD_ISR_Int2_mask                                                          (0x00000004)
+#define SD_SD_ISR_Int2(data)                                                         (0x00000004&((data)<<2))
+#define SD_SD_ISR_Int2_src(data)                                                     ((0x00000004&(data))>>2)
+#define SD_SD_ISR_get_Int2(data)                                                     ((0x00000004&(data))>>2)
+#define SD_SD_ISR_Int1_shift                                                         (1)
+#define SD_SD_ISR_Int1_mask                                                          (0x00000002)
+#define SD_SD_ISR_Int1(data)                                                         (0x00000002&((data)<<1))
+#define SD_SD_ISR_Int1_src(data)                                                     ((0x00000002&(data))>>1)
+#define SD_SD_ISR_get_Int1(data)                                                     ((0x00000002&(data))>>1)
+#define SD_SD_ISR_write_data_shift                                                   (0)
+#define SD_SD_ISR_write_data_mask                                                    (0x00000001)
+#define SD_SD_ISR_write_data(data)                                                   (0x00000001&((data)<<0))
+#define SD_SD_ISR_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define SD_SD_ISR_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SD_SD_ISREN                                                                  0x18010428
+#define SD_SD_ISREN_reg_addr                                                         "0xB8010428"
+#define SD_SD_ISREN_reg                                                              0xB8010428
+#define set_SD_SD_ISREN_reg(data)   (*((volatile unsigned int*) SD_SD_ISREN_reg)=data)
+#define get_SD_SD_ISREN_reg   (*((volatile unsigned int*) SD_SD_ISREN_reg))
+#define SD_SD_ISREN_inst_adr                                                         "0x000A"
+#define SD_SD_ISREN_inst                                                             0x000A
+#define SD_SD_ISREN_Int4En_shift                                                     (4)
+#define SD_SD_ISREN_Int4En_mask                                                      (0x00000010)
+#define SD_SD_ISREN_Int4En(data)                                                     (0x00000010&((data)<<4))
+#define SD_SD_ISREN_Int4En_src(data)                                                 ((0x00000010&(data))>>4)
+#define SD_SD_ISREN_get_Int4En(data)                                                 ((0x00000010&(data))>>4)
+#define SD_SD_ISREN_Int2En_shift                                                     (2)
+#define SD_SD_ISREN_Int2En_mask                                                      (0x00000004)
+#define SD_SD_ISREN_Int2En(data)                                                     (0x00000004&((data)<<2))
+#define SD_SD_ISREN_Int2En_src(data)                                                 ((0x00000004&(data))>>2)
+#define SD_SD_ISREN_get_Int2En(data)                                                 ((0x00000004&(data))>>2)
+#define SD_SD_ISREN_Int1En_shift                                                     (1)
+#define SD_SD_ISREN_Int1En_mask                                                      (0x00000002)
+#define SD_SD_ISREN_Int1En(data)                                                     (0x00000002&((data)<<1))
+#define SD_SD_ISREN_Int1En_src(data)                                                 ((0x00000002&(data))>>1)
+#define SD_SD_ISREN_get_Int1En(data)                                                 ((0x00000002&(data))>>1)
+#define SD_SD_ISREN_write_data_shift                                                 (0)
+#define SD_SD_ISREN_write_data_mask                                                  (0x00000001)
+#define SD_SD_ISREN_write_data(data)                                                 (0x00000001&((data)<<0))
+#define SD_SD_ISREN_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define SD_SD_ISREN_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SD_DUMMY_SYS                                                                 0x1801042C
+#define SD_DUMMY_SYS_reg_addr                                                        "0xB801042C"
+#define SD_DUMMY_SYS_reg                                                             0xB801042C
+#define set_SD_DUMMY_SYS_reg(data)   (*((volatile unsigned int*) SD_DUMMY_SYS_reg)=data)
+#define get_SD_DUMMY_SYS_reg   (*((volatile unsigned int*) SD_DUMMY_SYS_reg))
+#define SD_DUMMY_SYS_inst_adr                                                        "0x000B"
+#define SD_DUMMY_SYS_inst                                                            0x000B
+#define SD_DUMMY_SYS_dmy_shift                                                       (0)
+#define SD_DUMMY_SYS_dmy_mask                                                        (0xFFFFFFFF)
+#define SD_DUMMY_SYS_dmy(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define SD_DUMMY_SYS_dmy_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define SD_DUMMY_SYS_get_dmy(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define SD_DBG                                                                       0x18010444
+#define SD_DBG_reg_addr                                                              "0xB8010444"
+#define SD_DBG_reg                                                                   0xB8010444
+#define set_SD_DBG_reg(data)   (*((volatile unsigned int*) SD_DBG_reg)=data)
+#define get_SD_DBG_reg   (*((volatile unsigned int*) SD_DBG_reg))
+#define SD_DBG_inst_adr                                                              "0x0011"
+#define SD_DBG_inst                                                                  0x0011
+#define SD_DBG_write_enable4_shift                                                   (12)
+#define SD_DBG_write_enable4_mask                                                    (0x00001000)
+#define SD_DBG_write_enable4(data)                                                   (0x00001000&((data)<<12))
+#define SD_DBG_write_enable4_src(data)                                               ((0x00001000&(data))>>12)
+#define SD_DBG_get_write_enable4(data)                                               ((0x00001000&(data))>>12)
+#define SD_DBG_cr_dbg_sel_shift                                                      (10)
+#define SD_DBG_cr_dbg_sel_mask                                                       (0x00000C00)
+#define SD_DBG_cr_dbg_sel(data)                                                      (0x00000C00&((data)<<10))
+#define SD_DBG_cr_dbg_sel_src(data)                                                  ((0x00000C00&(data))>>10)
+#define SD_DBG_get_cr_dbg_sel(data)                                                  ((0x00000C00&(data))>>10)
+#define SD_DBG_write_enable3_shift                                                   (9)
+#define SD_DBG_write_enable3_mask                                                    (0x00000200)
+#define SD_DBG_write_enable3(data)                                                   (0x00000200&((data)<<9))
+#define SD_DBG_write_enable3_src(data)                                               ((0x00000200&(data))>>9)
+#define SD_DBG_get_write_enable3(data)                                               ((0x00000200&(data))>>9)
+#define SD_DBG_sel1_shift                                                            (6)
+#define SD_DBG_sel1_mask                                                             (0x000001C0)
+#define SD_DBG_sel1(data)                                                            (0x000001C0&((data)<<6))
+#define SD_DBG_sel1_src(data)                                                        ((0x000001C0&(data))>>6)
+#define SD_DBG_get_sel1(data)                                                        ((0x000001C0&(data))>>6)
+#define SD_DBG_write_enable2_shift                                                   (5)
+#define SD_DBG_write_enable2_mask                                                    (0x00000020)
+#define SD_DBG_write_enable2(data)                                                   (0x00000020&((data)<<5))
+#define SD_DBG_write_enable2_src(data)                                               ((0x00000020&(data))>>5)
+#define SD_DBG_get_write_enable2(data)                                               ((0x00000020&(data))>>5)
+#define SD_DBG_sel0_shift                                                            (2)
+#define SD_DBG_sel0_mask                                                             (0x0000001C)
+#define SD_DBG_sel0(data)                                                            (0x0000001C&((data)<<2))
+#define SD_DBG_sel0_src(data)                                                        ((0x0000001C&(data))>>2)
+#define SD_DBG_get_sel0(data)                                                        ((0x0000001C&(data))>>2)
+#define SD_DBG_write_enable1_shift                                                   (1)
+#define SD_DBG_write_enable1_mask                                                    (0x00000002)
+#define SD_DBG_write_enable1(data)                                                   (0x00000002&((data)<<1))
+#define SD_DBG_write_enable1_src(data)                                               ((0x00000002&(data))>>1)
+#define SD_DBG_get_write_enable1(data)                                               ((0x00000002&(data))>>1)
+#define SD_DBG_enable_shift                                                          (0)
+#define SD_DBG_enable_mask                                                           (0x00000001)
+#define SD_DBG_enable(data)                                                          (0x00000001&((data)<<0))
+#define SD_DBG_enable_src(data)                                                      ((0x00000001&(data))>>0)
+#define SD_DBG_get_enable(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define SD_IP_BIST_CTL                                                               0x18010460
+#define SD_IP_BIST_CTL_reg_addr                                                      "0xB8010460"
+#define SD_IP_BIST_CTL_reg                                                           0xB8010460
+#define set_SD_IP_BIST_CTL_reg(data)   (*((volatile unsigned int*) SD_IP_BIST_CTL_reg)=data)
+#define get_SD_IP_BIST_CTL_reg   (*((volatile unsigned int*) SD_IP_BIST_CTL_reg))
+#define SD_IP_BIST_CTL_inst_adr                                                      "0x0018"
+#define SD_IP_BIST_CTL_inst                                                          0x0018
+#define SD_IP_BIST_CTL_bist_cr_ppb_rme_1_shift                                       (14)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rme_1_mask                                        (0x00004000)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rme_1(data)                                       (0x00004000&((data)<<14))
+#define SD_IP_BIST_CTL_bist_cr_ppb_rme_1_src(data)                                   ((0x00004000&(data))>>14)
+#define SD_IP_BIST_CTL_get_bist_cr_ppb_rme_1(data)                                   ((0x00004000&(data))>>14)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rm_1_shift                                        (10)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rm_1_mask                                         (0x00003C00)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rm_1(data)                                        (0x00003C00&((data)<<10))
+#define SD_IP_BIST_CTL_bist_cr_ppb_rm_1_src(data)                                    ((0x00003C00&(data))>>10)
+#define SD_IP_BIST_CTL_get_bist_cr_ppb_rm_1(data)                                    ((0x00003C00&(data))>>10)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rme_0_shift                                       (9)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rme_0_mask                                        (0x00000200)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rme_0(data)                                       (0x00000200&((data)<<9))
+#define SD_IP_BIST_CTL_bist_cr_ppb_rme_0_src(data)                                   ((0x00000200&(data))>>9)
+#define SD_IP_BIST_CTL_get_bist_cr_ppb_rme_0(data)                                   ((0x00000200&(data))>>9)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rm_0_shift                                        (5)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rm_0_mask                                         (0x000001E0)
+#define SD_IP_BIST_CTL_bist_cr_ppb_rm_0(data)                                        (0x000001E0&((data)<<5))
+#define SD_IP_BIST_CTL_bist_cr_ppb_rm_0_src(data)                                    ((0x000001E0&(data))>>5)
+#define SD_IP_BIST_CTL_get_bist_cr_ppb_rm_0(data)                                    ((0x000001E0&(data))>>5)
+#define SD_IP_BIST_CTL_bist_clk_en_shift                                             (4)
+#define SD_IP_BIST_CTL_bist_clk_en_mask                                              (0x00000010)
+#define SD_IP_BIST_CTL_bist_clk_en(data)                                             (0x00000010&((data)<<4))
+#define SD_IP_BIST_CTL_bist_clk_en_src(data)                                         ((0x00000010&(data))>>4)
+#define SD_IP_BIST_CTL_get_bist_clk_en(data)                                         ((0x00000010&(data))>>4)
+#define SD_IP_BIST_CTL_bist_drf_test_resume_shift                                    (3)
+#define SD_IP_BIST_CTL_bist_drf_test_resume_mask                                     (0x00000008)
+#define SD_IP_BIST_CTL_bist_drf_test_resume(data)                                    (0x00000008&((data)<<3))
+#define SD_IP_BIST_CTL_bist_drf_test_resume_src(data)                                ((0x00000008&(data))>>3)
+#define SD_IP_BIST_CTL_get_bist_drf_test_resume(data)                                ((0x00000008&(data))>>3)
+#define SD_IP_BIST_CTL_bist_drf_mode_shift                                           (2)
+#define SD_IP_BIST_CTL_bist_drf_mode_mask                                            (0x00000004)
+#define SD_IP_BIST_CTL_bist_drf_mode(data)                                           (0x00000004&((data)<<2))
+#define SD_IP_BIST_CTL_bist_drf_mode_src(data)                                       ((0x00000004&(data))>>2)
+#define SD_IP_BIST_CTL_get_bist_drf_mode(data)                                       ((0x00000004&(data))>>2)
+#define SD_IP_BIST_CTL_bist_en_shift                                                 (1)
+#define SD_IP_BIST_CTL_bist_en_mask                                                  (0x00000002)
+#define SD_IP_BIST_CTL_bist_en(data)                                                 (0x00000002&((data)<<1))
+#define SD_IP_BIST_CTL_bist_en_src(data)                                             ((0x00000002&(data))>>1)
+#define SD_IP_BIST_CTL_get_bist_en(data)                                             ((0x00000002&(data))>>1)
+#define SD_IP_BIST_CTL_bist_rstn_shift                                               (0)
+#define SD_IP_BIST_CTL_bist_rstn_mask                                                (0x00000001)
+#define SD_IP_BIST_CTL_bist_rstn(data)                                               (0x00000001&((data)<<0))
+#define SD_IP_BIST_CTL_bist_rstn_src(data)                                           ((0x00000001&(data))>>0)
+#define SD_IP_BIST_CTL_get_bist_rstn(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SD_IP_BIST_STS                                                               0x18010464
+#define SD_IP_BIST_STS_reg_addr                                                      "0xB8010464"
+#define SD_IP_BIST_STS_reg                                                           0xB8010464
+#define set_SD_IP_BIST_STS_reg(data)   (*((volatile unsigned int*) SD_IP_BIST_STS_reg)=data)
+#define get_SD_IP_BIST_STS_reg   (*((volatile unsigned int*) SD_IP_BIST_STS_reg))
+#define SD_IP_BIST_STS_inst_adr                                                      "0x0019"
+#define SD_IP_BIST_STS_inst                                                          0x0019
+#define SD_IP_BIST_STS_bist_drf_start_pause_shift                                    (6)
+#define SD_IP_BIST_STS_bist_drf_start_pause_mask                                     (0x00000040)
+#define SD_IP_BIST_STS_bist_drf_start_pause(data)                                    (0x00000040&((data)<<6))
+#define SD_IP_BIST_STS_bist_drf_start_pause_src(data)                                ((0x00000040&(data))>>6)
+#define SD_IP_BIST_STS_get_bist_drf_start_pause(data)                                ((0x00000040&(data))>>6)
+#define SD_IP_BIST_STS_bist_drf_fail_1_shift                                         (5)
+#define SD_IP_BIST_STS_bist_drf_fail_1_mask                                          (0x00000020)
+#define SD_IP_BIST_STS_bist_drf_fail_1(data)                                         (0x00000020&((data)<<5))
+#define SD_IP_BIST_STS_bist_drf_fail_1_src(data)                                     ((0x00000020&(data))>>5)
+#define SD_IP_BIST_STS_get_bist_drf_fail_1(data)                                     ((0x00000020&(data))>>5)
+#define SD_IP_BIST_STS_bist_drf_fail_0_shift                                         (4)
+#define SD_IP_BIST_STS_bist_drf_fail_0_mask                                          (0x00000010)
+#define SD_IP_BIST_STS_bist_drf_fail_0(data)                                         (0x00000010&((data)<<4))
+#define SD_IP_BIST_STS_bist_drf_fail_0_src(data)                                     ((0x00000010&(data))>>4)
+#define SD_IP_BIST_STS_get_bist_drf_fail_0(data)                                     ((0x00000010&(data))>>4)
+#define SD_IP_BIST_STS_bist_drf_done_shift                                           (3)
+#define SD_IP_BIST_STS_bist_drf_done_mask                                            (0x00000008)
+#define SD_IP_BIST_STS_bist_drf_done(data)                                           (0x00000008&((data)<<3))
+#define SD_IP_BIST_STS_bist_drf_done_src(data)                                       ((0x00000008&(data))>>3)
+#define SD_IP_BIST_STS_get_bist_drf_done(data)                                       ((0x00000008&(data))>>3)
+#define SD_IP_BIST_STS_bist_1_fail_shift                                             (2)
+#define SD_IP_BIST_STS_bist_1_fail_mask                                              (0x00000004)
+#define SD_IP_BIST_STS_bist_1_fail(data)                                             (0x00000004&((data)<<2))
+#define SD_IP_BIST_STS_bist_1_fail_src(data)                                         ((0x00000004&(data))>>2)
+#define SD_IP_BIST_STS_get_bist_1_fail(data)                                         ((0x00000004&(data))>>2)
+#define SD_IP_BIST_STS_bist_0_fail_shift                                             (1)
+#define SD_IP_BIST_STS_bist_0_fail_mask                                              (0x00000002)
+#define SD_IP_BIST_STS_bist_0_fail(data)                                             (0x00000002&((data)<<1))
+#define SD_IP_BIST_STS_bist_0_fail_src(data)                                         ((0x00000002&(data))>>1)
+#define SD_IP_BIST_STS_get_bist_0_fail(data)                                         ((0x00000002&(data))>>1)
+#define SD_IP_BIST_STS_bist_done_shift                                               (0)
+#define SD_IP_BIST_STS_bist_done_mask                                                (0x00000001)
+#define SD_IP_BIST_STS_bist_done(data)                                               (0x00000001&((data)<<0))
+#define SD_IP_BIST_STS_bist_done_src(data)                                           ((0x00000001&(data))>>0)
+#define SD_IP_BIST_STS_get_bist_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SD_BIST_CTL                                                                  0x18010468
+#define SD_BIST_CTL_reg_addr                                                         "0xB8010468"
+#define SD_BIST_CTL_reg                                                              0xB8010468
+#define set_SD_BIST_CTL_reg(data)   (*((volatile unsigned int*) SD_BIST_CTL_reg)=data)
+#define get_SD_BIST_CTL_reg   (*((volatile unsigned int*) SD_BIST_CTL_reg))
+#define SD_BIST_CTL_inst_adr                                                         "0x001A"
+#define SD_BIST_CTL_inst                                                             0x001A
+#define SD_BIST_CTL_cr_bist2_rme_1_shift                                             (13)
+#define SD_BIST_CTL_cr_bist2_rme_1_mask                                              (0x00002000)
+#define SD_BIST_CTL_cr_bist2_rme_1(data)                                             (0x00002000&((data)<<13))
+#define SD_BIST_CTL_cr_bist2_rme_1_src(data)                                         ((0x00002000&(data))>>13)
+#define SD_BIST_CTL_get_cr_bist2_rme_1(data)                                         ((0x00002000&(data))>>13)
+#define SD_BIST_CTL_cr_bist2_rm_1_shift                                              (9)
+#define SD_BIST_CTL_cr_bist2_rm_1_mask                                               (0x00001E00)
+#define SD_BIST_CTL_cr_bist2_rm_1(data)                                              (0x00001E00&((data)<<9))
+#define SD_BIST_CTL_cr_bist2_rm_1_src(data)                                          ((0x00001E00&(data))>>9)
+#define SD_BIST_CTL_get_cr_bist2_rm_1(data)                                          ((0x00001E00&(data))>>9)
+#define SD_BIST_CTL_cr_bist2_rme_0_shift                                             (8)
+#define SD_BIST_CTL_cr_bist2_rme_0_mask                                              (0x00000100)
+#define SD_BIST_CTL_cr_bist2_rme_0(data)                                             (0x00000100&((data)<<8))
+#define SD_BIST_CTL_cr_bist2_rme_0_src(data)                                         ((0x00000100&(data))>>8)
+#define SD_BIST_CTL_get_cr_bist2_rme_0(data)                                         ((0x00000100&(data))>>8)
+#define SD_BIST_CTL_cr_bist2_rm_0_shift                                              (4)
+#define SD_BIST_CTL_cr_bist2_rm_0_mask                                               (0x000000F0)
+#define SD_BIST_CTL_cr_bist2_rm_0(data)                                              (0x000000F0&((data)<<4))
+#define SD_BIST_CTL_cr_bist2_rm_0_src(data)                                          ((0x000000F0&(data))>>4)
+#define SD_BIST_CTL_get_cr_bist2_rm_0(data)                                          ((0x000000F0&(data))>>4)
+#define SD_BIST_CTL_cr_bist2_drf_test_resume_shift                                   (3)
+#define SD_BIST_CTL_cr_bist2_drf_test_resume_mask                                    (0x00000008)
+#define SD_BIST_CTL_cr_bist2_drf_test_resume(data)                                   (0x00000008&((data)<<3))
+#define SD_BIST_CTL_cr_bist2_drf_test_resume_src(data)                               ((0x00000008&(data))>>3)
+#define SD_BIST_CTL_get_cr_bist2_drf_test_resume(data)                               ((0x00000008&(data))>>3)
+#define SD_BIST_CTL_cr_drf_bist2_mode_shift                                          (2)
+#define SD_BIST_CTL_cr_drf_bist2_mode_mask                                           (0x00000004)
+#define SD_BIST_CTL_cr_drf_bist2_mode(data)                                          (0x00000004&((data)<<2))
+#define SD_BIST_CTL_cr_drf_bist2_mode_src(data)                                      ((0x00000004&(data))>>2)
+#define SD_BIST_CTL_get_cr_drf_bist2_mode(data)                                      ((0x00000004&(data))>>2)
+#define SD_BIST_CTL_cr_bist2_mode_shift                                              (1)
+#define SD_BIST_CTL_cr_bist2_mode_mask                                               (0x00000002)
+#define SD_BIST_CTL_cr_bist2_mode(data)                                              (0x00000002&((data)<<1))
+#define SD_BIST_CTL_cr_bist2_mode_src(data)                                          ((0x00000002&(data))>>1)
+#define SD_BIST_CTL_get_cr_bist2_mode(data)                                          ((0x00000002&(data))>>1)
+#define SD_BIST_CTL_cr_bist2_rstn_shift                                              (0)
+#define SD_BIST_CTL_cr_bist2_rstn_mask                                               (0x00000001)
+#define SD_BIST_CTL_cr_bist2_rstn(data)                                              (0x00000001&((data)<<0))
+#define SD_BIST_CTL_cr_bist2_rstn_src(data)                                          ((0x00000001&(data))>>0)
+#define SD_BIST_CTL_get_cr_bist2_rstn(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SD_BIST_STS                                                                  0x1801046C
+#define SD_BIST_STS_reg_addr                                                         "0xB801046C"
+#define SD_BIST_STS_reg                                                              0xB801046C
+#define set_SD_BIST_STS_reg(data)   (*((volatile unsigned int*) SD_BIST_STS_reg)=data)
+#define get_SD_BIST_STS_reg   (*((volatile unsigned int*) SD_BIST_STS_reg))
+#define SD_BIST_STS_inst_adr                                                         "0x001B"
+#define SD_BIST_STS_inst                                                             0x001B
+#define SD_BIST_STS_drf_bist2_fail_3_shift                                           (21)
+#define SD_BIST_STS_drf_bist2_fail_3_mask                                            (0x00200000)
+#define SD_BIST_STS_drf_bist2_fail_3(data)                                           (0x00200000&((data)<<21))
+#define SD_BIST_STS_drf_bist2_fail_3_src(data)                                       ((0x00200000&(data))>>21)
+#define SD_BIST_STS_get_drf_bist2_fail_3(data)                                       ((0x00200000&(data))>>21)
+#define SD_BIST_STS_drf_bist2_fail_2_shift                                           (20)
+#define SD_BIST_STS_drf_bist2_fail_2_mask                                            (0x00100000)
+#define SD_BIST_STS_drf_bist2_fail_2(data)                                           (0x00100000&((data)<<20))
+#define SD_BIST_STS_drf_bist2_fail_2_src(data)                                       ((0x00100000&(data))>>20)
+#define SD_BIST_STS_get_drf_bist2_fail_2(data)                                       ((0x00100000&(data))>>20)
+#define SD_BIST_STS_drf_bist2_fail_1_shift                                           (19)
+#define SD_BIST_STS_drf_bist2_fail_1_mask                                            (0x00080000)
+#define SD_BIST_STS_drf_bist2_fail_1(data)                                           (0x00080000&((data)<<19))
+#define SD_BIST_STS_drf_bist2_fail_1_src(data)                                       ((0x00080000&(data))>>19)
+#define SD_BIST_STS_get_drf_bist2_fail_1(data)                                       ((0x00080000&(data))>>19)
+#define SD_BIST_STS_drf_bist2_fail_0_shift                                           (18)
+#define SD_BIST_STS_drf_bist2_fail_0_mask                                            (0x00040000)
+#define SD_BIST_STS_drf_bist2_fail_0(data)                                           (0x00040000&((data)<<18))
+#define SD_BIST_STS_drf_bist2_fail_0_src(data)                                       ((0x00040000&(data))>>18)
+#define SD_BIST_STS_get_drf_bist2_fail_0(data)                                       ((0x00040000&(data))>>18)
+#define SD_BIST_STS_bist2_drf_start_pause_shift                                      (17)
+#define SD_BIST_STS_bist2_drf_start_pause_mask                                       (0x00020000)
+#define SD_BIST_STS_bist2_drf_start_pause(data)                                      (0x00020000&((data)<<17))
+#define SD_BIST_STS_bist2_drf_start_pause_src(data)                                  ((0x00020000&(data))>>17)
+#define SD_BIST_STS_get_bist2_drf_start_pause(data)                                  ((0x00020000&(data))>>17)
+#define SD_BIST_STS_drf_bist2_done_shift                                             (16)
+#define SD_BIST_STS_drf_bist2_done_mask                                              (0x00010000)
+#define SD_BIST_STS_drf_bist2_done(data)                                             (0x00010000&((data)<<16))
+#define SD_BIST_STS_drf_bist2_done_src(data)                                         ((0x00010000&(data))>>16)
+#define SD_BIST_STS_get_drf_bist2_done(data)                                         ((0x00010000&(data))>>16)
+#define SD_BIST_STS_bist2_fail_3_shift                                               (4)
+#define SD_BIST_STS_bist2_fail_3_mask                                                (0x00000010)
+#define SD_BIST_STS_bist2_fail_3(data)                                               (0x00000010&((data)<<4))
+#define SD_BIST_STS_bist2_fail_3_src(data)                                           ((0x00000010&(data))>>4)
+#define SD_BIST_STS_get_bist2_fail_3(data)                                           ((0x00000010&(data))>>4)
+#define SD_BIST_STS_bist2_fail_2_shift                                               (3)
+#define SD_BIST_STS_bist2_fail_2_mask                                                (0x00000008)
+#define SD_BIST_STS_bist2_fail_2(data)                                               (0x00000008&((data)<<3))
+#define SD_BIST_STS_bist2_fail_2_src(data)                                           ((0x00000008&(data))>>3)
+#define SD_BIST_STS_get_bist2_fail_2(data)                                           ((0x00000008&(data))>>3)
+#define SD_BIST_STS_bist2_fail_1_shift                                               (2)
+#define SD_BIST_STS_bist2_fail_1_mask                                                (0x00000004)
+#define SD_BIST_STS_bist2_fail_1(data)                                               (0x00000004&((data)<<2))
+#define SD_BIST_STS_bist2_fail_1_src(data)                                           ((0x00000004&(data))>>2)
+#define SD_BIST_STS_get_bist2_fail_1(data)                                           ((0x00000004&(data))>>2)
+#define SD_BIST_STS_bist2_fail_0_shift                                               (1)
+#define SD_BIST_STS_bist2_fail_0_mask                                                (0x00000002)
+#define SD_BIST_STS_bist2_fail_0(data)                                               (0x00000002&((data)<<1))
+#define SD_BIST_STS_bist2_fail_0_src(data)                                           ((0x00000002&(data))>>1)
+#define SD_BIST_STS_get_bist2_fail_0(data)                                           ((0x00000002&(data))>>1)
+#define SD_BIST_STS_bist2_done_shift                                                 (0)
+#define SD_BIST_STS_bist2_done_mask                                                  (0x00000001)
+#define SD_BIST_STS_bist2_done(data)                                                 (0x00000001&((data)<<0))
+#define SD_BIST_STS_bist2_done_src(data)                                             ((0x00000001&(data))>>0)
+#define SD_BIST_STS_get_bist2_done(data)                                             ((0x00000001&(data))>>0)
+
+
+#define SD_IP_CTL                                                                    0x18010470
+#define SD_IP_CTL_reg_addr                                                           "0xB8010470"
+#define SD_IP_CTL_reg                                                                0xB8010470
+#define set_SD_IP_CTL_reg(data)   (*((volatile unsigned int*) SD_IP_CTL_reg)=data)
+#define get_SD_IP_CTL_reg   (*((volatile unsigned int*) SD_IP_CTL_reg))
+#define SD_IP_CTL_inst_adr                                                           "0x001C"
+#define SD_IP_CTL_inst                                                               0x001C
+#define SD_IP_CTL_asic_crc_dbgo_sel_shift                                            (8)
+#define SD_IP_CTL_asic_crc_dbgo_sel_mask                                             (0x0000FF00)
+#define SD_IP_CTL_asic_crc_dbgo_sel(data)                                            (0x0000FF00&((data)<<8))
+#define SD_IP_CTL_asic_crc_dbgo_sel_src(data)                                        ((0x0000FF00&(data))>>8)
+#define SD_IP_CTL_get_asic_crc_dbgo_sel(data)                                        ((0x0000FF00&(data))>>8)
+#define SD_IP_CTL_crc_dbgo_sel_shift                                                 (3)
+#define SD_IP_CTL_crc_dbgo_sel_mask                                                  (0x00000078)
+#define SD_IP_CTL_crc_dbgo_sel(data)                                                 (0x00000078&((data)<<3))
+#define SD_IP_CTL_crc_dbgo_sel_src(data)                                             ((0x00000078&(data))>>3)
+#define SD_IP_CTL_get_crc_dbgo_sel(data)                                             ((0x00000078&(data))>>3)
+#define SD_IP_CTL_ip_ea_flash_shift                                                  (2)
+#define SD_IP_CTL_ip_ea_flash_mask                                                   (0x00000004)
+#define SD_IP_CTL_ip_ea_flash(data)                                                  (0x00000004&((data)<<2))
+#define SD_IP_CTL_ip_ea_flash_src(data)                                              ((0x00000004&(data))>>2)
+#define SD_IP_CTL_get_ip_ea_flash(data)                                              ((0x00000004&(data))>>2)
+#define SD_IP_CTL_crc_clk_disable_trig_shift                                         (1)
+#define SD_IP_CTL_crc_clk_disable_trig_mask                                          (0x00000002)
+#define SD_IP_CTL_crc_clk_disable_trig(data)                                         (0x00000002&((data)<<1))
+#define SD_IP_CTL_crc_clk_disable_trig_src(data)                                     ((0x00000002&(data))>>1)
+#define SD_IP_CTL_get_crc_clk_disable_trig(data)                                     ((0x00000002&(data))>>1)
+#define SD_IP_CTL_mcu_time_1_us_shift                                                (0)
+#define SD_IP_CTL_mcu_time_1_us_mask                                                 (0x00000001)
+#define SD_IP_CTL_mcu_time_1_us(data)                                                (0x00000001&((data)<<0))
+#define SD_IP_CTL_mcu_time_1_us_src(data)                                            ((0x00000001&(data))>>0)
+#define SD_IP_CTL_get_mcu_time_1_us(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SD_PAD_CTL                                                                   0x18010474
+#define SD_PAD_CTL_reg_addr                                                          "0xB8010474"
+#define SD_PAD_CTL_reg                                                               0xB8010474
+#define set_SD_PAD_CTL_reg(data)   (*((volatile unsigned int*) SD_PAD_CTL_reg)=data)
+#define get_SD_PAD_CTL_reg   (*((volatile unsigned int*) SD_PAD_CTL_reg))
+#define SD_PAD_CTL_inst_adr                                                          "0x001D"
+#define SD_PAD_CTL_inst                                                              0x001D
+#define SD_PAD_CTL_tune3318_shift                                                    (0)
+#define SD_PAD_CTL_tune3318_mask                                                     (0x00000001)
+#define SD_PAD_CTL_tune3318(data)                                                    (0x00000001&((data)<<0))
+#define SD_PAD_CTL_tune3318_src(data)                                                ((0x00000001&(data))>>0)
+#define SD_PAD_CTL_get_tune3318(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SD_CKGEN_CTL                                                                 0x18010478
+#define SD_CKGEN_CTL_reg_addr                                                        "0xB8010478"
+#define SD_CKGEN_CTL_reg                                                             0xB8010478
+#define set_SD_CKGEN_CTL_reg(data)   (*((volatile unsigned int*) SD_CKGEN_CTL_reg)=data)
+#define get_SD_CKGEN_CTL_reg   (*((volatile unsigned int*) SD_CKGEN_CTL_reg))
+#define SD_CKGEN_CTL_inst_adr                                                        "0x001E"
+#define SD_CKGEN_CTL_inst                                                            0x001E
+#define SD_CKGEN_CTL_sd30_sample_change_shift                                        (18)
+#define SD_CKGEN_CTL_sd30_sample_change_mask                                         (0x00040000)
+#define SD_CKGEN_CTL_sd30_sample_change(data)                                        (0x00040000&((data)<<18))
+#define SD_CKGEN_CTL_sd30_sample_change_src(data)                                    ((0x00040000&(data))>>18)
+#define SD_CKGEN_CTL_get_sd30_sample_change(data)                                    ((0x00040000&(data))>>18)
+#define SD_CKGEN_CTL_sd30_push_change_shift                                          (17)
+#define SD_CKGEN_CTL_sd30_push_change_mask                                           (0x00020000)
+#define SD_CKGEN_CTL_sd30_push_change(data)                                          (0x00020000&((data)<<17))
+#define SD_CKGEN_CTL_sd30_push_change_src(data)                                      ((0x00020000&(data))>>17)
+#define SD_CKGEN_CTL_get_sd30_push_change(data)                                      ((0x00020000&(data))>>17)
+#define SD_CKGEN_CTL_crc_clk_change_shift                                            (16)
+#define SD_CKGEN_CTL_crc_clk_change_mask                                             (0x00010000)
+#define SD_CKGEN_CTL_crc_clk_change(data)                                            (0x00010000&((data)<<16))
+#define SD_CKGEN_CTL_crc_clk_change_src(data)                                        ((0x00010000&(data))>>16)
+#define SD_CKGEN_CTL_get_crc_clk_change(data)                                        ((0x00010000&(data))>>16)
+#define SD_CKGEN_CTL_sd30_sample_clk_src_shift                                       (12)
+#define SD_CKGEN_CTL_sd30_sample_clk_src_mask                                        (0x00003000)
+#define SD_CKGEN_CTL_sd30_sample_clk_src(data)                                       (0x00003000&((data)<<12))
+#define SD_CKGEN_CTL_sd30_sample_clk_src_src(data)                                   ((0x00003000&(data))>>12)
+#define SD_CKGEN_CTL_get_sd30_sample_clk_src(data)                                   ((0x00003000&(data))>>12)
+#define SD_CKGEN_CTL_sd30_push_clk_src_shift                                         (8)
+#define SD_CKGEN_CTL_sd30_push_clk_src_mask                                          (0x00000300)
+#define SD_CKGEN_CTL_sd30_push_clk_src(data)                                         (0x00000300&((data)<<8))
+#define SD_CKGEN_CTL_sd30_push_clk_src_src(data)                                     ((0x00000300&(data))>>8)
+#define SD_CKGEN_CTL_get_sd30_push_clk_src(data)                                     ((0x00000300&(data))>>8)
+#define SD_CKGEN_CTL_crc_clk_src_shift                                               (4)
+#define SD_CKGEN_CTL_crc_clk_src_mask                                                (0x00000030)
+#define SD_CKGEN_CTL_crc_clk_src(data)                                               (0x00000030&((data)<<4))
+#define SD_CKGEN_CTL_crc_clk_src_src(data)                                           ((0x00000030&(data))>>4)
+#define SD_CKGEN_CTL_get_crc_clk_src(data)                                           ((0x00000030&(data))>>4)
+#define SD_CKGEN_CTL_clk_div_shift                                                   (0)
+#define SD_CKGEN_CTL_clk_div_mask                                                    (0x00000007)
+#define SD_CKGEN_CTL_clk_div(data)                                                   (0x00000007&((data)<<0))
+#define SD_CKGEN_CTL_clk_div_src(data)                                               ((0x00000007&(data))>>0)
+#define SD_CKGEN_CTL_get_clk_div(data)                                               ((0x00000007&(data))>>0)
+
+
+#define SD_SDIO_BIST_CTL                                                             0x18010480
+#define SD_SDIO_BIST_CTL_reg_addr                                                    "0xB8010480"
+#define SD_SDIO_BIST_CTL_reg                                                         0xB8010480
+#define set_SD_SDIO_BIST_CTL_reg(data)   (*((volatile unsigned int*) SD_SDIO_BIST_CTL_reg)=data)
+#define get_SD_SDIO_BIST_CTL_reg   (*((volatile unsigned int*) SD_SDIO_BIST_CTL_reg))
+#define SD_SDIO_BIST_CTL_inst_adr                                                    "0x0020"
+#define SD_SDIO_BIST_CTL_inst                                                        0x0020
+#define SD_SDIO_BIST_CTL_bist_dbus_buf_rme_shift                                     (8)
+#define SD_SDIO_BIST_CTL_bist_dbus_buf_rme_mask                                      (0x00000100)
+#define SD_SDIO_BIST_CTL_bist_dbus_buf_rme(data)                                     (0x00000100&((data)<<8))
+#define SD_SDIO_BIST_CTL_bist_dbus_buf_rme_src(data)                                 ((0x00000100&(data))>>8)
+#define SD_SDIO_BIST_CTL_get_bist_dbus_buf_rme(data)                                 ((0x00000100&(data))>>8)
+#define SD_SDIO_BIST_CTL_bist_dbus_buf_rm_shift                                      (4)
+#define SD_SDIO_BIST_CTL_bist_dbus_buf_rm_mask                                       (0x000000F0)
+#define SD_SDIO_BIST_CTL_bist_dbus_buf_rm(data)                                      (0x000000F0&((data)<<4))
+#define SD_SDIO_BIST_CTL_bist_dbus_buf_rm_src(data)                                  ((0x000000F0&(data))>>4)
+#define SD_SDIO_BIST_CTL_get_bist_dbus_buf_rm(data)                                  ((0x000000F0&(data))>>4)
+#define SD_SDIO_BIST_CTL_bist_clk_en_shift                                           (3)
+#define SD_SDIO_BIST_CTL_bist_clk_en_mask                                            (0x00000008)
+#define SD_SDIO_BIST_CTL_bist_clk_en(data)                                           (0x00000008&((data)<<3))
+#define SD_SDIO_BIST_CTL_bist_clk_en_src(data)                                       ((0x00000008&(data))>>3)
+#define SD_SDIO_BIST_CTL_get_bist_clk_en(data)                                       ((0x00000008&(data))>>3)
+#define SD_SDIO_BIST_CTL_bist_drf_test_resume_shift                                  (2)
+#define SD_SDIO_BIST_CTL_bist_drf_test_resume_mask                                   (0x00000004)
+#define SD_SDIO_BIST_CTL_bist_drf_test_resume(data)                                  (0x00000004&((data)<<2))
+#define SD_SDIO_BIST_CTL_bist_drf_test_resume_src(data)                              ((0x00000004&(data))>>2)
+#define SD_SDIO_BIST_CTL_get_bist_drf_test_resume(data)                              ((0x00000004&(data))>>2)
+#define SD_SDIO_BIST_CTL_bist_drf_mode_shift                                         (1)
+#define SD_SDIO_BIST_CTL_bist_drf_mode_mask                                          (0x00000002)
+#define SD_SDIO_BIST_CTL_bist_drf_mode(data)                                         (0x00000002&((data)<<1))
+#define SD_SDIO_BIST_CTL_bist_drf_mode_src(data)                                     ((0x00000002&(data))>>1)
+#define SD_SDIO_BIST_CTL_get_bist_drf_mode(data)                                     ((0x00000002&(data))>>1)
+#define SD_SDIO_BIST_CTL_bist_en_shift                                               (0)
+#define SD_SDIO_BIST_CTL_bist_en_mask                                                (0x00000001)
+#define SD_SDIO_BIST_CTL_bist_en(data)                                               (0x00000001&((data)<<0))
+#define SD_SDIO_BIST_CTL_bist_en_src(data)                                           ((0x00000001&(data))>>0)
+#define SD_SDIO_BIST_CTL_get_bist_en(data)                                           ((0x00000001&(data))>>0)
+
+
+#define SD_SDIO_BIST_STS                                                             0x18010484
+#define SD_SDIO_BIST_STS_reg_addr                                                    "0xB8010484"
+#define SD_SDIO_BIST_STS_reg                                                         0xB8010484
+#define set_SD_SDIO_BIST_STS_reg(data)   (*((volatile unsigned int*) SD_SDIO_BIST_STS_reg)=data)
+#define get_SD_SDIO_BIST_STS_reg   (*((volatile unsigned int*) SD_SDIO_BIST_STS_reg))
+#define SD_SDIO_BIST_STS_inst_adr                                                    "0x0021"
+#define SD_SDIO_BIST_STS_inst                                                        0x0021
+#define SD_SDIO_BIST_STS_bist_drf_start_pause_shift                                  (6)
+#define SD_SDIO_BIST_STS_bist_drf_start_pause_mask                                   (0x00000040)
+#define SD_SDIO_BIST_STS_bist_drf_start_pause(data)                                  (0x00000040&((data)<<6))
+#define SD_SDIO_BIST_STS_bist_drf_start_pause_src(data)                              ((0x00000040&(data))>>6)
+#define SD_SDIO_BIST_STS_get_bist_drf_start_pause(data)                              ((0x00000040&(data))>>6)
+#define SD_SDIO_BIST_STS_bist_drf_fail_1_shift                                       (5)
+#define SD_SDIO_BIST_STS_bist_drf_fail_1_mask                                        (0x00000020)
+#define SD_SDIO_BIST_STS_bist_drf_fail_1(data)                                       (0x00000020&((data)<<5))
+#define SD_SDIO_BIST_STS_bist_drf_fail_1_src(data)                                   ((0x00000020&(data))>>5)
+#define SD_SDIO_BIST_STS_get_bist_drf_fail_1(data)                                   ((0x00000020&(data))>>5)
+#define SD_SDIO_BIST_STS_bist_drf_fail_0_shift                                       (4)
+#define SD_SDIO_BIST_STS_bist_drf_fail_0_mask                                        (0x00000010)
+#define SD_SDIO_BIST_STS_bist_drf_fail_0(data)                                       (0x00000010&((data)<<4))
+#define SD_SDIO_BIST_STS_bist_drf_fail_0_src(data)                                   ((0x00000010&(data))>>4)
+#define SD_SDIO_BIST_STS_get_bist_drf_fail_0(data)                                   ((0x00000010&(data))>>4)
+#define SD_SDIO_BIST_STS_bist_drf_done_shift                                         (3)
+#define SD_SDIO_BIST_STS_bist_drf_done_mask                                          (0x00000008)
+#define SD_SDIO_BIST_STS_bist_drf_done(data)                                         (0x00000008&((data)<<3))
+#define SD_SDIO_BIST_STS_bist_drf_done_src(data)                                     ((0x00000008&(data))>>3)
+#define SD_SDIO_BIST_STS_get_bist_drf_done(data)                                     ((0x00000008&(data))>>3)
+#define SD_SDIO_BIST_STS_bist_1_fail_shift                                           (2)
+#define SD_SDIO_BIST_STS_bist_1_fail_mask                                            (0x00000004)
+#define SD_SDIO_BIST_STS_bist_1_fail(data)                                           (0x00000004&((data)<<2))
+#define SD_SDIO_BIST_STS_bist_1_fail_src(data)                                       ((0x00000004&(data))>>2)
+#define SD_SDIO_BIST_STS_get_bist_1_fail(data)                                       ((0x00000004&(data))>>2)
+#define SD_SDIO_BIST_STS_bist_0_fail_shift                                           (1)
+#define SD_SDIO_BIST_STS_bist_0_fail_mask                                            (0x00000002)
+#define SD_SDIO_BIST_STS_bist_0_fail(data)                                           (0x00000002&((data)<<1))
+#define SD_SDIO_BIST_STS_bist_0_fail_src(data)                                       ((0x00000002&(data))>>1)
+#define SD_SDIO_BIST_STS_get_bist_0_fail(data)                                       ((0x00000002&(data))>>1)
+#define SD_SDIO_BIST_STS_bist_done_shift                                             (0)
+#define SD_SDIO_BIST_STS_bist_done_mask                                              (0x00000001)
+#define SD_SDIO_BIST_STS_bist_done(data)                                             (0x00000001&((data)<<0))
+#define SD_SDIO_BIST_STS_bist_done_src(data)                                         ((0x00000001&(data))>>0)
+#define SD_SDIO_BIST_STS_get_bist_done(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SD_SDIO_IP_BIST_CTL                                                          0x18010488
+#define SD_SDIO_IP_BIST_CTL_reg_addr                                                 "0xB8010488"
+#define SD_SDIO_IP_BIST_CTL_reg                                                      0xB8010488
+#define set_SD_SDIO_IP_BIST_CTL_reg(data)   (*((volatile unsigned int*) SD_SDIO_IP_BIST_CTL_reg)=data)
+#define get_SD_SDIO_IP_BIST_CTL_reg   (*((volatile unsigned int*) SD_SDIO_IP_BIST_CTL_reg))
+#define SD_SDIO_IP_BIST_CTL_inst_adr                                                 "0x0022"
+#define SD_SDIO_IP_BIST_CTL_inst                                                     0x0022
+#define SD_SDIO_IP_BIST_CTL_bist_ring_buf_rme_0_shift                                (8)
+#define SD_SDIO_IP_BIST_CTL_bist_ring_buf_rme_0_mask                                 (0x00000100)
+#define SD_SDIO_IP_BIST_CTL_bist_ring_buf_rme_0(data)                                (0x00000100&((data)<<8))
+#define SD_SDIO_IP_BIST_CTL_bist_ring_buf_rme_0_src(data)                            ((0x00000100&(data))>>8)
+#define SD_SDIO_IP_BIST_CTL_get_bist_ring_buf_rme_0(data)                            ((0x00000100&(data))>>8)
+#define SD_SDIO_IP_BIST_CTL_bist_ring_buf_rm_0_shift                                 (4)
+#define SD_SDIO_IP_BIST_CTL_bist_ring_buf_rm_0_mask                                  (0x000000F0)
+#define SD_SDIO_IP_BIST_CTL_bist_ring_buf_rm_0(data)                                 (0x000000F0&((data)<<4))
+#define SD_SDIO_IP_BIST_CTL_bist_ring_buf_rm_0_src(data)                             ((0x000000F0&(data))>>4)
+#define SD_SDIO_IP_BIST_CTL_get_bist_ring_buf_rm_0(data)                             ((0x000000F0&(data))>>4)
+#define SD_SDIO_IP_BIST_CTL_bist_clk_en_shift                                        (3)
+#define SD_SDIO_IP_BIST_CTL_bist_clk_en_mask                                         (0x00000008)
+#define SD_SDIO_IP_BIST_CTL_bist_clk_en(data)                                        (0x00000008&((data)<<3))
+#define SD_SDIO_IP_BIST_CTL_bist_clk_en_src(data)                                    ((0x00000008&(data))>>3)
+#define SD_SDIO_IP_BIST_CTL_get_bist_clk_en(data)                                    ((0x00000008&(data))>>3)
+#define SD_SDIO_IP_BIST_CTL_bist_drf_test_resume_shift                               (2)
+#define SD_SDIO_IP_BIST_CTL_bist_drf_test_resume_mask                                (0x00000004)
+#define SD_SDIO_IP_BIST_CTL_bist_drf_test_resume(data)                               (0x00000004&((data)<<2))
+#define SD_SDIO_IP_BIST_CTL_bist_drf_test_resume_src(data)                           ((0x00000004&(data))>>2)
+#define SD_SDIO_IP_BIST_CTL_get_bist_drf_test_resume(data)                           ((0x00000004&(data))>>2)
+#define SD_SDIO_IP_BIST_CTL_bist_drf_mode_shift                                      (1)
+#define SD_SDIO_IP_BIST_CTL_bist_drf_mode_mask                                       (0x00000002)
+#define SD_SDIO_IP_BIST_CTL_bist_drf_mode(data)                                      (0x00000002&((data)<<1))
+#define SD_SDIO_IP_BIST_CTL_bist_drf_mode_src(data)                                  ((0x00000002&(data))>>1)
+#define SD_SDIO_IP_BIST_CTL_get_bist_drf_mode(data)                                  ((0x00000002&(data))>>1)
+#define SD_SDIO_IP_BIST_CTL_bist_en_shift                                            (0)
+#define SD_SDIO_IP_BIST_CTL_bist_en_mask                                             (0x00000001)
+#define SD_SDIO_IP_BIST_CTL_bist_en(data)                                            (0x00000001&((data)<<0))
+#define SD_SDIO_IP_BIST_CTL_bist_en_src(data)                                        ((0x00000001&(data))>>0)
+#define SD_SDIO_IP_BIST_CTL_get_bist_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define SD_SDIO_IP_BIST_STS                                                          0x1801048C
+#define SD_SDIO_IP_BIST_STS_reg_addr                                                 "0xB801048C"
+#define SD_SDIO_IP_BIST_STS_reg                                                      0xB801048C
+#define set_SD_SDIO_IP_BIST_STS_reg(data)   (*((volatile unsigned int*) SD_SDIO_IP_BIST_STS_reg)=data)
+#define get_SD_SDIO_IP_BIST_STS_reg   (*((volatile unsigned int*) SD_SDIO_IP_BIST_STS_reg))
+#define SD_SDIO_IP_BIST_STS_inst_adr                                                 "0x0023"
+#define SD_SDIO_IP_BIST_STS_inst                                                     0x0023
+#define SD_SDIO_IP_BIST_STS_bist_drf_start_pause_shift                               (4)
+#define SD_SDIO_IP_BIST_STS_bist_drf_start_pause_mask                                (0x00000010)
+#define SD_SDIO_IP_BIST_STS_bist_drf_start_pause(data)                               (0x00000010&((data)<<4))
+#define SD_SDIO_IP_BIST_STS_bist_drf_start_pause_src(data)                           ((0x00000010&(data))>>4)
+#define SD_SDIO_IP_BIST_STS_get_bist_drf_start_pause(data)                           ((0x00000010&(data))>>4)
+#define SD_SDIO_IP_BIST_STS_bist_drf_fail_shift                                      (3)
+#define SD_SDIO_IP_BIST_STS_bist_drf_fail_mask                                       (0x00000008)
+#define SD_SDIO_IP_BIST_STS_bist_drf_fail(data)                                      (0x00000008&((data)<<3))
+#define SD_SDIO_IP_BIST_STS_bist_drf_fail_src(data)                                  ((0x00000008&(data))>>3)
+#define SD_SDIO_IP_BIST_STS_get_bist_drf_fail(data)                                  ((0x00000008&(data))>>3)
+#define SD_SDIO_IP_BIST_STS_bist_drf_done_shift                                      (2)
+#define SD_SDIO_IP_BIST_STS_bist_drf_done_mask                                       (0x00000004)
+#define SD_SDIO_IP_BIST_STS_bist_drf_done(data)                                      (0x00000004&((data)<<2))
+#define SD_SDIO_IP_BIST_STS_bist_drf_done_src(data)                                  ((0x00000004&(data))>>2)
+#define SD_SDIO_IP_BIST_STS_get_bist_drf_done(data)                                  ((0x00000004&(data))>>2)
+#define SD_SDIO_IP_BIST_STS_bist_fail_shift                                          (1)
+#define SD_SDIO_IP_BIST_STS_bist_fail_mask                                           (0x00000002)
+#define SD_SDIO_IP_BIST_STS_bist_fail(data)                                          (0x00000002&((data)<<1))
+#define SD_SDIO_IP_BIST_STS_bist_fail_src(data)                                      ((0x00000002&(data))>>1)
+#define SD_SDIO_IP_BIST_STS_get_bist_fail(data)                                      ((0x00000002&(data))>>1)
+#define SD_SDIO_IP_BIST_STS_bist_done_shift                                          (0)
+#define SD_SDIO_IP_BIST_STS_bist_done_mask                                           (0x00000001)
+#define SD_SDIO_IP_BIST_STS_bist_done(data)                                          (0x00000001&((data)<<0))
+#define SD_SDIO_IP_BIST_STS_bist_done_src(data)                                      ((0x00000001&(data))>>0)
+#define SD_SDIO_IP_BIST_STS_get_bist_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SD_SPEED_SENSOR_CTRL_0                                                       0x18010490
+#define SD_SPEED_SENSOR_CTRL_1                                                       0x18010494
+#define SD_SPEED_SENSOR_CTRL_0_reg_addr                                              "0xB8010490"
+#define SD_SPEED_SENSOR_CTRL_1_reg_addr                                              "0xB8010494"
+#define SD_SPEED_SENSOR_CTRL_0_reg                                                   0xB8010490
+#define SD_SPEED_SENSOR_CTRL_1_reg                                                   0xB8010494
+#define set_SD_SPEED_SENSOR_CTRL_0_reg(data)   (*((volatile unsigned int*) SD_SPEED_SENSOR_CTRL_0_reg)=data)
+#define set_SD_SPEED_SENSOR_CTRL_1_reg(data)   (*((volatile unsigned int*) SD_SPEED_SENSOR_CTRL_1_reg)=data)
+#define get_SD_SPEED_SENSOR_CTRL_0_reg   (*((volatile unsigned int*) SD_SPEED_SENSOR_CTRL_0_reg))
+#define get_SD_SPEED_SENSOR_CTRL_1_reg   (*((volatile unsigned int*) SD_SPEED_SENSOR_CTRL_1_reg))
+#define SD_SPEED_SENSOR_CTRL_0_inst_adr                                              "0x0024"
+#define SD_SPEED_SENSOR_CTRL_1_inst_adr                                              "0x0025"
+#define SD_SPEED_SENSOR_CTRL_0_inst                                                  0x0024
+#define SD_SPEED_SENSOR_CTRL_1_inst                                                  0x0025
+#define SD_SPEED_SENSOR_CTRL_sensor_clk_en_shift                                     (26)
+#define SD_SPEED_SENSOR_CTRL_sensor_clk_en_mask                                      (0x04000000)
+#define SD_SPEED_SENSOR_CTRL_sensor_clk_en(data)                                     (0x04000000&((data)<<26))
+#define SD_SPEED_SENSOR_CTRL_sensor_clk_en_src(data)                                 ((0x04000000&(data))>>26)
+#define SD_SPEED_SENSOR_CTRL_get_sensor_clk_en(data)                                 ((0x04000000&(data))>>26)
+#define SD_SPEED_SENSOR_CTRL_speed_en_shift                                          (25)
+#define SD_SPEED_SENSOR_CTRL_speed_en_mask                                           (0x02000000)
+#define SD_SPEED_SENSOR_CTRL_speed_en(data)                                          (0x02000000&((data)<<25))
+#define SD_SPEED_SENSOR_CTRL_speed_en_src(data)                                      ((0x02000000&(data))>>25)
+#define SD_SPEED_SENSOR_CTRL_get_speed_en(data)                                      ((0x02000000&(data))>>25)
+#define SD_SPEED_SENSOR_CTRL_daya_in_shift                                           (5)
+#define SD_SPEED_SENSOR_CTRL_daya_in_mask                                            (0x01FFFFE0)
+#define SD_SPEED_SENSOR_CTRL_daya_in(data)                                           (0x01FFFFE0&((data)<<5))
+#define SD_SPEED_SENSOR_CTRL_daya_in_src(data)                                       ((0x01FFFFE0&(data))>>5)
+#define SD_SPEED_SENSOR_CTRL_get_daya_in(data)                                       ((0x01FFFFE0&(data))>>5)
+#define SD_SPEED_SENSOR_CTRL_wire_sel_shift                                          (4)
+#define SD_SPEED_SENSOR_CTRL_wire_sel_mask                                           (0x00000010)
+#define SD_SPEED_SENSOR_CTRL_wire_sel(data)                                          (0x00000010&((data)<<4))
+#define SD_SPEED_SENSOR_CTRL_wire_sel_src(data)                                      ((0x00000010&(data))>>4)
+#define SD_SPEED_SENSOR_CTRL_get_wire_sel(data)                                      ((0x00000010&(data))>>4)
+#define SD_SPEED_SENSOR_CTRL_ro_sel_shift                                            (1)
+#define SD_SPEED_SENSOR_CTRL_ro_sel_mask                                             (0x0000000E)
+#define SD_SPEED_SENSOR_CTRL_ro_sel(data)                                            (0x0000000E&((data)<<1))
+#define SD_SPEED_SENSOR_CTRL_ro_sel_src(data)                                        ((0x0000000E&(data))>>1)
+#define SD_SPEED_SENSOR_CTRL_get_ro_sel(data)                                        ((0x0000000E&(data))>>1)
+#define SD_SPEED_SENSOR_CTRL_rstn_shift                                              (0)
+#define SD_SPEED_SENSOR_CTRL_rstn_mask                                               (0x00000001)
+#define SD_SPEED_SENSOR_CTRL_rstn(data)                                              (0x00000001&((data)<<0))
+#define SD_SPEED_SENSOR_CTRL_rstn_src(data)                                          ((0x00000001&(data))>>0)
+#define SD_SPEED_SENSOR_CTRL_get_rstn(data)                                          ((0x00000001&(data))>>0)
+
+
+#define SD_SPEED_SENSOR_OUT1_0                                                       0x1801049C
+#define SD_SPEED_SENSOR_OUT1_1                                                       0x180104A0
+#define SD_SPEED_SENSOR_OUT1_0_reg_addr                                              "0xB801049C"
+#define SD_SPEED_SENSOR_OUT1_1_reg_addr                                              "0xB80104A0"
+#define SD_SPEED_SENSOR_OUT1_0_reg                                                   0xB801049C
+#define SD_SPEED_SENSOR_OUT1_1_reg                                                   0xB80104A0
+#define set_SD_SPEED_SENSOR_OUT1_0_reg(data)   (*((volatile unsigned int*) SD_SPEED_SENSOR_OUT1_0_reg)=data)
+#define set_SD_SPEED_SENSOR_OUT1_1_reg(data)   (*((volatile unsigned int*) SD_SPEED_SENSOR_OUT1_1_reg)=data)
+#define get_SD_SPEED_SENSOR_OUT1_0_reg   (*((volatile unsigned int*) SD_SPEED_SENSOR_OUT1_0_reg))
+#define get_SD_SPEED_SENSOR_OUT1_1_reg   (*((volatile unsigned int*) SD_SPEED_SENSOR_OUT1_1_reg))
+#define SD_SPEED_SENSOR_OUT1_0_inst_adr                                              "0x0027"
+#define SD_SPEED_SENSOR_OUT1_1_inst_adr                                              "0x0028"
+#define SD_SPEED_SENSOR_OUT1_0_inst                                                  0x0027
+#define SD_SPEED_SENSOR_OUT1_1_inst                                                  0x0028
+#define SD_SPEED_SENSOR_OUT1_count_out_shift                                         (1)
+#define SD_SPEED_SENSOR_OUT1_count_out_mask                                          (0x001FFFFE)
+#define SD_SPEED_SENSOR_OUT1_count_out(data)                                         (0x001FFFFE&((data)<<1))
+#define SD_SPEED_SENSOR_OUT1_count_out_src(data)                                     ((0x001FFFFE&(data))>>1)
+#define SD_SPEED_SENSOR_OUT1_get_count_out(data)                                     ((0x001FFFFE&(data))>>1)
+#define SD_SPEED_SENSOR_OUT1_ready_shift                                             (0)
+#define SD_SPEED_SENSOR_OUT1_ready_mask                                              (0x00000001)
+#define SD_SPEED_SENSOR_OUT1_ready(data)                                             (0x00000001&((data)<<0))
+#define SD_SPEED_SENSOR_OUT1_ready_src(data)                                         ((0x00000001&(data))>>0)
+#define SD_SPEED_SENSOR_OUT1_get_ready(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SD_SPEED_SENSOR_OUT2_0                                                       0x180104A4
+#define SD_SPEED_SENSOR_OUT2_1                                                       0x180104A8
+#define SD_SPEED_SENSOR_OUT2_0_reg_addr                                              "0xB80104A4"
+#define SD_SPEED_SENSOR_OUT2_1_reg_addr                                              "0xB80104A8"
+#define SD_SPEED_SENSOR_OUT2_0_reg                                                   0xB80104A4
+#define SD_SPEED_SENSOR_OUT2_1_reg                                                   0xB80104A8
+#define set_SD_SPEED_SENSOR_OUT2_0_reg(data)   (*((volatile unsigned int*) SD_SPEED_SENSOR_OUT2_0_reg)=data)
+#define set_SD_SPEED_SENSOR_OUT2_1_reg(data)   (*((volatile unsigned int*) SD_SPEED_SENSOR_OUT2_1_reg)=data)
+#define get_SD_SPEED_SENSOR_OUT2_0_reg   (*((volatile unsigned int*) SD_SPEED_SENSOR_OUT2_0_reg))
+#define get_SD_SPEED_SENSOR_OUT2_1_reg   (*((volatile unsigned int*) SD_SPEED_SENSOR_OUT2_1_reg))
+#define SD_SPEED_SENSOR_OUT2_0_inst_adr                                              "0x0029"
+#define SD_SPEED_SENSOR_OUT2_1_inst_adr                                              "0x002A"
+#define SD_SPEED_SENSOR_OUT2_0_inst                                                  0x0029
+#define SD_SPEED_SENSOR_OUT2_1_inst                                                  0x002A
+#define SD_SPEED_SENSOR_OUT2_dbgo_shift                                              (1)
+#define SD_SPEED_SENSOR_OUT2_dbgo_mask                                               (0x0001FFFE)
+#define SD_SPEED_SENSOR_OUT2_dbgo(data)                                              (0x0001FFFE&((data)<<1))
+#define SD_SPEED_SENSOR_OUT2_dbgo_src(data)                                          ((0x0001FFFE&(data))>>1)
+#define SD_SPEED_SENSOR_OUT2_get_dbgo(data)                                          ((0x0001FFFE&(data))>>1)
+#define SD_SPEED_SENSOR_OUT2_wsort_go_shift                                          (0)
+#define SD_SPEED_SENSOR_OUT2_wsort_go_mask                                           (0x00000001)
+#define SD_SPEED_SENSOR_OUT2_wsort_go(data)                                          (0x00000001&((data)<<0))
+#define SD_SPEED_SENSOR_OUT2_wsort_go_src(data)                                      ((0x00000001&(data))>>0)
+#define SD_SPEED_SENSOR_OUT2_get_wsort_go(data)                                      ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sde_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sde_reg.h
new file mode 100644
index 00000000..9dddc00
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sde_reg.h
@@ -0,0 +1,435 @@
+/**************************************************************
+// Spec Version                  : 0.0.7
+// Parser Version                : MAR_Parser_1.0
+// CModelGen Version             : 1.0 2006.04.18
+// Naming Rule                   : Module_Register_Name
+// Firmware Header Generate Date : 2007/9/12
+***************************************************************/
+
+
+#ifndef _SDE_REG_H_INCLUDED_
+#define _SDE_REG_H_INCLUDED_
+#ifdef  _SDE_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     dmem_addr:14;
+}SDE_DMEM_ADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ddr_addr:28;
+}SDE_DDR_ADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     length:14;
+}SDE_DMA_LEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     write_enable2:1;
+unsigned int     stop:1;
+unsigned int     write_enable1:1;
+unsigned int     r_w:1;
+unsigned int     go:1;
+}SDE_DMA_CTRL;
+
+typedef struct 
+{
+unsigned int     dmem_err:1;
+unsigned int     reserved_0:21;
+unsigned int     dma_done_7:1;
+unsigned int     dma_done_6:1;
+unsigned int     dma_done_5:1;
+unsigned int     dma_done_4:1;
+unsigned int     dma_done_3:1;
+unsigned int     dma_done_2:1;
+unsigned int     dma_done_1:1;
+unsigned int     dma_done_0:1;
+unsigned int     dma_all_done:1;
+unsigned int     write_data:1;
+}SDE_DMA_DONE;
+
+typedef struct 
+{
+unsigned int     dmem_err_int_en:1;
+unsigned int     reserved_0:21;
+unsigned int     dma_done_7_en:1;
+unsigned int     dma_done_6_en:1;
+unsigned int     dma_done_5_en:1;
+unsigned int     dma_done_4_en:1;
+unsigned int     dma_done_3_en:1;
+unsigned int     dma_done_2_en:1;
+unsigned int     dma_done_1_en:1;
+unsigned int     dma_done_0_en:1;
+unsigned int     dma_all_done_en:1;
+unsigned int     write_data:1;
+}SDE_DMA_DONE_EN;
+
+typedef struct 
+{
+unsigned int     data:32;
+}SDE_DUMMY;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     write_enable3:1;
+unsigned int     sel1:5;
+unsigned int     write_enable2:1;
+unsigned int     sel0:5;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}SDE_DBG;
+
+#endif
+
+#define SDE_DMEM_ADDR_0                                                              0x18003000
+#define SDE_DMEM_ADDR_1                                                              0x18003004
+#define SDE_DMEM_ADDR_2                                                              0x18003008
+#define SDE_DMEM_ADDR_3                                                              0x1800300C
+#define SDE_DMEM_ADDR_4                                                              0x18003010
+#define SDE_DMEM_ADDR_5                                                              0x18003014
+#define SDE_DMEM_ADDR_6                                                              0x18003018
+#define SDE_DMEM_ADDR_7                                                              0x1800301C
+#define SDE_DMEM_ADDR_0_reg_addr                                                     "0xB8003000"
+#define SDE_DMEM_ADDR_1_reg_addr                                                     "0xB8003004"
+#define SDE_DMEM_ADDR_2_reg_addr                                                     "0xB8003008"
+#define SDE_DMEM_ADDR_3_reg_addr                                                     "0xB800300C"
+#define SDE_DMEM_ADDR_4_reg_addr                                                     "0xB8003010"
+#define SDE_DMEM_ADDR_5_reg_addr                                                     "0xB8003014"
+#define SDE_DMEM_ADDR_6_reg_addr                                                     "0xB8003018"
+#define SDE_DMEM_ADDR_7_reg_addr                                                     "0xB800301C"
+#define SDE_DMEM_ADDR_0_reg                                                          0xB8003000
+#define SDE_DMEM_ADDR_1_reg                                                          0xB8003004
+#define SDE_DMEM_ADDR_2_reg                                                          0xB8003008
+#define SDE_DMEM_ADDR_3_reg                                                          0xB800300C
+#define SDE_DMEM_ADDR_4_reg                                                          0xB8003010
+#define SDE_DMEM_ADDR_5_reg                                                          0xB8003014
+#define SDE_DMEM_ADDR_6_reg                                                          0xB8003018
+#define SDE_DMEM_ADDR_7_reg                                                          0xB800301C
+#define SDE_DMEM_ADDR_0_inst_adr                                                     "0x0000"
+#define SDE_DMEM_ADDR_1_inst_adr                                                     "0x0001"
+#define SDE_DMEM_ADDR_2_inst_adr                                                     "0x0002"
+#define SDE_DMEM_ADDR_3_inst_adr                                                     "0x0003"
+#define SDE_DMEM_ADDR_4_inst_adr                                                     "0x0004"
+#define SDE_DMEM_ADDR_5_inst_adr                                                     "0x0005"
+#define SDE_DMEM_ADDR_6_inst_adr                                                     "0x0006"
+#define SDE_DMEM_ADDR_7_inst_adr                                                     "0x0007"
+#define SDE_DMEM_ADDR_0_inst                                                         0x0000
+#define SDE_DMEM_ADDR_1_inst                                                         0x0001
+#define SDE_DMEM_ADDR_2_inst                                                         0x0002
+#define SDE_DMEM_ADDR_3_inst                                                         0x0003
+#define SDE_DMEM_ADDR_4_inst                                                         0x0004
+#define SDE_DMEM_ADDR_5_inst                                                         0x0005
+#define SDE_DMEM_ADDR_6_inst                                                         0x0006
+#define SDE_DMEM_ADDR_7_inst                                                         0x0007
+#define SDE_DMEM_ADDR_dmem_addr_shift                                                (0)
+#define SDE_DMEM_ADDR_dmem_addr_mask                                                 (0x00003FFF)
+#define SDE_DMEM_ADDR_dmem_addr(data)                                                (0x00003FFF&((data)<<0))
+#define SDE_DMEM_ADDR_dmem_addr_src(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define SDE_DDR_ADDR_0                                                               0x18003020
+#define SDE_DDR_ADDR_1                                                               0x18003024
+#define SDE_DDR_ADDR_2                                                               0x18003028
+#define SDE_DDR_ADDR_3                                                               0x1800302C
+#define SDE_DDR_ADDR_4                                                               0x18003030
+#define SDE_DDR_ADDR_5                                                               0x18003034
+#define SDE_DDR_ADDR_6                                                               0x18003038
+#define SDE_DDR_ADDR_7                                                               0x1800303C
+#define SDE_DDR_ADDR_0_reg_addr                                                      "0xB8003020"
+#define SDE_DDR_ADDR_1_reg_addr                                                      "0xB8003024"
+#define SDE_DDR_ADDR_2_reg_addr                                                      "0xB8003028"
+#define SDE_DDR_ADDR_3_reg_addr                                                      "0xB800302C"
+#define SDE_DDR_ADDR_4_reg_addr                                                      "0xB8003030"
+#define SDE_DDR_ADDR_5_reg_addr                                                      "0xB8003034"
+#define SDE_DDR_ADDR_6_reg_addr                                                      "0xB8003038"
+#define SDE_DDR_ADDR_7_reg_addr                                                      "0xB800303C"
+#define SDE_DDR_ADDR_0_reg                                                           0xB8003020
+#define SDE_DDR_ADDR_1_reg                                                           0xB8003024
+#define SDE_DDR_ADDR_2_reg                                                           0xB8003028
+#define SDE_DDR_ADDR_3_reg                                                           0xB800302C
+#define SDE_DDR_ADDR_4_reg                                                           0xB8003030
+#define SDE_DDR_ADDR_5_reg                                                           0xB8003034
+#define SDE_DDR_ADDR_6_reg                                                           0xB8003038
+#define SDE_DDR_ADDR_7_reg                                                           0xB800303C
+#define SDE_DDR_ADDR_0_inst_adr                                                      "0x0008"
+#define SDE_DDR_ADDR_1_inst_adr                                                      "0x0009"
+#define SDE_DDR_ADDR_2_inst_adr                                                      "0x000A"
+#define SDE_DDR_ADDR_3_inst_adr                                                      "0x000B"
+#define SDE_DDR_ADDR_4_inst_adr                                                      "0x000C"
+#define SDE_DDR_ADDR_5_inst_adr                                                      "0x000D"
+#define SDE_DDR_ADDR_6_inst_adr                                                      "0x000E"
+#define SDE_DDR_ADDR_7_inst_adr                                                      "0x000F"
+#define SDE_DDR_ADDR_0_inst                                                          0x0008
+#define SDE_DDR_ADDR_1_inst                                                          0x0009
+#define SDE_DDR_ADDR_2_inst                                                          0x000A
+#define SDE_DDR_ADDR_3_inst                                                          0x000B
+#define SDE_DDR_ADDR_4_inst                                                          0x000C
+#define SDE_DDR_ADDR_5_inst                                                          0x000D
+#define SDE_DDR_ADDR_6_inst                                                          0x000E
+#define SDE_DDR_ADDR_7_inst                                                          0x000F
+#define SDE_DDR_ADDR_ddr_addr_shift                                                  (0)
+#define SDE_DDR_ADDR_ddr_addr_mask                                                   (0x0FFFFFFF)
+#define SDE_DDR_ADDR_ddr_addr(data)                                                  (0x0FFFFFFF&((data)<<0))
+#define SDE_DDR_ADDR_ddr_addr_src(data)                                              ((0x0FFFFFFF&(data))>>0)
+
+
+#define SDE_DMA_LEN_0                                                                0x18003040
+#define SDE_DMA_LEN_1                                                                0x18003044
+#define SDE_DMA_LEN_2                                                                0x18003048
+#define SDE_DMA_LEN_3                                                                0x1800304C
+#define SDE_DMA_LEN_4                                                                0x18003050
+#define SDE_DMA_LEN_5                                                                0x18003054
+#define SDE_DMA_LEN_6                                                                0x18003058
+#define SDE_DMA_LEN_7                                                                0x1800305C
+#define SDE_DMA_LEN_0_reg_addr                                                       "0xB8003040"
+#define SDE_DMA_LEN_1_reg_addr                                                       "0xB8003044"
+#define SDE_DMA_LEN_2_reg_addr                                                       "0xB8003048"
+#define SDE_DMA_LEN_3_reg_addr                                                       "0xB800304C"
+#define SDE_DMA_LEN_4_reg_addr                                                       "0xB8003050"
+#define SDE_DMA_LEN_5_reg_addr                                                       "0xB8003054"
+#define SDE_DMA_LEN_6_reg_addr                                                       "0xB8003058"
+#define SDE_DMA_LEN_7_reg_addr                                                       "0xB800305C"
+#define SDE_DMA_LEN_0_reg                                                            0xB8003040
+#define SDE_DMA_LEN_1_reg                                                            0xB8003044
+#define SDE_DMA_LEN_2_reg                                                            0xB8003048
+#define SDE_DMA_LEN_3_reg                                                            0xB800304C
+#define SDE_DMA_LEN_4_reg                                                            0xB8003050
+#define SDE_DMA_LEN_5_reg                                                            0xB8003054
+#define SDE_DMA_LEN_6_reg                                                            0xB8003058
+#define SDE_DMA_LEN_7_reg                                                            0xB800305C
+#define SDE_DMA_LEN_0_inst_adr                                                       "0x0010"
+#define SDE_DMA_LEN_1_inst_adr                                                       "0x0011"
+#define SDE_DMA_LEN_2_inst_adr                                                       "0x0012"
+#define SDE_DMA_LEN_3_inst_adr                                                       "0x0013"
+#define SDE_DMA_LEN_4_inst_adr                                                       "0x0014"
+#define SDE_DMA_LEN_5_inst_adr                                                       "0x0015"
+#define SDE_DMA_LEN_6_inst_adr                                                       "0x0016"
+#define SDE_DMA_LEN_7_inst_adr                                                       "0x0017"
+#define SDE_DMA_LEN_0_inst                                                           0x0010
+#define SDE_DMA_LEN_1_inst                                                           0x0011
+#define SDE_DMA_LEN_2_inst                                                           0x0012
+#define SDE_DMA_LEN_3_inst                                                           0x0013
+#define SDE_DMA_LEN_4_inst                                                           0x0014
+#define SDE_DMA_LEN_5_inst                                                           0x0015
+#define SDE_DMA_LEN_6_inst                                                           0x0016
+#define SDE_DMA_LEN_7_inst                                                           0x0017
+#define SDE_DMA_LEN_length_shift                                                     (0)
+#define SDE_DMA_LEN_length_mask                                                      (0x00003FFF)
+#define SDE_DMA_LEN_length(data)                                                     (0x00003FFF&((data)<<0))
+#define SDE_DMA_LEN_length_src(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define SDE_DMA_CTRL_0                                                               0x18003060
+#define SDE_DMA_CTRL_1                                                               0x18003064
+#define SDE_DMA_CTRL_2                                                               0x18003068
+#define SDE_DMA_CTRL_3                                                               0x1800306C
+#define SDE_DMA_CTRL_4                                                               0x18003070
+#define SDE_DMA_CTRL_5                                                               0x18003074
+#define SDE_DMA_CTRL_6                                                               0x18003078
+#define SDE_DMA_CTRL_7                                                               0x1800307C
+#define SDE_DMA_CTRL_0_reg_addr                                                      "0xB8003060"
+#define SDE_DMA_CTRL_1_reg_addr                                                      "0xB8003064"
+#define SDE_DMA_CTRL_2_reg_addr                                                      "0xB8003068"
+#define SDE_DMA_CTRL_3_reg_addr                                                      "0xB800306C"
+#define SDE_DMA_CTRL_4_reg_addr                                                      "0xB8003070"
+#define SDE_DMA_CTRL_5_reg_addr                                                      "0xB8003074"
+#define SDE_DMA_CTRL_6_reg_addr                                                      "0xB8003078"
+#define SDE_DMA_CTRL_7_reg_addr                                                      "0xB800307C"
+#define SDE_DMA_CTRL_0_reg                                                           0xB8003060
+#define SDE_DMA_CTRL_1_reg                                                           0xB8003064
+#define SDE_DMA_CTRL_2_reg                                                           0xB8003068
+#define SDE_DMA_CTRL_3_reg                                                           0xB800306C
+#define SDE_DMA_CTRL_4_reg                                                           0xB8003070
+#define SDE_DMA_CTRL_5_reg                                                           0xB8003074
+#define SDE_DMA_CTRL_6_reg                                                           0xB8003078
+#define SDE_DMA_CTRL_7_reg                                                           0xB800307C
+#define SDE_DMA_CTRL_0_inst_adr                                                      "0x0018"
+#define SDE_DMA_CTRL_1_inst_adr                                                      "0x0019"
+#define SDE_DMA_CTRL_2_inst_adr                                                      "0x001A"
+#define SDE_DMA_CTRL_3_inst_adr                                                      "0x001B"
+#define SDE_DMA_CTRL_4_inst_adr                                                      "0x001C"
+#define SDE_DMA_CTRL_5_inst_adr                                                      "0x001D"
+#define SDE_DMA_CTRL_6_inst_adr                                                      "0x001E"
+#define SDE_DMA_CTRL_7_inst_adr                                                      "0x001F"
+#define SDE_DMA_CTRL_0_inst                                                          0x0018
+#define SDE_DMA_CTRL_1_inst                                                          0x0019
+#define SDE_DMA_CTRL_2_inst                                                          0x001A
+#define SDE_DMA_CTRL_3_inst                                                          0x001B
+#define SDE_DMA_CTRL_4_inst                                                          0x001C
+#define SDE_DMA_CTRL_5_inst                                                          0x001D
+#define SDE_DMA_CTRL_6_inst                                                          0x001E
+#define SDE_DMA_CTRL_7_inst                                                          0x001F
+#define SDE_DMA_CTRL_write_enable2_shift                                             (4)
+#define SDE_DMA_CTRL_write_enable2_mask                                              (0x00000010)
+#define SDE_DMA_CTRL_write_enable2(data)                                             (0x00000010&((data)<<4))
+#define SDE_DMA_CTRL_write_enable2_src(data)                                         ((0x00000010&(data))>>4)
+#define SDE_DMA_CTRL_stop_shift                                                      (3)
+#define SDE_DMA_CTRL_stop_mask                                                       (0x00000008)
+#define SDE_DMA_CTRL_stop(data)                                                      (0x00000008&((data)<<3))
+#define SDE_DMA_CTRL_stop_src(data)                                                  ((0x00000008&(data))>>3)
+#define SDE_DMA_CTRL_write_enable1_shift                                             (2)
+#define SDE_DMA_CTRL_write_enable1_mask                                              (0x00000004)
+#define SDE_DMA_CTRL_write_enable1(data)                                             (0x00000004&((data)<<2))
+#define SDE_DMA_CTRL_write_enable1_src(data)                                         ((0x00000004&(data))>>2)
+#define SDE_DMA_CTRL_r_w_shift                                                       (1)
+#define SDE_DMA_CTRL_r_w_mask                                                        (0x00000002)
+#define SDE_DMA_CTRL_r_w(data)                                                       (0x00000002&((data)<<1))
+#define SDE_DMA_CTRL_r_w_src(data)                                                   ((0x00000002&(data))>>1)
+#define SDE_DMA_CTRL_go_shift                                                        (0)
+#define SDE_DMA_CTRL_go_mask                                                         (0x00000001)
+#define SDE_DMA_CTRL_go(data)                                                        (0x00000001&((data)<<0))
+#define SDE_DMA_CTRL_go_src(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define SDE_DMA_DONE                                                                 0x18003080
+#define SDE_DMA_DONE_reg_addr                                                        "0xB8003080"
+#define SDE_DMA_DONE_reg                                                             0xB8003080
+#define SDE_DMA_DONE_inst_adr                                                        "0x0020"
+#define SDE_DMA_DONE_inst                                                            0x0020
+#define SDE_DMA_DONE_dmem_err_shift                                                  (31)
+#define SDE_DMA_DONE_dmem_err_mask                                                   (0x80000000)
+#define SDE_DMA_DONE_dmem_err(data)                                                  (0x80000000&((data)<<31))
+#define SDE_DMA_DONE_dmem_err_src(data)                                              ((0x80000000&(data))>>31)
+#define SDE_DMA_DONE_dma_done_7_shift                                                (9)
+#define SDE_DMA_DONE_dma_done_7_mask                                                 (0x00000200)
+#define SDE_DMA_DONE_dma_done_7(data)                                                (0x00000200&((data)<<9))
+#define SDE_DMA_DONE_dma_done_7_src(data)                                            ((0x00000200&(data))>>9)
+#define SDE_DMA_DONE_dma_done_6_shift                                                (8)
+#define SDE_DMA_DONE_dma_done_6_mask                                                 (0x00000100)
+#define SDE_DMA_DONE_dma_done_6(data)                                                (0x00000100&((data)<<8))
+#define SDE_DMA_DONE_dma_done_6_src(data)                                            ((0x00000100&(data))>>8)
+#define SDE_DMA_DONE_dma_done_5_shift                                                (7)
+#define SDE_DMA_DONE_dma_done_5_mask                                                 (0x00000080)
+#define SDE_DMA_DONE_dma_done_5(data)                                                (0x00000080&((data)<<7))
+#define SDE_DMA_DONE_dma_done_5_src(data)                                            ((0x00000080&(data))>>7)
+#define SDE_DMA_DONE_dma_done_4_shift                                                (6)
+#define SDE_DMA_DONE_dma_done_4_mask                                                 (0x00000040)
+#define SDE_DMA_DONE_dma_done_4(data)                                                (0x00000040&((data)<<6))
+#define SDE_DMA_DONE_dma_done_4_src(data)                                            ((0x00000040&(data))>>6)
+#define SDE_DMA_DONE_dma_done_3_shift                                                (5)
+#define SDE_DMA_DONE_dma_done_3_mask                                                 (0x00000020)
+#define SDE_DMA_DONE_dma_done_3(data)                                                (0x00000020&((data)<<5))
+#define SDE_DMA_DONE_dma_done_3_src(data)                                            ((0x00000020&(data))>>5)
+#define SDE_DMA_DONE_dma_done_2_shift                                                (4)
+#define SDE_DMA_DONE_dma_done_2_mask                                                 (0x00000010)
+#define SDE_DMA_DONE_dma_done_2(data)                                                (0x00000010&((data)<<4))
+#define SDE_DMA_DONE_dma_done_2_src(data)                                            ((0x00000010&(data))>>4)
+#define SDE_DMA_DONE_dma_done_1_shift                                                (3)
+#define SDE_DMA_DONE_dma_done_1_mask                                                 (0x00000008)
+#define SDE_DMA_DONE_dma_done_1(data)                                                (0x00000008&((data)<<3))
+#define SDE_DMA_DONE_dma_done_1_src(data)                                            ((0x00000008&(data))>>3)
+#define SDE_DMA_DONE_dma_done_0_shift                                                (2)
+#define SDE_DMA_DONE_dma_done_0_mask                                                 (0x00000004)
+#define SDE_DMA_DONE_dma_done_0(data)                                                (0x00000004&((data)<<2))
+#define SDE_DMA_DONE_dma_done_0_src(data)                                            ((0x00000004&(data))>>2)
+#define SDE_DMA_DONE_dma_all_done_shift                                              (1)
+#define SDE_DMA_DONE_dma_all_done_mask                                               (0x00000002)
+#define SDE_DMA_DONE_dma_all_done(data)                                              (0x00000002&((data)<<1))
+#define SDE_DMA_DONE_dma_all_done_src(data)                                          ((0x00000002&(data))>>1)
+#define SDE_DMA_DONE_write_data_shift                                                (0)
+#define SDE_DMA_DONE_write_data_mask                                                 (0x00000001)
+#define SDE_DMA_DONE_write_data(data)                                                (0x00000001&((data)<<0))
+#define SDE_DMA_DONE_write_data_src(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SDE_DMA_DONE_EN                                                              0x18003084
+#define SDE_DMA_DONE_EN_reg_addr                                                     "0xB8003084"
+#define SDE_DMA_DONE_EN_reg                                                          0xB8003084
+#define SDE_DMA_DONE_EN_inst_adr                                                     "0x0021"
+#define SDE_DMA_DONE_EN_inst                                                         0x0021
+#define SDE_DMA_DONE_EN_dmem_err_int_en_shift                                        (31)
+#define SDE_DMA_DONE_EN_dmem_err_int_en_mask                                         (0x80000000)
+#define SDE_DMA_DONE_EN_dmem_err_int_en(data)                                        (0x80000000&((data)<<31))
+#define SDE_DMA_DONE_EN_dmem_err_int_en_src(data)                                    ((0x80000000&(data))>>31)
+#define SDE_DMA_DONE_EN_dma_done_7_en_shift                                          (9)
+#define SDE_DMA_DONE_EN_dma_done_7_en_mask                                           (0x00000200)
+#define SDE_DMA_DONE_EN_dma_done_7_en(data)                                          (0x00000200&((data)<<9))
+#define SDE_DMA_DONE_EN_dma_done_7_en_src(data)                                      ((0x00000200&(data))>>9)
+#define SDE_DMA_DONE_EN_dma_done_6_en_shift                                          (8)
+#define SDE_DMA_DONE_EN_dma_done_6_en_mask                                           (0x00000100)
+#define SDE_DMA_DONE_EN_dma_done_6_en(data)                                          (0x00000100&((data)<<8))
+#define SDE_DMA_DONE_EN_dma_done_6_en_src(data)                                      ((0x00000100&(data))>>8)
+#define SDE_DMA_DONE_EN_dma_done_5_en_shift                                          (7)
+#define SDE_DMA_DONE_EN_dma_done_5_en_mask                                           (0x00000080)
+#define SDE_DMA_DONE_EN_dma_done_5_en(data)                                          (0x00000080&((data)<<7))
+#define SDE_DMA_DONE_EN_dma_done_5_en_src(data)                                      ((0x00000080&(data))>>7)
+#define SDE_DMA_DONE_EN_dma_done_4_en_shift                                          (6)
+#define SDE_DMA_DONE_EN_dma_done_4_en_mask                                           (0x00000040)
+#define SDE_DMA_DONE_EN_dma_done_4_en(data)                                          (0x00000040&((data)<<6))
+#define SDE_DMA_DONE_EN_dma_done_4_en_src(data)                                      ((0x00000040&(data))>>6)
+#define SDE_DMA_DONE_EN_dma_done_3_en_shift                                          (5)
+#define SDE_DMA_DONE_EN_dma_done_3_en_mask                                           (0x00000020)
+#define SDE_DMA_DONE_EN_dma_done_3_en(data)                                          (0x00000020&((data)<<5))
+#define SDE_DMA_DONE_EN_dma_done_3_en_src(data)                                      ((0x00000020&(data))>>5)
+#define SDE_DMA_DONE_EN_dma_done_2_en_shift                                          (4)
+#define SDE_DMA_DONE_EN_dma_done_2_en_mask                                           (0x00000010)
+#define SDE_DMA_DONE_EN_dma_done_2_en(data)                                          (0x00000010&((data)<<4))
+#define SDE_DMA_DONE_EN_dma_done_2_en_src(data)                                      ((0x00000010&(data))>>4)
+#define SDE_DMA_DONE_EN_dma_done_1_en_shift                                          (3)
+#define SDE_DMA_DONE_EN_dma_done_1_en_mask                                           (0x00000008)
+#define SDE_DMA_DONE_EN_dma_done_1_en(data)                                          (0x00000008&((data)<<3))
+#define SDE_DMA_DONE_EN_dma_done_1_en_src(data)                                      ((0x00000008&(data))>>3)
+#define SDE_DMA_DONE_EN_dma_done_0_en_shift                                          (2)
+#define SDE_DMA_DONE_EN_dma_done_0_en_mask                                           (0x00000004)
+#define SDE_DMA_DONE_EN_dma_done_0_en(data)                                          (0x00000004&((data)<<2))
+#define SDE_DMA_DONE_EN_dma_done_0_en_src(data)                                      ((0x00000004&(data))>>2)
+#define SDE_DMA_DONE_EN_dma_all_done_en_shift                                        (1)
+#define SDE_DMA_DONE_EN_dma_all_done_en_mask                                         (0x00000002)
+#define SDE_DMA_DONE_EN_dma_all_done_en(data)                                        (0x00000002&((data)<<1))
+#define SDE_DMA_DONE_EN_dma_all_done_en_src(data)                                    ((0x00000002&(data))>>1)
+#define SDE_DMA_DONE_EN_write_data_shift                                             (0)
+#define SDE_DMA_DONE_EN_write_data_mask                                              (0x00000001)
+#define SDE_DMA_DONE_EN_write_data(data)                                             (0x00000001&((data)<<0))
+#define SDE_DMA_DONE_EN_write_data_src(data)                                         ((0x00000001&(data))>>0)
+
+
+#define SDE_DUMMY                                                                    0x18003090
+#define SDE_DUMMY_reg_addr                                                           "0xB8003090"
+#define SDE_DUMMY_reg                                                                0xB8003090
+#define SDE_DUMMY_inst_adr                                                           "0x0024"
+#define SDE_DUMMY_inst                                                               0x0024
+#define SDE_DUMMY_data_shift                                                         (0)
+#define SDE_DUMMY_data_mask                                                          (0xFFFFFFFF)
+#define SDE_DUMMY_data(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define SDE_DUMMY_data_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#define SDE_DBG                                                                      0x180030A0
+#define SDE_DBG_reg_addr                                                             "0xB80030A0"
+#define SDE_DBG_reg                                                                  0xB80030A0
+#define SDE_DBG_inst_adr                                                             "0x0028"
+#define SDE_DBG_inst                                                                 0x0028
+#define SDE_DBG_write_enable3_shift                                                  (13)
+#define SDE_DBG_write_enable3_mask                                                   (0x00002000)
+#define SDE_DBG_write_enable3(data)                                                  (0x00002000&((data)<<13))
+#define SDE_DBG_write_enable3_src(data)                                              ((0x00002000&(data))>>13)
+#define SDE_DBG_sel1_shift                                                           (8)
+#define SDE_DBG_sel1_mask                                                            (0x00001F00)
+#define SDE_DBG_sel1(data)                                                           (0x00001F00&((data)<<8))
+#define SDE_DBG_sel1_src(data)                                                       ((0x00001F00&(data))>>8)
+#define SDE_DBG_write_enable2_shift                                                  (7)
+#define SDE_DBG_write_enable2_mask                                                   (0x00000080)
+#define SDE_DBG_write_enable2(data)                                                  (0x00000080&((data)<<7))
+#define SDE_DBG_write_enable2_src(data)                                              ((0x00000080&(data))>>7)
+#define SDE_DBG_sel0_shift                                                           (2)
+#define SDE_DBG_sel0_mask                                                            (0x0000007C)
+#define SDE_DBG_sel0(data)                                                           (0x0000007C&((data)<<2))
+#define SDE_DBG_sel0_src(data)                                                       ((0x0000007C&(data))>>2)
+#define SDE_DBG_write_enable1_shift                                                  (1)
+#define SDE_DBG_write_enable1_mask                                                   (0x00000002)
+#define SDE_DBG_write_enable1(data)                                                  (0x00000002&((data)<<1))
+#define SDE_DBG_write_enable1_src(data)                                              ((0x00000002&(data))>>1)
+#define SDE_DBG_enable_shift                                                         (0)
+#define SDE_DBG_enable_mask                                                          (0x00000001)
+#define SDE_DBG_enable(data)                                                         (0x00000001&((data)<<0))
+#define SDE_DBG_enable_src(data)                                                     ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sdio_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sdio_reg.h
new file mode 100644
index 00000000..580803d
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sdio_reg.h
@@ -0,0 +1,225 @@
+/**************************************************************
+// Spec Version                  : 0.7
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/7/23 16:58:21
+***************************************************************/
+
+
+#ifndef _SDIO_REG_H_INCLUDED_
+#define _SDIO_REG_H_INCLUDED_
+#ifdef  _SDIO_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     mcu_buf_access:2;
+unsigned int     mcu_sel:1;
+}SDIO_SRAM_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     suspend_n:1;
+}SDIO_IP_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_enable3:1;
+unsigned int     sel1:3;
+unsigned int     write_enable2:1;
+unsigned int     sel0:3;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}SDIO_DBG_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     dbus_dbg_sel:3;
+}SDIO_DBG_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ip_dbg_sel:8;
+}SDIO_DBG_3;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     Int4:1;
+unsigned int     Int3:1;
+unsigned int     Int2:1;
+unsigned int     Int1:1;
+unsigned int     write_data:1;
+}SDIO_ISR;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     Int1En:1;
+unsigned int     write_data:1;
+}SDIO_ISREN;
+
+#endif
+
+#define SDIO_SRAM_CTL                                                                0x18010A00
+#define SDIO_SRAM_CTL_reg_addr                                                       "0xB8010A00"
+#define SDIO_SRAM_CTL_reg                                                            0xB8010A00
+#define set_SDIO_SRAM_CTL_reg(data)   (*((volatile unsigned int*) SDIO_SRAM_CTL_reg)=data)
+#define get_SDIO_SRAM_CTL_reg   (*((volatile unsigned int*) SDIO_SRAM_CTL_reg))
+#define SDIO_SRAM_CTL_inst_adr                                                       "0x0080"
+#define SDIO_SRAM_CTL_inst                                                           0x0080
+#define SDIO_SRAM_CTL_mcu_buf_access_shift                                           (1)
+#define SDIO_SRAM_CTL_mcu_buf_access_mask                                            (0x00000006)
+#define SDIO_SRAM_CTL_mcu_buf_access(data)                                           (0x00000006&((data)<<1))
+#define SDIO_SRAM_CTL_mcu_buf_access_src(data)                                       ((0x00000006&(data))>>1)
+#define SDIO_SRAM_CTL_get_mcu_buf_access(data)                                       ((0x00000006&(data))>>1)
+#define SDIO_SRAM_CTL_mcu_sel_shift                                                  (0)
+#define SDIO_SRAM_CTL_mcu_sel_mask                                                   (0x00000001)
+#define SDIO_SRAM_CTL_mcu_sel(data)                                                  (0x00000001&((data)<<0))
+#define SDIO_SRAM_CTL_mcu_sel_src(data)                                              ((0x00000001&(data))>>0)
+#define SDIO_SRAM_CTL_get_mcu_sel(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SDIO_IP_CTL                                                                  0x18010A10
+#define SDIO_IP_CTL_reg_addr                                                         "0xB8010A10"
+#define SDIO_IP_CTL_reg                                                              0xB8010A10
+#define set_SDIO_IP_CTL_reg(data)   (*((volatile unsigned int*) SDIO_IP_CTL_reg)=data)
+#define get_SDIO_IP_CTL_reg   (*((volatile unsigned int*) SDIO_IP_CTL_reg))
+#define SDIO_IP_CTL_inst_adr                                                         "0x0084"
+#define SDIO_IP_CTL_inst                                                             0x0084
+#define SDIO_IP_CTL_suspend_n_shift                                                  (0)
+#define SDIO_IP_CTL_suspend_n_mask                                                   (0x00000001)
+#define SDIO_IP_CTL_suspend_n(data)                                                  (0x00000001&((data)<<0))
+#define SDIO_IP_CTL_suspend_n_src(data)                                              ((0x00000001&(data))>>0)
+#define SDIO_IP_CTL_get_suspend_n(data)                                              ((0x00000001&(data))>>0)
+
+
+#define SDIO_DBG_1                                                                   0x18010A20
+#define SDIO_DBG_1_reg_addr                                                          "0xB8010A20"
+#define SDIO_DBG_1_reg                                                               0xB8010A20
+#define set_SDIO_DBG_1_reg(data)   (*((volatile unsigned int*) SDIO_DBG_1_reg)=data)
+#define get_SDIO_DBG_1_reg   (*((volatile unsigned int*) SDIO_DBG_1_reg))
+#define SDIO_DBG_1_inst_adr                                                          "0x0088"
+#define SDIO_DBG_1_inst                                                              0x0088
+#define SDIO_DBG_1_write_enable3_shift                                               (9)
+#define SDIO_DBG_1_write_enable3_mask                                                (0x00000200)
+#define SDIO_DBG_1_write_enable3(data)                                               (0x00000200&((data)<<9))
+#define SDIO_DBG_1_write_enable3_src(data)                                           ((0x00000200&(data))>>9)
+#define SDIO_DBG_1_get_write_enable3(data)                                           ((0x00000200&(data))>>9)
+#define SDIO_DBG_1_sel1_shift                                                        (6)
+#define SDIO_DBG_1_sel1_mask                                                         (0x000001C0)
+#define SDIO_DBG_1_sel1(data)                                                        (0x000001C0&((data)<<6))
+#define SDIO_DBG_1_sel1_src(data)                                                    ((0x000001C0&(data))>>6)
+#define SDIO_DBG_1_get_sel1(data)                                                    ((0x000001C0&(data))>>6)
+#define SDIO_DBG_1_write_enable2_shift                                               (5)
+#define SDIO_DBG_1_write_enable2_mask                                                (0x00000020)
+#define SDIO_DBG_1_write_enable2(data)                                               (0x00000020&((data)<<5))
+#define SDIO_DBG_1_write_enable2_src(data)                                           ((0x00000020&(data))>>5)
+#define SDIO_DBG_1_get_write_enable2(data)                                           ((0x00000020&(data))>>5)
+#define SDIO_DBG_1_sel0_shift                                                        (2)
+#define SDIO_DBG_1_sel0_mask                                                         (0x0000001C)
+#define SDIO_DBG_1_sel0(data)                                                        (0x0000001C&((data)<<2))
+#define SDIO_DBG_1_sel0_src(data)                                                    ((0x0000001C&(data))>>2)
+#define SDIO_DBG_1_get_sel0(data)                                                    ((0x0000001C&(data))>>2)
+#define SDIO_DBG_1_write_enable1_shift                                               (1)
+#define SDIO_DBG_1_write_enable1_mask                                                (0x00000002)
+#define SDIO_DBG_1_write_enable1(data)                                               (0x00000002&((data)<<1))
+#define SDIO_DBG_1_write_enable1_src(data)                                           ((0x00000002&(data))>>1)
+#define SDIO_DBG_1_get_write_enable1(data)                                           ((0x00000002&(data))>>1)
+#define SDIO_DBG_1_enable_shift                                                      (0)
+#define SDIO_DBG_1_enable_mask                                                       (0x00000001)
+#define SDIO_DBG_1_enable(data)                                                      (0x00000001&((data)<<0))
+#define SDIO_DBG_1_enable_src(data)                                                  ((0x00000001&(data))>>0)
+#define SDIO_DBG_1_get_enable(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define SDIO_DBG_2                                                                   0x18010A24
+#define SDIO_DBG_2_reg_addr                                                          "0xB8010A24"
+#define SDIO_DBG_2_reg                                                               0xB8010A24
+#define set_SDIO_DBG_2_reg(data)   (*((volatile unsigned int*) SDIO_DBG_2_reg)=data)
+#define get_SDIO_DBG_2_reg   (*((volatile unsigned int*) SDIO_DBG_2_reg))
+#define SDIO_DBG_2_inst_adr                                                          "0x0089"
+#define SDIO_DBG_2_inst                                                              0x0089
+#define SDIO_DBG_2_dbus_dbg_sel_shift                                                (0)
+#define SDIO_DBG_2_dbus_dbg_sel_mask                                                 (0x00000007)
+#define SDIO_DBG_2_dbus_dbg_sel(data)                                                (0x00000007&((data)<<0))
+#define SDIO_DBG_2_dbus_dbg_sel_src(data)                                            ((0x00000007&(data))>>0)
+#define SDIO_DBG_2_get_dbus_dbg_sel(data)                                            ((0x00000007&(data))>>0)
+
+
+#define SDIO_DBG_3                                                                   0x18010A28
+#define SDIO_DBG_3_reg_addr                                                          "0xB8010A28"
+#define SDIO_DBG_3_reg                                                               0xB8010A28
+#define set_SDIO_DBG_3_reg(data)   (*((volatile unsigned int*) SDIO_DBG_3_reg)=data)
+#define get_SDIO_DBG_3_reg   (*((volatile unsigned int*) SDIO_DBG_3_reg))
+#define SDIO_DBG_3_inst_adr                                                          "0x008A"
+#define SDIO_DBG_3_inst                                                              0x008A
+#define SDIO_DBG_3_ip_dbg_sel_shift                                                  (0)
+#define SDIO_DBG_3_ip_dbg_sel_mask                                                   (0x000000FF)
+#define SDIO_DBG_3_ip_dbg_sel(data)                                                  (0x000000FF&((data)<<0))
+#define SDIO_DBG_3_ip_dbg_sel_src(data)                                              ((0x000000FF&(data))>>0)
+#define SDIO_DBG_3_get_ip_dbg_sel(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define SDIO_ISR                                                                     0x18010A30
+#define SDIO_ISR_reg_addr                                                            "0xB8010A30"
+#define SDIO_ISR_reg                                                                 0xB8010A30
+#define set_SDIO_ISR_reg(data)   (*((volatile unsigned int*) SDIO_ISR_reg)=data)
+#define get_SDIO_ISR_reg   (*((volatile unsigned int*) SDIO_ISR_reg))
+#define SDIO_ISR_inst_adr                                                            "0x008C"
+#define SDIO_ISR_inst                                                                0x008C
+#define SDIO_ISR_Int4_shift                                                          (4)
+#define SDIO_ISR_Int4_mask                                                           (0x00000010)
+#define SDIO_ISR_Int4(data)                                                          (0x00000010&((data)<<4))
+#define SDIO_ISR_Int4_src(data)                                                      ((0x00000010&(data))>>4)
+#define SDIO_ISR_get_Int4(data)                                                      ((0x00000010&(data))>>4)
+#define SDIO_ISR_Int3_shift                                                          (3)
+#define SDIO_ISR_Int3_mask                                                           (0x00000008)
+#define SDIO_ISR_Int3(data)                                                          (0x00000008&((data)<<3))
+#define SDIO_ISR_Int3_src(data)                                                      ((0x00000008&(data))>>3)
+#define SDIO_ISR_get_Int3(data)                                                      ((0x00000008&(data))>>3)
+#define SDIO_ISR_Int2_shift                                                          (2)
+#define SDIO_ISR_Int2_mask                                                           (0x00000004)
+#define SDIO_ISR_Int2(data)                                                          (0x00000004&((data)<<2))
+#define SDIO_ISR_Int2_src(data)                                                      ((0x00000004&(data))>>2)
+#define SDIO_ISR_get_Int2(data)                                                      ((0x00000004&(data))>>2)
+#define SDIO_ISR_Int1_shift                                                          (1)
+#define SDIO_ISR_Int1_mask                                                           (0x00000002)
+#define SDIO_ISR_Int1(data)                                                          (0x00000002&((data)<<1))
+#define SDIO_ISR_Int1_src(data)                                                      ((0x00000002&(data))>>1)
+#define SDIO_ISR_get_Int1(data)                                                      ((0x00000002&(data))>>1)
+#define SDIO_ISR_write_data_shift                                                    (0)
+#define SDIO_ISR_write_data_mask                                                     (0x00000001)
+#define SDIO_ISR_write_data(data)                                                    (0x00000001&((data)<<0))
+#define SDIO_ISR_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define SDIO_ISR_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define SDIO_ISREN                                                                   0x18010A34
+#define SDIO_ISREN_reg_addr                                                          "0xB8010A34"
+#define SDIO_ISREN_reg                                                               0xB8010A34
+#define set_SDIO_ISREN_reg(data)   (*((volatile unsigned int*) SDIO_ISREN_reg)=data)
+#define get_SDIO_ISREN_reg   (*((volatile unsigned int*) SDIO_ISREN_reg))
+#define SDIO_ISREN_inst_adr                                                          "0x008D"
+#define SDIO_ISREN_inst                                                              0x008D
+#define SDIO_ISREN_Int1En_shift                                                      (1)
+#define SDIO_ISREN_Int1En_mask                                                       (0x00000002)
+#define SDIO_ISREN_Int1En(data)                                                      (0x00000002&((data)<<1))
+#define SDIO_ISREN_Int1En_src(data)                                                  ((0x00000002&(data))>>1)
+#define SDIO_ISREN_get_Int1En(data)                                                  ((0x00000002&(data))>>1)
+#define SDIO_ISREN_write_data_shift                                                  (0)
+#define SDIO_ISREN_write_data_mask                                                   (0x00000001)
+#define SDIO_ISREN_write_data(data)                                                  (0x00000001&((data)<<0))
+#define SDIO_ISREN_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define SDIO_ISREN_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/se_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/se_reg.h
new file mode 100644
index 00000000..4e8d069
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/se_reg.h
@@ -0,0 +1,4603 @@
+/**************************************************************
+// Spec Version                  : 0.3
+// Parser Version                : DVR_Parser_6.8(110516)
+// CModelGen Version             : 5.0 2009.04.09
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2011/12/23 11:59:49
+***************************************************************/
+
+
+#ifndef _SE_REG_H_INCLUDED_
+#define _SE_REG_H_INCLUDED_
+#ifdef  _SE_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     base:27;
+unsigned int     reserved_1:4;
+}SE_CMDBASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     limit:27;
+unsigned int     reserved_1:4;
+}SE_CMDLMT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     rptr:27;
+unsigned int     reserved_1:4;
+}SE_CMDRPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     wptr:27;
+unsigned int     reserved_1:4;
+}SE_CMDWPTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     srwordcnt:7;
+}SE_SRWORDCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     Pri3:2;
+unsigned int     Pri2:2;
+unsigned int     Pri1:2;
+}SE_Q_PRIORITY;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     write_enable10:1;
+unsigned int     rounding_en:1;
+unsigned int     write_enable8:1;
+unsigned int     big_endian_o:1;
+unsigned int     write_enable7:1;
+unsigned int     big_endian_i2:1;
+unsigned int     write_enable6:1;
+unsigned int     big_endian_i1:1;
+unsigned int     write_enable5:1;
+unsigned int     alpha_loc2:1;
+unsigned int     reserved_1:6;
+unsigned int     write_enable2:1;
+unsigned int     alpha_loc:1;
+unsigned int     write_enable1:1;
+unsigned int     Format:4;
+}SE_CLR_FMT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     color_key:24;
+}SE_COLOR_KEY;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     dst_color_key:24;
+}SE_DST_COLOR_KEY;
+
+typedef struct 
+{
+unsigned int     src_color:32;
+}SE_SRC_COLOR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     src_alpha:8;
+}SE_SRC_ALPHA;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dest_alpha:8;
+}SE_DEST_ALPHA;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     rslt_alpha:8;
+}SE_RSLT_ALPHA;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     baddr:31;
+}SE_BADDR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     interleave:1;
+unsigned int     pitch:16;
+}SE_PITCH1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     baddr:31;
+}SE_BADDR2;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     interleave:1;
+unsigned int     pitch:16;
+}SE_PITCH2;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     baddr:31;
+}SE_BADDR3;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     interleave:1;
+unsigned int     pitch:16;
+}SE_PITCH3;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     clipen:1;
+unsigned int     xmin:12;
+unsigned int     xmax:12;
+}SE_CLIP_XCOOR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ymin:12;
+unsigned int     ymax:12;
+}SE_CLIP_YCOOR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     clipen:1;
+unsigned int     xmin:12;
+unsigned int     xmax:12;
+}SE_CLIP_XCOOR2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ymin:12;
+unsigned int     ymax:12;
+}SE_CLIP_YCOOR2;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     clipen:1;
+unsigned int     xmin:12;
+unsigned int     xmax:12;
+}SE_CLIP_XCOOR3;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     ymin:12;
+unsigned int     ymax:12;
+}SE_CLIP_YCOOR3;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     clut_lock_st:2;
+}SE_CLUT_LOCK_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     hdown:1;
+unsigned int     vdown:1;
+unsigned int     hup:1;
+unsigned int     vup:1;
+}SE_CONVSCALING;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     m01:13;
+unsigned int     m00:13;
+}SE_CONVCOEF1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     m10:13;
+unsigned int     m02:13;
+}SE_CONVCOEF2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     m12:13;
+unsigned int     m11:13;
+}SE_CONVCOEF3;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     m21:13;
+unsigned int     m20:13;
+}SE_CONVCOEF4;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     m22:13;
+}SE_CONVCOEF5;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     a2:10;
+unsigned int     a1:10;
+unsigned int     a0:10;
+}SE_CONVCOEF6;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     color_key:24;
+}SE_FCV_BITBLIT_COLOR_KEY;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     src_clr_add_red:9;
+unsigned int     reserved_1:7;
+unsigned int     src_clr_mul_red:9;
+}SE_SRC_CLR_RED;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     src_clr_add_green:9;
+unsigned int     reserved_1:7;
+unsigned int     src_clr_mul_green:9;
+}SE_SRC_CLR_GREEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     src_clr_add_blue:9;
+unsigned int     reserved_1:7;
+unsigned int     src_clr_mul_blue:9;
+}SE_SRC_CLR_BLUE;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     src_clr_add_alpha:9;
+unsigned int     reserved_1:7;
+unsigned int     src_clr_mul_alpha:9;
+}SE_SRC_CLR_ALPHA;
+
+typedef struct 
+{
+unsigned int     auto_dir_en:1;
+unsigned int     vo_plane:1;
+unsigned int     before_vo_cur:1;
+unsigned int     after_vo_cur:1;
+unsigned int     vbi:1;
+unsigned int     vo_osd_plane:1;
+unsigned int     reserved_0:14;
+unsigned int     margin_VOtoSE:12;
+}SE_SYNC_VO_MARGIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     VO_current_y:12;
+}SE_SYNC_VO_LOCATION;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     repl_alpha:1;
+unsigned int     repl_color:1;
+unsigned int     ref_alpha:1;
+unsigned int     htype:2;
+unsigned int     vtype:1;
+unsigned int     hodd:1;
+unsigned int     vodd:1;
+}SE_STRETCH;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     H_scaling_iniph:4;
+unsigned int     H_scaling_dph_msb:4;
+unsigned int     H_scaling_dph_lsb:14;
+}SE_HDHS;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     V_scaling_iniph:4;
+unsigned int     V_scaling_dph_msb:4;
+unsigned int     V_scaling_dph_lsb:14;
+}SE_VDHS;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     hcoef:14;
+}SE_HCOEF1;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     hcoef:14;
+}SE_HCOEF1_32;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     vcoef:14;
+}SE_VCOEF1;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     vcoef:14;
+}SE_VCOEF1_16;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     hcoef:14;
+}SE_HCOEF2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     hcoef:14;
+}SE_HCOEF2_32;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     vcoef:14;
+}SE_VCOEF2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     vcoef:14;
+}SE_VCOEF2_16;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     hcoef:14;
+}SE_HCOEF3;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     hcoef:14;
+}SE_HCOEF3_32;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     vcoef:14;
+}SE_VCOEF3;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     vcoef:14;
+}SE_VCOEF3_16;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     color_key:24;
+}SE_SC_BITBLIT_COLOR_KEY;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     endiswap:1;
+unsigned int     go:1;
+unsigned int     write_data:1;
+}SE_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     idle:1;
+}SE_IDLE;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     sel3:1;
+unsigned int     sel2:1;
+unsigned int     sel1:1;
+}SE_INTSEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     vo_sync_err:1;
+unsigned int     fmt_err:1;
+unsigned int     reserved_1:12;
+unsigned int     com_empty:1;
+unsigned int     com_err:1;
+unsigned int     sync:1;
+unsigned int     write_data:1;
+}SE_INTS;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     vo_sync_err:1;
+unsigned int     fmt_err:1;
+unsigned int     reserved_1:12;
+unsigned int     com_empty:1;
+unsigned int     com_err:1;
+unsigned int     sync:1;
+unsigned int     write_data:1;
+}SE_INTE;
+
+typedef struct 
+{
+unsigned int     instcnt_l:32;
+}SE_INSTCNT_L;
+
+typedef struct 
+{
+unsigned int     instcnt_h:32;
+}SE_INSTCNT_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     radr:8;
+}SE_CLUT_RADR;
+
+typedef struct 
+{
+unsigned int     value:32;
+}SE_CLUT_VALUE;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     dbg_en:1;
+unsigned int     dbg_module_sel1:4;
+unsigned int     dbg_module_sel0:4;
+unsigned int     reserved_1:3;
+unsigned int     dbg_sel1:5;
+unsigned int     reserved_2:3;
+unsigned int     dbg_sel0:5;
+}SE_DBG;
+
+typedef struct 
+{
+unsigned int     Reg1:16;
+unsigned int     Reg0:16;
+}SE_SCTCH;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     Gcra_en:1;
+}SE_GCRA_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Gcra_req_num:24;
+}SE_GCRA_REQ_CNT;
+
+typedef struct 
+{
+unsigned int     Gcra_tim_cnt:32;
+}SE_GCRA_TIM_CNT;
+
+typedef struct 
+{
+unsigned int     Gcra_tim_thr:32;
+}SE_GCRA_TIM_THR;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     Gcra_req_thr:24;
+}SE_GCRA_REQ_THR;
+
+#endif
+
+#define SE_CMDBASE_0                                                                 0x1800C000
+#define SE_CMDBASE_1                                                                 0x1800C004
+#define SE_CMDBASE_2                                                                 0x1800C008
+#define SE_CMDBASE_0_reg_addr                                                        "0xB800C000"
+#define SE_CMDBASE_1_reg_addr                                                        "0xB800C004"
+#define SE_CMDBASE_2_reg_addr                                                        "0xB800C008"
+#define SE_CMDBASE_0_reg                                                             0xB800C000
+#define SE_CMDBASE_1_reg                                                             0xB800C004
+#define SE_CMDBASE_2_reg                                                             0xB800C008
+#define set_SE_CMDBASE_0_reg(data)   (*((volatile unsigned int*) SE_CMDBASE_0_reg)=data)
+#define set_SE_CMDBASE_1_reg(data)   (*((volatile unsigned int*) SE_CMDBASE_1_reg)=data)
+#define set_SE_CMDBASE_2_reg(data)   (*((volatile unsigned int*) SE_CMDBASE_2_reg)=data)
+#define get_SE_CMDBASE_0_reg   (*((volatile unsigned int*) SE_CMDBASE_0_reg))
+#define get_SE_CMDBASE_1_reg   (*((volatile unsigned int*) SE_CMDBASE_1_reg))
+#define get_SE_CMDBASE_2_reg   (*((volatile unsigned int*) SE_CMDBASE_2_reg))
+#define SE_CMDBASE_0_inst_adr                                                        "0x0000"
+#define SE_CMDBASE_1_inst_adr                                                        "0x0001"
+#define SE_CMDBASE_2_inst_adr                                                        "0x0002"
+#define SE_CMDBASE_0_inst                                                            0x0000
+#define SE_CMDBASE_1_inst                                                            0x0001
+#define SE_CMDBASE_2_inst                                                            0x0002
+#define SE_CMDBASE_base_shift                                                        (4)
+#define SE_CMDBASE_base_mask                                                         (0x7FFFFFF0)
+#define SE_CMDBASE_base(data)                                                        (0x7FFFFFF0&((data)<<4))
+#define SE_CMDBASE_base_src(data)                                                    ((0x7FFFFFF0&(data))>>4)
+#define SE_CMDBASE_get_base(data)                                                    ((0x7FFFFFF0&(data))>>4)
+
+
+#define SE_CMDLMT_0                                                                  0x1800C00C
+#define SE_CMDLMT_1                                                                  0x1800C010
+#define SE_CMDLMT_2                                                                  0x1800C014
+#define SE_CMDLMT_0_reg_addr                                                         "0xB800C00C"
+#define SE_CMDLMT_1_reg_addr                                                         "0xB800C010"
+#define SE_CMDLMT_2_reg_addr                                                         "0xB800C014"
+#define SE_CMDLMT_0_reg                                                              0xB800C00C
+#define SE_CMDLMT_1_reg                                                              0xB800C010
+#define SE_CMDLMT_2_reg                                                              0xB800C014
+#define set_SE_CMDLMT_0_reg(data)   (*((volatile unsigned int*) SE_CMDLMT_0_reg)=data)
+#define set_SE_CMDLMT_1_reg(data)   (*((volatile unsigned int*) SE_CMDLMT_1_reg)=data)
+#define set_SE_CMDLMT_2_reg(data)   (*((volatile unsigned int*) SE_CMDLMT_2_reg)=data)
+#define get_SE_CMDLMT_0_reg   (*((volatile unsigned int*) SE_CMDLMT_0_reg))
+#define get_SE_CMDLMT_1_reg   (*((volatile unsigned int*) SE_CMDLMT_1_reg))
+#define get_SE_CMDLMT_2_reg   (*((volatile unsigned int*) SE_CMDLMT_2_reg))
+#define SE_CMDLMT_0_inst_adr                                                         "0x0003"
+#define SE_CMDLMT_1_inst_adr                                                         "0x0004"
+#define SE_CMDLMT_2_inst_adr                                                         "0x0005"
+#define SE_CMDLMT_0_inst                                                             0x0003
+#define SE_CMDLMT_1_inst                                                             0x0004
+#define SE_CMDLMT_2_inst                                                             0x0005
+#define SE_CMDLMT_limit_shift                                                        (4)
+#define SE_CMDLMT_limit_mask                                                         (0x7FFFFFF0)
+#define SE_CMDLMT_limit(data)                                                        (0x7FFFFFF0&((data)<<4))
+#define SE_CMDLMT_limit_src(data)                                                    ((0x7FFFFFF0&(data))>>4)
+#define SE_CMDLMT_get_limit(data)                                                    ((0x7FFFFFF0&(data))>>4)
+
+
+#define SE_CMDRPTR_0                                                                 0x1800C018
+#define SE_CMDRPTR_1                                                                 0x1800C01C
+#define SE_CMDRPTR_2                                                                 0x1800C020
+#define SE_CMDRPTR_0_reg_addr                                                        "0xB800C018"
+#define SE_CMDRPTR_1_reg_addr                                                        "0xB800C01C"
+#define SE_CMDRPTR_2_reg_addr                                                        "0xB800C020"
+#define SE_CMDRPTR_0_reg                                                             0xB800C018
+#define SE_CMDRPTR_1_reg                                                             0xB800C01C
+#define SE_CMDRPTR_2_reg                                                             0xB800C020
+#define set_SE_CMDRPTR_0_reg(data)   (*((volatile unsigned int*) SE_CMDRPTR_0_reg)=data)
+#define set_SE_CMDRPTR_1_reg(data)   (*((volatile unsigned int*) SE_CMDRPTR_1_reg)=data)
+#define set_SE_CMDRPTR_2_reg(data)   (*((volatile unsigned int*) SE_CMDRPTR_2_reg)=data)
+#define get_SE_CMDRPTR_0_reg   (*((volatile unsigned int*) SE_CMDRPTR_0_reg))
+#define get_SE_CMDRPTR_1_reg   (*((volatile unsigned int*) SE_CMDRPTR_1_reg))
+#define get_SE_CMDRPTR_2_reg   (*((volatile unsigned int*) SE_CMDRPTR_2_reg))
+#define SE_CMDRPTR_0_inst_adr                                                        "0x0006"
+#define SE_CMDRPTR_1_inst_adr                                                        "0x0007"
+#define SE_CMDRPTR_2_inst_adr                                                        "0x0008"
+#define SE_CMDRPTR_0_inst                                                            0x0006
+#define SE_CMDRPTR_1_inst                                                            0x0007
+#define SE_CMDRPTR_2_inst                                                            0x0008
+#define SE_CMDRPTR_rptr_shift                                                        (4)
+#define SE_CMDRPTR_rptr_mask                                                         (0x7FFFFFF0)
+#define SE_CMDRPTR_rptr(data)                                                        (0x7FFFFFF0&((data)<<4))
+#define SE_CMDRPTR_rptr_src(data)                                                    ((0x7FFFFFF0&(data))>>4)
+#define SE_CMDRPTR_get_rptr(data)                                                    ((0x7FFFFFF0&(data))>>4)
+
+
+#define SE_CMDWPTR_0                                                                 0x1800C024
+#define SE_CMDWPTR_1                                                                 0x1800C028
+#define SE_CMDWPTR_2                                                                 0x1800C02C
+#define SE_CMDWPTR_0_reg_addr                                                        "0xB800C024"
+#define SE_CMDWPTR_1_reg_addr                                                        "0xB800C028"
+#define SE_CMDWPTR_2_reg_addr                                                        "0xB800C02C"
+#define SE_CMDWPTR_0_reg                                                             0xB800C024
+#define SE_CMDWPTR_1_reg                                                             0xB800C028
+#define SE_CMDWPTR_2_reg                                                             0xB800C02C
+#define set_SE_CMDWPTR_0_reg(data)   (*((volatile unsigned int*) SE_CMDWPTR_0_reg)=data)
+#define set_SE_CMDWPTR_1_reg(data)   (*((volatile unsigned int*) SE_CMDWPTR_1_reg)=data)
+#define set_SE_CMDWPTR_2_reg(data)   (*((volatile unsigned int*) SE_CMDWPTR_2_reg)=data)
+#define get_SE_CMDWPTR_0_reg   (*((volatile unsigned int*) SE_CMDWPTR_0_reg))
+#define get_SE_CMDWPTR_1_reg   (*((volatile unsigned int*) SE_CMDWPTR_1_reg))
+#define get_SE_CMDWPTR_2_reg   (*((volatile unsigned int*) SE_CMDWPTR_2_reg))
+#define SE_CMDWPTR_0_inst_adr                                                        "0x0009"
+#define SE_CMDWPTR_1_inst_adr                                                        "0x000A"
+#define SE_CMDWPTR_2_inst_adr                                                        "0x000B"
+#define SE_CMDWPTR_0_inst                                                            0x0009
+#define SE_CMDWPTR_1_inst                                                            0x000A
+#define SE_CMDWPTR_2_inst                                                            0x000B
+#define SE_CMDWPTR_wptr_shift                                                        (4)
+#define SE_CMDWPTR_wptr_mask                                                         (0x7FFFFFF0)
+#define SE_CMDWPTR_wptr(data)                                                        (0x7FFFFFF0&((data)<<4))
+#define SE_CMDWPTR_wptr_src(data)                                                    ((0x7FFFFFF0&(data))>>4)
+#define SE_CMDWPTR_get_wptr(data)                                                    ((0x7FFFFFF0&(data))>>4)
+
+
+#define SE_SRWORDCNT_0                                                               0x1800C030
+#define SE_SRWORDCNT_1                                                               0x1800C034
+#define SE_SRWORDCNT_2                                                               0x1800C038
+#define SE_SRWORDCNT_0_reg_addr                                                      "0xB800C030"
+#define SE_SRWORDCNT_1_reg_addr                                                      "0xB800C034"
+#define SE_SRWORDCNT_2_reg_addr                                                      "0xB800C038"
+#define SE_SRWORDCNT_0_reg                                                           0xB800C030
+#define SE_SRWORDCNT_1_reg                                                           0xB800C034
+#define SE_SRWORDCNT_2_reg                                                           0xB800C038
+#define set_SE_SRWORDCNT_0_reg(data)   (*((volatile unsigned int*) SE_SRWORDCNT_0_reg)=data)
+#define set_SE_SRWORDCNT_1_reg(data)   (*((volatile unsigned int*) SE_SRWORDCNT_1_reg)=data)
+#define set_SE_SRWORDCNT_2_reg(data)   (*((volatile unsigned int*) SE_SRWORDCNT_2_reg)=data)
+#define get_SE_SRWORDCNT_0_reg   (*((volatile unsigned int*) SE_SRWORDCNT_0_reg))
+#define get_SE_SRWORDCNT_1_reg   (*((volatile unsigned int*) SE_SRWORDCNT_1_reg))
+#define get_SE_SRWORDCNT_2_reg   (*((volatile unsigned int*) SE_SRWORDCNT_2_reg))
+#define SE_SRWORDCNT_0_inst_adr                                                      "0x000C"
+#define SE_SRWORDCNT_1_inst_adr                                                      "0x000D"
+#define SE_SRWORDCNT_2_inst_adr                                                      "0x000E"
+#define SE_SRWORDCNT_0_inst                                                          0x000C
+#define SE_SRWORDCNT_1_inst                                                          0x000D
+#define SE_SRWORDCNT_2_inst                                                          0x000E
+#define SE_SRWORDCNT_srwordcnt_shift                                                 (0)
+#define SE_SRWORDCNT_srwordcnt_mask                                                  (0x0000007F)
+#define SE_SRWORDCNT_srwordcnt(data)                                                 (0x0000007F&((data)<<0))
+#define SE_SRWORDCNT_srwordcnt_src(data)                                             ((0x0000007F&(data))>>0)
+#define SE_SRWORDCNT_get_srwordcnt(data)                                             ((0x0000007F&(data))>>0)
+
+
+#define SE_Q_PRIORITY                                                                0x1800C03C
+#define SE_Q_PRIORITY_reg_addr                                                       "0xB800C03C"
+#define SE_Q_PRIORITY_reg                                                            0xB800C03C
+#define set_SE_Q_PRIORITY_reg(data)   (*((volatile unsigned int*) SE_Q_PRIORITY_reg)=data)
+#define get_SE_Q_PRIORITY_reg   (*((volatile unsigned int*) SE_Q_PRIORITY_reg))
+#define SE_Q_PRIORITY_inst_adr                                                       "0x000F"
+#define SE_Q_PRIORITY_inst                                                           0x000F
+#define SE_Q_PRIORITY_Pri3_shift                                                     (4)
+#define SE_Q_PRIORITY_Pri3_mask                                                      (0x00000030)
+#define SE_Q_PRIORITY_Pri3(data)                                                     (0x00000030&((data)<<4))
+#define SE_Q_PRIORITY_Pri3_src(data)                                                 ((0x00000030&(data))>>4)
+#define SE_Q_PRIORITY_get_Pri3(data)                                                 ((0x00000030&(data))>>4)
+#define SE_Q_PRIORITY_Pri2_shift                                                     (2)
+#define SE_Q_PRIORITY_Pri2_mask                                                      (0x0000000C)
+#define SE_Q_PRIORITY_Pri2(data)                                                     (0x0000000C&((data)<<2))
+#define SE_Q_PRIORITY_Pri2_src(data)                                                 ((0x0000000C&(data))>>2)
+#define SE_Q_PRIORITY_get_Pri2(data)                                                 ((0x0000000C&(data))>>2)
+#define SE_Q_PRIORITY_Pri1_shift                                                     (0)
+#define SE_Q_PRIORITY_Pri1_mask                                                      (0x00000003)
+#define SE_Q_PRIORITY_Pri1(data)                                                     (0x00000003&((data)<<0))
+#define SE_Q_PRIORITY_Pri1_src(data)                                                 ((0x00000003&(data))>>0)
+#define SE_Q_PRIORITY_get_Pri1(data)                                                 ((0x00000003&(data))>>0)
+
+
+#define SE_CLR_FMT_0                                                                 0x1800C040
+#define SE_CLR_FMT_1                                                                 0x1800C044
+#define SE_CLR_FMT_2                                                                 0x1800C048
+#define SE_CLR_FMT_0_reg_addr                                                        "0xB800C040"
+#define SE_CLR_FMT_1_reg_addr                                                        "0xB800C044"
+#define SE_CLR_FMT_2_reg_addr                                                        "0xB800C048"
+#define SE_CLR_FMT_0_reg                                                             0xB800C040
+#define SE_CLR_FMT_1_reg                                                             0xB800C044
+#define SE_CLR_FMT_2_reg                                                             0xB800C048
+#define set_SE_CLR_FMT_0_reg(data)   (*((volatile unsigned int*) SE_CLR_FMT_0_reg)=data)
+#define set_SE_CLR_FMT_1_reg(data)   (*((volatile unsigned int*) SE_CLR_FMT_1_reg)=data)
+#define set_SE_CLR_FMT_2_reg(data)   (*((volatile unsigned int*) SE_CLR_FMT_2_reg)=data)
+#define get_SE_CLR_FMT_0_reg   (*((volatile unsigned int*) SE_CLR_FMT_0_reg))
+#define get_SE_CLR_FMT_1_reg   (*((volatile unsigned int*) SE_CLR_FMT_1_reg))
+#define get_SE_CLR_FMT_2_reg   (*((volatile unsigned int*) SE_CLR_FMT_2_reg))
+#define SE_CLR_FMT_0_inst_adr                                                        "0x0010"
+#define SE_CLR_FMT_1_inst_adr                                                        "0x0011"
+#define SE_CLR_FMT_2_inst_adr                                                        "0x0012"
+#define SE_CLR_FMT_0_inst                                                            0x0010
+#define SE_CLR_FMT_1_inst                                                            0x0011
+#define SE_CLR_FMT_2_inst                                                            0x0012
+#define SE_CLR_FMT_write_enable10_shift                                              (22)
+#define SE_CLR_FMT_write_enable10_mask                                               (0x00400000)
+#define SE_CLR_FMT_write_enable10(data)                                              (0x00400000&((data)<<22))
+#define SE_CLR_FMT_write_enable10_src(data)                                          ((0x00400000&(data))>>22)
+#define SE_CLR_FMT_get_write_enable10(data)                                          ((0x00400000&(data))>>22)
+#define SE_CLR_FMT_rounding_en_shift                                                 (21)
+#define SE_CLR_FMT_rounding_en_mask                                                  (0x00200000)
+#define SE_CLR_FMT_rounding_en(data)                                                 (0x00200000&((data)<<21))
+#define SE_CLR_FMT_rounding_en_src(data)                                             ((0x00200000&(data))>>21)
+#define SE_CLR_FMT_get_rounding_en(data)                                             ((0x00200000&(data))>>21)
+#define SE_CLR_FMT_write_enable8_shift                                               (20)
+#define SE_CLR_FMT_write_enable8_mask                                                (0x00100000)
+#define SE_CLR_FMT_write_enable8(data)                                               (0x00100000&((data)<<20))
+#define SE_CLR_FMT_write_enable8_src(data)                                           ((0x00100000&(data))>>20)
+#define SE_CLR_FMT_get_write_enable8(data)                                           ((0x00100000&(data))>>20)
+#define SE_CLR_FMT_big_endian_o_shift                                                (19)
+#define SE_CLR_FMT_big_endian_o_mask                                                 (0x00080000)
+#define SE_CLR_FMT_big_endian_o(data)                                                (0x00080000&((data)<<19))
+#define SE_CLR_FMT_big_endian_o_src(data)                                            ((0x00080000&(data))>>19)
+#define SE_CLR_FMT_get_big_endian_o(data)                                            ((0x00080000&(data))>>19)
+#define SE_CLR_FMT_write_enable7_shift                                               (18)
+#define SE_CLR_FMT_write_enable7_mask                                                (0x00040000)
+#define SE_CLR_FMT_write_enable7(data)                                               (0x00040000&((data)<<18))
+#define SE_CLR_FMT_write_enable7_src(data)                                           ((0x00040000&(data))>>18)
+#define SE_CLR_FMT_get_write_enable7(data)                                           ((0x00040000&(data))>>18)
+#define SE_CLR_FMT_big_endian_i2_shift                                               (17)
+#define SE_CLR_FMT_big_endian_i2_mask                                                (0x00020000)
+#define SE_CLR_FMT_big_endian_i2(data)                                               (0x00020000&((data)<<17))
+#define SE_CLR_FMT_big_endian_i2_src(data)                                           ((0x00020000&(data))>>17)
+#define SE_CLR_FMT_get_big_endian_i2(data)                                           ((0x00020000&(data))>>17)
+#define SE_CLR_FMT_write_enable6_shift                                               (16)
+#define SE_CLR_FMT_write_enable6_mask                                                (0x00010000)
+#define SE_CLR_FMT_write_enable6(data)                                               (0x00010000&((data)<<16))
+#define SE_CLR_FMT_write_enable6_src(data)                                           ((0x00010000&(data))>>16)
+#define SE_CLR_FMT_get_write_enable6(data)                                           ((0x00010000&(data))>>16)
+#define SE_CLR_FMT_big_endian_i1_shift                                               (15)
+#define SE_CLR_FMT_big_endian_i1_mask                                                (0x00008000)
+#define SE_CLR_FMT_big_endian_i1(data)                                               (0x00008000&((data)<<15))
+#define SE_CLR_FMT_big_endian_i1_src(data)                                           ((0x00008000&(data))>>15)
+#define SE_CLR_FMT_get_big_endian_i1(data)                                           ((0x00008000&(data))>>15)
+#define SE_CLR_FMT_write_enable5_shift                                               (14)
+#define SE_CLR_FMT_write_enable5_mask                                                (0x00004000)
+#define SE_CLR_FMT_write_enable5(data)                                               (0x00004000&((data)<<14))
+#define SE_CLR_FMT_write_enable5_src(data)                                           ((0x00004000&(data))>>14)
+#define SE_CLR_FMT_get_write_enable5(data)                                           ((0x00004000&(data))>>14)
+#define SE_CLR_FMT_alpha_loc2_shift                                                  (13)
+#define SE_CLR_FMT_alpha_loc2_mask                                                   (0x00002000)
+#define SE_CLR_FMT_alpha_loc2(data)                                                  (0x00002000&((data)<<13))
+#define SE_CLR_FMT_alpha_loc2_src(data)                                              ((0x00002000&(data))>>13)
+#define SE_CLR_FMT_get_alpha_loc2(data)                                              ((0x00002000&(data))>>13)
+#define SE_CLR_FMT_write_enable2_shift                                               (6)
+#define SE_CLR_FMT_write_enable2_mask                                                (0x00000040)
+#define SE_CLR_FMT_write_enable2(data)                                               (0x00000040&((data)<<6))
+#define SE_CLR_FMT_write_enable2_src(data)                                           ((0x00000040&(data))>>6)
+#define SE_CLR_FMT_get_write_enable2(data)                                           ((0x00000040&(data))>>6)
+#define SE_CLR_FMT_alpha_loc_shift                                                   (5)
+#define SE_CLR_FMT_alpha_loc_mask                                                    (0x00000020)
+#define SE_CLR_FMT_alpha_loc(data)                                                   (0x00000020&((data)<<5))
+#define SE_CLR_FMT_alpha_loc_src(data)                                               ((0x00000020&(data))>>5)
+#define SE_CLR_FMT_get_alpha_loc(data)                                               ((0x00000020&(data))>>5)
+#define SE_CLR_FMT_write_enable1_shift                                               (4)
+#define SE_CLR_FMT_write_enable1_mask                                                (0x00000010)
+#define SE_CLR_FMT_write_enable1(data)                                               (0x00000010&((data)<<4))
+#define SE_CLR_FMT_write_enable1_src(data)                                           ((0x00000010&(data))>>4)
+#define SE_CLR_FMT_get_write_enable1(data)                                           ((0x00000010&(data))>>4)
+#define SE_CLR_FMT_Format_shift                                                      (0)
+#define SE_CLR_FMT_Format_mask                                                       (0x0000000F)
+#define SE_CLR_FMT_Format(data)                                                      (0x0000000F&((data)<<0))
+#define SE_CLR_FMT_Format_src(data)                                                  ((0x0000000F&(data))>>0)
+#define SE_CLR_FMT_get_Format(data)                                                  ((0x0000000F&(data))>>0)
+
+
+#define SE_COLOR_KEY_0                                                               0x1800C04C
+#define SE_COLOR_KEY_1                                                               0x1800C050
+#define SE_COLOR_KEY_2                                                               0x1800C054
+#define SE_COLOR_KEY_0_reg_addr                                                      "0xB800C04C"
+#define SE_COLOR_KEY_1_reg_addr                                                      "0xB800C050"
+#define SE_COLOR_KEY_2_reg_addr                                                      "0xB800C054"
+#define SE_COLOR_KEY_0_reg                                                           0xB800C04C
+#define SE_COLOR_KEY_1_reg                                                           0xB800C050
+#define SE_COLOR_KEY_2_reg                                                           0xB800C054
+#define set_SE_COLOR_KEY_0_reg(data)   (*((volatile unsigned int*) SE_COLOR_KEY_0_reg)=data)
+#define set_SE_COLOR_KEY_1_reg(data)   (*((volatile unsigned int*) SE_COLOR_KEY_1_reg)=data)
+#define set_SE_COLOR_KEY_2_reg(data)   (*((volatile unsigned int*) SE_COLOR_KEY_2_reg)=data)
+#define get_SE_COLOR_KEY_0_reg   (*((volatile unsigned int*) SE_COLOR_KEY_0_reg))
+#define get_SE_COLOR_KEY_1_reg   (*((volatile unsigned int*) SE_COLOR_KEY_1_reg))
+#define get_SE_COLOR_KEY_2_reg   (*((volatile unsigned int*) SE_COLOR_KEY_2_reg))
+#define SE_COLOR_KEY_0_inst_adr                                                      "0x0013"
+#define SE_COLOR_KEY_1_inst_adr                                                      "0x0014"
+#define SE_COLOR_KEY_2_inst_adr                                                      "0x0015"
+#define SE_COLOR_KEY_0_inst                                                          0x0013
+#define SE_COLOR_KEY_1_inst                                                          0x0014
+#define SE_COLOR_KEY_2_inst                                                          0x0015
+#define SE_COLOR_KEY_color_key_shift                                                 (0)
+#define SE_COLOR_KEY_color_key_mask                                                  (0x00FFFFFF)
+#define SE_COLOR_KEY_color_key(data)                                                 (0x00FFFFFF&((data)<<0))
+#define SE_COLOR_KEY_color_key_src(data)                                             ((0x00FFFFFF&(data))>>0)
+#define SE_COLOR_KEY_get_color_key(data)                                             ((0x00FFFFFF&(data))>>0)
+
+
+#define SE_DST_COLOR_KEY_0                                                           0x1800C54C
+#define SE_DST_COLOR_KEY_1                                                           0x1800C550
+#define SE_DST_COLOR_KEY_2                                                           0x1800C554
+#define SE_DST_COLOR_KEY_0_reg_addr                                                  "0xB800C54C"
+#define SE_DST_COLOR_KEY_1_reg_addr                                                  "0xB800C550"
+#define SE_DST_COLOR_KEY_2_reg_addr                                                  "0xB800C554"
+#define SE_DST_COLOR_KEY_0_reg                                                       0xB800C54C
+#define SE_DST_COLOR_KEY_1_reg                                                       0xB800C550
+#define SE_DST_COLOR_KEY_2_reg                                                       0xB800C554
+#define set_SE_DST_COLOR_KEY_0_reg(data)   (*((volatile unsigned int*) SE_DST_COLOR_KEY_0_reg)=data)
+#define set_SE_DST_COLOR_KEY_1_reg(data)   (*((volatile unsigned int*) SE_DST_COLOR_KEY_1_reg)=data)
+#define set_SE_DST_COLOR_KEY_2_reg(data)   (*((volatile unsigned int*) SE_DST_COLOR_KEY_2_reg)=data)
+#define get_SE_DST_COLOR_KEY_0_reg   (*((volatile unsigned int*) SE_DST_COLOR_KEY_0_reg))
+#define get_SE_DST_COLOR_KEY_1_reg   (*((volatile unsigned int*) SE_DST_COLOR_KEY_1_reg))
+#define get_SE_DST_COLOR_KEY_2_reg   (*((volatile unsigned int*) SE_DST_COLOR_KEY_2_reg))
+#define SE_DST_COLOR_KEY_0_inst_adr                                                  "0x0053"
+#define SE_DST_COLOR_KEY_1_inst_adr                                                  "0x0054"
+#define SE_DST_COLOR_KEY_2_inst_adr                                                  "0x0055"
+#define SE_DST_COLOR_KEY_0_inst                                                      0x0053
+#define SE_DST_COLOR_KEY_1_inst                                                      0x0054
+#define SE_DST_COLOR_KEY_2_inst                                                      0x0055
+#define SE_DST_COLOR_KEY_dst_color_key_shift                                         (0)
+#define SE_DST_COLOR_KEY_dst_color_key_mask                                          (0x00FFFFFF)
+#define SE_DST_COLOR_KEY_dst_color_key(data)                                         (0x00FFFFFF&((data)<<0))
+#define SE_DST_COLOR_KEY_dst_color_key_src(data)                                     ((0x00FFFFFF&(data))>>0)
+#define SE_DST_COLOR_KEY_get_dst_color_key(data)                                     ((0x00FFFFFF&(data))>>0)
+
+
+#define SE_SRC_COLOR_0                                                               0x1800C058
+#define SE_SRC_COLOR_1                                                               0x1800C05C
+#define SE_SRC_COLOR_2                                                               0x1800C060
+#define SE_SRC_COLOR_0_reg_addr                                                      "0xB800C058"
+#define SE_SRC_COLOR_1_reg_addr                                                      "0xB800C05C"
+#define SE_SRC_COLOR_2_reg_addr                                                      "0xB800C060"
+#define SE_SRC_COLOR_0_reg                                                           0xB800C058
+#define SE_SRC_COLOR_1_reg                                                           0xB800C05C
+#define SE_SRC_COLOR_2_reg                                                           0xB800C060
+#define set_SE_SRC_COLOR_0_reg(data)   (*((volatile unsigned int*) SE_SRC_COLOR_0_reg)=data)
+#define set_SE_SRC_COLOR_1_reg(data)   (*((volatile unsigned int*) SE_SRC_COLOR_1_reg)=data)
+#define set_SE_SRC_COLOR_2_reg(data)   (*((volatile unsigned int*) SE_SRC_COLOR_2_reg)=data)
+#define get_SE_SRC_COLOR_0_reg   (*((volatile unsigned int*) SE_SRC_COLOR_0_reg))
+#define get_SE_SRC_COLOR_1_reg   (*((volatile unsigned int*) SE_SRC_COLOR_1_reg))
+#define get_SE_SRC_COLOR_2_reg   (*((volatile unsigned int*) SE_SRC_COLOR_2_reg))
+#define SE_SRC_COLOR_0_inst_adr                                                      "0x0016"
+#define SE_SRC_COLOR_1_inst_adr                                                      "0x0017"
+#define SE_SRC_COLOR_2_inst_adr                                                      "0x0018"
+#define SE_SRC_COLOR_0_inst                                                          0x0016
+#define SE_SRC_COLOR_1_inst                                                          0x0017
+#define SE_SRC_COLOR_2_inst                                                          0x0018
+#define SE_SRC_COLOR_src_color_shift                                                 (0)
+#define SE_SRC_COLOR_src_color_mask                                                  (0xFFFFFFFF)
+#define SE_SRC_COLOR_src_color(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SE_SRC_COLOR_src_color_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SE_SRC_COLOR_get_src_color(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SE_SRC_ALPHA_0                                                               0x1800C070
+#define SE_SRC_ALPHA_1                                                               0x1800C074
+#define SE_SRC_ALPHA_2                                                               0x1800C078
+#define SE_SRC_ALPHA_0_reg_addr                                                      "0xB800C070"
+#define SE_SRC_ALPHA_1_reg_addr                                                      "0xB800C074"
+#define SE_SRC_ALPHA_2_reg_addr                                                      "0xB800C078"
+#define SE_SRC_ALPHA_0_reg                                                           0xB800C070
+#define SE_SRC_ALPHA_1_reg                                                           0xB800C074
+#define SE_SRC_ALPHA_2_reg                                                           0xB800C078
+#define set_SE_SRC_ALPHA_0_reg(data)   (*((volatile unsigned int*) SE_SRC_ALPHA_0_reg)=data)
+#define set_SE_SRC_ALPHA_1_reg(data)   (*((volatile unsigned int*) SE_SRC_ALPHA_1_reg)=data)
+#define set_SE_SRC_ALPHA_2_reg(data)   (*((volatile unsigned int*) SE_SRC_ALPHA_2_reg)=data)
+#define get_SE_SRC_ALPHA_0_reg   (*((volatile unsigned int*) SE_SRC_ALPHA_0_reg))
+#define get_SE_SRC_ALPHA_1_reg   (*((volatile unsigned int*) SE_SRC_ALPHA_1_reg))
+#define get_SE_SRC_ALPHA_2_reg   (*((volatile unsigned int*) SE_SRC_ALPHA_2_reg))
+#define SE_SRC_ALPHA_0_inst_adr                                                      "0x001C"
+#define SE_SRC_ALPHA_1_inst_adr                                                      "0x001D"
+#define SE_SRC_ALPHA_2_inst_adr                                                      "0x001E"
+#define SE_SRC_ALPHA_0_inst                                                          0x001C
+#define SE_SRC_ALPHA_1_inst                                                          0x001D
+#define SE_SRC_ALPHA_2_inst                                                          0x001E
+#define SE_SRC_ALPHA_src_alpha_shift                                                 (0)
+#define SE_SRC_ALPHA_src_alpha_mask                                                  (0x000000FF)
+#define SE_SRC_ALPHA_src_alpha(data)                                                 (0x000000FF&((data)<<0))
+#define SE_SRC_ALPHA_src_alpha_src(data)                                             ((0x000000FF&(data))>>0)
+#define SE_SRC_ALPHA_get_src_alpha(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define SE_DEST_ALPHA_0                                                              0x1800C07C
+#define SE_DEST_ALPHA_1                                                              0x1800C080
+#define SE_DEST_ALPHA_2                                                              0x1800C084
+#define SE_DEST_ALPHA_0_reg_addr                                                     "0xB800C07C"
+#define SE_DEST_ALPHA_1_reg_addr                                                     "0xB800C080"
+#define SE_DEST_ALPHA_2_reg_addr                                                     "0xB800C084"
+#define SE_DEST_ALPHA_0_reg                                                          0xB800C07C
+#define SE_DEST_ALPHA_1_reg                                                          0xB800C080
+#define SE_DEST_ALPHA_2_reg                                                          0xB800C084
+#define set_SE_DEST_ALPHA_0_reg(data)   (*((volatile unsigned int*) SE_DEST_ALPHA_0_reg)=data)
+#define set_SE_DEST_ALPHA_1_reg(data)   (*((volatile unsigned int*) SE_DEST_ALPHA_1_reg)=data)
+#define set_SE_DEST_ALPHA_2_reg(data)   (*((volatile unsigned int*) SE_DEST_ALPHA_2_reg)=data)
+#define get_SE_DEST_ALPHA_0_reg   (*((volatile unsigned int*) SE_DEST_ALPHA_0_reg))
+#define get_SE_DEST_ALPHA_1_reg   (*((volatile unsigned int*) SE_DEST_ALPHA_1_reg))
+#define get_SE_DEST_ALPHA_2_reg   (*((volatile unsigned int*) SE_DEST_ALPHA_2_reg))
+#define SE_DEST_ALPHA_0_inst_adr                                                     "0x001F"
+#define SE_DEST_ALPHA_1_inst_adr                                                     "0x0020"
+#define SE_DEST_ALPHA_2_inst_adr                                                     "0x0021"
+#define SE_DEST_ALPHA_0_inst                                                         0x001F
+#define SE_DEST_ALPHA_1_inst                                                         0x0020
+#define SE_DEST_ALPHA_2_inst                                                         0x0021
+#define SE_DEST_ALPHA_dest_alpha_shift                                               (0)
+#define SE_DEST_ALPHA_dest_alpha_mask                                                (0x000000FF)
+#define SE_DEST_ALPHA_dest_alpha(data)                                               (0x000000FF&((data)<<0))
+#define SE_DEST_ALPHA_dest_alpha_src(data)                                           ((0x000000FF&(data))>>0)
+#define SE_DEST_ALPHA_get_dest_alpha(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define SE_RSLT_ALPHA_0                                                              0x1800C088
+#define SE_RSLT_ALPHA_1                                                              0x1800C08C
+#define SE_RSLT_ALPHA_2                                                              0x1800C090
+#define SE_RSLT_ALPHA_0_reg_addr                                                     "0xB800C088"
+#define SE_RSLT_ALPHA_1_reg_addr                                                     "0xB800C08C"
+#define SE_RSLT_ALPHA_2_reg_addr                                                     "0xB800C090"
+#define SE_RSLT_ALPHA_0_reg                                                          0xB800C088
+#define SE_RSLT_ALPHA_1_reg                                                          0xB800C08C
+#define SE_RSLT_ALPHA_2_reg                                                          0xB800C090
+#define set_SE_RSLT_ALPHA_0_reg(data)   (*((volatile unsigned int*) SE_RSLT_ALPHA_0_reg)=data)
+#define set_SE_RSLT_ALPHA_1_reg(data)   (*((volatile unsigned int*) SE_RSLT_ALPHA_1_reg)=data)
+#define set_SE_RSLT_ALPHA_2_reg(data)   (*((volatile unsigned int*) SE_RSLT_ALPHA_2_reg)=data)
+#define get_SE_RSLT_ALPHA_0_reg   (*((volatile unsigned int*) SE_RSLT_ALPHA_0_reg))
+#define get_SE_RSLT_ALPHA_1_reg   (*((volatile unsigned int*) SE_RSLT_ALPHA_1_reg))
+#define get_SE_RSLT_ALPHA_2_reg   (*((volatile unsigned int*) SE_RSLT_ALPHA_2_reg))
+#define SE_RSLT_ALPHA_0_inst_adr                                                     "0x0022"
+#define SE_RSLT_ALPHA_1_inst_adr                                                     "0x0023"
+#define SE_RSLT_ALPHA_2_inst_adr                                                     "0x0024"
+#define SE_RSLT_ALPHA_0_inst                                                         0x0022
+#define SE_RSLT_ALPHA_1_inst                                                         0x0023
+#define SE_RSLT_ALPHA_2_inst                                                         0x0024
+#define SE_RSLT_ALPHA_rslt_alpha_shift                                               (0)
+#define SE_RSLT_ALPHA_rslt_alpha_mask                                                (0x000000FF)
+#define SE_RSLT_ALPHA_rslt_alpha(data)                                               (0x000000FF&((data)<<0))
+#define SE_RSLT_ALPHA_rslt_alpha_src(data)                                           ((0x000000FF&(data))>>0)
+#define SE_RSLT_ALPHA_get_rslt_alpha(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define SE_BADDR1_0                                                                  0x1800C094
+#define SE_BADDR1_1                                                                  0x1800C098
+#define SE_BADDR1_2                                                                  0x1800C09C
+#define SE_BADDR1_3                                                                  0x1800C0A0
+#define SE_BADDR1_0_reg_addr                                                         "0xB800C094"
+#define SE_BADDR1_1_reg_addr                                                         "0xB800C098"
+#define SE_BADDR1_2_reg_addr                                                         "0xB800C09C"
+#define SE_BADDR1_3_reg_addr                                                         "0xB800C0A0"
+#define SE_BADDR1_0_reg                                                              0xB800C094
+#define SE_BADDR1_1_reg                                                              0xB800C098
+#define SE_BADDR1_2_reg                                                              0xB800C09C
+#define SE_BADDR1_3_reg                                                              0xB800C0A0
+#define set_SE_BADDR1_0_reg(data)   (*((volatile unsigned int*) SE_BADDR1_0_reg)=data)
+#define set_SE_BADDR1_1_reg(data)   (*((volatile unsigned int*) SE_BADDR1_1_reg)=data)
+#define set_SE_BADDR1_2_reg(data)   (*((volatile unsigned int*) SE_BADDR1_2_reg)=data)
+#define set_SE_BADDR1_3_reg(data)   (*((volatile unsigned int*) SE_BADDR1_3_reg)=data)
+#define get_SE_BADDR1_0_reg   (*((volatile unsigned int*) SE_BADDR1_0_reg))
+#define get_SE_BADDR1_1_reg   (*((volatile unsigned int*) SE_BADDR1_1_reg))
+#define get_SE_BADDR1_2_reg   (*((volatile unsigned int*) SE_BADDR1_2_reg))
+#define get_SE_BADDR1_3_reg   (*((volatile unsigned int*) SE_BADDR1_3_reg))
+#define SE_BADDR1_0_inst_adr                                                         "0x0025"
+#define SE_BADDR1_1_inst_adr                                                         "0x0026"
+#define SE_BADDR1_2_inst_adr                                                         "0x0027"
+#define SE_BADDR1_3_inst_adr                                                         "0x0028"
+#define SE_BADDR1_0_inst                                                             0x0025
+#define SE_BADDR1_1_inst                                                             0x0026
+#define SE_BADDR1_2_inst                                                             0x0027
+#define SE_BADDR1_3_inst                                                             0x0028
+#define SE_BADDR1_baddr_shift                                                        (0)
+#define SE_BADDR1_baddr_mask                                                         (0x7FFFFFFF)
+#define SE_BADDR1_baddr(data)                                                        (0x7FFFFFFF&((data)<<0))
+#define SE_BADDR1_baddr_src(data)                                                    ((0x7FFFFFFF&(data))>>0)
+#define SE_BADDR1_get_baddr(data)                                                    ((0x7FFFFFFF&(data))>>0)
+
+
+#define SE_PITCH1_0                                                                  0x1800C0A4
+#define SE_PITCH1_1                                                                  0x1800C0A8
+#define SE_PITCH1_2                                                                  0x1800C0AC
+#define SE_PITCH1_3                                                                  0x1800C0B0
+#define SE_PITCH1_0_reg_addr                                                         "0xB800C0A4"
+#define SE_PITCH1_1_reg_addr                                                         "0xB800C0A8"
+#define SE_PITCH1_2_reg_addr                                                         "0xB800C0AC"
+#define SE_PITCH1_3_reg_addr                                                         "0xB800C0B0"
+#define SE_PITCH1_0_reg                                                              0xB800C0A4
+#define SE_PITCH1_1_reg                                                              0xB800C0A8
+#define SE_PITCH1_2_reg                                                              0xB800C0AC
+#define SE_PITCH1_3_reg                                                              0xB800C0B0
+#define set_SE_PITCH1_0_reg(data)   (*((volatile unsigned int*) SE_PITCH1_0_reg)=data)
+#define set_SE_PITCH1_1_reg(data)   (*((volatile unsigned int*) SE_PITCH1_1_reg)=data)
+#define set_SE_PITCH1_2_reg(data)   (*((volatile unsigned int*) SE_PITCH1_2_reg)=data)
+#define set_SE_PITCH1_3_reg(data)   (*((volatile unsigned int*) SE_PITCH1_3_reg)=data)
+#define get_SE_PITCH1_0_reg   (*((volatile unsigned int*) SE_PITCH1_0_reg))
+#define get_SE_PITCH1_1_reg   (*((volatile unsigned int*) SE_PITCH1_1_reg))
+#define get_SE_PITCH1_2_reg   (*((volatile unsigned int*) SE_PITCH1_2_reg))
+#define get_SE_PITCH1_3_reg   (*((volatile unsigned int*) SE_PITCH1_3_reg))
+#define SE_PITCH1_0_inst_adr                                                         "0x0029"
+#define SE_PITCH1_1_inst_adr                                                         "0x002A"
+#define SE_PITCH1_2_inst_adr                                                         "0x002B"
+#define SE_PITCH1_3_inst_adr                                                         "0x002C"
+#define SE_PITCH1_0_inst                                                             0x0029
+#define SE_PITCH1_1_inst                                                             0x002A
+#define SE_PITCH1_2_inst                                                             0x002B
+#define SE_PITCH1_3_inst                                                             0x002C
+#define SE_PITCH1_interleave_shift                                                   (16)
+#define SE_PITCH1_interleave_mask                                                    (0x00010000)
+#define SE_PITCH1_interleave(data)                                                   (0x00010000&((data)<<16))
+#define SE_PITCH1_interleave_src(data)                                               ((0x00010000&(data))>>16)
+#define SE_PITCH1_get_interleave(data)                                               ((0x00010000&(data))>>16)
+#define SE_PITCH1_pitch_shift                                                        (0)
+#define SE_PITCH1_pitch_mask                                                         (0x0000FFFF)
+#define SE_PITCH1_pitch(data)                                                        (0x0000FFFF&((data)<<0))
+#define SE_PITCH1_pitch_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define SE_PITCH1_get_pitch(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define SE_BADDR2_0                                                                  0x1800C0B4
+#define SE_BADDR2_1                                                                  0x1800C0B8
+#define SE_BADDR2_2                                                                  0x1800C0BC
+#define SE_BADDR2_3                                                                  0x1800C0C0
+#define SE_BADDR2_0_reg_addr                                                         "0xB800C0B4"
+#define SE_BADDR2_1_reg_addr                                                         "0xB800C0B8"
+#define SE_BADDR2_2_reg_addr                                                         "0xB800C0BC"
+#define SE_BADDR2_3_reg_addr                                                         "0xB800C0C0"
+#define SE_BADDR2_0_reg                                                              0xB800C0B4
+#define SE_BADDR2_1_reg                                                              0xB800C0B8
+#define SE_BADDR2_2_reg                                                              0xB800C0BC
+#define SE_BADDR2_3_reg                                                              0xB800C0C0
+#define set_SE_BADDR2_0_reg(data)   (*((volatile unsigned int*) SE_BADDR2_0_reg)=data)
+#define set_SE_BADDR2_1_reg(data)   (*((volatile unsigned int*) SE_BADDR2_1_reg)=data)
+#define set_SE_BADDR2_2_reg(data)   (*((volatile unsigned int*) SE_BADDR2_2_reg)=data)
+#define set_SE_BADDR2_3_reg(data)   (*((volatile unsigned int*) SE_BADDR2_3_reg)=data)
+#define get_SE_BADDR2_0_reg   (*((volatile unsigned int*) SE_BADDR2_0_reg))
+#define get_SE_BADDR2_1_reg   (*((volatile unsigned int*) SE_BADDR2_1_reg))
+#define get_SE_BADDR2_2_reg   (*((volatile unsigned int*) SE_BADDR2_2_reg))
+#define get_SE_BADDR2_3_reg   (*((volatile unsigned int*) SE_BADDR2_3_reg))
+#define SE_BADDR2_0_inst_adr                                                         "0x002D"
+#define SE_BADDR2_1_inst_adr                                                         "0x002E"
+#define SE_BADDR2_2_inst_adr                                                         "0x002F"
+#define SE_BADDR2_3_inst_adr                                                         "0x0030"
+#define SE_BADDR2_0_inst                                                             0x002D
+#define SE_BADDR2_1_inst                                                             0x002E
+#define SE_BADDR2_2_inst                                                             0x002F
+#define SE_BADDR2_3_inst                                                             0x0030
+#define SE_BADDR2_baddr_shift                                                        (0)
+#define SE_BADDR2_baddr_mask                                                         (0x7FFFFFFF)
+#define SE_BADDR2_baddr(data)                                                        (0x7FFFFFFF&((data)<<0))
+#define SE_BADDR2_baddr_src(data)                                                    ((0x7FFFFFFF&(data))>>0)
+#define SE_BADDR2_get_baddr(data)                                                    ((0x7FFFFFFF&(data))>>0)
+
+
+#define SE_PITCH2_0                                                                  0x1800C0C4
+#define SE_PITCH2_1                                                                  0x1800C0C8
+#define SE_PITCH2_2                                                                  0x1800C0CC
+#define SE_PITCH2_3                                                                  0x1800C0D0
+#define SE_PITCH2_0_reg_addr                                                         "0xB800C0C4"
+#define SE_PITCH2_1_reg_addr                                                         "0xB800C0C8"
+#define SE_PITCH2_2_reg_addr                                                         "0xB800C0CC"
+#define SE_PITCH2_3_reg_addr                                                         "0xB800C0D0"
+#define SE_PITCH2_0_reg                                                              0xB800C0C4
+#define SE_PITCH2_1_reg                                                              0xB800C0C8
+#define SE_PITCH2_2_reg                                                              0xB800C0CC
+#define SE_PITCH2_3_reg                                                              0xB800C0D0
+#define set_SE_PITCH2_0_reg(data)   (*((volatile unsigned int*) SE_PITCH2_0_reg)=data)
+#define set_SE_PITCH2_1_reg(data)   (*((volatile unsigned int*) SE_PITCH2_1_reg)=data)
+#define set_SE_PITCH2_2_reg(data)   (*((volatile unsigned int*) SE_PITCH2_2_reg)=data)
+#define set_SE_PITCH2_3_reg(data)   (*((volatile unsigned int*) SE_PITCH2_3_reg)=data)
+#define get_SE_PITCH2_0_reg   (*((volatile unsigned int*) SE_PITCH2_0_reg))
+#define get_SE_PITCH2_1_reg   (*((volatile unsigned int*) SE_PITCH2_1_reg))
+#define get_SE_PITCH2_2_reg   (*((volatile unsigned int*) SE_PITCH2_2_reg))
+#define get_SE_PITCH2_3_reg   (*((volatile unsigned int*) SE_PITCH2_3_reg))
+#define SE_PITCH2_0_inst_adr                                                         "0x0031"
+#define SE_PITCH2_1_inst_adr                                                         "0x0032"
+#define SE_PITCH2_2_inst_adr                                                         "0x0033"
+#define SE_PITCH2_3_inst_adr                                                         "0x0034"
+#define SE_PITCH2_0_inst                                                             0x0031
+#define SE_PITCH2_1_inst                                                             0x0032
+#define SE_PITCH2_2_inst                                                             0x0033
+#define SE_PITCH2_3_inst                                                             0x0034
+#define SE_PITCH2_interleave_shift                                                   (16)
+#define SE_PITCH2_interleave_mask                                                    (0x00010000)
+#define SE_PITCH2_interleave(data)                                                   (0x00010000&((data)<<16))
+#define SE_PITCH2_interleave_src(data)                                               ((0x00010000&(data))>>16)
+#define SE_PITCH2_get_interleave(data)                                               ((0x00010000&(data))>>16)
+#define SE_PITCH2_pitch_shift                                                        (0)
+#define SE_PITCH2_pitch_mask                                                         (0x0000FFFF)
+#define SE_PITCH2_pitch(data)                                                        (0x0000FFFF&((data)<<0))
+#define SE_PITCH2_pitch_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define SE_PITCH2_get_pitch(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define SE_BADDR3_0                                                                  0x1800C0D4
+#define SE_BADDR3_1                                                                  0x1800C0D8
+#define SE_BADDR3_2                                                                  0x1800C0DC
+#define SE_BADDR3_3                                                                  0x1800C0E0
+#define SE_BADDR3_0_reg_addr                                                         "0xB800C0D4"
+#define SE_BADDR3_1_reg_addr                                                         "0xB800C0D8"
+#define SE_BADDR3_2_reg_addr                                                         "0xB800C0DC"
+#define SE_BADDR3_3_reg_addr                                                         "0xB800C0E0"
+#define SE_BADDR3_0_reg                                                              0xB800C0D4
+#define SE_BADDR3_1_reg                                                              0xB800C0D8
+#define SE_BADDR3_2_reg                                                              0xB800C0DC
+#define SE_BADDR3_3_reg                                                              0xB800C0E0
+#define set_SE_BADDR3_0_reg(data)   (*((volatile unsigned int*) SE_BADDR3_0_reg)=data)
+#define set_SE_BADDR3_1_reg(data)   (*((volatile unsigned int*) SE_BADDR3_1_reg)=data)
+#define set_SE_BADDR3_2_reg(data)   (*((volatile unsigned int*) SE_BADDR3_2_reg)=data)
+#define set_SE_BADDR3_3_reg(data)   (*((volatile unsigned int*) SE_BADDR3_3_reg)=data)
+#define get_SE_BADDR3_0_reg   (*((volatile unsigned int*) SE_BADDR3_0_reg))
+#define get_SE_BADDR3_1_reg   (*((volatile unsigned int*) SE_BADDR3_1_reg))
+#define get_SE_BADDR3_2_reg   (*((volatile unsigned int*) SE_BADDR3_2_reg))
+#define get_SE_BADDR3_3_reg   (*((volatile unsigned int*) SE_BADDR3_3_reg))
+#define SE_BADDR3_0_inst_adr                                                         "0x0035"
+#define SE_BADDR3_1_inst_adr                                                         "0x0036"
+#define SE_BADDR3_2_inst_adr                                                         "0x0037"
+#define SE_BADDR3_3_inst_adr                                                         "0x0038"
+#define SE_BADDR3_0_inst                                                             0x0035
+#define SE_BADDR3_1_inst                                                             0x0036
+#define SE_BADDR3_2_inst                                                             0x0037
+#define SE_BADDR3_3_inst                                                             0x0038
+#define SE_BADDR3_baddr_shift                                                        (0)
+#define SE_BADDR3_baddr_mask                                                         (0x7FFFFFFF)
+#define SE_BADDR3_baddr(data)                                                        (0x7FFFFFFF&((data)<<0))
+#define SE_BADDR3_baddr_src(data)                                                    ((0x7FFFFFFF&(data))>>0)
+#define SE_BADDR3_get_baddr(data)                                                    ((0x7FFFFFFF&(data))>>0)
+
+
+#define SE_PITCH3_0                                                                  0x1800C0E4
+#define SE_PITCH3_1                                                                  0x1800C0E8
+#define SE_PITCH3_2                                                                  0x1800C0EC
+#define SE_PITCH3_3                                                                  0x1800C0F0
+#define SE_PITCH3_0_reg_addr                                                         "0xB800C0E4"
+#define SE_PITCH3_1_reg_addr                                                         "0xB800C0E8"
+#define SE_PITCH3_2_reg_addr                                                         "0xB800C0EC"
+#define SE_PITCH3_3_reg_addr                                                         "0xB800C0F0"
+#define SE_PITCH3_0_reg                                                              0xB800C0E4
+#define SE_PITCH3_1_reg                                                              0xB800C0E8
+#define SE_PITCH3_2_reg                                                              0xB800C0EC
+#define SE_PITCH3_3_reg                                                              0xB800C0F0
+#define set_SE_PITCH3_0_reg(data)   (*((volatile unsigned int*) SE_PITCH3_0_reg)=data)
+#define set_SE_PITCH3_1_reg(data)   (*((volatile unsigned int*) SE_PITCH3_1_reg)=data)
+#define set_SE_PITCH3_2_reg(data)   (*((volatile unsigned int*) SE_PITCH3_2_reg)=data)
+#define set_SE_PITCH3_3_reg(data)   (*((volatile unsigned int*) SE_PITCH3_3_reg)=data)
+#define get_SE_PITCH3_0_reg   (*((volatile unsigned int*) SE_PITCH3_0_reg))
+#define get_SE_PITCH3_1_reg   (*((volatile unsigned int*) SE_PITCH3_1_reg))
+#define get_SE_PITCH3_2_reg   (*((volatile unsigned int*) SE_PITCH3_2_reg))
+#define get_SE_PITCH3_3_reg   (*((volatile unsigned int*) SE_PITCH3_3_reg))
+#define SE_PITCH3_0_inst_adr                                                         "0x0039"
+#define SE_PITCH3_1_inst_adr                                                         "0x003A"
+#define SE_PITCH3_2_inst_adr                                                         "0x003B"
+#define SE_PITCH3_3_inst_adr                                                         "0x003C"
+#define SE_PITCH3_0_inst                                                             0x0039
+#define SE_PITCH3_1_inst                                                             0x003A
+#define SE_PITCH3_2_inst                                                             0x003B
+#define SE_PITCH3_3_inst                                                             0x003C
+#define SE_PITCH3_interleave_shift                                                   (16)
+#define SE_PITCH3_interleave_mask                                                    (0x00010000)
+#define SE_PITCH3_interleave(data)                                                   (0x00010000&((data)<<16))
+#define SE_PITCH3_interleave_src(data)                                               ((0x00010000&(data))>>16)
+#define SE_PITCH3_get_interleave(data)                                               ((0x00010000&(data))>>16)
+#define SE_PITCH3_pitch_shift                                                        (0)
+#define SE_PITCH3_pitch_mask                                                         (0x0000FFFF)
+#define SE_PITCH3_pitch(data)                                                        (0x0000FFFF&((data)<<0))
+#define SE_PITCH3_pitch_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define SE_PITCH3_get_pitch(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define SE_CLIP_XCOOR1_0                                                             0x1800C128
+#define SE_CLIP_XCOOR1_1                                                             0x1800C12C
+#define SE_CLIP_XCOOR1_2                                                             0x1800C130
+#define SE_CLIP_XCOOR1_3                                                             0x1800C134
+#define SE_CLIP_XCOOR1_0_reg_addr                                                    "0xB800C128"
+#define SE_CLIP_XCOOR1_1_reg_addr                                                    "0xB800C12C"
+#define SE_CLIP_XCOOR1_2_reg_addr                                                    "0xB800C130"
+#define SE_CLIP_XCOOR1_3_reg_addr                                                    "0xB800C134"
+#define SE_CLIP_XCOOR1_0_reg                                                         0xB800C128
+#define SE_CLIP_XCOOR1_1_reg                                                         0xB800C12C
+#define SE_CLIP_XCOOR1_2_reg                                                         0xB800C130
+#define SE_CLIP_XCOOR1_3_reg                                                         0xB800C134
+#define set_SE_CLIP_XCOOR1_0_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR1_0_reg)=data)
+#define set_SE_CLIP_XCOOR1_1_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR1_1_reg)=data)
+#define set_SE_CLIP_XCOOR1_2_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR1_2_reg)=data)
+#define set_SE_CLIP_XCOOR1_3_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR1_3_reg)=data)
+#define get_SE_CLIP_XCOOR1_0_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR1_0_reg))
+#define get_SE_CLIP_XCOOR1_1_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR1_1_reg))
+#define get_SE_CLIP_XCOOR1_2_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR1_2_reg))
+#define get_SE_CLIP_XCOOR1_3_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR1_3_reg))
+#define SE_CLIP_XCOOR1_0_inst_adr                                                    "0x004A"
+#define SE_CLIP_XCOOR1_1_inst_adr                                                    "0x004B"
+#define SE_CLIP_XCOOR1_2_inst_adr                                                    "0x004C"
+#define SE_CLIP_XCOOR1_3_inst_adr                                                    "0x004D"
+#define SE_CLIP_XCOOR1_0_inst                                                        0x004A
+#define SE_CLIP_XCOOR1_1_inst                                                        0x004B
+#define SE_CLIP_XCOOR1_2_inst                                                        0x004C
+#define SE_CLIP_XCOOR1_3_inst                                                        0x004D
+#define SE_CLIP_XCOOR1_clipen_shift                                                  (24)
+#define SE_CLIP_XCOOR1_clipen_mask                                                   (0x01000000)
+#define SE_CLIP_XCOOR1_clipen(data)                                                  (0x01000000&((data)<<24))
+#define SE_CLIP_XCOOR1_clipen_src(data)                                              ((0x01000000&(data))>>24)
+#define SE_CLIP_XCOOR1_get_clipen(data)                                              ((0x01000000&(data))>>24)
+#define SE_CLIP_XCOOR1_xmin_shift                                                    (12)
+#define SE_CLIP_XCOOR1_xmin_mask                                                     (0x00FFF000)
+#define SE_CLIP_XCOOR1_xmin(data)                                                    (0x00FFF000&((data)<<12))
+#define SE_CLIP_XCOOR1_xmin_src(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_XCOOR1_get_xmin(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_XCOOR1_xmax_shift                                                    (0)
+#define SE_CLIP_XCOOR1_xmax_mask                                                     (0x00000FFF)
+#define SE_CLIP_XCOOR1_xmax(data)                                                    (0x00000FFF&((data)<<0))
+#define SE_CLIP_XCOOR1_xmax_src(data)                                                ((0x00000FFF&(data))>>0)
+#define SE_CLIP_XCOOR1_get_xmax(data)                                                ((0x00000FFF&(data))>>0)
+
+
+#define SE_CLIP_YCOOR1_0                                                             0x1800C138
+#define SE_CLIP_YCOOR1_1                                                             0x1800C13C
+#define SE_CLIP_YCOOR1_2                                                             0x1800C140
+#define SE_CLIP_YCOOR1_3                                                             0x1800C144
+#define SE_CLIP_YCOOR1_0_reg_addr                                                    "0xB800C138"
+#define SE_CLIP_YCOOR1_1_reg_addr                                                    "0xB800C13C"
+#define SE_CLIP_YCOOR1_2_reg_addr                                                    "0xB800C140"
+#define SE_CLIP_YCOOR1_3_reg_addr                                                    "0xB800C144"
+#define SE_CLIP_YCOOR1_0_reg                                                         0xB800C138
+#define SE_CLIP_YCOOR1_1_reg                                                         0xB800C13C
+#define SE_CLIP_YCOOR1_2_reg                                                         0xB800C140
+#define SE_CLIP_YCOOR1_3_reg                                                         0xB800C144
+#define set_SE_CLIP_YCOOR1_0_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR1_0_reg)=data)
+#define set_SE_CLIP_YCOOR1_1_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR1_1_reg)=data)
+#define set_SE_CLIP_YCOOR1_2_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR1_2_reg)=data)
+#define set_SE_CLIP_YCOOR1_3_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR1_3_reg)=data)
+#define get_SE_CLIP_YCOOR1_0_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR1_0_reg))
+#define get_SE_CLIP_YCOOR1_1_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR1_1_reg))
+#define get_SE_CLIP_YCOOR1_2_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR1_2_reg))
+#define get_SE_CLIP_YCOOR1_3_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR1_3_reg))
+#define SE_CLIP_YCOOR1_0_inst_adr                                                    "0x004E"
+#define SE_CLIP_YCOOR1_1_inst_adr                                                    "0x004F"
+#define SE_CLIP_YCOOR1_2_inst_adr                                                    "0x0050"
+#define SE_CLIP_YCOOR1_3_inst_adr                                                    "0x0051"
+#define SE_CLIP_YCOOR1_0_inst                                                        0x004E
+#define SE_CLIP_YCOOR1_1_inst                                                        0x004F
+#define SE_CLIP_YCOOR1_2_inst                                                        0x0050
+#define SE_CLIP_YCOOR1_3_inst                                                        0x0051
+#define SE_CLIP_YCOOR1_ymin_shift                                                    (12)
+#define SE_CLIP_YCOOR1_ymin_mask                                                     (0x00FFF000)
+#define SE_CLIP_YCOOR1_ymin(data)                                                    (0x00FFF000&((data)<<12))
+#define SE_CLIP_YCOOR1_ymin_src(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_YCOOR1_get_ymin(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_YCOOR1_ymax_shift                                                    (0)
+#define SE_CLIP_YCOOR1_ymax_mask                                                     (0x00000FFF)
+#define SE_CLIP_YCOOR1_ymax(data)                                                    (0x00000FFF&((data)<<0))
+#define SE_CLIP_YCOOR1_ymax_src(data)                                                ((0x00000FFF&(data))>>0)
+#define SE_CLIP_YCOOR1_get_ymax(data)                                                ((0x00000FFF&(data))>>0)
+
+
+#define SE_CLIP_XCOOR2_0                                                             0x1800C148
+#define SE_CLIP_XCOOR2_1                                                             0x1800C14C
+#define SE_CLIP_XCOOR2_2                                                             0x1800C150
+#define SE_CLIP_XCOOR2_3                                                             0x1800C154
+#define SE_CLIP_XCOOR2_0_reg_addr                                                    "0xB800C148"
+#define SE_CLIP_XCOOR2_1_reg_addr                                                    "0xB800C14C"
+#define SE_CLIP_XCOOR2_2_reg_addr                                                    "0xB800C150"
+#define SE_CLIP_XCOOR2_3_reg_addr                                                    "0xB800C154"
+#define SE_CLIP_XCOOR2_0_reg                                                         0xB800C148
+#define SE_CLIP_XCOOR2_1_reg                                                         0xB800C14C
+#define SE_CLIP_XCOOR2_2_reg                                                         0xB800C150
+#define SE_CLIP_XCOOR2_3_reg                                                         0xB800C154
+#define set_SE_CLIP_XCOOR2_0_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR2_0_reg)=data)
+#define set_SE_CLIP_XCOOR2_1_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR2_1_reg)=data)
+#define set_SE_CLIP_XCOOR2_2_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR2_2_reg)=data)
+#define set_SE_CLIP_XCOOR2_3_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR2_3_reg)=data)
+#define get_SE_CLIP_XCOOR2_0_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR2_0_reg))
+#define get_SE_CLIP_XCOOR2_1_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR2_1_reg))
+#define get_SE_CLIP_XCOOR2_2_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR2_2_reg))
+#define get_SE_CLIP_XCOOR2_3_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR2_3_reg))
+#define SE_CLIP_XCOOR2_0_inst_adr                                                    "0x0052"
+#define SE_CLIP_XCOOR2_1_inst_adr                                                    "0x0053"
+#define SE_CLIP_XCOOR2_2_inst_adr                                                    "0x0054"
+#define SE_CLIP_XCOOR2_3_inst_adr                                                    "0x0055"
+#define SE_CLIP_XCOOR2_0_inst                                                        0x0052
+#define SE_CLIP_XCOOR2_1_inst                                                        0x0053
+#define SE_CLIP_XCOOR2_2_inst                                                        0x0054
+#define SE_CLIP_XCOOR2_3_inst                                                        0x0055
+#define SE_CLIP_XCOOR2_clipen_shift                                                  (24)
+#define SE_CLIP_XCOOR2_clipen_mask                                                   (0x01000000)
+#define SE_CLIP_XCOOR2_clipen(data)                                                  (0x01000000&((data)<<24))
+#define SE_CLIP_XCOOR2_clipen_src(data)                                              ((0x01000000&(data))>>24)
+#define SE_CLIP_XCOOR2_get_clipen(data)                                              ((0x01000000&(data))>>24)
+#define SE_CLIP_XCOOR2_xmin_shift                                                    (12)
+#define SE_CLIP_XCOOR2_xmin_mask                                                     (0x00FFF000)
+#define SE_CLIP_XCOOR2_xmin(data)                                                    (0x00FFF000&((data)<<12))
+#define SE_CLIP_XCOOR2_xmin_src(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_XCOOR2_get_xmin(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_XCOOR2_xmax_shift                                                    (0)
+#define SE_CLIP_XCOOR2_xmax_mask                                                     (0x00000FFF)
+#define SE_CLIP_XCOOR2_xmax(data)                                                    (0x00000FFF&((data)<<0))
+#define SE_CLIP_XCOOR2_xmax_src(data)                                                ((0x00000FFF&(data))>>0)
+#define SE_CLIP_XCOOR2_get_xmax(data)                                                ((0x00000FFF&(data))>>0)
+
+
+#define SE_CLIP_YCOOR2_0                                                             0x1800C158
+#define SE_CLIP_YCOOR2_1                                                             0x1800C15C
+#define SE_CLIP_YCOOR2_2                                                             0x1800C160
+#define SE_CLIP_YCOOR2_3                                                             0x1800C164
+#define SE_CLIP_YCOOR2_0_reg_addr                                                    "0xB800C158"
+#define SE_CLIP_YCOOR2_1_reg_addr                                                    "0xB800C15C"
+#define SE_CLIP_YCOOR2_2_reg_addr                                                    "0xB800C160"
+#define SE_CLIP_YCOOR2_3_reg_addr                                                    "0xB800C164"
+#define SE_CLIP_YCOOR2_0_reg                                                         0xB800C158
+#define SE_CLIP_YCOOR2_1_reg                                                         0xB800C15C
+#define SE_CLIP_YCOOR2_2_reg                                                         0xB800C160
+#define SE_CLIP_YCOOR2_3_reg                                                         0xB800C164
+#define set_SE_CLIP_YCOOR2_0_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR2_0_reg)=data)
+#define set_SE_CLIP_YCOOR2_1_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR2_1_reg)=data)
+#define set_SE_CLIP_YCOOR2_2_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR2_2_reg)=data)
+#define set_SE_CLIP_YCOOR2_3_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR2_3_reg)=data)
+#define get_SE_CLIP_YCOOR2_0_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR2_0_reg))
+#define get_SE_CLIP_YCOOR2_1_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR2_1_reg))
+#define get_SE_CLIP_YCOOR2_2_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR2_2_reg))
+#define get_SE_CLIP_YCOOR2_3_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR2_3_reg))
+#define SE_CLIP_YCOOR2_0_inst_adr                                                    "0x0056"
+#define SE_CLIP_YCOOR2_1_inst_adr                                                    "0x0057"
+#define SE_CLIP_YCOOR2_2_inst_adr                                                    "0x0058"
+#define SE_CLIP_YCOOR2_3_inst_adr                                                    "0x0059"
+#define SE_CLIP_YCOOR2_0_inst                                                        0x0056
+#define SE_CLIP_YCOOR2_1_inst                                                        0x0057
+#define SE_CLIP_YCOOR2_2_inst                                                        0x0058
+#define SE_CLIP_YCOOR2_3_inst                                                        0x0059
+#define SE_CLIP_YCOOR2_ymin_shift                                                    (12)
+#define SE_CLIP_YCOOR2_ymin_mask                                                     (0x00FFF000)
+#define SE_CLIP_YCOOR2_ymin(data)                                                    (0x00FFF000&((data)<<12))
+#define SE_CLIP_YCOOR2_ymin_src(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_YCOOR2_get_ymin(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_YCOOR2_ymax_shift                                                    (0)
+#define SE_CLIP_YCOOR2_ymax_mask                                                     (0x00000FFF)
+#define SE_CLIP_YCOOR2_ymax(data)                                                    (0x00000FFF&((data)<<0))
+#define SE_CLIP_YCOOR2_ymax_src(data)                                                ((0x00000FFF&(data))>>0)
+#define SE_CLIP_YCOOR2_get_ymax(data)                                                ((0x00000FFF&(data))>>0)
+
+
+#define SE_CLIP_XCOOR3_0                                                             0x1800C168
+#define SE_CLIP_XCOOR3_1                                                             0x1800C16C
+#define SE_CLIP_XCOOR3_2                                                             0x1800C170
+#define SE_CLIP_XCOOR3_3                                                             0x1800C174
+#define SE_CLIP_XCOOR3_0_reg_addr                                                    "0xB800C168"
+#define SE_CLIP_XCOOR3_1_reg_addr                                                    "0xB800C16C"
+#define SE_CLIP_XCOOR3_2_reg_addr                                                    "0xB800C170"
+#define SE_CLIP_XCOOR3_3_reg_addr                                                    "0xB800C174"
+#define SE_CLIP_XCOOR3_0_reg                                                         0xB800C168
+#define SE_CLIP_XCOOR3_1_reg                                                         0xB800C16C
+#define SE_CLIP_XCOOR3_2_reg                                                         0xB800C170
+#define SE_CLIP_XCOOR3_3_reg                                                         0xB800C174
+#define set_SE_CLIP_XCOOR3_0_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR3_0_reg)=data)
+#define set_SE_CLIP_XCOOR3_1_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR3_1_reg)=data)
+#define set_SE_CLIP_XCOOR3_2_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR3_2_reg)=data)
+#define set_SE_CLIP_XCOOR3_3_reg(data)   (*((volatile unsigned int*) SE_CLIP_XCOOR3_3_reg)=data)
+#define get_SE_CLIP_XCOOR3_0_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR3_0_reg))
+#define get_SE_CLIP_XCOOR3_1_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR3_1_reg))
+#define get_SE_CLIP_XCOOR3_2_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR3_2_reg))
+#define get_SE_CLIP_XCOOR3_3_reg   (*((volatile unsigned int*) SE_CLIP_XCOOR3_3_reg))
+#define SE_CLIP_XCOOR3_0_inst_adr                                                    "0x005A"
+#define SE_CLIP_XCOOR3_1_inst_adr                                                    "0x005B"
+#define SE_CLIP_XCOOR3_2_inst_adr                                                    "0x005C"
+#define SE_CLIP_XCOOR3_3_inst_adr                                                    "0x005D"
+#define SE_CLIP_XCOOR3_0_inst                                                        0x005A
+#define SE_CLIP_XCOOR3_1_inst                                                        0x005B
+#define SE_CLIP_XCOOR3_2_inst                                                        0x005C
+#define SE_CLIP_XCOOR3_3_inst                                                        0x005D
+#define SE_CLIP_XCOOR3_clipen_shift                                                  (24)
+#define SE_CLIP_XCOOR3_clipen_mask                                                   (0x01000000)
+#define SE_CLIP_XCOOR3_clipen(data)                                                  (0x01000000&((data)<<24))
+#define SE_CLIP_XCOOR3_clipen_src(data)                                              ((0x01000000&(data))>>24)
+#define SE_CLIP_XCOOR3_get_clipen(data)                                              ((0x01000000&(data))>>24)
+#define SE_CLIP_XCOOR3_xmin_shift                                                    (12)
+#define SE_CLIP_XCOOR3_xmin_mask                                                     (0x00FFF000)
+#define SE_CLIP_XCOOR3_xmin(data)                                                    (0x00FFF000&((data)<<12))
+#define SE_CLIP_XCOOR3_xmin_src(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_XCOOR3_get_xmin(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_XCOOR3_xmax_shift                                                    (0)
+#define SE_CLIP_XCOOR3_xmax_mask                                                     (0x00000FFF)
+#define SE_CLIP_XCOOR3_xmax(data)                                                    (0x00000FFF&((data)<<0))
+#define SE_CLIP_XCOOR3_xmax_src(data)                                                ((0x00000FFF&(data))>>0)
+#define SE_CLIP_XCOOR3_get_xmax(data)                                                ((0x00000FFF&(data))>>0)
+
+
+#define SE_CLIP_YCOOR3_0                                                             0x1800C178
+#define SE_CLIP_YCOOR3_1                                                             0x1800C17C
+#define SE_CLIP_YCOOR3_2                                                             0x1800C180
+#define SE_CLIP_YCOOR3_3                                                             0x1800C184
+#define SE_CLIP_YCOOR3_0_reg_addr                                                    "0xB800C178"
+#define SE_CLIP_YCOOR3_1_reg_addr                                                    "0xB800C17C"
+#define SE_CLIP_YCOOR3_2_reg_addr                                                    "0xB800C180"
+#define SE_CLIP_YCOOR3_3_reg_addr                                                    "0xB800C184"
+#define SE_CLIP_YCOOR3_0_reg                                                         0xB800C178
+#define SE_CLIP_YCOOR3_1_reg                                                         0xB800C17C
+#define SE_CLIP_YCOOR3_2_reg                                                         0xB800C180
+#define SE_CLIP_YCOOR3_3_reg                                                         0xB800C184
+#define set_SE_CLIP_YCOOR3_0_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR3_0_reg)=data)
+#define set_SE_CLIP_YCOOR3_1_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR3_1_reg)=data)
+#define set_SE_CLIP_YCOOR3_2_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR3_2_reg)=data)
+#define set_SE_CLIP_YCOOR3_3_reg(data)   (*((volatile unsigned int*) SE_CLIP_YCOOR3_3_reg)=data)
+#define get_SE_CLIP_YCOOR3_0_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR3_0_reg))
+#define get_SE_CLIP_YCOOR3_1_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR3_1_reg))
+#define get_SE_CLIP_YCOOR3_2_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR3_2_reg))
+#define get_SE_CLIP_YCOOR3_3_reg   (*((volatile unsigned int*) SE_CLIP_YCOOR3_3_reg))
+#define SE_CLIP_YCOOR3_0_inst_adr                                                    "0x005E"
+#define SE_CLIP_YCOOR3_1_inst_adr                                                    "0x005F"
+#define SE_CLIP_YCOOR3_2_inst_adr                                                    "0x0060"
+#define SE_CLIP_YCOOR3_3_inst_adr                                                    "0x0061"
+#define SE_CLIP_YCOOR3_0_inst                                                        0x005E
+#define SE_CLIP_YCOOR3_1_inst                                                        0x005F
+#define SE_CLIP_YCOOR3_2_inst                                                        0x0060
+#define SE_CLIP_YCOOR3_3_inst                                                        0x0061
+#define SE_CLIP_YCOOR3_ymin_shift                                                    (12)
+#define SE_CLIP_YCOOR3_ymin_mask                                                     (0x00FFF000)
+#define SE_CLIP_YCOOR3_ymin(data)                                                    (0x00FFF000&((data)<<12))
+#define SE_CLIP_YCOOR3_ymin_src(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_YCOOR3_get_ymin(data)                                                ((0x00FFF000&(data))>>12)
+#define SE_CLIP_YCOOR3_ymax_shift                                                    (0)
+#define SE_CLIP_YCOOR3_ymax_mask                                                     (0x00000FFF)
+#define SE_CLIP_YCOOR3_ymax(data)                                                    (0x00000FFF&((data)<<0))
+#define SE_CLIP_YCOOR3_ymax_src(data)                                                ((0x00000FFF&(data))>>0)
+#define SE_CLIP_YCOOR3_get_ymax(data)                                                ((0x00000FFF&(data))>>0)
+
+
+#define SE_CLUT_LOCK_ST                                                              0x1800C4C8
+#define SE_CLUT_LOCK_ST_reg_addr                                                     "0xB800C4C8"
+#define SE_CLUT_LOCK_ST_reg                                                          0xB800C4C8
+#define set_SE_CLUT_LOCK_ST_reg(data)   (*((volatile unsigned int*) SE_CLUT_LOCK_ST_reg)=data)
+#define get_SE_CLUT_LOCK_ST_reg   (*((volatile unsigned int*) SE_CLUT_LOCK_ST_reg))
+#define SE_CLUT_LOCK_ST_inst_adr                                                     "0x0032"
+#define SE_CLUT_LOCK_ST_inst                                                         0x0032
+#define SE_CLUT_LOCK_ST_clut_lock_st_shift                                           (0)
+#define SE_CLUT_LOCK_ST_clut_lock_st_mask                                            (0x00000003)
+#define SE_CLUT_LOCK_ST_clut_lock_st(data)                                           (0x00000003&((data)<<0))
+#define SE_CLUT_LOCK_ST_clut_lock_st_src(data)                                       ((0x00000003&(data))>>0)
+#define SE_CLUT_LOCK_ST_get_clut_lock_st(data)                                       ((0x00000003&(data))>>0)
+
+
+#define SE_CONVSCALING_0                                                             0x1800C188
+#define SE_CONVSCALING_1                                                             0x1800C18C
+#define SE_CONVSCALING_2                                                             0x1800C190
+#define SE_CONVSCALING_0_reg_addr                                                    "0xB800C188"
+#define SE_CONVSCALING_1_reg_addr                                                    "0xB800C18C"
+#define SE_CONVSCALING_2_reg_addr                                                    "0xB800C190"
+#define SE_CONVSCALING_0_reg                                                         0xB800C188
+#define SE_CONVSCALING_1_reg                                                         0xB800C18C
+#define SE_CONVSCALING_2_reg                                                         0xB800C190
+#define set_SE_CONVSCALING_0_reg(data)   (*((volatile unsigned int*) SE_CONVSCALING_0_reg)=data)
+#define set_SE_CONVSCALING_1_reg(data)   (*((volatile unsigned int*) SE_CONVSCALING_1_reg)=data)
+#define set_SE_CONVSCALING_2_reg(data)   (*((volatile unsigned int*) SE_CONVSCALING_2_reg)=data)
+#define get_SE_CONVSCALING_0_reg   (*((volatile unsigned int*) SE_CONVSCALING_0_reg))
+#define get_SE_CONVSCALING_1_reg   (*((volatile unsigned int*) SE_CONVSCALING_1_reg))
+#define get_SE_CONVSCALING_2_reg   (*((volatile unsigned int*) SE_CONVSCALING_2_reg))
+#define SE_CONVSCALING_0_inst_adr                                                    "0x0062"
+#define SE_CONVSCALING_1_inst_adr                                                    "0x0063"
+#define SE_CONVSCALING_2_inst_adr                                                    "0x0064"
+#define SE_CONVSCALING_0_inst                                                        0x0062
+#define SE_CONVSCALING_1_inst                                                        0x0063
+#define SE_CONVSCALING_2_inst                                                        0x0064
+#define SE_CONVSCALING_hdown_shift                                                   (3)
+#define SE_CONVSCALING_hdown_mask                                                    (0x00000008)
+#define SE_CONVSCALING_hdown(data)                                                   (0x00000008&((data)<<3))
+#define SE_CONVSCALING_hdown_src(data)                                               ((0x00000008&(data))>>3)
+#define SE_CONVSCALING_get_hdown(data)                                               ((0x00000008&(data))>>3)
+#define SE_CONVSCALING_vdown_shift                                                   (2)
+#define SE_CONVSCALING_vdown_mask                                                    (0x00000004)
+#define SE_CONVSCALING_vdown(data)                                                   (0x00000004&((data)<<2))
+#define SE_CONVSCALING_vdown_src(data)                                               ((0x00000004&(data))>>2)
+#define SE_CONVSCALING_get_vdown(data)                                               ((0x00000004&(data))>>2)
+#define SE_CONVSCALING_hup_shift                                                     (1)
+#define SE_CONVSCALING_hup_mask                                                      (0x00000002)
+#define SE_CONVSCALING_hup(data)                                                     (0x00000002&((data)<<1))
+#define SE_CONVSCALING_hup_src(data)                                                 ((0x00000002&(data))>>1)
+#define SE_CONVSCALING_get_hup(data)                                                 ((0x00000002&(data))>>1)
+#define SE_CONVSCALING_vup_shift                                                     (0)
+#define SE_CONVSCALING_vup_mask                                                      (0x00000001)
+#define SE_CONVSCALING_vup(data)                                                     (0x00000001&((data)<<0))
+#define SE_CONVSCALING_vup_src(data)                                                 ((0x00000001&(data))>>0)
+#define SE_CONVSCALING_get_vup(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define SE_CONVCOEF1_0                                                               0x1800C194
+#define SE_CONVCOEF1_1                                                               0x1800C198
+#define SE_CONVCOEF1_2                                                               0x1800C19C
+#define SE_CONVCOEF1_0_reg_addr                                                      "0xB800C194"
+#define SE_CONVCOEF1_1_reg_addr                                                      "0xB800C198"
+#define SE_CONVCOEF1_2_reg_addr                                                      "0xB800C19C"
+#define SE_CONVCOEF1_0_reg                                                           0xB800C194
+#define SE_CONVCOEF1_1_reg                                                           0xB800C198
+#define SE_CONVCOEF1_2_reg                                                           0xB800C19C
+#define set_SE_CONVCOEF1_0_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF1_0_reg)=data)
+#define set_SE_CONVCOEF1_1_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF1_1_reg)=data)
+#define set_SE_CONVCOEF1_2_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF1_2_reg)=data)
+#define get_SE_CONVCOEF1_0_reg   (*((volatile unsigned int*) SE_CONVCOEF1_0_reg))
+#define get_SE_CONVCOEF1_1_reg   (*((volatile unsigned int*) SE_CONVCOEF1_1_reg))
+#define get_SE_CONVCOEF1_2_reg   (*((volatile unsigned int*) SE_CONVCOEF1_2_reg))
+#define SE_CONVCOEF1_0_inst_adr                                                      "0x0065"
+#define SE_CONVCOEF1_1_inst_adr                                                      "0x0066"
+#define SE_CONVCOEF1_2_inst_adr                                                      "0x0067"
+#define SE_CONVCOEF1_0_inst                                                          0x0065
+#define SE_CONVCOEF1_1_inst                                                          0x0066
+#define SE_CONVCOEF1_2_inst                                                          0x0067
+#define SE_CONVCOEF1_m01_shift                                                       (13)
+#define SE_CONVCOEF1_m01_mask                                                        (0x03FFE000)
+#define SE_CONVCOEF1_m01(data)                                                       (0x03FFE000&((data)<<13))
+#define SE_CONVCOEF1_m01_src(data)                                                   ((0x03FFE000&(data))>>13)
+#define SE_CONVCOEF1_get_m01(data)                                                   ((0x03FFE000&(data))>>13)
+#define SE_CONVCOEF1_m00_shift                                                       (0)
+#define SE_CONVCOEF1_m00_mask                                                        (0x00001FFF)
+#define SE_CONVCOEF1_m00(data)                                                       (0x00001FFF&((data)<<0))
+#define SE_CONVCOEF1_m00_src(data)                                                   ((0x00001FFF&(data))>>0)
+#define SE_CONVCOEF1_get_m00(data)                                                   ((0x00001FFF&(data))>>0)
+
+
+#define SE_CONVCOEF2_0                                                               0x1800C1A0
+#define SE_CONVCOEF2_1                                                               0x1800C1A4
+#define SE_CONVCOEF2_2                                                               0x1800C1A8
+#define SE_CONVCOEF2_0_reg_addr                                                      "0xB800C1A0"
+#define SE_CONVCOEF2_1_reg_addr                                                      "0xB800C1A4"
+#define SE_CONVCOEF2_2_reg_addr                                                      "0xB800C1A8"
+#define SE_CONVCOEF2_0_reg                                                           0xB800C1A0
+#define SE_CONVCOEF2_1_reg                                                           0xB800C1A4
+#define SE_CONVCOEF2_2_reg                                                           0xB800C1A8
+#define set_SE_CONVCOEF2_0_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF2_0_reg)=data)
+#define set_SE_CONVCOEF2_1_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF2_1_reg)=data)
+#define set_SE_CONVCOEF2_2_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF2_2_reg)=data)
+#define get_SE_CONVCOEF2_0_reg   (*((volatile unsigned int*) SE_CONVCOEF2_0_reg))
+#define get_SE_CONVCOEF2_1_reg   (*((volatile unsigned int*) SE_CONVCOEF2_1_reg))
+#define get_SE_CONVCOEF2_2_reg   (*((volatile unsigned int*) SE_CONVCOEF2_2_reg))
+#define SE_CONVCOEF2_0_inst_adr                                                      "0x0068"
+#define SE_CONVCOEF2_1_inst_adr                                                      "0x0069"
+#define SE_CONVCOEF2_2_inst_adr                                                      "0x006A"
+#define SE_CONVCOEF2_0_inst                                                          0x0068
+#define SE_CONVCOEF2_1_inst                                                          0x0069
+#define SE_CONVCOEF2_2_inst                                                          0x006A
+#define SE_CONVCOEF2_m10_shift                                                       (13)
+#define SE_CONVCOEF2_m10_mask                                                        (0x03FFE000)
+#define SE_CONVCOEF2_m10(data)                                                       (0x03FFE000&((data)<<13))
+#define SE_CONVCOEF2_m10_src(data)                                                   ((0x03FFE000&(data))>>13)
+#define SE_CONVCOEF2_get_m10(data)                                                   ((0x03FFE000&(data))>>13)
+#define SE_CONVCOEF2_m02_shift                                                       (0)
+#define SE_CONVCOEF2_m02_mask                                                        (0x00001FFF)
+#define SE_CONVCOEF2_m02(data)                                                       (0x00001FFF&((data)<<0))
+#define SE_CONVCOEF2_m02_src(data)                                                   ((0x00001FFF&(data))>>0)
+#define SE_CONVCOEF2_get_m02(data)                                                   ((0x00001FFF&(data))>>0)
+
+
+#define SE_CONVCOEF3_0                                                               0x1800C1AC
+#define SE_CONVCOEF3_1                                                               0x1800C1B0
+#define SE_CONVCOEF3_2                                                               0x1800C1B4
+#define SE_CONVCOEF3_0_reg_addr                                                      "0xB800C1AC"
+#define SE_CONVCOEF3_1_reg_addr                                                      "0xB800C1B0"
+#define SE_CONVCOEF3_2_reg_addr                                                      "0xB800C1B4"
+#define SE_CONVCOEF3_0_reg                                                           0xB800C1AC
+#define SE_CONVCOEF3_1_reg                                                           0xB800C1B0
+#define SE_CONVCOEF3_2_reg                                                           0xB800C1B4
+#define set_SE_CONVCOEF3_0_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF3_0_reg)=data)
+#define set_SE_CONVCOEF3_1_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF3_1_reg)=data)
+#define set_SE_CONVCOEF3_2_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF3_2_reg)=data)
+#define get_SE_CONVCOEF3_0_reg   (*((volatile unsigned int*) SE_CONVCOEF3_0_reg))
+#define get_SE_CONVCOEF3_1_reg   (*((volatile unsigned int*) SE_CONVCOEF3_1_reg))
+#define get_SE_CONVCOEF3_2_reg   (*((volatile unsigned int*) SE_CONVCOEF3_2_reg))
+#define SE_CONVCOEF3_0_inst_adr                                                      "0x006B"
+#define SE_CONVCOEF3_1_inst_adr                                                      "0x006C"
+#define SE_CONVCOEF3_2_inst_adr                                                      "0x006D"
+#define SE_CONVCOEF3_0_inst                                                          0x006B
+#define SE_CONVCOEF3_1_inst                                                          0x006C
+#define SE_CONVCOEF3_2_inst                                                          0x006D
+#define SE_CONVCOEF3_m12_shift                                                       (13)
+#define SE_CONVCOEF3_m12_mask                                                        (0x03FFE000)
+#define SE_CONVCOEF3_m12(data)                                                       (0x03FFE000&((data)<<13))
+#define SE_CONVCOEF3_m12_src(data)                                                   ((0x03FFE000&(data))>>13)
+#define SE_CONVCOEF3_get_m12(data)                                                   ((0x03FFE000&(data))>>13)
+#define SE_CONVCOEF3_m11_shift                                                       (0)
+#define SE_CONVCOEF3_m11_mask                                                        (0x00001FFF)
+#define SE_CONVCOEF3_m11(data)                                                       (0x00001FFF&((data)<<0))
+#define SE_CONVCOEF3_m11_src(data)                                                   ((0x00001FFF&(data))>>0)
+#define SE_CONVCOEF3_get_m11(data)                                                   ((0x00001FFF&(data))>>0)
+
+
+#define SE_CONVCOEF4_0                                                               0x1800C1B8
+#define SE_CONVCOEF4_1                                                               0x1800C1BC
+#define SE_CONVCOEF4_2                                                               0x1800C1C0
+#define SE_CONVCOEF4_0_reg_addr                                                      "0xB800C1B8"
+#define SE_CONVCOEF4_1_reg_addr                                                      "0xB800C1BC"
+#define SE_CONVCOEF4_2_reg_addr                                                      "0xB800C1C0"
+#define SE_CONVCOEF4_0_reg                                                           0xB800C1B8
+#define SE_CONVCOEF4_1_reg                                                           0xB800C1BC
+#define SE_CONVCOEF4_2_reg                                                           0xB800C1C0
+#define set_SE_CONVCOEF4_0_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF4_0_reg)=data)
+#define set_SE_CONVCOEF4_1_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF4_1_reg)=data)
+#define set_SE_CONVCOEF4_2_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF4_2_reg)=data)
+#define get_SE_CONVCOEF4_0_reg   (*((volatile unsigned int*) SE_CONVCOEF4_0_reg))
+#define get_SE_CONVCOEF4_1_reg   (*((volatile unsigned int*) SE_CONVCOEF4_1_reg))
+#define get_SE_CONVCOEF4_2_reg   (*((volatile unsigned int*) SE_CONVCOEF4_2_reg))
+#define SE_CONVCOEF4_0_inst_adr                                                      "0x006E"
+#define SE_CONVCOEF4_1_inst_adr                                                      "0x006F"
+#define SE_CONVCOEF4_2_inst_adr                                                      "0x0070"
+#define SE_CONVCOEF4_0_inst                                                          0x006E
+#define SE_CONVCOEF4_1_inst                                                          0x006F
+#define SE_CONVCOEF4_2_inst                                                          0x0070
+#define SE_CONVCOEF4_m21_shift                                                       (13)
+#define SE_CONVCOEF4_m21_mask                                                        (0x03FFE000)
+#define SE_CONVCOEF4_m21(data)                                                       (0x03FFE000&((data)<<13))
+#define SE_CONVCOEF4_m21_src(data)                                                   ((0x03FFE000&(data))>>13)
+#define SE_CONVCOEF4_get_m21(data)                                                   ((0x03FFE000&(data))>>13)
+#define SE_CONVCOEF4_m20_shift                                                       (0)
+#define SE_CONVCOEF4_m20_mask                                                        (0x00001FFF)
+#define SE_CONVCOEF4_m20(data)                                                       (0x00001FFF&((data)<<0))
+#define SE_CONVCOEF4_m20_src(data)                                                   ((0x00001FFF&(data))>>0)
+#define SE_CONVCOEF4_get_m20(data)                                                   ((0x00001FFF&(data))>>0)
+
+
+#define SE_CONVCOEF5_0                                                               0x1800C1C4
+#define SE_CONVCOEF5_1                                                               0x1800C1C8
+#define SE_CONVCOEF5_2                                                               0x1800C1CC
+#define SE_CONVCOEF5_0_reg_addr                                                      "0xB800C1C4"
+#define SE_CONVCOEF5_1_reg_addr                                                      "0xB800C1C8"
+#define SE_CONVCOEF5_2_reg_addr                                                      "0xB800C1CC"
+#define SE_CONVCOEF5_0_reg                                                           0xB800C1C4
+#define SE_CONVCOEF5_1_reg                                                           0xB800C1C8
+#define SE_CONVCOEF5_2_reg                                                           0xB800C1CC
+#define set_SE_CONVCOEF5_0_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF5_0_reg)=data)
+#define set_SE_CONVCOEF5_1_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF5_1_reg)=data)
+#define set_SE_CONVCOEF5_2_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF5_2_reg)=data)
+#define get_SE_CONVCOEF5_0_reg   (*((volatile unsigned int*) SE_CONVCOEF5_0_reg))
+#define get_SE_CONVCOEF5_1_reg   (*((volatile unsigned int*) SE_CONVCOEF5_1_reg))
+#define get_SE_CONVCOEF5_2_reg   (*((volatile unsigned int*) SE_CONVCOEF5_2_reg))
+#define SE_CONVCOEF5_0_inst_adr                                                      "0x0071"
+#define SE_CONVCOEF5_1_inst_adr                                                      "0x0072"
+#define SE_CONVCOEF5_2_inst_adr                                                      "0x0073"
+#define SE_CONVCOEF5_0_inst                                                          0x0071
+#define SE_CONVCOEF5_1_inst                                                          0x0072
+#define SE_CONVCOEF5_2_inst                                                          0x0073
+#define SE_CONVCOEF5_m22_shift                                                       (0)
+#define SE_CONVCOEF5_m22_mask                                                        (0x00001FFF)
+#define SE_CONVCOEF5_m22(data)                                                       (0x00001FFF&((data)<<0))
+#define SE_CONVCOEF5_m22_src(data)                                                   ((0x00001FFF&(data))>>0)
+#define SE_CONVCOEF5_get_m22(data)                                                   ((0x00001FFF&(data))>>0)
+
+
+#define SE_CONVCOEF6_0                                                               0x1800C1D0
+#define SE_CONVCOEF6_1                                                               0x1800C1D4
+#define SE_CONVCOEF6_2                                                               0x1800C1D8
+#define SE_CONVCOEF6_0_reg_addr                                                      "0xB800C1D0"
+#define SE_CONVCOEF6_1_reg_addr                                                      "0xB800C1D4"
+#define SE_CONVCOEF6_2_reg_addr                                                      "0xB800C1D8"
+#define SE_CONVCOEF6_0_reg                                                           0xB800C1D0
+#define SE_CONVCOEF6_1_reg                                                           0xB800C1D4
+#define SE_CONVCOEF6_2_reg                                                           0xB800C1D8
+#define set_SE_CONVCOEF6_0_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF6_0_reg)=data)
+#define set_SE_CONVCOEF6_1_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF6_1_reg)=data)
+#define set_SE_CONVCOEF6_2_reg(data)   (*((volatile unsigned int*) SE_CONVCOEF6_2_reg)=data)
+#define get_SE_CONVCOEF6_0_reg   (*((volatile unsigned int*) SE_CONVCOEF6_0_reg))
+#define get_SE_CONVCOEF6_1_reg   (*((volatile unsigned int*) SE_CONVCOEF6_1_reg))
+#define get_SE_CONVCOEF6_2_reg   (*((volatile unsigned int*) SE_CONVCOEF6_2_reg))
+#define SE_CONVCOEF6_0_inst_adr                                                      "0x0074"
+#define SE_CONVCOEF6_1_inst_adr                                                      "0x0075"
+#define SE_CONVCOEF6_2_inst_adr                                                      "0x0076"
+#define SE_CONVCOEF6_0_inst                                                          0x0074
+#define SE_CONVCOEF6_1_inst                                                          0x0075
+#define SE_CONVCOEF6_2_inst                                                          0x0076
+#define SE_CONVCOEF6_a2_shift                                                        (20)
+#define SE_CONVCOEF6_a2_mask                                                         (0x3FF00000)
+#define SE_CONVCOEF6_a2(data)                                                        (0x3FF00000&((data)<<20))
+#define SE_CONVCOEF6_a2_src(data)                                                    ((0x3FF00000&(data))>>20)
+#define SE_CONVCOEF6_get_a2(data)                                                    ((0x3FF00000&(data))>>20)
+#define SE_CONVCOEF6_a1_shift                                                        (10)
+#define SE_CONVCOEF6_a1_mask                                                         (0x000FFC00)
+#define SE_CONVCOEF6_a1(data)                                                        (0x000FFC00&((data)<<10))
+#define SE_CONVCOEF6_a1_src(data)                                                    ((0x000FFC00&(data))>>10)
+#define SE_CONVCOEF6_get_a1(data)                                                    ((0x000FFC00&(data))>>10)
+#define SE_CONVCOEF6_a0_shift                                                        (0)
+#define SE_CONVCOEF6_a0_mask                                                         (0x000003FF)
+#define SE_CONVCOEF6_a0(data)                                                        (0x000003FF&((data)<<0))
+#define SE_CONVCOEF6_a0_src(data)                                                    ((0x000003FF&(data))>>0)
+#define SE_CONVCOEF6_get_a0(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define SE_FCV_BITBLIT_COLOR_KEY_0                                                   0x1800C4BC
+#define SE_FCV_BITBLIT_COLOR_KEY_1                                                   0x1800C4C0
+#define SE_FCV_BITBLIT_COLOR_KEY_2                                                   0x1800C4C4
+#define SE_FCV_BITBLIT_COLOR_KEY_0_reg_addr                                          "0xB800C4BC"
+#define SE_FCV_BITBLIT_COLOR_KEY_1_reg_addr                                          "0xB800C4C0"
+#define SE_FCV_BITBLIT_COLOR_KEY_2_reg_addr                                          "0xB800C4C4"
+#define SE_FCV_BITBLIT_COLOR_KEY_0_reg                                               0xB800C4BC
+#define SE_FCV_BITBLIT_COLOR_KEY_1_reg                                               0xB800C4C0
+#define SE_FCV_BITBLIT_COLOR_KEY_2_reg                                               0xB800C4C4
+#define set_SE_FCV_BITBLIT_COLOR_KEY_0_reg(data)   (*((volatile unsigned int*) SE_FCV_BITBLIT_COLOR_KEY_0_reg)=data)
+#define set_SE_FCV_BITBLIT_COLOR_KEY_1_reg(data)   (*((volatile unsigned int*) SE_FCV_BITBLIT_COLOR_KEY_1_reg)=data)
+#define set_SE_FCV_BITBLIT_COLOR_KEY_2_reg(data)   (*((volatile unsigned int*) SE_FCV_BITBLIT_COLOR_KEY_2_reg)=data)
+#define get_SE_FCV_BITBLIT_COLOR_KEY_0_reg   (*((volatile unsigned int*) SE_FCV_BITBLIT_COLOR_KEY_0_reg))
+#define get_SE_FCV_BITBLIT_COLOR_KEY_1_reg   (*((volatile unsigned int*) SE_FCV_BITBLIT_COLOR_KEY_1_reg))
+#define get_SE_FCV_BITBLIT_COLOR_KEY_2_reg   (*((volatile unsigned int*) SE_FCV_BITBLIT_COLOR_KEY_2_reg))
+#define SE_FCV_BITBLIT_COLOR_KEY_0_inst_adr                                          "0x002F"
+#define SE_FCV_BITBLIT_COLOR_KEY_1_inst_adr                                          "0x0030"
+#define SE_FCV_BITBLIT_COLOR_KEY_2_inst_adr                                          "0x0031"
+#define SE_FCV_BITBLIT_COLOR_KEY_0_inst                                              0x002F
+#define SE_FCV_BITBLIT_COLOR_KEY_1_inst                                              0x0030
+#define SE_FCV_BITBLIT_COLOR_KEY_2_inst                                              0x0031
+#define SE_FCV_BITBLIT_COLOR_KEY_color_key_shift                                     (0)
+#define SE_FCV_BITBLIT_COLOR_KEY_color_key_mask                                      (0x00FFFFFF)
+#define SE_FCV_BITBLIT_COLOR_KEY_color_key(data)                                     (0x00FFFFFF&((data)<<0))
+#define SE_FCV_BITBLIT_COLOR_KEY_color_key_src(data)                                 ((0x00FFFFFF&(data))>>0)
+#define SE_FCV_BITBLIT_COLOR_KEY_get_color_key(data)                                 ((0x00FFFFFF&(data))>>0)
+
+
+#define SE_SRC_CLR_RED_0                                                             0x1800C51C
+#define SE_SRC_CLR_RED_1                                                             0x1800C520
+#define SE_SRC_CLR_RED_2                                                             0x1800C524
+#define SE_SRC_CLR_RED_0_reg_addr                                                    "0xB800C51C"
+#define SE_SRC_CLR_RED_1_reg_addr                                                    "0xB800C520"
+#define SE_SRC_CLR_RED_2_reg_addr                                                    "0xB800C524"
+#define SE_SRC_CLR_RED_0_reg                                                         0xB800C51C
+#define SE_SRC_CLR_RED_1_reg                                                         0xB800C520
+#define SE_SRC_CLR_RED_2_reg                                                         0xB800C524
+#define set_SE_SRC_CLR_RED_0_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_RED_0_reg)=data)
+#define set_SE_SRC_CLR_RED_1_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_RED_1_reg)=data)
+#define set_SE_SRC_CLR_RED_2_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_RED_2_reg)=data)
+#define get_SE_SRC_CLR_RED_0_reg   (*((volatile unsigned int*) SE_SRC_CLR_RED_0_reg))
+#define get_SE_SRC_CLR_RED_1_reg   (*((volatile unsigned int*) SE_SRC_CLR_RED_1_reg))
+#define get_SE_SRC_CLR_RED_2_reg   (*((volatile unsigned int*) SE_SRC_CLR_RED_2_reg))
+#define SE_SRC_CLR_RED_0_inst_adr                                                    "0x0047"
+#define SE_SRC_CLR_RED_1_inst_adr                                                    "0x0048"
+#define SE_SRC_CLR_RED_2_inst_adr                                                    "0x0049"
+#define SE_SRC_CLR_RED_0_inst                                                        0x0047
+#define SE_SRC_CLR_RED_1_inst                                                        0x0048
+#define SE_SRC_CLR_RED_2_inst                                                        0x0049
+#define SE_SRC_CLR_RED_src_clr_add_red_shift                                         (16)
+#define SE_SRC_CLR_RED_src_clr_add_red_mask                                          (0x01FF0000)
+#define SE_SRC_CLR_RED_src_clr_add_red(data)                                         (0x01FF0000&((data)<<16))
+#define SE_SRC_CLR_RED_src_clr_add_red_src(data)                                     ((0x01FF0000&(data))>>16)
+#define SE_SRC_CLR_RED_get_src_clr_add_red(data)                                     ((0x01FF0000&(data))>>16)
+#define SE_SRC_CLR_RED_src_clr_mul_red_shift                                         (0)
+#define SE_SRC_CLR_RED_src_clr_mul_red_mask                                          (0x000001FF)
+#define SE_SRC_CLR_RED_src_clr_mul_red(data)                                         (0x000001FF&((data)<<0))
+#define SE_SRC_CLR_RED_src_clr_mul_red_src(data)                                     ((0x000001FF&(data))>>0)
+#define SE_SRC_CLR_RED_get_src_clr_mul_red(data)                                     ((0x000001FF&(data))>>0)
+
+
+#define SE_SRC_CLR_GREEN_0                                                           0x1800C528
+#define SE_SRC_CLR_GREEN_1                                                           0x1800C52C
+#define SE_SRC_CLR_GREEN_2                                                           0x1800C530
+#define SE_SRC_CLR_GREEN_0_reg_addr                                                  "0xB800C528"
+#define SE_SRC_CLR_GREEN_1_reg_addr                                                  "0xB800C52C"
+#define SE_SRC_CLR_GREEN_2_reg_addr                                                  "0xB800C530"
+#define SE_SRC_CLR_GREEN_0_reg                                                       0xB800C528
+#define SE_SRC_CLR_GREEN_1_reg                                                       0xB800C52C
+#define SE_SRC_CLR_GREEN_2_reg                                                       0xB800C530
+#define set_SE_SRC_CLR_GREEN_0_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_GREEN_0_reg)=data)
+#define set_SE_SRC_CLR_GREEN_1_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_GREEN_1_reg)=data)
+#define set_SE_SRC_CLR_GREEN_2_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_GREEN_2_reg)=data)
+#define get_SE_SRC_CLR_GREEN_0_reg   (*((volatile unsigned int*) SE_SRC_CLR_GREEN_0_reg))
+#define get_SE_SRC_CLR_GREEN_1_reg   (*((volatile unsigned int*) SE_SRC_CLR_GREEN_1_reg))
+#define get_SE_SRC_CLR_GREEN_2_reg   (*((volatile unsigned int*) SE_SRC_CLR_GREEN_2_reg))
+#define SE_SRC_CLR_GREEN_0_inst_adr                                                  "0x004A"
+#define SE_SRC_CLR_GREEN_1_inst_adr                                                  "0x004B"
+#define SE_SRC_CLR_GREEN_2_inst_adr                                                  "0x004C"
+#define SE_SRC_CLR_GREEN_0_inst                                                      0x004A
+#define SE_SRC_CLR_GREEN_1_inst                                                      0x004B
+#define SE_SRC_CLR_GREEN_2_inst                                                      0x004C
+#define SE_SRC_CLR_GREEN_src_clr_add_green_shift                                     (16)
+#define SE_SRC_CLR_GREEN_src_clr_add_green_mask                                      (0x01FF0000)
+#define SE_SRC_CLR_GREEN_src_clr_add_green(data)                                     (0x01FF0000&((data)<<16))
+#define SE_SRC_CLR_GREEN_src_clr_add_green_src(data)                                 ((0x01FF0000&(data))>>16)
+#define SE_SRC_CLR_GREEN_get_src_clr_add_green(data)                                 ((0x01FF0000&(data))>>16)
+#define SE_SRC_CLR_GREEN_src_clr_mul_green_shift                                     (0)
+#define SE_SRC_CLR_GREEN_src_clr_mul_green_mask                                      (0x000001FF)
+#define SE_SRC_CLR_GREEN_src_clr_mul_green(data)                                     (0x000001FF&((data)<<0))
+#define SE_SRC_CLR_GREEN_src_clr_mul_green_src(data)                                 ((0x000001FF&(data))>>0)
+#define SE_SRC_CLR_GREEN_get_src_clr_mul_green(data)                                 ((0x000001FF&(data))>>0)
+
+
+#define SE_SRC_CLR_BLUE_0                                                            0x1800C534
+#define SE_SRC_CLR_BLUE_1                                                            0x1800C538
+#define SE_SRC_CLR_BLUE_2                                                            0x1800C53C
+#define SE_SRC_CLR_BLUE_0_reg_addr                                                   "0xB800C534"
+#define SE_SRC_CLR_BLUE_1_reg_addr                                                   "0xB800C538"
+#define SE_SRC_CLR_BLUE_2_reg_addr                                                   "0xB800C53C"
+#define SE_SRC_CLR_BLUE_0_reg                                                        0xB800C534
+#define SE_SRC_CLR_BLUE_1_reg                                                        0xB800C538
+#define SE_SRC_CLR_BLUE_2_reg                                                        0xB800C53C
+#define set_SE_SRC_CLR_BLUE_0_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_BLUE_0_reg)=data)
+#define set_SE_SRC_CLR_BLUE_1_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_BLUE_1_reg)=data)
+#define set_SE_SRC_CLR_BLUE_2_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_BLUE_2_reg)=data)
+#define get_SE_SRC_CLR_BLUE_0_reg   (*((volatile unsigned int*) SE_SRC_CLR_BLUE_0_reg))
+#define get_SE_SRC_CLR_BLUE_1_reg   (*((volatile unsigned int*) SE_SRC_CLR_BLUE_1_reg))
+#define get_SE_SRC_CLR_BLUE_2_reg   (*((volatile unsigned int*) SE_SRC_CLR_BLUE_2_reg))
+#define SE_SRC_CLR_BLUE_0_inst_adr                                                   "0x004D"
+#define SE_SRC_CLR_BLUE_1_inst_adr                                                   "0x004E"
+#define SE_SRC_CLR_BLUE_2_inst_adr                                                   "0x004F"
+#define SE_SRC_CLR_BLUE_0_inst                                                       0x004D
+#define SE_SRC_CLR_BLUE_1_inst                                                       0x004E
+#define SE_SRC_CLR_BLUE_2_inst                                                       0x004F
+#define SE_SRC_CLR_BLUE_src_clr_add_blue_shift                                       (16)
+#define SE_SRC_CLR_BLUE_src_clr_add_blue_mask                                        (0x01FF0000)
+#define SE_SRC_CLR_BLUE_src_clr_add_blue(data)                                       (0x01FF0000&((data)<<16))
+#define SE_SRC_CLR_BLUE_src_clr_add_blue_src(data)                                   ((0x01FF0000&(data))>>16)
+#define SE_SRC_CLR_BLUE_get_src_clr_add_blue(data)                                   ((0x01FF0000&(data))>>16)
+#define SE_SRC_CLR_BLUE_src_clr_mul_blue_shift                                       (0)
+#define SE_SRC_CLR_BLUE_src_clr_mul_blue_mask                                        (0x000001FF)
+#define SE_SRC_CLR_BLUE_src_clr_mul_blue(data)                                       (0x000001FF&((data)<<0))
+#define SE_SRC_CLR_BLUE_src_clr_mul_blue_src(data)                                   ((0x000001FF&(data))>>0)
+#define SE_SRC_CLR_BLUE_get_src_clr_mul_blue(data)                                   ((0x000001FF&(data))>>0)
+
+
+#define SE_SRC_CLR_ALPHA_0                                                           0x1800C540
+#define SE_SRC_CLR_ALPHA_1                                                           0x1800C544
+#define SE_SRC_CLR_ALPHA_2                                                           0x1800C548
+#define SE_SRC_CLR_ALPHA_0_reg_addr                                                  "0xB800C540"
+#define SE_SRC_CLR_ALPHA_1_reg_addr                                                  "0xB800C544"
+#define SE_SRC_CLR_ALPHA_2_reg_addr                                                  "0xB800C548"
+#define SE_SRC_CLR_ALPHA_0_reg                                                       0xB800C540
+#define SE_SRC_CLR_ALPHA_1_reg                                                       0xB800C544
+#define SE_SRC_CLR_ALPHA_2_reg                                                       0xB800C548
+#define set_SE_SRC_CLR_ALPHA_0_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_ALPHA_0_reg)=data)
+#define set_SE_SRC_CLR_ALPHA_1_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_ALPHA_1_reg)=data)
+#define set_SE_SRC_CLR_ALPHA_2_reg(data)   (*((volatile unsigned int*) SE_SRC_CLR_ALPHA_2_reg)=data)
+#define get_SE_SRC_CLR_ALPHA_0_reg   (*((volatile unsigned int*) SE_SRC_CLR_ALPHA_0_reg))
+#define get_SE_SRC_CLR_ALPHA_1_reg   (*((volatile unsigned int*) SE_SRC_CLR_ALPHA_1_reg))
+#define get_SE_SRC_CLR_ALPHA_2_reg   (*((volatile unsigned int*) SE_SRC_CLR_ALPHA_2_reg))
+#define SE_SRC_CLR_ALPHA_0_inst_adr                                                  "0x0050"
+#define SE_SRC_CLR_ALPHA_1_inst_adr                                                  "0x0051"
+#define SE_SRC_CLR_ALPHA_2_inst_adr                                                  "0x0052"
+#define SE_SRC_CLR_ALPHA_0_inst                                                      0x0050
+#define SE_SRC_CLR_ALPHA_1_inst                                                      0x0051
+#define SE_SRC_CLR_ALPHA_2_inst                                                      0x0052
+#define SE_SRC_CLR_ALPHA_src_clr_add_alpha_shift                                     (16)
+#define SE_SRC_CLR_ALPHA_src_clr_add_alpha_mask                                      (0x01FF0000)
+#define SE_SRC_CLR_ALPHA_src_clr_add_alpha(data)                                     (0x01FF0000&((data)<<16))
+#define SE_SRC_CLR_ALPHA_src_clr_add_alpha_src(data)                                 ((0x01FF0000&(data))>>16)
+#define SE_SRC_CLR_ALPHA_get_src_clr_add_alpha(data)                                 ((0x01FF0000&(data))>>16)
+#define SE_SRC_CLR_ALPHA_src_clr_mul_alpha_shift                                     (0)
+#define SE_SRC_CLR_ALPHA_src_clr_mul_alpha_mask                                      (0x000001FF)
+#define SE_SRC_CLR_ALPHA_src_clr_mul_alpha(data)                                     (0x000001FF&((data)<<0))
+#define SE_SRC_CLR_ALPHA_src_clr_mul_alpha_src(data)                                 ((0x000001FF&(data))>>0)
+#define SE_SRC_CLR_ALPHA_get_src_clr_mul_alpha(data)                                 ((0x000001FF&(data))>>0)
+
+
+#define SE_SYNC_VO_MARGIN_0                                                          0x1800C4E0
+#define SE_SYNC_VO_MARGIN_1                                                          0x1800C4E4
+#define SE_SYNC_VO_MARGIN_2                                                          0x1800C4E8
+#define SE_SYNC_VO_MARGIN_0_reg_addr                                                 "0xB800C4E0"
+#define SE_SYNC_VO_MARGIN_1_reg_addr                                                 "0xB800C4E4"
+#define SE_SYNC_VO_MARGIN_2_reg_addr                                                 "0xB800C4E8"
+#define SE_SYNC_VO_MARGIN_0_reg                                                      0xB800C4E0
+#define SE_SYNC_VO_MARGIN_1_reg                                                      0xB800C4E4
+#define SE_SYNC_VO_MARGIN_2_reg                                                      0xB800C4E8
+#define set_SE_SYNC_VO_MARGIN_0_reg(data)   (*((volatile unsigned int*) SE_SYNC_VO_MARGIN_0_reg)=data)
+#define set_SE_SYNC_VO_MARGIN_1_reg(data)   (*((volatile unsigned int*) SE_SYNC_VO_MARGIN_1_reg)=data)
+#define set_SE_SYNC_VO_MARGIN_2_reg(data)   (*((volatile unsigned int*) SE_SYNC_VO_MARGIN_2_reg)=data)
+#define get_SE_SYNC_VO_MARGIN_0_reg   (*((volatile unsigned int*) SE_SYNC_VO_MARGIN_0_reg))
+#define get_SE_SYNC_VO_MARGIN_1_reg   (*((volatile unsigned int*) SE_SYNC_VO_MARGIN_1_reg))
+#define get_SE_SYNC_VO_MARGIN_2_reg   (*((volatile unsigned int*) SE_SYNC_VO_MARGIN_2_reg))
+#define SE_SYNC_VO_MARGIN_0_inst_adr                                                 "0x0038"
+#define SE_SYNC_VO_MARGIN_1_inst_adr                                                 "0x0039"
+#define SE_SYNC_VO_MARGIN_2_inst_adr                                                 "0x003A"
+#define SE_SYNC_VO_MARGIN_0_inst                                                     0x0038
+#define SE_SYNC_VO_MARGIN_1_inst                                                     0x0039
+#define SE_SYNC_VO_MARGIN_2_inst                                                     0x003A
+#define SE_SYNC_VO_MARGIN_auto_dir_en_shift                                          (31)
+#define SE_SYNC_VO_MARGIN_auto_dir_en_mask                                           (0x80000000)
+#define SE_SYNC_VO_MARGIN_auto_dir_en(data)                                          (0x80000000&((data)<<31))
+#define SE_SYNC_VO_MARGIN_auto_dir_en_src(data)                                      ((0x80000000&(data))>>31)
+#define SE_SYNC_VO_MARGIN_get_auto_dir_en(data)                                      ((0x80000000&(data))>>31)
+#define SE_SYNC_VO_MARGIN_vo_plane_shift                                             (30)
+#define SE_SYNC_VO_MARGIN_vo_plane_mask                                              (0x40000000)
+#define SE_SYNC_VO_MARGIN_vo_plane(data)                                             (0x40000000&((data)<<30))
+#define SE_SYNC_VO_MARGIN_vo_plane_src(data)                                         ((0x40000000&(data))>>30)
+#define SE_SYNC_VO_MARGIN_get_vo_plane(data)                                         ((0x40000000&(data))>>30)
+#define SE_SYNC_VO_MARGIN_before_vo_cur_shift                                        (29)
+#define SE_SYNC_VO_MARGIN_before_vo_cur_mask                                         (0x20000000)
+#define SE_SYNC_VO_MARGIN_before_vo_cur(data)                                        (0x20000000&((data)<<29))
+#define SE_SYNC_VO_MARGIN_before_vo_cur_src(data)                                    ((0x20000000&(data))>>29)
+#define SE_SYNC_VO_MARGIN_get_before_vo_cur(data)                                    ((0x20000000&(data))>>29)
+#define SE_SYNC_VO_MARGIN_after_vo_cur_shift                                         (28)
+#define SE_SYNC_VO_MARGIN_after_vo_cur_mask                                          (0x10000000)
+#define SE_SYNC_VO_MARGIN_after_vo_cur(data)                                         (0x10000000&((data)<<28))
+#define SE_SYNC_VO_MARGIN_after_vo_cur_src(data)                                     ((0x10000000&(data))>>28)
+#define SE_SYNC_VO_MARGIN_get_after_vo_cur(data)                                     ((0x10000000&(data))>>28)
+#define SE_SYNC_VO_MARGIN_vbi_shift                                                  (27)
+#define SE_SYNC_VO_MARGIN_vbi_mask                                                   (0x08000000)
+#define SE_SYNC_VO_MARGIN_vbi(data)                                                  (0x08000000&((data)<<27))
+#define SE_SYNC_VO_MARGIN_vbi_src(data)                                              ((0x08000000&(data))>>27)
+#define SE_SYNC_VO_MARGIN_get_vbi(data)                                              ((0x08000000&(data))>>27)
+#define SE_SYNC_VO_MARGIN_vo_osd_plane_shift                                         (26)
+#define SE_SYNC_VO_MARGIN_vo_osd_plane_mask                                          (0x04000000)
+#define SE_SYNC_VO_MARGIN_vo_osd_plane(data)                                         (0x04000000&((data)<<26))
+#define SE_SYNC_VO_MARGIN_vo_osd_plane_src(data)                                     ((0x04000000&(data))>>26)
+#define SE_SYNC_VO_MARGIN_get_vo_osd_plane(data)                                     ((0x04000000&(data))>>26)
+#define SE_SYNC_VO_MARGIN_margin_VOtoSE_shift                                        (0)
+#define SE_SYNC_VO_MARGIN_margin_VOtoSE_mask                                         (0x00000FFF)
+#define SE_SYNC_VO_MARGIN_margin_VOtoSE(data)                                        (0x00000FFF&((data)<<0))
+#define SE_SYNC_VO_MARGIN_margin_VOtoSE_src(data)                                    ((0x00000FFF&(data))>>0)
+#define SE_SYNC_VO_MARGIN_get_margin_VOtoSE(data)                                    ((0x00000FFF&(data))>>0)
+
+
+#define SE_SYNC_VO_LOCATION_0                                                        0x1800C4F8
+#define SE_SYNC_VO_LOCATION_1                                                        0x1800C4FC
+#define SE_SYNC_VO_LOCATION_2                                                        0x1800C500
+#define SE_SYNC_VO_LOCATION_0_reg_addr                                               "0xB800C4F8"
+#define SE_SYNC_VO_LOCATION_1_reg_addr                                               "0xB800C4FC"
+#define SE_SYNC_VO_LOCATION_2_reg_addr                                               "0xB800C500"
+#define SE_SYNC_VO_LOCATION_0_reg                                                    0xB800C4F8
+#define SE_SYNC_VO_LOCATION_1_reg                                                    0xB800C4FC
+#define SE_SYNC_VO_LOCATION_2_reg                                                    0xB800C500
+#define set_SE_SYNC_VO_LOCATION_0_reg(data)   (*((volatile unsigned int*) SE_SYNC_VO_LOCATION_0_reg)=data)
+#define set_SE_SYNC_VO_LOCATION_1_reg(data)   (*((volatile unsigned int*) SE_SYNC_VO_LOCATION_1_reg)=data)
+#define set_SE_SYNC_VO_LOCATION_2_reg(data)   (*((volatile unsigned int*) SE_SYNC_VO_LOCATION_2_reg)=data)
+#define get_SE_SYNC_VO_LOCATION_0_reg   (*((volatile unsigned int*) SE_SYNC_VO_LOCATION_0_reg))
+#define get_SE_SYNC_VO_LOCATION_1_reg   (*((volatile unsigned int*) SE_SYNC_VO_LOCATION_1_reg))
+#define get_SE_SYNC_VO_LOCATION_2_reg   (*((volatile unsigned int*) SE_SYNC_VO_LOCATION_2_reg))
+#define SE_SYNC_VO_LOCATION_0_inst_adr                                               "0x003E"
+#define SE_SYNC_VO_LOCATION_1_inst_adr                                               "0x003F"
+#define SE_SYNC_VO_LOCATION_2_inst_adr                                               "0x0040"
+#define SE_SYNC_VO_LOCATION_0_inst                                                   0x003E
+#define SE_SYNC_VO_LOCATION_1_inst                                                   0x003F
+#define SE_SYNC_VO_LOCATION_2_inst                                                   0x0040
+#define SE_SYNC_VO_LOCATION_VO_current_y_shift                                       (0)
+#define SE_SYNC_VO_LOCATION_VO_current_y_mask                                        (0x00000FFF)
+#define SE_SYNC_VO_LOCATION_VO_current_y(data)                                       (0x00000FFF&((data)<<0))
+#define SE_SYNC_VO_LOCATION_VO_current_y_src(data)                                   ((0x00000FFF&(data))>>0)
+#define SE_SYNC_VO_LOCATION_get_VO_current_y(data)                                   ((0x00000FFF&(data))>>0)
+
+
+#define SE_STRETCH_0                                                                 0x1800C1DC
+#define SE_STRETCH_1                                                                 0x1800C1E0
+#define SE_STRETCH_2                                                                 0x1800C1E4
+#define SE_STRETCH_0_reg_addr                                                        "0xB800C1DC"
+#define SE_STRETCH_1_reg_addr                                                        "0xB800C1E0"
+#define SE_STRETCH_2_reg_addr                                                        "0xB800C1E4"
+#define SE_STRETCH_0_reg                                                             0xB800C1DC
+#define SE_STRETCH_1_reg                                                             0xB800C1E0
+#define SE_STRETCH_2_reg                                                             0xB800C1E4
+#define set_SE_STRETCH_0_reg(data)   (*((volatile unsigned int*) SE_STRETCH_0_reg)=data)
+#define set_SE_STRETCH_1_reg(data)   (*((volatile unsigned int*) SE_STRETCH_1_reg)=data)
+#define set_SE_STRETCH_2_reg(data)   (*((volatile unsigned int*) SE_STRETCH_2_reg)=data)
+#define get_SE_STRETCH_0_reg   (*((volatile unsigned int*) SE_STRETCH_0_reg))
+#define get_SE_STRETCH_1_reg   (*((volatile unsigned int*) SE_STRETCH_1_reg))
+#define get_SE_STRETCH_2_reg   (*((volatile unsigned int*) SE_STRETCH_2_reg))
+#define SE_STRETCH_0_inst_adr                                                        "0x0077"
+#define SE_STRETCH_1_inst_adr                                                        "0x0078"
+#define SE_STRETCH_2_inst_adr                                                        "0x0079"
+#define SE_STRETCH_0_inst                                                            0x0077
+#define SE_STRETCH_1_inst                                                            0x0078
+#define SE_STRETCH_2_inst                                                            0x0079
+#define SE_STRETCH_repl_alpha_shift                                                  (7)
+#define SE_STRETCH_repl_alpha_mask                                                   (0x00000080)
+#define SE_STRETCH_repl_alpha(data)                                                  (0x00000080&((data)<<7))
+#define SE_STRETCH_repl_alpha_src(data)                                              ((0x00000080&(data))>>7)
+#define SE_STRETCH_get_repl_alpha(data)                                              ((0x00000080&(data))>>7)
+#define SE_STRETCH_repl_color_shift                                                  (6)
+#define SE_STRETCH_repl_color_mask                                                   (0x00000040)
+#define SE_STRETCH_repl_color(data)                                                  (0x00000040&((data)<<6))
+#define SE_STRETCH_repl_color_src(data)                                              ((0x00000040&(data))>>6)
+#define SE_STRETCH_get_repl_color(data)                                              ((0x00000040&(data))>>6)
+#define SE_STRETCH_ref_alpha_shift                                                   (5)
+#define SE_STRETCH_ref_alpha_mask                                                    (0x00000020)
+#define SE_STRETCH_ref_alpha(data)                                                   (0x00000020&((data)<<5))
+#define SE_STRETCH_ref_alpha_src(data)                                               ((0x00000020&(data))>>5)
+#define SE_STRETCH_get_ref_alpha(data)                                               ((0x00000020&(data))>>5)
+#define SE_STRETCH_htype_shift                                                       (3)
+#define SE_STRETCH_htype_mask                                                        (0x00000018)
+#define SE_STRETCH_htype(data)                                                       (0x00000018&((data)<<3))
+#define SE_STRETCH_htype_src(data)                                                   ((0x00000018&(data))>>3)
+#define SE_STRETCH_get_htype(data)                                                   ((0x00000018&(data))>>3)
+#define SE_STRETCH_vtype_shift                                                       (2)
+#define SE_STRETCH_vtype_mask                                                        (0x00000004)
+#define SE_STRETCH_vtype(data)                                                       (0x00000004&((data)<<2))
+#define SE_STRETCH_vtype_src(data)                                                   ((0x00000004&(data))>>2)
+#define SE_STRETCH_get_vtype(data)                                                   ((0x00000004&(data))>>2)
+#define SE_STRETCH_hodd_shift                                                        (1)
+#define SE_STRETCH_hodd_mask                                                         (0x00000002)
+#define SE_STRETCH_hodd(data)                                                        (0x00000002&((data)<<1))
+#define SE_STRETCH_hodd_src(data)                                                    ((0x00000002&(data))>>1)
+#define SE_STRETCH_get_hodd(data)                                                    ((0x00000002&(data))>>1)
+#define SE_STRETCH_vodd_shift                                                        (0)
+#define SE_STRETCH_vodd_mask                                                         (0x00000001)
+#define SE_STRETCH_vodd(data)                                                        (0x00000001&((data)<<0))
+#define SE_STRETCH_vodd_src(data)                                                    ((0x00000001&(data))>>0)
+#define SE_STRETCH_get_vodd(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define SE_HDHS_0                                                                    0x1800C1E8
+#define SE_HDHS_1                                                                    0x1800C1EC
+#define SE_HDHS_2                                                                    0x1800C1F0
+#define SE_HDHS_0_reg_addr                                                           "0xB800C1E8"
+#define SE_HDHS_1_reg_addr                                                           "0xB800C1EC"
+#define SE_HDHS_2_reg_addr                                                           "0xB800C1F0"
+#define SE_HDHS_0_reg                                                                0xB800C1E8
+#define SE_HDHS_1_reg                                                                0xB800C1EC
+#define SE_HDHS_2_reg                                                                0xB800C1F0
+#define set_SE_HDHS_0_reg(data)   (*((volatile unsigned int*) SE_HDHS_0_reg)=data)
+#define set_SE_HDHS_1_reg(data)   (*((volatile unsigned int*) SE_HDHS_1_reg)=data)
+#define set_SE_HDHS_2_reg(data)   (*((volatile unsigned int*) SE_HDHS_2_reg)=data)
+#define get_SE_HDHS_0_reg   (*((volatile unsigned int*) SE_HDHS_0_reg))
+#define get_SE_HDHS_1_reg   (*((volatile unsigned int*) SE_HDHS_1_reg))
+#define get_SE_HDHS_2_reg   (*((volatile unsigned int*) SE_HDHS_2_reg))
+#define SE_HDHS_0_inst_adr                                                           "0x007A"
+#define SE_HDHS_1_inst_adr                                                           "0x007B"
+#define SE_HDHS_2_inst_adr                                                           "0x007C"
+#define SE_HDHS_0_inst                                                               0x007A
+#define SE_HDHS_1_inst                                                               0x007B
+#define SE_HDHS_2_inst                                                               0x007C
+#define SE_HDHS_H_scaling_iniph_shift                                                (18)
+#define SE_HDHS_H_scaling_iniph_mask                                                 (0x003C0000)
+#define SE_HDHS_H_scaling_iniph(data)                                                (0x003C0000&((data)<<18))
+#define SE_HDHS_H_scaling_iniph_src(data)                                            ((0x003C0000&(data))>>18)
+#define SE_HDHS_get_H_scaling_iniph(data)                                            ((0x003C0000&(data))>>18)
+#define SE_HDHS_H_scaling_dph_msb_shift                                              (14)
+#define SE_HDHS_H_scaling_dph_msb_mask                                               (0x0003C000)
+#define SE_HDHS_H_scaling_dph_msb(data)                                              (0x0003C000&((data)<<14))
+#define SE_HDHS_H_scaling_dph_msb_src(data)                                          ((0x0003C000&(data))>>14)
+#define SE_HDHS_get_H_scaling_dph_msb(data)                                          ((0x0003C000&(data))>>14)
+#define SE_HDHS_H_scaling_dph_lsb_shift                                              (0)
+#define SE_HDHS_H_scaling_dph_lsb_mask                                               (0x00003FFF)
+#define SE_HDHS_H_scaling_dph_lsb(data)                                              (0x00003FFF&((data)<<0))
+#define SE_HDHS_H_scaling_dph_lsb_src(data)                                          ((0x00003FFF&(data))>>0)
+#define SE_HDHS_get_H_scaling_dph_lsb(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#define SE_VDHS_0                                                                    0x1800C1F4
+#define SE_VDHS_1                                                                    0x1800C1F8
+#define SE_VDHS_2                                                                    0x1800C1FC
+#define SE_VDHS_0_reg_addr                                                           "0xB800C1F4"
+#define SE_VDHS_1_reg_addr                                                           "0xB800C1F8"
+#define SE_VDHS_2_reg_addr                                                           "0xB800C1FC"
+#define SE_VDHS_0_reg                                                                0xB800C1F4
+#define SE_VDHS_1_reg                                                                0xB800C1F8
+#define SE_VDHS_2_reg                                                                0xB800C1FC
+#define set_SE_VDHS_0_reg(data)   (*((volatile unsigned int*) SE_VDHS_0_reg)=data)
+#define set_SE_VDHS_1_reg(data)   (*((volatile unsigned int*) SE_VDHS_1_reg)=data)
+#define set_SE_VDHS_2_reg(data)   (*((volatile unsigned int*) SE_VDHS_2_reg)=data)
+#define get_SE_VDHS_0_reg   (*((volatile unsigned int*) SE_VDHS_0_reg))
+#define get_SE_VDHS_1_reg   (*((volatile unsigned int*) SE_VDHS_1_reg))
+#define get_SE_VDHS_2_reg   (*((volatile unsigned int*) SE_VDHS_2_reg))
+#define SE_VDHS_0_inst_adr                                                           "0x007D"
+#define SE_VDHS_1_inst_adr                                                           "0x007E"
+#define SE_VDHS_2_inst_adr                                                           "0x007F"
+#define SE_VDHS_0_inst                                                               0x007D
+#define SE_VDHS_1_inst                                                               0x007E
+#define SE_VDHS_2_inst                                                               0x007F
+#define SE_VDHS_V_scaling_iniph_shift                                                (18)
+#define SE_VDHS_V_scaling_iniph_mask                                                 (0x003C0000)
+#define SE_VDHS_V_scaling_iniph(data)                                                (0x003C0000&((data)<<18))
+#define SE_VDHS_V_scaling_iniph_src(data)                                            ((0x003C0000&(data))>>18)
+#define SE_VDHS_get_V_scaling_iniph(data)                                            ((0x003C0000&(data))>>18)
+#define SE_VDHS_V_scaling_dph_msb_shift                                              (14)
+#define SE_VDHS_V_scaling_dph_msb_mask                                               (0x0003C000)
+#define SE_VDHS_V_scaling_dph_msb(data)                                              (0x0003C000&((data)<<14))
+#define SE_VDHS_V_scaling_dph_msb_src(data)                                          ((0x0003C000&(data))>>14)
+#define SE_VDHS_get_V_scaling_dph_msb(data)                                          ((0x0003C000&(data))>>14)
+#define SE_VDHS_V_scaling_dph_lsb_shift                                              (0)
+#define SE_VDHS_V_scaling_dph_lsb_mask                                               (0x00003FFF)
+#define SE_VDHS_V_scaling_dph_lsb(data)                                              (0x00003FFF&((data)<<0))
+#define SE_VDHS_V_scaling_dph_lsb_src(data)                                          ((0x00003FFF&(data))>>0)
+#define SE_VDHS_get_V_scaling_dph_lsb(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#define SE_HCOEF1_0                                                                  0x1800C200
+#define SE_HCOEF1_1                                                                  0x1800C204
+#define SE_HCOEF1_2                                                                  0x1800C208
+#define SE_HCOEF1_3                                                                  0x1800C20C
+#define SE_HCOEF1_4                                                                  0x1800C210
+#define SE_HCOEF1_5                                                                  0x1800C214
+#define SE_HCOEF1_6                                                                  0x1800C218
+#define SE_HCOEF1_7                                                                  0x1800C21C
+#define SE_HCOEF1_8                                                                  0x1800C220
+#define SE_HCOEF1_9                                                                  0x1800C224
+#define SE_HCOEF1_10                                                                  0x1800C228
+#define SE_HCOEF1_11                                                                  0x1800C22C
+#define SE_HCOEF1_12                                                                  0x1800C230
+#define SE_HCOEF1_13                                                                  0x1800C234
+#define SE_HCOEF1_14                                                                  0x1800C238
+#define SE_HCOEF1_15                                                                  0x1800C23C
+#define SE_HCOEF1_16                                                                  0x1800C240
+#define SE_HCOEF1_17                                                                  0x1800C244
+#define SE_HCOEF1_18                                                                  0x1800C248
+#define SE_HCOEF1_19                                                                  0x1800C24C
+#define SE_HCOEF1_20                                                                  0x1800C250
+#define SE_HCOEF1_21                                                                  0x1800C254
+#define SE_HCOEF1_22                                                                  0x1800C258
+#define SE_HCOEF1_23                                                                  0x1800C25C
+#define SE_HCOEF1_24                                                                  0x1800C260
+#define SE_HCOEF1_25                                                                  0x1800C264
+#define SE_HCOEF1_26                                                                  0x1800C268
+#define SE_HCOEF1_27                                                                  0x1800C26C
+#define SE_HCOEF1_28                                                                  0x1800C270
+#define SE_HCOEF1_29                                                                  0x1800C274
+#define SE_HCOEF1_30                                                                  0x1800C278
+#define SE_HCOEF1_31                                                                  0x1800C27C
+#define SE_HCOEF1_0_reg_addr                                                         "0xB800C200"
+#define SE_HCOEF1_1_reg_addr                                                         "0xB800C204"
+#define SE_HCOEF1_2_reg_addr                                                         "0xB800C208"
+#define SE_HCOEF1_3_reg_addr                                                         "0xB800C20C"
+#define SE_HCOEF1_4_reg_addr                                                         "0xB800C210"
+#define SE_HCOEF1_5_reg_addr                                                         "0xB800C214"
+#define SE_HCOEF1_6_reg_addr                                                         "0xB800C218"
+#define SE_HCOEF1_7_reg_addr                                                         "0xB800C21C"
+#define SE_HCOEF1_8_reg_addr                                                         "0xB800C220"
+#define SE_HCOEF1_9_reg_addr                                                         "0xB800C224"
+#define SE_HCOEF1_10_reg_addr                                                         "0xB800C228"
+#define SE_HCOEF1_11_reg_addr                                                         "0xB800C22C"
+#define SE_HCOEF1_12_reg_addr                                                         "0xB800C230"
+#define SE_HCOEF1_13_reg_addr                                                         "0xB800C234"
+#define SE_HCOEF1_14_reg_addr                                                         "0xB800C238"
+#define SE_HCOEF1_15_reg_addr                                                         "0xB800C23C"
+#define SE_HCOEF1_16_reg_addr                                                         "0xB800C240"
+#define SE_HCOEF1_17_reg_addr                                                         "0xB800C244"
+#define SE_HCOEF1_18_reg_addr                                                         "0xB800C248"
+#define SE_HCOEF1_19_reg_addr                                                         "0xB800C24C"
+#define SE_HCOEF1_20_reg_addr                                                         "0xB800C250"
+#define SE_HCOEF1_21_reg_addr                                                         "0xB800C254"
+#define SE_HCOEF1_22_reg_addr                                                         "0xB800C258"
+#define SE_HCOEF1_23_reg_addr                                                         "0xB800C25C"
+#define SE_HCOEF1_24_reg_addr                                                         "0xB800C260"
+#define SE_HCOEF1_25_reg_addr                                                         "0xB800C264"
+#define SE_HCOEF1_26_reg_addr                                                         "0xB800C268"
+#define SE_HCOEF1_27_reg_addr                                                         "0xB800C26C"
+#define SE_HCOEF1_28_reg_addr                                                         "0xB800C270"
+#define SE_HCOEF1_29_reg_addr                                                         "0xB800C274"
+#define SE_HCOEF1_30_reg_addr                                                         "0xB800C278"
+#define SE_HCOEF1_31_reg_addr                                                         "0xB800C27C"
+#define SE_HCOEF1_0_reg                                                              0xB800C200
+#define SE_HCOEF1_1_reg                                                              0xB800C204
+#define SE_HCOEF1_2_reg                                                              0xB800C208
+#define SE_HCOEF1_3_reg                                                              0xB800C20C
+#define SE_HCOEF1_4_reg                                                              0xB800C210
+#define SE_HCOEF1_5_reg                                                              0xB800C214
+#define SE_HCOEF1_6_reg                                                              0xB800C218
+#define SE_HCOEF1_7_reg                                                              0xB800C21C
+#define SE_HCOEF1_8_reg                                                              0xB800C220
+#define SE_HCOEF1_9_reg                                                              0xB800C224
+#define SE_HCOEF1_10_reg                                                              0xB800C228
+#define SE_HCOEF1_11_reg                                                              0xB800C22C
+#define SE_HCOEF1_12_reg                                                              0xB800C230
+#define SE_HCOEF1_13_reg                                                              0xB800C234
+#define SE_HCOEF1_14_reg                                                              0xB800C238
+#define SE_HCOEF1_15_reg                                                              0xB800C23C
+#define SE_HCOEF1_16_reg                                                              0xB800C240
+#define SE_HCOEF1_17_reg                                                              0xB800C244
+#define SE_HCOEF1_18_reg                                                              0xB800C248
+#define SE_HCOEF1_19_reg                                                              0xB800C24C
+#define SE_HCOEF1_20_reg                                                              0xB800C250
+#define SE_HCOEF1_21_reg                                                              0xB800C254
+#define SE_HCOEF1_22_reg                                                              0xB800C258
+#define SE_HCOEF1_23_reg                                                              0xB800C25C
+#define SE_HCOEF1_24_reg                                                              0xB800C260
+#define SE_HCOEF1_25_reg                                                              0xB800C264
+#define SE_HCOEF1_26_reg                                                              0xB800C268
+#define SE_HCOEF1_27_reg                                                              0xB800C26C
+#define SE_HCOEF1_28_reg                                                              0xB800C270
+#define SE_HCOEF1_29_reg                                                              0xB800C274
+#define SE_HCOEF1_30_reg                                                              0xB800C278
+#define SE_HCOEF1_31_reg                                                              0xB800C27C
+#define set_SE_HCOEF1_0_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_0_reg)=data)
+#define set_SE_HCOEF1_1_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_1_reg)=data)
+#define set_SE_HCOEF1_2_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_2_reg)=data)
+#define set_SE_HCOEF1_3_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_3_reg)=data)
+#define set_SE_HCOEF1_4_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_4_reg)=data)
+#define set_SE_HCOEF1_5_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_5_reg)=data)
+#define set_SE_HCOEF1_6_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_6_reg)=data)
+#define set_SE_HCOEF1_7_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_7_reg)=data)
+#define set_SE_HCOEF1_8_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_8_reg)=data)
+#define set_SE_HCOEF1_9_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_9_reg)=data)
+#define set_SE_HCOEF1_10_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_10_reg)=data)
+#define set_SE_HCOEF1_11_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_11_reg)=data)
+#define set_SE_HCOEF1_12_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_12_reg)=data)
+#define set_SE_HCOEF1_13_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_13_reg)=data)
+#define set_SE_HCOEF1_14_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_14_reg)=data)
+#define set_SE_HCOEF1_15_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_15_reg)=data)
+#define set_SE_HCOEF1_16_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_16_reg)=data)
+#define set_SE_HCOEF1_17_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_17_reg)=data)
+#define set_SE_HCOEF1_18_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_18_reg)=data)
+#define set_SE_HCOEF1_19_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_19_reg)=data)
+#define set_SE_HCOEF1_20_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_20_reg)=data)
+#define set_SE_HCOEF1_21_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_21_reg)=data)
+#define set_SE_HCOEF1_22_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_22_reg)=data)
+#define set_SE_HCOEF1_23_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_23_reg)=data)
+#define set_SE_HCOEF1_24_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_24_reg)=data)
+#define set_SE_HCOEF1_25_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_25_reg)=data)
+#define set_SE_HCOEF1_26_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_26_reg)=data)
+#define set_SE_HCOEF1_27_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_27_reg)=data)
+#define set_SE_HCOEF1_28_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_28_reg)=data)
+#define set_SE_HCOEF1_29_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_29_reg)=data)
+#define set_SE_HCOEF1_30_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_30_reg)=data)
+#define set_SE_HCOEF1_31_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_31_reg)=data)
+#define get_SE_HCOEF1_0_reg   (*((volatile unsigned int*) SE_HCOEF1_0_reg))
+#define get_SE_HCOEF1_1_reg   (*((volatile unsigned int*) SE_HCOEF1_1_reg))
+#define get_SE_HCOEF1_2_reg   (*((volatile unsigned int*) SE_HCOEF1_2_reg))
+#define get_SE_HCOEF1_3_reg   (*((volatile unsigned int*) SE_HCOEF1_3_reg))
+#define get_SE_HCOEF1_4_reg   (*((volatile unsigned int*) SE_HCOEF1_4_reg))
+#define get_SE_HCOEF1_5_reg   (*((volatile unsigned int*) SE_HCOEF1_5_reg))
+#define get_SE_HCOEF1_6_reg   (*((volatile unsigned int*) SE_HCOEF1_6_reg))
+#define get_SE_HCOEF1_7_reg   (*((volatile unsigned int*) SE_HCOEF1_7_reg))
+#define get_SE_HCOEF1_8_reg   (*((volatile unsigned int*) SE_HCOEF1_8_reg))
+#define get_SE_HCOEF1_9_reg   (*((volatile unsigned int*) SE_HCOEF1_9_reg))
+#define get_SE_HCOEF1_10_reg   (*((volatile unsigned int*) SE_HCOEF1_10_reg))
+#define get_SE_HCOEF1_11_reg   (*((volatile unsigned int*) SE_HCOEF1_11_reg))
+#define get_SE_HCOEF1_12_reg   (*((volatile unsigned int*) SE_HCOEF1_12_reg))
+#define get_SE_HCOEF1_13_reg   (*((volatile unsigned int*) SE_HCOEF1_13_reg))
+#define get_SE_HCOEF1_14_reg   (*((volatile unsigned int*) SE_HCOEF1_14_reg))
+#define get_SE_HCOEF1_15_reg   (*((volatile unsigned int*) SE_HCOEF1_15_reg))
+#define get_SE_HCOEF1_16_reg   (*((volatile unsigned int*) SE_HCOEF1_16_reg))
+#define get_SE_HCOEF1_17_reg   (*((volatile unsigned int*) SE_HCOEF1_17_reg))
+#define get_SE_HCOEF1_18_reg   (*((volatile unsigned int*) SE_HCOEF1_18_reg))
+#define get_SE_HCOEF1_19_reg   (*((volatile unsigned int*) SE_HCOEF1_19_reg))
+#define get_SE_HCOEF1_20_reg   (*((volatile unsigned int*) SE_HCOEF1_20_reg))
+#define get_SE_HCOEF1_21_reg   (*((volatile unsigned int*) SE_HCOEF1_21_reg))
+#define get_SE_HCOEF1_22_reg   (*((volatile unsigned int*) SE_HCOEF1_22_reg))
+#define get_SE_HCOEF1_23_reg   (*((volatile unsigned int*) SE_HCOEF1_23_reg))
+#define get_SE_HCOEF1_24_reg   (*((volatile unsigned int*) SE_HCOEF1_24_reg))
+#define get_SE_HCOEF1_25_reg   (*((volatile unsigned int*) SE_HCOEF1_25_reg))
+#define get_SE_HCOEF1_26_reg   (*((volatile unsigned int*) SE_HCOEF1_26_reg))
+#define get_SE_HCOEF1_27_reg   (*((volatile unsigned int*) SE_HCOEF1_27_reg))
+#define get_SE_HCOEF1_28_reg   (*((volatile unsigned int*) SE_HCOEF1_28_reg))
+#define get_SE_HCOEF1_29_reg   (*((volatile unsigned int*) SE_HCOEF1_29_reg))
+#define get_SE_HCOEF1_30_reg   (*((volatile unsigned int*) SE_HCOEF1_30_reg))
+#define get_SE_HCOEF1_31_reg   (*((volatile unsigned int*) SE_HCOEF1_31_reg))
+#define SE_HCOEF1_0_inst_adr                                                         "0x0080"
+#define SE_HCOEF1_1_inst_adr                                                         "0x0081"
+#define SE_HCOEF1_2_inst_adr                                                         "0x0082"
+#define SE_HCOEF1_3_inst_adr                                                         "0x0083"
+#define SE_HCOEF1_4_inst_adr                                                         "0x0084"
+#define SE_HCOEF1_5_inst_adr                                                         "0x0085"
+#define SE_HCOEF1_6_inst_adr                                                         "0x0086"
+#define SE_HCOEF1_7_inst_adr                                                         "0x0087"
+#define SE_HCOEF1_8_inst_adr                                                         "0x0088"
+#define SE_HCOEF1_9_inst_adr                                                         "0x0089"
+#define SE_HCOEF1_10_inst_adr                                                         "0x008A"
+#define SE_HCOEF1_11_inst_adr                                                         "0x008B"
+#define SE_HCOEF1_12_inst_adr                                                         "0x008C"
+#define SE_HCOEF1_13_inst_adr                                                         "0x008D"
+#define SE_HCOEF1_14_inst_adr                                                         "0x008E"
+#define SE_HCOEF1_15_inst_adr                                                         "0x008F"
+#define SE_HCOEF1_16_inst_adr                                                         "0x0090"
+#define SE_HCOEF1_17_inst_adr                                                         "0x0091"
+#define SE_HCOEF1_18_inst_adr                                                         "0x0092"
+#define SE_HCOEF1_19_inst_adr                                                         "0x0093"
+#define SE_HCOEF1_20_inst_adr                                                         "0x0094"
+#define SE_HCOEF1_21_inst_adr                                                         "0x0095"
+#define SE_HCOEF1_22_inst_adr                                                         "0x0096"
+#define SE_HCOEF1_23_inst_adr                                                         "0x0097"
+#define SE_HCOEF1_24_inst_adr                                                         "0x0098"
+#define SE_HCOEF1_25_inst_adr                                                         "0x0099"
+#define SE_HCOEF1_26_inst_adr                                                         "0x009A"
+#define SE_HCOEF1_27_inst_adr                                                         "0x009B"
+#define SE_HCOEF1_28_inst_adr                                                         "0x009C"
+#define SE_HCOEF1_29_inst_adr                                                         "0x009D"
+#define SE_HCOEF1_30_inst_adr                                                         "0x009E"
+#define SE_HCOEF1_31_inst_adr                                                         "0x009F"
+#define SE_HCOEF1_0_inst                                                             0x0080
+#define SE_HCOEF1_1_inst                                                             0x0081
+#define SE_HCOEF1_2_inst                                                             0x0082
+#define SE_HCOEF1_3_inst                                                             0x0083
+#define SE_HCOEF1_4_inst                                                             0x0084
+#define SE_HCOEF1_5_inst                                                             0x0085
+#define SE_HCOEF1_6_inst                                                             0x0086
+#define SE_HCOEF1_7_inst                                                             0x0087
+#define SE_HCOEF1_8_inst                                                             0x0088
+#define SE_HCOEF1_9_inst                                                             0x0089
+#define SE_HCOEF1_10_inst                                                             0x008A
+#define SE_HCOEF1_11_inst                                                             0x008B
+#define SE_HCOEF1_12_inst                                                             0x008C
+#define SE_HCOEF1_13_inst                                                             0x008D
+#define SE_HCOEF1_14_inst                                                             0x008E
+#define SE_HCOEF1_15_inst                                                             0x008F
+#define SE_HCOEF1_16_inst                                                             0x0090
+#define SE_HCOEF1_17_inst                                                             0x0091
+#define SE_HCOEF1_18_inst                                                             0x0092
+#define SE_HCOEF1_19_inst                                                             0x0093
+#define SE_HCOEF1_20_inst                                                             0x0094
+#define SE_HCOEF1_21_inst                                                             0x0095
+#define SE_HCOEF1_22_inst                                                             0x0096
+#define SE_HCOEF1_23_inst                                                             0x0097
+#define SE_HCOEF1_24_inst                                                             0x0098
+#define SE_HCOEF1_25_inst                                                             0x0099
+#define SE_HCOEF1_26_inst                                                             0x009A
+#define SE_HCOEF1_27_inst                                                             0x009B
+#define SE_HCOEF1_28_inst                                                             0x009C
+#define SE_HCOEF1_29_inst                                                             0x009D
+#define SE_HCOEF1_30_inst                                                             0x009E
+#define SE_HCOEF1_31_inst                                                             0x009F
+#define SE_HCOEF1_hcoef_shift                                                        (0)
+#define SE_HCOEF1_hcoef_mask                                                         (0x00003FFF)
+#define SE_HCOEF1_hcoef(data)                                                        (0x00003FFF&((data)<<0))
+#define SE_HCOEF1_hcoef_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define SE_HCOEF1_get_hcoef(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define SE_HCOEF1_32_0                                                               0x1800C558
+#define SE_HCOEF1_32_1                                                               0x1800C55C
+#define SE_HCOEF1_32_2                                                               0x1800C560
+#define SE_HCOEF1_32_3                                                               0x1800C564
+#define SE_HCOEF1_32_4                                                               0x1800C568
+#define SE_HCOEF1_32_5                                                               0x1800C56C
+#define SE_HCOEF1_32_6                                                               0x1800C570
+#define SE_HCOEF1_32_7                                                               0x1800C574
+#define SE_HCOEF1_32_8                                                               0x1800C578
+#define SE_HCOEF1_32_9                                                               0x1800C57C
+#define SE_HCOEF1_32_10                                                               0x1800C580
+#define SE_HCOEF1_32_11                                                               0x1800C584
+#define SE_HCOEF1_32_12                                                               0x1800C588
+#define SE_HCOEF1_32_13                                                               0x1800C58C
+#define SE_HCOEF1_32_14                                                               0x1800C590
+#define SE_HCOEF1_32_15                                                               0x1800C594
+#define SE_HCOEF1_32_16                                                               0x1800C598
+#define SE_HCOEF1_32_17                                                               0x1800C59C
+#define SE_HCOEF1_32_18                                                               0x1800C5A0
+#define SE_HCOEF1_32_19                                                               0x1800C5A4
+#define SE_HCOEF1_32_20                                                               0x1800C5A8
+#define SE_HCOEF1_32_21                                                               0x1800C5AC
+#define SE_HCOEF1_32_22                                                               0x1800C5B0
+#define SE_HCOEF1_32_23                                                               0x1800C5B4
+#define SE_HCOEF1_32_24                                                               0x1800C5B8
+#define SE_HCOEF1_32_25                                                               0x1800C5BC
+#define SE_HCOEF1_32_26                                                               0x1800C5C0
+#define SE_HCOEF1_32_27                                                               0x1800C5C4
+#define SE_HCOEF1_32_28                                                               0x1800C5C8
+#define SE_HCOEF1_32_29                                                               0x1800C5CC
+#define SE_HCOEF1_32_30                                                               0x1800C5D0
+#define SE_HCOEF1_32_31                                                               0x1800C5D4
+#define SE_HCOEF1_32_0_reg_addr                                                      "0xB800C558"
+#define SE_HCOEF1_32_1_reg_addr                                                      "0xB800C55C"
+#define SE_HCOEF1_32_2_reg_addr                                                      "0xB800C560"
+#define SE_HCOEF1_32_3_reg_addr                                                      "0xB800C564"
+#define SE_HCOEF1_32_4_reg_addr                                                      "0xB800C568"
+#define SE_HCOEF1_32_5_reg_addr                                                      "0xB800C56C"
+#define SE_HCOEF1_32_6_reg_addr                                                      "0xB800C570"
+#define SE_HCOEF1_32_7_reg_addr                                                      "0xB800C574"
+#define SE_HCOEF1_32_8_reg_addr                                                      "0xB800C578"
+#define SE_HCOEF1_32_9_reg_addr                                                      "0xB800C57C"
+#define SE_HCOEF1_32_10_reg_addr                                                      "0xB800C580"
+#define SE_HCOEF1_32_11_reg_addr                                                      "0xB800C584"
+#define SE_HCOEF1_32_12_reg_addr                                                      "0xB800C588"
+#define SE_HCOEF1_32_13_reg_addr                                                      "0xB800C58C"
+#define SE_HCOEF1_32_14_reg_addr                                                      "0xB800C590"
+#define SE_HCOEF1_32_15_reg_addr                                                      "0xB800C594"
+#define SE_HCOEF1_32_16_reg_addr                                                      "0xB800C598"
+#define SE_HCOEF1_32_17_reg_addr                                                      "0xB800C59C"
+#define SE_HCOEF1_32_18_reg_addr                                                      "0xB800C5A0"
+#define SE_HCOEF1_32_19_reg_addr                                                      "0xB800C5A4"
+#define SE_HCOEF1_32_20_reg_addr                                                      "0xB800C5A8"
+#define SE_HCOEF1_32_21_reg_addr                                                      "0xB800C5AC"
+#define SE_HCOEF1_32_22_reg_addr                                                      "0xB800C5B0"
+#define SE_HCOEF1_32_23_reg_addr                                                      "0xB800C5B4"
+#define SE_HCOEF1_32_24_reg_addr                                                      "0xB800C5B8"
+#define SE_HCOEF1_32_25_reg_addr                                                      "0xB800C5BC"
+#define SE_HCOEF1_32_26_reg_addr                                                      "0xB800C5C0"
+#define SE_HCOEF1_32_27_reg_addr                                                      "0xB800C5C4"
+#define SE_HCOEF1_32_28_reg_addr                                                      "0xB800C5C8"
+#define SE_HCOEF1_32_29_reg_addr                                                      "0xB800C5CC"
+#define SE_HCOEF1_32_30_reg_addr                                                      "0xB800C5D0"
+#define SE_HCOEF1_32_31_reg_addr                                                      "0xB800C5D4"
+#define SE_HCOEF1_32_0_reg                                                           0xB800C558
+#define SE_HCOEF1_32_1_reg                                                           0xB800C55C
+#define SE_HCOEF1_32_2_reg                                                           0xB800C560
+#define SE_HCOEF1_32_3_reg                                                           0xB800C564
+#define SE_HCOEF1_32_4_reg                                                           0xB800C568
+#define SE_HCOEF1_32_5_reg                                                           0xB800C56C
+#define SE_HCOEF1_32_6_reg                                                           0xB800C570
+#define SE_HCOEF1_32_7_reg                                                           0xB800C574
+#define SE_HCOEF1_32_8_reg                                                           0xB800C578
+#define SE_HCOEF1_32_9_reg                                                           0xB800C57C
+#define SE_HCOEF1_32_10_reg                                                           0xB800C580
+#define SE_HCOEF1_32_11_reg                                                           0xB800C584
+#define SE_HCOEF1_32_12_reg                                                           0xB800C588
+#define SE_HCOEF1_32_13_reg                                                           0xB800C58C
+#define SE_HCOEF1_32_14_reg                                                           0xB800C590
+#define SE_HCOEF1_32_15_reg                                                           0xB800C594
+#define SE_HCOEF1_32_16_reg                                                           0xB800C598
+#define SE_HCOEF1_32_17_reg                                                           0xB800C59C
+#define SE_HCOEF1_32_18_reg                                                           0xB800C5A0
+#define SE_HCOEF1_32_19_reg                                                           0xB800C5A4
+#define SE_HCOEF1_32_20_reg                                                           0xB800C5A8
+#define SE_HCOEF1_32_21_reg                                                           0xB800C5AC
+#define SE_HCOEF1_32_22_reg                                                           0xB800C5B0
+#define SE_HCOEF1_32_23_reg                                                           0xB800C5B4
+#define SE_HCOEF1_32_24_reg                                                           0xB800C5B8
+#define SE_HCOEF1_32_25_reg                                                           0xB800C5BC
+#define SE_HCOEF1_32_26_reg                                                           0xB800C5C0
+#define SE_HCOEF1_32_27_reg                                                           0xB800C5C4
+#define SE_HCOEF1_32_28_reg                                                           0xB800C5C8
+#define SE_HCOEF1_32_29_reg                                                           0xB800C5CC
+#define SE_HCOEF1_32_30_reg                                                           0xB800C5D0
+#define SE_HCOEF1_32_31_reg                                                           0xB800C5D4
+#define set_SE_HCOEF1_32_0_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_0_reg)=data)
+#define set_SE_HCOEF1_32_1_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_1_reg)=data)
+#define set_SE_HCOEF1_32_2_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_2_reg)=data)
+#define set_SE_HCOEF1_32_3_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_3_reg)=data)
+#define set_SE_HCOEF1_32_4_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_4_reg)=data)
+#define set_SE_HCOEF1_32_5_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_5_reg)=data)
+#define set_SE_HCOEF1_32_6_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_6_reg)=data)
+#define set_SE_HCOEF1_32_7_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_7_reg)=data)
+#define set_SE_HCOEF1_32_8_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_8_reg)=data)
+#define set_SE_HCOEF1_32_9_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_9_reg)=data)
+#define set_SE_HCOEF1_32_10_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_10_reg)=data)
+#define set_SE_HCOEF1_32_11_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_11_reg)=data)
+#define set_SE_HCOEF1_32_12_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_12_reg)=data)
+#define set_SE_HCOEF1_32_13_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_13_reg)=data)
+#define set_SE_HCOEF1_32_14_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_14_reg)=data)
+#define set_SE_HCOEF1_32_15_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_15_reg)=data)
+#define set_SE_HCOEF1_32_16_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_16_reg)=data)
+#define set_SE_HCOEF1_32_17_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_17_reg)=data)
+#define set_SE_HCOEF1_32_18_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_18_reg)=data)
+#define set_SE_HCOEF1_32_19_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_19_reg)=data)
+#define set_SE_HCOEF1_32_20_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_20_reg)=data)
+#define set_SE_HCOEF1_32_21_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_21_reg)=data)
+#define set_SE_HCOEF1_32_22_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_22_reg)=data)
+#define set_SE_HCOEF1_32_23_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_23_reg)=data)
+#define set_SE_HCOEF1_32_24_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_24_reg)=data)
+#define set_SE_HCOEF1_32_25_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_25_reg)=data)
+#define set_SE_HCOEF1_32_26_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_26_reg)=data)
+#define set_SE_HCOEF1_32_27_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_27_reg)=data)
+#define set_SE_HCOEF1_32_28_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_28_reg)=data)
+#define set_SE_HCOEF1_32_29_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_29_reg)=data)
+#define set_SE_HCOEF1_32_30_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_30_reg)=data)
+#define set_SE_HCOEF1_32_31_reg(data)   (*((volatile unsigned int*) SE_HCOEF1_32_31_reg)=data)
+#define get_SE_HCOEF1_32_0_reg   (*((volatile unsigned int*) SE_HCOEF1_32_0_reg))
+#define get_SE_HCOEF1_32_1_reg   (*((volatile unsigned int*) SE_HCOEF1_32_1_reg))
+#define get_SE_HCOEF1_32_2_reg   (*((volatile unsigned int*) SE_HCOEF1_32_2_reg))
+#define get_SE_HCOEF1_32_3_reg   (*((volatile unsigned int*) SE_HCOEF1_32_3_reg))
+#define get_SE_HCOEF1_32_4_reg   (*((volatile unsigned int*) SE_HCOEF1_32_4_reg))
+#define get_SE_HCOEF1_32_5_reg   (*((volatile unsigned int*) SE_HCOEF1_32_5_reg))
+#define get_SE_HCOEF1_32_6_reg   (*((volatile unsigned int*) SE_HCOEF1_32_6_reg))
+#define get_SE_HCOEF1_32_7_reg   (*((volatile unsigned int*) SE_HCOEF1_32_7_reg))
+#define get_SE_HCOEF1_32_8_reg   (*((volatile unsigned int*) SE_HCOEF1_32_8_reg))
+#define get_SE_HCOEF1_32_9_reg   (*((volatile unsigned int*) SE_HCOEF1_32_9_reg))
+#define get_SE_HCOEF1_32_10_reg   (*((volatile unsigned int*) SE_HCOEF1_32_10_reg))
+#define get_SE_HCOEF1_32_11_reg   (*((volatile unsigned int*) SE_HCOEF1_32_11_reg))
+#define get_SE_HCOEF1_32_12_reg   (*((volatile unsigned int*) SE_HCOEF1_32_12_reg))
+#define get_SE_HCOEF1_32_13_reg   (*((volatile unsigned int*) SE_HCOEF1_32_13_reg))
+#define get_SE_HCOEF1_32_14_reg   (*((volatile unsigned int*) SE_HCOEF1_32_14_reg))
+#define get_SE_HCOEF1_32_15_reg   (*((volatile unsigned int*) SE_HCOEF1_32_15_reg))
+#define get_SE_HCOEF1_32_16_reg   (*((volatile unsigned int*) SE_HCOEF1_32_16_reg))
+#define get_SE_HCOEF1_32_17_reg   (*((volatile unsigned int*) SE_HCOEF1_32_17_reg))
+#define get_SE_HCOEF1_32_18_reg   (*((volatile unsigned int*) SE_HCOEF1_32_18_reg))
+#define get_SE_HCOEF1_32_19_reg   (*((volatile unsigned int*) SE_HCOEF1_32_19_reg))
+#define get_SE_HCOEF1_32_20_reg   (*((volatile unsigned int*) SE_HCOEF1_32_20_reg))
+#define get_SE_HCOEF1_32_21_reg   (*((volatile unsigned int*) SE_HCOEF1_32_21_reg))
+#define get_SE_HCOEF1_32_22_reg   (*((volatile unsigned int*) SE_HCOEF1_32_22_reg))
+#define get_SE_HCOEF1_32_23_reg   (*((volatile unsigned int*) SE_HCOEF1_32_23_reg))
+#define get_SE_HCOEF1_32_24_reg   (*((volatile unsigned int*) SE_HCOEF1_32_24_reg))
+#define get_SE_HCOEF1_32_25_reg   (*((volatile unsigned int*) SE_HCOEF1_32_25_reg))
+#define get_SE_HCOEF1_32_26_reg   (*((volatile unsigned int*) SE_HCOEF1_32_26_reg))
+#define get_SE_HCOEF1_32_27_reg   (*((volatile unsigned int*) SE_HCOEF1_32_27_reg))
+#define get_SE_HCOEF1_32_28_reg   (*((volatile unsigned int*) SE_HCOEF1_32_28_reg))
+#define get_SE_HCOEF1_32_29_reg   (*((volatile unsigned int*) SE_HCOEF1_32_29_reg))
+#define get_SE_HCOEF1_32_30_reg   (*((volatile unsigned int*) SE_HCOEF1_32_30_reg))
+#define get_SE_HCOEF1_32_31_reg   (*((volatile unsigned int*) SE_HCOEF1_32_31_reg))
+#define SE_HCOEF1_32_0_inst_adr                                                      "0x0056"
+#define SE_HCOEF1_32_1_inst_adr                                                      "0x0057"
+#define SE_HCOEF1_32_2_inst_adr                                                      "0x0058"
+#define SE_HCOEF1_32_3_inst_adr                                                      "0x0059"
+#define SE_HCOEF1_32_4_inst_adr                                                      "0x005A"
+#define SE_HCOEF1_32_5_inst_adr                                                      "0x005B"
+#define SE_HCOEF1_32_6_inst_adr                                                      "0x005C"
+#define SE_HCOEF1_32_7_inst_adr                                                      "0x005D"
+#define SE_HCOEF1_32_8_inst_adr                                                      "0x005E"
+#define SE_HCOEF1_32_9_inst_adr                                                      "0x005F"
+#define SE_HCOEF1_32_10_inst_adr                                                      "0x0060"
+#define SE_HCOEF1_32_11_inst_adr                                                      "0x0061"
+#define SE_HCOEF1_32_12_inst_adr                                                      "0x0062"
+#define SE_HCOEF1_32_13_inst_adr                                                      "0x0063"
+#define SE_HCOEF1_32_14_inst_adr                                                      "0x0064"
+#define SE_HCOEF1_32_15_inst_adr                                                      "0x0065"
+#define SE_HCOEF1_32_16_inst_adr                                                      "0x0066"
+#define SE_HCOEF1_32_17_inst_adr                                                      "0x0067"
+#define SE_HCOEF1_32_18_inst_adr                                                      "0x0068"
+#define SE_HCOEF1_32_19_inst_adr                                                      "0x0069"
+#define SE_HCOEF1_32_20_inst_adr                                                      "0x006A"
+#define SE_HCOEF1_32_21_inst_adr                                                      "0x006B"
+#define SE_HCOEF1_32_22_inst_adr                                                      "0x006C"
+#define SE_HCOEF1_32_23_inst_adr                                                      "0x006D"
+#define SE_HCOEF1_32_24_inst_adr                                                      "0x006E"
+#define SE_HCOEF1_32_25_inst_adr                                                      "0x006F"
+#define SE_HCOEF1_32_26_inst_adr                                                      "0x0070"
+#define SE_HCOEF1_32_27_inst_adr                                                      "0x0071"
+#define SE_HCOEF1_32_28_inst_adr                                                      "0x0072"
+#define SE_HCOEF1_32_29_inst_adr                                                      "0x0073"
+#define SE_HCOEF1_32_30_inst_adr                                                      "0x0074"
+#define SE_HCOEF1_32_31_inst_adr                                                      "0x0075"
+#define SE_HCOEF1_32_0_inst                                                          0x0056
+#define SE_HCOEF1_32_1_inst                                                          0x0057
+#define SE_HCOEF1_32_2_inst                                                          0x0058
+#define SE_HCOEF1_32_3_inst                                                          0x0059
+#define SE_HCOEF1_32_4_inst                                                          0x005A
+#define SE_HCOEF1_32_5_inst                                                          0x005B
+#define SE_HCOEF1_32_6_inst                                                          0x005C
+#define SE_HCOEF1_32_7_inst                                                          0x005D
+#define SE_HCOEF1_32_8_inst                                                          0x005E
+#define SE_HCOEF1_32_9_inst                                                          0x005F
+#define SE_HCOEF1_32_10_inst                                                          0x0060
+#define SE_HCOEF1_32_11_inst                                                          0x0061
+#define SE_HCOEF1_32_12_inst                                                          0x0062
+#define SE_HCOEF1_32_13_inst                                                          0x0063
+#define SE_HCOEF1_32_14_inst                                                          0x0064
+#define SE_HCOEF1_32_15_inst                                                          0x0065
+#define SE_HCOEF1_32_16_inst                                                          0x0066
+#define SE_HCOEF1_32_17_inst                                                          0x0067
+#define SE_HCOEF1_32_18_inst                                                          0x0068
+#define SE_HCOEF1_32_19_inst                                                          0x0069
+#define SE_HCOEF1_32_20_inst                                                          0x006A
+#define SE_HCOEF1_32_21_inst                                                          0x006B
+#define SE_HCOEF1_32_22_inst                                                          0x006C
+#define SE_HCOEF1_32_23_inst                                                          0x006D
+#define SE_HCOEF1_32_24_inst                                                          0x006E
+#define SE_HCOEF1_32_25_inst                                                          0x006F
+#define SE_HCOEF1_32_26_inst                                                          0x0070
+#define SE_HCOEF1_32_27_inst                                                          0x0071
+#define SE_HCOEF1_32_28_inst                                                          0x0072
+#define SE_HCOEF1_32_29_inst                                                          0x0073
+#define SE_HCOEF1_32_30_inst                                                          0x0074
+#define SE_HCOEF1_32_31_inst                                                          0x0075
+#define SE_HCOEF1_32_hcoef_shift                                                     (0)
+#define SE_HCOEF1_32_hcoef_mask                                                      (0x00003FFF)
+#define SE_HCOEF1_32_hcoef(data)                                                     (0x00003FFF&((data)<<0))
+#define SE_HCOEF1_32_hcoef_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define SE_HCOEF1_32_get_hcoef(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define SE_VCOEF1_0                                                                  0x1800C280
+#define SE_VCOEF1_1                                                                  0x1800C284
+#define SE_VCOEF1_2                                                                  0x1800C288
+#define SE_VCOEF1_3                                                                  0x1800C28C
+#define SE_VCOEF1_4                                                                  0x1800C290
+#define SE_VCOEF1_5                                                                  0x1800C294
+#define SE_VCOEF1_6                                                                  0x1800C298
+#define SE_VCOEF1_7                                                                  0x1800C29C
+#define SE_VCOEF1_8                                                                  0x1800C2A0
+#define SE_VCOEF1_9                                                                  0x1800C2A4
+#define SE_VCOEF1_10                                                                  0x1800C2A8
+#define SE_VCOEF1_11                                                                  0x1800C2AC
+#define SE_VCOEF1_12                                                                  0x1800C2B0
+#define SE_VCOEF1_13                                                                  0x1800C2B4
+#define SE_VCOEF1_14                                                                  0x1800C2B8
+#define SE_VCOEF1_15                                                                  0x1800C2BC
+#define SE_VCOEF1_0_reg_addr                                                         "0xB800C280"
+#define SE_VCOEF1_1_reg_addr                                                         "0xB800C284"
+#define SE_VCOEF1_2_reg_addr                                                         "0xB800C288"
+#define SE_VCOEF1_3_reg_addr                                                         "0xB800C28C"
+#define SE_VCOEF1_4_reg_addr                                                         "0xB800C290"
+#define SE_VCOEF1_5_reg_addr                                                         "0xB800C294"
+#define SE_VCOEF1_6_reg_addr                                                         "0xB800C298"
+#define SE_VCOEF1_7_reg_addr                                                         "0xB800C29C"
+#define SE_VCOEF1_8_reg_addr                                                         "0xB800C2A0"
+#define SE_VCOEF1_9_reg_addr                                                         "0xB800C2A4"
+#define SE_VCOEF1_10_reg_addr                                                         "0xB800C2A8"
+#define SE_VCOEF1_11_reg_addr                                                         "0xB800C2AC"
+#define SE_VCOEF1_12_reg_addr                                                         "0xB800C2B0"
+#define SE_VCOEF1_13_reg_addr                                                         "0xB800C2B4"
+#define SE_VCOEF1_14_reg_addr                                                         "0xB800C2B8"
+#define SE_VCOEF1_15_reg_addr                                                         "0xB800C2BC"
+#define SE_VCOEF1_0_reg                                                              0xB800C280
+#define SE_VCOEF1_1_reg                                                              0xB800C284
+#define SE_VCOEF1_2_reg                                                              0xB800C288
+#define SE_VCOEF1_3_reg                                                              0xB800C28C
+#define SE_VCOEF1_4_reg                                                              0xB800C290
+#define SE_VCOEF1_5_reg                                                              0xB800C294
+#define SE_VCOEF1_6_reg                                                              0xB800C298
+#define SE_VCOEF1_7_reg                                                              0xB800C29C
+#define SE_VCOEF1_8_reg                                                              0xB800C2A0
+#define SE_VCOEF1_9_reg                                                              0xB800C2A4
+#define SE_VCOEF1_10_reg                                                              0xB800C2A8
+#define SE_VCOEF1_11_reg                                                              0xB800C2AC
+#define SE_VCOEF1_12_reg                                                              0xB800C2B0
+#define SE_VCOEF1_13_reg                                                              0xB800C2B4
+#define SE_VCOEF1_14_reg                                                              0xB800C2B8
+#define SE_VCOEF1_15_reg                                                              0xB800C2BC
+#define set_SE_VCOEF1_0_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_0_reg)=data)
+#define set_SE_VCOEF1_1_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_1_reg)=data)
+#define set_SE_VCOEF1_2_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_2_reg)=data)
+#define set_SE_VCOEF1_3_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_3_reg)=data)
+#define set_SE_VCOEF1_4_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_4_reg)=data)
+#define set_SE_VCOEF1_5_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_5_reg)=data)
+#define set_SE_VCOEF1_6_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_6_reg)=data)
+#define set_SE_VCOEF1_7_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_7_reg)=data)
+#define set_SE_VCOEF1_8_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_8_reg)=data)
+#define set_SE_VCOEF1_9_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_9_reg)=data)
+#define set_SE_VCOEF1_10_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_10_reg)=data)
+#define set_SE_VCOEF1_11_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_11_reg)=data)
+#define set_SE_VCOEF1_12_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_12_reg)=data)
+#define set_SE_VCOEF1_13_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_13_reg)=data)
+#define set_SE_VCOEF1_14_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_14_reg)=data)
+#define set_SE_VCOEF1_15_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_15_reg)=data)
+#define get_SE_VCOEF1_0_reg   (*((volatile unsigned int*) SE_VCOEF1_0_reg))
+#define get_SE_VCOEF1_1_reg   (*((volatile unsigned int*) SE_VCOEF1_1_reg))
+#define get_SE_VCOEF1_2_reg   (*((volatile unsigned int*) SE_VCOEF1_2_reg))
+#define get_SE_VCOEF1_3_reg   (*((volatile unsigned int*) SE_VCOEF1_3_reg))
+#define get_SE_VCOEF1_4_reg   (*((volatile unsigned int*) SE_VCOEF1_4_reg))
+#define get_SE_VCOEF1_5_reg   (*((volatile unsigned int*) SE_VCOEF1_5_reg))
+#define get_SE_VCOEF1_6_reg   (*((volatile unsigned int*) SE_VCOEF1_6_reg))
+#define get_SE_VCOEF1_7_reg   (*((volatile unsigned int*) SE_VCOEF1_7_reg))
+#define get_SE_VCOEF1_8_reg   (*((volatile unsigned int*) SE_VCOEF1_8_reg))
+#define get_SE_VCOEF1_9_reg   (*((volatile unsigned int*) SE_VCOEF1_9_reg))
+#define get_SE_VCOEF1_10_reg   (*((volatile unsigned int*) SE_VCOEF1_10_reg))
+#define get_SE_VCOEF1_11_reg   (*((volatile unsigned int*) SE_VCOEF1_11_reg))
+#define get_SE_VCOEF1_12_reg   (*((volatile unsigned int*) SE_VCOEF1_12_reg))
+#define get_SE_VCOEF1_13_reg   (*((volatile unsigned int*) SE_VCOEF1_13_reg))
+#define get_SE_VCOEF1_14_reg   (*((volatile unsigned int*) SE_VCOEF1_14_reg))
+#define get_SE_VCOEF1_15_reg   (*((volatile unsigned int*) SE_VCOEF1_15_reg))
+#define SE_VCOEF1_0_inst_adr                                                         "0x00A0"
+#define SE_VCOEF1_1_inst_adr                                                         "0x00A1"
+#define SE_VCOEF1_2_inst_adr                                                         "0x00A2"
+#define SE_VCOEF1_3_inst_adr                                                         "0x00A3"
+#define SE_VCOEF1_4_inst_adr                                                         "0x00A4"
+#define SE_VCOEF1_5_inst_adr                                                         "0x00A5"
+#define SE_VCOEF1_6_inst_adr                                                         "0x00A6"
+#define SE_VCOEF1_7_inst_adr                                                         "0x00A7"
+#define SE_VCOEF1_8_inst_adr                                                         "0x00A8"
+#define SE_VCOEF1_9_inst_adr                                                         "0x00A9"
+#define SE_VCOEF1_10_inst_adr                                                         "0x00AA"
+#define SE_VCOEF1_11_inst_adr                                                         "0x00AB"
+#define SE_VCOEF1_12_inst_adr                                                         "0x00AC"
+#define SE_VCOEF1_13_inst_adr                                                         "0x00AD"
+#define SE_VCOEF1_14_inst_adr                                                         "0x00AE"
+#define SE_VCOEF1_15_inst_adr                                                         "0x00AF"
+#define SE_VCOEF1_0_inst                                                             0x00A0
+#define SE_VCOEF1_1_inst                                                             0x00A1
+#define SE_VCOEF1_2_inst                                                             0x00A2
+#define SE_VCOEF1_3_inst                                                             0x00A3
+#define SE_VCOEF1_4_inst                                                             0x00A4
+#define SE_VCOEF1_5_inst                                                             0x00A5
+#define SE_VCOEF1_6_inst                                                             0x00A6
+#define SE_VCOEF1_7_inst                                                             0x00A7
+#define SE_VCOEF1_8_inst                                                             0x00A8
+#define SE_VCOEF1_9_inst                                                             0x00A9
+#define SE_VCOEF1_10_inst                                                             0x00AA
+#define SE_VCOEF1_11_inst                                                             0x00AB
+#define SE_VCOEF1_12_inst                                                             0x00AC
+#define SE_VCOEF1_13_inst                                                             0x00AD
+#define SE_VCOEF1_14_inst                                                             0x00AE
+#define SE_VCOEF1_15_inst                                                             0x00AF
+#define SE_VCOEF1_vcoef_shift                                                        (0)
+#define SE_VCOEF1_vcoef_mask                                                         (0x00003FFF)
+#define SE_VCOEF1_vcoef(data)                                                        (0x00003FFF&((data)<<0))
+#define SE_VCOEF1_vcoef_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define SE_VCOEF1_get_vcoef(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define SE_VCOEF1_16_0                                                               0x1800C5D8
+#define SE_VCOEF1_16_1                                                               0x1800C5DC
+#define SE_VCOEF1_16_2                                                               0x1800C5E0
+#define SE_VCOEF1_16_3                                                               0x1800C5E4
+#define SE_VCOEF1_16_4                                                               0x1800C5E8
+#define SE_VCOEF1_16_5                                                               0x1800C5EC
+#define SE_VCOEF1_16_6                                                               0x1800C5F0
+#define SE_VCOEF1_16_7                                                               0x1800C5F4
+#define SE_VCOEF1_16_8                                                               0x1800C5F8
+#define SE_VCOEF1_16_9                                                               0x1800C5FC
+#define SE_VCOEF1_16_10                                                               0x1800C600
+#define SE_VCOEF1_16_11                                                               0x1800C604
+#define SE_VCOEF1_16_12                                                               0x1800C608
+#define SE_VCOEF1_16_13                                                               0x1800C60C
+#define SE_VCOEF1_16_14                                                               0x1800C610
+#define SE_VCOEF1_16_15                                                               0x1800C614
+#define SE_VCOEF1_16_0_reg_addr                                                      "0xB800C5D8"
+#define SE_VCOEF1_16_1_reg_addr                                                      "0xB800C5DC"
+#define SE_VCOEF1_16_2_reg_addr                                                      "0xB800C5E0"
+#define SE_VCOEF1_16_3_reg_addr                                                      "0xB800C5E4"
+#define SE_VCOEF1_16_4_reg_addr                                                      "0xB800C5E8"
+#define SE_VCOEF1_16_5_reg_addr                                                      "0xB800C5EC"
+#define SE_VCOEF1_16_6_reg_addr                                                      "0xB800C5F0"
+#define SE_VCOEF1_16_7_reg_addr                                                      "0xB800C5F4"
+#define SE_VCOEF1_16_8_reg_addr                                                      "0xB800C5F8"
+#define SE_VCOEF1_16_9_reg_addr                                                      "0xB800C5FC"
+#define SE_VCOEF1_16_10_reg_addr                                                      "0xB800C600"
+#define SE_VCOEF1_16_11_reg_addr                                                      "0xB800C604"
+#define SE_VCOEF1_16_12_reg_addr                                                      "0xB800C608"
+#define SE_VCOEF1_16_13_reg_addr                                                      "0xB800C60C"
+#define SE_VCOEF1_16_14_reg_addr                                                      "0xB800C610"
+#define SE_VCOEF1_16_15_reg_addr                                                      "0xB800C614"
+#define SE_VCOEF1_16_0_reg                                                           0xB800C5D8
+#define SE_VCOEF1_16_1_reg                                                           0xB800C5DC
+#define SE_VCOEF1_16_2_reg                                                           0xB800C5E0
+#define SE_VCOEF1_16_3_reg                                                           0xB800C5E4
+#define SE_VCOEF1_16_4_reg                                                           0xB800C5E8
+#define SE_VCOEF1_16_5_reg                                                           0xB800C5EC
+#define SE_VCOEF1_16_6_reg                                                           0xB800C5F0
+#define SE_VCOEF1_16_7_reg                                                           0xB800C5F4
+#define SE_VCOEF1_16_8_reg                                                           0xB800C5F8
+#define SE_VCOEF1_16_9_reg                                                           0xB800C5FC
+#define SE_VCOEF1_16_10_reg                                                           0xB800C600
+#define SE_VCOEF1_16_11_reg                                                           0xB800C604
+#define SE_VCOEF1_16_12_reg                                                           0xB800C608
+#define SE_VCOEF1_16_13_reg                                                           0xB800C60C
+#define SE_VCOEF1_16_14_reg                                                           0xB800C610
+#define SE_VCOEF1_16_15_reg                                                           0xB800C614
+#define set_SE_VCOEF1_16_0_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_0_reg)=data)
+#define set_SE_VCOEF1_16_1_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_1_reg)=data)
+#define set_SE_VCOEF1_16_2_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_2_reg)=data)
+#define set_SE_VCOEF1_16_3_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_3_reg)=data)
+#define set_SE_VCOEF1_16_4_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_4_reg)=data)
+#define set_SE_VCOEF1_16_5_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_5_reg)=data)
+#define set_SE_VCOEF1_16_6_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_6_reg)=data)
+#define set_SE_VCOEF1_16_7_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_7_reg)=data)
+#define set_SE_VCOEF1_16_8_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_8_reg)=data)
+#define set_SE_VCOEF1_16_9_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_9_reg)=data)
+#define set_SE_VCOEF1_16_10_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_10_reg)=data)
+#define set_SE_VCOEF1_16_11_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_11_reg)=data)
+#define set_SE_VCOEF1_16_12_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_12_reg)=data)
+#define set_SE_VCOEF1_16_13_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_13_reg)=data)
+#define set_SE_VCOEF1_16_14_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_14_reg)=data)
+#define set_SE_VCOEF1_16_15_reg(data)   (*((volatile unsigned int*) SE_VCOEF1_16_15_reg)=data)
+#define get_SE_VCOEF1_16_0_reg   (*((volatile unsigned int*) SE_VCOEF1_16_0_reg))
+#define get_SE_VCOEF1_16_1_reg   (*((volatile unsigned int*) SE_VCOEF1_16_1_reg))
+#define get_SE_VCOEF1_16_2_reg   (*((volatile unsigned int*) SE_VCOEF1_16_2_reg))
+#define get_SE_VCOEF1_16_3_reg   (*((volatile unsigned int*) SE_VCOEF1_16_3_reg))
+#define get_SE_VCOEF1_16_4_reg   (*((volatile unsigned int*) SE_VCOEF1_16_4_reg))
+#define get_SE_VCOEF1_16_5_reg   (*((volatile unsigned int*) SE_VCOEF1_16_5_reg))
+#define get_SE_VCOEF1_16_6_reg   (*((volatile unsigned int*) SE_VCOEF1_16_6_reg))
+#define get_SE_VCOEF1_16_7_reg   (*((volatile unsigned int*) SE_VCOEF1_16_7_reg))
+#define get_SE_VCOEF1_16_8_reg   (*((volatile unsigned int*) SE_VCOEF1_16_8_reg))
+#define get_SE_VCOEF1_16_9_reg   (*((volatile unsigned int*) SE_VCOEF1_16_9_reg))
+#define get_SE_VCOEF1_16_10_reg   (*((volatile unsigned int*) SE_VCOEF1_16_10_reg))
+#define get_SE_VCOEF1_16_11_reg   (*((volatile unsigned int*) SE_VCOEF1_16_11_reg))
+#define get_SE_VCOEF1_16_12_reg   (*((volatile unsigned int*) SE_VCOEF1_16_12_reg))
+#define get_SE_VCOEF1_16_13_reg   (*((volatile unsigned int*) SE_VCOEF1_16_13_reg))
+#define get_SE_VCOEF1_16_14_reg   (*((volatile unsigned int*) SE_VCOEF1_16_14_reg))
+#define get_SE_VCOEF1_16_15_reg   (*((volatile unsigned int*) SE_VCOEF1_16_15_reg))
+#define SE_VCOEF1_16_0_inst_adr                                                      "0x0076"
+#define SE_VCOEF1_16_1_inst_adr                                                      "0x0077"
+#define SE_VCOEF1_16_2_inst_adr                                                      "0x0078"
+#define SE_VCOEF1_16_3_inst_adr                                                      "0x0079"
+#define SE_VCOEF1_16_4_inst_adr                                                      "0x007A"
+#define SE_VCOEF1_16_5_inst_adr                                                      "0x007B"
+#define SE_VCOEF1_16_6_inst_adr                                                      "0x007C"
+#define SE_VCOEF1_16_7_inst_adr                                                      "0x007D"
+#define SE_VCOEF1_16_8_inst_adr                                                      "0x007E"
+#define SE_VCOEF1_16_9_inst_adr                                                      "0x007F"
+#define SE_VCOEF1_16_10_inst_adr                                                      "0x0080"
+#define SE_VCOEF1_16_11_inst_adr                                                      "0x0081"
+#define SE_VCOEF1_16_12_inst_adr                                                      "0x0082"
+#define SE_VCOEF1_16_13_inst_adr                                                      "0x0083"
+#define SE_VCOEF1_16_14_inst_adr                                                      "0x0084"
+#define SE_VCOEF1_16_15_inst_adr                                                      "0x0085"
+#define SE_VCOEF1_16_0_inst                                                          0x0076
+#define SE_VCOEF1_16_1_inst                                                          0x0077
+#define SE_VCOEF1_16_2_inst                                                          0x0078
+#define SE_VCOEF1_16_3_inst                                                          0x0079
+#define SE_VCOEF1_16_4_inst                                                          0x007A
+#define SE_VCOEF1_16_5_inst                                                          0x007B
+#define SE_VCOEF1_16_6_inst                                                          0x007C
+#define SE_VCOEF1_16_7_inst                                                          0x007D
+#define SE_VCOEF1_16_8_inst                                                          0x007E
+#define SE_VCOEF1_16_9_inst                                                          0x007F
+#define SE_VCOEF1_16_10_inst                                                          0x0080
+#define SE_VCOEF1_16_11_inst                                                          0x0081
+#define SE_VCOEF1_16_12_inst                                                          0x0082
+#define SE_VCOEF1_16_13_inst                                                          0x0083
+#define SE_VCOEF1_16_14_inst                                                          0x0084
+#define SE_VCOEF1_16_15_inst                                                          0x0085
+#define SE_VCOEF1_16_vcoef_shift                                                     (0)
+#define SE_VCOEF1_16_vcoef_mask                                                      (0x00003FFF)
+#define SE_VCOEF1_16_vcoef(data)                                                     (0x00003FFF&((data)<<0))
+#define SE_VCOEF1_16_vcoef_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define SE_VCOEF1_16_get_vcoef(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define SE_HCOEF2_0                                                                  0x1800C2C0
+#define SE_HCOEF2_1                                                                  0x1800C2C4
+#define SE_HCOEF2_2                                                                  0x1800C2C8
+#define SE_HCOEF2_3                                                                  0x1800C2CC
+#define SE_HCOEF2_4                                                                  0x1800C2D0
+#define SE_HCOEF2_5                                                                  0x1800C2D4
+#define SE_HCOEF2_6                                                                  0x1800C2D8
+#define SE_HCOEF2_7                                                                  0x1800C2DC
+#define SE_HCOEF2_8                                                                  0x1800C2E0
+#define SE_HCOEF2_9                                                                  0x1800C2E4
+#define SE_HCOEF2_10                                                                  0x1800C2E8
+#define SE_HCOEF2_11                                                                  0x1800C2EC
+#define SE_HCOEF2_12                                                                  0x1800C2F0
+#define SE_HCOEF2_13                                                                  0x1800C2F4
+#define SE_HCOEF2_14                                                                  0x1800C2F8
+#define SE_HCOEF2_15                                                                  0x1800C2FC
+#define SE_HCOEF2_16                                                                  0x1800C300
+#define SE_HCOEF2_17                                                                  0x1800C304
+#define SE_HCOEF2_18                                                                  0x1800C308
+#define SE_HCOEF2_19                                                                  0x1800C30C
+#define SE_HCOEF2_20                                                                  0x1800C310
+#define SE_HCOEF2_21                                                                  0x1800C314
+#define SE_HCOEF2_22                                                                  0x1800C318
+#define SE_HCOEF2_23                                                                  0x1800C31C
+#define SE_HCOEF2_24                                                                  0x1800C320
+#define SE_HCOEF2_25                                                                  0x1800C324
+#define SE_HCOEF2_26                                                                  0x1800C328
+#define SE_HCOEF2_27                                                                  0x1800C32C
+#define SE_HCOEF2_28                                                                  0x1800C330
+#define SE_HCOEF2_29                                                                  0x1800C334
+#define SE_HCOEF2_30                                                                  0x1800C338
+#define SE_HCOEF2_31                                                                  0x1800C33C
+#define SE_HCOEF2_0_reg_addr                                                         "0xB800C2C0"
+#define SE_HCOEF2_1_reg_addr                                                         "0xB800C2C4"
+#define SE_HCOEF2_2_reg_addr                                                         "0xB800C2C8"
+#define SE_HCOEF2_3_reg_addr                                                         "0xB800C2CC"
+#define SE_HCOEF2_4_reg_addr                                                         "0xB800C2D0"
+#define SE_HCOEF2_5_reg_addr                                                         "0xB800C2D4"
+#define SE_HCOEF2_6_reg_addr                                                         "0xB800C2D8"
+#define SE_HCOEF2_7_reg_addr                                                         "0xB800C2DC"
+#define SE_HCOEF2_8_reg_addr                                                         "0xB800C2E0"
+#define SE_HCOEF2_9_reg_addr                                                         "0xB800C2E4"
+#define SE_HCOEF2_10_reg_addr                                                         "0xB800C2E8"
+#define SE_HCOEF2_11_reg_addr                                                         "0xB800C2EC"
+#define SE_HCOEF2_12_reg_addr                                                         "0xB800C2F0"
+#define SE_HCOEF2_13_reg_addr                                                         "0xB800C2F4"
+#define SE_HCOEF2_14_reg_addr                                                         "0xB800C2F8"
+#define SE_HCOEF2_15_reg_addr                                                         "0xB800C2FC"
+#define SE_HCOEF2_16_reg_addr                                                         "0xB800C300"
+#define SE_HCOEF2_17_reg_addr                                                         "0xB800C304"
+#define SE_HCOEF2_18_reg_addr                                                         "0xB800C308"
+#define SE_HCOEF2_19_reg_addr                                                         "0xB800C30C"
+#define SE_HCOEF2_20_reg_addr                                                         "0xB800C310"
+#define SE_HCOEF2_21_reg_addr                                                         "0xB800C314"
+#define SE_HCOEF2_22_reg_addr                                                         "0xB800C318"
+#define SE_HCOEF2_23_reg_addr                                                         "0xB800C31C"
+#define SE_HCOEF2_24_reg_addr                                                         "0xB800C320"
+#define SE_HCOEF2_25_reg_addr                                                         "0xB800C324"
+#define SE_HCOEF2_26_reg_addr                                                         "0xB800C328"
+#define SE_HCOEF2_27_reg_addr                                                         "0xB800C32C"
+#define SE_HCOEF2_28_reg_addr                                                         "0xB800C330"
+#define SE_HCOEF2_29_reg_addr                                                         "0xB800C334"
+#define SE_HCOEF2_30_reg_addr                                                         "0xB800C338"
+#define SE_HCOEF2_31_reg_addr                                                         "0xB800C33C"
+#define SE_HCOEF2_0_reg                                                              0xB800C2C0
+#define SE_HCOEF2_1_reg                                                              0xB800C2C4
+#define SE_HCOEF2_2_reg                                                              0xB800C2C8
+#define SE_HCOEF2_3_reg                                                              0xB800C2CC
+#define SE_HCOEF2_4_reg                                                              0xB800C2D0
+#define SE_HCOEF2_5_reg                                                              0xB800C2D4
+#define SE_HCOEF2_6_reg                                                              0xB800C2D8
+#define SE_HCOEF2_7_reg                                                              0xB800C2DC
+#define SE_HCOEF2_8_reg                                                              0xB800C2E0
+#define SE_HCOEF2_9_reg                                                              0xB800C2E4
+#define SE_HCOEF2_10_reg                                                              0xB800C2E8
+#define SE_HCOEF2_11_reg                                                              0xB800C2EC
+#define SE_HCOEF2_12_reg                                                              0xB800C2F0
+#define SE_HCOEF2_13_reg                                                              0xB800C2F4
+#define SE_HCOEF2_14_reg                                                              0xB800C2F8
+#define SE_HCOEF2_15_reg                                                              0xB800C2FC
+#define SE_HCOEF2_16_reg                                                              0xB800C300
+#define SE_HCOEF2_17_reg                                                              0xB800C304
+#define SE_HCOEF2_18_reg                                                              0xB800C308
+#define SE_HCOEF2_19_reg                                                              0xB800C30C
+#define SE_HCOEF2_20_reg                                                              0xB800C310
+#define SE_HCOEF2_21_reg                                                              0xB800C314
+#define SE_HCOEF2_22_reg                                                              0xB800C318
+#define SE_HCOEF2_23_reg                                                              0xB800C31C
+#define SE_HCOEF2_24_reg                                                              0xB800C320
+#define SE_HCOEF2_25_reg                                                              0xB800C324
+#define SE_HCOEF2_26_reg                                                              0xB800C328
+#define SE_HCOEF2_27_reg                                                              0xB800C32C
+#define SE_HCOEF2_28_reg                                                              0xB800C330
+#define SE_HCOEF2_29_reg                                                              0xB800C334
+#define SE_HCOEF2_30_reg                                                              0xB800C338
+#define SE_HCOEF2_31_reg                                                              0xB800C33C
+#define set_SE_HCOEF2_0_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_0_reg)=data)
+#define set_SE_HCOEF2_1_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_1_reg)=data)
+#define set_SE_HCOEF2_2_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_2_reg)=data)
+#define set_SE_HCOEF2_3_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_3_reg)=data)
+#define set_SE_HCOEF2_4_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_4_reg)=data)
+#define set_SE_HCOEF2_5_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_5_reg)=data)
+#define set_SE_HCOEF2_6_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_6_reg)=data)
+#define set_SE_HCOEF2_7_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_7_reg)=data)
+#define set_SE_HCOEF2_8_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_8_reg)=data)
+#define set_SE_HCOEF2_9_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_9_reg)=data)
+#define set_SE_HCOEF2_10_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_10_reg)=data)
+#define set_SE_HCOEF2_11_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_11_reg)=data)
+#define set_SE_HCOEF2_12_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_12_reg)=data)
+#define set_SE_HCOEF2_13_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_13_reg)=data)
+#define set_SE_HCOEF2_14_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_14_reg)=data)
+#define set_SE_HCOEF2_15_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_15_reg)=data)
+#define set_SE_HCOEF2_16_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_16_reg)=data)
+#define set_SE_HCOEF2_17_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_17_reg)=data)
+#define set_SE_HCOEF2_18_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_18_reg)=data)
+#define set_SE_HCOEF2_19_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_19_reg)=data)
+#define set_SE_HCOEF2_20_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_20_reg)=data)
+#define set_SE_HCOEF2_21_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_21_reg)=data)
+#define set_SE_HCOEF2_22_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_22_reg)=data)
+#define set_SE_HCOEF2_23_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_23_reg)=data)
+#define set_SE_HCOEF2_24_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_24_reg)=data)
+#define set_SE_HCOEF2_25_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_25_reg)=data)
+#define set_SE_HCOEF2_26_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_26_reg)=data)
+#define set_SE_HCOEF2_27_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_27_reg)=data)
+#define set_SE_HCOEF2_28_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_28_reg)=data)
+#define set_SE_HCOEF2_29_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_29_reg)=data)
+#define set_SE_HCOEF2_30_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_30_reg)=data)
+#define set_SE_HCOEF2_31_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_31_reg)=data)
+#define get_SE_HCOEF2_0_reg   (*((volatile unsigned int*) SE_HCOEF2_0_reg))
+#define get_SE_HCOEF2_1_reg   (*((volatile unsigned int*) SE_HCOEF2_1_reg))
+#define get_SE_HCOEF2_2_reg   (*((volatile unsigned int*) SE_HCOEF2_2_reg))
+#define get_SE_HCOEF2_3_reg   (*((volatile unsigned int*) SE_HCOEF2_3_reg))
+#define get_SE_HCOEF2_4_reg   (*((volatile unsigned int*) SE_HCOEF2_4_reg))
+#define get_SE_HCOEF2_5_reg   (*((volatile unsigned int*) SE_HCOEF2_5_reg))
+#define get_SE_HCOEF2_6_reg   (*((volatile unsigned int*) SE_HCOEF2_6_reg))
+#define get_SE_HCOEF2_7_reg   (*((volatile unsigned int*) SE_HCOEF2_7_reg))
+#define get_SE_HCOEF2_8_reg   (*((volatile unsigned int*) SE_HCOEF2_8_reg))
+#define get_SE_HCOEF2_9_reg   (*((volatile unsigned int*) SE_HCOEF2_9_reg))
+#define get_SE_HCOEF2_10_reg   (*((volatile unsigned int*) SE_HCOEF2_10_reg))
+#define get_SE_HCOEF2_11_reg   (*((volatile unsigned int*) SE_HCOEF2_11_reg))
+#define get_SE_HCOEF2_12_reg   (*((volatile unsigned int*) SE_HCOEF2_12_reg))
+#define get_SE_HCOEF2_13_reg   (*((volatile unsigned int*) SE_HCOEF2_13_reg))
+#define get_SE_HCOEF2_14_reg   (*((volatile unsigned int*) SE_HCOEF2_14_reg))
+#define get_SE_HCOEF2_15_reg   (*((volatile unsigned int*) SE_HCOEF2_15_reg))
+#define get_SE_HCOEF2_16_reg   (*((volatile unsigned int*) SE_HCOEF2_16_reg))
+#define get_SE_HCOEF2_17_reg   (*((volatile unsigned int*) SE_HCOEF2_17_reg))
+#define get_SE_HCOEF2_18_reg   (*((volatile unsigned int*) SE_HCOEF2_18_reg))
+#define get_SE_HCOEF2_19_reg   (*((volatile unsigned int*) SE_HCOEF2_19_reg))
+#define get_SE_HCOEF2_20_reg   (*((volatile unsigned int*) SE_HCOEF2_20_reg))
+#define get_SE_HCOEF2_21_reg   (*((volatile unsigned int*) SE_HCOEF2_21_reg))
+#define get_SE_HCOEF2_22_reg   (*((volatile unsigned int*) SE_HCOEF2_22_reg))
+#define get_SE_HCOEF2_23_reg   (*((volatile unsigned int*) SE_HCOEF2_23_reg))
+#define get_SE_HCOEF2_24_reg   (*((volatile unsigned int*) SE_HCOEF2_24_reg))
+#define get_SE_HCOEF2_25_reg   (*((volatile unsigned int*) SE_HCOEF2_25_reg))
+#define get_SE_HCOEF2_26_reg   (*((volatile unsigned int*) SE_HCOEF2_26_reg))
+#define get_SE_HCOEF2_27_reg   (*((volatile unsigned int*) SE_HCOEF2_27_reg))
+#define get_SE_HCOEF2_28_reg   (*((volatile unsigned int*) SE_HCOEF2_28_reg))
+#define get_SE_HCOEF2_29_reg   (*((volatile unsigned int*) SE_HCOEF2_29_reg))
+#define get_SE_HCOEF2_30_reg   (*((volatile unsigned int*) SE_HCOEF2_30_reg))
+#define get_SE_HCOEF2_31_reg   (*((volatile unsigned int*) SE_HCOEF2_31_reg))
+#define SE_HCOEF2_0_inst_adr                                                         "0x00B0"
+#define SE_HCOEF2_1_inst_adr                                                         "0x00B1"
+#define SE_HCOEF2_2_inst_adr                                                         "0x00B2"
+#define SE_HCOEF2_3_inst_adr                                                         "0x00B3"
+#define SE_HCOEF2_4_inst_adr                                                         "0x00B4"
+#define SE_HCOEF2_5_inst_adr                                                         "0x00B5"
+#define SE_HCOEF2_6_inst_adr                                                         "0x00B6"
+#define SE_HCOEF2_7_inst_adr                                                         "0x00B7"
+#define SE_HCOEF2_8_inst_adr                                                         "0x00B8"
+#define SE_HCOEF2_9_inst_adr                                                         "0x00B9"
+#define SE_HCOEF2_10_inst_adr                                                         "0x00BA"
+#define SE_HCOEF2_11_inst_adr                                                         "0x00BB"
+#define SE_HCOEF2_12_inst_adr                                                         "0x00BC"
+#define SE_HCOEF2_13_inst_adr                                                         "0x00BD"
+#define SE_HCOEF2_14_inst_adr                                                         "0x00BE"
+#define SE_HCOEF2_15_inst_adr                                                         "0x00BF"
+#define SE_HCOEF2_16_inst_adr                                                         "0x00C0"
+#define SE_HCOEF2_17_inst_adr                                                         "0x00C1"
+#define SE_HCOEF2_18_inst_adr                                                         "0x00C2"
+#define SE_HCOEF2_19_inst_adr                                                         "0x00C3"
+#define SE_HCOEF2_20_inst_adr                                                         "0x00C4"
+#define SE_HCOEF2_21_inst_adr                                                         "0x00C5"
+#define SE_HCOEF2_22_inst_adr                                                         "0x00C6"
+#define SE_HCOEF2_23_inst_adr                                                         "0x00C7"
+#define SE_HCOEF2_24_inst_adr                                                         "0x00C8"
+#define SE_HCOEF2_25_inst_adr                                                         "0x00C9"
+#define SE_HCOEF2_26_inst_adr                                                         "0x00CA"
+#define SE_HCOEF2_27_inst_adr                                                         "0x00CB"
+#define SE_HCOEF2_28_inst_adr                                                         "0x00CC"
+#define SE_HCOEF2_29_inst_adr                                                         "0x00CD"
+#define SE_HCOEF2_30_inst_adr                                                         "0x00CE"
+#define SE_HCOEF2_31_inst_adr                                                         "0x00CF"
+#define SE_HCOEF2_0_inst                                                             0x00B0
+#define SE_HCOEF2_1_inst                                                             0x00B1
+#define SE_HCOEF2_2_inst                                                             0x00B2
+#define SE_HCOEF2_3_inst                                                             0x00B3
+#define SE_HCOEF2_4_inst                                                             0x00B4
+#define SE_HCOEF2_5_inst                                                             0x00B5
+#define SE_HCOEF2_6_inst                                                             0x00B6
+#define SE_HCOEF2_7_inst                                                             0x00B7
+#define SE_HCOEF2_8_inst                                                             0x00B8
+#define SE_HCOEF2_9_inst                                                             0x00B9
+#define SE_HCOEF2_10_inst                                                             0x00BA
+#define SE_HCOEF2_11_inst                                                             0x00BB
+#define SE_HCOEF2_12_inst                                                             0x00BC
+#define SE_HCOEF2_13_inst                                                             0x00BD
+#define SE_HCOEF2_14_inst                                                             0x00BE
+#define SE_HCOEF2_15_inst                                                             0x00BF
+#define SE_HCOEF2_16_inst                                                             0x00C0
+#define SE_HCOEF2_17_inst                                                             0x00C1
+#define SE_HCOEF2_18_inst                                                             0x00C2
+#define SE_HCOEF2_19_inst                                                             0x00C3
+#define SE_HCOEF2_20_inst                                                             0x00C4
+#define SE_HCOEF2_21_inst                                                             0x00C5
+#define SE_HCOEF2_22_inst                                                             0x00C6
+#define SE_HCOEF2_23_inst                                                             0x00C7
+#define SE_HCOEF2_24_inst                                                             0x00C8
+#define SE_HCOEF2_25_inst                                                             0x00C9
+#define SE_HCOEF2_26_inst                                                             0x00CA
+#define SE_HCOEF2_27_inst                                                             0x00CB
+#define SE_HCOEF2_28_inst                                                             0x00CC
+#define SE_HCOEF2_29_inst                                                             0x00CD
+#define SE_HCOEF2_30_inst                                                             0x00CE
+#define SE_HCOEF2_31_inst                                                             0x00CF
+#define SE_HCOEF2_hcoef_shift                                                        (0)
+#define SE_HCOEF2_hcoef_mask                                                         (0x00003FFF)
+#define SE_HCOEF2_hcoef(data)                                                        (0x00003FFF&((data)<<0))
+#define SE_HCOEF2_hcoef_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define SE_HCOEF2_get_hcoef(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define SE_HCOEF2_32_0                                                               0x1800C618
+#define SE_HCOEF2_32_1                                                               0x1800C61C
+#define SE_HCOEF2_32_2                                                               0x1800C620
+#define SE_HCOEF2_32_3                                                               0x1800C624
+#define SE_HCOEF2_32_4                                                               0x1800C628
+#define SE_HCOEF2_32_5                                                               0x1800C62C
+#define SE_HCOEF2_32_6                                                               0x1800C630
+#define SE_HCOEF2_32_7                                                               0x1800C634
+#define SE_HCOEF2_32_8                                                               0x1800C638
+#define SE_HCOEF2_32_9                                                               0x1800C63C
+#define SE_HCOEF2_32_10                                                               0x1800C640
+#define SE_HCOEF2_32_11                                                               0x1800C644
+#define SE_HCOEF2_32_12                                                               0x1800C648
+#define SE_HCOEF2_32_13                                                               0x1800C64C
+#define SE_HCOEF2_32_14                                                               0x1800C650
+#define SE_HCOEF2_32_15                                                               0x1800C654
+#define SE_HCOEF2_32_16                                                               0x1800C658
+#define SE_HCOEF2_32_17                                                               0x1800C65C
+#define SE_HCOEF2_32_18                                                               0x1800C660
+#define SE_HCOEF2_32_19                                                               0x1800C664
+#define SE_HCOEF2_32_20                                                               0x1800C668
+#define SE_HCOEF2_32_21                                                               0x1800C66C
+#define SE_HCOEF2_32_22                                                               0x1800C670
+#define SE_HCOEF2_32_23                                                               0x1800C674
+#define SE_HCOEF2_32_24                                                               0x1800C678
+#define SE_HCOEF2_32_25                                                               0x1800C67C
+#define SE_HCOEF2_32_26                                                               0x1800C680
+#define SE_HCOEF2_32_27                                                               0x1800C684
+#define SE_HCOEF2_32_28                                                               0x1800C688
+#define SE_HCOEF2_32_29                                                               0x1800C68C
+#define SE_HCOEF2_32_30                                                               0x1800C690
+#define SE_HCOEF2_32_31                                                               0x1800C694
+#define SE_HCOEF2_32_0_reg_addr                                                      "0xB800C618"
+#define SE_HCOEF2_32_1_reg_addr                                                      "0xB800C61C"
+#define SE_HCOEF2_32_2_reg_addr                                                      "0xB800C620"
+#define SE_HCOEF2_32_3_reg_addr                                                      "0xB800C624"
+#define SE_HCOEF2_32_4_reg_addr                                                      "0xB800C628"
+#define SE_HCOEF2_32_5_reg_addr                                                      "0xB800C62C"
+#define SE_HCOEF2_32_6_reg_addr                                                      "0xB800C630"
+#define SE_HCOEF2_32_7_reg_addr                                                      "0xB800C634"
+#define SE_HCOEF2_32_8_reg_addr                                                      "0xB800C638"
+#define SE_HCOEF2_32_9_reg_addr                                                      "0xB800C63C"
+#define SE_HCOEF2_32_10_reg_addr                                                      "0xB800C640"
+#define SE_HCOEF2_32_11_reg_addr                                                      "0xB800C644"
+#define SE_HCOEF2_32_12_reg_addr                                                      "0xB800C648"
+#define SE_HCOEF2_32_13_reg_addr                                                      "0xB800C64C"
+#define SE_HCOEF2_32_14_reg_addr                                                      "0xB800C650"
+#define SE_HCOEF2_32_15_reg_addr                                                      "0xB800C654"
+#define SE_HCOEF2_32_16_reg_addr                                                      "0xB800C658"
+#define SE_HCOEF2_32_17_reg_addr                                                      "0xB800C65C"
+#define SE_HCOEF2_32_18_reg_addr                                                      "0xB800C660"
+#define SE_HCOEF2_32_19_reg_addr                                                      "0xB800C664"
+#define SE_HCOEF2_32_20_reg_addr                                                      "0xB800C668"
+#define SE_HCOEF2_32_21_reg_addr                                                      "0xB800C66C"
+#define SE_HCOEF2_32_22_reg_addr                                                      "0xB800C670"
+#define SE_HCOEF2_32_23_reg_addr                                                      "0xB800C674"
+#define SE_HCOEF2_32_24_reg_addr                                                      "0xB800C678"
+#define SE_HCOEF2_32_25_reg_addr                                                      "0xB800C67C"
+#define SE_HCOEF2_32_26_reg_addr                                                      "0xB800C680"
+#define SE_HCOEF2_32_27_reg_addr                                                      "0xB800C684"
+#define SE_HCOEF2_32_28_reg_addr                                                      "0xB800C688"
+#define SE_HCOEF2_32_29_reg_addr                                                      "0xB800C68C"
+#define SE_HCOEF2_32_30_reg_addr                                                      "0xB800C690"
+#define SE_HCOEF2_32_31_reg_addr                                                      "0xB800C694"
+#define SE_HCOEF2_32_0_reg                                                           0xB800C618
+#define SE_HCOEF2_32_1_reg                                                           0xB800C61C
+#define SE_HCOEF2_32_2_reg                                                           0xB800C620
+#define SE_HCOEF2_32_3_reg                                                           0xB800C624
+#define SE_HCOEF2_32_4_reg                                                           0xB800C628
+#define SE_HCOEF2_32_5_reg                                                           0xB800C62C
+#define SE_HCOEF2_32_6_reg                                                           0xB800C630
+#define SE_HCOEF2_32_7_reg                                                           0xB800C634
+#define SE_HCOEF2_32_8_reg                                                           0xB800C638
+#define SE_HCOEF2_32_9_reg                                                           0xB800C63C
+#define SE_HCOEF2_32_10_reg                                                           0xB800C640
+#define SE_HCOEF2_32_11_reg                                                           0xB800C644
+#define SE_HCOEF2_32_12_reg                                                           0xB800C648
+#define SE_HCOEF2_32_13_reg                                                           0xB800C64C
+#define SE_HCOEF2_32_14_reg                                                           0xB800C650
+#define SE_HCOEF2_32_15_reg                                                           0xB800C654
+#define SE_HCOEF2_32_16_reg                                                           0xB800C658
+#define SE_HCOEF2_32_17_reg                                                           0xB800C65C
+#define SE_HCOEF2_32_18_reg                                                           0xB800C660
+#define SE_HCOEF2_32_19_reg                                                           0xB800C664
+#define SE_HCOEF2_32_20_reg                                                           0xB800C668
+#define SE_HCOEF2_32_21_reg                                                           0xB800C66C
+#define SE_HCOEF2_32_22_reg                                                           0xB800C670
+#define SE_HCOEF2_32_23_reg                                                           0xB800C674
+#define SE_HCOEF2_32_24_reg                                                           0xB800C678
+#define SE_HCOEF2_32_25_reg                                                           0xB800C67C
+#define SE_HCOEF2_32_26_reg                                                           0xB800C680
+#define SE_HCOEF2_32_27_reg                                                           0xB800C684
+#define SE_HCOEF2_32_28_reg                                                           0xB800C688
+#define SE_HCOEF2_32_29_reg                                                           0xB800C68C
+#define SE_HCOEF2_32_30_reg                                                           0xB800C690
+#define SE_HCOEF2_32_31_reg                                                           0xB800C694
+#define set_SE_HCOEF2_32_0_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_0_reg)=data)
+#define set_SE_HCOEF2_32_1_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_1_reg)=data)
+#define set_SE_HCOEF2_32_2_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_2_reg)=data)
+#define set_SE_HCOEF2_32_3_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_3_reg)=data)
+#define set_SE_HCOEF2_32_4_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_4_reg)=data)
+#define set_SE_HCOEF2_32_5_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_5_reg)=data)
+#define set_SE_HCOEF2_32_6_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_6_reg)=data)
+#define set_SE_HCOEF2_32_7_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_7_reg)=data)
+#define set_SE_HCOEF2_32_8_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_8_reg)=data)
+#define set_SE_HCOEF2_32_9_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_9_reg)=data)
+#define set_SE_HCOEF2_32_10_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_10_reg)=data)
+#define set_SE_HCOEF2_32_11_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_11_reg)=data)
+#define set_SE_HCOEF2_32_12_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_12_reg)=data)
+#define set_SE_HCOEF2_32_13_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_13_reg)=data)
+#define set_SE_HCOEF2_32_14_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_14_reg)=data)
+#define set_SE_HCOEF2_32_15_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_15_reg)=data)
+#define set_SE_HCOEF2_32_16_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_16_reg)=data)
+#define set_SE_HCOEF2_32_17_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_17_reg)=data)
+#define set_SE_HCOEF2_32_18_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_18_reg)=data)
+#define set_SE_HCOEF2_32_19_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_19_reg)=data)
+#define set_SE_HCOEF2_32_20_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_20_reg)=data)
+#define set_SE_HCOEF2_32_21_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_21_reg)=data)
+#define set_SE_HCOEF2_32_22_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_22_reg)=data)
+#define set_SE_HCOEF2_32_23_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_23_reg)=data)
+#define set_SE_HCOEF2_32_24_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_24_reg)=data)
+#define set_SE_HCOEF2_32_25_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_25_reg)=data)
+#define set_SE_HCOEF2_32_26_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_26_reg)=data)
+#define set_SE_HCOEF2_32_27_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_27_reg)=data)
+#define set_SE_HCOEF2_32_28_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_28_reg)=data)
+#define set_SE_HCOEF2_32_29_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_29_reg)=data)
+#define set_SE_HCOEF2_32_30_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_30_reg)=data)
+#define set_SE_HCOEF2_32_31_reg(data)   (*((volatile unsigned int*) SE_HCOEF2_32_31_reg)=data)
+#define get_SE_HCOEF2_32_0_reg   (*((volatile unsigned int*) SE_HCOEF2_32_0_reg))
+#define get_SE_HCOEF2_32_1_reg   (*((volatile unsigned int*) SE_HCOEF2_32_1_reg))
+#define get_SE_HCOEF2_32_2_reg   (*((volatile unsigned int*) SE_HCOEF2_32_2_reg))
+#define get_SE_HCOEF2_32_3_reg   (*((volatile unsigned int*) SE_HCOEF2_32_3_reg))
+#define get_SE_HCOEF2_32_4_reg   (*((volatile unsigned int*) SE_HCOEF2_32_4_reg))
+#define get_SE_HCOEF2_32_5_reg   (*((volatile unsigned int*) SE_HCOEF2_32_5_reg))
+#define get_SE_HCOEF2_32_6_reg   (*((volatile unsigned int*) SE_HCOEF2_32_6_reg))
+#define get_SE_HCOEF2_32_7_reg   (*((volatile unsigned int*) SE_HCOEF2_32_7_reg))
+#define get_SE_HCOEF2_32_8_reg   (*((volatile unsigned int*) SE_HCOEF2_32_8_reg))
+#define get_SE_HCOEF2_32_9_reg   (*((volatile unsigned int*) SE_HCOEF2_32_9_reg))
+#define get_SE_HCOEF2_32_10_reg   (*((volatile unsigned int*) SE_HCOEF2_32_10_reg))
+#define get_SE_HCOEF2_32_11_reg   (*((volatile unsigned int*) SE_HCOEF2_32_11_reg))
+#define get_SE_HCOEF2_32_12_reg   (*((volatile unsigned int*) SE_HCOEF2_32_12_reg))
+#define get_SE_HCOEF2_32_13_reg   (*((volatile unsigned int*) SE_HCOEF2_32_13_reg))
+#define get_SE_HCOEF2_32_14_reg   (*((volatile unsigned int*) SE_HCOEF2_32_14_reg))
+#define get_SE_HCOEF2_32_15_reg   (*((volatile unsigned int*) SE_HCOEF2_32_15_reg))
+#define get_SE_HCOEF2_32_16_reg   (*((volatile unsigned int*) SE_HCOEF2_32_16_reg))
+#define get_SE_HCOEF2_32_17_reg   (*((volatile unsigned int*) SE_HCOEF2_32_17_reg))
+#define get_SE_HCOEF2_32_18_reg   (*((volatile unsigned int*) SE_HCOEF2_32_18_reg))
+#define get_SE_HCOEF2_32_19_reg   (*((volatile unsigned int*) SE_HCOEF2_32_19_reg))
+#define get_SE_HCOEF2_32_20_reg   (*((volatile unsigned int*) SE_HCOEF2_32_20_reg))
+#define get_SE_HCOEF2_32_21_reg   (*((volatile unsigned int*) SE_HCOEF2_32_21_reg))
+#define get_SE_HCOEF2_32_22_reg   (*((volatile unsigned int*) SE_HCOEF2_32_22_reg))
+#define get_SE_HCOEF2_32_23_reg   (*((volatile unsigned int*) SE_HCOEF2_32_23_reg))
+#define get_SE_HCOEF2_32_24_reg   (*((volatile unsigned int*) SE_HCOEF2_32_24_reg))
+#define get_SE_HCOEF2_32_25_reg   (*((volatile unsigned int*) SE_HCOEF2_32_25_reg))
+#define get_SE_HCOEF2_32_26_reg   (*((volatile unsigned int*) SE_HCOEF2_32_26_reg))
+#define get_SE_HCOEF2_32_27_reg   (*((volatile unsigned int*) SE_HCOEF2_32_27_reg))
+#define get_SE_HCOEF2_32_28_reg   (*((volatile unsigned int*) SE_HCOEF2_32_28_reg))
+#define get_SE_HCOEF2_32_29_reg   (*((volatile unsigned int*) SE_HCOEF2_32_29_reg))
+#define get_SE_HCOEF2_32_30_reg   (*((volatile unsigned int*) SE_HCOEF2_32_30_reg))
+#define get_SE_HCOEF2_32_31_reg   (*((volatile unsigned int*) SE_HCOEF2_32_31_reg))
+#define SE_HCOEF2_32_0_inst_adr                                                      "0x0086"
+#define SE_HCOEF2_32_1_inst_adr                                                      "0x0087"
+#define SE_HCOEF2_32_2_inst_adr                                                      "0x0088"
+#define SE_HCOEF2_32_3_inst_adr                                                      "0x0089"
+#define SE_HCOEF2_32_4_inst_adr                                                      "0x008A"
+#define SE_HCOEF2_32_5_inst_adr                                                      "0x008B"
+#define SE_HCOEF2_32_6_inst_adr                                                      "0x008C"
+#define SE_HCOEF2_32_7_inst_adr                                                      "0x008D"
+#define SE_HCOEF2_32_8_inst_adr                                                      "0x008E"
+#define SE_HCOEF2_32_9_inst_adr                                                      "0x008F"
+#define SE_HCOEF2_32_10_inst_adr                                                      "0x0090"
+#define SE_HCOEF2_32_11_inst_adr                                                      "0x0091"
+#define SE_HCOEF2_32_12_inst_adr                                                      "0x0092"
+#define SE_HCOEF2_32_13_inst_adr                                                      "0x0093"
+#define SE_HCOEF2_32_14_inst_adr                                                      "0x0094"
+#define SE_HCOEF2_32_15_inst_adr                                                      "0x0095"
+#define SE_HCOEF2_32_16_inst_adr                                                      "0x0096"
+#define SE_HCOEF2_32_17_inst_adr                                                      "0x0097"
+#define SE_HCOEF2_32_18_inst_adr                                                      "0x0098"
+#define SE_HCOEF2_32_19_inst_adr                                                      "0x0099"
+#define SE_HCOEF2_32_20_inst_adr                                                      "0x009A"
+#define SE_HCOEF2_32_21_inst_adr                                                      "0x009B"
+#define SE_HCOEF2_32_22_inst_adr                                                      "0x009C"
+#define SE_HCOEF2_32_23_inst_adr                                                      "0x009D"
+#define SE_HCOEF2_32_24_inst_adr                                                      "0x009E"
+#define SE_HCOEF2_32_25_inst_adr                                                      "0x009F"
+#define SE_HCOEF2_32_26_inst_adr                                                      "0x00A0"
+#define SE_HCOEF2_32_27_inst_adr                                                      "0x00A1"
+#define SE_HCOEF2_32_28_inst_adr                                                      "0x00A2"
+#define SE_HCOEF2_32_29_inst_adr                                                      "0x00A3"
+#define SE_HCOEF2_32_30_inst_adr                                                      "0x00A4"
+#define SE_HCOEF2_32_31_inst_adr                                                      "0x00A5"
+#define SE_HCOEF2_32_0_inst                                                          0x0086
+#define SE_HCOEF2_32_1_inst                                                          0x0087
+#define SE_HCOEF2_32_2_inst                                                          0x0088
+#define SE_HCOEF2_32_3_inst                                                          0x0089
+#define SE_HCOEF2_32_4_inst                                                          0x008A
+#define SE_HCOEF2_32_5_inst                                                          0x008B
+#define SE_HCOEF2_32_6_inst                                                          0x008C
+#define SE_HCOEF2_32_7_inst                                                          0x008D
+#define SE_HCOEF2_32_8_inst                                                          0x008E
+#define SE_HCOEF2_32_9_inst                                                          0x008F
+#define SE_HCOEF2_32_10_inst                                                          0x0090
+#define SE_HCOEF2_32_11_inst                                                          0x0091
+#define SE_HCOEF2_32_12_inst                                                          0x0092
+#define SE_HCOEF2_32_13_inst                                                          0x0093
+#define SE_HCOEF2_32_14_inst                                                          0x0094
+#define SE_HCOEF2_32_15_inst                                                          0x0095
+#define SE_HCOEF2_32_16_inst                                                          0x0096
+#define SE_HCOEF2_32_17_inst                                                          0x0097
+#define SE_HCOEF2_32_18_inst                                                          0x0098
+#define SE_HCOEF2_32_19_inst                                                          0x0099
+#define SE_HCOEF2_32_20_inst                                                          0x009A
+#define SE_HCOEF2_32_21_inst                                                          0x009B
+#define SE_HCOEF2_32_22_inst                                                          0x009C
+#define SE_HCOEF2_32_23_inst                                                          0x009D
+#define SE_HCOEF2_32_24_inst                                                          0x009E
+#define SE_HCOEF2_32_25_inst                                                          0x009F
+#define SE_HCOEF2_32_26_inst                                                          0x00A0
+#define SE_HCOEF2_32_27_inst                                                          0x00A1
+#define SE_HCOEF2_32_28_inst                                                          0x00A2
+#define SE_HCOEF2_32_29_inst                                                          0x00A3
+#define SE_HCOEF2_32_30_inst                                                          0x00A4
+#define SE_HCOEF2_32_31_inst                                                          0x00A5
+#define SE_HCOEF2_32_hcoef_shift                                                     (0)
+#define SE_HCOEF2_32_hcoef_mask                                                      (0x00003FFF)
+#define SE_HCOEF2_32_hcoef(data)                                                     (0x00003FFF&((data)<<0))
+#define SE_HCOEF2_32_hcoef_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define SE_HCOEF2_32_get_hcoef(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define SE_VCOEF2_0                                                                  0x1800C340
+#define SE_VCOEF2_1                                                                  0x1800C344
+#define SE_VCOEF2_2                                                                  0x1800C348
+#define SE_VCOEF2_3                                                                  0x1800C34C
+#define SE_VCOEF2_4                                                                  0x1800C350
+#define SE_VCOEF2_5                                                                  0x1800C354
+#define SE_VCOEF2_6                                                                  0x1800C358
+#define SE_VCOEF2_7                                                                  0x1800C35C
+#define SE_VCOEF2_8                                                                  0x1800C360
+#define SE_VCOEF2_9                                                                  0x1800C364
+#define SE_VCOEF2_10                                                                  0x1800C368
+#define SE_VCOEF2_11                                                                  0x1800C36C
+#define SE_VCOEF2_12                                                                  0x1800C370
+#define SE_VCOEF2_13                                                                  0x1800C374
+#define SE_VCOEF2_14                                                                  0x1800C378
+#define SE_VCOEF2_15                                                                  0x1800C37C
+#define SE_VCOEF2_0_reg_addr                                                         "0xB800C340"
+#define SE_VCOEF2_1_reg_addr                                                         "0xB800C344"
+#define SE_VCOEF2_2_reg_addr                                                         "0xB800C348"
+#define SE_VCOEF2_3_reg_addr                                                         "0xB800C34C"
+#define SE_VCOEF2_4_reg_addr                                                         "0xB800C350"
+#define SE_VCOEF2_5_reg_addr                                                         "0xB800C354"
+#define SE_VCOEF2_6_reg_addr                                                         "0xB800C358"
+#define SE_VCOEF2_7_reg_addr                                                         "0xB800C35C"
+#define SE_VCOEF2_8_reg_addr                                                         "0xB800C360"
+#define SE_VCOEF2_9_reg_addr                                                         "0xB800C364"
+#define SE_VCOEF2_10_reg_addr                                                         "0xB800C368"
+#define SE_VCOEF2_11_reg_addr                                                         "0xB800C36C"
+#define SE_VCOEF2_12_reg_addr                                                         "0xB800C370"
+#define SE_VCOEF2_13_reg_addr                                                         "0xB800C374"
+#define SE_VCOEF2_14_reg_addr                                                         "0xB800C378"
+#define SE_VCOEF2_15_reg_addr                                                         "0xB800C37C"
+#define SE_VCOEF2_0_reg                                                              0xB800C340
+#define SE_VCOEF2_1_reg                                                              0xB800C344
+#define SE_VCOEF2_2_reg                                                              0xB800C348
+#define SE_VCOEF2_3_reg                                                              0xB800C34C
+#define SE_VCOEF2_4_reg                                                              0xB800C350
+#define SE_VCOEF2_5_reg                                                              0xB800C354
+#define SE_VCOEF2_6_reg                                                              0xB800C358
+#define SE_VCOEF2_7_reg                                                              0xB800C35C
+#define SE_VCOEF2_8_reg                                                              0xB800C360
+#define SE_VCOEF2_9_reg                                                              0xB800C364
+#define SE_VCOEF2_10_reg                                                              0xB800C368
+#define SE_VCOEF2_11_reg                                                              0xB800C36C
+#define SE_VCOEF2_12_reg                                                              0xB800C370
+#define SE_VCOEF2_13_reg                                                              0xB800C374
+#define SE_VCOEF2_14_reg                                                              0xB800C378
+#define SE_VCOEF2_15_reg                                                              0xB800C37C
+#define set_SE_VCOEF2_0_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_0_reg)=data)
+#define set_SE_VCOEF2_1_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_1_reg)=data)
+#define set_SE_VCOEF2_2_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_2_reg)=data)
+#define set_SE_VCOEF2_3_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_3_reg)=data)
+#define set_SE_VCOEF2_4_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_4_reg)=data)
+#define set_SE_VCOEF2_5_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_5_reg)=data)
+#define set_SE_VCOEF2_6_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_6_reg)=data)
+#define set_SE_VCOEF2_7_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_7_reg)=data)
+#define set_SE_VCOEF2_8_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_8_reg)=data)
+#define set_SE_VCOEF2_9_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_9_reg)=data)
+#define set_SE_VCOEF2_10_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_10_reg)=data)
+#define set_SE_VCOEF2_11_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_11_reg)=data)
+#define set_SE_VCOEF2_12_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_12_reg)=data)
+#define set_SE_VCOEF2_13_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_13_reg)=data)
+#define set_SE_VCOEF2_14_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_14_reg)=data)
+#define set_SE_VCOEF2_15_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_15_reg)=data)
+#define get_SE_VCOEF2_0_reg   (*((volatile unsigned int*) SE_VCOEF2_0_reg))
+#define get_SE_VCOEF2_1_reg   (*((volatile unsigned int*) SE_VCOEF2_1_reg))
+#define get_SE_VCOEF2_2_reg   (*((volatile unsigned int*) SE_VCOEF2_2_reg))
+#define get_SE_VCOEF2_3_reg   (*((volatile unsigned int*) SE_VCOEF2_3_reg))
+#define get_SE_VCOEF2_4_reg   (*((volatile unsigned int*) SE_VCOEF2_4_reg))
+#define get_SE_VCOEF2_5_reg   (*((volatile unsigned int*) SE_VCOEF2_5_reg))
+#define get_SE_VCOEF2_6_reg   (*((volatile unsigned int*) SE_VCOEF2_6_reg))
+#define get_SE_VCOEF2_7_reg   (*((volatile unsigned int*) SE_VCOEF2_7_reg))
+#define get_SE_VCOEF2_8_reg   (*((volatile unsigned int*) SE_VCOEF2_8_reg))
+#define get_SE_VCOEF2_9_reg   (*((volatile unsigned int*) SE_VCOEF2_9_reg))
+#define get_SE_VCOEF2_10_reg   (*((volatile unsigned int*) SE_VCOEF2_10_reg))
+#define get_SE_VCOEF2_11_reg   (*((volatile unsigned int*) SE_VCOEF2_11_reg))
+#define get_SE_VCOEF2_12_reg   (*((volatile unsigned int*) SE_VCOEF2_12_reg))
+#define get_SE_VCOEF2_13_reg   (*((volatile unsigned int*) SE_VCOEF2_13_reg))
+#define get_SE_VCOEF2_14_reg   (*((volatile unsigned int*) SE_VCOEF2_14_reg))
+#define get_SE_VCOEF2_15_reg   (*((volatile unsigned int*) SE_VCOEF2_15_reg))
+#define SE_VCOEF2_0_inst_adr                                                         "0x00D0"
+#define SE_VCOEF2_1_inst_adr                                                         "0x00D1"
+#define SE_VCOEF2_2_inst_adr                                                         "0x00D2"
+#define SE_VCOEF2_3_inst_adr                                                         "0x00D3"
+#define SE_VCOEF2_4_inst_adr                                                         "0x00D4"
+#define SE_VCOEF2_5_inst_adr                                                         "0x00D5"
+#define SE_VCOEF2_6_inst_adr                                                         "0x00D6"
+#define SE_VCOEF2_7_inst_adr                                                         "0x00D7"
+#define SE_VCOEF2_8_inst_adr                                                         "0x00D8"
+#define SE_VCOEF2_9_inst_adr                                                         "0x00D9"
+#define SE_VCOEF2_10_inst_adr                                                         "0x00DA"
+#define SE_VCOEF2_11_inst_adr                                                         "0x00DB"
+#define SE_VCOEF2_12_inst_adr                                                         "0x00DC"
+#define SE_VCOEF2_13_inst_adr                                                         "0x00DD"
+#define SE_VCOEF2_14_inst_adr                                                         "0x00DE"
+#define SE_VCOEF2_15_inst_adr                                                         "0x00DF"
+#define SE_VCOEF2_0_inst                                                             0x00D0
+#define SE_VCOEF2_1_inst                                                             0x00D1
+#define SE_VCOEF2_2_inst                                                             0x00D2
+#define SE_VCOEF2_3_inst                                                             0x00D3
+#define SE_VCOEF2_4_inst                                                             0x00D4
+#define SE_VCOEF2_5_inst                                                             0x00D5
+#define SE_VCOEF2_6_inst                                                             0x00D6
+#define SE_VCOEF2_7_inst                                                             0x00D7
+#define SE_VCOEF2_8_inst                                                             0x00D8
+#define SE_VCOEF2_9_inst                                                             0x00D9
+#define SE_VCOEF2_10_inst                                                             0x00DA
+#define SE_VCOEF2_11_inst                                                             0x00DB
+#define SE_VCOEF2_12_inst                                                             0x00DC
+#define SE_VCOEF2_13_inst                                                             0x00DD
+#define SE_VCOEF2_14_inst                                                             0x00DE
+#define SE_VCOEF2_15_inst                                                             0x00DF
+#define SE_VCOEF2_vcoef_shift                                                        (0)
+#define SE_VCOEF2_vcoef_mask                                                         (0x00003FFF)
+#define SE_VCOEF2_vcoef(data)                                                        (0x00003FFF&((data)<<0))
+#define SE_VCOEF2_vcoef_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define SE_VCOEF2_get_vcoef(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define SE_VCOEF2_16_0                                                               0x1800C698
+#define SE_VCOEF2_16_1                                                               0x1800C69C
+#define SE_VCOEF2_16_2                                                               0x1800C6A0
+#define SE_VCOEF2_16_3                                                               0x1800C6A4
+#define SE_VCOEF2_16_4                                                               0x1800C6A8
+#define SE_VCOEF2_16_5                                                               0x1800C6AC
+#define SE_VCOEF2_16_6                                                               0x1800C6B0
+#define SE_VCOEF2_16_7                                                               0x1800C6B4
+#define SE_VCOEF2_16_8                                                               0x1800C6B8
+#define SE_VCOEF2_16_9                                                               0x1800C6BC
+#define SE_VCOEF2_16_10                                                               0x1800C6C0
+#define SE_VCOEF2_16_11                                                               0x1800C6C4
+#define SE_VCOEF2_16_12                                                               0x1800C6C8
+#define SE_VCOEF2_16_13                                                               0x1800C6CC
+#define SE_VCOEF2_16_14                                                               0x1800C6D0
+#define SE_VCOEF2_16_15                                                               0x1800C6D4
+#define SE_VCOEF2_16_0_reg_addr                                                      "0xB800C698"
+#define SE_VCOEF2_16_1_reg_addr                                                      "0xB800C69C"
+#define SE_VCOEF2_16_2_reg_addr                                                      "0xB800C6A0"
+#define SE_VCOEF2_16_3_reg_addr                                                      "0xB800C6A4"
+#define SE_VCOEF2_16_4_reg_addr                                                      "0xB800C6A8"
+#define SE_VCOEF2_16_5_reg_addr                                                      "0xB800C6AC"
+#define SE_VCOEF2_16_6_reg_addr                                                      "0xB800C6B0"
+#define SE_VCOEF2_16_7_reg_addr                                                      "0xB800C6B4"
+#define SE_VCOEF2_16_8_reg_addr                                                      "0xB800C6B8"
+#define SE_VCOEF2_16_9_reg_addr                                                      "0xB800C6BC"
+#define SE_VCOEF2_16_10_reg_addr                                                      "0xB800C6C0"
+#define SE_VCOEF2_16_11_reg_addr                                                      "0xB800C6C4"
+#define SE_VCOEF2_16_12_reg_addr                                                      "0xB800C6C8"
+#define SE_VCOEF2_16_13_reg_addr                                                      "0xB800C6CC"
+#define SE_VCOEF2_16_14_reg_addr                                                      "0xB800C6D0"
+#define SE_VCOEF2_16_15_reg_addr                                                      "0xB800C6D4"
+#define SE_VCOEF2_16_0_reg                                                           0xB800C698
+#define SE_VCOEF2_16_1_reg                                                           0xB800C69C
+#define SE_VCOEF2_16_2_reg                                                           0xB800C6A0
+#define SE_VCOEF2_16_3_reg                                                           0xB800C6A4
+#define SE_VCOEF2_16_4_reg                                                           0xB800C6A8
+#define SE_VCOEF2_16_5_reg                                                           0xB800C6AC
+#define SE_VCOEF2_16_6_reg                                                           0xB800C6B0
+#define SE_VCOEF2_16_7_reg                                                           0xB800C6B4
+#define SE_VCOEF2_16_8_reg                                                           0xB800C6B8
+#define SE_VCOEF2_16_9_reg                                                           0xB800C6BC
+#define SE_VCOEF2_16_10_reg                                                           0xB800C6C0
+#define SE_VCOEF2_16_11_reg                                                           0xB800C6C4
+#define SE_VCOEF2_16_12_reg                                                           0xB800C6C8
+#define SE_VCOEF2_16_13_reg                                                           0xB800C6CC
+#define SE_VCOEF2_16_14_reg                                                           0xB800C6D0
+#define SE_VCOEF2_16_15_reg                                                           0xB800C6D4
+#define set_SE_VCOEF2_16_0_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_0_reg)=data)
+#define set_SE_VCOEF2_16_1_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_1_reg)=data)
+#define set_SE_VCOEF2_16_2_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_2_reg)=data)
+#define set_SE_VCOEF2_16_3_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_3_reg)=data)
+#define set_SE_VCOEF2_16_4_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_4_reg)=data)
+#define set_SE_VCOEF2_16_5_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_5_reg)=data)
+#define set_SE_VCOEF2_16_6_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_6_reg)=data)
+#define set_SE_VCOEF2_16_7_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_7_reg)=data)
+#define set_SE_VCOEF2_16_8_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_8_reg)=data)
+#define set_SE_VCOEF2_16_9_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_9_reg)=data)
+#define set_SE_VCOEF2_16_10_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_10_reg)=data)
+#define set_SE_VCOEF2_16_11_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_11_reg)=data)
+#define set_SE_VCOEF2_16_12_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_12_reg)=data)
+#define set_SE_VCOEF2_16_13_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_13_reg)=data)
+#define set_SE_VCOEF2_16_14_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_14_reg)=data)
+#define set_SE_VCOEF2_16_15_reg(data)   (*((volatile unsigned int*) SE_VCOEF2_16_15_reg)=data)
+#define get_SE_VCOEF2_16_0_reg   (*((volatile unsigned int*) SE_VCOEF2_16_0_reg))
+#define get_SE_VCOEF2_16_1_reg   (*((volatile unsigned int*) SE_VCOEF2_16_1_reg))
+#define get_SE_VCOEF2_16_2_reg   (*((volatile unsigned int*) SE_VCOEF2_16_2_reg))
+#define get_SE_VCOEF2_16_3_reg   (*((volatile unsigned int*) SE_VCOEF2_16_3_reg))
+#define get_SE_VCOEF2_16_4_reg   (*((volatile unsigned int*) SE_VCOEF2_16_4_reg))
+#define get_SE_VCOEF2_16_5_reg   (*((volatile unsigned int*) SE_VCOEF2_16_5_reg))
+#define get_SE_VCOEF2_16_6_reg   (*((volatile unsigned int*) SE_VCOEF2_16_6_reg))
+#define get_SE_VCOEF2_16_7_reg   (*((volatile unsigned int*) SE_VCOEF2_16_7_reg))
+#define get_SE_VCOEF2_16_8_reg   (*((volatile unsigned int*) SE_VCOEF2_16_8_reg))
+#define get_SE_VCOEF2_16_9_reg   (*((volatile unsigned int*) SE_VCOEF2_16_9_reg))
+#define get_SE_VCOEF2_16_10_reg   (*((volatile unsigned int*) SE_VCOEF2_16_10_reg))
+#define get_SE_VCOEF2_16_11_reg   (*((volatile unsigned int*) SE_VCOEF2_16_11_reg))
+#define get_SE_VCOEF2_16_12_reg   (*((volatile unsigned int*) SE_VCOEF2_16_12_reg))
+#define get_SE_VCOEF2_16_13_reg   (*((volatile unsigned int*) SE_VCOEF2_16_13_reg))
+#define get_SE_VCOEF2_16_14_reg   (*((volatile unsigned int*) SE_VCOEF2_16_14_reg))
+#define get_SE_VCOEF2_16_15_reg   (*((volatile unsigned int*) SE_VCOEF2_16_15_reg))
+#define SE_VCOEF2_16_0_inst_adr                                                      "0x00A6"
+#define SE_VCOEF2_16_1_inst_adr                                                      "0x00A7"
+#define SE_VCOEF2_16_2_inst_adr                                                      "0x00A8"
+#define SE_VCOEF2_16_3_inst_adr                                                      "0x00A9"
+#define SE_VCOEF2_16_4_inst_adr                                                      "0x00AA"
+#define SE_VCOEF2_16_5_inst_adr                                                      "0x00AB"
+#define SE_VCOEF2_16_6_inst_adr                                                      "0x00AC"
+#define SE_VCOEF2_16_7_inst_adr                                                      "0x00AD"
+#define SE_VCOEF2_16_8_inst_adr                                                      "0x00AE"
+#define SE_VCOEF2_16_9_inst_adr                                                      "0x00AF"
+#define SE_VCOEF2_16_10_inst_adr                                                      "0x00B0"
+#define SE_VCOEF2_16_11_inst_adr                                                      "0x00B1"
+#define SE_VCOEF2_16_12_inst_adr                                                      "0x00B2"
+#define SE_VCOEF2_16_13_inst_adr                                                      "0x00B3"
+#define SE_VCOEF2_16_14_inst_adr                                                      "0x00B4"
+#define SE_VCOEF2_16_15_inst_adr                                                      "0x00B5"
+#define SE_VCOEF2_16_0_inst                                                          0x00A6
+#define SE_VCOEF2_16_1_inst                                                          0x00A7
+#define SE_VCOEF2_16_2_inst                                                          0x00A8
+#define SE_VCOEF2_16_3_inst                                                          0x00A9
+#define SE_VCOEF2_16_4_inst                                                          0x00AA
+#define SE_VCOEF2_16_5_inst                                                          0x00AB
+#define SE_VCOEF2_16_6_inst                                                          0x00AC
+#define SE_VCOEF2_16_7_inst                                                          0x00AD
+#define SE_VCOEF2_16_8_inst                                                          0x00AE
+#define SE_VCOEF2_16_9_inst                                                          0x00AF
+#define SE_VCOEF2_16_10_inst                                                          0x00B0
+#define SE_VCOEF2_16_11_inst                                                          0x00B1
+#define SE_VCOEF2_16_12_inst                                                          0x00B2
+#define SE_VCOEF2_16_13_inst                                                          0x00B3
+#define SE_VCOEF2_16_14_inst                                                          0x00B4
+#define SE_VCOEF2_16_15_inst                                                          0x00B5
+#define SE_VCOEF2_16_vcoef_shift                                                     (0)
+#define SE_VCOEF2_16_vcoef_mask                                                      (0x00003FFF)
+#define SE_VCOEF2_16_vcoef(data)                                                     (0x00003FFF&((data)<<0))
+#define SE_VCOEF2_16_vcoef_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define SE_VCOEF2_16_get_vcoef(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define SE_HCOEF3_0                                                                  0x1800C380
+#define SE_HCOEF3_1                                                                  0x1800C384
+#define SE_HCOEF3_2                                                                  0x1800C388
+#define SE_HCOEF3_3                                                                  0x1800C38C
+#define SE_HCOEF3_4                                                                  0x1800C390
+#define SE_HCOEF3_5                                                                  0x1800C394
+#define SE_HCOEF3_6                                                                  0x1800C398
+#define SE_HCOEF3_7                                                                  0x1800C39C
+#define SE_HCOEF3_8                                                                  0x1800C3A0
+#define SE_HCOEF3_9                                                                  0x1800C3A4
+#define SE_HCOEF3_10                                                                  0x1800C3A8
+#define SE_HCOEF3_11                                                                  0x1800C3AC
+#define SE_HCOEF3_12                                                                  0x1800C3B0
+#define SE_HCOEF3_13                                                                  0x1800C3B4
+#define SE_HCOEF3_14                                                                  0x1800C3B8
+#define SE_HCOEF3_15                                                                  0x1800C3BC
+#define SE_HCOEF3_16                                                                  0x1800C3C0
+#define SE_HCOEF3_17                                                                  0x1800C3C4
+#define SE_HCOEF3_18                                                                  0x1800C3C8
+#define SE_HCOEF3_19                                                                  0x1800C3CC
+#define SE_HCOEF3_20                                                                  0x1800C3D0
+#define SE_HCOEF3_21                                                                  0x1800C3D4
+#define SE_HCOEF3_22                                                                  0x1800C3D8
+#define SE_HCOEF3_23                                                                  0x1800C3DC
+#define SE_HCOEF3_24                                                                  0x1800C3E0
+#define SE_HCOEF3_25                                                                  0x1800C3E4
+#define SE_HCOEF3_26                                                                  0x1800C3E8
+#define SE_HCOEF3_27                                                                  0x1800C3EC
+#define SE_HCOEF3_28                                                                  0x1800C3F0
+#define SE_HCOEF3_29                                                                  0x1800C3F4
+#define SE_HCOEF3_30                                                                  0x1800C3F8
+#define SE_HCOEF3_31                                                                  0x1800C3FC
+#define SE_HCOEF3_0_reg_addr                                                         "0xB800C380"
+#define SE_HCOEF3_1_reg_addr                                                         "0xB800C384"
+#define SE_HCOEF3_2_reg_addr                                                         "0xB800C388"
+#define SE_HCOEF3_3_reg_addr                                                         "0xB800C38C"
+#define SE_HCOEF3_4_reg_addr                                                         "0xB800C390"
+#define SE_HCOEF3_5_reg_addr                                                         "0xB800C394"
+#define SE_HCOEF3_6_reg_addr                                                         "0xB800C398"
+#define SE_HCOEF3_7_reg_addr                                                         "0xB800C39C"
+#define SE_HCOEF3_8_reg_addr                                                         "0xB800C3A0"
+#define SE_HCOEF3_9_reg_addr                                                         "0xB800C3A4"
+#define SE_HCOEF3_10_reg_addr                                                         "0xB800C3A8"
+#define SE_HCOEF3_11_reg_addr                                                         "0xB800C3AC"
+#define SE_HCOEF3_12_reg_addr                                                         "0xB800C3B0"
+#define SE_HCOEF3_13_reg_addr                                                         "0xB800C3B4"
+#define SE_HCOEF3_14_reg_addr                                                         "0xB800C3B8"
+#define SE_HCOEF3_15_reg_addr                                                         "0xB800C3BC"
+#define SE_HCOEF3_16_reg_addr                                                         "0xB800C3C0"
+#define SE_HCOEF3_17_reg_addr                                                         "0xB800C3C4"
+#define SE_HCOEF3_18_reg_addr                                                         "0xB800C3C8"
+#define SE_HCOEF3_19_reg_addr                                                         "0xB800C3CC"
+#define SE_HCOEF3_20_reg_addr                                                         "0xB800C3D0"
+#define SE_HCOEF3_21_reg_addr                                                         "0xB800C3D4"
+#define SE_HCOEF3_22_reg_addr                                                         "0xB800C3D8"
+#define SE_HCOEF3_23_reg_addr                                                         "0xB800C3DC"
+#define SE_HCOEF3_24_reg_addr                                                         "0xB800C3E0"
+#define SE_HCOEF3_25_reg_addr                                                         "0xB800C3E4"
+#define SE_HCOEF3_26_reg_addr                                                         "0xB800C3E8"
+#define SE_HCOEF3_27_reg_addr                                                         "0xB800C3EC"
+#define SE_HCOEF3_28_reg_addr                                                         "0xB800C3F0"
+#define SE_HCOEF3_29_reg_addr                                                         "0xB800C3F4"
+#define SE_HCOEF3_30_reg_addr                                                         "0xB800C3F8"
+#define SE_HCOEF3_31_reg_addr                                                         "0xB800C3FC"
+#define SE_HCOEF3_0_reg                                                              0xB800C380
+#define SE_HCOEF3_1_reg                                                              0xB800C384
+#define SE_HCOEF3_2_reg                                                              0xB800C388
+#define SE_HCOEF3_3_reg                                                              0xB800C38C
+#define SE_HCOEF3_4_reg                                                              0xB800C390
+#define SE_HCOEF3_5_reg                                                              0xB800C394
+#define SE_HCOEF3_6_reg                                                              0xB800C398
+#define SE_HCOEF3_7_reg                                                              0xB800C39C
+#define SE_HCOEF3_8_reg                                                              0xB800C3A0
+#define SE_HCOEF3_9_reg                                                              0xB800C3A4
+#define SE_HCOEF3_10_reg                                                              0xB800C3A8
+#define SE_HCOEF3_11_reg                                                              0xB800C3AC
+#define SE_HCOEF3_12_reg                                                              0xB800C3B0
+#define SE_HCOEF3_13_reg                                                              0xB800C3B4
+#define SE_HCOEF3_14_reg                                                              0xB800C3B8
+#define SE_HCOEF3_15_reg                                                              0xB800C3BC
+#define SE_HCOEF3_16_reg                                                              0xB800C3C0
+#define SE_HCOEF3_17_reg                                                              0xB800C3C4
+#define SE_HCOEF3_18_reg                                                              0xB800C3C8
+#define SE_HCOEF3_19_reg                                                              0xB800C3CC
+#define SE_HCOEF3_20_reg                                                              0xB800C3D0
+#define SE_HCOEF3_21_reg                                                              0xB800C3D4
+#define SE_HCOEF3_22_reg                                                              0xB800C3D8
+#define SE_HCOEF3_23_reg                                                              0xB800C3DC
+#define SE_HCOEF3_24_reg                                                              0xB800C3E0
+#define SE_HCOEF3_25_reg                                                              0xB800C3E4
+#define SE_HCOEF3_26_reg                                                              0xB800C3E8
+#define SE_HCOEF3_27_reg                                                              0xB800C3EC
+#define SE_HCOEF3_28_reg                                                              0xB800C3F0
+#define SE_HCOEF3_29_reg                                                              0xB800C3F4
+#define SE_HCOEF3_30_reg                                                              0xB800C3F8
+#define SE_HCOEF3_31_reg                                                              0xB800C3FC
+#define set_SE_HCOEF3_0_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_0_reg)=data)
+#define set_SE_HCOEF3_1_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_1_reg)=data)
+#define set_SE_HCOEF3_2_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_2_reg)=data)
+#define set_SE_HCOEF3_3_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_3_reg)=data)
+#define set_SE_HCOEF3_4_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_4_reg)=data)
+#define set_SE_HCOEF3_5_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_5_reg)=data)
+#define set_SE_HCOEF3_6_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_6_reg)=data)
+#define set_SE_HCOEF3_7_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_7_reg)=data)
+#define set_SE_HCOEF3_8_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_8_reg)=data)
+#define set_SE_HCOEF3_9_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_9_reg)=data)
+#define set_SE_HCOEF3_10_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_10_reg)=data)
+#define set_SE_HCOEF3_11_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_11_reg)=data)
+#define set_SE_HCOEF3_12_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_12_reg)=data)
+#define set_SE_HCOEF3_13_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_13_reg)=data)
+#define set_SE_HCOEF3_14_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_14_reg)=data)
+#define set_SE_HCOEF3_15_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_15_reg)=data)
+#define set_SE_HCOEF3_16_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_16_reg)=data)
+#define set_SE_HCOEF3_17_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_17_reg)=data)
+#define set_SE_HCOEF3_18_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_18_reg)=data)
+#define set_SE_HCOEF3_19_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_19_reg)=data)
+#define set_SE_HCOEF3_20_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_20_reg)=data)
+#define set_SE_HCOEF3_21_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_21_reg)=data)
+#define set_SE_HCOEF3_22_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_22_reg)=data)
+#define set_SE_HCOEF3_23_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_23_reg)=data)
+#define set_SE_HCOEF3_24_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_24_reg)=data)
+#define set_SE_HCOEF3_25_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_25_reg)=data)
+#define set_SE_HCOEF3_26_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_26_reg)=data)
+#define set_SE_HCOEF3_27_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_27_reg)=data)
+#define set_SE_HCOEF3_28_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_28_reg)=data)
+#define set_SE_HCOEF3_29_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_29_reg)=data)
+#define set_SE_HCOEF3_30_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_30_reg)=data)
+#define set_SE_HCOEF3_31_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_31_reg)=data)
+#define get_SE_HCOEF3_0_reg   (*((volatile unsigned int*) SE_HCOEF3_0_reg))
+#define get_SE_HCOEF3_1_reg   (*((volatile unsigned int*) SE_HCOEF3_1_reg))
+#define get_SE_HCOEF3_2_reg   (*((volatile unsigned int*) SE_HCOEF3_2_reg))
+#define get_SE_HCOEF3_3_reg   (*((volatile unsigned int*) SE_HCOEF3_3_reg))
+#define get_SE_HCOEF3_4_reg   (*((volatile unsigned int*) SE_HCOEF3_4_reg))
+#define get_SE_HCOEF3_5_reg   (*((volatile unsigned int*) SE_HCOEF3_5_reg))
+#define get_SE_HCOEF3_6_reg   (*((volatile unsigned int*) SE_HCOEF3_6_reg))
+#define get_SE_HCOEF3_7_reg   (*((volatile unsigned int*) SE_HCOEF3_7_reg))
+#define get_SE_HCOEF3_8_reg   (*((volatile unsigned int*) SE_HCOEF3_8_reg))
+#define get_SE_HCOEF3_9_reg   (*((volatile unsigned int*) SE_HCOEF3_9_reg))
+#define get_SE_HCOEF3_10_reg   (*((volatile unsigned int*) SE_HCOEF3_10_reg))
+#define get_SE_HCOEF3_11_reg   (*((volatile unsigned int*) SE_HCOEF3_11_reg))
+#define get_SE_HCOEF3_12_reg   (*((volatile unsigned int*) SE_HCOEF3_12_reg))
+#define get_SE_HCOEF3_13_reg   (*((volatile unsigned int*) SE_HCOEF3_13_reg))
+#define get_SE_HCOEF3_14_reg   (*((volatile unsigned int*) SE_HCOEF3_14_reg))
+#define get_SE_HCOEF3_15_reg   (*((volatile unsigned int*) SE_HCOEF3_15_reg))
+#define get_SE_HCOEF3_16_reg   (*((volatile unsigned int*) SE_HCOEF3_16_reg))
+#define get_SE_HCOEF3_17_reg   (*((volatile unsigned int*) SE_HCOEF3_17_reg))
+#define get_SE_HCOEF3_18_reg   (*((volatile unsigned int*) SE_HCOEF3_18_reg))
+#define get_SE_HCOEF3_19_reg   (*((volatile unsigned int*) SE_HCOEF3_19_reg))
+#define get_SE_HCOEF3_20_reg   (*((volatile unsigned int*) SE_HCOEF3_20_reg))
+#define get_SE_HCOEF3_21_reg   (*((volatile unsigned int*) SE_HCOEF3_21_reg))
+#define get_SE_HCOEF3_22_reg   (*((volatile unsigned int*) SE_HCOEF3_22_reg))
+#define get_SE_HCOEF3_23_reg   (*((volatile unsigned int*) SE_HCOEF3_23_reg))
+#define get_SE_HCOEF3_24_reg   (*((volatile unsigned int*) SE_HCOEF3_24_reg))
+#define get_SE_HCOEF3_25_reg   (*((volatile unsigned int*) SE_HCOEF3_25_reg))
+#define get_SE_HCOEF3_26_reg   (*((volatile unsigned int*) SE_HCOEF3_26_reg))
+#define get_SE_HCOEF3_27_reg   (*((volatile unsigned int*) SE_HCOEF3_27_reg))
+#define get_SE_HCOEF3_28_reg   (*((volatile unsigned int*) SE_HCOEF3_28_reg))
+#define get_SE_HCOEF3_29_reg   (*((volatile unsigned int*) SE_HCOEF3_29_reg))
+#define get_SE_HCOEF3_30_reg   (*((volatile unsigned int*) SE_HCOEF3_30_reg))
+#define get_SE_HCOEF3_31_reg   (*((volatile unsigned int*) SE_HCOEF3_31_reg))
+#define SE_HCOEF3_0_inst_adr                                                         "0x00E0"
+#define SE_HCOEF3_1_inst_adr                                                         "0x00E1"
+#define SE_HCOEF3_2_inst_adr                                                         "0x00E2"
+#define SE_HCOEF3_3_inst_adr                                                         "0x00E3"
+#define SE_HCOEF3_4_inst_adr                                                         "0x00E4"
+#define SE_HCOEF3_5_inst_adr                                                         "0x00E5"
+#define SE_HCOEF3_6_inst_adr                                                         "0x00E6"
+#define SE_HCOEF3_7_inst_adr                                                         "0x00E7"
+#define SE_HCOEF3_8_inst_adr                                                         "0x00E8"
+#define SE_HCOEF3_9_inst_adr                                                         "0x00E9"
+#define SE_HCOEF3_10_inst_adr                                                         "0x00EA"
+#define SE_HCOEF3_11_inst_adr                                                         "0x00EB"
+#define SE_HCOEF3_12_inst_adr                                                         "0x00EC"
+#define SE_HCOEF3_13_inst_adr                                                         "0x00ED"
+#define SE_HCOEF3_14_inst_adr                                                         "0x00EE"
+#define SE_HCOEF3_15_inst_adr                                                         "0x00EF"
+#define SE_HCOEF3_16_inst_adr                                                         "0x00F0"
+#define SE_HCOEF3_17_inst_adr                                                         "0x00F1"
+#define SE_HCOEF3_18_inst_adr                                                         "0x00F2"
+#define SE_HCOEF3_19_inst_adr                                                         "0x00F3"
+#define SE_HCOEF3_20_inst_adr                                                         "0x00F4"
+#define SE_HCOEF3_21_inst_adr                                                         "0x00F5"
+#define SE_HCOEF3_22_inst_adr                                                         "0x00F6"
+#define SE_HCOEF3_23_inst_adr                                                         "0x00F7"
+#define SE_HCOEF3_24_inst_adr                                                         "0x00F8"
+#define SE_HCOEF3_25_inst_adr                                                         "0x00F9"
+#define SE_HCOEF3_26_inst_adr                                                         "0x00FA"
+#define SE_HCOEF3_27_inst_adr                                                         "0x00FB"
+#define SE_HCOEF3_28_inst_adr                                                         "0x00FC"
+#define SE_HCOEF3_29_inst_adr                                                         "0x00FD"
+#define SE_HCOEF3_30_inst_adr                                                         "0x00FE"
+#define SE_HCOEF3_31_inst_adr                                                         "0x00FF"
+#define SE_HCOEF3_0_inst                                                             0x00E0
+#define SE_HCOEF3_1_inst                                                             0x00E1
+#define SE_HCOEF3_2_inst                                                             0x00E2
+#define SE_HCOEF3_3_inst                                                             0x00E3
+#define SE_HCOEF3_4_inst                                                             0x00E4
+#define SE_HCOEF3_5_inst                                                             0x00E5
+#define SE_HCOEF3_6_inst                                                             0x00E6
+#define SE_HCOEF3_7_inst                                                             0x00E7
+#define SE_HCOEF3_8_inst                                                             0x00E8
+#define SE_HCOEF3_9_inst                                                             0x00E9
+#define SE_HCOEF3_10_inst                                                             0x00EA
+#define SE_HCOEF3_11_inst                                                             0x00EB
+#define SE_HCOEF3_12_inst                                                             0x00EC
+#define SE_HCOEF3_13_inst                                                             0x00ED
+#define SE_HCOEF3_14_inst                                                             0x00EE
+#define SE_HCOEF3_15_inst                                                             0x00EF
+#define SE_HCOEF3_16_inst                                                             0x00F0
+#define SE_HCOEF3_17_inst                                                             0x00F1
+#define SE_HCOEF3_18_inst                                                             0x00F2
+#define SE_HCOEF3_19_inst                                                             0x00F3
+#define SE_HCOEF3_20_inst                                                             0x00F4
+#define SE_HCOEF3_21_inst                                                             0x00F5
+#define SE_HCOEF3_22_inst                                                             0x00F6
+#define SE_HCOEF3_23_inst                                                             0x00F7
+#define SE_HCOEF3_24_inst                                                             0x00F8
+#define SE_HCOEF3_25_inst                                                             0x00F9
+#define SE_HCOEF3_26_inst                                                             0x00FA
+#define SE_HCOEF3_27_inst                                                             0x00FB
+#define SE_HCOEF3_28_inst                                                             0x00FC
+#define SE_HCOEF3_29_inst                                                             0x00FD
+#define SE_HCOEF3_30_inst                                                             0x00FE
+#define SE_HCOEF3_31_inst                                                             0x00FF
+#define SE_HCOEF3_hcoef_shift                                                        (0)
+#define SE_HCOEF3_hcoef_mask                                                         (0x00003FFF)
+#define SE_HCOEF3_hcoef(data)                                                        (0x00003FFF&((data)<<0))
+#define SE_HCOEF3_hcoef_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define SE_HCOEF3_get_hcoef(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define SE_HCOEF3_32_0                                                               0x1800C6D8
+#define SE_HCOEF3_32_1                                                               0x1800C6DC
+#define SE_HCOEF3_32_2                                                               0x1800C6E0
+#define SE_HCOEF3_32_3                                                               0x1800C6E4
+#define SE_HCOEF3_32_4                                                               0x1800C6E8
+#define SE_HCOEF3_32_5                                                               0x1800C6EC
+#define SE_HCOEF3_32_6                                                               0x1800C6F0
+#define SE_HCOEF3_32_7                                                               0x1800C6F4
+#define SE_HCOEF3_32_8                                                               0x1800C6F8
+#define SE_HCOEF3_32_9                                                               0x1800C6FC
+#define SE_HCOEF3_32_10                                                               0x1800C700
+#define SE_HCOEF3_32_11                                                               0x1800C704
+#define SE_HCOEF3_32_12                                                               0x1800C708
+#define SE_HCOEF3_32_13                                                               0x1800C70C
+#define SE_HCOEF3_32_14                                                               0x1800C710
+#define SE_HCOEF3_32_15                                                               0x1800C714
+#define SE_HCOEF3_32_16                                                               0x1800C718
+#define SE_HCOEF3_32_17                                                               0x1800C71C
+#define SE_HCOEF3_32_18                                                               0x1800C720
+#define SE_HCOEF3_32_19                                                               0x1800C724
+#define SE_HCOEF3_32_20                                                               0x1800C728
+#define SE_HCOEF3_32_21                                                               0x1800C72C
+#define SE_HCOEF3_32_22                                                               0x1800C730
+#define SE_HCOEF3_32_23                                                               0x1800C734
+#define SE_HCOEF3_32_24                                                               0x1800C738
+#define SE_HCOEF3_32_25                                                               0x1800C73C
+#define SE_HCOEF3_32_26                                                               0x1800C740
+#define SE_HCOEF3_32_27                                                               0x1800C744
+#define SE_HCOEF3_32_28                                                               0x1800C748
+#define SE_HCOEF3_32_29                                                               0x1800C74C
+#define SE_HCOEF3_32_30                                                               0x1800C750
+#define SE_HCOEF3_32_31                                                               0x1800C754
+#define SE_HCOEF3_32_0_reg_addr                                                      "0xB800C6D8"
+#define SE_HCOEF3_32_1_reg_addr                                                      "0xB800C6DC"
+#define SE_HCOEF3_32_2_reg_addr                                                      "0xB800C6E0"
+#define SE_HCOEF3_32_3_reg_addr                                                      "0xB800C6E4"
+#define SE_HCOEF3_32_4_reg_addr                                                      "0xB800C6E8"
+#define SE_HCOEF3_32_5_reg_addr                                                      "0xB800C6EC"
+#define SE_HCOEF3_32_6_reg_addr                                                      "0xB800C6F0"
+#define SE_HCOEF3_32_7_reg_addr                                                      "0xB800C6F4"
+#define SE_HCOEF3_32_8_reg_addr                                                      "0xB800C6F8"
+#define SE_HCOEF3_32_9_reg_addr                                                      "0xB800C6FC"
+#define SE_HCOEF3_32_10_reg_addr                                                      "0xB800C700"
+#define SE_HCOEF3_32_11_reg_addr                                                      "0xB800C704"
+#define SE_HCOEF3_32_12_reg_addr                                                      "0xB800C708"
+#define SE_HCOEF3_32_13_reg_addr                                                      "0xB800C70C"
+#define SE_HCOEF3_32_14_reg_addr                                                      "0xB800C710"
+#define SE_HCOEF3_32_15_reg_addr                                                      "0xB800C714"
+#define SE_HCOEF3_32_16_reg_addr                                                      "0xB800C718"
+#define SE_HCOEF3_32_17_reg_addr                                                      "0xB800C71C"
+#define SE_HCOEF3_32_18_reg_addr                                                      "0xB800C720"
+#define SE_HCOEF3_32_19_reg_addr                                                      "0xB800C724"
+#define SE_HCOEF3_32_20_reg_addr                                                      "0xB800C728"
+#define SE_HCOEF3_32_21_reg_addr                                                      "0xB800C72C"
+#define SE_HCOEF3_32_22_reg_addr                                                      "0xB800C730"
+#define SE_HCOEF3_32_23_reg_addr                                                      "0xB800C734"
+#define SE_HCOEF3_32_24_reg_addr                                                      "0xB800C738"
+#define SE_HCOEF3_32_25_reg_addr                                                      "0xB800C73C"
+#define SE_HCOEF3_32_26_reg_addr                                                      "0xB800C740"
+#define SE_HCOEF3_32_27_reg_addr                                                      "0xB800C744"
+#define SE_HCOEF3_32_28_reg_addr                                                      "0xB800C748"
+#define SE_HCOEF3_32_29_reg_addr                                                      "0xB800C74C"
+#define SE_HCOEF3_32_30_reg_addr                                                      "0xB800C750"
+#define SE_HCOEF3_32_31_reg_addr                                                      "0xB800C754"
+#define SE_HCOEF3_32_0_reg                                                           0xB800C6D8
+#define SE_HCOEF3_32_1_reg                                                           0xB800C6DC
+#define SE_HCOEF3_32_2_reg                                                           0xB800C6E0
+#define SE_HCOEF3_32_3_reg                                                           0xB800C6E4
+#define SE_HCOEF3_32_4_reg                                                           0xB800C6E8
+#define SE_HCOEF3_32_5_reg                                                           0xB800C6EC
+#define SE_HCOEF3_32_6_reg                                                           0xB800C6F0
+#define SE_HCOEF3_32_7_reg                                                           0xB800C6F4
+#define SE_HCOEF3_32_8_reg                                                           0xB800C6F8
+#define SE_HCOEF3_32_9_reg                                                           0xB800C6FC
+#define SE_HCOEF3_32_10_reg                                                           0xB800C700
+#define SE_HCOEF3_32_11_reg                                                           0xB800C704
+#define SE_HCOEF3_32_12_reg                                                           0xB800C708
+#define SE_HCOEF3_32_13_reg                                                           0xB800C70C
+#define SE_HCOEF3_32_14_reg                                                           0xB800C710
+#define SE_HCOEF3_32_15_reg                                                           0xB800C714
+#define SE_HCOEF3_32_16_reg                                                           0xB800C718
+#define SE_HCOEF3_32_17_reg                                                           0xB800C71C
+#define SE_HCOEF3_32_18_reg                                                           0xB800C720
+#define SE_HCOEF3_32_19_reg                                                           0xB800C724
+#define SE_HCOEF3_32_20_reg                                                           0xB800C728
+#define SE_HCOEF3_32_21_reg                                                           0xB800C72C
+#define SE_HCOEF3_32_22_reg                                                           0xB800C730
+#define SE_HCOEF3_32_23_reg                                                           0xB800C734
+#define SE_HCOEF3_32_24_reg                                                           0xB800C738
+#define SE_HCOEF3_32_25_reg                                                           0xB800C73C
+#define SE_HCOEF3_32_26_reg                                                           0xB800C740
+#define SE_HCOEF3_32_27_reg                                                           0xB800C744
+#define SE_HCOEF3_32_28_reg                                                           0xB800C748
+#define SE_HCOEF3_32_29_reg                                                           0xB800C74C
+#define SE_HCOEF3_32_30_reg                                                           0xB800C750
+#define SE_HCOEF3_32_31_reg                                                           0xB800C754
+#define set_SE_HCOEF3_32_0_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_0_reg)=data)
+#define set_SE_HCOEF3_32_1_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_1_reg)=data)
+#define set_SE_HCOEF3_32_2_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_2_reg)=data)
+#define set_SE_HCOEF3_32_3_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_3_reg)=data)
+#define set_SE_HCOEF3_32_4_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_4_reg)=data)
+#define set_SE_HCOEF3_32_5_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_5_reg)=data)
+#define set_SE_HCOEF3_32_6_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_6_reg)=data)
+#define set_SE_HCOEF3_32_7_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_7_reg)=data)
+#define set_SE_HCOEF3_32_8_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_8_reg)=data)
+#define set_SE_HCOEF3_32_9_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_9_reg)=data)
+#define set_SE_HCOEF3_32_10_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_10_reg)=data)
+#define set_SE_HCOEF3_32_11_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_11_reg)=data)
+#define set_SE_HCOEF3_32_12_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_12_reg)=data)
+#define set_SE_HCOEF3_32_13_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_13_reg)=data)
+#define set_SE_HCOEF3_32_14_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_14_reg)=data)
+#define set_SE_HCOEF3_32_15_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_15_reg)=data)
+#define set_SE_HCOEF3_32_16_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_16_reg)=data)
+#define set_SE_HCOEF3_32_17_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_17_reg)=data)
+#define set_SE_HCOEF3_32_18_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_18_reg)=data)
+#define set_SE_HCOEF3_32_19_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_19_reg)=data)
+#define set_SE_HCOEF3_32_20_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_20_reg)=data)
+#define set_SE_HCOEF3_32_21_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_21_reg)=data)
+#define set_SE_HCOEF3_32_22_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_22_reg)=data)
+#define set_SE_HCOEF3_32_23_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_23_reg)=data)
+#define set_SE_HCOEF3_32_24_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_24_reg)=data)
+#define set_SE_HCOEF3_32_25_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_25_reg)=data)
+#define set_SE_HCOEF3_32_26_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_26_reg)=data)
+#define set_SE_HCOEF3_32_27_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_27_reg)=data)
+#define set_SE_HCOEF3_32_28_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_28_reg)=data)
+#define set_SE_HCOEF3_32_29_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_29_reg)=data)
+#define set_SE_HCOEF3_32_30_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_30_reg)=data)
+#define set_SE_HCOEF3_32_31_reg(data)   (*((volatile unsigned int*) SE_HCOEF3_32_31_reg)=data)
+#define get_SE_HCOEF3_32_0_reg   (*((volatile unsigned int*) SE_HCOEF3_32_0_reg))
+#define get_SE_HCOEF3_32_1_reg   (*((volatile unsigned int*) SE_HCOEF3_32_1_reg))
+#define get_SE_HCOEF3_32_2_reg   (*((volatile unsigned int*) SE_HCOEF3_32_2_reg))
+#define get_SE_HCOEF3_32_3_reg   (*((volatile unsigned int*) SE_HCOEF3_32_3_reg))
+#define get_SE_HCOEF3_32_4_reg   (*((volatile unsigned int*) SE_HCOEF3_32_4_reg))
+#define get_SE_HCOEF3_32_5_reg   (*((volatile unsigned int*) SE_HCOEF3_32_5_reg))
+#define get_SE_HCOEF3_32_6_reg   (*((volatile unsigned int*) SE_HCOEF3_32_6_reg))
+#define get_SE_HCOEF3_32_7_reg   (*((volatile unsigned int*) SE_HCOEF3_32_7_reg))
+#define get_SE_HCOEF3_32_8_reg   (*((volatile unsigned int*) SE_HCOEF3_32_8_reg))
+#define get_SE_HCOEF3_32_9_reg   (*((volatile unsigned int*) SE_HCOEF3_32_9_reg))
+#define get_SE_HCOEF3_32_10_reg   (*((volatile unsigned int*) SE_HCOEF3_32_10_reg))
+#define get_SE_HCOEF3_32_11_reg   (*((volatile unsigned int*) SE_HCOEF3_32_11_reg))
+#define get_SE_HCOEF3_32_12_reg   (*((volatile unsigned int*) SE_HCOEF3_32_12_reg))
+#define get_SE_HCOEF3_32_13_reg   (*((volatile unsigned int*) SE_HCOEF3_32_13_reg))
+#define get_SE_HCOEF3_32_14_reg   (*((volatile unsigned int*) SE_HCOEF3_32_14_reg))
+#define get_SE_HCOEF3_32_15_reg   (*((volatile unsigned int*) SE_HCOEF3_32_15_reg))
+#define get_SE_HCOEF3_32_16_reg   (*((volatile unsigned int*) SE_HCOEF3_32_16_reg))
+#define get_SE_HCOEF3_32_17_reg   (*((volatile unsigned int*) SE_HCOEF3_32_17_reg))
+#define get_SE_HCOEF3_32_18_reg   (*((volatile unsigned int*) SE_HCOEF3_32_18_reg))
+#define get_SE_HCOEF3_32_19_reg   (*((volatile unsigned int*) SE_HCOEF3_32_19_reg))
+#define get_SE_HCOEF3_32_20_reg   (*((volatile unsigned int*) SE_HCOEF3_32_20_reg))
+#define get_SE_HCOEF3_32_21_reg   (*((volatile unsigned int*) SE_HCOEF3_32_21_reg))
+#define get_SE_HCOEF3_32_22_reg   (*((volatile unsigned int*) SE_HCOEF3_32_22_reg))
+#define get_SE_HCOEF3_32_23_reg   (*((volatile unsigned int*) SE_HCOEF3_32_23_reg))
+#define get_SE_HCOEF3_32_24_reg   (*((volatile unsigned int*) SE_HCOEF3_32_24_reg))
+#define get_SE_HCOEF3_32_25_reg   (*((volatile unsigned int*) SE_HCOEF3_32_25_reg))
+#define get_SE_HCOEF3_32_26_reg   (*((volatile unsigned int*) SE_HCOEF3_32_26_reg))
+#define get_SE_HCOEF3_32_27_reg   (*((volatile unsigned int*) SE_HCOEF3_32_27_reg))
+#define get_SE_HCOEF3_32_28_reg   (*((volatile unsigned int*) SE_HCOEF3_32_28_reg))
+#define get_SE_HCOEF3_32_29_reg   (*((volatile unsigned int*) SE_HCOEF3_32_29_reg))
+#define get_SE_HCOEF3_32_30_reg   (*((volatile unsigned int*) SE_HCOEF3_32_30_reg))
+#define get_SE_HCOEF3_32_31_reg   (*((volatile unsigned int*) SE_HCOEF3_32_31_reg))
+#define SE_HCOEF3_32_0_inst_adr                                                      "0x00B6"
+#define SE_HCOEF3_32_1_inst_adr                                                      "0x00B7"
+#define SE_HCOEF3_32_2_inst_adr                                                      "0x00B8"
+#define SE_HCOEF3_32_3_inst_adr                                                      "0x00B9"
+#define SE_HCOEF3_32_4_inst_adr                                                      "0x00BA"
+#define SE_HCOEF3_32_5_inst_adr                                                      "0x00BB"
+#define SE_HCOEF3_32_6_inst_adr                                                      "0x00BC"
+#define SE_HCOEF3_32_7_inst_adr                                                      "0x00BD"
+#define SE_HCOEF3_32_8_inst_adr                                                      "0x00BE"
+#define SE_HCOEF3_32_9_inst_adr                                                      "0x00BF"
+#define SE_HCOEF3_32_10_inst_adr                                                      "0x00C0"
+#define SE_HCOEF3_32_11_inst_adr                                                      "0x00C1"
+#define SE_HCOEF3_32_12_inst_adr                                                      "0x00C2"
+#define SE_HCOEF3_32_13_inst_adr                                                      "0x00C3"
+#define SE_HCOEF3_32_14_inst_adr                                                      "0x00C4"
+#define SE_HCOEF3_32_15_inst_adr                                                      "0x00C5"
+#define SE_HCOEF3_32_16_inst_adr                                                      "0x00C6"
+#define SE_HCOEF3_32_17_inst_adr                                                      "0x00C7"
+#define SE_HCOEF3_32_18_inst_adr                                                      "0x00C8"
+#define SE_HCOEF3_32_19_inst_adr                                                      "0x00C9"
+#define SE_HCOEF3_32_20_inst_adr                                                      "0x00CA"
+#define SE_HCOEF3_32_21_inst_adr                                                      "0x00CB"
+#define SE_HCOEF3_32_22_inst_adr                                                      "0x00CC"
+#define SE_HCOEF3_32_23_inst_adr                                                      "0x00CD"
+#define SE_HCOEF3_32_24_inst_adr                                                      "0x00CE"
+#define SE_HCOEF3_32_25_inst_adr                                                      "0x00CF"
+#define SE_HCOEF3_32_26_inst_adr                                                      "0x00D0"
+#define SE_HCOEF3_32_27_inst_adr                                                      "0x00D1"
+#define SE_HCOEF3_32_28_inst_adr                                                      "0x00D2"
+#define SE_HCOEF3_32_29_inst_adr                                                      "0x00D3"
+#define SE_HCOEF3_32_30_inst_adr                                                      "0x00D4"
+#define SE_HCOEF3_32_31_inst_adr                                                      "0x00D5"
+#define SE_HCOEF3_32_0_inst                                                          0x00B6
+#define SE_HCOEF3_32_1_inst                                                          0x00B7
+#define SE_HCOEF3_32_2_inst                                                          0x00B8
+#define SE_HCOEF3_32_3_inst                                                          0x00B9
+#define SE_HCOEF3_32_4_inst                                                          0x00BA
+#define SE_HCOEF3_32_5_inst                                                          0x00BB
+#define SE_HCOEF3_32_6_inst                                                          0x00BC
+#define SE_HCOEF3_32_7_inst                                                          0x00BD
+#define SE_HCOEF3_32_8_inst                                                          0x00BE
+#define SE_HCOEF3_32_9_inst                                                          0x00BF
+#define SE_HCOEF3_32_10_inst                                                          0x00C0
+#define SE_HCOEF3_32_11_inst                                                          0x00C1
+#define SE_HCOEF3_32_12_inst                                                          0x00C2
+#define SE_HCOEF3_32_13_inst                                                          0x00C3
+#define SE_HCOEF3_32_14_inst                                                          0x00C4
+#define SE_HCOEF3_32_15_inst                                                          0x00C5
+#define SE_HCOEF3_32_16_inst                                                          0x00C6
+#define SE_HCOEF3_32_17_inst                                                          0x00C7
+#define SE_HCOEF3_32_18_inst                                                          0x00C8
+#define SE_HCOEF3_32_19_inst                                                          0x00C9
+#define SE_HCOEF3_32_20_inst                                                          0x00CA
+#define SE_HCOEF3_32_21_inst                                                          0x00CB
+#define SE_HCOEF3_32_22_inst                                                          0x00CC
+#define SE_HCOEF3_32_23_inst                                                          0x00CD
+#define SE_HCOEF3_32_24_inst                                                          0x00CE
+#define SE_HCOEF3_32_25_inst                                                          0x00CF
+#define SE_HCOEF3_32_26_inst                                                          0x00D0
+#define SE_HCOEF3_32_27_inst                                                          0x00D1
+#define SE_HCOEF3_32_28_inst                                                          0x00D2
+#define SE_HCOEF3_32_29_inst                                                          0x00D3
+#define SE_HCOEF3_32_30_inst                                                          0x00D4
+#define SE_HCOEF3_32_31_inst                                                          0x00D5
+#define SE_HCOEF3_32_hcoef_shift                                                     (0)
+#define SE_HCOEF3_32_hcoef_mask                                                      (0x00003FFF)
+#define SE_HCOEF3_32_hcoef(data)                                                     (0x00003FFF&((data)<<0))
+#define SE_HCOEF3_32_hcoef_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define SE_HCOEF3_32_get_hcoef(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define SE_VCOEF3_0                                                                  0x1800C400
+#define SE_VCOEF3_1                                                                  0x1800C404
+#define SE_VCOEF3_2                                                                  0x1800C408
+#define SE_VCOEF3_3                                                                  0x1800C40C
+#define SE_VCOEF3_4                                                                  0x1800C410
+#define SE_VCOEF3_5                                                                  0x1800C414
+#define SE_VCOEF3_6                                                                  0x1800C418
+#define SE_VCOEF3_7                                                                  0x1800C41C
+#define SE_VCOEF3_8                                                                  0x1800C420
+#define SE_VCOEF3_9                                                                  0x1800C424
+#define SE_VCOEF3_10                                                                  0x1800C428
+#define SE_VCOEF3_11                                                                  0x1800C42C
+#define SE_VCOEF3_12                                                                  0x1800C430
+#define SE_VCOEF3_13                                                                  0x1800C434
+#define SE_VCOEF3_14                                                                  0x1800C438
+#define SE_VCOEF3_15                                                                  0x1800C43C
+#define SE_VCOEF3_0_reg_addr                                                         "0xB800C400"
+#define SE_VCOEF3_1_reg_addr                                                         "0xB800C404"
+#define SE_VCOEF3_2_reg_addr                                                         "0xB800C408"
+#define SE_VCOEF3_3_reg_addr                                                         "0xB800C40C"
+#define SE_VCOEF3_4_reg_addr                                                         "0xB800C410"
+#define SE_VCOEF3_5_reg_addr                                                         "0xB800C414"
+#define SE_VCOEF3_6_reg_addr                                                         "0xB800C418"
+#define SE_VCOEF3_7_reg_addr                                                         "0xB800C41C"
+#define SE_VCOEF3_8_reg_addr                                                         "0xB800C420"
+#define SE_VCOEF3_9_reg_addr                                                         "0xB800C424"
+#define SE_VCOEF3_10_reg_addr                                                         "0xB800C428"
+#define SE_VCOEF3_11_reg_addr                                                         "0xB800C42C"
+#define SE_VCOEF3_12_reg_addr                                                         "0xB800C430"
+#define SE_VCOEF3_13_reg_addr                                                         "0xB800C434"
+#define SE_VCOEF3_14_reg_addr                                                         "0xB800C438"
+#define SE_VCOEF3_15_reg_addr                                                         "0xB800C43C"
+#define SE_VCOEF3_0_reg                                                              0xB800C400
+#define SE_VCOEF3_1_reg                                                              0xB800C404
+#define SE_VCOEF3_2_reg                                                              0xB800C408
+#define SE_VCOEF3_3_reg                                                              0xB800C40C
+#define SE_VCOEF3_4_reg                                                              0xB800C410
+#define SE_VCOEF3_5_reg                                                              0xB800C414
+#define SE_VCOEF3_6_reg                                                              0xB800C418
+#define SE_VCOEF3_7_reg                                                              0xB800C41C
+#define SE_VCOEF3_8_reg                                                              0xB800C420
+#define SE_VCOEF3_9_reg                                                              0xB800C424
+#define SE_VCOEF3_10_reg                                                              0xB800C428
+#define SE_VCOEF3_11_reg                                                              0xB800C42C
+#define SE_VCOEF3_12_reg                                                              0xB800C430
+#define SE_VCOEF3_13_reg                                                              0xB800C434
+#define SE_VCOEF3_14_reg                                                              0xB800C438
+#define SE_VCOEF3_15_reg                                                              0xB800C43C
+#define set_SE_VCOEF3_0_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_0_reg)=data)
+#define set_SE_VCOEF3_1_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_1_reg)=data)
+#define set_SE_VCOEF3_2_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_2_reg)=data)
+#define set_SE_VCOEF3_3_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_3_reg)=data)
+#define set_SE_VCOEF3_4_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_4_reg)=data)
+#define set_SE_VCOEF3_5_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_5_reg)=data)
+#define set_SE_VCOEF3_6_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_6_reg)=data)
+#define set_SE_VCOEF3_7_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_7_reg)=data)
+#define set_SE_VCOEF3_8_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_8_reg)=data)
+#define set_SE_VCOEF3_9_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_9_reg)=data)
+#define set_SE_VCOEF3_10_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_10_reg)=data)
+#define set_SE_VCOEF3_11_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_11_reg)=data)
+#define set_SE_VCOEF3_12_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_12_reg)=data)
+#define set_SE_VCOEF3_13_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_13_reg)=data)
+#define set_SE_VCOEF3_14_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_14_reg)=data)
+#define set_SE_VCOEF3_15_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_15_reg)=data)
+#define get_SE_VCOEF3_0_reg   (*((volatile unsigned int*) SE_VCOEF3_0_reg))
+#define get_SE_VCOEF3_1_reg   (*((volatile unsigned int*) SE_VCOEF3_1_reg))
+#define get_SE_VCOEF3_2_reg   (*((volatile unsigned int*) SE_VCOEF3_2_reg))
+#define get_SE_VCOEF3_3_reg   (*((volatile unsigned int*) SE_VCOEF3_3_reg))
+#define get_SE_VCOEF3_4_reg   (*((volatile unsigned int*) SE_VCOEF3_4_reg))
+#define get_SE_VCOEF3_5_reg   (*((volatile unsigned int*) SE_VCOEF3_5_reg))
+#define get_SE_VCOEF3_6_reg   (*((volatile unsigned int*) SE_VCOEF3_6_reg))
+#define get_SE_VCOEF3_7_reg   (*((volatile unsigned int*) SE_VCOEF3_7_reg))
+#define get_SE_VCOEF3_8_reg   (*((volatile unsigned int*) SE_VCOEF3_8_reg))
+#define get_SE_VCOEF3_9_reg   (*((volatile unsigned int*) SE_VCOEF3_9_reg))
+#define get_SE_VCOEF3_10_reg   (*((volatile unsigned int*) SE_VCOEF3_10_reg))
+#define get_SE_VCOEF3_11_reg   (*((volatile unsigned int*) SE_VCOEF3_11_reg))
+#define get_SE_VCOEF3_12_reg   (*((volatile unsigned int*) SE_VCOEF3_12_reg))
+#define get_SE_VCOEF3_13_reg   (*((volatile unsigned int*) SE_VCOEF3_13_reg))
+#define get_SE_VCOEF3_14_reg   (*((volatile unsigned int*) SE_VCOEF3_14_reg))
+#define get_SE_VCOEF3_15_reg   (*((volatile unsigned int*) SE_VCOEF3_15_reg))
+#define SE_VCOEF3_0_inst_adr                                                         "0x0000"
+#define SE_VCOEF3_1_inst_adr                                                         "0x0001"
+#define SE_VCOEF3_2_inst_adr                                                         "0x0002"
+#define SE_VCOEF3_3_inst_adr                                                         "0x0003"
+#define SE_VCOEF3_4_inst_adr                                                         "0x0004"
+#define SE_VCOEF3_5_inst_adr                                                         "0x0005"
+#define SE_VCOEF3_6_inst_adr                                                         "0x0006"
+#define SE_VCOEF3_7_inst_adr                                                         "0x0007"
+#define SE_VCOEF3_8_inst_adr                                                         "0x0008"
+#define SE_VCOEF3_9_inst_adr                                                         "0x0009"
+#define SE_VCOEF3_10_inst_adr                                                         "0x000A"
+#define SE_VCOEF3_11_inst_adr                                                         "0x000B"
+#define SE_VCOEF3_12_inst_adr                                                         "0x000C"
+#define SE_VCOEF3_13_inst_adr                                                         "0x000D"
+#define SE_VCOEF3_14_inst_adr                                                         "0x000E"
+#define SE_VCOEF3_15_inst_adr                                                         "0x000F"
+#define SE_VCOEF3_0_inst                                                             0x0000
+#define SE_VCOEF3_1_inst                                                             0x0001
+#define SE_VCOEF3_2_inst                                                             0x0002
+#define SE_VCOEF3_3_inst                                                             0x0003
+#define SE_VCOEF3_4_inst                                                             0x0004
+#define SE_VCOEF3_5_inst                                                             0x0005
+#define SE_VCOEF3_6_inst                                                             0x0006
+#define SE_VCOEF3_7_inst                                                             0x0007
+#define SE_VCOEF3_8_inst                                                             0x0008
+#define SE_VCOEF3_9_inst                                                             0x0009
+#define SE_VCOEF3_10_inst                                                             0x000A
+#define SE_VCOEF3_11_inst                                                             0x000B
+#define SE_VCOEF3_12_inst                                                             0x000C
+#define SE_VCOEF3_13_inst                                                             0x000D
+#define SE_VCOEF3_14_inst                                                             0x000E
+#define SE_VCOEF3_15_inst                                                             0x000F
+#define SE_VCOEF3_vcoef_shift                                                        (0)
+#define SE_VCOEF3_vcoef_mask                                                         (0x00003FFF)
+#define SE_VCOEF3_vcoef(data)                                                        (0x00003FFF&((data)<<0))
+#define SE_VCOEF3_vcoef_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define SE_VCOEF3_get_vcoef(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define SE_VCOEF3_16_0                                                               0x1800C758
+#define SE_VCOEF3_16_1                                                               0x1800C75C
+#define SE_VCOEF3_16_2                                                               0x1800C760
+#define SE_VCOEF3_16_3                                                               0x1800C764
+#define SE_VCOEF3_16_4                                                               0x1800C768
+#define SE_VCOEF3_16_5                                                               0x1800C76C
+#define SE_VCOEF3_16_6                                                               0x1800C770
+#define SE_VCOEF3_16_7                                                               0x1800C774
+#define SE_VCOEF3_16_8                                                               0x1800C778
+#define SE_VCOEF3_16_9                                                               0x1800C77C
+#define SE_VCOEF3_16_10                                                               0x1800C780
+#define SE_VCOEF3_16_11                                                               0x1800C784
+#define SE_VCOEF3_16_12                                                               0x1800C788
+#define SE_VCOEF3_16_13                                                               0x1800C78C
+#define SE_VCOEF3_16_14                                                               0x1800C790
+#define SE_VCOEF3_16_15                                                               0x1800C794
+#define SE_VCOEF3_16_0_reg_addr                                                      "0xB800C758"
+#define SE_VCOEF3_16_1_reg_addr                                                      "0xB800C75C"
+#define SE_VCOEF3_16_2_reg_addr                                                      "0xB800C760"
+#define SE_VCOEF3_16_3_reg_addr                                                      "0xB800C764"
+#define SE_VCOEF3_16_4_reg_addr                                                      "0xB800C768"
+#define SE_VCOEF3_16_5_reg_addr                                                      "0xB800C76C"
+#define SE_VCOEF3_16_6_reg_addr                                                      "0xB800C770"
+#define SE_VCOEF3_16_7_reg_addr                                                      "0xB800C774"
+#define SE_VCOEF3_16_8_reg_addr                                                      "0xB800C778"
+#define SE_VCOEF3_16_9_reg_addr                                                      "0xB800C77C"
+#define SE_VCOEF3_16_10_reg_addr                                                      "0xB800C780"
+#define SE_VCOEF3_16_11_reg_addr                                                      "0xB800C784"
+#define SE_VCOEF3_16_12_reg_addr                                                      "0xB800C788"
+#define SE_VCOEF3_16_13_reg_addr                                                      "0xB800C78C"
+#define SE_VCOEF3_16_14_reg_addr                                                      "0xB800C790"
+#define SE_VCOEF3_16_15_reg_addr                                                      "0xB800C794"
+#define SE_VCOEF3_16_0_reg                                                           0xB800C758
+#define SE_VCOEF3_16_1_reg                                                           0xB800C75C
+#define SE_VCOEF3_16_2_reg                                                           0xB800C760
+#define SE_VCOEF3_16_3_reg                                                           0xB800C764
+#define SE_VCOEF3_16_4_reg                                                           0xB800C768
+#define SE_VCOEF3_16_5_reg                                                           0xB800C76C
+#define SE_VCOEF3_16_6_reg                                                           0xB800C770
+#define SE_VCOEF3_16_7_reg                                                           0xB800C774
+#define SE_VCOEF3_16_8_reg                                                           0xB800C778
+#define SE_VCOEF3_16_9_reg                                                           0xB800C77C
+#define SE_VCOEF3_16_10_reg                                                           0xB800C780
+#define SE_VCOEF3_16_11_reg                                                           0xB800C784
+#define SE_VCOEF3_16_12_reg                                                           0xB800C788
+#define SE_VCOEF3_16_13_reg                                                           0xB800C78C
+#define SE_VCOEF3_16_14_reg                                                           0xB800C790
+#define SE_VCOEF3_16_15_reg                                                           0xB800C794
+#define set_SE_VCOEF3_16_0_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_0_reg)=data)
+#define set_SE_VCOEF3_16_1_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_1_reg)=data)
+#define set_SE_VCOEF3_16_2_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_2_reg)=data)
+#define set_SE_VCOEF3_16_3_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_3_reg)=data)
+#define set_SE_VCOEF3_16_4_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_4_reg)=data)
+#define set_SE_VCOEF3_16_5_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_5_reg)=data)
+#define set_SE_VCOEF3_16_6_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_6_reg)=data)
+#define set_SE_VCOEF3_16_7_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_7_reg)=data)
+#define set_SE_VCOEF3_16_8_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_8_reg)=data)
+#define set_SE_VCOEF3_16_9_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_9_reg)=data)
+#define set_SE_VCOEF3_16_10_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_10_reg)=data)
+#define set_SE_VCOEF3_16_11_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_11_reg)=data)
+#define set_SE_VCOEF3_16_12_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_12_reg)=data)
+#define set_SE_VCOEF3_16_13_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_13_reg)=data)
+#define set_SE_VCOEF3_16_14_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_14_reg)=data)
+#define set_SE_VCOEF3_16_15_reg(data)   (*((volatile unsigned int*) SE_VCOEF3_16_15_reg)=data)
+#define get_SE_VCOEF3_16_0_reg   (*((volatile unsigned int*) SE_VCOEF3_16_0_reg))
+#define get_SE_VCOEF3_16_1_reg   (*((volatile unsigned int*) SE_VCOEF3_16_1_reg))
+#define get_SE_VCOEF3_16_2_reg   (*((volatile unsigned int*) SE_VCOEF3_16_2_reg))
+#define get_SE_VCOEF3_16_3_reg   (*((volatile unsigned int*) SE_VCOEF3_16_3_reg))
+#define get_SE_VCOEF3_16_4_reg   (*((volatile unsigned int*) SE_VCOEF3_16_4_reg))
+#define get_SE_VCOEF3_16_5_reg   (*((volatile unsigned int*) SE_VCOEF3_16_5_reg))
+#define get_SE_VCOEF3_16_6_reg   (*((volatile unsigned int*) SE_VCOEF3_16_6_reg))
+#define get_SE_VCOEF3_16_7_reg   (*((volatile unsigned int*) SE_VCOEF3_16_7_reg))
+#define get_SE_VCOEF3_16_8_reg   (*((volatile unsigned int*) SE_VCOEF3_16_8_reg))
+#define get_SE_VCOEF3_16_9_reg   (*((volatile unsigned int*) SE_VCOEF3_16_9_reg))
+#define get_SE_VCOEF3_16_10_reg   (*((volatile unsigned int*) SE_VCOEF3_16_10_reg))
+#define get_SE_VCOEF3_16_11_reg   (*((volatile unsigned int*) SE_VCOEF3_16_11_reg))
+#define get_SE_VCOEF3_16_12_reg   (*((volatile unsigned int*) SE_VCOEF3_16_12_reg))
+#define get_SE_VCOEF3_16_13_reg   (*((volatile unsigned int*) SE_VCOEF3_16_13_reg))
+#define get_SE_VCOEF3_16_14_reg   (*((volatile unsigned int*) SE_VCOEF3_16_14_reg))
+#define get_SE_VCOEF3_16_15_reg   (*((volatile unsigned int*) SE_VCOEF3_16_15_reg))
+#define SE_VCOEF3_16_0_inst_adr                                                      "0x00D6"
+#define SE_VCOEF3_16_1_inst_adr                                                      "0x00D7"
+#define SE_VCOEF3_16_2_inst_adr                                                      "0x00D8"
+#define SE_VCOEF3_16_3_inst_adr                                                      "0x00D9"
+#define SE_VCOEF3_16_4_inst_adr                                                      "0x00DA"
+#define SE_VCOEF3_16_5_inst_adr                                                      "0x00DB"
+#define SE_VCOEF3_16_6_inst_adr                                                      "0x00DC"
+#define SE_VCOEF3_16_7_inst_adr                                                      "0x00DD"
+#define SE_VCOEF3_16_8_inst_adr                                                      "0x00DE"
+#define SE_VCOEF3_16_9_inst_adr                                                      "0x00DF"
+#define SE_VCOEF3_16_10_inst_adr                                                      "0x00E0"
+#define SE_VCOEF3_16_11_inst_adr                                                      "0x00E1"
+#define SE_VCOEF3_16_12_inst_adr                                                      "0x00E2"
+#define SE_VCOEF3_16_13_inst_adr                                                      "0x00E3"
+#define SE_VCOEF3_16_14_inst_adr                                                      "0x00E4"
+#define SE_VCOEF3_16_15_inst_adr                                                      "0x00E5"
+#define SE_VCOEF3_16_0_inst                                                          0x00D6
+#define SE_VCOEF3_16_1_inst                                                          0x00D7
+#define SE_VCOEF3_16_2_inst                                                          0x00D8
+#define SE_VCOEF3_16_3_inst                                                          0x00D9
+#define SE_VCOEF3_16_4_inst                                                          0x00DA
+#define SE_VCOEF3_16_5_inst                                                          0x00DB
+#define SE_VCOEF3_16_6_inst                                                          0x00DC
+#define SE_VCOEF3_16_7_inst                                                          0x00DD
+#define SE_VCOEF3_16_8_inst                                                          0x00DE
+#define SE_VCOEF3_16_9_inst                                                          0x00DF
+#define SE_VCOEF3_16_10_inst                                                          0x00E0
+#define SE_VCOEF3_16_11_inst                                                          0x00E1
+#define SE_VCOEF3_16_12_inst                                                          0x00E2
+#define SE_VCOEF3_16_13_inst                                                          0x00E3
+#define SE_VCOEF3_16_14_inst                                                          0x00E4
+#define SE_VCOEF3_16_15_inst                                                          0x00E5
+#define SE_VCOEF3_16_vcoef_shift                                                     (0)
+#define SE_VCOEF3_16_vcoef_mask                                                      (0x00003FFF)
+#define SE_VCOEF3_16_vcoef(data)                                                     (0x00003FFF&((data)<<0))
+#define SE_VCOEF3_16_vcoef_src(data)                                                 ((0x00003FFF&(data))>>0)
+#define SE_VCOEF3_16_get_vcoef(data)                                                 ((0x00003FFF&(data))>>0)
+
+
+#define SE_SC_BITBLIT_COLOR_KEY_0                                                    0x1800C4EC
+#define SE_SC_BITBLIT_COLOR_KEY_1                                                    0x1800C4F0
+#define SE_SC_BITBLIT_COLOR_KEY_2                                                    0x1800C4F4
+#define SE_SC_BITBLIT_COLOR_KEY_0_reg_addr                                           "0xB800C4EC"
+#define SE_SC_BITBLIT_COLOR_KEY_1_reg_addr                                           "0xB800C4F0"
+#define SE_SC_BITBLIT_COLOR_KEY_2_reg_addr                                           "0xB800C4F4"
+#define SE_SC_BITBLIT_COLOR_KEY_0_reg                                                0xB800C4EC
+#define SE_SC_BITBLIT_COLOR_KEY_1_reg                                                0xB800C4F0
+#define SE_SC_BITBLIT_COLOR_KEY_2_reg                                                0xB800C4F4
+#define set_SE_SC_BITBLIT_COLOR_KEY_0_reg(data)   (*((volatile unsigned int*) SE_SC_BITBLIT_COLOR_KEY_0_reg)=data)
+#define set_SE_SC_BITBLIT_COLOR_KEY_1_reg(data)   (*((volatile unsigned int*) SE_SC_BITBLIT_COLOR_KEY_1_reg)=data)
+#define set_SE_SC_BITBLIT_COLOR_KEY_2_reg(data)   (*((volatile unsigned int*) SE_SC_BITBLIT_COLOR_KEY_2_reg)=data)
+#define get_SE_SC_BITBLIT_COLOR_KEY_0_reg   (*((volatile unsigned int*) SE_SC_BITBLIT_COLOR_KEY_0_reg))
+#define get_SE_SC_BITBLIT_COLOR_KEY_1_reg   (*((volatile unsigned int*) SE_SC_BITBLIT_COLOR_KEY_1_reg))
+#define get_SE_SC_BITBLIT_COLOR_KEY_2_reg   (*((volatile unsigned int*) SE_SC_BITBLIT_COLOR_KEY_2_reg))
+#define SE_SC_BITBLIT_COLOR_KEY_0_inst_adr                                           "0x003B"
+#define SE_SC_BITBLIT_COLOR_KEY_1_inst_adr                                           "0x003C"
+#define SE_SC_BITBLIT_COLOR_KEY_2_inst_adr                                           "0x003D"
+#define SE_SC_BITBLIT_COLOR_KEY_0_inst                                               0x003B
+#define SE_SC_BITBLIT_COLOR_KEY_1_inst                                               0x003C
+#define SE_SC_BITBLIT_COLOR_KEY_2_inst                                               0x003D
+#define SE_SC_BITBLIT_COLOR_KEY_color_key_shift                                      (0)
+#define SE_SC_BITBLIT_COLOR_KEY_color_key_mask                                       (0x00FFFFFF)
+#define SE_SC_BITBLIT_COLOR_KEY_color_key(data)                                      (0x00FFFFFF&((data)<<0))
+#define SE_SC_BITBLIT_COLOR_KEY_color_key_src(data)                                  ((0x00FFFFFF&(data))>>0)
+#define SE_SC_BITBLIT_COLOR_KEY_get_color_key(data)                                  ((0x00FFFFFF&(data))>>0)
+
+
+#define SE_CTRL_0                                                                    0x1800C458
+#define SE_CTRL_1                                                                    0x1800C45C
+#define SE_CTRL_2                                                                    0x1800C460
+#define SE_CTRL_0_reg_addr                                                           "0xB800C458"
+#define SE_CTRL_1_reg_addr                                                           "0xB800C45C"
+#define SE_CTRL_2_reg_addr                                                           "0xB800C460"
+#define SE_CTRL_0_reg                                                                0xB800C458
+#define SE_CTRL_1_reg                                                                0xB800C45C
+#define SE_CTRL_2_reg                                                                0xB800C460
+#define set_SE_CTRL_0_reg(data)   (*((volatile unsigned int*) SE_CTRL_0_reg)=data)
+#define set_SE_CTRL_1_reg(data)   (*((volatile unsigned int*) SE_CTRL_1_reg)=data)
+#define set_SE_CTRL_2_reg(data)   (*((volatile unsigned int*) SE_CTRL_2_reg)=data)
+#define get_SE_CTRL_0_reg   (*((volatile unsigned int*) SE_CTRL_0_reg))
+#define get_SE_CTRL_1_reg   (*((volatile unsigned int*) SE_CTRL_1_reg))
+#define get_SE_CTRL_2_reg   (*((volatile unsigned int*) SE_CTRL_2_reg))
+#define SE_CTRL_0_inst_adr                                                           "0x0016"
+#define SE_CTRL_1_inst_adr                                                           "0x0017"
+#define SE_CTRL_2_inst_adr                                                           "0x0018"
+#define SE_CTRL_0_inst                                                               0x0016
+#define SE_CTRL_1_inst                                                               0x0017
+#define SE_CTRL_2_inst                                                               0x0018
+#define SE_CTRL_endiswap_shift                                                       (2)
+#define SE_CTRL_endiswap_mask                                                        (0x00000004)
+#define SE_CTRL_endiswap(data)                                                       (0x00000004&((data)<<2))
+#define SE_CTRL_endiswap_src(data)                                                   ((0x00000004&(data))>>2)
+#define SE_CTRL_get_endiswap(data)                                                   ((0x00000004&(data))>>2)
+#define SE_CTRL_go_shift                                                             (1)
+#define SE_CTRL_go_mask                                                              (0x00000002)
+#define SE_CTRL_go(data)                                                             (0x00000002&((data)<<1))
+#define SE_CTRL_go_src(data)                                                         ((0x00000002&(data))>>1)
+#define SE_CTRL_get_go(data)                                                         ((0x00000002&(data))>>1)
+#define SE_CTRL_write_data_shift                                                     (0)
+#define SE_CTRL_write_data_mask                                                      (0x00000001)
+#define SE_CTRL_write_data(data)                                                     (0x00000001&((data)<<0))
+#define SE_CTRL_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define SE_CTRL_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define SE_IDLE_0                                                                    0x1800C464
+#define SE_IDLE_1                                                                    0x1800C468
+#define SE_IDLE_2                                                                    0x1800C46C
+#define SE_IDLE_0_reg_addr                                                           "0xB800C464"
+#define SE_IDLE_1_reg_addr                                                           "0xB800C468"
+#define SE_IDLE_2_reg_addr                                                           "0xB800C46C"
+#define SE_IDLE_0_reg                                                                0xB800C464
+#define SE_IDLE_1_reg                                                                0xB800C468
+#define SE_IDLE_2_reg                                                                0xB800C46C
+#define set_SE_IDLE_0_reg(data)   (*((volatile unsigned int*) SE_IDLE_0_reg)=data)
+#define set_SE_IDLE_1_reg(data)   (*((volatile unsigned int*) SE_IDLE_1_reg)=data)
+#define set_SE_IDLE_2_reg(data)   (*((volatile unsigned int*) SE_IDLE_2_reg)=data)
+#define get_SE_IDLE_0_reg   (*((volatile unsigned int*) SE_IDLE_0_reg))
+#define get_SE_IDLE_1_reg   (*((volatile unsigned int*) SE_IDLE_1_reg))
+#define get_SE_IDLE_2_reg   (*((volatile unsigned int*) SE_IDLE_2_reg))
+#define SE_IDLE_0_inst_adr                                                           "0x0019"
+#define SE_IDLE_1_inst_adr                                                           "0x001A"
+#define SE_IDLE_2_inst_adr                                                           "0x001B"
+#define SE_IDLE_0_inst                                                               0x0019
+#define SE_IDLE_1_inst                                                               0x001A
+#define SE_IDLE_2_inst                                                               0x001B
+#define SE_IDLE_idle_shift                                                           (0)
+#define SE_IDLE_idle_mask                                                            (0x00000001)
+#define SE_IDLE_idle(data)                                                           (0x00000001&((data)<<0))
+#define SE_IDLE_idle_src(data)                                                       ((0x00000001&(data))>>0)
+#define SE_IDLE_get_idle(data)                                                       ((0x00000001&(data))>>0)
+
+
+#define SE_INTSEL                                                                    0x1800C470
+#define SE_INTSEL_reg_addr                                                           "0xB800C470"
+#define SE_INTSEL_reg                                                                0xB800C470
+#define set_SE_INTSEL_reg(data)   (*((volatile unsigned int*) SE_INTSEL_reg)=data)
+#define get_SE_INTSEL_reg   (*((volatile unsigned int*) SE_INTSEL_reg))
+#define SE_INTSEL_inst_adr                                                           "0x001C"
+#define SE_INTSEL_inst                                                               0x001C
+#define SE_INTSEL_sel3_shift                                                         (2)
+#define SE_INTSEL_sel3_mask                                                          (0x00000004)
+#define SE_INTSEL_sel3(data)                                                         (0x00000004&((data)<<2))
+#define SE_INTSEL_sel3_src(data)                                                     ((0x00000004&(data))>>2)
+#define SE_INTSEL_get_sel3(data)                                                     ((0x00000004&(data))>>2)
+#define SE_INTSEL_sel2_shift                                                         (1)
+#define SE_INTSEL_sel2_mask                                                          (0x00000002)
+#define SE_INTSEL_sel2(data)                                                         (0x00000002&((data)<<1))
+#define SE_INTSEL_sel2_src(data)                                                     ((0x00000002&(data))>>1)
+#define SE_INTSEL_get_sel2(data)                                                     ((0x00000002&(data))>>1)
+#define SE_INTSEL_sel1_shift                                                         (0)
+#define SE_INTSEL_sel1_mask                                                          (0x00000001)
+#define SE_INTSEL_sel1(data)                                                         (0x00000001&((data)<<0))
+#define SE_INTSEL_sel1_src(data)                                                     ((0x00000001&(data))>>0)
+#define SE_INTSEL_get_sel1(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define SE_INTS_0                                                                    0x1800C474
+#define SE_INTS_1                                                                    0x1800C478
+#define SE_INTS_2                                                                    0x1800C47C
+#define SE_INTS_0_reg_addr                                                           "0xB800C474"
+#define SE_INTS_1_reg_addr                                                           "0xB800C478"
+#define SE_INTS_2_reg_addr                                                           "0xB800C47C"
+#define SE_INTS_0_reg                                                                0xB800C474
+#define SE_INTS_1_reg                                                                0xB800C478
+#define SE_INTS_2_reg                                                                0xB800C47C
+#define set_SE_INTS_0_reg(data)   (*((volatile unsigned int*) SE_INTS_0_reg)=data)
+#define set_SE_INTS_1_reg(data)   (*((volatile unsigned int*) SE_INTS_1_reg)=data)
+#define set_SE_INTS_2_reg(data)   (*((volatile unsigned int*) SE_INTS_2_reg)=data)
+#define get_SE_INTS_0_reg   (*((volatile unsigned int*) SE_INTS_0_reg))
+#define get_SE_INTS_1_reg   (*((volatile unsigned int*) SE_INTS_1_reg))
+#define get_SE_INTS_2_reg   (*((volatile unsigned int*) SE_INTS_2_reg))
+#define SE_INTS_0_inst_adr                                                           "0x001D"
+#define SE_INTS_1_inst_adr                                                           "0x001E"
+#define SE_INTS_2_inst_adr                                                           "0x001F"
+#define SE_INTS_0_inst                                                               0x001D
+#define SE_INTS_1_inst                                                               0x001E
+#define SE_INTS_2_inst                                                               0x001F
+#define SE_INTS_vo_sync_err_shift                                                    (17)
+#define SE_INTS_vo_sync_err_mask                                                     (0x00020000)
+#define SE_INTS_vo_sync_err(data)                                                    (0x00020000&((data)<<17))
+#define SE_INTS_vo_sync_err_src(data)                                                ((0x00020000&(data))>>17)
+#define SE_INTS_get_vo_sync_err(data)                                                ((0x00020000&(data))>>17)
+#define SE_INTS_fmt_err_shift                                                        (16)
+#define SE_INTS_fmt_err_mask                                                         (0x00010000)
+#define SE_INTS_fmt_err(data)                                                        (0x00010000&((data)<<16))
+#define SE_INTS_fmt_err_src(data)                                                    ((0x00010000&(data))>>16)
+#define SE_INTS_get_fmt_err(data)                                                    ((0x00010000&(data))>>16)
+#define SE_INTS_com_empty_shift                                                      (3)
+#define SE_INTS_com_empty_mask                                                       (0x00000008)
+#define SE_INTS_com_empty(data)                                                      (0x00000008&((data)<<3))
+#define SE_INTS_com_empty_src(data)                                                  ((0x00000008&(data))>>3)
+#define SE_INTS_get_com_empty(data)                                                  ((0x00000008&(data))>>3)
+#define SE_INTS_com_err_shift                                                        (2)
+#define SE_INTS_com_err_mask                                                         (0x00000004)
+#define SE_INTS_com_err(data)                                                        (0x00000004&((data)<<2))
+#define SE_INTS_com_err_src(data)                                                    ((0x00000004&(data))>>2)
+#define SE_INTS_get_com_err(data)                                                    ((0x00000004&(data))>>2)
+#define SE_INTS_sync_shift                                                           (1)
+#define SE_INTS_sync_mask                                                            (0x00000002)
+#define SE_INTS_sync(data)                                                           (0x00000002&((data)<<1))
+#define SE_INTS_sync_src(data)                                                       ((0x00000002&(data))>>1)
+#define SE_INTS_get_sync(data)                                                       ((0x00000002&(data))>>1)
+#define SE_INTS_write_data_shift                                                     (0)
+#define SE_INTS_write_data_mask                                                      (0x00000001)
+#define SE_INTS_write_data(data)                                                     (0x00000001&((data)<<0))
+#define SE_INTS_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define SE_INTS_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define SE_INTE_0                                                                    0x1800C480
+#define SE_INTE_1                                                                    0x1800C484
+#define SE_INTE_2                                                                    0x1800C488
+#define SE_INTE_0_reg_addr                                                           "0xB800C480"
+#define SE_INTE_1_reg_addr                                                           "0xB800C484"
+#define SE_INTE_2_reg_addr                                                           "0xB800C488"
+#define SE_INTE_0_reg                                                                0xB800C480
+#define SE_INTE_1_reg                                                                0xB800C484
+#define SE_INTE_2_reg                                                                0xB800C488
+#define set_SE_INTE_0_reg(data)   (*((volatile unsigned int*) SE_INTE_0_reg)=data)
+#define set_SE_INTE_1_reg(data)   (*((volatile unsigned int*) SE_INTE_1_reg)=data)
+#define set_SE_INTE_2_reg(data)   (*((volatile unsigned int*) SE_INTE_2_reg)=data)
+#define get_SE_INTE_0_reg   (*((volatile unsigned int*) SE_INTE_0_reg))
+#define get_SE_INTE_1_reg   (*((volatile unsigned int*) SE_INTE_1_reg))
+#define get_SE_INTE_2_reg   (*((volatile unsigned int*) SE_INTE_2_reg))
+#define SE_INTE_0_inst_adr                                                           "0x0020"
+#define SE_INTE_1_inst_adr                                                           "0x0021"
+#define SE_INTE_2_inst_adr                                                           "0x0022"
+#define SE_INTE_0_inst                                                               0x0020
+#define SE_INTE_1_inst                                                               0x0021
+#define SE_INTE_2_inst                                                               0x0022
+#define SE_INTE_vo_sync_err_shift                                                    (17)
+#define SE_INTE_vo_sync_err_mask                                                     (0x00020000)
+#define SE_INTE_vo_sync_err(data)                                                    (0x00020000&((data)<<17))
+#define SE_INTE_vo_sync_err_src(data)                                                ((0x00020000&(data))>>17)
+#define SE_INTE_get_vo_sync_err(data)                                                ((0x00020000&(data))>>17)
+#define SE_INTE_fmt_err_shift                                                        (16)
+#define SE_INTE_fmt_err_mask                                                         (0x00010000)
+#define SE_INTE_fmt_err(data)                                                        (0x00010000&((data)<<16))
+#define SE_INTE_fmt_err_src(data)                                                    ((0x00010000&(data))>>16)
+#define SE_INTE_get_fmt_err(data)                                                    ((0x00010000&(data))>>16)
+#define SE_INTE_com_empty_shift                                                      (3)
+#define SE_INTE_com_empty_mask                                                       (0x00000008)
+#define SE_INTE_com_empty(data)                                                      (0x00000008&((data)<<3))
+#define SE_INTE_com_empty_src(data)                                                  ((0x00000008&(data))>>3)
+#define SE_INTE_get_com_empty(data)                                                  ((0x00000008&(data))>>3)
+#define SE_INTE_com_err_shift                                                        (2)
+#define SE_INTE_com_err_mask                                                         (0x00000004)
+#define SE_INTE_com_err(data)                                                        (0x00000004&((data)<<2))
+#define SE_INTE_com_err_src(data)                                                    ((0x00000004&(data))>>2)
+#define SE_INTE_get_com_err(data)                                                    ((0x00000004&(data))>>2)
+#define SE_INTE_sync_shift                                                           (1)
+#define SE_INTE_sync_mask                                                            (0x00000002)
+#define SE_INTE_sync(data)                                                           (0x00000002&((data)<<1))
+#define SE_INTE_sync_src(data)                                                       ((0x00000002&(data))>>1)
+#define SE_INTE_get_sync(data)                                                       ((0x00000002&(data))>>1)
+#define SE_INTE_write_data_shift                                                     (0)
+#define SE_INTE_write_data_mask                                                      (0x00000001)
+#define SE_INTE_write_data(data)                                                     (0x00000001&((data)<<0))
+#define SE_INTE_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define SE_INTE_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define SE_INSTCNT_L_0                                                               0x1800C48C
+#define SE_INSTCNT_L_1                                                               0x1800C490
+#define SE_INSTCNT_L_2                                                               0x1800C494
+#define SE_INSTCNT_L_0_reg_addr                                                      "0xB800C48C"
+#define SE_INSTCNT_L_1_reg_addr                                                      "0xB800C490"
+#define SE_INSTCNT_L_2_reg_addr                                                      "0xB800C494"
+#define SE_INSTCNT_L_0_reg                                                           0xB800C48C
+#define SE_INSTCNT_L_1_reg                                                           0xB800C490
+#define SE_INSTCNT_L_2_reg                                                           0xB800C494
+#define set_SE_INSTCNT_L_0_reg(data)   (*((volatile unsigned int*) SE_INSTCNT_L_0_reg)=data)
+#define set_SE_INSTCNT_L_1_reg(data)   (*((volatile unsigned int*) SE_INSTCNT_L_1_reg)=data)
+#define set_SE_INSTCNT_L_2_reg(data)   (*((volatile unsigned int*) SE_INSTCNT_L_2_reg)=data)
+#define get_SE_INSTCNT_L_0_reg   (*((volatile unsigned int*) SE_INSTCNT_L_0_reg))
+#define get_SE_INSTCNT_L_1_reg   (*((volatile unsigned int*) SE_INSTCNT_L_1_reg))
+#define get_SE_INSTCNT_L_2_reg   (*((volatile unsigned int*) SE_INSTCNT_L_2_reg))
+#define SE_INSTCNT_L_0_inst_adr                                                      "0x0023"
+#define SE_INSTCNT_L_1_inst_adr                                                      "0x0024"
+#define SE_INSTCNT_L_2_inst_adr                                                      "0x0025"
+#define SE_INSTCNT_L_0_inst                                                          0x0023
+#define SE_INSTCNT_L_1_inst                                                          0x0024
+#define SE_INSTCNT_L_2_inst                                                          0x0025
+#define SE_INSTCNT_L_instcnt_l_shift                                                 (0)
+#define SE_INSTCNT_L_instcnt_l_mask                                                  (0xFFFFFFFF)
+#define SE_INSTCNT_L_instcnt_l(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SE_INSTCNT_L_instcnt_l_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SE_INSTCNT_L_get_instcnt_l(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SE_INSTCNT_H_0                                                               0x1800C510
+#define SE_INSTCNT_H_1                                                               0x1800C514
+#define SE_INSTCNT_H_2                                                               0x1800C518
+#define SE_INSTCNT_H_0_reg_addr                                                      "0xB800C510"
+#define SE_INSTCNT_H_1_reg_addr                                                      "0xB800C514"
+#define SE_INSTCNT_H_2_reg_addr                                                      "0xB800C518"
+#define SE_INSTCNT_H_0_reg                                                           0xB800C510
+#define SE_INSTCNT_H_1_reg                                                           0xB800C514
+#define SE_INSTCNT_H_2_reg                                                           0xB800C518
+#define set_SE_INSTCNT_H_0_reg(data)   (*((volatile unsigned int*) SE_INSTCNT_H_0_reg)=data)
+#define set_SE_INSTCNT_H_1_reg(data)   (*((volatile unsigned int*) SE_INSTCNT_H_1_reg)=data)
+#define set_SE_INSTCNT_H_2_reg(data)   (*((volatile unsigned int*) SE_INSTCNT_H_2_reg)=data)
+#define get_SE_INSTCNT_H_0_reg   (*((volatile unsigned int*) SE_INSTCNT_H_0_reg))
+#define get_SE_INSTCNT_H_1_reg   (*((volatile unsigned int*) SE_INSTCNT_H_1_reg))
+#define get_SE_INSTCNT_H_2_reg   (*((volatile unsigned int*) SE_INSTCNT_H_2_reg))
+#define SE_INSTCNT_H_0_inst_adr                                                      "0x0044"
+#define SE_INSTCNT_H_1_inst_adr                                                      "0x0045"
+#define SE_INSTCNT_H_2_inst_adr                                                      "0x0046"
+#define SE_INSTCNT_H_0_inst                                                          0x0044
+#define SE_INSTCNT_H_1_inst                                                          0x0045
+#define SE_INSTCNT_H_2_inst                                                          0x0046
+#define SE_INSTCNT_H_instcnt_h_shift                                                 (0)
+#define SE_INSTCNT_H_instcnt_h_mask                                                  (0xFFFFFFFF)
+#define SE_INSTCNT_H_instcnt_h(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define SE_INSTCNT_H_instcnt_h_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define SE_INSTCNT_H_get_instcnt_h(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define SE_CLUT_RADR                                                                 0x1800C498
+#define SE_CLUT_RADR_reg_addr                                                        "0xB800C498"
+#define SE_CLUT_RADR_reg                                                             0xB800C498
+#define set_SE_CLUT_RADR_reg(data)   (*((volatile unsigned int*) SE_CLUT_RADR_reg)=data)
+#define get_SE_CLUT_RADR_reg   (*((volatile unsigned int*) SE_CLUT_RADR_reg))
+#define SE_CLUT_RADR_inst_adr                                                        "0x0026"
+#define SE_CLUT_RADR_inst                                                            0x0026
+#define SE_CLUT_RADR_radr_shift                                                      (0)
+#define SE_CLUT_RADR_radr_mask                                                       (0x000000FF)
+#define SE_CLUT_RADR_radr(data)                                                      (0x000000FF&((data)<<0))
+#define SE_CLUT_RADR_radr_src(data)                                                  ((0x000000FF&(data))>>0)
+#define SE_CLUT_RADR_get_radr(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define SE_CLUT_VALUE                                                                0x1800C49C
+#define SE_CLUT_VALUE_reg_addr                                                       "0xB800C49C"
+#define SE_CLUT_VALUE_reg                                                            0xB800C49C
+#define set_SE_CLUT_VALUE_reg(data)   (*((volatile unsigned int*) SE_CLUT_VALUE_reg)=data)
+#define get_SE_CLUT_VALUE_reg   (*((volatile unsigned int*) SE_CLUT_VALUE_reg))
+#define SE_CLUT_VALUE_inst_adr                                                       "0x0027"
+#define SE_CLUT_VALUE_inst                                                           0x0027
+#define SE_CLUT_VALUE_value_shift                                                    (0)
+#define SE_CLUT_VALUE_value_mask                                                     (0xFFFFFFFF)
+#define SE_CLUT_VALUE_value(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define SE_CLUT_VALUE_value_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define SE_CLUT_VALUE_get_value(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define SE_DBG                                                                       0x1800C4A0
+#define SE_DBG_reg_addr                                                              "0xB800C4A0"
+#define SE_DBG_reg                                                                   0xB800C4A0
+#define set_SE_DBG_reg(data)   (*((volatile unsigned int*) SE_DBG_reg)=data)
+#define get_SE_DBG_reg   (*((volatile unsigned int*) SE_DBG_reg))
+#define SE_DBG_inst_adr                                                              "0x0028"
+#define SE_DBG_inst                                                                  0x0028
+#define SE_DBG_dbg_en_shift                                                          (24)
+#define SE_DBG_dbg_en_mask                                                           (0x01000000)
+#define SE_DBG_dbg_en(data)                                                          (0x01000000&((data)<<24))
+#define SE_DBG_dbg_en_src(data)                                                      ((0x01000000&(data))>>24)
+#define SE_DBG_get_dbg_en(data)                                                      ((0x01000000&(data))>>24)
+#define SE_DBG_dbg_module_sel1_shift                                                 (20)
+#define SE_DBG_dbg_module_sel1_mask                                                  (0x00F00000)
+#define SE_DBG_dbg_module_sel1(data)                                                 (0x00F00000&((data)<<20))
+#define SE_DBG_dbg_module_sel1_src(data)                                             ((0x00F00000&(data))>>20)
+#define SE_DBG_get_dbg_module_sel1(data)                                             ((0x00F00000&(data))>>20)
+#define SE_DBG_dbg_module_sel0_shift                                                 (16)
+#define SE_DBG_dbg_module_sel0_mask                                                  (0x000F0000)
+#define SE_DBG_dbg_module_sel0(data)                                                 (0x000F0000&((data)<<16))
+#define SE_DBG_dbg_module_sel0_src(data)                                             ((0x000F0000&(data))>>16)
+#define SE_DBG_get_dbg_module_sel0(data)                                             ((0x000F0000&(data))>>16)
+#define SE_DBG_dbg_sel1_shift                                                        (8)
+#define SE_DBG_dbg_sel1_mask                                                         (0x00001F00)
+#define SE_DBG_dbg_sel1(data)                                                        (0x00001F00&((data)<<8))
+#define SE_DBG_dbg_sel1_src(data)                                                    ((0x00001F00&(data))>>8)
+#define SE_DBG_get_dbg_sel1(data)                                                    ((0x00001F00&(data))>>8)
+#define SE_DBG_dbg_sel0_shift                                                        (0)
+#define SE_DBG_dbg_sel0_mask                                                         (0x0000001F)
+#define SE_DBG_dbg_sel0(data)                                                        (0x0000001F&((data)<<0))
+#define SE_DBG_dbg_sel0_src(data)                                                    ((0x0000001F&(data))>>0)
+#define SE_DBG_get_dbg_sel0(data)                                                    ((0x0000001F&(data))>>0)
+
+
+#define SE_SCTCH                                                                     0x1800C4A4
+#define SE_SCTCH_reg_addr                                                            "0xB800C4A4"
+#define SE_SCTCH_reg                                                                 0xB800C4A4
+#define set_SE_SCTCH_reg(data)   (*((volatile unsigned int*) SE_SCTCH_reg)=data)
+#define get_SE_SCTCH_reg   (*((volatile unsigned int*) SE_SCTCH_reg))
+#define SE_SCTCH_inst_adr                                                            "0x0029"
+#define SE_SCTCH_inst                                                                0x0029
+#define SE_SCTCH_Reg1_shift                                                          (16)
+#define SE_SCTCH_Reg1_mask                                                           (0xFFFF0000)
+#define SE_SCTCH_Reg1(data)                                                          (0xFFFF0000&((data)<<16))
+#define SE_SCTCH_Reg1_src(data)                                                      ((0xFFFF0000&(data))>>16)
+#define SE_SCTCH_get_Reg1(data)                                                      ((0xFFFF0000&(data))>>16)
+#define SE_SCTCH_Reg0_shift                                                          (0)
+#define SE_SCTCH_Reg0_mask                                                           (0x0000FFFF)
+#define SE_SCTCH_Reg0(data)                                                          (0x0000FFFF&((data)<<0))
+#define SE_SCTCH_Reg0_src(data)                                                      ((0x0000FFFF&(data))>>0)
+#define SE_SCTCH_get_Reg0(data)                                                      ((0x0000FFFF&(data))>>0)
+
+
+#define SE_GCRA_CTRL                                                                 0x1800C4A8
+#define SE_GCRA_CTRL_reg_addr                                                        "0xB800C4A8"
+#define SE_GCRA_CTRL_reg                                                             0xB800C4A8
+#define set_SE_GCRA_CTRL_reg(data)   (*((volatile unsigned int*) SE_GCRA_CTRL_reg)=data)
+#define get_SE_GCRA_CTRL_reg   (*((volatile unsigned int*) SE_GCRA_CTRL_reg))
+#define SE_GCRA_CTRL_inst_adr                                                        "0x002A"
+#define SE_GCRA_CTRL_inst                                                            0x002A
+#define SE_GCRA_CTRL_Gcra_en_shift                                                   (0)
+#define SE_GCRA_CTRL_Gcra_en_mask                                                    (0x00000001)
+#define SE_GCRA_CTRL_Gcra_en(data)                                                   (0x00000001&((data)<<0))
+#define SE_GCRA_CTRL_Gcra_en_src(data)                                               ((0x00000001&(data))>>0)
+#define SE_GCRA_CTRL_get_Gcra_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SE_GCRA_REQ_CNT                                                              0x1800C4AC
+#define SE_GCRA_REQ_CNT_reg_addr                                                     "0xB800C4AC"
+#define SE_GCRA_REQ_CNT_reg                                                          0xB800C4AC
+#define set_SE_GCRA_REQ_CNT_reg(data)   (*((volatile unsigned int*) SE_GCRA_REQ_CNT_reg)=data)
+#define get_SE_GCRA_REQ_CNT_reg   (*((volatile unsigned int*) SE_GCRA_REQ_CNT_reg))
+#define SE_GCRA_REQ_CNT_inst_adr                                                     "0x002B"
+#define SE_GCRA_REQ_CNT_inst                                                         0x002B
+#define SE_GCRA_REQ_CNT_Gcra_req_num_shift                                           (0)
+#define SE_GCRA_REQ_CNT_Gcra_req_num_mask                                            (0x00FFFFFF)
+#define SE_GCRA_REQ_CNT_Gcra_req_num(data)                                           (0x00FFFFFF&((data)<<0))
+#define SE_GCRA_REQ_CNT_Gcra_req_num_src(data)                                       ((0x00FFFFFF&(data))>>0)
+#define SE_GCRA_REQ_CNT_get_Gcra_req_num(data)                                       ((0x00FFFFFF&(data))>>0)
+
+
+#define SE_GCRA_TIM_CNT                                                              0x1800C4B0
+#define SE_GCRA_TIM_CNT_reg_addr                                                     "0xB800C4B0"
+#define SE_GCRA_TIM_CNT_reg                                                          0xB800C4B0
+#define set_SE_GCRA_TIM_CNT_reg(data)   (*((volatile unsigned int*) SE_GCRA_TIM_CNT_reg)=data)
+#define get_SE_GCRA_TIM_CNT_reg   (*((volatile unsigned int*) SE_GCRA_TIM_CNT_reg))
+#define SE_GCRA_TIM_CNT_inst_adr                                                     "0x002C"
+#define SE_GCRA_TIM_CNT_inst                                                         0x002C
+#define SE_GCRA_TIM_CNT_Gcra_tim_cnt_shift                                           (0)
+#define SE_GCRA_TIM_CNT_Gcra_tim_cnt_mask                                            (0xFFFFFFFF)
+#define SE_GCRA_TIM_CNT_Gcra_tim_cnt(data)                                           (0xFFFFFFFF&((data)<<0))
+#define SE_GCRA_TIM_CNT_Gcra_tim_cnt_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define SE_GCRA_TIM_CNT_get_Gcra_tim_cnt(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define SE_GCRA_TIM_THR                                                              0x1800C4B4
+#define SE_GCRA_TIM_THR_reg_addr                                                     "0xB800C4B4"
+#define SE_GCRA_TIM_THR_reg                                                          0xB800C4B4
+#define set_SE_GCRA_TIM_THR_reg(data)   (*((volatile unsigned int*) SE_GCRA_TIM_THR_reg)=data)
+#define get_SE_GCRA_TIM_THR_reg   (*((volatile unsigned int*) SE_GCRA_TIM_THR_reg))
+#define SE_GCRA_TIM_THR_inst_adr                                                     "0x002D"
+#define SE_GCRA_TIM_THR_inst                                                         0x002D
+#define SE_GCRA_TIM_THR_Gcra_tim_thr_shift                                           (0)
+#define SE_GCRA_TIM_THR_Gcra_tim_thr_mask                                            (0xFFFFFFFF)
+#define SE_GCRA_TIM_THR_Gcra_tim_thr(data)                                           (0xFFFFFFFF&((data)<<0))
+#define SE_GCRA_TIM_THR_Gcra_tim_thr_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define SE_GCRA_TIM_THR_get_Gcra_tim_thr(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define SE_GCRA_REQ_THR                                                              0x1800C4B8
+#define SE_GCRA_REQ_THR_reg_addr                                                     "0xB800C4B8"
+#define SE_GCRA_REQ_THR_reg                                                          0xB800C4B8
+#define set_SE_GCRA_REQ_THR_reg(data)   (*((volatile unsigned int*) SE_GCRA_REQ_THR_reg)=data)
+#define get_SE_GCRA_REQ_THR_reg   (*((volatile unsigned int*) SE_GCRA_REQ_THR_reg))
+#define SE_GCRA_REQ_THR_inst_adr                                                     "0x002E"
+#define SE_GCRA_REQ_THR_inst                                                         0x002E
+#define SE_GCRA_REQ_THR_Gcra_req_thr_shift                                           (0)
+#define SE_GCRA_REQ_THR_Gcra_req_thr_mask                                            (0x00FFFFFF)
+#define SE_GCRA_REQ_THR_Gcra_req_thr(data)                                           (0x00FFFFFF&((data)<<0))
+#define SE_GCRA_REQ_THR_Gcra_req_thr_src(data)                                       ((0x00FFFFFF&(data))>>0)
+#define SE_GCRA_REQ_THR_get_Gcra_req_thr(data)                                       ((0x00FFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/sp_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sp_reg.h
new file mode 100644
index 00000000..ccca4c1
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/sp_reg.h
@@ -0,0 +1,123 @@
+// This file is generated using the spec version 0.9, firmware template version 1.38and DVR_Parser_0.3
+#ifndef _SP_REG_H_INCLUDED_
+#define _SP_REG_H_INCLUDED_
+
+//#define  _SP_USE_STRUCT
+#ifdef _SP_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    reserved_0:28;
+    unsigned int    m3_run:1;
+    unsigned int    m3_sel:4;
+    unsigned int    reserved_1:3;
+    unsigned int    m2_run:1;
+    unsigned int    m2_sel:4;
+    unsigned int    reserved_2:3;
+    unsigned int    m1_run:1;
+    unsigned int    m1_sel:4;
+    unsigned int    reserved_3:3;
+    unsigned int    m0_run:1;
+    unsigned int    m0_sel:4;
+}sp_PM_CNTL;
+
+typedef struct
+{
+    unsigned int    cnt_lo:32;
+}sp_PM_CNT_LO;
+
+typedef struct
+{
+    unsigned int    reserved_0:0;
+    unsigned int    cnt_hi:16;
+}sp_PM_CNT_HI;
+#endif
+
+#define SP_PM_CNTL                                                    0x18003000
+#define SP_PM_CNTL_reg_addr                                           "0xB8003000"
+#define SP_PM_CNTL_reg                                                0xB8003000
+#define SP_PM_CNTL_inst_addr                                          "0x0000"
+#define SP_PM_CNTL_inst                                               0x0000
+#define SP_PM_CNTL_m3_run_shift                                       (28)
+#define SP_PM_CNTL_m3_sel_shift                                       (24)
+#define SP_PM_CNTL_m2_run_shift                                       (20)
+#define SP_PM_CNTL_m2_sel_shift                                       (16)
+#define SP_PM_CNTL_m1_run_shift                                       (12)
+#define SP_PM_CNTL_m1_sel_shift                                       (8)
+#define SP_PM_CNTL_m0_run_shift                                       (4)
+#define SP_PM_CNTL_m0_sel_shift                                       (0)
+#define SP_PM_CNTL_m3_run_mask                                        (0x10000000)
+#define SP_PM_CNTL_m3_sel_mask                                        (0x0F000000)
+#define SP_PM_CNTL_m2_run_mask                                        (0x00100000)
+#define SP_PM_CNTL_m2_sel_mask                                        (0x000F0000)
+#define SP_PM_CNTL_m1_run_mask                                        (0x00001000)
+#define SP_PM_CNTL_m1_sel_mask                                        (0x00000F00)
+#define SP_PM_CNTL_m0_run_mask                                        (0x00000010)
+#define SP_PM_CNTL_m0_sel_mask                                        (0x0000000F)
+#define SP_PM_CNTL_m3_run(data)                                       (0x10000000&((data)<<28))
+#define SP_PM_CNTL_m3_sel(data)                                       (0x0F000000&((data)<<24))
+#define SP_PM_CNTL_m2_run(data)                                       (0x00100000&((data)<<20))
+#define SP_PM_CNTL_m2_sel(data)                                       (0x000F0000&((data)<<16))
+#define SP_PM_CNTL_m1_run(data)                                       (0x00001000&((data)<<12))
+#define SP_PM_CNTL_m1_sel(data)                                       (0x00000F00&((data)<<8))
+#define SP_PM_CNTL_m0_run(data)                                       (0x00000010&((data)<<4))
+#define SP_PM_CNTL_m0_sel(data)                                       (0x0000000F&(data))
+#define SP_PM_CNTL_get_m3_run(data)                                   ((0x10000000&(data))>>28)
+#define SP_PM_CNTL_get_m3_sel(data)                                   ((0x0F000000&(data))>>24)
+#define SP_PM_CNTL_get_m2_run(data)                                   ((0x00100000&(data))>>20)
+#define SP_PM_CNTL_get_m2_sel(data)                                   ((0x000F0000&(data))>>16)
+#define SP_PM_CNTL_get_m1_run(data)                                   ((0x00001000&(data))>>12)
+#define SP_PM_CNTL_get_m1_sel(data)                                   ((0x00000F00&(data))>>8)
+#define SP_PM_CNTL_get_m0_run(data)                                   ((0x00000010&(data))>>4)
+#define SP_PM_CNTL_get_m0_sel(data)                                   (0x0000000F&(data))
+
+#define SP_PM_CNT_LO_0                                                0x18003008
+#define SP_PM_CNT_LO_1                                                0x18003010
+#define SP_PM_CNT_LO_2                                                0x18003018
+#define SP_PM_CNT_LO_3                                                0x18003020
+#define SP_PM_CNT_LO_0_reg_addr                                       "0xB8003008"
+#define SP_PM_CNT_LO_1_reg_addr                                       "0xB8003010"
+#define SP_PM_CNT_LO_2_reg_addr                                       "0xB8003018"
+#define SP_PM_CNT_LO_3_reg_addr                                       "0xB8003020"
+#define SP_PM_CNT_LO_0_reg                                            0xB8003008
+#define SP_PM_CNT_LO_1_reg                                            0xB8003010
+#define SP_PM_CNT_LO_2_reg                                            0xB8003018
+#define SP_PM_CNT_LO_3_reg                                            0xB8003020
+#define SP_PM_CNT_LO_0_inst_addr                                      "0x0002"
+#define SP_PM_CNT_LO_0_inst                                           0x0002
+#define SP_PM_CNT_LO_1_inst_addr                                      "0x0004"
+#define SP_PM_CNT_LO_1_inst                                           0x0004
+#define SP_PM_CNT_LO_2_inst_addr                                      "0x0006"
+#define SP_PM_CNT_LO_2_inst                                           0x0006
+#define SP_PM_CNT_LO_3_inst_addr                                      "0x0008"
+#define SP_PM_CNT_LO_3_inst                                           0x0008
+#define SP_PM_CNT_LO_cnt_lo_shift                                     (0)
+#define SP_PM_CNT_LO_cnt_lo_mask                                      (0xFFFFFFFF)
+#define SP_PM_CNT_LO_cnt_lo(data)                                     (0xFFFFFFFF&(data))
+#define SP_PM_CNT_LO_get_cnt_lo(data)                                 (0xFFFFFFFF&(data))
+
+#define SP_PM_CNT_HI_0                                                0x1800300C
+#define SP_PM_CNT_HI_1                                                0x18003014
+#define SP_PM_CNT_HI_2                                                0x1800301C
+#define SP_PM_CNT_HI_3                                                0x18003024
+#define SP_PM_CNT_HI_0_reg_addr                                       "0xB800300C"
+#define SP_PM_CNT_HI_1_reg_addr                                       "0xB8003014"
+#define SP_PM_CNT_HI_2_reg_addr                                       "0xB800301C"
+#define SP_PM_CNT_HI_3_reg_addr                                       "0xB8003024"
+#define SP_PM_CNT_HI_0_reg                                            0xB800300C
+#define SP_PM_CNT_HI_1_reg                                            0xB8003014
+#define SP_PM_CNT_HI_2_reg                                            0xB800301C
+#define SP_PM_CNT_HI_3_reg                                            0xB8003024
+#define SP_PM_CNT_HI_0_inst_addr                                      "0x0003"
+#define SP_PM_CNT_HI_0_inst                                           0x0003
+#define SP_PM_CNT_HI_1_inst_addr                                      "0x0005"
+#define SP_PM_CNT_HI_1_inst                                           0x0005
+#define SP_PM_CNT_HI_2_inst_addr                                      "0x0007"
+#define SP_PM_CNT_HI_2_inst                                           0x0007
+#define SP_PM_CNT_HI_3_inst_addr                                      "0x0009"
+#define SP_PM_CNT_HI_3_inst                                           0x0009
+#define SP_PM_CNT_HI_cnt_hi_shift                                     (0)
+#define SP_PM_CNT_HI_cnt_hi_mask                                      (0x0000FFFF)
+#define SP_PM_CNT_HI_cnt_hi(data)                                     (0x0000FFFF&(data))
+#define SP_PM_CNT_HI_get_cnt_hi(data)                                 (0x0000FFFF&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/system.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/system.h
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/tp_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/tp_reg.h
new file mode 100644
index 00000000..19d88f2
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/tp_reg.h
@@ -0,0 +1,4072 @@
+/**************************************************************
+// Spec Version                  : 1.0
+// Parser Version                : DVR_Parser_6.5
+// CModelGen Version             : 5.0 2009.04.09
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/7/15 20:28:43
+***************************************************************/
+
+
+#ifndef _TP_REG_H_INCLUDED_
+#define _TP_REG_H_INCLUDED_
+#ifdef  _TP_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     tp_err_fix_en:1;
+unsigned int     strm_id_en:1;
+unsigned int     buf_rdy_ctl:1;
+unsigned int     psc_en:1;
+unsigned int     pes_en:1;
+unsigned int     tsc_en:1;
+unsigned int     tb:1;
+unsigned int     busy:1;
+unsigned int     mode:1;
+unsigned int     du_en:1;
+unsigned int     de_en:1;
+unsigned int     xt_en:1;
+unsigned int     pid_en:1;
+unsigned int     null_en:1;
+unsigned int     trerr_en:1;
+unsigned int     sync_en:1;
+unsigned int     rst_en:1;
+unsigned int     write_data:1;
+}TP_TF0_CNTL;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF0_STRM_ID_0;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF0_STRM_ID_1;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF0_STRM_ID_2;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF0_STRM_ID_3;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     val_set33:1;
+unsigned int     val_set32:1;
+unsigned int     val_set31:1;
+unsigned int     val_set30:1;
+unsigned int     val_set23:1;
+unsigned int     val_set22:1;
+unsigned int     val_set21:1;
+unsigned int     val_set20:1;
+unsigned int     val_set13:1;
+unsigned int     val_set12:1;
+unsigned int     val_set11:1;
+unsigned int     val_set10:1;
+unsigned int     val_set03:1;
+unsigned int     val_set02:1;
+unsigned int     val_set01:1;
+unsigned int     val_set00:1;
+}TP_TF0_STRM_VAL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     cnt:24;
+}TP_TF0_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     drp_cnt:16;
+}TP_TF0_DRP_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     err_cnt:16;
+}TP_TF0_ERR_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     tp_err_fix_en:1;
+unsigned int     strm_id_en:1;
+unsigned int     buf_rdy_ctl:1;
+unsigned int     psc_en:1;
+unsigned int     pes_en:1;
+unsigned int     tsc_en:1;
+unsigned int     tb:1;
+unsigned int     busy:1;
+unsigned int     mode:1;
+unsigned int     du_en:1;
+unsigned int     de_en:1;
+unsigned int     xt_en:1;
+unsigned int     pid_en:1;
+unsigned int     null_en:1;
+unsigned int     trerr_en:1;
+unsigned int     sync_en:1;
+unsigned int     rst_en:1;
+unsigned int     write_data:1;
+}TP_TF1_CNTL;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF1_STRM_ID_0;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF1_STRM_ID_1;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF1_STRM_ID_2;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF1_STRM_ID_3;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     val_set33:1;
+unsigned int     val_set32:1;
+unsigned int     val_set31:1;
+unsigned int     val_set30:1;
+unsigned int     val_set23:1;
+unsigned int     val_set22:1;
+unsigned int     val_set21:1;
+unsigned int     val_set20:1;
+unsigned int     val_set13:1;
+unsigned int     val_set12:1;
+unsigned int     val_set11:1;
+unsigned int     val_set10:1;
+unsigned int     val_set03:1;
+unsigned int     val_set02:1;
+unsigned int     val_set01:1;
+unsigned int     val_set00:1;
+}TP_TF1_STRM_VAL;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     tp_err_fix_en:1;
+unsigned int     strm_id_en:1;
+unsigned int     buf_rdy_ctl:1;
+unsigned int     psc_en:1;
+unsigned int     pes_en:1;
+unsigned int     tsc_en:1;
+unsigned int     tb:1;
+unsigned int     busy:1;
+unsigned int     mode:1;
+unsigned int     du_en:1;
+unsigned int     de_en:1;
+unsigned int     xt_en:1;
+unsigned int     pid_en:1;
+unsigned int     null_en:1;
+unsigned int     trerr_en:1;
+unsigned int     sync_en:1;
+unsigned int     rst_en:1;
+unsigned int     write_data:1;
+}TP_TF2_CNTL;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF2_STRM_ID_0;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF2_STRM_ID_1;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF2_STRM_ID_2;
+
+typedef struct 
+{
+unsigned int     set3:8;
+unsigned int     set2:8;
+unsigned int     set1:8;
+unsigned int     set0:8;
+}TP_TF2_STRM_ID_3;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     val_set33:1;
+unsigned int     val_set32:1;
+unsigned int     val_set31:1;
+unsigned int     val_set30:1;
+unsigned int     val_set23:1;
+unsigned int     val_set22:1;
+unsigned int     val_set21:1;
+unsigned int     val_set20:1;
+unsigned int     val_set13:1;
+unsigned int     val_set12:1;
+unsigned int     val_set11:1;
+unsigned int     val_set10:1;
+unsigned int     val_set03:1;
+unsigned int     val_set02:1;
+unsigned int     val_set01:1;
+unsigned int     val_set00:1;
+}TP_TF2_STRM_VAL;
+
+typedef struct 
+{
+unsigned int     pcr_90k_cnt:32;
+}TP_PCR_90K_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     extra_func_ena:1;
+unsigned int     reserved_1:1;
+unsigned int     extra_pid_addr:7;
+}TP0_PCR_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     extra_func_ena:1;
+unsigned int     reserved_1:1;
+unsigned int     extra_pid_addr:7;
+}TP1_PCR_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     extra_func_ena:1;
+unsigned int     reserved_1:1;
+unsigned int     extra_pid_addr:7;
+}TP2_PCR_CTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     latch_ena:1;
+unsigned int     reserved_1:6;
+unsigned int     latch_sel:2;
+}TP_PCR_LATCH;
+
+typedef struct 
+{
+unsigned int     pcr_base_lo:32;
+}TP_PCR_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     pcr_base_hi:1;
+unsigned int     reserved_1:7;
+unsigned int     pcr_ext:9;
+}TP_PCR_EXT;
+
+typedef struct 
+{
+unsigned int     system_ts:32;
+}TP_PCR_SYSTEM;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     num:16;
+}TP_EMM_REJECT_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     pre_des:1;
+unsigned int     reserved_1:3;
+unsigned int     key_sel:5;
+}TP_EMM_PRE_DES;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     cnt:24;
+}TP_TF1_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     drp_cnt:16;
+}TP_TF1_DRP_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     err_cnt:16;
+}TP_TF1_ERR_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     cnt:24;
+}TP_TF2_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     drp_cnt:16;
+}TP_TF2_DRP_CNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     err_cnt:16;
+}TP_TF2_ERR_CNT;
+
+typedef struct 
+{
+unsigned int     sync_byte:8;
+unsigned int     dropno:4;
+unsigned int     lockno:4;
+unsigned int     packet_size:2;
+unsigned int     data_order:1;
+unsigned int     frm_en:1;
+unsigned int     forcedrop:1;
+unsigned int     syncmode:5;
+unsigned int     serial:1;
+unsigned int     datapin:1;
+unsigned int     err_pol:1;
+unsigned int     sync_pol:1;
+unsigned int     val_pol:1;
+unsigned int     clk_pol:1;
+}TP_TF0_FRMCFG;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     adf_pcr_in:1;
+unsigned int     overflow:1;
+unsigned int     drop:1;
+unsigned int     sync:1;
+unsigned int     write_data:1;
+}TP_TF0_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     adf_pcr_in_en:1;
+unsigned int     overflow_en:1;
+unsigned int     drop_en:1;
+unsigned int     sync_en:1;
+unsigned int     write_data:1;
+}TP_TF0_INT_EN;
+
+typedef struct 
+{
+unsigned int     sync_byte:8;
+unsigned int     dropno:4;
+unsigned int     lockno:4;
+unsigned int     packet_size:2;
+unsigned int     data_order:1;
+unsigned int     frm_en:1;
+unsigned int     forcedrop:1;
+unsigned int     syncmode:5;
+unsigned int     serial:1;
+unsigned int     datapin:1;
+unsigned int     err_pol:1;
+unsigned int     sync_pol:1;
+unsigned int     val_pol:1;
+unsigned int     clk_pol:1;
+}TP_TF1_FRMCFG;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     adf_pcr_in:1;
+unsigned int     overflow:1;
+unsigned int     drop:1;
+unsigned int     sync:1;
+unsigned int     write_data:1;
+}TP_TF1_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     adf_pcr_in_en:1;
+unsigned int     overflow_en:1;
+unsigned int     drop_en:1;
+unsigned int     sync_en:1;
+unsigned int     write_data:1;
+}TP_TF1_INT_EN;
+
+typedef struct 
+{
+unsigned int     sync_byte:8;
+unsigned int     dropno:4;
+unsigned int     lockno:4;
+unsigned int     packet_size:2;
+unsigned int     data_order:1;
+unsigned int     frm_en:1;
+unsigned int     forcedrop:1;
+unsigned int     syncmode:5;
+unsigned int     serial:1;
+unsigned int     datapin:1;
+unsigned int     err_pol:1;
+unsigned int     sync_pol:1;
+unsigned int     val_pol:1;
+unsigned int     clk_pol:1;
+}TP_TF2_FRMCFG;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     adf_pcr_in:1;
+unsigned int     overflow:1;
+unsigned int     drop:1;
+unsigned int     sync:1;
+unsigned int     write_data:1;
+}TP_TF2_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     adf_pcr_in_en:1;
+unsigned int     overflow_en:1;
+unsigned int     drop_en:1;
+unsigned int     sync_en:1;
+unsigned int     write_data:1;
+}TP_TF2_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     byps_tperr_en:1;
+unsigned int     tperr_bit_sel:1;
+unsigned int     in_tp_out_en:1;
+unsigned int     in_tp_rst:1;
+unsigned int     data_src:2;
+unsigned int     reserved_1:1;
+unsigned int     in_data_order:1;
+unsigned int     in_serial:1;
+unsigned int     in_datapin:1;
+unsigned int     in_err_pol:1;
+unsigned int     in_sync_pol:1;
+unsigned int     in_val_pol:1;
+unsigned int     in_clk_pol:1;
+unsigned int     reserved_2:1;
+unsigned int     out_data_order:1;
+unsigned int     out_serial:1;
+unsigned int     reserved_3:1;
+unsigned int     out_err_pol:1;
+unsigned int     out_sync_pol:1;
+unsigned int     out_val_pol:1;
+unsigned int     out_clk_pol:1;
+}TP_TF_OUT_FRMCFG;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     sync_dur:1;
+unsigned int     ck_gate:1;
+unsigned int     tp_frame_rate:13;
+unsigned int     tp_clk_div:5;
+}TP_OUT_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     partition2:7;
+unsigned int     reserved_1:1;
+unsigned int     partition1:7;
+}TP_PID_PART;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     r_w:1;
+unsigned int     idx:7;
+}TP_PID_CTRL;
+
+typedef struct 
+{
+unsigned int     si_en:1;
+unsigned int     pid_ini:1;
+unsigned int     ai_en:1;
+unsigned int     ti_en:1;
+unsigned int     sec_idx:6;
+unsigned int     sec_en:1;
+unsigned int     reversed:1;
+unsigned int     ddr_q:5;
+unsigned int     cc_en:1;
+unsigned int     v:1;
+unsigned int     pid:13;
+}TP_PID_DATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     pre_des:1;
+unsigned int     key:5;
+unsigned int     reversed:2;
+unsigned int     info_q:5;
+}TP_PID_DATA2;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     r_w:1;
+unsigned int     idx:6;
+}TP_SEC_CTRL;
+
+typedef struct 
+{
+unsigned int     filter_value_msb:32;
+}TP_SEC_DATA0;
+
+typedef struct 
+{
+unsigned int     filter_value_lsb:32;
+}TP_SEC_DATA1;
+
+typedef struct 
+{
+unsigned int     mask_value_msb:32;
+}TP_SEC_DATA2;
+
+typedef struct 
+{
+unsigned int     mask_value_lsb:32;
+}TP_SEC_DATA3;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     sp_filter:2;
+unsigned int     sp_mask:2;
+unsigned int     crc_en:1;
+unsigned int     p_d:1;
+unsigned int     p_n:1;
+unsigned int     last:1;
+unsigned int     next_sec:6;
+}TP_SEC_DATA4;
+
+typedef struct 
+{
+unsigned int     neg_filter_value_msb:32;
+}TP_SEC_DATA5;
+
+typedef struct 
+{
+unsigned int     neg_filter_value_lsb:32;
+}TP_SEC_DATA6;
+
+typedef struct 
+{
+unsigned int     neg_mask_value_msb:32;
+}TP_SEC_DATA7;
+
+typedef struct 
+{
+unsigned int     neg_mask_value_lsb:32;
+}TP_SEC_DATA8;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     neg_sp_filter:2;
+unsigned int     neg_sp_mask:2;
+unsigned int     reserved_1:8;
+unsigned int     filter_sel:2;
+}TP_SEC_DATA9;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     ofb_mode:2;
+unsigned int     csa_mode:2;
+unsigned int     round:8;
+unsigned int     multi2_mode:1;
+unsigned int     map_11:1;
+unsigned int     map_10:1;
+unsigned int     map_01:1;
+unsigned int     des_mode:1;
+unsigned int     mode:3;
+}TP_TP0_DES_CNTL;
+
+typedef struct 
+{
+unsigned int     key_info:32;
+}TP_KEY_INFO;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     r_w:1;
+unsigned int     idx:7;
+}TP_KEY_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     ofb_mode:2;
+unsigned int     csa_mode:2;
+unsigned int     round:8;
+unsigned int     multi2_mode:1;
+unsigned int     map_11:1;
+unsigned int     map_10:1;
+unsigned int     map_01:1;
+unsigned int     des_mode:1;
+unsigned int     mode:3;
+}TP_TP1_DES_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     ofb_mode:2;
+unsigned int     csa_mode:2;
+unsigned int     round:8;
+unsigned int     multi2_mode:1;
+unsigned int     map_11:1;
+unsigned int     map_10:1;
+unsigned int     map_01:1;
+unsigned int     des_mode:1;
+unsigned int     mode:3;
+}TP_TP2_DES_CNTL;
+
+typedef struct 
+{
+unsigned int     crc_init:32;
+}TP_CRC_INIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     threshold:27;
+}TP_THRESHOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     fullness:27;
+}TP_FULLNESS;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     wm:4;
+unsigned int     r_w:1;
+unsigned int     reserved_1:1;
+unsigned int     idx:5;
+}TP_RING_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ring_limit:27;
+unsigned int     reserved_1:3;
+}TP_RING_LIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ring_base:27;
+unsigned int     reserved_1:3;
+}TP_RING_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ring_rp:30;
+}TP_RING_RP;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ring_wp:30;
+}TP_RING_WP;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     ring_avail_15:1;
+unsigned int     ring_avail_14:1;
+unsigned int     ring_avail_13:1;
+unsigned int     ring_avail_12:1;
+unsigned int     ring_avail_11:1;
+unsigned int     ring_avail_10:1;
+unsigned int     ring_avail_9:1;
+unsigned int     ring_avail_8:1;
+unsigned int     ring_avail_7:1;
+unsigned int     ring_avail_6:1;
+unsigned int     ring_avail_5:1;
+unsigned int     ring_avail_4:1;
+unsigned int     ring_avail_3:1;
+unsigned int     ring_avail_2:1;
+unsigned int     ring_avail_1:1;
+unsigned int     ring_avail_0:1;
+unsigned int     write_data:1;
+}TP_RING_AVAIL_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     ring_full_15:1;
+unsigned int     ring_full_14:1;
+unsigned int     ring_full_13:1;
+unsigned int     ring_full_12:1;
+unsigned int     ring_full_11:1;
+unsigned int     ring_full_10:1;
+unsigned int     ring_full_9:1;
+unsigned int     ring_full_8:1;
+unsigned int     ring_full_7:1;
+unsigned int     ring_full_6:1;
+unsigned int     ring_full_5:1;
+unsigned int     ring_full_4:1;
+unsigned int     ring_full_3:1;
+unsigned int     ring_full_2:1;
+unsigned int     ring_full_1:1;
+unsigned int     ring_full_0:1;
+unsigned int     write_data:1;
+}TP_RING_FULL_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     ring_avail_15_en:1;
+unsigned int     ring_avail_14_en:1;
+unsigned int     ring_avail_13_en:1;
+unsigned int     ring_avail_12_en:1;
+unsigned int     ring_avail_11_en:1;
+unsigned int     ring_avail_10_en:1;
+unsigned int     ring_avail_9_en:1;
+unsigned int     ring_avail_8_en:1;
+unsigned int     ring_avail_7_en:1;
+unsigned int     ring_avail_6_en:1;
+unsigned int     ring_avail_5_en:1;
+unsigned int     ring_avail_4_en:1;
+unsigned int     ring_avail_3_en:1;
+unsigned int     ring_avail_2_en:1;
+unsigned int     ring_avail_1_en:1;
+unsigned int     ring_avail_0_en:1;
+unsigned int     write_data:1;
+}TP_RING_AVAIL_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     ring_full_15_en:1;
+unsigned int     ring_full_14_en:1;
+unsigned int     ring_full_13_en:1;
+unsigned int     ring_full_12_en:1;
+unsigned int     ring_full_11_en:1;
+unsigned int     ring_full_10_en:1;
+unsigned int     ring_full_9_en:1;
+unsigned int     ring_full_8_en:1;
+unsigned int     ring_full_7_en:1;
+unsigned int     ring_full_6_en:1;
+unsigned int     ring_full_5_en:1;
+unsigned int     ring_full_4_en:1;
+unsigned int     ring_full_3_en:1;
+unsigned int     ring_full_2_en:1;
+unsigned int     ring_full_1_en:1;
+unsigned int     ring_full_0_en:1;
+unsigned int     write_data:1;
+}TP_RING_FULL_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ring_limit:27;
+unsigned int     reserved_1:3;
+}TP_M2M_RING_LIMIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ring_base:27;
+unsigned int     reserved_1:3;
+}TP_M2M_RING_BASE;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ring_rp:30;
+}TP_M2M_RING_RP;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     ring_wp:30;
+}TP_M2M_RING_WP;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     empty:1;
+unsigned int     empty_en:1;
+unsigned int     stop:1;
+unsigned int     go:1;
+unsigned int     write_data:1;
+}TP_M2M_RING_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     sync_pos:30;
+}TP_SYNC_POS;
+
+typedef struct 
+{
+unsigned int     dmy:32;
+}TP_DMY_A;
+
+typedef struct 
+{
+unsigned int     dmy:32;
+}TP_DMY_B;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     dvse:1;
+unsigned int     dvs_3:1;
+unsigned int     dvs_2:1;
+unsigned int     dvs_1:1;
+unsigned int     dvs_0:1;
+}BIST_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     bist_fail5:1;
+unsigned int     bist_fail4:1;
+unsigned int     bist_fail3:1;
+unsigned int     bist_fail2:1;
+unsigned int     bist_fail1:1;
+unsigned int     bist_fail0:1;
+unsigned int     bist_done:1;
+}BIST_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:9;
+unsigned int     drf_fail5:1;
+unsigned int     drf_fail4:1;
+unsigned int     drf_fail3:1;
+unsigned int     drf_fail2:1;
+unsigned int     drf_fail1:1;
+unsigned int     drf_fail0:1;
+unsigned int     drf_done:1;
+}DRF_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     drf_test_resume:1;
+unsigned int     drf_bist_en:1;
+unsigned int     bist_en:1;
+}DRF_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     dv_verify_only:1;
+unsigned int     tp_sram_sleep_off:1;
+unsigned int     tp_pkt_sram_addr_rst_sel:1;
+unsigned int     dbg_mode:5;
+}TP_DEBUG;
+
+#endif
+
+#define TP_TF0_CNTL                                                                  0x18014000
+#define TP_TF0_CNTL_reg_addr                                                         "0xB8014000"
+#define TP_TF0_CNTL_reg                                                              0xB8014000
+#define set_TP_TF0_CNTL_reg(data)   (*((volatile unsigned int*) TP_TF0_CNTL_reg)=data)
+#define get_TP_TF0_CNTL_reg   (*((volatile unsigned int*) TP_TF0_CNTL_reg))
+#define TP_TF0_CNTL_inst_adr                                                         "0x0000"
+#define TP_TF0_CNTL_inst                                                             0x0000
+#define TP_TF0_CNTL_tp_err_fix_en_shift                                              (17)
+#define TP_TF0_CNTL_tp_err_fix_en_mask                                               (0x00020000)
+#define TP_TF0_CNTL_tp_err_fix_en(data)                                              (0x00020000&((data)<<17))
+#define TP_TF0_CNTL_tp_err_fix_en_src(data)                                          ((0x00020000&(data))>>17)
+#define TP_TF0_CNTL_get_tp_err_fix_en(data)                                          ((0x00020000&(data))>>17)
+#define TP_TF0_CNTL_strm_id_en_shift                                                 (16)
+#define TP_TF0_CNTL_strm_id_en_mask                                                  (0x00010000)
+#define TP_TF0_CNTL_strm_id_en(data)                                                 (0x00010000&((data)<<16))
+#define TP_TF0_CNTL_strm_id_en_src(data)                                             ((0x00010000&(data))>>16)
+#define TP_TF0_CNTL_get_strm_id_en(data)                                             ((0x00010000&(data))>>16)
+#define TP_TF0_CNTL_buf_rdy_ctl_shift                                                (15)
+#define TP_TF0_CNTL_buf_rdy_ctl_mask                                                 (0x00008000)
+#define TP_TF0_CNTL_buf_rdy_ctl(data)                                                (0x00008000&((data)<<15))
+#define TP_TF0_CNTL_buf_rdy_ctl_src(data)                                            ((0x00008000&(data))>>15)
+#define TP_TF0_CNTL_get_buf_rdy_ctl(data)                                            ((0x00008000&(data))>>15)
+#define TP_TF0_CNTL_psc_en_shift                                                     (14)
+#define TP_TF0_CNTL_psc_en_mask                                                      (0x00004000)
+#define TP_TF0_CNTL_psc_en(data)                                                     (0x00004000&((data)<<14))
+#define TP_TF0_CNTL_psc_en_src(data)                                                 ((0x00004000&(data))>>14)
+#define TP_TF0_CNTL_get_psc_en(data)                                                 ((0x00004000&(data))>>14)
+#define TP_TF0_CNTL_pes_en_shift                                                     (13)
+#define TP_TF0_CNTL_pes_en_mask                                                      (0x00002000)
+#define TP_TF0_CNTL_pes_en(data)                                                     (0x00002000&((data)<<13))
+#define TP_TF0_CNTL_pes_en_src(data)                                                 ((0x00002000&(data))>>13)
+#define TP_TF0_CNTL_get_pes_en(data)                                                 ((0x00002000&(data))>>13)
+#define TP_TF0_CNTL_tsc_en_shift                                                     (12)
+#define TP_TF0_CNTL_tsc_en_mask                                                      (0x00001000)
+#define TP_TF0_CNTL_tsc_en(data)                                                     (0x00001000&((data)<<12))
+#define TP_TF0_CNTL_tsc_en_src(data)                                                 ((0x00001000&(data))>>12)
+#define TP_TF0_CNTL_get_tsc_en(data)                                                 ((0x00001000&(data))>>12)
+#define TP_TF0_CNTL_tb_shift                                                         (11)
+#define TP_TF0_CNTL_tb_mask                                                          (0x00000800)
+#define TP_TF0_CNTL_tb(data)                                                         (0x00000800&((data)<<11))
+#define TP_TF0_CNTL_tb_src(data)                                                     ((0x00000800&(data))>>11)
+#define TP_TF0_CNTL_get_tb(data)                                                     ((0x00000800&(data))>>11)
+#define TP_TF0_CNTL_busy_shift                                                       (10)
+#define TP_TF0_CNTL_busy_mask                                                        (0x00000400)
+#define TP_TF0_CNTL_busy(data)                                                       (0x00000400&((data)<<10))
+#define TP_TF0_CNTL_busy_src(data)                                                   ((0x00000400&(data))>>10)
+#define TP_TF0_CNTL_get_busy(data)                                                   ((0x00000400&(data))>>10)
+#define TP_TF0_CNTL_mode_shift                                                       (9)
+#define TP_TF0_CNTL_mode_mask                                                        (0x00000200)
+#define TP_TF0_CNTL_mode(data)                                                       (0x00000200&((data)<<9))
+#define TP_TF0_CNTL_mode_src(data)                                                   ((0x00000200&(data))>>9)
+#define TP_TF0_CNTL_get_mode(data)                                                   ((0x00000200&(data))>>9)
+#define TP_TF0_CNTL_du_en_shift                                                      (8)
+#define TP_TF0_CNTL_du_en_mask                                                       (0x00000100)
+#define TP_TF0_CNTL_du_en(data)                                                      (0x00000100&((data)<<8))
+#define TP_TF0_CNTL_du_en_src(data)                                                  ((0x00000100&(data))>>8)
+#define TP_TF0_CNTL_get_du_en(data)                                                  ((0x00000100&(data))>>8)
+#define TP_TF0_CNTL_de_en_shift                                                      (7)
+#define TP_TF0_CNTL_de_en_mask                                                       (0x00000080)
+#define TP_TF0_CNTL_de_en(data)                                                      (0x00000080&((data)<<7))
+#define TP_TF0_CNTL_de_en_src(data)                                                  ((0x00000080&(data))>>7)
+#define TP_TF0_CNTL_get_de_en(data)                                                  ((0x00000080&(data))>>7)
+#define TP_TF0_CNTL_xt_en_shift                                                      (6)
+#define TP_TF0_CNTL_xt_en_mask                                                       (0x00000040)
+#define TP_TF0_CNTL_xt_en(data)                                                      (0x00000040&((data)<<6))
+#define TP_TF0_CNTL_xt_en_src(data)                                                  ((0x00000040&(data))>>6)
+#define TP_TF0_CNTL_get_xt_en(data)                                                  ((0x00000040&(data))>>6)
+#define TP_TF0_CNTL_pid_en_shift                                                     (5)
+#define TP_TF0_CNTL_pid_en_mask                                                      (0x00000020)
+#define TP_TF0_CNTL_pid_en(data)                                                     (0x00000020&((data)<<5))
+#define TP_TF0_CNTL_pid_en_src(data)                                                 ((0x00000020&(data))>>5)
+#define TP_TF0_CNTL_get_pid_en(data)                                                 ((0x00000020&(data))>>5)
+#define TP_TF0_CNTL_null_en_shift                                                    (4)
+#define TP_TF0_CNTL_null_en_mask                                                     (0x00000010)
+#define TP_TF0_CNTL_null_en(data)                                                    (0x00000010&((data)<<4))
+#define TP_TF0_CNTL_null_en_src(data)                                                ((0x00000010&(data))>>4)
+#define TP_TF0_CNTL_get_null_en(data)                                                ((0x00000010&(data))>>4)
+#define TP_TF0_CNTL_trerr_en_shift                                                   (3)
+#define TP_TF0_CNTL_trerr_en_mask                                                    (0x00000008)
+#define TP_TF0_CNTL_trerr_en(data)                                                   (0x00000008&((data)<<3))
+#define TP_TF0_CNTL_trerr_en_src(data)                                               ((0x00000008&(data))>>3)
+#define TP_TF0_CNTL_get_trerr_en(data)                                               ((0x00000008&(data))>>3)
+#define TP_TF0_CNTL_sync_en_shift                                                    (2)
+#define TP_TF0_CNTL_sync_en_mask                                                     (0x00000004)
+#define TP_TF0_CNTL_sync_en(data)                                                    (0x00000004&((data)<<2))
+#define TP_TF0_CNTL_sync_en_src(data)                                                ((0x00000004&(data))>>2)
+#define TP_TF0_CNTL_get_sync_en(data)                                                ((0x00000004&(data))>>2)
+#define TP_TF0_CNTL_rst_en_shift                                                     (1)
+#define TP_TF0_CNTL_rst_en_mask                                                      (0x00000002)
+#define TP_TF0_CNTL_rst_en(data)                                                     (0x00000002&((data)<<1))
+#define TP_TF0_CNTL_rst_en_src(data)                                                 ((0x00000002&(data))>>1)
+#define TP_TF0_CNTL_get_rst_en(data)                                                 ((0x00000002&(data))>>1)
+#define TP_TF0_CNTL_write_data_shift                                                 (0)
+#define TP_TF0_CNTL_write_data_mask                                                  (0x00000001)
+#define TP_TF0_CNTL_write_data(data)                                                 (0x00000001&((data)<<0))
+#define TP_TF0_CNTL_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define TP_TF0_CNTL_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define TP_TF0_STRM_ID_0                                                             0x18014208
+#define TP_TF0_STRM_ID_0_reg_addr                                                    "0xB8014208"
+#define TP_TF0_STRM_ID_0_reg                                                         0xB8014208
+#define set_TP_TF0_STRM_ID_0_reg(data)   (*((volatile unsigned int*) TP_TF0_STRM_ID_0_reg)=data)
+#define get_TP_TF0_STRM_ID_0_reg   (*((volatile unsigned int*) TP_TF0_STRM_ID_0_reg))
+#define TP_TF0_STRM_ID_0_inst_adr                                                    "0x0082"
+#define TP_TF0_STRM_ID_0_inst                                                        0x0082
+#define TP_TF0_STRM_ID_0_set3_shift                                                  (24)
+#define TP_TF0_STRM_ID_0_set3_mask                                                   (0xFF000000)
+#define TP_TF0_STRM_ID_0_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF0_STRM_ID_0_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF0_STRM_ID_0_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF0_STRM_ID_0_set2_shift                                                  (16)
+#define TP_TF0_STRM_ID_0_set2_mask                                                   (0x00FF0000)
+#define TP_TF0_STRM_ID_0_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF0_STRM_ID_0_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF0_STRM_ID_0_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF0_STRM_ID_0_set1_shift                                                  (8)
+#define TP_TF0_STRM_ID_0_set1_mask                                                   (0x0000FF00)
+#define TP_TF0_STRM_ID_0_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF0_STRM_ID_0_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF0_STRM_ID_0_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF0_STRM_ID_0_set0_shift                                                  (0)
+#define TP_TF0_STRM_ID_0_set0_mask                                                   (0x000000FF)
+#define TP_TF0_STRM_ID_0_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF0_STRM_ID_0_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF0_STRM_ID_0_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF0_STRM_ID_1                                                             0x1801420c
+#define TP_TF0_STRM_ID_1_reg_addr                                                    "0xB801420C"
+#define TP_TF0_STRM_ID_1_reg                                                         0xB801420C
+#define set_TP_TF0_STRM_ID_1_reg(data)   (*((volatile unsigned int*) TP_TF0_STRM_ID_1_reg)=data)
+#define get_TP_TF0_STRM_ID_1_reg   (*((volatile unsigned int*) TP_TF0_STRM_ID_1_reg))
+#define TP_TF0_STRM_ID_1_inst_adr                                                    "0x0083"
+#define TP_TF0_STRM_ID_1_inst                                                        0x0083
+#define TP_TF0_STRM_ID_1_set3_shift                                                  (24)
+#define TP_TF0_STRM_ID_1_set3_mask                                                   (0xFF000000)
+#define TP_TF0_STRM_ID_1_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF0_STRM_ID_1_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF0_STRM_ID_1_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF0_STRM_ID_1_set2_shift                                                  (16)
+#define TP_TF0_STRM_ID_1_set2_mask                                                   (0x00FF0000)
+#define TP_TF0_STRM_ID_1_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF0_STRM_ID_1_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF0_STRM_ID_1_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF0_STRM_ID_1_set1_shift                                                  (8)
+#define TP_TF0_STRM_ID_1_set1_mask                                                   (0x0000FF00)
+#define TP_TF0_STRM_ID_1_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF0_STRM_ID_1_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF0_STRM_ID_1_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF0_STRM_ID_1_set0_shift                                                  (0)
+#define TP_TF0_STRM_ID_1_set0_mask                                                   (0x000000FF)
+#define TP_TF0_STRM_ID_1_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF0_STRM_ID_1_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF0_STRM_ID_1_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF0_STRM_ID_2                                                             0x18014210
+#define TP_TF0_STRM_ID_2_reg_addr                                                    "0xB8014210"
+#define TP_TF0_STRM_ID_2_reg                                                         0xB8014210
+#define set_TP_TF0_STRM_ID_2_reg(data)   (*((volatile unsigned int*) TP_TF0_STRM_ID_2_reg)=data)
+#define get_TP_TF0_STRM_ID_2_reg   (*((volatile unsigned int*) TP_TF0_STRM_ID_2_reg))
+#define TP_TF0_STRM_ID_2_inst_adr                                                    "0x0084"
+#define TP_TF0_STRM_ID_2_inst                                                        0x0084
+#define TP_TF0_STRM_ID_2_set3_shift                                                  (24)
+#define TP_TF0_STRM_ID_2_set3_mask                                                   (0xFF000000)
+#define TP_TF0_STRM_ID_2_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF0_STRM_ID_2_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF0_STRM_ID_2_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF0_STRM_ID_2_set2_shift                                                  (16)
+#define TP_TF0_STRM_ID_2_set2_mask                                                   (0x00FF0000)
+#define TP_TF0_STRM_ID_2_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF0_STRM_ID_2_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF0_STRM_ID_2_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF0_STRM_ID_2_set1_shift                                                  (8)
+#define TP_TF0_STRM_ID_2_set1_mask                                                   (0x0000FF00)
+#define TP_TF0_STRM_ID_2_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF0_STRM_ID_2_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF0_STRM_ID_2_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF0_STRM_ID_2_set0_shift                                                  (0)
+#define TP_TF0_STRM_ID_2_set0_mask                                                   (0x000000FF)
+#define TP_TF0_STRM_ID_2_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF0_STRM_ID_2_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF0_STRM_ID_2_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF0_STRM_ID_3                                                             0x18014214
+#define TP_TF0_STRM_ID_3_reg_addr                                                    "0xB8014214"
+#define TP_TF0_STRM_ID_3_reg                                                         0xB8014214
+#define set_TP_TF0_STRM_ID_3_reg(data)   (*((volatile unsigned int*) TP_TF0_STRM_ID_3_reg)=data)
+#define get_TP_TF0_STRM_ID_3_reg   (*((volatile unsigned int*) TP_TF0_STRM_ID_3_reg))
+#define TP_TF0_STRM_ID_3_inst_adr                                                    "0x0085"
+#define TP_TF0_STRM_ID_3_inst                                                        0x0085
+#define TP_TF0_STRM_ID_3_set3_shift                                                  (24)
+#define TP_TF0_STRM_ID_3_set3_mask                                                   (0xFF000000)
+#define TP_TF0_STRM_ID_3_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF0_STRM_ID_3_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF0_STRM_ID_3_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF0_STRM_ID_3_set2_shift                                                  (16)
+#define TP_TF0_STRM_ID_3_set2_mask                                                   (0x00FF0000)
+#define TP_TF0_STRM_ID_3_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF0_STRM_ID_3_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF0_STRM_ID_3_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF0_STRM_ID_3_set1_shift                                                  (8)
+#define TP_TF0_STRM_ID_3_set1_mask                                                   (0x0000FF00)
+#define TP_TF0_STRM_ID_3_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF0_STRM_ID_3_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF0_STRM_ID_3_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF0_STRM_ID_3_set0_shift                                                  (0)
+#define TP_TF0_STRM_ID_3_set0_mask                                                   (0x000000FF)
+#define TP_TF0_STRM_ID_3_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF0_STRM_ID_3_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF0_STRM_ID_3_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF0_STRM_VAL                                                              0x18014218
+#define TP_TF0_STRM_VAL_reg_addr                                                     "0xB8014218"
+#define TP_TF0_STRM_VAL_reg                                                          0xB8014218
+#define set_TP_TF0_STRM_VAL_reg(data)   (*((volatile unsigned int*) TP_TF0_STRM_VAL_reg)=data)
+#define get_TP_TF0_STRM_VAL_reg   (*((volatile unsigned int*) TP_TF0_STRM_VAL_reg))
+#define TP_TF0_STRM_VAL_inst_adr                                                     "0x0086"
+#define TP_TF0_STRM_VAL_inst                                                         0x0086
+#define TP_TF0_STRM_VAL_val_set33_shift                                              (15)
+#define TP_TF0_STRM_VAL_val_set33_mask                                               (0x00008000)
+#define TP_TF0_STRM_VAL_val_set33(data)                                              (0x00008000&((data)<<15))
+#define TP_TF0_STRM_VAL_val_set33_src(data)                                          ((0x00008000&(data))>>15)
+#define TP_TF0_STRM_VAL_get_val_set33(data)                                          ((0x00008000&(data))>>15)
+#define TP_TF0_STRM_VAL_val_set32_shift                                              (14)
+#define TP_TF0_STRM_VAL_val_set32_mask                                               (0x00004000)
+#define TP_TF0_STRM_VAL_val_set32(data)                                              (0x00004000&((data)<<14))
+#define TP_TF0_STRM_VAL_val_set32_src(data)                                          ((0x00004000&(data))>>14)
+#define TP_TF0_STRM_VAL_get_val_set32(data)                                          ((0x00004000&(data))>>14)
+#define TP_TF0_STRM_VAL_val_set31_shift                                              (13)
+#define TP_TF0_STRM_VAL_val_set31_mask                                               (0x00002000)
+#define TP_TF0_STRM_VAL_val_set31(data)                                              (0x00002000&((data)<<13))
+#define TP_TF0_STRM_VAL_val_set31_src(data)                                          ((0x00002000&(data))>>13)
+#define TP_TF0_STRM_VAL_get_val_set31(data)                                          ((0x00002000&(data))>>13)
+#define TP_TF0_STRM_VAL_val_set30_shift                                              (12)
+#define TP_TF0_STRM_VAL_val_set30_mask                                               (0x00001000)
+#define TP_TF0_STRM_VAL_val_set30(data)                                              (0x00001000&((data)<<12))
+#define TP_TF0_STRM_VAL_val_set30_src(data)                                          ((0x00001000&(data))>>12)
+#define TP_TF0_STRM_VAL_get_val_set30(data)                                          ((0x00001000&(data))>>12)
+#define TP_TF0_STRM_VAL_val_set23_shift                                              (11)
+#define TP_TF0_STRM_VAL_val_set23_mask                                               (0x00000800)
+#define TP_TF0_STRM_VAL_val_set23(data)                                              (0x00000800&((data)<<11))
+#define TP_TF0_STRM_VAL_val_set23_src(data)                                          ((0x00000800&(data))>>11)
+#define TP_TF0_STRM_VAL_get_val_set23(data)                                          ((0x00000800&(data))>>11)
+#define TP_TF0_STRM_VAL_val_set22_shift                                              (10)
+#define TP_TF0_STRM_VAL_val_set22_mask                                               (0x00000400)
+#define TP_TF0_STRM_VAL_val_set22(data)                                              (0x00000400&((data)<<10))
+#define TP_TF0_STRM_VAL_val_set22_src(data)                                          ((0x00000400&(data))>>10)
+#define TP_TF0_STRM_VAL_get_val_set22(data)                                          ((0x00000400&(data))>>10)
+#define TP_TF0_STRM_VAL_val_set21_shift                                              (9)
+#define TP_TF0_STRM_VAL_val_set21_mask                                               (0x00000200)
+#define TP_TF0_STRM_VAL_val_set21(data)                                              (0x00000200&((data)<<9))
+#define TP_TF0_STRM_VAL_val_set21_src(data)                                          ((0x00000200&(data))>>9)
+#define TP_TF0_STRM_VAL_get_val_set21(data)                                          ((0x00000200&(data))>>9)
+#define TP_TF0_STRM_VAL_val_set20_shift                                              (8)
+#define TP_TF0_STRM_VAL_val_set20_mask                                               (0x00000100)
+#define TP_TF0_STRM_VAL_val_set20(data)                                              (0x00000100&((data)<<8))
+#define TP_TF0_STRM_VAL_val_set20_src(data)                                          ((0x00000100&(data))>>8)
+#define TP_TF0_STRM_VAL_get_val_set20(data)                                          ((0x00000100&(data))>>8)
+#define TP_TF0_STRM_VAL_val_set13_shift                                              (7)
+#define TP_TF0_STRM_VAL_val_set13_mask                                               (0x00000080)
+#define TP_TF0_STRM_VAL_val_set13(data)                                              (0x00000080&((data)<<7))
+#define TP_TF0_STRM_VAL_val_set13_src(data)                                          ((0x00000080&(data))>>7)
+#define TP_TF0_STRM_VAL_get_val_set13(data)                                          ((0x00000080&(data))>>7)
+#define TP_TF0_STRM_VAL_val_set12_shift                                              (6)
+#define TP_TF0_STRM_VAL_val_set12_mask                                               (0x00000040)
+#define TP_TF0_STRM_VAL_val_set12(data)                                              (0x00000040&((data)<<6))
+#define TP_TF0_STRM_VAL_val_set12_src(data)                                          ((0x00000040&(data))>>6)
+#define TP_TF0_STRM_VAL_get_val_set12(data)                                          ((0x00000040&(data))>>6)
+#define TP_TF0_STRM_VAL_val_set11_shift                                              (5)
+#define TP_TF0_STRM_VAL_val_set11_mask                                               (0x00000020)
+#define TP_TF0_STRM_VAL_val_set11(data)                                              (0x00000020&((data)<<5))
+#define TP_TF0_STRM_VAL_val_set11_src(data)                                          ((0x00000020&(data))>>5)
+#define TP_TF0_STRM_VAL_get_val_set11(data)                                          ((0x00000020&(data))>>5)
+#define TP_TF0_STRM_VAL_val_set10_shift                                              (4)
+#define TP_TF0_STRM_VAL_val_set10_mask                                               (0x00000010)
+#define TP_TF0_STRM_VAL_val_set10(data)                                              (0x00000010&((data)<<4))
+#define TP_TF0_STRM_VAL_val_set10_src(data)                                          ((0x00000010&(data))>>4)
+#define TP_TF0_STRM_VAL_get_val_set10(data)                                          ((0x00000010&(data))>>4)
+#define TP_TF0_STRM_VAL_val_set03_shift                                              (3)
+#define TP_TF0_STRM_VAL_val_set03_mask                                               (0x00000008)
+#define TP_TF0_STRM_VAL_val_set03(data)                                              (0x00000008&((data)<<3))
+#define TP_TF0_STRM_VAL_val_set03_src(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF0_STRM_VAL_get_val_set03(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF0_STRM_VAL_val_set02_shift                                              (2)
+#define TP_TF0_STRM_VAL_val_set02_mask                                               (0x00000004)
+#define TP_TF0_STRM_VAL_val_set02(data)                                              (0x00000004&((data)<<2))
+#define TP_TF0_STRM_VAL_val_set02_src(data)                                          ((0x00000004&(data))>>2)
+#define TP_TF0_STRM_VAL_get_val_set02(data)                                          ((0x00000004&(data))>>2)
+#define TP_TF0_STRM_VAL_val_set01_shift                                              (1)
+#define TP_TF0_STRM_VAL_val_set01_mask                                               (0x00000002)
+#define TP_TF0_STRM_VAL_val_set01(data)                                              (0x00000002&((data)<<1))
+#define TP_TF0_STRM_VAL_val_set01_src(data)                                          ((0x00000002&(data))>>1)
+#define TP_TF0_STRM_VAL_get_val_set01(data)                                          ((0x00000002&(data))>>1)
+#define TP_TF0_STRM_VAL_val_set00_shift                                              (0)
+#define TP_TF0_STRM_VAL_val_set00_mask                                               (0x00000001)
+#define TP_TF0_STRM_VAL_val_set00(data)                                              (0x00000001&((data)<<0))
+#define TP_TF0_STRM_VAL_val_set00_src(data)                                          ((0x00000001&(data))>>0)
+#define TP_TF0_STRM_VAL_get_val_set00(data)                                          ((0x00000001&(data))>>0)
+
+
+#define TP_TF0_CNT                                                                   0x18014004
+#define TP_TF0_CNT_reg_addr                                                          "0xB8014004"
+#define TP_TF0_CNT_reg                                                               0xB8014004
+#define set_TP_TF0_CNT_reg(data)   (*((volatile unsigned int*) TP_TF0_CNT_reg)=data)
+#define get_TP_TF0_CNT_reg   (*((volatile unsigned int*) TP_TF0_CNT_reg))
+#define TP_TF0_CNT_inst_adr                                                          "0x0001"
+#define TP_TF0_CNT_inst                                                              0x0001
+#define TP_TF0_CNT_cnt_shift                                                         (0)
+#define TP_TF0_CNT_cnt_mask                                                          (0x00FFFFFF)
+#define TP_TF0_CNT_cnt(data)                                                         (0x00FFFFFF&((data)<<0))
+#define TP_TF0_CNT_cnt_src(data)                                                     ((0x00FFFFFF&(data))>>0)
+#define TP_TF0_CNT_get_cnt(data)                                                     ((0x00FFFFFF&(data))>>0)
+
+
+#define TP_TF0_DRP_CNT                                                               0x18014008
+#define TP_TF0_DRP_CNT_reg_addr                                                      "0xB8014008"
+#define TP_TF0_DRP_CNT_reg                                                           0xB8014008
+#define set_TP_TF0_DRP_CNT_reg(data)   (*((volatile unsigned int*) TP_TF0_DRP_CNT_reg)=data)
+#define get_TP_TF0_DRP_CNT_reg   (*((volatile unsigned int*) TP_TF0_DRP_CNT_reg))
+#define TP_TF0_DRP_CNT_inst_adr                                                      "0x0002"
+#define TP_TF0_DRP_CNT_inst                                                          0x0002
+#define TP_TF0_DRP_CNT_drp_cnt_shift                                                 (0)
+#define TP_TF0_DRP_CNT_drp_cnt_mask                                                  (0x0000FFFF)
+#define TP_TF0_DRP_CNT_drp_cnt(data)                                                 (0x0000FFFF&((data)<<0))
+#define TP_TF0_DRP_CNT_drp_cnt_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define TP_TF0_DRP_CNT_get_drp_cnt(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define TP_TF0_ERR_CNT                                                               0x1801400C
+#define TP_TF0_ERR_CNT_reg_addr                                                      "0xB801400C"
+#define TP_TF0_ERR_CNT_reg                                                           0xB801400C
+#define set_TP_TF0_ERR_CNT_reg(data)   (*((volatile unsigned int*) TP_TF0_ERR_CNT_reg)=data)
+#define get_TP_TF0_ERR_CNT_reg   (*((volatile unsigned int*) TP_TF0_ERR_CNT_reg))
+#define TP_TF0_ERR_CNT_inst_adr                                                      "0x0003"
+#define TP_TF0_ERR_CNT_inst                                                          0x0003
+#define TP_TF0_ERR_CNT_err_cnt_shift                                                 (0)
+#define TP_TF0_ERR_CNT_err_cnt_mask                                                  (0x0000FFFF)
+#define TP_TF0_ERR_CNT_err_cnt(data)                                                 (0x0000FFFF&((data)<<0))
+#define TP_TF0_ERR_CNT_err_cnt_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define TP_TF0_ERR_CNT_get_err_cnt(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define TP_TF1_CNTL                                                                  0x18014010
+#define TP_TF1_CNTL_reg_addr                                                         "0xB8014010"
+#define TP_TF1_CNTL_reg                                                              0xB8014010
+#define set_TP_TF1_CNTL_reg(data)   (*((volatile unsigned int*) TP_TF1_CNTL_reg)=data)
+#define get_TP_TF1_CNTL_reg   (*((volatile unsigned int*) TP_TF1_CNTL_reg))
+#define TP_TF1_CNTL_inst_adr                                                         "0x0004"
+#define TP_TF1_CNTL_inst                                                             0x0004
+#define TP_TF1_CNTL_tp_err_fix_en_shift                                              (17)
+#define TP_TF1_CNTL_tp_err_fix_en_mask                                               (0x00020000)
+#define TP_TF1_CNTL_tp_err_fix_en(data)                                              (0x00020000&((data)<<17))
+#define TP_TF1_CNTL_tp_err_fix_en_src(data)                                          ((0x00020000&(data))>>17)
+#define TP_TF1_CNTL_get_tp_err_fix_en(data)                                          ((0x00020000&(data))>>17)
+#define TP_TF1_CNTL_strm_id_en_shift                                                 (16)
+#define TP_TF1_CNTL_strm_id_en_mask                                                  (0x00010000)
+#define TP_TF1_CNTL_strm_id_en(data)                                                 (0x00010000&((data)<<16))
+#define TP_TF1_CNTL_strm_id_en_src(data)                                             ((0x00010000&(data))>>16)
+#define TP_TF1_CNTL_get_strm_id_en(data)                                             ((0x00010000&(data))>>16)
+#define TP_TF1_CNTL_buf_rdy_ctl_shift                                                (15)
+#define TP_TF1_CNTL_buf_rdy_ctl_mask                                                 (0x00008000)
+#define TP_TF1_CNTL_buf_rdy_ctl(data)                                                (0x00008000&((data)<<15))
+#define TP_TF1_CNTL_buf_rdy_ctl_src(data)                                            ((0x00008000&(data))>>15)
+#define TP_TF1_CNTL_get_buf_rdy_ctl(data)                                            ((0x00008000&(data))>>15)
+#define TP_TF1_CNTL_psc_en_shift                                                     (14)
+#define TP_TF1_CNTL_psc_en_mask                                                      (0x00004000)
+#define TP_TF1_CNTL_psc_en(data)                                                     (0x00004000&((data)<<14))
+#define TP_TF1_CNTL_psc_en_src(data)                                                 ((0x00004000&(data))>>14)
+#define TP_TF1_CNTL_get_psc_en(data)                                                 ((0x00004000&(data))>>14)
+#define TP_TF1_CNTL_pes_en_shift                                                     (13)
+#define TP_TF1_CNTL_pes_en_mask                                                      (0x00002000)
+#define TP_TF1_CNTL_pes_en(data)                                                     (0x00002000&((data)<<13))
+#define TP_TF1_CNTL_pes_en_src(data)                                                 ((0x00002000&(data))>>13)
+#define TP_TF1_CNTL_get_pes_en(data)                                                 ((0x00002000&(data))>>13)
+#define TP_TF1_CNTL_tsc_en_shift                                                     (12)
+#define TP_TF1_CNTL_tsc_en_mask                                                      (0x00001000)
+#define TP_TF1_CNTL_tsc_en(data)                                                     (0x00001000&((data)<<12))
+#define TP_TF1_CNTL_tsc_en_src(data)                                                 ((0x00001000&(data))>>12)
+#define TP_TF1_CNTL_get_tsc_en(data)                                                 ((0x00001000&(data))>>12)
+#define TP_TF1_CNTL_tb_shift                                                         (11)
+#define TP_TF1_CNTL_tb_mask                                                          (0x00000800)
+#define TP_TF1_CNTL_tb(data)                                                         (0x00000800&((data)<<11))
+#define TP_TF1_CNTL_tb_src(data)                                                     ((0x00000800&(data))>>11)
+#define TP_TF1_CNTL_get_tb(data)                                                     ((0x00000800&(data))>>11)
+#define TP_TF1_CNTL_busy_shift                                                       (10)
+#define TP_TF1_CNTL_busy_mask                                                        (0x00000400)
+#define TP_TF1_CNTL_busy(data)                                                       (0x00000400&((data)<<10))
+#define TP_TF1_CNTL_busy_src(data)                                                   ((0x00000400&(data))>>10)
+#define TP_TF1_CNTL_get_busy(data)                                                   ((0x00000400&(data))>>10)
+#define TP_TF1_CNTL_mode_shift                                                       (9)
+#define TP_TF1_CNTL_mode_mask                                                        (0x00000200)
+#define TP_TF1_CNTL_mode(data)                                                       (0x00000200&((data)<<9))
+#define TP_TF1_CNTL_mode_src(data)                                                   ((0x00000200&(data))>>9)
+#define TP_TF1_CNTL_get_mode(data)                                                   ((0x00000200&(data))>>9)
+#define TP_TF1_CNTL_du_en_shift                                                      (8)
+#define TP_TF1_CNTL_du_en_mask                                                       (0x00000100)
+#define TP_TF1_CNTL_du_en(data)                                                      (0x00000100&((data)<<8))
+#define TP_TF1_CNTL_du_en_src(data)                                                  ((0x00000100&(data))>>8)
+#define TP_TF1_CNTL_get_du_en(data)                                                  ((0x00000100&(data))>>8)
+#define TP_TF1_CNTL_de_en_shift                                                      (7)
+#define TP_TF1_CNTL_de_en_mask                                                       (0x00000080)
+#define TP_TF1_CNTL_de_en(data)                                                      (0x00000080&((data)<<7))
+#define TP_TF1_CNTL_de_en_src(data)                                                  ((0x00000080&(data))>>7)
+#define TP_TF1_CNTL_get_de_en(data)                                                  ((0x00000080&(data))>>7)
+#define TP_TF1_CNTL_xt_en_shift                                                      (6)
+#define TP_TF1_CNTL_xt_en_mask                                                       (0x00000040)
+#define TP_TF1_CNTL_xt_en(data)                                                      (0x00000040&((data)<<6))
+#define TP_TF1_CNTL_xt_en_src(data)                                                  ((0x00000040&(data))>>6)
+#define TP_TF1_CNTL_get_xt_en(data)                                                  ((0x00000040&(data))>>6)
+#define TP_TF1_CNTL_pid_en_shift                                                     (5)
+#define TP_TF1_CNTL_pid_en_mask                                                      (0x00000020)
+#define TP_TF1_CNTL_pid_en(data)                                                     (0x00000020&((data)<<5))
+#define TP_TF1_CNTL_pid_en_src(data)                                                 ((0x00000020&(data))>>5)
+#define TP_TF1_CNTL_get_pid_en(data)                                                 ((0x00000020&(data))>>5)
+#define TP_TF1_CNTL_null_en_shift                                                    (4)
+#define TP_TF1_CNTL_null_en_mask                                                     (0x00000010)
+#define TP_TF1_CNTL_null_en(data)                                                    (0x00000010&((data)<<4))
+#define TP_TF1_CNTL_null_en_src(data)                                                ((0x00000010&(data))>>4)
+#define TP_TF1_CNTL_get_null_en(data)                                                ((0x00000010&(data))>>4)
+#define TP_TF1_CNTL_trerr_en_shift                                                   (3)
+#define TP_TF1_CNTL_trerr_en_mask                                                    (0x00000008)
+#define TP_TF1_CNTL_trerr_en(data)                                                   (0x00000008&((data)<<3))
+#define TP_TF1_CNTL_trerr_en_src(data)                                               ((0x00000008&(data))>>3)
+#define TP_TF1_CNTL_get_trerr_en(data)                                               ((0x00000008&(data))>>3)
+#define TP_TF1_CNTL_sync_en_shift                                                    (2)
+#define TP_TF1_CNTL_sync_en_mask                                                     (0x00000004)
+#define TP_TF1_CNTL_sync_en(data)                                                    (0x00000004&((data)<<2))
+#define TP_TF1_CNTL_sync_en_src(data)                                                ((0x00000004&(data))>>2)
+#define TP_TF1_CNTL_get_sync_en(data)                                                ((0x00000004&(data))>>2)
+#define TP_TF1_CNTL_rst_en_shift                                                     (1)
+#define TP_TF1_CNTL_rst_en_mask                                                      (0x00000002)
+#define TP_TF1_CNTL_rst_en(data)                                                     (0x00000002&((data)<<1))
+#define TP_TF1_CNTL_rst_en_src(data)                                                 ((0x00000002&(data))>>1)
+#define TP_TF1_CNTL_get_rst_en(data)                                                 ((0x00000002&(data))>>1)
+#define TP_TF1_CNTL_write_data_shift                                                 (0)
+#define TP_TF1_CNTL_write_data_mask                                                  (0x00000001)
+#define TP_TF1_CNTL_write_data(data)                                                 (0x00000001&((data)<<0))
+#define TP_TF1_CNTL_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define TP_TF1_CNTL_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define TP_TF1_STRM_ID_0                                                             0x1801421c
+#define TP_TF1_STRM_ID_0_reg_addr                                                    "0xB801421C"
+#define TP_TF1_STRM_ID_0_reg                                                         0xB801421C
+#define set_TP_TF1_STRM_ID_0_reg(data)   (*((volatile unsigned int*) TP_TF1_STRM_ID_0_reg)=data)
+#define get_TP_TF1_STRM_ID_0_reg   (*((volatile unsigned int*) TP_TF1_STRM_ID_0_reg))
+#define TP_TF1_STRM_ID_0_inst_adr                                                    "0x0087"
+#define TP_TF1_STRM_ID_0_inst                                                        0x0087
+#define TP_TF1_STRM_ID_0_set3_shift                                                  (24)
+#define TP_TF1_STRM_ID_0_set3_mask                                                   (0xFF000000)
+#define TP_TF1_STRM_ID_0_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF1_STRM_ID_0_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF1_STRM_ID_0_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF1_STRM_ID_0_set2_shift                                                  (16)
+#define TP_TF1_STRM_ID_0_set2_mask                                                   (0x00FF0000)
+#define TP_TF1_STRM_ID_0_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF1_STRM_ID_0_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF1_STRM_ID_0_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF1_STRM_ID_0_set1_shift                                                  (8)
+#define TP_TF1_STRM_ID_0_set1_mask                                                   (0x0000FF00)
+#define TP_TF1_STRM_ID_0_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF1_STRM_ID_0_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF1_STRM_ID_0_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF1_STRM_ID_0_set0_shift                                                  (0)
+#define TP_TF1_STRM_ID_0_set0_mask                                                   (0x000000FF)
+#define TP_TF1_STRM_ID_0_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF1_STRM_ID_0_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF1_STRM_ID_0_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF1_STRM_ID_1                                                             0x18014220
+#define TP_TF1_STRM_ID_1_reg_addr                                                    "0xB8014220"
+#define TP_TF1_STRM_ID_1_reg                                                         0xB8014220
+#define set_TP_TF1_STRM_ID_1_reg(data)   (*((volatile unsigned int*) TP_TF1_STRM_ID_1_reg)=data)
+#define get_TP_TF1_STRM_ID_1_reg   (*((volatile unsigned int*) TP_TF1_STRM_ID_1_reg))
+#define TP_TF1_STRM_ID_1_inst_adr                                                    "0x0088"
+#define TP_TF1_STRM_ID_1_inst                                                        0x0088
+#define TP_TF1_STRM_ID_1_set3_shift                                                  (24)
+#define TP_TF1_STRM_ID_1_set3_mask                                                   (0xFF000000)
+#define TP_TF1_STRM_ID_1_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF1_STRM_ID_1_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF1_STRM_ID_1_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF1_STRM_ID_1_set2_shift                                                  (16)
+#define TP_TF1_STRM_ID_1_set2_mask                                                   (0x00FF0000)
+#define TP_TF1_STRM_ID_1_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF1_STRM_ID_1_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF1_STRM_ID_1_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF1_STRM_ID_1_set1_shift                                                  (8)
+#define TP_TF1_STRM_ID_1_set1_mask                                                   (0x0000FF00)
+#define TP_TF1_STRM_ID_1_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF1_STRM_ID_1_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF1_STRM_ID_1_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF1_STRM_ID_1_set0_shift                                                  (0)
+#define TP_TF1_STRM_ID_1_set0_mask                                                   (0x000000FF)
+#define TP_TF1_STRM_ID_1_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF1_STRM_ID_1_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF1_STRM_ID_1_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF1_STRM_ID_2                                                             0x18014224
+#define TP_TF1_STRM_ID_2_reg_addr                                                    "0xB8014224"
+#define TP_TF1_STRM_ID_2_reg                                                         0xB8014224
+#define set_TP_TF1_STRM_ID_2_reg(data)   (*((volatile unsigned int*) TP_TF1_STRM_ID_2_reg)=data)
+#define get_TP_TF1_STRM_ID_2_reg   (*((volatile unsigned int*) TP_TF1_STRM_ID_2_reg))
+#define TP_TF1_STRM_ID_2_inst_adr                                                    "0x0089"
+#define TP_TF1_STRM_ID_2_inst                                                        0x0089
+#define TP_TF1_STRM_ID_2_set3_shift                                                  (24)
+#define TP_TF1_STRM_ID_2_set3_mask                                                   (0xFF000000)
+#define TP_TF1_STRM_ID_2_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF1_STRM_ID_2_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF1_STRM_ID_2_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF1_STRM_ID_2_set2_shift                                                  (16)
+#define TP_TF1_STRM_ID_2_set2_mask                                                   (0x00FF0000)
+#define TP_TF1_STRM_ID_2_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF1_STRM_ID_2_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF1_STRM_ID_2_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF1_STRM_ID_2_set1_shift                                                  (8)
+#define TP_TF1_STRM_ID_2_set1_mask                                                   (0x0000FF00)
+#define TP_TF1_STRM_ID_2_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF1_STRM_ID_2_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF1_STRM_ID_2_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF1_STRM_ID_2_set0_shift                                                  (0)
+#define TP_TF1_STRM_ID_2_set0_mask                                                   (0x000000FF)
+#define TP_TF1_STRM_ID_2_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF1_STRM_ID_2_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF1_STRM_ID_2_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF1_STRM_ID_3                                                             0x18014228
+#define TP_TF1_STRM_ID_3_reg_addr                                                    "0xB8014228"
+#define TP_TF1_STRM_ID_3_reg                                                         0xB8014228
+#define set_TP_TF1_STRM_ID_3_reg(data)   (*((volatile unsigned int*) TP_TF1_STRM_ID_3_reg)=data)
+#define get_TP_TF1_STRM_ID_3_reg   (*((volatile unsigned int*) TP_TF1_STRM_ID_3_reg))
+#define TP_TF1_STRM_ID_3_inst_adr                                                    "0x008A"
+#define TP_TF1_STRM_ID_3_inst                                                        0x008A
+#define TP_TF1_STRM_ID_3_set3_shift                                                  (24)
+#define TP_TF1_STRM_ID_3_set3_mask                                                   (0xFF000000)
+#define TP_TF1_STRM_ID_3_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF1_STRM_ID_3_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF1_STRM_ID_3_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF1_STRM_ID_3_set2_shift                                                  (16)
+#define TP_TF1_STRM_ID_3_set2_mask                                                   (0x00FF0000)
+#define TP_TF1_STRM_ID_3_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF1_STRM_ID_3_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF1_STRM_ID_3_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF1_STRM_ID_3_set1_shift                                                  (8)
+#define TP_TF1_STRM_ID_3_set1_mask                                                   (0x0000FF00)
+#define TP_TF1_STRM_ID_3_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF1_STRM_ID_3_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF1_STRM_ID_3_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF1_STRM_ID_3_set0_shift                                                  (0)
+#define TP_TF1_STRM_ID_3_set0_mask                                                   (0x000000FF)
+#define TP_TF1_STRM_ID_3_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF1_STRM_ID_3_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF1_STRM_ID_3_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF1_STRM_VAL                                                              0x1801422c
+#define TP_TF1_STRM_VAL_reg_addr                                                     "0xB801422C"
+#define TP_TF1_STRM_VAL_reg                                                          0xB801422C
+#define set_TP_TF1_STRM_VAL_reg(data)   (*((volatile unsigned int*) TP_TF1_STRM_VAL_reg)=data)
+#define get_TP_TF1_STRM_VAL_reg   (*((volatile unsigned int*) TP_TF1_STRM_VAL_reg))
+#define TP_TF1_STRM_VAL_inst_adr                                                     "0x008B"
+#define TP_TF1_STRM_VAL_inst                                                         0x008B
+#define TP_TF1_STRM_VAL_val_set33_shift                                              (15)
+#define TP_TF1_STRM_VAL_val_set33_mask                                               (0x00008000)
+#define TP_TF1_STRM_VAL_val_set33(data)                                              (0x00008000&((data)<<15))
+#define TP_TF1_STRM_VAL_val_set33_src(data)                                          ((0x00008000&(data))>>15)
+#define TP_TF1_STRM_VAL_get_val_set33(data)                                          ((0x00008000&(data))>>15)
+#define TP_TF1_STRM_VAL_val_set32_shift                                              (14)
+#define TP_TF1_STRM_VAL_val_set32_mask                                               (0x00004000)
+#define TP_TF1_STRM_VAL_val_set32(data)                                              (0x00004000&((data)<<14))
+#define TP_TF1_STRM_VAL_val_set32_src(data)                                          ((0x00004000&(data))>>14)
+#define TP_TF1_STRM_VAL_get_val_set32(data)                                          ((0x00004000&(data))>>14)
+#define TP_TF1_STRM_VAL_val_set31_shift                                              (13)
+#define TP_TF1_STRM_VAL_val_set31_mask                                               (0x00002000)
+#define TP_TF1_STRM_VAL_val_set31(data)                                              (0x00002000&((data)<<13))
+#define TP_TF1_STRM_VAL_val_set31_src(data)                                          ((0x00002000&(data))>>13)
+#define TP_TF1_STRM_VAL_get_val_set31(data)                                          ((0x00002000&(data))>>13)
+#define TP_TF1_STRM_VAL_val_set30_shift                                              (12)
+#define TP_TF1_STRM_VAL_val_set30_mask                                               (0x00001000)
+#define TP_TF1_STRM_VAL_val_set30(data)                                              (0x00001000&((data)<<12))
+#define TP_TF1_STRM_VAL_val_set30_src(data)                                          ((0x00001000&(data))>>12)
+#define TP_TF1_STRM_VAL_get_val_set30(data)                                          ((0x00001000&(data))>>12)
+#define TP_TF1_STRM_VAL_val_set23_shift                                              (11)
+#define TP_TF1_STRM_VAL_val_set23_mask                                               (0x00000800)
+#define TP_TF1_STRM_VAL_val_set23(data)                                              (0x00000800&((data)<<11))
+#define TP_TF1_STRM_VAL_val_set23_src(data)                                          ((0x00000800&(data))>>11)
+#define TP_TF1_STRM_VAL_get_val_set23(data)                                          ((0x00000800&(data))>>11)
+#define TP_TF1_STRM_VAL_val_set22_shift                                              (10)
+#define TP_TF1_STRM_VAL_val_set22_mask                                               (0x00000400)
+#define TP_TF1_STRM_VAL_val_set22(data)                                              (0x00000400&((data)<<10))
+#define TP_TF1_STRM_VAL_val_set22_src(data)                                          ((0x00000400&(data))>>10)
+#define TP_TF1_STRM_VAL_get_val_set22(data)                                          ((0x00000400&(data))>>10)
+#define TP_TF1_STRM_VAL_val_set21_shift                                              (9)
+#define TP_TF1_STRM_VAL_val_set21_mask                                               (0x00000200)
+#define TP_TF1_STRM_VAL_val_set21(data)                                              (0x00000200&((data)<<9))
+#define TP_TF1_STRM_VAL_val_set21_src(data)                                          ((0x00000200&(data))>>9)
+#define TP_TF1_STRM_VAL_get_val_set21(data)                                          ((0x00000200&(data))>>9)
+#define TP_TF1_STRM_VAL_val_set20_shift                                              (8)
+#define TP_TF1_STRM_VAL_val_set20_mask                                               (0x00000100)
+#define TP_TF1_STRM_VAL_val_set20(data)                                              (0x00000100&((data)<<8))
+#define TP_TF1_STRM_VAL_val_set20_src(data)                                          ((0x00000100&(data))>>8)
+#define TP_TF1_STRM_VAL_get_val_set20(data)                                          ((0x00000100&(data))>>8)
+#define TP_TF1_STRM_VAL_val_set13_shift                                              (7)
+#define TP_TF1_STRM_VAL_val_set13_mask                                               (0x00000080)
+#define TP_TF1_STRM_VAL_val_set13(data)                                              (0x00000080&((data)<<7))
+#define TP_TF1_STRM_VAL_val_set13_src(data)                                          ((0x00000080&(data))>>7)
+#define TP_TF1_STRM_VAL_get_val_set13(data)                                          ((0x00000080&(data))>>7)
+#define TP_TF1_STRM_VAL_val_set12_shift                                              (6)
+#define TP_TF1_STRM_VAL_val_set12_mask                                               (0x00000040)
+#define TP_TF1_STRM_VAL_val_set12(data)                                              (0x00000040&((data)<<6))
+#define TP_TF1_STRM_VAL_val_set12_src(data)                                          ((0x00000040&(data))>>6)
+#define TP_TF1_STRM_VAL_get_val_set12(data)                                          ((0x00000040&(data))>>6)
+#define TP_TF1_STRM_VAL_val_set11_shift                                              (5)
+#define TP_TF1_STRM_VAL_val_set11_mask                                               (0x00000020)
+#define TP_TF1_STRM_VAL_val_set11(data)                                              (0x00000020&((data)<<5))
+#define TP_TF1_STRM_VAL_val_set11_src(data)                                          ((0x00000020&(data))>>5)
+#define TP_TF1_STRM_VAL_get_val_set11(data)                                          ((0x00000020&(data))>>5)
+#define TP_TF1_STRM_VAL_val_set10_shift                                              (4)
+#define TP_TF1_STRM_VAL_val_set10_mask                                               (0x00000010)
+#define TP_TF1_STRM_VAL_val_set10(data)                                              (0x00000010&((data)<<4))
+#define TP_TF1_STRM_VAL_val_set10_src(data)                                          ((0x00000010&(data))>>4)
+#define TP_TF1_STRM_VAL_get_val_set10(data)                                          ((0x00000010&(data))>>4)
+#define TP_TF1_STRM_VAL_val_set03_shift                                              (3)
+#define TP_TF1_STRM_VAL_val_set03_mask                                               (0x00000008)
+#define TP_TF1_STRM_VAL_val_set03(data)                                              (0x00000008&((data)<<3))
+#define TP_TF1_STRM_VAL_val_set03_src(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF1_STRM_VAL_get_val_set03(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF1_STRM_VAL_val_set02_shift                                              (2)
+#define TP_TF1_STRM_VAL_val_set02_mask                                               (0x00000004)
+#define TP_TF1_STRM_VAL_val_set02(data)                                              (0x00000004&((data)<<2))
+#define TP_TF1_STRM_VAL_val_set02_src(data)                                          ((0x00000004&(data))>>2)
+#define TP_TF1_STRM_VAL_get_val_set02(data)                                          ((0x00000004&(data))>>2)
+#define TP_TF1_STRM_VAL_val_set01_shift                                              (1)
+#define TP_TF1_STRM_VAL_val_set01_mask                                               (0x00000002)
+#define TP_TF1_STRM_VAL_val_set01(data)                                              (0x00000002&((data)<<1))
+#define TP_TF1_STRM_VAL_val_set01_src(data)                                          ((0x00000002&(data))>>1)
+#define TP_TF1_STRM_VAL_get_val_set01(data)                                          ((0x00000002&(data))>>1)
+#define TP_TF1_STRM_VAL_val_set00_shift                                              (0)
+#define TP_TF1_STRM_VAL_val_set00_mask                                               (0x00000001)
+#define TP_TF1_STRM_VAL_val_set00(data)                                              (0x00000001&((data)<<0))
+#define TP_TF1_STRM_VAL_val_set00_src(data)                                          ((0x00000001&(data))>>0)
+#define TP_TF1_STRM_VAL_get_val_set00(data)                                          ((0x00000001&(data))>>0)
+
+
+#define TP_TF2_CNTL                                                                  0x18014070
+#define TP_TF2_CNTL_reg_addr                                                         "0xB8014070"
+#define TP_TF2_CNTL_reg                                                              0xB8014070
+#define set_TP_TF2_CNTL_reg(data)   (*((volatile unsigned int*) TP_TF2_CNTL_reg)=data)
+#define get_TP_TF2_CNTL_reg   (*((volatile unsigned int*) TP_TF2_CNTL_reg))
+#define TP_TF2_CNTL_inst_adr                                                         "0x001C"
+#define TP_TF2_CNTL_inst                                                             0x001C
+#define TP_TF2_CNTL_tp_err_fix_en_shift                                              (17)
+#define TP_TF2_CNTL_tp_err_fix_en_mask                                               (0x00020000)
+#define TP_TF2_CNTL_tp_err_fix_en(data)                                              (0x00020000&((data)<<17))
+#define TP_TF2_CNTL_tp_err_fix_en_src(data)                                          ((0x00020000&(data))>>17)
+#define TP_TF2_CNTL_get_tp_err_fix_en(data)                                          ((0x00020000&(data))>>17)
+#define TP_TF2_CNTL_strm_id_en_shift                                                 (16)
+#define TP_TF2_CNTL_strm_id_en_mask                                                  (0x00010000)
+#define TP_TF2_CNTL_strm_id_en(data)                                                 (0x00010000&((data)<<16))
+#define TP_TF2_CNTL_strm_id_en_src(data)                                             ((0x00010000&(data))>>16)
+#define TP_TF2_CNTL_get_strm_id_en(data)                                             ((0x00010000&(data))>>16)
+#define TP_TF2_CNTL_buf_rdy_ctl_shift                                                (15)
+#define TP_TF2_CNTL_buf_rdy_ctl_mask                                                 (0x00008000)
+#define TP_TF2_CNTL_buf_rdy_ctl(data)                                                (0x00008000&((data)<<15))
+#define TP_TF2_CNTL_buf_rdy_ctl_src(data)                                            ((0x00008000&(data))>>15)
+#define TP_TF2_CNTL_get_buf_rdy_ctl(data)                                            ((0x00008000&(data))>>15)
+#define TP_TF2_CNTL_psc_en_shift                                                     (14)
+#define TP_TF2_CNTL_psc_en_mask                                                      (0x00004000)
+#define TP_TF2_CNTL_psc_en(data)                                                     (0x00004000&((data)<<14))
+#define TP_TF2_CNTL_psc_en_src(data)                                                 ((0x00004000&(data))>>14)
+#define TP_TF2_CNTL_get_psc_en(data)                                                 ((0x00004000&(data))>>14)
+#define TP_TF2_CNTL_pes_en_shift                                                     (13)
+#define TP_TF2_CNTL_pes_en_mask                                                      (0x00002000)
+#define TP_TF2_CNTL_pes_en(data)                                                     (0x00002000&((data)<<13))
+#define TP_TF2_CNTL_pes_en_src(data)                                                 ((0x00002000&(data))>>13)
+#define TP_TF2_CNTL_get_pes_en(data)                                                 ((0x00002000&(data))>>13)
+#define TP_TF2_CNTL_tsc_en_shift                                                     (12)
+#define TP_TF2_CNTL_tsc_en_mask                                                      (0x00001000)
+#define TP_TF2_CNTL_tsc_en(data)                                                     (0x00001000&((data)<<12))
+#define TP_TF2_CNTL_tsc_en_src(data)                                                 ((0x00001000&(data))>>12)
+#define TP_TF2_CNTL_get_tsc_en(data)                                                 ((0x00001000&(data))>>12)
+#define TP_TF2_CNTL_tb_shift                                                         (11)
+#define TP_TF2_CNTL_tb_mask                                                          (0x00000800)
+#define TP_TF2_CNTL_tb(data)                                                         (0x00000800&((data)<<11))
+#define TP_TF2_CNTL_tb_src(data)                                                     ((0x00000800&(data))>>11)
+#define TP_TF2_CNTL_get_tb(data)                                                     ((0x00000800&(data))>>11)
+#define TP_TF2_CNTL_busy_shift                                                       (10)
+#define TP_TF2_CNTL_busy_mask                                                        (0x00000400)
+#define TP_TF2_CNTL_busy(data)                                                       (0x00000400&((data)<<10))
+#define TP_TF2_CNTL_busy_src(data)                                                   ((0x00000400&(data))>>10)
+#define TP_TF2_CNTL_get_busy(data)                                                   ((0x00000400&(data))>>10)
+#define TP_TF2_CNTL_mode_shift                                                       (9)
+#define TP_TF2_CNTL_mode_mask                                                        (0x00000200)
+#define TP_TF2_CNTL_mode(data)                                                       (0x00000200&((data)<<9))
+#define TP_TF2_CNTL_mode_src(data)                                                   ((0x00000200&(data))>>9)
+#define TP_TF2_CNTL_get_mode(data)                                                   ((0x00000200&(data))>>9)
+#define TP_TF2_CNTL_du_en_shift                                                      (8)
+#define TP_TF2_CNTL_du_en_mask                                                       (0x00000100)
+#define TP_TF2_CNTL_du_en(data)                                                      (0x00000100&((data)<<8))
+#define TP_TF2_CNTL_du_en_src(data)                                                  ((0x00000100&(data))>>8)
+#define TP_TF2_CNTL_get_du_en(data)                                                  ((0x00000100&(data))>>8)
+#define TP_TF2_CNTL_de_en_shift                                                      (7)
+#define TP_TF2_CNTL_de_en_mask                                                       (0x00000080)
+#define TP_TF2_CNTL_de_en(data)                                                      (0x00000080&((data)<<7))
+#define TP_TF2_CNTL_de_en_src(data)                                                  ((0x00000080&(data))>>7)
+#define TP_TF2_CNTL_get_de_en(data)                                                  ((0x00000080&(data))>>7)
+#define TP_TF2_CNTL_xt_en_shift                                                      (6)
+#define TP_TF2_CNTL_xt_en_mask                                                       (0x00000040)
+#define TP_TF2_CNTL_xt_en(data)                                                      (0x00000040&((data)<<6))
+#define TP_TF2_CNTL_xt_en_src(data)                                                  ((0x00000040&(data))>>6)
+#define TP_TF2_CNTL_get_xt_en(data)                                                  ((0x00000040&(data))>>6)
+#define TP_TF2_CNTL_pid_en_shift                                                     (5)
+#define TP_TF2_CNTL_pid_en_mask                                                      (0x00000020)
+#define TP_TF2_CNTL_pid_en(data)                                                     (0x00000020&((data)<<5))
+#define TP_TF2_CNTL_pid_en_src(data)                                                 ((0x00000020&(data))>>5)
+#define TP_TF2_CNTL_get_pid_en(data)                                                 ((0x00000020&(data))>>5)
+#define TP_TF2_CNTL_null_en_shift                                                    (4)
+#define TP_TF2_CNTL_null_en_mask                                                     (0x00000010)
+#define TP_TF2_CNTL_null_en(data)                                                    (0x00000010&((data)<<4))
+#define TP_TF2_CNTL_null_en_src(data)                                                ((0x00000010&(data))>>4)
+#define TP_TF2_CNTL_get_null_en(data)                                                ((0x00000010&(data))>>4)
+#define TP_TF2_CNTL_trerr_en_shift                                                   (3)
+#define TP_TF2_CNTL_trerr_en_mask                                                    (0x00000008)
+#define TP_TF2_CNTL_trerr_en(data)                                                   (0x00000008&((data)<<3))
+#define TP_TF2_CNTL_trerr_en_src(data)                                               ((0x00000008&(data))>>3)
+#define TP_TF2_CNTL_get_trerr_en(data)                                               ((0x00000008&(data))>>3)
+#define TP_TF2_CNTL_sync_en_shift                                                    (2)
+#define TP_TF2_CNTL_sync_en_mask                                                     (0x00000004)
+#define TP_TF2_CNTL_sync_en(data)                                                    (0x00000004&((data)<<2))
+#define TP_TF2_CNTL_sync_en_src(data)                                                ((0x00000004&(data))>>2)
+#define TP_TF2_CNTL_get_sync_en(data)                                                ((0x00000004&(data))>>2)
+#define TP_TF2_CNTL_rst_en_shift                                                     (1)
+#define TP_TF2_CNTL_rst_en_mask                                                      (0x00000002)
+#define TP_TF2_CNTL_rst_en(data)                                                     (0x00000002&((data)<<1))
+#define TP_TF2_CNTL_rst_en_src(data)                                                 ((0x00000002&(data))>>1)
+#define TP_TF2_CNTL_get_rst_en(data)                                                 ((0x00000002&(data))>>1)
+#define TP_TF2_CNTL_write_data_shift                                                 (0)
+#define TP_TF2_CNTL_write_data_mask                                                  (0x00000001)
+#define TP_TF2_CNTL_write_data(data)                                                 (0x00000001&((data)<<0))
+#define TP_TF2_CNTL_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define TP_TF2_CNTL_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define TP_TF2_STRM_ID_0                                                             0x18014230
+#define TP_TF2_STRM_ID_0_reg_addr                                                    "0xB8014230"
+#define TP_TF2_STRM_ID_0_reg                                                         0xB8014230
+#define set_TP_TF2_STRM_ID_0_reg(data)   (*((volatile unsigned int*) TP_TF2_STRM_ID_0_reg)=data)
+#define get_TP_TF2_STRM_ID_0_reg   (*((volatile unsigned int*) TP_TF2_STRM_ID_0_reg))
+#define TP_TF2_STRM_ID_0_inst_adr                                                    "0x008C"
+#define TP_TF2_STRM_ID_0_inst                                                        0x008C
+#define TP_TF2_STRM_ID_0_set3_shift                                                  (24)
+#define TP_TF2_STRM_ID_0_set3_mask                                                   (0xFF000000)
+#define TP_TF2_STRM_ID_0_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF2_STRM_ID_0_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF2_STRM_ID_0_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF2_STRM_ID_0_set2_shift                                                  (16)
+#define TP_TF2_STRM_ID_0_set2_mask                                                   (0x00FF0000)
+#define TP_TF2_STRM_ID_0_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF2_STRM_ID_0_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF2_STRM_ID_0_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF2_STRM_ID_0_set1_shift                                                  (8)
+#define TP_TF2_STRM_ID_0_set1_mask                                                   (0x0000FF00)
+#define TP_TF2_STRM_ID_0_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF2_STRM_ID_0_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF2_STRM_ID_0_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF2_STRM_ID_0_set0_shift                                                  (0)
+#define TP_TF2_STRM_ID_0_set0_mask                                                   (0x000000FF)
+#define TP_TF2_STRM_ID_0_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF2_STRM_ID_0_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF2_STRM_ID_0_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF2_STRM_ID_1                                                             0x18014234
+#define TP_TF2_STRM_ID_1_reg_addr                                                    "0xB8014234"
+#define TP_TF2_STRM_ID_1_reg                                                         0xB8014234
+#define set_TP_TF2_STRM_ID_1_reg(data)   (*((volatile unsigned int*) TP_TF2_STRM_ID_1_reg)=data)
+#define get_TP_TF2_STRM_ID_1_reg   (*((volatile unsigned int*) TP_TF2_STRM_ID_1_reg))
+#define TP_TF2_STRM_ID_1_inst_adr                                                    "0x008D"
+#define TP_TF2_STRM_ID_1_inst                                                        0x008D
+#define TP_TF2_STRM_ID_1_set3_shift                                                  (24)
+#define TP_TF2_STRM_ID_1_set3_mask                                                   (0xFF000000)
+#define TP_TF2_STRM_ID_1_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF2_STRM_ID_1_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF2_STRM_ID_1_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF2_STRM_ID_1_set2_shift                                                  (16)
+#define TP_TF2_STRM_ID_1_set2_mask                                                   (0x00FF0000)
+#define TP_TF2_STRM_ID_1_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF2_STRM_ID_1_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF2_STRM_ID_1_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF2_STRM_ID_1_set1_shift                                                  (8)
+#define TP_TF2_STRM_ID_1_set1_mask                                                   (0x0000FF00)
+#define TP_TF2_STRM_ID_1_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF2_STRM_ID_1_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF2_STRM_ID_1_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF2_STRM_ID_1_set0_shift                                                  (0)
+#define TP_TF2_STRM_ID_1_set0_mask                                                   (0x000000FF)
+#define TP_TF2_STRM_ID_1_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF2_STRM_ID_1_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF2_STRM_ID_1_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF2_STRM_ID_2                                                             0x18014238
+#define TP_TF2_STRM_ID_2_reg_addr                                                    "0xB8014238"
+#define TP_TF2_STRM_ID_2_reg                                                         0xB8014238
+#define set_TP_TF2_STRM_ID_2_reg(data)   (*((volatile unsigned int*) TP_TF2_STRM_ID_2_reg)=data)
+#define get_TP_TF2_STRM_ID_2_reg   (*((volatile unsigned int*) TP_TF2_STRM_ID_2_reg))
+#define TP_TF2_STRM_ID_2_inst_adr                                                    "0x008E"
+#define TP_TF2_STRM_ID_2_inst                                                        0x008E
+#define TP_TF2_STRM_ID_2_set3_shift                                                  (24)
+#define TP_TF2_STRM_ID_2_set3_mask                                                   (0xFF000000)
+#define TP_TF2_STRM_ID_2_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF2_STRM_ID_2_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF2_STRM_ID_2_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF2_STRM_ID_2_set2_shift                                                  (16)
+#define TP_TF2_STRM_ID_2_set2_mask                                                   (0x00FF0000)
+#define TP_TF2_STRM_ID_2_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF2_STRM_ID_2_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF2_STRM_ID_2_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF2_STRM_ID_2_set1_shift                                                  (8)
+#define TP_TF2_STRM_ID_2_set1_mask                                                   (0x0000FF00)
+#define TP_TF2_STRM_ID_2_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF2_STRM_ID_2_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF2_STRM_ID_2_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF2_STRM_ID_2_set0_shift                                                  (0)
+#define TP_TF2_STRM_ID_2_set0_mask                                                   (0x000000FF)
+#define TP_TF2_STRM_ID_2_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF2_STRM_ID_2_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF2_STRM_ID_2_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF2_STRM_ID_3                                                             0x1801423C
+#define TP_TF2_STRM_ID_3_reg_addr                                                    "0xB801423C"
+#define TP_TF2_STRM_ID_3_reg                                                         0xB801423C
+#define set_TP_TF2_STRM_ID_3_reg(data)   (*((volatile unsigned int*) TP_TF2_STRM_ID_3_reg)=data)
+#define get_TP_TF2_STRM_ID_3_reg   (*((volatile unsigned int*) TP_TF2_STRM_ID_3_reg))
+#define TP_TF2_STRM_ID_3_inst_adr                                                    "0x008F"
+#define TP_TF2_STRM_ID_3_inst                                                        0x008F
+#define TP_TF2_STRM_ID_3_set3_shift                                                  (24)
+#define TP_TF2_STRM_ID_3_set3_mask                                                   (0xFF000000)
+#define TP_TF2_STRM_ID_3_set3(data)                                                  (0xFF000000&((data)<<24))
+#define TP_TF2_STRM_ID_3_set3_src(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF2_STRM_ID_3_get_set3(data)                                              ((0xFF000000&(data))>>24)
+#define TP_TF2_STRM_ID_3_set2_shift                                                  (16)
+#define TP_TF2_STRM_ID_3_set2_mask                                                   (0x00FF0000)
+#define TP_TF2_STRM_ID_3_set2(data)                                                  (0x00FF0000&((data)<<16))
+#define TP_TF2_STRM_ID_3_set2_src(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF2_STRM_ID_3_get_set2(data)                                              ((0x00FF0000&(data))>>16)
+#define TP_TF2_STRM_ID_3_set1_shift                                                  (8)
+#define TP_TF2_STRM_ID_3_set1_mask                                                   (0x0000FF00)
+#define TP_TF2_STRM_ID_3_set1(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TF2_STRM_ID_3_set1_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF2_STRM_ID_3_get_set1(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TF2_STRM_ID_3_set0_shift                                                  (0)
+#define TP_TF2_STRM_ID_3_set0_mask                                                   (0x000000FF)
+#define TP_TF2_STRM_ID_3_set0(data)                                                  (0x000000FF&((data)<<0))
+#define TP_TF2_STRM_ID_3_set0_src(data)                                              ((0x000000FF&(data))>>0)
+#define TP_TF2_STRM_ID_3_get_set0(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TP_TF2_STRM_VAL                                                              0x18014240
+#define TP_TF2_STRM_VAL_reg_addr                                                     "0xB8014240"
+#define TP_TF2_STRM_VAL_reg                                                          0xB8014240
+#define set_TP_TF2_STRM_VAL_reg(data)   (*((volatile unsigned int*) TP_TF2_STRM_VAL_reg)=data)
+#define get_TP_TF2_STRM_VAL_reg   (*((volatile unsigned int*) TP_TF2_STRM_VAL_reg))
+#define TP_TF2_STRM_VAL_inst_adr                                                     "0x0090"
+#define TP_TF2_STRM_VAL_inst                                                         0x0090
+#define TP_TF2_STRM_VAL_val_set33_shift                                              (15)
+#define TP_TF2_STRM_VAL_val_set33_mask                                               (0x00008000)
+#define TP_TF2_STRM_VAL_val_set33(data)                                              (0x00008000&((data)<<15))
+#define TP_TF2_STRM_VAL_val_set33_src(data)                                          ((0x00008000&(data))>>15)
+#define TP_TF2_STRM_VAL_get_val_set33(data)                                          ((0x00008000&(data))>>15)
+#define TP_TF2_STRM_VAL_val_set32_shift                                              (14)
+#define TP_TF2_STRM_VAL_val_set32_mask                                               (0x00004000)
+#define TP_TF2_STRM_VAL_val_set32(data)                                              (0x00004000&((data)<<14))
+#define TP_TF2_STRM_VAL_val_set32_src(data)                                          ((0x00004000&(data))>>14)
+#define TP_TF2_STRM_VAL_get_val_set32(data)                                          ((0x00004000&(data))>>14)
+#define TP_TF2_STRM_VAL_val_set31_shift                                              (13)
+#define TP_TF2_STRM_VAL_val_set31_mask                                               (0x00002000)
+#define TP_TF2_STRM_VAL_val_set31(data)                                              (0x00002000&((data)<<13))
+#define TP_TF2_STRM_VAL_val_set31_src(data)                                          ((0x00002000&(data))>>13)
+#define TP_TF2_STRM_VAL_get_val_set31(data)                                          ((0x00002000&(data))>>13)
+#define TP_TF2_STRM_VAL_val_set30_shift                                              (12)
+#define TP_TF2_STRM_VAL_val_set30_mask                                               (0x00001000)
+#define TP_TF2_STRM_VAL_val_set30(data)                                              (0x00001000&((data)<<12))
+#define TP_TF2_STRM_VAL_val_set30_src(data)                                          ((0x00001000&(data))>>12)
+#define TP_TF2_STRM_VAL_get_val_set30(data)                                          ((0x00001000&(data))>>12)
+#define TP_TF2_STRM_VAL_val_set23_shift                                              (11)
+#define TP_TF2_STRM_VAL_val_set23_mask                                               (0x00000800)
+#define TP_TF2_STRM_VAL_val_set23(data)                                              (0x00000800&((data)<<11))
+#define TP_TF2_STRM_VAL_val_set23_src(data)                                          ((0x00000800&(data))>>11)
+#define TP_TF2_STRM_VAL_get_val_set23(data)                                          ((0x00000800&(data))>>11)
+#define TP_TF2_STRM_VAL_val_set22_shift                                              (10)
+#define TP_TF2_STRM_VAL_val_set22_mask                                               (0x00000400)
+#define TP_TF2_STRM_VAL_val_set22(data)                                              (0x00000400&((data)<<10))
+#define TP_TF2_STRM_VAL_val_set22_src(data)                                          ((0x00000400&(data))>>10)
+#define TP_TF2_STRM_VAL_get_val_set22(data)                                          ((0x00000400&(data))>>10)
+#define TP_TF2_STRM_VAL_val_set21_shift                                              (9)
+#define TP_TF2_STRM_VAL_val_set21_mask                                               (0x00000200)
+#define TP_TF2_STRM_VAL_val_set21(data)                                              (0x00000200&((data)<<9))
+#define TP_TF2_STRM_VAL_val_set21_src(data)                                          ((0x00000200&(data))>>9)
+#define TP_TF2_STRM_VAL_get_val_set21(data)                                          ((0x00000200&(data))>>9)
+#define TP_TF2_STRM_VAL_val_set20_shift                                              (8)
+#define TP_TF2_STRM_VAL_val_set20_mask                                               (0x00000100)
+#define TP_TF2_STRM_VAL_val_set20(data)                                              (0x00000100&((data)<<8))
+#define TP_TF2_STRM_VAL_val_set20_src(data)                                          ((0x00000100&(data))>>8)
+#define TP_TF2_STRM_VAL_get_val_set20(data)                                          ((0x00000100&(data))>>8)
+#define TP_TF2_STRM_VAL_val_set13_shift                                              (7)
+#define TP_TF2_STRM_VAL_val_set13_mask                                               (0x00000080)
+#define TP_TF2_STRM_VAL_val_set13(data)                                              (0x00000080&((data)<<7))
+#define TP_TF2_STRM_VAL_val_set13_src(data)                                          ((0x00000080&(data))>>7)
+#define TP_TF2_STRM_VAL_get_val_set13(data)                                          ((0x00000080&(data))>>7)
+#define TP_TF2_STRM_VAL_val_set12_shift                                              (6)
+#define TP_TF2_STRM_VAL_val_set12_mask                                               (0x00000040)
+#define TP_TF2_STRM_VAL_val_set12(data)                                              (0x00000040&((data)<<6))
+#define TP_TF2_STRM_VAL_val_set12_src(data)                                          ((0x00000040&(data))>>6)
+#define TP_TF2_STRM_VAL_get_val_set12(data)                                          ((0x00000040&(data))>>6)
+#define TP_TF2_STRM_VAL_val_set11_shift                                              (5)
+#define TP_TF2_STRM_VAL_val_set11_mask                                               (0x00000020)
+#define TP_TF2_STRM_VAL_val_set11(data)                                              (0x00000020&((data)<<5))
+#define TP_TF2_STRM_VAL_val_set11_src(data)                                          ((0x00000020&(data))>>5)
+#define TP_TF2_STRM_VAL_get_val_set11(data)                                          ((0x00000020&(data))>>5)
+#define TP_TF2_STRM_VAL_val_set10_shift                                              (4)
+#define TP_TF2_STRM_VAL_val_set10_mask                                               (0x00000010)
+#define TP_TF2_STRM_VAL_val_set10(data)                                              (0x00000010&((data)<<4))
+#define TP_TF2_STRM_VAL_val_set10_src(data)                                          ((0x00000010&(data))>>4)
+#define TP_TF2_STRM_VAL_get_val_set10(data)                                          ((0x00000010&(data))>>4)
+#define TP_TF2_STRM_VAL_val_set03_shift                                              (3)
+#define TP_TF2_STRM_VAL_val_set03_mask                                               (0x00000008)
+#define TP_TF2_STRM_VAL_val_set03(data)                                              (0x00000008&((data)<<3))
+#define TP_TF2_STRM_VAL_val_set03_src(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF2_STRM_VAL_get_val_set03(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF2_STRM_VAL_val_set02_shift                                              (2)
+#define TP_TF2_STRM_VAL_val_set02_mask                                               (0x00000004)
+#define TP_TF2_STRM_VAL_val_set02(data)                                              (0x00000004&((data)<<2))
+#define TP_TF2_STRM_VAL_val_set02_src(data)                                          ((0x00000004&(data))>>2)
+#define TP_TF2_STRM_VAL_get_val_set02(data)                                          ((0x00000004&(data))>>2)
+#define TP_TF2_STRM_VAL_val_set01_shift                                              (1)
+#define TP_TF2_STRM_VAL_val_set01_mask                                               (0x00000002)
+#define TP_TF2_STRM_VAL_val_set01(data)                                              (0x00000002&((data)<<1))
+#define TP_TF2_STRM_VAL_val_set01_src(data)                                          ((0x00000002&(data))>>1)
+#define TP_TF2_STRM_VAL_get_val_set01(data)                                          ((0x00000002&(data))>>1)
+#define TP_TF2_STRM_VAL_val_set00_shift                                              (0)
+#define TP_TF2_STRM_VAL_val_set00_mask                                               (0x00000001)
+#define TP_TF2_STRM_VAL_val_set00(data)                                              (0x00000001&((data)<<0))
+#define TP_TF2_STRM_VAL_val_set00_src(data)                                          ((0x00000001&(data))>>0)
+#define TP_TF2_STRM_VAL_get_val_set00(data)                                          ((0x00000001&(data))>>0)
+
+
+#define TP_PCR_90K_CNT                                                               0x18014244
+#define TP_PCR_90K_CNT_reg_addr                                                      "0xB8014244"
+#define TP_PCR_90K_CNT_reg                                                           0xB8014244
+#define set_TP_PCR_90K_CNT_reg(data)   (*((volatile unsigned int*) TP_PCR_90K_CNT_reg)=data)
+#define get_TP_PCR_90K_CNT_reg   (*((volatile unsigned int*) TP_PCR_90K_CNT_reg))
+#define TP_PCR_90K_CNT_inst_adr                                                      "0x0091"
+#define TP_PCR_90K_CNT_inst                                                          0x0091
+#define TP_PCR_90K_CNT_pcr_90k_cnt_shift                                             (0)
+#define TP_PCR_90K_CNT_pcr_90k_cnt_mask                                              (0xFFFFFFFF)
+#define TP_PCR_90K_CNT_pcr_90k_cnt(data)                                             (0xFFFFFFFF&((data)<<0))
+#define TP_PCR_90K_CNT_pcr_90k_cnt_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define TP_PCR_90K_CNT_get_pcr_90k_cnt(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP0_PCR_CTL                                                                  0x18014248
+#define TP0_PCR_CTL_reg_addr                                                         "0xB8014248"
+#define TP0_PCR_CTL_reg                                                              0xB8014248
+#define set_TP0_PCR_CTL_reg(data)   (*((volatile unsigned int*) TP0_PCR_CTL_reg)=data)
+#define get_TP0_PCR_CTL_reg   (*((volatile unsigned int*) TP0_PCR_CTL_reg))
+#define TP0_PCR_CTL_inst_adr                                                         "0x0092"
+#define TP0_PCR_CTL_inst                                                             0x0092
+#define TP0_PCR_CTL_extra_func_ena_shift                                             (8)
+#define TP0_PCR_CTL_extra_func_ena_mask                                              (0x00000100)
+#define TP0_PCR_CTL_extra_func_ena(data)                                             (0x00000100&((data)<<8))
+#define TP0_PCR_CTL_extra_func_ena_src(data)                                         ((0x00000100&(data))>>8)
+#define TP0_PCR_CTL_get_extra_func_ena(data)                                         ((0x00000100&(data))>>8)
+#define TP0_PCR_CTL_extra_pid_addr_shift                                             (0)
+#define TP0_PCR_CTL_extra_pid_addr_mask                                              (0x0000007F)
+#define TP0_PCR_CTL_extra_pid_addr(data)                                             (0x0000007F&((data)<<0))
+#define TP0_PCR_CTL_extra_pid_addr_src(data)                                         ((0x0000007F&(data))>>0)
+#define TP0_PCR_CTL_get_extra_pid_addr(data)                                         ((0x0000007F&(data))>>0)
+
+
+#define TP1_PCR_CTL                                                                  0x1801424C
+#define TP1_PCR_CTL_reg_addr                                                         "0xB801424C"
+#define TP1_PCR_CTL_reg                                                              0xB801424C
+#define set_TP1_PCR_CTL_reg(data)   (*((volatile unsigned int*) TP1_PCR_CTL_reg)=data)
+#define get_TP1_PCR_CTL_reg   (*((volatile unsigned int*) TP1_PCR_CTL_reg))
+#define TP1_PCR_CTL_inst_adr                                                         "0x0093"
+#define TP1_PCR_CTL_inst                                                             0x0093
+#define TP1_PCR_CTL_extra_func_ena_shift                                             (8)
+#define TP1_PCR_CTL_extra_func_ena_mask                                              (0x00000100)
+#define TP1_PCR_CTL_extra_func_ena(data)                                             (0x00000100&((data)<<8))
+#define TP1_PCR_CTL_extra_func_ena_src(data)                                         ((0x00000100&(data))>>8)
+#define TP1_PCR_CTL_get_extra_func_ena(data)                                         ((0x00000100&(data))>>8)
+#define TP1_PCR_CTL_extra_pid_addr_shift                                             (0)
+#define TP1_PCR_CTL_extra_pid_addr_mask                                              (0x0000007F)
+#define TP1_PCR_CTL_extra_pid_addr(data)                                             (0x0000007F&((data)<<0))
+#define TP1_PCR_CTL_extra_pid_addr_src(data)                                         ((0x0000007F&(data))>>0)
+#define TP1_PCR_CTL_get_extra_pid_addr(data)                                         ((0x0000007F&(data))>>0)
+
+
+#define TP2_PCR_CTL                                                                  0x18014250
+#define TP2_PCR_CTL_reg_addr                                                         "0xB8014250"
+#define TP2_PCR_CTL_reg                                                              0xB8014250
+#define set_TP2_PCR_CTL_reg(data)   (*((volatile unsigned int*) TP2_PCR_CTL_reg)=data)
+#define get_TP2_PCR_CTL_reg   (*((volatile unsigned int*) TP2_PCR_CTL_reg))
+#define TP2_PCR_CTL_inst_adr                                                         "0x0094"
+#define TP2_PCR_CTL_inst                                                             0x0094
+#define TP2_PCR_CTL_extra_func_ena_shift                                             (8)
+#define TP2_PCR_CTL_extra_func_ena_mask                                              (0x00000100)
+#define TP2_PCR_CTL_extra_func_ena(data)                                             (0x00000100&((data)<<8))
+#define TP2_PCR_CTL_extra_func_ena_src(data)                                         ((0x00000100&(data))>>8)
+#define TP2_PCR_CTL_get_extra_func_ena(data)                                         ((0x00000100&(data))>>8)
+#define TP2_PCR_CTL_extra_pid_addr_shift                                             (0)
+#define TP2_PCR_CTL_extra_pid_addr_mask                                              (0x0000007F)
+#define TP2_PCR_CTL_extra_pid_addr(data)                                             (0x0000007F&((data)<<0))
+#define TP2_PCR_CTL_extra_pid_addr_src(data)                                         ((0x0000007F&(data))>>0)
+#define TP2_PCR_CTL_get_extra_pid_addr(data)                                         ((0x0000007F&(data))>>0)
+
+
+#define TP_PCR_LATCH                                                                 0x18014254
+#define TP_PCR_LATCH_reg_addr                                                        "0xB8014254"
+#define TP_PCR_LATCH_reg                                                             0xB8014254
+#define set_TP_PCR_LATCH_reg(data)   (*((volatile unsigned int*) TP_PCR_LATCH_reg)=data)
+#define get_TP_PCR_LATCH_reg   (*((volatile unsigned int*) TP_PCR_LATCH_reg))
+#define TP_PCR_LATCH_inst_adr                                                        "0x0095"
+#define TP_PCR_LATCH_inst                                                            0x0095
+#define TP_PCR_LATCH_latch_ena_shift                                                 (8)
+#define TP_PCR_LATCH_latch_ena_mask                                                  (0x00000100)
+#define TP_PCR_LATCH_latch_ena(data)                                                 (0x00000100&((data)<<8))
+#define TP_PCR_LATCH_latch_ena_src(data)                                             ((0x00000100&(data))>>8)
+#define TP_PCR_LATCH_get_latch_ena(data)                                             ((0x00000100&(data))>>8)
+#define TP_PCR_LATCH_latch_sel_shift                                                 (0)
+#define TP_PCR_LATCH_latch_sel_mask                                                  (0x00000003)
+#define TP_PCR_LATCH_latch_sel(data)                                                 (0x00000003&((data)<<0))
+#define TP_PCR_LATCH_latch_sel_src(data)                                             ((0x00000003&(data))>>0)
+#define TP_PCR_LATCH_get_latch_sel(data)                                             ((0x00000003&(data))>>0)
+
+
+#define TP_PCR_BASE                                                                  0x18014258
+#define TP_PCR_BASE_reg_addr                                                         "0xB8014258"
+#define TP_PCR_BASE_reg                                                              0xB8014258
+#define set_TP_PCR_BASE_reg(data)   (*((volatile unsigned int*) TP_PCR_BASE_reg)=data)
+#define get_TP_PCR_BASE_reg   (*((volatile unsigned int*) TP_PCR_BASE_reg))
+#define TP_PCR_BASE_inst_adr                                                         "0x0096"
+#define TP_PCR_BASE_inst                                                             0x0096
+#define TP_PCR_BASE_pcr_base_lo_shift                                                (0)
+#define TP_PCR_BASE_pcr_base_lo_mask                                                 (0xFFFFFFFF)
+#define TP_PCR_BASE_pcr_base_lo(data)                                                (0xFFFFFFFF&((data)<<0))
+#define TP_PCR_BASE_pcr_base_lo_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define TP_PCR_BASE_get_pcr_base_lo(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_PCR_EXT                                                                   0x1801425C
+#define TP_PCR_EXT_reg_addr                                                          "0xB801425C"
+#define TP_PCR_EXT_reg                                                               0xB801425C
+#define set_TP_PCR_EXT_reg(data)   (*((volatile unsigned int*) TP_PCR_EXT_reg)=data)
+#define get_TP_PCR_EXT_reg   (*((volatile unsigned int*) TP_PCR_EXT_reg))
+#define TP_PCR_EXT_inst_adr                                                          "0x0097"
+#define TP_PCR_EXT_inst                                                              0x0097
+#define TP_PCR_EXT_pcr_base_hi_shift                                                 (16)
+#define TP_PCR_EXT_pcr_base_hi_mask                                                  (0x00010000)
+#define TP_PCR_EXT_pcr_base_hi(data)                                                 (0x00010000&((data)<<16))
+#define TP_PCR_EXT_pcr_base_hi_src(data)                                             ((0x00010000&(data))>>16)
+#define TP_PCR_EXT_get_pcr_base_hi(data)                                             ((0x00010000&(data))>>16)
+#define TP_PCR_EXT_pcr_ext_shift                                                     (0)
+#define TP_PCR_EXT_pcr_ext_mask                                                      (0x000001FF)
+#define TP_PCR_EXT_pcr_ext(data)                                                     (0x000001FF&((data)<<0))
+#define TP_PCR_EXT_pcr_ext_src(data)                                                 ((0x000001FF&(data))>>0)
+#define TP_PCR_EXT_get_pcr_ext(data)                                                 ((0x000001FF&(data))>>0)
+
+
+#define TP_PCR_SYSTEM                                                                0x18014260
+#define TP_PCR_SYSTEM_reg_addr                                                       "0xB8014260"
+#define TP_PCR_SYSTEM_reg                                                            0xB8014260
+#define set_TP_PCR_SYSTEM_reg(data)   (*((volatile unsigned int*) TP_PCR_SYSTEM_reg)=data)
+#define get_TP_PCR_SYSTEM_reg   (*((volatile unsigned int*) TP_PCR_SYSTEM_reg))
+#define TP_PCR_SYSTEM_inst_adr                                                       "0x0098"
+#define TP_PCR_SYSTEM_inst                                                           0x0098
+#define TP_PCR_SYSTEM_system_ts_shift                                                (0)
+#define TP_PCR_SYSTEM_system_ts_mask                                                 (0xFFFFFFFF)
+#define TP_PCR_SYSTEM_system_ts(data)                                                (0xFFFFFFFF&((data)<<0))
+#define TP_PCR_SYSTEM_system_ts_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define TP_PCR_SYSTEM_get_system_ts(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_EMM_REJECT_CNT                                                            0x18014268
+#define TP_EMM_REJECT_CNT_reg_addr                                                   "0xB8014268"
+#define TP_EMM_REJECT_CNT_reg                                                        0xB8014268
+#define set_TP_EMM_REJECT_CNT_reg(data)   (*((volatile unsigned int*) TP_EMM_REJECT_CNT_reg)=data)
+#define get_TP_EMM_REJECT_CNT_reg   (*((volatile unsigned int*) TP_EMM_REJECT_CNT_reg))
+#define TP_EMM_REJECT_CNT_inst_adr                                                   "0x009A"
+#define TP_EMM_REJECT_CNT_inst                                                       0x009A
+#define TP_EMM_REJECT_CNT_num_shift                                                  (0)
+#define TP_EMM_REJECT_CNT_num_mask                                                   (0x0000FFFF)
+#define TP_EMM_REJECT_CNT_num(data)                                                  (0x0000FFFF&((data)<<0))
+#define TP_EMM_REJECT_CNT_num_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define TP_EMM_REJECT_CNT_get_num(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define TP_EMM_PRE_DES                                                               0x1801426C
+#define TP_EMM_PRE_DES_reg_addr                                                      "0xB801426C"
+#define TP_EMM_PRE_DES_reg                                                           0xB801426C
+#define set_TP_EMM_PRE_DES_reg(data)   (*((volatile unsigned int*) TP_EMM_PRE_DES_reg)=data)
+#define get_TP_EMM_PRE_DES_reg   (*((volatile unsigned int*) TP_EMM_PRE_DES_reg))
+#define TP_EMM_PRE_DES_inst_adr                                                      "0x009B"
+#define TP_EMM_PRE_DES_inst                                                          0x009B
+#define TP_EMM_PRE_DES_pre_des_shift                                                 (8)
+#define TP_EMM_PRE_DES_pre_des_mask                                                  (0x00000100)
+#define TP_EMM_PRE_DES_pre_des(data)                                                 (0x00000100&((data)<<8))
+#define TP_EMM_PRE_DES_pre_des_src(data)                                             ((0x00000100&(data))>>8)
+#define TP_EMM_PRE_DES_get_pre_des(data)                                             ((0x00000100&(data))>>8)
+#define TP_EMM_PRE_DES_key_sel_shift                                                 (0)
+#define TP_EMM_PRE_DES_key_sel_mask                                                  (0x0000001F)
+#define TP_EMM_PRE_DES_key_sel(data)                                                 (0x0000001F&((data)<<0))
+#define TP_EMM_PRE_DES_key_sel_src(data)                                             ((0x0000001F&(data))>>0)
+#define TP_EMM_PRE_DES_get_key_sel(data)                                             ((0x0000001F&(data))>>0)
+
+
+#define TP_TF1_CNT                                                                   0x18014014
+#define TP_TF1_CNT_reg_addr                                                          "0xB8014014"
+#define TP_TF1_CNT_reg                                                               0xB8014014
+#define set_TP_TF1_CNT_reg(data)   (*((volatile unsigned int*) TP_TF1_CNT_reg)=data)
+#define get_TP_TF1_CNT_reg   (*((volatile unsigned int*) TP_TF1_CNT_reg))
+#define TP_TF1_CNT_inst_adr                                                          "0x0005"
+#define TP_TF1_CNT_inst                                                              0x0005
+#define TP_TF1_CNT_cnt_shift                                                         (0)
+#define TP_TF1_CNT_cnt_mask                                                          (0x00FFFFFF)
+#define TP_TF1_CNT_cnt(data)                                                         (0x00FFFFFF&((data)<<0))
+#define TP_TF1_CNT_cnt_src(data)                                                     ((0x00FFFFFF&(data))>>0)
+#define TP_TF1_CNT_get_cnt(data)                                                     ((0x00FFFFFF&(data))>>0)
+
+
+#define TP_TF1_DRP_CNT                                                               0x18014018
+#define TP_TF1_DRP_CNT_reg_addr                                                      "0xB8014018"
+#define TP_TF1_DRP_CNT_reg                                                           0xB8014018
+#define set_TP_TF1_DRP_CNT_reg(data)   (*((volatile unsigned int*) TP_TF1_DRP_CNT_reg)=data)
+#define get_TP_TF1_DRP_CNT_reg   (*((volatile unsigned int*) TP_TF1_DRP_CNT_reg))
+#define TP_TF1_DRP_CNT_inst_adr                                                      "0x0006"
+#define TP_TF1_DRP_CNT_inst                                                          0x0006
+#define TP_TF1_DRP_CNT_drp_cnt_shift                                                 (0)
+#define TP_TF1_DRP_CNT_drp_cnt_mask                                                  (0x0000FFFF)
+#define TP_TF1_DRP_CNT_drp_cnt(data)                                                 (0x0000FFFF&((data)<<0))
+#define TP_TF1_DRP_CNT_drp_cnt_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define TP_TF1_DRP_CNT_get_drp_cnt(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define TP_TF1_ERR_CNT                                                               0x1801401C
+#define TP_TF1_ERR_CNT_reg_addr                                                      "0xB801401C"
+#define TP_TF1_ERR_CNT_reg                                                           0xB801401C
+#define set_TP_TF1_ERR_CNT_reg(data)   (*((volatile unsigned int*) TP_TF1_ERR_CNT_reg)=data)
+#define get_TP_TF1_ERR_CNT_reg   (*((volatile unsigned int*) TP_TF1_ERR_CNT_reg))
+#define TP_TF1_ERR_CNT_inst_adr                                                      "0x0007"
+#define TP_TF1_ERR_CNT_inst                                                          0x0007
+#define TP_TF1_ERR_CNT_err_cnt_shift                                                 (0)
+#define TP_TF1_ERR_CNT_err_cnt_mask                                                  (0x0000FFFF)
+#define TP_TF1_ERR_CNT_err_cnt(data)                                                 (0x0000FFFF&((data)<<0))
+#define TP_TF1_ERR_CNT_err_cnt_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define TP_TF1_ERR_CNT_get_err_cnt(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define TP_TF2_CNT                                                                   0x18014074
+#define TP_TF2_CNT_reg_addr                                                          "0xB8014074"
+#define TP_TF2_CNT_reg                                                               0xB8014074
+#define set_TP_TF2_CNT_reg(data)   (*((volatile unsigned int*) TP_TF2_CNT_reg)=data)
+#define get_TP_TF2_CNT_reg   (*((volatile unsigned int*) TP_TF2_CNT_reg))
+#define TP_TF2_CNT_inst_adr                                                          "0x001D"
+#define TP_TF2_CNT_inst                                                              0x001D
+#define TP_TF2_CNT_cnt_shift                                                         (0)
+#define TP_TF2_CNT_cnt_mask                                                          (0x00FFFFFF)
+#define TP_TF2_CNT_cnt(data)                                                         (0x00FFFFFF&((data)<<0))
+#define TP_TF2_CNT_cnt_src(data)                                                     ((0x00FFFFFF&(data))>>0)
+#define TP_TF2_CNT_get_cnt(data)                                                     ((0x00FFFFFF&(data))>>0)
+
+
+#define TP_TF2_DRP_CNT                                                               0x18014078
+#define TP_TF2_DRP_CNT_reg_addr                                                      "0xB8014078"
+#define TP_TF2_DRP_CNT_reg                                                           0xB8014078
+#define set_TP_TF2_DRP_CNT_reg(data)   (*((volatile unsigned int*) TP_TF2_DRP_CNT_reg)=data)
+#define get_TP_TF2_DRP_CNT_reg   (*((volatile unsigned int*) TP_TF2_DRP_CNT_reg))
+#define TP_TF2_DRP_CNT_inst_adr                                                      "0x001E"
+#define TP_TF2_DRP_CNT_inst                                                          0x001E
+#define TP_TF2_DRP_CNT_drp_cnt_shift                                                 (0)
+#define TP_TF2_DRP_CNT_drp_cnt_mask                                                  (0x0000FFFF)
+#define TP_TF2_DRP_CNT_drp_cnt(data)                                                 (0x0000FFFF&((data)<<0))
+#define TP_TF2_DRP_CNT_drp_cnt_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define TP_TF2_DRP_CNT_get_drp_cnt(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define TP_TF2_ERR_CNT                                                               0x1801407C
+#define TP_TF2_ERR_CNT_reg_addr                                                      "0xB801407C"
+#define TP_TF2_ERR_CNT_reg                                                           0xB801407C
+#define set_TP_TF2_ERR_CNT_reg(data)   (*((volatile unsigned int*) TP_TF2_ERR_CNT_reg)=data)
+#define get_TP_TF2_ERR_CNT_reg   (*((volatile unsigned int*) TP_TF2_ERR_CNT_reg))
+#define TP_TF2_ERR_CNT_inst_adr                                                      "0x001F"
+#define TP_TF2_ERR_CNT_inst                                                          0x001F
+#define TP_TF2_ERR_CNT_err_cnt_shift                                                 (0)
+#define TP_TF2_ERR_CNT_err_cnt_mask                                                  (0x0000FFFF)
+#define TP_TF2_ERR_CNT_err_cnt(data)                                                 (0x0000FFFF&((data)<<0))
+#define TP_TF2_ERR_CNT_err_cnt_src(data)                                             ((0x0000FFFF&(data))>>0)
+#define TP_TF2_ERR_CNT_get_err_cnt(data)                                             ((0x0000FFFF&(data))>>0)
+
+
+#define TP_TF0_FRMCFG                                                                0x18014824
+#define TP_TF0_FRMCFG_reg_addr                                                       "0xB8014824"
+#define TP_TF0_FRMCFG_reg                                                            0xB8014824
+#define set_TP_TF0_FRMCFG_reg(data)   (*((volatile unsigned int*) TP_TF0_FRMCFG_reg)=data)
+#define get_TP_TF0_FRMCFG_reg   (*((volatile unsigned int*) TP_TF0_FRMCFG_reg))
+#define TP_TF0_FRMCFG_inst_adr                                                       "0x0009"
+#define TP_TF0_FRMCFG_inst                                                           0x0009
+#define TP_TF0_FRMCFG_sync_byte_shift                                                (24)
+#define TP_TF0_FRMCFG_sync_byte_mask                                                 (0xFF000000)
+#define TP_TF0_FRMCFG_sync_byte(data)                                                (0xFF000000&((data)<<24))
+#define TP_TF0_FRMCFG_sync_byte_src(data)                                            ((0xFF000000&(data))>>24)
+#define TP_TF0_FRMCFG_get_sync_byte(data)                                            ((0xFF000000&(data))>>24)
+#define TP_TF0_FRMCFG_dropno_shift                                                   (20)
+#define TP_TF0_FRMCFG_dropno_mask                                                    (0x00F00000)
+#define TP_TF0_FRMCFG_dropno(data)                                                   (0x00F00000&((data)<<20))
+#define TP_TF0_FRMCFG_dropno_src(data)                                               ((0x00F00000&(data))>>20)
+#define TP_TF0_FRMCFG_get_dropno(data)                                               ((0x00F00000&(data))>>20)
+#define TP_TF0_FRMCFG_lockno_shift                                                   (16)
+#define TP_TF0_FRMCFG_lockno_mask                                                    (0x000F0000)
+#define TP_TF0_FRMCFG_lockno(data)                                                   (0x000F0000&((data)<<16))
+#define TP_TF0_FRMCFG_lockno_src(data)                                               ((0x000F0000&(data))>>16)
+#define TP_TF0_FRMCFG_get_lockno(data)                                               ((0x000F0000&(data))>>16)
+#define TP_TF0_FRMCFG_packet_size_shift                                              (14)
+#define TP_TF0_FRMCFG_packet_size_mask                                               (0x0000C000)
+#define TP_TF0_FRMCFG_packet_size(data)                                              (0x0000C000&((data)<<14))
+#define TP_TF0_FRMCFG_packet_size_src(data)                                          ((0x0000C000&(data))>>14)
+#define TP_TF0_FRMCFG_get_packet_size(data)                                          ((0x0000C000&(data))>>14)
+#define TP_TF0_FRMCFG_data_order_shift                                               (13)
+#define TP_TF0_FRMCFG_data_order_mask                                                (0x00002000)
+#define TP_TF0_FRMCFG_data_order(data)                                               (0x00002000&((data)<<13))
+#define TP_TF0_FRMCFG_data_order_src(data)                                           ((0x00002000&(data))>>13)
+#define TP_TF0_FRMCFG_get_data_order(data)                                           ((0x00002000&(data))>>13)
+#define TP_TF0_FRMCFG_frm_en_shift                                                   (12)
+#define TP_TF0_FRMCFG_frm_en_mask                                                    (0x00001000)
+#define TP_TF0_FRMCFG_frm_en(data)                                                   (0x00001000&((data)<<12))
+#define TP_TF0_FRMCFG_frm_en_src(data)                                               ((0x00001000&(data))>>12)
+#define TP_TF0_FRMCFG_get_frm_en(data)                                               ((0x00001000&(data))>>12)
+#define TP_TF0_FRMCFG_forcedrop_shift                                                (11)
+#define TP_TF0_FRMCFG_forcedrop_mask                                                 (0x00000800)
+#define TP_TF0_FRMCFG_forcedrop(data)                                                (0x00000800&((data)<<11))
+#define TP_TF0_FRMCFG_forcedrop_src(data)                                            ((0x00000800&(data))>>11)
+#define TP_TF0_FRMCFG_get_forcedrop(data)                                            ((0x00000800&(data))>>11)
+#define TP_TF0_FRMCFG_syncmode_shift                                                 (6)
+#define TP_TF0_FRMCFG_syncmode_mask                                                  (0x000007C0)
+#define TP_TF0_FRMCFG_syncmode(data)                                                 (0x000007C0&((data)<<6))
+#define TP_TF0_FRMCFG_syncmode_src(data)                                             ((0x000007C0&(data))>>6)
+#define TP_TF0_FRMCFG_get_syncmode(data)                                             ((0x000007C0&(data))>>6)
+#define TP_TF0_FRMCFG_serial_shift                                                   (5)
+#define TP_TF0_FRMCFG_serial_mask                                                    (0x00000020)
+#define TP_TF0_FRMCFG_serial(data)                                                   (0x00000020&((data)<<5))
+#define TP_TF0_FRMCFG_serial_src(data)                                               ((0x00000020&(data))>>5)
+#define TP_TF0_FRMCFG_get_serial(data)                                               ((0x00000020&(data))>>5)
+#define TP_TF0_FRMCFG_datapin_shift                                                  (4)
+#define TP_TF0_FRMCFG_datapin_mask                                                   (0x00000010)
+#define TP_TF0_FRMCFG_datapin(data)                                                  (0x00000010&((data)<<4))
+#define TP_TF0_FRMCFG_datapin_src(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF0_FRMCFG_get_datapin(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF0_FRMCFG_err_pol_shift                                                  (3)
+#define TP_TF0_FRMCFG_err_pol_mask                                                   (0x00000008)
+#define TP_TF0_FRMCFG_err_pol(data)                                                  (0x00000008&((data)<<3))
+#define TP_TF0_FRMCFG_err_pol_src(data)                                              ((0x00000008&(data))>>3)
+#define TP_TF0_FRMCFG_get_err_pol(data)                                              ((0x00000008&(data))>>3)
+#define TP_TF0_FRMCFG_sync_pol_shift                                                 (2)
+#define TP_TF0_FRMCFG_sync_pol_mask                                                  (0x00000004)
+#define TP_TF0_FRMCFG_sync_pol(data)                                                 (0x00000004&((data)<<2))
+#define TP_TF0_FRMCFG_sync_pol_src(data)                                             ((0x00000004&(data))>>2)
+#define TP_TF0_FRMCFG_get_sync_pol(data)                                             ((0x00000004&(data))>>2)
+#define TP_TF0_FRMCFG_val_pol_shift                                                  (1)
+#define TP_TF0_FRMCFG_val_pol_mask                                                   (0x00000002)
+#define TP_TF0_FRMCFG_val_pol(data)                                                  (0x00000002&((data)<<1))
+#define TP_TF0_FRMCFG_val_pol_src(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF0_FRMCFG_get_val_pol(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF0_FRMCFG_clk_pol_shift                                                  (0)
+#define TP_TF0_FRMCFG_clk_pol_mask                                                   (0x00000001)
+#define TP_TF0_FRMCFG_clk_pol(data)                                                  (0x00000001&((data)<<0))
+#define TP_TF0_FRMCFG_clk_pol_src(data)                                              ((0x00000001&(data))>>0)
+#define TP_TF0_FRMCFG_get_clk_pol(data)                                              ((0x00000001&(data))>>0)
+
+
+#define TP_TF0_INT                                                                   0x18014828
+#define TP_TF0_INT_reg_addr                                                          "0xB8014828"
+#define TP_TF0_INT_reg                                                               0xB8014828
+#define set_TP_TF0_INT_reg(data)   (*((volatile unsigned int*) TP_TF0_INT_reg)=data)
+#define get_TP_TF0_INT_reg   (*((volatile unsigned int*) TP_TF0_INT_reg))
+#define TP_TF0_INT_inst_adr                                                          "0x000A"
+#define TP_TF0_INT_inst                                                              0x000A
+#define TP_TF0_INT_adf_pcr_in_shift                                                  (4)
+#define TP_TF0_INT_adf_pcr_in_mask                                                   (0x00000010)
+#define TP_TF0_INT_adf_pcr_in(data)                                                  (0x00000010&((data)<<4))
+#define TP_TF0_INT_adf_pcr_in_src(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF0_INT_get_adf_pcr_in(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF0_INT_overflow_shift                                                    (3)
+#define TP_TF0_INT_overflow_mask                                                     (0x00000008)
+#define TP_TF0_INT_overflow(data)                                                    (0x00000008&((data)<<3))
+#define TP_TF0_INT_overflow_src(data)                                                ((0x00000008&(data))>>3)
+#define TP_TF0_INT_get_overflow(data)                                                ((0x00000008&(data))>>3)
+#define TP_TF0_INT_drop_shift                                                        (2)
+#define TP_TF0_INT_drop_mask                                                         (0x00000004)
+#define TP_TF0_INT_drop(data)                                                        (0x00000004&((data)<<2))
+#define TP_TF0_INT_drop_src(data)                                                    ((0x00000004&(data))>>2)
+#define TP_TF0_INT_get_drop(data)                                                    ((0x00000004&(data))>>2)
+#define TP_TF0_INT_sync_shift                                                        (1)
+#define TP_TF0_INT_sync_mask                                                         (0x00000002)
+#define TP_TF0_INT_sync(data)                                                        (0x00000002&((data)<<1))
+#define TP_TF0_INT_sync_src(data)                                                    ((0x00000002&(data))>>1)
+#define TP_TF0_INT_get_sync(data)                                                    ((0x00000002&(data))>>1)
+#define TP_TF0_INT_write_data_shift                                                  (0)
+#define TP_TF0_INT_write_data_mask                                                   (0x00000001)
+#define TP_TF0_INT_write_data(data)                                                  (0x00000001&((data)<<0))
+#define TP_TF0_INT_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define TP_TF0_INT_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define TP_TF0_INT_EN                                                                0x1801482C
+#define TP_TF0_INT_EN_reg_addr                                                       "0xB801482C"
+#define TP_TF0_INT_EN_reg                                                            0xB801482C
+#define set_TP_TF0_INT_EN_reg(data)   (*((volatile unsigned int*) TP_TF0_INT_EN_reg)=data)
+#define get_TP_TF0_INT_EN_reg   (*((volatile unsigned int*) TP_TF0_INT_EN_reg))
+#define TP_TF0_INT_EN_inst_adr                                                       "0x000B"
+#define TP_TF0_INT_EN_inst                                                           0x000B
+#define TP_TF0_INT_EN_adf_pcr_in_en_shift                                            (4)
+#define TP_TF0_INT_EN_adf_pcr_in_en_mask                                             (0x00000010)
+#define TP_TF0_INT_EN_adf_pcr_in_en(data)                                            (0x00000010&((data)<<4))
+#define TP_TF0_INT_EN_adf_pcr_in_en_src(data)                                        ((0x00000010&(data))>>4)
+#define TP_TF0_INT_EN_get_adf_pcr_in_en(data)                                        ((0x00000010&(data))>>4)
+#define TP_TF0_INT_EN_overflow_en_shift                                              (3)
+#define TP_TF0_INT_EN_overflow_en_mask                                               (0x00000008)
+#define TP_TF0_INT_EN_overflow_en(data)                                              (0x00000008&((data)<<3))
+#define TP_TF0_INT_EN_overflow_en_src(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF0_INT_EN_get_overflow_en(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF0_INT_EN_drop_en_shift                                                  (2)
+#define TP_TF0_INT_EN_drop_en_mask                                                   (0x00000004)
+#define TP_TF0_INT_EN_drop_en(data)                                                  (0x00000004&((data)<<2))
+#define TP_TF0_INT_EN_drop_en_src(data)                                              ((0x00000004&(data))>>2)
+#define TP_TF0_INT_EN_get_drop_en(data)                                              ((0x00000004&(data))>>2)
+#define TP_TF0_INT_EN_sync_en_shift                                                  (1)
+#define TP_TF0_INT_EN_sync_en_mask                                                   (0x00000002)
+#define TP_TF0_INT_EN_sync_en(data)                                                  (0x00000002&((data)<<1))
+#define TP_TF0_INT_EN_sync_en_src(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF0_INT_EN_get_sync_en(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF0_INT_EN_write_data_shift                                               (0)
+#define TP_TF0_INT_EN_write_data_mask                                                (0x00000001)
+#define TP_TF0_INT_EN_write_data(data)                                               (0x00000001&((data)<<0))
+#define TP_TF0_INT_EN_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define TP_TF0_INT_EN_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define TP_TF1_FRMCFG                                                                0x18014830
+#define TP_TF1_FRMCFG_reg_addr                                                       "0xB8014830"
+#define TP_TF1_FRMCFG_reg                                                            0xB8014830
+#define set_TP_TF1_FRMCFG_reg(data)   (*((volatile unsigned int*) TP_TF1_FRMCFG_reg)=data)
+#define get_TP_TF1_FRMCFG_reg   (*((volatile unsigned int*) TP_TF1_FRMCFG_reg))
+#define TP_TF1_FRMCFG_inst_adr                                                       "0x000C"
+#define TP_TF1_FRMCFG_inst                                                           0x000C
+#define TP_TF1_FRMCFG_sync_byte_shift                                                (24)
+#define TP_TF1_FRMCFG_sync_byte_mask                                                 (0xFF000000)
+#define TP_TF1_FRMCFG_sync_byte(data)                                                (0xFF000000&((data)<<24))
+#define TP_TF1_FRMCFG_sync_byte_src(data)                                            ((0xFF000000&(data))>>24)
+#define TP_TF1_FRMCFG_get_sync_byte(data)                                            ((0xFF000000&(data))>>24)
+#define TP_TF1_FRMCFG_dropno_shift                                                   (20)
+#define TP_TF1_FRMCFG_dropno_mask                                                    (0x00F00000)
+#define TP_TF1_FRMCFG_dropno(data)                                                   (0x00F00000&((data)<<20))
+#define TP_TF1_FRMCFG_dropno_src(data)                                               ((0x00F00000&(data))>>20)
+#define TP_TF1_FRMCFG_get_dropno(data)                                               ((0x00F00000&(data))>>20)
+#define TP_TF1_FRMCFG_lockno_shift                                                   (16)
+#define TP_TF1_FRMCFG_lockno_mask                                                    (0x000F0000)
+#define TP_TF1_FRMCFG_lockno(data)                                                   (0x000F0000&((data)<<16))
+#define TP_TF1_FRMCFG_lockno_src(data)                                               ((0x000F0000&(data))>>16)
+#define TP_TF1_FRMCFG_get_lockno(data)                                               ((0x000F0000&(data))>>16)
+#define TP_TF1_FRMCFG_packet_size_shift                                              (14)
+#define TP_TF1_FRMCFG_packet_size_mask                                               (0x0000C000)
+#define TP_TF1_FRMCFG_packet_size(data)                                              (0x0000C000&((data)<<14))
+#define TP_TF1_FRMCFG_packet_size_src(data)                                          ((0x0000C000&(data))>>14)
+#define TP_TF1_FRMCFG_get_packet_size(data)                                          ((0x0000C000&(data))>>14)
+#define TP_TF1_FRMCFG_data_order_shift                                               (13)
+#define TP_TF1_FRMCFG_data_order_mask                                                (0x00002000)
+#define TP_TF1_FRMCFG_data_order(data)                                               (0x00002000&((data)<<13))
+#define TP_TF1_FRMCFG_data_order_src(data)                                           ((0x00002000&(data))>>13)
+#define TP_TF1_FRMCFG_get_data_order(data)                                           ((0x00002000&(data))>>13)
+#define TP_TF1_FRMCFG_frm_en_shift                                                   (12)
+#define TP_TF1_FRMCFG_frm_en_mask                                                    (0x00001000)
+#define TP_TF1_FRMCFG_frm_en(data)                                                   (0x00001000&((data)<<12))
+#define TP_TF1_FRMCFG_frm_en_src(data)                                               ((0x00001000&(data))>>12)
+#define TP_TF1_FRMCFG_get_frm_en(data)                                               ((0x00001000&(data))>>12)
+#define TP_TF1_FRMCFG_forcedrop_shift                                                (11)
+#define TP_TF1_FRMCFG_forcedrop_mask                                                 (0x00000800)
+#define TP_TF1_FRMCFG_forcedrop(data)                                                (0x00000800&((data)<<11))
+#define TP_TF1_FRMCFG_forcedrop_src(data)                                            ((0x00000800&(data))>>11)
+#define TP_TF1_FRMCFG_get_forcedrop(data)                                            ((0x00000800&(data))>>11)
+#define TP_TF1_FRMCFG_syncmode_shift                                                 (6)
+#define TP_TF1_FRMCFG_syncmode_mask                                                  (0x000007C0)
+#define TP_TF1_FRMCFG_syncmode(data)                                                 (0x000007C0&((data)<<6))
+#define TP_TF1_FRMCFG_syncmode_src(data)                                             ((0x000007C0&(data))>>6)
+#define TP_TF1_FRMCFG_get_syncmode(data)                                             ((0x000007C0&(data))>>6)
+#define TP_TF1_FRMCFG_serial_shift                                                   (5)
+#define TP_TF1_FRMCFG_serial_mask                                                    (0x00000020)
+#define TP_TF1_FRMCFG_serial(data)                                                   (0x00000020&((data)<<5))
+#define TP_TF1_FRMCFG_serial_src(data)                                               ((0x00000020&(data))>>5)
+#define TP_TF1_FRMCFG_get_serial(data)                                               ((0x00000020&(data))>>5)
+#define TP_TF1_FRMCFG_datapin_shift                                                  (4)
+#define TP_TF1_FRMCFG_datapin_mask                                                   (0x00000010)
+#define TP_TF1_FRMCFG_datapin(data)                                                  (0x00000010&((data)<<4))
+#define TP_TF1_FRMCFG_datapin_src(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF1_FRMCFG_get_datapin(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF1_FRMCFG_err_pol_shift                                                  (3)
+#define TP_TF1_FRMCFG_err_pol_mask                                                   (0x00000008)
+#define TP_TF1_FRMCFG_err_pol(data)                                                  (0x00000008&((data)<<3))
+#define TP_TF1_FRMCFG_err_pol_src(data)                                              ((0x00000008&(data))>>3)
+#define TP_TF1_FRMCFG_get_err_pol(data)                                              ((0x00000008&(data))>>3)
+#define TP_TF1_FRMCFG_sync_pol_shift                                                 (2)
+#define TP_TF1_FRMCFG_sync_pol_mask                                                  (0x00000004)
+#define TP_TF1_FRMCFG_sync_pol(data)                                                 (0x00000004&((data)<<2))
+#define TP_TF1_FRMCFG_sync_pol_src(data)                                             ((0x00000004&(data))>>2)
+#define TP_TF1_FRMCFG_get_sync_pol(data)                                             ((0x00000004&(data))>>2)
+#define TP_TF1_FRMCFG_val_pol_shift                                                  (1)
+#define TP_TF1_FRMCFG_val_pol_mask                                                   (0x00000002)
+#define TP_TF1_FRMCFG_val_pol(data)                                                  (0x00000002&((data)<<1))
+#define TP_TF1_FRMCFG_val_pol_src(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF1_FRMCFG_get_val_pol(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF1_FRMCFG_clk_pol_shift                                                  (0)
+#define TP_TF1_FRMCFG_clk_pol_mask                                                   (0x00000001)
+#define TP_TF1_FRMCFG_clk_pol(data)                                                  (0x00000001&((data)<<0))
+#define TP_TF1_FRMCFG_clk_pol_src(data)                                              ((0x00000001&(data))>>0)
+#define TP_TF1_FRMCFG_get_clk_pol(data)                                              ((0x00000001&(data))>>0)
+
+
+#define TP_TF1_INT                                                                   0x18014834
+#define TP_TF1_INT_reg_addr                                                          "0xB8014834"
+#define TP_TF1_INT_reg                                                               0xB8014834
+#define set_TP_TF1_INT_reg(data)   (*((volatile unsigned int*) TP_TF1_INT_reg)=data)
+#define get_TP_TF1_INT_reg   (*((volatile unsigned int*) TP_TF1_INT_reg))
+#define TP_TF1_INT_inst_adr                                                          "0x000D"
+#define TP_TF1_INT_inst                                                              0x000D
+#define TP_TF1_INT_adf_pcr_in_shift                                                  (4)
+#define TP_TF1_INT_adf_pcr_in_mask                                                   (0x00000010)
+#define TP_TF1_INT_adf_pcr_in(data)                                                  (0x00000010&((data)<<4))
+#define TP_TF1_INT_adf_pcr_in_src(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF1_INT_get_adf_pcr_in(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF1_INT_overflow_shift                                                    (3)
+#define TP_TF1_INT_overflow_mask                                                     (0x00000008)
+#define TP_TF1_INT_overflow(data)                                                    (0x00000008&((data)<<3))
+#define TP_TF1_INT_overflow_src(data)                                                ((0x00000008&(data))>>3)
+#define TP_TF1_INT_get_overflow(data)                                                ((0x00000008&(data))>>3)
+#define TP_TF1_INT_drop_shift                                                        (2)
+#define TP_TF1_INT_drop_mask                                                         (0x00000004)
+#define TP_TF1_INT_drop(data)                                                        (0x00000004&((data)<<2))
+#define TP_TF1_INT_drop_src(data)                                                    ((0x00000004&(data))>>2)
+#define TP_TF1_INT_get_drop(data)                                                    ((0x00000004&(data))>>2)
+#define TP_TF1_INT_sync_shift                                                        (1)
+#define TP_TF1_INT_sync_mask                                                         (0x00000002)
+#define TP_TF1_INT_sync(data)                                                        (0x00000002&((data)<<1))
+#define TP_TF1_INT_sync_src(data)                                                    ((0x00000002&(data))>>1)
+#define TP_TF1_INT_get_sync(data)                                                    ((0x00000002&(data))>>1)
+#define TP_TF1_INT_write_data_shift                                                  (0)
+#define TP_TF1_INT_write_data_mask                                                   (0x00000001)
+#define TP_TF1_INT_write_data(data)                                                  (0x00000001&((data)<<0))
+#define TP_TF1_INT_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define TP_TF1_INT_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define TP_TF1_INT_EN                                                                0x1801483C
+#define TP_TF1_INT_EN_reg_addr                                                       "0xB801483C"
+#define TP_TF1_INT_EN_reg                                                            0xB801483C
+#define set_TP_TF1_INT_EN_reg(data)   (*((volatile unsigned int*) TP_TF1_INT_EN_reg)=data)
+#define get_TP_TF1_INT_EN_reg   (*((volatile unsigned int*) TP_TF1_INT_EN_reg))
+#define TP_TF1_INT_EN_inst_adr                                                       "0x000F"
+#define TP_TF1_INT_EN_inst                                                           0x000F
+#define TP_TF1_INT_EN_adf_pcr_in_en_shift                                            (4)
+#define TP_TF1_INT_EN_adf_pcr_in_en_mask                                             (0x00000010)
+#define TP_TF1_INT_EN_adf_pcr_in_en(data)                                            (0x00000010&((data)<<4))
+#define TP_TF1_INT_EN_adf_pcr_in_en_src(data)                                        ((0x00000010&(data))>>4)
+#define TP_TF1_INT_EN_get_adf_pcr_in_en(data)                                        ((0x00000010&(data))>>4)
+#define TP_TF1_INT_EN_overflow_en_shift                                              (3)
+#define TP_TF1_INT_EN_overflow_en_mask                                               (0x00000008)
+#define TP_TF1_INT_EN_overflow_en(data)                                              (0x00000008&((data)<<3))
+#define TP_TF1_INT_EN_overflow_en_src(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF1_INT_EN_get_overflow_en(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF1_INT_EN_drop_en_shift                                                  (2)
+#define TP_TF1_INT_EN_drop_en_mask                                                   (0x00000004)
+#define TP_TF1_INT_EN_drop_en(data)                                                  (0x00000004&((data)<<2))
+#define TP_TF1_INT_EN_drop_en_src(data)                                              ((0x00000004&(data))>>2)
+#define TP_TF1_INT_EN_get_drop_en(data)                                              ((0x00000004&(data))>>2)
+#define TP_TF1_INT_EN_sync_en_shift                                                  (1)
+#define TP_TF1_INT_EN_sync_en_mask                                                   (0x00000002)
+#define TP_TF1_INT_EN_sync_en(data)                                                  (0x00000002&((data)<<1))
+#define TP_TF1_INT_EN_sync_en_src(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF1_INT_EN_get_sync_en(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF1_INT_EN_write_data_shift                                               (0)
+#define TP_TF1_INT_EN_write_data_mask                                                (0x00000001)
+#define TP_TF1_INT_EN_write_data(data)                                               (0x00000001&((data)<<0))
+#define TP_TF1_INT_EN_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define TP_TF1_INT_EN_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define TP_TF2_FRMCFG                                                                0x18014850
+#define TP_TF2_FRMCFG_reg_addr                                                       "0xB8014850"
+#define TP_TF2_FRMCFG_reg                                                            0xB8014850
+#define set_TP_TF2_FRMCFG_reg(data)   (*((volatile unsigned int*) TP_TF2_FRMCFG_reg)=data)
+#define get_TP_TF2_FRMCFG_reg   (*((volatile unsigned int*) TP_TF2_FRMCFG_reg))
+#define TP_TF2_FRMCFG_inst_adr                                                       "0x0014"
+#define TP_TF2_FRMCFG_inst                                                           0x0014
+#define TP_TF2_FRMCFG_sync_byte_shift                                                (24)
+#define TP_TF2_FRMCFG_sync_byte_mask                                                 (0xFF000000)
+#define TP_TF2_FRMCFG_sync_byte(data)                                                (0xFF000000&((data)<<24))
+#define TP_TF2_FRMCFG_sync_byte_src(data)                                            ((0xFF000000&(data))>>24)
+#define TP_TF2_FRMCFG_get_sync_byte(data)                                            ((0xFF000000&(data))>>24)
+#define TP_TF2_FRMCFG_dropno_shift                                                   (20)
+#define TP_TF2_FRMCFG_dropno_mask                                                    (0x00F00000)
+#define TP_TF2_FRMCFG_dropno(data)                                                   (0x00F00000&((data)<<20))
+#define TP_TF2_FRMCFG_dropno_src(data)                                               ((0x00F00000&(data))>>20)
+#define TP_TF2_FRMCFG_get_dropno(data)                                               ((0x00F00000&(data))>>20)
+#define TP_TF2_FRMCFG_lockno_shift                                                   (16)
+#define TP_TF2_FRMCFG_lockno_mask                                                    (0x000F0000)
+#define TP_TF2_FRMCFG_lockno(data)                                                   (0x000F0000&((data)<<16))
+#define TP_TF2_FRMCFG_lockno_src(data)                                               ((0x000F0000&(data))>>16)
+#define TP_TF2_FRMCFG_get_lockno(data)                                               ((0x000F0000&(data))>>16)
+#define TP_TF2_FRMCFG_packet_size_shift                                              (14)
+#define TP_TF2_FRMCFG_packet_size_mask                                               (0x0000C000)
+#define TP_TF2_FRMCFG_packet_size(data)                                              (0x0000C000&((data)<<14))
+#define TP_TF2_FRMCFG_packet_size_src(data)                                          ((0x0000C000&(data))>>14)
+#define TP_TF2_FRMCFG_get_packet_size(data)                                          ((0x0000C000&(data))>>14)
+#define TP_TF2_FRMCFG_data_order_shift                                               (13)
+#define TP_TF2_FRMCFG_data_order_mask                                                (0x00002000)
+#define TP_TF2_FRMCFG_data_order(data)                                               (0x00002000&((data)<<13))
+#define TP_TF2_FRMCFG_data_order_src(data)                                           ((0x00002000&(data))>>13)
+#define TP_TF2_FRMCFG_get_data_order(data)                                           ((0x00002000&(data))>>13)
+#define TP_TF2_FRMCFG_frm_en_shift                                                   (12)
+#define TP_TF2_FRMCFG_frm_en_mask                                                    (0x00001000)
+#define TP_TF2_FRMCFG_frm_en(data)                                                   (0x00001000&((data)<<12))
+#define TP_TF2_FRMCFG_frm_en_src(data)                                               ((0x00001000&(data))>>12)
+#define TP_TF2_FRMCFG_get_frm_en(data)                                               ((0x00001000&(data))>>12)
+#define TP_TF2_FRMCFG_forcedrop_shift                                                (11)
+#define TP_TF2_FRMCFG_forcedrop_mask                                                 (0x00000800)
+#define TP_TF2_FRMCFG_forcedrop(data)                                                (0x00000800&((data)<<11))
+#define TP_TF2_FRMCFG_forcedrop_src(data)                                            ((0x00000800&(data))>>11)
+#define TP_TF2_FRMCFG_get_forcedrop(data)                                            ((0x00000800&(data))>>11)
+#define TP_TF2_FRMCFG_syncmode_shift                                                 (6)
+#define TP_TF2_FRMCFG_syncmode_mask                                                  (0x000007C0)
+#define TP_TF2_FRMCFG_syncmode(data)                                                 (0x000007C0&((data)<<6))
+#define TP_TF2_FRMCFG_syncmode_src(data)                                             ((0x000007C0&(data))>>6)
+#define TP_TF2_FRMCFG_get_syncmode(data)                                             ((0x000007C0&(data))>>6)
+#define TP_TF2_FRMCFG_serial_shift                                                   (5)
+#define TP_TF2_FRMCFG_serial_mask                                                    (0x00000020)
+#define TP_TF2_FRMCFG_serial(data)                                                   (0x00000020&((data)<<5))
+#define TP_TF2_FRMCFG_serial_src(data)                                               ((0x00000020&(data))>>5)
+#define TP_TF2_FRMCFG_get_serial(data)                                               ((0x00000020&(data))>>5)
+#define TP_TF2_FRMCFG_datapin_shift                                                  (4)
+#define TP_TF2_FRMCFG_datapin_mask                                                   (0x00000010)
+#define TP_TF2_FRMCFG_datapin(data)                                                  (0x00000010&((data)<<4))
+#define TP_TF2_FRMCFG_datapin_src(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF2_FRMCFG_get_datapin(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF2_FRMCFG_err_pol_shift                                                  (3)
+#define TP_TF2_FRMCFG_err_pol_mask                                                   (0x00000008)
+#define TP_TF2_FRMCFG_err_pol(data)                                                  (0x00000008&((data)<<3))
+#define TP_TF2_FRMCFG_err_pol_src(data)                                              ((0x00000008&(data))>>3)
+#define TP_TF2_FRMCFG_get_err_pol(data)                                              ((0x00000008&(data))>>3)
+#define TP_TF2_FRMCFG_sync_pol_shift                                                 (2)
+#define TP_TF2_FRMCFG_sync_pol_mask                                                  (0x00000004)
+#define TP_TF2_FRMCFG_sync_pol(data)                                                 (0x00000004&((data)<<2))
+#define TP_TF2_FRMCFG_sync_pol_src(data)                                             ((0x00000004&(data))>>2)
+#define TP_TF2_FRMCFG_get_sync_pol(data)                                             ((0x00000004&(data))>>2)
+#define TP_TF2_FRMCFG_val_pol_shift                                                  (1)
+#define TP_TF2_FRMCFG_val_pol_mask                                                   (0x00000002)
+#define TP_TF2_FRMCFG_val_pol(data)                                                  (0x00000002&((data)<<1))
+#define TP_TF2_FRMCFG_val_pol_src(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF2_FRMCFG_get_val_pol(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF2_FRMCFG_clk_pol_shift                                                  (0)
+#define TP_TF2_FRMCFG_clk_pol_mask                                                   (0x00000001)
+#define TP_TF2_FRMCFG_clk_pol(data)                                                  (0x00000001&((data)<<0))
+#define TP_TF2_FRMCFG_clk_pol_src(data)                                              ((0x00000001&(data))>>0)
+#define TP_TF2_FRMCFG_get_clk_pol(data)                                              ((0x00000001&(data))>>0)
+
+
+#define TP_TF2_INT                                                                   0x18014854
+#define TP_TF2_INT_reg_addr                                                          "0xB8014854"
+#define TP_TF2_INT_reg                                                               0xB8014854
+#define set_TP_TF2_INT_reg(data)   (*((volatile unsigned int*) TP_TF2_INT_reg)=data)
+#define get_TP_TF2_INT_reg   (*((volatile unsigned int*) TP_TF2_INT_reg))
+#define TP_TF2_INT_inst_adr                                                          "0x0015"
+#define TP_TF2_INT_inst                                                              0x0015
+#define TP_TF2_INT_adf_pcr_in_shift                                                  (4)
+#define TP_TF2_INT_adf_pcr_in_mask                                                   (0x00000010)
+#define TP_TF2_INT_adf_pcr_in(data)                                                  (0x00000010&((data)<<4))
+#define TP_TF2_INT_adf_pcr_in_src(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF2_INT_get_adf_pcr_in(data)                                              ((0x00000010&(data))>>4)
+#define TP_TF2_INT_overflow_shift                                                    (3)
+#define TP_TF2_INT_overflow_mask                                                     (0x00000008)
+#define TP_TF2_INT_overflow(data)                                                    (0x00000008&((data)<<3))
+#define TP_TF2_INT_overflow_src(data)                                                ((0x00000008&(data))>>3)
+#define TP_TF2_INT_get_overflow(data)                                                ((0x00000008&(data))>>3)
+#define TP_TF2_INT_drop_shift                                                        (2)
+#define TP_TF2_INT_drop_mask                                                         (0x00000004)
+#define TP_TF2_INT_drop(data)                                                        (0x00000004&((data)<<2))
+#define TP_TF2_INT_drop_src(data)                                                    ((0x00000004&(data))>>2)
+#define TP_TF2_INT_get_drop(data)                                                    ((0x00000004&(data))>>2)
+#define TP_TF2_INT_sync_shift                                                        (1)
+#define TP_TF2_INT_sync_mask                                                         (0x00000002)
+#define TP_TF2_INT_sync(data)                                                        (0x00000002&((data)<<1))
+#define TP_TF2_INT_sync_src(data)                                                    ((0x00000002&(data))>>1)
+#define TP_TF2_INT_get_sync(data)                                                    ((0x00000002&(data))>>1)
+#define TP_TF2_INT_write_data_shift                                                  (0)
+#define TP_TF2_INT_write_data_mask                                                   (0x00000001)
+#define TP_TF2_INT_write_data(data)                                                  (0x00000001&((data)<<0))
+#define TP_TF2_INT_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define TP_TF2_INT_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define TP_TF2_INT_EN                                                                0x18014858
+#define TP_TF2_INT_EN_reg_addr                                                       "0xB8014858"
+#define TP_TF2_INT_EN_reg                                                            0xB8014858
+#define set_TP_TF2_INT_EN_reg(data)   (*((volatile unsigned int*) TP_TF2_INT_EN_reg)=data)
+#define get_TP_TF2_INT_EN_reg   (*((volatile unsigned int*) TP_TF2_INT_EN_reg))
+#define TP_TF2_INT_EN_inst_adr                                                       "0x0016"
+#define TP_TF2_INT_EN_inst                                                           0x0016
+#define TP_TF2_INT_EN_adf_pcr_in_en_shift                                            (4)
+#define TP_TF2_INT_EN_adf_pcr_in_en_mask                                             (0x00000010)
+#define TP_TF2_INT_EN_adf_pcr_in_en(data)                                            (0x00000010&((data)<<4))
+#define TP_TF2_INT_EN_adf_pcr_in_en_src(data)                                        ((0x00000010&(data))>>4)
+#define TP_TF2_INT_EN_get_adf_pcr_in_en(data)                                        ((0x00000010&(data))>>4)
+#define TP_TF2_INT_EN_overflow_en_shift                                              (3)
+#define TP_TF2_INT_EN_overflow_en_mask                                               (0x00000008)
+#define TP_TF2_INT_EN_overflow_en(data)                                              (0x00000008&((data)<<3))
+#define TP_TF2_INT_EN_overflow_en_src(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF2_INT_EN_get_overflow_en(data)                                          ((0x00000008&(data))>>3)
+#define TP_TF2_INT_EN_drop_en_shift                                                  (2)
+#define TP_TF2_INT_EN_drop_en_mask                                                   (0x00000004)
+#define TP_TF2_INT_EN_drop_en(data)                                                  (0x00000004&((data)<<2))
+#define TP_TF2_INT_EN_drop_en_src(data)                                              ((0x00000004&(data))>>2)
+#define TP_TF2_INT_EN_get_drop_en(data)                                              ((0x00000004&(data))>>2)
+#define TP_TF2_INT_EN_sync_en_shift                                                  (1)
+#define TP_TF2_INT_EN_sync_en_mask                                                   (0x00000002)
+#define TP_TF2_INT_EN_sync_en(data)                                                  (0x00000002&((data)<<1))
+#define TP_TF2_INT_EN_sync_en_src(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF2_INT_EN_get_sync_en(data)                                              ((0x00000002&(data))>>1)
+#define TP_TF2_INT_EN_write_data_shift                                               (0)
+#define TP_TF2_INT_EN_write_data_mask                                                (0x00000001)
+#define TP_TF2_INT_EN_write_data(data)                                               (0x00000001&((data)<<0))
+#define TP_TF2_INT_EN_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define TP_TF2_INT_EN_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define TP_TF_OUT_FRMCFG                                                             0x18014840
+#define TP_TF_OUT_FRMCFG_reg_addr                                                    "0xB8014840"
+#define TP_TF_OUT_FRMCFG_reg                                                         0xB8014840
+#define set_TP_TF_OUT_FRMCFG_reg(data)   (*((volatile unsigned int*) TP_TF_OUT_FRMCFG_reg)=data)
+#define get_TP_TF_OUT_FRMCFG_reg   (*((volatile unsigned int*) TP_TF_OUT_FRMCFG_reg))
+#define TP_TF_OUT_FRMCFG_inst_adr                                                    "0x0010"
+#define TP_TF_OUT_FRMCFG_inst                                                        0x0010
+#define TP_TF_OUT_FRMCFG_byps_tperr_en_shift                                         (21)
+#define TP_TF_OUT_FRMCFG_byps_tperr_en_mask                                          (0x00200000)
+#define TP_TF_OUT_FRMCFG_byps_tperr_en(data)                                         (0x00200000&((data)<<21))
+#define TP_TF_OUT_FRMCFG_byps_tperr_en_src(data)                                     ((0x00200000&(data))>>21)
+#define TP_TF_OUT_FRMCFG_get_byps_tperr_en(data)                                     ((0x00200000&(data))>>21)
+#define TP_TF_OUT_FRMCFG_tperr_bit_sel_shift                                         (20)
+#define TP_TF_OUT_FRMCFG_tperr_bit_sel_mask                                          (0x00100000)
+#define TP_TF_OUT_FRMCFG_tperr_bit_sel(data)                                         (0x00100000&((data)<<20))
+#define TP_TF_OUT_FRMCFG_tperr_bit_sel_src(data)                                     ((0x00100000&(data))>>20)
+#define TP_TF_OUT_FRMCFG_get_tperr_bit_sel(data)                                     ((0x00100000&(data))>>20)
+#define TP_TF_OUT_FRMCFG_in_tp_out_en_shift                                          (19)
+#define TP_TF_OUT_FRMCFG_in_tp_out_en_mask                                           (0x00080000)
+#define TP_TF_OUT_FRMCFG_in_tp_out_en(data)                                          (0x00080000&((data)<<19))
+#define TP_TF_OUT_FRMCFG_in_tp_out_en_src(data)                                      ((0x00080000&(data))>>19)
+#define TP_TF_OUT_FRMCFG_get_in_tp_out_en(data)                                      ((0x00080000&(data))>>19)
+#define TP_TF_OUT_FRMCFG_in_tp_rst_shift                                             (18)
+#define TP_TF_OUT_FRMCFG_in_tp_rst_mask                                              (0x00040000)
+#define TP_TF_OUT_FRMCFG_in_tp_rst(data)                                             (0x00040000&((data)<<18))
+#define TP_TF_OUT_FRMCFG_in_tp_rst_src(data)                                         ((0x00040000&(data))>>18)
+#define TP_TF_OUT_FRMCFG_get_in_tp_rst(data)                                         ((0x00040000&(data))>>18)
+#define TP_TF_OUT_FRMCFG_data_src_shift                                              (16)
+#define TP_TF_OUT_FRMCFG_data_src_mask                                               (0x00030000)
+#define TP_TF_OUT_FRMCFG_data_src(data)                                              (0x00030000&((data)<<16))
+#define TP_TF_OUT_FRMCFG_data_src_src(data)                                          ((0x00030000&(data))>>16)
+#define TP_TF_OUT_FRMCFG_get_data_src(data)                                          ((0x00030000&(data))>>16)
+#define TP_TF_OUT_FRMCFG_in_data_order_shift                                         (14)
+#define TP_TF_OUT_FRMCFG_in_data_order_mask                                          (0x00004000)
+#define TP_TF_OUT_FRMCFG_in_data_order(data)                                         (0x00004000&((data)<<14))
+#define TP_TF_OUT_FRMCFG_in_data_order_src(data)                                     ((0x00004000&(data))>>14)
+#define TP_TF_OUT_FRMCFG_get_in_data_order(data)                                     ((0x00004000&(data))>>14)
+#define TP_TF_OUT_FRMCFG_in_serial_shift                                             (13)
+#define TP_TF_OUT_FRMCFG_in_serial_mask                                              (0x00002000)
+#define TP_TF_OUT_FRMCFG_in_serial(data)                                             (0x00002000&((data)<<13))
+#define TP_TF_OUT_FRMCFG_in_serial_src(data)                                         ((0x00002000&(data))>>13)
+#define TP_TF_OUT_FRMCFG_get_in_serial(data)                                         ((0x00002000&(data))>>13)
+#define TP_TF_OUT_FRMCFG_in_datapin_shift                                            (12)
+#define TP_TF_OUT_FRMCFG_in_datapin_mask                                             (0x00001000)
+#define TP_TF_OUT_FRMCFG_in_datapin(data)                                            (0x00001000&((data)<<12))
+#define TP_TF_OUT_FRMCFG_in_datapin_src(data)                                        ((0x00001000&(data))>>12)
+#define TP_TF_OUT_FRMCFG_get_in_datapin(data)                                        ((0x00001000&(data))>>12)
+#define TP_TF_OUT_FRMCFG_in_err_pol_shift                                            (11)
+#define TP_TF_OUT_FRMCFG_in_err_pol_mask                                             (0x00000800)
+#define TP_TF_OUT_FRMCFG_in_err_pol(data)                                            (0x00000800&((data)<<11))
+#define TP_TF_OUT_FRMCFG_in_err_pol_src(data)                                        ((0x00000800&(data))>>11)
+#define TP_TF_OUT_FRMCFG_get_in_err_pol(data)                                        ((0x00000800&(data))>>11)
+#define TP_TF_OUT_FRMCFG_in_sync_pol_shift                                           (10)
+#define TP_TF_OUT_FRMCFG_in_sync_pol_mask                                            (0x00000400)
+#define TP_TF_OUT_FRMCFG_in_sync_pol(data)                                           (0x00000400&((data)<<10))
+#define TP_TF_OUT_FRMCFG_in_sync_pol_src(data)                                       ((0x00000400&(data))>>10)
+#define TP_TF_OUT_FRMCFG_get_in_sync_pol(data)                                       ((0x00000400&(data))>>10)
+#define TP_TF_OUT_FRMCFG_in_val_pol_shift                                            (9)
+#define TP_TF_OUT_FRMCFG_in_val_pol_mask                                             (0x00000200)
+#define TP_TF_OUT_FRMCFG_in_val_pol(data)                                            (0x00000200&((data)<<9))
+#define TP_TF_OUT_FRMCFG_in_val_pol_src(data)                                        ((0x00000200&(data))>>9)
+#define TP_TF_OUT_FRMCFG_get_in_val_pol(data)                                        ((0x00000200&(data))>>9)
+#define TP_TF_OUT_FRMCFG_in_clk_pol_shift                                            (8)
+#define TP_TF_OUT_FRMCFG_in_clk_pol_mask                                             (0x00000100)
+#define TP_TF_OUT_FRMCFG_in_clk_pol(data)                                            (0x00000100&((data)<<8))
+#define TP_TF_OUT_FRMCFG_in_clk_pol_src(data)                                        ((0x00000100&(data))>>8)
+#define TP_TF_OUT_FRMCFG_get_in_clk_pol(data)                                        ((0x00000100&(data))>>8)
+#define TP_TF_OUT_FRMCFG_out_data_order_shift                                        (6)
+#define TP_TF_OUT_FRMCFG_out_data_order_mask                                         (0x00000040)
+#define TP_TF_OUT_FRMCFG_out_data_order(data)                                        (0x00000040&((data)<<6))
+#define TP_TF_OUT_FRMCFG_out_data_order_src(data)                                    ((0x00000040&(data))>>6)
+#define TP_TF_OUT_FRMCFG_get_out_data_order(data)                                    ((0x00000040&(data))>>6)
+#define TP_TF_OUT_FRMCFG_out_serial_shift                                            (5)
+#define TP_TF_OUT_FRMCFG_out_serial_mask                                             (0x00000020)
+#define TP_TF_OUT_FRMCFG_out_serial(data)                                            (0x00000020&((data)<<5))
+#define TP_TF_OUT_FRMCFG_out_serial_src(data)                                        ((0x00000020&(data))>>5)
+#define TP_TF_OUT_FRMCFG_get_out_serial(data)                                        ((0x00000020&(data))>>5)
+#define TP_TF_OUT_FRMCFG_out_err_pol_shift                                           (3)
+#define TP_TF_OUT_FRMCFG_out_err_pol_mask                                            (0x00000008)
+#define TP_TF_OUT_FRMCFG_out_err_pol(data)                                           (0x00000008&((data)<<3))
+#define TP_TF_OUT_FRMCFG_out_err_pol_src(data)                                       ((0x00000008&(data))>>3)
+#define TP_TF_OUT_FRMCFG_get_out_err_pol(data)                                       ((0x00000008&(data))>>3)
+#define TP_TF_OUT_FRMCFG_out_sync_pol_shift                                          (2)
+#define TP_TF_OUT_FRMCFG_out_sync_pol_mask                                           (0x00000004)
+#define TP_TF_OUT_FRMCFG_out_sync_pol(data)                                          (0x00000004&((data)<<2))
+#define TP_TF_OUT_FRMCFG_out_sync_pol_src(data)                                      ((0x00000004&(data))>>2)
+#define TP_TF_OUT_FRMCFG_get_out_sync_pol(data)                                      ((0x00000004&(data))>>2)
+#define TP_TF_OUT_FRMCFG_out_val_pol_shift                                           (1)
+#define TP_TF_OUT_FRMCFG_out_val_pol_mask                                            (0x00000002)
+#define TP_TF_OUT_FRMCFG_out_val_pol(data)                                           (0x00000002&((data)<<1))
+#define TP_TF_OUT_FRMCFG_out_val_pol_src(data)                                       ((0x00000002&(data))>>1)
+#define TP_TF_OUT_FRMCFG_get_out_val_pol(data)                                       ((0x00000002&(data))>>1)
+#define TP_TF_OUT_FRMCFG_out_clk_pol_shift                                           (0)
+#define TP_TF_OUT_FRMCFG_out_clk_pol_mask                                            (0x00000001)
+#define TP_TF_OUT_FRMCFG_out_clk_pol(data)                                           (0x00000001&((data)<<0))
+#define TP_TF_OUT_FRMCFG_out_clk_pol_src(data)                                       ((0x00000001&(data))>>0)
+#define TP_TF_OUT_FRMCFG_get_out_clk_pol(data)                                       ((0x00000001&(data))>>0)
+
+
+#define TP_OUT_CTRL                                                                  0x18014844
+#define TP_OUT_CTRL_reg_addr                                                         "0xB8014844"
+#define TP_OUT_CTRL_reg                                                              0xB8014844
+#define set_TP_OUT_CTRL_reg(data)   (*((volatile unsigned int*) TP_OUT_CTRL_reg)=data)
+#define get_TP_OUT_CTRL_reg   (*((volatile unsigned int*) TP_OUT_CTRL_reg))
+#define TP_OUT_CTRL_inst_adr                                                         "0x0011"
+#define TP_OUT_CTRL_inst                                                             0x0011
+#define TP_OUT_CTRL_sync_dur_shift                                                   (19)
+#define TP_OUT_CTRL_sync_dur_mask                                                    (0x00080000)
+#define TP_OUT_CTRL_sync_dur(data)                                                   (0x00080000&((data)<<19))
+#define TP_OUT_CTRL_sync_dur_src(data)                                               ((0x00080000&(data))>>19)
+#define TP_OUT_CTRL_get_sync_dur(data)                                               ((0x00080000&(data))>>19)
+#define TP_OUT_CTRL_ck_gate_shift                                                    (18)
+#define TP_OUT_CTRL_ck_gate_mask                                                     (0x00040000)
+#define TP_OUT_CTRL_ck_gate(data)                                                    (0x00040000&((data)<<18))
+#define TP_OUT_CTRL_ck_gate_src(data)                                                ((0x00040000&(data))>>18)
+#define TP_OUT_CTRL_get_ck_gate(data)                                                ((0x00040000&(data))>>18)
+#define TP_OUT_CTRL_tp_frame_rate_shift                                              (5)
+#define TP_OUT_CTRL_tp_frame_rate_mask                                               (0x0003FFE0)
+#define TP_OUT_CTRL_tp_frame_rate(data)                                              (0x0003FFE0&((data)<<5))
+#define TP_OUT_CTRL_tp_frame_rate_src(data)                                          ((0x0003FFE0&(data))>>5)
+#define TP_OUT_CTRL_get_tp_frame_rate(data)                                          ((0x0003FFE0&(data))>>5)
+#define TP_OUT_CTRL_tp_clk_div_shift                                                 (0)
+#define TP_OUT_CTRL_tp_clk_div_mask                                                  (0x0000001F)
+#define TP_OUT_CTRL_tp_clk_div(data)                                                 (0x0000001F&((data)<<0))
+#define TP_OUT_CTRL_tp_clk_div_src(data)                                             ((0x0000001F&(data))>>0)
+#define TP_OUT_CTRL_get_tp_clk_div(data)                                             ((0x0000001F&(data))>>0)
+
+
+#define TP_PID_PART                                                                  0x18014024
+#define TP_PID_PART_reg_addr                                                         "0xB8014024"
+#define TP_PID_PART_reg                                                              0xB8014024
+#define set_TP_PID_PART_reg(data)   (*((volatile unsigned int*) TP_PID_PART_reg)=data)
+#define get_TP_PID_PART_reg   (*((volatile unsigned int*) TP_PID_PART_reg))
+#define TP_PID_PART_inst_adr                                                         "0x0009"
+#define TP_PID_PART_inst                                                             0x0009
+#define TP_PID_PART_partition2_shift                                                 (8)
+#define TP_PID_PART_partition2_mask                                                  (0x00007F00)
+#define TP_PID_PART_partition2(data)                                                 (0x00007F00&((data)<<8))
+#define TP_PID_PART_partition2_src(data)                                             ((0x00007F00&(data))>>8)
+#define TP_PID_PART_get_partition2(data)                                             ((0x00007F00&(data))>>8)
+#define TP_PID_PART_partition1_shift                                                 (0)
+#define TP_PID_PART_partition1_mask                                                  (0x0000007F)
+#define TP_PID_PART_partition1(data)                                                 (0x0000007F&((data)<<0))
+#define TP_PID_PART_partition1_src(data)                                             ((0x0000007F&(data))>>0)
+#define TP_PID_PART_get_partition1(data)                                             ((0x0000007F&(data))>>0)
+
+
+#define TP_PID_CTRL                                                                  0x18014028
+#define TP_PID_CTRL_reg_addr                                                         "0xB8014028"
+#define TP_PID_CTRL_reg                                                              0xB8014028
+#define set_TP_PID_CTRL_reg(data)   (*((volatile unsigned int*) TP_PID_CTRL_reg)=data)
+#define get_TP_PID_CTRL_reg   (*((volatile unsigned int*) TP_PID_CTRL_reg))
+#define TP_PID_CTRL_inst_adr                                                         "0x000A"
+#define TP_PID_CTRL_inst                                                             0x000A
+#define TP_PID_CTRL_r_w_shift                                                        (7)
+#define TP_PID_CTRL_r_w_mask                                                         (0x00000080)
+#define TP_PID_CTRL_r_w(data)                                                        (0x00000080&((data)<<7))
+#define TP_PID_CTRL_r_w_src(data)                                                    ((0x00000080&(data))>>7)
+#define TP_PID_CTRL_get_r_w(data)                                                    ((0x00000080&(data))>>7)
+#define TP_PID_CTRL_idx_shift                                                        (0)
+#define TP_PID_CTRL_idx_mask                                                         (0x0000007F)
+#define TP_PID_CTRL_idx(data)                                                        (0x0000007F&((data)<<0))
+#define TP_PID_CTRL_idx_src(data)                                                    ((0x0000007F&(data))>>0)
+#define TP_PID_CTRL_get_idx(data)                                                    ((0x0000007F&(data))>>0)
+
+
+#define TP_PID_DATA                                                                  0x1801402C
+#define TP_PID_DATA_reg_addr                                                         "0xB801402C"
+#define TP_PID_DATA_reg                                                              0xB801402C
+#define set_TP_PID_DATA_reg(data)   (*((volatile unsigned int*) TP_PID_DATA_reg)=data)
+#define get_TP_PID_DATA_reg   (*((volatile unsigned int*) TP_PID_DATA_reg))
+#define TP_PID_DATA_inst_adr                                                         "0x000B"
+#define TP_PID_DATA_inst                                                             0x000B
+#define TP_PID_DATA_si_en_shift                                                      (31)
+#define TP_PID_DATA_si_en_mask                                                       (0x80000000)
+#define TP_PID_DATA_si_en(data)                                                      (0x80000000&((data)<<31))
+#define TP_PID_DATA_si_en_src(data)                                                  ((0x80000000&(data))>>31)
+#define TP_PID_DATA_get_si_en(data)                                                  ((0x80000000&(data))>>31)
+#define TP_PID_DATA_pid_ini_shift                                                    (30)
+#define TP_PID_DATA_pid_ini_mask                                                     (0x40000000)
+#define TP_PID_DATA_pid_ini(data)                                                    (0x40000000&((data)<<30))
+#define TP_PID_DATA_pid_ini_src(data)                                                ((0x40000000&(data))>>30)
+#define TP_PID_DATA_get_pid_ini(data)                                                ((0x40000000&(data))>>30)
+#define TP_PID_DATA_ai_en_shift                                                      (29)
+#define TP_PID_DATA_ai_en_mask                                                       (0x20000000)
+#define TP_PID_DATA_ai_en(data)                                                      (0x20000000&((data)<<29))
+#define TP_PID_DATA_ai_en_src(data)                                                  ((0x20000000&(data))>>29)
+#define TP_PID_DATA_get_ai_en(data)                                                  ((0x20000000&(data))>>29)
+#define TP_PID_DATA_ti_en_shift                                                      (28)
+#define TP_PID_DATA_ti_en_mask                                                       (0x10000000)
+#define TP_PID_DATA_ti_en(data)                                                      (0x10000000&((data)<<28))
+#define TP_PID_DATA_ti_en_src(data)                                                  ((0x10000000&(data))>>28)
+#define TP_PID_DATA_get_ti_en(data)                                                  ((0x10000000&(data))>>28)
+#define TP_PID_DATA_sec_idx_shift                                                    (22)
+#define TP_PID_DATA_sec_idx_mask                                                     (0x0FC00000)
+#define TP_PID_DATA_sec_idx(data)                                                    (0x0FC00000&((data)<<22))
+#define TP_PID_DATA_sec_idx_src(data)                                                ((0x0FC00000&(data))>>22)
+#define TP_PID_DATA_get_sec_idx(data)                                                ((0x0FC00000&(data))>>22)
+#define TP_PID_DATA_sec_en_shift                                                     (21)
+#define TP_PID_DATA_sec_en_mask                                                      (0x00200000)
+#define TP_PID_DATA_sec_en(data)                                                     (0x00200000&((data)<<21))
+#define TP_PID_DATA_sec_en_src(data)                                                 ((0x00200000&(data))>>21)
+#define TP_PID_DATA_get_sec_en(data)                                                 ((0x00200000&(data))>>21)
+#define TP_PID_DATA_reversed_shift                                                   (20)
+#define TP_PID_DATA_reversed_mask                                                    (0x00100000)
+#define TP_PID_DATA_reversed(data)                                                   (0x00100000&((data)<<20))
+#define TP_PID_DATA_reversed_src(data)                                               ((0x00100000&(data))>>20)
+#define TP_PID_DATA_get_reversed(data)                                               ((0x00100000&(data))>>20)
+#define TP_PID_DATA_ddr_q_shift                                                      (15)
+#define TP_PID_DATA_ddr_q_mask                                                       (0x000F8000)
+#define TP_PID_DATA_ddr_q(data)                                                      (0x000F8000&((data)<<15))
+#define TP_PID_DATA_ddr_q_src(data)                                                  ((0x000F8000&(data))>>15)
+#define TP_PID_DATA_get_ddr_q(data)                                                  ((0x000F8000&(data))>>15)
+#define TP_PID_DATA_cc_en_shift                                                      (14)
+#define TP_PID_DATA_cc_en_mask                                                       (0x00004000)
+#define TP_PID_DATA_cc_en(data)                                                      (0x00004000&((data)<<14))
+#define TP_PID_DATA_cc_en_src(data)                                                  ((0x00004000&(data))>>14)
+#define TP_PID_DATA_get_cc_en(data)                                                  ((0x00004000&(data))>>14)
+#define TP_PID_DATA_v_shift                                                          (13)
+#define TP_PID_DATA_v_mask                                                           (0x00002000)
+#define TP_PID_DATA_v(data)                                                          (0x00002000&((data)<<13))
+#define TP_PID_DATA_v_src(data)                                                      ((0x00002000&(data))>>13)
+#define TP_PID_DATA_get_v(data)                                                      ((0x00002000&(data))>>13)
+#define TP_PID_DATA_pid_shift                                                        (0)
+#define TP_PID_DATA_pid_mask                                                         (0x00001FFF)
+#define TP_PID_DATA_pid(data)                                                        (0x00001FFF&((data)<<0))
+#define TP_PID_DATA_pid_src(data)                                                    ((0x00001FFF&(data))>>0)
+#define TP_PID_DATA_get_pid(data)                                                    ((0x00001FFF&(data))>>0)
+
+
+#define TP_PID_DATA2                                                                 0x18014020
+#define TP_PID_DATA2_reg_addr                                                        "0xB8014020"
+#define TP_PID_DATA2_reg                                                             0xB8014020
+#define set_TP_PID_DATA2_reg(data)   (*((volatile unsigned int*) TP_PID_DATA2_reg)=data)
+#define get_TP_PID_DATA2_reg   (*((volatile unsigned int*) TP_PID_DATA2_reg))
+#define TP_PID_DATA2_inst_adr                                                        "0x0008"
+#define TP_PID_DATA2_inst                                                            0x0008
+#define TP_PID_DATA2_pre_des_shift                                                   (12)
+#define TP_PID_DATA2_pre_des_mask                                                    (0x00001000)
+#define TP_PID_DATA2_pre_des(data)                                                   (0x00001000&((data)<<12))
+#define TP_PID_DATA2_pre_des_src(data)                                               ((0x00001000&(data))>>12)
+#define TP_PID_DATA2_get_pre_des(data)                                               ((0x00001000&(data))>>12)
+#define TP_PID_DATA2_key_shift                                                       (7)
+#define TP_PID_DATA2_key_mask                                                        (0x00000F80)
+#define TP_PID_DATA2_key(data)                                                       (0x00000F80&((data)<<7))
+#define TP_PID_DATA2_key_src(data)                                                   ((0x00000F80&(data))>>7)
+#define TP_PID_DATA2_get_key(data)                                                   ((0x00000F80&(data))>>7)
+#define TP_PID_DATA2_reversed_shift                                                  (5)
+#define TP_PID_DATA2_reversed_mask                                                   (0x00000060)
+#define TP_PID_DATA2_reversed(data)                                                  (0x00000060&((data)<<5))
+#define TP_PID_DATA2_reversed_src(data)                                              ((0x00000060&(data))>>5)
+#define TP_PID_DATA2_get_reversed(data)                                              ((0x00000060&(data))>>5)
+#define TP_PID_DATA2_info_q_shift                                                    (0)
+#define TP_PID_DATA2_info_q_mask                                                     (0x0000001F)
+#define TP_PID_DATA2_info_q(data)                                                    (0x0000001F&((data)<<0))
+#define TP_PID_DATA2_info_q_src(data)                                                ((0x0000001F&(data))>>0)
+#define TP_PID_DATA2_get_info_q(data)                                                ((0x0000001F&(data))>>0)
+
+
+#define TP_SEC_CTRL                                                                  0x18014030
+#define TP_SEC_CTRL_reg_addr                                                         "0xB8014030"
+#define TP_SEC_CTRL_reg                                                              0xB8014030
+#define set_TP_SEC_CTRL_reg(data)   (*((volatile unsigned int*) TP_SEC_CTRL_reg)=data)
+#define get_TP_SEC_CTRL_reg   (*((volatile unsigned int*) TP_SEC_CTRL_reg))
+#define TP_SEC_CTRL_inst_adr                                                         "0x000C"
+#define TP_SEC_CTRL_inst                                                             0x000C
+#define TP_SEC_CTRL_r_w_shift                                                        (6)
+#define TP_SEC_CTRL_r_w_mask                                                         (0x00000040)
+#define TP_SEC_CTRL_r_w(data)                                                        (0x00000040&((data)<<6))
+#define TP_SEC_CTRL_r_w_src(data)                                                    ((0x00000040&(data))>>6)
+#define TP_SEC_CTRL_get_r_w(data)                                                    ((0x00000040&(data))>>6)
+#define TP_SEC_CTRL_idx_shift                                                        (0)
+#define TP_SEC_CTRL_idx_mask                                                         (0x0000003F)
+#define TP_SEC_CTRL_idx(data)                                                        (0x0000003F&((data)<<0))
+#define TP_SEC_CTRL_idx_src(data)                                                    ((0x0000003F&(data))>>0)
+#define TP_SEC_CTRL_get_idx(data)                                                    ((0x0000003F&(data))>>0)
+
+
+#define TP_SEC_DATA0                                                                 0x18014034
+#define TP_SEC_DATA0_reg_addr                                                        "0xB8014034"
+#define TP_SEC_DATA0_reg                                                             0xB8014034
+#define set_TP_SEC_DATA0_reg(data)   (*((volatile unsigned int*) TP_SEC_DATA0_reg)=data)
+#define get_TP_SEC_DATA0_reg   (*((volatile unsigned int*) TP_SEC_DATA0_reg))
+#define TP_SEC_DATA0_inst_adr                                                        "0x000D"
+#define TP_SEC_DATA0_inst                                                            0x000D
+#define TP_SEC_DATA0_filter_value_msb_shift                                          (0)
+#define TP_SEC_DATA0_filter_value_msb_mask                                           (0xFFFFFFFF)
+#define TP_SEC_DATA0_filter_value_msb(data)                                          (0xFFFFFFFF&((data)<<0))
+#define TP_SEC_DATA0_filter_value_msb_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define TP_SEC_DATA0_get_filter_value_msb(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_SEC_DATA1                                                                 0x18014038
+#define TP_SEC_DATA1_reg_addr                                                        "0xB8014038"
+#define TP_SEC_DATA1_reg                                                             0xB8014038
+#define set_TP_SEC_DATA1_reg(data)   (*((volatile unsigned int*) TP_SEC_DATA1_reg)=data)
+#define get_TP_SEC_DATA1_reg   (*((volatile unsigned int*) TP_SEC_DATA1_reg))
+#define TP_SEC_DATA1_inst_adr                                                        "0x000E"
+#define TP_SEC_DATA1_inst                                                            0x000E
+#define TP_SEC_DATA1_filter_value_lsb_shift                                          (0)
+#define TP_SEC_DATA1_filter_value_lsb_mask                                           (0xFFFFFFFF)
+#define TP_SEC_DATA1_filter_value_lsb(data)                                          (0xFFFFFFFF&((data)<<0))
+#define TP_SEC_DATA1_filter_value_lsb_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define TP_SEC_DATA1_get_filter_value_lsb(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_SEC_DATA2                                                                 0x1801403C
+#define TP_SEC_DATA2_reg_addr                                                        "0xB801403C"
+#define TP_SEC_DATA2_reg                                                             0xB801403C
+#define set_TP_SEC_DATA2_reg(data)   (*((volatile unsigned int*) TP_SEC_DATA2_reg)=data)
+#define get_TP_SEC_DATA2_reg   (*((volatile unsigned int*) TP_SEC_DATA2_reg))
+#define TP_SEC_DATA2_inst_adr                                                        "0x000F"
+#define TP_SEC_DATA2_inst                                                            0x000F
+#define TP_SEC_DATA2_mask_value_msb_shift                                            (0)
+#define TP_SEC_DATA2_mask_value_msb_mask                                             (0xFFFFFFFF)
+#define TP_SEC_DATA2_mask_value_msb(data)                                            (0xFFFFFFFF&((data)<<0))
+#define TP_SEC_DATA2_mask_value_msb_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define TP_SEC_DATA2_get_mask_value_msb(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_SEC_DATA3                                                                 0x18014040
+#define TP_SEC_DATA3_reg_addr                                                        "0xB8014040"
+#define TP_SEC_DATA3_reg                                                             0xB8014040
+#define set_TP_SEC_DATA3_reg(data)   (*((volatile unsigned int*) TP_SEC_DATA3_reg)=data)
+#define get_TP_SEC_DATA3_reg   (*((volatile unsigned int*) TP_SEC_DATA3_reg))
+#define TP_SEC_DATA3_inst_adr                                                        "0x0010"
+#define TP_SEC_DATA3_inst                                                            0x0010
+#define TP_SEC_DATA3_mask_value_lsb_shift                                            (0)
+#define TP_SEC_DATA3_mask_value_lsb_mask                                             (0xFFFFFFFF)
+#define TP_SEC_DATA3_mask_value_lsb(data)                                            (0xFFFFFFFF&((data)<<0))
+#define TP_SEC_DATA3_mask_value_lsb_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define TP_SEC_DATA3_get_mask_value_lsb(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_SEC_DATA4                                                                 0x18014044
+#define TP_SEC_DATA4_reg_addr                                                        "0xB8014044"
+#define TP_SEC_DATA4_reg                                                             0xB8014044
+#define set_TP_SEC_DATA4_reg(data)   (*((volatile unsigned int*) TP_SEC_DATA4_reg)=data)
+#define get_TP_SEC_DATA4_reg   (*((volatile unsigned int*) TP_SEC_DATA4_reg))
+#define TP_SEC_DATA4_inst_adr                                                        "0x0011"
+#define TP_SEC_DATA4_inst                                                            0x0011
+#define TP_SEC_DATA4_sp_filter_shift                                                 (12)
+#define TP_SEC_DATA4_sp_filter_mask                                                  (0x00003000)
+#define TP_SEC_DATA4_sp_filter(data)                                                 (0x00003000&((data)<<12))
+#define TP_SEC_DATA4_sp_filter_src(data)                                             ((0x00003000&(data))>>12)
+#define TP_SEC_DATA4_get_sp_filter(data)                                             ((0x00003000&(data))>>12)
+#define TP_SEC_DATA4_sp_mask_shift                                                   (10)
+#define TP_SEC_DATA4_sp_mask_mask                                                    (0x00000C00)
+#define TP_SEC_DATA4_sp_mask(data)                                                   (0x00000C00&((data)<<10))
+#define TP_SEC_DATA4_sp_mask_src(data)                                               ((0x00000C00&(data))>>10)
+#define TP_SEC_DATA4_get_sp_mask(data)                                               ((0x00000C00&(data))>>10)
+#define TP_SEC_DATA4_crc_en_shift                                                    (9)
+#define TP_SEC_DATA4_crc_en_mask                                                     (0x00000200)
+#define TP_SEC_DATA4_crc_en(data)                                                    (0x00000200&((data)<<9))
+#define TP_SEC_DATA4_crc_en_src(data)                                                ((0x00000200&(data))>>9)
+#define TP_SEC_DATA4_get_crc_en(data)                                                ((0x00000200&(data))>>9)
+#define TP_SEC_DATA4_p_d_shift                                                       (8)
+#define TP_SEC_DATA4_p_d_mask                                                        (0x00000100)
+#define TP_SEC_DATA4_p_d(data)                                                       (0x00000100&((data)<<8))
+#define TP_SEC_DATA4_p_d_src(data)                                                   ((0x00000100&(data))>>8)
+#define TP_SEC_DATA4_get_p_d(data)                                                   ((0x00000100&(data))>>8)
+#define TP_SEC_DATA4_p_n_shift                                                       (7)
+#define TP_SEC_DATA4_p_n_mask                                                        (0x00000080)
+#define TP_SEC_DATA4_p_n(data)                                                       (0x00000080&((data)<<7))
+#define TP_SEC_DATA4_p_n_src(data)                                                   ((0x00000080&(data))>>7)
+#define TP_SEC_DATA4_get_p_n(data)                                                   ((0x00000080&(data))>>7)
+#define TP_SEC_DATA4_last_shift                                                      (6)
+#define TP_SEC_DATA4_last_mask                                                       (0x00000040)
+#define TP_SEC_DATA4_last(data)                                                      (0x00000040&((data)<<6))
+#define TP_SEC_DATA4_last_src(data)                                                  ((0x00000040&(data))>>6)
+#define TP_SEC_DATA4_get_last(data)                                                  ((0x00000040&(data))>>6)
+#define TP_SEC_DATA4_next_sec_shift                                                  (0)
+#define TP_SEC_DATA4_next_sec_mask                                                   (0x0000003F)
+#define TP_SEC_DATA4_next_sec(data)                                                  (0x0000003F&((data)<<0))
+#define TP_SEC_DATA4_next_sec_src(data)                                              ((0x0000003F&(data))>>0)
+#define TP_SEC_DATA4_get_next_sec(data)                                              ((0x0000003F&(data))>>0)
+
+
+#define TP_SEC_DATA5                                                                 0x18014080
+#define TP_SEC_DATA5_reg_addr                                                        "0xB8014080"
+#define TP_SEC_DATA5_reg                                                             0xB8014080
+#define set_TP_SEC_DATA5_reg(data)   (*((volatile unsigned int*) TP_SEC_DATA5_reg)=data)
+#define get_TP_SEC_DATA5_reg   (*((volatile unsigned int*) TP_SEC_DATA5_reg))
+#define TP_SEC_DATA5_inst_adr                                                        "0x0020"
+#define TP_SEC_DATA5_inst                                                            0x0020
+#define TP_SEC_DATA5_neg_filter_value_msb_shift                                      (0)
+#define TP_SEC_DATA5_neg_filter_value_msb_mask                                       (0xFFFFFFFF)
+#define TP_SEC_DATA5_neg_filter_value_msb(data)                                      (0xFFFFFFFF&((data)<<0))
+#define TP_SEC_DATA5_neg_filter_value_msb_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define TP_SEC_DATA5_get_neg_filter_value_msb(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_SEC_DATA6                                                                 0x18014084
+#define TP_SEC_DATA6_reg_addr                                                        "0xB8014084"
+#define TP_SEC_DATA6_reg                                                             0xB8014084
+#define set_TP_SEC_DATA6_reg(data)   (*((volatile unsigned int*) TP_SEC_DATA6_reg)=data)
+#define get_TP_SEC_DATA6_reg   (*((volatile unsigned int*) TP_SEC_DATA6_reg))
+#define TP_SEC_DATA6_inst_adr                                                        "0x0021"
+#define TP_SEC_DATA6_inst                                                            0x0021
+#define TP_SEC_DATA6_neg_filter_value_lsb_shift                                      (0)
+#define TP_SEC_DATA6_neg_filter_value_lsb_mask                                       (0xFFFFFFFF)
+#define TP_SEC_DATA6_neg_filter_value_lsb(data)                                      (0xFFFFFFFF&((data)<<0))
+#define TP_SEC_DATA6_neg_filter_value_lsb_src(data)                                  ((0xFFFFFFFF&(data))>>0)
+#define TP_SEC_DATA6_get_neg_filter_value_lsb(data)                                  ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_SEC_DATA7                                                                 0x18014088
+#define TP_SEC_DATA7_reg_addr                                                        "0xB8014088"
+#define TP_SEC_DATA7_reg                                                             0xB8014088
+#define set_TP_SEC_DATA7_reg(data)   (*((volatile unsigned int*) TP_SEC_DATA7_reg)=data)
+#define get_TP_SEC_DATA7_reg   (*((volatile unsigned int*) TP_SEC_DATA7_reg))
+#define TP_SEC_DATA7_inst_adr                                                        "0x0022"
+#define TP_SEC_DATA7_inst                                                            0x0022
+#define TP_SEC_DATA7_neg_mask_value_msb_shift                                        (0)
+#define TP_SEC_DATA7_neg_mask_value_msb_mask                                         (0xFFFFFFFF)
+#define TP_SEC_DATA7_neg_mask_value_msb(data)                                        (0xFFFFFFFF&((data)<<0))
+#define TP_SEC_DATA7_neg_mask_value_msb_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define TP_SEC_DATA7_get_neg_mask_value_msb(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_SEC_DATA8                                                                 0x1801408C
+#define TP_SEC_DATA8_reg_addr                                                        "0xB801408C"
+#define TP_SEC_DATA8_reg                                                             0xB801408C
+#define set_TP_SEC_DATA8_reg(data)   (*((volatile unsigned int*) TP_SEC_DATA8_reg)=data)
+#define get_TP_SEC_DATA8_reg   (*((volatile unsigned int*) TP_SEC_DATA8_reg))
+#define TP_SEC_DATA8_inst_adr                                                        "0x0023"
+#define TP_SEC_DATA8_inst                                                            0x0023
+#define TP_SEC_DATA8_neg_mask_value_lsb_shift                                        (0)
+#define TP_SEC_DATA8_neg_mask_value_lsb_mask                                         (0xFFFFFFFF)
+#define TP_SEC_DATA8_neg_mask_value_lsb(data)                                        (0xFFFFFFFF&((data)<<0))
+#define TP_SEC_DATA8_neg_mask_value_lsb_src(data)                                    ((0xFFFFFFFF&(data))>>0)
+#define TP_SEC_DATA8_get_neg_mask_value_lsb(data)                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_SEC_DATA9                                                                 0x18014090
+#define TP_SEC_DATA9_reg_addr                                                        "0xB8014090"
+#define TP_SEC_DATA9_reg                                                             0xB8014090
+#define set_TP_SEC_DATA9_reg(data)   (*((volatile unsigned int*) TP_SEC_DATA9_reg)=data)
+#define get_TP_SEC_DATA9_reg   (*((volatile unsigned int*) TP_SEC_DATA9_reg))
+#define TP_SEC_DATA9_inst_adr                                                        "0x0024"
+#define TP_SEC_DATA9_inst                                                            0x0024
+#define TP_SEC_DATA9_neg_sp_filter_shift                                             (12)
+#define TP_SEC_DATA9_neg_sp_filter_mask                                              (0x00003000)
+#define TP_SEC_DATA9_neg_sp_filter(data)                                             (0x00003000&((data)<<12))
+#define TP_SEC_DATA9_neg_sp_filter_src(data)                                         ((0x00003000&(data))>>12)
+#define TP_SEC_DATA9_get_neg_sp_filter(data)                                         ((0x00003000&(data))>>12)
+#define TP_SEC_DATA9_neg_sp_mask_shift                                               (10)
+#define TP_SEC_DATA9_neg_sp_mask_mask                                                (0x00000C00)
+#define TP_SEC_DATA9_neg_sp_mask(data)                                               (0x00000C00&((data)<<10))
+#define TP_SEC_DATA9_neg_sp_mask_src(data)                                           ((0x00000C00&(data))>>10)
+#define TP_SEC_DATA9_get_neg_sp_mask(data)                                           ((0x00000C00&(data))>>10)
+#define TP_SEC_DATA9_filter_sel_shift                                                (0)
+#define TP_SEC_DATA9_filter_sel_mask                                                 (0x00000003)
+#define TP_SEC_DATA9_filter_sel(data)                                                (0x00000003&((data)<<0))
+#define TP_SEC_DATA9_filter_sel_src(data)                                            ((0x00000003&(data))>>0)
+#define TP_SEC_DATA9_get_filter_sel(data)                                            ((0x00000003&(data))>>0)
+
+
+#define TP_TP0_DES_CNTL                                                              0x18014050
+#define TP_TP0_DES_CNTL_reg_addr                                                     "0xB8014050"
+#define TP_TP0_DES_CNTL_reg                                                          0xB8014050
+#define set_TP_TP0_DES_CNTL_reg(data)   (*((volatile unsigned int*) TP_TP0_DES_CNTL_reg)=data)
+#define get_TP_TP0_DES_CNTL_reg   (*((volatile unsigned int*) TP_TP0_DES_CNTL_reg))
+#define TP_TP0_DES_CNTL_inst_adr                                                     "0x0014"
+#define TP_TP0_DES_CNTL_inst                                                         0x0014
+#define TP_TP0_DES_CNTL_ofb_mode_shift                                               (18)
+#define TP_TP0_DES_CNTL_ofb_mode_mask                                                (0x000C0000)
+#define TP_TP0_DES_CNTL_ofb_mode(data)                                               (0x000C0000&((data)<<18))
+#define TP_TP0_DES_CNTL_ofb_mode_src(data)                                           ((0x000C0000&(data))>>18)
+#define TP_TP0_DES_CNTL_get_ofb_mode(data)                                           ((0x000C0000&(data))>>18)
+#define TP_TP0_DES_CNTL_csa_mode_shift                                               (16)
+#define TP_TP0_DES_CNTL_csa_mode_mask                                                (0x00030000)
+#define TP_TP0_DES_CNTL_csa_mode(data)                                               (0x00030000&((data)<<16))
+#define TP_TP0_DES_CNTL_csa_mode_src(data)                                           ((0x00030000&(data))>>16)
+#define TP_TP0_DES_CNTL_get_csa_mode(data)                                           ((0x00030000&(data))>>16)
+#define TP_TP0_DES_CNTL_round_shift                                                  (8)
+#define TP_TP0_DES_CNTL_round_mask                                                   (0x0000FF00)
+#define TP_TP0_DES_CNTL_round(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TP0_DES_CNTL_round_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TP0_DES_CNTL_get_round(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TP0_DES_CNTL_multi2_mode_shift                                            (7)
+#define TP_TP0_DES_CNTL_multi2_mode_mask                                             (0x00000080)
+#define TP_TP0_DES_CNTL_multi2_mode(data)                                            (0x00000080&((data)<<7))
+#define TP_TP0_DES_CNTL_multi2_mode_src(data)                                        ((0x00000080&(data))>>7)
+#define TP_TP0_DES_CNTL_get_multi2_mode(data)                                        ((0x00000080&(data))>>7)
+#define TP_TP0_DES_CNTL_map_11_shift                                                 (6)
+#define TP_TP0_DES_CNTL_map_11_mask                                                  (0x00000040)
+#define TP_TP0_DES_CNTL_map_11(data)                                                 (0x00000040&((data)<<6))
+#define TP_TP0_DES_CNTL_map_11_src(data)                                             ((0x00000040&(data))>>6)
+#define TP_TP0_DES_CNTL_get_map_11(data)                                             ((0x00000040&(data))>>6)
+#define TP_TP0_DES_CNTL_map_10_shift                                                 (5)
+#define TP_TP0_DES_CNTL_map_10_mask                                                  (0x00000020)
+#define TP_TP0_DES_CNTL_map_10(data)                                                 (0x00000020&((data)<<5))
+#define TP_TP0_DES_CNTL_map_10_src(data)                                             ((0x00000020&(data))>>5)
+#define TP_TP0_DES_CNTL_get_map_10(data)                                             ((0x00000020&(data))>>5)
+#define TP_TP0_DES_CNTL_map_01_shift                                                 (4)
+#define TP_TP0_DES_CNTL_map_01_mask                                                  (0x00000010)
+#define TP_TP0_DES_CNTL_map_01(data)                                                 (0x00000010&((data)<<4))
+#define TP_TP0_DES_CNTL_map_01_src(data)                                             ((0x00000010&(data))>>4)
+#define TP_TP0_DES_CNTL_get_map_01(data)                                             ((0x00000010&(data))>>4)
+#define TP_TP0_DES_CNTL_des_mode_shift                                               (3)
+#define TP_TP0_DES_CNTL_des_mode_mask                                                (0x00000008)
+#define TP_TP0_DES_CNTL_des_mode(data)                                               (0x00000008&((data)<<3))
+#define TP_TP0_DES_CNTL_des_mode_src(data)                                           ((0x00000008&(data))>>3)
+#define TP_TP0_DES_CNTL_get_des_mode(data)                                           ((0x00000008&(data))>>3)
+#define TP_TP0_DES_CNTL_mode_shift                                                   (0)
+#define TP_TP0_DES_CNTL_mode_mask                                                    (0x00000007)
+#define TP_TP0_DES_CNTL_mode(data)                                                   (0x00000007&((data)<<0))
+#define TP_TP0_DES_CNTL_mode_src(data)                                               ((0x00000007&(data))>>0)
+#define TP_TP0_DES_CNTL_get_mode(data)                                               ((0x00000007&(data))>>0)
+
+
+#define TP_KEY_INFO_0                                                                0x18014058
+#define TP_KEY_INFO_1                                                                0x1801405C
+#define TP_KEY_INFO_0_reg_addr                                                       "0xB8014058"
+#define TP_KEY_INFO_1_reg_addr                                                       "0xB801405C"
+#define TP_KEY_INFO_0_reg                                                            0xB8014058
+#define TP_KEY_INFO_1_reg                                                            0xB801405C
+#define set_TP_KEY_INFO_0_reg(data)   (*((volatile unsigned int*) TP_KEY_INFO_0_reg)=data)
+#define set_TP_KEY_INFO_1_reg(data)   (*((volatile unsigned int*) TP_KEY_INFO_1_reg)=data)
+#define get_TP_KEY_INFO_0_reg   (*((volatile unsigned int*) TP_KEY_INFO_0_reg))
+#define get_TP_KEY_INFO_1_reg   (*((volatile unsigned int*) TP_KEY_INFO_1_reg))
+#define TP_KEY_INFO_0_inst_adr                                                       "0x0016"
+#define TP_KEY_INFO_1_inst_adr                                                       "0x0017"
+#define TP_KEY_INFO_0_inst                                                           0x0016
+#define TP_KEY_INFO_1_inst                                                           0x0017
+#define TP_KEY_INFO_key_info_shift                                                   (0)
+#define TP_KEY_INFO_key_info_mask                                                    (0xFFFFFFFF)
+#define TP_KEY_INFO_key_info(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define TP_KEY_INFO_key_info_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define TP_KEY_INFO_get_key_info(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_KEY_CTRL                                                                  0x18014060
+#define TP_KEY_CTRL_reg_addr                                                         "0xB8014060"
+#define TP_KEY_CTRL_reg                                                              0xB8014060
+#define set_TP_KEY_CTRL_reg(data)   (*((volatile unsigned int*) TP_KEY_CTRL_reg)=data)
+#define get_TP_KEY_CTRL_reg   (*((volatile unsigned int*) TP_KEY_CTRL_reg))
+#define TP_KEY_CTRL_inst_adr                                                         "0x0018"
+#define TP_KEY_CTRL_inst                                                             0x0018
+#define TP_KEY_CTRL_r_w_shift                                                        (7)
+#define TP_KEY_CTRL_r_w_mask                                                         (0x00000080)
+#define TP_KEY_CTRL_r_w(data)                                                        (0x00000080&((data)<<7))
+#define TP_KEY_CTRL_r_w_src(data)                                                    ((0x00000080&(data))>>7)
+#define TP_KEY_CTRL_get_r_w(data)                                                    ((0x00000080&(data))>>7)
+#define TP_KEY_CTRL_idx_shift                                                        (0)
+#define TP_KEY_CTRL_idx_mask                                                         (0x0000007F)
+#define TP_KEY_CTRL_idx(data)                                                        (0x0000007F&((data)<<0))
+#define TP_KEY_CTRL_idx_src(data)                                                    ((0x0000007F&(data))>>0)
+#define TP_KEY_CTRL_get_idx(data)                                                    ((0x0000007F&(data))>>0)
+
+
+#define TP_TP1_DES_CNTL                                                              0x180140A0
+#define TP_TP1_DES_CNTL_reg_addr                                                     "0xB80140A0"
+#define TP_TP1_DES_CNTL_reg                                                          0xB80140A0
+#define set_TP_TP1_DES_CNTL_reg(data)   (*((volatile unsigned int*) TP_TP1_DES_CNTL_reg)=data)
+#define get_TP_TP1_DES_CNTL_reg   (*((volatile unsigned int*) TP_TP1_DES_CNTL_reg))
+#define TP_TP1_DES_CNTL_inst_adr                                                     "0x0028"
+#define TP_TP1_DES_CNTL_inst                                                         0x0028
+#define TP_TP1_DES_CNTL_ofb_mode_shift                                               (18)
+#define TP_TP1_DES_CNTL_ofb_mode_mask                                                (0x000C0000)
+#define TP_TP1_DES_CNTL_ofb_mode(data)                                               (0x000C0000&((data)<<18))
+#define TP_TP1_DES_CNTL_ofb_mode_src(data)                                           ((0x000C0000&(data))>>18)
+#define TP_TP1_DES_CNTL_get_ofb_mode(data)                                           ((0x000C0000&(data))>>18)
+#define TP_TP1_DES_CNTL_csa_mode_shift                                               (16)
+#define TP_TP1_DES_CNTL_csa_mode_mask                                                (0x00030000)
+#define TP_TP1_DES_CNTL_csa_mode(data)                                               (0x00030000&((data)<<16))
+#define TP_TP1_DES_CNTL_csa_mode_src(data)                                           ((0x00030000&(data))>>16)
+#define TP_TP1_DES_CNTL_get_csa_mode(data)                                           ((0x00030000&(data))>>16)
+#define TP_TP1_DES_CNTL_round_shift                                                  (8)
+#define TP_TP1_DES_CNTL_round_mask                                                   (0x0000FF00)
+#define TP_TP1_DES_CNTL_round(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TP1_DES_CNTL_round_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TP1_DES_CNTL_get_round(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TP1_DES_CNTL_multi2_mode_shift                                            (7)
+#define TP_TP1_DES_CNTL_multi2_mode_mask                                             (0x00000080)
+#define TP_TP1_DES_CNTL_multi2_mode(data)                                            (0x00000080&((data)<<7))
+#define TP_TP1_DES_CNTL_multi2_mode_src(data)                                        ((0x00000080&(data))>>7)
+#define TP_TP1_DES_CNTL_get_multi2_mode(data)                                        ((0x00000080&(data))>>7)
+#define TP_TP1_DES_CNTL_map_11_shift                                                 (6)
+#define TP_TP1_DES_CNTL_map_11_mask                                                  (0x00000040)
+#define TP_TP1_DES_CNTL_map_11(data)                                                 (0x00000040&((data)<<6))
+#define TP_TP1_DES_CNTL_map_11_src(data)                                             ((0x00000040&(data))>>6)
+#define TP_TP1_DES_CNTL_get_map_11(data)                                             ((0x00000040&(data))>>6)
+#define TP_TP1_DES_CNTL_map_10_shift                                                 (5)
+#define TP_TP1_DES_CNTL_map_10_mask                                                  (0x00000020)
+#define TP_TP1_DES_CNTL_map_10(data)                                                 (0x00000020&((data)<<5))
+#define TP_TP1_DES_CNTL_map_10_src(data)                                             ((0x00000020&(data))>>5)
+#define TP_TP1_DES_CNTL_get_map_10(data)                                             ((0x00000020&(data))>>5)
+#define TP_TP1_DES_CNTL_map_01_shift                                                 (4)
+#define TP_TP1_DES_CNTL_map_01_mask                                                  (0x00000010)
+#define TP_TP1_DES_CNTL_map_01(data)                                                 (0x00000010&((data)<<4))
+#define TP_TP1_DES_CNTL_map_01_src(data)                                             ((0x00000010&(data))>>4)
+#define TP_TP1_DES_CNTL_get_map_01(data)                                             ((0x00000010&(data))>>4)
+#define TP_TP1_DES_CNTL_des_mode_shift                                               (3)
+#define TP_TP1_DES_CNTL_des_mode_mask                                                (0x00000008)
+#define TP_TP1_DES_CNTL_des_mode(data)                                               (0x00000008&((data)<<3))
+#define TP_TP1_DES_CNTL_des_mode_src(data)                                           ((0x00000008&(data))>>3)
+#define TP_TP1_DES_CNTL_get_des_mode(data)                                           ((0x00000008&(data))>>3)
+#define TP_TP1_DES_CNTL_mode_shift                                                   (0)
+#define TP_TP1_DES_CNTL_mode_mask                                                    (0x00000007)
+#define TP_TP1_DES_CNTL_mode(data)                                                   (0x00000007&((data)<<0))
+#define TP_TP1_DES_CNTL_mode_src(data)                                               ((0x00000007&(data))>>0)
+#define TP_TP1_DES_CNTL_get_mode(data)                                               ((0x00000007&(data))>>0)
+
+
+#define TP_TP2_DES_CNTL                                                              0x180140A4
+#define TP_TP2_DES_CNTL_reg_addr                                                     "0xB80140A4"
+#define TP_TP2_DES_CNTL_reg                                                          0xB80140A4
+#define set_TP_TP2_DES_CNTL_reg(data)   (*((volatile unsigned int*) TP_TP2_DES_CNTL_reg)=data)
+#define get_TP_TP2_DES_CNTL_reg   (*((volatile unsigned int*) TP_TP2_DES_CNTL_reg))
+#define TP_TP2_DES_CNTL_inst_adr                                                     "0x0029"
+#define TP_TP2_DES_CNTL_inst                                                         0x0029
+#define TP_TP2_DES_CNTL_ofb_mode_shift                                               (18)
+#define TP_TP2_DES_CNTL_ofb_mode_mask                                                (0x000C0000)
+#define TP_TP2_DES_CNTL_ofb_mode(data)                                               (0x000C0000&((data)<<18))
+#define TP_TP2_DES_CNTL_ofb_mode_src(data)                                           ((0x000C0000&(data))>>18)
+#define TP_TP2_DES_CNTL_get_ofb_mode(data)                                           ((0x000C0000&(data))>>18)
+#define TP_TP2_DES_CNTL_csa_mode_shift                                               (16)
+#define TP_TP2_DES_CNTL_csa_mode_mask                                                (0x00030000)
+#define TP_TP2_DES_CNTL_csa_mode(data)                                               (0x00030000&((data)<<16))
+#define TP_TP2_DES_CNTL_csa_mode_src(data)                                           ((0x00030000&(data))>>16)
+#define TP_TP2_DES_CNTL_get_csa_mode(data)                                           ((0x00030000&(data))>>16)
+#define TP_TP2_DES_CNTL_round_shift                                                  (8)
+#define TP_TP2_DES_CNTL_round_mask                                                   (0x0000FF00)
+#define TP_TP2_DES_CNTL_round(data)                                                  (0x0000FF00&((data)<<8))
+#define TP_TP2_DES_CNTL_round_src(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TP2_DES_CNTL_get_round(data)                                              ((0x0000FF00&(data))>>8)
+#define TP_TP2_DES_CNTL_multi2_mode_shift                                            (7)
+#define TP_TP2_DES_CNTL_multi2_mode_mask                                             (0x00000080)
+#define TP_TP2_DES_CNTL_multi2_mode(data)                                            (0x00000080&((data)<<7))
+#define TP_TP2_DES_CNTL_multi2_mode_src(data)                                        ((0x00000080&(data))>>7)
+#define TP_TP2_DES_CNTL_get_multi2_mode(data)                                        ((0x00000080&(data))>>7)
+#define TP_TP2_DES_CNTL_map_11_shift                                                 (6)
+#define TP_TP2_DES_CNTL_map_11_mask                                                  (0x00000040)
+#define TP_TP2_DES_CNTL_map_11(data)                                                 (0x00000040&((data)<<6))
+#define TP_TP2_DES_CNTL_map_11_src(data)                                             ((0x00000040&(data))>>6)
+#define TP_TP2_DES_CNTL_get_map_11(data)                                             ((0x00000040&(data))>>6)
+#define TP_TP2_DES_CNTL_map_10_shift                                                 (5)
+#define TP_TP2_DES_CNTL_map_10_mask                                                  (0x00000020)
+#define TP_TP2_DES_CNTL_map_10(data)                                                 (0x00000020&((data)<<5))
+#define TP_TP2_DES_CNTL_map_10_src(data)                                             ((0x00000020&(data))>>5)
+#define TP_TP2_DES_CNTL_get_map_10(data)                                             ((0x00000020&(data))>>5)
+#define TP_TP2_DES_CNTL_map_01_shift                                                 (4)
+#define TP_TP2_DES_CNTL_map_01_mask                                                  (0x00000010)
+#define TP_TP2_DES_CNTL_map_01(data)                                                 (0x00000010&((data)<<4))
+#define TP_TP2_DES_CNTL_map_01_src(data)                                             ((0x00000010&(data))>>4)
+#define TP_TP2_DES_CNTL_get_map_01(data)                                             ((0x00000010&(data))>>4)
+#define TP_TP2_DES_CNTL_des_mode_shift                                               (3)
+#define TP_TP2_DES_CNTL_des_mode_mask                                                (0x00000008)
+#define TP_TP2_DES_CNTL_des_mode(data)                                               (0x00000008&((data)<<3))
+#define TP_TP2_DES_CNTL_des_mode_src(data)                                           ((0x00000008&(data))>>3)
+#define TP_TP2_DES_CNTL_get_des_mode(data)                                           ((0x00000008&(data))>>3)
+#define TP_TP2_DES_CNTL_mode_shift                                                   (0)
+#define TP_TP2_DES_CNTL_mode_mask                                                    (0x00000007)
+#define TP_TP2_DES_CNTL_mode(data)                                                   (0x00000007&((data)<<0))
+#define TP_TP2_DES_CNTL_mode_src(data)                                               ((0x00000007&(data))>>0)
+#define TP_TP2_DES_CNTL_get_mode(data)                                               ((0x00000007&(data))>>0)
+
+
+#define TP_CRC_INIT                                                                  0x180140EC
+#define TP_CRC_INIT_reg_addr                                                         "0xB80140EC"
+#define TP_CRC_INIT_reg                                                              0xB80140EC
+#define set_TP_CRC_INIT_reg(data)   (*((volatile unsigned int*) TP_CRC_INIT_reg)=data)
+#define get_TP_CRC_INIT_reg   (*((volatile unsigned int*) TP_CRC_INIT_reg))
+#define TP_CRC_INIT_inst_adr                                                         "0x003B"
+#define TP_CRC_INIT_inst                                                             0x003B
+#define TP_CRC_INIT_crc_init_shift                                                   (0)
+#define TP_CRC_INIT_crc_init_mask                                                    (0xFFFFFFFF)
+#define TP_CRC_INIT_crc_init(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define TP_CRC_INIT_crc_init_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define TP_CRC_INIT_get_crc_init(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_THRESHOLD                                                                 0x180140F0
+#define TP_THRESHOLD_reg_addr                                                        "0xB80140F0"
+#define TP_THRESHOLD_reg                                                             0xB80140F0
+#define set_TP_THRESHOLD_reg(data)   (*((volatile unsigned int*) TP_THRESHOLD_reg)=data)
+#define get_TP_THRESHOLD_reg   (*((volatile unsigned int*) TP_THRESHOLD_reg))
+#define TP_THRESHOLD_inst_adr                                                        "0x003C"
+#define TP_THRESHOLD_inst                                                            0x003C
+#define TP_THRESHOLD_threshold_shift                                                 (0)
+#define TP_THRESHOLD_threshold_mask                                                  (0x07FFFFFF)
+#define TP_THRESHOLD_threshold(data)                                                 (0x07FFFFFF&((data)<<0))
+#define TP_THRESHOLD_threshold_src(data)                                             ((0x07FFFFFF&(data))>>0)
+#define TP_THRESHOLD_get_threshold(data)                                             ((0x07FFFFFF&(data))>>0)
+
+
+#define TP_FULLNESS                                                                  0x180140F4
+#define TP_FULLNESS_reg_addr                                                         "0xB80140F4"
+#define TP_FULLNESS_reg                                                              0xB80140F4
+#define set_TP_FULLNESS_reg(data)   (*((volatile unsigned int*) TP_FULLNESS_reg)=data)
+#define get_TP_FULLNESS_reg   (*((volatile unsigned int*) TP_FULLNESS_reg))
+#define TP_FULLNESS_inst_adr                                                         "0x003D"
+#define TP_FULLNESS_inst                                                             0x003D
+#define TP_FULLNESS_fullness_shift                                                   (0)
+#define TP_FULLNESS_fullness_mask                                                    (0x07FFFFFF)
+#define TP_FULLNESS_fullness(data)                                                   (0x07FFFFFF&((data)<<0))
+#define TP_FULLNESS_fullness_src(data)                                               ((0x07FFFFFF&(data))>>0)
+#define TP_FULLNESS_get_fullness(data)                                               ((0x07FFFFFF&(data))>>0)
+
+
+#define TP_RING_CTRL                                                                 0x180140FC
+#define TP_RING_CTRL_reg_addr                                                        "0xB80140FC"
+#define TP_RING_CTRL_reg                                                             0xB80140FC
+#define set_TP_RING_CTRL_reg(data)   (*((volatile unsigned int*) TP_RING_CTRL_reg)=data)
+#define get_TP_RING_CTRL_reg   (*((volatile unsigned int*) TP_RING_CTRL_reg))
+#define TP_RING_CTRL_inst_adr                                                        "0x003F"
+#define TP_RING_CTRL_inst                                                            0x003F
+#define TP_RING_CTRL_wm_shift                                                        (7)
+#define TP_RING_CTRL_wm_mask                                                         (0x00000780)
+#define TP_RING_CTRL_wm(data)                                                        (0x00000780&((data)<<7))
+#define TP_RING_CTRL_wm_src(data)                                                    ((0x00000780&(data))>>7)
+#define TP_RING_CTRL_get_wm(data)                                                    ((0x00000780&(data))>>7)
+#define TP_RING_CTRL_r_w_shift                                                       (6)
+#define TP_RING_CTRL_r_w_mask                                                        (0x00000040)
+#define TP_RING_CTRL_r_w(data)                                                       (0x00000040&((data)<<6))
+#define TP_RING_CTRL_r_w_src(data)                                                   ((0x00000040&(data))>>6)
+#define TP_RING_CTRL_get_r_w(data)                                                   ((0x00000040&(data))>>6)
+#define TP_RING_CTRL_idx_shift                                                       (0)
+#define TP_RING_CTRL_idx_mask                                                        (0x0000001F)
+#define TP_RING_CTRL_idx(data)                                                       (0x0000001F&((data)<<0))
+#define TP_RING_CTRL_idx_src(data)                                                   ((0x0000001F&(data))>>0)
+#define TP_RING_CTRL_get_idx(data)                                                   ((0x0000001F&(data))>>0)
+
+
+#define TP_RING_LIMIT                                                                0x18014100
+#define TP_RING_LIMIT_reg_addr                                                       "0xB8014100"
+#define TP_RING_LIMIT_reg                                                            0xB8014100
+#define set_TP_RING_LIMIT_reg(data)   (*((volatile unsigned int*) TP_RING_LIMIT_reg)=data)
+#define get_TP_RING_LIMIT_reg   (*((volatile unsigned int*) TP_RING_LIMIT_reg))
+#define TP_RING_LIMIT_inst_adr                                                       "0x0040"
+#define TP_RING_LIMIT_inst                                                           0x0040
+#define TP_RING_LIMIT_ring_limit_shift                                               (3)
+#define TP_RING_LIMIT_ring_limit_mask                                                (0x3FFFFFF8)
+#define TP_RING_LIMIT_ring_limit(data)                                               (0x3FFFFFF8&((data)<<3))
+#define TP_RING_LIMIT_ring_limit_src(data)                                           ((0x3FFFFFF8&(data))>>3)
+#define TP_RING_LIMIT_get_ring_limit(data)                                           ((0x3FFFFFF8&(data))>>3)
+
+
+#define TP_RING_BASE                                                                 0x18014104
+#define TP_RING_BASE_reg_addr                                                        "0xB8014104"
+#define TP_RING_BASE_reg                                                             0xB8014104
+#define set_TP_RING_BASE_reg(data)   (*((volatile unsigned int*) TP_RING_BASE_reg)=data)
+#define get_TP_RING_BASE_reg   (*((volatile unsigned int*) TP_RING_BASE_reg))
+#define TP_RING_BASE_inst_adr                                                        "0x0041"
+#define TP_RING_BASE_inst                                                            0x0041
+#define TP_RING_BASE_ring_base_shift                                                 (3)
+#define TP_RING_BASE_ring_base_mask                                                  (0x3FFFFFF8)
+#define TP_RING_BASE_ring_base(data)                                                 (0x3FFFFFF8&((data)<<3))
+#define TP_RING_BASE_ring_base_src(data)                                             ((0x3FFFFFF8&(data))>>3)
+#define TP_RING_BASE_get_ring_base(data)                                             ((0x3FFFFFF8&(data))>>3)
+
+
+#define TP_RING_RP                                                                   0x18014108
+#define TP_RING_RP_reg_addr                                                          "0xB8014108"
+#define TP_RING_RP_reg                                                               0xB8014108
+#define set_TP_RING_RP_reg(data)   (*((volatile unsigned int*) TP_RING_RP_reg)=data)
+#define get_TP_RING_RP_reg   (*((volatile unsigned int*) TP_RING_RP_reg))
+#define TP_RING_RP_inst_adr                                                          "0x0042"
+#define TP_RING_RP_inst                                                              0x0042
+#define TP_RING_RP_ring_rp_shift                                                     (0)
+#define TP_RING_RP_ring_rp_mask                                                      (0x3FFFFFFF)
+#define TP_RING_RP_ring_rp(data)                                                     (0x3FFFFFFF&((data)<<0))
+#define TP_RING_RP_ring_rp_src(data)                                                 ((0x3FFFFFFF&(data))>>0)
+#define TP_RING_RP_get_ring_rp(data)                                                 ((0x3FFFFFFF&(data))>>0)
+
+
+#define TP_RING_WP                                                                   0x1801410c
+#define TP_RING_WP_reg_addr                                                          "0xB801410C"
+#define TP_RING_WP_reg                                                               0xB801410C
+#define set_TP_RING_WP_reg(data)   (*((volatile unsigned int*) TP_RING_WP_reg)=data)
+#define get_TP_RING_WP_reg   (*((volatile unsigned int*) TP_RING_WP_reg))
+#define TP_RING_WP_inst_adr                                                          "0x0043"
+#define TP_RING_WP_inst                                                              0x0043
+#define TP_RING_WP_ring_wp_shift                                                     (0)
+#define TP_RING_WP_ring_wp_mask                                                      (0x3FFFFFFF)
+#define TP_RING_WP_ring_wp(data)                                                     (0x3FFFFFFF&((data)<<0))
+#define TP_RING_WP_ring_wp_src(data)                                                 ((0x3FFFFFFF&(data))>>0)
+#define TP_RING_WP_get_ring_wp(data)                                                 ((0x3FFFFFFF&(data))>>0)
+
+
+#define TP_RING_AVAIL_INT_0                                                          0x18014600
+#define TP_RING_AVAIL_INT_1                                                          0x18014604
+#define TP_RING_AVAIL_INT_0_reg_addr                                                 "0xB8014600"
+#define TP_RING_AVAIL_INT_1_reg_addr                                                 "0xB8014604"
+#define TP_RING_AVAIL_INT_0_reg                                                      0xB8014600
+#define TP_RING_AVAIL_INT_1_reg                                                      0xB8014604
+#define set_TP_RING_AVAIL_INT_0_reg(data)   (*((volatile unsigned int*) TP_RING_AVAIL_INT_0_reg)=data)
+#define set_TP_RING_AVAIL_INT_1_reg(data)   (*((volatile unsigned int*) TP_RING_AVAIL_INT_1_reg)=data)
+#define get_TP_RING_AVAIL_INT_0_reg   (*((volatile unsigned int*) TP_RING_AVAIL_INT_0_reg))
+#define get_TP_RING_AVAIL_INT_1_reg   (*((volatile unsigned int*) TP_RING_AVAIL_INT_1_reg))
+#define TP_RING_AVAIL_INT_0_inst_adr                                                 "0x0080"
+#define TP_RING_AVAIL_INT_1_inst_adr                                                 "0x0081"
+#define TP_RING_AVAIL_INT_0_inst                                                     0x0080
+#define TP_RING_AVAIL_INT_1_inst                                                     0x0081
+#define TP_RING_AVAIL_INT_ring_avail_15_shift                                        (16)
+#define TP_RING_AVAIL_INT_ring_avail_15_mask                                         (0x00010000)
+#define TP_RING_AVAIL_INT_ring_avail_15(data)                                        (0x00010000&((data)<<16))
+#define TP_RING_AVAIL_INT_ring_avail_15_src(data)                                    ((0x00010000&(data))>>16)
+#define TP_RING_AVAIL_INT_get_ring_avail_15(data)                                    ((0x00010000&(data))>>16)
+#define TP_RING_AVAIL_INT_ring_avail_14_shift                                        (15)
+#define TP_RING_AVAIL_INT_ring_avail_14_mask                                         (0x00008000)
+#define TP_RING_AVAIL_INT_ring_avail_14(data)                                        (0x00008000&((data)<<15))
+#define TP_RING_AVAIL_INT_ring_avail_14_src(data)                                    ((0x00008000&(data))>>15)
+#define TP_RING_AVAIL_INT_get_ring_avail_14(data)                                    ((0x00008000&(data))>>15)
+#define TP_RING_AVAIL_INT_ring_avail_13_shift                                        (14)
+#define TP_RING_AVAIL_INT_ring_avail_13_mask                                         (0x00004000)
+#define TP_RING_AVAIL_INT_ring_avail_13(data)                                        (0x00004000&((data)<<14))
+#define TP_RING_AVAIL_INT_ring_avail_13_src(data)                                    ((0x00004000&(data))>>14)
+#define TP_RING_AVAIL_INT_get_ring_avail_13(data)                                    ((0x00004000&(data))>>14)
+#define TP_RING_AVAIL_INT_ring_avail_12_shift                                        (13)
+#define TP_RING_AVAIL_INT_ring_avail_12_mask                                         (0x00002000)
+#define TP_RING_AVAIL_INT_ring_avail_12(data)                                        (0x00002000&((data)<<13))
+#define TP_RING_AVAIL_INT_ring_avail_12_src(data)                                    ((0x00002000&(data))>>13)
+#define TP_RING_AVAIL_INT_get_ring_avail_12(data)                                    ((0x00002000&(data))>>13)
+#define TP_RING_AVAIL_INT_ring_avail_11_shift                                        (12)
+#define TP_RING_AVAIL_INT_ring_avail_11_mask                                         (0x00001000)
+#define TP_RING_AVAIL_INT_ring_avail_11(data)                                        (0x00001000&((data)<<12))
+#define TP_RING_AVAIL_INT_ring_avail_11_src(data)                                    ((0x00001000&(data))>>12)
+#define TP_RING_AVAIL_INT_get_ring_avail_11(data)                                    ((0x00001000&(data))>>12)
+#define TP_RING_AVAIL_INT_ring_avail_10_shift                                        (11)
+#define TP_RING_AVAIL_INT_ring_avail_10_mask                                         (0x00000800)
+#define TP_RING_AVAIL_INT_ring_avail_10(data)                                        (0x00000800&((data)<<11))
+#define TP_RING_AVAIL_INT_ring_avail_10_src(data)                                    ((0x00000800&(data))>>11)
+#define TP_RING_AVAIL_INT_get_ring_avail_10(data)                                    ((0x00000800&(data))>>11)
+#define TP_RING_AVAIL_INT_ring_avail_9_shift                                         (10)
+#define TP_RING_AVAIL_INT_ring_avail_9_mask                                          (0x00000400)
+#define TP_RING_AVAIL_INT_ring_avail_9(data)                                         (0x00000400&((data)<<10))
+#define TP_RING_AVAIL_INT_ring_avail_9_src(data)                                     ((0x00000400&(data))>>10)
+#define TP_RING_AVAIL_INT_get_ring_avail_9(data)                                     ((0x00000400&(data))>>10)
+#define TP_RING_AVAIL_INT_ring_avail_8_shift                                         (9)
+#define TP_RING_AVAIL_INT_ring_avail_8_mask                                          (0x00000200)
+#define TP_RING_AVAIL_INT_ring_avail_8(data)                                         (0x00000200&((data)<<9))
+#define TP_RING_AVAIL_INT_ring_avail_8_src(data)                                     ((0x00000200&(data))>>9)
+#define TP_RING_AVAIL_INT_get_ring_avail_8(data)                                     ((0x00000200&(data))>>9)
+#define TP_RING_AVAIL_INT_ring_avail_7_shift                                         (8)
+#define TP_RING_AVAIL_INT_ring_avail_7_mask                                          (0x00000100)
+#define TP_RING_AVAIL_INT_ring_avail_7(data)                                         (0x00000100&((data)<<8))
+#define TP_RING_AVAIL_INT_ring_avail_7_src(data)                                     ((0x00000100&(data))>>8)
+#define TP_RING_AVAIL_INT_get_ring_avail_7(data)                                     ((0x00000100&(data))>>8)
+#define TP_RING_AVAIL_INT_ring_avail_6_shift                                         (7)
+#define TP_RING_AVAIL_INT_ring_avail_6_mask                                          (0x00000080)
+#define TP_RING_AVAIL_INT_ring_avail_6(data)                                         (0x00000080&((data)<<7))
+#define TP_RING_AVAIL_INT_ring_avail_6_src(data)                                     ((0x00000080&(data))>>7)
+#define TP_RING_AVAIL_INT_get_ring_avail_6(data)                                     ((0x00000080&(data))>>7)
+#define TP_RING_AVAIL_INT_ring_avail_5_shift                                         (6)
+#define TP_RING_AVAIL_INT_ring_avail_5_mask                                          (0x00000040)
+#define TP_RING_AVAIL_INT_ring_avail_5(data)                                         (0x00000040&((data)<<6))
+#define TP_RING_AVAIL_INT_ring_avail_5_src(data)                                     ((0x00000040&(data))>>6)
+#define TP_RING_AVAIL_INT_get_ring_avail_5(data)                                     ((0x00000040&(data))>>6)
+#define TP_RING_AVAIL_INT_ring_avail_4_shift                                         (5)
+#define TP_RING_AVAIL_INT_ring_avail_4_mask                                          (0x00000020)
+#define TP_RING_AVAIL_INT_ring_avail_4(data)                                         (0x00000020&((data)<<5))
+#define TP_RING_AVAIL_INT_ring_avail_4_src(data)                                     ((0x00000020&(data))>>5)
+#define TP_RING_AVAIL_INT_get_ring_avail_4(data)                                     ((0x00000020&(data))>>5)
+#define TP_RING_AVAIL_INT_ring_avail_3_shift                                         (4)
+#define TP_RING_AVAIL_INT_ring_avail_3_mask                                          (0x00000010)
+#define TP_RING_AVAIL_INT_ring_avail_3(data)                                         (0x00000010&((data)<<4))
+#define TP_RING_AVAIL_INT_ring_avail_3_src(data)                                     ((0x00000010&(data))>>4)
+#define TP_RING_AVAIL_INT_get_ring_avail_3(data)                                     ((0x00000010&(data))>>4)
+#define TP_RING_AVAIL_INT_ring_avail_2_shift                                         (3)
+#define TP_RING_AVAIL_INT_ring_avail_2_mask                                          (0x00000008)
+#define TP_RING_AVAIL_INT_ring_avail_2(data)                                         (0x00000008&((data)<<3))
+#define TP_RING_AVAIL_INT_ring_avail_2_src(data)                                     ((0x00000008&(data))>>3)
+#define TP_RING_AVAIL_INT_get_ring_avail_2(data)                                     ((0x00000008&(data))>>3)
+#define TP_RING_AVAIL_INT_ring_avail_1_shift                                         (2)
+#define TP_RING_AVAIL_INT_ring_avail_1_mask                                          (0x00000004)
+#define TP_RING_AVAIL_INT_ring_avail_1(data)                                         (0x00000004&((data)<<2))
+#define TP_RING_AVAIL_INT_ring_avail_1_src(data)                                     ((0x00000004&(data))>>2)
+#define TP_RING_AVAIL_INT_get_ring_avail_1(data)                                     ((0x00000004&(data))>>2)
+#define TP_RING_AVAIL_INT_ring_avail_0_shift                                         (1)
+#define TP_RING_AVAIL_INT_ring_avail_0_mask                                          (0x00000002)
+#define TP_RING_AVAIL_INT_ring_avail_0(data)                                         (0x00000002&((data)<<1))
+#define TP_RING_AVAIL_INT_ring_avail_0_src(data)                                     ((0x00000002&(data))>>1)
+#define TP_RING_AVAIL_INT_get_ring_avail_0(data)                                     ((0x00000002&(data))>>1)
+#define TP_RING_AVAIL_INT_write_data_shift                                           (0)
+#define TP_RING_AVAIL_INT_write_data_mask                                            (0x00000001)
+#define TP_RING_AVAIL_INT_write_data(data)                                           (0x00000001&((data)<<0))
+#define TP_RING_AVAIL_INT_write_data_src(data)                                       ((0x00000001&(data))>>0)
+#define TP_RING_AVAIL_INT_get_write_data(data)                                       ((0x00000001&(data))>>0)
+
+
+#define TP_RING_FULL_INT_0                                                           0x18014610
+#define TP_RING_FULL_INT_1                                                           0x18014614
+#define TP_RING_FULL_INT_0_reg_addr                                                  "0xB8014610"
+#define TP_RING_FULL_INT_1_reg_addr                                                  "0xB8014614"
+#define TP_RING_FULL_INT_0_reg                                                       0xB8014610
+#define TP_RING_FULL_INT_1_reg                                                       0xB8014614
+#define set_TP_RING_FULL_INT_0_reg(data)   (*((volatile unsigned int*) TP_RING_FULL_INT_0_reg)=data)
+#define set_TP_RING_FULL_INT_1_reg(data)   (*((volatile unsigned int*) TP_RING_FULL_INT_1_reg)=data)
+#define get_TP_RING_FULL_INT_0_reg   (*((volatile unsigned int*) TP_RING_FULL_INT_0_reg))
+#define get_TP_RING_FULL_INT_1_reg   (*((volatile unsigned int*) TP_RING_FULL_INT_1_reg))
+#define TP_RING_FULL_INT_0_inst_adr                                                  "0x0084"
+#define TP_RING_FULL_INT_1_inst_adr                                                  "0x0085"
+#define TP_RING_FULL_INT_0_inst                                                      0x0084
+#define TP_RING_FULL_INT_1_inst                                                      0x0085
+#define TP_RING_FULL_INT_ring_full_15_shift                                          (16)
+#define TP_RING_FULL_INT_ring_full_15_mask                                           (0x00010000)
+#define TP_RING_FULL_INT_ring_full_15(data)                                          (0x00010000&((data)<<16))
+#define TP_RING_FULL_INT_ring_full_15_src(data)                                      ((0x00010000&(data))>>16)
+#define TP_RING_FULL_INT_get_ring_full_15(data)                                      ((0x00010000&(data))>>16)
+#define TP_RING_FULL_INT_ring_full_14_shift                                          (15)
+#define TP_RING_FULL_INT_ring_full_14_mask                                           (0x00008000)
+#define TP_RING_FULL_INT_ring_full_14(data)                                          (0x00008000&((data)<<15))
+#define TP_RING_FULL_INT_ring_full_14_src(data)                                      ((0x00008000&(data))>>15)
+#define TP_RING_FULL_INT_get_ring_full_14(data)                                      ((0x00008000&(data))>>15)
+#define TP_RING_FULL_INT_ring_full_13_shift                                          (14)
+#define TP_RING_FULL_INT_ring_full_13_mask                                           (0x00004000)
+#define TP_RING_FULL_INT_ring_full_13(data)                                          (0x00004000&((data)<<14))
+#define TP_RING_FULL_INT_ring_full_13_src(data)                                      ((0x00004000&(data))>>14)
+#define TP_RING_FULL_INT_get_ring_full_13(data)                                      ((0x00004000&(data))>>14)
+#define TP_RING_FULL_INT_ring_full_12_shift                                          (13)
+#define TP_RING_FULL_INT_ring_full_12_mask                                           (0x00002000)
+#define TP_RING_FULL_INT_ring_full_12(data)                                          (0x00002000&((data)<<13))
+#define TP_RING_FULL_INT_ring_full_12_src(data)                                      ((0x00002000&(data))>>13)
+#define TP_RING_FULL_INT_get_ring_full_12(data)                                      ((0x00002000&(data))>>13)
+#define TP_RING_FULL_INT_ring_full_11_shift                                          (12)
+#define TP_RING_FULL_INT_ring_full_11_mask                                           (0x00001000)
+#define TP_RING_FULL_INT_ring_full_11(data)                                          (0x00001000&((data)<<12))
+#define TP_RING_FULL_INT_ring_full_11_src(data)                                      ((0x00001000&(data))>>12)
+#define TP_RING_FULL_INT_get_ring_full_11(data)                                      ((0x00001000&(data))>>12)
+#define TP_RING_FULL_INT_ring_full_10_shift                                          (11)
+#define TP_RING_FULL_INT_ring_full_10_mask                                           (0x00000800)
+#define TP_RING_FULL_INT_ring_full_10(data)                                          (0x00000800&((data)<<11))
+#define TP_RING_FULL_INT_ring_full_10_src(data)                                      ((0x00000800&(data))>>11)
+#define TP_RING_FULL_INT_get_ring_full_10(data)                                      ((0x00000800&(data))>>11)
+#define TP_RING_FULL_INT_ring_full_9_shift                                           (10)
+#define TP_RING_FULL_INT_ring_full_9_mask                                            (0x00000400)
+#define TP_RING_FULL_INT_ring_full_9(data)                                           (0x00000400&((data)<<10))
+#define TP_RING_FULL_INT_ring_full_9_src(data)                                       ((0x00000400&(data))>>10)
+#define TP_RING_FULL_INT_get_ring_full_9(data)                                       ((0x00000400&(data))>>10)
+#define TP_RING_FULL_INT_ring_full_8_shift                                           (9)
+#define TP_RING_FULL_INT_ring_full_8_mask                                            (0x00000200)
+#define TP_RING_FULL_INT_ring_full_8(data)                                           (0x00000200&((data)<<9))
+#define TP_RING_FULL_INT_ring_full_8_src(data)                                       ((0x00000200&(data))>>9)
+#define TP_RING_FULL_INT_get_ring_full_8(data)                                       ((0x00000200&(data))>>9)
+#define TP_RING_FULL_INT_ring_full_7_shift                                           (8)
+#define TP_RING_FULL_INT_ring_full_7_mask                                            (0x00000100)
+#define TP_RING_FULL_INT_ring_full_7(data)                                           (0x00000100&((data)<<8))
+#define TP_RING_FULL_INT_ring_full_7_src(data)                                       ((0x00000100&(data))>>8)
+#define TP_RING_FULL_INT_get_ring_full_7(data)                                       ((0x00000100&(data))>>8)
+#define TP_RING_FULL_INT_ring_full_6_shift                                           (7)
+#define TP_RING_FULL_INT_ring_full_6_mask                                            (0x00000080)
+#define TP_RING_FULL_INT_ring_full_6(data)                                           (0x00000080&((data)<<7))
+#define TP_RING_FULL_INT_ring_full_6_src(data)                                       ((0x00000080&(data))>>7)
+#define TP_RING_FULL_INT_get_ring_full_6(data)                                       ((0x00000080&(data))>>7)
+#define TP_RING_FULL_INT_ring_full_5_shift                                           (6)
+#define TP_RING_FULL_INT_ring_full_5_mask                                            (0x00000040)
+#define TP_RING_FULL_INT_ring_full_5(data)                                           (0x00000040&((data)<<6))
+#define TP_RING_FULL_INT_ring_full_5_src(data)                                       ((0x00000040&(data))>>6)
+#define TP_RING_FULL_INT_get_ring_full_5(data)                                       ((0x00000040&(data))>>6)
+#define TP_RING_FULL_INT_ring_full_4_shift                                           (5)
+#define TP_RING_FULL_INT_ring_full_4_mask                                            (0x00000020)
+#define TP_RING_FULL_INT_ring_full_4(data)                                           (0x00000020&((data)<<5))
+#define TP_RING_FULL_INT_ring_full_4_src(data)                                       ((0x00000020&(data))>>5)
+#define TP_RING_FULL_INT_get_ring_full_4(data)                                       ((0x00000020&(data))>>5)
+#define TP_RING_FULL_INT_ring_full_3_shift                                           (4)
+#define TP_RING_FULL_INT_ring_full_3_mask                                            (0x00000010)
+#define TP_RING_FULL_INT_ring_full_3(data)                                           (0x00000010&((data)<<4))
+#define TP_RING_FULL_INT_ring_full_3_src(data)                                       ((0x00000010&(data))>>4)
+#define TP_RING_FULL_INT_get_ring_full_3(data)                                       ((0x00000010&(data))>>4)
+#define TP_RING_FULL_INT_ring_full_2_shift                                           (3)
+#define TP_RING_FULL_INT_ring_full_2_mask                                            (0x00000008)
+#define TP_RING_FULL_INT_ring_full_2(data)                                           (0x00000008&((data)<<3))
+#define TP_RING_FULL_INT_ring_full_2_src(data)                                       ((0x00000008&(data))>>3)
+#define TP_RING_FULL_INT_get_ring_full_2(data)                                       ((0x00000008&(data))>>3)
+#define TP_RING_FULL_INT_ring_full_1_shift                                           (2)
+#define TP_RING_FULL_INT_ring_full_1_mask                                            (0x00000004)
+#define TP_RING_FULL_INT_ring_full_1(data)                                           (0x00000004&((data)<<2))
+#define TP_RING_FULL_INT_ring_full_1_src(data)                                       ((0x00000004&(data))>>2)
+#define TP_RING_FULL_INT_get_ring_full_1(data)                                       ((0x00000004&(data))>>2)
+#define TP_RING_FULL_INT_ring_full_0_shift                                           (1)
+#define TP_RING_FULL_INT_ring_full_0_mask                                            (0x00000002)
+#define TP_RING_FULL_INT_ring_full_0(data)                                           (0x00000002&((data)<<1))
+#define TP_RING_FULL_INT_ring_full_0_src(data)                                       ((0x00000002&(data))>>1)
+#define TP_RING_FULL_INT_get_ring_full_0(data)                                       ((0x00000002&(data))>>1)
+#define TP_RING_FULL_INT_write_data_shift                                            (0)
+#define TP_RING_FULL_INT_write_data_mask                                             (0x00000001)
+#define TP_RING_FULL_INT_write_data(data)                                            (0x00000001&((data)<<0))
+#define TP_RING_FULL_INT_write_data_src(data)                                        ((0x00000001&(data))>>0)
+#define TP_RING_FULL_INT_get_write_data(data)                                        ((0x00000001&(data))>>0)
+
+
+#define TP_RING_AVAIL_INT_EN_0                                                       0x18014620
+#define TP_RING_AVAIL_INT_EN_1                                                       0x18014624
+#define TP_RING_AVAIL_INT_EN_0_reg_addr                                              "0xB8014620"
+#define TP_RING_AVAIL_INT_EN_1_reg_addr                                              "0xB8014624"
+#define TP_RING_AVAIL_INT_EN_0_reg                                                   0xB8014620
+#define TP_RING_AVAIL_INT_EN_1_reg                                                   0xB8014624
+#define set_TP_RING_AVAIL_INT_EN_0_reg(data)   (*((volatile unsigned int*) TP_RING_AVAIL_INT_EN_0_reg)=data)
+#define set_TP_RING_AVAIL_INT_EN_1_reg(data)   (*((volatile unsigned int*) TP_RING_AVAIL_INT_EN_1_reg)=data)
+#define get_TP_RING_AVAIL_INT_EN_0_reg   (*((volatile unsigned int*) TP_RING_AVAIL_INT_EN_0_reg))
+#define get_TP_RING_AVAIL_INT_EN_1_reg   (*((volatile unsigned int*) TP_RING_AVAIL_INT_EN_1_reg))
+#define TP_RING_AVAIL_INT_EN_0_inst_adr                                              "0x0088"
+#define TP_RING_AVAIL_INT_EN_1_inst_adr                                              "0x0089"
+#define TP_RING_AVAIL_INT_EN_0_inst                                                  0x0088
+#define TP_RING_AVAIL_INT_EN_1_inst                                                  0x0089
+#define TP_RING_AVAIL_INT_EN_ring_avail_15_en_shift                                  (16)
+#define TP_RING_AVAIL_INT_EN_ring_avail_15_en_mask                                   (0x00010000)
+#define TP_RING_AVAIL_INT_EN_ring_avail_15_en(data)                                  (0x00010000&((data)<<16))
+#define TP_RING_AVAIL_INT_EN_ring_avail_15_en_src(data)                              ((0x00010000&(data))>>16)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_15_en(data)                              ((0x00010000&(data))>>16)
+#define TP_RING_AVAIL_INT_EN_ring_avail_14_en_shift                                  (15)
+#define TP_RING_AVAIL_INT_EN_ring_avail_14_en_mask                                   (0x00008000)
+#define TP_RING_AVAIL_INT_EN_ring_avail_14_en(data)                                  (0x00008000&((data)<<15))
+#define TP_RING_AVAIL_INT_EN_ring_avail_14_en_src(data)                              ((0x00008000&(data))>>15)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_14_en(data)                              ((0x00008000&(data))>>15)
+#define TP_RING_AVAIL_INT_EN_ring_avail_13_en_shift                                  (14)
+#define TP_RING_AVAIL_INT_EN_ring_avail_13_en_mask                                   (0x00004000)
+#define TP_RING_AVAIL_INT_EN_ring_avail_13_en(data)                                  (0x00004000&((data)<<14))
+#define TP_RING_AVAIL_INT_EN_ring_avail_13_en_src(data)                              ((0x00004000&(data))>>14)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_13_en(data)                              ((0x00004000&(data))>>14)
+#define TP_RING_AVAIL_INT_EN_ring_avail_12_en_shift                                  (13)
+#define TP_RING_AVAIL_INT_EN_ring_avail_12_en_mask                                   (0x00002000)
+#define TP_RING_AVAIL_INT_EN_ring_avail_12_en(data)                                  (0x00002000&((data)<<13))
+#define TP_RING_AVAIL_INT_EN_ring_avail_12_en_src(data)                              ((0x00002000&(data))>>13)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_12_en(data)                              ((0x00002000&(data))>>13)
+#define TP_RING_AVAIL_INT_EN_ring_avail_11_en_shift                                  (12)
+#define TP_RING_AVAIL_INT_EN_ring_avail_11_en_mask                                   (0x00001000)
+#define TP_RING_AVAIL_INT_EN_ring_avail_11_en(data)                                  (0x00001000&((data)<<12))
+#define TP_RING_AVAIL_INT_EN_ring_avail_11_en_src(data)                              ((0x00001000&(data))>>12)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_11_en(data)                              ((0x00001000&(data))>>12)
+#define TP_RING_AVAIL_INT_EN_ring_avail_10_en_shift                                  (11)
+#define TP_RING_AVAIL_INT_EN_ring_avail_10_en_mask                                   (0x00000800)
+#define TP_RING_AVAIL_INT_EN_ring_avail_10_en(data)                                  (0x00000800&((data)<<11))
+#define TP_RING_AVAIL_INT_EN_ring_avail_10_en_src(data)                              ((0x00000800&(data))>>11)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_10_en(data)                              ((0x00000800&(data))>>11)
+#define TP_RING_AVAIL_INT_EN_ring_avail_9_en_shift                                   (10)
+#define TP_RING_AVAIL_INT_EN_ring_avail_9_en_mask                                    (0x00000400)
+#define TP_RING_AVAIL_INT_EN_ring_avail_9_en(data)                                   (0x00000400&((data)<<10))
+#define TP_RING_AVAIL_INT_EN_ring_avail_9_en_src(data)                               ((0x00000400&(data))>>10)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_9_en(data)                               ((0x00000400&(data))>>10)
+#define TP_RING_AVAIL_INT_EN_ring_avail_8_en_shift                                   (9)
+#define TP_RING_AVAIL_INT_EN_ring_avail_8_en_mask                                    (0x00000200)
+#define TP_RING_AVAIL_INT_EN_ring_avail_8_en(data)                                   (0x00000200&((data)<<9))
+#define TP_RING_AVAIL_INT_EN_ring_avail_8_en_src(data)                               ((0x00000200&(data))>>9)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_8_en(data)                               ((0x00000200&(data))>>9)
+#define TP_RING_AVAIL_INT_EN_ring_avail_7_en_shift                                   (8)
+#define TP_RING_AVAIL_INT_EN_ring_avail_7_en_mask                                    (0x00000100)
+#define TP_RING_AVAIL_INT_EN_ring_avail_7_en(data)                                   (0x00000100&((data)<<8))
+#define TP_RING_AVAIL_INT_EN_ring_avail_7_en_src(data)                               ((0x00000100&(data))>>8)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_7_en(data)                               ((0x00000100&(data))>>8)
+#define TP_RING_AVAIL_INT_EN_ring_avail_6_en_shift                                   (7)
+#define TP_RING_AVAIL_INT_EN_ring_avail_6_en_mask                                    (0x00000080)
+#define TP_RING_AVAIL_INT_EN_ring_avail_6_en(data)                                   (0x00000080&((data)<<7))
+#define TP_RING_AVAIL_INT_EN_ring_avail_6_en_src(data)                               ((0x00000080&(data))>>7)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_6_en(data)                               ((0x00000080&(data))>>7)
+#define TP_RING_AVAIL_INT_EN_ring_avail_5_en_shift                                   (6)
+#define TP_RING_AVAIL_INT_EN_ring_avail_5_en_mask                                    (0x00000040)
+#define TP_RING_AVAIL_INT_EN_ring_avail_5_en(data)                                   (0x00000040&((data)<<6))
+#define TP_RING_AVAIL_INT_EN_ring_avail_5_en_src(data)                               ((0x00000040&(data))>>6)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_5_en(data)                               ((0x00000040&(data))>>6)
+#define TP_RING_AVAIL_INT_EN_ring_avail_4_en_shift                                   (5)
+#define TP_RING_AVAIL_INT_EN_ring_avail_4_en_mask                                    (0x00000020)
+#define TP_RING_AVAIL_INT_EN_ring_avail_4_en(data)                                   (0x00000020&((data)<<5))
+#define TP_RING_AVAIL_INT_EN_ring_avail_4_en_src(data)                               ((0x00000020&(data))>>5)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_4_en(data)                               ((0x00000020&(data))>>5)
+#define TP_RING_AVAIL_INT_EN_ring_avail_3_en_shift                                   (4)
+#define TP_RING_AVAIL_INT_EN_ring_avail_3_en_mask                                    (0x00000010)
+#define TP_RING_AVAIL_INT_EN_ring_avail_3_en(data)                                   (0x00000010&((data)<<4))
+#define TP_RING_AVAIL_INT_EN_ring_avail_3_en_src(data)                               ((0x00000010&(data))>>4)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_3_en(data)                               ((0x00000010&(data))>>4)
+#define TP_RING_AVAIL_INT_EN_ring_avail_2_en_shift                                   (3)
+#define TP_RING_AVAIL_INT_EN_ring_avail_2_en_mask                                    (0x00000008)
+#define TP_RING_AVAIL_INT_EN_ring_avail_2_en(data)                                   (0x00000008&((data)<<3))
+#define TP_RING_AVAIL_INT_EN_ring_avail_2_en_src(data)                               ((0x00000008&(data))>>3)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_2_en(data)                               ((0x00000008&(data))>>3)
+#define TP_RING_AVAIL_INT_EN_ring_avail_1_en_shift                                   (2)
+#define TP_RING_AVAIL_INT_EN_ring_avail_1_en_mask                                    (0x00000004)
+#define TP_RING_AVAIL_INT_EN_ring_avail_1_en(data)                                   (0x00000004&((data)<<2))
+#define TP_RING_AVAIL_INT_EN_ring_avail_1_en_src(data)                               ((0x00000004&(data))>>2)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_1_en(data)                               ((0x00000004&(data))>>2)
+#define TP_RING_AVAIL_INT_EN_ring_avail_0_en_shift                                   (1)
+#define TP_RING_AVAIL_INT_EN_ring_avail_0_en_mask                                    (0x00000002)
+#define TP_RING_AVAIL_INT_EN_ring_avail_0_en(data)                                   (0x00000002&((data)<<1))
+#define TP_RING_AVAIL_INT_EN_ring_avail_0_en_src(data)                               ((0x00000002&(data))>>1)
+#define TP_RING_AVAIL_INT_EN_get_ring_avail_0_en(data)                               ((0x00000002&(data))>>1)
+#define TP_RING_AVAIL_INT_EN_write_data_shift                                        (0)
+#define TP_RING_AVAIL_INT_EN_write_data_mask                                         (0x00000001)
+#define TP_RING_AVAIL_INT_EN_write_data(data)                                        (0x00000001&((data)<<0))
+#define TP_RING_AVAIL_INT_EN_write_data_src(data)                                    ((0x00000001&(data))>>0)
+#define TP_RING_AVAIL_INT_EN_get_write_data(data)                                    ((0x00000001&(data))>>0)
+
+
+#define TP_RING_FULL_INT_EN_0                                                        0x18014630
+#define TP_RING_FULL_INT_EN_1                                                        0x18014634
+#define TP_RING_FULL_INT_EN_0_reg_addr                                               "0xB8014630"
+#define TP_RING_FULL_INT_EN_1_reg_addr                                               "0xB8014634"
+#define TP_RING_FULL_INT_EN_0_reg                                                    0xB8014630
+#define TP_RING_FULL_INT_EN_1_reg                                                    0xB8014634
+#define set_TP_RING_FULL_INT_EN_0_reg(data)   (*((volatile unsigned int*) TP_RING_FULL_INT_EN_0_reg)=data)
+#define set_TP_RING_FULL_INT_EN_1_reg(data)   (*((volatile unsigned int*) TP_RING_FULL_INT_EN_1_reg)=data)
+#define get_TP_RING_FULL_INT_EN_0_reg   (*((volatile unsigned int*) TP_RING_FULL_INT_EN_0_reg))
+#define get_TP_RING_FULL_INT_EN_1_reg   (*((volatile unsigned int*) TP_RING_FULL_INT_EN_1_reg))
+#define TP_RING_FULL_INT_EN_0_inst_adr                                               "0x008C"
+#define TP_RING_FULL_INT_EN_1_inst_adr                                               "0x008D"
+#define TP_RING_FULL_INT_EN_0_inst                                                   0x008C
+#define TP_RING_FULL_INT_EN_1_inst                                                   0x008D
+#define TP_RING_FULL_INT_EN_ring_full_15_en_shift                                    (16)
+#define TP_RING_FULL_INT_EN_ring_full_15_en_mask                                     (0x00010000)
+#define TP_RING_FULL_INT_EN_ring_full_15_en(data)                                    (0x00010000&((data)<<16))
+#define TP_RING_FULL_INT_EN_ring_full_15_en_src(data)                                ((0x00010000&(data))>>16)
+#define TP_RING_FULL_INT_EN_get_ring_full_15_en(data)                                ((0x00010000&(data))>>16)
+#define TP_RING_FULL_INT_EN_ring_full_14_en_shift                                    (15)
+#define TP_RING_FULL_INT_EN_ring_full_14_en_mask                                     (0x00008000)
+#define TP_RING_FULL_INT_EN_ring_full_14_en(data)                                    (0x00008000&((data)<<15))
+#define TP_RING_FULL_INT_EN_ring_full_14_en_src(data)                                ((0x00008000&(data))>>15)
+#define TP_RING_FULL_INT_EN_get_ring_full_14_en(data)                                ((0x00008000&(data))>>15)
+#define TP_RING_FULL_INT_EN_ring_full_13_en_shift                                    (14)
+#define TP_RING_FULL_INT_EN_ring_full_13_en_mask                                     (0x00004000)
+#define TP_RING_FULL_INT_EN_ring_full_13_en(data)                                    (0x00004000&((data)<<14))
+#define TP_RING_FULL_INT_EN_ring_full_13_en_src(data)                                ((0x00004000&(data))>>14)
+#define TP_RING_FULL_INT_EN_get_ring_full_13_en(data)                                ((0x00004000&(data))>>14)
+#define TP_RING_FULL_INT_EN_ring_full_12_en_shift                                    (13)
+#define TP_RING_FULL_INT_EN_ring_full_12_en_mask                                     (0x00002000)
+#define TP_RING_FULL_INT_EN_ring_full_12_en(data)                                    (0x00002000&((data)<<13))
+#define TP_RING_FULL_INT_EN_ring_full_12_en_src(data)                                ((0x00002000&(data))>>13)
+#define TP_RING_FULL_INT_EN_get_ring_full_12_en(data)                                ((0x00002000&(data))>>13)
+#define TP_RING_FULL_INT_EN_ring_full_11_en_shift                                    (12)
+#define TP_RING_FULL_INT_EN_ring_full_11_en_mask                                     (0x00001000)
+#define TP_RING_FULL_INT_EN_ring_full_11_en(data)                                    (0x00001000&((data)<<12))
+#define TP_RING_FULL_INT_EN_ring_full_11_en_src(data)                                ((0x00001000&(data))>>12)
+#define TP_RING_FULL_INT_EN_get_ring_full_11_en(data)                                ((0x00001000&(data))>>12)
+#define TP_RING_FULL_INT_EN_ring_full_10_en_shift                                    (11)
+#define TP_RING_FULL_INT_EN_ring_full_10_en_mask                                     (0x00000800)
+#define TP_RING_FULL_INT_EN_ring_full_10_en(data)                                    (0x00000800&((data)<<11))
+#define TP_RING_FULL_INT_EN_ring_full_10_en_src(data)                                ((0x00000800&(data))>>11)
+#define TP_RING_FULL_INT_EN_get_ring_full_10_en(data)                                ((0x00000800&(data))>>11)
+#define TP_RING_FULL_INT_EN_ring_full_9_en_shift                                     (10)
+#define TP_RING_FULL_INT_EN_ring_full_9_en_mask                                      (0x00000400)
+#define TP_RING_FULL_INT_EN_ring_full_9_en(data)                                     (0x00000400&((data)<<10))
+#define TP_RING_FULL_INT_EN_ring_full_9_en_src(data)                                 ((0x00000400&(data))>>10)
+#define TP_RING_FULL_INT_EN_get_ring_full_9_en(data)                                 ((0x00000400&(data))>>10)
+#define TP_RING_FULL_INT_EN_ring_full_8_en_shift                                     (9)
+#define TP_RING_FULL_INT_EN_ring_full_8_en_mask                                      (0x00000200)
+#define TP_RING_FULL_INT_EN_ring_full_8_en(data)                                     (0x00000200&((data)<<9))
+#define TP_RING_FULL_INT_EN_ring_full_8_en_src(data)                                 ((0x00000200&(data))>>9)
+#define TP_RING_FULL_INT_EN_get_ring_full_8_en(data)                                 ((0x00000200&(data))>>9)
+#define TP_RING_FULL_INT_EN_ring_full_7_en_shift                                     (8)
+#define TP_RING_FULL_INT_EN_ring_full_7_en_mask                                      (0x00000100)
+#define TP_RING_FULL_INT_EN_ring_full_7_en(data)                                     (0x00000100&((data)<<8))
+#define TP_RING_FULL_INT_EN_ring_full_7_en_src(data)                                 ((0x00000100&(data))>>8)
+#define TP_RING_FULL_INT_EN_get_ring_full_7_en(data)                                 ((0x00000100&(data))>>8)
+#define TP_RING_FULL_INT_EN_ring_full_6_en_shift                                     (7)
+#define TP_RING_FULL_INT_EN_ring_full_6_en_mask                                      (0x00000080)
+#define TP_RING_FULL_INT_EN_ring_full_6_en(data)                                     (0x00000080&((data)<<7))
+#define TP_RING_FULL_INT_EN_ring_full_6_en_src(data)                                 ((0x00000080&(data))>>7)
+#define TP_RING_FULL_INT_EN_get_ring_full_6_en(data)                                 ((0x00000080&(data))>>7)
+#define TP_RING_FULL_INT_EN_ring_full_5_en_shift                                     (6)
+#define TP_RING_FULL_INT_EN_ring_full_5_en_mask                                      (0x00000040)
+#define TP_RING_FULL_INT_EN_ring_full_5_en(data)                                     (0x00000040&((data)<<6))
+#define TP_RING_FULL_INT_EN_ring_full_5_en_src(data)                                 ((0x00000040&(data))>>6)
+#define TP_RING_FULL_INT_EN_get_ring_full_5_en(data)                                 ((0x00000040&(data))>>6)
+#define TP_RING_FULL_INT_EN_ring_full_4_en_shift                                     (5)
+#define TP_RING_FULL_INT_EN_ring_full_4_en_mask                                      (0x00000020)
+#define TP_RING_FULL_INT_EN_ring_full_4_en(data)                                     (0x00000020&((data)<<5))
+#define TP_RING_FULL_INT_EN_ring_full_4_en_src(data)                                 ((0x00000020&(data))>>5)
+#define TP_RING_FULL_INT_EN_get_ring_full_4_en(data)                                 ((0x00000020&(data))>>5)
+#define TP_RING_FULL_INT_EN_ring_full_3_en_shift                                     (4)
+#define TP_RING_FULL_INT_EN_ring_full_3_en_mask                                      (0x00000010)
+#define TP_RING_FULL_INT_EN_ring_full_3_en(data)                                     (0x00000010&((data)<<4))
+#define TP_RING_FULL_INT_EN_ring_full_3_en_src(data)                                 ((0x00000010&(data))>>4)
+#define TP_RING_FULL_INT_EN_get_ring_full_3_en(data)                                 ((0x00000010&(data))>>4)
+#define TP_RING_FULL_INT_EN_ring_full_2_en_shift                                     (3)
+#define TP_RING_FULL_INT_EN_ring_full_2_en_mask                                      (0x00000008)
+#define TP_RING_FULL_INT_EN_ring_full_2_en(data)                                     (0x00000008&((data)<<3))
+#define TP_RING_FULL_INT_EN_ring_full_2_en_src(data)                                 ((0x00000008&(data))>>3)
+#define TP_RING_FULL_INT_EN_get_ring_full_2_en(data)                                 ((0x00000008&(data))>>3)
+#define TP_RING_FULL_INT_EN_ring_full_1_en_shift                                     (2)
+#define TP_RING_FULL_INT_EN_ring_full_1_en_mask                                      (0x00000004)
+#define TP_RING_FULL_INT_EN_ring_full_1_en(data)                                     (0x00000004&((data)<<2))
+#define TP_RING_FULL_INT_EN_ring_full_1_en_src(data)                                 ((0x00000004&(data))>>2)
+#define TP_RING_FULL_INT_EN_get_ring_full_1_en(data)                                 ((0x00000004&(data))>>2)
+#define TP_RING_FULL_INT_EN_ring_full_0_en_shift                                     (1)
+#define TP_RING_FULL_INT_EN_ring_full_0_en_mask                                      (0x00000002)
+#define TP_RING_FULL_INT_EN_ring_full_0_en(data)                                     (0x00000002&((data)<<1))
+#define TP_RING_FULL_INT_EN_ring_full_0_en_src(data)                                 ((0x00000002&(data))>>1)
+#define TP_RING_FULL_INT_EN_get_ring_full_0_en(data)                                 ((0x00000002&(data))>>1)
+#define TP_RING_FULL_INT_EN_write_data_shift                                         (0)
+#define TP_RING_FULL_INT_EN_write_data_mask                                          (0x00000001)
+#define TP_RING_FULL_INT_EN_write_data(data)                                         (0x00000001&((data)<<0))
+#define TP_RING_FULL_INT_EN_write_data_src(data)                                     ((0x00000001&(data))>>0)
+#define TP_RING_FULL_INT_EN_get_write_data(data)                                     ((0x00000001&(data))>>0)
+
+
+#define TP_M2M_RING_LIMIT                                                            0x18014640
+#define TP_M2M_RING_LIMIT_reg_addr                                                   "0xB8014640"
+#define TP_M2M_RING_LIMIT_reg                                                        0xB8014640
+#define set_TP_M2M_RING_LIMIT_reg(data)   (*((volatile unsigned int*) TP_M2M_RING_LIMIT_reg)=data)
+#define get_TP_M2M_RING_LIMIT_reg   (*((volatile unsigned int*) TP_M2M_RING_LIMIT_reg))
+#define TP_M2M_RING_LIMIT_inst_adr                                                   "0x0090"
+#define TP_M2M_RING_LIMIT_inst                                                       0x0090
+#define TP_M2M_RING_LIMIT_ring_limit_shift                                           (3)
+#define TP_M2M_RING_LIMIT_ring_limit_mask                                            (0x3FFFFFF8)
+#define TP_M2M_RING_LIMIT_ring_limit(data)                                           (0x3FFFFFF8&((data)<<3))
+#define TP_M2M_RING_LIMIT_ring_limit_src(data)                                       ((0x3FFFFFF8&(data))>>3)
+#define TP_M2M_RING_LIMIT_get_ring_limit(data)                                       ((0x3FFFFFF8&(data))>>3)
+
+
+#define TP_M2M_RING_BASE                                                             0x18014644
+#define TP_M2M_RING_BASE_reg_addr                                                    "0xB8014644"
+#define TP_M2M_RING_BASE_reg                                                         0xB8014644
+#define set_TP_M2M_RING_BASE_reg(data)   (*((volatile unsigned int*) TP_M2M_RING_BASE_reg)=data)
+#define get_TP_M2M_RING_BASE_reg   (*((volatile unsigned int*) TP_M2M_RING_BASE_reg))
+#define TP_M2M_RING_BASE_inst_adr                                                    "0x0091"
+#define TP_M2M_RING_BASE_inst                                                        0x0091
+#define TP_M2M_RING_BASE_ring_base_shift                                             (3)
+#define TP_M2M_RING_BASE_ring_base_mask                                              (0x3FFFFFF8)
+#define TP_M2M_RING_BASE_ring_base(data)                                             (0x3FFFFFF8&((data)<<3))
+#define TP_M2M_RING_BASE_ring_base_src(data)                                         ((0x3FFFFFF8&(data))>>3)
+#define TP_M2M_RING_BASE_get_ring_base(data)                                         ((0x3FFFFFF8&(data))>>3)
+
+
+#define TP_M2M_RING_RP                                                               0x18014648
+#define TP_M2M_RING_RP_reg_addr                                                      "0xB8014648"
+#define TP_M2M_RING_RP_reg                                                           0xB8014648
+#define set_TP_M2M_RING_RP_reg(data)   (*((volatile unsigned int*) TP_M2M_RING_RP_reg)=data)
+#define get_TP_M2M_RING_RP_reg   (*((volatile unsigned int*) TP_M2M_RING_RP_reg))
+#define TP_M2M_RING_RP_inst_adr                                                      "0x0092"
+#define TP_M2M_RING_RP_inst                                                          0x0092
+#define TP_M2M_RING_RP_ring_rp_shift                                                 (0)
+#define TP_M2M_RING_RP_ring_rp_mask                                                  (0x3FFFFFFF)
+#define TP_M2M_RING_RP_ring_rp(data)                                                 (0x3FFFFFFF&((data)<<0))
+#define TP_M2M_RING_RP_ring_rp_src(data)                                             ((0x3FFFFFFF&(data))>>0)
+#define TP_M2M_RING_RP_get_ring_rp(data)                                             ((0x3FFFFFFF&(data))>>0)
+
+
+#define TP_M2M_RING_WP                                                               0x1801464c
+#define TP_M2M_RING_WP_reg_addr                                                      "0xB801464C"
+#define TP_M2M_RING_WP_reg                                                           0xB801464C
+#define set_TP_M2M_RING_WP_reg(data)   (*((volatile unsigned int*) TP_M2M_RING_WP_reg)=data)
+#define get_TP_M2M_RING_WP_reg   (*((volatile unsigned int*) TP_M2M_RING_WP_reg))
+#define TP_M2M_RING_WP_inst_adr                                                      "0x0093"
+#define TP_M2M_RING_WP_inst                                                          0x0093
+#define TP_M2M_RING_WP_ring_wp_shift                                                 (0)
+#define TP_M2M_RING_WP_ring_wp_mask                                                  (0x3FFFFFFF)
+#define TP_M2M_RING_WP_ring_wp(data)                                                 (0x3FFFFFFF&((data)<<0))
+#define TP_M2M_RING_WP_ring_wp_src(data)                                             ((0x3FFFFFFF&(data))>>0)
+#define TP_M2M_RING_WP_get_ring_wp(data)                                             ((0x3FFFFFFF&(data))>>0)
+
+
+#define TP_M2M_RING_CTRL                                                             0x18014650
+#define TP_M2M_RING_CTRL_reg_addr                                                    "0xB8014650"
+#define TP_M2M_RING_CTRL_reg                                                         0xB8014650
+#define set_TP_M2M_RING_CTRL_reg(data)   (*((volatile unsigned int*) TP_M2M_RING_CTRL_reg)=data)
+#define get_TP_M2M_RING_CTRL_reg   (*((volatile unsigned int*) TP_M2M_RING_CTRL_reg))
+#define TP_M2M_RING_CTRL_inst_adr                                                    "0x0094"
+#define TP_M2M_RING_CTRL_inst                                                        0x0094
+#define TP_M2M_RING_CTRL_empty_shift                                                 (4)
+#define TP_M2M_RING_CTRL_empty_mask                                                  (0x00000010)
+#define TP_M2M_RING_CTRL_empty(data)                                                 (0x00000010&((data)<<4))
+#define TP_M2M_RING_CTRL_empty_src(data)                                             ((0x00000010&(data))>>4)
+#define TP_M2M_RING_CTRL_get_empty(data)                                             ((0x00000010&(data))>>4)
+#define TP_M2M_RING_CTRL_empty_en_shift                                              (3)
+#define TP_M2M_RING_CTRL_empty_en_mask                                               (0x00000008)
+#define TP_M2M_RING_CTRL_empty_en(data)                                              (0x00000008&((data)<<3))
+#define TP_M2M_RING_CTRL_empty_en_src(data)                                          ((0x00000008&(data))>>3)
+#define TP_M2M_RING_CTRL_get_empty_en(data)                                          ((0x00000008&(data))>>3)
+#define TP_M2M_RING_CTRL_stop_shift                                                  (2)
+#define TP_M2M_RING_CTRL_stop_mask                                                   (0x00000004)
+#define TP_M2M_RING_CTRL_stop(data)                                                  (0x00000004&((data)<<2))
+#define TP_M2M_RING_CTRL_stop_src(data)                                              ((0x00000004&(data))>>2)
+#define TP_M2M_RING_CTRL_get_stop(data)                                              ((0x00000004&(data))>>2)
+#define TP_M2M_RING_CTRL_go_shift                                                    (1)
+#define TP_M2M_RING_CTRL_go_mask                                                     (0x00000002)
+#define TP_M2M_RING_CTRL_go(data)                                                    (0x00000002&((data)<<1))
+#define TP_M2M_RING_CTRL_go_src(data)                                                ((0x00000002&(data))>>1)
+#define TP_M2M_RING_CTRL_get_go(data)                                                ((0x00000002&(data))>>1)
+#define TP_M2M_RING_CTRL_write_data_shift                                            (0)
+#define TP_M2M_RING_CTRL_write_data_mask                                             (0x00000001)
+#define TP_M2M_RING_CTRL_write_data(data)                                            (0x00000001&((data)<<0))
+#define TP_M2M_RING_CTRL_write_data_src(data)                                        ((0x00000001&(data))>>0)
+#define TP_M2M_RING_CTRL_get_write_data(data)                                        ((0x00000001&(data))>>0)
+
+
+#define TP_SYNC_POS                                                                  0x18014658
+#define TP_SYNC_POS_reg_addr                                                         "0xB8014658"
+#define TP_SYNC_POS_reg                                                              0xB8014658
+#define set_TP_SYNC_POS_reg(data)   (*((volatile unsigned int*) TP_SYNC_POS_reg)=data)
+#define get_TP_SYNC_POS_reg   (*((volatile unsigned int*) TP_SYNC_POS_reg))
+#define TP_SYNC_POS_inst_adr                                                         "0x0096"
+#define TP_SYNC_POS_inst                                                             0x0096
+#define TP_SYNC_POS_sync_pos_shift                                                   (0)
+#define TP_SYNC_POS_sync_pos_mask                                                    (0x3FFFFFFF)
+#define TP_SYNC_POS_sync_pos(data)                                                   (0x3FFFFFFF&((data)<<0))
+#define TP_SYNC_POS_sync_pos_src(data)                                               ((0x3FFFFFFF&(data))>>0)
+#define TP_SYNC_POS_get_sync_pos(data)                                               ((0x3FFFFFFF&(data))>>0)
+
+
+#define TP_DMY_A                                                                     0x1801465C
+#define TP_DMY_A_reg_addr                                                            "0xB801465C"
+#define TP_DMY_A_reg                                                                 0xB801465C
+#define set_TP_DMY_A_reg(data)   (*((volatile unsigned int*) TP_DMY_A_reg)=data)
+#define get_TP_DMY_A_reg   (*((volatile unsigned int*) TP_DMY_A_reg))
+#define TP_DMY_A_inst_adr                                                            "0x0097"
+#define TP_DMY_A_inst                                                                0x0097
+#define TP_DMY_A_dmy_shift                                                           (0)
+#define TP_DMY_A_dmy_mask                                                            (0xFFFFFFFF)
+#define TP_DMY_A_dmy(data)                                                           (0xFFFFFFFF&((data)<<0))
+#define TP_DMY_A_dmy_src(data)                                                       ((0xFFFFFFFF&(data))>>0)
+#define TP_DMY_A_get_dmy(data)                                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define TP_DMY_B                                                                     0x18014660
+#define TP_DMY_B_reg_addr                                                            "0xB8014660"
+#define TP_DMY_B_reg                                                                 0xB8014660
+#define set_TP_DMY_B_reg(data)   (*((volatile unsigned int*) TP_DMY_B_reg)=data)
+#define get_TP_DMY_B_reg   (*((volatile unsigned int*) TP_DMY_B_reg))
+#define TP_DMY_B_inst_adr                                                            "0x0098"
+#define TP_DMY_B_inst                                                                0x0098
+#define TP_DMY_B_dmy_shift                                                           (0)
+#define TP_DMY_B_dmy_mask                                                            (0xFFFFFFFF)
+#define TP_DMY_B_dmy(data)                                                           (0xFFFFFFFF&((data)<<0))
+#define TP_DMY_B_dmy_src(data)                                                       ((0xFFFFFFFF&(data))>>0)
+#define TP_DMY_B_get_dmy(data)                                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define BIST_RM                                                                      0x18014670
+#define BIST_RM_reg_addr                                                             "0xB8014670"
+#define BIST_RM_reg                                                                  0xB8014670
+#define set_BIST_RM_reg(data)   (*((volatile unsigned int*) BIST_RM_reg)=data)
+#define get_BIST_RM_reg   (*((volatile unsigned int*) BIST_RM_reg))
+#define BIST_RM_inst_adr                                                             "0x009C"
+#define BIST_RM_inst                                                                 0x009C
+#define BIST_RM_dvse_shift                                                           (4)
+#define BIST_RM_dvse_mask                                                            (0x00000010)
+#define BIST_RM_dvse(data)                                                           (0x00000010&((data)<<4))
+#define BIST_RM_dvse_src(data)                                                       ((0x00000010&(data))>>4)
+#define BIST_RM_get_dvse(data)                                                       ((0x00000010&(data))>>4)
+#define BIST_RM_dvs_3_shift                                                          (3)
+#define BIST_RM_dvs_3_mask                                                           (0x00000008)
+#define BIST_RM_dvs_3(data)                                                          (0x00000008&((data)<<3))
+#define BIST_RM_dvs_3_src(data)                                                      ((0x00000008&(data))>>3)
+#define BIST_RM_get_dvs_3(data)                                                      ((0x00000008&(data))>>3)
+#define BIST_RM_dvs_2_shift                                                          (2)
+#define BIST_RM_dvs_2_mask                                                           (0x00000004)
+#define BIST_RM_dvs_2(data)                                                          (0x00000004&((data)<<2))
+#define BIST_RM_dvs_2_src(data)                                                      ((0x00000004&(data))>>2)
+#define BIST_RM_get_dvs_2(data)                                                      ((0x00000004&(data))>>2)
+#define BIST_RM_dvs_1_shift                                                          (1)
+#define BIST_RM_dvs_1_mask                                                           (0x00000002)
+#define BIST_RM_dvs_1(data)                                                          (0x00000002&((data)<<1))
+#define BIST_RM_dvs_1_src(data)                                                      ((0x00000002&(data))>>1)
+#define BIST_RM_get_dvs_1(data)                                                      ((0x00000002&(data))>>1)
+#define BIST_RM_dvs_0_shift                                                          (0)
+#define BIST_RM_dvs_0_mask                                                           (0x00000001)
+#define BIST_RM_dvs_0(data)                                                          (0x00000001&((data)<<0))
+#define BIST_RM_dvs_0_src(data)                                                      ((0x00000001&(data))>>0)
+#define BIST_RM_get_dvs_0(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define BIST_ST                                                                      0x18014674
+#define BIST_ST_reg_addr                                                             "0xB8014674"
+#define BIST_ST_reg                                                                  0xB8014674
+#define set_BIST_ST_reg(data)   (*((volatile unsigned int*) BIST_ST_reg)=data)
+#define get_BIST_ST_reg   (*((volatile unsigned int*) BIST_ST_reg))
+#define BIST_ST_inst_adr                                                             "0x009D"
+#define BIST_ST_inst                                                                 0x009D
+#define BIST_ST_bist_fail5_shift                                                     (6)
+#define BIST_ST_bist_fail5_mask                                                      (0x00000040)
+#define BIST_ST_bist_fail5(data)                                                     (0x00000040&((data)<<6))
+#define BIST_ST_bist_fail5_src(data)                                                 ((0x00000040&(data))>>6)
+#define BIST_ST_get_bist_fail5(data)                                                 ((0x00000040&(data))>>6)
+#define BIST_ST_bist_fail4_shift                                                     (5)
+#define BIST_ST_bist_fail4_mask                                                      (0x00000020)
+#define BIST_ST_bist_fail4(data)                                                     (0x00000020&((data)<<5))
+#define BIST_ST_bist_fail4_src(data)                                                 ((0x00000020&(data))>>5)
+#define BIST_ST_get_bist_fail4(data)                                                 ((0x00000020&(data))>>5)
+#define BIST_ST_bist_fail3_shift                                                     (4)
+#define BIST_ST_bist_fail3_mask                                                      (0x00000010)
+#define BIST_ST_bist_fail3(data)                                                     (0x00000010&((data)<<4))
+#define BIST_ST_bist_fail3_src(data)                                                 ((0x00000010&(data))>>4)
+#define BIST_ST_get_bist_fail3(data)                                                 ((0x00000010&(data))>>4)
+#define BIST_ST_bist_fail2_shift                                                     (3)
+#define BIST_ST_bist_fail2_mask                                                      (0x00000008)
+#define BIST_ST_bist_fail2(data)                                                     (0x00000008&((data)<<3))
+#define BIST_ST_bist_fail2_src(data)                                                 ((0x00000008&(data))>>3)
+#define BIST_ST_get_bist_fail2(data)                                                 ((0x00000008&(data))>>3)
+#define BIST_ST_bist_fail1_shift                                                     (2)
+#define BIST_ST_bist_fail1_mask                                                      (0x00000004)
+#define BIST_ST_bist_fail1(data)                                                     (0x00000004&((data)<<2))
+#define BIST_ST_bist_fail1_src(data)                                                 ((0x00000004&(data))>>2)
+#define BIST_ST_get_bist_fail1(data)                                                 ((0x00000004&(data))>>2)
+#define BIST_ST_bist_fail0_shift                                                     (1)
+#define BIST_ST_bist_fail0_mask                                                      (0x00000002)
+#define BIST_ST_bist_fail0(data)                                                     (0x00000002&((data)<<1))
+#define BIST_ST_bist_fail0_src(data)                                                 ((0x00000002&(data))>>1)
+#define BIST_ST_get_bist_fail0(data)                                                 ((0x00000002&(data))>>1)
+#define BIST_ST_bist_done_shift                                                      (0)
+#define BIST_ST_bist_done_mask                                                       (0x00000001)
+#define BIST_ST_bist_done(data)                                                      (0x00000001&((data)<<0))
+#define BIST_ST_bist_done_src(data)                                                  ((0x00000001&(data))>>0)
+#define BIST_ST_get_bist_done(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define DRF_ST                                                                       0x18014678
+#define DRF_ST_reg_addr                                                              "0xB8014678"
+#define DRF_ST_reg                                                                   0xB8014678
+#define set_DRF_ST_reg(data)   (*((volatile unsigned int*) DRF_ST_reg)=data)
+#define get_DRF_ST_reg   (*((volatile unsigned int*) DRF_ST_reg))
+#define DRF_ST_inst_adr                                                              "0x009E"
+#define DRF_ST_inst                                                                  0x009E
+#define DRF_ST_drf_start_pause_shift                                                 (16)
+#define DRF_ST_drf_start_pause_mask                                                  (0x00010000)
+#define DRF_ST_drf_start_pause(data)                                                 (0x00010000&((data)<<16))
+#define DRF_ST_drf_start_pause_src(data)                                             ((0x00010000&(data))>>16)
+#define DRF_ST_get_drf_start_pause(data)                                             ((0x00010000&(data))>>16)
+#define DRF_ST_drf_fail5_shift                                                       (6)
+#define DRF_ST_drf_fail5_mask                                                        (0x00000040)
+#define DRF_ST_drf_fail5(data)                                                       (0x00000040&((data)<<6))
+#define DRF_ST_drf_fail5_src(data)                                                   ((0x00000040&(data))>>6)
+#define DRF_ST_get_drf_fail5(data)                                                   ((0x00000040&(data))>>6)
+#define DRF_ST_drf_fail4_shift                                                       (5)
+#define DRF_ST_drf_fail4_mask                                                        (0x00000020)
+#define DRF_ST_drf_fail4(data)                                                       (0x00000020&((data)<<5))
+#define DRF_ST_drf_fail4_src(data)                                                   ((0x00000020&(data))>>5)
+#define DRF_ST_get_drf_fail4(data)                                                   ((0x00000020&(data))>>5)
+#define DRF_ST_drf_fail3_shift                                                       (4)
+#define DRF_ST_drf_fail3_mask                                                        (0x00000010)
+#define DRF_ST_drf_fail3(data)                                                       (0x00000010&((data)<<4))
+#define DRF_ST_drf_fail3_src(data)                                                   ((0x00000010&(data))>>4)
+#define DRF_ST_get_drf_fail3(data)                                                   ((0x00000010&(data))>>4)
+#define DRF_ST_drf_fail2_shift                                                       (3)
+#define DRF_ST_drf_fail2_mask                                                        (0x00000008)
+#define DRF_ST_drf_fail2(data)                                                       (0x00000008&((data)<<3))
+#define DRF_ST_drf_fail2_src(data)                                                   ((0x00000008&(data))>>3)
+#define DRF_ST_get_drf_fail2(data)                                                   ((0x00000008&(data))>>3)
+#define DRF_ST_drf_fail1_shift                                                       (2)
+#define DRF_ST_drf_fail1_mask                                                        (0x00000004)
+#define DRF_ST_drf_fail1(data)                                                       (0x00000004&((data)<<2))
+#define DRF_ST_drf_fail1_src(data)                                                   ((0x00000004&(data))>>2)
+#define DRF_ST_get_drf_fail1(data)                                                   ((0x00000004&(data))>>2)
+#define DRF_ST_drf_fail0_shift                                                       (1)
+#define DRF_ST_drf_fail0_mask                                                        (0x00000002)
+#define DRF_ST_drf_fail0(data)                                                       (0x00000002&((data)<<1))
+#define DRF_ST_drf_fail0_src(data)                                                   ((0x00000002&(data))>>1)
+#define DRF_ST_get_drf_fail0(data)                                                   ((0x00000002&(data))>>1)
+#define DRF_ST_drf_done_shift                                                        (0)
+#define DRF_ST_drf_done_mask                                                         (0x00000001)
+#define DRF_ST_drf_done(data)                                                        (0x00000001&((data)<<0))
+#define DRF_ST_drf_done_src(data)                                                    ((0x00000001&(data))>>0)
+#define DRF_ST_get_drf_done(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define DRF_ST                                                                       0x1801467c
+#define DRF_ST_reg_addr                                                              "0xB801467C"
+#define DRF_ST_reg                                                                   0xB801467C
+#define set_DRF_ST_reg(data)   (*((volatile unsigned int*) DRF_ST_reg)=data)
+#define get_DRF_ST_reg   (*((volatile unsigned int*) DRF_ST_reg))
+#define DRF_ST_inst_adr                                                              "0x009F"
+#define DRF_ST_inst                                                                  0x009F
+#define DRF_ST_drf_test_resume_shift                                                 (2)
+#define DRF_ST_drf_test_resume_mask                                                  (0x00000004)
+#define DRF_ST_drf_test_resume(data)                                                 (0x00000004&((data)<<2))
+#define DRF_ST_drf_test_resume_src(data)                                             ((0x00000004&(data))>>2)
+#define DRF_ST_get_drf_test_resume(data)                                             ((0x00000004&(data))>>2)
+#define DRF_ST_drf_bist_en_shift                                                     (1)
+#define DRF_ST_drf_bist_en_mask                                                      (0x00000002)
+#define DRF_ST_drf_bist_en(data)                                                     (0x00000002&((data)<<1))
+#define DRF_ST_drf_bist_en_src(data)                                                 ((0x00000002&(data))>>1)
+#define DRF_ST_get_drf_bist_en(data)                                                 ((0x00000002&(data))>>1)
+#define DRF_ST_bist_en_shift                                                         (0)
+#define DRF_ST_bist_en_mask                                                          (0x00000001)
+#define DRF_ST_bist_en(data)                                                         (0x00000001&((data)<<0))
+#define DRF_ST_bist_en_src(data)                                                     ((0x00000001&(data))>>0)
+#define DRF_ST_get_bist_en(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define TP_DEBUG                                                                     0x18014690
+#define TP_DEBUG_reg_addr                                                            "0xB8014690"
+#define TP_DEBUG_reg                                                                 0xB8014690
+#define set_TP_DEBUG_reg(data)   (*((volatile unsigned int*) TP_DEBUG_reg)=data)
+#define get_TP_DEBUG_reg   (*((volatile unsigned int*) TP_DEBUG_reg))
+#define TP_DEBUG_inst_adr                                                            "0x00A4"
+#define TP_DEBUG_inst                                                                0x00A4
+#define TP_DEBUG_dv_verify_only_shift                                                (7)
+#define TP_DEBUG_dv_verify_only_mask                                                 (0x00000080)
+#define TP_DEBUG_dv_verify_only(data)                                                (0x00000080&((data)<<7))
+#define TP_DEBUG_dv_verify_only_src(data)                                            ((0x00000080&(data))>>7)
+#define TP_DEBUG_get_dv_verify_only(data)                                            ((0x00000080&(data))>>7)
+#define TP_DEBUG_tp_sram_sleep_off_shift                                             (6)
+#define TP_DEBUG_tp_sram_sleep_off_mask                                              (0x00000040)
+#define TP_DEBUG_tp_sram_sleep_off(data)                                             (0x00000040&((data)<<6))
+#define TP_DEBUG_tp_sram_sleep_off_src(data)                                         ((0x00000040&(data))>>6)
+#define TP_DEBUG_get_tp_sram_sleep_off(data)                                         ((0x00000040&(data))>>6)
+#define TP_DEBUG_tp_pkt_sram_addr_rst_sel_shift                                      (5)
+#define TP_DEBUG_tp_pkt_sram_addr_rst_sel_mask                                       (0x00000020)
+#define TP_DEBUG_tp_pkt_sram_addr_rst_sel(data)                                      (0x00000020&((data)<<5))
+#define TP_DEBUG_tp_pkt_sram_addr_rst_sel_src(data)                                  ((0x00000020&(data))>>5)
+#define TP_DEBUG_get_tp_pkt_sram_addr_rst_sel(data)                                  ((0x00000020&(data))>>5)
+#define TP_DEBUG_dbg_mode_shift                                                      (0)
+#define TP_DEBUG_dbg_mode_mask                                                       (0x0000001F)
+#define TP_DEBUG_dbg_mode(data)                                                      (0x0000001F&((data)<<0))
+#define TP_DEBUG_dbg_mode_src(data)                                                  ((0x0000001F&(data))>>0)
+#define TP_DEBUG_get_dbg_mode(data)                                                  ((0x0000001F&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/tvd_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/tvd_reg.h
new file mode 100644
index 00000000..b6344e8
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/tvd_reg.h
@@ -0,0 +1,3286 @@
+// This file is generated using the spec version 0.3.3, firmware template version 1.39and DVR_Parser_0.4
+#ifndef _TVD_REG_H_INCLUDED_
+#define _TVD_REG_H_INCLUDED_
+
+//#define  _TVD_USE_STRUCT
+#ifdef _TVD_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    reserved_0:15;
+    unsigned int    write_enable7:1;
+    unsigned int    hv_delay:1;
+    unsigned int    write_enable6:1;
+    unsigned int    hpixel:2;
+    unsigned int    write_enable5:1;
+    unsigned int    vline_625:1;
+    unsigned int    write_enable4:1;
+    unsigned int    colour_mode:3;
+    unsigned int    write_enable3:1;
+    unsigned int    yc_src:1;
+    unsigned int    write_enable2:1;
+    unsigned int    cv_inv:1;
+    unsigned int    write_enable1:1;
+    unsigned int    cv_src:1;
+}tvd_VDO_CTRL1;
+
+typedef struct
+{
+    unsigned int    reserved_0:11;
+    unsigned int    write_enable9:1;
+    unsigned int    luma_notch_bw:2;
+    unsigned int    write_enable8:1;
+    unsigned int    chroma_bw_lo:2;
+    unsigned int    write_enable7:1;
+    unsigned int    chroma_burst5or10:1;
+    unsigned int    write_enable6:1;
+    unsigned int    ped:1;
+    unsigned int    write_enable5:1;
+    unsigned int    hagc_field:1;
+    unsigned int    write_enable4:1;
+    unsigned int    mv_hagc:1;
+    unsigned int    write_enable3:1;
+    unsigned int    dc_clamp_mode:2;
+    unsigned int    write_enable2:1;
+    unsigned int    cagc_en:1;
+    unsigned int    write_enable1:1;
+    unsigned int    hagc_en:1;
+}tvd_VDO_CTRL2;
+
+typedef struct
+{
+    unsigned int    reserved_0:26;
+    unsigned int    write_enable2:1;
+    unsigned int    colour_trap:1;
+    unsigned int    write_enable1:1;
+    unsigned int    adaptive_mode:3;
+}tvd_YC_SEP_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    write_enable6:1;
+    unsigned int    hagc:8;
+    unsigned int    write_enable5:1;
+    unsigned int    noise_thresh:8;
+    unsigned int    write_enable4:1;
+    unsigned int    adc_updn_swap:1;
+    unsigned int    write_enable3:1;
+    unsigned int    adc_input_swap:1;
+    unsigned int    write_enable2:1;
+    unsigned int    adc_cbcr_pump_swap:1;
+    unsigned int    write_enable1:1;
+    unsigned int    adc_gate_thresh:5;
+}tvd_HOR_ACQ;
+
+typedef struct
+{
+    unsigned int    reserved_0:22;
+    unsigned int    write_enable3:1;
+    unsigned int    cbcr_swap:1;
+    unsigned int    write_enable2:1;
+    unsigned int    blue_mode:2;
+    unsigned int    write_enable1:1;
+    unsigned int    yc_delay:4;
+}tvd_OUT_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:14;
+    unsigned int    write_enable2:1;
+    unsigned int    contrast:8;
+    unsigned int    write_enable1:1;
+    unsigned int    brightness:8;
+}tvd_LUMA_ADJUST;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    write_enable3:1;
+    unsigned int    saturation:8;
+    unsigned int    write_enable2:1;
+    unsigned int    hue:8;
+    unsigned int    write_enable1:1;
+    unsigned int    cagc:8;
+}tvd_CHROMA_ADJUST;
+
+typedef struct
+{
+    unsigned int    reserved_0:10;
+    unsigned int    write_enable7:1;
+    unsigned int    user_ckill_mode:2;
+    unsigned int    write_enable6:1;
+    unsigned int    vbi_ckill:1;
+    unsigned int    write_enable5:1;
+    unsigned int    hlock_ckill:1;
+    unsigned int    write_enable4:1;
+    unsigned int    chroma_kill:4;
+    unsigned int    write_enable3:1;
+    unsigned int    secam_test_mode:1;
+    unsigned int    write_enable2:1;
+    unsigned int    fixed_burstgate:1;
+    unsigned int    write_enable1:1;
+    unsigned int    cautopos:5;
+}tvd_CHROMA_KILL_AUTOPOS;
+
+typedef struct
+{
+    unsigned int    reserved_0:11;
+    unsigned int    write_enable6:1;
+    unsigned int    agc_peak_nominal:7;
+    unsigned int    write_enable5:1;
+    unsigned int    agc_gate_vsync_coarse:1;
+    unsigned int    write_enable4:1;
+    unsigned int    agc_gate_vsync_stip:1;
+    unsigned int    write_enable3:1;
+    unsigned int    agc_gate_kill_mode:2;
+    unsigned int    write_enable2:1;
+    unsigned int    agc_peak_en:1;
+    unsigned int    write_enable1:1;
+    unsigned int    agc_peak_cntl:3;
+}tvd_AGC_PEAKGATE;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    write_enable3:1;
+    unsigned int    agc_gate_start:11;
+    unsigned int    write_enable2:1;
+    unsigned int    agc_gate_width:7;
+    unsigned int    write_enable1:1;
+    unsigned int    agc_bp_delay:8;
+}tvd_AGC_GATE;
+
+typedef struct
+{
+    unsigned int    reserved_0:9;
+    unsigned int    write_enable7:1;
+    unsigned int    locked_count_noisy_max:4;
+    unsigned int    write_enable6:1;
+    unsigned int    locked_count_clean_max:4;
+    unsigned int    write_enable5:1;
+    unsigned int    hlock_vsync_mode:2;
+    unsigned int    write_enable4:1;
+    unsigned int    hstate_fixed:1;
+    unsigned int    write_enable3:1;
+    unsigned int    disable_hfine:1;
+    unsigned int    write_enable2:1;
+    unsigned int    hstate_unlocked:1;
+    unsigned int    write_enable1:1;
+    unsigned int    hstate_max:3;
+}tvd_HPLL_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:1;
+    unsigned int    cdto_fixed:1;
+    unsigned int    cdto_inc:30;
+}tvd_CHROMA_DTO;
+
+typedef struct
+{
+    unsigned int    reserved_0:1;
+    unsigned int    hdto_fixed:1;
+    unsigned int    hdto_inc:30;
+}tvd_HSYNC_DTO;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    hsync_rising:8;
+    unsigned int    hsync_phase_offset:8;
+}tvd_HSYNC_OCCUR;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    hsync_gate_start:8;
+    unsigned int    hsync_gate_end:8;
+}tvd_HSYNC_GATE_TIME;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    hsync_tip_start:8;
+    unsigned int    hsync_tip_end:8;
+}tvd_HSYNC_TIP_TIME;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    hsync_rising_start:8;
+    unsigned int    hsync_rising_end:8;
+}tvd_HSYNC_RISING_TIME;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    backporch_start:8;
+    unsigned int    backporch_end:8;
+}tvd_BACKPROCH_TIME;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    hblank_start:8;
+    unsigned int    hblank_end:8;
+}tvd_HBLANK_TIME;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    burst_gate_start:8;
+    unsigned int    burst_gate_end:8;
+}tvd_BURST_GATE_TIME;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    hactive_start:8;
+    unsigned int    hactive_width:8;
+}tvd_HACTIVE_TIME;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    vactive_start:8;
+    unsigned int    vactive_height:8;
+}tvd_VACTIVE_TIME;
+
+typedef struct
+{
+    unsigned int    reserved_0:18;
+    unsigned int    vsync_h_min:7;
+    unsigned int    vsync_h_max:7;
+}tvd_VSYNC_H_LOCKOUT;
+
+typedef struct
+{
+    unsigned int    reserved_0:17;
+    unsigned int    vsync_clamp_mode:2;
+    unsigned int    vsync_agc_min:7;
+    unsigned int    vsync_agc_max:6;
+}tvd_VSYNC_AGC_LOCKOUT;
+
+typedef struct
+{
+    unsigned int    reserved_0:17;
+    unsigned int    vlock_wide_range:1;
+    unsigned int    vsync_vbi_min:7;
+    unsigned int    vsync_vbi_max:7;
+}tvd_VSYNC_VBI_LOCKOUT;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    write_enable8:1;
+    unsigned int    vsync_cntl:2;
+    unsigned int    write_enable7:1;
+    unsigned int    vsync_threshold:6;
+    unsigned int    write_enable6:1;
+    unsigned int    field_polarity:1;
+    unsigned int    write_enable5:1;
+    unsigned int    flip_field:1;
+    unsigned int    write_enable4:1;
+    unsigned int    veven_delayed:1;
+    unsigned int    write_enable3:1;
+    unsigned int    vodd_delayed:1;
+    unsigned int    write_enable2:1;
+    unsigned int    field_detect_mode:2;
+    unsigned int    write_enable1:1;
+    unsigned int    vloop_tc:2;
+}tvd_VSYNC_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:14;
+    unsigned int    mv_colourstripes:3;
+    unsigned int    mv_vbi_detected:1;
+    unsigned int    chomalock:1;
+    unsigned int    vlock:1;
+    unsigned int    hlock:1;
+    unsigned int    no_signal:1;
+    unsigned int    palm_flag:1;
+    unsigned int    proscan_detected:1;
+    unsigned int    vcr_rew:1;
+    unsigned int    vcr_ff:1;
+    unsigned int    vcr_trick:1;
+    unsigned int    vcr:1;
+    unsigned int    noisy:1;
+    unsigned int    625lines_detected:1;
+    unsigned int    secam_detected:1;
+    unsigned int    pal_detected:1;
+}tvd_STATUS1;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    status_hdto_inc:30;
+}tvd_HDTO_STATUS;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    status_cdto_inc:30;
+}tvd_CDTO_STATUS;
+
+typedef struct
+{
+    unsigned int    reserved_0:10;
+    unsigned int    status_cmag:8;
+    unsigned int    status_cgain:14;
+}tvd_CHROMA_STATUS;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    status_agc_dgain:8;
+    unsigned int    status_cordiq_freq:8;
+    unsigned int    status_noise:8;
+}tvd_STATUS2;
+
+typedef struct
+{
+    unsigned int    reserved_0:23;
+    unsigned int    write_enable3:1;
+    unsigned int    peak_range:2;
+    unsigned int    write_enable2:1;
+    unsigned int    peak_gain:3;
+    unsigned int    write_enable1:1;
+    unsigned int    peak_en:1;
+}tvd_PEAKING;
+
+typedef struct
+{
+    unsigned int    reserved_0:23;
+    unsigned int    write_enable4:1;
+    unsigned int    pal_perr:1;
+    unsigned int    write_enable3:1;
+    unsigned int    pal_perr_auto_en:1;
+    unsigned int    write_enable2:1;
+    unsigned int    comb_wide_band:1;
+    unsigned int    write_enable1:1;
+    unsigned int    palsw_level:2;
+}tvd_COMB_CONFIG;
+
+typedef struct
+{
+    unsigned int    reserved_0:21;
+    unsigned int    write_enable3:1;
+    unsigned int    lose_chromalock_count:4;
+    unsigned int    write_enable2:1;
+    unsigned int    lose_chromalock_level:3;
+    unsigned int    write_enable1:1;
+    unsigned int    lose_chromalock_ckill:1;
+}tvd_CHROMA_LOCK;
+
+typedef struct
+{
+    unsigned int    noise_ntsc_c:8;
+    unsigned int    noise_pal_c:8;
+    unsigned int    noise_phase_c:8;
+    unsigned int    noise_phase_y:8;
+}tvd_COMB_THD;
+
+typedef struct
+{
+    unsigned int    reserved_0:28;
+    unsigned int    cstate:3;
+    unsigned int    fixed_cstat:1;
+}tvd_CHROMA_LPFILTER;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    hresampler_2up:1;
+}tvd_HRESAMPLE;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    write_enable5:1;
+    unsigned int    cpump_adjust_delay:6;
+    unsigned int    write_enable4:1;
+    unsigned int    cpump_adjust_polarity:1;
+    unsigned int    write_enable3:1;
+    unsigned int    cpump_delay_en:1;
+    unsigned int    write_enable2:1;
+    unsigned int    cpump_adjust:8;
+    unsigned int    write_enable1:1;
+    unsigned int    cpump_delay:8;
+}tvd_CHG_PUMP_DLY;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    write_enable11:1;
+    unsigned int    debug_mode:1;
+    unsigned int    write_enable10:1;
+    unsigned int    debug_enable:1;
+    unsigned int    write_enable9:1;
+    unsigned int    memory_size:2;
+    unsigned int    write_enable8:1;
+    unsigned int    ntscpal_select:1;
+    unsigned int    write_enable7:1;
+    unsigned int    yc_separation_control:3;
+    unsigned int    write_enable6:1;
+    unsigned int    chroma_vlpf_en:1;
+    unsigned int    write_enable5:1;
+    unsigned int    bpf_bw_sel:3;
+    unsigned int    write_enable4:1;
+    unsigned int    vcr3d2d:1;
+    unsigned int    write_enable3:1;
+    unsigned int    noisy3d2d:1;
+    unsigned int    write_enable2:1;
+    unsigned int    field_toggle_en:1;
+    unsigned int    write_enable1:1;
+    unsigned int    debug_tree_monitor:4;
+}tvd_3DYC_SEP_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    md_y_lo_diff_thresh1:4;
+    unsigned int    check_mdt_en:1;
+    unsigned int    md_y_lo_diff_thresh2:6;
+    unsigned int    md_mesh_det_thresh1:4;
+    unsigned int    md_mesh_c_large_thresh:4;
+    unsigned int    md_frame_close_chk_enable:1;
+    unsigned int    md_mesh_det_thresh2:4;
+    unsigned int    md_mesh_det_cnt_thresh:3;
+}tvd_3DTHD1;
+
+typedef struct
+{
+    unsigned int    reserved_0:13;
+    unsigned int    md_chk_mesh_thresh:2;
+    unsigned int    md_y_lo_line_diff_thresh:4;
+    unsigned int    md_chk_three_line_c_thresh1:3;
+    unsigned int    md_c_detect_thresh:4;
+    unsigned int    md_orig_diff_thresh:6;
+}tvd_3DTHD2;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    md_line_close_thresh:4;
+    unsigned int    md_c_near_2d_3d_thresh:4;
+    unsigned int    md_chk_three_line_c_thresh2:3;
+    unsigned int    md_line_compare_thresh1:5;
+    unsigned int    md_chk_angle_c_thresh:3;
+    unsigned int    md_line_compare_thresh2:5;
+}tvd_3DTHD3;
+
+typedef struct
+{
+    unsigned int    reserved_0:9;
+    unsigned int    md_c_3d_large_thresh1:4;
+    unsigned int    md_c_3d_large_thresh2:4;
+    unsigned int    md_cross_c_suppress_enable:1;
+    unsigned int    md_c_edge_thresh1:7;
+    unsigned int    md_c_edge_thresh2:7;
+}tvd_3DTHD4;
+
+typedef struct
+{
+    unsigned int    reserved_0:13;
+    unsigned int    write_enable6:1;
+    unsigned int    cc_hddet_st:8;
+    unsigned int    write_enable5:1;
+    unsigned int    adap_slvl_en:1;
+    unsigned int    write_enable4:1;
+    unsigned int    vbi_st_err_ignored:1;
+    unsigned int    write_enable3:1;
+    unsigned int    vbi_en:1;
+    unsigned int    write_enable2:1;
+    unsigned int    cgms_bot_en:1;
+    unsigned int    write_enable1:1;
+    unsigned int    cgms_top_en:1;
+}tvd_SLICER_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    vps_vbil16o:4;
+    unsigned int    vps_vbil16e:4;
+}tvd_VPS_LINE_16;
+
+typedef struct
+{
+    unsigned int    vbio05:4;
+    unsigned int    vbie05:4;
+    unsigned int    vbio06:4;
+    unsigned int    vbie06:4;
+    unsigned int    vbio07:4;
+    unsigned int    vbie07:4;
+    unsigned int    vbio08:4;
+    unsigned int    vbie08:4;
+}tvd_VBI_LINE0;
+
+typedef struct
+{
+    unsigned int    vbio09:4;
+    unsigned int    vbie09:4;
+    unsigned int    vbio10:4;
+    unsigned int    vbie10:4;
+    unsigned int    vbio11:4;
+    unsigned int    vbie11:4;
+    unsigned int    vbio12:4;
+    unsigned int    vbie12:4;
+}tvd_VBI_LINE1;
+
+typedef struct
+{
+    unsigned int    vbio13:4;
+    unsigned int    vbie13:4;
+    unsigned int    vbio14:4;
+    unsigned int    vbie14:4;
+    unsigned int    vbio15:4;
+    unsigned int    vbie15:4;
+    unsigned int    vbio16:4;
+    unsigned int    vbie16:4;
+}tvd_VBI_LINE2;
+
+typedef struct
+{
+    unsigned int    vbio17:4;
+    unsigned int    vbie17:4;
+    unsigned int    vbio18:4;
+    unsigned int    vbie18:4;
+    unsigned int    vbio19:4;
+    unsigned int    vbie19:4;
+    unsigned int    vbio20:4;
+    unsigned int    vbie20:4;
+}tvd_VBI_LINE3;
+
+typedef struct
+{
+    unsigned int    vbio21:4;
+    unsigned int    vbie21:4;
+    unsigned int    vbio22:4;
+    unsigned int    vbie22:4;
+    unsigned int    vbio23:4;
+    unsigned int    vbie23:4;
+    unsigned int    vbio_other:4;
+    unsigned int    vbie_other:4;
+}tvd_VBI_LINE4;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    cgms_line_even:8;
+    unsigned int    cgms_line_odd:8;
+}tvd_CGMS_LINE;
+
+typedef struct
+{
+    unsigned int    reserved_0:15;
+    unsigned int    data_hlvl:8;
+    unsigned int    gain:3;
+    unsigned int    igain:3;
+    unsigned int    pgain:3;
+}tvd_VBI_GAIN_LVL;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    cc_dto:16;
+}tvd_CC_DTO;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    tt_dto:16;
+}tvd_TT_DTO;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    wss_dto:16;
+}tvd_WSS_DTO;
+
+typedef struct
+{
+    unsigned int    cc_frame_start:8;
+    unsigned int    tt_frame_start:8;
+    unsigned int    tt_start_code:8;
+    unsigned int    wss_frame_start:8;
+}tvd_VBI_FRAME_START;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    cc_start:8;
+    unsigned int    tt_start:8;
+    unsigned int    wss_start:8;
+}tvd_VBI_START;
+
+typedef struct
+{
+    unsigned int    vbi_cal_dc_st:4;
+    unsigned int    vbi_cal_dc_end:4;
+    unsigned int    wss_cal_dc_st:4;
+    unsigned int    wss_cal_dc_end:4;
+    unsigned int    vps_cal_dc_st:4;
+    unsigned int    vps_cal_dc_end:4;
+    unsigned int    cgms_cal_dc_st:4;
+    unsigned int    cgms_cal_dc_end:4;
+}tvd_VBI_CAL_DC_DETECT;
+
+typedef struct
+{
+    unsigned int    reserved_0:23;
+    unsigned int    adap_cgms_dc_en:1;
+    unsigned int    cgms_dc:8;
+}tvd_CGMS_DC;
+
+typedef struct
+{
+    unsigned int    reserved_0:29;
+    unsigned int    cc_rdy:1;
+    unsigned int    wss_rdy:1;
+    unsigned int    cgms_rdy:1;
+}tvd_VBI_RDY;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    cc_data:16;
+}tvd_CC_DATA;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    wss_data:16;
+}tvd_WSS_DATA;
+
+typedef struct
+{
+    unsigned int    reserved_0:12;
+    unsigned int    cgms_data:20;
+}tvd_CGMS_DATA;
+
+typedef struct
+{
+    unsigned int    reserved_0:6;
+    unsigned int    apowl:1;
+    unsigned int    bpowl:1;
+    unsigned int    cpowl:1;
+    unsigned int    dpowl:1;
+    unsigned int    asgainl:3;
+    unsigned int    bsgainl:3;
+    unsigned int    csgainl:3;
+    unsigned int    dsgainl:3;
+    unsigned int    calibratel:4;
+    unsigned int    scavl:3;
+    unsigned int    svoutl:3;
+}tvd_VIDEO_ADC_DIGITAL_CTRL0;
+
+typedef struct
+{
+    unsigned int    ainswl:2;
+    unsigned int    binswl:2;
+    unsigned int    cinswl:2;
+    unsigned int    dinswl:2;
+    unsigned int    aclamp_spl:6;
+    unsigned int    bclamp_spl:6;
+    unsigned int    cclamp_spl:6;
+    unsigned int    dclamp_spl:6;
+}tvd_VIDEO_ADC_DIGITAL_CTRL1;
+
+typedef struct
+{
+    unsigned int    asvicml:3;
+    unsigned int    bsvicml:3;
+    unsigned int    csvicml:3;
+    unsigned int    dsvicml:3;
+    unsigned int    sib_bufl:4;
+    unsigned int    sib_mdacl:4;
+    unsigned int    sib_sourcel:4;
+    unsigned int    sib_topl:4;
+    unsigned int    sib_vrtbufl:4;
+}tvd_VIDEO_ADC_ANALOG_CTRL0;
+
+typedef struct
+{
+    unsigned int    reserved_0:6;
+    unsigned int    avrbl:3;
+    unsigned int    bvrbl:3;
+    unsigned int    cvrbl:3;
+    unsigned int    dvrbl:3;
+    unsigned int    svrbl:3;
+    unsigned int    clamp_enl:4;
+    unsigned int    sckinl:2;
+    unsigned int    sckol:1;
+    unsigned int    vicmpowl:4;
+}tvd_VIDEO_ADC_ANALOG_CTRL1;
+
+typedef struct
+{
+    unsigned int    reserved_0:4;
+    unsigned int    afepowl:4;
+    unsigned int    sadcinl:4;
+    unsigned int    vrefpowl:5;
+    unsigned int    avrtl:3;
+    unsigned int    bvrtl:3;
+    unsigned int    cvrtl:3;
+    unsigned int    dvrtl:3;
+    unsigned int    svrtl:3;
+}tvd_VIDEO_ADC_ANALOG_CTRL2;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    write_enable9:1;
+    unsigned int    fsw_en:1;
+    unsigned int    write_enable8:1;
+    unsigned int    sw_y_r:2;
+    unsigned int    write_enable7:1;
+    unsigned int    sw_pb_g:2;
+    unsigned int    write_enable6:1;
+    unsigned int    sw_pr_b:2;
+    unsigned int    write_enable5:1;
+    unsigned int    ad1_y_sw:1;
+    unsigned int    write_enable4:1;
+    unsigned int    scart_en:1;
+    unsigned int    write_enable3:1;
+    unsigned int    clamp_ad2:2;
+    unsigned int    write_enable2:1;
+    unsigned int    clamp_ad3:2;
+    unsigned int    write_enable1:1;
+    unsigned int    clamp_ad4:2;
+}tvd_AD_SW_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    hst:8;
+    unsigned int    hwidth:8;
+    unsigned int    vst:7;
+    unsigned int    vwidth:7;
+}tvd_SCART_ACTIVE;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    clamp_a_up_en:1;
+    unsigned int    clamp_a_dn_en:1;
+    unsigned int    clamp_b_up_en:1;
+    unsigned int    clamp_b_dn_en:1;
+    unsigned int    clamp_c_up_en:1;
+    unsigned int    clamp_c_dn_en:1;
+    unsigned int    clamp_d_up_en:1;
+    unsigned int    clamp_d_dn_en:1;
+}tvd_CLAMP_EN_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:25;
+    unsigned int    value:7;
+}tvd_3B_ADC;
+
+typedef struct
+{
+    unsigned int    reserved_0:20;
+    unsigned int    muxanalogb:4;
+    unsigned int    muxanaloga:4;
+    unsigned int    muxdigital:4;
+}tvd_DEBUG;
+
+typedef struct
+{
+    unsigned int    reserved_0:21;
+    unsigned int    serration_thd:8;
+    unsigned int    lock_h_on_no_signal:1;
+    unsigned int    disable_blue_screen_when_vcr:1;
+    unsigned int    detect_vcr_when_h_unlock:1;
+}tvd_VCR_OPTION;
+
+typedef struct
+{
+    unsigned int    reserved_0:12;
+    unsigned int    first_v:10;
+    unsigned int    second_v:10;
+}tvd_HV_MEASURE_1;
+
+typedef struct
+{
+    unsigned int    reserved_0:11;
+    unsigned int    count:8;
+    unsigned int    hgt:13;
+}tvd_HV_MEASURE_2;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    crc_en:1;
+    unsigned int    ptgen_en:1;
+}tvd_CRC_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:16;
+    unsigned int    checksum:16;
+}tvd_CRC_CHECKSUM;
+
+typedef struct
+{
+    unsigned int    reserved_0:10;
+    unsigned int    mask:22;
+}tvd_RAW_MASK;
+
+typedef struct
+{
+    unsigned int    reserved_0:12;
+    unsigned int    start:10;
+    unsigned int    end:10;
+}tvd_3D_VACTIVE1;
+
+typedef struct
+{
+    unsigned int    reserved_0:12;
+    unsigned int    start:10;
+    unsigned int    end:10;
+}tvd_3D_VACTIVE2;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    frame_adr0:27;
+}tvd_FRAME_ADDR0;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    frame_adr1:27;
+}tvd_FRAME_ADDR1;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    write_enable5:1;
+    unsigned int    dmaen:1;
+    unsigned int    write_enable4:1;
+    unsigned int    ififo_thr:6;
+    unsigned int    write_enable3:1;
+    unsigned int    ofifo_thr:6;
+    unsigned int    write_enable2:1;
+    unsigned int    ceiladr:6;
+    unsigned int    write_enable1:1;
+    unsigned int    bstlen:3;
+}tvd_DMA_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    ififo_err:1;
+    unsigned int    ofifo_err:1;
+}tvd_DMA_ERR;
+
+typedef struct
+{
+    unsigned int    reserved_0:12;
+    unsigned int    hcnt:10;
+    unsigned int    vcnt:10;
+}tvd_IPCNT;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    iprstn:1;
+}tvd_IP_RESET;
+
+typedef struct
+{
+    unsigned int    reserved_0:28;
+    unsigned int    edge_sel4:1;
+    unsigned int    edge_sel3:1;
+    unsigned int    edge_sel2:1;
+    unsigned int    edge_sel1:1;
+}tvd_ADC_SAMPLE;
+#endif
+
+#define TVD_VDO_CTRL1                                                 0x18019000
+#define TVD_VDO_CTRL1_reg_addr                                        "0xB8019000"
+#define TVD_VDO_CTRL1_reg                                             0xB8019000
+#define TVD_VDO_CTRL1_inst_addr                                       "0x0000"
+#define TVD_VDO_CTRL1_inst                                            0x0000
+#define TVD_VDO_CTRL1_write_enable7_shift                             (16)
+#define TVD_VDO_CTRL1_hv_delay_shift                                  (15)
+#define TVD_VDO_CTRL1_write_enable6_shift                             (14)
+#define TVD_VDO_CTRL1_hpixel_shift                                    (12)
+#define TVD_VDO_CTRL1_write_enable5_shift                             (11)
+#define TVD_VDO_CTRL1_vline_625_shift                                 (10)
+#define TVD_VDO_CTRL1_write_enable4_shift                             (9)
+#define TVD_VDO_CTRL1_colour_mode_shift                               (6)
+#define TVD_VDO_CTRL1_write_enable3_shift                             (5)
+#define TVD_VDO_CTRL1_yc_src_shift                                    (4)
+#define TVD_VDO_CTRL1_write_enable2_shift                             (3)
+#define TVD_VDO_CTRL1_cv_inv_shift                                    (2)
+#define TVD_VDO_CTRL1_write_enable1_shift                             (1)
+#define TVD_VDO_CTRL1_cv_src_shift                                    (0)
+#define TVD_VDO_CTRL1_write_enable7_mask                              (0x00010000)
+#define TVD_VDO_CTRL1_hv_delay_mask                                   (0x00008000)
+#define TVD_VDO_CTRL1_write_enable6_mask                              (0x00004000)
+#define TVD_VDO_CTRL1_hpixel_mask                                     (0x00003000)
+#define TVD_VDO_CTRL1_write_enable5_mask                              (0x00000800)
+#define TVD_VDO_CTRL1_vline_625_mask                                  (0x00000400)
+#define TVD_VDO_CTRL1_write_enable4_mask                              (0x00000200)
+#define TVD_VDO_CTRL1_colour_mode_mask                                (0x000001C0)
+#define TVD_VDO_CTRL1_write_enable3_mask                              (0x00000020)
+#define TVD_VDO_CTRL1_yc_src_mask                                     (0x00000010)
+#define TVD_VDO_CTRL1_write_enable2_mask                              (0x00000008)
+#define TVD_VDO_CTRL1_cv_inv_mask                                     (0x00000004)
+#define TVD_VDO_CTRL1_write_enable1_mask                              (0x00000002)
+#define TVD_VDO_CTRL1_cv_src_mask                                     (0x00000001)
+#define TVD_VDO_CTRL1_write_enable7(data)                             (0x00010000&((data)<<16))
+#define TVD_VDO_CTRL1_hv_delay(data)                                  (0x00008000&((data)<<15))
+#define TVD_VDO_CTRL1_write_enable6(data)                             (0x00004000&((data)<<14))
+#define TVD_VDO_CTRL1_hpixel(data)                                    (0x00003000&((data)<<12))
+#define TVD_VDO_CTRL1_write_enable5(data)                             (0x00000800&((data)<<11))
+#define TVD_VDO_CTRL1_vline_625(data)                                 (0x00000400&((data)<<10))
+#define TVD_VDO_CTRL1_write_enable4(data)                             (0x00000200&((data)<<9))
+#define TVD_VDO_CTRL1_colour_mode(data)                               (0x000001C0&((data)<<6))
+#define TVD_VDO_CTRL1_write_enable3(data)                             (0x00000020&((data)<<5))
+#define TVD_VDO_CTRL1_yc_src(data)                                    (0x00000010&((data)<<4))
+#define TVD_VDO_CTRL1_write_enable2(data)                             (0x00000008&((data)<<3))
+#define TVD_VDO_CTRL1_cv_inv(data)                                    (0x00000004&((data)<<2))
+#define TVD_VDO_CTRL1_write_enable1(data)                             (0x00000002&((data)<<1))
+#define TVD_VDO_CTRL1_cv_src(data)                                    (0x00000001&(data))
+#define TVD_VDO_CTRL1_get_write_enable7(data)                         ((0x00010000&(data))>>16)
+#define TVD_VDO_CTRL1_get_hv_delay(data)                              ((0x00008000&(data))>>15)
+#define TVD_VDO_CTRL1_get_write_enable6(data)                         ((0x00004000&(data))>>14)
+#define TVD_VDO_CTRL1_get_hpixel(data)                                ((0x00003000&(data))>>12)
+#define TVD_VDO_CTRL1_get_write_enable5(data)                         ((0x00000800&(data))>>11)
+#define TVD_VDO_CTRL1_get_vline_625(data)                             ((0x00000400&(data))>>10)
+#define TVD_VDO_CTRL1_get_write_enable4(data)                         ((0x00000200&(data))>>9)
+#define TVD_VDO_CTRL1_get_colour_mode(data)                           ((0x000001C0&(data))>>6)
+#define TVD_VDO_CTRL1_get_write_enable3(data)                         ((0x00000020&(data))>>5)
+#define TVD_VDO_CTRL1_get_yc_src(data)                                ((0x00000010&(data))>>4)
+#define TVD_VDO_CTRL1_get_write_enable2(data)                         ((0x00000008&(data))>>3)
+#define TVD_VDO_CTRL1_get_cv_inv(data)                                ((0x00000004&(data))>>2)
+#define TVD_VDO_CTRL1_get_write_enable1(data)                         ((0x00000002&(data))>>1)
+#define TVD_VDO_CTRL1_get_cv_src(data)                                (0x00000001&(data))
+
+#define TVD_VDO_CTRL2                                                 0x18019004
+#define TVD_VDO_CTRL2_reg_addr                                        "0xB8019004"
+#define TVD_VDO_CTRL2_reg                                             0xB8019004
+#define TVD_VDO_CTRL2_inst_addr                                       "0x0001"
+#define TVD_VDO_CTRL2_inst                                            0x0001
+#define TVD_VDO_CTRL2_write_enable9_shift                             (20)
+#define TVD_VDO_CTRL2_luma_notch_bw_shift                             (18)
+#define TVD_VDO_CTRL2_write_enable8_shift                             (17)
+#define TVD_VDO_CTRL2_chroma_bw_lo_shift                              (15)
+#define TVD_VDO_CTRL2_write_enable7_shift                             (14)
+#define TVD_VDO_CTRL2_chroma_burst5or10_shift                         (13)
+#define TVD_VDO_CTRL2_write_enable6_shift                             (12)
+#define TVD_VDO_CTRL2_ped_shift                                       (11)
+#define TVD_VDO_CTRL2_write_enable5_shift                             (10)
+#define TVD_VDO_CTRL2_hagc_field_shift                                (9)
+#define TVD_VDO_CTRL2_write_enable4_shift                             (8)
+#define TVD_VDO_CTRL2_mv_hagc_shift                                   (7)
+#define TVD_VDO_CTRL2_write_enable3_shift                             (6)
+#define TVD_VDO_CTRL2_dc_clamp_mode_shift                             (4)
+#define TVD_VDO_CTRL2_write_enable2_shift                             (3)
+#define TVD_VDO_CTRL2_cagc_en_shift                                   (2)
+#define TVD_VDO_CTRL2_write_enable1_shift                             (1)
+#define TVD_VDO_CTRL2_hagc_en_shift                                   (0)
+#define TVD_VDO_CTRL2_write_enable9_mask                              (0x00100000)
+#define TVD_VDO_CTRL2_luma_notch_bw_mask                              (0x000C0000)
+#define TVD_VDO_CTRL2_write_enable8_mask                              (0x00020000)
+#define TVD_VDO_CTRL2_chroma_bw_lo_mask                               (0x00018000)
+#define TVD_VDO_CTRL2_write_enable7_mask                              (0x00004000)
+#define TVD_VDO_CTRL2_chroma_burst5or10_mask                          (0x00002000)
+#define TVD_VDO_CTRL2_write_enable6_mask                              (0x00001000)
+#define TVD_VDO_CTRL2_ped_mask                                        (0x00000800)
+#define TVD_VDO_CTRL2_write_enable5_mask                              (0x00000400)
+#define TVD_VDO_CTRL2_hagc_field_mask                                 (0x00000200)
+#define TVD_VDO_CTRL2_write_enable4_mask                              (0x00000100)
+#define TVD_VDO_CTRL2_mv_hagc_mask                                    (0x00000080)
+#define TVD_VDO_CTRL2_write_enable3_mask                              (0x00000040)
+#define TVD_VDO_CTRL2_dc_clamp_mode_mask                              (0x00000030)
+#define TVD_VDO_CTRL2_write_enable2_mask                              (0x00000008)
+#define TVD_VDO_CTRL2_cagc_en_mask                                    (0x00000004)
+#define TVD_VDO_CTRL2_write_enable1_mask                              (0x00000002)
+#define TVD_VDO_CTRL2_hagc_en_mask                                    (0x00000001)
+#define TVD_VDO_CTRL2_write_enable9(data)                             (0x00100000&((data)<<20))
+#define TVD_VDO_CTRL2_luma_notch_bw(data)                             (0x000C0000&((data)<<18))
+#define TVD_VDO_CTRL2_write_enable8(data)                             (0x00020000&((data)<<17))
+#define TVD_VDO_CTRL2_chroma_bw_lo(data)                              (0x00018000&((data)<<15))
+#define TVD_VDO_CTRL2_write_enable7(data)                             (0x00004000&((data)<<14))
+#define TVD_VDO_CTRL2_chroma_burst5or10(data)                         (0x00002000&((data)<<13))
+#define TVD_VDO_CTRL2_write_enable6(data)                             (0x00001000&((data)<<12))
+#define TVD_VDO_CTRL2_ped(data)                                       (0x00000800&((data)<<11))
+#define TVD_VDO_CTRL2_write_enable5(data)                             (0x00000400&((data)<<10))
+#define TVD_VDO_CTRL2_hagc_field(data)                                (0x00000200&((data)<<9))
+#define TVD_VDO_CTRL2_write_enable4(data)                             (0x00000100&((data)<<8))
+#define TVD_VDO_CTRL2_mv_hagc(data)                                   (0x00000080&((data)<<7))
+#define TVD_VDO_CTRL2_write_enable3(data)                             (0x00000040&((data)<<6))
+#define TVD_VDO_CTRL2_dc_clamp_mode(data)                             (0x00000030&((data)<<4))
+#define TVD_VDO_CTRL2_write_enable2(data)                             (0x00000008&((data)<<3))
+#define TVD_VDO_CTRL2_cagc_en(data)                                   (0x00000004&((data)<<2))
+#define TVD_VDO_CTRL2_write_enable1(data)                             (0x00000002&((data)<<1))
+#define TVD_VDO_CTRL2_hagc_en(data)                                   (0x00000001&(data))
+#define TVD_VDO_CTRL2_get_write_enable9(data)                         ((0x00100000&(data))>>20)
+#define TVD_VDO_CTRL2_get_luma_notch_bw(data)                         ((0x000C0000&(data))>>18)
+#define TVD_VDO_CTRL2_get_write_enable8(data)                         ((0x00020000&(data))>>17)
+#define TVD_VDO_CTRL2_get_chroma_bw_lo(data)                          ((0x00018000&(data))>>15)
+#define TVD_VDO_CTRL2_get_write_enable7(data)                         ((0x00004000&(data))>>14)
+#define TVD_VDO_CTRL2_get_chroma_burst5or10(data)                     ((0x00002000&(data))>>13)
+#define TVD_VDO_CTRL2_get_write_enable6(data)                         ((0x00001000&(data))>>12)
+#define TVD_VDO_CTRL2_get_ped(data)                                   ((0x00000800&(data))>>11)
+#define TVD_VDO_CTRL2_get_write_enable5(data)                         ((0x00000400&(data))>>10)
+#define TVD_VDO_CTRL2_get_hagc_field(data)                            ((0x00000200&(data))>>9)
+#define TVD_VDO_CTRL2_get_write_enable4(data)                         ((0x00000100&(data))>>8)
+#define TVD_VDO_CTRL2_get_mv_hagc(data)                               ((0x00000080&(data))>>7)
+#define TVD_VDO_CTRL2_get_write_enable3(data)                         ((0x00000040&(data))>>6)
+#define TVD_VDO_CTRL2_get_dc_clamp_mode(data)                         ((0x00000030&(data))>>4)
+#define TVD_VDO_CTRL2_get_write_enable2(data)                         ((0x00000008&(data))>>3)
+#define TVD_VDO_CTRL2_get_cagc_en(data)                               ((0x00000004&(data))>>2)
+#define TVD_VDO_CTRL2_get_write_enable1(data)                         ((0x00000002&(data))>>1)
+#define TVD_VDO_CTRL2_get_hagc_en(data)                               (0x00000001&(data))
+
+#define TVD_YC_SEP_CTRL                                               0x18019008
+#define TVD_YC_SEP_CTRL_reg_addr                                      "0xB8019008"
+#define TVD_YC_SEP_CTRL_reg                                           0xB8019008
+#define TVD_YC_SEP_CTRL_inst_addr                                     "0x0002"
+#define TVD_YC_SEP_CTRL_inst                                          0x0002
+#define TVD_YC_SEP_CTRL_write_enable2_shift                           (5)
+#define TVD_YC_SEP_CTRL_colour_trap_shift                             (4)
+#define TVD_YC_SEP_CTRL_write_enable1_shift                           (3)
+#define TVD_YC_SEP_CTRL_adaptive_mode_shift                           (0)
+#define TVD_YC_SEP_CTRL_write_enable2_mask                            (0x00000020)
+#define TVD_YC_SEP_CTRL_colour_trap_mask                              (0x00000010)
+#define TVD_YC_SEP_CTRL_write_enable1_mask                            (0x00000008)
+#define TVD_YC_SEP_CTRL_adaptive_mode_mask                            (0x00000007)
+#define TVD_YC_SEP_CTRL_write_enable2(data)                           (0x00000020&((data)<<5))
+#define TVD_YC_SEP_CTRL_colour_trap(data)                             (0x00000010&((data)<<4))
+#define TVD_YC_SEP_CTRL_write_enable1(data)                           (0x00000008&((data)<<3))
+#define TVD_YC_SEP_CTRL_adaptive_mode(data)                           (0x00000007&(data))
+#define TVD_YC_SEP_CTRL_get_write_enable2(data)                       ((0x00000020&(data))>>5)
+#define TVD_YC_SEP_CTRL_get_colour_trap(data)                         ((0x00000010&(data))>>4)
+#define TVD_YC_SEP_CTRL_get_write_enable1(data)                       ((0x00000008&(data))>>3)
+#define TVD_YC_SEP_CTRL_get_adaptive_mode(data)                       (0x00000007&(data))
+
+#define TVD_HOR_ACQ                                                   0x1801900C
+#define TVD_HOR_ACQ_reg_addr                                          "0xB801900C"
+#define TVD_HOR_ACQ_reg                                               0xB801900C
+#define TVD_HOR_ACQ_inst_addr                                         "0x0003"
+#define TVD_HOR_ACQ_inst                                              0x0003
+#define TVD_HOR_ACQ_write_enable6_shift                               (29)
+#define TVD_HOR_ACQ_hagc_shift                                        (21)
+#define TVD_HOR_ACQ_write_enable5_shift                               (20)
+#define TVD_HOR_ACQ_noise_thresh_shift                                (12)
+#define TVD_HOR_ACQ_write_enable4_shift                               (11)
+#define TVD_HOR_ACQ_adc_updn_swap_shift                               (10)
+#define TVD_HOR_ACQ_write_enable3_shift                               (9)
+#define TVD_HOR_ACQ_adc_input_swap_shift                              (8)
+#define TVD_HOR_ACQ_write_enable2_shift                               (7)
+#define TVD_HOR_ACQ_adc_cbcr_pump_swap_shift                          (6)
+#define TVD_HOR_ACQ_write_enable1_shift                               (5)
+#define TVD_HOR_ACQ_adc_gate_thresh_shift                             (0)
+#define TVD_HOR_ACQ_write_enable6_mask                                (0x20000000)
+#define TVD_HOR_ACQ_hagc_mask                                         (0x1FE00000)
+#define TVD_HOR_ACQ_write_enable5_mask                                (0x00100000)
+#define TVD_HOR_ACQ_noise_thresh_mask                                 (0x000FF000)
+#define TVD_HOR_ACQ_write_enable4_mask                                (0x00000800)
+#define TVD_HOR_ACQ_adc_updn_swap_mask                                (0x00000400)
+#define TVD_HOR_ACQ_write_enable3_mask                                (0x00000200)
+#define TVD_HOR_ACQ_adc_input_swap_mask                               (0x00000100)
+#define TVD_HOR_ACQ_write_enable2_mask                                (0x00000080)
+#define TVD_HOR_ACQ_adc_cbcr_pump_swap_mask                           (0x00000040)
+#define TVD_HOR_ACQ_write_enable1_mask                                (0x00000020)
+#define TVD_HOR_ACQ_adc_gate_thresh_mask                              (0x0000001F)
+#define TVD_HOR_ACQ_write_enable6(data)                               (0x20000000&((data)<<29))
+#define TVD_HOR_ACQ_hagc(data)                                        (0x1FE00000&((data)<<21))
+#define TVD_HOR_ACQ_write_enable5(data)                               (0x00100000&((data)<<20))
+#define TVD_HOR_ACQ_noise_thresh(data)                                (0x000FF000&((data)<<12))
+#define TVD_HOR_ACQ_write_enable4(data)                               (0x00000800&((data)<<11))
+#define TVD_HOR_ACQ_adc_updn_swap(data)                               (0x00000400&((data)<<10))
+#define TVD_HOR_ACQ_write_enable3(data)                               (0x00000200&((data)<<9))
+#define TVD_HOR_ACQ_adc_input_swap(data)                              (0x00000100&((data)<<8))
+#define TVD_HOR_ACQ_write_enable2(data)                               (0x00000080&((data)<<7))
+#define TVD_HOR_ACQ_adc_cbcr_pump_swap(data)                          (0x00000040&((data)<<6))
+#define TVD_HOR_ACQ_write_enable1(data)                               (0x00000020&((data)<<5))
+#define TVD_HOR_ACQ_adc_gate_thresh(data)                             (0x0000001F&(data))
+#define TVD_HOR_ACQ_get_write_enable6(data)                           ((0x20000000&(data))>>29)
+#define TVD_HOR_ACQ_get_hagc(data)                                    ((0x1FE00000&(data))>>21)
+#define TVD_HOR_ACQ_get_write_enable5(data)                           ((0x00100000&(data))>>20)
+#define TVD_HOR_ACQ_get_noise_thresh(data)                            ((0x000FF000&(data))>>12)
+#define TVD_HOR_ACQ_get_write_enable4(data)                           ((0x00000800&(data))>>11)
+#define TVD_HOR_ACQ_get_adc_updn_swap(data)                           ((0x00000400&(data))>>10)
+#define TVD_HOR_ACQ_get_write_enable3(data)                           ((0x00000200&(data))>>9)
+#define TVD_HOR_ACQ_get_adc_input_swap(data)                          ((0x00000100&(data))>>8)
+#define TVD_HOR_ACQ_get_write_enable2(data)                           ((0x00000080&(data))>>7)
+#define TVD_HOR_ACQ_get_adc_cbcr_pump_swap(data)                      ((0x00000040&(data))>>6)
+#define TVD_HOR_ACQ_get_write_enable1(data)                           ((0x00000020&(data))>>5)
+#define TVD_HOR_ACQ_get_adc_gate_thresh(data)                         (0x0000001F&(data))
+
+#define TVD_OUT_CTRL                                                  0x18019010
+#define TVD_OUT_CTRL_reg_addr                                         "0xB8019010"
+#define TVD_OUT_CTRL_reg                                              0xB8019010
+#define TVD_OUT_CTRL_inst_addr                                        "0x0004"
+#define TVD_OUT_CTRL_inst                                             0x0004
+#define TVD_OUT_CTRL_write_enable3_shift                              (9)
+#define TVD_OUT_CTRL_cbcr_swap_shift                                  (8)
+#define TVD_OUT_CTRL_write_enable2_shift                              (7)
+#define TVD_OUT_CTRL_blue_mode_shift                                  (5)
+#define TVD_OUT_CTRL_write_enable1_shift                              (4)
+#define TVD_OUT_CTRL_yc_delay_shift                                   (0)
+#define TVD_OUT_CTRL_write_enable3_mask                               (0x00000200)
+#define TVD_OUT_CTRL_cbcr_swap_mask                                   (0x00000100)
+#define TVD_OUT_CTRL_write_enable2_mask                               (0x00000080)
+#define TVD_OUT_CTRL_blue_mode_mask                                   (0x00000060)
+#define TVD_OUT_CTRL_write_enable1_mask                               (0x00000010)
+#define TVD_OUT_CTRL_yc_delay_mask                                    (0x0000000F)
+#define TVD_OUT_CTRL_write_enable3(data)                              (0x00000200&((data)<<9))
+#define TVD_OUT_CTRL_cbcr_swap(data)                                  (0x00000100&((data)<<8))
+#define TVD_OUT_CTRL_write_enable2(data)                              (0x00000080&((data)<<7))
+#define TVD_OUT_CTRL_blue_mode(data)                                  (0x00000060&((data)<<5))
+#define TVD_OUT_CTRL_write_enable1(data)                              (0x00000010&((data)<<4))
+#define TVD_OUT_CTRL_yc_delay(data)                                   (0x0000000F&(data))
+#define TVD_OUT_CTRL_get_write_enable3(data)                          ((0x00000200&(data))>>9)
+#define TVD_OUT_CTRL_get_cbcr_swap(data)                              ((0x00000100&(data))>>8)
+#define TVD_OUT_CTRL_get_write_enable2(data)                          ((0x00000080&(data))>>7)
+#define TVD_OUT_CTRL_get_blue_mode(data)                              ((0x00000060&(data))>>5)
+#define TVD_OUT_CTRL_get_write_enable1(data)                          ((0x00000010&(data))>>4)
+#define TVD_OUT_CTRL_get_yc_delay(data)                               (0x0000000F&(data))
+
+#define TVD_LUMA_ADJUST                                               0x18019014
+#define TVD_LUMA_ADJUST_reg_addr                                      "0xB8019014"
+#define TVD_LUMA_ADJUST_reg                                           0xB8019014
+#define TVD_LUMA_ADJUST_inst_addr                                     "0x0005"
+#define TVD_LUMA_ADJUST_inst                                          0x0005
+#define TVD_LUMA_ADJUST_write_enable2_shift                           (17)
+#define TVD_LUMA_ADJUST_contrast_shift                                (9)
+#define TVD_LUMA_ADJUST_write_enable1_shift                           (8)
+#define TVD_LUMA_ADJUST_brightness_shift                              (0)
+#define TVD_LUMA_ADJUST_write_enable2_mask                            (0x00020000)
+#define TVD_LUMA_ADJUST_contrast_mask                                 (0x0001FE00)
+#define TVD_LUMA_ADJUST_write_enable1_mask                            (0x00000100)
+#define TVD_LUMA_ADJUST_brightness_mask                               (0x000000FF)
+#define TVD_LUMA_ADJUST_write_enable2(data)                           (0x00020000&((data)<<17))
+#define TVD_LUMA_ADJUST_contrast(data)                                (0x0001FE00&((data)<<9))
+#define TVD_LUMA_ADJUST_write_enable1(data)                           (0x00000100&((data)<<8))
+#define TVD_LUMA_ADJUST_brightness(data)                              (0x000000FF&(data))
+#define TVD_LUMA_ADJUST_get_write_enable2(data)                       ((0x00020000&(data))>>17)
+#define TVD_LUMA_ADJUST_get_contrast(data)                            ((0x0001FE00&(data))>>9)
+#define TVD_LUMA_ADJUST_get_write_enable1(data)                       ((0x00000100&(data))>>8)
+#define TVD_LUMA_ADJUST_get_brightness(data)                          (0x000000FF&(data))
+
+#define TVD_CHROMA_ADJUST                                             0x18019018
+#define TVD_CHROMA_ADJUST_reg_addr                                    "0xB8019018"
+#define TVD_CHROMA_ADJUST_reg                                         0xB8019018
+#define TVD_CHROMA_ADJUST_inst_addr                                   "0x0006"
+#define TVD_CHROMA_ADJUST_inst                                        0x0006
+#define TVD_CHROMA_ADJUST_write_enable3_shift                         (26)
+#define TVD_CHROMA_ADJUST_saturation_shift                            (18)
+#define TVD_CHROMA_ADJUST_write_enable2_shift                         (17)
+#define TVD_CHROMA_ADJUST_hue_shift                                   (9)
+#define TVD_CHROMA_ADJUST_write_enable1_shift                         (8)
+#define TVD_CHROMA_ADJUST_cagc_shift                                  (0)
+#define TVD_CHROMA_ADJUST_write_enable3_mask                          (0x04000000)
+#define TVD_CHROMA_ADJUST_saturation_mask                             (0x03FC0000)
+#define TVD_CHROMA_ADJUST_write_enable2_mask                          (0x00020000)
+#define TVD_CHROMA_ADJUST_hue_mask                                    (0x0001FE00)
+#define TVD_CHROMA_ADJUST_write_enable1_mask                          (0x00000100)
+#define TVD_CHROMA_ADJUST_cagc_mask                                   (0x000000FF)
+#define TVD_CHROMA_ADJUST_write_enable3(data)                         (0x04000000&((data)<<26))
+#define TVD_CHROMA_ADJUST_saturation(data)                            (0x03FC0000&((data)<<18))
+#define TVD_CHROMA_ADJUST_write_enable2(data)                         (0x00020000&((data)<<17))
+#define TVD_CHROMA_ADJUST_hue(data)                                   (0x0001FE00&((data)<<9))
+#define TVD_CHROMA_ADJUST_write_enable1(data)                         (0x00000100&((data)<<8))
+#define TVD_CHROMA_ADJUST_cagc(data)                                  (0x000000FF&(data))
+#define TVD_CHROMA_ADJUST_get_write_enable3(data)                     ((0x04000000&(data))>>26)
+#define TVD_CHROMA_ADJUST_get_saturation(data)                        ((0x03FC0000&(data))>>18)
+#define TVD_CHROMA_ADJUST_get_write_enable2(data)                     ((0x00020000&(data))>>17)
+#define TVD_CHROMA_ADJUST_get_hue(data)                               ((0x0001FE00&(data))>>9)
+#define TVD_CHROMA_ADJUST_get_write_enable1(data)                     ((0x00000100&(data))>>8)
+#define TVD_CHROMA_ADJUST_get_cagc(data)                              (0x000000FF&(data))
+
+#define TVD_CHROMA_KILL_AUTOPOS                                       0x1801901C
+#define TVD_CHROMA_KILL_AUTOPOS_reg_addr                              "0xB801901C"
+#define TVD_CHROMA_KILL_AUTOPOS_reg                                   0xB801901C
+#define TVD_CHROMA_KILL_AUTOPOS_inst_addr                             "0x0007"
+#define TVD_CHROMA_KILL_AUTOPOS_inst                                  0x0007
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable7_shift                   (21)
+#define TVD_CHROMA_KILL_AUTOPOS_user_ckill_mode_shift                 (19)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable6_shift                   (18)
+#define TVD_CHROMA_KILL_AUTOPOS_vbi_ckill_shift                       (17)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable5_shift                   (16)
+#define TVD_CHROMA_KILL_AUTOPOS_hlock_ckill_shift                     (15)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable4_shift                   (14)
+#define TVD_CHROMA_KILL_AUTOPOS_chroma_kill_shift                     (10)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable3_shift                   (9)
+#define TVD_CHROMA_KILL_AUTOPOS_secam_test_mode_shift                 (8)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable2_shift                   (7)
+#define TVD_CHROMA_KILL_AUTOPOS_fixed_burstgate_shift                 (6)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable1_shift                   (5)
+#define TVD_CHROMA_KILL_AUTOPOS_cautopos_shift                        (0)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable7_mask                    (0x00200000)
+#define TVD_CHROMA_KILL_AUTOPOS_user_ckill_mode_mask                  (0x00180000)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable6_mask                    (0x00040000)
+#define TVD_CHROMA_KILL_AUTOPOS_vbi_ckill_mask                        (0x00020000)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable5_mask                    (0x00010000)
+#define TVD_CHROMA_KILL_AUTOPOS_hlock_ckill_mask                      (0x00008000)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable4_mask                    (0x00004000)
+#define TVD_CHROMA_KILL_AUTOPOS_chroma_kill_mask                      (0x00003C00)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable3_mask                    (0x00000200)
+#define TVD_CHROMA_KILL_AUTOPOS_secam_test_mode_mask                  (0x00000100)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable2_mask                    (0x00000080)
+#define TVD_CHROMA_KILL_AUTOPOS_fixed_burstgate_mask                  (0x00000040)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable1_mask                    (0x00000020)
+#define TVD_CHROMA_KILL_AUTOPOS_cautopos_mask                         (0x0000001F)
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable7(data)                   (0x00200000&((data)<<21))
+#define TVD_CHROMA_KILL_AUTOPOS_user_ckill_mode(data)                 (0x00180000&((data)<<19))
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable6(data)                   (0x00040000&((data)<<18))
+#define TVD_CHROMA_KILL_AUTOPOS_vbi_ckill(data)                       (0x00020000&((data)<<17))
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable5(data)                   (0x00010000&((data)<<16))
+#define TVD_CHROMA_KILL_AUTOPOS_hlock_ckill(data)                     (0x00008000&((data)<<15))
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable4(data)                   (0x00004000&((data)<<14))
+#define TVD_CHROMA_KILL_AUTOPOS_chroma_kill(data)                     (0x00003C00&((data)<<10))
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable3(data)                   (0x00000200&((data)<<9))
+#define TVD_CHROMA_KILL_AUTOPOS_secam_test_mode(data)                 (0x00000100&((data)<<8))
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable2(data)                   (0x00000080&((data)<<7))
+#define TVD_CHROMA_KILL_AUTOPOS_fixed_burstgate(data)                 (0x00000040&((data)<<6))
+#define TVD_CHROMA_KILL_AUTOPOS_write_enable1(data)                   (0x00000020&((data)<<5))
+#define TVD_CHROMA_KILL_AUTOPOS_cautopos(data)                        (0x0000001F&(data))
+#define TVD_CHROMA_KILL_AUTOPOS_get_write_enable7(data)               ((0x00200000&(data))>>21)
+#define TVD_CHROMA_KILL_AUTOPOS_get_user_ckill_mode(data)             ((0x00180000&(data))>>19)
+#define TVD_CHROMA_KILL_AUTOPOS_get_write_enable6(data)               ((0x00040000&(data))>>18)
+#define TVD_CHROMA_KILL_AUTOPOS_get_vbi_ckill(data)                   ((0x00020000&(data))>>17)
+#define TVD_CHROMA_KILL_AUTOPOS_get_write_enable5(data)               ((0x00010000&(data))>>16)
+#define TVD_CHROMA_KILL_AUTOPOS_get_hlock_ckill(data)                 ((0x00008000&(data))>>15)
+#define TVD_CHROMA_KILL_AUTOPOS_get_write_enable4(data)               ((0x00004000&(data))>>14)
+#define TVD_CHROMA_KILL_AUTOPOS_get_chroma_kill(data)                 ((0x00003C00&(data))>>10)
+#define TVD_CHROMA_KILL_AUTOPOS_get_write_enable3(data)               ((0x00000200&(data))>>9)
+#define TVD_CHROMA_KILL_AUTOPOS_get_secam_test_mode(data)             ((0x00000100&(data))>>8)
+#define TVD_CHROMA_KILL_AUTOPOS_get_write_enable2(data)               ((0x00000080&(data))>>7)
+#define TVD_CHROMA_KILL_AUTOPOS_get_fixed_burstgate(data)             ((0x00000040&(data))>>6)
+#define TVD_CHROMA_KILL_AUTOPOS_get_write_enable1(data)               ((0x00000020&(data))>>5)
+#define TVD_CHROMA_KILL_AUTOPOS_get_cautopos(data)                    (0x0000001F&(data))
+
+#define TVD_AGC_PEAKGATE                                              0x18019020
+#define TVD_AGC_PEAKGATE_reg_addr                                     "0xB8019020"
+#define TVD_AGC_PEAKGATE_reg                                          0xB8019020
+#define TVD_AGC_PEAKGATE_inst_addr                                    "0x0008"
+#define TVD_AGC_PEAKGATE_inst                                         0x0008
+#define TVD_AGC_PEAKGATE_write_enable6_shift                          (20)
+#define TVD_AGC_PEAKGATE_agc_peak_nominal_shift                       (13)
+#define TVD_AGC_PEAKGATE_write_enable5_shift                          (12)
+#define TVD_AGC_PEAKGATE_agc_gate_vsync_coarse_shift                  (11)
+#define TVD_AGC_PEAKGATE_write_enable4_shift                          (10)
+#define TVD_AGC_PEAKGATE_agc_gate_vsync_stip_shift                    (9)
+#define TVD_AGC_PEAKGATE_write_enable3_shift                          (8)
+#define TVD_AGC_PEAKGATE_agc_gate_kill_mode_shift                     (6)
+#define TVD_AGC_PEAKGATE_write_enable2_shift                          (5)
+#define TVD_AGC_PEAKGATE_agc_peak_en_shift                            (4)
+#define TVD_AGC_PEAKGATE_write_enable1_shift                          (3)
+#define TVD_AGC_PEAKGATE_agc_peak_cntl_shift                          (0)
+#define TVD_AGC_PEAKGATE_write_enable6_mask                           (0x00100000)
+#define TVD_AGC_PEAKGATE_agc_peak_nominal_mask                        (0x000FE000)
+#define TVD_AGC_PEAKGATE_write_enable5_mask                           (0x00001000)
+#define TVD_AGC_PEAKGATE_agc_gate_vsync_coarse_mask                   (0x00000800)
+#define TVD_AGC_PEAKGATE_write_enable4_mask                           (0x00000400)
+#define TVD_AGC_PEAKGATE_agc_gate_vsync_stip_mask                     (0x00000200)
+#define TVD_AGC_PEAKGATE_write_enable3_mask                           (0x00000100)
+#define TVD_AGC_PEAKGATE_agc_gate_kill_mode_mask                      (0x000000C0)
+#define TVD_AGC_PEAKGATE_write_enable2_mask                           (0x00000020)
+#define TVD_AGC_PEAKGATE_agc_peak_en_mask                             (0x00000010)
+#define TVD_AGC_PEAKGATE_write_enable1_mask                           (0x00000008)
+#define TVD_AGC_PEAKGATE_agc_peak_cntl_mask                           (0x00000007)
+#define TVD_AGC_PEAKGATE_write_enable6(data)                          (0x00100000&((data)<<20))
+#define TVD_AGC_PEAKGATE_agc_peak_nominal(data)                       (0x000FE000&((data)<<13))
+#define TVD_AGC_PEAKGATE_write_enable5(data)                          (0x00001000&((data)<<12))
+#define TVD_AGC_PEAKGATE_agc_gate_vsync_coarse(data)                  (0x00000800&((data)<<11))
+#define TVD_AGC_PEAKGATE_write_enable4(data)                          (0x00000400&((data)<<10))
+#define TVD_AGC_PEAKGATE_agc_gate_vsync_stip(data)                    (0x00000200&((data)<<9))
+#define TVD_AGC_PEAKGATE_write_enable3(data)                          (0x00000100&((data)<<8))
+#define TVD_AGC_PEAKGATE_agc_gate_kill_mode(data)                     (0x000000C0&((data)<<6))
+#define TVD_AGC_PEAKGATE_write_enable2(data)                          (0x00000020&((data)<<5))
+#define TVD_AGC_PEAKGATE_agc_peak_en(data)                            (0x00000010&((data)<<4))
+#define TVD_AGC_PEAKGATE_write_enable1(data)                          (0x00000008&((data)<<3))
+#define TVD_AGC_PEAKGATE_agc_peak_cntl(data)                          (0x00000007&(data))
+#define TVD_AGC_PEAKGATE_get_write_enable6(data)                      ((0x00100000&(data))>>20)
+#define TVD_AGC_PEAKGATE_get_agc_peak_nominal(data)                   ((0x000FE000&(data))>>13)
+#define TVD_AGC_PEAKGATE_get_write_enable5(data)                      ((0x00001000&(data))>>12)
+#define TVD_AGC_PEAKGATE_get_agc_gate_vsync_coarse(data)              ((0x00000800&(data))>>11)
+#define TVD_AGC_PEAKGATE_get_write_enable4(data)                      ((0x00000400&(data))>>10)
+#define TVD_AGC_PEAKGATE_get_agc_gate_vsync_stip(data)                ((0x00000200&(data))>>9)
+#define TVD_AGC_PEAKGATE_get_write_enable3(data)                      ((0x00000100&(data))>>8)
+#define TVD_AGC_PEAKGATE_get_agc_gate_kill_mode(data)                 ((0x000000C0&(data))>>6)
+#define TVD_AGC_PEAKGATE_get_write_enable2(data)                      ((0x00000020&(data))>>5)
+#define TVD_AGC_PEAKGATE_get_agc_peak_en(data)                        ((0x00000010&(data))>>4)
+#define TVD_AGC_PEAKGATE_get_write_enable1(data)                      ((0x00000008&(data))>>3)
+#define TVD_AGC_PEAKGATE_get_agc_peak_cntl(data)                      (0x00000007&(data))
+
+#define TVD_AGC_GATE                                                  0x18019024
+#define TVD_AGC_GATE_reg_addr                                         "0xB8019024"
+#define TVD_AGC_GATE_reg                                              0xB8019024
+#define TVD_AGC_GATE_inst_addr                                        "0x0009"
+#define TVD_AGC_GATE_inst                                             0x0009
+#define TVD_AGC_GATE_write_enable3_shift                              (28)
+#define TVD_AGC_GATE_agc_gate_start_shift                             (17)
+#define TVD_AGC_GATE_write_enable2_shift                              (16)
+#define TVD_AGC_GATE_agc_gate_width_shift                             (9)
+#define TVD_AGC_GATE_write_enable1_shift                              (8)
+#define TVD_AGC_GATE_agc_bp_delay_shift                               (0)
+#define TVD_AGC_GATE_write_enable3_mask                               (0x10000000)
+#define TVD_AGC_GATE_agc_gate_start_mask                              (0x0FFE0000)
+#define TVD_AGC_GATE_write_enable2_mask                               (0x00010000)
+#define TVD_AGC_GATE_agc_gate_width_mask                              (0x0000FE00)
+#define TVD_AGC_GATE_write_enable1_mask                               (0x00000100)
+#define TVD_AGC_GATE_agc_bp_delay_mask                                (0x000000FF)
+#define TVD_AGC_GATE_write_enable3(data)                              (0x10000000&((data)<<28))
+#define TVD_AGC_GATE_agc_gate_start(data)                             (0x0FFE0000&((data)<<17))
+#define TVD_AGC_GATE_write_enable2(data)                              (0x00010000&((data)<<16))
+#define TVD_AGC_GATE_agc_gate_width(data)                             (0x0000FE00&((data)<<9))
+#define TVD_AGC_GATE_write_enable1(data)                              (0x00000100&((data)<<8))
+#define TVD_AGC_GATE_agc_bp_delay(data)                               (0x000000FF&(data))
+#define TVD_AGC_GATE_get_write_enable3(data)                          ((0x10000000&(data))>>28)
+#define TVD_AGC_GATE_get_agc_gate_start(data)                         ((0x0FFE0000&(data))>>17)
+#define TVD_AGC_GATE_get_write_enable2(data)                          ((0x00010000&(data))>>16)
+#define TVD_AGC_GATE_get_agc_gate_width(data)                         ((0x0000FE00&(data))>>9)
+#define TVD_AGC_GATE_get_write_enable1(data)                          ((0x00000100&(data))>>8)
+#define TVD_AGC_GATE_get_agc_bp_delay(data)                           (0x000000FF&(data))
+
+#define TVD_HPLL_CTRL                                                 0x18019028
+#define TVD_HPLL_CTRL_reg_addr                                        "0xB8019028"
+#define TVD_HPLL_CTRL_reg                                             0xB8019028
+#define TVD_HPLL_CTRL_inst_addr                                       "0x000A"
+#define TVD_HPLL_CTRL_inst                                            0x000A
+#define TVD_HPLL_CTRL_write_enable7_shift                             (22)
+#define TVD_HPLL_CTRL_locked_count_noisy_max_shift                    (18)
+#define TVD_HPLL_CTRL_write_enable6_shift                             (17)
+#define TVD_HPLL_CTRL_locked_count_clean_max_shift                    (13)
+#define TVD_HPLL_CTRL_write_enable5_shift                             (12)
+#define TVD_HPLL_CTRL_hlock_vsync_mode_shift                          (10)
+#define TVD_HPLL_CTRL_write_enable4_shift                             (9)
+#define TVD_HPLL_CTRL_hstate_fixed_shift                              (8)
+#define TVD_HPLL_CTRL_write_enable3_shift                             (7)
+#define TVD_HPLL_CTRL_disable_hfine_shift                             (6)
+#define TVD_HPLL_CTRL_write_enable2_shift                             (5)
+#define TVD_HPLL_CTRL_hstate_unlocked_shift                           (4)
+#define TVD_HPLL_CTRL_write_enable1_shift                             (3)
+#define TVD_HPLL_CTRL_hstate_max_shift                                (0)
+#define TVD_HPLL_CTRL_write_enable7_mask                              (0x00400000)
+#define TVD_HPLL_CTRL_locked_count_noisy_max_mask                     (0x003C0000)
+#define TVD_HPLL_CTRL_write_enable6_mask                              (0x00020000)
+#define TVD_HPLL_CTRL_locked_count_clean_max_mask                     (0x0001E000)
+#define TVD_HPLL_CTRL_write_enable5_mask                              (0x00001000)
+#define TVD_HPLL_CTRL_hlock_vsync_mode_mask                           (0x00000C00)
+#define TVD_HPLL_CTRL_write_enable4_mask                              (0x00000200)
+#define TVD_HPLL_CTRL_hstate_fixed_mask                               (0x00000100)
+#define TVD_HPLL_CTRL_write_enable3_mask                              (0x00000080)
+#define TVD_HPLL_CTRL_disable_hfine_mask                              (0x00000040)
+#define TVD_HPLL_CTRL_write_enable2_mask                              (0x00000020)
+#define TVD_HPLL_CTRL_hstate_unlocked_mask                            (0x00000010)
+#define TVD_HPLL_CTRL_write_enable1_mask                              (0x00000008)
+#define TVD_HPLL_CTRL_hstate_max_mask                                 (0x00000007)
+#define TVD_HPLL_CTRL_write_enable7(data)                             (0x00400000&((data)<<22))
+#define TVD_HPLL_CTRL_locked_count_noisy_max(data)                    (0x003C0000&((data)<<18))
+#define TVD_HPLL_CTRL_write_enable6(data)                             (0x00020000&((data)<<17))
+#define TVD_HPLL_CTRL_locked_count_clean_max(data)                    (0x0001E000&((data)<<13))
+#define TVD_HPLL_CTRL_write_enable5(data)                             (0x00001000&((data)<<12))
+#define TVD_HPLL_CTRL_hlock_vsync_mode(data)                          (0x00000C00&((data)<<10))
+#define TVD_HPLL_CTRL_write_enable4(data)                             (0x00000200&((data)<<9))
+#define TVD_HPLL_CTRL_hstate_fixed(data)                              (0x00000100&((data)<<8))
+#define TVD_HPLL_CTRL_write_enable3(data)                             (0x00000080&((data)<<7))
+#define TVD_HPLL_CTRL_disable_hfine(data)                             (0x00000040&((data)<<6))
+#define TVD_HPLL_CTRL_write_enable2(data)                             (0x00000020&((data)<<5))
+#define TVD_HPLL_CTRL_hstate_unlocked(data)                           (0x00000010&((data)<<4))
+#define TVD_HPLL_CTRL_write_enable1(data)                             (0x00000008&((data)<<3))
+#define TVD_HPLL_CTRL_hstate_max(data)                                (0x00000007&(data))
+#define TVD_HPLL_CTRL_get_write_enable7(data)                         ((0x00400000&(data))>>22)
+#define TVD_HPLL_CTRL_get_locked_count_noisy_max(data)                ((0x003C0000&(data))>>18)
+#define TVD_HPLL_CTRL_get_write_enable6(data)                         ((0x00020000&(data))>>17)
+#define TVD_HPLL_CTRL_get_locked_count_clean_max(data)                ((0x0001E000&(data))>>13)
+#define TVD_HPLL_CTRL_get_write_enable5(data)                         ((0x00001000&(data))>>12)
+#define TVD_HPLL_CTRL_get_hlock_vsync_mode(data)                      ((0x00000C00&(data))>>10)
+#define TVD_HPLL_CTRL_get_write_enable4(data)                         ((0x00000200&(data))>>9)
+#define TVD_HPLL_CTRL_get_hstate_fixed(data)                          ((0x00000100&(data))>>8)
+#define TVD_HPLL_CTRL_get_write_enable3(data)                         ((0x00000080&(data))>>7)
+#define TVD_HPLL_CTRL_get_disable_hfine(data)                         ((0x00000040&(data))>>6)
+#define TVD_HPLL_CTRL_get_write_enable2(data)                         ((0x00000020&(data))>>5)
+#define TVD_HPLL_CTRL_get_hstate_unlocked(data)                       ((0x00000010&(data))>>4)
+#define TVD_HPLL_CTRL_get_write_enable1(data)                         ((0x00000008&(data))>>3)
+#define TVD_HPLL_CTRL_get_hstate_max(data)                            (0x00000007&(data))
+
+#define TVD_CHROMA_DTO                                                0x1801902C
+#define TVD_CHROMA_DTO_reg_addr                                       "0xB801902C"
+#define TVD_CHROMA_DTO_reg                                            0xB801902C
+#define TVD_CHROMA_DTO_inst_addr                                      "0x000B"
+#define TVD_CHROMA_DTO_inst                                           0x000B
+#define TVD_CHROMA_DTO_cdto_fixed_shift                               (30)
+#define TVD_CHROMA_DTO_cdto_inc_shift                                 (0)
+#define TVD_CHROMA_DTO_cdto_fixed_mask                                (0x40000000)
+#define TVD_CHROMA_DTO_cdto_inc_mask                                  (0x3FFFFFFF)
+#define TVD_CHROMA_DTO_cdto_fixed(data)                               (0x40000000&((data)<<30))
+#define TVD_CHROMA_DTO_cdto_inc(data)                                 (0x3FFFFFFF&(data))
+#define TVD_CHROMA_DTO_get_cdto_fixed(data)                           ((0x40000000&(data))>>30)
+#define TVD_CHROMA_DTO_get_cdto_inc(data)                             (0x3FFFFFFF&(data))
+
+#define TVD_HSYNC_DTO                                                 0x18019030
+#define TVD_HSYNC_DTO_reg_addr                                        "0xB8019030"
+#define TVD_HSYNC_DTO_reg                                             0xB8019030
+#define TVD_HSYNC_DTO_inst_addr                                       "0x000C"
+#define TVD_HSYNC_DTO_inst                                            0x000C
+#define TVD_HSYNC_DTO_hdto_fixed_shift                                (30)
+#define TVD_HSYNC_DTO_hdto_inc_shift                                  (0)
+#define TVD_HSYNC_DTO_hdto_fixed_mask                                 (0x40000000)
+#define TVD_HSYNC_DTO_hdto_inc_mask                                   (0x3FFFFFFF)
+#define TVD_HSYNC_DTO_hdto_fixed(data)                                (0x40000000&((data)<<30))
+#define TVD_HSYNC_DTO_hdto_inc(data)                                  (0x3FFFFFFF&(data))
+#define TVD_HSYNC_DTO_get_hdto_fixed(data)                            ((0x40000000&(data))>>30)
+#define TVD_HSYNC_DTO_get_hdto_inc(data)                              (0x3FFFFFFF&(data))
+
+#define TVD_HSYNC_OCCUR                                               0x18019034
+#define TVD_HSYNC_OCCUR_reg_addr                                      "0xB8019034"
+#define TVD_HSYNC_OCCUR_reg                                           0xB8019034
+#define TVD_HSYNC_OCCUR_inst_addr                                     "0x000D"
+#define TVD_HSYNC_OCCUR_inst                                          0x000D
+#define TVD_HSYNC_OCCUR_hsync_rising_shift                            (8)
+#define TVD_HSYNC_OCCUR_hsync_phase_offset_shift                      (0)
+#define TVD_HSYNC_OCCUR_hsync_rising_mask                             (0x0000FF00)
+#define TVD_HSYNC_OCCUR_hsync_phase_offset_mask                       (0x000000FF)
+#define TVD_HSYNC_OCCUR_hsync_rising(data)                            (0x0000FF00&((data)<<8))
+#define TVD_HSYNC_OCCUR_hsync_phase_offset(data)                      (0x000000FF&(data))
+#define TVD_HSYNC_OCCUR_get_hsync_rising(data)                        ((0x0000FF00&(data))>>8)
+#define TVD_HSYNC_OCCUR_get_hsync_phase_offset(data)                  (0x000000FF&(data))
+
+#define TVD_HSYNC_GATE_TIME                                           0x18019038
+#define TVD_HSYNC_GATE_TIME_reg_addr                                  "0xB8019038"
+#define TVD_HSYNC_GATE_TIME_reg                                       0xB8019038
+#define TVD_HSYNC_GATE_TIME_inst_addr                                 "0x000E"
+#define TVD_HSYNC_GATE_TIME_inst                                      0x000E
+#define TVD_HSYNC_GATE_TIME_hsync_gate_start_shift                    (8)
+#define TVD_HSYNC_GATE_TIME_hsync_gate_end_shift                      (0)
+#define TVD_HSYNC_GATE_TIME_hsync_gate_start_mask                     (0x0000FF00)
+#define TVD_HSYNC_GATE_TIME_hsync_gate_end_mask                       (0x000000FF)
+#define TVD_HSYNC_GATE_TIME_hsync_gate_start(data)                    (0x0000FF00&((data)<<8))
+#define TVD_HSYNC_GATE_TIME_hsync_gate_end(data)                      (0x000000FF&(data))
+#define TVD_HSYNC_GATE_TIME_get_hsync_gate_start(data)                ((0x0000FF00&(data))>>8)
+#define TVD_HSYNC_GATE_TIME_get_hsync_gate_end(data)                  (0x000000FF&(data))
+
+#define TVD_HSYNC_TIP_TIME                                            0x1801903C
+#define TVD_HSYNC_TIP_TIME_reg_addr                                   "0xB801903C"
+#define TVD_HSYNC_TIP_TIME_reg                                        0xB801903C
+#define TVD_HSYNC_TIP_TIME_inst_addr                                  "0x000F"
+#define TVD_HSYNC_TIP_TIME_inst                                       0x000F
+#define TVD_HSYNC_TIP_TIME_hsync_tip_start_shift                      (8)
+#define TVD_HSYNC_TIP_TIME_hsync_tip_end_shift                        (0)
+#define TVD_HSYNC_TIP_TIME_hsync_tip_start_mask                       (0x0000FF00)
+#define TVD_HSYNC_TIP_TIME_hsync_tip_end_mask                         (0x000000FF)
+#define TVD_HSYNC_TIP_TIME_hsync_tip_start(data)                      (0x0000FF00&((data)<<8))
+#define TVD_HSYNC_TIP_TIME_hsync_tip_end(data)                        (0x000000FF&(data))
+#define TVD_HSYNC_TIP_TIME_get_hsync_tip_start(data)                  ((0x0000FF00&(data))>>8)
+#define TVD_HSYNC_TIP_TIME_get_hsync_tip_end(data)                    (0x000000FF&(data))
+
+#define TVD_HSYNC_RISING_TIME                                         0x18019040
+#define TVD_HSYNC_RISING_TIME_reg_addr                                "0xB8019040"
+#define TVD_HSYNC_RISING_TIME_reg                                     0xB8019040
+#define TVD_HSYNC_RISING_TIME_inst_addr                               "0x0010"
+#define TVD_HSYNC_RISING_TIME_inst                                    0x0010
+#define TVD_HSYNC_RISING_TIME_hsync_rising_start_shift                (8)
+#define TVD_HSYNC_RISING_TIME_hsync_rising_end_shift                  (0)
+#define TVD_HSYNC_RISING_TIME_hsync_rising_start_mask                 (0x0000FF00)
+#define TVD_HSYNC_RISING_TIME_hsync_rising_end_mask                   (0x000000FF)
+#define TVD_HSYNC_RISING_TIME_hsync_rising_start(data)                (0x0000FF00&((data)<<8))
+#define TVD_HSYNC_RISING_TIME_hsync_rising_end(data)                  (0x000000FF&(data))
+#define TVD_HSYNC_RISING_TIME_get_hsync_rising_start(data)            ((0x0000FF00&(data))>>8)
+#define TVD_HSYNC_RISING_TIME_get_hsync_rising_end(data)              (0x000000FF&(data))
+
+#define TVD_BACKPROCH_TIME                                            0x18019044
+#define TVD_BACKPROCH_TIME_reg_addr                                   "0xB8019044"
+#define TVD_BACKPROCH_TIME_reg                                        0xB8019044
+#define TVD_BACKPROCH_TIME_inst_addr                                  "0x0011"
+#define TVD_BACKPROCH_TIME_inst                                       0x0011
+#define TVD_BACKPROCH_TIME_backporch_start_shift                      (8)
+#define TVD_BACKPROCH_TIME_backporch_end_shift                        (0)
+#define TVD_BACKPROCH_TIME_backporch_start_mask                       (0x0000FF00)
+#define TVD_BACKPROCH_TIME_backporch_end_mask                         (0x000000FF)
+#define TVD_BACKPROCH_TIME_backporch_start(data)                      (0x0000FF00&((data)<<8))
+#define TVD_BACKPROCH_TIME_backporch_end(data)                        (0x000000FF&(data))
+#define TVD_BACKPROCH_TIME_get_backporch_start(data)                  ((0x0000FF00&(data))>>8)
+#define TVD_BACKPROCH_TIME_get_backporch_end(data)                    (0x000000FF&(data))
+
+#define TVD_HBLANK_TIME                                               0x18019048
+#define TVD_HBLANK_TIME_reg_addr                                      "0xB8019048"
+#define TVD_HBLANK_TIME_reg                                           0xB8019048
+#define TVD_HBLANK_TIME_inst_addr                                     "0x0012"
+#define TVD_HBLANK_TIME_inst                                          0x0012
+#define TVD_HBLANK_TIME_hblank_start_shift                            (8)
+#define TVD_HBLANK_TIME_hblank_end_shift                              (0)
+#define TVD_HBLANK_TIME_hblank_start_mask                             (0x0000FF00)
+#define TVD_HBLANK_TIME_hblank_end_mask                               (0x000000FF)
+#define TVD_HBLANK_TIME_hblank_start(data)                            (0x0000FF00&((data)<<8))
+#define TVD_HBLANK_TIME_hblank_end(data)                              (0x000000FF&(data))
+#define TVD_HBLANK_TIME_get_hblank_start(data)                        ((0x0000FF00&(data))>>8)
+#define TVD_HBLANK_TIME_get_hblank_end(data)                          (0x000000FF&(data))
+
+#define TVD_BURST_GATE_TIME                                           0x1801904C
+#define TVD_BURST_GATE_TIME_reg_addr                                  "0xB801904C"
+#define TVD_BURST_GATE_TIME_reg                                       0xB801904C
+#define TVD_BURST_GATE_TIME_inst_addr                                 "0x0013"
+#define TVD_BURST_GATE_TIME_inst                                      0x0013
+#define TVD_BURST_GATE_TIME_burst_gate_start_shift                    (8)
+#define TVD_BURST_GATE_TIME_burst_gate_end_shift                      (0)
+#define TVD_BURST_GATE_TIME_burst_gate_start_mask                     (0x0000FF00)
+#define TVD_BURST_GATE_TIME_burst_gate_end_mask                       (0x000000FF)
+#define TVD_BURST_GATE_TIME_burst_gate_start(data)                    (0x0000FF00&((data)<<8))
+#define TVD_BURST_GATE_TIME_burst_gate_end(data)                      (0x000000FF&(data))
+#define TVD_BURST_GATE_TIME_get_burst_gate_start(data)                ((0x0000FF00&(data))>>8)
+#define TVD_BURST_GATE_TIME_get_burst_gate_end(data)                  (0x000000FF&(data))
+
+#define TVD_HACTIVE_TIME                                              0x18019050
+#define TVD_HACTIVE_TIME_reg_addr                                     "0xB8019050"
+#define TVD_HACTIVE_TIME_reg                                          0xB8019050
+#define TVD_HACTIVE_TIME_inst_addr                                    "0x0014"
+#define TVD_HACTIVE_TIME_inst                                         0x0014
+#define TVD_HACTIVE_TIME_hactive_start_shift                          (8)
+#define TVD_HACTIVE_TIME_hactive_width_shift                          (0)
+#define TVD_HACTIVE_TIME_hactive_start_mask                           (0x0000FF00)
+#define TVD_HACTIVE_TIME_hactive_width_mask                           (0x000000FF)
+#define TVD_HACTIVE_TIME_hactive_start(data)                          (0x0000FF00&((data)<<8))
+#define TVD_HACTIVE_TIME_hactive_width(data)                          (0x000000FF&(data))
+#define TVD_HACTIVE_TIME_get_hactive_start(data)                      ((0x0000FF00&(data))>>8)
+#define TVD_HACTIVE_TIME_get_hactive_width(data)                      (0x000000FF&(data))
+
+#define TVD_VACTIVE_TIME                                              0x18019054
+#define TVD_VACTIVE_TIME_reg_addr                                     "0xB8019054"
+#define TVD_VACTIVE_TIME_reg                                          0xB8019054
+#define TVD_VACTIVE_TIME_inst_addr                                    "0x0015"
+#define TVD_VACTIVE_TIME_inst                                         0x0015
+#define TVD_VACTIVE_TIME_vactive_start_shift                          (8)
+#define TVD_VACTIVE_TIME_vactive_height_shift                         (0)
+#define TVD_VACTIVE_TIME_vactive_start_mask                           (0x0000FF00)
+#define TVD_VACTIVE_TIME_vactive_height_mask                          (0x000000FF)
+#define TVD_VACTIVE_TIME_vactive_start(data)                          (0x0000FF00&((data)<<8))
+#define TVD_VACTIVE_TIME_vactive_height(data)                         (0x000000FF&(data))
+#define TVD_VACTIVE_TIME_get_vactive_start(data)                      ((0x0000FF00&(data))>>8)
+#define TVD_VACTIVE_TIME_get_vactive_height(data)                     (0x000000FF&(data))
+
+#define TVD_VSYNC_H_LOCKOUT                                           0x18019058
+#define TVD_VSYNC_H_LOCKOUT_reg_addr                                  "0xB8019058"
+#define TVD_VSYNC_H_LOCKOUT_reg                                       0xB8019058
+#define TVD_VSYNC_H_LOCKOUT_inst_addr                                 "0x0016"
+#define TVD_VSYNC_H_LOCKOUT_inst                                      0x0016
+#define TVD_VSYNC_H_LOCKOUT_vsync_h_min_shift                         (7)
+#define TVD_VSYNC_H_LOCKOUT_vsync_h_max_shift                         (0)
+#define TVD_VSYNC_H_LOCKOUT_vsync_h_min_mask                          (0x00003F80)
+#define TVD_VSYNC_H_LOCKOUT_vsync_h_max_mask                          (0x0000007F)
+#define TVD_VSYNC_H_LOCKOUT_vsync_h_min(data)                         (0x00003F80&((data)<<7))
+#define TVD_VSYNC_H_LOCKOUT_vsync_h_max(data)                         (0x0000007F&(data))
+#define TVD_VSYNC_H_LOCKOUT_get_vsync_h_min(data)                     ((0x00003F80&(data))>>7)
+#define TVD_VSYNC_H_LOCKOUT_get_vsync_h_max(data)                     (0x0000007F&(data))
+
+#define TVD_VSYNC_AGC_LOCKOUT                                         0x1801905C
+#define TVD_VSYNC_AGC_LOCKOUT_reg_addr                                "0xB801905C"
+#define TVD_VSYNC_AGC_LOCKOUT_reg                                     0xB801905C
+#define TVD_VSYNC_AGC_LOCKOUT_inst_addr                               "0x0017"
+#define TVD_VSYNC_AGC_LOCKOUT_inst                                    0x0017
+#define TVD_VSYNC_AGC_LOCKOUT_vsync_clamp_mode_shift                  (13)
+#define TVD_VSYNC_AGC_LOCKOUT_vsync_agc_min_shift                     (6)
+#define TVD_VSYNC_AGC_LOCKOUT_vsync_agc_max_shift                     (0)
+#define TVD_VSYNC_AGC_LOCKOUT_vsync_clamp_mode_mask                   (0x00006000)
+#define TVD_VSYNC_AGC_LOCKOUT_vsync_agc_min_mask                      (0x00001FC0)
+#define TVD_VSYNC_AGC_LOCKOUT_vsync_agc_max_mask                      (0x0000003F)
+#define TVD_VSYNC_AGC_LOCKOUT_vsync_clamp_mode(data)                  (0x00006000&((data)<<13))
+#define TVD_VSYNC_AGC_LOCKOUT_vsync_agc_min(data)                     (0x00001FC0&((data)<<6))
+#define TVD_VSYNC_AGC_LOCKOUT_vsync_agc_max(data)                     (0x0000003F&(data))
+#define TVD_VSYNC_AGC_LOCKOUT_get_vsync_clamp_mode(data)              ((0x00006000&(data))>>13)
+#define TVD_VSYNC_AGC_LOCKOUT_get_vsync_agc_min(data)                 ((0x00001FC0&(data))>>6)
+#define TVD_VSYNC_AGC_LOCKOUT_get_vsync_agc_max(data)                 (0x0000003F&(data))
+
+#define TVD_VSYNC_VBI_LOCKOUT                                         0x18019060
+#define TVD_VSYNC_VBI_LOCKOUT_reg_addr                                "0xB8019060"
+#define TVD_VSYNC_VBI_LOCKOUT_reg                                     0xB8019060
+#define TVD_VSYNC_VBI_LOCKOUT_inst_addr                               "0x0018"
+#define TVD_VSYNC_VBI_LOCKOUT_inst                                    0x0018
+#define TVD_VSYNC_VBI_LOCKOUT_vlock_wide_range_shift                  (14)
+#define TVD_VSYNC_VBI_LOCKOUT_vsync_vbi_min_shift                     (7)
+#define TVD_VSYNC_VBI_LOCKOUT_vsync_vbi_max_shift                     (0)
+#define TVD_VSYNC_VBI_LOCKOUT_vlock_wide_range_mask                   (0x00004000)
+#define TVD_VSYNC_VBI_LOCKOUT_vsync_vbi_min_mask                      (0x00003F80)
+#define TVD_VSYNC_VBI_LOCKOUT_vsync_vbi_max_mask                      (0x0000007F)
+#define TVD_VSYNC_VBI_LOCKOUT_vlock_wide_range(data)                  (0x00004000&((data)<<14))
+#define TVD_VSYNC_VBI_LOCKOUT_vsync_vbi_min(data)                     (0x00003F80&((data)<<7))
+#define TVD_VSYNC_VBI_LOCKOUT_vsync_vbi_max(data)                     (0x0000007F&(data))
+#define TVD_VSYNC_VBI_LOCKOUT_get_vlock_wide_range(data)              ((0x00004000&(data))>>14)
+#define TVD_VSYNC_VBI_LOCKOUT_get_vsync_vbi_min(data)                 ((0x00003F80&(data))>>7)
+#define TVD_VSYNC_VBI_LOCKOUT_get_vsync_vbi_max(data)                 (0x0000007F&(data))
+
+#define TVD_VSYNC_CTRL                                                0x18019064
+#define TVD_VSYNC_CTRL_reg_addr                                       "0xB8019064"
+#define TVD_VSYNC_CTRL_reg                                            0xB8019064
+#define TVD_VSYNC_CTRL_inst_addr                                      "0x0019"
+#define TVD_VSYNC_CTRL_inst                                           0x0019
+#define TVD_VSYNC_CTRL_write_enable8_shift                            (23)
+#define TVD_VSYNC_CTRL_vsync_cntl_shift                               (21)
+#define TVD_VSYNC_CTRL_write_enable7_shift                            (20)
+#define TVD_VSYNC_CTRL_vsync_threshold_shift                          (14)
+#define TVD_VSYNC_CTRL_write_enable6_shift                            (13)
+#define TVD_VSYNC_CTRL_field_polarity_shift                           (12)
+#define TVD_VSYNC_CTRL_write_enable5_shift                            (11)
+#define TVD_VSYNC_CTRL_flip_field_shift                               (10)
+#define TVD_VSYNC_CTRL_write_enable4_shift                            (9)
+#define TVD_VSYNC_CTRL_veven_delayed_shift                            (8)
+#define TVD_VSYNC_CTRL_write_enable3_shift                            (7)
+#define TVD_VSYNC_CTRL_vodd_delayed_shift                             (6)
+#define TVD_VSYNC_CTRL_write_enable2_shift                            (5)
+#define TVD_VSYNC_CTRL_field_detect_mode_shift                        (3)
+#define TVD_VSYNC_CTRL_write_enable1_shift                            (2)
+#define TVD_VSYNC_CTRL_vloop_tc_shift                                 (0)
+#define TVD_VSYNC_CTRL_write_enable8_mask                             (0x00800000)
+#define TVD_VSYNC_CTRL_vsync_cntl_mask                                (0x00600000)
+#define TVD_VSYNC_CTRL_write_enable7_mask                             (0x00100000)
+#define TVD_VSYNC_CTRL_vsync_threshold_mask                           (0x000FC000)
+#define TVD_VSYNC_CTRL_write_enable6_mask                             (0x00002000)
+#define TVD_VSYNC_CTRL_field_polarity_mask                            (0x00001000)
+#define TVD_VSYNC_CTRL_write_enable5_mask                             (0x00000800)
+#define TVD_VSYNC_CTRL_flip_field_mask                                (0x00000400)
+#define TVD_VSYNC_CTRL_write_enable4_mask                             (0x00000200)
+#define TVD_VSYNC_CTRL_veven_delayed_mask                             (0x00000100)
+#define TVD_VSYNC_CTRL_write_enable3_mask                             (0x00000080)
+#define TVD_VSYNC_CTRL_vodd_delayed_mask                              (0x00000040)
+#define TVD_VSYNC_CTRL_write_enable2_mask                             (0x00000020)
+#define TVD_VSYNC_CTRL_field_detect_mode_mask                         (0x00000018)
+#define TVD_VSYNC_CTRL_write_enable1_mask                             (0x00000004)
+#define TVD_VSYNC_CTRL_vloop_tc_mask                                  (0x00000003)
+#define TVD_VSYNC_CTRL_write_enable8(data)                            (0x00800000&((data)<<23))
+#define TVD_VSYNC_CTRL_vsync_cntl(data)                               (0x00600000&((data)<<21))
+#define TVD_VSYNC_CTRL_write_enable7(data)                            (0x00100000&((data)<<20))
+#define TVD_VSYNC_CTRL_vsync_threshold(data)                          (0x000FC000&((data)<<14))
+#define TVD_VSYNC_CTRL_write_enable6(data)                            (0x00002000&((data)<<13))
+#define TVD_VSYNC_CTRL_field_polarity(data)                           (0x00001000&((data)<<12))
+#define TVD_VSYNC_CTRL_write_enable5(data)                            (0x00000800&((data)<<11))
+#define TVD_VSYNC_CTRL_flip_field(data)                               (0x00000400&((data)<<10))
+#define TVD_VSYNC_CTRL_write_enable4(data)                            (0x00000200&((data)<<9))
+#define TVD_VSYNC_CTRL_veven_delayed(data)                            (0x00000100&((data)<<8))
+#define TVD_VSYNC_CTRL_write_enable3(data)                            (0x00000080&((data)<<7))
+#define TVD_VSYNC_CTRL_vodd_delayed(data)                             (0x00000040&((data)<<6))
+#define TVD_VSYNC_CTRL_write_enable2(data)                            (0x00000020&((data)<<5))
+#define TVD_VSYNC_CTRL_field_detect_mode(data)                        (0x00000018&((data)<<3))
+#define TVD_VSYNC_CTRL_write_enable1(data)                            (0x00000004&((data)<<2))
+#define TVD_VSYNC_CTRL_vloop_tc(data)                                 (0x00000003&(data))
+#define TVD_VSYNC_CTRL_get_write_enable8(data)                        ((0x00800000&(data))>>23)
+#define TVD_VSYNC_CTRL_get_vsync_cntl(data)                           ((0x00600000&(data))>>21)
+#define TVD_VSYNC_CTRL_get_write_enable7(data)                        ((0x00100000&(data))>>20)
+#define TVD_VSYNC_CTRL_get_vsync_threshold(data)                      ((0x000FC000&(data))>>14)
+#define TVD_VSYNC_CTRL_get_write_enable6(data)                        ((0x00002000&(data))>>13)
+#define TVD_VSYNC_CTRL_get_field_polarity(data)                       ((0x00001000&(data))>>12)
+#define TVD_VSYNC_CTRL_get_write_enable5(data)                        ((0x00000800&(data))>>11)
+#define TVD_VSYNC_CTRL_get_flip_field(data)                           ((0x00000400&(data))>>10)
+#define TVD_VSYNC_CTRL_get_write_enable4(data)                        ((0x00000200&(data))>>9)
+#define TVD_VSYNC_CTRL_get_veven_delayed(data)                        ((0x00000100&(data))>>8)
+#define TVD_VSYNC_CTRL_get_write_enable3(data)                        ((0x00000080&(data))>>7)
+#define TVD_VSYNC_CTRL_get_vodd_delayed(data)                         ((0x00000040&(data))>>6)
+#define TVD_VSYNC_CTRL_get_write_enable2(data)                        ((0x00000020&(data))>>5)
+#define TVD_VSYNC_CTRL_get_field_detect_mode(data)                    ((0x00000018&(data))>>3)
+#define TVD_VSYNC_CTRL_get_write_enable1(data)                        ((0x00000004&(data))>>2)
+#define TVD_VSYNC_CTRL_get_vloop_tc(data)                             (0x00000003&(data))
+
+#define TVD_STATUS1                                                   0x18019068
+#define TVD_STATUS1_reg_addr                                          "0xB8019068"
+#define TVD_STATUS1_reg                                               0xB8019068
+#define TVD_STATUS1_inst_addr                                         "0x001A"
+#define TVD_STATUS1_inst                                              0x001A
+#define TVD_STATUS1_mv_colourstripes_shift                            (15)
+#define TVD_STATUS1_mv_vbi_detected_shift                             (14)
+#define TVD_STATUS1_chomalock_shift                                   (13)
+#define TVD_STATUS1_vlock_shift                                       (12)
+#define TVD_STATUS1_hlock_shift                                       (11)
+#define TVD_STATUS1_no_signal_shift                                   (10)
+#define TVD_STATUS1_palm_flag_shift                                   (9)
+#define TVD_STATUS1_proscan_detected_shift                            (8)
+#define TVD_STATUS1_vcr_rew_shift                                     (7)
+#define TVD_STATUS1_vcr_ff_shift                                      (6)
+#define TVD_STATUS1_vcr_trick_shift                                   (5)
+#define TVD_STATUS1_vcr_shift                                         (4)
+#define TVD_STATUS1_noisy_shift                                       (3)
+#define TVD_STATUS1_625lines_detected_shift                           (2)
+#define TVD_STATUS1_secam_detected_shift                              (1)
+#define TVD_STATUS1_pal_detected_shift                                (0)
+#define TVD_STATUS1_mv_colourstripes_mask                             (0x00038000)
+#define TVD_STATUS1_mv_vbi_detected_mask                              (0x00004000)
+#define TVD_STATUS1_chomalock_mask                                    (0x00002000)
+#define TVD_STATUS1_vlock_mask                                        (0x00001000)
+#define TVD_STATUS1_hlock_mask                                        (0x00000800)
+#define TVD_STATUS1_no_signal_mask                                    (0x00000400)
+#define TVD_STATUS1_palm_flag_mask                                    (0x00000200)
+#define TVD_STATUS1_proscan_detected_mask                             (0x00000100)
+#define TVD_STATUS1_vcr_rew_mask                                      (0x00000080)
+#define TVD_STATUS1_vcr_ff_mask                                       (0x00000040)
+#define TVD_STATUS1_vcr_trick_mask                                    (0x00000020)
+#define TVD_STATUS1_vcr_mask                                          (0x00000010)
+#define TVD_STATUS1_noisy_mask                                        (0x00000008)
+#define TVD_STATUS1_625lines_detected_mask                            (0x00000004)
+#define TVD_STATUS1_secam_detected_mask                               (0x00000002)
+#define TVD_STATUS1_pal_detected_mask                                 (0x00000001)
+#define TVD_STATUS1_mv_colourstripes(data)                            (0x00038000&((data)<<15))
+#define TVD_STATUS1_mv_vbi_detected(data)                             (0x00004000&((data)<<14))
+#define TVD_STATUS1_chomalock(data)                                   (0x00002000&((data)<<13))
+#define TVD_STATUS1_vlock(data)                                       (0x00001000&((data)<<12))
+#define TVD_STATUS1_hlock(data)                                       (0x00000800&((data)<<11))
+#define TVD_STATUS1_no_signal(data)                                   (0x00000400&((data)<<10))
+#define TVD_STATUS1_palm_flag(data)                                   (0x00000200&((data)<<9))
+#define TVD_STATUS1_proscan_detected(data)                            (0x00000100&((data)<<8))
+#define TVD_STATUS1_vcr_rew(data)                                     (0x00000080&((data)<<7))
+#define TVD_STATUS1_vcr_ff(data)                                      (0x00000040&((data)<<6))
+#define TVD_STATUS1_vcr_trick(data)                                   (0x00000020&((data)<<5))
+#define TVD_STATUS1_vcr(data)                                         (0x00000010&((data)<<4))
+#define TVD_STATUS1_noisy(data)                                       (0x00000008&((data)<<3))
+#define TVD_STATUS1_625lines_detected(data)                           (0x00000004&((data)<<2))
+#define TVD_STATUS1_secam_detected(data)                              (0x00000002&((data)<<1))
+#define TVD_STATUS1_pal_detected(data)                                (0x00000001&(data))
+#define TVD_STATUS1_get_mv_colourstripes(data)                        ((0x00038000&(data))>>15)
+#define TVD_STATUS1_get_mv_vbi_detected(data)                         ((0x00004000&(data))>>14)
+#define TVD_STATUS1_get_chomalock(data)                               ((0x00002000&(data))>>13)
+#define TVD_STATUS1_get_vlock(data)                                   ((0x00001000&(data))>>12)
+#define TVD_STATUS1_get_hlock(data)                                   ((0x00000800&(data))>>11)
+#define TVD_STATUS1_get_no_signal(data)                               ((0x00000400&(data))>>10)
+#define TVD_STATUS1_get_palm_flag(data)                               ((0x00000200&(data))>>9)
+#define TVD_STATUS1_get_proscan_detected(data)                        ((0x00000100&(data))>>8)
+#define TVD_STATUS1_get_vcr_rew(data)                                 ((0x00000080&(data))>>7)
+#define TVD_STATUS1_get_vcr_ff(data)                                  ((0x00000040&(data))>>6)
+#define TVD_STATUS1_get_vcr_trick(data)                               ((0x00000020&(data))>>5)
+#define TVD_STATUS1_get_vcr(data)                                     ((0x00000010&(data))>>4)
+#define TVD_STATUS1_get_noisy(data)                                   ((0x00000008&(data))>>3)
+#define TVD_STATUS1_get_625lines_detected(data)                       ((0x00000004&(data))>>2)
+#define TVD_STATUS1_get_secam_detected(data)                          ((0x00000002&(data))>>1)
+#define TVD_STATUS1_get_pal_detected(data)                            (0x00000001&(data))
+
+#define TVD_HDTO_STATUS                                               0x1801906C
+#define TVD_HDTO_STATUS_reg_addr                                      "0xB801906C"
+#define TVD_HDTO_STATUS_reg                                           0xB801906C
+#define TVD_HDTO_STATUS_inst_addr                                     "0x001B"
+#define TVD_HDTO_STATUS_inst                                          0x001B
+#define TVD_HDTO_STATUS_status_hdto_inc_shift                         (0)
+#define TVD_HDTO_STATUS_status_hdto_inc_mask                          (0x3FFFFFFF)
+#define TVD_HDTO_STATUS_status_hdto_inc(data)                         (0x3FFFFFFF&(data))
+#define TVD_HDTO_STATUS_get_status_hdto_inc(data)                     (0x3FFFFFFF&(data))
+
+#define TVD_CDTO_STATUS                                               0x18019070
+#define TVD_CDTO_STATUS_reg_addr                                      "0xB8019070"
+#define TVD_CDTO_STATUS_reg                                           0xB8019070
+#define TVD_CDTO_STATUS_inst_addr                                     "0x001C"
+#define TVD_CDTO_STATUS_inst                                          0x001C
+#define TVD_CDTO_STATUS_status_cdto_inc_shift                         (0)
+#define TVD_CDTO_STATUS_status_cdto_inc_mask                          (0x3FFFFFFF)
+#define TVD_CDTO_STATUS_status_cdto_inc(data)                         (0x3FFFFFFF&(data))
+#define TVD_CDTO_STATUS_get_status_cdto_inc(data)                     (0x3FFFFFFF&(data))
+
+#define TVD_CHROMA_STATUS                                             0x18019074
+#define TVD_CHROMA_STATUS_reg_addr                                    "0xB8019074"
+#define TVD_CHROMA_STATUS_reg                                         0xB8019074
+#define TVD_CHROMA_STATUS_inst_addr                                   "0x001D"
+#define TVD_CHROMA_STATUS_inst                                        0x001D
+#define TVD_CHROMA_STATUS_status_cmag_shift                           (14)
+#define TVD_CHROMA_STATUS_status_cgain_shift                          (0)
+#define TVD_CHROMA_STATUS_status_cmag_mask                            (0x003FC000)
+#define TVD_CHROMA_STATUS_status_cgain_mask                           (0x00003FFF)
+#define TVD_CHROMA_STATUS_status_cmag(data)                           (0x003FC000&((data)<<14))
+#define TVD_CHROMA_STATUS_status_cgain(data)                          (0x00003FFF&(data))
+#define TVD_CHROMA_STATUS_get_status_cmag(data)                       ((0x003FC000&(data))>>14)
+#define TVD_CHROMA_STATUS_get_status_cgain(data)                      (0x00003FFF&(data))
+
+#define TVD_STATUS2                                                   0x18019078
+#define TVD_STATUS2_reg_addr                                          "0xB8019078"
+#define TVD_STATUS2_reg                                               0xB8019078
+#define TVD_STATUS2_inst_addr                                         "0x001E"
+#define TVD_STATUS2_inst                                              0x001E
+#define TVD_STATUS2_status_agc_dgain_shift                            (16)
+#define TVD_STATUS2_status_cordiq_freq_shift                          (8)
+#define TVD_STATUS2_status_noise_shift                                (0)
+#define TVD_STATUS2_status_agc_dgain_mask                             (0x00FF0000)
+#define TVD_STATUS2_status_cordiq_freq_mask                           (0x0000FF00)
+#define TVD_STATUS2_status_noise_mask                                 (0x000000FF)
+#define TVD_STATUS2_status_agc_dgain(data)                            (0x00FF0000&((data)<<16))
+#define TVD_STATUS2_status_cordiq_freq(data)                          (0x0000FF00&((data)<<8))
+#define TVD_STATUS2_status_noise(data)                                (0x000000FF&(data))
+#define TVD_STATUS2_get_status_agc_dgain(data)                        ((0x00FF0000&(data))>>16)
+#define TVD_STATUS2_get_status_cordiq_freq(data)                      ((0x0000FF00&(data))>>8)
+#define TVD_STATUS2_get_status_noise(data)                            (0x000000FF&(data))
+
+#define TVD_PEAKING                                                   0x1801907C
+#define TVD_PEAKING_reg_addr                                          "0xB801907C"
+#define TVD_PEAKING_reg                                               0xB801907C
+#define TVD_PEAKING_inst_addr                                         "0x001F"
+#define TVD_PEAKING_inst                                              0x001F
+#define TVD_PEAKING_write_enable3_shift                               (8)
+#define TVD_PEAKING_peak_range_shift                                  (6)
+#define TVD_PEAKING_write_enable2_shift                               (5)
+#define TVD_PEAKING_peak_gain_shift                                   (2)
+#define TVD_PEAKING_write_enable1_shift                               (1)
+#define TVD_PEAKING_peak_en_shift                                     (0)
+#define TVD_PEAKING_write_enable3_mask                                (0x00000100)
+#define TVD_PEAKING_peak_range_mask                                   (0x000000C0)
+#define TVD_PEAKING_write_enable2_mask                                (0x00000020)
+#define TVD_PEAKING_peak_gain_mask                                    (0x0000001C)
+#define TVD_PEAKING_write_enable1_mask                                (0x00000002)
+#define TVD_PEAKING_peak_en_mask                                      (0x00000001)
+#define TVD_PEAKING_write_enable3(data)                               (0x00000100&((data)<<8))
+#define TVD_PEAKING_peak_range(data)                                  (0x000000C0&((data)<<6))
+#define TVD_PEAKING_write_enable2(data)                               (0x00000020&((data)<<5))
+#define TVD_PEAKING_peak_gain(data)                                   (0x0000001C&((data)<<2))
+#define TVD_PEAKING_write_enable1(data)                               (0x00000002&((data)<<1))
+#define TVD_PEAKING_peak_en(data)                                     (0x00000001&(data))
+#define TVD_PEAKING_get_write_enable3(data)                           ((0x00000100&(data))>>8)
+#define TVD_PEAKING_get_peak_range(data)                              ((0x000000C0&(data))>>6)
+#define TVD_PEAKING_get_write_enable2(data)                           ((0x00000020&(data))>>5)
+#define TVD_PEAKING_get_peak_gain(data)                               ((0x0000001C&(data))>>2)
+#define TVD_PEAKING_get_write_enable1(data)                           ((0x00000002&(data))>>1)
+#define TVD_PEAKING_get_peak_en(data)                                 (0x00000001&(data))
+
+#define TVD_COMB_CONFIG                                               0x18019080
+#define TVD_COMB_CONFIG_reg_addr                                      "0xB8019080"
+#define TVD_COMB_CONFIG_reg                                           0xB8019080
+#define TVD_COMB_CONFIG_inst_addr                                     "0x0020"
+#define TVD_COMB_CONFIG_inst                                          0x0020
+#define TVD_COMB_CONFIG_write_enable4_shift                           (8)
+#define TVD_COMB_CONFIG_pal_perr_shift                                (7)
+#define TVD_COMB_CONFIG_write_enable3_shift                           (6)
+#define TVD_COMB_CONFIG_pal_perr_auto_en_shift                        (5)
+#define TVD_COMB_CONFIG_write_enable2_shift                           (4)
+#define TVD_COMB_CONFIG_comb_wide_band_shift                          (3)
+#define TVD_COMB_CONFIG_write_enable1_shift                           (2)
+#define TVD_COMB_CONFIG_palsw_level_shift                             (0)
+#define TVD_COMB_CONFIG_write_enable4_mask                            (0x00000100)
+#define TVD_COMB_CONFIG_pal_perr_mask                                 (0x00000080)
+#define TVD_COMB_CONFIG_write_enable3_mask                            (0x00000040)
+#define TVD_COMB_CONFIG_pal_perr_auto_en_mask                         (0x00000020)
+#define TVD_COMB_CONFIG_write_enable2_mask                            (0x00000010)
+#define TVD_COMB_CONFIG_comb_wide_band_mask                           (0x00000008)
+#define TVD_COMB_CONFIG_write_enable1_mask                            (0x00000004)
+#define TVD_COMB_CONFIG_palsw_level_mask                              (0x00000003)
+#define TVD_COMB_CONFIG_write_enable4(data)                           (0x00000100&((data)<<8))
+#define TVD_COMB_CONFIG_pal_perr(data)                                (0x00000080&((data)<<7))
+#define TVD_COMB_CONFIG_write_enable3(data)                           (0x00000040&((data)<<6))
+#define TVD_COMB_CONFIG_pal_perr_auto_en(data)                        (0x00000020&((data)<<5))
+#define TVD_COMB_CONFIG_write_enable2(data)                           (0x00000010&((data)<<4))
+#define TVD_COMB_CONFIG_comb_wide_band(data)                          (0x00000008&((data)<<3))
+#define TVD_COMB_CONFIG_write_enable1(data)                           (0x00000004&((data)<<2))
+#define TVD_COMB_CONFIG_palsw_level(data)                             (0x00000003&(data))
+#define TVD_COMB_CONFIG_get_write_enable4(data)                       ((0x00000100&(data))>>8)
+#define TVD_COMB_CONFIG_get_pal_perr(data)                            ((0x00000080&(data))>>7)
+#define TVD_COMB_CONFIG_get_write_enable3(data)                       ((0x00000040&(data))>>6)
+#define TVD_COMB_CONFIG_get_pal_perr_auto_en(data)                    ((0x00000020&(data))>>5)
+#define TVD_COMB_CONFIG_get_write_enable2(data)                       ((0x00000010&(data))>>4)
+#define TVD_COMB_CONFIG_get_comb_wide_band(data)                      ((0x00000008&(data))>>3)
+#define TVD_COMB_CONFIG_get_write_enable1(data)                       ((0x00000004&(data))>>2)
+#define TVD_COMB_CONFIG_get_palsw_level(data)                         (0x00000003&(data))
+
+#define TVD_CHROMA_LOCK                                               0x18019084
+#define TVD_CHROMA_LOCK_reg_addr                                      "0xB8019084"
+#define TVD_CHROMA_LOCK_reg                                           0xB8019084
+#define TVD_CHROMA_LOCK_inst_addr                                     "0x0021"
+#define TVD_CHROMA_LOCK_inst                                          0x0021
+#define TVD_CHROMA_LOCK_write_enable3_shift                           (10)
+#define TVD_CHROMA_LOCK_lose_chromalock_count_shift                   (6)
+#define TVD_CHROMA_LOCK_write_enable2_shift                           (5)
+#define TVD_CHROMA_LOCK_lose_chromalock_level_shift                   (2)
+#define TVD_CHROMA_LOCK_write_enable1_shift                           (1)
+#define TVD_CHROMA_LOCK_lose_chromalock_ckill_shift                   (0)
+#define TVD_CHROMA_LOCK_write_enable3_mask                            (0x00000400)
+#define TVD_CHROMA_LOCK_lose_chromalock_count_mask                    (0x000003C0)
+#define TVD_CHROMA_LOCK_write_enable2_mask                            (0x00000020)
+#define TVD_CHROMA_LOCK_lose_chromalock_level_mask                    (0x0000001C)
+#define TVD_CHROMA_LOCK_write_enable1_mask                            (0x00000002)
+#define TVD_CHROMA_LOCK_lose_chromalock_ckill_mask                    (0x00000001)
+#define TVD_CHROMA_LOCK_write_enable3(data)                           (0x00000400&((data)<<10))
+#define TVD_CHROMA_LOCK_lose_chromalock_count(data)                   (0x000003C0&((data)<<6))
+#define TVD_CHROMA_LOCK_write_enable2(data)                           (0x00000020&((data)<<5))
+#define TVD_CHROMA_LOCK_lose_chromalock_level(data)                   (0x0000001C&((data)<<2))
+#define TVD_CHROMA_LOCK_write_enable1(data)                           (0x00000002&((data)<<1))
+#define TVD_CHROMA_LOCK_lose_chromalock_ckill(data)                   (0x00000001&(data))
+#define TVD_CHROMA_LOCK_get_write_enable3(data)                       ((0x00000400&(data))>>10)
+#define TVD_CHROMA_LOCK_get_lose_chromalock_count(data)               ((0x000003C0&(data))>>6)
+#define TVD_CHROMA_LOCK_get_write_enable2(data)                       ((0x00000020&(data))>>5)
+#define TVD_CHROMA_LOCK_get_lose_chromalock_level(data)               ((0x0000001C&(data))>>2)
+#define TVD_CHROMA_LOCK_get_write_enable1(data)                       ((0x00000002&(data))>>1)
+#define TVD_CHROMA_LOCK_get_lose_chromalock_ckill(data)               (0x00000001&(data))
+
+#define TVD_COMB_THD                                                  0x18019088
+#define TVD_COMB_THD_reg_addr                                         "0xB8019088"
+#define TVD_COMB_THD_reg                                              0xB8019088
+#define TVD_COMB_THD_inst_addr                                        "0x0022"
+#define TVD_COMB_THD_inst                                             0x0022
+#define TVD_COMB_THD_noise_ntsc_c_shift                               (24)
+#define TVD_COMB_THD_noise_pal_c_shift                                (16)
+#define TVD_COMB_THD_noise_phase_c_shift                              (8)
+#define TVD_COMB_THD_noise_phase_y_shift                              (0)
+#define TVD_COMB_THD_noise_ntsc_c_mask                                (0xFF000000)
+#define TVD_COMB_THD_noise_pal_c_mask                                 (0x00FF0000)
+#define TVD_COMB_THD_noise_phase_c_mask                               (0x0000FF00)
+#define TVD_COMB_THD_noise_phase_y_mask                               (0x000000FF)
+#define TVD_COMB_THD_noise_ntsc_c(data)                               (0xFF000000&((data)<<24))
+#define TVD_COMB_THD_noise_pal_c(data)                                (0x00FF0000&((data)<<16))
+#define TVD_COMB_THD_noise_phase_c(data)                              (0x0000FF00&((data)<<8))
+#define TVD_COMB_THD_noise_phase_y(data)                              (0x000000FF&(data))
+#define TVD_COMB_THD_get_noise_ntsc_c(data)                           ((0xFF000000&(data))>>24)
+#define TVD_COMB_THD_get_noise_pal_c(data)                            ((0x00FF0000&(data))>>16)
+#define TVD_COMB_THD_get_noise_phase_c(data)                          ((0x0000FF00&(data))>>8)
+#define TVD_COMB_THD_get_noise_phase_y(data)                          (0x000000FF&(data))
+
+#define TVD_CHROMA_LPFILTER                                           0x1801908C
+#define TVD_CHROMA_LPFILTER_reg_addr                                  "0xB801908C"
+#define TVD_CHROMA_LPFILTER_reg                                       0xB801908C
+#define TVD_CHROMA_LPFILTER_inst_addr                                 "0x0023"
+#define TVD_CHROMA_LPFILTER_inst                                      0x0023
+#define TVD_CHROMA_LPFILTER_cstate_shift                              (1)
+#define TVD_CHROMA_LPFILTER_fixed_cstat_shift                         (0)
+#define TVD_CHROMA_LPFILTER_cstate_mask                               (0x0000000E)
+#define TVD_CHROMA_LPFILTER_fixed_cstat_mask                          (0x00000001)
+#define TVD_CHROMA_LPFILTER_cstate(data)                              (0x0000000E&((data)<<1))
+#define TVD_CHROMA_LPFILTER_fixed_cstat(data)                         (0x00000001&(data))
+#define TVD_CHROMA_LPFILTER_get_cstate(data)                          ((0x0000000E&(data))>>1)
+#define TVD_CHROMA_LPFILTER_get_fixed_cstat(data)                     (0x00000001&(data))
+
+#define TVD_HRESAMPLE                                                 0x18019090
+#define TVD_HRESAMPLE_reg_addr                                        "0xB8019090"
+#define TVD_HRESAMPLE_reg                                             0xB8019090
+#define TVD_HRESAMPLE_inst_addr                                       "0x0024"
+#define TVD_HRESAMPLE_inst                                            0x0024
+#define TVD_HRESAMPLE_hresampler_2up_shift                            (0)
+#define TVD_HRESAMPLE_hresampler_2up_mask                             (0x00000001)
+#define TVD_HRESAMPLE_hresampler_2up(data)                            (0x00000001&(data))
+#define TVD_HRESAMPLE_get_hresampler_2up(data)                        (0x00000001&(data))
+
+#define TVD_CHG_PUMP_DLY                                              0x18019094
+#define TVD_CHG_PUMP_DLY_reg_addr                                     "0xB8019094"
+#define TVD_CHG_PUMP_DLY_reg                                          0xB8019094
+#define TVD_CHG_PUMP_DLY_inst_addr                                    "0x0025"
+#define TVD_CHG_PUMP_DLY_inst                                         0x0025
+#define TVD_CHG_PUMP_DLY_write_enable5_shift                          (28)
+#define TVD_CHG_PUMP_DLY_cpump_adjust_delay_shift                     (22)
+#define TVD_CHG_PUMP_DLY_write_enable4_shift                          (21)
+#define TVD_CHG_PUMP_DLY_cpump_adjust_polarity_shift                  (20)
+#define TVD_CHG_PUMP_DLY_write_enable3_shift                          (19)
+#define TVD_CHG_PUMP_DLY_cpump_delay_en_shift                         (18)
+#define TVD_CHG_PUMP_DLY_write_enable2_shift                          (17)
+#define TVD_CHG_PUMP_DLY_cpump_adjust_shift                           (9)
+#define TVD_CHG_PUMP_DLY_write_enable1_shift                          (8)
+#define TVD_CHG_PUMP_DLY_cpump_delay_shift                            (0)
+#define TVD_CHG_PUMP_DLY_write_enable5_mask                           (0x10000000)
+#define TVD_CHG_PUMP_DLY_cpump_adjust_delay_mask                      (0x0FC00000)
+#define TVD_CHG_PUMP_DLY_write_enable4_mask                           (0x00200000)
+#define TVD_CHG_PUMP_DLY_cpump_adjust_polarity_mask                   (0x00100000)
+#define TVD_CHG_PUMP_DLY_write_enable3_mask                           (0x00080000)
+#define TVD_CHG_PUMP_DLY_cpump_delay_en_mask                          (0x00040000)
+#define TVD_CHG_PUMP_DLY_write_enable2_mask                           (0x00020000)
+#define TVD_CHG_PUMP_DLY_cpump_adjust_mask                            (0x0001FE00)
+#define TVD_CHG_PUMP_DLY_write_enable1_mask                           (0x00000100)
+#define TVD_CHG_PUMP_DLY_cpump_delay_mask                             (0x000000FF)
+#define TVD_CHG_PUMP_DLY_write_enable5(data)                          (0x10000000&((data)<<28))
+#define TVD_CHG_PUMP_DLY_cpump_adjust_delay(data)                     (0x0FC00000&((data)<<22))
+#define TVD_CHG_PUMP_DLY_write_enable4(data)                          (0x00200000&((data)<<21))
+#define TVD_CHG_PUMP_DLY_cpump_adjust_polarity(data)                  (0x00100000&((data)<<20))
+#define TVD_CHG_PUMP_DLY_write_enable3(data)                          (0x00080000&((data)<<19))
+#define TVD_CHG_PUMP_DLY_cpump_delay_en(data)                         (0x00040000&((data)<<18))
+#define TVD_CHG_PUMP_DLY_write_enable2(data)                          (0x00020000&((data)<<17))
+#define TVD_CHG_PUMP_DLY_cpump_adjust(data)                           (0x0001FE00&((data)<<9))
+#define TVD_CHG_PUMP_DLY_write_enable1(data)                          (0x00000100&((data)<<8))
+#define TVD_CHG_PUMP_DLY_cpump_delay(data)                            (0x000000FF&(data))
+#define TVD_CHG_PUMP_DLY_get_write_enable5(data)                      ((0x10000000&(data))>>28)
+#define TVD_CHG_PUMP_DLY_get_cpump_adjust_delay(data)                 ((0x0FC00000&(data))>>22)
+#define TVD_CHG_PUMP_DLY_get_write_enable4(data)                      ((0x00200000&(data))>>21)
+#define TVD_CHG_PUMP_DLY_get_cpump_adjust_polarity(data)              ((0x00100000&(data))>>20)
+#define TVD_CHG_PUMP_DLY_get_write_enable3(data)                      ((0x00080000&(data))>>19)
+#define TVD_CHG_PUMP_DLY_get_cpump_delay_en(data)                     ((0x00040000&(data))>>18)
+#define TVD_CHG_PUMP_DLY_get_write_enable2(data)                      ((0x00020000&(data))>>17)
+#define TVD_CHG_PUMP_DLY_get_cpump_adjust(data)                       ((0x0001FE00&(data))>>9)
+#define TVD_CHG_PUMP_DLY_get_write_enable1(data)                      ((0x00000100&(data))>>8)
+#define TVD_CHG_PUMP_DLY_get_cpump_delay(data)                        (0x000000FF&(data))
+
+#define TVD_3DYC_SEP_CTRL                                             0x18019098
+#define TVD_3DYC_SEP_CTRL_reg_addr                                    "0xB8019098"
+#define TVD_3DYC_SEP_CTRL_reg                                         0xB8019098
+#define TVD_3DYC_SEP_CTRL_inst_addr                                   "0x0026"
+#define TVD_3DYC_SEP_CTRL_inst                                        0x0026
+#define TVD_3DYC_SEP_CTRL_write_enable11_shift                        (29)
+#define TVD_3DYC_SEP_CTRL_debug_mode_shift                            (28)
+#define TVD_3DYC_SEP_CTRL_write_enable10_shift                        (27)
+#define TVD_3DYC_SEP_CTRL_debug_enable_shift                          (26)
+#define TVD_3DYC_SEP_CTRL_write_enable9_shift                         (25)
+#define TVD_3DYC_SEP_CTRL_memory_size_shift                           (23)
+#define TVD_3DYC_SEP_CTRL_write_enable8_shift                         (22)
+#define TVD_3DYC_SEP_CTRL_ntscpal_select_shift                        (21)
+#define TVD_3DYC_SEP_CTRL_write_enable7_shift                         (20)
+#define TVD_3DYC_SEP_CTRL_yc_separation_control_shift                 (17)
+#define TVD_3DYC_SEP_CTRL_write_enable6_shift                         (16)
+#define TVD_3DYC_SEP_CTRL_chroma_vlpf_en_shift                        (15)
+#define TVD_3DYC_SEP_CTRL_write_enable5_shift                         (14)
+#define TVD_3DYC_SEP_CTRL_bpf_bw_sel_shift                            (11)
+#define TVD_3DYC_SEP_CTRL_write_enable4_shift                         (10)
+#define TVD_3DYC_SEP_CTRL_vcr3d2d_shift                               (9)
+#define TVD_3DYC_SEP_CTRL_write_enable3_shift                         (8)
+#define TVD_3DYC_SEP_CTRL_noisy3d2d_shift                             (7)
+#define TVD_3DYC_SEP_CTRL_write_enable2_shift                         (6)
+#define TVD_3DYC_SEP_CTRL_field_toggle_en_shift                       (5)
+#define TVD_3DYC_SEP_CTRL_write_enable1_shift                         (4)
+#define TVD_3DYC_SEP_CTRL_debug_tree_monitor_shift                    (0)
+#define TVD_3DYC_SEP_CTRL_write_enable11_mask                         (0x20000000)
+#define TVD_3DYC_SEP_CTRL_debug_mode_mask                             (0x10000000)
+#define TVD_3DYC_SEP_CTRL_write_enable10_mask                         (0x08000000)
+#define TVD_3DYC_SEP_CTRL_debug_enable_mask                           (0x04000000)
+#define TVD_3DYC_SEP_CTRL_write_enable9_mask                          (0x02000000)
+#define TVD_3DYC_SEP_CTRL_memory_size_mask                            (0x01800000)
+#define TVD_3DYC_SEP_CTRL_write_enable8_mask                          (0x00400000)
+#define TVD_3DYC_SEP_CTRL_ntscpal_select_mask                         (0x00200000)
+#define TVD_3DYC_SEP_CTRL_write_enable7_mask                          (0x00100000)
+#define TVD_3DYC_SEP_CTRL_yc_separation_control_mask                  (0x000E0000)
+#define TVD_3DYC_SEP_CTRL_write_enable6_mask                          (0x00010000)
+#define TVD_3DYC_SEP_CTRL_chroma_vlpf_en_mask                         (0x00008000)
+#define TVD_3DYC_SEP_CTRL_write_enable5_mask                          (0x00004000)
+#define TVD_3DYC_SEP_CTRL_bpf_bw_sel_mask                             (0x00003800)
+#define TVD_3DYC_SEP_CTRL_write_enable4_mask                          (0x00000400)
+#define TVD_3DYC_SEP_CTRL_vcr3d2d_mask                                (0x00000200)
+#define TVD_3DYC_SEP_CTRL_write_enable3_mask                          (0x00000100)
+#define TVD_3DYC_SEP_CTRL_noisy3d2d_mask                              (0x00000080)
+#define TVD_3DYC_SEP_CTRL_write_enable2_mask                          (0x00000040)
+#define TVD_3DYC_SEP_CTRL_field_toggle_en_mask                        (0x00000020)
+#define TVD_3DYC_SEP_CTRL_write_enable1_mask                          (0x00000010)
+#define TVD_3DYC_SEP_CTRL_debug_tree_monitor_mask                     (0x0000000F)
+#define TVD_3DYC_SEP_CTRL_write_enable11(data)                        (0x20000000&((data)<<29))
+#define TVD_3DYC_SEP_CTRL_debug_mode(data)                            (0x10000000&((data)<<28))
+#define TVD_3DYC_SEP_CTRL_write_enable10(data)                        (0x08000000&((data)<<27))
+#define TVD_3DYC_SEP_CTRL_debug_enable(data)                          (0x04000000&((data)<<26))
+#define TVD_3DYC_SEP_CTRL_write_enable9(data)                         (0x02000000&((data)<<25))
+#define TVD_3DYC_SEP_CTRL_memory_size(data)                           (0x01800000&((data)<<23))
+#define TVD_3DYC_SEP_CTRL_write_enable8(data)                         (0x00400000&((data)<<22))
+#define TVD_3DYC_SEP_CTRL_ntscpal_select(data)                        (0x00200000&((data)<<21))
+#define TVD_3DYC_SEP_CTRL_write_enable7(data)                         (0x00100000&((data)<<20))
+#define TVD_3DYC_SEP_CTRL_yc_separation_control(data)                 (0x000E0000&((data)<<17))
+#define TVD_3DYC_SEP_CTRL_write_enable6(data)                         (0x00010000&((data)<<16))
+#define TVD_3DYC_SEP_CTRL_chroma_vlpf_en(data)                        (0x00008000&((data)<<15))
+#define TVD_3DYC_SEP_CTRL_write_enable5(data)                         (0x00004000&((data)<<14))
+#define TVD_3DYC_SEP_CTRL_bpf_bw_sel(data)                            (0x00003800&((data)<<11))
+#define TVD_3DYC_SEP_CTRL_write_enable4(data)                         (0x00000400&((data)<<10))
+#define TVD_3DYC_SEP_CTRL_vcr3d2d(data)                               (0x00000200&((data)<<9))
+#define TVD_3DYC_SEP_CTRL_write_enable3(data)                         (0x00000100&((data)<<8))
+#define TVD_3DYC_SEP_CTRL_noisy3d2d(data)                             (0x00000080&((data)<<7))
+#define TVD_3DYC_SEP_CTRL_write_enable2(data)                         (0x00000040&((data)<<6))
+#define TVD_3DYC_SEP_CTRL_field_toggle_en(data)                       (0x00000020&((data)<<5))
+#define TVD_3DYC_SEP_CTRL_write_enable1(data)                         (0x00000010&((data)<<4))
+#define TVD_3DYC_SEP_CTRL_debug_tree_monitor(data)                    (0x0000000F&(data))
+#define TVD_3DYC_SEP_CTRL_get_write_enable11(data)                    ((0x20000000&(data))>>29)
+#define TVD_3DYC_SEP_CTRL_get_debug_mode(data)                        ((0x10000000&(data))>>28)
+#define TVD_3DYC_SEP_CTRL_get_write_enable10(data)                    ((0x08000000&(data))>>27)
+#define TVD_3DYC_SEP_CTRL_get_debug_enable(data)                      ((0x04000000&(data))>>26)
+#define TVD_3DYC_SEP_CTRL_get_write_enable9(data)                     ((0x02000000&(data))>>25)
+#define TVD_3DYC_SEP_CTRL_get_memory_size(data)                       ((0x01800000&(data))>>23)
+#define TVD_3DYC_SEP_CTRL_get_write_enable8(data)                     ((0x00400000&(data))>>22)
+#define TVD_3DYC_SEP_CTRL_get_ntscpal_select(data)                    ((0x00200000&(data))>>21)
+#define TVD_3DYC_SEP_CTRL_get_write_enable7(data)                     ((0x00100000&(data))>>20)
+#define TVD_3DYC_SEP_CTRL_get_yc_separation_control(data)             ((0x000E0000&(data))>>17)
+#define TVD_3DYC_SEP_CTRL_get_write_enable6(data)                     ((0x00010000&(data))>>16)
+#define TVD_3DYC_SEP_CTRL_get_chroma_vlpf_en(data)                    ((0x00008000&(data))>>15)
+#define TVD_3DYC_SEP_CTRL_get_write_enable5(data)                     ((0x00004000&(data))>>14)
+#define TVD_3DYC_SEP_CTRL_get_bpf_bw_sel(data)                        ((0x00003800&(data))>>11)
+#define TVD_3DYC_SEP_CTRL_get_write_enable4(data)                     ((0x00000400&(data))>>10)
+#define TVD_3DYC_SEP_CTRL_get_vcr3d2d(data)                           ((0x00000200&(data))>>9)
+#define TVD_3DYC_SEP_CTRL_get_write_enable3(data)                     ((0x00000100&(data))>>8)
+#define TVD_3DYC_SEP_CTRL_get_noisy3d2d(data)                         ((0x00000080&(data))>>7)
+#define TVD_3DYC_SEP_CTRL_get_write_enable2(data)                     ((0x00000040&(data))>>6)
+#define TVD_3DYC_SEP_CTRL_get_field_toggle_en(data)                   ((0x00000020&(data))>>5)
+#define TVD_3DYC_SEP_CTRL_get_write_enable1(data)                     ((0x00000010&(data))>>4)
+#define TVD_3DYC_SEP_CTRL_get_debug_tree_monitor(data)                (0x0000000F&(data))
+
+#define TVD_3DTHD1                                                    0x1801909C
+#define TVD_3DTHD1_reg_addr                                           "0xB801909C"
+#define TVD_3DTHD1_reg                                                0xB801909C
+#define TVD_3DTHD1_inst_addr                                          "0x0027"
+#define TVD_3DTHD1_inst                                               0x0027
+#define TVD_3DTHD1_md_y_lo_diff_thresh1_shift                         (23)
+#define TVD_3DTHD1_check_mdt_en_shift                                 (22)
+#define TVD_3DTHD1_md_y_lo_diff_thresh2_shift                         (16)
+#define TVD_3DTHD1_md_mesh_det_thresh1_shift                          (12)
+#define TVD_3DTHD1_md_mesh_c_large_thresh_shift                       (8)
+#define TVD_3DTHD1_md_frame_close_chk_enable_shift                    (7)
+#define TVD_3DTHD1_md_mesh_det_thresh2_shift                          (3)
+#define TVD_3DTHD1_md_mesh_det_cnt_thresh_shift                       (0)
+#define TVD_3DTHD1_md_y_lo_diff_thresh1_mask                          (0x07800000)
+#define TVD_3DTHD1_check_mdt_en_mask                                  (0x00400000)
+#define TVD_3DTHD1_md_y_lo_diff_thresh2_mask                          (0x003F0000)
+#define TVD_3DTHD1_md_mesh_det_thresh1_mask                           (0x0000F000)
+#define TVD_3DTHD1_md_mesh_c_large_thresh_mask                        (0x00000F00)
+#define TVD_3DTHD1_md_frame_close_chk_enable_mask                     (0x00000080)
+#define TVD_3DTHD1_md_mesh_det_thresh2_mask                           (0x00000078)
+#define TVD_3DTHD1_md_mesh_det_cnt_thresh_mask                        (0x00000007)
+#define TVD_3DTHD1_md_y_lo_diff_thresh1(data)                         (0x07800000&((data)<<23))
+#define TVD_3DTHD1_check_mdt_en(data)                                 (0x00400000&((data)<<22))
+#define TVD_3DTHD1_md_y_lo_diff_thresh2(data)                         (0x003F0000&((data)<<16))
+#define TVD_3DTHD1_md_mesh_det_thresh1(data)                          (0x0000F000&((data)<<12))
+#define TVD_3DTHD1_md_mesh_c_large_thresh(data)                       (0x00000F00&((data)<<8))
+#define TVD_3DTHD1_md_frame_close_chk_enable(data)                    (0x00000080&((data)<<7))
+#define TVD_3DTHD1_md_mesh_det_thresh2(data)                          (0x00000078&((data)<<3))
+#define TVD_3DTHD1_md_mesh_det_cnt_thresh(data)                       (0x00000007&(data))
+#define TVD_3DTHD1_get_md_y_lo_diff_thresh1(data)                     ((0x07800000&(data))>>23)
+#define TVD_3DTHD1_get_check_mdt_en(data)                             ((0x00400000&(data))>>22)
+#define TVD_3DTHD1_get_md_y_lo_diff_thresh2(data)                     ((0x003F0000&(data))>>16)
+#define TVD_3DTHD1_get_md_mesh_det_thresh1(data)                      ((0x0000F000&(data))>>12)
+#define TVD_3DTHD1_get_md_mesh_c_large_thresh(data)                   ((0x00000F00&(data))>>8)
+#define TVD_3DTHD1_get_md_frame_close_chk_enable(data)                ((0x00000080&(data))>>7)
+#define TVD_3DTHD1_get_md_mesh_det_thresh2(data)                      ((0x00000078&(data))>>3)
+#define TVD_3DTHD1_get_md_mesh_det_cnt_thresh(data)                   (0x00000007&(data))
+
+#define TVD_3DTHD2                                                    0x180190A0
+#define TVD_3DTHD2_reg_addr                                           "0xB80190A0"
+#define TVD_3DTHD2_reg                                                0xB80190A0
+#define TVD_3DTHD2_inst_addr                                          "0x0028"
+#define TVD_3DTHD2_inst                                               0x0028
+#define TVD_3DTHD2_md_chk_mesh_thresh_shift                           (17)
+#define TVD_3DTHD2_md_y_lo_line_diff_thresh_shift                     (13)
+#define TVD_3DTHD2_md_chk_three_line_c_thresh1_shift                  (10)
+#define TVD_3DTHD2_md_c_detect_thresh_shift                           (6)
+#define TVD_3DTHD2_md_orig_diff_thresh_shift                          (0)
+#define TVD_3DTHD2_md_chk_mesh_thresh_mask                            (0x00060000)
+#define TVD_3DTHD2_md_y_lo_line_diff_thresh_mask                      (0x0001E000)
+#define TVD_3DTHD2_md_chk_three_line_c_thresh1_mask                   (0x00001C00)
+#define TVD_3DTHD2_md_c_detect_thresh_mask                            (0x000003C0)
+#define TVD_3DTHD2_md_orig_diff_thresh_mask                           (0x0000003F)
+#define TVD_3DTHD2_md_chk_mesh_thresh(data)                           (0x00060000&((data)<<17))
+#define TVD_3DTHD2_md_y_lo_line_diff_thresh(data)                     (0x0001E000&((data)<<13))
+#define TVD_3DTHD2_md_chk_three_line_c_thresh1(data)                  (0x00001C00&((data)<<10))
+#define TVD_3DTHD2_md_c_detect_thresh(data)                           (0x000003C0&((data)<<6))
+#define TVD_3DTHD2_md_orig_diff_thresh(data)                          (0x0000003F&(data))
+#define TVD_3DTHD2_get_md_chk_mesh_thresh(data)                       ((0x00060000&(data))>>17)
+#define TVD_3DTHD2_get_md_y_lo_line_diff_thresh(data)                 ((0x0001E000&(data))>>13)
+#define TVD_3DTHD2_get_md_chk_three_line_c_thresh1(data)              ((0x00001C00&(data))>>10)
+#define TVD_3DTHD2_get_md_c_detect_thresh(data)                       ((0x000003C0&(data))>>6)
+#define TVD_3DTHD2_get_md_orig_diff_thresh(data)                      (0x0000003F&(data))
+
+#define TVD_3DTHD3                                                    0x180190A4
+#define TVD_3DTHD3_reg_addr                                           "0xB80190A4"
+#define TVD_3DTHD3_reg                                                0xB80190A4
+#define TVD_3DTHD3_inst_addr                                          "0x0029"
+#define TVD_3DTHD3_inst                                               0x0029
+#define TVD_3DTHD3_md_line_close_thresh_shift                         (20)
+#define TVD_3DTHD3_md_c_near_2d_3d_thresh_shift                       (16)
+#define TVD_3DTHD3_md_chk_three_line_c_thresh2_shift                  (13)
+#define TVD_3DTHD3_md_line_compare_thresh1_shift                      (8)
+#define TVD_3DTHD3_md_chk_angle_c_thresh_shift                        (5)
+#define TVD_3DTHD3_md_line_compare_thresh2_shift                      (0)
+#define TVD_3DTHD3_md_line_close_thresh_mask                          (0x00F00000)
+#define TVD_3DTHD3_md_c_near_2d_3d_thresh_mask                        (0x000F0000)
+#define TVD_3DTHD3_md_chk_three_line_c_thresh2_mask                   (0x0000E000)
+#define TVD_3DTHD3_md_line_compare_thresh1_mask                       (0x00001F00)
+#define TVD_3DTHD3_md_chk_angle_c_thresh_mask                         (0x000000E0)
+#define TVD_3DTHD3_md_line_compare_thresh2_mask                       (0x0000001F)
+#define TVD_3DTHD3_md_line_close_thresh(data)                         (0x00F00000&((data)<<20))
+#define TVD_3DTHD3_md_c_near_2d_3d_thresh(data)                       (0x000F0000&((data)<<16))
+#define TVD_3DTHD3_md_chk_three_line_c_thresh2(data)                  (0x0000E000&((data)<<13))
+#define TVD_3DTHD3_md_line_compare_thresh1(data)                      (0x00001F00&((data)<<8))
+#define TVD_3DTHD3_md_chk_angle_c_thresh(data)                        (0x000000E0&((data)<<5))
+#define TVD_3DTHD3_md_line_compare_thresh2(data)                      (0x0000001F&(data))
+#define TVD_3DTHD3_get_md_line_close_thresh(data)                     ((0x00F00000&(data))>>20)
+#define TVD_3DTHD3_get_md_c_near_2d_3d_thresh(data)                   ((0x000F0000&(data))>>16)
+#define TVD_3DTHD3_get_md_chk_three_line_c_thresh2(data)              ((0x0000E000&(data))>>13)
+#define TVD_3DTHD3_get_md_line_compare_thresh1(data)                  ((0x00001F00&(data))>>8)
+#define TVD_3DTHD3_get_md_chk_angle_c_thresh(data)                    ((0x000000E0&(data))>>5)
+#define TVD_3DTHD3_get_md_line_compare_thresh2(data)                  (0x0000001F&(data))
+
+#define TVD_3DTHD4                                                    0x180190A8
+#define TVD_3DTHD4_reg_addr                                           "0xB80190A8"
+#define TVD_3DTHD4_reg                                                0xB80190A8
+#define TVD_3DTHD4_inst_addr                                          "0x002A"
+#define TVD_3DTHD4_inst                                               0x002A
+#define TVD_3DTHD4_md_c_3d_large_thresh1_shift                        (19)
+#define TVD_3DTHD4_md_c_3d_large_thresh2_shift                        (15)
+#define TVD_3DTHD4_md_cross_c_suppress_enable_shift                   (14)
+#define TVD_3DTHD4_md_c_edge_thresh1_shift                            (7)
+#define TVD_3DTHD4_md_c_edge_thresh2_shift                            (0)
+#define TVD_3DTHD4_md_c_3d_large_thresh1_mask                         (0x00780000)
+#define TVD_3DTHD4_md_c_3d_large_thresh2_mask                         (0x00078000)
+#define TVD_3DTHD4_md_cross_c_suppress_enable_mask                    (0x00004000)
+#define TVD_3DTHD4_md_c_edge_thresh1_mask                             (0x00003F80)
+#define TVD_3DTHD4_md_c_edge_thresh2_mask                             (0x0000007F)
+#define TVD_3DTHD4_md_c_3d_large_thresh1(data)                        (0x00780000&((data)<<19))
+#define TVD_3DTHD4_md_c_3d_large_thresh2(data)                        (0x00078000&((data)<<15))
+#define TVD_3DTHD4_md_cross_c_suppress_enable(data)                   (0x00004000&((data)<<14))
+#define TVD_3DTHD4_md_c_edge_thresh1(data)                            (0x00003F80&((data)<<7))
+#define TVD_3DTHD4_md_c_edge_thresh2(data)                            (0x0000007F&(data))
+#define TVD_3DTHD4_get_md_c_3d_large_thresh1(data)                    ((0x00780000&(data))>>19)
+#define TVD_3DTHD4_get_md_c_3d_large_thresh2(data)                    ((0x00078000&(data))>>15)
+#define TVD_3DTHD4_get_md_cross_c_suppress_enable(data)               ((0x00004000&(data))>>14)
+#define TVD_3DTHD4_get_md_c_edge_thresh1(data)                        ((0x00003F80&(data))>>7)
+#define TVD_3DTHD4_get_md_c_edge_thresh2(data)                        (0x0000007F&(data))
+
+#define TVD_SLICER_CTRL                                               0x180190AC
+#define TVD_SLICER_CTRL_reg_addr                                      "0xB80190AC"
+#define TVD_SLICER_CTRL_reg                                           0xB80190AC
+#define TVD_SLICER_CTRL_inst_addr                                     "0x002B"
+#define TVD_SLICER_CTRL_inst                                          0x002B
+#define TVD_SLICER_CTRL_write_enable6_shift                           (18)
+#define TVD_SLICER_CTRL_cc_hddet_st_shift                             (10)
+#define TVD_SLICER_CTRL_write_enable5_shift                           (9)
+#define TVD_SLICER_CTRL_adap_slvl_en_shift                            (8)
+#define TVD_SLICER_CTRL_write_enable4_shift                           (7)
+#define TVD_SLICER_CTRL_vbi_st_err_ignored_shift                      (6)
+#define TVD_SLICER_CTRL_write_enable3_shift                           (5)
+#define TVD_SLICER_CTRL_vbi_en_shift                                  (4)
+#define TVD_SLICER_CTRL_write_enable2_shift                           (3)
+#define TVD_SLICER_CTRL_cgms_bot_en_shift                             (2)
+#define TVD_SLICER_CTRL_write_enable1_shift                           (1)
+#define TVD_SLICER_CTRL_cgms_top_en_shift                             (0)
+#define TVD_SLICER_CTRL_write_enable6_mask                            (0x00040000)
+#define TVD_SLICER_CTRL_cc_hddet_st_mask                              (0x0003FC00)
+#define TVD_SLICER_CTRL_write_enable5_mask                            (0x00000200)
+#define TVD_SLICER_CTRL_adap_slvl_en_mask                             (0x00000100)
+#define TVD_SLICER_CTRL_write_enable4_mask                            (0x00000080)
+#define TVD_SLICER_CTRL_vbi_st_err_ignored_mask                       (0x00000040)
+#define TVD_SLICER_CTRL_write_enable3_mask                            (0x00000020)
+#define TVD_SLICER_CTRL_vbi_en_mask                                   (0x00000010)
+#define TVD_SLICER_CTRL_write_enable2_mask                            (0x00000008)
+#define TVD_SLICER_CTRL_cgms_bot_en_mask                              (0x00000004)
+#define TVD_SLICER_CTRL_write_enable1_mask                            (0x00000002)
+#define TVD_SLICER_CTRL_cgms_top_en_mask                              (0x00000001)
+#define TVD_SLICER_CTRL_write_enable6(data)                           (0x00040000&((data)<<18))
+#define TVD_SLICER_CTRL_cc_hddet_st(data)                             (0x0003FC00&((data)<<10))
+#define TVD_SLICER_CTRL_write_enable5(data)                           (0x00000200&((data)<<9))
+#define TVD_SLICER_CTRL_adap_slvl_en(data)                            (0x00000100&((data)<<8))
+#define TVD_SLICER_CTRL_write_enable4(data)                           (0x00000080&((data)<<7))
+#define TVD_SLICER_CTRL_vbi_st_err_ignored(data)                      (0x00000040&((data)<<6))
+#define TVD_SLICER_CTRL_write_enable3(data)                           (0x00000020&((data)<<5))
+#define TVD_SLICER_CTRL_vbi_en(data)                                  (0x00000010&((data)<<4))
+#define TVD_SLICER_CTRL_write_enable2(data)                           (0x00000008&((data)<<3))
+#define TVD_SLICER_CTRL_cgms_bot_en(data)                             (0x00000004&((data)<<2))
+#define TVD_SLICER_CTRL_write_enable1(data)                           (0x00000002&((data)<<1))
+#define TVD_SLICER_CTRL_cgms_top_en(data)                             (0x00000001&(data))
+#define TVD_SLICER_CTRL_get_write_enable6(data)                       ((0x00040000&(data))>>18)
+#define TVD_SLICER_CTRL_get_cc_hddet_st(data)                         ((0x0003FC00&(data))>>10)
+#define TVD_SLICER_CTRL_get_write_enable5(data)                       ((0x00000200&(data))>>9)
+#define TVD_SLICER_CTRL_get_adap_slvl_en(data)                        ((0x00000100&(data))>>8)
+#define TVD_SLICER_CTRL_get_write_enable4(data)                       ((0x00000080&(data))>>7)
+#define TVD_SLICER_CTRL_get_vbi_st_err_ignored(data)                  ((0x00000040&(data))>>6)
+#define TVD_SLICER_CTRL_get_write_enable3(data)                       ((0x00000020&(data))>>5)
+#define TVD_SLICER_CTRL_get_vbi_en(data)                              ((0x00000010&(data))>>4)
+#define TVD_SLICER_CTRL_get_write_enable2(data)                       ((0x00000008&(data))>>3)
+#define TVD_SLICER_CTRL_get_cgms_bot_en(data)                         ((0x00000004&(data))>>2)
+#define TVD_SLICER_CTRL_get_write_enable1(data)                       ((0x00000002&(data))>>1)
+#define TVD_SLICER_CTRL_get_cgms_top_en(data)                         (0x00000001&(data))
+
+#define TVD_VPS_LINE_16                                               0x180190B0
+#define TVD_VPS_LINE_16_reg_addr                                      "0xB80190B0"
+#define TVD_VPS_LINE_16_reg                                           0xB80190B0
+#define TVD_VPS_LINE_16_inst_addr                                     "0x002C"
+#define TVD_VPS_LINE_16_inst                                          0x002C
+#define TVD_VPS_LINE_16_vps_vbil16o_shift                             (4)
+#define TVD_VPS_LINE_16_vps_vbil16e_shift                             (0)
+#define TVD_VPS_LINE_16_vps_vbil16o_mask                              (0x000000F0)
+#define TVD_VPS_LINE_16_vps_vbil16e_mask                              (0x0000000F)
+#define TVD_VPS_LINE_16_vps_vbil16o(data)                             (0x000000F0&((data)<<4))
+#define TVD_VPS_LINE_16_vps_vbil16e(data)                             (0x0000000F&(data))
+#define TVD_VPS_LINE_16_get_vps_vbil16o(data)                         ((0x000000F0&(data))>>4)
+#define TVD_VPS_LINE_16_get_vps_vbil16e(data)                         (0x0000000F&(data))
+
+#define TVD_VBI_LINE0                                                 0x180190B4
+#define TVD_VBI_LINE0_reg_addr                                        "0xB80190B4"
+#define TVD_VBI_LINE0_reg                                             0xB80190B4
+#define TVD_VBI_LINE0_inst_addr                                       "0x002D"
+#define TVD_VBI_LINE0_inst                                            0x002D
+#define TVD_VBI_LINE0_vbio05_shift                                    (28)
+#define TVD_VBI_LINE0_vbie05_shift                                    (24)
+#define TVD_VBI_LINE0_vbio06_shift                                    (20)
+#define TVD_VBI_LINE0_vbie06_shift                                    (16)
+#define TVD_VBI_LINE0_vbio07_shift                                    (12)
+#define TVD_VBI_LINE0_vbie07_shift                                    (8)
+#define TVD_VBI_LINE0_vbio08_shift                                    (4)
+#define TVD_VBI_LINE0_vbie08_shift                                    (0)
+#define TVD_VBI_LINE0_vbio05_mask                                     (0xF0000000)
+#define TVD_VBI_LINE0_vbie05_mask                                     (0x0F000000)
+#define TVD_VBI_LINE0_vbio06_mask                                     (0x00F00000)
+#define TVD_VBI_LINE0_vbie06_mask                                     (0x000F0000)
+#define TVD_VBI_LINE0_vbio07_mask                                     (0x0000F000)
+#define TVD_VBI_LINE0_vbie07_mask                                     (0x00000F00)
+#define TVD_VBI_LINE0_vbio08_mask                                     (0x000000F0)
+#define TVD_VBI_LINE0_vbie08_mask                                     (0x0000000F)
+#define TVD_VBI_LINE0_vbio05(data)                                    (0xF0000000&((data)<<28))
+#define TVD_VBI_LINE0_vbie05(data)                                    (0x0F000000&((data)<<24))
+#define TVD_VBI_LINE0_vbio06(data)                                    (0x00F00000&((data)<<20))
+#define TVD_VBI_LINE0_vbie06(data)                                    (0x000F0000&((data)<<16))
+#define TVD_VBI_LINE0_vbio07(data)                                    (0x0000F000&((data)<<12))
+#define TVD_VBI_LINE0_vbie07(data)                                    (0x00000F00&((data)<<8))
+#define TVD_VBI_LINE0_vbio08(data)                                    (0x000000F0&((data)<<4))
+#define TVD_VBI_LINE0_vbie08(data)                                    (0x0000000F&(data))
+#define TVD_VBI_LINE0_get_vbio05(data)                                ((0xF0000000&(data))>>28)
+#define TVD_VBI_LINE0_get_vbie05(data)                                ((0x0F000000&(data))>>24)
+#define TVD_VBI_LINE0_get_vbio06(data)                                ((0x00F00000&(data))>>20)
+#define TVD_VBI_LINE0_get_vbie06(data)                                ((0x000F0000&(data))>>16)
+#define TVD_VBI_LINE0_get_vbio07(data)                                ((0x0000F000&(data))>>12)
+#define TVD_VBI_LINE0_get_vbie07(data)                                ((0x00000F00&(data))>>8)
+#define TVD_VBI_LINE0_get_vbio08(data)                                ((0x000000F0&(data))>>4)
+#define TVD_VBI_LINE0_get_vbie08(data)                                (0x0000000F&(data))
+
+#define TVD_VBI_LINE1                                                 0x180190B8
+#define TVD_VBI_LINE1_reg_addr                                        "0xB80190B8"
+#define TVD_VBI_LINE1_reg                                             0xB80190B8
+#define TVD_VBI_LINE1_inst_addr                                       "0x002E"
+#define TVD_VBI_LINE1_inst                                            0x002E
+#define TVD_VBI_LINE1_vbio09_shift                                    (28)
+#define TVD_VBI_LINE1_vbie09_shift                                    (24)
+#define TVD_VBI_LINE1_vbio10_shift                                    (20)
+#define TVD_VBI_LINE1_vbie10_shift                                    (16)
+#define TVD_VBI_LINE1_vbio11_shift                                    (12)
+#define TVD_VBI_LINE1_vbie11_shift                                    (8)
+#define TVD_VBI_LINE1_vbio12_shift                                    (4)
+#define TVD_VBI_LINE1_vbie12_shift                                    (0)
+#define TVD_VBI_LINE1_vbio09_mask                                     (0xF0000000)
+#define TVD_VBI_LINE1_vbie09_mask                                     (0x0F000000)
+#define TVD_VBI_LINE1_vbio10_mask                                     (0x00F00000)
+#define TVD_VBI_LINE1_vbie10_mask                                     (0x000F0000)
+#define TVD_VBI_LINE1_vbio11_mask                                     (0x0000F000)
+#define TVD_VBI_LINE1_vbie11_mask                                     (0x00000F00)
+#define TVD_VBI_LINE1_vbio12_mask                                     (0x000000F0)
+#define TVD_VBI_LINE1_vbie12_mask                                     (0x0000000F)
+#define TVD_VBI_LINE1_vbio09(data)                                    (0xF0000000&((data)<<28))
+#define TVD_VBI_LINE1_vbie09(data)                                    (0x0F000000&((data)<<24))
+#define TVD_VBI_LINE1_vbio10(data)                                    (0x00F00000&((data)<<20))
+#define TVD_VBI_LINE1_vbie10(data)                                    (0x000F0000&((data)<<16))
+#define TVD_VBI_LINE1_vbio11(data)                                    (0x0000F000&((data)<<12))
+#define TVD_VBI_LINE1_vbie11(data)                                    (0x00000F00&((data)<<8))
+#define TVD_VBI_LINE1_vbio12(data)                                    (0x000000F0&((data)<<4))
+#define TVD_VBI_LINE1_vbie12(data)                                    (0x0000000F&(data))
+#define TVD_VBI_LINE1_get_vbio09(data)                                ((0xF0000000&(data))>>28)
+#define TVD_VBI_LINE1_get_vbie09(data)                                ((0x0F000000&(data))>>24)
+#define TVD_VBI_LINE1_get_vbio10(data)                                ((0x00F00000&(data))>>20)
+#define TVD_VBI_LINE1_get_vbie10(data)                                ((0x000F0000&(data))>>16)
+#define TVD_VBI_LINE1_get_vbio11(data)                                ((0x0000F000&(data))>>12)
+#define TVD_VBI_LINE1_get_vbie11(data)                                ((0x00000F00&(data))>>8)
+#define TVD_VBI_LINE1_get_vbio12(data)                                ((0x000000F0&(data))>>4)
+#define TVD_VBI_LINE1_get_vbie12(data)                                (0x0000000F&(data))
+
+#define TVD_VBI_LINE2                                                 0x180190BC
+#define TVD_VBI_LINE2_reg_addr                                        "0xB80190BC"
+#define TVD_VBI_LINE2_reg                                             0xB80190BC
+#define TVD_VBI_LINE2_inst_addr                                       "0x002F"
+#define TVD_VBI_LINE2_inst                                            0x002F
+#define TVD_VBI_LINE2_vbio13_shift                                    (28)
+#define TVD_VBI_LINE2_vbie13_shift                                    (24)
+#define TVD_VBI_LINE2_vbio14_shift                                    (20)
+#define TVD_VBI_LINE2_vbie14_shift                                    (16)
+#define TVD_VBI_LINE2_vbio15_shift                                    (12)
+#define TVD_VBI_LINE2_vbie15_shift                                    (8)
+#define TVD_VBI_LINE2_vbio16_shift                                    (4)
+#define TVD_VBI_LINE2_vbie16_shift                                    (0)
+#define TVD_VBI_LINE2_vbio13_mask                                     (0xF0000000)
+#define TVD_VBI_LINE2_vbie13_mask                                     (0x0F000000)
+#define TVD_VBI_LINE2_vbio14_mask                                     (0x00F00000)
+#define TVD_VBI_LINE2_vbie14_mask                                     (0x000F0000)
+#define TVD_VBI_LINE2_vbio15_mask                                     (0x0000F000)
+#define TVD_VBI_LINE2_vbie15_mask                                     (0x00000F00)
+#define TVD_VBI_LINE2_vbio16_mask                                     (0x000000F0)
+#define TVD_VBI_LINE2_vbie16_mask                                     (0x0000000F)
+#define TVD_VBI_LINE2_vbio13(data)                                    (0xF0000000&((data)<<28))
+#define TVD_VBI_LINE2_vbie13(data)                                    (0x0F000000&((data)<<24))
+#define TVD_VBI_LINE2_vbio14(data)                                    (0x00F00000&((data)<<20))
+#define TVD_VBI_LINE2_vbie14(data)                                    (0x000F0000&((data)<<16))
+#define TVD_VBI_LINE2_vbio15(data)                                    (0x0000F000&((data)<<12))
+#define TVD_VBI_LINE2_vbie15(data)                                    (0x00000F00&((data)<<8))
+#define TVD_VBI_LINE2_vbio16(data)                                    (0x000000F0&((data)<<4))
+#define TVD_VBI_LINE2_vbie16(data)                                    (0x0000000F&(data))
+#define TVD_VBI_LINE2_get_vbio13(data)                                ((0xF0000000&(data))>>28)
+#define TVD_VBI_LINE2_get_vbie13(data)                                ((0x0F000000&(data))>>24)
+#define TVD_VBI_LINE2_get_vbio14(data)                                ((0x00F00000&(data))>>20)
+#define TVD_VBI_LINE2_get_vbie14(data)                                ((0x000F0000&(data))>>16)
+#define TVD_VBI_LINE2_get_vbio15(data)                                ((0x0000F000&(data))>>12)
+#define TVD_VBI_LINE2_get_vbie15(data)                                ((0x00000F00&(data))>>8)
+#define TVD_VBI_LINE2_get_vbio16(data)                                ((0x000000F0&(data))>>4)
+#define TVD_VBI_LINE2_get_vbie16(data)                                (0x0000000F&(data))
+
+#define TVD_VBI_LINE3                                                 0x180190C0
+#define TVD_VBI_LINE3_reg_addr                                        "0xB80190C0"
+#define TVD_VBI_LINE3_reg                                             0xB80190C0
+#define TVD_VBI_LINE3_inst_addr                                       "0x0030"
+#define TVD_VBI_LINE3_inst                                            0x0030
+#define TVD_VBI_LINE3_vbio17_shift                                    (28)
+#define TVD_VBI_LINE3_vbie17_shift                                    (24)
+#define TVD_VBI_LINE3_vbio18_shift                                    (20)
+#define TVD_VBI_LINE3_vbie18_shift                                    (16)
+#define TVD_VBI_LINE3_vbio19_shift                                    (12)
+#define TVD_VBI_LINE3_vbie19_shift                                    (8)
+#define TVD_VBI_LINE3_vbio20_shift                                    (4)
+#define TVD_VBI_LINE3_vbie20_shift                                    (0)
+#define TVD_VBI_LINE3_vbio17_mask                                     (0xF0000000)
+#define TVD_VBI_LINE3_vbie17_mask                                     (0x0F000000)
+#define TVD_VBI_LINE3_vbio18_mask                                     (0x00F00000)
+#define TVD_VBI_LINE3_vbie18_mask                                     (0x000F0000)
+#define TVD_VBI_LINE3_vbio19_mask                                     (0x0000F000)
+#define TVD_VBI_LINE3_vbie19_mask                                     (0x00000F00)
+#define TVD_VBI_LINE3_vbio20_mask                                     (0x000000F0)
+#define TVD_VBI_LINE3_vbie20_mask                                     (0x0000000F)
+#define TVD_VBI_LINE3_vbio17(data)                                    (0xF0000000&((data)<<28))
+#define TVD_VBI_LINE3_vbie17(data)                                    (0x0F000000&((data)<<24))
+#define TVD_VBI_LINE3_vbio18(data)                                    (0x00F00000&((data)<<20))
+#define TVD_VBI_LINE3_vbie18(data)                                    (0x000F0000&((data)<<16))
+#define TVD_VBI_LINE3_vbio19(data)                                    (0x0000F000&((data)<<12))
+#define TVD_VBI_LINE3_vbie19(data)                                    (0x00000F00&((data)<<8))
+#define TVD_VBI_LINE3_vbio20(data)                                    (0x000000F0&((data)<<4))
+#define TVD_VBI_LINE3_vbie20(data)                                    (0x0000000F&(data))
+#define TVD_VBI_LINE3_get_vbio17(data)                                ((0xF0000000&(data))>>28)
+#define TVD_VBI_LINE3_get_vbie17(data)                                ((0x0F000000&(data))>>24)
+#define TVD_VBI_LINE3_get_vbio18(data)                                ((0x00F00000&(data))>>20)
+#define TVD_VBI_LINE3_get_vbie18(data)                                ((0x000F0000&(data))>>16)
+#define TVD_VBI_LINE3_get_vbio19(data)                                ((0x0000F000&(data))>>12)
+#define TVD_VBI_LINE3_get_vbie19(data)                                ((0x00000F00&(data))>>8)
+#define TVD_VBI_LINE3_get_vbio20(data)                                ((0x000000F0&(data))>>4)
+#define TVD_VBI_LINE3_get_vbie20(data)                                (0x0000000F&(data))
+
+#define TVD_VBI_LINE4                                                 0x180190C4
+#define TVD_VBI_LINE4_reg_addr                                        "0xB80190C4"
+#define TVD_VBI_LINE4_reg                                             0xB80190C4
+#define TVD_VBI_LINE4_inst_addr                                       "0x0031"
+#define TVD_VBI_LINE4_inst                                            0x0031
+#define TVD_VBI_LINE4_vbio21_shift                                    (28)
+#define TVD_VBI_LINE4_vbie21_shift                                    (24)
+#define TVD_VBI_LINE4_vbio22_shift                                    (20)
+#define TVD_VBI_LINE4_vbie22_shift                                    (16)
+#define TVD_VBI_LINE4_vbio23_shift                                    (12)
+#define TVD_VBI_LINE4_vbie23_shift                                    (8)
+#define TVD_VBI_LINE4_vbio_other_shift                                (4)
+#define TVD_VBI_LINE4_vbie_other_shift                                (0)
+#define TVD_VBI_LINE4_vbio21_mask                                     (0xF0000000)
+#define TVD_VBI_LINE4_vbie21_mask                                     (0x0F000000)
+#define TVD_VBI_LINE4_vbio22_mask                                     (0x00F00000)
+#define TVD_VBI_LINE4_vbie22_mask                                     (0x000F0000)
+#define TVD_VBI_LINE4_vbio23_mask                                     (0x0000F000)
+#define TVD_VBI_LINE4_vbie23_mask                                     (0x00000F00)
+#define TVD_VBI_LINE4_vbio_other_mask                                 (0x000000F0)
+#define TVD_VBI_LINE4_vbie_other_mask                                 (0x0000000F)
+#define TVD_VBI_LINE4_vbio21(data)                                    (0xF0000000&((data)<<28))
+#define TVD_VBI_LINE4_vbie21(data)                                    (0x0F000000&((data)<<24))
+#define TVD_VBI_LINE4_vbio22(data)                                    (0x00F00000&((data)<<20))
+#define TVD_VBI_LINE4_vbie22(data)                                    (0x000F0000&((data)<<16))
+#define TVD_VBI_LINE4_vbio23(data)                                    (0x0000F000&((data)<<12))
+#define TVD_VBI_LINE4_vbie23(data)                                    (0x00000F00&((data)<<8))
+#define TVD_VBI_LINE4_vbio_other(data)                                (0x000000F0&((data)<<4))
+#define TVD_VBI_LINE4_vbie_other(data)                                (0x0000000F&(data))
+#define TVD_VBI_LINE4_get_vbio21(data)                                ((0xF0000000&(data))>>28)
+#define TVD_VBI_LINE4_get_vbie21(data)                                ((0x0F000000&(data))>>24)
+#define TVD_VBI_LINE4_get_vbio22(data)                                ((0x00F00000&(data))>>20)
+#define TVD_VBI_LINE4_get_vbie22(data)                                ((0x000F0000&(data))>>16)
+#define TVD_VBI_LINE4_get_vbio23(data)                                ((0x0000F000&(data))>>12)
+#define TVD_VBI_LINE4_get_vbie23(data)                                ((0x00000F00&(data))>>8)
+#define TVD_VBI_LINE4_get_vbio_other(data)                            ((0x000000F0&(data))>>4)
+#define TVD_VBI_LINE4_get_vbie_other(data)                            (0x0000000F&(data))
+
+#define TVD_CGMS_LINE                                                 0x180190C8
+#define TVD_CGMS_LINE_reg_addr                                        "0xB80190C8"
+#define TVD_CGMS_LINE_reg                                             0xB80190C8
+#define TVD_CGMS_LINE_inst_addr                                       "0x0032"
+#define TVD_CGMS_LINE_inst                                            0x0032
+#define TVD_CGMS_LINE_cgms_line_even_shift                            (8)
+#define TVD_CGMS_LINE_cgms_line_odd_shift                             (0)
+#define TVD_CGMS_LINE_cgms_line_even_mask                             (0x0000FF00)
+#define TVD_CGMS_LINE_cgms_line_odd_mask                              (0x000000FF)
+#define TVD_CGMS_LINE_cgms_line_even(data)                            (0x0000FF00&((data)<<8))
+#define TVD_CGMS_LINE_cgms_line_odd(data)                             (0x000000FF&(data))
+#define TVD_CGMS_LINE_get_cgms_line_even(data)                        ((0x0000FF00&(data))>>8)
+#define TVD_CGMS_LINE_get_cgms_line_odd(data)                         (0x000000FF&(data))
+
+#define TVD_VBI_GAIN_LVL                                              0x180190CC
+#define TVD_VBI_GAIN_LVL_reg_addr                                     "0xB80190CC"
+#define TVD_VBI_GAIN_LVL_reg                                          0xB80190CC
+#define TVD_VBI_GAIN_LVL_inst_addr                                    "0x0033"
+#define TVD_VBI_GAIN_LVL_inst                                         0x0033
+#define TVD_VBI_GAIN_LVL_data_hlvl_shift                              (9)
+#define TVD_VBI_GAIN_LVL_gain_shift                                   (6)
+#define TVD_VBI_GAIN_LVL_igain_shift                                  (3)
+#define TVD_VBI_GAIN_LVL_pgain_shift                                  (0)
+#define TVD_VBI_GAIN_LVL_data_hlvl_mask                               (0x0001FE00)
+#define TVD_VBI_GAIN_LVL_gain_mask                                    (0x000001C0)
+#define TVD_VBI_GAIN_LVL_igain_mask                                   (0x00000038)
+#define TVD_VBI_GAIN_LVL_pgain_mask                                   (0x00000007)
+#define TVD_VBI_GAIN_LVL_data_hlvl(data)                              (0x0001FE00&((data)<<9))
+#define TVD_VBI_GAIN_LVL_gain(data)                                   (0x000001C0&((data)<<6))
+#define TVD_VBI_GAIN_LVL_igain(data)                                  (0x00000038&((data)<<3))
+#define TVD_VBI_GAIN_LVL_pgain(data)                                  (0x00000007&(data))
+#define TVD_VBI_GAIN_LVL_get_data_hlvl(data)                          ((0x0001FE00&(data))>>9)
+#define TVD_VBI_GAIN_LVL_get_gain(data)                               ((0x000001C0&(data))>>6)
+#define TVD_VBI_GAIN_LVL_get_igain(data)                              ((0x00000038&(data))>>3)
+#define TVD_VBI_GAIN_LVL_get_pgain(data)                              (0x00000007&(data))
+
+#define TVD_CC_DTO                                                    0x180190D0
+#define TVD_CC_DTO_reg_addr                                           "0xB80190D0"
+#define TVD_CC_DTO_reg                                                0xB80190D0
+#define TVD_CC_DTO_inst_addr                                          "0x0034"
+#define TVD_CC_DTO_inst                                               0x0034
+#define TVD_CC_DTO_cc_dto_shift                                       (0)
+#define TVD_CC_DTO_cc_dto_mask                                        (0x0000FFFF)
+#define TVD_CC_DTO_cc_dto(data)                                       (0x0000FFFF&(data))
+#define TVD_CC_DTO_get_cc_dto(data)                                   (0x0000FFFF&(data))
+
+#define TVD_TT_DTO                                                    0x180190D4
+#define TVD_TT_DTO_reg_addr                                           "0xB80190D4"
+#define TVD_TT_DTO_reg                                                0xB80190D4
+#define TVD_TT_DTO_inst_addr                                          "0x0035"
+#define TVD_TT_DTO_inst                                               0x0035
+#define TVD_TT_DTO_tt_dto_shift                                       (0)
+#define TVD_TT_DTO_tt_dto_mask                                        (0x0000FFFF)
+#define TVD_TT_DTO_tt_dto(data)                                       (0x0000FFFF&(data))
+#define TVD_TT_DTO_get_tt_dto(data)                                   (0x0000FFFF&(data))
+
+#define TVD_WSS_DTO                                                   0x180190D8
+#define TVD_WSS_DTO_reg_addr                                          "0xB80190D8"
+#define TVD_WSS_DTO_reg                                               0xB80190D8
+#define TVD_WSS_DTO_inst_addr                                         "0x0036"
+#define TVD_WSS_DTO_inst                                              0x0036
+#define TVD_WSS_DTO_wss_dto_shift                                     (0)
+#define TVD_WSS_DTO_wss_dto_mask                                      (0x0000FFFF)
+#define TVD_WSS_DTO_wss_dto(data)                                     (0x0000FFFF&(data))
+#define TVD_WSS_DTO_get_wss_dto(data)                                 (0x0000FFFF&(data))
+
+#define TVD_VBI_FRAME_START                                           0x180190DC
+#define TVD_VBI_FRAME_START_reg_addr                                  "0xB80190DC"
+#define TVD_VBI_FRAME_START_reg                                       0xB80190DC
+#define TVD_VBI_FRAME_START_inst_addr                                 "0x0037"
+#define TVD_VBI_FRAME_START_inst                                      0x0037
+#define TVD_VBI_FRAME_START_cc_frame_start_shift                      (24)
+#define TVD_VBI_FRAME_START_tt_frame_start_shift                      (16)
+#define TVD_VBI_FRAME_START_tt_start_code_shift                       (8)
+#define TVD_VBI_FRAME_START_wss_frame_start_shift                     (0)
+#define TVD_VBI_FRAME_START_cc_frame_start_mask                       (0xFF000000)
+#define TVD_VBI_FRAME_START_tt_frame_start_mask                       (0x00FF0000)
+#define TVD_VBI_FRAME_START_tt_start_code_mask                        (0x0000FF00)
+#define TVD_VBI_FRAME_START_wss_frame_start_mask                      (0x000000FF)
+#define TVD_VBI_FRAME_START_cc_frame_start(data)                      (0xFF000000&((data)<<24))
+#define TVD_VBI_FRAME_START_tt_frame_start(data)                      (0x00FF0000&((data)<<16))
+#define TVD_VBI_FRAME_START_tt_start_code(data)                       (0x0000FF00&((data)<<8))
+#define TVD_VBI_FRAME_START_wss_frame_start(data)                     (0x000000FF&(data))
+#define TVD_VBI_FRAME_START_get_cc_frame_start(data)                  ((0xFF000000&(data))>>24)
+#define TVD_VBI_FRAME_START_get_tt_frame_start(data)                  ((0x00FF0000&(data))>>16)
+#define TVD_VBI_FRAME_START_get_tt_start_code(data)                   ((0x0000FF00&(data))>>8)
+#define TVD_VBI_FRAME_START_get_wss_frame_start(data)                 (0x000000FF&(data))
+
+#define TVD_VBI_START                                                 0x180190E0
+#define TVD_VBI_START_reg_addr                                        "0xB80190E0"
+#define TVD_VBI_START_reg                                             0xB80190E0
+#define TVD_VBI_START_inst_addr                                       "0x0038"
+#define TVD_VBI_START_inst                                            0x0038
+#define TVD_VBI_START_cc_start_shift                                  (16)
+#define TVD_VBI_START_tt_start_shift                                  (8)
+#define TVD_VBI_START_wss_start_shift                                 (0)
+#define TVD_VBI_START_cc_start_mask                                   (0x00FF0000)
+#define TVD_VBI_START_tt_start_mask                                   (0x0000FF00)
+#define TVD_VBI_START_wss_start_mask                                  (0x000000FF)
+#define TVD_VBI_START_cc_start(data)                                  (0x00FF0000&((data)<<16))
+#define TVD_VBI_START_tt_start(data)                                  (0x0000FF00&((data)<<8))
+#define TVD_VBI_START_wss_start(data)                                 (0x000000FF&(data))
+#define TVD_VBI_START_get_cc_start(data)                              ((0x00FF0000&(data))>>16)
+#define TVD_VBI_START_get_tt_start(data)                              ((0x0000FF00&(data))>>8)
+#define TVD_VBI_START_get_wss_start(data)                             (0x000000FF&(data))
+
+#define TVD_VBI_CAL_DC_DETECT                                         0x180190E4
+#define TVD_VBI_CAL_DC_DETECT_reg_addr                                "0xB80190E4"
+#define TVD_VBI_CAL_DC_DETECT_reg                                     0xB80190E4
+#define TVD_VBI_CAL_DC_DETECT_inst_addr                               "0x0039"
+#define TVD_VBI_CAL_DC_DETECT_inst                                    0x0039
+#define TVD_VBI_CAL_DC_DETECT_vbi_cal_dc_st_shift                     (28)
+#define TVD_VBI_CAL_DC_DETECT_vbi_cal_dc_end_shift                    (24)
+#define TVD_VBI_CAL_DC_DETECT_wss_cal_dc_st_shift                     (20)
+#define TVD_VBI_CAL_DC_DETECT_wss_cal_dc_end_shift                    (16)
+#define TVD_VBI_CAL_DC_DETECT_vps_cal_dc_st_shift                     (12)
+#define TVD_VBI_CAL_DC_DETECT_vps_cal_dc_end_shift                    (8)
+#define TVD_VBI_CAL_DC_DETECT_cgms_cal_dc_st_shift                    (4)
+#define TVD_VBI_CAL_DC_DETECT_cgms_cal_dc_end_shift                   (0)
+#define TVD_VBI_CAL_DC_DETECT_vbi_cal_dc_st_mask                      (0xF0000000)
+#define TVD_VBI_CAL_DC_DETECT_vbi_cal_dc_end_mask                     (0x0F000000)
+#define TVD_VBI_CAL_DC_DETECT_wss_cal_dc_st_mask                      (0x00F00000)
+#define TVD_VBI_CAL_DC_DETECT_wss_cal_dc_end_mask                     (0x000F0000)
+#define TVD_VBI_CAL_DC_DETECT_vps_cal_dc_st_mask                      (0x0000F000)
+#define TVD_VBI_CAL_DC_DETECT_vps_cal_dc_end_mask                     (0x00000F00)
+#define TVD_VBI_CAL_DC_DETECT_cgms_cal_dc_st_mask                     (0x000000F0)
+#define TVD_VBI_CAL_DC_DETECT_cgms_cal_dc_end_mask                    (0x0000000F)
+#define TVD_VBI_CAL_DC_DETECT_vbi_cal_dc_st(data)                     (0xF0000000&((data)<<28))
+#define TVD_VBI_CAL_DC_DETECT_vbi_cal_dc_end(data)                    (0x0F000000&((data)<<24))
+#define TVD_VBI_CAL_DC_DETECT_wss_cal_dc_st(data)                     (0x00F00000&((data)<<20))
+#define TVD_VBI_CAL_DC_DETECT_wss_cal_dc_end(data)                    (0x000F0000&((data)<<16))
+#define TVD_VBI_CAL_DC_DETECT_vps_cal_dc_st(data)                     (0x0000F000&((data)<<12))
+#define TVD_VBI_CAL_DC_DETECT_vps_cal_dc_end(data)                    (0x00000F00&((data)<<8))
+#define TVD_VBI_CAL_DC_DETECT_cgms_cal_dc_st(data)                    (0x000000F0&((data)<<4))
+#define TVD_VBI_CAL_DC_DETECT_cgms_cal_dc_end(data)                   (0x0000000F&(data))
+#define TVD_VBI_CAL_DC_DETECT_get_vbi_cal_dc_st(data)                 ((0xF0000000&(data))>>28)
+#define TVD_VBI_CAL_DC_DETECT_get_vbi_cal_dc_end(data)                ((0x0F000000&(data))>>24)
+#define TVD_VBI_CAL_DC_DETECT_get_wss_cal_dc_st(data)                 ((0x00F00000&(data))>>20)
+#define TVD_VBI_CAL_DC_DETECT_get_wss_cal_dc_end(data)                ((0x000F0000&(data))>>16)
+#define TVD_VBI_CAL_DC_DETECT_get_vps_cal_dc_st(data)                 ((0x0000F000&(data))>>12)
+#define TVD_VBI_CAL_DC_DETECT_get_vps_cal_dc_end(data)                ((0x00000F00&(data))>>8)
+#define TVD_VBI_CAL_DC_DETECT_get_cgms_cal_dc_st(data)                ((0x000000F0&(data))>>4)
+#define TVD_VBI_CAL_DC_DETECT_get_cgms_cal_dc_end(data)               (0x0000000F&(data))
+
+#define TVD_CGMS_DC                                                   0x180190E8
+#define TVD_CGMS_DC_reg_addr                                          "0xB80190E8"
+#define TVD_CGMS_DC_reg                                               0xB80190E8
+#define TVD_CGMS_DC_inst_addr                                         "0x003A"
+#define TVD_CGMS_DC_inst                                              0x003A
+#define TVD_CGMS_DC_adap_cgms_dc_en_shift                             (8)
+#define TVD_CGMS_DC_cgms_dc_shift                                     (0)
+#define TVD_CGMS_DC_adap_cgms_dc_en_mask                              (0x00000100)
+#define TVD_CGMS_DC_cgms_dc_mask                                      (0x000000FF)
+#define TVD_CGMS_DC_adap_cgms_dc_en(data)                             (0x00000100&((data)<<8))
+#define TVD_CGMS_DC_cgms_dc(data)                                     (0x000000FF&(data))
+#define TVD_CGMS_DC_get_adap_cgms_dc_en(data)                         ((0x00000100&(data))>>8)
+#define TVD_CGMS_DC_get_cgms_dc(data)                                 (0x000000FF&(data))
+
+#define TVD_VBI_RDY                                                   0x180190EC
+#define TVD_VBI_RDY_reg_addr                                          "0xB80190EC"
+#define TVD_VBI_RDY_reg                                               0xB80190EC
+#define TVD_VBI_RDY_inst_addr                                         "0x003B"
+#define TVD_VBI_RDY_inst                                              0x003B
+#define TVD_VBI_RDY_cc_rdy_shift                                      (2)
+#define TVD_VBI_RDY_wss_rdy_shift                                     (1)
+#define TVD_VBI_RDY_cgms_rdy_shift                                    (0)
+#define TVD_VBI_RDY_cc_rdy_mask                                       (0x00000004)
+#define TVD_VBI_RDY_wss_rdy_mask                                      (0x00000002)
+#define TVD_VBI_RDY_cgms_rdy_mask                                     (0x00000001)
+#define TVD_VBI_RDY_cc_rdy(data)                                      (0x00000004&((data)<<2))
+#define TVD_VBI_RDY_wss_rdy(data)                                     (0x00000002&((data)<<1))
+#define TVD_VBI_RDY_cgms_rdy(data)                                    (0x00000001&(data))
+#define TVD_VBI_RDY_get_cc_rdy(data)                                  ((0x00000004&(data))>>2)
+#define TVD_VBI_RDY_get_wss_rdy(data)                                 ((0x00000002&(data))>>1)
+#define TVD_VBI_RDY_get_cgms_rdy(data)                                (0x00000001&(data))
+
+#define TVD_CC_DATA                                                   0x180190F0
+#define TVD_CC_DATA_reg_addr                                          "0xB80190F0"
+#define TVD_CC_DATA_reg                                               0xB80190F0
+#define TVD_CC_DATA_inst_addr                                         "0x003C"
+#define TVD_CC_DATA_inst                                              0x003C
+#define TVD_CC_DATA_cc_data_shift                                     (0)
+#define TVD_CC_DATA_cc_data_mask                                      (0x0000FFFF)
+#define TVD_CC_DATA_cc_data(data)                                     (0x0000FFFF&(data))
+#define TVD_CC_DATA_get_cc_data(data)                                 (0x0000FFFF&(data))
+
+#define TVD_WSS_DATA                                                  0x180190F4
+#define TVD_WSS_DATA_reg_addr                                         "0xB80190F4"
+#define TVD_WSS_DATA_reg                                              0xB80190F4
+#define TVD_WSS_DATA_inst_addr                                        "0x003D"
+#define TVD_WSS_DATA_inst                                             0x003D
+#define TVD_WSS_DATA_wss_data_shift                                   (0)
+#define TVD_WSS_DATA_wss_data_mask                                    (0x0000FFFF)
+#define TVD_WSS_DATA_wss_data(data)                                   (0x0000FFFF&(data))
+#define TVD_WSS_DATA_get_wss_data(data)                               (0x0000FFFF&(data))
+
+#define TVD_CGMS_DATA                                                 0x180190F8
+#define TVD_CGMS_DATA_reg_addr                                        "0xB80190F8"
+#define TVD_CGMS_DATA_reg                                             0xB80190F8
+#define TVD_CGMS_DATA_inst_addr                                       "0x003E"
+#define TVD_CGMS_DATA_inst                                            0x003E
+#define TVD_CGMS_DATA_cgms_data_shift                                 (0)
+#define TVD_CGMS_DATA_cgms_data_mask                                  (0x000FFFFF)
+#define TVD_CGMS_DATA_cgms_data(data)                                 (0x000FFFFF&(data))
+#define TVD_CGMS_DATA_get_cgms_data(data)                             (0x000FFFFF&(data))
+
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0                                   0x180190FC
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_reg_addr                          "0xB80190FC"
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_reg                               0xB80190FC
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_inst_addr                         "0x003F"
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_inst                              0x003F
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_apowl_shift                       (25)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_bpowl_shift                       (24)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_cpowl_shift                       (23)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_dpowl_shift                       (22)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_asgainl_shift                     (19)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_bsgainl_shift                     (16)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_csgainl_shift                     (13)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_dsgainl_shift                     (10)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_calibratel_shift                  (6)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_scavl_shift                       (3)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_svoutl_shift                      (0)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_apowl_mask                        (0x02000000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_bpowl_mask                        (0x01000000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_cpowl_mask                        (0x00800000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_dpowl_mask                        (0x00400000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_asgainl_mask                      (0x00380000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_bsgainl_mask                      (0x00070000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_csgainl_mask                      (0x0000E000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_dsgainl_mask                      (0x00001C00)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_calibratel_mask                   (0x000003C0)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_scavl_mask                        (0x00000038)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_svoutl_mask                       (0x00000007)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_apowl(data)                       (0x02000000&((data)<<25))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_bpowl(data)                       (0x01000000&((data)<<24))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_cpowl(data)                       (0x00800000&((data)<<23))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_dpowl(data)                       (0x00400000&((data)<<22))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_asgainl(data)                     (0x00380000&((data)<<19))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_bsgainl(data)                     (0x00070000&((data)<<16))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_csgainl(data)                     (0x0000E000&((data)<<13))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_dsgainl(data)                     (0x00001C00&((data)<<10))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_calibratel(data)                  (0x000003C0&((data)<<6))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_scavl(data)                       (0x00000038&((data)<<3))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_svoutl(data)                      (0x00000007&(data))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_apowl(data)                   ((0x02000000&(data))>>25)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_bpowl(data)                   ((0x01000000&(data))>>24)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_cpowl(data)                   ((0x00800000&(data))>>23)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_dpowl(data)                   ((0x00400000&(data))>>22)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_asgainl(data)                 ((0x00380000&(data))>>19)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_bsgainl(data)                 ((0x00070000&(data))>>16)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_csgainl(data)                 ((0x0000E000&(data))>>13)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_dsgainl(data)                 ((0x00001C00&(data))>>10)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_calibratel(data)              ((0x000003C0&(data))>>6)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_scavl(data)                   ((0x00000038&(data))>>3)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL0_get_svoutl(data)                  (0x00000007&(data))
+
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1                                   0x18019100
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_reg_addr                          "0xB8019100"
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_reg                               0xB8019100
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_inst_addr                         "0x0040"
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_inst                              0x0040
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_ainswl_shift                      (30)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_binswl_shift                      (28)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_cinswl_shift                      (26)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_dinswl_shift                      (24)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_aclamp_spl_shift                  (18)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_bclamp_spl_shift                  (12)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_cclamp_spl_shift                  (6)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_dclamp_spl_shift                  (0)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_ainswl_mask                       (0xC0000000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_binswl_mask                       (0x30000000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_cinswl_mask                       (0x0C000000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_dinswl_mask                       (0x03000000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_aclamp_spl_mask                   (0x00FC0000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_bclamp_spl_mask                   (0x0003F000)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_cclamp_spl_mask                   (0x00000FC0)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_dclamp_spl_mask                   (0x0000003F)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_ainswl(data)                      (0xC0000000&((data)<<30))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_binswl(data)                      (0x30000000&((data)<<28))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_cinswl(data)                      (0x0C000000&((data)<<26))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_dinswl(data)                      (0x03000000&((data)<<24))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_aclamp_spl(data)                  (0x00FC0000&((data)<<18))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_bclamp_spl(data)                  (0x0003F000&((data)<<12))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_cclamp_spl(data)                  (0x00000FC0&((data)<<6))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_dclamp_spl(data)                  (0x0000003F&(data))
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_get_ainswl(data)                  ((0xC0000000&(data))>>30)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_get_binswl(data)                  ((0x30000000&(data))>>28)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_get_cinswl(data)                  ((0x0C000000&(data))>>26)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_get_dinswl(data)                  ((0x03000000&(data))>>24)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_get_aclamp_spl(data)              ((0x00FC0000&(data))>>18)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_get_bclamp_spl(data)              ((0x0003F000&(data))>>12)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_get_cclamp_spl(data)              ((0x00000FC0&(data))>>6)
+#define TVD_VIDEO_ADC_DIGITAL_CTRL1_get_dclamp_spl(data)              (0x0000003F&(data))
+
+#define TVD_VIDEO_ADC_ANALOG_CTRL0                                    0x18019104
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_reg_addr                           "0xB8019104"
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_reg                                0xB8019104
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_inst_addr                          "0x0041"
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_inst                               0x0041
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_asvicml_shift                      (29)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_bsvicml_shift                      (26)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_csvicml_shift                      (23)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_dsvicml_shift                      (20)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_bufl_shift                     (16)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_mdacl_shift                    (12)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_sourcel_shift                  (8)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_topl_shift                     (4)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_vrtbufl_shift                  (0)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_asvicml_mask                       (0xE0000000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_bsvicml_mask                       (0x1C000000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_csvicml_mask                       (0x03800000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_dsvicml_mask                       (0x00700000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_bufl_mask                      (0x000F0000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_mdacl_mask                     (0x0000F000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_sourcel_mask                   (0x00000F00)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_topl_mask                      (0x000000F0)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_vrtbufl_mask                   (0x0000000F)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_asvicml(data)                      (0xE0000000&((data)<<29))
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_bsvicml(data)                      (0x1C000000&((data)<<26))
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_csvicml(data)                      (0x03800000&((data)<<23))
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_dsvicml(data)                      (0x00700000&((data)<<20))
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_bufl(data)                     (0x000F0000&((data)<<16))
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_mdacl(data)                    (0x0000F000&((data)<<12))
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_sourcel(data)                  (0x00000F00&((data)<<8))
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_topl(data)                     (0x000000F0&((data)<<4))
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_sib_vrtbufl(data)                  (0x0000000F&(data))
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_get_asvicml(data)                  ((0xE0000000&(data))>>29)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_get_bsvicml(data)                  ((0x1C000000&(data))>>26)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_get_csvicml(data)                  ((0x03800000&(data))>>23)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_get_dsvicml(data)                  ((0x00700000&(data))>>20)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_get_sib_bufl(data)                 ((0x000F0000&(data))>>16)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_get_sib_mdacl(data)                ((0x0000F000&(data))>>12)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_get_sib_sourcel(data)              ((0x00000F00&(data))>>8)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_get_sib_topl(data)                 ((0x000000F0&(data))>>4)
+#define TVD_VIDEO_ADC_ANALOG_CTRL0_get_sib_vrtbufl(data)              (0x0000000F&(data))
+
+#define TVD_VIDEO_ADC_ANALOG_CTRL1                                    0x18019108
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_reg_addr                           "0xB8019108"
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_reg                                0xB8019108
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_inst_addr                          "0x0042"
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_inst                               0x0042
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_avrbl_shift                        (23)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_bvrbl_shift                        (20)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_cvrbl_shift                        (17)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_dvrbl_shift                        (14)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_svrbl_shift                        (11)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_clamp_enl_shift                    (7)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_sckinl_shift                       (5)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_sckol_shift                        (4)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_vicmpowl_shift                     (0)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_avrbl_mask                         (0x03800000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_bvrbl_mask                         (0x00700000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_cvrbl_mask                         (0x000E0000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_dvrbl_mask                         (0x0001C000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_svrbl_mask                         (0x00003800)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_clamp_enl_mask                     (0x00000780)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_sckinl_mask                        (0x00000060)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_sckol_mask                         (0x00000010)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_vicmpowl_mask                      (0x0000000F)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_avrbl(data)                        (0x03800000&((data)<<23))
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_bvrbl(data)                        (0x00700000&((data)<<20))
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_cvrbl(data)                        (0x000E0000&((data)<<17))
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_dvrbl(data)                        (0x0001C000&((data)<<14))
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_svrbl(data)                        (0x00003800&((data)<<11))
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_clamp_enl(data)                    (0x00000780&((data)<<7))
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_sckinl(data)                       (0x00000060&((data)<<5))
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_sckol(data)                        (0x00000010&((data)<<4))
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_vicmpowl(data)                     (0x0000000F&(data))
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_get_avrbl(data)                    ((0x03800000&(data))>>23)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_get_bvrbl(data)                    ((0x00700000&(data))>>20)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_get_cvrbl(data)                    ((0x000E0000&(data))>>17)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_get_dvrbl(data)                    ((0x0001C000&(data))>>14)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_get_svrbl(data)                    ((0x00003800&(data))>>11)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_get_clamp_enl(data)                ((0x00000780&(data))>>7)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_get_sckinl(data)                   ((0x00000060&(data))>>5)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_get_sckol(data)                    ((0x00000010&(data))>>4)
+#define TVD_VIDEO_ADC_ANALOG_CTRL1_get_vicmpowl(data)                 (0x0000000F&(data))
+
+#define TVD_VIDEO_ADC_ANALOG_CTRL2                                    0x1801910C
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_reg_addr                           "0xB801910C"
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_reg                                0xB801910C
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_inst_addr                          "0x0043"
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_inst                               0x0043
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_afepowl_shift                      (24)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_sadcinl_shift                      (20)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_vrefpowl_shift                     (15)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_avrtl_shift                        (12)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_bvrtl_shift                        (9)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_cvrtl_shift                        (6)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_dvrtl_shift                        (3)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_svrtl_shift                        (0)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_afepowl_mask                       (0x0F000000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_sadcinl_mask                       (0x00F00000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_vrefpowl_mask                      (0x000F8000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_avrtl_mask                         (0x00007000)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_bvrtl_mask                         (0x00000E00)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_cvrtl_mask                         (0x000001C0)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_dvrtl_mask                         (0x00000038)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_svrtl_mask                         (0x00000007)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_afepowl(data)                      (0x0F000000&((data)<<24))
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_sadcinl(data)                      (0x00F00000&((data)<<20))
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_vrefpowl(data)                     (0x000F8000&((data)<<15))
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_avrtl(data)                        (0x00007000&((data)<<12))
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_bvrtl(data)                        (0x00000E00&((data)<<9))
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_cvrtl(data)                        (0x000001C0&((data)<<6))
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_dvrtl(data)                        (0x00000038&((data)<<3))
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_svrtl(data)                        (0x00000007&(data))
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_get_afepowl(data)                  ((0x0F000000&(data))>>24)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_get_sadcinl(data)                  ((0x00F00000&(data))>>20)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_get_vrefpowl(data)                 ((0x000F8000&(data))>>15)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_get_avrtl(data)                    ((0x00007000&(data))>>12)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_get_bvrtl(data)                    ((0x00000E00&(data))>>9)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_get_cvrtl(data)                    ((0x000001C0&(data))>>6)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_get_dvrtl(data)                    ((0x00000038&(data))>>3)
+#define TVD_VIDEO_ADC_ANALOG_CTRL2_get_svrtl(data)                    (0x00000007&(data))
+
+#define TVD_AD_SW_CTRL                                                0x18019110
+#define TVD_AD_SW_CTRL_reg_addr                                       "0xB8019110"
+#define TVD_AD_SW_CTRL_reg                                            0xB8019110
+#define TVD_AD_SW_CTRL_inst_addr                                      "0x0044"
+#define TVD_AD_SW_CTRL_inst                                           0x0044
+#define TVD_AD_SW_CTRL_write_enable9_shift                            (23)
+#define TVD_AD_SW_CTRL_fsw_en_shift                                   (22)
+#define TVD_AD_SW_CTRL_write_enable8_shift                            (21)
+#define TVD_AD_SW_CTRL_sw_y_r_shift                                   (19)
+#define TVD_AD_SW_CTRL_write_enable7_shift                            (18)
+#define TVD_AD_SW_CTRL_sw_pb_g_shift                                  (16)
+#define TVD_AD_SW_CTRL_write_enable6_shift                            (15)
+#define TVD_AD_SW_CTRL_sw_pr_b_shift                                  (13)
+#define TVD_AD_SW_CTRL_write_enable5_shift                            (12)
+#define TVD_AD_SW_CTRL_ad1_y_sw_shift                                 (11)
+#define TVD_AD_SW_CTRL_write_enable4_shift                            (10)
+#define TVD_AD_SW_CTRL_scart_en_shift                                 (9)
+#define TVD_AD_SW_CTRL_write_enable3_shift                            (8)
+#define TVD_AD_SW_CTRL_clamp_ad2_shift                                (6)
+#define TVD_AD_SW_CTRL_write_enable2_shift                            (5)
+#define TVD_AD_SW_CTRL_clamp_ad3_shift                                (3)
+#define TVD_AD_SW_CTRL_write_enable1_shift                            (2)
+#define TVD_AD_SW_CTRL_clamp_ad4_shift                                (0)
+#define TVD_AD_SW_CTRL_write_enable9_mask                             (0x00800000)
+#define TVD_AD_SW_CTRL_fsw_en_mask                                    (0x00400000)
+#define TVD_AD_SW_CTRL_write_enable8_mask                             (0x00200000)
+#define TVD_AD_SW_CTRL_sw_y_r_mask                                    (0x00180000)
+#define TVD_AD_SW_CTRL_write_enable7_mask                             (0x00040000)
+#define TVD_AD_SW_CTRL_sw_pb_g_mask                                   (0x00030000)
+#define TVD_AD_SW_CTRL_write_enable6_mask                             (0x00008000)
+#define TVD_AD_SW_CTRL_sw_pr_b_mask                                   (0x00006000)
+#define TVD_AD_SW_CTRL_write_enable5_mask                             (0x00001000)
+#define TVD_AD_SW_CTRL_ad1_y_sw_mask                                  (0x00000800)
+#define TVD_AD_SW_CTRL_write_enable4_mask                             (0x00000400)
+#define TVD_AD_SW_CTRL_scart_en_mask                                  (0x00000200)
+#define TVD_AD_SW_CTRL_write_enable3_mask                             (0x00000100)
+#define TVD_AD_SW_CTRL_clamp_ad2_mask                                 (0x000000C0)
+#define TVD_AD_SW_CTRL_write_enable2_mask                             (0x00000020)
+#define TVD_AD_SW_CTRL_clamp_ad3_mask                                 (0x00000018)
+#define TVD_AD_SW_CTRL_write_enable1_mask                             (0x00000004)
+#define TVD_AD_SW_CTRL_clamp_ad4_mask                                 (0x00000003)
+#define TVD_AD_SW_CTRL_write_enable9(data)                            (0x00800000&((data)<<23))
+#define TVD_AD_SW_CTRL_fsw_en(data)                                   (0x00400000&((data)<<22))
+#define TVD_AD_SW_CTRL_write_enable8(data)                            (0x00200000&((data)<<21))
+#define TVD_AD_SW_CTRL_sw_y_r(data)                                   (0x00180000&((data)<<19))
+#define TVD_AD_SW_CTRL_write_enable7(data)                            (0x00040000&((data)<<18))
+#define TVD_AD_SW_CTRL_sw_pb_g(data)                                  (0x00030000&((data)<<16))
+#define TVD_AD_SW_CTRL_write_enable6(data)                            (0x00008000&((data)<<15))
+#define TVD_AD_SW_CTRL_sw_pr_b(data)                                  (0x00006000&((data)<<13))
+#define TVD_AD_SW_CTRL_write_enable5(data)                            (0x00001000&((data)<<12))
+#define TVD_AD_SW_CTRL_ad1_y_sw(data)                                 (0x00000800&((data)<<11))
+#define TVD_AD_SW_CTRL_write_enable4(data)                            (0x00000400&((data)<<10))
+#define TVD_AD_SW_CTRL_scart_en(data)                                 (0x00000200&((data)<<9))
+#define TVD_AD_SW_CTRL_write_enable3(data)                            (0x00000100&((data)<<8))
+#define TVD_AD_SW_CTRL_clamp_ad2(data)                                (0x000000C0&((data)<<6))
+#define TVD_AD_SW_CTRL_write_enable2(data)                            (0x00000020&((data)<<5))
+#define TVD_AD_SW_CTRL_clamp_ad3(data)                                (0x00000018&((data)<<3))
+#define TVD_AD_SW_CTRL_write_enable1(data)                            (0x00000004&((data)<<2))
+#define TVD_AD_SW_CTRL_clamp_ad4(data)                                (0x00000003&(data))
+#define TVD_AD_SW_CTRL_get_write_enable9(data)                        ((0x00800000&(data))>>23)
+#define TVD_AD_SW_CTRL_get_fsw_en(data)                               ((0x00400000&(data))>>22)
+#define TVD_AD_SW_CTRL_get_write_enable8(data)                        ((0x00200000&(data))>>21)
+#define TVD_AD_SW_CTRL_get_sw_y_r(data)                               ((0x00180000&(data))>>19)
+#define TVD_AD_SW_CTRL_get_write_enable7(data)                        ((0x00040000&(data))>>18)
+#define TVD_AD_SW_CTRL_get_sw_pb_g(data)                              ((0x00030000&(data))>>16)
+#define TVD_AD_SW_CTRL_get_write_enable6(data)                        ((0x00008000&(data))>>15)
+#define TVD_AD_SW_CTRL_get_sw_pr_b(data)                              ((0x00006000&(data))>>13)
+#define TVD_AD_SW_CTRL_get_write_enable5(data)                        ((0x00001000&(data))>>12)
+#define TVD_AD_SW_CTRL_get_ad1_y_sw(data)                             ((0x00000800&(data))>>11)
+#define TVD_AD_SW_CTRL_get_write_enable4(data)                        ((0x00000400&(data))>>10)
+#define TVD_AD_SW_CTRL_get_scart_en(data)                             ((0x00000200&(data))>>9)
+#define TVD_AD_SW_CTRL_get_write_enable3(data)                        ((0x00000100&(data))>>8)
+#define TVD_AD_SW_CTRL_get_clamp_ad2(data)                            ((0x000000C0&(data))>>6)
+#define TVD_AD_SW_CTRL_get_write_enable2(data)                        ((0x00000020&(data))>>5)
+#define TVD_AD_SW_CTRL_get_clamp_ad3(data)                            ((0x00000018&(data))>>3)
+#define TVD_AD_SW_CTRL_get_write_enable1(data)                        ((0x00000004&(data))>>2)
+#define TVD_AD_SW_CTRL_get_clamp_ad4(data)                            (0x00000003&(data))
+
+#define TVD_SCART_ACTIVE                                              0x18019114
+#define TVD_SCART_ACTIVE_reg_addr                                     "0xB8019114"
+#define TVD_SCART_ACTIVE_reg                                          0xB8019114
+#define TVD_SCART_ACTIVE_inst_addr                                    "0x0045"
+#define TVD_SCART_ACTIVE_inst                                         0x0045
+#define TVD_SCART_ACTIVE_hst_shift                                    (22)
+#define TVD_SCART_ACTIVE_hwidth_shift                                 (14)
+#define TVD_SCART_ACTIVE_vst_shift                                    (7)
+#define TVD_SCART_ACTIVE_vwidth_shift                                 (0)
+#define TVD_SCART_ACTIVE_hst_mask                                     (0x3FC00000)
+#define TVD_SCART_ACTIVE_hwidth_mask                                  (0x003FC000)
+#define TVD_SCART_ACTIVE_vst_mask                                     (0x00003F80)
+#define TVD_SCART_ACTIVE_vwidth_mask                                  (0x0000007F)
+#define TVD_SCART_ACTIVE_hst(data)                                    (0x3FC00000&((data)<<22))
+#define TVD_SCART_ACTIVE_hwidth(data)                                 (0x003FC000&((data)<<14))
+#define TVD_SCART_ACTIVE_vst(data)                                    (0x00003F80&((data)<<7))
+#define TVD_SCART_ACTIVE_vwidth(data)                                 (0x0000007F&(data))
+#define TVD_SCART_ACTIVE_get_hst(data)                                ((0x3FC00000&(data))>>22)
+#define TVD_SCART_ACTIVE_get_hwidth(data)                             ((0x003FC000&(data))>>14)
+#define TVD_SCART_ACTIVE_get_vst(data)                                ((0x00003F80&(data))>>7)
+#define TVD_SCART_ACTIVE_get_vwidth(data)                             (0x0000007F&(data))
+
+#define TVD_CLAMP_EN_CTRL                                             0x18019118
+#define TVD_CLAMP_EN_CTRL_reg_addr                                    "0xB8019118"
+#define TVD_CLAMP_EN_CTRL_reg                                         0xB8019118
+#define TVD_CLAMP_EN_CTRL_inst_addr                                   "0x0046"
+#define TVD_CLAMP_EN_CTRL_inst                                        0x0046
+#define TVD_CLAMP_EN_CTRL_clamp_a_up_en_shift                         (7)
+#define TVD_CLAMP_EN_CTRL_clamp_a_dn_en_shift                         (6)
+#define TVD_CLAMP_EN_CTRL_clamp_b_up_en_shift                         (5)
+#define TVD_CLAMP_EN_CTRL_clamp_b_dn_en_shift                         (4)
+#define TVD_CLAMP_EN_CTRL_clamp_c_up_en_shift                         (3)
+#define TVD_CLAMP_EN_CTRL_clamp_c_dn_en_shift                         (2)
+#define TVD_CLAMP_EN_CTRL_clamp_d_up_en_shift                         (1)
+#define TVD_CLAMP_EN_CTRL_clamp_d_dn_en_shift                         (0)
+#define TVD_CLAMP_EN_CTRL_clamp_a_up_en_mask                          (0x00000080)
+#define TVD_CLAMP_EN_CTRL_clamp_a_dn_en_mask                          (0x00000040)
+#define TVD_CLAMP_EN_CTRL_clamp_b_up_en_mask                          (0x00000020)
+#define TVD_CLAMP_EN_CTRL_clamp_b_dn_en_mask                          (0x00000010)
+#define TVD_CLAMP_EN_CTRL_clamp_c_up_en_mask                          (0x00000008)
+#define TVD_CLAMP_EN_CTRL_clamp_c_dn_en_mask                          (0x00000004)
+#define TVD_CLAMP_EN_CTRL_clamp_d_up_en_mask                          (0x00000002)
+#define TVD_CLAMP_EN_CTRL_clamp_d_dn_en_mask                          (0x00000001)
+#define TVD_CLAMP_EN_CTRL_clamp_a_up_en(data)                         (0x00000080&((data)<<7))
+#define TVD_CLAMP_EN_CTRL_clamp_a_dn_en(data)                         (0x00000040&((data)<<6))
+#define TVD_CLAMP_EN_CTRL_clamp_b_up_en(data)                         (0x00000020&((data)<<5))
+#define TVD_CLAMP_EN_CTRL_clamp_b_dn_en(data)                         (0x00000010&((data)<<4))
+#define TVD_CLAMP_EN_CTRL_clamp_c_up_en(data)                         (0x00000008&((data)<<3))
+#define TVD_CLAMP_EN_CTRL_clamp_c_dn_en(data)                         (0x00000004&((data)<<2))
+#define TVD_CLAMP_EN_CTRL_clamp_d_up_en(data)                         (0x00000002&((data)<<1))
+#define TVD_CLAMP_EN_CTRL_clamp_d_dn_en(data)                         (0x00000001&(data))
+#define TVD_CLAMP_EN_CTRL_get_clamp_a_up_en(data)                     ((0x00000080&(data))>>7)
+#define TVD_CLAMP_EN_CTRL_get_clamp_a_dn_en(data)                     ((0x00000040&(data))>>6)
+#define TVD_CLAMP_EN_CTRL_get_clamp_b_up_en(data)                     ((0x00000020&(data))>>5)
+#define TVD_CLAMP_EN_CTRL_get_clamp_b_dn_en(data)                     ((0x00000010&(data))>>4)
+#define TVD_CLAMP_EN_CTRL_get_clamp_c_up_en(data)                     ((0x00000008&(data))>>3)
+#define TVD_CLAMP_EN_CTRL_get_clamp_c_dn_en(data)                     ((0x00000004&(data))>>2)
+#define TVD_CLAMP_EN_CTRL_get_clamp_d_up_en(data)                     ((0x00000002&(data))>>1)
+#define TVD_CLAMP_EN_CTRL_get_clamp_d_dn_en(data)                     (0x00000001&(data))
+
+#define TVD_3B_ADC                                                    0x1801911C
+#define TVD_3B_ADC_reg_addr                                           "0xB801911C"
+#define TVD_3B_ADC_reg                                                0xB801911C
+#define TVD_3B_ADC_inst_addr                                          "0x0047"
+#define TVD_3B_ADC_inst                                               0x0047
+#define TVD_3B_ADC_value_shift                                        (0)
+#define TVD_3B_ADC_value_mask                                         (0x0000007F)
+#define TVD_3B_ADC_value(data)                                        (0x0000007F&(data))
+#define TVD_3B_ADC_get_value(data)                                    (0x0000007F&(data))
+
+#define TVD_DEBUG                                                     0x18019120
+#define TVD_DEBUG_reg_addr                                            "0xB8019120"
+#define TVD_DEBUG_reg                                                 0xB8019120
+#define TVD_DEBUG_inst_addr                                           "0x0048"
+#define TVD_DEBUG_inst                                                0x0048
+#define TVD_DEBUG_muxanalogb_shift                                    (8)
+#define TVD_DEBUG_muxanaloga_shift                                    (4)
+#define TVD_DEBUG_muxdigital_shift                                    (0)
+#define TVD_DEBUG_muxanalogb_mask                                     (0x00000F00)
+#define TVD_DEBUG_muxanaloga_mask                                     (0x000000F0)
+#define TVD_DEBUG_muxdigital_mask                                     (0x0000000F)
+#define TVD_DEBUG_muxanalogb(data)                                    (0x00000F00&((data)<<8))
+#define TVD_DEBUG_muxanaloga(data)                                    (0x000000F0&((data)<<4))
+#define TVD_DEBUG_muxdigital(data)                                    (0x0000000F&(data))
+#define TVD_DEBUG_get_muxanalogb(data)                                ((0x00000F00&(data))>>8)
+#define TVD_DEBUG_get_muxanaloga(data)                                ((0x000000F0&(data))>>4)
+#define TVD_DEBUG_get_muxdigital(data)                                (0x0000000F&(data))
+
+#define TVD_VCR_OPTION                                                0x18019128
+#define TVD_VCR_OPTION_reg_addr                                       "0xB8019128"
+#define TVD_VCR_OPTION_reg                                            0xB8019128
+#define TVD_VCR_OPTION_inst_addr                                      "0x004A"
+#define TVD_VCR_OPTION_inst                                           0x004A
+#define TVD_VCR_OPTION_serration_thd_shift                            (3)
+#define TVD_VCR_OPTION_lock_h_on_no_signal_shift                      (2)
+#define TVD_VCR_OPTION_disable_blue_screen_when_vcr_shift             (1)
+#define TVD_VCR_OPTION_detect_vcr_when_h_unlock_shift                 (0)
+#define TVD_VCR_OPTION_serration_thd_mask                             (0x000007F8)
+#define TVD_VCR_OPTION_lock_h_on_no_signal_mask                       (0x00000004)
+#define TVD_VCR_OPTION_disable_blue_screen_when_vcr_mask              (0x00000002)
+#define TVD_VCR_OPTION_detect_vcr_when_h_unlock_mask                  (0x00000001)
+#define TVD_VCR_OPTION_serration_thd(data)                            (0x000007F8&((data)<<3))
+#define TVD_VCR_OPTION_lock_h_on_no_signal(data)                      (0x00000004&((data)<<2))
+#define TVD_VCR_OPTION_disable_blue_screen_when_vcr(data)             (0x00000002&((data)<<1))
+#define TVD_VCR_OPTION_detect_vcr_when_h_unlock(data)                 (0x00000001&(data))
+#define TVD_VCR_OPTION_get_serration_thd(data)                        ((0x000007F8&(data))>>3)
+#define TVD_VCR_OPTION_get_lock_h_on_no_signal(data)                  ((0x00000004&(data))>>2)
+#define TVD_VCR_OPTION_get_disable_blue_screen_when_vcr(data)         ((0x00000002&(data))>>1)
+#define TVD_VCR_OPTION_get_detect_vcr_when_h_unlock(data)             (0x00000001&(data))
+
+#define TVD_HV_MEASURE_1                                              0x1801912C
+#define TVD_HV_MEASURE_1_reg_addr                                     "0xB801912C"
+#define TVD_HV_MEASURE_1_reg                                          0xB801912C
+#define TVD_HV_MEASURE_1_inst_addr                                    "0x004B"
+#define TVD_HV_MEASURE_1_inst                                         0x004B
+#define TVD_HV_MEASURE_1_first_v_shift                                (10)
+#define TVD_HV_MEASURE_1_second_v_shift                               (0)
+#define TVD_HV_MEASURE_1_first_v_mask                                 (0x000FFC00)
+#define TVD_HV_MEASURE_1_second_v_mask                                (0x000003FF)
+#define TVD_HV_MEASURE_1_first_v(data)                                (0x000FFC00&((data)<<10))
+#define TVD_HV_MEASURE_1_second_v(data)                               (0x000003FF&(data))
+#define TVD_HV_MEASURE_1_get_first_v(data)                            ((0x000FFC00&(data))>>10)
+#define TVD_HV_MEASURE_1_get_second_v(data)                           (0x000003FF&(data))
+
+#define TVD_HV_MEASURE_2                                              0x18019130
+#define TVD_HV_MEASURE_2_reg_addr                                     "0xB8019130"
+#define TVD_HV_MEASURE_2_reg                                          0xB8019130
+#define TVD_HV_MEASURE_2_inst_addr                                    "0x004C"
+#define TVD_HV_MEASURE_2_inst                                         0x004C
+#define TVD_HV_MEASURE_2_count_shift                                  (13)
+#define TVD_HV_MEASURE_2_hgt_shift                                    (0)
+#define TVD_HV_MEASURE_2_count_mask                                   (0x001FE000)
+#define TVD_HV_MEASURE_2_hgt_mask                                     (0x00001FFF)
+#define TVD_HV_MEASURE_2_count(data)                                  (0x001FE000&((data)<<13))
+#define TVD_HV_MEASURE_2_hgt(data)                                    (0x00001FFF&(data))
+#define TVD_HV_MEASURE_2_get_count(data)                              ((0x001FE000&(data))>>13)
+#define TVD_HV_MEASURE_2_get_hgt(data)                                (0x00001FFF&(data))
+
+#define TVD_CRC_CTRL                                                  0x18019134
+#define TVD_CRC_CTRL_reg_addr                                         "0xB8019134"
+#define TVD_CRC_CTRL_reg                                              0xB8019134
+#define TVD_CRC_CTRL_inst_addr                                        "0x004D"
+#define TVD_CRC_CTRL_inst                                             0x004D
+#define TVD_CRC_CTRL_crc_en_shift                                     (1)
+#define TVD_CRC_CTRL_ptgen_en_shift                                   (0)
+#define TVD_CRC_CTRL_crc_en_mask                                      (0x00000002)
+#define TVD_CRC_CTRL_ptgen_en_mask                                    (0x00000001)
+#define TVD_CRC_CTRL_crc_en(data)                                     (0x00000002&((data)<<1))
+#define TVD_CRC_CTRL_ptgen_en(data)                                   (0x00000001&(data))
+#define TVD_CRC_CTRL_get_crc_en(data)                                 ((0x00000002&(data))>>1)
+#define TVD_CRC_CTRL_get_ptgen_en(data)                               (0x00000001&(data))
+
+#define TVD_CRC_CHECKSUM                                              0x18019138
+#define TVD_CRC_CHECKSUM_reg_addr                                     "0xB8019138"
+#define TVD_CRC_CHECKSUM_reg                                          0xB8019138
+#define TVD_CRC_CHECKSUM_inst_addr                                    "0x004E"
+#define TVD_CRC_CHECKSUM_inst                                         0x004E
+#define TVD_CRC_CHECKSUM_checksum_shift                               (0)
+#define TVD_CRC_CHECKSUM_checksum_mask                                (0x0000FFFF)
+#define TVD_CRC_CHECKSUM_checksum(data)                               (0x0000FFFF&(data))
+#define TVD_CRC_CHECKSUM_get_checksum(data)                           (0x0000FFFF&(data))
+
+#define TVD_RAW_MASK                                                  0x1801913C
+#define TVD_RAW_MASK_reg_addr                                         "0xB801913C"
+#define TVD_RAW_MASK_reg                                              0xB801913C
+#define TVD_RAW_MASK_inst_addr                                        "0x004F"
+#define TVD_RAW_MASK_inst                                             0x004F
+#define TVD_RAW_MASK_mask_shift                                       (0)
+#define TVD_RAW_MASK_mask_mask                                        (0x003FFFFF)
+#define TVD_RAW_MASK_mask(data)                                       (0x003FFFFF&(data))
+#define TVD_RAW_MASK_get_mask(data)                                   (0x003FFFFF&(data))
+
+#define TVD_3D_VACTIVE1                                               0x18019140
+#define TVD_3D_VACTIVE1_reg_addr                                      "0xB8019140"
+#define TVD_3D_VACTIVE1_reg                                           0xB8019140
+#define TVD_3D_VACTIVE1_inst_addr                                     "0x0050"
+#define TVD_3D_VACTIVE1_inst                                          0x0050
+#define TVD_3D_VACTIVE1_start_shift                                   (10)
+#define TVD_3D_VACTIVE1_end_shift                                     (0)
+#define TVD_3D_VACTIVE1_start_mask                                    (0x000FFC00)
+#define TVD_3D_VACTIVE1_end_mask                                      (0x000003FF)
+#define TVD_3D_VACTIVE1_start(data)                                   (0x000FFC00&((data)<<10))
+#define TVD_3D_VACTIVE1_end(data)                                     (0x000003FF&(data))
+#define TVD_3D_VACTIVE1_get_start(data)                               ((0x000FFC00&(data))>>10)
+#define TVD_3D_VACTIVE1_get_end(data)                                 (0x000003FF&(data))
+
+#define TVD_3D_VACTIVE2                                               0x18019144
+#define TVD_3D_VACTIVE2_reg_addr                                      "0xB8019144"
+#define TVD_3D_VACTIVE2_reg                                           0xB8019144
+#define TVD_3D_VACTIVE2_inst_addr                                     "0x0051"
+#define TVD_3D_VACTIVE2_inst                                          0x0051
+#define TVD_3D_VACTIVE2_start_shift                                   (10)
+#define TVD_3D_VACTIVE2_end_shift                                     (0)
+#define TVD_3D_VACTIVE2_start_mask                                    (0x000FFC00)
+#define TVD_3D_VACTIVE2_end_mask                                      (0x000003FF)
+#define TVD_3D_VACTIVE2_start(data)                                   (0x000FFC00&((data)<<10))
+#define TVD_3D_VACTIVE2_end(data)                                     (0x000003FF&(data))
+#define TVD_3D_VACTIVE2_get_start(data)                               ((0x000FFC00&(data))>>10)
+#define TVD_3D_VACTIVE2_get_end(data)                                 (0x000003FF&(data))
+
+#define TVD_FRAME_ADDR0                                               0x18019148
+#define TVD_FRAME_ADDR0_reg_addr                                      "0xB8019148"
+#define TVD_FRAME_ADDR0_reg                                           0xB8019148
+#define TVD_FRAME_ADDR0_inst_addr                                     "0x0052"
+#define TVD_FRAME_ADDR0_inst                                          0x0052
+#define TVD_FRAME_ADDR0_frame_adr0_shift                              (0)
+#define TVD_FRAME_ADDR0_frame_adr0_mask                               (0x07FFFFFF)
+#define TVD_FRAME_ADDR0_frame_adr0(data)                              (0x07FFFFFF&(data))
+#define TVD_FRAME_ADDR0_get_frame_adr0(data)                          (0x07FFFFFF&(data))
+
+#define TVD_FRAME_ADDR1                                               0x1801914C
+#define TVD_FRAME_ADDR1_reg_addr                                      "0xB801914C"
+#define TVD_FRAME_ADDR1_reg                                           0xB801914C
+#define TVD_FRAME_ADDR1_inst_addr                                     "0x0053"
+#define TVD_FRAME_ADDR1_inst                                          0x0053
+#define TVD_FRAME_ADDR1_frame_adr1_shift                              (0)
+#define TVD_FRAME_ADDR1_frame_adr1_mask                               (0x07FFFFFF)
+#define TVD_FRAME_ADDR1_frame_adr1(data)                              (0x07FFFFFF&(data))
+#define TVD_FRAME_ADDR1_get_frame_adr1(data)                          (0x07FFFFFF&(data))
+
+#define TVD_DMA_CTRL                                                  0x18019150
+#define TVD_DMA_CTRL_reg_addr                                         "0xB8019150"
+#define TVD_DMA_CTRL_reg                                              0xB8019150
+#define TVD_DMA_CTRL_inst_addr                                        "0x0054"
+#define TVD_DMA_CTRL_inst                                             0x0054
+#define TVD_DMA_CTRL_write_enable5_shift                              (26)
+#define TVD_DMA_CTRL_dmaen_shift                                      (25)
+#define TVD_DMA_CTRL_write_enable4_shift                              (24)
+#define TVD_DMA_CTRL_ififo_thr_shift                                  (18)
+#define TVD_DMA_CTRL_write_enable3_shift                              (17)
+#define TVD_DMA_CTRL_ofifo_thr_shift                                  (11)
+#define TVD_DMA_CTRL_write_enable2_shift                              (10)
+#define TVD_DMA_CTRL_ceiladr_shift                                    (4)
+#define TVD_DMA_CTRL_write_enable1_shift                              (3)
+#define TVD_DMA_CTRL_bstlen_shift                                     (0)
+#define TVD_DMA_CTRL_write_enable5_mask                               (0x04000000)
+#define TVD_DMA_CTRL_dmaen_mask                                       (0x02000000)
+#define TVD_DMA_CTRL_write_enable4_mask                               (0x01000000)
+#define TVD_DMA_CTRL_ififo_thr_mask                                   (0x00FC0000)
+#define TVD_DMA_CTRL_write_enable3_mask                               (0x00020000)
+#define TVD_DMA_CTRL_ofifo_thr_mask                                   (0x0001F800)
+#define TVD_DMA_CTRL_write_enable2_mask                               (0x00000400)
+#define TVD_DMA_CTRL_ceiladr_mask                                     (0x000003F0)
+#define TVD_DMA_CTRL_write_enable1_mask                               (0x00000008)
+#define TVD_DMA_CTRL_bstlen_mask                                      (0x00000007)
+#define TVD_DMA_CTRL_write_enable5(data)                              (0x04000000&((data)<<26))
+#define TVD_DMA_CTRL_dmaen(data)                                      (0x02000000&((data)<<25))
+#define TVD_DMA_CTRL_write_enable4(data)                              (0x01000000&((data)<<24))
+#define TVD_DMA_CTRL_ififo_thr(data)                                  (0x00FC0000&((data)<<18))
+#define TVD_DMA_CTRL_write_enable3(data)                              (0x00020000&((data)<<17))
+#define TVD_DMA_CTRL_ofifo_thr(data)                                  (0x0001F800&((data)<<11))
+#define TVD_DMA_CTRL_write_enable2(data)                              (0x00000400&((data)<<10))
+#define TVD_DMA_CTRL_ceiladr(data)                                    (0x000003F0&((data)<<4))
+#define TVD_DMA_CTRL_write_enable1(data)                              (0x00000008&((data)<<3))
+#define TVD_DMA_CTRL_bstlen(data)                                     (0x00000007&(data))
+#define TVD_DMA_CTRL_get_write_enable5(data)                          ((0x04000000&(data))>>26)
+#define TVD_DMA_CTRL_get_dmaen(data)                                  ((0x02000000&(data))>>25)
+#define TVD_DMA_CTRL_get_write_enable4(data)                          ((0x01000000&(data))>>24)
+#define TVD_DMA_CTRL_get_ififo_thr(data)                              ((0x00FC0000&(data))>>18)
+#define TVD_DMA_CTRL_get_write_enable3(data)                          ((0x00020000&(data))>>17)
+#define TVD_DMA_CTRL_get_ofifo_thr(data)                              ((0x0001F800&(data))>>11)
+#define TVD_DMA_CTRL_get_write_enable2(data)                          ((0x00000400&(data))>>10)
+#define TVD_DMA_CTRL_get_ceiladr(data)                                ((0x000003F0&(data))>>4)
+#define TVD_DMA_CTRL_get_write_enable1(data)                          ((0x00000008&(data))>>3)
+#define TVD_DMA_CTRL_get_bstlen(data)                                 (0x00000007&(data))
+
+#define TVD_DMA_ERR                                                   0x18019154
+#define TVD_DMA_ERR_reg_addr                                          "0xB8019154"
+#define TVD_DMA_ERR_reg                                               0xB8019154
+#define TVD_DMA_ERR_inst_addr                                         "0x0055"
+#define TVD_DMA_ERR_inst                                              0x0055
+#define TVD_DMA_ERR_ififo_err_shift                                   (1)
+#define TVD_DMA_ERR_ofifo_err_shift                                   (0)
+#define TVD_DMA_ERR_ififo_err_mask                                    (0x00000002)
+#define TVD_DMA_ERR_ofifo_err_mask                                    (0x00000001)
+#define TVD_DMA_ERR_ififo_err(data)                                   (0x00000002&((data)<<1))
+#define TVD_DMA_ERR_ofifo_err(data)                                   (0x00000001&(data))
+#define TVD_DMA_ERR_get_ififo_err(data)                               ((0x00000002&(data))>>1)
+#define TVD_DMA_ERR_get_ofifo_err(data)                               (0x00000001&(data))
+
+#define TVD_IPCNT                                                     0x18019158
+#define TVD_IPCNT_reg_addr                                            "0xB8019158"
+#define TVD_IPCNT_reg                                                 0xB8019158
+#define TVD_IPCNT_inst_addr                                           "0x0056"
+#define TVD_IPCNT_inst                                                0x0056
+#define TVD_IPCNT_hcnt_shift                                          (10)
+#define TVD_IPCNT_vcnt_shift                                          (0)
+#define TVD_IPCNT_hcnt_mask                                           (0x000FFC00)
+#define TVD_IPCNT_vcnt_mask                                           (0x000003FF)
+#define TVD_IPCNT_hcnt(data)                                          (0x000FFC00&((data)<<10))
+#define TVD_IPCNT_vcnt(data)                                          (0x000003FF&(data))
+#define TVD_IPCNT_get_hcnt(data)                                      ((0x000FFC00&(data))>>10)
+#define TVD_IPCNT_get_vcnt(data)                                      (0x000003FF&(data))
+
+#define TVD_IP_RESET                                                  0x1801915C
+#define TVD_IP_RESET_reg_addr                                         "0xB801915C"
+#define TVD_IP_RESET_reg                                              0xB801915C
+#define TVD_IP_RESET_inst_addr                                        "0x0057"
+#define TVD_IP_RESET_inst                                             0x0057
+#define TVD_IP_RESET_iprstn_shift                                     (0)
+#define TVD_IP_RESET_iprstn_mask                                      (0x00000001)
+#define TVD_IP_RESET_iprstn(data)                                     (0x00000001&(data))
+#define TVD_IP_RESET_get_iprstn(data)                                 (0x00000001&(data))
+
+#define TVD_ADC_SAMPLE                                                0x18019160
+#define TVD_ADC_SAMPLE_reg_addr                                       "0xB8019160"
+#define TVD_ADC_SAMPLE_reg                                            0xB8019160
+#define TVD_ADC_SAMPLE_inst_addr                                      "0x0058"
+#define TVD_ADC_SAMPLE_inst                                           0x0058
+#define TVD_ADC_SAMPLE_edge_sel4_shift                                (3)
+#define TVD_ADC_SAMPLE_edge_sel3_shift                                (2)
+#define TVD_ADC_SAMPLE_edge_sel2_shift                                (1)
+#define TVD_ADC_SAMPLE_edge_sel1_shift                                (0)
+#define TVD_ADC_SAMPLE_edge_sel4_mask                                 (0x00000008)
+#define TVD_ADC_SAMPLE_edge_sel3_mask                                 (0x00000004)
+#define TVD_ADC_SAMPLE_edge_sel2_mask                                 (0x00000002)
+#define TVD_ADC_SAMPLE_edge_sel1_mask                                 (0x00000001)
+#define TVD_ADC_SAMPLE_edge_sel4(data)                                (0x00000008&((data)<<3))
+#define TVD_ADC_SAMPLE_edge_sel3(data)                                (0x00000004&((data)<<2))
+#define TVD_ADC_SAMPLE_edge_sel2(data)                                (0x00000002&((data)<<1))
+#define TVD_ADC_SAMPLE_edge_sel1(data)                                (0x00000001&(data))
+#define TVD_ADC_SAMPLE_get_edge_sel4(data)                            ((0x00000008&(data))>>3)
+#define TVD_ADC_SAMPLE_get_edge_sel3(data)                            ((0x00000004&(data))>>2)
+#define TVD_ADC_SAMPLE_get_edge_sel2(data)                            ((0x00000002&(data))>>1)
+#define TVD_ADC_SAMPLE_get_edge_sel1(data)                            (0x00000001&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/tve_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/tve_reg.h
new file mode 100644
index 00000000..fd5adcc
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/tve_reg.h
@@ -0,0 +1,7161 @@
+/**************************************************************
+// Spec Version                  : 0.0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/4/22 17:17:31
+***************************************************************/
+
+
+#ifndef _TVE_REG_H_INCLUDED_
+#define _TVE_REG_H_INCLUDED_
+#ifdef  _TVE_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en6:1;
+unsigned int     ph_sync_go:1;
+unsigned int     write_en5:1;
+unsigned int     hi_sync_go:1;
+unsigned int     write_en4:1;
+unsigned int     pi_sync_go:1;
+unsigned int     write_en3:1;
+unsigned int     i_sync_go:1;
+unsigned int     write_en2:1;
+unsigned int     p_sync_go:1;
+unsigned int     write_en1:1;
+unsigned int     h_sync_go:1;
+}TVE_SYNCGEN_RST;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     v_thr:11;
+unsigned int     write_en1:1;
+unsigned int     h_thr:13;
+}TVE_SYNCGEN_I;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en3:1;
+unsigned int     i_p_sel:1;
+unsigned int     write_en2:1;
+unsigned int     v_thr:11;
+unsigned int     write_en1:1;
+unsigned int     h_thr:13;
+}TVE_SYNCGEN_P;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en4:1;
+unsigned int     mode_1080i:1;
+unsigned int     write_en3:1;
+unsigned int     i_p_sel:1;
+unsigned int     write_en2:1;
+unsigned int     v_thr:11;
+unsigned int     write_en1:1;
+unsigned int     h_thr:13;
+}TVE_SYNCGEN_HDMI;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     comp_ebl:1;
+unsigned int     sdtv_ebl:1;
+unsigned int     vs_polar:1;
+unsigned int     hs_polar:1;
+unsigned int     vga_hvsync:1;
+unsigned int     comp_sel:1;
+unsigned int     sync_rb_ebl:1;
+unsigned int     sync_g_ebl:1;
+unsigned int     rgb_mod:1;
+unsigned int     vbi_rb_ebl:1;
+unsigned int     vbi_g_ebl:1;
+unsigned int     hdsync:1;
+unsigned int     syncmod_sel:1;
+unsigned int     write_data:1;
+}TVE_COMP_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     i_field:1;
+unsigned int     i_vcnt:11;
+unsigned int     p_field:1;
+unsigned int     p_vcnt:11;
+}TVE_SYNCGEN_STATUS_I;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     h_field:1;
+unsigned int     h_vcnt:11;
+}TVE_SYNCGEN_STATUS_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     inten_vbi_h:1;
+unsigned int     inten_vbi_i:1;
+unsigned int     inten_vbi_p:1;
+unsigned int     inten_h:1;
+unsigned int     inten_i:1;
+unsigned int     inten_p:1;
+unsigned int     write_data:1;
+}TVE_INTEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     intst_vbi_h:1;
+unsigned int     intst_vbi_i:1;
+unsigned int     intst_vbi_p:1;
+unsigned int     intst_h:1;
+unsigned int     intst_i:1;
+unsigned int     intst_p:1;
+unsigned int     write_data:1;
+}TVE_INTST;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     int_vpos:11;
+unsigned int     write_en1:1;
+unsigned int     int_hpos:13;
+}TVE_INTPOS_I;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     int_vpos:11;
+unsigned int     write_en1:1;
+unsigned int     int_hpos:13;
+}TVE_INTPOS_P1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     int_vpos:11;
+unsigned int     write_en1:1;
+unsigned int     int_hpos:13;
+}TVE_INTPOS_P2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     int_vpos:11;
+unsigned int     write_en1:1;
+unsigned int     int_hpos:13;
+}TVE_INTPOS_H1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     int_vpos:11;
+unsigned int     write_en1:1;
+unsigned int     int_hpos:13;
+}TVE_INTPOS_H2;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     srstn:1;
+}TVE_SRSTN;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     h_colorbar_ebl:1;
+unsigned int     h_black_ebl:1;
+unsigned int     i_colorbar_ebl:1;
+unsigned int     p_colorbar_ebl:1;
+unsigned int     i_black_ebl:1;
+unsigned int     p_black_ebl:1;
+unsigned int     write_data:1;
+}TVE_AV_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     fir422_sel:2;
+}TVE_CAV_422;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_en4:1;
+unsigned int     i_en:1;
+unsigned int     write_en3:1;
+unsigned int     p_en:1;
+unsigned int     write_en2:1;
+unsigned int     i_slewrate:2;
+unsigned int     write_en1:1;
+unsigned int     p_slewrate:2;
+}TVE_AV_SLEW;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     write_en2:1;
+unsigned int     i_h_st:10;
+unsigned int     write_en1:1;
+unsigned int     i_h_end:10;
+}TVE_SLEW_I_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en2:1;
+unsigned int     i_h_st:13;
+unsigned int     write_en1:1;
+unsigned int     i_h_end:13;
+}TVE_AV_I_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en3:1;
+unsigned int     p_av_cord:1;
+unsigned int     write_en2:1;
+unsigned int     p_h_st:13;
+unsigned int     write_en1:1;
+unsigned int     p_h_end:13;
+}TVE_AV_P_HPOS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en3:1;
+unsigned int     h_av_cord:1;
+unsigned int     write_en2:1;
+unsigned int     h_h_st:13;
+unsigned int     write_en1:1;
+unsigned int     h_h_end:13;
+}TVE_AV_H_HPOS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     itop_v_st:11;
+unsigned int     write_en1:1;
+unsigned int     itop_v_end:11;
+}TVE_ITOP_VPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     ibot_v_st:11;
+unsigned int     write_en1:1;
+unsigned int     ibot_v_end:11;
+}TVE_IBOT_VPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     p_v_st:11;
+unsigned int     write_en1:1;
+unsigned int     p_v_end:11;
+}TVE_P_VPOS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     p_v_st:11;
+unsigned int     write_en1:1;
+unsigned int     p_v_end:11;
+}TVE_P_VPOS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     h_v_st:11;
+unsigned int     write_en1:1;
+unsigned int     h_v_end:11;
+}TVE_H_VPOS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     h_v_st:11;
+unsigned int     write_en1:1;
+unsigned int     h_v_end:11;
+}TVE_H_VPOS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     write_en2:1;
+unsigned int     i_h_width:10;
+unsigned int     write_en1:1;
+unsigned int     i_h_st_pos:10;
+}TVE_I_COLORBAR_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     write_en2:1;
+unsigned int     p_h_width:10;
+unsigned int     write_en1:1;
+unsigned int     p_h_st_pos:10;
+}TVE_P_COLORBAR_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     write_en2:1;
+unsigned int     p_h_width:10;
+unsigned int     write_en1:1;
+unsigned int     p_h_st_pos:10;
+}TVE_H_COLORBAR_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en3:1;
+unsigned int     negsyncst:9;
+unsigned int     write_en2:1;
+unsigned int     possyncst:9;
+unsigned int     write_en1:1;
+unsigned int     syncend:9;
+}TVE_COMP_VSYNC_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     1080i_ebl:1;
+}TVE_COMP_SER_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en2:1;
+unsigned int     ser_hstart:13;
+unsigned int     write_en1:1;
+unsigned int     ser_hend:13;
+}TVE_COMP_SER_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en2:1;
+unsigned int     ser_vstart:5;
+unsigned int     write_en1:1;
+unsigned int     ser_vend:5;
+}TVE_COMP_SER_VPOS;
+
+typedef struct 
+{
+unsigned int     write_en4:1;
+unsigned int     dsync_b_vstart:10;
+unsigned int     write_en3:1;
+unsigned int     dsync_b_vend:10;
+unsigned int     write_en2:1;
+unsigned int     dsync_t_vstart:4;
+unsigned int     write_en1:1;
+unsigned int     dsync_t_vend:4;
+}TVE_COMP_DSYNC_VPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en2:1;
+unsigned int     hs_start:13;
+unsigned int     write_en1:1;
+unsigned int     hs_end:13;
+}TVE_VGA_HSYNC_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     vs_st_posv:11;
+unsigned int     write_en1:1;
+unsigned int     vs_st_posh:13;
+}TVE_VGA_VSYNC_ST_POS;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     vs_end_posv:11;
+unsigned int     write_en1:1;
+unsigned int     vs_end_posh:13;
+}TVE_VGA_VSYNC_END_POS;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     write_en2:1;
+unsigned int     ip_vsync_pos1:10;
+unsigned int     write_en1:1;
+unsigned int     ip_vsync_pos2:10;
+}TVE_IP_VSYNCPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     hthr:11;
+}TVE_IP_HSYNCPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en4:1;
+unsigned int     sync_en:1;
+unsigned int     write_en3:1;
+unsigned int     ch_sel:1;
+unsigned int     write_en2:1;
+unsigned int     vpos:11;
+unsigned int     write_en1:1;
+unsigned int     hpos:13;
+}TVE_HDMI_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en2:1;
+unsigned int     hs_start:13;
+unsigned int     write_en1:1;
+unsigned int     hs_end:13;
+}TVE_HDMI_DISP_HS;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     vs_st_pos1v:11;
+unsigned int     write_en1:1;
+unsigned int     vs_st_pos1h:13;
+}TVE_HDMI_DISP_VSST1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     vs_end_pos1v:11;
+unsigned int     write_en1:1;
+unsigned int     vs_end_pos1h:13;
+}TVE_HDMI_DISP_VSED1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     vs_st_pos2v:11;
+unsigned int     write_en1:1;
+unsigned int     vs_st_pos2h:13;
+}TVE_HDMI_DISP_VSST2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     vs_end_pos2v:11;
+unsigned int     write_en1:1;
+unsigned int     vs_end_pos2h:13;
+}TVE_HDMI_DISP_VSED2;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en2:1;
+unsigned int     hpos_end:13;
+unsigned int     write_en1:1;
+unsigned int     hpos_st:13;
+}TVE_HDMI_PXLACT;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en3:1;
+unsigned int     slewrate:2;
+unsigned int     write_en2:1;
+unsigned int     y_negsynclvl:12;
+unsigned int     write_en1:1;
+unsigned int     y_possynclvl:12;
+}TVE_COMP_SYNCLVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     y_sync_h:12;
+unsigned int     write_en1:1;
+unsigned int     y_sync_m:12;
+}TVE_COMP_SYNC_SLEWLVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     y_sync_l:12;
+unsigned int     write_en1:1;
+unsigned int     bp_lvl:12;
+}TVE_COMP_BP_LVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     pbpr_negsynclvl:12;
+unsigned int     write_en1:1;
+unsigned int     pbpr_possynclvl:12;
+}TVE_COMP_PBPR_SYNCLVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     y_blank_lvl:12;
+unsigned int     write_en1:1;
+unsigned int     pbpr_blank_lvl:12;
+}TVE_COMP_PBPR_BLNKLVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     g_up:12;
+unsigned int     write_en1:1;
+unsigned int     g_dn:12;
+}TVE_COMP_G_CLMPLVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     rb_up:12;
+unsigned int     write_en1:1;
+unsigned int     rb_dn:12;
+}TVE_COMP_RB_CLMPLVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     y_black_lvl:8;
+}TVE_IP_INPUT;
+
+typedef struct 
+{
+unsigned int     write_en2:1;
+unsigned int     gain:15;
+unsigned int     write_en1:1;
+unsigned int     offset:15;
+}TVE_VBI_COEFF;
+
+typedef struct 
+{
+unsigned int     write_en2:1;
+unsigned int     gain:15;
+unsigned int     write_en1:1;
+unsigned int     offset:15;
+}TVE_BLNK_COEFF;
+
+typedef struct 
+{
+unsigned int     write_en2:1;
+unsigned int     c2:15;
+unsigned int     write_en1:1;
+unsigned int     c1:15;
+}TVE_AV_COEFF1;
+
+typedef struct 
+{
+unsigned int     write_en2:1;
+unsigned int     c3:15;
+unsigned int     write_en1:1;
+unsigned int     c4:15;
+}TVE_AV_COEFF2;
+
+typedef struct 
+{
+unsigned int     write_en2:1;
+unsigned int     c5:15;
+unsigned int     write_en1:1;
+unsigned int     c6:15;
+}TVE_AV_COEFF3;
+
+typedef struct 
+{
+unsigned int     write_en2:1;
+unsigned int     k1:15;
+unsigned int     write_en1:1;
+unsigned int     k2:15;
+}TVE_AV_COEFF4;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_en1:1;
+unsigned int     vbi_gain_ebl:1;
+unsigned int     write_en2:1;
+unsigned int     k3:15;
+}TVE_AV_COEFF5;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     mv_rb_ebl:1;
+unsigned int     mv_g_ebl:1;
+unsigned int     mv_ebl:1;
+unsigned int     write_data:1;
+}TVE_MV_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     write_en2:1;
+unsigned int     mv_end_line:6;
+unsigned int     write_en1:1;
+unsigned int     mv_st_line:6;
+}TVE_MV_VPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en4:1;
+unsigned int     mv_st_ps:8;
+unsigned int     write_en3:1;
+unsigned int     mv_ps_len:6;
+unsigned int     write_en2:1;
+unsigned int     mv_agc_len:6;
+unsigned int     write_en1:1;
+unsigned int     mv_blnk_len:6;
+}TVE_MV_LEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     mv_rd:20;
+}TVE_MV_RD;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     mv_dn:20;
+}TVE_MV_DN;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     mv_ru:20;
+}TVE_MV_RU;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     mv_up:20;
+}TVE_MV_UP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en3:1;
+unsigned int     mv_ru_dlt:8;
+unsigned int     write_en2:1;
+unsigned int     mv_rd_dlt:8;
+unsigned int     write_en1:1;
+unsigned int     mv_stn:12;
+}TVE_MV_LVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     write_en3:1;
+unsigned int     cgms_i_ebl:1;
+unsigned int     write_en2:1;
+unsigned int     cgms_p_ebl:1;
+unsigned int     write_en1:1;
+unsigned int     cgms_data:20;
+}TVE_CGMS_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     cgms_data:20;
+}TVE_CGMS_CTRL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     write_en2:1;
+unsigned int     cgms_i_vpos1:9;
+unsigned int     write_en1:1;
+unsigned int     cgms_i_vpos2:10;
+}TVE_CGMS_I_VPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     write_en2:1;
+unsigned int     cgms_p_vpos2:11;
+unsigned int     write_en1:1;
+unsigned int     cgms_p_vpos1:10;
+}TVE_CGMS_P_VPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     write_en2:1;
+unsigned int     cgms_i_hst:10;
+unsigned int     write_en1:1;
+unsigned int     cgms_i_len:10;
+}TVE_CGMS_I_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en3:1;
+unsigned int     cgms_p_lvl:8;
+unsigned int     write_en2:1;
+unsigned int     cgms_p_hst:10;
+unsigned int     write_en1:1;
+unsigned int     cgms_p_len:10;
+}TVE_CGMS_P_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     write_en3:1;
+unsigned int     cgms_p_b_ebl:1;
+unsigned int     write_en2:1;
+unsigned int     cgms_p2_vpos2:11;
+unsigned int     write_en1:1;
+unsigned int     cgms_p2_vpos1:10;
+}TVE_CGMS_P2_VPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en3:1;
+unsigned int     cgms_p2_lvl:8;
+unsigned int     write_en2:1;
+unsigned int     cgms_p2_hst:10;
+unsigned int     write_en1:1;
+unsigned int     cgms_p2_len:10;
+}TVE_CGMS_P2_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     cgms_hdr:6;
+}TVE_CGMS_B_HDR;
+
+typedef struct 
+{
+unsigned int     cgms_data:32;
+}TVE_CGMS_B_DATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en4:1;
+unsigned int     wss_ebl:1;
+unsigned int     write_en3:1;
+unsigned int     wss_intp_sel:1;
+unsigned int     write_en2:1;
+unsigned int     wss_end_hpos:11;
+unsigned int     write_en1:1;
+unsigned int     wss_data:14;
+}TVE_WSS_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     write_en2:1;
+unsigned int     wss_h_pos:11;
+unsigned int     write_en1:1;
+unsigned int     wss_v_pos:10;
+}TVE_WSS_POS;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     write_en3:1;
+unsigned int     wss_ebl:1;
+unsigned int     write_en2:1;
+unsigned int     wss_intp_sel:1;
+unsigned int     write_en1:1;
+unsigned int     wss_data:14;
+}TVE_625P_WSS_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     write_en2:1;
+unsigned int     wss_h_pos:11;
+unsigned int     write_en1:1;
+unsigned int     wss_v_pos:10;
+}TVE_625P_WSS_POS;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     write_en4:1;
+unsigned int     tt_h_st:11;
+unsigned int     write_en3:1;
+unsigned int     tt_line_no:8;
+unsigned int     write_en2:1;
+unsigned int     tt_intp_sel:1;
+unsigned int     write_en1:1;
+unsigned int     vbi_tt_ebl:1;
+}TVE_TT_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_en2:1;
+unsigned int     tt_b_vst:9;
+unsigned int     write_en1:1;
+unsigned int     tt_t_vst:5;
+}TVE_TT_VPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     start_line2:11;
+unsigned int     write_en1:1;
+unsigned int     start_line1:11;
+}TVE_TT_MASK_VPOS;
+
+typedef struct 
+{
+unsigned int     tt_line_mask:32;
+}TVE_TT_MASK_FLG;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_en4:1;
+unsigned int     vps_h_pos:11;
+unsigned int     write_en3:1;
+unsigned int     vps_v_pos:10;
+unsigned int     write_en2:1;
+unsigned int     vps_intp_sel:1;
+unsigned int     write_en1:1;
+unsigned int     vbi_vps_ebl:1;
+}TVE_VPS_CTRL;
+
+typedef struct 
+{
+unsigned int     vps_data:32;
+}TVE_VPS_DATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     vps_data:8;
+}TVE_VPS_DATA1;
+
+typedef struct 
+{
+unsigned int     write_en4:1;
+unsigned int     dwn_ebl:2;
+unsigned int     write_en3:1;
+unsigned int     dwn_i_p_sel:1;
+unsigned int     write_en2:1;
+unsigned int     dwn_st_i:12;
+unsigned int     write_en1:1;
+unsigned int     dwn_end_i:13;
+}TVE_VBI_DWN_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_en2:1;
+unsigned int     dwn_st_p:12;
+unsigned int     write_en1:1;
+unsigned int     dwn_end_p:13;
+}TVE_VBI_DWN_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     vbi_start_line2:11;
+unsigned int     write_en1:1;
+unsigned int     vbi_start_line1:11;
+}TVE_VBI_DWN_VPOS_I;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     vbi_start_line2:11;
+unsigned int     write_en1:1;
+unsigned int     vbi_start_line1:11;
+}TVE_VBI_DWN_VPOS_P;
+
+typedef struct 
+{
+unsigned int     vbi_line_flg:32;
+}TVE_VBI_LINE_FLAG_I;
+
+typedef struct 
+{
+unsigned int     vbi_line_flg:32;
+}TVE_VBI_LINE_FLAG_P;
+
+typedef struct 
+{
+unsigned int     vbi_pty:32;
+}TVE_VBI_LINE_PTY_I;
+
+typedef struct 
+{
+unsigned int     vbi_pty:32;
+}TVE_VBI_LINE_PTY_P;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_en3:1;
+unsigned int     di_i_p_sel:2;
+unsigned int     write_en2:1;
+unsigned int     hact_start:13;
+unsigned int     write_en1:1;
+unsigned int     hact_end:13;
+}TVE_DIF_HACTIVE;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     cd:1;
+unsigned int     di_bus_swap:1;
+unsigned int     di_clk_phs:1;
+unsigned int     di_fpga_clk_sel:1;
+unsigned int     di_vbi_bypass:1;
+unsigned int     di_ebl:1;
+unsigned int     di_source_sel:1;
+unsigned int     di_mod:1;
+unsigned int     di_hdr_ebl:1;
+unsigned int     write_data:1;
+}TVE_DIF_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_en3:1;
+unsigned int     hs_polar:1;
+unsigned int     write_en2:1;
+unsigned int     hs_start:13;
+unsigned int     write_en1:1;
+unsigned int     hs_end:13;
+}TVE_DIF_HSYNC;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en3:1;
+unsigned int     vs_polar:1;
+unsigned int     write_en2:1;
+unsigned int     vs_st_pos1v:11;
+unsigned int     write_en1:1;
+unsigned int     vs_st_pos1h:13;
+}TVE_DIF_VS_ST_POS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     vs_end_pos1v:11;
+unsigned int     write_en1:1;
+unsigned int     vs_end_pos1h:13;
+}TVE_DIF_VS_END_POS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     vs_st_pos2v:11;
+unsigned int     write_en1:1;
+unsigned int     vs_st_pos2h:13;
+}TVE_DIF_VS_ST_POS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     vs_end_pos2v:11;
+unsigned int     write_en1:1;
+unsigned int     vs_end_pos2h:13;
+}TVE_DIF_VS_END_POS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     v_tgl_hi:11;
+unsigned int     write_en1:1;
+unsigned int     v_tgl_lo:11;
+}TVE_DIF_F_BIT_POS;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     v_tgl1_hi:11;
+unsigned int     write_en1:1;
+unsigned int     v_tgl1_lo:11;
+}TVE_DIF_V_BIT_POS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     v_tgl2_hi:11;
+unsigned int     write_en1:1;
+unsigned int     v_tgl2_lo:11;
+}TVE_DIF_V_BIT_POS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en2:1;
+unsigned int     fv_start:13;
+unsigned int     write_en1:1;
+unsigned int     fv_end:13;
+}TVE_DIF_FV_BIT_HPOS;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     phi:8;
+}TVE_IP_PHS;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sctoh:8;
+}TVE_IP_SCTOH;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     u_invert:1;
+unsigned int     v_invert:1;
+unsigned int     t_offset_phase:1;
+unsigned int     t_reset_fsc:1;
+}TVE_IP_F_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     t_sel_sin:1;
+unsigned int     t_fsc_rom:1;
+}TVE_IP_T_SEL_SIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     black_lvl:8;
+}TVE_IP_BLCK_LVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     blank_lvl:8;
+}TVE_IP_BLNK_LVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     clamp_lvl:8;
+}TVE_IP_CLAMP_LVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sync_lvl:8;
+}TVE_IP_SYNC_LVL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     y_interp:2;
+unsigned int     y_colorbar_en:1;
+unsigned int     t_ydel_adj:3;
+unsigned int     t_sel_ylpf:1;
+unsigned int     t_ygain_val:1;
+}TVE_IP_Y_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     t_byp_yups:1;
+unsigned int     t_sel_ylp:1;
+unsigned int     t_ygain_off:1;
+unsigned int     y_tsin_cos:1;
+unsigned int     y_tsel_dac_tst:1;
+unsigned int     y_tdig_out:2;
+}TVE_IP_TEST_PARAM;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     y_gain:10;
+}TVE_IP_Y_GAIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sync_lvl_h:8;
+}TVE_IP_SYNC_LVL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sync_lvl_m:8;
+}TVE_IP_SYNC_LVL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sync_lvl_l:8;
+}TVE_IP_SYNC_LVL4;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     y_tsel_yuv:1;
+unsigned int     t_pd_cvdac:1;
+unsigned int     t_pd_ydac:1;
+unsigned int     t_pd_cdac:1;
+}TVE_IP_O_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     nba:8;
+}TVE_IP_NBA;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     pba:8;
+}TVE_IP_PBA;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     t_pal_clpf:1;
+unsigned int     t_sel_c_gain:1;
+}TVE_IP_C_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     t_byp_cups:1;
+unsigned int     t_byp_clpf:1;
+unsigned int     t_c_gain_off:1;
+}TVE_IP_TEST_T_BYP_CUPS;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     clpf_gain:8;
+}TVE_IP_SYNCLPF_GAIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     t_hsync_phs:1;
+unsigned int     t_vsync_phs:1;
+unsigned int     y_tsyncmode:3;
+unsigned int     y_tencd_mode:3;
+}TVE_IP_S_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     clk_phs:2;
+unsigned int     t_fsync_enbl:1;
+unsigned int     t_fsync_phs:1;
+unsigned int     reserved_1:2;
+unsigned int     vso:2;
+}TVE_IP_VSO0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     vso:8;
+}TVE_IP_VSO1;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     hso:3;
+}TVE_IP_HSO0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     hso:8;
+}TVE_IP_HSO1;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     hlc:2;
+}TVE_IP_HLC0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     hlc:8;
+}TVE_IP_HLC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ccd_odd:8;
+}TVE_IP_CCD_ODD;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     ccd_even:8;
+}TVE_IP_CCD_EVEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cc_enbl:2;
+}TVE_IP_CCD_ENBL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     hlr:2;
+}TVE_IP_TEST_HLR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     hlr:8;
+}TVE_IP_TEST_HLR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     vsmr:5;
+}TVE_IP_TEST_VSMR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     sync_strt:4;
+}TVE_IP_SYNC_STRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     sync_end:7;
+}TVE_IP_SYNC_END;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     sync_srend:8;
+}TVE_IP_SYNC_SREND;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     sync_eqend:6;
+}TVE_IP_SYNC_EQEND;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     actv_strt:8;
+}TVE_IP_ACTV_STRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     actv_end:8;
+}TVE_IP_ACTV_END;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     wbrst_strt:7;
+}TVE_IP_WBRST_STRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     nbrst_strt:7;
+}TVE_IP_NBRST_STRT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     nbrst_end:8;
+}TVE_IP_NBRST_END;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvfcr:8;
+}TVE_IP_MVFCR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvcsl1:8;
+}TVE_IP_MVCSL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     mvcls1:6;
+}TVE_IP_MVCLS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvcsl2:8;
+}TVE_IP_MVCSL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     mvcls2:6;
+}TVE_IP_MVCLS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvcssp:3;
+unsigned int     mvcsnum:3;
+unsigned int     mvcsln:2;
+}TVE_IP_MVCSSP;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     mvpsd:6;
+}TVE_IP_MVPSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     mvpsl:6;
+}TVE_IP_MVPSL;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     mvpss:6;
+}TVE_IP_MVPSS;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     mvpsls:7;
+}TVE_IP_MVPSLS0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvpsls:8;
+}TVE_IP_MVPSLS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     mvpsfs:7;
+}TVE_IP_MVPSFS0;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvpsfs:8;
+}TVE_IP_MVPSFS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvpsagca:8;
+}TVE_IP_MVPSAGCA;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvpsagcb:8;
+}TVE_IP_MVPSAGCB;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mveofbpc:8;
+}TVE_IP_MVEOFBPC;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvpbz1:4;
+unsigned int     mvpbz2:4;
+}TVE_IP_MVPBZ1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvpbz3:4;
+unsigned int     mvpadvbsen:1;
+unsigned int     mvpzninvrt:3;
+}TVE_IP_MVPBZ3;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvpcslimd_lsb:8;
+}TVE_IP_MVPCSLIMD0;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     mvpcslimd_msb:2;
+}TVE_IP_MVPCSLIMD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     mvtms:8;
+}TVE_IP_MV_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     vdac_apow:1;
+unsigned int     vdac_bpow:1;
+unsigned int     vdac_cpow:1;
+unsigned int     powldv_l:1;
+unsigned int     stanby_l:1;
+unsigned int     reserved_1:2;
+unsigned int     biasa_regl:4;
+unsigned int     reserved_2:2;
+unsigned int     biasb_regl:4;
+unsigned int     reserved_3:2;
+unsigned int     biasc_regl:4;
+}TVE_VIDEO_DAC_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     abiq_regl:3;
+unsigned int     ldvbias_regl:3;
+unsigned int     vcmref_regl:2;
+unsigned int     reserved_1:2;
+unsigned int     vdac_cf_regl:3;
+unsigned int     vdac_rf_regl:2;
+}TVE_VIDEO_DAC_CTRL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     write_en6:1;
+unsigned int     dcc2_l:1;
+unsigned int     write_en5:1;
+unsigned int     dcc_l:1;
+unsigned int     write_en4:1;
+unsigned int     caldiv:2;
+unsigned int     reserved_1:3;
+unsigned int     write_en3:1;
+unsigned int     div_regl:2;
+unsigned int     write_en2:1;
+unsigned int     ckmode_regl:2;
+unsigned int     write_en1:1;
+unsigned int     calen_regl:2;
+}TVE_VIDEO_DAC_CTRL3;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     write_en1:1;
+unsigned int     dac0_sel:2;
+}TVE_DAC_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     write_en6:1;
+unsigned int     up_ctrl_prog:2;
+unsigned int     write_en5:1;
+unsigned int     up_ctrl_int0:2;
+unsigned int     write_en4:1;
+unsigned int     up_ctrl_int1:2;
+unsigned int     write_en3:1;
+unsigned int     dacmode:2;
+unsigned int     write_en2:1;
+unsigned int     swap23:1;
+unsigned int     write_en1:1;
+unsigned int     swap56:1;
+}TVE_DAC_MUX;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     write_en3:1;
+unsigned int     ygdelay:2;
+unsigned int     write_en2:1;
+unsigned int     bdelay:2;
+unsigned int     write_en1:1;
+unsigned int     rdelay:2;
+}TVE_CMP_DLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en4:1;
+unsigned int     out_control123:3;
+unsigned int     write_en3:1;
+unsigned int     neg_out:6;
+unsigned int     write_en2:1;
+unsigned int     out_control:1;
+unsigned int     write_en1:1;
+unsigned int     dac_value:10;
+unsigned int     reserved_1:2;
+}TVE_DAC_MISC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     dac_value3:10;
+unsigned int     dac_value2:10;
+unsigned int     dac_value1:10;
+}TVE_DAC_MISC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_en3:1;
+unsigned int     sel1:4;
+unsigned int     write_en2:1;
+unsigned int     sel0:4;
+unsigned int     write_en1:1;
+unsigned int     enable:1;
+}TVE_DBG;
+
+typedef struct 
+{
+unsigned int     dummy:32;
+}TVE_DUMMY;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     aio_dac_en:1;
+unsigned int     dac1_en:1;
+unsigned int     dac0_en:1;
+}TVE_DAC_TEST;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     int_vpos:11;
+unsigned int     write_en1:1;
+unsigned int     int_hpos:13;
+}TVE_INTVBI_I;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     int_vpos:11;
+unsigned int     write_en1:1;
+unsigned int     int_hpos:13;
+}TVE_INTVBI_P1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     int_vpos:11;
+unsigned int     write_en1:1;
+unsigned int     int_hpos:13;
+}TVE_INTVBI_P2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     int_vpos:11;
+unsigned int     write_en1:1;
+unsigned int     int_hpos:13;
+}TVE_INTVBI_H1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_en2:1;
+unsigned int     int_vpos:11;
+unsigned int     write_en1:1;
+unsigned int     int_hpos:13;
+}TVE_INTVBI_H2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}TVE_DAC1_FIR_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c3:14;
+unsigned int     reserved_1:2;
+unsigned int     c2:14;
+}TVE_DAC1_FIR_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}TVE_DAC2_FIR_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c3:14;
+unsigned int     reserved_1:2;
+unsigned int     c2:14;
+}TVE_DAC2_FIR_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}TVE_DAC3_FIR_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c3:14;
+unsigned int     reserved_1:2;
+unsigned int     c2:14;
+}TVE_DAC3_FIR_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}TVE_DAC4_FIR_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c3:14;
+unsigned int     reserved_1:2;
+unsigned int     c2:14;
+}TVE_DAC4_FIR_2;
+
+typedef struct 
+{
+unsigned int     reg_vdac_dac_en:1;
+unsigned int     reg_vdac_powmbias:1;
+unsigned int     reg_vdac_mbias_envr:1;
+unsigned int     reg_vdac_mbias_vr15sel:2;
+unsigned int     reg_vdac_bg_rbg2:2;
+unsigned int     reg_vdac_bg_envbgup:1;
+unsigned int     reg_vdac_bg_rbg:3;
+unsigned int     reg_vdac_dac_vref_adj:2;
+unsigned int     reg_vdac_dac_res75_setup:5;
+unsigned int     reg_vdac_dac_clkedge:1;
+unsigned int     reg_vdac_dac_cur:4;
+unsigned int     reg_vdac_dac_cal75_en:1;
+unsigned int     reg_vdac_dac_draw_en:1;
+unsigned int     reg_vdac_dac_plugin_en:1;
+unsigned int     reg_vdac_dac_res75_en:1;
+unsigned int     reg_vdac_dac_res75_sel:1;
+unsigned int     reserved_0:4;
+}TVE_VDAC_CTR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     reg_vdac_bg_auto_en:1;
+unsigned int     reg_vdac_dac_rescal:5;
+unsigned int     reg_vdac_dac_plugin:1;
+unsigned int     reg_vdac_dac_drawout:1;
+}TVE_VDAC_CTR2;
+
+#endif
+
+#define TVE_SYNCGEN_RST                                                              0x18018000
+#define TVE_SYNCGEN_RST_reg_addr                                                     "0xB8018000"
+#define TVE_SYNCGEN_RST_reg                                                          0xB8018000
+#define set_TVE_SYNCGEN_RST_reg(data)   (*((volatile unsigned int*) TVE_SYNCGEN_RST_reg)=data)
+#define get_TVE_SYNCGEN_RST_reg   (*((volatile unsigned int*) TVE_SYNCGEN_RST_reg))
+#define TVE_SYNCGEN_RST_inst_adr                                                     "0x0000"
+#define TVE_SYNCGEN_RST_inst                                                         0x0000
+#define TVE_SYNCGEN_RST_write_en6_shift                                              (11)
+#define TVE_SYNCGEN_RST_write_en6_mask                                               (0x00000800)
+#define TVE_SYNCGEN_RST_write_en6(data)                                              (0x00000800&((data)<<11))
+#define TVE_SYNCGEN_RST_write_en6_src(data)                                          ((0x00000800&(data))>>11)
+#define TVE_SYNCGEN_RST_get_write_en6(data)                                          ((0x00000800&(data))>>11)
+#define TVE_SYNCGEN_RST_ph_sync_go_shift                                             (10)
+#define TVE_SYNCGEN_RST_ph_sync_go_mask                                              (0x00000400)
+#define TVE_SYNCGEN_RST_ph_sync_go(data)                                             (0x00000400&((data)<<10))
+#define TVE_SYNCGEN_RST_ph_sync_go_src(data)                                         ((0x00000400&(data))>>10)
+#define TVE_SYNCGEN_RST_get_ph_sync_go(data)                                         ((0x00000400&(data))>>10)
+#define TVE_SYNCGEN_RST_write_en5_shift                                              (9)
+#define TVE_SYNCGEN_RST_write_en5_mask                                               (0x00000200)
+#define TVE_SYNCGEN_RST_write_en5(data)                                              (0x00000200&((data)<<9))
+#define TVE_SYNCGEN_RST_write_en5_src(data)                                          ((0x00000200&(data))>>9)
+#define TVE_SYNCGEN_RST_get_write_en5(data)                                          ((0x00000200&(data))>>9)
+#define TVE_SYNCGEN_RST_hi_sync_go_shift                                             (8)
+#define TVE_SYNCGEN_RST_hi_sync_go_mask                                              (0x00000100)
+#define TVE_SYNCGEN_RST_hi_sync_go(data)                                             (0x00000100&((data)<<8))
+#define TVE_SYNCGEN_RST_hi_sync_go_src(data)                                         ((0x00000100&(data))>>8)
+#define TVE_SYNCGEN_RST_get_hi_sync_go(data)                                         ((0x00000100&(data))>>8)
+#define TVE_SYNCGEN_RST_write_en4_shift                                              (7)
+#define TVE_SYNCGEN_RST_write_en4_mask                                               (0x00000080)
+#define TVE_SYNCGEN_RST_write_en4(data)                                              (0x00000080&((data)<<7))
+#define TVE_SYNCGEN_RST_write_en4_src(data)                                          ((0x00000080&(data))>>7)
+#define TVE_SYNCGEN_RST_get_write_en4(data)                                          ((0x00000080&(data))>>7)
+#define TVE_SYNCGEN_RST_pi_sync_go_shift                                             (6)
+#define TVE_SYNCGEN_RST_pi_sync_go_mask                                              (0x00000040)
+#define TVE_SYNCGEN_RST_pi_sync_go(data)                                             (0x00000040&((data)<<6))
+#define TVE_SYNCGEN_RST_pi_sync_go_src(data)                                         ((0x00000040&(data))>>6)
+#define TVE_SYNCGEN_RST_get_pi_sync_go(data)                                         ((0x00000040&(data))>>6)
+#define TVE_SYNCGEN_RST_write_en3_shift                                              (5)
+#define TVE_SYNCGEN_RST_write_en3_mask                                               (0x00000020)
+#define TVE_SYNCGEN_RST_write_en3(data)                                              (0x00000020&((data)<<5))
+#define TVE_SYNCGEN_RST_write_en3_src(data)                                          ((0x00000020&(data))>>5)
+#define TVE_SYNCGEN_RST_get_write_en3(data)                                          ((0x00000020&(data))>>5)
+#define TVE_SYNCGEN_RST_i_sync_go_shift                                              (4)
+#define TVE_SYNCGEN_RST_i_sync_go_mask                                               (0x00000010)
+#define TVE_SYNCGEN_RST_i_sync_go(data)                                              (0x00000010&((data)<<4))
+#define TVE_SYNCGEN_RST_i_sync_go_src(data)                                          ((0x00000010&(data))>>4)
+#define TVE_SYNCGEN_RST_get_i_sync_go(data)                                          ((0x00000010&(data))>>4)
+#define TVE_SYNCGEN_RST_write_en2_shift                                              (3)
+#define TVE_SYNCGEN_RST_write_en2_mask                                               (0x00000008)
+#define TVE_SYNCGEN_RST_write_en2(data)                                              (0x00000008&((data)<<3))
+#define TVE_SYNCGEN_RST_write_en2_src(data)                                          ((0x00000008&(data))>>3)
+#define TVE_SYNCGEN_RST_get_write_en2(data)                                          ((0x00000008&(data))>>3)
+#define TVE_SYNCGEN_RST_p_sync_go_shift                                              (2)
+#define TVE_SYNCGEN_RST_p_sync_go_mask                                               (0x00000004)
+#define TVE_SYNCGEN_RST_p_sync_go(data)                                              (0x00000004&((data)<<2))
+#define TVE_SYNCGEN_RST_p_sync_go_src(data)                                          ((0x00000004&(data))>>2)
+#define TVE_SYNCGEN_RST_get_p_sync_go(data)                                          ((0x00000004&(data))>>2)
+#define TVE_SYNCGEN_RST_write_en1_shift                                              (1)
+#define TVE_SYNCGEN_RST_write_en1_mask                                               (0x00000002)
+#define TVE_SYNCGEN_RST_write_en1(data)                                              (0x00000002&((data)<<1))
+#define TVE_SYNCGEN_RST_write_en1_src(data)                                          ((0x00000002&(data))>>1)
+#define TVE_SYNCGEN_RST_get_write_en1(data)                                          ((0x00000002&(data))>>1)
+#define TVE_SYNCGEN_RST_h_sync_go_shift                                              (0)
+#define TVE_SYNCGEN_RST_h_sync_go_mask                                               (0x00000001)
+#define TVE_SYNCGEN_RST_h_sync_go(data)                                              (0x00000001&((data)<<0))
+#define TVE_SYNCGEN_RST_h_sync_go_src(data)                                          ((0x00000001&(data))>>0)
+#define TVE_SYNCGEN_RST_get_h_sync_go(data)                                          ((0x00000001&(data))>>0)
+
+
+#define TVE_SYNCGEN_I                                                                0x18018004
+#define TVE_SYNCGEN_I_reg_addr                                                       "0xB8018004"
+#define TVE_SYNCGEN_I_reg                                                            0xB8018004
+#define set_TVE_SYNCGEN_I_reg(data)   (*((volatile unsigned int*) TVE_SYNCGEN_I_reg)=data)
+#define get_TVE_SYNCGEN_I_reg   (*((volatile unsigned int*) TVE_SYNCGEN_I_reg))
+#define TVE_SYNCGEN_I_inst_adr                                                       "0x0001"
+#define TVE_SYNCGEN_I_inst                                                           0x0001
+#define TVE_SYNCGEN_I_write_en2_shift                                                (25)
+#define TVE_SYNCGEN_I_write_en2_mask                                                 (0x02000000)
+#define TVE_SYNCGEN_I_write_en2(data)                                                (0x02000000&((data)<<25))
+#define TVE_SYNCGEN_I_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define TVE_SYNCGEN_I_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define TVE_SYNCGEN_I_v_thr_shift                                                    (14)
+#define TVE_SYNCGEN_I_v_thr_mask                                                     (0x01FFC000)
+#define TVE_SYNCGEN_I_v_thr(data)                                                    (0x01FFC000&((data)<<14))
+#define TVE_SYNCGEN_I_v_thr_src(data)                                                ((0x01FFC000&(data))>>14)
+#define TVE_SYNCGEN_I_get_v_thr(data)                                                ((0x01FFC000&(data))>>14)
+#define TVE_SYNCGEN_I_write_en1_shift                                                (13)
+#define TVE_SYNCGEN_I_write_en1_mask                                                 (0x00002000)
+#define TVE_SYNCGEN_I_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_SYNCGEN_I_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_SYNCGEN_I_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_SYNCGEN_I_h_thr_shift                                                    (0)
+#define TVE_SYNCGEN_I_h_thr_mask                                                     (0x00001FFF)
+#define TVE_SYNCGEN_I_h_thr(data)                                                    (0x00001FFF&((data)<<0))
+#define TVE_SYNCGEN_I_h_thr_src(data)                                                ((0x00001FFF&(data))>>0)
+#define TVE_SYNCGEN_I_get_h_thr(data)                                                ((0x00001FFF&(data))>>0)
+
+
+#define TVE_SYNCGEN_P                                                                0x18018008
+#define TVE_SYNCGEN_P_reg_addr                                                       "0xB8018008"
+#define TVE_SYNCGEN_P_reg                                                            0xB8018008
+#define set_TVE_SYNCGEN_P_reg(data)   (*((volatile unsigned int*) TVE_SYNCGEN_P_reg)=data)
+#define get_TVE_SYNCGEN_P_reg   (*((volatile unsigned int*) TVE_SYNCGEN_P_reg))
+#define TVE_SYNCGEN_P_inst_adr                                                       "0x0002"
+#define TVE_SYNCGEN_P_inst                                                           0x0002
+#define TVE_SYNCGEN_P_write_en3_shift                                                (27)
+#define TVE_SYNCGEN_P_write_en3_mask                                                 (0x08000000)
+#define TVE_SYNCGEN_P_write_en3(data)                                                (0x08000000&((data)<<27))
+#define TVE_SYNCGEN_P_write_en3_src(data)                                            ((0x08000000&(data))>>27)
+#define TVE_SYNCGEN_P_get_write_en3(data)                                            ((0x08000000&(data))>>27)
+#define TVE_SYNCGEN_P_i_p_sel_shift                                                  (26)
+#define TVE_SYNCGEN_P_i_p_sel_mask                                                   (0x04000000)
+#define TVE_SYNCGEN_P_i_p_sel(data)                                                  (0x04000000&((data)<<26))
+#define TVE_SYNCGEN_P_i_p_sel_src(data)                                              ((0x04000000&(data))>>26)
+#define TVE_SYNCGEN_P_get_i_p_sel(data)                                              ((0x04000000&(data))>>26)
+#define TVE_SYNCGEN_P_write_en2_shift                                                (25)
+#define TVE_SYNCGEN_P_write_en2_mask                                                 (0x02000000)
+#define TVE_SYNCGEN_P_write_en2(data)                                                (0x02000000&((data)<<25))
+#define TVE_SYNCGEN_P_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define TVE_SYNCGEN_P_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define TVE_SYNCGEN_P_v_thr_shift                                                    (14)
+#define TVE_SYNCGEN_P_v_thr_mask                                                     (0x01FFC000)
+#define TVE_SYNCGEN_P_v_thr(data)                                                    (0x01FFC000&((data)<<14))
+#define TVE_SYNCGEN_P_v_thr_src(data)                                                ((0x01FFC000&(data))>>14)
+#define TVE_SYNCGEN_P_get_v_thr(data)                                                ((0x01FFC000&(data))>>14)
+#define TVE_SYNCGEN_P_write_en1_shift                                                (13)
+#define TVE_SYNCGEN_P_write_en1_mask                                                 (0x00002000)
+#define TVE_SYNCGEN_P_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_SYNCGEN_P_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_SYNCGEN_P_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_SYNCGEN_P_h_thr_shift                                                    (0)
+#define TVE_SYNCGEN_P_h_thr_mask                                                     (0x00001FFF)
+#define TVE_SYNCGEN_P_h_thr(data)                                                    (0x00001FFF&((data)<<0))
+#define TVE_SYNCGEN_P_h_thr_src(data)                                                ((0x00001FFF&(data))>>0)
+#define TVE_SYNCGEN_P_get_h_thr(data)                                                ((0x00001FFF&(data))>>0)
+
+
+#define TVE_SYNCGEN_HDMI                                                             0x1801800c
+#define TVE_SYNCGEN_HDMI_reg_addr                                                    "0xB801800C"
+#define TVE_SYNCGEN_HDMI_reg                                                         0xB801800C
+#define set_TVE_SYNCGEN_HDMI_reg(data)   (*((volatile unsigned int*) TVE_SYNCGEN_HDMI_reg)=data)
+#define get_TVE_SYNCGEN_HDMI_reg   (*((volatile unsigned int*) TVE_SYNCGEN_HDMI_reg))
+#define TVE_SYNCGEN_HDMI_inst_adr                                                    "0x0003"
+#define TVE_SYNCGEN_HDMI_inst                                                        0x0003
+#define TVE_SYNCGEN_HDMI_write_en4_shift                                             (29)
+#define TVE_SYNCGEN_HDMI_write_en4_mask                                              (0x20000000)
+#define TVE_SYNCGEN_HDMI_write_en4(data)                                             (0x20000000&((data)<<29))
+#define TVE_SYNCGEN_HDMI_write_en4_src(data)                                         ((0x20000000&(data))>>29)
+#define TVE_SYNCGEN_HDMI_get_write_en4(data)                                         ((0x20000000&(data))>>29)
+#define TVE_SYNCGEN_HDMI_mode_1080i_shift                                            (28)
+#define TVE_SYNCGEN_HDMI_mode_1080i_mask                                             (0x10000000)
+#define TVE_SYNCGEN_HDMI_mode_1080i(data)                                            (0x10000000&((data)<<28))
+#define TVE_SYNCGEN_HDMI_mode_1080i_src(data)                                        ((0x10000000&(data))>>28)
+#define TVE_SYNCGEN_HDMI_get_mode_1080i(data)                                        ((0x10000000&(data))>>28)
+#define TVE_SYNCGEN_HDMI_write_en3_shift                                             (27)
+#define TVE_SYNCGEN_HDMI_write_en3_mask                                              (0x08000000)
+#define TVE_SYNCGEN_HDMI_write_en3(data)                                             (0x08000000&((data)<<27))
+#define TVE_SYNCGEN_HDMI_write_en3_src(data)                                         ((0x08000000&(data))>>27)
+#define TVE_SYNCGEN_HDMI_get_write_en3(data)                                         ((0x08000000&(data))>>27)
+#define TVE_SYNCGEN_HDMI_i_p_sel_shift                                               (26)
+#define TVE_SYNCGEN_HDMI_i_p_sel_mask                                                (0x04000000)
+#define TVE_SYNCGEN_HDMI_i_p_sel(data)                                               (0x04000000&((data)<<26))
+#define TVE_SYNCGEN_HDMI_i_p_sel_src(data)                                           ((0x04000000&(data))>>26)
+#define TVE_SYNCGEN_HDMI_get_i_p_sel(data)                                           ((0x04000000&(data))>>26)
+#define TVE_SYNCGEN_HDMI_write_en2_shift                                             (25)
+#define TVE_SYNCGEN_HDMI_write_en2_mask                                              (0x02000000)
+#define TVE_SYNCGEN_HDMI_write_en2(data)                                             (0x02000000&((data)<<25))
+#define TVE_SYNCGEN_HDMI_write_en2_src(data)                                         ((0x02000000&(data))>>25)
+#define TVE_SYNCGEN_HDMI_get_write_en2(data)                                         ((0x02000000&(data))>>25)
+#define TVE_SYNCGEN_HDMI_v_thr_shift                                                 (14)
+#define TVE_SYNCGEN_HDMI_v_thr_mask                                                  (0x01FFC000)
+#define TVE_SYNCGEN_HDMI_v_thr(data)                                                 (0x01FFC000&((data)<<14))
+#define TVE_SYNCGEN_HDMI_v_thr_src(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_SYNCGEN_HDMI_get_v_thr(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_SYNCGEN_HDMI_write_en1_shift                                             (13)
+#define TVE_SYNCGEN_HDMI_write_en1_mask                                              (0x00002000)
+#define TVE_SYNCGEN_HDMI_write_en1(data)                                             (0x00002000&((data)<<13))
+#define TVE_SYNCGEN_HDMI_write_en1_src(data)                                         ((0x00002000&(data))>>13)
+#define TVE_SYNCGEN_HDMI_get_write_en1(data)                                         ((0x00002000&(data))>>13)
+#define TVE_SYNCGEN_HDMI_h_thr_shift                                                 (0)
+#define TVE_SYNCGEN_HDMI_h_thr_mask                                                  (0x00001FFF)
+#define TVE_SYNCGEN_HDMI_h_thr(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_SYNCGEN_HDMI_h_thr_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_SYNCGEN_HDMI_get_h_thr(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_COMP_CTRL                                                                0x18018010
+#define TVE_COMP_CTRL_reg_addr                                                       "0xB8018010"
+#define TVE_COMP_CTRL_reg                                                            0xB8018010
+#define set_TVE_COMP_CTRL_reg(data)   (*((volatile unsigned int*) TVE_COMP_CTRL_reg)=data)
+#define get_TVE_COMP_CTRL_reg   (*((volatile unsigned int*) TVE_COMP_CTRL_reg))
+#define TVE_COMP_CTRL_inst_adr                                                       "0x0004"
+#define TVE_COMP_CTRL_inst                                                           0x0004
+#define TVE_COMP_CTRL_comp_ebl_shift                                                 (13)
+#define TVE_COMP_CTRL_comp_ebl_mask                                                  (0x00002000)
+#define TVE_COMP_CTRL_comp_ebl(data)                                                 (0x00002000&((data)<<13))
+#define TVE_COMP_CTRL_comp_ebl_src(data)                                             ((0x00002000&(data))>>13)
+#define TVE_COMP_CTRL_get_comp_ebl(data)                                             ((0x00002000&(data))>>13)
+#define TVE_COMP_CTRL_sdtv_ebl_shift                                                 (12)
+#define TVE_COMP_CTRL_sdtv_ebl_mask                                                  (0x00001000)
+#define TVE_COMP_CTRL_sdtv_ebl(data)                                                 (0x00001000&((data)<<12))
+#define TVE_COMP_CTRL_sdtv_ebl_src(data)                                             ((0x00001000&(data))>>12)
+#define TVE_COMP_CTRL_get_sdtv_ebl(data)                                             ((0x00001000&(data))>>12)
+#define TVE_COMP_CTRL_vs_polar_shift                                                 (11)
+#define TVE_COMP_CTRL_vs_polar_mask                                                  (0x00000800)
+#define TVE_COMP_CTRL_vs_polar(data)                                                 (0x00000800&((data)<<11))
+#define TVE_COMP_CTRL_vs_polar_src(data)                                             ((0x00000800&(data))>>11)
+#define TVE_COMP_CTRL_get_vs_polar(data)                                             ((0x00000800&(data))>>11)
+#define TVE_COMP_CTRL_hs_polar_shift                                                 (10)
+#define TVE_COMP_CTRL_hs_polar_mask                                                  (0x00000400)
+#define TVE_COMP_CTRL_hs_polar(data)                                                 (0x00000400&((data)<<10))
+#define TVE_COMP_CTRL_hs_polar_src(data)                                             ((0x00000400&(data))>>10)
+#define TVE_COMP_CTRL_get_hs_polar(data)                                             ((0x00000400&(data))>>10)
+#define TVE_COMP_CTRL_vga_hvsync_shift                                               (9)
+#define TVE_COMP_CTRL_vga_hvsync_mask                                                (0x00000200)
+#define TVE_COMP_CTRL_vga_hvsync(data)                                               (0x00000200&((data)<<9))
+#define TVE_COMP_CTRL_vga_hvsync_src(data)                                           ((0x00000200&(data))>>9)
+#define TVE_COMP_CTRL_get_vga_hvsync(data)                                           ((0x00000200&(data))>>9)
+#define TVE_COMP_CTRL_comp_sel_shift                                                 (8)
+#define TVE_COMP_CTRL_comp_sel_mask                                                  (0x00000100)
+#define TVE_COMP_CTRL_comp_sel(data)                                                 (0x00000100&((data)<<8))
+#define TVE_COMP_CTRL_comp_sel_src(data)                                             ((0x00000100&(data))>>8)
+#define TVE_COMP_CTRL_get_comp_sel(data)                                             ((0x00000100&(data))>>8)
+#define TVE_COMP_CTRL_sync_rb_ebl_shift                                              (7)
+#define TVE_COMP_CTRL_sync_rb_ebl_mask                                               (0x00000080)
+#define TVE_COMP_CTRL_sync_rb_ebl(data)                                              (0x00000080&((data)<<7))
+#define TVE_COMP_CTRL_sync_rb_ebl_src(data)                                          ((0x00000080&(data))>>7)
+#define TVE_COMP_CTRL_get_sync_rb_ebl(data)                                          ((0x00000080&(data))>>7)
+#define TVE_COMP_CTRL_sync_g_ebl_shift                                               (6)
+#define TVE_COMP_CTRL_sync_g_ebl_mask                                                (0x00000040)
+#define TVE_COMP_CTRL_sync_g_ebl(data)                                               (0x00000040&((data)<<6))
+#define TVE_COMP_CTRL_sync_g_ebl_src(data)                                           ((0x00000040&(data))>>6)
+#define TVE_COMP_CTRL_get_sync_g_ebl(data)                                           ((0x00000040&(data))>>6)
+#define TVE_COMP_CTRL_rgb_mod_shift                                                  (5)
+#define TVE_COMP_CTRL_rgb_mod_mask                                                   (0x00000020)
+#define TVE_COMP_CTRL_rgb_mod(data)                                                  (0x00000020&((data)<<5))
+#define TVE_COMP_CTRL_rgb_mod_src(data)                                              ((0x00000020&(data))>>5)
+#define TVE_COMP_CTRL_get_rgb_mod(data)                                              ((0x00000020&(data))>>5)
+#define TVE_COMP_CTRL_vbi_rb_ebl_shift                                               (4)
+#define TVE_COMP_CTRL_vbi_rb_ebl_mask                                                (0x00000010)
+#define TVE_COMP_CTRL_vbi_rb_ebl(data)                                               (0x00000010&((data)<<4))
+#define TVE_COMP_CTRL_vbi_rb_ebl_src(data)                                           ((0x00000010&(data))>>4)
+#define TVE_COMP_CTRL_get_vbi_rb_ebl(data)                                           ((0x00000010&(data))>>4)
+#define TVE_COMP_CTRL_vbi_g_ebl_shift                                                (3)
+#define TVE_COMP_CTRL_vbi_g_ebl_mask                                                 (0x00000008)
+#define TVE_COMP_CTRL_vbi_g_ebl(data)                                                (0x00000008&((data)<<3))
+#define TVE_COMP_CTRL_vbi_g_ebl_src(data)                                            ((0x00000008&(data))>>3)
+#define TVE_COMP_CTRL_get_vbi_g_ebl(data)                                            ((0x00000008&(data))>>3)
+#define TVE_COMP_CTRL_hdsync_shift                                                   (2)
+#define TVE_COMP_CTRL_hdsync_mask                                                    (0x00000004)
+#define TVE_COMP_CTRL_hdsync(data)                                                   (0x00000004&((data)<<2))
+#define TVE_COMP_CTRL_hdsync_src(data)                                               ((0x00000004&(data))>>2)
+#define TVE_COMP_CTRL_get_hdsync(data)                                               ((0x00000004&(data))>>2)
+#define TVE_COMP_CTRL_syncmod_sel_shift                                              (1)
+#define TVE_COMP_CTRL_syncmod_sel_mask                                               (0x00000002)
+#define TVE_COMP_CTRL_syncmod_sel(data)                                              (0x00000002&((data)<<1))
+#define TVE_COMP_CTRL_syncmod_sel_src(data)                                          ((0x00000002&(data))>>1)
+#define TVE_COMP_CTRL_get_syncmod_sel(data)                                          ((0x00000002&(data))>>1)
+#define TVE_COMP_CTRL_write_data_shift                                               (0)
+#define TVE_COMP_CTRL_write_data_mask                                                (0x00000001)
+#define TVE_COMP_CTRL_write_data(data)                                               (0x00000001&((data)<<0))
+#define TVE_COMP_CTRL_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define TVE_COMP_CTRL_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define TVE_SYNCGEN_STATUS_I                                                         0x18018014
+#define TVE_SYNCGEN_STATUS_I_reg_addr                                                "0xB8018014"
+#define TVE_SYNCGEN_STATUS_I_reg                                                     0xB8018014
+#define set_TVE_SYNCGEN_STATUS_I_reg(data)   (*((volatile unsigned int*) TVE_SYNCGEN_STATUS_I_reg)=data)
+#define get_TVE_SYNCGEN_STATUS_I_reg   (*((volatile unsigned int*) TVE_SYNCGEN_STATUS_I_reg))
+#define TVE_SYNCGEN_STATUS_I_inst_adr                                                "0x0005"
+#define TVE_SYNCGEN_STATUS_I_inst                                                    0x0005
+#define TVE_SYNCGEN_STATUS_I_i_field_shift                                           (23)
+#define TVE_SYNCGEN_STATUS_I_i_field_mask                                            (0x00800000)
+#define TVE_SYNCGEN_STATUS_I_i_field(data)                                           (0x00800000&((data)<<23))
+#define TVE_SYNCGEN_STATUS_I_i_field_src(data)                                       ((0x00800000&(data))>>23)
+#define TVE_SYNCGEN_STATUS_I_get_i_field(data)                                       ((0x00800000&(data))>>23)
+#define TVE_SYNCGEN_STATUS_I_i_vcnt_shift                                            (12)
+#define TVE_SYNCGEN_STATUS_I_i_vcnt_mask                                             (0x007FF000)
+#define TVE_SYNCGEN_STATUS_I_i_vcnt(data)                                            (0x007FF000&((data)<<12))
+#define TVE_SYNCGEN_STATUS_I_i_vcnt_src(data)                                        ((0x007FF000&(data))>>12)
+#define TVE_SYNCGEN_STATUS_I_get_i_vcnt(data)                                        ((0x007FF000&(data))>>12)
+#define TVE_SYNCGEN_STATUS_I_p_field_shift                                           (11)
+#define TVE_SYNCGEN_STATUS_I_p_field_mask                                            (0x00000800)
+#define TVE_SYNCGEN_STATUS_I_p_field(data)                                           (0x00000800&((data)<<11))
+#define TVE_SYNCGEN_STATUS_I_p_field_src(data)                                       ((0x00000800&(data))>>11)
+#define TVE_SYNCGEN_STATUS_I_get_p_field(data)                                       ((0x00000800&(data))>>11)
+#define TVE_SYNCGEN_STATUS_I_p_vcnt_shift                                            (0)
+#define TVE_SYNCGEN_STATUS_I_p_vcnt_mask                                             (0x000007FF)
+#define TVE_SYNCGEN_STATUS_I_p_vcnt(data)                                            (0x000007FF&((data)<<0))
+#define TVE_SYNCGEN_STATUS_I_p_vcnt_src(data)                                        ((0x000007FF&(data))>>0)
+#define TVE_SYNCGEN_STATUS_I_get_p_vcnt(data)                                        ((0x000007FF&(data))>>0)
+
+
+#define TVE_SYNCGEN_STATUS_H                                                         0x18018018
+#define TVE_SYNCGEN_STATUS_H_reg_addr                                                "0xB8018018"
+#define TVE_SYNCGEN_STATUS_H_reg                                                     0xB8018018
+#define set_TVE_SYNCGEN_STATUS_H_reg(data)   (*((volatile unsigned int*) TVE_SYNCGEN_STATUS_H_reg)=data)
+#define get_TVE_SYNCGEN_STATUS_H_reg   (*((volatile unsigned int*) TVE_SYNCGEN_STATUS_H_reg))
+#define TVE_SYNCGEN_STATUS_H_inst_adr                                                "0x0006"
+#define TVE_SYNCGEN_STATUS_H_inst                                                    0x0006
+#define TVE_SYNCGEN_STATUS_H_h_field_shift                                           (11)
+#define TVE_SYNCGEN_STATUS_H_h_field_mask                                            (0x00000800)
+#define TVE_SYNCGEN_STATUS_H_h_field(data)                                           (0x00000800&((data)<<11))
+#define TVE_SYNCGEN_STATUS_H_h_field_src(data)                                       ((0x00000800&(data))>>11)
+#define TVE_SYNCGEN_STATUS_H_get_h_field(data)                                       ((0x00000800&(data))>>11)
+#define TVE_SYNCGEN_STATUS_H_h_vcnt_shift                                            (0)
+#define TVE_SYNCGEN_STATUS_H_h_vcnt_mask                                             (0x000007FF)
+#define TVE_SYNCGEN_STATUS_H_h_vcnt(data)                                            (0x000007FF&((data)<<0))
+#define TVE_SYNCGEN_STATUS_H_h_vcnt_src(data)                                        ((0x000007FF&(data))>>0)
+#define TVE_SYNCGEN_STATUS_H_get_h_vcnt(data)                                        ((0x000007FF&(data))>>0)
+
+
+#define TVE_INTEN                                                                    0x1801801c
+#define TVE_INTEN_reg_addr                                                           "0xB801801C"
+#define TVE_INTEN_reg                                                                0xB801801C
+#define set_TVE_INTEN_reg(data)   (*((volatile unsigned int*) TVE_INTEN_reg)=data)
+#define get_TVE_INTEN_reg   (*((volatile unsigned int*) TVE_INTEN_reg))
+#define TVE_INTEN_inst_adr                                                           "0x0007"
+#define TVE_INTEN_inst                                                               0x0007
+#define TVE_INTEN_inten_vbi_h_shift                                                  (6)
+#define TVE_INTEN_inten_vbi_h_mask                                                   (0x00000040)
+#define TVE_INTEN_inten_vbi_h(data)                                                  (0x00000040&((data)<<6))
+#define TVE_INTEN_inten_vbi_h_src(data)                                              ((0x00000040&(data))>>6)
+#define TVE_INTEN_get_inten_vbi_h(data)                                              ((0x00000040&(data))>>6)
+#define TVE_INTEN_inten_vbi_i_shift                                                  (5)
+#define TVE_INTEN_inten_vbi_i_mask                                                   (0x00000020)
+#define TVE_INTEN_inten_vbi_i(data)                                                  (0x00000020&((data)<<5))
+#define TVE_INTEN_inten_vbi_i_src(data)                                              ((0x00000020&(data))>>5)
+#define TVE_INTEN_get_inten_vbi_i(data)                                              ((0x00000020&(data))>>5)
+#define TVE_INTEN_inten_vbi_p_shift                                                  (4)
+#define TVE_INTEN_inten_vbi_p_mask                                                   (0x00000010)
+#define TVE_INTEN_inten_vbi_p(data)                                                  (0x00000010&((data)<<4))
+#define TVE_INTEN_inten_vbi_p_src(data)                                              ((0x00000010&(data))>>4)
+#define TVE_INTEN_get_inten_vbi_p(data)                                              ((0x00000010&(data))>>4)
+#define TVE_INTEN_inten_h_shift                                                      (3)
+#define TVE_INTEN_inten_h_mask                                                       (0x00000008)
+#define TVE_INTEN_inten_h(data)                                                      (0x00000008&((data)<<3))
+#define TVE_INTEN_inten_h_src(data)                                                  ((0x00000008&(data))>>3)
+#define TVE_INTEN_get_inten_h(data)                                                  ((0x00000008&(data))>>3)
+#define TVE_INTEN_inten_i_shift                                                      (2)
+#define TVE_INTEN_inten_i_mask                                                       (0x00000004)
+#define TVE_INTEN_inten_i(data)                                                      (0x00000004&((data)<<2))
+#define TVE_INTEN_inten_i_src(data)                                                  ((0x00000004&(data))>>2)
+#define TVE_INTEN_get_inten_i(data)                                                  ((0x00000004&(data))>>2)
+#define TVE_INTEN_inten_p_shift                                                      (1)
+#define TVE_INTEN_inten_p_mask                                                       (0x00000002)
+#define TVE_INTEN_inten_p(data)                                                      (0x00000002&((data)<<1))
+#define TVE_INTEN_inten_p_src(data)                                                  ((0x00000002&(data))>>1)
+#define TVE_INTEN_get_inten_p(data)                                                  ((0x00000002&(data))>>1)
+#define TVE_INTEN_write_data_shift                                                   (0)
+#define TVE_INTEN_write_data_mask                                                    (0x00000001)
+#define TVE_INTEN_write_data(data)                                                   (0x00000001&((data)<<0))
+#define TVE_INTEN_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define TVE_INTEN_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define TVE_INTST                                                                    0x18018020
+#define TVE_INTST_reg_addr                                                           "0xB8018020"
+#define TVE_INTST_reg                                                                0xB8018020
+#define set_TVE_INTST_reg(data)   (*((volatile unsigned int*) TVE_INTST_reg)=data)
+#define get_TVE_INTST_reg   (*((volatile unsigned int*) TVE_INTST_reg))
+#define TVE_INTST_inst_adr                                                           "0x0008"
+#define TVE_INTST_inst                                                               0x0008
+#define TVE_INTST_intst_vbi_h_shift                                                  (6)
+#define TVE_INTST_intst_vbi_h_mask                                                   (0x00000040)
+#define TVE_INTST_intst_vbi_h(data)                                                  (0x00000040&((data)<<6))
+#define TVE_INTST_intst_vbi_h_src(data)                                              ((0x00000040&(data))>>6)
+#define TVE_INTST_get_intst_vbi_h(data)                                              ((0x00000040&(data))>>6)
+#define TVE_INTST_intst_vbi_i_shift                                                  (5)
+#define TVE_INTST_intst_vbi_i_mask                                                   (0x00000020)
+#define TVE_INTST_intst_vbi_i(data)                                                  (0x00000020&((data)<<5))
+#define TVE_INTST_intst_vbi_i_src(data)                                              ((0x00000020&(data))>>5)
+#define TVE_INTST_get_intst_vbi_i(data)                                              ((0x00000020&(data))>>5)
+#define TVE_INTST_intst_vbi_p_shift                                                  (4)
+#define TVE_INTST_intst_vbi_p_mask                                                   (0x00000010)
+#define TVE_INTST_intst_vbi_p(data)                                                  (0x00000010&((data)<<4))
+#define TVE_INTST_intst_vbi_p_src(data)                                              ((0x00000010&(data))>>4)
+#define TVE_INTST_get_intst_vbi_p(data)                                              ((0x00000010&(data))>>4)
+#define TVE_INTST_intst_h_shift                                                      (3)
+#define TVE_INTST_intst_h_mask                                                       (0x00000008)
+#define TVE_INTST_intst_h(data)                                                      (0x00000008&((data)<<3))
+#define TVE_INTST_intst_h_src(data)                                                  ((0x00000008&(data))>>3)
+#define TVE_INTST_get_intst_h(data)                                                  ((0x00000008&(data))>>3)
+#define TVE_INTST_intst_i_shift                                                      (2)
+#define TVE_INTST_intst_i_mask                                                       (0x00000004)
+#define TVE_INTST_intst_i(data)                                                      (0x00000004&((data)<<2))
+#define TVE_INTST_intst_i_src(data)                                                  ((0x00000004&(data))>>2)
+#define TVE_INTST_get_intst_i(data)                                                  ((0x00000004&(data))>>2)
+#define TVE_INTST_intst_p_shift                                                      (1)
+#define TVE_INTST_intst_p_mask                                                       (0x00000002)
+#define TVE_INTST_intst_p(data)                                                      (0x00000002&((data)<<1))
+#define TVE_INTST_intst_p_src(data)                                                  ((0x00000002&(data))>>1)
+#define TVE_INTST_get_intst_p(data)                                                  ((0x00000002&(data))>>1)
+#define TVE_INTST_write_data_shift                                                   (0)
+#define TVE_INTST_write_data_mask                                                    (0x00000001)
+#define TVE_INTST_write_data(data)                                                   (0x00000001&((data)<<0))
+#define TVE_INTST_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define TVE_INTST_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define TVE_INTPOS_I                                                                 0x18018024
+#define TVE_INTPOS_I_reg_addr                                                        "0xB8018024"
+#define TVE_INTPOS_I_reg                                                             0xB8018024
+#define set_TVE_INTPOS_I_reg(data)   (*((volatile unsigned int*) TVE_INTPOS_I_reg)=data)
+#define get_TVE_INTPOS_I_reg   (*((volatile unsigned int*) TVE_INTPOS_I_reg))
+#define TVE_INTPOS_I_inst_adr                                                        "0x0009"
+#define TVE_INTPOS_I_inst                                                            0x0009
+#define TVE_INTPOS_I_write_en2_shift                                                 (25)
+#define TVE_INTPOS_I_write_en2_mask                                                  (0x02000000)
+#define TVE_INTPOS_I_write_en2(data)                                                 (0x02000000&((data)<<25))
+#define TVE_INTPOS_I_write_en2_src(data)                                             ((0x02000000&(data))>>25)
+#define TVE_INTPOS_I_get_write_en2(data)                                             ((0x02000000&(data))>>25)
+#define TVE_INTPOS_I_int_vpos_shift                                                  (14)
+#define TVE_INTPOS_I_int_vpos_mask                                                   (0x01FFC000)
+#define TVE_INTPOS_I_int_vpos(data)                                                  (0x01FFC000&((data)<<14))
+#define TVE_INTPOS_I_int_vpos_src(data)                                              ((0x01FFC000&(data))>>14)
+#define TVE_INTPOS_I_get_int_vpos(data)                                              ((0x01FFC000&(data))>>14)
+#define TVE_INTPOS_I_write_en1_shift                                                 (13)
+#define TVE_INTPOS_I_write_en1_mask                                                  (0x00002000)
+#define TVE_INTPOS_I_write_en1(data)                                                 (0x00002000&((data)<<13))
+#define TVE_INTPOS_I_write_en1_src(data)                                             ((0x00002000&(data))>>13)
+#define TVE_INTPOS_I_get_write_en1(data)                                             ((0x00002000&(data))>>13)
+#define TVE_INTPOS_I_int_hpos_shift                                                  (0)
+#define TVE_INTPOS_I_int_hpos_mask                                                   (0x00001FFF)
+#define TVE_INTPOS_I_int_hpos(data)                                                  (0x00001FFF&((data)<<0))
+#define TVE_INTPOS_I_int_hpos_src(data)                                              ((0x00001FFF&(data))>>0)
+#define TVE_INTPOS_I_get_int_hpos(data)                                              ((0x00001FFF&(data))>>0)
+
+
+#define TVE_INTPOS_P1                                                                0x18018028
+#define TVE_INTPOS_P1_reg_addr                                                       "0xB8018028"
+#define TVE_INTPOS_P1_reg                                                            0xB8018028
+#define set_TVE_INTPOS_P1_reg(data)   (*((volatile unsigned int*) TVE_INTPOS_P1_reg)=data)
+#define get_TVE_INTPOS_P1_reg   (*((volatile unsigned int*) TVE_INTPOS_P1_reg))
+#define TVE_INTPOS_P1_inst_adr                                                       "0x000A"
+#define TVE_INTPOS_P1_inst                                                           0x000A
+#define TVE_INTPOS_P1_write_en2_shift                                                (25)
+#define TVE_INTPOS_P1_write_en2_mask                                                 (0x02000000)
+#define TVE_INTPOS_P1_write_en2(data)                                                (0x02000000&((data)<<25))
+#define TVE_INTPOS_P1_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTPOS_P1_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTPOS_P1_int_vpos_shift                                                 (14)
+#define TVE_INTPOS_P1_int_vpos_mask                                                  (0x01FFC000)
+#define TVE_INTPOS_P1_int_vpos(data)                                                 (0x01FFC000&((data)<<14))
+#define TVE_INTPOS_P1_int_vpos_src(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTPOS_P1_get_int_vpos(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTPOS_P1_write_en1_shift                                                (13)
+#define TVE_INTPOS_P1_write_en1_mask                                                 (0x00002000)
+#define TVE_INTPOS_P1_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_INTPOS_P1_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTPOS_P1_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTPOS_P1_int_hpos_shift                                                 (0)
+#define TVE_INTPOS_P1_int_hpos_mask                                                  (0x00001FFF)
+#define TVE_INTPOS_P1_int_hpos(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_INTPOS_P1_int_hpos_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_INTPOS_P1_get_int_hpos(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_INTPOS_P2                                                                0x1801802c
+#define TVE_INTPOS_P2_reg_addr                                                       "0xB801802C"
+#define TVE_INTPOS_P2_reg                                                            0xB801802C
+#define set_TVE_INTPOS_P2_reg(data)   (*((volatile unsigned int*) TVE_INTPOS_P2_reg)=data)
+#define get_TVE_INTPOS_P2_reg   (*((volatile unsigned int*) TVE_INTPOS_P2_reg))
+#define TVE_INTPOS_P2_inst_adr                                                       "0x000B"
+#define TVE_INTPOS_P2_inst                                                           0x000B
+#define TVE_INTPOS_P2_write_en2_shift                                                (25)
+#define TVE_INTPOS_P2_write_en2_mask                                                 (0x02000000)
+#define TVE_INTPOS_P2_write_en2(data)                                                (0x02000000&((data)<<25))
+#define TVE_INTPOS_P2_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTPOS_P2_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTPOS_P2_int_vpos_shift                                                 (14)
+#define TVE_INTPOS_P2_int_vpos_mask                                                  (0x01FFC000)
+#define TVE_INTPOS_P2_int_vpos(data)                                                 (0x01FFC000&((data)<<14))
+#define TVE_INTPOS_P2_int_vpos_src(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTPOS_P2_get_int_vpos(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTPOS_P2_write_en1_shift                                                (13)
+#define TVE_INTPOS_P2_write_en1_mask                                                 (0x00002000)
+#define TVE_INTPOS_P2_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_INTPOS_P2_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTPOS_P2_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTPOS_P2_int_hpos_shift                                                 (0)
+#define TVE_INTPOS_P2_int_hpos_mask                                                  (0x00001FFF)
+#define TVE_INTPOS_P2_int_hpos(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_INTPOS_P2_int_hpos_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_INTPOS_P2_get_int_hpos(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_INTPOS_H1                                                                0x18018030
+#define TVE_INTPOS_H1_reg_addr                                                       "0xB8018030"
+#define TVE_INTPOS_H1_reg                                                            0xB8018030
+#define set_TVE_INTPOS_H1_reg(data)   (*((volatile unsigned int*) TVE_INTPOS_H1_reg)=data)
+#define get_TVE_INTPOS_H1_reg   (*((volatile unsigned int*) TVE_INTPOS_H1_reg))
+#define TVE_INTPOS_H1_inst_adr                                                       "0x000C"
+#define TVE_INTPOS_H1_inst                                                           0x000C
+#define TVE_INTPOS_H1_write_en2_shift                                                (25)
+#define TVE_INTPOS_H1_write_en2_mask                                                 (0x02000000)
+#define TVE_INTPOS_H1_write_en2(data)                                                (0x02000000&((data)<<25))
+#define TVE_INTPOS_H1_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTPOS_H1_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTPOS_H1_int_vpos_shift                                                 (14)
+#define TVE_INTPOS_H1_int_vpos_mask                                                  (0x01FFC000)
+#define TVE_INTPOS_H1_int_vpos(data)                                                 (0x01FFC000&((data)<<14))
+#define TVE_INTPOS_H1_int_vpos_src(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTPOS_H1_get_int_vpos(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTPOS_H1_write_en1_shift                                                (13)
+#define TVE_INTPOS_H1_write_en1_mask                                                 (0x00002000)
+#define TVE_INTPOS_H1_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_INTPOS_H1_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTPOS_H1_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTPOS_H1_int_hpos_shift                                                 (0)
+#define TVE_INTPOS_H1_int_hpos_mask                                                  (0x00001FFF)
+#define TVE_INTPOS_H1_int_hpos(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_INTPOS_H1_int_hpos_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_INTPOS_H1_get_int_hpos(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_INTPOS_H2                                                                0x18018034
+#define TVE_INTPOS_H2_reg_addr                                                       "0xB8018034"
+#define TVE_INTPOS_H2_reg                                                            0xB8018034
+#define set_TVE_INTPOS_H2_reg(data)   (*((volatile unsigned int*) TVE_INTPOS_H2_reg)=data)
+#define get_TVE_INTPOS_H2_reg   (*((volatile unsigned int*) TVE_INTPOS_H2_reg))
+#define TVE_INTPOS_H2_inst_adr                                                       "0x000D"
+#define TVE_INTPOS_H2_inst                                                           0x000D
+#define TVE_INTPOS_H2_write_en2_shift                                                (25)
+#define TVE_INTPOS_H2_write_en2_mask                                                 (0x02000000)
+#define TVE_INTPOS_H2_write_en2(data)                                                (0x02000000&((data)<<25))
+#define TVE_INTPOS_H2_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTPOS_H2_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTPOS_H2_int_vpos_shift                                                 (14)
+#define TVE_INTPOS_H2_int_vpos_mask                                                  (0x01FFC000)
+#define TVE_INTPOS_H2_int_vpos(data)                                                 (0x01FFC000&((data)<<14))
+#define TVE_INTPOS_H2_int_vpos_src(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTPOS_H2_get_int_vpos(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTPOS_H2_write_en1_shift                                                (13)
+#define TVE_INTPOS_H2_write_en1_mask                                                 (0x00002000)
+#define TVE_INTPOS_H2_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_INTPOS_H2_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTPOS_H2_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTPOS_H2_int_hpos_shift                                                 (0)
+#define TVE_INTPOS_H2_int_hpos_mask                                                  (0x00001FFF)
+#define TVE_INTPOS_H2_int_hpos(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_INTPOS_H2_int_hpos_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_INTPOS_H2_get_int_hpos(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_SRSTN                                                                    0x18018038
+#define TVE_SRSTN_reg_addr                                                           "0xB8018038"
+#define TVE_SRSTN_reg                                                                0xB8018038
+#define set_TVE_SRSTN_reg(data)   (*((volatile unsigned int*) TVE_SRSTN_reg)=data)
+#define get_TVE_SRSTN_reg   (*((volatile unsigned int*) TVE_SRSTN_reg))
+#define TVE_SRSTN_inst_adr                                                           "0x000E"
+#define TVE_SRSTN_inst                                                               0x000E
+#define TVE_SRSTN_srstn_shift                                                        (0)
+#define TVE_SRSTN_srstn_mask                                                         (0x00000001)
+#define TVE_SRSTN_srstn(data)                                                        (0x00000001&((data)<<0))
+#define TVE_SRSTN_srstn_src(data)                                                    ((0x00000001&(data))>>0)
+#define TVE_SRSTN_get_srstn(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define TVE_AV_CTRL                                                                  0x18018040
+#define TVE_AV_CTRL_reg_addr                                                         "0xB8018040"
+#define TVE_AV_CTRL_reg                                                              0xB8018040
+#define set_TVE_AV_CTRL_reg(data)   (*((volatile unsigned int*) TVE_AV_CTRL_reg)=data)
+#define get_TVE_AV_CTRL_reg   (*((volatile unsigned int*) TVE_AV_CTRL_reg))
+#define TVE_AV_CTRL_inst_adr                                                         "0x0010"
+#define TVE_AV_CTRL_inst                                                             0x0010
+#define TVE_AV_CTRL_h_colorbar_ebl_shift                                             (6)
+#define TVE_AV_CTRL_h_colorbar_ebl_mask                                              (0x00000040)
+#define TVE_AV_CTRL_h_colorbar_ebl(data)                                             (0x00000040&((data)<<6))
+#define TVE_AV_CTRL_h_colorbar_ebl_src(data)                                         ((0x00000040&(data))>>6)
+#define TVE_AV_CTRL_get_h_colorbar_ebl(data)                                         ((0x00000040&(data))>>6)
+#define TVE_AV_CTRL_h_black_ebl_shift                                                (5)
+#define TVE_AV_CTRL_h_black_ebl_mask                                                 (0x00000020)
+#define TVE_AV_CTRL_h_black_ebl(data)                                                (0x00000020&((data)<<5))
+#define TVE_AV_CTRL_h_black_ebl_src(data)                                            ((0x00000020&(data))>>5)
+#define TVE_AV_CTRL_get_h_black_ebl(data)                                            ((0x00000020&(data))>>5)
+#define TVE_AV_CTRL_i_colorbar_ebl_shift                                             (4)
+#define TVE_AV_CTRL_i_colorbar_ebl_mask                                              (0x00000010)
+#define TVE_AV_CTRL_i_colorbar_ebl(data)                                             (0x00000010&((data)<<4))
+#define TVE_AV_CTRL_i_colorbar_ebl_src(data)                                         ((0x00000010&(data))>>4)
+#define TVE_AV_CTRL_get_i_colorbar_ebl(data)                                         ((0x00000010&(data))>>4)
+#define TVE_AV_CTRL_p_colorbar_ebl_shift                                             (3)
+#define TVE_AV_CTRL_p_colorbar_ebl_mask                                              (0x00000008)
+#define TVE_AV_CTRL_p_colorbar_ebl(data)                                             (0x00000008&((data)<<3))
+#define TVE_AV_CTRL_p_colorbar_ebl_src(data)                                         ((0x00000008&(data))>>3)
+#define TVE_AV_CTRL_get_p_colorbar_ebl(data)                                         ((0x00000008&(data))>>3)
+#define TVE_AV_CTRL_i_black_ebl_shift                                                (2)
+#define TVE_AV_CTRL_i_black_ebl_mask                                                 (0x00000004)
+#define TVE_AV_CTRL_i_black_ebl(data)                                                (0x00000004&((data)<<2))
+#define TVE_AV_CTRL_i_black_ebl_src(data)                                            ((0x00000004&(data))>>2)
+#define TVE_AV_CTRL_get_i_black_ebl(data)                                            ((0x00000004&(data))>>2)
+#define TVE_AV_CTRL_p_black_ebl_shift                                                (1)
+#define TVE_AV_CTRL_p_black_ebl_mask                                                 (0x00000002)
+#define TVE_AV_CTRL_p_black_ebl(data)                                                (0x00000002&((data)<<1))
+#define TVE_AV_CTRL_p_black_ebl_src(data)                                            ((0x00000002&(data))>>1)
+#define TVE_AV_CTRL_get_p_black_ebl(data)                                            ((0x00000002&(data))>>1)
+#define TVE_AV_CTRL_write_data_shift                                                 (0)
+#define TVE_AV_CTRL_write_data_mask                                                  (0x00000001)
+#define TVE_AV_CTRL_write_data(data)                                                 (0x00000001&((data)<<0))
+#define TVE_AV_CTRL_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define TVE_AV_CTRL_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define TVE_CAV_422                                                                  0x18018044
+#define TVE_CAV_422_reg_addr                                                         "0xB8018044"
+#define TVE_CAV_422_reg                                                              0xB8018044
+#define set_TVE_CAV_422_reg(data)   (*((volatile unsigned int*) TVE_CAV_422_reg)=data)
+#define get_TVE_CAV_422_reg   (*((volatile unsigned int*) TVE_CAV_422_reg))
+#define TVE_CAV_422_inst_adr                                                         "0x0011"
+#define TVE_CAV_422_inst                                                             0x0011
+#define TVE_CAV_422_fir422_sel_shift                                                 (0)
+#define TVE_CAV_422_fir422_sel_mask                                                  (0x00000003)
+#define TVE_CAV_422_fir422_sel(data)                                                 (0x00000003&((data)<<0))
+#define TVE_CAV_422_fir422_sel_src(data)                                             ((0x00000003&(data))>>0)
+#define TVE_CAV_422_get_fir422_sel(data)                                             ((0x00000003&(data))>>0)
+
+
+#define TVE_AV_SLEW                                                                  0x18018048
+#define TVE_AV_SLEW_reg_addr                                                         "0xB8018048"
+#define TVE_AV_SLEW_reg                                                              0xB8018048
+#define set_TVE_AV_SLEW_reg(data)   (*((volatile unsigned int*) TVE_AV_SLEW_reg)=data)
+#define get_TVE_AV_SLEW_reg   (*((volatile unsigned int*) TVE_AV_SLEW_reg))
+#define TVE_AV_SLEW_inst_adr                                                         "0x0012"
+#define TVE_AV_SLEW_inst                                                             0x0012
+#define TVE_AV_SLEW_write_en4_shift                                                  (9)
+#define TVE_AV_SLEW_write_en4_mask                                                   (0x00000200)
+#define TVE_AV_SLEW_write_en4(data)                                                  (0x00000200&((data)<<9))
+#define TVE_AV_SLEW_write_en4_src(data)                                              ((0x00000200&(data))>>9)
+#define TVE_AV_SLEW_get_write_en4(data)                                              ((0x00000200&(data))>>9)
+#define TVE_AV_SLEW_i_en_shift                                                       (8)
+#define TVE_AV_SLEW_i_en_mask                                                        (0x00000100)
+#define TVE_AV_SLEW_i_en(data)                                                       (0x00000100&((data)<<8))
+#define TVE_AV_SLEW_i_en_src(data)                                                   ((0x00000100&(data))>>8)
+#define TVE_AV_SLEW_get_i_en(data)                                                   ((0x00000100&(data))>>8)
+#define TVE_AV_SLEW_write_en3_shift                                                  (7)
+#define TVE_AV_SLEW_write_en3_mask                                                   (0x00000080)
+#define TVE_AV_SLEW_write_en3(data)                                                  (0x00000080&((data)<<7))
+#define TVE_AV_SLEW_write_en3_src(data)                                              ((0x00000080&(data))>>7)
+#define TVE_AV_SLEW_get_write_en3(data)                                              ((0x00000080&(data))>>7)
+#define TVE_AV_SLEW_p_en_shift                                                       (6)
+#define TVE_AV_SLEW_p_en_mask                                                        (0x00000040)
+#define TVE_AV_SLEW_p_en(data)                                                       (0x00000040&((data)<<6))
+#define TVE_AV_SLEW_p_en_src(data)                                                   ((0x00000040&(data))>>6)
+#define TVE_AV_SLEW_get_p_en(data)                                                   ((0x00000040&(data))>>6)
+#define TVE_AV_SLEW_write_en2_shift                                                  (5)
+#define TVE_AV_SLEW_write_en2_mask                                                   (0x00000020)
+#define TVE_AV_SLEW_write_en2(data)                                                  (0x00000020&((data)<<5))
+#define TVE_AV_SLEW_write_en2_src(data)                                              ((0x00000020&(data))>>5)
+#define TVE_AV_SLEW_get_write_en2(data)                                              ((0x00000020&(data))>>5)
+#define TVE_AV_SLEW_i_slewrate_shift                                                 (3)
+#define TVE_AV_SLEW_i_slewrate_mask                                                  (0x00000018)
+#define TVE_AV_SLEW_i_slewrate(data)                                                 (0x00000018&((data)<<3))
+#define TVE_AV_SLEW_i_slewrate_src(data)                                             ((0x00000018&(data))>>3)
+#define TVE_AV_SLEW_get_i_slewrate(data)                                             ((0x00000018&(data))>>3)
+#define TVE_AV_SLEW_write_en1_shift                                                  (2)
+#define TVE_AV_SLEW_write_en1_mask                                                   (0x00000004)
+#define TVE_AV_SLEW_write_en1(data)                                                  (0x00000004&((data)<<2))
+#define TVE_AV_SLEW_write_en1_src(data)                                              ((0x00000004&(data))>>2)
+#define TVE_AV_SLEW_get_write_en1(data)                                              ((0x00000004&(data))>>2)
+#define TVE_AV_SLEW_p_slewrate_shift                                                 (0)
+#define TVE_AV_SLEW_p_slewrate_mask                                                  (0x00000003)
+#define TVE_AV_SLEW_p_slewrate(data)                                                 (0x00000003&((data)<<0))
+#define TVE_AV_SLEW_p_slewrate_src(data)                                             ((0x00000003&(data))>>0)
+#define TVE_AV_SLEW_get_p_slewrate(data)                                             ((0x00000003&(data))>>0)
+
+
+#define TVE_SLEW_I_HPOS                                                              0x1801804c
+#define TVE_SLEW_I_HPOS_reg_addr                                                     "0xB801804C"
+#define TVE_SLEW_I_HPOS_reg                                                          0xB801804C
+#define set_TVE_SLEW_I_HPOS_reg(data)   (*((volatile unsigned int*) TVE_SLEW_I_HPOS_reg)=data)
+#define get_TVE_SLEW_I_HPOS_reg   (*((volatile unsigned int*) TVE_SLEW_I_HPOS_reg))
+#define TVE_SLEW_I_HPOS_inst_adr                                                     "0x0013"
+#define TVE_SLEW_I_HPOS_inst                                                         0x0013
+#define TVE_SLEW_I_HPOS_write_en2_shift                                              (21)
+#define TVE_SLEW_I_HPOS_write_en2_mask                                               (0x00200000)
+#define TVE_SLEW_I_HPOS_write_en2(data)                                              (0x00200000&((data)<<21))
+#define TVE_SLEW_I_HPOS_write_en2_src(data)                                          ((0x00200000&(data))>>21)
+#define TVE_SLEW_I_HPOS_get_write_en2(data)                                          ((0x00200000&(data))>>21)
+#define TVE_SLEW_I_HPOS_i_h_st_shift                                                 (11)
+#define TVE_SLEW_I_HPOS_i_h_st_mask                                                  (0x001FF800)
+#define TVE_SLEW_I_HPOS_i_h_st(data)                                                 (0x001FF800&((data)<<11))
+#define TVE_SLEW_I_HPOS_i_h_st_src(data)                                             ((0x001FF800&(data))>>11)
+#define TVE_SLEW_I_HPOS_get_i_h_st(data)                                             ((0x001FF800&(data))>>11)
+#define TVE_SLEW_I_HPOS_write_en1_shift                                              (10)
+#define TVE_SLEW_I_HPOS_write_en1_mask                                               (0x00000400)
+#define TVE_SLEW_I_HPOS_write_en1(data)                                              (0x00000400&((data)<<10))
+#define TVE_SLEW_I_HPOS_write_en1_src(data)                                          ((0x00000400&(data))>>10)
+#define TVE_SLEW_I_HPOS_get_write_en1(data)                                          ((0x00000400&(data))>>10)
+#define TVE_SLEW_I_HPOS_i_h_end_shift                                                (0)
+#define TVE_SLEW_I_HPOS_i_h_end_mask                                                 (0x000003FF)
+#define TVE_SLEW_I_HPOS_i_h_end(data)                                                (0x000003FF&((data)<<0))
+#define TVE_SLEW_I_HPOS_i_h_end_src(data)                                            ((0x000003FF&(data))>>0)
+#define TVE_SLEW_I_HPOS_get_i_h_end(data)                                            ((0x000003FF&(data))>>0)
+
+
+#define TVE_AV_I_HPOS                                                                0x18018050
+#define TVE_AV_I_HPOS_reg_addr                                                       "0xB8018050"
+#define TVE_AV_I_HPOS_reg                                                            0xB8018050
+#define set_TVE_AV_I_HPOS_reg(data)   (*((volatile unsigned int*) TVE_AV_I_HPOS_reg)=data)
+#define get_TVE_AV_I_HPOS_reg   (*((volatile unsigned int*) TVE_AV_I_HPOS_reg))
+#define TVE_AV_I_HPOS_inst_adr                                                       "0x0014"
+#define TVE_AV_I_HPOS_inst                                                           0x0014
+#define TVE_AV_I_HPOS_write_en2_shift                                                (27)
+#define TVE_AV_I_HPOS_write_en2_mask                                                 (0x08000000)
+#define TVE_AV_I_HPOS_write_en2(data)                                                (0x08000000&((data)<<27))
+#define TVE_AV_I_HPOS_write_en2_src(data)                                            ((0x08000000&(data))>>27)
+#define TVE_AV_I_HPOS_get_write_en2(data)                                            ((0x08000000&(data))>>27)
+#define TVE_AV_I_HPOS_i_h_st_shift                                                   (14)
+#define TVE_AV_I_HPOS_i_h_st_mask                                                    (0x07FFC000)
+#define TVE_AV_I_HPOS_i_h_st(data)                                                   (0x07FFC000&((data)<<14))
+#define TVE_AV_I_HPOS_i_h_st_src(data)                                               ((0x07FFC000&(data))>>14)
+#define TVE_AV_I_HPOS_get_i_h_st(data)                                               ((0x07FFC000&(data))>>14)
+#define TVE_AV_I_HPOS_write_en1_shift                                                (13)
+#define TVE_AV_I_HPOS_write_en1_mask                                                 (0x00002000)
+#define TVE_AV_I_HPOS_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_AV_I_HPOS_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_AV_I_HPOS_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_AV_I_HPOS_i_h_end_shift                                                  (0)
+#define TVE_AV_I_HPOS_i_h_end_mask                                                   (0x00001FFF)
+#define TVE_AV_I_HPOS_i_h_end(data)                                                  (0x00001FFF&((data)<<0))
+#define TVE_AV_I_HPOS_i_h_end_src(data)                                              ((0x00001FFF&(data))>>0)
+#define TVE_AV_I_HPOS_get_i_h_end(data)                                              ((0x00001FFF&(data))>>0)
+
+
+#define TVE_AV_P_HPOS1                                                               0x18018054
+#define TVE_AV_P_HPOS1_reg_addr                                                      "0xB8018054"
+#define TVE_AV_P_HPOS1_reg                                                           0xB8018054
+#define set_TVE_AV_P_HPOS1_reg(data)   (*((volatile unsigned int*) TVE_AV_P_HPOS1_reg)=data)
+#define get_TVE_AV_P_HPOS1_reg   (*((volatile unsigned int*) TVE_AV_P_HPOS1_reg))
+#define TVE_AV_P_HPOS1_inst_adr                                                      "0x0015"
+#define TVE_AV_P_HPOS1_inst                                                          0x0015
+#define TVE_AV_P_HPOS1_write_en3_shift                                               (29)
+#define TVE_AV_P_HPOS1_write_en3_mask                                                (0x20000000)
+#define TVE_AV_P_HPOS1_write_en3(data)                                               (0x20000000&((data)<<29))
+#define TVE_AV_P_HPOS1_write_en3_src(data)                                           ((0x20000000&(data))>>29)
+#define TVE_AV_P_HPOS1_get_write_en3(data)                                           ((0x20000000&(data))>>29)
+#define TVE_AV_P_HPOS1_p_av_cord_shift                                               (28)
+#define TVE_AV_P_HPOS1_p_av_cord_mask                                                (0x10000000)
+#define TVE_AV_P_HPOS1_p_av_cord(data)                                               (0x10000000&((data)<<28))
+#define TVE_AV_P_HPOS1_p_av_cord_src(data)                                           ((0x10000000&(data))>>28)
+#define TVE_AV_P_HPOS1_get_p_av_cord(data)                                           ((0x10000000&(data))>>28)
+#define TVE_AV_P_HPOS1_write_en2_shift                                               (27)
+#define TVE_AV_P_HPOS1_write_en2_mask                                                (0x08000000)
+#define TVE_AV_P_HPOS1_write_en2(data)                                               (0x08000000&((data)<<27))
+#define TVE_AV_P_HPOS1_write_en2_src(data)                                           ((0x08000000&(data))>>27)
+#define TVE_AV_P_HPOS1_get_write_en2(data)                                           ((0x08000000&(data))>>27)
+#define TVE_AV_P_HPOS1_p_h_st_shift                                                  (14)
+#define TVE_AV_P_HPOS1_p_h_st_mask                                                   (0x07FFC000)
+#define TVE_AV_P_HPOS1_p_h_st(data)                                                  (0x07FFC000&((data)<<14))
+#define TVE_AV_P_HPOS1_p_h_st_src(data)                                              ((0x07FFC000&(data))>>14)
+#define TVE_AV_P_HPOS1_get_p_h_st(data)                                              ((0x07FFC000&(data))>>14)
+#define TVE_AV_P_HPOS1_write_en1_shift                                               (13)
+#define TVE_AV_P_HPOS1_write_en1_mask                                                (0x00002000)
+#define TVE_AV_P_HPOS1_write_en1(data)                                               (0x00002000&((data)<<13))
+#define TVE_AV_P_HPOS1_write_en1_src(data)                                           ((0x00002000&(data))>>13)
+#define TVE_AV_P_HPOS1_get_write_en1(data)                                           ((0x00002000&(data))>>13)
+#define TVE_AV_P_HPOS1_p_h_end_shift                                                 (0)
+#define TVE_AV_P_HPOS1_p_h_end_mask                                                  (0x00001FFF)
+#define TVE_AV_P_HPOS1_p_h_end(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_AV_P_HPOS1_p_h_end_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_AV_P_HPOS1_get_p_h_end(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_AV_H_HPOS1                                                               0x18018058
+#define TVE_AV_H_HPOS1_reg_addr                                                      "0xB8018058"
+#define TVE_AV_H_HPOS1_reg                                                           0xB8018058
+#define set_TVE_AV_H_HPOS1_reg(data)   (*((volatile unsigned int*) TVE_AV_H_HPOS1_reg)=data)
+#define get_TVE_AV_H_HPOS1_reg   (*((volatile unsigned int*) TVE_AV_H_HPOS1_reg))
+#define TVE_AV_H_HPOS1_inst_adr                                                      "0x0016"
+#define TVE_AV_H_HPOS1_inst                                                          0x0016
+#define TVE_AV_H_HPOS1_write_en3_shift                                               (29)
+#define TVE_AV_H_HPOS1_write_en3_mask                                                (0x20000000)
+#define TVE_AV_H_HPOS1_write_en3(data)                                               (0x20000000&((data)<<29))
+#define TVE_AV_H_HPOS1_write_en3_src(data)                                           ((0x20000000&(data))>>29)
+#define TVE_AV_H_HPOS1_get_write_en3(data)                                           ((0x20000000&(data))>>29)
+#define TVE_AV_H_HPOS1_h_av_cord_shift                                               (28)
+#define TVE_AV_H_HPOS1_h_av_cord_mask                                                (0x10000000)
+#define TVE_AV_H_HPOS1_h_av_cord(data)                                               (0x10000000&((data)<<28))
+#define TVE_AV_H_HPOS1_h_av_cord_src(data)                                           ((0x10000000&(data))>>28)
+#define TVE_AV_H_HPOS1_get_h_av_cord(data)                                           ((0x10000000&(data))>>28)
+#define TVE_AV_H_HPOS1_write_en2_shift                                               (27)
+#define TVE_AV_H_HPOS1_write_en2_mask                                                (0x08000000)
+#define TVE_AV_H_HPOS1_write_en2(data)                                               (0x08000000&((data)<<27))
+#define TVE_AV_H_HPOS1_write_en2_src(data)                                           ((0x08000000&(data))>>27)
+#define TVE_AV_H_HPOS1_get_write_en2(data)                                           ((0x08000000&(data))>>27)
+#define TVE_AV_H_HPOS1_h_h_st_shift                                                  (14)
+#define TVE_AV_H_HPOS1_h_h_st_mask                                                   (0x07FFC000)
+#define TVE_AV_H_HPOS1_h_h_st(data)                                                  (0x07FFC000&((data)<<14))
+#define TVE_AV_H_HPOS1_h_h_st_src(data)                                              ((0x07FFC000&(data))>>14)
+#define TVE_AV_H_HPOS1_get_h_h_st(data)                                              ((0x07FFC000&(data))>>14)
+#define TVE_AV_H_HPOS1_write_en1_shift                                               (13)
+#define TVE_AV_H_HPOS1_write_en1_mask                                                (0x00002000)
+#define TVE_AV_H_HPOS1_write_en1(data)                                               (0x00002000&((data)<<13))
+#define TVE_AV_H_HPOS1_write_en1_src(data)                                           ((0x00002000&(data))>>13)
+#define TVE_AV_H_HPOS1_get_write_en1(data)                                           ((0x00002000&(data))>>13)
+#define TVE_AV_H_HPOS1_h_h_end_shift                                                 (0)
+#define TVE_AV_H_HPOS1_h_h_end_mask                                                  (0x00001FFF)
+#define TVE_AV_H_HPOS1_h_h_end(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_AV_H_HPOS1_h_h_end_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_AV_H_HPOS1_get_h_h_end(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_ITOP_VPOS                                                                0x1801805c
+#define TVE_ITOP_VPOS_reg_addr                                                       "0xB801805C"
+#define TVE_ITOP_VPOS_reg                                                            0xB801805C
+#define set_TVE_ITOP_VPOS_reg(data)   (*((volatile unsigned int*) TVE_ITOP_VPOS_reg)=data)
+#define get_TVE_ITOP_VPOS_reg   (*((volatile unsigned int*) TVE_ITOP_VPOS_reg))
+#define TVE_ITOP_VPOS_inst_adr                                                       "0x0017"
+#define TVE_ITOP_VPOS_inst                                                           0x0017
+#define TVE_ITOP_VPOS_write_en2_shift                                                (23)
+#define TVE_ITOP_VPOS_write_en2_mask                                                 (0x00800000)
+#define TVE_ITOP_VPOS_write_en2(data)                                                (0x00800000&((data)<<23))
+#define TVE_ITOP_VPOS_write_en2_src(data)                                            ((0x00800000&(data))>>23)
+#define TVE_ITOP_VPOS_get_write_en2(data)                                            ((0x00800000&(data))>>23)
+#define TVE_ITOP_VPOS_itop_v_st_shift                                                (12)
+#define TVE_ITOP_VPOS_itop_v_st_mask                                                 (0x007FF000)
+#define TVE_ITOP_VPOS_itop_v_st(data)                                                (0x007FF000&((data)<<12))
+#define TVE_ITOP_VPOS_itop_v_st_src(data)                                            ((0x007FF000&(data))>>12)
+#define TVE_ITOP_VPOS_get_itop_v_st(data)                                            ((0x007FF000&(data))>>12)
+#define TVE_ITOP_VPOS_write_en1_shift                                                (11)
+#define TVE_ITOP_VPOS_write_en1_mask                                                 (0x00000800)
+#define TVE_ITOP_VPOS_write_en1(data)                                                (0x00000800&((data)<<11))
+#define TVE_ITOP_VPOS_write_en1_src(data)                                            ((0x00000800&(data))>>11)
+#define TVE_ITOP_VPOS_get_write_en1(data)                                            ((0x00000800&(data))>>11)
+#define TVE_ITOP_VPOS_itop_v_end_shift                                               (0)
+#define TVE_ITOP_VPOS_itop_v_end_mask                                                (0x000007FF)
+#define TVE_ITOP_VPOS_itop_v_end(data)                                               (0x000007FF&((data)<<0))
+#define TVE_ITOP_VPOS_itop_v_end_src(data)                                           ((0x000007FF&(data))>>0)
+#define TVE_ITOP_VPOS_get_itop_v_end(data)                                           ((0x000007FF&(data))>>0)
+
+
+#define TVE_IBOT_VPOS                                                                0x18018060
+#define TVE_IBOT_VPOS_reg_addr                                                       "0xB8018060"
+#define TVE_IBOT_VPOS_reg                                                            0xB8018060
+#define set_TVE_IBOT_VPOS_reg(data)   (*((volatile unsigned int*) TVE_IBOT_VPOS_reg)=data)
+#define get_TVE_IBOT_VPOS_reg   (*((volatile unsigned int*) TVE_IBOT_VPOS_reg))
+#define TVE_IBOT_VPOS_inst_adr                                                       "0x0018"
+#define TVE_IBOT_VPOS_inst                                                           0x0018
+#define TVE_IBOT_VPOS_write_en2_shift                                                (23)
+#define TVE_IBOT_VPOS_write_en2_mask                                                 (0x00800000)
+#define TVE_IBOT_VPOS_write_en2(data)                                                (0x00800000&((data)<<23))
+#define TVE_IBOT_VPOS_write_en2_src(data)                                            ((0x00800000&(data))>>23)
+#define TVE_IBOT_VPOS_get_write_en2(data)                                            ((0x00800000&(data))>>23)
+#define TVE_IBOT_VPOS_ibot_v_st_shift                                                (12)
+#define TVE_IBOT_VPOS_ibot_v_st_mask                                                 (0x007FF000)
+#define TVE_IBOT_VPOS_ibot_v_st(data)                                                (0x007FF000&((data)<<12))
+#define TVE_IBOT_VPOS_ibot_v_st_src(data)                                            ((0x007FF000&(data))>>12)
+#define TVE_IBOT_VPOS_get_ibot_v_st(data)                                            ((0x007FF000&(data))>>12)
+#define TVE_IBOT_VPOS_write_en1_shift                                                (11)
+#define TVE_IBOT_VPOS_write_en1_mask                                                 (0x00000800)
+#define TVE_IBOT_VPOS_write_en1(data)                                                (0x00000800&((data)<<11))
+#define TVE_IBOT_VPOS_write_en1_src(data)                                            ((0x00000800&(data))>>11)
+#define TVE_IBOT_VPOS_get_write_en1(data)                                            ((0x00000800&(data))>>11)
+#define TVE_IBOT_VPOS_ibot_v_end_shift                                               (0)
+#define TVE_IBOT_VPOS_ibot_v_end_mask                                                (0x000007FF)
+#define TVE_IBOT_VPOS_ibot_v_end(data)                                               (0x000007FF&((data)<<0))
+#define TVE_IBOT_VPOS_ibot_v_end_src(data)                                           ((0x000007FF&(data))>>0)
+#define TVE_IBOT_VPOS_get_ibot_v_end(data)                                           ((0x000007FF&(data))>>0)
+
+
+#define TVE_P_VPOS1                                                                  0x18018064
+#define TVE_P_VPOS1_reg_addr                                                         "0xB8018064"
+#define TVE_P_VPOS1_reg                                                              0xB8018064
+#define set_TVE_P_VPOS1_reg(data)   (*((volatile unsigned int*) TVE_P_VPOS1_reg)=data)
+#define get_TVE_P_VPOS1_reg   (*((volatile unsigned int*) TVE_P_VPOS1_reg))
+#define TVE_P_VPOS1_inst_adr                                                         "0x0019"
+#define TVE_P_VPOS1_inst                                                             0x0019
+#define TVE_P_VPOS1_write_en2_shift                                                  (23)
+#define TVE_P_VPOS1_write_en2_mask                                                   (0x00800000)
+#define TVE_P_VPOS1_write_en2(data)                                                  (0x00800000&((data)<<23))
+#define TVE_P_VPOS1_write_en2_src(data)                                              ((0x00800000&(data))>>23)
+#define TVE_P_VPOS1_get_write_en2(data)                                              ((0x00800000&(data))>>23)
+#define TVE_P_VPOS1_p_v_st_shift                                                     (12)
+#define TVE_P_VPOS1_p_v_st_mask                                                      (0x007FF000)
+#define TVE_P_VPOS1_p_v_st(data)                                                     (0x007FF000&((data)<<12))
+#define TVE_P_VPOS1_p_v_st_src(data)                                                 ((0x007FF000&(data))>>12)
+#define TVE_P_VPOS1_get_p_v_st(data)                                                 ((0x007FF000&(data))>>12)
+#define TVE_P_VPOS1_write_en1_shift                                                  (11)
+#define TVE_P_VPOS1_write_en1_mask                                                   (0x00000800)
+#define TVE_P_VPOS1_write_en1(data)                                                  (0x00000800&((data)<<11))
+#define TVE_P_VPOS1_write_en1_src(data)                                              ((0x00000800&(data))>>11)
+#define TVE_P_VPOS1_get_write_en1(data)                                              ((0x00000800&(data))>>11)
+#define TVE_P_VPOS1_p_v_end_shift                                                    (0)
+#define TVE_P_VPOS1_p_v_end_mask                                                     (0x000007FF)
+#define TVE_P_VPOS1_p_v_end(data)                                                    (0x000007FF&((data)<<0))
+#define TVE_P_VPOS1_p_v_end_src(data)                                                ((0x000007FF&(data))>>0)
+#define TVE_P_VPOS1_get_p_v_end(data)                                                ((0x000007FF&(data))>>0)
+
+
+#define TVE_P_VPOS2                                                                  0x18018068
+#define TVE_P_VPOS2_reg_addr                                                         "0xB8018068"
+#define TVE_P_VPOS2_reg                                                              0xB8018068
+#define set_TVE_P_VPOS2_reg(data)   (*((volatile unsigned int*) TVE_P_VPOS2_reg)=data)
+#define get_TVE_P_VPOS2_reg   (*((volatile unsigned int*) TVE_P_VPOS2_reg))
+#define TVE_P_VPOS2_inst_adr                                                         "0x001A"
+#define TVE_P_VPOS2_inst                                                             0x001A
+#define TVE_P_VPOS2_write_en2_shift                                                  (23)
+#define TVE_P_VPOS2_write_en2_mask                                                   (0x00800000)
+#define TVE_P_VPOS2_write_en2(data)                                                  (0x00800000&((data)<<23))
+#define TVE_P_VPOS2_write_en2_src(data)                                              ((0x00800000&(data))>>23)
+#define TVE_P_VPOS2_get_write_en2(data)                                              ((0x00800000&(data))>>23)
+#define TVE_P_VPOS2_p_v_st_shift                                                     (12)
+#define TVE_P_VPOS2_p_v_st_mask                                                      (0x007FF000)
+#define TVE_P_VPOS2_p_v_st(data)                                                     (0x007FF000&((data)<<12))
+#define TVE_P_VPOS2_p_v_st_src(data)                                                 ((0x007FF000&(data))>>12)
+#define TVE_P_VPOS2_get_p_v_st(data)                                                 ((0x007FF000&(data))>>12)
+#define TVE_P_VPOS2_write_en1_shift                                                  (11)
+#define TVE_P_VPOS2_write_en1_mask                                                   (0x00000800)
+#define TVE_P_VPOS2_write_en1(data)                                                  (0x00000800&((data)<<11))
+#define TVE_P_VPOS2_write_en1_src(data)                                              ((0x00000800&(data))>>11)
+#define TVE_P_VPOS2_get_write_en1(data)                                              ((0x00000800&(data))>>11)
+#define TVE_P_VPOS2_p_v_end_shift                                                    (0)
+#define TVE_P_VPOS2_p_v_end_mask                                                     (0x000007FF)
+#define TVE_P_VPOS2_p_v_end(data)                                                    (0x000007FF&((data)<<0))
+#define TVE_P_VPOS2_p_v_end_src(data)                                                ((0x000007FF&(data))>>0)
+#define TVE_P_VPOS2_get_p_v_end(data)                                                ((0x000007FF&(data))>>0)
+
+
+#define TVE_H_VPOS1                                                                  0x1801806c
+#define TVE_H_VPOS1_reg_addr                                                         "0xB801806C"
+#define TVE_H_VPOS1_reg                                                              0xB801806C
+#define set_TVE_H_VPOS1_reg(data)   (*((volatile unsigned int*) TVE_H_VPOS1_reg)=data)
+#define get_TVE_H_VPOS1_reg   (*((volatile unsigned int*) TVE_H_VPOS1_reg))
+#define TVE_H_VPOS1_inst_adr                                                         "0x001B"
+#define TVE_H_VPOS1_inst                                                             0x001B
+#define TVE_H_VPOS1_write_en2_shift                                                  (23)
+#define TVE_H_VPOS1_write_en2_mask                                                   (0x00800000)
+#define TVE_H_VPOS1_write_en2(data)                                                  (0x00800000&((data)<<23))
+#define TVE_H_VPOS1_write_en2_src(data)                                              ((0x00800000&(data))>>23)
+#define TVE_H_VPOS1_get_write_en2(data)                                              ((0x00800000&(data))>>23)
+#define TVE_H_VPOS1_h_v_st_shift                                                     (12)
+#define TVE_H_VPOS1_h_v_st_mask                                                      (0x007FF000)
+#define TVE_H_VPOS1_h_v_st(data)                                                     (0x007FF000&((data)<<12))
+#define TVE_H_VPOS1_h_v_st_src(data)                                                 ((0x007FF000&(data))>>12)
+#define TVE_H_VPOS1_get_h_v_st(data)                                                 ((0x007FF000&(data))>>12)
+#define TVE_H_VPOS1_write_en1_shift                                                  (11)
+#define TVE_H_VPOS1_write_en1_mask                                                   (0x00000800)
+#define TVE_H_VPOS1_write_en1(data)                                                  (0x00000800&((data)<<11))
+#define TVE_H_VPOS1_write_en1_src(data)                                              ((0x00000800&(data))>>11)
+#define TVE_H_VPOS1_get_write_en1(data)                                              ((0x00000800&(data))>>11)
+#define TVE_H_VPOS1_h_v_end_shift                                                    (0)
+#define TVE_H_VPOS1_h_v_end_mask                                                     (0x000007FF)
+#define TVE_H_VPOS1_h_v_end(data)                                                    (0x000007FF&((data)<<0))
+#define TVE_H_VPOS1_h_v_end_src(data)                                                ((0x000007FF&(data))>>0)
+#define TVE_H_VPOS1_get_h_v_end(data)                                                ((0x000007FF&(data))>>0)
+
+
+#define TVE_H_VPOS2                                                                  0x18018070
+#define TVE_H_VPOS2_reg_addr                                                         "0xB8018070"
+#define TVE_H_VPOS2_reg                                                              0xB8018070
+#define set_TVE_H_VPOS2_reg(data)   (*((volatile unsigned int*) TVE_H_VPOS2_reg)=data)
+#define get_TVE_H_VPOS2_reg   (*((volatile unsigned int*) TVE_H_VPOS2_reg))
+#define TVE_H_VPOS2_inst_adr                                                         "0x001C"
+#define TVE_H_VPOS2_inst                                                             0x001C
+#define TVE_H_VPOS2_write_en2_shift                                                  (23)
+#define TVE_H_VPOS2_write_en2_mask                                                   (0x00800000)
+#define TVE_H_VPOS2_write_en2(data)                                                  (0x00800000&((data)<<23))
+#define TVE_H_VPOS2_write_en2_src(data)                                              ((0x00800000&(data))>>23)
+#define TVE_H_VPOS2_get_write_en2(data)                                              ((0x00800000&(data))>>23)
+#define TVE_H_VPOS2_h_v_st_shift                                                     (12)
+#define TVE_H_VPOS2_h_v_st_mask                                                      (0x007FF000)
+#define TVE_H_VPOS2_h_v_st(data)                                                     (0x007FF000&((data)<<12))
+#define TVE_H_VPOS2_h_v_st_src(data)                                                 ((0x007FF000&(data))>>12)
+#define TVE_H_VPOS2_get_h_v_st(data)                                                 ((0x007FF000&(data))>>12)
+#define TVE_H_VPOS2_write_en1_shift                                                  (11)
+#define TVE_H_VPOS2_write_en1_mask                                                   (0x00000800)
+#define TVE_H_VPOS2_write_en1(data)                                                  (0x00000800&((data)<<11))
+#define TVE_H_VPOS2_write_en1_src(data)                                              ((0x00000800&(data))>>11)
+#define TVE_H_VPOS2_get_write_en1(data)                                              ((0x00000800&(data))>>11)
+#define TVE_H_VPOS2_h_v_end_shift                                                    (0)
+#define TVE_H_VPOS2_h_v_end_mask                                                     (0x000007FF)
+#define TVE_H_VPOS2_h_v_end(data)                                                    (0x000007FF&((data)<<0))
+#define TVE_H_VPOS2_h_v_end_src(data)                                                ((0x000007FF&(data))>>0)
+#define TVE_H_VPOS2_get_h_v_end(data)                                                ((0x000007FF&(data))>>0)
+
+
+#define TVE_I_COLORBAR_HPOS                                                          0x18018074
+#define TVE_I_COLORBAR_HPOS_reg_addr                                                 "0xB8018074"
+#define TVE_I_COLORBAR_HPOS_reg                                                      0xB8018074
+#define set_TVE_I_COLORBAR_HPOS_reg(data)   (*((volatile unsigned int*) TVE_I_COLORBAR_HPOS_reg)=data)
+#define get_TVE_I_COLORBAR_HPOS_reg   (*((volatile unsigned int*) TVE_I_COLORBAR_HPOS_reg))
+#define TVE_I_COLORBAR_HPOS_inst_adr                                                 "0x001D"
+#define TVE_I_COLORBAR_HPOS_inst                                                     0x001D
+#define TVE_I_COLORBAR_HPOS_write_en2_shift                                          (21)
+#define TVE_I_COLORBAR_HPOS_write_en2_mask                                           (0x00200000)
+#define TVE_I_COLORBAR_HPOS_write_en2(data)                                          (0x00200000&((data)<<21))
+#define TVE_I_COLORBAR_HPOS_write_en2_src(data)                                      ((0x00200000&(data))>>21)
+#define TVE_I_COLORBAR_HPOS_get_write_en2(data)                                      ((0x00200000&(data))>>21)
+#define TVE_I_COLORBAR_HPOS_i_h_width_shift                                          (11)
+#define TVE_I_COLORBAR_HPOS_i_h_width_mask                                           (0x001FF800)
+#define TVE_I_COLORBAR_HPOS_i_h_width(data)                                          (0x001FF800&((data)<<11))
+#define TVE_I_COLORBAR_HPOS_i_h_width_src(data)                                      ((0x001FF800&(data))>>11)
+#define TVE_I_COLORBAR_HPOS_get_i_h_width(data)                                      ((0x001FF800&(data))>>11)
+#define TVE_I_COLORBAR_HPOS_write_en1_shift                                          (10)
+#define TVE_I_COLORBAR_HPOS_write_en1_mask                                           (0x00000400)
+#define TVE_I_COLORBAR_HPOS_write_en1(data)                                          (0x00000400&((data)<<10))
+#define TVE_I_COLORBAR_HPOS_write_en1_src(data)                                      ((0x00000400&(data))>>10)
+#define TVE_I_COLORBAR_HPOS_get_write_en1(data)                                      ((0x00000400&(data))>>10)
+#define TVE_I_COLORBAR_HPOS_i_h_st_pos_shift                                         (0)
+#define TVE_I_COLORBAR_HPOS_i_h_st_pos_mask                                          (0x000003FF)
+#define TVE_I_COLORBAR_HPOS_i_h_st_pos(data)                                         (0x000003FF&((data)<<0))
+#define TVE_I_COLORBAR_HPOS_i_h_st_pos_src(data)                                     ((0x000003FF&(data))>>0)
+#define TVE_I_COLORBAR_HPOS_get_i_h_st_pos(data)                                     ((0x000003FF&(data))>>0)
+
+
+#define TVE_P_COLORBAR_HPOS                                                          0x18018078
+#define TVE_P_COLORBAR_HPOS_reg_addr                                                 "0xB8018078"
+#define TVE_P_COLORBAR_HPOS_reg                                                      0xB8018078
+#define set_TVE_P_COLORBAR_HPOS_reg(data)   (*((volatile unsigned int*) TVE_P_COLORBAR_HPOS_reg)=data)
+#define get_TVE_P_COLORBAR_HPOS_reg   (*((volatile unsigned int*) TVE_P_COLORBAR_HPOS_reg))
+#define TVE_P_COLORBAR_HPOS_inst_adr                                                 "0x001E"
+#define TVE_P_COLORBAR_HPOS_inst                                                     0x001E
+#define TVE_P_COLORBAR_HPOS_write_en2_shift                                          (21)
+#define TVE_P_COLORBAR_HPOS_write_en2_mask                                           (0x00200000)
+#define TVE_P_COLORBAR_HPOS_write_en2(data)                                          (0x00200000&((data)<<21))
+#define TVE_P_COLORBAR_HPOS_write_en2_src(data)                                      ((0x00200000&(data))>>21)
+#define TVE_P_COLORBAR_HPOS_get_write_en2(data)                                      ((0x00200000&(data))>>21)
+#define TVE_P_COLORBAR_HPOS_p_h_width_shift                                          (11)
+#define TVE_P_COLORBAR_HPOS_p_h_width_mask                                           (0x001FF800)
+#define TVE_P_COLORBAR_HPOS_p_h_width(data)                                          (0x001FF800&((data)<<11))
+#define TVE_P_COLORBAR_HPOS_p_h_width_src(data)                                      ((0x001FF800&(data))>>11)
+#define TVE_P_COLORBAR_HPOS_get_p_h_width(data)                                      ((0x001FF800&(data))>>11)
+#define TVE_P_COLORBAR_HPOS_write_en1_shift                                          (10)
+#define TVE_P_COLORBAR_HPOS_write_en1_mask                                           (0x00000400)
+#define TVE_P_COLORBAR_HPOS_write_en1(data)                                          (0x00000400&((data)<<10))
+#define TVE_P_COLORBAR_HPOS_write_en1_src(data)                                      ((0x00000400&(data))>>10)
+#define TVE_P_COLORBAR_HPOS_get_write_en1(data)                                      ((0x00000400&(data))>>10)
+#define TVE_P_COLORBAR_HPOS_p_h_st_pos_shift                                         (0)
+#define TVE_P_COLORBAR_HPOS_p_h_st_pos_mask                                          (0x000003FF)
+#define TVE_P_COLORBAR_HPOS_p_h_st_pos(data)                                         (0x000003FF&((data)<<0))
+#define TVE_P_COLORBAR_HPOS_p_h_st_pos_src(data)                                     ((0x000003FF&(data))>>0)
+#define TVE_P_COLORBAR_HPOS_get_p_h_st_pos(data)                                     ((0x000003FF&(data))>>0)
+
+
+#define TVE_H_COLORBAR_HPOS                                                          0x1801807c
+#define TVE_H_COLORBAR_HPOS_reg_addr                                                 "0xB801807C"
+#define TVE_H_COLORBAR_HPOS_reg                                                      0xB801807C
+#define set_TVE_H_COLORBAR_HPOS_reg(data)   (*((volatile unsigned int*) TVE_H_COLORBAR_HPOS_reg)=data)
+#define get_TVE_H_COLORBAR_HPOS_reg   (*((volatile unsigned int*) TVE_H_COLORBAR_HPOS_reg))
+#define TVE_H_COLORBAR_HPOS_inst_adr                                                 "0x001F"
+#define TVE_H_COLORBAR_HPOS_inst                                                     0x001F
+#define TVE_H_COLORBAR_HPOS_write_en2_shift                                          (21)
+#define TVE_H_COLORBAR_HPOS_write_en2_mask                                           (0x00200000)
+#define TVE_H_COLORBAR_HPOS_write_en2(data)                                          (0x00200000&((data)<<21))
+#define TVE_H_COLORBAR_HPOS_write_en2_src(data)                                      ((0x00200000&(data))>>21)
+#define TVE_H_COLORBAR_HPOS_get_write_en2(data)                                      ((0x00200000&(data))>>21)
+#define TVE_H_COLORBAR_HPOS_p_h_width_shift                                          (11)
+#define TVE_H_COLORBAR_HPOS_p_h_width_mask                                           (0x001FF800)
+#define TVE_H_COLORBAR_HPOS_p_h_width(data)                                          (0x001FF800&((data)<<11))
+#define TVE_H_COLORBAR_HPOS_p_h_width_src(data)                                      ((0x001FF800&(data))>>11)
+#define TVE_H_COLORBAR_HPOS_get_p_h_width(data)                                      ((0x001FF800&(data))>>11)
+#define TVE_H_COLORBAR_HPOS_write_en1_shift                                          (10)
+#define TVE_H_COLORBAR_HPOS_write_en1_mask                                           (0x00000400)
+#define TVE_H_COLORBAR_HPOS_write_en1(data)                                          (0x00000400&((data)<<10))
+#define TVE_H_COLORBAR_HPOS_write_en1_src(data)                                      ((0x00000400&(data))>>10)
+#define TVE_H_COLORBAR_HPOS_get_write_en1(data)                                      ((0x00000400&(data))>>10)
+#define TVE_H_COLORBAR_HPOS_p_h_st_pos_shift                                         (0)
+#define TVE_H_COLORBAR_HPOS_p_h_st_pos_mask                                          (0x000003FF)
+#define TVE_H_COLORBAR_HPOS_p_h_st_pos(data)                                         (0x000003FF&((data)<<0))
+#define TVE_H_COLORBAR_HPOS_p_h_st_pos_src(data)                                     ((0x000003FF&(data))>>0)
+#define TVE_H_COLORBAR_HPOS_get_p_h_st_pos(data)                                     ((0x000003FF&(data))>>0)
+
+
+#define TVE_COMP_VSYNC_HPOS                                                          0x18018080
+#define TVE_COMP_VSYNC_HPOS_reg_addr                                                 "0xB8018080"
+#define TVE_COMP_VSYNC_HPOS_reg                                                      0xB8018080
+#define set_TVE_COMP_VSYNC_HPOS_reg(data)   (*((volatile unsigned int*) TVE_COMP_VSYNC_HPOS_reg)=data)
+#define get_TVE_COMP_VSYNC_HPOS_reg   (*((volatile unsigned int*) TVE_COMP_VSYNC_HPOS_reg))
+#define TVE_COMP_VSYNC_HPOS_inst_adr                                                 "0x0020"
+#define TVE_COMP_VSYNC_HPOS_inst                                                     0x0020
+#define TVE_COMP_VSYNC_HPOS_write_en3_shift                                          (29)
+#define TVE_COMP_VSYNC_HPOS_write_en3_mask                                           (0x20000000)
+#define TVE_COMP_VSYNC_HPOS_write_en3(data)                                          (0x20000000&((data)<<29))
+#define TVE_COMP_VSYNC_HPOS_write_en3_src(data)                                      ((0x20000000&(data))>>29)
+#define TVE_COMP_VSYNC_HPOS_get_write_en3(data)                                      ((0x20000000&(data))>>29)
+#define TVE_COMP_VSYNC_HPOS_negsyncst_shift                                          (20)
+#define TVE_COMP_VSYNC_HPOS_negsyncst_mask                                           (0x1FF00000)
+#define TVE_COMP_VSYNC_HPOS_negsyncst(data)                                          (0x1FF00000&((data)<<20))
+#define TVE_COMP_VSYNC_HPOS_negsyncst_src(data)                                      ((0x1FF00000&(data))>>20)
+#define TVE_COMP_VSYNC_HPOS_get_negsyncst(data)                                      ((0x1FF00000&(data))>>20)
+#define TVE_COMP_VSYNC_HPOS_write_en2_shift                                          (19)
+#define TVE_COMP_VSYNC_HPOS_write_en2_mask                                           (0x00080000)
+#define TVE_COMP_VSYNC_HPOS_write_en2(data)                                          (0x00080000&((data)<<19))
+#define TVE_COMP_VSYNC_HPOS_write_en2_src(data)                                      ((0x00080000&(data))>>19)
+#define TVE_COMP_VSYNC_HPOS_get_write_en2(data)                                      ((0x00080000&(data))>>19)
+#define TVE_COMP_VSYNC_HPOS_possyncst_shift                                          (10)
+#define TVE_COMP_VSYNC_HPOS_possyncst_mask                                           (0x0007FC00)
+#define TVE_COMP_VSYNC_HPOS_possyncst(data)                                          (0x0007FC00&((data)<<10))
+#define TVE_COMP_VSYNC_HPOS_possyncst_src(data)                                      ((0x0007FC00&(data))>>10)
+#define TVE_COMP_VSYNC_HPOS_get_possyncst(data)                                      ((0x0007FC00&(data))>>10)
+#define TVE_COMP_VSYNC_HPOS_write_en1_shift                                          (9)
+#define TVE_COMP_VSYNC_HPOS_write_en1_mask                                           (0x00000200)
+#define TVE_COMP_VSYNC_HPOS_write_en1(data)                                          (0x00000200&((data)<<9))
+#define TVE_COMP_VSYNC_HPOS_write_en1_src(data)                                      ((0x00000200&(data))>>9)
+#define TVE_COMP_VSYNC_HPOS_get_write_en1(data)                                      ((0x00000200&(data))>>9)
+#define TVE_COMP_VSYNC_HPOS_syncend_shift                                            (0)
+#define TVE_COMP_VSYNC_HPOS_syncend_mask                                             (0x000001FF)
+#define TVE_COMP_VSYNC_HPOS_syncend(data)                                            (0x000001FF&((data)<<0))
+#define TVE_COMP_VSYNC_HPOS_syncend_src(data)                                        ((0x000001FF&(data))>>0)
+#define TVE_COMP_VSYNC_HPOS_get_syncend(data)                                        ((0x000001FF&(data))>>0)
+
+
+#define TVE_COMP_SER_CTRL                                                            0x18018084
+#define TVE_COMP_SER_CTRL_reg_addr                                                   "0xB8018084"
+#define TVE_COMP_SER_CTRL_reg                                                        0xB8018084
+#define set_TVE_COMP_SER_CTRL_reg(data)   (*((volatile unsigned int*) TVE_COMP_SER_CTRL_reg)=data)
+#define get_TVE_COMP_SER_CTRL_reg   (*((volatile unsigned int*) TVE_COMP_SER_CTRL_reg))
+#define TVE_COMP_SER_CTRL_inst_adr                                                   "0x0021"
+#define TVE_COMP_SER_CTRL_inst                                                       0x0021
+#define TVE_COMP_SER_CTRL_1080i_ebl_shift                                            (0)
+#define TVE_COMP_SER_CTRL_1080i_ebl_mask                                             (0x00000001)
+#define TVE_COMP_SER_CTRL_1080i_ebl(data)                                            (0x00000001&((data)<<0))
+#define TVE_COMP_SER_CTRL_1080i_ebl_src(data)                                        ((0x00000001&(data))>>0)
+#define TVE_COMP_SER_CTRL_get_1080i_ebl(data)                                        ((0x00000001&(data))>>0)
+
+
+#define TVE_COMP_SER_HPOS                                                            0x18018088
+#define TVE_COMP_SER_HPOS_reg_addr                                                   "0xB8018088"
+#define TVE_COMP_SER_HPOS_reg                                                        0xB8018088
+#define set_TVE_COMP_SER_HPOS_reg(data)   (*((volatile unsigned int*) TVE_COMP_SER_HPOS_reg)=data)
+#define get_TVE_COMP_SER_HPOS_reg   (*((volatile unsigned int*) TVE_COMP_SER_HPOS_reg))
+#define TVE_COMP_SER_HPOS_inst_adr                                                   "0x0022"
+#define TVE_COMP_SER_HPOS_inst                                                       0x0022
+#define TVE_COMP_SER_HPOS_write_en2_shift                                            (27)
+#define TVE_COMP_SER_HPOS_write_en2_mask                                             (0x08000000)
+#define TVE_COMP_SER_HPOS_write_en2(data)                                            (0x08000000&((data)<<27))
+#define TVE_COMP_SER_HPOS_write_en2_src(data)                                        ((0x08000000&(data))>>27)
+#define TVE_COMP_SER_HPOS_get_write_en2(data)                                        ((0x08000000&(data))>>27)
+#define TVE_COMP_SER_HPOS_ser_hstart_shift                                           (14)
+#define TVE_COMP_SER_HPOS_ser_hstart_mask                                            (0x07FFC000)
+#define TVE_COMP_SER_HPOS_ser_hstart(data)                                           (0x07FFC000&((data)<<14))
+#define TVE_COMP_SER_HPOS_ser_hstart_src(data)                                       ((0x07FFC000&(data))>>14)
+#define TVE_COMP_SER_HPOS_get_ser_hstart(data)                                       ((0x07FFC000&(data))>>14)
+#define TVE_COMP_SER_HPOS_write_en1_shift                                            (13)
+#define TVE_COMP_SER_HPOS_write_en1_mask                                             (0x00002000)
+#define TVE_COMP_SER_HPOS_write_en1(data)                                            (0x00002000&((data)<<13))
+#define TVE_COMP_SER_HPOS_write_en1_src(data)                                        ((0x00002000&(data))>>13)
+#define TVE_COMP_SER_HPOS_get_write_en1(data)                                        ((0x00002000&(data))>>13)
+#define TVE_COMP_SER_HPOS_ser_hend_shift                                             (0)
+#define TVE_COMP_SER_HPOS_ser_hend_mask                                              (0x00001FFF)
+#define TVE_COMP_SER_HPOS_ser_hend(data)                                             (0x00001FFF&((data)<<0))
+#define TVE_COMP_SER_HPOS_ser_hend_src(data)                                         ((0x00001FFF&(data))>>0)
+#define TVE_COMP_SER_HPOS_get_ser_hend(data)                                         ((0x00001FFF&(data))>>0)
+
+
+#define TVE_COMP_SER_VPOS                                                            0x1801808c
+#define TVE_COMP_SER_VPOS_reg_addr                                                   "0xB801808C"
+#define TVE_COMP_SER_VPOS_reg                                                        0xB801808C
+#define set_TVE_COMP_SER_VPOS_reg(data)   (*((volatile unsigned int*) TVE_COMP_SER_VPOS_reg)=data)
+#define get_TVE_COMP_SER_VPOS_reg   (*((volatile unsigned int*) TVE_COMP_SER_VPOS_reg))
+#define TVE_COMP_SER_VPOS_inst_adr                                                   "0x0023"
+#define TVE_COMP_SER_VPOS_inst                                                       0x0023
+#define TVE_COMP_SER_VPOS_write_en2_shift                                            (11)
+#define TVE_COMP_SER_VPOS_write_en2_mask                                             (0x00000800)
+#define TVE_COMP_SER_VPOS_write_en2(data)                                            (0x00000800&((data)<<11))
+#define TVE_COMP_SER_VPOS_write_en2_src(data)                                        ((0x00000800&(data))>>11)
+#define TVE_COMP_SER_VPOS_get_write_en2(data)                                        ((0x00000800&(data))>>11)
+#define TVE_COMP_SER_VPOS_ser_vstart_shift                                           (6)
+#define TVE_COMP_SER_VPOS_ser_vstart_mask                                            (0x000007C0)
+#define TVE_COMP_SER_VPOS_ser_vstart(data)                                           (0x000007C0&((data)<<6))
+#define TVE_COMP_SER_VPOS_ser_vstart_src(data)                                       ((0x000007C0&(data))>>6)
+#define TVE_COMP_SER_VPOS_get_ser_vstart(data)                                       ((0x000007C0&(data))>>6)
+#define TVE_COMP_SER_VPOS_write_en1_shift                                            (5)
+#define TVE_COMP_SER_VPOS_write_en1_mask                                             (0x00000020)
+#define TVE_COMP_SER_VPOS_write_en1(data)                                            (0x00000020&((data)<<5))
+#define TVE_COMP_SER_VPOS_write_en1_src(data)                                        ((0x00000020&(data))>>5)
+#define TVE_COMP_SER_VPOS_get_write_en1(data)                                        ((0x00000020&(data))>>5)
+#define TVE_COMP_SER_VPOS_ser_vend_shift                                             (0)
+#define TVE_COMP_SER_VPOS_ser_vend_mask                                              (0x0000001F)
+#define TVE_COMP_SER_VPOS_ser_vend(data)                                             (0x0000001F&((data)<<0))
+#define TVE_COMP_SER_VPOS_ser_vend_src(data)                                         ((0x0000001F&(data))>>0)
+#define TVE_COMP_SER_VPOS_get_ser_vend(data)                                         ((0x0000001F&(data))>>0)
+
+
+#define TVE_COMP_DSYNC_VPOS                                                          0x18018090
+#define TVE_COMP_DSYNC_VPOS_reg_addr                                                 "0xB8018090"
+#define TVE_COMP_DSYNC_VPOS_reg                                                      0xB8018090
+#define set_TVE_COMP_DSYNC_VPOS_reg(data)   (*((volatile unsigned int*) TVE_COMP_DSYNC_VPOS_reg)=data)
+#define get_TVE_COMP_DSYNC_VPOS_reg   (*((volatile unsigned int*) TVE_COMP_DSYNC_VPOS_reg))
+#define TVE_COMP_DSYNC_VPOS_inst_adr                                                 "0x0024"
+#define TVE_COMP_DSYNC_VPOS_inst                                                     0x0024
+#define TVE_COMP_DSYNC_VPOS_write_en4_shift                                          (31)
+#define TVE_COMP_DSYNC_VPOS_write_en4_mask                                           (0x80000000)
+#define TVE_COMP_DSYNC_VPOS_write_en4(data)                                          (0x80000000&((data)<<31))
+#define TVE_COMP_DSYNC_VPOS_write_en4_src(data)                                      ((0x80000000&(data))>>31)
+#define TVE_COMP_DSYNC_VPOS_get_write_en4(data)                                      ((0x80000000&(data))>>31)
+#define TVE_COMP_DSYNC_VPOS_dsync_b_vstart_shift                                     (21)
+#define TVE_COMP_DSYNC_VPOS_dsync_b_vstart_mask                                      (0x7FE00000)
+#define TVE_COMP_DSYNC_VPOS_dsync_b_vstart(data)                                     (0x7FE00000&((data)<<21))
+#define TVE_COMP_DSYNC_VPOS_dsync_b_vstart_src(data)                                 ((0x7FE00000&(data))>>21)
+#define TVE_COMP_DSYNC_VPOS_get_dsync_b_vstart(data)                                 ((0x7FE00000&(data))>>21)
+#define TVE_COMP_DSYNC_VPOS_write_en3_shift                                          (20)
+#define TVE_COMP_DSYNC_VPOS_write_en3_mask                                           (0x00100000)
+#define TVE_COMP_DSYNC_VPOS_write_en3(data)                                          (0x00100000&((data)<<20))
+#define TVE_COMP_DSYNC_VPOS_write_en3_src(data)                                      ((0x00100000&(data))>>20)
+#define TVE_COMP_DSYNC_VPOS_get_write_en3(data)                                      ((0x00100000&(data))>>20)
+#define TVE_COMP_DSYNC_VPOS_dsync_b_vend_shift                                       (10)
+#define TVE_COMP_DSYNC_VPOS_dsync_b_vend_mask                                        (0x000FFC00)
+#define TVE_COMP_DSYNC_VPOS_dsync_b_vend(data)                                       (0x000FFC00&((data)<<10))
+#define TVE_COMP_DSYNC_VPOS_dsync_b_vend_src(data)                                   ((0x000FFC00&(data))>>10)
+#define TVE_COMP_DSYNC_VPOS_get_dsync_b_vend(data)                                   ((0x000FFC00&(data))>>10)
+#define TVE_COMP_DSYNC_VPOS_write_en2_shift                                          (9)
+#define TVE_COMP_DSYNC_VPOS_write_en2_mask                                           (0x00000200)
+#define TVE_COMP_DSYNC_VPOS_write_en2(data)                                          (0x00000200&((data)<<9))
+#define TVE_COMP_DSYNC_VPOS_write_en2_src(data)                                      ((0x00000200&(data))>>9)
+#define TVE_COMP_DSYNC_VPOS_get_write_en2(data)                                      ((0x00000200&(data))>>9)
+#define TVE_COMP_DSYNC_VPOS_dsync_t_vstart_shift                                     (5)
+#define TVE_COMP_DSYNC_VPOS_dsync_t_vstart_mask                                      (0x000001E0)
+#define TVE_COMP_DSYNC_VPOS_dsync_t_vstart(data)                                     (0x000001E0&((data)<<5))
+#define TVE_COMP_DSYNC_VPOS_dsync_t_vstart_src(data)                                 ((0x000001E0&(data))>>5)
+#define TVE_COMP_DSYNC_VPOS_get_dsync_t_vstart(data)                                 ((0x000001E0&(data))>>5)
+#define TVE_COMP_DSYNC_VPOS_write_en1_shift                                          (4)
+#define TVE_COMP_DSYNC_VPOS_write_en1_mask                                           (0x00000010)
+#define TVE_COMP_DSYNC_VPOS_write_en1(data)                                          (0x00000010&((data)<<4))
+#define TVE_COMP_DSYNC_VPOS_write_en1_src(data)                                      ((0x00000010&(data))>>4)
+#define TVE_COMP_DSYNC_VPOS_get_write_en1(data)                                      ((0x00000010&(data))>>4)
+#define TVE_COMP_DSYNC_VPOS_dsync_t_vend_shift                                       (0)
+#define TVE_COMP_DSYNC_VPOS_dsync_t_vend_mask                                        (0x0000000F)
+#define TVE_COMP_DSYNC_VPOS_dsync_t_vend(data)                                       (0x0000000F&((data)<<0))
+#define TVE_COMP_DSYNC_VPOS_dsync_t_vend_src(data)                                   ((0x0000000F&(data))>>0)
+#define TVE_COMP_DSYNC_VPOS_get_dsync_t_vend(data)                                   ((0x0000000F&(data))>>0)
+
+
+#define TVE_VGA_HSYNC_HPOS                                                           0x18018094
+#define TVE_VGA_HSYNC_HPOS_reg_addr                                                  "0xB8018094"
+#define TVE_VGA_HSYNC_HPOS_reg                                                       0xB8018094
+#define set_TVE_VGA_HSYNC_HPOS_reg(data)   (*((volatile unsigned int*) TVE_VGA_HSYNC_HPOS_reg)=data)
+#define get_TVE_VGA_HSYNC_HPOS_reg   (*((volatile unsigned int*) TVE_VGA_HSYNC_HPOS_reg))
+#define TVE_VGA_HSYNC_HPOS_inst_adr                                                  "0x0025"
+#define TVE_VGA_HSYNC_HPOS_inst                                                      0x0025
+#define TVE_VGA_HSYNC_HPOS_write_en2_shift                                           (27)
+#define TVE_VGA_HSYNC_HPOS_write_en2_mask                                            (0x08000000)
+#define TVE_VGA_HSYNC_HPOS_write_en2(data)                                           (0x08000000&((data)<<27))
+#define TVE_VGA_HSYNC_HPOS_write_en2_src(data)                                       ((0x08000000&(data))>>27)
+#define TVE_VGA_HSYNC_HPOS_get_write_en2(data)                                       ((0x08000000&(data))>>27)
+#define TVE_VGA_HSYNC_HPOS_hs_start_shift                                            (14)
+#define TVE_VGA_HSYNC_HPOS_hs_start_mask                                             (0x07FFC000)
+#define TVE_VGA_HSYNC_HPOS_hs_start(data)                                            (0x07FFC000&((data)<<14))
+#define TVE_VGA_HSYNC_HPOS_hs_start_src(data)                                        ((0x07FFC000&(data))>>14)
+#define TVE_VGA_HSYNC_HPOS_get_hs_start(data)                                        ((0x07FFC000&(data))>>14)
+#define TVE_VGA_HSYNC_HPOS_write_en1_shift                                           (13)
+#define TVE_VGA_HSYNC_HPOS_write_en1_mask                                            (0x00002000)
+#define TVE_VGA_HSYNC_HPOS_write_en1(data)                                           (0x00002000&((data)<<13))
+#define TVE_VGA_HSYNC_HPOS_write_en1_src(data)                                       ((0x00002000&(data))>>13)
+#define TVE_VGA_HSYNC_HPOS_get_write_en1(data)                                       ((0x00002000&(data))>>13)
+#define TVE_VGA_HSYNC_HPOS_hs_end_shift                                              (0)
+#define TVE_VGA_HSYNC_HPOS_hs_end_mask                                               (0x00001FFF)
+#define TVE_VGA_HSYNC_HPOS_hs_end(data)                                              (0x00001FFF&((data)<<0))
+#define TVE_VGA_HSYNC_HPOS_hs_end_src(data)                                          ((0x00001FFF&(data))>>0)
+#define TVE_VGA_HSYNC_HPOS_get_hs_end(data)                                          ((0x00001FFF&(data))>>0)
+
+
+#define TVE_VGA_VSYNC_ST_POS_0                                                       0x18018098
+#define TVE_VGA_VSYNC_ST_POS_1                                                       0x1801809C
+#define TVE_VGA_VSYNC_ST_POS_0_reg_addr                                              "0xB8018098"
+#define TVE_VGA_VSYNC_ST_POS_1_reg_addr                                              "0xB801809C"
+#define TVE_VGA_VSYNC_ST_POS_0_reg                                                   0xB8018098
+#define TVE_VGA_VSYNC_ST_POS_1_reg                                                   0xB801809C
+#define set_TVE_VGA_VSYNC_ST_POS_0_reg(data)   (*((volatile unsigned int*) TVE_VGA_VSYNC_ST_POS_0_reg)=data)
+#define set_TVE_VGA_VSYNC_ST_POS_1_reg(data)   (*((volatile unsigned int*) TVE_VGA_VSYNC_ST_POS_1_reg)=data)
+#define get_TVE_VGA_VSYNC_ST_POS_0_reg   (*((volatile unsigned int*) TVE_VGA_VSYNC_ST_POS_0_reg))
+#define get_TVE_VGA_VSYNC_ST_POS_1_reg   (*((volatile unsigned int*) TVE_VGA_VSYNC_ST_POS_1_reg))
+#define TVE_VGA_VSYNC_ST_POS_0_inst_adr                                              "0x0026"
+#define TVE_VGA_VSYNC_ST_POS_1_inst_adr                                              "0x0027"
+#define TVE_VGA_VSYNC_ST_POS_0_inst                                                  0x0026
+#define TVE_VGA_VSYNC_ST_POS_1_inst                                                  0x0027
+#define TVE_VGA_VSYNC_ST_POS_write_en2_shift                                         (25)
+#define TVE_VGA_VSYNC_ST_POS_write_en2_mask                                          (0x02000000)
+#define TVE_VGA_VSYNC_ST_POS_write_en2(data)                                         (0x02000000&((data)<<25))
+#define TVE_VGA_VSYNC_ST_POS_write_en2_src(data)                                     ((0x02000000&(data))>>25)
+#define TVE_VGA_VSYNC_ST_POS_get_write_en2(data)                                     ((0x02000000&(data))>>25)
+#define TVE_VGA_VSYNC_ST_POS_vs_st_posv_shift                                        (14)
+#define TVE_VGA_VSYNC_ST_POS_vs_st_posv_mask                                         (0x01FFC000)
+#define TVE_VGA_VSYNC_ST_POS_vs_st_posv(data)                                        (0x01FFC000&((data)<<14))
+#define TVE_VGA_VSYNC_ST_POS_vs_st_posv_src(data)                                    ((0x01FFC000&(data))>>14)
+#define TVE_VGA_VSYNC_ST_POS_get_vs_st_posv(data)                                    ((0x01FFC000&(data))>>14)
+#define TVE_VGA_VSYNC_ST_POS_write_en1_shift                                         (13)
+#define TVE_VGA_VSYNC_ST_POS_write_en1_mask                                          (0x00002000)
+#define TVE_VGA_VSYNC_ST_POS_write_en1(data)                                         (0x00002000&((data)<<13))
+#define TVE_VGA_VSYNC_ST_POS_write_en1_src(data)                                     ((0x00002000&(data))>>13)
+#define TVE_VGA_VSYNC_ST_POS_get_write_en1(data)                                     ((0x00002000&(data))>>13)
+#define TVE_VGA_VSYNC_ST_POS_vs_st_posh_shift                                        (0)
+#define TVE_VGA_VSYNC_ST_POS_vs_st_posh_mask                                         (0x00001FFF)
+#define TVE_VGA_VSYNC_ST_POS_vs_st_posh(data)                                        (0x00001FFF&((data)<<0))
+#define TVE_VGA_VSYNC_ST_POS_vs_st_posh_src(data)                                    ((0x00001FFF&(data))>>0)
+#define TVE_VGA_VSYNC_ST_POS_get_vs_st_posh(data)                                    ((0x00001FFF&(data))>>0)
+
+
+#define TVE_VGA_VSYNC_END_POS_0                                                      0x180180A0
+#define TVE_VGA_VSYNC_END_POS_1                                                      0x180180A4
+#define TVE_VGA_VSYNC_END_POS_0_reg_addr                                             "0xB80180A0"
+#define TVE_VGA_VSYNC_END_POS_1_reg_addr                                             "0xB80180A4"
+#define TVE_VGA_VSYNC_END_POS_0_reg                                                  0xB80180A0
+#define TVE_VGA_VSYNC_END_POS_1_reg                                                  0xB80180A4
+#define set_TVE_VGA_VSYNC_END_POS_0_reg(data)   (*((volatile unsigned int*) TVE_VGA_VSYNC_END_POS_0_reg)=data)
+#define set_TVE_VGA_VSYNC_END_POS_1_reg(data)   (*((volatile unsigned int*) TVE_VGA_VSYNC_END_POS_1_reg)=data)
+#define get_TVE_VGA_VSYNC_END_POS_0_reg   (*((volatile unsigned int*) TVE_VGA_VSYNC_END_POS_0_reg))
+#define get_TVE_VGA_VSYNC_END_POS_1_reg   (*((volatile unsigned int*) TVE_VGA_VSYNC_END_POS_1_reg))
+#define TVE_VGA_VSYNC_END_POS_0_inst_adr                                             "0x0028"
+#define TVE_VGA_VSYNC_END_POS_1_inst_adr                                             "0x0029"
+#define TVE_VGA_VSYNC_END_POS_0_inst                                                 0x0028
+#define TVE_VGA_VSYNC_END_POS_1_inst                                                 0x0029
+#define TVE_VGA_VSYNC_END_POS_write_en2_shift                                        (25)
+#define TVE_VGA_VSYNC_END_POS_write_en2_mask                                         (0x02000000)
+#define TVE_VGA_VSYNC_END_POS_write_en2(data)                                        (0x02000000&((data)<<25))
+#define TVE_VGA_VSYNC_END_POS_write_en2_src(data)                                    ((0x02000000&(data))>>25)
+#define TVE_VGA_VSYNC_END_POS_get_write_en2(data)                                    ((0x02000000&(data))>>25)
+#define TVE_VGA_VSYNC_END_POS_vs_end_posv_shift                                      (14)
+#define TVE_VGA_VSYNC_END_POS_vs_end_posv_mask                                       (0x01FFC000)
+#define TVE_VGA_VSYNC_END_POS_vs_end_posv(data)                                      (0x01FFC000&((data)<<14))
+#define TVE_VGA_VSYNC_END_POS_vs_end_posv_src(data)                                  ((0x01FFC000&(data))>>14)
+#define TVE_VGA_VSYNC_END_POS_get_vs_end_posv(data)                                  ((0x01FFC000&(data))>>14)
+#define TVE_VGA_VSYNC_END_POS_write_en1_shift                                        (13)
+#define TVE_VGA_VSYNC_END_POS_write_en1_mask                                         (0x00002000)
+#define TVE_VGA_VSYNC_END_POS_write_en1(data)                                        (0x00002000&((data)<<13))
+#define TVE_VGA_VSYNC_END_POS_write_en1_src(data)                                    ((0x00002000&(data))>>13)
+#define TVE_VGA_VSYNC_END_POS_get_write_en1(data)                                    ((0x00002000&(data))>>13)
+#define TVE_VGA_VSYNC_END_POS_vs_end_posh_shift                                      (0)
+#define TVE_VGA_VSYNC_END_POS_vs_end_posh_mask                                       (0x00001FFF)
+#define TVE_VGA_VSYNC_END_POS_vs_end_posh(data)                                      (0x00001FFF&((data)<<0))
+#define TVE_VGA_VSYNC_END_POS_vs_end_posh_src(data)                                  ((0x00001FFF&(data))>>0)
+#define TVE_VGA_VSYNC_END_POS_get_vs_end_posh(data)                                  ((0x00001FFF&(data))>>0)
+
+
+#define TVE_IP_VSYNCPOS                                                              0x180180b0
+#define TVE_IP_VSYNCPOS_reg_addr                                                     "0xB80180B0"
+#define TVE_IP_VSYNCPOS_reg                                                          0xB80180B0
+#define set_TVE_IP_VSYNCPOS_reg(data)   (*((volatile unsigned int*) TVE_IP_VSYNCPOS_reg)=data)
+#define get_TVE_IP_VSYNCPOS_reg   (*((volatile unsigned int*) TVE_IP_VSYNCPOS_reg))
+#define TVE_IP_VSYNCPOS_inst_adr                                                     "0x002C"
+#define TVE_IP_VSYNCPOS_inst                                                         0x002C
+#define TVE_IP_VSYNCPOS_write_en2_shift                                              (21)
+#define TVE_IP_VSYNCPOS_write_en2_mask                                               (0x00200000)
+#define TVE_IP_VSYNCPOS_write_en2(data)                                              (0x00200000&((data)<<21))
+#define TVE_IP_VSYNCPOS_write_en2_src(data)                                          ((0x00200000&(data))>>21)
+#define TVE_IP_VSYNCPOS_get_write_en2(data)                                          ((0x00200000&(data))>>21)
+#define TVE_IP_VSYNCPOS_ip_vsync_pos1_shift                                          (11)
+#define TVE_IP_VSYNCPOS_ip_vsync_pos1_mask                                           (0x001FF800)
+#define TVE_IP_VSYNCPOS_ip_vsync_pos1(data)                                          (0x001FF800&((data)<<11))
+#define TVE_IP_VSYNCPOS_ip_vsync_pos1_src(data)                                      ((0x001FF800&(data))>>11)
+#define TVE_IP_VSYNCPOS_get_ip_vsync_pos1(data)                                      ((0x001FF800&(data))>>11)
+#define TVE_IP_VSYNCPOS_write_en1_shift                                              (10)
+#define TVE_IP_VSYNCPOS_write_en1_mask                                               (0x00000400)
+#define TVE_IP_VSYNCPOS_write_en1(data)                                              (0x00000400&((data)<<10))
+#define TVE_IP_VSYNCPOS_write_en1_src(data)                                          ((0x00000400&(data))>>10)
+#define TVE_IP_VSYNCPOS_get_write_en1(data)                                          ((0x00000400&(data))>>10)
+#define TVE_IP_VSYNCPOS_ip_vsync_pos2_shift                                          (0)
+#define TVE_IP_VSYNCPOS_ip_vsync_pos2_mask                                           (0x000003FF)
+#define TVE_IP_VSYNCPOS_ip_vsync_pos2(data)                                          (0x000003FF&((data)<<0))
+#define TVE_IP_VSYNCPOS_ip_vsync_pos2_src(data)                                      ((0x000003FF&(data))>>0)
+#define TVE_IP_VSYNCPOS_get_ip_vsync_pos2(data)                                      ((0x000003FF&(data))>>0)
+
+
+#define TVE_IP_HSYNCPOS                                                              0x180180b4
+#define TVE_IP_HSYNCPOS_reg_addr                                                     "0xB80180B4"
+#define TVE_IP_HSYNCPOS_reg                                                          0xB80180B4
+#define set_TVE_IP_HSYNCPOS_reg(data)   (*((volatile unsigned int*) TVE_IP_HSYNCPOS_reg)=data)
+#define get_TVE_IP_HSYNCPOS_reg   (*((volatile unsigned int*) TVE_IP_HSYNCPOS_reg))
+#define TVE_IP_HSYNCPOS_inst_adr                                                     "0x002D"
+#define TVE_IP_HSYNCPOS_inst                                                         0x002D
+#define TVE_IP_HSYNCPOS_hthr_shift                                                   (0)
+#define TVE_IP_HSYNCPOS_hthr_mask                                                    (0x000007FF)
+#define TVE_IP_HSYNCPOS_hthr(data)                                                   (0x000007FF&((data)<<0))
+#define TVE_IP_HSYNCPOS_hthr_src(data)                                               ((0x000007FF&(data))>>0)
+#define TVE_IP_HSYNCPOS_get_hthr(data)                                               ((0x000007FF&(data))>>0)
+
+
+#define TVE_HDMI_ST                                                                  0x180180b8
+#define TVE_HDMI_ST_reg_addr                                                         "0xB80180B8"
+#define TVE_HDMI_ST_reg                                                              0xB80180B8
+#define set_TVE_HDMI_ST_reg(data)   (*((volatile unsigned int*) TVE_HDMI_ST_reg)=data)
+#define get_TVE_HDMI_ST_reg   (*((volatile unsigned int*) TVE_HDMI_ST_reg))
+#define TVE_HDMI_ST_inst_adr                                                         "0x002E"
+#define TVE_HDMI_ST_inst                                                             0x002E
+#define TVE_HDMI_ST_write_en4_shift                                                  (29)
+#define TVE_HDMI_ST_write_en4_mask                                                   (0x20000000)
+#define TVE_HDMI_ST_write_en4(data)                                                  (0x20000000&((data)<<29))
+#define TVE_HDMI_ST_write_en4_src(data)                                              ((0x20000000&(data))>>29)
+#define TVE_HDMI_ST_get_write_en4(data)                                              ((0x20000000&(data))>>29)
+#define TVE_HDMI_ST_sync_en_shift                                                    (28)
+#define TVE_HDMI_ST_sync_en_mask                                                     (0x10000000)
+#define TVE_HDMI_ST_sync_en(data)                                                    (0x10000000&((data)<<28))
+#define TVE_HDMI_ST_sync_en_src(data)                                                ((0x10000000&(data))>>28)
+#define TVE_HDMI_ST_get_sync_en(data)                                                ((0x10000000&(data))>>28)
+#define TVE_HDMI_ST_write_en3_shift                                                  (27)
+#define TVE_HDMI_ST_write_en3_mask                                                   (0x08000000)
+#define TVE_HDMI_ST_write_en3(data)                                                  (0x08000000&((data)<<27))
+#define TVE_HDMI_ST_write_en3_src(data)                                              ((0x08000000&(data))>>27)
+#define TVE_HDMI_ST_get_write_en3(data)                                              ((0x08000000&(data))>>27)
+#define TVE_HDMI_ST_ch_sel_shift                                                     (26)
+#define TVE_HDMI_ST_ch_sel_mask                                                      (0x04000000)
+#define TVE_HDMI_ST_ch_sel(data)                                                     (0x04000000&((data)<<26))
+#define TVE_HDMI_ST_ch_sel_src(data)                                                 ((0x04000000&(data))>>26)
+#define TVE_HDMI_ST_get_ch_sel(data)                                                 ((0x04000000&(data))>>26)
+#define TVE_HDMI_ST_write_en2_shift                                                  (25)
+#define TVE_HDMI_ST_write_en2_mask                                                   (0x02000000)
+#define TVE_HDMI_ST_write_en2(data)                                                  (0x02000000&((data)<<25))
+#define TVE_HDMI_ST_write_en2_src(data)                                              ((0x02000000&(data))>>25)
+#define TVE_HDMI_ST_get_write_en2(data)                                              ((0x02000000&(data))>>25)
+#define TVE_HDMI_ST_vpos_shift                                                       (14)
+#define TVE_HDMI_ST_vpos_mask                                                        (0x01FFC000)
+#define TVE_HDMI_ST_vpos(data)                                                       (0x01FFC000&((data)<<14))
+#define TVE_HDMI_ST_vpos_src(data)                                                   ((0x01FFC000&(data))>>14)
+#define TVE_HDMI_ST_get_vpos(data)                                                   ((0x01FFC000&(data))>>14)
+#define TVE_HDMI_ST_write_en1_shift                                                  (13)
+#define TVE_HDMI_ST_write_en1_mask                                                   (0x00002000)
+#define TVE_HDMI_ST_write_en1(data)                                                  (0x00002000&((data)<<13))
+#define TVE_HDMI_ST_write_en1_src(data)                                              ((0x00002000&(data))>>13)
+#define TVE_HDMI_ST_get_write_en1(data)                                              ((0x00002000&(data))>>13)
+#define TVE_HDMI_ST_hpos_shift                                                       (0)
+#define TVE_HDMI_ST_hpos_mask                                                        (0x00001FFF)
+#define TVE_HDMI_ST_hpos(data)                                                       (0x00001FFF&((data)<<0))
+#define TVE_HDMI_ST_hpos_src(data)                                                   ((0x00001FFF&(data))>>0)
+#define TVE_HDMI_ST_get_hpos(data)                                                   ((0x00001FFF&(data))>>0)
+
+
+#define TVE_HDMI_DISP_HS                                                             0x180180bc
+#define TVE_HDMI_DISP_HS_reg_addr                                                    "0xB80180BC"
+#define TVE_HDMI_DISP_HS_reg                                                         0xB80180BC
+#define set_TVE_HDMI_DISP_HS_reg(data)   (*((volatile unsigned int*) TVE_HDMI_DISP_HS_reg)=data)
+#define get_TVE_HDMI_DISP_HS_reg   (*((volatile unsigned int*) TVE_HDMI_DISP_HS_reg))
+#define TVE_HDMI_DISP_HS_inst_adr                                                    "0x002F"
+#define TVE_HDMI_DISP_HS_inst                                                        0x002F
+#define TVE_HDMI_DISP_HS_write_en2_shift                                             (27)
+#define TVE_HDMI_DISP_HS_write_en2_mask                                              (0x08000000)
+#define TVE_HDMI_DISP_HS_write_en2(data)                                             (0x08000000&((data)<<27))
+#define TVE_HDMI_DISP_HS_write_en2_src(data)                                         ((0x08000000&(data))>>27)
+#define TVE_HDMI_DISP_HS_get_write_en2(data)                                         ((0x08000000&(data))>>27)
+#define TVE_HDMI_DISP_HS_hs_start_shift                                              (14)
+#define TVE_HDMI_DISP_HS_hs_start_mask                                               (0x07FFC000)
+#define TVE_HDMI_DISP_HS_hs_start(data)                                              (0x07FFC000&((data)<<14))
+#define TVE_HDMI_DISP_HS_hs_start_src(data)                                          ((0x07FFC000&(data))>>14)
+#define TVE_HDMI_DISP_HS_get_hs_start(data)                                          ((0x07FFC000&(data))>>14)
+#define TVE_HDMI_DISP_HS_write_en1_shift                                             (13)
+#define TVE_HDMI_DISP_HS_write_en1_mask                                              (0x00002000)
+#define TVE_HDMI_DISP_HS_write_en1(data)                                             (0x00002000&((data)<<13))
+#define TVE_HDMI_DISP_HS_write_en1_src(data)                                         ((0x00002000&(data))>>13)
+#define TVE_HDMI_DISP_HS_get_write_en1(data)                                         ((0x00002000&(data))>>13)
+#define TVE_HDMI_DISP_HS_hs_end_shift                                                (0)
+#define TVE_HDMI_DISP_HS_hs_end_mask                                                 (0x00001FFF)
+#define TVE_HDMI_DISP_HS_hs_end(data)                                                (0x00001FFF&((data)<<0))
+#define TVE_HDMI_DISP_HS_hs_end_src(data)                                            ((0x00001FFF&(data))>>0)
+#define TVE_HDMI_DISP_HS_get_hs_end(data)                                            ((0x00001FFF&(data))>>0)
+
+
+#define TVE_HDMI_DISP_VSST1                                                          0x180180c0
+#define TVE_HDMI_DISP_VSST1_reg_addr                                                 "0xB80180C0"
+#define TVE_HDMI_DISP_VSST1_reg                                                      0xB80180C0
+#define set_TVE_HDMI_DISP_VSST1_reg(data)   (*((volatile unsigned int*) TVE_HDMI_DISP_VSST1_reg)=data)
+#define get_TVE_HDMI_DISP_VSST1_reg   (*((volatile unsigned int*) TVE_HDMI_DISP_VSST1_reg))
+#define TVE_HDMI_DISP_VSST1_inst_adr                                                 "0x0030"
+#define TVE_HDMI_DISP_VSST1_inst                                                     0x0030
+#define TVE_HDMI_DISP_VSST1_write_en2_shift                                          (25)
+#define TVE_HDMI_DISP_VSST1_write_en2_mask                                           (0x02000000)
+#define TVE_HDMI_DISP_VSST1_write_en2(data)                                          (0x02000000&((data)<<25))
+#define TVE_HDMI_DISP_VSST1_write_en2_src(data)                                      ((0x02000000&(data))>>25)
+#define TVE_HDMI_DISP_VSST1_get_write_en2(data)                                      ((0x02000000&(data))>>25)
+#define TVE_HDMI_DISP_VSST1_vs_st_pos1v_shift                                        (14)
+#define TVE_HDMI_DISP_VSST1_vs_st_pos1v_mask                                         (0x01FFC000)
+#define TVE_HDMI_DISP_VSST1_vs_st_pos1v(data)                                        (0x01FFC000&((data)<<14))
+#define TVE_HDMI_DISP_VSST1_vs_st_pos1v_src(data)                                    ((0x01FFC000&(data))>>14)
+#define TVE_HDMI_DISP_VSST1_get_vs_st_pos1v(data)                                    ((0x01FFC000&(data))>>14)
+#define TVE_HDMI_DISP_VSST1_write_en1_shift                                          (13)
+#define TVE_HDMI_DISP_VSST1_write_en1_mask                                           (0x00002000)
+#define TVE_HDMI_DISP_VSST1_write_en1(data)                                          (0x00002000&((data)<<13))
+#define TVE_HDMI_DISP_VSST1_write_en1_src(data)                                      ((0x00002000&(data))>>13)
+#define TVE_HDMI_DISP_VSST1_get_write_en1(data)                                      ((0x00002000&(data))>>13)
+#define TVE_HDMI_DISP_VSST1_vs_st_pos1h_shift                                        (0)
+#define TVE_HDMI_DISP_VSST1_vs_st_pos1h_mask                                         (0x00001FFF)
+#define TVE_HDMI_DISP_VSST1_vs_st_pos1h(data)                                        (0x00001FFF&((data)<<0))
+#define TVE_HDMI_DISP_VSST1_vs_st_pos1h_src(data)                                    ((0x00001FFF&(data))>>0)
+#define TVE_HDMI_DISP_VSST1_get_vs_st_pos1h(data)                                    ((0x00001FFF&(data))>>0)
+
+
+#define TVE_HDMI_DISP_VSED1                                                          0x180180c4
+#define TVE_HDMI_DISP_VSED1_reg_addr                                                 "0xB80180C4"
+#define TVE_HDMI_DISP_VSED1_reg                                                      0xB80180C4
+#define set_TVE_HDMI_DISP_VSED1_reg(data)   (*((volatile unsigned int*) TVE_HDMI_DISP_VSED1_reg)=data)
+#define get_TVE_HDMI_DISP_VSED1_reg   (*((volatile unsigned int*) TVE_HDMI_DISP_VSED1_reg))
+#define TVE_HDMI_DISP_VSED1_inst_adr                                                 "0x0031"
+#define TVE_HDMI_DISP_VSED1_inst                                                     0x0031
+#define TVE_HDMI_DISP_VSED1_write_en2_shift                                          (25)
+#define TVE_HDMI_DISP_VSED1_write_en2_mask                                           (0x02000000)
+#define TVE_HDMI_DISP_VSED1_write_en2(data)                                          (0x02000000&((data)<<25))
+#define TVE_HDMI_DISP_VSED1_write_en2_src(data)                                      ((0x02000000&(data))>>25)
+#define TVE_HDMI_DISP_VSED1_get_write_en2(data)                                      ((0x02000000&(data))>>25)
+#define TVE_HDMI_DISP_VSED1_vs_end_pos1v_shift                                       (14)
+#define TVE_HDMI_DISP_VSED1_vs_end_pos1v_mask                                        (0x01FFC000)
+#define TVE_HDMI_DISP_VSED1_vs_end_pos1v(data)                                       (0x01FFC000&((data)<<14))
+#define TVE_HDMI_DISP_VSED1_vs_end_pos1v_src(data)                                   ((0x01FFC000&(data))>>14)
+#define TVE_HDMI_DISP_VSED1_get_vs_end_pos1v(data)                                   ((0x01FFC000&(data))>>14)
+#define TVE_HDMI_DISP_VSED1_write_en1_shift                                          (13)
+#define TVE_HDMI_DISP_VSED1_write_en1_mask                                           (0x00002000)
+#define TVE_HDMI_DISP_VSED1_write_en1(data)                                          (0x00002000&((data)<<13))
+#define TVE_HDMI_DISP_VSED1_write_en1_src(data)                                      ((0x00002000&(data))>>13)
+#define TVE_HDMI_DISP_VSED1_get_write_en1(data)                                      ((0x00002000&(data))>>13)
+#define TVE_HDMI_DISP_VSED1_vs_end_pos1h_shift                                       (0)
+#define TVE_HDMI_DISP_VSED1_vs_end_pos1h_mask                                        (0x00001FFF)
+#define TVE_HDMI_DISP_VSED1_vs_end_pos1h(data)                                       (0x00001FFF&((data)<<0))
+#define TVE_HDMI_DISP_VSED1_vs_end_pos1h_src(data)                                   ((0x00001FFF&(data))>>0)
+#define TVE_HDMI_DISP_VSED1_get_vs_end_pos1h(data)                                   ((0x00001FFF&(data))>>0)
+
+
+#define TVE_HDMI_DISP_VSST2                                                          0x180180c8
+#define TVE_HDMI_DISP_VSST2_reg_addr                                                 "0xB80180C8"
+#define TVE_HDMI_DISP_VSST2_reg                                                      0xB80180C8
+#define set_TVE_HDMI_DISP_VSST2_reg(data)   (*((volatile unsigned int*) TVE_HDMI_DISP_VSST2_reg)=data)
+#define get_TVE_HDMI_DISP_VSST2_reg   (*((volatile unsigned int*) TVE_HDMI_DISP_VSST2_reg))
+#define TVE_HDMI_DISP_VSST2_inst_adr                                                 "0x0032"
+#define TVE_HDMI_DISP_VSST2_inst                                                     0x0032
+#define TVE_HDMI_DISP_VSST2_write_en2_shift                                          (25)
+#define TVE_HDMI_DISP_VSST2_write_en2_mask                                           (0x02000000)
+#define TVE_HDMI_DISP_VSST2_write_en2(data)                                          (0x02000000&((data)<<25))
+#define TVE_HDMI_DISP_VSST2_write_en2_src(data)                                      ((0x02000000&(data))>>25)
+#define TVE_HDMI_DISP_VSST2_get_write_en2(data)                                      ((0x02000000&(data))>>25)
+#define TVE_HDMI_DISP_VSST2_vs_st_pos2v_shift                                        (14)
+#define TVE_HDMI_DISP_VSST2_vs_st_pos2v_mask                                         (0x01FFC000)
+#define TVE_HDMI_DISP_VSST2_vs_st_pos2v(data)                                        (0x01FFC000&((data)<<14))
+#define TVE_HDMI_DISP_VSST2_vs_st_pos2v_src(data)                                    ((0x01FFC000&(data))>>14)
+#define TVE_HDMI_DISP_VSST2_get_vs_st_pos2v(data)                                    ((0x01FFC000&(data))>>14)
+#define TVE_HDMI_DISP_VSST2_write_en1_shift                                          (13)
+#define TVE_HDMI_DISP_VSST2_write_en1_mask                                           (0x00002000)
+#define TVE_HDMI_DISP_VSST2_write_en1(data)                                          (0x00002000&((data)<<13))
+#define TVE_HDMI_DISP_VSST2_write_en1_src(data)                                      ((0x00002000&(data))>>13)
+#define TVE_HDMI_DISP_VSST2_get_write_en1(data)                                      ((0x00002000&(data))>>13)
+#define TVE_HDMI_DISP_VSST2_vs_st_pos2h_shift                                        (0)
+#define TVE_HDMI_DISP_VSST2_vs_st_pos2h_mask                                         (0x00001FFF)
+#define TVE_HDMI_DISP_VSST2_vs_st_pos2h(data)                                        (0x00001FFF&((data)<<0))
+#define TVE_HDMI_DISP_VSST2_vs_st_pos2h_src(data)                                    ((0x00001FFF&(data))>>0)
+#define TVE_HDMI_DISP_VSST2_get_vs_st_pos2h(data)                                    ((0x00001FFF&(data))>>0)
+
+
+#define TVE_HDMI_DISP_VSED2                                                          0x180180cc
+#define TVE_HDMI_DISP_VSED2_reg_addr                                                 "0xB80180CC"
+#define TVE_HDMI_DISP_VSED2_reg                                                      0xB80180CC
+#define set_TVE_HDMI_DISP_VSED2_reg(data)   (*((volatile unsigned int*) TVE_HDMI_DISP_VSED2_reg)=data)
+#define get_TVE_HDMI_DISP_VSED2_reg   (*((volatile unsigned int*) TVE_HDMI_DISP_VSED2_reg))
+#define TVE_HDMI_DISP_VSED2_inst_adr                                                 "0x0033"
+#define TVE_HDMI_DISP_VSED2_inst                                                     0x0033
+#define TVE_HDMI_DISP_VSED2_write_en2_shift                                          (25)
+#define TVE_HDMI_DISP_VSED2_write_en2_mask                                           (0x02000000)
+#define TVE_HDMI_DISP_VSED2_write_en2(data)                                          (0x02000000&((data)<<25))
+#define TVE_HDMI_DISP_VSED2_write_en2_src(data)                                      ((0x02000000&(data))>>25)
+#define TVE_HDMI_DISP_VSED2_get_write_en2(data)                                      ((0x02000000&(data))>>25)
+#define TVE_HDMI_DISP_VSED2_vs_end_pos2v_shift                                       (14)
+#define TVE_HDMI_DISP_VSED2_vs_end_pos2v_mask                                        (0x01FFC000)
+#define TVE_HDMI_DISP_VSED2_vs_end_pos2v(data)                                       (0x01FFC000&((data)<<14))
+#define TVE_HDMI_DISP_VSED2_vs_end_pos2v_src(data)                                   ((0x01FFC000&(data))>>14)
+#define TVE_HDMI_DISP_VSED2_get_vs_end_pos2v(data)                                   ((0x01FFC000&(data))>>14)
+#define TVE_HDMI_DISP_VSED2_write_en1_shift                                          (13)
+#define TVE_HDMI_DISP_VSED2_write_en1_mask                                           (0x00002000)
+#define TVE_HDMI_DISP_VSED2_write_en1(data)                                          (0x00002000&((data)<<13))
+#define TVE_HDMI_DISP_VSED2_write_en1_src(data)                                      ((0x00002000&(data))>>13)
+#define TVE_HDMI_DISP_VSED2_get_write_en1(data)                                      ((0x00002000&(data))>>13)
+#define TVE_HDMI_DISP_VSED2_vs_end_pos2h_shift                                       (0)
+#define TVE_HDMI_DISP_VSED2_vs_end_pos2h_mask                                        (0x00001FFF)
+#define TVE_HDMI_DISP_VSED2_vs_end_pos2h(data)                                       (0x00001FFF&((data)<<0))
+#define TVE_HDMI_DISP_VSED2_vs_end_pos2h_src(data)                                   ((0x00001FFF&(data))>>0)
+#define TVE_HDMI_DISP_VSED2_get_vs_end_pos2h(data)                                   ((0x00001FFF&(data))>>0)
+
+
+#define TVE_HDMI_PXLACT                                                              0x180180d0
+#define TVE_HDMI_PXLACT_reg_addr                                                     "0xB80180D0"
+#define TVE_HDMI_PXLACT_reg                                                          0xB80180D0
+#define set_TVE_HDMI_PXLACT_reg(data)   (*((volatile unsigned int*) TVE_HDMI_PXLACT_reg)=data)
+#define get_TVE_HDMI_PXLACT_reg   (*((volatile unsigned int*) TVE_HDMI_PXLACT_reg))
+#define TVE_HDMI_PXLACT_inst_adr                                                     "0x0034"
+#define TVE_HDMI_PXLACT_inst                                                         0x0034
+#define TVE_HDMI_PXLACT_write_en2_shift                                              (27)
+#define TVE_HDMI_PXLACT_write_en2_mask                                               (0x08000000)
+#define TVE_HDMI_PXLACT_write_en2(data)                                              (0x08000000&((data)<<27))
+#define TVE_HDMI_PXLACT_write_en2_src(data)                                          ((0x08000000&(data))>>27)
+#define TVE_HDMI_PXLACT_get_write_en2(data)                                          ((0x08000000&(data))>>27)
+#define TVE_HDMI_PXLACT_hpos_end_shift                                               (14)
+#define TVE_HDMI_PXLACT_hpos_end_mask                                                (0x07FFC000)
+#define TVE_HDMI_PXLACT_hpos_end(data)                                               (0x07FFC000&((data)<<14))
+#define TVE_HDMI_PXLACT_hpos_end_src(data)                                           ((0x07FFC000&(data))>>14)
+#define TVE_HDMI_PXLACT_get_hpos_end(data)                                           ((0x07FFC000&(data))>>14)
+#define TVE_HDMI_PXLACT_write_en1_shift                                              (13)
+#define TVE_HDMI_PXLACT_write_en1_mask                                               (0x00002000)
+#define TVE_HDMI_PXLACT_write_en1(data)                                              (0x00002000&((data)<<13))
+#define TVE_HDMI_PXLACT_write_en1_src(data)                                          ((0x00002000&(data))>>13)
+#define TVE_HDMI_PXLACT_get_write_en1(data)                                          ((0x00002000&(data))>>13)
+#define TVE_HDMI_PXLACT_hpos_st_shift                                                (0)
+#define TVE_HDMI_PXLACT_hpos_st_mask                                                 (0x00001FFF)
+#define TVE_HDMI_PXLACT_hpos_st(data)                                                (0x00001FFF&((data)<<0))
+#define TVE_HDMI_PXLACT_hpos_st_src(data)                                            ((0x00001FFF&(data))>>0)
+#define TVE_HDMI_PXLACT_get_hpos_st(data)                                            ((0x00001FFF&(data))>>0)
+
+
+#define TVE_COMP_SYNCLVL                                                             0x180180e0
+#define TVE_COMP_SYNCLVL_reg_addr                                                    "0xB80180E0"
+#define TVE_COMP_SYNCLVL_reg                                                         0xB80180E0
+#define set_TVE_COMP_SYNCLVL_reg(data)   (*((volatile unsigned int*) TVE_COMP_SYNCLVL_reg)=data)
+#define get_TVE_COMP_SYNCLVL_reg   (*((volatile unsigned int*) TVE_COMP_SYNCLVL_reg))
+#define TVE_COMP_SYNCLVL_inst_adr                                                    "0x0038"
+#define TVE_COMP_SYNCLVL_inst                                                        0x0038
+#define TVE_COMP_SYNCLVL_write_en3_shift                                             (28)
+#define TVE_COMP_SYNCLVL_write_en3_mask                                              (0x10000000)
+#define TVE_COMP_SYNCLVL_write_en3(data)                                             (0x10000000&((data)<<28))
+#define TVE_COMP_SYNCLVL_write_en3_src(data)                                         ((0x10000000&(data))>>28)
+#define TVE_COMP_SYNCLVL_get_write_en3(data)                                         ((0x10000000&(data))>>28)
+#define TVE_COMP_SYNCLVL_slewrate_shift                                              (26)
+#define TVE_COMP_SYNCLVL_slewrate_mask                                               (0x0C000000)
+#define TVE_COMP_SYNCLVL_slewrate(data)                                              (0x0C000000&((data)<<26))
+#define TVE_COMP_SYNCLVL_slewrate_src(data)                                          ((0x0C000000&(data))>>26)
+#define TVE_COMP_SYNCLVL_get_slewrate(data)                                          ((0x0C000000&(data))>>26)
+#define TVE_COMP_SYNCLVL_write_en2_shift                                             (25)
+#define TVE_COMP_SYNCLVL_write_en2_mask                                              (0x02000000)
+#define TVE_COMP_SYNCLVL_write_en2(data)                                             (0x02000000&((data)<<25))
+#define TVE_COMP_SYNCLVL_write_en2_src(data)                                         ((0x02000000&(data))>>25)
+#define TVE_COMP_SYNCLVL_get_write_en2(data)                                         ((0x02000000&(data))>>25)
+#define TVE_COMP_SYNCLVL_y_negsynclvl_shift                                          (13)
+#define TVE_COMP_SYNCLVL_y_negsynclvl_mask                                           (0x01FFE000)
+#define TVE_COMP_SYNCLVL_y_negsynclvl(data)                                          (0x01FFE000&((data)<<13))
+#define TVE_COMP_SYNCLVL_y_negsynclvl_src(data)                                      ((0x01FFE000&(data))>>13)
+#define TVE_COMP_SYNCLVL_get_y_negsynclvl(data)                                      ((0x01FFE000&(data))>>13)
+#define TVE_COMP_SYNCLVL_write_en1_shift                                             (12)
+#define TVE_COMP_SYNCLVL_write_en1_mask                                              (0x00001000)
+#define TVE_COMP_SYNCLVL_write_en1(data)                                             (0x00001000&((data)<<12))
+#define TVE_COMP_SYNCLVL_write_en1_src(data)                                         ((0x00001000&(data))>>12)
+#define TVE_COMP_SYNCLVL_get_write_en1(data)                                         ((0x00001000&(data))>>12)
+#define TVE_COMP_SYNCLVL_y_possynclvl_shift                                          (0)
+#define TVE_COMP_SYNCLVL_y_possynclvl_mask                                           (0x00000FFF)
+#define TVE_COMP_SYNCLVL_y_possynclvl(data)                                          (0x00000FFF&((data)<<0))
+#define TVE_COMP_SYNCLVL_y_possynclvl_src(data)                                      ((0x00000FFF&(data))>>0)
+#define TVE_COMP_SYNCLVL_get_y_possynclvl(data)                                      ((0x00000FFF&(data))>>0)
+
+
+#define TVE_COMP_SYNC_SLEWLVL                                                        0x180180e4
+#define TVE_COMP_SYNC_SLEWLVL_reg_addr                                               "0xB80180E4"
+#define TVE_COMP_SYNC_SLEWLVL_reg                                                    0xB80180E4
+#define set_TVE_COMP_SYNC_SLEWLVL_reg(data)   (*((volatile unsigned int*) TVE_COMP_SYNC_SLEWLVL_reg)=data)
+#define get_TVE_COMP_SYNC_SLEWLVL_reg   (*((volatile unsigned int*) TVE_COMP_SYNC_SLEWLVL_reg))
+#define TVE_COMP_SYNC_SLEWLVL_inst_adr                                               "0x0039"
+#define TVE_COMP_SYNC_SLEWLVL_inst                                                   0x0039
+#define TVE_COMP_SYNC_SLEWLVL_write_en2_shift                                        (25)
+#define TVE_COMP_SYNC_SLEWLVL_write_en2_mask                                         (0x02000000)
+#define TVE_COMP_SYNC_SLEWLVL_write_en2(data)                                        (0x02000000&((data)<<25))
+#define TVE_COMP_SYNC_SLEWLVL_write_en2_src(data)                                    ((0x02000000&(data))>>25)
+#define TVE_COMP_SYNC_SLEWLVL_get_write_en2(data)                                    ((0x02000000&(data))>>25)
+#define TVE_COMP_SYNC_SLEWLVL_y_sync_h_shift                                         (13)
+#define TVE_COMP_SYNC_SLEWLVL_y_sync_h_mask                                          (0x01FFE000)
+#define TVE_COMP_SYNC_SLEWLVL_y_sync_h(data)                                         (0x01FFE000&((data)<<13))
+#define TVE_COMP_SYNC_SLEWLVL_y_sync_h_src(data)                                     ((0x01FFE000&(data))>>13)
+#define TVE_COMP_SYNC_SLEWLVL_get_y_sync_h(data)                                     ((0x01FFE000&(data))>>13)
+#define TVE_COMP_SYNC_SLEWLVL_write_en1_shift                                        (12)
+#define TVE_COMP_SYNC_SLEWLVL_write_en1_mask                                         (0x00001000)
+#define TVE_COMP_SYNC_SLEWLVL_write_en1(data)                                        (0x00001000&((data)<<12))
+#define TVE_COMP_SYNC_SLEWLVL_write_en1_src(data)                                    ((0x00001000&(data))>>12)
+#define TVE_COMP_SYNC_SLEWLVL_get_write_en1(data)                                    ((0x00001000&(data))>>12)
+#define TVE_COMP_SYNC_SLEWLVL_y_sync_m_shift                                         (0)
+#define TVE_COMP_SYNC_SLEWLVL_y_sync_m_mask                                          (0x00000FFF)
+#define TVE_COMP_SYNC_SLEWLVL_y_sync_m(data)                                         (0x00000FFF&((data)<<0))
+#define TVE_COMP_SYNC_SLEWLVL_y_sync_m_src(data)                                     ((0x00000FFF&(data))>>0)
+#define TVE_COMP_SYNC_SLEWLVL_get_y_sync_m(data)                                     ((0x00000FFF&(data))>>0)
+
+
+#define TVE_COMP_BP_LVL                                                              0x180180e8
+#define TVE_COMP_BP_LVL_reg_addr                                                     "0xB80180E8"
+#define TVE_COMP_BP_LVL_reg                                                          0xB80180E8
+#define set_TVE_COMP_BP_LVL_reg(data)   (*((volatile unsigned int*) TVE_COMP_BP_LVL_reg)=data)
+#define get_TVE_COMP_BP_LVL_reg   (*((volatile unsigned int*) TVE_COMP_BP_LVL_reg))
+#define TVE_COMP_BP_LVL_inst_adr                                                     "0x003A"
+#define TVE_COMP_BP_LVL_inst                                                         0x003A
+#define TVE_COMP_BP_LVL_write_en2_shift                                              (25)
+#define TVE_COMP_BP_LVL_write_en2_mask                                               (0x02000000)
+#define TVE_COMP_BP_LVL_write_en2(data)                                              (0x02000000&((data)<<25))
+#define TVE_COMP_BP_LVL_write_en2_src(data)                                          ((0x02000000&(data))>>25)
+#define TVE_COMP_BP_LVL_get_write_en2(data)                                          ((0x02000000&(data))>>25)
+#define TVE_COMP_BP_LVL_y_sync_l_shift                                               (13)
+#define TVE_COMP_BP_LVL_y_sync_l_mask                                                (0x01FFE000)
+#define TVE_COMP_BP_LVL_y_sync_l(data)                                               (0x01FFE000&((data)<<13))
+#define TVE_COMP_BP_LVL_y_sync_l_src(data)                                           ((0x01FFE000&(data))>>13)
+#define TVE_COMP_BP_LVL_get_y_sync_l(data)                                           ((0x01FFE000&(data))>>13)
+#define TVE_COMP_BP_LVL_write_en1_shift                                              (12)
+#define TVE_COMP_BP_LVL_write_en1_mask                                               (0x00001000)
+#define TVE_COMP_BP_LVL_write_en1(data)                                              (0x00001000&((data)<<12))
+#define TVE_COMP_BP_LVL_write_en1_src(data)                                          ((0x00001000&(data))>>12)
+#define TVE_COMP_BP_LVL_get_write_en1(data)                                          ((0x00001000&(data))>>12)
+#define TVE_COMP_BP_LVL_bp_lvl_shift                                                 (0)
+#define TVE_COMP_BP_LVL_bp_lvl_mask                                                  (0x00000FFF)
+#define TVE_COMP_BP_LVL_bp_lvl(data)                                                 (0x00000FFF&((data)<<0))
+#define TVE_COMP_BP_LVL_bp_lvl_src(data)                                             ((0x00000FFF&(data))>>0)
+#define TVE_COMP_BP_LVL_get_bp_lvl(data)                                             ((0x00000FFF&(data))>>0)
+
+
+#define TVE_COMP_PBPR_SYNCLVL                                                        0x180180ec
+#define TVE_COMP_PBPR_SYNCLVL_reg_addr                                               "0xB80180EC"
+#define TVE_COMP_PBPR_SYNCLVL_reg                                                    0xB80180EC
+#define set_TVE_COMP_PBPR_SYNCLVL_reg(data)   (*((volatile unsigned int*) TVE_COMP_PBPR_SYNCLVL_reg)=data)
+#define get_TVE_COMP_PBPR_SYNCLVL_reg   (*((volatile unsigned int*) TVE_COMP_PBPR_SYNCLVL_reg))
+#define TVE_COMP_PBPR_SYNCLVL_inst_adr                                               "0x003B"
+#define TVE_COMP_PBPR_SYNCLVL_inst                                                   0x003B
+#define TVE_COMP_PBPR_SYNCLVL_write_en2_shift                                        (25)
+#define TVE_COMP_PBPR_SYNCLVL_write_en2_mask                                         (0x02000000)
+#define TVE_COMP_PBPR_SYNCLVL_write_en2(data)                                        (0x02000000&((data)<<25))
+#define TVE_COMP_PBPR_SYNCLVL_write_en2_src(data)                                    ((0x02000000&(data))>>25)
+#define TVE_COMP_PBPR_SYNCLVL_get_write_en2(data)                                    ((0x02000000&(data))>>25)
+#define TVE_COMP_PBPR_SYNCLVL_pbpr_negsynclvl_shift                                  (13)
+#define TVE_COMP_PBPR_SYNCLVL_pbpr_negsynclvl_mask                                   (0x01FFE000)
+#define TVE_COMP_PBPR_SYNCLVL_pbpr_negsynclvl(data)                                  (0x01FFE000&((data)<<13))
+#define TVE_COMP_PBPR_SYNCLVL_pbpr_negsynclvl_src(data)                              ((0x01FFE000&(data))>>13)
+#define TVE_COMP_PBPR_SYNCLVL_get_pbpr_negsynclvl(data)                              ((0x01FFE000&(data))>>13)
+#define TVE_COMP_PBPR_SYNCLVL_write_en1_shift                                        (12)
+#define TVE_COMP_PBPR_SYNCLVL_write_en1_mask                                         (0x00001000)
+#define TVE_COMP_PBPR_SYNCLVL_write_en1(data)                                        (0x00001000&((data)<<12))
+#define TVE_COMP_PBPR_SYNCLVL_write_en1_src(data)                                    ((0x00001000&(data))>>12)
+#define TVE_COMP_PBPR_SYNCLVL_get_write_en1(data)                                    ((0x00001000&(data))>>12)
+#define TVE_COMP_PBPR_SYNCLVL_pbpr_possynclvl_shift                                  (0)
+#define TVE_COMP_PBPR_SYNCLVL_pbpr_possynclvl_mask                                   (0x00000FFF)
+#define TVE_COMP_PBPR_SYNCLVL_pbpr_possynclvl(data)                                  (0x00000FFF&((data)<<0))
+#define TVE_COMP_PBPR_SYNCLVL_pbpr_possynclvl_src(data)                              ((0x00000FFF&(data))>>0)
+#define TVE_COMP_PBPR_SYNCLVL_get_pbpr_possynclvl(data)                              ((0x00000FFF&(data))>>0)
+
+
+#define TVE_COMP_PBPR_BLNKLVL                                                        0x180180f0
+#define TVE_COMP_PBPR_BLNKLVL_reg_addr                                               "0xB80180F0"
+#define TVE_COMP_PBPR_BLNKLVL_reg                                                    0xB80180F0
+#define set_TVE_COMP_PBPR_BLNKLVL_reg(data)   (*((volatile unsigned int*) TVE_COMP_PBPR_BLNKLVL_reg)=data)
+#define get_TVE_COMP_PBPR_BLNKLVL_reg   (*((volatile unsigned int*) TVE_COMP_PBPR_BLNKLVL_reg))
+#define TVE_COMP_PBPR_BLNKLVL_inst_adr                                               "0x003C"
+#define TVE_COMP_PBPR_BLNKLVL_inst                                                   0x003C
+#define TVE_COMP_PBPR_BLNKLVL_write_en2_shift                                        (25)
+#define TVE_COMP_PBPR_BLNKLVL_write_en2_mask                                         (0x02000000)
+#define TVE_COMP_PBPR_BLNKLVL_write_en2(data)                                        (0x02000000&((data)<<25))
+#define TVE_COMP_PBPR_BLNKLVL_write_en2_src(data)                                    ((0x02000000&(data))>>25)
+#define TVE_COMP_PBPR_BLNKLVL_get_write_en2(data)                                    ((0x02000000&(data))>>25)
+#define TVE_COMP_PBPR_BLNKLVL_y_blank_lvl_shift                                      (13)
+#define TVE_COMP_PBPR_BLNKLVL_y_blank_lvl_mask                                       (0x01FFE000)
+#define TVE_COMP_PBPR_BLNKLVL_y_blank_lvl(data)                                      (0x01FFE000&((data)<<13))
+#define TVE_COMP_PBPR_BLNKLVL_y_blank_lvl_src(data)                                  ((0x01FFE000&(data))>>13)
+#define TVE_COMP_PBPR_BLNKLVL_get_y_blank_lvl(data)                                  ((0x01FFE000&(data))>>13)
+#define TVE_COMP_PBPR_BLNKLVL_write_en1_shift                                        (12)
+#define TVE_COMP_PBPR_BLNKLVL_write_en1_mask                                         (0x00001000)
+#define TVE_COMP_PBPR_BLNKLVL_write_en1(data)                                        (0x00001000&((data)<<12))
+#define TVE_COMP_PBPR_BLNKLVL_write_en1_src(data)                                    ((0x00001000&(data))>>12)
+#define TVE_COMP_PBPR_BLNKLVL_get_write_en1(data)                                    ((0x00001000&(data))>>12)
+#define TVE_COMP_PBPR_BLNKLVL_pbpr_blank_lvl_shift                                   (0)
+#define TVE_COMP_PBPR_BLNKLVL_pbpr_blank_lvl_mask                                    (0x00000FFF)
+#define TVE_COMP_PBPR_BLNKLVL_pbpr_blank_lvl(data)                                   (0x00000FFF&((data)<<0))
+#define TVE_COMP_PBPR_BLNKLVL_pbpr_blank_lvl_src(data)                               ((0x00000FFF&(data))>>0)
+#define TVE_COMP_PBPR_BLNKLVL_get_pbpr_blank_lvl(data)                               ((0x00000FFF&(data))>>0)
+
+
+#define TVE_COMP_G_CLMPLVL                                                           0x180180f4
+#define TVE_COMP_G_CLMPLVL_reg_addr                                                  "0xB80180F4"
+#define TVE_COMP_G_CLMPLVL_reg                                                       0xB80180F4
+#define set_TVE_COMP_G_CLMPLVL_reg(data)   (*((volatile unsigned int*) TVE_COMP_G_CLMPLVL_reg)=data)
+#define get_TVE_COMP_G_CLMPLVL_reg   (*((volatile unsigned int*) TVE_COMP_G_CLMPLVL_reg))
+#define TVE_COMP_G_CLMPLVL_inst_adr                                                  "0x003D"
+#define TVE_COMP_G_CLMPLVL_inst                                                      0x003D
+#define TVE_COMP_G_CLMPLVL_write_en2_shift                                           (25)
+#define TVE_COMP_G_CLMPLVL_write_en2_mask                                            (0x02000000)
+#define TVE_COMP_G_CLMPLVL_write_en2(data)                                           (0x02000000&((data)<<25))
+#define TVE_COMP_G_CLMPLVL_write_en2_src(data)                                       ((0x02000000&(data))>>25)
+#define TVE_COMP_G_CLMPLVL_get_write_en2(data)                                       ((0x02000000&(data))>>25)
+#define TVE_COMP_G_CLMPLVL_g_up_shift                                                (13)
+#define TVE_COMP_G_CLMPLVL_g_up_mask                                                 (0x01FFE000)
+#define TVE_COMP_G_CLMPLVL_g_up(data)                                                (0x01FFE000&((data)<<13))
+#define TVE_COMP_G_CLMPLVL_g_up_src(data)                                            ((0x01FFE000&(data))>>13)
+#define TVE_COMP_G_CLMPLVL_get_g_up(data)                                            ((0x01FFE000&(data))>>13)
+#define TVE_COMP_G_CLMPLVL_write_en1_shift                                           (12)
+#define TVE_COMP_G_CLMPLVL_write_en1_mask                                            (0x00001000)
+#define TVE_COMP_G_CLMPLVL_write_en1(data)                                           (0x00001000&((data)<<12))
+#define TVE_COMP_G_CLMPLVL_write_en1_src(data)                                       ((0x00001000&(data))>>12)
+#define TVE_COMP_G_CLMPLVL_get_write_en1(data)                                       ((0x00001000&(data))>>12)
+#define TVE_COMP_G_CLMPLVL_g_dn_shift                                                (0)
+#define TVE_COMP_G_CLMPLVL_g_dn_mask                                                 (0x00000FFF)
+#define TVE_COMP_G_CLMPLVL_g_dn(data)                                                (0x00000FFF&((data)<<0))
+#define TVE_COMP_G_CLMPLVL_g_dn_src(data)                                            ((0x00000FFF&(data))>>0)
+#define TVE_COMP_G_CLMPLVL_get_g_dn(data)                                            ((0x00000FFF&(data))>>0)
+
+
+#define TVE_COMP_RB_CLMPLVL                                                          0x180180f8
+#define TVE_COMP_RB_CLMPLVL_reg_addr                                                 "0xB80180F8"
+#define TVE_COMP_RB_CLMPLVL_reg                                                      0xB80180F8
+#define set_TVE_COMP_RB_CLMPLVL_reg(data)   (*((volatile unsigned int*) TVE_COMP_RB_CLMPLVL_reg)=data)
+#define get_TVE_COMP_RB_CLMPLVL_reg   (*((volatile unsigned int*) TVE_COMP_RB_CLMPLVL_reg))
+#define TVE_COMP_RB_CLMPLVL_inst_adr                                                 "0x003E"
+#define TVE_COMP_RB_CLMPLVL_inst                                                     0x003E
+#define TVE_COMP_RB_CLMPLVL_write_en2_shift                                          (25)
+#define TVE_COMP_RB_CLMPLVL_write_en2_mask                                           (0x02000000)
+#define TVE_COMP_RB_CLMPLVL_write_en2(data)                                          (0x02000000&((data)<<25))
+#define TVE_COMP_RB_CLMPLVL_write_en2_src(data)                                      ((0x02000000&(data))>>25)
+#define TVE_COMP_RB_CLMPLVL_get_write_en2(data)                                      ((0x02000000&(data))>>25)
+#define TVE_COMP_RB_CLMPLVL_rb_up_shift                                              (13)
+#define TVE_COMP_RB_CLMPLVL_rb_up_mask                                               (0x01FFE000)
+#define TVE_COMP_RB_CLMPLVL_rb_up(data)                                              (0x01FFE000&((data)<<13))
+#define TVE_COMP_RB_CLMPLVL_rb_up_src(data)                                          ((0x01FFE000&(data))>>13)
+#define TVE_COMP_RB_CLMPLVL_get_rb_up(data)                                          ((0x01FFE000&(data))>>13)
+#define TVE_COMP_RB_CLMPLVL_write_en1_shift                                          (12)
+#define TVE_COMP_RB_CLMPLVL_write_en1_mask                                           (0x00001000)
+#define TVE_COMP_RB_CLMPLVL_write_en1(data)                                          (0x00001000&((data)<<12))
+#define TVE_COMP_RB_CLMPLVL_write_en1_src(data)                                      ((0x00001000&(data))>>12)
+#define TVE_COMP_RB_CLMPLVL_get_write_en1(data)                                      ((0x00001000&(data))>>12)
+#define TVE_COMP_RB_CLMPLVL_rb_dn_shift                                              (0)
+#define TVE_COMP_RB_CLMPLVL_rb_dn_mask                                               (0x00000FFF)
+#define TVE_COMP_RB_CLMPLVL_rb_dn(data)                                              (0x00000FFF&((data)<<0))
+#define TVE_COMP_RB_CLMPLVL_rb_dn_src(data)                                          ((0x00000FFF&(data))>>0)
+#define TVE_COMP_RB_CLMPLVL_get_rb_dn(data)                                          ((0x00000FFF&(data))>>0)
+
+
+#define TVE_IP_INPUT                                                                 0x18018220
+#define TVE_IP_INPUT_reg_addr                                                        "0xB8018220"
+#define TVE_IP_INPUT_reg                                                             0xB8018220
+#define set_TVE_IP_INPUT_reg(data)   (*((volatile unsigned int*) TVE_IP_INPUT_reg)=data)
+#define get_TVE_IP_INPUT_reg   (*((volatile unsigned int*) TVE_IP_INPUT_reg))
+#define TVE_IP_INPUT_inst_adr                                                        "0x0088"
+#define TVE_IP_INPUT_inst                                                            0x0088
+#define TVE_IP_INPUT_y_black_lvl_shift                                               (0)
+#define TVE_IP_INPUT_y_black_lvl_mask                                                (0x000000FF)
+#define TVE_IP_INPUT_y_black_lvl(data)                                               (0x000000FF&((data)<<0))
+#define TVE_IP_INPUT_y_black_lvl_src(data)                                           ((0x000000FF&(data))>>0)
+#define TVE_IP_INPUT_get_y_black_lvl(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define TVE_VBI_COEFF                                                                0x18018100
+#define TVE_VBI_COEFF_reg_addr                                                       "0xB8018100"
+#define TVE_VBI_COEFF_reg                                                            0xB8018100
+#define set_TVE_VBI_COEFF_reg(data)   (*((volatile unsigned int*) TVE_VBI_COEFF_reg)=data)
+#define get_TVE_VBI_COEFF_reg   (*((volatile unsigned int*) TVE_VBI_COEFF_reg))
+#define TVE_VBI_COEFF_inst_adr                                                       "0x0040"
+#define TVE_VBI_COEFF_inst                                                           0x0040
+#define TVE_VBI_COEFF_write_en2_shift                                                (31)
+#define TVE_VBI_COEFF_write_en2_mask                                                 (0x80000000)
+#define TVE_VBI_COEFF_write_en2(data)                                                (0x80000000&((data)<<31))
+#define TVE_VBI_COEFF_write_en2_src(data)                                            ((0x80000000&(data))>>31)
+#define TVE_VBI_COEFF_get_write_en2(data)                                            ((0x80000000&(data))>>31)
+#define TVE_VBI_COEFF_gain_shift                                                     (16)
+#define TVE_VBI_COEFF_gain_mask                                                      (0x7FFF0000)
+#define TVE_VBI_COEFF_gain(data)                                                     (0x7FFF0000&((data)<<16))
+#define TVE_VBI_COEFF_gain_src(data)                                                 ((0x7FFF0000&(data))>>16)
+#define TVE_VBI_COEFF_get_gain(data)                                                 ((0x7FFF0000&(data))>>16)
+#define TVE_VBI_COEFF_write_en1_shift                                                (15)
+#define TVE_VBI_COEFF_write_en1_mask                                                 (0x00008000)
+#define TVE_VBI_COEFF_write_en1(data)                                                (0x00008000&((data)<<15))
+#define TVE_VBI_COEFF_write_en1_src(data)                                            ((0x00008000&(data))>>15)
+#define TVE_VBI_COEFF_get_write_en1(data)                                            ((0x00008000&(data))>>15)
+#define TVE_VBI_COEFF_offset_shift                                                   (0)
+#define TVE_VBI_COEFF_offset_mask                                                    (0x00007FFF)
+#define TVE_VBI_COEFF_offset(data)                                                   (0x00007FFF&((data)<<0))
+#define TVE_VBI_COEFF_offset_src(data)                                               ((0x00007FFF&(data))>>0)
+#define TVE_VBI_COEFF_get_offset(data)                                               ((0x00007FFF&(data))>>0)
+
+
+#define TVE_BLNK_COEFF                                                               0x18018104
+#define TVE_BLNK_COEFF_reg_addr                                                      "0xB8018104"
+#define TVE_BLNK_COEFF_reg                                                           0xB8018104
+#define set_TVE_BLNK_COEFF_reg(data)   (*((volatile unsigned int*) TVE_BLNK_COEFF_reg)=data)
+#define get_TVE_BLNK_COEFF_reg   (*((volatile unsigned int*) TVE_BLNK_COEFF_reg))
+#define TVE_BLNK_COEFF_inst_adr                                                      "0x0041"
+#define TVE_BLNK_COEFF_inst                                                          0x0041
+#define TVE_BLNK_COEFF_write_en2_shift                                               (31)
+#define TVE_BLNK_COEFF_write_en2_mask                                                (0x80000000)
+#define TVE_BLNK_COEFF_write_en2(data)                                               (0x80000000&((data)<<31))
+#define TVE_BLNK_COEFF_write_en2_src(data)                                           ((0x80000000&(data))>>31)
+#define TVE_BLNK_COEFF_get_write_en2(data)                                           ((0x80000000&(data))>>31)
+#define TVE_BLNK_COEFF_gain_shift                                                    (16)
+#define TVE_BLNK_COEFF_gain_mask                                                     (0x7FFF0000)
+#define TVE_BLNK_COEFF_gain(data)                                                    (0x7FFF0000&((data)<<16))
+#define TVE_BLNK_COEFF_gain_src(data)                                                ((0x7FFF0000&(data))>>16)
+#define TVE_BLNK_COEFF_get_gain(data)                                                ((0x7FFF0000&(data))>>16)
+#define TVE_BLNK_COEFF_write_en1_shift                                               (15)
+#define TVE_BLNK_COEFF_write_en1_mask                                                (0x00008000)
+#define TVE_BLNK_COEFF_write_en1(data)                                               (0x00008000&((data)<<15))
+#define TVE_BLNK_COEFF_write_en1_src(data)                                           ((0x00008000&(data))>>15)
+#define TVE_BLNK_COEFF_get_write_en1(data)                                           ((0x00008000&(data))>>15)
+#define TVE_BLNK_COEFF_offset_shift                                                  (0)
+#define TVE_BLNK_COEFF_offset_mask                                                   (0x00007FFF)
+#define TVE_BLNK_COEFF_offset(data)                                                  (0x00007FFF&((data)<<0))
+#define TVE_BLNK_COEFF_offset_src(data)                                              ((0x00007FFF&(data))>>0)
+#define TVE_BLNK_COEFF_get_offset(data)                                              ((0x00007FFF&(data))>>0)
+
+
+#define TVE_AV_COEFF1                                                                0x18018108
+#define TVE_AV_COEFF1_reg_addr                                                       "0xB8018108"
+#define TVE_AV_COEFF1_reg                                                            0xB8018108
+#define set_TVE_AV_COEFF1_reg(data)   (*((volatile unsigned int*) TVE_AV_COEFF1_reg)=data)
+#define get_TVE_AV_COEFF1_reg   (*((volatile unsigned int*) TVE_AV_COEFF1_reg))
+#define TVE_AV_COEFF1_inst_adr                                                       "0x0042"
+#define TVE_AV_COEFF1_inst                                                           0x0042
+#define TVE_AV_COEFF1_write_en2_shift                                                (31)
+#define TVE_AV_COEFF1_write_en2_mask                                                 (0x80000000)
+#define TVE_AV_COEFF1_write_en2(data)                                                (0x80000000&((data)<<31))
+#define TVE_AV_COEFF1_write_en2_src(data)                                            ((0x80000000&(data))>>31)
+#define TVE_AV_COEFF1_get_write_en2(data)                                            ((0x80000000&(data))>>31)
+#define TVE_AV_COEFF1_c2_shift                                                       (16)
+#define TVE_AV_COEFF1_c2_mask                                                        (0x7FFF0000)
+#define TVE_AV_COEFF1_c2(data)                                                       (0x7FFF0000&((data)<<16))
+#define TVE_AV_COEFF1_c2_src(data)                                                   ((0x7FFF0000&(data))>>16)
+#define TVE_AV_COEFF1_get_c2(data)                                                   ((0x7FFF0000&(data))>>16)
+#define TVE_AV_COEFF1_write_en1_shift                                                (15)
+#define TVE_AV_COEFF1_write_en1_mask                                                 (0x00008000)
+#define TVE_AV_COEFF1_write_en1(data)                                                (0x00008000&((data)<<15))
+#define TVE_AV_COEFF1_write_en1_src(data)                                            ((0x00008000&(data))>>15)
+#define TVE_AV_COEFF1_get_write_en1(data)                                            ((0x00008000&(data))>>15)
+#define TVE_AV_COEFF1_c1_shift                                                       (0)
+#define TVE_AV_COEFF1_c1_mask                                                        (0x00007FFF)
+#define TVE_AV_COEFF1_c1(data)                                                       (0x00007FFF&((data)<<0))
+#define TVE_AV_COEFF1_c1_src(data)                                                   ((0x00007FFF&(data))>>0)
+#define TVE_AV_COEFF1_get_c1(data)                                                   ((0x00007FFF&(data))>>0)
+
+
+#define TVE_AV_COEFF2                                                                0x1801810c
+#define TVE_AV_COEFF2_reg_addr                                                       "0xB801810C"
+#define TVE_AV_COEFF2_reg                                                            0xB801810C
+#define set_TVE_AV_COEFF2_reg(data)   (*((volatile unsigned int*) TVE_AV_COEFF2_reg)=data)
+#define get_TVE_AV_COEFF2_reg   (*((volatile unsigned int*) TVE_AV_COEFF2_reg))
+#define TVE_AV_COEFF2_inst_adr                                                       "0x0043"
+#define TVE_AV_COEFF2_inst                                                           0x0043
+#define TVE_AV_COEFF2_write_en2_shift                                                (31)
+#define TVE_AV_COEFF2_write_en2_mask                                                 (0x80000000)
+#define TVE_AV_COEFF2_write_en2(data)                                                (0x80000000&((data)<<31))
+#define TVE_AV_COEFF2_write_en2_src(data)                                            ((0x80000000&(data))>>31)
+#define TVE_AV_COEFF2_get_write_en2(data)                                            ((0x80000000&(data))>>31)
+#define TVE_AV_COEFF2_c3_shift                                                       (16)
+#define TVE_AV_COEFF2_c3_mask                                                        (0x7FFF0000)
+#define TVE_AV_COEFF2_c3(data)                                                       (0x7FFF0000&((data)<<16))
+#define TVE_AV_COEFF2_c3_src(data)                                                   ((0x7FFF0000&(data))>>16)
+#define TVE_AV_COEFF2_get_c3(data)                                                   ((0x7FFF0000&(data))>>16)
+#define TVE_AV_COEFF2_write_en1_shift                                                (15)
+#define TVE_AV_COEFF2_write_en1_mask                                                 (0x00008000)
+#define TVE_AV_COEFF2_write_en1(data)                                                (0x00008000&((data)<<15))
+#define TVE_AV_COEFF2_write_en1_src(data)                                            ((0x00008000&(data))>>15)
+#define TVE_AV_COEFF2_get_write_en1(data)                                            ((0x00008000&(data))>>15)
+#define TVE_AV_COEFF2_c4_shift                                                       (0)
+#define TVE_AV_COEFF2_c4_mask                                                        (0x00007FFF)
+#define TVE_AV_COEFF2_c4(data)                                                       (0x00007FFF&((data)<<0))
+#define TVE_AV_COEFF2_c4_src(data)                                                   ((0x00007FFF&(data))>>0)
+#define TVE_AV_COEFF2_get_c4(data)                                                   ((0x00007FFF&(data))>>0)
+
+
+#define TVE_AV_COEFF3                                                                0x18018110
+#define TVE_AV_COEFF3_reg_addr                                                       "0xB8018110"
+#define TVE_AV_COEFF3_reg                                                            0xB8018110
+#define set_TVE_AV_COEFF3_reg(data)   (*((volatile unsigned int*) TVE_AV_COEFF3_reg)=data)
+#define get_TVE_AV_COEFF3_reg   (*((volatile unsigned int*) TVE_AV_COEFF3_reg))
+#define TVE_AV_COEFF3_inst_adr                                                       "0x0044"
+#define TVE_AV_COEFF3_inst                                                           0x0044
+#define TVE_AV_COEFF3_write_en2_shift                                                (31)
+#define TVE_AV_COEFF3_write_en2_mask                                                 (0x80000000)
+#define TVE_AV_COEFF3_write_en2(data)                                                (0x80000000&((data)<<31))
+#define TVE_AV_COEFF3_write_en2_src(data)                                            ((0x80000000&(data))>>31)
+#define TVE_AV_COEFF3_get_write_en2(data)                                            ((0x80000000&(data))>>31)
+#define TVE_AV_COEFF3_c5_shift                                                       (16)
+#define TVE_AV_COEFF3_c5_mask                                                        (0x7FFF0000)
+#define TVE_AV_COEFF3_c5(data)                                                       (0x7FFF0000&((data)<<16))
+#define TVE_AV_COEFF3_c5_src(data)                                                   ((0x7FFF0000&(data))>>16)
+#define TVE_AV_COEFF3_get_c5(data)                                                   ((0x7FFF0000&(data))>>16)
+#define TVE_AV_COEFF3_write_en1_shift                                                (15)
+#define TVE_AV_COEFF3_write_en1_mask                                                 (0x00008000)
+#define TVE_AV_COEFF3_write_en1(data)                                                (0x00008000&((data)<<15))
+#define TVE_AV_COEFF3_write_en1_src(data)                                            ((0x00008000&(data))>>15)
+#define TVE_AV_COEFF3_get_write_en1(data)                                            ((0x00008000&(data))>>15)
+#define TVE_AV_COEFF3_c6_shift                                                       (0)
+#define TVE_AV_COEFF3_c6_mask                                                        (0x00007FFF)
+#define TVE_AV_COEFF3_c6(data)                                                       (0x00007FFF&((data)<<0))
+#define TVE_AV_COEFF3_c6_src(data)                                                   ((0x00007FFF&(data))>>0)
+#define TVE_AV_COEFF3_get_c6(data)                                                   ((0x00007FFF&(data))>>0)
+
+
+#define TVE_AV_COEFF4                                                                0x18018114
+#define TVE_AV_COEFF4_reg_addr                                                       "0xB8018114"
+#define TVE_AV_COEFF4_reg                                                            0xB8018114
+#define set_TVE_AV_COEFF4_reg(data)   (*((volatile unsigned int*) TVE_AV_COEFF4_reg)=data)
+#define get_TVE_AV_COEFF4_reg   (*((volatile unsigned int*) TVE_AV_COEFF4_reg))
+#define TVE_AV_COEFF4_inst_adr                                                       "0x0045"
+#define TVE_AV_COEFF4_inst                                                           0x0045
+#define TVE_AV_COEFF4_write_en2_shift                                                (31)
+#define TVE_AV_COEFF4_write_en2_mask                                                 (0x80000000)
+#define TVE_AV_COEFF4_write_en2(data)                                                (0x80000000&((data)<<31))
+#define TVE_AV_COEFF4_write_en2_src(data)                                            ((0x80000000&(data))>>31)
+#define TVE_AV_COEFF4_get_write_en2(data)                                            ((0x80000000&(data))>>31)
+#define TVE_AV_COEFF4_k1_shift                                                       (16)
+#define TVE_AV_COEFF4_k1_mask                                                        (0x7FFF0000)
+#define TVE_AV_COEFF4_k1(data)                                                       (0x7FFF0000&((data)<<16))
+#define TVE_AV_COEFF4_k1_src(data)                                                   ((0x7FFF0000&(data))>>16)
+#define TVE_AV_COEFF4_get_k1(data)                                                   ((0x7FFF0000&(data))>>16)
+#define TVE_AV_COEFF4_write_en1_shift                                                (15)
+#define TVE_AV_COEFF4_write_en1_mask                                                 (0x00008000)
+#define TVE_AV_COEFF4_write_en1(data)                                                (0x00008000&((data)<<15))
+#define TVE_AV_COEFF4_write_en1_src(data)                                            ((0x00008000&(data))>>15)
+#define TVE_AV_COEFF4_get_write_en1(data)                                            ((0x00008000&(data))>>15)
+#define TVE_AV_COEFF4_k2_shift                                                       (0)
+#define TVE_AV_COEFF4_k2_mask                                                        (0x00007FFF)
+#define TVE_AV_COEFF4_k2(data)                                                       (0x00007FFF&((data)<<0))
+#define TVE_AV_COEFF4_k2_src(data)                                                   ((0x00007FFF&(data))>>0)
+#define TVE_AV_COEFF4_get_k2(data)                                                   ((0x00007FFF&(data))>>0)
+
+
+#define TVE_AV_COEFF5                                                                0x18018118
+#define TVE_AV_COEFF5_reg_addr                                                       "0xB8018118"
+#define TVE_AV_COEFF5_reg                                                            0xB8018118
+#define set_TVE_AV_COEFF5_reg(data)   (*((volatile unsigned int*) TVE_AV_COEFF5_reg)=data)
+#define get_TVE_AV_COEFF5_reg   (*((volatile unsigned int*) TVE_AV_COEFF5_reg))
+#define TVE_AV_COEFF5_inst_adr                                                       "0x0046"
+#define TVE_AV_COEFF5_inst                                                           0x0046
+#define TVE_AV_COEFF5_write_en1_shift                                                (17)
+#define TVE_AV_COEFF5_write_en1_mask                                                 (0x00020000)
+#define TVE_AV_COEFF5_write_en1(data)                                                (0x00020000&((data)<<17))
+#define TVE_AV_COEFF5_write_en1_src(data)                                            ((0x00020000&(data))>>17)
+#define TVE_AV_COEFF5_get_write_en1(data)                                            ((0x00020000&(data))>>17)
+#define TVE_AV_COEFF5_vbi_gain_ebl_shift                                             (16)
+#define TVE_AV_COEFF5_vbi_gain_ebl_mask                                              (0x00010000)
+#define TVE_AV_COEFF5_vbi_gain_ebl(data)                                             (0x00010000&((data)<<16))
+#define TVE_AV_COEFF5_vbi_gain_ebl_src(data)                                         ((0x00010000&(data))>>16)
+#define TVE_AV_COEFF5_get_vbi_gain_ebl(data)                                         ((0x00010000&(data))>>16)
+#define TVE_AV_COEFF5_write_en2_shift                                                (15)
+#define TVE_AV_COEFF5_write_en2_mask                                                 (0x00008000)
+#define TVE_AV_COEFF5_write_en2(data)                                                (0x00008000&((data)<<15))
+#define TVE_AV_COEFF5_write_en2_src(data)                                            ((0x00008000&(data))>>15)
+#define TVE_AV_COEFF5_get_write_en2(data)                                            ((0x00008000&(data))>>15)
+#define TVE_AV_COEFF5_k3_shift                                                       (0)
+#define TVE_AV_COEFF5_k3_mask                                                        (0x00007FFF)
+#define TVE_AV_COEFF5_k3(data)                                                       (0x00007FFF&((data)<<0))
+#define TVE_AV_COEFF5_k3_src(data)                                                   ((0x00007FFF&(data))>>0)
+#define TVE_AV_COEFF5_get_k3(data)                                                   ((0x00007FFF&(data))>>0)
+
+
+#define TVE_MV_CTRL                                                                  0x18018130
+#define TVE_MV_CTRL_reg_addr                                                         "0xB8018130"
+#define TVE_MV_CTRL_reg                                                              0xB8018130
+#define set_TVE_MV_CTRL_reg(data)   (*((volatile unsigned int*) TVE_MV_CTRL_reg)=data)
+#define get_TVE_MV_CTRL_reg   (*((volatile unsigned int*) TVE_MV_CTRL_reg))
+#define TVE_MV_CTRL_inst_adr                                                         "0x004C"
+#define TVE_MV_CTRL_inst                                                             0x004C
+#define TVE_MV_CTRL_mv_rb_ebl_shift                                                  (3)
+#define TVE_MV_CTRL_mv_rb_ebl_mask                                                   (0x00000008)
+#define TVE_MV_CTRL_mv_rb_ebl(data)                                                  (0x00000008&((data)<<3))
+#define TVE_MV_CTRL_mv_rb_ebl_src(data)                                              ((0x00000008&(data))>>3)
+#define TVE_MV_CTRL_get_mv_rb_ebl(data)                                              ((0x00000008&(data))>>3)
+#define TVE_MV_CTRL_mv_g_ebl_shift                                                   (2)
+#define TVE_MV_CTRL_mv_g_ebl_mask                                                    (0x00000004)
+#define TVE_MV_CTRL_mv_g_ebl(data)                                                   (0x00000004&((data)<<2))
+#define TVE_MV_CTRL_mv_g_ebl_src(data)                                               ((0x00000004&(data))>>2)
+#define TVE_MV_CTRL_get_mv_g_ebl(data)                                               ((0x00000004&(data))>>2)
+#define TVE_MV_CTRL_mv_ebl_shift                                                     (1)
+#define TVE_MV_CTRL_mv_ebl_mask                                                      (0x00000002)
+#define TVE_MV_CTRL_mv_ebl(data)                                                     (0x00000002&((data)<<1))
+#define TVE_MV_CTRL_mv_ebl_src(data)                                                 ((0x00000002&(data))>>1)
+#define TVE_MV_CTRL_get_mv_ebl(data)                                                 ((0x00000002&(data))>>1)
+#define TVE_MV_CTRL_write_data_shift                                                 (0)
+#define TVE_MV_CTRL_write_data_mask                                                  (0x00000001)
+#define TVE_MV_CTRL_write_data(data)                                                 (0x00000001&((data)<<0))
+#define TVE_MV_CTRL_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define TVE_MV_CTRL_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define TVE_MV_VPOS                                                                  0x18018134
+#define TVE_MV_VPOS_reg_addr                                                         "0xB8018134"
+#define TVE_MV_VPOS_reg                                                              0xB8018134
+#define set_TVE_MV_VPOS_reg(data)   (*((volatile unsigned int*) TVE_MV_VPOS_reg)=data)
+#define get_TVE_MV_VPOS_reg   (*((volatile unsigned int*) TVE_MV_VPOS_reg))
+#define TVE_MV_VPOS_inst_adr                                                         "0x004D"
+#define TVE_MV_VPOS_inst                                                             0x004D
+#define TVE_MV_VPOS_write_en2_shift                                                  (13)
+#define TVE_MV_VPOS_write_en2_mask                                                   (0x00002000)
+#define TVE_MV_VPOS_write_en2(data)                                                  (0x00002000&((data)<<13))
+#define TVE_MV_VPOS_write_en2_src(data)                                              ((0x00002000&(data))>>13)
+#define TVE_MV_VPOS_get_write_en2(data)                                              ((0x00002000&(data))>>13)
+#define TVE_MV_VPOS_mv_end_line_shift                                                (7)
+#define TVE_MV_VPOS_mv_end_line_mask                                                 (0x00001F80)
+#define TVE_MV_VPOS_mv_end_line(data)                                                (0x00001F80&((data)<<7))
+#define TVE_MV_VPOS_mv_end_line_src(data)                                            ((0x00001F80&(data))>>7)
+#define TVE_MV_VPOS_get_mv_end_line(data)                                            ((0x00001F80&(data))>>7)
+#define TVE_MV_VPOS_write_en1_shift                                                  (6)
+#define TVE_MV_VPOS_write_en1_mask                                                   (0x00000040)
+#define TVE_MV_VPOS_write_en1(data)                                                  (0x00000040&((data)<<6))
+#define TVE_MV_VPOS_write_en1_src(data)                                              ((0x00000040&(data))>>6)
+#define TVE_MV_VPOS_get_write_en1(data)                                              ((0x00000040&(data))>>6)
+#define TVE_MV_VPOS_mv_st_line_shift                                                 (0)
+#define TVE_MV_VPOS_mv_st_line_mask                                                  (0x0000003F)
+#define TVE_MV_VPOS_mv_st_line(data)                                                 (0x0000003F&((data)<<0))
+#define TVE_MV_VPOS_mv_st_line_src(data)                                             ((0x0000003F&(data))>>0)
+#define TVE_MV_VPOS_get_mv_st_line(data)                                             ((0x0000003F&(data))>>0)
+
+
+#define TVE_MV_LEN                                                                   0x18018138
+#define TVE_MV_LEN_reg_addr                                                          "0xB8018138"
+#define TVE_MV_LEN_reg                                                               0xB8018138
+#define set_TVE_MV_LEN_reg(data)   (*((volatile unsigned int*) TVE_MV_LEN_reg)=data)
+#define get_TVE_MV_LEN_reg   (*((volatile unsigned int*) TVE_MV_LEN_reg))
+#define TVE_MV_LEN_inst_adr                                                          "0x004E"
+#define TVE_MV_LEN_inst                                                              0x004E
+#define TVE_MV_LEN_write_en4_shift                                                   (29)
+#define TVE_MV_LEN_write_en4_mask                                                    (0x20000000)
+#define TVE_MV_LEN_write_en4(data)                                                   (0x20000000&((data)<<29))
+#define TVE_MV_LEN_write_en4_src(data)                                               ((0x20000000&(data))>>29)
+#define TVE_MV_LEN_get_write_en4(data)                                               ((0x20000000&(data))>>29)
+#define TVE_MV_LEN_mv_st_ps_shift                                                    (21)
+#define TVE_MV_LEN_mv_st_ps_mask                                                     (0x1FE00000)
+#define TVE_MV_LEN_mv_st_ps(data)                                                    (0x1FE00000&((data)<<21))
+#define TVE_MV_LEN_mv_st_ps_src(data)                                                ((0x1FE00000&(data))>>21)
+#define TVE_MV_LEN_get_mv_st_ps(data)                                                ((0x1FE00000&(data))>>21)
+#define TVE_MV_LEN_write_en3_shift                                                   (20)
+#define TVE_MV_LEN_write_en3_mask                                                    (0x00100000)
+#define TVE_MV_LEN_write_en3(data)                                                   (0x00100000&((data)<<20))
+#define TVE_MV_LEN_write_en3_src(data)                                               ((0x00100000&(data))>>20)
+#define TVE_MV_LEN_get_write_en3(data)                                               ((0x00100000&(data))>>20)
+#define TVE_MV_LEN_mv_ps_len_shift                                                   (14)
+#define TVE_MV_LEN_mv_ps_len_mask                                                    (0x000FC000)
+#define TVE_MV_LEN_mv_ps_len(data)                                                   (0x000FC000&((data)<<14))
+#define TVE_MV_LEN_mv_ps_len_src(data)                                               ((0x000FC000&(data))>>14)
+#define TVE_MV_LEN_get_mv_ps_len(data)                                               ((0x000FC000&(data))>>14)
+#define TVE_MV_LEN_write_en2_shift                                                   (13)
+#define TVE_MV_LEN_write_en2_mask                                                    (0x00002000)
+#define TVE_MV_LEN_write_en2(data)                                                   (0x00002000&((data)<<13))
+#define TVE_MV_LEN_write_en2_src(data)                                               ((0x00002000&(data))>>13)
+#define TVE_MV_LEN_get_write_en2(data)                                               ((0x00002000&(data))>>13)
+#define TVE_MV_LEN_mv_agc_len_shift                                                  (7)
+#define TVE_MV_LEN_mv_agc_len_mask                                                   (0x00001F80)
+#define TVE_MV_LEN_mv_agc_len(data)                                                  (0x00001F80&((data)<<7))
+#define TVE_MV_LEN_mv_agc_len_src(data)                                              ((0x00001F80&(data))>>7)
+#define TVE_MV_LEN_get_mv_agc_len(data)                                              ((0x00001F80&(data))>>7)
+#define TVE_MV_LEN_write_en1_shift                                                   (6)
+#define TVE_MV_LEN_write_en1_mask                                                    (0x00000040)
+#define TVE_MV_LEN_write_en1(data)                                                   (0x00000040&((data)<<6))
+#define TVE_MV_LEN_write_en1_src(data)                                               ((0x00000040&(data))>>6)
+#define TVE_MV_LEN_get_write_en1(data)                                               ((0x00000040&(data))>>6)
+#define TVE_MV_LEN_mv_blnk_len_shift                                                 (0)
+#define TVE_MV_LEN_mv_blnk_len_mask                                                  (0x0000003F)
+#define TVE_MV_LEN_mv_blnk_len(data)                                                 (0x0000003F&((data)<<0))
+#define TVE_MV_LEN_mv_blnk_len_src(data)                                             ((0x0000003F&(data))>>0)
+#define TVE_MV_LEN_get_mv_blnk_len(data)                                             ((0x0000003F&(data))>>0)
+
+
+#define TVE_MV_RD                                                                    0x1801813c
+#define TVE_MV_RD_reg_addr                                                           "0xB801813C"
+#define TVE_MV_RD_reg                                                                0xB801813C
+#define set_TVE_MV_RD_reg(data)   (*((volatile unsigned int*) TVE_MV_RD_reg)=data)
+#define get_TVE_MV_RD_reg   (*((volatile unsigned int*) TVE_MV_RD_reg))
+#define TVE_MV_RD_inst_adr                                                           "0x004F"
+#define TVE_MV_RD_inst                                                               0x004F
+#define TVE_MV_RD_mv_rd_shift                                                        (0)
+#define TVE_MV_RD_mv_rd_mask                                                         (0x000FFFFF)
+#define TVE_MV_RD_mv_rd(data)                                                        (0x000FFFFF&((data)<<0))
+#define TVE_MV_RD_mv_rd_src(data)                                                    ((0x000FFFFF&(data))>>0)
+#define TVE_MV_RD_get_mv_rd(data)                                                    ((0x000FFFFF&(data))>>0)
+
+
+#define TVE_MV_DN                                                                    0x18018140
+#define TVE_MV_DN_reg_addr                                                           "0xB8018140"
+#define TVE_MV_DN_reg                                                                0xB8018140
+#define set_TVE_MV_DN_reg(data)   (*((volatile unsigned int*) TVE_MV_DN_reg)=data)
+#define get_TVE_MV_DN_reg   (*((volatile unsigned int*) TVE_MV_DN_reg))
+#define TVE_MV_DN_inst_adr                                                           "0x0050"
+#define TVE_MV_DN_inst                                                               0x0050
+#define TVE_MV_DN_mv_dn_shift                                                        (0)
+#define TVE_MV_DN_mv_dn_mask                                                         (0x000FFFFF)
+#define TVE_MV_DN_mv_dn(data)                                                        (0x000FFFFF&((data)<<0))
+#define TVE_MV_DN_mv_dn_src(data)                                                    ((0x000FFFFF&(data))>>0)
+#define TVE_MV_DN_get_mv_dn(data)                                                    ((0x000FFFFF&(data))>>0)
+
+
+#define TVE_MV_RU                                                                    0x18018144
+#define TVE_MV_RU_reg_addr                                                           "0xB8018144"
+#define TVE_MV_RU_reg                                                                0xB8018144
+#define set_TVE_MV_RU_reg(data)   (*((volatile unsigned int*) TVE_MV_RU_reg)=data)
+#define get_TVE_MV_RU_reg   (*((volatile unsigned int*) TVE_MV_RU_reg))
+#define TVE_MV_RU_inst_adr                                                           "0x0051"
+#define TVE_MV_RU_inst                                                               0x0051
+#define TVE_MV_RU_mv_ru_shift                                                        (0)
+#define TVE_MV_RU_mv_ru_mask                                                         (0x000FFFFF)
+#define TVE_MV_RU_mv_ru(data)                                                        (0x000FFFFF&((data)<<0))
+#define TVE_MV_RU_mv_ru_src(data)                                                    ((0x000FFFFF&(data))>>0)
+#define TVE_MV_RU_get_mv_ru(data)                                                    ((0x000FFFFF&(data))>>0)
+
+
+#define TVE_MV_UP                                                                    0x18018148
+#define TVE_MV_UP_reg_addr                                                           "0xB8018148"
+#define TVE_MV_UP_reg                                                                0xB8018148
+#define set_TVE_MV_UP_reg(data)   (*((volatile unsigned int*) TVE_MV_UP_reg)=data)
+#define get_TVE_MV_UP_reg   (*((volatile unsigned int*) TVE_MV_UP_reg))
+#define TVE_MV_UP_inst_adr                                                           "0x0052"
+#define TVE_MV_UP_inst                                                               0x0052
+#define TVE_MV_UP_mv_up_shift                                                        (0)
+#define TVE_MV_UP_mv_up_mask                                                         (0x000FFFFF)
+#define TVE_MV_UP_mv_up(data)                                                        (0x000FFFFF&((data)<<0))
+#define TVE_MV_UP_mv_up_src(data)                                                    ((0x000FFFFF&(data))>>0)
+#define TVE_MV_UP_get_mv_up(data)                                                    ((0x000FFFFF&(data))>>0)
+
+
+#define TVE_MV_LVL                                                                   0x1801814c
+#define TVE_MV_LVL_reg_addr                                                          "0xB801814C"
+#define TVE_MV_LVL_reg                                                               0xB801814C
+#define set_TVE_MV_LVL_reg(data)   (*((volatile unsigned int*) TVE_MV_LVL_reg)=data)
+#define get_TVE_MV_LVL_reg   (*((volatile unsigned int*) TVE_MV_LVL_reg))
+#define TVE_MV_LVL_inst_adr                                                          "0x0053"
+#define TVE_MV_LVL_inst                                                              0x0053
+#define TVE_MV_LVL_write_en3_shift                                                   (30)
+#define TVE_MV_LVL_write_en3_mask                                                    (0x40000000)
+#define TVE_MV_LVL_write_en3(data)                                                   (0x40000000&((data)<<30))
+#define TVE_MV_LVL_write_en3_src(data)                                               ((0x40000000&(data))>>30)
+#define TVE_MV_LVL_get_write_en3(data)                                               ((0x40000000&(data))>>30)
+#define TVE_MV_LVL_mv_ru_dlt_shift                                                   (22)
+#define TVE_MV_LVL_mv_ru_dlt_mask                                                    (0x3FC00000)
+#define TVE_MV_LVL_mv_ru_dlt(data)                                                   (0x3FC00000&((data)<<22))
+#define TVE_MV_LVL_mv_ru_dlt_src(data)                                               ((0x3FC00000&(data))>>22)
+#define TVE_MV_LVL_get_mv_ru_dlt(data)                                               ((0x3FC00000&(data))>>22)
+#define TVE_MV_LVL_write_en2_shift                                                   (21)
+#define TVE_MV_LVL_write_en2_mask                                                    (0x00200000)
+#define TVE_MV_LVL_write_en2(data)                                                   (0x00200000&((data)<<21))
+#define TVE_MV_LVL_write_en2_src(data)                                               ((0x00200000&(data))>>21)
+#define TVE_MV_LVL_get_write_en2(data)                                               ((0x00200000&(data))>>21)
+#define TVE_MV_LVL_mv_rd_dlt_shift                                                   (13)
+#define TVE_MV_LVL_mv_rd_dlt_mask                                                    (0x001FE000)
+#define TVE_MV_LVL_mv_rd_dlt(data)                                                   (0x001FE000&((data)<<13))
+#define TVE_MV_LVL_mv_rd_dlt_src(data)                                               ((0x001FE000&(data))>>13)
+#define TVE_MV_LVL_get_mv_rd_dlt(data)                                               ((0x001FE000&(data))>>13)
+#define TVE_MV_LVL_write_en1_shift                                                   (12)
+#define TVE_MV_LVL_write_en1_mask                                                    (0x00001000)
+#define TVE_MV_LVL_write_en1(data)                                                   (0x00001000&((data)<<12))
+#define TVE_MV_LVL_write_en1_src(data)                                               ((0x00001000&(data))>>12)
+#define TVE_MV_LVL_get_write_en1(data)                                               ((0x00001000&(data))>>12)
+#define TVE_MV_LVL_mv_stn_shift                                                      (0)
+#define TVE_MV_LVL_mv_stn_mask                                                       (0x00000FFF)
+#define TVE_MV_LVL_mv_stn(data)                                                      (0x00000FFF&((data)<<0))
+#define TVE_MV_LVL_mv_stn_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define TVE_MV_LVL_get_mv_stn(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define TVE_CGMS_CTRL                                                                0x18018160
+#define TVE_CGMS_CTRL_reg_addr                                                       "0xB8018160"
+#define TVE_CGMS_CTRL_reg                                                            0xB8018160
+#define set_TVE_CGMS_CTRL_reg(data)   (*((volatile unsigned int*) TVE_CGMS_CTRL_reg)=data)
+#define get_TVE_CGMS_CTRL_reg   (*((volatile unsigned int*) TVE_CGMS_CTRL_reg))
+#define TVE_CGMS_CTRL_inst_adr                                                       "0x0058"
+#define TVE_CGMS_CTRL_inst                                                           0x0058
+#define TVE_CGMS_CTRL_write_en3_shift                                                (24)
+#define TVE_CGMS_CTRL_write_en3_mask                                                 (0x01000000)
+#define TVE_CGMS_CTRL_write_en3(data)                                                (0x01000000&((data)<<24))
+#define TVE_CGMS_CTRL_write_en3_src(data)                                            ((0x01000000&(data))>>24)
+#define TVE_CGMS_CTRL_get_write_en3(data)                                            ((0x01000000&(data))>>24)
+#define TVE_CGMS_CTRL_cgms_i_ebl_shift                                               (23)
+#define TVE_CGMS_CTRL_cgms_i_ebl_mask                                                (0x00800000)
+#define TVE_CGMS_CTRL_cgms_i_ebl(data)                                               (0x00800000&((data)<<23))
+#define TVE_CGMS_CTRL_cgms_i_ebl_src(data)                                           ((0x00800000&(data))>>23)
+#define TVE_CGMS_CTRL_get_cgms_i_ebl(data)                                           ((0x00800000&(data))>>23)
+#define TVE_CGMS_CTRL_write_en2_shift                                                (22)
+#define TVE_CGMS_CTRL_write_en2_mask                                                 (0x00400000)
+#define TVE_CGMS_CTRL_write_en2(data)                                                (0x00400000&((data)<<22))
+#define TVE_CGMS_CTRL_write_en2_src(data)                                            ((0x00400000&(data))>>22)
+#define TVE_CGMS_CTRL_get_write_en2(data)                                            ((0x00400000&(data))>>22)
+#define TVE_CGMS_CTRL_cgms_p_ebl_shift                                               (21)
+#define TVE_CGMS_CTRL_cgms_p_ebl_mask                                                (0x00200000)
+#define TVE_CGMS_CTRL_cgms_p_ebl(data)                                               (0x00200000&((data)<<21))
+#define TVE_CGMS_CTRL_cgms_p_ebl_src(data)                                           ((0x00200000&(data))>>21)
+#define TVE_CGMS_CTRL_get_cgms_p_ebl(data)                                           ((0x00200000&(data))>>21)
+#define TVE_CGMS_CTRL_write_en1_shift                                                (20)
+#define TVE_CGMS_CTRL_write_en1_mask                                                 (0x00100000)
+#define TVE_CGMS_CTRL_write_en1(data)                                                (0x00100000&((data)<<20))
+#define TVE_CGMS_CTRL_write_en1_src(data)                                            ((0x00100000&(data))>>20)
+#define TVE_CGMS_CTRL_get_write_en1(data)                                            ((0x00100000&(data))>>20)
+#define TVE_CGMS_CTRL_cgms_data_shift                                                (0)
+#define TVE_CGMS_CTRL_cgms_data_mask                                                 (0x000FFFFF)
+#define TVE_CGMS_CTRL_cgms_data(data)                                                (0x000FFFFF&((data)<<0))
+#define TVE_CGMS_CTRL_cgms_data_src(data)                                            ((0x000FFFFF&(data))>>0)
+#define TVE_CGMS_CTRL_get_cgms_data(data)                                            ((0x000FFFFF&(data))>>0)
+
+
+#define TVE_CGMS_CTRL1                                                               0x18018310
+#define TVE_CGMS_CTRL1_reg_addr                                                      "0xB8018310"
+#define TVE_CGMS_CTRL1_reg                                                           0xB8018310
+#define set_TVE_CGMS_CTRL1_reg(data)   (*((volatile unsigned int*) TVE_CGMS_CTRL1_reg)=data)
+#define get_TVE_CGMS_CTRL1_reg   (*((volatile unsigned int*) TVE_CGMS_CTRL1_reg))
+#define TVE_CGMS_CTRL1_inst_adr                                                      "0x00C4"
+#define TVE_CGMS_CTRL1_inst                                                          0x00C4
+#define TVE_CGMS_CTRL1_cgms_data_shift                                               (0)
+#define TVE_CGMS_CTRL1_cgms_data_mask                                                (0x000FFFFF)
+#define TVE_CGMS_CTRL1_cgms_data(data)                                               (0x000FFFFF&((data)<<0))
+#define TVE_CGMS_CTRL1_cgms_data_src(data)                                           ((0x000FFFFF&(data))>>0)
+#define TVE_CGMS_CTRL1_get_cgms_data(data)                                           ((0x000FFFFF&(data))>>0)
+
+
+#define TVE_CGMS_I_VPOS                                                              0x18018164
+#define TVE_CGMS_I_VPOS_reg_addr                                                     "0xB8018164"
+#define TVE_CGMS_I_VPOS_reg                                                          0xB8018164
+#define set_TVE_CGMS_I_VPOS_reg(data)   (*((volatile unsigned int*) TVE_CGMS_I_VPOS_reg)=data)
+#define get_TVE_CGMS_I_VPOS_reg   (*((volatile unsigned int*) TVE_CGMS_I_VPOS_reg))
+#define TVE_CGMS_I_VPOS_inst_adr                                                     "0x0059"
+#define TVE_CGMS_I_VPOS_inst                                                         0x0059
+#define TVE_CGMS_I_VPOS_write_en2_shift                                              (20)
+#define TVE_CGMS_I_VPOS_write_en2_mask                                               (0x00100000)
+#define TVE_CGMS_I_VPOS_write_en2(data)                                              (0x00100000&((data)<<20))
+#define TVE_CGMS_I_VPOS_write_en2_src(data)                                          ((0x00100000&(data))>>20)
+#define TVE_CGMS_I_VPOS_get_write_en2(data)                                          ((0x00100000&(data))>>20)
+#define TVE_CGMS_I_VPOS_cgms_i_vpos1_shift                                           (11)
+#define TVE_CGMS_I_VPOS_cgms_i_vpos1_mask                                            (0x000FF800)
+#define TVE_CGMS_I_VPOS_cgms_i_vpos1(data)                                           (0x000FF800&((data)<<11))
+#define TVE_CGMS_I_VPOS_cgms_i_vpos1_src(data)                                       ((0x000FF800&(data))>>11)
+#define TVE_CGMS_I_VPOS_get_cgms_i_vpos1(data)                                       ((0x000FF800&(data))>>11)
+#define TVE_CGMS_I_VPOS_write_en1_shift                                              (10)
+#define TVE_CGMS_I_VPOS_write_en1_mask                                               (0x00000400)
+#define TVE_CGMS_I_VPOS_write_en1(data)                                              (0x00000400&((data)<<10))
+#define TVE_CGMS_I_VPOS_write_en1_src(data)                                          ((0x00000400&(data))>>10)
+#define TVE_CGMS_I_VPOS_get_write_en1(data)                                          ((0x00000400&(data))>>10)
+#define TVE_CGMS_I_VPOS_cgms_i_vpos2_shift                                           (0)
+#define TVE_CGMS_I_VPOS_cgms_i_vpos2_mask                                            (0x000003FF)
+#define TVE_CGMS_I_VPOS_cgms_i_vpos2(data)                                           (0x000003FF&((data)<<0))
+#define TVE_CGMS_I_VPOS_cgms_i_vpos2_src(data)                                       ((0x000003FF&(data))>>0)
+#define TVE_CGMS_I_VPOS_get_cgms_i_vpos2(data)                                       ((0x000003FF&(data))>>0)
+
+
+#define TVE_CGMS_P_VPOS                                                              0x18018168
+#define TVE_CGMS_P_VPOS_reg_addr                                                     "0xB8018168"
+#define TVE_CGMS_P_VPOS_reg                                                          0xB8018168
+#define set_TVE_CGMS_P_VPOS_reg(data)   (*((volatile unsigned int*) TVE_CGMS_P_VPOS_reg)=data)
+#define get_TVE_CGMS_P_VPOS_reg   (*((volatile unsigned int*) TVE_CGMS_P_VPOS_reg))
+#define TVE_CGMS_P_VPOS_inst_adr                                                     "0x005A"
+#define TVE_CGMS_P_VPOS_inst                                                         0x005A
+#define TVE_CGMS_P_VPOS_write_en2_shift                                              (22)
+#define TVE_CGMS_P_VPOS_write_en2_mask                                               (0x00400000)
+#define TVE_CGMS_P_VPOS_write_en2(data)                                              (0x00400000&((data)<<22))
+#define TVE_CGMS_P_VPOS_write_en2_src(data)                                          ((0x00400000&(data))>>22)
+#define TVE_CGMS_P_VPOS_get_write_en2(data)                                          ((0x00400000&(data))>>22)
+#define TVE_CGMS_P_VPOS_cgms_p_vpos2_shift                                           (11)
+#define TVE_CGMS_P_VPOS_cgms_p_vpos2_mask                                            (0x003FF800)
+#define TVE_CGMS_P_VPOS_cgms_p_vpos2(data)                                           (0x003FF800&((data)<<11))
+#define TVE_CGMS_P_VPOS_cgms_p_vpos2_src(data)                                       ((0x003FF800&(data))>>11)
+#define TVE_CGMS_P_VPOS_get_cgms_p_vpos2(data)                                       ((0x003FF800&(data))>>11)
+#define TVE_CGMS_P_VPOS_write_en1_shift                                              (10)
+#define TVE_CGMS_P_VPOS_write_en1_mask                                               (0x00000400)
+#define TVE_CGMS_P_VPOS_write_en1(data)                                              (0x00000400&((data)<<10))
+#define TVE_CGMS_P_VPOS_write_en1_src(data)                                          ((0x00000400&(data))>>10)
+#define TVE_CGMS_P_VPOS_get_write_en1(data)                                          ((0x00000400&(data))>>10)
+#define TVE_CGMS_P_VPOS_cgms_p_vpos1_shift                                           (0)
+#define TVE_CGMS_P_VPOS_cgms_p_vpos1_mask                                            (0x000003FF)
+#define TVE_CGMS_P_VPOS_cgms_p_vpos1(data)                                           (0x000003FF&((data)<<0))
+#define TVE_CGMS_P_VPOS_cgms_p_vpos1_src(data)                                       ((0x000003FF&(data))>>0)
+#define TVE_CGMS_P_VPOS_get_cgms_p_vpos1(data)                                       ((0x000003FF&(data))>>0)
+
+
+#define TVE_CGMS_I_HPOS                                                              0x1801816c
+#define TVE_CGMS_I_HPOS_reg_addr                                                     "0xB801816C"
+#define TVE_CGMS_I_HPOS_reg                                                          0xB801816C
+#define set_TVE_CGMS_I_HPOS_reg(data)   (*((volatile unsigned int*) TVE_CGMS_I_HPOS_reg)=data)
+#define get_TVE_CGMS_I_HPOS_reg   (*((volatile unsigned int*) TVE_CGMS_I_HPOS_reg))
+#define TVE_CGMS_I_HPOS_inst_adr                                                     "0x005B"
+#define TVE_CGMS_I_HPOS_inst                                                         0x005B
+#define TVE_CGMS_I_HPOS_write_en2_shift                                              (21)
+#define TVE_CGMS_I_HPOS_write_en2_mask                                               (0x00200000)
+#define TVE_CGMS_I_HPOS_write_en2(data)                                              (0x00200000&((data)<<21))
+#define TVE_CGMS_I_HPOS_write_en2_src(data)                                          ((0x00200000&(data))>>21)
+#define TVE_CGMS_I_HPOS_get_write_en2(data)                                          ((0x00200000&(data))>>21)
+#define TVE_CGMS_I_HPOS_cgms_i_hst_shift                                             (11)
+#define TVE_CGMS_I_HPOS_cgms_i_hst_mask                                              (0x001FF800)
+#define TVE_CGMS_I_HPOS_cgms_i_hst(data)                                             (0x001FF800&((data)<<11))
+#define TVE_CGMS_I_HPOS_cgms_i_hst_src(data)                                         ((0x001FF800&(data))>>11)
+#define TVE_CGMS_I_HPOS_get_cgms_i_hst(data)                                         ((0x001FF800&(data))>>11)
+#define TVE_CGMS_I_HPOS_write_en1_shift                                              (10)
+#define TVE_CGMS_I_HPOS_write_en1_mask                                               (0x00000400)
+#define TVE_CGMS_I_HPOS_write_en1(data)                                              (0x00000400&((data)<<10))
+#define TVE_CGMS_I_HPOS_write_en1_src(data)                                          ((0x00000400&(data))>>10)
+#define TVE_CGMS_I_HPOS_get_write_en1(data)                                          ((0x00000400&(data))>>10)
+#define TVE_CGMS_I_HPOS_cgms_i_len_shift                                             (0)
+#define TVE_CGMS_I_HPOS_cgms_i_len_mask                                              (0x000003FF)
+#define TVE_CGMS_I_HPOS_cgms_i_len(data)                                             (0x000003FF&((data)<<0))
+#define TVE_CGMS_I_HPOS_cgms_i_len_src(data)                                         ((0x000003FF&(data))>>0)
+#define TVE_CGMS_I_HPOS_get_cgms_i_len(data)                                         ((0x000003FF&(data))>>0)
+
+
+#define TVE_CGMS_P_HPOS                                                              0x18018170
+#define TVE_CGMS_P_HPOS_reg_addr                                                     "0xB8018170"
+#define TVE_CGMS_P_HPOS_reg                                                          0xB8018170
+#define set_TVE_CGMS_P_HPOS_reg(data)   (*((volatile unsigned int*) TVE_CGMS_P_HPOS_reg)=data)
+#define get_TVE_CGMS_P_HPOS_reg   (*((volatile unsigned int*) TVE_CGMS_P_HPOS_reg))
+#define TVE_CGMS_P_HPOS_inst_adr                                                     "0x005C"
+#define TVE_CGMS_P_HPOS_inst                                                         0x005C
+#define TVE_CGMS_P_HPOS_write_en3_shift                                              (30)
+#define TVE_CGMS_P_HPOS_write_en3_mask                                               (0x40000000)
+#define TVE_CGMS_P_HPOS_write_en3(data)                                              (0x40000000&((data)<<30))
+#define TVE_CGMS_P_HPOS_write_en3_src(data)                                          ((0x40000000&(data))>>30)
+#define TVE_CGMS_P_HPOS_get_write_en3(data)                                          ((0x40000000&(data))>>30)
+#define TVE_CGMS_P_HPOS_cgms_p_lvl_shift                                             (22)
+#define TVE_CGMS_P_HPOS_cgms_p_lvl_mask                                              (0x3FC00000)
+#define TVE_CGMS_P_HPOS_cgms_p_lvl(data)                                             (0x3FC00000&((data)<<22))
+#define TVE_CGMS_P_HPOS_cgms_p_lvl_src(data)                                         ((0x3FC00000&(data))>>22)
+#define TVE_CGMS_P_HPOS_get_cgms_p_lvl(data)                                         ((0x3FC00000&(data))>>22)
+#define TVE_CGMS_P_HPOS_write_en2_shift                                              (21)
+#define TVE_CGMS_P_HPOS_write_en2_mask                                               (0x00200000)
+#define TVE_CGMS_P_HPOS_write_en2(data)                                              (0x00200000&((data)<<21))
+#define TVE_CGMS_P_HPOS_write_en2_src(data)                                          ((0x00200000&(data))>>21)
+#define TVE_CGMS_P_HPOS_get_write_en2(data)                                          ((0x00200000&(data))>>21)
+#define TVE_CGMS_P_HPOS_cgms_p_hst_shift                                             (11)
+#define TVE_CGMS_P_HPOS_cgms_p_hst_mask                                              (0x001FF800)
+#define TVE_CGMS_P_HPOS_cgms_p_hst(data)                                             (0x001FF800&((data)<<11))
+#define TVE_CGMS_P_HPOS_cgms_p_hst_src(data)                                         ((0x001FF800&(data))>>11)
+#define TVE_CGMS_P_HPOS_get_cgms_p_hst(data)                                         ((0x001FF800&(data))>>11)
+#define TVE_CGMS_P_HPOS_write_en1_shift                                              (10)
+#define TVE_CGMS_P_HPOS_write_en1_mask                                               (0x00000400)
+#define TVE_CGMS_P_HPOS_write_en1(data)                                              (0x00000400&((data)<<10))
+#define TVE_CGMS_P_HPOS_write_en1_src(data)                                          ((0x00000400&(data))>>10)
+#define TVE_CGMS_P_HPOS_get_write_en1(data)                                          ((0x00000400&(data))>>10)
+#define TVE_CGMS_P_HPOS_cgms_p_len_shift                                             (0)
+#define TVE_CGMS_P_HPOS_cgms_p_len_mask                                              (0x000003FF)
+#define TVE_CGMS_P_HPOS_cgms_p_len(data)                                             (0x000003FF&((data)<<0))
+#define TVE_CGMS_P_HPOS_cgms_p_len_src(data)                                         ((0x000003FF&(data))>>0)
+#define TVE_CGMS_P_HPOS_get_cgms_p_len(data)                                         ((0x000003FF&(data))>>0)
+
+
+#define TVE_CGMS_P2_VPOS                                                             0x18018384
+#define TVE_CGMS_P2_VPOS_reg_addr                                                    "0xB8018384"
+#define TVE_CGMS_P2_VPOS_reg                                                         0xB8018384
+#define set_TVE_CGMS_P2_VPOS_reg(data)   (*((volatile unsigned int*) TVE_CGMS_P2_VPOS_reg)=data)
+#define get_TVE_CGMS_P2_VPOS_reg   (*((volatile unsigned int*) TVE_CGMS_P2_VPOS_reg))
+#define TVE_CGMS_P2_VPOS_inst_adr                                                    "0x00E1"
+#define TVE_CGMS_P2_VPOS_inst                                                        0x00E1
+#define TVE_CGMS_P2_VPOS_write_en3_shift                                             (24)
+#define TVE_CGMS_P2_VPOS_write_en3_mask                                              (0x01000000)
+#define TVE_CGMS_P2_VPOS_write_en3(data)                                             (0x01000000&((data)<<24))
+#define TVE_CGMS_P2_VPOS_write_en3_src(data)                                         ((0x01000000&(data))>>24)
+#define TVE_CGMS_P2_VPOS_get_write_en3(data)                                         ((0x01000000&(data))>>24)
+#define TVE_CGMS_P2_VPOS_cgms_p_b_ebl_shift                                          (23)
+#define TVE_CGMS_P2_VPOS_cgms_p_b_ebl_mask                                           (0x00800000)
+#define TVE_CGMS_P2_VPOS_cgms_p_b_ebl(data)                                          (0x00800000&((data)<<23))
+#define TVE_CGMS_P2_VPOS_cgms_p_b_ebl_src(data)                                      ((0x00800000&(data))>>23)
+#define TVE_CGMS_P2_VPOS_get_cgms_p_b_ebl(data)                                      ((0x00800000&(data))>>23)
+#define TVE_CGMS_P2_VPOS_write_en2_shift                                             (22)
+#define TVE_CGMS_P2_VPOS_write_en2_mask                                              (0x00400000)
+#define TVE_CGMS_P2_VPOS_write_en2(data)                                             (0x00400000&((data)<<22))
+#define TVE_CGMS_P2_VPOS_write_en2_src(data)                                         ((0x00400000&(data))>>22)
+#define TVE_CGMS_P2_VPOS_get_write_en2(data)                                         ((0x00400000&(data))>>22)
+#define TVE_CGMS_P2_VPOS_cgms_p2_vpos2_shift                                         (11)
+#define TVE_CGMS_P2_VPOS_cgms_p2_vpos2_mask                                          (0x003FF800)
+#define TVE_CGMS_P2_VPOS_cgms_p2_vpos2(data)                                         (0x003FF800&((data)<<11))
+#define TVE_CGMS_P2_VPOS_cgms_p2_vpos2_src(data)                                     ((0x003FF800&(data))>>11)
+#define TVE_CGMS_P2_VPOS_get_cgms_p2_vpos2(data)                                     ((0x003FF800&(data))>>11)
+#define TVE_CGMS_P2_VPOS_write_en1_shift                                             (10)
+#define TVE_CGMS_P2_VPOS_write_en1_mask                                              (0x00000400)
+#define TVE_CGMS_P2_VPOS_write_en1(data)                                             (0x00000400&((data)<<10))
+#define TVE_CGMS_P2_VPOS_write_en1_src(data)                                         ((0x00000400&(data))>>10)
+#define TVE_CGMS_P2_VPOS_get_write_en1(data)                                         ((0x00000400&(data))>>10)
+#define TVE_CGMS_P2_VPOS_cgms_p2_vpos1_shift                                         (0)
+#define TVE_CGMS_P2_VPOS_cgms_p2_vpos1_mask                                          (0x000003FF)
+#define TVE_CGMS_P2_VPOS_cgms_p2_vpos1(data)                                         (0x000003FF&((data)<<0))
+#define TVE_CGMS_P2_VPOS_cgms_p2_vpos1_src(data)                                     ((0x000003FF&(data))>>0)
+#define TVE_CGMS_P2_VPOS_get_cgms_p2_vpos1(data)                                     ((0x000003FF&(data))>>0)
+
+
+#define TVE_CGMS_P2_HPOS                                                             0x18018354
+#define TVE_CGMS_P2_HPOS_reg_addr                                                    "0xB8018354"
+#define TVE_CGMS_P2_HPOS_reg                                                         0xB8018354
+#define set_TVE_CGMS_P2_HPOS_reg(data)   (*((volatile unsigned int*) TVE_CGMS_P2_HPOS_reg)=data)
+#define get_TVE_CGMS_P2_HPOS_reg   (*((volatile unsigned int*) TVE_CGMS_P2_HPOS_reg))
+#define TVE_CGMS_P2_HPOS_inst_adr                                                    "0x00D5"
+#define TVE_CGMS_P2_HPOS_inst                                                        0x00D5
+#define TVE_CGMS_P2_HPOS_write_en3_shift                                             (30)
+#define TVE_CGMS_P2_HPOS_write_en3_mask                                              (0x40000000)
+#define TVE_CGMS_P2_HPOS_write_en3(data)                                             (0x40000000&((data)<<30))
+#define TVE_CGMS_P2_HPOS_write_en3_src(data)                                         ((0x40000000&(data))>>30)
+#define TVE_CGMS_P2_HPOS_get_write_en3(data)                                         ((0x40000000&(data))>>30)
+#define TVE_CGMS_P2_HPOS_cgms_p2_lvl_shift                                           (22)
+#define TVE_CGMS_P2_HPOS_cgms_p2_lvl_mask                                            (0x3FC00000)
+#define TVE_CGMS_P2_HPOS_cgms_p2_lvl(data)                                           (0x3FC00000&((data)<<22))
+#define TVE_CGMS_P2_HPOS_cgms_p2_lvl_src(data)                                       ((0x3FC00000&(data))>>22)
+#define TVE_CGMS_P2_HPOS_get_cgms_p2_lvl(data)                                       ((0x3FC00000&(data))>>22)
+#define TVE_CGMS_P2_HPOS_write_en2_shift                                             (21)
+#define TVE_CGMS_P2_HPOS_write_en2_mask                                              (0x00200000)
+#define TVE_CGMS_P2_HPOS_write_en2(data)                                             (0x00200000&((data)<<21))
+#define TVE_CGMS_P2_HPOS_write_en2_src(data)                                         ((0x00200000&(data))>>21)
+#define TVE_CGMS_P2_HPOS_get_write_en2(data)                                         ((0x00200000&(data))>>21)
+#define TVE_CGMS_P2_HPOS_cgms_p2_hst_shift                                           (11)
+#define TVE_CGMS_P2_HPOS_cgms_p2_hst_mask                                            (0x001FF800)
+#define TVE_CGMS_P2_HPOS_cgms_p2_hst(data)                                           (0x001FF800&((data)<<11))
+#define TVE_CGMS_P2_HPOS_cgms_p2_hst_src(data)                                       ((0x001FF800&(data))>>11)
+#define TVE_CGMS_P2_HPOS_get_cgms_p2_hst(data)                                       ((0x001FF800&(data))>>11)
+#define TVE_CGMS_P2_HPOS_write_en1_shift                                             (10)
+#define TVE_CGMS_P2_HPOS_write_en1_mask                                              (0x00000400)
+#define TVE_CGMS_P2_HPOS_write_en1(data)                                             (0x00000400&((data)<<10))
+#define TVE_CGMS_P2_HPOS_write_en1_src(data)                                         ((0x00000400&(data))>>10)
+#define TVE_CGMS_P2_HPOS_get_write_en1(data)                                         ((0x00000400&(data))>>10)
+#define TVE_CGMS_P2_HPOS_cgms_p2_len_shift                                           (0)
+#define TVE_CGMS_P2_HPOS_cgms_p2_len_mask                                            (0x000003FF)
+#define TVE_CGMS_P2_HPOS_cgms_p2_len(data)                                           (0x000003FF&((data)<<0))
+#define TVE_CGMS_P2_HPOS_cgms_p2_len_src(data)                                       ((0x000003FF&(data))>>0)
+#define TVE_CGMS_P2_HPOS_get_cgms_p2_len(data)                                       ((0x000003FF&(data))>>0)
+
+
+#define TVE_CGMS_B_HDR                                                               0x18018358
+#define TVE_CGMS_B_HDR_reg_addr                                                      "0xB8018358"
+#define TVE_CGMS_B_HDR_reg                                                           0xB8018358
+#define set_TVE_CGMS_B_HDR_reg(data)   (*((volatile unsigned int*) TVE_CGMS_B_HDR_reg)=data)
+#define get_TVE_CGMS_B_HDR_reg   (*((volatile unsigned int*) TVE_CGMS_B_HDR_reg))
+#define TVE_CGMS_B_HDR_inst_adr                                                      "0x00D6"
+#define TVE_CGMS_B_HDR_inst                                                          0x00D6
+#define TVE_CGMS_B_HDR_cgms_hdr_shift                                                (0)
+#define TVE_CGMS_B_HDR_cgms_hdr_mask                                                 (0x0000003F)
+#define TVE_CGMS_B_HDR_cgms_hdr(data)                                                (0x0000003F&((data)<<0))
+#define TVE_CGMS_B_HDR_cgms_hdr_src(data)                                            ((0x0000003F&(data))>>0)
+#define TVE_CGMS_B_HDR_get_cgms_hdr(data)                                            ((0x0000003F&(data))>>0)
+
+
+#define TVE_CGMS_B_DATA_0                                                            0x1801835C
+#define TVE_CGMS_B_DATA_1                                                            0x18018360
+#define TVE_CGMS_B_DATA_2                                                            0x18018364
+#define TVE_CGMS_B_DATA_3                                                            0x18018368
+#define TVE_CGMS_B_DATA_0_reg_addr                                                   "0xB801835C"
+#define TVE_CGMS_B_DATA_1_reg_addr                                                   "0xB8018360"
+#define TVE_CGMS_B_DATA_2_reg_addr                                                   "0xB8018364"
+#define TVE_CGMS_B_DATA_3_reg_addr                                                   "0xB8018368"
+#define TVE_CGMS_B_DATA_0_reg                                                        0xB801835C
+#define TVE_CGMS_B_DATA_1_reg                                                        0xB8018360
+#define TVE_CGMS_B_DATA_2_reg                                                        0xB8018364
+#define TVE_CGMS_B_DATA_3_reg                                                        0xB8018368
+#define set_TVE_CGMS_B_DATA_0_reg(data)   (*((volatile unsigned int*) TVE_CGMS_B_DATA_0_reg)=data)
+#define set_TVE_CGMS_B_DATA_1_reg(data)   (*((volatile unsigned int*) TVE_CGMS_B_DATA_1_reg)=data)
+#define set_TVE_CGMS_B_DATA_2_reg(data)   (*((volatile unsigned int*) TVE_CGMS_B_DATA_2_reg)=data)
+#define set_TVE_CGMS_B_DATA_3_reg(data)   (*((volatile unsigned int*) TVE_CGMS_B_DATA_3_reg)=data)
+#define get_TVE_CGMS_B_DATA_0_reg   (*((volatile unsigned int*) TVE_CGMS_B_DATA_0_reg))
+#define get_TVE_CGMS_B_DATA_1_reg   (*((volatile unsigned int*) TVE_CGMS_B_DATA_1_reg))
+#define get_TVE_CGMS_B_DATA_2_reg   (*((volatile unsigned int*) TVE_CGMS_B_DATA_2_reg))
+#define get_TVE_CGMS_B_DATA_3_reg   (*((volatile unsigned int*) TVE_CGMS_B_DATA_3_reg))
+#define TVE_CGMS_B_DATA_0_inst_adr                                                   "0x00D7"
+#define TVE_CGMS_B_DATA_1_inst_adr                                                   "0x00D8"
+#define TVE_CGMS_B_DATA_2_inst_adr                                                   "0x00D9"
+#define TVE_CGMS_B_DATA_3_inst_adr                                                   "0x00DA"
+#define TVE_CGMS_B_DATA_0_inst                                                       0x00D7
+#define TVE_CGMS_B_DATA_1_inst                                                       0x00D8
+#define TVE_CGMS_B_DATA_2_inst                                                       0x00D9
+#define TVE_CGMS_B_DATA_3_inst                                                       0x00DA
+#define TVE_CGMS_B_DATA_cgms_data_shift                                              (0)
+#define TVE_CGMS_B_DATA_cgms_data_mask                                               (0xFFFFFFFF)
+#define TVE_CGMS_B_DATA_cgms_data(data)                                              (0xFFFFFFFF&((data)<<0))
+#define TVE_CGMS_B_DATA_cgms_data_src(data)                                          ((0xFFFFFFFF&(data))>>0)
+#define TVE_CGMS_B_DATA_get_cgms_data(data)                                          ((0xFFFFFFFF&(data))>>0)
+
+
+#define TVE_WSS_CTRL                                                                 0x18018174
+#define TVE_WSS_CTRL_reg_addr                                                        "0xB8018174"
+#define TVE_WSS_CTRL_reg                                                             0xB8018174
+#define set_TVE_WSS_CTRL_reg(data)   (*((volatile unsigned int*) TVE_WSS_CTRL_reg)=data)
+#define get_TVE_WSS_CTRL_reg   (*((volatile unsigned int*) TVE_WSS_CTRL_reg))
+#define TVE_WSS_CTRL_inst_adr                                                        "0x005D"
+#define TVE_WSS_CTRL_inst                                                            0x005D
+#define TVE_WSS_CTRL_write_en4_shift                                                 (30)
+#define TVE_WSS_CTRL_write_en4_mask                                                  (0x40000000)
+#define TVE_WSS_CTRL_write_en4(data)                                                 (0x40000000&((data)<<30))
+#define TVE_WSS_CTRL_write_en4_src(data)                                             ((0x40000000&(data))>>30)
+#define TVE_WSS_CTRL_get_write_en4(data)                                             ((0x40000000&(data))>>30)
+#define TVE_WSS_CTRL_wss_ebl_shift                                                   (29)
+#define TVE_WSS_CTRL_wss_ebl_mask                                                    (0x20000000)
+#define TVE_WSS_CTRL_wss_ebl(data)                                                   (0x20000000&((data)<<29))
+#define TVE_WSS_CTRL_wss_ebl_src(data)                                               ((0x20000000&(data))>>29)
+#define TVE_WSS_CTRL_get_wss_ebl(data)                                               ((0x20000000&(data))>>29)
+#define TVE_WSS_CTRL_write_en3_shift                                                 (28)
+#define TVE_WSS_CTRL_write_en3_mask                                                  (0x10000000)
+#define TVE_WSS_CTRL_write_en3(data)                                                 (0x10000000&((data)<<28))
+#define TVE_WSS_CTRL_write_en3_src(data)                                             ((0x10000000&(data))>>28)
+#define TVE_WSS_CTRL_get_write_en3(data)                                             ((0x10000000&(data))>>28)
+#define TVE_WSS_CTRL_wss_intp_sel_shift                                              (27)
+#define TVE_WSS_CTRL_wss_intp_sel_mask                                               (0x08000000)
+#define TVE_WSS_CTRL_wss_intp_sel(data)                                              (0x08000000&((data)<<27))
+#define TVE_WSS_CTRL_wss_intp_sel_src(data)                                          ((0x08000000&(data))>>27)
+#define TVE_WSS_CTRL_get_wss_intp_sel(data)                                          ((0x08000000&(data))>>27)
+#define TVE_WSS_CTRL_write_en2_shift                                                 (26)
+#define TVE_WSS_CTRL_write_en2_mask                                                  (0x04000000)
+#define TVE_WSS_CTRL_write_en2(data)                                                 (0x04000000&((data)<<26))
+#define TVE_WSS_CTRL_write_en2_src(data)                                             ((0x04000000&(data))>>26)
+#define TVE_WSS_CTRL_get_write_en2(data)                                             ((0x04000000&(data))>>26)
+#define TVE_WSS_CTRL_wss_end_hpos_shift                                              (15)
+#define TVE_WSS_CTRL_wss_end_hpos_mask                                               (0x03FF8000)
+#define TVE_WSS_CTRL_wss_end_hpos(data)                                              (0x03FF8000&((data)<<15))
+#define TVE_WSS_CTRL_wss_end_hpos_src(data)                                          ((0x03FF8000&(data))>>15)
+#define TVE_WSS_CTRL_get_wss_end_hpos(data)                                          ((0x03FF8000&(data))>>15)
+#define TVE_WSS_CTRL_write_en1_shift                                                 (14)
+#define TVE_WSS_CTRL_write_en1_mask                                                  (0x00004000)
+#define TVE_WSS_CTRL_write_en1(data)                                                 (0x00004000&((data)<<14))
+#define TVE_WSS_CTRL_write_en1_src(data)                                             ((0x00004000&(data))>>14)
+#define TVE_WSS_CTRL_get_write_en1(data)                                             ((0x00004000&(data))>>14)
+#define TVE_WSS_CTRL_wss_data_shift                                                  (0)
+#define TVE_WSS_CTRL_wss_data_mask                                                   (0x00003FFF)
+#define TVE_WSS_CTRL_wss_data(data)                                                  (0x00003FFF&((data)<<0))
+#define TVE_WSS_CTRL_wss_data_src(data)                                              ((0x00003FFF&(data))>>0)
+#define TVE_WSS_CTRL_get_wss_data(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define TVE_WSS_POS                                                                  0x18018178
+#define TVE_WSS_POS_reg_addr                                                         "0xB8018178"
+#define TVE_WSS_POS_reg                                                              0xB8018178
+#define set_TVE_WSS_POS_reg(data)   (*((volatile unsigned int*) TVE_WSS_POS_reg)=data)
+#define get_TVE_WSS_POS_reg   (*((volatile unsigned int*) TVE_WSS_POS_reg))
+#define TVE_WSS_POS_inst_adr                                                         "0x005E"
+#define TVE_WSS_POS_inst                                                             0x005E
+#define TVE_WSS_POS_write_en2_shift                                                  (22)
+#define TVE_WSS_POS_write_en2_mask                                                   (0x00400000)
+#define TVE_WSS_POS_write_en2(data)                                                  (0x00400000&((data)<<22))
+#define TVE_WSS_POS_write_en2_src(data)                                              ((0x00400000&(data))>>22)
+#define TVE_WSS_POS_get_write_en2(data)                                              ((0x00400000&(data))>>22)
+#define TVE_WSS_POS_wss_h_pos_shift                                                  (11)
+#define TVE_WSS_POS_wss_h_pos_mask                                                   (0x003FF800)
+#define TVE_WSS_POS_wss_h_pos(data)                                                  (0x003FF800&((data)<<11))
+#define TVE_WSS_POS_wss_h_pos_src(data)                                              ((0x003FF800&(data))>>11)
+#define TVE_WSS_POS_get_wss_h_pos(data)                                              ((0x003FF800&(data))>>11)
+#define TVE_WSS_POS_write_en1_shift                                                  (10)
+#define TVE_WSS_POS_write_en1_mask                                                   (0x00000400)
+#define TVE_WSS_POS_write_en1(data)                                                  (0x00000400&((data)<<10))
+#define TVE_WSS_POS_write_en1_src(data)                                              ((0x00000400&(data))>>10)
+#define TVE_WSS_POS_get_write_en1(data)                                              ((0x00000400&(data))>>10)
+#define TVE_WSS_POS_wss_v_pos_shift                                                  (0)
+#define TVE_WSS_POS_wss_v_pos_mask                                                   (0x000003FF)
+#define TVE_WSS_POS_wss_v_pos(data)                                                  (0x000003FF&((data)<<0))
+#define TVE_WSS_POS_wss_v_pos_src(data)                                              ((0x000003FF&(data))>>0)
+#define TVE_WSS_POS_get_wss_v_pos(data)                                              ((0x000003FF&(data))>>0)
+
+
+#define TVE_625P_WSS_CTRL                                                            0x1801817c
+#define TVE_625P_WSS_CTRL_reg_addr                                                   "0xB801817C"
+#define TVE_625P_WSS_CTRL_reg                                                        0xB801817C
+#define set_TVE_625P_WSS_CTRL_reg(data)   (*((volatile unsigned int*) TVE_625P_WSS_CTRL_reg)=data)
+#define get_TVE_625P_WSS_CTRL_reg   (*((volatile unsigned int*) TVE_625P_WSS_CTRL_reg))
+#define TVE_625P_WSS_CTRL_inst_adr                                                   "0x005F"
+#define TVE_625P_WSS_CTRL_inst                                                       0x005F
+#define TVE_625P_WSS_CTRL_write_en3_shift                                            (18)
+#define TVE_625P_WSS_CTRL_write_en3_mask                                             (0x00040000)
+#define TVE_625P_WSS_CTRL_write_en3(data)                                            (0x00040000&((data)<<18))
+#define TVE_625P_WSS_CTRL_write_en3_src(data)                                        ((0x00040000&(data))>>18)
+#define TVE_625P_WSS_CTRL_get_write_en3(data)                                        ((0x00040000&(data))>>18)
+#define TVE_625P_WSS_CTRL_wss_ebl_shift                                              (17)
+#define TVE_625P_WSS_CTRL_wss_ebl_mask                                               (0x00020000)
+#define TVE_625P_WSS_CTRL_wss_ebl(data)                                              (0x00020000&((data)<<17))
+#define TVE_625P_WSS_CTRL_wss_ebl_src(data)                                          ((0x00020000&(data))>>17)
+#define TVE_625P_WSS_CTRL_get_wss_ebl(data)                                          ((0x00020000&(data))>>17)
+#define TVE_625P_WSS_CTRL_write_en2_shift                                            (16)
+#define TVE_625P_WSS_CTRL_write_en2_mask                                             (0x00010000)
+#define TVE_625P_WSS_CTRL_write_en2(data)                                            (0x00010000&((data)<<16))
+#define TVE_625P_WSS_CTRL_write_en2_src(data)                                        ((0x00010000&(data))>>16)
+#define TVE_625P_WSS_CTRL_get_write_en2(data)                                        ((0x00010000&(data))>>16)
+#define TVE_625P_WSS_CTRL_wss_intp_sel_shift                                         (15)
+#define TVE_625P_WSS_CTRL_wss_intp_sel_mask                                          (0x00008000)
+#define TVE_625P_WSS_CTRL_wss_intp_sel(data)                                         (0x00008000&((data)<<15))
+#define TVE_625P_WSS_CTRL_wss_intp_sel_src(data)                                     ((0x00008000&(data))>>15)
+#define TVE_625P_WSS_CTRL_get_wss_intp_sel(data)                                     ((0x00008000&(data))>>15)
+#define TVE_625P_WSS_CTRL_write_en1_shift                                            (14)
+#define TVE_625P_WSS_CTRL_write_en1_mask                                             (0x00004000)
+#define TVE_625P_WSS_CTRL_write_en1(data)                                            (0x00004000&((data)<<14))
+#define TVE_625P_WSS_CTRL_write_en1_src(data)                                        ((0x00004000&(data))>>14)
+#define TVE_625P_WSS_CTRL_get_write_en1(data)                                        ((0x00004000&(data))>>14)
+#define TVE_625P_WSS_CTRL_wss_data_shift                                             (0)
+#define TVE_625P_WSS_CTRL_wss_data_mask                                              (0x00003FFF)
+#define TVE_625P_WSS_CTRL_wss_data(data)                                             (0x00003FFF&((data)<<0))
+#define TVE_625P_WSS_CTRL_wss_data_src(data)                                         ((0x00003FFF&(data))>>0)
+#define TVE_625P_WSS_CTRL_get_wss_data(data)                                         ((0x00003FFF&(data))>>0)
+
+
+#define TVE_625P_WSS_POS                                                             0x18018180
+#define TVE_625P_WSS_POS_reg_addr                                                    "0xB8018180"
+#define TVE_625P_WSS_POS_reg                                                         0xB8018180
+#define set_TVE_625P_WSS_POS_reg(data)   (*((volatile unsigned int*) TVE_625P_WSS_POS_reg)=data)
+#define get_TVE_625P_WSS_POS_reg   (*((volatile unsigned int*) TVE_625P_WSS_POS_reg))
+#define TVE_625P_WSS_POS_inst_adr                                                    "0x0060"
+#define TVE_625P_WSS_POS_inst                                                        0x0060
+#define TVE_625P_WSS_POS_write_en2_shift                                             (22)
+#define TVE_625P_WSS_POS_write_en2_mask                                              (0x00400000)
+#define TVE_625P_WSS_POS_write_en2(data)                                             (0x00400000&((data)<<22))
+#define TVE_625P_WSS_POS_write_en2_src(data)                                         ((0x00400000&(data))>>22)
+#define TVE_625P_WSS_POS_get_write_en2(data)                                         ((0x00400000&(data))>>22)
+#define TVE_625P_WSS_POS_wss_h_pos_shift                                             (11)
+#define TVE_625P_WSS_POS_wss_h_pos_mask                                              (0x003FF800)
+#define TVE_625P_WSS_POS_wss_h_pos(data)                                             (0x003FF800&((data)<<11))
+#define TVE_625P_WSS_POS_wss_h_pos_src(data)                                         ((0x003FF800&(data))>>11)
+#define TVE_625P_WSS_POS_get_wss_h_pos(data)                                         ((0x003FF800&(data))>>11)
+#define TVE_625P_WSS_POS_write_en1_shift                                             (10)
+#define TVE_625P_WSS_POS_write_en1_mask                                              (0x00000400)
+#define TVE_625P_WSS_POS_write_en1(data)                                             (0x00000400&((data)<<10))
+#define TVE_625P_WSS_POS_write_en1_src(data)                                         ((0x00000400&(data))>>10)
+#define TVE_625P_WSS_POS_get_write_en1(data)                                         ((0x00000400&(data))>>10)
+#define TVE_625P_WSS_POS_wss_v_pos_shift                                             (0)
+#define TVE_625P_WSS_POS_wss_v_pos_mask                                              (0x000003FF)
+#define TVE_625P_WSS_POS_wss_v_pos(data)                                             (0x000003FF&((data)<<0))
+#define TVE_625P_WSS_POS_wss_v_pos_src(data)                                         ((0x000003FF&(data))>>0)
+#define TVE_625P_WSS_POS_get_wss_v_pos(data)                                         ((0x000003FF&(data))>>0)
+
+
+#define TVE_TT_CTRL                                                                  0x18018184
+#define TVE_TT_CTRL_reg_addr                                                         "0xB8018184"
+#define TVE_TT_CTRL_reg                                                              0xB8018184
+#define set_TVE_TT_CTRL_reg(data)   (*((volatile unsigned int*) TVE_TT_CTRL_reg)=data)
+#define get_TVE_TT_CTRL_reg   (*((volatile unsigned int*) TVE_TT_CTRL_reg))
+#define TVE_TT_CTRL_inst_adr                                                         "0x0061"
+#define TVE_TT_CTRL_inst                                                             0x0061
+#define TVE_TT_CTRL_write_en4_shift                                                  (24)
+#define TVE_TT_CTRL_write_en4_mask                                                   (0x01000000)
+#define TVE_TT_CTRL_write_en4(data)                                                  (0x01000000&((data)<<24))
+#define TVE_TT_CTRL_write_en4_src(data)                                              ((0x01000000&(data))>>24)
+#define TVE_TT_CTRL_get_write_en4(data)                                              ((0x01000000&(data))>>24)
+#define TVE_TT_CTRL_tt_h_st_shift                                                    (13)
+#define TVE_TT_CTRL_tt_h_st_mask                                                     (0x00FFE000)
+#define TVE_TT_CTRL_tt_h_st(data)                                                    (0x00FFE000&((data)<<13))
+#define TVE_TT_CTRL_tt_h_st_src(data)                                                ((0x00FFE000&(data))>>13)
+#define TVE_TT_CTRL_get_tt_h_st(data)                                                ((0x00FFE000&(data))>>13)
+#define TVE_TT_CTRL_write_en3_shift                                                  (12)
+#define TVE_TT_CTRL_write_en3_mask                                                   (0x00001000)
+#define TVE_TT_CTRL_write_en3(data)                                                  (0x00001000&((data)<<12))
+#define TVE_TT_CTRL_write_en3_src(data)                                              ((0x00001000&(data))>>12)
+#define TVE_TT_CTRL_get_write_en3(data)                                              ((0x00001000&(data))>>12)
+#define TVE_TT_CTRL_tt_line_no_shift                                                 (4)
+#define TVE_TT_CTRL_tt_line_no_mask                                                  (0x00000FF0)
+#define TVE_TT_CTRL_tt_line_no(data)                                                 (0x00000FF0&((data)<<4))
+#define TVE_TT_CTRL_tt_line_no_src(data)                                             ((0x00000FF0&(data))>>4)
+#define TVE_TT_CTRL_get_tt_line_no(data)                                             ((0x00000FF0&(data))>>4)
+#define TVE_TT_CTRL_write_en2_shift                                                  (3)
+#define TVE_TT_CTRL_write_en2_mask                                                   (0x00000008)
+#define TVE_TT_CTRL_write_en2(data)                                                  (0x00000008&((data)<<3))
+#define TVE_TT_CTRL_write_en2_src(data)                                              ((0x00000008&(data))>>3)
+#define TVE_TT_CTRL_get_write_en2(data)                                              ((0x00000008&(data))>>3)
+#define TVE_TT_CTRL_tt_intp_sel_shift                                                (2)
+#define TVE_TT_CTRL_tt_intp_sel_mask                                                 (0x00000004)
+#define TVE_TT_CTRL_tt_intp_sel(data)                                                (0x00000004&((data)<<2))
+#define TVE_TT_CTRL_tt_intp_sel_src(data)                                            ((0x00000004&(data))>>2)
+#define TVE_TT_CTRL_get_tt_intp_sel(data)                                            ((0x00000004&(data))>>2)
+#define TVE_TT_CTRL_write_en1_shift                                                  (1)
+#define TVE_TT_CTRL_write_en1_mask                                                   (0x00000002)
+#define TVE_TT_CTRL_write_en1(data)                                                  (0x00000002&((data)<<1))
+#define TVE_TT_CTRL_write_en1_src(data)                                              ((0x00000002&(data))>>1)
+#define TVE_TT_CTRL_get_write_en1(data)                                              ((0x00000002&(data))>>1)
+#define TVE_TT_CTRL_vbi_tt_ebl_shift                                                 (0)
+#define TVE_TT_CTRL_vbi_tt_ebl_mask                                                  (0x00000001)
+#define TVE_TT_CTRL_vbi_tt_ebl(data)                                                 (0x00000001&((data)<<0))
+#define TVE_TT_CTRL_vbi_tt_ebl_src(data)                                             ((0x00000001&(data))>>0)
+#define TVE_TT_CTRL_get_vbi_tt_ebl(data)                                             ((0x00000001&(data))>>0)
+
+
+#define TVE_TT_VPOS                                                                  0x18018188
+#define TVE_TT_VPOS_reg_addr                                                         "0xB8018188"
+#define TVE_TT_VPOS_reg                                                              0xB8018188
+#define set_TVE_TT_VPOS_reg(data)   (*((volatile unsigned int*) TVE_TT_VPOS_reg)=data)
+#define get_TVE_TT_VPOS_reg   (*((volatile unsigned int*) TVE_TT_VPOS_reg))
+#define TVE_TT_VPOS_inst_adr                                                         "0x0062"
+#define TVE_TT_VPOS_inst                                                             0x0062
+#define TVE_TT_VPOS_write_en2_shift                                                  (15)
+#define TVE_TT_VPOS_write_en2_mask                                                   (0x00008000)
+#define TVE_TT_VPOS_write_en2(data)                                                  (0x00008000&((data)<<15))
+#define TVE_TT_VPOS_write_en2_src(data)                                              ((0x00008000&(data))>>15)
+#define TVE_TT_VPOS_get_write_en2(data)                                              ((0x00008000&(data))>>15)
+#define TVE_TT_VPOS_tt_b_vst_shift                                                   (6)
+#define TVE_TT_VPOS_tt_b_vst_mask                                                    (0x00007FC0)
+#define TVE_TT_VPOS_tt_b_vst(data)                                                   (0x00007FC0&((data)<<6))
+#define TVE_TT_VPOS_tt_b_vst_src(data)                                               ((0x00007FC0&(data))>>6)
+#define TVE_TT_VPOS_get_tt_b_vst(data)                                               ((0x00007FC0&(data))>>6)
+#define TVE_TT_VPOS_write_en1_shift                                                  (5)
+#define TVE_TT_VPOS_write_en1_mask                                                   (0x00000020)
+#define TVE_TT_VPOS_write_en1(data)                                                  (0x00000020&((data)<<5))
+#define TVE_TT_VPOS_write_en1_src(data)                                              ((0x00000020&(data))>>5)
+#define TVE_TT_VPOS_get_write_en1(data)                                              ((0x00000020&(data))>>5)
+#define TVE_TT_VPOS_tt_t_vst_shift                                                   (0)
+#define TVE_TT_VPOS_tt_t_vst_mask                                                    (0x0000001F)
+#define TVE_TT_VPOS_tt_t_vst(data)                                                   (0x0000001F&((data)<<0))
+#define TVE_TT_VPOS_tt_t_vst_src(data)                                               ((0x0000001F&(data))>>0)
+#define TVE_TT_VPOS_get_tt_t_vst(data)                                               ((0x0000001F&(data))>>0)
+
+
+#define TVE_TT_MASK_VPOS                                                             0x1801818c
+#define TVE_TT_MASK_VPOS_reg_addr                                                    "0xB801818C"
+#define TVE_TT_MASK_VPOS_reg                                                         0xB801818C
+#define set_TVE_TT_MASK_VPOS_reg(data)   (*((volatile unsigned int*) TVE_TT_MASK_VPOS_reg)=data)
+#define get_TVE_TT_MASK_VPOS_reg   (*((volatile unsigned int*) TVE_TT_MASK_VPOS_reg))
+#define TVE_TT_MASK_VPOS_inst_adr                                                    "0x0063"
+#define TVE_TT_MASK_VPOS_inst                                                        0x0063
+#define TVE_TT_MASK_VPOS_write_en2_shift                                             (23)
+#define TVE_TT_MASK_VPOS_write_en2_mask                                              (0x00800000)
+#define TVE_TT_MASK_VPOS_write_en2(data)                                             (0x00800000&((data)<<23))
+#define TVE_TT_MASK_VPOS_write_en2_src(data)                                         ((0x00800000&(data))>>23)
+#define TVE_TT_MASK_VPOS_get_write_en2(data)                                         ((0x00800000&(data))>>23)
+#define TVE_TT_MASK_VPOS_start_line2_shift                                           (12)
+#define TVE_TT_MASK_VPOS_start_line2_mask                                            (0x007FF000)
+#define TVE_TT_MASK_VPOS_start_line2(data)                                           (0x007FF000&((data)<<12))
+#define TVE_TT_MASK_VPOS_start_line2_src(data)                                       ((0x007FF000&(data))>>12)
+#define TVE_TT_MASK_VPOS_get_start_line2(data)                                       ((0x007FF000&(data))>>12)
+#define TVE_TT_MASK_VPOS_write_en1_shift                                             (11)
+#define TVE_TT_MASK_VPOS_write_en1_mask                                              (0x00000800)
+#define TVE_TT_MASK_VPOS_write_en1(data)                                             (0x00000800&((data)<<11))
+#define TVE_TT_MASK_VPOS_write_en1_src(data)                                         ((0x00000800&(data))>>11)
+#define TVE_TT_MASK_VPOS_get_write_en1(data)                                         ((0x00000800&(data))>>11)
+#define TVE_TT_MASK_VPOS_start_line1_shift                                           (0)
+#define TVE_TT_MASK_VPOS_start_line1_mask                                            (0x000007FF)
+#define TVE_TT_MASK_VPOS_start_line1(data)                                           (0x000007FF&((data)<<0))
+#define TVE_TT_MASK_VPOS_start_line1_src(data)                                       ((0x000007FF&(data))>>0)
+#define TVE_TT_MASK_VPOS_get_start_line1(data)                                       ((0x000007FF&(data))>>0)
+
+
+#define TVE_TT_MASK_FLG_0                                                            0x18018190
+#define TVE_TT_MASK_FLG_1                                                            0x18018194
+#define TVE_TT_MASK_FLG_0_reg_addr                                                   "0xB8018190"
+#define TVE_TT_MASK_FLG_1_reg_addr                                                   "0xB8018194"
+#define TVE_TT_MASK_FLG_0_reg                                                        0xB8018190
+#define TVE_TT_MASK_FLG_1_reg                                                        0xB8018194
+#define set_TVE_TT_MASK_FLG_0_reg(data)   (*((volatile unsigned int*) TVE_TT_MASK_FLG_0_reg)=data)
+#define set_TVE_TT_MASK_FLG_1_reg(data)   (*((volatile unsigned int*) TVE_TT_MASK_FLG_1_reg)=data)
+#define get_TVE_TT_MASK_FLG_0_reg   (*((volatile unsigned int*) TVE_TT_MASK_FLG_0_reg))
+#define get_TVE_TT_MASK_FLG_1_reg   (*((volatile unsigned int*) TVE_TT_MASK_FLG_1_reg))
+#define TVE_TT_MASK_FLG_0_inst_adr                                                   "0x0064"
+#define TVE_TT_MASK_FLG_1_inst_adr                                                   "0x0065"
+#define TVE_TT_MASK_FLG_0_inst                                                       0x0064
+#define TVE_TT_MASK_FLG_1_inst                                                       0x0065
+#define TVE_TT_MASK_FLG_tt_line_mask_shift                                           (0)
+#define TVE_TT_MASK_FLG_tt_line_mask_mask                                            (0xFFFFFFFF)
+#define TVE_TT_MASK_FLG_tt_line_mask(data)                                           (0xFFFFFFFF&((data)<<0))
+#define TVE_TT_MASK_FLG_tt_line_mask_src(data)                                       ((0xFFFFFFFF&(data))>>0)
+#define TVE_TT_MASK_FLG_get_tt_line_mask(data)                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define TVE_VPS_CTRL                                                                 0x18018198
+#define TVE_VPS_CTRL_reg_addr                                                        "0xB8018198"
+#define TVE_VPS_CTRL_reg                                                             0xB8018198
+#define set_TVE_VPS_CTRL_reg(data)   (*((volatile unsigned int*) TVE_VPS_CTRL_reg)=data)
+#define get_TVE_VPS_CTRL_reg   (*((volatile unsigned int*) TVE_VPS_CTRL_reg))
+#define TVE_VPS_CTRL_inst_adr                                                        "0x0066"
+#define TVE_VPS_CTRL_inst                                                            0x0066
+#define TVE_VPS_CTRL_write_en4_shift                                                 (26)
+#define TVE_VPS_CTRL_write_en4_mask                                                  (0x04000000)
+#define TVE_VPS_CTRL_write_en4(data)                                                 (0x04000000&((data)<<26))
+#define TVE_VPS_CTRL_write_en4_src(data)                                             ((0x04000000&(data))>>26)
+#define TVE_VPS_CTRL_get_write_en4(data)                                             ((0x04000000&(data))>>26)
+#define TVE_VPS_CTRL_vps_h_pos_shift                                                 (15)
+#define TVE_VPS_CTRL_vps_h_pos_mask                                                  (0x03FF8000)
+#define TVE_VPS_CTRL_vps_h_pos(data)                                                 (0x03FF8000&((data)<<15))
+#define TVE_VPS_CTRL_vps_h_pos_src(data)                                             ((0x03FF8000&(data))>>15)
+#define TVE_VPS_CTRL_get_vps_h_pos(data)                                             ((0x03FF8000&(data))>>15)
+#define TVE_VPS_CTRL_write_en3_shift                                                 (14)
+#define TVE_VPS_CTRL_write_en3_mask                                                  (0x00004000)
+#define TVE_VPS_CTRL_write_en3(data)                                                 (0x00004000&((data)<<14))
+#define TVE_VPS_CTRL_write_en3_src(data)                                             ((0x00004000&(data))>>14)
+#define TVE_VPS_CTRL_get_write_en3(data)                                             ((0x00004000&(data))>>14)
+#define TVE_VPS_CTRL_vps_v_pos_shift                                                 (4)
+#define TVE_VPS_CTRL_vps_v_pos_mask                                                  (0x00003FF0)
+#define TVE_VPS_CTRL_vps_v_pos(data)                                                 (0x00003FF0&((data)<<4))
+#define TVE_VPS_CTRL_vps_v_pos_src(data)                                             ((0x00003FF0&(data))>>4)
+#define TVE_VPS_CTRL_get_vps_v_pos(data)                                             ((0x00003FF0&(data))>>4)
+#define TVE_VPS_CTRL_write_en2_shift                                                 (3)
+#define TVE_VPS_CTRL_write_en2_mask                                                  (0x00000008)
+#define TVE_VPS_CTRL_write_en2(data)                                                 (0x00000008&((data)<<3))
+#define TVE_VPS_CTRL_write_en2_src(data)                                             ((0x00000008&(data))>>3)
+#define TVE_VPS_CTRL_get_write_en2(data)                                             ((0x00000008&(data))>>3)
+#define TVE_VPS_CTRL_vps_intp_sel_shift                                              (2)
+#define TVE_VPS_CTRL_vps_intp_sel_mask                                               (0x00000004)
+#define TVE_VPS_CTRL_vps_intp_sel(data)                                              (0x00000004&((data)<<2))
+#define TVE_VPS_CTRL_vps_intp_sel_src(data)                                          ((0x00000004&(data))>>2)
+#define TVE_VPS_CTRL_get_vps_intp_sel(data)                                          ((0x00000004&(data))>>2)
+#define TVE_VPS_CTRL_write_en1_shift                                                 (1)
+#define TVE_VPS_CTRL_write_en1_mask                                                  (0x00000002)
+#define TVE_VPS_CTRL_write_en1(data)                                                 (0x00000002&((data)<<1))
+#define TVE_VPS_CTRL_write_en1_src(data)                                             ((0x00000002&(data))>>1)
+#define TVE_VPS_CTRL_get_write_en1(data)                                             ((0x00000002&(data))>>1)
+#define TVE_VPS_CTRL_vbi_vps_ebl_shift                                               (0)
+#define TVE_VPS_CTRL_vbi_vps_ebl_mask                                                (0x00000001)
+#define TVE_VPS_CTRL_vbi_vps_ebl(data)                                               (0x00000001&((data)<<0))
+#define TVE_VPS_CTRL_vbi_vps_ebl_src(data)                                           ((0x00000001&(data))>>0)
+#define TVE_VPS_CTRL_get_vbi_vps_ebl(data)                                           ((0x00000001&(data))>>0)
+
+
+#define TVE_VPS_DATA_0                                                               0x180181A0
+#define TVE_VPS_DATA_1                                                               0x180181A4
+#define TVE_VPS_DATA_2                                                               0x180181A8
+#define TVE_VPS_DATA_0_reg_addr                                                      "0xB80181A0"
+#define TVE_VPS_DATA_1_reg_addr                                                      "0xB80181A4"
+#define TVE_VPS_DATA_2_reg_addr                                                      "0xB80181A8"
+#define TVE_VPS_DATA_0_reg                                                           0xB80181A0
+#define TVE_VPS_DATA_1_reg                                                           0xB80181A4
+#define TVE_VPS_DATA_2_reg                                                           0xB80181A8
+#define set_TVE_VPS_DATA_0_reg(data)   (*((volatile unsigned int*) TVE_VPS_DATA_0_reg)=data)
+#define set_TVE_VPS_DATA_1_reg(data)   (*((volatile unsigned int*) TVE_VPS_DATA_1_reg)=data)
+#define set_TVE_VPS_DATA_2_reg(data)   (*((volatile unsigned int*) TVE_VPS_DATA_2_reg)=data)
+#define get_TVE_VPS_DATA_0_reg   (*((volatile unsigned int*) TVE_VPS_DATA_0_reg))
+#define get_TVE_VPS_DATA_1_reg   (*((volatile unsigned int*) TVE_VPS_DATA_1_reg))
+#define get_TVE_VPS_DATA_2_reg   (*((volatile unsigned int*) TVE_VPS_DATA_2_reg))
+#define TVE_VPS_DATA_0_inst_adr                                                      "0x0068"
+#define TVE_VPS_DATA_1_inst_adr                                                      "0x0069"
+#define TVE_VPS_DATA_2_inst_adr                                                      "0x006A"
+#define TVE_VPS_DATA_0_inst                                                          0x0068
+#define TVE_VPS_DATA_1_inst                                                          0x0069
+#define TVE_VPS_DATA_2_inst                                                          0x006A
+#define TVE_VPS_DATA_vps_data_shift                                                  (0)
+#define TVE_VPS_DATA_vps_data_mask                                                   (0xFFFFFFFF)
+#define TVE_VPS_DATA_vps_data(data)                                                  (0xFFFFFFFF&((data)<<0))
+#define TVE_VPS_DATA_vps_data_src(data)                                              ((0xFFFFFFFF&(data))>>0)
+#define TVE_VPS_DATA_get_vps_data(data)                                              ((0xFFFFFFFF&(data))>>0)
+
+
+#define TVE_VPS_DATA1                                                                0x180181ac
+#define TVE_VPS_DATA1_reg_addr                                                       "0xB80181AC"
+#define TVE_VPS_DATA1_reg                                                            0xB80181AC
+#define set_TVE_VPS_DATA1_reg(data)   (*((volatile unsigned int*) TVE_VPS_DATA1_reg)=data)
+#define get_TVE_VPS_DATA1_reg   (*((volatile unsigned int*) TVE_VPS_DATA1_reg))
+#define TVE_VPS_DATA1_inst_adr                                                       "0x006B"
+#define TVE_VPS_DATA1_inst                                                           0x006B
+#define TVE_VPS_DATA1_vps_data_shift                                                 (0)
+#define TVE_VPS_DATA1_vps_data_mask                                                  (0x000000FF)
+#define TVE_VPS_DATA1_vps_data(data)                                                 (0x000000FF&((data)<<0))
+#define TVE_VPS_DATA1_vps_data_src(data)                                             ((0x000000FF&(data))>>0)
+#define TVE_VPS_DATA1_get_vps_data(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define TVE_VBI_DWN_CTRL                                                             0x18018314
+#define TVE_VBI_DWN_CTRL_reg_addr                                                    "0xB8018314"
+#define TVE_VBI_DWN_CTRL_reg                                                         0xB8018314
+#define set_TVE_VBI_DWN_CTRL_reg(data)   (*((volatile unsigned int*) TVE_VBI_DWN_CTRL_reg)=data)
+#define get_TVE_VBI_DWN_CTRL_reg   (*((volatile unsigned int*) TVE_VBI_DWN_CTRL_reg))
+#define TVE_VBI_DWN_CTRL_inst_adr                                                    "0x00C5"
+#define TVE_VBI_DWN_CTRL_inst                                                        0x00C5
+#define TVE_VBI_DWN_CTRL_write_en4_shift                                             (31)
+#define TVE_VBI_DWN_CTRL_write_en4_mask                                              (0x80000000)
+#define TVE_VBI_DWN_CTRL_write_en4(data)                                             (0x80000000&((data)<<31))
+#define TVE_VBI_DWN_CTRL_write_en4_src(data)                                         ((0x80000000&(data))>>31)
+#define TVE_VBI_DWN_CTRL_get_write_en4(data)                                         ((0x80000000&(data))>>31)
+#define TVE_VBI_DWN_CTRL_dwn_ebl_shift                                               (29)
+#define TVE_VBI_DWN_CTRL_dwn_ebl_mask                                                (0x60000000)
+#define TVE_VBI_DWN_CTRL_dwn_ebl(data)                                               (0x60000000&((data)<<29))
+#define TVE_VBI_DWN_CTRL_dwn_ebl_src(data)                                           ((0x60000000&(data))>>29)
+#define TVE_VBI_DWN_CTRL_get_dwn_ebl(data)                                           ((0x60000000&(data))>>29)
+#define TVE_VBI_DWN_CTRL_write_en3_shift                                             (28)
+#define TVE_VBI_DWN_CTRL_write_en3_mask                                              (0x10000000)
+#define TVE_VBI_DWN_CTRL_write_en3(data)                                             (0x10000000&((data)<<28))
+#define TVE_VBI_DWN_CTRL_write_en3_src(data)                                         ((0x10000000&(data))>>28)
+#define TVE_VBI_DWN_CTRL_get_write_en3(data)                                         ((0x10000000&(data))>>28)
+#define TVE_VBI_DWN_CTRL_dwn_i_p_sel_shift                                           (27)
+#define TVE_VBI_DWN_CTRL_dwn_i_p_sel_mask                                            (0x08000000)
+#define TVE_VBI_DWN_CTRL_dwn_i_p_sel(data)                                           (0x08000000&((data)<<27))
+#define TVE_VBI_DWN_CTRL_dwn_i_p_sel_src(data)                                       ((0x08000000&(data))>>27)
+#define TVE_VBI_DWN_CTRL_get_dwn_i_p_sel(data)                                       ((0x08000000&(data))>>27)
+#define TVE_VBI_DWN_CTRL_write_en2_shift                                             (26)
+#define TVE_VBI_DWN_CTRL_write_en2_mask                                              (0x04000000)
+#define TVE_VBI_DWN_CTRL_write_en2(data)                                             (0x04000000&((data)<<26))
+#define TVE_VBI_DWN_CTRL_write_en2_src(data)                                         ((0x04000000&(data))>>26)
+#define TVE_VBI_DWN_CTRL_get_write_en2(data)                                         ((0x04000000&(data))>>26)
+#define TVE_VBI_DWN_CTRL_dwn_st_i_shift                                              (14)
+#define TVE_VBI_DWN_CTRL_dwn_st_i_mask                                               (0x03FFC000)
+#define TVE_VBI_DWN_CTRL_dwn_st_i(data)                                              (0x03FFC000&((data)<<14))
+#define TVE_VBI_DWN_CTRL_dwn_st_i_src(data)                                          ((0x03FFC000&(data))>>14)
+#define TVE_VBI_DWN_CTRL_get_dwn_st_i(data)                                          ((0x03FFC000&(data))>>14)
+#define TVE_VBI_DWN_CTRL_write_en1_shift                                             (13)
+#define TVE_VBI_DWN_CTRL_write_en1_mask                                              (0x00002000)
+#define TVE_VBI_DWN_CTRL_write_en1(data)                                             (0x00002000&((data)<<13))
+#define TVE_VBI_DWN_CTRL_write_en1_src(data)                                         ((0x00002000&(data))>>13)
+#define TVE_VBI_DWN_CTRL_get_write_en1(data)                                         ((0x00002000&(data))>>13)
+#define TVE_VBI_DWN_CTRL_dwn_end_i_shift                                             (0)
+#define TVE_VBI_DWN_CTRL_dwn_end_i_mask                                              (0x00001FFF)
+#define TVE_VBI_DWN_CTRL_dwn_end_i(data)                                             (0x00001FFF&((data)<<0))
+#define TVE_VBI_DWN_CTRL_dwn_end_i_src(data)                                         ((0x00001FFF&(data))>>0)
+#define TVE_VBI_DWN_CTRL_get_dwn_end_i(data)                                         ((0x00001FFF&(data))>>0)
+
+
+#define TVE_VBI_DWN_HPOS                                                             0x18018318
+#define TVE_VBI_DWN_HPOS_reg_addr                                                    "0xB8018318"
+#define TVE_VBI_DWN_HPOS_reg                                                         0xB8018318
+#define set_TVE_VBI_DWN_HPOS_reg(data)   (*((volatile unsigned int*) TVE_VBI_DWN_HPOS_reg)=data)
+#define get_TVE_VBI_DWN_HPOS_reg   (*((volatile unsigned int*) TVE_VBI_DWN_HPOS_reg))
+#define TVE_VBI_DWN_HPOS_inst_adr                                                    "0x00C6"
+#define TVE_VBI_DWN_HPOS_inst                                                        0x00C6
+#define TVE_VBI_DWN_HPOS_write_en2_shift                                             (26)
+#define TVE_VBI_DWN_HPOS_write_en2_mask                                              (0x04000000)
+#define TVE_VBI_DWN_HPOS_write_en2(data)                                             (0x04000000&((data)<<26))
+#define TVE_VBI_DWN_HPOS_write_en2_src(data)                                         ((0x04000000&(data))>>26)
+#define TVE_VBI_DWN_HPOS_get_write_en2(data)                                         ((0x04000000&(data))>>26)
+#define TVE_VBI_DWN_HPOS_dwn_st_p_shift                                              (14)
+#define TVE_VBI_DWN_HPOS_dwn_st_p_mask                                               (0x03FFC000)
+#define TVE_VBI_DWN_HPOS_dwn_st_p(data)                                              (0x03FFC000&((data)<<14))
+#define TVE_VBI_DWN_HPOS_dwn_st_p_src(data)                                          ((0x03FFC000&(data))>>14)
+#define TVE_VBI_DWN_HPOS_get_dwn_st_p(data)                                          ((0x03FFC000&(data))>>14)
+#define TVE_VBI_DWN_HPOS_write_en1_shift                                             (13)
+#define TVE_VBI_DWN_HPOS_write_en1_mask                                              (0x00002000)
+#define TVE_VBI_DWN_HPOS_write_en1(data)                                             (0x00002000&((data)<<13))
+#define TVE_VBI_DWN_HPOS_write_en1_src(data)                                         ((0x00002000&(data))>>13)
+#define TVE_VBI_DWN_HPOS_get_write_en1(data)                                         ((0x00002000&(data))>>13)
+#define TVE_VBI_DWN_HPOS_dwn_end_p_shift                                             (0)
+#define TVE_VBI_DWN_HPOS_dwn_end_p_mask                                              (0x00001FFF)
+#define TVE_VBI_DWN_HPOS_dwn_end_p(data)                                             (0x00001FFF&((data)<<0))
+#define TVE_VBI_DWN_HPOS_dwn_end_p_src(data)                                         ((0x00001FFF&(data))>>0)
+#define TVE_VBI_DWN_HPOS_get_dwn_end_p(data)                                         ((0x00001FFF&(data))>>0)
+
+
+#define TVE_VBI_DWN_VPOS_I                                                           0x1801831c
+#define TVE_VBI_DWN_VPOS_I_reg_addr                                                  "0xB801831C"
+#define TVE_VBI_DWN_VPOS_I_reg                                                       0xB801831C
+#define set_TVE_VBI_DWN_VPOS_I_reg(data)   (*((volatile unsigned int*) TVE_VBI_DWN_VPOS_I_reg)=data)
+#define get_TVE_VBI_DWN_VPOS_I_reg   (*((volatile unsigned int*) TVE_VBI_DWN_VPOS_I_reg))
+#define TVE_VBI_DWN_VPOS_I_inst_adr                                                  "0x00C7"
+#define TVE_VBI_DWN_VPOS_I_inst                                                      0x00C7
+#define TVE_VBI_DWN_VPOS_I_write_en2_shift                                           (23)
+#define TVE_VBI_DWN_VPOS_I_write_en2_mask                                            (0x00800000)
+#define TVE_VBI_DWN_VPOS_I_write_en2(data)                                           (0x00800000&((data)<<23))
+#define TVE_VBI_DWN_VPOS_I_write_en2_src(data)                                       ((0x00800000&(data))>>23)
+#define TVE_VBI_DWN_VPOS_I_get_write_en2(data)                                       ((0x00800000&(data))>>23)
+#define TVE_VBI_DWN_VPOS_I_vbi_start_line2_shift                                     (12)
+#define TVE_VBI_DWN_VPOS_I_vbi_start_line2_mask                                      (0x007FF000)
+#define TVE_VBI_DWN_VPOS_I_vbi_start_line2(data)                                     (0x007FF000&((data)<<12))
+#define TVE_VBI_DWN_VPOS_I_vbi_start_line2_src(data)                                 ((0x007FF000&(data))>>12)
+#define TVE_VBI_DWN_VPOS_I_get_vbi_start_line2(data)                                 ((0x007FF000&(data))>>12)
+#define TVE_VBI_DWN_VPOS_I_write_en1_shift                                           (11)
+#define TVE_VBI_DWN_VPOS_I_write_en1_mask                                            (0x00000800)
+#define TVE_VBI_DWN_VPOS_I_write_en1(data)                                           (0x00000800&((data)<<11))
+#define TVE_VBI_DWN_VPOS_I_write_en1_src(data)                                       ((0x00000800&(data))>>11)
+#define TVE_VBI_DWN_VPOS_I_get_write_en1(data)                                       ((0x00000800&(data))>>11)
+#define TVE_VBI_DWN_VPOS_I_vbi_start_line1_shift                                     (0)
+#define TVE_VBI_DWN_VPOS_I_vbi_start_line1_mask                                      (0x000007FF)
+#define TVE_VBI_DWN_VPOS_I_vbi_start_line1(data)                                     (0x000007FF&((data)<<0))
+#define TVE_VBI_DWN_VPOS_I_vbi_start_line1_src(data)                                 ((0x000007FF&(data))>>0)
+#define TVE_VBI_DWN_VPOS_I_get_vbi_start_line1(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define TVE_VBI_DWN_VPOS_P                                                           0x18018320
+#define TVE_VBI_DWN_VPOS_P_reg_addr                                                  "0xB8018320"
+#define TVE_VBI_DWN_VPOS_P_reg                                                       0xB8018320
+#define set_TVE_VBI_DWN_VPOS_P_reg(data)   (*((volatile unsigned int*) TVE_VBI_DWN_VPOS_P_reg)=data)
+#define get_TVE_VBI_DWN_VPOS_P_reg   (*((volatile unsigned int*) TVE_VBI_DWN_VPOS_P_reg))
+#define TVE_VBI_DWN_VPOS_P_inst_adr                                                  "0x00C8"
+#define TVE_VBI_DWN_VPOS_P_inst                                                      0x00C8
+#define TVE_VBI_DWN_VPOS_P_write_en2_shift                                           (23)
+#define TVE_VBI_DWN_VPOS_P_write_en2_mask                                            (0x00800000)
+#define TVE_VBI_DWN_VPOS_P_write_en2(data)                                           (0x00800000&((data)<<23))
+#define TVE_VBI_DWN_VPOS_P_write_en2_src(data)                                       ((0x00800000&(data))>>23)
+#define TVE_VBI_DWN_VPOS_P_get_write_en2(data)                                       ((0x00800000&(data))>>23)
+#define TVE_VBI_DWN_VPOS_P_vbi_start_line2_shift                                     (12)
+#define TVE_VBI_DWN_VPOS_P_vbi_start_line2_mask                                      (0x007FF000)
+#define TVE_VBI_DWN_VPOS_P_vbi_start_line2(data)                                     (0x007FF000&((data)<<12))
+#define TVE_VBI_DWN_VPOS_P_vbi_start_line2_src(data)                                 ((0x007FF000&(data))>>12)
+#define TVE_VBI_DWN_VPOS_P_get_vbi_start_line2(data)                                 ((0x007FF000&(data))>>12)
+#define TVE_VBI_DWN_VPOS_P_write_en1_shift                                           (11)
+#define TVE_VBI_DWN_VPOS_P_write_en1_mask                                            (0x00000800)
+#define TVE_VBI_DWN_VPOS_P_write_en1(data)                                           (0x00000800&((data)<<11))
+#define TVE_VBI_DWN_VPOS_P_write_en1_src(data)                                       ((0x00000800&(data))>>11)
+#define TVE_VBI_DWN_VPOS_P_get_write_en1(data)                                       ((0x00000800&(data))>>11)
+#define TVE_VBI_DWN_VPOS_P_vbi_start_line1_shift                                     (0)
+#define TVE_VBI_DWN_VPOS_P_vbi_start_line1_mask                                      (0x000007FF)
+#define TVE_VBI_DWN_VPOS_P_vbi_start_line1(data)                                     (0x000007FF&((data)<<0))
+#define TVE_VBI_DWN_VPOS_P_vbi_start_line1_src(data)                                 ((0x000007FF&(data))>>0)
+#define TVE_VBI_DWN_VPOS_P_get_vbi_start_line1(data)                                 ((0x000007FF&(data))>>0)
+
+
+#define TVE_VBI_LINE_FLAG_I_0                                                        0x18018324
+#define TVE_VBI_LINE_FLAG_I_1                                                        0x18018328
+#define TVE_VBI_LINE_FLAG_I_0_reg_addr                                               "0xB8018324"
+#define TVE_VBI_LINE_FLAG_I_1_reg_addr                                               "0xB8018328"
+#define TVE_VBI_LINE_FLAG_I_0_reg                                                    0xB8018324
+#define TVE_VBI_LINE_FLAG_I_1_reg                                                    0xB8018328
+#define set_TVE_VBI_LINE_FLAG_I_0_reg(data)   (*((volatile unsigned int*) TVE_VBI_LINE_FLAG_I_0_reg)=data)
+#define set_TVE_VBI_LINE_FLAG_I_1_reg(data)   (*((volatile unsigned int*) TVE_VBI_LINE_FLAG_I_1_reg)=data)
+#define get_TVE_VBI_LINE_FLAG_I_0_reg   (*((volatile unsigned int*) TVE_VBI_LINE_FLAG_I_0_reg))
+#define get_TVE_VBI_LINE_FLAG_I_1_reg   (*((volatile unsigned int*) TVE_VBI_LINE_FLAG_I_1_reg))
+#define TVE_VBI_LINE_FLAG_I_0_inst_adr                                               "0x00C9"
+#define TVE_VBI_LINE_FLAG_I_1_inst_adr                                               "0x00CA"
+#define TVE_VBI_LINE_FLAG_I_0_inst                                                   0x00C9
+#define TVE_VBI_LINE_FLAG_I_1_inst                                                   0x00CA
+#define TVE_VBI_LINE_FLAG_I_vbi_line_flg_shift                                       (0)
+#define TVE_VBI_LINE_FLAG_I_vbi_line_flg_mask                                        (0xFFFFFFFF)
+#define TVE_VBI_LINE_FLAG_I_vbi_line_flg(data)                                       (0xFFFFFFFF&((data)<<0))
+#define TVE_VBI_LINE_FLAG_I_vbi_line_flg_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define TVE_VBI_LINE_FLAG_I_get_vbi_line_flg(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define TVE_VBI_LINE_FLAG_P_0                                                        0x1801832C
+#define TVE_VBI_LINE_FLAG_P_1                                                        0x18018330
+#define TVE_VBI_LINE_FLAG_P_0_reg_addr                                               "0xB801832C"
+#define TVE_VBI_LINE_FLAG_P_1_reg_addr                                               "0xB8018330"
+#define TVE_VBI_LINE_FLAG_P_0_reg                                                    0xB801832C
+#define TVE_VBI_LINE_FLAG_P_1_reg                                                    0xB8018330
+#define set_TVE_VBI_LINE_FLAG_P_0_reg(data)   (*((volatile unsigned int*) TVE_VBI_LINE_FLAG_P_0_reg)=data)
+#define set_TVE_VBI_LINE_FLAG_P_1_reg(data)   (*((volatile unsigned int*) TVE_VBI_LINE_FLAG_P_1_reg)=data)
+#define get_TVE_VBI_LINE_FLAG_P_0_reg   (*((volatile unsigned int*) TVE_VBI_LINE_FLAG_P_0_reg))
+#define get_TVE_VBI_LINE_FLAG_P_1_reg   (*((volatile unsigned int*) TVE_VBI_LINE_FLAG_P_1_reg))
+#define TVE_VBI_LINE_FLAG_P_0_inst_adr                                               "0x00CB"
+#define TVE_VBI_LINE_FLAG_P_1_inst_adr                                               "0x00CC"
+#define TVE_VBI_LINE_FLAG_P_0_inst                                                   0x00CB
+#define TVE_VBI_LINE_FLAG_P_1_inst                                                   0x00CC
+#define TVE_VBI_LINE_FLAG_P_vbi_line_flg_shift                                       (0)
+#define TVE_VBI_LINE_FLAG_P_vbi_line_flg_mask                                        (0xFFFFFFFF)
+#define TVE_VBI_LINE_FLAG_P_vbi_line_flg(data)                                       (0xFFFFFFFF&((data)<<0))
+#define TVE_VBI_LINE_FLAG_P_vbi_line_flg_src(data)                                   ((0xFFFFFFFF&(data))>>0)
+#define TVE_VBI_LINE_FLAG_P_get_vbi_line_flg(data)                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define TVE_VBI_LINE_PTY_I_0                                                         0x18018334
+#define TVE_VBI_LINE_PTY_I_1                                                         0x18018338
+#define TVE_VBI_LINE_PTY_I_0_reg_addr                                                "0xB8018334"
+#define TVE_VBI_LINE_PTY_I_1_reg_addr                                                "0xB8018338"
+#define TVE_VBI_LINE_PTY_I_0_reg                                                     0xB8018334
+#define TVE_VBI_LINE_PTY_I_1_reg                                                     0xB8018338
+#define set_TVE_VBI_LINE_PTY_I_0_reg(data)   (*((volatile unsigned int*) TVE_VBI_LINE_PTY_I_0_reg)=data)
+#define set_TVE_VBI_LINE_PTY_I_1_reg(data)   (*((volatile unsigned int*) TVE_VBI_LINE_PTY_I_1_reg)=data)
+#define get_TVE_VBI_LINE_PTY_I_0_reg   (*((volatile unsigned int*) TVE_VBI_LINE_PTY_I_0_reg))
+#define get_TVE_VBI_LINE_PTY_I_1_reg   (*((volatile unsigned int*) TVE_VBI_LINE_PTY_I_1_reg))
+#define TVE_VBI_LINE_PTY_I_0_inst_adr                                                "0x00CD"
+#define TVE_VBI_LINE_PTY_I_1_inst_adr                                                "0x00CE"
+#define TVE_VBI_LINE_PTY_I_0_inst                                                    0x00CD
+#define TVE_VBI_LINE_PTY_I_1_inst                                                    0x00CE
+#define TVE_VBI_LINE_PTY_I_vbi_pty_shift                                             (0)
+#define TVE_VBI_LINE_PTY_I_vbi_pty_mask                                              (0xFFFFFFFF)
+#define TVE_VBI_LINE_PTY_I_vbi_pty(data)                                             (0xFFFFFFFF&((data)<<0))
+#define TVE_VBI_LINE_PTY_I_vbi_pty_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define TVE_VBI_LINE_PTY_I_get_vbi_pty(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define TVE_VBI_LINE_PTY_P_0                                                         0x1801833C
+#define TVE_VBI_LINE_PTY_P_1                                                         0x18018340
+#define TVE_VBI_LINE_PTY_P_0_reg_addr                                                "0xB801833C"
+#define TVE_VBI_LINE_PTY_P_1_reg_addr                                                "0xB8018340"
+#define TVE_VBI_LINE_PTY_P_0_reg                                                     0xB801833C
+#define TVE_VBI_LINE_PTY_P_1_reg                                                     0xB8018340
+#define set_TVE_VBI_LINE_PTY_P_0_reg(data)   (*((volatile unsigned int*) TVE_VBI_LINE_PTY_P_0_reg)=data)
+#define set_TVE_VBI_LINE_PTY_P_1_reg(data)   (*((volatile unsigned int*) TVE_VBI_LINE_PTY_P_1_reg)=data)
+#define get_TVE_VBI_LINE_PTY_P_0_reg   (*((volatile unsigned int*) TVE_VBI_LINE_PTY_P_0_reg))
+#define get_TVE_VBI_LINE_PTY_P_1_reg   (*((volatile unsigned int*) TVE_VBI_LINE_PTY_P_1_reg))
+#define TVE_VBI_LINE_PTY_P_0_inst_adr                                                "0x00CF"
+#define TVE_VBI_LINE_PTY_P_1_inst_adr                                                "0x00D0"
+#define TVE_VBI_LINE_PTY_P_0_inst                                                    0x00CF
+#define TVE_VBI_LINE_PTY_P_1_inst                                                    0x00D0
+#define TVE_VBI_LINE_PTY_P_vbi_pty_shift                                             (0)
+#define TVE_VBI_LINE_PTY_P_vbi_pty_mask                                              (0xFFFFFFFF)
+#define TVE_VBI_LINE_PTY_P_vbi_pty(data)                                             (0xFFFFFFFF&((data)<<0))
+#define TVE_VBI_LINE_PTY_P_vbi_pty_src(data)                                         ((0xFFFFFFFF&(data))>>0)
+#define TVE_VBI_LINE_PTY_P_get_vbi_pty(data)                                         ((0xFFFFFFFF&(data))>>0)
+
+
+#define TVE_DIF_HACTIVE                                                              0x180181b0
+#define TVE_DIF_HACTIVE_reg_addr                                                     "0xB80181B0"
+#define TVE_DIF_HACTIVE_reg                                                          0xB80181B0
+#define set_TVE_DIF_HACTIVE_reg(data)   (*((volatile unsigned int*) TVE_DIF_HACTIVE_reg)=data)
+#define get_TVE_DIF_HACTIVE_reg   (*((volatile unsigned int*) TVE_DIF_HACTIVE_reg))
+#define TVE_DIF_HACTIVE_inst_adr                                                     "0x006C"
+#define TVE_DIF_HACTIVE_inst                                                         0x006C
+#define TVE_DIF_HACTIVE_write_en3_shift                                              (30)
+#define TVE_DIF_HACTIVE_write_en3_mask                                               (0x40000000)
+#define TVE_DIF_HACTIVE_write_en3(data)                                              (0x40000000&((data)<<30))
+#define TVE_DIF_HACTIVE_write_en3_src(data)                                          ((0x40000000&(data))>>30)
+#define TVE_DIF_HACTIVE_get_write_en3(data)                                          ((0x40000000&(data))>>30)
+#define TVE_DIF_HACTIVE_di_i_p_sel_shift                                             (28)
+#define TVE_DIF_HACTIVE_di_i_p_sel_mask                                              (0x30000000)
+#define TVE_DIF_HACTIVE_di_i_p_sel(data)                                             (0x30000000&((data)<<28))
+#define TVE_DIF_HACTIVE_di_i_p_sel_src(data)                                         ((0x30000000&(data))>>28)
+#define TVE_DIF_HACTIVE_get_di_i_p_sel(data)                                         ((0x30000000&(data))>>28)
+#define TVE_DIF_HACTIVE_write_en2_shift                                              (27)
+#define TVE_DIF_HACTIVE_write_en2_mask                                               (0x08000000)
+#define TVE_DIF_HACTIVE_write_en2(data)                                              (0x08000000&((data)<<27))
+#define TVE_DIF_HACTIVE_write_en2_src(data)                                          ((0x08000000&(data))>>27)
+#define TVE_DIF_HACTIVE_get_write_en2(data)                                          ((0x08000000&(data))>>27)
+#define TVE_DIF_HACTIVE_hact_start_shift                                             (14)
+#define TVE_DIF_HACTIVE_hact_start_mask                                              (0x07FFC000)
+#define TVE_DIF_HACTIVE_hact_start(data)                                             (0x07FFC000&((data)<<14))
+#define TVE_DIF_HACTIVE_hact_start_src(data)                                         ((0x07FFC000&(data))>>14)
+#define TVE_DIF_HACTIVE_get_hact_start(data)                                         ((0x07FFC000&(data))>>14)
+#define TVE_DIF_HACTIVE_write_en1_shift                                              (13)
+#define TVE_DIF_HACTIVE_write_en1_mask                                               (0x00002000)
+#define TVE_DIF_HACTIVE_write_en1(data)                                              (0x00002000&((data)<<13))
+#define TVE_DIF_HACTIVE_write_en1_src(data)                                          ((0x00002000&(data))>>13)
+#define TVE_DIF_HACTIVE_get_write_en1(data)                                          ((0x00002000&(data))>>13)
+#define TVE_DIF_HACTIVE_hact_end_shift                                               (0)
+#define TVE_DIF_HACTIVE_hact_end_mask                                                (0x00001FFF)
+#define TVE_DIF_HACTIVE_hact_end(data)                                               (0x00001FFF&((data)<<0))
+#define TVE_DIF_HACTIVE_hact_end_src(data)                                           ((0x00001FFF&(data))>>0)
+#define TVE_DIF_HACTIVE_get_hact_end(data)                                           ((0x00001FFF&(data))>>0)
+
+
+#define TVE_DIF_CTRL                                                                 0x180181b4
+#define TVE_DIF_CTRL_reg_addr                                                        "0xB80181B4"
+#define TVE_DIF_CTRL_reg                                                             0xB80181B4
+#define set_TVE_DIF_CTRL_reg(data)   (*((volatile unsigned int*) TVE_DIF_CTRL_reg)=data)
+#define get_TVE_DIF_CTRL_reg   (*((volatile unsigned int*) TVE_DIF_CTRL_reg))
+#define TVE_DIF_CTRL_inst_adr                                                        "0x006D"
+#define TVE_DIF_CTRL_inst                                                            0x006D
+#define TVE_DIF_CTRL_cd_shift                                                        (9)
+#define TVE_DIF_CTRL_cd_mask                                                         (0x00000200)
+#define TVE_DIF_CTRL_cd(data)                                                        (0x00000200&((data)<<9))
+#define TVE_DIF_CTRL_cd_src(data)                                                    ((0x00000200&(data))>>9)
+#define TVE_DIF_CTRL_get_cd(data)                                                    ((0x00000200&(data))>>9)
+#define TVE_DIF_CTRL_di_bus_swap_shift                                               (8)
+#define TVE_DIF_CTRL_di_bus_swap_mask                                                (0x00000100)
+#define TVE_DIF_CTRL_di_bus_swap(data)                                               (0x00000100&((data)<<8))
+#define TVE_DIF_CTRL_di_bus_swap_src(data)                                           ((0x00000100&(data))>>8)
+#define TVE_DIF_CTRL_get_di_bus_swap(data)                                           ((0x00000100&(data))>>8)
+#define TVE_DIF_CTRL_di_clk_phs_shift                                                (7)
+#define TVE_DIF_CTRL_di_clk_phs_mask                                                 (0x00000080)
+#define TVE_DIF_CTRL_di_clk_phs(data)                                                (0x00000080&((data)<<7))
+#define TVE_DIF_CTRL_di_clk_phs_src(data)                                            ((0x00000080&(data))>>7)
+#define TVE_DIF_CTRL_get_di_clk_phs(data)                                            ((0x00000080&(data))>>7)
+#define TVE_DIF_CTRL_di_fpga_clk_sel_shift                                           (6)
+#define TVE_DIF_CTRL_di_fpga_clk_sel_mask                                            (0x00000040)
+#define TVE_DIF_CTRL_di_fpga_clk_sel(data)                                           (0x00000040&((data)<<6))
+#define TVE_DIF_CTRL_di_fpga_clk_sel_src(data)                                       ((0x00000040&(data))>>6)
+#define TVE_DIF_CTRL_get_di_fpga_clk_sel(data)                                       ((0x00000040&(data))>>6)
+#define TVE_DIF_CTRL_di_vbi_bypass_shift                                             (5)
+#define TVE_DIF_CTRL_di_vbi_bypass_mask                                              (0x00000020)
+#define TVE_DIF_CTRL_di_vbi_bypass(data)                                             (0x00000020&((data)<<5))
+#define TVE_DIF_CTRL_di_vbi_bypass_src(data)                                         ((0x00000020&(data))>>5)
+#define TVE_DIF_CTRL_get_di_vbi_bypass(data)                                         ((0x00000020&(data))>>5)
+#define TVE_DIF_CTRL_di_ebl_shift                                                    (4)
+#define TVE_DIF_CTRL_di_ebl_mask                                                     (0x00000010)
+#define TVE_DIF_CTRL_di_ebl(data)                                                    (0x00000010&((data)<<4))
+#define TVE_DIF_CTRL_di_ebl_src(data)                                                ((0x00000010&(data))>>4)
+#define TVE_DIF_CTRL_get_di_ebl(data)                                                ((0x00000010&(data))>>4)
+#define TVE_DIF_CTRL_di_source_sel_shift                                             (3)
+#define TVE_DIF_CTRL_di_source_sel_mask                                              (0x00000008)
+#define TVE_DIF_CTRL_di_source_sel(data)                                             (0x00000008&((data)<<3))
+#define TVE_DIF_CTRL_di_source_sel_src(data)                                         ((0x00000008&(data))>>3)
+#define TVE_DIF_CTRL_get_di_source_sel(data)                                         ((0x00000008&(data))>>3)
+#define TVE_DIF_CTRL_di_mod_shift                                                    (2)
+#define TVE_DIF_CTRL_di_mod_mask                                                     (0x00000004)
+#define TVE_DIF_CTRL_di_mod(data)                                                    (0x00000004&((data)<<2))
+#define TVE_DIF_CTRL_di_mod_src(data)                                                ((0x00000004&(data))>>2)
+#define TVE_DIF_CTRL_get_di_mod(data)                                                ((0x00000004&(data))>>2)
+#define TVE_DIF_CTRL_di_hdr_ebl_shift                                                (1)
+#define TVE_DIF_CTRL_di_hdr_ebl_mask                                                 (0x00000002)
+#define TVE_DIF_CTRL_di_hdr_ebl(data)                                                (0x00000002&((data)<<1))
+#define TVE_DIF_CTRL_di_hdr_ebl_src(data)                                            ((0x00000002&(data))>>1)
+#define TVE_DIF_CTRL_get_di_hdr_ebl(data)                                            ((0x00000002&(data))>>1)
+#define TVE_DIF_CTRL_write_data_shift                                                (0)
+#define TVE_DIF_CTRL_write_data_mask                                                 (0x00000001)
+#define TVE_DIF_CTRL_write_data(data)                                                (0x00000001&((data)<<0))
+#define TVE_DIF_CTRL_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define TVE_DIF_CTRL_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define TVE_DIF_HSYNC                                                                0x180181b8
+#define TVE_DIF_HSYNC_reg_addr                                                       "0xB80181B8"
+#define TVE_DIF_HSYNC_reg                                                            0xB80181B8
+#define set_TVE_DIF_HSYNC_reg(data)   (*((volatile unsigned int*) TVE_DIF_HSYNC_reg)=data)
+#define get_TVE_DIF_HSYNC_reg   (*((volatile unsigned int*) TVE_DIF_HSYNC_reg))
+#define TVE_DIF_HSYNC_inst_adr                                                       "0x006E"
+#define TVE_DIF_HSYNC_inst                                                           0x006E
+#define TVE_DIF_HSYNC_write_en3_shift                                                (29)
+#define TVE_DIF_HSYNC_write_en3_mask                                                 (0x20000000)
+#define TVE_DIF_HSYNC_write_en3(data)                                                (0x20000000&((data)<<29))
+#define TVE_DIF_HSYNC_write_en3_src(data)                                            ((0x20000000&(data))>>29)
+#define TVE_DIF_HSYNC_get_write_en3(data)                                            ((0x20000000&(data))>>29)
+#define TVE_DIF_HSYNC_hs_polar_shift                                                 (28)
+#define TVE_DIF_HSYNC_hs_polar_mask                                                  (0x10000000)
+#define TVE_DIF_HSYNC_hs_polar(data)                                                 (0x10000000&((data)<<28))
+#define TVE_DIF_HSYNC_hs_polar_src(data)                                             ((0x10000000&(data))>>28)
+#define TVE_DIF_HSYNC_get_hs_polar(data)                                             ((0x10000000&(data))>>28)
+#define TVE_DIF_HSYNC_write_en2_shift                                                (27)
+#define TVE_DIF_HSYNC_write_en2_mask                                                 (0x08000000)
+#define TVE_DIF_HSYNC_write_en2(data)                                                (0x08000000&((data)<<27))
+#define TVE_DIF_HSYNC_write_en2_src(data)                                            ((0x08000000&(data))>>27)
+#define TVE_DIF_HSYNC_get_write_en2(data)                                            ((0x08000000&(data))>>27)
+#define TVE_DIF_HSYNC_hs_start_shift                                                 (14)
+#define TVE_DIF_HSYNC_hs_start_mask                                                  (0x07FFC000)
+#define TVE_DIF_HSYNC_hs_start(data)                                                 (0x07FFC000&((data)<<14))
+#define TVE_DIF_HSYNC_hs_start_src(data)                                             ((0x07FFC000&(data))>>14)
+#define TVE_DIF_HSYNC_get_hs_start(data)                                             ((0x07FFC000&(data))>>14)
+#define TVE_DIF_HSYNC_write_en1_shift                                                (13)
+#define TVE_DIF_HSYNC_write_en1_mask                                                 (0x00002000)
+#define TVE_DIF_HSYNC_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_DIF_HSYNC_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_DIF_HSYNC_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_DIF_HSYNC_hs_end_shift                                                   (0)
+#define TVE_DIF_HSYNC_hs_end_mask                                                    (0x00001FFF)
+#define TVE_DIF_HSYNC_hs_end(data)                                                   (0x00001FFF&((data)<<0))
+#define TVE_DIF_HSYNC_hs_end_src(data)                                               ((0x00001FFF&(data))>>0)
+#define TVE_DIF_HSYNC_get_hs_end(data)                                               ((0x00001FFF&(data))>>0)
+
+
+#define TVE_DIF_VS_ST_POS1                                                           0x180181bc
+#define TVE_DIF_VS_ST_POS1_reg_addr                                                  "0xB80181BC"
+#define TVE_DIF_VS_ST_POS1_reg                                                       0xB80181BC
+#define set_TVE_DIF_VS_ST_POS1_reg(data)   (*((volatile unsigned int*) TVE_DIF_VS_ST_POS1_reg)=data)
+#define get_TVE_DIF_VS_ST_POS1_reg   (*((volatile unsigned int*) TVE_DIF_VS_ST_POS1_reg))
+#define TVE_DIF_VS_ST_POS1_inst_adr                                                  "0x006F"
+#define TVE_DIF_VS_ST_POS1_inst                                                      0x006F
+#define TVE_DIF_VS_ST_POS1_write_en3_shift                                           (27)
+#define TVE_DIF_VS_ST_POS1_write_en3_mask                                            (0x08000000)
+#define TVE_DIF_VS_ST_POS1_write_en3(data)                                           (0x08000000&((data)<<27))
+#define TVE_DIF_VS_ST_POS1_write_en3_src(data)                                       ((0x08000000&(data))>>27)
+#define TVE_DIF_VS_ST_POS1_get_write_en3(data)                                       ((0x08000000&(data))>>27)
+#define TVE_DIF_VS_ST_POS1_vs_polar_shift                                            (26)
+#define TVE_DIF_VS_ST_POS1_vs_polar_mask                                             (0x04000000)
+#define TVE_DIF_VS_ST_POS1_vs_polar(data)                                            (0x04000000&((data)<<26))
+#define TVE_DIF_VS_ST_POS1_vs_polar_src(data)                                        ((0x04000000&(data))>>26)
+#define TVE_DIF_VS_ST_POS1_get_vs_polar(data)                                        ((0x04000000&(data))>>26)
+#define TVE_DIF_VS_ST_POS1_write_en2_shift                                           (25)
+#define TVE_DIF_VS_ST_POS1_write_en2_mask                                            (0x02000000)
+#define TVE_DIF_VS_ST_POS1_write_en2(data)                                           (0x02000000&((data)<<25))
+#define TVE_DIF_VS_ST_POS1_write_en2_src(data)                                       ((0x02000000&(data))>>25)
+#define TVE_DIF_VS_ST_POS1_get_write_en2(data)                                       ((0x02000000&(data))>>25)
+#define TVE_DIF_VS_ST_POS1_vs_st_pos1v_shift                                         (14)
+#define TVE_DIF_VS_ST_POS1_vs_st_pos1v_mask                                          (0x01FFC000)
+#define TVE_DIF_VS_ST_POS1_vs_st_pos1v(data)                                         (0x01FFC000&((data)<<14))
+#define TVE_DIF_VS_ST_POS1_vs_st_pos1v_src(data)                                     ((0x01FFC000&(data))>>14)
+#define TVE_DIF_VS_ST_POS1_get_vs_st_pos1v(data)                                     ((0x01FFC000&(data))>>14)
+#define TVE_DIF_VS_ST_POS1_write_en1_shift                                           (13)
+#define TVE_DIF_VS_ST_POS1_write_en1_mask                                            (0x00002000)
+#define TVE_DIF_VS_ST_POS1_write_en1(data)                                           (0x00002000&((data)<<13))
+#define TVE_DIF_VS_ST_POS1_write_en1_src(data)                                       ((0x00002000&(data))>>13)
+#define TVE_DIF_VS_ST_POS1_get_write_en1(data)                                       ((0x00002000&(data))>>13)
+#define TVE_DIF_VS_ST_POS1_vs_st_pos1h_shift                                         (0)
+#define TVE_DIF_VS_ST_POS1_vs_st_pos1h_mask                                          (0x00001FFF)
+#define TVE_DIF_VS_ST_POS1_vs_st_pos1h(data)                                         (0x00001FFF&((data)<<0))
+#define TVE_DIF_VS_ST_POS1_vs_st_pos1h_src(data)                                     ((0x00001FFF&(data))>>0)
+#define TVE_DIF_VS_ST_POS1_get_vs_st_pos1h(data)                                     ((0x00001FFF&(data))>>0)
+
+
+#define TVE_DIF_VS_END_POS1                                                          0x180181c0
+#define TVE_DIF_VS_END_POS1_reg_addr                                                 "0xB80181C0"
+#define TVE_DIF_VS_END_POS1_reg                                                      0xB80181C0
+#define set_TVE_DIF_VS_END_POS1_reg(data)   (*((volatile unsigned int*) TVE_DIF_VS_END_POS1_reg)=data)
+#define get_TVE_DIF_VS_END_POS1_reg   (*((volatile unsigned int*) TVE_DIF_VS_END_POS1_reg))
+#define TVE_DIF_VS_END_POS1_inst_adr                                                 "0x0070"
+#define TVE_DIF_VS_END_POS1_inst                                                     0x0070
+#define TVE_DIF_VS_END_POS1_write_en2_shift                                          (25)
+#define TVE_DIF_VS_END_POS1_write_en2_mask                                           (0x02000000)
+#define TVE_DIF_VS_END_POS1_write_en2(data)                                          (0x02000000&((data)<<25))
+#define TVE_DIF_VS_END_POS1_write_en2_src(data)                                      ((0x02000000&(data))>>25)
+#define TVE_DIF_VS_END_POS1_get_write_en2(data)                                      ((0x02000000&(data))>>25)
+#define TVE_DIF_VS_END_POS1_vs_end_pos1v_shift                                       (14)
+#define TVE_DIF_VS_END_POS1_vs_end_pos1v_mask                                        (0x01FFC000)
+#define TVE_DIF_VS_END_POS1_vs_end_pos1v(data)                                       (0x01FFC000&((data)<<14))
+#define TVE_DIF_VS_END_POS1_vs_end_pos1v_src(data)                                   ((0x01FFC000&(data))>>14)
+#define TVE_DIF_VS_END_POS1_get_vs_end_pos1v(data)                                   ((0x01FFC000&(data))>>14)
+#define TVE_DIF_VS_END_POS1_write_en1_shift                                          (13)
+#define TVE_DIF_VS_END_POS1_write_en1_mask                                           (0x00002000)
+#define TVE_DIF_VS_END_POS1_write_en1(data)                                          (0x00002000&((data)<<13))
+#define TVE_DIF_VS_END_POS1_write_en1_src(data)                                      ((0x00002000&(data))>>13)
+#define TVE_DIF_VS_END_POS1_get_write_en1(data)                                      ((0x00002000&(data))>>13)
+#define TVE_DIF_VS_END_POS1_vs_end_pos1h_shift                                       (0)
+#define TVE_DIF_VS_END_POS1_vs_end_pos1h_mask                                        (0x00001FFF)
+#define TVE_DIF_VS_END_POS1_vs_end_pos1h(data)                                       (0x00001FFF&((data)<<0))
+#define TVE_DIF_VS_END_POS1_vs_end_pos1h_src(data)                                   ((0x00001FFF&(data))>>0)
+#define TVE_DIF_VS_END_POS1_get_vs_end_pos1h(data)                                   ((0x00001FFF&(data))>>0)
+
+
+#define TVE_DIF_VS_ST_POS2                                                           0x180181c4
+#define TVE_DIF_VS_ST_POS2_reg_addr                                                  "0xB80181C4"
+#define TVE_DIF_VS_ST_POS2_reg                                                       0xB80181C4
+#define set_TVE_DIF_VS_ST_POS2_reg(data)   (*((volatile unsigned int*) TVE_DIF_VS_ST_POS2_reg)=data)
+#define get_TVE_DIF_VS_ST_POS2_reg   (*((volatile unsigned int*) TVE_DIF_VS_ST_POS2_reg))
+#define TVE_DIF_VS_ST_POS2_inst_adr                                                  "0x0071"
+#define TVE_DIF_VS_ST_POS2_inst                                                      0x0071
+#define TVE_DIF_VS_ST_POS2_write_en2_shift                                           (25)
+#define TVE_DIF_VS_ST_POS2_write_en2_mask                                            (0x02000000)
+#define TVE_DIF_VS_ST_POS2_write_en2(data)                                           (0x02000000&((data)<<25))
+#define TVE_DIF_VS_ST_POS2_write_en2_src(data)                                       ((0x02000000&(data))>>25)
+#define TVE_DIF_VS_ST_POS2_get_write_en2(data)                                       ((0x02000000&(data))>>25)
+#define TVE_DIF_VS_ST_POS2_vs_st_pos2v_shift                                         (14)
+#define TVE_DIF_VS_ST_POS2_vs_st_pos2v_mask                                          (0x01FFC000)
+#define TVE_DIF_VS_ST_POS2_vs_st_pos2v(data)                                         (0x01FFC000&((data)<<14))
+#define TVE_DIF_VS_ST_POS2_vs_st_pos2v_src(data)                                     ((0x01FFC000&(data))>>14)
+#define TVE_DIF_VS_ST_POS2_get_vs_st_pos2v(data)                                     ((0x01FFC000&(data))>>14)
+#define TVE_DIF_VS_ST_POS2_write_en1_shift                                           (13)
+#define TVE_DIF_VS_ST_POS2_write_en1_mask                                            (0x00002000)
+#define TVE_DIF_VS_ST_POS2_write_en1(data)                                           (0x00002000&((data)<<13))
+#define TVE_DIF_VS_ST_POS2_write_en1_src(data)                                       ((0x00002000&(data))>>13)
+#define TVE_DIF_VS_ST_POS2_get_write_en1(data)                                       ((0x00002000&(data))>>13)
+#define TVE_DIF_VS_ST_POS2_vs_st_pos2h_shift                                         (0)
+#define TVE_DIF_VS_ST_POS2_vs_st_pos2h_mask                                          (0x00001FFF)
+#define TVE_DIF_VS_ST_POS2_vs_st_pos2h(data)                                         (0x00001FFF&((data)<<0))
+#define TVE_DIF_VS_ST_POS2_vs_st_pos2h_src(data)                                     ((0x00001FFF&(data))>>0)
+#define TVE_DIF_VS_ST_POS2_get_vs_st_pos2h(data)                                     ((0x00001FFF&(data))>>0)
+
+
+#define TVE_DIF_VS_END_POS2                                                          0x180181c8
+#define TVE_DIF_VS_END_POS2_reg_addr                                                 "0xB80181C8"
+#define TVE_DIF_VS_END_POS2_reg                                                      0xB80181C8
+#define set_TVE_DIF_VS_END_POS2_reg(data)   (*((volatile unsigned int*) TVE_DIF_VS_END_POS2_reg)=data)
+#define get_TVE_DIF_VS_END_POS2_reg   (*((volatile unsigned int*) TVE_DIF_VS_END_POS2_reg))
+#define TVE_DIF_VS_END_POS2_inst_adr                                                 "0x0072"
+#define TVE_DIF_VS_END_POS2_inst                                                     0x0072
+#define TVE_DIF_VS_END_POS2_write_en2_shift                                          (25)
+#define TVE_DIF_VS_END_POS2_write_en2_mask                                           (0x02000000)
+#define TVE_DIF_VS_END_POS2_write_en2(data)                                          (0x02000000&((data)<<25))
+#define TVE_DIF_VS_END_POS2_write_en2_src(data)                                      ((0x02000000&(data))>>25)
+#define TVE_DIF_VS_END_POS2_get_write_en2(data)                                      ((0x02000000&(data))>>25)
+#define TVE_DIF_VS_END_POS2_vs_end_pos2v_shift                                       (14)
+#define TVE_DIF_VS_END_POS2_vs_end_pos2v_mask                                        (0x01FFC000)
+#define TVE_DIF_VS_END_POS2_vs_end_pos2v(data)                                       (0x01FFC000&((data)<<14))
+#define TVE_DIF_VS_END_POS2_vs_end_pos2v_src(data)                                   ((0x01FFC000&(data))>>14)
+#define TVE_DIF_VS_END_POS2_get_vs_end_pos2v(data)                                   ((0x01FFC000&(data))>>14)
+#define TVE_DIF_VS_END_POS2_write_en1_shift                                          (13)
+#define TVE_DIF_VS_END_POS2_write_en1_mask                                           (0x00002000)
+#define TVE_DIF_VS_END_POS2_write_en1(data)                                          (0x00002000&((data)<<13))
+#define TVE_DIF_VS_END_POS2_write_en1_src(data)                                      ((0x00002000&(data))>>13)
+#define TVE_DIF_VS_END_POS2_get_write_en1(data)                                      ((0x00002000&(data))>>13)
+#define TVE_DIF_VS_END_POS2_vs_end_pos2h_shift                                       (0)
+#define TVE_DIF_VS_END_POS2_vs_end_pos2h_mask                                        (0x00001FFF)
+#define TVE_DIF_VS_END_POS2_vs_end_pos2h(data)                                       (0x00001FFF&((data)<<0))
+#define TVE_DIF_VS_END_POS2_vs_end_pos2h_src(data)                                   ((0x00001FFF&(data))>>0)
+#define TVE_DIF_VS_END_POS2_get_vs_end_pos2h(data)                                   ((0x00001FFF&(data))>>0)
+
+
+#define TVE_DIF_F_BIT_POS                                                            0x180181cc
+#define TVE_DIF_F_BIT_POS_reg_addr                                                   "0xB80181CC"
+#define TVE_DIF_F_BIT_POS_reg                                                        0xB80181CC
+#define set_TVE_DIF_F_BIT_POS_reg(data)   (*((volatile unsigned int*) TVE_DIF_F_BIT_POS_reg)=data)
+#define get_TVE_DIF_F_BIT_POS_reg   (*((volatile unsigned int*) TVE_DIF_F_BIT_POS_reg))
+#define TVE_DIF_F_BIT_POS_inst_adr                                                   "0x0073"
+#define TVE_DIF_F_BIT_POS_inst                                                       0x0073
+#define TVE_DIF_F_BIT_POS_write_en2_shift                                            (23)
+#define TVE_DIF_F_BIT_POS_write_en2_mask                                             (0x00800000)
+#define TVE_DIF_F_BIT_POS_write_en2(data)                                            (0x00800000&((data)<<23))
+#define TVE_DIF_F_BIT_POS_write_en2_src(data)                                        ((0x00800000&(data))>>23)
+#define TVE_DIF_F_BIT_POS_get_write_en2(data)                                        ((0x00800000&(data))>>23)
+#define TVE_DIF_F_BIT_POS_v_tgl_hi_shift                                             (12)
+#define TVE_DIF_F_BIT_POS_v_tgl_hi_mask                                              (0x007FF000)
+#define TVE_DIF_F_BIT_POS_v_tgl_hi(data)                                             (0x007FF000&((data)<<12))
+#define TVE_DIF_F_BIT_POS_v_tgl_hi_src(data)                                         ((0x007FF000&(data))>>12)
+#define TVE_DIF_F_BIT_POS_get_v_tgl_hi(data)                                         ((0x007FF000&(data))>>12)
+#define TVE_DIF_F_BIT_POS_write_en1_shift                                            (11)
+#define TVE_DIF_F_BIT_POS_write_en1_mask                                             (0x00000800)
+#define TVE_DIF_F_BIT_POS_write_en1(data)                                            (0x00000800&((data)<<11))
+#define TVE_DIF_F_BIT_POS_write_en1_src(data)                                        ((0x00000800&(data))>>11)
+#define TVE_DIF_F_BIT_POS_get_write_en1(data)                                        ((0x00000800&(data))>>11)
+#define TVE_DIF_F_BIT_POS_v_tgl_lo_shift                                             (0)
+#define TVE_DIF_F_BIT_POS_v_tgl_lo_mask                                              (0x000007FF)
+#define TVE_DIF_F_BIT_POS_v_tgl_lo(data)                                             (0x000007FF&((data)<<0))
+#define TVE_DIF_F_BIT_POS_v_tgl_lo_src(data)                                         ((0x000007FF&(data))>>0)
+#define TVE_DIF_F_BIT_POS_get_v_tgl_lo(data)                                         ((0x000007FF&(data))>>0)
+
+
+#define TVE_DIF_V_BIT_POS1                                                           0x180181d0
+#define TVE_DIF_V_BIT_POS1_reg_addr                                                  "0xB80181D0"
+#define TVE_DIF_V_BIT_POS1_reg                                                       0xB80181D0
+#define set_TVE_DIF_V_BIT_POS1_reg(data)   (*((volatile unsigned int*) TVE_DIF_V_BIT_POS1_reg)=data)
+#define get_TVE_DIF_V_BIT_POS1_reg   (*((volatile unsigned int*) TVE_DIF_V_BIT_POS1_reg))
+#define TVE_DIF_V_BIT_POS1_inst_adr                                                  "0x0074"
+#define TVE_DIF_V_BIT_POS1_inst                                                      0x0074
+#define TVE_DIF_V_BIT_POS1_write_en2_shift                                           (23)
+#define TVE_DIF_V_BIT_POS1_write_en2_mask                                            (0x00800000)
+#define TVE_DIF_V_BIT_POS1_write_en2(data)                                           (0x00800000&((data)<<23))
+#define TVE_DIF_V_BIT_POS1_write_en2_src(data)                                       ((0x00800000&(data))>>23)
+#define TVE_DIF_V_BIT_POS1_get_write_en2(data)                                       ((0x00800000&(data))>>23)
+#define TVE_DIF_V_BIT_POS1_v_tgl1_hi_shift                                           (12)
+#define TVE_DIF_V_BIT_POS1_v_tgl1_hi_mask                                            (0x007FF000)
+#define TVE_DIF_V_BIT_POS1_v_tgl1_hi(data)                                           (0x007FF000&((data)<<12))
+#define TVE_DIF_V_BIT_POS1_v_tgl1_hi_src(data)                                       ((0x007FF000&(data))>>12)
+#define TVE_DIF_V_BIT_POS1_get_v_tgl1_hi(data)                                       ((0x007FF000&(data))>>12)
+#define TVE_DIF_V_BIT_POS1_write_en1_shift                                           (11)
+#define TVE_DIF_V_BIT_POS1_write_en1_mask                                            (0x00000800)
+#define TVE_DIF_V_BIT_POS1_write_en1(data)                                           (0x00000800&((data)<<11))
+#define TVE_DIF_V_BIT_POS1_write_en1_src(data)                                       ((0x00000800&(data))>>11)
+#define TVE_DIF_V_BIT_POS1_get_write_en1(data)                                       ((0x00000800&(data))>>11)
+#define TVE_DIF_V_BIT_POS1_v_tgl1_lo_shift                                           (0)
+#define TVE_DIF_V_BIT_POS1_v_tgl1_lo_mask                                            (0x000007FF)
+#define TVE_DIF_V_BIT_POS1_v_tgl1_lo(data)                                           (0x000007FF&((data)<<0))
+#define TVE_DIF_V_BIT_POS1_v_tgl1_lo_src(data)                                       ((0x000007FF&(data))>>0)
+#define TVE_DIF_V_BIT_POS1_get_v_tgl1_lo(data)                                       ((0x000007FF&(data))>>0)
+
+
+#define TVE_DIF_V_BIT_POS2                                                           0x180181d4
+#define TVE_DIF_V_BIT_POS2_reg_addr                                                  "0xB80181D4"
+#define TVE_DIF_V_BIT_POS2_reg                                                       0xB80181D4
+#define set_TVE_DIF_V_BIT_POS2_reg(data)   (*((volatile unsigned int*) TVE_DIF_V_BIT_POS2_reg)=data)
+#define get_TVE_DIF_V_BIT_POS2_reg   (*((volatile unsigned int*) TVE_DIF_V_BIT_POS2_reg))
+#define TVE_DIF_V_BIT_POS2_inst_adr                                                  "0x0075"
+#define TVE_DIF_V_BIT_POS2_inst                                                      0x0075
+#define TVE_DIF_V_BIT_POS2_write_en2_shift                                           (23)
+#define TVE_DIF_V_BIT_POS2_write_en2_mask                                            (0x00800000)
+#define TVE_DIF_V_BIT_POS2_write_en2(data)                                           (0x00800000&((data)<<23))
+#define TVE_DIF_V_BIT_POS2_write_en2_src(data)                                       ((0x00800000&(data))>>23)
+#define TVE_DIF_V_BIT_POS2_get_write_en2(data)                                       ((0x00800000&(data))>>23)
+#define TVE_DIF_V_BIT_POS2_v_tgl2_hi_shift                                           (12)
+#define TVE_DIF_V_BIT_POS2_v_tgl2_hi_mask                                            (0x007FF000)
+#define TVE_DIF_V_BIT_POS2_v_tgl2_hi(data)                                           (0x007FF000&((data)<<12))
+#define TVE_DIF_V_BIT_POS2_v_tgl2_hi_src(data)                                       ((0x007FF000&(data))>>12)
+#define TVE_DIF_V_BIT_POS2_get_v_tgl2_hi(data)                                       ((0x007FF000&(data))>>12)
+#define TVE_DIF_V_BIT_POS2_write_en1_shift                                           (11)
+#define TVE_DIF_V_BIT_POS2_write_en1_mask                                            (0x00000800)
+#define TVE_DIF_V_BIT_POS2_write_en1(data)                                           (0x00000800&((data)<<11))
+#define TVE_DIF_V_BIT_POS2_write_en1_src(data)                                       ((0x00000800&(data))>>11)
+#define TVE_DIF_V_BIT_POS2_get_write_en1(data)                                       ((0x00000800&(data))>>11)
+#define TVE_DIF_V_BIT_POS2_v_tgl2_lo_shift                                           (0)
+#define TVE_DIF_V_BIT_POS2_v_tgl2_lo_mask                                            (0x000007FF)
+#define TVE_DIF_V_BIT_POS2_v_tgl2_lo(data)                                           (0x000007FF&((data)<<0))
+#define TVE_DIF_V_BIT_POS2_v_tgl2_lo_src(data)                                       ((0x000007FF&(data))>>0)
+#define TVE_DIF_V_BIT_POS2_get_v_tgl2_lo(data)                                       ((0x000007FF&(data))>>0)
+
+
+#define TVE_DIF_FV_BIT_HPOS                                                          0x180181d8
+#define TVE_DIF_FV_BIT_HPOS_reg_addr                                                 "0xB80181D8"
+#define TVE_DIF_FV_BIT_HPOS_reg                                                      0xB80181D8
+#define set_TVE_DIF_FV_BIT_HPOS_reg(data)   (*((volatile unsigned int*) TVE_DIF_FV_BIT_HPOS_reg)=data)
+#define get_TVE_DIF_FV_BIT_HPOS_reg   (*((volatile unsigned int*) TVE_DIF_FV_BIT_HPOS_reg))
+#define TVE_DIF_FV_BIT_HPOS_inst_adr                                                 "0x0076"
+#define TVE_DIF_FV_BIT_HPOS_inst                                                     0x0076
+#define TVE_DIF_FV_BIT_HPOS_write_en2_shift                                          (27)
+#define TVE_DIF_FV_BIT_HPOS_write_en2_mask                                           (0x08000000)
+#define TVE_DIF_FV_BIT_HPOS_write_en2(data)                                          (0x08000000&((data)<<27))
+#define TVE_DIF_FV_BIT_HPOS_write_en2_src(data)                                      ((0x08000000&(data))>>27)
+#define TVE_DIF_FV_BIT_HPOS_get_write_en2(data)                                      ((0x08000000&(data))>>27)
+#define TVE_DIF_FV_BIT_HPOS_fv_start_shift                                           (14)
+#define TVE_DIF_FV_BIT_HPOS_fv_start_mask                                            (0x07FFC000)
+#define TVE_DIF_FV_BIT_HPOS_fv_start(data)                                           (0x07FFC000&((data)<<14))
+#define TVE_DIF_FV_BIT_HPOS_fv_start_src(data)                                       ((0x07FFC000&(data))>>14)
+#define TVE_DIF_FV_BIT_HPOS_get_fv_start(data)                                       ((0x07FFC000&(data))>>14)
+#define TVE_DIF_FV_BIT_HPOS_write_en1_shift                                          (13)
+#define TVE_DIF_FV_BIT_HPOS_write_en1_mask                                           (0x00002000)
+#define TVE_DIF_FV_BIT_HPOS_write_en1(data)                                          (0x00002000&((data)<<13))
+#define TVE_DIF_FV_BIT_HPOS_write_en1_src(data)                                      ((0x00002000&(data))>>13)
+#define TVE_DIF_FV_BIT_HPOS_get_write_en1(data)                                      ((0x00002000&(data))>>13)
+#define TVE_DIF_FV_BIT_HPOS_fv_end_shift                                             (0)
+#define TVE_DIF_FV_BIT_HPOS_fv_end_mask                                              (0x00001FFF)
+#define TVE_DIF_FV_BIT_HPOS_fv_end(data)                                             (0x00001FFF&((data)<<0))
+#define TVE_DIF_FV_BIT_HPOS_fv_end_src(data)                                         ((0x00001FFF&(data))>>0)
+#define TVE_DIF_FV_BIT_HPOS_get_fv_end(data)                                         ((0x00001FFF&(data))>>0)
+
+
+#define TVE_IP_PHS_0                                                                 0x18018880
+#define TVE_IP_PHS_1                                                                 0x18018884
+#define TVE_IP_PHS_2                                                                 0x18018888
+#define TVE_IP_PHS_3                                                                 0x1801888C
+#define TVE_IP_PHS_0_reg_addr                                                        "0xB8018880"
+#define TVE_IP_PHS_1_reg_addr                                                        "0xB8018884"
+#define TVE_IP_PHS_2_reg_addr                                                        "0xB8018888"
+#define TVE_IP_PHS_3_reg_addr                                                        "0xB801888C"
+#define TVE_IP_PHS_0_reg                                                             0xB8018880
+#define TVE_IP_PHS_1_reg                                                             0xB8018884
+#define TVE_IP_PHS_2_reg                                                             0xB8018888
+#define TVE_IP_PHS_3_reg                                                             0xB801888C
+#define set_TVE_IP_PHS_0_reg(data)   (*((volatile unsigned int*) TVE_IP_PHS_0_reg)=data)
+#define set_TVE_IP_PHS_1_reg(data)   (*((volatile unsigned int*) TVE_IP_PHS_1_reg)=data)
+#define set_TVE_IP_PHS_2_reg(data)   (*((volatile unsigned int*) TVE_IP_PHS_2_reg)=data)
+#define set_TVE_IP_PHS_3_reg(data)   (*((volatile unsigned int*) TVE_IP_PHS_3_reg)=data)
+#define get_TVE_IP_PHS_0_reg   (*((volatile unsigned int*) TVE_IP_PHS_0_reg))
+#define get_TVE_IP_PHS_1_reg   (*((volatile unsigned int*) TVE_IP_PHS_1_reg))
+#define get_TVE_IP_PHS_2_reg   (*((volatile unsigned int*) TVE_IP_PHS_2_reg))
+#define get_TVE_IP_PHS_3_reg   (*((volatile unsigned int*) TVE_IP_PHS_3_reg))
+#define TVE_IP_PHS_0_inst_adr                                                        "0x0020"
+#define TVE_IP_PHS_1_inst_adr                                                        "0x0021"
+#define TVE_IP_PHS_2_inst_adr                                                        "0x0022"
+#define TVE_IP_PHS_3_inst_adr                                                        "0x0023"
+#define TVE_IP_PHS_0_inst                                                            0x0020
+#define TVE_IP_PHS_1_inst                                                            0x0021
+#define TVE_IP_PHS_2_inst                                                            0x0022
+#define TVE_IP_PHS_3_inst                                                            0x0023
+#define TVE_IP_PHS_phi_shift                                                         (0)
+#define TVE_IP_PHS_phi_mask                                                          (0x000000FF)
+#define TVE_IP_PHS_phi(data)                                                         (0x000000FF&((data)<<0))
+#define TVE_IP_PHS_phi_src(data)                                                     ((0x000000FF&(data))>>0)
+#define TVE_IP_PHS_get_phi(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_SCTOH_0                                                               0x18018890
+#define TVE_IP_SCTOH_1                                                               0x18018894
+#define TVE_IP_SCTOH_2                                                               0x18018898
+#define TVE_IP_SCTOH_3                                                               0x1801889C
+#define TVE_IP_SCTOH_0_reg_addr                                                      "0xB8018890"
+#define TVE_IP_SCTOH_1_reg_addr                                                      "0xB8018894"
+#define TVE_IP_SCTOH_2_reg_addr                                                      "0xB8018898"
+#define TVE_IP_SCTOH_3_reg_addr                                                      "0xB801889C"
+#define TVE_IP_SCTOH_0_reg                                                           0xB8018890
+#define TVE_IP_SCTOH_1_reg                                                           0xB8018894
+#define TVE_IP_SCTOH_2_reg                                                           0xB8018898
+#define TVE_IP_SCTOH_3_reg                                                           0xB801889C
+#define set_TVE_IP_SCTOH_0_reg(data)   (*((volatile unsigned int*) TVE_IP_SCTOH_0_reg)=data)
+#define set_TVE_IP_SCTOH_1_reg(data)   (*((volatile unsigned int*) TVE_IP_SCTOH_1_reg)=data)
+#define set_TVE_IP_SCTOH_2_reg(data)   (*((volatile unsigned int*) TVE_IP_SCTOH_2_reg)=data)
+#define set_TVE_IP_SCTOH_3_reg(data)   (*((volatile unsigned int*) TVE_IP_SCTOH_3_reg)=data)
+#define get_TVE_IP_SCTOH_0_reg   (*((volatile unsigned int*) TVE_IP_SCTOH_0_reg))
+#define get_TVE_IP_SCTOH_1_reg   (*((volatile unsigned int*) TVE_IP_SCTOH_1_reg))
+#define get_TVE_IP_SCTOH_2_reg   (*((volatile unsigned int*) TVE_IP_SCTOH_2_reg))
+#define get_TVE_IP_SCTOH_3_reg   (*((volatile unsigned int*) TVE_IP_SCTOH_3_reg))
+#define TVE_IP_SCTOH_0_inst_adr                                                      "0x0024"
+#define TVE_IP_SCTOH_1_inst_adr                                                      "0x0025"
+#define TVE_IP_SCTOH_2_inst_adr                                                      "0x0026"
+#define TVE_IP_SCTOH_3_inst_adr                                                      "0x0027"
+#define TVE_IP_SCTOH_0_inst                                                          0x0024
+#define TVE_IP_SCTOH_1_inst                                                          0x0025
+#define TVE_IP_SCTOH_2_inst                                                          0x0026
+#define TVE_IP_SCTOH_3_inst                                                          0x0027
+#define TVE_IP_SCTOH_sctoh_shift                                                     (0)
+#define TVE_IP_SCTOH_sctoh_mask                                                      (0x000000FF)
+#define TVE_IP_SCTOH_sctoh(data)                                                     (0x000000FF&((data)<<0))
+#define TVE_IP_SCTOH_sctoh_src(data)                                                 ((0x000000FF&(data))>>0)
+#define TVE_IP_SCTOH_get_sctoh(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_F_CTRL                                                                0x180188a0
+#define TVE_IP_F_CTRL_reg_addr                                                       "0xB80188A0"
+#define TVE_IP_F_CTRL_reg                                                            0xB80188A0
+#define set_TVE_IP_F_CTRL_reg(data)   (*((volatile unsigned int*) TVE_IP_F_CTRL_reg)=data)
+#define get_TVE_IP_F_CTRL_reg   (*((volatile unsigned int*) TVE_IP_F_CTRL_reg))
+#define TVE_IP_F_CTRL_inst_adr                                                       "0x0028"
+#define TVE_IP_F_CTRL_inst                                                           0x0028
+#define TVE_IP_F_CTRL_u_invert_shift                                                 (3)
+#define TVE_IP_F_CTRL_u_invert_mask                                                  (0x00000008)
+#define TVE_IP_F_CTRL_u_invert(data)                                                 (0x00000008&((data)<<3))
+#define TVE_IP_F_CTRL_u_invert_src(data)                                             ((0x00000008&(data))>>3)
+#define TVE_IP_F_CTRL_get_u_invert(data)                                             ((0x00000008&(data))>>3)
+#define TVE_IP_F_CTRL_v_invert_shift                                                 (2)
+#define TVE_IP_F_CTRL_v_invert_mask                                                  (0x00000004)
+#define TVE_IP_F_CTRL_v_invert(data)                                                 (0x00000004&((data)<<2))
+#define TVE_IP_F_CTRL_v_invert_src(data)                                             ((0x00000004&(data))>>2)
+#define TVE_IP_F_CTRL_get_v_invert(data)                                             ((0x00000004&(data))>>2)
+#define TVE_IP_F_CTRL_t_offset_phase_shift                                           (1)
+#define TVE_IP_F_CTRL_t_offset_phase_mask                                            (0x00000002)
+#define TVE_IP_F_CTRL_t_offset_phase(data)                                           (0x00000002&((data)<<1))
+#define TVE_IP_F_CTRL_t_offset_phase_src(data)                                       ((0x00000002&(data))>>1)
+#define TVE_IP_F_CTRL_get_t_offset_phase(data)                                       ((0x00000002&(data))>>1)
+#define TVE_IP_F_CTRL_t_reset_fsc_shift                                              (0)
+#define TVE_IP_F_CTRL_t_reset_fsc_mask                                               (0x00000001)
+#define TVE_IP_F_CTRL_t_reset_fsc(data)                                              (0x00000001&((data)<<0))
+#define TVE_IP_F_CTRL_t_reset_fsc_src(data)                                          ((0x00000001&(data))>>0)
+#define TVE_IP_F_CTRL_get_t_reset_fsc(data)                                          ((0x00000001&(data))>>0)
+
+
+#define TVE_IP_T_SEL_SIN                                                             0x18018980
+#define TVE_IP_T_SEL_SIN_reg_addr                                                    "0xB8018980"
+#define TVE_IP_T_SEL_SIN_reg                                                         0xB8018980
+#define set_TVE_IP_T_SEL_SIN_reg(data)   (*((volatile unsigned int*) TVE_IP_T_SEL_SIN_reg)=data)
+#define get_TVE_IP_T_SEL_SIN_reg   (*((volatile unsigned int*) TVE_IP_T_SEL_SIN_reg))
+#define TVE_IP_T_SEL_SIN_inst_adr                                                    "0x0060"
+#define TVE_IP_T_SEL_SIN_inst                                                        0x0060
+#define TVE_IP_T_SEL_SIN_t_sel_sin_shift                                             (1)
+#define TVE_IP_T_SEL_SIN_t_sel_sin_mask                                              (0x00000002)
+#define TVE_IP_T_SEL_SIN_t_sel_sin(data)                                             (0x00000002&((data)<<1))
+#define TVE_IP_T_SEL_SIN_t_sel_sin_src(data)                                         ((0x00000002&(data))>>1)
+#define TVE_IP_T_SEL_SIN_get_t_sel_sin(data)                                         ((0x00000002&(data))>>1)
+#define TVE_IP_T_SEL_SIN_t_fsc_rom_shift                                             (0)
+#define TVE_IP_T_SEL_SIN_t_fsc_rom_mask                                              (0x00000001)
+#define TVE_IP_T_SEL_SIN_t_fsc_rom(data)                                             (0x00000001&((data)<<0))
+#define TVE_IP_T_SEL_SIN_t_fsc_rom_src(data)                                         ((0x00000001&(data))>>0)
+#define TVE_IP_T_SEL_SIN_get_t_fsc_rom(data)                                         ((0x00000001&(data))>>0)
+
+
+#define TVE_IP_BLCK_LVL                                                              0x180188a8
+#define TVE_IP_BLCK_LVL_reg_addr                                                     "0xB80188A8"
+#define TVE_IP_BLCK_LVL_reg                                                          0xB80188A8
+#define set_TVE_IP_BLCK_LVL_reg(data)   (*((volatile unsigned int*) TVE_IP_BLCK_LVL_reg)=data)
+#define get_TVE_IP_BLCK_LVL_reg   (*((volatile unsigned int*) TVE_IP_BLCK_LVL_reg))
+#define TVE_IP_BLCK_LVL_inst_adr                                                     "0x002A"
+#define TVE_IP_BLCK_LVL_inst                                                         0x002A
+#define TVE_IP_BLCK_LVL_black_lvl_shift                                              (0)
+#define TVE_IP_BLCK_LVL_black_lvl_mask                                               (0x000000FF)
+#define TVE_IP_BLCK_LVL_black_lvl(data)                                              (0x000000FF&((data)<<0))
+#define TVE_IP_BLCK_LVL_black_lvl_src(data)                                          ((0x000000FF&(data))>>0)
+#define TVE_IP_BLCK_LVL_get_black_lvl(data)                                          ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_BLNK_LVL                                                              0x180188ac
+#define TVE_IP_BLNK_LVL_reg_addr                                                     "0xB80188AC"
+#define TVE_IP_BLNK_LVL_reg                                                          0xB80188AC
+#define set_TVE_IP_BLNK_LVL_reg(data)   (*((volatile unsigned int*) TVE_IP_BLNK_LVL_reg)=data)
+#define get_TVE_IP_BLNK_LVL_reg   (*((volatile unsigned int*) TVE_IP_BLNK_LVL_reg))
+#define TVE_IP_BLNK_LVL_inst_adr                                                     "0x002B"
+#define TVE_IP_BLNK_LVL_inst                                                         0x002B
+#define TVE_IP_BLNK_LVL_blank_lvl_shift                                              (0)
+#define TVE_IP_BLNK_LVL_blank_lvl_mask                                               (0x000000FF)
+#define TVE_IP_BLNK_LVL_blank_lvl(data)                                              (0x000000FF&((data)<<0))
+#define TVE_IP_BLNK_LVL_blank_lvl_src(data)                                          ((0x000000FF&(data))>>0)
+#define TVE_IP_BLNK_LVL_get_blank_lvl(data)                                          ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_CLAMP_LVL                                                             0x180188b0
+#define TVE_IP_CLAMP_LVL_reg_addr                                                    "0xB80188B0"
+#define TVE_IP_CLAMP_LVL_reg                                                         0xB80188B0
+#define set_TVE_IP_CLAMP_LVL_reg(data)   (*((volatile unsigned int*) TVE_IP_CLAMP_LVL_reg)=data)
+#define get_TVE_IP_CLAMP_LVL_reg   (*((volatile unsigned int*) TVE_IP_CLAMP_LVL_reg))
+#define TVE_IP_CLAMP_LVL_inst_adr                                                    "0x002C"
+#define TVE_IP_CLAMP_LVL_inst                                                        0x002C
+#define TVE_IP_CLAMP_LVL_clamp_lvl_shift                                             (0)
+#define TVE_IP_CLAMP_LVL_clamp_lvl_mask                                              (0x000000FF)
+#define TVE_IP_CLAMP_LVL_clamp_lvl(data)                                             (0x000000FF&((data)<<0))
+#define TVE_IP_CLAMP_LVL_clamp_lvl_src(data)                                         ((0x000000FF&(data))>>0)
+#define TVE_IP_CLAMP_LVL_get_clamp_lvl(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_SYNC_LVL                                                              0x180188b4
+#define TVE_IP_SYNC_LVL_reg_addr                                                     "0xB80188B4"
+#define TVE_IP_SYNC_LVL_reg                                                          0xB80188B4
+#define set_TVE_IP_SYNC_LVL_reg(data)   (*((volatile unsigned int*) TVE_IP_SYNC_LVL_reg)=data)
+#define get_TVE_IP_SYNC_LVL_reg   (*((volatile unsigned int*) TVE_IP_SYNC_LVL_reg))
+#define TVE_IP_SYNC_LVL_inst_adr                                                     "0x002D"
+#define TVE_IP_SYNC_LVL_inst                                                         0x002D
+#define TVE_IP_SYNC_LVL_sync_lvl_shift                                               (0)
+#define TVE_IP_SYNC_LVL_sync_lvl_mask                                                (0x000000FF)
+#define TVE_IP_SYNC_LVL_sync_lvl(data)                                               (0x000000FF&((data)<<0))
+#define TVE_IP_SYNC_LVL_sync_lvl_src(data)                                           ((0x000000FF&(data))>>0)
+#define TVE_IP_SYNC_LVL_get_sync_lvl(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_Y_CTRL                                                                0x180188b8
+#define TVE_IP_Y_CTRL_reg_addr                                                       "0xB80188B8"
+#define TVE_IP_Y_CTRL_reg                                                            0xB80188B8
+#define set_TVE_IP_Y_CTRL_reg(data)   (*((volatile unsigned int*) TVE_IP_Y_CTRL_reg)=data)
+#define get_TVE_IP_Y_CTRL_reg   (*((volatile unsigned int*) TVE_IP_Y_CTRL_reg))
+#define TVE_IP_Y_CTRL_inst_adr                                                       "0x002E"
+#define TVE_IP_Y_CTRL_inst                                                           0x002E
+#define TVE_IP_Y_CTRL_y_interp_shift                                                 (6)
+#define TVE_IP_Y_CTRL_y_interp_mask                                                  (0x000000C0)
+#define TVE_IP_Y_CTRL_y_interp(data)                                                 (0x000000C0&((data)<<6))
+#define TVE_IP_Y_CTRL_y_interp_src(data)                                             ((0x000000C0&(data))>>6)
+#define TVE_IP_Y_CTRL_get_y_interp(data)                                             ((0x000000C0&(data))>>6)
+#define TVE_IP_Y_CTRL_y_colorbar_en_shift                                            (5)
+#define TVE_IP_Y_CTRL_y_colorbar_en_mask                                             (0x00000020)
+#define TVE_IP_Y_CTRL_y_colorbar_en(data)                                            (0x00000020&((data)<<5))
+#define TVE_IP_Y_CTRL_y_colorbar_en_src(data)                                        ((0x00000020&(data))>>5)
+#define TVE_IP_Y_CTRL_get_y_colorbar_en(data)                                        ((0x00000020&(data))>>5)
+#define TVE_IP_Y_CTRL_t_ydel_adj_shift                                               (2)
+#define TVE_IP_Y_CTRL_t_ydel_adj_mask                                                (0x0000001C)
+#define TVE_IP_Y_CTRL_t_ydel_adj(data)                                               (0x0000001C&((data)<<2))
+#define TVE_IP_Y_CTRL_t_ydel_adj_src(data)                                           ((0x0000001C&(data))>>2)
+#define TVE_IP_Y_CTRL_get_t_ydel_adj(data)                                           ((0x0000001C&(data))>>2)
+#define TVE_IP_Y_CTRL_t_sel_ylpf_shift                                               (1)
+#define TVE_IP_Y_CTRL_t_sel_ylpf_mask                                                (0x00000002)
+#define TVE_IP_Y_CTRL_t_sel_ylpf(data)                                               (0x00000002&((data)<<1))
+#define TVE_IP_Y_CTRL_t_sel_ylpf_src(data)                                           ((0x00000002&(data))>>1)
+#define TVE_IP_Y_CTRL_get_t_sel_ylpf(data)                                           ((0x00000002&(data))>>1)
+#define TVE_IP_Y_CTRL_t_ygain_val_shift                                              (0)
+#define TVE_IP_Y_CTRL_t_ygain_val_mask                                               (0x00000001)
+#define TVE_IP_Y_CTRL_t_ygain_val(data)                                              (0x00000001&((data)<<0))
+#define TVE_IP_Y_CTRL_t_ygain_val_src(data)                                          ((0x00000001&(data))>>0)
+#define TVE_IP_Y_CTRL_get_t_ygain_val(data)                                          ((0x00000001&(data))>>0)
+
+
+#define TVE_IP_TEST_PARAM                                                            0x18018984
+#define TVE_IP_TEST_PARAM_reg_addr                                                   "0xB8018984"
+#define TVE_IP_TEST_PARAM_reg                                                        0xB8018984
+#define set_TVE_IP_TEST_PARAM_reg(data)   (*((volatile unsigned int*) TVE_IP_TEST_PARAM_reg)=data)
+#define get_TVE_IP_TEST_PARAM_reg   (*((volatile unsigned int*) TVE_IP_TEST_PARAM_reg))
+#define TVE_IP_TEST_PARAM_inst_adr                                                   "0x0061"
+#define TVE_IP_TEST_PARAM_inst                                                       0x0061
+#define TVE_IP_TEST_PARAM_t_byp_yups_shift                                           (6)
+#define TVE_IP_TEST_PARAM_t_byp_yups_mask                                            (0x00000040)
+#define TVE_IP_TEST_PARAM_t_byp_yups(data)                                           (0x00000040&((data)<<6))
+#define TVE_IP_TEST_PARAM_t_byp_yups_src(data)                                       ((0x00000040&(data))>>6)
+#define TVE_IP_TEST_PARAM_get_t_byp_yups(data)                                       ((0x00000040&(data))>>6)
+#define TVE_IP_TEST_PARAM_t_sel_ylp_shift                                            (5)
+#define TVE_IP_TEST_PARAM_t_sel_ylp_mask                                             (0x00000020)
+#define TVE_IP_TEST_PARAM_t_sel_ylp(data)                                            (0x00000020&((data)<<5))
+#define TVE_IP_TEST_PARAM_t_sel_ylp_src(data)                                        ((0x00000020&(data))>>5)
+#define TVE_IP_TEST_PARAM_get_t_sel_ylp(data)                                        ((0x00000020&(data))>>5)
+#define TVE_IP_TEST_PARAM_t_ygain_off_shift                                          (4)
+#define TVE_IP_TEST_PARAM_t_ygain_off_mask                                           (0x00000010)
+#define TVE_IP_TEST_PARAM_t_ygain_off(data)                                          (0x00000010&((data)<<4))
+#define TVE_IP_TEST_PARAM_t_ygain_off_src(data)                                      ((0x00000010&(data))>>4)
+#define TVE_IP_TEST_PARAM_get_t_ygain_off(data)                                      ((0x00000010&(data))>>4)
+#define TVE_IP_TEST_PARAM_y_tsin_cos_shift                                           (3)
+#define TVE_IP_TEST_PARAM_y_tsin_cos_mask                                            (0x00000008)
+#define TVE_IP_TEST_PARAM_y_tsin_cos(data)                                           (0x00000008&((data)<<3))
+#define TVE_IP_TEST_PARAM_y_tsin_cos_src(data)                                       ((0x00000008&(data))>>3)
+#define TVE_IP_TEST_PARAM_get_y_tsin_cos(data)                                       ((0x00000008&(data))>>3)
+#define TVE_IP_TEST_PARAM_y_tsel_dac_tst_shift                                       (2)
+#define TVE_IP_TEST_PARAM_y_tsel_dac_tst_mask                                        (0x00000004)
+#define TVE_IP_TEST_PARAM_y_tsel_dac_tst(data)                                       (0x00000004&((data)<<2))
+#define TVE_IP_TEST_PARAM_y_tsel_dac_tst_src(data)                                   ((0x00000004&(data))>>2)
+#define TVE_IP_TEST_PARAM_get_y_tsel_dac_tst(data)                                   ((0x00000004&(data))>>2)
+#define TVE_IP_TEST_PARAM_y_tdig_out_shift                                           (0)
+#define TVE_IP_TEST_PARAM_y_tdig_out_mask                                            (0x00000003)
+#define TVE_IP_TEST_PARAM_y_tdig_out(data)                                           (0x00000003&((data)<<0))
+#define TVE_IP_TEST_PARAM_y_tdig_out_src(data)                                       ((0x00000003&(data))>>0)
+#define TVE_IP_TEST_PARAM_get_y_tdig_out(data)                                       ((0x00000003&(data))>>0)
+
+
+#define TVE_IP_Y_GAIN                                                                0x18018a00
+#define TVE_IP_Y_GAIN_reg_addr                                                       "0xB8018A00"
+#define TVE_IP_Y_GAIN_reg                                                            0xB8018A00
+#define set_TVE_IP_Y_GAIN_reg(data)   (*((volatile unsigned int*) TVE_IP_Y_GAIN_reg)=data)
+#define get_TVE_IP_Y_GAIN_reg   (*((volatile unsigned int*) TVE_IP_Y_GAIN_reg))
+#define TVE_IP_Y_GAIN_inst_adr                                                       "0x0080"
+#define TVE_IP_Y_GAIN_inst                                                           0x0080
+#define TVE_IP_Y_GAIN_y_gain_shift                                                   (0)
+#define TVE_IP_Y_GAIN_y_gain_mask                                                    (0x000003FF)
+#define TVE_IP_Y_GAIN_y_gain(data)                                                   (0x000003FF&((data)<<0))
+#define TVE_IP_Y_GAIN_y_gain_src(data)                                               ((0x000003FF&(data))>>0)
+#define TVE_IP_Y_GAIN_get_y_gain(data)                                               ((0x000003FF&(data))>>0)
+
+
+#define TVE_IP_SYNC_LVL2                                                             0x180189c0
+#define TVE_IP_SYNC_LVL2_reg_addr                                                    "0xB80189C0"
+#define TVE_IP_SYNC_LVL2_reg                                                         0xB80189C0
+#define set_TVE_IP_SYNC_LVL2_reg(data)   (*((volatile unsigned int*) TVE_IP_SYNC_LVL2_reg)=data)
+#define get_TVE_IP_SYNC_LVL2_reg   (*((volatile unsigned int*) TVE_IP_SYNC_LVL2_reg))
+#define TVE_IP_SYNC_LVL2_inst_adr                                                    "0x0070"
+#define TVE_IP_SYNC_LVL2_inst                                                        0x0070
+#define TVE_IP_SYNC_LVL2_sync_lvl_h_shift                                            (0)
+#define TVE_IP_SYNC_LVL2_sync_lvl_h_mask                                             (0x000000FF)
+#define TVE_IP_SYNC_LVL2_sync_lvl_h(data)                                            (0x000000FF&((data)<<0))
+#define TVE_IP_SYNC_LVL2_sync_lvl_h_src(data)                                        ((0x000000FF&(data))>>0)
+#define TVE_IP_SYNC_LVL2_get_sync_lvl_h(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_SYNC_LVL3                                                             0x180189c4
+#define TVE_IP_SYNC_LVL3_reg_addr                                                    "0xB80189C4"
+#define TVE_IP_SYNC_LVL3_reg                                                         0xB80189C4
+#define set_TVE_IP_SYNC_LVL3_reg(data)   (*((volatile unsigned int*) TVE_IP_SYNC_LVL3_reg)=data)
+#define get_TVE_IP_SYNC_LVL3_reg   (*((volatile unsigned int*) TVE_IP_SYNC_LVL3_reg))
+#define TVE_IP_SYNC_LVL3_inst_adr                                                    "0x0071"
+#define TVE_IP_SYNC_LVL3_inst                                                        0x0071
+#define TVE_IP_SYNC_LVL3_sync_lvl_m_shift                                            (0)
+#define TVE_IP_SYNC_LVL3_sync_lvl_m_mask                                             (0x000000FF)
+#define TVE_IP_SYNC_LVL3_sync_lvl_m(data)                                            (0x000000FF&((data)<<0))
+#define TVE_IP_SYNC_LVL3_sync_lvl_m_src(data)                                        ((0x000000FF&(data))>>0)
+#define TVE_IP_SYNC_LVL3_get_sync_lvl_m(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_SYNC_LVL4                                                             0x180189c8
+#define TVE_IP_SYNC_LVL4_reg_addr                                                    "0xB80189C8"
+#define TVE_IP_SYNC_LVL4_reg                                                         0xB80189C8
+#define set_TVE_IP_SYNC_LVL4_reg(data)   (*((volatile unsigned int*) TVE_IP_SYNC_LVL4_reg)=data)
+#define get_TVE_IP_SYNC_LVL4_reg   (*((volatile unsigned int*) TVE_IP_SYNC_LVL4_reg))
+#define TVE_IP_SYNC_LVL4_inst_adr                                                    "0x0072"
+#define TVE_IP_SYNC_LVL4_inst                                                        0x0072
+#define TVE_IP_SYNC_LVL4_sync_lvl_l_shift                                            (0)
+#define TVE_IP_SYNC_LVL4_sync_lvl_l_mask                                             (0x000000FF)
+#define TVE_IP_SYNC_LVL4_sync_lvl_l(data)                                            (0x000000FF&((data)<<0))
+#define TVE_IP_SYNC_LVL4_sync_lvl_l_src(data)                                        ((0x000000FF&(data))>>0)
+#define TVE_IP_SYNC_LVL4_get_sync_lvl_l(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_O_CTRL                                                                0x180188bc
+#define TVE_IP_O_CTRL_reg_addr                                                       "0xB80188BC"
+#define TVE_IP_O_CTRL_reg                                                            0xB80188BC
+#define set_TVE_IP_O_CTRL_reg(data)   (*((volatile unsigned int*) TVE_IP_O_CTRL_reg)=data)
+#define get_TVE_IP_O_CTRL_reg   (*((volatile unsigned int*) TVE_IP_O_CTRL_reg))
+#define TVE_IP_O_CTRL_inst_adr                                                       "0x002F"
+#define TVE_IP_O_CTRL_inst                                                           0x002F
+#define TVE_IP_O_CTRL_y_tsel_yuv_shift                                               (3)
+#define TVE_IP_O_CTRL_y_tsel_yuv_mask                                                (0x00000008)
+#define TVE_IP_O_CTRL_y_tsel_yuv(data)                                               (0x00000008&((data)<<3))
+#define TVE_IP_O_CTRL_y_tsel_yuv_src(data)                                           ((0x00000008&(data))>>3)
+#define TVE_IP_O_CTRL_get_y_tsel_yuv(data)                                           ((0x00000008&(data))>>3)
+#define TVE_IP_O_CTRL_t_pd_cvdac_shift                                               (2)
+#define TVE_IP_O_CTRL_t_pd_cvdac_mask                                                (0x00000004)
+#define TVE_IP_O_CTRL_t_pd_cvdac(data)                                               (0x00000004&((data)<<2))
+#define TVE_IP_O_CTRL_t_pd_cvdac_src(data)                                           ((0x00000004&(data))>>2)
+#define TVE_IP_O_CTRL_get_t_pd_cvdac(data)                                           ((0x00000004&(data))>>2)
+#define TVE_IP_O_CTRL_t_pd_ydac_shift                                                (1)
+#define TVE_IP_O_CTRL_t_pd_ydac_mask                                                 (0x00000002)
+#define TVE_IP_O_CTRL_t_pd_ydac(data)                                                (0x00000002&((data)<<1))
+#define TVE_IP_O_CTRL_t_pd_ydac_src(data)                                            ((0x00000002&(data))>>1)
+#define TVE_IP_O_CTRL_get_t_pd_ydac(data)                                            ((0x00000002&(data))>>1)
+#define TVE_IP_O_CTRL_t_pd_cdac_shift                                                (0)
+#define TVE_IP_O_CTRL_t_pd_cdac_mask                                                 (0x00000001)
+#define TVE_IP_O_CTRL_t_pd_cdac(data)                                                (0x00000001&((data)<<0))
+#define TVE_IP_O_CTRL_t_pd_cdac_src(data)                                            ((0x00000001&(data))>>0)
+#define TVE_IP_O_CTRL_get_t_pd_cdac(data)                                            ((0x00000001&(data))>>0)
+
+
+#define TVE_IP_NBA                                                                   0x180188c8
+#define TVE_IP_NBA_reg_addr                                                          "0xB80188C8"
+#define TVE_IP_NBA_reg                                                               0xB80188C8
+#define set_TVE_IP_NBA_reg(data)   (*((volatile unsigned int*) TVE_IP_NBA_reg)=data)
+#define get_TVE_IP_NBA_reg   (*((volatile unsigned int*) TVE_IP_NBA_reg))
+#define TVE_IP_NBA_inst_adr                                                          "0x0032"
+#define TVE_IP_NBA_inst                                                              0x0032
+#define TVE_IP_NBA_nba_shift                                                         (0)
+#define TVE_IP_NBA_nba_mask                                                          (0x000000FF)
+#define TVE_IP_NBA_nba(data)                                                         (0x000000FF&((data)<<0))
+#define TVE_IP_NBA_nba_src(data)                                                     ((0x000000FF&(data))>>0)
+#define TVE_IP_NBA_get_nba(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_PBA                                                                   0x180188cc
+#define TVE_IP_PBA_reg_addr                                                          "0xB80188CC"
+#define TVE_IP_PBA_reg                                                               0xB80188CC
+#define set_TVE_IP_PBA_reg(data)   (*((volatile unsigned int*) TVE_IP_PBA_reg)=data)
+#define get_TVE_IP_PBA_reg   (*((volatile unsigned int*) TVE_IP_PBA_reg))
+#define TVE_IP_PBA_inst_adr                                                          "0x0033"
+#define TVE_IP_PBA_inst                                                              0x0033
+#define TVE_IP_PBA_pba_shift                                                         (0)
+#define TVE_IP_PBA_pba_mask                                                          (0x000000FF)
+#define TVE_IP_PBA_pba(data)                                                         (0x000000FF&((data)<<0))
+#define TVE_IP_PBA_pba_src(data)                                                     ((0x000000FF&(data))>>0)
+#define TVE_IP_PBA_get_pba(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_C_CTRL                                                                0x180188d0
+#define TVE_IP_C_CTRL_reg_addr                                                       "0xB80188D0"
+#define TVE_IP_C_CTRL_reg                                                            0xB80188D0
+#define set_TVE_IP_C_CTRL_reg(data)   (*((volatile unsigned int*) TVE_IP_C_CTRL_reg)=data)
+#define get_TVE_IP_C_CTRL_reg   (*((volatile unsigned int*) TVE_IP_C_CTRL_reg))
+#define TVE_IP_C_CTRL_inst_adr                                                       "0x0034"
+#define TVE_IP_C_CTRL_inst                                                           0x0034
+#define TVE_IP_C_CTRL_t_pal_clpf_shift                                               (1)
+#define TVE_IP_C_CTRL_t_pal_clpf_mask                                                (0x00000002)
+#define TVE_IP_C_CTRL_t_pal_clpf(data)                                               (0x00000002&((data)<<1))
+#define TVE_IP_C_CTRL_t_pal_clpf_src(data)                                           ((0x00000002&(data))>>1)
+#define TVE_IP_C_CTRL_get_t_pal_clpf(data)                                           ((0x00000002&(data))>>1)
+#define TVE_IP_C_CTRL_t_sel_c_gain_shift                                             (0)
+#define TVE_IP_C_CTRL_t_sel_c_gain_mask                                              (0x00000001)
+#define TVE_IP_C_CTRL_t_sel_c_gain(data)                                             (0x00000001&((data)<<0))
+#define TVE_IP_C_CTRL_t_sel_c_gain_src(data)                                         ((0x00000001&(data))>>0)
+#define TVE_IP_C_CTRL_get_t_sel_c_gain(data)                                         ((0x00000001&(data))>>0)
+
+
+#define TVE_IP_TEST_T_BYP_CUPS                                                       0x1801898c
+#define TVE_IP_TEST_T_BYP_CUPS_reg_addr                                              "0xB801898C"
+#define TVE_IP_TEST_T_BYP_CUPS_reg                                                   0xB801898C
+#define set_TVE_IP_TEST_T_BYP_CUPS_reg(data)   (*((volatile unsigned int*) TVE_IP_TEST_T_BYP_CUPS_reg)=data)
+#define get_TVE_IP_TEST_T_BYP_CUPS_reg   (*((volatile unsigned int*) TVE_IP_TEST_T_BYP_CUPS_reg))
+#define TVE_IP_TEST_T_BYP_CUPS_inst_adr                                              "0x0063"
+#define TVE_IP_TEST_T_BYP_CUPS_inst                                                  0x0063
+#define TVE_IP_TEST_T_BYP_CUPS_t_byp_cups_shift                                      (2)
+#define TVE_IP_TEST_T_BYP_CUPS_t_byp_cups_mask                                       (0x00000004)
+#define TVE_IP_TEST_T_BYP_CUPS_t_byp_cups(data)                                      (0x00000004&((data)<<2))
+#define TVE_IP_TEST_T_BYP_CUPS_t_byp_cups_src(data)                                  ((0x00000004&(data))>>2)
+#define TVE_IP_TEST_T_BYP_CUPS_get_t_byp_cups(data)                                  ((0x00000004&(data))>>2)
+#define TVE_IP_TEST_T_BYP_CUPS_t_byp_clpf_shift                                      (1)
+#define TVE_IP_TEST_T_BYP_CUPS_t_byp_clpf_mask                                       (0x00000002)
+#define TVE_IP_TEST_T_BYP_CUPS_t_byp_clpf(data)                                      (0x00000002&((data)<<1))
+#define TVE_IP_TEST_T_BYP_CUPS_t_byp_clpf_src(data)                                  ((0x00000002&(data))>>1)
+#define TVE_IP_TEST_T_BYP_CUPS_get_t_byp_clpf(data)                                  ((0x00000002&(data))>>1)
+#define TVE_IP_TEST_T_BYP_CUPS_t_c_gain_off_shift                                    (0)
+#define TVE_IP_TEST_T_BYP_CUPS_t_c_gain_off_mask                                     (0x00000001)
+#define TVE_IP_TEST_T_BYP_CUPS_t_c_gain_off(data)                                    (0x00000001&((data)<<0))
+#define TVE_IP_TEST_T_BYP_CUPS_t_c_gain_off_src(data)                                ((0x00000001&(data))>>0)
+#define TVE_IP_TEST_T_BYP_CUPS_get_t_c_gain_off(data)                                ((0x00000001&(data))>>0)
+
+
+#define TVE_IP_SYNCLPF_GAIN                                                          0x180189cc
+#define TVE_IP_SYNCLPF_GAIN_reg_addr                                                 "0xB80189CC"
+#define TVE_IP_SYNCLPF_GAIN_reg                                                      0xB80189CC
+#define set_TVE_IP_SYNCLPF_GAIN_reg(data)   (*((volatile unsigned int*) TVE_IP_SYNCLPF_GAIN_reg)=data)
+#define get_TVE_IP_SYNCLPF_GAIN_reg   (*((volatile unsigned int*) TVE_IP_SYNCLPF_GAIN_reg))
+#define TVE_IP_SYNCLPF_GAIN_inst_adr                                                 "0x0073"
+#define TVE_IP_SYNCLPF_GAIN_inst                                                     0x0073
+#define TVE_IP_SYNCLPF_GAIN_clpf_gain_shift                                          (0)
+#define TVE_IP_SYNCLPF_GAIN_clpf_gain_mask                                           (0x000000FF)
+#define TVE_IP_SYNCLPF_GAIN_clpf_gain(data)                                          (0x000000FF&((data)<<0))
+#define TVE_IP_SYNCLPF_GAIN_clpf_gain_src(data)                                      ((0x000000FF&(data))>>0)
+#define TVE_IP_SYNCLPF_GAIN_get_clpf_gain(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_S_CTRL                                                                0x180188e0
+#define TVE_IP_S_CTRL_reg_addr                                                       "0xB80188E0"
+#define TVE_IP_S_CTRL_reg                                                            0xB80188E0
+#define set_TVE_IP_S_CTRL_reg(data)   (*((volatile unsigned int*) TVE_IP_S_CTRL_reg)=data)
+#define get_TVE_IP_S_CTRL_reg   (*((volatile unsigned int*) TVE_IP_S_CTRL_reg))
+#define TVE_IP_S_CTRL_inst_adr                                                       "0x0038"
+#define TVE_IP_S_CTRL_inst                                                           0x0038
+#define TVE_IP_S_CTRL_t_hsync_phs_shift                                              (7)
+#define TVE_IP_S_CTRL_t_hsync_phs_mask                                               (0x00000080)
+#define TVE_IP_S_CTRL_t_hsync_phs(data)                                              (0x00000080&((data)<<7))
+#define TVE_IP_S_CTRL_t_hsync_phs_src(data)                                          ((0x00000080&(data))>>7)
+#define TVE_IP_S_CTRL_get_t_hsync_phs(data)                                          ((0x00000080&(data))>>7)
+#define TVE_IP_S_CTRL_t_vsync_phs_shift                                              (6)
+#define TVE_IP_S_CTRL_t_vsync_phs_mask                                               (0x00000040)
+#define TVE_IP_S_CTRL_t_vsync_phs(data)                                              (0x00000040&((data)<<6))
+#define TVE_IP_S_CTRL_t_vsync_phs_src(data)                                          ((0x00000040&(data))>>6)
+#define TVE_IP_S_CTRL_get_t_vsync_phs(data)                                          ((0x00000040&(data))>>6)
+#define TVE_IP_S_CTRL_y_tsyncmode_shift                                              (3)
+#define TVE_IP_S_CTRL_y_tsyncmode_mask                                               (0x00000038)
+#define TVE_IP_S_CTRL_y_tsyncmode(data)                                              (0x00000038&((data)<<3))
+#define TVE_IP_S_CTRL_y_tsyncmode_src(data)                                          ((0x00000038&(data))>>3)
+#define TVE_IP_S_CTRL_get_y_tsyncmode(data)                                          ((0x00000038&(data))>>3)
+#define TVE_IP_S_CTRL_y_tencd_mode_shift                                             (0)
+#define TVE_IP_S_CTRL_y_tencd_mode_mask                                              (0x00000007)
+#define TVE_IP_S_CTRL_y_tencd_mode(data)                                             (0x00000007&((data)<<0))
+#define TVE_IP_S_CTRL_y_tencd_mode_src(data)                                         ((0x00000007&(data))>>0)
+#define TVE_IP_S_CTRL_get_y_tencd_mode(data)                                         ((0x00000007&(data))>>0)
+
+
+#define TVE_IP_VSO0                                                                  0x180188e4
+#define TVE_IP_VSO0_reg_addr                                                         "0xB80188E4"
+#define TVE_IP_VSO0_reg                                                              0xB80188E4
+#define set_TVE_IP_VSO0_reg(data)   (*((volatile unsigned int*) TVE_IP_VSO0_reg)=data)
+#define get_TVE_IP_VSO0_reg   (*((volatile unsigned int*) TVE_IP_VSO0_reg))
+#define TVE_IP_VSO0_inst_adr                                                         "0x0039"
+#define TVE_IP_VSO0_inst                                                             0x0039
+#define TVE_IP_VSO0_clk_phs_shift                                                    (6)
+#define TVE_IP_VSO0_clk_phs_mask                                                     (0x000000C0)
+#define TVE_IP_VSO0_clk_phs(data)                                                    (0x000000C0&((data)<<6))
+#define TVE_IP_VSO0_clk_phs_src(data)                                                ((0x000000C0&(data))>>6)
+#define TVE_IP_VSO0_get_clk_phs(data)                                                ((0x000000C0&(data))>>6)
+#define TVE_IP_VSO0_t_fsync_enbl_shift                                               (5)
+#define TVE_IP_VSO0_t_fsync_enbl_mask                                                (0x00000020)
+#define TVE_IP_VSO0_t_fsync_enbl(data)                                               (0x00000020&((data)<<5))
+#define TVE_IP_VSO0_t_fsync_enbl_src(data)                                           ((0x00000020&(data))>>5)
+#define TVE_IP_VSO0_get_t_fsync_enbl(data)                                           ((0x00000020&(data))>>5)
+#define TVE_IP_VSO0_t_fsync_phs_shift                                                (4)
+#define TVE_IP_VSO0_t_fsync_phs_mask                                                 (0x00000010)
+#define TVE_IP_VSO0_t_fsync_phs(data)                                                (0x00000010&((data)<<4))
+#define TVE_IP_VSO0_t_fsync_phs_src(data)                                            ((0x00000010&(data))>>4)
+#define TVE_IP_VSO0_get_t_fsync_phs(data)                                            ((0x00000010&(data))>>4)
+#define TVE_IP_VSO0_vso_shift                                                        (0)
+#define TVE_IP_VSO0_vso_mask                                                         (0x00000003)
+#define TVE_IP_VSO0_vso(data)                                                        (0x00000003&((data)<<0))
+#define TVE_IP_VSO0_vso_src(data)                                                    ((0x00000003&(data))>>0)
+#define TVE_IP_VSO0_get_vso(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define TVE_IP_VSO1                                                                  0x180188e8
+#define TVE_IP_VSO1_reg_addr                                                         "0xB80188E8"
+#define TVE_IP_VSO1_reg                                                              0xB80188E8
+#define set_TVE_IP_VSO1_reg(data)   (*((volatile unsigned int*) TVE_IP_VSO1_reg)=data)
+#define get_TVE_IP_VSO1_reg   (*((volatile unsigned int*) TVE_IP_VSO1_reg))
+#define TVE_IP_VSO1_inst_adr                                                         "0x003A"
+#define TVE_IP_VSO1_inst                                                             0x003A
+#define TVE_IP_VSO1_vso_shift                                                        (0)
+#define TVE_IP_VSO1_vso_mask                                                         (0x000000FF)
+#define TVE_IP_VSO1_vso(data)                                                        (0x000000FF&((data)<<0))
+#define TVE_IP_VSO1_vso_src(data)                                                    ((0x000000FF&(data))>>0)
+#define TVE_IP_VSO1_get_vso(data)                                                    ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_HSO0                                                                  0x180188ec
+#define TVE_IP_HSO0_reg_addr                                                         "0xB80188EC"
+#define TVE_IP_HSO0_reg                                                              0xB80188EC
+#define set_TVE_IP_HSO0_reg(data)   (*((volatile unsigned int*) TVE_IP_HSO0_reg)=data)
+#define get_TVE_IP_HSO0_reg   (*((volatile unsigned int*) TVE_IP_HSO0_reg))
+#define TVE_IP_HSO0_inst_adr                                                         "0x003B"
+#define TVE_IP_HSO0_inst                                                             0x003B
+#define TVE_IP_HSO0_hso_shift                                                        (0)
+#define TVE_IP_HSO0_hso_mask                                                         (0x00000007)
+#define TVE_IP_HSO0_hso(data)                                                        (0x00000007&((data)<<0))
+#define TVE_IP_HSO0_hso_src(data)                                                    ((0x00000007&(data))>>0)
+#define TVE_IP_HSO0_get_hso(data)                                                    ((0x00000007&(data))>>0)
+
+
+#define TVE_IP_HSO1                                                                  0x180188f0
+#define TVE_IP_HSO1_reg_addr                                                         "0xB80188F0"
+#define TVE_IP_HSO1_reg                                                              0xB80188F0
+#define set_TVE_IP_HSO1_reg(data)   (*((volatile unsigned int*) TVE_IP_HSO1_reg)=data)
+#define get_TVE_IP_HSO1_reg   (*((volatile unsigned int*) TVE_IP_HSO1_reg))
+#define TVE_IP_HSO1_inst_adr                                                         "0x003C"
+#define TVE_IP_HSO1_inst                                                             0x003C
+#define TVE_IP_HSO1_hso_shift                                                        (0)
+#define TVE_IP_HSO1_hso_mask                                                         (0x000000FF)
+#define TVE_IP_HSO1_hso(data)                                                        (0x000000FF&((data)<<0))
+#define TVE_IP_HSO1_hso_src(data)                                                    ((0x000000FF&(data))>>0)
+#define TVE_IP_HSO1_get_hso(data)                                                    ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_HLC0                                                                  0x180188f4
+#define TVE_IP_HLC0_reg_addr                                                         "0xB80188F4"
+#define TVE_IP_HLC0_reg                                                              0xB80188F4
+#define set_TVE_IP_HLC0_reg(data)   (*((volatile unsigned int*) TVE_IP_HLC0_reg)=data)
+#define get_TVE_IP_HLC0_reg   (*((volatile unsigned int*) TVE_IP_HLC0_reg))
+#define TVE_IP_HLC0_inst_adr                                                         "0x003D"
+#define TVE_IP_HLC0_inst                                                             0x003D
+#define TVE_IP_HLC0_hlc_shift                                                        (0)
+#define TVE_IP_HLC0_hlc_mask                                                         (0x00000003)
+#define TVE_IP_HLC0_hlc(data)                                                        (0x00000003&((data)<<0))
+#define TVE_IP_HLC0_hlc_src(data)                                                    ((0x00000003&(data))>>0)
+#define TVE_IP_HLC0_get_hlc(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define TVE_IP_HLC1                                                                  0x180188f8
+#define TVE_IP_HLC1_reg_addr                                                         "0xB80188F8"
+#define TVE_IP_HLC1_reg                                                              0xB80188F8
+#define set_TVE_IP_HLC1_reg(data)   (*((volatile unsigned int*) TVE_IP_HLC1_reg)=data)
+#define get_TVE_IP_HLC1_reg   (*((volatile unsigned int*) TVE_IP_HLC1_reg))
+#define TVE_IP_HLC1_inst_adr                                                         "0x003E"
+#define TVE_IP_HLC1_inst                                                             0x003E
+#define TVE_IP_HLC1_hlc_shift                                                        (0)
+#define TVE_IP_HLC1_hlc_mask                                                         (0x000000FF)
+#define TVE_IP_HLC1_hlc(data)                                                        (0x000000FF&((data)<<0))
+#define TVE_IP_HLC1_hlc_src(data)                                                    ((0x000000FF&(data))>>0)
+#define TVE_IP_HLC1_get_hlc(data)                                                    ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_CCD_ODD_0                                                             0x18018904
+#define TVE_IP_CCD_ODD_1                                                             0x18018908
+#define TVE_IP_CCD_ODD_0_reg_addr                                                    "0xB8018904"
+#define TVE_IP_CCD_ODD_1_reg_addr                                                    "0xB8018908"
+#define TVE_IP_CCD_ODD_0_reg                                                         0xB8018904
+#define TVE_IP_CCD_ODD_1_reg                                                         0xB8018908
+#define set_TVE_IP_CCD_ODD_0_reg(data)   (*((volatile unsigned int*) TVE_IP_CCD_ODD_0_reg)=data)
+#define set_TVE_IP_CCD_ODD_1_reg(data)   (*((volatile unsigned int*) TVE_IP_CCD_ODD_1_reg)=data)
+#define get_TVE_IP_CCD_ODD_0_reg   (*((volatile unsigned int*) TVE_IP_CCD_ODD_0_reg))
+#define get_TVE_IP_CCD_ODD_1_reg   (*((volatile unsigned int*) TVE_IP_CCD_ODD_1_reg))
+#define TVE_IP_CCD_ODD_0_inst_adr                                                    "0x0041"
+#define TVE_IP_CCD_ODD_1_inst_adr                                                    "0x0042"
+#define TVE_IP_CCD_ODD_0_inst                                                        0x0041
+#define TVE_IP_CCD_ODD_1_inst                                                        0x0042
+#define TVE_IP_CCD_ODD_ccd_odd_shift                                                 (0)
+#define TVE_IP_CCD_ODD_ccd_odd_mask                                                  (0x000000FF)
+#define TVE_IP_CCD_ODD_ccd_odd(data)                                                 (0x000000FF&((data)<<0))
+#define TVE_IP_CCD_ODD_ccd_odd_src(data)                                             ((0x000000FF&(data))>>0)
+#define TVE_IP_CCD_ODD_get_ccd_odd(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_CCD_EVEN_0                                                            0x1801890C
+#define TVE_IP_CCD_EVEN_1                                                            0x18018910
+#define TVE_IP_CCD_EVEN_0_reg_addr                                                   "0xB801890C"
+#define TVE_IP_CCD_EVEN_1_reg_addr                                                   "0xB8018910"
+#define TVE_IP_CCD_EVEN_0_reg                                                        0xB801890C
+#define TVE_IP_CCD_EVEN_1_reg                                                        0xB8018910
+#define set_TVE_IP_CCD_EVEN_0_reg(data)   (*((volatile unsigned int*) TVE_IP_CCD_EVEN_0_reg)=data)
+#define set_TVE_IP_CCD_EVEN_1_reg(data)   (*((volatile unsigned int*) TVE_IP_CCD_EVEN_1_reg)=data)
+#define get_TVE_IP_CCD_EVEN_0_reg   (*((volatile unsigned int*) TVE_IP_CCD_EVEN_0_reg))
+#define get_TVE_IP_CCD_EVEN_1_reg   (*((volatile unsigned int*) TVE_IP_CCD_EVEN_1_reg))
+#define TVE_IP_CCD_EVEN_0_inst_adr                                                   "0x0043"
+#define TVE_IP_CCD_EVEN_1_inst_adr                                                   "0x0044"
+#define TVE_IP_CCD_EVEN_0_inst                                                       0x0043
+#define TVE_IP_CCD_EVEN_1_inst                                                       0x0044
+#define TVE_IP_CCD_EVEN_ccd_even_shift                                               (0)
+#define TVE_IP_CCD_EVEN_ccd_even_mask                                                (0x000000FF)
+#define TVE_IP_CCD_EVEN_ccd_even(data)                                               (0x000000FF&((data)<<0))
+#define TVE_IP_CCD_EVEN_ccd_even_src(data)                                           ((0x000000FF&(data))>>0)
+#define TVE_IP_CCD_EVEN_get_ccd_even(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_CCD_ENBL                                                              0x18018914
+#define TVE_IP_CCD_ENBL_reg_addr                                                     "0xB8018914"
+#define TVE_IP_CCD_ENBL_reg                                                          0xB8018914
+#define set_TVE_IP_CCD_ENBL_reg(data)   (*((volatile unsigned int*) TVE_IP_CCD_ENBL_reg)=data)
+#define get_TVE_IP_CCD_ENBL_reg   (*((volatile unsigned int*) TVE_IP_CCD_ENBL_reg))
+#define TVE_IP_CCD_ENBL_inst_adr                                                     "0x0045"
+#define TVE_IP_CCD_ENBL_inst                                                         0x0045
+#define TVE_IP_CCD_ENBL_cc_enbl_shift                                                (0)
+#define TVE_IP_CCD_ENBL_cc_enbl_mask                                                 (0x00000003)
+#define TVE_IP_CCD_ENBL_cc_enbl(data)                                                (0x00000003&((data)<<0))
+#define TVE_IP_CCD_ENBL_cc_enbl_src(data)                                            ((0x00000003&(data))>>0)
+#define TVE_IP_CCD_ENBL_get_cc_enbl(data)                                            ((0x00000003&(data))>>0)
+
+
+#define TVE_IP_TEST_HLR0                                                             0x180189b4
+#define TVE_IP_TEST_HLR0_reg_addr                                                    "0xB80189B4"
+#define TVE_IP_TEST_HLR0_reg                                                         0xB80189B4
+#define set_TVE_IP_TEST_HLR0_reg(data)   (*((volatile unsigned int*) TVE_IP_TEST_HLR0_reg)=data)
+#define get_TVE_IP_TEST_HLR0_reg   (*((volatile unsigned int*) TVE_IP_TEST_HLR0_reg))
+#define TVE_IP_TEST_HLR0_inst_adr                                                    "0x006D"
+#define TVE_IP_TEST_HLR0_inst                                                        0x006D
+#define TVE_IP_TEST_HLR0_hlr_shift                                                   (0)
+#define TVE_IP_TEST_HLR0_hlr_mask                                                    (0x00000003)
+#define TVE_IP_TEST_HLR0_hlr(data)                                                   (0x00000003&((data)<<0))
+#define TVE_IP_TEST_HLR0_hlr_src(data)                                               ((0x00000003&(data))>>0)
+#define TVE_IP_TEST_HLR0_get_hlr(data)                                               ((0x00000003&(data))>>0)
+
+
+#define TVE_IP_TEST_HLR1                                                             0x180189b8
+#define TVE_IP_TEST_HLR1_reg_addr                                                    "0xB80189B8"
+#define TVE_IP_TEST_HLR1_reg                                                         0xB80189B8
+#define set_TVE_IP_TEST_HLR1_reg(data)   (*((volatile unsigned int*) TVE_IP_TEST_HLR1_reg)=data)
+#define get_TVE_IP_TEST_HLR1_reg   (*((volatile unsigned int*) TVE_IP_TEST_HLR1_reg))
+#define TVE_IP_TEST_HLR1_inst_adr                                                    "0x006E"
+#define TVE_IP_TEST_HLR1_inst                                                        0x006E
+#define TVE_IP_TEST_HLR1_hlr_shift                                                   (0)
+#define TVE_IP_TEST_HLR1_hlr_mask                                                    (0x000000FF)
+#define TVE_IP_TEST_HLR1_hlr(data)                                                   (0x000000FF&((data)<<0))
+#define TVE_IP_TEST_HLR1_hlr_src(data)                                               ((0x000000FF&(data))>>0)
+#define TVE_IP_TEST_HLR1_get_hlr(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_TEST_VSMR                                                             0x180189bc
+#define TVE_IP_TEST_VSMR_reg_addr                                                    "0xB80189BC"
+#define TVE_IP_TEST_VSMR_reg                                                         0xB80189BC
+#define set_TVE_IP_TEST_VSMR_reg(data)   (*((volatile unsigned int*) TVE_IP_TEST_VSMR_reg)=data)
+#define get_TVE_IP_TEST_VSMR_reg   (*((volatile unsigned int*) TVE_IP_TEST_VSMR_reg))
+#define TVE_IP_TEST_VSMR_inst_adr                                                    "0x006F"
+#define TVE_IP_TEST_VSMR_inst                                                        0x006F
+#define TVE_IP_TEST_VSMR_vsmr_shift                                                  (0)
+#define TVE_IP_TEST_VSMR_vsmr_mask                                                   (0x0000001F)
+#define TVE_IP_TEST_VSMR_vsmr(data)                                                  (0x0000001F&((data)<<0))
+#define TVE_IP_TEST_VSMR_vsmr_src(data)                                              ((0x0000001F&(data))>>0)
+#define TVE_IP_TEST_VSMR_get_vsmr(data)                                              ((0x0000001F&(data))>>0)
+
+
+#define TVE_IP_SYNC_STRT                                                             0x180189d0
+#define TVE_IP_SYNC_STRT_reg_addr                                                    "0xB80189D0"
+#define TVE_IP_SYNC_STRT_reg                                                         0xB80189D0
+#define set_TVE_IP_SYNC_STRT_reg(data)   (*((volatile unsigned int*) TVE_IP_SYNC_STRT_reg)=data)
+#define get_TVE_IP_SYNC_STRT_reg   (*((volatile unsigned int*) TVE_IP_SYNC_STRT_reg))
+#define TVE_IP_SYNC_STRT_inst_adr                                                    "0x0074"
+#define TVE_IP_SYNC_STRT_inst                                                        0x0074
+#define TVE_IP_SYNC_STRT_sync_strt_shift                                             (0)
+#define TVE_IP_SYNC_STRT_sync_strt_mask                                              (0x0000000F)
+#define TVE_IP_SYNC_STRT_sync_strt(data)                                             (0x0000000F&((data)<<0))
+#define TVE_IP_SYNC_STRT_sync_strt_src(data)                                         ((0x0000000F&(data))>>0)
+#define TVE_IP_SYNC_STRT_get_sync_strt(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define TVE_IP_SYNC_END                                                              0x180189d4
+#define TVE_IP_SYNC_END_reg_addr                                                     "0xB80189D4"
+#define TVE_IP_SYNC_END_reg                                                          0xB80189D4
+#define set_TVE_IP_SYNC_END_reg(data)   (*((volatile unsigned int*) TVE_IP_SYNC_END_reg)=data)
+#define get_TVE_IP_SYNC_END_reg   (*((volatile unsigned int*) TVE_IP_SYNC_END_reg))
+#define TVE_IP_SYNC_END_inst_adr                                                     "0x0075"
+#define TVE_IP_SYNC_END_inst                                                         0x0075
+#define TVE_IP_SYNC_END_sync_end_shift                                               (0)
+#define TVE_IP_SYNC_END_sync_end_mask                                                (0x0000007F)
+#define TVE_IP_SYNC_END_sync_end(data)                                               (0x0000007F&((data)<<0))
+#define TVE_IP_SYNC_END_sync_end_src(data)                                           ((0x0000007F&(data))>>0)
+#define TVE_IP_SYNC_END_get_sync_end(data)                                           ((0x0000007F&(data))>>0)
+
+
+#define TVE_IP_SYNC_SREND                                                            0x180189d8
+#define TVE_IP_SYNC_SREND_reg_addr                                                   "0xB80189D8"
+#define TVE_IP_SYNC_SREND_reg                                                        0xB80189D8
+#define set_TVE_IP_SYNC_SREND_reg(data)   (*((volatile unsigned int*) TVE_IP_SYNC_SREND_reg)=data)
+#define get_TVE_IP_SYNC_SREND_reg   (*((volatile unsigned int*) TVE_IP_SYNC_SREND_reg))
+#define TVE_IP_SYNC_SREND_inst_adr                                                   "0x0076"
+#define TVE_IP_SYNC_SREND_inst                                                       0x0076
+#define TVE_IP_SYNC_SREND_sync_srend_shift                                           (0)
+#define TVE_IP_SYNC_SREND_sync_srend_mask                                            (0x000000FF)
+#define TVE_IP_SYNC_SREND_sync_srend(data)                                           (0x000000FF&((data)<<0))
+#define TVE_IP_SYNC_SREND_sync_srend_src(data)                                       ((0x000000FF&(data))>>0)
+#define TVE_IP_SYNC_SREND_get_sync_srend(data)                                       ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_SYNC_EQEND                                                            0x180189dc
+#define TVE_IP_SYNC_EQEND_reg_addr                                                   "0xB80189DC"
+#define TVE_IP_SYNC_EQEND_reg                                                        0xB80189DC
+#define set_TVE_IP_SYNC_EQEND_reg(data)   (*((volatile unsigned int*) TVE_IP_SYNC_EQEND_reg)=data)
+#define get_TVE_IP_SYNC_EQEND_reg   (*((volatile unsigned int*) TVE_IP_SYNC_EQEND_reg))
+#define TVE_IP_SYNC_EQEND_inst_adr                                                   "0x0077"
+#define TVE_IP_SYNC_EQEND_inst                                                       0x0077
+#define TVE_IP_SYNC_EQEND_sync_eqend_shift                                           (0)
+#define TVE_IP_SYNC_EQEND_sync_eqend_mask                                            (0x0000003F)
+#define TVE_IP_SYNC_EQEND_sync_eqend(data)                                           (0x0000003F&((data)<<0))
+#define TVE_IP_SYNC_EQEND_sync_eqend_src(data)                                       ((0x0000003F&(data))>>0)
+#define TVE_IP_SYNC_EQEND_get_sync_eqend(data)                                       ((0x0000003F&(data))>>0)
+
+
+#define TVE_IP_ACTV_STRT                                                             0x180189e0
+#define TVE_IP_ACTV_STRT_reg_addr                                                    "0xB80189E0"
+#define TVE_IP_ACTV_STRT_reg                                                         0xB80189E0
+#define set_TVE_IP_ACTV_STRT_reg(data)   (*((volatile unsigned int*) TVE_IP_ACTV_STRT_reg)=data)
+#define get_TVE_IP_ACTV_STRT_reg   (*((volatile unsigned int*) TVE_IP_ACTV_STRT_reg))
+#define TVE_IP_ACTV_STRT_inst_adr                                                    "0x0078"
+#define TVE_IP_ACTV_STRT_inst                                                        0x0078
+#define TVE_IP_ACTV_STRT_actv_strt_shift                                             (0)
+#define TVE_IP_ACTV_STRT_actv_strt_mask                                              (0x000000FF)
+#define TVE_IP_ACTV_STRT_actv_strt(data)                                             (0x000000FF&((data)<<0))
+#define TVE_IP_ACTV_STRT_actv_strt_src(data)                                         ((0x000000FF&(data))>>0)
+#define TVE_IP_ACTV_STRT_get_actv_strt(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_ACTV_END                                                              0x180189e4
+#define TVE_IP_ACTV_END_reg_addr                                                     "0xB80189E4"
+#define TVE_IP_ACTV_END_reg                                                          0xB80189E4
+#define set_TVE_IP_ACTV_END_reg(data)   (*((volatile unsigned int*) TVE_IP_ACTV_END_reg)=data)
+#define get_TVE_IP_ACTV_END_reg   (*((volatile unsigned int*) TVE_IP_ACTV_END_reg))
+#define TVE_IP_ACTV_END_inst_adr                                                     "0x0079"
+#define TVE_IP_ACTV_END_inst                                                         0x0079
+#define TVE_IP_ACTV_END_actv_end_shift                                               (0)
+#define TVE_IP_ACTV_END_actv_end_mask                                                (0x000000FF)
+#define TVE_IP_ACTV_END_actv_end(data)                                               (0x000000FF&((data)<<0))
+#define TVE_IP_ACTV_END_actv_end_src(data)                                           ((0x000000FF&(data))>>0)
+#define TVE_IP_ACTV_END_get_actv_end(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_WBRST_STRT                                                            0x180189e8
+#define TVE_IP_WBRST_STRT_reg_addr                                                   "0xB80189E8"
+#define TVE_IP_WBRST_STRT_reg                                                        0xB80189E8
+#define set_TVE_IP_WBRST_STRT_reg(data)   (*((volatile unsigned int*) TVE_IP_WBRST_STRT_reg)=data)
+#define get_TVE_IP_WBRST_STRT_reg   (*((volatile unsigned int*) TVE_IP_WBRST_STRT_reg))
+#define TVE_IP_WBRST_STRT_inst_adr                                                   "0x007A"
+#define TVE_IP_WBRST_STRT_inst                                                       0x007A
+#define TVE_IP_WBRST_STRT_wbrst_strt_shift                                           (0)
+#define TVE_IP_WBRST_STRT_wbrst_strt_mask                                            (0x0000007F)
+#define TVE_IP_WBRST_STRT_wbrst_strt(data)                                           (0x0000007F&((data)<<0))
+#define TVE_IP_WBRST_STRT_wbrst_strt_src(data)                                       ((0x0000007F&(data))>>0)
+#define TVE_IP_WBRST_STRT_get_wbrst_strt(data)                                       ((0x0000007F&(data))>>0)
+
+
+#define TVE_IP_NBRST_STRT                                                            0x180189ec
+#define TVE_IP_NBRST_STRT_reg_addr                                                   "0xB80189EC"
+#define TVE_IP_NBRST_STRT_reg                                                        0xB80189EC
+#define set_TVE_IP_NBRST_STRT_reg(data)   (*((volatile unsigned int*) TVE_IP_NBRST_STRT_reg)=data)
+#define get_TVE_IP_NBRST_STRT_reg   (*((volatile unsigned int*) TVE_IP_NBRST_STRT_reg))
+#define TVE_IP_NBRST_STRT_inst_adr                                                   "0x007B"
+#define TVE_IP_NBRST_STRT_inst                                                       0x007B
+#define TVE_IP_NBRST_STRT_nbrst_strt_shift                                           (0)
+#define TVE_IP_NBRST_STRT_nbrst_strt_mask                                            (0x0000007F)
+#define TVE_IP_NBRST_STRT_nbrst_strt(data)                                           (0x0000007F&((data)<<0))
+#define TVE_IP_NBRST_STRT_nbrst_strt_src(data)                                       ((0x0000007F&(data))>>0)
+#define TVE_IP_NBRST_STRT_get_nbrst_strt(data)                                       ((0x0000007F&(data))>>0)
+
+
+#define TVE_IP_NBRST_END                                                             0x180189f0
+#define TVE_IP_NBRST_END_reg_addr                                                    "0xB80189F0"
+#define TVE_IP_NBRST_END_reg                                                         0xB80189F0
+#define set_TVE_IP_NBRST_END_reg(data)   (*((volatile unsigned int*) TVE_IP_NBRST_END_reg)=data)
+#define get_TVE_IP_NBRST_END_reg   (*((volatile unsigned int*) TVE_IP_NBRST_END_reg))
+#define TVE_IP_NBRST_END_inst_adr                                                    "0x007C"
+#define TVE_IP_NBRST_END_inst                                                        0x007C
+#define TVE_IP_NBRST_END_nbrst_end_shift                                             (0)
+#define TVE_IP_NBRST_END_nbrst_end_mask                                              (0x000000FF)
+#define TVE_IP_NBRST_END_nbrst_end(data)                                             (0x000000FF&((data)<<0))
+#define TVE_IP_NBRST_END_nbrst_end_src(data)                                         ((0x000000FF&(data))>>0)
+#define TVE_IP_NBRST_END_get_nbrst_end(data)                                         ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_MVFCR                                                                 0x18018920
+#define TVE_IP_MVFCR_reg_addr                                                        "0xB8018920"
+#define TVE_IP_MVFCR_reg                                                             0xB8018920
+#define set_TVE_IP_MVFCR_reg(data)   (*((volatile unsigned int*) TVE_IP_MVFCR_reg)=data)
+#define get_TVE_IP_MVFCR_reg   (*((volatile unsigned int*) TVE_IP_MVFCR_reg))
+#define TVE_IP_MVFCR_inst_adr                                                        "0x0048"
+#define TVE_IP_MVFCR_inst                                                            0x0048
+#define TVE_IP_MVFCR_mvfcr_shift                                                     (0)
+#define TVE_IP_MVFCR_mvfcr_mask                                                      (0x000000FF)
+#define TVE_IP_MVFCR_mvfcr(data)                                                     (0x000000FF&((data)<<0))
+#define TVE_IP_MVFCR_mvfcr_src(data)                                                 ((0x000000FF&(data))>>0)
+#define TVE_IP_MVFCR_get_mvfcr(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_MVCSL1                                                                0x18018924
+#define TVE_IP_MVCSL1_reg_addr                                                       "0xB8018924"
+#define TVE_IP_MVCSL1_reg                                                            0xB8018924
+#define set_TVE_IP_MVCSL1_reg(data)   (*((volatile unsigned int*) TVE_IP_MVCSL1_reg)=data)
+#define get_TVE_IP_MVCSL1_reg   (*((volatile unsigned int*) TVE_IP_MVCSL1_reg))
+#define TVE_IP_MVCSL1_inst_adr                                                       "0x0049"
+#define TVE_IP_MVCSL1_inst                                                           0x0049
+#define TVE_IP_MVCSL1_mvcsl1_shift                                                   (0)
+#define TVE_IP_MVCSL1_mvcsl1_mask                                                    (0x000000FF)
+#define TVE_IP_MVCSL1_mvcsl1(data)                                                   (0x000000FF&((data)<<0))
+#define TVE_IP_MVCSL1_mvcsl1_src(data)                                               ((0x000000FF&(data))>>0)
+#define TVE_IP_MVCSL1_get_mvcsl1(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_MVCLS1                                                                0x18018928
+#define TVE_IP_MVCLS1_reg_addr                                                       "0xB8018928"
+#define TVE_IP_MVCLS1_reg                                                            0xB8018928
+#define set_TVE_IP_MVCLS1_reg(data)   (*((volatile unsigned int*) TVE_IP_MVCLS1_reg)=data)
+#define get_TVE_IP_MVCLS1_reg   (*((volatile unsigned int*) TVE_IP_MVCLS1_reg))
+#define TVE_IP_MVCLS1_inst_adr                                                       "0x004A"
+#define TVE_IP_MVCLS1_inst                                                           0x004A
+#define TVE_IP_MVCLS1_mvcls1_shift                                                   (0)
+#define TVE_IP_MVCLS1_mvcls1_mask                                                    (0x0000003F)
+#define TVE_IP_MVCLS1_mvcls1(data)                                                   (0x0000003F&((data)<<0))
+#define TVE_IP_MVCLS1_mvcls1_src(data)                                               ((0x0000003F&(data))>>0)
+#define TVE_IP_MVCLS1_get_mvcls1(data)                                               ((0x0000003F&(data))>>0)
+
+
+#define TVE_IP_MVCSL2                                                                0x1801892c
+#define TVE_IP_MVCSL2_reg_addr                                                       "0xB801892C"
+#define TVE_IP_MVCSL2_reg                                                            0xB801892C
+#define set_TVE_IP_MVCSL2_reg(data)   (*((volatile unsigned int*) TVE_IP_MVCSL2_reg)=data)
+#define get_TVE_IP_MVCSL2_reg   (*((volatile unsigned int*) TVE_IP_MVCSL2_reg))
+#define TVE_IP_MVCSL2_inst_adr                                                       "0x004B"
+#define TVE_IP_MVCSL2_inst                                                           0x004B
+#define TVE_IP_MVCSL2_mvcsl2_shift                                                   (0)
+#define TVE_IP_MVCSL2_mvcsl2_mask                                                    (0x000000FF)
+#define TVE_IP_MVCSL2_mvcsl2(data)                                                   (0x000000FF&((data)<<0))
+#define TVE_IP_MVCSL2_mvcsl2_src(data)                                               ((0x000000FF&(data))>>0)
+#define TVE_IP_MVCSL2_get_mvcsl2(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_MVCLS2                                                                0x18018930
+#define TVE_IP_MVCLS2_reg_addr                                                       "0xB8018930"
+#define TVE_IP_MVCLS2_reg                                                            0xB8018930
+#define set_TVE_IP_MVCLS2_reg(data)   (*((volatile unsigned int*) TVE_IP_MVCLS2_reg)=data)
+#define get_TVE_IP_MVCLS2_reg   (*((volatile unsigned int*) TVE_IP_MVCLS2_reg))
+#define TVE_IP_MVCLS2_inst_adr                                                       "0x004C"
+#define TVE_IP_MVCLS2_inst                                                           0x004C
+#define TVE_IP_MVCLS2_mvcls2_shift                                                   (0)
+#define TVE_IP_MVCLS2_mvcls2_mask                                                    (0x0000003F)
+#define TVE_IP_MVCLS2_mvcls2(data)                                                   (0x0000003F&((data)<<0))
+#define TVE_IP_MVCLS2_mvcls2_src(data)                                               ((0x0000003F&(data))>>0)
+#define TVE_IP_MVCLS2_get_mvcls2(data)                                               ((0x0000003F&(data))>>0)
+
+
+#define TVE_IP_MVCSSP                                                                0x18018934
+#define TVE_IP_MVCSSP_reg_addr                                                       "0xB8018934"
+#define TVE_IP_MVCSSP_reg                                                            0xB8018934
+#define set_TVE_IP_MVCSSP_reg(data)   (*((volatile unsigned int*) TVE_IP_MVCSSP_reg)=data)
+#define get_TVE_IP_MVCSSP_reg   (*((volatile unsigned int*) TVE_IP_MVCSSP_reg))
+#define TVE_IP_MVCSSP_inst_adr                                                       "0x004D"
+#define TVE_IP_MVCSSP_inst                                                           0x004D
+#define TVE_IP_MVCSSP_mvcssp_shift                                                   (5)
+#define TVE_IP_MVCSSP_mvcssp_mask                                                    (0x000000E0)
+#define TVE_IP_MVCSSP_mvcssp(data)                                                   (0x000000E0&((data)<<5))
+#define TVE_IP_MVCSSP_mvcssp_src(data)                                               ((0x000000E0&(data))>>5)
+#define TVE_IP_MVCSSP_get_mvcssp(data)                                               ((0x000000E0&(data))>>5)
+#define TVE_IP_MVCSSP_mvcsnum_shift                                                  (2)
+#define TVE_IP_MVCSSP_mvcsnum_mask                                                   (0x0000001C)
+#define TVE_IP_MVCSSP_mvcsnum(data)                                                  (0x0000001C&((data)<<2))
+#define TVE_IP_MVCSSP_mvcsnum_src(data)                                              ((0x0000001C&(data))>>2)
+#define TVE_IP_MVCSSP_get_mvcsnum(data)                                              ((0x0000001C&(data))>>2)
+#define TVE_IP_MVCSSP_mvcsln_shift                                                   (0)
+#define TVE_IP_MVCSSP_mvcsln_mask                                                    (0x00000003)
+#define TVE_IP_MVCSSP_mvcsln(data)                                                   (0x00000003&((data)<<0))
+#define TVE_IP_MVCSSP_mvcsln_src(data)                                               ((0x00000003&(data))>>0)
+#define TVE_IP_MVCSSP_get_mvcsln(data)                                               ((0x00000003&(data))>>0)
+
+
+#define TVE_IP_MVPSD                                                                 0x18018938
+#define TVE_IP_MVPSD_reg_addr                                                        "0xB8018938"
+#define TVE_IP_MVPSD_reg                                                             0xB8018938
+#define set_TVE_IP_MVPSD_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPSD_reg)=data)
+#define get_TVE_IP_MVPSD_reg   (*((volatile unsigned int*) TVE_IP_MVPSD_reg))
+#define TVE_IP_MVPSD_inst_adr                                                        "0x004E"
+#define TVE_IP_MVPSD_inst                                                            0x004E
+#define TVE_IP_MVPSD_mvpsd_shift                                                     (0)
+#define TVE_IP_MVPSD_mvpsd_mask                                                      (0x0000003F)
+#define TVE_IP_MVPSD_mvpsd(data)                                                     (0x0000003F&((data)<<0))
+#define TVE_IP_MVPSD_mvpsd_src(data)                                                 ((0x0000003F&(data))>>0)
+#define TVE_IP_MVPSD_get_mvpsd(data)                                                 ((0x0000003F&(data))>>0)
+
+
+#define TVE_IP_MVPSL                                                                 0x1801893c
+#define TVE_IP_MVPSL_reg_addr                                                        "0xB801893C"
+#define TVE_IP_MVPSL_reg                                                             0xB801893C
+#define set_TVE_IP_MVPSL_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPSL_reg)=data)
+#define get_TVE_IP_MVPSL_reg   (*((volatile unsigned int*) TVE_IP_MVPSL_reg))
+#define TVE_IP_MVPSL_inst_adr                                                        "0x004F"
+#define TVE_IP_MVPSL_inst                                                            0x004F
+#define TVE_IP_MVPSL_mvpsl_shift                                                     (0)
+#define TVE_IP_MVPSL_mvpsl_mask                                                      (0x0000003F)
+#define TVE_IP_MVPSL_mvpsl(data)                                                     (0x0000003F&((data)<<0))
+#define TVE_IP_MVPSL_mvpsl_src(data)                                                 ((0x0000003F&(data))>>0)
+#define TVE_IP_MVPSL_get_mvpsl(data)                                                 ((0x0000003F&(data))>>0)
+
+
+#define TVE_IP_MVPSS                                                                 0x18018940
+#define TVE_IP_MVPSS_reg_addr                                                        "0xB8018940"
+#define TVE_IP_MVPSS_reg                                                             0xB8018940
+#define set_TVE_IP_MVPSS_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPSS_reg)=data)
+#define get_TVE_IP_MVPSS_reg   (*((volatile unsigned int*) TVE_IP_MVPSS_reg))
+#define TVE_IP_MVPSS_inst_adr                                                        "0x0050"
+#define TVE_IP_MVPSS_inst                                                            0x0050
+#define TVE_IP_MVPSS_mvpss_shift                                                     (0)
+#define TVE_IP_MVPSS_mvpss_mask                                                      (0x0000003F)
+#define TVE_IP_MVPSS_mvpss(data)                                                     (0x0000003F&((data)<<0))
+#define TVE_IP_MVPSS_mvpss_src(data)                                                 ((0x0000003F&(data))>>0)
+#define TVE_IP_MVPSS_get_mvpss(data)                                                 ((0x0000003F&(data))>>0)
+
+
+#define TVE_IP_MVPSLS0                                                               0x18018944
+#define TVE_IP_MVPSLS0_reg_addr                                                      "0xB8018944"
+#define TVE_IP_MVPSLS0_reg                                                           0xB8018944
+#define set_TVE_IP_MVPSLS0_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPSLS0_reg)=data)
+#define get_TVE_IP_MVPSLS0_reg   (*((volatile unsigned int*) TVE_IP_MVPSLS0_reg))
+#define TVE_IP_MVPSLS0_inst_adr                                                      "0x0051"
+#define TVE_IP_MVPSLS0_inst                                                          0x0051
+#define TVE_IP_MVPSLS0_mvpsls_shift                                                  (0)
+#define TVE_IP_MVPSLS0_mvpsls_mask                                                   (0x0000007F)
+#define TVE_IP_MVPSLS0_mvpsls(data)                                                  (0x0000007F&((data)<<0))
+#define TVE_IP_MVPSLS0_mvpsls_src(data)                                              ((0x0000007F&(data))>>0)
+#define TVE_IP_MVPSLS0_get_mvpsls(data)                                              ((0x0000007F&(data))>>0)
+
+
+#define TVE_IP_MVPSLS1                                                               0x18018948
+#define TVE_IP_MVPSLS1_reg_addr                                                      "0xB8018948"
+#define TVE_IP_MVPSLS1_reg                                                           0xB8018948
+#define set_TVE_IP_MVPSLS1_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPSLS1_reg)=data)
+#define get_TVE_IP_MVPSLS1_reg   (*((volatile unsigned int*) TVE_IP_MVPSLS1_reg))
+#define TVE_IP_MVPSLS1_inst_adr                                                      "0x0052"
+#define TVE_IP_MVPSLS1_inst                                                          0x0052
+#define TVE_IP_MVPSLS1_mvpsls_shift                                                  (0)
+#define TVE_IP_MVPSLS1_mvpsls_mask                                                   (0x000000FF)
+#define TVE_IP_MVPSLS1_mvpsls(data)                                                  (0x000000FF&((data)<<0))
+#define TVE_IP_MVPSLS1_mvpsls_src(data)                                              ((0x000000FF&(data))>>0)
+#define TVE_IP_MVPSLS1_get_mvpsls(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_MVPSFS0                                                               0x1801894c
+#define TVE_IP_MVPSFS0_reg_addr                                                      "0xB801894C"
+#define TVE_IP_MVPSFS0_reg                                                           0xB801894C
+#define set_TVE_IP_MVPSFS0_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPSFS0_reg)=data)
+#define get_TVE_IP_MVPSFS0_reg   (*((volatile unsigned int*) TVE_IP_MVPSFS0_reg))
+#define TVE_IP_MVPSFS0_inst_adr                                                      "0x0053"
+#define TVE_IP_MVPSFS0_inst                                                          0x0053
+#define TVE_IP_MVPSFS0_mvpsfs_shift                                                  (0)
+#define TVE_IP_MVPSFS0_mvpsfs_mask                                                   (0x0000007F)
+#define TVE_IP_MVPSFS0_mvpsfs(data)                                                  (0x0000007F&((data)<<0))
+#define TVE_IP_MVPSFS0_mvpsfs_src(data)                                              ((0x0000007F&(data))>>0)
+#define TVE_IP_MVPSFS0_get_mvpsfs(data)                                              ((0x0000007F&(data))>>0)
+
+
+#define TVE_IP_MVPSFS1                                                               0x18018950
+#define TVE_IP_MVPSFS1_reg_addr                                                      "0xB8018950"
+#define TVE_IP_MVPSFS1_reg                                                           0xB8018950
+#define set_TVE_IP_MVPSFS1_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPSFS1_reg)=data)
+#define get_TVE_IP_MVPSFS1_reg   (*((volatile unsigned int*) TVE_IP_MVPSFS1_reg))
+#define TVE_IP_MVPSFS1_inst_adr                                                      "0x0054"
+#define TVE_IP_MVPSFS1_inst                                                          0x0054
+#define TVE_IP_MVPSFS1_mvpsfs_shift                                                  (0)
+#define TVE_IP_MVPSFS1_mvpsfs_mask                                                   (0x000000FF)
+#define TVE_IP_MVPSFS1_mvpsfs(data)                                                  (0x000000FF&((data)<<0))
+#define TVE_IP_MVPSFS1_mvpsfs_src(data)                                              ((0x000000FF&(data))>>0)
+#define TVE_IP_MVPSFS1_get_mvpsfs(data)                                              ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_MVPSAGCA                                                              0x18018954
+#define TVE_IP_MVPSAGCA_reg_addr                                                     "0xB8018954"
+#define TVE_IP_MVPSAGCA_reg                                                          0xB8018954
+#define set_TVE_IP_MVPSAGCA_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPSAGCA_reg)=data)
+#define get_TVE_IP_MVPSAGCA_reg   (*((volatile unsigned int*) TVE_IP_MVPSAGCA_reg))
+#define TVE_IP_MVPSAGCA_inst_adr                                                     "0x0055"
+#define TVE_IP_MVPSAGCA_inst                                                         0x0055
+#define TVE_IP_MVPSAGCA_mvpsagca_shift                                               (0)
+#define TVE_IP_MVPSAGCA_mvpsagca_mask                                                (0x000000FF)
+#define TVE_IP_MVPSAGCA_mvpsagca(data)                                               (0x000000FF&((data)<<0))
+#define TVE_IP_MVPSAGCA_mvpsagca_src(data)                                           ((0x000000FF&(data))>>0)
+#define TVE_IP_MVPSAGCA_get_mvpsagca(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_MVPSAGCB                                                              0x18018958
+#define TVE_IP_MVPSAGCB_reg_addr                                                     "0xB8018958"
+#define TVE_IP_MVPSAGCB_reg                                                          0xB8018958
+#define set_TVE_IP_MVPSAGCB_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPSAGCB_reg)=data)
+#define get_TVE_IP_MVPSAGCB_reg   (*((volatile unsigned int*) TVE_IP_MVPSAGCB_reg))
+#define TVE_IP_MVPSAGCB_inst_adr                                                     "0x0056"
+#define TVE_IP_MVPSAGCB_inst                                                         0x0056
+#define TVE_IP_MVPSAGCB_mvpsagcb_shift                                               (0)
+#define TVE_IP_MVPSAGCB_mvpsagcb_mask                                                (0x000000FF)
+#define TVE_IP_MVPSAGCB_mvpsagcb(data)                                               (0x000000FF&((data)<<0))
+#define TVE_IP_MVPSAGCB_mvpsagcb_src(data)                                           ((0x000000FF&(data))>>0)
+#define TVE_IP_MVPSAGCB_get_mvpsagcb(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_MVEOFBPC                                                              0x1801895c
+#define TVE_IP_MVEOFBPC_reg_addr                                                     "0xB801895C"
+#define TVE_IP_MVEOFBPC_reg                                                          0xB801895C
+#define set_TVE_IP_MVEOFBPC_reg(data)   (*((volatile unsigned int*) TVE_IP_MVEOFBPC_reg)=data)
+#define get_TVE_IP_MVEOFBPC_reg   (*((volatile unsigned int*) TVE_IP_MVEOFBPC_reg))
+#define TVE_IP_MVEOFBPC_inst_adr                                                     "0x0057"
+#define TVE_IP_MVEOFBPC_inst                                                         0x0057
+#define TVE_IP_MVEOFBPC_mveofbpc_shift                                               (0)
+#define TVE_IP_MVEOFBPC_mveofbpc_mask                                                (0x000000FF)
+#define TVE_IP_MVEOFBPC_mveofbpc(data)                                               (0x000000FF&((data)<<0))
+#define TVE_IP_MVEOFBPC_mveofbpc_src(data)                                           ((0x000000FF&(data))>>0)
+#define TVE_IP_MVEOFBPC_get_mveofbpc(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_MVPBZ1                                                                0x18018960
+#define TVE_IP_MVPBZ1_reg_addr                                                       "0xB8018960"
+#define TVE_IP_MVPBZ1_reg                                                            0xB8018960
+#define set_TVE_IP_MVPBZ1_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPBZ1_reg)=data)
+#define get_TVE_IP_MVPBZ1_reg   (*((volatile unsigned int*) TVE_IP_MVPBZ1_reg))
+#define TVE_IP_MVPBZ1_inst_adr                                                       "0x0058"
+#define TVE_IP_MVPBZ1_inst                                                           0x0058
+#define TVE_IP_MVPBZ1_mvpbz1_shift                                                   (4)
+#define TVE_IP_MVPBZ1_mvpbz1_mask                                                    (0x000000F0)
+#define TVE_IP_MVPBZ1_mvpbz1(data)                                                   (0x000000F0&((data)<<4))
+#define TVE_IP_MVPBZ1_mvpbz1_src(data)                                               ((0x000000F0&(data))>>4)
+#define TVE_IP_MVPBZ1_get_mvpbz1(data)                                               ((0x000000F0&(data))>>4)
+#define TVE_IP_MVPBZ1_mvpbz2_shift                                                   (0)
+#define TVE_IP_MVPBZ1_mvpbz2_mask                                                    (0x0000000F)
+#define TVE_IP_MVPBZ1_mvpbz2(data)                                                   (0x0000000F&((data)<<0))
+#define TVE_IP_MVPBZ1_mvpbz2_src(data)                                               ((0x0000000F&(data))>>0)
+#define TVE_IP_MVPBZ1_get_mvpbz2(data)                                               ((0x0000000F&(data))>>0)
+
+
+#define TVE_IP_MVPBZ3                                                                0x18018964
+#define TVE_IP_MVPBZ3_reg_addr                                                       "0xB8018964"
+#define TVE_IP_MVPBZ3_reg                                                            0xB8018964
+#define set_TVE_IP_MVPBZ3_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPBZ3_reg)=data)
+#define get_TVE_IP_MVPBZ3_reg   (*((volatile unsigned int*) TVE_IP_MVPBZ3_reg))
+#define TVE_IP_MVPBZ3_inst_adr                                                       "0x0059"
+#define TVE_IP_MVPBZ3_inst                                                           0x0059
+#define TVE_IP_MVPBZ3_mvpbz3_shift                                                   (4)
+#define TVE_IP_MVPBZ3_mvpbz3_mask                                                    (0x000000F0)
+#define TVE_IP_MVPBZ3_mvpbz3(data)                                                   (0x000000F0&((data)<<4))
+#define TVE_IP_MVPBZ3_mvpbz3_src(data)                                               ((0x000000F0&(data))>>4)
+#define TVE_IP_MVPBZ3_get_mvpbz3(data)                                               ((0x000000F0&(data))>>4)
+#define TVE_IP_MVPBZ3_mvpadvbsen_shift                                               (3)
+#define TVE_IP_MVPBZ3_mvpadvbsen_mask                                                (0x00000008)
+#define TVE_IP_MVPBZ3_mvpadvbsen(data)                                               (0x00000008&((data)<<3))
+#define TVE_IP_MVPBZ3_mvpadvbsen_src(data)                                           ((0x00000008&(data))>>3)
+#define TVE_IP_MVPBZ3_get_mvpadvbsen(data)                                           ((0x00000008&(data))>>3)
+#define TVE_IP_MVPBZ3_mvpzninvrt_shift                                               (0)
+#define TVE_IP_MVPBZ3_mvpzninvrt_mask                                                (0x00000007)
+#define TVE_IP_MVPBZ3_mvpzninvrt(data)                                               (0x00000007&((data)<<0))
+#define TVE_IP_MVPBZ3_mvpzninvrt_src(data)                                           ((0x00000007&(data))>>0)
+#define TVE_IP_MVPBZ3_get_mvpzninvrt(data)                                           ((0x00000007&(data))>>0)
+
+
+#define TVE_IP_MVPCSLIMD0                                                            0x18018968
+#define TVE_IP_MVPCSLIMD0_reg_addr                                                   "0xB8018968"
+#define TVE_IP_MVPCSLIMD0_reg                                                        0xB8018968
+#define set_TVE_IP_MVPCSLIMD0_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPCSLIMD0_reg)=data)
+#define get_TVE_IP_MVPCSLIMD0_reg   (*((volatile unsigned int*) TVE_IP_MVPCSLIMD0_reg))
+#define TVE_IP_MVPCSLIMD0_inst_adr                                                   "0x005A"
+#define TVE_IP_MVPCSLIMD0_inst                                                       0x005A
+#define TVE_IP_MVPCSLIMD0_mvpcslimd_lsb_shift                                        (0)
+#define TVE_IP_MVPCSLIMD0_mvpcslimd_lsb_mask                                         (0x000000FF)
+#define TVE_IP_MVPCSLIMD0_mvpcslimd_lsb(data)                                        (0x000000FF&((data)<<0))
+#define TVE_IP_MVPCSLIMD0_mvpcslimd_lsb_src(data)                                    ((0x000000FF&(data))>>0)
+#define TVE_IP_MVPCSLIMD0_get_mvpcslimd_lsb(data)                                    ((0x000000FF&(data))>>0)
+
+
+#define TVE_IP_MVPCSLIMD1                                                            0x1801896c
+#define TVE_IP_MVPCSLIMD1_reg_addr                                                   "0xB801896C"
+#define TVE_IP_MVPCSLIMD1_reg                                                        0xB801896C
+#define set_TVE_IP_MVPCSLIMD1_reg(data)   (*((volatile unsigned int*) TVE_IP_MVPCSLIMD1_reg)=data)
+#define get_TVE_IP_MVPCSLIMD1_reg   (*((volatile unsigned int*) TVE_IP_MVPCSLIMD1_reg))
+#define TVE_IP_MVPCSLIMD1_inst_adr                                                   "0x005B"
+#define TVE_IP_MVPCSLIMD1_inst                                                       0x005B
+#define TVE_IP_MVPCSLIMD1_mvpcslimd_msb_shift                                        (0)
+#define TVE_IP_MVPCSLIMD1_mvpcslimd_msb_mask                                         (0x00000003)
+#define TVE_IP_MVPCSLIMD1_mvpcslimd_msb(data)                                        (0x00000003&((data)<<0))
+#define TVE_IP_MVPCSLIMD1_mvpcslimd_msb_src(data)                                    ((0x00000003&(data))>>0)
+#define TVE_IP_MVPCSLIMD1_get_mvpcslimd_msb(data)                                    ((0x00000003&(data))>>0)
+
+
+#define TVE_IP_MV_CTRL                                                               0x18018990
+#define TVE_IP_MV_CTRL_reg_addr                                                      "0xB8018990"
+#define TVE_IP_MV_CTRL_reg                                                           0xB8018990
+#define set_TVE_IP_MV_CTRL_reg(data)   (*((volatile unsigned int*) TVE_IP_MV_CTRL_reg)=data)
+#define get_TVE_IP_MV_CTRL_reg   (*((volatile unsigned int*) TVE_IP_MV_CTRL_reg))
+#define TVE_IP_MV_CTRL_inst_adr                                                      "0x0064"
+#define TVE_IP_MV_CTRL_inst                                                          0x0064
+#define TVE_IP_MV_CTRL_mvtms_shift                                                   (0)
+#define TVE_IP_MV_CTRL_mvtms_mask                                                    (0x000000FF)
+#define TVE_IP_MV_CTRL_mvtms(data)                                                   (0x000000FF&((data)<<0))
+#define TVE_IP_MV_CTRL_mvtms_src(data)                                               ((0x000000FF&(data))>>0)
+#define TVE_IP_MV_CTRL_get_mvtms(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define TVE_VIDEO_DAC_CTRL_0                                                         0x18018200
+#define TVE_VIDEO_DAC_CTRL_1                                                         0x18018204
+#define TVE_VIDEO_DAC_CTRL_0_reg_addr                                                "0xB8018200"
+#define TVE_VIDEO_DAC_CTRL_1_reg_addr                                                "0xB8018204"
+#define TVE_VIDEO_DAC_CTRL_0_reg                                                     0xB8018200
+#define TVE_VIDEO_DAC_CTRL_1_reg                                                     0xB8018204
+#define set_TVE_VIDEO_DAC_CTRL_0_reg(data)   (*((volatile unsigned int*) TVE_VIDEO_DAC_CTRL_0_reg)=data)
+#define set_TVE_VIDEO_DAC_CTRL_1_reg(data)   (*((volatile unsigned int*) TVE_VIDEO_DAC_CTRL_1_reg)=data)
+#define get_TVE_VIDEO_DAC_CTRL_0_reg   (*((volatile unsigned int*) TVE_VIDEO_DAC_CTRL_0_reg))
+#define get_TVE_VIDEO_DAC_CTRL_1_reg   (*((volatile unsigned int*) TVE_VIDEO_DAC_CTRL_1_reg))
+#define TVE_VIDEO_DAC_CTRL_0_inst_adr                                                "0x0080"
+#define TVE_VIDEO_DAC_CTRL_1_inst_adr                                                "0x0081"
+#define TVE_VIDEO_DAC_CTRL_0_inst                                                    0x0080
+#define TVE_VIDEO_DAC_CTRL_1_inst                                                    0x0081
+#define TVE_VIDEO_DAC_CTRL_vdac_apow_shift                                           (22)
+#define TVE_VIDEO_DAC_CTRL_vdac_apow_mask                                            (0x00400000)
+#define TVE_VIDEO_DAC_CTRL_vdac_apow(data)                                           (0x00400000&((data)<<22))
+#define TVE_VIDEO_DAC_CTRL_vdac_apow_src(data)                                       ((0x00400000&(data))>>22)
+#define TVE_VIDEO_DAC_CTRL_get_vdac_apow(data)                                       ((0x00400000&(data))>>22)
+#define TVE_VIDEO_DAC_CTRL_vdac_bpow_shift                                           (21)
+#define TVE_VIDEO_DAC_CTRL_vdac_bpow_mask                                            (0x00200000)
+#define TVE_VIDEO_DAC_CTRL_vdac_bpow(data)                                           (0x00200000&((data)<<21))
+#define TVE_VIDEO_DAC_CTRL_vdac_bpow_src(data)                                       ((0x00200000&(data))>>21)
+#define TVE_VIDEO_DAC_CTRL_get_vdac_bpow(data)                                       ((0x00200000&(data))>>21)
+#define TVE_VIDEO_DAC_CTRL_vdac_cpow_shift                                           (20)
+#define TVE_VIDEO_DAC_CTRL_vdac_cpow_mask                                            (0x00100000)
+#define TVE_VIDEO_DAC_CTRL_vdac_cpow(data)                                           (0x00100000&((data)<<20))
+#define TVE_VIDEO_DAC_CTRL_vdac_cpow_src(data)                                       ((0x00100000&(data))>>20)
+#define TVE_VIDEO_DAC_CTRL_get_vdac_cpow(data)                                       ((0x00100000&(data))>>20)
+#define TVE_VIDEO_DAC_CTRL_powldv_l_shift                                            (19)
+#define TVE_VIDEO_DAC_CTRL_powldv_l_mask                                             (0x00080000)
+#define TVE_VIDEO_DAC_CTRL_powldv_l(data)                                            (0x00080000&((data)<<19))
+#define TVE_VIDEO_DAC_CTRL_powldv_l_src(data)                                        ((0x00080000&(data))>>19)
+#define TVE_VIDEO_DAC_CTRL_get_powldv_l(data)                                        ((0x00080000&(data))>>19)
+#define TVE_VIDEO_DAC_CTRL_stanby_l_shift                                            (18)
+#define TVE_VIDEO_DAC_CTRL_stanby_l_mask                                             (0x00040000)
+#define TVE_VIDEO_DAC_CTRL_stanby_l(data)                                            (0x00040000&((data)<<18))
+#define TVE_VIDEO_DAC_CTRL_stanby_l_src(data)                                        ((0x00040000&(data))>>18)
+#define TVE_VIDEO_DAC_CTRL_get_stanby_l(data)                                        ((0x00040000&(data))>>18)
+#define TVE_VIDEO_DAC_CTRL_biasa_regl_shift                                          (12)
+#define TVE_VIDEO_DAC_CTRL_biasa_regl_mask                                           (0x0000F000)
+#define TVE_VIDEO_DAC_CTRL_biasa_regl(data)                                          (0x0000F000&((data)<<12))
+#define TVE_VIDEO_DAC_CTRL_biasa_regl_src(data)                                      ((0x0000F000&(data))>>12)
+#define TVE_VIDEO_DAC_CTRL_get_biasa_regl(data)                                      ((0x0000F000&(data))>>12)
+#define TVE_VIDEO_DAC_CTRL_biasb_regl_shift                                          (6)
+#define TVE_VIDEO_DAC_CTRL_biasb_regl_mask                                           (0x000003C0)
+#define TVE_VIDEO_DAC_CTRL_biasb_regl(data)                                          (0x000003C0&((data)<<6))
+#define TVE_VIDEO_DAC_CTRL_biasb_regl_src(data)                                      ((0x000003C0&(data))>>6)
+#define TVE_VIDEO_DAC_CTRL_get_biasb_regl(data)                                      ((0x000003C0&(data))>>6)
+#define TVE_VIDEO_DAC_CTRL_biasc_regl_shift                                          (0)
+#define TVE_VIDEO_DAC_CTRL_biasc_regl_mask                                           (0x0000000F)
+#define TVE_VIDEO_DAC_CTRL_biasc_regl(data)                                          (0x0000000F&((data)<<0))
+#define TVE_VIDEO_DAC_CTRL_biasc_regl_src(data)                                      ((0x0000000F&(data))>>0)
+#define TVE_VIDEO_DAC_CTRL_get_biasc_regl(data)                                      ((0x0000000F&(data))>>0)
+
+
+#define TVE_VIDEO_DAC_CTRL2_0                                                        0x18018218
+#define TVE_VIDEO_DAC_CTRL2_1                                                        0x1801821C
+#define TVE_VIDEO_DAC_CTRL2_0_reg_addr                                               "0xB8018218"
+#define TVE_VIDEO_DAC_CTRL2_1_reg_addr                                               "0xB801821C"
+#define TVE_VIDEO_DAC_CTRL2_0_reg                                                    0xB8018218
+#define TVE_VIDEO_DAC_CTRL2_1_reg                                                    0xB801821C
+#define set_TVE_VIDEO_DAC_CTRL2_0_reg(data)   (*((volatile unsigned int*) TVE_VIDEO_DAC_CTRL2_0_reg)=data)
+#define set_TVE_VIDEO_DAC_CTRL2_1_reg(data)   (*((volatile unsigned int*) TVE_VIDEO_DAC_CTRL2_1_reg)=data)
+#define get_TVE_VIDEO_DAC_CTRL2_0_reg   (*((volatile unsigned int*) TVE_VIDEO_DAC_CTRL2_0_reg))
+#define get_TVE_VIDEO_DAC_CTRL2_1_reg   (*((volatile unsigned int*) TVE_VIDEO_DAC_CTRL2_1_reg))
+#define TVE_VIDEO_DAC_CTRL2_0_inst_adr                                               "0x0086"
+#define TVE_VIDEO_DAC_CTRL2_1_inst_adr                                               "0x0087"
+#define TVE_VIDEO_DAC_CTRL2_0_inst                                                   0x0086
+#define TVE_VIDEO_DAC_CTRL2_1_inst                                                   0x0087
+#define TVE_VIDEO_DAC_CTRL2_abiq_regl_shift                                          (12)
+#define TVE_VIDEO_DAC_CTRL2_abiq_regl_mask                                           (0x00007000)
+#define TVE_VIDEO_DAC_CTRL2_abiq_regl(data)                                          (0x00007000&((data)<<12))
+#define TVE_VIDEO_DAC_CTRL2_abiq_regl_src(data)                                      ((0x00007000&(data))>>12)
+#define TVE_VIDEO_DAC_CTRL2_get_abiq_regl(data)                                      ((0x00007000&(data))>>12)
+#define TVE_VIDEO_DAC_CTRL2_ldvbias_regl_shift                                       (9)
+#define TVE_VIDEO_DAC_CTRL2_ldvbias_regl_mask                                        (0x00000E00)
+#define TVE_VIDEO_DAC_CTRL2_ldvbias_regl(data)                                       (0x00000E00&((data)<<9))
+#define TVE_VIDEO_DAC_CTRL2_ldvbias_regl_src(data)                                   ((0x00000E00&(data))>>9)
+#define TVE_VIDEO_DAC_CTRL2_get_ldvbias_regl(data)                                   ((0x00000E00&(data))>>9)
+#define TVE_VIDEO_DAC_CTRL2_vcmref_regl_shift                                        (7)
+#define TVE_VIDEO_DAC_CTRL2_vcmref_regl_mask                                         (0x00000180)
+#define TVE_VIDEO_DAC_CTRL2_vcmref_regl(data)                                        (0x00000180&((data)<<7))
+#define TVE_VIDEO_DAC_CTRL2_vcmref_regl_src(data)                                    ((0x00000180&(data))>>7)
+#define TVE_VIDEO_DAC_CTRL2_get_vcmref_regl(data)                                    ((0x00000180&(data))>>7)
+#define TVE_VIDEO_DAC_CTRL2_vdac_cf_regl_shift                                       (2)
+#define TVE_VIDEO_DAC_CTRL2_vdac_cf_regl_mask                                        (0x0000001C)
+#define TVE_VIDEO_DAC_CTRL2_vdac_cf_regl(data)                                       (0x0000001C&((data)<<2))
+#define TVE_VIDEO_DAC_CTRL2_vdac_cf_regl_src(data)                                   ((0x0000001C&(data))>>2)
+#define TVE_VIDEO_DAC_CTRL2_get_vdac_cf_regl(data)                                   ((0x0000001C&(data))>>2)
+#define TVE_VIDEO_DAC_CTRL2_vdac_rf_regl_shift                                       (0)
+#define TVE_VIDEO_DAC_CTRL2_vdac_rf_regl_mask                                        (0x00000003)
+#define TVE_VIDEO_DAC_CTRL2_vdac_rf_regl(data)                                       (0x00000003&((data)<<0))
+#define TVE_VIDEO_DAC_CTRL2_vdac_rf_regl_src(data)                                   ((0x00000003&(data))>>0)
+#define TVE_VIDEO_DAC_CTRL2_get_vdac_rf_regl(data)                                   ((0x00000003&(data))>>0)
+
+
+#define TVE_VIDEO_DAC_CTRL3                                                          0x18018350
+#define TVE_VIDEO_DAC_CTRL3_reg_addr                                                 "0xB8018350"
+#define TVE_VIDEO_DAC_CTRL3_reg                                                      0xB8018350
+#define set_TVE_VIDEO_DAC_CTRL3_reg(data)   (*((volatile unsigned int*) TVE_VIDEO_DAC_CTRL3_reg)=data)
+#define get_TVE_VIDEO_DAC_CTRL3_reg   (*((volatile unsigned int*) TVE_VIDEO_DAC_CTRL3_reg))
+#define TVE_VIDEO_DAC_CTRL3_inst_adr                                                 "0x00D4"
+#define TVE_VIDEO_DAC_CTRL3_inst                                                     0x00D4
+#define TVE_VIDEO_DAC_CTRL3_write_en6_shift                                          (18)
+#define TVE_VIDEO_DAC_CTRL3_write_en6_mask                                           (0x00040000)
+#define TVE_VIDEO_DAC_CTRL3_write_en6(data)                                          (0x00040000&((data)<<18))
+#define TVE_VIDEO_DAC_CTRL3_write_en6_src(data)                                      ((0x00040000&(data))>>18)
+#define TVE_VIDEO_DAC_CTRL3_get_write_en6(data)                                      ((0x00040000&(data))>>18)
+#define TVE_VIDEO_DAC_CTRL3_dcc2_l_shift                                             (17)
+#define TVE_VIDEO_DAC_CTRL3_dcc2_l_mask                                              (0x00020000)
+#define TVE_VIDEO_DAC_CTRL3_dcc2_l(data)                                             (0x00020000&((data)<<17))
+#define TVE_VIDEO_DAC_CTRL3_dcc2_l_src(data)                                         ((0x00020000&(data))>>17)
+#define TVE_VIDEO_DAC_CTRL3_get_dcc2_l(data)                                         ((0x00020000&(data))>>17)
+#define TVE_VIDEO_DAC_CTRL3_write_en5_shift                                          (16)
+#define TVE_VIDEO_DAC_CTRL3_write_en5_mask                                           (0x00010000)
+#define TVE_VIDEO_DAC_CTRL3_write_en5(data)                                          (0x00010000&((data)<<16))
+#define TVE_VIDEO_DAC_CTRL3_write_en5_src(data)                                      ((0x00010000&(data))>>16)
+#define TVE_VIDEO_DAC_CTRL3_get_write_en5(data)                                      ((0x00010000&(data))>>16)
+#define TVE_VIDEO_DAC_CTRL3_dcc_l_shift                                              (15)
+#define TVE_VIDEO_DAC_CTRL3_dcc_l_mask                                               (0x00008000)
+#define TVE_VIDEO_DAC_CTRL3_dcc_l(data)                                              (0x00008000&((data)<<15))
+#define TVE_VIDEO_DAC_CTRL3_dcc_l_src(data)                                          ((0x00008000&(data))>>15)
+#define TVE_VIDEO_DAC_CTRL3_get_dcc_l(data)                                          ((0x00008000&(data))>>15)
+#define TVE_VIDEO_DAC_CTRL3_write_en4_shift                                          (14)
+#define TVE_VIDEO_DAC_CTRL3_write_en4_mask                                           (0x00004000)
+#define TVE_VIDEO_DAC_CTRL3_write_en4(data)                                          (0x00004000&((data)<<14))
+#define TVE_VIDEO_DAC_CTRL3_write_en4_src(data)                                      ((0x00004000&(data))>>14)
+#define TVE_VIDEO_DAC_CTRL3_get_write_en4(data)                                      ((0x00004000&(data))>>14)
+#define TVE_VIDEO_DAC_CTRL3_caldiv_shift                                             (12)
+#define TVE_VIDEO_DAC_CTRL3_caldiv_mask                                              (0x00003000)
+#define TVE_VIDEO_DAC_CTRL3_caldiv(data)                                             (0x00003000&((data)<<12))
+#define TVE_VIDEO_DAC_CTRL3_caldiv_src(data)                                         ((0x00003000&(data))>>12)
+#define TVE_VIDEO_DAC_CTRL3_get_caldiv(data)                                         ((0x00003000&(data))>>12)
+#define TVE_VIDEO_DAC_CTRL3_write_en3_shift                                          (8)
+#define TVE_VIDEO_DAC_CTRL3_write_en3_mask                                           (0x00000100)
+#define TVE_VIDEO_DAC_CTRL3_write_en3(data)                                          (0x00000100&((data)<<8))
+#define TVE_VIDEO_DAC_CTRL3_write_en3_src(data)                                      ((0x00000100&(data))>>8)
+#define TVE_VIDEO_DAC_CTRL3_get_write_en3(data)                                      ((0x00000100&(data))>>8)
+#define TVE_VIDEO_DAC_CTRL3_div_regl_shift                                           (6)
+#define TVE_VIDEO_DAC_CTRL3_div_regl_mask                                            (0x000000C0)
+#define TVE_VIDEO_DAC_CTRL3_div_regl(data)                                           (0x000000C0&((data)<<6))
+#define TVE_VIDEO_DAC_CTRL3_div_regl_src(data)                                       ((0x000000C0&(data))>>6)
+#define TVE_VIDEO_DAC_CTRL3_get_div_regl(data)                                       ((0x000000C0&(data))>>6)
+#define TVE_VIDEO_DAC_CTRL3_write_en2_shift                                          (5)
+#define TVE_VIDEO_DAC_CTRL3_write_en2_mask                                           (0x00000020)
+#define TVE_VIDEO_DAC_CTRL3_write_en2(data)                                          (0x00000020&((data)<<5))
+#define TVE_VIDEO_DAC_CTRL3_write_en2_src(data)                                      ((0x00000020&(data))>>5)
+#define TVE_VIDEO_DAC_CTRL3_get_write_en2(data)                                      ((0x00000020&(data))>>5)
+#define TVE_VIDEO_DAC_CTRL3_ckmode_regl_shift                                        (3)
+#define TVE_VIDEO_DAC_CTRL3_ckmode_regl_mask                                         (0x00000018)
+#define TVE_VIDEO_DAC_CTRL3_ckmode_regl(data)                                        (0x00000018&((data)<<3))
+#define TVE_VIDEO_DAC_CTRL3_ckmode_regl_src(data)                                    ((0x00000018&(data))>>3)
+#define TVE_VIDEO_DAC_CTRL3_get_ckmode_regl(data)                                    ((0x00000018&(data))>>3)
+#define TVE_VIDEO_DAC_CTRL3_write_en1_shift                                          (2)
+#define TVE_VIDEO_DAC_CTRL3_write_en1_mask                                           (0x00000004)
+#define TVE_VIDEO_DAC_CTRL3_write_en1(data)                                          (0x00000004&((data)<<2))
+#define TVE_VIDEO_DAC_CTRL3_write_en1_src(data)                                      ((0x00000004&(data))>>2)
+#define TVE_VIDEO_DAC_CTRL3_get_write_en1(data)                                      ((0x00000004&(data))>>2)
+#define TVE_VIDEO_DAC_CTRL3_calen_regl_shift                                         (0)
+#define TVE_VIDEO_DAC_CTRL3_calen_regl_mask                                          (0x00000003)
+#define TVE_VIDEO_DAC_CTRL3_calen_regl(data)                                         (0x00000003&((data)<<0))
+#define TVE_VIDEO_DAC_CTRL3_calen_regl_src(data)                                     ((0x00000003&(data))>>0)
+#define TVE_VIDEO_DAC_CTRL3_get_calen_regl(data)                                     ((0x00000003&(data))>>0)
+
+
+#define TVE_DAC_SEL                                                                  0x1801836c
+#define TVE_DAC_SEL_reg_addr                                                         "0xB801836C"
+#define TVE_DAC_SEL_reg                                                              0xB801836C
+#define set_TVE_DAC_SEL_reg(data)   (*((volatile unsigned int*) TVE_DAC_SEL_reg)=data)
+#define get_TVE_DAC_SEL_reg   (*((volatile unsigned int*) TVE_DAC_SEL_reg))
+#define TVE_DAC_SEL_inst_adr                                                         "0x00DB"
+#define TVE_DAC_SEL_inst                                                             0x00DB
+#define TVE_DAC_SEL_write_en1_shift                                                  (2)
+#define TVE_DAC_SEL_write_en1_mask                                                   (0x00000004)
+#define TVE_DAC_SEL_write_en1(data)                                                  (0x00000004&((data)<<2))
+#define TVE_DAC_SEL_write_en1_src(data)                                              ((0x00000004&(data))>>2)
+#define TVE_DAC_SEL_get_write_en1(data)                                              ((0x00000004&(data))>>2)
+#define TVE_DAC_SEL_dac0_sel_shift                                                   (0)
+#define TVE_DAC_SEL_dac0_sel_mask                                                    (0x00000003)
+#define TVE_DAC_SEL_dac0_sel(data)                                                   (0x00000003&((data)<<0))
+#define TVE_DAC_SEL_dac0_sel_src(data)                                               ((0x00000003&(data))>>0)
+#define TVE_DAC_SEL_get_dac0_sel(data)                                               ((0x00000003&(data))>>0)
+
+
+#define TVE_DAC_MUX                                                                  0x18018208
+#define TVE_DAC_MUX_reg_addr                                                         "0xB8018208"
+#define TVE_DAC_MUX_reg                                                              0xB8018208
+#define set_TVE_DAC_MUX_reg(data)   (*((volatile unsigned int*) TVE_DAC_MUX_reg)=data)
+#define get_TVE_DAC_MUX_reg   (*((volatile unsigned int*) TVE_DAC_MUX_reg))
+#define TVE_DAC_MUX_inst_adr                                                         "0x0082"
+#define TVE_DAC_MUX_inst                                                             0x0082
+#define TVE_DAC_MUX_write_en6_shift                                                  (15)
+#define TVE_DAC_MUX_write_en6_mask                                                   (0x00008000)
+#define TVE_DAC_MUX_write_en6(data)                                                  (0x00008000&((data)<<15))
+#define TVE_DAC_MUX_write_en6_src(data)                                              ((0x00008000&(data))>>15)
+#define TVE_DAC_MUX_get_write_en6(data)                                              ((0x00008000&(data))>>15)
+#define TVE_DAC_MUX_up_ctrl_prog_shift                                               (13)
+#define TVE_DAC_MUX_up_ctrl_prog_mask                                                (0x00006000)
+#define TVE_DAC_MUX_up_ctrl_prog(data)                                               (0x00006000&((data)<<13))
+#define TVE_DAC_MUX_up_ctrl_prog_src(data)                                           ((0x00006000&(data))>>13)
+#define TVE_DAC_MUX_get_up_ctrl_prog(data)                                           ((0x00006000&(data))>>13)
+#define TVE_DAC_MUX_write_en5_shift                                                  (12)
+#define TVE_DAC_MUX_write_en5_mask                                                   (0x00001000)
+#define TVE_DAC_MUX_write_en5(data)                                                  (0x00001000&((data)<<12))
+#define TVE_DAC_MUX_write_en5_src(data)                                              ((0x00001000&(data))>>12)
+#define TVE_DAC_MUX_get_write_en5(data)                                              ((0x00001000&(data))>>12)
+#define TVE_DAC_MUX_up_ctrl_int0_shift                                               (10)
+#define TVE_DAC_MUX_up_ctrl_int0_mask                                                (0x00000C00)
+#define TVE_DAC_MUX_up_ctrl_int0(data)                                               (0x00000C00&((data)<<10))
+#define TVE_DAC_MUX_up_ctrl_int0_src(data)                                           ((0x00000C00&(data))>>10)
+#define TVE_DAC_MUX_get_up_ctrl_int0(data)                                           ((0x00000C00&(data))>>10)
+#define TVE_DAC_MUX_write_en4_shift                                                  (9)
+#define TVE_DAC_MUX_write_en4_mask                                                   (0x00000200)
+#define TVE_DAC_MUX_write_en4(data)                                                  (0x00000200&((data)<<9))
+#define TVE_DAC_MUX_write_en4_src(data)                                              ((0x00000200&(data))>>9)
+#define TVE_DAC_MUX_get_write_en4(data)                                              ((0x00000200&(data))>>9)
+#define TVE_DAC_MUX_up_ctrl_int1_shift                                               (7)
+#define TVE_DAC_MUX_up_ctrl_int1_mask                                                (0x00000180)
+#define TVE_DAC_MUX_up_ctrl_int1(data)                                               (0x00000180&((data)<<7))
+#define TVE_DAC_MUX_up_ctrl_int1_src(data)                                           ((0x00000180&(data))>>7)
+#define TVE_DAC_MUX_get_up_ctrl_int1(data)                                           ((0x00000180&(data))>>7)
+#define TVE_DAC_MUX_write_en3_shift                                                  (6)
+#define TVE_DAC_MUX_write_en3_mask                                                   (0x00000040)
+#define TVE_DAC_MUX_write_en3(data)                                                  (0x00000040&((data)<<6))
+#define TVE_DAC_MUX_write_en3_src(data)                                              ((0x00000040&(data))>>6)
+#define TVE_DAC_MUX_get_write_en3(data)                                              ((0x00000040&(data))>>6)
+#define TVE_DAC_MUX_dacmode_shift                                                    (4)
+#define TVE_DAC_MUX_dacmode_mask                                                     (0x00000030)
+#define TVE_DAC_MUX_dacmode(data)                                                    (0x00000030&((data)<<4))
+#define TVE_DAC_MUX_dacmode_src(data)                                                ((0x00000030&(data))>>4)
+#define TVE_DAC_MUX_get_dacmode(data)                                                ((0x00000030&(data))>>4)
+#define TVE_DAC_MUX_write_en2_shift                                                  (3)
+#define TVE_DAC_MUX_write_en2_mask                                                   (0x00000008)
+#define TVE_DAC_MUX_write_en2(data)                                                  (0x00000008&((data)<<3))
+#define TVE_DAC_MUX_write_en2_src(data)                                              ((0x00000008&(data))>>3)
+#define TVE_DAC_MUX_get_write_en2(data)                                              ((0x00000008&(data))>>3)
+#define TVE_DAC_MUX_swap23_shift                                                     (2)
+#define TVE_DAC_MUX_swap23_mask                                                      (0x00000004)
+#define TVE_DAC_MUX_swap23(data)                                                     (0x00000004&((data)<<2))
+#define TVE_DAC_MUX_swap23_src(data)                                                 ((0x00000004&(data))>>2)
+#define TVE_DAC_MUX_get_swap23(data)                                                 ((0x00000004&(data))>>2)
+#define TVE_DAC_MUX_write_en1_shift                                                  (1)
+#define TVE_DAC_MUX_write_en1_mask                                                   (0x00000002)
+#define TVE_DAC_MUX_write_en1(data)                                                  (0x00000002&((data)<<1))
+#define TVE_DAC_MUX_write_en1_src(data)                                              ((0x00000002&(data))>>1)
+#define TVE_DAC_MUX_get_write_en1(data)                                              ((0x00000002&(data))>>1)
+#define TVE_DAC_MUX_swap56_shift                                                     (0)
+#define TVE_DAC_MUX_swap56_mask                                                      (0x00000001)
+#define TVE_DAC_MUX_swap56(data)                                                     (0x00000001&((data)<<0))
+#define TVE_DAC_MUX_swap56_src(data)                                                 ((0x00000001&(data))>>0)
+#define TVE_DAC_MUX_get_swap56(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define TVE_CMP_DLY                                                                  0x1801820c
+#define TVE_CMP_DLY_reg_addr                                                         "0xB801820C"
+#define TVE_CMP_DLY_reg                                                              0xB801820C
+#define set_TVE_CMP_DLY_reg(data)   (*((volatile unsigned int*) TVE_CMP_DLY_reg)=data)
+#define get_TVE_CMP_DLY_reg   (*((volatile unsigned int*) TVE_CMP_DLY_reg))
+#define TVE_CMP_DLY_inst_adr                                                         "0x0083"
+#define TVE_CMP_DLY_inst                                                             0x0083
+#define TVE_CMP_DLY_write_en3_shift                                                  (8)
+#define TVE_CMP_DLY_write_en3_mask                                                   (0x00000100)
+#define TVE_CMP_DLY_write_en3(data)                                                  (0x00000100&((data)<<8))
+#define TVE_CMP_DLY_write_en3_src(data)                                              ((0x00000100&(data))>>8)
+#define TVE_CMP_DLY_get_write_en3(data)                                              ((0x00000100&(data))>>8)
+#define TVE_CMP_DLY_ygdelay_shift                                                    (6)
+#define TVE_CMP_DLY_ygdelay_mask                                                     (0x000000C0)
+#define TVE_CMP_DLY_ygdelay(data)                                                    (0x000000C0&((data)<<6))
+#define TVE_CMP_DLY_ygdelay_src(data)                                                ((0x000000C0&(data))>>6)
+#define TVE_CMP_DLY_get_ygdelay(data)                                                ((0x000000C0&(data))>>6)
+#define TVE_CMP_DLY_write_en2_shift                                                  (5)
+#define TVE_CMP_DLY_write_en2_mask                                                   (0x00000020)
+#define TVE_CMP_DLY_write_en2(data)                                                  (0x00000020&((data)<<5))
+#define TVE_CMP_DLY_write_en2_src(data)                                              ((0x00000020&(data))>>5)
+#define TVE_CMP_DLY_get_write_en2(data)                                              ((0x00000020&(data))>>5)
+#define TVE_CMP_DLY_bdelay_shift                                                     (3)
+#define TVE_CMP_DLY_bdelay_mask                                                      (0x00000018)
+#define TVE_CMP_DLY_bdelay(data)                                                     (0x00000018&((data)<<3))
+#define TVE_CMP_DLY_bdelay_src(data)                                                 ((0x00000018&(data))>>3)
+#define TVE_CMP_DLY_get_bdelay(data)                                                 ((0x00000018&(data))>>3)
+#define TVE_CMP_DLY_write_en1_shift                                                  (2)
+#define TVE_CMP_DLY_write_en1_mask                                                   (0x00000004)
+#define TVE_CMP_DLY_write_en1(data)                                                  (0x00000004&((data)<<2))
+#define TVE_CMP_DLY_write_en1_src(data)                                              ((0x00000004&(data))>>2)
+#define TVE_CMP_DLY_get_write_en1(data)                                              ((0x00000004&(data))>>2)
+#define TVE_CMP_DLY_rdelay_shift                                                     (0)
+#define TVE_CMP_DLY_rdelay_mask                                                      (0x00000003)
+#define TVE_CMP_DLY_rdelay(data)                                                     (0x00000003&((data)<<0))
+#define TVE_CMP_DLY_rdelay_src(data)                                                 ((0x00000003&(data))>>0)
+#define TVE_CMP_DLY_get_rdelay(data)                                                 ((0x00000003&(data))>>0)
+
+
+#define TVE_DAC_MISC                                                                 0x18018210
+#define TVE_DAC_MISC_reg_addr                                                        "0xB8018210"
+#define TVE_DAC_MISC_reg                                                             0xB8018210
+#define set_TVE_DAC_MISC_reg(data)   (*((volatile unsigned int*) TVE_DAC_MISC_reg)=data)
+#define get_TVE_DAC_MISC_reg   (*((volatile unsigned int*) TVE_DAC_MISC_reg))
+#define TVE_DAC_MISC_inst_adr                                                        "0x0084"
+#define TVE_DAC_MISC_inst                                                            0x0084
+#define TVE_DAC_MISC_write_en4_shift                                                 (25)
+#define TVE_DAC_MISC_write_en4_mask                                                  (0x02000000)
+#define TVE_DAC_MISC_write_en4(data)                                                 (0x02000000&((data)<<25))
+#define TVE_DAC_MISC_write_en4_src(data)                                             ((0x02000000&(data))>>25)
+#define TVE_DAC_MISC_get_write_en4(data)                                             ((0x02000000&(data))>>25)
+#define TVE_DAC_MISC_out_control123_shift                                            (22)
+#define TVE_DAC_MISC_out_control123_mask                                             (0x01C00000)
+#define TVE_DAC_MISC_out_control123(data)                                            (0x01C00000&((data)<<22))
+#define TVE_DAC_MISC_out_control123_src(data)                                        ((0x01C00000&(data))>>22)
+#define TVE_DAC_MISC_get_out_control123(data)                                        ((0x01C00000&(data))>>22)
+#define TVE_DAC_MISC_write_en3_shift                                                 (21)
+#define TVE_DAC_MISC_write_en3_mask                                                  (0x00200000)
+#define TVE_DAC_MISC_write_en3(data)                                                 (0x00200000&((data)<<21))
+#define TVE_DAC_MISC_write_en3_src(data)                                             ((0x00200000&(data))>>21)
+#define TVE_DAC_MISC_get_write_en3(data)                                             ((0x00200000&(data))>>21)
+#define TVE_DAC_MISC_neg_out_shift                                                   (15)
+#define TVE_DAC_MISC_neg_out_mask                                                    (0x001F8000)
+#define TVE_DAC_MISC_neg_out(data)                                                   (0x001F8000&((data)<<15))
+#define TVE_DAC_MISC_neg_out_src(data)                                               ((0x001F8000&(data))>>15)
+#define TVE_DAC_MISC_get_neg_out(data)                                               ((0x001F8000&(data))>>15)
+#define TVE_DAC_MISC_write_en2_shift                                                 (14)
+#define TVE_DAC_MISC_write_en2_mask                                                  (0x00004000)
+#define TVE_DAC_MISC_write_en2(data)                                                 (0x00004000&((data)<<14))
+#define TVE_DAC_MISC_write_en2_src(data)                                             ((0x00004000&(data))>>14)
+#define TVE_DAC_MISC_get_write_en2(data)                                             ((0x00004000&(data))>>14)
+#define TVE_DAC_MISC_out_control_shift                                               (13)
+#define TVE_DAC_MISC_out_control_mask                                                (0x00002000)
+#define TVE_DAC_MISC_out_control(data)                                               (0x00002000&((data)<<13))
+#define TVE_DAC_MISC_out_control_src(data)                                           ((0x00002000&(data))>>13)
+#define TVE_DAC_MISC_get_out_control(data)                                           ((0x00002000&(data))>>13)
+#define TVE_DAC_MISC_write_en1_shift                                                 (12)
+#define TVE_DAC_MISC_write_en1_mask                                                  (0x00001000)
+#define TVE_DAC_MISC_write_en1(data)                                                 (0x00001000&((data)<<12))
+#define TVE_DAC_MISC_write_en1_src(data)                                             ((0x00001000&(data))>>12)
+#define TVE_DAC_MISC_get_write_en1(data)                                             ((0x00001000&(data))>>12)
+#define TVE_DAC_MISC_dac_value_shift                                                 (2)
+#define TVE_DAC_MISC_dac_value_mask                                                  (0x00000FFC)
+#define TVE_DAC_MISC_dac_value(data)                                                 (0x00000FFC&((data)<<2))
+#define TVE_DAC_MISC_dac_value_src(data)                                             ((0x00000FFC&(data))>>2)
+#define TVE_DAC_MISC_get_dac_value(data)                                             ((0x00000FFC&(data))>>2)
+
+
+#define TVE_DAC_MISC1                                                                0x18018224
+#define TVE_DAC_MISC1_reg_addr                                                       "0xB8018224"
+#define TVE_DAC_MISC1_reg                                                            0xB8018224
+#define set_TVE_DAC_MISC1_reg(data)   (*((volatile unsigned int*) TVE_DAC_MISC1_reg)=data)
+#define get_TVE_DAC_MISC1_reg   (*((volatile unsigned int*) TVE_DAC_MISC1_reg))
+#define TVE_DAC_MISC1_inst_adr                                                       "0x0089"
+#define TVE_DAC_MISC1_inst                                                           0x0089
+#define TVE_DAC_MISC1_dac_value3_shift                                               (20)
+#define TVE_DAC_MISC1_dac_value3_mask                                                (0x3FF00000)
+#define TVE_DAC_MISC1_dac_value3(data)                                               (0x3FF00000&((data)<<20))
+#define TVE_DAC_MISC1_dac_value3_src(data)                                           ((0x3FF00000&(data))>>20)
+#define TVE_DAC_MISC1_get_dac_value3(data)                                           ((0x3FF00000&(data))>>20)
+#define TVE_DAC_MISC1_dac_value2_shift                                               (10)
+#define TVE_DAC_MISC1_dac_value2_mask                                                (0x000FFC00)
+#define TVE_DAC_MISC1_dac_value2(data)                                               (0x000FFC00&((data)<<10))
+#define TVE_DAC_MISC1_dac_value2_src(data)                                           ((0x000FFC00&(data))>>10)
+#define TVE_DAC_MISC1_get_dac_value2(data)                                           ((0x000FFC00&(data))>>10)
+#define TVE_DAC_MISC1_dac_value1_shift                                               (0)
+#define TVE_DAC_MISC1_dac_value1_mask                                                (0x000003FF)
+#define TVE_DAC_MISC1_dac_value1(data)                                               (0x000003FF&((data)<<0))
+#define TVE_DAC_MISC1_dac_value1_src(data)                                           ((0x000003FF&(data))>>0)
+#define TVE_DAC_MISC1_get_dac_value1(data)                                           ((0x000003FF&(data))>>0)
+
+
+#define TVE_DBG                                                                      0x18018214
+#define TVE_DBG_reg_addr                                                             "0xB8018214"
+#define TVE_DBG_reg                                                                  0xB8018214
+#define set_TVE_DBG_reg(data)   (*((volatile unsigned int*) TVE_DBG_reg)=data)
+#define get_TVE_DBG_reg   (*((volatile unsigned int*) TVE_DBG_reg))
+#define TVE_DBG_inst_adr                                                             "0x0085"
+#define TVE_DBG_inst                                                                 0x0085
+#define TVE_DBG_write_en3_shift                                                      (11)
+#define TVE_DBG_write_en3_mask                                                       (0x00000800)
+#define TVE_DBG_write_en3(data)                                                      (0x00000800&((data)<<11))
+#define TVE_DBG_write_en3_src(data)                                                  ((0x00000800&(data))>>11)
+#define TVE_DBG_get_write_en3(data)                                                  ((0x00000800&(data))>>11)
+#define TVE_DBG_sel1_shift                                                           (7)
+#define TVE_DBG_sel1_mask                                                            (0x00000780)
+#define TVE_DBG_sel1(data)                                                           (0x00000780&((data)<<7))
+#define TVE_DBG_sel1_src(data)                                                       ((0x00000780&(data))>>7)
+#define TVE_DBG_get_sel1(data)                                                       ((0x00000780&(data))>>7)
+#define TVE_DBG_write_en2_shift                                                      (6)
+#define TVE_DBG_write_en2_mask                                                       (0x00000040)
+#define TVE_DBG_write_en2(data)                                                      (0x00000040&((data)<<6))
+#define TVE_DBG_write_en2_src(data)                                                  ((0x00000040&(data))>>6)
+#define TVE_DBG_get_write_en2(data)                                                  ((0x00000040&(data))>>6)
+#define TVE_DBG_sel0_shift                                                           (2)
+#define TVE_DBG_sel0_mask                                                            (0x0000003C)
+#define TVE_DBG_sel0(data)                                                           (0x0000003C&((data)<<2))
+#define TVE_DBG_sel0_src(data)                                                       ((0x0000003C&(data))>>2)
+#define TVE_DBG_get_sel0(data)                                                       ((0x0000003C&(data))>>2)
+#define TVE_DBG_write_en1_shift                                                      (1)
+#define TVE_DBG_write_en1_mask                                                       (0x00000002)
+#define TVE_DBG_write_en1(data)                                                      (0x00000002&((data)<<1))
+#define TVE_DBG_write_en1_src(data)                                                  ((0x00000002&(data))>>1)
+#define TVE_DBG_get_write_en1(data)                                                  ((0x00000002&(data))>>1)
+#define TVE_DBG_enable_shift                                                         (0)
+#define TVE_DBG_enable_mask                                                          (0x00000001)
+#define TVE_DBG_enable(data)                                                         (0x00000001&((data)<<0))
+#define TVE_DBG_enable_src(data)                                                     ((0x00000001&(data))>>0)
+#define TVE_DBG_get_enable(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define TVE_DUMMY_0                                                                  0x18018300
+#define TVE_DUMMY_1                                                                  0x18018304
+#define TVE_DUMMY_0_reg_addr                                                         "0xB8018300"
+#define TVE_DUMMY_1_reg_addr                                                         "0xB8018304"
+#define TVE_DUMMY_0_reg                                                              0xB8018300
+#define TVE_DUMMY_1_reg                                                              0xB8018304
+#define set_TVE_DUMMY_0_reg(data)   (*((volatile unsigned int*) TVE_DUMMY_0_reg)=data)
+#define set_TVE_DUMMY_1_reg(data)   (*((volatile unsigned int*) TVE_DUMMY_1_reg)=data)
+#define get_TVE_DUMMY_0_reg   (*((volatile unsigned int*) TVE_DUMMY_0_reg))
+#define get_TVE_DUMMY_1_reg   (*((volatile unsigned int*) TVE_DUMMY_1_reg))
+#define TVE_DUMMY_0_inst_adr                                                         "0x00C0"
+#define TVE_DUMMY_1_inst_adr                                                         "0x00C1"
+#define TVE_DUMMY_0_inst                                                             0x00C0
+#define TVE_DUMMY_1_inst                                                             0x00C1
+#define TVE_DUMMY_dummy_shift                                                        (0)
+#define TVE_DUMMY_dummy_mask                                                         (0xFFFFFFFF)
+#define TVE_DUMMY_dummy(data)                                                        (0xFFFFFFFF&((data)<<0))
+#define TVE_DUMMY_dummy_src(data)                                                    ((0xFFFFFFFF&(data))>>0)
+#define TVE_DUMMY_get_dummy(data)                                                    ((0xFFFFFFFF&(data))>>0)
+
+
+#define TVE_DAC_TEST                                                                 0x18018344
+#define TVE_DAC_TEST_reg_addr                                                        "0xB8018344"
+#define TVE_DAC_TEST_reg                                                             0xB8018344
+#define set_TVE_DAC_TEST_reg(data)   (*((volatile unsigned int*) TVE_DAC_TEST_reg)=data)
+#define get_TVE_DAC_TEST_reg   (*((volatile unsigned int*) TVE_DAC_TEST_reg))
+#define TVE_DAC_TEST_inst_adr                                                        "0x00D1"
+#define TVE_DAC_TEST_inst                                                            0x00D1
+#define TVE_DAC_TEST_aio_dac_en_shift                                                (2)
+#define TVE_DAC_TEST_aio_dac_en_mask                                                 (0x00000004)
+#define TVE_DAC_TEST_aio_dac_en(data)                                                (0x00000004&((data)<<2))
+#define TVE_DAC_TEST_aio_dac_en_src(data)                                            ((0x00000004&(data))>>2)
+#define TVE_DAC_TEST_get_aio_dac_en(data)                                            ((0x00000004&(data))>>2)
+#define TVE_DAC_TEST_dac1_en_shift                                                   (1)
+#define TVE_DAC_TEST_dac1_en_mask                                                    (0x00000002)
+#define TVE_DAC_TEST_dac1_en(data)                                                   (0x00000002&((data)<<1))
+#define TVE_DAC_TEST_dac1_en_src(data)                                               ((0x00000002&(data))>>1)
+#define TVE_DAC_TEST_get_dac1_en(data)                                               ((0x00000002&(data))>>1)
+#define TVE_DAC_TEST_dac0_en_shift                                                   (0)
+#define TVE_DAC_TEST_dac0_en_mask                                                    (0x00000001)
+#define TVE_DAC_TEST_dac0_en(data)                                                   (0x00000001&((data)<<0))
+#define TVE_DAC_TEST_dac0_en_src(data)                                               ((0x00000001&(data))>>0)
+#define TVE_DAC_TEST_get_dac0_en(data)                                               ((0x00000001&(data))>>0)
+
+
+#define TVE_INTVBI_I                                                                 0x18018348
+#define TVE_INTVBI_I_reg_addr                                                        "0xB8018348"
+#define TVE_INTVBI_I_reg                                                             0xB8018348
+#define set_TVE_INTVBI_I_reg(data)   (*((volatile unsigned int*) TVE_INTVBI_I_reg)=data)
+#define get_TVE_INTVBI_I_reg   (*((volatile unsigned int*) TVE_INTVBI_I_reg))
+#define TVE_INTVBI_I_inst_adr                                                        "0x00D2"
+#define TVE_INTVBI_I_inst                                                            0x00D2
+#define TVE_INTVBI_I_write_en2_shift                                                 (25)
+#define TVE_INTVBI_I_write_en2_mask                                                  (0x02000000)
+#define TVE_INTVBI_I_write_en2(data)                                                 (0x02000000&((data)<<25))
+#define TVE_INTVBI_I_write_en2_src(data)                                             ((0x02000000&(data))>>25)
+#define TVE_INTVBI_I_get_write_en2(data)                                             ((0x02000000&(data))>>25)
+#define TVE_INTVBI_I_int_vpos_shift                                                  (14)
+#define TVE_INTVBI_I_int_vpos_mask                                                   (0x01FFC000)
+#define TVE_INTVBI_I_int_vpos(data)                                                  (0x01FFC000&((data)<<14))
+#define TVE_INTVBI_I_int_vpos_src(data)                                              ((0x01FFC000&(data))>>14)
+#define TVE_INTVBI_I_get_int_vpos(data)                                              ((0x01FFC000&(data))>>14)
+#define TVE_INTVBI_I_write_en1_shift                                                 (13)
+#define TVE_INTVBI_I_write_en1_mask                                                  (0x00002000)
+#define TVE_INTVBI_I_write_en1(data)                                                 (0x00002000&((data)<<13))
+#define TVE_INTVBI_I_write_en1_src(data)                                             ((0x00002000&(data))>>13)
+#define TVE_INTVBI_I_get_write_en1(data)                                             ((0x00002000&(data))>>13)
+#define TVE_INTVBI_I_int_hpos_shift                                                  (0)
+#define TVE_INTVBI_I_int_hpos_mask                                                   (0x00001FFF)
+#define TVE_INTVBI_I_int_hpos(data)                                                  (0x00001FFF&((data)<<0))
+#define TVE_INTVBI_I_int_hpos_src(data)                                              ((0x00001FFF&(data))>>0)
+#define TVE_INTVBI_I_get_int_hpos(data)                                              ((0x00001FFF&(data))>>0)
+
+
+#define TVE_INTVBI_P1                                                                0x1801834c
+#define TVE_INTVBI_P1_reg_addr                                                       "0xB801834C"
+#define TVE_INTVBI_P1_reg                                                            0xB801834C
+#define set_TVE_INTVBI_P1_reg(data)   (*((volatile unsigned int*) TVE_INTVBI_P1_reg)=data)
+#define get_TVE_INTVBI_P1_reg   (*((volatile unsigned int*) TVE_INTVBI_P1_reg))
+#define TVE_INTVBI_P1_inst_adr                                                       "0x00D3"
+#define TVE_INTVBI_P1_inst                                                           0x00D3
+#define TVE_INTVBI_P1_write_en2_shift                                                (25)
+#define TVE_INTVBI_P1_write_en2_mask                                                 (0x02000000)
+#define TVE_INTVBI_P1_write_en2(data)                                                (0x02000000&((data)<<25))
+#define TVE_INTVBI_P1_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTVBI_P1_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTVBI_P1_int_vpos_shift                                                 (14)
+#define TVE_INTVBI_P1_int_vpos_mask                                                  (0x01FFC000)
+#define TVE_INTVBI_P1_int_vpos(data)                                                 (0x01FFC000&((data)<<14))
+#define TVE_INTVBI_P1_int_vpos_src(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTVBI_P1_get_int_vpos(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTVBI_P1_write_en1_shift                                                (13)
+#define TVE_INTVBI_P1_write_en1_mask                                                 (0x00002000)
+#define TVE_INTVBI_P1_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_INTVBI_P1_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTVBI_P1_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTVBI_P1_int_hpos_shift                                                 (0)
+#define TVE_INTVBI_P1_int_hpos_mask                                                  (0x00001FFF)
+#define TVE_INTVBI_P1_int_hpos(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_INTVBI_P1_int_hpos_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_INTVBI_P1_get_int_hpos(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_INTVBI_P2                                                                0x18018370
+#define TVE_INTVBI_P2_reg_addr                                                       "0xB8018370"
+#define TVE_INTVBI_P2_reg                                                            0xB8018370
+#define set_TVE_INTVBI_P2_reg(data)   (*((volatile unsigned int*) TVE_INTVBI_P2_reg)=data)
+#define get_TVE_INTVBI_P2_reg   (*((volatile unsigned int*) TVE_INTVBI_P2_reg))
+#define TVE_INTVBI_P2_inst_adr                                                       "0x00DC"
+#define TVE_INTVBI_P2_inst                                                           0x00DC
+#define TVE_INTVBI_P2_write_en2_shift                                                (25)
+#define TVE_INTVBI_P2_write_en2_mask                                                 (0x02000000)
+#define TVE_INTVBI_P2_write_en2(data)                                                (0x02000000&((data)<<25))
+#define TVE_INTVBI_P2_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTVBI_P2_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTVBI_P2_int_vpos_shift                                                 (14)
+#define TVE_INTVBI_P2_int_vpos_mask                                                  (0x01FFC000)
+#define TVE_INTVBI_P2_int_vpos(data)                                                 (0x01FFC000&((data)<<14))
+#define TVE_INTVBI_P2_int_vpos_src(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTVBI_P2_get_int_vpos(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTVBI_P2_write_en1_shift                                                (13)
+#define TVE_INTVBI_P2_write_en1_mask                                                 (0x00002000)
+#define TVE_INTVBI_P2_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_INTVBI_P2_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTVBI_P2_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTVBI_P2_int_hpos_shift                                                 (0)
+#define TVE_INTVBI_P2_int_hpos_mask                                                  (0x00001FFF)
+#define TVE_INTVBI_P2_int_hpos(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_INTVBI_P2_int_hpos_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_INTVBI_P2_get_int_hpos(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_INTVBI_H1                                                                0x18018374
+#define TVE_INTVBI_H1_reg_addr                                                       "0xB8018374"
+#define TVE_INTVBI_H1_reg                                                            0xB8018374
+#define set_TVE_INTVBI_H1_reg(data)   (*((volatile unsigned int*) TVE_INTVBI_H1_reg)=data)
+#define get_TVE_INTVBI_H1_reg   (*((volatile unsigned int*) TVE_INTVBI_H1_reg))
+#define TVE_INTVBI_H1_inst_adr                                                       "0x00DD"
+#define TVE_INTVBI_H1_inst                                                           0x00DD
+#define TVE_INTVBI_H1_write_en2_shift                                                (25)
+#define TVE_INTVBI_H1_write_en2_mask                                                 (0x02000000)
+#define TVE_INTVBI_H1_write_en2(data)                                                (0x02000000&((data)<<25))
+#define TVE_INTVBI_H1_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTVBI_H1_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTVBI_H1_int_vpos_shift                                                 (14)
+#define TVE_INTVBI_H1_int_vpos_mask                                                  (0x01FFC000)
+#define TVE_INTVBI_H1_int_vpos(data)                                                 (0x01FFC000&((data)<<14))
+#define TVE_INTVBI_H1_int_vpos_src(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTVBI_H1_get_int_vpos(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTVBI_H1_write_en1_shift                                                (13)
+#define TVE_INTVBI_H1_write_en1_mask                                                 (0x00002000)
+#define TVE_INTVBI_H1_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_INTVBI_H1_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTVBI_H1_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTVBI_H1_int_hpos_shift                                                 (0)
+#define TVE_INTVBI_H1_int_hpos_mask                                                  (0x00001FFF)
+#define TVE_INTVBI_H1_int_hpos(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_INTVBI_H1_int_hpos_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_INTVBI_H1_get_int_hpos(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_INTVBI_H2                                                                0x18018378
+#define TVE_INTVBI_H2_reg_addr                                                       "0xB8018378"
+#define TVE_INTVBI_H2_reg                                                            0xB8018378
+#define set_TVE_INTVBI_H2_reg(data)   (*((volatile unsigned int*) TVE_INTVBI_H2_reg)=data)
+#define get_TVE_INTVBI_H2_reg   (*((volatile unsigned int*) TVE_INTVBI_H2_reg))
+#define TVE_INTVBI_H2_inst_adr                                                       "0x00DE"
+#define TVE_INTVBI_H2_inst                                                           0x00DE
+#define TVE_INTVBI_H2_write_en2_shift                                                (25)
+#define TVE_INTVBI_H2_write_en2_mask                                                 (0x02000000)
+#define TVE_INTVBI_H2_write_en2(data)                                                (0x02000000&((data)<<25))
+#define TVE_INTVBI_H2_write_en2_src(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTVBI_H2_get_write_en2(data)                                            ((0x02000000&(data))>>25)
+#define TVE_INTVBI_H2_int_vpos_shift                                                 (14)
+#define TVE_INTVBI_H2_int_vpos_mask                                                  (0x01FFC000)
+#define TVE_INTVBI_H2_int_vpos(data)                                                 (0x01FFC000&((data)<<14))
+#define TVE_INTVBI_H2_int_vpos_src(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTVBI_H2_get_int_vpos(data)                                             ((0x01FFC000&(data))>>14)
+#define TVE_INTVBI_H2_write_en1_shift                                                (13)
+#define TVE_INTVBI_H2_write_en1_mask                                                 (0x00002000)
+#define TVE_INTVBI_H2_write_en1(data)                                                (0x00002000&((data)<<13))
+#define TVE_INTVBI_H2_write_en1_src(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTVBI_H2_get_write_en1(data)                                            ((0x00002000&(data))>>13)
+#define TVE_INTVBI_H2_int_hpos_shift                                                 (0)
+#define TVE_INTVBI_H2_int_hpos_mask                                                  (0x00001FFF)
+#define TVE_INTVBI_H2_int_hpos(data)                                                 (0x00001FFF&((data)<<0))
+#define TVE_INTVBI_H2_int_hpos_src(data)                                             ((0x00001FFF&(data))>>0)
+#define TVE_INTVBI_H2_get_int_hpos(data)                                             ((0x00001FFF&(data))>>0)
+
+
+#define TVE_DAC1_FIR_1                                                               0x1801837c
+#define TVE_DAC1_FIR_1_reg_addr                                                      "0xB801837C"
+#define TVE_DAC1_FIR_1_reg                                                           0xB801837C
+#define set_TVE_DAC1_FIR_1_reg(data)   (*((volatile unsigned int*) TVE_DAC1_FIR_1_reg)=data)
+#define get_TVE_DAC1_FIR_1_reg   (*((volatile unsigned int*) TVE_DAC1_FIR_1_reg))
+#define TVE_DAC1_FIR_1_inst_adr                                                      "0x00DF"
+#define TVE_DAC1_FIR_1_inst                                                          0x00DF
+#define TVE_DAC1_FIR_1_c1_shift                                                      (16)
+#define TVE_DAC1_FIR_1_c1_mask                                                       (0x3FFF0000)
+#define TVE_DAC1_FIR_1_c1(data)                                                      (0x3FFF0000&((data)<<16))
+#define TVE_DAC1_FIR_1_c1_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC1_FIR_1_get_c1(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC1_FIR_1_c0_shift                                                      (0)
+#define TVE_DAC1_FIR_1_c0_mask                                                       (0x00003FFF)
+#define TVE_DAC1_FIR_1_c0(data)                                                      (0x00003FFF&((data)<<0))
+#define TVE_DAC1_FIR_1_c0_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define TVE_DAC1_FIR_1_get_c0(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define TVE_DAC1_FIR_2                                                               0x18018380
+#define TVE_DAC1_FIR_2_reg_addr                                                      "0xB8018380"
+#define TVE_DAC1_FIR_2_reg                                                           0xB8018380
+#define set_TVE_DAC1_FIR_2_reg(data)   (*((volatile unsigned int*) TVE_DAC1_FIR_2_reg)=data)
+#define get_TVE_DAC1_FIR_2_reg   (*((volatile unsigned int*) TVE_DAC1_FIR_2_reg))
+#define TVE_DAC1_FIR_2_inst_adr                                                      "0x00E0"
+#define TVE_DAC1_FIR_2_inst                                                          0x00E0
+#define TVE_DAC1_FIR_2_c3_shift                                                      (16)
+#define TVE_DAC1_FIR_2_c3_mask                                                       (0x3FFF0000)
+#define TVE_DAC1_FIR_2_c3(data)                                                      (0x3FFF0000&((data)<<16))
+#define TVE_DAC1_FIR_2_c3_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC1_FIR_2_get_c3(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC1_FIR_2_c2_shift                                                      (0)
+#define TVE_DAC1_FIR_2_c2_mask                                                       (0x00003FFF)
+#define TVE_DAC1_FIR_2_c2(data)                                                      (0x00003FFF&((data)<<0))
+#define TVE_DAC1_FIR_2_c2_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define TVE_DAC1_FIR_2_get_c2(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define TVE_DAC2_FIR_1                                                               0x18018388
+#define TVE_DAC2_FIR_1_reg_addr                                                      "0xB8018388"
+#define TVE_DAC2_FIR_1_reg                                                           0xB8018388
+#define set_TVE_DAC2_FIR_1_reg(data)   (*((volatile unsigned int*) TVE_DAC2_FIR_1_reg)=data)
+#define get_TVE_DAC2_FIR_1_reg   (*((volatile unsigned int*) TVE_DAC2_FIR_1_reg))
+#define TVE_DAC2_FIR_1_inst_adr                                                      "0x00E2"
+#define TVE_DAC2_FIR_1_inst                                                          0x00E2
+#define TVE_DAC2_FIR_1_c1_shift                                                      (16)
+#define TVE_DAC2_FIR_1_c1_mask                                                       (0x3FFF0000)
+#define TVE_DAC2_FIR_1_c1(data)                                                      (0x3FFF0000&((data)<<16))
+#define TVE_DAC2_FIR_1_c1_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC2_FIR_1_get_c1(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC2_FIR_1_c0_shift                                                      (0)
+#define TVE_DAC2_FIR_1_c0_mask                                                       (0x00003FFF)
+#define TVE_DAC2_FIR_1_c0(data)                                                      (0x00003FFF&((data)<<0))
+#define TVE_DAC2_FIR_1_c0_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define TVE_DAC2_FIR_1_get_c0(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define TVE_DAC2_FIR_2                                                               0x1801838c
+#define TVE_DAC2_FIR_2_reg_addr                                                      "0xB801838C"
+#define TVE_DAC2_FIR_2_reg                                                           0xB801838C
+#define set_TVE_DAC2_FIR_2_reg(data)   (*((volatile unsigned int*) TVE_DAC2_FIR_2_reg)=data)
+#define get_TVE_DAC2_FIR_2_reg   (*((volatile unsigned int*) TVE_DAC2_FIR_2_reg))
+#define TVE_DAC2_FIR_2_inst_adr                                                      "0x00E3"
+#define TVE_DAC2_FIR_2_inst                                                          0x00E3
+#define TVE_DAC2_FIR_2_c3_shift                                                      (16)
+#define TVE_DAC2_FIR_2_c3_mask                                                       (0x3FFF0000)
+#define TVE_DAC2_FIR_2_c3(data)                                                      (0x3FFF0000&((data)<<16))
+#define TVE_DAC2_FIR_2_c3_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC2_FIR_2_get_c3(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC2_FIR_2_c2_shift                                                      (0)
+#define TVE_DAC2_FIR_2_c2_mask                                                       (0x00003FFF)
+#define TVE_DAC2_FIR_2_c2(data)                                                      (0x00003FFF&((data)<<0))
+#define TVE_DAC2_FIR_2_c2_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define TVE_DAC2_FIR_2_get_c2(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define TVE_DAC3_FIR_1                                                               0x18018390
+#define TVE_DAC3_FIR_1_reg_addr                                                      "0xB8018390"
+#define TVE_DAC3_FIR_1_reg                                                           0xB8018390
+#define set_TVE_DAC3_FIR_1_reg(data)   (*((volatile unsigned int*) TVE_DAC3_FIR_1_reg)=data)
+#define get_TVE_DAC3_FIR_1_reg   (*((volatile unsigned int*) TVE_DAC3_FIR_1_reg))
+#define TVE_DAC3_FIR_1_inst_adr                                                      "0x00E4"
+#define TVE_DAC3_FIR_1_inst                                                          0x00E4
+#define TVE_DAC3_FIR_1_c1_shift                                                      (16)
+#define TVE_DAC3_FIR_1_c1_mask                                                       (0x3FFF0000)
+#define TVE_DAC3_FIR_1_c1(data)                                                      (0x3FFF0000&((data)<<16))
+#define TVE_DAC3_FIR_1_c1_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC3_FIR_1_get_c1(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC3_FIR_1_c0_shift                                                      (0)
+#define TVE_DAC3_FIR_1_c0_mask                                                       (0x00003FFF)
+#define TVE_DAC3_FIR_1_c0(data)                                                      (0x00003FFF&((data)<<0))
+#define TVE_DAC3_FIR_1_c0_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define TVE_DAC3_FIR_1_get_c0(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define TVE_DAC3_FIR_2                                                               0x18018394
+#define TVE_DAC3_FIR_2_reg_addr                                                      "0xB8018394"
+#define TVE_DAC3_FIR_2_reg                                                           0xB8018394
+#define set_TVE_DAC3_FIR_2_reg(data)   (*((volatile unsigned int*) TVE_DAC3_FIR_2_reg)=data)
+#define get_TVE_DAC3_FIR_2_reg   (*((volatile unsigned int*) TVE_DAC3_FIR_2_reg))
+#define TVE_DAC3_FIR_2_inst_adr                                                      "0x00E5"
+#define TVE_DAC3_FIR_2_inst                                                          0x00E5
+#define TVE_DAC3_FIR_2_c3_shift                                                      (16)
+#define TVE_DAC3_FIR_2_c3_mask                                                       (0x3FFF0000)
+#define TVE_DAC3_FIR_2_c3(data)                                                      (0x3FFF0000&((data)<<16))
+#define TVE_DAC3_FIR_2_c3_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC3_FIR_2_get_c3(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC3_FIR_2_c2_shift                                                      (0)
+#define TVE_DAC3_FIR_2_c2_mask                                                       (0x00003FFF)
+#define TVE_DAC3_FIR_2_c2(data)                                                      (0x00003FFF&((data)<<0))
+#define TVE_DAC3_FIR_2_c2_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define TVE_DAC3_FIR_2_get_c2(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define TVE_DAC4_FIR_1                                                               0x18018398
+#define TVE_DAC4_FIR_1_reg_addr                                                      "0xB8018398"
+#define TVE_DAC4_FIR_1_reg                                                           0xB8018398
+#define set_TVE_DAC4_FIR_1_reg(data)   (*((volatile unsigned int*) TVE_DAC4_FIR_1_reg)=data)
+#define get_TVE_DAC4_FIR_1_reg   (*((volatile unsigned int*) TVE_DAC4_FIR_1_reg))
+#define TVE_DAC4_FIR_1_inst_adr                                                      "0x00E6"
+#define TVE_DAC4_FIR_1_inst                                                          0x00E6
+#define TVE_DAC4_FIR_1_c1_shift                                                      (16)
+#define TVE_DAC4_FIR_1_c1_mask                                                       (0x3FFF0000)
+#define TVE_DAC4_FIR_1_c1(data)                                                      (0x3FFF0000&((data)<<16))
+#define TVE_DAC4_FIR_1_c1_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC4_FIR_1_get_c1(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC4_FIR_1_c0_shift                                                      (0)
+#define TVE_DAC4_FIR_1_c0_mask                                                       (0x00003FFF)
+#define TVE_DAC4_FIR_1_c0(data)                                                      (0x00003FFF&((data)<<0))
+#define TVE_DAC4_FIR_1_c0_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define TVE_DAC4_FIR_1_get_c0(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define TVE_DAC4_FIR_2                                                               0x1801839c
+#define TVE_DAC4_FIR_2_reg_addr                                                      "0xB801839C"
+#define TVE_DAC4_FIR_2_reg                                                           0xB801839C
+#define set_TVE_DAC4_FIR_2_reg(data)   (*((volatile unsigned int*) TVE_DAC4_FIR_2_reg)=data)
+#define get_TVE_DAC4_FIR_2_reg   (*((volatile unsigned int*) TVE_DAC4_FIR_2_reg))
+#define TVE_DAC4_FIR_2_inst_adr                                                      "0x00E7"
+#define TVE_DAC4_FIR_2_inst                                                          0x00E7
+#define TVE_DAC4_FIR_2_c3_shift                                                      (16)
+#define TVE_DAC4_FIR_2_c3_mask                                                       (0x3FFF0000)
+#define TVE_DAC4_FIR_2_c3(data)                                                      (0x3FFF0000&((data)<<16))
+#define TVE_DAC4_FIR_2_c3_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC4_FIR_2_get_c3(data)                                                  ((0x3FFF0000&(data))>>16)
+#define TVE_DAC4_FIR_2_c2_shift                                                      (0)
+#define TVE_DAC4_FIR_2_c2_mask                                                       (0x00003FFF)
+#define TVE_DAC4_FIR_2_c2(data)                                                      (0x00003FFF&((data)<<0))
+#define TVE_DAC4_FIR_2_c2_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define TVE_DAC4_FIR_2_get_c2(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define TVE_VDAC_CTR1                                                                0x180183A0
+#define TVE_VDAC_CTR1_reg_addr                                                       "0xB80183A0"
+#define TVE_VDAC_CTR1_reg                                                            0xB80183A0
+#define set_TVE_VDAC_CTR1_reg(data)   (*((volatile unsigned int*) TVE_VDAC_CTR1_reg)=data)
+#define get_TVE_VDAC_CTR1_reg   (*((volatile unsigned int*) TVE_VDAC_CTR1_reg))
+#define TVE_VDAC_CTR1_inst_adr                                                       "0x00E8"
+#define TVE_VDAC_CTR1_inst                                                           0x00E8
+#define TVE_VDAC_CTR1_reg_vdac_dac_en_shift                                          (31)
+#define TVE_VDAC_CTR1_reg_vdac_dac_en_mask                                           (0x80000000)
+#define TVE_VDAC_CTR1_reg_vdac_dac_en(data)                                          (0x80000000&((data)<<31))
+#define TVE_VDAC_CTR1_reg_vdac_dac_en_src(data)                                      ((0x80000000&(data))>>31)
+#define TVE_VDAC_CTR1_get_reg_vdac_dac_en(data)                                      ((0x80000000&(data))>>31)
+#define TVE_VDAC_CTR1_reg_vdac_powmbias_shift                                        (30)
+#define TVE_VDAC_CTR1_reg_vdac_powmbias_mask                                         (0x40000000)
+#define TVE_VDAC_CTR1_reg_vdac_powmbias(data)                                        (0x40000000&((data)<<30))
+#define TVE_VDAC_CTR1_reg_vdac_powmbias_src(data)                                    ((0x40000000&(data))>>30)
+#define TVE_VDAC_CTR1_get_reg_vdac_powmbias(data)                                    ((0x40000000&(data))>>30)
+#define TVE_VDAC_CTR1_reg_vdac_mbias_envr_shift                                      (29)
+#define TVE_VDAC_CTR1_reg_vdac_mbias_envr_mask                                       (0x20000000)
+#define TVE_VDAC_CTR1_reg_vdac_mbias_envr(data)                                      (0x20000000&((data)<<29))
+#define TVE_VDAC_CTR1_reg_vdac_mbias_envr_src(data)                                  ((0x20000000&(data))>>29)
+#define TVE_VDAC_CTR1_get_reg_vdac_mbias_envr(data)                                  ((0x20000000&(data))>>29)
+#define TVE_VDAC_CTR1_reg_vdac_mbias_vr15sel_shift                                   (27)
+#define TVE_VDAC_CTR1_reg_vdac_mbias_vr15sel_mask                                    (0x18000000)
+#define TVE_VDAC_CTR1_reg_vdac_mbias_vr15sel(data)                                   (0x18000000&((data)<<27))
+#define TVE_VDAC_CTR1_reg_vdac_mbias_vr15sel_src(data)                               ((0x18000000&(data))>>27)
+#define TVE_VDAC_CTR1_get_reg_vdac_mbias_vr15sel(data)                               ((0x18000000&(data))>>27)
+#define TVE_VDAC_CTR1_reg_vdac_bg_rbg2_shift                                         (25)
+#define TVE_VDAC_CTR1_reg_vdac_bg_rbg2_mask                                          (0x06000000)
+#define TVE_VDAC_CTR1_reg_vdac_bg_rbg2(data)                                         (0x06000000&((data)<<25))
+#define TVE_VDAC_CTR1_reg_vdac_bg_rbg2_src(data)                                     ((0x06000000&(data))>>25)
+#define TVE_VDAC_CTR1_get_reg_vdac_bg_rbg2(data)                                     ((0x06000000&(data))>>25)
+#define TVE_VDAC_CTR1_reg_vdac_bg_envbgup_shift                                      (24)
+#define TVE_VDAC_CTR1_reg_vdac_bg_envbgup_mask                                       (0x01000000)
+#define TVE_VDAC_CTR1_reg_vdac_bg_envbgup(data)                                      (0x01000000&((data)<<24))
+#define TVE_VDAC_CTR1_reg_vdac_bg_envbgup_src(data)                                  ((0x01000000&(data))>>24)
+#define TVE_VDAC_CTR1_get_reg_vdac_bg_envbgup(data)                                  ((0x01000000&(data))>>24)
+#define TVE_VDAC_CTR1_reg_vdac_bg_rbg_shift                                          (21)
+#define TVE_VDAC_CTR1_reg_vdac_bg_rbg_mask                                           (0x00E00000)
+#define TVE_VDAC_CTR1_reg_vdac_bg_rbg(data)                                          (0x00E00000&((data)<<21))
+#define TVE_VDAC_CTR1_reg_vdac_bg_rbg_src(data)                                      ((0x00E00000&(data))>>21)
+#define TVE_VDAC_CTR1_get_reg_vdac_bg_rbg(data)                                      ((0x00E00000&(data))>>21)
+#define TVE_VDAC_CTR1_reg_vdac_dac_vref_adj_shift                                    (19)
+#define TVE_VDAC_CTR1_reg_vdac_dac_vref_adj_mask                                     (0x00180000)
+#define TVE_VDAC_CTR1_reg_vdac_dac_vref_adj(data)                                    (0x00180000&((data)<<19))
+#define TVE_VDAC_CTR1_reg_vdac_dac_vref_adj_src(data)                                ((0x00180000&(data))>>19)
+#define TVE_VDAC_CTR1_get_reg_vdac_dac_vref_adj(data)                                ((0x00180000&(data))>>19)
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_setup_shift                                 (14)
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_setup_mask                                  (0x0007C000)
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_setup(data)                                 (0x0007C000&((data)<<14))
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_setup_src(data)                             ((0x0007C000&(data))>>14)
+#define TVE_VDAC_CTR1_get_reg_vdac_dac_res75_setup(data)                             ((0x0007C000&(data))>>14)
+#define TVE_VDAC_CTR1_reg_vdac_dac_clkedge_shift                                     (13)
+#define TVE_VDAC_CTR1_reg_vdac_dac_clkedge_mask                                      (0x00002000)
+#define TVE_VDAC_CTR1_reg_vdac_dac_clkedge(data)                                     (0x00002000&((data)<<13))
+#define TVE_VDAC_CTR1_reg_vdac_dac_clkedge_src(data)                                 ((0x00002000&(data))>>13)
+#define TVE_VDAC_CTR1_get_reg_vdac_dac_clkedge(data)                                 ((0x00002000&(data))>>13)
+#define TVE_VDAC_CTR1_reg_vdac_dac_cur_shift                                         (9)
+#define TVE_VDAC_CTR1_reg_vdac_dac_cur_mask                                          (0x00001E00)
+#define TVE_VDAC_CTR1_reg_vdac_dac_cur(data)                                         (0x00001E00&((data)<<9))
+#define TVE_VDAC_CTR1_reg_vdac_dac_cur_src(data)                                     ((0x00001E00&(data))>>9)
+#define TVE_VDAC_CTR1_get_reg_vdac_dac_cur(data)                                     ((0x00001E00&(data))>>9)
+#define TVE_VDAC_CTR1_reg_vdac_dac_cal75_en_shift                                    (8)
+#define TVE_VDAC_CTR1_reg_vdac_dac_cal75_en_mask                                     (0x00000100)
+#define TVE_VDAC_CTR1_reg_vdac_dac_cal75_en(data)                                    (0x00000100&((data)<<8))
+#define TVE_VDAC_CTR1_reg_vdac_dac_cal75_en_src(data)                                ((0x00000100&(data))>>8)
+#define TVE_VDAC_CTR1_get_reg_vdac_dac_cal75_en(data)                                ((0x00000100&(data))>>8)
+#define TVE_VDAC_CTR1_reg_vdac_dac_draw_en_shift                                     (7)
+#define TVE_VDAC_CTR1_reg_vdac_dac_draw_en_mask                                      (0x00000080)
+#define TVE_VDAC_CTR1_reg_vdac_dac_draw_en(data)                                     (0x00000080&((data)<<7))
+#define TVE_VDAC_CTR1_reg_vdac_dac_draw_en_src(data)                                 ((0x00000080&(data))>>7)
+#define TVE_VDAC_CTR1_get_reg_vdac_dac_draw_en(data)                                 ((0x00000080&(data))>>7)
+#define TVE_VDAC_CTR1_reg_vdac_dac_plugin_en_shift                                   (6)
+#define TVE_VDAC_CTR1_reg_vdac_dac_plugin_en_mask                                    (0x00000040)
+#define TVE_VDAC_CTR1_reg_vdac_dac_plugin_en(data)                                   (0x00000040&((data)<<6))
+#define TVE_VDAC_CTR1_reg_vdac_dac_plugin_en_src(data)                               ((0x00000040&(data))>>6)
+#define TVE_VDAC_CTR1_get_reg_vdac_dac_plugin_en(data)                               ((0x00000040&(data))>>6)
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_en_shift                                    (5)
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_en_mask                                     (0x00000020)
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_en(data)                                    (0x00000020&((data)<<5))
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_en_src(data)                                ((0x00000020&(data))>>5)
+#define TVE_VDAC_CTR1_get_reg_vdac_dac_res75_en(data)                                ((0x00000020&(data))>>5)
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_sel_shift                                   (4)
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_sel_mask                                    (0x00000010)
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_sel(data)                                   (0x00000010&((data)<<4))
+#define TVE_VDAC_CTR1_reg_vdac_dac_res75_sel_src(data)                               ((0x00000010&(data))>>4)
+#define TVE_VDAC_CTR1_get_reg_vdac_dac_res75_sel(data)                               ((0x00000010&(data))>>4)
+
+
+#define TVE_VDAC_CTR2                                                                0x180183A4
+#define TVE_VDAC_CTR2_reg_addr                                                       "0xB80183A4"
+#define TVE_VDAC_CTR2_reg                                                            0xB80183A4
+#define set_TVE_VDAC_CTR2_reg(data)   (*((volatile unsigned int*) TVE_VDAC_CTR2_reg)=data)
+#define get_TVE_VDAC_CTR2_reg   (*((volatile unsigned int*) TVE_VDAC_CTR2_reg))
+#define TVE_VDAC_CTR2_inst_adr                                                       "0x00E9"
+#define TVE_VDAC_CTR2_inst                                                           0x00E9
+#define TVE_VDAC_CTR2_reg_vdac_bg_auto_en_shift                                      (7)
+#define TVE_VDAC_CTR2_reg_vdac_bg_auto_en_mask                                       (0x00000080)
+#define TVE_VDAC_CTR2_reg_vdac_bg_auto_en(data)                                      (0x00000080&((data)<<7))
+#define TVE_VDAC_CTR2_reg_vdac_bg_auto_en_src(data)                                  ((0x00000080&(data))>>7)
+#define TVE_VDAC_CTR2_get_reg_vdac_bg_auto_en(data)                                  ((0x00000080&(data))>>7)
+#define TVE_VDAC_CTR2_reg_vdac_dac_rescal_shift                                      (2)
+#define TVE_VDAC_CTR2_reg_vdac_dac_rescal_mask                                       (0x0000007C)
+#define TVE_VDAC_CTR2_reg_vdac_dac_rescal(data)                                      (0x0000007C&((data)<<2))
+#define TVE_VDAC_CTR2_reg_vdac_dac_rescal_src(data)                                  ((0x0000007C&(data))>>2)
+#define TVE_VDAC_CTR2_get_reg_vdac_dac_rescal(data)                                  ((0x0000007C&(data))>>2)
+#define TVE_VDAC_CTR2_reg_vdac_dac_plugin_shift                                      (1)
+#define TVE_VDAC_CTR2_reg_vdac_dac_plugin_mask                                       (0x00000002)
+#define TVE_VDAC_CTR2_reg_vdac_dac_plugin(data)                                      (0x00000002&((data)<<1))
+#define TVE_VDAC_CTR2_reg_vdac_dac_plugin_src(data)                                  ((0x00000002&(data))>>1)
+#define TVE_VDAC_CTR2_get_reg_vdac_dac_plugin(data)                                  ((0x00000002&(data))>>1)
+#define TVE_VDAC_CTR2_reg_vdac_dac_drawout_shift                                     (0)
+#define TVE_VDAC_CTR2_reg_vdac_dac_drawout_mask                                      (0x00000001)
+#define TVE_VDAC_CTR2_reg_vdac_dac_drawout(data)                                     (0x00000001&((data)<<0))
+#define TVE_VDAC_CTR2_reg_vdac_dac_drawout_src(data)                                 ((0x00000001&(data))>>0)
+#define TVE_VDAC_CTR2_get_reg_vdac_dac_drawout(data)                                 ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/usb_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/usb_reg.h
new file mode 100644
index 00000000..0564e9a
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/usb_reg.h
@@ -0,0 +1,1235 @@
+/**************************************************************
+// Spec Version                  : 0.0.2
+// Parser Version                : MAR_Parser_1.0
+// CModelGen Version             : 4.1 2009.03.10
+// Naming Rule                   : Register_Name_reg
+// Firmware Header Generate Date : 2010/7/27
+***************************************************************/
+
+
+#ifndef _USB_REG_H_INCLUDED_
+#define _USB_REG_H_INCLUDED_
+#ifdef  _USB_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     sram_debug_sel:1;
+unsigned int     sram_debug_mode:1;
+unsigned int     dbus_multi_req_disable:1;
+unsigned int     dev_mode:1;
+}WRAP_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     device_int:1;
+unsigned int     host_int:1;
+}GNR_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     reset_utmi_p0:1;
+}USB2_PHY_UTMI;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     reset_pipe3_p0:1;
+}USB3_PHY_PIPE;
+
+typedef struct 
+{
+unsigned int     data:16;
+unsigned int     phy_addr:3;
+unsigned int     phy_reg_addr:5;
+unsigned int     mdio_busy:1;
+unsigned int     mdio_st:2;
+unsigned int     mdio_rdy:1;
+unsigned int     mclk_rate:2;
+unsigned int     mdio_srst:1;
+unsigned int     mdio_rdwr:1;
+}MDIO_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     p0_vstatus_out:8;
+}VSTATUS0_OUT;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     simulation_mode_p0:1;
+unsigned int     force_hs_mode_p0:1;
+unsigned int     test_rst_p0:1;
+unsigned int     test_en_p0:1;
+}SLP_BACK0_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     test_speed_p0:2;
+unsigned int     test_seed_p0:8;
+unsigned int     test_psl_p0:2;
+}SLP_BACK0_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     test_fail_p0:1;
+unsigned int     test_done_p0:1;
+}SLP_BACK0_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     p0_usb2phy_slb_hs:1;
+unsigned int     p0_usb2phy_force_slb:1;
+}PHY2_SLB_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     p0_usb2phy_slb_fail:1;
+unsigned int     p0_usb2phy_slb_done:1;
+}PHY2_SLB_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     p0_suspend_r:1;
+}USB2_SPD_CTR;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     p0_pipe_bist_sel:2;
+unsigned int     p0_pipe_bist_en:1;
+}PHY3_SLB_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     p0_usb3phy_slb_go:1;
+}PHY3_SLB_CT;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     p0_usb3phy_slb_fail:1;
+unsigned int     p0_usb3phy_slb_done:1;
+}PHY3_SLB_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     dbg_sel1:6;
+unsigned int     dbg_sel0:6;
+unsigned int     dbg_en:1;
+}USB_DBG;
+
+typedef struct 
+{
+unsigned int     reg1:16;
+unsigned int     reg0:16;
+}USB_SCTCH;
+
+typedef struct 
+{
+unsigned int     test_sp_reg:32;
+}USB_TMP_SP;
+
+typedef struct 
+{
+unsigned int     test_reg:32;
+}USB_TMP;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     host_utmiotg_vbusvalid:1;
+unsigned int     host_fladj_30mhz:6;
+unsigned int     host_ppc_present:1;
+unsigned int     host_msi_enable:1;
+unsigned int     host_pm_pw_state_req:2;
+unsigned int     hub_port_over_current:4;
+unsigned int     reserved_1:2;
+unsigned int     hub_port_perm_attach:2;
+unsigned int     reserved_2:2;
+unsigned int     host_u2_port_disable:1;
+unsigned int     host_u3_port_disable:1;
+unsigned int     host_num_u2_port:4;
+unsigned int     host_num_u3_port:4;
+}HMAC_CTR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     host_current_power_state:2;
+unsigned int     host_hub_vbus_ctrl:2;
+}MAC3_HST_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     dev_vbus_value:1;
+unsigned int     dev_utmiotg_vbusvalid:1;
+unsigned int     dev_pm_pw_state_req:2;
+unsigned int     dev_fladj_30mhz:6;
+unsigned int     dev_usb_outep_pkt_buff:16;
+}DMAC_CTR0;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     dev_current_power_state:2;
+}MAC3_DEV_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     p0_DmPulldown:1;
+unsigned int     p0_DpPulldown:1;
+unsigned int     p0_IDPULLUP:1;
+unsigned int     reserved_1:5;
+unsigned int     p0_DmPulldown_sel:1;
+unsigned int     p0_DpPulldown_sel:1;
+unsigned int     p0_IDPULLUP_sel:1;
+}USB2_PHY;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     done_st:1;
+unsigned int     reserved_1:15;
+unsigned int     go_ct:1;
+}RAM_CTR;
+
+typedef struct 
+{
+unsigned int     sram_addr:32;
+}RAM_ADDR;
+
+typedef struct 
+{
+unsigned int     ram_wdata:32;
+}RAM_WDATA;
+
+typedef struct 
+{
+unsigned int     ram_rdata:32;
+}RAM_RDATA;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     p0_count_num:19;
+}PHY0_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     phy3_hperiod:3;
+unsigned int     phy3_lperiod:3;
+unsigned int     phy3_last:2;
+unsigned int     host_ovr_current_value:1;
+unsigned int     host_ovr_current_sel:1;
+}USB3_OVR_CT;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     rstn_usb2_phy1:1;
+unsigned int     rstn_usb2_phy0:1;
+unsigned int     rstn_usb2:1;
+}SOFT_RESET;
+
+typedef struct 
+{
+unsigned int     usb_mac_ctrl:32;
+}GBL_USB_CT;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     dbus_robin_enable:1;
+unsigned int     cmd_full_number:2;
+unsigned int     dbus_arb_priority:1;
+}GBL_USB_ARB;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     usb2_bist_test_mode:1;
+unsigned int     write_data:1;
+}USB_BIST_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     usb2_bist_en:1;
+unsigned int     write_data:1;
+}USB_BIST_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     usb2_2_bist_fail0:1;
+unsigned int     usb2_2_bist_done:1;
+unsigned int     usb2_bist_fail0:1;
+unsigned int     usb2_bist_done:1;
+}USB_BIST_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     usb2_2_drf_start_pause:1;
+unsigned int     usb2_drf_start_pause:1;
+}USB_DRF_START;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     usb2_2_drf_test_resume:1;
+unsigned int     usb2_drf_test_resume:1;
+unsigned int     write_data:1;
+}USB_DRF_RESUME;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     usb2_drf_bist_en:1;
+unsigned int     write_data:1;
+}USB_DRF_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     usb2_2_drf_bist_fail0:1;
+unsigned int     usb2_2_drf_bist_done:1;
+unsigned int     usb2_drf_bist_fail0:1;
+unsigned int     usb2_drf_bist_done:1;
+}USB_DRF_ST;
+
+#endif
+
+#define WRAP_CTR                                                                     0x18013200
+#define WRAP_CTR_reg_addr                                                            "0xB8013200"
+#define WRAP_CTR_reg                                                                 0xB8013200
+#define set_WRAP_CTR_reg(data)   (*((volatile unsigned int*) WRAP_CTR_reg)=data)
+#define get_WRAP_CTR_reg   (*((volatile unsigned int*) WRAP_CTR_reg))
+#define WRAP_CTR_inst_adr                                                            "0x0080"
+#define WRAP_CTR_inst                                                                0x0080
+#define WRAP_CTR_sram_debug_sel_shift                                                (3)
+#define WRAP_CTR_sram_debug_sel_mask                                                 (0x00000008)
+#define WRAP_CTR_sram_debug_sel(data)                                                (0x00000008&((data)<<3))
+#define WRAP_CTR_sram_debug_sel_src(data)                                            ((0x00000008&(data))>>3)
+#define WRAP_CTR_get_sram_debug_sel(data)                                            ((0x00000008&(data))>>3)
+#define WRAP_CTR_sram_debug_mode_shift                                               (2)
+#define WRAP_CTR_sram_debug_mode_mask                                                (0x00000004)
+#define WRAP_CTR_sram_debug_mode(data)                                               (0x00000004&((data)<<2))
+#define WRAP_CTR_sram_debug_mode_src(data)                                           ((0x00000004&(data))>>2)
+#define WRAP_CTR_get_sram_debug_mode(data)                                           ((0x00000004&(data))>>2)
+#define WRAP_CTR_dbus_multi_req_disable_shift                                        (1)
+#define WRAP_CTR_dbus_multi_req_disable_mask                                         (0x00000002)
+#define WRAP_CTR_dbus_multi_req_disable(data)                                        (0x00000002&((data)<<1))
+#define WRAP_CTR_dbus_multi_req_disable_src(data)                                    ((0x00000002&(data))>>1)
+#define WRAP_CTR_get_dbus_multi_req_disable(data)                                    ((0x00000002&(data))>>1)
+#define WRAP_CTR_dev_mode_shift                                                      (0)
+#define WRAP_CTR_dev_mode_mask                                                       (0x00000001)
+#define WRAP_CTR_dev_mode(data)                                                      (0x00000001&((data)<<0))
+#define WRAP_CTR_dev_mode_src(data)                                                  ((0x00000001&(data))>>0)
+#define WRAP_CTR_get_dev_mode(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define GNR_INT                                                                      0x18013204
+#define GNR_INT_reg_addr                                                             "0xB8013204"
+#define GNR_INT_reg                                                                  0xB8013204
+#define set_GNR_INT_reg(data)   (*((volatile unsigned int*) GNR_INT_reg)=data)
+#define get_GNR_INT_reg   (*((volatile unsigned int*) GNR_INT_reg))
+#define GNR_INT_inst_adr                                                             "0x0081"
+#define GNR_INT_inst                                                                 0x0081
+#define GNR_INT_device_int_shift                                                     (1)
+#define GNR_INT_device_int_mask                                                      (0x00000002)
+#define GNR_INT_device_int(data)                                                     (0x00000002&((data)<<1))
+#define GNR_INT_device_int_src(data)                                                 ((0x00000002&(data))>>1)
+#define GNR_INT_get_device_int(data)                                                 ((0x00000002&(data))>>1)
+#define GNR_INT_host_int_shift                                                       (0)
+#define GNR_INT_host_int_mask                                                        (0x00000001)
+#define GNR_INT_host_int(data)                                                       (0x00000001&((data)<<0))
+#define GNR_INT_host_int_src(data)                                                   ((0x00000001&(data))>>0)
+#define GNR_INT_get_host_int(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define USB2_PHY_UTMI                                                                0x18013208
+#define USB2_PHY_UTMI_reg_addr                                                       "0xB8013208"
+#define USB2_PHY_UTMI_reg                                                            0xB8013208
+#define set_USB2_PHY_UTMI_reg(data)   (*((volatile unsigned int*) USB2_PHY_UTMI_reg)=data)
+#define get_USB2_PHY_UTMI_reg   (*((volatile unsigned int*) USB2_PHY_UTMI_reg))
+#define USB2_PHY_UTMI_inst_adr                                                       "0x0082"
+#define USB2_PHY_UTMI_inst                                                           0x0082
+#define USB2_PHY_UTMI_reset_utmi_p0_shift                                            (0)
+#define USB2_PHY_UTMI_reset_utmi_p0_mask                                             (0x00000001)
+#define USB2_PHY_UTMI_reset_utmi_p0(data)                                            (0x00000001&((data)<<0))
+#define USB2_PHY_UTMI_reset_utmi_p0_src(data)                                        ((0x00000001&(data))>>0)
+#define USB2_PHY_UTMI_get_reset_utmi_p0(data)                                        ((0x00000001&(data))>>0)
+
+
+#define USB3_PHY_PIPE                                                                0x1801320c
+#define USB3_PHY_PIPE_reg_addr                                                       "0xB801320C"
+#define USB3_PHY_PIPE_reg                                                            0xB801320C
+#define set_USB3_PHY_PIPE_reg(data)   (*((volatile unsigned int*) USB3_PHY_PIPE_reg)=data)
+#define get_USB3_PHY_PIPE_reg   (*((volatile unsigned int*) USB3_PHY_PIPE_reg))
+#define USB3_PHY_PIPE_inst_adr                                                       "0x0083"
+#define USB3_PHY_PIPE_inst                                                           0x0083
+#define USB3_PHY_PIPE_reset_pipe3_p0_shift                                           (0)
+#define USB3_PHY_PIPE_reset_pipe3_p0_mask                                            (0x00000001)
+#define USB3_PHY_PIPE_reset_pipe3_p0(data)                                           (0x00000001&((data)<<0))
+#define USB3_PHY_PIPE_reset_pipe3_p0_src(data)                                       ((0x00000001&(data))>>0)
+#define USB3_PHY_PIPE_get_reset_pipe3_p0(data)                                       ((0x00000001&(data))>>0)
+
+
+#define MDIO_CTR                                                                     0x18013210
+#define MDIO_CTR_reg_addr                                                            "0xB8013210"
+#define MDIO_CTR_reg                                                                 0xB8013210
+#define set_MDIO_CTR_reg(data)   (*((volatile unsigned int*) MDIO_CTR_reg)=data)
+#define get_MDIO_CTR_reg   (*((volatile unsigned int*) MDIO_CTR_reg))
+#define MDIO_CTR_inst_adr                                                            "0x0084"
+#define MDIO_CTR_inst                                                                0x0084
+#define MDIO_CTR_data_shift                                                          (16)
+#define MDIO_CTR_data_mask                                                           (0xFFFF0000)
+#define MDIO_CTR_data(data)                                                          (0xFFFF0000&((data)<<16))
+#define MDIO_CTR_data_src(data)                                                      ((0xFFFF0000&(data))>>16)
+#define MDIO_CTR_get_data(data)                                                      ((0xFFFF0000&(data))>>16)
+#define MDIO_CTR_phy_addr_shift                                                      (13)
+#define MDIO_CTR_phy_addr_mask                                                       (0x0000E000)
+#define MDIO_CTR_phy_addr(data)                                                      (0x0000E000&((data)<<13))
+#define MDIO_CTR_phy_addr_src(data)                                                  ((0x0000E000&(data))>>13)
+#define MDIO_CTR_get_phy_addr(data)                                                  ((0x0000E000&(data))>>13)
+#define MDIO_CTR_phy_reg_addr_shift                                                  (8)
+#define MDIO_CTR_phy_reg_addr_mask                                                   (0x00001F00)
+#define MDIO_CTR_phy_reg_addr(data)                                                  (0x00001F00&((data)<<8))
+#define MDIO_CTR_phy_reg_addr_src(data)                                              ((0x00001F00&(data))>>8)
+#define MDIO_CTR_get_phy_reg_addr(data)                                              ((0x00001F00&(data))>>8)
+#define MDIO_CTR_mdio_busy_shift                                                     (7)
+#define MDIO_CTR_mdio_busy_mask                                                      (0x00000080)
+#define MDIO_CTR_mdio_busy(data)                                                     (0x00000080&((data)<<7))
+#define MDIO_CTR_mdio_busy_src(data)                                                 ((0x00000080&(data))>>7)
+#define MDIO_CTR_get_mdio_busy(data)                                                 ((0x00000080&(data))>>7)
+#define MDIO_CTR_mdio_st_shift                                                       (5)
+#define MDIO_CTR_mdio_st_mask                                                        (0x00000060)
+#define MDIO_CTR_mdio_st(data)                                                       (0x00000060&((data)<<5))
+#define MDIO_CTR_mdio_st_src(data)                                                   ((0x00000060&(data))>>5)
+#define MDIO_CTR_get_mdio_st(data)                                                   ((0x00000060&(data))>>5)
+#define MDIO_CTR_mdio_rdy_shift                                                      (4)
+#define MDIO_CTR_mdio_rdy_mask                                                       (0x00000010)
+#define MDIO_CTR_mdio_rdy(data)                                                      (0x00000010&((data)<<4))
+#define MDIO_CTR_mdio_rdy_src(data)                                                  ((0x00000010&(data))>>4)
+#define MDIO_CTR_get_mdio_rdy(data)                                                  ((0x00000010&(data))>>4)
+#define MDIO_CTR_mclk_rate_shift                                                     (2)
+#define MDIO_CTR_mclk_rate_mask                                                      (0x0000000C)
+#define MDIO_CTR_mclk_rate(data)                                                     (0x0000000C&((data)<<2))
+#define MDIO_CTR_mclk_rate_src(data)                                                 ((0x0000000C&(data))>>2)
+#define MDIO_CTR_get_mclk_rate(data)                                                 ((0x0000000C&(data))>>2)
+#define MDIO_CTR_mdio_srst_shift                                                     (1)
+#define MDIO_CTR_mdio_srst_mask                                                      (0x00000002)
+#define MDIO_CTR_mdio_srst(data)                                                     (0x00000002&((data)<<1))
+#define MDIO_CTR_mdio_srst_src(data)                                                 ((0x00000002&(data))>>1)
+#define MDIO_CTR_get_mdio_srst(data)                                                 ((0x00000002&(data))>>1)
+#define MDIO_CTR_mdio_rdwr_shift                                                     (0)
+#define MDIO_CTR_mdio_rdwr_mask                                                      (0x00000001)
+#define MDIO_CTR_mdio_rdwr(data)                                                     (0x00000001&((data)<<0))
+#define MDIO_CTR_mdio_rdwr_src(data)                                                 ((0x00000001&(data))>>0)
+#define MDIO_CTR_get_mdio_rdwr(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VSTATUS0_OUT                                                                 0x18013214
+#define VSTATUS0_OUT_reg_addr                                                        "0xB8013214"
+#define VSTATUS0_OUT_reg                                                             0xB8013214
+#define set_VSTATUS0_OUT_reg(data)   (*((volatile unsigned int*) VSTATUS0_OUT_reg)=data)
+#define get_VSTATUS0_OUT_reg   (*((volatile unsigned int*) VSTATUS0_OUT_reg))
+#define VSTATUS0_OUT_inst_adr                                                        "0x0085"
+#define VSTATUS0_OUT_inst                                                            0x0085
+#define VSTATUS0_OUT_p0_vstatus_out_shift                                            (0)
+#define VSTATUS0_OUT_p0_vstatus_out_mask                                             (0x000000FF)
+#define VSTATUS0_OUT_p0_vstatus_out(data)                                            (0x000000FF&((data)<<0))
+#define VSTATUS0_OUT_p0_vstatus_out_src(data)                                        ((0x000000FF&(data))>>0)
+#define VSTATUS0_OUT_get_p0_vstatus_out(data)                                        ((0x000000FF&(data))>>0)
+
+
+#define SLP_BACK0_EN                                                                 0x18013218
+#define SLP_BACK0_EN_reg_addr                                                        "0xB8013218"
+#define SLP_BACK0_EN_reg                                                             0xB8013218
+#define set_SLP_BACK0_EN_reg(data)   (*((volatile unsigned int*) SLP_BACK0_EN_reg)=data)
+#define get_SLP_BACK0_EN_reg   (*((volatile unsigned int*) SLP_BACK0_EN_reg))
+#define SLP_BACK0_EN_inst_adr                                                        "0x0086"
+#define SLP_BACK0_EN_inst                                                            0x0086
+#define SLP_BACK0_EN_simulation_mode_p0_shift                                        (3)
+#define SLP_BACK0_EN_simulation_mode_p0_mask                                         (0x00000008)
+#define SLP_BACK0_EN_simulation_mode_p0(data)                                        (0x00000008&((data)<<3))
+#define SLP_BACK0_EN_simulation_mode_p0_src(data)                                    ((0x00000008&(data))>>3)
+#define SLP_BACK0_EN_get_simulation_mode_p0(data)                                    ((0x00000008&(data))>>3)
+#define SLP_BACK0_EN_force_hs_mode_p0_shift                                          (2)
+#define SLP_BACK0_EN_force_hs_mode_p0_mask                                           (0x00000004)
+#define SLP_BACK0_EN_force_hs_mode_p0(data)                                          (0x00000004&((data)<<2))
+#define SLP_BACK0_EN_force_hs_mode_p0_src(data)                                      ((0x00000004&(data))>>2)
+#define SLP_BACK0_EN_get_force_hs_mode_p0(data)                                      ((0x00000004&(data))>>2)
+#define SLP_BACK0_EN_test_rst_p0_shift                                               (1)
+#define SLP_BACK0_EN_test_rst_p0_mask                                                (0x00000002)
+#define SLP_BACK0_EN_test_rst_p0(data)                                               (0x00000002&((data)<<1))
+#define SLP_BACK0_EN_test_rst_p0_src(data)                                           ((0x00000002&(data))>>1)
+#define SLP_BACK0_EN_get_test_rst_p0(data)                                           ((0x00000002&(data))>>1)
+#define SLP_BACK0_EN_test_en_p0_shift                                                (0)
+#define SLP_BACK0_EN_test_en_p0_mask                                                 (0x00000001)
+#define SLP_BACK0_EN_test_en_p0(data)                                                (0x00000001&((data)<<0))
+#define SLP_BACK0_EN_test_en_p0_src(data)                                            ((0x00000001&(data))>>0)
+#define SLP_BACK0_EN_get_test_en_p0(data)                                            ((0x00000001&(data))>>0)
+
+
+#define SLP_BACK0_CTR                                                                0x1801321c
+#define SLP_BACK0_CTR_reg_addr                                                       "0xB801321C"
+#define SLP_BACK0_CTR_reg                                                            0xB801321C
+#define set_SLP_BACK0_CTR_reg(data)   (*((volatile unsigned int*) SLP_BACK0_CTR_reg)=data)
+#define get_SLP_BACK0_CTR_reg   (*((volatile unsigned int*) SLP_BACK0_CTR_reg))
+#define SLP_BACK0_CTR_inst_adr                                                       "0x0087"
+#define SLP_BACK0_CTR_inst                                                           0x0087
+#define SLP_BACK0_CTR_test_speed_p0_shift                                            (10)
+#define SLP_BACK0_CTR_test_speed_p0_mask                                             (0x00000C00)
+#define SLP_BACK0_CTR_test_speed_p0(data)                                            (0x00000C00&((data)<<10))
+#define SLP_BACK0_CTR_test_speed_p0_src(data)                                        ((0x00000C00&(data))>>10)
+#define SLP_BACK0_CTR_get_test_speed_p0(data)                                        ((0x00000C00&(data))>>10)
+#define SLP_BACK0_CTR_test_seed_p0_shift                                             (2)
+#define SLP_BACK0_CTR_test_seed_p0_mask                                              (0x000003FC)
+#define SLP_BACK0_CTR_test_seed_p0(data)                                             (0x000003FC&((data)<<2))
+#define SLP_BACK0_CTR_test_seed_p0_src(data)                                         ((0x000003FC&(data))>>2)
+#define SLP_BACK0_CTR_get_test_seed_p0(data)                                         ((0x000003FC&(data))>>2)
+#define SLP_BACK0_CTR_test_psl_p0_shift                                              (0)
+#define SLP_BACK0_CTR_test_psl_p0_mask                                               (0x00000003)
+#define SLP_BACK0_CTR_test_psl_p0(data)                                              (0x00000003&((data)<<0))
+#define SLP_BACK0_CTR_test_psl_p0_src(data)                                          ((0x00000003&(data))>>0)
+#define SLP_BACK0_CTR_get_test_psl_p0(data)                                          ((0x00000003&(data))>>0)
+
+
+#define SLP_BACK0_ST                                                                 0x18013220
+#define SLP_BACK0_ST_reg_addr                                                        "0xB8013220"
+#define SLP_BACK0_ST_reg                                                             0xB8013220
+#define set_SLP_BACK0_ST_reg(data)   (*((volatile unsigned int*) SLP_BACK0_ST_reg)=data)
+#define get_SLP_BACK0_ST_reg   (*((volatile unsigned int*) SLP_BACK0_ST_reg))
+#define SLP_BACK0_ST_inst_adr                                                        "0x0088"
+#define SLP_BACK0_ST_inst                                                            0x0088
+#define SLP_BACK0_ST_test_fail_p0_shift                                              (1)
+#define SLP_BACK0_ST_test_fail_p0_mask                                               (0x00000002)
+#define SLP_BACK0_ST_test_fail_p0(data)                                              (0x00000002&((data)<<1))
+#define SLP_BACK0_ST_test_fail_p0_src(data)                                          ((0x00000002&(data))>>1)
+#define SLP_BACK0_ST_get_test_fail_p0(data)                                          ((0x00000002&(data))>>1)
+#define SLP_BACK0_ST_test_done_p0_shift                                              (0)
+#define SLP_BACK0_ST_test_done_p0_mask                                               (0x00000001)
+#define SLP_BACK0_ST_test_done_p0(data)                                              (0x00000001&((data)<<0))
+#define SLP_BACK0_ST_test_done_p0_src(data)                                          ((0x00000001&(data))>>0)
+#define SLP_BACK0_ST_get_test_done_p0(data)                                          ((0x00000001&(data))>>0)
+
+
+#define PHY2_SLB_EN                                                                  0x18013224
+#define PHY2_SLB_EN_reg_addr                                                         "0xB8013224"
+#define PHY2_SLB_EN_reg                                                              0xB8013224
+#define set_PHY2_SLB_EN_reg(data)   (*((volatile unsigned int*) PHY2_SLB_EN_reg)=data)
+#define get_PHY2_SLB_EN_reg   (*((volatile unsigned int*) PHY2_SLB_EN_reg))
+#define PHY2_SLB_EN_inst_adr                                                         "0x0089"
+#define PHY2_SLB_EN_inst                                                             0x0089
+#define PHY2_SLB_EN_p0_usb2phy_slb_hs_shift                                          (1)
+#define PHY2_SLB_EN_p0_usb2phy_slb_hs_mask                                           (0x00000002)
+#define PHY2_SLB_EN_p0_usb2phy_slb_hs(data)                                          (0x00000002&((data)<<1))
+#define PHY2_SLB_EN_p0_usb2phy_slb_hs_src(data)                                      ((0x00000002&(data))>>1)
+#define PHY2_SLB_EN_get_p0_usb2phy_slb_hs(data)                                      ((0x00000002&(data))>>1)
+#define PHY2_SLB_EN_p0_usb2phy_force_slb_shift                                       (0)
+#define PHY2_SLB_EN_p0_usb2phy_force_slb_mask                                        (0x00000001)
+#define PHY2_SLB_EN_p0_usb2phy_force_slb(data)                                       (0x00000001&((data)<<0))
+#define PHY2_SLB_EN_p0_usb2phy_force_slb_src(data)                                   ((0x00000001&(data))>>0)
+#define PHY2_SLB_EN_get_p0_usb2phy_force_slb(data)                                   ((0x00000001&(data))>>0)
+
+
+#define PHY2_SLB_ST                                                                  0x18013228
+#define PHY2_SLB_ST_reg_addr                                                         "0xB8013228"
+#define PHY2_SLB_ST_reg                                                              0xB8013228
+#define set_PHY2_SLB_ST_reg(data)   (*((volatile unsigned int*) PHY2_SLB_ST_reg)=data)
+#define get_PHY2_SLB_ST_reg   (*((volatile unsigned int*) PHY2_SLB_ST_reg))
+#define PHY2_SLB_ST_inst_adr                                                         "0x008A"
+#define PHY2_SLB_ST_inst                                                             0x008A
+#define PHY2_SLB_ST_p0_usb2phy_slb_fail_shift                                        (1)
+#define PHY2_SLB_ST_p0_usb2phy_slb_fail_mask                                         (0x00000002)
+#define PHY2_SLB_ST_p0_usb2phy_slb_fail(data)                                        (0x00000002&((data)<<1))
+#define PHY2_SLB_ST_p0_usb2phy_slb_fail_src(data)                                    ((0x00000002&(data))>>1)
+#define PHY2_SLB_ST_get_p0_usb2phy_slb_fail(data)                                    ((0x00000002&(data))>>1)
+#define PHY2_SLB_ST_p0_usb2phy_slb_done_shift                                        (0)
+#define PHY2_SLB_ST_p0_usb2phy_slb_done_mask                                         (0x00000001)
+#define PHY2_SLB_ST_p0_usb2phy_slb_done(data)                                        (0x00000001&((data)<<0))
+#define PHY2_SLB_ST_p0_usb2phy_slb_done_src(data)                                    ((0x00000001&(data))>>0)
+#define PHY2_SLB_ST_get_p0_usb2phy_slb_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define USB2_SPD_CTR                                                                 0x1801322c
+#define USB2_SPD_CTR_reg_addr                                                        "0xB801322C"
+#define USB2_SPD_CTR_reg                                                             0xB801322C
+#define set_USB2_SPD_CTR_reg(data)   (*((volatile unsigned int*) USB2_SPD_CTR_reg)=data)
+#define get_USB2_SPD_CTR_reg   (*((volatile unsigned int*) USB2_SPD_CTR_reg))
+#define USB2_SPD_CTR_inst_adr                                                        "0x008B"
+#define USB2_SPD_CTR_inst                                                            0x008B
+#define USB2_SPD_CTR_p0_suspend_r_shift                                              (0)
+#define USB2_SPD_CTR_p0_suspend_r_mask                                               (0x00000001)
+#define USB2_SPD_CTR_p0_suspend_r(data)                                              (0x00000001&((data)<<0))
+#define USB2_SPD_CTR_p0_suspend_r_src(data)                                          ((0x00000001&(data))>>0)
+#define USB2_SPD_CTR_get_p0_suspend_r(data)                                          ((0x00000001&(data))>>0)
+
+
+#define PHY3_SLB_EN                                                                  0x18013230
+#define PHY3_SLB_EN_reg_addr                                                         "0xB8013230"
+#define PHY3_SLB_EN_reg                                                              0xB8013230
+#define set_PHY3_SLB_EN_reg(data)   (*((volatile unsigned int*) PHY3_SLB_EN_reg)=data)
+#define get_PHY3_SLB_EN_reg   (*((volatile unsigned int*) PHY3_SLB_EN_reg))
+#define PHY3_SLB_EN_inst_adr                                                         "0x008C"
+#define PHY3_SLB_EN_inst                                                             0x008C
+#define PHY3_SLB_EN_p0_pipe_bist_sel_shift                                           (1)
+#define PHY3_SLB_EN_p0_pipe_bist_sel_mask                                            (0x00000006)
+#define PHY3_SLB_EN_p0_pipe_bist_sel(data)                                           (0x00000006&((data)<<1))
+#define PHY3_SLB_EN_p0_pipe_bist_sel_src(data)                                       ((0x00000006&(data))>>1)
+#define PHY3_SLB_EN_get_p0_pipe_bist_sel(data)                                       ((0x00000006&(data))>>1)
+#define PHY3_SLB_EN_p0_pipe_bist_en_shift                                            (0)
+#define PHY3_SLB_EN_p0_pipe_bist_en_mask                                             (0x00000001)
+#define PHY3_SLB_EN_p0_pipe_bist_en(data)                                            (0x00000001&((data)<<0))
+#define PHY3_SLB_EN_p0_pipe_bist_en_src(data)                                        ((0x00000001&(data))>>0)
+#define PHY3_SLB_EN_get_p0_pipe_bist_en(data)                                        ((0x00000001&(data))>>0)
+
+
+#define PHY3_SLB_CT                                                                  0x18013234
+#define PHY3_SLB_CT_reg_addr                                                         "0xB8013234"
+#define PHY3_SLB_CT_reg                                                              0xB8013234
+#define set_PHY3_SLB_CT_reg(data)   (*((volatile unsigned int*) PHY3_SLB_CT_reg)=data)
+#define get_PHY3_SLB_CT_reg   (*((volatile unsigned int*) PHY3_SLB_CT_reg))
+#define PHY3_SLB_CT_inst_adr                                                         "0x008D"
+#define PHY3_SLB_CT_inst                                                             0x008D
+#define PHY3_SLB_CT_p0_usb3phy_slb_go_shift                                          (0)
+#define PHY3_SLB_CT_p0_usb3phy_slb_go_mask                                           (0x00000001)
+#define PHY3_SLB_CT_p0_usb3phy_slb_go(data)                                          (0x00000001&((data)<<0))
+#define PHY3_SLB_CT_p0_usb3phy_slb_go_src(data)                                      ((0x00000001&(data))>>0)
+#define PHY3_SLB_CT_get_p0_usb3phy_slb_go(data)                                      ((0x00000001&(data))>>0)
+
+
+#define PHY3_SLB_ST                                                                  0x18013238
+#define PHY3_SLB_ST_reg_addr                                                         "0xB8013238"
+#define PHY3_SLB_ST_reg                                                              0xB8013238
+#define set_PHY3_SLB_ST_reg(data)   (*((volatile unsigned int*) PHY3_SLB_ST_reg)=data)
+#define get_PHY3_SLB_ST_reg   (*((volatile unsigned int*) PHY3_SLB_ST_reg))
+#define PHY3_SLB_ST_inst_adr                                                         "0x008E"
+#define PHY3_SLB_ST_inst                                                             0x008E
+#define PHY3_SLB_ST_p0_usb3phy_slb_fail_shift                                        (1)
+#define PHY3_SLB_ST_p0_usb3phy_slb_fail_mask                                         (0x00000002)
+#define PHY3_SLB_ST_p0_usb3phy_slb_fail(data)                                        (0x00000002&((data)<<1))
+#define PHY3_SLB_ST_p0_usb3phy_slb_fail_src(data)                                    ((0x00000002&(data))>>1)
+#define PHY3_SLB_ST_get_p0_usb3phy_slb_fail(data)                                    ((0x00000002&(data))>>1)
+#define PHY3_SLB_ST_p0_usb3phy_slb_done_shift                                        (0)
+#define PHY3_SLB_ST_p0_usb3phy_slb_done_mask                                         (0x00000001)
+#define PHY3_SLB_ST_p0_usb3phy_slb_done(data)                                        (0x00000001&((data)<<0))
+#define PHY3_SLB_ST_p0_usb3phy_slb_done_src(data)                                    ((0x00000001&(data))>>0)
+#define PHY3_SLB_ST_get_p0_usb3phy_slb_done(data)                                    ((0x00000001&(data))>>0)
+
+
+#define USB_DBG                                                                      0x18013240
+#define USB_DBG_reg_addr                                                             "0xB8013240"
+#define USB_DBG_reg                                                                  0xB8013240
+#define set_USB_DBG_reg(data)   (*((volatile unsigned int*) USB_DBG_reg)=data)
+#define get_USB_DBG_reg   (*((volatile unsigned int*) USB_DBG_reg))
+#define USB_DBG_inst_adr                                                             "0x0090"
+#define USB_DBG_inst                                                                 0x0090
+#define USB_DBG_dbg_sel1_shift                                                       (7)
+#define USB_DBG_dbg_sel1_mask                                                        (0x00001F80)
+#define USB_DBG_dbg_sel1(data)                                                       (0x00001F80&((data)<<7))
+#define USB_DBG_dbg_sel1_src(data)                                                   ((0x00001F80&(data))>>7)
+#define USB_DBG_get_dbg_sel1(data)                                                   ((0x00001F80&(data))>>7)
+#define USB_DBG_dbg_sel0_shift                                                       (1)
+#define USB_DBG_dbg_sel0_mask                                                        (0x0000007E)
+#define USB_DBG_dbg_sel0(data)                                                       (0x0000007E&((data)<<1))
+#define USB_DBG_dbg_sel0_src(data)                                                   ((0x0000007E&(data))>>1)
+#define USB_DBG_get_dbg_sel0(data)                                                   ((0x0000007E&(data))>>1)
+#define USB_DBG_dbg_en_shift                                                         (0)
+#define USB_DBG_dbg_en_mask                                                          (0x00000001)
+#define USB_DBG_dbg_en(data)                                                         (0x00000001&((data)<<0))
+#define USB_DBG_dbg_en_src(data)                                                     ((0x00000001&(data))>>0)
+#define USB_DBG_get_dbg_en(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define USB_SCTCH                                                                    0x18013244
+#define USB_SCTCH_reg_addr                                                           "0xB8013244"
+#define USB_SCTCH_reg                                                                0xB8013244
+#define set_USB_SCTCH_reg(data)   (*((volatile unsigned int*) USB_SCTCH_reg)=data)
+#define get_USB_SCTCH_reg   (*((volatile unsigned int*) USB_SCTCH_reg))
+#define USB_SCTCH_inst_adr                                                           "0x0091"
+#define USB_SCTCH_inst                                                               0x0091
+#define USB_SCTCH_reg1_shift                                                         (16)
+#define USB_SCTCH_reg1_mask                                                          (0xFFFF0000)
+#define USB_SCTCH_reg1(data)                                                         (0xFFFF0000&((data)<<16))
+#define USB_SCTCH_reg1_src(data)                                                     ((0xFFFF0000&(data))>>16)
+#define USB_SCTCH_get_reg1(data)                                                     ((0xFFFF0000&(data))>>16)
+#define USB_SCTCH_reg0_shift                                                         (0)
+#define USB_SCTCH_reg0_mask                                                          (0x0000FFFF)
+#define USB_SCTCH_reg0(data)                                                         (0x0000FFFF&((data)<<0))
+#define USB_SCTCH_reg0_src(data)                                                     ((0x0000FFFF&(data))>>0)
+#define USB_SCTCH_get_reg0(data)                                                     ((0x0000FFFF&(data))>>0)
+
+
+#define USB_TMP_SP_0                                                                 0x18013248
+#define USB_TMP_SP_1                                                                 0x1801324C
+#define USB_TMP_SP_0_reg_addr                                                        "0xB8013248"
+#define USB_TMP_SP_1_reg_addr                                                        "0xB801324C"
+#define USB_TMP_SP_0_reg                                                             0xB8013248
+#define USB_TMP_SP_1_reg                                                             0xB801324C
+#define set_USB_TMP_SP_0_reg(data)   (*((volatile unsigned int*) USB_TMP_SP_0_reg)=data)
+#define set_USB_TMP_SP_1_reg(data)   (*((volatile unsigned int*) USB_TMP_SP_1_reg)=data)
+#define get_USB_TMP_SP_0_reg   (*((volatile unsigned int*) USB_TMP_SP_0_reg))
+#define get_USB_TMP_SP_1_reg   (*((volatile unsigned int*) USB_TMP_SP_1_reg))
+#define USB_TMP_SP_0_inst_adr                                                        "0x0092"
+#define USB_TMP_SP_1_inst_adr                                                        "0x0093"
+#define USB_TMP_SP_0_inst                                                            0x0092
+#define USB_TMP_SP_1_inst                                                            0x0093
+#define USB_TMP_SP_test_sp_reg_shift                                                 (0)
+#define USB_TMP_SP_test_sp_reg_mask                                                  (0xFFFFFFFF)
+#define USB_TMP_SP_test_sp_reg(data)                                                 (0xFFFFFFFF&((data)<<0))
+#define USB_TMP_SP_test_sp_reg_src(data)                                             ((0xFFFFFFFF&(data))>>0)
+#define USB_TMP_SP_get_test_sp_reg(data)                                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define USB_TMP_0                                                                    0x18013250
+#define USB_TMP_1                                                                    0x18013254
+#define USB_TMP_2                                                                    0x18013258
+#define USB_TMP_3                                                                    0x1801325C
+#define USB_TMP_0_reg_addr                                                           "0xB8013250"
+#define USB_TMP_1_reg_addr                                                           "0xB8013254"
+#define USB_TMP_2_reg_addr                                                           "0xB8013258"
+#define USB_TMP_3_reg_addr                                                           "0xB801325C"
+#define USB_TMP_0_reg                                                                0xB8013250
+#define USB_TMP_1_reg                                                                0xB8013254
+#define USB_TMP_2_reg                                                                0xB8013258
+#define USB_TMP_3_reg                                                                0xB801325C
+#define set_USB_TMP_0_reg(data)   (*((volatile unsigned int*) USB_TMP_0_reg)=data)
+#define set_USB_TMP_1_reg(data)   (*((volatile unsigned int*) USB_TMP_1_reg)=data)
+#define set_USB_TMP_2_reg(data)   (*((volatile unsigned int*) USB_TMP_2_reg)=data)
+#define set_USB_TMP_3_reg(data)   (*((volatile unsigned int*) USB_TMP_3_reg)=data)
+#define get_USB_TMP_0_reg   (*((volatile unsigned int*) USB_TMP_0_reg))
+#define get_USB_TMP_1_reg   (*((volatile unsigned int*) USB_TMP_1_reg))
+#define get_USB_TMP_2_reg   (*((volatile unsigned int*) USB_TMP_2_reg))
+#define get_USB_TMP_3_reg   (*((volatile unsigned int*) USB_TMP_3_reg))
+#define USB_TMP_0_inst_adr                                                           "0x0094"
+#define USB_TMP_1_inst_adr                                                           "0x0095"
+#define USB_TMP_2_inst_adr                                                           "0x0096"
+#define USB_TMP_3_inst_adr                                                           "0x0097"
+#define USB_TMP_0_inst                                                               0x0094
+#define USB_TMP_1_inst                                                               0x0095
+#define USB_TMP_2_inst                                                               0x0096
+#define USB_TMP_3_inst                                                               0x0097
+#define USB_TMP_test_reg_shift                                                       (0)
+#define USB_TMP_test_reg_mask                                                        (0xFFFFFFFF)
+#define USB_TMP_test_reg(data)                                                       (0xFFFFFFFF&((data)<<0))
+#define USB_TMP_test_reg_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
+#define USB_TMP_get_test_reg(data)                                                   ((0xFFFFFFFF&(data))>>0)
+
+
+#define HMAC_CTR0                                                                    0x18013260
+#define HMAC_CTR0_reg_addr                                                           "0xB8013260"
+#define HMAC_CTR0_reg                                                                0xB8013260
+#define set_HMAC_CTR0_reg(data)   (*((volatile unsigned int*) HMAC_CTR0_reg)=data)
+#define get_HMAC_CTR0_reg   (*((volatile unsigned int*) HMAC_CTR0_reg))
+#define HMAC_CTR0_inst_adr                                                           "0x0098"
+#define HMAC_CTR0_inst                                                               0x0098
+#define HMAC_CTR0_host_utmiotg_vbusvalid_shift                                       (30)
+#define HMAC_CTR0_host_utmiotg_vbusvalid_mask                                        (0x40000000)
+#define HMAC_CTR0_host_utmiotg_vbusvalid(data)                                       (0x40000000&((data)<<30))
+#define HMAC_CTR0_host_utmiotg_vbusvalid_src(data)                                   ((0x40000000&(data))>>30)
+#define HMAC_CTR0_get_host_utmiotg_vbusvalid(data)                                   ((0x40000000&(data))>>30)
+#define HMAC_CTR0_host_fladj_30mhz_shift                                             (24)
+#define HMAC_CTR0_host_fladj_30mhz_mask                                              (0x3F000000)
+#define HMAC_CTR0_host_fladj_30mhz(data)                                             (0x3F000000&((data)<<24))
+#define HMAC_CTR0_host_fladj_30mhz_src(data)                                         ((0x3F000000&(data))>>24)
+#define HMAC_CTR0_get_host_fladj_30mhz(data)                                         ((0x3F000000&(data))>>24)
+#define HMAC_CTR0_host_ppc_present_shift                                             (23)
+#define HMAC_CTR0_host_ppc_present_mask                                              (0x00800000)
+#define HMAC_CTR0_host_ppc_present(data)                                             (0x00800000&((data)<<23))
+#define HMAC_CTR0_host_ppc_present_src(data)                                         ((0x00800000&(data))>>23)
+#define HMAC_CTR0_get_host_ppc_present(data)                                         ((0x00800000&(data))>>23)
+#define HMAC_CTR0_host_msi_enable_shift                                              (22)
+#define HMAC_CTR0_host_msi_enable_mask                                               (0x00400000)
+#define HMAC_CTR0_host_msi_enable(data)                                              (0x00400000&((data)<<22))
+#define HMAC_CTR0_host_msi_enable_src(data)                                          ((0x00400000&(data))>>22)
+#define HMAC_CTR0_get_host_msi_enable(data)                                          ((0x00400000&(data))>>22)
+#define HMAC_CTR0_host_pm_pw_state_req_shift                                         (20)
+#define HMAC_CTR0_host_pm_pw_state_req_mask                                          (0x00300000)
+#define HMAC_CTR0_host_pm_pw_state_req(data)                                         (0x00300000&((data)<<20))
+#define HMAC_CTR0_host_pm_pw_state_req_src(data)                                     ((0x00300000&(data))>>20)
+#define HMAC_CTR0_get_host_pm_pw_state_req(data)                                     ((0x00300000&(data))>>20)
+#define HMAC_CTR0_hub_port_over_current_shift                                        (16)
+#define HMAC_CTR0_hub_port_over_current_mask                                         (0x000F0000)
+#define HMAC_CTR0_hub_port_over_current(data)                                        (0x000F0000&((data)<<16))
+#define HMAC_CTR0_hub_port_over_current_src(data)                                    ((0x000F0000&(data))>>16)
+#define HMAC_CTR0_get_hub_port_over_current(data)                                    ((0x000F0000&(data))>>16)
+#define HMAC_CTR0_hub_port_perm_attach_shift                                         (12)
+#define HMAC_CTR0_hub_port_perm_attach_mask                                          (0x00003000)
+#define HMAC_CTR0_hub_port_perm_attach(data)                                         (0x00003000&((data)<<12))
+#define HMAC_CTR0_hub_port_perm_attach_src(data)                                     ((0x00003000&(data))>>12)
+#define HMAC_CTR0_get_hub_port_perm_attach(data)                                     ((0x00003000&(data))>>12)
+#define HMAC_CTR0_host_u2_port_disable_shift                                         (9)
+#define HMAC_CTR0_host_u2_port_disable_mask                                          (0x00000200)
+#define HMAC_CTR0_host_u2_port_disable(data)                                         (0x00000200&((data)<<9))
+#define HMAC_CTR0_host_u2_port_disable_src(data)                                     ((0x00000200&(data))>>9)
+#define HMAC_CTR0_get_host_u2_port_disable(data)                                     ((0x00000200&(data))>>9)
+#define HMAC_CTR0_host_u3_port_disable_shift                                         (8)
+#define HMAC_CTR0_host_u3_port_disable_mask                                          (0x00000100)
+#define HMAC_CTR0_host_u3_port_disable(data)                                         (0x00000100&((data)<<8))
+#define HMAC_CTR0_host_u3_port_disable_src(data)                                     ((0x00000100&(data))>>8)
+#define HMAC_CTR0_get_host_u3_port_disable(data)                                     ((0x00000100&(data))>>8)
+#define HMAC_CTR0_host_num_u2_port_shift                                             (4)
+#define HMAC_CTR0_host_num_u2_port_mask                                              (0x000000F0)
+#define HMAC_CTR0_host_num_u2_port(data)                                             (0x000000F0&((data)<<4))
+#define HMAC_CTR0_host_num_u2_port_src(data)                                         ((0x000000F0&(data))>>4)
+#define HMAC_CTR0_get_host_num_u2_port(data)                                         ((0x000000F0&(data))>>4)
+#define HMAC_CTR0_host_num_u3_port_shift                                             (0)
+#define HMAC_CTR0_host_num_u3_port_mask                                              (0x0000000F)
+#define HMAC_CTR0_host_num_u3_port(data)                                             (0x0000000F&((data)<<0))
+#define HMAC_CTR0_host_num_u3_port_src(data)                                         ((0x0000000F&(data))>>0)
+#define HMAC_CTR0_get_host_num_u3_port(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define MAC3_HST_ST                                                                  0x18013264
+#define MAC3_HST_ST_reg_addr                                                         "0xB8013264"
+#define MAC3_HST_ST_reg                                                              0xB8013264
+#define set_MAC3_HST_ST_reg(data)   (*((volatile unsigned int*) MAC3_HST_ST_reg)=data)
+#define get_MAC3_HST_ST_reg   (*((volatile unsigned int*) MAC3_HST_ST_reg))
+#define MAC3_HST_ST_inst_adr                                                         "0x0099"
+#define MAC3_HST_ST_inst                                                             0x0099
+#define MAC3_HST_ST_host_current_power_state_shift                                   (2)
+#define MAC3_HST_ST_host_current_power_state_mask                                    (0x0000000C)
+#define MAC3_HST_ST_host_current_power_state(data)                                   (0x0000000C&((data)<<2))
+#define MAC3_HST_ST_host_current_power_state_src(data)                               ((0x0000000C&(data))>>2)
+#define MAC3_HST_ST_get_host_current_power_state(data)                               ((0x0000000C&(data))>>2)
+#define MAC3_HST_ST_host_hub_vbus_ctrl_shift                                         (0)
+#define MAC3_HST_ST_host_hub_vbus_ctrl_mask                                          (0x00000003)
+#define MAC3_HST_ST_host_hub_vbus_ctrl(data)                                         (0x00000003&((data)<<0))
+#define MAC3_HST_ST_host_hub_vbus_ctrl_src(data)                                     ((0x00000003&(data))>>0)
+#define MAC3_HST_ST_get_host_hub_vbus_ctrl(data)                                     ((0x00000003&(data))>>0)
+
+
+#define DMAC_CTR0                                                                    0x18013268
+#define DMAC_CTR0_reg_addr                                                           "0xB8013268"
+#define DMAC_CTR0_reg                                                                0xB8013268
+#define set_DMAC_CTR0_reg(data)   (*((volatile unsigned int*) DMAC_CTR0_reg)=data)
+#define get_DMAC_CTR0_reg   (*((volatile unsigned int*) DMAC_CTR0_reg))
+#define DMAC_CTR0_inst_adr                                                           "0x009A"
+#define DMAC_CTR0_inst                                                               0x009A
+#define DMAC_CTR0_dev_vbus_value_shift                                               (25)
+#define DMAC_CTR0_dev_vbus_value_mask                                                (0x02000000)
+#define DMAC_CTR0_dev_vbus_value(data)                                               (0x02000000&((data)<<25))
+#define DMAC_CTR0_dev_vbus_value_src(data)                                           ((0x02000000&(data))>>25)
+#define DMAC_CTR0_get_dev_vbus_value(data)                                           ((0x02000000&(data))>>25)
+#define DMAC_CTR0_dev_utmiotg_vbusvalid_shift                                        (24)
+#define DMAC_CTR0_dev_utmiotg_vbusvalid_mask                                         (0x01000000)
+#define DMAC_CTR0_dev_utmiotg_vbusvalid(data)                                        (0x01000000&((data)<<24))
+#define DMAC_CTR0_dev_utmiotg_vbusvalid_src(data)                                    ((0x01000000&(data))>>24)
+#define DMAC_CTR0_get_dev_utmiotg_vbusvalid(data)                                    ((0x01000000&(data))>>24)
+#define DMAC_CTR0_dev_pm_pw_state_req_shift                                          (22)
+#define DMAC_CTR0_dev_pm_pw_state_req_mask                                           (0x00C00000)
+#define DMAC_CTR0_dev_pm_pw_state_req(data)                                          (0x00C00000&((data)<<22))
+#define DMAC_CTR0_dev_pm_pw_state_req_src(data)                                      ((0x00C00000&(data))>>22)
+#define DMAC_CTR0_get_dev_pm_pw_state_req(data)                                      ((0x00C00000&(data))>>22)
+#define DMAC_CTR0_dev_fladj_30mhz_shift                                              (16)
+#define DMAC_CTR0_dev_fladj_30mhz_mask                                               (0x003F0000)
+#define DMAC_CTR0_dev_fladj_30mhz(data)                                              (0x003F0000&((data)<<16))
+#define DMAC_CTR0_dev_fladj_30mhz_src(data)                                          ((0x003F0000&(data))>>16)
+#define DMAC_CTR0_get_dev_fladj_30mhz(data)                                          ((0x003F0000&(data))>>16)
+#define DMAC_CTR0_dev_usb_outep_pkt_buff_shift                                       (0)
+#define DMAC_CTR0_dev_usb_outep_pkt_buff_mask                                        (0x0000FFFF)
+#define DMAC_CTR0_dev_usb_outep_pkt_buff(data)                                       (0x0000FFFF&((data)<<0))
+#define DMAC_CTR0_dev_usb_outep_pkt_buff_src(data)                                   ((0x0000FFFF&(data))>>0)
+#define DMAC_CTR0_get_dev_usb_outep_pkt_buff(data)                                   ((0x0000FFFF&(data))>>0)
+
+
+#define MAC3_DEV_ST                                                                  0x1801326c
+#define MAC3_DEV_ST_reg_addr                                                         "0xB801326C"
+#define MAC3_DEV_ST_reg                                                              0xB801326C
+#define set_MAC3_DEV_ST_reg(data)   (*((volatile unsigned int*) MAC3_DEV_ST_reg)=data)
+#define get_MAC3_DEV_ST_reg   (*((volatile unsigned int*) MAC3_DEV_ST_reg))
+#define MAC3_DEV_ST_inst_adr                                                         "0x009B"
+#define MAC3_DEV_ST_inst                                                             0x009B
+#define MAC3_DEV_ST_dev_current_power_state_shift                                    (0)
+#define MAC3_DEV_ST_dev_current_power_state_mask                                     (0x00000003)
+#define MAC3_DEV_ST_dev_current_power_state(data)                                    (0x00000003&((data)<<0))
+#define MAC3_DEV_ST_dev_current_power_state_src(data)                                ((0x00000003&(data))>>0)
+#define MAC3_DEV_ST_get_dev_current_power_state(data)                                ((0x00000003&(data))>>0)
+
+
+#define USB2_PHY                                                                     0x18013270
+#define USB2_PHY_reg_addr                                                            "0xB8013270"
+#define USB2_PHY_reg                                                                 0xB8013270
+#define set_USB2_PHY_reg(data)   (*((volatile unsigned int*) USB2_PHY_reg)=data)
+#define get_USB2_PHY_reg   (*((volatile unsigned int*) USB2_PHY_reg))
+#define USB2_PHY_inst_adr                                                            "0x009C"
+#define USB2_PHY_inst                                                                0x009C
+#define USB2_PHY_p0_DmPulldown_shift                                                 (10)
+#define USB2_PHY_p0_DmPulldown_mask                                                  (0x00000400)
+#define USB2_PHY_p0_DmPulldown(data)                                                 (0x00000400&((data)<<10))
+#define USB2_PHY_p0_DmPulldown_src(data)                                             ((0x00000400&(data))>>10)
+#define USB2_PHY_get_p0_DmPulldown(data)                                             ((0x00000400&(data))>>10)
+#define USB2_PHY_p0_DpPulldown_shift                                                 (9)
+#define USB2_PHY_p0_DpPulldown_mask                                                  (0x00000200)
+#define USB2_PHY_p0_DpPulldown(data)                                                 (0x00000200&((data)<<9))
+#define USB2_PHY_p0_DpPulldown_src(data)                                             ((0x00000200&(data))>>9)
+#define USB2_PHY_get_p0_DpPulldown(data)                                             ((0x00000200&(data))>>9)
+#define USB2_PHY_p0_IDPULLUP_shift                                                   (8)
+#define USB2_PHY_p0_IDPULLUP_mask                                                    (0x00000100)
+#define USB2_PHY_p0_IDPULLUP(data)                                                   (0x00000100&((data)<<8))
+#define USB2_PHY_p0_IDPULLUP_src(data)                                               ((0x00000100&(data))>>8)
+#define USB2_PHY_get_p0_IDPULLUP(data)                                               ((0x00000100&(data))>>8)
+#define USB2_PHY_p0_DmPulldown_sel_shift                                             (2)
+#define USB2_PHY_p0_DmPulldown_sel_mask                                              (0x00000004)
+#define USB2_PHY_p0_DmPulldown_sel(data)                                             (0x00000004&((data)<<2))
+#define USB2_PHY_p0_DmPulldown_sel_src(data)                                         ((0x00000004&(data))>>2)
+#define USB2_PHY_get_p0_DmPulldown_sel(data)                                         ((0x00000004&(data))>>2)
+#define USB2_PHY_p0_DpPulldown_sel_shift                                             (1)
+#define USB2_PHY_p0_DpPulldown_sel_mask                                              (0x00000002)
+#define USB2_PHY_p0_DpPulldown_sel(data)                                             (0x00000002&((data)<<1))
+#define USB2_PHY_p0_DpPulldown_sel_src(data)                                         ((0x00000002&(data))>>1)
+#define USB2_PHY_get_p0_DpPulldown_sel(data)                                         ((0x00000002&(data))>>1)
+#define USB2_PHY_p0_IDPULLUP_sel_shift                                               (0)
+#define USB2_PHY_p0_IDPULLUP_sel_mask                                                (0x00000001)
+#define USB2_PHY_p0_IDPULLUP_sel(data)                                               (0x00000001&((data)<<0))
+#define USB2_PHY_p0_IDPULLUP_sel_src(data)                                           ((0x00000001&(data))>>0)
+#define USB2_PHY_get_p0_IDPULLUP_sel(data)                                           ((0x00000001&(data))>>0)
+
+
+#define RAM_CTR                                                                      0x18013274
+#define RAM_CTR_reg_addr                                                             "0xB8013274"
+#define RAM_CTR_reg                                                                  0xB8013274
+#define set_RAM_CTR_reg(data)   (*((volatile unsigned int*) RAM_CTR_reg)=data)
+#define get_RAM_CTR_reg   (*((volatile unsigned int*) RAM_CTR_reg))
+#define RAM_CTR_inst_adr                                                             "0x009D"
+#define RAM_CTR_inst                                                                 0x009D
+#define RAM_CTR_done_st_shift                                                        (16)
+#define RAM_CTR_done_st_mask                                                         (0x00010000)
+#define RAM_CTR_done_st(data)                                                        (0x00010000&((data)<<16))
+#define RAM_CTR_done_st_src(data)                                                    ((0x00010000&(data))>>16)
+#define RAM_CTR_get_done_st(data)                                                    ((0x00010000&(data))>>16)
+#define RAM_CTR_go_ct_shift                                                          (0)
+#define RAM_CTR_go_ct_mask                                                           (0x00000001)
+#define RAM_CTR_go_ct(data)                                                          (0x00000001&((data)<<0))
+#define RAM_CTR_go_ct_src(data)                                                      ((0x00000001&(data))>>0)
+#define RAM_CTR_get_go_ct(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define RAM_ADDR                                                                     0x18013278
+#define RAM_ADDR_reg_addr                                                            "0xB8013278"
+#define RAM_ADDR_reg                                                                 0xB8013278
+#define set_RAM_ADDR_reg(data)   (*((volatile unsigned int*) RAM_ADDR_reg)=data)
+#define get_RAM_ADDR_reg   (*((volatile unsigned int*) RAM_ADDR_reg))
+#define RAM_ADDR_inst_adr                                                            "0x009E"
+#define RAM_ADDR_inst                                                                0x009E
+#define RAM_ADDR_sram_addr_shift                                                     (0)
+#define RAM_ADDR_sram_addr_mask                                                      (0xFFFFFFFF)
+#define RAM_ADDR_sram_addr(data)                                                     (0xFFFFFFFF&((data)<<0))
+#define RAM_ADDR_sram_addr_src(data)                                                 ((0xFFFFFFFF&(data))>>0)
+#define RAM_ADDR_get_sram_addr(data)                                                 ((0xFFFFFFFF&(data))>>0)
+
+
+#define RAM_WDATA                                                                    0x1801327C
+#define RAM_WDATA_reg_addr                                                           "0xB801327C"
+#define RAM_WDATA_reg                                                                0xB801327C
+#define set_RAM_WDATA_reg(data)   (*((volatile unsigned int*) RAM_WDATA_reg)=data)
+#define get_RAM_WDATA_reg   (*((volatile unsigned int*) RAM_WDATA_reg))
+#define RAM_WDATA_inst_adr                                                           "0x009F"
+#define RAM_WDATA_inst                                                               0x009F
+#define RAM_WDATA_ram_wdata_shift                                                    (0)
+#define RAM_WDATA_ram_wdata_mask                                                     (0xFFFFFFFF)
+#define RAM_WDATA_ram_wdata(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define RAM_WDATA_ram_wdata_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define RAM_WDATA_get_ram_wdata(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define RAM_RDATA                                                                    0x18013280
+#define RAM_RDATA_reg_addr                                                           "0xB8013280"
+#define RAM_RDATA_reg                                                                0xB8013280
+#define set_RAM_RDATA_reg(data)   (*((volatile unsigned int*) RAM_RDATA_reg)=data)
+#define get_RAM_RDATA_reg   (*((volatile unsigned int*) RAM_RDATA_reg))
+#define RAM_RDATA_inst_adr                                                           "0x00A0"
+#define RAM_RDATA_inst                                                               0x00A0
+#define RAM_RDATA_ram_rdata_shift                                                    (0)
+#define RAM_RDATA_ram_rdata_mask                                                     (0xFFFFFFFF)
+#define RAM_RDATA_ram_rdata(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define RAM_RDATA_ram_rdata_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define RAM_RDATA_get_ram_rdata(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define PHY0_ST                                                                      0x18013284
+#define PHY0_ST_reg_addr                                                             "0xB8013284"
+#define PHY0_ST_reg                                                                  0xB8013284
+#define set_PHY0_ST_reg(data)   (*((volatile unsigned int*) PHY0_ST_reg)=data)
+#define get_PHY0_ST_reg   (*((volatile unsigned int*) PHY0_ST_reg))
+#define PHY0_ST_inst_adr                                                             "0x00A1"
+#define PHY0_ST_inst                                                                 0x00A1
+#define PHY0_ST_p0_count_num_shift                                                   (0)
+#define PHY0_ST_p0_count_num_mask                                                    (0x0007FFFF)
+#define PHY0_ST_p0_count_num(data)                                                   (0x0007FFFF&((data)<<0))
+#define PHY0_ST_p0_count_num_src(data)                                               ((0x0007FFFF&(data))>>0)
+#define PHY0_ST_get_p0_count_num(data)                                               ((0x0007FFFF&(data))>>0)
+
+
+#define USB3_OVR_CT                                                                  0x18013288
+#define USB3_OVR_CT_reg_addr                                                         "0xB8013288"
+#define USB3_OVR_CT_reg                                                              0xB8013288
+#define set_USB3_OVR_CT_reg(data)   (*((volatile unsigned int*) USB3_OVR_CT_reg)=data)
+#define get_USB3_OVR_CT_reg   (*((volatile unsigned int*) USB3_OVR_CT_reg))
+#define USB3_OVR_CT_inst_adr                                                         "0x00A2"
+#define USB3_OVR_CT_inst                                                             0x00A2
+#define USB3_OVR_CT_phy3_hperiod_shift                                               (7)
+#define USB3_OVR_CT_phy3_hperiod_mask                                                (0x00000380)
+#define USB3_OVR_CT_phy3_hperiod(data)                                               (0x00000380&((data)<<7))
+#define USB3_OVR_CT_phy3_hperiod_src(data)                                           ((0x00000380&(data))>>7)
+#define USB3_OVR_CT_get_phy3_hperiod(data)                                           ((0x00000380&(data))>>7)
+#define USB3_OVR_CT_phy3_lperiod_shift                                               (4)
+#define USB3_OVR_CT_phy3_lperiod_mask                                                (0x00000070)
+#define USB3_OVR_CT_phy3_lperiod(data)                                               (0x00000070&((data)<<4))
+#define USB3_OVR_CT_phy3_lperiod_src(data)                                           ((0x00000070&(data))>>4)
+#define USB3_OVR_CT_get_phy3_lperiod(data)                                           ((0x00000070&(data))>>4)
+#define USB3_OVR_CT_phy3_last_shift                                                  (2)
+#define USB3_OVR_CT_phy3_last_mask                                                   (0x0000000C)
+#define USB3_OVR_CT_phy3_last(data)                                                  (0x0000000C&((data)<<2))
+#define USB3_OVR_CT_phy3_last_src(data)                                              ((0x0000000C&(data))>>2)
+#define USB3_OVR_CT_get_phy3_last(data)                                              ((0x0000000C&(data))>>2)
+#define USB3_OVR_CT_host_ovr_current_value_shift                                     (1)
+#define USB3_OVR_CT_host_ovr_current_value_mask                                      (0x00000002)
+#define USB3_OVR_CT_host_ovr_current_value(data)                                     (0x00000002&((data)<<1))
+#define USB3_OVR_CT_host_ovr_current_value_src(data)                                 ((0x00000002&(data))>>1)
+#define USB3_OVR_CT_get_host_ovr_current_value(data)                                 ((0x00000002&(data))>>1)
+#define USB3_OVR_CT_host_ovr_current_sel_shift                                       (0)
+#define USB3_OVR_CT_host_ovr_current_sel_mask                                        (0x00000001)
+#define USB3_OVR_CT_host_ovr_current_sel(data)                                       (0x00000001&((data)<<0))
+#define USB3_OVR_CT_host_ovr_current_sel_src(data)                                   ((0x00000001&(data))>>0)
+#define USB3_OVR_CT_get_host_ovr_current_sel(data)                                   ((0x00000001&(data))>>0)
+
+
+#define SOFT_RESET                                                                   0x18013300
+#define SOFT_RESET_reg_addr                                                          "0xB8013300"
+#define SOFT_RESET_reg                                                               0xB8013300
+#define set_SOFT_RESET_reg(data)   (*((volatile unsigned int*) SOFT_RESET_reg)=data)
+#define get_SOFT_RESET_reg   (*((volatile unsigned int*) SOFT_RESET_reg))
+#define SOFT_RESET_inst_adr                                                          "0x00C0"
+#define SOFT_RESET_inst                                                              0x00C0
+#define SOFT_RESET_rstn_usb2_phy1_shift                                              (2)
+#define SOFT_RESET_rstn_usb2_phy1_mask                                               (0x00000004)
+#define SOFT_RESET_rstn_usb2_phy1(data)                                              (0x00000004&((data)<<2))
+#define SOFT_RESET_rstn_usb2_phy1_src(data)                                          ((0x00000004&(data))>>2)
+#define SOFT_RESET_get_rstn_usb2_phy1(data)                                          ((0x00000004&(data))>>2)
+#define SOFT_RESET_rstn_usb2_phy0_shift                                              (1)
+#define SOFT_RESET_rstn_usb2_phy0_mask                                               (0x00000002)
+#define SOFT_RESET_rstn_usb2_phy0(data)                                              (0x00000002&((data)<<1))
+#define SOFT_RESET_rstn_usb2_phy0_src(data)                                          ((0x00000002&(data))>>1)
+#define SOFT_RESET_get_rstn_usb2_phy0(data)                                          ((0x00000002&(data))>>1)
+#define SOFT_RESET_rstn_usb2_shift                                                   (0)
+#define SOFT_RESET_rstn_usb2_mask                                                    (0x00000001)
+#define SOFT_RESET_rstn_usb2(data)                                                   (0x00000001&((data)<<0))
+#define SOFT_RESET_rstn_usb2_src(data)                                               ((0x00000001&(data))>>0)
+#define SOFT_RESET_get_rstn_usb2(data)                                               ((0x00000001&(data))>>0)
+
+
+#define GBL_USB_CT                                                                   0x18013304
+#define GBL_USB_CT_reg_addr                                                          "0xB8013304"
+#define GBL_USB_CT_reg                                                               0xB8013304
+#define set_GBL_USB_CT_reg(data)   (*((volatile unsigned int*) GBL_USB_CT_reg)=data)
+#define get_GBL_USB_CT_reg   (*((volatile unsigned int*) GBL_USB_CT_reg))
+#define GBL_USB_CT_inst_adr                                                          "0x00C1"
+#define GBL_USB_CT_inst                                                              0x00C1
+#define GBL_USB_CT_usb_mac_ctrl_shift                                                (0)
+#define GBL_USB_CT_usb_mac_ctrl_mask                                                 (0xFFFFFFFF)
+#define GBL_USB_CT_usb_mac_ctrl(data)                                                (0xFFFFFFFF&((data)<<0))
+#define GBL_USB_CT_usb_mac_ctrl_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define GBL_USB_CT_get_usb_mac_ctrl(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define GBL_USB_ARB                                                                  0x18013308
+#define GBL_USB_ARB_reg_addr                                                         "0xB8013308"
+#define GBL_USB_ARB_reg                                                              0xB8013308
+#define set_GBL_USB_ARB_reg(data)   (*((volatile unsigned int*) GBL_USB_ARB_reg)=data)
+#define get_GBL_USB_ARB_reg   (*((volatile unsigned int*) GBL_USB_ARB_reg))
+#define GBL_USB_ARB_inst_adr                                                         "0x00C2"
+#define GBL_USB_ARB_inst                                                             0x00C2
+#define GBL_USB_ARB_dbus_robin_enable_shift                                          (3)
+#define GBL_USB_ARB_dbus_robin_enable_mask                                           (0x00000008)
+#define GBL_USB_ARB_dbus_robin_enable(data)                                          (0x00000008&((data)<<3))
+#define GBL_USB_ARB_dbus_robin_enable_src(data)                                      ((0x00000008&(data))>>3)
+#define GBL_USB_ARB_get_dbus_robin_enable(data)                                      ((0x00000008&(data))>>3)
+#define GBL_USB_ARB_cmd_full_number_shift                                            (1)
+#define GBL_USB_ARB_cmd_full_number_mask                                             (0x00000006)
+#define GBL_USB_ARB_cmd_full_number(data)                                            (0x00000006&((data)<<1))
+#define GBL_USB_ARB_cmd_full_number_src(data)                                        ((0x00000006&(data))>>1)
+#define GBL_USB_ARB_get_cmd_full_number(data)                                        ((0x00000006&(data))>>1)
+#define GBL_USB_ARB_dbus_arb_priority_shift                                          (0)
+#define GBL_USB_ARB_dbus_arb_priority_mask                                           (0x00000001)
+#define GBL_USB_ARB_dbus_arb_priority(data)                                          (0x00000001&((data)<<0))
+#define GBL_USB_ARB_dbus_arb_priority_src(data)                                      ((0x00000001&(data))>>0)
+#define GBL_USB_ARB_get_dbus_arb_priority(data)                                      ((0x00000001&(data))>>0)
+
+
+#define USB_BIST_MODE                                                                0x18013310
+#define USB_BIST_MODE_reg_addr                                                       "0xB8013310"
+#define USB_BIST_MODE_reg                                                            0xB8013310
+#define set_USB_BIST_MODE_reg(data)   (*((volatile unsigned int*) USB_BIST_MODE_reg)=data)
+#define get_USB_BIST_MODE_reg   (*((volatile unsigned int*) USB_BIST_MODE_reg))
+#define USB_BIST_MODE_inst_adr                                                       "0x00C4"
+#define USB_BIST_MODE_inst                                                           0x00C4
+#define USB_BIST_MODE_usb2_bist_test_mode_shift                                      (1)
+#define USB_BIST_MODE_usb2_bist_test_mode_mask                                       (0x00000002)
+#define USB_BIST_MODE_usb2_bist_test_mode(data)                                      (0x00000002&((data)<<1))
+#define USB_BIST_MODE_usb2_bist_test_mode_src(data)                                  ((0x00000002&(data))>>1)
+#define USB_BIST_MODE_get_usb2_bist_test_mode(data)                                  ((0x00000002&(data))>>1)
+#define USB_BIST_MODE_write_data_shift                                               (0)
+#define USB_BIST_MODE_write_data_mask                                                (0x00000001)
+#define USB_BIST_MODE_write_data(data)                                               (0x00000001&((data)<<0))
+#define USB_BIST_MODE_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define USB_BIST_MODE_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define USB_BIST_EN                                                                  0x18013314
+#define USB_BIST_EN_reg_addr                                                         "0xB8013314"
+#define USB_BIST_EN_reg                                                              0xB8013314
+#define set_USB_BIST_EN_reg(data)   (*((volatile unsigned int*) USB_BIST_EN_reg)=data)
+#define get_USB_BIST_EN_reg   (*((volatile unsigned int*) USB_BIST_EN_reg))
+#define USB_BIST_EN_inst_adr                                                         "0x00C5"
+#define USB_BIST_EN_inst                                                             0x00C5
+#define USB_BIST_EN_usb2_bist_en_shift                                               (1)
+#define USB_BIST_EN_usb2_bist_en_mask                                                (0x00000002)
+#define USB_BIST_EN_usb2_bist_en(data)                                               (0x00000002&((data)<<1))
+#define USB_BIST_EN_usb2_bist_en_src(data)                                           ((0x00000002&(data))>>1)
+#define USB_BIST_EN_get_usb2_bist_en(data)                                           ((0x00000002&(data))>>1)
+#define USB_BIST_EN_write_data_shift                                                 (0)
+#define USB_BIST_EN_write_data_mask                                                  (0x00000001)
+#define USB_BIST_EN_write_data(data)                                                 (0x00000001&((data)<<0))
+#define USB_BIST_EN_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define USB_BIST_EN_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define USB_BIST_ST                                                                  0x18013318
+#define USB_BIST_ST_reg_addr                                                         "0xB8013318"
+#define USB_BIST_ST_reg                                                              0xB8013318
+#define set_USB_BIST_ST_reg(data)   (*((volatile unsigned int*) USB_BIST_ST_reg)=data)
+#define get_USB_BIST_ST_reg   (*((volatile unsigned int*) USB_BIST_ST_reg))
+#define USB_BIST_ST_inst_adr                                                         "0x00C6"
+#define USB_BIST_ST_inst                                                             0x00C6
+#define USB_BIST_ST_usb2_2_bist_fail0_shift                                          (3)
+#define USB_BIST_ST_usb2_2_bist_fail0_mask                                           (0x00000008)
+#define USB_BIST_ST_usb2_2_bist_fail0(data)                                          (0x00000008&((data)<<3))
+#define USB_BIST_ST_usb2_2_bist_fail0_src(data)                                      ((0x00000008&(data))>>3)
+#define USB_BIST_ST_get_usb2_2_bist_fail0(data)                                      ((0x00000008&(data))>>3)
+#define USB_BIST_ST_usb2_2_bist_done_shift                                           (2)
+#define USB_BIST_ST_usb2_2_bist_done_mask                                            (0x00000004)
+#define USB_BIST_ST_usb2_2_bist_done(data)                                           (0x00000004&((data)<<2))
+#define USB_BIST_ST_usb2_2_bist_done_src(data)                                       ((0x00000004&(data))>>2)
+#define USB_BIST_ST_get_usb2_2_bist_done(data)                                       ((0x00000004&(data))>>2)
+#define USB_BIST_ST_usb2_bist_fail0_shift                                            (1)
+#define USB_BIST_ST_usb2_bist_fail0_mask                                             (0x00000002)
+#define USB_BIST_ST_usb2_bist_fail0(data)                                            (0x00000002&((data)<<1))
+#define USB_BIST_ST_usb2_bist_fail0_src(data)                                        ((0x00000002&(data))>>1)
+#define USB_BIST_ST_get_usb2_bist_fail0(data)                                        ((0x00000002&(data))>>1)
+#define USB_BIST_ST_usb2_bist_done_shift                                             (0)
+#define USB_BIST_ST_usb2_bist_done_mask                                              (0x00000001)
+#define USB_BIST_ST_usb2_bist_done(data)                                             (0x00000001&((data)<<0))
+#define USB_BIST_ST_usb2_bist_done_src(data)                                         ((0x00000001&(data))>>0)
+#define USB_BIST_ST_get_usb2_bist_done(data)                                         ((0x00000001&(data))>>0)
+
+
+#define USB_DRF_START                                                                0x1801331c
+#define USB_DRF_START_reg_addr                                                       "0xB801331C"
+#define USB_DRF_START_reg                                                            0xB801331C
+#define set_USB_DRF_START_reg(data)   (*((volatile unsigned int*) USB_DRF_START_reg)=data)
+#define get_USB_DRF_START_reg   (*((volatile unsigned int*) USB_DRF_START_reg))
+#define USB_DRF_START_inst_adr                                                       "0x00C7"
+#define USB_DRF_START_inst                                                           0x00C7
+#define USB_DRF_START_usb2_2_drf_start_pause_shift                                   (1)
+#define USB_DRF_START_usb2_2_drf_start_pause_mask                                    (0x00000002)
+#define USB_DRF_START_usb2_2_drf_start_pause(data)                                   (0x00000002&((data)<<1))
+#define USB_DRF_START_usb2_2_drf_start_pause_src(data)                               ((0x00000002&(data))>>1)
+#define USB_DRF_START_get_usb2_2_drf_start_pause(data)                               ((0x00000002&(data))>>1)
+#define USB_DRF_START_usb2_drf_start_pause_shift                                     (0)
+#define USB_DRF_START_usb2_drf_start_pause_mask                                      (0x00000001)
+#define USB_DRF_START_usb2_drf_start_pause(data)                                     (0x00000001&((data)<<0))
+#define USB_DRF_START_usb2_drf_start_pause_src(data)                                 ((0x00000001&(data))>>0)
+#define USB_DRF_START_get_usb2_drf_start_pause(data)                                 ((0x00000001&(data))>>0)
+
+
+#define USB_DRF_RESUME                                                               0x18013320
+#define USB_DRF_RESUME_reg_addr                                                      "0xB8013320"
+#define USB_DRF_RESUME_reg                                                           0xB8013320
+#define set_USB_DRF_RESUME_reg(data)   (*((volatile unsigned int*) USB_DRF_RESUME_reg)=data)
+#define get_USB_DRF_RESUME_reg   (*((volatile unsigned int*) USB_DRF_RESUME_reg))
+#define USB_DRF_RESUME_inst_adr                                                      "0x00C8"
+#define USB_DRF_RESUME_inst                                                          0x00C8
+#define USB_DRF_RESUME_usb2_2_drf_test_resume_shift                                  (2)
+#define USB_DRF_RESUME_usb2_2_drf_test_resume_mask                                   (0x00000004)
+#define USB_DRF_RESUME_usb2_2_drf_test_resume(data)                                  (0x00000004&((data)<<2))
+#define USB_DRF_RESUME_usb2_2_drf_test_resume_src(data)                              ((0x00000004&(data))>>2)
+#define USB_DRF_RESUME_get_usb2_2_drf_test_resume(data)                              ((0x00000004&(data))>>2)
+#define USB_DRF_RESUME_usb2_drf_test_resume_shift                                    (1)
+#define USB_DRF_RESUME_usb2_drf_test_resume_mask                                     (0x00000002)
+#define USB_DRF_RESUME_usb2_drf_test_resume(data)                                    (0x00000002&((data)<<1))
+#define USB_DRF_RESUME_usb2_drf_test_resume_src(data)                                ((0x00000002&(data))>>1)
+#define USB_DRF_RESUME_get_usb2_drf_test_resume(data)                                ((0x00000002&(data))>>1)
+#define USB_DRF_RESUME_write_data_shift                                              (0)
+#define USB_DRF_RESUME_write_data_mask                                               (0x00000001)
+#define USB_DRF_RESUME_write_data(data)                                              (0x00000001&((data)<<0))
+#define USB_DRF_RESUME_write_data_src(data)                                          ((0x00000001&(data))>>0)
+#define USB_DRF_RESUME_get_write_data(data)                                          ((0x00000001&(data))>>0)
+
+
+#define USB_DRF_EN                                                                   0x18013324
+#define USB_DRF_EN_reg_addr                                                          "0xB8013324"
+#define USB_DRF_EN_reg                                                               0xB8013324
+#define set_USB_DRF_EN_reg(data)   (*((volatile unsigned int*) USB_DRF_EN_reg)=data)
+#define get_USB_DRF_EN_reg   (*((volatile unsigned int*) USB_DRF_EN_reg))
+#define USB_DRF_EN_inst_adr                                                          "0x00C9"
+#define USB_DRF_EN_inst                                                              0x00C9
+#define USB_DRF_EN_usb2_drf_bist_en_shift                                            (1)
+#define USB_DRF_EN_usb2_drf_bist_en_mask                                             (0x00000002)
+#define USB_DRF_EN_usb2_drf_bist_en(data)                                            (0x00000002&((data)<<1))
+#define USB_DRF_EN_usb2_drf_bist_en_src(data)                                        ((0x00000002&(data))>>1)
+#define USB_DRF_EN_get_usb2_drf_bist_en(data)                                        ((0x00000002&(data))>>1)
+#define USB_DRF_EN_write_data_shift                                                  (0)
+#define USB_DRF_EN_write_data_mask                                                   (0x00000001)
+#define USB_DRF_EN_write_data(data)                                                  (0x00000001&((data)<<0))
+#define USB_DRF_EN_write_data_src(data)                                              ((0x00000001&(data))>>0)
+#define USB_DRF_EN_get_write_data(data)                                              ((0x00000001&(data))>>0)
+
+
+#define USB_DRF_ST                                                                   0x18013328
+#define USB_DRF_ST_reg_addr                                                          "0xB8013328"
+#define USB_DRF_ST_reg                                                               0xB8013328
+#define set_USB_DRF_ST_reg(data)   (*((volatile unsigned int*) USB_DRF_ST_reg)=data)
+#define get_USB_DRF_ST_reg   (*((volatile unsigned int*) USB_DRF_ST_reg))
+#define USB_DRF_ST_inst_adr                                                          "0x00CA"
+#define USB_DRF_ST_inst                                                              0x00CA
+#define USB_DRF_ST_usb2_2_drf_bist_fail0_shift                                       (3)
+#define USB_DRF_ST_usb2_2_drf_bist_fail0_mask                                        (0x00000008)
+#define USB_DRF_ST_usb2_2_drf_bist_fail0(data)                                       (0x00000008&((data)<<3))
+#define USB_DRF_ST_usb2_2_drf_bist_fail0_src(data)                                   ((0x00000008&(data))>>3)
+#define USB_DRF_ST_get_usb2_2_drf_bist_fail0(data)                                   ((0x00000008&(data))>>3)
+#define USB_DRF_ST_usb2_2_drf_bist_done_shift                                        (2)
+#define USB_DRF_ST_usb2_2_drf_bist_done_mask                                         (0x00000004)
+#define USB_DRF_ST_usb2_2_drf_bist_done(data)                                        (0x00000004&((data)<<2))
+#define USB_DRF_ST_usb2_2_drf_bist_done_src(data)                                    ((0x00000004&(data))>>2)
+#define USB_DRF_ST_get_usb2_2_drf_bist_done(data)                                    ((0x00000004&(data))>>2)
+#define USB_DRF_ST_usb2_drf_bist_fail0_shift                                         (1)
+#define USB_DRF_ST_usb2_drf_bist_fail0_mask                                          (0x00000002)
+#define USB_DRF_ST_usb2_drf_bist_fail0(data)                                         (0x00000002&((data)<<1))
+#define USB_DRF_ST_usb2_drf_bist_fail0_src(data)                                     ((0x00000002&(data))>>1)
+#define USB_DRF_ST_get_usb2_drf_bist_fail0(data)                                     ((0x00000002&(data))>>1)
+#define USB_DRF_ST_usb2_drf_bist_done_shift                                          (0)
+#define USB_DRF_ST_usb2_drf_bist_done_mask                                           (0x00000001)
+#define USB_DRF_ST_usb2_drf_bist_done(data)                                          (0x00000001&((data)<<0))
+#define USB_DRF_ST_usb2_drf_bist_done_src(data)                                      ((0x00000001&(data))>>0)
+#define USB_DRF_ST_get_usb2_drf_bist_done(data)                                      ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/vde_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/vde_reg.h
new file mode 100644
index 00000000..c8cf21e
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/vde_reg.h
@@ -0,0 +1,799 @@
+/**************************************************************
+// Spec Version                  : 1.0
+// Parser Version                : DVR_Parser_6.8(110516)
+// CModelGen Version             : 5.0 2009.04.09
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2011/9/8 15:10:45
+***************************************************************/
+
+
+#ifndef _VC_REG_H_INCLUDED_
+#define _VC_REG_H_INCLUDED_
+#ifdef  _VC_USE_STRUCT
+typedef struct 
+{
+unsigned int     src:29;
+unsigned int     reserved_0:3;
+}VC_DMA_SRC;
+
+typedef struct 
+{
+unsigned int     dst:29;
+unsigned int     reserved_0:3;
+}VC_DMA_DST;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     valid:1;
+unsigned int     dir:1;
+unsigned int     size:11;
+unsigned int     reserved_1:2;
+unsigned int     dma_type:1;
+}VC_DMA_SIZE;
+
+typedef struct 
+{
+unsigned int     blk_h:6;
+unsigned int     blk_w:4;
+unsigned int     blk_y:12;
+unsigned int     blk_x:10;
+}VC_DMA_BLK;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     field_mode:1;
+unsigned int     pic_index:7;
+unsigned int     chroma:1;
+unsigned int     row_offset:5;
+unsigned int     chroma_pitch:11;
+}VC_DMA_BLKINFO;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     max_xfer:6;
+unsigned int     reserved_1:5;
+unsigned int     write_enable3:1;
+unsigned int     dmem_req_en:1;
+unsigned int     write_enable4:1;
+unsigned int     stop:1;
+unsigned int     write_enable5:1;
+unsigned int     go:1;
+}VC_DMA_CNTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     int_done:1;
+}VC_DMA_INT;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     int_done_en:1;
+}VC_DMA_INT_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     done_7:1;
+unsigned int     done_6:1;
+unsigned int     done_5:1;
+unsigned int     done_4:1;
+unsigned int     done_3:1;
+unsigned int     done_2:1;
+unsigned int     done_1:1;
+unsigned int     done_0:1;
+}VC_DMA_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_enable3:1;
+unsigned int     sel1:4;
+unsigned int     write_enable2:1;
+unsigned int     sel0:4;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}VC_DMA_DEBUG;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     write_enable1:1;
+unsigned int     delay_timer:5;
+}VC_DMA_TIMER;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     RMEA:1;
+unsigned int     RMA_3:1;
+unsigned int     RMA_2:1;
+unsigned int     RMA_1:1;
+unsigned int     RMA_0:1;
+unsigned int     reserved_1:3;
+unsigned int     RMEB:1;
+unsigned int     RMB_3:1;
+unsigned int     RMB_2:1;
+unsigned int     RMB_1:1;
+unsigned int     RMB_0:1;
+}VC_DMA_BIST_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     bist_fail0:1;
+unsigned int     bist_done:1;
+}VC_DMA_BIST_ST;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     drf_start_pause:1;
+unsigned int     reserved_1:14;
+unsigned int     drf_fail0:1;
+unsigned int     drf_done:1;
+}VC_DMA_DRF_ST;
+
+#endif
+
+#define VC_DMA_SRC_0                                                                 0x18001000
+#define VC_DMA_SRC_1                                                                 0x18001004
+#define VC_DMA_SRC_2                                                                 0x18001008
+#define VC_DMA_SRC_3                                                                 0x1800100C
+#define VC_DMA_SRC_4                                                                 0x18001010
+#define VC_DMA_SRC_5                                                                 0x18001014
+#define VC_DMA_SRC_6                                                                 0x18001018
+#define VC_DMA_SRC_7                                                                 0x1800101C
+#define VC_DMA_SRC_0_reg_addr                                                        "0xB8001000"
+#define VC_DMA_SRC_1_reg_addr                                                        "0xB8001004"
+#define VC_DMA_SRC_2_reg_addr                                                        "0xB8001008"
+#define VC_DMA_SRC_3_reg_addr                                                        "0xB800100C"
+#define VC_DMA_SRC_4_reg_addr                                                        "0xB8001010"
+#define VC_DMA_SRC_5_reg_addr                                                        "0xB8001014"
+#define VC_DMA_SRC_6_reg_addr                                                        "0xB8001018"
+#define VC_DMA_SRC_7_reg_addr                                                        "0xB800101C"
+#define VC_DMA_SRC_0_reg                                                             0xB8001000
+#define VC_DMA_SRC_1_reg                                                             0xB8001004
+#define VC_DMA_SRC_2_reg                                                             0xB8001008
+#define VC_DMA_SRC_3_reg                                                             0xB800100C
+#define VC_DMA_SRC_4_reg                                                             0xB8001010
+#define VC_DMA_SRC_5_reg                                                             0xB8001014
+#define VC_DMA_SRC_6_reg                                                             0xB8001018
+#define VC_DMA_SRC_7_reg                                                             0xB800101C
+#define set_VC_DMA_SRC_0_reg(data)   (*((volatile unsigned int*) VC_DMA_SRC_0_reg)=data)
+#define set_VC_DMA_SRC_1_reg(data)   (*((volatile unsigned int*) VC_DMA_SRC_1_reg)=data)
+#define set_VC_DMA_SRC_2_reg(data)   (*((volatile unsigned int*) VC_DMA_SRC_2_reg)=data)
+#define set_VC_DMA_SRC_3_reg(data)   (*((volatile unsigned int*) VC_DMA_SRC_3_reg)=data)
+#define set_VC_DMA_SRC_4_reg(data)   (*((volatile unsigned int*) VC_DMA_SRC_4_reg)=data)
+#define set_VC_DMA_SRC_5_reg(data)   (*((volatile unsigned int*) VC_DMA_SRC_5_reg)=data)
+#define set_VC_DMA_SRC_6_reg(data)   (*((volatile unsigned int*) VC_DMA_SRC_6_reg)=data)
+#define set_VC_DMA_SRC_7_reg(data)   (*((volatile unsigned int*) VC_DMA_SRC_7_reg)=data)
+#define get_VC_DMA_SRC_0_reg   (*((volatile unsigned int*) VC_DMA_SRC_0_reg))
+#define get_VC_DMA_SRC_1_reg   (*((volatile unsigned int*) VC_DMA_SRC_1_reg))
+#define get_VC_DMA_SRC_2_reg   (*((volatile unsigned int*) VC_DMA_SRC_2_reg))
+#define get_VC_DMA_SRC_3_reg   (*((volatile unsigned int*) VC_DMA_SRC_3_reg))
+#define get_VC_DMA_SRC_4_reg   (*((volatile unsigned int*) VC_DMA_SRC_4_reg))
+#define get_VC_DMA_SRC_5_reg   (*((volatile unsigned int*) VC_DMA_SRC_5_reg))
+#define get_VC_DMA_SRC_6_reg   (*((volatile unsigned int*) VC_DMA_SRC_6_reg))
+#define get_VC_DMA_SRC_7_reg   (*((volatile unsigned int*) VC_DMA_SRC_7_reg))
+#define VC_DMA_SRC_0_inst_adr                                                        "0x0000"
+#define VC_DMA_SRC_1_inst_adr                                                        "0x0001"
+#define VC_DMA_SRC_2_inst_adr                                                        "0x0002"
+#define VC_DMA_SRC_3_inst_adr                                                        "0x0003"
+#define VC_DMA_SRC_4_inst_adr                                                        "0x0004"
+#define VC_DMA_SRC_5_inst_adr                                                        "0x0005"
+#define VC_DMA_SRC_6_inst_adr                                                        "0x0006"
+#define VC_DMA_SRC_7_inst_adr                                                        "0x0007"
+#define VC_DMA_SRC_0_inst                                                            0x0000
+#define VC_DMA_SRC_1_inst                                                            0x0001
+#define VC_DMA_SRC_2_inst                                                            0x0002
+#define VC_DMA_SRC_3_inst                                                            0x0003
+#define VC_DMA_SRC_4_inst                                                            0x0004
+#define VC_DMA_SRC_5_inst                                                            0x0005
+#define VC_DMA_SRC_6_inst                                                            0x0006
+#define VC_DMA_SRC_7_inst                                                            0x0007
+#define VC_DMA_SRC_src_shift                                                         (3)
+#define VC_DMA_SRC_src_mask                                                          (0xFFFFFFF8)
+#define VC_DMA_SRC_src(data)                                                         (0xFFFFFFF8&((data)<<3))
+#define VC_DMA_SRC_src_src(data)                                                     ((0xFFFFFFF8&(data))>>3)
+#define VC_DMA_SRC_get_src(data)                                                     ((0xFFFFFFF8&(data))>>3)
+
+
+#define VC_DMA_DST_0                                                                 0x18001020
+#define VC_DMA_DST_1                                                                 0x18001024
+#define VC_DMA_DST_2                                                                 0x18001028
+#define VC_DMA_DST_3                                                                 0x1800102C
+#define VC_DMA_DST_4                                                                 0x18001030
+#define VC_DMA_DST_5                                                                 0x18001034
+#define VC_DMA_DST_6                                                                 0x18001038
+#define VC_DMA_DST_7                                                                 0x1800103C
+#define VC_DMA_DST_0_reg_addr                                                        "0xB8001020"
+#define VC_DMA_DST_1_reg_addr                                                        "0xB8001024"
+#define VC_DMA_DST_2_reg_addr                                                        "0xB8001028"
+#define VC_DMA_DST_3_reg_addr                                                        "0xB800102C"
+#define VC_DMA_DST_4_reg_addr                                                        "0xB8001030"
+#define VC_DMA_DST_5_reg_addr                                                        "0xB8001034"
+#define VC_DMA_DST_6_reg_addr                                                        "0xB8001038"
+#define VC_DMA_DST_7_reg_addr                                                        "0xB800103C"
+#define VC_DMA_DST_0_reg                                                             0xB8001020
+#define VC_DMA_DST_1_reg                                                             0xB8001024
+#define VC_DMA_DST_2_reg                                                             0xB8001028
+#define VC_DMA_DST_3_reg                                                             0xB800102C
+#define VC_DMA_DST_4_reg                                                             0xB8001030
+#define VC_DMA_DST_5_reg                                                             0xB8001034
+#define VC_DMA_DST_6_reg                                                             0xB8001038
+#define VC_DMA_DST_7_reg                                                             0xB800103C
+#define set_VC_DMA_DST_0_reg(data)   (*((volatile unsigned int*) VC_DMA_DST_0_reg)=data)
+#define set_VC_DMA_DST_1_reg(data)   (*((volatile unsigned int*) VC_DMA_DST_1_reg)=data)
+#define set_VC_DMA_DST_2_reg(data)   (*((volatile unsigned int*) VC_DMA_DST_2_reg)=data)
+#define set_VC_DMA_DST_3_reg(data)   (*((volatile unsigned int*) VC_DMA_DST_3_reg)=data)
+#define set_VC_DMA_DST_4_reg(data)   (*((volatile unsigned int*) VC_DMA_DST_4_reg)=data)
+#define set_VC_DMA_DST_5_reg(data)   (*((volatile unsigned int*) VC_DMA_DST_5_reg)=data)
+#define set_VC_DMA_DST_6_reg(data)   (*((volatile unsigned int*) VC_DMA_DST_6_reg)=data)
+#define set_VC_DMA_DST_7_reg(data)   (*((volatile unsigned int*) VC_DMA_DST_7_reg)=data)
+#define get_VC_DMA_DST_0_reg   (*((volatile unsigned int*) VC_DMA_DST_0_reg))
+#define get_VC_DMA_DST_1_reg   (*((volatile unsigned int*) VC_DMA_DST_1_reg))
+#define get_VC_DMA_DST_2_reg   (*((volatile unsigned int*) VC_DMA_DST_2_reg))
+#define get_VC_DMA_DST_3_reg   (*((volatile unsigned int*) VC_DMA_DST_3_reg))
+#define get_VC_DMA_DST_4_reg   (*((volatile unsigned int*) VC_DMA_DST_4_reg))
+#define get_VC_DMA_DST_5_reg   (*((volatile unsigned int*) VC_DMA_DST_5_reg))
+#define get_VC_DMA_DST_6_reg   (*((volatile unsigned int*) VC_DMA_DST_6_reg))
+#define get_VC_DMA_DST_7_reg   (*((volatile unsigned int*) VC_DMA_DST_7_reg))
+#define VC_DMA_DST_0_inst_adr                                                        "0x0008"
+#define VC_DMA_DST_1_inst_adr                                                        "0x0009"
+#define VC_DMA_DST_2_inst_adr                                                        "0x000A"
+#define VC_DMA_DST_3_inst_adr                                                        "0x000B"
+#define VC_DMA_DST_4_inst_adr                                                        "0x000C"
+#define VC_DMA_DST_5_inst_adr                                                        "0x000D"
+#define VC_DMA_DST_6_inst_adr                                                        "0x000E"
+#define VC_DMA_DST_7_inst_adr                                                        "0x000F"
+#define VC_DMA_DST_0_inst                                                            0x0008
+#define VC_DMA_DST_1_inst                                                            0x0009
+#define VC_DMA_DST_2_inst                                                            0x000A
+#define VC_DMA_DST_3_inst                                                            0x000B
+#define VC_DMA_DST_4_inst                                                            0x000C
+#define VC_DMA_DST_5_inst                                                            0x000D
+#define VC_DMA_DST_6_inst                                                            0x000E
+#define VC_DMA_DST_7_inst                                                            0x000F
+#define VC_DMA_DST_dst_shift                                                         (3)
+#define VC_DMA_DST_dst_mask                                                          (0xFFFFFFF8)
+#define VC_DMA_DST_dst(data)                                                         (0xFFFFFFF8&((data)<<3))
+#define VC_DMA_DST_dst_src(data)                                                     ((0xFFFFFFF8&(data))>>3)
+#define VC_DMA_DST_get_dst(data)                                                     ((0xFFFFFFF8&(data))>>3)
+
+
+#define VC_DMA_SIZE_0                                                                0x18001040
+#define VC_DMA_SIZE_1                                                                0x18001044
+#define VC_DMA_SIZE_2                                                                0x18001048
+#define VC_DMA_SIZE_3                                                                0x1800104C
+#define VC_DMA_SIZE_4                                                                0x18001050
+#define VC_DMA_SIZE_5                                                                0x18001054
+#define VC_DMA_SIZE_6                                                                0x18001058
+#define VC_DMA_SIZE_7                                                                0x1800105C
+#define VC_DMA_SIZE_0_reg_addr                                                       "0xB8001040"
+#define VC_DMA_SIZE_1_reg_addr                                                       "0xB8001044"
+#define VC_DMA_SIZE_2_reg_addr                                                       "0xB8001048"
+#define VC_DMA_SIZE_3_reg_addr                                                       "0xB800104C"
+#define VC_DMA_SIZE_4_reg_addr                                                       "0xB8001050"
+#define VC_DMA_SIZE_5_reg_addr                                                       "0xB8001054"
+#define VC_DMA_SIZE_6_reg_addr                                                       "0xB8001058"
+#define VC_DMA_SIZE_7_reg_addr                                                       "0xB800105C"
+#define VC_DMA_SIZE_0_reg                                                            0xB8001040
+#define VC_DMA_SIZE_1_reg                                                            0xB8001044
+#define VC_DMA_SIZE_2_reg                                                            0xB8001048
+#define VC_DMA_SIZE_3_reg                                                            0xB800104C
+#define VC_DMA_SIZE_4_reg                                                            0xB8001050
+#define VC_DMA_SIZE_5_reg                                                            0xB8001054
+#define VC_DMA_SIZE_6_reg                                                            0xB8001058
+#define VC_DMA_SIZE_7_reg                                                            0xB800105C
+#define set_VC_DMA_SIZE_0_reg(data)   (*((volatile unsigned int*) VC_DMA_SIZE_0_reg)=data)
+#define set_VC_DMA_SIZE_1_reg(data)   (*((volatile unsigned int*) VC_DMA_SIZE_1_reg)=data)
+#define set_VC_DMA_SIZE_2_reg(data)   (*((volatile unsigned int*) VC_DMA_SIZE_2_reg)=data)
+#define set_VC_DMA_SIZE_3_reg(data)   (*((volatile unsigned int*) VC_DMA_SIZE_3_reg)=data)
+#define set_VC_DMA_SIZE_4_reg(data)   (*((volatile unsigned int*) VC_DMA_SIZE_4_reg)=data)
+#define set_VC_DMA_SIZE_5_reg(data)   (*((volatile unsigned int*) VC_DMA_SIZE_5_reg)=data)
+#define set_VC_DMA_SIZE_6_reg(data)   (*((volatile unsigned int*) VC_DMA_SIZE_6_reg)=data)
+#define set_VC_DMA_SIZE_7_reg(data)   (*((volatile unsigned int*) VC_DMA_SIZE_7_reg)=data)
+#define get_VC_DMA_SIZE_0_reg   (*((volatile unsigned int*) VC_DMA_SIZE_0_reg))
+#define get_VC_DMA_SIZE_1_reg   (*((volatile unsigned int*) VC_DMA_SIZE_1_reg))
+#define get_VC_DMA_SIZE_2_reg   (*((volatile unsigned int*) VC_DMA_SIZE_2_reg))
+#define get_VC_DMA_SIZE_3_reg   (*((volatile unsigned int*) VC_DMA_SIZE_3_reg))
+#define get_VC_DMA_SIZE_4_reg   (*((volatile unsigned int*) VC_DMA_SIZE_4_reg))
+#define get_VC_DMA_SIZE_5_reg   (*((volatile unsigned int*) VC_DMA_SIZE_5_reg))
+#define get_VC_DMA_SIZE_6_reg   (*((volatile unsigned int*) VC_DMA_SIZE_6_reg))
+#define get_VC_DMA_SIZE_7_reg   (*((volatile unsigned int*) VC_DMA_SIZE_7_reg))
+#define VC_DMA_SIZE_0_inst_adr                                                       "0x0010"
+#define VC_DMA_SIZE_1_inst_adr                                                       "0x0011"
+#define VC_DMA_SIZE_2_inst_adr                                                       "0x0012"
+#define VC_DMA_SIZE_3_inst_adr                                                       "0x0013"
+#define VC_DMA_SIZE_4_inst_adr                                                       "0x0014"
+#define VC_DMA_SIZE_5_inst_adr                                                       "0x0015"
+#define VC_DMA_SIZE_6_inst_adr                                                       "0x0016"
+#define VC_DMA_SIZE_7_inst_adr                                                       "0x0017"
+#define VC_DMA_SIZE_0_inst                                                           0x0010
+#define VC_DMA_SIZE_1_inst                                                           0x0011
+#define VC_DMA_SIZE_2_inst                                                           0x0012
+#define VC_DMA_SIZE_3_inst                                                           0x0013
+#define VC_DMA_SIZE_4_inst                                                           0x0014
+#define VC_DMA_SIZE_5_inst                                                           0x0015
+#define VC_DMA_SIZE_6_inst                                                           0x0016
+#define VC_DMA_SIZE_7_inst                                                           0x0017
+#define VC_DMA_SIZE_valid_shift                                                      (15)
+#define VC_DMA_SIZE_valid_mask                                                       (0x00008000)
+#define VC_DMA_SIZE_valid(data)                                                      (0x00008000&((data)<<15))
+#define VC_DMA_SIZE_valid_src(data)                                                  ((0x00008000&(data))>>15)
+#define VC_DMA_SIZE_get_valid(data)                                                  ((0x00008000&(data))>>15)
+#define VC_DMA_SIZE_dir_shift                                                        (14)
+#define VC_DMA_SIZE_dir_mask                                                         (0x00004000)
+#define VC_DMA_SIZE_dir(data)                                                        (0x00004000&((data)<<14))
+#define VC_DMA_SIZE_dir_src(data)                                                    ((0x00004000&(data))>>14)
+#define VC_DMA_SIZE_get_dir(data)                                                    ((0x00004000&(data))>>14)
+#define VC_DMA_SIZE_size_shift                                                       (3)
+#define VC_DMA_SIZE_size_mask                                                        (0x00003FF8)
+#define VC_DMA_SIZE_size(data)                                                       (0x00003FF8&((data)<<3))
+#define VC_DMA_SIZE_size_src(data)                                                   ((0x00003FF8&(data))>>3)
+#define VC_DMA_SIZE_get_size(data)                                                   ((0x00003FF8&(data))>>3)
+#define VC_DMA_SIZE_dma_type_shift                                                   (0)
+#define VC_DMA_SIZE_dma_type_mask                                                    (0x00000001)
+#define VC_DMA_SIZE_dma_type(data)                                                   (0x00000001&((data)<<0))
+#define VC_DMA_SIZE_dma_type_src(data)                                               ((0x00000001&(data))>>0)
+#define VC_DMA_SIZE_get_dma_type(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VC_DMA_BLK_0                                                                 0x18001090
+#define VC_DMA_BLK_1                                                                 0x18001094
+#define VC_DMA_BLK_2                                                                 0x18001098
+#define VC_DMA_BLK_3                                                                 0x1800109C
+#define VC_DMA_BLK_4                                                                 0x180010A0
+#define VC_DMA_BLK_5                                                                 0x180010A4
+#define VC_DMA_BLK_6                                                                 0x180010A8
+#define VC_DMA_BLK_7                                                                 0x180010AC
+#define VC_DMA_BLK_0_reg_addr                                                        "0xB8001090"
+#define VC_DMA_BLK_1_reg_addr                                                        "0xB8001094"
+#define VC_DMA_BLK_2_reg_addr                                                        "0xB8001098"
+#define VC_DMA_BLK_3_reg_addr                                                        "0xB800109C"
+#define VC_DMA_BLK_4_reg_addr                                                        "0xB80010A0"
+#define VC_DMA_BLK_5_reg_addr                                                        "0xB80010A4"
+#define VC_DMA_BLK_6_reg_addr                                                        "0xB80010A8"
+#define VC_DMA_BLK_7_reg_addr                                                        "0xB80010AC"
+#define VC_DMA_BLK_0_reg                                                             0xB8001090
+#define VC_DMA_BLK_1_reg                                                             0xB8001094
+#define VC_DMA_BLK_2_reg                                                             0xB8001098
+#define VC_DMA_BLK_3_reg                                                             0xB800109C
+#define VC_DMA_BLK_4_reg                                                             0xB80010A0
+#define VC_DMA_BLK_5_reg                                                             0xB80010A4
+#define VC_DMA_BLK_6_reg                                                             0xB80010A8
+#define VC_DMA_BLK_7_reg                                                             0xB80010AC
+#define set_VC_DMA_BLK_0_reg(data)   (*((volatile unsigned int*) VC_DMA_BLK_0_reg)=data)
+#define set_VC_DMA_BLK_1_reg(data)   (*((volatile unsigned int*) VC_DMA_BLK_1_reg)=data)
+#define set_VC_DMA_BLK_2_reg(data)   (*((volatile unsigned int*) VC_DMA_BLK_2_reg)=data)
+#define set_VC_DMA_BLK_3_reg(data)   (*((volatile unsigned int*) VC_DMA_BLK_3_reg)=data)
+#define set_VC_DMA_BLK_4_reg(data)   (*((volatile unsigned int*) VC_DMA_BLK_4_reg)=data)
+#define set_VC_DMA_BLK_5_reg(data)   (*((volatile unsigned int*) VC_DMA_BLK_5_reg)=data)
+#define set_VC_DMA_BLK_6_reg(data)   (*((volatile unsigned int*) VC_DMA_BLK_6_reg)=data)
+#define set_VC_DMA_BLK_7_reg(data)   (*((volatile unsigned int*) VC_DMA_BLK_7_reg)=data)
+#define get_VC_DMA_BLK_0_reg   (*((volatile unsigned int*) VC_DMA_BLK_0_reg))
+#define get_VC_DMA_BLK_1_reg   (*((volatile unsigned int*) VC_DMA_BLK_1_reg))
+#define get_VC_DMA_BLK_2_reg   (*((volatile unsigned int*) VC_DMA_BLK_2_reg))
+#define get_VC_DMA_BLK_3_reg   (*((volatile unsigned int*) VC_DMA_BLK_3_reg))
+#define get_VC_DMA_BLK_4_reg   (*((volatile unsigned int*) VC_DMA_BLK_4_reg))
+#define get_VC_DMA_BLK_5_reg   (*((volatile unsigned int*) VC_DMA_BLK_5_reg))
+#define get_VC_DMA_BLK_6_reg   (*((volatile unsigned int*) VC_DMA_BLK_6_reg))
+#define get_VC_DMA_BLK_7_reg   (*((volatile unsigned int*) VC_DMA_BLK_7_reg))
+#define VC_DMA_BLK_0_inst_adr                                                        "0x0024"
+#define VC_DMA_BLK_1_inst_adr                                                        "0x0025"
+#define VC_DMA_BLK_2_inst_adr                                                        "0x0026"
+#define VC_DMA_BLK_3_inst_adr                                                        "0x0027"
+#define VC_DMA_BLK_4_inst_adr                                                        "0x0028"
+#define VC_DMA_BLK_5_inst_adr                                                        "0x0029"
+#define VC_DMA_BLK_6_inst_adr                                                        "0x002A"
+#define VC_DMA_BLK_7_inst_adr                                                        "0x002B"
+#define VC_DMA_BLK_0_inst                                                            0x0024
+#define VC_DMA_BLK_1_inst                                                            0x0025
+#define VC_DMA_BLK_2_inst                                                            0x0026
+#define VC_DMA_BLK_3_inst                                                            0x0027
+#define VC_DMA_BLK_4_inst                                                            0x0028
+#define VC_DMA_BLK_5_inst                                                            0x0029
+#define VC_DMA_BLK_6_inst                                                            0x002A
+#define VC_DMA_BLK_7_inst                                                            0x002B
+#define VC_DMA_BLK_blk_h_shift                                                       (26)
+#define VC_DMA_BLK_blk_h_mask                                                        (0xFC000000)
+#define VC_DMA_BLK_blk_h(data)                                                       (0xFC000000&((data)<<26))
+#define VC_DMA_BLK_blk_h_src(data)                                                   ((0xFC000000&(data))>>26)
+#define VC_DMA_BLK_get_blk_h(data)                                                   ((0xFC000000&(data))>>26)
+#define VC_DMA_BLK_blk_w_shift                                                       (22)
+#define VC_DMA_BLK_blk_w_mask                                                        (0x03C00000)
+#define VC_DMA_BLK_blk_w(data)                                                       (0x03C00000&((data)<<22))
+#define VC_DMA_BLK_blk_w_src(data)                                                   ((0x03C00000&(data))>>22)
+#define VC_DMA_BLK_get_blk_w(data)                                                   ((0x03C00000&(data))>>22)
+#define VC_DMA_BLK_blk_y_shift                                                       (10)
+#define VC_DMA_BLK_blk_y_mask                                                        (0x003FFC00)
+#define VC_DMA_BLK_blk_y(data)                                                       (0x003FFC00&((data)<<10))
+#define VC_DMA_BLK_blk_y_src(data)                                                   ((0x003FFC00&(data))>>10)
+#define VC_DMA_BLK_get_blk_y(data)                                                   ((0x003FFC00&(data))>>10)
+#define VC_DMA_BLK_blk_x_shift                                                       (0)
+#define VC_DMA_BLK_blk_x_mask                                                        (0x000003FF)
+#define VC_DMA_BLK_blk_x(data)                                                       (0x000003FF&((data)<<0))
+#define VC_DMA_BLK_blk_x_src(data)                                                   ((0x000003FF&(data))>>0)
+#define VC_DMA_BLK_get_blk_x(data)                                                   ((0x000003FF&(data))>>0)
+
+
+#define VC_DMA_BLKINFO_0                                                             0x180010B0
+#define VC_DMA_BLKINFO_1                                                             0x180010B4
+#define VC_DMA_BLKINFO_2                                                             0x180010B8
+#define VC_DMA_BLKINFO_3                                                             0x180010BC
+#define VC_DMA_BLKINFO_4                                                             0x180010C0
+#define VC_DMA_BLKINFO_5                                                             0x180010C4
+#define VC_DMA_BLKINFO_6                                                             0x180010C8
+#define VC_DMA_BLKINFO_7                                                             0x180010CC
+#define VC_DMA_BLKINFO_0_reg_addr                                                    "0xB80010B0"
+#define VC_DMA_BLKINFO_1_reg_addr                                                    "0xB80010B4"
+#define VC_DMA_BLKINFO_2_reg_addr                                                    "0xB80010B8"
+#define VC_DMA_BLKINFO_3_reg_addr                                                    "0xB80010BC"
+#define VC_DMA_BLKINFO_4_reg_addr                                                    "0xB80010C0"
+#define VC_DMA_BLKINFO_5_reg_addr                                                    "0xB80010C4"
+#define VC_DMA_BLKINFO_6_reg_addr                                                    "0xB80010C8"
+#define VC_DMA_BLKINFO_7_reg_addr                                                    "0xB80010CC"
+#define VC_DMA_BLKINFO_0_reg                                                         0xB80010B0
+#define VC_DMA_BLKINFO_1_reg                                                         0xB80010B4
+#define VC_DMA_BLKINFO_2_reg                                                         0xB80010B8
+#define VC_DMA_BLKINFO_3_reg                                                         0xB80010BC
+#define VC_DMA_BLKINFO_4_reg                                                         0xB80010C0
+#define VC_DMA_BLKINFO_5_reg                                                         0xB80010C4
+#define VC_DMA_BLKINFO_6_reg                                                         0xB80010C8
+#define VC_DMA_BLKINFO_7_reg                                                         0xB80010CC
+#define set_VC_DMA_BLKINFO_0_reg(data)   (*((volatile unsigned int*) VC_DMA_BLKINFO_0_reg)=data)
+#define set_VC_DMA_BLKINFO_1_reg(data)   (*((volatile unsigned int*) VC_DMA_BLKINFO_1_reg)=data)
+#define set_VC_DMA_BLKINFO_2_reg(data)   (*((volatile unsigned int*) VC_DMA_BLKINFO_2_reg)=data)
+#define set_VC_DMA_BLKINFO_3_reg(data)   (*((volatile unsigned int*) VC_DMA_BLKINFO_3_reg)=data)
+#define set_VC_DMA_BLKINFO_4_reg(data)   (*((volatile unsigned int*) VC_DMA_BLKINFO_4_reg)=data)
+#define set_VC_DMA_BLKINFO_5_reg(data)   (*((volatile unsigned int*) VC_DMA_BLKINFO_5_reg)=data)
+#define set_VC_DMA_BLKINFO_6_reg(data)   (*((volatile unsigned int*) VC_DMA_BLKINFO_6_reg)=data)
+#define set_VC_DMA_BLKINFO_7_reg(data)   (*((volatile unsigned int*) VC_DMA_BLKINFO_7_reg)=data)
+#define get_VC_DMA_BLKINFO_0_reg   (*((volatile unsigned int*) VC_DMA_BLKINFO_0_reg))
+#define get_VC_DMA_BLKINFO_1_reg   (*((volatile unsigned int*) VC_DMA_BLKINFO_1_reg))
+#define get_VC_DMA_BLKINFO_2_reg   (*((volatile unsigned int*) VC_DMA_BLKINFO_2_reg))
+#define get_VC_DMA_BLKINFO_3_reg   (*((volatile unsigned int*) VC_DMA_BLKINFO_3_reg))
+#define get_VC_DMA_BLKINFO_4_reg   (*((volatile unsigned int*) VC_DMA_BLKINFO_4_reg))
+#define get_VC_DMA_BLKINFO_5_reg   (*((volatile unsigned int*) VC_DMA_BLKINFO_5_reg))
+#define get_VC_DMA_BLKINFO_6_reg   (*((volatile unsigned int*) VC_DMA_BLKINFO_6_reg))
+#define get_VC_DMA_BLKINFO_7_reg   (*((volatile unsigned int*) VC_DMA_BLKINFO_7_reg))
+#define VC_DMA_BLKINFO_0_inst_adr                                                    "0x002C"
+#define VC_DMA_BLKINFO_1_inst_adr                                                    "0x002D"
+#define VC_DMA_BLKINFO_2_inst_adr                                                    "0x002E"
+#define VC_DMA_BLKINFO_3_inst_adr                                                    "0x002F"
+#define VC_DMA_BLKINFO_4_inst_adr                                                    "0x0030"
+#define VC_DMA_BLKINFO_5_inst_adr                                                    "0x0031"
+#define VC_DMA_BLKINFO_6_inst_adr                                                    "0x0032"
+#define VC_DMA_BLKINFO_7_inst_adr                                                    "0x0033"
+#define VC_DMA_BLKINFO_0_inst                                                        0x002C
+#define VC_DMA_BLKINFO_1_inst                                                        0x002D
+#define VC_DMA_BLKINFO_2_inst                                                        0x002E
+#define VC_DMA_BLKINFO_3_inst                                                        0x002F
+#define VC_DMA_BLKINFO_4_inst                                                        0x0030
+#define VC_DMA_BLKINFO_5_inst                                                        0x0031
+#define VC_DMA_BLKINFO_6_inst                                                        0x0032
+#define VC_DMA_BLKINFO_7_inst                                                        0x0033
+#define VC_DMA_BLKINFO_field_mode_shift                                              (24)
+#define VC_DMA_BLKINFO_field_mode_mask                                               (0x01000000)
+#define VC_DMA_BLKINFO_field_mode(data)                                              (0x01000000&((data)<<24))
+#define VC_DMA_BLKINFO_field_mode_src(data)                                          ((0x01000000&(data))>>24)
+#define VC_DMA_BLKINFO_get_field_mode(data)                                          ((0x01000000&(data))>>24)
+#define VC_DMA_BLKINFO_pic_index_shift                                               (17)
+#define VC_DMA_BLKINFO_pic_index_mask                                                (0x00FE0000)
+#define VC_DMA_BLKINFO_pic_index(data)                                               (0x00FE0000&((data)<<17))
+#define VC_DMA_BLKINFO_pic_index_src(data)                                           ((0x00FE0000&(data))>>17)
+#define VC_DMA_BLKINFO_get_pic_index(data)                                           ((0x00FE0000&(data))>>17)
+#define VC_DMA_BLKINFO_chroma_shift                                                  (16)
+#define VC_DMA_BLKINFO_chroma_mask                                                   (0x00010000)
+#define VC_DMA_BLKINFO_chroma(data)                                                  (0x00010000&((data)<<16))
+#define VC_DMA_BLKINFO_chroma_src(data)                                              ((0x00010000&(data))>>16)
+#define VC_DMA_BLKINFO_get_chroma(data)                                              ((0x00010000&(data))>>16)
+#define VC_DMA_BLKINFO_row_offset_shift                                              (11)
+#define VC_DMA_BLKINFO_row_offset_mask                                               (0x0000F800)
+#define VC_DMA_BLKINFO_row_offset(data)                                              (0x0000F800&((data)<<11))
+#define VC_DMA_BLKINFO_row_offset_src(data)                                          ((0x0000F800&(data))>>11)
+#define VC_DMA_BLKINFO_get_row_offset(data)                                          ((0x0000F800&(data))>>11)
+#define VC_DMA_BLKINFO_chroma_pitch_shift                                            (0)
+#define VC_DMA_BLKINFO_chroma_pitch_mask                                             (0x000007FF)
+#define VC_DMA_BLKINFO_chroma_pitch(data)                                            (0x000007FF&((data)<<0))
+#define VC_DMA_BLKINFO_chroma_pitch_src(data)                                        ((0x000007FF&(data))>>0)
+#define VC_DMA_BLKINFO_get_chroma_pitch(data)                                        ((0x000007FF&(data))>>0)
+
+
+#define VC_DMA_CNTL                                                                  0x18001064
+#define VC_DMA_CNTL_reg_addr                                                         "0xB8001064"
+#define VC_DMA_CNTL_reg                                                              0xB8001064
+#define set_VC_DMA_CNTL_reg(data)   (*((volatile unsigned int*) VC_DMA_CNTL_reg)=data)
+#define get_VC_DMA_CNTL_reg   (*((volatile unsigned int*) VC_DMA_CNTL_reg))
+#define VC_DMA_CNTL_inst_adr                                                         "0x0019"
+#define VC_DMA_CNTL_inst                                                             0x0019
+#define VC_DMA_CNTL_write_enable1_shift                                              (17)
+#define VC_DMA_CNTL_write_enable1_mask                                               (0x00020000)
+#define VC_DMA_CNTL_write_enable1(data)                                              (0x00020000&((data)<<17))
+#define VC_DMA_CNTL_write_enable1_src(data)                                          ((0x00020000&(data))>>17)
+#define VC_DMA_CNTL_get_write_enable1(data)                                          ((0x00020000&(data))>>17)
+#define VC_DMA_CNTL_max_xfer_shift                                                   (11)
+#define VC_DMA_CNTL_max_xfer_mask                                                    (0x0001F800)
+#define VC_DMA_CNTL_max_xfer(data)                                                   (0x0001F800&((data)<<11))
+#define VC_DMA_CNTL_max_xfer_src(data)                                               ((0x0001F800&(data))>>11)
+#define VC_DMA_CNTL_get_max_xfer(data)                                               ((0x0001F800&(data))>>11)
+#define VC_DMA_CNTL_write_enable3_shift                                              (5)
+#define VC_DMA_CNTL_write_enable3_mask                                               (0x00000020)
+#define VC_DMA_CNTL_write_enable3(data)                                              (0x00000020&((data)<<5))
+#define VC_DMA_CNTL_write_enable3_src(data)                                          ((0x00000020&(data))>>5)
+#define VC_DMA_CNTL_get_write_enable3(data)                                          ((0x00000020&(data))>>5)
+#define VC_DMA_CNTL_dmem_req_en_shift                                                (4)
+#define VC_DMA_CNTL_dmem_req_en_mask                                                 (0x00000010)
+#define VC_DMA_CNTL_dmem_req_en(data)                                                (0x00000010&((data)<<4))
+#define VC_DMA_CNTL_dmem_req_en_src(data)                                            ((0x00000010&(data))>>4)
+#define VC_DMA_CNTL_get_dmem_req_en(data)                                            ((0x00000010&(data))>>4)
+#define VC_DMA_CNTL_write_enable4_shift                                              (3)
+#define VC_DMA_CNTL_write_enable4_mask                                               (0x00000008)
+#define VC_DMA_CNTL_write_enable4(data)                                              (0x00000008&((data)<<3))
+#define VC_DMA_CNTL_write_enable4_src(data)                                          ((0x00000008&(data))>>3)
+#define VC_DMA_CNTL_get_write_enable4(data)                                          ((0x00000008&(data))>>3)
+#define VC_DMA_CNTL_stop_shift                                                       (2)
+#define VC_DMA_CNTL_stop_mask                                                        (0x00000004)
+#define VC_DMA_CNTL_stop(data)                                                       (0x00000004&((data)<<2))
+#define VC_DMA_CNTL_stop_src(data)                                                   ((0x00000004&(data))>>2)
+#define VC_DMA_CNTL_get_stop(data)                                                   ((0x00000004&(data))>>2)
+#define VC_DMA_CNTL_write_enable5_shift                                              (1)
+#define VC_DMA_CNTL_write_enable5_mask                                               (0x00000002)
+#define VC_DMA_CNTL_write_enable5(data)                                              (0x00000002&((data)<<1))
+#define VC_DMA_CNTL_write_enable5_src(data)                                          ((0x00000002&(data))>>1)
+#define VC_DMA_CNTL_get_write_enable5(data)                                          ((0x00000002&(data))>>1)
+#define VC_DMA_CNTL_go_shift                                                         (0)
+#define VC_DMA_CNTL_go_mask                                                          (0x00000001)
+#define VC_DMA_CNTL_go(data)                                                         (0x00000001&((data)<<0))
+#define VC_DMA_CNTL_go_src(data)                                                     ((0x00000001&(data))>>0)
+#define VC_DMA_CNTL_get_go(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define VC_DMA_INT                                                                   0x18001068
+#define VC_DMA_INT_reg_addr                                                          "0xB8001068"
+#define VC_DMA_INT_reg                                                               0xB8001068
+#define set_VC_DMA_INT_reg(data)   (*((volatile unsigned int*) VC_DMA_INT_reg)=data)
+#define get_VC_DMA_INT_reg   (*((volatile unsigned int*) VC_DMA_INT_reg))
+#define VC_DMA_INT_inst_adr                                                          "0x001A"
+#define VC_DMA_INT_inst                                                              0x001A
+#define VC_DMA_INT_int_done_shift                                                    (0)
+#define VC_DMA_INT_int_done_mask                                                     (0x00000001)
+#define VC_DMA_INT_int_done(data)                                                    (0x00000001&((data)<<0))
+#define VC_DMA_INT_int_done_src(data)                                                ((0x00000001&(data))>>0)
+#define VC_DMA_INT_get_int_done(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VC_DMA_INT_EN                                                                0x1800106c
+#define VC_DMA_INT_EN_reg_addr                                                       "0xB800106C"
+#define VC_DMA_INT_EN_reg                                                            0xB800106C
+#define set_VC_DMA_INT_EN_reg(data)   (*((volatile unsigned int*) VC_DMA_INT_EN_reg)=data)
+#define get_VC_DMA_INT_EN_reg   (*((volatile unsigned int*) VC_DMA_INT_EN_reg))
+#define VC_DMA_INT_EN_inst_adr                                                       "0x001B"
+#define VC_DMA_INT_EN_inst                                                           0x001B
+#define VC_DMA_INT_EN_int_done_en_shift                                              (0)
+#define VC_DMA_INT_EN_int_done_en_mask                                               (0x00000001)
+#define VC_DMA_INT_EN_int_done_en(data)                                              (0x00000001&((data)<<0))
+#define VC_DMA_INT_EN_int_done_en_src(data)                                          ((0x00000001&(data))>>0)
+#define VC_DMA_INT_EN_get_int_done_en(data)                                          ((0x00000001&(data))>>0)
+
+
+#define VC_DMA_STATUS                                                                0x18001060
+#define VC_DMA_STATUS_reg_addr                                                       "0xB8001060"
+#define VC_DMA_STATUS_reg                                                            0xB8001060
+#define set_VC_DMA_STATUS_reg(data)   (*((volatile unsigned int*) VC_DMA_STATUS_reg)=data)
+#define get_VC_DMA_STATUS_reg   (*((volatile unsigned int*) VC_DMA_STATUS_reg))
+#define VC_DMA_STATUS_inst_adr                                                       "0x0018"
+#define VC_DMA_STATUS_inst                                                           0x0018
+#define VC_DMA_STATUS_done_7_shift                                                   (7)
+#define VC_DMA_STATUS_done_7_mask                                                    (0x00000080)
+#define VC_DMA_STATUS_done_7(data)                                                   (0x00000080&((data)<<7))
+#define VC_DMA_STATUS_done_7_src(data)                                               ((0x00000080&(data))>>7)
+#define VC_DMA_STATUS_get_done_7(data)                                               ((0x00000080&(data))>>7)
+#define VC_DMA_STATUS_done_6_shift                                                   (6)
+#define VC_DMA_STATUS_done_6_mask                                                    (0x00000040)
+#define VC_DMA_STATUS_done_6(data)                                                   (0x00000040&((data)<<6))
+#define VC_DMA_STATUS_done_6_src(data)                                               ((0x00000040&(data))>>6)
+#define VC_DMA_STATUS_get_done_6(data)                                               ((0x00000040&(data))>>6)
+#define VC_DMA_STATUS_done_5_shift                                                   (5)
+#define VC_DMA_STATUS_done_5_mask                                                    (0x00000020)
+#define VC_DMA_STATUS_done_5(data)                                                   (0x00000020&((data)<<5))
+#define VC_DMA_STATUS_done_5_src(data)                                               ((0x00000020&(data))>>5)
+#define VC_DMA_STATUS_get_done_5(data)                                               ((0x00000020&(data))>>5)
+#define VC_DMA_STATUS_done_4_shift                                                   (4)
+#define VC_DMA_STATUS_done_4_mask                                                    (0x00000010)
+#define VC_DMA_STATUS_done_4(data)                                                   (0x00000010&((data)<<4))
+#define VC_DMA_STATUS_done_4_src(data)                                               ((0x00000010&(data))>>4)
+#define VC_DMA_STATUS_get_done_4(data)                                               ((0x00000010&(data))>>4)
+#define VC_DMA_STATUS_done_3_shift                                                   (3)
+#define VC_DMA_STATUS_done_3_mask                                                    (0x00000008)
+#define VC_DMA_STATUS_done_3(data)                                                   (0x00000008&((data)<<3))
+#define VC_DMA_STATUS_done_3_src(data)                                               ((0x00000008&(data))>>3)
+#define VC_DMA_STATUS_get_done_3(data)                                               ((0x00000008&(data))>>3)
+#define VC_DMA_STATUS_done_2_shift                                                   (2)
+#define VC_DMA_STATUS_done_2_mask                                                    (0x00000004)
+#define VC_DMA_STATUS_done_2(data)                                                   (0x00000004&((data)<<2))
+#define VC_DMA_STATUS_done_2_src(data)                                               ((0x00000004&(data))>>2)
+#define VC_DMA_STATUS_get_done_2(data)                                               ((0x00000004&(data))>>2)
+#define VC_DMA_STATUS_done_1_shift                                                   (1)
+#define VC_DMA_STATUS_done_1_mask                                                    (0x00000002)
+#define VC_DMA_STATUS_done_1(data)                                                   (0x00000002&((data)<<1))
+#define VC_DMA_STATUS_done_1_src(data)                                               ((0x00000002&(data))>>1)
+#define VC_DMA_STATUS_get_done_1(data)                                               ((0x00000002&(data))>>1)
+#define VC_DMA_STATUS_done_0_shift                                                   (0)
+#define VC_DMA_STATUS_done_0_mask                                                    (0x00000001)
+#define VC_DMA_STATUS_done_0(data)                                                   (0x00000001&((data)<<0))
+#define VC_DMA_STATUS_done_0_src(data)                                               ((0x00000001&(data))>>0)
+#define VC_DMA_STATUS_get_done_0(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VC_DMA_DEBUG                                                                 0x18001080
+#define VC_DMA_DEBUG_reg_addr                                                        "0xB8001080"
+#define VC_DMA_DEBUG_reg                                                             0xB8001080
+#define set_VC_DMA_DEBUG_reg(data)   (*((volatile unsigned int*) VC_DMA_DEBUG_reg)=data)
+#define get_VC_DMA_DEBUG_reg   (*((volatile unsigned int*) VC_DMA_DEBUG_reg))
+#define VC_DMA_DEBUG_inst_adr                                                        "0x0020"
+#define VC_DMA_DEBUG_inst                                                            0x0020
+#define VC_DMA_DEBUG_write_enable3_shift                                             (11)
+#define VC_DMA_DEBUG_write_enable3_mask                                              (0x00000800)
+#define VC_DMA_DEBUG_write_enable3(data)                                             (0x00000800&((data)<<11))
+#define VC_DMA_DEBUG_write_enable3_src(data)                                         ((0x00000800&(data))>>11)
+#define VC_DMA_DEBUG_get_write_enable3(data)                                         ((0x00000800&(data))>>11)
+#define VC_DMA_DEBUG_sel1_shift                                                      (7)
+#define VC_DMA_DEBUG_sel1_mask                                                       (0x00000780)
+#define VC_DMA_DEBUG_sel1(data)                                                      (0x00000780&((data)<<7))
+#define VC_DMA_DEBUG_sel1_src(data)                                                  ((0x00000780&(data))>>7)
+#define VC_DMA_DEBUG_get_sel1(data)                                                  ((0x00000780&(data))>>7)
+#define VC_DMA_DEBUG_write_enable2_shift                                             (6)
+#define VC_DMA_DEBUG_write_enable2_mask                                              (0x00000040)
+#define VC_DMA_DEBUG_write_enable2(data)                                             (0x00000040&((data)<<6))
+#define VC_DMA_DEBUG_write_enable2_src(data)                                         ((0x00000040&(data))>>6)
+#define VC_DMA_DEBUG_get_write_enable2(data)                                         ((0x00000040&(data))>>6)
+#define VC_DMA_DEBUG_sel0_shift                                                      (2)
+#define VC_DMA_DEBUG_sel0_mask                                                       (0x0000003C)
+#define VC_DMA_DEBUG_sel0(data)                                                      (0x0000003C&((data)<<2))
+#define VC_DMA_DEBUG_sel0_src(data)                                                  ((0x0000003C&(data))>>2)
+#define VC_DMA_DEBUG_get_sel0(data)                                                  ((0x0000003C&(data))>>2)
+#define VC_DMA_DEBUG_write_enable1_shift                                             (1)
+#define VC_DMA_DEBUG_write_enable1_mask                                              (0x00000002)
+#define VC_DMA_DEBUG_write_enable1(data)                                             (0x00000002&((data)<<1))
+#define VC_DMA_DEBUG_write_enable1_src(data)                                         ((0x00000002&(data))>>1)
+#define VC_DMA_DEBUG_get_write_enable1(data)                                         ((0x00000002&(data))>>1)
+#define VC_DMA_DEBUG_enable_shift                                                    (0)
+#define VC_DMA_DEBUG_enable_mask                                                     (0x00000001)
+#define VC_DMA_DEBUG_enable(data)                                                    (0x00000001&((data)<<0))
+#define VC_DMA_DEBUG_enable_src(data)                                                ((0x00000001&(data))>>0)
+#define VC_DMA_DEBUG_get_enable(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VC_DMA_TIMER                                                                 0x18001084
+#define VC_DMA_TIMER_reg_addr                                                        "0xB8001084"
+#define VC_DMA_TIMER_reg                                                             0xB8001084
+#define set_VC_DMA_TIMER_reg(data)   (*((volatile unsigned int*) VC_DMA_TIMER_reg)=data)
+#define get_VC_DMA_TIMER_reg   (*((volatile unsigned int*) VC_DMA_TIMER_reg))
+#define VC_DMA_TIMER_inst_adr                                                        "0x0021"
+#define VC_DMA_TIMER_inst                                                            0x0021
+#define VC_DMA_TIMER_write_enable1_shift                                             (5)
+#define VC_DMA_TIMER_write_enable1_mask                                              (0x00000020)
+#define VC_DMA_TIMER_write_enable1(data)                                             (0x00000020&((data)<<5))
+#define VC_DMA_TIMER_write_enable1_src(data)                                         ((0x00000020&(data))>>5)
+#define VC_DMA_TIMER_get_write_enable1(data)                                         ((0x00000020&(data))>>5)
+#define VC_DMA_TIMER_delay_timer_shift                                               (0)
+#define VC_DMA_TIMER_delay_timer_mask                                                (0x0000001F)
+#define VC_DMA_TIMER_delay_timer(data)                                               (0x0000001F&((data)<<0))
+#define VC_DMA_TIMER_delay_timer_src(data)                                           ((0x0000001F&(data))>>0)
+#define VC_DMA_TIMER_get_delay_timer(data)                                           ((0x0000001F&(data))>>0)
+
+
+#define VC_DMA_BIST_RM                                                               0x180010D0
+#define VC_DMA_BIST_RM_reg_addr                                                      "0xB80010D0"
+#define VC_DMA_BIST_RM_reg                                                           0xB80010D0
+#define set_VC_DMA_BIST_RM_reg(data)   (*((volatile unsigned int*) VC_DMA_BIST_RM_reg)=data)
+#define get_VC_DMA_BIST_RM_reg   (*((volatile unsigned int*) VC_DMA_BIST_RM_reg))
+#define VC_DMA_BIST_RM_inst_adr                                                      "0x0034"
+#define VC_DMA_BIST_RM_inst                                                          0x0034
+#define VC_DMA_BIST_RM_RMEA_shift                                                    (12)
+#define VC_DMA_BIST_RM_RMEA_mask                                                     (0x00001000)
+#define VC_DMA_BIST_RM_RMEA(data)                                                    (0x00001000&((data)<<12))
+#define VC_DMA_BIST_RM_RMEA_src(data)                                                ((0x00001000&(data))>>12)
+#define VC_DMA_BIST_RM_get_RMEA(data)                                                ((0x00001000&(data))>>12)
+#define VC_DMA_BIST_RM_RMA_3_shift                                                   (11)
+#define VC_DMA_BIST_RM_RMA_3_mask                                                    (0x00000800)
+#define VC_DMA_BIST_RM_RMA_3(data)                                                   (0x00000800&((data)<<11))
+#define VC_DMA_BIST_RM_RMA_3_src(data)                                               ((0x00000800&(data))>>11)
+#define VC_DMA_BIST_RM_get_RMA_3(data)                                               ((0x00000800&(data))>>11)
+#define VC_DMA_BIST_RM_RMA_2_shift                                                   (10)
+#define VC_DMA_BIST_RM_RMA_2_mask                                                    (0x00000400)
+#define VC_DMA_BIST_RM_RMA_2(data)                                                   (0x00000400&((data)<<10))
+#define VC_DMA_BIST_RM_RMA_2_src(data)                                               ((0x00000400&(data))>>10)
+#define VC_DMA_BIST_RM_get_RMA_2(data)                                               ((0x00000400&(data))>>10)
+#define VC_DMA_BIST_RM_RMA_1_shift                                                   (9)
+#define VC_DMA_BIST_RM_RMA_1_mask                                                    (0x00000200)
+#define VC_DMA_BIST_RM_RMA_1(data)                                                   (0x00000200&((data)<<9))
+#define VC_DMA_BIST_RM_RMA_1_src(data)                                               ((0x00000200&(data))>>9)
+#define VC_DMA_BIST_RM_get_RMA_1(data)                                               ((0x00000200&(data))>>9)
+#define VC_DMA_BIST_RM_RMA_0_shift                                                   (8)
+#define VC_DMA_BIST_RM_RMA_0_mask                                                    (0x00000100)
+#define VC_DMA_BIST_RM_RMA_0(data)                                                   (0x00000100&((data)<<8))
+#define VC_DMA_BIST_RM_RMA_0_src(data)                                               ((0x00000100&(data))>>8)
+#define VC_DMA_BIST_RM_get_RMA_0(data)                                               ((0x00000100&(data))>>8)
+#define VC_DMA_BIST_RM_RMEB_shift                                                    (4)
+#define VC_DMA_BIST_RM_RMEB_mask                                                     (0x00000010)
+#define VC_DMA_BIST_RM_RMEB(data)                                                    (0x00000010&((data)<<4))
+#define VC_DMA_BIST_RM_RMEB_src(data)                                                ((0x00000010&(data))>>4)
+#define VC_DMA_BIST_RM_get_RMEB(data)                                                ((0x00000010&(data))>>4)
+#define VC_DMA_BIST_RM_RMB_3_shift                                                   (3)
+#define VC_DMA_BIST_RM_RMB_3_mask                                                    (0x00000008)
+#define VC_DMA_BIST_RM_RMB_3(data)                                                   (0x00000008&((data)<<3))
+#define VC_DMA_BIST_RM_RMB_3_src(data)                                               ((0x00000008&(data))>>3)
+#define VC_DMA_BIST_RM_get_RMB_3(data)                                               ((0x00000008&(data))>>3)
+#define VC_DMA_BIST_RM_RMB_2_shift                                                   (2)
+#define VC_DMA_BIST_RM_RMB_2_mask                                                    (0x00000004)
+#define VC_DMA_BIST_RM_RMB_2(data)                                                   (0x00000004&((data)<<2))
+#define VC_DMA_BIST_RM_RMB_2_src(data)                                               ((0x00000004&(data))>>2)
+#define VC_DMA_BIST_RM_get_RMB_2(data)                                               ((0x00000004&(data))>>2)
+#define VC_DMA_BIST_RM_RMB_1_shift                                                   (1)
+#define VC_DMA_BIST_RM_RMB_1_mask                                                    (0x00000002)
+#define VC_DMA_BIST_RM_RMB_1(data)                                                   (0x00000002&((data)<<1))
+#define VC_DMA_BIST_RM_RMB_1_src(data)                                               ((0x00000002&(data))>>1)
+#define VC_DMA_BIST_RM_get_RMB_1(data)                                               ((0x00000002&(data))>>1)
+#define VC_DMA_BIST_RM_RMB_0_shift                                                   (0)
+#define VC_DMA_BIST_RM_RMB_0_mask                                                    (0x00000001)
+#define VC_DMA_BIST_RM_RMB_0(data)                                                   (0x00000001&((data)<<0))
+#define VC_DMA_BIST_RM_RMB_0_src(data)                                               ((0x00000001&(data))>>0)
+#define VC_DMA_BIST_RM_get_RMB_0(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VC_DMA_BIST_ST                                                               0x180010D4
+#define VC_DMA_BIST_ST_reg_addr                                                      "0xB80010D4"
+#define VC_DMA_BIST_ST_reg                                                           0xB80010D4
+#define set_VC_DMA_BIST_ST_reg(data)   (*((volatile unsigned int*) VC_DMA_BIST_ST_reg)=data)
+#define get_VC_DMA_BIST_ST_reg   (*((volatile unsigned int*) VC_DMA_BIST_ST_reg))
+#define VC_DMA_BIST_ST_inst_adr                                                      "0x0035"
+#define VC_DMA_BIST_ST_inst                                                          0x0035
+#define VC_DMA_BIST_ST_bist_fail0_shift                                              (1)
+#define VC_DMA_BIST_ST_bist_fail0_mask                                               (0x00000002)
+#define VC_DMA_BIST_ST_bist_fail0(data)                                              (0x00000002&((data)<<1))
+#define VC_DMA_BIST_ST_bist_fail0_src(data)                                          ((0x00000002&(data))>>1)
+#define VC_DMA_BIST_ST_get_bist_fail0(data)                                          ((0x00000002&(data))>>1)
+#define VC_DMA_BIST_ST_bist_done_shift                                               (0)
+#define VC_DMA_BIST_ST_bist_done_mask                                                (0x00000001)
+#define VC_DMA_BIST_ST_bist_done(data)                                               (0x00000001&((data)<<0))
+#define VC_DMA_BIST_ST_bist_done_src(data)                                           ((0x00000001&(data))>>0)
+#define VC_DMA_BIST_ST_get_bist_done(data)                                           ((0x00000001&(data))>>0)
+
+
+#define VC_DMA_DRF_ST                                                                0x180010D8
+#define VC_DMA_DRF_ST_reg_addr                                                       "0xB80010D8"
+#define VC_DMA_DRF_ST_reg                                                            0xB80010D8
+#define set_VC_DMA_DRF_ST_reg(data)   (*((volatile unsigned int*) VC_DMA_DRF_ST_reg)=data)
+#define get_VC_DMA_DRF_ST_reg   (*((volatile unsigned int*) VC_DMA_DRF_ST_reg))
+#define VC_DMA_DRF_ST_inst_adr                                                       "0x0036"
+#define VC_DMA_DRF_ST_inst                                                           0x0036
+#define VC_DMA_DRF_ST_drf_start_pause_shift                                          (16)
+#define VC_DMA_DRF_ST_drf_start_pause_mask                                           (0x00010000)
+#define VC_DMA_DRF_ST_drf_start_pause(data)                                          (0x00010000&((data)<<16))
+#define VC_DMA_DRF_ST_drf_start_pause_src(data)                                      ((0x00010000&(data))>>16)
+#define VC_DMA_DRF_ST_get_drf_start_pause(data)                                      ((0x00010000&(data))>>16)
+#define VC_DMA_DRF_ST_drf_fail0_shift                                                (1)
+#define VC_DMA_DRF_ST_drf_fail0_mask                                                 (0x00000002)
+#define VC_DMA_DRF_ST_drf_fail0(data)                                                (0x00000002&((data)<<1))
+#define VC_DMA_DRF_ST_drf_fail0_src(data)                                            ((0x00000002&(data))>>1)
+#define VC_DMA_DRF_ST_get_drf_fail0(data)                                            ((0x00000002&(data))>>1)
+#define VC_DMA_DRF_ST_drf_done_shift                                                 (0)
+#define VC_DMA_DRF_ST_drf_done_mask                                                  (0x00000001)
+#define VC_DMA_DRF_ST_drf_done(data)                                                 (0x00000001&((data)<<0))
+#define VC_DMA_DRF_ST_drf_done_src(data)                                             ((0x00000001&(data))>>0)
+#define VC_DMA_DRF_ST_get_drf_done(data)                                             ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/ve_avs_rlblk_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/ve_avs_rlblk_reg.h
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/ve_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/ve_reg.h
new file mode 100644
index 00000000..e766ba9
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/ve_reg.h
@@ -0,0 +1,2995 @@
+// This file is generated using the spec version 1.66, firmware template version 1.39and DVR_Parser_0.46
+#ifndef _VE_REG_H_INCLUDED_
+#define _VE_REG_H_INCLUDED_
+
+//#define  _VE_USE_STRUCT
+#ifdef _VE_USE_STRUCT
+
+typedef struct
+{
+    unsigned int    reserved_0:9;
+    unsigned int    dering_dbg_sel:3;
+    unsigned int    vmblk_idle:1;
+    unsigned int    dbg_group2_sel:5;
+    unsigned int    dbg_group1_sel:5;
+    unsigned int    dbg_out_en:1;
+    unsigned int    codblk_mode1:1;
+    unsigned int    codblk_mode0:1;
+    unsigned int    haltve_done:1;
+    unsigned int    haltve:1;
+    unsigned int    veidle:1;
+    unsigned int    inten:1;
+    unsigned int    reset_ptr:1;
+    unsigned int    write_data:1;
+}ve_CNTL;
+
+typedef struct
+{
+    unsigned int    reserved_0:12;
+    unsigned int    first_error_b3:1;
+    unsigned int    first_error_b2:1;
+    unsigned int    first_error_b1:1;
+    unsigned int    first_error_b0:1;
+    unsigned int    reserved_1:8;
+    unsigned int    mt64coeff:1;
+    unsigned int    rstff_oflow:1;
+    unsigned int    rstff_empty:1;
+    unsigned int    bitst_fifo:1;
+    unsigned int    unexp_inst:1;
+    unsigned int    scode_limit:1;
+    unsigned int    dec_bitst:1;
+    unsigned int    write_data:1;
+}ve_INT_STATUS;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    mt64coeff:1;
+    unsigned int    rstff_oflow:1;
+    unsigned int    rstff_empty:1;
+    unsigned int    bitst_fifo:1;
+    unsigned int    unexp_inst:1;
+    unsigned int    scode_limit:1;
+    unsigned int    dec_bitst:1;
+    unsigned int    write_data:1;
+}ve_INTEN;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    codenum:6;
+    unsigned int    vspnum:6;
+    unsigned int    dmanum:6;
+    unsigned int    maxfifo:6;
+    unsigned int    rstnum:5;
+}ve_FIFOSTATE;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    write_enable7:1;
+    unsigned int    img_rsltstall_enable:1;
+    unsigned int    write_enable6:1;
+    unsigned int    dct_rsltstall_enable:1;
+    unsigned int    dct_cmstall_enable:1;
+    unsigned int    write_enable5:1;
+    unsigned int    vlc_cmstall_enable:1;
+    unsigned int    vlc_bsstall_enable:1;
+    unsigned int    write_enable4:1;
+    unsigned int    vld_rsltstall_enable:1;
+    unsigned int    vld_cmstall_enable:1;
+    unsigned int    vld_bsstall_enable:1;
+    unsigned int    write_enable3:1;
+    unsigned int    pc2_src:2;
+    unsigned int    pc2_enable:1;
+    unsigned int    write_enable2:1;
+    unsigned int    pc1_src:1;
+    unsigned int    reserved1:1;
+    unsigned int    pc1_enable:1;
+    unsigned int    write_enable1:1;
+    unsigned int    pc0_src:1;
+    unsigned int    reserved0:1;
+    unsigned int    pc0_enable:1;
+}ve_PCCNTL;
+
+typedef struct
+{
+    unsigned int    perf_counter0:32;
+}ve_PC0;
+
+typedef struct
+{
+    unsigned int    perf_counter1:32;
+}ve_PC1;
+
+typedef struct
+{
+    unsigned int    perf_counter2:32;
+}ve_PC2;
+
+typedef struct
+{
+    unsigned int    reserved_0:4;
+    unsigned int    write_enable8:1;
+    unsigned int    quant_type:1;
+    unsigned int    write_enable6:1;
+    unsigned int    quant_msk:8;
+    unsigned int    write_enable5:1;
+    unsigned int    ch_conv:1;
+    unsigned int    write_enable4:1;
+    unsigned int    intra:1;
+    unsigned int    write_enable3:1;
+    unsigned int    qst:1;
+    unsigned int    write_enable2:1;
+    unsigned int    qsc:5;
+    unsigned int    write_enable1:1;
+    unsigned int    id_pred:2;
+    unsigned int    write_enable:1;
+    unsigned int    field_dct:1;
+}ve_DCTCNTL;
+
+typedef struct
+{
+    unsigned int    reserved_0:13;
+    unsigned int    intra_round_dir:1;
+    unsigned int    intra_round_value:3;
+    unsigned int    inter_round_dir:1;
+    unsigned int    inter_round_value:3;
+    unsigned int    threshold:4;
+    unsigned int    mb_pattern:1;
+    unsigned int    cbp:6;
+}ve_CODECPARAM;
+
+typedef struct
+{
+    unsigned int    write_enable6:1;
+    unsigned int    bk_x_fcode:4;
+    unsigned int    bk_y_fcode:4;
+    unsigned int    write_enable5:1;
+    unsigned int    fo_x_fcode:4;
+    unsigned int    fo_y_fcode:4;
+    unsigned int    write_enable4:1;
+    unsigned int    max_xfer_size:1;
+    unsigned int    write_enable3:1;
+    unsigned int    min_xfer_size:3;
+    unsigned int    write_enable2:1;
+    unsigned int    pic_type:2;
+    unsigned int    write_enable1:1;
+    unsigned int    coding_type:4;
+}ve_CODECCNTL;
+
+typedef struct
+{
+    unsigned int    dv_skip_pass3:1;
+    unsigned int    ivf:1;
+    unsigned int    as:1;
+    unsigned int    pseudomode:1;
+    unsigned int    reserved_0:20;
+    unsigned int    data_partition:1;
+    unsigned int    intra_dc_vlc:1;
+    unsigned int    short_hdr:1;
+    unsigned int    r_vlc:1;
+    unsigned int    ac_pred:1;
+    unsigned int    q_sample:1;
+    unsigned int    ldtable:1;
+    unsigned int    write_data:1;
+}ve_CODECCNTL1;
+
+typedef struct
+{
+    unsigned int    reserved_0:10;
+    unsigned int    dct_mode:6;
+    unsigned int    class_blk:12;
+    unsigned int    qno:4;
+}ve_DVPARAM;
+
+typedef struct
+{
+    unsigned int    reserved_0:1;
+    unsigned int    struvlc_len:31;
+}ve_RVSTRUVLCLEN;
+
+typedef struct
+{
+    unsigned int    write_enable3:1;
+    unsigned int    umem1_mstr:1;
+    unsigned int    write_enable2:1;
+    unsigned int    rvmb_type:4;
+    unsigned int    write_enable1:1;
+    unsigned int    24bits_cbp:24;
+}ve_RVPARAM;
+
+typedef struct
+{
+    unsigned int    intra_mode1:32;
+}ve_RVINTRAMODE1;
+
+typedef struct
+{
+    unsigned int    intra_mode2:32;
+}ve_RVINTRAMODE2;
+
+typedef struct
+{
+    unsigned int    reserved_0:29;
+    unsigned int    rv9_intramode_use_top:1;
+    unsigned int    rv_osvquant:2;
+}ve_RVPARAM2;
+
+typedef struct
+{
+    unsigned int    reserved_0:21;
+    unsigned int    tbl_startaddr:11;
+}ve_VLDTBLPTR;
+
+typedef struct
+{
+    unsigned int    reserved_0:21;
+    unsigned int    tbl_espptr_saddr:11;
+}ve_VLDESPPTR;
+
+typedef struct
+{
+    unsigned int    max_bit:32;
+}ve_DECBITCNT;
+
+typedef struct
+{
+    unsigned int    bitcount:32;
+}ve_BITSTCNT;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    to_value:24;
+}ve_BSTTIMER;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    bitcount:24;
+}ve_PINSTCLIM;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    bs_base:29;
+}ve_BSBASE;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    bs_limit:29;
+}ve_BSLIMIT;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    wr_ptr:29;
+}ve_BSWRPTR;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    rd_ptr:29;
+}ve_BSRDPTR;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    cur_ptr:29;
+}ve_BSCURPTR;
+
+typedef struct
+{
+    unsigned int    dec_bit_ptr:32;
+}ve_DECBSPTR;
+
+typedef struct
+{
+    unsigned int    reserved_0:4;
+    unsigned int    write_enable5:1;
+    unsigned int    rpt_botline:3;
+    unsigned int    rpt_topline:3;
+    unsigned int    write_enable4:1;
+    unsigned int    rpt_rightpel:3;
+    unsigned int    rpt_leftpel:3;
+    unsigned int    write_enable3:1;
+    unsigned int    start_tap:4;
+    unsigned int    write_enable2:1;
+    unsigned int    tapnum:4;
+    unsigned int    write_enable1:1;
+    unsigned int    filt_prec:3;
+}ve_FILTCNTL;
+
+typedef struct
+{
+    unsigned int    reserved_0:9;
+    unsigned int    init_value:23;
+}ve_FILTINIT;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    alpha_loc:1;
+    unsigned int    alpha_enable:1;
+    unsigned int    color_key_enable:1;
+    unsigned int    format:2;
+}ve_CKCNTL;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    color_key2:8;
+    unsigned int    color_key1:8;
+    unsigned int    color_key0:8;
+}ve_CKDATA;
+
+typedef struct
+{
+    unsigned int    reserved_0:4;
+    unsigned int    rshift_size:3;
+    unsigned int    reserved_1:1;
+    unsigned int    t2:8;
+    unsigned int    k1:8;
+    unsigned int    t1:8;
+}ve_ADAPCNTL;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    alpha:8;
+}ve_ALPHA;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    thr_2:4;
+    unsigned int    thr_1:4;
+}ve_DEBLKCNTL;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    dc_value:8;
+}ve_DCVAL;
+
+typedef struct
+{
+    unsigned int    thr_4:8;
+    unsigned int    thr_3:8;
+    unsigned int    thr_2:8;
+    unsigned int    thr_1:8;
+}ve_BLKD_THR;
+
+typedef struct
+{
+    unsigned int    weight_5:8;
+    unsigned int    weight_4:8;
+    unsigned int    weight_3:8;
+    unsigned int    weight_2:8;
+}ve_BLKD_WEIGHT;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    qpel_format:1;
+}ve_QPEL_FORMAT;
+
+typedef struct
+{
+    unsigned int    thr_4:8;
+    unsigned int    thr_3:8;
+    unsigned int    thr_2:8;
+    unsigned int    thr_1:8;
+}ve_IMPULSE_THR;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    thr_7:8;
+    unsigned int    thr_6:8;
+    unsigned int    thr_5:8;
+}ve_IMPULSE_THR2;
+
+typedef struct
+{
+    unsigned int    reserved_0:30;
+    unsigned int    chroma_enable:1;
+    unsigned int    luma_enable:1;
+}ve_DERING_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    reserved_1:5;
+    unsigned int    coeffnplus1:9;
+    unsigned int    reserved_2:7;
+    unsigned int    coeffn:9;
+}ve_TAPCOEFF;
+
+typedef struct
+{
+    unsigned int    reserved_0:8;
+    unsigned int    cur_cr_cbp:4;
+    unsigned int    cur_cb_cbp:4;
+    unsigned int    cur_lu_cbp:16;
+}ve_RM_CUR_CBP;
+
+typedef struct
+{
+    unsigned int    reserved_0:13;
+    unsigned int    ul_cr_cbp:1;
+    unsigned int    ul_cb_cbp:1;
+    unsigned int    ul_lu_cbp:1;
+    unsigned int    up_cr_cbp:2;
+    unsigned int    up_cb_cbp:2;
+    unsigned int    up_lu_cbp:4;
+    unsigned int    left_cr_cbp:2;
+    unsigned int    left_cb_cbp:2;
+    unsigned int    left_lu_cbp:4;
+}ve_RM_NBR_CBP;
+
+typedef struct
+{
+    unsigned int    reserved_0:7;
+    unsigned int    ul_mvd:1;
+    unsigned int    up_mvd:4;
+    unsigned int    left_mvd:4;
+    unsigned int    cur_mvd:16;
+}ve_RM_MVD;
+
+typedef struct
+{
+    unsigned int    reserved_0:28;
+    unsigned int    ul_str_eq2:1;
+    unsigned int    up_str_eq2:1;
+    unsigned int    left_str_eq2:1;
+    unsigned int    cur_str_eq2:1;
+}ve_RM_BS;
+
+typedef struct
+{
+    unsigned int    write_enable2:1;
+    unsigned int    refqp:5;
+    unsigned int    beta2sel:1;
+    unsigned int    write_enable1:1;
+    unsigned int    up_ul_refdiff:1;
+    unsigned int    left_ul_refdiff:1;
+    unsigned int    cur_u_refdiff:1;
+    unsigned int    cur_l_refdiff:1;
+    unsigned int    qp_ul:5;
+    unsigned int    qp_up:5;
+    unsigned int    qp_left:5;
+    unsigned int    qp:5;
+}ve_RMBS_QP;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    str6_initqp:5;
+    unsigned int    str5_initqp:5;
+    unsigned int    str4_initqp:5;
+    unsigned int    str3_initqp:5;
+    unsigned int    str2_initqp:5;
+    unsigned int    str1_initqp:5;
+}ve_RV8_STR_MAP0;
+
+typedef struct
+{
+    unsigned int    reserved_0:17;
+    unsigned int    str9_initqp:5;
+    unsigned int    str8_initqp:5;
+    unsigned int    str7_initqp:5;
+}ve_RV8_STR_MAP1;
+
+typedef struct
+{
+    unsigned int    reserved_0:27;
+    unsigned int    write_enable2:1;
+    unsigned int    is_key_frame:1;
+    unsigned int    chroma_only:1;
+    unsigned int    write_enable1:1;
+    unsigned int    sel_s_chroma_deblock:1;
+}ve_RV8_CTRL;
+
+typedef struct
+{
+    unsigned int    reserved_0:29;
+    unsigned int    belowmb_refdiff_en:1;
+    unsigned int    subblk2clip_ch:1;
+    unsigned int    subblk12clip_lu:1;
+}ve_RV9_CLIP;
+
+typedef struct
+{
+    unsigned int    reserved_0:28;
+    unsigned int    rv89_mode:4;
+}ve_RV_MODE;
+
+typedef struct
+{
+    unsigned int    reserved_0:31;
+    unsigned int    u_cur_refdiff:1;
+}ve_BELOWMB_REFDIFF;
+
+typedef struct
+{
+    unsigned int    str_inc:32;
+}ve_RV8_PFILTSTR;
+
+typedef struct
+{
+    unsigned int    reserved_0:24;
+    unsigned int    uravail:1;
+    unsigned int    uavail:1;
+    unsigned int    lavail:1;
+    unsigned int    imode:1;
+    unsigned int    weighted_pred:1;
+    unsigned int    mb_type:2;
+    unsigned int    intra:1;
+}ve_RMPREDCCTL;
+
+typedef struct
+{
+    unsigned int    intrap7:4;
+    unsigned int    intrap6:4;
+    unsigned int    intrap5:4;
+    unsigned int    intrap4:4;
+    unsigned int    intrap3:4;
+    unsigned int    intrap2:4;
+    unsigned int    intrap1:4;
+    unsigned int    intrap0:4;
+}ve_RMINTRAM0;
+
+typedef struct
+{
+    unsigned int    intrap15:4;
+    unsigned int    intrap14:4;
+    unsigned int    intrap13:4;
+    unsigned int    intrap12:4;
+    unsigned int    intrap11:4;
+    unsigned int    intrap10:4;
+    unsigned int    intrap9:4;
+    unsigned int    intrap8:4;
+}ve_RMINTRAM1;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    coeff1:14;
+    unsigned int    reserved_1:2;
+    unsigned int    coeff0:14;
+}ve_RMCOEFF;
+
+typedef struct
+{
+    unsigned int    reserved_0:7;
+    unsigned int    init_phase:25;
+}ve_PHASE_INIT;
+
+typedef struct
+{
+    unsigned int    reserved_0:15;
+    unsigned int    phase_inc:17;
+}ve_PHASE_INC;
+
+typedef struct
+{
+    unsigned int    reserved_0:4;
+    unsigned int    reserved_1:3;
+    unsigned int    final_phase:25;
+}ve_PHASE_OUT;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    coeffnplus1:14;
+    unsigned int    reserved_1:2;
+    unsigned int    coeffn:14;
+}ve_TAPCOEFF1;
+
+typedef struct
+{
+    unsigned int    reserved_0:2;
+    unsigned int    coeffnplus1:14;
+    unsigned int    reserved_1:2;
+    unsigned int    coeffn:14;
+}ve_TAPCOEFF2;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    rcrpr:1;
+    unsigned int    color_cr:8;
+    unsigned int    color_cb:8;
+    unsigned int    color_y:8;
+    unsigned int    fill_mode:2;
+}ve_RMRPR_CNTL;
+
+typedef struct
+{
+    unsigned int    reserved_0:17;
+    unsigned int    m:4;
+    unsigned int    pixel_offset:11;
+}ve_RMRPR_PAR;
+
+typedef struct
+{
+    unsigned int    ax:32;
+}ve_RMRPR_AX;
+
+typedef struct
+{
+    unsigned int    ay:32;
+}ve_RMRPR_AY;
+
+typedef struct
+{
+    unsigned int    ax_inc:32;
+}ve_RMRPR_AXINC;
+
+typedef struct
+{
+    unsigned int    reserved_0:19;
+    unsigned int    picmb_h:6;
+    unsigned int    picmb_w:7;
+}ve_RMRPR_PICINFO;
+
+typedef struct
+{
+    unsigned int    reserved_0:20;
+    unsigned int    basea:12;
+}ve_BASEA;
+
+typedef struct
+{
+    unsigned int    reserved_0:20;
+    unsigned int    offseta:12;
+}ve_OFFSETA;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    x:13;
+    unsigned int    y:14;
+}ve_DMAREG1;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    field_frame:1;
+    unsigned int    decimated:2;
+    unsigned int    reserved_1:2;
+    unsigned int    bot_addr_idx:6;
+    unsigned int    reserved_2:2;
+    unsigned int    top_addr_idx:6;
+    unsigned int    post_inc_sel:1;
+    unsigned int    reserved_3:1;
+    unsigned int    post_inc:6;
+}ve_DMAREG2;
+
+typedef struct
+{
+    unsigned int    reserved_0:3;
+    unsigned int    line_off:1;
+    unsigned int    vm_pitch:7;
+    unsigned int    vm_addr:9;
+    unsigned int    h:6;
+    unsigned int    w:6;
+}ve_DMAREG3;
+
+typedef struct
+{
+    unsigned int    reserved_0:5;
+    unsigned int    write_enable3:1;
+    unsigned int    q_sample:1;
+    unsigned int    write_enable2:1;
+    unsigned int    rnd_cntl:1;
+    unsigned int    write_enable1:1;
+    unsigned int    h:11;
+    unsigned int    w:11;
+}ve_VMCNTL;
+#endif
+
+#define VE_CNTL                                                       0x1800A000
+#define VE_CNTL_reg_addr                                              "0xB800A000"
+#define VE_CNTL_reg                                                   0xB800A000
+#define VE_CNTL_inst_addr                                             "0x0000"
+#define VE_CNTL_inst                                                  0x0000
+#define VE_CNTL_dering_dbg_sel_shift                                  (20)
+#define VE_CNTL_vmblk_idle_shift                                      (19)
+#define VE_CNTL_dbg_group2_sel_shift                                  (14)
+#define VE_CNTL_dbg_group1_sel_shift                                  (9)
+#define VE_CNTL_dbg_out_en_shift                                      (8)
+#define VE_CNTL_codblk_mode1_shift                                    (7)
+#define VE_CNTL_codblk_mode0_shift                                    (6)
+#define VE_CNTL_codblk_mode_shift                                     (6)
+#define VE_CNTL_haltve_done_shift                                     (5)
+#define VE_CNTL_haltve_shift                                          (4)
+#define VE_CNTL_veidle_shift                                          (3)
+#define VE_CNTL_inten_shift                                           (2)
+#define VE_CNTL_reset_ptr_shift                                       (1)
+#define VE_CNTL_write_data_shift                                      (0)
+#define VE_CNTL_dering_dbg_sel_mask                                   (0x00700000)
+#define VE_CNTL_vmblk_idle_mask                                       (0x00080000)
+#define VE_CNTL_dbg_group2_sel_mask                                   (0x0007C000)
+#define VE_CNTL_dbg_group1_sel_mask                                   (0x00003E00)
+#define VE_CNTL_dbg_out_en_mask                                       (0x00000100)
+#define VE_CNTL_codblk_mode1_mask                                     (0x00000080)
+#define VE_CNTL_codblk_mode0_mask                                     (0x00000040)
+#define VE_CNTL_codblk_mode_mask                                      (0x000000C0)
+#define VE_CNTL_haltve_done_mask                                      (0x00000020)
+#define VE_CNTL_haltve_mask                                           (0x00000010)
+#define VE_CNTL_veidle_mask                                           (0x00000008)
+#define VE_CNTL_inten_mask                                            (0x00000004)
+#define VE_CNTL_reset_ptr_mask                                        (0x00000002)
+#define VE_CNTL_write_data_mask                                       (0x00000001)
+#define VE_CNTL_dering_dbg_sel(data)                                  (0x00700000&((data)<<20))
+#define VE_CNTL_vmblk_idle(data)                                      (0x00080000&((data)<<19))
+#define VE_CNTL_dbg_group2_sel(data)                                  (0x0007C000&((data)<<14))
+#define VE_CNTL_dbg_group1_sel(data)                                  (0x00003E00&((data)<<9))
+#define VE_CNTL_dbg_out_en(data)                                      (0x00000100&((data)<<8))
+#define VE_CNTL_codblk_mode1(data)                                    (0x00000080&((data)<<7))
+#define VE_CNTL_codblk_mode0(data)                                    (0x00000040&((data)<<6))
+#define VE_CNTL_codblk_mode(data)                                     (0x000000C0&((data)<<6))
+#define VE_CNTL_haltve_done(data)                                     (0x00000020&((data)<<5))
+#define VE_CNTL_haltve(data)                                          (0x00000010&((data)<<4))
+#define VE_CNTL_veidle(data)                                          (0x00000008&((data)<<3))
+#define VE_CNTL_inten(data)                                           (0x00000004&((data)<<2))
+#define VE_CNTL_reset_ptr(data)                                       (0x00000002&((data)<<1))
+#define VE_CNTL_write_data(data)                                      (0x00000001&(data))
+#define VE_CNTL_get_dering_dbg_sel(data)                              ((0x00700000&(data))>>20)
+#define VE_CNTL_get_vmblk_idle(data)                                  ((0x00080000&(data))>>19)
+#define VE_CNTL_get_dbg_group2_sel(data)                              ((0x0007C000&(data))>>14)
+#define VE_CNTL_get_dbg_group1_sel(data)                              ((0x00003E00&(data))>>9)
+#define VE_CNTL_get_dbg_out_en(data)                                  ((0x00000100&(data))>>8)
+#define VE_CNTL_get_codblk_mode1(data)                                ((0x00000080&(data))>>7)
+#define VE_CNTL_get_codblk_mode0(data)                                ((0x00000040&(data))>>6)
+#define VE_CNTL_get_codblk_mode(data)                                 ((0x000000C0&(data))>>6)
+#define VE_CNTL_get_haltve_done(data)                                 ((0x00000020&(data))>>5)
+#define VE_CNTL_get_haltve(data)                                      ((0x00000010&(data))>>4)
+#define VE_CNTL_get_veidle(data)                                      ((0x00000008&(data))>>3)
+#define VE_CNTL_get_inten(data)                                       ((0x00000004&(data))>>2)
+#define VE_CNTL_get_reset_ptr(data)                                   ((0x00000002&(data))>>1)
+#define VE_CNTL_get_write_data(data)                                  (0x00000001&(data))
+
+#define VE_INT_STATUS                                                 0x1800A004
+#define VE_INT_STATUS_reg_addr                                        "0xB800A004"
+#define VE_INT_STATUS_reg                                             0xB800A004
+#define VE_INT_STATUS_inst_addr                                       "0x0001"
+#define VE_INT_STATUS_inst                                            0x0001
+#define VE_INT_STATUS_first_error_b3_shift                            (19)
+#define VE_INT_STATUS_first_error_b2_shift                            (18)
+#define VE_INT_STATUS_first_error_b1_shift                            (17)
+#define VE_INT_STATUS_first_error_b0_shift                            (16)
+#define VE_INT_STATUS_first_error_shift                               (16)
+#define VE_INT_STATUS_mt64coeff_shift                                 (7)
+#define VE_INT_STATUS_rstff_oflow_shift                               (6)
+#define VE_INT_STATUS_rstff_empty_shift                               (5)
+#define VE_INT_STATUS_bitst_fifo_shift                                (4)
+#define VE_INT_STATUS_unexp_inst_shift                                (3)
+#define VE_INT_STATUS_scode_limit_shift                               (2)
+#define VE_INT_STATUS_dec_bitst_shift                                 (1)
+#define VE_INT_STATUS_write_data_shift                                (0)
+#define VE_INT_STATUS_first_error_b3_mask                             (0x00080000)
+#define VE_INT_STATUS_first_error_b2_mask                             (0x00040000)
+#define VE_INT_STATUS_first_error_b1_mask                             (0x00020000)
+#define VE_INT_STATUS_first_error_b0_mask                             (0x00010000)
+#define VE_INT_STATUS_first_error_mask                                (0x000F0000)
+#define VE_INT_STATUS_mt64coeff_mask                                  (0x00000080)
+#define VE_INT_STATUS_rstff_oflow_mask                                (0x00000040)
+#define VE_INT_STATUS_rstff_empty_mask                                (0x00000020)
+#define VE_INT_STATUS_bitst_fifo_mask                                 (0x00000010)
+#define VE_INT_STATUS_unexp_inst_mask                                 (0x00000008)
+#define VE_INT_STATUS_scode_limit_mask                                (0x00000004)
+#define VE_INT_STATUS_dec_bitst_mask                                  (0x00000002)
+#define VE_INT_STATUS_write_data_mask                                 (0x00000001)
+#define VE_INT_STATUS_first_error_b3(data)                            (0x00080000&((data)<<19))
+#define VE_INT_STATUS_first_error_b2(data)                            (0x00040000&((data)<<18))
+#define VE_INT_STATUS_first_error_b1(data)                            (0x00020000&((data)<<17))
+#define VE_INT_STATUS_first_error_b0(data)                            (0x00010000&((data)<<16))
+#define VE_INT_STATUS_first_error(data)                               (0x000F0000&((data)<<16))
+#define VE_INT_STATUS_mt64coeff(data)                                 (0x00000080&((data)<<7))
+#define VE_INT_STATUS_rstff_oflow(data)                               (0x00000040&((data)<<6))
+#define VE_INT_STATUS_rstff_empty(data)                               (0x00000020&((data)<<5))
+#define VE_INT_STATUS_bitst_fifo(data)                                (0x00000010&((data)<<4))
+#define VE_INT_STATUS_unexp_inst(data)                                (0x00000008&((data)<<3))
+#define VE_INT_STATUS_scode_limit(data)                               (0x00000004&((data)<<2))
+#define VE_INT_STATUS_dec_bitst(data)                                 (0x00000002&((data)<<1))
+#define VE_INT_STATUS_write_data(data)                                (0x00000001&(data))
+#define VE_INT_STATUS_get_first_error_b3(data)                        ((0x00080000&(data))>>19)
+#define VE_INT_STATUS_get_first_error_b2(data)                        ((0x00040000&(data))>>18)
+#define VE_INT_STATUS_get_first_error_b1(data)                        ((0x00020000&(data))>>17)
+#define VE_INT_STATUS_get_first_error_b0(data)                        ((0x00010000&(data))>>16)
+#define VE_INT_STATUS_get_first_error(data)                           ((0x000F0000&(data))>>16)
+#define VE_INT_STATUS_get_mt64coeff(data)                             ((0x00000080&(data))>>7)
+#define VE_INT_STATUS_get_rstff_oflow(data)                           ((0x00000040&(data))>>6)
+#define VE_INT_STATUS_get_rstff_empty(data)                           ((0x00000020&(data))>>5)
+#define VE_INT_STATUS_get_bitst_fifo(data)                            ((0x00000010&(data))>>4)
+#define VE_INT_STATUS_get_unexp_inst(data)                            ((0x00000008&(data))>>3)
+#define VE_INT_STATUS_get_scode_limit(data)                           ((0x00000004&(data))>>2)
+#define VE_INT_STATUS_get_dec_bitst(data)                             ((0x00000002&(data))>>1)
+#define VE_INT_STATUS_get_write_data(data)                            (0x00000001&(data))
+
+#define VE_INTEN                                                      0x1800A008
+#define VE_INTEN_reg_addr                                             "0xB800A008"
+#define VE_INTEN_reg                                                  0xB800A008
+#define VE_INTEN_inst_addr                                            "0x0002"
+#define VE_INTEN_inst                                                 0x0002
+#define VE_INTEN_mt64coeff_shift                                      (7)
+#define VE_INTEN_rstff_oflow_shift                                    (6)
+#define VE_INTEN_rstff_empty_shift                                    (5)
+#define VE_INTEN_bitst_fifo_shift                                     (4)
+#define VE_INTEN_unexp_inst_shift                                     (3)
+#define VE_INTEN_scode_limit_shift                                    (2)
+#define VE_INTEN_dec_bitst_shift                                      (1)
+#define VE_INTEN_write_data_shift                                     (0)
+#define VE_INTEN_mt64coeff_mask                                       (0x00000080)
+#define VE_INTEN_rstff_oflow_mask                                     (0x00000040)
+#define VE_INTEN_rstff_empty_mask                                     (0x00000020)
+#define VE_INTEN_bitst_fifo_mask                                      (0x00000010)
+#define VE_INTEN_unexp_inst_mask                                      (0x00000008)
+#define VE_INTEN_scode_limit_mask                                     (0x00000004)
+#define VE_INTEN_dec_bitst_mask                                       (0x00000002)
+#define VE_INTEN_write_data_mask                                      (0x00000001)
+#define VE_INTEN_mt64coeff(data)                                      (0x00000080&((data)<<7))
+#define VE_INTEN_rstff_oflow(data)                                    (0x00000040&((data)<<6))
+#define VE_INTEN_rstff_empty(data)                                    (0x00000020&((data)<<5))
+#define VE_INTEN_bitst_fifo(data)                                     (0x00000010&((data)<<4))
+#define VE_INTEN_unexp_inst(data)                                     (0x00000008&((data)<<3))
+#define VE_INTEN_scode_limit(data)                                    (0x00000004&((data)<<2))
+#define VE_INTEN_dec_bitst(data)                                      (0x00000002&((data)<<1))
+#define VE_INTEN_write_data(data)                                     (0x00000001&(data))
+#define VE_INTEN_get_mt64coeff(data)                                  ((0x00000080&(data))>>7)
+#define VE_INTEN_get_rstff_oflow(data)                                ((0x00000040&(data))>>6)
+#define VE_INTEN_get_rstff_empty(data)                                ((0x00000020&(data))>>5)
+#define VE_INTEN_get_bitst_fifo(data)                                 ((0x00000010&(data))>>4)
+#define VE_INTEN_get_unexp_inst(data)                                 ((0x00000008&(data))>>3)
+#define VE_INTEN_get_scode_limit(data)                                ((0x00000004&(data))>>2)
+#define VE_INTEN_get_dec_bitst(data)                                  ((0x00000002&(data))>>1)
+#define VE_INTEN_get_write_data(data)                                 (0x00000001&(data))
+
+#define VE_FIFOSTATE                                                  0x1800A020
+#define VE_FIFOSTATE_reg_addr                                         "0xB800A020"
+#define VE_FIFOSTATE_reg                                              0xB800A020
+#define VE_FIFOSTATE_inst_addr                                        "0x0008"
+#define VE_FIFOSTATE_inst                                             0x0008
+#define VE_FIFOSTATE_codenum_shift                                    (23)
+#define VE_FIFOSTATE_vspnum_shift                                     (17)
+#define VE_FIFOSTATE_dmanum_shift                                     (11)
+#define VE_FIFOSTATE_maxfifo_shift                                    (5)
+#define VE_FIFOSTATE_rstnum_shift                                     (0)
+#define VE_FIFOSTATE_codenum_mask                                     (0x1F800000)
+#define VE_FIFOSTATE_vspnum_mask                                      (0x007E0000)
+#define VE_FIFOSTATE_dmanum_mask                                      (0x0001F800)
+#define VE_FIFOSTATE_maxfifo_mask                                     (0x000007E0)
+#define VE_FIFOSTATE_rstnum_mask                                      (0x0000001F)
+#define VE_FIFOSTATE_codenum(data)                                    (0x1F800000&((data)<<23))
+#define VE_FIFOSTATE_vspnum(data)                                     (0x007E0000&((data)<<17))
+#define VE_FIFOSTATE_dmanum(data)                                     (0x0001F800&((data)<<11))
+#define VE_FIFOSTATE_maxfifo(data)                                    (0x000007E0&((data)<<5))
+#define VE_FIFOSTATE_rstnum(data)                                     (0x0000001F&(data))
+#define VE_FIFOSTATE_get_codenum(data)                                ((0x1F800000&(data))>>23)
+#define VE_FIFOSTATE_get_vspnum(data)                                 ((0x007E0000&(data))>>17)
+#define VE_FIFOSTATE_get_dmanum(data)                                 ((0x0001F800&(data))>>11)
+#define VE_FIFOSTATE_get_maxfifo(data)                                ((0x000007E0&(data))>>5)
+#define VE_FIFOSTATE_get_rstnum(data)                                 (0x0000001F&(data))
+
+#define VE_PCCNTL                                                     0x1800A030
+#define VE_PCCNTL_reg_addr                                            "0xB800A030"
+#define VE_PCCNTL_reg                                                 0xB800A030
+#define VE_PCCNTL_inst_addr                                           "0x000C"
+#define VE_PCCNTL_inst                                                0x000C
+#define VE_PCCNTL_write_enable7_shift                                 (23)
+#define VE_PCCNTL_img_rsltstall_enable_shift                          (22)
+#define VE_PCCNTL_write_enable6_shift                                 (21)
+#define VE_PCCNTL_dct_rsltstall_enable_shift                          (20)
+#define VE_PCCNTL_dct_cmstall_enable_shift                            (19)
+#define VE_PCCNTL_write_enable5_shift                                 (18)
+#define VE_PCCNTL_vlc_cmstall_enable_shift                            (17)
+#define VE_PCCNTL_vlc_bsstall_enable_shift                            (16)
+#define VE_PCCNTL_write_enable4_shift                                 (15)
+#define VE_PCCNTL_vld_rsltstall_enable_shift                          (14)
+#define VE_PCCNTL_vld_cmstall_enable_shift                            (13)
+#define VE_PCCNTL_vld_bsstall_enable_shift                            (12)
+#define VE_PCCNTL_write_enable3_shift                                 (11)
+#define VE_PCCNTL_pc2_src_shift                                       (9)
+#define VE_PCCNTL_pc2_enable_shift                                    (8)
+#define VE_PCCNTL_write_enable2_shift                                 (7)
+#define VE_PCCNTL_pc1_src_shift                                       (6)
+#define VE_PCCNTL_reserved1_shift                                     (5)
+#define VE_PCCNTL_pc1_enable_shift                                    (4)
+#define VE_PCCNTL_write_enable1_shift                                 (3)
+#define VE_PCCNTL_pc0_src_shift                                       (2)
+#define VE_PCCNTL_reserved0_shift                                     (1)
+#define VE_PCCNTL_pc0_enable_shift                                    (0)
+#define VE_PCCNTL_write_enable7_mask                                  (0x00800000)
+#define VE_PCCNTL_img_rsltstall_enable_mask                           (0x00400000)
+#define VE_PCCNTL_write_enable6_mask                                  (0x00200000)
+#define VE_PCCNTL_dct_rsltstall_enable_mask                           (0x00100000)
+#define VE_PCCNTL_dct_cmstall_enable_mask                             (0x00080000)
+#define VE_PCCNTL_write_enable5_mask                                  (0x00040000)
+#define VE_PCCNTL_vlc_cmstall_enable_mask                             (0x00020000)
+#define VE_PCCNTL_vlc_bsstall_enable_mask                             (0x00010000)
+#define VE_PCCNTL_write_enable4_mask                                  (0x00008000)
+#define VE_PCCNTL_vld_rsltstall_enable_mask                           (0x00004000)
+#define VE_PCCNTL_vld_cmstall_enable_mask                             (0x00002000)
+#define VE_PCCNTL_vld_bsstall_enable_mask                             (0x00001000)
+#define VE_PCCNTL_write_enable3_mask                                  (0x00000800)
+#define VE_PCCNTL_pc2_src_mask                                        (0x00000600)
+#define VE_PCCNTL_pc2_enable_mask                                     (0x00000100)
+#define VE_PCCNTL_write_enable2_mask                                  (0x00000080)
+#define VE_PCCNTL_pc1_src_mask                                        (0x00000040)
+#define VE_PCCNTL_reserved1_mask                                      (0x00000020)
+#define VE_PCCNTL_pc1_enable_mask                                     (0x00000010)
+#define VE_PCCNTL_write_enable1_mask                                  (0x00000008)
+#define VE_PCCNTL_pc0_src_mask                                        (0x00000004)
+#define VE_PCCNTL_reserved0_mask                                      (0x00000002)
+#define VE_PCCNTL_pc0_enable_mask                                     (0x00000001)
+#define VE_PCCNTL_write_enable7(data)                                 (0x00800000&((data)<<23))
+#define VE_PCCNTL_img_rsltstall_enable(data)                          (0x00400000&((data)<<22))
+#define VE_PCCNTL_write_enable6(data)                                 (0x00200000&((data)<<21))
+#define VE_PCCNTL_dct_rsltstall_enable(data)                          (0x00100000&((data)<<20))
+#define VE_PCCNTL_dct_cmstall_enable(data)                            (0x00080000&((data)<<19))
+#define VE_PCCNTL_write_enable5(data)                                 (0x00040000&((data)<<18))
+#define VE_PCCNTL_vlc_cmstall_enable(data)                            (0x00020000&((data)<<17))
+#define VE_PCCNTL_vlc_bsstall_enable(data)                            (0x00010000&((data)<<16))
+#define VE_PCCNTL_write_enable4(data)                                 (0x00008000&((data)<<15))
+#define VE_PCCNTL_vld_rsltstall_enable(data)                          (0x00004000&((data)<<14))
+#define VE_PCCNTL_vld_cmstall_enable(data)                            (0x00002000&((data)<<13))
+#define VE_PCCNTL_vld_bsstall_enable(data)                            (0x00001000&((data)<<12))
+#define VE_PCCNTL_write_enable3(data)                                 (0x00000800&((data)<<11))
+#define VE_PCCNTL_pc2_src(data)                                       (0x00000600&((data)<<9))
+#define VE_PCCNTL_pc2_enable(data)                                    (0x00000100&((data)<<8))
+#define VE_PCCNTL_write_enable2(data)                                 (0x00000080&((data)<<7))
+#define VE_PCCNTL_pc1_src(data)                                       (0x00000040&((data)<<6))
+#define VE_PCCNTL_reserved1(data)                                     (0x00000020&((data)<<5))
+#define VE_PCCNTL_pc1_enable(data)                                    (0x00000010&((data)<<4))
+#define VE_PCCNTL_write_enable1(data)                                 (0x00000008&((data)<<3))
+#define VE_PCCNTL_pc0_src(data)                                       (0x00000004&((data)<<2))
+#define VE_PCCNTL_reserved0(data)                                     (0x00000002&((data)<<1))
+#define VE_PCCNTL_pc0_enable(data)                                    (0x00000001&(data))
+#define VE_PCCNTL_get_write_enable7(data)                             ((0x00800000&(data))>>23)
+#define VE_PCCNTL_get_img_rsltstall_enable(data)                      ((0x00400000&(data))>>22)
+#define VE_PCCNTL_get_write_enable6(data)                             ((0x00200000&(data))>>21)
+#define VE_PCCNTL_get_dct_rsltstall_enable(data)                      ((0x00100000&(data))>>20)
+#define VE_PCCNTL_get_dct_cmstall_enable(data)                        ((0x00080000&(data))>>19)
+#define VE_PCCNTL_get_write_enable5(data)                             ((0x00040000&(data))>>18)
+#define VE_PCCNTL_get_vlc_cmstall_enable(data)                        ((0x00020000&(data))>>17)
+#define VE_PCCNTL_get_vlc_bsstall_enable(data)                        ((0x00010000&(data))>>16)
+#define VE_PCCNTL_get_write_enable4(data)                             ((0x00008000&(data))>>15)
+#define VE_PCCNTL_get_vld_rsltstall_enable(data)                      ((0x00004000&(data))>>14)
+#define VE_PCCNTL_get_vld_cmstall_enable(data)                        ((0x00002000&(data))>>13)
+#define VE_PCCNTL_get_vld_bsstall_enable(data)                        ((0x00001000&(data))>>12)
+#define VE_PCCNTL_get_write_enable3(data)                             ((0x00000800&(data))>>11)
+#define VE_PCCNTL_get_pc2_src(data)                                   ((0x00000600&(data))>>9)
+#define VE_PCCNTL_get_pc2_enable(data)                                ((0x00000100&(data))>>8)
+#define VE_PCCNTL_get_write_enable2(data)                             ((0x00000080&(data))>>7)
+#define VE_PCCNTL_get_pc1_src(data)                                   ((0x00000040&(data))>>6)
+#define VE_PCCNTL_get_reserved1(data)                                 ((0x00000020&(data))>>5)
+#define VE_PCCNTL_get_pc1_enable(data)                                ((0x00000010&(data))>>4)
+#define VE_PCCNTL_get_write_enable1(data)                             ((0x00000008&(data))>>3)
+#define VE_PCCNTL_get_pc0_src(data)                                   ((0x00000004&(data))>>2)
+#define VE_PCCNTL_get_reserved0(data)                                 ((0x00000002&(data))>>1)
+#define VE_PCCNTL_get_pc0_enable(data)                                (0x00000001&(data))
+
+#define VE_PC0                                                        0x1800A034
+#define VE_PC0_reg_addr                                               "0xB800A034"
+#define VE_PC0_reg                                                    0xB800A034
+#define VE_PC0_inst_addr                                              "0x000D"
+#define VE_PC0_inst                                                   0x000D
+#define VE_PC0_perf_counter0_shift                                    (0)
+#define VE_PC0_perf_counter0_mask                                     (0xFFFFFFFF)
+#define VE_PC0_perf_counter0(data)                                    (0xFFFFFFFF&(data))
+#define VE_PC0_get_perf_counter0(data)                                (0xFFFFFFFF&(data))
+
+#define VE_PC1                                                        0x1800A038
+#define VE_PC1_reg_addr                                               "0xB800A038"
+#define VE_PC1_reg                                                    0xB800A038
+#define VE_PC1_inst_addr                                              "0x000E"
+#define VE_PC1_inst                                                   0x000E
+#define VE_PC1_perf_counter1_shift                                    (0)
+#define VE_PC1_perf_counter1_mask                                     (0xFFFFFFFF)
+#define VE_PC1_perf_counter1(data)                                    (0xFFFFFFFF&(data))
+#define VE_PC1_get_perf_counter1(data)                                (0xFFFFFFFF&(data))
+
+#define VE_PC2                                                        0x1800A03C
+#define VE_PC2_reg_addr                                               "0xB800A03C"
+#define VE_PC2_reg                                                    0xB800A03C
+#define VE_PC2_inst_addr                                              "0x000F"
+#define VE_PC2_inst                                                   0x000F
+#define VE_PC2_perf_counter2_shift                                    (0)
+#define VE_PC2_perf_counter2_mask                                     (0xFFFFFFFF)
+#define VE_PC2_perf_counter2(data)                                    (0xFFFFFFFF&(data))
+#define VE_PC2_get_perf_counter2(data)                                (0xFFFFFFFF&(data))
+
+#define VE_DCTCNTL                                                    0x1800A080
+#define VE_DCTCNTL_reg_addr                                           "0xB800A080"
+#define VE_DCTCNTL_reg                                                0xB800A080
+#define VE_DCTCNTL_inst_addr                                          "0x0020"
+#define VE_DCTCNTL_inst                                               0x0020
+#define VE_DCTCNTL_write_enable8_shift                                (27)
+#define VE_DCTCNTL_quant_type_shift                                   (26)
+#define VE_DCTCNTL_write_enable6_shift                                (25)
+#define VE_DCTCNTL_quant_msk_shift                                    (17)
+#define VE_DCTCNTL_write_enable5_shift                                (16)
+#define VE_DCTCNTL_ch_conv_shift                                      (15)
+#define VE_DCTCNTL_write_enable4_shift                                (14)
+#define VE_DCTCNTL_intra_shift                                        (13)
+#define VE_DCTCNTL_write_enable3_shift                                (12)
+#define VE_DCTCNTL_qst_shift                                          (11)
+#define VE_DCTCNTL_write_enable2_shift                                (10)
+#define VE_DCTCNTL_qsc_shift                                          (5)
+#define VE_DCTCNTL_write_enable1_shift                                (4)
+#define VE_DCTCNTL_id_pred_shift                                      (2)
+#define VE_DCTCNTL_write_enable_shift                                 (1)
+#define VE_DCTCNTL_field_dct_shift                                    (0)
+#define VE_DCTCNTL_write_enable8_mask                                 (0x08000000)
+#define VE_DCTCNTL_quant_type_mask                                    (0x04000000)
+#define VE_DCTCNTL_write_enable6_mask                                 (0x02000000)
+#define VE_DCTCNTL_quant_msk_mask                                     (0x01FE0000)
+#define VE_DCTCNTL_write_enable5_mask                                 (0x00010000)
+#define VE_DCTCNTL_ch_conv_mask                                       (0x00008000)
+#define VE_DCTCNTL_write_enable4_mask                                 (0x00004000)
+#define VE_DCTCNTL_intra_mask                                         (0x00002000)
+#define VE_DCTCNTL_write_enable3_mask                                 (0x00001000)
+#define VE_DCTCNTL_qst_mask                                           (0x00000800)
+#define VE_DCTCNTL_write_enable2_mask                                 (0x00000400)
+#define VE_DCTCNTL_qsc_mask                                           (0x000003E0)
+#define VE_DCTCNTL_write_enable1_mask                                 (0x00000010)
+#define VE_DCTCNTL_id_pred_mask                                       (0x0000000C)
+#define VE_DCTCNTL_write_enable_mask                                  (0x00000002)
+#define VE_DCTCNTL_field_dct_mask                                     (0x00000001)
+#define VE_DCTCNTL_write_enable8(data)                                (0x08000000&((data)<<27))
+#define VE_DCTCNTL_quant_type(data)                                   (0x04000000&((data)<<26))
+#define VE_DCTCNTL_write_enable6(data)                                (0x02000000&((data)<<25))
+#define VE_DCTCNTL_quant_msk(data)                                    (0x01FE0000&((data)<<17))
+#define VE_DCTCNTL_write_enable5(data)                                (0x00010000&((data)<<16))
+#define VE_DCTCNTL_ch_conv(data)                                      (0x00008000&((data)<<15))
+#define VE_DCTCNTL_write_enable4(data)                                (0x00004000&((data)<<14))
+#define VE_DCTCNTL_intra(data)                                        (0x00002000&((data)<<13))
+#define VE_DCTCNTL_write_enable3(data)                                (0x00001000&((data)<<12))
+#define VE_DCTCNTL_qst(data)                                          (0x00000800&((data)<<11))
+#define VE_DCTCNTL_write_enable2(data)                                (0x00000400&((data)<<10))
+#define VE_DCTCNTL_qsc(data)                                          (0x000003E0&((data)<<5))
+#define VE_DCTCNTL_write_enable1(data)                                (0x00000010&((data)<<4))
+#define VE_DCTCNTL_id_pred(data)                                      (0x0000000C&((data)<<2))
+#define VE_DCTCNTL_write_enable(data)                                 (0x00000002&((data)<<1))
+#define VE_DCTCNTL_field_dct(data)                                    (0x00000001&(data))
+#define VE_DCTCNTL_get_write_enable8(data)                            ((0x08000000&(data))>>27)
+#define VE_DCTCNTL_get_quant_type(data)                               ((0x04000000&(data))>>26)
+#define VE_DCTCNTL_get_write_enable6(data)                            ((0x02000000&(data))>>25)
+#define VE_DCTCNTL_get_quant_msk(data)                                ((0x01FE0000&(data))>>17)
+#define VE_DCTCNTL_get_write_enable5(data)                            ((0x00010000&(data))>>16)
+#define VE_DCTCNTL_get_ch_conv(data)                                  ((0x00008000&(data))>>15)
+#define VE_DCTCNTL_get_write_enable4(data)                            ((0x00004000&(data))>>14)
+#define VE_DCTCNTL_get_intra(data)                                    ((0x00002000&(data))>>13)
+#define VE_DCTCNTL_get_write_enable3(data)                            ((0x00001000&(data))>>12)
+#define VE_DCTCNTL_get_qst(data)                                      ((0x00000800&(data))>>11)
+#define VE_DCTCNTL_get_write_enable2(data)                            ((0x00000400&(data))>>10)
+#define VE_DCTCNTL_get_qsc(data)                                      ((0x000003E0&(data))>>5)
+#define VE_DCTCNTL_get_write_enable1(data)                            ((0x00000010&(data))>>4)
+#define VE_DCTCNTL_get_id_pred(data)                                  ((0x0000000C&(data))>>2)
+#define VE_DCTCNTL_get_write_enable(data)                             ((0x00000002&(data))>>1)
+#define VE_DCTCNTL_get_field_dct(data)                                (0x00000001&(data))
+
+#define VE_CODECPARAM                                                 0x1800A084
+#define VE_CODECPARAM_reg_addr                                        "0xB800A084"
+#define VE_CODECPARAM_reg                                             0xB800A084
+#define VE_CODECPARAM_inst_addr                                       "0x0021"
+#define VE_CODECPARAM_inst                                            0x0021
+#define VE_CODECPARAM_intra_round_dir_shift                           (18)
+#define VE_CODECPARAM_intra_round_value_shift                         (15)
+#define VE_CODECPARAM_inter_round_dir_shift                           (14)
+#define VE_CODECPARAM_inter_round_value_shift                         (11)
+#define VE_CODECPARAM_threshold_shift                                 (7)
+#define VE_CODECPARAM_mb_pattern_shift                                (6)
+#define VE_CODECPARAM_cbp_shift                                       (0)
+#define VE_CODECPARAM_intra_round_dir_mask                            (0x00040000)
+#define VE_CODECPARAM_intra_round_value_mask                          (0x00038000)
+#define VE_CODECPARAM_inter_round_dir_mask                            (0x00004000)
+#define VE_CODECPARAM_inter_round_value_mask                          (0x00003800)
+#define VE_CODECPARAM_threshold_mask                                  (0x00000780)
+#define VE_CODECPARAM_mb_pattern_mask                                 (0x00000040)
+#define VE_CODECPARAM_cbp_mask                                        (0x0000003F)
+#define VE_CODECPARAM_intra_round_dir(data)                           (0x00040000&((data)<<18))
+#define VE_CODECPARAM_intra_round_value(data)                         (0x00038000&((data)<<15))
+#define VE_CODECPARAM_inter_round_dir(data)                           (0x00004000&((data)<<14))
+#define VE_CODECPARAM_inter_round_value(data)                         (0x00003800&((data)<<11))
+#define VE_CODECPARAM_threshold(data)                                 (0x00000780&((data)<<7))
+#define VE_CODECPARAM_mb_pattern(data)                                (0x00000040&((data)<<6))
+#define VE_CODECPARAM_cbp(data)                                       (0x0000003F&(data))
+#define VE_CODECPARAM_get_intra_round_dir(data)                       ((0x00040000&(data))>>18)
+#define VE_CODECPARAM_get_intra_round_value(data)                     ((0x00038000&(data))>>15)
+#define VE_CODECPARAM_get_inter_round_dir(data)                       ((0x00004000&(data))>>14)
+#define VE_CODECPARAM_get_inter_round_value(data)                     ((0x00003800&(data))>>11)
+#define VE_CODECPARAM_get_threshold(data)                             ((0x00000780&(data))>>7)
+#define VE_CODECPARAM_get_mb_pattern(data)                            ((0x00000040&(data))>>6)
+#define VE_CODECPARAM_get_cbp(data)                                   (0x0000003F&(data))
+
+#define VE_CODECCNTL                                                  0x1800A100
+#define VE_CODECCNTL_reg_addr                                         "0xB800A100"
+#define VE_CODECCNTL_reg                                              0xB800A100
+#define VE_CODECCNTL_inst_addr                                        "0x0040"
+#define VE_CODECCNTL_inst                                             0x0040
+#define VE_CODECCNTL_write_enable6_shift                              (31)
+#define VE_CODECCNTL_bk_x_fcode_shift                                 (27)
+#define VE_CODECCNTL_bk_y_fcode_shift                                 (23)
+#define VE_CODECCNTL_write_enable5_shift                              (22)
+#define VE_CODECCNTL_fo_x_fcode_shift                                 (18)
+#define VE_CODECCNTL_fo_y_fcode_shift                                 (14)
+#define VE_CODECCNTL_write_enable4_shift                              (13)
+#define VE_CODECCNTL_max_xfer_size_shift                              (12)
+#define VE_CODECCNTL_write_enable3_shift                              (11)
+#define VE_CODECCNTL_min_xfer_size_shift                              (8)
+#define VE_CODECCNTL_write_enable2_shift                              (7)
+#define VE_CODECCNTL_pic_type_shift                                   (5)
+#define VE_CODECCNTL_write_enable1_shift                              (4)
+#define VE_CODECCNTL_coding_type_shift                                (0)
+#define VE_CODECCNTL_write_enable6_mask                               (0x80000000)
+#define VE_CODECCNTL_bk_x_fcode_mask                                  (0x78000000)
+#define VE_CODECCNTL_bk_y_fcode_mask                                  (0x07800000)
+#define VE_CODECCNTL_write_enable5_mask                               (0x00400000)
+#define VE_CODECCNTL_fo_x_fcode_mask                                  (0x003C0000)
+#define VE_CODECCNTL_fo_y_fcode_mask                                  (0x0003C000)
+#define VE_CODECCNTL_write_enable4_mask                               (0x00002000)
+#define VE_CODECCNTL_max_xfer_size_mask                               (0x00001000)
+#define VE_CODECCNTL_write_enable3_mask                               (0x00000800)
+#define VE_CODECCNTL_min_xfer_size_mask                               (0x00000700)
+#define VE_CODECCNTL_write_enable2_mask                               (0x00000080)
+#define VE_CODECCNTL_pic_type_mask                                    (0x00000060)
+#define VE_CODECCNTL_write_enable1_mask                               (0x00000010)
+#define VE_CODECCNTL_coding_type_mask                                 (0x0000000F)
+#define VE_CODECCNTL_write_enable6(data)                              (0x80000000&((data)<<31))
+#define VE_CODECCNTL_bk_x_fcode(data)                                 (0x78000000&((data)<<27))
+#define VE_CODECCNTL_bk_y_fcode(data)                                 (0x07800000&((data)<<23))
+#define VE_CODECCNTL_write_enable5(data)                              (0x00400000&((data)<<22))
+#define VE_CODECCNTL_fo_x_fcode(data)                                 (0x003C0000&((data)<<18))
+#define VE_CODECCNTL_fo_y_fcode(data)                                 (0x0003C000&((data)<<14))
+#define VE_CODECCNTL_write_enable4(data)                              (0x00002000&((data)<<13))
+#define VE_CODECCNTL_max_xfer_size(data)                              (0x00001000&((data)<<12))
+#define VE_CODECCNTL_write_enable3(data)                              (0x00000800&((data)<<11))
+#define VE_CODECCNTL_min_xfer_size(data)                              (0x00000700&((data)<<8))
+#define VE_CODECCNTL_write_enable2(data)                              (0x00000080&((data)<<7))
+#define VE_CODECCNTL_pic_type(data)                                   (0x00000060&((data)<<5))
+#define VE_CODECCNTL_write_enable1(data)                              (0x00000010&((data)<<4))
+#define VE_CODECCNTL_coding_type(data)                                (0x0000000F&(data))
+#define VE_CODECCNTL_get_write_enable6(data)                          ((0x80000000&(data))>>31)
+#define VE_CODECCNTL_get_bk_x_fcode(data)                             ((0x78000000&(data))>>27)
+#define VE_CODECCNTL_get_bk_y_fcode(data)                             ((0x07800000&(data))>>23)
+#define VE_CODECCNTL_get_write_enable5(data)                          ((0x00400000&(data))>>22)
+#define VE_CODECCNTL_get_fo_x_fcode(data)                             ((0x003C0000&(data))>>18)
+#define VE_CODECCNTL_get_fo_y_fcode(data)                             ((0x0003C000&(data))>>14)
+#define VE_CODECCNTL_get_write_enable4(data)                          ((0x00002000&(data))>>13)
+#define VE_CODECCNTL_get_max_xfer_size(data)                          ((0x00001000&(data))>>12)
+#define VE_CODECCNTL_get_write_enable3(data)                          ((0x00000800&(data))>>11)
+#define VE_CODECCNTL_get_min_xfer_size(data)                          ((0x00000700&(data))>>8)
+#define VE_CODECCNTL_get_write_enable2(data)                          ((0x00000080&(data))>>7)
+#define VE_CODECCNTL_get_pic_type(data)                               ((0x00000060&(data))>>5)
+#define VE_CODECCNTL_get_write_enable1(data)                          ((0x00000010&(data))>>4)
+#define VE_CODECCNTL_get_coding_type(data)                            (0x0000000F&(data))
+
+#define VE_CODECCNTL1                                                 0x1800A104
+#define VE_CODECCNTL1_reg_addr                                        "0xB800A104"
+#define VE_CODECCNTL1_reg                                             0xB800A104
+#define VE_CODECCNTL1_inst_addr                                       "0x0041"
+#define VE_CODECCNTL1_inst                                            0x0041
+#define VE_CODECCNTL1_dv_skip_pass3_shift                             (31)
+#define VE_CODECCNTL1_ivf_shift                                       (30)
+#define VE_CODECCNTL1_as_shift                                        (29)
+#define VE_CODECCNTL1_pseudomode_shift                                (28)
+#define VE_CODECCNTL1_data_partition_shift                            (7)
+#define VE_CODECCNTL1_intra_dc_vlc_shift                              (6)
+#define VE_CODECCNTL1_short_hdr_shift                                 (5)
+#define VE_CODECCNTL1_r_vlc_shift                                     (4)
+#define VE_CODECCNTL1_ac_pred_shift                                   (3)
+#define VE_CODECCNTL1_q_sample_shift                                  (2)
+#define VE_CODECCNTL1_ldtable_shift                                   (1)
+#define VE_CODECCNTL1_write_data_shift                                (0)
+#define VE_CODECCNTL1_dv_skip_pass3_mask                              (0x80000000)
+#define VE_CODECCNTL1_ivf_mask                                        (0x40000000)
+#define VE_CODECCNTL1_as_mask                                         (0x20000000)
+#define VE_CODECCNTL1_pseudomode_mask                                 (0x10000000)
+#define VE_CODECCNTL1_data_partition_mask                             (0x00000080)
+#define VE_CODECCNTL1_intra_dc_vlc_mask                               (0x00000040)
+#define VE_CODECCNTL1_short_hdr_mask                                  (0x00000020)
+#define VE_CODECCNTL1_r_vlc_mask                                      (0x00000010)
+#define VE_CODECCNTL1_ac_pred_mask                                    (0x00000008)
+#define VE_CODECCNTL1_q_sample_mask                                   (0x00000004)
+#define VE_CODECCNTL1_ldtable_mask                                    (0x00000002)
+#define VE_CODECCNTL1_write_data_mask                                 (0x00000001)
+#define VE_CODECCNTL1_dv_skip_pass3(data)                             (0x80000000&((data)<<31))
+#define VE_CODECCNTL1_ivf(data)                                       (0x40000000&((data)<<30))
+#define VE_CODECCNTL1_as(data)                                        (0x20000000&((data)<<29))
+#define VE_CODECCNTL1_pseudomode(data)                                (0x10000000&((data)<<28))
+#define VE_CODECCNTL1_data_partition(data)                            (0x00000080&((data)<<7))
+#define VE_CODECCNTL1_intra_dc_vlc(data)                              (0x00000040&((data)<<6))
+#define VE_CODECCNTL1_short_hdr(data)                                 (0x00000020&((data)<<5))
+#define VE_CODECCNTL1_r_vlc(data)                                     (0x00000010&((data)<<4))
+#define VE_CODECCNTL1_ac_pred(data)                                   (0x00000008&((data)<<3))
+#define VE_CODECCNTL1_q_sample(data)                                  (0x00000004&((data)<<2))
+#define VE_CODECCNTL1_ldtable(data)                                   (0x00000002&((data)<<1))
+#define VE_CODECCNTL1_write_data(data)                                (0x00000001&(data))
+#define VE_CODECCNTL1_get_dv_skip_pass3(data)                         ((0x80000000&(data))>>31)
+#define VE_CODECCNTL1_get_ivf(data)                                   ((0x40000000&(data))>>30)
+#define VE_CODECCNTL1_get_as(data)                                    ((0x20000000&(data))>>29)
+#define VE_CODECCNTL1_get_pseudomode(data)                            ((0x10000000&(data))>>28)
+#define VE_CODECCNTL1_get_data_partition(data)                        ((0x00000080&(data))>>7)
+#define VE_CODECCNTL1_get_intra_dc_vlc(data)                          ((0x00000040&(data))>>6)
+#define VE_CODECCNTL1_get_short_hdr(data)                             ((0x00000020&(data))>>5)
+#define VE_CODECCNTL1_get_r_vlc(data)                                 ((0x00000010&(data))>>4)
+#define VE_CODECCNTL1_get_ac_pred(data)                               ((0x00000008&(data))>>3)
+#define VE_CODECCNTL1_get_q_sample(data)                              ((0x00000004&(data))>>2)
+#define VE_CODECCNTL1_get_ldtable(data)                               ((0x00000002&(data))>>1)
+#define VE_CODECCNTL1_get_write_data(data)                            (0x00000001&(data))
+
+#define VE_DVPARAM                                                    0x1800A108
+#define VE_DVPARAM_reg_addr                                           "0xB800A108"
+#define VE_DVPARAM_reg                                                0xB800A108
+#define VE_DVPARAM_inst_addr                                          "0x0042"
+#define VE_DVPARAM_inst                                               0x0042
+#define VE_DVPARAM_dct_mode_shift                                     (16)
+#define VE_DVPARAM_class_blk_shift                                    (4)
+#define VE_DVPARAM_qno_shift                                          (0)
+#define VE_DVPARAM_dct_mode_mask                                      (0x003F0000)
+#define VE_DVPARAM_class_blk_mask                                     (0x0000FFF0)
+#define VE_DVPARAM_qno_mask                                           (0x0000000F)
+#define VE_DVPARAM_dct_mode(data)                                     (0x003F0000&((data)<<16))
+#define VE_DVPARAM_class_blk(data)                                    (0x0000FFF0&((data)<<4))
+#define VE_DVPARAM_qno(data)                                          (0x0000000F&(data))
+#define VE_DVPARAM_get_dct_mode(data)                                 ((0x003F0000&(data))>>16)
+#define VE_DVPARAM_get_class_blk(data)                                ((0x0000FFF0&(data))>>4)
+#define VE_DVPARAM_get_qno(data)                                      (0x0000000F&(data))
+
+#define VE_RVSTRUVLCLEN                                               0x1800A10C
+#define VE_RVSTRUVLCLEN_reg_addr                                      "0xB800A10C"
+#define VE_RVSTRUVLCLEN_reg                                           0xB800A10C
+#define VE_RVSTRUVLCLEN_inst_addr                                     "0x0043"
+#define VE_RVSTRUVLCLEN_inst                                          0x0043
+#define VE_RVSTRUVLCLEN_struvlc_len_shift                             (0)
+#define VE_RVSTRUVLCLEN_struvlc_len_mask                              (0x7FFFFFFF)
+#define VE_RVSTRUVLCLEN_struvlc_len(data)                             (0x7FFFFFFF&(data))
+#define VE_RVSTRUVLCLEN_get_struvlc_len(data)                         (0x7FFFFFFF&(data))
+
+#define VE_RVPARAM                                                    0x1800A110
+#define VE_RVPARAM_reg_addr                                           "0xB800A110"
+#define VE_RVPARAM_reg                                                0xB800A110
+#define VE_RVPARAM_inst_addr                                          "0x0044"
+#define VE_RVPARAM_inst                                               0x0044
+#define VE_RVPARAM_write_enable3_shift                                (31)
+#define VE_RVPARAM_umem1_mstr_shift                                   (30)
+#define VE_RVPARAM_write_enable2_shift                                (29)
+#define VE_RVPARAM_rvmb_type_shift                                    (25)
+#define VE_RVPARAM_write_enable1_shift                                (24)
+#define VE_RVPARAM_24bits_cbp_shift                                   (0)
+#define VE_RVPARAM_write_enable3_mask                                 (0x80000000)
+#define VE_RVPARAM_umem1_mstr_mask                                    (0x40000000)
+#define VE_RVPARAM_write_enable2_mask                                 (0x20000000)
+#define VE_RVPARAM_rvmb_type_mask                                     (0x1E000000)
+#define VE_RVPARAM_write_enable1_mask                                 (0x01000000)
+#define VE_RVPARAM_24bits_cbp_mask                                    (0x00FFFFFF)
+#define VE_RVPARAM_write_enable3(data)                                (0x80000000&((data)<<31))
+#define VE_RVPARAM_umem1_mstr(data)                                   (0x40000000&((data)<<30))
+#define VE_RVPARAM_write_enable2(data)                                (0x20000000&((data)<<29))
+#define VE_RVPARAM_rvmb_type(data)                                    (0x1E000000&((data)<<25))
+#define VE_RVPARAM_write_enable1(data)                                (0x01000000&((data)<<24))
+#define VE_RVPARAM_24bits_cbp(data)                                   (0x00FFFFFF&(data))
+#define VE_RVPARAM_get_write_enable3(data)                            ((0x80000000&(data))>>31)
+#define VE_RVPARAM_get_umem1_mstr(data)                               ((0x40000000&(data))>>30)
+#define VE_RVPARAM_get_write_enable2(data)                            ((0x20000000&(data))>>29)
+#define VE_RVPARAM_get_rvmb_type(data)                                ((0x1E000000&(data))>>25)
+#define VE_RVPARAM_get_write_enable1(data)                            ((0x01000000&(data))>>24)
+#define VE_RVPARAM_get_24bits_cbp(data)                               (0x00FFFFFF&(data))
+
+#define VE_RVINTRAMODE1                                               0x1800A114
+#define VE_RVINTRAMODE1_reg_addr                                      "0xB800A114"
+#define VE_RVINTRAMODE1_reg                                           0xB800A114
+#define VE_RVINTRAMODE1_inst_addr                                     "0x0045"
+#define VE_RVINTRAMODE1_inst                                          0x0045
+#define VE_RVINTRAMODE1_intra_mode1_shift                             (0)
+#define VE_RVINTRAMODE1_intra_mode1_mask                              (0xFFFFFFFF)
+#define VE_RVINTRAMODE1_intra_mode1(data)                             (0xFFFFFFFF&(data))
+#define VE_RVINTRAMODE1_get_intra_mode1(data)                         (0xFFFFFFFF&(data))
+
+#define VE_RVINTRAMODE2                                               0x1800A118
+#define VE_RVINTRAMODE2_reg_addr                                      "0xB800A118"
+#define VE_RVINTRAMODE2_reg                                           0xB800A118
+#define VE_RVINTRAMODE2_inst_addr                                     "0x0046"
+#define VE_RVINTRAMODE2_inst                                          0x0046
+#define VE_RVINTRAMODE2_intra_mode2_shift                             (0)
+#define VE_RVINTRAMODE2_intra_mode2_mask                              (0xFFFFFFFF)
+#define VE_RVINTRAMODE2_intra_mode2(data)                             (0xFFFFFFFF&(data))
+#define VE_RVINTRAMODE2_get_intra_mode2(data)                         (0xFFFFFFFF&(data))
+
+#define VE_RVPARAM2                                                   0x1800A11C
+#define VE_RVPARAM2_reg_addr                                          "0xB800A11C"
+#define VE_RVPARAM2_reg                                               0xB800A11C
+#define VE_RVPARAM2_inst_addr                                         "0x0047"
+#define VE_RVPARAM2_inst                                              0x0047
+#define VE_RVPARAM2_rv9_intramode_use_top_shift                       (2)
+#define VE_RVPARAM2_rv_osvquant_shift                                 (0)
+#define VE_RVPARAM2_rv9_intramode_use_top_mask                        (0x00000004)
+#define VE_RVPARAM2_rv_osvquant_mask                                  (0x00000003)
+#define VE_RVPARAM2_rv9_intramode_use_top(data)                       (0x00000004&((data)<<2))
+#define VE_RVPARAM2_rv_osvquant(data)                                 (0x00000003&(data))
+#define VE_RVPARAM2_get_rv9_intramode_use_top(data)                   ((0x00000004&(data))>>2)
+#define VE_RVPARAM2_get_rv_osvquant(data)                             (0x00000003&(data))
+
+#define VE_VLDTBLPTR_0                                                0x1800A120
+#define VE_VLDTBLPTR_1                                                0x1800A124
+#define VE_VLDTBLPTR_2                                                0x1800A128
+#define VE_VLDTBLPTR_3                                                0x1800A12C
+#define VE_VLDTBLPTR_0_reg_addr                                       "0xB800A120"
+#define VE_VLDTBLPTR_1_reg_addr                                       "0xB800A124"
+#define VE_VLDTBLPTR_2_reg_addr                                       "0xB800A128"
+#define VE_VLDTBLPTR_3_reg_addr                                       "0xB800A12C"
+#define VE_VLDTBLPTR_0_reg                                            0xB800A120
+#define VE_VLDTBLPTR_1_reg                                            0xB800A124
+#define VE_VLDTBLPTR_2_reg                                            0xB800A128
+#define VE_VLDTBLPTR_3_reg                                            0xB800A12C
+#define VE_VLDTBLPTR_0_inst_addr                                      "0x0048"
+#define VE_VLDTBLPTR_0_inst                                           0x0048
+#define VE_VLDTBLPTR_1_inst_addr                                      "0x0049"
+#define VE_VLDTBLPTR_1_inst                                           0x0049
+#define VE_VLDTBLPTR_2_inst_addr                                      "0x004A"
+#define VE_VLDTBLPTR_2_inst                                           0x004A
+#define VE_VLDTBLPTR_3_inst_addr                                      "0x004B"
+#define VE_VLDTBLPTR_3_inst                                           0x004B
+#define VE_VLDTBLPTR_tbl_startaddr_shift                              (0)
+#define VE_VLDTBLPTR_tbl_startaddr_mask                               (0x000007FF)
+#define VE_VLDTBLPTR_tbl_startaddr(data)                              (0x000007FF&(data))
+#define VE_VLDTBLPTR_get_tbl_startaddr(data)                          (0x000007FF&(data))
+
+#define VE_VLDESPPTR_0                                                0x1800A130
+#define VE_VLDESPPTR_1                                                0x1800A134
+#define VE_VLDESPPTR_2                                                0x1800A138
+#define VE_VLDESPPTR_3                                                0x1800A13C
+#define VE_VLDESPPTR_0_reg_addr                                       "0xB800A130"
+#define VE_VLDESPPTR_1_reg_addr                                       "0xB800A134"
+#define VE_VLDESPPTR_2_reg_addr                                       "0xB800A138"
+#define VE_VLDESPPTR_3_reg_addr                                       "0xB800A13C"
+#define VE_VLDESPPTR_0_reg                                            0xB800A130
+#define VE_VLDESPPTR_1_reg                                            0xB800A134
+#define VE_VLDESPPTR_2_reg                                            0xB800A138
+#define VE_VLDESPPTR_3_reg                                            0xB800A13C
+#define VE_VLDESPPTR_0_inst_addr                                      "0x004C"
+#define VE_VLDESPPTR_0_inst                                           0x004C
+#define VE_VLDESPPTR_1_inst_addr                                      "0x004D"
+#define VE_VLDESPPTR_1_inst                                           0x004D
+#define VE_VLDESPPTR_2_inst_addr                                      "0x004E"
+#define VE_VLDESPPTR_2_inst                                           0x004E
+#define VE_VLDESPPTR_3_inst_addr                                      "0x004F"
+#define VE_VLDESPPTR_3_inst                                           0x004F
+#define VE_VLDESPPTR_tbl_espptr_saddr_shift                           (0)
+#define VE_VLDESPPTR_tbl_espptr_saddr_mask                            (0x000007FF)
+#define VE_VLDESPPTR_tbl_espptr_saddr(data)                           (0x000007FF&(data))
+#define VE_VLDESPPTR_get_tbl_espptr_saddr(data)                       (0x000007FF&(data))
+
+#define VE_DECBITCNT                                                  0x1800A140
+#define VE_DECBITCNT_reg_addr                                         "0xB800A140"
+#define VE_DECBITCNT_reg                                              0xB800A140
+#define VE_DECBITCNT_inst_addr                                        "0x0050"
+#define VE_DECBITCNT_inst                                             0x0050
+#define VE_DECBITCNT_max_bit_shift                                    (0)
+#define VE_DECBITCNT_max_bit_mask                                     (0xFFFFFFFF)
+#define VE_DECBITCNT_max_bit(data)                                    (0xFFFFFFFF&(data))
+#define VE_DECBITCNT_get_max_bit(data)                                (0xFFFFFFFF&(data))
+
+#define VE_BITSTCNT                                                   0x1800A144
+#define VE_BITSTCNT_reg_addr                                          "0xB800A144"
+#define VE_BITSTCNT_reg                                               0xB800A144
+#define VE_BITSTCNT_inst_addr                                         "0x0051"
+#define VE_BITSTCNT_inst                                              0x0051
+#define VE_BITSTCNT_bitcount_shift                                    (0)
+#define VE_BITSTCNT_bitcount_mask                                     (0xFFFFFFFF)
+#define VE_BITSTCNT_bitcount(data)                                    (0xFFFFFFFF&(data))
+#define VE_BITSTCNT_get_bitcount(data)                                (0xFFFFFFFF&(data))
+
+#define VE_BSTTIMER                                                   0x1800A148
+#define VE_BSTTIMER_reg_addr                                          "0xB800A148"
+#define VE_BSTTIMER_reg                                               0xB800A148
+#define VE_BSTTIMER_inst_addr                                         "0x0052"
+#define VE_BSTTIMER_inst                                              0x0052
+#define VE_BSTTIMER_to_value_shift                                    (0)
+#define VE_BSTTIMER_to_value_mask                                     (0x00FFFFFF)
+#define VE_BSTTIMER_to_value(data)                                    (0x00FFFFFF&(data))
+#define VE_BSTTIMER_get_to_value(data)                                (0x00FFFFFF&(data))
+
+#define VE_PINSTCLIM                                                  0x1800A14C
+#define VE_PINSTCLIM_reg_addr                                         "0xB800A14C"
+#define VE_PINSTCLIM_reg                                              0xB800A14C
+#define VE_PINSTCLIM_inst_addr                                        "0x0053"
+#define VE_PINSTCLIM_inst                                             0x0053
+#define VE_PINSTCLIM_bitcount_shift                                   (0)
+#define VE_PINSTCLIM_bitcount_mask                                    (0x00FFFFFF)
+#define VE_PINSTCLIM_bitcount(data)                                   (0x00FFFFFF&(data))
+#define VE_PINSTCLIM_get_bitcount(data)                               (0x00FFFFFF&(data))
+
+#define VE_BSBASE                                                     0x1800A160
+#define VE_BSBASE_reg_addr                                            "0xB800A160"
+#define VE_BSBASE_reg                                                 0xB800A160
+#define VE_BSBASE_inst_addr                                           "0x0058"
+#define VE_BSBASE_inst                                                0x0058
+#define VE_BSBASE_bs_base_shift                                       (0)
+#define VE_BSBASE_bs_base_mask                                        (0x1FFFFFFF)
+#define VE_BSBASE_bs_base(data)                                       (0x1FFFFFFF&(data))
+#define VE_BSBASE_get_bs_base(data)                                   (0x1FFFFFFF&(data))
+
+#define VE_BSLIMIT                                                    0x1800A164
+#define VE_BSLIMIT_reg_addr                                           "0xB800A164"
+#define VE_BSLIMIT_reg                                                0xB800A164
+#define VE_BSLIMIT_inst_addr                                          "0x0059"
+#define VE_BSLIMIT_inst                                               0x0059
+#define VE_BSLIMIT_bs_limit_shift                                     (0)
+#define VE_BSLIMIT_bs_limit_mask                                      (0x1FFFFFFF)
+#define VE_BSLIMIT_bs_limit(data)                                     (0x1FFFFFFF&(data))
+#define VE_BSLIMIT_get_bs_limit(data)                                 (0x1FFFFFFF&(data))
+
+#define VE_BSWRPTR                                                    0x1800A168
+#define VE_BSWRPTR_reg_addr                                           "0xB800A168"
+#define VE_BSWRPTR_reg                                                0xB800A168
+#define VE_BSWRPTR_inst_addr                                          "0x005A"
+#define VE_BSWRPTR_inst                                               0x005A
+#define VE_BSWRPTR_wr_ptr_shift                                       (0)
+#define VE_BSWRPTR_wr_ptr_mask                                        (0x1FFFFFFF)
+#define VE_BSWRPTR_wr_ptr(data)                                       (0x1FFFFFFF&(data))
+#define VE_BSWRPTR_get_wr_ptr(data)                                   (0x1FFFFFFF&(data))
+
+#define VE_BSRDPTR                                                    0x1800A16C
+#define VE_BSRDPTR_reg_addr                                           "0xB800A16C"
+#define VE_BSRDPTR_reg                                                0xB800A16C
+#define VE_BSRDPTR_inst_addr                                          "0x005B"
+#define VE_BSRDPTR_inst                                               0x005B
+#define VE_BSRDPTR_rd_ptr_shift                                       (0)
+#define VE_BSRDPTR_rd_ptr_mask                                        (0x1FFFFFFF)
+#define VE_BSRDPTR_rd_ptr(data)                                       (0x1FFFFFFF&(data))
+#define VE_BSRDPTR_get_rd_ptr(data)                                   (0x1FFFFFFF&(data))
+
+#define VE_BSCURPTR                                                   0x1800A170
+#define VE_BSCURPTR_reg_addr                                          "0xB800A170"
+#define VE_BSCURPTR_reg                                               0xB800A170
+#define VE_BSCURPTR_inst_addr                                         "0x005C"
+#define VE_BSCURPTR_inst                                              0x005C
+#define VE_BSCURPTR_cur_ptr_shift                                     (0)
+#define VE_BSCURPTR_cur_ptr_mask                                      (0x1FFFFFFF)
+#define VE_BSCURPTR_cur_ptr(data)                                     (0x1FFFFFFF&(data))
+#define VE_BSCURPTR_get_cur_ptr(data)                                 (0x1FFFFFFF&(data))
+
+#define VE_DECBSPTR                                                   0x1800A174
+#define VE_DECBSPTR_reg_addr                                          "0xB800A174"
+#define VE_DECBSPTR_reg                                               0xB800A174
+#define VE_DECBSPTR_inst_addr                                         "0x005D"
+#define VE_DECBSPTR_inst                                              0x005D
+#define VE_DECBSPTR_dec_bit_ptr_shift                                 (0)
+#define VE_DECBSPTR_dec_bit_ptr_mask                                  (0xFFFFFFFF)
+#define VE_DECBSPTR_dec_bit_ptr(data)                                 (0xFFFFFFFF&(data))
+#define VE_DECBSPTR_get_dec_bit_ptr(data)                             (0xFFFFFFFF&(data))
+
+#define VE_FILTCNTL                                                   0x1800A200
+#define VE_FILTCNTL_reg_addr                                          "0xB800A200"
+#define VE_FILTCNTL_reg                                               0xB800A200
+#define VE_FILTCNTL_inst_addr                                         "0x0080"
+#define VE_FILTCNTL_inst                                              0x0080
+#define VE_FILTCNTL_write_enable5_shift                               (27)
+#define VE_FILTCNTL_rpt_botline_shift                                 (24)
+#define VE_FILTCNTL_rpt_topline_shift                                 (21)
+#define VE_FILTCNTL_write_enable4_shift                               (20)
+#define VE_FILTCNTL_rpt_rightpel_shift                                (17)
+#define VE_FILTCNTL_rpt_leftpel_shift                                 (14)
+#define VE_FILTCNTL_write_enable3_shift                               (13)
+#define VE_FILTCNTL_start_tap_shift                                   (9)
+#define VE_FILTCNTL_write_enable2_shift                               (8)
+#define VE_FILTCNTL_tapnum_shift                                      (4)
+#define VE_FILTCNTL_write_enable1_shift                               (3)
+#define VE_FILTCNTL_filt_prec_shift                                   (0)
+#define VE_FILTCNTL_write_enable5_mask                                (0x08000000)
+#define VE_FILTCNTL_rpt_botline_mask                                  (0x07000000)
+#define VE_FILTCNTL_rpt_topline_mask                                  (0x00E00000)
+#define VE_FILTCNTL_write_enable4_mask                                (0x00100000)
+#define VE_FILTCNTL_rpt_rightpel_mask                                 (0x000E0000)
+#define VE_FILTCNTL_rpt_leftpel_mask                                  (0x0001C000)
+#define VE_FILTCNTL_write_enable3_mask                                (0x00002000)
+#define VE_FILTCNTL_start_tap_mask                                    (0x00001E00)
+#define VE_FILTCNTL_write_enable2_mask                                (0x00000100)
+#define VE_FILTCNTL_tapnum_mask                                       (0x000000F0)
+#define VE_FILTCNTL_write_enable1_mask                                (0x00000008)
+#define VE_FILTCNTL_filt_prec_mask                                    (0x00000007)
+#define VE_FILTCNTL_write_enable5(data)                               (0x08000000&((data)<<27))
+#define VE_FILTCNTL_rpt_botline(data)                                 (0x07000000&((data)<<24))
+#define VE_FILTCNTL_rpt_topline(data)                                 (0x00E00000&((data)<<21))
+#define VE_FILTCNTL_write_enable4(data)                               (0x00100000&((data)<<20))
+#define VE_FILTCNTL_rpt_rightpel(data)                                (0x000E0000&((data)<<17))
+#define VE_FILTCNTL_rpt_leftpel(data)                                 (0x0001C000&((data)<<14))
+#define VE_FILTCNTL_write_enable3(data)                               (0x00002000&((data)<<13))
+#define VE_FILTCNTL_start_tap(data)                                   (0x00001E00&((data)<<9))
+#define VE_FILTCNTL_write_enable2(data)                               (0x00000100&((data)<<8))
+#define VE_FILTCNTL_tapnum(data)                                      (0x000000F0&((data)<<4))
+#define VE_FILTCNTL_write_enable1(data)                               (0x00000008&((data)<<3))
+#define VE_FILTCNTL_filt_prec(data)                                   (0x00000007&(data))
+#define VE_FILTCNTL_get_write_enable5(data)                           ((0x08000000&(data))>>27)
+#define VE_FILTCNTL_get_rpt_botline(data)                             ((0x07000000&(data))>>24)
+#define VE_FILTCNTL_get_rpt_topline(data)                             ((0x00E00000&(data))>>21)
+#define VE_FILTCNTL_get_write_enable4(data)                           ((0x00100000&(data))>>20)
+#define VE_FILTCNTL_get_rpt_rightpel(data)                            ((0x000E0000&(data))>>17)
+#define VE_FILTCNTL_get_rpt_leftpel(data)                             ((0x0001C000&(data))>>14)
+#define VE_FILTCNTL_get_write_enable3(data)                           ((0x00002000&(data))>>13)
+#define VE_FILTCNTL_get_start_tap(data)                               ((0x00001E00&(data))>>9)
+#define VE_FILTCNTL_get_write_enable2(data)                           ((0x00000100&(data))>>8)
+#define VE_FILTCNTL_get_tapnum(data)                                  ((0x000000F0&(data))>>4)
+#define VE_FILTCNTL_get_write_enable1(data)                           ((0x00000008&(data))>>3)
+#define VE_FILTCNTL_get_filt_prec(data)                               (0x00000007&(data))
+
+#define VE_FILTINIT                                                   0x1800A204
+#define VE_FILTINIT_reg_addr                                          "0xB800A204"
+#define VE_FILTINIT_reg                                               0xB800A204
+#define VE_FILTINIT_inst_addr                                         "0x0081"
+#define VE_FILTINIT_inst                                              0x0081
+#define VE_FILTINIT_init_value_shift                                  (0)
+#define VE_FILTINIT_init_value_mask                                   (0x007FFFFF)
+#define VE_FILTINIT_init_value(data)                                  (0x007FFFFF&(data))
+#define VE_FILTINIT_get_init_value(data)                              (0x007FFFFF&(data))
+
+#define VE_CKCNTL                                                     0x1800A208
+#define VE_CKCNTL_reg_addr                                            "0xB800A208"
+#define VE_CKCNTL_reg                                                 0xB800A208
+#define VE_CKCNTL_inst_addr                                           "0x0082"
+#define VE_CKCNTL_inst                                                0x0082
+#define VE_CKCNTL_alpha_loc_shift                                     (4)
+#define VE_CKCNTL_alpha_enable_shift                                  (3)
+#define VE_CKCNTL_color_key_enable_shift                              (2)
+#define VE_CKCNTL_format_shift                                        (0)
+#define VE_CKCNTL_alpha_loc_mask                                      (0x00000010)
+#define VE_CKCNTL_alpha_enable_mask                                   (0x00000008)
+#define VE_CKCNTL_color_key_enable_mask                               (0x00000004)
+#define VE_CKCNTL_format_mask                                         (0x00000003)
+#define VE_CKCNTL_alpha_loc(data)                                     (0x00000010&((data)<<4))
+#define VE_CKCNTL_alpha_enable(data)                                  (0x00000008&((data)<<3))
+#define VE_CKCNTL_color_key_enable(data)                              (0x00000004&((data)<<2))
+#define VE_CKCNTL_format(data)                                        (0x00000003&(data))
+#define VE_CKCNTL_get_alpha_loc(data)                                 ((0x00000010&(data))>>4)
+#define VE_CKCNTL_get_alpha_enable(data)                              ((0x00000008&(data))>>3)
+#define VE_CKCNTL_get_color_key_enable(data)                          ((0x00000004&(data))>>2)
+#define VE_CKCNTL_get_format(data)                                    (0x00000003&(data))
+
+#define VE_CKDATA                                                     0x1800A20C
+#define VE_CKDATA_reg_addr                                            "0xB800A20C"
+#define VE_CKDATA_reg                                                 0xB800A20C
+#define VE_CKDATA_inst_addr                                           "0x0083"
+#define VE_CKDATA_inst                                                0x0083
+#define VE_CKDATA_color_key2_shift                                    (16)
+#define VE_CKDATA_color_key1_shift                                    (8)
+#define VE_CKDATA_color_key0_shift                                    (0)
+#define VE_CKDATA_color_key2_mask                                     (0x00FF0000)
+#define VE_CKDATA_color_key1_mask                                     (0x0000FF00)
+#define VE_CKDATA_color_key0_mask                                     (0x000000FF)
+#define VE_CKDATA_color_key2(data)                                    (0x00FF0000&((data)<<16))
+#define VE_CKDATA_color_key1(data)                                    (0x0000FF00&((data)<<8))
+#define VE_CKDATA_color_key0(data)                                    (0x000000FF&(data))
+#define VE_CKDATA_get_color_key2(data)                                ((0x00FF0000&(data))>>16)
+#define VE_CKDATA_get_color_key1(data)                                ((0x0000FF00&(data))>>8)
+#define VE_CKDATA_get_color_key0(data)                                (0x000000FF&(data))
+
+#define VE_ADAPCNTL                                                   0x1800A210
+#define VE_ADAPCNTL_reg_addr                                          "0xB800A210"
+#define VE_ADAPCNTL_reg                                               0xB800A210
+#define VE_ADAPCNTL_inst_addr                                         "0x0084"
+#define VE_ADAPCNTL_inst                                              0x0084
+#define VE_ADAPCNTL_rshift_size_shift                                 (25)
+#define VE_ADAPCNTL_t2_shift                                          (16)
+#define VE_ADAPCNTL_k1_shift                                          (8)
+#define VE_ADAPCNTL_t1_shift                                          (0)
+#define VE_ADAPCNTL_rshift_size_mask                                  (0x0E000000)
+#define VE_ADAPCNTL_t2_mask                                           (0x00FF0000)
+#define VE_ADAPCNTL_k1_mask                                           (0x0000FF00)
+#define VE_ADAPCNTL_t1_mask                                           (0x000000FF)
+#define VE_ADAPCNTL_rshift_size(data)                                 (0x0E000000&((data)<<25))
+#define VE_ADAPCNTL_t2(data)                                          (0x00FF0000&((data)<<16))
+#define VE_ADAPCNTL_k1(data)                                          (0x0000FF00&((data)<<8))
+#define VE_ADAPCNTL_t1(data)                                          (0x000000FF&(data))
+#define VE_ADAPCNTL_get_rshift_size(data)                             ((0x0E000000&(data))>>25)
+#define VE_ADAPCNTL_get_t2(data)                                      ((0x00FF0000&(data))>>16)
+#define VE_ADAPCNTL_get_k1(data)                                      ((0x0000FF00&(data))>>8)
+#define VE_ADAPCNTL_get_t1(data)                                      (0x000000FF&(data))
+
+#define VE_ALPHA                                                      0x1800A214
+#define VE_ALPHA_reg_addr                                             "0xB800A214"
+#define VE_ALPHA_reg                                                  0xB800A214
+#define VE_ALPHA_inst_addr                                            "0x0085"
+#define VE_ALPHA_inst                                                 0x0085
+#define VE_ALPHA_alpha_shift                                          (0)
+#define VE_ALPHA_alpha_mask                                           (0x000000FF)
+#define VE_ALPHA_alpha(data)                                          (0x000000FF&(data))
+#define VE_ALPHA_get_alpha(data)                                      (0x000000FF&(data))
+
+#define VE_DEBLKCNTL                                                  0x1800A218
+#define VE_DEBLKCNTL_reg_addr                                         "0xB800A218"
+#define VE_DEBLKCNTL_reg                                              0xB800A218
+#define VE_DEBLKCNTL_inst_addr                                        "0x0086"
+#define VE_DEBLKCNTL_inst                                             0x0086
+#define VE_DEBLKCNTL_thr_2_shift                                      (4)
+#define VE_DEBLKCNTL_thr_1_shift                                      (0)
+#define VE_DEBLKCNTL_thr_2_mask                                       (0x000000F0)
+#define VE_DEBLKCNTL_thr_1_mask                                       (0x0000000F)
+#define VE_DEBLKCNTL_thr_2(data)                                      (0x000000F0&((data)<<4))
+#define VE_DEBLKCNTL_thr_1(data)                                      (0x0000000F&(data))
+#define VE_DEBLKCNTL_get_thr_2(data)                                  ((0x000000F0&(data))>>4)
+#define VE_DEBLKCNTL_get_thr_1(data)                                  (0x0000000F&(data))
+
+#define VE_DCVAL                                                      0x1800A220
+#define VE_DCVAL_reg_addr                                             "0xB800A220"
+#define VE_DCVAL_reg                                                  0xB800A220
+#define VE_DCVAL_inst_addr                                            "0x0088"
+#define VE_DCVAL_inst                                                 0x0088
+#define VE_DCVAL_dc_value_shift                                       (0)
+#define VE_DCVAL_dc_value_mask                                        (0x000000FF)
+#define VE_DCVAL_dc_value(data)                                       (0x000000FF&(data))
+#define VE_DCVAL_get_dc_value(data)                                   (0x000000FF&(data))
+
+#define VE_BLKD_THR                                                   0x1800A224
+#define VE_BLKD_THR_reg_addr                                          "0xB800A224"
+#define VE_BLKD_THR_reg                                               0xB800A224
+#define VE_BLKD_THR_inst_addr                                         "0x0089"
+#define VE_BLKD_THR_inst                                              0x0089
+#define VE_BLKD_THR_thr_4_shift                                       (24)
+#define VE_BLKD_THR_thr_3_shift                                       (16)
+#define VE_BLKD_THR_thr_2_shift                                       (8)
+#define VE_BLKD_THR_thr_1_shift                                       (0)
+#define VE_BLKD_THR_thr_4_mask                                        (0xFF000000)
+#define VE_BLKD_THR_thr_3_mask                                        (0x00FF0000)
+#define VE_BLKD_THR_thr_2_mask                                        (0x0000FF00)
+#define VE_BLKD_THR_thr_1_mask                                        (0x000000FF)
+#define VE_BLKD_THR_thr_4(data)                                       (0xFF000000&((data)<<24))
+#define VE_BLKD_THR_thr_3(data)                                       (0x00FF0000&((data)<<16))
+#define VE_BLKD_THR_thr_2(data)                                       (0x0000FF00&((data)<<8))
+#define VE_BLKD_THR_thr_1(data)                                       (0x000000FF&(data))
+#define VE_BLKD_THR_get_thr_4(data)                                   ((0xFF000000&(data))>>24)
+#define VE_BLKD_THR_get_thr_3(data)                                   ((0x00FF0000&(data))>>16)
+#define VE_BLKD_THR_get_thr_2(data)                                   ((0x0000FF00&(data))>>8)
+#define VE_BLKD_THR_get_thr_1(data)                                   (0x000000FF&(data))
+
+#define VE_BLKD_WEIGHT                                                0x1800A228
+#define VE_BLKD_WEIGHT_reg_addr                                       "0xB800A228"
+#define VE_BLKD_WEIGHT_reg                                            0xB800A228
+#define VE_BLKD_WEIGHT_inst_addr                                      "0x008A"
+#define VE_BLKD_WEIGHT_inst                                           0x008A
+#define VE_BLKD_WEIGHT_weight_5_shift                                 (24)
+#define VE_BLKD_WEIGHT_weight_4_shift                                 (16)
+#define VE_BLKD_WEIGHT_weight_3_shift                                 (8)
+#define VE_BLKD_WEIGHT_weight_2_shift                                 (0)
+#define VE_BLKD_WEIGHT_weight_5_mask                                  (0xFF000000)
+#define VE_BLKD_WEIGHT_weight_4_mask                                  (0x00FF0000)
+#define VE_BLKD_WEIGHT_weight_3_mask                                  (0x0000FF00)
+#define VE_BLKD_WEIGHT_weight_2_mask                                  (0x000000FF)
+#define VE_BLKD_WEIGHT_weight_5(data)                                 (0xFF000000&((data)<<24))
+#define VE_BLKD_WEIGHT_weight_4(data)                                 (0x00FF0000&((data)<<16))
+#define VE_BLKD_WEIGHT_weight_3(data)                                 (0x0000FF00&((data)<<8))
+#define VE_BLKD_WEIGHT_weight_2(data)                                 (0x000000FF&(data))
+#define VE_BLKD_WEIGHT_get_weight_5(data)                             ((0xFF000000&(data))>>24)
+#define VE_BLKD_WEIGHT_get_weight_4(data)                             ((0x00FF0000&(data))>>16)
+#define VE_BLKD_WEIGHT_get_weight_3(data)                             ((0x0000FF00&(data))>>8)
+#define VE_BLKD_WEIGHT_get_weight_2(data)                             (0x000000FF&(data))
+
+#define VE_QPEL_FORMAT                                                0x1800A22C
+#define VE_QPEL_FORMAT_reg_addr                                       "0xB800A22C"
+#define VE_QPEL_FORMAT_reg                                            0xB800A22C
+#define VE_QPEL_FORMAT_inst_addr                                      "0x008B"
+#define VE_QPEL_FORMAT_inst                                           0x008B
+#define VE_QPEL_FORMAT_qpel_format_shift                              (0)
+#define VE_QPEL_FORMAT_qpel_format_mask                               (0x00000001)
+#define VE_QPEL_FORMAT_qpel_format(data)                              (0x00000001&(data))
+#define VE_QPEL_FORMAT_get_qpel_format(data)                          (0x00000001&(data))
+
+#define VE_IMPULSE_THR                                                0x1800A230
+#define VE_IMPULSE_THR_reg_addr                                       "0xB800A230"
+#define VE_IMPULSE_THR_reg                                            0xB800A230
+#define VE_IMPULSE_THR_inst_addr                                      "0x008C"
+#define VE_IMPULSE_THR_inst                                           0x008C
+#define VE_IMPULSE_THR_thr_4_shift                                    (24)
+#define VE_IMPULSE_THR_thr_3_shift                                    (16)
+#define VE_IMPULSE_THR_thr_2_shift                                    (8)
+#define VE_IMPULSE_THR_thr_1_shift                                    (0)
+#define VE_IMPULSE_THR_thr_4_mask                                     (0xFF000000)
+#define VE_IMPULSE_THR_thr_3_mask                                     (0x00FF0000)
+#define VE_IMPULSE_THR_thr_2_mask                                     (0x0000FF00)
+#define VE_IMPULSE_THR_thr_1_mask                                     (0x000000FF)
+#define VE_IMPULSE_THR_thr_4(data)                                    (0xFF000000&((data)<<24))
+#define VE_IMPULSE_THR_thr_3(data)                                    (0x00FF0000&((data)<<16))
+#define VE_IMPULSE_THR_thr_2(data)                                    (0x0000FF00&((data)<<8))
+#define VE_IMPULSE_THR_thr_1(data)                                    (0x000000FF&(data))
+#define VE_IMPULSE_THR_get_thr_4(data)                                ((0xFF000000&(data))>>24)
+#define VE_IMPULSE_THR_get_thr_3(data)                                ((0x00FF0000&(data))>>16)
+#define VE_IMPULSE_THR_get_thr_2(data)                                ((0x0000FF00&(data))>>8)
+#define VE_IMPULSE_THR_get_thr_1(data)                                (0x000000FF&(data))
+
+#define VE_IMPULSE_THR2                                               0x1800A234
+#define VE_IMPULSE_THR2_reg_addr                                      "0xB800A234"
+#define VE_IMPULSE_THR2_reg                                           0xB800A234
+#define VE_IMPULSE_THR2_inst_addr                                     "0x008D"
+#define VE_IMPULSE_THR2_inst                                          0x008D
+#define VE_IMPULSE_THR2_thr_7_shift                                   (16)
+#define VE_IMPULSE_THR2_thr_6_shift                                   (8)
+#define VE_IMPULSE_THR2_thr_5_shift                                   (0)
+#define VE_IMPULSE_THR2_thr_7_mask                                    (0x00FF0000)
+#define VE_IMPULSE_THR2_thr_6_mask                                    (0x0000FF00)
+#define VE_IMPULSE_THR2_thr_5_mask                                    (0x000000FF)
+#define VE_IMPULSE_THR2_thr_7(data)                                   (0x00FF0000&((data)<<16))
+#define VE_IMPULSE_THR2_thr_6(data)                                   (0x0000FF00&((data)<<8))
+#define VE_IMPULSE_THR2_thr_5(data)                                   (0x000000FF&(data))
+#define VE_IMPULSE_THR2_get_thr_7(data)                               ((0x00FF0000&(data))>>16)
+#define VE_IMPULSE_THR2_get_thr_6(data)                               ((0x0000FF00&(data))>>8)
+#define VE_IMPULSE_THR2_get_thr_5(data)                               (0x000000FF&(data))
+
+#define VE_DERING_CTRL                                                0x1800A238
+#define VE_DERING_CTRL_reg_addr                                       "0xB800A238"
+#define VE_DERING_CTRL_reg                                            0xB800A238
+#define VE_DERING_CTRL_inst_addr                                      "0x008E"
+#define VE_DERING_CTRL_inst                                           0x008E
+#define VE_DERING_CTRL_chroma_enable_shift                            (1)
+#define VE_DERING_CTRL_luma_enable_shift                              (0)
+#define VE_DERING_CTRL_chroma_enable_mask                             (0x00000002)
+#define VE_DERING_CTRL_luma_enable_mask                               (0x00000001)
+#define VE_DERING_CTRL_chroma_enable(data)                            (0x00000002&((data)<<1))
+#define VE_DERING_CTRL_luma_enable(data)                              (0x00000001&(data))
+#define VE_DERING_CTRL_get_chroma_enable(data)                        ((0x00000002&(data))>>1)
+#define VE_DERING_CTRL_get_luma_enable(data)                          (0x00000001&(data))
+
+#define VE_TAPCOEFF_0                                                 0x1800A240
+#define VE_TAPCOEFF_1                                                 0x1800A244
+#define VE_TAPCOEFF_2                                                 0x1800A248
+#define VE_TAPCOEFF_3                                                 0x1800A24C
+#define VE_TAPCOEFF_4                                                 0x1800A250
+#define VE_TAPCOEFF_5                                                 0x1800A254
+#define VE_TAPCOEFF_6                                                 0x1800A258
+#define VE_TAPCOEFF_7                                                 0x1800A25C
+#define VE_TAPCOEFF_0_reg_addr                                        "0xB800A240"
+#define VE_TAPCOEFF_1_reg_addr                                        "0xB800A244"
+#define VE_TAPCOEFF_2_reg_addr                                        "0xB800A248"
+#define VE_TAPCOEFF_3_reg_addr                                        "0xB800A24C"
+#define VE_TAPCOEFF_4_reg_addr                                        "0xB800A250"
+#define VE_TAPCOEFF_5_reg_addr                                        "0xB800A254"
+#define VE_TAPCOEFF_6_reg_addr                                        "0xB800A258"
+#define VE_TAPCOEFF_7_reg_addr                                        "0xB800A25C"
+#define VE_TAPCOEFF_0_reg                                             0xB800A240
+#define VE_TAPCOEFF_1_reg                                             0xB800A244
+#define VE_TAPCOEFF_2_reg                                             0xB800A248
+#define VE_TAPCOEFF_3_reg                                             0xB800A24C
+#define VE_TAPCOEFF_4_reg                                             0xB800A250
+#define VE_TAPCOEFF_5_reg                                             0xB800A254
+#define VE_TAPCOEFF_6_reg                                             0xB800A258
+#define VE_TAPCOEFF_7_reg                                             0xB800A25C
+#define VE_TAPCOEFF_0_inst_addr                                       "0x0090"
+#define VE_TAPCOEFF_0_inst                                            0x0090
+#define VE_TAPCOEFF_1_inst_addr                                       "0x0091"
+#define VE_TAPCOEFF_1_inst                                            0x0091
+#define VE_TAPCOEFF_2_inst_addr                                       "0x0092"
+#define VE_TAPCOEFF_2_inst                                            0x0092
+#define VE_TAPCOEFF_3_inst_addr                                       "0x0093"
+#define VE_TAPCOEFF_3_inst                                            0x0093
+#define VE_TAPCOEFF_4_inst_addr                                       "0x0094"
+#define VE_TAPCOEFF_4_inst                                            0x0094
+#define VE_TAPCOEFF_5_inst_addr                                       "0x0095"
+#define VE_TAPCOEFF_5_inst                                            0x0095
+#define VE_TAPCOEFF_6_inst_addr                                       "0x0096"
+#define VE_TAPCOEFF_6_inst                                            0x0096
+#define VE_TAPCOEFF_7_inst_addr                                       "0x0097"
+#define VE_TAPCOEFF_7_inst                                            0x0097
+#define VE_TAPCOEFF_coeffnplus1_shift                                 (16)
+#define VE_TAPCOEFF_coeffn_shift                                      (0)
+#define VE_TAPCOEFF_coeffnplus1_mask                                  (0x01FF0000)
+#define VE_TAPCOEFF_coeffn_mask                                       (0x000001FF)
+#define VE_TAPCOEFF_coeffnplus1(data)                                 (0x01FF0000&((data)<<16))
+#define VE_TAPCOEFF_coeffn(data)                                      (0x000001FF&(data))
+#define VE_TAPCOEFF_get_coeffnplus1(data)                             ((0x01FF0000&(data))>>16)
+#define VE_TAPCOEFF_get_coeffn(data)                                  (0x000001FF&(data))
+
+#define VE_RM_CUR_CBP                                                 0x1800A2A0
+#define VE_RM_CUR_CBP_reg_addr                                        "0xB800A2A0"
+#define VE_RM_CUR_CBP_reg                                             0xB800A2A0
+#define VE_RM_CUR_CBP_inst_addr                                       "0x00A8"
+#define VE_RM_CUR_CBP_inst                                            0x00A8
+#define VE_RM_CUR_CBP_cur_cr_cbp_shift                                (20)
+#define VE_RM_CUR_CBP_cur_cb_cbp_shift                                (16)
+#define VE_RM_CUR_CBP_cur_lu_cbp_shift                                (0)
+#define VE_RM_CUR_CBP_cur_cr_cbp_mask                                 (0x00F00000)
+#define VE_RM_CUR_CBP_cur_cb_cbp_mask                                 (0x000F0000)
+#define VE_RM_CUR_CBP_cur_lu_cbp_mask                                 (0x0000FFFF)
+#define VE_RM_CUR_CBP_cur_cr_cbp(data)                                (0x00F00000&((data)<<20))
+#define VE_RM_CUR_CBP_cur_cb_cbp(data)                                (0x000F0000&((data)<<16))
+#define VE_RM_CUR_CBP_cur_lu_cbp(data)                                (0x0000FFFF&(data))
+#define VE_RM_CUR_CBP_get_cur_cr_cbp(data)                            ((0x00F00000&(data))>>20)
+#define VE_RM_CUR_CBP_get_cur_cb_cbp(data)                            ((0x000F0000&(data))>>16)
+#define VE_RM_CUR_CBP_get_cur_lu_cbp(data)                            (0x0000FFFF&(data))
+
+#define VE_RM_NBR_CBP                                                 0x1800A2A4
+#define VE_RM_NBR_CBP_reg_addr                                        "0xB800A2A4"
+#define VE_RM_NBR_CBP_reg                                             0xB800A2A4
+#define VE_RM_NBR_CBP_inst_addr                                       "0x00A9"
+#define VE_RM_NBR_CBP_inst                                            0x00A9
+#define VE_RM_NBR_CBP_ul_cr_cbp_shift                                 (18)
+#define VE_RM_NBR_CBP_ul_cb_cbp_shift                                 (17)
+#define VE_RM_NBR_CBP_ul_lu_cbp_shift                                 (16)
+#define VE_RM_NBR_CBP_up_cr_cbp_shift                                 (14)
+#define VE_RM_NBR_CBP_up_cb_cbp_shift                                 (12)
+#define VE_RM_NBR_CBP_up_lu_cbp_shift                                 (8)
+#define VE_RM_NBR_CBP_left_cr_cbp_shift                               (6)
+#define VE_RM_NBR_CBP_left_cb_cbp_shift                               (4)
+#define VE_RM_NBR_CBP_left_lu_cbp_shift                               (0)
+#define VE_RM_NBR_CBP_ul_cr_cbp_mask                                  (0x00040000)
+#define VE_RM_NBR_CBP_ul_cb_cbp_mask                                  (0x00020000)
+#define VE_RM_NBR_CBP_ul_lu_cbp_mask                                  (0x00010000)
+#define VE_RM_NBR_CBP_up_cr_cbp_mask                                  (0x0000C000)
+#define VE_RM_NBR_CBP_up_cb_cbp_mask                                  (0x00003000)
+#define VE_RM_NBR_CBP_up_lu_cbp_mask                                  (0x00000F00)
+#define VE_RM_NBR_CBP_left_cr_cbp_mask                                (0x000000C0)
+#define VE_RM_NBR_CBP_left_cb_cbp_mask                                (0x00000030)
+#define VE_RM_NBR_CBP_left_lu_cbp_mask                                (0x0000000F)
+#define VE_RM_NBR_CBP_ul_cr_cbp(data)                                 (0x00040000&((data)<<18))
+#define VE_RM_NBR_CBP_ul_cb_cbp(data)                                 (0x00020000&((data)<<17))
+#define VE_RM_NBR_CBP_ul_lu_cbp(data)                                 (0x00010000&((data)<<16))
+#define VE_RM_NBR_CBP_up_cr_cbp(data)                                 (0x0000C000&((data)<<14))
+#define VE_RM_NBR_CBP_up_cb_cbp(data)                                 (0x00003000&((data)<<12))
+#define VE_RM_NBR_CBP_up_lu_cbp(data)                                 (0x00000F00&((data)<<8))
+#define VE_RM_NBR_CBP_left_cr_cbp(data)                               (0x000000C0&((data)<<6))
+#define VE_RM_NBR_CBP_left_cb_cbp(data)                               (0x00000030&((data)<<4))
+#define VE_RM_NBR_CBP_left_lu_cbp(data)                               (0x0000000F&(data))
+#define VE_RM_NBR_CBP_get_ul_cr_cbp(data)                             ((0x00040000&(data))>>18)
+#define VE_RM_NBR_CBP_get_ul_cb_cbp(data)                             ((0x00020000&(data))>>17)
+#define VE_RM_NBR_CBP_get_ul_lu_cbp(data)                             ((0x00010000&(data))>>16)
+#define VE_RM_NBR_CBP_get_up_cr_cbp(data)                             ((0x0000C000&(data))>>14)
+#define VE_RM_NBR_CBP_get_up_cb_cbp(data)                             ((0x00003000&(data))>>12)
+#define VE_RM_NBR_CBP_get_up_lu_cbp(data)                             ((0x00000F00&(data))>>8)
+#define VE_RM_NBR_CBP_get_left_cr_cbp(data)                           ((0x000000C0&(data))>>6)
+#define VE_RM_NBR_CBP_get_left_cb_cbp(data)                           ((0x00000030&(data))>>4)
+#define VE_RM_NBR_CBP_get_left_lu_cbp(data)                           (0x0000000F&(data))
+
+#define VE_RM_MVD                                                     0x1800A2A8
+#define VE_RM_MVD_reg_addr                                            "0xB800A2A8"
+#define VE_RM_MVD_reg                                                 0xB800A2A8
+#define VE_RM_MVD_inst_addr                                           "0x00AA"
+#define VE_RM_MVD_inst                                                0x00AA
+#define VE_RM_MVD_ul_mvd_shift                                        (24)
+#define VE_RM_MVD_up_mvd_shift                                        (20)
+#define VE_RM_MVD_left_mvd_shift                                      (16)
+#define VE_RM_MVD_cur_mvd_shift                                       (0)
+#define VE_RM_MVD_ul_mvd_mask                                         (0x01000000)
+#define VE_RM_MVD_up_mvd_mask                                         (0x00F00000)
+#define VE_RM_MVD_left_mvd_mask                                       (0x000F0000)
+#define VE_RM_MVD_cur_mvd_mask                                        (0x0000FFFF)
+#define VE_RM_MVD_ul_mvd(data)                                        (0x01000000&((data)<<24))
+#define VE_RM_MVD_up_mvd(data)                                        (0x00F00000&((data)<<20))
+#define VE_RM_MVD_left_mvd(data)                                      (0x000F0000&((data)<<16))
+#define VE_RM_MVD_cur_mvd(data)                                       (0x0000FFFF&(data))
+#define VE_RM_MVD_get_ul_mvd(data)                                    ((0x01000000&(data))>>24)
+#define VE_RM_MVD_get_up_mvd(data)                                    ((0x00F00000&(data))>>20)
+#define VE_RM_MVD_get_left_mvd(data)                                  ((0x000F0000&(data))>>16)
+#define VE_RM_MVD_get_cur_mvd(data)                                   (0x0000FFFF&(data))
+
+#define VE_RM_BS                                                      0x1800A2AC
+#define VE_RM_BS_reg_addr                                             "0xB800A2AC"
+#define VE_RM_BS_reg                                                  0xB800A2AC
+#define VE_RM_BS_inst_addr                                            "0x00AB"
+#define VE_RM_BS_inst                                                 0x00AB
+#define VE_RM_BS_ul_str_eq2_shift                                     (3)
+#define VE_RM_BS_up_str_eq2_shift                                     (2)
+#define VE_RM_BS_left_str_eq2_shift                                   (1)
+#define VE_RM_BS_cur_str_eq2_shift                                    (0)
+#define VE_RM_BS_ul_str_eq2_mask                                      (0x00000008)
+#define VE_RM_BS_up_str_eq2_mask                                      (0x00000004)
+#define VE_RM_BS_left_str_eq2_mask                                    (0x00000002)
+#define VE_RM_BS_cur_str_eq2_mask                                     (0x00000001)
+#define VE_RM_BS_ul_str_eq2(data)                                     (0x00000008&((data)<<3))
+#define VE_RM_BS_up_str_eq2(data)                                     (0x00000004&((data)<<2))
+#define VE_RM_BS_left_str_eq2(data)                                   (0x00000002&((data)<<1))
+#define VE_RM_BS_cur_str_eq2(data)                                    (0x00000001&(data))
+#define VE_RM_BS_get_ul_str_eq2(data)                                 ((0x00000008&(data))>>3)
+#define VE_RM_BS_get_up_str_eq2(data)                                 ((0x00000004&(data))>>2)
+#define VE_RM_BS_get_left_str_eq2(data)                               ((0x00000002&(data))>>1)
+#define VE_RM_BS_get_cur_str_eq2(data)                                (0x00000001&(data))
+
+#define VE_RMBS_QP                                                    0x1800A2B0
+#define VE_RMBS_QP_reg_addr                                           "0xB800A2B0"
+#define VE_RMBS_QP_reg                                                0xB800A2B0
+#define VE_RMBS_QP_inst_addr                                          "0x00AC"
+#define VE_RMBS_QP_inst                                               0x00AC
+#define VE_RMBS_QP_write_enable2_shift                                (31)
+#define VE_RMBS_QP_refqp_shift                                        (26)
+#define VE_RMBS_QP_beta2sel_shift                                     (25)
+#define VE_RMBS_QP_write_enable1_shift                                (24)
+#define VE_RMBS_QP_up_ul_refdiff_shift                                (23)
+#define VE_RMBS_QP_left_ul_refdiff_shift                              (22)
+#define VE_RMBS_QP_cur_u_refdiff_shift                                (21)
+#define VE_RMBS_QP_cur_l_refdiff_shift                                (20)
+#define VE_RMBS_QP_qp_ul_shift                                        (15)
+#define VE_RMBS_QP_qp_up_shift                                        (10)
+#define VE_RMBS_QP_qp_left_shift                                      (5)
+#define VE_RMBS_QP_qp_shift                                           (0)
+#define VE_RMBS_QP_write_enable2_mask                                 (0x80000000)
+#define VE_RMBS_QP_refqp_mask                                         (0x7C000000)
+#define VE_RMBS_QP_beta2sel_mask                                      (0x02000000)
+#define VE_RMBS_QP_write_enable1_mask                                 (0x01000000)
+#define VE_RMBS_QP_up_ul_refdiff_mask                                 (0x00800000)
+#define VE_RMBS_QP_left_ul_refdiff_mask                               (0x00400000)
+#define VE_RMBS_QP_cur_u_refdiff_mask                                 (0x00200000)
+#define VE_RMBS_QP_cur_l_refdiff_mask                                 (0x00100000)
+#define VE_RMBS_QP_qp_ul_mask                                         (0x000F8000)
+#define VE_RMBS_QP_qp_up_mask                                         (0x00007C00)
+#define VE_RMBS_QP_qp_left_mask                                       (0x000003E0)
+#define VE_RMBS_QP_qp_mask                                            (0x0000001F)
+#define VE_RMBS_QP_write_enable2(data)                                (0x80000000&((data)<<31))
+#define VE_RMBS_QP_refqp(data)                                        (0x7C000000&((data)<<26))
+#define VE_RMBS_QP_beta2sel(data)                                     (0x02000000&((data)<<25))
+#define VE_RMBS_QP_write_enable1(data)                                (0x01000000&((data)<<24))
+#define VE_RMBS_QP_up_ul_refdiff(data)                                (0x00800000&((data)<<23))
+#define VE_RMBS_QP_left_ul_refdiff(data)                              (0x00400000&((data)<<22))
+#define VE_RMBS_QP_cur_u_refdiff(data)                                (0x00200000&((data)<<21))
+#define VE_RMBS_QP_cur_l_refdiff(data)                                (0x00100000&((data)<<20))
+#define VE_RMBS_QP_qp_ul(data)                                        (0x000F8000&((data)<<15))
+#define VE_RMBS_QP_qp_up(data)                                        (0x00007C00&((data)<<10))
+#define VE_RMBS_QP_qp_left(data)                                      (0x000003E0&((data)<<5))
+#define VE_RMBS_QP_qp(data)                                           (0x0000001F&(data))
+#define VE_RMBS_QP_get_write_enable2(data)                            ((0x80000000&(data))>>31)
+#define VE_RMBS_QP_get_refqp(data)                                    ((0x7C000000&(data))>>26)
+#define VE_RMBS_QP_get_beta2sel(data)                                 ((0x02000000&(data))>>25)
+#define VE_RMBS_QP_get_write_enable1(data)                            ((0x01000000&(data))>>24)
+#define VE_RMBS_QP_get_up_ul_refdiff(data)                            ((0x00800000&(data))>>23)
+#define VE_RMBS_QP_get_left_ul_refdiff(data)                          ((0x00400000&(data))>>22)
+#define VE_RMBS_QP_get_cur_u_refdiff(data)                            ((0x00200000&(data))>>21)
+#define VE_RMBS_QP_get_cur_l_refdiff(data)                            ((0x00100000&(data))>>20)
+#define VE_RMBS_QP_get_qp_ul(data)                                    ((0x000F8000&(data))>>15)
+#define VE_RMBS_QP_get_qp_up(data)                                    ((0x00007C00&(data))>>10)
+#define VE_RMBS_QP_get_qp_left(data)                                  ((0x000003E0&(data))>>5)
+#define VE_RMBS_QP_get_qp(data)                                       (0x0000001F&(data))
+
+#define VE_RV8_STR_MAP0                                               0x1800A2B4
+#define VE_RV8_STR_MAP0_reg_addr                                      "0xB800A2B4"
+#define VE_RV8_STR_MAP0_reg                                           0xB800A2B4
+#define VE_RV8_STR_MAP0_inst_addr                                     "0x00AD"
+#define VE_RV8_STR_MAP0_inst                                          0x00AD
+#define VE_RV8_STR_MAP0_str6_initqp_shift                             (25)
+#define VE_RV8_STR_MAP0_str5_initqp_shift                             (20)
+#define VE_RV8_STR_MAP0_str4_initqp_shift                             (15)
+#define VE_RV8_STR_MAP0_str3_initqp_shift                             (10)
+#define VE_RV8_STR_MAP0_str2_initqp_shift                             (5)
+#define VE_RV8_STR_MAP0_str1_initqp_shift                             (0)
+#define VE_RV8_STR_MAP0_str6_initqp_mask                              (0x3E000000)
+#define VE_RV8_STR_MAP0_str5_initqp_mask                              (0x01F00000)
+#define VE_RV8_STR_MAP0_str4_initqp_mask                              (0x000F8000)
+#define VE_RV8_STR_MAP0_str3_initqp_mask                              (0x00007C00)
+#define VE_RV8_STR_MAP0_str2_initqp_mask                              (0x000003E0)
+#define VE_RV8_STR_MAP0_str1_initqp_mask                              (0x0000001F)
+#define VE_RV8_STR_MAP0_str6_initqp(data)                             (0x3E000000&((data)<<25))
+#define VE_RV8_STR_MAP0_str5_initqp(data)                             (0x01F00000&((data)<<20))
+#define VE_RV8_STR_MAP0_str4_initqp(data)                             (0x000F8000&((data)<<15))
+#define VE_RV8_STR_MAP0_str3_initqp(data)                             (0x00007C00&((data)<<10))
+#define VE_RV8_STR_MAP0_str2_initqp(data)                             (0x000003E0&((data)<<5))
+#define VE_RV8_STR_MAP0_str1_initqp(data)                             (0x0000001F&(data))
+#define VE_RV8_STR_MAP0_get_str6_initqp(data)                         ((0x3E000000&(data))>>25)
+#define VE_RV8_STR_MAP0_get_str5_initqp(data)                         ((0x01F00000&(data))>>20)
+#define VE_RV8_STR_MAP0_get_str4_initqp(data)                         ((0x000F8000&(data))>>15)
+#define VE_RV8_STR_MAP0_get_str3_initqp(data)                         ((0x00007C00&(data))>>10)
+#define VE_RV8_STR_MAP0_get_str2_initqp(data)                         ((0x000003E0&(data))>>5)
+#define VE_RV8_STR_MAP0_get_str1_initqp(data)                         (0x0000001F&(data))
+
+#define VE_RV8_STR_MAP1                                               0x1800A2B8
+#define VE_RV8_STR_MAP1_reg_addr                                      "0xB800A2B8"
+#define VE_RV8_STR_MAP1_reg                                           0xB800A2B8
+#define VE_RV8_STR_MAP1_inst_addr                                     "0x00AE"
+#define VE_RV8_STR_MAP1_inst                                          0x00AE
+#define VE_RV8_STR_MAP1_str9_initqp_shift                             (10)
+#define VE_RV8_STR_MAP1_str8_initqp_shift                             (5)
+#define VE_RV8_STR_MAP1_str7_initqp_shift                             (0)
+#define VE_RV8_STR_MAP1_str9_initqp_mask                              (0x00007C00)
+#define VE_RV8_STR_MAP1_str8_initqp_mask                              (0x000003E0)
+#define VE_RV8_STR_MAP1_str7_initqp_mask                              (0x0000001F)
+#define VE_RV8_STR_MAP1_str9_initqp(data)                             (0x00007C00&((data)<<10))
+#define VE_RV8_STR_MAP1_str8_initqp(data)                             (0x000003E0&((data)<<5))
+#define VE_RV8_STR_MAP1_str7_initqp(data)                             (0x0000001F&(data))
+#define VE_RV8_STR_MAP1_get_str9_initqp(data)                         ((0x00007C00&(data))>>10)
+#define VE_RV8_STR_MAP1_get_str8_initqp(data)                         ((0x000003E0&(data))>>5)
+#define VE_RV8_STR_MAP1_get_str7_initqp(data)                         (0x0000001F&(data))
+
+#define VE_RV8_CTRL                                                   0x1800A2BC
+#define VE_RV8_CTRL_reg_addr                                          "0xB800A2BC"
+#define VE_RV8_CTRL_reg                                               0xB800A2BC
+#define VE_RV8_CTRL_inst_addr                                         "0x00AF"
+#define VE_RV8_CTRL_inst                                              0x00AF
+#define VE_RV8_CTRL_write_enable2_shift                               (4)
+#define VE_RV8_CTRL_is_key_frame_shift                                (3)
+#define VE_RV8_CTRL_chroma_only_shift                                 (2)
+#define VE_RV8_CTRL_write_enable1_shift                               (1)
+#define VE_RV8_CTRL_sel_s_chroma_deblock_shift                        (0)
+#define VE_RV8_CTRL_write_enable2_mask                                (0x00000010)
+#define VE_RV8_CTRL_is_key_frame_mask                                 (0x00000008)
+#define VE_RV8_CTRL_chroma_only_mask                                  (0x00000004)
+#define VE_RV8_CTRL_write_enable1_mask                                (0x00000002)
+#define VE_RV8_CTRL_sel_s_chroma_deblock_mask                         (0x00000001)
+#define VE_RV8_CTRL_write_enable2(data)                               (0x00000010&((data)<<4))
+#define VE_RV8_CTRL_is_key_frame(data)                                (0x00000008&((data)<<3))
+#define VE_RV8_CTRL_chroma_only(data)                                 (0x00000004&((data)<<2))
+#define VE_RV8_CTRL_write_enable1(data)                               (0x00000002&((data)<<1))
+#define VE_RV8_CTRL_sel_s_chroma_deblock(data)                        (0x00000001&(data))
+#define VE_RV8_CTRL_get_write_enable2(data)                           ((0x00000010&(data))>>4)
+#define VE_RV8_CTRL_get_is_key_frame(data)                            ((0x00000008&(data))>>3)
+#define VE_RV8_CTRL_get_chroma_only(data)                             ((0x00000004&(data))>>2)
+#define VE_RV8_CTRL_get_write_enable1(data)                           ((0x00000002&(data))>>1)
+#define VE_RV8_CTRL_get_sel_s_chroma_deblock(data)                    (0x00000001&(data))
+
+#define VE_RV9_CLIP                                                   0x1800A2C0
+#define VE_RV9_CLIP_reg_addr                                          "0xB800A2C0"
+#define VE_RV9_CLIP_reg                                               0xB800A2C0
+#define VE_RV9_CLIP_inst_addr                                         "0x00B0"
+#define VE_RV9_CLIP_inst                                              0x00B0
+#define VE_RV9_CLIP_belowmb_refdiff_en_shift                          (2)
+#define VE_RV9_CLIP_subblk2clip_ch_shift                              (1)
+#define VE_RV9_CLIP_subblk12clip_lu_shift                             (0)
+#define VE_RV9_CLIP_belowmb_refdiff_en_mask                           (0x00000004)
+#define VE_RV9_CLIP_subblk2clip_ch_mask                               (0x00000002)
+#define VE_RV9_CLIP_subblk12clip_lu_mask                              (0x00000001)
+#define VE_RV9_CLIP_belowmb_refdiff_en(data)                          (0x00000004&((data)<<2))
+#define VE_RV9_CLIP_subblk2clip_ch(data)                              (0x00000002&((data)<<1))
+#define VE_RV9_CLIP_subblk12clip_lu(data)                             (0x00000001&(data))
+#define VE_RV9_CLIP_get_belowmb_refdiff_en(data)                      ((0x00000004&(data))>>2)
+#define VE_RV9_CLIP_get_subblk2clip_ch(data)                          ((0x00000002&(data))>>1)
+#define VE_RV9_CLIP_get_subblk12clip_lu(data)                         (0x00000001&(data))
+
+#define VE_RV_MODE                                                    0x1800A2C4
+#define VE_RV_MODE_reg_addr                                           "0xB800A2C4"
+#define VE_RV_MODE_reg                                                0xB800A2C4
+#define VE_RV_MODE_inst_addr                                          "0x00B1"
+#define VE_RV_MODE_inst                                               0x00B1
+#define VE_RV_MODE_rv89_mode_shift                                    (0)
+#define VE_RV_MODE_rv89_mode_mask                                     (0x0000000F)
+#define VE_RV_MODE_rv89_mode(data)                                    (0x0000000F&(data))
+#define VE_RV_MODE_get_rv89_mode(data)                                (0x0000000F&(data))
+
+#define VE_BELOWMB_REFDIFF                                            0x1800A2C8
+#define VE_BELOWMB_REFDIFF_reg_addr                                   "0xB800A2C8"
+#define VE_BELOWMB_REFDIFF_reg                                        0xB800A2C8
+#define VE_BELOWMB_REFDIFF_inst_addr                                  "0x00B2"
+#define VE_BELOWMB_REFDIFF_inst                                       0x00B2
+#define VE_BELOWMB_REFDIFF_u_cur_refdiff_shift                        (0)
+#define VE_BELOWMB_REFDIFF_u_cur_refdiff_mask                         (0x00000001)
+#define VE_BELOWMB_REFDIFF_u_cur_refdiff(data)                        (0x00000001&(data))
+#define VE_BELOWMB_REFDIFF_get_u_cur_refdiff(data)                    (0x00000001&(data))
+
+#define VE_RV8_PFILTSTR_0                                             0x1800A2D0
+#define VE_RV8_PFILTSTR_1                                             0x1800A2D4
+#define VE_RV8_PFILTSTR_2                                             0x1800A2D8
+#define VE_RV8_PFILTSTR_0_reg_addr                                    "0xB800A2D0"
+#define VE_RV8_PFILTSTR_1_reg_addr                                    "0xB800A2D4"
+#define VE_RV8_PFILTSTR_2_reg_addr                                    "0xB800A2D8"
+#define VE_RV8_PFILTSTR_0_reg                                         0xB800A2D0
+#define VE_RV8_PFILTSTR_1_reg                                         0xB800A2D4
+#define VE_RV8_PFILTSTR_2_reg                                         0xB800A2D8
+#define VE_RV8_PFILTSTR_0_inst_addr                                   "0x00B4"
+#define VE_RV8_PFILTSTR_0_inst                                        0x00B4
+#define VE_RV8_PFILTSTR_1_inst_addr                                   "0x00B5"
+#define VE_RV8_PFILTSTR_1_inst                                        0x00B5
+#define VE_RV8_PFILTSTR_2_inst_addr                                   "0x00B6"
+#define VE_RV8_PFILTSTR_2_inst                                        0x00B6
+#define VE_RV8_PFILTSTR_str_inc_shift                                 (0)
+#define VE_RV8_PFILTSTR_str_inc_mask                                  (0xFFFFFFFF)
+#define VE_RV8_PFILTSTR_str_inc(data)                                 (0xFFFFFFFF&(data))
+#define VE_RV8_PFILTSTR_get_str_inc(data)                             (0xFFFFFFFF&(data))
+
+#define VE_RMPREDCCTL                                                 0x1800A2E0
+#define VE_RMPREDCCTL_reg_addr                                        "0xB800A2E0"
+#define VE_RMPREDCCTL_reg                                             0xB800A2E0
+#define VE_RMPREDCCTL_inst_addr                                       "0x00B8"
+#define VE_RMPREDCCTL_inst                                            0x00B8
+#define VE_RMPREDCCTL_uravail_shift                                   (7)
+#define VE_RMPREDCCTL_uavail_shift                                    (6)
+#define VE_RMPREDCCTL_lavail_shift                                    (5)
+#define VE_RMPREDCCTL_imode_shift                                     (4)
+#define VE_RMPREDCCTL_weighted_pred_shift                             (3)
+#define VE_RMPREDCCTL_mb_type_shift                                   (1)
+#define VE_RMPREDCCTL_intra_shift                                     (0)
+#define VE_RMPREDCCTL_uravail_mask                                    (0x00000080)
+#define VE_RMPREDCCTL_uavail_mask                                     (0x00000040)
+#define VE_RMPREDCCTL_lavail_mask                                     (0x00000020)
+#define VE_RMPREDCCTL_imode_mask                                      (0x00000010)
+#define VE_RMPREDCCTL_weighted_pred_mask                              (0x00000008)
+#define VE_RMPREDCCTL_mb_type_mask                                    (0x00000006)
+#define VE_RMPREDCCTL_intra_mask                                      (0x00000001)
+#define VE_RMPREDCCTL_uravail(data)                                   (0x00000080&((data)<<7))
+#define VE_RMPREDCCTL_uavail(data)                                    (0x00000040&((data)<<6))
+#define VE_RMPREDCCTL_lavail(data)                                    (0x00000020&((data)<<5))
+#define VE_RMPREDCCTL_imode(data)                                     (0x00000010&((data)<<4))
+#define VE_RMPREDCCTL_weighted_pred(data)                             (0x00000008&((data)<<3))
+#define VE_RMPREDCCTL_mb_type(data)                                   (0x00000006&((data)<<1))
+#define VE_RMPREDCCTL_intra(data)                                     (0x00000001&(data))
+#define VE_RMPREDCCTL_get_uravail(data)                               ((0x00000080&(data))>>7)
+#define VE_RMPREDCCTL_get_uavail(data)                                ((0x00000040&(data))>>6)
+#define VE_RMPREDCCTL_get_lavail(data)                                ((0x00000020&(data))>>5)
+#define VE_RMPREDCCTL_get_imode(data)                                 ((0x00000010&(data))>>4)
+#define VE_RMPREDCCTL_get_weighted_pred(data)                         ((0x00000008&(data))>>3)
+#define VE_RMPREDCCTL_get_mb_type(data)                               ((0x00000006&(data))>>1)
+#define VE_RMPREDCCTL_get_intra(data)                                 (0x00000001&(data))
+
+#define VE_RMINTRAM0                                                  0x1800A2E4
+#define VE_RMINTRAM0_reg_addr                                         "0xB800A2E4"
+#define VE_RMINTRAM0_reg                                              0xB800A2E4
+#define VE_RMINTRAM0_inst_addr                                        "0x00B9"
+#define VE_RMINTRAM0_inst                                             0x00B9
+#define VE_RMINTRAM0_intrap7_shift                                    (28)
+#define VE_RMINTRAM0_intrap6_shift                                    (24)
+#define VE_RMINTRAM0_intrap5_shift                                    (20)
+#define VE_RMINTRAM0_intrap4_shift                                    (16)
+#define VE_RMINTRAM0_intrap3_shift                                    (12)
+#define VE_RMINTRAM0_intrap2_shift                                    (8)
+#define VE_RMINTRAM0_intrap1_shift                                    (4)
+#define VE_RMINTRAM0_intrap0_shift                                    (0)
+#define VE_RMINTRAM0_intrap7_mask                                     (0xF0000000)
+#define VE_RMINTRAM0_intrap6_mask                                     (0x0F000000)
+#define VE_RMINTRAM0_intrap5_mask                                     (0x00F00000)
+#define VE_RMINTRAM0_intrap4_mask                                     (0x000F0000)
+#define VE_RMINTRAM0_intrap3_mask                                     (0x0000F000)
+#define VE_RMINTRAM0_intrap2_mask                                     (0x00000F00)
+#define VE_RMINTRAM0_intrap1_mask                                     (0x000000F0)
+#define VE_RMINTRAM0_intrap0_mask                                     (0x0000000F)
+#define VE_RMINTRAM0_intrap7(data)                                    (0xF0000000&((data)<<28))
+#define VE_RMINTRAM0_intrap6(data)                                    (0x0F000000&((data)<<24))
+#define VE_RMINTRAM0_intrap5(data)                                    (0x00F00000&((data)<<20))
+#define VE_RMINTRAM0_intrap4(data)                                    (0x000F0000&((data)<<16))
+#define VE_RMINTRAM0_intrap3(data)                                    (0x0000F000&((data)<<12))
+#define VE_RMINTRAM0_intrap2(data)                                    (0x00000F00&((data)<<8))
+#define VE_RMINTRAM0_intrap1(data)                                    (0x000000F0&((data)<<4))
+#define VE_RMINTRAM0_intrap0(data)                                    (0x0000000F&(data))
+#define VE_RMINTRAM0_get_intrap7(data)                                ((0xF0000000&(data))>>28)
+#define VE_RMINTRAM0_get_intrap6(data)                                ((0x0F000000&(data))>>24)
+#define VE_RMINTRAM0_get_intrap5(data)                                ((0x00F00000&(data))>>20)
+#define VE_RMINTRAM0_get_intrap4(data)                                ((0x000F0000&(data))>>16)
+#define VE_RMINTRAM0_get_intrap3(data)                                ((0x0000F000&(data))>>12)
+#define VE_RMINTRAM0_get_intrap2(data)                                ((0x00000F00&(data))>>8)
+#define VE_RMINTRAM0_get_intrap1(data)                                ((0x000000F0&(data))>>4)
+#define VE_RMINTRAM0_get_intrap0(data)                                (0x0000000F&(data))
+
+#define VE_RMINTRAM1                                                  0x1800A2E8
+#define VE_RMINTRAM1_reg_addr                                         "0xB800A2E8"
+#define VE_RMINTRAM1_reg                                              0xB800A2E8
+#define VE_RMINTRAM1_inst_addr                                        "0x00BA"
+#define VE_RMINTRAM1_inst                                             0x00BA
+#define VE_RMINTRAM1_intrap15_shift                                   (28)
+#define VE_RMINTRAM1_intrap14_shift                                   (24)
+#define VE_RMINTRAM1_intrap13_shift                                   (20)
+#define VE_RMINTRAM1_intrap12_shift                                   (16)
+#define VE_RMINTRAM1_intrap11_shift                                   (12)
+#define VE_RMINTRAM1_intrap10_shift                                   (8)
+#define VE_RMINTRAM1_intrap9_shift                                    (4)
+#define VE_RMINTRAM1_intrap8_shift                                    (0)
+#define VE_RMINTRAM1_intrap15_mask                                    (0xF0000000)
+#define VE_RMINTRAM1_intrap14_mask                                    (0x0F000000)
+#define VE_RMINTRAM1_intrap13_mask                                    (0x00F00000)
+#define VE_RMINTRAM1_intrap12_mask                                    (0x000F0000)
+#define VE_RMINTRAM1_intrap11_mask                                    (0x0000F000)
+#define VE_RMINTRAM1_intrap10_mask                                    (0x00000F00)
+#define VE_RMINTRAM1_intrap9_mask                                     (0x000000F0)
+#define VE_RMINTRAM1_intrap8_mask                                     (0x0000000F)
+#define VE_RMINTRAM1_intrap15(data)                                   (0xF0000000&((data)<<28))
+#define VE_RMINTRAM1_intrap14(data)                                   (0x0F000000&((data)<<24))
+#define VE_RMINTRAM1_intrap13(data)                                   (0x00F00000&((data)<<20))
+#define VE_RMINTRAM1_intrap12(data)                                   (0x000F0000&((data)<<16))
+#define VE_RMINTRAM1_intrap11(data)                                   (0x0000F000&((data)<<12))
+#define VE_RMINTRAM1_intrap10(data)                                   (0x00000F00&((data)<<8))
+#define VE_RMINTRAM1_intrap9(data)                                    (0x000000F0&((data)<<4))
+#define VE_RMINTRAM1_intrap8(data)                                    (0x0000000F&(data))
+#define VE_RMINTRAM1_get_intrap15(data)                               ((0xF0000000&(data))>>28)
+#define VE_RMINTRAM1_get_intrap14(data)                               ((0x0F000000&(data))>>24)
+#define VE_RMINTRAM1_get_intrap13(data)                               ((0x00F00000&(data))>>20)
+#define VE_RMINTRAM1_get_intrap12(data)                               ((0x000F0000&(data))>>16)
+#define VE_RMINTRAM1_get_intrap11(data)                               ((0x0000F000&(data))>>12)
+#define VE_RMINTRAM1_get_intrap10(data)                               ((0x00000F00&(data))>>8)
+#define VE_RMINTRAM1_get_intrap9(data)                                ((0x000000F0&(data))>>4)
+#define VE_RMINTRAM1_get_intrap8(data)                                (0x0000000F&(data))
+
+#define VE_RMCOEFF                                                    0x1800A2EC
+#define VE_RMCOEFF_reg_addr                                           "0xB800A2EC"
+#define VE_RMCOEFF_reg                                                0xB800A2EC
+#define VE_RMCOEFF_inst_addr                                          "0x00BB"
+#define VE_RMCOEFF_inst                                               0x00BB
+#define VE_RMCOEFF_coeff1_shift                                       (16)
+#define VE_RMCOEFF_coeff0_shift                                       (0)
+#define VE_RMCOEFF_coeff1_mask                                        (0x3FFF0000)
+#define VE_RMCOEFF_coeff0_mask                                        (0x00003FFF)
+#define VE_RMCOEFF_coeff1(data)                                       (0x3FFF0000&((data)<<16))
+#define VE_RMCOEFF_coeff0(data)                                       (0x00003FFF&(data))
+#define VE_RMCOEFF_get_coeff1(data)                                   ((0x3FFF0000&(data))>>16)
+#define VE_RMCOEFF_get_coeff0(data)                                   (0x00003FFF&(data))
+
+#define VE_PHASE_INIT_0                                               0x1800A400
+#define VE_PHASE_INIT_1                                               0x1800A404
+#define VE_PHASE_INIT_2                                               0x1800A408
+#define VE_PHASE_INIT_3                                               0x1800A40C
+#define VE_PHASE_INIT_0_reg_addr                                      "0xB800A400"
+#define VE_PHASE_INIT_1_reg_addr                                      "0xB800A404"
+#define VE_PHASE_INIT_2_reg_addr                                      "0xB800A408"
+#define VE_PHASE_INIT_3_reg_addr                                      "0xB800A40C"
+#define VE_PHASE_INIT_0_reg                                           0xB800A400
+#define VE_PHASE_INIT_1_reg                                           0xB800A404
+#define VE_PHASE_INIT_2_reg                                           0xB800A408
+#define VE_PHASE_INIT_3_reg                                           0xB800A40C
+#define VE_PHASE_INIT_0_inst_addr                                     "0x0100"
+#define VE_PHASE_INIT_0_inst                                          0x0100
+#define VE_PHASE_INIT_1_inst_addr                                     "0x0101"
+#define VE_PHASE_INIT_1_inst                                          0x0101
+#define VE_PHASE_INIT_2_inst_addr                                     "0x0102"
+#define VE_PHASE_INIT_2_inst                                          0x0102
+#define VE_PHASE_INIT_3_inst_addr                                     "0x0103"
+#define VE_PHASE_INIT_3_inst                                          0x0103
+#define VE_PHASE_INIT_init_phase_shift                                (0)
+#define VE_PHASE_INIT_init_phase_mask                                 (0x01FFFFFF)
+#define VE_PHASE_INIT_init_phase(data)                                (0x01FFFFFF&(data))
+#define VE_PHASE_INIT_get_init_phase(data)                            (0x01FFFFFF&(data))
+
+#define VE_PHASE_INC_0                                                0x1800A410
+#define VE_PHASE_INC_1                                                0x1800A414
+#define VE_PHASE_INC_2                                                0x1800A418
+#define VE_PHASE_INC_3                                                0x1800A41C
+#define VE_PHASE_INC_0_reg_addr                                       "0xB800A410"
+#define VE_PHASE_INC_1_reg_addr                                       "0xB800A414"
+#define VE_PHASE_INC_2_reg_addr                                       "0xB800A418"
+#define VE_PHASE_INC_3_reg_addr                                       "0xB800A41C"
+#define VE_PHASE_INC_0_reg                                            0xB800A410
+#define VE_PHASE_INC_1_reg                                            0xB800A414
+#define VE_PHASE_INC_2_reg                                            0xB800A418
+#define VE_PHASE_INC_3_reg                                            0xB800A41C
+#define VE_PHASE_INC_0_inst_addr                                      "0x0104"
+#define VE_PHASE_INC_0_inst                                           0x0104
+#define VE_PHASE_INC_1_inst_addr                                      "0x0105"
+#define VE_PHASE_INC_1_inst                                           0x0105
+#define VE_PHASE_INC_2_inst_addr                                      "0x0106"
+#define VE_PHASE_INC_2_inst                                           0x0106
+#define VE_PHASE_INC_3_inst_addr                                      "0x0107"
+#define VE_PHASE_INC_3_inst                                           0x0107
+#define VE_PHASE_INC_phase_inc_shift                                  (0)
+#define VE_PHASE_INC_phase_inc_mask                                   (0x0001FFFF)
+#define VE_PHASE_INC_phase_inc(data)                                  (0x0001FFFF&(data))
+#define VE_PHASE_INC_get_phase_inc(data)                              (0x0001FFFF&(data))
+
+#define VE_PHASE_OUT_0                                                0x1800A420
+#define VE_PHASE_OUT_1                                                0x1800A424
+#define VE_PHASE_OUT_2                                                0x1800A428
+#define VE_PHASE_OUT_3                                                0x1800A42C
+#define VE_PHASE_OUT_0_reg_addr                                       "0xB800A420"
+#define VE_PHASE_OUT_1_reg_addr                                       "0xB800A424"
+#define VE_PHASE_OUT_2_reg_addr                                       "0xB800A428"
+#define VE_PHASE_OUT_3_reg_addr                                       "0xB800A42C"
+#define VE_PHASE_OUT_0_reg                                            0xB800A420
+#define VE_PHASE_OUT_1_reg                                            0xB800A424
+#define VE_PHASE_OUT_2_reg                                            0xB800A428
+#define VE_PHASE_OUT_3_reg                                            0xB800A42C
+#define VE_PHASE_OUT_0_inst_addr                                      "0x0108"
+#define VE_PHASE_OUT_0_inst                                           0x0108
+#define VE_PHASE_OUT_1_inst_addr                                      "0x0109"
+#define VE_PHASE_OUT_1_inst                                           0x0109
+#define VE_PHASE_OUT_2_inst_addr                                      "0x010A"
+#define VE_PHASE_OUT_2_inst                                           0x010A
+#define VE_PHASE_OUT_3_inst_addr                                      "0x010B"
+#define VE_PHASE_OUT_3_inst                                           0x010B
+#define VE_PHASE_OUT_final_phase_shift                                (0)
+#define VE_PHASE_OUT_final_phase_mask                                 (0x01FFFFFF)
+#define VE_PHASE_OUT_final_phase(data)                                (0x01FFFFFF&(data))
+#define VE_PHASE_OUT_get_final_phase(data)                            (0x01FFFFFF&(data))
+
+#define VE_TAPCOEFF1_0                                                0x1800A430
+#define VE_TAPCOEFF1_1                                                0x1800A434
+#define VE_TAPCOEFF1_2                                                0x1800A438
+#define VE_TAPCOEFF1_3                                                0x1800A43C
+#define VE_TAPCOEFF1_4                                                0x1800A440
+#define VE_TAPCOEFF1_5                                                0x1800A444
+#define VE_TAPCOEFF1_6                                                0x1800A448
+#define VE_TAPCOEFF1_7                                                0x1800A44C
+#define VE_TAPCOEFF1_8                                                0x1800A450
+#define VE_TAPCOEFF1_9                                                0x1800A454
+#define VE_TAPCOEFF1_10                                               0x1800A458
+#define VE_TAPCOEFF1_11                                               0x1800A45C
+#define VE_TAPCOEFF1_12                                               0x1800A460
+#define VE_TAPCOEFF1_13                                               0x1800A464
+#define VE_TAPCOEFF1_14                                               0x1800A468
+#define VE_TAPCOEFF1_15                                               0x1800A46C
+#define VE_TAPCOEFF1_16                                               0x1800A470
+#define VE_TAPCOEFF1_17                                               0x1800A474
+#define VE_TAPCOEFF1_18                                               0x1800A478
+#define VE_TAPCOEFF1_19                                               0x1800A47C
+#define VE_TAPCOEFF1_20                                               0x1800A480
+#define VE_TAPCOEFF1_21                                               0x1800A484
+#define VE_TAPCOEFF1_22                                               0x1800A488
+#define VE_TAPCOEFF1_23                                               0x1800A48C
+#define VE_TAPCOEFF1_0_reg_addr                                       "0xB800A430"
+#define VE_TAPCOEFF1_1_reg_addr                                       "0xB800A434"
+#define VE_TAPCOEFF1_2_reg_addr                                       "0xB800A438"
+#define VE_TAPCOEFF1_3_reg_addr                                       "0xB800A43C"
+#define VE_TAPCOEFF1_4_reg_addr                                       "0xB800A440"
+#define VE_TAPCOEFF1_5_reg_addr                                       "0xB800A444"
+#define VE_TAPCOEFF1_6_reg_addr                                       "0xB800A448"
+#define VE_TAPCOEFF1_7_reg_addr                                       "0xB800A44C"
+#define VE_TAPCOEFF1_8_reg_addr                                       "0xB800A450"
+#define VE_TAPCOEFF1_9_reg_addr                                       "0xB800A454"
+#define VE_TAPCOEFF1_10_reg_addr                                      "0xB800A458"
+#define VE_TAPCOEFF1_11_reg_addr                                      "0xB800A45C"
+#define VE_TAPCOEFF1_12_reg_addr                                      "0xB800A460"
+#define VE_TAPCOEFF1_13_reg_addr                                      "0xB800A464"
+#define VE_TAPCOEFF1_14_reg_addr                                      "0xB800A468"
+#define VE_TAPCOEFF1_15_reg_addr                                      "0xB800A46C"
+#define VE_TAPCOEFF1_16_reg_addr                                      "0xB800A470"
+#define VE_TAPCOEFF1_17_reg_addr                                      "0xB800A474"
+#define VE_TAPCOEFF1_18_reg_addr                                      "0xB800A478"
+#define VE_TAPCOEFF1_19_reg_addr                                      "0xB800A47C"
+#define VE_TAPCOEFF1_20_reg_addr                                      "0xB800A480"
+#define VE_TAPCOEFF1_21_reg_addr                                      "0xB800A484"
+#define VE_TAPCOEFF1_22_reg_addr                                      "0xB800A488"
+#define VE_TAPCOEFF1_23_reg_addr                                      "0xB800A48C"
+#define VE_TAPCOEFF1_0_reg                                            0xB800A430
+#define VE_TAPCOEFF1_1_reg                                            0xB800A434
+#define VE_TAPCOEFF1_2_reg                                            0xB800A438
+#define VE_TAPCOEFF1_3_reg                                            0xB800A43C
+#define VE_TAPCOEFF1_4_reg                                            0xB800A440
+#define VE_TAPCOEFF1_5_reg                                            0xB800A444
+#define VE_TAPCOEFF1_6_reg                                            0xB800A448
+#define VE_TAPCOEFF1_7_reg                                            0xB800A44C
+#define VE_TAPCOEFF1_8_reg                                            0xB800A450
+#define VE_TAPCOEFF1_9_reg                                            0xB800A454
+#define VE_TAPCOEFF1_10_reg                                           0xB800A458
+#define VE_TAPCOEFF1_11_reg                                           0xB800A45C
+#define VE_TAPCOEFF1_12_reg                                           0xB800A460
+#define VE_TAPCOEFF1_13_reg                                           0xB800A464
+#define VE_TAPCOEFF1_14_reg                                           0xB800A468
+#define VE_TAPCOEFF1_15_reg                                           0xB800A46C
+#define VE_TAPCOEFF1_16_reg                                           0xB800A470
+#define VE_TAPCOEFF1_17_reg                                           0xB800A474
+#define VE_TAPCOEFF1_18_reg                                           0xB800A478
+#define VE_TAPCOEFF1_19_reg                                           0xB800A47C
+#define VE_TAPCOEFF1_20_reg                                           0xB800A480
+#define VE_TAPCOEFF1_21_reg                                           0xB800A484
+#define VE_TAPCOEFF1_22_reg                                           0xB800A488
+#define VE_TAPCOEFF1_23_reg                                           0xB800A48C
+#define VE_TAPCOEFF1_0_inst_addr                                      "0x010C"
+#define VE_TAPCOEFF1_0_inst                                           0x010C
+#define VE_TAPCOEFF1_1_inst_addr                                      "0x010D"
+#define VE_TAPCOEFF1_1_inst                                           0x010D
+#define VE_TAPCOEFF1_2_inst_addr                                      "0x010E"
+#define VE_TAPCOEFF1_2_inst                                           0x010E
+#define VE_TAPCOEFF1_3_inst_addr                                      "0x010F"
+#define VE_TAPCOEFF1_3_inst                                           0x010F
+#define VE_TAPCOEFF1_4_inst_addr                                      "0x0110"
+#define VE_TAPCOEFF1_4_inst                                           0x0110
+#define VE_TAPCOEFF1_5_inst_addr                                      "0x0111"
+#define VE_TAPCOEFF1_5_inst                                           0x0111
+#define VE_TAPCOEFF1_6_inst_addr                                      "0x0112"
+#define VE_TAPCOEFF1_6_inst                                           0x0112
+#define VE_TAPCOEFF1_7_inst_addr                                      "0x0113"
+#define VE_TAPCOEFF1_7_inst                                           0x0113
+#define VE_TAPCOEFF1_8_inst_addr                                      "0x0114"
+#define VE_TAPCOEFF1_8_inst                                           0x0114
+#define VE_TAPCOEFF1_9_inst_addr                                      "0x0115"
+#define VE_TAPCOEFF1_9_inst                                           0x0115
+#define VE_TAPCOEFF1_10_inst_addr                                     "0x0116"
+#define VE_TAPCOEFF1_10_inst                                          0x0116
+#define VE_TAPCOEFF1_11_inst_addr                                     "0x0117"
+#define VE_TAPCOEFF1_11_inst                                          0x0117
+#define VE_TAPCOEFF1_12_inst_addr                                     "0x0118"
+#define VE_TAPCOEFF1_12_inst                                          0x0118
+#define VE_TAPCOEFF1_13_inst_addr                                     "0x0119"
+#define VE_TAPCOEFF1_13_inst                                          0x0119
+#define VE_TAPCOEFF1_14_inst_addr                                     "0x011A"
+#define VE_TAPCOEFF1_14_inst                                          0x011A
+#define VE_TAPCOEFF1_15_inst_addr                                     "0x011B"
+#define VE_TAPCOEFF1_15_inst                                          0x011B
+#define VE_TAPCOEFF1_16_inst_addr                                     "0x011C"
+#define VE_TAPCOEFF1_16_inst                                          0x011C
+#define VE_TAPCOEFF1_17_inst_addr                                     "0x011D"
+#define VE_TAPCOEFF1_17_inst                                          0x011D
+#define VE_TAPCOEFF1_18_inst_addr                                     "0x011E"
+#define VE_TAPCOEFF1_18_inst                                          0x011E
+#define VE_TAPCOEFF1_19_inst_addr                                     "0x011F"
+#define VE_TAPCOEFF1_19_inst                                          0x011F
+#define VE_TAPCOEFF1_20_inst_addr                                     "0x0120"
+#define VE_TAPCOEFF1_20_inst                                          0x0120
+#define VE_TAPCOEFF1_21_inst_addr                                     "0x0121"
+#define VE_TAPCOEFF1_21_inst                                          0x0121
+#define VE_TAPCOEFF1_22_inst_addr                                     "0x0122"
+#define VE_TAPCOEFF1_22_inst                                          0x0122
+#define VE_TAPCOEFF1_23_inst_addr                                     "0x0123"
+#define VE_TAPCOEFF1_23_inst                                          0x0123
+#define VE_TAPCOEFF1_coeffnplus1_shift                                (16)
+#define VE_TAPCOEFF1_coeffn_shift                                     (0)
+#define VE_TAPCOEFF1_coeffnplus1_mask                                 (0x3FFF0000)
+#define VE_TAPCOEFF1_coeffn_mask                                      (0x00003FFF)
+#define VE_TAPCOEFF1_coeffnplus1(data)                                (0x3FFF0000&((data)<<16))
+#define VE_TAPCOEFF1_coeffn(data)                                     (0x00003FFF&(data))
+#define VE_TAPCOEFF1_get_coeffnplus1(data)                            ((0x3FFF0000&(data))>>16)
+#define VE_TAPCOEFF1_get_coeffn(data)                                 (0x00003FFF&(data))
+
+#define VE_TAPCOEFF2_0                                                0x1800A490
+#define VE_TAPCOEFF2_1                                                0x1800A494
+#define VE_TAPCOEFF2_2                                                0x1800A498
+#define VE_TAPCOEFF2_3                                                0x1800A49C
+#define VE_TAPCOEFF2_4                                                0x1800A4A0
+#define VE_TAPCOEFF2_5                                                0x1800A4A4
+#define VE_TAPCOEFF2_6                                                0x1800A4A8
+#define VE_TAPCOEFF2_7                                                0x1800A4AC
+#define VE_TAPCOEFF2_8                                                0x1800A4B0
+#define VE_TAPCOEFF2_9                                                0x1800A4B4
+#define VE_TAPCOEFF2_10                                               0x1800A4B8
+#define VE_TAPCOEFF2_11                                               0x1800A4BC
+#define VE_TAPCOEFF2_12                                               0x1800A4C0
+#define VE_TAPCOEFF2_13                                               0x1800A4C4
+#define VE_TAPCOEFF2_14                                               0x1800A4C8
+#define VE_TAPCOEFF2_15                                               0x1800A4CC
+#define VE_TAPCOEFF2_16                                               0x1800A4D0
+#define VE_TAPCOEFF2_17                                               0x1800A4D4
+#define VE_TAPCOEFF2_18                                               0x1800A4D8
+#define VE_TAPCOEFF2_19                                               0x1800A4DC
+#define VE_TAPCOEFF2_20                                               0x1800A4E0
+#define VE_TAPCOEFF2_21                                               0x1800A4E4
+#define VE_TAPCOEFF2_22                                               0x1800A4E8
+#define VE_TAPCOEFF2_23                                               0x1800A4EC
+#define VE_TAPCOEFF2_0_reg_addr                                       "0xB800A490"
+#define VE_TAPCOEFF2_1_reg_addr                                       "0xB800A494"
+#define VE_TAPCOEFF2_2_reg_addr                                       "0xB800A498"
+#define VE_TAPCOEFF2_3_reg_addr                                       "0xB800A49C"
+#define VE_TAPCOEFF2_4_reg_addr                                       "0xB800A4A0"
+#define VE_TAPCOEFF2_5_reg_addr                                       "0xB800A4A4"
+#define VE_TAPCOEFF2_6_reg_addr                                       "0xB800A4A8"
+#define VE_TAPCOEFF2_7_reg_addr                                       "0xB800A4AC"
+#define VE_TAPCOEFF2_8_reg_addr                                       "0xB800A4B0"
+#define VE_TAPCOEFF2_9_reg_addr                                       "0xB800A4B4"
+#define VE_TAPCOEFF2_10_reg_addr                                      "0xB800A4B8"
+#define VE_TAPCOEFF2_11_reg_addr                                      "0xB800A4BC"
+#define VE_TAPCOEFF2_12_reg_addr                                      "0xB800A4C0"
+#define VE_TAPCOEFF2_13_reg_addr                                      "0xB800A4C4"
+#define VE_TAPCOEFF2_14_reg_addr                                      "0xB800A4C8"
+#define VE_TAPCOEFF2_15_reg_addr                                      "0xB800A4CC"
+#define VE_TAPCOEFF2_16_reg_addr                                      "0xB800A4D0"
+#define VE_TAPCOEFF2_17_reg_addr                                      "0xB800A4D4"
+#define VE_TAPCOEFF2_18_reg_addr                                      "0xB800A4D8"
+#define VE_TAPCOEFF2_19_reg_addr                                      "0xB800A4DC"
+#define VE_TAPCOEFF2_20_reg_addr                                      "0xB800A4E0"
+#define VE_TAPCOEFF2_21_reg_addr                                      "0xB800A4E4"
+#define VE_TAPCOEFF2_22_reg_addr                                      "0xB800A4E8"
+#define VE_TAPCOEFF2_23_reg_addr                                      "0xB800A4EC"
+#define VE_TAPCOEFF2_0_reg                                            0xB800A490
+#define VE_TAPCOEFF2_1_reg                                            0xB800A494
+#define VE_TAPCOEFF2_2_reg                                            0xB800A498
+#define VE_TAPCOEFF2_3_reg                                            0xB800A49C
+#define VE_TAPCOEFF2_4_reg                                            0xB800A4A0
+#define VE_TAPCOEFF2_5_reg                                            0xB800A4A4
+#define VE_TAPCOEFF2_6_reg                                            0xB800A4A8
+#define VE_TAPCOEFF2_7_reg                                            0xB800A4AC
+#define VE_TAPCOEFF2_8_reg                                            0xB800A4B0
+#define VE_TAPCOEFF2_9_reg                                            0xB800A4B4
+#define VE_TAPCOEFF2_10_reg                                           0xB800A4B8
+#define VE_TAPCOEFF2_11_reg                                           0xB800A4BC
+#define VE_TAPCOEFF2_12_reg                                           0xB800A4C0
+#define VE_TAPCOEFF2_13_reg                                           0xB800A4C4
+#define VE_TAPCOEFF2_14_reg                                           0xB800A4C8
+#define VE_TAPCOEFF2_15_reg                                           0xB800A4CC
+#define VE_TAPCOEFF2_16_reg                                           0xB800A4D0
+#define VE_TAPCOEFF2_17_reg                                           0xB800A4D4
+#define VE_TAPCOEFF2_18_reg                                           0xB800A4D8
+#define VE_TAPCOEFF2_19_reg                                           0xB800A4DC
+#define VE_TAPCOEFF2_20_reg                                           0xB800A4E0
+#define VE_TAPCOEFF2_21_reg                                           0xB800A4E4
+#define VE_TAPCOEFF2_22_reg                                           0xB800A4E8
+#define VE_TAPCOEFF2_23_reg                                           0xB800A4EC
+#define VE_TAPCOEFF2_0_inst_addr                                      "0x0124"
+#define VE_TAPCOEFF2_0_inst                                           0x0124
+#define VE_TAPCOEFF2_1_inst_addr                                      "0x0125"
+#define VE_TAPCOEFF2_1_inst                                           0x0125
+#define VE_TAPCOEFF2_2_inst_addr                                      "0x0126"
+#define VE_TAPCOEFF2_2_inst                                           0x0126
+#define VE_TAPCOEFF2_3_inst_addr                                      "0x0127"
+#define VE_TAPCOEFF2_3_inst                                           0x0127
+#define VE_TAPCOEFF2_4_inst_addr                                      "0x0128"
+#define VE_TAPCOEFF2_4_inst                                           0x0128
+#define VE_TAPCOEFF2_5_inst_addr                                      "0x0129"
+#define VE_TAPCOEFF2_5_inst                                           0x0129
+#define VE_TAPCOEFF2_6_inst_addr                                      "0x012A"
+#define VE_TAPCOEFF2_6_inst                                           0x012A
+#define VE_TAPCOEFF2_7_inst_addr                                      "0x012B"
+#define VE_TAPCOEFF2_7_inst                                           0x012B
+#define VE_TAPCOEFF2_8_inst_addr                                      "0x012C"
+#define VE_TAPCOEFF2_8_inst                                           0x012C
+#define VE_TAPCOEFF2_9_inst_addr                                      "0x012D"
+#define VE_TAPCOEFF2_9_inst                                           0x012D
+#define VE_TAPCOEFF2_10_inst_addr                                     "0x012E"
+#define VE_TAPCOEFF2_10_inst                                          0x012E
+#define VE_TAPCOEFF2_11_inst_addr                                     "0x012F"
+#define VE_TAPCOEFF2_11_inst                                          0x012F
+#define VE_TAPCOEFF2_12_inst_addr                                     "0x0130"
+#define VE_TAPCOEFF2_12_inst                                          0x0130
+#define VE_TAPCOEFF2_13_inst_addr                                     "0x0131"
+#define VE_TAPCOEFF2_13_inst                                          0x0131
+#define VE_TAPCOEFF2_14_inst_addr                                     "0x0132"
+#define VE_TAPCOEFF2_14_inst                                          0x0132
+#define VE_TAPCOEFF2_15_inst_addr                                     "0x0133"
+#define VE_TAPCOEFF2_15_inst                                          0x0133
+#define VE_TAPCOEFF2_16_inst_addr                                     "0x0134"
+#define VE_TAPCOEFF2_16_inst                                          0x0134
+#define VE_TAPCOEFF2_17_inst_addr                                     "0x0135"
+#define VE_TAPCOEFF2_17_inst                                          0x0135
+#define VE_TAPCOEFF2_18_inst_addr                                     "0x0136"
+#define VE_TAPCOEFF2_18_inst                                          0x0136
+#define VE_TAPCOEFF2_19_inst_addr                                     "0x0137"
+#define VE_TAPCOEFF2_19_inst                                          0x0137
+#define VE_TAPCOEFF2_20_inst_addr                                     "0x0138"
+#define VE_TAPCOEFF2_20_inst                                          0x0138
+#define VE_TAPCOEFF2_21_inst_addr                                     "0x0139"
+#define VE_TAPCOEFF2_21_inst                                          0x0139
+#define VE_TAPCOEFF2_22_inst_addr                                     "0x013A"
+#define VE_TAPCOEFF2_22_inst                                          0x013A
+#define VE_TAPCOEFF2_23_inst_addr                                     "0x013B"
+#define VE_TAPCOEFF2_23_inst                                          0x013B
+#define VE_TAPCOEFF2_coeffnplus1_shift                                (16)
+#define VE_TAPCOEFF2_coeffn_shift                                     (0)
+#define VE_TAPCOEFF2_coeffnplus1_mask                                 (0x3FFF0000)
+#define VE_TAPCOEFF2_coeffn_mask                                      (0x00003FFF)
+#define VE_TAPCOEFF2_coeffnplus1(data)                                (0x3FFF0000&((data)<<16))
+#define VE_TAPCOEFF2_coeffn(data)                                     (0x00003FFF&(data))
+#define VE_TAPCOEFF2_get_coeffnplus1(data)                            ((0x3FFF0000&(data))>>16)
+#define VE_TAPCOEFF2_get_coeffn(data)                                 (0x00003FFF&(data))
+
+#define VE_RMRPR_CNTL                                                 0x1800A2F0
+#define VE_RMRPR_CNTL_reg_addr                                        "0xB800A2F0"
+#define VE_RMRPR_CNTL_reg                                             0xB800A2F0
+#define VE_RMRPR_CNTL_inst_addr                                       "0x00BC"
+#define VE_RMRPR_CNTL_inst                                            0x00BC
+#define VE_RMRPR_CNTL_rcrpr_shift                                     (26)
+#define VE_RMRPR_CNTL_color_cr_shift                                  (18)
+#define VE_RMRPR_CNTL_color_cb_shift                                  (10)
+#define VE_RMRPR_CNTL_color_y_shift                                   (2)
+#define VE_RMRPR_CNTL_fill_mode_shift                                 (0)
+#define VE_RMRPR_CNTL_rcrpr_mask                                      (0x04000000)
+#define VE_RMRPR_CNTL_color_cr_mask                                   (0x03FC0000)
+#define VE_RMRPR_CNTL_color_cb_mask                                   (0x0003FC00)
+#define VE_RMRPR_CNTL_color_y_mask                                    (0x000003FC)
+#define VE_RMRPR_CNTL_fill_mode_mask                                  (0x00000003)
+#define VE_RMRPR_CNTL_rcrpr(data)                                     (0x04000000&((data)<<26))
+#define VE_RMRPR_CNTL_color_cr(data)                                  (0x03FC0000&((data)<<18))
+#define VE_RMRPR_CNTL_color_cb(data)                                  (0x0003FC00&((data)<<10))
+#define VE_RMRPR_CNTL_color_y(data)                                   (0x000003FC&((data)<<2))
+#define VE_RMRPR_CNTL_fill_mode(data)                                 (0x00000003&(data))
+#define VE_RMRPR_CNTL_get_rcrpr(data)                                 ((0x04000000&(data))>>26)
+#define VE_RMRPR_CNTL_get_color_cr(data)                              ((0x03FC0000&(data))>>18)
+#define VE_RMRPR_CNTL_get_color_cb(data)                              ((0x0003FC00&(data))>>10)
+#define VE_RMRPR_CNTL_get_color_y(data)                               ((0x000003FC&(data))>>2)
+#define VE_RMRPR_CNTL_get_fill_mode(data)                             (0x00000003&(data))
+
+#define VE_RMRPR_PAR                                                  0x1800A2F4
+#define VE_RMRPR_PAR_reg_addr                                         "0xB800A2F4"
+#define VE_RMRPR_PAR_reg                                              0xB800A2F4
+#define VE_RMRPR_PAR_inst_addr                                        "0x00BD"
+#define VE_RMRPR_PAR_inst                                             0x00BD
+#define VE_RMRPR_PAR_m_shift                                          (11)
+#define VE_RMRPR_PAR_pixel_offset_shift                               (0)
+#define VE_RMRPR_PAR_m_mask                                           (0x00007800)
+#define VE_RMRPR_PAR_pixel_offset_mask                                (0x000007FF)
+#define VE_RMRPR_PAR_m(data)                                          (0x00007800&((data)<<11))
+#define VE_RMRPR_PAR_pixel_offset(data)                               (0x000007FF&(data))
+#define VE_RMRPR_PAR_get_m(data)                                      ((0x00007800&(data))>>11)
+#define VE_RMRPR_PAR_get_pixel_offset(data)                           (0x000007FF&(data))
+
+#define VE_RMRPR_AX                                                   0x1800A2F8
+#define VE_RMRPR_AX_reg_addr                                          "0xB800A2F8"
+#define VE_RMRPR_AX_reg                                               0xB800A2F8
+#define VE_RMRPR_AX_inst_addr                                         "0x00BE"
+#define VE_RMRPR_AX_inst                                              0x00BE
+#define VE_RMRPR_AX_ax_shift                                          (0)
+#define VE_RMRPR_AX_ax_mask                                           (0xFFFFFFFF)
+#define VE_RMRPR_AX_ax(data)                                          (0xFFFFFFFF&(data))
+#define VE_RMRPR_AX_get_ax(data)                                      (0xFFFFFFFF&(data))
+
+#define VE_RMRPR_AY                                                   0x1800A2FC
+#define VE_RMRPR_AY_reg_addr                                          "0xB800A2FC"
+#define VE_RMRPR_AY_reg                                               0xB800A2FC
+#define VE_RMRPR_AY_inst_addr                                         "0x00BF"
+#define VE_RMRPR_AY_inst                                              0x00BF
+#define VE_RMRPR_AY_ay_shift                                          (0)
+#define VE_RMRPR_AY_ay_mask                                           (0xFFFFFFFF)
+#define VE_RMRPR_AY_ay(data)                                          (0xFFFFFFFF&(data))
+#define VE_RMRPR_AY_get_ay(data)                                      (0xFFFFFFFF&(data))
+
+#define VE_RMRPR_AXINC                                                0x1800A4F0
+#define VE_RMRPR_AXINC_reg_addr                                       "0xB800A4F0"
+#define VE_RMRPR_AXINC_reg                                            0xB800A4F0
+#define VE_RMRPR_AXINC_inst_addr                                      "0x013C"
+#define VE_RMRPR_AXINC_inst                                           0x013C
+#define VE_RMRPR_AXINC_ax_inc_shift                                   (0)
+#define VE_RMRPR_AXINC_ax_inc_mask                                    (0xFFFFFFFF)
+#define VE_RMRPR_AXINC_ax_inc(data)                                   (0xFFFFFFFF&(data))
+#define VE_RMRPR_AXINC_get_ax_inc(data)                               (0xFFFFFFFF&(data))
+
+#define VE_RMRPR_PICINFO                                              0x1800A4F4
+#define VE_RMRPR_PICINFO_reg_addr                                     "0xB800A4F4"
+#define VE_RMRPR_PICINFO_reg                                          0xB800A4F4
+#define VE_RMRPR_PICINFO_inst_addr                                    "0x013D"
+#define VE_RMRPR_PICINFO_inst                                         0x013D
+#define VE_RMRPR_PICINFO_picmb_h_shift                                (7)
+#define VE_RMRPR_PICINFO_picmb_w_shift                                (0)
+#define VE_RMRPR_PICINFO_picmb_h_mask                                 (0x00001F80)
+#define VE_RMRPR_PICINFO_picmb_w_mask                                 (0x0000007F)
+#define VE_RMRPR_PICINFO_picmb_h(data)                                (0x00001F80&((data)<<7))
+#define VE_RMRPR_PICINFO_picmb_w(data)                                (0x0000007F&(data))
+#define VE_RMRPR_PICINFO_get_picmb_h(data)                            ((0x00001F80&(data))>>7)
+#define VE_RMRPR_PICINFO_get_picmb_w(data)                            (0x0000007F&(data))
+
+#define VE_BASEA_0                                                    0x1800A280
+#define VE_BASEA_1                                                    0x1800A284
+#define VE_BASEA_2                                                    0x1800A288
+#define VE_BASEA_3                                                    0x1800A28C
+#define VE_BASEA_0_reg_addr                                           "0xB800A280"
+#define VE_BASEA_1_reg_addr                                           "0xB800A284"
+#define VE_BASEA_2_reg_addr                                           "0xB800A288"
+#define VE_BASEA_3_reg_addr                                           "0xB800A28C"
+#define VE_BASEA_0_reg                                                0xB800A280
+#define VE_BASEA_1_reg                                                0xB800A284
+#define VE_BASEA_2_reg                                                0xB800A288
+#define VE_BASEA_3_reg                                                0xB800A28C
+#define VE_BASEA_0_inst_addr                                          "0x00A0"
+#define VE_BASEA_0_inst                                               0x00A0
+#define VE_BASEA_1_inst_addr                                          "0x00A1"
+#define VE_BASEA_1_inst                                               0x00A1
+#define VE_BASEA_2_inst_addr                                          "0x00A2"
+#define VE_BASEA_2_inst                                               0x00A2
+#define VE_BASEA_3_inst_addr                                          "0x00A3"
+#define VE_BASEA_3_inst                                               0x00A3
+#define VE_BASEA_basea_shift                                          (0)
+#define VE_BASEA_basea_mask                                           (0x00000FFF)
+#define VE_BASEA_basea(data)                                          (0x00000FFF&(data))
+#define VE_BASEA_get_basea(data)                                      (0x00000FFF&(data))
+
+#define VE_OFFSETA_0                                                  0x1800A290
+#define VE_OFFSETA_1                                                  0x1800A294
+#define VE_OFFSETA_2                                                  0x1800A298
+#define VE_OFFSETA_3                                                  0x1800A29C
+#define VE_OFFSETA_0_reg_addr                                         "0xB800A290"
+#define VE_OFFSETA_1_reg_addr                                         "0xB800A294"
+#define VE_OFFSETA_2_reg_addr                                         "0xB800A298"
+#define VE_OFFSETA_3_reg_addr                                         "0xB800A29C"
+#define VE_OFFSETA_0_reg                                              0xB800A290
+#define VE_OFFSETA_1_reg                                              0xB800A294
+#define VE_OFFSETA_2_reg                                              0xB800A298
+#define VE_OFFSETA_3_reg                                              0xB800A29C
+#define VE_OFFSETA_0_inst_addr                                        "0x00A4"
+#define VE_OFFSETA_0_inst                                             0x00A4
+#define VE_OFFSETA_1_inst_addr                                        "0x00A5"
+#define VE_OFFSETA_1_inst                                             0x00A5
+#define VE_OFFSETA_2_inst_addr                                        "0x00A6"
+#define VE_OFFSETA_2_inst                                             0x00A6
+#define VE_OFFSETA_3_inst_addr                                        "0x00A7"
+#define VE_OFFSETA_3_inst                                             0x00A7
+#define VE_OFFSETA_offseta_shift                                      (0)
+#define VE_OFFSETA_offseta_mask                                       (0x00000FFF)
+#define VE_OFFSETA_offseta(data)                                      (0x00000FFF&(data))
+#define VE_OFFSETA_get_offseta(data)                                  (0x00000FFF&(data))
+
+#define VE_DMAREG1_0                                                  0x1800A300
+#define VE_DMAREG1_1                                                  0x1800A304
+#define VE_DMAREG1_2                                                  0x1800A308
+#define VE_DMAREG1_3                                                  0x1800A30C
+#define VE_DMAREG1_4                                                  0x1800A310
+#define VE_DMAREG1_5                                                  0x1800A314
+#define VE_DMAREG1_6                                                  0x1800A318
+#define VE_DMAREG1_7                                                  0x1800A31C
+#define VE_DMAREG1_8                                                  0x1800A320
+#define VE_DMAREG1_9                                                  0x1800A324
+#define VE_DMAREG1_10                                                 0x1800A328
+#define VE_DMAREG1_11                                                 0x1800A32C
+#define VE_DMAREG1_12                                                 0x1800A330
+#define VE_DMAREG1_13                                                 0x1800A334
+#define VE_DMAREG1_14                                                 0x1800A338
+#define VE_DMAREG1_15                                                 0x1800A33C
+#define VE_DMAREG1_0_reg_addr                                         "0xB800A300"
+#define VE_DMAREG1_1_reg_addr                                         "0xB800A304"
+#define VE_DMAREG1_2_reg_addr                                         "0xB800A308"
+#define VE_DMAREG1_3_reg_addr                                         "0xB800A30C"
+#define VE_DMAREG1_4_reg_addr                                         "0xB800A310"
+#define VE_DMAREG1_5_reg_addr                                         "0xB800A314"
+#define VE_DMAREG1_6_reg_addr                                         "0xB800A318"
+#define VE_DMAREG1_7_reg_addr                                         "0xB800A31C"
+#define VE_DMAREG1_8_reg_addr                                         "0xB800A320"
+#define VE_DMAREG1_9_reg_addr                                         "0xB800A324"
+#define VE_DMAREG1_10_reg_addr                                        "0xB800A328"
+#define VE_DMAREG1_11_reg_addr                                        "0xB800A32C"
+#define VE_DMAREG1_12_reg_addr                                        "0xB800A330"
+#define VE_DMAREG1_13_reg_addr                                        "0xB800A334"
+#define VE_DMAREG1_14_reg_addr                                        "0xB800A338"
+#define VE_DMAREG1_15_reg_addr                                        "0xB800A33C"
+#define VE_DMAREG1_0_reg                                              0xB800A300
+#define VE_DMAREG1_1_reg                                              0xB800A304
+#define VE_DMAREG1_2_reg                                              0xB800A308
+#define VE_DMAREG1_3_reg                                              0xB800A30C
+#define VE_DMAREG1_4_reg                                              0xB800A310
+#define VE_DMAREG1_5_reg                                              0xB800A314
+#define VE_DMAREG1_6_reg                                              0xB800A318
+#define VE_DMAREG1_7_reg                                              0xB800A31C
+#define VE_DMAREG1_8_reg                                              0xB800A320
+#define VE_DMAREG1_9_reg                                              0xB800A324
+#define VE_DMAREG1_10_reg                                             0xB800A328
+#define VE_DMAREG1_11_reg                                             0xB800A32C
+#define VE_DMAREG1_12_reg                                             0xB800A330
+#define VE_DMAREG1_13_reg                                             0xB800A334
+#define VE_DMAREG1_14_reg                                             0xB800A338
+#define VE_DMAREG1_15_reg                                             0xB800A33C
+#define VE_DMAREG1_0_inst_addr                                        "((0<<4)|0)"
+#define VE_DMAREG1_0_inst                                             ((0<<4)|0)
+#define VE_DMAREG1_1_inst_addr                                        "((0<<4)|1)"
+#define VE_DMAREG1_1_inst                                             ((0<<4)|1)
+#define VE_DMAREG1_2_inst_addr                                        "((0<<4)|2)"
+#define VE_DMAREG1_2_inst                                             ((0<<4)|2)
+#define VE_DMAREG1_3_inst_addr                                        "((0<<4)|3)"
+#define VE_DMAREG1_3_inst                                             ((0<<4)|3)
+#define VE_DMAREG1_4_inst_addr                                        "((0<<4)|4)"
+#define VE_DMAREG1_4_inst                                             ((0<<4)|4)
+#define VE_DMAREG1_5_inst_addr                                        "((0<<4)|5)"
+#define VE_DMAREG1_5_inst                                             ((0<<4)|5)
+#define VE_DMAREG1_6_inst_addr                                        "((0<<4)|6)"
+#define VE_DMAREG1_6_inst                                             ((0<<4)|6)
+#define VE_DMAREG1_7_inst_addr                                        "((0<<4)|7)"
+#define VE_DMAREG1_7_inst                                             ((0<<4)|7)
+#define VE_DMAREG1_8_inst_addr                                        "((0<<4)|8)"
+#define VE_DMAREG1_8_inst                                             ((0<<4)|8)
+#define VE_DMAREG1_9_inst_addr                                        "((0<<4)|9)"
+#define VE_DMAREG1_9_inst                                             ((0<<4)|9)
+#define VE_DMAREG1_10_inst_addr                                       "((0<<4)|10)"
+#define VE_DMAREG1_10_inst                                            ((0<<4)|10)
+#define VE_DMAREG1_11_inst_addr                                       "((0<<4)|11)"
+#define VE_DMAREG1_11_inst                                            ((0<<4)|11)
+#define VE_DMAREG1_12_inst_addr                                       "((0<<4)|12)"
+#define VE_DMAREG1_12_inst                                            ((0<<4)|12)
+#define VE_DMAREG1_13_inst_addr                                       "((0<<4)|13)"
+#define VE_DMAREG1_13_inst                                            ((0<<4)|13)
+#define VE_DMAREG1_14_inst_addr                                       "((0<<4)|14)"
+#define VE_DMAREG1_14_inst                                            ((0<<4)|14)
+#define VE_DMAREG1_15_inst_addr                                       "((0<<4)|15)"
+#define VE_DMAREG1_15_inst                                            ((0<<4)|15)
+#define VE_DMAREG1_x_shift                                            (14)
+#define VE_DMAREG1_y_shift                                            (0)
+#define VE_DMAREG1_x_mask                                             (0x07FFC000)
+#define VE_DMAREG1_y_mask                                             (0x00003FFF)
+#define VE_DMAREG1_x(data)                                            (0x07FFC000&((data)<<14))
+#define VE_DMAREG1_y(data)                                            (0x00003FFF&(data))
+#define VE_DMAREG1_get_x(data)                                        ((0x07FFC000&(data))>>14)
+#define VE_DMAREG1_get_y(data)                                        (0x00003FFF&(data))
+
+#define VE_DMAREG2_0                                                  0x1800A340
+#define VE_DMAREG2_1                                                  0x1800A344
+#define VE_DMAREG2_2                                                  0x1800A348
+#define VE_DMAREG2_3                                                  0x1800A34C
+#define VE_DMAREG2_4                                                  0x1800A350
+#define VE_DMAREG2_5                                                  0x1800A354
+#define VE_DMAREG2_6                                                  0x1800A358
+#define VE_DMAREG2_7                                                  0x1800A35C
+#define VE_DMAREG2_8                                                  0x1800A360
+#define VE_DMAREG2_9                                                  0x1800A364
+#define VE_DMAREG2_10                                                 0x1800A368
+#define VE_DMAREG2_11                                                 0x1800A36C
+#define VE_DMAREG2_12                                                 0x1800A370
+#define VE_DMAREG2_13                                                 0x1800A374
+#define VE_DMAREG2_14                                                 0x1800A378
+#define VE_DMAREG2_15                                                 0x1800A37C
+#define VE_DMAREG2_0_reg_addr                                         "0xB800A340"
+#define VE_DMAREG2_1_reg_addr                                         "0xB800A344"
+#define VE_DMAREG2_2_reg_addr                                         "0xB800A348"
+#define VE_DMAREG2_3_reg_addr                                         "0xB800A34C"
+#define VE_DMAREG2_4_reg_addr                                         "0xB800A350"
+#define VE_DMAREG2_5_reg_addr                                         "0xB800A354"
+#define VE_DMAREG2_6_reg_addr                                         "0xB800A358"
+#define VE_DMAREG2_7_reg_addr                                         "0xB800A35C"
+#define VE_DMAREG2_8_reg_addr                                         "0xB800A360"
+#define VE_DMAREG2_9_reg_addr                                         "0xB800A364"
+#define VE_DMAREG2_10_reg_addr                                        "0xB800A368"
+#define VE_DMAREG2_11_reg_addr                                        "0xB800A36C"
+#define VE_DMAREG2_12_reg_addr                                        "0xB800A370"
+#define VE_DMAREG2_13_reg_addr                                        "0xB800A374"
+#define VE_DMAREG2_14_reg_addr                                        "0xB800A378"
+#define VE_DMAREG2_15_reg_addr                                        "0xB800A37C"
+#define VE_DMAREG2_0_reg                                              0xB800A340
+#define VE_DMAREG2_1_reg                                              0xB800A344
+#define VE_DMAREG2_2_reg                                              0xB800A348
+#define VE_DMAREG2_3_reg                                              0xB800A34C
+#define VE_DMAREG2_4_reg                                              0xB800A350
+#define VE_DMAREG2_5_reg                                              0xB800A354
+#define VE_DMAREG2_6_reg                                              0xB800A358
+#define VE_DMAREG2_7_reg                                              0xB800A35C
+#define VE_DMAREG2_8_reg                                              0xB800A360
+#define VE_DMAREG2_9_reg                                              0xB800A364
+#define VE_DMAREG2_10_reg                                             0xB800A368
+#define VE_DMAREG2_11_reg                                             0xB800A36C
+#define VE_DMAREG2_12_reg                                             0xB800A370
+#define VE_DMAREG2_13_reg                                             0xB800A374
+#define VE_DMAREG2_14_reg                                             0xB800A378
+#define VE_DMAREG2_15_reg                                             0xB800A37C
+#define VE_DMAREG2_0_inst_addr                                        "((1<<4)|0)"
+#define VE_DMAREG2_0_inst                                             ((1<<4)|0)
+#define VE_DMAREG2_1_inst_addr                                        "((1<<4)|1)"
+#define VE_DMAREG2_1_inst                                             ((1<<4)|1)
+#define VE_DMAREG2_2_inst_addr                                        "((1<<4)|2)"
+#define VE_DMAREG2_2_inst                                             ((1<<4)|2)
+#define VE_DMAREG2_3_inst_addr                                        "((1<<4)|3)"
+#define VE_DMAREG2_3_inst                                             ((1<<4)|3)
+#define VE_DMAREG2_4_inst_addr                                        "((1<<4)|4)"
+#define VE_DMAREG2_4_inst                                             ((1<<4)|4)
+#define VE_DMAREG2_5_inst_addr                                        "((1<<4)|5)"
+#define VE_DMAREG2_5_inst                                             ((1<<4)|5)
+#define VE_DMAREG2_6_inst_addr                                        "((1<<4)|6)"
+#define VE_DMAREG2_6_inst                                             ((1<<4)|6)
+#define VE_DMAREG2_7_inst_addr                                        "((1<<4)|7)"
+#define VE_DMAREG2_7_inst                                             ((1<<4)|7)
+#define VE_DMAREG2_8_inst_addr                                        "((1<<4)|8)"
+#define VE_DMAREG2_8_inst                                             ((1<<4)|8)
+#define VE_DMAREG2_9_inst_addr                                        "((1<<4)|9)"
+#define VE_DMAREG2_9_inst                                             ((1<<4)|9)
+#define VE_DMAREG2_10_inst_addr                                       "((1<<4)|10)"
+#define VE_DMAREG2_10_inst                                            ((1<<4)|10)
+#define VE_DMAREG2_11_inst_addr                                       "((1<<4)|11)"
+#define VE_DMAREG2_11_inst                                            ((1<<4)|11)
+#define VE_DMAREG2_12_inst_addr                                       "((1<<4)|12)"
+#define VE_DMAREG2_12_inst                                            ((1<<4)|12)
+#define VE_DMAREG2_13_inst_addr                                       "((1<<4)|13)"
+#define VE_DMAREG2_13_inst                                            ((1<<4)|13)
+#define VE_DMAREG2_14_inst_addr                                       "((1<<4)|14)"
+#define VE_DMAREG2_14_inst                                            ((1<<4)|14)
+#define VE_DMAREG2_15_inst_addr                                       "((1<<4)|15)"
+#define VE_DMAREG2_15_inst                                            ((1<<4)|15)
+#define VE_DMAREG2_field_frame_shift                                  (26)
+#define VE_DMAREG2_decimated_shift                                    (24)
+#define VE_DMAREG2_bot_addr_idx_shift                                 (16)
+#define VE_DMAREG2_top_addr_idx_shift                                 (8)
+#define VE_DMAREG2_post_inc_sel_shift                                 (7)
+#define VE_DMAREG2_post_inc_shift                                     (0)
+#define VE_DMAREG2_field_frame_mask                                   (0x04000000)
+#define VE_DMAREG2_decimated_mask                                     (0x03000000)
+#define VE_DMAREG2_bot_addr_idx_mask                                  (0x003F0000)
+#define VE_DMAREG2_top_addr_idx_mask                                  (0x00003F00)
+#define VE_DMAREG2_post_inc_sel_mask                                  (0x00000080)
+#define VE_DMAREG2_post_inc_mask                                      (0x0000003F)
+#define VE_DMAREG2_field_frame(data)                                  (0x04000000&((data)<<26))
+#define VE_DMAREG2_decimated(data)                                    (0x03000000&((data)<<24))
+#define VE_DMAREG2_bot_addr_idx(data)                                 (0x003F0000&((data)<<16))
+#define VE_DMAREG2_top_addr_idx(data)                                 (0x00003F00&((data)<<8))
+#define VE_DMAREG2_post_inc_sel(data)                                 (0x00000080&((data)<<7))
+#define VE_DMAREG2_post_inc(data)                                     (0x0000003F&(data))
+#define VE_DMAREG2_get_field_frame(data)                              ((0x04000000&(data))>>26)
+#define VE_DMAREG2_get_decimated(data)                                ((0x03000000&(data))>>24)
+#define VE_DMAREG2_get_bot_addr_idx(data)                             ((0x003F0000&(data))>>16)
+#define VE_DMAREG2_get_top_addr_idx(data)                             ((0x00003F00&(data))>>8)
+#define VE_DMAREG2_get_post_inc_sel(data)                             ((0x00000080&(data))>>7)
+#define VE_DMAREG2_get_post_inc(data)                                 (0x0000003F&(data))
+
+#define VE_DMAREG3_0                                                  0x1800A380
+#define VE_DMAREG3_1                                                  0x1800A384
+#define VE_DMAREG3_2                                                  0x1800A388
+#define VE_DMAREG3_3                                                  0x1800A38C
+#define VE_DMAREG3_4                                                  0x1800A390
+#define VE_DMAREG3_5                                                  0x1800A394
+#define VE_DMAREG3_6                                                  0x1800A398
+#define VE_DMAREG3_7                                                  0x1800A39C
+#define VE_DMAREG3_8                                                  0x1800A3A0
+#define VE_DMAREG3_9                                                  0x1800A3A4
+#define VE_DMAREG3_10                                                 0x1800A3A8
+#define VE_DMAREG3_11                                                 0x1800A3AC
+#define VE_DMAREG3_12                                                 0x1800A3B0
+#define VE_DMAREG3_13                                                 0x1800A3B4
+#define VE_DMAREG3_14                                                 0x1800A3B8
+#define VE_DMAREG3_15                                                 0x1800A3BC
+#define VE_DMAREG3_0_reg_addr                                         "0xB800A380"
+#define VE_DMAREG3_1_reg_addr                                         "0xB800A384"
+#define VE_DMAREG3_2_reg_addr                                         "0xB800A388"
+#define VE_DMAREG3_3_reg_addr                                         "0xB800A38C"
+#define VE_DMAREG3_4_reg_addr                                         "0xB800A390"
+#define VE_DMAREG3_5_reg_addr                                         "0xB800A394"
+#define VE_DMAREG3_6_reg_addr                                         "0xB800A398"
+#define VE_DMAREG3_7_reg_addr                                         "0xB800A39C"
+#define VE_DMAREG3_8_reg_addr                                         "0xB800A3A0"
+#define VE_DMAREG3_9_reg_addr                                         "0xB800A3A4"
+#define VE_DMAREG3_10_reg_addr                                        "0xB800A3A8"
+#define VE_DMAREG3_11_reg_addr                                        "0xB800A3AC"
+#define VE_DMAREG3_12_reg_addr                                        "0xB800A3B0"
+#define VE_DMAREG3_13_reg_addr                                        "0xB800A3B4"
+#define VE_DMAREG3_14_reg_addr                                        "0xB800A3B8"
+#define VE_DMAREG3_15_reg_addr                                        "0xB800A3BC"
+#define VE_DMAREG3_0_reg                                              0xB800A380
+#define VE_DMAREG3_1_reg                                              0xB800A384
+#define VE_DMAREG3_2_reg                                              0xB800A388
+#define VE_DMAREG3_3_reg                                              0xB800A38C
+#define VE_DMAREG3_4_reg                                              0xB800A390
+#define VE_DMAREG3_5_reg                                              0xB800A394
+#define VE_DMAREG3_6_reg                                              0xB800A398
+#define VE_DMAREG3_7_reg                                              0xB800A39C
+#define VE_DMAREG3_8_reg                                              0xB800A3A0
+#define VE_DMAREG3_9_reg                                              0xB800A3A4
+#define VE_DMAREG3_10_reg                                             0xB800A3A8
+#define VE_DMAREG3_11_reg                                             0xB800A3AC
+#define VE_DMAREG3_12_reg                                             0xB800A3B0
+#define VE_DMAREG3_13_reg                                             0xB800A3B4
+#define VE_DMAREG3_14_reg                                             0xB800A3B8
+#define VE_DMAREG3_15_reg                                             0xB800A3BC
+#define VE_DMAREG3_0_inst_addr                                        "((2<<4)|0)"
+#define VE_DMAREG3_0_inst                                             ((2<<4)|0)
+#define VE_DMAREG3_1_inst_addr                                        "((2<<4)|1)"
+#define VE_DMAREG3_1_inst                                             ((2<<4)|1)
+#define VE_DMAREG3_2_inst_addr                                        "((2<<4)|2)"
+#define VE_DMAREG3_2_inst                                             ((2<<4)|2)
+#define VE_DMAREG3_3_inst_addr                                        "((2<<4)|3)"
+#define VE_DMAREG3_3_inst                                             ((2<<4)|3)
+#define VE_DMAREG3_4_inst_addr                                        "((2<<4)|4)"
+#define VE_DMAREG3_4_inst                                             ((2<<4)|4)
+#define VE_DMAREG3_5_inst_addr                                        "((2<<4)|5)"
+#define VE_DMAREG3_5_inst                                             ((2<<4)|5)
+#define VE_DMAREG3_6_inst_addr                                        "((2<<4)|6)"
+#define VE_DMAREG3_6_inst                                             ((2<<4)|6)
+#define VE_DMAREG3_7_inst_addr                                        "((2<<4)|7)"
+#define VE_DMAREG3_7_inst                                             ((2<<4)|7)
+#define VE_DMAREG3_8_inst_addr                                        "((2<<4)|8)"
+#define VE_DMAREG3_8_inst                                             ((2<<4)|8)
+#define VE_DMAREG3_9_inst_addr                                        "((2<<4)|9)"
+#define VE_DMAREG3_9_inst                                             ((2<<4)|9)
+#define VE_DMAREG3_10_inst_addr                                       "((2<<4)|10)"
+#define VE_DMAREG3_10_inst                                            ((2<<4)|10)
+#define VE_DMAREG3_11_inst_addr                                       "((2<<4)|11)"
+#define VE_DMAREG3_11_inst                                            ((2<<4)|11)
+#define VE_DMAREG3_12_inst_addr                                       "((2<<4)|12)"
+#define VE_DMAREG3_12_inst                                            ((2<<4)|12)
+#define VE_DMAREG3_13_inst_addr                                       "((2<<4)|13)"
+#define VE_DMAREG3_13_inst                                            ((2<<4)|13)
+#define VE_DMAREG3_14_inst_addr                                       "((2<<4)|14)"
+#define VE_DMAREG3_14_inst                                            ((2<<4)|14)
+#define VE_DMAREG3_15_inst_addr                                       "((2<<4)|15)"
+#define VE_DMAREG3_15_inst                                            ((2<<4)|15)
+#define VE_DMAREG3_line_off_shift                                     (28)
+#define VE_DMAREG3_vm_pitch_shift                                     (21)
+#define VE_DMAREG3_vm_addr_shift                                      (12)
+#define VE_DMAREG3_h_shift                                            (6)
+#define VE_DMAREG3_w_shift                                            (0)
+#define VE_DMAREG3_line_off_mask                                      (0x10000000)
+#define VE_DMAREG3_vm_pitch_mask                                      (0x0FE00000)
+#define VE_DMAREG3_vm_addr_mask                                       (0x001FF000)
+#define VE_DMAREG3_h_mask                                             (0x00000FC0)
+#define VE_DMAREG3_w_mask                                             (0x0000003F)
+#define VE_DMAREG3_line_off(data)                                     (0x10000000&((data)<<28))
+#define VE_DMAREG3_vm_pitch(data)                                     (0x0FE00000&((data)<<21))
+#define VE_DMAREG3_vm_addr(data)                                      (0x001FF000&((data)<<12))
+#define VE_DMAREG3_h(data)                                            (0x00000FC0&((data)<<6))
+#define VE_DMAREG3_w(data)                                            (0x0000003F&(data))
+#define VE_DMAREG3_get_line_off(data)                                 ((0x10000000&(data))>>28)
+#define VE_DMAREG3_get_vm_pitch(data)                                 ((0x0FE00000&(data))>>21)
+#define VE_DMAREG3_get_vm_addr(data)                                  ((0x001FF000&(data))>>12)
+#define VE_DMAREG3_get_h(data)                                        ((0x00000FC0&(data))>>6)
+#define VE_DMAREG3_get_w(data)                                        (0x0000003F&(data))
+
+#define VE_VMCNTL                                                     0x1800A3C0
+#define VE_VMCNTL_reg_addr                                            "0xB800A3C0"
+#define VE_VMCNTL_reg                                                 0xB800A3C0
+#define VE_VMCNTL_inst_addr                                           "(3<<4)"
+#define VE_VMCNTL_inst                                                (3<<4)
+#define VE_VMCNTL_write_enable3_shift                                 (26)
+#define VE_VMCNTL_q_sample_shift                                      (25)
+#define VE_VMCNTL_write_enable2_shift                                 (24)
+#define VE_VMCNTL_rnd_cntl_shift                                      (23)
+#define VE_VMCNTL_write_enable1_shift                                 (22)
+#define VE_VMCNTL_h_shift                                             (11)
+#define VE_VMCNTL_w_shift                                             (0)
+#define VE_VMCNTL_write_enable3_mask                                  (0x04000000)
+#define VE_VMCNTL_q_sample_mask                                       (0x02000000)
+#define VE_VMCNTL_write_enable2_mask                                  (0x01000000)
+#define VE_VMCNTL_rnd_cntl_mask                                       (0x00800000)
+#define VE_VMCNTL_write_enable1_mask                                  (0x00400000)
+#define VE_VMCNTL_h_mask                                              (0x003FF800)
+#define VE_VMCNTL_w_mask                                              (0x000007FF)
+#define VE_VMCNTL_write_enable3(data)                                 (0x04000000&((data)<<26))
+#define VE_VMCNTL_q_sample(data)                                      (0x02000000&((data)<<25))
+#define VE_VMCNTL_write_enable2(data)                                 (0x01000000&((data)<<24))
+#define VE_VMCNTL_rnd_cntl(data)                                      (0x00800000&((data)<<23))
+#define VE_VMCNTL_write_enable1(data)                                 (0x00400000&((data)<<22))
+#define VE_VMCNTL_h(data)                                             (0x003FF800&((data)<<11))
+#define VE_VMCNTL_w(data)                                             (0x000007FF&(data))
+#define VE_VMCNTL_get_write_enable3(data)                             ((0x04000000&(data))>>26)
+#define VE_VMCNTL_get_q_sample(data)                                  ((0x02000000&(data))>>25)
+#define VE_VMCNTL_get_write_enable2(data)                             ((0x01000000&(data))>>24)
+#define VE_VMCNTL_get_rnd_cntl(data)                                  ((0x00800000&(data))>>23)
+#define VE_VMCNTL_get_write_enable1(data)                             ((0x00400000&(data))>>22)
+#define VE_VMCNTL_get_h(data)                                         ((0x003FF800&(data))>>11)
+#define VE_VMCNTL_get_w(data)                                         (0x000007FF&(data))
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/venus.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/venus.h
new file mode 100644
index 00000000..e69de29
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/vi_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/vi_reg.h
new file mode 100644
index 00000000..ff0def1
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/vi_reg.h
@@ -0,0 +1,6263 @@
+/**************************************************************
+// Spec Version                  : 0.8.0
+// Parser Version                : MAR_Parser_1.0
+// CModelGen Version             : 1.0 2006.04.18
+// Naming Rule                   : Module_Register_Name_reg
+// Firmware Header Generate Date : 2008/4/1
+***************************************************************/
+
+
+#ifndef _VI_REG_H_INCLUDED_
+#define _VI_REG_H_INCLUDED_
+#ifdef  _VI_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     video16_en:1;
+unsigned int     video16_type:2;
+unsigned int     posen:1;
+unsigned int     negen:1;
+unsigned int     ycsel:2;
+}VI_EDGE1;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     posen:1;
+unsigned int     negen:1;
+unsigned int     ycsel:2;
+}VI_EDGE2;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     ignore1:1;
+unsigned int     enable1:1;
+unsigned int     ignore:1;
+unsigned int     enable:1;
+unsigned int     write_data:1;
+}VI_PBIT;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     error1:1;
+unsigned int     error:1;
+}VI_PBIT_ERR;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     write_enable1:1;
+unsigned int     ext_en:1;
+unsigned int     write_enable2:1;
+unsigned int     hsync_sel:1;
+}VI_EXT_SYNC;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     field:1;
+unsigned int     vcnt:11;
+unsigned int     hcnt:12;
+}VI_FVH1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     field:1;
+unsigned int     vcnt:11;
+unsigned int     hcnt:12;
+}VI_FVH2;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_enable3:1;
+unsigned int     reinten:1;
+unsigned int     write_enable4:1;
+unsigned int     top:1;
+unsigned int     write_enable1:1;
+unsigned int     vstart:11;
+unsigned int     write_enable2:1;
+unsigned int     vend:11;
+}VI_CWV1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_enable3:1;
+unsigned int     reinten:1;
+unsigned int     write_enable4:1;
+unsigned int     top:1;
+unsigned int     write_enable1:1;
+unsigned int     vstart:11;
+unsigned int     write_enable2:1;
+unsigned int     vend:11;
+}VI_CWV2;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     hstart:12;
+unsigned int     write_enable2:1;
+unsigned int     hend:12;
+}VI_CWH1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     hstart:12;
+unsigned int     write_enable2:1;
+unsigned int     hend:12;
+}VI_CWH2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable1:1;
+unsigned int     v2_fend:11;
+unsigned int     write_enable2:1;
+unsigned int     v1_fend:11;
+}VI_CWFEND;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     threshold:23;
+}VI_VSTHRESHOLD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     threshold:23;
+}VI_VSTHRESHOLD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     flvcnt1:11;
+unsigned int     flvcnt2:11;
+}VI_FLVCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     slcnt1:11;
+unsigned int     slcnt2:11;
+}VI_SLCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     llcnt1:11;
+unsigned int     llcnt2:11;
+}VI_LLCNT;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable1:1;
+unsigned int     slthd1:11;
+unsigned int     write_enable2:1;
+unsigned int     slthd2:11;
+}VI_SLTHRESHOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable1:1;
+unsigned int     llthd1:11;
+unsigned int     write_enable2:1;
+unsigned int     llthd2:11;
+}VI_LLTHRESHOLD;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable5:1;
+unsigned int     reserved_1:1;
+unsigned int     write_enable4:1;
+unsigned int     yonly:1;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+unsigned int     write_enable2:1;
+unsigned int     vstart:11;
+unsigned int     write_enable3:1;
+unsigned int     vend:11;
+}VI_VBIWV1F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable5:1;
+unsigned int     reserved_1:1;
+unsigned int     write_enable4:1;
+unsigned int     yonly:1;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+unsigned int     write_enable2:1;
+unsigned int     vstart:11;
+unsigned int     write_enable3:1;
+unsigned int     vend:11;
+}VI_VBIWV1F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable5:1;
+unsigned int     reserved_1:1;
+unsigned int     write_enable1:1;
+unsigned int     yonly:1;
+unsigned int     write_enable2:1;
+unsigned int     enable:1;
+unsigned int     write_enable3:1;
+unsigned int     vstart:11;
+unsigned int     write_enable4:1;
+unsigned int     vend:11;
+}VI_VBIWV2F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable5:1;
+unsigned int     reserved_1:1;
+unsigned int     write_enable1:1;
+unsigned int     yonly:1;
+unsigned int     write_enable2:1;
+unsigned int     enable:1;
+unsigned int     write_enable3:1;
+unsigned int     vstart:11;
+unsigned int     write_enable4:1;
+unsigned int     vend:11;
+}VI_VBIWV2F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     hstart:12;
+unsigned int     write_enable2:1;
+unsigned int     hend:12;
+}VI_VBIWH1F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     hstart:12;
+unsigned int     write_enable2:1;
+unsigned int     hend:12;
+}VI_VBIWH1F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     hstart:12;
+unsigned int     write_enable2:1;
+unsigned int     hend:12;
+}VI_VBIWH2F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     hstart:12;
+unsigned int     write_enable2:1;
+unsigned int     hend:12;
+}VI_VBIWH2F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     en:1;
+unsigned int     write_enable2:1;
+unsigned int     vstart:11;
+unsigned int     write_enable3:1;
+unsigned int     vend:11;
+}VI_VBIWV1F0_SC;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     en:1;
+unsigned int     write_enable2:1;
+unsigned int     vstart:11;
+unsigned int     write_enable3:1;
+unsigned int     vend:11;
+}VI_VBIWV1F1_SC;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     en:1;
+unsigned int     write_enable2:1;
+unsigned int     vstart:11;
+unsigned int     write_enable3:1;
+unsigned int     vend:11;
+}VI_VBIWV2F0_SC;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     en:1;
+unsigned int     write_enable2:1;
+unsigned int     vstart:11;
+unsigned int     write_enable3:1;
+unsigned int     vend:11;
+}VI_VBIWV2F1_SC;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     hstart:12;
+unsigned int     write_enable2:1;
+unsigned int     hend:12;
+}VI_VBIWH1F0_SC;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     hstart:12;
+unsigned int     write_enable2:1;
+unsigned int     hend:12;
+}VI_VBIWH1F1_SC;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     hstart:12;
+unsigned int     write_enable2:1;
+unsigned int     hend:12;
+}VI_VBIWH2F0_SC;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     write_enable1:1;
+unsigned int     hstart:12;
+unsigned int     write_enable2:1;
+unsigned int     hend:12;
+}VI_VBIWH2F1_SC;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     write_enable1:1;
+unsigned int     scaling_en1:1;
+unsigned int     write_enable2:1;
+unsigned int     gain:8;
+unsigned int     write_enable3:1;
+unsigned int     offset:8;
+}VI_VBIF0_SCALING1;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     write_enable1:1;
+unsigned int     scaling_en1:1;
+unsigned int     write_enable2:1;
+unsigned int     gain:8;
+unsigned int     write_enable3:1;
+unsigned int     offset:8;
+}VI_VBIF1_SCALING1;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     write_enable1:1;
+unsigned int     scaling_en2:1;
+unsigned int     write_enable2:1;
+unsigned int     gain:8;
+unsigned int     write_enable3:1;
+unsigned int     offset:8;
+}VI_VBIF0_SCALING2;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     write_enable1:1;
+unsigned int     scaling_en2:1;
+unsigned int     write_enable2:1;
+unsigned int     gain:8;
+unsigned int     write_enable3:1;
+unsigned int     offset:8;
+}VI_VBIF1_SCALING2;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     dc:29;
+}VI_YDC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     dc:29;
+}VI_YDC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     yen:1;
+unsigned int     cen:1;
+unsigned int     write_data:1;
+}VI_COCTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     yen:1;
+unsigned int     cen:1;
+unsigned int     write_data:1;
+}VI_COCTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     write_enable1:1;
+unsigned int     range:8;
+unsigned int     write_enable2:1;
+unsigned int     conti:1;
+unsigned int     write_enable3:1;
+unsigned int     clamp:1;
+}VI_YCO1;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     write_enable1:1;
+unsigned int     range:8;
+unsigned int     write_enable2:1;
+unsigned int     conti:1;
+unsigned int     write_enable3:1;
+unsigned int     clamp:1;
+}VI_CCO1;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     write_enable1:1;
+unsigned int     range:8;
+unsigned int     write_enable2:1;
+unsigned int     conti:1;
+unsigned int     write_enable3:1;
+unsigned int     clamp:1;
+}VI_YCO2;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     write_enable1:1;
+unsigned int     range:8;
+unsigned int     write_enable2:1;
+unsigned int     conti:1;
+unsigned int     write_enable3:1;
+unsigned int     clamp:1;
+}VI_CCO2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     up_en:1;
+unsigned int     tap_mode:2;
+unsigned int     yen:1;
+unsigned int     yoddtype:1;
+unsigned int     cen:1;
+unsigned int     coddtype:1;
+unsigned int     reserved_1:1;
+}VI_VSCCTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     up_en:1;
+unsigned int     tap_mode:2;
+unsigned int     yen:1;
+unsigned int     yoddtype:1;
+unsigned int     cen:1;
+unsigned int     coddtype:1;
+unsigned int     reserved_1:1;
+}VI_VSCCTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_enable1:1;
+unsigned int     yonl:11;
+unsigned int     write_enable2:1;
+unsigned int     ydphs:18;
+}VI_VYSC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_enable1:1;
+unsigned int     conl:11;
+unsigned int     write_enable2:1;
+unsigned int     cdphs:18;
+}VI_VCSC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_enable1:1;
+unsigned int     yonl:11;
+unsigned int     write_enable2:1;
+unsigned int     ydphs:18;
+}VI_VYSC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_enable1:1;
+unsigned int     conl:11;
+unsigned int     write_enable2:1;
+unsigned int     cdphs:18;
+}VI_VCSC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     init_offset:11;
+unsigned int     init_phase:14;
+}VI_VYIPOS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     init_offset:11;
+unsigned int     init_phase:14;
+}VI_VYIPOS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     init_offset:11;
+unsigned int     init_phase:14;
+}VI_VCIPOS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     init_offset:11;
+unsigned int     init_phase:14;
+}VI_VCIPOS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     ysccoef:14;
+}VI_VYSCCOEF1;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     ysccoef:14;
+}VI_VYSCCOEF2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     csccoef:14;
+}VI_VCSCCOEF1;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     csccoef:14;
+}VI_VCSCCOEF2;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     y1_clamp:1;
+unsigned int     c1_clamp:1;
+unsigned int     y2_clamp:1;
+unsigned int     c2_clamp:1;
+unsigned int     y1:1;
+unsigned int     c1:1;
+unsigned int     y2:1;
+unsigned int     c2:1;
+unsigned int     write_data:1;
+}VI_VOFFSETEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable1:1;
+unsigned int     heighy:11;
+unsigned int     write_enable2:1;
+unsigned int     heighc:11;
+}VI_VINFO1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable1:1;
+unsigned int     heighy:11;
+unsigned int     write_enable2:1;
+unsigned int     heighc:11;
+}VI_VINFO2;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     yen:1;
+unsigned int     yoddtype:1;
+unsigned int     cen:1;
+unsigned int     coddtype:1;
+unsigned int     write_data:1;
+}VI_SCCTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     yen:1;
+unsigned int     yoddtype:1;
+unsigned int     cen:1;
+unsigned int     coddtype:1;
+unsigned int     write_data:1;
+}VI_SCCTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable1:1;
+unsigned int     yonp:11;
+unsigned int     write_enable2:1;
+unsigned int     ydphs:17;
+}VI_YSC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable1:1;
+unsigned int     conp:11;
+unsigned int     write_enable2:1;
+unsigned int     cdphs:17;
+}VI_CSC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable1:1;
+unsigned int     yonp:11;
+unsigned int     write_enable2:1;
+unsigned int     ydphs:17;
+}VI_YSC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable1:1;
+unsigned int     conp:11;
+unsigned int     write_enable2:1;
+unsigned int     cdphs:17;
+}VI_CSC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     init_offset:11;
+unsigned int     init_phase:14;
+}VI_YIPOS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     init_offset:11;
+unsigned int     init_phase:14;
+}VI_YIPOS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     init_offset:11;
+unsigned int     init_phase:14;
+}VI_CIPOS1;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     init_offset:11;
+unsigned int     init_phase:14;
+}VI_CIPOS2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     ysccoef:14;
+}VI_YSCCOEF1;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     ysccoef:14;
+}VI_YSCCOEF2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     csccoef:14;
+}VI_CSCCOEF1;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     csccoef:14;
+}VI_CSCCOEF2;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     y1_clamp:1;
+unsigned int     c1_clamp:1;
+unsigned int     y2_clamp:1;
+unsigned int     c2_clamp:1;
+unsigned int     y1:1;
+unsigned int     c1:1;
+unsigned int     y2:1;
+unsigned int     c2:1;
+unsigned int     write_data:1;
+}VI_OFFSETEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hpd_enable:1;
+unsigned int     hpd_acc:29;
+}VI_HPD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     hpd_enable:1;
+unsigned int     hpd_acc:29;
+}VI_HPD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vpd_enable:1;
+unsigned int     vpd_acc:29;
+}VI_VPD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     vpd_enable:1;
+unsigned int     vpd_acc:29;
+}VI_VPD2;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable7:1;
+unsigned int     cvd1_on:1;
+unsigned int     write_enable8:1;
+unsigned int     cvd2_on:1;
+unsigned int     write_enable5:1;
+unsigned int     hdcvden1:1;
+unsigned int     write_enable6:1;
+unsigned int     hdcvden2:1;
+unsigned int     write_enable1:1;
+unsigned int     cvden1:1;
+unsigned int     write_enable2:1;
+unsigned int     cvdtp1:2;
+unsigned int     write_enable3:1;
+unsigned int     cvden2:1;
+unsigned int     write_enable4:1;
+unsigned int     cvdtp2:2;
+}VI_CVDEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     write_enable4:1;
+unsigned int     src_sel:1;
+unsigned int     write_enable5:1;
+unsigned int     luma_2x_en:1;
+unsigned int     write_enable1:1;
+unsigned int     yden:1;
+unsigned int     write_enable2:1;
+unsigned int     reserved_1:1;
+unsigned int     write_enable3:1;
+unsigned int     ydrtio:2;
+}VI_YDCTL1;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     write_enable4:1;
+unsigned int     src_sel:1;
+unsigned int     write_enable5:1;
+unsigned int     luma_2x_en:1;
+unsigned int     write_enable1:1;
+unsigned int     yden:1;
+unsigned int     write_enable2:1;
+unsigned int     reserved_1:1;
+unsigned int     write_enable3:1;
+unsigned int     ydrtio:2;
+}VI_YDCTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     write_enable1:1;
+unsigned int     dmaen1:1;
+unsigned int     write_enable2:1;
+unsigned int     dmaen2:1;
+unsigned int     write_enable4:1;
+unsigned int     hddmaen1:1;
+unsigned int     write_enable5:1;
+unsigned int     hddmaen2:1;
+unsigned int     write_enable3:1;
+unsigned int     bstlen:3;
+}VI_DMACTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     write_enable1:1;
+unsigned int     thd:6;
+}VI_VBI1BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     write_enable1:1;
+unsigned int     thd:6;
+}VI_VBI2BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     write_enable1:1;
+unsigned int     thd:6;
+unsigned int     reserved_1:10;
+}VI_HDY1BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable1:1;
+unsigned int     thd:6;
+unsigned int     reserved_1:20;
+}VI_HDY2BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable1:1;
+unsigned int     thd:6;
+unsigned int     reserved_1:20;
+}VI_HDC1BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable1:1;
+unsigned int     thd:6;
+unsigned int     reserved_1:20;
+}VI_HDC2BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:15;
+unsigned int     write_enable1:1;
+unsigned int     thd:6;
+unsigned int     reserved_1:10;
+}VI_Y1BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable1:1;
+unsigned int     thd:6;
+unsigned int     reserved_1:20;
+}VI_Y2BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable1:1;
+unsigned int     thd:6;
+unsigned int     reserved_1:20;
+}VI_C1BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable1:1;
+unsigned int     thd:6;
+unsigned int     reserved_1:20;
+}VI_C2BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable1:1;
+unsigned int     thd1:6;
+unsigned int     write_enable2:1;
+unsigned int     thd2:6;
+unsigned int     reserved_1:13;
+}VI_YDBUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}VI_VBISCADR1F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}VI_VBISCADR1F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}VI_VBISCADR2F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}VI_VBISCADR2F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     length:18;
+}VI_VBISCLEN1F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     length:18;
+}VI_VBISCLEN1F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     length:18;
+}VI_VBISCLEN2F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     length:18;
+}VI_VBISCLEN2F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}VI_VBIADR1F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}VI_VBIADR1F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     length:18;
+}VI_VBILEN1F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     length:18;
+}VI_VBILEN1F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}VI_VBIADR2F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     addr:28;
+}VI_VBIADR2F1;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     length:18;
+}VI_VBILEN2F0;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     length:18;
+}VI_VBILEN2F1;
+
+typedef struct 
+{
+unsigned int     write_enable2:1;
+unsigned int     yads:7;
+unsigned int     write_enable3:1;
+unsigned int     cads:7;
+unsigned int     write_enable4:1;
+unsigned int     hdyads:7;
+unsigned int     write_enable5:1;
+unsigned int     hdcads:7;
+}VI_DMACTL1;
+
+typedef struct 
+{
+unsigned int     write_enable2:1;
+unsigned int     yads:7;
+unsigned int     write_enable3:1;
+unsigned int     cads:7;
+unsigned int     write_enable4:1;
+unsigned int     hdyads:7;
+unsigned int     write_enable5:1;
+unsigned int     hdcads:7;
+}VI_DMACTL2;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     dyads2:7;
+unsigned int     dyads:7;
+}VI_DYDMACTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     v1hd_odd:1;
+unsigned int     v1hd_interleave:1;
+unsigned int     v2hd_odd:1;
+unsigned int     v2hd_interleave:1;
+unsigned int     v1_odd:1;
+unsigned int     v1_interleave:1;
+unsigned int     v2_odd:1;
+unsigned int     v2_interleave:1;
+unsigned int     dy_odd:1;
+unsigned int     dy_interleave:1;
+unsigned int     dy2_odd:1;
+unsigned int     dy2_interleave:1;
+unsigned int     write_data:1;
+}VI_IMMODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     write_enable1:1;
+unsigned int     y1c1:4;
+unsigned int     write_enable2:1;
+unsigned int     y2c2:4;
+unsigned int     write_enable3:1;
+unsigned int     vbi1:4;
+unsigned int     write_enable4:1;
+unsigned int     vbi2:4;
+unsigned int     write_enable5:1;
+unsigned int     dy:4;
+unsigned int     write_enable6:1;
+unsigned int     dy2:4;
+}VI_DMA_MIN_TIME;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     write_enable1:1;
+unsigned int     y1c1:4;
+unsigned int     write_enable2:1;
+unsigned int     y2c2:4;
+}VI_HDDMA_MIN_TIME;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     v2_err:1;
+unsigned int     v1_err:1;
+}VI_DMAERR;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     feinte1:1;
+unsigned int     feinte2:1;
+unsigned int     hdolinte1:1;
+unsigned int     hdolinte2:1;
+unsigned int     dmaerrinte:1;
+unsigned int     reserved_1:1;
+unsigned int     sfinte1:1;
+unsigned int     sfinte2:1;
+unsigned int     vsinte1:1;
+unsigned int     vsinte2:1;
+unsigned int     tointe1:1;
+unsigned int     tointe2:1;
+unsigned int     olinte1:1;
+unsigned int     olinte2:1;
+unsigned int     write_data:1;
+}VI_INTEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:17;
+unsigned int     feints1:1;
+unsigned int     feints2:1;
+unsigned int     hdolints1:1;
+unsigned int     hdolints2:1;
+unsigned int     dmaerrints:1;
+unsigned int     reserved_1:1;
+unsigned int     sfints1:1;
+unsigned int     sfints2:1;
+unsigned int     vsints1:1;
+unsigned int     vsints2:1;
+unsigned int     toints1:1;
+unsigned int     toints2:1;
+unsigned int     olints1:1;
+unsigned int     olints2:1;
+unsigned int     write_data:1;
+}VI_INTST;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable1:1;
+unsigned int     y:11;
+unsigned int     write_enable2:1;
+unsigned int     c:11;
+}VI_OLN1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable1:1;
+unsigned int     y:11;
+unsigned int     write_enable2:1;
+unsigned int     c:11;
+}VI_OLN2;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable1:1;
+unsigned int     y:11;
+unsigned int     write_enable2:1;
+unsigned int     c:11;
+}VI_HDOLN1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_enable1:1;
+unsigned int     y:11;
+unsigned int     write_enable2:1;
+unsigned int     c:11;
+}VI_HDOLN2;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     y:11;
+unsigned int     c:11;
+}VI_OLNCNT1;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     y:11;
+unsigned int     c:11;
+}VI_OLNCNT2;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     y:11;
+unsigned int     c:11;
+}VI_HDOLNCNT1;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     y:11;
+unsigned int     c:11;
+}VI_HDOLNCNT2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     write_enable3:1;
+unsigned int     vsce1:1;
+unsigned int     write_enable4:1;
+unsigned int     vsce2:1;
+unsigned int     write_enable7:1;
+unsigned int     hdvsce1:1;
+unsigned int     write_enable8:1;
+unsigned int     hdvsce2:1;
+}VI_GCTL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     write_enable1:1;
+unsigned int     enable:1;
+}VI_DYNAMIC_P;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_Y1OBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_Y2OBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_C1OBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_C2OBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_VBI1OBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_VBI2OBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_DYOBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_DYEXTOBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_HDY1OBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_HDY2OBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_HDC1OBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_HDC2OBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_Y1EXTOBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     start:8;
+unsigned int     write_enable2:1;
+unsigned int     end:8;
+}VI_Y2EXTOBUFF;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     write_enable1:1;
+unsigned int     fa_enable:1;
+unsigned int     write_enable2:1;
+unsigned int     fa_buffer_sel:1;
+unsigned int     write_enable3:1;
+unsigned int     fa_addr_2:9;
+}VI_FA_ADDR;
+
+typedef struct 
+{
+unsigned int     data:32;
+}VI_FA_DATA_MSB;
+
+typedef struct 
+{
+unsigned int     data:32;
+}VI_FA_DATA_LSB;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     write_enable1:1;
+unsigned int     sel0:7;
+unsigned int     write_enable2:1;
+unsigned int     sel1:7;
+unsigned int     write_enable3:1;
+unsigned int     enable:1;
+}VI_DBG;
+
+typedef struct 
+{
+unsigned int     dummy:32;
+}VI_DUMMY;
+
+#endif
+
+#define VI_EDGE1                                                                     0x18004290
+#define VI_EDGE1_reg_addr                                                            "0xB8004290"
+#define VI_EDGE1_reg                                                                 0xB8004290
+#define VI_EDGE1_inst_adr                                                            "0x00A4"
+#define VI_EDGE1_inst                                                                0x00A4
+#define VI_EDGE1_video16_en_shift                                                    (6)
+#define VI_EDGE1_video16_en_mask                                                     (0x00000040)
+#define VI_EDGE1_video16_en(data)                                                    (0x00000040&((data)<<6))
+#define VI_EDGE1_video16_en_src(data)                                                ((0x00000040&(data))>>6)
+#define VI_EDGE1_get_video16_en(data)                                                ((0x00000040&(data))>>6)
+#define VI_EDGE1_video16_type_shift                                                  (4)
+#define VI_EDGE1_video16_type_mask                                                   (0x00000030)
+#define VI_EDGE1_video16_type(data)                                                  (0x00000030&((data)<<4))
+#define VI_EDGE1_video16_type_src(data)                                              ((0x00000030&(data))>>4)
+#define VI_EDGE1_get_video16_type(data)                                              ((0x00000030&(data))>>4)
+#define VI_EDGE1_posen_shift                                                         (3)
+#define VI_EDGE1_posen_mask                                                          (0x00000008)
+#define VI_EDGE1_posen(data)                                                         (0x00000008&((data)<<3))
+#define VI_EDGE1_posen_src(data)                                                     ((0x00000008&(data))>>3)
+#define VI_EDGE1_get_posen(data)                                                     ((0x00000008&(data))>>3)
+#define VI_EDGE1_negen_shift                                                         (2)
+#define VI_EDGE1_negen_mask                                                          (0x00000004)
+#define VI_EDGE1_negen(data)                                                         (0x00000004&((data)<<2))
+#define VI_EDGE1_negen_src(data)                                                     ((0x00000004&(data))>>2)
+#define VI_EDGE1_get_negen(data)                                                     ((0x00000004&(data))>>2)
+#define VI_EDGE1_ycsel_shift                                                         (0)
+#define VI_EDGE1_ycsel_mask                                                          (0x00000003)
+#define VI_EDGE1_ycsel(data)                                                         (0x00000003&((data)<<0))
+#define VI_EDGE1_ycsel_src(data)                                                     ((0x00000003&(data))>>0)
+#define VI_EDGE1_get_ycsel(data)                                                     ((0x00000003&(data))>>0)
+
+
+#define VI_EDGE2                                                                     0x18004294
+#define VI_EDGE2_reg_addr                                                            "0xB8004294"
+#define VI_EDGE2_reg                                                                 0xB8004294
+#define VI_EDGE2_inst_adr                                                            "0x00A5"
+#define VI_EDGE2_inst                                                                0x00A5
+#define VI_EDGE2_posen_shift                                                         (3)
+#define VI_EDGE2_posen_mask                                                          (0x00000008)
+#define VI_EDGE2_posen(data)                                                         (0x00000008&((data)<<3))
+#define VI_EDGE2_posen_src(data)                                                     ((0x00000008&(data))>>3)
+#define VI_EDGE2_get_posen(data)                                                     ((0x00000008&(data))>>3)
+#define VI_EDGE2_negen_shift                                                         (2)
+#define VI_EDGE2_negen_mask                                                          (0x00000004)
+#define VI_EDGE2_negen(data)                                                         (0x00000004&((data)<<2))
+#define VI_EDGE2_negen_src(data)                                                     ((0x00000004&(data))>>2)
+#define VI_EDGE2_get_negen(data)                                                     ((0x00000004&(data))>>2)
+#define VI_EDGE2_ycsel_shift                                                         (0)
+#define VI_EDGE2_ycsel_mask                                                          (0x00000003)
+#define VI_EDGE2_ycsel(data)                                                         (0x00000003&((data)<<0))
+#define VI_EDGE2_ycsel_src(data)                                                     ((0x00000003&(data))>>0)
+#define VI_EDGE2_get_ycsel(data)                                                     ((0x00000003&(data))>>0)
+
+
+#define VI_PBIT                                                                      0x18004004
+#define VI_PBIT_reg_addr                                                             "0xB8004004"
+#define VI_PBIT_reg                                                                  0xB8004004
+#define VI_PBIT_inst_adr                                                             "0x0001"
+#define VI_PBIT_inst                                                                 0x0001
+#define VI_PBIT_ignore1_shift                                                        (4)
+#define VI_PBIT_ignore1_mask                                                         (0x00000010)
+#define VI_PBIT_ignore1(data)                                                        (0x00000010&((data)<<4))
+#define VI_PBIT_ignore1_src(data)                                                    ((0x00000010&(data))>>4)
+#define VI_PBIT_get_ignore1(data)                                                    ((0x00000010&(data))>>4)
+#define VI_PBIT_enable1_shift                                                        (3)
+#define VI_PBIT_enable1_mask                                                         (0x00000008)
+#define VI_PBIT_enable1(data)                                                        (0x00000008&((data)<<3))
+#define VI_PBIT_enable1_src(data)                                                    ((0x00000008&(data))>>3)
+#define VI_PBIT_get_enable1(data)                                                    ((0x00000008&(data))>>3)
+#define VI_PBIT_ignore_shift                                                         (2)
+#define VI_PBIT_ignore_mask                                                          (0x00000004)
+#define VI_PBIT_ignore(data)                                                         (0x00000004&((data)<<2))
+#define VI_PBIT_ignore_src(data)                                                     ((0x00000004&(data))>>2)
+#define VI_PBIT_get_ignore(data)                                                     ((0x00000004&(data))>>2)
+#define VI_PBIT_enable_shift                                                         (1)
+#define VI_PBIT_enable_mask                                                          (0x00000002)
+#define VI_PBIT_enable(data)                                                         (0x00000002&((data)<<1))
+#define VI_PBIT_enable_src(data)                                                     ((0x00000002&(data))>>1)
+#define VI_PBIT_get_enable(data)                                                     ((0x00000002&(data))>>1)
+#define VI_PBIT_write_data_shift                                                     (0)
+#define VI_PBIT_write_data_mask                                                      (0x00000001)
+#define VI_PBIT_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VI_PBIT_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VI_PBIT_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VI_PBIT_ERR                                                                  0x18004008
+#define VI_PBIT_ERR_reg_addr                                                         "0xB8004008"
+#define VI_PBIT_ERR_reg                                                              0xB8004008
+#define VI_PBIT_ERR_inst_adr                                                         "0x0002"
+#define VI_PBIT_ERR_inst                                                             0x0002
+#define VI_PBIT_ERR_error1_shift                                                     (1)
+#define VI_PBIT_ERR_error1_mask                                                      (0x00000002)
+#define VI_PBIT_ERR_error1(data)                                                     (0x00000002&((data)<<1))
+#define VI_PBIT_ERR_error1_src(data)                                                 ((0x00000002&(data))>>1)
+#define VI_PBIT_ERR_get_error1(data)                                                 ((0x00000002&(data))>>1)
+#define VI_PBIT_ERR_error_shift                                                      (0)
+#define VI_PBIT_ERR_error_mask                                                       (0x00000001)
+#define VI_PBIT_ERR_error(data)                                                      (0x00000001&((data)<<0))
+#define VI_PBIT_ERR_error_src(data)                                                  ((0x00000001&(data))>>0)
+#define VI_PBIT_ERR_get_error(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VI_EXT_SYNC                                                                  0x180044b0
+#define VI_EXT_SYNC_reg_addr                                                         "0xB80044B0"
+#define VI_EXT_SYNC_reg                                                              0xB80044B0
+#define VI_EXT_SYNC_inst_adr                                                         "0x002C"
+#define VI_EXT_SYNC_inst                                                             0x002C
+#define VI_EXT_SYNC_write_enable1_shift                                              (3)
+#define VI_EXT_SYNC_write_enable1_mask                                               (0x00000008)
+#define VI_EXT_SYNC_write_enable1(data)                                              (0x00000008&((data)<<3))
+#define VI_EXT_SYNC_write_enable1_src(data)                                          ((0x00000008&(data))>>3)
+#define VI_EXT_SYNC_get_write_enable1(data)                                          ((0x00000008&(data))>>3)
+#define VI_EXT_SYNC_ext_en_shift                                                     (2)
+#define VI_EXT_SYNC_ext_en_mask                                                      (0x00000004)
+#define VI_EXT_SYNC_ext_en(data)                                                     (0x00000004&((data)<<2))
+#define VI_EXT_SYNC_ext_en_src(data)                                                 ((0x00000004&(data))>>2)
+#define VI_EXT_SYNC_get_ext_en(data)                                                 ((0x00000004&(data))>>2)
+#define VI_EXT_SYNC_write_enable2_shift                                              (1)
+#define VI_EXT_SYNC_write_enable2_mask                                               (0x00000002)
+#define VI_EXT_SYNC_write_enable2(data)                                              (0x00000002&((data)<<1))
+#define VI_EXT_SYNC_write_enable2_src(data)                                          ((0x00000002&(data))>>1)
+#define VI_EXT_SYNC_get_write_enable2(data)                                          ((0x00000002&(data))>>1)
+#define VI_EXT_SYNC_hsync_sel_shift                                                  (0)
+#define VI_EXT_SYNC_hsync_sel_mask                                                   (0x00000001)
+#define VI_EXT_SYNC_hsync_sel(data)                                                  (0x00000001&((data)<<0))
+#define VI_EXT_SYNC_hsync_sel_src(data)                                              ((0x00000001&(data))>>0)
+#define VI_EXT_SYNC_get_hsync_sel(data)                                              ((0x00000001&(data))>>0)
+
+
+#define VI_FVH1                                                                      0x1800400c
+#define VI_FVH1_reg_addr                                                             "0xB800400C"
+#define VI_FVH1_reg                                                                  0xB800400C
+#define VI_FVH1_inst_adr                                                             "0x0003"
+#define VI_FVH1_inst                                                                 0x0003
+#define VI_FVH1_field_shift                                                          (23)
+#define VI_FVH1_field_mask                                                           (0x00800000)
+#define VI_FVH1_field(data)                                                          (0x00800000&((data)<<23))
+#define VI_FVH1_field_src(data)                                                      ((0x00800000&(data))>>23)
+#define VI_FVH1_get_field(data)                                                      ((0x00800000&(data))>>23)
+#define VI_FVH1_vcnt_shift                                                           (12)
+#define VI_FVH1_vcnt_mask                                                            (0x007FF000)
+#define VI_FVH1_vcnt(data)                                                           (0x007FF000&((data)<<12))
+#define VI_FVH1_vcnt_src(data)                                                       ((0x007FF000&(data))>>12)
+#define VI_FVH1_get_vcnt(data)                                                       ((0x007FF000&(data))>>12)
+#define VI_FVH1_hcnt_shift                                                           (0)
+#define VI_FVH1_hcnt_mask                                                            (0x00000FFF)
+#define VI_FVH1_hcnt(data)                                                           (0x00000FFF&((data)<<0))
+#define VI_FVH1_hcnt_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VI_FVH1_get_hcnt(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VI_FVH2                                                                      0x18004010
+#define VI_FVH2_reg_addr                                                             "0xB8004010"
+#define VI_FVH2_reg                                                                  0xB8004010
+#define VI_FVH2_inst_adr                                                             "0x0004"
+#define VI_FVH2_inst                                                                 0x0004
+#define VI_FVH2_field_shift                                                          (23)
+#define VI_FVH2_field_mask                                                           (0x00800000)
+#define VI_FVH2_field(data)                                                          (0x00800000&((data)<<23))
+#define VI_FVH2_field_src(data)                                                      ((0x00800000&(data))>>23)
+#define VI_FVH2_get_field(data)                                                      ((0x00800000&(data))>>23)
+#define VI_FVH2_vcnt_shift                                                           (12)
+#define VI_FVH2_vcnt_mask                                                            (0x007FF000)
+#define VI_FVH2_vcnt(data)                                                           (0x007FF000&((data)<<12))
+#define VI_FVH2_vcnt_src(data)                                                       ((0x007FF000&(data))>>12)
+#define VI_FVH2_get_vcnt(data)                                                       ((0x007FF000&(data))>>12)
+#define VI_FVH2_hcnt_shift                                                           (0)
+#define VI_FVH2_hcnt_mask                                                            (0x00000FFF)
+#define VI_FVH2_hcnt(data)                                                           (0x00000FFF&((data)<<0))
+#define VI_FVH2_hcnt_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VI_FVH2_get_hcnt(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VI_CWV1                                                                      0x18004014
+#define VI_CWV1_reg_addr                                                             "0xB8004014"
+#define VI_CWV1_reg                                                                  0xB8004014
+#define VI_CWV1_inst_adr                                                             "0x0005"
+#define VI_CWV1_inst                                                                 0x0005
+#define VI_CWV1_write_enable3_shift                                                  (27)
+#define VI_CWV1_write_enable3_mask                                                   (0x08000000)
+#define VI_CWV1_write_enable3(data)                                                  (0x08000000&((data)<<27))
+#define VI_CWV1_write_enable3_src(data)                                              ((0x08000000&(data))>>27)
+#define VI_CWV1_get_write_enable3(data)                                              ((0x08000000&(data))>>27)
+#define VI_CWV1_reinten_shift                                                        (26)
+#define VI_CWV1_reinten_mask                                                         (0x04000000)
+#define VI_CWV1_reinten(data)                                                        (0x04000000&((data)<<26))
+#define VI_CWV1_reinten_src(data)                                                    ((0x04000000&(data))>>26)
+#define VI_CWV1_get_reinten(data)                                                    ((0x04000000&(data))>>26)
+#define VI_CWV1_write_enable4_shift                                                  (25)
+#define VI_CWV1_write_enable4_mask                                                   (0x02000000)
+#define VI_CWV1_write_enable4(data)                                                  (0x02000000&((data)<<25))
+#define VI_CWV1_write_enable4_src(data)                                              ((0x02000000&(data))>>25)
+#define VI_CWV1_get_write_enable4(data)                                              ((0x02000000&(data))>>25)
+#define VI_CWV1_top_shift                                                            (24)
+#define VI_CWV1_top_mask                                                             (0x01000000)
+#define VI_CWV1_top(data)                                                            (0x01000000&((data)<<24))
+#define VI_CWV1_top_src(data)                                                        ((0x01000000&(data))>>24)
+#define VI_CWV1_get_top(data)                                                        ((0x01000000&(data))>>24)
+#define VI_CWV1_write_enable1_shift                                                  (23)
+#define VI_CWV1_write_enable1_mask                                                   (0x00800000)
+#define VI_CWV1_write_enable1(data)                                                  (0x00800000&((data)<<23))
+#define VI_CWV1_write_enable1_src(data)                                              ((0x00800000&(data))>>23)
+#define VI_CWV1_get_write_enable1(data)                                              ((0x00800000&(data))>>23)
+#define VI_CWV1_vstart_shift                                                         (12)
+#define VI_CWV1_vstart_mask                                                          (0x007FF000)
+#define VI_CWV1_vstart(data)                                                         (0x007FF000&((data)<<12))
+#define VI_CWV1_vstart_src(data)                                                     ((0x007FF000&(data))>>12)
+#define VI_CWV1_get_vstart(data)                                                     ((0x007FF000&(data))>>12)
+#define VI_CWV1_write_enable2_shift                                                  (11)
+#define VI_CWV1_write_enable2_mask                                                   (0x00000800)
+#define VI_CWV1_write_enable2(data)                                                  (0x00000800&((data)<<11))
+#define VI_CWV1_write_enable2_src(data)                                              ((0x00000800&(data))>>11)
+#define VI_CWV1_get_write_enable2(data)                                              ((0x00000800&(data))>>11)
+#define VI_CWV1_vend_shift                                                           (0)
+#define VI_CWV1_vend_mask                                                            (0x000007FF)
+#define VI_CWV1_vend(data)                                                           (0x000007FF&((data)<<0))
+#define VI_CWV1_vend_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VI_CWV1_get_vend(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VI_CWV2                                                                      0x18004018
+#define VI_CWV2_reg_addr                                                             "0xB8004018"
+#define VI_CWV2_reg                                                                  0xB8004018
+#define VI_CWV2_inst_adr                                                             "0x0006"
+#define VI_CWV2_inst                                                                 0x0006
+#define VI_CWV2_write_enable3_shift                                                  (27)
+#define VI_CWV2_write_enable3_mask                                                   (0x08000000)
+#define VI_CWV2_write_enable3(data)                                                  (0x08000000&((data)<<27))
+#define VI_CWV2_write_enable3_src(data)                                              ((0x08000000&(data))>>27)
+#define VI_CWV2_get_write_enable3(data)                                              ((0x08000000&(data))>>27)
+#define VI_CWV2_reinten_shift                                                        (26)
+#define VI_CWV2_reinten_mask                                                         (0x04000000)
+#define VI_CWV2_reinten(data)                                                        (0x04000000&((data)<<26))
+#define VI_CWV2_reinten_src(data)                                                    ((0x04000000&(data))>>26)
+#define VI_CWV2_get_reinten(data)                                                    ((0x04000000&(data))>>26)
+#define VI_CWV2_write_enable4_shift                                                  (25)
+#define VI_CWV2_write_enable4_mask                                                   (0x02000000)
+#define VI_CWV2_write_enable4(data)                                                  (0x02000000&((data)<<25))
+#define VI_CWV2_write_enable4_src(data)                                              ((0x02000000&(data))>>25)
+#define VI_CWV2_get_write_enable4(data)                                              ((0x02000000&(data))>>25)
+#define VI_CWV2_top_shift                                                            (24)
+#define VI_CWV2_top_mask                                                             (0x01000000)
+#define VI_CWV2_top(data)                                                            (0x01000000&((data)<<24))
+#define VI_CWV2_top_src(data)                                                        ((0x01000000&(data))>>24)
+#define VI_CWV2_get_top(data)                                                        ((0x01000000&(data))>>24)
+#define VI_CWV2_write_enable1_shift                                                  (23)
+#define VI_CWV2_write_enable1_mask                                                   (0x00800000)
+#define VI_CWV2_write_enable1(data)                                                  (0x00800000&((data)<<23))
+#define VI_CWV2_write_enable1_src(data)                                              ((0x00800000&(data))>>23)
+#define VI_CWV2_get_write_enable1(data)                                              ((0x00800000&(data))>>23)
+#define VI_CWV2_vstart_shift                                                         (12)
+#define VI_CWV2_vstart_mask                                                          (0x007FF000)
+#define VI_CWV2_vstart(data)                                                         (0x007FF000&((data)<<12))
+#define VI_CWV2_vstart_src(data)                                                     ((0x007FF000&(data))>>12)
+#define VI_CWV2_get_vstart(data)                                                     ((0x007FF000&(data))>>12)
+#define VI_CWV2_write_enable2_shift                                                  (11)
+#define VI_CWV2_write_enable2_mask                                                   (0x00000800)
+#define VI_CWV2_write_enable2(data)                                                  (0x00000800&((data)<<11))
+#define VI_CWV2_write_enable2_src(data)                                              ((0x00000800&(data))>>11)
+#define VI_CWV2_get_write_enable2(data)                                              ((0x00000800&(data))>>11)
+#define VI_CWV2_vend_shift                                                           (0)
+#define VI_CWV2_vend_mask                                                            (0x000007FF)
+#define VI_CWV2_vend(data)                                                           (0x000007FF&((data)<<0))
+#define VI_CWV2_vend_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VI_CWV2_get_vend(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VI_CWH1                                                                      0x1800401c
+#define VI_CWH1_reg_addr                                                             "0xB800401C"
+#define VI_CWH1_reg                                                                  0xB800401C
+#define VI_CWH1_inst_adr                                                             "0x0007"
+#define VI_CWH1_inst                                                                 0x0007
+#define VI_CWH1_write_enable1_shift                                                  (25)
+#define VI_CWH1_write_enable1_mask                                                   (0x02000000)
+#define VI_CWH1_write_enable1(data)                                                  (0x02000000&((data)<<25))
+#define VI_CWH1_write_enable1_src(data)                                              ((0x02000000&(data))>>25)
+#define VI_CWH1_get_write_enable1(data)                                              ((0x02000000&(data))>>25)
+#define VI_CWH1_hstart_shift                                                         (13)
+#define VI_CWH1_hstart_mask                                                          (0x01FFE000)
+#define VI_CWH1_hstart(data)                                                         (0x01FFE000&((data)<<13))
+#define VI_CWH1_hstart_src(data)                                                     ((0x01FFE000&(data))>>13)
+#define VI_CWH1_get_hstart(data)                                                     ((0x01FFE000&(data))>>13)
+#define VI_CWH1_write_enable2_shift                                                  (12)
+#define VI_CWH1_write_enable2_mask                                                   (0x00001000)
+#define VI_CWH1_write_enable2(data)                                                  (0x00001000&((data)<<12))
+#define VI_CWH1_write_enable2_src(data)                                              ((0x00001000&(data))>>12)
+#define VI_CWH1_get_write_enable2(data)                                              ((0x00001000&(data))>>12)
+#define VI_CWH1_hend_shift                                                           (0)
+#define VI_CWH1_hend_mask                                                            (0x00000FFF)
+#define VI_CWH1_hend(data)                                                           (0x00000FFF&((data)<<0))
+#define VI_CWH1_hend_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VI_CWH1_get_hend(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VI_CWH2                                                                      0x18004020
+#define VI_CWH2_reg_addr                                                             "0xB8004020"
+#define VI_CWH2_reg                                                                  0xB8004020
+#define VI_CWH2_inst_adr                                                             "0x0008"
+#define VI_CWH2_inst                                                                 0x0008
+#define VI_CWH2_write_enable1_shift                                                  (25)
+#define VI_CWH2_write_enable1_mask                                                   (0x02000000)
+#define VI_CWH2_write_enable1(data)                                                  (0x02000000&((data)<<25))
+#define VI_CWH2_write_enable1_src(data)                                              ((0x02000000&(data))>>25)
+#define VI_CWH2_get_write_enable1(data)                                              ((0x02000000&(data))>>25)
+#define VI_CWH2_hstart_shift                                                         (13)
+#define VI_CWH2_hstart_mask                                                          (0x01FFE000)
+#define VI_CWH2_hstart(data)                                                         (0x01FFE000&((data)<<13))
+#define VI_CWH2_hstart_src(data)                                                     ((0x01FFE000&(data))>>13)
+#define VI_CWH2_get_hstart(data)                                                     ((0x01FFE000&(data))>>13)
+#define VI_CWH2_write_enable2_shift                                                  (12)
+#define VI_CWH2_write_enable2_mask                                                   (0x00001000)
+#define VI_CWH2_write_enable2(data)                                                  (0x00001000&((data)<<12))
+#define VI_CWH2_write_enable2_src(data)                                              ((0x00001000&(data))>>12)
+#define VI_CWH2_get_write_enable2(data)                                              ((0x00001000&(data))>>12)
+#define VI_CWH2_hend_shift                                                           (0)
+#define VI_CWH2_hend_mask                                                            (0x00000FFF)
+#define VI_CWH2_hend(data)                                                           (0x00000FFF&((data)<<0))
+#define VI_CWH2_hend_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VI_CWH2_get_hend(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VI_CWFEND                                                                    0x18004580
+#define VI_CWFEND_reg_addr                                                           "0xB8004580"
+#define VI_CWFEND_reg                                                                0xB8004580
+#define VI_CWFEND_inst_adr                                                           "0x0060"
+#define VI_CWFEND_inst                                                               0x0060
+#define VI_CWFEND_write_enable1_shift                                                (23)
+#define VI_CWFEND_write_enable1_mask                                                 (0x00800000)
+#define VI_CWFEND_write_enable1(data)                                                (0x00800000&((data)<<23))
+#define VI_CWFEND_write_enable1_src(data)                                            ((0x00800000&(data))>>23)
+#define VI_CWFEND_get_write_enable1(data)                                            ((0x00800000&(data))>>23)
+#define VI_CWFEND_v2_fend_shift                                                      (12)
+#define VI_CWFEND_v2_fend_mask                                                       (0x007FF000)
+#define VI_CWFEND_v2_fend(data)                                                      (0x007FF000&((data)<<12))
+#define VI_CWFEND_v2_fend_src(data)                                                  ((0x007FF000&(data))>>12)
+#define VI_CWFEND_get_v2_fend(data)                                                  ((0x007FF000&(data))>>12)
+#define VI_CWFEND_write_enable2_shift                                                (11)
+#define VI_CWFEND_write_enable2_mask                                                 (0x00000800)
+#define VI_CWFEND_write_enable2(data)                                                (0x00000800&((data)<<11))
+#define VI_CWFEND_write_enable2_src(data)                                            ((0x00000800&(data))>>11)
+#define VI_CWFEND_get_write_enable2(data)                                            ((0x00000800&(data))>>11)
+#define VI_CWFEND_v1_fend_shift                                                      (0)
+#define VI_CWFEND_v1_fend_mask                                                       (0x000007FF)
+#define VI_CWFEND_v1_fend(data)                                                      (0x000007FF&((data)<<0))
+#define VI_CWFEND_v1_fend_src(data)                                                  ((0x000007FF&(data))>>0)
+#define VI_CWFEND_get_v1_fend(data)                                                  ((0x000007FF&(data))>>0)
+
+
+#define VI_VSTHRESHOLD1                                                              0x18004024
+#define VI_VSTHRESHOLD1_reg_addr                                                     "0xB8004024"
+#define VI_VSTHRESHOLD1_reg                                                          0xB8004024
+#define VI_VSTHRESHOLD1_inst_adr                                                     "0x0009"
+#define VI_VSTHRESHOLD1_inst                                                         0x0009
+#define VI_VSTHRESHOLD1_threshold_shift                                              (0)
+#define VI_VSTHRESHOLD1_threshold_mask                                               (0x007FFFFF)
+#define VI_VSTHRESHOLD1_threshold(data)                                              (0x007FFFFF&((data)<<0))
+#define VI_VSTHRESHOLD1_threshold_src(data)                                          ((0x007FFFFF&(data))>>0)
+#define VI_VSTHRESHOLD1_get_threshold(data)                                          ((0x007FFFFF&(data))>>0)
+
+
+#define VI_VSTHRESHOLD2                                                              0x18004028
+#define VI_VSTHRESHOLD2_reg_addr                                                     "0xB8004028"
+#define VI_VSTHRESHOLD2_reg                                                          0xB8004028
+#define VI_VSTHRESHOLD2_inst_adr                                                     "0x000A"
+#define VI_VSTHRESHOLD2_inst                                                         0x000A
+#define VI_VSTHRESHOLD2_threshold_shift                                              (0)
+#define VI_VSTHRESHOLD2_threshold_mask                                               (0x007FFFFF)
+#define VI_VSTHRESHOLD2_threshold(data)                                              (0x007FFFFF&((data)<<0))
+#define VI_VSTHRESHOLD2_threshold_src(data)                                          ((0x007FFFFF&(data))>>0)
+#define VI_VSTHRESHOLD2_get_threshold(data)                                          ((0x007FFFFF&(data))>>0)
+
+
+#define VI_FLVCNT                                                                    0x1800402c
+#define VI_FLVCNT_reg_addr                                                           "0xB800402C"
+#define VI_FLVCNT_reg                                                                0xB800402C
+#define VI_FLVCNT_inst_adr                                                           "0x000B"
+#define VI_FLVCNT_inst                                                               0x000B
+#define VI_FLVCNT_flvcnt1_shift                                                      (11)
+#define VI_FLVCNT_flvcnt1_mask                                                       (0x003FF800)
+#define VI_FLVCNT_flvcnt1(data)                                                      (0x003FF800&((data)<<11))
+#define VI_FLVCNT_flvcnt1_src(data)                                                  ((0x003FF800&(data))>>11)
+#define VI_FLVCNT_get_flvcnt1(data)                                                  ((0x003FF800&(data))>>11)
+#define VI_FLVCNT_flvcnt2_shift                                                      (0)
+#define VI_FLVCNT_flvcnt2_mask                                                       (0x000007FF)
+#define VI_FLVCNT_flvcnt2(data)                                                      (0x000007FF&((data)<<0))
+#define VI_FLVCNT_flvcnt2_src(data)                                                  ((0x000007FF&(data))>>0)
+#define VI_FLVCNT_get_flvcnt2(data)                                                  ((0x000007FF&(data))>>0)
+
+
+#define VI_SLCNT                                                                     0x18004030
+#define VI_SLCNT_reg_addr                                                            "0xB8004030"
+#define VI_SLCNT_reg                                                                 0xB8004030
+#define VI_SLCNT_inst_adr                                                            "0x000C"
+#define VI_SLCNT_inst                                                                0x000C
+#define VI_SLCNT_slcnt1_shift                                                        (11)
+#define VI_SLCNT_slcnt1_mask                                                         (0x003FF800)
+#define VI_SLCNT_slcnt1(data)                                                        (0x003FF800&((data)<<11))
+#define VI_SLCNT_slcnt1_src(data)                                                    ((0x003FF800&(data))>>11)
+#define VI_SLCNT_get_slcnt1(data)                                                    ((0x003FF800&(data))>>11)
+#define VI_SLCNT_slcnt2_shift                                                        (0)
+#define VI_SLCNT_slcnt2_mask                                                         (0x000007FF)
+#define VI_SLCNT_slcnt2(data)                                                        (0x000007FF&((data)<<0))
+#define VI_SLCNT_slcnt2_src(data)                                                    ((0x000007FF&(data))>>0)
+#define VI_SLCNT_get_slcnt2(data)                                                    ((0x000007FF&(data))>>0)
+
+
+#define VI_LLCNT                                                                     0x18004034
+#define VI_LLCNT_reg_addr                                                            "0xB8004034"
+#define VI_LLCNT_reg                                                                 0xB8004034
+#define VI_LLCNT_inst_adr                                                            "0x000D"
+#define VI_LLCNT_inst                                                                0x000D
+#define VI_LLCNT_llcnt1_shift                                                        (11)
+#define VI_LLCNT_llcnt1_mask                                                         (0x003FF800)
+#define VI_LLCNT_llcnt1(data)                                                        (0x003FF800&((data)<<11))
+#define VI_LLCNT_llcnt1_src(data)                                                    ((0x003FF800&(data))>>11)
+#define VI_LLCNT_get_llcnt1(data)                                                    ((0x003FF800&(data))>>11)
+#define VI_LLCNT_llcnt2_shift                                                        (0)
+#define VI_LLCNT_llcnt2_mask                                                         (0x000007FF)
+#define VI_LLCNT_llcnt2(data)                                                        (0x000007FF&((data)<<0))
+#define VI_LLCNT_llcnt2_src(data)                                                    ((0x000007FF&(data))>>0)
+#define VI_LLCNT_get_llcnt2(data)                                                    ((0x000007FF&(data))>>0)
+
+
+#define VI_SLTHRESHOLD                                                               0x18004038
+#define VI_SLTHRESHOLD_reg_addr                                                      "0xB8004038"
+#define VI_SLTHRESHOLD_reg                                                           0xB8004038
+#define VI_SLTHRESHOLD_inst_adr                                                      "0x000E"
+#define VI_SLTHRESHOLD_inst                                                          0x000E
+#define VI_SLTHRESHOLD_write_enable1_shift                                           (23)
+#define VI_SLTHRESHOLD_write_enable1_mask                                            (0x00800000)
+#define VI_SLTHRESHOLD_write_enable1(data)                                           (0x00800000&((data)<<23))
+#define VI_SLTHRESHOLD_write_enable1_src(data)                                       ((0x00800000&(data))>>23)
+#define VI_SLTHRESHOLD_get_write_enable1(data)                                       ((0x00800000&(data))>>23)
+#define VI_SLTHRESHOLD_slthd1_shift                                                  (12)
+#define VI_SLTHRESHOLD_slthd1_mask                                                   (0x007FF000)
+#define VI_SLTHRESHOLD_slthd1(data)                                                  (0x007FF000&((data)<<12))
+#define VI_SLTHRESHOLD_slthd1_src(data)                                              ((0x007FF000&(data))>>12)
+#define VI_SLTHRESHOLD_get_slthd1(data)                                              ((0x007FF000&(data))>>12)
+#define VI_SLTHRESHOLD_write_enable2_shift                                           (11)
+#define VI_SLTHRESHOLD_write_enable2_mask                                            (0x00000800)
+#define VI_SLTHRESHOLD_write_enable2(data)                                           (0x00000800&((data)<<11))
+#define VI_SLTHRESHOLD_write_enable2_src(data)                                       ((0x00000800&(data))>>11)
+#define VI_SLTHRESHOLD_get_write_enable2(data)                                       ((0x00000800&(data))>>11)
+#define VI_SLTHRESHOLD_slthd2_shift                                                  (0)
+#define VI_SLTHRESHOLD_slthd2_mask                                                   (0x000007FF)
+#define VI_SLTHRESHOLD_slthd2(data)                                                  (0x000007FF&((data)<<0))
+#define VI_SLTHRESHOLD_slthd2_src(data)                                              ((0x000007FF&(data))>>0)
+#define VI_SLTHRESHOLD_get_slthd2(data)                                              ((0x000007FF&(data))>>0)
+
+
+#define VI_LLTHRESHOLD                                                               0x1800403c
+#define VI_LLTHRESHOLD_reg_addr                                                      "0xB800403C"
+#define VI_LLTHRESHOLD_reg                                                           0xB800403C
+#define VI_LLTHRESHOLD_inst_adr                                                      "0x000F"
+#define VI_LLTHRESHOLD_inst                                                          0x000F
+#define VI_LLTHRESHOLD_write_enable1_shift                                           (23)
+#define VI_LLTHRESHOLD_write_enable1_mask                                            (0x00800000)
+#define VI_LLTHRESHOLD_write_enable1(data)                                           (0x00800000&((data)<<23))
+#define VI_LLTHRESHOLD_write_enable1_src(data)                                       ((0x00800000&(data))>>23)
+#define VI_LLTHRESHOLD_get_write_enable1(data)                                       ((0x00800000&(data))>>23)
+#define VI_LLTHRESHOLD_llthd1_shift                                                  (12)
+#define VI_LLTHRESHOLD_llthd1_mask                                                   (0x007FF000)
+#define VI_LLTHRESHOLD_llthd1(data)                                                  (0x007FF000&((data)<<12))
+#define VI_LLTHRESHOLD_llthd1_src(data)                                              ((0x007FF000&(data))>>12)
+#define VI_LLTHRESHOLD_get_llthd1(data)                                              ((0x007FF000&(data))>>12)
+#define VI_LLTHRESHOLD_write_enable2_shift                                           (11)
+#define VI_LLTHRESHOLD_write_enable2_mask                                            (0x00000800)
+#define VI_LLTHRESHOLD_write_enable2(data)                                           (0x00000800&((data)<<11))
+#define VI_LLTHRESHOLD_write_enable2_src(data)                                       ((0x00000800&(data))>>11)
+#define VI_LLTHRESHOLD_get_write_enable2(data)                                       ((0x00000800&(data))>>11)
+#define VI_LLTHRESHOLD_llthd2_shift                                                  (0)
+#define VI_LLTHRESHOLD_llthd2_mask                                                   (0x000007FF)
+#define VI_LLTHRESHOLD_llthd2(data)                                                  (0x000007FF&((data)<<0))
+#define VI_LLTHRESHOLD_llthd2_src(data)                                              ((0x000007FF&(data))>>0)
+#define VI_LLTHRESHOLD_get_llthd2(data)                                              ((0x000007FF&(data))>>0)
+
+
+#define VI_VBIWV1F0                                                                  0x18004040
+#define VI_VBIWV1F0_reg_addr                                                         "0xB8004040"
+#define VI_VBIWV1F0_reg                                                              0xB8004040
+#define VI_VBIWV1F0_inst_adr                                                         "0x0010"
+#define VI_VBIWV1F0_inst                                                             0x0010
+#define VI_VBIWV1F0_write_enable5_shift                                              (29)
+#define VI_VBIWV1F0_write_enable5_mask                                               (0x20000000)
+#define VI_VBIWV1F0_write_enable5(data)                                              (0x20000000&((data)<<29))
+#define VI_VBIWV1F0_write_enable5_src(data)                                          ((0x20000000&(data))>>29)
+#define VI_VBIWV1F0_get_write_enable5(data)                                          ((0x20000000&(data))>>29)
+#define VI_VBIWV1F0_write_enable4_shift                                              (27)
+#define VI_VBIWV1F0_write_enable4_mask                                               (0x08000000)
+#define VI_VBIWV1F0_write_enable4(data)                                              (0x08000000&((data)<<27))
+#define VI_VBIWV1F0_write_enable4_src(data)                                          ((0x08000000&(data))>>27)
+#define VI_VBIWV1F0_get_write_enable4(data)                                          ((0x08000000&(data))>>27)
+#define VI_VBIWV1F0_yonly_shift                                                      (26)
+#define VI_VBIWV1F0_yonly_mask                                                       (0x04000000)
+#define VI_VBIWV1F0_yonly(data)                                                      (0x04000000&((data)<<26))
+#define VI_VBIWV1F0_yonly_src(data)                                                  ((0x04000000&(data))>>26)
+#define VI_VBIWV1F0_get_yonly(data)                                                  ((0x04000000&(data))>>26)
+#define VI_VBIWV1F0_write_enable1_shift                                              (25)
+#define VI_VBIWV1F0_write_enable1_mask                                               (0x02000000)
+#define VI_VBIWV1F0_write_enable1(data)                                              (0x02000000&((data)<<25))
+#define VI_VBIWV1F0_write_enable1_src(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWV1F0_get_write_enable1(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWV1F0_enable_shift                                                     (24)
+#define VI_VBIWV1F0_enable_mask                                                      (0x01000000)
+#define VI_VBIWV1F0_enable(data)                                                     (0x01000000&((data)<<24))
+#define VI_VBIWV1F0_enable_src(data)                                                 ((0x01000000&(data))>>24)
+#define VI_VBIWV1F0_get_enable(data)                                                 ((0x01000000&(data))>>24)
+#define VI_VBIWV1F0_write_enable2_shift                                              (23)
+#define VI_VBIWV1F0_write_enable2_mask                                               (0x00800000)
+#define VI_VBIWV1F0_write_enable2(data)                                              (0x00800000&((data)<<23))
+#define VI_VBIWV1F0_write_enable2_src(data)                                          ((0x00800000&(data))>>23)
+#define VI_VBIWV1F0_get_write_enable2(data)                                          ((0x00800000&(data))>>23)
+#define VI_VBIWV1F0_vstart_shift                                                     (12)
+#define VI_VBIWV1F0_vstart_mask                                                      (0x007FF000)
+#define VI_VBIWV1F0_vstart(data)                                                     (0x007FF000&((data)<<12))
+#define VI_VBIWV1F0_vstart_src(data)                                                 ((0x007FF000&(data))>>12)
+#define VI_VBIWV1F0_get_vstart(data)                                                 ((0x007FF000&(data))>>12)
+#define VI_VBIWV1F0_write_enable3_shift                                              (11)
+#define VI_VBIWV1F0_write_enable3_mask                                               (0x00000800)
+#define VI_VBIWV1F0_write_enable3(data)                                              (0x00000800&((data)<<11))
+#define VI_VBIWV1F0_write_enable3_src(data)                                          ((0x00000800&(data))>>11)
+#define VI_VBIWV1F0_get_write_enable3(data)                                          ((0x00000800&(data))>>11)
+#define VI_VBIWV1F0_vend_shift                                                       (0)
+#define VI_VBIWV1F0_vend_mask                                                        (0x000007FF)
+#define VI_VBIWV1F0_vend(data)                                                       (0x000007FF&((data)<<0))
+#define VI_VBIWV1F0_vend_src(data)                                                   ((0x000007FF&(data))>>0)
+#define VI_VBIWV1F0_get_vend(data)                                                   ((0x000007FF&(data))>>0)
+
+
+#define VI_VBIWV1F1                                                                  0x180044c8
+#define VI_VBIWV1F1_reg_addr                                                         "0xB80044C8"
+#define VI_VBIWV1F1_reg                                                              0xB80044C8
+#define VI_VBIWV1F1_inst_adr                                                         "0x0032"
+#define VI_VBIWV1F1_inst                                                             0x0032
+#define VI_VBIWV1F1_write_enable5_shift                                              (29)
+#define VI_VBIWV1F1_write_enable5_mask                                               (0x20000000)
+#define VI_VBIWV1F1_write_enable5(data)                                              (0x20000000&((data)<<29))
+#define VI_VBIWV1F1_write_enable5_src(data)                                          ((0x20000000&(data))>>29)
+#define VI_VBIWV1F1_get_write_enable5(data)                                          ((0x20000000&(data))>>29)
+#define VI_VBIWV1F1_write_enable4_shift                                              (27)
+#define VI_VBIWV1F1_write_enable4_mask                                               (0x08000000)
+#define VI_VBIWV1F1_write_enable4(data)                                              (0x08000000&((data)<<27))
+#define VI_VBIWV1F1_write_enable4_src(data)                                          ((0x08000000&(data))>>27)
+#define VI_VBIWV1F1_get_write_enable4(data)                                          ((0x08000000&(data))>>27)
+#define VI_VBIWV1F1_yonly_shift                                                      (26)
+#define VI_VBIWV1F1_yonly_mask                                                       (0x04000000)
+#define VI_VBIWV1F1_yonly(data)                                                      (0x04000000&((data)<<26))
+#define VI_VBIWV1F1_yonly_src(data)                                                  ((0x04000000&(data))>>26)
+#define VI_VBIWV1F1_get_yonly(data)                                                  ((0x04000000&(data))>>26)
+#define VI_VBIWV1F1_write_enable1_shift                                              (25)
+#define VI_VBIWV1F1_write_enable1_mask                                               (0x02000000)
+#define VI_VBIWV1F1_write_enable1(data)                                              (0x02000000&((data)<<25))
+#define VI_VBIWV1F1_write_enable1_src(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWV1F1_get_write_enable1(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWV1F1_enable_shift                                                     (24)
+#define VI_VBIWV1F1_enable_mask                                                      (0x01000000)
+#define VI_VBIWV1F1_enable(data)                                                     (0x01000000&((data)<<24))
+#define VI_VBIWV1F1_enable_src(data)                                                 ((0x01000000&(data))>>24)
+#define VI_VBIWV1F1_get_enable(data)                                                 ((0x01000000&(data))>>24)
+#define VI_VBIWV1F1_write_enable2_shift                                              (23)
+#define VI_VBIWV1F1_write_enable2_mask                                               (0x00800000)
+#define VI_VBIWV1F1_write_enable2(data)                                              (0x00800000&((data)<<23))
+#define VI_VBIWV1F1_write_enable2_src(data)                                          ((0x00800000&(data))>>23)
+#define VI_VBIWV1F1_get_write_enable2(data)                                          ((0x00800000&(data))>>23)
+#define VI_VBIWV1F1_vstart_shift                                                     (12)
+#define VI_VBIWV1F1_vstart_mask                                                      (0x007FF000)
+#define VI_VBIWV1F1_vstart(data)                                                     (0x007FF000&((data)<<12))
+#define VI_VBIWV1F1_vstart_src(data)                                                 ((0x007FF000&(data))>>12)
+#define VI_VBIWV1F1_get_vstart(data)                                                 ((0x007FF000&(data))>>12)
+#define VI_VBIWV1F1_write_enable3_shift                                              (11)
+#define VI_VBIWV1F1_write_enable3_mask                                               (0x00000800)
+#define VI_VBIWV1F1_write_enable3(data)                                              (0x00000800&((data)<<11))
+#define VI_VBIWV1F1_write_enable3_src(data)                                          ((0x00000800&(data))>>11)
+#define VI_VBIWV1F1_get_write_enable3(data)                                          ((0x00000800&(data))>>11)
+#define VI_VBIWV1F1_vend_shift                                                       (0)
+#define VI_VBIWV1F1_vend_mask                                                        (0x000007FF)
+#define VI_VBIWV1F1_vend(data)                                                       (0x000007FF&((data)<<0))
+#define VI_VBIWV1F1_vend_src(data)                                                   ((0x000007FF&(data))>>0)
+#define VI_VBIWV1F1_get_vend(data)                                                   ((0x000007FF&(data))>>0)
+
+
+#define VI_VBIWV2F0                                                                  0x18004044
+#define VI_VBIWV2F0_reg_addr                                                         "0xB8004044"
+#define VI_VBIWV2F0_reg                                                              0xB8004044
+#define VI_VBIWV2F0_inst_adr                                                         "0x0011"
+#define VI_VBIWV2F0_inst                                                             0x0011
+#define VI_VBIWV2F0_write_enable5_shift                                              (29)
+#define VI_VBIWV2F0_write_enable5_mask                                               (0x20000000)
+#define VI_VBIWV2F0_write_enable5(data)                                              (0x20000000&((data)<<29))
+#define VI_VBIWV2F0_write_enable5_src(data)                                          ((0x20000000&(data))>>29)
+#define VI_VBIWV2F0_get_write_enable5(data)                                          ((0x20000000&(data))>>29)
+#define VI_VBIWV2F0_write_enable1_shift                                              (27)
+#define VI_VBIWV2F0_write_enable1_mask                                               (0x08000000)
+#define VI_VBIWV2F0_write_enable1(data)                                              (0x08000000&((data)<<27))
+#define VI_VBIWV2F0_write_enable1_src(data)                                          ((0x08000000&(data))>>27)
+#define VI_VBIWV2F0_get_write_enable1(data)                                          ((0x08000000&(data))>>27)
+#define VI_VBIWV2F0_yonly_shift                                                      (26)
+#define VI_VBIWV2F0_yonly_mask                                                       (0x04000000)
+#define VI_VBIWV2F0_yonly(data)                                                      (0x04000000&((data)<<26))
+#define VI_VBIWV2F0_yonly_src(data)                                                  ((0x04000000&(data))>>26)
+#define VI_VBIWV2F0_get_yonly(data)                                                  ((0x04000000&(data))>>26)
+#define VI_VBIWV2F0_write_enable2_shift                                              (25)
+#define VI_VBIWV2F0_write_enable2_mask                                               (0x02000000)
+#define VI_VBIWV2F0_write_enable2(data)                                              (0x02000000&((data)<<25))
+#define VI_VBIWV2F0_write_enable2_src(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWV2F0_get_write_enable2(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWV2F0_enable_shift                                                     (24)
+#define VI_VBIWV2F0_enable_mask                                                      (0x01000000)
+#define VI_VBIWV2F0_enable(data)                                                     (0x01000000&((data)<<24))
+#define VI_VBIWV2F0_enable_src(data)                                                 ((0x01000000&(data))>>24)
+#define VI_VBIWV2F0_get_enable(data)                                                 ((0x01000000&(data))>>24)
+#define VI_VBIWV2F0_write_enable3_shift                                              (23)
+#define VI_VBIWV2F0_write_enable3_mask                                               (0x00800000)
+#define VI_VBIWV2F0_write_enable3(data)                                              (0x00800000&((data)<<23))
+#define VI_VBIWV2F0_write_enable3_src(data)                                          ((0x00800000&(data))>>23)
+#define VI_VBIWV2F0_get_write_enable3(data)                                          ((0x00800000&(data))>>23)
+#define VI_VBIWV2F0_vstart_shift                                                     (12)
+#define VI_VBIWV2F0_vstart_mask                                                      (0x007FF000)
+#define VI_VBIWV2F0_vstart(data)                                                     (0x007FF000&((data)<<12))
+#define VI_VBIWV2F0_vstart_src(data)                                                 ((0x007FF000&(data))>>12)
+#define VI_VBIWV2F0_get_vstart(data)                                                 ((0x007FF000&(data))>>12)
+#define VI_VBIWV2F0_write_enable4_shift                                              (11)
+#define VI_VBIWV2F0_write_enable4_mask                                               (0x00000800)
+#define VI_VBIWV2F0_write_enable4(data)                                              (0x00000800&((data)<<11))
+#define VI_VBIWV2F0_write_enable4_src(data)                                          ((0x00000800&(data))>>11)
+#define VI_VBIWV2F0_get_write_enable4(data)                                          ((0x00000800&(data))>>11)
+#define VI_VBIWV2F0_vend_shift                                                       (0)
+#define VI_VBIWV2F0_vend_mask                                                        (0x000007FF)
+#define VI_VBIWV2F0_vend(data)                                                       (0x000007FF&((data)<<0))
+#define VI_VBIWV2F0_vend_src(data)                                                   ((0x000007FF&(data))>>0)
+#define VI_VBIWV2F0_get_vend(data)                                                   ((0x000007FF&(data))>>0)
+
+
+#define VI_VBIWV2F1                                                                  0x180044cc
+#define VI_VBIWV2F1_reg_addr                                                         "0xB80044CC"
+#define VI_VBIWV2F1_reg                                                              0xB80044CC
+#define VI_VBIWV2F1_inst_adr                                                         "0x0033"
+#define VI_VBIWV2F1_inst                                                             0x0033
+#define VI_VBIWV2F1_write_enable5_shift                                              (29)
+#define VI_VBIWV2F1_write_enable5_mask                                               (0x20000000)
+#define VI_VBIWV2F1_write_enable5(data)                                              (0x20000000&((data)<<29))
+#define VI_VBIWV2F1_write_enable5_src(data)                                          ((0x20000000&(data))>>29)
+#define VI_VBIWV2F1_get_write_enable5(data)                                          ((0x20000000&(data))>>29)
+#define VI_VBIWV2F1_write_enable1_shift                                              (27)
+#define VI_VBIWV2F1_write_enable1_mask                                               (0x08000000)
+#define VI_VBIWV2F1_write_enable1(data)                                              (0x08000000&((data)<<27))
+#define VI_VBIWV2F1_write_enable1_src(data)                                          ((0x08000000&(data))>>27)
+#define VI_VBIWV2F1_get_write_enable1(data)                                          ((0x08000000&(data))>>27)
+#define VI_VBIWV2F1_yonly_shift                                                      (26)
+#define VI_VBIWV2F1_yonly_mask                                                       (0x04000000)
+#define VI_VBIWV2F1_yonly(data)                                                      (0x04000000&((data)<<26))
+#define VI_VBIWV2F1_yonly_src(data)                                                  ((0x04000000&(data))>>26)
+#define VI_VBIWV2F1_get_yonly(data)                                                  ((0x04000000&(data))>>26)
+#define VI_VBIWV2F1_write_enable2_shift                                              (25)
+#define VI_VBIWV2F1_write_enable2_mask                                               (0x02000000)
+#define VI_VBIWV2F1_write_enable2(data)                                              (0x02000000&((data)<<25))
+#define VI_VBIWV2F1_write_enable2_src(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWV2F1_get_write_enable2(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWV2F1_enable_shift                                                     (24)
+#define VI_VBIWV2F1_enable_mask                                                      (0x01000000)
+#define VI_VBIWV2F1_enable(data)                                                     (0x01000000&((data)<<24))
+#define VI_VBIWV2F1_enable_src(data)                                                 ((0x01000000&(data))>>24)
+#define VI_VBIWV2F1_get_enable(data)                                                 ((0x01000000&(data))>>24)
+#define VI_VBIWV2F1_write_enable3_shift                                              (23)
+#define VI_VBIWV2F1_write_enable3_mask                                               (0x00800000)
+#define VI_VBIWV2F1_write_enable3(data)                                              (0x00800000&((data)<<23))
+#define VI_VBIWV2F1_write_enable3_src(data)                                          ((0x00800000&(data))>>23)
+#define VI_VBIWV2F1_get_write_enable3(data)                                          ((0x00800000&(data))>>23)
+#define VI_VBIWV2F1_vstart_shift                                                     (12)
+#define VI_VBIWV2F1_vstart_mask                                                      (0x007FF000)
+#define VI_VBIWV2F1_vstart(data)                                                     (0x007FF000&((data)<<12))
+#define VI_VBIWV2F1_vstart_src(data)                                                 ((0x007FF000&(data))>>12)
+#define VI_VBIWV2F1_get_vstart(data)                                                 ((0x007FF000&(data))>>12)
+#define VI_VBIWV2F1_write_enable4_shift                                              (11)
+#define VI_VBIWV2F1_write_enable4_mask                                               (0x00000800)
+#define VI_VBIWV2F1_write_enable4(data)                                              (0x00000800&((data)<<11))
+#define VI_VBIWV2F1_write_enable4_src(data)                                          ((0x00000800&(data))>>11)
+#define VI_VBIWV2F1_get_write_enable4(data)                                          ((0x00000800&(data))>>11)
+#define VI_VBIWV2F1_vend_shift                                                       (0)
+#define VI_VBIWV2F1_vend_mask                                                        (0x000007FF)
+#define VI_VBIWV2F1_vend(data)                                                       (0x000007FF&((data)<<0))
+#define VI_VBIWV2F1_vend_src(data)                                                   ((0x000007FF&(data))>>0)
+#define VI_VBIWV2F1_get_vend(data)                                                   ((0x000007FF&(data))>>0)
+
+
+#define VI_VBIWH1F0                                                                  0x18004048
+#define VI_VBIWH1F0_reg_addr                                                         "0xB8004048"
+#define VI_VBIWH1F0_reg                                                              0xB8004048
+#define VI_VBIWH1F0_inst_adr                                                         "0x0012"
+#define VI_VBIWH1F0_inst                                                             0x0012
+#define VI_VBIWH1F0_write_enable1_shift                                              (25)
+#define VI_VBIWH1F0_write_enable1_mask                                               (0x02000000)
+#define VI_VBIWH1F0_write_enable1(data)                                              (0x02000000&((data)<<25))
+#define VI_VBIWH1F0_write_enable1_src(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWH1F0_get_write_enable1(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWH1F0_hstart_shift                                                     (13)
+#define VI_VBIWH1F0_hstart_mask                                                      (0x01FFE000)
+#define VI_VBIWH1F0_hstart(data)                                                     (0x01FFE000&((data)<<13))
+#define VI_VBIWH1F0_hstart_src(data)                                                 ((0x01FFE000&(data))>>13)
+#define VI_VBIWH1F0_get_hstart(data)                                                 ((0x01FFE000&(data))>>13)
+#define VI_VBIWH1F0_write_enable2_shift                                              (12)
+#define VI_VBIWH1F0_write_enable2_mask                                               (0x00001000)
+#define VI_VBIWH1F0_write_enable2(data)                                              (0x00001000&((data)<<12))
+#define VI_VBIWH1F0_write_enable2_src(data)                                          ((0x00001000&(data))>>12)
+#define VI_VBIWH1F0_get_write_enable2(data)                                          ((0x00001000&(data))>>12)
+#define VI_VBIWH1F0_hend_shift                                                       (0)
+#define VI_VBIWH1F0_hend_mask                                                        (0x00000FFF)
+#define VI_VBIWH1F0_hend(data)                                                       (0x00000FFF&((data)<<0))
+#define VI_VBIWH1F0_hend_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VI_VBIWH1F0_get_hend(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VI_VBIWH1F1                                                                  0x180044d0
+#define VI_VBIWH1F1_reg_addr                                                         "0xB80044D0"
+#define VI_VBIWH1F1_reg                                                              0xB80044D0
+#define VI_VBIWH1F1_inst_adr                                                         "0x0034"
+#define VI_VBIWH1F1_inst                                                             0x0034
+#define VI_VBIWH1F1_write_enable1_shift                                              (25)
+#define VI_VBIWH1F1_write_enable1_mask                                               (0x02000000)
+#define VI_VBIWH1F1_write_enable1(data)                                              (0x02000000&((data)<<25))
+#define VI_VBIWH1F1_write_enable1_src(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWH1F1_get_write_enable1(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWH1F1_hstart_shift                                                     (13)
+#define VI_VBIWH1F1_hstart_mask                                                      (0x01FFE000)
+#define VI_VBIWH1F1_hstart(data)                                                     (0x01FFE000&((data)<<13))
+#define VI_VBIWH1F1_hstart_src(data)                                                 ((0x01FFE000&(data))>>13)
+#define VI_VBIWH1F1_get_hstart(data)                                                 ((0x01FFE000&(data))>>13)
+#define VI_VBIWH1F1_write_enable2_shift                                              (12)
+#define VI_VBIWH1F1_write_enable2_mask                                               (0x00001000)
+#define VI_VBIWH1F1_write_enable2(data)                                              (0x00001000&((data)<<12))
+#define VI_VBIWH1F1_write_enable2_src(data)                                          ((0x00001000&(data))>>12)
+#define VI_VBIWH1F1_get_write_enable2(data)                                          ((0x00001000&(data))>>12)
+#define VI_VBIWH1F1_hend_shift                                                       (0)
+#define VI_VBIWH1F1_hend_mask                                                        (0x00000FFF)
+#define VI_VBIWH1F1_hend(data)                                                       (0x00000FFF&((data)<<0))
+#define VI_VBIWH1F1_hend_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VI_VBIWH1F1_get_hend(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VI_VBIWH2F0                                                                  0x1800404c
+#define VI_VBIWH2F0_reg_addr                                                         "0xB800404C"
+#define VI_VBIWH2F0_reg                                                              0xB800404C
+#define VI_VBIWH2F0_inst_adr                                                         "0x0013"
+#define VI_VBIWH2F0_inst                                                             0x0013
+#define VI_VBIWH2F0_write_enable1_shift                                              (25)
+#define VI_VBIWH2F0_write_enable1_mask                                               (0x02000000)
+#define VI_VBIWH2F0_write_enable1(data)                                              (0x02000000&((data)<<25))
+#define VI_VBIWH2F0_write_enable1_src(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWH2F0_get_write_enable1(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWH2F0_hstart_shift                                                     (13)
+#define VI_VBIWH2F0_hstart_mask                                                      (0x01FFE000)
+#define VI_VBIWH2F0_hstart(data)                                                     (0x01FFE000&((data)<<13))
+#define VI_VBIWH2F0_hstart_src(data)                                                 ((0x01FFE000&(data))>>13)
+#define VI_VBIWH2F0_get_hstart(data)                                                 ((0x01FFE000&(data))>>13)
+#define VI_VBIWH2F0_write_enable2_shift                                              (12)
+#define VI_VBIWH2F0_write_enable2_mask                                               (0x00001000)
+#define VI_VBIWH2F0_write_enable2(data)                                              (0x00001000&((data)<<12))
+#define VI_VBIWH2F0_write_enable2_src(data)                                          ((0x00001000&(data))>>12)
+#define VI_VBIWH2F0_get_write_enable2(data)                                          ((0x00001000&(data))>>12)
+#define VI_VBIWH2F0_hend_shift                                                       (0)
+#define VI_VBIWH2F0_hend_mask                                                        (0x00000FFF)
+#define VI_VBIWH2F0_hend(data)                                                       (0x00000FFF&((data)<<0))
+#define VI_VBIWH2F0_hend_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VI_VBIWH2F0_get_hend(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VI_VBIWH2F1                                                                  0x180044d4
+#define VI_VBIWH2F1_reg_addr                                                         "0xB80044D4"
+#define VI_VBIWH2F1_reg                                                              0xB80044D4
+#define VI_VBIWH2F1_inst_adr                                                         "0x0035"
+#define VI_VBIWH2F1_inst                                                             0x0035
+#define VI_VBIWH2F1_write_enable1_shift                                              (25)
+#define VI_VBIWH2F1_write_enable1_mask                                               (0x02000000)
+#define VI_VBIWH2F1_write_enable1(data)                                              (0x02000000&((data)<<25))
+#define VI_VBIWH2F1_write_enable1_src(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWH2F1_get_write_enable1(data)                                          ((0x02000000&(data))>>25)
+#define VI_VBIWH2F1_hstart_shift                                                     (13)
+#define VI_VBIWH2F1_hstart_mask                                                      (0x01FFE000)
+#define VI_VBIWH2F1_hstart(data)                                                     (0x01FFE000&((data)<<13))
+#define VI_VBIWH2F1_hstart_src(data)                                                 ((0x01FFE000&(data))>>13)
+#define VI_VBIWH2F1_get_hstart(data)                                                 ((0x01FFE000&(data))>>13)
+#define VI_VBIWH2F1_write_enable2_shift                                              (12)
+#define VI_VBIWH2F1_write_enable2_mask                                               (0x00001000)
+#define VI_VBIWH2F1_write_enable2(data)                                              (0x00001000&((data)<<12))
+#define VI_VBIWH2F1_write_enable2_src(data)                                          ((0x00001000&(data))>>12)
+#define VI_VBIWH2F1_get_write_enable2(data)                                          ((0x00001000&(data))>>12)
+#define VI_VBIWH2F1_hend_shift                                                       (0)
+#define VI_VBIWH2F1_hend_mask                                                        (0x00000FFF)
+#define VI_VBIWH2F1_hend(data)                                                       (0x00000FFF&((data)<<0))
+#define VI_VBIWH2F1_hend_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VI_VBIWH2F1_get_hend(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VI_VBIWV1F0_SC                                                               0x180044f0
+#define VI_VBIWV1F0_SC_reg_addr                                                      "0xB80044F0"
+#define VI_VBIWV1F0_SC_reg                                                           0xB80044F0
+#define VI_VBIWV1F0_SC_inst_adr                                                      "0x003C"
+#define VI_VBIWV1F0_SC_inst                                                          0x003C
+#define VI_VBIWV1F0_SC_write_enable1_shift                                           (25)
+#define VI_VBIWV1F0_SC_write_enable1_mask                                            (0x02000000)
+#define VI_VBIWV1F0_SC_write_enable1(data)                                           (0x02000000&((data)<<25))
+#define VI_VBIWV1F0_SC_write_enable1_src(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWV1F0_SC_get_write_enable1(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWV1F0_SC_en_shift                                                      (24)
+#define VI_VBIWV1F0_SC_en_mask                                                       (0x01000000)
+#define VI_VBIWV1F0_SC_en(data)                                                      (0x01000000&((data)<<24))
+#define VI_VBIWV1F0_SC_en_src(data)                                                  ((0x01000000&(data))>>24)
+#define VI_VBIWV1F0_SC_get_en(data)                                                  ((0x01000000&(data))>>24)
+#define VI_VBIWV1F0_SC_write_enable2_shift                                           (23)
+#define VI_VBIWV1F0_SC_write_enable2_mask                                            (0x00800000)
+#define VI_VBIWV1F0_SC_write_enable2(data)                                           (0x00800000&((data)<<23))
+#define VI_VBIWV1F0_SC_write_enable2_src(data)                                       ((0x00800000&(data))>>23)
+#define VI_VBIWV1F0_SC_get_write_enable2(data)                                       ((0x00800000&(data))>>23)
+#define VI_VBIWV1F0_SC_vstart_shift                                                  (12)
+#define VI_VBIWV1F0_SC_vstart_mask                                                   (0x007FF000)
+#define VI_VBIWV1F0_SC_vstart(data)                                                  (0x007FF000&((data)<<12))
+#define VI_VBIWV1F0_SC_vstart_src(data)                                              ((0x007FF000&(data))>>12)
+#define VI_VBIWV1F0_SC_get_vstart(data)                                              ((0x007FF000&(data))>>12)
+#define VI_VBIWV1F0_SC_write_enable3_shift                                           (11)
+#define VI_VBIWV1F0_SC_write_enable3_mask                                            (0x00000800)
+#define VI_VBIWV1F0_SC_write_enable3(data)                                           (0x00000800&((data)<<11))
+#define VI_VBIWV1F0_SC_write_enable3_src(data)                                       ((0x00000800&(data))>>11)
+#define VI_VBIWV1F0_SC_get_write_enable3(data)                                       ((0x00000800&(data))>>11)
+#define VI_VBIWV1F0_SC_vend_shift                                                    (0)
+#define VI_VBIWV1F0_SC_vend_mask                                                     (0x000007FF)
+#define VI_VBIWV1F0_SC_vend(data)                                                    (0x000007FF&((data)<<0))
+#define VI_VBIWV1F0_SC_vend_src(data)                                                ((0x000007FF&(data))>>0)
+#define VI_VBIWV1F0_SC_get_vend(data)                                                ((0x000007FF&(data))>>0)
+
+
+#define VI_VBIWV1F1_SC                                                               0x180044f4
+#define VI_VBIWV1F1_SC_reg_addr                                                      "0xB80044F4"
+#define VI_VBIWV1F1_SC_reg                                                           0xB80044F4
+#define VI_VBIWV1F1_SC_inst_adr                                                      "0x003D"
+#define VI_VBIWV1F1_SC_inst                                                          0x003D
+#define VI_VBIWV1F1_SC_write_enable1_shift                                           (25)
+#define VI_VBIWV1F1_SC_write_enable1_mask                                            (0x02000000)
+#define VI_VBIWV1F1_SC_write_enable1(data)                                           (0x02000000&((data)<<25))
+#define VI_VBIWV1F1_SC_write_enable1_src(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWV1F1_SC_get_write_enable1(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWV1F1_SC_en_shift                                                      (24)
+#define VI_VBIWV1F1_SC_en_mask                                                       (0x01000000)
+#define VI_VBIWV1F1_SC_en(data)                                                      (0x01000000&((data)<<24))
+#define VI_VBIWV1F1_SC_en_src(data)                                                  ((0x01000000&(data))>>24)
+#define VI_VBIWV1F1_SC_get_en(data)                                                  ((0x01000000&(data))>>24)
+#define VI_VBIWV1F1_SC_write_enable2_shift                                           (23)
+#define VI_VBIWV1F1_SC_write_enable2_mask                                            (0x00800000)
+#define VI_VBIWV1F1_SC_write_enable2(data)                                           (0x00800000&((data)<<23))
+#define VI_VBIWV1F1_SC_write_enable2_src(data)                                       ((0x00800000&(data))>>23)
+#define VI_VBIWV1F1_SC_get_write_enable2(data)                                       ((0x00800000&(data))>>23)
+#define VI_VBIWV1F1_SC_vstart_shift                                                  (12)
+#define VI_VBIWV1F1_SC_vstart_mask                                                   (0x007FF000)
+#define VI_VBIWV1F1_SC_vstart(data)                                                  (0x007FF000&((data)<<12))
+#define VI_VBIWV1F1_SC_vstart_src(data)                                              ((0x007FF000&(data))>>12)
+#define VI_VBIWV1F1_SC_get_vstart(data)                                              ((0x007FF000&(data))>>12)
+#define VI_VBIWV1F1_SC_write_enable3_shift                                           (11)
+#define VI_VBIWV1F1_SC_write_enable3_mask                                            (0x00000800)
+#define VI_VBIWV1F1_SC_write_enable3(data)                                           (0x00000800&((data)<<11))
+#define VI_VBIWV1F1_SC_write_enable3_src(data)                                       ((0x00000800&(data))>>11)
+#define VI_VBIWV1F1_SC_get_write_enable3(data)                                       ((0x00000800&(data))>>11)
+#define VI_VBIWV1F1_SC_vend_shift                                                    (0)
+#define VI_VBIWV1F1_SC_vend_mask                                                     (0x000007FF)
+#define VI_VBIWV1F1_SC_vend(data)                                                    (0x000007FF&((data)<<0))
+#define VI_VBIWV1F1_SC_vend_src(data)                                                ((0x000007FF&(data))>>0)
+#define VI_VBIWV1F1_SC_get_vend(data)                                                ((0x000007FF&(data))>>0)
+
+
+#define VI_VBIWV2F0_SC                                                               0x180044f8
+#define VI_VBIWV2F0_SC_reg_addr                                                      "0xB80044F8"
+#define VI_VBIWV2F0_SC_reg                                                           0xB80044F8
+#define VI_VBIWV2F0_SC_inst_adr                                                      "0x003E"
+#define VI_VBIWV2F0_SC_inst                                                          0x003E
+#define VI_VBIWV2F0_SC_write_enable1_shift                                           (25)
+#define VI_VBIWV2F0_SC_write_enable1_mask                                            (0x02000000)
+#define VI_VBIWV2F0_SC_write_enable1(data)                                           (0x02000000&((data)<<25))
+#define VI_VBIWV2F0_SC_write_enable1_src(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWV2F0_SC_get_write_enable1(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWV2F0_SC_en_shift                                                      (24)
+#define VI_VBIWV2F0_SC_en_mask                                                       (0x01000000)
+#define VI_VBIWV2F0_SC_en(data)                                                      (0x01000000&((data)<<24))
+#define VI_VBIWV2F0_SC_en_src(data)                                                  ((0x01000000&(data))>>24)
+#define VI_VBIWV2F0_SC_get_en(data)                                                  ((0x01000000&(data))>>24)
+#define VI_VBIWV2F0_SC_write_enable2_shift                                           (23)
+#define VI_VBIWV2F0_SC_write_enable2_mask                                            (0x00800000)
+#define VI_VBIWV2F0_SC_write_enable2(data)                                           (0x00800000&((data)<<23))
+#define VI_VBIWV2F0_SC_write_enable2_src(data)                                       ((0x00800000&(data))>>23)
+#define VI_VBIWV2F0_SC_get_write_enable2(data)                                       ((0x00800000&(data))>>23)
+#define VI_VBIWV2F0_SC_vstart_shift                                                  (12)
+#define VI_VBIWV2F0_SC_vstart_mask                                                   (0x007FF000)
+#define VI_VBIWV2F0_SC_vstart(data)                                                  (0x007FF000&((data)<<12))
+#define VI_VBIWV2F0_SC_vstart_src(data)                                              ((0x007FF000&(data))>>12)
+#define VI_VBIWV2F0_SC_get_vstart(data)                                              ((0x007FF000&(data))>>12)
+#define VI_VBIWV2F0_SC_write_enable3_shift                                           (11)
+#define VI_VBIWV2F0_SC_write_enable3_mask                                            (0x00000800)
+#define VI_VBIWV2F0_SC_write_enable3(data)                                           (0x00000800&((data)<<11))
+#define VI_VBIWV2F0_SC_write_enable3_src(data)                                       ((0x00000800&(data))>>11)
+#define VI_VBIWV2F0_SC_get_write_enable3(data)                                       ((0x00000800&(data))>>11)
+#define VI_VBIWV2F0_SC_vend_shift                                                    (0)
+#define VI_VBIWV2F0_SC_vend_mask                                                     (0x000007FF)
+#define VI_VBIWV2F0_SC_vend(data)                                                    (0x000007FF&((data)<<0))
+#define VI_VBIWV2F0_SC_vend_src(data)                                                ((0x000007FF&(data))>>0)
+#define VI_VBIWV2F0_SC_get_vend(data)                                                ((0x000007FF&(data))>>0)
+
+
+#define VI_VBIWV2F1_SC                                                               0x180044fc
+#define VI_VBIWV2F1_SC_reg_addr                                                      "0xB80044FC"
+#define VI_VBIWV2F1_SC_reg                                                           0xB80044FC
+#define VI_VBIWV2F1_SC_inst_adr                                                      "0x003F"
+#define VI_VBIWV2F1_SC_inst                                                          0x003F
+#define VI_VBIWV2F1_SC_write_enable1_shift                                           (25)
+#define VI_VBIWV2F1_SC_write_enable1_mask                                            (0x02000000)
+#define VI_VBIWV2F1_SC_write_enable1(data)                                           (0x02000000&((data)<<25))
+#define VI_VBIWV2F1_SC_write_enable1_src(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWV2F1_SC_get_write_enable1(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWV2F1_SC_en_shift                                                      (24)
+#define VI_VBIWV2F1_SC_en_mask                                                       (0x01000000)
+#define VI_VBIWV2F1_SC_en(data)                                                      (0x01000000&((data)<<24))
+#define VI_VBIWV2F1_SC_en_src(data)                                                  ((0x01000000&(data))>>24)
+#define VI_VBIWV2F1_SC_get_en(data)                                                  ((0x01000000&(data))>>24)
+#define VI_VBIWV2F1_SC_write_enable2_shift                                           (23)
+#define VI_VBIWV2F1_SC_write_enable2_mask                                            (0x00800000)
+#define VI_VBIWV2F1_SC_write_enable2(data)                                           (0x00800000&((data)<<23))
+#define VI_VBIWV2F1_SC_write_enable2_src(data)                                       ((0x00800000&(data))>>23)
+#define VI_VBIWV2F1_SC_get_write_enable2(data)                                       ((0x00800000&(data))>>23)
+#define VI_VBIWV2F1_SC_vstart_shift                                                  (12)
+#define VI_VBIWV2F1_SC_vstart_mask                                                   (0x007FF000)
+#define VI_VBIWV2F1_SC_vstart(data)                                                  (0x007FF000&((data)<<12))
+#define VI_VBIWV2F1_SC_vstart_src(data)                                              ((0x007FF000&(data))>>12)
+#define VI_VBIWV2F1_SC_get_vstart(data)                                              ((0x007FF000&(data))>>12)
+#define VI_VBIWV2F1_SC_write_enable3_shift                                           (11)
+#define VI_VBIWV2F1_SC_write_enable3_mask                                            (0x00000800)
+#define VI_VBIWV2F1_SC_write_enable3(data)                                           (0x00000800&((data)<<11))
+#define VI_VBIWV2F1_SC_write_enable3_src(data)                                       ((0x00000800&(data))>>11)
+#define VI_VBIWV2F1_SC_get_write_enable3(data)                                       ((0x00000800&(data))>>11)
+#define VI_VBIWV2F1_SC_vend_shift                                                    (0)
+#define VI_VBIWV2F1_SC_vend_mask                                                     (0x000007FF)
+#define VI_VBIWV2F1_SC_vend(data)                                                    (0x000007FF&((data)<<0))
+#define VI_VBIWV2F1_SC_vend_src(data)                                                ((0x000007FF&(data))>>0)
+#define VI_VBIWV2F1_SC_get_vend(data)                                                ((0x000007FF&(data))>>0)
+
+
+#define VI_VBIWH1F0_SC                                                               0x18004500
+#define VI_VBIWH1F0_SC_reg_addr                                                      "0xB8004500"
+#define VI_VBIWH1F0_SC_reg                                                           0xB8004500
+#define VI_VBIWH1F0_SC_inst_adr                                                      "0x0040"
+#define VI_VBIWH1F0_SC_inst                                                          0x0040
+#define VI_VBIWH1F0_SC_write_enable1_shift                                           (25)
+#define VI_VBIWH1F0_SC_write_enable1_mask                                            (0x02000000)
+#define VI_VBIWH1F0_SC_write_enable1(data)                                           (0x02000000&((data)<<25))
+#define VI_VBIWH1F0_SC_write_enable1_src(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWH1F0_SC_get_write_enable1(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWH1F0_SC_hstart_shift                                                  (13)
+#define VI_VBIWH1F0_SC_hstart_mask                                                   (0x01FFE000)
+#define VI_VBIWH1F0_SC_hstart(data)                                                  (0x01FFE000&((data)<<13))
+#define VI_VBIWH1F0_SC_hstart_src(data)                                              ((0x01FFE000&(data))>>13)
+#define VI_VBIWH1F0_SC_get_hstart(data)                                              ((0x01FFE000&(data))>>13)
+#define VI_VBIWH1F0_SC_write_enable2_shift                                           (12)
+#define VI_VBIWH1F0_SC_write_enable2_mask                                            (0x00001000)
+#define VI_VBIWH1F0_SC_write_enable2(data)                                           (0x00001000&((data)<<12))
+#define VI_VBIWH1F0_SC_write_enable2_src(data)                                       ((0x00001000&(data))>>12)
+#define VI_VBIWH1F0_SC_get_write_enable2(data)                                       ((0x00001000&(data))>>12)
+#define VI_VBIWH1F0_SC_hend_shift                                                    (0)
+#define VI_VBIWH1F0_SC_hend_mask                                                     (0x00000FFF)
+#define VI_VBIWH1F0_SC_hend(data)                                                    (0x00000FFF&((data)<<0))
+#define VI_VBIWH1F0_SC_hend_src(data)                                                ((0x00000FFF&(data))>>0)
+#define VI_VBIWH1F0_SC_get_hend(data)                                                ((0x00000FFF&(data))>>0)
+
+
+#define VI_VBIWH1F1_SC                                                               0x18004504
+#define VI_VBIWH1F1_SC_reg_addr                                                      "0xB8004504"
+#define VI_VBIWH1F1_SC_reg                                                           0xB8004504
+#define VI_VBIWH1F1_SC_inst_adr                                                      "0x0041"
+#define VI_VBIWH1F1_SC_inst                                                          0x0041
+#define VI_VBIWH1F1_SC_write_enable1_shift                                           (25)
+#define VI_VBIWH1F1_SC_write_enable1_mask                                            (0x02000000)
+#define VI_VBIWH1F1_SC_write_enable1(data)                                           (0x02000000&((data)<<25))
+#define VI_VBIWH1F1_SC_write_enable1_src(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWH1F1_SC_get_write_enable1(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWH1F1_SC_hstart_shift                                                  (13)
+#define VI_VBIWH1F1_SC_hstart_mask                                                   (0x01FFE000)
+#define VI_VBIWH1F1_SC_hstart(data)                                                  (0x01FFE000&((data)<<13))
+#define VI_VBIWH1F1_SC_hstart_src(data)                                              ((0x01FFE000&(data))>>13)
+#define VI_VBIWH1F1_SC_get_hstart(data)                                              ((0x01FFE000&(data))>>13)
+#define VI_VBIWH1F1_SC_write_enable2_shift                                           (12)
+#define VI_VBIWH1F1_SC_write_enable2_mask                                            (0x00001000)
+#define VI_VBIWH1F1_SC_write_enable2(data)                                           (0x00001000&((data)<<12))
+#define VI_VBIWH1F1_SC_write_enable2_src(data)                                       ((0x00001000&(data))>>12)
+#define VI_VBIWH1F1_SC_get_write_enable2(data)                                       ((0x00001000&(data))>>12)
+#define VI_VBIWH1F1_SC_hend_shift                                                    (0)
+#define VI_VBIWH1F1_SC_hend_mask                                                     (0x00000FFF)
+#define VI_VBIWH1F1_SC_hend(data)                                                    (0x00000FFF&((data)<<0))
+#define VI_VBIWH1F1_SC_hend_src(data)                                                ((0x00000FFF&(data))>>0)
+#define VI_VBIWH1F1_SC_get_hend(data)                                                ((0x00000FFF&(data))>>0)
+
+
+#define VI_VBIWH2F0_SC                                                               0x18004508
+#define VI_VBIWH2F0_SC_reg_addr                                                      "0xB8004508"
+#define VI_VBIWH2F0_SC_reg                                                           0xB8004508
+#define VI_VBIWH2F0_SC_inst_adr                                                      "0x0042"
+#define VI_VBIWH2F0_SC_inst                                                          0x0042
+#define VI_VBIWH2F0_SC_write_enable1_shift                                           (25)
+#define VI_VBIWH2F0_SC_write_enable1_mask                                            (0x02000000)
+#define VI_VBIWH2F0_SC_write_enable1(data)                                           (0x02000000&((data)<<25))
+#define VI_VBIWH2F0_SC_write_enable1_src(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWH2F0_SC_get_write_enable1(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWH2F0_SC_hstart_shift                                                  (13)
+#define VI_VBIWH2F0_SC_hstart_mask                                                   (0x01FFE000)
+#define VI_VBIWH2F0_SC_hstart(data)                                                  (0x01FFE000&((data)<<13))
+#define VI_VBIWH2F0_SC_hstart_src(data)                                              ((0x01FFE000&(data))>>13)
+#define VI_VBIWH2F0_SC_get_hstart(data)                                              ((0x01FFE000&(data))>>13)
+#define VI_VBIWH2F0_SC_write_enable2_shift                                           (12)
+#define VI_VBIWH2F0_SC_write_enable2_mask                                            (0x00001000)
+#define VI_VBIWH2F0_SC_write_enable2(data)                                           (0x00001000&((data)<<12))
+#define VI_VBIWH2F0_SC_write_enable2_src(data)                                       ((0x00001000&(data))>>12)
+#define VI_VBIWH2F0_SC_get_write_enable2(data)                                       ((0x00001000&(data))>>12)
+#define VI_VBIWH2F0_SC_hend_shift                                                    (0)
+#define VI_VBIWH2F0_SC_hend_mask                                                     (0x00000FFF)
+#define VI_VBIWH2F0_SC_hend(data)                                                    (0x00000FFF&((data)<<0))
+#define VI_VBIWH2F0_SC_hend_src(data)                                                ((0x00000FFF&(data))>>0)
+#define VI_VBIWH2F0_SC_get_hend(data)                                                ((0x00000FFF&(data))>>0)
+
+
+#define VI_VBIWH2F1_SC                                                               0x1800450c
+#define VI_VBIWH2F1_SC_reg_addr                                                      "0xB800450C"
+#define VI_VBIWH2F1_SC_reg                                                           0xB800450C
+#define VI_VBIWH2F1_SC_inst_adr                                                      "0x0043"
+#define VI_VBIWH2F1_SC_inst                                                          0x0043
+#define VI_VBIWH2F1_SC_write_enable1_shift                                           (25)
+#define VI_VBIWH2F1_SC_write_enable1_mask                                            (0x02000000)
+#define VI_VBIWH2F1_SC_write_enable1(data)                                           (0x02000000&((data)<<25))
+#define VI_VBIWH2F1_SC_write_enable1_src(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWH2F1_SC_get_write_enable1(data)                                       ((0x02000000&(data))>>25)
+#define VI_VBIWH2F1_SC_hstart_shift                                                  (13)
+#define VI_VBIWH2F1_SC_hstart_mask                                                   (0x01FFE000)
+#define VI_VBIWH2F1_SC_hstart(data)                                                  (0x01FFE000&((data)<<13))
+#define VI_VBIWH2F1_SC_hstart_src(data)                                              ((0x01FFE000&(data))>>13)
+#define VI_VBIWH2F1_SC_get_hstart(data)                                              ((0x01FFE000&(data))>>13)
+#define VI_VBIWH2F1_SC_write_enable2_shift                                           (12)
+#define VI_VBIWH2F1_SC_write_enable2_mask                                            (0x00001000)
+#define VI_VBIWH2F1_SC_write_enable2(data)                                           (0x00001000&((data)<<12))
+#define VI_VBIWH2F1_SC_write_enable2_src(data)                                       ((0x00001000&(data))>>12)
+#define VI_VBIWH2F1_SC_get_write_enable2(data)                                       ((0x00001000&(data))>>12)
+#define VI_VBIWH2F1_SC_hend_shift                                                    (0)
+#define VI_VBIWH2F1_SC_hend_mask                                                     (0x00000FFF)
+#define VI_VBIWH2F1_SC_hend(data)                                                    (0x00000FFF&((data)<<0))
+#define VI_VBIWH2F1_SC_hend_src(data)                                                ((0x00000FFF&(data))>>0)
+#define VI_VBIWH2F1_SC_get_hend(data)                                                ((0x00000FFF&(data))>>0)
+
+
+#define VI_VBIF0_SCALING1                                                            0x18004050
+#define VI_VBIF0_SCALING1_reg_addr                                                   "0xB8004050"
+#define VI_VBIF0_SCALING1_reg                                                        0xB8004050
+#define VI_VBIF0_SCALING1_inst_adr                                                   "0x0014"
+#define VI_VBIF0_SCALING1_inst                                                       0x0014
+#define VI_VBIF0_SCALING1_write_enable1_shift                                        (19)
+#define VI_VBIF0_SCALING1_write_enable1_mask                                         (0x00080000)
+#define VI_VBIF0_SCALING1_write_enable1(data)                                        (0x00080000&((data)<<19))
+#define VI_VBIF0_SCALING1_write_enable1_src(data)                                    ((0x00080000&(data))>>19)
+#define VI_VBIF0_SCALING1_get_write_enable1(data)                                    ((0x00080000&(data))>>19)
+#define VI_VBIF0_SCALING1_scaling_en1_shift                                          (18)
+#define VI_VBIF0_SCALING1_scaling_en1_mask                                           (0x00040000)
+#define VI_VBIF0_SCALING1_scaling_en1(data)                                          (0x00040000&((data)<<18))
+#define VI_VBIF0_SCALING1_scaling_en1_src(data)                                      ((0x00040000&(data))>>18)
+#define VI_VBIF0_SCALING1_get_scaling_en1(data)                                      ((0x00040000&(data))>>18)
+#define VI_VBIF0_SCALING1_write_enable2_shift                                        (17)
+#define VI_VBIF0_SCALING1_write_enable2_mask                                         (0x00020000)
+#define VI_VBIF0_SCALING1_write_enable2(data)                                        (0x00020000&((data)<<17))
+#define VI_VBIF0_SCALING1_write_enable2_src(data)                                    ((0x00020000&(data))>>17)
+#define VI_VBIF0_SCALING1_get_write_enable2(data)                                    ((0x00020000&(data))>>17)
+#define VI_VBIF0_SCALING1_gain_shift                                                 (9)
+#define VI_VBIF0_SCALING1_gain_mask                                                  (0x0001FE00)
+#define VI_VBIF0_SCALING1_gain(data)                                                 (0x0001FE00&((data)<<9))
+#define VI_VBIF0_SCALING1_gain_src(data)                                             ((0x0001FE00&(data))>>9)
+#define VI_VBIF0_SCALING1_get_gain(data)                                             ((0x0001FE00&(data))>>9)
+#define VI_VBIF0_SCALING1_write_enable3_shift                                        (8)
+#define VI_VBIF0_SCALING1_write_enable3_mask                                         (0x00000100)
+#define VI_VBIF0_SCALING1_write_enable3(data)                                        (0x00000100&((data)<<8))
+#define VI_VBIF0_SCALING1_write_enable3_src(data)                                    ((0x00000100&(data))>>8)
+#define VI_VBIF0_SCALING1_get_write_enable3(data)                                    ((0x00000100&(data))>>8)
+#define VI_VBIF0_SCALING1_offset_shift                                               (0)
+#define VI_VBIF0_SCALING1_offset_mask                                                (0x000000FF)
+#define VI_VBIF0_SCALING1_offset(data)                                               (0x000000FF&((data)<<0))
+#define VI_VBIF0_SCALING1_offset_src(data)                                           ((0x000000FF&(data))>>0)
+#define VI_VBIF0_SCALING1_get_offset(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define VI_VBIF1_SCALING1                                                            0x180044d8
+#define VI_VBIF1_SCALING1_reg_addr                                                   "0xB80044D8"
+#define VI_VBIF1_SCALING1_reg                                                        0xB80044D8
+#define VI_VBIF1_SCALING1_inst_adr                                                   "0x0036"
+#define VI_VBIF1_SCALING1_inst                                                       0x0036
+#define VI_VBIF1_SCALING1_write_enable1_shift                                        (19)
+#define VI_VBIF1_SCALING1_write_enable1_mask                                         (0x00080000)
+#define VI_VBIF1_SCALING1_write_enable1(data)                                        (0x00080000&((data)<<19))
+#define VI_VBIF1_SCALING1_write_enable1_src(data)                                    ((0x00080000&(data))>>19)
+#define VI_VBIF1_SCALING1_get_write_enable1(data)                                    ((0x00080000&(data))>>19)
+#define VI_VBIF1_SCALING1_scaling_en1_shift                                          (18)
+#define VI_VBIF1_SCALING1_scaling_en1_mask                                           (0x00040000)
+#define VI_VBIF1_SCALING1_scaling_en1(data)                                          (0x00040000&((data)<<18))
+#define VI_VBIF1_SCALING1_scaling_en1_src(data)                                      ((0x00040000&(data))>>18)
+#define VI_VBIF1_SCALING1_get_scaling_en1(data)                                      ((0x00040000&(data))>>18)
+#define VI_VBIF1_SCALING1_write_enable2_shift                                        (17)
+#define VI_VBIF1_SCALING1_write_enable2_mask                                         (0x00020000)
+#define VI_VBIF1_SCALING1_write_enable2(data)                                        (0x00020000&((data)<<17))
+#define VI_VBIF1_SCALING1_write_enable2_src(data)                                    ((0x00020000&(data))>>17)
+#define VI_VBIF1_SCALING1_get_write_enable2(data)                                    ((0x00020000&(data))>>17)
+#define VI_VBIF1_SCALING1_gain_shift                                                 (9)
+#define VI_VBIF1_SCALING1_gain_mask                                                  (0x0001FE00)
+#define VI_VBIF1_SCALING1_gain(data)                                                 (0x0001FE00&((data)<<9))
+#define VI_VBIF1_SCALING1_gain_src(data)                                             ((0x0001FE00&(data))>>9)
+#define VI_VBIF1_SCALING1_get_gain(data)                                             ((0x0001FE00&(data))>>9)
+#define VI_VBIF1_SCALING1_write_enable3_shift                                        (8)
+#define VI_VBIF1_SCALING1_write_enable3_mask                                         (0x00000100)
+#define VI_VBIF1_SCALING1_write_enable3(data)                                        (0x00000100&((data)<<8))
+#define VI_VBIF1_SCALING1_write_enable3_src(data)                                    ((0x00000100&(data))>>8)
+#define VI_VBIF1_SCALING1_get_write_enable3(data)                                    ((0x00000100&(data))>>8)
+#define VI_VBIF1_SCALING1_offset_shift                                               (0)
+#define VI_VBIF1_SCALING1_offset_mask                                                (0x000000FF)
+#define VI_VBIF1_SCALING1_offset(data)                                               (0x000000FF&((data)<<0))
+#define VI_VBIF1_SCALING1_offset_src(data)                                           ((0x000000FF&(data))>>0)
+#define VI_VBIF1_SCALING1_get_offset(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define VI_VBIF0_SCALING2                                                            0x18004054
+#define VI_VBIF0_SCALING2_reg_addr                                                   "0xB8004054"
+#define VI_VBIF0_SCALING2_reg                                                        0xB8004054
+#define VI_VBIF0_SCALING2_inst_adr                                                   "0x0015"
+#define VI_VBIF0_SCALING2_inst                                                       0x0015
+#define VI_VBIF0_SCALING2_write_enable1_shift                                        (19)
+#define VI_VBIF0_SCALING2_write_enable1_mask                                         (0x00080000)
+#define VI_VBIF0_SCALING2_write_enable1(data)                                        (0x00080000&((data)<<19))
+#define VI_VBIF0_SCALING2_write_enable1_src(data)                                    ((0x00080000&(data))>>19)
+#define VI_VBIF0_SCALING2_get_write_enable1(data)                                    ((0x00080000&(data))>>19)
+#define VI_VBIF0_SCALING2_scaling_en2_shift                                          (18)
+#define VI_VBIF0_SCALING2_scaling_en2_mask                                           (0x00040000)
+#define VI_VBIF0_SCALING2_scaling_en2(data)                                          (0x00040000&((data)<<18))
+#define VI_VBIF0_SCALING2_scaling_en2_src(data)                                      ((0x00040000&(data))>>18)
+#define VI_VBIF0_SCALING2_get_scaling_en2(data)                                      ((0x00040000&(data))>>18)
+#define VI_VBIF0_SCALING2_write_enable2_shift                                        (17)
+#define VI_VBIF0_SCALING2_write_enable2_mask                                         (0x00020000)
+#define VI_VBIF0_SCALING2_write_enable2(data)                                        (0x00020000&((data)<<17))
+#define VI_VBIF0_SCALING2_write_enable2_src(data)                                    ((0x00020000&(data))>>17)
+#define VI_VBIF0_SCALING2_get_write_enable2(data)                                    ((0x00020000&(data))>>17)
+#define VI_VBIF0_SCALING2_gain_shift                                                 (9)
+#define VI_VBIF0_SCALING2_gain_mask                                                  (0x0001FE00)
+#define VI_VBIF0_SCALING2_gain(data)                                                 (0x0001FE00&((data)<<9))
+#define VI_VBIF0_SCALING2_gain_src(data)                                             ((0x0001FE00&(data))>>9)
+#define VI_VBIF0_SCALING2_get_gain(data)                                             ((0x0001FE00&(data))>>9)
+#define VI_VBIF0_SCALING2_write_enable3_shift                                        (8)
+#define VI_VBIF0_SCALING2_write_enable3_mask                                         (0x00000100)
+#define VI_VBIF0_SCALING2_write_enable3(data)                                        (0x00000100&((data)<<8))
+#define VI_VBIF0_SCALING2_write_enable3_src(data)                                    ((0x00000100&(data))>>8)
+#define VI_VBIF0_SCALING2_get_write_enable3(data)                                    ((0x00000100&(data))>>8)
+#define VI_VBIF0_SCALING2_offset_shift                                               (0)
+#define VI_VBIF0_SCALING2_offset_mask                                                (0x000000FF)
+#define VI_VBIF0_SCALING2_offset(data)                                               (0x000000FF&((data)<<0))
+#define VI_VBIF0_SCALING2_offset_src(data)                                           ((0x000000FF&(data))>>0)
+#define VI_VBIF0_SCALING2_get_offset(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define VI_VBIF1_SCALING2                                                            0x180044dc
+#define VI_VBIF1_SCALING2_reg_addr                                                   "0xB80044DC"
+#define VI_VBIF1_SCALING2_reg                                                        0xB80044DC
+#define VI_VBIF1_SCALING2_inst_adr                                                   "0x0037"
+#define VI_VBIF1_SCALING2_inst                                                       0x0037
+#define VI_VBIF1_SCALING2_write_enable1_shift                                        (19)
+#define VI_VBIF1_SCALING2_write_enable1_mask                                         (0x00080000)
+#define VI_VBIF1_SCALING2_write_enable1(data)                                        (0x00080000&((data)<<19))
+#define VI_VBIF1_SCALING2_write_enable1_src(data)                                    ((0x00080000&(data))>>19)
+#define VI_VBIF1_SCALING2_get_write_enable1(data)                                    ((0x00080000&(data))>>19)
+#define VI_VBIF1_SCALING2_scaling_en2_shift                                          (18)
+#define VI_VBIF1_SCALING2_scaling_en2_mask                                           (0x00040000)
+#define VI_VBIF1_SCALING2_scaling_en2(data)                                          (0x00040000&((data)<<18))
+#define VI_VBIF1_SCALING2_scaling_en2_src(data)                                      ((0x00040000&(data))>>18)
+#define VI_VBIF1_SCALING2_get_scaling_en2(data)                                      ((0x00040000&(data))>>18)
+#define VI_VBIF1_SCALING2_write_enable2_shift                                        (17)
+#define VI_VBIF1_SCALING2_write_enable2_mask                                         (0x00020000)
+#define VI_VBIF1_SCALING2_write_enable2(data)                                        (0x00020000&((data)<<17))
+#define VI_VBIF1_SCALING2_write_enable2_src(data)                                    ((0x00020000&(data))>>17)
+#define VI_VBIF1_SCALING2_get_write_enable2(data)                                    ((0x00020000&(data))>>17)
+#define VI_VBIF1_SCALING2_gain_shift                                                 (9)
+#define VI_VBIF1_SCALING2_gain_mask                                                  (0x0001FE00)
+#define VI_VBIF1_SCALING2_gain(data)                                                 (0x0001FE00&((data)<<9))
+#define VI_VBIF1_SCALING2_gain_src(data)                                             ((0x0001FE00&(data))>>9)
+#define VI_VBIF1_SCALING2_get_gain(data)                                             ((0x0001FE00&(data))>>9)
+#define VI_VBIF1_SCALING2_write_enable3_shift                                        (8)
+#define VI_VBIF1_SCALING2_write_enable3_mask                                         (0x00000100)
+#define VI_VBIF1_SCALING2_write_enable3(data)                                        (0x00000100&((data)<<8))
+#define VI_VBIF1_SCALING2_write_enable3_src(data)                                    ((0x00000100&(data))>>8)
+#define VI_VBIF1_SCALING2_get_write_enable3(data)                                    ((0x00000100&(data))>>8)
+#define VI_VBIF1_SCALING2_offset_shift                                               (0)
+#define VI_VBIF1_SCALING2_offset_mask                                                (0x000000FF)
+#define VI_VBIF1_SCALING2_offset(data)                                               (0x000000FF&((data)<<0))
+#define VI_VBIF1_SCALING2_offset_src(data)                                           ((0x000000FF&(data))>>0)
+#define VI_VBIF1_SCALING2_get_offset(data)                                           ((0x000000FF&(data))>>0)
+
+
+#define VI_YDC1                                                                      0x18004060
+#define VI_YDC1_reg_addr                                                             "0xB8004060"
+#define VI_YDC1_reg                                                                  0xB8004060
+#define VI_YDC1_inst_adr                                                             "0x0018"
+#define VI_YDC1_inst                                                                 0x0018
+#define VI_YDC1_dc_shift                                                             (0)
+#define VI_YDC1_dc_mask                                                              (0x1FFFFFFF)
+#define VI_YDC1_dc(data)                                                             (0x1FFFFFFF&((data)<<0))
+#define VI_YDC1_dc_src(data)                                                         ((0x1FFFFFFF&(data))>>0)
+#define VI_YDC1_get_dc(data)                                                         ((0x1FFFFFFF&(data))>>0)
+
+
+#define VI_YDC2                                                                      0x18004064
+#define VI_YDC2_reg_addr                                                             "0xB8004064"
+#define VI_YDC2_reg                                                                  0xB8004064
+#define VI_YDC2_inst_adr                                                             "0x0019"
+#define VI_YDC2_inst                                                                 0x0019
+#define VI_YDC2_dc_shift                                                             (0)
+#define VI_YDC2_dc_mask                                                              (0x1FFFFFFF)
+#define VI_YDC2_dc(data)                                                             (0x1FFFFFFF&((data)<<0))
+#define VI_YDC2_dc_src(data)                                                         ((0x1FFFFFFF&(data))>>0)
+#define VI_YDC2_get_dc(data)                                                         ((0x1FFFFFFF&(data))>>0)
+
+
+#define VI_COCTL1                                                                    0x180042b4
+#define VI_COCTL1_reg_addr                                                           "0xB80042B4"
+#define VI_COCTL1_reg                                                                0xB80042B4
+#define VI_COCTL1_inst_adr                                                           "0x00AD"
+#define VI_COCTL1_inst                                                               0x00AD
+#define VI_COCTL1_yen_shift                                                          (2)
+#define VI_COCTL1_yen_mask                                                           (0x00000004)
+#define VI_COCTL1_yen(data)                                                          (0x00000004&((data)<<2))
+#define VI_COCTL1_yen_src(data)                                                      ((0x00000004&(data))>>2)
+#define VI_COCTL1_get_yen(data)                                                      ((0x00000004&(data))>>2)
+#define VI_COCTL1_cen_shift                                                          (1)
+#define VI_COCTL1_cen_mask                                                           (0x00000002)
+#define VI_COCTL1_cen(data)                                                          (0x00000002&((data)<<1))
+#define VI_COCTL1_cen_src(data)                                                      ((0x00000002&(data))>>1)
+#define VI_COCTL1_get_cen(data)                                                      ((0x00000002&(data))>>1)
+#define VI_COCTL1_write_data_shift                                                   (0)
+#define VI_COCTL1_write_data_mask                                                    (0x00000001)
+#define VI_COCTL1_write_data(data)                                                   (0x00000001&((data)<<0))
+#define VI_COCTL1_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define VI_COCTL1_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VI_COCTL2                                                                    0x180042b8
+#define VI_COCTL2_reg_addr                                                           "0xB80042B8"
+#define VI_COCTL2_reg                                                                0xB80042B8
+#define VI_COCTL2_inst_adr                                                           "0x00AE"
+#define VI_COCTL2_inst                                                               0x00AE
+#define VI_COCTL2_yen_shift                                                          (2)
+#define VI_COCTL2_yen_mask                                                           (0x00000004)
+#define VI_COCTL2_yen(data)                                                          (0x00000004&((data)<<2))
+#define VI_COCTL2_yen_src(data)                                                      ((0x00000004&(data))>>2)
+#define VI_COCTL2_get_yen(data)                                                      ((0x00000004&(data))>>2)
+#define VI_COCTL2_cen_shift                                                          (1)
+#define VI_COCTL2_cen_mask                                                           (0x00000002)
+#define VI_COCTL2_cen(data)                                                          (0x00000002&((data)<<1))
+#define VI_COCTL2_cen_src(data)                                                      ((0x00000002&(data))>>1)
+#define VI_COCTL2_get_cen(data)                                                      ((0x00000002&(data))>>1)
+#define VI_COCTL2_write_data_shift                                                   (0)
+#define VI_COCTL2_write_data_mask                                                    (0x00000001)
+#define VI_COCTL2_write_data(data)                                                   (0x00000001&((data)<<0))
+#define VI_COCTL2_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define VI_COCTL2_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VI_YCO1                                                                      0x180042bc
+#define VI_YCO1_reg_addr                                                             "0xB80042BC"
+#define VI_YCO1_reg                                                                  0xB80042BC
+#define VI_YCO1_inst_adr                                                             "0x00AF"
+#define VI_YCO1_inst                                                                 0x00AF
+#define VI_YCO1_write_enable1_shift                                                  (12)
+#define VI_YCO1_write_enable1_mask                                                   (0x00001000)
+#define VI_YCO1_write_enable1(data)                                                  (0x00001000&((data)<<12))
+#define VI_YCO1_write_enable1_src(data)                                              ((0x00001000&(data))>>12)
+#define VI_YCO1_get_write_enable1(data)                                              ((0x00001000&(data))>>12)
+#define VI_YCO1_range_shift                                                          (4)
+#define VI_YCO1_range_mask                                                           (0x00000FF0)
+#define VI_YCO1_range(data)                                                          (0x00000FF0&((data)<<4))
+#define VI_YCO1_range_src(data)                                                      ((0x00000FF0&(data))>>4)
+#define VI_YCO1_get_range(data)                                                      ((0x00000FF0&(data))>>4)
+#define VI_YCO1_write_enable2_shift                                                  (3)
+#define VI_YCO1_write_enable2_mask                                                   (0x00000008)
+#define VI_YCO1_write_enable2(data)                                                  (0x00000008&((data)<<3))
+#define VI_YCO1_write_enable2_src(data)                                              ((0x00000008&(data))>>3)
+#define VI_YCO1_get_write_enable2(data)                                              ((0x00000008&(data))>>3)
+#define VI_YCO1_conti_shift                                                          (2)
+#define VI_YCO1_conti_mask                                                           (0x00000004)
+#define VI_YCO1_conti(data)                                                          (0x00000004&((data)<<2))
+#define VI_YCO1_conti_src(data)                                                      ((0x00000004&(data))>>2)
+#define VI_YCO1_get_conti(data)                                                      ((0x00000004&(data))>>2)
+#define VI_YCO1_write_enable3_shift                                                  (1)
+#define VI_YCO1_write_enable3_mask                                                   (0x00000002)
+#define VI_YCO1_write_enable3(data)                                                  (0x00000002&((data)<<1))
+#define VI_YCO1_write_enable3_src(data)                                              ((0x00000002&(data))>>1)
+#define VI_YCO1_get_write_enable3(data)                                              ((0x00000002&(data))>>1)
+#define VI_YCO1_clamp_shift                                                          (0)
+#define VI_YCO1_clamp_mask                                                           (0x00000001)
+#define VI_YCO1_clamp(data)                                                          (0x00000001&((data)<<0))
+#define VI_YCO1_clamp_src(data)                                                      ((0x00000001&(data))>>0)
+#define VI_YCO1_get_clamp(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define VI_CCO1                                                                      0x180042c0
+#define VI_CCO1_reg_addr                                                             "0xB80042C0"
+#define VI_CCO1_reg                                                                  0xB80042C0
+#define VI_CCO1_inst_adr                                                             "0x00B0"
+#define VI_CCO1_inst                                                                 0x00B0
+#define VI_CCO1_write_enable1_shift                                                  (12)
+#define VI_CCO1_write_enable1_mask                                                   (0x00001000)
+#define VI_CCO1_write_enable1(data)                                                  (0x00001000&((data)<<12))
+#define VI_CCO1_write_enable1_src(data)                                              ((0x00001000&(data))>>12)
+#define VI_CCO1_get_write_enable1(data)                                              ((0x00001000&(data))>>12)
+#define VI_CCO1_range_shift                                                          (4)
+#define VI_CCO1_range_mask                                                           (0x00000FF0)
+#define VI_CCO1_range(data)                                                          (0x00000FF0&((data)<<4))
+#define VI_CCO1_range_src(data)                                                      ((0x00000FF0&(data))>>4)
+#define VI_CCO1_get_range(data)                                                      ((0x00000FF0&(data))>>4)
+#define VI_CCO1_write_enable2_shift                                                  (3)
+#define VI_CCO1_write_enable2_mask                                                   (0x00000008)
+#define VI_CCO1_write_enable2(data)                                                  (0x00000008&((data)<<3))
+#define VI_CCO1_write_enable2_src(data)                                              ((0x00000008&(data))>>3)
+#define VI_CCO1_get_write_enable2(data)                                              ((0x00000008&(data))>>3)
+#define VI_CCO1_conti_shift                                                          (2)
+#define VI_CCO1_conti_mask                                                           (0x00000004)
+#define VI_CCO1_conti(data)                                                          (0x00000004&((data)<<2))
+#define VI_CCO1_conti_src(data)                                                      ((0x00000004&(data))>>2)
+#define VI_CCO1_get_conti(data)                                                      ((0x00000004&(data))>>2)
+#define VI_CCO1_write_enable3_shift                                                  (1)
+#define VI_CCO1_write_enable3_mask                                                   (0x00000002)
+#define VI_CCO1_write_enable3(data)                                                  (0x00000002&((data)<<1))
+#define VI_CCO1_write_enable3_src(data)                                              ((0x00000002&(data))>>1)
+#define VI_CCO1_get_write_enable3(data)                                              ((0x00000002&(data))>>1)
+#define VI_CCO1_clamp_shift                                                          (0)
+#define VI_CCO1_clamp_mask                                                           (0x00000001)
+#define VI_CCO1_clamp(data)                                                          (0x00000001&((data)<<0))
+#define VI_CCO1_clamp_src(data)                                                      ((0x00000001&(data))>>0)
+#define VI_CCO1_get_clamp(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define VI_YCO2                                                                      0x180042c4
+#define VI_YCO2_reg_addr                                                             "0xB80042C4"
+#define VI_YCO2_reg                                                                  0xB80042C4
+#define VI_YCO2_inst_adr                                                             "0x00B1"
+#define VI_YCO2_inst                                                                 0x00B1
+#define VI_YCO2_write_enable1_shift                                                  (12)
+#define VI_YCO2_write_enable1_mask                                                   (0x00001000)
+#define VI_YCO2_write_enable1(data)                                                  (0x00001000&((data)<<12))
+#define VI_YCO2_write_enable1_src(data)                                              ((0x00001000&(data))>>12)
+#define VI_YCO2_get_write_enable1(data)                                              ((0x00001000&(data))>>12)
+#define VI_YCO2_range_shift                                                          (4)
+#define VI_YCO2_range_mask                                                           (0x00000FF0)
+#define VI_YCO2_range(data)                                                          (0x00000FF0&((data)<<4))
+#define VI_YCO2_range_src(data)                                                      ((0x00000FF0&(data))>>4)
+#define VI_YCO2_get_range(data)                                                      ((0x00000FF0&(data))>>4)
+#define VI_YCO2_write_enable2_shift                                                  (3)
+#define VI_YCO2_write_enable2_mask                                                   (0x00000008)
+#define VI_YCO2_write_enable2(data)                                                  (0x00000008&((data)<<3))
+#define VI_YCO2_write_enable2_src(data)                                              ((0x00000008&(data))>>3)
+#define VI_YCO2_get_write_enable2(data)                                              ((0x00000008&(data))>>3)
+#define VI_YCO2_conti_shift                                                          (2)
+#define VI_YCO2_conti_mask                                                           (0x00000004)
+#define VI_YCO2_conti(data)                                                          (0x00000004&((data)<<2))
+#define VI_YCO2_conti_src(data)                                                      ((0x00000004&(data))>>2)
+#define VI_YCO2_get_conti(data)                                                      ((0x00000004&(data))>>2)
+#define VI_YCO2_write_enable3_shift                                                  (1)
+#define VI_YCO2_write_enable3_mask                                                   (0x00000002)
+#define VI_YCO2_write_enable3(data)                                                  (0x00000002&((data)<<1))
+#define VI_YCO2_write_enable3_src(data)                                              ((0x00000002&(data))>>1)
+#define VI_YCO2_get_write_enable3(data)                                              ((0x00000002&(data))>>1)
+#define VI_YCO2_clamp_shift                                                          (0)
+#define VI_YCO2_clamp_mask                                                           (0x00000001)
+#define VI_YCO2_clamp(data)                                                          (0x00000001&((data)<<0))
+#define VI_YCO2_clamp_src(data)                                                      ((0x00000001&(data))>>0)
+#define VI_YCO2_get_clamp(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define VI_CCO2                                                                      0x180042c8
+#define VI_CCO2_reg_addr                                                             "0xB80042C8"
+#define VI_CCO2_reg                                                                  0xB80042C8
+#define VI_CCO2_inst_adr                                                             "0x00B2"
+#define VI_CCO2_inst                                                                 0x00B2
+#define VI_CCO2_write_enable1_shift                                                  (12)
+#define VI_CCO2_write_enable1_mask                                                   (0x00001000)
+#define VI_CCO2_write_enable1(data)                                                  (0x00001000&((data)<<12))
+#define VI_CCO2_write_enable1_src(data)                                              ((0x00001000&(data))>>12)
+#define VI_CCO2_get_write_enable1(data)                                              ((0x00001000&(data))>>12)
+#define VI_CCO2_range_shift                                                          (4)
+#define VI_CCO2_range_mask                                                           (0x00000FF0)
+#define VI_CCO2_range(data)                                                          (0x00000FF0&((data)<<4))
+#define VI_CCO2_range_src(data)                                                      ((0x00000FF0&(data))>>4)
+#define VI_CCO2_get_range(data)                                                      ((0x00000FF0&(data))>>4)
+#define VI_CCO2_write_enable2_shift                                                  (3)
+#define VI_CCO2_write_enable2_mask                                                   (0x00000008)
+#define VI_CCO2_write_enable2(data)                                                  (0x00000008&((data)<<3))
+#define VI_CCO2_write_enable2_src(data)                                              ((0x00000008&(data))>>3)
+#define VI_CCO2_get_write_enable2(data)                                              ((0x00000008&(data))>>3)
+#define VI_CCO2_conti_shift                                                          (2)
+#define VI_CCO2_conti_mask                                                           (0x00000004)
+#define VI_CCO2_conti(data)                                                          (0x00000004&((data)<<2))
+#define VI_CCO2_conti_src(data)                                                      ((0x00000004&(data))>>2)
+#define VI_CCO2_get_conti(data)                                                      ((0x00000004&(data))>>2)
+#define VI_CCO2_write_enable3_shift                                                  (1)
+#define VI_CCO2_write_enable3_mask                                                   (0x00000002)
+#define VI_CCO2_write_enable3(data)                                                  (0x00000002&((data)<<1))
+#define VI_CCO2_write_enable3_src(data)                                              ((0x00000002&(data))>>1)
+#define VI_CCO2_get_write_enable3(data)                                              ((0x00000002&(data))>>1)
+#define VI_CCO2_clamp_shift                                                          (0)
+#define VI_CCO2_clamp_mask                                                           (0x00000001)
+#define VI_CCO2_clamp(data)                                                          (0x00000001&((data)<<0))
+#define VI_CCO2_clamp_src(data)                                                      ((0x00000001&(data))>>0)
+#define VI_CCO2_get_clamp(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define VI_VSCCTL1                                                                   0x180042d4
+#define VI_VSCCTL1_reg_addr                                                          "0xB80042D4"
+#define VI_VSCCTL1_reg                                                               0xB80042D4
+#define VI_VSCCTL1_inst_adr                                                          "0x00B5"
+#define VI_VSCCTL1_inst                                                              0x00B5
+#define VI_VSCCTL1_up_en_shift                                                       (7)
+#define VI_VSCCTL1_up_en_mask                                                        (0x00000080)
+#define VI_VSCCTL1_up_en(data)                                                       (0x00000080&((data)<<7))
+#define VI_VSCCTL1_up_en_src(data)                                                   ((0x00000080&(data))>>7)
+#define VI_VSCCTL1_get_up_en(data)                                                   ((0x00000080&(data))>>7)
+#define VI_VSCCTL1_tap_mode_shift                                                    (5)
+#define VI_VSCCTL1_tap_mode_mask                                                     (0x00000060)
+#define VI_VSCCTL1_tap_mode(data)                                                    (0x00000060&((data)<<5))
+#define VI_VSCCTL1_tap_mode_src(data)                                                ((0x00000060&(data))>>5)
+#define VI_VSCCTL1_get_tap_mode(data)                                                ((0x00000060&(data))>>5)
+#define VI_VSCCTL1_yen_shift                                                         (4)
+#define VI_VSCCTL1_yen_mask                                                          (0x00000010)
+#define VI_VSCCTL1_yen(data)                                                         (0x00000010&((data)<<4))
+#define VI_VSCCTL1_yen_src(data)                                                     ((0x00000010&(data))>>4)
+#define VI_VSCCTL1_get_yen(data)                                                     ((0x00000010&(data))>>4)
+#define VI_VSCCTL1_yoddtype_shift                                                    (3)
+#define VI_VSCCTL1_yoddtype_mask                                                     (0x00000008)
+#define VI_VSCCTL1_yoddtype(data)                                                    (0x00000008&((data)<<3))
+#define VI_VSCCTL1_yoddtype_src(data)                                                ((0x00000008&(data))>>3)
+#define VI_VSCCTL1_get_yoddtype(data)                                                ((0x00000008&(data))>>3)
+#define VI_VSCCTL1_cen_shift                                                         (2)
+#define VI_VSCCTL1_cen_mask                                                          (0x00000004)
+#define VI_VSCCTL1_cen(data)                                                         (0x00000004&((data)<<2))
+#define VI_VSCCTL1_cen_src(data)                                                     ((0x00000004&(data))>>2)
+#define VI_VSCCTL1_get_cen(data)                                                     ((0x00000004&(data))>>2)
+#define VI_VSCCTL1_coddtype_shift                                                    (1)
+#define VI_VSCCTL1_coddtype_mask                                                     (0x00000002)
+#define VI_VSCCTL1_coddtype(data)                                                    (0x00000002&((data)<<1))
+#define VI_VSCCTL1_coddtype_src(data)                                                ((0x00000002&(data))>>1)
+#define VI_VSCCTL1_get_coddtype(data)                                                ((0x00000002&(data))>>1)
+
+
+#define VI_VSCCTL2                                                                   0x180042d8
+#define VI_VSCCTL2_reg_addr                                                          "0xB80042D8"
+#define VI_VSCCTL2_reg                                                               0xB80042D8
+#define VI_VSCCTL2_inst_adr                                                          "0x00B6"
+#define VI_VSCCTL2_inst                                                              0x00B6
+#define VI_VSCCTL2_up_en_shift                                                       (7)
+#define VI_VSCCTL2_up_en_mask                                                        (0x00000080)
+#define VI_VSCCTL2_up_en(data)                                                       (0x00000080&((data)<<7))
+#define VI_VSCCTL2_up_en_src(data)                                                   ((0x00000080&(data))>>7)
+#define VI_VSCCTL2_get_up_en(data)                                                   ((0x00000080&(data))>>7)
+#define VI_VSCCTL2_tap_mode_shift                                                    (5)
+#define VI_VSCCTL2_tap_mode_mask                                                     (0x00000060)
+#define VI_VSCCTL2_tap_mode(data)                                                    (0x00000060&((data)<<5))
+#define VI_VSCCTL2_tap_mode_src(data)                                                ((0x00000060&(data))>>5)
+#define VI_VSCCTL2_get_tap_mode(data)                                                ((0x00000060&(data))>>5)
+#define VI_VSCCTL2_yen_shift                                                         (4)
+#define VI_VSCCTL2_yen_mask                                                          (0x00000010)
+#define VI_VSCCTL2_yen(data)                                                         (0x00000010&((data)<<4))
+#define VI_VSCCTL2_yen_src(data)                                                     ((0x00000010&(data))>>4)
+#define VI_VSCCTL2_get_yen(data)                                                     ((0x00000010&(data))>>4)
+#define VI_VSCCTL2_yoddtype_shift                                                    (3)
+#define VI_VSCCTL2_yoddtype_mask                                                     (0x00000008)
+#define VI_VSCCTL2_yoddtype(data)                                                    (0x00000008&((data)<<3))
+#define VI_VSCCTL2_yoddtype_src(data)                                                ((0x00000008&(data))>>3)
+#define VI_VSCCTL2_get_yoddtype(data)                                                ((0x00000008&(data))>>3)
+#define VI_VSCCTL2_cen_shift                                                         (2)
+#define VI_VSCCTL2_cen_mask                                                          (0x00000004)
+#define VI_VSCCTL2_cen(data)                                                         (0x00000004&((data)<<2))
+#define VI_VSCCTL2_cen_src(data)                                                     ((0x00000004&(data))>>2)
+#define VI_VSCCTL2_get_cen(data)                                                     ((0x00000004&(data))>>2)
+#define VI_VSCCTL2_coddtype_shift                                                    (1)
+#define VI_VSCCTL2_coddtype_mask                                                     (0x00000002)
+#define VI_VSCCTL2_coddtype(data)                                                    (0x00000002&((data)<<1))
+#define VI_VSCCTL2_coddtype_src(data)                                                ((0x00000002&(data))>>1)
+#define VI_VSCCTL2_get_coddtype(data)                                                ((0x00000002&(data))>>1)
+
+
+#define VI_VYSC1                                                                     0x180042dc
+#define VI_VYSC1_reg_addr                                                            "0xB80042DC"
+#define VI_VYSC1_reg                                                                 0xB80042DC
+#define VI_VYSC1_inst_adr                                                            "0x00B7"
+#define VI_VYSC1_inst                                                                0x00B7
+#define VI_VYSC1_write_enable1_shift                                                 (30)
+#define VI_VYSC1_write_enable1_mask                                                  (0x40000000)
+#define VI_VYSC1_write_enable1(data)                                                 (0x40000000&((data)<<30))
+#define VI_VYSC1_write_enable1_src(data)                                             ((0x40000000&(data))>>30)
+#define VI_VYSC1_get_write_enable1(data)                                             ((0x40000000&(data))>>30)
+#define VI_VYSC1_yonl_shift                                                          (19)
+#define VI_VYSC1_yonl_mask                                                           (0x3FF80000)
+#define VI_VYSC1_yonl(data)                                                          (0x3FF80000&((data)<<19))
+#define VI_VYSC1_yonl_src(data)                                                      ((0x3FF80000&(data))>>19)
+#define VI_VYSC1_get_yonl(data)                                                      ((0x3FF80000&(data))>>19)
+#define VI_VYSC1_write_enable2_shift                                                 (18)
+#define VI_VYSC1_write_enable2_mask                                                  (0x00040000)
+#define VI_VYSC1_write_enable2(data)                                                 (0x00040000&((data)<<18))
+#define VI_VYSC1_write_enable2_src(data)                                             ((0x00040000&(data))>>18)
+#define VI_VYSC1_get_write_enable2(data)                                             ((0x00040000&(data))>>18)
+#define VI_VYSC1_ydphs_shift                                                         (0)
+#define VI_VYSC1_ydphs_mask                                                          (0x0003FFFF)
+#define VI_VYSC1_ydphs(data)                                                         (0x0003FFFF&((data)<<0))
+#define VI_VYSC1_ydphs_src(data)                                                     ((0x0003FFFF&(data))>>0)
+#define VI_VYSC1_get_ydphs(data)                                                     ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VCSC1                                                                     0x180042e0
+#define VI_VCSC1_reg_addr                                                            "0xB80042E0"
+#define VI_VCSC1_reg                                                                 0xB80042E0
+#define VI_VCSC1_inst_adr                                                            "0x00B8"
+#define VI_VCSC1_inst                                                                0x00B8
+#define VI_VCSC1_write_enable1_shift                                                 (30)
+#define VI_VCSC1_write_enable1_mask                                                  (0x40000000)
+#define VI_VCSC1_write_enable1(data)                                                 (0x40000000&((data)<<30))
+#define VI_VCSC1_write_enable1_src(data)                                             ((0x40000000&(data))>>30)
+#define VI_VCSC1_get_write_enable1(data)                                             ((0x40000000&(data))>>30)
+#define VI_VCSC1_conl_shift                                                          (19)
+#define VI_VCSC1_conl_mask                                                           (0x3FF80000)
+#define VI_VCSC1_conl(data)                                                          (0x3FF80000&((data)<<19))
+#define VI_VCSC1_conl_src(data)                                                      ((0x3FF80000&(data))>>19)
+#define VI_VCSC1_get_conl(data)                                                      ((0x3FF80000&(data))>>19)
+#define VI_VCSC1_write_enable2_shift                                                 (18)
+#define VI_VCSC1_write_enable2_mask                                                  (0x00040000)
+#define VI_VCSC1_write_enable2(data)                                                 (0x00040000&((data)<<18))
+#define VI_VCSC1_write_enable2_src(data)                                             ((0x00040000&(data))>>18)
+#define VI_VCSC1_get_write_enable2(data)                                             ((0x00040000&(data))>>18)
+#define VI_VCSC1_cdphs_shift                                                         (0)
+#define VI_VCSC1_cdphs_mask                                                          (0x0003FFFF)
+#define VI_VCSC1_cdphs(data)                                                         (0x0003FFFF&((data)<<0))
+#define VI_VCSC1_cdphs_src(data)                                                     ((0x0003FFFF&(data))>>0)
+#define VI_VCSC1_get_cdphs(data)                                                     ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VYSC2                                                                     0x180042e4
+#define VI_VYSC2_reg_addr                                                            "0xB80042E4"
+#define VI_VYSC2_reg                                                                 0xB80042E4
+#define VI_VYSC2_inst_adr                                                            "0x00B9"
+#define VI_VYSC2_inst                                                                0x00B9
+#define VI_VYSC2_write_enable1_shift                                                 (30)
+#define VI_VYSC2_write_enable1_mask                                                  (0x40000000)
+#define VI_VYSC2_write_enable1(data)                                                 (0x40000000&((data)<<30))
+#define VI_VYSC2_write_enable1_src(data)                                             ((0x40000000&(data))>>30)
+#define VI_VYSC2_get_write_enable1(data)                                             ((0x40000000&(data))>>30)
+#define VI_VYSC2_yonl_shift                                                          (19)
+#define VI_VYSC2_yonl_mask                                                           (0x3FF80000)
+#define VI_VYSC2_yonl(data)                                                          (0x3FF80000&((data)<<19))
+#define VI_VYSC2_yonl_src(data)                                                      ((0x3FF80000&(data))>>19)
+#define VI_VYSC2_get_yonl(data)                                                      ((0x3FF80000&(data))>>19)
+#define VI_VYSC2_write_enable2_shift                                                 (18)
+#define VI_VYSC2_write_enable2_mask                                                  (0x00040000)
+#define VI_VYSC2_write_enable2(data)                                                 (0x00040000&((data)<<18))
+#define VI_VYSC2_write_enable2_src(data)                                             ((0x00040000&(data))>>18)
+#define VI_VYSC2_get_write_enable2(data)                                             ((0x00040000&(data))>>18)
+#define VI_VYSC2_ydphs_shift                                                         (0)
+#define VI_VYSC2_ydphs_mask                                                          (0x0003FFFF)
+#define VI_VYSC2_ydphs(data)                                                         (0x0003FFFF&((data)<<0))
+#define VI_VYSC2_ydphs_src(data)                                                     ((0x0003FFFF&(data))>>0)
+#define VI_VYSC2_get_ydphs(data)                                                     ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VCSC2                                                                     0x180042e8
+#define VI_VCSC2_reg_addr                                                            "0xB80042E8"
+#define VI_VCSC2_reg                                                                 0xB80042E8
+#define VI_VCSC2_inst_adr                                                            "0x00BA"
+#define VI_VCSC2_inst                                                                0x00BA
+#define VI_VCSC2_write_enable1_shift                                                 (30)
+#define VI_VCSC2_write_enable1_mask                                                  (0x40000000)
+#define VI_VCSC2_write_enable1(data)                                                 (0x40000000&((data)<<30))
+#define VI_VCSC2_write_enable1_src(data)                                             ((0x40000000&(data))>>30)
+#define VI_VCSC2_get_write_enable1(data)                                             ((0x40000000&(data))>>30)
+#define VI_VCSC2_conl_shift                                                          (19)
+#define VI_VCSC2_conl_mask                                                           (0x3FF80000)
+#define VI_VCSC2_conl(data)                                                          (0x3FF80000&((data)<<19))
+#define VI_VCSC2_conl_src(data)                                                      ((0x3FF80000&(data))>>19)
+#define VI_VCSC2_get_conl(data)                                                      ((0x3FF80000&(data))>>19)
+#define VI_VCSC2_write_enable2_shift                                                 (18)
+#define VI_VCSC2_write_enable2_mask                                                  (0x00040000)
+#define VI_VCSC2_write_enable2(data)                                                 (0x00040000&((data)<<18))
+#define VI_VCSC2_write_enable2_src(data)                                             ((0x00040000&(data))>>18)
+#define VI_VCSC2_get_write_enable2(data)                                             ((0x00040000&(data))>>18)
+#define VI_VCSC2_cdphs_shift                                                         (0)
+#define VI_VCSC2_cdphs_mask                                                          (0x0003FFFF)
+#define VI_VCSC2_cdphs(data)                                                         (0x0003FFFF&((data)<<0))
+#define VI_VCSC2_cdphs_src(data)                                                     ((0x0003FFFF&(data))>>0)
+#define VI_VCSC2_get_cdphs(data)                                                     ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VYIPOS1                                                                   0x180042ec
+#define VI_VYIPOS1_reg_addr                                                          "0xB80042EC"
+#define VI_VYIPOS1_reg                                                               0xB80042EC
+#define VI_VYIPOS1_inst_adr                                                          "0x00BB"
+#define VI_VYIPOS1_inst                                                              0x00BB
+#define VI_VYIPOS1_init_offset_shift                                                 (14)
+#define VI_VYIPOS1_init_offset_mask                                                  (0x01FFC000)
+#define VI_VYIPOS1_init_offset(data)                                                 (0x01FFC000&((data)<<14))
+#define VI_VYIPOS1_init_offset_src(data)                                             ((0x01FFC000&(data))>>14)
+#define VI_VYIPOS1_get_init_offset(data)                                             ((0x01FFC000&(data))>>14)
+#define VI_VYIPOS1_init_phase_shift                                                  (0)
+#define VI_VYIPOS1_init_phase_mask                                                   (0x00003FFF)
+#define VI_VYIPOS1_init_phase(data)                                                  (0x00003FFF&((data)<<0))
+#define VI_VYIPOS1_init_phase_src(data)                                              ((0x00003FFF&(data))>>0)
+#define VI_VYIPOS1_get_init_phase(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define VI_VYIPOS2                                                                   0x180042f0
+#define VI_VYIPOS2_reg_addr                                                          "0xB80042F0"
+#define VI_VYIPOS2_reg                                                               0xB80042F0
+#define VI_VYIPOS2_inst_adr                                                          "0x00BC"
+#define VI_VYIPOS2_inst                                                              0x00BC
+#define VI_VYIPOS2_init_offset_shift                                                 (14)
+#define VI_VYIPOS2_init_offset_mask                                                  (0x01FFC000)
+#define VI_VYIPOS2_init_offset(data)                                                 (0x01FFC000&((data)<<14))
+#define VI_VYIPOS2_init_offset_src(data)                                             ((0x01FFC000&(data))>>14)
+#define VI_VYIPOS2_get_init_offset(data)                                             ((0x01FFC000&(data))>>14)
+#define VI_VYIPOS2_init_phase_shift                                                  (0)
+#define VI_VYIPOS2_init_phase_mask                                                   (0x00003FFF)
+#define VI_VYIPOS2_init_phase(data)                                                  (0x00003FFF&((data)<<0))
+#define VI_VYIPOS2_init_phase_src(data)                                              ((0x00003FFF&(data))>>0)
+#define VI_VYIPOS2_get_init_phase(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define VI_VCIPOS1                                                                   0x180042f4
+#define VI_VCIPOS1_reg_addr                                                          "0xB80042F4"
+#define VI_VCIPOS1_reg                                                               0xB80042F4
+#define VI_VCIPOS1_inst_adr                                                          "0x00BD"
+#define VI_VCIPOS1_inst                                                              0x00BD
+#define VI_VCIPOS1_init_offset_shift                                                 (14)
+#define VI_VCIPOS1_init_offset_mask                                                  (0x01FFC000)
+#define VI_VCIPOS1_init_offset(data)                                                 (0x01FFC000&((data)<<14))
+#define VI_VCIPOS1_init_offset_src(data)                                             ((0x01FFC000&(data))>>14)
+#define VI_VCIPOS1_get_init_offset(data)                                             ((0x01FFC000&(data))>>14)
+#define VI_VCIPOS1_init_phase_shift                                                  (0)
+#define VI_VCIPOS1_init_phase_mask                                                   (0x00003FFF)
+#define VI_VCIPOS1_init_phase(data)                                                  (0x00003FFF&((data)<<0))
+#define VI_VCIPOS1_init_phase_src(data)                                              ((0x00003FFF&(data))>>0)
+#define VI_VCIPOS1_get_init_phase(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define VI_VCIPOS2                                                                   0x180042f8
+#define VI_VCIPOS2_reg_addr                                                          "0xB80042F8"
+#define VI_VCIPOS2_reg                                                               0xB80042F8
+#define VI_VCIPOS2_inst_adr                                                          "0x00BE"
+#define VI_VCIPOS2_inst                                                              0x00BE
+#define VI_VCIPOS2_init_offset_shift                                                 (14)
+#define VI_VCIPOS2_init_offset_mask                                                  (0x01FFC000)
+#define VI_VCIPOS2_init_offset(data)                                                 (0x01FFC000&((data)<<14))
+#define VI_VCIPOS2_init_offset_src(data)                                             ((0x01FFC000&(data))>>14)
+#define VI_VCIPOS2_get_init_offset(data)                                             ((0x01FFC000&(data))>>14)
+#define VI_VCIPOS2_init_phase_shift                                                  (0)
+#define VI_VCIPOS2_init_phase_mask                                                   (0x00003FFF)
+#define VI_VCIPOS2_init_phase(data)                                                  (0x00003FFF&((data)<<0))
+#define VI_VCIPOS2_init_phase_src(data)                                              ((0x00003FFF&(data))>>0)
+#define VI_VCIPOS2_get_init_phase(data)                                              ((0x00003FFF&(data))>>0)
+
+
+#define VI_VYSCCOEF1_0                                                               0x180042FC
+#define VI_VYSCCOEF1_1                                                               0x18004300
+#define VI_VYSCCOEF1_2                                                               0x18004304
+#define VI_VYSCCOEF1_3                                                               0x18004308
+#define VI_VYSCCOEF1_4                                                               0x1800430C
+#define VI_VYSCCOEF1_5                                                               0x18004310
+#define VI_VYSCCOEF1_6                                                               0x18004314
+#define VI_VYSCCOEF1_7                                                               0x18004318
+#define VI_VYSCCOEF1_8                                                               0x1800431C
+#define VI_VYSCCOEF1_9                                                               0x18004320
+#define VI_VYSCCOEF1_10                                                               0x18004324
+#define VI_VYSCCOEF1_11                                                               0x18004328
+#define VI_VYSCCOEF1_12                                                               0x1800432C
+#define VI_VYSCCOEF1_13                                                               0x18004330
+#define VI_VYSCCOEF1_14                                                               0x18004334
+#define VI_VYSCCOEF1_15                                                               0x18004338
+#define VI_VYSCCOEF1_16                                                               0x1800433C
+#define VI_VYSCCOEF1_17                                                               0x18004340
+#define VI_VYSCCOEF1_18                                                               0x18004344
+#define VI_VYSCCOEF1_19                                                               0x18004348
+#define VI_VYSCCOEF1_0_reg_addr                                                      "0xB80042FC"
+#define VI_VYSCCOEF1_1_reg_addr                                                      "0xB8004300"
+#define VI_VYSCCOEF1_2_reg_addr                                                      "0xB8004304"
+#define VI_VYSCCOEF1_3_reg_addr                                                      "0xB8004308"
+#define VI_VYSCCOEF1_4_reg_addr                                                      "0xB800430C"
+#define VI_VYSCCOEF1_5_reg_addr                                                      "0xB8004310"
+#define VI_VYSCCOEF1_6_reg_addr                                                      "0xB8004314"
+#define VI_VYSCCOEF1_7_reg_addr                                                      "0xB8004318"
+#define VI_VYSCCOEF1_8_reg_addr                                                      "0xB800431C"
+#define VI_VYSCCOEF1_9_reg_addr                                                      "0xB8004320"
+#define VI_VYSCCOEF1_10_reg_addr                                                      "0xB8004324"
+#define VI_VYSCCOEF1_11_reg_addr                                                      "0xB8004328"
+#define VI_VYSCCOEF1_12_reg_addr                                                      "0xB800432C"
+#define VI_VYSCCOEF1_13_reg_addr                                                      "0xB8004330"
+#define VI_VYSCCOEF1_14_reg_addr                                                      "0xB8004334"
+#define VI_VYSCCOEF1_15_reg_addr                                                      "0xB8004338"
+#define VI_VYSCCOEF1_16_reg_addr                                                      "0xB800433C"
+#define VI_VYSCCOEF1_17_reg_addr                                                      "0xB8004340"
+#define VI_VYSCCOEF1_18_reg_addr                                                      "0xB8004344"
+#define VI_VYSCCOEF1_19_reg_addr                                                      "0xB8004348"
+#define VI_VYSCCOEF1_0_reg                                                           0xB80042FC
+#define VI_VYSCCOEF1_1_reg                                                           0xB8004300
+#define VI_VYSCCOEF1_2_reg                                                           0xB8004304
+#define VI_VYSCCOEF1_3_reg                                                           0xB8004308
+#define VI_VYSCCOEF1_4_reg                                                           0xB800430C
+#define VI_VYSCCOEF1_5_reg                                                           0xB8004310
+#define VI_VYSCCOEF1_6_reg                                                           0xB8004314
+#define VI_VYSCCOEF1_7_reg                                                           0xB8004318
+#define VI_VYSCCOEF1_8_reg                                                           0xB800431C
+#define VI_VYSCCOEF1_9_reg                                                           0xB8004320
+#define VI_VYSCCOEF1_10_reg                                                           0xB8004324
+#define VI_VYSCCOEF1_11_reg                                                           0xB8004328
+#define VI_VYSCCOEF1_12_reg                                                           0xB800432C
+#define VI_VYSCCOEF1_13_reg                                                           0xB8004330
+#define VI_VYSCCOEF1_14_reg                                                           0xB8004334
+#define VI_VYSCCOEF1_15_reg                                                           0xB8004338
+#define VI_VYSCCOEF1_16_reg                                                           0xB800433C
+#define VI_VYSCCOEF1_17_reg                                                           0xB8004340
+#define VI_VYSCCOEF1_18_reg                                                           0xB8004344
+#define VI_VYSCCOEF1_19_reg                                                           0xB8004348
+#define VI_VYSCCOEF1_0_inst_adr                                                      "0x00BF"
+#define VI_VYSCCOEF1_1_inst_adr                                                      "0x00C0"
+#define VI_VYSCCOEF1_2_inst_adr                                                      "0x00C1"
+#define VI_VYSCCOEF1_3_inst_adr                                                      "0x00C2"
+#define VI_VYSCCOEF1_4_inst_adr                                                      "0x00C3"
+#define VI_VYSCCOEF1_5_inst_adr                                                      "0x00C4"
+#define VI_VYSCCOEF1_6_inst_adr                                                      "0x00C5"
+#define VI_VYSCCOEF1_7_inst_adr                                                      "0x00C6"
+#define VI_VYSCCOEF1_8_inst_adr                                                      "0x00C7"
+#define VI_VYSCCOEF1_9_inst_adr                                                      "0x00C8"
+#define VI_VYSCCOEF1_10_inst_adr                                                      "0x00C9"
+#define VI_VYSCCOEF1_11_inst_adr                                                      "0x00CA"
+#define VI_VYSCCOEF1_12_inst_adr                                                      "0x00CB"
+#define VI_VYSCCOEF1_13_inst_adr                                                      "0x00CC"
+#define VI_VYSCCOEF1_14_inst_adr                                                      "0x00CD"
+#define VI_VYSCCOEF1_15_inst_adr                                                      "0x00CE"
+#define VI_VYSCCOEF1_16_inst_adr                                                      "0x00CF"
+#define VI_VYSCCOEF1_17_inst_adr                                                      "0x00D0"
+#define VI_VYSCCOEF1_18_inst_adr                                                      "0x00D1"
+#define VI_VYSCCOEF1_19_inst_adr                                                      "0x00D2"
+#define VI_VYSCCOEF1_0_inst                                                          0x00BF
+#define VI_VYSCCOEF1_1_inst                                                          0x00C0
+#define VI_VYSCCOEF1_2_inst                                                          0x00C1
+#define VI_VYSCCOEF1_3_inst                                                          0x00C2
+#define VI_VYSCCOEF1_4_inst                                                          0x00C3
+#define VI_VYSCCOEF1_5_inst                                                          0x00C4
+#define VI_VYSCCOEF1_6_inst                                                          0x00C5
+#define VI_VYSCCOEF1_7_inst                                                          0x00C6
+#define VI_VYSCCOEF1_8_inst                                                          0x00C7
+#define VI_VYSCCOEF1_9_inst                                                          0x00C8
+#define VI_VYSCCOEF1_10_inst                                                          0x00C9
+#define VI_VYSCCOEF1_11_inst                                                          0x00CA
+#define VI_VYSCCOEF1_12_inst                                                          0x00CB
+#define VI_VYSCCOEF1_13_inst                                                          0x00CC
+#define VI_VYSCCOEF1_14_inst                                                          0x00CD
+#define VI_VYSCCOEF1_15_inst                                                          0x00CE
+#define VI_VYSCCOEF1_16_inst                                                          0x00CF
+#define VI_VYSCCOEF1_17_inst                                                          0x00D0
+#define VI_VYSCCOEF1_18_inst                                                          0x00D1
+#define VI_VYSCCOEF1_19_inst                                                          0x00D2
+#define VI_VYSCCOEF1_ysccoef_shift                                                   (0)
+#define VI_VYSCCOEF1_ysccoef_mask                                                    (0x00003FFF)
+#define VI_VYSCCOEF1_ysccoef(data)                                                   (0x00003FFF&((data)<<0))
+#define VI_VYSCCOEF1_ysccoef_src(data)                                               ((0x00003FFF&(data))>>0)
+#define VI_VYSCCOEF1_get_ysccoef(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define VI_VYSCCOEF2_0                                                               0x1800434C
+#define VI_VYSCCOEF2_1                                                               0x18004350
+#define VI_VYSCCOEF2_2                                                               0x18004354
+#define VI_VYSCCOEF2_3                                                               0x18004358
+#define VI_VYSCCOEF2_4                                                               0x1800435C
+#define VI_VYSCCOEF2_5                                                               0x18004360
+#define VI_VYSCCOEF2_6                                                               0x18004364
+#define VI_VYSCCOEF2_7                                                               0x18004368
+#define VI_VYSCCOEF2_8                                                               0x1800436C
+#define VI_VYSCCOEF2_9                                                               0x18004370
+#define VI_VYSCCOEF2_10                                                               0x18004374
+#define VI_VYSCCOEF2_11                                                               0x18004378
+#define VI_VYSCCOEF2_12                                                               0x1800437C
+#define VI_VYSCCOEF2_13                                                               0x18004380
+#define VI_VYSCCOEF2_14                                                               0x18004384
+#define VI_VYSCCOEF2_15                                                               0x18004388
+#define VI_VYSCCOEF2_16                                                               0x1800438C
+#define VI_VYSCCOEF2_17                                                               0x18004390
+#define VI_VYSCCOEF2_18                                                               0x18004394
+#define VI_VYSCCOEF2_19                                                               0x18004398
+#define VI_VYSCCOEF2_0_reg_addr                                                      "0xB800434C"
+#define VI_VYSCCOEF2_1_reg_addr                                                      "0xB8004350"
+#define VI_VYSCCOEF2_2_reg_addr                                                      "0xB8004354"
+#define VI_VYSCCOEF2_3_reg_addr                                                      "0xB8004358"
+#define VI_VYSCCOEF2_4_reg_addr                                                      "0xB800435C"
+#define VI_VYSCCOEF2_5_reg_addr                                                      "0xB8004360"
+#define VI_VYSCCOEF2_6_reg_addr                                                      "0xB8004364"
+#define VI_VYSCCOEF2_7_reg_addr                                                      "0xB8004368"
+#define VI_VYSCCOEF2_8_reg_addr                                                      "0xB800436C"
+#define VI_VYSCCOEF2_9_reg_addr                                                      "0xB8004370"
+#define VI_VYSCCOEF2_10_reg_addr                                                      "0xB8004374"
+#define VI_VYSCCOEF2_11_reg_addr                                                      "0xB8004378"
+#define VI_VYSCCOEF2_12_reg_addr                                                      "0xB800437C"
+#define VI_VYSCCOEF2_13_reg_addr                                                      "0xB8004380"
+#define VI_VYSCCOEF2_14_reg_addr                                                      "0xB8004384"
+#define VI_VYSCCOEF2_15_reg_addr                                                      "0xB8004388"
+#define VI_VYSCCOEF2_16_reg_addr                                                      "0xB800438C"
+#define VI_VYSCCOEF2_17_reg_addr                                                      "0xB8004390"
+#define VI_VYSCCOEF2_18_reg_addr                                                      "0xB8004394"
+#define VI_VYSCCOEF2_19_reg_addr                                                      "0xB8004398"
+#define VI_VYSCCOEF2_0_reg                                                           0xB800434C
+#define VI_VYSCCOEF2_1_reg                                                           0xB8004350
+#define VI_VYSCCOEF2_2_reg                                                           0xB8004354
+#define VI_VYSCCOEF2_3_reg                                                           0xB8004358
+#define VI_VYSCCOEF2_4_reg                                                           0xB800435C
+#define VI_VYSCCOEF2_5_reg                                                           0xB8004360
+#define VI_VYSCCOEF2_6_reg                                                           0xB8004364
+#define VI_VYSCCOEF2_7_reg                                                           0xB8004368
+#define VI_VYSCCOEF2_8_reg                                                           0xB800436C
+#define VI_VYSCCOEF2_9_reg                                                           0xB8004370
+#define VI_VYSCCOEF2_10_reg                                                           0xB8004374
+#define VI_VYSCCOEF2_11_reg                                                           0xB8004378
+#define VI_VYSCCOEF2_12_reg                                                           0xB800437C
+#define VI_VYSCCOEF2_13_reg                                                           0xB8004380
+#define VI_VYSCCOEF2_14_reg                                                           0xB8004384
+#define VI_VYSCCOEF2_15_reg                                                           0xB8004388
+#define VI_VYSCCOEF2_16_reg                                                           0xB800438C
+#define VI_VYSCCOEF2_17_reg                                                           0xB8004390
+#define VI_VYSCCOEF2_18_reg                                                           0xB8004394
+#define VI_VYSCCOEF2_19_reg                                                           0xB8004398
+#define VI_VYSCCOEF2_0_inst_adr                                                      "0x00D3"
+#define VI_VYSCCOEF2_1_inst_adr                                                      "0x00D4"
+#define VI_VYSCCOEF2_2_inst_adr                                                      "0x00D5"
+#define VI_VYSCCOEF2_3_inst_adr                                                      "0x00D6"
+#define VI_VYSCCOEF2_4_inst_adr                                                      "0x00D7"
+#define VI_VYSCCOEF2_5_inst_adr                                                      "0x00D8"
+#define VI_VYSCCOEF2_6_inst_adr                                                      "0x00D9"
+#define VI_VYSCCOEF2_7_inst_adr                                                      "0x00DA"
+#define VI_VYSCCOEF2_8_inst_adr                                                      "0x00DB"
+#define VI_VYSCCOEF2_9_inst_adr                                                      "0x00DC"
+#define VI_VYSCCOEF2_10_inst_adr                                                      "0x00DD"
+#define VI_VYSCCOEF2_11_inst_adr                                                      "0x00DE"
+#define VI_VYSCCOEF2_12_inst_adr                                                      "0x00DF"
+#define VI_VYSCCOEF2_13_inst_adr                                                      "0x00E0"
+#define VI_VYSCCOEF2_14_inst_adr                                                      "0x00E1"
+#define VI_VYSCCOEF2_15_inst_adr                                                      "0x00E2"
+#define VI_VYSCCOEF2_16_inst_adr                                                      "0x00E3"
+#define VI_VYSCCOEF2_17_inst_adr                                                      "0x00E4"
+#define VI_VYSCCOEF2_18_inst_adr                                                      "0x00E5"
+#define VI_VYSCCOEF2_19_inst_adr                                                      "0x00E6"
+#define VI_VYSCCOEF2_0_inst                                                          0x00D3
+#define VI_VYSCCOEF2_1_inst                                                          0x00D4
+#define VI_VYSCCOEF2_2_inst                                                          0x00D5
+#define VI_VYSCCOEF2_3_inst                                                          0x00D6
+#define VI_VYSCCOEF2_4_inst                                                          0x00D7
+#define VI_VYSCCOEF2_5_inst                                                          0x00D8
+#define VI_VYSCCOEF2_6_inst                                                          0x00D9
+#define VI_VYSCCOEF2_7_inst                                                          0x00DA
+#define VI_VYSCCOEF2_8_inst                                                          0x00DB
+#define VI_VYSCCOEF2_9_inst                                                          0x00DC
+#define VI_VYSCCOEF2_10_inst                                                          0x00DD
+#define VI_VYSCCOEF2_11_inst                                                          0x00DE
+#define VI_VYSCCOEF2_12_inst                                                          0x00DF
+#define VI_VYSCCOEF2_13_inst                                                          0x00E0
+#define VI_VYSCCOEF2_14_inst                                                          0x00E1
+#define VI_VYSCCOEF2_15_inst                                                          0x00E2
+#define VI_VYSCCOEF2_16_inst                                                          0x00E3
+#define VI_VYSCCOEF2_17_inst                                                          0x00E4
+#define VI_VYSCCOEF2_18_inst                                                          0x00E5
+#define VI_VYSCCOEF2_19_inst                                                          0x00E6
+#define VI_VYSCCOEF2_ysccoef_shift                                                   (0)
+#define VI_VYSCCOEF2_ysccoef_mask                                                    (0x00003FFF)
+#define VI_VYSCCOEF2_ysccoef(data)                                                   (0x00003FFF&((data)<<0))
+#define VI_VYSCCOEF2_ysccoef_src(data)                                               ((0x00003FFF&(data))>>0)
+#define VI_VYSCCOEF2_get_ysccoef(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define VI_VCSCCOEF1_0                                                               0x1800439C
+#define VI_VCSCCOEF1_1                                                               0x180043A0
+#define VI_VCSCCOEF1_2                                                               0x180043A4
+#define VI_VCSCCOEF1_3                                                               0x180043A8
+#define VI_VCSCCOEF1_4                                                               0x180043AC
+#define VI_VCSCCOEF1_5                                                               0x180043B0
+#define VI_VCSCCOEF1_6                                                               0x180043B4
+#define VI_VCSCCOEF1_7                                                               0x180043B8
+#define VI_VCSCCOEF1_8                                                               0x180043BC
+#define VI_VCSCCOEF1_9                                                               0x180043C0
+#define VI_VCSCCOEF1_10                                                               0x180043C4
+#define VI_VCSCCOEF1_11                                                               0x180043C8
+#define VI_VCSCCOEF1_12                                                               0x180043CC
+#define VI_VCSCCOEF1_13                                                               0x180043D0
+#define VI_VCSCCOEF1_14                                                               0x180043D4
+#define VI_VCSCCOEF1_15                                                               0x180043D8
+#define VI_VCSCCOEF1_16                                                               0x180043DC
+#define VI_VCSCCOEF1_17                                                               0x180043E0
+#define VI_VCSCCOEF1_18                                                               0x180043E4
+#define VI_VCSCCOEF1_19                                                               0x180043E8
+#define VI_VCSCCOEF1_0_reg_addr                                                      "0xB800439C"
+#define VI_VCSCCOEF1_1_reg_addr                                                      "0xB80043A0"
+#define VI_VCSCCOEF1_2_reg_addr                                                      "0xB80043A4"
+#define VI_VCSCCOEF1_3_reg_addr                                                      "0xB80043A8"
+#define VI_VCSCCOEF1_4_reg_addr                                                      "0xB80043AC"
+#define VI_VCSCCOEF1_5_reg_addr                                                      "0xB80043B0"
+#define VI_VCSCCOEF1_6_reg_addr                                                      "0xB80043B4"
+#define VI_VCSCCOEF1_7_reg_addr                                                      "0xB80043B8"
+#define VI_VCSCCOEF1_8_reg_addr                                                      "0xB80043BC"
+#define VI_VCSCCOEF1_9_reg_addr                                                      "0xB80043C0"
+#define VI_VCSCCOEF1_10_reg_addr                                                      "0xB80043C4"
+#define VI_VCSCCOEF1_11_reg_addr                                                      "0xB80043C8"
+#define VI_VCSCCOEF1_12_reg_addr                                                      "0xB80043CC"
+#define VI_VCSCCOEF1_13_reg_addr                                                      "0xB80043D0"
+#define VI_VCSCCOEF1_14_reg_addr                                                      "0xB80043D4"
+#define VI_VCSCCOEF1_15_reg_addr                                                      "0xB80043D8"
+#define VI_VCSCCOEF1_16_reg_addr                                                      "0xB80043DC"
+#define VI_VCSCCOEF1_17_reg_addr                                                      "0xB80043E0"
+#define VI_VCSCCOEF1_18_reg_addr                                                      "0xB80043E4"
+#define VI_VCSCCOEF1_19_reg_addr                                                      "0xB80043E8"
+#define VI_VCSCCOEF1_0_reg                                                           0xB800439C
+#define VI_VCSCCOEF1_1_reg                                                           0xB80043A0
+#define VI_VCSCCOEF1_2_reg                                                           0xB80043A4
+#define VI_VCSCCOEF1_3_reg                                                           0xB80043A8
+#define VI_VCSCCOEF1_4_reg                                                           0xB80043AC
+#define VI_VCSCCOEF1_5_reg                                                           0xB80043B0
+#define VI_VCSCCOEF1_6_reg                                                           0xB80043B4
+#define VI_VCSCCOEF1_7_reg                                                           0xB80043B8
+#define VI_VCSCCOEF1_8_reg                                                           0xB80043BC
+#define VI_VCSCCOEF1_9_reg                                                           0xB80043C0
+#define VI_VCSCCOEF1_10_reg                                                           0xB80043C4
+#define VI_VCSCCOEF1_11_reg                                                           0xB80043C8
+#define VI_VCSCCOEF1_12_reg                                                           0xB80043CC
+#define VI_VCSCCOEF1_13_reg                                                           0xB80043D0
+#define VI_VCSCCOEF1_14_reg                                                           0xB80043D4
+#define VI_VCSCCOEF1_15_reg                                                           0xB80043D8
+#define VI_VCSCCOEF1_16_reg                                                           0xB80043DC
+#define VI_VCSCCOEF1_17_reg                                                           0xB80043E0
+#define VI_VCSCCOEF1_18_reg                                                           0xB80043E4
+#define VI_VCSCCOEF1_19_reg                                                           0xB80043E8
+#define VI_VCSCCOEF1_0_inst_adr                                                      "0x00E7"
+#define VI_VCSCCOEF1_1_inst_adr                                                      "0x00E8"
+#define VI_VCSCCOEF1_2_inst_adr                                                      "0x00E9"
+#define VI_VCSCCOEF1_3_inst_adr                                                      "0x00EA"
+#define VI_VCSCCOEF1_4_inst_adr                                                      "0x00EB"
+#define VI_VCSCCOEF1_5_inst_adr                                                      "0x00EC"
+#define VI_VCSCCOEF1_6_inst_adr                                                      "0x00ED"
+#define VI_VCSCCOEF1_7_inst_adr                                                      "0x00EE"
+#define VI_VCSCCOEF1_8_inst_adr                                                      "0x00EF"
+#define VI_VCSCCOEF1_9_inst_adr                                                      "0x00F0"
+#define VI_VCSCCOEF1_10_inst_adr                                                      "0x00F1"
+#define VI_VCSCCOEF1_11_inst_adr                                                      "0x00F2"
+#define VI_VCSCCOEF1_12_inst_adr                                                      "0x00F3"
+#define VI_VCSCCOEF1_13_inst_adr                                                      "0x00F4"
+#define VI_VCSCCOEF1_14_inst_adr                                                      "0x00F5"
+#define VI_VCSCCOEF1_15_inst_adr                                                      "0x00F6"
+#define VI_VCSCCOEF1_16_inst_adr                                                      "0x00F7"
+#define VI_VCSCCOEF1_17_inst_adr                                                      "0x00F8"
+#define VI_VCSCCOEF1_18_inst_adr                                                      "0x00F9"
+#define VI_VCSCCOEF1_19_inst_adr                                                      "0x00FA"
+#define VI_VCSCCOEF1_0_inst                                                          0x00E7
+#define VI_VCSCCOEF1_1_inst                                                          0x00E8
+#define VI_VCSCCOEF1_2_inst                                                          0x00E9
+#define VI_VCSCCOEF1_3_inst                                                          0x00EA
+#define VI_VCSCCOEF1_4_inst                                                          0x00EB
+#define VI_VCSCCOEF1_5_inst                                                          0x00EC
+#define VI_VCSCCOEF1_6_inst                                                          0x00ED
+#define VI_VCSCCOEF1_7_inst                                                          0x00EE
+#define VI_VCSCCOEF1_8_inst                                                          0x00EF
+#define VI_VCSCCOEF1_9_inst                                                          0x00F0
+#define VI_VCSCCOEF1_10_inst                                                          0x00F1
+#define VI_VCSCCOEF1_11_inst                                                          0x00F2
+#define VI_VCSCCOEF1_12_inst                                                          0x00F3
+#define VI_VCSCCOEF1_13_inst                                                          0x00F4
+#define VI_VCSCCOEF1_14_inst                                                          0x00F5
+#define VI_VCSCCOEF1_15_inst                                                          0x00F6
+#define VI_VCSCCOEF1_16_inst                                                          0x00F7
+#define VI_VCSCCOEF1_17_inst                                                          0x00F8
+#define VI_VCSCCOEF1_18_inst                                                          0x00F9
+#define VI_VCSCCOEF1_19_inst                                                          0x00FA
+#define VI_VCSCCOEF1_csccoef_shift                                                   (0)
+#define VI_VCSCCOEF1_csccoef_mask                                                    (0x00003FFF)
+#define VI_VCSCCOEF1_csccoef(data)                                                   (0x00003FFF&((data)<<0))
+#define VI_VCSCCOEF1_csccoef_src(data)                                               ((0x00003FFF&(data))>>0)
+#define VI_VCSCCOEF1_get_csccoef(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define VI_VCSCCOEF2_0                                                               0x180043EC
+#define VI_VCSCCOEF2_1                                                               0x180043F0
+#define VI_VCSCCOEF2_2                                                               0x180043F4
+#define VI_VCSCCOEF2_3                                                               0x180043F8
+#define VI_VCSCCOEF2_4                                                               0x180043FC
+#define VI_VCSCCOEF2_5                                                               0x18004400
+#define VI_VCSCCOEF2_6                                                               0x18004404
+#define VI_VCSCCOEF2_7                                                               0x18004408
+#define VI_VCSCCOEF2_8                                                               0x1800440C
+#define VI_VCSCCOEF2_9                                                               0x18004410
+#define VI_VCSCCOEF2_10                                                               0x18004414
+#define VI_VCSCCOEF2_11                                                               0x18004418
+#define VI_VCSCCOEF2_12                                                               0x1800441C
+#define VI_VCSCCOEF2_13                                                               0x18004420
+#define VI_VCSCCOEF2_14                                                               0x18004424
+#define VI_VCSCCOEF2_15                                                               0x18004428
+#define VI_VCSCCOEF2_16                                                               0x1800442C
+#define VI_VCSCCOEF2_17                                                               0x18004430
+#define VI_VCSCCOEF2_18                                                               0x18004434
+#define VI_VCSCCOEF2_19                                                               0x18004438
+#define VI_VCSCCOEF2_0_reg_addr                                                      "0xB80043EC"
+#define VI_VCSCCOEF2_1_reg_addr                                                      "0xB80043F0"
+#define VI_VCSCCOEF2_2_reg_addr                                                      "0xB80043F4"
+#define VI_VCSCCOEF2_3_reg_addr                                                      "0xB80043F8"
+#define VI_VCSCCOEF2_4_reg_addr                                                      "0xB80043FC"
+#define VI_VCSCCOEF2_5_reg_addr                                                      "0xB8004400"
+#define VI_VCSCCOEF2_6_reg_addr                                                      "0xB8004404"
+#define VI_VCSCCOEF2_7_reg_addr                                                      "0xB8004408"
+#define VI_VCSCCOEF2_8_reg_addr                                                      "0xB800440C"
+#define VI_VCSCCOEF2_9_reg_addr                                                      "0xB8004410"
+#define VI_VCSCCOEF2_10_reg_addr                                                      "0xB8004414"
+#define VI_VCSCCOEF2_11_reg_addr                                                      "0xB8004418"
+#define VI_VCSCCOEF2_12_reg_addr                                                      "0xB800441C"
+#define VI_VCSCCOEF2_13_reg_addr                                                      "0xB8004420"
+#define VI_VCSCCOEF2_14_reg_addr                                                      "0xB8004424"
+#define VI_VCSCCOEF2_15_reg_addr                                                      "0xB8004428"
+#define VI_VCSCCOEF2_16_reg_addr                                                      "0xB800442C"
+#define VI_VCSCCOEF2_17_reg_addr                                                      "0xB8004430"
+#define VI_VCSCCOEF2_18_reg_addr                                                      "0xB8004434"
+#define VI_VCSCCOEF2_19_reg_addr                                                      "0xB8004438"
+#define VI_VCSCCOEF2_0_reg                                                           0xB80043EC
+#define VI_VCSCCOEF2_1_reg                                                           0xB80043F0
+#define VI_VCSCCOEF2_2_reg                                                           0xB80043F4
+#define VI_VCSCCOEF2_3_reg                                                           0xB80043F8
+#define VI_VCSCCOEF2_4_reg                                                           0xB80043FC
+#define VI_VCSCCOEF2_5_reg                                                           0xB8004400
+#define VI_VCSCCOEF2_6_reg                                                           0xB8004404
+#define VI_VCSCCOEF2_7_reg                                                           0xB8004408
+#define VI_VCSCCOEF2_8_reg                                                           0xB800440C
+#define VI_VCSCCOEF2_9_reg                                                           0xB8004410
+#define VI_VCSCCOEF2_10_reg                                                           0xB8004414
+#define VI_VCSCCOEF2_11_reg                                                           0xB8004418
+#define VI_VCSCCOEF2_12_reg                                                           0xB800441C
+#define VI_VCSCCOEF2_13_reg                                                           0xB8004420
+#define VI_VCSCCOEF2_14_reg                                                           0xB8004424
+#define VI_VCSCCOEF2_15_reg                                                           0xB8004428
+#define VI_VCSCCOEF2_16_reg                                                           0xB800442C
+#define VI_VCSCCOEF2_17_reg                                                           0xB8004430
+#define VI_VCSCCOEF2_18_reg                                                           0xB8004434
+#define VI_VCSCCOEF2_19_reg                                                           0xB8004438
+#define VI_VCSCCOEF2_0_inst_adr                                                      "0x00FB"
+#define VI_VCSCCOEF2_1_inst_adr                                                      "0x00FC"
+#define VI_VCSCCOEF2_2_inst_adr                                                      "0x00FD"
+#define VI_VCSCCOEF2_3_inst_adr                                                      "0x00FE"
+#define VI_VCSCCOEF2_4_inst_adr                                                      "0x00FF"
+#define VI_VCSCCOEF2_5_inst_adr                                                      "0x0100"
+#define VI_VCSCCOEF2_6_inst_adr                                                      "0x0101"
+#define VI_VCSCCOEF2_7_inst_adr                                                      "0x0102"
+#define VI_VCSCCOEF2_8_inst_adr                                                      "0x0103"
+#define VI_VCSCCOEF2_9_inst_adr                                                      "0x0104"
+#define VI_VCSCCOEF2_10_inst_adr                                                      "0x0105"
+#define VI_VCSCCOEF2_11_inst_adr                                                      "0x0106"
+#define VI_VCSCCOEF2_12_inst_adr                                                      "0x0107"
+#define VI_VCSCCOEF2_13_inst_adr                                                      "0x0108"
+#define VI_VCSCCOEF2_14_inst_adr                                                      "0x0109"
+#define VI_VCSCCOEF2_15_inst_adr                                                      "0x010A"
+#define VI_VCSCCOEF2_16_inst_adr                                                      "0x010B"
+#define VI_VCSCCOEF2_17_inst_adr                                                      "0x010C"
+#define VI_VCSCCOEF2_18_inst_adr                                                      "0x010D"
+#define VI_VCSCCOEF2_19_inst_adr                                                      "0x010E"
+#define VI_VCSCCOEF2_0_inst                                                          0x00FB
+#define VI_VCSCCOEF2_1_inst                                                          0x00FC
+#define VI_VCSCCOEF2_2_inst                                                          0x00FD
+#define VI_VCSCCOEF2_3_inst                                                          0x00FE
+#define VI_VCSCCOEF2_4_inst                                                          0x00FF
+#define VI_VCSCCOEF2_5_inst                                                          0x0100
+#define VI_VCSCCOEF2_6_inst                                                          0x0101
+#define VI_VCSCCOEF2_7_inst                                                          0x0102
+#define VI_VCSCCOEF2_8_inst                                                          0x0103
+#define VI_VCSCCOEF2_9_inst                                                          0x0104
+#define VI_VCSCCOEF2_10_inst                                                          0x0105
+#define VI_VCSCCOEF2_11_inst                                                          0x0106
+#define VI_VCSCCOEF2_12_inst                                                          0x0107
+#define VI_VCSCCOEF2_13_inst                                                          0x0108
+#define VI_VCSCCOEF2_14_inst                                                          0x0109
+#define VI_VCSCCOEF2_15_inst                                                          0x010A
+#define VI_VCSCCOEF2_16_inst                                                          0x010B
+#define VI_VCSCCOEF2_17_inst                                                          0x010C
+#define VI_VCSCCOEF2_18_inst                                                          0x010D
+#define VI_VCSCCOEF2_19_inst                                                          0x010E
+#define VI_VCSCCOEF2_csccoef_shift                                                   (0)
+#define VI_VCSCCOEF2_csccoef_mask                                                    (0x00003FFF)
+#define VI_VCSCCOEF2_csccoef(data)                                                   (0x00003FFF&((data)<<0))
+#define VI_VCSCCOEF2_csccoef_src(data)                                               ((0x00003FFF&(data))>>0)
+#define VI_VCSCCOEF2_get_csccoef(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define VI_VOFFSETEN                                                                 0x1800447c
+#define VI_VOFFSETEN_reg_addr                                                        "0xB800447C"
+#define VI_VOFFSETEN_reg                                                             0xB800447C
+#define VI_VOFFSETEN_inst_adr                                                        "0x001F"
+#define VI_VOFFSETEN_inst                                                            0x001F
+#define VI_VOFFSETEN_y1_clamp_shift                                                  (8)
+#define VI_VOFFSETEN_y1_clamp_mask                                                   (0x00000100)
+#define VI_VOFFSETEN_y1_clamp(data)                                                  (0x00000100&((data)<<8))
+#define VI_VOFFSETEN_y1_clamp_src(data)                                              ((0x00000100&(data))>>8)
+#define VI_VOFFSETEN_get_y1_clamp(data)                                              ((0x00000100&(data))>>8)
+#define VI_VOFFSETEN_c1_clamp_shift                                                  (7)
+#define VI_VOFFSETEN_c1_clamp_mask                                                   (0x00000080)
+#define VI_VOFFSETEN_c1_clamp(data)                                                  (0x00000080&((data)<<7))
+#define VI_VOFFSETEN_c1_clamp_src(data)                                              ((0x00000080&(data))>>7)
+#define VI_VOFFSETEN_get_c1_clamp(data)                                              ((0x00000080&(data))>>7)
+#define VI_VOFFSETEN_y2_clamp_shift                                                  (6)
+#define VI_VOFFSETEN_y2_clamp_mask                                                   (0x00000040)
+#define VI_VOFFSETEN_y2_clamp(data)                                                  (0x00000040&((data)<<6))
+#define VI_VOFFSETEN_y2_clamp_src(data)                                              ((0x00000040&(data))>>6)
+#define VI_VOFFSETEN_get_y2_clamp(data)                                              ((0x00000040&(data))>>6)
+#define VI_VOFFSETEN_c2_clamp_shift                                                  (5)
+#define VI_VOFFSETEN_c2_clamp_mask                                                   (0x00000020)
+#define VI_VOFFSETEN_c2_clamp(data)                                                  (0x00000020&((data)<<5))
+#define VI_VOFFSETEN_c2_clamp_src(data)                                              ((0x00000020&(data))>>5)
+#define VI_VOFFSETEN_get_c2_clamp(data)                                              ((0x00000020&(data))>>5)
+#define VI_VOFFSETEN_y1_shift                                                        (4)
+#define VI_VOFFSETEN_y1_mask                                                         (0x00000010)
+#define VI_VOFFSETEN_y1(data)                                                        (0x00000010&((data)<<4))
+#define VI_VOFFSETEN_y1_src(data)                                                    ((0x00000010&(data))>>4)
+#define VI_VOFFSETEN_get_y1(data)                                                    ((0x00000010&(data))>>4)
+#define VI_VOFFSETEN_c1_shift                                                        (3)
+#define VI_VOFFSETEN_c1_mask                                                         (0x00000008)
+#define VI_VOFFSETEN_c1(data)                                                        (0x00000008&((data)<<3))
+#define VI_VOFFSETEN_c1_src(data)                                                    ((0x00000008&(data))>>3)
+#define VI_VOFFSETEN_get_c1(data)                                                    ((0x00000008&(data))>>3)
+#define VI_VOFFSETEN_y2_shift                                                        (2)
+#define VI_VOFFSETEN_y2_mask                                                         (0x00000004)
+#define VI_VOFFSETEN_y2(data)                                                        (0x00000004&((data)<<2))
+#define VI_VOFFSETEN_y2_src(data)                                                    ((0x00000004&(data))>>2)
+#define VI_VOFFSETEN_get_y2(data)                                                    ((0x00000004&(data))>>2)
+#define VI_VOFFSETEN_c2_shift                                                        (1)
+#define VI_VOFFSETEN_c2_mask                                                         (0x00000002)
+#define VI_VOFFSETEN_c2(data)                                                        (0x00000002&((data)<<1))
+#define VI_VOFFSETEN_c2_src(data)                                                    ((0x00000002&(data))>>1)
+#define VI_VOFFSETEN_get_c2(data)                                                    ((0x00000002&(data))>>1)
+#define VI_VOFFSETEN_write_data_shift                                                (0)
+#define VI_VOFFSETEN_write_data_mask                                                 (0x00000001)
+#define VI_VOFFSETEN_write_data(data)                                                (0x00000001&((data)<<0))
+#define VI_VOFFSETEN_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define VI_VOFFSETEN_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VI_VINFO1                                                                    0x1800456c
+#define VI_VINFO1_reg_addr                                                           "0xB800456C"
+#define VI_VINFO1_reg                                                                0xB800456C
+#define VI_VINFO1_inst_adr                                                           "0x005B"
+#define VI_VINFO1_inst                                                               0x005B
+#define VI_VINFO1_write_enable1_shift                                                (23)
+#define VI_VINFO1_write_enable1_mask                                                 (0x00800000)
+#define VI_VINFO1_write_enable1(data)                                                (0x00800000&((data)<<23))
+#define VI_VINFO1_write_enable1_src(data)                                            ((0x00800000&(data))>>23)
+#define VI_VINFO1_get_write_enable1(data)                                            ((0x00800000&(data))>>23)
+#define VI_VINFO1_heighy_shift                                                       (12)
+#define VI_VINFO1_heighy_mask                                                        (0x007FF000)
+#define VI_VINFO1_heighy(data)                                                       (0x007FF000&((data)<<12))
+#define VI_VINFO1_heighy_src(data)                                                   ((0x007FF000&(data))>>12)
+#define VI_VINFO1_get_heighy(data)                                                   ((0x007FF000&(data))>>12)
+#define VI_VINFO1_write_enable2_shift                                                (11)
+#define VI_VINFO1_write_enable2_mask                                                 (0x00000800)
+#define VI_VINFO1_write_enable2(data)                                                (0x00000800&((data)<<11))
+#define VI_VINFO1_write_enable2_src(data)                                            ((0x00000800&(data))>>11)
+#define VI_VINFO1_get_write_enable2(data)                                            ((0x00000800&(data))>>11)
+#define VI_VINFO1_heighc_shift                                                       (0)
+#define VI_VINFO1_heighc_mask                                                        (0x000007FF)
+#define VI_VINFO1_heighc(data)                                                       (0x000007FF&((data)<<0))
+#define VI_VINFO1_heighc_src(data)                                                   ((0x000007FF&(data))>>0)
+#define VI_VINFO1_get_heighc(data)                                                   ((0x000007FF&(data))>>0)
+
+
+#define VI_VINFO2                                                                    0x18004574
+#define VI_VINFO2_reg_addr                                                           "0xB8004574"
+#define VI_VINFO2_reg                                                                0xB8004574
+#define VI_VINFO2_inst_adr                                                           "0x005D"
+#define VI_VINFO2_inst                                                               0x005D
+#define VI_VINFO2_write_enable1_shift                                                (23)
+#define VI_VINFO2_write_enable1_mask                                                 (0x00800000)
+#define VI_VINFO2_write_enable1(data)                                                (0x00800000&((data)<<23))
+#define VI_VINFO2_write_enable1_src(data)                                            ((0x00800000&(data))>>23)
+#define VI_VINFO2_get_write_enable1(data)                                            ((0x00800000&(data))>>23)
+#define VI_VINFO2_heighy_shift                                                       (12)
+#define VI_VINFO2_heighy_mask                                                        (0x007FF000)
+#define VI_VINFO2_heighy(data)                                                       (0x007FF000&((data)<<12))
+#define VI_VINFO2_heighy_src(data)                                                   ((0x007FF000&(data))>>12)
+#define VI_VINFO2_get_heighy(data)                                                   ((0x007FF000&(data))>>12)
+#define VI_VINFO2_write_enable2_shift                                                (11)
+#define VI_VINFO2_write_enable2_mask                                                 (0x00000800)
+#define VI_VINFO2_write_enable2(data)                                                (0x00000800&((data)<<11))
+#define VI_VINFO2_write_enable2_src(data)                                            ((0x00000800&(data))>>11)
+#define VI_VINFO2_get_write_enable2(data)                                            ((0x00000800&(data))>>11)
+#define VI_VINFO2_heighc_shift                                                       (0)
+#define VI_VINFO2_heighc_mask                                                        (0x000007FF)
+#define VI_VINFO2_heighc(data)                                                       (0x000007FF&((data)<<0))
+#define VI_VINFO2_heighc_src(data)                                                   ((0x000007FF&(data))>>0)
+#define VI_VINFO2_get_heighc(data)                                                   ((0x000007FF&(data))>>0)
+
+
+#define VI_SCCTL1                                                                    0x18004070
+#define VI_SCCTL1_reg_addr                                                           "0xB8004070"
+#define VI_SCCTL1_reg                                                                0xB8004070
+#define VI_SCCTL1_inst_adr                                                           "0x001C"
+#define VI_SCCTL1_inst                                                               0x001C
+#define VI_SCCTL1_yen_shift                                                          (4)
+#define VI_SCCTL1_yen_mask                                                           (0x00000010)
+#define VI_SCCTL1_yen(data)                                                          (0x00000010&((data)<<4))
+#define VI_SCCTL1_yen_src(data)                                                      ((0x00000010&(data))>>4)
+#define VI_SCCTL1_get_yen(data)                                                      ((0x00000010&(data))>>4)
+#define VI_SCCTL1_yoddtype_shift                                                     (3)
+#define VI_SCCTL1_yoddtype_mask                                                      (0x00000008)
+#define VI_SCCTL1_yoddtype(data)                                                     (0x00000008&((data)<<3))
+#define VI_SCCTL1_yoddtype_src(data)                                                 ((0x00000008&(data))>>3)
+#define VI_SCCTL1_get_yoddtype(data)                                                 ((0x00000008&(data))>>3)
+#define VI_SCCTL1_cen_shift                                                          (2)
+#define VI_SCCTL1_cen_mask                                                           (0x00000004)
+#define VI_SCCTL1_cen(data)                                                          (0x00000004&((data)<<2))
+#define VI_SCCTL1_cen_src(data)                                                      ((0x00000004&(data))>>2)
+#define VI_SCCTL1_get_cen(data)                                                      ((0x00000004&(data))>>2)
+#define VI_SCCTL1_coddtype_shift                                                     (1)
+#define VI_SCCTL1_coddtype_mask                                                      (0x00000002)
+#define VI_SCCTL1_coddtype(data)                                                     (0x00000002&((data)<<1))
+#define VI_SCCTL1_coddtype_src(data)                                                 ((0x00000002&(data))>>1)
+#define VI_SCCTL1_get_coddtype(data)                                                 ((0x00000002&(data))>>1)
+#define VI_SCCTL1_write_data_shift                                                   (0)
+#define VI_SCCTL1_write_data_mask                                                    (0x00000001)
+#define VI_SCCTL1_write_data(data)                                                   (0x00000001&((data)<<0))
+#define VI_SCCTL1_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define VI_SCCTL1_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VI_SCCTL2                                                                    0x18004074
+#define VI_SCCTL2_reg_addr                                                           "0xB8004074"
+#define VI_SCCTL2_reg                                                                0xB8004074
+#define VI_SCCTL2_inst_adr                                                           "0x001D"
+#define VI_SCCTL2_inst                                                               0x001D
+#define VI_SCCTL2_yen_shift                                                          (4)
+#define VI_SCCTL2_yen_mask                                                           (0x00000010)
+#define VI_SCCTL2_yen(data)                                                          (0x00000010&((data)<<4))
+#define VI_SCCTL2_yen_src(data)                                                      ((0x00000010&(data))>>4)
+#define VI_SCCTL2_get_yen(data)                                                      ((0x00000010&(data))>>4)
+#define VI_SCCTL2_yoddtype_shift                                                     (3)
+#define VI_SCCTL2_yoddtype_mask                                                      (0x00000008)
+#define VI_SCCTL2_yoddtype(data)                                                     (0x00000008&((data)<<3))
+#define VI_SCCTL2_yoddtype_src(data)                                                 ((0x00000008&(data))>>3)
+#define VI_SCCTL2_get_yoddtype(data)                                                 ((0x00000008&(data))>>3)
+#define VI_SCCTL2_cen_shift                                                          (2)
+#define VI_SCCTL2_cen_mask                                                           (0x00000004)
+#define VI_SCCTL2_cen(data)                                                          (0x00000004&((data)<<2))
+#define VI_SCCTL2_cen_src(data)                                                      ((0x00000004&(data))>>2)
+#define VI_SCCTL2_get_cen(data)                                                      ((0x00000004&(data))>>2)
+#define VI_SCCTL2_coddtype_shift                                                     (1)
+#define VI_SCCTL2_coddtype_mask                                                      (0x00000002)
+#define VI_SCCTL2_coddtype(data)                                                     (0x00000002&((data)<<1))
+#define VI_SCCTL2_coddtype_src(data)                                                 ((0x00000002&(data))>>1)
+#define VI_SCCTL2_get_coddtype(data)                                                 ((0x00000002&(data))>>1)
+#define VI_SCCTL2_write_data_shift                                                   (0)
+#define VI_SCCTL2_write_data_mask                                                    (0x00000001)
+#define VI_SCCTL2_write_data(data)                                                   (0x00000001&((data)<<0))
+#define VI_SCCTL2_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define VI_SCCTL2_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VI_YSC1                                                                      0x18004078
+#define VI_YSC1_reg_addr                                                             "0xB8004078"
+#define VI_YSC1_reg                                                                  0xB8004078
+#define VI_YSC1_inst_adr                                                             "0x001E"
+#define VI_YSC1_inst                                                                 0x001E
+#define VI_YSC1_write_enable1_shift                                                  (29)
+#define VI_YSC1_write_enable1_mask                                                   (0x20000000)
+#define VI_YSC1_write_enable1(data)                                                  (0x20000000&((data)<<29))
+#define VI_YSC1_write_enable1_src(data)                                              ((0x20000000&(data))>>29)
+#define VI_YSC1_get_write_enable1(data)                                              ((0x20000000&(data))>>29)
+#define VI_YSC1_yonp_shift                                                           (18)
+#define VI_YSC1_yonp_mask                                                            (0x1FFC0000)
+#define VI_YSC1_yonp(data)                                                           (0x1FFC0000&((data)<<18))
+#define VI_YSC1_yonp_src(data)                                                       ((0x1FFC0000&(data))>>18)
+#define VI_YSC1_get_yonp(data)                                                       ((0x1FFC0000&(data))>>18)
+#define VI_YSC1_write_enable2_shift                                                  (17)
+#define VI_YSC1_write_enable2_mask                                                   (0x00020000)
+#define VI_YSC1_write_enable2(data)                                                  (0x00020000&((data)<<17))
+#define VI_YSC1_write_enable2_src(data)                                              ((0x00020000&(data))>>17)
+#define VI_YSC1_get_write_enable2(data)                                              ((0x00020000&(data))>>17)
+#define VI_YSC1_ydphs_shift                                                          (0)
+#define VI_YSC1_ydphs_mask                                                           (0x0001FFFF)
+#define VI_YSC1_ydphs(data)                                                          (0x0001FFFF&((data)<<0))
+#define VI_YSC1_ydphs_src(data)                                                      ((0x0001FFFF&(data))>>0)
+#define VI_YSC1_get_ydphs(data)                                                      ((0x0001FFFF&(data))>>0)
+
+
+#define VI_CSC1                                                                      0x1800407c
+#define VI_CSC1_reg_addr                                                             "0xB800407C"
+#define VI_CSC1_reg                                                                  0xB800407C
+#define VI_CSC1_inst_adr                                                             "0x001F"
+#define VI_CSC1_inst                                                                 0x001F
+#define VI_CSC1_write_enable1_shift                                                  (29)
+#define VI_CSC1_write_enable1_mask                                                   (0x20000000)
+#define VI_CSC1_write_enable1(data)                                                  (0x20000000&((data)<<29))
+#define VI_CSC1_write_enable1_src(data)                                              ((0x20000000&(data))>>29)
+#define VI_CSC1_get_write_enable1(data)                                              ((0x20000000&(data))>>29)
+#define VI_CSC1_conp_shift                                                           (18)
+#define VI_CSC1_conp_mask                                                            (0x1FFC0000)
+#define VI_CSC1_conp(data)                                                           (0x1FFC0000&((data)<<18))
+#define VI_CSC1_conp_src(data)                                                       ((0x1FFC0000&(data))>>18)
+#define VI_CSC1_get_conp(data)                                                       ((0x1FFC0000&(data))>>18)
+#define VI_CSC1_write_enable2_shift                                                  (17)
+#define VI_CSC1_write_enable2_mask                                                   (0x00020000)
+#define VI_CSC1_write_enable2(data)                                                  (0x00020000&((data)<<17))
+#define VI_CSC1_write_enable2_src(data)                                              ((0x00020000&(data))>>17)
+#define VI_CSC1_get_write_enable2(data)                                              ((0x00020000&(data))>>17)
+#define VI_CSC1_cdphs_shift                                                          (0)
+#define VI_CSC1_cdphs_mask                                                           (0x0001FFFF)
+#define VI_CSC1_cdphs(data)                                                          (0x0001FFFF&((data)<<0))
+#define VI_CSC1_cdphs_src(data)                                                      ((0x0001FFFF&(data))>>0)
+#define VI_CSC1_get_cdphs(data)                                                      ((0x0001FFFF&(data))>>0)
+
+
+#define VI_YSC2                                                                      0x18004080
+#define VI_YSC2_reg_addr                                                             "0xB8004080"
+#define VI_YSC2_reg                                                                  0xB8004080
+#define VI_YSC2_inst_adr                                                             "0x0020"
+#define VI_YSC2_inst                                                                 0x0020
+#define VI_YSC2_write_enable1_shift                                                  (29)
+#define VI_YSC2_write_enable1_mask                                                   (0x20000000)
+#define VI_YSC2_write_enable1(data)                                                  (0x20000000&((data)<<29))
+#define VI_YSC2_write_enable1_src(data)                                              ((0x20000000&(data))>>29)
+#define VI_YSC2_get_write_enable1(data)                                              ((0x20000000&(data))>>29)
+#define VI_YSC2_yonp_shift                                                           (18)
+#define VI_YSC2_yonp_mask                                                            (0x1FFC0000)
+#define VI_YSC2_yonp(data)                                                           (0x1FFC0000&((data)<<18))
+#define VI_YSC2_yonp_src(data)                                                       ((0x1FFC0000&(data))>>18)
+#define VI_YSC2_get_yonp(data)                                                       ((0x1FFC0000&(data))>>18)
+#define VI_YSC2_write_enable2_shift                                                  (17)
+#define VI_YSC2_write_enable2_mask                                                   (0x00020000)
+#define VI_YSC2_write_enable2(data)                                                  (0x00020000&((data)<<17))
+#define VI_YSC2_write_enable2_src(data)                                              ((0x00020000&(data))>>17)
+#define VI_YSC2_get_write_enable2(data)                                              ((0x00020000&(data))>>17)
+#define VI_YSC2_ydphs_shift                                                          (0)
+#define VI_YSC2_ydphs_mask                                                           (0x0001FFFF)
+#define VI_YSC2_ydphs(data)                                                          (0x0001FFFF&((data)<<0))
+#define VI_YSC2_ydphs_src(data)                                                      ((0x0001FFFF&(data))>>0)
+#define VI_YSC2_get_ydphs(data)                                                      ((0x0001FFFF&(data))>>0)
+
+
+#define VI_CSC2                                                                      0x18004084
+#define VI_CSC2_reg_addr                                                             "0xB8004084"
+#define VI_CSC2_reg                                                                  0xB8004084
+#define VI_CSC2_inst_adr                                                             "0x0021"
+#define VI_CSC2_inst                                                                 0x0021
+#define VI_CSC2_write_enable1_shift                                                  (29)
+#define VI_CSC2_write_enable1_mask                                                   (0x20000000)
+#define VI_CSC2_write_enable1(data)                                                  (0x20000000&((data)<<29))
+#define VI_CSC2_write_enable1_src(data)                                              ((0x20000000&(data))>>29)
+#define VI_CSC2_get_write_enable1(data)                                              ((0x20000000&(data))>>29)
+#define VI_CSC2_conp_shift                                                           (18)
+#define VI_CSC2_conp_mask                                                            (0x1FFC0000)
+#define VI_CSC2_conp(data)                                                           (0x1FFC0000&((data)<<18))
+#define VI_CSC2_conp_src(data)                                                       ((0x1FFC0000&(data))>>18)
+#define VI_CSC2_get_conp(data)                                                       ((0x1FFC0000&(data))>>18)
+#define VI_CSC2_write_enable2_shift                                                  (17)
+#define VI_CSC2_write_enable2_mask                                                   (0x00020000)
+#define VI_CSC2_write_enable2(data)                                                  (0x00020000&((data)<<17))
+#define VI_CSC2_write_enable2_src(data)                                              ((0x00020000&(data))>>17)
+#define VI_CSC2_get_write_enable2(data)                                              ((0x00020000&(data))>>17)
+#define VI_CSC2_cdphs_shift                                                          (0)
+#define VI_CSC2_cdphs_mask                                                           (0x0001FFFF)
+#define VI_CSC2_cdphs(data)                                                          (0x0001FFFF&((data)<<0))
+#define VI_CSC2_cdphs_src(data)                                                      ((0x0001FFFF&(data))>>0)
+#define VI_CSC2_get_cdphs(data)                                                      ((0x0001FFFF&(data))>>0)
+
+
+#define VI_YIPOS1                                                                    0x18004088
+#define VI_YIPOS1_reg_addr                                                           "0xB8004088"
+#define VI_YIPOS1_reg                                                                0xB8004088
+#define VI_YIPOS1_inst_adr                                                           "0x0022"
+#define VI_YIPOS1_inst                                                               0x0022
+#define VI_YIPOS1_init_offset_shift                                                  (14)
+#define VI_YIPOS1_init_offset_mask                                                   (0x01FFC000)
+#define VI_YIPOS1_init_offset(data)                                                  (0x01FFC000&((data)<<14))
+#define VI_YIPOS1_init_offset_src(data)                                              ((0x01FFC000&(data))>>14)
+#define VI_YIPOS1_get_init_offset(data)                                              ((0x01FFC000&(data))>>14)
+#define VI_YIPOS1_init_phase_shift                                                   (0)
+#define VI_YIPOS1_init_phase_mask                                                    (0x00003FFF)
+#define VI_YIPOS1_init_phase(data)                                                   (0x00003FFF&((data)<<0))
+#define VI_YIPOS1_init_phase_src(data)                                               ((0x00003FFF&(data))>>0)
+#define VI_YIPOS1_get_init_phase(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define VI_YIPOS2                                                                    0x1800408c
+#define VI_YIPOS2_reg_addr                                                           "0xB800408C"
+#define VI_YIPOS2_reg                                                                0xB800408C
+#define VI_YIPOS2_inst_adr                                                           "0x0023"
+#define VI_YIPOS2_inst                                                               0x0023
+#define VI_YIPOS2_init_offset_shift                                                  (14)
+#define VI_YIPOS2_init_offset_mask                                                   (0x01FFC000)
+#define VI_YIPOS2_init_offset(data)                                                  (0x01FFC000&((data)<<14))
+#define VI_YIPOS2_init_offset_src(data)                                              ((0x01FFC000&(data))>>14)
+#define VI_YIPOS2_get_init_offset(data)                                              ((0x01FFC000&(data))>>14)
+#define VI_YIPOS2_init_phase_shift                                                   (0)
+#define VI_YIPOS2_init_phase_mask                                                    (0x00003FFF)
+#define VI_YIPOS2_init_phase(data)                                                   (0x00003FFF&((data)<<0))
+#define VI_YIPOS2_init_phase_src(data)                                               ((0x00003FFF&(data))>>0)
+#define VI_YIPOS2_get_init_phase(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define VI_CIPOS1                                                                    0x18004090
+#define VI_CIPOS1_reg_addr                                                           "0xB8004090"
+#define VI_CIPOS1_reg                                                                0xB8004090
+#define VI_CIPOS1_inst_adr                                                           "0x0024"
+#define VI_CIPOS1_inst                                                               0x0024
+#define VI_CIPOS1_init_offset_shift                                                  (14)
+#define VI_CIPOS1_init_offset_mask                                                   (0x01FFC000)
+#define VI_CIPOS1_init_offset(data)                                                  (0x01FFC000&((data)<<14))
+#define VI_CIPOS1_init_offset_src(data)                                              ((0x01FFC000&(data))>>14)
+#define VI_CIPOS1_get_init_offset(data)                                              ((0x01FFC000&(data))>>14)
+#define VI_CIPOS1_init_phase_shift                                                   (0)
+#define VI_CIPOS1_init_phase_mask                                                    (0x00003FFF)
+#define VI_CIPOS1_init_phase(data)                                                   (0x00003FFF&((data)<<0))
+#define VI_CIPOS1_init_phase_src(data)                                               ((0x00003FFF&(data))>>0)
+#define VI_CIPOS1_get_init_phase(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define VI_CIPOS2                                                                    0x18004094
+#define VI_CIPOS2_reg_addr                                                           "0xB8004094"
+#define VI_CIPOS2_reg                                                                0xB8004094
+#define VI_CIPOS2_inst_adr                                                           "0x0025"
+#define VI_CIPOS2_inst                                                               0x0025
+#define VI_CIPOS2_init_offset_shift                                                  (14)
+#define VI_CIPOS2_init_offset_mask                                                   (0x01FFC000)
+#define VI_CIPOS2_init_offset(data)                                                  (0x01FFC000&((data)<<14))
+#define VI_CIPOS2_init_offset_src(data)                                              ((0x01FFC000&(data))>>14)
+#define VI_CIPOS2_get_init_offset(data)                                              ((0x01FFC000&(data))>>14)
+#define VI_CIPOS2_init_phase_shift                                                   (0)
+#define VI_CIPOS2_init_phase_mask                                                    (0x00003FFF)
+#define VI_CIPOS2_init_phase(data)                                                   (0x00003FFF&((data)<<0))
+#define VI_CIPOS2_init_phase_src(data)                                               ((0x00003FFF&(data))>>0)
+#define VI_CIPOS2_get_init_phase(data)                                               ((0x00003FFF&(data))>>0)
+
+
+#define VI_YSCCOEF1_0                                                                0x18004098
+#define VI_YSCCOEF1_1                                                                0x1800409C
+#define VI_YSCCOEF1_2                                                                0x180040A0
+#define VI_YSCCOEF1_3                                                                0x180040A4
+#define VI_YSCCOEF1_4                                                                0x180040A8
+#define VI_YSCCOEF1_5                                                                0x180040AC
+#define VI_YSCCOEF1_6                                                                0x180040B0
+#define VI_YSCCOEF1_7                                                                0x180040B4
+#define VI_YSCCOEF1_8                                                                0x180040B8
+#define VI_YSCCOEF1_9                                                                0x180040BC
+#define VI_YSCCOEF1_10                                                                0x180040C0
+#define VI_YSCCOEF1_11                                                                0x180040C4
+#define VI_YSCCOEF1_12                                                                0x180040C8
+#define VI_YSCCOEF1_13                                                                0x180040CC
+#define VI_YSCCOEF1_14                                                                0x180040D0
+#define VI_YSCCOEF1_15                                                                0x180040D4
+#define VI_YSCCOEF1_16                                                                0x180040D8
+#define VI_YSCCOEF1_17                                                                0x180040DC
+#define VI_YSCCOEF1_18                                                                0x180040E0
+#define VI_YSCCOEF1_19                                                                0x180040E4
+#define VI_YSCCOEF1_20                                                                0x180040E8
+#define VI_YSCCOEF1_21                                                                0x180040EC
+#define VI_YSCCOEF1_22                                                                0x180040F0
+#define VI_YSCCOEF1_23                                                                0x180040F4
+#define VI_YSCCOEF1_24                                                                0x180040F8
+#define VI_YSCCOEF1_25                                                                0x180040FC
+#define VI_YSCCOEF1_26                                                                0x18004100
+#define VI_YSCCOEF1_27                                                                0x18004104
+#define VI_YSCCOEF1_28                                                                0x18004108
+#define VI_YSCCOEF1_29                                                                0x1800410C
+#define VI_YSCCOEF1_30                                                                0x18004110
+#define VI_YSCCOEF1_31                                                                0x18004114
+#define VI_YSCCOEF1_0_reg_addr                                                       "0xB8004098"
+#define VI_YSCCOEF1_1_reg_addr                                                       "0xB800409C"
+#define VI_YSCCOEF1_2_reg_addr                                                       "0xB80040A0"
+#define VI_YSCCOEF1_3_reg_addr                                                       "0xB80040A4"
+#define VI_YSCCOEF1_4_reg_addr                                                       "0xB80040A8"
+#define VI_YSCCOEF1_5_reg_addr                                                       "0xB80040AC"
+#define VI_YSCCOEF1_6_reg_addr                                                       "0xB80040B0"
+#define VI_YSCCOEF1_7_reg_addr                                                       "0xB80040B4"
+#define VI_YSCCOEF1_8_reg_addr                                                       "0xB80040B8"
+#define VI_YSCCOEF1_9_reg_addr                                                       "0xB80040BC"
+#define VI_YSCCOEF1_10_reg_addr                                                       "0xB80040C0"
+#define VI_YSCCOEF1_11_reg_addr                                                       "0xB80040C4"
+#define VI_YSCCOEF1_12_reg_addr                                                       "0xB80040C8"
+#define VI_YSCCOEF1_13_reg_addr                                                       "0xB80040CC"
+#define VI_YSCCOEF1_14_reg_addr                                                       "0xB80040D0"
+#define VI_YSCCOEF1_15_reg_addr                                                       "0xB80040D4"
+#define VI_YSCCOEF1_16_reg_addr                                                       "0xB80040D8"
+#define VI_YSCCOEF1_17_reg_addr                                                       "0xB80040DC"
+#define VI_YSCCOEF1_18_reg_addr                                                       "0xB80040E0"
+#define VI_YSCCOEF1_19_reg_addr                                                       "0xB80040E4"
+#define VI_YSCCOEF1_20_reg_addr                                                       "0xB80040E8"
+#define VI_YSCCOEF1_21_reg_addr                                                       "0xB80040EC"
+#define VI_YSCCOEF1_22_reg_addr                                                       "0xB80040F0"
+#define VI_YSCCOEF1_23_reg_addr                                                       "0xB80040F4"
+#define VI_YSCCOEF1_24_reg_addr                                                       "0xB80040F8"
+#define VI_YSCCOEF1_25_reg_addr                                                       "0xB80040FC"
+#define VI_YSCCOEF1_26_reg_addr                                                       "0xB8004100"
+#define VI_YSCCOEF1_27_reg_addr                                                       "0xB8004104"
+#define VI_YSCCOEF1_28_reg_addr                                                       "0xB8004108"
+#define VI_YSCCOEF1_29_reg_addr                                                       "0xB800410C"
+#define VI_YSCCOEF1_30_reg_addr                                                       "0xB8004110"
+#define VI_YSCCOEF1_31_reg_addr                                                       "0xB8004114"
+#define VI_YSCCOEF1_0_reg                                                            0xB8004098
+#define VI_YSCCOEF1_1_reg                                                            0xB800409C
+#define VI_YSCCOEF1_2_reg                                                            0xB80040A0
+#define VI_YSCCOEF1_3_reg                                                            0xB80040A4
+#define VI_YSCCOEF1_4_reg                                                            0xB80040A8
+#define VI_YSCCOEF1_5_reg                                                            0xB80040AC
+#define VI_YSCCOEF1_6_reg                                                            0xB80040B0
+#define VI_YSCCOEF1_7_reg                                                            0xB80040B4
+#define VI_YSCCOEF1_8_reg                                                            0xB80040B8
+#define VI_YSCCOEF1_9_reg                                                            0xB80040BC
+#define VI_YSCCOEF1_10_reg                                                            0xB80040C0
+#define VI_YSCCOEF1_11_reg                                                            0xB80040C4
+#define VI_YSCCOEF1_12_reg                                                            0xB80040C8
+#define VI_YSCCOEF1_13_reg                                                            0xB80040CC
+#define VI_YSCCOEF1_14_reg                                                            0xB80040D0
+#define VI_YSCCOEF1_15_reg                                                            0xB80040D4
+#define VI_YSCCOEF1_16_reg                                                            0xB80040D8
+#define VI_YSCCOEF1_17_reg                                                            0xB80040DC
+#define VI_YSCCOEF1_18_reg                                                            0xB80040E0
+#define VI_YSCCOEF1_19_reg                                                            0xB80040E4
+#define VI_YSCCOEF1_20_reg                                                            0xB80040E8
+#define VI_YSCCOEF1_21_reg                                                            0xB80040EC
+#define VI_YSCCOEF1_22_reg                                                            0xB80040F0
+#define VI_YSCCOEF1_23_reg                                                            0xB80040F4
+#define VI_YSCCOEF1_24_reg                                                            0xB80040F8
+#define VI_YSCCOEF1_25_reg                                                            0xB80040FC
+#define VI_YSCCOEF1_26_reg                                                            0xB8004100
+#define VI_YSCCOEF1_27_reg                                                            0xB8004104
+#define VI_YSCCOEF1_28_reg                                                            0xB8004108
+#define VI_YSCCOEF1_29_reg                                                            0xB800410C
+#define VI_YSCCOEF1_30_reg                                                            0xB8004110
+#define VI_YSCCOEF1_31_reg                                                            0xB8004114
+#define VI_YSCCOEF1_0_inst_adr                                                       "0x0026"
+#define VI_YSCCOEF1_1_inst_adr                                                       "0x0027"
+#define VI_YSCCOEF1_2_inst_adr                                                       "0x0028"
+#define VI_YSCCOEF1_3_inst_adr                                                       "0x0029"
+#define VI_YSCCOEF1_4_inst_adr                                                       "0x002A"
+#define VI_YSCCOEF1_5_inst_adr                                                       "0x002B"
+#define VI_YSCCOEF1_6_inst_adr                                                       "0x002C"
+#define VI_YSCCOEF1_7_inst_adr                                                       "0x002D"
+#define VI_YSCCOEF1_8_inst_adr                                                       "0x002E"
+#define VI_YSCCOEF1_9_inst_adr                                                       "0x002F"
+#define VI_YSCCOEF1_10_inst_adr                                                       "0x0030"
+#define VI_YSCCOEF1_11_inst_adr                                                       "0x0031"
+#define VI_YSCCOEF1_12_inst_adr                                                       "0x0032"
+#define VI_YSCCOEF1_13_inst_adr                                                       "0x0033"
+#define VI_YSCCOEF1_14_inst_adr                                                       "0x0034"
+#define VI_YSCCOEF1_15_inst_adr                                                       "0x0035"
+#define VI_YSCCOEF1_16_inst_adr                                                       "0x0036"
+#define VI_YSCCOEF1_17_inst_adr                                                       "0x0037"
+#define VI_YSCCOEF1_18_inst_adr                                                       "0x0038"
+#define VI_YSCCOEF1_19_inst_adr                                                       "0x0039"
+#define VI_YSCCOEF1_20_inst_adr                                                       "0x003A"
+#define VI_YSCCOEF1_21_inst_adr                                                       "0x003B"
+#define VI_YSCCOEF1_22_inst_adr                                                       "0x003C"
+#define VI_YSCCOEF1_23_inst_adr                                                       "0x003D"
+#define VI_YSCCOEF1_24_inst_adr                                                       "0x003E"
+#define VI_YSCCOEF1_25_inst_adr                                                       "0x003F"
+#define VI_YSCCOEF1_26_inst_adr                                                       "0x0040"
+#define VI_YSCCOEF1_27_inst_adr                                                       "0x0041"
+#define VI_YSCCOEF1_28_inst_adr                                                       "0x0042"
+#define VI_YSCCOEF1_29_inst_adr                                                       "0x0043"
+#define VI_YSCCOEF1_30_inst_adr                                                       "0x0044"
+#define VI_YSCCOEF1_31_inst_adr                                                       "0x0045"
+#define VI_YSCCOEF1_0_inst                                                           0x0026
+#define VI_YSCCOEF1_1_inst                                                           0x0027
+#define VI_YSCCOEF1_2_inst                                                           0x0028
+#define VI_YSCCOEF1_3_inst                                                           0x0029
+#define VI_YSCCOEF1_4_inst                                                           0x002A
+#define VI_YSCCOEF1_5_inst                                                           0x002B
+#define VI_YSCCOEF1_6_inst                                                           0x002C
+#define VI_YSCCOEF1_7_inst                                                           0x002D
+#define VI_YSCCOEF1_8_inst                                                           0x002E
+#define VI_YSCCOEF1_9_inst                                                           0x002F
+#define VI_YSCCOEF1_10_inst                                                           0x0030
+#define VI_YSCCOEF1_11_inst                                                           0x0031
+#define VI_YSCCOEF1_12_inst                                                           0x0032
+#define VI_YSCCOEF1_13_inst                                                           0x0033
+#define VI_YSCCOEF1_14_inst                                                           0x0034
+#define VI_YSCCOEF1_15_inst                                                           0x0035
+#define VI_YSCCOEF1_16_inst                                                           0x0036
+#define VI_YSCCOEF1_17_inst                                                           0x0037
+#define VI_YSCCOEF1_18_inst                                                           0x0038
+#define VI_YSCCOEF1_19_inst                                                           0x0039
+#define VI_YSCCOEF1_20_inst                                                           0x003A
+#define VI_YSCCOEF1_21_inst                                                           0x003B
+#define VI_YSCCOEF1_22_inst                                                           0x003C
+#define VI_YSCCOEF1_23_inst                                                           0x003D
+#define VI_YSCCOEF1_24_inst                                                           0x003E
+#define VI_YSCCOEF1_25_inst                                                           0x003F
+#define VI_YSCCOEF1_26_inst                                                           0x0040
+#define VI_YSCCOEF1_27_inst                                                           0x0041
+#define VI_YSCCOEF1_28_inst                                                           0x0042
+#define VI_YSCCOEF1_29_inst                                                           0x0043
+#define VI_YSCCOEF1_30_inst                                                           0x0044
+#define VI_YSCCOEF1_31_inst                                                           0x0045
+#define VI_YSCCOEF1_ysccoef_shift                                                    (0)
+#define VI_YSCCOEF1_ysccoef_mask                                                     (0x00003FFF)
+#define VI_YSCCOEF1_ysccoef(data)                                                    (0x00003FFF&((data)<<0))
+#define VI_YSCCOEF1_ysccoef_src(data)                                                ((0x00003FFF&(data))>>0)
+#define VI_YSCCOEF1_get_ysccoef(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define VI_YSCCOEF2_0                                                                0x18004118
+#define VI_YSCCOEF2_1                                                                0x1800411C
+#define VI_YSCCOEF2_2                                                                0x18004120
+#define VI_YSCCOEF2_3                                                                0x18004124
+#define VI_YSCCOEF2_4                                                                0x18004128
+#define VI_YSCCOEF2_5                                                                0x1800412C
+#define VI_YSCCOEF2_6                                                                0x18004130
+#define VI_YSCCOEF2_7                                                                0x18004134
+#define VI_YSCCOEF2_8                                                                0x18004138
+#define VI_YSCCOEF2_9                                                                0x1800413C
+#define VI_YSCCOEF2_10                                                                0x18004140
+#define VI_YSCCOEF2_11                                                                0x18004144
+#define VI_YSCCOEF2_12                                                                0x18004148
+#define VI_YSCCOEF2_13                                                                0x1800414C
+#define VI_YSCCOEF2_14                                                                0x18004150
+#define VI_YSCCOEF2_15                                                                0x18004154
+#define VI_YSCCOEF2_16                                                                0x18004158
+#define VI_YSCCOEF2_17                                                                0x1800415C
+#define VI_YSCCOEF2_18                                                                0x18004160
+#define VI_YSCCOEF2_19                                                                0x18004164
+#define VI_YSCCOEF2_20                                                                0x18004168
+#define VI_YSCCOEF2_21                                                                0x1800416C
+#define VI_YSCCOEF2_22                                                                0x18004170
+#define VI_YSCCOEF2_23                                                                0x18004174
+#define VI_YSCCOEF2_24                                                                0x18004178
+#define VI_YSCCOEF2_25                                                                0x1800417C
+#define VI_YSCCOEF2_26                                                                0x18004180
+#define VI_YSCCOEF2_27                                                                0x18004184
+#define VI_YSCCOEF2_28                                                                0x18004188
+#define VI_YSCCOEF2_29                                                                0x1800418C
+#define VI_YSCCOEF2_30                                                                0x18004190
+#define VI_YSCCOEF2_31                                                                0x18004194
+#define VI_YSCCOEF2_0_reg_addr                                                       "0xB8004118"
+#define VI_YSCCOEF2_1_reg_addr                                                       "0xB800411C"
+#define VI_YSCCOEF2_2_reg_addr                                                       "0xB8004120"
+#define VI_YSCCOEF2_3_reg_addr                                                       "0xB8004124"
+#define VI_YSCCOEF2_4_reg_addr                                                       "0xB8004128"
+#define VI_YSCCOEF2_5_reg_addr                                                       "0xB800412C"
+#define VI_YSCCOEF2_6_reg_addr                                                       "0xB8004130"
+#define VI_YSCCOEF2_7_reg_addr                                                       "0xB8004134"
+#define VI_YSCCOEF2_8_reg_addr                                                       "0xB8004138"
+#define VI_YSCCOEF2_9_reg_addr                                                       "0xB800413C"
+#define VI_YSCCOEF2_10_reg_addr                                                       "0xB8004140"
+#define VI_YSCCOEF2_11_reg_addr                                                       "0xB8004144"
+#define VI_YSCCOEF2_12_reg_addr                                                       "0xB8004148"
+#define VI_YSCCOEF2_13_reg_addr                                                       "0xB800414C"
+#define VI_YSCCOEF2_14_reg_addr                                                       "0xB8004150"
+#define VI_YSCCOEF2_15_reg_addr                                                       "0xB8004154"
+#define VI_YSCCOEF2_16_reg_addr                                                       "0xB8004158"
+#define VI_YSCCOEF2_17_reg_addr                                                       "0xB800415C"
+#define VI_YSCCOEF2_18_reg_addr                                                       "0xB8004160"
+#define VI_YSCCOEF2_19_reg_addr                                                       "0xB8004164"
+#define VI_YSCCOEF2_20_reg_addr                                                       "0xB8004168"
+#define VI_YSCCOEF2_21_reg_addr                                                       "0xB800416C"
+#define VI_YSCCOEF2_22_reg_addr                                                       "0xB8004170"
+#define VI_YSCCOEF2_23_reg_addr                                                       "0xB8004174"
+#define VI_YSCCOEF2_24_reg_addr                                                       "0xB8004178"
+#define VI_YSCCOEF2_25_reg_addr                                                       "0xB800417C"
+#define VI_YSCCOEF2_26_reg_addr                                                       "0xB8004180"
+#define VI_YSCCOEF2_27_reg_addr                                                       "0xB8004184"
+#define VI_YSCCOEF2_28_reg_addr                                                       "0xB8004188"
+#define VI_YSCCOEF2_29_reg_addr                                                       "0xB800418C"
+#define VI_YSCCOEF2_30_reg_addr                                                       "0xB8004190"
+#define VI_YSCCOEF2_31_reg_addr                                                       "0xB8004194"
+#define VI_YSCCOEF2_0_reg                                                            0xB8004118
+#define VI_YSCCOEF2_1_reg                                                            0xB800411C
+#define VI_YSCCOEF2_2_reg                                                            0xB8004120
+#define VI_YSCCOEF2_3_reg                                                            0xB8004124
+#define VI_YSCCOEF2_4_reg                                                            0xB8004128
+#define VI_YSCCOEF2_5_reg                                                            0xB800412C
+#define VI_YSCCOEF2_6_reg                                                            0xB8004130
+#define VI_YSCCOEF2_7_reg                                                            0xB8004134
+#define VI_YSCCOEF2_8_reg                                                            0xB8004138
+#define VI_YSCCOEF2_9_reg                                                            0xB800413C
+#define VI_YSCCOEF2_10_reg                                                            0xB8004140
+#define VI_YSCCOEF2_11_reg                                                            0xB8004144
+#define VI_YSCCOEF2_12_reg                                                            0xB8004148
+#define VI_YSCCOEF2_13_reg                                                            0xB800414C
+#define VI_YSCCOEF2_14_reg                                                            0xB8004150
+#define VI_YSCCOEF2_15_reg                                                            0xB8004154
+#define VI_YSCCOEF2_16_reg                                                            0xB8004158
+#define VI_YSCCOEF2_17_reg                                                            0xB800415C
+#define VI_YSCCOEF2_18_reg                                                            0xB8004160
+#define VI_YSCCOEF2_19_reg                                                            0xB8004164
+#define VI_YSCCOEF2_20_reg                                                            0xB8004168
+#define VI_YSCCOEF2_21_reg                                                            0xB800416C
+#define VI_YSCCOEF2_22_reg                                                            0xB8004170
+#define VI_YSCCOEF2_23_reg                                                            0xB8004174
+#define VI_YSCCOEF2_24_reg                                                            0xB8004178
+#define VI_YSCCOEF2_25_reg                                                            0xB800417C
+#define VI_YSCCOEF2_26_reg                                                            0xB8004180
+#define VI_YSCCOEF2_27_reg                                                            0xB8004184
+#define VI_YSCCOEF2_28_reg                                                            0xB8004188
+#define VI_YSCCOEF2_29_reg                                                            0xB800418C
+#define VI_YSCCOEF2_30_reg                                                            0xB8004190
+#define VI_YSCCOEF2_31_reg                                                            0xB8004194
+#define VI_YSCCOEF2_0_inst_adr                                                       "0x0046"
+#define VI_YSCCOEF2_1_inst_adr                                                       "0x0047"
+#define VI_YSCCOEF2_2_inst_adr                                                       "0x0048"
+#define VI_YSCCOEF2_3_inst_adr                                                       "0x0049"
+#define VI_YSCCOEF2_4_inst_adr                                                       "0x004A"
+#define VI_YSCCOEF2_5_inst_adr                                                       "0x004B"
+#define VI_YSCCOEF2_6_inst_adr                                                       "0x004C"
+#define VI_YSCCOEF2_7_inst_adr                                                       "0x004D"
+#define VI_YSCCOEF2_8_inst_adr                                                       "0x004E"
+#define VI_YSCCOEF2_9_inst_adr                                                       "0x004F"
+#define VI_YSCCOEF2_10_inst_adr                                                       "0x0050"
+#define VI_YSCCOEF2_11_inst_adr                                                       "0x0051"
+#define VI_YSCCOEF2_12_inst_adr                                                       "0x0052"
+#define VI_YSCCOEF2_13_inst_adr                                                       "0x0053"
+#define VI_YSCCOEF2_14_inst_adr                                                       "0x0054"
+#define VI_YSCCOEF2_15_inst_adr                                                       "0x0055"
+#define VI_YSCCOEF2_16_inst_adr                                                       "0x0056"
+#define VI_YSCCOEF2_17_inst_adr                                                       "0x0057"
+#define VI_YSCCOEF2_18_inst_adr                                                       "0x0058"
+#define VI_YSCCOEF2_19_inst_adr                                                       "0x0059"
+#define VI_YSCCOEF2_20_inst_adr                                                       "0x005A"
+#define VI_YSCCOEF2_21_inst_adr                                                       "0x005B"
+#define VI_YSCCOEF2_22_inst_adr                                                       "0x005C"
+#define VI_YSCCOEF2_23_inst_adr                                                       "0x005D"
+#define VI_YSCCOEF2_24_inst_adr                                                       "0x005E"
+#define VI_YSCCOEF2_25_inst_adr                                                       "0x005F"
+#define VI_YSCCOEF2_26_inst_adr                                                       "0x0060"
+#define VI_YSCCOEF2_27_inst_adr                                                       "0x0061"
+#define VI_YSCCOEF2_28_inst_adr                                                       "0x0062"
+#define VI_YSCCOEF2_29_inst_adr                                                       "0x0063"
+#define VI_YSCCOEF2_30_inst_adr                                                       "0x0064"
+#define VI_YSCCOEF2_31_inst_adr                                                       "0x0065"
+#define VI_YSCCOEF2_0_inst                                                           0x0046
+#define VI_YSCCOEF2_1_inst                                                           0x0047
+#define VI_YSCCOEF2_2_inst                                                           0x0048
+#define VI_YSCCOEF2_3_inst                                                           0x0049
+#define VI_YSCCOEF2_4_inst                                                           0x004A
+#define VI_YSCCOEF2_5_inst                                                           0x004B
+#define VI_YSCCOEF2_6_inst                                                           0x004C
+#define VI_YSCCOEF2_7_inst                                                           0x004D
+#define VI_YSCCOEF2_8_inst                                                           0x004E
+#define VI_YSCCOEF2_9_inst                                                           0x004F
+#define VI_YSCCOEF2_10_inst                                                           0x0050
+#define VI_YSCCOEF2_11_inst                                                           0x0051
+#define VI_YSCCOEF2_12_inst                                                           0x0052
+#define VI_YSCCOEF2_13_inst                                                           0x0053
+#define VI_YSCCOEF2_14_inst                                                           0x0054
+#define VI_YSCCOEF2_15_inst                                                           0x0055
+#define VI_YSCCOEF2_16_inst                                                           0x0056
+#define VI_YSCCOEF2_17_inst                                                           0x0057
+#define VI_YSCCOEF2_18_inst                                                           0x0058
+#define VI_YSCCOEF2_19_inst                                                           0x0059
+#define VI_YSCCOEF2_20_inst                                                           0x005A
+#define VI_YSCCOEF2_21_inst                                                           0x005B
+#define VI_YSCCOEF2_22_inst                                                           0x005C
+#define VI_YSCCOEF2_23_inst                                                           0x005D
+#define VI_YSCCOEF2_24_inst                                                           0x005E
+#define VI_YSCCOEF2_25_inst                                                           0x005F
+#define VI_YSCCOEF2_26_inst                                                           0x0060
+#define VI_YSCCOEF2_27_inst                                                           0x0061
+#define VI_YSCCOEF2_28_inst                                                           0x0062
+#define VI_YSCCOEF2_29_inst                                                           0x0063
+#define VI_YSCCOEF2_30_inst                                                           0x0064
+#define VI_YSCCOEF2_31_inst                                                           0x0065
+#define VI_YSCCOEF2_ysccoef_shift                                                    (0)
+#define VI_YSCCOEF2_ysccoef_mask                                                     (0x00003FFF)
+#define VI_YSCCOEF2_ysccoef(data)                                                    (0x00003FFF&((data)<<0))
+#define VI_YSCCOEF2_ysccoef_src(data)                                                ((0x00003FFF&(data))>>0)
+#define VI_YSCCOEF2_get_ysccoef(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define VI_CSCCOEF1_0                                                                0x18004198
+#define VI_CSCCOEF1_1                                                                0x1800419C
+#define VI_CSCCOEF1_2                                                                0x180041A0
+#define VI_CSCCOEF1_3                                                                0x180041A4
+#define VI_CSCCOEF1_4                                                                0x180041A8
+#define VI_CSCCOEF1_5                                                                0x180041AC
+#define VI_CSCCOEF1_6                                                                0x180041B0
+#define VI_CSCCOEF1_7                                                                0x180041B4
+#define VI_CSCCOEF1_8                                                                0x180041B8
+#define VI_CSCCOEF1_9                                                                0x180041BC
+#define VI_CSCCOEF1_10                                                                0x180041C0
+#define VI_CSCCOEF1_11                                                                0x180041C4
+#define VI_CSCCOEF1_12                                                                0x180041C8
+#define VI_CSCCOEF1_13                                                                0x180041CC
+#define VI_CSCCOEF1_14                                                                0x180041D0
+#define VI_CSCCOEF1_15                                                                0x180041D4
+#define VI_CSCCOEF1_0_reg_addr                                                       "0xB8004198"
+#define VI_CSCCOEF1_1_reg_addr                                                       "0xB800419C"
+#define VI_CSCCOEF1_2_reg_addr                                                       "0xB80041A0"
+#define VI_CSCCOEF1_3_reg_addr                                                       "0xB80041A4"
+#define VI_CSCCOEF1_4_reg_addr                                                       "0xB80041A8"
+#define VI_CSCCOEF1_5_reg_addr                                                       "0xB80041AC"
+#define VI_CSCCOEF1_6_reg_addr                                                       "0xB80041B0"
+#define VI_CSCCOEF1_7_reg_addr                                                       "0xB80041B4"
+#define VI_CSCCOEF1_8_reg_addr                                                       "0xB80041B8"
+#define VI_CSCCOEF1_9_reg_addr                                                       "0xB80041BC"
+#define VI_CSCCOEF1_10_reg_addr                                                       "0xB80041C0"
+#define VI_CSCCOEF1_11_reg_addr                                                       "0xB80041C4"
+#define VI_CSCCOEF1_12_reg_addr                                                       "0xB80041C8"
+#define VI_CSCCOEF1_13_reg_addr                                                       "0xB80041CC"
+#define VI_CSCCOEF1_14_reg_addr                                                       "0xB80041D0"
+#define VI_CSCCOEF1_15_reg_addr                                                       "0xB80041D4"
+#define VI_CSCCOEF1_0_reg                                                            0xB8004198
+#define VI_CSCCOEF1_1_reg                                                            0xB800419C
+#define VI_CSCCOEF1_2_reg                                                            0xB80041A0
+#define VI_CSCCOEF1_3_reg                                                            0xB80041A4
+#define VI_CSCCOEF1_4_reg                                                            0xB80041A8
+#define VI_CSCCOEF1_5_reg                                                            0xB80041AC
+#define VI_CSCCOEF1_6_reg                                                            0xB80041B0
+#define VI_CSCCOEF1_7_reg                                                            0xB80041B4
+#define VI_CSCCOEF1_8_reg                                                            0xB80041B8
+#define VI_CSCCOEF1_9_reg                                                            0xB80041BC
+#define VI_CSCCOEF1_10_reg                                                            0xB80041C0
+#define VI_CSCCOEF1_11_reg                                                            0xB80041C4
+#define VI_CSCCOEF1_12_reg                                                            0xB80041C8
+#define VI_CSCCOEF1_13_reg                                                            0xB80041CC
+#define VI_CSCCOEF1_14_reg                                                            0xB80041D0
+#define VI_CSCCOEF1_15_reg                                                            0xB80041D4
+#define VI_CSCCOEF1_0_inst_adr                                                       "0x0066"
+#define VI_CSCCOEF1_1_inst_adr                                                       "0x0067"
+#define VI_CSCCOEF1_2_inst_adr                                                       "0x0068"
+#define VI_CSCCOEF1_3_inst_adr                                                       "0x0069"
+#define VI_CSCCOEF1_4_inst_adr                                                       "0x006A"
+#define VI_CSCCOEF1_5_inst_adr                                                       "0x006B"
+#define VI_CSCCOEF1_6_inst_adr                                                       "0x006C"
+#define VI_CSCCOEF1_7_inst_adr                                                       "0x006D"
+#define VI_CSCCOEF1_8_inst_adr                                                       "0x006E"
+#define VI_CSCCOEF1_9_inst_adr                                                       "0x006F"
+#define VI_CSCCOEF1_10_inst_adr                                                       "0x0070"
+#define VI_CSCCOEF1_11_inst_adr                                                       "0x0071"
+#define VI_CSCCOEF1_12_inst_adr                                                       "0x0072"
+#define VI_CSCCOEF1_13_inst_adr                                                       "0x0073"
+#define VI_CSCCOEF1_14_inst_adr                                                       "0x0074"
+#define VI_CSCCOEF1_15_inst_adr                                                       "0x0075"
+#define VI_CSCCOEF1_0_inst                                                           0x0066
+#define VI_CSCCOEF1_1_inst                                                           0x0067
+#define VI_CSCCOEF1_2_inst                                                           0x0068
+#define VI_CSCCOEF1_3_inst                                                           0x0069
+#define VI_CSCCOEF1_4_inst                                                           0x006A
+#define VI_CSCCOEF1_5_inst                                                           0x006B
+#define VI_CSCCOEF1_6_inst                                                           0x006C
+#define VI_CSCCOEF1_7_inst                                                           0x006D
+#define VI_CSCCOEF1_8_inst                                                           0x006E
+#define VI_CSCCOEF1_9_inst                                                           0x006F
+#define VI_CSCCOEF1_10_inst                                                           0x0070
+#define VI_CSCCOEF1_11_inst                                                           0x0071
+#define VI_CSCCOEF1_12_inst                                                           0x0072
+#define VI_CSCCOEF1_13_inst                                                           0x0073
+#define VI_CSCCOEF1_14_inst                                                           0x0074
+#define VI_CSCCOEF1_15_inst                                                           0x0075
+#define VI_CSCCOEF1_csccoef_shift                                                    (0)
+#define VI_CSCCOEF1_csccoef_mask                                                     (0x00003FFF)
+#define VI_CSCCOEF1_csccoef(data)                                                    (0x00003FFF&((data)<<0))
+#define VI_CSCCOEF1_csccoef_src(data)                                                ((0x00003FFF&(data))>>0)
+#define VI_CSCCOEF1_get_csccoef(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define VI_CSCCOEF2_0                                                                0x180041D8
+#define VI_CSCCOEF2_1                                                                0x180041DC
+#define VI_CSCCOEF2_2                                                                0x180041E0
+#define VI_CSCCOEF2_3                                                                0x180041E4
+#define VI_CSCCOEF2_4                                                                0x180041E8
+#define VI_CSCCOEF2_5                                                                0x180041EC
+#define VI_CSCCOEF2_6                                                                0x180041F0
+#define VI_CSCCOEF2_7                                                                0x180041F4
+#define VI_CSCCOEF2_8                                                                0x180041F8
+#define VI_CSCCOEF2_9                                                                0x180041FC
+#define VI_CSCCOEF2_10                                                                0x18004200
+#define VI_CSCCOEF2_11                                                                0x18004204
+#define VI_CSCCOEF2_12                                                                0x18004208
+#define VI_CSCCOEF2_13                                                                0x1800420C
+#define VI_CSCCOEF2_14                                                                0x18004210
+#define VI_CSCCOEF2_15                                                                0x18004214
+#define VI_CSCCOEF2_0_reg_addr                                                       "0xB80041D8"
+#define VI_CSCCOEF2_1_reg_addr                                                       "0xB80041DC"
+#define VI_CSCCOEF2_2_reg_addr                                                       "0xB80041E0"
+#define VI_CSCCOEF2_3_reg_addr                                                       "0xB80041E4"
+#define VI_CSCCOEF2_4_reg_addr                                                       "0xB80041E8"
+#define VI_CSCCOEF2_5_reg_addr                                                       "0xB80041EC"
+#define VI_CSCCOEF2_6_reg_addr                                                       "0xB80041F0"
+#define VI_CSCCOEF2_7_reg_addr                                                       "0xB80041F4"
+#define VI_CSCCOEF2_8_reg_addr                                                       "0xB80041F8"
+#define VI_CSCCOEF2_9_reg_addr                                                       "0xB80041FC"
+#define VI_CSCCOEF2_10_reg_addr                                                       "0xB8004200"
+#define VI_CSCCOEF2_11_reg_addr                                                       "0xB8004204"
+#define VI_CSCCOEF2_12_reg_addr                                                       "0xB8004208"
+#define VI_CSCCOEF2_13_reg_addr                                                       "0xB800420C"
+#define VI_CSCCOEF2_14_reg_addr                                                       "0xB8004210"
+#define VI_CSCCOEF2_15_reg_addr                                                       "0xB8004214"
+#define VI_CSCCOEF2_0_reg                                                            0xB80041D8
+#define VI_CSCCOEF2_1_reg                                                            0xB80041DC
+#define VI_CSCCOEF2_2_reg                                                            0xB80041E0
+#define VI_CSCCOEF2_3_reg                                                            0xB80041E4
+#define VI_CSCCOEF2_4_reg                                                            0xB80041E8
+#define VI_CSCCOEF2_5_reg                                                            0xB80041EC
+#define VI_CSCCOEF2_6_reg                                                            0xB80041F0
+#define VI_CSCCOEF2_7_reg                                                            0xB80041F4
+#define VI_CSCCOEF2_8_reg                                                            0xB80041F8
+#define VI_CSCCOEF2_9_reg                                                            0xB80041FC
+#define VI_CSCCOEF2_10_reg                                                            0xB8004200
+#define VI_CSCCOEF2_11_reg                                                            0xB8004204
+#define VI_CSCCOEF2_12_reg                                                            0xB8004208
+#define VI_CSCCOEF2_13_reg                                                            0xB800420C
+#define VI_CSCCOEF2_14_reg                                                            0xB8004210
+#define VI_CSCCOEF2_15_reg                                                            0xB8004214
+#define VI_CSCCOEF2_0_inst_adr                                                       "0x0076"
+#define VI_CSCCOEF2_1_inst_adr                                                       "0x0077"
+#define VI_CSCCOEF2_2_inst_adr                                                       "0x0078"
+#define VI_CSCCOEF2_3_inst_adr                                                       "0x0079"
+#define VI_CSCCOEF2_4_inst_adr                                                       "0x007A"
+#define VI_CSCCOEF2_5_inst_adr                                                       "0x007B"
+#define VI_CSCCOEF2_6_inst_adr                                                       "0x007C"
+#define VI_CSCCOEF2_7_inst_adr                                                       "0x007D"
+#define VI_CSCCOEF2_8_inst_adr                                                       "0x007E"
+#define VI_CSCCOEF2_9_inst_adr                                                       "0x007F"
+#define VI_CSCCOEF2_10_inst_adr                                                       "0x0080"
+#define VI_CSCCOEF2_11_inst_adr                                                       "0x0081"
+#define VI_CSCCOEF2_12_inst_adr                                                       "0x0082"
+#define VI_CSCCOEF2_13_inst_adr                                                       "0x0083"
+#define VI_CSCCOEF2_14_inst_adr                                                       "0x0084"
+#define VI_CSCCOEF2_15_inst_adr                                                       "0x0085"
+#define VI_CSCCOEF2_0_inst                                                           0x0076
+#define VI_CSCCOEF2_1_inst                                                           0x0077
+#define VI_CSCCOEF2_2_inst                                                           0x0078
+#define VI_CSCCOEF2_3_inst                                                           0x0079
+#define VI_CSCCOEF2_4_inst                                                           0x007A
+#define VI_CSCCOEF2_5_inst                                                           0x007B
+#define VI_CSCCOEF2_6_inst                                                           0x007C
+#define VI_CSCCOEF2_7_inst                                                           0x007D
+#define VI_CSCCOEF2_8_inst                                                           0x007E
+#define VI_CSCCOEF2_9_inst                                                           0x007F
+#define VI_CSCCOEF2_10_inst                                                           0x0080
+#define VI_CSCCOEF2_11_inst                                                           0x0081
+#define VI_CSCCOEF2_12_inst                                                           0x0082
+#define VI_CSCCOEF2_13_inst                                                           0x0083
+#define VI_CSCCOEF2_14_inst                                                           0x0084
+#define VI_CSCCOEF2_15_inst                                                           0x0085
+#define VI_CSCCOEF2_csccoef_shift                                                    (0)
+#define VI_CSCCOEF2_csccoef_mask                                                     (0x00003FFF)
+#define VI_CSCCOEF2_csccoef(data)                                                    (0x00003FFF&((data)<<0))
+#define VI_CSCCOEF2_csccoef_src(data)                                                ((0x00003FFF&(data))>>0)
+#define VI_CSCCOEF2_get_csccoef(data)                                                ((0x00003FFF&(data))>>0)
+
+
+#define VI_OFFSETEN                                                                  0x18004218
+#define VI_OFFSETEN_reg_addr                                                         "0xB8004218"
+#define VI_OFFSETEN_reg                                                              0xB8004218
+#define VI_OFFSETEN_inst_adr                                                         "0x0086"
+#define VI_OFFSETEN_inst                                                             0x0086
+#define VI_OFFSETEN_y1_clamp_shift                                                   (8)
+#define VI_OFFSETEN_y1_clamp_mask                                                    (0x00000100)
+#define VI_OFFSETEN_y1_clamp(data)                                                   (0x00000100&((data)<<8))
+#define VI_OFFSETEN_y1_clamp_src(data)                                               ((0x00000100&(data))>>8)
+#define VI_OFFSETEN_get_y1_clamp(data)                                               ((0x00000100&(data))>>8)
+#define VI_OFFSETEN_c1_clamp_shift                                                   (7)
+#define VI_OFFSETEN_c1_clamp_mask                                                    (0x00000080)
+#define VI_OFFSETEN_c1_clamp(data)                                                   (0x00000080&((data)<<7))
+#define VI_OFFSETEN_c1_clamp_src(data)                                               ((0x00000080&(data))>>7)
+#define VI_OFFSETEN_get_c1_clamp(data)                                               ((0x00000080&(data))>>7)
+#define VI_OFFSETEN_y2_clamp_shift                                                   (6)
+#define VI_OFFSETEN_y2_clamp_mask                                                    (0x00000040)
+#define VI_OFFSETEN_y2_clamp(data)                                                   (0x00000040&((data)<<6))
+#define VI_OFFSETEN_y2_clamp_src(data)                                               ((0x00000040&(data))>>6)
+#define VI_OFFSETEN_get_y2_clamp(data)                                               ((0x00000040&(data))>>6)
+#define VI_OFFSETEN_c2_clamp_shift                                                   (5)
+#define VI_OFFSETEN_c2_clamp_mask                                                    (0x00000020)
+#define VI_OFFSETEN_c2_clamp(data)                                                   (0x00000020&((data)<<5))
+#define VI_OFFSETEN_c2_clamp_src(data)                                               ((0x00000020&(data))>>5)
+#define VI_OFFSETEN_get_c2_clamp(data)                                               ((0x00000020&(data))>>5)
+#define VI_OFFSETEN_y1_shift                                                         (4)
+#define VI_OFFSETEN_y1_mask                                                          (0x00000010)
+#define VI_OFFSETEN_y1(data)                                                         (0x00000010&((data)<<4))
+#define VI_OFFSETEN_y1_src(data)                                                     ((0x00000010&(data))>>4)
+#define VI_OFFSETEN_get_y1(data)                                                     ((0x00000010&(data))>>4)
+#define VI_OFFSETEN_c1_shift                                                         (3)
+#define VI_OFFSETEN_c1_mask                                                          (0x00000008)
+#define VI_OFFSETEN_c1(data)                                                         (0x00000008&((data)<<3))
+#define VI_OFFSETEN_c1_src(data)                                                     ((0x00000008&(data))>>3)
+#define VI_OFFSETEN_get_c1(data)                                                     ((0x00000008&(data))>>3)
+#define VI_OFFSETEN_y2_shift                                                         (2)
+#define VI_OFFSETEN_y2_mask                                                          (0x00000004)
+#define VI_OFFSETEN_y2(data)                                                         (0x00000004&((data)<<2))
+#define VI_OFFSETEN_y2_src(data)                                                     ((0x00000004&(data))>>2)
+#define VI_OFFSETEN_get_y2(data)                                                     ((0x00000004&(data))>>2)
+#define VI_OFFSETEN_c2_shift                                                         (1)
+#define VI_OFFSETEN_c2_mask                                                          (0x00000002)
+#define VI_OFFSETEN_c2(data)                                                         (0x00000002&((data)<<1))
+#define VI_OFFSETEN_c2_src(data)                                                     ((0x00000002&(data))>>1)
+#define VI_OFFSETEN_get_c2(data)                                                     ((0x00000002&(data))>>1)
+#define VI_OFFSETEN_write_data_shift                                                 (0)
+#define VI_OFFSETEN_write_data_mask                                                  (0x00000001)
+#define VI_OFFSETEN_write_data(data)                                                 (0x00000001&((data)<<0))
+#define VI_OFFSETEN_write_data_src(data)                                             ((0x00000001&(data))>>0)
+#define VI_OFFSETEN_get_write_data(data)                                             ((0x00000001&(data))>>0)
+
+
+#define VI_HPD1                                                                      0x1800421c
+#define VI_HPD1_reg_addr                                                             "0xB800421C"
+#define VI_HPD1_reg                                                                  0xB800421C
+#define VI_HPD1_inst_adr                                                             "0x0087"
+#define VI_HPD1_inst                                                                 0x0087
+#define VI_HPD1_hpd_enable_shift                                                     (29)
+#define VI_HPD1_hpd_enable_mask                                                      (0x20000000)
+#define VI_HPD1_hpd_enable(data)                                                     (0x20000000&((data)<<29))
+#define VI_HPD1_hpd_enable_src(data)                                                 ((0x20000000&(data))>>29)
+#define VI_HPD1_get_hpd_enable(data)                                                 ((0x20000000&(data))>>29)
+#define VI_HPD1_hpd_acc_shift                                                        (0)
+#define VI_HPD1_hpd_acc_mask                                                         (0x1FFFFFFF)
+#define VI_HPD1_hpd_acc(data)                                                        (0x1FFFFFFF&((data)<<0))
+#define VI_HPD1_hpd_acc_src(data)                                                    ((0x1FFFFFFF&(data))>>0)
+#define VI_HPD1_get_hpd_acc(data)                                                    ((0x1FFFFFFF&(data))>>0)
+
+
+#define VI_HPD2                                                                      0x18004220
+#define VI_HPD2_reg_addr                                                             "0xB8004220"
+#define VI_HPD2_reg                                                                  0xB8004220
+#define VI_HPD2_inst_adr                                                             "0x0088"
+#define VI_HPD2_inst                                                                 0x0088
+#define VI_HPD2_hpd_enable_shift                                                     (29)
+#define VI_HPD2_hpd_enable_mask                                                      (0x20000000)
+#define VI_HPD2_hpd_enable(data)                                                     (0x20000000&((data)<<29))
+#define VI_HPD2_hpd_enable_src(data)                                                 ((0x20000000&(data))>>29)
+#define VI_HPD2_get_hpd_enable(data)                                                 ((0x20000000&(data))>>29)
+#define VI_HPD2_hpd_acc_shift                                                        (0)
+#define VI_HPD2_hpd_acc_mask                                                         (0x1FFFFFFF)
+#define VI_HPD2_hpd_acc(data)                                                        (0x1FFFFFFF&((data)<<0))
+#define VI_HPD2_hpd_acc_src(data)                                                    ((0x1FFFFFFF&(data))>>0)
+#define VI_HPD2_get_hpd_acc(data)                                                    ((0x1FFFFFFF&(data))>>0)
+
+
+#define VI_VPD1                                                                      0x180044b4
+#define VI_VPD1_reg_addr                                                             "0xB80044B4"
+#define VI_VPD1_reg                                                                  0xB80044B4
+#define VI_VPD1_inst_adr                                                             "0x002D"
+#define VI_VPD1_inst                                                                 0x002D
+#define VI_VPD1_vpd_enable_shift                                                     (29)
+#define VI_VPD1_vpd_enable_mask                                                      (0x20000000)
+#define VI_VPD1_vpd_enable(data)                                                     (0x20000000&((data)<<29))
+#define VI_VPD1_vpd_enable_src(data)                                                 ((0x20000000&(data))>>29)
+#define VI_VPD1_get_vpd_enable(data)                                                 ((0x20000000&(data))>>29)
+#define VI_VPD1_vpd_acc_shift                                                        (0)
+#define VI_VPD1_vpd_acc_mask                                                         (0x1FFFFFFF)
+#define VI_VPD1_vpd_acc(data)                                                        (0x1FFFFFFF&((data)<<0))
+#define VI_VPD1_vpd_acc_src(data)                                                    ((0x1FFFFFFF&(data))>>0)
+#define VI_VPD1_get_vpd_acc(data)                                                    ((0x1FFFFFFF&(data))>>0)
+
+
+#define VI_VPD2                                                                      0x180044b8
+#define VI_VPD2_reg_addr                                                             "0xB80044B8"
+#define VI_VPD2_reg                                                                  0xB80044B8
+#define VI_VPD2_inst_adr                                                             "0x002E"
+#define VI_VPD2_inst                                                                 0x002E
+#define VI_VPD2_vpd_enable_shift                                                     (29)
+#define VI_VPD2_vpd_enable_mask                                                      (0x20000000)
+#define VI_VPD2_vpd_enable(data)                                                     (0x20000000&((data)<<29))
+#define VI_VPD2_vpd_enable_src(data)                                                 ((0x20000000&(data))>>29)
+#define VI_VPD2_get_vpd_enable(data)                                                 ((0x20000000&(data))>>29)
+#define VI_VPD2_vpd_acc_shift                                                        (0)
+#define VI_VPD2_vpd_acc_mask                                                         (0x1FFFFFFF)
+#define VI_VPD2_vpd_acc(data)                                                        (0x1FFFFFFF&((data)<<0))
+#define VI_VPD2_vpd_acc_src(data)                                                    ((0x1FFFFFFF&(data))>>0)
+#define VI_VPD2_get_vpd_acc(data)                                                    ((0x1FFFFFFF&(data))>>0)
+
+
+#define VI_CVDEN                                                                     0x180044bc
+#define VI_CVDEN_reg_addr                                                            "0xB80044BC"
+#define VI_CVDEN_reg                                                                 0xB80044BC
+#define VI_CVDEN_inst_adr                                                            "0x002F"
+#define VI_CVDEN_inst                                                                0x002F
+#define VI_CVDEN_write_enable7_shift                                                 (17)
+#define VI_CVDEN_write_enable7_mask                                                  (0x00020000)
+#define VI_CVDEN_write_enable7(data)                                                 (0x00020000&((data)<<17))
+#define VI_CVDEN_write_enable7_src(data)                                             ((0x00020000&(data))>>17)
+#define VI_CVDEN_get_write_enable7(data)                                             ((0x00020000&(data))>>17)
+#define VI_CVDEN_cvd1_on_shift                                                       (16)
+#define VI_CVDEN_cvd1_on_mask                                                        (0x00010000)
+#define VI_CVDEN_cvd1_on(data)                                                       (0x00010000&((data)<<16))
+#define VI_CVDEN_cvd1_on_src(data)                                                   ((0x00010000&(data))>>16)
+#define VI_CVDEN_get_cvd1_on(data)                                                   ((0x00010000&(data))>>16)
+#define VI_CVDEN_write_enable8_shift                                                 (15)
+#define VI_CVDEN_write_enable8_mask                                                  (0x00008000)
+#define VI_CVDEN_write_enable8(data)                                                 (0x00008000&((data)<<15))
+#define VI_CVDEN_write_enable8_src(data)                                             ((0x00008000&(data))>>15)
+#define VI_CVDEN_get_write_enable8(data)                                             ((0x00008000&(data))>>15)
+#define VI_CVDEN_cvd2_on_shift                                                       (14)
+#define VI_CVDEN_cvd2_on_mask                                                        (0x00004000)
+#define VI_CVDEN_cvd2_on(data)                                                       (0x00004000&((data)<<14))
+#define VI_CVDEN_cvd2_on_src(data)                                                   ((0x00004000&(data))>>14)
+#define VI_CVDEN_get_cvd2_on(data)                                                   ((0x00004000&(data))>>14)
+#define VI_CVDEN_write_enable5_shift                                                 (13)
+#define VI_CVDEN_write_enable5_mask                                                  (0x00002000)
+#define VI_CVDEN_write_enable5(data)                                                 (0x00002000&((data)<<13))
+#define VI_CVDEN_write_enable5_src(data)                                             ((0x00002000&(data))>>13)
+#define VI_CVDEN_get_write_enable5(data)                                             ((0x00002000&(data))>>13)
+#define VI_CVDEN_hdcvden1_shift                                                      (12)
+#define VI_CVDEN_hdcvden1_mask                                                       (0x00001000)
+#define VI_CVDEN_hdcvden1(data)                                                      (0x00001000&((data)<<12))
+#define VI_CVDEN_hdcvden1_src(data)                                                  ((0x00001000&(data))>>12)
+#define VI_CVDEN_get_hdcvden1(data)                                                  ((0x00001000&(data))>>12)
+#define VI_CVDEN_write_enable6_shift                                                 (11)
+#define VI_CVDEN_write_enable6_mask                                                  (0x00000800)
+#define VI_CVDEN_write_enable6(data)                                                 (0x00000800&((data)<<11))
+#define VI_CVDEN_write_enable6_src(data)                                             ((0x00000800&(data))>>11)
+#define VI_CVDEN_get_write_enable6(data)                                             ((0x00000800&(data))>>11)
+#define VI_CVDEN_hdcvden2_shift                                                      (10)
+#define VI_CVDEN_hdcvden2_mask                                                       (0x00000400)
+#define VI_CVDEN_hdcvden2(data)                                                      (0x00000400&((data)<<10))
+#define VI_CVDEN_hdcvden2_src(data)                                                  ((0x00000400&(data))>>10)
+#define VI_CVDEN_get_hdcvden2(data)                                                  ((0x00000400&(data))>>10)
+#define VI_CVDEN_write_enable1_shift                                                 (9)
+#define VI_CVDEN_write_enable1_mask                                                  (0x00000200)
+#define VI_CVDEN_write_enable1(data)                                                 (0x00000200&((data)<<9))
+#define VI_CVDEN_write_enable1_src(data)                                             ((0x00000200&(data))>>9)
+#define VI_CVDEN_get_write_enable1(data)                                             ((0x00000200&(data))>>9)
+#define VI_CVDEN_cvden1_shift                                                        (8)
+#define VI_CVDEN_cvden1_mask                                                         (0x00000100)
+#define VI_CVDEN_cvden1(data)                                                        (0x00000100&((data)<<8))
+#define VI_CVDEN_cvden1_src(data)                                                    ((0x00000100&(data))>>8)
+#define VI_CVDEN_get_cvden1(data)                                                    ((0x00000100&(data))>>8)
+#define VI_CVDEN_write_enable2_shift                                                 (7)
+#define VI_CVDEN_write_enable2_mask                                                  (0x00000080)
+#define VI_CVDEN_write_enable2(data)                                                 (0x00000080&((data)<<7))
+#define VI_CVDEN_write_enable2_src(data)                                             ((0x00000080&(data))>>7)
+#define VI_CVDEN_get_write_enable2(data)                                             ((0x00000080&(data))>>7)
+#define VI_CVDEN_cvdtp1_shift                                                        (5)
+#define VI_CVDEN_cvdtp1_mask                                                         (0x00000060)
+#define VI_CVDEN_cvdtp1(data)                                                        (0x00000060&((data)<<5))
+#define VI_CVDEN_cvdtp1_src(data)                                                    ((0x00000060&(data))>>5)
+#define VI_CVDEN_get_cvdtp1(data)                                                    ((0x00000060&(data))>>5)
+#define VI_CVDEN_write_enable3_shift                                                 (4)
+#define VI_CVDEN_write_enable3_mask                                                  (0x00000010)
+#define VI_CVDEN_write_enable3(data)                                                 (0x00000010&((data)<<4))
+#define VI_CVDEN_write_enable3_src(data)                                             ((0x00000010&(data))>>4)
+#define VI_CVDEN_get_write_enable3(data)                                             ((0x00000010&(data))>>4)
+#define VI_CVDEN_cvden2_shift                                                        (3)
+#define VI_CVDEN_cvden2_mask                                                         (0x00000008)
+#define VI_CVDEN_cvden2(data)                                                        (0x00000008&((data)<<3))
+#define VI_CVDEN_cvden2_src(data)                                                    ((0x00000008&(data))>>3)
+#define VI_CVDEN_get_cvden2(data)                                                    ((0x00000008&(data))>>3)
+#define VI_CVDEN_write_enable4_shift                                                 (2)
+#define VI_CVDEN_write_enable4_mask                                                  (0x00000004)
+#define VI_CVDEN_write_enable4(data)                                                 (0x00000004&((data)<<2))
+#define VI_CVDEN_write_enable4_src(data)                                             ((0x00000004&(data))>>2)
+#define VI_CVDEN_get_write_enable4(data)                                             ((0x00000004&(data))>>2)
+#define VI_CVDEN_cvdtp2_shift                                                        (0)
+#define VI_CVDEN_cvdtp2_mask                                                         (0x00000003)
+#define VI_CVDEN_cvdtp2(data)                                                        (0x00000003&((data)<<0))
+#define VI_CVDEN_cvdtp2_src(data)                                                    ((0x00000003&(data))>>0)
+#define VI_CVDEN_get_cvdtp2(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define VI_YDCTL1                                                                    0x18004228
+#define VI_YDCTL1_reg_addr                                                           "0xB8004228"
+#define VI_YDCTL1_reg                                                                0xB8004228
+#define VI_YDCTL1_inst_adr                                                           "0x008A"
+#define VI_YDCTL1_inst                                                               0x008A
+#define VI_YDCTL1_write_enable4_shift                                                (10)
+#define VI_YDCTL1_write_enable4_mask                                                 (0x00000400)
+#define VI_YDCTL1_write_enable4(data)                                                (0x00000400&((data)<<10))
+#define VI_YDCTL1_write_enable4_src(data)                                            ((0x00000400&(data))>>10)
+#define VI_YDCTL1_get_write_enable4(data)                                            ((0x00000400&(data))>>10)
+#define VI_YDCTL1_src_sel_shift                                                      (9)
+#define VI_YDCTL1_src_sel_mask                                                       (0x00000200)
+#define VI_YDCTL1_src_sel(data)                                                      (0x00000200&((data)<<9))
+#define VI_YDCTL1_src_sel_src(data)                                                  ((0x00000200&(data))>>9)
+#define VI_YDCTL1_get_src_sel(data)                                                  ((0x00000200&(data))>>9)
+#define VI_YDCTL1_write_enable5_shift                                                (8)
+#define VI_YDCTL1_write_enable5_mask                                                 (0x00000100)
+#define VI_YDCTL1_write_enable5(data)                                                (0x00000100&((data)<<8))
+#define VI_YDCTL1_write_enable5_src(data)                                            ((0x00000100&(data))>>8)
+#define VI_YDCTL1_get_write_enable5(data)                                            ((0x00000100&(data))>>8)
+#define VI_YDCTL1_luma_2x_en_shift                                                   (7)
+#define VI_YDCTL1_luma_2x_en_mask                                                    (0x00000080)
+#define VI_YDCTL1_luma_2x_en(data)                                                   (0x00000080&((data)<<7))
+#define VI_YDCTL1_luma_2x_en_src(data)                                               ((0x00000080&(data))>>7)
+#define VI_YDCTL1_get_luma_2x_en(data)                                               ((0x00000080&(data))>>7)
+#define VI_YDCTL1_write_enable1_shift                                                (6)
+#define VI_YDCTL1_write_enable1_mask                                                 (0x00000040)
+#define VI_YDCTL1_write_enable1(data)                                                (0x00000040&((data)<<6))
+#define VI_YDCTL1_write_enable1_src(data)                                            ((0x00000040&(data))>>6)
+#define VI_YDCTL1_get_write_enable1(data)                                            ((0x00000040&(data))>>6)
+#define VI_YDCTL1_yden_shift                                                         (5)
+#define VI_YDCTL1_yden_mask                                                          (0x00000020)
+#define VI_YDCTL1_yden(data)                                                         (0x00000020&((data)<<5))
+#define VI_YDCTL1_yden_src(data)                                                     ((0x00000020&(data))>>5)
+#define VI_YDCTL1_get_yden(data)                                                     ((0x00000020&(data))>>5)
+#define VI_YDCTL1_write_enable2_shift                                                (4)
+#define VI_YDCTL1_write_enable2_mask                                                 (0x00000010)
+#define VI_YDCTL1_write_enable2(data)                                                (0x00000010&((data)<<4))
+#define VI_YDCTL1_write_enable2_src(data)                                            ((0x00000010&(data))>>4)
+#define VI_YDCTL1_get_write_enable2(data)                                            ((0x00000010&(data))>>4)
+#define VI_YDCTL1_write_enable3_shift                                                (2)
+#define VI_YDCTL1_write_enable3_mask                                                 (0x00000004)
+#define VI_YDCTL1_write_enable3(data)                                                (0x00000004&((data)<<2))
+#define VI_YDCTL1_write_enable3_src(data)                                            ((0x00000004&(data))>>2)
+#define VI_YDCTL1_get_write_enable3(data)                                            ((0x00000004&(data))>>2)
+#define VI_YDCTL1_ydrtio_shift                                                       (0)
+#define VI_YDCTL1_ydrtio_mask                                                        (0x00000003)
+#define VI_YDCTL1_ydrtio(data)                                                       (0x00000003&((data)<<0))
+#define VI_YDCTL1_ydrtio_src(data)                                                   ((0x00000003&(data))>>0)
+#define VI_YDCTL1_get_ydrtio(data)                                                   ((0x00000003&(data))>>0)
+
+
+#define VI_YDCTL2                                                                    0x180044c0
+#define VI_YDCTL2_reg_addr                                                           "0xB80044C0"
+#define VI_YDCTL2_reg                                                                0xB80044C0
+#define VI_YDCTL2_inst_adr                                                           "0x0030"
+#define VI_YDCTL2_inst                                                               0x0030
+#define VI_YDCTL2_write_enable4_shift                                                (10)
+#define VI_YDCTL2_write_enable4_mask                                                 (0x00000400)
+#define VI_YDCTL2_write_enable4(data)                                                (0x00000400&((data)<<10))
+#define VI_YDCTL2_write_enable4_src(data)                                            ((0x00000400&(data))>>10)
+#define VI_YDCTL2_get_write_enable4(data)                                            ((0x00000400&(data))>>10)
+#define VI_YDCTL2_src_sel_shift                                                      (9)
+#define VI_YDCTL2_src_sel_mask                                                       (0x00000200)
+#define VI_YDCTL2_src_sel(data)                                                      (0x00000200&((data)<<9))
+#define VI_YDCTL2_src_sel_src(data)                                                  ((0x00000200&(data))>>9)
+#define VI_YDCTL2_get_src_sel(data)                                                  ((0x00000200&(data))>>9)
+#define VI_YDCTL2_write_enable5_shift                                                (8)
+#define VI_YDCTL2_write_enable5_mask                                                 (0x00000100)
+#define VI_YDCTL2_write_enable5(data)                                                (0x00000100&((data)<<8))
+#define VI_YDCTL2_write_enable5_src(data)                                            ((0x00000100&(data))>>8)
+#define VI_YDCTL2_get_write_enable5(data)                                            ((0x00000100&(data))>>8)
+#define VI_YDCTL2_luma_2x_en_shift                                                   (7)
+#define VI_YDCTL2_luma_2x_en_mask                                                    (0x00000080)
+#define VI_YDCTL2_luma_2x_en(data)                                                   (0x00000080&((data)<<7))
+#define VI_YDCTL2_luma_2x_en_src(data)                                               ((0x00000080&(data))>>7)
+#define VI_YDCTL2_get_luma_2x_en(data)                                               ((0x00000080&(data))>>7)
+#define VI_YDCTL2_write_enable1_shift                                                (6)
+#define VI_YDCTL2_write_enable1_mask                                                 (0x00000040)
+#define VI_YDCTL2_write_enable1(data)                                                (0x00000040&((data)<<6))
+#define VI_YDCTL2_write_enable1_src(data)                                            ((0x00000040&(data))>>6)
+#define VI_YDCTL2_get_write_enable1(data)                                            ((0x00000040&(data))>>6)
+#define VI_YDCTL2_yden_shift                                                         (5)
+#define VI_YDCTL2_yden_mask                                                          (0x00000020)
+#define VI_YDCTL2_yden(data)                                                         (0x00000020&((data)<<5))
+#define VI_YDCTL2_yden_src(data)                                                     ((0x00000020&(data))>>5)
+#define VI_YDCTL2_get_yden(data)                                                     ((0x00000020&(data))>>5)
+#define VI_YDCTL2_write_enable2_shift                                                (4)
+#define VI_YDCTL2_write_enable2_mask                                                 (0x00000010)
+#define VI_YDCTL2_write_enable2(data)                                                (0x00000010&((data)<<4))
+#define VI_YDCTL2_write_enable2_src(data)                                            ((0x00000010&(data))>>4)
+#define VI_YDCTL2_get_write_enable2(data)                                            ((0x00000010&(data))>>4)
+#define VI_YDCTL2_write_enable3_shift                                                (2)
+#define VI_YDCTL2_write_enable3_mask                                                 (0x00000004)
+#define VI_YDCTL2_write_enable3(data)                                                (0x00000004&((data)<<2))
+#define VI_YDCTL2_write_enable3_src(data)                                            ((0x00000004&(data))>>2)
+#define VI_YDCTL2_get_write_enable3(data)                                            ((0x00000004&(data))>>2)
+#define VI_YDCTL2_ydrtio_shift                                                       (0)
+#define VI_YDCTL2_ydrtio_mask                                                        (0x00000003)
+#define VI_YDCTL2_ydrtio(data)                                                       (0x00000003&((data)<<0))
+#define VI_YDCTL2_ydrtio_src(data)                                                   ((0x00000003&(data))>>0)
+#define VI_YDCTL2_get_ydrtio(data)                                                   ((0x00000003&(data))>>0)
+
+
+#define VI_DMACTL                                                                    0x1800422c
+#define VI_DMACTL_reg_addr                                                           "0xB800422C"
+#define VI_DMACTL_reg                                                                0xB800422C
+#define VI_DMACTL_inst_adr                                                           "0x008B"
+#define VI_DMACTL_inst                                                               0x008B
+#define VI_DMACTL_write_enable1_shift                                                (11)
+#define VI_DMACTL_write_enable1_mask                                                 (0x00000800)
+#define VI_DMACTL_write_enable1(data)                                                (0x00000800&((data)<<11))
+#define VI_DMACTL_write_enable1_src(data)                                            ((0x00000800&(data))>>11)
+#define VI_DMACTL_get_write_enable1(data)                                            ((0x00000800&(data))>>11)
+#define VI_DMACTL_dmaen1_shift                                                       (10)
+#define VI_DMACTL_dmaen1_mask                                                        (0x00000400)
+#define VI_DMACTL_dmaen1(data)                                                       (0x00000400&((data)<<10))
+#define VI_DMACTL_dmaen1_src(data)                                                   ((0x00000400&(data))>>10)
+#define VI_DMACTL_get_dmaen1(data)                                                   ((0x00000400&(data))>>10)
+#define VI_DMACTL_write_enable2_shift                                                (9)
+#define VI_DMACTL_write_enable2_mask                                                 (0x00000200)
+#define VI_DMACTL_write_enable2(data)                                                (0x00000200&((data)<<9))
+#define VI_DMACTL_write_enable2_src(data)                                            ((0x00000200&(data))>>9)
+#define VI_DMACTL_get_write_enable2(data)                                            ((0x00000200&(data))>>9)
+#define VI_DMACTL_dmaen2_shift                                                       (8)
+#define VI_DMACTL_dmaen2_mask                                                        (0x00000100)
+#define VI_DMACTL_dmaen2(data)                                                       (0x00000100&((data)<<8))
+#define VI_DMACTL_dmaen2_src(data)                                                   ((0x00000100&(data))>>8)
+#define VI_DMACTL_get_dmaen2(data)                                                   ((0x00000100&(data))>>8)
+#define VI_DMACTL_write_enable4_shift                                                (7)
+#define VI_DMACTL_write_enable4_mask                                                 (0x00000080)
+#define VI_DMACTL_write_enable4(data)                                                (0x00000080&((data)<<7))
+#define VI_DMACTL_write_enable4_src(data)                                            ((0x00000080&(data))>>7)
+#define VI_DMACTL_get_write_enable4(data)                                            ((0x00000080&(data))>>7)
+#define VI_DMACTL_hddmaen1_shift                                                     (6)
+#define VI_DMACTL_hddmaen1_mask                                                      (0x00000040)
+#define VI_DMACTL_hddmaen1(data)                                                     (0x00000040&((data)<<6))
+#define VI_DMACTL_hddmaen1_src(data)                                                 ((0x00000040&(data))>>6)
+#define VI_DMACTL_get_hddmaen1(data)                                                 ((0x00000040&(data))>>6)
+#define VI_DMACTL_write_enable5_shift                                                (5)
+#define VI_DMACTL_write_enable5_mask                                                 (0x00000020)
+#define VI_DMACTL_write_enable5(data)                                                (0x00000020&((data)<<5))
+#define VI_DMACTL_write_enable5_src(data)                                            ((0x00000020&(data))>>5)
+#define VI_DMACTL_get_write_enable5(data)                                            ((0x00000020&(data))>>5)
+#define VI_DMACTL_hddmaen2_shift                                                     (4)
+#define VI_DMACTL_hddmaen2_mask                                                      (0x00000010)
+#define VI_DMACTL_hddmaen2(data)                                                     (0x00000010&((data)<<4))
+#define VI_DMACTL_hddmaen2_src(data)                                                 ((0x00000010&(data))>>4)
+#define VI_DMACTL_get_hddmaen2(data)                                                 ((0x00000010&(data))>>4)
+#define VI_DMACTL_write_enable3_shift                                                (3)
+#define VI_DMACTL_write_enable3_mask                                                 (0x00000008)
+#define VI_DMACTL_write_enable3(data)                                                (0x00000008&((data)<<3))
+#define VI_DMACTL_write_enable3_src(data)                                            ((0x00000008&(data))>>3)
+#define VI_DMACTL_get_write_enable3(data)                                            ((0x00000008&(data))>>3)
+#define VI_DMACTL_bstlen_shift                                                       (0)
+#define VI_DMACTL_bstlen_mask                                                        (0x00000007)
+#define VI_DMACTL_bstlen(data)                                                       (0x00000007&((data)<<0))
+#define VI_DMACTL_bstlen_src(data)                                                   ((0x00000007&(data))>>0)
+#define VI_DMACTL_get_bstlen(data)                                                   ((0x00000007&(data))>>0)
+
+
+#define VI_VBI1BUF                                                                   0x1800429c
+#define VI_VBI1BUF_reg_addr                                                          "0xB800429C"
+#define VI_VBI1BUF_reg                                                               0xB800429C
+#define VI_VBI1BUF_inst_adr                                                          "0x00A7"
+#define VI_VBI1BUF_inst                                                              0x00A7
+#define VI_VBI1BUF_write_enable1_shift                                               (6)
+#define VI_VBI1BUF_write_enable1_mask                                                (0x00000040)
+#define VI_VBI1BUF_write_enable1(data)                                               (0x00000040&((data)<<6))
+#define VI_VBI1BUF_write_enable1_src(data)                                           ((0x00000040&(data))>>6)
+#define VI_VBI1BUF_get_write_enable1(data)                                           ((0x00000040&(data))>>6)
+#define VI_VBI1BUF_thd_shift                                                         (0)
+#define VI_VBI1BUF_thd_mask                                                          (0x0000003F)
+#define VI_VBI1BUF_thd(data)                                                         (0x0000003F&((data)<<0))
+#define VI_VBI1BUF_thd_src(data)                                                     ((0x0000003F&(data))>>0)
+#define VI_VBI1BUF_get_thd(data)                                                     ((0x0000003F&(data))>>0)
+
+
+#define VI_VBI2BUF                                                                   0x180042a0
+#define VI_VBI2BUF_reg_addr                                                          "0xB80042A0"
+#define VI_VBI2BUF_reg                                                               0xB80042A0
+#define VI_VBI2BUF_inst_adr                                                          "0x00A8"
+#define VI_VBI2BUF_inst                                                              0x00A8
+#define VI_VBI2BUF_write_enable1_shift                                               (6)
+#define VI_VBI2BUF_write_enable1_mask                                                (0x00000040)
+#define VI_VBI2BUF_write_enable1(data)                                               (0x00000040&((data)<<6))
+#define VI_VBI2BUF_write_enable1_src(data)                                           ((0x00000040&(data))>>6)
+#define VI_VBI2BUF_get_write_enable1(data)                                           ((0x00000040&(data))>>6)
+#define VI_VBI2BUF_thd_shift                                                         (0)
+#define VI_VBI2BUF_thd_mask                                                          (0x0000003F)
+#define VI_VBI2BUF_thd(data)                                                         (0x0000003F&((data)<<0))
+#define VI_VBI2BUF_thd_src(data)                                                     ((0x0000003F&(data))>>0)
+#define VI_VBI2BUF_get_thd(data)                                                     ((0x0000003F&(data))>>0)
+
+
+#define VI_HDY1BUF                                                                   0x18004480
+#define VI_HDY1BUF_reg_addr                                                          "0xB8004480"
+#define VI_HDY1BUF_reg                                                               0xB8004480
+#define VI_HDY1BUF_inst_adr                                                          "0x0020"
+#define VI_HDY1BUF_inst                                                              0x0020
+#define VI_HDY1BUF_write_enable1_shift                                               (16)
+#define VI_HDY1BUF_write_enable1_mask                                                (0x00010000)
+#define VI_HDY1BUF_write_enable1(data)                                               (0x00010000&((data)<<16))
+#define VI_HDY1BUF_write_enable1_src(data)                                           ((0x00010000&(data))>>16)
+#define VI_HDY1BUF_get_write_enable1(data)                                           ((0x00010000&(data))>>16)
+#define VI_HDY1BUF_thd_shift                                                         (10)
+#define VI_HDY1BUF_thd_mask                                                          (0x0000FC00)
+#define VI_HDY1BUF_thd(data)                                                         (0x0000FC00&((data)<<10))
+#define VI_HDY1BUF_thd_src(data)                                                     ((0x0000FC00&(data))>>10)
+#define VI_HDY1BUF_get_thd(data)                                                     ((0x0000FC00&(data))>>10)
+
+
+#define VI_HDY2BUF                                                                   0x18004484
+#define VI_HDY2BUF_reg_addr                                                          "0xB8004484"
+#define VI_HDY2BUF_reg                                                               0xB8004484
+#define VI_HDY2BUF_inst_adr                                                          "0x0021"
+#define VI_HDY2BUF_inst                                                              0x0021
+#define VI_HDY2BUF_write_enable1_shift                                               (26)
+#define VI_HDY2BUF_write_enable1_mask                                                (0x04000000)
+#define VI_HDY2BUF_write_enable1(data)                                               (0x04000000&((data)<<26))
+#define VI_HDY2BUF_write_enable1_src(data)                                           ((0x04000000&(data))>>26)
+#define VI_HDY2BUF_get_write_enable1(data)                                           ((0x04000000&(data))>>26)
+#define VI_HDY2BUF_thd_shift                                                         (20)
+#define VI_HDY2BUF_thd_mask                                                          (0x03F00000)
+#define VI_HDY2BUF_thd(data)                                                         (0x03F00000&((data)<<20))
+#define VI_HDY2BUF_thd_src(data)                                                     ((0x03F00000&(data))>>20)
+#define VI_HDY2BUF_get_thd(data)                                                     ((0x03F00000&(data))>>20)
+
+
+#define VI_HDC1BUF                                                                   0x18004488
+#define VI_HDC1BUF_reg_addr                                                          "0xB8004488"
+#define VI_HDC1BUF_reg                                                               0xB8004488
+#define VI_HDC1BUF_inst_adr                                                          "0x0022"
+#define VI_HDC1BUF_inst                                                              0x0022
+#define VI_HDC1BUF_write_enable1_shift                                               (26)
+#define VI_HDC1BUF_write_enable1_mask                                                (0x04000000)
+#define VI_HDC1BUF_write_enable1(data)                                               (0x04000000&((data)<<26))
+#define VI_HDC1BUF_write_enable1_src(data)                                           ((0x04000000&(data))>>26)
+#define VI_HDC1BUF_get_write_enable1(data)                                           ((0x04000000&(data))>>26)
+#define VI_HDC1BUF_thd_shift                                                         (20)
+#define VI_HDC1BUF_thd_mask                                                          (0x03F00000)
+#define VI_HDC1BUF_thd(data)                                                         (0x03F00000&((data)<<20))
+#define VI_HDC1BUF_thd_src(data)                                                     ((0x03F00000&(data))>>20)
+#define VI_HDC1BUF_get_thd(data)                                                     ((0x03F00000&(data))>>20)
+
+
+#define VI_HDC2BUF                                                                   0x1800448c
+#define VI_HDC2BUF_reg_addr                                                          "0xB800448C"
+#define VI_HDC2BUF_reg                                                               0xB800448C
+#define VI_HDC2BUF_inst_adr                                                          "0x0023"
+#define VI_HDC2BUF_inst                                                              0x0023
+#define VI_HDC2BUF_write_enable1_shift                                               (26)
+#define VI_HDC2BUF_write_enable1_mask                                                (0x04000000)
+#define VI_HDC2BUF_write_enable1(data)                                               (0x04000000&((data)<<26))
+#define VI_HDC2BUF_write_enable1_src(data)                                           ((0x04000000&(data))>>26)
+#define VI_HDC2BUF_get_write_enable1(data)                                           ((0x04000000&(data))>>26)
+#define VI_HDC2BUF_thd_shift                                                         (20)
+#define VI_HDC2BUF_thd_mask                                                          (0x03F00000)
+#define VI_HDC2BUF_thd(data)                                                         (0x03F00000&((data)<<20))
+#define VI_HDC2BUF_thd_src(data)                                                     ((0x03F00000&(data))>>20)
+#define VI_HDC2BUF_get_thd(data)                                                     ((0x03F00000&(data))>>20)
+
+
+#define VI_Y1BUF                                                                     0x18004230
+#define VI_Y1BUF_reg_addr                                                            "0xB8004230"
+#define VI_Y1BUF_reg                                                                 0xB8004230
+#define VI_Y1BUF_inst_adr                                                            "0x008C"
+#define VI_Y1BUF_inst                                                                0x008C
+#define VI_Y1BUF_write_enable1_shift                                                 (16)
+#define VI_Y1BUF_write_enable1_mask                                                  (0x00010000)
+#define VI_Y1BUF_write_enable1(data)                                                 (0x00010000&((data)<<16))
+#define VI_Y1BUF_write_enable1_src(data)                                             ((0x00010000&(data))>>16)
+#define VI_Y1BUF_get_write_enable1(data)                                             ((0x00010000&(data))>>16)
+#define VI_Y1BUF_thd_shift                                                           (10)
+#define VI_Y1BUF_thd_mask                                                            (0x0000FC00)
+#define VI_Y1BUF_thd(data)                                                           (0x0000FC00&((data)<<10))
+#define VI_Y1BUF_thd_src(data)                                                       ((0x0000FC00&(data))>>10)
+#define VI_Y1BUF_get_thd(data)                                                       ((0x0000FC00&(data))>>10)
+
+
+#define VI_Y2BUF                                                                     0x18004234
+#define VI_Y2BUF_reg_addr                                                            "0xB8004234"
+#define VI_Y2BUF_reg                                                                 0xB8004234
+#define VI_Y2BUF_inst_adr                                                            "0x008D"
+#define VI_Y2BUF_inst                                                                0x008D
+#define VI_Y2BUF_write_enable1_shift                                                 (26)
+#define VI_Y2BUF_write_enable1_mask                                                  (0x04000000)
+#define VI_Y2BUF_write_enable1(data)                                                 (0x04000000&((data)<<26))
+#define VI_Y2BUF_write_enable1_src(data)                                             ((0x04000000&(data))>>26)
+#define VI_Y2BUF_get_write_enable1(data)                                             ((0x04000000&(data))>>26)
+#define VI_Y2BUF_thd_shift                                                           (20)
+#define VI_Y2BUF_thd_mask                                                            (0x03F00000)
+#define VI_Y2BUF_thd(data)                                                           (0x03F00000&((data)<<20))
+#define VI_Y2BUF_thd_src(data)                                                       ((0x03F00000&(data))>>20)
+#define VI_Y2BUF_get_thd(data)                                                       ((0x03F00000&(data))>>20)
+
+
+#define VI_C1BUF                                                                     0x18004238
+#define VI_C1BUF_reg_addr                                                            "0xB8004238"
+#define VI_C1BUF_reg                                                                 0xB8004238
+#define VI_C1BUF_inst_adr                                                            "0x008E"
+#define VI_C1BUF_inst                                                                0x008E
+#define VI_C1BUF_write_enable1_shift                                                 (26)
+#define VI_C1BUF_write_enable1_mask                                                  (0x04000000)
+#define VI_C1BUF_write_enable1(data)                                                 (0x04000000&((data)<<26))
+#define VI_C1BUF_write_enable1_src(data)                                             ((0x04000000&(data))>>26)
+#define VI_C1BUF_get_write_enable1(data)                                             ((0x04000000&(data))>>26)
+#define VI_C1BUF_thd_shift                                                           (20)
+#define VI_C1BUF_thd_mask                                                            (0x03F00000)
+#define VI_C1BUF_thd(data)                                                           (0x03F00000&((data)<<20))
+#define VI_C1BUF_thd_src(data)                                                       ((0x03F00000&(data))>>20)
+#define VI_C1BUF_get_thd(data)                                                       ((0x03F00000&(data))>>20)
+
+
+#define VI_C2BUF                                                                     0x1800423c
+#define VI_C2BUF_reg_addr                                                            "0xB800423C"
+#define VI_C2BUF_reg                                                                 0xB800423C
+#define VI_C2BUF_inst_adr                                                            "0x008F"
+#define VI_C2BUF_inst                                                                0x008F
+#define VI_C2BUF_write_enable1_shift                                                 (26)
+#define VI_C2BUF_write_enable1_mask                                                  (0x04000000)
+#define VI_C2BUF_write_enable1(data)                                                 (0x04000000&((data)<<26))
+#define VI_C2BUF_write_enable1_src(data)                                             ((0x04000000&(data))>>26)
+#define VI_C2BUF_get_write_enable1(data)                                             ((0x04000000&(data))>>26)
+#define VI_C2BUF_thd_shift                                                           (20)
+#define VI_C2BUF_thd_mask                                                            (0x03F00000)
+#define VI_C2BUF_thd(data)                                                           (0x03F00000&((data)<<20))
+#define VI_C2BUF_thd_src(data)                                                       ((0x03F00000&(data))>>20)
+#define VI_C2BUF_get_thd(data)                                                       ((0x03F00000&(data))>>20)
+
+
+#define VI_YDBUF                                                                     0x18004240
+#define VI_YDBUF_reg_addr                                                            "0xB8004240"
+#define VI_YDBUF_reg                                                                 0xB8004240
+#define VI_YDBUF_inst_adr                                                            "0x0090"
+#define VI_YDBUF_inst                                                                0x0090
+#define VI_YDBUF_write_enable1_shift                                                 (26)
+#define VI_YDBUF_write_enable1_mask                                                  (0x04000000)
+#define VI_YDBUF_write_enable1(data)                                                 (0x04000000&((data)<<26))
+#define VI_YDBUF_write_enable1_src(data)                                             ((0x04000000&(data))>>26)
+#define VI_YDBUF_get_write_enable1(data)                                             ((0x04000000&(data))>>26)
+#define VI_YDBUF_thd1_shift                                                          (20)
+#define VI_YDBUF_thd1_mask                                                           (0x03F00000)
+#define VI_YDBUF_thd1(data)                                                          (0x03F00000&((data)<<20))
+#define VI_YDBUF_thd1_src(data)                                                      ((0x03F00000&(data))>>20)
+#define VI_YDBUF_get_thd1(data)                                                      ((0x03F00000&(data))>>20)
+#define VI_YDBUF_write_enable2_shift                                                 (19)
+#define VI_YDBUF_write_enable2_mask                                                  (0x00080000)
+#define VI_YDBUF_write_enable2(data)                                                 (0x00080000&((data)<<19))
+#define VI_YDBUF_write_enable2_src(data)                                             ((0x00080000&(data))>>19)
+#define VI_YDBUF_get_write_enable2(data)                                             ((0x00080000&(data))>>19)
+#define VI_YDBUF_thd2_shift                                                          (13)
+#define VI_YDBUF_thd2_mask                                                           (0x0007E000)
+#define VI_YDBUF_thd2(data)                                                          (0x0007E000&((data)<<13))
+#define VI_YDBUF_thd2_src(data)                                                      ((0x0007E000&(data))>>13)
+#define VI_YDBUF_get_thd2(data)                                                      ((0x0007E000&(data))>>13)
+
+
+#define VI_VBISCADR1F0                                                               0x18004510
+#define VI_VBISCADR1F0_reg_addr                                                      "0xB8004510"
+#define VI_VBISCADR1F0_reg                                                           0xB8004510
+#define VI_VBISCADR1F0_inst_adr                                                      "0x0044"
+#define VI_VBISCADR1F0_inst                                                          0x0044
+#define VI_VBISCADR1F0_addr_shift                                                    (0)
+#define VI_VBISCADR1F0_addr_mask                                                     (0x0FFFFFFF)
+#define VI_VBISCADR1F0_addr(data)                                                    (0x0FFFFFFF&((data)<<0))
+#define VI_VBISCADR1F0_addr_src(data)                                                ((0x0FFFFFFF&(data))>>0)
+#define VI_VBISCADR1F0_get_addr(data)                                                ((0x0FFFFFFF&(data))>>0)
+
+
+#define VI_VBISCADR1F1                                                               0x18004514
+#define VI_VBISCADR1F1_reg_addr                                                      "0xB8004514"
+#define VI_VBISCADR1F1_reg                                                           0xB8004514
+#define VI_VBISCADR1F1_inst_adr                                                      "0x0045"
+#define VI_VBISCADR1F1_inst                                                          0x0045
+#define VI_VBISCADR1F1_addr_shift                                                    (0)
+#define VI_VBISCADR1F1_addr_mask                                                     (0x0FFFFFFF)
+#define VI_VBISCADR1F1_addr(data)                                                    (0x0FFFFFFF&((data)<<0))
+#define VI_VBISCADR1F1_addr_src(data)                                                ((0x0FFFFFFF&(data))>>0)
+#define VI_VBISCADR1F1_get_addr(data)                                                ((0x0FFFFFFF&(data))>>0)
+
+
+#define VI_VBISCADR2F0                                                               0x18004518
+#define VI_VBISCADR2F0_reg_addr                                                      "0xB8004518"
+#define VI_VBISCADR2F0_reg                                                           0xB8004518
+#define VI_VBISCADR2F0_inst_adr                                                      "0x0046"
+#define VI_VBISCADR2F0_inst                                                          0x0046
+#define VI_VBISCADR2F0_addr_shift                                                    (0)
+#define VI_VBISCADR2F0_addr_mask                                                     (0x0FFFFFFF)
+#define VI_VBISCADR2F0_addr(data)                                                    (0x0FFFFFFF&((data)<<0))
+#define VI_VBISCADR2F0_addr_src(data)                                                ((0x0FFFFFFF&(data))>>0)
+#define VI_VBISCADR2F0_get_addr(data)                                                ((0x0FFFFFFF&(data))>>0)
+
+
+#define VI_VBISCADR2F1                                                               0x1800451c
+#define VI_VBISCADR2F1_reg_addr                                                      "0xB800451C"
+#define VI_VBISCADR2F1_reg                                                           0xB800451C
+#define VI_VBISCADR2F1_inst_adr                                                      "0x0047"
+#define VI_VBISCADR2F1_inst                                                          0x0047
+#define VI_VBISCADR2F1_addr_shift                                                    (0)
+#define VI_VBISCADR2F1_addr_mask                                                     (0x0FFFFFFF)
+#define VI_VBISCADR2F1_addr(data)                                                    (0x0FFFFFFF&((data)<<0))
+#define VI_VBISCADR2F1_addr_src(data)                                                ((0x0FFFFFFF&(data))>>0)
+#define VI_VBISCADR2F1_get_addr(data)                                                ((0x0FFFFFFF&(data))>>0)
+
+
+#define VI_VBISCLEN1F0                                                               0x18004520
+#define VI_VBISCLEN1F0_reg_addr                                                      "0xB8004520"
+#define VI_VBISCLEN1F0_reg                                                           0xB8004520
+#define VI_VBISCLEN1F0_inst_adr                                                      "0x0048"
+#define VI_VBISCLEN1F0_inst                                                          0x0048
+#define VI_VBISCLEN1F0_length_shift                                                  (0)
+#define VI_VBISCLEN1F0_length_mask                                                   (0x0003FFFF)
+#define VI_VBISCLEN1F0_length(data)                                                  (0x0003FFFF&((data)<<0))
+#define VI_VBISCLEN1F0_length_src(data)                                              ((0x0003FFFF&(data))>>0)
+#define VI_VBISCLEN1F0_get_length(data)                                              ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VBISCLEN1F1                                                               0x18004524
+#define VI_VBISCLEN1F1_reg_addr                                                      "0xB8004524"
+#define VI_VBISCLEN1F1_reg                                                           0xB8004524
+#define VI_VBISCLEN1F1_inst_adr                                                      "0x0049"
+#define VI_VBISCLEN1F1_inst                                                          0x0049
+#define VI_VBISCLEN1F1_length_shift                                                  (0)
+#define VI_VBISCLEN1F1_length_mask                                                   (0x0003FFFF)
+#define VI_VBISCLEN1F1_length(data)                                                  (0x0003FFFF&((data)<<0))
+#define VI_VBISCLEN1F1_length_src(data)                                              ((0x0003FFFF&(data))>>0)
+#define VI_VBISCLEN1F1_get_length(data)                                              ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VBISCLEN2F0                                                               0x18004528
+#define VI_VBISCLEN2F0_reg_addr                                                      "0xB8004528"
+#define VI_VBISCLEN2F0_reg                                                           0xB8004528
+#define VI_VBISCLEN2F0_inst_adr                                                      "0x004A"
+#define VI_VBISCLEN2F0_inst                                                          0x004A
+#define VI_VBISCLEN2F0_length_shift                                                  (0)
+#define VI_VBISCLEN2F0_length_mask                                                   (0x0003FFFF)
+#define VI_VBISCLEN2F0_length(data)                                                  (0x0003FFFF&((data)<<0))
+#define VI_VBISCLEN2F0_length_src(data)                                              ((0x0003FFFF&(data))>>0)
+#define VI_VBISCLEN2F0_get_length(data)                                              ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VBISCLEN2F1                                                               0x1800452c
+#define VI_VBISCLEN2F1_reg_addr                                                      "0xB800452C"
+#define VI_VBISCLEN2F1_reg                                                           0xB800452C
+#define VI_VBISCLEN2F1_inst_adr                                                      "0x004B"
+#define VI_VBISCLEN2F1_inst                                                          0x004B
+#define VI_VBISCLEN2F1_length_shift                                                  (0)
+#define VI_VBISCLEN2F1_length_mask                                                   (0x0003FFFF)
+#define VI_VBISCLEN2F1_length(data)                                                  (0x0003FFFF&((data)<<0))
+#define VI_VBISCLEN2F1_length_src(data)                                              ((0x0003FFFF&(data))>>0)
+#define VI_VBISCLEN2F1_get_length(data)                                              ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VBIADR1F0                                                                 0x180042a4
+#define VI_VBIADR1F0_reg_addr                                                        "0xB80042A4"
+#define VI_VBIADR1F0_reg                                                             0xB80042A4
+#define VI_VBIADR1F0_inst_adr                                                        "0x00A9"
+#define VI_VBIADR1F0_inst                                                            0x00A9
+#define VI_VBIADR1F0_addr_shift                                                      (0)
+#define VI_VBIADR1F0_addr_mask                                                       (0x0FFFFFFF)
+#define VI_VBIADR1F0_addr(data)                                                      (0x0FFFFFFF&((data)<<0))
+#define VI_VBIADR1F0_addr_src(data)                                                  ((0x0FFFFFFF&(data))>>0)
+#define VI_VBIADR1F0_get_addr(data)                                                  ((0x0FFFFFFF&(data))>>0)
+
+
+#define VI_VBIADR1F1                                                                 0x180044e0
+#define VI_VBIADR1F1_reg_addr                                                        "0xB80044E0"
+#define VI_VBIADR1F1_reg                                                             0xB80044E0
+#define VI_VBIADR1F1_inst_adr                                                        "0x0038"
+#define VI_VBIADR1F1_inst                                                            0x0038
+#define VI_VBIADR1F1_addr_shift                                                      (0)
+#define VI_VBIADR1F1_addr_mask                                                       (0x0FFFFFFF)
+#define VI_VBIADR1F1_addr(data)                                                      (0x0FFFFFFF&((data)<<0))
+#define VI_VBIADR1F1_addr_src(data)                                                  ((0x0FFFFFFF&(data))>>0)
+#define VI_VBIADR1F1_get_addr(data)                                                  ((0x0FFFFFFF&(data))>>0)
+
+
+#define VI_VBILEN1F0                                                                 0x180042a8
+#define VI_VBILEN1F0_reg_addr                                                        "0xB80042A8"
+#define VI_VBILEN1F0_reg                                                             0xB80042A8
+#define VI_VBILEN1F0_inst_adr                                                        "0x00AA"
+#define VI_VBILEN1F0_inst                                                            0x00AA
+#define VI_VBILEN1F0_length_shift                                                    (0)
+#define VI_VBILEN1F0_length_mask                                                     (0x0003FFFF)
+#define VI_VBILEN1F0_length(data)                                                    (0x0003FFFF&((data)<<0))
+#define VI_VBILEN1F0_length_src(data)                                                ((0x0003FFFF&(data))>>0)
+#define VI_VBILEN1F0_get_length(data)                                                ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VBILEN1F1                                                                 0x180044e4
+#define VI_VBILEN1F1_reg_addr                                                        "0xB80044E4"
+#define VI_VBILEN1F1_reg                                                             0xB80044E4
+#define VI_VBILEN1F1_inst_adr                                                        "0x0039"
+#define VI_VBILEN1F1_inst                                                            0x0039
+#define VI_VBILEN1F1_length_shift                                                    (0)
+#define VI_VBILEN1F1_length_mask                                                     (0x0003FFFF)
+#define VI_VBILEN1F1_length(data)                                                    (0x0003FFFF&((data)<<0))
+#define VI_VBILEN1F1_length_src(data)                                                ((0x0003FFFF&(data))>>0)
+#define VI_VBILEN1F1_get_length(data)                                                ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VBIADR2F0                                                                 0x180042ac
+#define VI_VBIADR2F0_reg_addr                                                        "0xB80042AC"
+#define VI_VBIADR2F0_reg                                                             0xB80042AC
+#define VI_VBIADR2F0_inst_adr                                                        "0x00AB"
+#define VI_VBIADR2F0_inst                                                            0x00AB
+#define VI_VBIADR2F0_addr_shift                                                      (0)
+#define VI_VBIADR2F0_addr_mask                                                       (0x0FFFFFFF)
+#define VI_VBIADR2F0_addr(data)                                                      (0x0FFFFFFF&((data)<<0))
+#define VI_VBIADR2F0_addr_src(data)                                                  ((0x0FFFFFFF&(data))>>0)
+#define VI_VBIADR2F0_get_addr(data)                                                  ((0x0FFFFFFF&(data))>>0)
+
+
+#define VI_VBIADR2F1                                                                 0x180044e8
+#define VI_VBIADR2F1_reg_addr                                                        "0xB80044E8"
+#define VI_VBIADR2F1_reg                                                             0xB80044E8
+#define VI_VBIADR2F1_inst_adr                                                        "0x003A"
+#define VI_VBIADR2F1_inst                                                            0x003A
+#define VI_VBIADR2F1_addr_shift                                                      (0)
+#define VI_VBIADR2F1_addr_mask                                                       (0x0FFFFFFF)
+#define VI_VBIADR2F1_addr(data)                                                      (0x0FFFFFFF&((data)<<0))
+#define VI_VBIADR2F1_addr_src(data)                                                  ((0x0FFFFFFF&(data))>>0)
+#define VI_VBIADR2F1_get_addr(data)                                                  ((0x0FFFFFFF&(data))>>0)
+
+
+#define VI_VBILEN2F0                                                                 0x180042b0
+#define VI_VBILEN2F0_reg_addr                                                        "0xB80042B0"
+#define VI_VBILEN2F0_reg                                                             0xB80042B0
+#define VI_VBILEN2F0_inst_adr                                                        "0x00AC"
+#define VI_VBILEN2F0_inst                                                            0x00AC
+#define VI_VBILEN2F0_length_shift                                                    (0)
+#define VI_VBILEN2F0_length_mask                                                     (0x0003FFFF)
+#define VI_VBILEN2F0_length(data)                                                    (0x0003FFFF&((data)<<0))
+#define VI_VBILEN2F0_length_src(data)                                                ((0x0003FFFF&(data))>>0)
+#define VI_VBILEN2F0_get_length(data)                                                ((0x0003FFFF&(data))>>0)
+
+
+#define VI_VBILEN2F1                                                                 0x180044ec
+#define VI_VBILEN2F1_reg_addr                                                        "0xB80044EC"
+#define VI_VBILEN2F1_reg                                                             0xB80044EC
+#define VI_VBILEN2F1_inst_adr                                                        "0x003B"
+#define VI_VBILEN2F1_inst                                                            0x003B
+#define VI_VBILEN2F1_length_shift                                                    (0)
+#define VI_VBILEN2F1_length_mask                                                     (0x0003FFFF)
+#define VI_VBILEN2F1_length(data)                                                    (0x0003FFFF&((data)<<0))
+#define VI_VBILEN2F1_length_src(data)                                                ((0x0003FFFF&(data))>>0)
+#define VI_VBILEN2F1_get_length(data)                                                ((0x0003FFFF&(data))>>0)
+
+
+#define VI_DMACTL1                                                                   0x1800424c
+#define VI_DMACTL1_reg_addr                                                          "0xB800424C"
+#define VI_DMACTL1_reg                                                               0xB800424C
+#define VI_DMACTL1_inst_adr                                                          "0x0093"
+#define VI_DMACTL1_inst                                                              0x0093
+#define VI_DMACTL1_write_enable2_shift                                               (31)
+#define VI_DMACTL1_write_enable2_mask                                                (0x80000000)
+#define VI_DMACTL1_write_enable2(data)                                               (0x80000000&((data)<<31))
+#define VI_DMACTL1_write_enable2_src(data)                                           ((0x80000000&(data))>>31)
+#define VI_DMACTL1_get_write_enable2(data)                                           ((0x80000000&(data))>>31)
+#define VI_DMACTL1_yads_shift                                                        (24)
+#define VI_DMACTL1_yads_mask                                                         (0x7F000000)
+#define VI_DMACTL1_yads(data)                                                        (0x7F000000&((data)<<24))
+#define VI_DMACTL1_yads_src(data)                                                    ((0x7F000000&(data))>>24)
+#define VI_DMACTL1_get_yads(data)                                                    ((0x7F000000&(data))>>24)
+#define VI_DMACTL1_write_enable3_shift                                               (23)
+#define VI_DMACTL1_write_enable3_mask                                                (0x00800000)
+#define VI_DMACTL1_write_enable3(data)                                               (0x00800000&((data)<<23))
+#define VI_DMACTL1_write_enable3_src(data)                                           ((0x00800000&(data))>>23)
+#define VI_DMACTL1_get_write_enable3(data)                                           ((0x00800000&(data))>>23)
+#define VI_DMACTL1_cads_shift                                                        (16)
+#define VI_DMACTL1_cads_mask                                                         (0x007F0000)
+#define VI_DMACTL1_cads(data)                                                        (0x007F0000&((data)<<16))
+#define VI_DMACTL1_cads_src(data)                                                    ((0x007F0000&(data))>>16)
+#define VI_DMACTL1_get_cads(data)                                                    ((0x007F0000&(data))>>16)
+#define VI_DMACTL1_write_enable4_shift                                               (15)
+#define VI_DMACTL1_write_enable4_mask                                                (0x00008000)
+#define VI_DMACTL1_write_enable4(data)                                               (0x00008000&((data)<<15))
+#define VI_DMACTL1_write_enable4_src(data)                                           ((0x00008000&(data))>>15)
+#define VI_DMACTL1_get_write_enable4(data)                                           ((0x00008000&(data))>>15)
+#define VI_DMACTL1_hdyads_shift                                                      (8)
+#define VI_DMACTL1_hdyads_mask                                                       (0x00007F00)
+#define VI_DMACTL1_hdyads(data)                                                      (0x00007F00&((data)<<8))
+#define VI_DMACTL1_hdyads_src(data)                                                  ((0x00007F00&(data))>>8)
+#define VI_DMACTL1_get_hdyads(data)                                                  ((0x00007F00&(data))>>8)
+#define VI_DMACTL1_write_enable5_shift                                               (7)
+#define VI_DMACTL1_write_enable5_mask                                                (0x00000080)
+#define VI_DMACTL1_write_enable5(data)                                               (0x00000080&((data)<<7))
+#define VI_DMACTL1_write_enable5_src(data)                                           ((0x00000080&(data))>>7)
+#define VI_DMACTL1_get_write_enable5(data)                                           ((0x00000080&(data))>>7)
+#define VI_DMACTL1_hdcads_shift                                                      (0)
+#define VI_DMACTL1_hdcads_mask                                                       (0x0000007F)
+#define VI_DMACTL1_hdcads(data)                                                      (0x0000007F&((data)<<0))
+#define VI_DMACTL1_hdcads_src(data)                                                  ((0x0000007F&(data))>>0)
+#define VI_DMACTL1_get_hdcads(data)                                                  ((0x0000007F&(data))>>0)
+
+
+#define VI_DMACTL2                                                                   0x18004250
+#define VI_DMACTL2_reg_addr                                                          "0xB8004250"
+#define VI_DMACTL2_reg                                                               0xB8004250
+#define VI_DMACTL2_inst_adr                                                          "0x0094"
+#define VI_DMACTL2_inst                                                              0x0094
+#define VI_DMACTL2_write_enable2_shift                                               (31)
+#define VI_DMACTL2_write_enable2_mask                                                (0x80000000)
+#define VI_DMACTL2_write_enable2(data)                                               (0x80000000&((data)<<31))
+#define VI_DMACTL2_write_enable2_src(data)                                           ((0x80000000&(data))>>31)
+#define VI_DMACTL2_get_write_enable2(data)                                           ((0x80000000&(data))>>31)
+#define VI_DMACTL2_yads_shift                                                        (24)
+#define VI_DMACTL2_yads_mask                                                         (0x7F000000)
+#define VI_DMACTL2_yads(data)                                                        (0x7F000000&((data)<<24))
+#define VI_DMACTL2_yads_src(data)                                                    ((0x7F000000&(data))>>24)
+#define VI_DMACTL2_get_yads(data)                                                    ((0x7F000000&(data))>>24)
+#define VI_DMACTL2_write_enable3_shift                                               (23)
+#define VI_DMACTL2_write_enable3_mask                                                (0x00800000)
+#define VI_DMACTL2_write_enable3(data)                                               (0x00800000&((data)<<23))
+#define VI_DMACTL2_write_enable3_src(data)                                           ((0x00800000&(data))>>23)
+#define VI_DMACTL2_get_write_enable3(data)                                           ((0x00800000&(data))>>23)
+#define VI_DMACTL2_cads_shift                                                        (16)
+#define VI_DMACTL2_cads_mask                                                         (0x007F0000)
+#define VI_DMACTL2_cads(data)                                                        (0x007F0000&((data)<<16))
+#define VI_DMACTL2_cads_src(data)                                                    ((0x007F0000&(data))>>16)
+#define VI_DMACTL2_get_cads(data)                                                    ((0x007F0000&(data))>>16)
+#define VI_DMACTL2_write_enable4_shift                                               (15)
+#define VI_DMACTL2_write_enable4_mask                                                (0x00008000)
+#define VI_DMACTL2_write_enable4(data)                                               (0x00008000&((data)<<15))
+#define VI_DMACTL2_write_enable4_src(data)                                           ((0x00008000&(data))>>15)
+#define VI_DMACTL2_get_write_enable4(data)                                           ((0x00008000&(data))>>15)
+#define VI_DMACTL2_hdyads_shift                                                      (8)
+#define VI_DMACTL2_hdyads_mask                                                       (0x00007F00)
+#define VI_DMACTL2_hdyads(data)                                                      (0x00007F00&((data)<<8))
+#define VI_DMACTL2_hdyads_src(data)                                                  ((0x00007F00&(data))>>8)
+#define VI_DMACTL2_get_hdyads(data)                                                  ((0x00007F00&(data))>>8)
+#define VI_DMACTL2_write_enable5_shift                                               (7)
+#define VI_DMACTL2_write_enable5_mask                                                (0x00000080)
+#define VI_DMACTL2_write_enable5(data)                                               (0x00000080&((data)<<7))
+#define VI_DMACTL2_write_enable5_src(data)                                           ((0x00000080&(data))>>7)
+#define VI_DMACTL2_get_write_enable5(data)                                           ((0x00000080&(data))>>7)
+#define VI_DMACTL2_hdcads_shift                                                      (0)
+#define VI_DMACTL2_hdcads_mask                                                       (0x0000007F)
+#define VI_DMACTL2_hdcads(data)                                                      (0x0000007F&((data)<<0))
+#define VI_DMACTL2_hdcads_src(data)                                                  ((0x0000007F&(data))>>0)
+#define VI_DMACTL2_get_hdcads(data)                                                  ((0x0000007F&(data))>>0)
+
+
+#define VI_DYDMACTL                                                                  0x18004254
+#define VI_DYDMACTL_reg_addr                                                         "0xB8004254"
+#define VI_DYDMACTL_reg                                                              0xB8004254
+#define VI_DYDMACTL_inst_adr                                                         "0x0095"
+#define VI_DYDMACTL_inst                                                             0x0095
+#define VI_DYDMACTL_dyads2_shift                                                     (7)
+#define VI_DYDMACTL_dyads2_mask                                                      (0x00003F80)
+#define VI_DYDMACTL_dyads2(data)                                                     (0x00003F80&((data)<<7))
+#define VI_DYDMACTL_dyads2_src(data)                                                 ((0x00003F80&(data))>>7)
+#define VI_DYDMACTL_get_dyads2(data)                                                 ((0x00003F80&(data))>>7)
+#define VI_DYDMACTL_dyads_shift                                                      (0)
+#define VI_DYDMACTL_dyads_mask                                                       (0x0000007F)
+#define VI_DYDMACTL_dyads(data)                                                      (0x0000007F&((data)<<0))
+#define VI_DYDMACTL_dyads_src(data)                                                  ((0x0000007F&(data))>>0)
+#define VI_DYDMACTL_get_dyads(data)                                                  ((0x0000007F&(data))>>0)
+
+
+#define VI_IMMODE                                                                    0x1800425c
+#define VI_IMMODE_reg_addr                                                           "0xB800425C"
+#define VI_IMMODE_reg                                                                0xB800425C
+#define VI_IMMODE_inst_adr                                                           "0x0097"
+#define VI_IMMODE_inst                                                               0x0097
+#define VI_IMMODE_v1hd_odd_shift                                                     (12)
+#define VI_IMMODE_v1hd_odd_mask                                                      (0x00001000)
+#define VI_IMMODE_v1hd_odd(data)                                                     (0x00001000&((data)<<12))
+#define VI_IMMODE_v1hd_odd_src(data)                                                 ((0x00001000&(data))>>12)
+#define VI_IMMODE_get_v1hd_odd(data)                                                 ((0x00001000&(data))>>12)
+#define VI_IMMODE_v1hd_interleave_shift                                              (11)
+#define VI_IMMODE_v1hd_interleave_mask                                               (0x00000800)
+#define VI_IMMODE_v1hd_interleave(data)                                              (0x00000800&((data)<<11))
+#define VI_IMMODE_v1hd_interleave_src(data)                                          ((0x00000800&(data))>>11)
+#define VI_IMMODE_get_v1hd_interleave(data)                                          ((0x00000800&(data))>>11)
+#define VI_IMMODE_v2hd_odd_shift                                                     (10)
+#define VI_IMMODE_v2hd_odd_mask                                                      (0x00000400)
+#define VI_IMMODE_v2hd_odd(data)                                                     (0x00000400&((data)<<10))
+#define VI_IMMODE_v2hd_odd_src(data)                                                 ((0x00000400&(data))>>10)
+#define VI_IMMODE_get_v2hd_odd(data)                                                 ((0x00000400&(data))>>10)
+#define VI_IMMODE_v2hd_interleave_shift                                              (9)
+#define VI_IMMODE_v2hd_interleave_mask                                               (0x00000200)
+#define VI_IMMODE_v2hd_interleave(data)                                              (0x00000200&((data)<<9))
+#define VI_IMMODE_v2hd_interleave_src(data)                                          ((0x00000200&(data))>>9)
+#define VI_IMMODE_get_v2hd_interleave(data)                                          ((0x00000200&(data))>>9)
+#define VI_IMMODE_v1_odd_shift                                                       (8)
+#define VI_IMMODE_v1_odd_mask                                                        (0x00000100)
+#define VI_IMMODE_v1_odd(data)                                                       (0x00000100&((data)<<8))
+#define VI_IMMODE_v1_odd_src(data)                                                   ((0x00000100&(data))>>8)
+#define VI_IMMODE_get_v1_odd(data)                                                   ((0x00000100&(data))>>8)
+#define VI_IMMODE_v1_interleave_shift                                                (7)
+#define VI_IMMODE_v1_interleave_mask                                                 (0x00000080)
+#define VI_IMMODE_v1_interleave(data)                                                (0x00000080&((data)<<7))
+#define VI_IMMODE_v1_interleave_src(data)                                            ((0x00000080&(data))>>7)
+#define VI_IMMODE_get_v1_interleave(data)                                            ((0x00000080&(data))>>7)
+#define VI_IMMODE_v2_odd_shift                                                       (6)
+#define VI_IMMODE_v2_odd_mask                                                        (0x00000040)
+#define VI_IMMODE_v2_odd(data)                                                       (0x00000040&((data)<<6))
+#define VI_IMMODE_v2_odd_src(data)                                                   ((0x00000040&(data))>>6)
+#define VI_IMMODE_get_v2_odd(data)                                                   ((0x00000040&(data))>>6)
+#define VI_IMMODE_v2_interleave_shift                                                (5)
+#define VI_IMMODE_v2_interleave_mask                                                 (0x00000020)
+#define VI_IMMODE_v2_interleave(data)                                                (0x00000020&((data)<<5))
+#define VI_IMMODE_v2_interleave_src(data)                                            ((0x00000020&(data))>>5)
+#define VI_IMMODE_get_v2_interleave(data)                                            ((0x00000020&(data))>>5)
+#define VI_IMMODE_dy_odd_shift                                                       (4)
+#define VI_IMMODE_dy_odd_mask                                                        (0x00000010)
+#define VI_IMMODE_dy_odd(data)                                                       (0x00000010&((data)<<4))
+#define VI_IMMODE_dy_odd_src(data)                                                   ((0x00000010&(data))>>4)
+#define VI_IMMODE_get_dy_odd(data)                                                   ((0x00000010&(data))>>4)
+#define VI_IMMODE_dy_interleave_shift                                                (3)
+#define VI_IMMODE_dy_interleave_mask                                                 (0x00000008)
+#define VI_IMMODE_dy_interleave(data)                                                (0x00000008&((data)<<3))
+#define VI_IMMODE_dy_interleave_src(data)                                            ((0x00000008&(data))>>3)
+#define VI_IMMODE_get_dy_interleave(data)                                            ((0x00000008&(data))>>3)
+#define VI_IMMODE_dy2_odd_shift                                                      (2)
+#define VI_IMMODE_dy2_odd_mask                                                       (0x00000004)
+#define VI_IMMODE_dy2_odd(data)                                                      (0x00000004&((data)<<2))
+#define VI_IMMODE_dy2_odd_src(data)                                                  ((0x00000004&(data))>>2)
+#define VI_IMMODE_get_dy2_odd(data)                                                  ((0x00000004&(data))>>2)
+#define VI_IMMODE_dy2_interleave_shift                                               (1)
+#define VI_IMMODE_dy2_interleave_mask                                                (0x00000002)
+#define VI_IMMODE_dy2_interleave(data)                                               (0x00000002&((data)<<1))
+#define VI_IMMODE_dy2_interleave_src(data)                                           ((0x00000002&(data))>>1)
+#define VI_IMMODE_get_dy2_interleave(data)                                           ((0x00000002&(data))>>1)
+#define VI_IMMODE_write_data_shift                                                   (0)
+#define VI_IMMODE_write_data_mask                                                    (0x00000001)
+#define VI_IMMODE_write_data(data)                                                   (0x00000001&((data)<<0))
+#define VI_IMMODE_write_data_src(data)                                               ((0x00000001&(data))>>0)
+#define VI_IMMODE_get_write_data(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VI_DMA_MIN_TIME                                                              0x18004260
+#define VI_DMA_MIN_TIME_reg_addr                                                     "0xB8004260"
+#define VI_DMA_MIN_TIME_reg                                                          0xB8004260
+#define VI_DMA_MIN_TIME_inst_adr                                                     "0x0098"
+#define VI_DMA_MIN_TIME_inst                                                         0x0098
+#define VI_DMA_MIN_TIME_write_enable1_shift                                          (29)
+#define VI_DMA_MIN_TIME_write_enable1_mask                                           (0x20000000)
+#define VI_DMA_MIN_TIME_write_enable1(data)                                          (0x20000000&((data)<<29))
+#define VI_DMA_MIN_TIME_write_enable1_src(data)                                      ((0x20000000&(data))>>29)
+#define VI_DMA_MIN_TIME_get_write_enable1(data)                                      ((0x20000000&(data))>>29)
+#define VI_DMA_MIN_TIME_y1c1_shift                                                   (25)
+#define VI_DMA_MIN_TIME_y1c1_mask                                                    (0x1E000000)
+#define VI_DMA_MIN_TIME_y1c1(data)                                                   (0x1E000000&((data)<<25))
+#define VI_DMA_MIN_TIME_y1c1_src(data)                                               ((0x1E000000&(data))>>25)
+#define VI_DMA_MIN_TIME_get_y1c1(data)                                               ((0x1E000000&(data))>>25)
+#define VI_DMA_MIN_TIME_write_enable2_shift                                          (24)
+#define VI_DMA_MIN_TIME_write_enable2_mask                                           (0x01000000)
+#define VI_DMA_MIN_TIME_write_enable2(data)                                          (0x01000000&((data)<<24))
+#define VI_DMA_MIN_TIME_write_enable2_src(data)                                      ((0x01000000&(data))>>24)
+#define VI_DMA_MIN_TIME_get_write_enable2(data)                                      ((0x01000000&(data))>>24)
+#define VI_DMA_MIN_TIME_y2c2_shift                                                   (20)
+#define VI_DMA_MIN_TIME_y2c2_mask                                                    (0x00F00000)
+#define VI_DMA_MIN_TIME_y2c2(data)                                                   (0x00F00000&((data)<<20))
+#define VI_DMA_MIN_TIME_y2c2_src(data)                                               ((0x00F00000&(data))>>20)
+#define VI_DMA_MIN_TIME_get_y2c2(data)                                               ((0x00F00000&(data))>>20)
+#define VI_DMA_MIN_TIME_write_enable3_shift                                          (19)
+#define VI_DMA_MIN_TIME_write_enable3_mask                                           (0x00080000)
+#define VI_DMA_MIN_TIME_write_enable3(data)                                          (0x00080000&((data)<<19))
+#define VI_DMA_MIN_TIME_write_enable3_src(data)                                      ((0x00080000&(data))>>19)
+#define VI_DMA_MIN_TIME_get_write_enable3(data)                                      ((0x00080000&(data))>>19)
+#define VI_DMA_MIN_TIME_vbi1_shift                                                   (15)
+#define VI_DMA_MIN_TIME_vbi1_mask                                                    (0x00078000)
+#define VI_DMA_MIN_TIME_vbi1(data)                                                   (0x00078000&((data)<<15))
+#define VI_DMA_MIN_TIME_vbi1_src(data)                                               ((0x00078000&(data))>>15)
+#define VI_DMA_MIN_TIME_get_vbi1(data)                                               ((0x00078000&(data))>>15)
+#define VI_DMA_MIN_TIME_write_enable4_shift                                          (14)
+#define VI_DMA_MIN_TIME_write_enable4_mask                                           (0x00004000)
+#define VI_DMA_MIN_TIME_write_enable4(data)                                          (0x00004000&((data)<<14))
+#define VI_DMA_MIN_TIME_write_enable4_src(data)                                      ((0x00004000&(data))>>14)
+#define VI_DMA_MIN_TIME_get_write_enable4(data)                                      ((0x00004000&(data))>>14)
+#define VI_DMA_MIN_TIME_vbi2_shift                                                   (10)
+#define VI_DMA_MIN_TIME_vbi2_mask                                                    (0x00003C00)
+#define VI_DMA_MIN_TIME_vbi2(data)                                                   (0x00003C00&((data)<<10))
+#define VI_DMA_MIN_TIME_vbi2_src(data)                                               ((0x00003C00&(data))>>10)
+#define VI_DMA_MIN_TIME_get_vbi2(data)                                               ((0x00003C00&(data))>>10)
+#define VI_DMA_MIN_TIME_write_enable5_shift                                          (9)
+#define VI_DMA_MIN_TIME_write_enable5_mask                                           (0x00000200)
+#define VI_DMA_MIN_TIME_write_enable5(data)                                          (0x00000200&((data)<<9))
+#define VI_DMA_MIN_TIME_write_enable5_src(data)                                      ((0x00000200&(data))>>9)
+#define VI_DMA_MIN_TIME_get_write_enable5(data)                                      ((0x00000200&(data))>>9)
+#define VI_DMA_MIN_TIME_dy_shift                                                     (5)
+#define VI_DMA_MIN_TIME_dy_mask                                                      (0x000001E0)
+#define VI_DMA_MIN_TIME_dy(data)                                                     (0x000001E0&((data)<<5))
+#define VI_DMA_MIN_TIME_dy_src(data)                                                 ((0x000001E0&(data))>>5)
+#define VI_DMA_MIN_TIME_get_dy(data)                                                 ((0x000001E0&(data))>>5)
+#define VI_DMA_MIN_TIME_write_enable6_shift                                          (4)
+#define VI_DMA_MIN_TIME_write_enable6_mask                                           (0x00000010)
+#define VI_DMA_MIN_TIME_write_enable6(data)                                          (0x00000010&((data)<<4))
+#define VI_DMA_MIN_TIME_write_enable6_src(data)                                      ((0x00000010&(data))>>4)
+#define VI_DMA_MIN_TIME_get_write_enable6(data)                                      ((0x00000010&(data))>>4)
+#define VI_DMA_MIN_TIME_dy2_shift                                                    (0)
+#define VI_DMA_MIN_TIME_dy2_mask                                                     (0x0000000F)
+#define VI_DMA_MIN_TIME_dy2(data)                                                    (0x0000000F&((data)<<0))
+#define VI_DMA_MIN_TIME_dy2_src(data)                                                ((0x0000000F&(data))>>0)
+#define VI_DMA_MIN_TIME_get_dy2(data)                                                ((0x0000000F&(data))>>0)
+
+
+#define VI_HDDMA_MIN_TIME                                                            0x18004490
+#define VI_HDDMA_MIN_TIME_reg_addr                                                   "0xB8004490"
+#define VI_HDDMA_MIN_TIME_reg                                                        0xB8004490
+#define VI_HDDMA_MIN_TIME_inst_adr                                                   "0x0024"
+#define VI_HDDMA_MIN_TIME_inst                                                       0x0024
+#define VI_HDDMA_MIN_TIME_write_enable1_shift                                        (9)
+#define VI_HDDMA_MIN_TIME_write_enable1_mask                                         (0x00000200)
+#define VI_HDDMA_MIN_TIME_write_enable1(data)                                        (0x00000200&((data)<<9))
+#define VI_HDDMA_MIN_TIME_write_enable1_src(data)                                    ((0x00000200&(data))>>9)
+#define VI_HDDMA_MIN_TIME_get_write_enable1(data)                                    ((0x00000200&(data))>>9)
+#define VI_HDDMA_MIN_TIME_y1c1_shift                                                 (5)
+#define VI_HDDMA_MIN_TIME_y1c1_mask                                                  (0x000001E0)
+#define VI_HDDMA_MIN_TIME_y1c1(data)                                                 (0x000001E0&((data)<<5))
+#define VI_HDDMA_MIN_TIME_y1c1_src(data)                                             ((0x000001E0&(data))>>5)
+#define VI_HDDMA_MIN_TIME_get_y1c1(data)                                             ((0x000001E0&(data))>>5)
+#define VI_HDDMA_MIN_TIME_write_enable2_shift                                        (4)
+#define VI_HDDMA_MIN_TIME_write_enable2_mask                                         (0x00000010)
+#define VI_HDDMA_MIN_TIME_write_enable2(data)                                        (0x00000010&((data)<<4))
+#define VI_HDDMA_MIN_TIME_write_enable2_src(data)                                    ((0x00000010&(data))>>4)
+#define VI_HDDMA_MIN_TIME_get_write_enable2(data)                                    ((0x00000010&(data))>>4)
+#define VI_HDDMA_MIN_TIME_y2c2_shift                                                 (0)
+#define VI_HDDMA_MIN_TIME_y2c2_mask                                                  (0x0000000F)
+#define VI_HDDMA_MIN_TIME_y2c2(data)                                                 (0x0000000F&((data)<<0))
+#define VI_HDDMA_MIN_TIME_y2c2_src(data)                                             ((0x0000000F&(data))>>0)
+#define VI_HDDMA_MIN_TIME_get_y2c2(data)                                             ((0x0000000F&(data))>>0)
+
+
+#define VI_DMAERR                                                                    0x18004264
+#define VI_DMAERR_reg_addr                                                           "0xB8004264"
+#define VI_DMAERR_reg                                                                0xB8004264
+#define VI_DMAERR_inst_adr                                                           "0x0099"
+#define VI_DMAERR_inst                                                               0x0099
+#define VI_DMAERR_v2_err_shift                                                       (1)
+#define VI_DMAERR_v2_err_mask                                                        (0x00000002)
+#define VI_DMAERR_v2_err(data)                                                       (0x00000002&((data)<<1))
+#define VI_DMAERR_v2_err_src(data)                                                   ((0x00000002&(data))>>1)
+#define VI_DMAERR_get_v2_err(data)                                                   ((0x00000002&(data))>>1)
+#define VI_DMAERR_v1_err_shift                                                       (0)
+#define VI_DMAERR_v1_err_mask                                                        (0x00000001)
+#define VI_DMAERR_v1_err(data)                                                       (0x00000001&((data)<<0))
+#define VI_DMAERR_v1_err_src(data)                                                   ((0x00000001&(data))>>0)
+#define VI_DMAERR_get_v1_err(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define VI_INTEN                                                                     0x18004268
+#define VI_INTEN_reg_addr                                                            "0xB8004268"
+#define VI_INTEN_reg                                                                 0xB8004268
+#define VI_INTEN_inst_adr                                                            "0x009A"
+#define VI_INTEN_inst                                                                0x009A
+#define VI_INTEN_feinte1_shift                                                       (14)
+#define VI_INTEN_feinte1_mask                                                        (0x00004000)
+#define VI_INTEN_feinte1(data)                                                       (0x00004000&((data)<<14))
+#define VI_INTEN_feinte1_src(data)                                                   ((0x00004000&(data))>>14)
+#define VI_INTEN_get_feinte1(data)                                                   ((0x00004000&(data))>>14)
+#define VI_INTEN_feinte2_shift                                                       (13)
+#define VI_INTEN_feinte2_mask                                                        (0x00002000)
+#define VI_INTEN_feinte2(data)                                                       (0x00002000&((data)<<13))
+#define VI_INTEN_feinte2_src(data)                                                   ((0x00002000&(data))>>13)
+#define VI_INTEN_get_feinte2(data)                                                   ((0x00002000&(data))>>13)
+#define VI_INTEN_hdolinte1_shift                                                     (12)
+#define VI_INTEN_hdolinte1_mask                                                      (0x00001000)
+#define VI_INTEN_hdolinte1(data)                                                     (0x00001000&((data)<<12))
+#define VI_INTEN_hdolinte1_src(data)                                                 ((0x00001000&(data))>>12)
+#define VI_INTEN_get_hdolinte1(data)                                                 ((0x00001000&(data))>>12)
+#define VI_INTEN_hdolinte2_shift                                                     (11)
+#define VI_INTEN_hdolinte2_mask                                                      (0x00000800)
+#define VI_INTEN_hdolinte2(data)                                                     (0x00000800&((data)<<11))
+#define VI_INTEN_hdolinte2_src(data)                                                 ((0x00000800&(data))>>11)
+#define VI_INTEN_get_hdolinte2(data)                                                 ((0x00000800&(data))>>11)
+#define VI_INTEN_dmaerrinte_shift                                                    (10)
+#define VI_INTEN_dmaerrinte_mask                                                     (0x00000400)
+#define VI_INTEN_dmaerrinte(data)                                                    (0x00000400&((data)<<10))
+#define VI_INTEN_dmaerrinte_src(data)                                                ((0x00000400&(data))>>10)
+#define VI_INTEN_get_dmaerrinte(data)                                                ((0x00000400&(data))>>10)
+#define VI_INTEN_sfinte1_shift                                                       (8)
+#define VI_INTEN_sfinte1_mask                                                        (0x00000100)
+#define VI_INTEN_sfinte1(data)                                                       (0x00000100&((data)<<8))
+#define VI_INTEN_sfinte1_src(data)                                                   ((0x00000100&(data))>>8)
+#define VI_INTEN_get_sfinte1(data)                                                   ((0x00000100&(data))>>8)
+#define VI_INTEN_sfinte2_shift                                                       (7)
+#define VI_INTEN_sfinte2_mask                                                        (0x00000080)
+#define VI_INTEN_sfinte2(data)                                                       (0x00000080&((data)<<7))
+#define VI_INTEN_sfinte2_src(data)                                                   ((0x00000080&(data))>>7)
+#define VI_INTEN_get_sfinte2(data)                                                   ((0x00000080&(data))>>7)
+#define VI_INTEN_vsinte1_shift                                                       (6)
+#define VI_INTEN_vsinte1_mask                                                        (0x00000040)
+#define VI_INTEN_vsinte1(data)                                                       (0x00000040&((data)<<6))
+#define VI_INTEN_vsinte1_src(data)                                                   ((0x00000040&(data))>>6)
+#define VI_INTEN_get_vsinte1(data)                                                   ((0x00000040&(data))>>6)
+#define VI_INTEN_vsinte2_shift                                                       (5)
+#define VI_INTEN_vsinte2_mask                                                        (0x00000020)
+#define VI_INTEN_vsinte2(data)                                                       (0x00000020&((data)<<5))
+#define VI_INTEN_vsinte2_src(data)                                                   ((0x00000020&(data))>>5)
+#define VI_INTEN_get_vsinte2(data)                                                   ((0x00000020&(data))>>5)
+#define VI_INTEN_tointe1_shift                                                       (4)
+#define VI_INTEN_tointe1_mask                                                        (0x00000010)
+#define VI_INTEN_tointe1(data)                                                       (0x00000010&((data)<<4))
+#define VI_INTEN_tointe1_src(data)                                                   ((0x00000010&(data))>>4)
+#define VI_INTEN_get_tointe1(data)                                                   ((0x00000010&(data))>>4)
+#define VI_INTEN_tointe2_shift                                                       (3)
+#define VI_INTEN_tointe2_mask                                                        (0x00000008)
+#define VI_INTEN_tointe2(data)                                                       (0x00000008&((data)<<3))
+#define VI_INTEN_tointe2_src(data)                                                   ((0x00000008&(data))>>3)
+#define VI_INTEN_get_tointe2(data)                                                   ((0x00000008&(data))>>3)
+#define VI_INTEN_olinte1_shift                                                       (2)
+#define VI_INTEN_olinte1_mask                                                        (0x00000004)
+#define VI_INTEN_olinte1(data)                                                       (0x00000004&((data)<<2))
+#define VI_INTEN_olinte1_src(data)                                                   ((0x00000004&(data))>>2)
+#define VI_INTEN_get_olinte1(data)                                                   ((0x00000004&(data))>>2)
+#define VI_INTEN_olinte2_shift                                                       (1)
+#define VI_INTEN_olinte2_mask                                                        (0x00000002)
+#define VI_INTEN_olinte2(data)                                                       (0x00000002&((data)<<1))
+#define VI_INTEN_olinte2_src(data)                                                   ((0x00000002&(data))>>1)
+#define VI_INTEN_get_olinte2(data)                                                   ((0x00000002&(data))>>1)
+#define VI_INTEN_write_data_shift                                                    (0)
+#define VI_INTEN_write_data_mask                                                     (0x00000001)
+#define VI_INTEN_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VI_INTEN_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VI_INTEN_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VI_INTST                                                                     0x1800426c
+#define VI_INTST_reg_addr                                                            "0xB800426C"
+#define VI_INTST_reg                                                                 0xB800426C
+#define VI_INTST_inst_adr                                                            "0x009B"
+#define VI_INTST_inst                                                                0x009B
+#define VI_INTST_feints1_shift                                                       (14)
+#define VI_INTST_feints1_mask                                                        (0x00004000)
+#define VI_INTST_feints1(data)                                                       (0x00004000&((data)<<14))
+#define VI_INTST_feints1_src(data)                                                   ((0x00004000&(data))>>14)
+#define VI_INTST_get_feints1(data)                                                   ((0x00004000&(data))>>14)
+#define VI_INTST_feints2_shift                                                       (13)
+#define VI_INTST_feints2_mask                                                        (0x00002000)
+#define VI_INTST_feints2(data)                                                       (0x00002000&((data)<<13))
+#define VI_INTST_feints2_src(data)                                                   ((0x00002000&(data))>>13)
+#define VI_INTST_get_feints2(data)                                                   ((0x00002000&(data))>>13)
+#define VI_INTST_hdolints1_shift                                                     (12)
+#define VI_INTST_hdolints1_mask                                                      (0x00001000)
+#define VI_INTST_hdolints1(data)                                                     (0x00001000&((data)<<12))
+#define VI_INTST_hdolints1_src(data)                                                 ((0x00001000&(data))>>12)
+#define VI_INTST_get_hdolints1(data)                                                 ((0x00001000&(data))>>12)
+#define VI_INTST_hdolints2_shift                                                     (11)
+#define VI_INTST_hdolints2_mask                                                      (0x00000800)
+#define VI_INTST_hdolints2(data)                                                     (0x00000800&((data)<<11))
+#define VI_INTST_hdolints2_src(data)                                                 ((0x00000800&(data))>>11)
+#define VI_INTST_get_hdolints2(data)                                                 ((0x00000800&(data))>>11)
+#define VI_INTST_dmaerrints_shift                                                    (10)
+#define VI_INTST_dmaerrints_mask                                                     (0x00000400)
+#define VI_INTST_dmaerrints(data)                                                    (0x00000400&((data)<<10))
+#define VI_INTST_dmaerrints_src(data)                                                ((0x00000400&(data))>>10)
+#define VI_INTST_get_dmaerrints(data)                                                ((0x00000400&(data))>>10)
+#define VI_INTST_sfints1_shift                                                       (8)
+#define VI_INTST_sfints1_mask                                                        (0x00000100)
+#define VI_INTST_sfints1(data)                                                       (0x00000100&((data)<<8))
+#define VI_INTST_sfints1_src(data)                                                   ((0x00000100&(data))>>8)
+#define VI_INTST_get_sfints1(data)                                                   ((0x00000100&(data))>>8)
+#define VI_INTST_sfints2_shift                                                       (7)
+#define VI_INTST_sfints2_mask                                                        (0x00000080)
+#define VI_INTST_sfints2(data)                                                       (0x00000080&((data)<<7))
+#define VI_INTST_sfints2_src(data)                                                   ((0x00000080&(data))>>7)
+#define VI_INTST_get_sfints2(data)                                                   ((0x00000080&(data))>>7)
+#define VI_INTST_vsints1_shift                                                       (6)
+#define VI_INTST_vsints1_mask                                                        (0x00000040)
+#define VI_INTST_vsints1(data)                                                       (0x00000040&((data)<<6))
+#define VI_INTST_vsints1_src(data)                                                   ((0x00000040&(data))>>6)
+#define VI_INTST_get_vsints1(data)                                                   ((0x00000040&(data))>>6)
+#define VI_INTST_vsints2_shift                                                       (5)
+#define VI_INTST_vsints2_mask                                                        (0x00000020)
+#define VI_INTST_vsints2(data)                                                       (0x00000020&((data)<<5))
+#define VI_INTST_vsints2_src(data)                                                   ((0x00000020&(data))>>5)
+#define VI_INTST_get_vsints2(data)                                                   ((0x00000020&(data))>>5)
+#define VI_INTST_toints1_shift                                                       (4)
+#define VI_INTST_toints1_mask                                                        (0x00000010)
+#define VI_INTST_toints1(data)                                                       (0x00000010&((data)<<4))
+#define VI_INTST_toints1_src(data)                                                   ((0x00000010&(data))>>4)
+#define VI_INTST_get_toints1(data)                                                   ((0x00000010&(data))>>4)
+#define VI_INTST_toints2_shift                                                       (3)
+#define VI_INTST_toints2_mask                                                        (0x00000008)
+#define VI_INTST_toints2(data)                                                       (0x00000008&((data)<<3))
+#define VI_INTST_toints2_src(data)                                                   ((0x00000008&(data))>>3)
+#define VI_INTST_get_toints2(data)                                                   ((0x00000008&(data))>>3)
+#define VI_INTST_olints1_shift                                                       (2)
+#define VI_INTST_olints1_mask                                                        (0x00000004)
+#define VI_INTST_olints1(data)                                                       (0x00000004&((data)<<2))
+#define VI_INTST_olints1_src(data)                                                   ((0x00000004&(data))>>2)
+#define VI_INTST_get_olints1(data)                                                   ((0x00000004&(data))>>2)
+#define VI_INTST_olints2_shift                                                       (1)
+#define VI_INTST_olints2_mask                                                        (0x00000002)
+#define VI_INTST_olints2(data)                                                       (0x00000002&((data)<<1))
+#define VI_INTST_olints2_src(data)                                                   ((0x00000002&(data))>>1)
+#define VI_INTST_get_olints2(data)                                                   ((0x00000002&(data))>>1)
+#define VI_INTST_write_data_shift                                                    (0)
+#define VI_INTST_write_data_mask                                                     (0x00000001)
+#define VI_INTST_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VI_INTST_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VI_INTST_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VI_OLN1                                                                      0x18004270
+#define VI_OLN1_reg_addr                                                             "0xB8004270"
+#define VI_OLN1_reg                                                                  0xB8004270
+#define VI_OLN1_inst_adr                                                             "0x009C"
+#define VI_OLN1_inst                                                                 0x009C
+#define VI_OLN1_write_enable1_shift                                                  (23)
+#define VI_OLN1_write_enable1_mask                                                   (0x00800000)
+#define VI_OLN1_write_enable1(data)                                                  (0x00800000&((data)<<23))
+#define VI_OLN1_write_enable1_src(data)                                              ((0x00800000&(data))>>23)
+#define VI_OLN1_get_write_enable1(data)                                              ((0x00800000&(data))>>23)
+#define VI_OLN1_y_shift                                                              (12)
+#define VI_OLN1_y_mask                                                               (0x007FF000)
+#define VI_OLN1_y(data)                                                              (0x007FF000&((data)<<12))
+#define VI_OLN1_y_src(data)                                                          ((0x007FF000&(data))>>12)
+#define VI_OLN1_get_y(data)                                                          ((0x007FF000&(data))>>12)
+#define VI_OLN1_write_enable2_shift                                                  (11)
+#define VI_OLN1_write_enable2_mask                                                   (0x00000800)
+#define VI_OLN1_write_enable2(data)                                                  (0x00000800&((data)<<11))
+#define VI_OLN1_write_enable2_src(data)                                              ((0x00000800&(data))>>11)
+#define VI_OLN1_get_write_enable2(data)                                              ((0x00000800&(data))>>11)
+#define VI_OLN1_c_shift                                                              (0)
+#define VI_OLN1_c_mask                                                               (0x000007FF)
+#define VI_OLN1_c(data)                                                              (0x000007FF&((data)<<0))
+#define VI_OLN1_c_src(data)                                                          ((0x000007FF&(data))>>0)
+#define VI_OLN1_get_c(data)                                                          ((0x000007FF&(data))>>0)
+
+
+#define VI_OLN2                                                                      0x18004274
+#define VI_OLN2_reg_addr                                                             "0xB8004274"
+#define VI_OLN2_reg                                                                  0xB8004274
+#define VI_OLN2_inst_adr                                                             "0x009D"
+#define VI_OLN2_inst                                                                 0x009D
+#define VI_OLN2_write_enable1_shift                                                  (23)
+#define VI_OLN2_write_enable1_mask                                                   (0x00800000)
+#define VI_OLN2_write_enable1(data)                                                  (0x00800000&((data)<<23))
+#define VI_OLN2_write_enable1_src(data)                                              ((0x00800000&(data))>>23)
+#define VI_OLN2_get_write_enable1(data)                                              ((0x00800000&(data))>>23)
+#define VI_OLN2_y_shift                                                              (12)
+#define VI_OLN2_y_mask                                                               (0x007FF000)
+#define VI_OLN2_y(data)                                                              (0x007FF000&((data)<<12))
+#define VI_OLN2_y_src(data)                                                          ((0x007FF000&(data))>>12)
+#define VI_OLN2_get_y(data)                                                          ((0x007FF000&(data))>>12)
+#define VI_OLN2_write_enable2_shift                                                  (11)
+#define VI_OLN2_write_enable2_mask                                                   (0x00000800)
+#define VI_OLN2_write_enable2(data)                                                  (0x00000800&((data)<<11))
+#define VI_OLN2_write_enable2_src(data)                                              ((0x00000800&(data))>>11)
+#define VI_OLN2_get_write_enable2(data)                                              ((0x00000800&(data))>>11)
+#define VI_OLN2_c_shift                                                              (0)
+#define VI_OLN2_c_mask                                                               (0x000007FF)
+#define VI_OLN2_c(data)                                                              (0x000007FF&((data)<<0))
+#define VI_OLN2_c_src(data)                                                          ((0x000007FF&(data))>>0)
+#define VI_OLN2_get_c(data)                                                          ((0x000007FF&(data))>>0)
+
+
+#define VI_HDOLN1                                                                    0x18004494
+#define VI_HDOLN1_reg_addr                                                           "0xB8004494"
+#define VI_HDOLN1_reg                                                                0xB8004494
+#define VI_HDOLN1_inst_adr                                                           "0x0025"
+#define VI_HDOLN1_inst                                                               0x0025
+#define VI_HDOLN1_write_enable1_shift                                                (23)
+#define VI_HDOLN1_write_enable1_mask                                                 (0x00800000)
+#define VI_HDOLN1_write_enable1(data)                                                (0x00800000&((data)<<23))
+#define VI_HDOLN1_write_enable1_src(data)                                            ((0x00800000&(data))>>23)
+#define VI_HDOLN1_get_write_enable1(data)                                            ((0x00800000&(data))>>23)
+#define VI_HDOLN1_y_shift                                                            (12)
+#define VI_HDOLN1_y_mask                                                             (0x007FF000)
+#define VI_HDOLN1_y(data)                                                            (0x007FF000&((data)<<12))
+#define VI_HDOLN1_y_src(data)                                                        ((0x007FF000&(data))>>12)
+#define VI_HDOLN1_get_y(data)                                                        ((0x007FF000&(data))>>12)
+#define VI_HDOLN1_write_enable2_shift                                                (11)
+#define VI_HDOLN1_write_enable2_mask                                                 (0x00000800)
+#define VI_HDOLN1_write_enable2(data)                                                (0x00000800&((data)<<11))
+#define VI_HDOLN1_write_enable2_src(data)                                            ((0x00000800&(data))>>11)
+#define VI_HDOLN1_get_write_enable2(data)                                            ((0x00000800&(data))>>11)
+#define VI_HDOLN1_c_shift                                                            (0)
+#define VI_HDOLN1_c_mask                                                             (0x000007FF)
+#define VI_HDOLN1_c(data)                                                            (0x000007FF&((data)<<0))
+#define VI_HDOLN1_c_src(data)                                                        ((0x000007FF&(data))>>0)
+#define VI_HDOLN1_get_c(data)                                                        ((0x000007FF&(data))>>0)
+
+
+#define VI_HDOLN2                                                                    0x18004498
+#define VI_HDOLN2_reg_addr                                                           "0xB8004498"
+#define VI_HDOLN2_reg                                                                0xB8004498
+#define VI_HDOLN2_inst_adr                                                           "0x0026"
+#define VI_HDOLN2_inst                                                               0x0026
+#define VI_HDOLN2_write_enable1_shift                                                (23)
+#define VI_HDOLN2_write_enable1_mask                                                 (0x00800000)
+#define VI_HDOLN2_write_enable1(data)                                                (0x00800000&((data)<<23))
+#define VI_HDOLN2_write_enable1_src(data)                                            ((0x00800000&(data))>>23)
+#define VI_HDOLN2_get_write_enable1(data)                                            ((0x00800000&(data))>>23)
+#define VI_HDOLN2_y_shift                                                            (12)
+#define VI_HDOLN2_y_mask                                                             (0x007FF000)
+#define VI_HDOLN2_y(data)                                                            (0x007FF000&((data)<<12))
+#define VI_HDOLN2_y_src(data)                                                        ((0x007FF000&(data))>>12)
+#define VI_HDOLN2_get_y(data)                                                        ((0x007FF000&(data))>>12)
+#define VI_HDOLN2_write_enable2_shift                                                (11)
+#define VI_HDOLN2_write_enable2_mask                                                 (0x00000800)
+#define VI_HDOLN2_write_enable2(data)                                                (0x00000800&((data)<<11))
+#define VI_HDOLN2_write_enable2_src(data)                                            ((0x00000800&(data))>>11)
+#define VI_HDOLN2_get_write_enable2(data)                                            ((0x00000800&(data))>>11)
+#define VI_HDOLN2_c_shift                                                            (0)
+#define VI_HDOLN2_c_mask                                                             (0x000007FF)
+#define VI_HDOLN2_c(data)                                                            (0x000007FF&((data)<<0))
+#define VI_HDOLN2_c_src(data)                                                        ((0x000007FF&(data))>>0)
+#define VI_HDOLN2_get_c(data)                                                        ((0x000007FF&(data))>>0)
+
+
+#define VI_OLNCNT1                                                                   0x18004278
+#define VI_OLNCNT1_reg_addr                                                          "0xB8004278"
+#define VI_OLNCNT1_reg                                                               0xB8004278
+#define VI_OLNCNT1_inst_adr                                                          "0x009E"
+#define VI_OLNCNT1_inst                                                              0x009E
+#define VI_OLNCNT1_y_shift                                                           (11)
+#define VI_OLNCNT1_y_mask                                                            (0x003FF800)
+#define VI_OLNCNT1_y(data)                                                           (0x003FF800&((data)<<11))
+#define VI_OLNCNT1_y_src(data)                                                       ((0x003FF800&(data))>>11)
+#define VI_OLNCNT1_get_y(data)                                                       ((0x003FF800&(data))>>11)
+#define VI_OLNCNT1_c_shift                                                           (0)
+#define VI_OLNCNT1_c_mask                                                            (0x000007FF)
+#define VI_OLNCNT1_c(data)                                                           (0x000007FF&((data)<<0))
+#define VI_OLNCNT1_c_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VI_OLNCNT1_get_c(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VI_OLNCNT2                                                                   0x1800427c
+#define VI_OLNCNT2_reg_addr                                                          "0xB800427C"
+#define VI_OLNCNT2_reg                                                               0xB800427C
+#define VI_OLNCNT2_inst_adr                                                          "0x009F"
+#define VI_OLNCNT2_inst                                                              0x009F
+#define VI_OLNCNT2_y_shift                                                           (11)
+#define VI_OLNCNT2_y_mask                                                            (0x003FF800)
+#define VI_OLNCNT2_y(data)                                                           (0x003FF800&((data)<<11))
+#define VI_OLNCNT2_y_src(data)                                                       ((0x003FF800&(data))>>11)
+#define VI_OLNCNT2_get_y(data)                                                       ((0x003FF800&(data))>>11)
+#define VI_OLNCNT2_c_shift                                                           (0)
+#define VI_OLNCNT2_c_mask                                                            (0x000007FF)
+#define VI_OLNCNT2_c(data)                                                           (0x000007FF&((data)<<0))
+#define VI_OLNCNT2_c_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VI_OLNCNT2_get_c(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VI_HDOLNCNT1                                                                 0x1800449c
+#define VI_HDOLNCNT1_reg_addr                                                        "0xB800449C"
+#define VI_HDOLNCNT1_reg                                                             0xB800449C
+#define VI_HDOLNCNT1_inst_adr                                                        "0x0027"
+#define VI_HDOLNCNT1_inst                                                            0x0027
+#define VI_HDOLNCNT1_y_shift                                                         (11)
+#define VI_HDOLNCNT1_y_mask                                                          (0x003FF800)
+#define VI_HDOLNCNT1_y(data)                                                         (0x003FF800&((data)<<11))
+#define VI_HDOLNCNT1_y_src(data)                                                     ((0x003FF800&(data))>>11)
+#define VI_HDOLNCNT1_get_y(data)                                                     ((0x003FF800&(data))>>11)
+#define VI_HDOLNCNT1_c_shift                                                         (0)
+#define VI_HDOLNCNT1_c_mask                                                          (0x000007FF)
+#define VI_HDOLNCNT1_c(data)                                                         (0x000007FF&((data)<<0))
+#define VI_HDOLNCNT1_c_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VI_HDOLNCNT1_get_c(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VI_HDOLNCNT2                                                                 0x180044a0
+#define VI_HDOLNCNT2_reg_addr                                                        "0xB80044A0"
+#define VI_HDOLNCNT2_reg                                                             0xB80044A0
+#define VI_HDOLNCNT2_inst_adr                                                        "0x0028"
+#define VI_HDOLNCNT2_inst                                                            0x0028
+#define VI_HDOLNCNT2_y_shift                                                         (11)
+#define VI_HDOLNCNT2_y_mask                                                          (0x003FF800)
+#define VI_HDOLNCNT2_y(data)                                                         (0x003FF800&((data)<<11))
+#define VI_HDOLNCNT2_y_src(data)                                                     ((0x003FF800&(data))>>11)
+#define VI_HDOLNCNT2_get_y(data)                                                     ((0x003FF800&(data))>>11)
+#define VI_HDOLNCNT2_c_shift                                                         (0)
+#define VI_HDOLNCNT2_c_mask                                                          (0x000007FF)
+#define VI_HDOLNCNT2_c(data)                                                         (0x000007FF&((data)<<0))
+#define VI_HDOLNCNT2_c_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VI_HDOLNCNT2_get_c(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VI_GCTL                                                                      0x18004280
+#define VI_GCTL_reg_addr                                                             "0xB8004280"
+#define VI_GCTL_reg                                                                  0xB8004280
+#define VI_GCTL_inst_adr                                                             "0x00A0"
+#define VI_GCTL_inst                                                                 0x00A0
+#define VI_GCTL_write_enable3_shift                                                  (7)
+#define VI_GCTL_write_enable3_mask                                                   (0x00000080)
+#define VI_GCTL_write_enable3(data)                                                  (0x00000080&((data)<<7))
+#define VI_GCTL_write_enable3_src(data)                                              ((0x00000080&(data))>>7)
+#define VI_GCTL_get_write_enable3(data)                                              ((0x00000080&(data))>>7)
+#define VI_GCTL_vsce1_shift                                                          (6)
+#define VI_GCTL_vsce1_mask                                                           (0x00000040)
+#define VI_GCTL_vsce1(data)                                                          (0x00000040&((data)<<6))
+#define VI_GCTL_vsce1_src(data)                                                      ((0x00000040&(data))>>6)
+#define VI_GCTL_get_vsce1(data)                                                      ((0x00000040&(data))>>6)
+#define VI_GCTL_write_enable4_shift                                                  (5)
+#define VI_GCTL_write_enable4_mask                                                   (0x00000020)
+#define VI_GCTL_write_enable4(data)                                                  (0x00000020&((data)<<5))
+#define VI_GCTL_write_enable4_src(data)                                              ((0x00000020&(data))>>5)
+#define VI_GCTL_get_write_enable4(data)                                              ((0x00000020&(data))>>5)
+#define VI_GCTL_vsce2_shift                                                          (4)
+#define VI_GCTL_vsce2_mask                                                           (0x00000010)
+#define VI_GCTL_vsce2(data)                                                          (0x00000010&((data)<<4))
+#define VI_GCTL_vsce2_src(data)                                                      ((0x00000010&(data))>>4)
+#define VI_GCTL_get_vsce2(data)                                                      ((0x00000010&(data))>>4)
+#define VI_GCTL_write_enable7_shift                                                  (3)
+#define VI_GCTL_write_enable7_mask                                                   (0x00000008)
+#define VI_GCTL_write_enable7(data)                                                  (0x00000008&((data)<<3))
+#define VI_GCTL_write_enable7_src(data)                                              ((0x00000008&(data))>>3)
+#define VI_GCTL_get_write_enable7(data)                                              ((0x00000008&(data))>>3)
+#define VI_GCTL_hdvsce1_shift                                                        (2)
+#define VI_GCTL_hdvsce1_mask                                                         (0x00000004)
+#define VI_GCTL_hdvsce1(data)                                                        (0x00000004&((data)<<2))
+#define VI_GCTL_hdvsce1_src(data)                                                    ((0x00000004&(data))>>2)
+#define VI_GCTL_get_hdvsce1(data)                                                    ((0x00000004&(data))>>2)
+#define VI_GCTL_write_enable8_shift                                                  (1)
+#define VI_GCTL_write_enable8_mask                                                   (0x00000002)
+#define VI_GCTL_write_enable8(data)                                                  (0x00000002&((data)<<1))
+#define VI_GCTL_write_enable8_src(data)                                              ((0x00000002&(data))>>1)
+#define VI_GCTL_get_write_enable8(data)                                              ((0x00000002&(data))>>1)
+#define VI_GCTL_hdvsce2_shift                                                        (0)
+#define VI_GCTL_hdvsce2_mask                                                         (0x00000001)
+#define VI_GCTL_hdvsce2(data)                                                        (0x00000001&((data)<<0))
+#define VI_GCTL_hdvsce2_src(data)                                                    ((0x00000001&(data))>>0)
+#define VI_GCTL_get_hdvsce2(data)                                                    ((0x00000001&(data))>>0)
+
+
+#define VI_DYNAMIC_P                                                                 0x18004530
+#define VI_DYNAMIC_P_reg_addr                                                        "0xB8004530"
+#define VI_DYNAMIC_P_reg                                                             0xB8004530
+#define VI_DYNAMIC_P_inst_adr                                                        "0x004C"
+#define VI_DYNAMIC_P_inst                                                            0x004C
+#define VI_DYNAMIC_P_write_enable1_shift                                             (1)
+#define VI_DYNAMIC_P_write_enable1_mask                                              (0x00000002)
+#define VI_DYNAMIC_P_write_enable1(data)                                             (0x00000002&((data)<<1))
+#define VI_DYNAMIC_P_write_enable1_src(data)                                         ((0x00000002&(data))>>1)
+#define VI_DYNAMIC_P_get_write_enable1(data)                                         ((0x00000002&(data))>>1)
+#define VI_DYNAMIC_P_enable_shift                                                    (0)
+#define VI_DYNAMIC_P_enable_mask                                                     (0x00000001)
+#define VI_DYNAMIC_P_enable(data)                                                    (0x00000001&((data)<<0))
+#define VI_DYNAMIC_P_enable_src(data)                                                ((0x00000001&(data))>>0)
+#define VI_DYNAMIC_P_get_enable(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VI_Y1OBUFF                                                                   0x18004534
+#define VI_Y1OBUFF_reg_addr                                                          "0xB8004534"
+#define VI_Y1OBUFF_reg                                                               0xB8004534
+#define VI_Y1OBUFF_inst_adr                                                          "0x004D"
+#define VI_Y1OBUFF_inst                                                              0x004D
+#define VI_Y1OBUFF_write_enable1_shift                                               (17)
+#define VI_Y1OBUFF_write_enable1_mask                                                (0x00020000)
+#define VI_Y1OBUFF_write_enable1(data)                                               (0x00020000&((data)<<17))
+#define VI_Y1OBUFF_write_enable1_src(data)                                           ((0x00020000&(data))>>17)
+#define VI_Y1OBUFF_get_write_enable1(data)                                           ((0x00020000&(data))>>17)
+#define VI_Y1OBUFF_start_shift                                                       (9)
+#define VI_Y1OBUFF_start_mask                                                        (0x0001FE00)
+#define VI_Y1OBUFF_start(data)                                                       (0x0001FE00&((data)<<9))
+#define VI_Y1OBUFF_start_src(data)                                                   ((0x0001FE00&(data))>>9)
+#define VI_Y1OBUFF_get_start(data)                                                   ((0x0001FE00&(data))>>9)
+#define VI_Y1OBUFF_write_enable2_shift                                               (8)
+#define VI_Y1OBUFF_write_enable2_mask                                                (0x00000100)
+#define VI_Y1OBUFF_write_enable2(data)                                               (0x00000100&((data)<<8))
+#define VI_Y1OBUFF_write_enable2_src(data)                                           ((0x00000100&(data))>>8)
+#define VI_Y1OBUFF_get_write_enable2(data)                                           ((0x00000100&(data))>>8)
+#define VI_Y1OBUFF_end_shift                                                         (0)
+#define VI_Y1OBUFF_end_mask                                                          (0x000000FF)
+#define VI_Y1OBUFF_end(data)                                                         (0x000000FF&((data)<<0))
+#define VI_Y1OBUFF_end_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VI_Y1OBUFF_get_end(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VI_Y2OBUFF                                                                   0x18004538
+#define VI_Y2OBUFF_reg_addr                                                          "0xB8004538"
+#define VI_Y2OBUFF_reg                                                               0xB8004538
+#define VI_Y2OBUFF_inst_adr                                                          "0x004E"
+#define VI_Y2OBUFF_inst                                                              0x004E
+#define VI_Y2OBUFF_write_enable1_shift                                               (17)
+#define VI_Y2OBUFF_write_enable1_mask                                                (0x00020000)
+#define VI_Y2OBUFF_write_enable1(data)                                               (0x00020000&((data)<<17))
+#define VI_Y2OBUFF_write_enable1_src(data)                                           ((0x00020000&(data))>>17)
+#define VI_Y2OBUFF_get_write_enable1(data)                                           ((0x00020000&(data))>>17)
+#define VI_Y2OBUFF_start_shift                                                       (9)
+#define VI_Y2OBUFF_start_mask                                                        (0x0001FE00)
+#define VI_Y2OBUFF_start(data)                                                       (0x0001FE00&((data)<<9))
+#define VI_Y2OBUFF_start_src(data)                                                   ((0x0001FE00&(data))>>9)
+#define VI_Y2OBUFF_get_start(data)                                                   ((0x0001FE00&(data))>>9)
+#define VI_Y2OBUFF_write_enable2_shift                                               (8)
+#define VI_Y2OBUFF_write_enable2_mask                                                (0x00000100)
+#define VI_Y2OBUFF_write_enable2(data)                                               (0x00000100&((data)<<8))
+#define VI_Y2OBUFF_write_enable2_src(data)                                           ((0x00000100&(data))>>8)
+#define VI_Y2OBUFF_get_write_enable2(data)                                           ((0x00000100&(data))>>8)
+#define VI_Y2OBUFF_end_shift                                                         (0)
+#define VI_Y2OBUFF_end_mask                                                          (0x000000FF)
+#define VI_Y2OBUFF_end(data)                                                         (0x000000FF&((data)<<0))
+#define VI_Y2OBUFF_end_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VI_Y2OBUFF_get_end(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VI_C1OBUFF                                                                   0x1800453c
+#define VI_C1OBUFF_reg_addr                                                          "0xB800453C"
+#define VI_C1OBUFF_reg                                                               0xB800453C
+#define VI_C1OBUFF_inst_adr                                                          "0x004F"
+#define VI_C1OBUFF_inst                                                              0x004F
+#define VI_C1OBUFF_write_enable1_shift                                               (17)
+#define VI_C1OBUFF_write_enable1_mask                                                (0x00020000)
+#define VI_C1OBUFF_write_enable1(data)                                               (0x00020000&((data)<<17))
+#define VI_C1OBUFF_write_enable1_src(data)                                           ((0x00020000&(data))>>17)
+#define VI_C1OBUFF_get_write_enable1(data)                                           ((0x00020000&(data))>>17)
+#define VI_C1OBUFF_start_shift                                                       (9)
+#define VI_C1OBUFF_start_mask                                                        (0x0001FE00)
+#define VI_C1OBUFF_start(data)                                                       (0x0001FE00&((data)<<9))
+#define VI_C1OBUFF_start_src(data)                                                   ((0x0001FE00&(data))>>9)
+#define VI_C1OBUFF_get_start(data)                                                   ((0x0001FE00&(data))>>9)
+#define VI_C1OBUFF_write_enable2_shift                                               (8)
+#define VI_C1OBUFF_write_enable2_mask                                                (0x00000100)
+#define VI_C1OBUFF_write_enable2(data)                                               (0x00000100&((data)<<8))
+#define VI_C1OBUFF_write_enable2_src(data)                                           ((0x00000100&(data))>>8)
+#define VI_C1OBUFF_get_write_enable2(data)                                           ((0x00000100&(data))>>8)
+#define VI_C1OBUFF_end_shift                                                         (0)
+#define VI_C1OBUFF_end_mask                                                          (0x000000FF)
+#define VI_C1OBUFF_end(data)                                                         (0x000000FF&((data)<<0))
+#define VI_C1OBUFF_end_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VI_C1OBUFF_get_end(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VI_C2OBUFF                                                                   0x18004540
+#define VI_C2OBUFF_reg_addr                                                          "0xB8004540"
+#define VI_C2OBUFF_reg                                                               0xB8004540
+#define VI_C2OBUFF_inst_adr                                                          "0x0050"
+#define VI_C2OBUFF_inst                                                              0x0050
+#define VI_C2OBUFF_write_enable1_shift                                               (17)
+#define VI_C2OBUFF_write_enable1_mask                                                (0x00020000)
+#define VI_C2OBUFF_write_enable1(data)                                               (0x00020000&((data)<<17))
+#define VI_C2OBUFF_write_enable1_src(data)                                           ((0x00020000&(data))>>17)
+#define VI_C2OBUFF_get_write_enable1(data)                                           ((0x00020000&(data))>>17)
+#define VI_C2OBUFF_start_shift                                                       (9)
+#define VI_C2OBUFF_start_mask                                                        (0x0001FE00)
+#define VI_C2OBUFF_start(data)                                                       (0x0001FE00&((data)<<9))
+#define VI_C2OBUFF_start_src(data)                                                   ((0x0001FE00&(data))>>9)
+#define VI_C2OBUFF_get_start(data)                                                   ((0x0001FE00&(data))>>9)
+#define VI_C2OBUFF_write_enable2_shift                                               (8)
+#define VI_C2OBUFF_write_enable2_mask                                                (0x00000100)
+#define VI_C2OBUFF_write_enable2(data)                                               (0x00000100&((data)<<8))
+#define VI_C2OBUFF_write_enable2_src(data)                                           ((0x00000100&(data))>>8)
+#define VI_C2OBUFF_get_write_enable2(data)                                           ((0x00000100&(data))>>8)
+#define VI_C2OBUFF_end_shift                                                         (0)
+#define VI_C2OBUFF_end_mask                                                          (0x000000FF)
+#define VI_C2OBUFF_end(data)                                                         (0x000000FF&((data)<<0))
+#define VI_C2OBUFF_end_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VI_C2OBUFF_get_end(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VI_VBI1OBUFF                                                                 0x18004544
+#define VI_VBI1OBUFF_reg_addr                                                        "0xB8004544"
+#define VI_VBI1OBUFF_reg                                                             0xB8004544
+#define VI_VBI1OBUFF_inst_adr                                                        "0x0051"
+#define VI_VBI1OBUFF_inst                                                            0x0051
+#define VI_VBI1OBUFF_write_enable1_shift                                             (17)
+#define VI_VBI1OBUFF_write_enable1_mask                                              (0x00020000)
+#define VI_VBI1OBUFF_write_enable1(data)                                             (0x00020000&((data)<<17))
+#define VI_VBI1OBUFF_write_enable1_src(data)                                         ((0x00020000&(data))>>17)
+#define VI_VBI1OBUFF_get_write_enable1(data)                                         ((0x00020000&(data))>>17)
+#define VI_VBI1OBUFF_start_shift                                                     (9)
+#define VI_VBI1OBUFF_start_mask                                                      (0x0001FE00)
+#define VI_VBI1OBUFF_start(data)                                                     (0x0001FE00&((data)<<9))
+#define VI_VBI1OBUFF_start_src(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_VBI1OBUFF_get_start(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_VBI1OBUFF_write_enable2_shift                                             (8)
+#define VI_VBI1OBUFF_write_enable2_mask                                              (0x00000100)
+#define VI_VBI1OBUFF_write_enable2(data)                                             (0x00000100&((data)<<8))
+#define VI_VBI1OBUFF_write_enable2_src(data)                                         ((0x00000100&(data))>>8)
+#define VI_VBI1OBUFF_get_write_enable2(data)                                         ((0x00000100&(data))>>8)
+#define VI_VBI1OBUFF_end_shift                                                       (0)
+#define VI_VBI1OBUFF_end_mask                                                        (0x000000FF)
+#define VI_VBI1OBUFF_end(data)                                                       (0x000000FF&((data)<<0))
+#define VI_VBI1OBUFF_end_src(data)                                                   ((0x000000FF&(data))>>0)
+#define VI_VBI1OBUFF_get_end(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define VI_VBI2OBUFF                                                                 0x18004548
+#define VI_VBI2OBUFF_reg_addr                                                        "0xB8004548"
+#define VI_VBI2OBUFF_reg                                                             0xB8004548
+#define VI_VBI2OBUFF_inst_adr                                                        "0x0052"
+#define VI_VBI2OBUFF_inst                                                            0x0052
+#define VI_VBI2OBUFF_write_enable1_shift                                             (17)
+#define VI_VBI2OBUFF_write_enable1_mask                                              (0x00020000)
+#define VI_VBI2OBUFF_write_enable1(data)                                             (0x00020000&((data)<<17))
+#define VI_VBI2OBUFF_write_enable1_src(data)                                         ((0x00020000&(data))>>17)
+#define VI_VBI2OBUFF_get_write_enable1(data)                                         ((0x00020000&(data))>>17)
+#define VI_VBI2OBUFF_start_shift                                                     (9)
+#define VI_VBI2OBUFF_start_mask                                                      (0x0001FE00)
+#define VI_VBI2OBUFF_start(data)                                                     (0x0001FE00&((data)<<9))
+#define VI_VBI2OBUFF_start_src(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_VBI2OBUFF_get_start(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_VBI2OBUFF_write_enable2_shift                                             (8)
+#define VI_VBI2OBUFF_write_enable2_mask                                              (0x00000100)
+#define VI_VBI2OBUFF_write_enable2(data)                                             (0x00000100&((data)<<8))
+#define VI_VBI2OBUFF_write_enable2_src(data)                                         ((0x00000100&(data))>>8)
+#define VI_VBI2OBUFF_get_write_enable2(data)                                         ((0x00000100&(data))>>8)
+#define VI_VBI2OBUFF_end_shift                                                       (0)
+#define VI_VBI2OBUFF_end_mask                                                        (0x000000FF)
+#define VI_VBI2OBUFF_end(data)                                                       (0x000000FF&((data)<<0))
+#define VI_VBI2OBUFF_end_src(data)                                                   ((0x000000FF&(data))>>0)
+#define VI_VBI2OBUFF_get_end(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define VI_DYOBUFF                                                                   0x1800454c
+#define VI_DYOBUFF_reg_addr                                                          "0xB800454C"
+#define VI_DYOBUFF_reg                                                               0xB800454C
+#define VI_DYOBUFF_inst_adr                                                          "0x0053"
+#define VI_DYOBUFF_inst                                                              0x0053
+#define VI_DYOBUFF_write_enable1_shift                                               (17)
+#define VI_DYOBUFF_write_enable1_mask                                                (0x00020000)
+#define VI_DYOBUFF_write_enable1(data)                                               (0x00020000&((data)<<17))
+#define VI_DYOBUFF_write_enable1_src(data)                                           ((0x00020000&(data))>>17)
+#define VI_DYOBUFF_get_write_enable1(data)                                           ((0x00020000&(data))>>17)
+#define VI_DYOBUFF_start_shift                                                       (9)
+#define VI_DYOBUFF_start_mask                                                        (0x0001FE00)
+#define VI_DYOBUFF_start(data)                                                       (0x0001FE00&((data)<<9))
+#define VI_DYOBUFF_start_src(data)                                                   ((0x0001FE00&(data))>>9)
+#define VI_DYOBUFF_get_start(data)                                                   ((0x0001FE00&(data))>>9)
+#define VI_DYOBUFF_write_enable2_shift                                               (8)
+#define VI_DYOBUFF_write_enable2_mask                                                (0x00000100)
+#define VI_DYOBUFF_write_enable2(data)                                               (0x00000100&((data)<<8))
+#define VI_DYOBUFF_write_enable2_src(data)                                           ((0x00000100&(data))>>8)
+#define VI_DYOBUFF_get_write_enable2(data)                                           ((0x00000100&(data))>>8)
+#define VI_DYOBUFF_end_shift                                                         (0)
+#define VI_DYOBUFF_end_mask                                                          (0x000000FF)
+#define VI_DYOBUFF_end(data)                                                         (0x000000FF&((data)<<0))
+#define VI_DYOBUFF_end_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VI_DYOBUFF_get_end(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VI_DYEXTOBUFF                                                                0x18004550
+#define VI_DYEXTOBUFF_reg_addr                                                       "0xB8004550"
+#define VI_DYEXTOBUFF_reg                                                            0xB8004550
+#define VI_DYEXTOBUFF_inst_adr                                                       "0x0054"
+#define VI_DYEXTOBUFF_inst                                                           0x0054
+#define VI_DYEXTOBUFF_write_enable1_shift                                            (17)
+#define VI_DYEXTOBUFF_write_enable1_mask                                             (0x00020000)
+#define VI_DYEXTOBUFF_write_enable1(data)                                            (0x00020000&((data)<<17))
+#define VI_DYEXTOBUFF_write_enable1_src(data)                                        ((0x00020000&(data))>>17)
+#define VI_DYEXTOBUFF_get_write_enable1(data)                                        ((0x00020000&(data))>>17)
+#define VI_DYEXTOBUFF_start_shift                                                    (9)
+#define VI_DYEXTOBUFF_start_mask                                                     (0x0001FE00)
+#define VI_DYEXTOBUFF_start(data)                                                    (0x0001FE00&((data)<<9))
+#define VI_DYEXTOBUFF_start_src(data)                                                ((0x0001FE00&(data))>>9)
+#define VI_DYEXTOBUFF_get_start(data)                                                ((0x0001FE00&(data))>>9)
+#define VI_DYEXTOBUFF_write_enable2_shift                                            (8)
+#define VI_DYEXTOBUFF_write_enable2_mask                                             (0x00000100)
+#define VI_DYEXTOBUFF_write_enable2(data)                                            (0x00000100&((data)<<8))
+#define VI_DYEXTOBUFF_write_enable2_src(data)                                        ((0x00000100&(data))>>8)
+#define VI_DYEXTOBUFF_get_write_enable2(data)                                        ((0x00000100&(data))>>8)
+#define VI_DYEXTOBUFF_end_shift                                                      (0)
+#define VI_DYEXTOBUFF_end_mask                                                       (0x000000FF)
+#define VI_DYEXTOBUFF_end(data)                                                      (0x000000FF&((data)<<0))
+#define VI_DYEXTOBUFF_end_src(data)                                                  ((0x000000FF&(data))>>0)
+#define VI_DYEXTOBUFF_get_end(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define VI_HDY1OBUFF                                                                 0x18004554
+#define VI_HDY1OBUFF_reg_addr                                                        "0xB8004554"
+#define VI_HDY1OBUFF_reg                                                             0xB8004554
+#define VI_HDY1OBUFF_inst_adr                                                        "0x0055"
+#define VI_HDY1OBUFF_inst                                                            0x0055
+#define VI_HDY1OBUFF_write_enable1_shift                                             (17)
+#define VI_HDY1OBUFF_write_enable1_mask                                              (0x00020000)
+#define VI_HDY1OBUFF_write_enable1(data)                                             (0x00020000&((data)<<17))
+#define VI_HDY1OBUFF_write_enable1_src(data)                                         ((0x00020000&(data))>>17)
+#define VI_HDY1OBUFF_get_write_enable1(data)                                         ((0x00020000&(data))>>17)
+#define VI_HDY1OBUFF_start_shift                                                     (9)
+#define VI_HDY1OBUFF_start_mask                                                      (0x0001FE00)
+#define VI_HDY1OBUFF_start(data)                                                     (0x0001FE00&((data)<<9))
+#define VI_HDY1OBUFF_start_src(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_HDY1OBUFF_get_start(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_HDY1OBUFF_write_enable2_shift                                             (8)
+#define VI_HDY1OBUFF_write_enable2_mask                                              (0x00000100)
+#define VI_HDY1OBUFF_write_enable2(data)                                             (0x00000100&((data)<<8))
+#define VI_HDY1OBUFF_write_enable2_src(data)                                         ((0x00000100&(data))>>8)
+#define VI_HDY1OBUFF_get_write_enable2(data)                                         ((0x00000100&(data))>>8)
+#define VI_HDY1OBUFF_end_shift                                                       (0)
+#define VI_HDY1OBUFF_end_mask                                                        (0x000000FF)
+#define VI_HDY1OBUFF_end(data)                                                       (0x000000FF&((data)<<0))
+#define VI_HDY1OBUFF_end_src(data)                                                   ((0x000000FF&(data))>>0)
+#define VI_HDY1OBUFF_get_end(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define VI_HDY2OBUFF                                                                 0x18004558
+#define VI_HDY2OBUFF_reg_addr                                                        "0xB8004558"
+#define VI_HDY2OBUFF_reg                                                             0xB8004558
+#define VI_HDY2OBUFF_inst_adr                                                        "0x0056"
+#define VI_HDY2OBUFF_inst                                                            0x0056
+#define VI_HDY2OBUFF_write_enable1_shift                                             (17)
+#define VI_HDY2OBUFF_write_enable1_mask                                              (0x00020000)
+#define VI_HDY2OBUFF_write_enable1(data)                                             (0x00020000&((data)<<17))
+#define VI_HDY2OBUFF_write_enable1_src(data)                                         ((0x00020000&(data))>>17)
+#define VI_HDY2OBUFF_get_write_enable1(data)                                         ((0x00020000&(data))>>17)
+#define VI_HDY2OBUFF_start_shift                                                     (9)
+#define VI_HDY2OBUFF_start_mask                                                      (0x0001FE00)
+#define VI_HDY2OBUFF_start(data)                                                     (0x0001FE00&((data)<<9))
+#define VI_HDY2OBUFF_start_src(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_HDY2OBUFF_get_start(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_HDY2OBUFF_write_enable2_shift                                             (8)
+#define VI_HDY2OBUFF_write_enable2_mask                                              (0x00000100)
+#define VI_HDY2OBUFF_write_enable2(data)                                             (0x00000100&((data)<<8))
+#define VI_HDY2OBUFF_write_enable2_src(data)                                         ((0x00000100&(data))>>8)
+#define VI_HDY2OBUFF_get_write_enable2(data)                                         ((0x00000100&(data))>>8)
+#define VI_HDY2OBUFF_end_shift                                                       (0)
+#define VI_HDY2OBUFF_end_mask                                                        (0x000000FF)
+#define VI_HDY2OBUFF_end(data)                                                       (0x000000FF&((data)<<0))
+#define VI_HDY2OBUFF_end_src(data)                                                   ((0x000000FF&(data))>>0)
+#define VI_HDY2OBUFF_get_end(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define VI_HDC1OBUFF                                                                 0x1800455c
+#define VI_HDC1OBUFF_reg_addr                                                        "0xB800455C"
+#define VI_HDC1OBUFF_reg                                                             0xB800455C
+#define VI_HDC1OBUFF_inst_adr                                                        "0x0057"
+#define VI_HDC1OBUFF_inst                                                            0x0057
+#define VI_HDC1OBUFF_write_enable1_shift                                             (17)
+#define VI_HDC1OBUFF_write_enable1_mask                                              (0x00020000)
+#define VI_HDC1OBUFF_write_enable1(data)                                             (0x00020000&((data)<<17))
+#define VI_HDC1OBUFF_write_enable1_src(data)                                         ((0x00020000&(data))>>17)
+#define VI_HDC1OBUFF_get_write_enable1(data)                                         ((0x00020000&(data))>>17)
+#define VI_HDC1OBUFF_start_shift                                                     (9)
+#define VI_HDC1OBUFF_start_mask                                                      (0x0001FE00)
+#define VI_HDC1OBUFF_start(data)                                                     (0x0001FE00&((data)<<9))
+#define VI_HDC1OBUFF_start_src(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_HDC1OBUFF_get_start(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_HDC1OBUFF_write_enable2_shift                                             (8)
+#define VI_HDC1OBUFF_write_enable2_mask                                              (0x00000100)
+#define VI_HDC1OBUFF_write_enable2(data)                                             (0x00000100&((data)<<8))
+#define VI_HDC1OBUFF_write_enable2_src(data)                                         ((0x00000100&(data))>>8)
+#define VI_HDC1OBUFF_get_write_enable2(data)                                         ((0x00000100&(data))>>8)
+#define VI_HDC1OBUFF_end_shift                                                       (0)
+#define VI_HDC1OBUFF_end_mask                                                        (0x000000FF)
+#define VI_HDC1OBUFF_end(data)                                                       (0x000000FF&((data)<<0))
+#define VI_HDC1OBUFF_end_src(data)                                                   ((0x000000FF&(data))>>0)
+#define VI_HDC1OBUFF_get_end(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define VI_HDC2OBUFF                                                                 0x18004560
+#define VI_HDC2OBUFF_reg_addr                                                        "0xB8004560"
+#define VI_HDC2OBUFF_reg                                                             0xB8004560
+#define VI_HDC2OBUFF_inst_adr                                                        "0x0058"
+#define VI_HDC2OBUFF_inst                                                            0x0058
+#define VI_HDC2OBUFF_write_enable1_shift                                             (17)
+#define VI_HDC2OBUFF_write_enable1_mask                                              (0x00020000)
+#define VI_HDC2OBUFF_write_enable1(data)                                             (0x00020000&((data)<<17))
+#define VI_HDC2OBUFF_write_enable1_src(data)                                         ((0x00020000&(data))>>17)
+#define VI_HDC2OBUFF_get_write_enable1(data)                                         ((0x00020000&(data))>>17)
+#define VI_HDC2OBUFF_start_shift                                                     (9)
+#define VI_HDC2OBUFF_start_mask                                                      (0x0001FE00)
+#define VI_HDC2OBUFF_start(data)                                                     (0x0001FE00&((data)<<9))
+#define VI_HDC2OBUFF_start_src(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_HDC2OBUFF_get_start(data)                                                 ((0x0001FE00&(data))>>9)
+#define VI_HDC2OBUFF_write_enable2_shift                                             (8)
+#define VI_HDC2OBUFF_write_enable2_mask                                              (0x00000100)
+#define VI_HDC2OBUFF_write_enable2(data)                                             (0x00000100&((data)<<8))
+#define VI_HDC2OBUFF_write_enable2_src(data)                                         ((0x00000100&(data))>>8)
+#define VI_HDC2OBUFF_get_write_enable2(data)                                         ((0x00000100&(data))>>8)
+#define VI_HDC2OBUFF_end_shift                                                       (0)
+#define VI_HDC2OBUFF_end_mask                                                        (0x000000FF)
+#define VI_HDC2OBUFF_end(data)                                                       (0x000000FF&((data)<<0))
+#define VI_HDC2OBUFF_end_src(data)                                                   ((0x000000FF&(data))>>0)
+#define VI_HDC2OBUFF_get_end(data)                                                   ((0x000000FF&(data))>>0)
+
+
+#define VI_Y1EXTOBUFF                                                                0x18004564
+#define VI_Y1EXTOBUFF_reg_addr                                                       "0xB8004564"
+#define VI_Y1EXTOBUFF_reg                                                            0xB8004564
+#define VI_Y1EXTOBUFF_inst_adr                                                       "0x0059"
+#define VI_Y1EXTOBUFF_inst                                                           0x0059
+#define VI_Y1EXTOBUFF_write_enable1_shift                                            (17)
+#define VI_Y1EXTOBUFF_write_enable1_mask                                             (0x00020000)
+#define VI_Y1EXTOBUFF_write_enable1(data)                                            (0x00020000&((data)<<17))
+#define VI_Y1EXTOBUFF_write_enable1_src(data)                                        ((0x00020000&(data))>>17)
+#define VI_Y1EXTOBUFF_get_write_enable1(data)                                        ((0x00020000&(data))>>17)
+#define VI_Y1EXTOBUFF_start_shift                                                    (9)
+#define VI_Y1EXTOBUFF_start_mask                                                     (0x0001FE00)
+#define VI_Y1EXTOBUFF_start(data)                                                    (0x0001FE00&((data)<<9))
+#define VI_Y1EXTOBUFF_start_src(data)                                                ((0x0001FE00&(data))>>9)
+#define VI_Y1EXTOBUFF_get_start(data)                                                ((0x0001FE00&(data))>>9)
+#define VI_Y1EXTOBUFF_write_enable2_shift                                            (8)
+#define VI_Y1EXTOBUFF_write_enable2_mask                                             (0x00000100)
+#define VI_Y1EXTOBUFF_write_enable2(data)                                            (0x00000100&((data)<<8))
+#define VI_Y1EXTOBUFF_write_enable2_src(data)                                        ((0x00000100&(data))>>8)
+#define VI_Y1EXTOBUFF_get_write_enable2(data)                                        ((0x00000100&(data))>>8)
+#define VI_Y1EXTOBUFF_end_shift                                                      (0)
+#define VI_Y1EXTOBUFF_end_mask                                                       (0x000000FF)
+#define VI_Y1EXTOBUFF_end(data)                                                      (0x000000FF&((data)<<0))
+#define VI_Y1EXTOBUFF_end_src(data)                                                  ((0x000000FF&(data))>>0)
+#define VI_Y1EXTOBUFF_get_end(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define VI_Y2EXTOBUFF                                                                0x18004568
+#define VI_Y2EXTOBUFF_reg_addr                                                       "0xB8004568"
+#define VI_Y2EXTOBUFF_reg                                                            0xB8004568
+#define VI_Y2EXTOBUFF_inst_adr                                                       "0x005A"
+#define VI_Y2EXTOBUFF_inst                                                           0x005A
+#define VI_Y2EXTOBUFF_write_enable1_shift                                            (17)
+#define VI_Y2EXTOBUFF_write_enable1_mask                                             (0x00020000)
+#define VI_Y2EXTOBUFF_write_enable1(data)                                            (0x00020000&((data)<<17))
+#define VI_Y2EXTOBUFF_write_enable1_src(data)                                        ((0x00020000&(data))>>17)
+#define VI_Y2EXTOBUFF_get_write_enable1(data)                                        ((0x00020000&(data))>>17)
+#define VI_Y2EXTOBUFF_start_shift                                                    (9)
+#define VI_Y2EXTOBUFF_start_mask                                                     (0x0001FE00)
+#define VI_Y2EXTOBUFF_start(data)                                                    (0x0001FE00&((data)<<9))
+#define VI_Y2EXTOBUFF_start_src(data)                                                ((0x0001FE00&(data))>>9)
+#define VI_Y2EXTOBUFF_get_start(data)                                                ((0x0001FE00&(data))>>9)
+#define VI_Y2EXTOBUFF_write_enable2_shift                                            (8)
+#define VI_Y2EXTOBUFF_write_enable2_mask                                             (0x00000100)
+#define VI_Y2EXTOBUFF_write_enable2(data)                                            (0x00000100&((data)<<8))
+#define VI_Y2EXTOBUFF_write_enable2_src(data)                                        ((0x00000100&(data))>>8)
+#define VI_Y2EXTOBUFF_get_write_enable2(data)                                        ((0x00000100&(data))>>8)
+#define VI_Y2EXTOBUFF_end_shift                                                      (0)
+#define VI_Y2EXTOBUFF_end_mask                                                       (0x000000FF)
+#define VI_Y2EXTOBUFF_end(data)                                                      (0x000000FF&((data)<<0))
+#define VI_Y2EXTOBUFF_end_src(data)                                                  ((0x000000FF&(data))>>0)
+#define VI_Y2EXTOBUFF_get_end(data)                                                  ((0x000000FF&(data))>>0)
+
+
+#define VI_FA_ADDR                                                                   0x180044a8
+#define VI_FA_ADDR_reg_addr                                                          "0xB80044A8"
+#define VI_FA_ADDR_reg                                                               0xB80044A8
+#define VI_FA_ADDR_inst_adr                                                          "0x002A"
+#define VI_FA_ADDR_inst                                                              0x002A
+#define VI_FA_ADDR_write_enable1_shift                                               (13)
+#define VI_FA_ADDR_write_enable1_mask                                                (0x00002000)
+#define VI_FA_ADDR_write_enable1(data)                                               (0x00002000&((data)<<13))
+#define VI_FA_ADDR_write_enable1_src(data)                                           ((0x00002000&(data))>>13)
+#define VI_FA_ADDR_get_write_enable1(data)                                           ((0x00002000&(data))>>13)
+#define VI_FA_ADDR_fa_enable_shift                                                   (12)
+#define VI_FA_ADDR_fa_enable_mask                                                    (0x00001000)
+#define VI_FA_ADDR_fa_enable(data)                                                   (0x00001000&((data)<<12))
+#define VI_FA_ADDR_fa_enable_src(data)                                               ((0x00001000&(data))>>12)
+#define VI_FA_ADDR_get_fa_enable(data)                                               ((0x00001000&(data))>>12)
+#define VI_FA_ADDR_write_enable2_shift                                               (11)
+#define VI_FA_ADDR_write_enable2_mask                                                (0x00000800)
+#define VI_FA_ADDR_write_enable2(data)                                               (0x00000800&((data)<<11))
+#define VI_FA_ADDR_write_enable2_src(data)                                           ((0x00000800&(data))>>11)
+#define VI_FA_ADDR_get_write_enable2(data)                                           ((0x00000800&(data))>>11)
+#define VI_FA_ADDR_fa_buffer_sel_shift                                               (10)
+#define VI_FA_ADDR_fa_buffer_sel_mask                                                (0x00000400)
+#define VI_FA_ADDR_fa_buffer_sel(data)                                               (0x00000400&((data)<<10))
+#define VI_FA_ADDR_fa_buffer_sel_src(data)                                           ((0x00000400&(data))>>10)
+#define VI_FA_ADDR_get_fa_buffer_sel(data)                                           ((0x00000400&(data))>>10)
+#define VI_FA_ADDR_write_enable3_shift                                               (9)
+#define VI_FA_ADDR_write_enable3_mask                                                (0x00000200)
+#define VI_FA_ADDR_write_enable3(data)                                               (0x00000200&((data)<<9))
+#define VI_FA_ADDR_write_enable3_src(data)                                           ((0x00000200&(data))>>9)
+#define VI_FA_ADDR_get_write_enable3(data)                                           ((0x00000200&(data))>>9)
+#define VI_FA_ADDR_fa_addr_2_shift                                                   (0)
+#define VI_FA_ADDR_fa_addr_2_mask                                                    (0x000001FF)
+#define VI_FA_ADDR_fa_addr_2(data)                                                   (0x000001FF&((data)<<0))
+#define VI_FA_ADDR_fa_addr_2_src(data)                                               ((0x000001FF&(data))>>0)
+#define VI_FA_ADDR_get_fa_addr_2(data)                                               ((0x000001FF&(data))>>0)
+
+
+#define VI_FA_DATA_MSB                                                               0x180044ac
+#define VI_FA_DATA_MSB_reg_addr                                                      "0xB80044AC"
+#define VI_FA_DATA_MSB_reg                                                           0xB80044AC
+#define VI_FA_DATA_MSB_inst_adr                                                      "0x002B"
+#define VI_FA_DATA_MSB_inst                                                          0x002B
+#define VI_FA_DATA_MSB_data_shift                                                    (0)
+#define VI_FA_DATA_MSB_data_mask                                                     (0xFFFFFFFF)
+#define VI_FA_DATA_MSB_data(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define VI_FA_DATA_MSB_data_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define VI_FA_DATA_MSB_get_data(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define VI_FA_DATA_LSB                                                               0x18004570
+#define VI_FA_DATA_LSB_reg_addr                                                      "0xB8004570"
+#define VI_FA_DATA_LSB_reg                                                           0xB8004570
+#define VI_FA_DATA_LSB_inst_adr                                                      "0x005C"
+#define VI_FA_DATA_LSB_inst                                                          0x005C
+#define VI_FA_DATA_LSB_data_shift                                                    (0)
+#define VI_FA_DATA_LSB_data_mask                                                     (0xFFFFFFFF)
+#define VI_FA_DATA_LSB_data(data)                                                    (0xFFFFFFFF&((data)<<0))
+#define VI_FA_DATA_LSB_data_src(data)                                                ((0xFFFFFFFF&(data))>>0)
+#define VI_FA_DATA_LSB_get_data(data)                                                ((0xFFFFFFFF&(data))>>0)
+
+
+#define VI_DBG                                                                       0x18004284
+#define VI_DBG_reg_addr                                                              "0xB8004284"
+#define VI_DBG_reg                                                                   0xB8004284
+#define VI_DBG_inst_adr                                                              "0x00A1"
+#define VI_DBG_inst                                                                  0x00A1
+#define VI_DBG_write_enable1_shift                                                   (17)
+#define VI_DBG_write_enable1_mask                                                    (0x00020000)
+#define VI_DBG_write_enable1(data)                                                   (0x00020000&((data)<<17))
+#define VI_DBG_write_enable1_src(data)                                               ((0x00020000&(data))>>17)
+#define VI_DBG_get_write_enable1(data)                                               ((0x00020000&(data))>>17)
+#define VI_DBG_sel0_shift                                                            (10)
+#define VI_DBG_sel0_mask                                                             (0x0001FC00)
+#define VI_DBG_sel0(data)                                                            (0x0001FC00&((data)<<10))
+#define VI_DBG_sel0_src(data)                                                        ((0x0001FC00&(data))>>10)
+#define VI_DBG_get_sel0(data)                                                        ((0x0001FC00&(data))>>10)
+#define VI_DBG_write_enable2_shift                                                   (9)
+#define VI_DBG_write_enable2_mask                                                    (0x00000200)
+#define VI_DBG_write_enable2(data)                                                   (0x00000200&((data)<<9))
+#define VI_DBG_write_enable2_src(data)                                               ((0x00000200&(data))>>9)
+#define VI_DBG_get_write_enable2(data)                                               ((0x00000200&(data))>>9)
+#define VI_DBG_sel1_shift                                                            (2)
+#define VI_DBG_sel1_mask                                                             (0x000001FC)
+#define VI_DBG_sel1(data)                                                            (0x000001FC&((data)<<2))
+#define VI_DBG_sel1_src(data)                                                        ((0x000001FC&(data))>>2)
+#define VI_DBG_get_sel1(data)                                                        ((0x000001FC&(data))>>2)
+#define VI_DBG_write_enable3_shift                                                   (1)
+#define VI_DBG_write_enable3_mask                                                    (0x00000002)
+#define VI_DBG_write_enable3(data)                                                   (0x00000002&((data)<<1))
+#define VI_DBG_write_enable3_src(data)                                               ((0x00000002&(data))>>1)
+#define VI_DBG_get_write_enable3(data)                                               ((0x00000002&(data))>>1)
+#define VI_DBG_enable_shift                                                          (0)
+#define VI_DBG_enable_mask                                                           (0x00000001)
+#define VI_DBG_enable(data)                                                          (0x00000001&((data)<<0))
+#define VI_DBG_enable_src(data)                                                      ((0x00000001&(data))>>0)
+#define VI_DBG_get_enable(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define VI_DUMMY                                                                     0x18004584
+#define VI_DUMMY_reg_addr                                                            "0xB8004584"
+#define VI_DUMMY_reg                                                                 0xB8004584
+#define VI_DUMMY_inst_adr                                                            "0x0061"
+#define VI_DUMMY_inst                                                                0x0061
+#define VI_DUMMY_dummy_shift                                                         (0)
+#define VI_DUMMY_dummy_mask                                                          (0xFFFFFFFF)
+#define VI_DUMMY_dummy(data)                                                         (0xFFFFFFFF&((data)<<0))
+#define VI_DUMMY_dummy_src(data)                                                     ((0xFFFFFFFF&(data))>>0)
+#define VI_DUMMY_get_dummy(data)                                                     ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/vma_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/vma_reg.h
new file mode 100644
index 00000000..2c047b9
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/vma_reg.h
@@ -0,0 +1,394 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/6/22 11:40:33
+***************************************************************/
+
+
+#ifndef _VMA_REG_H_INCLUDED_
+#define _VMA_REG_H_INCLUDED_
+#ifdef  _VMA_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     x:13;
+unsigned int     y:14;
+}VMA_DMAREG1A;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     cbcr_vmOffset:7;
+unsigned int     mode:1;
+unsigned int     right_offset:3;
+unsigned int     left_offset:3;
+unsigned int     reserved_1:1;
+unsigned int     addr_idx:7;
+unsigned int     post_inc_sel:1;
+unsigned int     reserved_2:1;
+unsigned int     post_inc:6;
+}VMA_DMAREG2A;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     line_off:1;
+unsigned int     reserved_1:1;
+unsigned int     vmRowOffset:5;
+unsigned int     reserved_2:3;
+unsigned int     vm_addr:7;
+unsigned int     H:6;
+unsigned int     reserved_3:2;
+unsigned int     W:4;
+}VMA_DMAREG3A;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     Seq_VMEM_addr:13;
+unsigned int     reserved_1:7;
+unsigned int     Seq_xsfr_size:9;
+}VMA_SDMACNTLA;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     seq_line_addr:31;
+}VMA_SDMAADRA;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     write_enable3:1;
+unsigned int     dmem_path:1;
+unsigned int     write_enable2:1;
+unsigned int     ldst_vmem_count:16;
+unsigned int     write_enable1:1;
+unsigned int     post_write_disable:1;
+}VMA_DMACTLA;
+
+#endif
+
+#define VMA_DMAREG1A_0                                                               0x1800EE00
+#define VMA_DMAREG1A_1                                                               0x1800EE04
+#define VMA_DMAREG1A_2                                                               0x1800EE08
+#define VMA_DMAREG1A_3                                                               0x1800EE0C
+#define VMA_DMAREG1A_4                                                               0x1800EE10
+#define VMA_DMAREG1A_5                                                               0x1800EE14
+#define VMA_DMAREG1A_6                                                               0x1800EE18
+#define VMA_DMAREG1A_7                                                               0x1800EE1C
+#define VMA_DMAREG1A_0_reg_addr                                                      "0xB800EE00"
+#define VMA_DMAREG1A_1_reg_addr                                                      "0xB800EE04"
+#define VMA_DMAREG1A_2_reg_addr                                                      "0xB800EE08"
+#define VMA_DMAREG1A_3_reg_addr                                                      "0xB800EE0C"
+#define VMA_DMAREG1A_4_reg_addr                                                      "0xB800EE10"
+#define VMA_DMAREG1A_5_reg_addr                                                      "0xB800EE14"
+#define VMA_DMAREG1A_6_reg_addr                                                      "0xB800EE18"
+#define VMA_DMAREG1A_7_reg_addr                                                      "0xB800EE1C"
+#define VMA_DMAREG1A_0_reg                                                           0xB800EE00
+#define VMA_DMAREG1A_1_reg                                                           0xB800EE04
+#define VMA_DMAREG1A_2_reg                                                           0xB800EE08
+#define VMA_DMAREG1A_3_reg                                                           0xB800EE0C
+#define VMA_DMAREG1A_4_reg                                                           0xB800EE10
+#define VMA_DMAREG1A_5_reg                                                           0xB800EE14
+#define VMA_DMAREG1A_6_reg                                                           0xB800EE18
+#define VMA_DMAREG1A_7_reg                                                           0xB800EE1C
+#define set_VMA_DMAREG1A_0_reg(data)   (*((volatile unsigned int*) VMA_DMAREG1A_0_reg)=data)
+#define set_VMA_DMAREG1A_1_reg(data)   (*((volatile unsigned int*) VMA_DMAREG1A_1_reg)=data)
+#define set_VMA_DMAREG1A_2_reg(data)   (*((volatile unsigned int*) VMA_DMAREG1A_2_reg)=data)
+#define set_VMA_DMAREG1A_3_reg(data)   (*((volatile unsigned int*) VMA_DMAREG1A_3_reg)=data)
+#define set_VMA_DMAREG1A_4_reg(data)   (*((volatile unsigned int*) VMA_DMAREG1A_4_reg)=data)
+#define set_VMA_DMAREG1A_5_reg(data)   (*((volatile unsigned int*) VMA_DMAREG1A_5_reg)=data)
+#define set_VMA_DMAREG1A_6_reg(data)   (*((volatile unsigned int*) VMA_DMAREG1A_6_reg)=data)
+#define set_VMA_DMAREG1A_7_reg(data)   (*((volatile unsigned int*) VMA_DMAREG1A_7_reg)=data)
+#define get_VMA_DMAREG1A_0_reg   (*((volatile unsigned int*) VMA_DMAREG1A_0_reg))
+#define get_VMA_DMAREG1A_1_reg   (*((volatile unsigned int*) VMA_DMAREG1A_1_reg))
+#define get_VMA_DMAREG1A_2_reg   (*((volatile unsigned int*) VMA_DMAREG1A_2_reg))
+#define get_VMA_DMAREG1A_3_reg   (*((volatile unsigned int*) VMA_DMAREG1A_3_reg))
+#define get_VMA_DMAREG1A_4_reg   (*((volatile unsigned int*) VMA_DMAREG1A_4_reg))
+#define get_VMA_DMAREG1A_5_reg   (*((volatile unsigned int*) VMA_DMAREG1A_5_reg))
+#define get_VMA_DMAREG1A_6_reg   (*((volatile unsigned int*) VMA_DMAREG1A_6_reg))
+#define get_VMA_DMAREG1A_7_reg   (*((volatile unsigned int*) VMA_DMAREG1A_7_reg))
+#define VMA_DMAREG1A_0_inst_adr                                                      "0x0080"
+#define VMA_DMAREG1A_1_inst_adr                                                      "0x0081"
+#define VMA_DMAREG1A_2_inst_adr                                                      "0x0082"
+#define VMA_DMAREG1A_3_inst_adr                                                      "0x0083"
+#define VMA_DMAREG1A_4_inst_adr                                                      "0x0084"
+#define VMA_DMAREG1A_5_inst_adr                                                      "0x0085"
+#define VMA_DMAREG1A_6_inst_adr                                                      "0x0086"
+#define VMA_DMAREG1A_7_inst_adr                                                      "0x0087"
+#define VMA_DMAREG1A_0_inst                                                          0x0080
+#define VMA_DMAREG1A_1_inst                                                          0x0081
+#define VMA_DMAREG1A_2_inst                                                          0x0082
+#define VMA_DMAREG1A_3_inst                                                          0x0083
+#define VMA_DMAREG1A_4_inst                                                          0x0084
+#define VMA_DMAREG1A_5_inst                                                          0x0085
+#define VMA_DMAREG1A_6_inst                                                          0x0086
+#define VMA_DMAREG1A_7_inst                                                          0x0087
+#define VMA_DMAREG1A_x_shift                                                         (14)
+#define VMA_DMAREG1A_x_mask                                                          (0x07FFC000)
+#define VMA_DMAREG1A_x(data)                                                         (0x07FFC000&((data)<<14))
+#define VMA_DMAREG1A_x_src(data)                                                     ((0x07FFC000&(data))>>14)
+#define VMA_DMAREG1A_get_x(data)                                                     ((0x07FFC000&(data))>>14)
+#define VMA_DMAREG1A_y_shift                                                         (0)
+#define VMA_DMAREG1A_y_mask                                                          (0x00003FFF)
+#define VMA_DMAREG1A_y(data)                                                         (0x00003FFF&((data)<<0))
+#define VMA_DMAREG1A_y_src(data)                                                     ((0x00003FFF&(data))>>0)
+#define VMA_DMAREG1A_get_y(data)                                                     ((0x00003FFF&(data))>>0)
+
+
+#define VMA_DMAREG2A_0                                                               0x1800EE20
+#define VMA_DMAREG2A_1                                                               0x1800EE24
+#define VMA_DMAREG2A_2                                                               0x1800EE28
+#define VMA_DMAREG2A_3                                                               0x1800EE2C
+#define VMA_DMAREG2A_4                                                               0x1800EE30
+#define VMA_DMAREG2A_5                                                               0x1800EE34
+#define VMA_DMAREG2A_6                                                               0x1800EE38
+#define VMA_DMAREG2A_7                                                               0x1800EE3C
+#define VMA_DMAREG2A_0_reg_addr                                                      "0xB800EE20"
+#define VMA_DMAREG2A_1_reg_addr                                                      "0xB800EE24"
+#define VMA_DMAREG2A_2_reg_addr                                                      "0xB800EE28"
+#define VMA_DMAREG2A_3_reg_addr                                                      "0xB800EE2C"
+#define VMA_DMAREG2A_4_reg_addr                                                      "0xB800EE30"
+#define VMA_DMAREG2A_5_reg_addr                                                      "0xB800EE34"
+#define VMA_DMAREG2A_6_reg_addr                                                      "0xB800EE38"
+#define VMA_DMAREG2A_7_reg_addr                                                      "0xB800EE3C"
+#define VMA_DMAREG2A_0_reg                                                           0xB800EE20
+#define VMA_DMAREG2A_1_reg                                                           0xB800EE24
+#define VMA_DMAREG2A_2_reg                                                           0xB800EE28
+#define VMA_DMAREG2A_3_reg                                                           0xB800EE2C
+#define VMA_DMAREG2A_4_reg                                                           0xB800EE30
+#define VMA_DMAREG2A_5_reg                                                           0xB800EE34
+#define VMA_DMAREG2A_6_reg                                                           0xB800EE38
+#define VMA_DMAREG2A_7_reg                                                           0xB800EE3C
+#define set_VMA_DMAREG2A_0_reg(data)   (*((volatile unsigned int*) VMA_DMAREG2A_0_reg)=data)
+#define set_VMA_DMAREG2A_1_reg(data)   (*((volatile unsigned int*) VMA_DMAREG2A_1_reg)=data)
+#define set_VMA_DMAREG2A_2_reg(data)   (*((volatile unsigned int*) VMA_DMAREG2A_2_reg)=data)
+#define set_VMA_DMAREG2A_3_reg(data)   (*((volatile unsigned int*) VMA_DMAREG2A_3_reg)=data)
+#define set_VMA_DMAREG2A_4_reg(data)   (*((volatile unsigned int*) VMA_DMAREG2A_4_reg)=data)
+#define set_VMA_DMAREG2A_5_reg(data)   (*((volatile unsigned int*) VMA_DMAREG2A_5_reg)=data)
+#define set_VMA_DMAREG2A_6_reg(data)   (*((volatile unsigned int*) VMA_DMAREG2A_6_reg)=data)
+#define set_VMA_DMAREG2A_7_reg(data)   (*((volatile unsigned int*) VMA_DMAREG2A_7_reg)=data)
+#define get_VMA_DMAREG2A_0_reg   (*((volatile unsigned int*) VMA_DMAREG2A_0_reg))
+#define get_VMA_DMAREG2A_1_reg   (*((volatile unsigned int*) VMA_DMAREG2A_1_reg))
+#define get_VMA_DMAREG2A_2_reg   (*((volatile unsigned int*) VMA_DMAREG2A_2_reg))
+#define get_VMA_DMAREG2A_3_reg   (*((volatile unsigned int*) VMA_DMAREG2A_3_reg))
+#define get_VMA_DMAREG2A_4_reg   (*((volatile unsigned int*) VMA_DMAREG2A_4_reg))
+#define get_VMA_DMAREG2A_5_reg   (*((volatile unsigned int*) VMA_DMAREG2A_5_reg))
+#define get_VMA_DMAREG2A_6_reg   (*((volatile unsigned int*) VMA_DMAREG2A_6_reg))
+#define get_VMA_DMAREG2A_7_reg   (*((volatile unsigned int*) VMA_DMAREG2A_7_reg))
+#define VMA_DMAREG2A_0_inst_adr                                                      "0x0088"
+#define VMA_DMAREG2A_1_inst_adr                                                      "0x0089"
+#define VMA_DMAREG2A_2_inst_adr                                                      "0x008A"
+#define VMA_DMAREG2A_3_inst_adr                                                      "0x008B"
+#define VMA_DMAREG2A_4_inst_adr                                                      "0x008C"
+#define VMA_DMAREG2A_5_inst_adr                                                      "0x008D"
+#define VMA_DMAREG2A_6_inst_adr                                                      "0x008E"
+#define VMA_DMAREG2A_7_inst_adr                                                      "0x008F"
+#define VMA_DMAREG2A_0_inst                                                          0x0088
+#define VMA_DMAREG2A_1_inst                                                          0x0089
+#define VMA_DMAREG2A_2_inst                                                          0x008A
+#define VMA_DMAREG2A_3_inst                                                          0x008B
+#define VMA_DMAREG2A_4_inst                                                          0x008C
+#define VMA_DMAREG2A_5_inst                                                          0x008D
+#define VMA_DMAREG2A_6_inst                                                          0x008E
+#define VMA_DMAREG2A_7_inst                                                          0x008F
+#define VMA_DMAREG2A_cbcr_vmOffset_shift                                             (23)
+#define VMA_DMAREG2A_cbcr_vmOffset_mask                                              (0x3F800000)
+#define VMA_DMAREG2A_cbcr_vmOffset(data)                                             (0x3F800000&((data)<<23))
+#define VMA_DMAREG2A_cbcr_vmOffset_src(data)                                         ((0x3F800000&(data))>>23)
+#define VMA_DMAREG2A_get_cbcr_vmOffset(data)                                         ((0x3F800000&(data))>>23)
+#define VMA_DMAREG2A_mode_shift                                                      (22)
+#define VMA_DMAREG2A_mode_mask                                                       (0x00400000)
+#define VMA_DMAREG2A_mode(data)                                                      (0x00400000&((data)<<22))
+#define VMA_DMAREG2A_mode_src(data)                                                  ((0x00400000&(data))>>22)
+#define VMA_DMAREG2A_get_mode(data)                                                  ((0x00400000&(data))>>22)
+#define VMA_DMAREG2A_right_offset_shift                                              (19)
+#define VMA_DMAREG2A_right_offset_mask                                               (0x00380000)
+#define VMA_DMAREG2A_right_offset(data)                                              (0x00380000&((data)<<19))
+#define VMA_DMAREG2A_right_offset_src(data)                                          ((0x00380000&(data))>>19)
+#define VMA_DMAREG2A_get_right_offset(data)                                          ((0x00380000&(data))>>19)
+#define VMA_DMAREG2A_left_offset_shift                                               (16)
+#define VMA_DMAREG2A_left_offset_mask                                                (0x00070000)
+#define VMA_DMAREG2A_left_offset(data)                                               (0x00070000&((data)<<16))
+#define VMA_DMAREG2A_left_offset_src(data)                                           ((0x00070000&(data))>>16)
+#define VMA_DMAREG2A_get_left_offset(data)                                           ((0x00070000&(data))>>16)
+#define VMA_DMAREG2A_addr_idx_shift                                                  (8)
+#define VMA_DMAREG2A_addr_idx_mask                                                   (0x00007F00)
+#define VMA_DMAREG2A_addr_idx(data)                                                  (0x00007F00&((data)<<8))
+#define VMA_DMAREG2A_addr_idx_src(data)                                              ((0x00007F00&(data))>>8)
+#define VMA_DMAREG2A_get_addr_idx(data)                                              ((0x00007F00&(data))>>8)
+#define VMA_DMAREG2A_post_inc_sel_shift                                              (7)
+#define VMA_DMAREG2A_post_inc_sel_mask                                               (0x00000080)
+#define VMA_DMAREG2A_post_inc_sel(data)                                              (0x00000080&((data)<<7))
+#define VMA_DMAREG2A_post_inc_sel_src(data)                                          ((0x00000080&(data))>>7)
+#define VMA_DMAREG2A_get_post_inc_sel(data)                                          ((0x00000080&(data))>>7)
+#define VMA_DMAREG2A_post_inc_shift                                                  (0)
+#define VMA_DMAREG2A_post_inc_mask                                                   (0x0000003F)
+#define VMA_DMAREG2A_post_inc(data)                                                  (0x0000003F&((data)<<0))
+#define VMA_DMAREG2A_post_inc_src(data)                                              ((0x0000003F&(data))>>0)
+#define VMA_DMAREG2A_get_post_inc(data)                                              ((0x0000003F&(data))>>0)
+
+
+#define VMA_DMAREG3A_0                                                               0x1800EE40
+#define VMA_DMAREG3A_1                                                               0x1800EE44
+#define VMA_DMAREG3A_2                                                               0x1800EE48
+#define VMA_DMAREG3A_3                                                               0x1800EE4C
+#define VMA_DMAREG3A_4                                                               0x1800EE50
+#define VMA_DMAREG3A_5                                                               0x1800EE54
+#define VMA_DMAREG3A_6                                                               0x1800EE58
+#define VMA_DMAREG3A_7                                                               0x1800EE5C
+#define VMA_DMAREG3A_0_reg_addr                                                      "0xB800EE40"
+#define VMA_DMAREG3A_1_reg_addr                                                      "0xB800EE44"
+#define VMA_DMAREG3A_2_reg_addr                                                      "0xB800EE48"
+#define VMA_DMAREG3A_3_reg_addr                                                      "0xB800EE4C"
+#define VMA_DMAREG3A_4_reg_addr                                                      "0xB800EE50"
+#define VMA_DMAREG3A_5_reg_addr                                                      "0xB800EE54"
+#define VMA_DMAREG3A_6_reg_addr                                                      "0xB800EE58"
+#define VMA_DMAREG3A_7_reg_addr                                                      "0xB800EE5C"
+#define VMA_DMAREG3A_0_reg                                                           0xB800EE40
+#define VMA_DMAREG3A_1_reg                                                           0xB800EE44
+#define VMA_DMAREG3A_2_reg                                                           0xB800EE48
+#define VMA_DMAREG3A_3_reg                                                           0xB800EE4C
+#define VMA_DMAREG3A_4_reg                                                           0xB800EE50
+#define VMA_DMAREG3A_5_reg                                                           0xB800EE54
+#define VMA_DMAREG3A_6_reg                                                           0xB800EE58
+#define VMA_DMAREG3A_7_reg                                                           0xB800EE5C
+#define set_VMA_DMAREG3A_0_reg(data)   (*((volatile unsigned int*) VMA_DMAREG3A_0_reg)=data)
+#define set_VMA_DMAREG3A_1_reg(data)   (*((volatile unsigned int*) VMA_DMAREG3A_1_reg)=data)
+#define set_VMA_DMAREG3A_2_reg(data)   (*((volatile unsigned int*) VMA_DMAREG3A_2_reg)=data)
+#define set_VMA_DMAREG3A_3_reg(data)   (*((volatile unsigned int*) VMA_DMAREG3A_3_reg)=data)
+#define set_VMA_DMAREG3A_4_reg(data)   (*((volatile unsigned int*) VMA_DMAREG3A_4_reg)=data)
+#define set_VMA_DMAREG3A_5_reg(data)   (*((volatile unsigned int*) VMA_DMAREG3A_5_reg)=data)
+#define set_VMA_DMAREG3A_6_reg(data)   (*((volatile unsigned int*) VMA_DMAREG3A_6_reg)=data)
+#define set_VMA_DMAREG3A_7_reg(data)   (*((volatile unsigned int*) VMA_DMAREG3A_7_reg)=data)
+#define get_VMA_DMAREG3A_0_reg   (*((volatile unsigned int*) VMA_DMAREG3A_0_reg))
+#define get_VMA_DMAREG3A_1_reg   (*((volatile unsigned int*) VMA_DMAREG3A_1_reg))
+#define get_VMA_DMAREG3A_2_reg   (*((volatile unsigned int*) VMA_DMAREG3A_2_reg))
+#define get_VMA_DMAREG3A_3_reg   (*((volatile unsigned int*) VMA_DMAREG3A_3_reg))
+#define get_VMA_DMAREG3A_4_reg   (*((volatile unsigned int*) VMA_DMAREG3A_4_reg))
+#define get_VMA_DMAREG3A_5_reg   (*((volatile unsigned int*) VMA_DMAREG3A_5_reg))
+#define get_VMA_DMAREG3A_6_reg   (*((volatile unsigned int*) VMA_DMAREG3A_6_reg))
+#define get_VMA_DMAREG3A_7_reg   (*((volatile unsigned int*) VMA_DMAREG3A_7_reg))
+#define VMA_DMAREG3A_0_inst_adr                                                      "0x0090"
+#define VMA_DMAREG3A_1_inst_adr                                                      "0x0091"
+#define VMA_DMAREG3A_2_inst_adr                                                      "0x0092"
+#define VMA_DMAREG3A_3_inst_adr                                                      "0x0093"
+#define VMA_DMAREG3A_4_inst_adr                                                      "0x0094"
+#define VMA_DMAREG3A_5_inst_adr                                                      "0x0095"
+#define VMA_DMAREG3A_6_inst_adr                                                      "0x0096"
+#define VMA_DMAREG3A_7_inst_adr                                                      "0x0097"
+#define VMA_DMAREG3A_0_inst                                                          0x0090
+#define VMA_DMAREG3A_1_inst                                                          0x0091
+#define VMA_DMAREG3A_2_inst                                                          0x0092
+#define VMA_DMAREG3A_3_inst                                                          0x0093
+#define VMA_DMAREG3A_4_inst                                                          0x0094
+#define VMA_DMAREG3A_5_inst                                                          0x0095
+#define VMA_DMAREG3A_6_inst                                                          0x0096
+#define VMA_DMAREG3A_7_inst                                                          0x0097
+#define VMA_DMAREG3A_line_off_shift                                                  (28)
+#define VMA_DMAREG3A_line_off_mask                                                   (0x10000000)
+#define VMA_DMAREG3A_line_off(data)                                                  (0x10000000&((data)<<28))
+#define VMA_DMAREG3A_line_off_src(data)                                              ((0x10000000&(data))>>28)
+#define VMA_DMAREG3A_get_line_off(data)                                              ((0x10000000&(data))>>28)
+#define VMA_DMAREG3A_vmRowOffset_shift                                               (22)
+#define VMA_DMAREG3A_vmRowOffset_mask                                                (0x07C00000)
+#define VMA_DMAREG3A_vmRowOffset(data)                                               (0x07C00000&((data)<<22))
+#define VMA_DMAREG3A_vmRowOffset_src(data)                                           ((0x07C00000&(data))>>22)
+#define VMA_DMAREG3A_get_vmRowOffset(data)                                           ((0x07C00000&(data))>>22)
+#define VMA_DMAREG3A_vm_addr_shift                                                   (12)
+#define VMA_DMAREG3A_vm_addr_mask                                                    (0x0007F000)
+#define VMA_DMAREG3A_vm_addr(data)                                                   (0x0007F000&((data)<<12))
+#define VMA_DMAREG3A_vm_addr_src(data)                                               ((0x0007F000&(data))>>12)
+#define VMA_DMAREG3A_get_vm_addr(data)                                               ((0x0007F000&(data))>>12)
+#define VMA_DMAREG3A_H_shift                                                         (6)
+#define VMA_DMAREG3A_H_mask                                                          (0x00000FC0)
+#define VMA_DMAREG3A_H(data)                                                         (0x00000FC0&((data)<<6))
+#define VMA_DMAREG3A_H_src(data)                                                     ((0x00000FC0&(data))>>6)
+#define VMA_DMAREG3A_get_H(data)                                                     ((0x00000FC0&(data))>>6)
+#define VMA_DMAREG3A_W_shift                                                         (0)
+#define VMA_DMAREG3A_W_mask                                                          (0x0000000F)
+#define VMA_DMAREG3A_W(data)                                                         (0x0000000F&((data)<<0))
+#define VMA_DMAREG3A_W_src(data)                                                     ((0x0000000F&(data))>>0)
+#define VMA_DMAREG3A_get_W(data)                                                     ((0x0000000F&(data))>>0)
+
+
+#define VMA_SDMACNTLA                                                                0x1800EE80
+#define VMA_SDMACNTLA_reg_addr                                                       "0xB800EE80"
+#define VMA_SDMACNTLA_reg                                                            0xB800EE80
+#define set_VMA_SDMACNTLA_reg(data)   (*((volatile unsigned int*) VMA_SDMACNTLA_reg)=data)
+#define get_VMA_SDMACNTLA_reg   (*((volatile unsigned int*) VMA_SDMACNTLA_reg))
+#define VMA_SDMACNTLA_inst_adr                                                       "0x00A0"
+#define VMA_SDMACNTLA_inst                                                           0x00A0
+#define VMA_SDMACNTLA_Seq_VMEM_addr_shift                                            (16)
+#define VMA_SDMACNTLA_Seq_VMEM_addr_mask                                             (0x1FFF0000)
+#define VMA_SDMACNTLA_Seq_VMEM_addr(data)                                            (0x1FFF0000&((data)<<16))
+#define VMA_SDMACNTLA_Seq_VMEM_addr_src(data)                                        ((0x1FFF0000&(data))>>16)
+#define VMA_SDMACNTLA_get_Seq_VMEM_addr(data)                                        ((0x1FFF0000&(data))>>16)
+#define VMA_SDMACNTLA_Seq_xsfr_size_shift                                            (0)
+#define VMA_SDMACNTLA_Seq_xsfr_size_mask                                             (0x000001FF)
+#define VMA_SDMACNTLA_Seq_xsfr_size(data)                                            (0x000001FF&((data)<<0))
+#define VMA_SDMACNTLA_Seq_xsfr_size_src(data)                                        ((0x000001FF&(data))>>0)
+#define VMA_SDMACNTLA_get_Seq_xsfr_size(data)                                        ((0x000001FF&(data))>>0)
+
+
+#define VMA_SDMAADRA                                                                 0x1800EE84
+#define VMA_SDMAADRA_reg_addr                                                        "0xB800EE84"
+#define VMA_SDMAADRA_reg                                                             0xB800EE84
+#define set_VMA_SDMAADRA_reg(data)   (*((volatile unsigned int*) VMA_SDMAADRA_reg)=data)
+#define get_VMA_SDMAADRA_reg   (*((volatile unsigned int*) VMA_SDMAADRA_reg))
+#define VMA_SDMAADRA_inst_adr                                                        "0x00A1"
+#define VMA_SDMAADRA_inst                                                            0x00A1
+#define VMA_SDMAADRA_seq_line_addr_shift                                             (0)
+#define VMA_SDMAADRA_seq_line_addr_mask                                              (0x7FFFFFFF)
+#define VMA_SDMAADRA_seq_line_addr(data)                                             (0x7FFFFFFF&((data)<<0))
+#define VMA_SDMAADRA_seq_line_addr_src(data)                                         ((0x7FFFFFFF&(data))>>0)
+#define VMA_SDMAADRA_get_seq_line_addr(data)                                         ((0x7FFFFFFF&(data))>>0)
+
+
+#define VMA_DMACTLA                                                                  0x1800EE88
+#define VMA_DMACTLA_reg_addr                                                         "0xB800EE88"
+#define VMA_DMACTLA_reg                                                              0xB800EE88
+#define set_VMA_DMACTLA_reg(data)   (*((volatile unsigned int*) VMA_DMACTLA_reg)=data)
+#define get_VMA_DMACTLA_reg   (*((volatile unsigned int*) VMA_DMACTLA_reg))
+#define VMA_DMACTLA_inst_adr                                                         "0x00A2"
+#define VMA_DMACTLA_inst                                                             0x00A2
+#define VMA_DMACTLA_write_enable3_shift                                              (20)
+#define VMA_DMACTLA_write_enable3_mask                                               (0x00100000)
+#define VMA_DMACTLA_write_enable3(data)                                              (0x00100000&((data)<<20))
+#define VMA_DMACTLA_write_enable3_src(data)                                          ((0x00100000&(data))>>20)
+#define VMA_DMACTLA_get_write_enable3(data)                                          ((0x00100000&(data))>>20)
+#define VMA_DMACTLA_dmem_path_shift                                                  (19)
+#define VMA_DMACTLA_dmem_path_mask                                                   (0x00080000)
+#define VMA_DMACTLA_dmem_path(data)                                                  (0x00080000&((data)<<19))
+#define VMA_DMACTLA_dmem_path_src(data)                                              ((0x00080000&(data))>>19)
+#define VMA_DMACTLA_get_dmem_path(data)                                              ((0x00080000&(data))>>19)
+#define VMA_DMACTLA_write_enable2_shift                                              (18)
+#define VMA_DMACTLA_write_enable2_mask                                               (0x00040000)
+#define VMA_DMACTLA_write_enable2(data)                                              (0x00040000&((data)<<18))
+#define VMA_DMACTLA_write_enable2_src(data)                                          ((0x00040000&(data))>>18)
+#define VMA_DMACTLA_get_write_enable2(data)                                          ((0x00040000&(data))>>18)
+#define VMA_DMACTLA_ldst_vmem_count_shift                                            (2)
+#define VMA_DMACTLA_ldst_vmem_count_mask                                             (0x0003FFFC)
+#define VMA_DMACTLA_ldst_vmem_count(data)                                            (0x0003FFFC&((data)<<2))
+#define VMA_DMACTLA_ldst_vmem_count_src(data)                                        ((0x0003FFFC&(data))>>2)
+#define VMA_DMACTLA_get_ldst_vmem_count(data)                                        ((0x0003FFFC&(data))>>2)
+#define VMA_DMACTLA_write_enable1_shift                                              (1)
+#define VMA_DMACTLA_write_enable1_mask                                               (0x00000002)
+#define VMA_DMACTLA_write_enable1(data)                                              (0x00000002&((data)<<1))
+#define VMA_DMACTLA_write_enable1_src(data)                                          ((0x00000002&(data))>>1)
+#define VMA_DMACTLA_get_write_enable1(data)                                          ((0x00000002&(data))>>1)
+#define VMA_DMACTLA_post_write_disable_shift                                         (0)
+#define VMA_DMACTLA_post_write_disable_mask                                          (0x00000001)
+#define VMA_DMACTLA_post_write_disable(data)                                         (0x00000001&((data)<<0))
+#define VMA_DMACTLA_post_write_disable_src(data)                                     ((0x00000001&(data))>>0)
+#define VMA_DMACTLA_get_post_write_disable(data)                                     ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/vo_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/vo_reg.h
new file mode 100644
index 00000000..75add59
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/vo_reg.h
@@ -0,0 +1,9769 @@
+/**************************************************************
+// Spec Version                  : 0.1
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/6/6 17:44:29
+***************************************************************/
+
+
+#ifndef _VO_REG_H_INCLUDED_
+#define _VO_REG_H_INCLUDED_
+#ifdef  _VO_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     shut_down_enable:1;
+unsigned int     gating_enable:1;
+unsigned int     ch2i:1;
+unsigned int     ch2:1;
+unsigned int     ch1i:1;
+unsigned int     ch1:1;
+unsigned int     write_data:1;
+}VO_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     write_en3:1;
+unsigned int     h:2;
+unsigned int     reserved_1:1;
+unsigned int     write_en2:1;
+unsigned int     i:2;
+unsigned int     reserved_2:1;
+unsigned int     write_en1:1;
+unsigned int     p:2;
+}VO_OUT;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     i_vbi:1;
+unsigned int     vbi:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     osd1:1;
+unsigned int     sub1:1;
+unsigned int     reserved_3:1;
+unsigned int     v1:1;
+unsigned int     reserved_4:1;
+unsigned int     reserved_5:1;
+unsigned int     bg:1;
+unsigned int     write_data:1;
+}VO_MIX1;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     i_vbi:1;
+unsigned int     vbi:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:1;
+unsigned int     reserved_4:1;
+unsigned int     reserved_5:1;
+unsigned int     reserved_6:1;
+unsigned int     dd:1;
+unsigned int     reserved_7:1;
+unsigned int     bg:1;
+unsigned int     write_data:1;
+}VO_MIX2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     reserved_1:1;
+unsigned int     osd1:1;
+unsigned int     sub1:1;
+unsigned int     reserved_2:1;
+unsigned int     v1:1;
+unsigned int     reserved_3:1;
+unsigned int     mix1:1;
+unsigned int     write_data:1;
+}VO_WB;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     top_and_bottom:1;
+unsigned int     side_by_side:1;
+unsigned int     right:1;
+unsigned int     write_data:1;
+}VO_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     wbgo:1;
+unsigned int     m2go:1;
+unsigned int     m1go:1;
+unsigned int     write_data:1;
+}VO_FC;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     ref:3;
+unsigned int     pos:12;
+unsigned int     th:12;
+}VO_VBI_END;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     d3_dbh:1;
+unsigned int     d3_dbw:1;
+unsigned int     d3_dup:1;
+unsigned int     reserved_1:1;
+unsigned int     st:1;
+unsigned int     reserved_2:2;
+unsigned int     seq:1;
+unsigned int     di:1;
+unsigned int     f422:1;
+unsigned int     vs:1;
+unsigned int     vs_near:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     hs:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     topfield:1;
+unsigned int     dmaweave:1;
+unsigned int     write_data:1;
+}VO_V1;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     l:6;
+}VO_V1_DMA;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     w_c:7;
+unsigned int     reserved_1:1;
+unsigned int     w_y:7;
+unsigned int     reserved_2:1;
+unsigned int     c:7;
+unsigned int     reserved_3:1;
+unsigned int     y:7;
+}VO_V1_INDEX;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     w_c:7;
+unsigned int     reserved_1:1;
+unsigned int     w_y:7;
+unsigned int     reserved_2:1;
+unsigned int     c:7;
+unsigned int     reserved_3:1;
+unsigned int     y:7;
+}VO_V1_INDEX_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_SEQ_SA_W_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_SEQ_SA_W_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_SEQ_SA_C_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_SEQ_SA_C_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_W_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_W_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_C_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_C_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_SEQ_SA_W_Y_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_SEQ_SA_W_C_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_SEQ_SA_C_Y_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_SEQ_SA_C_C_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     w_c_en:1;
+unsigned int     w_c:3;
+unsigned int     w_y_en:1;
+unsigned int     w_y:3;
+unsigned int     c_en:1;
+unsigned int     c:3;
+unsigned int     y_en:1;
+unsigned int     y:3;
+}VO_V1_INDEX_RR;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     a:9;
+}VO_V1_ALPHA;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_V1_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     th:9;
+}VO_V1_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     mode:2;
+}VO_V1_DI;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     n_c:7;
+unsigned int     reserved_1:1;
+unsigned int     n_y:7;
+unsigned int     reserved_2:1;
+unsigned int     p_c:7;
+unsigned int     reserved_3:1;
+unsigned int     p_y:7;
+}VO_V1_DI_3F;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     n_c:7;
+unsigned int     reserved_1:1;
+unsigned int     n_y:7;
+unsigned int     reserved_2:1;
+unsigned int     p_c:7;
+unsigned int     reserved_3:1;
+unsigned int     p_y:7;
+}VO_V1_DI_3F_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_DI_SEQ_SA_N_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_DI_SEQ_SA_N_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_DI_SEQ_SA_P_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_DI_SEQ_SA_P_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_N_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_N_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_P_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_V1_SEQ_PITCH_P_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_DI_SEQ_SA_N_Y_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_DI_SEQ_SA_N_C_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_DI_SEQ_SA_P_Y_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_DI_SEQ_SA_P_C_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     n_c_en:1;
+unsigned int     n_c:3;
+unsigned int     n_y_en:1;
+unsigned int     n_y:3;
+unsigned int     p_c_en:1;
+unsigned int     p_c:3;
+unsigned int     p_y_en:1;
+unsigned int     p_y:3;
+}VO_V1_DI_3F_RR;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     n_c_en:1;
+unsigned int     n_c:3;
+unsigned int     n_y_en:1;
+unsigned int     n_y:3;
+unsigned int     p_c_en:1;
+unsigned int     p_c:3;
+unsigned int     p_y_en:1;
+unsigned int     p_y:3;
+}VO_V1_DI_3F_RR_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_MA_FR;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_MA_FR_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_MA_FW;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_V1_MA_FW_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     c_range:1;
+unsigned int     y_range:2;
+unsigned int     reserved_1:3;
+unsigned int     th_pos:5;
+unsigned int     reserved_2:1;
+unsigned int     th_prediff:7;
+unsigned int     reserved_3:2;
+unsigned int     th_refdiff:6;
+}VO_V1_INTRA;
+
+typedef struct 
+{
+unsigned int     split:1;
+unsigned int     c_intra:1;
+unsigned int     lp:1;
+unsigned int     fm:1;
+unsigned int     reserved_0:1;
+unsigned int     sc:3;
+unsigned int     th_noise:8;
+unsigned int     th_c:8;
+unsigned int     th_y:8;
+}VO_V1_MA;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     correct:1;
+unsigned int     fm:1;
+unsigned int     limit:1;
+unsigned int     weave:1;
+unsigned int     blend:1;
+unsigned int     noisy_high:1;
+unsigned int     noisy:1;
+unsigned int     ma:1;
+unsigned int     write_data:1;
+}VO_V1_MA_NEW;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     limit:8;
+unsigned int     big:8;
+unsigned int     th:8;
+}VO_V1_MA_FT;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     noisy:8;
+unsigned int     th:8;
+}VO_V1_MA_FM;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     cth_log2:3;
+unsigned int     cth_low:8;
+unsigned int     reserved_1:5;
+unsigned int     yth_log2:3;
+unsigned int     yth_low:8;
+}VO_V1_DI_BLEND;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     mode:2;
+}VO_V1_FILM;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     th:8;
+unsigned int     reserved_1:4;
+unsigned int     wad:12;
+}VO_V1_WADTB;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     e:12;
+unsigned int     reserved_1:4;
+unsigned int     s:12;
+}VO_V1_DI_YWIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     e:12;
+unsigned int     reserved_1:4;
+unsigned int     s:12;
+}VO_V1_DI_CWIN;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V1_DI_WINX;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     swad:27;
+}VO_V1_FILM_SWAD;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     th:27;
+}VO_V1_FILM_TH;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     mode:3;
+}VO_V1_DI_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     cnt:23;
+}VO_V1_STA_TOTAL;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sum:31;
+}VO_V1_STA_SUM;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     cnt:23;
+}VO_V1_STA_BKT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     sum:31;
+}VO_V1_STA_AD;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     offset:14;
+unsigned int     phase:16;
+}VO_V1_VSYI;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     offset:14;
+unsigned int     phase:16;
+}VO_V1_VSCI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_V1_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_V1_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V1_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V1_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     offset:13;
+unsigned int     phase:16;
+}VO_V1_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_V1_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_V1_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V1_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_V1_HSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_V1_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_V1_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_V1_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_V1_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_V1_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     a2:9;
+unsigned int     a1:9;
+unsigned int     a0:9;
+}VO_V1_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     d3_dbh:1;
+unsigned int     d3_vdup:1;
+unsigned int     d3_dbw:1;
+unsigned int     d3_dup:1;
+unsigned int     rgb_out:1;
+unsigned int     reserved_1:1;
+unsigned int     dvd:1;
+unsigned int     hddvd:1;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:1;
+unsigned int     hl:1;
+unsigned int     reserved_4:1;
+unsigned int     dvb:1;
+unsigned int     osd:1;
+unsigned int     fetch_1080i:1;
+unsigned int     odd_1080i:1;
+unsigned int     reserved_5:1;
+unsigned int     reserved_6:1;
+unsigned int     reserved_7:1;
+unsigned int     vs:1;
+unsigned int     vs_near:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     hs:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     reserved_8:1;
+unsigned int     reserved_9:1;
+unsigned int     reserved_10:1;
+unsigned int     write_data:1;
+}VO_SUB1;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     ref:3;
+unsigned int     pos:12;
+unsigned int     th:12;
+}VO_SUB1_START;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     w:12;
+}VO_SUB1_SUBP;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     w:11;
+unsigned int     reserved_1:1;
+unsigned int     h:11;
+}VO_SUB1_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     th:9;
+}VO_SUB1_BUF;
+
+typedef struct 
+{
+unsigned int     endian:1;
+unsigned int     a:31;
+}VO_SUB1_WI;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_SUB1_WI_3D;
+
+typedef struct 
+{
+unsigned int     keep:1;
+unsigned int     a:31;
+}VO_SUB1_CLUT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_SUB1_PXDT;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_SUB1_PXDB;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     num:11;
+}VO_SUB1_LC;
+
+typedef struct 
+{
+unsigned int     a3:4;
+unsigned int     a2:4;
+unsigned int     a1:4;
+unsigned int     a0:4;
+unsigned int     i3:4;
+unsigned int     i2:4;
+unsigned int     i1:4;
+unsigned int     i0:4;
+}VO_SUB1_DFT;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     e:11;
+unsigned int     reserved_1:1;
+unsigned int     s:11;
+}VO_SUB1_HLX;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     e:11;
+unsigned int     reserved_1:1;
+unsigned int     s:11;
+}VO_SUB1_HLY;
+
+typedef struct 
+{
+unsigned int     a3:4;
+unsigned int     a2:4;
+unsigned int     a1:4;
+unsigned int     a0:4;
+unsigned int     i3:4;
+unsigned int     i2:4;
+unsigned int     i1:4;
+unsigned int     i0:4;
+}VO_SUB1_HL;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_SUB1_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_SUB1_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_SUB1_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_SUB1_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_SUB1_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     a2:9;
+unsigned int     a1:9;
+unsigned int     a0:9;
+}VO_SUB1_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     offset:12;
+unsigned int     phase:16;
+}VO_SUB1_VSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_SUB1_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_SUB1_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB1_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB1_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     offset:11;
+unsigned int     phase:16;
+}VO_SUB1_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_SUB1_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_SUB1_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB1_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_SUB1_HSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     d3_dbh:1;
+unsigned int     d3_vdup:1;
+unsigned int     d3_dbw:1;
+unsigned int     d3_dup:1;
+unsigned int     rgb_out:1;
+unsigned int     reserved_1:6;
+unsigned int     reserved_2:1;
+unsigned int     dvb:1;
+unsigned int     osd:1;
+unsigned int     fetch_1080i:1;
+unsigned int     odd_1080i:1;
+unsigned int     reserved_3:1;
+unsigned int     reserved_4:1;
+unsigned int     reserved_5:1;
+unsigned int     vs:1;
+unsigned int     vs_near:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     hs:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     reserved_6:1;
+unsigned int     reserved_7:1;
+unsigned int     reserved_8:1;
+unsigned int     write_data:1;
+}VO_OSD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     ref:3;
+unsigned int     pos:12;
+unsigned int     th:12;
+}VO_OSD1_START;
+
+typedef struct 
+{
+unsigned int     endian:1;
+unsigned int     a:31;
+}VO_OSD1_WI;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_OSD1_WI_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:9;
+unsigned int     w:11;
+unsigned int     reserved_1:1;
+unsigned int     h:11;
+}VO_OSD1_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     th:9;
+}VO_OSD1_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_OSD1_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_OSD1_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_OSD1_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_OSD1_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_OSD1_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     a2:9;
+unsigned int     a1:9;
+unsigned int     a0:9;
+}VO_OSD1_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     offset:12;
+unsigned int     phase:16;
+}VO_OSD1_VSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_OSD1_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_OSD1_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_OSD1_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_OSD1_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     offset:11;
+unsigned int     phase:16;
+}VO_OSD1_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_OSD1_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_OSD1_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_OSD1_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_OSD1_HSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     dd_seq:1;
+unsigned int     wb_seq:1;
+unsigned int     h2v:1;
+unsigned int     hd:1;
+unsigned int     f422:1;
+unsigned int     reint:1;
+unsigned int     bot:1;
+unsigned int     reserved_1:1;
+unsigned int     vs_yodd:1;
+unsigned int     vs_codd:1;
+unsigned int     reserved_2:1;
+unsigned int     hs_yodd:1;
+unsigned int     hs_codd:1;
+unsigned int     write_data:1;
+}VO_DDWB;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     write_en2:1;
+unsigned int     hs_sel:2;
+unsigned int     reserved_1:1;
+unsigned int     write_en1:1;
+unsigned int     vs_sel:2;
+}VO_DDWB_SEL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en5:1;
+unsigned int     interlace:1;
+unsigned int     write_en4:1;
+unsigned int     bot:1;
+unsigned int     reserved_1:8;
+unsigned int     write_en2:1;
+unsigned int     c:7;
+unsigned int     write_en1:1;
+unsigned int     y:7;
+}VO_DD_INDEX;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_DD_SEQ_SA_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_DD_SEQ_PITCH_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_DD_SEQ_SA_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_DD_SEQ_PITCH_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     write_en5:1;
+unsigned int     interlace:1;
+unsigned int     write_en4:1;
+unsigned int     bot:1;
+unsigned int     reserved_1:8;
+unsigned int     write_en2:1;
+unsigned int     c:7;
+unsigned int     write_en1:1;
+unsigned int     y:7;
+}VO_WB_INDEX;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_WB_SEQ_SA_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_WB_SEQ_PITCH_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_WB_SEQ_SA_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     p:16;
+}VO_WB_SEQ_PITCH_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_DD_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_WB_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     w:13;
+unsigned int     h:12;
+}VO_FS_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     num:8;
+}VO_WB_TPC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     offset:13;
+unsigned int     phase:16;
+}VO_DDWB_VSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_DDWB_VSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     out:12;
+}VO_DDWB_VSD_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_DDWB_VSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_DDWB_VSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     offset:13;
+unsigned int     phase:16;
+}VO_DDWB_HSI;
+
+typedef struct 
+{
+unsigned int     reserved_0:11;
+unsigned int     delta:21;
+}VO_DDWB_HSD;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     out:13;
+}VO_DDWB_HSD_W;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_DDWB_HSYC;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     c1:14;
+unsigned int     reserved_1:2;
+unsigned int     c0:14;
+}VO_DDWB_HSCC;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_VBI1;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     l:18;
+}VO_VBI1_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     a:31;
+}VO_VBI2;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     l:18;
+}VO_VBI2_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     write_en4:1;
+unsigned int     num_req_4:1;
+unsigned int     write_en3:1;
+unsigned int     dyn_id:1;
+unsigned int     write_en2:1;
+unsigned int     ref_mix:1;
+unsigned int     reserved_1:2;
+unsigned int     write_en1:1;
+unsigned int     l:5;
+}VO_DMA;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     wb:4;
+unsigned int     vbi:4;
+unsigned int     reserved_1:4;
+unsigned int     dd:4;
+unsigned int     reserved_2:4;
+unsigned int     v1:4;
+}VO_DMA_PV;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     reserved_1:4;
+unsigned int     reserved_2:4;
+unsigned int     osd1:4;
+unsigned int     sub1:4;
+}VO_DMA_PG;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     write_en3:1;
+unsigned int     init:8;
+unsigned int     reserved_1:3;
+unsigned int     write_en2:1;
+unsigned int     interval:8;
+unsigned int     reserved_2:2;
+unsigned int     write_en1:1;
+unsigned int     num:5;
+}VO_DMA_BWC;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     update:1;
+unsigned int     write_data:1;
+}VO_DMA_UPDATE;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_V1_Y0;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_V1_Y1;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_V1_Y2;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_V1_Y3;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_V1_C0;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_V1_C1;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_V1_C2;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_V1_C3;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_V1DI;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_SUB1_WI;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_SUB1_D0;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_SUB1_D1;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_OSD1_WI;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_OSD1_D0;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_OSD1_D1;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_DD_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_DD_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_VBI1;
+
+typedef struct 
+{
+unsigned int     reserved_0:10;
+unsigned int     depth:10;
+unsigned int     reserved_1:2;
+unsigned int     sa:10;
+}VO_DMA_VBI2;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     depth:7;
+unsigned int     reserved_1:5;
+unsigned int     sa:7;
+}VO_DMA_WB_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     depth:7;
+unsigned int     reserved_1:5;
+unsigned int     sa:7;
+}VO_DMA_WB_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:13;
+unsigned int     depth:7;
+unsigned int     reserved_1:5;
+unsigned int     sa:7;
+}VO_DMA_WB_V1;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     reserved_1:4;
+unsigned int     osd1:4;
+unsigned int     reserved_2:4;
+unsigned int     sub1:4;
+unsigned int     v1:4;
+unsigned int     reserved_3:4;
+unsigned int     reserved_4:4;
+}VO_MIX_ORDER;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     cd:1;
+unsigned int     cu:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     v1b:1;
+unsigned int     write_data:1;
+}VO_MIX;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     cr:8;
+unsigned int     cb:8;
+unsigned int     y:8;
+}VO_M1BG;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     w:13;
+unsigned int     reserved_1:3;
+unsigned int     h:13;
+}VO_M1_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     cr:8;
+unsigned int     cb:8;
+unsigned int     y:8;
+}VO_M2BG;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     w:13;
+unsigned int     reserved_1:3;
+unsigned int     h:13;
+}VO_M2_SIZE;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_V1_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     cr:8;
+unsigned int     cb:8;
+unsigned int     y:8;
+}VO_V1B_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V1B_X;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     e:13;
+unsigned int     reserved_1:3;
+unsigned int     s:13;
+}VO_V1B_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     dir_r:1;
+unsigned int     offset_r:13;
+unsigned int     reserved_1:2;
+unsigned int     dir_l:1;
+unsigned int     offset_l:13;
+}VO_V1_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_SUB1_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     dir_r:1;
+unsigned int     offset_r:13;
+unsigned int     reserved_1:2;
+unsigned int     dir_l:1;
+unsigned int     offset_l:13;
+}VO_SUB1_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_OSD1_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     dir_r:1;
+unsigned int     offset_r:13;
+unsigned int     reserved_1:2;
+unsigned int     dir_l:1;
+unsigned int     offset_l:13;
+}VO_OSD1_3D;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     x:13;
+unsigned int     reserved_1:3;
+unsigned int     y:13;
+}VO_DD_XY;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     th:11;
+unsigned int     write_en1:1;
+unsigned int     b:11;
+}VO_CH1_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     th:11;
+unsigned int     write_en1:1;
+unsigned int     b:11;
+}VO_CHI_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     write_en2:1;
+unsigned int     th:11;
+unsigned int     write_en1:1;
+unsigned int     b:11;
+}VO_CH2_BUF;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     itop:1;
+unsigned int     ireint:1;
+unsigned int     reserved_1:1;
+unsigned int     top:1;
+unsigned int     reint:1;
+unsigned int     write_data:1;
+}VO_CH1;
+
+typedef struct 
+{
+unsigned int     reserved_0:26;
+unsigned int     itop:1;
+unsigned int     ireint:1;
+unsigned int     reserved_1:1;
+unsigned int     top:1;
+unsigned int     reint:1;
+unsigned int     write_data:1;
+}VO_CH2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_PORT_L_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_PORT_L_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_PORT_L_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_PORT_L_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_PORT_L_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     a2:10;
+unsigned int     a1:10;
+unsigned int     a0:10;
+}VO_PORT_L_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     rmax:8;
+unsigned int     rmin:8;
+}VO_PORT_L_LMT_R;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     gmax:8;
+unsigned int     gmin:8;
+}VO_PORT_L_LMT_G;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     bmax:8;
+unsigned int     bmin:8;
+}VO_PORT_L_LMT_B;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     pport:1;
+}VO_PORT_L_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m01:14;
+unsigned int     reserved_1:2;
+unsigned int     m00:14;
+}VO_PORT_I_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m10:14;
+unsigned int     reserved_1:2;
+unsigned int     m02:14;
+}VO_PORT_I_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m12:14;
+unsigned int     reserved_1:2;
+unsigned int     m11:14;
+}VO_PORT_I_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:2;
+unsigned int     m21:14;
+unsigned int     reserved_1:2;
+unsigned int     m20:14;
+}VO_PORT_I_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     m22:14;
+}VO_PORT_I_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     a2:9;
+unsigned int     a1:9;
+unsigned int     a0:9;
+}VO_PORT_I_CC6;
+
+typedef struct 
+{
+unsigned int     cmax:8;
+unsigned int     cmin:8;
+unsigned int     ymax:8;
+unsigned int     ymin:8;
+}VO_PORT_I_LMT;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m00:18;
+}VO_PORT_H_CC1;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m01:18;
+}VO_PORT_H_CC2;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m02:18;
+}VO_PORT_H_CC3;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m10:18;
+}VO_PORT_H_CC4;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m11:18;
+}VO_PORT_H_CC5;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m12:18;
+}VO_PORT_H_CC6;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m20:18;
+}VO_PORT_H_CC7;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m21:18;
+}VO_PORT_H_CC8;
+
+typedef struct 
+{
+unsigned int     reserved_0:14;
+unsigned int     m22:18;
+}VO_PORT_H_CC9;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     a1:13;
+unsigned int     reserved_1:1;
+unsigned int     a0:13;
+}VO_PORT_H_CC10;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     a2:13;
+}VO_PORT_H_CC11;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     ymax:12;
+unsigned int     reserved_1:4;
+unsigned int     ymin:12;
+}VO_PORT_H_LMT_Y;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     cmax:12;
+unsigned int     reserved_1:4;
+unsigned int     cmin:12;
+}VO_PORT_H_LMT_C;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     lvds:1;
+unsigned int     write_data:1;
+}VO_SYNC;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     lvds:8;
+}VO_SYNC_DELAY;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:1;
+unsigned int     h_under:1;
+unsigned int     i_under:1;
+unsigned int     p_under:1;
+unsigned int     sub1:1;
+unsigned int     wbfin:1;
+unsigned int     m2fin:1;
+unsigned int     m1fin:1;
+unsigned int     write_data:1;
+}VO_INTEN;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:1;
+unsigned int     h_under:1;
+unsigned int     i_under:1;
+unsigned int     p_under:1;
+unsigned int     sub1:1;
+unsigned int     wbfin:1;
+unsigned int     m2fin:1;
+unsigned int     m1fin:1;
+unsigned int     write_data:1;
+}VO_INTST;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     tve_h_fetch:1;
+unsigned int     tve_i_fetch:1;
+unsigned int     tve_p_fetch:1;
+unsigned int     reserved_1:1;
+unsigned int     dd:1;
+unsigned int     reserved_2:1;
+unsigned int     reserved_3:1;
+unsigned int     osd1:1;
+unsigned int     sub1:1;
+unsigned int     reserved_4:1;
+unsigned int     v1:1;
+unsigned int     wb:1;
+unsigned int     mix2:1;
+unsigned int     mix1:1;
+}VO_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     udf_en:1;
+unsigned int     disp_en:1;
+unsigned int     delay_en:1;
+}VO_MON_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     wb:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     dd:1;
+unsigned int     reserved_3:1;
+unsigned int     osd1:1;
+unsigned int     sub1:1;
+unsigned int     reserved_4:1;
+unsigned int     v1:1;
+unsigned int     ch2:1;
+unsigned int     ch1_i:1;
+unsigned int     ch1_p:1;
+unsigned int     reserved_5:5;
+unsigned int     th:11;
+}VO_MON_SETUP;
+
+typedef struct 
+{
+unsigned int     delay:16;
+unsigned int     reserved_0:7;
+unsigned int     wb:1;
+unsigned int     reserved_1:1;
+unsigned int     reserved_2:1;
+unsigned int     dd:1;
+unsigned int     reserved_3:1;
+unsigned int     osd1:1;
+unsigned int     sub1:1;
+unsigned int     reserved_4:1;
+unsigned int     v1:1;
+}VO_MON_DLY;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     not_full:13;
+}VO_MON_DISP;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     y:13;
+}VO_MON_UF_I;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     y:13;
+}VO_MON_UF_P;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     y:13;
+}VO_MON_UF_H;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}VO_MON_UF_V1;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}VO_MON_UF_SUB1;
+
+typedef struct 
+{
+unsigned int     reserved_0:23;
+unsigned int     cnt:9;
+}VO_MON_UF_OSD1;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     write_en3:1;
+unsigned int     sel1:8;
+unsigned int     reserved_1:3;
+unsigned int     write_en2:1;
+unsigned int     sel0:8;
+unsigned int     reserved_2:2;
+unsigned int     write_en1:1;
+unsigned int     en:1;
+}VO_DBG;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     ramp_8:1;
+unsigned int     ramp_4:1;
+unsigned int     ramp_2:1;
+unsigned int     ramp_1:1;
+unsigned int     go:1;
+unsigned int     en:1;
+unsigned int     write_data:1;
+}VO_DACT;
+
+typedef struct 
+{
+unsigned int     reserved_0:21;
+unsigned int     l:11;
+}VO_DACT_L;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     a:10;
+}VO_DACT_R;
+
+typedef struct 
+{
+unsigned int     reserved_0:22;
+unsigned int     a:10;
+}VO_DACT_A;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     d:16;
+}VO_DACT_D;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     en:1;
+unsigned int     write_data:1;
+}VO_RBRAM;
+
+typedef struct 
+{
+unsigned int     mode:32;
+}VO_VERF;
+
+typedef struct 
+{
+unsigned int     reserved_0:19;
+unsigned int     rme_2:1;
+unsigned int     rm_2:4;
+unsigned int     reserved_1:3;
+unsigned int     rme_1:1;
+unsigned int     rm_1:4;
+}VO_SRAM_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:12;
+unsigned int     drf_start_pause_5:1;
+unsigned int     drf_test_resume_5:1;
+unsigned int     drf_bist_mode_5:1;
+unsigned int     bist_mode_5:1;
+unsigned int     drf_start_pause_4:1;
+unsigned int     drf_test_resume_4:1;
+unsigned int     drf_bist_mode_4:1;
+unsigned int     bist_mode_4:1;
+unsigned int     drf_start_pause_3:1;
+unsigned int     drf_test_resume_3:1;
+unsigned int     drf_bist_mode_3:1;
+unsigned int     bist_mode_3:1;
+unsigned int     drf_start_pause_2:1;
+unsigned int     drf_test_resume_2:1;
+unsigned int     drf_bist_mode_2:1;
+unsigned int     bist_mode_2:1;
+unsigned int     drf_start_pause_1:1;
+unsigned int     drf_test_resume_1:1;
+unsigned int     drf_bist_mode_1:1;
+unsigned int     bist_mode_1:1;
+}VO_MBIST;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     fail_5_1:1;
+unsigned int     fail_5_0:1;
+unsigned int     fail_4_4:1;
+unsigned int     fail_4_3:1;
+unsigned int     fail_4_2:1;
+unsigned int     fail_4_1:1;
+unsigned int     fail_4_0:1;
+unsigned int     fail_3_3:1;
+unsigned int     fail_3_2:1;
+unsigned int     fail_3_1:1;
+unsigned int     fail_3_0:1;
+unsigned int     fail_2_3:1;
+unsigned int     fail_2_2:1;
+unsigned int     fail_2_1:1;
+unsigned int     fail_2_0:1;
+unsigned int     reserved_1:1;
+unsigned int     fail_1_2:1;
+unsigned int     fail_1_1:1;
+unsigned int     fail_1_0:1;
+unsigned int     reserved_2:3;
+unsigned int     done_5:1;
+unsigned int     done_4:1;
+unsigned int     done_3:1;
+unsigned int     done_2:1;
+unsigned int     done_1:1;
+}VO_MBIST_OUT;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     fail_5_1:1;
+unsigned int     fail_5_0:1;
+unsigned int     fail_4_4:1;
+unsigned int     fail_4_3:1;
+unsigned int     fail_4_2:1;
+unsigned int     fail_4_1:1;
+unsigned int     fail_4_0:1;
+unsigned int     fail_3_3:1;
+unsigned int     fail_3_2:1;
+unsigned int     fail_3_1:1;
+unsigned int     fail_3_0:1;
+unsigned int     fail_2_3:1;
+unsigned int     fail_2_2:1;
+unsigned int     fail_2_1:1;
+unsigned int     fail_2_0:1;
+unsigned int     reserved_1:1;
+unsigned int     fail_1_2:1;
+unsigned int     fail_1_1:1;
+unsigned int     fail_1_0:1;
+unsigned int     reserved_2:3;
+unsigned int     done_5:1;
+unsigned int     done_4:1;
+unsigned int     done_3:1;
+unsigned int     done_2:1;
+unsigned int     done_1:1;
+}VO_DRF_MBIST_OUT;
+
+#endif
+
+#define VO_MODE                                                                      0x18005000
+#define VO_MODE_reg_addr                                                             "0xB8005000"
+#define VO_MODE_reg                                                                  0xB8005000
+#define set_VO_MODE_reg(data)   (*((volatile unsigned int*) VO_MODE_reg)=data)
+#define get_VO_MODE_reg   (*((volatile unsigned int*) VO_MODE_reg))
+#define VO_MODE_inst_adr                                                             "0x0000"
+#define VO_MODE_inst                                                                 0x0000
+#define VO_MODE_shut_down_enable_shift                                               (6)
+#define VO_MODE_shut_down_enable_mask                                                (0x00000040)
+#define VO_MODE_shut_down_enable(data)                                               (0x00000040&((data)<<6))
+#define VO_MODE_shut_down_enable_src(data)                                           ((0x00000040&(data))>>6)
+#define VO_MODE_get_shut_down_enable(data)                                           ((0x00000040&(data))>>6)
+#define VO_MODE_gating_enable_shift                                                  (5)
+#define VO_MODE_gating_enable_mask                                                   (0x00000020)
+#define VO_MODE_gating_enable(data)                                                  (0x00000020&((data)<<5))
+#define VO_MODE_gating_enable_src(data)                                              ((0x00000020&(data))>>5)
+#define VO_MODE_get_gating_enable(data)                                              ((0x00000020&(data))>>5)
+#define VO_MODE_ch2i_shift                                                           (4)
+#define VO_MODE_ch2i_mask                                                            (0x00000010)
+#define VO_MODE_ch2i(data)                                                           (0x00000010&((data)<<4))
+#define VO_MODE_ch2i_src(data)                                                       ((0x00000010&(data))>>4)
+#define VO_MODE_get_ch2i(data)                                                       ((0x00000010&(data))>>4)
+#define VO_MODE_ch2_shift                                                            (3)
+#define VO_MODE_ch2_mask                                                             (0x00000008)
+#define VO_MODE_ch2(data)                                                            (0x00000008&((data)<<3))
+#define VO_MODE_ch2_src(data)                                                        ((0x00000008&(data))>>3)
+#define VO_MODE_get_ch2(data)                                                        ((0x00000008&(data))>>3)
+#define VO_MODE_ch1i_shift                                                           (2)
+#define VO_MODE_ch1i_mask                                                            (0x00000004)
+#define VO_MODE_ch1i(data)                                                           (0x00000004&((data)<<2))
+#define VO_MODE_ch1i_src(data)                                                       ((0x00000004&(data))>>2)
+#define VO_MODE_get_ch1i(data)                                                       ((0x00000004&(data))>>2)
+#define VO_MODE_ch1_shift                                                            (1)
+#define VO_MODE_ch1_mask                                                             (0x00000002)
+#define VO_MODE_ch1(data)                                                            (0x00000002&((data)<<1))
+#define VO_MODE_ch1_src(data)                                                        ((0x00000002&(data))>>1)
+#define VO_MODE_get_ch1(data)                                                        ((0x00000002&(data))>>1)
+#define VO_MODE_write_data_shift                                                     (0)
+#define VO_MODE_write_data_mask                                                      (0x00000001)
+#define VO_MODE_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_MODE_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_MODE_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_OUT                                                                       0x18005004
+#define VO_OUT_reg_addr                                                              "0xB8005004"
+#define VO_OUT_reg                                                                   0xB8005004
+#define set_VO_OUT_reg(data)   (*((volatile unsigned int*) VO_OUT_reg)=data)
+#define get_VO_OUT_reg   (*((volatile unsigned int*) VO_OUT_reg))
+#define VO_OUT_inst_adr                                                              "0x0001"
+#define VO_OUT_inst                                                                  0x0001
+#define VO_OUT_write_en3_shift                                                       (10)
+#define VO_OUT_write_en3_mask                                                        (0x00000400)
+#define VO_OUT_write_en3(data)                                                       (0x00000400&((data)<<10))
+#define VO_OUT_write_en3_src(data)                                                   ((0x00000400&(data))>>10)
+#define VO_OUT_get_write_en3(data)                                                   ((0x00000400&(data))>>10)
+#define VO_OUT_h_shift                                                               (8)
+#define VO_OUT_h_mask                                                                (0x00000300)
+#define VO_OUT_h(data)                                                               (0x00000300&((data)<<8))
+#define VO_OUT_h_src(data)                                                           ((0x00000300&(data))>>8)
+#define VO_OUT_get_h(data)                                                           ((0x00000300&(data))>>8)
+#define VO_OUT_write_en2_shift                                                       (6)
+#define VO_OUT_write_en2_mask                                                        (0x00000040)
+#define VO_OUT_write_en2(data)                                                       (0x00000040&((data)<<6))
+#define VO_OUT_write_en2_src(data)                                                   ((0x00000040&(data))>>6)
+#define VO_OUT_get_write_en2(data)                                                   ((0x00000040&(data))>>6)
+#define VO_OUT_i_shift                                                               (4)
+#define VO_OUT_i_mask                                                                (0x00000030)
+#define VO_OUT_i(data)                                                               (0x00000030&((data)<<4))
+#define VO_OUT_i_src(data)                                                           ((0x00000030&(data))>>4)
+#define VO_OUT_get_i(data)                                                           ((0x00000030&(data))>>4)
+#define VO_OUT_write_en1_shift                                                       (2)
+#define VO_OUT_write_en1_mask                                                        (0x00000004)
+#define VO_OUT_write_en1(data)                                                       (0x00000004&((data)<<2))
+#define VO_OUT_write_en1_src(data)                                                   ((0x00000004&(data))>>2)
+#define VO_OUT_get_write_en1(data)                                                   ((0x00000004&(data))>>2)
+#define VO_OUT_p_shift                                                               (0)
+#define VO_OUT_p_mask                                                                (0x00000003)
+#define VO_OUT_p(data)                                                               (0x00000003&((data)<<0))
+#define VO_OUT_p_src(data)                                                           ((0x00000003&(data))>>0)
+#define VO_OUT_get_p(data)                                                           ((0x00000003&(data))>>0)
+
+
+#define VO_MIX1                                                                      0x18005008
+#define VO_MIX1_reg_addr                                                             "0xB8005008"
+#define VO_MIX1_reg                                                                  0xB8005008
+#define set_VO_MIX1_reg(data)   (*((volatile unsigned int*) VO_MIX1_reg)=data)
+#define get_VO_MIX1_reg   (*((volatile unsigned int*) VO_MIX1_reg))
+#define VO_MIX1_inst_adr                                                             "0x0002"
+#define VO_MIX1_inst                                                                 0x0002
+#define VO_MIX1_i_vbi_shift                                                          (11)
+#define VO_MIX1_i_vbi_mask                                                           (0x00000800)
+#define VO_MIX1_i_vbi(data)                                                          (0x00000800&((data)<<11))
+#define VO_MIX1_i_vbi_src(data)                                                      ((0x00000800&(data))>>11)
+#define VO_MIX1_get_i_vbi(data)                                                      ((0x00000800&(data))>>11)
+#define VO_MIX1_vbi_shift                                                            (10)
+#define VO_MIX1_vbi_mask                                                             (0x00000400)
+#define VO_MIX1_vbi(data)                                                            (0x00000400&((data)<<10))
+#define VO_MIX1_vbi_src(data)                                                        ((0x00000400&(data))>>10)
+#define VO_MIX1_get_vbi(data)                                                        ((0x00000400&(data))>>10)
+#define VO_MIX1_osd1_shift                                                           (7)
+#define VO_MIX1_osd1_mask                                                            (0x00000080)
+#define VO_MIX1_osd1(data)                                                           (0x00000080&((data)<<7))
+#define VO_MIX1_osd1_src(data)                                                       ((0x00000080&(data))>>7)
+#define VO_MIX1_get_osd1(data)                                                       ((0x00000080&(data))>>7)
+#define VO_MIX1_sub1_shift                                                           (6)
+#define VO_MIX1_sub1_mask                                                            (0x00000040)
+#define VO_MIX1_sub1(data)                                                           (0x00000040&((data)<<6))
+#define VO_MIX1_sub1_src(data)                                                       ((0x00000040&(data))>>6)
+#define VO_MIX1_get_sub1(data)                                                       ((0x00000040&(data))>>6)
+#define VO_MIX1_v1_shift                                                             (4)
+#define VO_MIX1_v1_mask                                                              (0x00000010)
+#define VO_MIX1_v1(data)                                                             (0x00000010&((data)<<4))
+#define VO_MIX1_v1_src(data)                                                         ((0x00000010&(data))>>4)
+#define VO_MIX1_get_v1(data)                                                         ((0x00000010&(data))>>4)
+#define VO_MIX1_bg_shift                                                             (1)
+#define VO_MIX1_bg_mask                                                              (0x00000002)
+#define VO_MIX1_bg(data)                                                             (0x00000002&((data)<<1))
+#define VO_MIX1_bg_src(data)                                                         ((0x00000002&(data))>>1)
+#define VO_MIX1_get_bg(data)                                                         ((0x00000002&(data))>>1)
+#define VO_MIX1_write_data_shift                                                     (0)
+#define VO_MIX1_write_data_mask                                                      (0x00000001)
+#define VO_MIX1_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_MIX1_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_MIX1_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_MIX2                                                                      0x1800500C
+#define VO_MIX2_reg_addr                                                             "0xB800500C"
+#define VO_MIX2_reg                                                                  0xB800500C
+#define set_VO_MIX2_reg(data)   (*((volatile unsigned int*) VO_MIX2_reg)=data)
+#define get_VO_MIX2_reg   (*((volatile unsigned int*) VO_MIX2_reg))
+#define VO_MIX2_inst_adr                                                             "0x0003"
+#define VO_MIX2_inst                                                                 0x0003
+#define VO_MIX2_i_vbi_shift                                                          (11)
+#define VO_MIX2_i_vbi_mask                                                           (0x00000800)
+#define VO_MIX2_i_vbi(data)                                                          (0x00000800&((data)<<11))
+#define VO_MIX2_i_vbi_src(data)                                                      ((0x00000800&(data))>>11)
+#define VO_MIX2_get_i_vbi(data)                                                      ((0x00000800&(data))>>11)
+#define VO_MIX2_vbi_shift                                                            (10)
+#define VO_MIX2_vbi_mask                                                             (0x00000400)
+#define VO_MIX2_vbi(data)                                                            (0x00000400&((data)<<10))
+#define VO_MIX2_vbi_src(data)                                                        ((0x00000400&(data))>>10)
+#define VO_MIX2_get_vbi(data)                                                        ((0x00000400&(data))>>10)
+#define VO_MIX2_dd_shift                                                             (3)
+#define VO_MIX2_dd_mask                                                              (0x00000008)
+#define VO_MIX2_dd(data)                                                             (0x00000008&((data)<<3))
+#define VO_MIX2_dd_src(data)                                                         ((0x00000008&(data))>>3)
+#define VO_MIX2_get_dd(data)                                                         ((0x00000008&(data))>>3)
+#define VO_MIX2_bg_shift                                                             (1)
+#define VO_MIX2_bg_mask                                                              (0x00000002)
+#define VO_MIX2_bg(data)                                                             (0x00000002&((data)<<1))
+#define VO_MIX2_bg_src(data)                                                         ((0x00000002&(data))>>1)
+#define VO_MIX2_get_bg(data)                                                         ((0x00000002&(data))>>1)
+#define VO_MIX2_write_data_shift                                                     (0)
+#define VO_MIX2_write_data_mask                                                      (0x00000001)
+#define VO_MIX2_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_MIX2_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_MIX2_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_WB                                                                        0x18005010
+#define VO_WB_reg_addr                                                               "0xB8005010"
+#define VO_WB_reg                                                                    0xB8005010
+#define set_VO_WB_reg(data)   (*((volatile unsigned int*) VO_WB_reg)=data)
+#define get_VO_WB_reg   (*((volatile unsigned int*) VO_WB_reg))
+#define VO_WB_inst_adr                                                               "0x0004"
+#define VO_WB_inst                                                                   0x0004
+#define VO_WB_osd1_shift                                                             (6)
+#define VO_WB_osd1_mask                                                              (0x00000040)
+#define VO_WB_osd1(data)                                                             (0x00000040&((data)<<6))
+#define VO_WB_osd1_src(data)                                                         ((0x00000040&(data))>>6)
+#define VO_WB_get_osd1(data)                                                         ((0x00000040&(data))>>6)
+#define VO_WB_sub1_shift                                                             (5)
+#define VO_WB_sub1_mask                                                              (0x00000020)
+#define VO_WB_sub1(data)                                                             (0x00000020&((data)<<5))
+#define VO_WB_sub1_src(data)                                                         ((0x00000020&(data))>>5)
+#define VO_WB_get_sub1(data)                                                         ((0x00000020&(data))>>5)
+#define VO_WB_v1_shift                                                               (3)
+#define VO_WB_v1_mask                                                                (0x00000008)
+#define VO_WB_v1(data)                                                               (0x00000008&((data)<<3))
+#define VO_WB_v1_src(data)                                                           ((0x00000008&(data))>>3)
+#define VO_WB_get_v1(data)                                                           ((0x00000008&(data))>>3)
+#define VO_WB_mix1_shift                                                             (1)
+#define VO_WB_mix1_mask                                                              (0x00000002)
+#define VO_WB_mix1(data)                                                             (0x00000002&((data)<<1))
+#define VO_WB_mix1_src(data)                                                         ((0x00000002&(data))>>1)
+#define VO_WB_get_mix1(data)                                                         ((0x00000002&(data))>>1)
+#define VO_WB_write_data_shift                                                       (0)
+#define VO_WB_write_data_mask                                                        (0x00000001)
+#define VO_WB_write_data(data)                                                       (0x00000001&((data)<<0))
+#define VO_WB_write_data_src(data)                                                   ((0x00000001&(data))>>0)
+#define VO_WB_get_write_data(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define VO_3D                                                                        0x18005014
+#define VO_3D_reg_addr                                                               "0xB8005014"
+#define VO_3D_reg                                                                    0xB8005014
+#define set_VO_3D_reg(data)   (*((volatile unsigned int*) VO_3D_reg)=data)
+#define get_VO_3D_reg   (*((volatile unsigned int*) VO_3D_reg))
+#define VO_3D_inst_adr                                                               "0x0005"
+#define VO_3D_inst                                                                   0x0005
+#define VO_3D_top_and_bottom_shift                                                   (3)
+#define VO_3D_top_and_bottom_mask                                                    (0x00000008)
+#define VO_3D_top_and_bottom(data)                                                   (0x00000008&((data)<<3))
+#define VO_3D_top_and_bottom_src(data)                                               ((0x00000008&(data))>>3)
+#define VO_3D_get_top_and_bottom(data)                                               ((0x00000008&(data))>>3)
+#define VO_3D_side_by_side_shift                                                     (2)
+#define VO_3D_side_by_side_mask                                                      (0x00000004)
+#define VO_3D_side_by_side(data)                                                     (0x00000004&((data)<<2))
+#define VO_3D_side_by_side_src(data)                                                 ((0x00000004&(data))>>2)
+#define VO_3D_get_side_by_side(data)                                                 ((0x00000004&(data))>>2)
+#define VO_3D_right_shift                                                            (1)
+#define VO_3D_right_mask                                                             (0x00000002)
+#define VO_3D_right(data)                                                            (0x00000002&((data)<<1))
+#define VO_3D_right_src(data)                                                        ((0x00000002&(data))>>1)
+#define VO_3D_get_right(data)                                                        ((0x00000002&(data))>>1)
+#define VO_3D_write_data_shift                                                       (0)
+#define VO_3D_write_data_mask                                                        (0x00000001)
+#define VO_3D_write_data(data)                                                       (0x00000001&((data)<<0))
+#define VO_3D_write_data_src(data)                                                   ((0x00000001&(data))>>0)
+#define VO_3D_get_write_data(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define VO_FC                                                                        0x18005018
+#define VO_FC_reg_addr                                                               "0xB8005018"
+#define VO_FC_reg                                                                    0xB8005018
+#define set_VO_FC_reg(data)   (*((volatile unsigned int*) VO_FC_reg)=data)
+#define get_VO_FC_reg   (*((volatile unsigned int*) VO_FC_reg))
+#define VO_FC_inst_adr                                                               "0x0006"
+#define VO_FC_inst                                                                   0x0006
+#define VO_FC_wbgo_shift                                                             (3)
+#define VO_FC_wbgo_mask                                                              (0x00000008)
+#define VO_FC_wbgo(data)                                                             (0x00000008&((data)<<3))
+#define VO_FC_wbgo_src(data)                                                         ((0x00000008&(data))>>3)
+#define VO_FC_get_wbgo(data)                                                         ((0x00000008&(data))>>3)
+#define VO_FC_m2go_shift                                                             (2)
+#define VO_FC_m2go_mask                                                              (0x00000004)
+#define VO_FC_m2go(data)                                                             (0x00000004&((data)<<2))
+#define VO_FC_m2go_src(data)                                                         ((0x00000004&(data))>>2)
+#define VO_FC_get_m2go(data)                                                         ((0x00000004&(data))>>2)
+#define VO_FC_m1go_shift                                                             (1)
+#define VO_FC_m1go_mask                                                              (0x00000002)
+#define VO_FC_m1go(data)                                                             (0x00000002&((data)<<1))
+#define VO_FC_m1go_src(data)                                                         ((0x00000002&(data))>>1)
+#define VO_FC_get_m1go(data)                                                         ((0x00000002&(data))>>1)
+#define VO_FC_write_data_shift                                                       (0)
+#define VO_FC_write_data_mask                                                        (0x00000001)
+#define VO_FC_write_data(data)                                                       (0x00000001&((data)<<0))
+#define VO_FC_write_data_src(data)                                                   ((0x00000001&(data))>>0)
+#define VO_FC_get_write_data(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define VO_VBI_END                                                                   0x1800501C
+#define VO_VBI_END_reg_addr                                                          "0xB800501C"
+#define VO_VBI_END_reg                                                               0xB800501C
+#define set_VO_VBI_END_reg(data)   (*((volatile unsigned int*) VO_VBI_END_reg)=data)
+#define get_VO_VBI_END_reg   (*((volatile unsigned int*) VO_VBI_END_reg))
+#define VO_VBI_END_inst_adr                                                          "0x0007"
+#define VO_VBI_END_inst                                                              0x0007
+#define VO_VBI_END_ref_shift                                                         (24)
+#define VO_VBI_END_ref_mask                                                          (0x07000000)
+#define VO_VBI_END_ref(data)                                                         (0x07000000&((data)<<24))
+#define VO_VBI_END_ref_src(data)                                                     ((0x07000000&(data))>>24)
+#define VO_VBI_END_get_ref(data)                                                     ((0x07000000&(data))>>24)
+#define VO_VBI_END_pos_shift                                                         (12)
+#define VO_VBI_END_pos_mask                                                          (0x00FFF000)
+#define VO_VBI_END_pos(data)                                                         (0x00FFF000&((data)<<12))
+#define VO_VBI_END_pos_src(data)                                                     ((0x00FFF000&(data))>>12)
+#define VO_VBI_END_get_pos(data)                                                     ((0x00FFF000&(data))>>12)
+#define VO_VBI_END_th_shift                                                          (0)
+#define VO_VBI_END_th_mask                                                           (0x00000FFF)
+#define VO_VBI_END_th(data)                                                          (0x00000FFF&((data)<<0))
+#define VO_VBI_END_th_src(data)                                                      ((0x00000FFF&(data))>>0)
+#define VO_VBI_END_get_th(data)                                                      ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1                                                                        0x18005020
+#define VO_V1_reg_addr                                                               "0xB8005020"
+#define VO_V1_reg                                                                    0xB8005020
+#define set_VO_V1_reg(data)   (*((volatile unsigned int*) VO_V1_reg)=data)
+#define get_VO_V1_reg   (*((volatile unsigned int*) VO_V1_reg))
+#define VO_V1_inst_adr                                                               "0x0008"
+#define VO_V1_inst                                                                   0x0008
+#define VO_V1_d3_dbh_shift                                                           (19)
+#define VO_V1_d3_dbh_mask                                                            (0x00080000)
+#define VO_V1_d3_dbh(data)                                                           (0x00080000&((data)<<19))
+#define VO_V1_d3_dbh_src(data)                                                       ((0x00080000&(data))>>19)
+#define VO_V1_get_d3_dbh(data)                                                       ((0x00080000&(data))>>19)
+#define VO_V1_d3_dbw_shift                                                           (18)
+#define VO_V1_d3_dbw_mask                                                            (0x00040000)
+#define VO_V1_d3_dbw(data)                                                           (0x00040000&((data)<<18))
+#define VO_V1_d3_dbw_src(data)                                                       ((0x00040000&(data))>>18)
+#define VO_V1_get_d3_dbw(data)                                                       ((0x00040000&(data))>>18)
+#define VO_V1_d3_dup_shift                                                           (17)
+#define VO_V1_d3_dup_mask                                                            (0x00020000)
+#define VO_V1_d3_dup(data)                                                           (0x00020000&((data)<<17))
+#define VO_V1_d3_dup_src(data)                                                       ((0x00020000&(data))>>17)
+#define VO_V1_get_d3_dup(data)                                                       ((0x00020000&(data))>>17)
+#define VO_V1_st_shift                                                               (15)
+#define VO_V1_st_mask                                                                (0x00008000)
+#define VO_V1_st(data)                                                               (0x00008000&((data)<<15))
+#define VO_V1_st_src(data)                                                           ((0x00008000&(data))>>15)
+#define VO_V1_get_st(data)                                                           ((0x00008000&(data))>>15)
+#define VO_V1_seq_shift                                                              (12)
+#define VO_V1_seq_mask                                                               (0x00001000)
+#define VO_V1_seq(data)                                                              (0x00001000&((data)<<12))
+#define VO_V1_seq_src(data)                                                          ((0x00001000&(data))>>12)
+#define VO_V1_get_seq(data)                                                          ((0x00001000&(data))>>12)
+#define VO_V1_di_shift                                                               (11)
+#define VO_V1_di_mask                                                                (0x00000800)
+#define VO_V1_di(data)                                                               (0x00000800&((data)<<11))
+#define VO_V1_di_src(data)                                                           ((0x00000800&(data))>>11)
+#define VO_V1_get_di(data)                                                           ((0x00000800&(data))>>11)
+#define VO_V1_f422_shift                                                             (10)
+#define VO_V1_f422_mask                                                              (0x00000400)
+#define VO_V1_f422(data)                                                             (0x00000400&((data)<<10))
+#define VO_V1_f422_src(data)                                                         ((0x00000400&(data))>>10)
+#define VO_V1_get_f422(data)                                                         ((0x00000400&(data))>>10)
+#define VO_V1_vs_shift                                                               (9)
+#define VO_V1_vs_mask                                                                (0x00000200)
+#define VO_V1_vs(data)                                                               (0x00000200&((data)<<9))
+#define VO_V1_vs_src(data)                                                           ((0x00000200&(data))>>9)
+#define VO_V1_get_vs(data)                                                           ((0x00000200&(data))>>9)
+#define VO_V1_vs_near_shift                                                          (8)
+#define VO_V1_vs_near_mask                                                           (0x00000100)
+#define VO_V1_vs_near(data)                                                          (0x00000100&((data)<<8))
+#define VO_V1_vs_near_src(data)                                                      ((0x00000100&(data))>>8)
+#define VO_V1_get_vs_near(data)                                                      ((0x00000100&(data))>>8)
+#define VO_V1_vs_yodd_shift                                                          (7)
+#define VO_V1_vs_yodd_mask                                                           (0x00000080)
+#define VO_V1_vs_yodd(data)                                                          (0x00000080&((data)<<7))
+#define VO_V1_vs_yodd_src(data)                                                      ((0x00000080&(data))>>7)
+#define VO_V1_get_vs_yodd(data)                                                      ((0x00000080&(data))>>7)
+#define VO_V1_vs_codd_shift                                                          (6)
+#define VO_V1_vs_codd_mask                                                           (0x00000040)
+#define VO_V1_vs_codd(data)                                                          (0x00000040&((data)<<6))
+#define VO_V1_vs_codd_src(data)                                                      ((0x00000040&(data))>>6)
+#define VO_V1_get_vs_codd(data)                                                      ((0x00000040&(data))>>6)
+#define VO_V1_hs_shift                                                               (5)
+#define VO_V1_hs_mask                                                                (0x00000020)
+#define VO_V1_hs(data)                                                               (0x00000020&((data)<<5))
+#define VO_V1_hs_src(data)                                                           ((0x00000020&(data))>>5)
+#define VO_V1_get_hs(data)                                                           ((0x00000020&(data))>>5)
+#define VO_V1_hs_yodd_shift                                                          (4)
+#define VO_V1_hs_yodd_mask                                                           (0x00000010)
+#define VO_V1_hs_yodd(data)                                                          (0x00000010&((data)<<4))
+#define VO_V1_hs_yodd_src(data)                                                      ((0x00000010&(data))>>4)
+#define VO_V1_get_hs_yodd(data)                                                      ((0x00000010&(data))>>4)
+#define VO_V1_hs_codd_shift                                                          (3)
+#define VO_V1_hs_codd_mask                                                           (0x00000008)
+#define VO_V1_hs_codd(data)                                                          (0x00000008&((data)<<3))
+#define VO_V1_hs_codd_src(data)                                                      ((0x00000008&(data))>>3)
+#define VO_V1_get_hs_codd(data)                                                      ((0x00000008&(data))>>3)
+#define VO_V1_topfield_shift                                                         (2)
+#define VO_V1_topfield_mask                                                          (0x00000004)
+#define VO_V1_topfield(data)                                                         (0x00000004&((data)<<2))
+#define VO_V1_topfield_src(data)                                                     ((0x00000004&(data))>>2)
+#define VO_V1_get_topfield(data)                                                     ((0x00000004&(data))>>2)
+#define VO_V1_dmaweave_shift                                                         (1)
+#define VO_V1_dmaweave_mask                                                          (0x00000002)
+#define VO_V1_dmaweave(data)                                                         (0x00000002&((data)<<1))
+#define VO_V1_dmaweave_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_V1_get_dmaweave(data)                                                     ((0x00000002&(data))>>1)
+#define VO_V1_write_data_shift                                                       (0)
+#define VO_V1_write_data_mask                                                        (0x00000001)
+#define VO_V1_write_data(data)                                                       (0x00000001&((data)<<0))
+#define VO_V1_write_data_src(data)                                                   ((0x00000001&(data))>>0)
+#define VO_V1_get_write_data(data)                                                   ((0x00000001&(data))>>0)
+
+
+#define VO_V1_DMA                                                                    0x18005024
+#define VO_V1_DMA_reg_addr                                                           "0xB8005024"
+#define VO_V1_DMA_reg                                                                0xB8005024
+#define set_VO_V1_DMA_reg(data)   (*((volatile unsigned int*) VO_V1_DMA_reg)=data)
+#define get_VO_V1_DMA_reg   (*((volatile unsigned int*) VO_V1_DMA_reg))
+#define VO_V1_DMA_inst_adr                                                           "0x0009"
+#define VO_V1_DMA_inst                                                               0x0009
+#define VO_V1_DMA_l_shift                                                            (0)
+#define VO_V1_DMA_l_mask                                                             (0x0000003F)
+#define VO_V1_DMA_l(data)                                                            (0x0000003F&((data)<<0))
+#define VO_V1_DMA_l_src(data)                                                        ((0x0000003F&(data))>>0)
+#define VO_V1_DMA_get_l(data)                                                        ((0x0000003F&(data))>>0)
+
+
+#define VO_V1_INDEX                                                                  0x18005028
+#define VO_V1_INDEX_reg_addr                                                         "0xB8005028"
+#define VO_V1_INDEX_reg                                                              0xB8005028
+#define set_VO_V1_INDEX_reg(data)   (*((volatile unsigned int*) VO_V1_INDEX_reg)=data)
+#define get_VO_V1_INDEX_reg   (*((volatile unsigned int*) VO_V1_INDEX_reg))
+#define VO_V1_INDEX_inst_adr                                                         "0x000A"
+#define VO_V1_INDEX_inst                                                             0x000A
+#define VO_V1_INDEX_w_c_shift                                                        (24)
+#define VO_V1_INDEX_w_c_mask                                                         (0x7F000000)
+#define VO_V1_INDEX_w_c(data)                                                        (0x7F000000&((data)<<24))
+#define VO_V1_INDEX_w_c_src(data)                                                    ((0x7F000000&(data))>>24)
+#define VO_V1_INDEX_get_w_c(data)                                                    ((0x7F000000&(data))>>24)
+#define VO_V1_INDEX_w_y_shift                                                        (16)
+#define VO_V1_INDEX_w_y_mask                                                         (0x007F0000)
+#define VO_V1_INDEX_w_y(data)                                                        (0x007F0000&((data)<<16))
+#define VO_V1_INDEX_w_y_src(data)                                                    ((0x007F0000&(data))>>16)
+#define VO_V1_INDEX_get_w_y(data)                                                    ((0x007F0000&(data))>>16)
+#define VO_V1_INDEX_c_shift                                                          (8)
+#define VO_V1_INDEX_c_mask                                                           (0x00007F00)
+#define VO_V1_INDEX_c(data)                                                          (0x00007F00&((data)<<8))
+#define VO_V1_INDEX_c_src(data)                                                      ((0x00007F00&(data))>>8)
+#define VO_V1_INDEX_get_c(data)                                                      ((0x00007F00&(data))>>8)
+#define VO_V1_INDEX_y_shift                                                          (0)
+#define VO_V1_INDEX_y_mask                                                           (0x0000007F)
+#define VO_V1_INDEX_y(data)                                                          (0x0000007F&((data)<<0))
+#define VO_V1_INDEX_y_src(data)                                                      ((0x0000007F&(data))>>0)
+#define VO_V1_INDEX_get_y(data)                                                      ((0x0000007F&(data))>>0)
+
+
+#define VO_V1_INDEX_3D                                                               0x1800502C
+#define VO_V1_INDEX_3D_reg_addr                                                      "0xB800502C"
+#define VO_V1_INDEX_3D_reg                                                           0xB800502C
+#define set_VO_V1_INDEX_3D_reg(data)   (*((volatile unsigned int*) VO_V1_INDEX_3D_reg)=data)
+#define get_VO_V1_INDEX_3D_reg   (*((volatile unsigned int*) VO_V1_INDEX_3D_reg))
+#define VO_V1_INDEX_3D_inst_adr                                                      "0x000B"
+#define VO_V1_INDEX_3D_inst                                                          0x000B
+#define VO_V1_INDEX_3D_w_c_shift                                                     (24)
+#define VO_V1_INDEX_3D_w_c_mask                                                      (0x7F000000)
+#define VO_V1_INDEX_3D_w_c(data)                                                     (0x7F000000&((data)<<24))
+#define VO_V1_INDEX_3D_w_c_src(data)                                                 ((0x7F000000&(data))>>24)
+#define VO_V1_INDEX_3D_get_w_c(data)                                                 ((0x7F000000&(data))>>24)
+#define VO_V1_INDEX_3D_w_y_shift                                                     (16)
+#define VO_V1_INDEX_3D_w_y_mask                                                      (0x007F0000)
+#define VO_V1_INDEX_3D_w_y(data)                                                     (0x007F0000&((data)<<16))
+#define VO_V1_INDEX_3D_w_y_src(data)                                                 ((0x007F0000&(data))>>16)
+#define VO_V1_INDEX_3D_get_w_y(data)                                                 ((0x007F0000&(data))>>16)
+#define VO_V1_INDEX_3D_c_shift                                                       (8)
+#define VO_V1_INDEX_3D_c_mask                                                        (0x00007F00)
+#define VO_V1_INDEX_3D_c(data)                                                       (0x00007F00&((data)<<8))
+#define VO_V1_INDEX_3D_c_src(data)                                                   ((0x00007F00&(data))>>8)
+#define VO_V1_INDEX_3D_get_c(data)                                                   ((0x00007F00&(data))>>8)
+#define VO_V1_INDEX_3D_y_shift                                                       (0)
+#define VO_V1_INDEX_3D_y_mask                                                        (0x0000007F)
+#define VO_V1_INDEX_3D_y(data)                                                       (0x0000007F&((data)<<0))
+#define VO_V1_INDEX_3D_y_src(data)                                                   ((0x0000007F&(data))>>0)
+#define VO_V1_INDEX_3D_get_y(data)                                                   ((0x0000007F&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_W_Y                                                             0x18005030
+#define VO_V1_SEQ_SA_W_Y_reg_addr                                                    "0xB8005030"
+#define VO_V1_SEQ_SA_W_Y_reg                                                         0xB8005030
+#define set_VO_V1_SEQ_SA_W_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_Y_reg)=data)
+#define get_VO_V1_SEQ_SA_W_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_Y_reg))
+#define VO_V1_SEQ_SA_W_Y_inst_adr                                                    "0x000C"
+#define VO_V1_SEQ_SA_W_Y_inst                                                        0x000C
+#define VO_V1_SEQ_SA_W_Y_a_shift                                                     (0)
+#define VO_V1_SEQ_SA_W_Y_a_mask                                                      (0x7FFFFFFF)
+#define VO_V1_SEQ_SA_W_Y_a(data)                                                     (0x7FFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_W_Y_a_src(data)                                                 ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_W_Y_get_a(data)                                                 ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_W_C                                                             0x18005034
+#define VO_V1_SEQ_SA_W_C_reg_addr                                                    "0xB8005034"
+#define VO_V1_SEQ_SA_W_C_reg                                                         0xB8005034
+#define set_VO_V1_SEQ_SA_W_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_C_reg)=data)
+#define get_VO_V1_SEQ_SA_W_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_C_reg))
+#define VO_V1_SEQ_SA_W_C_inst_adr                                                    "0x000D"
+#define VO_V1_SEQ_SA_W_C_inst                                                        0x000D
+#define VO_V1_SEQ_SA_W_C_a_shift                                                     (0)
+#define VO_V1_SEQ_SA_W_C_a_mask                                                      (0x7FFFFFFF)
+#define VO_V1_SEQ_SA_W_C_a(data)                                                     (0x7FFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_W_C_a_src(data)                                                 ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_W_C_get_a(data)                                                 ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_C_Y                                                             0x18005038
+#define VO_V1_SEQ_SA_C_Y_reg_addr                                                    "0xB8005038"
+#define VO_V1_SEQ_SA_C_Y_reg                                                         0xB8005038
+#define set_VO_V1_SEQ_SA_C_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_Y_reg)=data)
+#define get_VO_V1_SEQ_SA_C_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_Y_reg))
+#define VO_V1_SEQ_SA_C_Y_inst_adr                                                    "0x000E"
+#define VO_V1_SEQ_SA_C_Y_inst                                                        0x000E
+#define VO_V1_SEQ_SA_C_Y_a_shift                                                     (0)
+#define VO_V1_SEQ_SA_C_Y_a_mask                                                      (0x7FFFFFFF)
+#define VO_V1_SEQ_SA_C_Y_a(data)                                                     (0x7FFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_C_Y_a_src(data)                                                 ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_C_Y_get_a(data)                                                 ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_C_C                                                             0x1800503C
+#define VO_V1_SEQ_SA_C_C_reg_addr                                                    "0xB800503C"
+#define VO_V1_SEQ_SA_C_C_reg                                                         0xB800503C
+#define set_VO_V1_SEQ_SA_C_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_C_reg)=data)
+#define get_VO_V1_SEQ_SA_C_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_C_reg))
+#define VO_V1_SEQ_SA_C_C_inst_adr                                                    "0x000F"
+#define VO_V1_SEQ_SA_C_C_inst                                                        0x000F
+#define VO_V1_SEQ_SA_C_C_a_shift                                                     (0)
+#define VO_V1_SEQ_SA_C_C_a_mask                                                      (0x7FFFFFFF)
+#define VO_V1_SEQ_SA_C_C_a(data)                                                     (0x7FFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_C_C_a_src(data)                                                 ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_C_C_get_a(data)                                                 ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_W_Y                                                          0x18005040
+#define VO_V1_SEQ_PITCH_W_Y_reg_addr                                                 "0xB8005040"
+#define VO_V1_SEQ_PITCH_W_Y_reg                                                      0xB8005040
+#define set_VO_V1_SEQ_PITCH_W_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_W_Y_reg)=data)
+#define get_VO_V1_SEQ_PITCH_W_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_W_Y_reg))
+#define VO_V1_SEQ_PITCH_W_Y_inst_adr                                                 "0x0010"
+#define VO_V1_SEQ_PITCH_W_Y_inst                                                     0x0010
+#define VO_V1_SEQ_PITCH_W_Y_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_W_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_W_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_W_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_W_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_W_C                                                          0x18005044
+#define VO_V1_SEQ_PITCH_W_C_reg_addr                                                 "0xB8005044"
+#define VO_V1_SEQ_PITCH_W_C_reg                                                      0xB8005044
+#define set_VO_V1_SEQ_PITCH_W_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_W_C_reg)=data)
+#define get_VO_V1_SEQ_PITCH_W_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_W_C_reg))
+#define VO_V1_SEQ_PITCH_W_C_inst_adr                                                 "0x0011"
+#define VO_V1_SEQ_PITCH_W_C_inst                                                     0x0011
+#define VO_V1_SEQ_PITCH_W_C_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_W_C_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_W_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_W_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_W_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_C_Y                                                          0x18005048
+#define VO_V1_SEQ_PITCH_C_Y_reg_addr                                                 "0xB8005048"
+#define VO_V1_SEQ_PITCH_C_Y_reg                                                      0xB8005048
+#define set_VO_V1_SEQ_PITCH_C_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_C_Y_reg)=data)
+#define get_VO_V1_SEQ_PITCH_C_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_C_Y_reg))
+#define VO_V1_SEQ_PITCH_C_Y_inst_adr                                                 "0x0012"
+#define VO_V1_SEQ_PITCH_C_Y_inst                                                     0x0012
+#define VO_V1_SEQ_PITCH_C_Y_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_C_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_C_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_C_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_C_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_C_C                                                          0x1800504C
+#define VO_V1_SEQ_PITCH_C_C_reg_addr                                                 "0xB800504C"
+#define VO_V1_SEQ_PITCH_C_C_reg                                                      0xB800504C
+#define set_VO_V1_SEQ_PITCH_C_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_C_C_reg)=data)
+#define get_VO_V1_SEQ_PITCH_C_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_C_C_reg))
+#define VO_V1_SEQ_PITCH_C_C_inst_adr                                                 "0x0013"
+#define VO_V1_SEQ_PITCH_C_C_inst                                                     0x0013
+#define VO_V1_SEQ_PITCH_C_C_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_C_C_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_C_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_C_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_C_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_W_Y_3D                                                          0x18005050
+#define VO_V1_SEQ_SA_W_Y_3D_reg_addr                                                 "0xB8005050"
+#define VO_V1_SEQ_SA_W_Y_3D_reg                                                      0xB8005050
+#define set_VO_V1_SEQ_SA_W_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_Y_3D_reg)=data)
+#define get_VO_V1_SEQ_SA_W_Y_3D_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_Y_3D_reg))
+#define VO_V1_SEQ_SA_W_Y_3D_inst_adr                                                 "0x0014"
+#define VO_V1_SEQ_SA_W_Y_3D_inst                                                     0x0014
+#define VO_V1_SEQ_SA_W_Y_3D_a_shift                                                  (0)
+#define VO_V1_SEQ_SA_W_Y_3D_a_mask                                                   (0x7FFFFFFF)
+#define VO_V1_SEQ_SA_W_Y_3D_a(data)                                                  (0x7FFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_W_Y_3D_a_src(data)                                              ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_W_Y_3D_get_a(data)                                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_W_C_3D                                                          0x18005054
+#define VO_V1_SEQ_SA_W_C_3D_reg_addr                                                 "0xB8005054"
+#define VO_V1_SEQ_SA_W_C_3D_reg                                                      0xB8005054
+#define set_VO_V1_SEQ_SA_W_C_3D_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_C_3D_reg)=data)
+#define get_VO_V1_SEQ_SA_W_C_3D_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_W_C_3D_reg))
+#define VO_V1_SEQ_SA_W_C_3D_inst_adr                                                 "0x0015"
+#define VO_V1_SEQ_SA_W_C_3D_inst                                                     0x0015
+#define VO_V1_SEQ_SA_W_C_3D_a_shift                                                  (0)
+#define VO_V1_SEQ_SA_W_C_3D_a_mask                                                   (0x7FFFFFFF)
+#define VO_V1_SEQ_SA_W_C_3D_a(data)                                                  (0x7FFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_W_C_3D_a_src(data)                                              ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_W_C_3D_get_a(data)                                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_C_Y_3D                                                          0x18005058
+#define VO_V1_SEQ_SA_C_Y_3D_reg_addr                                                 "0xB8005058"
+#define VO_V1_SEQ_SA_C_Y_3D_reg                                                      0xB8005058
+#define set_VO_V1_SEQ_SA_C_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_Y_3D_reg)=data)
+#define get_VO_V1_SEQ_SA_C_Y_3D_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_Y_3D_reg))
+#define VO_V1_SEQ_SA_C_Y_3D_inst_adr                                                 "0x0016"
+#define VO_V1_SEQ_SA_C_Y_3D_inst                                                     0x0016
+#define VO_V1_SEQ_SA_C_Y_3D_a_shift                                                  (0)
+#define VO_V1_SEQ_SA_C_Y_3D_a_mask                                                   (0x7FFFFFFF)
+#define VO_V1_SEQ_SA_C_Y_3D_a(data)                                                  (0x7FFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_C_Y_3D_a_src(data)                                              ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_C_Y_3D_get_a(data)                                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_SA_C_C_3D                                                          0x1800505C
+#define VO_V1_SEQ_SA_C_C_3D_reg_addr                                                 "0xB800505C"
+#define VO_V1_SEQ_SA_C_C_3D_reg                                                      0xB800505C
+#define set_VO_V1_SEQ_SA_C_C_3D_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_C_3D_reg)=data)
+#define get_VO_V1_SEQ_SA_C_C_3D_reg   (*((volatile unsigned int*) VO_V1_SEQ_SA_C_C_3D_reg))
+#define VO_V1_SEQ_SA_C_C_3D_inst_adr                                                 "0x0017"
+#define VO_V1_SEQ_SA_C_C_3D_inst                                                     0x0017
+#define VO_V1_SEQ_SA_C_C_3D_a_shift                                                  (0)
+#define VO_V1_SEQ_SA_C_C_3D_a_mask                                                   (0x7FFFFFFF)
+#define VO_V1_SEQ_SA_C_C_3D_a(data)                                                  (0x7FFFFFFF&((data)<<0))
+#define VO_V1_SEQ_SA_C_C_3D_a_src(data)                                              ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_SEQ_SA_C_C_3D_get_a(data)                                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_INDEX_RR                                                               0x18005060
+#define VO_V1_INDEX_RR_reg_addr                                                      "0xB8005060"
+#define VO_V1_INDEX_RR_reg                                                           0xB8005060
+#define set_VO_V1_INDEX_RR_reg(data)   (*((volatile unsigned int*) VO_V1_INDEX_RR_reg)=data)
+#define get_VO_V1_INDEX_RR_reg   (*((volatile unsigned int*) VO_V1_INDEX_RR_reg))
+#define VO_V1_INDEX_RR_inst_adr                                                      "0x0018"
+#define VO_V1_INDEX_RR_inst                                                          0x0018
+#define VO_V1_INDEX_RR_w_c_en_shift                                                  (15)
+#define VO_V1_INDEX_RR_w_c_en_mask                                                   (0x00008000)
+#define VO_V1_INDEX_RR_w_c_en(data)                                                  (0x00008000&((data)<<15))
+#define VO_V1_INDEX_RR_w_c_en_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_V1_INDEX_RR_get_w_c_en(data)                                              ((0x00008000&(data))>>15)
+#define VO_V1_INDEX_RR_w_c_shift                                                     (12)
+#define VO_V1_INDEX_RR_w_c_mask                                                      (0x00007000)
+#define VO_V1_INDEX_RR_w_c(data)                                                     (0x00007000&((data)<<12))
+#define VO_V1_INDEX_RR_w_c_src(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_INDEX_RR_get_w_c(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_INDEX_RR_w_y_en_shift                                                  (11)
+#define VO_V1_INDEX_RR_w_y_en_mask                                                   (0x00000800)
+#define VO_V1_INDEX_RR_w_y_en(data)                                                  (0x00000800&((data)<<11))
+#define VO_V1_INDEX_RR_w_y_en_src(data)                                              ((0x00000800&(data))>>11)
+#define VO_V1_INDEX_RR_get_w_y_en(data)                                              ((0x00000800&(data))>>11)
+#define VO_V1_INDEX_RR_w_y_shift                                                     (8)
+#define VO_V1_INDEX_RR_w_y_mask                                                      (0x00000700)
+#define VO_V1_INDEX_RR_w_y(data)                                                     (0x00000700&((data)<<8))
+#define VO_V1_INDEX_RR_w_y_src(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_INDEX_RR_get_w_y(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_INDEX_RR_c_en_shift                                                    (7)
+#define VO_V1_INDEX_RR_c_en_mask                                                     (0x00000080)
+#define VO_V1_INDEX_RR_c_en(data)                                                    (0x00000080&((data)<<7))
+#define VO_V1_INDEX_RR_c_en_src(data)                                                ((0x00000080&(data))>>7)
+#define VO_V1_INDEX_RR_get_c_en(data)                                                ((0x00000080&(data))>>7)
+#define VO_V1_INDEX_RR_c_shift                                                       (4)
+#define VO_V1_INDEX_RR_c_mask                                                        (0x00000070)
+#define VO_V1_INDEX_RR_c(data)                                                       (0x00000070&((data)<<4))
+#define VO_V1_INDEX_RR_c_src(data)                                                   ((0x00000070&(data))>>4)
+#define VO_V1_INDEX_RR_get_c(data)                                                   ((0x00000070&(data))>>4)
+#define VO_V1_INDEX_RR_y_en_shift                                                    (3)
+#define VO_V1_INDEX_RR_y_en_mask                                                     (0x00000008)
+#define VO_V1_INDEX_RR_y_en(data)                                                    (0x00000008&((data)<<3))
+#define VO_V1_INDEX_RR_y_en_src(data)                                                ((0x00000008&(data))>>3)
+#define VO_V1_INDEX_RR_get_y_en(data)                                                ((0x00000008&(data))>>3)
+#define VO_V1_INDEX_RR_y_shift                                                       (0)
+#define VO_V1_INDEX_RR_y_mask                                                        (0x00000007)
+#define VO_V1_INDEX_RR_y(data)                                                       (0x00000007&((data)<<0))
+#define VO_V1_INDEX_RR_y_src(data)                                                   ((0x00000007&(data))>>0)
+#define VO_V1_INDEX_RR_get_y(data)                                                   ((0x00000007&(data))>>0)
+
+
+#define VO_V1_ALPHA                                                                  0x18005064
+#define VO_V1_ALPHA_reg_addr                                                         "0xB8005064"
+#define VO_V1_ALPHA_reg                                                              0xB8005064
+#define set_VO_V1_ALPHA_reg(data)   (*((volatile unsigned int*) VO_V1_ALPHA_reg)=data)
+#define get_VO_V1_ALPHA_reg   (*((volatile unsigned int*) VO_V1_ALPHA_reg))
+#define VO_V1_ALPHA_inst_adr                                                         "0x0019"
+#define VO_V1_ALPHA_inst                                                             0x0019
+#define VO_V1_ALPHA_a_shift                                                          (0)
+#define VO_V1_ALPHA_a_mask                                                           (0x000001FF)
+#define VO_V1_ALPHA_a(data)                                                          (0x000001FF&((data)<<0))
+#define VO_V1_ALPHA_a_src(data)                                                      ((0x000001FF&(data))>>0)
+#define VO_V1_ALPHA_get_a(data)                                                      ((0x000001FF&(data))>>0)
+
+
+#define VO_V1_SIZE                                                                   0x18005068
+#define VO_V1_SIZE_reg_addr                                                          "0xB8005068"
+#define VO_V1_SIZE_reg                                                               0xB8005068
+#define set_VO_V1_SIZE_reg(data)   (*((volatile unsigned int*) VO_V1_SIZE_reg)=data)
+#define get_VO_V1_SIZE_reg   (*((volatile unsigned int*) VO_V1_SIZE_reg))
+#define VO_V1_SIZE_inst_adr                                                          "0x001A"
+#define VO_V1_SIZE_inst                                                              0x001A
+#define VO_V1_SIZE_w_shift                                                           (12)
+#define VO_V1_SIZE_w_mask                                                            (0x01FFF000)
+#define VO_V1_SIZE_w(data)                                                           (0x01FFF000&((data)<<12))
+#define VO_V1_SIZE_w_src(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_V1_SIZE_get_w(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_V1_SIZE_h_shift                                                           (0)
+#define VO_V1_SIZE_h_mask                                                            (0x00000FFF)
+#define VO_V1_SIZE_h(data)                                                           (0x00000FFF&((data)<<0))
+#define VO_V1_SIZE_h_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VO_V1_SIZE_get_h(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_BUF                                                                    0x1800506C
+#define VO_V1_BUF_reg_addr                                                           "0xB800506C"
+#define VO_V1_BUF_reg                                                                0xB800506C
+#define set_VO_V1_BUF_reg(data)   (*((volatile unsigned int*) VO_V1_BUF_reg)=data)
+#define get_VO_V1_BUF_reg   (*((volatile unsigned int*) VO_V1_BUF_reg))
+#define VO_V1_BUF_inst_adr                                                           "0x001B"
+#define VO_V1_BUF_inst                                                               0x001B
+#define VO_V1_BUF_th_shift                                                           (0)
+#define VO_V1_BUF_th_mask                                                            (0x000001FF)
+#define VO_V1_BUF_th(data)                                                           (0x000001FF&((data)<<0))
+#define VO_V1_BUF_th_src(data)                                                       ((0x000001FF&(data))>>0)
+#define VO_V1_BUF_get_th(data)                                                       ((0x000001FF&(data))>>0)
+
+
+#define VO_V1_DI                                                                     0x18005070
+#define VO_V1_DI_reg_addr                                                            "0xB8005070"
+#define VO_V1_DI_reg                                                                 0xB8005070
+#define set_VO_V1_DI_reg(data)   (*((volatile unsigned int*) VO_V1_DI_reg)=data)
+#define get_VO_V1_DI_reg   (*((volatile unsigned int*) VO_V1_DI_reg))
+#define VO_V1_DI_inst_adr                                                            "0x001C"
+#define VO_V1_DI_inst                                                                0x001C
+#define VO_V1_DI_mode_shift                                                          (0)
+#define VO_V1_DI_mode_mask                                                           (0x00000003)
+#define VO_V1_DI_mode(data)                                                          (0x00000003&((data)<<0))
+#define VO_V1_DI_mode_src(data)                                                      ((0x00000003&(data))>>0)
+#define VO_V1_DI_get_mode(data)                                                      ((0x00000003&(data))>>0)
+
+
+#define VO_V1_DI_3F                                                                  0x18005074
+#define VO_V1_DI_3F_reg_addr                                                         "0xB8005074"
+#define VO_V1_DI_3F_reg                                                              0xB8005074
+#define set_VO_V1_DI_3F_reg(data)   (*((volatile unsigned int*) VO_V1_DI_3F_reg)=data)
+#define get_VO_V1_DI_3F_reg   (*((volatile unsigned int*) VO_V1_DI_3F_reg))
+#define VO_V1_DI_3F_inst_adr                                                         "0x001D"
+#define VO_V1_DI_3F_inst                                                             0x001D
+#define VO_V1_DI_3F_n_c_shift                                                        (24)
+#define VO_V1_DI_3F_n_c_mask                                                         (0x7F000000)
+#define VO_V1_DI_3F_n_c(data)                                                        (0x7F000000&((data)<<24))
+#define VO_V1_DI_3F_n_c_src(data)                                                    ((0x7F000000&(data))>>24)
+#define VO_V1_DI_3F_get_n_c(data)                                                    ((0x7F000000&(data))>>24)
+#define VO_V1_DI_3F_n_y_shift                                                        (16)
+#define VO_V1_DI_3F_n_y_mask                                                         (0x007F0000)
+#define VO_V1_DI_3F_n_y(data)                                                        (0x007F0000&((data)<<16))
+#define VO_V1_DI_3F_n_y_src(data)                                                    ((0x007F0000&(data))>>16)
+#define VO_V1_DI_3F_get_n_y(data)                                                    ((0x007F0000&(data))>>16)
+#define VO_V1_DI_3F_p_c_shift                                                        (8)
+#define VO_V1_DI_3F_p_c_mask                                                         (0x00007F00)
+#define VO_V1_DI_3F_p_c(data)                                                        (0x00007F00&((data)<<8))
+#define VO_V1_DI_3F_p_c_src(data)                                                    ((0x00007F00&(data))>>8)
+#define VO_V1_DI_3F_get_p_c(data)                                                    ((0x00007F00&(data))>>8)
+#define VO_V1_DI_3F_p_y_shift                                                        (0)
+#define VO_V1_DI_3F_p_y_mask                                                         (0x0000007F)
+#define VO_V1_DI_3F_p_y(data)                                                        (0x0000007F&((data)<<0))
+#define VO_V1_DI_3F_p_y_src(data)                                                    ((0x0000007F&(data))>>0)
+#define VO_V1_DI_3F_get_p_y(data)                                                    ((0x0000007F&(data))>>0)
+
+
+#define VO_V1_DI_3F_3D                                                               0x18005078
+#define VO_V1_DI_3F_3D_reg_addr                                                      "0xB8005078"
+#define VO_V1_DI_3F_3D_reg                                                           0xB8005078
+#define set_VO_V1_DI_3F_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_3F_3D_reg)=data)
+#define get_VO_V1_DI_3F_3D_reg   (*((volatile unsigned int*) VO_V1_DI_3F_3D_reg))
+#define VO_V1_DI_3F_3D_inst_adr                                                      "0x001E"
+#define VO_V1_DI_3F_3D_inst                                                          0x001E
+#define VO_V1_DI_3F_3D_n_c_shift                                                     (24)
+#define VO_V1_DI_3F_3D_n_c_mask                                                      (0x7F000000)
+#define VO_V1_DI_3F_3D_n_c(data)                                                     (0x7F000000&((data)<<24))
+#define VO_V1_DI_3F_3D_n_c_src(data)                                                 ((0x7F000000&(data))>>24)
+#define VO_V1_DI_3F_3D_get_n_c(data)                                                 ((0x7F000000&(data))>>24)
+#define VO_V1_DI_3F_3D_n_y_shift                                                     (16)
+#define VO_V1_DI_3F_3D_n_y_mask                                                      (0x007F0000)
+#define VO_V1_DI_3F_3D_n_y(data)                                                     (0x007F0000&((data)<<16))
+#define VO_V1_DI_3F_3D_n_y_src(data)                                                 ((0x007F0000&(data))>>16)
+#define VO_V1_DI_3F_3D_get_n_y(data)                                                 ((0x007F0000&(data))>>16)
+#define VO_V1_DI_3F_3D_p_c_shift                                                     (8)
+#define VO_V1_DI_3F_3D_p_c_mask                                                      (0x00007F00)
+#define VO_V1_DI_3F_3D_p_c(data)                                                     (0x00007F00&((data)<<8))
+#define VO_V1_DI_3F_3D_p_c_src(data)                                                 ((0x00007F00&(data))>>8)
+#define VO_V1_DI_3F_3D_get_p_c(data)                                                 ((0x00007F00&(data))>>8)
+#define VO_V1_DI_3F_3D_p_y_shift                                                     (0)
+#define VO_V1_DI_3F_3D_p_y_mask                                                      (0x0000007F)
+#define VO_V1_DI_3F_3D_p_y(data)                                                     (0x0000007F&((data)<<0))
+#define VO_V1_DI_3F_3D_p_y_src(data)                                                 ((0x0000007F&(data))>>0)
+#define VO_V1_DI_3F_3D_get_p_y(data)                                                 ((0x0000007F&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_N_Y                                                          0x1800507C
+#define VO_V1_DI_SEQ_SA_N_Y_reg_addr                                                 "0xB800507C"
+#define VO_V1_DI_SEQ_SA_N_Y_reg                                                      0xB800507C
+#define set_VO_V1_DI_SEQ_SA_N_Y_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_Y_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_N_Y_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_Y_reg))
+#define VO_V1_DI_SEQ_SA_N_Y_inst_adr                                                 "0x001F"
+#define VO_V1_DI_SEQ_SA_N_Y_inst                                                     0x001F
+#define VO_V1_DI_SEQ_SA_N_Y_a_shift                                                  (0)
+#define VO_V1_DI_SEQ_SA_N_Y_a_mask                                                   (0x7FFFFFFF)
+#define VO_V1_DI_SEQ_SA_N_Y_a(data)                                                  (0x7FFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_N_Y_a_src(data)                                              ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_N_Y_get_a(data)                                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_N_C                                                          0x18005080
+#define VO_V1_DI_SEQ_SA_N_C_reg_addr                                                 "0xB8005080"
+#define VO_V1_DI_SEQ_SA_N_C_reg                                                      0xB8005080
+#define set_VO_V1_DI_SEQ_SA_N_C_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_C_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_N_C_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_C_reg))
+#define VO_V1_DI_SEQ_SA_N_C_inst_adr                                                 "0x0020"
+#define VO_V1_DI_SEQ_SA_N_C_inst                                                     0x0020
+#define VO_V1_DI_SEQ_SA_N_C_a_shift                                                  (0)
+#define VO_V1_DI_SEQ_SA_N_C_a_mask                                                   (0x7FFFFFFF)
+#define VO_V1_DI_SEQ_SA_N_C_a(data)                                                  (0x7FFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_N_C_a_src(data)                                              ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_N_C_get_a(data)                                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_P_Y                                                          0x18005084
+#define VO_V1_DI_SEQ_SA_P_Y_reg_addr                                                 "0xB8005084"
+#define VO_V1_DI_SEQ_SA_P_Y_reg                                                      0xB8005084
+#define set_VO_V1_DI_SEQ_SA_P_Y_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_Y_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_P_Y_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_Y_reg))
+#define VO_V1_DI_SEQ_SA_P_Y_inst_adr                                                 "0x0021"
+#define VO_V1_DI_SEQ_SA_P_Y_inst                                                     0x0021
+#define VO_V1_DI_SEQ_SA_P_Y_a_shift                                                  (0)
+#define VO_V1_DI_SEQ_SA_P_Y_a_mask                                                   (0x7FFFFFFF)
+#define VO_V1_DI_SEQ_SA_P_Y_a(data)                                                  (0x7FFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_P_Y_a_src(data)                                              ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_P_Y_get_a(data)                                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_P_C                                                          0x18005088
+#define VO_V1_DI_SEQ_SA_P_C_reg_addr                                                 "0xB8005088"
+#define VO_V1_DI_SEQ_SA_P_C_reg                                                      0xB8005088
+#define set_VO_V1_DI_SEQ_SA_P_C_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_C_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_P_C_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_C_reg))
+#define VO_V1_DI_SEQ_SA_P_C_inst_adr                                                 "0x0022"
+#define VO_V1_DI_SEQ_SA_P_C_inst                                                     0x0022
+#define VO_V1_DI_SEQ_SA_P_C_a_shift                                                  (0)
+#define VO_V1_DI_SEQ_SA_P_C_a_mask                                                   (0x7FFFFFFF)
+#define VO_V1_DI_SEQ_SA_P_C_a(data)                                                  (0x7FFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_P_C_a_src(data)                                              ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_P_C_get_a(data)                                              ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_N_Y                                                          0x1800508C
+#define VO_V1_SEQ_PITCH_N_Y_reg_addr                                                 "0xB800508C"
+#define VO_V1_SEQ_PITCH_N_Y_reg                                                      0xB800508C
+#define set_VO_V1_SEQ_PITCH_N_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_N_Y_reg)=data)
+#define get_VO_V1_SEQ_PITCH_N_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_N_Y_reg))
+#define VO_V1_SEQ_PITCH_N_Y_inst_adr                                                 "0x0023"
+#define VO_V1_SEQ_PITCH_N_Y_inst                                                     0x0023
+#define VO_V1_SEQ_PITCH_N_Y_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_N_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_N_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_N_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_N_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_N_C                                                          0x18005090
+#define VO_V1_SEQ_PITCH_N_C_reg_addr                                                 "0xB8005090"
+#define VO_V1_SEQ_PITCH_N_C_reg                                                      0xB8005090
+#define set_VO_V1_SEQ_PITCH_N_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_N_C_reg)=data)
+#define get_VO_V1_SEQ_PITCH_N_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_N_C_reg))
+#define VO_V1_SEQ_PITCH_N_C_inst_adr                                                 "0x0024"
+#define VO_V1_SEQ_PITCH_N_C_inst                                                     0x0024
+#define VO_V1_SEQ_PITCH_N_C_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_N_C_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_N_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_N_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_N_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_P_Y                                                          0x18005094
+#define VO_V1_SEQ_PITCH_P_Y_reg_addr                                                 "0xB8005094"
+#define VO_V1_SEQ_PITCH_P_Y_reg                                                      0xB8005094
+#define set_VO_V1_SEQ_PITCH_P_Y_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_P_Y_reg)=data)
+#define get_VO_V1_SEQ_PITCH_P_Y_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_P_Y_reg))
+#define VO_V1_SEQ_PITCH_P_Y_inst_adr                                                 "0x0025"
+#define VO_V1_SEQ_PITCH_P_Y_inst                                                     0x0025
+#define VO_V1_SEQ_PITCH_P_Y_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_P_Y_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_P_Y_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_P_Y_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_P_Y_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_SEQ_PITCH_P_C                                                          0x18005098
+#define VO_V1_SEQ_PITCH_P_C_reg_addr                                                 "0xB8005098"
+#define VO_V1_SEQ_PITCH_P_C_reg                                                      0xB8005098
+#define set_VO_V1_SEQ_PITCH_P_C_reg(data)   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_P_C_reg)=data)
+#define get_VO_V1_SEQ_PITCH_P_C_reg   (*((volatile unsigned int*) VO_V1_SEQ_PITCH_P_C_reg))
+#define VO_V1_SEQ_PITCH_P_C_inst_adr                                                 "0x0026"
+#define VO_V1_SEQ_PITCH_P_C_inst                                                     0x0026
+#define VO_V1_SEQ_PITCH_P_C_p_shift                                                  (0)
+#define VO_V1_SEQ_PITCH_P_C_p_mask                                                   (0x0000FFFF)
+#define VO_V1_SEQ_PITCH_P_C_p(data)                                                  (0x0000FFFF&((data)<<0))
+#define VO_V1_SEQ_PITCH_P_C_p_src(data)                                              ((0x0000FFFF&(data))>>0)
+#define VO_V1_SEQ_PITCH_P_C_get_p(data)                                              ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_N_Y_3D                                                       0x1800509C
+#define VO_V1_DI_SEQ_SA_N_Y_3D_reg_addr                                              "0xB800509C"
+#define VO_V1_DI_SEQ_SA_N_Y_3D_reg                                                   0xB800509C
+#define set_VO_V1_DI_SEQ_SA_N_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_Y_3D_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_N_Y_3D_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_Y_3D_reg))
+#define VO_V1_DI_SEQ_SA_N_Y_3D_inst_adr                                              "0x0027"
+#define VO_V1_DI_SEQ_SA_N_Y_3D_inst                                                  0x0027
+#define VO_V1_DI_SEQ_SA_N_Y_3D_a_shift                                               (0)
+#define VO_V1_DI_SEQ_SA_N_Y_3D_a_mask                                                (0x7FFFFFFF)
+#define VO_V1_DI_SEQ_SA_N_Y_3D_a(data)                                               (0x7FFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_N_Y_3D_a_src(data)                                           ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_N_Y_3D_get_a(data)                                           ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_N_C_3D                                                       0x180050A0
+#define VO_V1_DI_SEQ_SA_N_C_3D_reg_addr                                              "0xB80050A0"
+#define VO_V1_DI_SEQ_SA_N_C_3D_reg                                                   0xB80050A0
+#define set_VO_V1_DI_SEQ_SA_N_C_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_C_3D_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_N_C_3D_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_N_C_3D_reg))
+#define VO_V1_DI_SEQ_SA_N_C_3D_inst_adr                                              "0x0028"
+#define VO_V1_DI_SEQ_SA_N_C_3D_inst                                                  0x0028
+#define VO_V1_DI_SEQ_SA_N_C_3D_a_shift                                               (0)
+#define VO_V1_DI_SEQ_SA_N_C_3D_a_mask                                                (0x7FFFFFFF)
+#define VO_V1_DI_SEQ_SA_N_C_3D_a(data)                                               (0x7FFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_N_C_3D_a_src(data)                                           ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_N_C_3D_get_a(data)                                           ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_P_Y_3D                                                       0x180050A4
+#define VO_V1_DI_SEQ_SA_P_Y_3D_reg_addr                                              "0xB80050A4"
+#define VO_V1_DI_SEQ_SA_P_Y_3D_reg                                                   0xB80050A4
+#define set_VO_V1_DI_SEQ_SA_P_Y_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_Y_3D_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_P_Y_3D_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_Y_3D_reg))
+#define VO_V1_DI_SEQ_SA_P_Y_3D_inst_adr                                              "0x0029"
+#define VO_V1_DI_SEQ_SA_P_Y_3D_inst                                                  0x0029
+#define VO_V1_DI_SEQ_SA_P_Y_3D_a_shift                                               (0)
+#define VO_V1_DI_SEQ_SA_P_Y_3D_a_mask                                                (0x7FFFFFFF)
+#define VO_V1_DI_SEQ_SA_P_Y_3D_a(data)                                               (0x7FFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_P_Y_3D_a_src(data)                                           ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_P_Y_3D_get_a(data)                                           ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_SEQ_SA_P_C_3D                                                       0x180050A8
+#define VO_V1_DI_SEQ_SA_P_C_3D_reg_addr                                              "0xB80050A8"
+#define VO_V1_DI_SEQ_SA_P_C_3D_reg                                                   0xB80050A8
+#define set_VO_V1_DI_SEQ_SA_P_C_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_C_3D_reg)=data)
+#define get_VO_V1_DI_SEQ_SA_P_C_3D_reg   (*((volatile unsigned int*) VO_V1_DI_SEQ_SA_P_C_3D_reg))
+#define VO_V1_DI_SEQ_SA_P_C_3D_inst_adr                                              "0x002A"
+#define VO_V1_DI_SEQ_SA_P_C_3D_inst                                                  0x002A
+#define VO_V1_DI_SEQ_SA_P_C_3D_a_shift                                               (0)
+#define VO_V1_DI_SEQ_SA_P_C_3D_a_mask                                                (0x7FFFFFFF)
+#define VO_V1_DI_SEQ_SA_P_C_3D_a(data)                                               (0x7FFFFFFF&((data)<<0))
+#define VO_V1_DI_SEQ_SA_P_C_3D_a_src(data)                                           ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_DI_SEQ_SA_P_C_3D_get_a(data)                                           ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_3F_RR                                                               0x180050AC
+#define VO_V1_DI_3F_RR_reg_addr                                                      "0xB80050AC"
+#define VO_V1_DI_3F_RR_reg                                                           0xB80050AC
+#define set_VO_V1_DI_3F_RR_reg(data)   (*((volatile unsigned int*) VO_V1_DI_3F_RR_reg)=data)
+#define get_VO_V1_DI_3F_RR_reg   (*((volatile unsigned int*) VO_V1_DI_3F_RR_reg))
+#define VO_V1_DI_3F_RR_inst_adr                                                      "0x002B"
+#define VO_V1_DI_3F_RR_inst                                                          0x002B
+#define VO_V1_DI_3F_RR_n_c_en_shift                                                  (15)
+#define VO_V1_DI_3F_RR_n_c_en_mask                                                   (0x00008000)
+#define VO_V1_DI_3F_RR_n_c_en(data)                                                  (0x00008000&((data)<<15))
+#define VO_V1_DI_3F_RR_n_c_en_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_V1_DI_3F_RR_get_n_c_en(data)                                              ((0x00008000&(data))>>15)
+#define VO_V1_DI_3F_RR_n_c_shift                                                     (12)
+#define VO_V1_DI_3F_RR_n_c_mask                                                      (0x00007000)
+#define VO_V1_DI_3F_RR_n_c(data)                                                     (0x00007000&((data)<<12))
+#define VO_V1_DI_3F_RR_n_c_src(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_DI_3F_RR_get_n_c(data)                                                 ((0x00007000&(data))>>12)
+#define VO_V1_DI_3F_RR_n_y_en_shift                                                  (11)
+#define VO_V1_DI_3F_RR_n_y_en_mask                                                   (0x00000800)
+#define VO_V1_DI_3F_RR_n_y_en(data)                                                  (0x00000800&((data)<<11))
+#define VO_V1_DI_3F_RR_n_y_en_src(data)                                              ((0x00000800&(data))>>11)
+#define VO_V1_DI_3F_RR_get_n_y_en(data)                                              ((0x00000800&(data))>>11)
+#define VO_V1_DI_3F_RR_n_y_shift                                                     (8)
+#define VO_V1_DI_3F_RR_n_y_mask                                                      (0x00000700)
+#define VO_V1_DI_3F_RR_n_y(data)                                                     (0x00000700&((data)<<8))
+#define VO_V1_DI_3F_RR_n_y_src(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_DI_3F_RR_get_n_y(data)                                                 ((0x00000700&(data))>>8)
+#define VO_V1_DI_3F_RR_p_c_en_shift                                                  (7)
+#define VO_V1_DI_3F_RR_p_c_en_mask                                                   (0x00000080)
+#define VO_V1_DI_3F_RR_p_c_en(data)                                                  (0x00000080&((data)<<7))
+#define VO_V1_DI_3F_RR_p_c_en_src(data)                                              ((0x00000080&(data))>>7)
+#define VO_V1_DI_3F_RR_get_p_c_en(data)                                              ((0x00000080&(data))>>7)
+#define VO_V1_DI_3F_RR_p_c_shift                                                     (4)
+#define VO_V1_DI_3F_RR_p_c_mask                                                      (0x00000070)
+#define VO_V1_DI_3F_RR_p_c(data)                                                     (0x00000070&((data)<<4))
+#define VO_V1_DI_3F_RR_p_c_src(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V1_DI_3F_RR_get_p_c(data)                                                 ((0x00000070&(data))>>4)
+#define VO_V1_DI_3F_RR_p_y_en_shift                                                  (3)
+#define VO_V1_DI_3F_RR_p_y_en_mask                                                   (0x00000008)
+#define VO_V1_DI_3F_RR_p_y_en(data)                                                  (0x00000008&((data)<<3))
+#define VO_V1_DI_3F_RR_p_y_en_src(data)                                              ((0x00000008&(data))>>3)
+#define VO_V1_DI_3F_RR_get_p_y_en(data)                                              ((0x00000008&(data))>>3)
+#define VO_V1_DI_3F_RR_p_y_shift                                                     (0)
+#define VO_V1_DI_3F_RR_p_y_mask                                                      (0x00000007)
+#define VO_V1_DI_3F_RR_p_y(data)                                                     (0x00000007&((data)<<0))
+#define VO_V1_DI_3F_RR_p_y_src(data)                                                 ((0x00000007&(data))>>0)
+#define VO_V1_DI_3F_RR_get_p_y(data)                                                 ((0x00000007&(data))>>0)
+
+
+#define VO_V1_DI_3F_RR_3D                                                            0x180050B0
+#define VO_V1_DI_3F_RR_3D_reg_addr                                                   "0xB80050B0"
+#define VO_V1_DI_3F_RR_3D_reg                                                        0xB80050B0
+#define set_VO_V1_DI_3F_RR_3D_reg(data)   (*((volatile unsigned int*) VO_V1_DI_3F_RR_3D_reg)=data)
+#define get_VO_V1_DI_3F_RR_3D_reg   (*((volatile unsigned int*) VO_V1_DI_3F_RR_3D_reg))
+#define VO_V1_DI_3F_RR_3D_inst_adr                                                   "0x002C"
+#define VO_V1_DI_3F_RR_3D_inst                                                       0x002C
+#define VO_V1_DI_3F_RR_3D_n_c_en_shift                                               (15)
+#define VO_V1_DI_3F_RR_3D_n_c_en_mask                                                (0x00008000)
+#define VO_V1_DI_3F_RR_3D_n_c_en(data)                                               (0x00008000&((data)<<15))
+#define VO_V1_DI_3F_RR_3D_n_c_en_src(data)                                           ((0x00008000&(data))>>15)
+#define VO_V1_DI_3F_RR_3D_get_n_c_en(data)                                           ((0x00008000&(data))>>15)
+#define VO_V1_DI_3F_RR_3D_n_c_shift                                                  (12)
+#define VO_V1_DI_3F_RR_3D_n_c_mask                                                   (0x00007000)
+#define VO_V1_DI_3F_RR_3D_n_c(data)                                                  (0x00007000&((data)<<12))
+#define VO_V1_DI_3F_RR_3D_n_c_src(data)                                              ((0x00007000&(data))>>12)
+#define VO_V1_DI_3F_RR_3D_get_n_c(data)                                              ((0x00007000&(data))>>12)
+#define VO_V1_DI_3F_RR_3D_n_y_en_shift                                               (11)
+#define VO_V1_DI_3F_RR_3D_n_y_en_mask                                                (0x00000800)
+#define VO_V1_DI_3F_RR_3D_n_y_en(data)                                               (0x00000800&((data)<<11))
+#define VO_V1_DI_3F_RR_3D_n_y_en_src(data)                                           ((0x00000800&(data))>>11)
+#define VO_V1_DI_3F_RR_3D_get_n_y_en(data)                                           ((0x00000800&(data))>>11)
+#define VO_V1_DI_3F_RR_3D_n_y_shift                                                  (8)
+#define VO_V1_DI_3F_RR_3D_n_y_mask                                                   (0x00000700)
+#define VO_V1_DI_3F_RR_3D_n_y(data)                                                  (0x00000700&((data)<<8))
+#define VO_V1_DI_3F_RR_3D_n_y_src(data)                                              ((0x00000700&(data))>>8)
+#define VO_V1_DI_3F_RR_3D_get_n_y(data)                                              ((0x00000700&(data))>>8)
+#define VO_V1_DI_3F_RR_3D_p_c_en_shift                                               (7)
+#define VO_V1_DI_3F_RR_3D_p_c_en_mask                                                (0x00000080)
+#define VO_V1_DI_3F_RR_3D_p_c_en(data)                                               (0x00000080&((data)<<7))
+#define VO_V1_DI_3F_RR_3D_p_c_en_src(data)                                           ((0x00000080&(data))>>7)
+#define VO_V1_DI_3F_RR_3D_get_p_c_en(data)                                           ((0x00000080&(data))>>7)
+#define VO_V1_DI_3F_RR_3D_p_c_shift                                                  (4)
+#define VO_V1_DI_3F_RR_3D_p_c_mask                                                   (0x00000070)
+#define VO_V1_DI_3F_RR_3D_p_c(data)                                                  (0x00000070&((data)<<4))
+#define VO_V1_DI_3F_RR_3D_p_c_src(data)                                              ((0x00000070&(data))>>4)
+#define VO_V1_DI_3F_RR_3D_get_p_c(data)                                              ((0x00000070&(data))>>4)
+#define VO_V1_DI_3F_RR_3D_p_y_en_shift                                               (3)
+#define VO_V1_DI_3F_RR_3D_p_y_en_mask                                                (0x00000008)
+#define VO_V1_DI_3F_RR_3D_p_y_en(data)                                               (0x00000008&((data)<<3))
+#define VO_V1_DI_3F_RR_3D_p_y_en_src(data)                                           ((0x00000008&(data))>>3)
+#define VO_V1_DI_3F_RR_3D_get_p_y_en(data)                                           ((0x00000008&(data))>>3)
+#define VO_V1_DI_3F_RR_3D_p_y_shift                                                  (0)
+#define VO_V1_DI_3F_RR_3D_p_y_mask                                                   (0x00000007)
+#define VO_V1_DI_3F_RR_3D_p_y(data)                                                  (0x00000007&((data)<<0))
+#define VO_V1_DI_3F_RR_3D_p_y_src(data)                                              ((0x00000007&(data))>>0)
+#define VO_V1_DI_3F_RR_3D_get_p_y(data)                                              ((0x00000007&(data))>>0)
+
+
+#define VO_V1_MA_FR                                                                  0x180050B4
+#define VO_V1_MA_FR_reg_addr                                                         "0xB80050B4"
+#define VO_V1_MA_FR_reg                                                              0xB80050B4
+#define set_VO_V1_MA_FR_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FR_reg)=data)
+#define get_VO_V1_MA_FR_reg   (*((volatile unsigned int*) VO_V1_MA_FR_reg))
+#define VO_V1_MA_FR_inst_adr                                                         "0x002D"
+#define VO_V1_MA_FR_inst                                                             0x002D
+#define VO_V1_MA_FR_a_shift                                                          (0)
+#define VO_V1_MA_FR_a_mask                                                           (0x7FFFFFFF)
+#define VO_V1_MA_FR_a(data)                                                          (0x7FFFFFFF&((data)<<0))
+#define VO_V1_MA_FR_a_src(data)                                                      ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_MA_FR_get_a(data)                                                      ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_MA_FR_3D                                                               0x180050B8
+#define VO_V1_MA_FR_3D_reg_addr                                                      "0xB80050B8"
+#define VO_V1_MA_FR_3D_reg                                                           0xB80050B8
+#define set_VO_V1_MA_FR_3D_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FR_3D_reg)=data)
+#define get_VO_V1_MA_FR_3D_reg   (*((volatile unsigned int*) VO_V1_MA_FR_3D_reg))
+#define VO_V1_MA_FR_3D_inst_adr                                                      "0x002E"
+#define VO_V1_MA_FR_3D_inst                                                          0x002E
+#define VO_V1_MA_FR_3D_a_shift                                                       (0)
+#define VO_V1_MA_FR_3D_a_mask                                                        (0x7FFFFFFF)
+#define VO_V1_MA_FR_3D_a(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define VO_V1_MA_FR_3D_a_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_MA_FR_3D_get_a(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_MA_FW                                                                  0x180050BC
+#define VO_V1_MA_FW_reg_addr                                                         "0xB80050BC"
+#define VO_V1_MA_FW_reg                                                              0xB80050BC
+#define set_VO_V1_MA_FW_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FW_reg)=data)
+#define get_VO_V1_MA_FW_reg   (*((volatile unsigned int*) VO_V1_MA_FW_reg))
+#define VO_V1_MA_FW_inst_adr                                                         "0x002F"
+#define VO_V1_MA_FW_inst                                                             0x002F
+#define VO_V1_MA_FW_a_shift                                                          (0)
+#define VO_V1_MA_FW_a_mask                                                           (0x7FFFFFFF)
+#define VO_V1_MA_FW_a(data)                                                          (0x7FFFFFFF&((data)<<0))
+#define VO_V1_MA_FW_a_src(data)                                                      ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_MA_FW_get_a(data)                                                      ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_MA_FW_3D                                                               0x180050C0
+#define VO_V1_MA_FW_3D_reg_addr                                                      "0xB80050C0"
+#define VO_V1_MA_FW_3D_reg                                                           0xB80050C0
+#define set_VO_V1_MA_FW_3D_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FW_3D_reg)=data)
+#define get_VO_V1_MA_FW_3D_reg   (*((volatile unsigned int*) VO_V1_MA_FW_3D_reg))
+#define VO_V1_MA_FW_3D_inst_adr                                                      "0x0030"
+#define VO_V1_MA_FW_3D_inst                                                          0x0030
+#define VO_V1_MA_FW_3D_a_shift                                                       (0)
+#define VO_V1_MA_FW_3D_a_mask                                                        (0x7FFFFFFF)
+#define VO_V1_MA_FW_3D_a(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define VO_V1_MA_FW_3D_a_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_MA_FW_3D_get_a(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_INTRA                                                                  0x180050C4
+#define VO_V1_INTRA_reg_addr                                                         "0xB80050C4"
+#define VO_V1_INTRA_reg                                                              0xB80050C4
+#define set_VO_V1_INTRA_reg(data)   (*((volatile unsigned int*) VO_V1_INTRA_reg)=data)
+#define get_VO_V1_INTRA_reg   (*((volatile unsigned int*) VO_V1_INTRA_reg))
+#define VO_V1_INTRA_inst_adr                                                         "0x0031"
+#define VO_V1_INTRA_inst                                                             0x0031
+#define VO_V1_INTRA_c_range_shift                                                    (26)
+#define VO_V1_INTRA_c_range_mask                                                     (0x04000000)
+#define VO_V1_INTRA_c_range(data)                                                    (0x04000000&((data)<<26))
+#define VO_V1_INTRA_c_range_src(data)                                                ((0x04000000&(data))>>26)
+#define VO_V1_INTRA_get_c_range(data)                                                ((0x04000000&(data))>>26)
+#define VO_V1_INTRA_y_range_shift                                                    (24)
+#define VO_V1_INTRA_y_range_mask                                                     (0x03000000)
+#define VO_V1_INTRA_y_range(data)                                                    (0x03000000&((data)<<24))
+#define VO_V1_INTRA_y_range_src(data)                                                ((0x03000000&(data))>>24)
+#define VO_V1_INTRA_get_y_range(data)                                                ((0x03000000&(data))>>24)
+#define VO_V1_INTRA_th_pos_shift                                                     (16)
+#define VO_V1_INTRA_th_pos_mask                                                      (0x001F0000)
+#define VO_V1_INTRA_th_pos(data)                                                     (0x001F0000&((data)<<16))
+#define VO_V1_INTRA_th_pos_src(data)                                                 ((0x001F0000&(data))>>16)
+#define VO_V1_INTRA_get_th_pos(data)                                                 ((0x001F0000&(data))>>16)
+#define VO_V1_INTRA_th_prediff_shift                                                 (8)
+#define VO_V1_INTRA_th_prediff_mask                                                  (0x00007F00)
+#define VO_V1_INTRA_th_prediff(data)                                                 (0x00007F00&((data)<<8))
+#define VO_V1_INTRA_th_prediff_src(data)                                             ((0x00007F00&(data))>>8)
+#define VO_V1_INTRA_get_th_prediff(data)                                             ((0x00007F00&(data))>>8)
+#define VO_V1_INTRA_th_refdiff_shift                                                 (0)
+#define VO_V1_INTRA_th_refdiff_mask                                                  (0x0000003F)
+#define VO_V1_INTRA_th_refdiff(data)                                                 (0x0000003F&((data)<<0))
+#define VO_V1_INTRA_th_refdiff_src(data)                                             ((0x0000003F&(data))>>0)
+#define VO_V1_INTRA_get_th_refdiff(data)                                             ((0x0000003F&(data))>>0)
+
+
+#define VO_V1_MA                                                                     0x180050C8
+#define VO_V1_MA_reg_addr                                                            "0xB80050C8"
+#define VO_V1_MA_reg                                                                 0xB80050C8
+#define set_VO_V1_MA_reg(data)   (*((volatile unsigned int*) VO_V1_MA_reg)=data)
+#define get_VO_V1_MA_reg   (*((volatile unsigned int*) VO_V1_MA_reg))
+#define VO_V1_MA_inst_adr                                                            "0x0032"
+#define VO_V1_MA_inst                                                                0x0032
+#define VO_V1_MA_split_shift                                                         (31)
+#define VO_V1_MA_split_mask                                                          (0x80000000)
+#define VO_V1_MA_split(data)                                                         (0x80000000&((data)<<31))
+#define VO_V1_MA_split_src(data)                                                     ((0x80000000&(data))>>31)
+#define VO_V1_MA_get_split(data)                                                     ((0x80000000&(data))>>31)
+#define VO_V1_MA_c_intra_shift                                                       (30)
+#define VO_V1_MA_c_intra_mask                                                        (0x40000000)
+#define VO_V1_MA_c_intra(data)                                                       (0x40000000&((data)<<30))
+#define VO_V1_MA_c_intra_src(data)                                                   ((0x40000000&(data))>>30)
+#define VO_V1_MA_get_c_intra(data)                                                   ((0x40000000&(data))>>30)
+#define VO_V1_MA_lp_shift                                                            (29)
+#define VO_V1_MA_lp_mask                                                             (0x20000000)
+#define VO_V1_MA_lp(data)                                                            (0x20000000&((data)<<29))
+#define VO_V1_MA_lp_src(data)                                                        ((0x20000000&(data))>>29)
+#define VO_V1_MA_get_lp(data)                                                        ((0x20000000&(data))>>29)
+#define VO_V1_MA_fm_shift                                                            (28)
+#define VO_V1_MA_fm_mask                                                             (0x10000000)
+#define VO_V1_MA_fm(data)                                                            (0x10000000&((data)<<28))
+#define VO_V1_MA_fm_src(data)                                                        ((0x10000000&(data))>>28)
+#define VO_V1_MA_get_fm(data)                                                        ((0x10000000&(data))>>28)
+#define VO_V1_MA_sc_shift                                                            (24)
+#define VO_V1_MA_sc_mask                                                             (0x07000000)
+#define VO_V1_MA_sc(data)                                                            (0x07000000&((data)<<24))
+#define VO_V1_MA_sc_src(data)                                                        ((0x07000000&(data))>>24)
+#define VO_V1_MA_get_sc(data)                                                        ((0x07000000&(data))>>24)
+#define VO_V1_MA_th_noise_shift                                                      (16)
+#define VO_V1_MA_th_noise_mask                                                       (0x00FF0000)
+#define VO_V1_MA_th_noise(data)                                                      (0x00FF0000&((data)<<16))
+#define VO_V1_MA_th_noise_src(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V1_MA_get_th_noise(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V1_MA_th_c_shift                                                          (8)
+#define VO_V1_MA_th_c_mask                                                           (0x0000FF00)
+#define VO_V1_MA_th_c(data)                                                          (0x0000FF00&((data)<<8))
+#define VO_V1_MA_th_c_src(data)                                                      ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_get_th_c(data)                                                      ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_th_y_shift                                                          (0)
+#define VO_V1_MA_th_y_mask                                                           (0x000000FF)
+#define VO_V1_MA_th_y(data)                                                          (0x000000FF&((data)<<0))
+#define VO_V1_MA_th_y_src(data)                                                      ((0x000000FF&(data))>>0)
+#define VO_V1_MA_get_th_y(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_MA_NEW                                                                 0x180050CC
+#define VO_V1_MA_NEW_reg_addr                                                        "0xB80050CC"
+#define VO_V1_MA_NEW_reg                                                             0xB80050CC
+#define set_VO_V1_MA_NEW_reg(data)   (*((volatile unsigned int*) VO_V1_MA_NEW_reg)=data)
+#define get_VO_V1_MA_NEW_reg   (*((volatile unsigned int*) VO_V1_MA_NEW_reg))
+#define VO_V1_MA_NEW_inst_adr                                                        "0x0033"
+#define VO_V1_MA_NEW_inst                                                            0x0033
+#define VO_V1_MA_NEW_correct_shift                                                   (8)
+#define VO_V1_MA_NEW_correct_mask                                                    (0x00000100)
+#define VO_V1_MA_NEW_correct(data)                                                   (0x00000100&((data)<<8))
+#define VO_V1_MA_NEW_correct_src(data)                                               ((0x00000100&(data))>>8)
+#define VO_V1_MA_NEW_get_correct(data)                                               ((0x00000100&(data))>>8)
+#define VO_V1_MA_NEW_fm_shift                                                        (7)
+#define VO_V1_MA_NEW_fm_mask                                                         (0x00000080)
+#define VO_V1_MA_NEW_fm(data)                                                        (0x00000080&((data)<<7))
+#define VO_V1_MA_NEW_fm_src(data)                                                    ((0x00000080&(data))>>7)
+#define VO_V1_MA_NEW_get_fm(data)                                                    ((0x00000080&(data))>>7)
+#define VO_V1_MA_NEW_limit_shift                                                     (6)
+#define VO_V1_MA_NEW_limit_mask                                                      (0x00000040)
+#define VO_V1_MA_NEW_limit(data)                                                     (0x00000040&((data)<<6))
+#define VO_V1_MA_NEW_limit_src(data)                                                 ((0x00000040&(data))>>6)
+#define VO_V1_MA_NEW_get_limit(data)                                                 ((0x00000040&(data))>>6)
+#define VO_V1_MA_NEW_weave_shift                                                     (5)
+#define VO_V1_MA_NEW_weave_mask                                                      (0x00000020)
+#define VO_V1_MA_NEW_weave(data)                                                     (0x00000020&((data)<<5))
+#define VO_V1_MA_NEW_weave_src(data)                                                 ((0x00000020&(data))>>5)
+#define VO_V1_MA_NEW_get_weave(data)                                                 ((0x00000020&(data))>>5)
+#define VO_V1_MA_NEW_blend_shift                                                     (4)
+#define VO_V1_MA_NEW_blend_mask                                                      (0x00000010)
+#define VO_V1_MA_NEW_blend(data)                                                     (0x00000010&((data)<<4))
+#define VO_V1_MA_NEW_blend_src(data)                                                 ((0x00000010&(data))>>4)
+#define VO_V1_MA_NEW_get_blend(data)                                                 ((0x00000010&(data))>>4)
+#define VO_V1_MA_NEW_noisy_high_shift                                                (3)
+#define VO_V1_MA_NEW_noisy_high_mask                                                 (0x00000008)
+#define VO_V1_MA_NEW_noisy_high(data)                                                (0x00000008&((data)<<3))
+#define VO_V1_MA_NEW_noisy_high_src(data)                                            ((0x00000008&(data))>>3)
+#define VO_V1_MA_NEW_get_noisy_high(data)                                            ((0x00000008&(data))>>3)
+#define VO_V1_MA_NEW_noisy_shift                                                     (2)
+#define VO_V1_MA_NEW_noisy_mask                                                      (0x00000004)
+#define VO_V1_MA_NEW_noisy(data)                                                     (0x00000004&((data)<<2))
+#define VO_V1_MA_NEW_noisy_src(data)                                                 ((0x00000004&(data))>>2)
+#define VO_V1_MA_NEW_get_noisy(data)                                                 ((0x00000004&(data))>>2)
+#define VO_V1_MA_NEW_ma_shift                                                        (1)
+#define VO_V1_MA_NEW_ma_mask                                                         (0x00000002)
+#define VO_V1_MA_NEW_ma(data)                                                        (0x00000002&((data)<<1))
+#define VO_V1_MA_NEW_ma_src(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V1_MA_NEW_get_ma(data)                                                    ((0x00000002&(data))>>1)
+#define VO_V1_MA_NEW_write_data_shift                                                (0)
+#define VO_V1_MA_NEW_write_data_mask                                                 (0x00000001)
+#define VO_V1_MA_NEW_write_data(data)                                                (0x00000001&((data)<<0))
+#define VO_V1_MA_NEW_write_data_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_V1_MA_NEW_get_write_data(data)                                            ((0x00000001&(data))>>0)
+
+
+#define VO_V1_MA_FT                                                                  0x180050D0
+#define VO_V1_MA_FT_reg_addr                                                         "0xB80050D0"
+#define VO_V1_MA_FT_reg                                                              0xB80050D0
+#define set_VO_V1_MA_FT_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FT_reg)=data)
+#define get_VO_V1_MA_FT_reg   (*((volatile unsigned int*) VO_V1_MA_FT_reg))
+#define VO_V1_MA_FT_inst_adr                                                         "0x0034"
+#define VO_V1_MA_FT_inst                                                             0x0034
+#define VO_V1_MA_FT_limit_shift                                                      (16)
+#define VO_V1_MA_FT_limit_mask                                                       (0x00FF0000)
+#define VO_V1_MA_FT_limit(data)                                                      (0x00FF0000&((data)<<16))
+#define VO_V1_MA_FT_limit_src(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V1_MA_FT_get_limit(data)                                                  ((0x00FF0000&(data))>>16)
+#define VO_V1_MA_FT_big_shift                                                        (8)
+#define VO_V1_MA_FT_big_mask                                                         (0x0000FF00)
+#define VO_V1_MA_FT_big(data)                                                        (0x0000FF00&((data)<<8))
+#define VO_V1_MA_FT_big_src(data)                                                    ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_FT_get_big(data)                                                    ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_FT_th_shift                                                         (0)
+#define VO_V1_MA_FT_th_mask                                                          (0x000000FF)
+#define VO_V1_MA_FT_th(data)                                                         (0x000000FF&((data)<<0))
+#define VO_V1_MA_FT_th_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VO_V1_MA_FT_get_th(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_MA_FM                                                                  0x180050D4
+#define VO_V1_MA_FM_reg_addr                                                         "0xB80050D4"
+#define VO_V1_MA_FM_reg                                                              0xB80050D4
+#define set_VO_V1_MA_FM_reg(data)   (*((volatile unsigned int*) VO_V1_MA_FM_reg)=data)
+#define get_VO_V1_MA_FM_reg   (*((volatile unsigned int*) VO_V1_MA_FM_reg))
+#define VO_V1_MA_FM_inst_adr                                                         "0x0035"
+#define VO_V1_MA_FM_inst                                                             0x0035
+#define VO_V1_MA_FM_noisy_shift                                                      (8)
+#define VO_V1_MA_FM_noisy_mask                                                       (0x0000FF00)
+#define VO_V1_MA_FM_noisy(data)                                                      (0x0000FF00&((data)<<8))
+#define VO_V1_MA_FM_noisy_src(data)                                                  ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_FM_get_noisy(data)                                                  ((0x0000FF00&(data))>>8)
+#define VO_V1_MA_FM_th_shift                                                         (0)
+#define VO_V1_MA_FM_th_mask                                                          (0x000000FF)
+#define VO_V1_MA_FM_th(data)                                                         (0x000000FF&((data)<<0))
+#define VO_V1_MA_FM_th_src(data)                                                     ((0x000000FF&(data))>>0)
+#define VO_V1_MA_FM_get_th(data)                                                     ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_DI_BLEND                                                               0x180050D8
+#define VO_V1_DI_BLEND_reg_addr                                                      "0xB80050D8"
+#define VO_V1_DI_BLEND_reg                                                           0xB80050D8
+#define set_VO_V1_DI_BLEND_reg(data)   (*((volatile unsigned int*) VO_V1_DI_BLEND_reg)=data)
+#define get_VO_V1_DI_BLEND_reg   (*((volatile unsigned int*) VO_V1_DI_BLEND_reg))
+#define VO_V1_DI_BLEND_inst_adr                                                      "0x0036"
+#define VO_V1_DI_BLEND_inst                                                          0x0036
+#define VO_V1_DI_BLEND_cth_log2_shift                                                (24)
+#define VO_V1_DI_BLEND_cth_log2_mask                                                 (0x07000000)
+#define VO_V1_DI_BLEND_cth_log2(data)                                                (0x07000000&((data)<<24))
+#define VO_V1_DI_BLEND_cth_log2_src(data)                                            ((0x07000000&(data))>>24)
+#define VO_V1_DI_BLEND_get_cth_log2(data)                                            ((0x07000000&(data))>>24)
+#define VO_V1_DI_BLEND_cth_low_shift                                                 (16)
+#define VO_V1_DI_BLEND_cth_low_mask                                                  (0x00FF0000)
+#define VO_V1_DI_BLEND_cth_low(data)                                                 (0x00FF0000&((data)<<16))
+#define VO_V1_DI_BLEND_cth_low_src(data)                                             ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_BLEND_get_cth_low(data)                                             ((0x00FF0000&(data))>>16)
+#define VO_V1_DI_BLEND_yth_log2_shift                                                (8)
+#define VO_V1_DI_BLEND_yth_log2_mask                                                 (0x00000700)
+#define VO_V1_DI_BLEND_yth_log2(data)                                                (0x00000700&((data)<<8))
+#define VO_V1_DI_BLEND_yth_log2_src(data)                                            ((0x00000700&(data))>>8)
+#define VO_V1_DI_BLEND_get_yth_log2(data)                                            ((0x00000700&(data))>>8)
+#define VO_V1_DI_BLEND_yth_low_shift                                                 (0)
+#define VO_V1_DI_BLEND_yth_low_mask                                                  (0x000000FF)
+#define VO_V1_DI_BLEND_yth_low(data)                                                 (0x000000FF&((data)<<0))
+#define VO_V1_DI_BLEND_yth_low_src(data)                                             ((0x000000FF&(data))>>0)
+#define VO_V1_DI_BLEND_get_yth_low(data)                                             ((0x000000FF&(data))>>0)
+
+
+#define VO_V1_FILM                                                                   0x180050DC
+#define VO_V1_FILM_reg_addr                                                          "0xB80050DC"
+#define VO_V1_FILM_reg                                                               0xB80050DC
+#define set_VO_V1_FILM_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_reg)=data)
+#define get_VO_V1_FILM_reg   (*((volatile unsigned int*) VO_V1_FILM_reg))
+#define VO_V1_FILM_inst_adr                                                          "0x0037"
+#define VO_V1_FILM_inst                                                              0x0037
+#define VO_V1_FILM_mode_shift                                                        (0)
+#define VO_V1_FILM_mode_mask                                                         (0x00000003)
+#define VO_V1_FILM_mode(data)                                                        (0x00000003&((data)<<0))
+#define VO_V1_FILM_mode_src(data)                                                    ((0x00000003&(data))>>0)
+#define VO_V1_FILM_get_mode(data)                                                    ((0x00000003&(data))>>0)
+
+
+#define VO_V1_WADTB_0                                                                0x180050E0
+#define VO_V1_WADTB_1                                                                0x180050E4
+#define VO_V1_WADTB_2                                                                0x180050E8
+#define VO_V1_WADTB_3                                                                0x180050EC
+#define VO_V1_WADTB_4                                                                0x180050F0
+#define VO_V1_WADTB_5                                                                0x180050F4
+#define VO_V1_WADTB_6                                                                0x180050F8
+#define VO_V1_WADTB_7                                                                0x180050FC
+#define VO_V1_WADTB_8                                                                0x18005100
+#define VO_V1_WADTB_0_reg_addr                                                       "0xB80050E0"
+#define VO_V1_WADTB_1_reg_addr                                                       "0xB80050E4"
+#define VO_V1_WADTB_2_reg_addr                                                       "0xB80050E8"
+#define VO_V1_WADTB_3_reg_addr                                                       "0xB80050EC"
+#define VO_V1_WADTB_4_reg_addr                                                       "0xB80050F0"
+#define VO_V1_WADTB_5_reg_addr                                                       "0xB80050F4"
+#define VO_V1_WADTB_6_reg_addr                                                       "0xB80050F8"
+#define VO_V1_WADTB_7_reg_addr                                                       "0xB80050FC"
+#define VO_V1_WADTB_8_reg_addr                                                       "0xB8005100"
+#define VO_V1_WADTB_0_reg                                                            0xB80050E0
+#define VO_V1_WADTB_1_reg                                                            0xB80050E4
+#define VO_V1_WADTB_2_reg                                                            0xB80050E8
+#define VO_V1_WADTB_3_reg                                                            0xB80050EC
+#define VO_V1_WADTB_4_reg                                                            0xB80050F0
+#define VO_V1_WADTB_5_reg                                                            0xB80050F4
+#define VO_V1_WADTB_6_reg                                                            0xB80050F8
+#define VO_V1_WADTB_7_reg                                                            0xB80050FC
+#define VO_V1_WADTB_8_reg                                                            0xB8005100
+#define set_VO_V1_WADTB_0_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_0_reg)=data)
+#define set_VO_V1_WADTB_1_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_1_reg)=data)
+#define set_VO_V1_WADTB_2_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_2_reg)=data)
+#define set_VO_V1_WADTB_3_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_3_reg)=data)
+#define set_VO_V1_WADTB_4_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_4_reg)=data)
+#define set_VO_V1_WADTB_5_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_5_reg)=data)
+#define set_VO_V1_WADTB_6_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_6_reg)=data)
+#define set_VO_V1_WADTB_7_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_7_reg)=data)
+#define set_VO_V1_WADTB_8_reg(data)   (*((volatile unsigned int*) VO_V1_WADTB_8_reg)=data)
+#define get_VO_V1_WADTB_0_reg   (*((volatile unsigned int*) VO_V1_WADTB_0_reg))
+#define get_VO_V1_WADTB_1_reg   (*((volatile unsigned int*) VO_V1_WADTB_1_reg))
+#define get_VO_V1_WADTB_2_reg   (*((volatile unsigned int*) VO_V1_WADTB_2_reg))
+#define get_VO_V1_WADTB_3_reg   (*((volatile unsigned int*) VO_V1_WADTB_3_reg))
+#define get_VO_V1_WADTB_4_reg   (*((volatile unsigned int*) VO_V1_WADTB_4_reg))
+#define get_VO_V1_WADTB_5_reg   (*((volatile unsigned int*) VO_V1_WADTB_5_reg))
+#define get_VO_V1_WADTB_6_reg   (*((volatile unsigned int*) VO_V1_WADTB_6_reg))
+#define get_VO_V1_WADTB_7_reg   (*((volatile unsigned int*) VO_V1_WADTB_7_reg))
+#define get_VO_V1_WADTB_8_reg   (*((volatile unsigned int*) VO_V1_WADTB_8_reg))
+#define VO_V1_WADTB_0_inst_adr                                                       "0x0038"
+#define VO_V1_WADTB_1_inst_adr                                                       "0x0039"
+#define VO_V1_WADTB_2_inst_adr                                                       "0x003A"
+#define VO_V1_WADTB_3_inst_adr                                                       "0x003B"
+#define VO_V1_WADTB_4_inst_adr                                                       "0x003C"
+#define VO_V1_WADTB_5_inst_adr                                                       "0x003D"
+#define VO_V1_WADTB_6_inst_adr                                                       "0x003E"
+#define VO_V1_WADTB_7_inst_adr                                                       "0x003F"
+#define VO_V1_WADTB_8_inst_adr                                                       "0x0040"
+#define VO_V1_WADTB_0_inst                                                           0x0038
+#define VO_V1_WADTB_1_inst                                                           0x0039
+#define VO_V1_WADTB_2_inst                                                           0x003A
+#define VO_V1_WADTB_3_inst                                                           0x003B
+#define VO_V1_WADTB_4_inst                                                           0x003C
+#define VO_V1_WADTB_5_inst                                                           0x003D
+#define VO_V1_WADTB_6_inst                                                           0x003E
+#define VO_V1_WADTB_7_inst                                                           0x003F
+#define VO_V1_WADTB_8_inst                                                           0x0040
+#define VO_V1_WADTB_th_shift                                                         (16)
+#define VO_V1_WADTB_th_mask                                                          (0x00FF0000)
+#define VO_V1_WADTB_th(data)                                                         (0x00FF0000&((data)<<16))
+#define VO_V1_WADTB_th_src(data)                                                     ((0x00FF0000&(data))>>16)
+#define VO_V1_WADTB_get_th(data)                                                     ((0x00FF0000&(data))>>16)
+#define VO_V1_WADTB_wad_shift                                                        (0)
+#define VO_V1_WADTB_wad_mask                                                         (0x00000FFF)
+#define VO_V1_WADTB_wad(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V1_WADTB_wad_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V1_WADTB_get_wad(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_DI_YWIN                                                                0x18005104
+#define VO_V1_DI_YWIN_reg_addr                                                       "0xB8005104"
+#define VO_V1_DI_YWIN_reg                                                            0xB8005104
+#define set_VO_V1_DI_YWIN_reg(data)   (*((volatile unsigned int*) VO_V1_DI_YWIN_reg)=data)
+#define get_VO_V1_DI_YWIN_reg   (*((volatile unsigned int*) VO_V1_DI_YWIN_reg))
+#define VO_V1_DI_YWIN_inst_adr                                                       "0x0041"
+#define VO_V1_DI_YWIN_inst                                                           0x0041
+#define VO_V1_DI_YWIN_e_shift                                                        (16)
+#define VO_V1_DI_YWIN_e_mask                                                         (0x0FFF0000)
+#define VO_V1_DI_YWIN_e(data)                                                        (0x0FFF0000&((data)<<16))
+#define VO_V1_DI_YWIN_e_src(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V1_DI_YWIN_get_e(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V1_DI_YWIN_s_shift                                                        (0)
+#define VO_V1_DI_YWIN_s_mask                                                         (0x00000FFF)
+#define VO_V1_DI_YWIN_s(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V1_DI_YWIN_s_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V1_DI_YWIN_get_s(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_DI_CWIN                                                                0x18005108
+#define VO_V1_DI_CWIN_reg_addr                                                       "0xB8005108"
+#define VO_V1_DI_CWIN_reg                                                            0xB8005108
+#define set_VO_V1_DI_CWIN_reg(data)   (*((volatile unsigned int*) VO_V1_DI_CWIN_reg)=data)
+#define get_VO_V1_DI_CWIN_reg   (*((volatile unsigned int*) VO_V1_DI_CWIN_reg))
+#define VO_V1_DI_CWIN_inst_adr                                                       "0x0042"
+#define VO_V1_DI_CWIN_inst                                                           0x0042
+#define VO_V1_DI_CWIN_e_shift                                                        (16)
+#define VO_V1_DI_CWIN_e_mask                                                         (0x0FFF0000)
+#define VO_V1_DI_CWIN_e(data)                                                        (0x0FFF0000&((data)<<16))
+#define VO_V1_DI_CWIN_e_src(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V1_DI_CWIN_get_e(data)                                                    ((0x0FFF0000&(data))>>16)
+#define VO_V1_DI_CWIN_s_shift                                                        (0)
+#define VO_V1_DI_CWIN_s_mask                                                         (0x00000FFF)
+#define VO_V1_DI_CWIN_s(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V1_DI_CWIN_s_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V1_DI_CWIN_get_s(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_DI_WINX                                                                0x1800510C
+#define VO_V1_DI_WINX_reg_addr                                                       "0xB800510C"
+#define VO_V1_DI_WINX_reg                                                            0xB800510C
+#define set_VO_V1_DI_WINX_reg(data)   (*((volatile unsigned int*) VO_V1_DI_WINX_reg)=data)
+#define get_VO_V1_DI_WINX_reg   (*((volatile unsigned int*) VO_V1_DI_WINX_reg))
+#define VO_V1_DI_WINX_inst_adr                                                       "0x0043"
+#define VO_V1_DI_WINX_inst                                                           0x0043
+#define VO_V1_DI_WINX_e_shift                                                        (16)
+#define VO_V1_DI_WINX_e_mask                                                         (0x1FFF0000)
+#define VO_V1_DI_WINX_e(data)                                                        (0x1FFF0000&((data)<<16))
+#define VO_V1_DI_WINX_e_src(data)                                                    ((0x1FFF0000&(data))>>16)
+#define VO_V1_DI_WINX_get_e(data)                                                    ((0x1FFF0000&(data))>>16)
+#define VO_V1_DI_WINX_s_shift                                                        (0)
+#define VO_V1_DI_WINX_s_mask                                                         (0x00001FFF)
+#define VO_V1_DI_WINX_s(data)                                                        (0x00001FFF&((data)<<0))
+#define VO_V1_DI_WINX_s_src(data)                                                    ((0x00001FFF&(data))>>0)
+#define VO_V1_DI_WINX_get_s(data)                                                    ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1_FILM_SWAD_0                                                            0x18005110
+#define VO_V1_FILM_SWAD_1                                                            0x18005114
+#define VO_V1_FILM_SWAD_2                                                            0x18005118
+#define VO_V1_FILM_SWAD_3                                                            0x1800511C
+#define VO_V1_FILM_SWAD_4                                                            0x18005120
+#define VO_V1_FILM_SWAD_5                                                            0x18005124
+#define VO_V1_FILM_SWAD_0_reg_addr                                                   "0xB8005110"
+#define VO_V1_FILM_SWAD_1_reg_addr                                                   "0xB8005114"
+#define VO_V1_FILM_SWAD_2_reg_addr                                                   "0xB8005118"
+#define VO_V1_FILM_SWAD_3_reg_addr                                                   "0xB800511C"
+#define VO_V1_FILM_SWAD_4_reg_addr                                                   "0xB8005120"
+#define VO_V1_FILM_SWAD_5_reg_addr                                                   "0xB8005124"
+#define VO_V1_FILM_SWAD_0_reg                                                        0xB8005110
+#define VO_V1_FILM_SWAD_1_reg                                                        0xB8005114
+#define VO_V1_FILM_SWAD_2_reg                                                        0xB8005118
+#define VO_V1_FILM_SWAD_3_reg                                                        0xB800511C
+#define VO_V1_FILM_SWAD_4_reg                                                        0xB8005120
+#define VO_V1_FILM_SWAD_5_reg                                                        0xB8005124
+#define set_VO_V1_FILM_SWAD_0_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_0_reg)=data)
+#define set_VO_V1_FILM_SWAD_1_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_1_reg)=data)
+#define set_VO_V1_FILM_SWAD_2_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_2_reg)=data)
+#define set_VO_V1_FILM_SWAD_3_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_3_reg)=data)
+#define set_VO_V1_FILM_SWAD_4_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_4_reg)=data)
+#define set_VO_V1_FILM_SWAD_5_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_SWAD_5_reg)=data)
+#define get_VO_V1_FILM_SWAD_0_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_0_reg))
+#define get_VO_V1_FILM_SWAD_1_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_1_reg))
+#define get_VO_V1_FILM_SWAD_2_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_2_reg))
+#define get_VO_V1_FILM_SWAD_3_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_3_reg))
+#define get_VO_V1_FILM_SWAD_4_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_4_reg))
+#define get_VO_V1_FILM_SWAD_5_reg   (*((volatile unsigned int*) VO_V1_FILM_SWAD_5_reg))
+#define VO_V1_FILM_SWAD_0_inst_adr                                                   "0x0044"
+#define VO_V1_FILM_SWAD_1_inst_adr                                                   "0x0045"
+#define VO_V1_FILM_SWAD_2_inst_adr                                                   "0x0046"
+#define VO_V1_FILM_SWAD_3_inst_adr                                                   "0x0047"
+#define VO_V1_FILM_SWAD_4_inst_adr                                                   "0x0048"
+#define VO_V1_FILM_SWAD_5_inst_adr                                                   "0x0049"
+#define VO_V1_FILM_SWAD_0_inst                                                       0x0044
+#define VO_V1_FILM_SWAD_1_inst                                                       0x0045
+#define VO_V1_FILM_SWAD_2_inst                                                       0x0046
+#define VO_V1_FILM_SWAD_3_inst                                                       0x0047
+#define VO_V1_FILM_SWAD_4_inst                                                       0x0048
+#define VO_V1_FILM_SWAD_5_inst                                                       0x0049
+#define VO_V1_FILM_SWAD_swad_shift                                                   (0)
+#define VO_V1_FILM_SWAD_swad_mask                                                    (0x07FFFFFF)
+#define VO_V1_FILM_SWAD_swad(data)                                                   (0x07FFFFFF&((data)<<0))
+#define VO_V1_FILM_SWAD_swad_src(data)                                               ((0x07FFFFFF&(data))>>0)
+#define VO_V1_FILM_SWAD_get_swad(data)                                               ((0x07FFFFFF&(data))>>0)
+
+
+#define VO_V1_FILM_TH_0                                                              0x18005128
+#define VO_V1_FILM_TH_1                                                              0x1800512C
+#define VO_V1_FILM_TH_2                                                              0x18005130
+#define VO_V1_FILM_TH_3                                                              0x18005134
+#define VO_V1_FILM_TH_4                                                              0x18005138
+#define VO_V1_FILM_TH_5                                                              0x1800513C
+#define VO_V1_FILM_TH_0_reg_addr                                                     "0xB8005128"
+#define VO_V1_FILM_TH_1_reg_addr                                                     "0xB800512C"
+#define VO_V1_FILM_TH_2_reg_addr                                                     "0xB8005130"
+#define VO_V1_FILM_TH_3_reg_addr                                                     "0xB8005134"
+#define VO_V1_FILM_TH_4_reg_addr                                                     "0xB8005138"
+#define VO_V1_FILM_TH_5_reg_addr                                                     "0xB800513C"
+#define VO_V1_FILM_TH_0_reg                                                          0xB8005128
+#define VO_V1_FILM_TH_1_reg                                                          0xB800512C
+#define VO_V1_FILM_TH_2_reg                                                          0xB8005130
+#define VO_V1_FILM_TH_3_reg                                                          0xB8005134
+#define VO_V1_FILM_TH_4_reg                                                          0xB8005138
+#define VO_V1_FILM_TH_5_reg                                                          0xB800513C
+#define set_VO_V1_FILM_TH_0_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_0_reg)=data)
+#define set_VO_V1_FILM_TH_1_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_1_reg)=data)
+#define set_VO_V1_FILM_TH_2_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_2_reg)=data)
+#define set_VO_V1_FILM_TH_3_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_3_reg)=data)
+#define set_VO_V1_FILM_TH_4_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_4_reg)=data)
+#define set_VO_V1_FILM_TH_5_reg(data)   (*((volatile unsigned int*) VO_V1_FILM_TH_5_reg)=data)
+#define get_VO_V1_FILM_TH_0_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_0_reg))
+#define get_VO_V1_FILM_TH_1_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_1_reg))
+#define get_VO_V1_FILM_TH_2_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_2_reg))
+#define get_VO_V1_FILM_TH_3_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_3_reg))
+#define get_VO_V1_FILM_TH_4_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_4_reg))
+#define get_VO_V1_FILM_TH_5_reg   (*((volatile unsigned int*) VO_V1_FILM_TH_5_reg))
+#define VO_V1_FILM_TH_0_inst_adr                                                     "0x004A"
+#define VO_V1_FILM_TH_1_inst_adr                                                     "0x004B"
+#define VO_V1_FILM_TH_2_inst_adr                                                     "0x004C"
+#define VO_V1_FILM_TH_3_inst_adr                                                     "0x004D"
+#define VO_V1_FILM_TH_4_inst_adr                                                     "0x004E"
+#define VO_V1_FILM_TH_5_inst_adr                                                     "0x004F"
+#define VO_V1_FILM_TH_0_inst                                                         0x004A
+#define VO_V1_FILM_TH_1_inst                                                         0x004B
+#define VO_V1_FILM_TH_2_inst                                                         0x004C
+#define VO_V1_FILM_TH_3_inst                                                         0x004D
+#define VO_V1_FILM_TH_4_inst                                                         0x004E
+#define VO_V1_FILM_TH_5_inst                                                         0x004F
+#define VO_V1_FILM_TH_th_shift                                                       (0)
+#define VO_V1_FILM_TH_th_mask                                                        (0x07FFFFFF)
+#define VO_V1_FILM_TH_th(data)                                                       (0x07FFFFFF&((data)<<0))
+#define VO_V1_FILM_TH_th_src(data)                                                   ((0x07FFFFFF&(data))>>0)
+#define VO_V1_FILM_TH_get_th(data)                                                   ((0x07FFFFFF&(data))>>0)
+
+
+#define VO_V1_DI_DBG                                                                 0x18005140
+#define VO_V1_DI_DBG_reg_addr                                                        "0xB8005140"
+#define VO_V1_DI_DBG_reg                                                             0xB8005140
+#define set_VO_V1_DI_DBG_reg(data)   (*((volatile unsigned int*) VO_V1_DI_DBG_reg)=data)
+#define get_VO_V1_DI_DBG_reg   (*((volatile unsigned int*) VO_V1_DI_DBG_reg))
+#define VO_V1_DI_DBG_inst_adr                                                        "0x0050"
+#define VO_V1_DI_DBG_inst                                                            0x0050
+#define VO_V1_DI_DBG_mode_shift                                                      (0)
+#define VO_V1_DI_DBG_mode_mask                                                       (0x00000007)
+#define VO_V1_DI_DBG_mode(data)                                                      (0x00000007&((data)<<0))
+#define VO_V1_DI_DBG_mode_src(data)                                                  ((0x00000007&(data))>>0)
+#define VO_V1_DI_DBG_get_mode(data)                                                  ((0x00000007&(data))>>0)
+
+
+#define VO_V1_STA_TOTAL                                                              0x18005144
+#define VO_V1_STA_TOTAL_reg_addr                                                     "0xB8005144"
+#define VO_V1_STA_TOTAL_reg                                                          0xB8005144
+#define set_VO_V1_STA_TOTAL_reg(data)   (*((volatile unsigned int*) VO_V1_STA_TOTAL_reg)=data)
+#define get_VO_V1_STA_TOTAL_reg   (*((volatile unsigned int*) VO_V1_STA_TOTAL_reg))
+#define VO_V1_STA_TOTAL_inst_adr                                                     "0x0051"
+#define VO_V1_STA_TOTAL_inst                                                         0x0051
+#define VO_V1_STA_TOTAL_cnt_shift                                                    (0)
+#define VO_V1_STA_TOTAL_cnt_mask                                                     (0x007FFFFF)
+#define VO_V1_STA_TOTAL_cnt(data)                                                    (0x007FFFFF&((data)<<0))
+#define VO_V1_STA_TOTAL_cnt_src(data)                                                ((0x007FFFFF&(data))>>0)
+#define VO_V1_STA_TOTAL_get_cnt(data)                                                ((0x007FFFFF&(data))>>0)
+
+
+#define VO_V1_STA_SUM                                                                0x18005148
+#define VO_V1_STA_SUM_reg_addr                                                       "0xB8005148"
+#define VO_V1_STA_SUM_reg                                                            0xB8005148
+#define set_VO_V1_STA_SUM_reg(data)   (*((volatile unsigned int*) VO_V1_STA_SUM_reg)=data)
+#define get_VO_V1_STA_SUM_reg   (*((volatile unsigned int*) VO_V1_STA_SUM_reg))
+#define VO_V1_STA_SUM_inst_adr                                                       "0x0052"
+#define VO_V1_STA_SUM_inst                                                           0x0052
+#define VO_V1_STA_SUM_sum_shift                                                      (0)
+#define VO_V1_STA_SUM_sum_mask                                                       (0x7FFFFFFF)
+#define VO_V1_STA_SUM_sum(data)                                                      (0x7FFFFFFF&((data)<<0))
+#define VO_V1_STA_SUM_sum_src(data)                                                  ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_STA_SUM_get_sum(data)                                                  ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_STA_BKT_0                                                              0x1800514C
+#define VO_V1_STA_BKT_1                                                              0x18005150
+#define VO_V1_STA_BKT_2                                                              0x18005154
+#define VO_V1_STA_BKT_3                                                              0x18005158
+#define VO_V1_STA_BKT_4                                                              0x1800515C
+#define VO_V1_STA_BKT_5                                                              0x18005160
+#define VO_V1_STA_BKT_6                                                              0x18005164
+#define VO_V1_STA_BKT_7                                                              0x18005168
+#define VO_V1_STA_BKT_8                                                              0x1800516C
+#define VO_V1_STA_BKT_9                                                              0x18005170
+#define VO_V1_STA_BKT_0_reg_addr                                                     "0xB800514C"
+#define VO_V1_STA_BKT_1_reg_addr                                                     "0xB8005150"
+#define VO_V1_STA_BKT_2_reg_addr                                                     "0xB8005154"
+#define VO_V1_STA_BKT_3_reg_addr                                                     "0xB8005158"
+#define VO_V1_STA_BKT_4_reg_addr                                                     "0xB800515C"
+#define VO_V1_STA_BKT_5_reg_addr                                                     "0xB8005160"
+#define VO_V1_STA_BKT_6_reg_addr                                                     "0xB8005164"
+#define VO_V1_STA_BKT_7_reg_addr                                                     "0xB8005168"
+#define VO_V1_STA_BKT_8_reg_addr                                                     "0xB800516C"
+#define VO_V1_STA_BKT_9_reg_addr                                                     "0xB8005170"
+#define VO_V1_STA_BKT_0_reg                                                          0xB800514C
+#define VO_V1_STA_BKT_1_reg                                                          0xB8005150
+#define VO_V1_STA_BKT_2_reg                                                          0xB8005154
+#define VO_V1_STA_BKT_3_reg                                                          0xB8005158
+#define VO_V1_STA_BKT_4_reg                                                          0xB800515C
+#define VO_V1_STA_BKT_5_reg                                                          0xB8005160
+#define VO_V1_STA_BKT_6_reg                                                          0xB8005164
+#define VO_V1_STA_BKT_7_reg                                                          0xB8005168
+#define VO_V1_STA_BKT_8_reg                                                          0xB800516C
+#define VO_V1_STA_BKT_9_reg                                                          0xB8005170
+#define set_VO_V1_STA_BKT_0_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_0_reg)=data)
+#define set_VO_V1_STA_BKT_1_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_1_reg)=data)
+#define set_VO_V1_STA_BKT_2_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_2_reg)=data)
+#define set_VO_V1_STA_BKT_3_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_3_reg)=data)
+#define set_VO_V1_STA_BKT_4_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_4_reg)=data)
+#define set_VO_V1_STA_BKT_5_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_5_reg)=data)
+#define set_VO_V1_STA_BKT_6_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_6_reg)=data)
+#define set_VO_V1_STA_BKT_7_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_7_reg)=data)
+#define set_VO_V1_STA_BKT_8_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_8_reg)=data)
+#define set_VO_V1_STA_BKT_9_reg(data)   (*((volatile unsigned int*) VO_V1_STA_BKT_9_reg)=data)
+#define get_VO_V1_STA_BKT_0_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_0_reg))
+#define get_VO_V1_STA_BKT_1_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_1_reg))
+#define get_VO_V1_STA_BKT_2_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_2_reg))
+#define get_VO_V1_STA_BKT_3_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_3_reg))
+#define get_VO_V1_STA_BKT_4_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_4_reg))
+#define get_VO_V1_STA_BKT_5_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_5_reg))
+#define get_VO_V1_STA_BKT_6_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_6_reg))
+#define get_VO_V1_STA_BKT_7_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_7_reg))
+#define get_VO_V1_STA_BKT_8_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_8_reg))
+#define get_VO_V1_STA_BKT_9_reg   (*((volatile unsigned int*) VO_V1_STA_BKT_9_reg))
+#define VO_V1_STA_BKT_0_inst_adr                                                     "0x0053"
+#define VO_V1_STA_BKT_1_inst_adr                                                     "0x0054"
+#define VO_V1_STA_BKT_2_inst_adr                                                     "0x0055"
+#define VO_V1_STA_BKT_3_inst_adr                                                     "0x0056"
+#define VO_V1_STA_BKT_4_inst_adr                                                     "0x0057"
+#define VO_V1_STA_BKT_5_inst_adr                                                     "0x0058"
+#define VO_V1_STA_BKT_6_inst_adr                                                     "0x0059"
+#define VO_V1_STA_BKT_7_inst_adr                                                     "0x005A"
+#define VO_V1_STA_BKT_8_inst_adr                                                     "0x005B"
+#define VO_V1_STA_BKT_9_inst_adr                                                     "0x005C"
+#define VO_V1_STA_BKT_0_inst                                                         0x0053
+#define VO_V1_STA_BKT_1_inst                                                         0x0054
+#define VO_V1_STA_BKT_2_inst                                                         0x0055
+#define VO_V1_STA_BKT_3_inst                                                         0x0056
+#define VO_V1_STA_BKT_4_inst                                                         0x0057
+#define VO_V1_STA_BKT_5_inst                                                         0x0058
+#define VO_V1_STA_BKT_6_inst                                                         0x0059
+#define VO_V1_STA_BKT_7_inst                                                         0x005A
+#define VO_V1_STA_BKT_8_inst                                                         0x005B
+#define VO_V1_STA_BKT_9_inst                                                         0x005C
+#define VO_V1_STA_BKT_cnt_shift                                                      (0)
+#define VO_V1_STA_BKT_cnt_mask                                                       (0x007FFFFF)
+#define VO_V1_STA_BKT_cnt(data)                                                      (0x007FFFFF&((data)<<0))
+#define VO_V1_STA_BKT_cnt_src(data)                                                  ((0x007FFFFF&(data))>>0)
+#define VO_V1_STA_BKT_get_cnt(data)                                                  ((0x007FFFFF&(data))>>0)
+
+
+#define VO_V1_STA_AD_0                                                               0x18005174
+#define VO_V1_STA_AD_1                                                               0x18005178
+#define VO_V1_STA_AD_2                                                               0x1800517C
+#define VO_V1_STA_AD_3                                                               0x18005180
+#define VO_V1_STA_AD_4                                                               0x18005184
+#define VO_V1_STA_AD_5                                                               0x18005188
+#define VO_V1_STA_AD_6                                                               0x1800518C
+#define VO_V1_STA_AD_7                                                               0x18005190
+#define VO_V1_STA_AD_8                                                               0x18005194
+#define VO_V1_STA_AD_9                                                               0x18005198
+#define VO_V1_STA_AD_0_reg_addr                                                      "0xB8005174"
+#define VO_V1_STA_AD_1_reg_addr                                                      "0xB8005178"
+#define VO_V1_STA_AD_2_reg_addr                                                      "0xB800517C"
+#define VO_V1_STA_AD_3_reg_addr                                                      "0xB8005180"
+#define VO_V1_STA_AD_4_reg_addr                                                      "0xB8005184"
+#define VO_V1_STA_AD_5_reg_addr                                                      "0xB8005188"
+#define VO_V1_STA_AD_6_reg_addr                                                      "0xB800518C"
+#define VO_V1_STA_AD_7_reg_addr                                                      "0xB8005190"
+#define VO_V1_STA_AD_8_reg_addr                                                      "0xB8005194"
+#define VO_V1_STA_AD_9_reg_addr                                                      "0xB8005198"
+#define VO_V1_STA_AD_0_reg                                                           0xB8005174
+#define VO_V1_STA_AD_1_reg                                                           0xB8005178
+#define VO_V1_STA_AD_2_reg                                                           0xB800517C
+#define VO_V1_STA_AD_3_reg                                                           0xB8005180
+#define VO_V1_STA_AD_4_reg                                                           0xB8005184
+#define VO_V1_STA_AD_5_reg                                                           0xB8005188
+#define VO_V1_STA_AD_6_reg                                                           0xB800518C
+#define VO_V1_STA_AD_7_reg                                                           0xB8005190
+#define VO_V1_STA_AD_8_reg                                                           0xB8005194
+#define VO_V1_STA_AD_9_reg                                                           0xB8005198
+#define set_VO_V1_STA_AD_0_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_0_reg)=data)
+#define set_VO_V1_STA_AD_1_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_1_reg)=data)
+#define set_VO_V1_STA_AD_2_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_2_reg)=data)
+#define set_VO_V1_STA_AD_3_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_3_reg)=data)
+#define set_VO_V1_STA_AD_4_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_4_reg)=data)
+#define set_VO_V1_STA_AD_5_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_5_reg)=data)
+#define set_VO_V1_STA_AD_6_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_6_reg)=data)
+#define set_VO_V1_STA_AD_7_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_7_reg)=data)
+#define set_VO_V1_STA_AD_8_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_8_reg)=data)
+#define set_VO_V1_STA_AD_9_reg(data)   (*((volatile unsigned int*) VO_V1_STA_AD_9_reg)=data)
+#define get_VO_V1_STA_AD_0_reg   (*((volatile unsigned int*) VO_V1_STA_AD_0_reg))
+#define get_VO_V1_STA_AD_1_reg   (*((volatile unsigned int*) VO_V1_STA_AD_1_reg))
+#define get_VO_V1_STA_AD_2_reg   (*((volatile unsigned int*) VO_V1_STA_AD_2_reg))
+#define get_VO_V1_STA_AD_3_reg   (*((volatile unsigned int*) VO_V1_STA_AD_3_reg))
+#define get_VO_V1_STA_AD_4_reg   (*((volatile unsigned int*) VO_V1_STA_AD_4_reg))
+#define get_VO_V1_STA_AD_5_reg   (*((volatile unsigned int*) VO_V1_STA_AD_5_reg))
+#define get_VO_V1_STA_AD_6_reg   (*((volatile unsigned int*) VO_V1_STA_AD_6_reg))
+#define get_VO_V1_STA_AD_7_reg   (*((volatile unsigned int*) VO_V1_STA_AD_7_reg))
+#define get_VO_V1_STA_AD_8_reg   (*((volatile unsigned int*) VO_V1_STA_AD_8_reg))
+#define get_VO_V1_STA_AD_9_reg   (*((volatile unsigned int*) VO_V1_STA_AD_9_reg))
+#define VO_V1_STA_AD_0_inst_adr                                                      "0x005D"
+#define VO_V1_STA_AD_1_inst_adr                                                      "0x005E"
+#define VO_V1_STA_AD_2_inst_adr                                                      "0x005F"
+#define VO_V1_STA_AD_3_inst_adr                                                      "0x0060"
+#define VO_V1_STA_AD_4_inst_adr                                                      "0x0061"
+#define VO_V1_STA_AD_5_inst_adr                                                      "0x0062"
+#define VO_V1_STA_AD_6_inst_adr                                                      "0x0063"
+#define VO_V1_STA_AD_7_inst_adr                                                      "0x0064"
+#define VO_V1_STA_AD_8_inst_adr                                                      "0x0065"
+#define VO_V1_STA_AD_9_inst_adr                                                      "0x0066"
+#define VO_V1_STA_AD_0_inst                                                          0x005D
+#define VO_V1_STA_AD_1_inst                                                          0x005E
+#define VO_V1_STA_AD_2_inst                                                          0x005F
+#define VO_V1_STA_AD_3_inst                                                          0x0060
+#define VO_V1_STA_AD_4_inst                                                          0x0061
+#define VO_V1_STA_AD_5_inst                                                          0x0062
+#define VO_V1_STA_AD_6_inst                                                          0x0063
+#define VO_V1_STA_AD_7_inst                                                          0x0064
+#define VO_V1_STA_AD_8_inst                                                          0x0065
+#define VO_V1_STA_AD_9_inst                                                          0x0066
+#define VO_V1_STA_AD_sum_shift                                                       (0)
+#define VO_V1_STA_AD_sum_mask                                                        (0x7FFFFFFF)
+#define VO_V1_STA_AD_sum(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define VO_V1_STA_AD_sum_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define VO_V1_STA_AD_get_sum(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_V1_VSYI                                                                   0x1800519C
+#define VO_V1_VSYI_reg_addr                                                          "0xB800519C"
+#define VO_V1_VSYI_reg                                                               0xB800519C
+#define set_VO_V1_VSYI_reg(data)   (*((volatile unsigned int*) VO_V1_VSYI_reg)=data)
+#define get_VO_V1_VSYI_reg   (*((volatile unsigned int*) VO_V1_VSYI_reg))
+#define VO_V1_VSYI_inst_adr                                                          "0x0067"
+#define VO_V1_VSYI_inst                                                              0x0067
+#define VO_V1_VSYI_offset_shift                                                      (16)
+#define VO_V1_VSYI_offset_mask                                                       (0x3FFF0000)
+#define VO_V1_VSYI_offset(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_V1_VSYI_offset_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSYI_get_offset(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSYI_phase_shift                                                       (0)
+#define VO_V1_VSYI_phase_mask                                                        (0x0000FFFF)
+#define VO_V1_VSYI_phase(data)                                                       (0x0000FFFF&((data)<<0))
+#define VO_V1_VSYI_phase_src(data)                                                   ((0x0000FFFF&(data))>>0)
+#define VO_V1_VSYI_get_phase(data)                                                   ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_VSCI                                                                   0x180051A0
+#define VO_V1_VSCI_reg_addr                                                          "0xB80051A0"
+#define VO_V1_VSCI_reg                                                               0xB80051A0
+#define set_VO_V1_VSCI_reg(data)   (*((volatile unsigned int*) VO_V1_VSCI_reg)=data)
+#define get_VO_V1_VSCI_reg   (*((volatile unsigned int*) VO_V1_VSCI_reg))
+#define VO_V1_VSCI_inst_adr                                                          "0x0068"
+#define VO_V1_VSCI_inst                                                              0x0068
+#define VO_V1_VSCI_offset_shift                                                      (16)
+#define VO_V1_VSCI_offset_mask                                                       (0x3FFF0000)
+#define VO_V1_VSCI_offset(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_V1_VSCI_offset_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSCI_get_offset(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSCI_phase_shift                                                       (0)
+#define VO_V1_VSCI_phase_mask                                                        (0x0000FFFF)
+#define VO_V1_VSCI_phase(data)                                                       (0x0000FFFF&((data)<<0))
+#define VO_V1_VSCI_phase_src(data)                                                   ((0x0000FFFF&(data))>>0)
+#define VO_V1_VSCI_get_phase(data)                                                   ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_VSD                                                                    0x180051A4
+#define VO_V1_VSD_reg_addr                                                           "0xB80051A4"
+#define VO_V1_VSD_reg                                                                0xB80051A4
+#define set_VO_V1_VSD_reg(data)   (*((volatile unsigned int*) VO_V1_VSD_reg)=data)
+#define get_VO_V1_VSD_reg   (*((volatile unsigned int*) VO_V1_VSD_reg))
+#define VO_V1_VSD_inst_adr                                                           "0x0069"
+#define VO_V1_VSD_inst                                                               0x0069
+#define VO_V1_VSD_delta_shift                                                        (0)
+#define VO_V1_VSD_delta_mask                                                         (0x001FFFFF)
+#define VO_V1_VSD_delta(data)                                                        (0x001FFFFF&((data)<<0))
+#define VO_V1_VSD_delta_src(data)                                                    ((0x001FFFFF&(data))>>0)
+#define VO_V1_VSD_get_delta(data)                                                    ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_VSD_H                                                                  0x180051A8
+#define VO_V1_VSD_H_reg_addr                                                         "0xB80051A8"
+#define VO_V1_VSD_H_reg                                                              0xB80051A8
+#define set_VO_V1_VSD_H_reg(data)   (*((volatile unsigned int*) VO_V1_VSD_H_reg)=data)
+#define get_VO_V1_VSD_H_reg   (*((volatile unsigned int*) VO_V1_VSD_H_reg))
+#define VO_V1_VSD_H_inst_adr                                                         "0x006A"
+#define VO_V1_VSD_H_inst                                                             0x006A
+#define VO_V1_VSD_H_out_shift                                                        (0)
+#define VO_V1_VSD_H_out_mask                                                         (0x00000FFF)
+#define VO_V1_VSD_H_out(data)                                                        (0x00000FFF&((data)<<0))
+#define VO_V1_VSD_H_out_src(data)                                                    ((0x00000FFF&(data))>>0)
+#define VO_V1_VSD_H_get_out(data)                                                    ((0x00000FFF&(data))>>0)
+
+
+#define VO_V1_VSYC_0                                                                 0x180051AC
+#define VO_V1_VSYC_1                                                                 0x180051B0
+#define VO_V1_VSYC_2                                                                 0x180051B4
+#define VO_V1_VSYC_3                                                                 0x180051B8
+#define VO_V1_VSYC_4                                                                 0x180051BC
+#define VO_V1_VSYC_5                                                                 0x180051C0
+#define VO_V1_VSYC_6                                                                 0x180051C4
+#define VO_V1_VSYC_7                                                                 0x180051C8
+#define VO_V1_VSYC_8                                                                 0x180051CC
+#define VO_V1_VSYC_9                                                                 0x180051D0
+#define VO_V1_VSYC_10                                                                 0x180051D4
+#define VO_V1_VSYC_11                                                                 0x180051D8
+#define VO_V1_VSYC_12                                                                 0x180051DC
+#define VO_V1_VSYC_13                                                                 0x180051E0
+#define VO_V1_VSYC_14                                                                 0x180051E4
+#define VO_V1_VSYC_15                                                                 0x180051E8
+#define VO_V1_VSYC_0_reg_addr                                                        "0xB80051AC"
+#define VO_V1_VSYC_1_reg_addr                                                        "0xB80051B0"
+#define VO_V1_VSYC_2_reg_addr                                                        "0xB80051B4"
+#define VO_V1_VSYC_3_reg_addr                                                        "0xB80051B8"
+#define VO_V1_VSYC_4_reg_addr                                                        "0xB80051BC"
+#define VO_V1_VSYC_5_reg_addr                                                        "0xB80051C0"
+#define VO_V1_VSYC_6_reg_addr                                                        "0xB80051C4"
+#define VO_V1_VSYC_7_reg_addr                                                        "0xB80051C8"
+#define VO_V1_VSYC_8_reg_addr                                                        "0xB80051CC"
+#define VO_V1_VSYC_9_reg_addr                                                        "0xB80051D0"
+#define VO_V1_VSYC_10_reg_addr                                                        "0xB80051D4"
+#define VO_V1_VSYC_11_reg_addr                                                        "0xB80051D8"
+#define VO_V1_VSYC_12_reg_addr                                                        "0xB80051DC"
+#define VO_V1_VSYC_13_reg_addr                                                        "0xB80051E0"
+#define VO_V1_VSYC_14_reg_addr                                                        "0xB80051E4"
+#define VO_V1_VSYC_15_reg_addr                                                        "0xB80051E8"
+#define VO_V1_VSYC_0_reg                                                             0xB80051AC
+#define VO_V1_VSYC_1_reg                                                             0xB80051B0
+#define VO_V1_VSYC_2_reg                                                             0xB80051B4
+#define VO_V1_VSYC_3_reg                                                             0xB80051B8
+#define VO_V1_VSYC_4_reg                                                             0xB80051BC
+#define VO_V1_VSYC_5_reg                                                             0xB80051C0
+#define VO_V1_VSYC_6_reg                                                             0xB80051C4
+#define VO_V1_VSYC_7_reg                                                             0xB80051C8
+#define VO_V1_VSYC_8_reg                                                             0xB80051CC
+#define VO_V1_VSYC_9_reg                                                             0xB80051D0
+#define VO_V1_VSYC_10_reg                                                             0xB80051D4
+#define VO_V1_VSYC_11_reg                                                             0xB80051D8
+#define VO_V1_VSYC_12_reg                                                             0xB80051DC
+#define VO_V1_VSYC_13_reg                                                             0xB80051E0
+#define VO_V1_VSYC_14_reg                                                             0xB80051E4
+#define VO_V1_VSYC_15_reg                                                             0xB80051E8
+#define set_VO_V1_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_0_reg)=data)
+#define set_VO_V1_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_1_reg)=data)
+#define set_VO_V1_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_2_reg)=data)
+#define set_VO_V1_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_3_reg)=data)
+#define set_VO_V1_VSYC_4_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_4_reg)=data)
+#define set_VO_V1_VSYC_5_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_5_reg)=data)
+#define set_VO_V1_VSYC_6_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_6_reg)=data)
+#define set_VO_V1_VSYC_7_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_7_reg)=data)
+#define set_VO_V1_VSYC_8_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_8_reg)=data)
+#define set_VO_V1_VSYC_9_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_9_reg)=data)
+#define set_VO_V1_VSYC_10_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_10_reg)=data)
+#define set_VO_V1_VSYC_11_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_11_reg)=data)
+#define set_VO_V1_VSYC_12_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_12_reg)=data)
+#define set_VO_V1_VSYC_13_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_13_reg)=data)
+#define set_VO_V1_VSYC_14_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_14_reg)=data)
+#define set_VO_V1_VSYC_15_reg(data)   (*((volatile unsigned int*) VO_V1_VSYC_15_reg)=data)
+#define get_VO_V1_VSYC_0_reg   (*((volatile unsigned int*) VO_V1_VSYC_0_reg))
+#define get_VO_V1_VSYC_1_reg   (*((volatile unsigned int*) VO_V1_VSYC_1_reg))
+#define get_VO_V1_VSYC_2_reg   (*((volatile unsigned int*) VO_V1_VSYC_2_reg))
+#define get_VO_V1_VSYC_3_reg   (*((volatile unsigned int*) VO_V1_VSYC_3_reg))
+#define get_VO_V1_VSYC_4_reg   (*((volatile unsigned int*) VO_V1_VSYC_4_reg))
+#define get_VO_V1_VSYC_5_reg   (*((volatile unsigned int*) VO_V1_VSYC_5_reg))
+#define get_VO_V1_VSYC_6_reg   (*((volatile unsigned int*) VO_V1_VSYC_6_reg))
+#define get_VO_V1_VSYC_7_reg   (*((volatile unsigned int*) VO_V1_VSYC_7_reg))
+#define get_VO_V1_VSYC_8_reg   (*((volatile unsigned int*) VO_V1_VSYC_8_reg))
+#define get_VO_V1_VSYC_9_reg   (*((volatile unsigned int*) VO_V1_VSYC_9_reg))
+#define get_VO_V1_VSYC_10_reg   (*((volatile unsigned int*) VO_V1_VSYC_10_reg))
+#define get_VO_V1_VSYC_11_reg   (*((volatile unsigned int*) VO_V1_VSYC_11_reg))
+#define get_VO_V1_VSYC_12_reg   (*((volatile unsigned int*) VO_V1_VSYC_12_reg))
+#define get_VO_V1_VSYC_13_reg   (*((volatile unsigned int*) VO_V1_VSYC_13_reg))
+#define get_VO_V1_VSYC_14_reg   (*((volatile unsigned int*) VO_V1_VSYC_14_reg))
+#define get_VO_V1_VSYC_15_reg   (*((volatile unsigned int*) VO_V1_VSYC_15_reg))
+#define VO_V1_VSYC_0_inst_adr                                                        "0x006B"
+#define VO_V1_VSYC_1_inst_adr                                                        "0x006C"
+#define VO_V1_VSYC_2_inst_adr                                                        "0x006D"
+#define VO_V1_VSYC_3_inst_adr                                                        "0x006E"
+#define VO_V1_VSYC_4_inst_adr                                                        "0x006F"
+#define VO_V1_VSYC_5_inst_adr                                                        "0x0070"
+#define VO_V1_VSYC_6_inst_adr                                                        "0x0071"
+#define VO_V1_VSYC_7_inst_adr                                                        "0x0072"
+#define VO_V1_VSYC_8_inst_adr                                                        "0x0073"
+#define VO_V1_VSYC_9_inst_adr                                                        "0x0074"
+#define VO_V1_VSYC_10_inst_adr                                                        "0x0075"
+#define VO_V1_VSYC_11_inst_adr                                                        "0x0076"
+#define VO_V1_VSYC_12_inst_adr                                                        "0x0077"
+#define VO_V1_VSYC_13_inst_adr                                                        "0x0078"
+#define VO_V1_VSYC_14_inst_adr                                                        "0x0079"
+#define VO_V1_VSYC_15_inst_adr                                                        "0x007A"
+#define VO_V1_VSYC_0_inst                                                            0x006B
+#define VO_V1_VSYC_1_inst                                                            0x006C
+#define VO_V1_VSYC_2_inst                                                            0x006D
+#define VO_V1_VSYC_3_inst                                                            0x006E
+#define VO_V1_VSYC_4_inst                                                            0x006F
+#define VO_V1_VSYC_5_inst                                                            0x0070
+#define VO_V1_VSYC_6_inst                                                            0x0071
+#define VO_V1_VSYC_7_inst                                                            0x0072
+#define VO_V1_VSYC_8_inst                                                            0x0073
+#define VO_V1_VSYC_9_inst                                                            0x0074
+#define VO_V1_VSYC_10_inst                                                            0x0075
+#define VO_V1_VSYC_11_inst                                                            0x0076
+#define VO_V1_VSYC_12_inst                                                            0x0077
+#define VO_V1_VSYC_13_inst                                                            0x0078
+#define VO_V1_VSYC_14_inst                                                            0x0079
+#define VO_V1_VSYC_15_inst                                                            0x007A
+#define VO_V1_VSYC_c1_shift                                                          (16)
+#define VO_V1_VSYC_c1_mask                                                           (0x3FFF0000)
+#define VO_V1_VSYC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_VSYC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSYC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSYC_c0_shift                                                          (0)
+#define VO_V1_VSYC_c0_mask                                                           (0x00003FFF)
+#define VO_V1_VSYC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_VSYC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_VSYC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_VSCC_0                                                                 0x180051EC
+#define VO_V1_VSCC_1                                                                 0x180051F0
+#define VO_V1_VSCC_2                                                                 0x180051F4
+#define VO_V1_VSCC_3                                                                 0x180051F8
+#define VO_V1_VSCC_4                                                                 0x180051FC
+#define VO_V1_VSCC_5                                                                 0x18005200
+#define VO_V1_VSCC_6                                                                 0x18005204
+#define VO_V1_VSCC_7                                                                 0x18005208
+#define VO_V1_VSCC_8                                                                 0x1800520C
+#define VO_V1_VSCC_9                                                                 0x18005210
+#define VO_V1_VSCC_10                                                                 0x18005214
+#define VO_V1_VSCC_11                                                                 0x18005218
+#define VO_V1_VSCC_12                                                                 0x1800521C
+#define VO_V1_VSCC_13                                                                 0x18005220
+#define VO_V1_VSCC_14                                                                 0x18005224
+#define VO_V1_VSCC_15                                                                 0x18005228
+#define VO_V1_VSCC_0_reg_addr                                                        "0xB80051EC"
+#define VO_V1_VSCC_1_reg_addr                                                        "0xB80051F0"
+#define VO_V1_VSCC_2_reg_addr                                                        "0xB80051F4"
+#define VO_V1_VSCC_3_reg_addr                                                        "0xB80051F8"
+#define VO_V1_VSCC_4_reg_addr                                                        "0xB80051FC"
+#define VO_V1_VSCC_5_reg_addr                                                        "0xB8005200"
+#define VO_V1_VSCC_6_reg_addr                                                        "0xB8005204"
+#define VO_V1_VSCC_7_reg_addr                                                        "0xB8005208"
+#define VO_V1_VSCC_8_reg_addr                                                        "0xB800520C"
+#define VO_V1_VSCC_9_reg_addr                                                        "0xB8005210"
+#define VO_V1_VSCC_10_reg_addr                                                        "0xB8005214"
+#define VO_V1_VSCC_11_reg_addr                                                        "0xB8005218"
+#define VO_V1_VSCC_12_reg_addr                                                        "0xB800521C"
+#define VO_V1_VSCC_13_reg_addr                                                        "0xB8005220"
+#define VO_V1_VSCC_14_reg_addr                                                        "0xB8005224"
+#define VO_V1_VSCC_15_reg_addr                                                        "0xB8005228"
+#define VO_V1_VSCC_0_reg                                                             0xB80051EC
+#define VO_V1_VSCC_1_reg                                                             0xB80051F0
+#define VO_V1_VSCC_2_reg                                                             0xB80051F4
+#define VO_V1_VSCC_3_reg                                                             0xB80051F8
+#define VO_V1_VSCC_4_reg                                                             0xB80051FC
+#define VO_V1_VSCC_5_reg                                                             0xB8005200
+#define VO_V1_VSCC_6_reg                                                             0xB8005204
+#define VO_V1_VSCC_7_reg                                                             0xB8005208
+#define VO_V1_VSCC_8_reg                                                             0xB800520C
+#define VO_V1_VSCC_9_reg                                                             0xB8005210
+#define VO_V1_VSCC_10_reg                                                             0xB8005214
+#define VO_V1_VSCC_11_reg                                                             0xB8005218
+#define VO_V1_VSCC_12_reg                                                             0xB800521C
+#define VO_V1_VSCC_13_reg                                                             0xB8005220
+#define VO_V1_VSCC_14_reg                                                             0xB8005224
+#define VO_V1_VSCC_15_reg                                                             0xB8005228
+#define set_VO_V1_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_0_reg)=data)
+#define set_VO_V1_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_1_reg)=data)
+#define set_VO_V1_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_2_reg)=data)
+#define set_VO_V1_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_3_reg)=data)
+#define set_VO_V1_VSCC_4_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_4_reg)=data)
+#define set_VO_V1_VSCC_5_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_5_reg)=data)
+#define set_VO_V1_VSCC_6_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_6_reg)=data)
+#define set_VO_V1_VSCC_7_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_7_reg)=data)
+#define set_VO_V1_VSCC_8_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_8_reg)=data)
+#define set_VO_V1_VSCC_9_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_9_reg)=data)
+#define set_VO_V1_VSCC_10_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_10_reg)=data)
+#define set_VO_V1_VSCC_11_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_11_reg)=data)
+#define set_VO_V1_VSCC_12_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_12_reg)=data)
+#define set_VO_V1_VSCC_13_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_13_reg)=data)
+#define set_VO_V1_VSCC_14_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_14_reg)=data)
+#define set_VO_V1_VSCC_15_reg(data)   (*((volatile unsigned int*) VO_V1_VSCC_15_reg)=data)
+#define get_VO_V1_VSCC_0_reg   (*((volatile unsigned int*) VO_V1_VSCC_0_reg))
+#define get_VO_V1_VSCC_1_reg   (*((volatile unsigned int*) VO_V1_VSCC_1_reg))
+#define get_VO_V1_VSCC_2_reg   (*((volatile unsigned int*) VO_V1_VSCC_2_reg))
+#define get_VO_V1_VSCC_3_reg   (*((volatile unsigned int*) VO_V1_VSCC_3_reg))
+#define get_VO_V1_VSCC_4_reg   (*((volatile unsigned int*) VO_V1_VSCC_4_reg))
+#define get_VO_V1_VSCC_5_reg   (*((volatile unsigned int*) VO_V1_VSCC_5_reg))
+#define get_VO_V1_VSCC_6_reg   (*((volatile unsigned int*) VO_V1_VSCC_6_reg))
+#define get_VO_V1_VSCC_7_reg   (*((volatile unsigned int*) VO_V1_VSCC_7_reg))
+#define get_VO_V1_VSCC_8_reg   (*((volatile unsigned int*) VO_V1_VSCC_8_reg))
+#define get_VO_V1_VSCC_9_reg   (*((volatile unsigned int*) VO_V1_VSCC_9_reg))
+#define get_VO_V1_VSCC_10_reg   (*((volatile unsigned int*) VO_V1_VSCC_10_reg))
+#define get_VO_V1_VSCC_11_reg   (*((volatile unsigned int*) VO_V1_VSCC_11_reg))
+#define get_VO_V1_VSCC_12_reg   (*((volatile unsigned int*) VO_V1_VSCC_12_reg))
+#define get_VO_V1_VSCC_13_reg   (*((volatile unsigned int*) VO_V1_VSCC_13_reg))
+#define get_VO_V1_VSCC_14_reg   (*((volatile unsigned int*) VO_V1_VSCC_14_reg))
+#define get_VO_V1_VSCC_15_reg   (*((volatile unsigned int*) VO_V1_VSCC_15_reg))
+#define VO_V1_VSCC_0_inst_adr                                                        "0x007B"
+#define VO_V1_VSCC_1_inst_adr                                                        "0x007C"
+#define VO_V1_VSCC_2_inst_adr                                                        "0x007D"
+#define VO_V1_VSCC_3_inst_adr                                                        "0x007E"
+#define VO_V1_VSCC_4_inst_adr                                                        "0x007F"
+#define VO_V1_VSCC_5_inst_adr                                                        "0x0080"
+#define VO_V1_VSCC_6_inst_adr                                                        "0x0081"
+#define VO_V1_VSCC_7_inst_adr                                                        "0x0082"
+#define VO_V1_VSCC_8_inst_adr                                                        "0x0083"
+#define VO_V1_VSCC_9_inst_adr                                                        "0x0084"
+#define VO_V1_VSCC_10_inst_adr                                                        "0x0085"
+#define VO_V1_VSCC_11_inst_adr                                                        "0x0086"
+#define VO_V1_VSCC_12_inst_adr                                                        "0x0087"
+#define VO_V1_VSCC_13_inst_adr                                                        "0x0088"
+#define VO_V1_VSCC_14_inst_adr                                                        "0x0089"
+#define VO_V1_VSCC_15_inst_adr                                                        "0x008A"
+#define VO_V1_VSCC_0_inst                                                            0x007B
+#define VO_V1_VSCC_1_inst                                                            0x007C
+#define VO_V1_VSCC_2_inst                                                            0x007D
+#define VO_V1_VSCC_3_inst                                                            0x007E
+#define VO_V1_VSCC_4_inst                                                            0x007F
+#define VO_V1_VSCC_5_inst                                                            0x0080
+#define VO_V1_VSCC_6_inst                                                            0x0081
+#define VO_V1_VSCC_7_inst                                                            0x0082
+#define VO_V1_VSCC_8_inst                                                            0x0083
+#define VO_V1_VSCC_9_inst                                                            0x0084
+#define VO_V1_VSCC_10_inst                                                            0x0085
+#define VO_V1_VSCC_11_inst                                                            0x0086
+#define VO_V1_VSCC_12_inst                                                            0x0087
+#define VO_V1_VSCC_13_inst                                                            0x0088
+#define VO_V1_VSCC_14_inst                                                            0x0089
+#define VO_V1_VSCC_15_inst                                                            0x008A
+#define VO_V1_VSCC_c1_shift                                                          (16)
+#define VO_V1_VSCC_c1_mask                                                           (0x3FFF0000)
+#define VO_V1_VSCC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_VSCC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSCC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_VSCC_c0_shift                                                          (0)
+#define VO_V1_VSCC_c0_mask                                                           (0x00003FFF)
+#define VO_V1_VSCC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_VSCC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_VSCC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_HSI                                                                    0x1800522C
+#define VO_V1_HSI_reg_addr                                                           "0xB800522C"
+#define VO_V1_HSI_reg                                                                0xB800522C
+#define set_VO_V1_HSI_reg(data)   (*((volatile unsigned int*) VO_V1_HSI_reg)=data)
+#define get_VO_V1_HSI_reg   (*((volatile unsigned int*) VO_V1_HSI_reg))
+#define VO_V1_HSI_inst_adr                                                           "0x008B"
+#define VO_V1_HSI_inst                                                               0x008B
+#define VO_V1_HSI_offset_shift                                                       (16)
+#define VO_V1_HSI_offset_mask                                                        (0x1FFF0000)
+#define VO_V1_HSI_offset(data)                                                       (0x1FFF0000&((data)<<16))
+#define VO_V1_HSI_offset_src(data)                                                   ((0x1FFF0000&(data))>>16)
+#define VO_V1_HSI_get_offset(data)                                                   ((0x1FFF0000&(data))>>16)
+#define VO_V1_HSI_phase_shift                                                        (0)
+#define VO_V1_HSI_phase_mask                                                         (0x0000FFFF)
+#define VO_V1_HSI_phase(data)                                                        (0x0000FFFF&((data)<<0))
+#define VO_V1_HSI_phase_src(data)                                                    ((0x0000FFFF&(data))>>0)
+#define VO_V1_HSI_get_phase(data)                                                    ((0x0000FFFF&(data))>>0)
+
+
+#define VO_V1_HSD                                                                    0x18005230
+#define VO_V1_HSD_reg_addr                                                           "0xB8005230"
+#define VO_V1_HSD_reg                                                                0xB8005230
+#define set_VO_V1_HSD_reg(data)   (*((volatile unsigned int*) VO_V1_HSD_reg)=data)
+#define get_VO_V1_HSD_reg   (*((volatile unsigned int*) VO_V1_HSD_reg))
+#define VO_V1_HSD_inst_adr                                                           "0x008C"
+#define VO_V1_HSD_inst                                                               0x008C
+#define VO_V1_HSD_delta_shift                                                        (0)
+#define VO_V1_HSD_delta_mask                                                         (0x001FFFFF)
+#define VO_V1_HSD_delta(data)                                                        (0x001FFFFF&((data)<<0))
+#define VO_V1_HSD_delta_src(data)                                                    ((0x001FFFFF&(data))>>0)
+#define VO_V1_HSD_get_delta(data)                                                    ((0x001FFFFF&(data))>>0)
+
+
+#define VO_V1_HSD_W                                                                  0x18005234
+#define VO_V1_HSD_W_reg_addr                                                         "0xB8005234"
+#define VO_V1_HSD_W_reg                                                              0xB8005234
+#define set_VO_V1_HSD_W_reg(data)   (*((volatile unsigned int*) VO_V1_HSD_W_reg)=data)
+#define get_VO_V1_HSD_W_reg   (*((volatile unsigned int*) VO_V1_HSD_W_reg))
+#define VO_V1_HSD_W_inst_adr                                                         "0x008D"
+#define VO_V1_HSD_W_inst                                                             0x008D
+#define VO_V1_HSD_W_out_shift                                                        (0)
+#define VO_V1_HSD_W_out_mask                                                         (0x00001FFF)
+#define VO_V1_HSD_W_out(data)                                                        (0x00001FFF&((data)<<0))
+#define VO_V1_HSD_W_out_src(data)                                                    ((0x00001FFF&(data))>>0)
+#define VO_V1_HSD_W_get_out(data)                                                    ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1_HSYC_0                                                                 0x18005238
+#define VO_V1_HSYC_1                                                                 0x1800523C
+#define VO_V1_HSYC_2                                                                 0x18005240
+#define VO_V1_HSYC_3                                                                 0x18005244
+#define VO_V1_HSYC_4                                                                 0x18005248
+#define VO_V1_HSYC_5                                                                 0x1800524C
+#define VO_V1_HSYC_6                                                                 0x18005250
+#define VO_V1_HSYC_7                                                                 0x18005254
+#define VO_V1_HSYC_8                                                                 0x18005258
+#define VO_V1_HSYC_9                                                                 0x1800525C
+#define VO_V1_HSYC_10                                                                 0x18005260
+#define VO_V1_HSYC_11                                                                 0x18005264
+#define VO_V1_HSYC_12                                                                 0x18005268
+#define VO_V1_HSYC_13                                                                 0x1800526C
+#define VO_V1_HSYC_14                                                                 0x18005270
+#define VO_V1_HSYC_15                                                                 0x18005274
+#define VO_V1_HSYC_16                                                                 0x18005278
+#define VO_V1_HSYC_17                                                                 0x1800527C
+#define VO_V1_HSYC_18                                                                 0x18005280
+#define VO_V1_HSYC_19                                                                 0x18005284
+#define VO_V1_HSYC_20                                                                 0x18005288
+#define VO_V1_HSYC_21                                                                 0x1800528C
+#define VO_V1_HSYC_22                                                                 0x18005290
+#define VO_V1_HSYC_23                                                                 0x18005294
+#define VO_V1_HSYC_24                                                                 0x18005298
+#define VO_V1_HSYC_25                                                                 0x1800529C
+#define VO_V1_HSYC_26                                                                 0x180052A0
+#define VO_V1_HSYC_27                                                                 0x180052A4
+#define VO_V1_HSYC_28                                                                 0x180052A8
+#define VO_V1_HSYC_29                                                                 0x180052AC
+#define VO_V1_HSYC_30                                                                 0x180052B0
+#define VO_V1_HSYC_31                                                                 0x180052B4
+#define VO_V1_HSYC_0_reg_addr                                                        "0xB8005238"
+#define VO_V1_HSYC_1_reg_addr                                                        "0xB800523C"
+#define VO_V1_HSYC_2_reg_addr                                                        "0xB8005240"
+#define VO_V1_HSYC_3_reg_addr                                                        "0xB8005244"
+#define VO_V1_HSYC_4_reg_addr                                                        "0xB8005248"
+#define VO_V1_HSYC_5_reg_addr                                                        "0xB800524C"
+#define VO_V1_HSYC_6_reg_addr                                                        "0xB8005250"
+#define VO_V1_HSYC_7_reg_addr                                                        "0xB8005254"
+#define VO_V1_HSYC_8_reg_addr                                                        "0xB8005258"
+#define VO_V1_HSYC_9_reg_addr                                                        "0xB800525C"
+#define VO_V1_HSYC_10_reg_addr                                                        "0xB8005260"
+#define VO_V1_HSYC_11_reg_addr                                                        "0xB8005264"
+#define VO_V1_HSYC_12_reg_addr                                                        "0xB8005268"
+#define VO_V1_HSYC_13_reg_addr                                                        "0xB800526C"
+#define VO_V1_HSYC_14_reg_addr                                                        "0xB8005270"
+#define VO_V1_HSYC_15_reg_addr                                                        "0xB8005274"
+#define VO_V1_HSYC_16_reg_addr                                                        "0xB8005278"
+#define VO_V1_HSYC_17_reg_addr                                                        "0xB800527C"
+#define VO_V1_HSYC_18_reg_addr                                                        "0xB8005280"
+#define VO_V1_HSYC_19_reg_addr                                                        "0xB8005284"
+#define VO_V1_HSYC_20_reg_addr                                                        "0xB8005288"
+#define VO_V1_HSYC_21_reg_addr                                                        "0xB800528C"
+#define VO_V1_HSYC_22_reg_addr                                                        "0xB8005290"
+#define VO_V1_HSYC_23_reg_addr                                                        "0xB8005294"
+#define VO_V1_HSYC_24_reg_addr                                                        "0xB8005298"
+#define VO_V1_HSYC_25_reg_addr                                                        "0xB800529C"
+#define VO_V1_HSYC_26_reg_addr                                                        "0xB80052A0"
+#define VO_V1_HSYC_27_reg_addr                                                        "0xB80052A4"
+#define VO_V1_HSYC_28_reg_addr                                                        "0xB80052A8"
+#define VO_V1_HSYC_29_reg_addr                                                        "0xB80052AC"
+#define VO_V1_HSYC_30_reg_addr                                                        "0xB80052B0"
+#define VO_V1_HSYC_31_reg_addr                                                        "0xB80052B4"
+#define VO_V1_HSYC_0_reg                                                             0xB8005238
+#define VO_V1_HSYC_1_reg                                                             0xB800523C
+#define VO_V1_HSYC_2_reg                                                             0xB8005240
+#define VO_V1_HSYC_3_reg                                                             0xB8005244
+#define VO_V1_HSYC_4_reg                                                             0xB8005248
+#define VO_V1_HSYC_5_reg                                                             0xB800524C
+#define VO_V1_HSYC_6_reg                                                             0xB8005250
+#define VO_V1_HSYC_7_reg                                                             0xB8005254
+#define VO_V1_HSYC_8_reg                                                             0xB8005258
+#define VO_V1_HSYC_9_reg                                                             0xB800525C
+#define VO_V1_HSYC_10_reg                                                             0xB8005260
+#define VO_V1_HSYC_11_reg                                                             0xB8005264
+#define VO_V1_HSYC_12_reg                                                             0xB8005268
+#define VO_V1_HSYC_13_reg                                                             0xB800526C
+#define VO_V1_HSYC_14_reg                                                             0xB8005270
+#define VO_V1_HSYC_15_reg                                                             0xB8005274
+#define VO_V1_HSYC_16_reg                                                             0xB8005278
+#define VO_V1_HSYC_17_reg                                                             0xB800527C
+#define VO_V1_HSYC_18_reg                                                             0xB8005280
+#define VO_V1_HSYC_19_reg                                                             0xB8005284
+#define VO_V1_HSYC_20_reg                                                             0xB8005288
+#define VO_V1_HSYC_21_reg                                                             0xB800528C
+#define VO_V1_HSYC_22_reg                                                             0xB8005290
+#define VO_V1_HSYC_23_reg                                                             0xB8005294
+#define VO_V1_HSYC_24_reg                                                             0xB8005298
+#define VO_V1_HSYC_25_reg                                                             0xB800529C
+#define VO_V1_HSYC_26_reg                                                             0xB80052A0
+#define VO_V1_HSYC_27_reg                                                             0xB80052A4
+#define VO_V1_HSYC_28_reg                                                             0xB80052A8
+#define VO_V1_HSYC_29_reg                                                             0xB80052AC
+#define VO_V1_HSYC_30_reg                                                             0xB80052B0
+#define VO_V1_HSYC_31_reg                                                             0xB80052B4
+#define set_VO_V1_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_0_reg)=data)
+#define set_VO_V1_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_1_reg)=data)
+#define set_VO_V1_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_2_reg)=data)
+#define set_VO_V1_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_3_reg)=data)
+#define set_VO_V1_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_4_reg)=data)
+#define set_VO_V1_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_5_reg)=data)
+#define set_VO_V1_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_6_reg)=data)
+#define set_VO_V1_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_7_reg)=data)
+#define set_VO_V1_HSYC_8_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_8_reg)=data)
+#define set_VO_V1_HSYC_9_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_9_reg)=data)
+#define set_VO_V1_HSYC_10_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_10_reg)=data)
+#define set_VO_V1_HSYC_11_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_11_reg)=data)
+#define set_VO_V1_HSYC_12_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_12_reg)=data)
+#define set_VO_V1_HSYC_13_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_13_reg)=data)
+#define set_VO_V1_HSYC_14_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_14_reg)=data)
+#define set_VO_V1_HSYC_15_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_15_reg)=data)
+#define set_VO_V1_HSYC_16_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_16_reg)=data)
+#define set_VO_V1_HSYC_17_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_17_reg)=data)
+#define set_VO_V1_HSYC_18_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_18_reg)=data)
+#define set_VO_V1_HSYC_19_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_19_reg)=data)
+#define set_VO_V1_HSYC_20_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_20_reg)=data)
+#define set_VO_V1_HSYC_21_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_21_reg)=data)
+#define set_VO_V1_HSYC_22_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_22_reg)=data)
+#define set_VO_V1_HSYC_23_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_23_reg)=data)
+#define set_VO_V1_HSYC_24_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_24_reg)=data)
+#define set_VO_V1_HSYC_25_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_25_reg)=data)
+#define set_VO_V1_HSYC_26_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_26_reg)=data)
+#define set_VO_V1_HSYC_27_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_27_reg)=data)
+#define set_VO_V1_HSYC_28_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_28_reg)=data)
+#define set_VO_V1_HSYC_29_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_29_reg)=data)
+#define set_VO_V1_HSYC_30_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_30_reg)=data)
+#define set_VO_V1_HSYC_31_reg(data)   (*((volatile unsigned int*) VO_V1_HSYC_31_reg)=data)
+#define get_VO_V1_HSYC_0_reg   (*((volatile unsigned int*) VO_V1_HSYC_0_reg))
+#define get_VO_V1_HSYC_1_reg   (*((volatile unsigned int*) VO_V1_HSYC_1_reg))
+#define get_VO_V1_HSYC_2_reg   (*((volatile unsigned int*) VO_V1_HSYC_2_reg))
+#define get_VO_V1_HSYC_3_reg   (*((volatile unsigned int*) VO_V1_HSYC_3_reg))
+#define get_VO_V1_HSYC_4_reg   (*((volatile unsigned int*) VO_V1_HSYC_4_reg))
+#define get_VO_V1_HSYC_5_reg   (*((volatile unsigned int*) VO_V1_HSYC_5_reg))
+#define get_VO_V1_HSYC_6_reg   (*((volatile unsigned int*) VO_V1_HSYC_6_reg))
+#define get_VO_V1_HSYC_7_reg   (*((volatile unsigned int*) VO_V1_HSYC_7_reg))
+#define get_VO_V1_HSYC_8_reg   (*((volatile unsigned int*) VO_V1_HSYC_8_reg))
+#define get_VO_V1_HSYC_9_reg   (*((volatile unsigned int*) VO_V1_HSYC_9_reg))
+#define get_VO_V1_HSYC_10_reg   (*((volatile unsigned int*) VO_V1_HSYC_10_reg))
+#define get_VO_V1_HSYC_11_reg   (*((volatile unsigned int*) VO_V1_HSYC_11_reg))
+#define get_VO_V1_HSYC_12_reg   (*((volatile unsigned int*) VO_V1_HSYC_12_reg))
+#define get_VO_V1_HSYC_13_reg   (*((volatile unsigned int*) VO_V1_HSYC_13_reg))
+#define get_VO_V1_HSYC_14_reg   (*((volatile unsigned int*) VO_V1_HSYC_14_reg))
+#define get_VO_V1_HSYC_15_reg   (*((volatile unsigned int*) VO_V1_HSYC_15_reg))
+#define get_VO_V1_HSYC_16_reg   (*((volatile unsigned int*) VO_V1_HSYC_16_reg))
+#define get_VO_V1_HSYC_17_reg   (*((volatile unsigned int*) VO_V1_HSYC_17_reg))
+#define get_VO_V1_HSYC_18_reg   (*((volatile unsigned int*) VO_V1_HSYC_18_reg))
+#define get_VO_V1_HSYC_19_reg   (*((volatile unsigned int*) VO_V1_HSYC_19_reg))
+#define get_VO_V1_HSYC_20_reg   (*((volatile unsigned int*) VO_V1_HSYC_20_reg))
+#define get_VO_V1_HSYC_21_reg   (*((volatile unsigned int*) VO_V1_HSYC_21_reg))
+#define get_VO_V1_HSYC_22_reg   (*((volatile unsigned int*) VO_V1_HSYC_22_reg))
+#define get_VO_V1_HSYC_23_reg   (*((volatile unsigned int*) VO_V1_HSYC_23_reg))
+#define get_VO_V1_HSYC_24_reg   (*((volatile unsigned int*) VO_V1_HSYC_24_reg))
+#define get_VO_V1_HSYC_25_reg   (*((volatile unsigned int*) VO_V1_HSYC_25_reg))
+#define get_VO_V1_HSYC_26_reg   (*((volatile unsigned int*) VO_V1_HSYC_26_reg))
+#define get_VO_V1_HSYC_27_reg   (*((volatile unsigned int*) VO_V1_HSYC_27_reg))
+#define get_VO_V1_HSYC_28_reg   (*((volatile unsigned int*) VO_V1_HSYC_28_reg))
+#define get_VO_V1_HSYC_29_reg   (*((volatile unsigned int*) VO_V1_HSYC_29_reg))
+#define get_VO_V1_HSYC_30_reg   (*((volatile unsigned int*) VO_V1_HSYC_30_reg))
+#define get_VO_V1_HSYC_31_reg   (*((volatile unsigned int*) VO_V1_HSYC_31_reg))
+#define VO_V1_HSYC_0_inst_adr                                                        "0x008E"
+#define VO_V1_HSYC_1_inst_adr                                                        "0x008F"
+#define VO_V1_HSYC_2_inst_adr                                                        "0x0090"
+#define VO_V1_HSYC_3_inst_adr                                                        "0x0091"
+#define VO_V1_HSYC_4_inst_adr                                                        "0x0092"
+#define VO_V1_HSYC_5_inst_adr                                                        "0x0093"
+#define VO_V1_HSYC_6_inst_adr                                                        "0x0094"
+#define VO_V1_HSYC_7_inst_adr                                                        "0x0095"
+#define VO_V1_HSYC_8_inst_adr                                                        "0x0096"
+#define VO_V1_HSYC_9_inst_adr                                                        "0x0097"
+#define VO_V1_HSYC_10_inst_adr                                                        "0x0098"
+#define VO_V1_HSYC_11_inst_adr                                                        "0x0099"
+#define VO_V1_HSYC_12_inst_adr                                                        "0x009A"
+#define VO_V1_HSYC_13_inst_adr                                                        "0x009B"
+#define VO_V1_HSYC_14_inst_adr                                                        "0x009C"
+#define VO_V1_HSYC_15_inst_adr                                                        "0x009D"
+#define VO_V1_HSYC_16_inst_adr                                                        "0x009E"
+#define VO_V1_HSYC_17_inst_adr                                                        "0x009F"
+#define VO_V1_HSYC_18_inst_adr                                                        "0x00A0"
+#define VO_V1_HSYC_19_inst_adr                                                        "0x00A1"
+#define VO_V1_HSYC_20_inst_adr                                                        "0x00A2"
+#define VO_V1_HSYC_21_inst_adr                                                        "0x00A3"
+#define VO_V1_HSYC_22_inst_adr                                                        "0x00A4"
+#define VO_V1_HSYC_23_inst_adr                                                        "0x00A5"
+#define VO_V1_HSYC_24_inst_adr                                                        "0x00A6"
+#define VO_V1_HSYC_25_inst_adr                                                        "0x00A7"
+#define VO_V1_HSYC_26_inst_adr                                                        "0x00A8"
+#define VO_V1_HSYC_27_inst_adr                                                        "0x00A9"
+#define VO_V1_HSYC_28_inst_adr                                                        "0x00AA"
+#define VO_V1_HSYC_29_inst_adr                                                        "0x00AB"
+#define VO_V1_HSYC_30_inst_adr                                                        "0x00AC"
+#define VO_V1_HSYC_31_inst_adr                                                        "0x00AD"
+#define VO_V1_HSYC_0_inst                                                            0x008E
+#define VO_V1_HSYC_1_inst                                                            0x008F
+#define VO_V1_HSYC_2_inst                                                            0x0090
+#define VO_V1_HSYC_3_inst                                                            0x0091
+#define VO_V1_HSYC_4_inst                                                            0x0092
+#define VO_V1_HSYC_5_inst                                                            0x0093
+#define VO_V1_HSYC_6_inst                                                            0x0094
+#define VO_V1_HSYC_7_inst                                                            0x0095
+#define VO_V1_HSYC_8_inst                                                            0x0096
+#define VO_V1_HSYC_9_inst                                                            0x0097
+#define VO_V1_HSYC_10_inst                                                            0x0098
+#define VO_V1_HSYC_11_inst                                                            0x0099
+#define VO_V1_HSYC_12_inst                                                            0x009A
+#define VO_V1_HSYC_13_inst                                                            0x009B
+#define VO_V1_HSYC_14_inst                                                            0x009C
+#define VO_V1_HSYC_15_inst                                                            0x009D
+#define VO_V1_HSYC_16_inst                                                            0x009E
+#define VO_V1_HSYC_17_inst                                                            0x009F
+#define VO_V1_HSYC_18_inst                                                            0x00A0
+#define VO_V1_HSYC_19_inst                                                            0x00A1
+#define VO_V1_HSYC_20_inst                                                            0x00A2
+#define VO_V1_HSYC_21_inst                                                            0x00A3
+#define VO_V1_HSYC_22_inst                                                            0x00A4
+#define VO_V1_HSYC_23_inst                                                            0x00A5
+#define VO_V1_HSYC_24_inst                                                            0x00A6
+#define VO_V1_HSYC_25_inst                                                            0x00A7
+#define VO_V1_HSYC_26_inst                                                            0x00A8
+#define VO_V1_HSYC_27_inst                                                            0x00A9
+#define VO_V1_HSYC_28_inst                                                            0x00AA
+#define VO_V1_HSYC_29_inst                                                            0x00AB
+#define VO_V1_HSYC_30_inst                                                            0x00AC
+#define VO_V1_HSYC_31_inst                                                            0x00AD
+#define VO_V1_HSYC_c1_shift                                                          (16)
+#define VO_V1_HSYC_c1_mask                                                           (0x3FFF0000)
+#define VO_V1_HSYC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_HSYC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_HSYC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_HSYC_c0_shift                                                          (0)
+#define VO_V1_HSYC_c0_mask                                                           (0x00003FFF)
+#define VO_V1_HSYC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_HSYC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_HSYC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_HSCC_0                                                                 0x180052B8
+#define VO_V1_HSCC_1                                                                 0x180052BC
+#define VO_V1_HSCC_2                                                                 0x180052C0
+#define VO_V1_HSCC_3                                                                 0x180052C4
+#define VO_V1_HSCC_4                                                                 0x180052C8
+#define VO_V1_HSCC_5                                                                 0x180052CC
+#define VO_V1_HSCC_6                                                                 0x180052D0
+#define VO_V1_HSCC_7                                                                 0x180052D4
+#define VO_V1_HSCC_8                                                                 0x180052D8
+#define VO_V1_HSCC_9                                                                 0x180052DC
+#define VO_V1_HSCC_10                                                                 0x180052E0
+#define VO_V1_HSCC_11                                                                 0x180052E4
+#define VO_V1_HSCC_12                                                                 0x180052E8
+#define VO_V1_HSCC_13                                                                 0x180052EC
+#define VO_V1_HSCC_14                                                                 0x180052F0
+#define VO_V1_HSCC_15                                                                 0x180052F4
+#define VO_V1_HSCC_0_reg_addr                                                        "0xB80052B8"
+#define VO_V1_HSCC_1_reg_addr                                                        "0xB80052BC"
+#define VO_V1_HSCC_2_reg_addr                                                        "0xB80052C0"
+#define VO_V1_HSCC_3_reg_addr                                                        "0xB80052C4"
+#define VO_V1_HSCC_4_reg_addr                                                        "0xB80052C8"
+#define VO_V1_HSCC_5_reg_addr                                                        "0xB80052CC"
+#define VO_V1_HSCC_6_reg_addr                                                        "0xB80052D0"
+#define VO_V1_HSCC_7_reg_addr                                                        "0xB80052D4"
+#define VO_V1_HSCC_8_reg_addr                                                        "0xB80052D8"
+#define VO_V1_HSCC_9_reg_addr                                                        "0xB80052DC"
+#define VO_V1_HSCC_10_reg_addr                                                        "0xB80052E0"
+#define VO_V1_HSCC_11_reg_addr                                                        "0xB80052E4"
+#define VO_V1_HSCC_12_reg_addr                                                        "0xB80052E8"
+#define VO_V1_HSCC_13_reg_addr                                                        "0xB80052EC"
+#define VO_V1_HSCC_14_reg_addr                                                        "0xB80052F0"
+#define VO_V1_HSCC_15_reg_addr                                                        "0xB80052F4"
+#define VO_V1_HSCC_0_reg                                                             0xB80052B8
+#define VO_V1_HSCC_1_reg                                                             0xB80052BC
+#define VO_V1_HSCC_2_reg                                                             0xB80052C0
+#define VO_V1_HSCC_3_reg                                                             0xB80052C4
+#define VO_V1_HSCC_4_reg                                                             0xB80052C8
+#define VO_V1_HSCC_5_reg                                                             0xB80052CC
+#define VO_V1_HSCC_6_reg                                                             0xB80052D0
+#define VO_V1_HSCC_7_reg                                                             0xB80052D4
+#define VO_V1_HSCC_8_reg                                                             0xB80052D8
+#define VO_V1_HSCC_9_reg                                                             0xB80052DC
+#define VO_V1_HSCC_10_reg                                                             0xB80052E0
+#define VO_V1_HSCC_11_reg                                                             0xB80052E4
+#define VO_V1_HSCC_12_reg                                                             0xB80052E8
+#define VO_V1_HSCC_13_reg                                                             0xB80052EC
+#define VO_V1_HSCC_14_reg                                                             0xB80052F0
+#define VO_V1_HSCC_15_reg                                                             0xB80052F4
+#define set_VO_V1_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_0_reg)=data)
+#define set_VO_V1_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_1_reg)=data)
+#define set_VO_V1_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_2_reg)=data)
+#define set_VO_V1_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_3_reg)=data)
+#define set_VO_V1_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_4_reg)=data)
+#define set_VO_V1_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_5_reg)=data)
+#define set_VO_V1_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_6_reg)=data)
+#define set_VO_V1_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_7_reg)=data)
+#define set_VO_V1_HSCC_8_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_8_reg)=data)
+#define set_VO_V1_HSCC_9_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_9_reg)=data)
+#define set_VO_V1_HSCC_10_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_10_reg)=data)
+#define set_VO_V1_HSCC_11_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_11_reg)=data)
+#define set_VO_V1_HSCC_12_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_12_reg)=data)
+#define set_VO_V1_HSCC_13_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_13_reg)=data)
+#define set_VO_V1_HSCC_14_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_14_reg)=data)
+#define set_VO_V1_HSCC_15_reg(data)   (*((volatile unsigned int*) VO_V1_HSCC_15_reg)=data)
+#define get_VO_V1_HSCC_0_reg   (*((volatile unsigned int*) VO_V1_HSCC_0_reg))
+#define get_VO_V1_HSCC_1_reg   (*((volatile unsigned int*) VO_V1_HSCC_1_reg))
+#define get_VO_V1_HSCC_2_reg   (*((volatile unsigned int*) VO_V1_HSCC_2_reg))
+#define get_VO_V1_HSCC_3_reg   (*((volatile unsigned int*) VO_V1_HSCC_3_reg))
+#define get_VO_V1_HSCC_4_reg   (*((volatile unsigned int*) VO_V1_HSCC_4_reg))
+#define get_VO_V1_HSCC_5_reg   (*((volatile unsigned int*) VO_V1_HSCC_5_reg))
+#define get_VO_V1_HSCC_6_reg   (*((volatile unsigned int*) VO_V1_HSCC_6_reg))
+#define get_VO_V1_HSCC_7_reg   (*((volatile unsigned int*) VO_V1_HSCC_7_reg))
+#define get_VO_V1_HSCC_8_reg   (*((volatile unsigned int*) VO_V1_HSCC_8_reg))
+#define get_VO_V1_HSCC_9_reg   (*((volatile unsigned int*) VO_V1_HSCC_9_reg))
+#define get_VO_V1_HSCC_10_reg   (*((volatile unsigned int*) VO_V1_HSCC_10_reg))
+#define get_VO_V1_HSCC_11_reg   (*((volatile unsigned int*) VO_V1_HSCC_11_reg))
+#define get_VO_V1_HSCC_12_reg   (*((volatile unsigned int*) VO_V1_HSCC_12_reg))
+#define get_VO_V1_HSCC_13_reg   (*((volatile unsigned int*) VO_V1_HSCC_13_reg))
+#define get_VO_V1_HSCC_14_reg   (*((volatile unsigned int*) VO_V1_HSCC_14_reg))
+#define get_VO_V1_HSCC_15_reg   (*((volatile unsigned int*) VO_V1_HSCC_15_reg))
+#define VO_V1_HSCC_0_inst_adr                                                        "0x00AE"
+#define VO_V1_HSCC_1_inst_adr                                                        "0x00AF"
+#define VO_V1_HSCC_2_inst_adr                                                        "0x00B0"
+#define VO_V1_HSCC_3_inst_adr                                                        "0x00B1"
+#define VO_V1_HSCC_4_inst_adr                                                        "0x00B2"
+#define VO_V1_HSCC_5_inst_adr                                                        "0x00B3"
+#define VO_V1_HSCC_6_inst_adr                                                        "0x00B4"
+#define VO_V1_HSCC_7_inst_adr                                                        "0x00B5"
+#define VO_V1_HSCC_8_inst_adr                                                        "0x00B6"
+#define VO_V1_HSCC_9_inst_adr                                                        "0x00B7"
+#define VO_V1_HSCC_10_inst_adr                                                        "0x00B8"
+#define VO_V1_HSCC_11_inst_adr                                                        "0x00B9"
+#define VO_V1_HSCC_12_inst_adr                                                        "0x00BA"
+#define VO_V1_HSCC_13_inst_adr                                                        "0x00BB"
+#define VO_V1_HSCC_14_inst_adr                                                        "0x00BC"
+#define VO_V1_HSCC_15_inst_adr                                                        "0x00BD"
+#define VO_V1_HSCC_0_inst                                                            0x00AE
+#define VO_V1_HSCC_1_inst                                                            0x00AF
+#define VO_V1_HSCC_2_inst                                                            0x00B0
+#define VO_V1_HSCC_3_inst                                                            0x00B1
+#define VO_V1_HSCC_4_inst                                                            0x00B2
+#define VO_V1_HSCC_5_inst                                                            0x00B3
+#define VO_V1_HSCC_6_inst                                                            0x00B4
+#define VO_V1_HSCC_7_inst                                                            0x00B5
+#define VO_V1_HSCC_8_inst                                                            0x00B6
+#define VO_V1_HSCC_9_inst                                                            0x00B7
+#define VO_V1_HSCC_10_inst                                                            0x00B8
+#define VO_V1_HSCC_11_inst                                                            0x00B9
+#define VO_V1_HSCC_12_inst                                                            0x00BA
+#define VO_V1_HSCC_13_inst                                                            0x00BB
+#define VO_V1_HSCC_14_inst                                                            0x00BC
+#define VO_V1_HSCC_15_inst                                                            0x00BD
+#define VO_V1_HSCC_c1_shift                                                          (16)
+#define VO_V1_HSCC_c1_mask                                                           (0x3FFF0000)
+#define VO_V1_HSCC_c1(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_HSCC_c1_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_HSCC_get_c1(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_HSCC_c0_shift                                                          (0)
+#define VO_V1_HSCC_c0_mask                                                           (0x00003FFF)
+#define VO_V1_HSCC_c0(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_HSCC_c0_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_HSCC_get_c0(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC1                                                                    0x180052F8
+#define VO_V1_CC1_reg_addr                                                           "0xB80052F8"
+#define VO_V1_CC1_reg                                                                0xB80052F8
+#define set_VO_V1_CC1_reg(data)   (*((volatile unsigned int*) VO_V1_CC1_reg)=data)
+#define get_VO_V1_CC1_reg   (*((volatile unsigned int*) VO_V1_CC1_reg))
+#define VO_V1_CC1_inst_adr                                                           "0x00BE"
+#define VO_V1_CC1_inst                                                               0x00BE
+#define VO_V1_CC1_m01_shift                                                          (16)
+#define VO_V1_CC1_m01_mask                                                           (0x3FFF0000)
+#define VO_V1_CC1_m01(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_CC1_m01_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC1_get_m01(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC1_m00_shift                                                          (0)
+#define VO_V1_CC1_m00_mask                                                           (0x00003FFF)
+#define VO_V1_CC1_m00(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_CC1_m00_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_CC1_get_m00(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC2                                                                    0x180052FC
+#define VO_V1_CC2_reg_addr                                                           "0xB80052FC"
+#define VO_V1_CC2_reg                                                                0xB80052FC
+#define set_VO_V1_CC2_reg(data)   (*((volatile unsigned int*) VO_V1_CC2_reg)=data)
+#define get_VO_V1_CC2_reg   (*((volatile unsigned int*) VO_V1_CC2_reg))
+#define VO_V1_CC2_inst_adr                                                           "0x00BF"
+#define VO_V1_CC2_inst                                                               0x00BF
+#define VO_V1_CC2_m10_shift                                                          (16)
+#define VO_V1_CC2_m10_mask                                                           (0x3FFF0000)
+#define VO_V1_CC2_m10(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_CC2_m10_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC2_get_m10(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC2_m02_shift                                                          (0)
+#define VO_V1_CC2_m02_mask                                                           (0x00003FFF)
+#define VO_V1_CC2_m02(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_CC2_m02_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_CC2_get_m02(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC3                                                                    0x18005300
+#define VO_V1_CC3_reg_addr                                                           "0xB8005300"
+#define VO_V1_CC3_reg                                                                0xB8005300
+#define set_VO_V1_CC3_reg(data)   (*((volatile unsigned int*) VO_V1_CC3_reg)=data)
+#define get_VO_V1_CC3_reg   (*((volatile unsigned int*) VO_V1_CC3_reg))
+#define VO_V1_CC3_inst_adr                                                           "0x00C0"
+#define VO_V1_CC3_inst                                                               0x00C0
+#define VO_V1_CC3_m12_shift                                                          (16)
+#define VO_V1_CC3_m12_mask                                                           (0x3FFF0000)
+#define VO_V1_CC3_m12(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_CC3_m12_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC3_get_m12(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC3_m11_shift                                                          (0)
+#define VO_V1_CC3_m11_mask                                                           (0x00003FFF)
+#define VO_V1_CC3_m11(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_CC3_m11_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_CC3_get_m11(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC4                                                                    0x18005304
+#define VO_V1_CC4_reg_addr                                                           "0xB8005304"
+#define VO_V1_CC4_reg                                                                0xB8005304
+#define set_VO_V1_CC4_reg(data)   (*((volatile unsigned int*) VO_V1_CC4_reg)=data)
+#define get_VO_V1_CC4_reg   (*((volatile unsigned int*) VO_V1_CC4_reg))
+#define VO_V1_CC4_inst_adr                                                           "0x00C1"
+#define VO_V1_CC4_inst                                                               0x00C1
+#define VO_V1_CC4_m21_shift                                                          (16)
+#define VO_V1_CC4_m21_mask                                                           (0x3FFF0000)
+#define VO_V1_CC4_m21(data)                                                          (0x3FFF0000&((data)<<16))
+#define VO_V1_CC4_m21_src(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC4_get_m21(data)                                                      ((0x3FFF0000&(data))>>16)
+#define VO_V1_CC4_m20_shift                                                          (0)
+#define VO_V1_CC4_m20_mask                                                           (0x00003FFF)
+#define VO_V1_CC4_m20(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_CC4_m20_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_CC4_get_m20(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC5                                                                    0x18005308
+#define VO_V1_CC5_reg_addr                                                           "0xB8005308"
+#define VO_V1_CC5_reg                                                                0xB8005308
+#define set_VO_V1_CC5_reg(data)   (*((volatile unsigned int*) VO_V1_CC5_reg)=data)
+#define get_VO_V1_CC5_reg   (*((volatile unsigned int*) VO_V1_CC5_reg))
+#define VO_V1_CC5_inst_adr                                                           "0x00C2"
+#define VO_V1_CC5_inst                                                               0x00C2
+#define VO_V1_CC5_m22_shift                                                          (0)
+#define VO_V1_CC5_m22_mask                                                           (0x00003FFF)
+#define VO_V1_CC5_m22(data)                                                          (0x00003FFF&((data)<<0))
+#define VO_V1_CC5_m22_src(data)                                                      ((0x00003FFF&(data))>>0)
+#define VO_V1_CC5_get_m22(data)                                                      ((0x00003FFF&(data))>>0)
+
+
+#define VO_V1_CC6                                                                    0x1800530C
+#define VO_V1_CC6_reg_addr                                                           "0xB800530C"
+#define VO_V1_CC6_reg                                                                0xB800530C
+#define set_VO_V1_CC6_reg(data)   (*((volatile unsigned int*) VO_V1_CC6_reg)=data)
+#define get_VO_V1_CC6_reg   (*((volatile unsigned int*) VO_V1_CC6_reg))
+#define VO_V1_CC6_inst_adr                                                           "0x00C3"
+#define VO_V1_CC6_inst                                                               0x00C3
+#define VO_V1_CC6_a2_shift                                                           (18)
+#define VO_V1_CC6_a2_mask                                                            (0x07FC0000)
+#define VO_V1_CC6_a2(data)                                                           (0x07FC0000&((data)<<18))
+#define VO_V1_CC6_a2_src(data)                                                       ((0x07FC0000&(data))>>18)
+#define VO_V1_CC6_get_a2(data)                                                       ((0x07FC0000&(data))>>18)
+#define VO_V1_CC6_a1_shift                                                           (9)
+#define VO_V1_CC6_a1_mask                                                            (0x0003FE00)
+#define VO_V1_CC6_a1(data)                                                           (0x0003FE00&((data)<<9))
+#define VO_V1_CC6_a1_src(data)                                                       ((0x0003FE00&(data))>>9)
+#define VO_V1_CC6_get_a1(data)                                                       ((0x0003FE00&(data))>>9)
+#define VO_V1_CC6_a0_shift                                                           (0)
+#define VO_V1_CC6_a0_mask                                                            (0x000001FF)
+#define VO_V1_CC6_a0(data)                                                           (0x000001FF&((data)<<0))
+#define VO_V1_CC6_a0_src(data)                                                       ((0x000001FF&(data))>>0)
+#define VO_V1_CC6_get_a0(data)                                                       ((0x000001FF&(data))>>0)
+
+
+#define VO_SUB1                                                                      0x18005310
+#define VO_SUB1_reg_addr                                                             "0xB8005310"
+#define VO_SUB1_reg                                                                  0xB8005310
+#define set_VO_SUB1_reg(data)   (*((volatile unsigned int*) VO_SUB1_reg)=data)
+#define get_VO_SUB1_reg   (*((volatile unsigned int*) VO_SUB1_reg))
+#define VO_SUB1_inst_adr                                                             "0x00C4"
+#define VO_SUB1_inst                                                                 0x00C4
+#define VO_SUB1_d3_dbh_shift                                                         (29)
+#define VO_SUB1_d3_dbh_mask                                                          (0x20000000)
+#define VO_SUB1_d3_dbh(data)                                                         (0x20000000&((data)<<29))
+#define VO_SUB1_d3_dbh_src(data)                                                     ((0x20000000&(data))>>29)
+#define VO_SUB1_get_d3_dbh(data)                                                     ((0x20000000&(data))>>29)
+#define VO_SUB1_d3_vdup_shift                                                        (28)
+#define VO_SUB1_d3_vdup_mask                                                         (0x10000000)
+#define VO_SUB1_d3_vdup(data)                                                        (0x10000000&((data)<<28))
+#define VO_SUB1_d3_vdup_src(data)                                                    ((0x10000000&(data))>>28)
+#define VO_SUB1_get_d3_vdup(data)                                                    ((0x10000000&(data))>>28)
+#define VO_SUB1_d3_dbw_shift                                                         (27)
+#define VO_SUB1_d3_dbw_mask                                                          (0x08000000)
+#define VO_SUB1_d3_dbw(data)                                                         (0x08000000&((data)<<27))
+#define VO_SUB1_d3_dbw_src(data)                                                     ((0x08000000&(data))>>27)
+#define VO_SUB1_get_d3_dbw(data)                                                     ((0x08000000&(data))>>27)
+#define VO_SUB1_d3_dup_shift                                                         (26)
+#define VO_SUB1_d3_dup_mask                                                          (0x04000000)
+#define VO_SUB1_d3_dup(data)                                                         (0x04000000&((data)<<26))
+#define VO_SUB1_d3_dup_src(data)                                                     ((0x04000000&(data))>>26)
+#define VO_SUB1_get_d3_dup(data)                                                     ((0x04000000&(data))>>26)
+#define VO_SUB1_rgb_out_shift                                                        (25)
+#define VO_SUB1_rgb_out_mask                                                         (0x02000000)
+#define VO_SUB1_rgb_out(data)                                                        (0x02000000&((data)<<25))
+#define VO_SUB1_rgb_out_src(data)                                                    ((0x02000000&(data))>>25)
+#define VO_SUB1_get_rgb_out(data)                                                    ((0x02000000&(data))>>25)
+#define VO_SUB1_dvd_shift                                                            (23)
+#define VO_SUB1_dvd_mask                                                             (0x00800000)
+#define VO_SUB1_dvd(data)                                                            (0x00800000&((data)<<23))
+#define VO_SUB1_dvd_src(data)                                                        ((0x00800000&(data))>>23)
+#define VO_SUB1_get_dvd(data)                                                        ((0x00800000&(data))>>23)
+#define VO_SUB1_hddvd_shift                                                          (22)
+#define VO_SUB1_hddvd_mask                                                           (0x00400000)
+#define VO_SUB1_hddvd(data)                                                          (0x00400000&((data)<<22))
+#define VO_SUB1_hddvd_src(data)                                                      ((0x00400000&(data))>>22)
+#define VO_SUB1_get_hddvd(data)                                                      ((0x00400000&(data))>>22)
+#define VO_SUB1_hl_shift                                                             (19)
+#define VO_SUB1_hl_mask                                                              (0x00080000)
+#define VO_SUB1_hl(data)                                                             (0x00080000&((data)<<19))
+#define VO_SUB1_hl_src(data)                                                         ((0x00080000&(data))>>19)
+#define VO_SUB1_get_hl(data)                                                         ((0x00080000&(data))>>19)
+#define VO_SUB1_dvb_shift                                                            (17)
+#define VO_SUB1_dvb_mask                                                             (0x00020000)
+#define VO_SUB1_dvb(data)                                                            (0x00020000&((data)<<17))
+#define VO_SUB1_dvb_src(data)                                                        ((0x00020000&(data))>>17)
+#define VO_SUB1_get_dvb(data)                                                        ((0x00020000&(data))>>17)
+#define VO_SUB1_osd_shift                                                            (16)
+#define VO_SUB1_osd_mask                                                             (0x00010000)
+#define VO_SUB1_osd(data)                                                            (0x00010000&((data)<<16))
+#define VO_SUB1_osd_src(data)                                                        ((0x00010000&(data))>>16)
+#define VO_SUB1_get_osd(data)                                                        ((0x00010000&(data))>>16)
+#define VO_SUB1_fetch_1080i_shift                                                    (15)
+#define VO_SUB1_fetch_1080i_mask                                                     (0x00008000)
+#define VO_SUB1_fetch_1080i(data)                                                    (0x00008000&((data)<<15))
+#define VO_SUB1_fetch_1080i_src(data)                                                ((0x00008000&(data))>>15)
+#define VO_SUB1_get_fetch_1080i(data)                                                ((0x00008000&(data))>>15)
+#define VO_SUB1_odd_1080i_shift                                                      (14)
+#define VO_SUB1_odd_1080i_mask                                                       (0x00004000)
+#define VO_SUB1_odd_1080i(data)                                                      (0x00004000&((data)<<14))
+#define VO_SUB1_odd_1080i_src(data)                                                  ((0x00004000&(data))>>14)
+#define VO_SUB1_get_odd_1080i(data)                                                  ((0x00004000&(data))>>14)
+#define VO_SUB1_vs_shift                                                             (10)
+#define VO_SUB1_vs_mask                                                              (0x00000400)
+#define VO_SUB1_vs(data)                                                             (0x00000400&((data)<<10))
+#define VO_SUB1_vs_src(data)                                                         ((0x00000400&(data))>>10)
+#define VO_SUB1_get_vs(data)                                                         ((0x00000400&(data))>>10)
+#define VO_SUB1_vs_near_shift                                                        (9)
+#define VO_SUB1_vs_near_mask                                                         (0x00000200)
+#define VO_SUB1_vs_near(data)                                                        (0x00000200&((data)<<9))
+#define VO_SUB1_vs_near_src(data)                                                    ((0x00000200&(data))>>9)
+#define VO_SUB1_get_vs_near(data)                                                    ((0x00000200&(data))>>9)
+#define VO_SUB1_vs_yodd_shift                                                        (8)
+#define VO_SUB1_vs_yodd_mask                                                         (0x00000100)
+#define VO_SUB1_vs_yodd(data)                                                        (0x00000100&((data)<<8))
+#define VO_SUB1_vs_yodd_src(data)                                                    ((0x00000100&(data))>>8)
+#define VO_SUB1_get_vs_yodd(data)                                                    ((0x00000100&(data))>>8)
+#define VO_SUB1_vs_codd_shift                                                        (7)
+#define VO_SUB1_vs_codd_mask                                                         (0x00000080)
+#define VO_SUB1_vs_codd(data)                                                        (0x00000080&((data)<<7))
+#define VO_SUB1_vs_codd_src(data)                                                    ((0x00000080&(data))>>7)
+#define VO_SUB1_get_vs_codd(data)                                                    ((0x00000080&(data))>>7)
+#define VO_SUB1_hs_shift                                                             (6)
+#define VO_SUB1_hs_mask                                                              (0x00000040)
+#define VO_SUB1_hs(data)                                                             (0x00000040&((data)<<6))
+#define VO_SUB1_hs_src(data)                                                         ((0x00000040&(data))>>6)
+#define VO_SUB1_get_hs(data)                                                         ((0x00000040&(data))>>6)
+#define VO_SUB1_hs_yodd_shift                                                        (5)
+#define VO_SUB1_hs_yodd_mask                                                         (0x00000020)
+#define VO_SUB1_hs_yodd(data)                                                        (0x00000020&((data)<<5))
+#define VO_SUB1_hs_yodd_src(data)                                                    ((0x00000020&(data))>>5)
+#define VO_SUB1_get_hs_yodd(data)                                                    ((0x00000020&(data))>>5)
+#define VO_SUB1_hs_codd_shift                                                        (4)
+#define VO_SUB1_hs_codd_mask                                                         (0x00000010)
+#define VO_SUB1_hs_codd(data)                                                        (0x00000010&((data)<<4))
+#define VO_SUB1_hs_codd_src(data)                                                    ((0x00000010&(data))>>4)
+#define VO_SUB1_get_hs_codd(data)                                                    ((0x00000010&(data))>>4)
+#define VO_SUB1_write_data_shift                                                     (0)
+#define VO_SUB1_write_data_mask                                                      (0x00000001)
+#define VO_SUB1_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_SUB1_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_SUB1_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_SUB1_START                                                                0x18005314
+#define VO_SUB1_START_reg_addr                                                       "0xB8005314"
+#define VO_SUB1_START_reg                                                            0xB8005314
+#define set_VO_SUB1_START_reg(data)   (*((volatile unsigned int*) VO_SUB1_START_reg)=data)
+#define get_VO_SUB1_START_reg   (*((volatile unsigned int*) VO_SUB1_START_reg))
+#define VO_SUB1_START_inst_adr                                                       "0x00C5"
+#define VO_SUB1_START_inst                                                           0x00C5
+#define VO_SUB1_START_ref_shift                                                      (24)
+#define VO_SUB1_START_ref_mask                                                       (0x07000000)
+#define VO_SUB1_START_ref(data)                                                      (0x07000000&((data)<<24))
+#define VO_SUB1_START_ref_src(data)                                                  ((0x07000000&(data))>>24)
+#define VO_SUB1_START_get_ref(data)                                                  ((0x07000000&(data))>>24)
+#define VO_SUB1_START_pos_shift                                                      (12)
+#define VO_SUB1_START_pos_mask                                                       (0x00FFF000)
+#define VO_SUB1_START_pos(data)                                                      (0x00FFF000&((data)<<12))
+#define VO_SUB1_START_pos_src(data)                                                  ((0x00FFF000&(data))>>12)
+#define VO_SUB1_START_get_pos(data)                                                  ((0x00FFF000&(data))>>12)
+#define VO_SUB1_START_th_shift                                                       (0)
+#define VO_SUB1_START_th_mask                                                        (0x00000FFF)
+#define VO_SUB1_START_th(data)                                                       (0x00000FFF&((data)<<0))
+#define VO_SUB1_START_th_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VO_SUB1_START_get_th(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VO_SUB1_SUBP                                                                 0x18005318
+#define VO_SUB1_SUBP_reg_addr                                                        "0xB8005318"
+#define VO_SUB1_SUBP_reg                                                             0xB8005318
+#define set_VO_SUB1_SUBP_reg(data)   (*((volatile unsigned int*) VO_SUB1_SUBP_reg)=data)
+#define get_VO_SUB1_SUBP_reg   (*((volatile unsigned int*) VO_SUB1_SUBP_reg))
+#define VO_SUB1_SUBP_inst_adr                                                        "0x00C6"
+#define VO_SUB1_SUBP_inst                                                            0x00C6
+#define VO_SUB1_SUBP_w_shift                                                         (0)
+#define VO_SUB1_SUBP_w_mask                                                          (0x00000FFF)
+#define VO_SUB1_SUBP_w(data)                                                         (0x00000FFF&((data)<<0))
+#define VO_SUB1_SUBP_w_src(data)                                                     ((0x00000FFF&(data))>>0)
+#define VO_SUB1_SUBP_get_w(data)                                                     ((0x00000FFF&(data))>>0)
+
+
+#define VO_SUB1_SIZE                                                                 0x1800531C
+#define VO_SUB1_SIZE_reg_addr                                                        "0xB800531C"
+#define VO_SUB1_SIZE_reg                                                             0xB800531C
+#define set_VO_SUB1_SIZE_reg(data)   (*((volatile unsigned int*) VO_SUB1_SIZE_reg)=data)
+#define get_VO_SUB1_SIZE_reg   (*((volatile unsigned int*) VO_SUB1_SIZE_reg))
+#define VO_SUB1_SIZE_inst_adr                                                        "0x00C7"
+#define VO_SUB1_SIZE_inst                                                            0x00C7
+#define VO_SUB1_SIZE_w_shift                                                         (12)
+#define VO_SUB1_SIZE_w_mask                                                          (0x007FF000)
+#define VO_SUB1_SIZE_w(data)                                                         (0x007FF000&((data)<<12))
+#define VO_SUB1_SIZE_w_src(data)                                                     ((0x007FF000&(data))>>12)
+#define VO_SUB1_SIZE_get_w(data)                                                     ((0x007FF000&(data))>>12)
+#define VO_SUB1_SIZE_h_shift                                                         (0)
+#define VO_SUB1_SIZE_h_mask                                                          (0x000007FF)
+#define VO_SUB1_SIZE_h(data)                                                         (0x000007FF&((data)<<0))
+#define VO_SUB1_SIZE_h_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_SUB1_SIZE_get_h(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1_BUF                                                                  0x18005320
+#define VO_SUB1_BUF_reg_addr                                                         "0xB8005320"
+#define VO_SUB1_BUF_reg                                                              0xB8005320
+#define set_VO_SUB1_BUF_reg(data)   (*((volatile unsigned int*) VO_SUB1_BUF_reg)=data)
+#define get_VO_SUB1_BUF_reg   (*((volatile unsigned int*) VO_SUB1_BUF_reg))
+#define VO_SUB1_BUF_inst_adr                                                         "0x00C8"
+#define VO_SUB1_BUF_inst                                                             0x00C8
+#define VO_SUB1_BUF_th_shift                                                         (0)
+#define VO_SUB1_BUF_th_mask                                                          (0x000001FF)
+#define VO_SUB1_BUF_th(data)                                                         (0x000001FF&((data)<<0))
+#define VO_SUB1_BUF_th_src(data)                                                     ((0x000001FF&(data))>>0)
+#define VO_SUB1_BUF_get_th(data)                                                     ((0x000001FF&(data))>>0)
+
+
+#define VO_SUB1_WI                                                                   0x18005324
+#define VO_SUB1_WI_reg_addr                                                          "0xB8005324"
+#define VO_SUB1_WI_reg                                                               0xB8005324
+#define set_VO_SUB1_WI_reg(data)   (*((volatile unsigned int*) VO_SUB1_WI_reg)=data)
+#define get_VO_SUB1_WI_reg   (*((volatile unsigned int*) VO_SUB1_WI_reg))
+#define VO_SUB1_WI_inst_adr                                                          "0x00C9"
+#define VO_SUB1_WI_inst                                                              0x00C9
+#define VO_SUB1_WI_endian_shift                                                      (31)
+#define VO_SUB1_WI_endian_mask                                                       (0x80000000)
+#define VO_SUB1_WI_endian(data)                                                      (0x80000000&((data)<<31))
+#define VO_SUB1_WI_endian_src(data)                                                  ((0x80000000&(data))>>31)
+#define VO_SUB1_WI_get_endian(data)                                                  ((0x80000000&(data))>>31)
+#define VO_SUB1_WI_a_shift                                                           (0)
+#define VO_SUB1_WI_a_mask                                                            (0x7FFFFFFF)
+#define VO_SUB1_WI_a(data)                                                           (0x7FFFFFFF&((data)<<0))
+#define VO_SUB1_WI_a_src(data)                                                       ((0x7FFFFFFF&(data))>>0)
+#define VO_SUB1_WI_get_a(data)                                                       ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_SUB1_WI_3D                                                                0x18005328
+#define VO_SUB1_WI_3D_reg_addr                                                       "0xB8005328"
+#define VO_SUB1_WI_3D_reg                                                            0xB8005328
+#define set_VO_SUB1_WI_3D_reg(data)   (*((volatile unsigned int*) VO_SUB1_WI_3D_reg)=data)
+#define get_VO_SUB1_WI_3D_reg   (*((volatile unsigned int*) VO_SUB1_WI_3D_reg))
+#define VO_SUB1_WI_3D_inst_adr                                                       "0x00CA"
+#define VO_SUB1_WI_3D_inst                                                           0x00CA
+#define VO_SUB1_WI_3D_a_shift                                                        (0)
+#define VO_SUB1_WI_3D_a_mask                                                         (0x7FFFFFFF)
+#define VO_SUB1_WI_3D_a(data)                                                        (0x7FFFFFFF&((data)<<0))
+#define VO_SUB1_WI_3D_a_src(data)                                                    ((0x7FFFFFFF&(data))>>0)
+#define VO_SUB1_WI_3D_get_a(data)                                                    ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_SUB1_CLUT                                                                 0x1800532C
+#define VO_SUB1_CLUT_reg_addr                                                        "0xB800532C"
+#define VO_SUB1_CLUT_reg                                                             0xB800532C
+#define set_VO_SUB1_CLUT_reg(data)   (*((volatile unsigned int*) VO_SUB1_CLUT_reg)=data)
+#define get_VO_SUB1_CLUT_reg   (*((volatile unsigned int*) VO_SUB1_CLUT_reg))
+#define VO_SUB1_CLUT_inst_adr                                                        "0x00CB"
+#define VO_SUB1_CLUT_inst                                                            0x00CB
+#define VO_SUB1_CLUT_keep_shift                                                      (31)
+#define VO_SUB1_CLUT_keep_mask                                                       (0x80000000)
+#define VO_SUB1_CLUT_keep(data)                                                      (0x80000000&((data)<<31))
+#define VO_SUB1_CLUT_keep_src(data)                                                  ((0x80000000&(data))>>31)
+#define VO_SUB1_CLUT_get_keep(data)                                                  ((0x80000000&(data))>>31)
+#define VO_SUB1_CLUT_a_shift                                                         (0)
+#define VO_SUB1_CLUT_a_mask                                                          (0x7FFFFFFF)
+#define VO_SUB1_CLUT_a(data)                                                         (0x7FFFFFFF&((data)<<0))
+#define VO_SUB1_CLUT_a_src(data)                                                     ((0x7FFFFFFF&(data))>>0)
+#define VO_SUB1_CLUT_get_a(data)                                                     ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_SUB1_PXDT                                                                 0x18005330
+#define VO_SUB1_PXDT_reg_addr                                                        "0xB8005330"
+#define VO_SUB1_PXDT_reg                                                             0xB8005330
+#define set_VO_SUB1_PXDT_reg(data)   (*((volatile unsigned int*) VO_SUB1_PXDT_reg)=data)
+#define get_VO_SUB1_PXDT_reg   (*((volatile unsigned int*) VO_SUB1_PXDT_reg))
+#define VO_SUB1_PXDT_inst_adr                                                        "0x00CC"
+#define VO_SUB1_PXDT_inst                                                            0x00CC
+#define VO_SUB1_PXDT_a_shift                                                         (0)
+#define VO_SUB1_PXDT_a_mask                                                          (0x7FFFFFFF)
+#define VO_SUB1_PXDT_a(data)                                                         (0x7FFFFFFF&((data)<<0))
+#define VO_SUB1_PXDT_a_src(data)                                                     ((0x7FFFFFFF&(data))>>0)
+#define VO_SUB1_PXDT_get_a(data)                                                     ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_SUB1_PXDB                                                                 0x18005334
+#define VO_SUB1_PXDB_reg_addr                                                        "0xB8005334"
+#define VO_SUB1_PXDB_reg                                                             0xB8005334
+#define set_VO_SUB1_PXDB_reg(data)   (*((volatile unsigned int*) VO_SUB1_PXDB_reg)=data)
+#define get_VO_SUB1_PXDB_reg   (*((volatile unsigned int*) VO_SUB1_PXDB_reg))
+#define VO_SUB1_PXDB_inst_adr                                                        "0x00CD"
+#define VO_SUB1_PXDB_inst                                                            0x00CD
+#define VO_SUB1_PXDB_a_shift                                                         (0)
+#define VO_SUB1_PXDB_a_mask                                                          (0x7FFFFFFF)
+#define VO_SUB1_PXDB_a(data)                                                         (0x7FFFFFFF&((data)<<0))
+#define VO_SUB1_PXDB_a_src(data)                                                     ((0x7FFFFFFF&(data))>>0)
+#define VO_SUB1_PXDB_get_a(data)                                                     ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_SUB1_LC                                                                   0x18005338
+#define VO_SUB1_LC_reg_addr                                                          "0xB8005338"
+#define VO_SUB1_LC_reg                                                               0xB8005338
+#define set_VO_SUB1_LC_reg(data)   (*((volatile unsigned int*) VO_SUB1_LC_reg)=data)
+#define get_VO_SUB1_LC_reg   (*((volatile unsigned int*) VO_SUB1_LC_reg))
+#define VO_SUB1_LC_inst_adr                                                          "0x00CE"
+#define VO_SUB1_LC_inst                                                              0x00CE
+#define VO_SUB1_LC_num_shift                                                         (0)
+#define VO_SUB1_LC_num_mask                                                          (0x000007FF)
+#define VO_SUB1_LC_num(data)                                                         (0x000007FF&((data)<<0))
+#define VO_SUB1_LC_num_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_SUB1_LC_get_num(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1_DFT                                                                  0x1800533C
+#define VO_SUB1_DFT_reg_addr                                                         "0xB800533C"
+#define VO_SUB1_DFT_reg                                                              0xB800533C
+#define set_VO_SUB1_DFT_reg(data)   (*((volatile unsigned int*) VO_SUB1_DFT_reg)=data)
+#define get_VO_SUB1_DFT_reg   (*((volatile unsigned int*) VO_SUB1_DFT_reg))
+#define VO_SUB1_DFT_inst_adr                                                         "0x00CF"
+#define VO_SUB1_DFT_inst                                                             0x00CF
+#define VO_SUB1_DFT_a3_shift                                                         (28)
+#define VO_SUB1_DFT_a3_mask                                                          (0xF0000000)
+#define VO_SUB1_DFT_a3(data)                                                         (0xF0000000&((data)<<28))
+#define VO_SUB1_DFT_a3_src(data)                                                     ((0xF0000000&(data))>>28)
+#define VO_SUB1_DFT_get_a3(data)                                                     ((0xF0000000&(data))>>28)
+#define VO_SUB1_DFT_a2_shift                                                         (24)
+#define VO_SUB1_DFT_a2_mask                                                          (0x0F000000)
+#define VO_SUB1_DFT_a2(data)                                                         (0x0F000000&((data)<<24))
+#define VO_SUB1_DFT_a2_src(data)                                                     ((0x0F000000&(data))>>24)
+#define VO_SUB1_DFT_get_a2(data)                                                     ((0x0F000000&(data))>>24)
+#define VO_SUB1_DFT_a1_shift                                                         (20)
+#define VO_SUB1_DFT_a1_mask                                                          (0x00F00000)
+#define VO_SUB1_DFT_a1(data)                                                         (0x00F00000&((data)<<20))
+#define VO_SUB1_DFT_a1_src(data)                                                     ((0x00F00000&(data))>>20)
+#define VO_SUB1_DFT_get_a1(data)                                                     ((0x00F00000&(data))>>20)
+#define VO_SUB1_DFT_a0_shift                                                         (16)
+#define VO_SUB1_DFT_a0_mask                                                          (0x000F0000)
+#define VO_SUB1_DFT_a0(data)                                                         (0x000F0000&((data)<<16))
+#define VO_SUB1_DFT_a0_src(data)                                                     ((0x000F0000&(data))>>16)
+#define VO_SUB1_DFT_get_a0(data)                                                     ((0x000F0000&(data))>>16)
+#define VO_SUB1_DFT_i3_shift                                                         (12)
+#define VO_SUB1_DFT_i3_mask                                                          (0x0000F000)
+#define VO_SUB1_DFT_i3(data)                                                         (0x0000F000&((data)<<12))
+#define VO_SUB1_DFT_i3_src(data)                                                     ((0x0000F000&(data))>>12)
+#define VO_SUB1_DFT_get_i3(data)                                                     ((0x0000F000&(data))>>12)
+#define VO_SUB1_DFT_i2_shift                                                         (8)
+#define VO_SUB1_DFT_i2_mask                                                          (0x00000F00)
+#define VO_SUB1_DFT_i2(data)                                                         (0x00000F00&((data)<<8))
+#define VO_SUB1_DFT_i2_src(data)                                                     ((0x00000F00&(data))>>8)
+#define VO_SUB1_DFT_get_i2(data)                                                     ((0x00000F00&(data))>>8)
+#define VO_SUB1_DFT_i1_shift                                                         (4)
+#define VO_SUB1_DFT_i1_mask                                                          (0x000000F0)
+#define VO_SUB1_DFT_i1(data)                                                         (0x000000F0&((data)<<4))
+#define VO_SUB1_DFT_i1_src(data)                                                     ((0x000000F0&(data))>>4)
+#define VO_SUB1_DFT_get_i1(data)                                                     ((0x000000F0&(data))>>4)
+#define VO_SUB1_DFT_i0_shift                                                         (0)
+#define VO_SUB1_DFT_i0_mask                                                          (0x0000000F)
+#define VO_SUB1_DFT_i0(data)                                                         (0x0000000F&((data)<<0))
+#define VO_SUB1_DFT_i0_src(data)                                                     ((0x0000000F&(data))>>0)
+#define VO_SUB1_DFT_get_i0(data)                                                     ((0x0000000F&(data))>>0)
+
+
+#define VO_SUB1_HLX                                                                  0x18005340
+#define VO_SUB1_HLX_reg_addr                                                         "0xB8005340"
+#define VO_SUB1_HLX_reg                                                              0xB8005340
+#define set_VO_SUB1_HLX_reg(data)   (*((volatile unsigned int*) VO_SUB1_HLX_reg)=data)
+#define get_VO_SUB1_HLX_reg   (*((volatile unsigned int*) VO_SUB1_HLX_reg))
+#define VO_SUB1_HLX_inst_adr                                                         "0x00D0"
+#define VO_SUB1_HLX_inst                                                             0x00D0
+#define VO_SUB1_HLX_e_shift                                                          (12)
+#define VO_SUB1_HLX_e_mask                                                           (0x007FF000)
+#define VO_SUB1_HLX_e(data)                                                          (0x007FF000&((data)<<12))
+#define VO_SUB1_HLX_e_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB1_HLX_get_e(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB1_HLX_s_shift                                                          (0)
+#define VO_SUB1_HLX_s_mask                                                           (0x000007FF)
+#define VO_SUB1_HLX_s(data)                                                          (0x000007FF&((data)<<0))
+#define VO_SUB1_HLX_s_src(data)                                                      ((0x000007FF&(data))>>0)
+#define VO_SUB1_HLX_get_s(data)                                                      ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1_HLY                                                                  0x18005344
+#define VO_SUB1_HLY_reg_addr                                                         "0xB8005344"
+#define VO_SUB1_HLY_reg                                                              0xB8005344
+#define set_VO_SUB1_HLY_reg(data)   (*((volatile unsigned int*) VO_SUB1_HLY_reg)=data)
+#define get_VO_SUB1_HLY_reg   (*((volatile unsigned int*) VO_SUB1_HLY_reg))
+#define VO_SUB1_HLY_inst_adr                                                         "0x00D1"
+#define VO_SUB1_HLY_inst                                                             0x00D1
+#define VO_SUB1_HLY_e_shift                                                          (12)
+#define VO_SUB1_HLY_e_mask                                                           (0x007FF000)
+#define VO_SUB1_HLY_e(data)                                                          (0x007FF000&((data)<<12))
+#define VO_SUB1_HLY_e_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB1_HLY_get_e(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_SUB1_HLY_s_shift                                                          (0)
+#define VO_SUB1_HLY_s_mask                                                           (0x000007FF)
+#define VO_SUB1_HLY_s(data)                                                          (0x000007FF&((data)<<0))
+#define VO_SUB1_HLY_s_src(data)                                                      ((0x000007FF&(data))>>0)
+#define VO_SUB1_HLY_get_s(data)                                                      ((0x000007FF&(data))>>0)
+
+
+#define VO_SUB1_HL                                                                   0x18005348
+#define VO_SUB1_HL_reg_addr                                                          "0xB8005348"
+#define VO_SUB1_HL_reg                                                               0xB8005348
+#define set_VO_SUB1_HL_reg(data)   (*((volatile unsigned int*) VO_SUB1_HL_reg)=data)
+#define get_VO_SUB1_HL_reg   (*((volatile unsigned int*) VO_SUB1_HL_reg))
+#define VO_SUB1_HL_inst_adr                                                          "0x00D2"
+#define VO_SUB1_HL_inst                                                              0x00D2
+#define VO_SUB1_HL_a3_shift                                                          (28)
+#define VO_SUB1_HL_a3_mask                                                           (0xF0000000)
+#define VO_SUB1_HL_a3(data)                                                          (0xF0000000&((data)<<28))
+#define VO_SUB1_HL_a3_src(data)                                                      ((0xF0000000&(data))>>28)
+#define VO_SUB1_HL_get_a3(data)                                                      ((0xF0000000&(data))>>28)
+#define VO_SUB1_HL_a2_shift                                                          (24)
+#define VO_SUB1_HL_a2_mask                                                           (0x0F000000)
+#define VO_SUB1_HL_a2(data)                                                          (0x0F000000&((data)<<24))
+#define VO_SUB1_HL_a2_src(data)                                                      ((0x0F000000&(data))>>24)
+#define VO_SUB1_HL_get_a2(data)                                                      ((0x0F000000&(data))>>24)
+#define VO_SUB1_HL_a1_shift                                                          (20)
+#define VO_SUB1_HL_a1_mask                                                           (0x00F00000)
+#define VO_SUB1_HL_a1(data)                                                          (0x00F00000&((data)<<20))
+#define VO_SUB1_HL_a1_src(data)                                                      ((0x00F00000&(data))>>20)
+#define VO_SUB1_HL_get_a1(data)                                                      ((0x00F00000&(data))>>20)
+#define VO_SUB1_HL_a0_shift                                                          (16)
+#define VO_SUB1_HL_a0_mask                                                           (0x000F0000)
+#define VO_SUB1_HL_a0(data)                                                          (0x000F0000&((data)<<16))
+#define VO_SUB1_HL_a0_src(data)                                                      ((0x000F0000&(data))>>16)
+#define VO_SUB1_HL_get_a0(data)                                                      ((0x000F0000&(data))>>16)
+#define VO_SUB1_HL_i3_shift                                                          (12)
+#define VO_SUB1_HL_i3_mask                                                           (0x0000F000)
+#define VO_SUB1_HL_i3(data)                                                          (0x0000F000&((data)<<12))
+#define VO_SUB1_HL_i3_src(data)                                                      ((0x0000F000&(data))>>12)
+#define VO_SUB1_HL_get_i3(data)                                                      ((0x0000F000&(data))>>12)
+#define VO_SUB1_HL_i2_shift                                                          (8)
+#define VO_SUB1_HL_i2_mask                                                           (0x00000F00)
+#define VO_SUB1_HL_i2(data)                                                          (0x00000F00&((data)<<8))
+#define VO_SUB1_HL_i2_src(data)                                                      ((0x00000F00&(data))>>8)
+#define VO_SUB1_HL_get_i2(data)                                                      ((0x00000F00&(data))>>8)
+#define VO_SUB1_HL_i1_shift                                                          (4)
+#define VO_SUB1_HL_i1_mask                                                           (0x000000F0)
+#define VO_SUB1_HL_i1(data)                                                          (0x000000F0&((data)<<4))
+#define VO_SUB1_HL_i1_src(data)                                                      ((0x000000F0&(data))>>4)
+#define VO_SUB1_HL_get_i1(data)                                                      ((0x000000F0&(data))>>4)
+#define VO_SUB1_HL_i0_shift                                                          (0)
+#define VO_SUB1_HL_i0_mask                                                           (0x0000000F)
+#define VO_SUB1_HL_i0(data)                                                          (0x0000000F&((data)<<0))
+#define VO_SUB1_HL_i0_src(data)                                                      ((0x0000000F&(data))>>0)
+#define VO_SUB1_HL_get_i0(data)                                                      ((0x0000000F&(data))>>0)
+
+
+#define VO_SUB1_CC1                                                                  0x1800534C
+#define VO_SUB1_CC1_reg_addr                                                         "0xB800534C"
+#define VO_SUB1_CC1_reg                                                              0xB800534C
+#define set_VO_SUB1_CC1_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC1_reg)=data)
+#define get_VO_SUB1_CC1_reg   (*((volatile unsigned int*) VO_SUB1_CC1_reg))
+#define VO_SUB1_CC1_inst_adr                                                         "0x00D3"
+#define VO_SUB1_CC1_inst                                                             0x00D3
+#define VO_SUB1_CC1_m01_shift                                                        (16)
+#define VO_SUB1_CC1_m01_mask                                                         (0x3FFF0000)
+#define VO_SUB1_CC1_m01(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_CC1_m01_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC1_get_m01(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC1_m00_shift                                                        (0)
+#define VO_SUB1_CC1_m00_mask                                                         (0x00003FFF)
+#define VO_SUB1_CC1_m00(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_CC1_m00_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_CC1_get_m00(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_CC2                                                                  0x18005350
+#define VO_SUB1_CC2_reg_addr                                                         "0xB8005350"
+#define VO_SUB1_CC2_reg                                                              0xB8005350
+#define set_VO_SUB1_CC2_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC2_reg)=data)
+#define get_VO_SUB1_CC2_reg   (*((volatile unsigned int*) VO_SUB1_CC2_reg))
+#define VO_SUB1_CC2_inst_adr                                                         "0x00D4"
+#define VO_SUB1_CC2_inst                                                             0x00D4
+#define VO_SUB1_CC2_m10_shift                                                        (16)
+#define VO_SUB1_CC2_m10_mask                                                         (0x3FFF0000)
+#define VO_SUB1_CC2_m10(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_CC2_m10_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC2_get_m10(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC2_m02_shift                                                        (0)
+#define VO_SUB1_CC2_m02_mask                                                         (0x00003FFF)
+#define VO_SUB1_CC2_m02(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_CC2_m02_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_CC2_get_m02(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_CC3                                                                  0x18005354
+#define VO_SUB1_CC3_reg_addr                                                         "0xB8005354"
+#define VO_SUB1_CC3_reg                                                              0xB8005354
+#define set_VO_SUB1_CC3_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC3_reg)=data)
+#define get_VO_SUB1_CC3_reg   (*((volatile unsigned int*) VO_SUB1_CC3_reg))
+#define VO_SUB1_CC3_inst_adr                                                         "0x00D5"
+#define VO_SUB1_CC3_inst                                                             0x00D5
+#define VO_SUB1_CC3_m12_shift                                                        (16)
+#define VO_SUB1_CC3_m12_mask                                                         (0x3FFF0000)
+#define VO_SUB1_CC3_m12(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_CC3_m12_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC3_get_m12(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC3_m11_shift                                                        (0)
+#define VO_SUB1_CC3_m11_mask                                                         (0x00003FFF)
+#define VO_SUB1_CC3_m11(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_CC3_m11_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_CC3_get_m11(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_CC4                                                                  0x18005358
+#define VO_SUB1_CC4_reg_addr                                                         "0xB8005358"
+#define VO_SUB1_CC4_reg                                                              0xB8005358
+#define set_VO_SUB1_CC4_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC4_reg)=data)
+#define get_VO_SUB1_CC4_reg   (*((volatile unsigned int*) VO_SUB1_CC4_reg))
+#define VO_SUB1_CC4_inst_adr                                                         "0x00D6"
+#define VO_SUB1_CC4_inst                                                             0x00D6
+#define VO_SUB1_CC4_m21_shift                                                        (16)
+#define VO_SUB1_CC4_m21_mask                                                         (0x3FFF0000)
+#define VO_SUB1_CC4_m21(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_CC4_m21_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC4_get_m21(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_CC4_m20_shift                                                        (0)
+#define VO_SUB1_CC4_m20_mask                                                         (0x00003FFF)
+#define VO_SUB1_CC4_m20(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_CC4_m20_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_CC4_get_m20(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_CC5                                                                  0x1800535C
+#define VO_SUB1_CC5_reg_addr                                                         "0xB800535C"
+#define VO_SUB1_CC5_reg                                                              0xB800535C
+#define set_VO_SUB1_CC5_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC5_reg)=data)
+#define get_VO_SUB1_CC5_reg   (*((volatile unsigned int*) VO_SUB1_CC5_reg))
+#define VO_SUB1_CC5_inst_adr                                                         "0x00D7"
+#define VO_SUB1_CC5_inst                                                             0x00D7
+#define VO_SUB1_CC5_m22_shift                                                        (0)
+#define VO_SUB1_CC5_m22_mask                                                         (0x00003FFF)
+#define VO_SUB1_CC5_m22(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_CC5_m22_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_CC5_get_m22(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_CC6                                                                  0x18005360
+#define VO_SUB1_CC6_reg_addr                                                         "0xB8005360"
+#define VO_SUB1_CC6_reg                                                              0xB8005360
+#define set_VO_SUB1_CC6_reg(data)   (*((volatile unsigned int*) VO_SUB1_CC6_reg)=data)
+#define get_VO_SUB1_CC6_reg   (*((volatile unsigned int*) VO_SUB1_CC6_reg))
+#define VO_SUB1_CC6_inst_adr                                                         "0x00D8"
+#define VO_SUB1_CC6_inst                                                             0x00D8
+#define VO_SUB1_CC6_a2_shift                                                         (18)
+#define VO_SUB1_CC6_a2_mask                                                          (0x07FC0000)
+#define VO_SUB1_CC6_a2(data)                                                         (0x07FC0000&((data)<<18))
+#define VO_SUB1_CC6_a2_src(data)                                                     ((0x07FC0000&(data))>>18)
+#define VO_SUB1_CC6_get_a2(data)                                                     ((0x07FC0000&(data))>>18)
+#define VO_SUB1_CC6_a1_shift                                                         (9)
+#define VO_SUB1_CC6_a1_mask                                                          (0x0003FE00)
+#define VO_SUB1_CC6_a1(data)                                                         (0x0003FE00&((data)<<9))
+#define VO_SUB1_CC6_a1_src(data)                                                     ((0x0003FE00&(data))>>9)
+#define VO_SUB1_CC6_get_a1(data)                                                     ((0x0003FE00&(data))>>9)
+#define VO_SUB1_CC6_a0_shift                                                         (0)
+#define VO_SUB1_CC6_a0_mask                                                          (0x000001FF)
+#define VO_SUB1_CC6_a0(data)                                                         (0x000001FF&((data)<<0))
+#define VO_SUB1_CC6_a0_src(data)                                                     ((0x000001FF&(data))>>0)
+#define VO_SUB1_CC6_get_a0(data)                                                     ((0x000001FF&(data))>>0)
+
+
+#define VO_SUB1_VSI                                                                  0x18005364
+#define VO_SUB1_VSI_reg_addr                                                         "0xB8005364"
+#define VO_SUB1_VSI_reg                                                              0xB8005364
+#define set_VO_SUB1_VSI_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSI_reg)=data)
+#define get_VO_SUB1_VSI_reg   (*((volatile unsigned int*) VO_SUB1_VSI_reg))
+#define VO_SUB1_VSI_inst_adr                                                         "0x00D9"
+#define VO_SUB1_VSI_inst                                                             0x00D9
+#define VO_SUB1_VSI_offset_shift                                                     (16)
+#define VO_SUB1_VSI_offset_mask                                                      (0x0FFF0000)
+#define VO_SUB1_VSI_offset(data)                                                     (0x0FFF0000&((data)<<16))
+#define VO_SUB1_VSI_offset_src(data)                                                 ((0x0FFF0000&(data))>>16)
+#define VO_SUB1_VSI_get_offset(data)                                                 ((0x0FFF0000&(data))>>16)
+#define VO_SUB1_VSI_phase_shift                                                      (0)
+#define VO_SUB1_VSI_phase_mask                                                       (0x0000FFFF)
+#define VO_SUB1_VSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_SUB1_VSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_SUB1_VSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_SUB1_VSD                                                                  0x18005368
+#define VO_SUB1_VSD_reg_addr                                                         "0xB8005368"
+#define VO_SUB1_VSD_reg                                                              0xB8005368
+#define set_VO_SUB1_VSD_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSD_reg)=data)
+#define get_VO_SUB1_VSD_reg   (*((volatile unsigned int*) VO_SUB1_VSD_reg))
+#define VO_SUB1_VSD_inst_adr                                                         "0x00DA"
+#define VO_SUB1_VSD_inst                                                             0x00DA
+#define VO_SUB1_VSD_delta_shift                                                      (0)
+#define VO_SUB1_VSD_delta_mask                                                       (0x001FFFFF)
+#define VO_SUB1_VSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_SUB1_VSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_SUB1_VSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_SUB1_VSD_H                                                                0x1800536C
+#define VO_SUB1_VSD_H_reg_addr                                                       "0xB800536C"
+#define VO_SUB1_VSD_H_reg                                                            0xB800536C
+#define set_VO_SUB1_VSD_H_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSD_H_reg)=data)
+#define get_VO_SUB1_VSD_H_reg   (*((volatile unsigned int*) VO_SUB1_VSD_H_reg))
+#define VO_SUB1_VSD_H_inst_adr                                                       "0x00DB"
+#define VO_SUB1_VSD_H_inst                                                           0x00DB
+#define VO_SUB1_VSD_H_out_shift                                                      (0)
+#define VO_SUB1_VSD_H_out_mask                                                       (0x00000FFF)
+#define VO_SUB1_VSD_H_out(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_SUB1_VSD_H_out_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_SUB1_VSD_H_get_out(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_SUB1_VSYC_0                                                               0x18005370
+#define VO_SUB1_VSYC_1                                                               0x18005374
+#define VO_SUB1_VSYC_2                                                               0x18005378
+#define VO_SUB1_VSYC_3                                                               0x1800537C
+#define VO_SUB1_VSYC_0_reg_addr                                                      "0xB8005370"
+#define VO_SUB1_VSYC_1_reg_addr                                                      "0xB8005374"
+#define VO_SUB1_VSYC_2_reg_addr                                                      "0xB8005378"
+#define VO_SUB1_VSYC_3_reg_addr                                                      "0xB800537C"
+#define VO_SUB1_VSYC_0_reg                                                           0xB8005370
+#define VO_SUB1_VSYC_1_reg                                                           0xB8005374
+#define VO_SUB1_VSYC_2_reg                                                           0xB8005378
+#define VO_SUB1_VSYC_3_reg                                                           0xB800537C
+#define set_VO_SUB1_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSYC_0_reg)=data)
+#define set_VO_SUB1_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSYC_1_reg)=data)
+#define set_VO_SUB1_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSYC_2_reg)=data)
+#define set_VO_SUB1_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSYC_3_reg)=data)
+#define get_VO_SUB1_VSYC_0_reg   (*((volatile unsigned int*) VO_SUB1_VSYC_0_reg))
+#define get_VO_SUB1_VSYC_1_reg   (*((volatile unsigned int*) VO_SUB1_VSYC_1_reg))
+#define get_VO_SUB1_VSYC_2_reg   (*((volatile unsigned int*) VO_SUB1_VSYC_2_reg))
+#define get_VO_SUB1_VSYC_3_reg   (*((volatile unsigned int*) VO_SUB1_VSYC_3_reg))
+#define VO_SUB1_VSYC_0_inst_adr                                                      "0x00DC"
+#define VO_SUB1_VSYC_1_inst_adr                                                      "0x00DD"
+#define VO_SUB1_VSYC_2_inst_adr                                                      "0x00DE"
+#define VO_SUB1_VSYC_3_inst_adr                                                      "0x00DF"
+#define VO_SUB1_VSYC_0_inst                                                          0x00DC
+#define VO_SUB1_VSYC_1_inst                                                          0x00DD
+#define VO_SUB1_VSYC_2_inst                                                          0x00DE
+#define VO_SUB1_VSYC_3_inst                                                          0x00DF
+#define VO_SUB1_VSYC_c1_shift                                                        (16)
+#define VO_SUB1_VSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB1_VSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_VSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_VSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_VSYC_c0_shift                                                        (0)
+#define VO_SUB1_VSYC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB1_VSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_VSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_VSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_VSCC_0                                                               0x18005380
+#define VO_SUB1_VSCC_1                                                               0x18005384
+#define VO_SUB1_VSCC_2                                                               0x18005388
+#define VO_SUB1_VSCC_3                                                               0x1800538C
+#define VO_SUB1_VSCC_0_reg_addr                                                      "0xB8005380"
+#define VO_SUB1_VSCC_1_reg_addr                                                      "0xB8005384"
+#define VO_SUB1_VSCC_2_reg_addr                                                      "0xB8005388"
+#define VO_SUB1_VSCC_3_reg_addr                                                      "0xB800538C"
+#define VO_SUB1_VSCC_0_reg                                                           0xB8005380
+#define VO_SUB1_VSCC_1_reg                                                           0xB8005384
+#define VO_SUB1_VSCC_2_reg                                                           0xB8005388
+#define VO_SUB1_VSCC_3_reg                                                           0xB800538C
+#define set_VO_SUB1_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSCC_0_reg)=data)
+#define set_VO_SUB1_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSCC_1_reg)=data)
+#define set_VO_SUB1_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSCC_2_reg)=data)
+#define set_VO_SUB1_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_SUB1_VSCC_3_reg)=data)
+#define get_VO_SUB1_VSCC_0_reg   (*((volatile unsigned int*) VO_SUB1_VSCC_0_reg))
+#define get_VO_SUB1_VSCC_1_reg   (*((volatile unsigned int*) VO_SUB1_VSCC_1_reg))
+#define get_VO_SUB1_VSCC_2_reg   (*((volatile unsigned int*) VO_SUB1_VSCC_2_reg))
+#define get_VO_SUB1_VSCC_3_reg   (*((volatile unsigned int*) VO_SUB1_VSCC_3_reg))
+#define VO_SUB1_VSCC_0_inst_adr                                                      "0x00E0"
+#define VO_SUB1_VSCC_1_inst_adr                                                      "0x00E1"
+#define VO_SUB1_VSCC_2_inst_adr                                                      "0x00E2"
+#define VO_SUB1_VSCC_3_inst_adr                                                      "0x00E3"
+#define VO_SUB1_VSCC_0_inst                                                          0x00E0
+#define VO_SUB1_VSCC_1_inst                                                          0x00E1
+#define VO_SUB1_VSCC_2_inst                                                          0x00E2
+#define VO_SUB1_VSCC_3_inst                                                          0x00E3
+#define VO_SUB1_VSCC_c1_shift                                                        (16)
+#define VO_SUB1_VSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB1_VSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_VSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_VSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_VSCC_c0_shift                                                        (0)
+#define VO_SUB1_VSCC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB1_VSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_VSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_VSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_HSI                                                                  0x18005390
+#define VO_SUB1_HSI_reg_addr                                                         "0xB8005390"
+#define VO_SUB1_HSI_reg                                                              0xB8005390
+#define set_VO_SUB1_HSI_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSI_reg)=data)
+#define get_VO_SUB1_HSI_reg   (*((volatile unsigned int*) VO_SUB1_HSI_reg))
+#define VO_SUB1_HSI_inst_adr                                                         "0x00E4"
+#define VO_SUB1_HSI_inst                                                             0x00E4
+#define VO_SUB1_HSI_offset_shift                                                     (16)
+#define VO_SUB1_HSI_offset_mask                                                      (0x07FF0000)
+#define VO_SUB1_HSI_offset(data)                                                     (0x07FF0000&((data)<<16))
+#define VO_SUB1_HSI_offset_src(data)                                                 ((0x07FF0000&(data))>>16)
+#define VO_SUB1_HSI_get_offset(data)                                                 ((0x07FF0000&(data))>>16)
+#define VO_SUB1_HSI_phase_shift                                                      (0)
+#define VO_SUB1_HSI_phase_mask                                                       (0x0000FFFF)
+#define VO_SUB1_HSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_SUB1_HSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_SUB1_HSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_SUB1_HSD                                                                  0x18005394
+#define VO_SUB1_HSD_reg_addr                                                         "0xB8005394"
+#define VO_SUB1_HSD_reg                                                              0xB8005394
+#define set_VO_SUB1_HSD_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSD_reg)=data)
+#define get_VO_SUB1_HSD_reg   (*((volatile unsigned int*) VO_SUB1_HSD_reg))
+#define VO_SUB1_HSD_inst_adr                                                         "0x00E5"
+#define VO_SUB1_HSD_inst                                                             0x00E5
+#define VO_SUB1_HSD_delta_shift                                                      (0)
+#define VO_SUB1_HSD_delta_mask                                                       (0x001FFFFF)
+#define VO_SUB1_HSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_SUB1_HSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_SUB1_HSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_SUB1_HSD_W                                                                0x18005398
+#define VO_SUB1_HSD_W_reg_addr                                                       "0xB8005398"
+#define VO_SUB1_HSD_W_reg                                                            0xB8005398
+#define set_VO_SUB1_HSD_W_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSD_W_reg)=data)
+#define get_VO_SUB1_HSD_W_reg   (*((volatile unsigned int*) VO_SUB1_HSD_W_reg))
+#define VO_SUB1_HSD_W_inst_adr                                                       "0x00E6"
+#define VO_SUB1_HSD_W_inst                                                           0x00E6
+#define VO_SUB1_HSD_W_out_shift                                                      (0)
+#define VO_SUB1_HSD_W_out_mask                                                       (0x00001FFF)
+#define VO_SUB1_HSD_W_out(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_SUB1_HSD_W_out_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_SUB1_HSD_W_get_out(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_SUB1_HSYC_0                                                               0x1800539C
+#define VO_SUB1_HSYC_1                                                               0x180053A0
+#define VO_SUB1_HSYC_2                                                               0x180053A4
+#define VO_SUB1_HSYC_3                                                               0x180053A8
+#define VO_SUB1_HSYC_4                                                               0x180053AC
+#define VO_SUB1_HSYC_5                                                               0x180053B0
+#define VO_SUB1_HSYC_6                                                               0x180053B4
+#define VO_SUB1_HSYC_7                                                               0x180053B8
+#define VO_SUB1_HSYC_0_reg_addr                                                      "0xB800539C"
+#define VO_SUB1_HSYC_1_reg_addr                                                      "0xB80053A0"
+#define VO_SUB1_HSYC_2_reg_addr                                                      "0xB80053A4"
+#define VO_SUB1_HSYC_3_reg_addr                                                      "0xB80053A8"
+#define VO_SUB1_HSYC_4_reg_addr                                                      "0xB80053AC"
+#define VO_SUB1_HSYC_5_reg_addr                                                      "0xB80053B0"
+#define VO_SUB1_HSYC_6_reg_addr                                                      "0xB80053B4"
+#define VO_SUB1_HSYC_7_reg_addr                                                      "0xB80053B8"
+#define VO_SUB1_HSYC_0_reg                                                           0xB800539C
+#define VO_SUB1_HSYC_1_reg                                                           0xB80053A0
+#define VO_SUB1_HSYC_2_reg                                                           0xB80053A4
+#define VO_SUB1_HSYC_3_reg                                                           0xB80053A8
+#define VO_SUB1_HSYC_4_reg                                                           0xB80053AC
+#define VO_SUB1_HSYC_5_reg                                                           0xB80053B0
+#define VO_SUB1_HSYC_6_reg                                                           0xB80053B4
+#define VO_SUB1_HSYC_7_reg                                                           0xB80053B8
+#define set_VO_SUB1_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_0_reg)=data)
+#define set_VO_SUB1_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_1_reg)=data)
+#define set_VO_SUB1_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_2_reg)=data)
+#define set_VO_SUB1_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_3_reg)=data)
+#define set_VO_SUB1_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_4_reg)=data)
+#define set_VO_SUB1_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_5_reg)=data)
+#define set_VO_SUB1_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_6_reg)=data)
+#define set_VO_SUB1_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSYC_7_reg)=data)
+#define get_VO_SUB1_HSYC_0_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_0_reg))
+#define get_VO_SUB1_HSYC_1_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_1_reg))
+#define get_VO_SUB1_HSYC_2_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_2_reg))
+#define get_VO_SUB1_HSYC_3_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_3_reg))
+#define get_VO_SUB1_HSYC_4_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_4_reg))
+#define get_VO_SUB1_HSYC_5_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_5_reg))
+#define get_VO_SUB1_HSYC_6_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_6_reg))
+#define get_VO_SUB1_HSYC_7_reg   (*((volatile unsigned int*) VO_SUB1_HSYC_7_reg))
+#define VO_SUB1_HSYC_0_inst_adr                                                      "0x00E7"
+#define VO_SUB1_HSYC_1_inst_adr                                                      "0x00E8"
+#define VO_SUB1_HSYC_2_inst_adr                                                      "0x00E9"
+#define VO_SUB1_HSYC_3_inst_adr                                                      "0x00EA"
+#define VO_SUB1_HSYC_4_inst_adr                                                      "0x00EB"
+#define VO_SUB1_HSYC_5_inst_adr                                                      "0x00EC"
+#define VO_SUB1_HSYC_6_inst_adr                                                      "0x00ED"
+#define VO_SUB1_HSYC_7_inst_adr                                                      "0x00EE"
+#define VO_SUB1_HSYC_0_inst                                                          0x00E7
+#define VO_SUB1_HSYC_1_inst                                                          0x00E8
+#define VO_SUB1_HSYC_2_inst                                                          0x00E9
+#define VO_SUB1_HSYC_3_inst                                                          0x00EA
+#define VO_SUB1_HSYC_4_inst                                                          0x00EB
+#define VO_SUB1_HSYC_5_inst                                                          0x00EC
+#define VO_SUB1_HSYC_6_inst                                                          0x00ED
+#define VO_SUB1_HSYC_7_inst                                                          0x00EE
+#define VO_SUB1_HSYC_c1_shift                                                        (16)
+#define VO_SUB1_HSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB1_HSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_HSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_HSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_HSYC_c0_shift                                                        (0)
+#define VO_SUB1_HSYC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB1_HSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_HSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_HSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_SUB1_HSCC_0                                                               0x180053BC
+#define VO_SUB1_HSCC_1                                                               0x180053C0
+#define VO_SUB1_HSCC_2                                                               0x180053C4
+#define VO_SUB1_HSCC_3                                                               0x180053C8
+#define VO_SUB1_HSCC_4                                                               0x180053CC
+#define VO_SUB1_HSCC_5                                                               0x180053D0
+#define VO_SUB1_HSCC_6                                                               0x180053D4
+#define VO_SUB1_HSCC_7                                                               0x180053D8
+#define VO_SUB1_HSCC_0_reg_addr                                                      "0xB80053BC"
+#define VO_SUB1_HSCC_1_reg_addr                                                      "0xB80053C0"
+#define VO_SUB1_HSCC_2_reg_addr                                                      "0xB80053C4"
+#define VO_SUB1_HSCC_3_reg_addr                                                      "0xB80053C8"
+#define VO_SUB1_HSCC_4_reg_addr                                                      "0xB80053CC"
+#define VO_SUB1_HSCC_5_reg_addr                                                      "0xB80053D0"
+#define VO_SUB1_HSCC_6_reg_addr                                                      "0xB80053D4"
+#define VO_SUB1_HSCC_7_reg_addr                                                      "0xB80053D8"
+#define VO_SUB1_HSCC_0_reg                                                           0xB80053BC
+#define VO_SUB1_HSCC_1_reg                                                           0xB80053C0
+#define VO_SUB1_HSCC_2_reg                                                           0xB80053C4
+#define VO_SUB1_HSCC_3_reg                                                           0xB80053C8
+#define VO_SUB1_HSCC_4_reg                                                           0xB80053CC
+#define VO_SUB1_HSCC_5_reg                                                           0xB80053D0
+#define VO_SUB1_HSCC_6_reg                                                           0xB80053D4
+#define VO_SUB1_HSCC_7_reg                                                           0xB80053D8
+#define set_VO_SUB1_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_0_reg)=data)
+#define set_VO_SUB1_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_1_reg)=data)
+#define set_VO_SUB1_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_2_reg)=data)
+#define set_VO_SUB1_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_3_reg)=data)
+#define set_VO_SUB1_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_4_reg)=data)
+#define set_VO_SUB1_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_5_reg)=data)
+#define set_VO_SUB1_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_6_reg)=data)
+#define set_VO_SUB1_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_SUB1_HSCC_7_reg)=data)
+#define get_VO_SUB1_HSCC_0_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_0_reg))
+#define get_VO_SUB1_HSCC_1_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_1_reg))
+#define get_VO_SUB1_HSCC_2_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_2_reg))
+#define get_VO_SUB1_HSCC_3_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_3_reg))
+#define get_VO_SUB1_HSCC_4_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_4_reg))
+#define get_VO_SUB1_HSCC_5_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_5_reg))
+#define get_VO_SUB1_HSCC_6_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_6_reg))
+#define get_VO_SUB1_HSCC_7_reg   (*((volatile unsigned int*) VO_SUB1_HSCC_7_reg))
+#define VO_SUB1_HSCC_0_inst_adr                                                      "0x00EF"
+#define VO_SUB1_HSCC_1_inst_adr                                                      "0x00F0"
+#define VO_SUB1_HSCC_2_inst_adr                                                      "0x00F1"
+#define VO_SUB1_HSCC_3_inst_adr                                                      "0x00F2"
+#define VO_SUB1_HSCC_4_inst_adr                                                      "0x00F3"
+#define VO_SUB1_HSCC_5_inst_adr                                                      "0x00F4"
+#define VO_SUB1_HSCC_6_inst_adr                                                      "0x00F5"
+#define VO_SUB1_HSCC_7_inst_adr                                                      "0x00F6"
+#define VO_SUB1_HSCC_0_inst                                                          0x00EF
+#define VO_SUB1_HSCC_1_inst                                                          0x00F0
+#define VO_SUB1_HSCC_2_inst                                                          0x00F1
+#define VO_SUB1_HSCC_3_inst                                                          0x00F2
+#define VO_SUB1_HSCC_4_inst                                                          0x00F3
+#define VO_SUB1_HSCC_5_inst                                                          0x00F4
+#define VO_SUB1_HSCC_6_inst                                                          0x00F5
+#define VO_SUB1_HSCC_7_inst                                                          0x00F6
+#define VO_SUB1_HSCC_c1_shift                                                        (16)
+#define VO_SUB1_HSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_SUB1_HSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_SUB1_HSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_HSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_SUB1_HSCC_c0_shift                                                        (0)
+#define VO_SUB1_HSCC_c0_mask                                                         (0x00003FFF)
+#define VO_SUB1_HSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_SUB1_HSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_SUB1_HSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1                                                                      0x180053DC
+#define VO_OSD1_reg_addr                                                             "0xB80053DC"
+#define VO_OSD1_reg                                                                  0xB80053DC
+#define set_VO_OSD1_reg(data)   (*((volatile unsigned int*) VO_OSD1_reg)=data)
+#define get_VO_OSD1_reg   (*((volatile unsigned int*) VO_OSD1_reg))
+#define VO_OSD1_inst_adr                                                             "0x00F7"
+#define VO_OSD1_inst                                                                 0x00F7
+#define VO_OSD1_d3_dbh_shift                                                         (29)
+#define VO_OSD1_d3_dbh_mask                                                          (0x20000000)
+#define VO_OSD1_d3_dbh(data)                                                         (0x20000000&((data)<<29))
+#define VO_OSD1_d3_dbh_src(data)                                                     ((0x20000000&(data))>>29)
+#define VO_OSD1_get_d3_dbh(data)                                                     ((0x20000000&(data))>>29)
+#define VO_OSD1_d3_vdup_shift                                                        (28)
+#define VO_OSD1_d3_vdup_mask                                                         (0x10000000)
+#define VO_OSD1_d3_vdup(data)                                                        (0x10000000&((data)<<28))
+#define VO_OSD1_d3_vdup_src(data)                                                    ((0x10000000&(data))>>28)
+#define VO_OSD1_get_d3_vdup(data)                                                    ((0x10000000&(data))>>28)
+#define VO_OSD1_d3_dbw_shift                                                         (27)
+#define VO_OSD1_d3_dbw_mask                                                          (0x08000000)
+#define VO_OSD1_d3_dbw(data)                                                         (0x08000000&((data)<<27))
+#define VO_OSD1_d3_dbw_src(data)                                                     ((0x08000000&(data))>>27)
+#define VO_OSD1_get_d3_dbw(data)                                                     ((0x08000000&(data))>>27)
+#define VO_OSD1_d3_dup_shift                                                         (26)
+#define VO_OSD1_d3_dup_mask                                                          (0x04000000)
+#define VO_OSD1_d3_dup(data)                                                         (0x04000000&((data)<<26))
+#define VO_OSD1_d3_dup_src(data)                                                     ((0x04000000&(data))>>26)
+#define VO_OSD1_get_d3_dup(data)                                                     ((0x04000000&(data))>>26)
+#define VO_OSD1_rgb_out_shift                                                        (25)
+#define VO_OSD1_rgb_out_mask                                                         (0x02000000)
+#define VO_OSD1_rgb_out(data)                                                        (0x02000000&((data)<<25))
+#define VO_OSD1_rgb_out_src(data)                                                    ((0x02000000&(data))>>25)
+#define VO_OSD1_get_rgb_out(data)                                                    ((0x02000000&(data))>>25)
+#define VO_OSD1_dvb_shift                                                            (17)
+#define VO_OSD1_dvb_mask                                                             (0x00020000)
+#define VO_OSD1_dvb(data)                                                            (0x00020000&((data)<<17))
+#define VO_OSD1_dvb_src(data)                                                        ((0x00020000&(data))>>17)
+#define VO_OSD1_get_dvb(data)                                                        ((0x00020000&(data))>>17)
+#define VO_OSD1_osd_shift                                                            (16)
+#define VO_OSD1_osd_mask                                                             (0x00010000)
+#define VO_OSD1_osd(data)                                                            (0x00010000&((data)<<16))
+#define VO_OSD1_osd_src(data)                                                        ((0x00010000&(data))>>16)
+#define VO_OSD1_get_osd(data)                                                        ((0x00010000&(data))>>16)
+#define VO_OSD1_fetch_1080i_shift                                                    (15)
+#define VO_OSD1_fetch_1080i_mask                                                     (0x00008000)
+#define VO_OSD1_fetch_1080i(data)                                                    (0x00008000&((data)<<15))
+#define VO_OSD1_fetch_1080i_src(data)                                                ((0x00008000&(data))>>15)
+#define VO_OSD1_get_fetch_1080i(data)                                                ((0x00008000&(data))>>15)
+#define VO_OSD1_odd_1080i_shift                                                      (14)
+#define VO_OSD1_odd_1080i_mask                                                       (0x00004000)
+#define VO_OSD1_odd_1080i(data)                                                      (0x00004000&((data)<<14))
+#define VO_OSD1_odd_1080i_src(data)                                                  ((0x00004000&(data))>>14)
+#define VO_OSD1_get_odd_1080i(data)                                                  ((0x00004000&(data))>>14)
+#define VO_OSD1_vs_shift                                                             (10)
+#define VO_OSD1_vs_mask                                                              (0x00000400)
+#define VO_OSD1_vs(data)                                                             (0x00000400&((data)<<10))
+#define VO_OSD1_vs_src(data)                                                         ((0x00000400&(data))>>10)
+#define VO_OSD1_get_vs(data)                                                         ((0x00000400&(data))>>10)
+#define VO_OSD1_vs_near_shift                                                        (9)
+#define VO_OSD1_vs_near_mask                                                         (0x00000200)
+#define VO_OSD1_vs_near(data)                                                        (0x00000200&((data)<<9))
+#define VO_OSD1_vs_near_src(data)                                                    ((0x00000200&(data))>>9)
+#define VO_OSD1_get_vs_near(data)                                                    ((0x00000200&(data))>>9)
+#define VO_OSD1_vs_yodd_shift                                                        (8)
+#define VO_OSD1_vs_yodd_mask                                                         (0x00000100)
+#define VO_OSD1_vs_yodd(data)                                                        (0x00000100&((data)<<8))
+#define VO_OSD1_vs_yodd_src(data)                                                    ((0x00000100&(data))>>8)
+#define VO_OSD1_get_vs_yodd(data)                                                    ((0x00000100&(data))>>8)
+#define VO_OSD1_vs_codd_shift                                                        (7)
+#define VO_OSD1_vs_codd_mask                                                         (0x00000080)
+#define VO_OSD1_vs_codd(data)                                                        (0x00000080&((data)<<7))
+#define VO_OSD1_vs_codd_src(data)                                                    ((0x00000080&(data))>>7)
+#define VO_OSD1_get_vs_codd(data)                                                    ((0x00000080&(data))>>7)
+#define VO_OSD1_hs_shift                                                             (6)
+#define VO_OSD1_hs_mask                                                              (0x00000040)
+#define VO_OSD1_hs(data)                                                             (0x00000040&((data)<<6))
+#define VO_OSD1_hs_src(data)                                                         ((0x00000040&(data))>>6)
+#define VO_OSD1_get_hs(data)                                                         ((0x00000040&(data))>>6)
+#define VO_OSD1_hs_yodd_shift                                                        (5)
+#define VO_OSD1_hs_yodd_mask                                                         (0x00000020)
+#define VO_OSD1_hs_yodd(data)                                                        (0x00000020&((data)<<5))
+#define VO_OSD1_hs_yodd_src(data)                                                    ((0x00000020&(data))>>5)
+#define VO_OSD1_get_hs_yodd(data)                                                    ((0x00000020&(data))>>5)
+#define VO_OSD1_hs_codd_shift                                                        (4)
+#define VO_OSD1_hs_codd_mask                                                         (0x00000010)
+#define VO_OSD1_hs_codd(data)                                                        (0x00000010&((data)<<4))
+#define VO_OSD1_hs_codd_src(data)                                                    ((0x00000010&(data))>>4)
+#define VO_OSD1_get_hs_codd(data)                                                    ((0x00000010&(data))>>4)
+#define VO_OSD1_write_data_shift                                                     (0)
+#define VO_OSD1_write_data_mask                                                      (0x00000001)
+#define VO_OSD1_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_OSD1_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_OSD1_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_OSD1_START                                                                0x180053E0
+#define VO_OSD1_START_reg_addr                                                       "0xB80053E0"
+#define VO_OSD1_START_reg                                                            0xB80053E0
+#define set_VO_OSD1_START_reg(data)   (*((volatile unsigned int*) VO_OSD1_START_reg)=data)
+#define get_VO_OSD1_START_reg   (*((volatile unsigned int*) VO_OSD1_START_reg))
+#define VO_OSD1_START_inst_adr                                                       "0x00F8"
+#define VO_OSD1_START_inst                                                           0x00F8
+#define VO_OSD1_START_ref_shift                                                      (24)
+#define VO_OSD1_START_ref_mask                                                       (0x07000000)
+#define VO_OSD1_START_ref(data)                                                      (0x07000000&((data)<<24))
+#define VO_OSD1_START_ref_src(data)                                                  ((0x07000000&(data))>>24)
+#define VO_OSD1_START_get_ref(data)                                                  ((0x07000000&(data))>>24)
+#define VO_OSD1_START_pos_shift                                                      (12)
+#define VO_OSD1_START_pos_mask                                                       (0x00FFF000)
+#define VO_OSD1_START_pos(data)                                                      (0x00FFF000&((data)<<12))
+#define VO_OSD1_START_pos_src(data)                                                  ((0x00FFF000&(data))>>12)
+#define VO_OSD1_START_get_pos(data)                                                  ((0x00FFF000&(data))>>12)
+#define VO_OSD1_START_th_shift                                                       (0)
+#define VO_OSD1_START_th_mask                                                        (0x00000FFF)
+#define VO_OSD1_START_th(data)                                                       (0x00000FFF&((data)<<0))
+#define VO_OSD1_START_th_src(data)                                                   ((0x00000FFF&(data))>>0)
+#define VO_OSD1_START_get_th(data)                                                   ((0x00000FFF&(data))>>0)
+
+
+#define VO_OSD1_WI                                                                   0x180053E4
+#define VO_OSD1_WI_reg_addr                                                          "0xB80053E4"
+#define VO_OSD1_WI_reg                                                               0xB80053E4
+#define set_VO_OSD1_WI_reg(data)   (*((volatile unsigned int*) VO_OSD1_WI_reg)=data)
+#define get_VO_OSD1_WI_reg   (*((volatile unsigned int*) VO_OSD1_WI_reg))
+#define VO_OSD1_WI_inst_adr                                                          "0x00F9"
+#define VO_OSD1_WI_inst                                                              0x00F9
+#define VO_OSD1_WI_endian_shift                                                      (31)
+#define VO_OSD1_WI_endian_mask                                                       (0x80000000)
+#define VO_OSD1_WI_endian(data)                                                      (0x80000000&((data)<<31))
+#define VO_OSD1_WI_endian_src(data)                                                  ((0x80000000&(data))>>31)
+#define VO_OSD1_WI_get_endian(data)                                                  ((0x80000000&(data))>>31)
+#define VO_OSD1_WI_a_shift                                                           (0)
+#define VO_OSD1_WI_a_mask                                                            (0x7FFFFFFF)
+#define VO_OSD1_WI_a(data)                                                           (0x7FFFFFFF&((data)<<0))
+#define VO_OSD1_WI_a_src(data)                                                       ((0x7FFFFFFF&(data))>>0)
+#define VO_OSD1_WI_get_a(data)                                                       ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_OSD1_WI_3D                                                                0x180053E8
+#define VO_OSD1_WI_3D_reg_addr                                                       "0xB80053E8"
+#define VO_OSD1_WI_3D_reg                                                            0xB80053E8
+#define set_VO_OSD1_WI_3D_reg(data)   (*((volatile unsigned int*) VO_OSD1_WI_3D_reg)=data)
+#define get_VO_OSD1_WI_3D_reg   (*((volatile unsigned int*) VO_OSD1_WI_3D_reg))
+#define VO_OSD1_WI_3D_inst_adr                                                       "0x00FA"
+#define VO_OSD1_WI_3D_inst                                                           0x00FA
+#define VO_OSD1_WI_3D_a_shift                                                        (0)
+#define VO_OSD1_WI_3D_a_mask                                                         (0x7FFFFFFF)
+#define VO_OSD1_WI_3D_a(data)                                                        (0x7FFFFFFF&((data)<<0))
+#define VO_OSD1_WI_3D_a_src(data)                                                    ((0x7FFFFFFF&(data))>>0)
+#define VO_OSD1_WI_3D_get_a(data)                                                    ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_OSD1_SIZE                                                                 0x180053EC
+#define VO_OSD1_SIZE_reg_addr                                                        "0xB80053EC"
+#define VO_OSD1_SIZE_reg                                                             0xB80053EC
+#define set_VO_OSD1_SIZE_reg(data)   (*((volatile unsigned int*) VO_OSD1_SIZE_reg)=data)
+#define get_VO_OSD1_SIZE_reg   (*((volatile unsigned int*) VO_OSD1_SIZE_reg))
+#define VO_OSD1_SIZE_inst_adr                                                        "0x00FB"
+#define VO_OSD1_SIZE_inst                                                            0x00FB
+#define VO_OSD1_SIZE_w_shift                                                         (12)
+#define VO_OSD1_SIZE_w_mask                                                          (0x007FF000)
+#define VO_OSD1_SIZE_w(data)                                                         (0x007FF000&((data)<<12))
+#define VO_OSD1_SIZE_w_src(data)                                                     ((0x007FF000&(data))>>12)
+#define VO_OSD1_SIZE_get_w(data)                                                     ((0x007FF000&(data))>>12)
+#define VO_OSD1_SIZE_h_shift                                                         (0)
+#define VO_OSD1_SIZE_h_mask                                                          (0x000007FF)
+#define VO_OSD1_SIZE_h(data)                                                         (0x000007FF&((data)<<0))
+#define VO_OSD1_SIZE_h_src(data)                                                     ((0x000007FF&(data))>>0)
+#define VO_OSD1_SIZE_get_h(data)                                                     ((0x000007FF&(data))>>0)
+
+
+#define VO_OSD1_BUF                                                                  0x180053F0
+#define VO_OSD1_BUF_reg_addr                                                         "0xB80053F0"
+#define VO_OSD1_BUF_reg                                                              0xB80053F0
+#define set_VO_OSD1_BUF_reg(data)   (*((volatile unsigned int*) VO_OSD1_BUF_reg)=data)
+#define get_VO_OSD1_BUF_reg   (*((volatile unsigned int*) VO_OSD1_BUF_reg))
+#define VO_OSD1_BUF_inst_adr                                                         "0x00FC"
+#define VO_OSD1_BUF_inst                                                             0x00FC
+#define VO_OSD1_BUF_th_shift                                                         (0)
+#define VO_OSD1_BUF_th_mask                                                          (0x000001FF)
+#define VO_OSD1_BUF_th(data)                                                         (0x000001FF&((data)<<0))
+#define VO_OSD1_BUF_th_src(data)                                                     ((0x000001FF&(data))>>0)
+#define VO_OSD1_BUF_get_th(data)                                                     ((0x000001FF&(data))>>0)
+
+
+#define VO_OSD1_CC1                                                                  0x180053F4
+#define VO_OSD1_CC1_reg_addr                                                         "0xB80053F4"
+#define VO_OSD1_CC1_reg                                                              0xB80053F4
+#define set_VO_OSD1_CC1_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC1_reg)=data)
+#define get_VO_OSD1_CC1_reg   (*((volatile unsigned int*) VO_OSD1_CC1_reg))
+#define VO_OSD1_CC1_inst_adr                                                         "0x00FD"
+#define VO_OSD1_CC1_inst                                                             0x00FD
+#define VO_OSD1_CC1_m01_shift                                                        (16)
+#define VO_OSD1_CC1_m01_mask                                                         (0x3FFF0000)
+#define VO_OSD1_CC1_m01(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_CC1_m01_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC1_get_m01(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC1_m00_shift                                                        (0)
+#define VO_OSD1_CC1_m00_mask                                                         (0x00003FFF)
+#define VO_OSD1_CC1_m00(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_CC1_m00_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_CC1_get_m00(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_CC2                                                                  0x180053F8
+#define VO_OSD1_CC2_reg_addr                                                         "0xB80053F8"
+#define VO_OSD1_CC2_reg                                                              0xB80053F8
+#define set_VO_OSD1_CC2_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC2_reg)=data)
+#define get_VO_OSD1_CC2_reg   (*((volatile unsigned int*) VO_OSD1_CC2_reg))
+#define VO_OSD1_CC2_inst_adr                                                         "0x00FE"
+#define VO_OSD1_CC2_inst                                                             0x00FE
+#define VO_OSD1_CC2_m10_shift                                                        (16)
+#define VO_OSD1_CC2_m10_mask                                                         (0x3FFF0000)
+#define VO_OSD1_CC2_m10(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_CC2_m10_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC2_get_m10(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC2_m02_shift                                                        (0)
+#define VO_OSD1_CC2_m02_mask                                                         (0x00003FFF)
+#define VO_OSD1_CC2_m02(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_CC2_m02_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_CC2_get_m02(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_CC3                                                                  0x180053FC
+#define VO_OSD1_CC3_reg_addr                                                         "0xB80053FC"
+#define VO_OSD1_CC3_reg                                                              0xB80053FC
+#define set_VO_OSD1_CC3_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC3_reg)=data)
+#define get_VO_OSD1_CC3_reg   (*((volatile unsigned int*) VO_OSD1_CC3_reg))
+#define VO_OSD1_CC3_inst_adr                                                         "0x00FF"
+#define VO_OSD1_CC3_inst                                                             0x00FF
+#define VO_OSD1_CC3_m12_shift                                                        (16)
+#define VO_OSD1_CC3_m12_mask                                                         (0x3FFF0000)
+#define VO_OSD1_CC3_m12(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_CC3_m12_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC3_get_m12(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC3_m11_shift                                                        (0)
+#define VO_OSD1_CC3_m11_mask                                                         (0x00003FFF)
+#define VO_OSD1_CC3_m11(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_CC3_m11_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_CC3_get_m11(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_CC4                                                                  0x18005400
+#define VO_OSD1_CC4_reg_addr                                                         "0xB8005400"
+#define VO_OSD1_CC4_reg                                                              0xB8005400
+#define set_VO_OSD1_CC4_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC4_reg)=data)
+#define get_VO_OSD1_CC4_reg   (*((volatile unsigned int*) VO_OSD1_CC4_reg))
+#define VO_OSD1_CC4_inst_adr                                                         "0x0000"
+#define VO_OSD1_CC4_inst                                                             0x0000
+#define VO_OSD1_CC4_m21_shift                                                        (16)
+#define VO_OSD1_CC4_m21_mask                                                         (0x3FFF0000)
+#define VO_OSD1_CC4_m21(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_CC4_m21_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC4_get_m21(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_CC4_m20_shift                                                        (0)
+#define VO_OSD1_CC4_m20_mask                                                         (0x00003FFF)
+#define VO_OSD1_CC4_m20(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_CC4_m20_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_CC4_get_m20(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_CC5                                                                  0x18005404
+#define VO_OSD1_CC5_reg_addr                                                         "0xB8005404"
+#define VO_OSD1_CC5_reg                                                              0xB8005404
+#define set_VO_OSD1_CC5_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC5_reg)=data)
+#define get_VO_OSD1_CC5_reg   (*((volatile unsigned int*) VO_OSD1_CC5_reg))
+#define VO_OSD1_CC5_inst_adr                                                         "0x0001"
+#define VO_OSD1_CC5_inst                                                             0x0001
+#define VO_OSD1_CC5_m22_shift                                                        (0)
+#define VO_OSD1_CC5_m22_mask                                                         (0x00003FFF)
+#define VO_OSD1_CC5_m22(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_CC5_m22_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_CC5_get_m22(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_CC6                                                                  0x18005408
+#define VO_OSD1_CC6_reg_addr                                                         "0xB8005408"
+#define VO_OSD1_CC6_reg                                                              0xB8005408
+#define set_VO_OSD1_CC6_reg(data)   (*((volatile unsigned int*) VO_OSD1_CC6_reg)=data)
+#define get_VO_OSD1_CC6_reg   (*((volatile unsigned int*) VO_OSD1_CC6_reg))
+#define VO_OSD1_CC6_inst_adr                                                         "0x0002"
+#define VO_OSD1_CC6_inst                                                             0x0002
+#define VO_OSD1_CC6_a2_shift                                                         (18)
+#define VO_OSD1_CC6_a2_mask                                                          (0x07FC0000)
+#define VO_OSD1_CC6_a2(data)                                                         (0x07FC0000&((data)<<18))
+#define VO_OSD1_CC6_a2_src(data)                                                     ((0x07FC0000&(data))>>18)
+#define VO_OSD1_CC6_get_a2(data)                                                     ((0x07FC0000&(data))>>18)
+#define VO_OSD1_CC6_a1_shift                                                         (9)
+#define VO_OSD1_CC6_a1_mask                                                          (0x0003FE00)
+#define VO_OSD1_CC6_a1(data)                                                         (0x0003FE00&((data)<<9))
+#define VO_OSD1_CC6_a1_src(data)                                                     ((0x0003FE00&(data))>>9)
+#define VO_OSD1_CC6_get_a1(data)                                                     ((0x0003FE00&(data))>>9)
+#define VO_OSD1_CC6_a0_shift                                                         (0)
+#define VO_OSD1_CC6_a0_mask                                                          (0x000001FF)
+#define VO_OSD1_CC6_a0(data)                                                         (0x000001FF&((data)<<0))
+#define VO_OSD1_CC6_a0_src(data)                                                     ((0x000001FF&(data))>>0)
+#define VO_OSD1_CC6_get_a0(data)                                                     ((0x000001FF&(data))>>0)
+
+
+#define VO_OSD1_VSI                                                                  0x1800540C
+#define VO_OSD1_VSI_reg_addr                                                         "0xB800540C"
+#define VO_OSD1_VSI_reg                                                              0xB800540C
+#define set_VO_OSD1_VSI_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSI_reg)=data)
+#define get_VO_OSD1_VSI_reg   (*((volatile unsigned int*) VO_OSD1_VSI_reg))
+#define VO_OSD1_VSI_inst_adr                                                         "0x0003"
+#define VO_OSD1_VSI_inst                                                             0x0003
+#define VO_OSD1_VSI_offset_shift                                                     (16)
+#define VO_OSD1_VSI_offset_mask                                                      (0x0FFF0000)
+#define VO_OSD1_VSI_offset(data)                                                     (0x0FFF0000&((data)<<16))
+#define VO_OSD1_VSI_offset_src(data)                                                 ((0x0FFF0000&(data))>>16)
+#define VO_OSD1_VSI_get_offset(data)                                                 ((0x0FFF0000&(data))>>16)
+#define VO_OSD1_VSI_phase_shift                                                      (0)
+#define VO_OSD1_VSI_phase_mask                                                       (0x0000FFFF)
+#define VO_OSD1_VSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_OSD1_VSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_OSD1_VSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_OSD1_VSD                                                                  0x18005410
+#define VO_OSD1_VSD_reg_addr                                                         "0xB8005410"
+#define VO_OSD1_VSD_reg                                                              0xB8005410
+#define set_VO_OSD1_VSD_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSD_reg)=data)
+#define get_VO_OSD1_VSD_reg   (*((volatile unsigned int*) VO_OSD1_VSD_reg))
+#define VO_OSD1_VSD_inst_adr                                                         "0x0004"
+#define VO_OSD1_VSD_inst                                                             0x0004
+#define VO_OSD1_VSD_delta_shift                                                      (0)
+#define VO_OSD1_VSD_delta_mask                                                       (0x001FFFFF)
+#define VO_OSD1_VSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_OSD1_VSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_OSD1_VSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_OSD1_VSD_H                                                                0x18005414
+#define VO_OSD1_VSD_H_reg_addr                                                       "0xB8005414"
+#define VO_OSD1_VSD_H_reg                                                            0xB8005414
+#define set_VO_OSD1_VSD_H_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSD_H_reg)=data)
+#define get_VO_OSD1_VSD_H_reg   (*((volatile unsigned int*) VO_OSD1_VSD_H_reg))
+#define VO_OSD1_VSD_H_inst_adr                                                       "0x0005"
+#define VO_OSD1_VSD_H_inst                                                           0x0005
+#define VO_OSD1_VSD_H_out_shift                                                      (0)
+#define VO_OSD1_VSD_H_out_mask                                                       (0x00000FFF)
+#define VO_OSD1_VSD_H_out(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_OSD1_VSD_H_out_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_OSD1_VSD_H_get_out(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_OSD1_VSYC_0                                                               0x18005418
+#define VO_OSD1_VSYC_1                                                               0x1800541C
+#define VO_OSD1_VSYC_2                                                               0x18005420
+#define VO_OSD1_VSYC_3                                                               0x18005424
+#define VO_OSD1_VSYC_0_reg_addr                                                      "0xB8005418"
+#define VO_OSD1_VSYC_1_reg_addr                                                      "0xB800541C"
+#define VO_OSD1_VSYC_2_reg_addr                                                      "0xB8005420"
+#define VO_OSD1_VSYC_3_reg_addr                                                      "0xB8005424"
+#define VO_OSD1_VSYC_0_reg                                                           0xB8005418
+#define VO_OSD1_VSYC_1_reg                                                           0xB800541C
+#define VO_OSD1_VSYC_2_reg                                                           0xB8005420
+#define VO_OSD1_VSYC_3_reg                                                           0xB8005424
+#define set_VO_OSD1_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSYC_0_reg)=data)
+#define set_VO_OSD1_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSYC_1_reg)=data)
+#define set_VO_OSD1_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSYC_2_reg)=data)
+#define set_VO_OSD1_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSYC_3_reg)=data)
+#define get_VO_OSD1_VSYC_0_reg   (*((volatile unsigned int*) VO_OSD1_VSYC_0_reg))
+#define get_VO_OSD1_VSYC_1_reg   (*((volatile unsigned int*) VO_OSD1_VSYC_1_reg))
+#define get_VO_OSD1_VSYC_2_reg   (*((volatile unsigned int*) VO_OSD1_VSYC_2_reg))
+#define get_VO_OSD1_VSYC_3_reg   (*((volatile unsigned int*) VO_OSD1_VSYC_3_reg))
+#define VO_OSD1_VSYC_0_inst_adr                                                      "0x0006"
+#define VO_OSD1_VSYC_1_inst_adr                                                      "0x0007"
+#define VO_OSD1_VSYC_2_inst_adr                                                      "0x0008"
+#define VO_OSD1_VSYC_3_inst_adr                                                      "0x0009"
+#define VO_OSD1_VSYC_0_inst                                                          0x0006
+#define VO_OSD1_VSYC_1_inst                                                          0x0007
+#define VO_OSD1_VSYC_2_inst                                                          0x0008
+#define VO_OSD1_VSYC_3_inst                                                          0x0009
+#define VO_OSD1_VSYC_c1_shift                                                        (16)
+#define VO_OSD1_VSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_OSD1_VSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_VSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_VSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_VSYC_c0_shift                                                        (0)
+#define VO_OSD1_VSYC_c0_mask                                                         (0x00003FFF)
+#define VO_OSD1_VSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_VSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_VSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_VSCC_0                                                               0x18005428
+#define VO_OSD1_VSCC_1                                                               0x1800542C
+#define VO_OSD1_VSCC_2                                                               0x18005430
+#define VO_OSD1_VSCC_3                                                               0x18005434
+#define VO_OSD1_VSCC_0_reg_addr                                                      "0xB8005428"
+#define VO_OSD1_VSCC_1_reg_addr                                                      "0xB800542C"
+#define VO_OSD1_VSCC_2_reg_addr                                                      "0xB8005430"
+#define VO_OSD1_VSCC_3_reg_addr                                                      "0xB8005434"
+#define VO_OSD1_VSCC_0_reg                                                           0xB8005428
+#define VO_OSD1_VSCC_1_reg                                                           0xB800542C
+#define VO_OSD1_VSCC_2_reg                                                           0xB8005430
+#define VO_OSD1_VSCC_3_reg                                                           0xB8005434
+#define set_VO_OSD1_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSCC_0_reg)=data)
+#define set_VO_OSD1_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSCC_1_reg)=data)
+#define set_VO_OSD1_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSCC_2_reg)=data)
+#define set_VO_OSD1_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_OSD1_VSCC_3_reg)=data)
+#define get_VO_OSD1_VSCC_0_reg   (*((volatile unsigned int*) VO_OSD1_VSCC_0_reg))
+#define get_VO_OSD1_VSCC_1_reg   (*((volatile unsigned int*) VO_OSD1_VSCC_1_reg))
+#define get_VO_OSD1_VSCC_2_reg   (*((volatile unsigned int*) VO_OSD1_VSCC_2_reg))
+#define get_VO_OSD1_VSCC_3_reg   (*((volatile unsigned int*) VO_OSD1_VSCC_3_reg))
+#define VO_OSD1_VSCC_0_inst_adr                                                      "0x000A"
+#define VO_OSD1_VSCC_1_inst_adr                                                      "0x000B"
+#define VO_OSD1_VSCC_2_inst_adr                                                      "0x000C"
+#define VO_OSD1_VSCC_3_inst_adr                                                      "0x000D"
+#define VO_OSD1_VSCC_0_inst                                                          0x000A
+#define VO_OSD1_VSCC_1_inst                                                          0x000B
+#define VO_OSD1_VSCC_2_inst                                                          0x000C
+#define VO_OSD1_VSCC_3_inst                                                          0x000D
+#define VO_OSD1_VSCC_c1_shift                                                        (16)
+#define VO_OSD1_VSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_OSD1_VSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_VSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_VSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_VSCC_c0_shift                                                        (0)
+#define VO_OSD1_VSCC_c0_mask                                                         (0x00003FFF)
+#define VO_OSD1_VSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_VSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_VSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_HSI                                                                  0x18005438
+#define VO_OSD1_HSI_reg_addr                                                         "0xB8005438"
+#define VO_OSD1_HSI_reg                                                              0xB8005438
+#define set_VO_OSD1_HSI_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSI_reg)=data)
+#define get_VO_OSD1_HSI_reg   (*((volatile unsigned int*) VO_OSD1_HSI_reg))
+#define VO_OSD1_HSI_inst_adr                                                         "0x000E"
+#define VO_OSD1_HSI_inst                                                             0x000E
+#define VO_OSD1_HSI_offset_shift                                                     (16)
+#define VO_OSD1_HSI_offset_mask                                                      (0x07FF0000)
+#define VO_OSD1_HSI_offset(data)                                                     (0x07FF0000&((data)<<16))
+#define VO_OSD1_HSI_offset_src(data)                                                 ((0x07FF0000&(data))>>16)
+#define VO_OSD1_HSI_get_offset(data)                                                 ((0x07FF0000&(data))>>16)
+#define VO_OSD1_HSI_phase_shift                                                      (0)
+#define VO_OSD1_HSI_phase_mask                                                       (0x0000FFFF)
+#define VO_OSD1_HSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_OSD1_HSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_OSD1_HSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_OSD1_HSD                                                                  0x1800543C
+#define VO_OSD1_HSD_reg_addr                                                         "0xB800543C"
+#define VO_OSD1_HSD_reg                                                              0xB800543C
+#define set_VO_OSD1_HSD_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSD_reg)=data)
+#define get_VO_OSD1_HSD_reg   (*((volatile unsigned int*) VO_OSD1_HSD_reg))
+#define VO_OSD1_HSD_inst_adr                                                         "0x000F"
+#define VO_OSD1_HSD_inst                                                             0x000F
+#define VO_OSD1_HSD_delta_shift                                                      (0)
+#define VO_OSD1_HSD_delta_mask                                                       (0x001FFFFF)
+#define VO_OSD1_HSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_OSD1_HSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_OSD1_HSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_OSD1_HSD_W                                                                0x18005440
+#define VO_OSD1_HSD_W_reg_addr                                                       "0xB8005440"
+#define VO_OSD1_HSD_W_reg                                                            0xB8005440
+#define set_VO_OSD1_HSD_W_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSD_W_reg)=data)
+#define get_VO_OSD1_HSD_W_reg   (*((volatile unsigned int*) VO_OSD1_HSD_W_reg))
+#define VO_OSD1_HSD_W_inst_adr                                                       "0x0010"
+#define VO_OSD1_HSD_W_inst                                                           0x0010
+#define VO_OSD1_HSD_W_out_shift                                                      (0)
+#define VO_OSD1_HSD_W_out_mask                                                       (0x00001FFF)
+#define VO_OSD1_HSD_W_out(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_OSD1_HSD_W_out_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_OSD1_HSD_W_get_out(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_OSD1_HSYC_0                                                               0x18005444
+#define VO_OSD1_HSYC_1                                                               0x18005448
+#define VO_OSD1_HSYC_2                                                               0x1800544C
+#define VO_OSD1_HSYC_3                                                               0x18005450
+#define VO_OSD1_HSYC_4                                                               0x18005454
+#define VO_OSD1_HSYC_5                                                               0x18005458
+#define VO_OSD1_HSYC_6                                                               0x1800545C
+#define VO_OSD1_HSYC_7                                                               0x18005460
+#define VO_OSD1_HSYC_0_reg_addr                                                      "0xB8005444"
+#define VO_OSD1_HSYC_1_reg_addr                                                      "0xB8005448"
+#define VO_OSD1_HSYC_2_reg_addr                                                      "0xB800544C"
+#define VO_OSD1_HSYC_3_reg_addr                                                      "0xB8005450"
+#define VO_OSD1_HSYC_4_reg_addr                                                      "0xB8005454"
+#define VO_OSD1_HSYC_5_reg_addr                                                      "0xB8005458"
+#define VO_OSD1_HSYC_6_reg_addr                                                      "0xB800545C"
+#define VO_OSD1_HSYC_7_reg_addr                                                      "0xB8005460"
+#define VO_OSD1_HSYC_0_reg                                                           0xB8005444
+#define VO_OSD1_HSYC_1_reg                                                           0xB8005448
+#define VO_OSD1_HSYC_2_reg                                                           0xB800544C
+#define VO_OSD1_HSYC_3_reg                                                           0xB8005450
+#define VO_OSD1_HSYC_4_reg                                                           0xB8005454
+#define VO_OSD1_HSYC_5_reg                                                           0xB8005458
+#define VO_OSD1_HSYC_6_reg                                                           0xB800545C
+#define VO_OSD1_HSYC_7_reg                                                           0xB8005460
+#define set_VO_OSD1_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_0_reg)=data)
+#define set_VO_OSD1_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_1_reg)=data)
+#define set_VO_OSD1_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_2_reg)=data)
+#define set_VO_OSD1_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_3_reg)=data)
+#define set_VO_OSD1_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_4_reg)=data)
+#define set_VO_OSD1_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_5_reg)=data)
+#define set_VO_OSD1_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_6_reg)=data)
+#define set_VO_OSD1_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSYC_7_reg)=data)
+#define get_VO_OSD1_HSYC_0_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_0_reg))
+#define get_VO_OSD1_HSYC_1_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_1_reg))
+#define get_VO_OSD1_HSYC_2_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_2_reg))
+#define get_VO_OSD1_HSYC_3_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_3_reg))
+#define get_VO_OSD1_HSYC_4_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_4_reg))
+#define get_VO_OSD1_HSYC_5_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_5_reg))
+#define get_VO_OSD1_HSYC_6_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_6_reg))
+#define get_VO_OSD1_HSYC_7_reg   (*((volatile unsigned int*) VO_OSD1_HSYC_7_reg))
+#define VO_OSD1_HSYC_0_inst_adr                                                      "0x0011"
+#define VO_OSD1_HSYC_1_inst_adr                                                      "0x0012"
+#define VO_OSD1_HSYC_2_inst_adr                                                      "0x0013"
+#define VO_OSD1_HSYC_3_inst_adr                                                      "0x0014"
+#define VO_OSD1_HSYC_4_inst_adr                                                      "0x0015"
+#define VO_OSD1_HSYC_5_inst_adr                                                      "0x0016"
+#define VO_OSD1_HSYC_6_inst_adr                                                      "0x0017"
+#define VO_OSD1_HSYC_7_inst_adr                                                      "0x0018"
+#define VO_OSD1_HSYC_0_inst                                                          0x0011
+#define VO_OSD1_HSYC_1_inst                                                          0x0012
+#define VO_OSD1_HSYC_2_inst                                                          0x0013
+#define VO_OSD1_HSYC_3_inst                                                          0x0014
+#define VO_OSD1_HSYC_4_inst                                                          0x0015
+#define VO_OSD1_HSYC_5_inst                                                          0x0016
+#define VO_OSD1_HSYC_6_inst                                                          0x0017
+#define VO_OSD1_HSYC_7_inst                                                          0x0018
+#define VO_OSD1_HSYC_c1_shift                                                        (16)
+#define VO_OSD1_HSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_OSD1_HSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_HSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_HSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_HSYC_c0_shift                                                        (0)
+#define VO_OSD1_HSYC_c0_mask                                                         (0x00003FFF)
+#define VO_OSD1_HSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_HSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_HSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_OSD1_HSCC_0                                                               0x18005464
+#define VO_OSD1_HSCC_1                                                               0x18005468
+#define VO_OSD1_HSCC_2                                                               0x1800546C
+#define VO_OSD1_HSCC_3                                                               0x18005470
+#define VO_OSD1_HSCC_4                                                               0x18005474
+#define VO_OSD1_HSCC_5                                                               0x18005478
+#define VO_OSD1_HSCC_6                                                               0x1800547C
+#define VO_OSD1_HSCC_7                                                               0x18005480
+#define VO_OSD1_HSCC_0_reg_addr                                                      "0xB8005464"
+#define VO_OSD1_HSCC_1_reg_addr                                                      "0xB8005468"
+#define VO_OSD1_HSCC_2_reg_addr                                                      "0xB800546C"
+#define VO_OSD1_HSCC_3_reg_addr                                                      "0xB8005470"
+#define VO_OSD1_HSCC_4_reg_addr                                                      "0xB8005474"
+#define VO_OSD1_HSCC_5_reg_addr                                                      "0xB8005478"
+#define VO_OSD1_HSCC_6_reg_addr                                                      "0xB800547C"
+#define VO_OSD1_HSCC_7_reg_addr                                                      "0xB8005480"
+#define VO_OSD1_HSCC_0_reg                                                           0xB8005464
+#define VO_OSD1_HSCC_1_reg                                                           0xB8005468
+#define VO_OSD1_HSCC_2_reg                                                           0xB800546C
+#define VO_OSD1_HSCC_3_reg                                                           0xB8005470
+#define VO_OSD1_HSCC_4_reg                                                           0xB8005474
+#define VO_OSD1_HSCC_5_reg                                                           0xB8005478
+#define VO_OSD1_HSCC_6_reg                                                           0xB800547C
+#define VO_OSD1_HSCC_7_reg                                                           0xB8005480
+#define set_VO_OSD1_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_0_reg)=data)
+#define set_VO_OSD1_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_1_reg)=data)
+#define set_VO_OSD1_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_2_reg)=data)
+#define set_VO_OSD1_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_3_reg)=data)
+#define set_VO_OSD1_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_4_reg)=data)
+#define set_VO_OSD1_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_5_reg)=data)
+#define set_VO_OSD1_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_6_reg)=data)
+#define set_VO_OSD1_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_OSD1_HSCC_7_reg)=data)
+#define get_VO_OSD1_HSCC_0_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_0_reg))
+#define get_VO_OSD1_HSCC_1_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_1_reg))
+#define get_VO_OSD1_HSCC_2_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_2_reg))
+#define get_VO_OSD1_HSCC_3_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_3_reg))
+#define get_VO_OSD1_HSCC_4_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_4_reg))
+#define get_VO_OSD1_HSCC_5_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_5_reg))
+#define get_VO_OSD1_HSCC_6_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_6_reg))
+#define get_VO_OSD1_HSCC_7_reg   (*((volatile unsigned int*) VO_OSD1_HSCC_7_reg))
+#define VO_OSD1_HSCC_0_inst_adr                                                      "0x0019"
+#define VO_OSD1_HSCC_1_inst_adr                                                      "0x001A"
+#define VO_OSD1_HSCC_2_inst_adr                                                      "0x001B"
+#define VO_OSD1_HSCC_3_inst_adr                                                      "0x001C"
+#define VO_OSD1_HSCC_4_inst_adr                                                      "0x001D"
+#define VO_OSD1_HSCC_5_inst_adr                                                      "0x001E"
+#define VO_OSD1_HSCC_6_inst_adr                                                      "0x001F"
+#define VO_OSD1_HSCC_7_inst_adr                                                      "0x0020"
+#define VO_OSD1_HSCC_0_inst                                                          0x0019
+#define VO_OSD1_HSCC_1_inst                                                          0x001A
+#define VO_OSD1_HSCC_2_inst                                                          0x001B
+#define VO_OSD1_HSCC_3_inst                                                          0x001C
+#define VO_OSD1_HSCC_4_inst                                                          0x001D
+#define VO_OSD1_HSCC_5_inst                                                          0x001E
+#define VO_OSD1_HSCC_6_inst                                                          0x001F
+#define VO_OSD1_HSCC_7_inst                                                          0x0020
+#define VO_OSD1_HSCC_c1_shift                                                        (16)
+#define VO_OSD1_HSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_OSD1_HSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_OSD1_HSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_HSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_OSD1_HSCC_c0_shift                                                        (0)
+#define VO_OSD1_HSCC_c0_mask                                                         (0x00003FFF)
+#define VO_OSD1_HSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_OSD1_HSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_OSD1_HSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_DDWB                                                                      0x18005484
+#define VO_DDWB_reg_addr                                                             "0xB8005484"
+#define VO_DDWB_reg                                                                  0xB8005484
+#define set_VO_DDWB_reg(data)   (*((volatile unsigned int*) VO_DDWB_reg)=data)
+#define get_VO_DDWB_reg   (*((volatile unsigned int*) VO_DDWB_reg))
+#define VO_DDWB_inst_adr                                                             "0x0021"
+#define VO_DDWB_inst                                                                 0x0021
+#define VO_DDWB_dd_seq_shift                                                         (13)
+#define VO_DDWB_dd_seq_mask                                                          (0x00002000)
+#define VO_DDWB_dd_seq(data)                                                         (0x00002000&((data)<<13))
+#define VO_DDWB_dd_seq_src(data)                                                     ((0x00002000&(data))>>13)
+#define VO_DDWB_get_dd_seq(data)                                                     ((0x00002000&(data))>>13)
+#define VO_DDWB_wb_seq_shift                                                         (12)
+#define VO_DDWB_wb_seq_mask                                                          (0x00001000)
+#define VO_DDWB_wb_seq(data)                                                         (0x00001000&((data)<<12))
+#define VO_DDWB_wb_seq_src(data)                                                     ((0x00001000&(data))>>12)
+#define VO_DDWB_get_wb_seq(data)                                                     ((0x00001000&(data))>>12)
+#define VO_DDWB_h2v_shift                                                            (11)
+#define VO_DDWB_h2v_mask                                                             (0x00000800)
+#define VO_DDWB_h2v(data)                                                            (0x00000800&((data)<<11))
+#define VO_DDWB_h2v_src(data)                                                        ((0x00000800&(data))>>11)
+#define VO_DDWB_get_h2v(data)                                                        ((0x00000800&(data))>>11)
+#define VO_DDWB_hd_shift                                                             (10)
+#define VO_DDWB_hd_mask                                                              (0x00000400)
+#define VO_DDWB_hd(data)                                                             (0x00000400&((data)<<10))
+#define VO_DDWB_hd_src(data)                                                         ((0x00000400&(data))>>10)
+#define VO_DDWB_get_hd(data)                                                         ((0x00000400&(data))>>10)
+#define VO_DDWB_f422_shift                                                           (9)
+#define VO_DDWB_f422_mask                                                            (0x00000200)
+#define VO_DDWB_f422(data)                                                           (0x00000200&((data)<<9))
+#define VO_DDWB_f422_src(data)                                                       ((0x00000200&(data))>>9)
+#define VO_DDWB_get_f422(data)                                                       ((0x00000200&(data))>>9)
+#define VO_DDWB_reint_shift                                                          (8)
+#define VO_DDWB_reint_mask                                                           (0x00000100)
+#define VO_DDWB_reint(data)                                                          (0x00000100&((data)<<8))
+#define VO_DDWB_reint_src(data)                                                      ((0x00000100&(data))>>8)
+#define VO_DDWB_get_reint(data)                                                      ((0x00000100&(data))>>8)
+#define VO_DDWB_bot_shift                                                            (7)
+#define VO_DDWB_bot_mask                                                             (0x00000080)
+#define VO_DDWB_bot(data)                                                            (0x00000080&((data)<<7))
+#define VO_DDWB_bot_src(data)                                                        ((0x00000080&(data))>>7)
+#define VO_DDWB_get_bot(data)                                                        ((0x00000080&(data))>>7)
+#define VO_DDWB_vs_yodd_shift                                                        (5)
+#define VO_DDWB_vs_yodd_mask                                                         (0x00000020)
+#define VO_DDWB_vs_yodd(data)                                                        (0x00000020&((data)<<5))
+#define VO_DDWB_vs_yodd_src(data)                                                    ((0x00000020&(data))>>5)
+#define VO_DDWB_get_vs_yodd(data)                                                    ((0x00000020&(data))>>5)
+#define VO_DDWB_vs_codd_shift                                                        (4)
+#define VO_DDWB_vs_codd_mask                                                         (0x00000010)
+#define VO_DDWB_vs_codd(data)                                                        (0x00000010&((data)<<4))
+#define VO_DDWB_vs_codd_src(data)                                                    ((0x00000010&(data))>>4)
+#define VO_DDWB_get_vs_codd(data)                                                    ((0x00000010&(data))>>4)
+#define VO_DDWB_hs_yodd_shift                                                        (2)
+#define VO_DDWB_hs_yodd_mask                                                         (0x00000004)
+#define VO_DDWB_hs_yodd(data)                                                        (0x00000004&((data)<<2))
+#define VO_DDWB_hs_yodd_src(data)                                                    ((0x00000004&(data))>>2)
+#define VO_DDWB_get_hs_yodd(data)                                                    ((0x00000004&(data))>>2)
+#define VO_DDWB_hs_codd_shift                                                        (1)
+#define VO_DDWB_hs_codd_mask                                                         (0x00000002)
+#define VO_DDWB_hs_codd(data)                                                        (0x00000002&((data)<<1))
+#define VO_DDWB_hs_codd_src(data)                                                    ((0x00000002&(data))>>1)
+#define VO_DDWB_get_hs_codd(data)                                                    ((0x00000002&(data))>>1)
+#define VO_DDWB_write_data_shift                                                     (0)
+#define VO_DDWB_write_data_mask                                                      (0x00000001)
+#define VO_DDWB_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_DDWB_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_DDWB_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_DDWB_SEL                                                                  0x18005488
+#define VO_DDWB_SEL_reg_addr                                                         "0xB8005488"
+#define VO_DDWB_SEL_reg                                                              0xB8005488
+#define set_VO_DDWB_SEL_reg(data)   (*((volatile unsigned int*) VO_DDWB_SEL_reg)=data)
+#define get_VO_DDWB_SEL_reg   (*((volatile unsigned int*) VO_DDWB_SEL_reg))
+#define VO_DDWB_SEL_inst_adr                                                         "0x0022"
+#define VO_DDWB_SEL_inst                                                             0x0022
+#define VO_DDWB_SEL_write_en2_shift                                                  (6)
+#define VO_DDWB_SEL_write_en2_mask                                                   (0x00000040)
+#define VO_DDWB_SEL_write_en2(data)                                                  (0x00000040&((data)<<6))
+#define VO_DDWB_SEL_write_en2_src(data)                                              ((0x00000040&(data))>>6)
+#define VO_DDWB_SEL_get_write_en2(data)                                              ((0x00000040&(data))>>6)
+#define VO_DDWB_SEL_hs_sel_shift                                                     (4)
+#define VO_DDWB_SEL_hs_sel_mask                                                      (0x00000030)
+#define VO_DDWB_SEL_hs_sel(data)                                                     (0x00000030&((data)<<4))
+#define VO_DDWB_SEL_hs_sel_src(data)                                                 ((0x00000030&(data))>>4)
+#define VO_DDWB_SEL_get_hs_sel(data)                                                 ((0x00000030&(data))>>4)
+#define VO_DDWB_SEL_write_en1_shift                                                  (2)
+#define VO_DDWB_SEL_write_en1_mask                                                   (0x00000004)
+#define VO_DDWB_SEL_write_en1(data)                                                  (0x00000004&((data)<<2))
+#define VO_DDWB_SEL_write_en1_src(data)                                              ((0x00000004&(data))>>2)
+#define VO_DDWB_SEL_get_write_en1(data)                                              ((0x00000004&(data))>>2)
+#define VO_DDWB_SEL_vs_sel_shift                                                     (0)
+#define VO_DDWB_SEL_vs_sel_mask                                                      (0x00000003)
+#define VO_DDWB_SEL_vs_sel(data)                                                     (0x00000003&((data)<<0))
+#define VO_DDWB_SEL_vs_sel_src(data)                                                 ((0x00000003&(data))>>0)
+#define VO_DDWB_SEL_get_vs_sel(data)                                                 ((0x00000003&(data))>>0)
+
+
+#define VO_DD_INDEX                                                                  0x1800548C
+#define VO_DD_INDEX_reg_addr                                                         "0xB800548C"
+#define VO_DD_INDEX_reg                                                              0xB800548C
+#define set_VO_DD_INDEX_reg(data)   (*((volatile unsigned int*) VO_DD_INDEX_reg)=data)
+#define get_VO_DD_INDEX_reg   (*((volatile unsigned int*) VO_DD_INDEX_reg))
+#define VO_DD_INDEX_inst_adr                                                         "0x0023"
+#define VO_DD_INDEX_inst                                                             0x0023
+#define VO_DD_INDEX_write_en5_shift                                                  (27)
+#define VO_DD_INDEX_write_en5_mask                                                   (0x08000000)
+#define VO_DD_INDEX_write_en5(data)                                                  (0x08000000&((data)<<27))
+#define VO_DD_INDEX_write_en5_src(data)                                              ((0x08000000&(data))>>27)
+#define VO_DD_INDEX_get_write_en5(data)                                              ((0x08000000&(data))>>27)
+#define VO_DD_INDEX_interlace_shift                                                  (26)
+#define VO_DD_INDEX_interlace_mask                                                   (0x04000000)
+#define VO_DD_INDEX_interlace(data)                                                  (0x04000000&((data)<<26))
+#define VO_DD_INDEX_interlace_src(data)                                              ((0x04000000&(data))>>26)
+#define VO_DD_INDEX_get_interlace(data)                                              ((0x04000000&(data))>>26)
+#define VO_DD_INDEX_write_en4_shift                                                  (25)
+#define VO_DD_INDEX_write_en4_mask                                                   (0x02000000)
+#define VO_DD_INDEX_write_en4(data)                                                  (0x02000000&((data)<<25))
+#define VO_DD_INDEX_write_en4_src(data)                                              ((0x02000000&(data))>>25)
+#define VO_DD_INDEX_get_write_en4(data)                                              ((0x02000000&(data))>>25)
+#define VO_DD_INDEX_bot_shift                                                        (24)
+#define VO_DD_INDEX_bot_mask                                                         (0x01000000)
+#define VO_DD_INDEX_bot(data)                                                        (0x01000000&((data)<<24))
+#define VO_DD_INDEX_bot_src(data)                                                    ((0x01000000&(data))>>24)
+#define VO_DD_INDEX_get_bot(data)                                                    ((0x01000000&(data))>>24)
+#define VO_DD_INDEX_write_en2_shift                                                  (15)
+#define VO_DD_INDEX_write_en2_mask                                                   (0x00008000)
+#define VO_DD_INDEX_write_en2(data)                                                  (0x00008000&((data)<<15))
+#define VO_DD_INDEX_write_en2_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_DD_INDEX_get_write_en2(data)                                              ((0x00008000&(data))>>15)
+#define VO_DD_INDEX_c_shift                                                          (8)
+#define VO_DD_INDEX_c_mask                                                           (0x00007F00)
+#define VO_DD_INDEX_c(data)                                                          (0x00007F00&((data)<<8))
+#define VO_DD_INDEX_c_src(data)                                                      ((0x00007F00&(data))>>8)
+#define VO_DD_INDEX_get_c(data)                                                      ((0x00007F00&(data))>>8)
+#define VO_DD_INDEX_write_en1_shift                                                  (7)
+#define VO_DD_INDEX_write_en1_mask                                                   (0x00000080)
+#define VO_DD_INDEX_write_en1(data)                                                  (0x00000080&((data)<<7))
+#define VO_DD_INDEX_write_en1_src(data)                                              ((0x00000080&(data))>>7)
+#define VO_DD_INDEX_get_write_en1(data)                                              ((0x00000080&(data))>>7)
+#define VO_DD_INDEX_y_shift                                                          (0)
+#define VO_DD_INDEX_y_mask                                                           (0x0000007F)
+#define VO_DD_INDEX_y(data)                                                          (0x0000007F&((data)<<0))
+#define VO_DD_INDEX_y_src(data)                                                      ((0x0000007F&(data))>>0)
+#define VO_DD_INDEX_get_y(data)                                                      ((0x0000007F&(data))>>0)
+
+
+#define VO_DD_SEQ_SA_Y                                                               0x18005490
+#define VO_DD_SEQ_SA_Y_reg_addr                                                      "0xB8005490"
+#define VO_DD_SEQ_SA_Y_reg                                                           0xB8005490
+#define set_VO_DD_SEQ_SA_Y_reg(data)   (*((volatile unsigned int*) VO_DD_SEQ_SA_Y_reg)=data)
+#define get_VO_DD_SEQ_SA_Y_reg   (*((volatile unsigned int*) VO_DD_SEQ_SA_Y_reg))
+#define VO_DD_SEQ_SA_Y_inst_adr                                                      "0x0024"
+#define VO_DD_SEQ_SA_Y_inst                                                          0x0024
+#define VO_DD_SEQ_SA_Y_a_shift                                                       (0)
+#define VO_DD_SEQ_SA_Y_a_mask                                                        (0x7FFFFFFF)
+#define VO_DD_SEQ_SA_Y_a(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define VO_DD_SEQ_SA_Y_a_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define VO_DD_SEQ_SA_Y_get_a(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_DD_SEQ_PITCH_Y                                                            0x18005494
+#define VO_DD_SEQ_PITCH_Y_reg_addr                                                   "0xB8005494"
+#define VO_DD_SEQ_PITCH_Y_reg                                                        0xB8005494
+#define set_VO_DD_SEQ_PITCH_Y_reg(data)   (*((volatile unsigned int*) VO_DD_SEQ_PITCH_Y_reg)=data)
+#define get_VO_DD_SEQ_PITCH_Y_reg   (*((volatile unsigned int*) VO_DD_SEQ_PITCH_Y_reg))
+#define VO_DD_SEQ_PITCH_Y_inst_adr                                                   "0x0025"
+#define VO_DD_SEQ_PITCH_Y_inst                                                       0x0025
+#define VO_DD_SEQ_PITCH_Y_p_shift                                                    (0)
+#define VO_DD_SEQ_PITCH_Y_p_mask                                                     (0x0000FFFF)
+#define VO_DD_SEQ_PITCH_Y_p(data)                                                    (0x0000FFFF&((data)<<0))
+#define VO_DD_SEQ_PITCH_Y_p_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define VO_DD_SEQ_PITCH_Y_get_p(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define VO_DD_SEQ_SA_C                                                               0x18005498
+#define VO_DD_SEQ_SA_C_reg_addr                                                      "0xB8005498"
+#define VO_DD_SEQ_SA_C_reg                                                           0xB8005498
+#define set_VO_DD_SEQ_SA_C_reg(data)   (*((volatile unsigned int*) VO_DD_SEQ_SA_C_reg)=data)
+#define get_VO_DD_SEQ_SA_C_reg   (*((volatile unsigned int*) VO_DD_SEQ_SA_C_reg))
+#define VO_DD_SEQ_SA_C_inst_adr                                                      "0x0026"
+#define VO_DD_SEQ_SA_C_inst                                                          0x0026
+#define VO_DD_SEQ_SA_C_a_shift                                                       (0)
+#define VO_DD_SEQ_SA_C_a_mask                                                        (0x7FFFFFFF)
+#define VO_DD_SEQ_SA_C_a(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define VO_DD_SEQ_SA_C_a_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define VO_DD_SEQ_SA_C_get_a(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_DD_SEQ_PITCH_C                                                            0x1800549C
+#define VO_DD_SEQ_PITCH_C_reg_addr                                                   "0xB800549C"
+#define VO_DD_SEQ_PITCH_C_reg                                                        0xB800549C
+#define set_VO_DD_SEQ_PITCH_C_reg(data)   (*((volatile unsigned int*) VO_DD_SEQ_PITCH_C_reg)=data)
+#define get_VO_DD_SEQ_PITCH_C_reg   (*((volatile unsigned int*) VO_DD_SEQ_PITCH_C_reg))
+#define VO_DD_SEQ_PITCH_C_inst_adr                                                   "0x0027"
+#define VO_DD_SEQ_PITCH_C_inst                                                       0x0027
+#define VO_DD_SEQ_PITCH_C_p_shift                                                    (0)
+#define VO_DD_SEQ_PITCH_C_p_mask                                                     (0x0000FFFF)
+#define VO_DD_SEQ_PITCH_C_p(data)                                                    (0x0000FFFF&((data)<<0))
+#define VO_DD_SEQ_PITCH_C_p_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define VO_DD_SEQ_PITCH_C_get_p(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define VO_WB_INDEX                                                                  0x180054A0
+#define VO_WB_INDEX_reg_addr                                                         "0xB80054A0"
+#define VO_WB_INDEX_reg                                                              0xB80054A0
+#define set_VO_WB_INDEX_reg(data)   (*((volatile unsigned int*) VO_WB_INDEX_reg)=data)
+#define get_VO_WB_INDEX_reg   (*((volatile unsigned int*) VO_WB_INDEX_reg))
+#define VO_WB_INDEX_inst_adr                                                         "0x0028"
+#define VO_WB_INDEX_inst                                                             0x0028
+#define VO_WB_INDEX_write_en5_shift                                                  (27)
+#define VO_WB_INDEX_write_en5_mask                                                   (0x08000000)
+#define VO_WB_INDEX_write_en5(data)                                                  (0x08000000&((data)<<27))
+#define VO_WB_INDEX_write_en5_src(data)                                              ((0x08000000&(data))>>27)
+#define VO_WB_INDEX_get_write_en5(data)                                              ((0x08000000&(data))>>27)
+#define VO_WB_INDEX_interlace_shift                                                  (26)
+#define VO_WB_INDEX_interlace_mask                                                   (0x04000000)
+#define VO_WB_INDEX_interlace(data)                                                  (0x04000000&((data)<<26))
+#define VO_WB_INDEX_interlace_src(data)                                              ((0x04000000&(data))>>26)
+#define VO_WB_INDEX_get_interlace(data)                                              ((0x04000000&(data))>>26)
+#define VO_WB_INDEX_write_en4_shift                                                  (25)
+#define VO_WB_INDEX_write_en4_mask                                                   (0x02000000)
+#define VO_WB_INDEX_write_en4(data)                                                  (0x02000000&((data)<<25))
+#define VO_WB_INDEX_write_en4_src(data)                                              ((0x02000000&(data))>>25)
+#define VO_WB_INDEX_get_write_en4(data)                                              ((0x02000000&(data))>>25)
+#define VO_WB_INDEX_bot_shift                                                        (24)
+#define VO_WB_INDEX_bot_mask                                                         (0x01000000)
+#define VO_WB_INDEX_bot(data)                                                        (0x01000000&((data)<<24))
+#define VO_WB_INDEX_bot_src(data)                                                    ((0x01000000&(data))>>24)
+#define VO_WB_INDEX_get_bot(data)                                                    ((0x01000000&(data))>>24)
+#define VO_WB_INDEX_write_en2_shift                                                  (15)
+#define VO_WB_INDEX_write_en2_mask                                                   (0x00008000)
+#define VO_WB_INDEX_write_en2(data)                                                  (0x00008000&((data)<<15))
+#define VO_WB_INDEX_write_en2_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_WB_INDEX_get_write_en2(data)                                              ((0x00008000&(data))>>15)
+#define VO_WB_INDEX_c_shift                                                          (8)
+#define VO_WB_INDEX_c_mask                                                           (0x00007F00)
+#define VO_WB_INDEX_c(data)                                                          (0x00007F00&((data)<<8))
+#define VO_WB_INDEX_c_src(data)                                                      ((0x00007F00&(data))>>8)
+#define VO_WB_INDEX_get_c(data)                                                      ((0x00007F00&(data))>>8)
+#define VO_WB_INDEX_write_en1_shift                                                  (7)
+#define VO_WB_INDEX_write_en1_mask                                                   (0x00000080)
+#define VO_WB_INDEX_write_en1(data)                                                  (0x00000080&((data)<<7))
+#define VO_WB_INDEX_write_en1_src(data)                                              ((0x00000080&(data))>>7)
+#define VO_WB_INDEX_get_write_en1(data)                                              ((0x00000080&(data))>>7)
+#define VO_WB_INDEX_y_shift                                                          (0)
+#define VO_WB_INDEX_y_mask                                                           (0x0000007F)
+#define VO_WB_INDEX_y(data)                                                          (0x0000007F&((data)<<0))
+#define VO_WB_INDEX_y_src(data)                                                      ((0x0000007F&(data))>>0)
+#define VO_WB_INDEX_get_y(data)                                                      ((0x0000007F&(data))>>0)
+
+
+#define VO_WB_SEQ_SA_Y                                                               0x180054A4
+#define VO_WB_SEQ_SA_Y_reg_addr                                                      "0xB80054A4"
+#define VO_WB_SEQ_SA_Y_reg                                                           0xB80054A4
+#define set_VO_WB_SEQ_SA_Y_reg(data)   (*((volatile unsigned int*) VO_WB_SEQ_SA_Y_reg)=data)
+#define get_VO_WB_SEQ_SA_Y_reg   (*((volatile unsigned int*) VO_WB_SEQ_SA_Y_reg))
+#define VO_WB_SEQ_SA_Y_inst_adr                                                      "0x0029"
+#define VO_WB_SEQ_SA_Y_inst                                                          0x0029
+#define VO_WB_SEQ_SA_Y_a_shift                                                       (0)
+#define VO_WB_SEQ_SA_Y_a_mask                                                        (0x7FFFFFFF)
+#define VO_WB_SEQ_SA_Y_a(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define VO_WB_SEQ_SA_Y_a_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define VO_WB_SEQ_SA_Y_get_a(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_WB_SEQ_PITCH_Y                                                            0x180054A8
+#define VO_WB_SEQ_PITCH_Y_reg_addr                                                   "0xB80054A8"
+#define VO_WB_SEQ_PITCH_Y_reg                                                        0xB80054A8
+#define set_VO_WB_SEQ_PITCH_Y_reg(data)   (*((volatile unsigned int*) VO_WB_SEQ_PITCH_Y_reg)=data)
+#define get_VO_WB_SEQ_PITCH_Y_reg   (*((volatile unsigned int*) VO_WB_SEQ_PITCH_Y_reg))
+#define VO_WB_SEQ_PITCH_Y_inst_adr                                                   "0x002A"
+#define VO_WB_SEQ_PITCH_Y_inst                                                       0x002A
+#define VO_WB_SEQ_PITCH_Y_p_shift                                                    (0)
+#define VO_WB_SEQ_PITCH_Y_p_mask                                                     (0x0000FFFF)
+#define VO_WB_SEQ_PITCH_Y_p(data)                                                    (0x0000FFFF&((data)<<0))
+#define VO_WB_SEQ_PITCH_Y_p_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define VO_WB_SEQ_PITCH_Y_get_p(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define VO_WB_SEQ_SA_C                                                               0x180054AC
+#define VO_WB_SEQ_SA_C_reg_addr                                                      "0xB80054AC"
+#define VO_WB_SEQ_SA_C_reg                                                           0xB80054AC
+#define set_VO_WB_SEQ_SA_C_reg(data)   (*((volatile unsigned int*) VO_WB_SEQ_SA_C_reg)=data)
+#define get_VO_WB_SEQ_SA_C_reg   (*((volatile unsigned int*) VO_WB_SEQ_SA_C_reg))
+#define VO_WB_SEQ_SA_C_inst_adr                                                      "0x002B"
+#define VO_WB_SEQ_SA_C_inst                                                          0x002B
+#define VO_WB_SEQ_SA_C_a_shift                                                       (0)
+#define VO_WB_SEQ_SA_C_a_mask                                                        (0x7FFFFFFF)
+#define VO_WB_SEQ_SA_C_a(data)                                                       (0x7FFFFFFF&((data)<<0))
+#define VO_WB_SEQ_SA_C_a_src(data)                                                   ((0x7FFFFFFF&(data))>>0)
+#define VO_WB_SEQ_SA_C_get_a(data)                                                   ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_WB_SEQ_PITCH_C                                                            0x180054B0
+#define VO_WB_SEQ_PITCH_C_reg_addr                                                   "0xB80054B0"
+#define VO_WB_SEQ_PITCH_C_reg                                                        0xB80054B0
+#define set_VO_WB_SEQ_PITCH_C_reg(data)   (*((volatile unsigned int*) VO_WB_SEQ_PITCH_C_reg)=data)
+#define get_VO_WB_SEQ_PITCH_C_reg   (*((volatile unsigned int*) VO_WB_SEQ_PITCH_C_reg))
+#define VO_WB_SEQ_PITCH_C_inst_adr                                                   "0x002C"
+#define VO_WB_SEQ_PITCH_C_inst                                                       0x002C
+#define VO_WB_SEQ_PITCH_C_p_shift                                                    (0)
+#define VO_WB_SEQ_PITCH_C_p_mask                                                     (0x0000FFFF)
+#define VO_WB_SEQ_PITCH_C_p(data)                                                    (0x0000FFFF&((data)<<0))
+#define VO_WB_SEQ_PITCH_C_p_src(data)                                                ((0x0000FFFF&(data))>>0)
+#define VO_WB_SEQ_PITCH_C_get_p(data)                                                ((0x0000FFFF&(data))>>0)
+
+
+#define VO_DD_SIZE                                                                   0x180054B4
+#define VO_DD_SIZE_reg_addr                                                          "0xB80054B4"
+#define VO_DD_SIZE_reg                                                               0xB80054B4
+#define set_VO_DD_SIZE_reg(data)   (*((volatile unsigned int*) VO_DD_SIZE_reg)=data)
+#define get_VO_DD_SIZE_reg   (*((volatile unsigned int*) VO_DD_SIZE_reg))
+#define VO_DD_SIZE_inst_adr                                                          "0x002D"
+#define VO_DD_SIZE_inst                                                              0x002D
+#define VO_DD_SIZE_w_shift                                                           (12)
+#define VO_DD_SIZE_w_mask                                                            (0x01FFF000)
+#define VO_DD_SIZE_w(data)                                                           (0x01FFF000&((data)<<12))
+#define VO_DD_SIZE_w_src(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_DD_SIZE_get_w(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_DD_SIZE_h_shift                                                           (0)
+#define VO_DD_SIZE_h_mask                                                            (0x00000FFF)
+#define VO_DD_SIZE_h(data)                                                           (0x00000FFF&((data)<<0))
+#define VO_DD_SIZE_h_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VO_DD_SIZE_get_h(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VO_WB_SIZE                                                                   0x180054B8
+#define VO_WB_SIZE_reg_addr                                                          "0xB80054B8"
+#define VO_WB_SIZE_reg                                                               0xB80054B8
+#define set_VO_WB_SIZE_reg(data)   (*((volatile unsigned int*) VO_WB_SIZE_reg)=data)
+#define get_VO_WB_SIZE_reg   (*((volatile unsigned int*) VO_WB_SIZE_reg))
+#define VO_WB_SIZE_inst_adr                                                          "0x002E"
+#define VO_WB_SIZE_inst                                                              0x002E
+#define VO_WB_SIZE_w_shift                                                           (12)
+#define VO_WB_SIZE_w_mask                                                            (0x01FFF000)
+#define VO_WB_SIZE_w(data)                                                           (0x01FFF000&((data)<<12))
+#define VO_WB_SIZE_w_src(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_WB_SIZE_get_w(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_WB_SIZE_h_shift                                                           (0)
+#define VO_WB_SIZE_h_mask                                                            (0x00000FFF)
+#define VO_WB_SIZE_h(data)                                                           (0x00000FFF&((data)<<0))
+#define VO_WB_SIZE_h_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VO_WB_SIZE_get_h(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VO_FS_SIZE                                                                   0x180054BC
+#define VO_FS_SIZE_reg_addr                                                          "0xB80054BC"
+#define VO_FS_SIZE_reg                                                               0xB80054BC
+#define set_VO_FS_SIZE_reg(data)   (*((volatile unsigned int*) VO_FS_SIZE_reg)=data)
+#define get_VO_FS_SIZE_reg   (*((volatile unsigned int*) VO_FS_SIZE_reg))
+#define VO_FS_SIZE_inst_adr                                                          "0x002F"
+#define VO_FS_SIZE_inst                                                              0x002F
+#define VO_FS_SIZE_w_shift                                                           (12)
+#define VO_FS_SIZE_w_mask                                                            (0x01FFF000)
+#define VO_FS_SIZE_w(data)                                                           (0x01FFF000&((data)<<12))
+#define VO_FS_SIZE_w_src(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_FS_SIZE_get_w(data)                                                       ((0x01FFF000&(data))>>12)
+#define VO_FS_SIZE_h_shift                                                           (0)
+#define VO_FS_SIZE_h_mask                                                            (0x00000FFF)
+#define VO_FS_SIZE_h(data)                                                           (0x00000FFF&((data)<<0))
+#define VO_FS_SIZE_h_src(data)                                                       ((0x00000FFF&(data))>>0)
+#define VO_FS_SIZE_get_h(data)                                                       ((0x00000FFF&(data))>>0)
+
+
+#define VO_WB_TPC                                                                    0x180054C0
+#define VO_WB_TPC_reg_addr                                                           "0xB80054C0"
+#define VO_WB_TPC_reg                                                                0xB80054C0
+#define set_VO_WB_TPC_reg(data)   (*((volatile unsigned int*) VO_WB_TPC_reg)=data)
+#define get_VO_WB_TPC_reg   (*((volatile unsigned int*) VO_WB_TPC_reg))
+#define VO_WB_TPC_inst_adr                                                           "0x0030"
+#define VO_WB_TPC_inst                                                               0x0030
+#define VO_WB_TPC_num_shift                                                          (0)
+#define VO_WB_TPC_num_mask                                                           (0x000000FF)
+#define VO_WB_TPC_num(data)                                                          (0x000000FF&((data)<<0))
+#define VO_WB_TPC_num_src(data)                                                      ((0x000000FF&(data))>>0)
+#define VO_WB_TPC_get_num(data)                                                      ((0x000000FF&(data))>>0)
+
+
+#define VO_DDWB_VSI                                                                  0x180054C4
+#define VO_DDWB_VSI_reg_addr                                                         "0xB80054C4"
+#define VO_DDWB_VSI_reg                                                              0xB80054C4
+#define set_VO_DDWB_VSI_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSI_reg)=data)
+#define get_VO_DDWB_VSI_reg   (*((volatile unsigned int*) VO_DDWB_VSI_reg))
+#define VO_DDWB_VSI_inst_adr                                                         "0x0031"
+#define VO_DDWB_VSI_inst                                                             0x0031
+#define VO_DDWB_VSI_offset_shift                                                     (16)
+#define VO_DDWB_VSI_offset_mask                                                      (0x1FFF0000)
+#define VO_DDWB_VSI_offset(data)                                                     (0x1FFF0000&((data)<<16))
+#define VO_DDWB_VSI_offset_src(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_DDWB_VSI_get_offset(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_DDWB_VSI_phase_shift                                                      (0)
+#define VO_DDWB_VSI_phase_mask                                                       (0x0000FFFF)
+#define VO_DDWB_VSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_DDWB_VSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_DDWB_VSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_DDWB_VSD                                                                  0x180054C8
+#define VO_DDWB_VSD_reg_addr                                                         "0xB80054C8"
+#define VO_DDWB_VSD_reg                                                              0xB80054C8
+#define set_VO_DDWB_VSD_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSD_reg)=data)
+#define get_VO_DDWB_VSD_reg   (*((volatile unsigned int*) VO_DDWB_VSD_reg))
+#define VO_DDWB_VSD_inst_adr                                                         "0x0032"
+#define VO_DDWB_VSD_inst                                                             0x0032
+#define VO_DDWB_VSD_delta_shift                                                      (0)
+#define VO_DDWB_VSD_delta_mask                                                       (0x001FFFFF)
+#define VO_DDWB_VSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_DDWB_VSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_DDWB_VSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_DDWB_VSD_H                                                                0x180054CC
+#define VO_DDWB_VSD_H_reg_addr                                                       "0xB80054CC"
+#define VO_DDWB_VSD_H_reg                                                            0xB80054CC
+#define set_VO_DDWB_VSD_H_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSD_H_reg)=data)
+#define get_VO_DDWB_VSD_H_reg   (*((volatile unsigned int*) VO_DDWB_VSD_H_reg))
+#define VO_DDWB_VSD_H_inst_adr                                                       "0x0033"
+#define VO_DDWB_VSD_H_inst                                                           0x0033
+#define VO_DDWB_VSD_H_out_shift                                                      (0)
+#define VO_DDWB_VSD_H_out_mask                                                       (0x00000FFF)
+#define VO_DDWB_VSD_H_out(data)                                                      (0x00000FFF&((data)<<0))
+#define VO_DDWB_VSD_H_out_src(data)                                                  ((0x00000FFF&(data))>>0)
+#define VO_DDWB_VSD_H_get_out(data)                                                  ((0x00000FFF&(data))>>0)
+
+
+#define VO_DDWB_VSYC_0                                                               0x180054D0
+#define VO_DDWB_VSYC_1                                                               0x180054D4
+#define VO_DDWB_VSYC_2                                                               0x180054D8
+#define VO_DDWB_VSYC_3                                                               0x180054DC
+#define VO_DDWB_VSYC_4                                                               0x180054E0
+#define VO_DDWB_VSYC_5                                                               0x180054E4
+#define VO_DDWB_VSYC_6                                                               0x180054E8
+#define VO_DDWB_VSYC_7                                                               0x180054EC
+#define VO_DDWB_VSYC_0_reg_addr                                                      "0xB80054D0"
+#define VO_DDWB_VSYC_1_reg_addr                                                      "0xB80054D4"
+#define VO_DDWB_VSYC_2_reg_addr                                                      "0xB80054D8"
+#define VO_DDWB_VSYC_3_reg_addr                                                      "0xB80054DC"
+#define VO_DDWB_VSYC_4_reg_addr                                                      "0xB80054E0"
+#define VO_DDWB_VSYC_5_reg_addr                                                      "0xB80054E4"
+#define VO_DDWB_VSYC_6_reg_addr                                                      "0xB80054E8"
+#define VO_DDWB_VSYC_7_reg_addr                                                      "0xB80054EC"
+#define VO_DDWB_VSYC_0_reg                                                           0xB80054D0
+#define VO_DDWB_VSYC_1_reg                                                           0xB80054D4
+#define VO_DDWB_VSYC_2_reg                                                           0xB80054D8
+#define VO_DDWB_VSYC_3_reg                                                           0xB80054DC
+#define VO_DDWB_VSYC_4_reg                                                           0xB80054E0
+#define VO_DDWB_VSYC_5_reg                                                           0xB80054E4
+#define VO_DDWB_VSYC_6_reg                                                           0xB80054E8
+#define VO_DDWB_VSYC_7_reg                                                           0xB80054EC
+#define set_VO_DDWB_VSYC_0_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_0_reg)=data)
+#define set_VO_DDWB_VSYC_1_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_1_reg)=data)
+#define set_VO_DDWB_VSYC_2_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_2_reg)=data)
+#define set_VO_DDWB_VSYC_3_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_3_reg)=data)
+#define set_VO_DDWB_VSYC_4_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_4_reg)=data)
+#define set_VO_DDWB_VSYC_5_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_5_reg)=data)
+#define set_VO_DDWB_VSYC_6_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_6_reg)=data)
+#define set_VO_DDWB_VSYC_7_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSYC_7_reg)=data)
+#define get_VO_DDWB_VSYC_0_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_0_reg))
+#define get_VO_DDWB_VSYC_1_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_1_reg))
+#define get_VO_DDWB_VSYC_2_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_2_reg))
+#define get_VO_DDWB_VSYC_3_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_3_reg))
+#define get_VO_DDWB_VSYC_4_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_4_reg))
+#define get_VO_DDWB_VSYC_5_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_5_reg))
+#define get_VO_DDWB_VSYC_6_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_6_reg))
+#define get_VO_DDWB_VSYC_7_reg   (*((volatile unsigned int*) VO_DDWB_VSYC_7_reg))
+#define VO_DDWB_VSYC_0_inst_adr                                                      "0x0034"
+#define VO_DDWB_VSYC_1_inst_adr                                                      "0x0035"
+#define VO_DDWB_VSYC_2_inst_adr                                                      "0x0036"
+#define VO_DDWB_VSYC_3_inst_adr                                                      "0x0037"
+#define VO_DDWB_VSYC_4_inst_adr                                                      "0x0038"
+#define VO_DDWB_VSYC_5_inst_adr                                                      "0x0039"
+#define VO_DDWB_VSYC_6_inst_adr                                                      "0x003A"
+#define VO_DDWB_VSYC_7_inst_adr                                                      "0x003B"
+#define VO_DDWB_VSYC_0_inst                                                          0x0034
+#define VO_DDWB_VSYC_1_inst                                                          0x0035
+#define VO_DDWB_VSYC_2_inst                                                          0x0036
+#define VO_DDWB_VSYC_3_inst                                                          0x0037
+#define VO_DDWB_VSYC_4_inst                                                          0x0038
+#define VO_DDWB_VSYC_5_inst                                                          0x0039
+#define VO_DDWB_VSYC_6_inst                                                          0x003A
+#define VO_DDWB_VSYC_7_inst                                                          0x003B
+#define VO_DDWB_VSYC_c1_shift                                                        (16)
+#define VO_DDWB_VSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_DDWB_VSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_DDWB_VSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_VSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_VSYC_c0_shift                                                        (0)
+#define VO_DDWB_VSYC_c0_mask                                                         (0x00003FFF)
+#define VO_DDWB_VSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_DDWB_VSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_DDWB_VSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_DDWB_VSCC_0                                                               0x180054F0
+#define VO_DDWB_VSCC_1                                                               0x180054F4
+#define VO_DDWB_VSCC_2                                                               0x180054F8
+#define VO_DDWB_VSCC_3                                                               0x180054FC
+#define VO_DDWB_VSCC_4                                                               0x18005500
+#define VO_DDWB_VSCC_5                                                               0x18005504
+#define VO_DDWB_VSCC_6                                                               0x18005508
+#define VO_DDWB_VSCC_7                                                               0x1800550C
+#define VO_DDWB_VSCC_0_reg_addr                                                      "0xB80054F0"
+#define VO_DDWB_VSCC_1_reg_addr                                                      "0xB80054F4"
+#define VO_DDWB_VSCC_2_reg_addr                                                      "0xB80054F8"
+#define VO_DDWB_VSCC_3_reg_addr                                                      "0xB80054FC"
+#define VO_DDWB_VSCC_4_reg_addr                                                      "0xB8005500"
+#define VO_DDWB_VSCC_5_reg_addr                                                      "0xB8005504"
+#define VO_DDWB_VSCC_6_reg_addr                                                      "0xB8005508"
+#define VO_DDWB_VSCC_7_reg_addr                                                      "0xB800550C"
+#define VO_DDWB_VSCC_0_reg                                                           0xB80054F0
+#define VO_DDWB_VSCC_1_reg                                                           0xB80054F4
+#define VO_DDWB_VSCC_2_reg                                                           0xB80054F8
+#define VO_DDWB_VSCC_3_reg                                                           0xB80054FC
+#define VO_DDWB_VSCC_4_reg                                                           0xB8005500
+#define VO_DDWB_VSCC_5_reg                                                           0xB8005504
+#define VO_DDWB_VSCC_6_reg                                                           0xB8005508
+#define VO_DDWB_VSCC_7_reg                                                           0xB800550C
+#define set_VO_DDWB_VSCC_0_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_0_reg)=data)
+#define set_VO_DDWB_VSCC_1_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_1_reg)=data)
+#define set_VO_DDWB_VSCC_2_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_2_reg)=data)
+#define set_VO_DDWB_VSCC_3_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_3_reg)=data)
+#define set_VO_DDWB_VSCC_4_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_4_reg)=data)
+#define set_VO_DDWB_VSCC_5_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_5_reg)=data)
+#define set_VO_DDWB_VSCC_6_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_6_reg)=data)
+#define set_VO_DDWB_VSCC_7_reg(data)   (*((volatile unsigned int*) VO_DDWB_VSCC_7_reg)=data)
+#define get_VO_DDWB_VSCC_0_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_0_reg))
+#define get_VO_DDWB_VSCC_1_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_1_reg))
+#define get_VO_DDWB_VSCC_2_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_2_reg))
+#define get_VO_DDWB_VSCC_3_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_3_reg))
+#define get_VO_DDWB_VSCC_4_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_4_reg))
+#define get_VO_DDWB_VSCC_5_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_5_reg))
+#define get_VO_DDWB_VSCC_6_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_6_reg))
+#define get_VO_DDWB_VSCC_7_reg   (*((volatile unsigned int*) VO_DDWB_VSCC_7_reg))
+#define VO_DDWB_VSCC_0_inst_adr                                                      "0x003C"
+#define VO_DDWB_VSCC_1_inst_adr                                                      "0x003D"
+#define VO_DDWB_VSCC_2_inst_adr                                                      "0x003E"
+#define VO_DDWB_VSCC_3_inst_adr                                                      "0x003F"
+#define VO_DDWB_VSCC_4_inst_adr                                                      "0x0040"
+#define VO_DDWB_VSCC_5_inst_adr                                                      "0x0041"
+#define VO_DDWB_VSCC_6_inst_adr                                                      "0x0042"
+#define VO_DDWB_VSCC_7_inst_adr                                                      "0x0043"
+#define VO_DDWB_VSCC_0_inst                                                          0x003C
+#define VO_DDWB_VSCC_1_inst                                                          0x003D
+#define VO_DDWB_VSCC_2_inst                                                          0x003E
+#define VO_DDWB_VSCC_3_inst                                                          0x003F
+#define VO_DDWB_VSCC_4_inst                                                          0x0040
+#define VO_DDWB_VSCC_5_inst                                                          0x0041
+#define VO_DDWB_VSCC_6_inst                                                          0x0042
+#define VO_DDWB_VSCC_7_inst                                                          0x0043
+#define VO_DDWB_VSCC_c1_shift                                                        (16)
+#define VO_DDWB_VSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_DDWB_VSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_DDWB_VSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_VSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_VSCC_c0_shift                                                        (0)
+#define VO_DDWB_VSCC_c0_mask                                                         (0x00003FFF)
+#define VO_DDWB_VSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_DDWB_VSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_DDWB_VSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_DDWB_HSI                                                                  0x18005510
+#define VO_DDWB_HSI_reg_addr                                                         "0xB8005510"
+#define VO_DDWB_HSI_reg                                                              0xB8005510
+#define set_VO_DDWB_HSI_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSI_reg)=data)
+#define get_VO_DDWB_HSI_reg   (*((volatile unsigned int*) VO_DDWB_HSI_reg))
+#define VO_DDWB_HSI_inst_adr                                                         "0x0044"
+#define VO_DDWB_HSI_inst                                                             0x0044
+#define VO_DDWB_HSI_offset_shift                                                     (16)
+#define VO_DDWB_HSI_offset_mask                                                      (0x1FFF0000)
+#define VO_DDWB_HSI_offset(data)                                                     (0x1FFF0000&((data)<<16))
+#define VO_DDWB_HSI_offset_src(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_DDWB_HSI_get_offset(data)                                                 ((0x1FFF0000&(data))>>16)
+#define VO_DDWB_HSI_phase_shift                                                      (0)
+#define VO_DDWB_HSI_phase_mask                                                       (0x0000FFFF)
+#define VO_DDWB_HSI_phase(data)                                                      (0x0000FFFF&((data)<<0))
+#define VO_DDWB_HSI_phase_src(data)                                                  ((0x0000FFFF&(data))>>0)
+#define VO_DDWB_HSI_get_phase(data)                                                  ((0x0000FFFF&(data))>>0)
+
+
+#define VO_DDWB_HSD                                                                  0x18005514
+#define VO_DDWB_HSD_reg_addr                                                         "0xB8005514"
+#define VO_DDWB_HSD_reg                                                              0xB8005514
+#define set_VO_DDWB_HSD_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSD_reg)=data)
+#define get_VO_DDWB_HSD_reg   (*((volatile unsigned int*) VO_DDWB_HSD_reg))
+#define VO_DDWB_HSD_inst_adr                                                         "0x0045"
+#define VO_DDWB_HSD_inst                                                             0x0045
+#define VO_DDWB_HSD_delta_shift                                                      (0)
+#define VO_DDWB_HSD_delta_mask                                                       (0x001FFFFF)
+#define VO_DDWB_HSD_delta(data)                                                      (0x001FFFFF&((data)<<0))
+#define VO_DDWB_HSD_delta_src(data)                                                  ((0x001FFFFF&(data))>>0)
+#define VO_DDWB_HSD_get_delta(data)                                                  ((0x001FFFFF&(data))>>0)
+
+
+#define VO_DDWB_HSD_W                                                                0x18005518
+#define VO_DDWB_HSD_W_reg_addr                                                       "0xB8005518"
+#define VO_DDWB_HSD_W_reg                                                            0xB8005518
+#define set_VO_DDWB_HSD_W_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSD_W_reg)=data)
+#define get_VO_DDWB_HSD_W_reg   (*((volatile unsigned int*) VO_DDWB_HSD_W_reg))
+#define VO_DDWB_HSD_W_inst_adr                                                       "0x0046"
+#define VO_DDWB_HSD_W_inst                                                           0x0046
+#define VO_DDWB_HSD_W_out_shift                                                      (0)
+#define VO_DDWB_HSD_W_out_mask                                                       (0x00001FFF)
+#define VO_DDWB_HSD_W_out(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_DDWB_HSD_W_out_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_DDWB_HSD_W_get_out(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_DDWB_HSYC_0                                                               0x1800551C
+#define VO_DDWB_HSYC_1                                                               0x18005520
+#define VO_DDWB_HSYC_2                                                               0x18005524
+#define VO_DDWB_HSYC_3                                                               0x18005528
+#define VO_DDWB_HSYC_4                                                               0x1800552C
+#define VO_DDWB_HSYC_5                                                               0x18005530
+#define VO_DDWB_HSYC_6                                                               0x18005534
+#define VO_DDWB_HSYC_7                                                               0x18005538
+#define VO_DDWB_HSYC_8                                                               0x1800553C
+#define VO_DDWB_HSYC_9                                                               0x18005540
+#define VO_DDWB_HSYC_10                                                               0x18005544
+#define VO_DDWB_HSYC_11                                                               0x18005548
+#define VO_DDWB_HSYC_12                                                               0x1800554C
+#define VO_DDWB_HSYC_13                                                               0x18005550
+#define VO_DDWB_HSYC_14                                                               0x18005554
+#define VO_DDWB_HSYC_15                                                               0x18005558
+#define VO_DDWB_HSYC_0_reg_addr                                                      "0xB800551C"
+#define VO_DDWB_HSYC_1_reg_addr                                                      "0xB8005520"
+#define VO_DDWB_HSYC_2_reg_addr                                                      "0xB8005524"
+#define VO_DDWB_HSYC_3_reg_addr                                                      "0xB8005528"
+#define VO_DDWB_HSYC_4_reg_addr                                                      "0xB800552C"
+#define VO_DDWB_HSYC_5_reg_addr                                                      "0xB8005530"
+#define VO_DDWB_HSYC_6_reg_addr                                                      "0xB8005534"
+#define VO_DDWB_HSYC_7_reg_addr                                                      "0xB8005538"
+#define VO_DDWB_HSYC_8_reg_addr                                                      "0xB800553C"
+#define VO_DDWB_HSYC_9_reg_addr                                                      "0xB8005540"
+#define VO_DDWB_HSYC_10_reg_addr                                                      "0xB8005544"
+#define VO_DDWB_HSYC_11_reg_addr                                                      "0xB8005548"
+#define VO_DDWB_HSYC_12_reg_addr                                                      "0xB800554C"
+#define VO_DDWB_HSYC_13_reg_addr                                                      "0xB8005550"
+#define VO_DDWB_HSYC_14_reg_addr                                                      "0xB8005554"
+#define VO_DDWB_HSYC_15_reg_addr                                                      "0xB8005558"
+#define VO_DDWB_HSYC_0_reg                                                           0xB800551C
+#define VO_DDWB_HSYC_1_reg                                                           0xB8005520
+#define VO_DDWB_HSYC_2_reg                                                           0xB8005524
+#define VO_DDWB_HSYC_3_reg                                                           0xB8005528
+#define VO_DDWB_HSYC_4_reg                                                           0xB800552C
+#define VO_DDWB_HSYC_5_reg                                                           0xB8005530
+#define VO_DDWB_HSYC_6_reg                                                           0xB8005534
+#define VO_DDWB_HSYC_7_reg                                                           0xB8005538
+#define VO_DDWB_HSYC_8_reg                                                           0xB800553C
+#define VO_DDWB_HSYC_9_reg                                                           0xB8005540
+#define VO_DDWB_HSYC_10_reg                                                           0xB8005544
+#define VO_DDWB_HSYC_11_reg                                                           0xB8005548
+#define VO_DDWB_HSYC_12_reg                                                           0xB800554C
+#define VO_DDWB_HSYC_13_reg                                                           0xB8005550
+#define VO_DDWB_HSYC_14_reg                                                           0xB8005554
+#define VO_DDWB_HSYC_15_reg                                                           0xB8005558
+#define set_VO_DDWB_HSYC_0_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_0_reg)=data)
+#define set_VO_DDWB_HSYC_1_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_1_reg)=data)
+#define set_VO_DDWB_HSYC_2_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_2_reg)=data)
+#define set_VO_DDWB_HSYC_3_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_3_reg)=data)
+#define set_VO_DDWB_HSYC_4_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_4_reg)=data)
+#define set_VO_DDWB_HSYC_5_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_5_reg)=data)
+#define set_VO_DDWB_HSYC_6_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_6_reg)=data)
+#define set_VO_DDWB_HSYC_7_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_7_reg)=data)
+#define set_VO_DDWB_HSYC_8_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_8_reg)=data)
+#define set_VO_DDWB_HSYC_9_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_9_reg)=data)
+#define set_VO_DDWB_HSYC_10_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_10_reg)=data)
+#define set_VO_DDWB_HSYC_11_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_11_reg)=data)
+#define set_VO_DDWB_HSYC_12_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_12_reg)=data)
+#define set_VO_DDWB_HSYC_13_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_13_reg)=data)
+#define set_VO_DDWB_HSYC_14_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_14_reg)=data)
+#define set_VO_DDWB_HSYC_15_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSYC_15_reg)=data)
+#define get_VO_DDWB_HSYC_0_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_0_reg))
+#define get_VO_DDWB_HSYC_1_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_1_reg))
+#define get_VO_DDWB_HSYC_2_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_2_reg))
+#define get_VO_DDWB_HSYC_3_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_3_reg))
+#define get_VO_DDWB_HSYC_4_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_4_reg))
+#define get_VO_DDWB_HSYC_5_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_5_reg))
+#define get_VO_DDWB_HSYC_6_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_6_reg))
+#define get_VO_DDWB_HSYC_7_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_7_reg))
+#define get_VO_DDWB_HSYC_8_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_8_reg))
+#define get_VO_DDWB_HSYC_9_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_9_reg))
+#define get_VO_DDWB_HSYC_10_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_10_reg))
+#define get_VO_DDWB_HSYC_11_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_11_reg))
+#define get_VO_DDWB_HSYC_12_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_12_reg))
+#define get_VO_DDWB_HSYC_13_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_13_reg))
+#define get_VO_DDWB_HSYC_14_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_14_reg))
+#define get_VO_DDWB_HSYC_15_reg   (*((volatile unsigned int*) VO_DDWB_HSYC_15_reg))
+#define VO_DDWB_HSYC_0_inst_adr                                                      "0x0047"
+#define VO_DDWB_HSYC_1_inst_adr                                                      "0x0048"
+#define VO_DDWB_HSYC_2_inst_adr                                                      "0x0049"
+#define VO_DDWB_HSYC_3_inst_adr                                                      "0x004A"
+#define VO_DDWB_HSYC_4_inst_adr                                                      "0x004B"
+#define VO_DDWB_HSYC_5_inst_adr                                                      "0x004C"
+#define VO_DDWB_HSYC_6_inst_adr                                                      "0x004D"
+#define VO_DDWB_HSYC_7_inst_adr                                                      "0x004E"
+#define VO_DDWB_HSYC_8_inst_adr                                                      "0x004F"
+#define VO_DDWB_HSYC_9_inst_adr                                                      "0x0050"
+#define VO_DDWB_HSYC_10_inst_adr                                                      "0x0051"
+#define VO_DDWB_HSYC_11_inst_adr                                                      "0x0052"
+#define VO_DDWB_HSYC_12_inst_adr                                                      "0x0053"
+#define VO_DDWB_HSYC_13_inst_adr                                                      "0x0054"
+#define VO_DDWB_HSYC_14_inst_adr                                                      "0x0055"
+#define VO_DDWB_HSYC_15_inst_adr                                                      "0x0056"
+#define VO_DDWB_HSYC_0_inst                                                          0x0047
+#define VO_DDWB_HSYC_1_inst                                                          0x0048
+#define VO_DDWB_HSYC_2_inst                                                          0x0049
+#define VO_DDWB_HSYC_3_inst                                                          0x004A
+#define VO_DDWB_HSYC_4_inst                                                          0x004B
+#define VO_DDWB_HSYC_5_inst                                                          0x004C
+#define VO_DDWB_HSYC_6_inst                                                          0x004D
+#define VO_DDWB_HSYC_7_inst                                                          0x004E
+#define VO_DDWB_HSYC_8_inst                                                          0x004F
+#define VO_DDWB_HSYC_9_inst                                                          0x0050
+#define VO_DDWB_HSYC_10_inst                                                          0x0051
+#define VO_DDWB_HSYC_11_inst                                                          0x0052
+#define VO_DDWB_HSYC_12_inst                                                          0x0053
+#define VO_DDWB_HSYC_13_inst                                                          0x0054
+#define VO_DDWB_HSYC_14_inst                                                          0x0055
+#define VO_DDWB_HSYC_15_inst                                                          0x0056
+#define VO_DDWB_HSYC_c1_shift                                                        (16)
+#define VO_DDWB_HSYC_c1_mask                                                         (0x3FFF0000)
+#define VO_DDWB_HSYC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_DDWB_HSYC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_HSYC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_HSYC_c0_shift                                                        (0)
+#define VO_DDWB_HSYC_c0_mask                                                         (0x00003FFF)
+#define VO_DDWB_HSYC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_DDWB_HSYC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_DDWB_HSYC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_DDWB_HSCC_0                                                               0x1800555C
+#define VO_DDWB_HSCC_1                                                               0x18005560
+#define VO_DDWB_HSCC_2                                                               0x18005564
+#define VO_DDWB_HSCC_3                                                               0x18005568
+#define VO_DDWB_HSCC_4                                                               0x1800556C
+#define VO_DDWB_HSCC_5                                                               0x18005570
+#define VO_DDWB_HSCC_6                                                               0x18005574
+#define VO_DDWB_HSCC_7                                                               0x18005578
+#define VO_DDWB_HSCC_0_reg_addr                                                      "0xB800555C"
+#define VO_DDWB_HSCC_1_reg_addr                                                      "0xB8005560"
+#define VO_DDWB_HSCC_2_reg_addr                                                      "0xB8005564"
+#define VO_DDWB_HSCC_3_reg_addr                                                      "0xB8005568"
+#define VO_DDWB_HSCC_4_reg_addr                                                      "0xB800556C"
+#define VO_DDWB_HSCC_5_reg_addr                                                      "0xB8005570"
+#define VO_DDWB_HSCC_6_reg_addr                                                      "0xB8005574"
+#define VO_DDWB_HSCC_7_reg_addr                                                      "0xB8005578"
+#define VO_DDWB_HSCC_0_reg                                                           0xB800555C
+#define VO_DDWB_HSCC_1_reg                                                           0xB8005560
+#define VO_DDWB_HSCC_2_reg                                                           0xB8005564
+#define VO_DDWB_HSCC_3_reg                                                           0xB8005568
+#define VO_DDWB_HSCC_4_reg                                                           0xB800556C
+#define VO_DDWB_HSCC_5_reg                                                           0xB8005570
+#define VO_DDWB_HSCC_6_reg                                                           0xB8005574
+#define VO_DDWB_HSCC_7_reg                                                           0xB8005578
+#define set_VO_DDWB_HSCC_0_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_0_reg)=data)
+#define set_VO_DDWB_HSCC_1_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_1_reg)=data)
+#define set_VO_DDWB_HSCC_2_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_2_reg)=data)
+#define set_VO_DDWB_HSCC_3_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_3_reg)=data)
+#define set_VO_DDWB_HSCC_4_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_4_reg)=data)
+#define set_VO_DDWB_HSCC_5_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_5_reg)=data)
+#define set_VO_DDWB_HSCC_6_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_6_reg)=data)
+#define set_VO_DDWB_HSCC_7_reg(data)   (*((volatile unsigned int*) VO_DDWB_HSCC_7_reg)=data)
+#define get_VO_DDWB_HSCC_0_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_0_reg))
+#define get_VO_DDWB_HSCC_1_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_1_reg))
+#define get_VO_DDWB_HSCC_2_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_2_reg))
+#define get_VO_DDWB_HSCC_3_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_3_reg))
+#define get_VO_DDWB_HSCC_4_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_4_reg))
+#define get_VO_DDWB_HSCC_5_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_5_reg))
+#define get_VO_DDWB_HSCC_6_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_6_reg))
+#define get_VO_DDWB_HSCC_7_reg   (*((volatile unsigned int*) VO_DDWB_HSCC_7_reg))
+#define VO_DDWB_HSCC_0_inst_adr                                                      "0x0057"
+#define VO_DDWB_HSCC_1_inst_adr                                                      "0x0058"
+#define VO_DDWB_HSCC_2_inst_adr                                                      "0x0059"
+#define VO_DDWB_HSCC_3_inst_adr                                                      "0x005A"
+#define VO_DDWB_HSCC_4_inst_adr                                                      "0x005B"
+#define VO_DDWB_HSCC_5_inst_adr                                                      "0x005C"
+#define VO_DDWB_HSCC_6_inst_adr                                                      "0x005D"
+#define VO_DDWB_HSCC_7_inst_adr                                                      "0x005E"
+#define VO_DDWB_HSCC_0_inst                                                          0x0057
+#define VO_DDWB_HSCC_1_inst                                                          0x0058
+#define VO_DDWB_HSCC_2_inst                                                          0x0059
+#define VO_DDWB_HSCC_3_inst                                                          0x005A
+#define VO_DDWB_HSCC_4_inst                                                          0x005B
+#define VO_DDWB_HSCC_5_inst                                                          0x005C
+#define VO_DDWB_HSCC_6_inst                                                          0x005D
+#define VO_DDWB_HSCC_7_inst                                                          0x005E
+#define VO_DDWB_HSCC_c1_shift                                                        (16)
+#define VO_DDWB_HSCC_c1_mask                                                         (0x3FFF0000)
+#define VO_DDWB_HSCC_c1(data)                                                        (0x3FFF0000&((data)<<16))
+#define VO_DDWB_HSCC_c1_src(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_HSCC_get_c1(data)                                                    ((0x3FFF0000&(data))>>16)
+#define VO_DDWB_HSCC_c0_shift                                                        (0)
+#define VO_DDWB_HSCC_c0_mask                                                         (0x00003FFF)
+#define VO_DDWB_HSCC_c0(data)                                                        (0x00003FFF&((data)<<0))
+#define VO_DDWB_HSCC_c0_src(data)                                                    ((0x00003FFF&(data))>>0)
+#define VO_DDWB_HSCC_get_c0(data)                                                    ((0x00003FFF&(data))>>0)
+
+
+#define VO_VBI1                                                                      0x1800557C
+#define VO_VBI1_reg_addr                                                             "0xB800557C"
+#define VO_VBI1_reg                                                                  0xB800557C
+#define set_VO_VBI1_reg(data)   (*((volatile unsigned int*) VO_VBI1_reg)=data)
+#define get_VO_VBI1_reg   (*((volatile unsigned int*) VO_VBI1_reg))
+#define VO_VBI1_inst_adr                                                             "0x005F"
+#define VO_VBI1_inst                                                                 0x005F
+#define VO_VBI1_a_shift                                                              (0)
+#define VO_VBI1_a_mask                                                               (0x7FFFFFFF)
+#define VO_VBI1_a(data)                                                              (0x7FFFFFFF&((data)<<0))
+#define VO_VBI1_a_src(data)                                                          ((0x7FFFFFFF&(data))>>0)
+#define VO_VBI1_get_a(data)                                                          ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_VBI1_SIZE                                                                 0x18005580
+#define VO_VBI1_SIZE_reg_addr                                                        "0xB8005580"
+#define VO_VBI1_SIZE_reg                                                             0xB8005580
+#define set_VO_VBI1_SIZE_reg(data)   (*((volatile unsigned int*) VO_VBI1_SIZE_reg)=data)
+#define get_VO_VBI1_SIZE_reg   (*((volatile unsigned int*) VO_VBI1_SIZE_reg))
+#define VO_VBI1_SIZE_inst_adr                                                        "0x0060"
+#define VO_VBI1_SIZE_inst                                                            0x0060
+#define VO_VBI1_SIZE_l_shift                                                         (0)
+#define VO_VBI1_SIZE_l_mask                                                          (0x0003FFFF)
+#define VO_VBI1_SIZE_l(data)                                                         (0x0003FFFF&((data)<<0))
+#define VO_VBI1_SIZE_l_src(data)                                                     ((0x0003FFFF&(data))>>0)
+#define VO_VBI1_SIZE_get_l(data)                                                     ((0x0003FFFF&(data))>>0)
+
+
+#define VO_VBI2                                                                      0x18005584
+#define VO_VBI2_reg_addr                                                             "0xB8005584"
+#define VO_VBI2_reg                                                                  0xB8005584
+#define set_VO_VBI2_reg(data)   (*((volatile unsigned int*) VO_VBI2_reg)=data)
+#define get_VO_VBI2_reg   (*((volatile unsigned int*) VO_VBI2_reg))
+#define VO_VBI2_inst_adr                                                             "0x0061"
+#define VO_VBI2_inst                                                                 0x0061
+#define VO_VBI2_a_shift                                                              (0)
+#define VO_VBI2_a_mask                                                               (0x7FFFFFFF)
+#define VO_VBI2_a(data)                                                              (0x7FFFFFFF&((data)<<0))
+#define VO_VBI2_a_src(data)                                                          ((0x7FFFFFFF&(data))>>0)
+#define VO_VBI2_get_a(data)                                                          ((0x7FFFFFFF&(data))>>0)
+
+
+#define VO_VBI2_SIZE                                                                 0x18005588
+#define VO_VBI2_SIZE_reg_addr                                                        "0xB8005588"
+#define VO_VBI2_SIZE_reg                                                             0xB8005588
+#define set_VO_VBI2_SIZE_reg(data)   (*((volatile unsigned int*) VO_VBI2_SIZE_reg)=data)
+#define get_VO_VBI2_SIZE_reg   (*((volatile unsigned int*) VO_VBI2_SIZE_reg))
+#define VO_VBI2_SIZE_inst_adr                                                        "0x0062"
+#define VO_VBI2_SIZE_inst                                                            0x0062
+#define VO_VBI2_SIZE_l_shift                                                         (0)
+#define VO_VBI2_SIZE_l_mask                                                          (0x0003FFFF)
+#define VO_VBI2_SIZE_l(data)                                                         (0x0003FFFF&((data)<<0))
+#define VO_VBI2_SIZE_l_src(data)                                                     ((0x0003FFFF&(data))>>0)
+#define VO_VBI2_SIZE_get_l(data)                                                     ((0x0003FFFF&(data))>>0)
+
+
+#define VO_DMA                                                                       0x1800558C
+#define VO_DMA_reg_addr                                                              "0xB800558C"
+#define VO_DMA_reg                                                                   0xB800558C
+#define set_VO_DMA_reg(data)   (*((volatile unsigned int*) VO_DMA_reg)=data)
+#define get_VO_DMA_reg   (*((volatile unsigned int*) VO_DMA_reg))
+#define VO_DMA_inst_adr                                                              "0x0063"
+#define VO_DMA_inst                                                                  0x0063
+#define VO_DMA_write_en4_shift                                                       (13)
+#define VO_DMA_write_en4_mask                                                        (0x00002000)
+#define VO_DMA_write_en4(data)                                                       (0x00002000&((data)<<13))
+#define VO_DMA_write_en4_src(data)                                                   ((0x00002000&(data))>>13)
+#define VO_DMA_get_write_en4(data)                                                   ((0x00002000&(data))>>13)
+#define VO_DMA_num_req_4_shift                                                       (12)
+#define VO_DMA_num_req_4_mask                                                        (0x00001000)
+#define VO_DMA_num_req_4(data)                                                       (0x00001000&((data)<<12))
+#define VO_DMA_num_req_4_src(data)                                                   ((0x00001000&(data))>>12)
+#define VO_DMA_get_num_req_4(data)                                                   ((0x00001000&(data))>>12)
+#define VO_DMA_write_en3_shift                                                       (11)
+#define VO_DMA_write_en3_mask                                                        (0x00000800)
+#define VO_DMA_write_en3(data)                                                       (0x00000800&((data)<<11))
+#define VO_DMA_write_en3_src(data)                                                   ((0x00000800&(data))>>11)
+#define VO_DMA_get_write_en3(data)                                                   ((0x00000800&(data))>>11)
+#define VO_DMA_dyn_id_shift                                                          (10)
+#define VO_DMA_dyn_id_mask                                                           (0x00000400)
+#define VO_DMA_dyn_id(data)                                                          (0x00000400&((data)<<10))
+#define VO_DMA_dyn_id_src(data)                                                      ((0x00000400&(data))>>10)
+#define VO_DMA_get_dyn_id(data)                                                      ((0x00000400&(data))>>10)
+#define VO_DMA_write_en2_shift                                                       (9)
+#define VO_DMA_write_en2_mask                                                        (0x00000200)
+#define VO_DMA_write_en2(data)                                                       (0x00000200&((data)<<9))
+#define VO_DMA_write_en2_src(data)                                                   ((0x00000200&(data))>>9)
+#define VO_DMA_get_write_en2(data)                                                   ((0x00000200&(data))>>9)
+#define VO_DMA_ref_mix_shift                                                         (8)
+#define VO_DMA_ref_mix_mask                                                          (0x00000100)
+#define VO_DMA_ref_mix(data)                                                         (0x00000100&((data)<<8))
+#define VO_DMA_ref_mix_src(data)                                                     ((0x00000100&(data))>>8)
+#define VO_DMA_get_ref_mix(data)                                                     ((0x00000100&(data))>>8)
+#define VO_DMA_write_en1_shift                                                       (5)
+#define VO_DMA_write_en1_mask                                                        (0x00000020)
+#define VO_DMA_write_en1(data)                                                       (0x00000020&((data)<<5))
+#define VO_DMA_write_en1_src(data)                                                   ((0x00000020&(data))>>5)
+#define VO_DMA_get_write_en1(data)                                                   ((0x00000020&(data))>>5)
+#define VO_DMA_l_shift                                                               (0)
+#define VO_DMA_l_mask                                                                (0x0000001F)
+#define VO_DMA_l(data)                                                               (0x0000001F&((data)<<0))
+#define VO_DMA_l_src(data)                                                           ((0x0000001F&(data))>>0)
+#define VO_DMA_get_l(data)                                                           ((0x0000001F&(data))>>0)
+
+
+#define VO_DMA_PV                                                                    0x18005590
+#define VO_DMA_PV_reg_addr                                                           "0xB8005590"
+#define VO_DMA_PV_reg                                                                0xB8005590
+#define set_VO_DMA_PV_reg(data)   (*((volatile unsigned int*) VO_DMA_PV_reg)=data)
+#define get_VO_DMA_PV_reg   (*((volatile unsigned int*) VO_DMA_PV_reg))
+#define VO_DMA_PV_inst_adr                                                           "0x0064"
+#define VO_DMA_PV_inst                                                               0x0064
+#define VO_DMA_PV_wb_shift                                                           (20)
+#define VO_DMA_PV_wb_mask                                                            (0x00F00000)
+#define VO_DMA_PV_wb(data)                                                           (0x00F00000&((data)<<20))
+#define VO_DMA_PV_wb_src(data)                                                       ((0x00F00000&(data))>>20)
+#define VO_DMA_PV_get_wb(data)                                                       ((0x00F00000&(data))>>20)
+#define VO_DMA_PV_vbi_shift                                                          (16)
+#define VO_DMA_PV_vbi_mask                                                           (0x000F0000)
+#define VO_DMA_PV_vbi(data)                                                          (0x000F0000&((data)<<16))
+#define VO_DMA_PV_vbi_src(data)                                                      ((0x000F0000&(data))>>16)
+#define VO_DMA_PV_get_vbi(data)                                                      ((0x000F0000&(data))>>16)
+#define VO_DMA_PV_dd_shift                                                           (8)
+#define VO_DMA_PV_dd_mask                                                            (0x00000F00)
+#define VO_DMA_PV_dd(data)                                                           (0x00000F00&((data)<<8))
+#define VO_DMA_PV_dd_src(data)                                                       ((0x00000F00&(data))>>8)
+#define VO_DMA_PV_get_dd(data)                                                       ((0x00000F00&(data))>>8)
+#define VO_DMA_PV_v1_shift                                                           (0)
+#define VO_DMA_PV_v1_mask                                                            (0x0000000F)
+#define VO_DMA_PV_v1(data)                                                           (0x0000000F&((data)<<0))
+#define VO_DMA_PV_v1_src(data)                                                       ((0x0000000F&(data))>>0)
+#define VO_DMA_PV_get_v1(data)                                                       ((0x0000000F&(data))>>0)
+
+
+#define VO_DMA_PG                                                                    0x18005594
+#define VO_DMA_PG_reg_addr                                                           "0xB8005594"
+#define VO_DMA_PG_reg                                                                0xB8005594
+#define set_VO_DMA_PG_reg(data)   (*((volatile unsigned int*) VO_DMA_PG_reg)=data)
+#define get_VO_DMA_PG_reg   (*((volatile unsigned int*) VO_DMA_PG_reg))
+#define VO_DMA_PG_inst_adr                                                           "0x0065"
+#define VO_DMA_PG_inst                                                               0x0065
+#define VO_DMA_PG_osd1_shift                                                         (4)
+#define VO_DMA_PG_osd1_mask                                                          (0x000000F0)
+#define VO_DMA_PG_osd1(data)                                                         (0x000000F0&((data)<<4))
+#define VO_DMA_PG_osd1_src(data)                                                     ((0x000000F0&(data))>>4)
+#define VO_DMA_PG_get_osd1(data)                                                     ((0x000000F0&(data))>>4)
+#define VO_DMA_PG_sub1_shift                                                         (0)
+#define VO_DMA_PG_sub1_mask                                                          (0x0000000F)
+#define VO_DMA_PG_sub1(data)                                                         (0x0000000F&((data)<<0))
+#define VO_DMA_PG_sub1_src(data)                                                     ((0x0000000F&(data))>>0)
+#define VO_DMA_PG_get_sub1(data)                                                     ((0x0000000F&(data))>>0)
+
+
+#define VO_DMA_BWC                                                                   0x18005598
+#define VO_DMA_BWC_reg_addr                                                          "0xB8005598"
+#define VO_DMA_BWC_reg                                                               0xB8005598
+#define set_VO_DMA_BWC_reg(data)   (*((volatile unsigned int*) VO_DMA_BWC_reg)=data)
+#define get_VO_DMA_BWC_reg   (*((volatile unsigned int*) VO_DMA_BWC_reg))
+#define VO_DMA_BWC_inst_adr                                                          "0x0066"
+#define VO_DMA_BWC_inst                                                              0x0066
+#define VO_DMA_BWC_write_en3_shift                                                   (28)
+#define VO_DMA_BWC_write_en3_mask                                                    (0x10000000)
+#define VO_DMA_BWC_write_en3(data)                                                   (0x10000000&((data)<<28))
+#define VO_DMA_BWC_write_en3_src(data)                                               ((0x10000000&(data))>>28)
+#define VO_DMA_BWC_get_write_en3(data)                                               ((0x10000000&(data))>>28)
+#define VO_DMA_BWC_init_shift                                                        (20)
+#define VO_DMA_BWC_init_mask                                                         (0x0FF00000)
+#define VO_DMA_BWC_init(data)                                                        (0x0FF00000&((data)<<20))
+#define VO_DMA_BWC_init_src(data)                                                    ((0x0FF00000&(data))>>20)
+#define VO_DMA_BWC_get_init(data)                                                    ((0x0FF00000&(data))>>20)
+#define VO_DMA_BWC_write_en2_shift                                                   (16)
+#define VO_DMA_BWC_write_en2_mask                                                    (0x00010000)
+#define VO_DMA_BWC_write_en2(data)                                                   (0x00010000&((data)<<16))
+#define VO_DMA_BWC_write_en2_src(data)                                               ((0x00010000&(data))>>16)
+#define VO_DMA_BWC_get_write_en2(data)                                               ((0x00010000&(data))>>16)
+#define VO_DMA_BWC_interval_shift                                                    (8)
+#define VO_DMA_BWC_interval_mask                                                     (0x0000FF00)
+#define VO_DMA_BWC_interval(data)                                                    (0x0000FF00&((data)<<8))
+#define VO_DMA_BWC_interval_src(data)                                                ((0x0000FF00&(data))>>8)
+#define VO_DMA_BWC_get_interval(data)                                                ((0x0000FF00&(data))>>8)
+#define VO_DMA_BWC_write_en1_shift                                                   (5)
+#define VO_DMA_BWC_write_en1_mask                                                    (0x00000020)
+#define VO_DMA_BWC_write_en1(data)                                                   (0x00000020&((data)<<5))
+#define VO_DMA_BWC_write_en1_src(data)                                               ((0x00000020&(data))>>5)
+#define VO_DMA_BWC_get_write_en1(data)                                               ((0x00000020&(data))>>5)
+#define VO_DMA_BWC_num_shift                                                         (0)
+#define VO_DMA_BWC_num_mask                                                          (0x0000001F)
+#define VO_DMA_BWC_num(data)                                                         (0x0000001F&((data)<<0))
+#define VO_DMA_BWC_num_src(data)                                                     ((0x0000001F&(data))>>0)
+#define VO_DMA_BWC_get_num(data)                                                     ((0x0000001F&(data))>>0)
+
+
+#define VO_DMA_UPDATE                                                                0x1800559C
+#define VO_DMA_UPDATE_reg_addr                                                       "0xB800559C"
+#define VO_DMA_UPDATE_reg                                                            0xB800559C
+#define set_VO_DMA_UPDATE_reg(data)   (*((volatile unsigned int*) VO_DMA_UPDATE_reg)=data)
+#define get_VO_DMA_UPDATE_reg   (*((volatile unsigned int*) VO_DMA_UPDATE_reg))
+#define VO_DMA_UPDATE_inst_adr                                                       "0x0067"
+#define VO_DMA_UPDATE_inst                                                           0x0067
+#define VO_DMA_UPDATE_update_shift                                                   (1)
+#define VO_DMA_UPDATE_update_mask                                                    (0x00000002)
+#define VO_DMA_UPDATE_update(data)                                                   (0x00000002&((data)<<1))
+#define VO_DMA_UPDATE_update_src(data)                                               ((0x00000002&(data))>>1)
+#define VO_DMA_UPDATE_get_update(data)                                               ((0x00000002&(data))>>1)
+#define VO_DMA_UPDATE_write_data_shift                                               (0)
+#define VO_DMA_UPDATE_write_data_mask                                                (0x00000001)
+#define VO_DMA_UPDATE_write_data(data)                                               (0x00000001&((data)<<0))
+#define VO_DMA_UPDATE_write_data_src(data)                                           ((0x00000001&(data))>>0)
+#define VO_DMA_UPDATE_get_write_data(data)                                           ((0x00000001&(data))>>0)
+
+
+#define VO_DMA_V1_Y0                                                                 0x180055A0
+#define VO_DMA_V1_Y0_reg_addr                                                        "0xB80055A0"
+#define VO_DMA_V1_Y0_reg                                                             0xB80055A0
+#define set_VO_DMA_V1_Y0_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_Y0_reg)=data)
+#define get_VO_DMA_V1_Y0_reg   (*((volatile unsigned int*) VO_DMA_V1_Y0_reg))
+#define VO_DMA_V1_Y0_inst_adr                                                        "0x0068"
+#define VO_DMA_V1_Y0_inst                                                            0x0068
+#define VO_DMA_V1_Y0_depth_shift                                                     (12)
+#define VO_DMA_V1_Y0_depth_mask                                                      (0x003FF000)
+#define VO_DMA_V1_Y0_depth(data)                                                     (0x003FF000&((data)<<12))
+#define VO_DMA_V1_Y0_depth_src(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_Y0_get_depth(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_Y0_sa_shift                                                        (0)
+#define VO_DMA_V1_Y0_sa_mask                                                         (0x000003FF)
+#define VO_DMA_V1_Y0_sa(data)                                                        (0x000003FF&((data)<<0))
+#define VO_DMA_V1_Y0_sa_src(data)                                                    ((0x000003FF&(data))>>0)
+#define VO_DMA_V1_Y0_get_sa(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_V1_Y1                                                                 0x180055A4
+#define VO_DMA_V1_Y1_reg_addr                                                        "0xB80055A4"
+#define VO_DMA_V1_Y1_reg                                                             0xB80055A4
+#define set_VO_DMA_V1_Y1_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_Y1_reg)=data)
+#define get_VO_DMA_V1_Y1_reg   (*((volatile unsigned int*) VO_DMA_V1_Y1_reg))
+#define VO_DMA_V1_Y1_inst_adr                                                        "0x0069"
+#define VO_DMA_V1_Y1_inst                                                            0x0069
+#define VO_DMA_V1_Y1_depth_shift                                                     (12)
+#define VO_DMA_V1_Y1_depth_mask                                                      (0x003FF000)
+#define VO_DMA_V1_Y1_depth(data)                                                     (0x003FF000&((data)<<12))
+#define VO_DMA_V1_Y1_depth_src(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_Y1_get_depth(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_Y1_sa_shift                                                        (0)
+#define VO_DMA_V1_Y1_sa_mask                                                         (0x000003FF)
+#define VO_DMA_V1_Y1_sa(data)                                                        (0x000003FF&((data)<<0))
+#define VO_DMA_V1_Y1_sa_src(data)                                                    ((0x000003FF&(data))>>0)
+#define VO_DMA_V1_Y1_get_sa(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_V1_Y2                                                                 0x180055A8
+#define VO_DMA_V1_Y2_reg_addr                                                        "0xB80055A8"
+#define VO_DMA_V1_Y2_reg                                                             0xB80055A8
+#define set_VO_DMA_V1_Y2_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_Y2_reg)=data)
+#define get_VO_DMA_V1_Y2_reg   (*((volatile unsigned int*) VO_DMA_V1_Y2_reg))
+#define VO_DMA_V1_Y2_inst_adr                                                        "0x006A"
+#define VO_DMA_V1_Y2_inst                                                            0x006A
+#define VO_DMA_V1_Y2_depth_shift                                                     (12)
+#define VO_DMA_V1_Y2_depth_mask                                                      (0x003FF000)
+#define VO_DMA_V1_Y2_depth(data)                                                     (0x003FF000&((data)<<12))
+#define VO_DMA_V1_Y2_depth_src(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_Y2_get_depth(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_Y2_sa_shift                                                        (0)
+#define VO_DMA_V1_Y2_sa_mask                                                         (0x000003FF)
+#define VO_DMA_V1_Y2_sa(data)                                                        (0x000003FF&((data)<<0))
+#define VO_DMA_V1_Y2_sa_src(data)                                                    ((0x000003FF&(data))>>0)
+#define VO_DMA_V1_Y2_get_sa(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_V1_Y3                                                                 0x180055AC
+#define VO_DMA_V1_Y3_reg_addr                                                        "0xB80055AC"
+#define VO_DMA_V1_Y3_reg                                                             0xB80055AC
+#define set_VO_DMA_V1_Y3_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_Y3_reg)=data)
+#define get_VO_DMA_V1_Y3_reg   (*((volatile unsigned int*) VO_DMA_V1_Y3_reg))
+#define VO_DMA_V1_Y3_inst_adr                                                        "0x006B"
+#define VO_DMA_V1_Y3_inst                                                            0x006B
+#define VO_DMA_V1_Y3_depth_shift                                                     (12)
+#define VO_DMA_V1_Y3_depth_mask                                                      (0x003FF000)
+#define VO_DMA_V1_Y3_depth(data)                                                     (0x003FF000&((data)<<12))
+#define VO_DMA_V1_Y3_depth_src(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_Y3_get_depth(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_Y3_sa_shift                                                        (0)
+#define VO_DMA_V1_Y3_sa_mask                                                         (0x000003FF)
+#define VO_DMA_V1_Y3_sa(data)                                                        (0x000003FF&((data)<<0))
+#define VO_DMA_V1_Y3_sa_src(data)                                                    ((0x000003FF&(data))>>0)
+#define VO_DMA_V1_Y3_get_sa(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_V1_C0                                                                 0x180055B0
+#define VO_DMA_V1_C0_reg_addr                                                        "0xB80055B0"
+#define VO_DMA_V1_C0_reg                                                             0xB80055B0
+#define set_VO_DMA_V1_C0_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_C0_reg)=data)
+#define get_VO_DMA_V1_C0_reg   (*((volatile unsigned int*) VO_DMA_V1_C0_reg))
+#define VO_DMA_V1_C0_inst_adr                                                        "0x006C"
+#define VO_DMA_V1_C0_inst                                                            0x006C
+#define VO_DMA_V1_C0_depth_shift                                                     (12)
+#define VO_DMA_V1_C0_depth_mask                                                      (0x003FF000)
+#define VO_DMA_V1_C0_depth(data)                                                     (0x003FF000&((data)<<12))
+#define VO_DMA_V1_C0_depth_src(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_C0_get_depth(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_C0_sa_shift                                                        (0)
+#define VO_DMA_V1_C0_sa_mask                                                         (0x000003FF)
+#define VO_DMA_V1_C0_sa(data)                                                        (0x000003FF&((data)<<0))
+#define VO_DMA_V1_C0_sa_src(data)                                                    ((0x000003FF&(data))>>0)
+#define VO_DMA_V1_C0_get_sa(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_V1_C1                                                                 0x180055B4
+#define VO_DMA_V1_C1_reg_addr                                                        "0xB80055B4"
+#define VO_DMA_V1_C1_reg                                                             0xB80055B4
+#define set_VO_DMA_V1_C1_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_C1_reg)=data)
+#define get_VO_DMA_V1_C1_reg   (*((volatile unsigned int*) VO_DMA_V1_C1_reg))
+#define VO_DMA_V1_C1_inst_adr                                                        "0x006D"
+#define VO_DMA_V1_C1_inst                                                            0x006D
+#define VO_DMA_V1_C1_depth_shift                                                     (12)
+#define VO_DMA_V1_C1_depth_mask                                                      (0x003FF000)
+#define VO_DMA_V1_C1_depth(data)                                                     (0x003FF000&((data)<<12))
+#define VO_DMA_V1_C1_depth_src(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_C1_get_depth(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_C1_sa_shift                                                        (0)
+#define VO_DMA_V1_C1_sa_mask                                                         (0x000003FF)
+#define VO_DMA_V1_C1_sa(data)                                                        (0x000003FF&((data)<<0))
+#define VO_DMA_V1_C1_sa_src(data)                                                    ((0x000003FF&(data))>>0)
+#define VO_DMA_V1_C1_get_sa(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_V1_C2                                                                 0x180055B8
+#define VO_DMA_V1_C2_reg_addr                                                        "0xB80055B8"
+#define VO_DMA_V1_C2_reg                                                             0xB80055B8
+#define set_VO_DMA_V1_C2_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_C2_reg)=data)
+#define get_VO_DMA_V1_C2_reg   (*((volatile unsigned int*) VO_DMA_V1_C2_reg))
+#define VO_DMA_V1_C2_inst_adr                                                        "0x006E"
+#define VO_DMA_V1_C2_inst                                                            0x006E
+#define VO_DMA_V1_C2_depth_shift                                                     (12)
+#define VO_DMA_V1_C2_depth_mask                                                      (0x003FF000)
+#define VO_DMA_V1_C2_depth(data)                                                     (0x003FF000&((data)<<12))
+#define VO_DMA_V1_C2_depth_src(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_C2_get_depth(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_C2_sa_shift                                                        (0)
+#define VO_DMA_V1_C2_sa_mask                                                         (0x000003FF)
+#define VO_DMA_V1_C2_sa(data)                                                        (0x000003FF&((data)<<0))
+#define VO_DMA_V1_C2_sa_src(data)                                                    ((0x000003FF&(data))>>0)
+#define VO_DMA_V1_C2_get_sa(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_V1_C3                                                                 0x180055BC
+#define VO_DMA_V1_C3_reg_addr                                                        "0xB80055BC"
+#define VO_DMA_V1_C3_reg                                                             0xB80055BC
+#define set_VO_DMA_V1_C3_reg(data)   (*((volatile unsigned int*) VO_DMA_V1_C3_reg)=data)
+#define get_VO_DMA_V1_C3_reg   (*((volatile unsigned int*) VO_DMA_V1_C3_reg))
+#define VO_DMA_V1_C3_inst_adr                                                        "0x006F"
+#define VO_DMA_V1_C3_inst                                                            0x006F
+#define VO_DMA_V1_C3_depth_shift                                                     (12)
+#define VO_DMA_V1_C3_depth_mask                                                      (0x003FF000)
+#define VO_DMA_V1_C3_depth(data)                                                     (0x003FF000&((data)<<12))
+#define VO_DMA_V1_C3_depth_src(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_C3_get_depth(data)                                                 ((0x003FF000&(data))>>12)
+#define VO_DMA_V1_C3_sa_shift                                                        (0)
+#define VO_DMA_V1_C3_sa_mask                                                         (0x000003FF)
+#define VO_DMA_V1_C3_sa(data)                                                        (0x000003FF&((data)<<0))
+#define VO_DMA_V1_C3_sa_src(data)                                                    ((0x000003FF&(data))>>0)
+#define VO_DMA_V1_C3_get_sa(data)                                                    ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_V1DI                                                                  0x180055C0
+#define VO_DMA_V1DI_reg_addr                                                         "0xB80055C0"
+#define VO_DMA_V1DI_reg                                                              0xB80055C0
+#define set_VO_DMA_V1DI_reg(data)   (*((volatile unsigned int*) VO_DMA_V1DI_reg)=data)
+#define get_VO_DMA_V1DI_reg   (*((volatile unsigned int*) VO_DMA_V1DI_reg))
+#define VO_DMA_V1DI_inst_adr                                                         "0x0070"
+#define VO_DMA_V1DI_inst                                                             0x0070
+#define VO_DMA_V1DI_depth_shift                                                      (12)
+#define VO_DMA_V1DI_depth_mask                                                       (0x003FF000)
+#define VO_DMA_V1DI_depth(data)                                                      (0x003FF000&((data)<<12))
+#define VO_DMA_V1DI_depth_src(data)                                                  ((0x003FF000&(data))>>12)
+#define VO_DMA_V1DI_get_depth(data)                                                  ((0x003FF000&(data))>>12)
+#define VO_DMA_V1DI_sa_shift                                                         (0)
+#define VO_DMA_V1DI_sa_mask                                                          (0x000003FF)
+#define VO_DMA_V1DI_sa(data)                                                         (0x000003FF&((data)<<0))
+#define VO_DMA_V1DI_sa_src(data)                                                     ((0x000003FF&(data))>>0)
+#define VO_DMA_V1DI_get_sa(data)                                                     ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_SUB1_WI                                                               0x180055C4
+#define VO_DMA_SUB1_WI_reg_addr                                                      "0xB80055C4"
+#define VO_DMA_SUB1_WI_reg                                                           0xB80055C4
+#define set_VO_DMA_SUB1_WI_reg(data)   (*((volatile unsigned int*) VO_DMA_SUB1_WI_reg)=data)
+#define get_VO_DMA_SUB1_WI_reg   (*((volatile unsigned int*) VO_DMA_SUB1_WI_reg))
+#define VO_DMA_SUB1_WI_inst_adr                                                      "0x0071"
+#define VO_DMA_SUB1_WI_inst                                                          0x0071
+#define VO_DMA_SUB1_WI_depth_shift                                                   (12)
+#define VO_DMA_SUB1_WI_depth_mask                                                    (0x003FF000)
+#define VO_DMA_SUB1_WI_depth(data)                                                   (0x003FF000&((data)<<12))
+#define VO_DMA_SUB1_WI_depth_src(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_SUB1_WI_get_depth(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_SUB1_WI_sa_shift                                                      (0)
+#define VO_DMA_SUB1_WI_sa_mask                                                       (0x000003FF)
+#define VO_DMA_SUB1_WI_sa(data)                                                      (0x000003FF&((data)<<0))
+#define VO_DMA_SUB1_WI_sa_src(data)                                                  ((0x000003FF&(data))>>0)
+#define VO_DMA_SUB1_WI_get_sa(data)                                                  ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_SUB1_D0                                                               0x180055C8
+#define VO_DMA_SUB1_D0_reg_addr                                                      "0xB80055C8"
+#define VO_DMA_SUB1_D0_reg                                                           0xB80055C8
+#define set_VO_DMA_SUB1_D0_reg(data)   (*((volatile unsigned int*) VO_DMA_SUB1_D0_reg)=data)
+#define get_VO_DMA_SUB1_D0_reg   (*((volatile unsigned int*) VO_DMA_SUB1_D0_reg))
+#define VO_DMA_SUB1_D0_inst_adr                                                      "0x0072"
+#define VO_DMA_SUB1_D0_inst                                                          0x0072
+#define VO_DMA_SUB1_D0_depth_shift                                                   (12)
+#define VO_DMA_SUB1_D0_depth_mask                                                    (0x003FF000)
+#define VO_DMA_SUB1_D0_depth(data)                                                   (0x003FF000&((data)<<12))
+#define VO_DMA_SUB1_D0_depth_src(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_SUB1_D0_get_depth(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_SUB1_D0_sa_shift                                                      (0)
+#define VO_DMA_SUB1_D0_sa_mask                                                       (0x000003FF)
+#define VO_DMA_SUB1_D0_sa(data)                                                      (0x000003FF&((data)<<0))
+#define VO_DMA_SUB1_D0_sa_src(data)                                                  ((0x000003FF&(data))>>0)
+#define VO_DMA_SUB1_D0_get_sa(data)                                                  ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_SUB1_D1                                                               0x180055CC
+#define VO_DMA_SUB1_D1_reg_addr                                                      "0xB80055CC"
+#define VO_DMA_SUB1_D1_reg                                                           0xB80055CC
+#define set_VO_DMA_SUB1_D1_reg(data)   (*((volatile unsigned int*) VO_DMA_SUB1_D1_reg)=data)
+#define get_VO_DMA_SUB1_D1_reg   (*((volatile unsigned int*) VO_DMA_SUB1_D1_reg))
+#define VO_DMA_SUB1_D1_inst_adr                                                      "0x0073"
+#define VO_DMA_SUB1_D1_inst                                                          0x0073
+#define VO_DMA_SUB1_D1_depth_shift                                                   (12)
+#define VO_DMA_SUB1_D1_depth_mask                                                    (0x003FF000)
+#define VO_DMA_SUB1_D1_depth(data)                                                   (0x003FF000&((data)<<12))
+#define VO_DMA_SUB1_D1_depth_src(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_SUB1_D1_get_depth(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_SUB1_D1_sa_shift                                                      (0)
+#define VO_DMA_SUB1_D1_sa_mask                                                       (0x000003FF)
+#define VO_DMA_SUB1_D1_sa(data)                                                      (0x000003FF&((data)<<0))
+#define VO_DMA_SUB1_D1_sa_src(data)                                                  ((0x000003FF&(data))>>0)
+#define VO_DMA_SUB1_D1_get_sa(data)                                                  ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_OSD1_WI                                                               0x180055D0
+#define VO_DMA_OSD1_WI_reg_addr                                                      "0xB80055D0"
+#define VO_DMA_OSD1_WI_reg                                                           0xB80055D0
+#define set_VO_DMA_OSD1_WI_reg(data)   (*((volatile unsigned int*) VO_DMA_OSD1_WI_reg)=data)
+#define get_VO_DMA_OSD1_WI_reg   (*((volatile unsigned int*) VO_DMA_OSD1_WI_reg))
+#define VO_DMA_OSD1_WI_inst_adr                                                      "0x0074"
+#define VO_DMA_OSD1_WI_inst                                                          0x0074
+#define VO_DMA_OSD1_WI_depth_shift                                                   (12)
+#define VO_DMA_OSD1_WI_depth_mask                                                    (0x003FF000)
+#define VO_DMA_OSD1_WI_depth(data)                                                   (0x003FF000&((data)<<12))
+#define VO_DMA_OSD1_WI_depth_src(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_OSD1_WI_get_depth(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_OSD1_WI_sa_shift                                                      (0)
+#define VO_DMA_OSD1_WI_sa_mask                                                       (0x000003FF)
+#define VO_DMA_OSD1_WI_sa(data)                                                      (0x000003FF&((data)<<0))
+#define VO_DMA_OSD1_WI_sa_src(data)                                                  ((0x000003FF&(data))>>0)
+#define VO_DMA_OSD1_WI_get_sa(data)                                                  ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_OSD1_D0                                                               0x180055D4
+#define VO_DMA_OSD1_D0_reg_addr                                                      "0xB80055D4"
+#define VO_DMA_OSD1_D0_reg                                                           0xB80055D4
+#define set_VO_DMA_OSD1_D0_reg(data)   (*((volatile unsigned int*) VO_DMA_OSD1_D0_reg)=data)
+#define get_VO_DMA_OSD1_D0_reg   (*((volatile unsigned int*) VO_DMA_OSD1_D0_reg))
+#define VO_DMA_OSD1_D0_inst_adr                                                      "0x0075"
+#define VO_DMA_OSD1_D0_inst                                                          0x0075
+#define VO_DMA_OSD1_D0_depth_shift                                                   (12)
+#define VO_DMA_OSD1_D0_depth_mask                                                    (0x003FF000)
+#define VO_DMA_OSD1_D0_depth(data)                                                   (0x003FF000&((data)<<12))
+#define VO_DMA_OSD1_D0_depth_src(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_OSD1_D0_get_depth(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_OSD1_D0_sa_shift                                                      (0)
+#define VO_DMA_OSD1_D0_sa_mask                                                       (0x000003FF)
+#define VO_DMA_OSD1_D0_sa(data)                                                      (0x000003FF&((data)<<0))
+#define VO_DMA_OSD1_D0_sa_src(data)                                                  ((0x000003FF&(data))>>0)
+#define VO_DMA_OSD1_D0_get_sa(data)                                                  ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_OSD1_D1                                                               0x180055D8
+#define VO_DMA_OSD1_D1_reg_addr                                                      "0xB80055D8"
+#define VO_DMA_OSD1_D1_reg                                                           0xB80055D8
+#define set_VO_DMA_OSD1_D1_reg(data)   (*((volatile unsigned int*) VO_DMA_OSD1_D1_reg)=data)
+#define get_VO_DMA_OSD1_D1_reg   (*((volatile unsigned int*) VO_DMA_OSD1_D1_reg))
+#define VO_DMA_OSD1_D1_inst_adr                                                      "0x0076"
+#define VO_DMA_OSD1_D1_inst                                                          0x0076
+#define VO_DMA_OSD1_D1_depth_shift                                                   (12)
+#define VO_DMA_OSD1_D1_depth_mask                                                    (0x003FF000)
+#define VO_DMA_OSD1_D1_depth(data)                                                   (0x003FF000&((data)<<12))
+#define VO_DMA_OSD1_D1_depth_src(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_OSD1_D1_get_depth(data)                                               ((0x003FF000&(data))>>12)
+#define VO_DMA_OSD1_D1_sa_shift                                                      (0)
+#define VO_DMA_OSD1_D1_sa_mask                                                       (0x000003FF)
+#define VO_DMA_OSD1_D1_sa(data)                                                      (0x000003FF&((data)<<0))
+#define VO_DMA_OSD1_D1_sa_src(data)                                                  ((0x000003FF&(data))>>0)
+#define VO_DMA_OSD1_D1_get_sa(data)                                                  ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_DD_Y                                                                  0x180055DC
+#define VO_DMA_DD_Y_reg_addr                                                         "0xB80055DC"
+#define VO_DMA_DD_Y_reg                                                              0xB80055DC
+#define set_VO_DMA_DD_Y_reg(data)   (*((volatile unsigned int*) VO_DMA_DD_Y_reg)=data)
+#define get_VO_DMA_DD_Y_reg   (*((volatile unsigned int*) VO_DMA_DD_Y_reg))
+#define VO_DMA_DD_Y_inst_adr                                                         "0x0077"
+#define VO_DMA_DD_Y_inst                                                             0x0077
+#define VO_DMA_DD_Y_depth_shift                                                      (12)
+#define VO_DMA_DD_Y_depth_mask                                                       (0x003FF000)
+#define VO_DMA_DD_Y_depth(data)                                                      (0x003FF000&((data)<<12))
+#define VO_DMA_DD_Y_depth_src(data)                                                  ((0x003FF000&(data))>>12)
+#define VO_DMA_DD_Y_get_depth(data)                                                  ((0x003FF000&(data))>>12)
+#define VO_DMA_DD_Y_sa_shift                                                         (0)
+#define VO_DMA_DD_Y_sa_mask                                                          (0x000003FF)
+#define VO_DMA_DD_Y_sa(data)                                                         (0x000003FF&((data)<<0))
+#define VO_DMA_DD_Y_sa_src(data)                                                     ((0x000003FF&(data))>>0)
+#define VO_DMA_DD_Y_get_sa(data)                                                     ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_DD_C                                                                  0x180055E0
+#define VO_DMA_DD_C_reg_addr                                                         "0xB80055E0"
+#define VO_DMA_DD_C_reg                                                              0xB80055E0
+#define set_VO_DMA_DD_C_reg(data)   (*((volatile unsigned int*) VO_DMA_DD_C_reg)=data)
+#define get_VO_DMA_DD_C_reg   (*((volatile unsigned int*) VO_DMA_DD_C_reg))
+#define VO_DMA_DD_C_inst_adr                                                         "0x0078"
+#define VO_DMA_DD_C_inst                                                             0x0078
+#define VO_DMA_DD_C_depth_shift                                                      (12)
+#define VO_DMA_DD_C_depth_mask                                                       (0x003FF000)
+#define VO_DMA_DD_C_depth(data)                                                      (0x003FF000&((data)<<12))
+#define VO_DMA_DD_C_depth_src(data)                                                  ((0x003FF000&(data))>>12)
+#define VO_DMA_DD_C_get_depth(data)                                                  ((0x003FF000&(data))>>12)
+#define VO_DMA_DD_C_sa_shift                                                         (0)
+#define VO_DMA_DD_C_sa_mask                                                          (0x000003FF)
+#define VO_DMA_DD_C_sa(data)                                                         (0x000003FF&((data)<<0))
+#define VO_DMA_DD_C_sa_src(data)                                                     ((0x000003FF&(data))>>0)
+#define VO_DMA_DD_C_get_sa(data)                                                     ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_VBI1                                                                  0x180055E4
+#define VO_DMA_VBI1_reg_addr                                                         "0xB80055E4"
+#define VO_DMA_VBI1_reg                                                              0xB80055E4
+#define set_VO_DMA_VBI1_reg(data)   (*((volatile unsigned int*) VO_DMA_VBI1_reg)=data)
+#define get_VO_DMA_VBI1_reg   (*((volatile unsigned int*) VO_DMA_VBI1_reg))
+#define VO_DMA_VBI1_inst_adr                                                         "0x0079"
+#define VO_DMA_VBI1_inst                                                             0x0079
+#define VO_DMA_VBI1_depth_shift                                                      (12)
+#define VO_DMA_VBI1_depth_mask                                                       (0x003FF000)
+#define VO_DMA_VBI1_depth(data)                                                      (0x003FF000&((data)<<12))
+#define VO_DMA_VBI1_depth_src(data)                                                  ((0x003FF000&(data))>>12)
+#define VO_DMA_VBI1_get_depth(data)                                                  ((0x003FF000&(data))>>12)
+#define VO_DMA_VBI1_sa_shift                                                         (0)
+#define VO_DMA_VBI1_sa_mask                                                          (0x000003FF)
+#define VO_DMA_VBI1_sa(data)                                                         (0x000003FF&((data)<<0))
+#define VO_DMA_VBI1_sa_src(data)                                                     ((0x000003FF&(data))>>0)
+#define VO_DMA_VBI1_get_sa(data)                                                     ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_VBI2                                                                  0x180055E8
+#define VO_DMA_VBI2_reg_addr                                                         "0xB80055E8"
+#define VO_DMA_VBI2_reg                                                              0xB80055E8
+#define set_VO_DMA_VBI2_reg(data)   (*((volatile unsigned int*) VO_DMA_VBI2_reg)=data)
+#define get_VO_DMA_VBI2_reg   (*((volatile unsigned int*) VO_DMA_VBI2_reg))
+#define VO_DMA_VBI2_inst_adr                                                         "0x007A"
+#define VO_DMA_VBI2_inst                                                             0x007A
+#define VO_DMA_VBI2_depth_shift                                                      (12)
+#define VO_DMA_VBI2_depth_mask                                                       (0x003FF000)
+#define VO_DMA_VBI2_depth(data)                                                      (0x003FF000&((data)<<12))
+#define VO_DMA_VBI2_depth_src(data)                                                  ((0x003FF000&(data))>>12)
+#define VO_DMA_VBI2_get_depth(data)                                                  ((0x003FF000&(data))>>12)
+#define VO_DMA_VBI2_sa_shift                                                         (0)
+#define VO_DMA_VBI2_sa_mask                                                          (0x000003FF)
+#define VO_DMA_VBI2_sa(data)                                                         (0x000003FF&((data)<<0))
+#define VO_DMA_VBI2_sa_src(data)                                                     ((0x000003FF&(data))>>0)
+#define VO_DMA_VBI2_get_sa(data)                                                     ((0x000003FF&(data))>>0)
+
+
+#define VO_DMA_WB_Y                                                                  0x180055EC
+#define VO_DMA_WB_Y_reg_addr                                                         "0xB80055EC"
+#define VO_DMA_WB_Y_reg                                                              0xB80055EC
+#define set_VO_DMA_WB_Y_reg(data)   (*((volatile unsigned int*) VO_DMA_WB_Y_reg)=data)
+#define get_VO_DMA_WB_Y_reg   (*((volatile unsigned int*) VO_DMA_WB_Y_reg))
+#define VO_DMA_WB_Y_inst_adr                                                         "0x007B"
+#define VO_DMA_WB_Y_inst                                                             0x007B
+#define VO_DMA_WB_Y_depth_shift                                                      (12)
+#define VO_DMA_WB_Y_depth_mask                                                       (0x0007F000)
+#define VO_DMA_WB_Y_depth(data)                                                      (0x0007F000&((data)<<12))
+#define VO_DMA_WB_Y_depth_src(data)                                                  ((0x0007F000&(data))>>12)
+#define VO_DMA_WB_Y_get_depth(data)                                                  ((0x0007F000&(data))>>12)
+#define VO_DMA_WB_Y_sa_shift                                                         (0)
+#define VO_DMA_WB_Y_sa_mask                                                          (0x0000007F)
+#define VO_DMA_WB_Y_sa(data)                                                         (0x0000007F&((data)<<0))
+#define VO_DMA_WB_Y_sa_src(data)                                                     ((0x0000007F&(data))>>0)
+#define VO_DMA_WB_Y_get_sa(data)                                                     ((0x0000007F&(data))>>0)
+
+
+#define VO_DMA_WB_C                                                                  0x180055F0
+#define VO_DMA_WB_C_reg_addr                                                         "0xB80055F0"
+#define VO_DMA_WB_C_reg                                                              0xB80055F0
+#define set_VO_DMA_WB_C_reg(data)   (*((volatile unsigned int*) VO_DMA_WB_C_reg)=data)
+#define get_VO_DMA_WB_C_reg   (*((volatile unsigned int*) VO_DMA_WB_C_reg))
+#define VO_DMA_WB_C_inst_adr                                                         "0x007C"
+#define VO_DMA_WB_C_inst                                                             0x007C
+#define VO_DMA_WB_C_depth_shift                                                      (12)
+#define VO_DMA_WB_C_depth_mask                                                       (0x0007F000)
+#define VO_DMA_WB_C_depth(data)                                                      (0x0007F000&((data)<<12))
+#define VO_DMA_WB_C_depth_src(data)                                                  ((0x0007F000&(data))>>12)
+#define VO_DMA_WB_C_get_depth(data)                                                  ((0x0007F000&(data))>>12)
+#define VO_DMA_WB_C_sa_shift                                                         (0)
+#define VO_DMA_WB_C_sa_mask                                                          (0x0000007F)
+#define VO_DMA_WB_C_sa(data)                                                         (0x0000007F&((data)<<0))
+#define VO_DMA_WB_C_sa_src(data)                                                     ((0x0000007F&(data))>>0)
+#define VO_DMA_WB_C_get_sa(data)                                                     ((0x0000007F&(data))>>0)
+
+
+#define VO_DMA_WB_V1                                                                 0x180055F4
+#define VO_DMA_WB_V1_reg_addr                                                        "0xB80055F4"
+#define VO_DMA_WB_V1_reg                                                             0xB80055F4
+#define set_VO_DMA_WB_V1_reg(data)   (*((volatile unsigned int*) VO_DMA_WB_V1_reg)=data)
+#define get_VO_DMA_WB_V1_reg   (*((volatile unsigned int*) VO_DMA_WB_V1_reg))
+#define VO_DMA_WB_V1_inst_adr                                                        "0x007D"
+#define VO_DMA_WB_V1_inst                                                            0x007D
+#define VO_DMA_WB_V1_depth_shift                                                     (12)
+#define VO_DMA_WB_V1_depth_mask                                                      (0x0007F000)
+#define VO_DMA_WB_V1_depth(data)                                                     (0x0007F000&((data)<<12))
+#define VO_DMA_WB_V1_depth_src(data)                                                 ((0x0007F000&(data))>>12)
+#define VO_DMA_WB_V1_get_depth(data)                                                 ((0x0007F000&(data))>>12)
+#define VO_DMA_WB_V1_sa_shift                                                        (0)
+#define VO_DMA_WB_V1_sa_mask                                                         (0x0000007F)
+#define VO_DMA_WB_V1_sa(data)                                                        (0x0000007F&((data)<<0))
+#define VO_DMA_WB_V1_sa_src(data)                                                    ((0x0000007F&(data))>>0)
+#define VO_DMA_WB_V1_get_sa(data)                                                    ((0x0000007F&(data))>>0)
+
+
+#define VO_MIX_ORDER                                                                 0x180055F8
+#define VO_MIX_ORDER_reg_addr                                                        "0xB80055F8"
+#define VO_MIX_ORDER_reg                                                             0xB80055F8
+#define set_VO_MIX_ORDER_reg(data)   (*((volatile unsigned int*) VO_MIX_ORDER_reg)=data)
+#define get_VO_MIX_ORDER_reg   (*((volatile unsigned int*) VO_MIX_ORDER_reg))
+#define VO_MIX_ORDER_inst_adr                                                        "0x007E"
+#define VO_MIX_ORDER_inst                                                            0x007E
+#define VO_MIX_ORDER_osd1_shift                                                      (20)
+#define VO_MIX_ORDER_osd1_mask                                                       (0x00F00000)
+#define VO_MIX_ORDER_osd1(data)                                                      (0x00F00000&((data)<<20))
+#define VO_MIX_ORDER_osd1_src(data)                                                  ((0x00F00000&(data))>>20)
+#define VO_MIX_ORDER_get_osd1(data)                                                  ((0x00F00000&(data))>>20)
+#define VO_MIX_ORDER_sub1_shift                                                      (12)
+#define VO_MIX_ORDER_sub1_mask                                                       (0x0000F000)
+#define VO_MIX_ORDER_sub1(data)                                                      (0x0000F000&((data)<<12))
+#define VO_MIX_ORDER_sub1_src(data)                                                  ((0x0000F000&(data))>>12)
+#define VO_MIX_ORDER_get_sub1(data)                                                  ((0x0000F000&(data))>>12)
+#define VO_MIX_ORDER_v1_shift                                                        (8)
+#define VO_MIX_ORDER_v1_mask                                                         (0x00000F00)
+#define VO_MIX_ORDER_v1(data)                                                        (0x00000F00&((data)<<8))
+#define VO_MIX_ORDER_v1_src(data)                                                    ((0x00000F00&(data))>>8)
+#define VO_MIX_ORDER_get_v1(data)                                                    ((0x00000F00&(data))>>8)
+
+
+#define VO_MIX                                                                       0x180055FC
+#define VO_MIX_reg_addr                                                              "0xB80055FC"
+#define VO_MIX_reg                                                                   0xB80055FC
+#define set_VO_MIX_reg(data)   (*((volatile unsigned int*) VO_MIX_reg)=data)
+#define get_VO_MIX_reg   (*((volatile unsigned int*) VO_MIX_reg))
+#define VO_MIX_inst_adr                                                              "0x007F"
+#define VO_MIX_inst                                                                  0x007F
+#define VO_MIX_cd_shift                                                              (5)
+#define VO_MIX_cd_mask                                                               (0x00000020)
+#define VO_MIX_cd(data)                                                              (0x00000020&((data)<<5))
+#define VO_MIX_cd_src(data)                                                          ((0x00000020&(data))>>5)
+#define VO_MIX_get_cd(data)                                                          ((0x00000020&(data))>>5)
+#define VO_MIX_cu_shift                                                              (4)
+#define VO_MIX_cu_mask                                                               (0x00000010)
+#define VO_MIX_cu(data)                                                              (0x00000010&((data)<<4))
+#define VO_MIX_cu_src(data)                                                          ((0x00000010&(data))>>4)
+#define VO_MIX_get_cu(data)                                                          ((0x00000010&(data))>>4)
+#define VO_MIX_v1b_shift                                                             (1)
+#define VO_MIX_v1b_mask                                                              (0x00000002)
+#define VO_MIX_v1b(data)                                                             (0x00000002&((data)<<1))
+#define VO_MIX_v1b_src(data)                                                         ((0x00000002&(data))>>1)
+#define VO_MIX_get_v1b(data)                                                         ((0x00000002&(data))>>1)
+#define VO_MIX_write_data_shift                                                      (0)
+#define VO_MIX_write_data_mask                                                       (0x00000001)
+#define VO_MIX_write_data(data)                                                      (0x00000001&((data)<<0))
+#define VO_MIX_write_data_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_MIX_get_write_data(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_M1BG                                                                      0x18005600
+#define VO_M1BG_reg_addr                                                             "0xB8005600"
+#define VO_M1BG_reg                                                                  0xB8005600
+#define set_VO_M1BG_reg(data)   (*((volatile unsigned int*) VO_M1BG_reg)=data)
+#define get_VO_M1BG_reg   (*((volatile unsigned int*) VO_M1BG_reg))
+#define VO_M1BG_inst_adr                                                             "0x0080"
+#define VO_M1BG_inst                                                                 0x0080
+#define VO_M1BG_cr_shift                                                             (16)
+#define VO_M1BG_cr_mask                                                              (0x00FF0000)
+#define VO_M1BG_cr(data)                                                             (0x00FF0000&((data)<<16))
+#define VO_M1BG_cr_src(data)                                                         ((0x00FF0000&(data))>>16)
+#define VO_M1BG_get_cr(data)                                                         ((0x00FF0000&(data))>>16)
+#define VO_M1BG_cb_shift                                                             (8)
+#define VO_M1BG_cb_mask                                                              (0x0000FF00)
+#define VO_M1BG_cb(data)                                                             (0x0000FF00&((data)<<8))
+#define VO_M1BG_cb_src(data)                                                         ((0x0000FF00&(data))>>8)
+#define VO_M1BG_get_cb(data)                                                         ((0x0000FF00&(data))>>8)
+#define VO_M1BG_y_shift                                                              (0)
+#define VO_M1BG_y_mask                                                               (0x000000FF)
+#define VO_M1BG_y(data)                                                              (0x000000FF&((data)<<0))
+#define VO_M1BG_y_src(data)                                                          ((0x000000FF&(data))>>0)
+#define VO_M1BG_get_y(data)                                                          ((0x000000FF&(data))>>0)
+
+
+#define VO_M1_SIZE                                                                   0x18005604
+#define VO_M1_SIZE_reg_addr                                                          "0xB8005604"
+#define VO_M1_SIZE_reg                                                               0xB8005604
+#define set_VO_M1_SIZE_reg(data)   (*((volatile unsigned int*) VO_M1_SIZE_reg)=data)
+#define get_VO_M1_SIZE_reg   (*((volatile unsigned int*) VO_M1_SIZE_reg))
+#define VO_M1_SIZE_inst_adr                                                          "0x0081"
+#define VO_M1_SIZE_inst                                                              0x0081
+#define VO_M1_SIZE_w_shift                                                           (16)
+#define VO_M1_SIZE_w_mask                                                            (0x1FFF0000)
+#define VO_M1_SIZE_w(data)                                                           (0x1FFF0000&((data)<<16))
+#define VO_M1_SIZE_w_src(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_M1_SIZE_get_w(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_M1_SIZE_h_shift                                                           (0)
+#define VO_M1_SIZE_h_mask                                                            (0x00001FFF)
+#define VO_M1_SIZE_h(data)                                                           (0x00001FFF&((data)<<0))
+#define VO_M1_SIZE_h_src(data)                                                       ((0x00001FFF&(data))>>0)
+#define VO_M1_SIZE_get_h(data)                                                       ((0x00001FFF&(data))>>0)
+
+
+#define VO_M2BG                                                                      0x18005608
+#define VO_M2BG_reg_addr                                                             "0xB8005608"
+#define VO_M2BG_reg                                                                  0xB8005608
+#define set_VO_M2BG_reg(data)   (*((volatile unsigned int*) VO_M2BG_reg)=data)
+#define get_VO_M2BG_reg   (*((volatile unsigned int*) VO_M2BG_reg))
+#define VO_M2BG_inst_adr                                                             "0x0082"
+#define VO_M2BG_inst                                                                 0x0082
+#define VO_M2BG_cr_shift                                                             (16)
+#define VO_M2BG_cr_mask                                                              (0x00FF0000)
+#define VO_M2BG_cr(data)                                                             (0x00FF0000&((data)<<16))
+#define VO_M2BG_cr_src(data)                                                         ((0x00FF0000&(data))>>16)
+#define VO_M2BG_get_cr(data)                                                         ((0x00FF0000&(data))>>16)
+#define VO_M2BG_cb_shift                                                             (8)
+#define VO_M2BG_cb_mask                                                              (0x0000FF00)
+#define VO_M2BG_cb(data)                                                             (0x0000FF00&((data)<<8))
+#define VO_M2BG_cb_src(data)                                                         ((0x0000FF00&(data))>>8)
+#define VO_M2BG_get_cb(data)                                                         ((0x0000FF00&(data))>>8)
+#define VO_M2BG_y_shift                                                              (0)
+#define VO_M2BG_y_mask                                                               (0x000000FF)
+#define VO_M2BG_y(data)                                                              (0x000000FF&((data)<<0))
+#define VO_M2BG_y_src(data)                                                          ((0x000000FF&(data))>>0)
+#define VO_M2BG_get_y(data)                                                          ((0x000000FF&(data))>>0)
+
+
+#define VO_M2_SIZE                                                                   0x1800560C
+#define VO_M2_SIZE_reg_addr                                                          "0xB800560C"
+#define VO_M2_SIZE_reg                                                               0xB800560C
+#define set_VO_M2_SIZE_reg(data)   (*((volatile unsigned int*) VO_M2_SIZE_reg)=data)
+#define get_VO_M2_SIZE_reg   (*((volatile unsigned int*) VO_M2_SIZE_reg))
+#define VO_M2_SIZE_inst_adr                                                          "0x0083"
+#define VO_M2_SIZE_inst                                                              0x0083
+#define VO_M2_SIZE_w_shift                                                           (16)
+#define VO_M2_SIZE_w_mask                                                            (0x1FFF0000)
+#define VO_M2_SIZE_w(data)                                                           (0x1FFF0000&((data)<<16))
+#define VO_M2_SIZE_w_src(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_M2_SIZE_get_w(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_M2_SIZE_h_shift                                                           (0)
+#define VO_M2_SIZE_h_mask                                                            (0x00001FFF)
+#define VO_M2_SIZE_h(data)                                                           (0x00001FFF&((data)<<0))
+#define VO_M2_SIZE_h_src(data)                                                       ((0x00001FFF&(data))>>0)
+#define VO_M2_SIZE_get_h(data)                                                       ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1_XY                                                                     0x18005610
+#define VO_V1_XY_reg_addr                                                            "0xB8005610"
+#define VO_V1_XY_reg                                                                 0xB8005610
+#define set_VO_V1_XY_reg(data)   (*((volatile unsigned int*) VO_V1_XY_reg)=data)
+#define get_VO_V1_XY_reg   (*((volatile unsigned int*) VO_V1_XY_reg))
+#define VO_V1_XY_inst_adr                                                            "0x0084"
+#define VO_V1_XY_inst                                                                0x0084
+#define VO_V1_XY_x_shift                                                             (16)
+#define VO_V1_XY_x_mask                                                              (0x1FFF0000)
+#define VO_V1_XY_x(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_V1_XY_x_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1_XY_get_x(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1_XY_y_shift                                                             (0)
+#define VO_V1_XY_y_mask                                                              (0x00001FFF)
+#define VO_V1_XY_y(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_V1_XY_y_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_V1_XY_get_y(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1B_C                                                                     0x18005614
+#define VO_V1B_C_reg_addr                                                            "0xB8005614"
+#define VO_V1B_C_reg                                                                 0xB8005614
+#define set_VO_V1B_C_reg(data)   (*((volatile unsigned int*) VO_V1B_C_reg)=data)
+#define get_VO_V1B_C_reg   (*((volatile unsigned int*) VO_V1B_C_reg))
+#define VO_V1B_C_inst_adr                                                            "0x0085"
+#define VO_V1B_C_inst                                                                0x0085
+#define VO_V1B_C_cr_shift                                                            (16)
+#define VO_V1B_C_cr_mask                                                             (0x00FF0000)
+#define VO_V1B_C_cr(data)                                                            (0x00FF0000&((data)<<16))
+#define VO_V1B_C_cr_src(data)                                                        ((0x00FF0000&(data))>>16)
+#define VO_V1B_C_get_cr(data)                                                        ((0x00FF0000&(data))>>16)
+#define VO_V1B_C_cb_shift                                                            (8)
+#define VO_V1B_C_cb_mask                                                             (0x0000FF00)
+#define VO_V1B_C_cb(data)                                                            (0x0000FF00&((data)<<8))
+#define VO_V1B_C_cb_src(data)                                                        ((0x0000FF00&(data))>>8)
+#define VO_V1B_C_get_cb(data)                                                        ((0x0000FF00&(data))>>8)
+#define VO_V1B_C_y_shift                                                             (0)
+#define VO_V1B_C_y_mask                                                              (0x000000FF)
+#define VO_V1B_C_y(data)                                                             (0x000000FF&((data)<<0))
+#define VO_V1B_C_y_src(data)                                                         ((0x000000FF&(data))>>0)
+#define VO_V1B_C_get_y(data)                                                         ((0x000000FF&(data))>>0)
+
+
+#define VO_V1B_X                                                                     0x18005618
+#define VO_V1B_X_reg_addr                                                            "0xB8005618"
+#define VO_V1B_X_reg                                                                 0xB8005618
+#define set_VO_V1B_X_reg(data)   (*((volatile unsigned int*) VO_V1B_X_reg)=data)
+#define get_VO_V1B_X_reg   (*((volatile unsigned int*) VO_V1B_X_reg))
+#define VO_V1B_X_inst_adr                                                            "0x0086"
+#define VO_V1B_X_inst                                                                0x0086
+#define VO_V1B_X_e_shift                                                             (16)
+#define VO_V1B_X_e_mask                                                              (0x1FFF0000)
+#define VO_V1B_X_e(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_V1B_X_e_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1B_X_get_e(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1B_X_s_shift                                                             (0)
+#define VO_V1B_X_s_mask                                                              (0x00001FFF)
+#define VO_V1B_X_s(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_V1B_X_s_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_V1B_X_get_s(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1B_Y                                                                     0x1800561C
+#define VO_V1B_Y_reg_addr                                                            "0xB800561C"
+#define VO_V1B_Y_reg                                                                 0xB800561C
+#define set_VO_V1B_Y_reg(data)   (*((volatile unsigned int*) VO_V1B_Y_reg)=data)
+#define get_VO_V1B_Y_reg   (*((volatile unsigned int*) VO_V1B_Y_reg))
+#define VO_V1B_Y_inst_adr                                                            "0x0087"
+#define VO_V1B_Y_inst                                                                0x0087
+#define VO_V1B_Y_e_shift                                                             (16)
+#define VO_V1B_Y_e_mask                                                              (0x1FFF0000)
+#define VO_V1B_Y_e(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_V1B_Y_e_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1B_Y_get_e(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_V1B_Y_s_shift                                                             (0)
+#define VO_V1B_Y_s_mask                                                              (0x00001FFF)
+#define VO_V1B_Y_s(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_V1B_Y_s_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_V1B_Y_get_s(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_V1_3D                                                                     0x18005620
+#define VO_V1_3D_reg_addr                                                            "0xB8005620"
+#define VO_V1_3D_reg                                                                 0xB8005620
+#define set_VO_V1_3D_reg(data)   (*((volatile unsigned int*) VO_V1_3D_reg)=data)
+#define get_VO_V1_3D_reg   (*((volatile unsigned int*) VO_V1_3D_reg))
+#define VO_V1_3D_inst_adr                                                            "0x0088"
+#define VO_V1_3D_inst                                                                0x0088
+#define VO_V1_3D_dir_r_shift                                                         (29)
+#define VO_V1_3D_dir_r_mask                                                          (0x20000000)
+#define VO_V1_3D_dir_r(data)                                                         (0x20000000&((data)<<29))
+#define VO_V1_3D_dir_r_src(data)                                                     ((0x20000000&(data))>>29)
+#define VO_V1_3D_get_dir_r(data)                                                     ((0x20000000&(data))>>29)
+#define VO_V1_3D_offset_r_shift                                                      (16)
+#define VO_V1_3D_offset_r_mask                                                       (0x1FFF0000)
+#define VO_V1_3D_offset_r(data)                                                      (0x1FFF0000&((data)<<16))
+#define VO_V1_3D_offset_r_src(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_V1_3D_get_offset_r(data)                                                  ((0x1FFF0000&(data))>>16)
+#define VO_V1_3D_dir_l_shift                                                         (13)
+#define VO_V1_3D_dir_l_mask                                                          (0x00002000)
+#define VO_V1_3D_dir_l(data)                                                         (0x00002000&((data)<<13))
+#define VO_V1_3D_dir_l_src(data)                                                     ((0x00002000&(data))>>13)
+#define VO_V1_3D_get_dir_l(data)                                                     ((0x00002000&(data))>>13)
+#define VO_V1_3D_offset_l_shift                                                      (0)
+#define VO_V1_3D_offset_l_mask                                                       (0x00001FFF)
+#define VO_V1_3D_offset_l(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_V1_3D_offset_l_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_V1_3D_get_offset_l(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_SUB1_XY                                                                   0x18005624
+#define VO_SUB1_XY_reg_addr                                                          "0xB8005624"
+#define VO_SUB1_XY_reg                                                               0xB8005624
+#define set_VO_SUB1_XY_reg(data)   (*((volatile unsigned int*) VO_SUB1_XY_reg)=data)
+#define get_VO_SUB1_XY_reg   (*((volatile unsigned int*) VO_SUB1_XY_reg))
+#define VO_SUB1_XY_inst_adr                                                          "0x0089"
+#define VO_SUB1_XY_inst                                                              0x0089
+#define VO_SUB1_XY_x_shift                                                           (16)
+#define VO_SUB1_XY_x_mask                                                            (0x1FFF0000)
+#define VO_SUB1_XY_x(data)                                                           (0x1FFF0000&((data)<<16))
+#define VO_SUB1_XY_x_src(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_SUB1_XY_get_x(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_SUB1_XY_y_shift                                                           (0)
+#define VO_SUB1_XY_y_mask                                                            (0x00001FFF)
+#define VO_SUB1_XY_y(data)                                                           (0x00001FFF&((data)<<0))
+#define VO_SUB1_XY_y_src(data)                                                       ((0x00001FFF&(data))>>0)
+#define VO_SUB1_XY_get_y(data)                                                       ((0x00001FFF&(data))>>0)
+
+
+#define VO_SUB1_3D                                                                   0x18005628
+#define VO_SUB1_3D_reg_addr                                                          "0xB8005628"
+#define VO_SUB1_3D_reg                                                               0xB8005628
+#define set_VO_SUB1_3D_reg(data)   (*((volatile unsigned int*) VO_SUB1_3D_reg)=data)
+#define get_VO_SUB1_3D_reg   (*((volatile unsigned int*) VO_SUB1_3D_reg))
+#define VO_SUB1_3D_inst_adr                                                          "0x008A"
+#define VO_SUB1_3D_inst                                                              0x008A
+#define VO_SUB1_3D_dir_r_shift                                                       (29)
+#define VO_SUB1_3D_dir_r_mask                                                        (0x20000000)
+#define VO_SUB1_3D_dir_r(data)                                                       (0x20000000&((data)<<29))
+#define VO_SUB1_3D_dir_r_src(data)                                                   ((0x20000000&(data))>>29)
+#define VO_SUB1_3D_get_dir_r(data)                                                   ((0x20000000&(data))>>29)
+#define VO_SUB1_3D_offset_r_shift                                                    (16)
+#define VO_SUB1_3D_offset_r_mask                                                     (0x1FFF0000)
+#define VO_SUB1_3D_offset_r(data)                                                    (0x1FFF0000&((data)<<16))
+#define VO_SUB1_3D_offset_r_src(data)                                                ((0x1FFF0000&(data))>>16)
+#define VO_SUB1_3D_get_offset_r(data)                                                ((0x1FFF0000&(data))>>16)
+#define VO_SUB1_3D_dir_l_shift                                                       (13)
+#define VO_SUB1_3D_dir_l_mask                                                        (0x00002000)
+#define VO_SUB1_3D_dir_l(data)                                                       (0x00002000&((data)<<13))
+#define VO_SUB1_3D_dir_l_src(data)                                                   ((0x00002000&(data))>>13)
+#define VO_SUB1_3D_get_dir_l(data)                                                   ((0x00002000&(data))>>13)
+#define VO_SUB1_3D_offset_l_shift                                                    (0)
+#define VO_SUB1_3D_offset_l_mask                                                     (0x00001FFF)
+#define VO_SUB1_3D_offset_l(data)                                                    (0x00001FFF&((data)<<0))
+#define VO_SUB1_3D_offset_l_src(data)                                                ((0x00001FFF&(data))>>0)
+#define VO_SUB1_3D_get_offset_l(data)                                                ((0x00001FFF&(data))>>0)
+
+
+#define VO_OSD1_XY                                                                   0x1800562C
+#define VO_OSD1_XY_reg_addr                                                          "0xB800562C"
+#define VO_OSD1_XY_reg                                                               0xB800562C
+#define set_VO_OSD1_XY_reg(data)   (*((volatile unsigned int*) VO_OSD1_XY_reg)=data)
+#define get_VO_OSD1_XY_reg   (*((volatile unsigned int*) VO_OSD1_XY_reg))
+#define VO_OSD1_XY_inst_adr                                                          "0x008B"
+#define VO_OSD1_XY_inst                                                              0x008B
+#define VO_OSD1_XY_x_shift                                                           (16)
+#define VO_OSD1_XY_x_mask                                                            (0x1FFF0000)
+#define VO_OSD1_XY_x(data)                                                           (0x1FFF0000&((data)<<16))
+#define VO_OSD1_XY_x_src(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_OSD1_XY_get_x(data)                                                       ((0x1FFF0000&(data))>>16)
+#define VO_OSD1_XY_y_shift                                                           (0)
+#define VO_OSD1_XY_y_mask                                                            (0x00001FFF)
+#define VO_OSD1_XY_y(data)                                                           (0x00001FFF&((data)<<0))
+#define VO_OSD1_XY_y_src(data)                                                       ((0x00001FFF&(data))>>0)
+#define VO_OSD1_XY_get_y(data)                                                       ((0x00001FFF&(data))>>0)
+
+
+#define VO_OSD1_3D                                                                   0x18005630
+#define VO_OSD1_3D_reg_addr                                                          "0xB8005630"
+#define VO_OSD1_3D_reg                                                               0xB8005630
+#define set_VO_OSD1_3D_reg(data)   (*((volatile unsigned int*) VO_OSD1_3D_reg)=data)
+#define get_VO_OSD1_3D_reg   (*((volatile unsigned int*) VO_OSD1_3D_reg))
+#define VO_OSD1_3D_inst_adr                                                          "0x008C"
+#define VO_OSD1_3D_inst                                                              0x008C
+#define VO_OSD1_3D_dir_r_shift                                                       (29)
+#define VO_OSD1_3D_dir_r_mask                                                        (0x20000000)
+#define VO_OSD1_3D_dir_r(data)                                                       (0x20000000&((data)<<29))
+#define VO_OSD1_3D_dir_r_src(data)                                                   ((0x20000000&(data))>>29)
+#define VO_OSD1_3D_get_dir_r(data)                                                   ((0x20000000&(data))>>29)
+#define VO_OSD1_3D_offset_r_shift                                                    (16)
+#define VO_OSD1_3D_offset_r_mask                                                     (0x1FFF0000)
+#define VO_OSD1_3D_offset_r(data)                                                    (0x1FFF0000&((data)<<16))
+#define VO_OSD1_3D_offset_r_src(data)                                                ((0x1FFF0000&(data))>>16)
+#define VO_OSD1_3D_get_offset_r(data)                                                ((0x1FFF0000&(data))>>16)
+#define VO_OSD1_3D_dir_l_shift                                                       (13)
+#define VO_OSD1_3D_dir_l_mask                                                        (0x00002000)
+#define VO_OSD1_3D_dir_l(data)                                                       (0x00002000&((data)<<13))
+#define VO_OSD1_3D_dir_l_src(data)                                                   ((0x00002000&(data))>>13)
+#define VO_OSD1_3D_get_dir_l(data)                                                   ((0x00002000&(data))>>13)
+#define VO_OSD1_3D_offset_l_shift                                                    (0)
+#define VO_OSD1_3D_offset_l_mask                                                     (0x00001FFF)
+#define VO_OSD1_3D_offset_l(data)                                                    (0x00001FFF&((data)<<0))
+#define VO_OSD1_3D_offset_l_src(data)                                                ((0x00001FFF&(data))>>0)
+#define VO_OSD1_3D_get_offset_l(data)                                                ((0x00001FFF&(data))>>0)
+
+
+#define VO_DD_XY                                                                     0x18005634
+#define VO_DD_XY_reg_addr                                                            "0xB8005634"
+#define VO_DD_XY_reg                                                                 0xB8005634
+#define set_VO_DD_XY_reg(data)   (*((volatile unsigned int*) VO_DD_XY_reg)=data)
+#define get_VO_DD_XY_reg   (*((volatile unsigned int*) VO_DD_XY_reg))
+#define VO_DD_XY_inst_adr                                                            "0x008D"
+#define VO_DD_XY_inst                                                                0x008D
+#define VO_DD_XY_x_shift                                                             (16)
+#define VO_DD_XY_x_mask                                                              (0x1FFF0000)
+#define VO_DD_XY_x(data)                                                             (0x1FFF0000&((data)<<16))
+#define VO_DD_XY_x_src(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_DD_XY_get_x(data)                                                         ((0x1FFF0000&(data))>>16)
+#define VO_DD_XY_y_shift                                                             (0)
+#define VO_DD_XY_y_mask                                                              (0x00001FFF)
+#define VO_DD_XY_y(data)                                                             (0x00001FFF&((data)<<0))
+#define VO_DD_XY_y_src(data)                                                         ((0x00001FFF&(data))>>0)
+#define VO_DD_XY_get_y(data)                                                         ((0x00001FFF&(data))>>0)
+
+
+#define VO_CH1_BUF                                                                   0x18005638
+#define VO_CH1_BUF_reg_addr                                                          "0xB8005638"
+#define VO_CH1_BUF_reg                                                               0xB8005638
+#define set_VO_CH1_BUF_reg(data)   (*((volatile unsigned int*) VO_CH1_BUF_reg)=data)
+#define get_VO_CH1_BUF_reg   (*((volatile unsigned int*) VO_CH1_BUF_reg))
+#define VO_CH1_BUF_inst_adr                                                          "0x008E"
+#define VO_CH1_BUF_inst                                                              0x008E
+#define VO_CH1_BUF_write_en2_shift                                                   (23)
+#define VO_CH1_BUF_write_en2_mask                                                    (0x00800000)
+#define VO_CH1_BUF_write_en2(data)                                                   (0x00800000&((data)<<23))
+#define VO_CH1_BUF_write_en2_src(data)                                               ((0x00800000&(data))>>23)
+#define VO_CH1_BUF_get_write_en2(data)                                               ((0x00800000&(data))>>23)
+#define VO_CH1_BUF_th_shift                                                          (12)
+#define VO_CH1_BUF_th_mask                                                           (0x007FF000)
+#define VO_CH1_BUF_th(data)                                                          (0x007FF000&((data)<<12))
+#define VO_CH1_BUF_th_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CH1_BUF_get_th(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CH1_BUF_write_en1_shift                                                   (11)
+#define VO_CH1_BUF_write_en1_mask                                                    (0x00000800)
+#define VO_CH1_BUF_write_en1(data)                                                   (0x00000800&((data)<<11))
+#define VO_CH1_BUF_write_en1_src(data)                                               ((0x00000800&(data))>>11)
+#define VO_CH1_BUF_get_write_en1(data)                                               ((0x00000800&(data))>>11)
+#define VO_CH1_BUF_b_shift                                                           (0)
+#define VO_CH1_BUF_b_mask                                                            (0x000007FF)
+#define VO_CH1_BUF_b(data)                                                           (0x000007FF&((data)<<0))
+#define VO_CH1_BUF_b_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VO_CH1_BUF_get_b(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VO_CHI_BUF                                                                   0x1800563C
+#define VO_CHI_BUF_reg_addr                                                          "0xB800563C"
+#define VO_CHI_BUF_reg                                                               0xB800563C
+#define set_VO_CHI_BUF_reg(data)   (*((volatile unsigned int*) VO_CHI_BUF_reg)=data)
+#define get_VO_CHI_BUF_reg   (*((volatile unsigned int*) VO_CHI_BUF_reg))
+#define VO_CHI_BUF_inst_adr                                                          "0x008F"
+#define VO_CHI_BUF_inst                                                              0x008F
+#define VO_CHI_BUF_write_en2_shift                                                   (23)
+#define VO_CHI_BUF_write_en2_mask                                                    (0x00800000)
+#define VO_CHI_BUF_write_en2(data)                                                   (0x00800000&((data)<<23))
+#define VO_CHI_BUF_write_en2_src(data)                                               ((0x00800000&(data))>>23)
+#define VO_CHI_BUF_get_write_en2(data)                                               ((0x00800000&(data))>>23)
+#define VO_CHI_BUF_th_shift                                                          (12)
+#define VO_CHI_BUF_th_mask                                                           (0x007FF000)
+#define VO_CHI_BUF_th(data)                                                          (0x007FF000&((data)<<12))
+#define VO_CHI_BUF_th_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CHI_BUF_get_th(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CHI_BUF_write_en1_shift                                                   (11)
+#define VO_CHI_BUF_write_en1_mask                                                    (0x00000800)
+#define VO_CHI_BUF_write_en1(data)                                                   (0x00000800&((data)<<11))
+#define VO_CHI_BUF_write_en1_src(data)                                               ((0x00000800&(data))>>11)
+#define VO_CHI_BUF_get_write_en1(data)                                               ((0x00000800&(data))>>11)
+#define VO_CHI_BUF_b_shift                                                           (0)
+#define VO_CHI_BUF_b_mask                                                            (0x000007FF)
+#define VO_CHI_BUF_b(data)                                                           (0x000007FF&((data)<<0))
+#define VO_CHI_BUF_b_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VO_CHI_BUF_get_b(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VO_CH2_BUF                                                                   0x18005640
+#define VO_CH2_BUF_reg_addr                                                          "0xB8005640"
+#define VO_CH2_BUF_reg                                                               0xB8005640
+#define set_VO_CH2_BUF_reg(data)   (*((volatile unsigned int*) VO_CH2_BUF_reg)=data)
+#define get_VO_CH2_BUF_reg   (*((volatile unsigned int*) VO_CH2_BUF_reg))
+#define VO_CH2_BUF_inst_adr                                                          "0x0090"
+#define VO_CH2_BUF_inst                                                              0x0090
+#define VO_CH2_BUF_write_en2_shift                                                   (23)
+#define VO_CH2_BUF_write_en2_mask                                                    (0x00800000)
+#define VO_CH2_BUF_write_en2(data)                                                   (0x00800000&((data)<<23))
+#define VO_CH2_BUF_write_en2_src(data)                                               ((0x00800000&(data))>>23)
+#define VO_CH2_BUF_get_write_en2(data)                                               ((0x00800000&(data))>>23)
+#define VO_CH2_BUF_th_shift                                                          (12)
+#define VO_CH2_BUF_th_mask                                                           (0x007FF000)
+#define VO_CH2_BUF_th(data)                                                          (0x007FF000&((data)<<12))
+#define VO_CH2_BUF_th_src(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CH2_BUF_get_th(data)                                                      ((0x007FF000&(data))>>12)
+#define VO_CH2_BUF_write_en1_shift                                                   (11)
+#define VO_CH2_BUF_write_en1_mask                                                    (0x00000800)
+#define VO_CH2_BUF_write_en1(data)                                                   (0x00000800&((data)<<11))
+#define VO_CH2_BUF_write_en1_src(data)                                               ((0x00000800&(data))>>11)
+#define VO_CH2_BUF_get_write_en1(data)                                               ((0x00000800&(data))>>11)
+#define VO_CH2_BUF_b_shift                                                           (0)
+#define VO_CH2_BUF_b_mask                                                            (0x000007FF)
+#define VO_CH2_BUF_b(data)                                                           (0x000007FF&((data)<<0))
+#define VO_CH2_BUF_b_src(data)                                                       ((0x000007FF&(data))>>0)
+#define VO_CH2_BUF_get_b(data)                                                       ((0x000007FF&(data))>>0)
+
+
+#define VO_CH1                                                                       0x18005644
+#define VO_CH1_reg_addr                                                              "0xB8005644"
+#define VO_CH1_reg                                                                   0xB8005644
+#define set_VO_CH1_reg(data)   (*((volatile unsigned int*) VO_CH1_reg)=data)
+#define get_VO_CH1_reg   (*((volatile unsigned int*) VO_CH1_reg))
+#define VO_CH1_inst_adr                                                              "0x0091"
+#define VO_CH1_inst                                                                  0x0091
+#define VO_CH1_itop_shift                                                            (5)
+#define VO_CH1_itop_mask                                                             (0x00000020)
+#define VO_CH1_itop(data)                                                            (0x00000020&((data)<<5))
+#define VO_CH1_itop_src(data)                                                        ((0x00000020&(data))>>5)
+#define VO_CH1_get_itop(data)                                                        ((0x00000020&(data))>>5)
+#define VO_CH1_ireint_shift                                                          (4)
+#define VO_CH1_ireint_mask                                                           (0x00000010)
+#define VO_CH1_ireint(data)                                                          (0x00000010&((data)<<4))
+#define VO_CH1_ireint_src(data)                                                      ((0x00000010&(data))>>4)
+#define VO_CH1_get_ireint(data)                                                      ((0x00000010&(data))>>4)
+#define VO_CH1_top_shift                                                             (2)
+#define VO_CH1_top_mask                                                              (0x00000004)
+#define VO_CH1_top(data)                                                             (0x00000004&((data)<<2))
+#define VO_CH1_top_src(data)                                                         ((0x00000004&(data))>>2)
+#define VO_CH1_get_top(data)                                                         ((0x00000004&(data))>>2)
+#define VO_CH1_reint_shift                                                           (1)
+#define VO_CH1_reint_mask                                                            (0x00000002)
+#define VO_CH1_reint(data)                                                           (0x00000002&((data)<<1))
+#define VO_CH1_reint_src(data)                                                       ((0x00000002&(data))>>1)
+#define VO_CH1_get_reint(data)                                                       ((0x00000002&(data))>>1)
+#define VO_CH1_write_data_shift                                                      (0)
+#define VO_CH1_write_data_mask                                                       (0x00000001)
+#define VO_CH1_write_data(data)                                                      (0x00000001&((data)<<0))
+#define VO_CH1_write_data_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_CH1_get_write_data(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_CH2                                                                       0x18005648
+#define VO_CH2_reg_addr                                                              "0xB8005648"
+#define VO_CH2_reg                                                                   0xB8005648
+#define set_VO_CH2_reg(data)   (*((volatile unsigned int*) VO_CH2_reg)=data)
+#define get_VO_CH2_reg   (*((volatile unsigned int*) VO_CH2_reg))
+#define VO_CH2_inst_adr                                                              "0x0092"
+#define VO_CH2_inst                                                                  0x0092
+#define VO_CH2_itop_shift                                                            (5)
+#define VO_CH2_itop_mask                                                             (0x00000020)
+#define VO_CH2_itop(data)                                                            (0x00000020&((data)<<5))
+#define VO_CH2_itop_src(data)                                                        ((0x00000020&(data))>>5)
+#define VO_CH2_get_itop(data)                                                        ((0x00000020&(data))>>5)
+#define VO_CH2_ireint_shift                                                          (4)
+#define VO_CH2_ireint_mask                                                           (0x00000010)
+#define VO_CH2_ireint(data)                                                          (0x00000010&((data)<<4))
+#define VO_CH2_ireint_src(data)                                                      ((0x00000010&(data))>>4)
+#define VO_CH2_get_ireint(data)                                                      ((0x00000010&(data))>>4)
+#define VO_CH2_top_shift                                                             (2)
+#define VO_CH2_top_mask                                                              (0x00000004)
+#define VO_CH2_top(data)                                                             (0x00000004&((data)<<2))
+#define VO_CH2_top_src(data)                                                         ((0x00000004&(data))>>2)
+#define VO_CH2_get_top(data)                                                         ((0x00000004&(data))>>2)
+#define VO_CH2_reint_shift                                                           (1)
+#define VO_CH2_reint_mask                                                            (0x00000002)
+#define VO_CH2_reint(data)                                                           (0x00000002&((data)<<1))
+#define VO_CH2_reint_src(data)                                                       ((0x00000002&(data))>>1)
+#define VO_CH2_get_reint(data)                                                       ((0x00000002&(data))>>1)
+#define VO_CH2_write_data_shift                                                      (0)
+#define VO_CH2_write_data_mask                                                       (0x00000001)
+#define VO_CH2_write_data(data)                                                      (0x00000001&((data)<<0))
+#define VO_CH2_write_data_src(data)                                                  ((0x00000001&(data))>>0)
+#define VO_CH2_get_write_data(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define VO_PORT_L_CC1                                                                0x1800564C
+#define VO_PORT_L_CC1_reg_addr                                                       "0xB800564C"
+#define VO_PORT_L_CC1_reg                                                            0xB800564C
+#define set_VO_PORT_L_CC1_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC1_reg)=data)
+#define get_VO_PORT_L_CC1_reg   (*((volatile unsigned int*) VO_PORT_L_CC1_reg))
+#define VO_PORT_L_CC1_inst_adr                                                       "0x0093"
+#define VO_PORT_L_CC1_inst                                                           0x0093
+#define VO_PORT_L_CC1_m01_shift                                                      (16)
+#define VO_PORT_L_CC1_m01_mask                                                       (0x3FFF0000)
+#define VO_PORT_L_CC1_m01(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_L_CC1_m01_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC1_get_m01(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC1_m00_shift                                                      (0)
+#define VO_PORT_L_CC1_m00_mask                                                       (0x00003FFF)
+#define VO_PORT_L_CC1_m00(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_L_CC1_m00_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_L_CC1_get_m00(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC2                                                                0x18005650
+#define VO_PORT_L_CC2_reg_addr                                                       "0xB8005650"
+#define VO_PORT_L_CC2_reg                                                            0xB8005650
+#define set_VO_PORT_L_CC2_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC2_reg)=data)
+#define get_VO_PORT_L_CC2_reg   (*((volatile unsigned int*) VO_PORT_L_CC2_reg))
+#define VO_PORT_L_CC2_inst_adr                                                       "0x0094"
+#define VO_PORT_L_CC2_inst                                                           0x0094
+#define VO_PORT_L_CC2_m10_shift                                                      (16)
+#define VO_PORT_L_CC2_m10_mask                                                       (0x3FFF0000)
+#define VO_PORT_L_CC2_m10(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_L_CC2_m10_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC2_get_m10(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC2_m02_shift                                                      (0)
+#define VO_PORT_L_CC2_m02_mask                                                       (0x00003FFF)
+#define VO_PORT_L_CC2_m02(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_L_CC2_m02_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_L_CC2_get_m02(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC3                                                                0x18005654
+#define VO_PORT_L_CC3_reg_addr                                                       "0xB8005654"
+#define VO_PORT_L_CC3_reg                                                            0xB8005654
+#define set_VO_PORT_L_CC3_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC3_reg)=data)
+#define get_VO_PORT_L_CC3_reg   (*((volatile unsigned int*) VO_PORT_L_CC3_reg))
+#define VO_PORT_L_CC3_inst_adr                                                       "0x0095"
+#define VO_PORT_L_CC3_inst                                                           0x0095
+#define VO_PORT_L_CC3_m12_shift                                                      (16)
+#define VO_PORT_L_CC3_m12_mask                                                       (0x3FFF0000)
+#define VO_PORT_L_CC3_m12(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_L_CC3_m12_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC3_get_m12(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC3_m11_shift                                                      (0)
+#define VO_PORT_L_CC3_m11_mask                                                       (0x00003FFF)
+#define VO_PORT_L_CC3_m11(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_L_CC3_m11_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_L_CC3_get_m11(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC4                                                                0x18005658
+#define VO_PORT_L_CC4_reg_addr                                                       "0xB8005658"
+#define VO_PORT_L_CC4_reg                                                            0xB8005658
+#define set_VO_PORT_L_CC4_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC4_reg)=data)
+#define get_VO_PORT_L_CC4_reg   (*((volatile unsigned int*) VO_PORT_L_CC4_reg))
+#define VO_PORT_L_CC4_inst_adr                                                       "0x0096"
+#define VO_PORT_L_CC4_inst                                                           0x0096
+#define VO_PORT_L_CC4_m21_shift                                                      (16)
+#define VO_PORT_L_CC4_m21_mask                                                       (0x3FFF0000)
+#define VO_PORT_L_CC4_m21(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_L_CC4_m21_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC4_get_m21(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_L_CC4_m20_shift                                                      (0)
+#define VO_PORT_L_CC4_m20_mask                                                       (0x00003FFF)
+#define VO_PORT_L_CC4_m20(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_L_CC4_m20_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_L_CC4_get_m20(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC5                                                                0x1800565C
+#define VO_PORT_L_CC5_reg_addr                                                       "0xB800565C"
+#define VO_PORT_L_CC5_reg                                                            0xB800565C
+#define set_VO_PORT_L_CC5_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC5_reg)=data)
+#define get_VO_PORT_L_CC5_reg   (*((volatile unsigned int*) VO_PORT_L_CC5_reg))
+#define VO_PORT_L_CC5_inst_adr                                                       "0x0097"
+#define VO_PORT_L_CC5_inst                                                           0x0097
+#define VO_PORT_L_CC5_m22_shift                                                      (0)
+#define VO_PORT_L_CC5_m22_mask                                                       (0x00003FFF)
+#define VO_PORT_L_CC5_m22(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_L_CC5_m22_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_L_CC5_get_m22(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_L_CC6                                                                0x18005660
+#define VO_PORT_L_CC6_reg_addr                                                       "0xB8005660"
+#define VO_PORT_L_CC6_reg                                                            0xB8005660
+#define set_VO_PORT_L_CC6_reg(data)   (*((volatile unsigned int*) VO_PORT_L_CC6_reg)=data)
+#define get_VO_PORT_L_CC6_reg   (*((volatile unsigned int*) VO_PORT_L_CC6_reg))
+#define VO_PORT_L_CC6_inst_adr                                                       "0x0098"
+#define VO_PORT_L_CC6_inst                                                           0x0098
+#define VO_PORT_L_CC6_a2_shift                                                       (20)
+#define VO_PORT_L_CC6_a2_mask                                                        (0x3FF00000)
+#define VO_PORT_L_CC6_a2(data)                                                       (0x3FF00000&((data)<<20))
+#define VO_PORT_L_CC6_a2_src(data)                                                   ((0x3FF00000&(data))>>20)
+#define VO_PORT_L_CC6_get_a2(data)                                                   ((0x3FF00000&(data))>>20)
+#define VO_PORT_L_CC6_a1_shift                                                       (10)
+#define VO_PORT_L_CC6_a1_mask                                                        (0x000FFC00)
+#define VO_PORT_L_CC6_a1(data)                                                       (0x000FFC00&((data)<<10))
+#define VO_PORT_L_CC6_a1_src(data)                                                   ((0x000FFC00&(data))>>10)
+#define VO_PORT_L_CC6_get_a1(data)                                                   ((0x000FFC00&(data))>>10)
+#define VO_PORT_L_CC6_a0_shift                                                       (0)
+#define VO_PORT_L_CC6_a0_mask                                                        (0x000003FF)
+#define VO_PORT_L_CC6_a0(data)                                                       (0x000003FF&((data)<<0))
+#define VO_PORT_L_CC6_a0_src(data)                                                   ((0x000003FF&(data))>>0)
+#define VO_PORT_L_CC6_get_a0(data)                                                   ((0x000003FF&(data))>>0)
+
+
+#define VO_PORT_L_LMT_R                                                              0x18005664
+#define VO_PORT_L_LMT_R_reg_addr                                                     "0xB8005664"
+#define VO_PORT_L_LMT_R_reg                                                          0xB8005664
+#define set_VO_PORT_L_LMT_R_reg(data)   (*((volatile unsigned int*) VO_PORT_L_LMT_R_reg)=data)
+#define get_VO_PORT_L_LMT_R_reg   (*((volatile unsigned int*) VO_PORT_L_LMT_R_reg))
+#define VO_PORT_L_LMT_R_inst_adr                                                     "0x0099"
+#define VO_PORT_L_LMT_R_inst                                                         0x0099
+#define VO_PORT_L_LMT_R_rmax_shift                                                   (8)
+#define VO_PORT_L_LMT_R_rmax_mask                                                    (0x0000FF00)
+#define VO_PORT_L_LMT_R_rmax(data)                                                   (0x0000FF00&((data)<<8))
+#define VO_PORT_L_LMT_R_rmax_src(data)                                               ((0x0000FF00&(data))>>8)
+#define VO_PORT_L_LMT_R_get_rmax(data)                                               ((0x0000FF00&(data))>>8)
+#define VO_PORT_L_LMT_R_rmin_shift                                                   (0)
+#define VO_PORT_L_LMT_R_rmin_mask                                                    (0x000000FF)
+#define VO_PORT_L_LMT_R_rmin(data)                                                   (0x000000FF&((data)<<0))
+#define VO_PORT_L_LMT_R_rmin_src(data)                                               ((0x000000FF&(data))>>0)
+#define VO_PORT_L_LMT_R_get_rmin(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define VO_PORT_L_LMT_G                                                              0x18005668
+#define VO_PORT_L_LMT_G_reg_addr                                                     "0xB8005668"
+#define VO_PORT_L_LMT_G_reg                                                          0xB8005668
+#define set_VO_PORT_L_LMT_G_reg(data)   (*((volatile unsigned int*) VO_PORT_L_LMT_G_reg)=data)
+#define get_VO_PORT_L_LMT_G_reg   (*((volatile unsigned int*) VO_PORT_L_LMT_G_reg))
+#define VO_PORT_L_LMT_G_inst_adr                                                     "0x009A"
+#define VO_PORT_L_LMT_G_inst                                                         0x009A
+#define VO_PORT_L_LMT_G_gmax_shift                                                   (8)
+#define VO_PORT_L_LMT_G_gmax_mask                                                    (0x0000FF00)
+#define VO_PORT_L_LMT_G_gmax(data)                                                   (0x0000FF00&((data)<<8))
+#define VO_PORT_L_LMT_G_gmax_src(data)                                               ((0x0000FF00&(data))>>8)
+#define VO_PORT_L_LMT_G_get_gmax(data)                                               ((0x0000FF00&(data))>>8)
+#define VO_PORT_L_LMT_G_gmin_shift                                                   (0)
+#define VO_PORT_L_LMT_G_gmin_mask                                                    (0x000000FF)
+#define VO_PORT_L_LMT_G_gmin(data)                                                   (0x000000FF&((data)<<0))
+#define VO_PORT_L_LMT_G_gmin_src(data)                                               ((0x000000FF&(data))>>0)
+#define VO_PORT_L_LMT_G_get_gmin(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define VO_PORT_L_LMT_B                                                              0x1800566C
+#define VO_PORT_L_LMT_B_reg_addr                                                     "0xB800566C"
+#define VO_PORT_L_LMT_B_reg                                                          0xB800566C
+#define set_VO_PORT_L_LMT_B_reg(data)   (*((volatile unsigned int*) VO_PORT_L_LMT_B_reg)=data)
+#define get_VO_PORT_L_LMT_B_reg   (*((volatile unsigned int*) VO_PORT_L_LMT_B_reg))
+#define VO_PORT_L_LMT_B_inst_adr                                                     "0x009B"
+#define VO_PORT_L_LMT_B_inst                                                         0x009B
+#define VO_PORT_L_LMT_B_bmax_shift                                                   (8)
+#define VO_PORT_L_LMT_B_bmax_mask                                                    (0x0000FF00)
+#define VO_PORT_L_LMT_B_bmax(data)                                                   (0x0000FF00&((data)<<8))
+#define VO_PORT_L_LMT_B_bmax_src(data)                                               ((0x0000FF00&(data))>>8)
+#define VO_PORT_L_LMT_B_get_bmax(data)                                               ((0x0000FF00&(data))>>8)
+#define VO_PORT_L_LMT_B_bmin_shift                                                   (0)
+#define VO_PORT_L_LMT_B_bmin_mask                                                    (0x000000FF)
+#define VO_PORT_L_LMT_B_bmin(data)                                                   (0x000000FF&((data)<<0))
+#define VO_PORT_L_LMT_B_bmin_src(data)                                               ((0x000000FF&(data))>>0)
+#define VO_PORT_L_LMT_B_get_bmin(data)                                               ((0x000000FF&(data))>>0)
+
+
+#define VO_PORT_L_MODE                                                               0x18005670
+#define VO_PORT_L_MODE_reg_addr                                                      "0xB8005670"
+#define VO_PORT_L_MODE_reg                                                           0xB8005670
+#define set_VO_PORT_L_MODE_reg(data)   (*((volatile unsigned int*) VO_PORT_L_MODE_reg)=data)
+#define get_VO_PORT_L_MODE_reg   (*((volatile unsigned int*) VO_PORT_L_MODE_reg))
+#define VO_PORT_L_MODE_inst_adr                                                      "0x009C"
+#define VO_PORT_L_MODE_inst                                                          0x009C
+#define VO_PORT_L_MODE_pport_shift                                                   (0)
+#define VO_PORT_L_MODE_pport_mask                                                    (0x00000001)
+#define VO_PORT_L_MODE_pport(data)                                                   (0x00000001&((data)<<0))
+#define VO_PORT_L_MODE_pport_src(data)                                               ((0x00000001&(data))>>0)
+#define VO_PORT_L_MODE_get_pport(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VO_PORT_I_CC1                                                                0x18005674
+#define VO_PORT_I_CC1_reg_addr                                                       "0xB8005674"
+#define VO_PORT_I_CC1_reg                                                            0xB8005674
+#define set_VO_PORT_I_CC1_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC1_reg)=data)
+#define get_VO_PORT_I_CC1_reg   (*((volatile unsigned int*) VO_PORT_I_CC1_reg))
+#define VO_PORT_I_CC1_inst_adr                                                       "0x009D"
+#define VO_PORT_I_CC1_inst                                                           0x009D
+#define VO_PORT_I_CC1_m01_shift                                                      (16)
+#define VO_PORT_I_CC1_m01_mask                                                       (0x3FFF0000)
+#define VO_PORT_I_CC1_m01(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_I_CC1_m01_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC1_get_m01(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC1_m00_shift                                                      (0)
+#define VO_PORT_I_CC1_m00_mask                                                       (0x00003FFF)
+#define VO_PORT_I_CC1_m00(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_I_CC1_m00_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_I_CC1_get_m00(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_I_CC2                                                                0x18005678
+#define VO_PORT_I_CC2_reg_addr                                                       "0xB8005678"
+#define VO_PORT_I_CC2_reg                                                            0xB8005678
+#define set_VO_PORT_I_CC2_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC2_reg)=data)
+#define get_VO_PORT_I_CC2_reg   (*((volatile unsigned int*) VO_PORT_I_CC2_reg))
+#define VO_PORT_I_CC2_inst_adr                                                       "0x009E"
+#define VO_PORT_I_CC2_inst                                                           0x009E
+#define VO_PORT_I_CC2_m10_shift                                                      (16)
+#define VO_PORT_I_CC2_m10_mask                                                       (0x3FFF0000)
+#define VO_PORT_I_CC2_m10(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_I_CC2_m10_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC2_get_m10(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC2_m02_shift                                                      (0)
+#define VO_PORT_I_CC2_m02_mask                                                       (0x00003FFF)
+#define VO_PORT_I_CC2_m02(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_I_CC2_m02_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_I_CC2_get_m02(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_I_CC3                                                                0x1800567C
+#define VO_PORT_I_CC3_reg_addr                                                       "0xB800567C"
+#define VO_PORT_I_CC3_reg                                                            0xB800567C
+#define set_VO_PORT_I_CC3_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC3_reg)=data)
+#define get_VO_PORT_I_CC3_reg   (*((volatile unsigned int*) VO_PORT_I_CC3_reg))
+#define VO_PORT_I_CC3_inst_adr                                                       "0x009F"
+#define VO_PORT_I_CC3_inst                                                           0x009F
+#define VO_PORT_I_CC3_m12_shift                                                      (16)
+#define VO_PORT_I_CC3_m12_mask                                                       (0x3FFF0000)
+#define VO_PORT_I_CC3_m12(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_I_CC3_m12_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC3_get_m12(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC3_m11_shift                                                      (0)
+#define VO_PORT_I_CC3_m11_mask                                                       (0x00003FFF)
+#define VO_PORT_I_CC3_m11(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_I_CC3_m11_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_I_CC3_get_m11(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_I_CC4                                                                0x18005680
+#define VO_PORT_I_CC4_reg_addr                                                       "0xB8005680"
+#define VO_PORT_I_CC4_reg                                                            0xB8005680
+#define set_VO_PORT_I_CC4_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC4_reg)=data)
+#define get_VO_PORT_I_CC4_reg   (*((volatile unsigned int*) VO_PORT_I_CC4_reg))
+#define VO_PORT_I_CC4_inst_adr                                                       "0x00A0"
+#define VO_PORT_I_CC4_inst                                                           0x00A0
+#define VO_PORT_I_CC4_m21_shift                                                      (16)
+#define VO_PORT_I_CC4_m21_mask                                                       (0x3FFF0000)
+#define VO_PORT_I_CC4_m21(data)                                                      (0x3FFF0000&((data)<<16))
+#define VO_PORT_I_CC4_m21_src(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC4_get_m21(data)                                                  ((0x3FFF0000&(data))>>16)
+#define VO_PORT_I_CC4_m20_shift                                                      (0)
+#define VO_PORT_I_CC4_m20_mask                                                       (0x00003FFF)
+#define VO_PORT_I_CC4_m20(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_I_CC4_m20_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_I_CC4_get_m20(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_I_CC5                                                                0x18005684
+#define VO_PORT_I_CC5_reg_addr                                                       "0xB8005684"
+#define VO_PORT_I_CC5_reg                                                            0xB8005684
+#define set_VO_PORT_I_CC5_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC5_reg)=data)
+#define get_VO_PORT_I_CC5_reg   (*((volatile unsigned int*) VO_PORT_I_CC5_reg))
+#define VO_PORT_I_CC5_inst_adr                                                       "0x00A1"
+#define VO_PORT_I_CC5_inst                                                           0x00A1
+#define VO_PORT_I_CC5_m22_shift                                                      (0)
+#define VO_PORT_I_CC5_m22_mask                                                       (0x00003FFF)
+#define VO_PORT_I_CC5_m22(data)                                                      (0x00003FFF&((data)<<0))
+#define VO_PORT_I_CC5_m22_src(data)                                                  ((0x00003FFF&(data))>>0)
+#define VO_PORT_I_CC5_get_m22(data)                                                  ((0x00003FFF&(data))>>0)
+
+
+#define VO_PORT_I_CC6                                                                0x18005688
+#define VO_PORT_I_CC6_reg_addr                                                       "0xB8005688"
+#define VO_PORT_I_CC6_reg                                                            0xB8005688
+#define set_VO_PORT_I_CC6_reg(data)   (*((volatile unsigned int*) VO_PORT_I_CC6_reg)=data)
+#define get_VO_PORT_I_CC6_reg   (*((volatile unsigned int*) VO_PORT_I_CC6_reg))
+#define VO_PORT_I_CC6_inst_adr                                                       "0x00A2"
+#define VO_PORT_I_CC6_inst                                                           0x00A2
+#define VO_PORT_I_CC6_a2_shift                                                       (18)
+#define VO_PORT_I_CC6_a2_mask                                                        (0x07FC0000)
+#define VO_PORT_I_CC6_a2(data)                                                       (0x07FC0000&((data)<<18))
+#define VO_PORT_I_CC6_a2_src(data)                                                   ((0x07FC0000&(data))>>18)
+#define VO_PORT_I_CC6_get_a2(data)                                                   ((0x07FC0000&(data))>>18)
+#define VO_PORT_I_CC6_a1_shift                                                       (9)
+#define VO_PORT_I_CC6_a1_mask                                                        (0x0003FE00)
+#define VO_PORT_I_CC6_a1(data)                                                       (0x0003FE00&((data)<<9))
+#define VO_PORT_I_CC6_a1_src(data)                                                   ((0x0003FE00&(data))>>9)
+#define VO_PORT_I_CC6_get_a1(data)                                                   ((0x0003FE00&(data))>>9)
+#define VO_PORT_I_CC6_a0_shift                                                       (0)
+#define VO_PORT_I_CC6_a0_mask                                                        (0x000001FF)
+#define VO_PORT_I_CC6_a0(data)                                                       (0x000001FF&((data)<<0))
+#define VO_PORT_I_CC6_a0_src(data)                                                   ((0x000001FF&(data))>>0)
+#define VO_PORT_I_CC6_get_a0(data)                                                   ((0x000001FF&(data))>>0)
+
+
+#define VO_PORT_I_LMT                                                                0x1800568C
+#define VO_PORT_I_LMT_reg_addr                                                       "0xB800568C"
+#define VO_PORT_I_LMT_reg                                                            0xB800568C
+#define set_VO_PORT_I_LMT_reg(data)   (*((volatile unsigned int*) VO_PORT_I_LMT_reg)=data)
+#define get_VO_PORT_I_LMT_reg   (*((volatile unsigned int*) VO_PORT_I_LMT_reg))
+#define VO_PORT_I_LMT_inst_adr                                                       "0x00A3"
+#define VO_PORT_I_LMT_inst                                                           0x00A3
+#define VO_PORT_I_LMT_cmax_shift                                                     (24)
+#define VO_PORT_I_LMT_cmax_mask                                                      (0xFF000000)
+#define VO_PORT_I_LMT_cmax(data)                                                     (0xFF000000&((data)<<24))
+#define VO_PORT_I_LMT_cmax_src(data)                                                 ((0xFF000000&(data))>>24)
+#define VO_PORT_I_LMT_get_cmax(data)                                                 ((0xFF000000&(data))>>24)
+#define VO_PORT_I_LMT_cmin_shift                                                     (16)
+#define VO_PORT_I_LMT_cmin_mask                                                      (0x00FF0000)
+#define VO_PORT_I_LMT_cmin(data)                                                     (0x00FF0000&((data)<<16))
+#define VO_PORT_I_LMT_cmin_src(data)                                                 ((0x00FF0000&(data))>>16)
+#define VO_PORT_I_LMT_get_cmin(data)                                                 ((0x00FF0000&(data))>>16)
+#define VO_PORT_I_LMT_ymax_shift                                                     (8)
+#define VO_PORT_I_LMT_ymax_mask                                                      (0x0000FF00)
+#define VO_PORT_I_LMT_ymax(data)                                                     (0x0000FF00&((data)<<8))
+#define VO_PORT_I_LMT_ymax_src(data)                                                 ((0x0000FF00&(data))>>8)
+#define VO_PORT_I_LMT_get_ymax(data)                                                 ((0x0000FF00&(data))>>8)
+#define VO_PORT_I_LMT_ymin_shift                                                     (0)
+#define VO_PORT_I_LMT_ymin_mask                                                      (0x000000FF)
+#define VO_PORT_I_LMT_ymin(data)                                                     (0x000000FF&((data)<<0))
+#define VO_PORT_I_LMT_ymin_src(data)                                                 ((0x000000FF&(data))>>0)
+#define VO_PORT_I_LMT_get_ymin(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define VO_PORT_H_CC1                                                                0x18005690
+#define VO_PORT_H_CC1_reg_addr                                                       "0xB8005690"
+#define VO_PORT_H_CC1_reg                                                            0xB8005690
+#define set_VO_PORT_H_CC1_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC1_reg)=data)
+#define get_VO_PORT_H_CC1_reg   (*((volatile unsigned int*) VO_PORT_H_CC1_reg))
+#define VO_PORT_H_CC1_inst_adr                                                       "0x00A4"
+#define VO_PORT_H_CC1_inst                                                           0x00A4
+#define VO_PORT_H_CC1_m00_shift                                                      (0)
+#define VO_PORT_H_CC1_m00_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC1_m00(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC1_m00_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC1_get_m00(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC2                                                                0x18005694
+#define VO_PORT_H_CC2_reg_addr                                                       "0xB8005694"
+#define VO_PORT_H_CC2_reg                                                            0xB8005694
+#define set_VO_PORT_H_CC2_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC2_reg)=data)
+#define get_VO_PORT_H_CC2_reg   (*((volatile unsigned int*) VO_PORT_H_CC2_reg))
+#define VO_PORT_H_CC2_inst_adr                                                       "0x00A5"
+#define VO_PORT_H_CC2_inst                                                           0x00A5
+#define VO_PORT_H_CC2_m01_shift                                                      (0)
+#define VO_PORT_H_CC2_m01_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC2_m01(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC2_m01_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC2_get_m01(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC3                                                                0x18005698
+#define VO_PORT_H_CC3_reg_addr                                                       "0xB8005698"
+#define VO_PORT_H_CC3_reg                                                            0xB8005698
+#define set_VO_PORT_H_CC3_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC3_reg)=data)
+#define get_VO_PORT_H_CC3_reg   (*((volatile unsigned int*) VO_PORT_H_CC3_reg))
+#define VO_PORT_H_CC3_inst_adr                                                       "0x00A6"
+#define VO_PORT_H_CC3_inst                                                           0x00A6
+#define VO_PORT_H_CC3_m02_shift                                                      (0)
+#define VO_PORT_H_CC3_m02_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC3_m02(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC3_m02_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC3_get_m02(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC4                                                                0x1800569C
+#define VO_PORT_H_CC4_reg_addr                                                       "0xB800569C"
+#define VO_PORT_H_CC4_reg                                                            0xB800569C
+#define set_VO_PORT_H_CC4_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC4_reg)=data)
+#define get_VO_PORT_H_CC4_reg   (*((volatile unsigned int*) VO_PORT_H_CC4_reg))
+#define VO_PORT_H_CC4_inst_adr                                                       "0x00A7"
+#define VO_PORT_H_CC4_inst                                                           0x00A7
+#define VO_PORT_H_CC4_m10_shift                                                      (0)
+#define VO_PORT_H_CC4_m10_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC4_m10(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC4_m10_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC4_get_m10(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC5                                                                0x180056A0
+#define VO_PORT_H_CC5_reg_addr                                                       "0xB80056A0"
+#define VO_PORT_H_CC5_reg                                                            0xB80056A0
+#define set_VO_PORT_H_CC5_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC5_reg)=data)
+#define get_VO_PORT_H_CC5_reg   (*((volatile unsigned int*) VO_PORT_H_CC5_reg))
+#define VO_PORT_H_CC5_inst_adr                                                       "0x00A8"
+#define VO_PORT_H_CC5_inst                                                           0x00A8
+#define VO_PORT_H_CC5_m11_shift                                                      (0)
+#define VO_PORT_H_CC5_m11_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC5_m11(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC5_m11_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC5_get_m11(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC6                                                                0x180056A4
+#define VO_PORT_H_CC6_reg_addr                                                       "0xB80056A4"
+#define VO_PORT_H_CC6_reg                                                            0xB80056A4
+#define set_VO_PORT_H_CC6_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC6_reg)=data)
+#define get_VO_PORT_H_CC6_reg   (*((volatile unsigned int*) VO_PORT_H_CC6_reg))
+#define VO_PORT_H_CC6_inst_adr                                                       "0x00A9"
+#define VO_PORT_H_CC6_inst                                                           0x00A9
+#define VO_PORT_H_CC6_m12_shift                                                      (0)
+#define VO_PORT_H_CC6_m12_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC6_m12(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC6_m12_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC6_get_m12(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC7                                                                0x180056A8
+#define VO_PORT_H_CC7_reg_addr                                                       "0xB80056A8"
+#define VO_PORT_H_CC7_reg                                                            0xB80056A8
+#define set_VO_PORT_H_CC7_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC7_reg)=data)
+#define get_VO_PORT_H_CC7_reg   (*((volatile unsigned int*) VO_PORT_H_CC7_reg))
+#define VO_PORT_H_CC7_inst_adr                                                       "0x00AA"
+#define VO_PORT_H_CC7_inst                                                           0x00AA
+#define VO_PORT_H_CC7_m20_shift                                                      (0)
+#define VO_PORT_H_CC7_m20_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC7_m20(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC7_m20_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC7_get_m20(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC8                                                                0x180056AC
+#define VO_PORT_H_CC8_reg_addr                                                       "0xB80056AC"
+#define VO_PORT_H_CC8_reg                                                            0xB80056AC
+#define set_VO_PORT_H_CC8_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC8_reg)=data)
+#define get_VO_PORT_H_CC8_reg   (*((volatile unsigned int*) VO_PORT_H_CC8_reg))
+#define VO_PORT_H_CC8_inst_adr                                                       "0x00AB"
+#define VO_PORT_H_CC8_inst                                                           0x00AB
+#define VO_PORT_H_CC8_m21_shift                                                      (0)
+#define VO_PORT_H_CC8_m21_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC8_m21(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC8_m21_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC8_get_m21(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC9                                                                0x180056B0
+#define VO_PORT_H_CC9_reg_addr                                                       "0xB80056B0"
+#define VO_PORT_H_CC9_reg                                                            0xB80056B0
+#define set_VO_PORT_H_CC9_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC9_reg)=data)
+#define get_VO_PORT_H_CC9_reg   (*((volatile unsigned int*) VO_PORT_H_CC9_reg))
+#define VO_PORT_H_CC9_inst_adr                                                       "0x00AC"
+#define VO_PORT_H_CC9_inst                                                           0x00AC
+#define VO_PORT_H_CC9_m22_shift                                                      (0)
+#define VO_PORT_H_CC9_m22_mask                                                       (0x0003FFFF)
+#define VO_PORT_H_CC9_m22(data)                                                      (0x0003FFFF&((data)<<0))
+#define VO_PORT_H_CC9_m22_src(data)                                                  ((0x0003FFFF&(data))>>0)
+#define VO_PORT_H_CC9_get_m22(data)                                                  ((0x0003FFFF&(data))>>0)
+
+
+#define VO_PORT_H_CC10                                                               0x180056B4
+#define VO_PORT_H_CC10_reg_addr                                                      "0xB80056B4"
+#define VO_PORT_H_CC10_reg                                                           0xB80056B4
+#define set_VO_PORT_H_CC10_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC10_reg)=data)
+#define get_VO_PORT_H_CC10_reg   (*((volatile unsigned int*) VO_PORT_H_CC10_reg))
+#define VO_PORT_H_CC10_inst_adr                                                      "0x00AD"
+#define VO_PORT_H_CC10_inst                                                          0x00AD
+#define VO_PORT_H_CC10_a1_shift                                                      (14)
+#define VO_PORT_H_CC10_a1_mask                                                       (0x07FFC000)
+#define VO_PORT_H_CC10_a1(data)                                                      (0x07FFC000&((data)<<14))
+#define VO_PORT_H_CC10_a1_src(data)                                                  ((0x07FFC000&(data))>>14)
+#define VO_PORT_H_CC10_get_a1(data)                                                  ((0x07FFC000&(data))>>14)
+#define VO_PORT_H_CC10_a0_shift                                                      (0)
+#define VO_PORT_H_CC10_a0_mask                                                       (0x00001FFF)
+#define VO_PORT_H_CC10_a0(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_PORT_H_CC10_a0_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_PORT_H_CC10_get_a0(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_PORT_H_CC11                                                               0x180056B8
+#define VO_PORT_H_CC11_reg_addr                                                      "0xB80056B8"
+#define VO_PORT_H_CC11_reg                                                           0xB80056B8
+#define set_VO_PORT_H_CC11_reg(data)   (*((volatile unsigned int*) VO_PORT_H_CC11_reg)=data)
+#define get_VO_PORT_H_CC11_reg   (*((volatile unsigned int*) VO_PORT_H_CC11_reg))
+#define VO_PORT_H_CC11_inst_adr                                                      "0x00AE"
+#define VO_PORT_H_CC11_inst                                                          0x00AE
+#define VO_PORT_H_CC11_a2_shift                                                      (0)
+#define VO_PORT_H_CC11_a2_mask                                                       (0x00001FFF)
+#define VO_PORT_H_CC11_a2(data)                                                      (0x00001FFF&((data)<<0))
+#define VO_PORT_H_CC11_a2_src(data)                                                  ((0x00001FFF&(data))>>0)
+#define VO_PORT_H_CC11_get_a2(data)                                                  ((0x00001FFF&(data))>>0)
+
+
+#define VO_PORT_H_LMT_Y                                                              0x180056BC
+#define VO_PORT_H_LMT_Y_reg_addr                                                     "0xB80056BC"
+#define VO_PORT_H_LMT_Y_reg                                                          0xB80056BC
+#define set_VO_PORT_H_LMT_Y_reg(data)   (*((volatile unsigned int*) VO_PORT_H_LMT_Y_reg)=data)
+#define get_VO_PORT_H_LMT_Y_reg   (*((volatile unsigned int*) VO_PORT_H_LMT_Y_reg))
+#define VO_PORT_H_LMT_Y_inst_adr                                                     "0x00AF"
+#define VO_PORT_H_LMT_Y_inst                                                         0x00AF
+#define VO_PORT_H_LMT_Y_ymax_shift                                                   (16)
+#define VO_PORT_H_LMT_Y_ymax_mask                                                    (0x0FFF0000)
+#define VO_PORT_H_LMT_Y_ymax(data)                                                   (0x0FFF0000&((data)<<16))
+#define VO_PORT_H_LMT_Y_ymax_src(data)                                               ((0x0FFF0000&(data))>>16)
+#define VO_PORT_H_LMT_Y_get_ymax(data)                                               ((0x0FFF0000&(data))>>16)
+#define VO_PORT_H_LMT_Y_ymin_shift                                                   (0)
+#define VO_PORT_H_LMT_Y_ymin_mask                                                    (0x00000FFF)
+#define VO_PORT_H_LMT_Y_ymin(data)                                                   (0x00000FFF&((data)<<0))
+#define VO_PORT_H_LMT_Y_ymin_src(data)                                               ((0x00000FFF&(data))>>0)
+#define VO_PORT_H_LMT_Y_get_ymin(data)                                               ((0x00000FFF&(data))>>0)
+
+
+#define VO_PORT_H_LMT_C                                                              0x180056C0
+#define VO_PORT_H_LMT_C_reg_addr                                                     "0xB80056C0"
+#define VO_PORT_H_LMT_C_reg                                                          0xB80056C0
+#define set_VO_PORT_H_LMT_C_reg(data)   (*((volatile unsigned int*) VO_PORT_H_LMT_C_reg)=data)
+#define get_VO_PORT_H_LMT_C_reg   (*((volatile unsigned int*) VO_PORT_H_LMT_C_reg))
+#define VO_PORT_H_LMT_C_inst_adr                                                     "0x00B0"
+#define VO_PORT_H_LMT_C_inst                                                         0x00B0
+#define VO_PORT_H_LMT_C_cmax_shift                                                   (16)
+#define VO_PORT_H_LMT_C_cmax_mask                                                    (0x0FFF0000)
+#define VO_PORT_H_LMT_C_cmax(data)                                                   (0x0FFF0000&((data)<<16))
+#define VO_PORT_H_LMT_C_cmax_src(data)                                               ((0x0FFF0000&(data))>>16)
+#define VO_PORT_H_LMT_C_get_cmax(data)                                               ((0x0FFF0000&(data))>>16)
+#define VO_PORT_H_LMT_C_cmin_shift                                                   (0)
+#define VO_PORT_H_LMT_C_cmin_mask                                                    (0x00000FFF)
+#define VO_PORT_H_LMT_C_cmin(data)                                                   (0x00000FFF&((data)<<0))
+#define VO_PORT_H_LMT_C_cmin_src(data)                                               ((0x00000FFF&(data))>>0)
+#define VO_PORT_H_LMT_C_get_cmin(data)                                               ((0x00000FFF&(data))>>0)
+
+
+#define VO_SYNC                                                                      0x180056C4
+#define VO_SYNC_reg_addr                                                             "0xB80056C4"
+#define VO_SYNC_reg                                                                  0xB80056C4
+#define set_VO_SYNC_reg(data)   (*((volatile unsigned int*) VO_SYNC_reg)=data)
+#define get_VO_SYNC_reg   (*((volatile unsigned int*) VO_SYNC_reg))
+#define VO_SYNC_inst_adr                                                             "0x00B1"
+#define VO_SYNC_inst                                                                 0x00B1
+#define VO_SYNC_lvds_shift                                                           (1)
+#define VO_SYNC_lvds_mask                                                            (0x00000002)
+#define VO_SYNC_lvds(data)                                                           (0x00000002&((data)<<1))
+#define VO_SYNC_lvds_src(data)                                                       ((0x00000002&(data))>>1)
+#define VO_SYNC_get_lvds(data)                                                       ((0x00000002&(data))>>1)
+#define VO_SYNC_write_data_shift                                                     (0)
+#define VO_SYNC_write_data_mask                                                      (0x00000001)
+#define VO_SYNC_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_SYNC_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_SYNC_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_SYNC_DELAY                                                                0x180056C8
+#define VO_SYNC_DELAY_reg_addr                                                       "0xB80056C8"
+#define VO_SYNC_DELAY_reg                                                            0xB80056C8
+#define set_VO_SYNC_DELAY_reg(data)   (*((volatile unsigned int*) VO_SYNC_DELAY_reg)=data)
+#define get_VO_SYNC_DELAY_reg   (*((volatile unsigned int*) VO_SYNC_DELAY_reg))
+#define VO_SYNC_DELAY_inst_adr                                                       "0x00B2"
+#define VO_SYNC_DELAY_inst                                                           0x00B2
+#define VO_SYNC_DELAY_lvds_shift                                                     (0)
+#define VO_SYNC_DELAY_lvds_mask                                                      (0x000000FF)
+#define VO_SYNC_DELAY_lvds(data)                                                     (0x000000FF&((data)<<0))
+#define VO_SYNC_DELAY_lvds_src(data)                                                 ((0x000000FF&(data))>>0)
+#define VO_SYNC_DELAY_get_lvds(data)                                                 ((0x000000FF&(data))>>0)
+
+
+#define VO_INTEN                                                                     0x180056CC
+#define VO_INTEN_reg_addr                                                            "0xB80056CC"
+#define VO_INTEN_reg                                                                 0xB80056CC
+#define set_VO_INTEN_reg(data)   (*((volatile unsigned int*) VO_INTEN_reg)=data)
+#define get_VO_INTEN_reg   (*((volatile unsigned int*) VO_INTEN_reg))
+#define VO_INTEN_inst_adr                                                            "0x00B3"
+#define VO_INTEN_inst                                                                0x00B3
+#define VO_INTEN_h_under_shift                                                       (7)
+#define VO_INTEN_h_under_mask                                                        (0x00000080)
+#define VO_INTEN_h_under(data)                                                       (0x00000080&((data)<<7))
+#define VO_INTEN_h_under_src(data)                                                   ((0x00000080&(data))>>7)
+#define VO_INTEN_get_h_under(data)                                                   ((0x00000080&(data))>>7)
+#define VO_INTEN_i_under_shift                                                       (6)
+#define VO_INTEN_i_under_mask                                                        (0x00000040)
+#define VO_INTEN_i_under(data)                                                       (0x00000040&((data)<<6))
+#define VO_INTEN_i_under_src(data)                                                   ((0x00000040&(data))>>6)
+#define VO_INTEN_get_i_under(data)                                                   ((0x00000040&(data))>>6)
+#define VO_INTEN_p_under_shift                                                       (5)
+#define VO_INTEN_p_under_mask                                                        (0x00000020)
+#define VO_INTEN_p_under(data)                                                       (0x00000020&((data)<<5))
+#define VO_INTEN_p_under_src(data)                                                   ((0x00000020&(data))>>5)
+#define VO_INTEN_get_p_under(data)                                                   ((0x00000020&(data))>>5)
+#define VO_INTEN_sub1_shift                                                          (4)
+#define VO_INTEN_sub1_mask                                                           (0x00000010)
+#define VO_INTEN_sub1(data)                                                          (0x00000010&((data)<<4))
+#define VO_INTEN_sub1_src(data)                                                      ((0x00000010&(data))>>4)
+#define VO_INTEN_get_sub1(data)                                                      ((0x00000010&(data))>>4)
+#define VO_INTEN_wbfin_shift                                                         (3)
+#define VO_INTEN_wbfin_mask                                                          (0x00000008)
+#define VO_INTEN_wbfin(data)                                                         (0x00000008&((data)<<3))
+#define VO_INTEN_wbfin_src(data)                                                     ((0x00000008&(data))>>3)
+#define VO_INTEN_get_wbfin(data)                                                     ((0x00000008&(data))>>3)
+#define VO_INTEN_m2fin_shift                                                         (2)
+#define VO_INTEN_m2fin_mask                                                          (0x00000004)
+#define VO_INTEN_m2fin(data)                                                         (0x00000004&((data)<<2))
+#define VO_INTEN_m2fin_src(data)                                                     ((0x00000004&(data))>>2)
+#define VO_INTEN_get_m2fin(data)                                                     ((0x00000004&(data))>>2)
+#define VO_INTEN_m1fin_shift                                                         (1)
+#define VO_INTEN_m1fin_mask                                                          (0x00000002)
+#define VO_INTEN_m1fin(data)                                                         (0x00000002&((data)<<1))
+#define VO_INTEN_m1fin_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_INTEN_get_m1fin(data)                                                     ((0x00000002&(data))>>1)
+#define VO_INTEN_write_data_shift                                                    (0)
+#define VO_INTEN_write_data_mask                                                     (0x00000001)
+#define VO_INTEN_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VO_INTEN_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_INTEN_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_INTST                                                                     0x180056D0
+#define VO_INTST_reg_addr                                                            "0xB80056D0"
+#define VO_INTST_reg                                                                 0xB80056D0
+#define set_VO_INTST_reg(data)   (*((volatile unsigned int*) VO_INTST_reg)=data)
+#define get_VO_INTST_reg   (*((volatile unsigned int*) VO_INTST_reg))
+#define VO_INTST_inst_adr                                                            "0x00B4"
+#define VO_INTST_inst                                                                0x00B4
+#define VO_INTST_h_under_shift                                                       (7)
+#define VO_INTST_h_under_mask                                                        (0x00000080)
+#define VO_INTST_h_under(data)                                                       (0x00000080&((data)<<7))
+#define VO_INTST_h_under_src(data)                                                   ((0x00000080&(data))>>7)
+#define VO_INTST_get_h_under(data)                                                   ((0x00000080&(data))>>7)
+#define VO_INTST_i_under_shift                                                       (6)
+#define VO_INTST_i_under_mask                                                        (0x00000040)
+#define VO_INTST_i_under(data)                                                       (0x00000040&((data)<<6))
+#define VO_INTST_i_under_src(data)                                                   ((0x00000040&(data))>>6)
+#define VO_INTST_get_i_under(data)                                                   ((0x00000040&(data))>>6)
+#define VO_INTST_p_under_shift                                                       (5)
+#define VO_INTST_p_under_mask                                                        (0x00000020)
+#define VO_INTST_p_under(data)                                                       (0x00000020&((data)<<5))
+#define VO_INTST_p_under_src(data)                                                   ((0x00000020&(data))>>5)
+#define VO_INTST_get_p_under(data)                                                   ((0x00000020&(data))>>5)
+#define VO_INTST_sub1_shift                                                          (4)
+#define VO_INTST_sub1_mask                                                           (0x00000010)
+#define VO_INTST_sub1(data)                                                          (0x00000010&((data)<<4))
+#define VO_INTST_sub1_src(data)                                                      ((0x00000010&(data))>>4)
+#define VO_INTST_get_sub1(data)                                                      ((0x00000010&(data))>>4)
+#define VO_INTST_wbfin_shift                                                         (3)
+#define VO_INTST_wbfin_mask                                                          (0x00000008)
+#define VO_INTST_wbfin(data)                                                         (0x00000008&((data)<<3))
+#define VO_INTST_wbfin_src(data)                                                     ((0x00000008&(data))>>3)
+#define VO_INTST_get_wbfin(data)                                                     ((0x00000008&(data))>>3)
+#define VO_INTST_m2fin_shift                                                         (2)
+#define VO_INTST_m2fin_mask                                                          (0x00000004)
+#define VO_INTST_m2fin(data)                                                         (0x00000004&((data)<<2))
+#define VO_INTST_m2fin_src(data)                                                     ((0x00000004&(data))>>2)
+#define VO_INTST_get_m2fin(data)                                                     ((0x00000004&(data))>>2)
+#define VO_INTST_m1fin_shift                                                         (1)
+#define VO_INTST_m1fin_mask                                                          (0x00000002)
+#define VO_INTST_m1fin(data)                                                         (0x00000002&((data)<<1))
+#define VO_INTST_m1fin_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_INTST_get_m1fin(data)                                                     ((0x00000002&(data))>>1)
+#define VO_INTST_write_data_shift                                                    (0)
+#define VO_INTST_write_data_mask                                                     (0x00000001)
+#define VO_INTST_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VO_INTST_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_INTST_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_STATUS                                                                    0x180056D4
+#define VO_STATUS_reg_addr                                                           "0xB80056D4"
+#define VO_STATUS_reg                                                                0xB80056D4
+#define set_VO_STATUS_reg(data)   (*((volatile unsigned int*) VO_STATUS_reg)=data)
+#define get_VO_STATUS_reg   (*((volatile unsigned int*) VO_STATUS_reg))
+#define VO_STATUS_inst_adr                                                           "0x00B5"
+#define VO_STATUS_inst                                                               0x00B5
+#define VO_STATUS_tve_h_fetch_shift                                                  (13)
+#define VO_STATUS_tve_h_fetch_mask                                                   (0x00002000)
+#define VO_STATUS_tve_h_fetch(data)                                                  (0x00002000&((data)<<13))
+#define VO_STATUS_tve_h_fetch_src(data)                                              ((0x00002000&(data))>>13)
+#define VO_STATUS_get_tve_h_fetch(data)                                              ((0x00002000&(data))>>13)
+#define VO_STATUS_tve_i_fetch_shift                                                  (12)
+#define VO_STATUS_tve_i_fetch_mask                                                   (0x00001000)
+#define VO_STATUS_tve_i_fetch(data)                                                  (0x00001000&((data)<<12))
+#define VO_STATUS_tve_i_fetch_src(data)                                              ((0x00001000&(data))>>12)
+#define VO_STATUS_get_tve_i_fetch(data)                                              ((0x00001000&(data))>>12)
+#define VO_STATUS_tve_p_fetch_shift                                                  (11)
+#define VO_STATUS_tve_p_fetch_mask                                                   (0x00000800)
+#define VO_STATUS_tve_p_fetch(data)                                                  (0x00000800&((data)<<11))
+#define VO_STATUS_tve_p_fetch_src(data)                                              ((0x00000800&(data))>>11)
+#define VO_STATUS_get_tve_p_fetch(data)                                              ((0x00000800&(data))>>11)
+#define VO_STATUS_dd_shift                                                           (9)
+#define VO_STATUS_dd_mask                                                            (0x00000200)
+#define VO_STATUS_dd(data)                                                           (0x00000200&((data)<<9))
+#define VO_STATUS_dd_src(data)                                                       ((0x00000200&(data))>>9)
+#define VO_STATUS_get_dd(data)                                                       ((0x00000200&(data))>>9)
+#define VO_STATUS_osd1_shift                                                         (6)
+#define VO_STATUS_osd1_mask                                                          (0x00000040)
+#define VO_STATUS_osd1(data)                                                         (0x00000040&((data)<<6))
+#define VO_STATUS_osd1_src(data)                                                     ((0x00000040&(data))>>6)
+#define VO_STATUS_get_osd1(data)                                                     ((0x00000040&(data))>>6)
+#define VO_STATUS_sub1_shift                                                         (5)
+#define VO_STATUS_sub1_mask                                                          (0x00000020)
+#define VO_STATUS_sub1(data)                                                         (0x00000020&((data)<<5))
+#define VO_STATUS_sub1_src(data)                                                     ((0x00000020&(data))>>5)
+#define VO_STATUS_get_sub1(data)                                                     ((0x00000020&(data))>>5)
+#define VO_STATUS_v1_shift                                                           (3)
+#define VO_STATUS_v1_mask                                                            (0x00000008)
+#define VO_STATUS_v1(data)                                                           (0x00000008&((data)<<3))
+#define VO_STATUS_v1_src(data)                                                       ((0x00000008&(data))>>3)
+#define VO_STATUS_get_v1(data)                                                       ((0x00000008&(data))>>3)
+#define VO_STATUS_wb_shift                                                           (2)
+#define VO_STATUS_wb_mask                                                            (0x00000004)
+#define VO_STATUS_wb(data)                                                           (0x00000004&((data)<<2))
+#define VO_STATUS_wb_src(data)                                                       ((0x00000004&(data))>>2)
+#define VO_STATUS_get_wb(data)                                                       ((0x00000004&(data))>>2)
+#define VO_STATUS_mix2_shift                                                         (1)
+#define VO_STATUS_mix2_mask                                                          (0x00000002)
+#define VO_STATUS_mix2(data)                                                         (0x00000002&((data)<<1))
+#define VO_STATUS_mix2_src(data)                                                     ((0x00000002&(data))>>1)
+#define VO_STATUS_get_mix2(data)                                                     ((0x00000002&(data))>>1)
+#define VO_STATUS_mix1_shift                                                         (0)
+#define VO_STATUS_mix1_mask                                                          (0x00000001)
+#define VO_STATUS_mix1(data)                                                         (0x00000001&((data)<<0))
+#define VO_STATUS_mix1_src(data)                                                     ((0x00000001&(data))>>0)
+#define VO_STATUS_get_mix1(data)                                                     ((0x00000001&(data))>>0)
+
+
+#define VO_MON_EN                                                                    0x180056D8
+#define VO_MON_EN_reg_addr                                                           "0xB80056D8"
+#define VO_MON_EN_reg                                                                0xB80056D8
+#define set_VO_MON_EN_reg(data)   (*((volatile unsigned int*) VO_MON_EN_reg)=data)
+#define get_VO_MON_EN_reg   (*((volatile unsigned int*) VO_MON_EN_reg))
+#define VO_MON_EN_inst_adr                                                           "0x00B6"
+#define VO_MON_EN_inst                                                               0x00B6
+#define VO_MON_EN_udf_en_shift                                                       (2)
+#define VO_MON_EN_udf_en_mask                                                        (0x00000004)
+#define VO_MON_EN_udf_en(data)                                                       (0x00000004&((data)<<2))
+#define VO_MON_EN_udf_en_src(data)                                                   ((0x00000004&(data))>>2)
+#define VO_MON_EN_get_udf_en(data)                                                   ((0x00000004&(data))>>2)
+#define VO_MON_EN_disp_en_shift                                                      (1)
+#define VO_MON_EN_disp_en_mask                                                       (0x00000002)
+#define VO_MON_EN_disp_en(data)                                                      (0x00000002&((data)<<1))
+#define VO_MON_EN_disp_en_src(data)                                                  ((0x00000002&(data))>>1)
+#define VO_MON_EN_get_disp_en(data)                                                  ((0x00000002&(data))>>1)
+#define VO_MON_EN_delay_en_shift                                                     (0)
+#define VO_MON_EN_delay_en_mask                                                      (0x00000001)
+#define VO_MON_EN_delay_en(data)                                                     (0x00000001&((data)<<0))
+#define VO_MON_EN_delay_en_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_MON_EN_get_delay_en(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_MON_SETUP                                                                 0x180056DC
+#define VO_MON_SETUP_reg_addr                                                        "0xB80056DC"
+#define VO_MON_SETUP_reg                                                             0xB80056DC
+#define set_VO_MON_SETUP_reg(data)   (*((volatile unsigned int*) VO_MON_SETUP_reg)=data)
+#define get_VO_MON_SETUP_reg   (*((volatile unsigned int*) VO_MON_SETUP_reg))
+#define VO_MON_SETUP_inst_adr                                                        "0x00B7"
+#define VO_MON_SETUP_inst                                                            0x00B7
+#define VO_MON_SETUP_wb_shift                                                        (27)
+#define VO_MON_SETUP_wb_mask                                                         (0x08000000)
+#define VO_MON_SETUP_wb(data)                                                        (0x08000000&((data)<<27))
+#define VO_MON_SETUP_wb_src(data)                                                    ((0x08000000&(data))>>27)
+#define VO_MON_SETUP_get_wb(data)                                                    ((0x08000000&(data))>>27)
+#define VO_MON_SETUP_dd_shift                                                        (24)
+#define VO_MON_SETUP_dd_mask                                                         (0x01000000)
+#define VO_MON_SETUP_dd(data)                                                        (0x01000000&((data)<<24))
+#define VO_MON_SETUP_dd_src(data)                                                    ((0x01000000&(data))>>24)
+#define VO_MON_SETUP_get_dd(data)                                                    ((0x01000000&(data))>>24)
+#define VO_MON_SETUP_osd1_shift                                                      (22)
+#define VO_MON_SETUP_osd1_mask                                                       (0x00400000)
+#define VO_MON_SETUP_osd1(data)                                                      (0x00400000&((data)<<22))
+#define VO_MON_SETUP_osd1_src(data)                                                  ((0x00400000&(data))>>22)
+#define VO_MON_SETUP_get_osd1(data)                                                  ((0x00400000&(data))>>22)
+#define VO_MON_SETUP_sub1_shift                                                      (21)
+#define VO_MON_SETUP_sub1_mask                                                       (0x00200000)
+#define VO_MON_SETUP_sub1(data)                                                      (0x00200000&((data)<<21))
+#define VO_MON_SETUP_sub1_src(data)                                                  ((0x00200000&(data))>>21)
+#define VO_MON_SETUP_get_sub1(data)                                                  ((0x00200000&(data))>>21)
+#define VO_MON_SETUP_v1_shift                                                        (19)
+#define VO_MON_SETUP_v1_mask                                                         (0x00080000)
+#define VO_MON_SETUP_v1(data)                                                        (0x00080000&((data)<<19))
+#define VO_MON_SETUP_v1_src(data)                                                    ((0x00080000&(data))>>19)
+#define VO_MON_SETUP_get_v1(data)                                                    ((0x00080000&(data))>>19)
+#define VO_MON_SETUP_ch2_shift                                                       (18)
+#define VO_MON_SETUP_ch2_mask                                                        (0x00040000)
+#define VO_MON_SETUP_ch2(data)                                                       (0x00040000&((data)<<18))
+#define VO_MON_SETUP_ch2_src(data)                                                   ((0x00040000&(data))>>18)
+#define VO_MON_SETUP_get_ch2(data)                                                   ((0x00040000&(data))>>18)
+#define VO_MON_SETUP_ch1_i_shift                                                     (17)
+#define VO_MON_SETUP_ch1_i_mask                                                      (0x00020000)
+#define VO_MON_SETUP_ch1_i(data)                                                     (0x00020000&((data)<<17))
+#define VO_MON_SETUP_ch1_i_src(data)                                                 ((0x00020000&(data))>>17)
+#define VO_MON_SETUP_get_ch1_i(data)                                                 ((0x00020000&(data))>>17)
+#define VO_MON_SETUP_ch1_p_shift                                                     (16)
+#define VO_MON_SETUP_ch1_p_mask                                                      (0x00010000)
+#define VO_MON_SETUP_ch1_p(data)                                                     (0x00010000&((data)<<16))
+#define VO_MON_SETUP_ch1_p_src(data)                                                 ((0x00010000&(data))>>16)
+#define VO_MON_SETUP_get_ch1_p(data)                                                 ((0x00010000&(data))>>16)
+#define VO_MON_SETUP_th_shift                                                        (0)
+#define VO_MON_SETUP_th_mask                                                         (0x000007FF)
+#define VO_MON_SETUP_th(data)                                                        (0x000007FF&((data)<<0))
+#define VO_MON_SETUP_th_src(data)                                                    ((0x000007FF&(data))>>0)
+#define VO_MON_SETUP_get_th(data)                                                    ((0x000007FF&(data))>>0)
+
+
+#define VO_MON_DLY                                                                   0x180056E0
+#define VO_MON_DLY_reg_addr                                                          "0xB80056E0"
+#define VO_MON_DLY_reg                                                               0xB80056E0
+#define set_VO_MON_DLY_reg(data)   (*((volatile unsigned int*) VO_MON_DLY_reg)=data)
+#define get_VO_MON_DLY_reg   (*((volatile unsigned int*) VO_MON_DLY_reg))
+#define VO_MON_DLY_inst_adr                                                          "0x00B8"
+#define VO_MON_DLY_inst                                                              0x00B8
+#define VO_MON_DLY_delay_shift                                                       (16)
+#define VO_MON_DLY_delay_mask                                                        (0xFFFF0000)
+#define VO_MON_DLY_delay(data)                                                       (0xFFFF0000&((data)<<16))
+#define VO_MON_DLY_delay_src(data)                                                   ((0xFFFF0000&(data))>>16)
+#define VO_MON_DLY_get_delay(data)                                                   ((0xFFFF0000&(data))>>16)
+#define VO_MON_DLY_wb_shift                                                          (8)
+#define VO_MON_DLY_wb_mask                                                           (0x00000100)
+#define VO_MON_DLY_wb(data)                                                          (0x00000100&((data)<<8))
+#define VO_MON_DLY_wb_src(data)                                                      ((0x00000100&(data))>>8)
+#define VO_MON_DLY_get_wb(data)                                                      ((0x00000100&(data))>>8)
+#define VO_MON_DLY_dd_shift                                                          (5)
+#define VO_MON_DLY_dd_mask                                                           (0x00000020)
+#define VO_MON_DLY_dd(data)                                                          (0x00000020&((data)<<5))
+#define VO_MON_DLY_dd_src(data)                                                      ((0x00000020&(data))>>5)
+#define VO_MON_DLY_get_dd(data)                                                      ((0x00000020&(data))>>5)
+#define VO_MON_DLY_osd1_shift                                                        (3)
+#define VO_MON_DLY_osd1_mask                                                         (0x00000008)
+#define VO_MON_DLY_osd1(data)                                                        (0x00000008&((data)<<3))
+#define VO_MON_DLY_osd1_src(data)                                                    ((0x00000008&(data))>>3)
+#define VO_MON_DLY_get_osd1(data)                                                    ((0x00000008&(data))>>3)
+#define VO_MON_DLY_sub1_shift                                                        (2)
+#define VO_MON_DLY_sub1_mask                                                         (0x00000004)
+#define VO_MON_DLY_sub1(data)                                                        (0x00000004&((data)<<2))
+#define VO_MON_DLY_sub1_src(data)                                                    ((0x00000004&(data))>>2)
+#define VO_MON_DLY_get_sub1(data)                                                    ((0x00000004&(data))>>2)
+#define VO_MON_DLY_v1_shift                                                          (0)
+#define VO_MON_DLY_v1_mask                                                           (0x00000001)
+#define VO_MON_DLY_v1(data)                                                          (0x00000001&((data)<<0))
+#define VO_MON_DLY_v1_src(data)                                                      ((0x00000001&(data))>>0)
+#define VO_MON_DLY_get_v1(data)                                                      ((0x00000001&(data))>>0)
+
+
+#define VO_MON_DISP                                                                  0x180056E4
+#define VO_MON_DISP_reg_addr                                                         "0xB80056E4"
+#define VO_MON_DISP_reg                                                              0xB80056E4
+#define set_VO_MON_DISP_reg(data)   (*((volatile unsigned int*) VO_MON_DISP_reg)=data)
+#define get_VO_MON_DISP_reg   (*((volatile unsigned int*) VO_MON_DISP_reg))
+#define VO_MON_DISP_inst_adr                                                         "0x00B9"
+#define VO_MON_DISP_inst                                                             0x00B9
+#define VO_MON_DISP_not_full_shift                                                   (0)
+#define VO_MON_DISP_not_full_mask                                                    (0x00001FFF)
+#define VO_MON_DISP_not_full(data)                                                   (0x00001FFF&((data)<<0))
+#define VO_MON_DISP_not_full_src(data)                                               ((0x00001FFF&(data))>>0)
+#define VO_MON_DISP_get_not_full(data)                                               ((0x00001FFF&(data))>>0)
+
+
+#define VO_MON_UF_I                                                                  0x180056E8
+#define VO_MON_UF_I_reg_addr                                                         "0xB80056E8"
+#define VO_MON_UF_I_reg                                                              0xB80056E8
+#define set_VO_MON_UF_I_reg(data)   (*((volatile unsigned int*) VO_MON_UF_I_reg)=data)
+#define get_VO_MON_UF_I_reg   (*((volatile unsigned int*) VO_MON_UF_I_reg))
+#define VO_MON_UF_I_inst_adr                                                         "0x00BA"
+#define VO_MON_UF_I_inst                                                             0x00BA
+#define VO_MON_UF_I_y_shift                                                          (0)
+#define VO_MON_UF_I_y_mask                                                           (0x00001FFF)
+#define VO_MON_UF_I_y(data)                                                          (0x00001FFF&((data)<<0))
+#define VO_MON_UF_I_y_src(data)                                                      ((0x00001FFF&(data))>>0)
+#define VO_MON_UF_I_get_y(data)                                                      ((0x00001FFF&(data))>>0)
+
+
+#define VO_MON_UF_P                                                                  0x180056EC
+#define VO_MON_UF_P_reg_addr                                                         "0xB80056EC"
+#define VO_MON_UF_P_reg                                                              0xB80056EC
+#define set_VO_MON_UF_P_reg(data)   (*((volatile unsigned int*) VO_MON_UF_P_reg)=data)
+#define get_VO_MON_UF_P_reg   (*((volatile unsigned int*) VO_MON_UF_P_reg))
+#define VO_MON_UF_P_inst_adr                                                         "0x00BB"
+#define VO_MON_UF_P_inst                                                             0x00BB
+#define VO_MON_UF_P_y_shift                                                          (0)
+#define VO_MON_UF_P_y_mask                                                           (0x00001FFF)
+#define VO_MON_UF_P_y(data)                                                          (0x00001FFF&((data)<<0))
+#define VO_MON_UF_P_y_src(data)                                                      ((0x00001FFF&(data))>>0)
+#define VO_MON_UF_P_get_y(data)                                                      ((0x00001FFF&(data))>>0)
+
+
+#define VO_MON_UF_H                                                                  0x180056F0
+#define VO_MON_UF_H_reg_addr                                                         "0xB80056F0"
+#define VO_MON_UF_H_reg                                                              0xB80056F0
+#define set_VO_MON_UF_H_reg(data)   (*((volatile unsigned int*) VO_MON_UF_H_reg)=data)
+#define get_VO_MON_UF_H_reg   (*((volatile unsigned int*) VO_MON_UF_H_reg))
+#define VO_MON_UF_H_inst_adr                                                         "0x00BC"
+#define VO_MON_UF_H_inst                                                             0x00BC
+#define VO_MON_UF_H_y_shift                                                          (0)
+#define VO_MON_UF_H_y_mask                                                           (0x00001FFF)
+#define VO_MON_UF_H_y(data)                                                          (0x00001FFF&((data)<<0))
+#define VO_MON_UF_H_y_src(data)                                                      ((0x00001FFF&(data))>>0)
+#define VO_MON_UF_H_get_y(data)                                                      ((0x00001FFF&(data))>>0)
+
+
+#define VO_MON_UF_V1                                                                 0x180056F4
+#define VO_MON_UF_V1_reg_addr                                                        "0xB80056F4"
+#define VO_MON_UF_V1_reg                                                             0xB80056F4
+#define set_VO_MON_UF_V1_reg(data)   (*((volatile unsigned int*) VO_MON_UF_V1_reg)=data)
+#define get_VO_MON_UF_V1_reg   (*((volatile unsigned int*) VO_MON_UF_V1_reg))
+#define VO_MON_UF_V1_inst_adr                                                        "0x00BD"
+#define VO_MON_UF_V1_inst                                                            0x00BD
+#define VO_MON_UF_V1_cnt_shift                                                       (0)
+#define VO_MON_UF_V1_cnt_mask                                                        (0x000001FF)
+#define VO_MON_UF_V1_cnt(data)                                                       (0x000001FF&((data)<<0))
+#define VO_MON_UF_V1_cnt_src(data)                                                   ((0x000001FF&(data))>>0)
+#define VO_MON_UF_V1_get_cnt(data)                                                   ((0x000001FF&(data))>>0)
+
+
+#define VO_MON_UF_SUB1                                                               0x180056F8
+#define VO_MON_UF_SUB1_reg_addr                                                      "0xB80056F8"
+#define VO_MON_UF_SUB1_reg                                                           0xB80056F8
+#define set_VO_MON_UF_SUB1_reg(data)   (*((volatile unsigned int*) VO_MON_UF_SUB1_reg)=data)
+#define get_VO_MON_UF_SUB1_reg   (*((volatile unsigned int*) VO_MON_UF_SUB1_reg))
+#define VO_MON_UF_SUB1_inst_adr                                                      "0x00BE"
+#define VO_MON_UF_SUB1_inst                                                          0x00BE
+#define VO_MON_UF_SUB1_cnt_shift                                                     (0)
+#define VO_MON_UF_SUB1_cnt_mask                                                      (0x000001FF)
+#define VO_MON_UF_SUB1_cnt(data)                                                     (0x000001FF&((data)<<0))
+#define VO_MON_UF_SUB1_cnt_src(data)                                                 ((0x000001FF&(data))>>0)
+#define VO_MON_UF_SUB1_get_cnt(data)                                                 ((0x000001FF&(data))>>0)
+
+
+#define VO_MON_UF_OSD1                                                               0x180056FC
+#define VO_MON_UF_OSD1_reg_addr                                                      "0xB80056FC"
+#define VO_MON_UF_OSD1_reg                                                           0xB80056FC
+#define set_VO_MON_UF_OSD1_reg(data)   (*((volatile unsigned int*) VO_MON_UF_OSD1_reg)=data)
+#define get_VO_MON_UF_OSD1_reg   (*((volatile unsigned int*) VO_MON_UF_OSD1_reg))
+#define VO_MON_UF_OSD1_inst_adr                                                      "0x00BF"
+#define VO_MON_UF_OSD1_inst                                                          0x00BF
+#define VO_MON_UF_OSD1_cnt_shift                                                     (0)
+#define VO_MON_UF_OSD1_cnt_mask                                                      (0x000001FF)
+#define VO_MON_UF_OSD1_cnt(data)                                                     (0x000001FF&((data)<<0))
+#define VO_MON_UF_OSD1_cnt_src(data)                                                 ((0x000001FF&(data))>>0)
+#define VO_MON_UF_OSD1_get_cnt(data)                                                 ((0x000001FF&(data))>>0)
+
+
+#define VO_DBG                                                                       0x18005700
+#define VO_DBG_reg_addr                                                              "0xB8005700"
+#define VO_DBG_reg                                                                   0xB8005700
+#define set_VO_DBG_reg(data)   (*((volatile unsigned int*) VO_DBG_reg)=data)
+#define get_VO_DBG_reg   (*((volatile unsigned int*) VO_DBG_reg))
+#define VO_DBG_inst_adr                                                              "0x00C0"
+#define VO_DBG_inst                                                                  0x00C0
+#define VO_DBG_write_en3_shift                                                       (24)
+#define VO_DBG_write_en3_mask                                                        (0x01000000)
+#define VO_DBG_write_en3(data)                                                       (0x01000000&((data)<<24))
+#define VO_DBG_write_en3_src(data)                                                   ((0x01000000&(data))>>24)
+#define VO_DBG_get_write_en3(data)                                                   ((0x01000000&(data))>>24)
+#define VO_DBG_sel1_shift                                                            (16)
+#define VO_DBG_sel1_mask                                                             (0x00FF0000)
+#define VO_DBG_sel1(data)                                                            (0x00FF0000&((data)<<16))
+#define VO_DBG_sel1_src(data)                                                        ((0x00FF0000&(data))>>16)
+#define VO_DBG_get_sel1(data)                                                        ((0x00FF0000&(data))>>16)
+#define VO_DBG_write_en2_shift                                                       (12)
+#define VO_DBG_write_en2_mask                                                        (0x00001000)
+#define VO_DBG_write_en2(data)                                                       (0x00001000&((data)<<12))
+#define VO_DBG_write_en2_src(data)                                                   ((0x00001000&(data))>>12)
+#define VO_DBG_get_write_en2(data)                                                   ((0x00001000&(data))>>12)
+#define VO_DBG_sel0_shift                                                            (4)
+#define VO_DBG_sel0_mask                                                             (0x00000FF0)
+#define VO_DBG_sel0(data)                                                            (0x00000FF0&((data)<<4))
+#define VO_DBG_sel0_src(data)                                                        ((0x00000FF0&(data))>>4)
+#define VO_DBG_get_sel0(data)                                                        ((0x00000FF0&(data))>>4)
+#define VO_DBG_write_en1_shift                                                       (1)
+#define VO_DBG_write_en1_mask                                                        (0x00000002)
+#define VO_DBG_write_en1(data)                                                       (0x00000002&((data)<<1))
+#define VO_DBG_write_en1_src(data)                                                   ((0x00000002&(data))>>1)
+#define VO_DBG_get_write_en1(data)                                                   ((0x00000002&(data))>>1)
+#define VO_DBG_en_shift                                                              (0)
+#define VO_DBG_en_mask                                                               (0x00000001)
+#define VO_DBG_en(data)                                                              (0x00000001&((data)<<0))
+#define VO_DBG_en_src(data)                                                          ((0x00000001&(data))>>0)
+#define VO_DBG_get_en(data)                                                          ((0x00000001&(data))>>0)
+
+
+#define VO_DACT                                                                      0x18005704
+#define VO_DACT_reg_addr                                                             "0xB8005704"
+#define VO_DACT_reg                                                                  0xB8005704
+#define set_VO_DACT_reg(data)   (*((volatile unsigned int*) VO_DACT_reg)=data)
+#define get_VO_DACT_reg   (*((volatile unsigned int*) VO_DACT_reg))
+#define VO_DACT_inst_adr                                                             "0x00C1"
+#define VO_DACT_inst                                                                 0x00C1
+#define VO_DACT_ramp_8_shift                                                         (6)
+#define VO_DACT_ramp_8_mask                                                          (0x00000040)
+#define VO_DACT_ramp_8(data)                                                         (0x00000040&((data)<<6))
+#define VO_DACT_ramp_8_src(data)                                                     ((0x00000040&(data))>>6)
+#define VO_DACT_get_ramp_8(data)                                                     ((0x00000040&(data))>>6)
+#define VO_DACT_ramp_4_shift                                                         (5)
+#define VO_DACT_ramp_4_mask                                                          (0x00000020)
+#define VO_DACT_ramp_4(data)                                                         (0x00000020&((data)<<5))
+#define VO_DACT_ramp_4_src(data)                                                     ((0x00000020&(data))>>5)
+#define VO_DACT_get_ramp_4(data)                                                     ((0x00000020&(data))>>5)
+#define VO_DACT_ramp_2_shift                                                         (4)
+#define VO_DACT_ramp_2_mask                                                          (0x00000010)
+#define VO_DACT_ramp_2(data)                                                         (0x00000010&((data)<<4))
+#define VO_DACT_ramp_2_src(data)                                                     ((0x00000010&(data))>>4)
+#define VO_DACT_get_ramp_2(data)                                                     ((0x00000010&(data))>>4)
+#define VO_DACT_ramp_1_shift                                                         (3)
+#define VO_DACT_ramp_1_mask                                                          (0x00000008)
+#define VO_DACT_ramp_1(data)                                                         (0x00000008&((data)<<3))
+#define VO_DACT_ramp_1_src(data)                                                     ((0x00000008&(data))>>3)
+#define VO_DACT_get_ramp_1(data)                                                     ((0x00000008&(data))>>3)
+#define VO_DACT_go_shift                                                             (2)
+#define VO_DACT_go_mask                                                              (0x00000004)
+#define VO_DACT_go(data)                                                             (0x00000004&((data)<<2))
+#define VO_DACT_go_src(data)                                                         ((0x00000004&(data))>>2)
+#define VO_DACT_get_go(data)                                                         ((0x00000004&(data))>>2)
+#define VO_DACT_en_shift                                                             (1)
+#define VO_DACT_en_mask                                                              (0x00000002)
+#define VO_DACT_en(data)                                                             (0x00000002&((data)<<1))
+#define VO_DACT_en_src(data)                                                         ((0x00000002&(data))>>1)
+#define VO_DACT_get_en(data)                                                         ((0x00000002&(data))>>1)
+#define VO_DACT_write_data_shift                                                     (0)
+#define VO_DACT_write_data_mask                                                      (0x00000001)
+#define VO_DACT_write_data(data)                                                     (0x00000001&((data)<<0))
+#define VO_DACT_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define VO_DACT_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define VO_DACT_L                                                                    0x18005708
+#define VO_DACT_L_reg_addr                                                           "0xB8005708"
+#define VO_DACT_L_reg                                                                0xB8005708
+#define set_VO_DACT_L_reg(data)   (*((volatile unsigned int*) VO_DACT_L_reg)=data)
+#define get_VO_DACT_L_reg   (*((volatile unsigned int*) VO_DACT_L_reg))
+#define VO_DACT_L_inst_adr                                                           "0x00C2"
+#define VO_DACT_L_inst                                                               0x00C2
+#define VO_DACT_L_l_shift                                                            (0)
+#define VO_DACT_L_l_mask                                                             (0x000007FF)
+#define VO_DACT_L_l(data)                                                            (0x000007FF&((data)<<0))
+#define VO_DACT_L_l_src(data)                                                        ((0x000007FF&(data))>>0)
+#define VO_DACT_L_get_l(data)                                                        ((0x000007FF&(data))>>0)
+
+
+#define VO_DACT_R                                                                    0x1800570C
+#define VO_DACT_R_reg_addr                                                           "0xB800570C"
+#define VO_DACT_R_reg                                                                0xB800570C
+#define set_VO_DACT_R_reg(data)   (*((volatile unsigned int*) VO_DACT_R_reg)=data)
+#define get_VO_DACT_R_reg   (*((volatile unsigned int*) VO_DACT_R_reg))
+#define VO_DACT_R_inst_adr                                                           "0x00C3"
+#define VO_DACT_R_inst                                                               0x00C3
+#define VO_DACT_R_a_shift                                                            (0)
+#define VO_DACT_R_a_mask                                                             (0x000003FF)
+#define VO_DACT_R_a(data)                                                            (0x000003FF&((data)<<0))
+#define VO_DACT_R_a_src(data)                                                        ((0x000003FF&(data))>>0)
+#define VO_DACT_R_get_a(data)                                                        ((0x000003FF&(data))>>0)
+
+
+#define VO_DACT_A                                                                    0x18005710
+#define VO_DACT_A_reg_addr                                                           "0xB8005710"
+#define VO_DACT_A_reg                                                                0xB8005710
+#define set_VO_DACT_A_reg(data)   (*((volatile unsigned int*) VO_DACT_A_reg)=data)
+#define get_VO_DACT_A_reg   (*((volatile unsigned int*) VO_DACT_A_reg))
+#define VO_DACT_A_inst_adr                                                           "0x00C4"
+#define VO_DACT_A_inst                                                               0x00C4
+#define VO_DACT_A_a_shift                                                            (0)
+#define VO_DACT_A_a_mask                                                             (0x000003FF)
+#define VO_DACT_A_a(data)                                                            (0x000003FF&((data)<<0))
+#define VO_DACT_A_a_src(data)                                                        ((0x000003FF&(data))>>0)
+#define VO_DACT_A_get_a(data)                                                        ((0x000003FF&(data))>>0)
+
+
+#define VO_DACT_D                                                                    0x18005714
+#define VO_DACT_D_reg_addr                                                           "0xB8005714"
+#define VO_DACT_D_reg                                                                0xB8005714
+#define set_VO_DACT_D_reg(data)   (*((volatile unsigned int*) VO_DACT_D_reg)=data)
+#define get_VO_DACT_D_reg   (*((volatile unsigned int*) VO_DACT_D_reg))
+#define VO_DACT_D_inst_adr                                                           "0x00C5"
+#define VO_DACT_D_inst                                                               0x00C5
+#define VO_DACT_D_d_shift                                                            (0)
+#define VO_DACT_D_d_mask                                                             (0x0000FFFF)
+#define VO_DACT_D_d(data)                                                            (0x0000FFFF&((data)<<0))
+#define VO_DACT_D_d_src(data)                                                        ((0x0000FFFF&(data))>>0)
+#define VO_DACT_D_get_d(data)                                                        ((0x0000FFFF&(data))>>0)
+
+
+#define VO_RBRAM                                                                     0x18005718
+#define VO_RBRAM_reg_addr                                                            "0xB8005718"
+#define VO_RBRAM_reg                                                                 0xB8005718
+#define set_VO_RBRAM_reg(data)   (*((volatile unsigned int*) VO_RBRAM_reg)=data)
+#define get_VO_RBRAM_reg   (*((volatile unsigned int*) VO_RBRAM_reg))
+#define VO_RBRAM_inst_adr                                                            "0x00C6"
+#define VO_RBRAM_inst                                                                0x00C6
+#define VO_RBRAM_en_shift                                                            (1)
+#define VO_RBRAM_en_mask                                                             (0x00000002)
+#define VO_RBRAM_en(data)                                                            (0x00000002&((data)<<1))
+#define VO_RBRAM_en_src(data)                                                        ((0x00000002&(data))>>1)
+#define VO_RBRAM_get_en(data)                                                        ((0x00000002&(data))>>1)
+#define VO_RBRAM_write_data_shift                                                    (0)
+#define VO_RBRAM_write_data_mask                                                     (0x00000001)
+#define VO_RBRAM_write_data(data)                                                    (0x00000001&((data)<<0))
+#define VO_RBRAM_write_data_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_RBRAM_get_write_data(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_VERF_0                                                                    0x1800571C
+#define VO_VERF_1                                                                    0x18005720
+#define VO_VERF_2                                                                    0x18005724
+#define VO_VERF_0_reg_addr                                                           "0xB800571C"
+#define VO_VERF_1_reg_addr                                                           "0xB8005720"
+#define VO_VERF_2_reg_addr                                                           "0xB8005724"
+#define VO_VERF_0_reg                                                                0xB800571C
+#define VO_VERF_1_reg                                                                0xB8005720
+#define VO_VERF_2_reg                                                                0xB8005724
+#define set_VO_VERF_0_reg(data)   (*((volatile unsigned int*) VO_VERF_0_reg)=data)
+#define set_VO_VERF_1_reg(data)   (*((volatile unsigned int*) VO_VERF_1_reg)=data)
+#define set_VO_VERF_2_reg(data)   (*((volatile unsigned int*) VO_VERF_2_reg)=data)
+#define get_VO_VERF_0_reg   (*((volatile unsigned int*) VO_VERF_0_reg))
+#define get_VO_VERF_1_reg   (*((volatile unsigned int*) VO_VERF_1_reg))
+#define get_VO_VERF_2_reg   (*((volatile unsigned int*) VO_VERF_2_reg))
+#define VO_VERF_0_inst_adr                                                           "0x00C7"
+#define VO_VERF_1_inst_adr                                                           "0x00C8"
+#define VO_VERF_2_inst_adr                                                           "0x00C9"
+#define VO_VERF_0_inst                                                               0x00C7
+#define VO_VERF_1_inst                                                               0x00C8
+#define VO_VERF_2_inst                                                               0x00C9
+#define VO_VERF_mode_shift                                                           (0)
+#define VO_VERF_mode_mask                                                            (0xFFFFFFFF)
+#define VO_VERF_mode(data)                                                           (0xFFFFFFFF&((data)<<0))
+#define VO_VERF_mode_src(data)                                                       ((0xFFFFFFFF&(data))>>0)
+#define VO_VERF_get_mode(data)                                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define VO_SRAM_RM                                                                   0x18005728
+#define VO_SRAM_RM_reg_addr                                                          "0xB8005728"
+#define VO_SRAM_RM_reg                                                               0xB8005728
+#define set_VO_SRAM_RM_reg(data)   (*((volatile unsigned int*) VO_SRAM_RM_reg)=data)
+#define get_VO_SRAM_RM_reg   (*((volatile unsigned int*) VO_SRAM_RM_reg))
+#define VO_SRAM_RM_inst_adr                                                          "0x00CA"
+#define VO_SRAM_RM_inst                                                              0x00CA
+#define VO_SRAM_RM_rme_2_shift                                                       (12)
+#define VO_SRAM_RM_rme_2_mask                                                        (0x00001000)
+#define VO_SRAM_RM_rme_2(data)                                                       (0x00001000&((data)<<12))
+#define VO_SRAM_RM_rme_2_src(data)                                                   ((0x00001000&(data))>>12)
+#define VO_SRAM_RM_get_rme_2(data)                                                   ((0x00001000&(data))>>12)
+#define VO_SRAM_RM_rm_2_shift                                                        (8)
+#define VO_SRAM_RM_rm_2_mask                                                         (0x00000F00)
+#define VO_SRAM_RM_rm_2(data)                                                        (0x00000F00&((data)<<8))
+#define VO_SRAM_RM_rm_2_src(data)                                                    ((0x00000F00&(data))>>8)
+#define VO_SRAM_RM_get_rm_2(data)                                                    ((0x00000F00&(data))>>8)
+#define VO_SRAM_RM_rme_1_shift                                                       (4)
+#define VO_SRAM_RM_rme_1_mask                                                        (0x00000010)
+#define VO_SRAM_RM_rme_1(data)                                                       (0x00000010&((data)<<4))
+#define VO_SRAM_RM_rme_1_src(data)                                                   ((0x00000010&(data))>>4)
+#define VO_SRAM_RM_get_rme_1(data)                                                   ((0x00000010&(data))>>4)
+#define VO_SRAM_RM_rm_1_shift                                                        (0)
+#define VO_SRAM_RM_rm_1_mask                                                         (0x0000000F)
+#define VO_SRAM_RM_rm_1(data)                                                        (0x0000000F&((data)<<0))
+#define VO_SRAM_RM_rm_1_src(data)                                                    ((0x0000000F&(data))>>0)
+#define VO_SRAM_RM_get_rm_1(data)                                                    ((0x0000000F&(data))>>0)
+
+
+#define VO_MBIST                                                                     0x1800572C
+#define VO_MBIST_reg_addr                                                            "0xB800572C"
+#define VO_MBIST_reg                                                                 0xB800572C
+#define set_VO_MBIST_reg(data)   (*((volatile unsigned int*) VO_MBIST_reg)=data)
+#define get_VO_MBIST_reg   (*((volatile unsigned int*) VO_MBIST_reg))
+#define VO_MBIST_inst_adr                                                            "0x00CB"
+#define VO_MBIST_inst                                                                0x00CB
+#define VO_MBIST_drf_start_pause_5_shift                                             (19)
+#define VO_MBIST_drf_start_pause_5_mask                                              (0x00080000)
+#define VO_MBIST_drf_start_pause_5(data)                                             (0x00080000&((data)<<19))
+#define VO_MBIST_drf_start_pause_5_src(data)                                         ((0x00080000&(data))>>19)
+#define VO_MBIST_get_drf_start_pause_5(data)                                         ((0x00080000&(data))>>19)
+#define VO_MBIST_drf_test_resume_5_shift                                             (18)
+#define VO_MBIST_drf_test_resume_5_mask                                              (0x00040000)
+#define VO_MBIST_drf_test_resume_5(data)                                             (0x00040000&((data)<<18))
+#define VO_MBIST_drf_test_resume_5_src(data)                                         ((0x00040000&(data))>>18)
+#define VO_MBIST_get_drf_test_resume_5(data)                                         ((0x00040000&(data))>>18)
+#define VO_MBIST_drf_bist_mode_5_shift                                               (17)
+#define VO_MBIST_drf_bist_mode_5_mask                                                (0x00020000)
+#define VO_MBIST_drf_bist_mode_5(data)                                               (0x00020000&((data)<<17))
+#define VO_MBIST_drf_bist_mode_5_src(data)                                           ((0x00020000&(data))>>17)
+#define VO_MBIST_get_drf_bist_mode_5(data)                                           ((0x00020000&(data))>>17)
+#define VO_MBIST_bist_mode_5_shift                                                   (16)
+#define VO_MBIST_bist_mode_5_mask                                                    (0x00010000)
+#define VO_MBIST_bist_mode_5(data)                                                   (0x00010000&((data)<<16))
+#define VO_MBIST_bist_mode_5_src(data)                                               ((0x00010000&(data))>>16)
+#define VO_MBIST_get_bist_mode_5(data)                                               ((0x00010000&(data))>>16)
+#define VO_MBIST_drf_start_pause_4_shift                                             (15)
+#define VO_MBIST_drf_start_pause_4_mask                                              (0x00008000)
+#define VO_MBIST_drf_start_pause_4(data)                                             (0x00008000&((data)<<15))
+#define VO_MBIST_drf_start_pause_4_src(data)                                         ((0x00008000&(data))>>15)
+#define VO_MBIST_get_drf_start_pause_4(data)                                         ((0x00008000&(data))>>15)
+#define VO_MBIST_drf_test_resume_4_shift                                             (14)
+#define VO_MBIST_drf_test_resume_4_mask                                              (0x00004000)
+#define VO_MBIST_drf_test_resume_4(data)                                             (0x00004000&((data)<<14))
+#define VO_MBIST_drf_test_resume_4_src(data)                                         ((0x00004000&(data))>>14)
+#define VO_MBIST_get_drf_test_resume_4(data)                                         ((0x00004000&(data))>>14)
+#define VO_MBIST_drf_bist_mode_4_shift                                               (13)
+#define VO_MBIST_drf_bist_mode_4_mask                                                (0x00002000)
+#define VO_MBIST_drf_bist_mode_4(data)                                               (0x00002000&((data)<<13))
+#define VO_MBIST_drf_bist_mode_4_src(data)                                           ((0x00002000&(data))>>13)
+#define VO_MBIST_get_drf_bist_mode_4(data)                                           ((0x00002000&(data))>>13)
+#define VO_MBIST_bist_mode_4_shift                                                   (12)
+#define VO_MBIST_bist_mode_4_mask                                                    (0x00001000)
+#define VO_MBIST_bist_mode_4(data)                                                   (0x00001000&((data)<<12))
+#define VO_MBIST_bist_mode_4_src(data)                                               ((0x00001000&(data))>>12)
+#define VO_MBIST_get_bist_mode_4(data)                                               ((0x00001000&(data))>>12)
+#define VO_MBIST_drf_start_pause_3_shift                                             (11)
+#define VO_MBIST_drf_start_pause_3_mask                                              (0x00000800)
+#define VO_MBIST_drf_start_pause_3(data)                                             (0x00000800&((data)<<11))
+#define VO_MBIST_drf_start_pause_3_src(data)                                         ((0x00000800&(data))>>11)
+#define VO_MBIST_get_drf_start_pause_3(data)                                         ((0x00000800&(data))>>11)
+#define VO_MBIST_drf_test_resume_3_shift                                             (10)
+#define VO_MBIST_drf_test_resume_3_mask                                              (0x00000400)
+#define VO_MBIST_drf_test_resume_3(data)                                             (0x00000400&((data)<<10))
+#define VO_MBIST_drf_test_resume_3_src(data)                                         ((0x00000400&(data))>>10)
+#define VO_MBIST_get_drf_test_resume_3(data)                                         ((0x00000400&(data))>>10)
+#define VO_MBIST_drf_bist_mode_3_shift                                               (9)
+#define VO_MBIST_drf_bist_mode_3_mask                                                (0x00000200)
+#define VO_MBIST_drf_bist_mode_3(data)                                               (0x00000200&((data)<<9))
+#define VO_MBIST_drf_bist_mode_3_src(data)                                           ((0x00000200&(data))>>9)
+#define VO_MBIST_get_drf_bist_mode_3(data)                                           ((0x00000200&(data))>>9)
+#define VO_MBIST_bist_mode_3_shift                                                   (8)
+#define VO_MBIST_bist_mode_3_mask                                                    (0x00000100)
+#define VO_MBIST_bist_mode_3(data)                                                   (0x00000100&((data)<<8))
+#define VO_MBIST_bist_mode_3_src(data)                                               ((0x00000100&(data))>>8)
+#define VO_MBIST_get_bist_mode_3(data)                                               ((0x00000100&(data))>>8)
+#define VO_MBIST_drf_start_pause_2_shift                                             (7)
+#define VO_MBIST_drf_start_pause_2_mask                                              (0x00000080)
+#define VO_MBIST_drf_start_pause_2(data)                                             (0x00000080&((data)<<7))
+#define VO_MBIST_drf_start_pause_2_src(data)                                         ((0x00000080&(data))>>7)
+#define VO_MBIST_get_drf_start_pause_2(data)                                         ((0x00000080&(data))>>7)
+#define VO_MBIST_drf_test_resume_2_shift                                             (6)
+#define VO_MBIST_drf_test_resume_2_mask                                              (0x00000040)
+#define VO_MBIST_drf_test_resume_2(data)                                             (0x00000040&((data)<<6))
+#define VO_MBIST_drf_test_resume_2_src(data)                                         ((0x00000040&(data))>>6)
+#define VO_MBIST_get_drf_test_resume_2(data)                                         ((0x00000040&(data))>>6)
+#define VO_MBIST_drf_bist_mode_2_shift                                               (5)
+#define VO_MBIST_drf_bist_mode_2_mask                                                (0x00000020)
+#define VO_MBIST_drf_bist_mode_2(data)                                               (0x00000020&((data)<<5))
+#define VO_MBIST_drf_bist_mode_2_src(data)                                           ((0x00000020&(data))>>5)
+#define VO_MBIST_get_drf_bist_mode_2(data)                                           ((0x00000020&(data))>>5)
+#define VO_MBIST_bist_mode_2_shift                                                   (4)
+#define VO_MBIST_bist_mode_2_mask                                                    (0x00000010)
+#define VO_MBIST_bist_mode_2(data)                                                   (0x00000010&((data)<<4))
+#define VO_MBIST_bist_mode_2_src(data)                                               ((0x00000010&(data))>>4)
+#define VO_MBIST_get_bist_mode_2(data)                                               ((0x00000010&(data))>>4)
+#define VO_MBIST_drf_start_pause_1_shift                                             (3)
+#define VO_MBIST_drf_start_pause_1_mask                                              (0x00000008)
+#define VO_MBIST_drf_start_pause_1(data)                                             (0x00000008&((data)<<3))
+#define VO_MBIST_drf_start_pause_1_src(data)                                         ((0x00000008&(data))>>3)
+#define VO_MBIST_get_drf_start_pause_1(data)                                         ((0x00000008&(data))>>3)
+#define VO_MBIST_drf_test_resume_1_shift                                             (2)
+#define VO_MBIST_drf_test_resume_1_mask                                              (0x00000004)
+#define VO_MBIST_drf_test_resume_1(data)                                             (0x00000004&((data)<<2))
+#define VO_MBIST_drf_test_resume_1_src(data)                                         ((0x00000004&(data))>>2)
+#define VO_MBIST_get_drf_test_resume_1(data)                                         ((0x00000004&(data))>>2)
+#define VO_MBIST_drf_bist_mode_1_shift                                               (1)
+#define VO_MBIST_drf_bist_mode_1_mask                                                (0x00000002)
+#define VO_MBIST_drf_bist_mode_1(data)                                               (0x00000002&((data)<<1))
+#define VO_MBIST_drf_bist_mode_1_src(data)                                           ((0x00000002&(data))>>1)
+#define VO_MBIST_get_drf_bist_mode_1(data)                                           ((0x00000002&(data))>>1)
+#define VO_MBIST_bist_mode_1_shift                                                   (0)
+#define VO_MBIST_bist_mode_1_mask                                                    (0x00000001)
+#define VO_MBIST_bist_mode_1(data)                                                   (0x00000001&((data)<<0))
+#define VO_MBIST_bist_mode_1_src(data)                                               ((0x00000001&(data))>>0)
+#define VO_MBIST_get_bist_mode_1(data)                                               ((0x00000001&(data))>>0)
+
+
+#define VO_MBIST_OUT                                                                 0x18005730
+#define VO_MBIST_OUT_reg_addr                                                        "0xB8005730"
+#define VO_MBIST_OUT_reg                                                             0xB8005730
+#define set_VO_MBIST_OUT_reg(data)   (*((volatile unsigned int*) VO_MBIST_OUT_reg)=data)
+#define get_VO_MBIST_OUT_reg   (*((volatile unsigned int*) VO_MBIST_OUT_reg))
+#define VO_MBIST_OUT_inst_adr                                                        "0x00CC"
+#define VO_MBIST_OUT_inst                                                            0x00CC
+#define VO_MBIST_OUT_fail_5_1_shift                                                  (26)
+#define VO_MBIST_OUT_fail_5_1_mask                                                   (0x04000000)
+#define VO_MBIST_OUT_fail_5_1(data)                                                  (0x04000000&((data)<<26))
+#define VO_MBIST_OUT_fail_5_1_src(data)                                              ((0x04000000&(data))>>26)
+#define VO_MBIST_OUT_get_fail_5_1(data)                                              ((0x04000000&(data))>>26)
+#define VO_MBIST_OUT_fail_5_0_shift                                                  (25)
+#define VO_MBIST_OUT_fail_5_0_mask                                                   (0x02000000)
+#define VO_MBIST_OUT_fail_5_0(data)                                                  (0x02000000&((data)<<25))
+#define VO_MBIST_OUT_fail_5_0_src(data)                                              ((0x02000000&(data))>>25)
+#define VO_MBIST_OUT_get_fail_5_0(data)                                              ((0x02000000&(data))>>25)
+#define VO_MBIST_OUT_fail_4_4_shift                                                  (24)
+#define VO_MBIST_OUT_fail_4_4_mask                                                   (0x01000000)
+#define VO_MBIST_OUT_fail_4_4(data)                                                  (0x01000000&((data)<<24))
+#define VO_MBIST_OUT_fail_4_4_src(data)                                              ((0x01000000&(data))>>24)
+#define VO_MBIST_OUT_get_fail_4_4(data)                                              ((0x01000000&(data))>>24)
+#define VO_MBIST_OUT_fail_4_3_shift                                                  (23)
+#define VO_MBIST_OUT_fail_4_3_mask                                                   (0x00800000)
+#define VO_MBIST_OUT_fail_4_3(data)                                                  (0x00800000&((data)<<23))
+#define VO_MBIST_OUT_fail_4_3_src(data)                                              ((0x00800000&(data))>>23)
+#define VO_MBIST_OUT_get_fail_4_3(data)                                              ((0x00800000&(data))>>23)
+#define VO_MBIST_OUT_fail_4_2_shift                                                  (22)
+#define VO_MBIST_OUT_fail_4_2_mask                                                   (0x00400000)
+#define VO_MBIST_OUT_fail_4_2(data)                                                  (0x00400000&((data)<<22))
+#define VO_MBIST_OUT_fail_4_2_src(data)                                              ((0x00400000&(data))>>22)
+#define VO_MBIST_OUT_get_fail_4_2(data)                                              ((0x00400000&(data))>>22)
+#define VO_MBIST_OUT_fail_4_1_shift                                                  (21)
+#define VO_MBIST_OUT_fail_4_1_mask                                                   (0x00200000)
+#define VO_MBIST_OUT_fail_4_1(data)                                                  (0x00200000&((data)<<21))
+#define VO_MBIST_OUT_fail_4_1_src(data)                                              ((0x00200000&(data))>>21)
+#define VO_MBIST_OUT_get_fail_4_1(data)                                              ((0x00200000&(data))>>21)
+#define VO_MBIST_OUT_fail_4_0_shift                                                  (20)
+#define VO_MBIST_OUT_fail_4_0_mask                                                   (0x00100000)
+#define VO_MBIST_OUT_fail_4_0(data)                                                  (0x00100000&((data)<<20))
+#define VO_MBIST_OUT_fail_4_0_src(data)                                              ((0x00100000&(data))>>20)
+#define VO_MBIST_OUT_get_fail_4_0(data)                                              ((0x00100000&(data))>>20)
+#define VO_MBIST_OUT_fail_3_3_shift                                                  (19)
+#define VO_MBIST_OUT_fail_3_3_mask                                                   (0x00080000)
+#define VO_MBIST_OUT_fail_3_3(data)                                                  (0x00080000&((data)<<19))
+#define VO_MBIST_OUT_fail_3_3_src(data)                                              ((0x00080000&(data))>>19)
+#define VO_MBIST_OUT_get_fail_3_3(data)                                              ((0x00080000&(data))>>19)
+#define VO_MBIST_OUT_fail_3_2_shift                                                  (18)
+#define VO_MBIST_OUT_fail_3_2_mask                                                   (0x00040000)
+#define VO_MBIST_OUT_fail_3_2(data)                                                  (0x00040000&((data)<<18))
+#define VO_MBIST_OUT_fail_3_2_src(data)                                              ((0x00040000&(data))>>18)
+#define VO_MBIST_OUT_get_fail_3_2(data)                                              ((0x00040000&(data))>>18)
+#define VO_MBIST_OUT_fail_3_1_shift                                                  (17)
+#define VO_MBIST_OUT_fail_3_1_mask                                                   (0x00020000)
+#define VO_MBIST_OUT_fail_3_1(data)                                                  (0x00020000&((data)<<17))
+#define VO_MBIST_OUT_fail_3_1_src(data)                                              ((0x00020000&(data))>>17)
+#define VO_MBIST_OUT_get_fail_3_1(data)                                              ((0x00020000&(data))>>17)
+#define VO_MBIST_OUT_fail_3_0_shift                                                  (16)
+#define VO_MBIST_OUT_fail_3_0_mask                                                   (0x00010000)
+#define VO_MBIST_OUT_fail_3_0(data)                                                  (0x00010000&((data)<<16))
+#define VO_MBIST_OUT_fail_3_0_src(data)                                              ((0x00010000&(data))>>16)
+#define VO_MBIST_OUT_get_fail_3_0(data)                                              ((0x00010000&(data))>>16)
+#define VO_MBIST_OUT_fail_2_3_shift                                                  (15)
+#define VO_MBIST_OUT_fail_2_3_mask                                                   (0x00008000)
+#define VO_MBIST_OUT_fail_2_3(data)                                                  (0x00008000&((data)<<15))
+#define VO_MBIST_OUT_fail_2_3_src(data)                                              ((0x00008000&(data))>>15)
+#define VO_MBIST_OUT_get_fail_2_3(data)                                              ((0x00008000&(data))>>15)
+#define VO_MBIST_OUT_fail_2_2_shift                                                  (14)
+#define VO_MBIST_OUT_fail_2_2_mask                                                   (0x00004000)
+#define VO_MBIST_OUT_fail_2_2(data)                                                  (0x00004000&((data)<<14))
+#define VO_MBIST_OUT_fail_2_2_src(data)                                              ((0x00004000&(data))>>14)
+#define VO_MBIST_OUT_get_fail_2_2(data)                                              ((0x00004000&(data))>>14)
+#define VO_MBIST_OUT_fail_2_1_shift                                                  (13)
+#define VO_MBIST_OUT_fail_2_1_mask                                                   (0x00002000)
+#define VO_MBIST_OUT_fail_2_1(data)                                                  (0x00002000&((data)<<13))
+#define VO_MBIST_OUT_fail_2_1_src(data)                                              ((0x00002000&(data))>>13)
+#define VO_MBIST_OUT_get_fail_2_1(data)                                              ((0x00002000&(data))>>13)
+#define VO_MBIST_OUT_fail_2_0_shift                                                  (12)
+#define VO_MBIST_OUT_fail_2_0_mask                                                   (0x00001000)
+#define VO_MBIST_OUT_fail_2_0(data)                                                  (0x00001000&((data)<<12))
+#define VO_MBIST_OUT_fail_2_0_src(data)                                              ((0x00001000&(data))>>12)
+#define VO_MBIST_OUT_get_fail_2_0(data)                                              ((0x00001000&(data))>>12)
+#define VO_MBIST_OUT_fail_1_2_shift                                                  (10)
+#define VO_MBIST_OUT_fail_1_2_mask                                                   (0x00000400)
+#define VO_MBIST_OUT_fail_1_2(data)                                                  (0x00000400&((data)<<10))
+#define VO_MBIST_OUT_fail_1_2_src(data)                                              ((0x00000400&(data))>>10)
+#define VO_MBIST_OUT_get_fail_1_2(data)                                              ((0x00000400&(data))>>10)
+#define VO_MBIST_OUT_fail_1_1_shift                                                  (9)
+#define VO_MBIST_OUT_fail_1_1_mask                                                   (0x00000200)
+#define VO_MBIST_OUT_fail_1_1(data)                                                  (0x00000200&((data)<<9))
+#define VO_MBIST_OUT_fail_1_1_src(data)                                              ((0x00000200&(data))>>9)
+#define VO_MBIST_OUT_get_fail_1_1(data)                                              ((0x00000200&(data))>>9)
+#define VO_MBIST_OUT_fail_1_0_shift                                                  (8)
+#define VO_MBIST_OUT_fail_1_0_mask                                                   (0x00000100)
+#define VO_MBIST_OUT_fail_1_0(data)                                                  (0x00000100&((data)<<8))
+#define VO_MBIST_OUT_fail_1_0_src(data)                                              ((0x00000100&(data))>>8)
+#define VO_MBIST_OUT_get_fail_1_0(data)                                              ((0x00000100&(data))>>8)
+#define VO_MBIST_OUT_done_5_shift                                                    (4)
+#define VO_MBIST_OUT_done_5_mask                                                     (0x00000010)
+#define VO_MBIST_OUT_done_5(data)                                                    (0x00000010&((data)<<4))
+#define VO_MBIST_OUT_done_5_src(data)                                                ((0x00000010&(data))>>4)
+#define VO_MBIST_OUT_get_done_5(data)                                                ((0x00000010&(data))>>4)
+#define VO_MBIST_OUT_done_4_shift                                                    (3)
+#define VO_MBIST_OUT_done_4_mask                                                     (0x00000008)
+#define VO_MBIST_OUT_done_4(data)                                                    (0x00000008&((data)<<3))
+#define VO_MBIST_OUT_done_4_src(data)                                                ((0x00000008&(data))>>3)
+#define VO_MBIST_OUT_get_done_4(data)                                                ((0x00000008&(data))>>3)
+#define VO_MBIST_OUT_done_3_shift                                                    (2)
+#define VO_MBIST_OUT_done_3_mask                                                     (0x00000004)
+#define VO_MBIST_OUT_done_3(data)                                                    (0x00000004&((data)<<2))
+#define VO_MBIST_OUT_done_3_src(data)                                                ((0x00000004&(data))>>2)
+#define VO_MBIST_OUT_get_done_3(data)                                                ((0x00000004&(data))>>2)
+#define VO_MBIST_OUT_done_2_shift                                                    (1)
+#define VO_MBIST_OUT_done_2_mask                                                     (0x00000002)
+#define VO_MBIST_OUT_done_2(data)                                                    (0x00000002&((data)<<1))
+#define VO_MBIST_OUT_done_2_src(data)                                                ((0x00000002&(data))>>1)
+#define VO_MBIST_OUT_get_done_2(data)                                                ((0x00000002&(data))>>1)
+#define VO_MBIST_OUT_done_1_shift                                                    (0)
+#define VO_MBIST_OUT_done_1_mask                                                     (0x00000001)
+#define VO_MBIST_OUT_done_1(data)                                                    (0x00000001&((data)<<0))
+#define VO_MBIST_OUT_done_1_src(data)                                                ((0x00000001&(data))>>0)
+#define VO_MBIST_OUT_get_done_1(data)                                                ((0x00000001&(data))>>0)
+
+
+#define VO_DRF_MBIST_OUT                                                             0x18005734
+#define VO_DRF_MBIST_OUT_reg_addr                                                    "0xB8005734"
+#define VO_DRF_MBIST_OUT_reg                                                         0xB8005734
+#define set_VO_DRF_MBIST_OUT_reg(data)   (*((volatile unsigned int*) VO_DRF_MBIST_OUT_reg)=data)
+#define get_VO_DRF_MBIST_OUT_reg   (*((volatile unsigned int*) VO_DRF_MBIST_OUT_reg))
+#define VO_DRF_MBIST_OUT_inst_adr                                                    "0x00CD"
+#define VO_DRF_MBIST_OUT_inst                                                        0x00CD
+#define VO_DRF_MBIST_OUT_fail_5_1_shift                                              (26)
+#define VO_DRF_MBIST_OUT_fail_5_1_mask                                               (0x04000000)
+#define VO_DRF_MBIST_OUT_fail_5_1(data)                                              (0x04000000&((data)<<26))
+#define VO_DRF_MBIST_OUT_fail_5_1_src(data)                                          ((0x04000000&(data))>>26)
+#define VO_DRF_MBIST_OUT_get_fail_5_1(data)                                          ((0x04000000&(data))>>26)
+#define VO_DRF_MBIST_OUT_fail_5_0_shift                                              (25)
+#define VO_DRF_MBIST_OUT_fail_5_0_mask                                               (0x02000000)
+#define VO_DRF_MBIST_OUT_fail_5_0(data)                                              (0x02000000&((data)<<25))
+#define VO_DRF_MBIST_OUT_fail_5_0_src(data)                                          ((0x02000000&(data))>>25)
+#define VO_DRF_MBIST_OUT_get_fail_5_0(data)                                          ((0x02000000&(data))>>25)
+#define VO_DRF_MBIST_OUT_fail_4_4_shift                                              (24)
+#define VO_DRF_MBIST_OUT_fail_4_4_mask                                               (0x01000000)
+#define VO_DRF_MBIST_OUT_fail_4_4(data)                                              (0x01000000&((data)<<24))
+#define VO_DRF_MBIST_OUT_fail_4_4_src(data)                                          ((0x01000000&(data))>>24)
+#define VO_DRF_MBIST_OUT_get_fail_4_4(data)                                          ((0x01000000&(data))>>24)
+#define VO_DRF_MBIST_OUT_fail_4_3_shift                                              (23)
+#define VO_DRF_MBIST_OUT_fail_4_3_mask                                               (0x00800000)
+#define VO_DRF_MBIST_OUT_fail_4_3(data)                                              (0x00800000&((data)<<23))
+#define VO_DRF_MBIST_OUT_fail_4_3_src(data)                                          ((0x00800000&(data))>>23)
+#define VO_DRF_MBIST_OUT_get_fail_4_3(data)                                          ((0x00800000&(data))>>23)
+#define VO_DRF_MBIST_OUT_fail_4_2_shift                                              (22)
+#define VO_DRF_MBIST_OUT_fail_4_2_mask                                               (0x00400000)
+#define VO_DRF_MBIST_OUT_fail_4_2(data)                                              (0x00400000&((data)<<22))
+#define VO_DRF_MBIST_OUT_fail_4_2_src(data)                                          ((0x00400000&(data))>>22)
+#define VO_DRF_MBIST_OUT_get_fail_4_2(data)                                          ((0x00400000&(data))>>22)
+#define VO_DRF_MBIST_OUT_fail_4_1_shift                                              (21)
+#define VO_DRF_MBIST_OUT_fail_4_1_mask                                               (0x00200000)
+#define VO_DRF_MBIST_OUT_fail_4_1(data)                                              (0x00200000&((data)<<21))
+#define VO_DRF_MBIST_OUT_fail_4_1_src(data)                                          ((0x00200000&(data))>>21)
+#define VO_DRF_MBIST_OUT_get_fail_4_1(data)                                          ((0x00200000&(data))>>21)
+#define VO_DRF_MBIST_OUT_fail_4_0_shift                                              (20)
+#define VO_DRF_MBIST_OUT_fail_4_0_mask                                               (0x00100000)
+#define VO_DRF_MBIST_OUT_fail_4_0(data)                                              (0x00100000&((data)<<20))
+#define VO_DRF_MBIST_OUT_fail_4_0_src(data)                                          ((0x00100000&(data))>>20)
+#define VO_DRF_MBIST_OUT_get_fail_4_0(data)                                          ((0x00100000&(data))>>20)
+#define VO_DRF_MBIST_OUT_fail_3_3_shift                                              (19)
+#define VO_DRF_MBIST_OUT_fail_3_3_mask                                               (0x00080000)
+#define VO_DRF_MBIST_OUT_fail_3_3(data)                                              (0x00080000&((data)<<19))
+#define VO_DRF_MBIST_OUT_fail_3_3_src(data)                                          ((0x00080000&(data))>>19)
+#define VO_DRF_MBIST_OUT_get_fail_3_3(data)                                          ((0x00080000&(data))>>19)
+#define VO_DRF_MBIST_OUT_fail_3_2_shift                                              (18)
+#define VO_DRF_MBIST_OUT_fail_3_2_mask                                               (0x00040000)
+#define VO_DRF_MBIST_OUT_fail_3_2(data)                                              (0x00040000&((data)<<18))
+#define VO_DRF_MBIST_OUT_fail_3_2_src(data)                                          ((0x00040000&(data))>>18)
+#define VO_DRF_MBIST_OUT_get_fail_3_2(data)                                          ((0x00040000&(data))>>18)
+#define VO_DRF_MBIST_OUT_fail_3_1_shift                                              (17)
+#define VO_DRF_MBIST_OUT_fail_3_1_mask                                               (0x00020000)
+#define VO_DRF_MBIST_OUT_fail_3_1(data)                                              (0x00020000&((data)<<17))
+#define VO_DRF_MBIST_OUT_fail_3_1_src(data)                                          ((0x00020000&(data))>>17)
+#define VO_DRF_MBIST_OUT_get_fail_3_1(data)                                          ((0x00020000&(data))>>17)
+#define VO_DRF_MBIST_OUT_fail_3_0_shift                                              (16)
+#define VO_DRF_MBIST_OUT_fail_3_0_mask                                               (0x00010000)
+#define VO_DRF_MBIST_OUT_fail_3_0(data)                                              (0x00010000&((data)<<16))
+#define VO_DRF_MBIST_OUT_fail_3_0_src(data)                                          ((0x00010000&(data))>>16)
+#define VO_DRF_MBIST_OUT_get_fail_3_0(data)                                          ((0x00010000&(data))>>16)
+#define VO_DRF_MBIST_OUT_fail_2_3_shift                                              (15)
+#define VO_DRF_MBIST_OUT_fail_2_3_mask                                               (0x00008000)
+#define VO_DRF_MBIST_OUT_fail_2_3(data)                                              (0x00008000&((data)<<15))
+#define VO_DRF_MBIST_OUT_fail_2_3_src(data)                                          ((0x00008000&(data))>>15)
+#define VO_DRF_MBIST_OUT_get_fail_2_3(data)                                          ((0x00008000&(data))>>15)
+#define VO_DRF_MBIST_OUT_fail_2_2_shift                                              (14)
+#define VO_DRF_MBIST_OUT_fail_2_2_mask                                               (0x00004000)
+#define VO_DRF_MBIST_OUT_fail_2_2(data)                                              (0x00004000&((data)<<14))
+#define VO_DRF_MBIST_OUT_fail_2_2_src(data)                                          ((0x00004000&(data))>>14)
+#define VO_DRF_MBIST_OUT_get_fail_2_2(data)                                          ((0x00004000&(data))>>14)
+#define VO_DRF_MBIST_OUT_fail_2_1_shift                                              (13)
+#define VO_DRF_MBIST_OUT_fail_2_1_mask                                               (0x00002000)
+#define VO_DRF_MBIST_OUT_fail_2_1(data)                                              (0x00002000&((data)<<13))
+#define VO_DRF_MBIST_OUT_fail_2_1_src(data)                                          ((0x00002000&(data))>>13)
+#define VO_DRF_MBIST_OUT_get_fail_2_1(data)                                          ((0x00002000&(data))>>13)
+#define VO_DRF_MBIST_OUT_fail_2_0_shift                                              (12)
+#define VO_DRF_MBIST_OUT_fail_2_0_mask                                               (0x00001000)
+#define VO_DRF_MBIST_OUT_fail_2_0(data)                                              (0x00001000&((data)<<12))
+#define VO_DRF_MBIST_OUT_fail_2_0_src(data)                                          ((0x00001000&(data))>>12)
+#define VO_DRF_MBIST_OUT_get_fail_2_0(data)                                          ((0x00001000&(data))>>12)
+#define VO_DRF_MBIST_OUT_fail_1_2_shift                                              (10)
+#define VO_DRF_MBIST_OUT_fail_1_2_mask                                               (0x00000400)
+#define VO_DRF_MBIST_OUT_fail_1_2(data)                                              (0x00000400&((data)<<10))
+#define VO_DRF_MBIST_OUT_fail_1_2_src(data)                                          ((0x00000400&(data))>>10)
+#define VO_DRF_MBIST_OUT_get_fail_1_2(data)                                          ((0x00000400&(data))>>10)
+#define VO_DRF_MBIST_OUT_fail_1_1_shift                                              (9)
+#define VO_DRF_MBIST_OUT_fail_1_1_mask                                               (0x00000200)
+#define VO_DRF_MBIST_OUT_fail_1_1(data)                                              (0x00000200&((data)<<9))
+#define VO_DRF_MBIST_OUT_fail_1_1_src(data)                                          ((0x00000200&(data))>>9)
+#define VO_DRF_MBIST_OUT_get_fail_1_1(data)                                          ((0x00000200&(data))>>9)
+#define VO_DRF_MBIST_OUT_fail_1_0_shift                                              (8)
+#define VO_DRF_MBIST_OUT_fail_1_0_mask                                               (0x00000100)
+#define VO_DRF_MBIST_OUT_fail_1_0(data)                                              (0x00000100&((data)<<8))
+#define VO_DRF_MBIST_OUT_fail_1_0_src(data)                                          ((0x00000100&(data))>>8)
+#define VO_DRF_MBIST_OUT_get_fail_1_0(data)                                          ((0x00000100&(data))>>8)
+#define VO_DRF_MBIST_OUT_done_5_shift                                                (4)
+#define VO_DRF_MBIST_OUT_done_5_mask                                                 (0x00000010)
+#define VO_DRF_MBIST_OUT_done_5(data)                                                (0x00000010&((data)<<4))
+#define VO_DRF_MBIST_OUT_done_5_src(data)                                            ((0x00000010&(data))>>4)
+#define VO_DRF_MBIST_OUT_get_done_5(data)                                            ((0x00000010&(data))>>4)
+#define VO_DRF_MBIST_OUT_done_4_shift                                                (3)
+#define VO_DRF_MBIST_OUT_done_4_mask                                                 (0x00000008)
+#define VO_DRF_MBIST_OUT_done_4(data)                                                (0x00000008&((data)<<3))
+#define VO_DRF_MBIST_OUT_done_4_src(data)                                            ((0x00000008&(data))>>3)
+#define VO_DRF_MBIST_OUT_get_done_4(data)                                            ((0x00000008&(data))>>3)
+#define VO_DRF_MBIST_OUT_done_3_shift                                                (2)
+#define VO_DRF_MBIST_OUT_done_3_mask                                                 (0x00000004)
+#define VO_DRF_MBIST_OUT_done_3(data)                                                (0x00000004&((data)<<2))
+#define VO_DRF_MBIST_OUT_done_3_src(data)                                            ((0x00000004&(data))>>2)
+#define VO_DRF_MBIST_OUT_get_done_3(data)                                            ((0x00000004&(data))>>2)
+#define VO_DRF_MBIST_OUT_done_2_shift                                                (1)
+#define VO_DRF_MBIST_OUT_done_2_mask                                                 (0x00000002)
+#define VO_DRF_MBIST_OUT_done_2(data)                                                (0x00000002&((data)<<1))
+#define VO_DRF_MBIST_OUT_done_2_src(data)                                            ((0x00000002&(data))>>1)
+#define VO_DRF_MBIST_OUT_get_done_2(data)                                            ((0x00000002&(data))>>1)
+#define VO_DRF_MBIST_OUT_done_1_shift                                                (0)
+#define VO_DRF_MBIST_OUT_done_1_mask                                                 (0x00000001)
+#define VO_DRF_MBIST_OUT_done_1(data)                                                (0x00000001&((data)<<0))
+#define VO_DRF_MBIST_OUT_done_1_src(data)                                            ((0x00000001&(data))>>0)
+#define VO_DRF_MBIST_OUT_get_done_1(data)                                            ((0x00000001&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/voregsram_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/voregsram_reg.h
new file mode 100644
index 00000000..d8a5425
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/voregsram_reg.h
@@ -0,0 +1,7199 @@
+/**************************************************************
+// Spec Version                  : 1.0
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/3/25 15:11:23
+***************************************************************/
+
+
+#ifndef _VOREGSRAM_REG_H_INCLUDED_
+#define _VOREGSRAM_REG_H_INCLUDED_
+#ifdef  _VOREGSRAM_USE_STRUCT
+typedef struct 
+{
+unsigned int     data:32;
+}REGSRAM;
+
+#endif
+
+#define REGSRAM_0                                                                    0x1800A000
+#define REGSRAM_1                                                                    0x1800A004
+#define REGSRAM_2                                                                    0x1800A008
+#define REGSRAM_3                                                                    0x1800A00C
+#define REGSRAM_4                                                                    0x1800A010
+#define REGSRAM_5                                                                    0x1800A014
+#define REGSRAM_6                                                                    0x1800A018
+#define REGSRAM_7                                                                    0x1800A01C
+#define REGSRAM_8                                                                    0x1800A020
+#define REGSRAM_9                                                                    0x1800A024
+#define REGSRAM_10                                                                    0x1800A028
+#define REGSRAM_11                                                                    0x1800A02C
+#define REGSRAM_12                                                                    0x1800A030
+#define REGSRAM_13                                                                    0x1800A034
+#define REGSRAM_14                                                                    0x1800A038
+#define REGSRAM_15                                                                    0x1800A03C
+#define REGSRAM_16                                                                    0x1800A040
+#define REGSRAM_17                                                                    0x1800A044
+#define REGSRAM_18                                                                    0x1800A048
+#define REGSRAM_19                                                                    0x1800A04C
+#define REGSRAM_20                                                                    0x1800A050
+#define REGSRAM_21                                                                    0x1800A054
+#define REGSRAM_22                                                                    0x1800A058
+#define REGSRAM_23                                                                    0x1800A05C
+#define REGSRAM_24                                                                    0x1800A060
+#define REGSRAM_25                                                                    0x1800A064
+#define REGSRAM_26                                                                    0x1800A068
+#define REGSRAM_27                                                                    0x1800A06C
+#define REGSRAM_28                                                                    0x1800A070
+#define REGSRAM_29                                                                    0x1800A074
+#define REGSRAM_30                                                                    0x1800A078
+#define REGSRAM_31                                                                    0x1800A07C
+#define REGSRAM_32                                                                    0x1800A080
+#define REGSRAM_33                                                                    0x1800A084
+#define REGSRAM_34                                                                    0x1800A088
+#define REGSRAM_35                                                                    0x1800A08C
+#define REGSRAM_36                                                                    0x1800A090
+#define REGSRAM_37                                                                    0x1800A094
+#define REGSRAM_38                                                                    0x1800A098
+#define REGSRAM_39                                                                    0x1800A09C
+#define REGSRAM_40                                                                    0x1800A0A0
+#define REGSRAM_41                                                                    0x1800A0A4
+#define REGSRAM_42                                                                    0x1800A0A8
+#define REGSRAM_43                                                                    0x1800A0AC
+#define REGSRAM_44                                                                    0x1800A0B0
+#define REGSRAM_45                                                                    0x1800A0B4
+#define REGSRAM_46                                                                    0x1800A0B8
+#define REGSRAM_47                                                                    0x1800A0BC
+#define REGSRAM_48                                                                    0x1800A0C0
+#define REGSRAM_49                                                                    0x1800A0C4
+#define REGSRAM_50                                                                    0x1800A0C8
+#define REGSRAM_51                                                                    0x1800A0CC
+#define REGSRAM_52                                                                    0x1800A0D0
+#define REGSRAM_53                                                                    0x1800A0D4
+#define REGSRAM_54                                                                    0x1800A0D8
+#define REGSRAM_55                                                                    0x1800A0DC
+#define REGSRAM_56                                                                    0x1800A0E0
+#define REGSRAM_57                                                                    0x1800A0E4
+#define REGSRAM_58                                                                    0x1800A0E8
+#define REGSRAM_59                                                                    0x1800A0EC
+#define REGSRAM_60                                                                    0x1800A0F0
+#define REGSRAM_61                                                                    0x1800A0F4
+#define REGSRAM_62                                                                    0x1800A0F8
+#define REGSRAM_63                                                                    0x1800A0FC
+#define REGSRAM_64                                                                    0x1800A100
+#define REGSRAM_65                                                                    0x1800A104
+#define REGSRAM_66                                                                    0x1800A108
+#define REGSRAM_67                                                                    0x1800A10C
+#define REGSRAM_68                                                                    0x1800A110
+#define REGSRAM_69                                                                    0x1800A114
+#define REGSRAM_70                                                                    0x1800A118
+#define REGSRAM_71                                                                    0x1800A11C
+#define REGSRAM_72                                                                    0x1800A120
+#define REGSRAM_73                                                                    0x1800A124
+#define REGSRAM_74                                                                    0x1800A128
+#define REGSRAM_75                                                                    0x1800A12C
+#define REGSRAM_76                                                                    0x1800A130
+#define REGSRAM_77                                                                    0x1800A134
+#define REGSRAM_78                                                                    0x1800A138
+#define REGSRAM_79                                                                    0x1800A13C
+#define REGSRAM_80                                                                    0x1800A140
+#define REGSRAM_81                                                                    0x1800A144
+#define REGSRAM_82                                                                    0x1800A148
+#define REGSRAM_83                                                                    0x1800A14C
+#define REGSRAM_84                                                                    0x1800A150
+#define REGSRAM_85                                                                    0x1800A154
+#define REGSRAM_86                                                                    0x1800A158
+#define REGSRAM_87                                                                    0x1800A15C
+#define REGSRAM_88                                                                    0x1800A160
+#define REGSRAM_89                                                                    0x1800A164
+#define REGSRAM_90                                                                    0x1800A168
+#define REGSRAM_91                                                                    0x1800A16C
+#define REGSRAM_92                                                                    0x1800A170
+#define REGSRAM_93                                                                    0x1800A174
+#define REGSRAM_94                                                                    0x1800A178
+#define REGSRAM_95                                                                    0x1800A17C
+#define REGSRAM_96                                                                    0x1800A180
+#define REGSRAM_97                                                                    0x1800A184
+#define REGSRAM_98                                                                    0x1800A188
+#define REGSRAM_99                                                                    0x1800A18C
+#define REGSRAM_100                                                                    0x1800A190
+#define REGSRAM_101                                                                    0x1800A194
+#define REGSRAM_102                                                                    0x1800A198
+#define REGSRAM_103                                                                    0x1800A19C
+#define REGSRAM_104                                                                    0x1800A1A0
+#define REGSRAM_105                                                                    0x1800A1A4
+#define REGSRAM_106                                                                    0x1800A1A8
+#define REGSRAM_107                                                                    0x1800A1AC
+#define REGSRAM_108                                                                    0x1800A1B0
+#define REGSRAM_109                                                                    0x1800A1B4
+#define REGSRAM_110                                                                    0x1800A1B8
+#define REGSRAM_111                                                                    0x1800A1BC
+#define REGSRAM_112                                                                    0x1800A1C0
+#define REGSRAM_113                                                                    0x1800A1C4
+#define REGSRAM_114                                                                    0x1800A1C8
+#define REGSRAM_115                                                                    0x1800A1CC
+#define REGSRAM_116                                                                    0x1800A1D0
+#define REGSRAM_117                                                                    0x1800A1D4
+#define REGSRAM_118                                                                    0x1800A1D8
+#define REGSRAM_119                                                                    0x1800A1DC
+#define REGSRAM_120                                                                    0x1800A1E0
+#define REGSRAM_121                                                                    0x1800A1E4
+#define REGSRAM_122                                                                    0x1800A1E8
+#define REGSRAM_123                                                                    0x1800A1EC
+#define REGSRAM_124                                                                    0x1800A1F0
+#define REGSRAM_125                                                                    0x1800A1F4
+#define REGSRAM_126                                                                    0x1800A1F8
+#define REGSRAM_127                                                                    0x1800A1FC
+#define REGSRAM_128                                                                    0x1800A200
+#define REGSRAM_129                                                                    0x1800A204
+#define REGSRAM_130                                                                    0x1800A208
+#define REGSRAM_131                                                                    0x1800A20C
+#define REGSRAM_132                                                                    0x1800A210
+#define REGSRAM_133                                                                    0x1800A214
+#define REGSRAM_134                                                                    0x1800A218
+#define REGSRAM_135                                                                    0x1800A21C
+#define REGSRAM_136                                                                    0x1800A220
+#define REGSRAM_137                                                                    0x1800A224
+#define REGSRAM_138                                                                    0x1800A228
+#define REGSRAM_139                                                                    0x1800A22C
+#define REGSRAM_140                                                                    0x1800A230
+#define REGSRAM_141                                                                    0x1800A234
+#define REGSRAM_142                                                                    0x1800A238
+#define REGSRAM_143                                                                    0x1800A23C
+#define REGSRAM_144                                                                    0x1800A240
+#define REGSRAM_145                                                                    0x1800A244
+#define REGSRAM_146                                                                    0x1800A248
+#define REGSRAM_147                                                                    0x1800A24C
+#define REGSRAM_148                                                                    0x1800A250
+#define REGSRAM_149                                                                    0x1800A254
+#define REGSRAM_150                                                                    0x1800A258
+#define REGSRAM_151                                                                    0x1800A25C
+#define REGSRAM_152                                                                    0x1800A260
+#define REGSRAM_153                                                                    0x1800A264
+#define REGSRAM_154                                                                    0x1800A268
+#define REGSRAM_155                                                                    0x1800A26C
+#define REGSRAM_156                                                                    0x1800A270
+#define REGSRAM_157                                                                    0x1800A274
+#define REGSRAM_158                                                                    0x1800A278
+#define REGSRAM_159                                                                    0x1800A27C
+#define REGSRAM_160                                                                    0x1800A280
+#define REGSRAM_161                                                                    0x1800A284
+#define REGSRAM_162                                                                    0x1800A288
+#define REGSRAM_163                                                                    0x1800A28C
+#define REGSRAM_164                                                                    0x1800A290
+#define REGSRAM_165                                                                    0x1800A294
+#define REGSRAM_166                                                                    0x1800A298
+#define REGSRAM_167                                                                    0x1800A29C
+#define REGSRAM_168                                                                    0x1800A2A0
+#define REGSRAM_169                                                                    0x1800A2A4
+#define REGSRAM_170                                                                    0x1800A2A8
+#define REGSRAM_171                                                                    0x1800A2AC
+#define REGSRAM_172                                                                    0x1800A2B0
+#define REGSRAM_173                                                                    0x1800A2B4
+#define REGSRAM_174                                                                    0x1800A2B8
+#define REGSRAM_175                                                                    0x1800A2BC
+#define REGSRAM_176                                                                    0x1800A2C0
+#define REGSRAM_177                                                                    0x1800A2C4
+#define REGSRAM_178                                                                    0x1800A2C8
+#define REGSRAM_179                                                                    0x1800A2CC
+#define REGSRAM_180                                                                    0x1800A2D0
+#define REGSRAM_181                                                                    0x1800A2D4
+#define REGSRAM_182                                                                    0x1800A2D8
+#define REGSRAM_183                                                                    0x1800A2DC
+#define REGSRAM_184                                                                    0x1800A2E0
+#define REGSRAM_185                                                                    0x1800A2E4
+#define REGSRAM_186                                                                    0x1800A2E8
+#define REGSRAM_187                                                                    0x1800A2EC
+#define REGSRAM_188                                                                    0x1800A2F0
+#define REGSRAM_189                                                                    0x1800A2F4
+#define REGSRAM_190                                                                    0x1800A2F8
+#define REGSRAM_191                                                                    0x1800A2FC
+#define REGSRAM_192                                                                    0x1800A300
+#define REGSRAM_193                                                                    0x1800A304
+#define REGSRAM_194                                                                    0x1800A308
+#define REGSRAM_195                                                                    0x1800A30C
+#define REGSRAM_196                                                                    0x1800A310
+#define REGSRAM_197                                                                    0x1800A314
+#define REGSRAM_198                                                                    0x1800A318
+#define REGSRAM_199                                                                    0x1800A31C
+#define REGSRAM_200                                                                    0x1800A320
+#define REGSRAM_201                                                                    0x1800A324
+#define REGSRAM_202                                                                    0x1800A328
+#define REGSRAM_203                                                                    0x1800A32C
+#define REGSRAM_204                                                                    0x1800A330
+#define REGSRAM_205                                                                    0x1800A334
+#define REGSRAM_206                                                                    0x1800A338
+#define REGSRAM_207                                                                    0x1800A33C
+#define REGSRAM_208                                                                    0x1800A340
+#define REGSRAM_209                                                                    0x1800A344
+#define REGSRAM_210                                                                    0x1800A348
+#define REGSRAM_211                                                                    0x1800A34C
+#define REGSRAM_212                                                                    0x1800A350
+#define REGSRAM_213                                                                    0x1800A354
+#define REGSRAM_214                                                                    0x1800A358
+#define REGSRAM_215                                                                    0x1800A35C
+#define REGSRAM_216                                                                    0x1800A360
+#define REGSRAM_217                                                                    0x1800A364
+#define REGSRAM_218                                                                    0x1800A368
+#define REGSRAM_219                                                                    0x1800A36C
+#define REGSRAM_220                                                                    0x1800A370
+#define REGSRAM_221                                                                    0x1800A374
+#define REGSRAM_222                                                                    0x1800A378
+#define REGSRAM_223                                                                    0x1800A37C
+#define REGSRAM_224                                                                    0x1800A380
+#define REGSRAM_225                                                                    0x1800A384
+#define REGSRAM_226                                                                    0x1800A388
+#define REGSRAM_227                                                                    0x1800A38C
+#define REGSRAM_228                                                                    0x1800A390
+#define REGSRAM_229                                                                    0x1800A394
+#define REGSRAM_230                                                                    0x1800A398
+#define REGSRAM_231                                                                    0x1800A39C
+#define REGSRAM_232                                                                    0x1800A3A0
+#define REGSRAM_233                                                                    0x1800A3A4
+#define REGSRAM_234                                                                    0x1800A3A8
+#define REGSRAM_235                                                                    0x1800A3AC
+#define REGSRAM_236                                                                    0x1800A3B0
+#define REGSRAM_237                                                                    0x1800A3B4
+#define REGSRAM_238                                                                    0x1800A3B8
+#define REGSRAM_239                                                                    0x1800A3BC
+#define REGSRAM_240                                                                    0x1800A3C0
+#define REGSRAM_241                                                                    0x1800A3C4
+#define REGSRAM_242                                                                    0x1800A3C8
+#define REGSRAM_243                                                                    0x1800A3CC
+#define REGSRAM_244                                                                    0x1800A3D0
+#define REGSRAM_245                                                                    0x1800A3D4
+#define REGSRAM_246                                                                    0x1800A3D8
+#define REGSRAM_247                                                                    0x1800A3DC
+#define REGSRAM_248                                                                    0x1800A3E0
+#define REGSRAM_249                                                                    0x1800A3E4
+#define REGSRAM_250                                                                    0x1800A3E8
+#define REGSRAM_251                                                                    0x1800A3EC
+#define REGSRAM_252                                                                    0x1800A3F0
+#define REGSRAM_253                                                                    0x1800A3F4
+#define REGSRAM_254                                                                    0x1800A3F8
+#define REGSRAM_255                                                                    0x1800A3FC
+#define REGSRAM_256                                                                    0x1800A400
+#define REGSRAM_257                                                                    0x1800A404
+#define REGSRAM_258                                                                    0x1800A408
+#define REGSRAM_259                                                                    0x1800A40C
+#define REGSRAM_260                                                                    0x1800A410
+#define REGSRAM_261                                                                    0x1800A414
+#define REGSRAM_262                                                                    0x1800A418
+#define REGSRAM_263                                                                    0x1800A41C
+#define REGSRAM_264                                                                    0x1800A420
+#define REGSRAM_265                                                                    0x1800A424
+#define REGSRAM_266                                                                    0x1800A428
+#define REGSRAM_267                                                                    0x1800A42C
+#define REGSRAM_268                                                                    0x1800A430
+#define REGSRAM_269                                                                    0x1800A434
+#define REGSRAM_270                                                                    0x1800A438
+#define REGSRAM_271                                                                    0x1800A43C
+#define REGSRAM_272                                                                    0x1800A440
+#define REGSRAM_273                                                                    0x1800A444
+#define REGSRAM_274                                                                    0x1800A448
+#define REGSRAM_275                                                                    0x1800A44C
+#define REGSRAM_276                                                                    0x1800A450
+#define REGSRAM_277                                                                    0x1800A454
+#define REGSRAM_278                                                                    0x1800A458
+#define REGSRAM_279                                                                    0x1800A45C
+#define REGSRAM_280                                                                    0x1800A460
+#define REGSRAM_281                                                                    0x1800A464
+#define REGSRAM_282                                                                    0x1800A468
+#define REGSRAM_283                                                                    0x1800A46C
+#define REGSRAM_284                                                                    0x1800A470
+#define REGSRAM_285                                                                    0x1800A474
+#define REGSRAM_286                                                                    0x1800A478
+#define REGSRAM_287                                                                    0x1800A47C
+#define REGSRAM_288                                                                    0x1800A480
+#define REGSRAM_289                                                                    0x1800A484
+#define REGSRAM_290                                                                    0x1800A488
+#define REGSRAM_291                                                                    0x1800A48C
+#define REGSRAM_292                                                                    0x1800A490
+#define REGSRAM_293                                                                    0x1800A494
+#define REGSRAM_294                                                                    0x1800A498
+#define REGSRAM_295                                                                    0x1800A49C
+#define REGSRAM_296                                                                    0x1800A4A0
+#define REGSRAM_297                                                                    0x1800A4A4
+#define REGSRAM_298                                                                    0x1800A4A8
+#define REGSRAM_299                                                                    0x1800A4AC
+#define REGSRAM_300                                                                    0x1800A4B0
+#define REGSRAM_301                                                                    0x1800A4B4
+#define REGSRAM_302                                                                    0x1800A4B8
+#define REGSRAM_303                                                                    0x1800A4BC
+#define REGSRAM_304                                                                    0x1800A4C0
+#define REGSRAM_305                                                                    0x1800A4C4
+#define REGSRAM_306                                                                    0x1800A4C8
+#define REGSRAM_307                                                                    0x1800A4CC
+#define REGSRAM_308                                                                    0x1800A4D0
+#define REGSRAM_309                                                                    0x1800A4D4
+#define REGSRAM_310                                                                    0x1800A4D8
+#define REGSRAM_311                                                                    0x1800A4DC
+#define REGSRAM_312                                                                    0x1800A4E0
+#define REGSRAM_313                                                                    0x1800A4E4
+#define REGSRAM_314                                                                    0x1800A4E8
+#define REGSRAM_315                                                                    0x1800A4EC
+#define REGSRAM_316                                                                    0x1800A4F0
+#define REGSRAM_317                                                                    0x1800A4F4
+#define REGSRAM_318                                                                    0x1800A4F8
+#define REGSRAM_319                                                                    0x1800A4FC
+#define REGSRAM_320                                                                    0x1800A500
+#define REGSRAM_321                                                                    0x1800A504
+#define REGSRAM_322                                                                    0x1800A508
+#define REGSRAM_323                                                                    0x1800A50C
+#define REGSRAM_324                                                                    0x1800A510
+#define REGSRAM_325                                                                    0x1800A514
+#define REGSRAM_326                                                                    0x1800A518
+#define REGSRAM_327                                                                    0x1800A51C
+#define REGSRAM_328                                                                    0x1800A520
+#define REGSRAM_329                                                                    0x1800A524
+#define REGSRAM_330                                                                    0x1800A528
+#define REGSRAM_331                                                                    0x1800A52C
+#define REGSRAM_332                                                                    0x1800A530
+#define REGSRAM_333                                                                    0x1800A534
+#define REGSRAM_334                                                                    0x1800A538
+#define REGSRAM_335                                                                    0x1800A53C
+#define REGSRAM_336                                                                    0x1800A540
+#define REGSRAM_337                                                                    0x1800A544
+#define REGSRAM_338                                                                    0x1800A548
+#define REGSRAM_339                                                                    0x1800A54C
+#define REGSRAM_340                                                                    0x1800A550
+#define REGSRAM_341                                                                    0x1800A554
+#define REGSRAM_342                                                                    0x1800A558
+#define REGSRAM_343                                                                    0x1800A55C
+#define REGSRAM_344                                                                    0x1800A560
+#define REGSRAM_345                                                                    0x1800A564
+#define REGSRAM_346                                                                    0x1800A568
+#define REGSRAM_347                                                                    0x1800A56C
+#define REGSRAM_348                                                                    0x1800A570
+#define REGSRAM_349                                                                    0x1800A574
+#define REGSRAM_350                                                                    0x1800A578
+#define REGSRAM_351                                                                    0x1800A57C
+#define REGSRAM_352                                                                    0x1800A580
+#define REGSRAM_353                                                                    0x1800A584
+#define REGSRAM_354                                                                    0x1800A588
+#define REGSRAM_355                                                                    0x1800A58C
+#define REGSRAM_356                                                                    0x1800A590
+#define REGSRAM_357                                                                    0x1800A594
+#define REGSRAM_358                                                                    0x1800A598
+#define REGSRAM_359                                                                    0x1800A59C
+#define REGSRAM_360                                                                    0x1800A5A0
+#define REGSRAM_361                                                                    0x1800A5A4
+#define REGSRAM_362                                                                    0x1800A5A8
+#define REGSRAM_363                                                                    0x1800A5AC
+#define REGSRAM_364                                                                    0x1800A5B0
+#define REGSRAM_365                                                                    0x1800A5B4
+#define REGSRAM_366                                                                    0x1800A5B8
+#define REGSRAM_367                                                                    0x1800A5BC
+#define REGSRAM_368                                                                    0x1800A5C0
+#define REGSRAM_369                                                                    0x1800A5C4
+#define REGSRAM_370                                                                    0x1800A5C8
+#define REGSRAM_371                                                                    0x1800A5CC
+#define REGSRAM_372                                                                    0x1800A5D0
+#define REGSRAM_373                                                                    0x1800A5D4
+#define REGSRAM_374                                                                    0x1800A5D8
+#define REGSRAM_375                                                                    0x1800A5DC
+#define REGSRAM_376                                                                    0x1800A5E0
+#define REGSRAM_377                                                                    0x1800A5E4
+#define REGSRAM_378                                                                    0x1800A5E8
+#define REGSRAM_379                                                                    0x1800A5EC
+#define REGSRAM_380                                                                    0x1800A5F0
+#define REGSRAM_381                                                                    0x1800A5F4
+#define REGSRAM_382                                                                    0x1800A5F8
+#define REGSRAM_383                                                                    0x1800A5FC
+#define REGSRAM_384                                                                    0x1800A600
+#define REGSRAM_385                                                                    0x1800A604
+#define REGSRAM_386                                                                    0x1800A608
+#define REGSRAM_387                                                                    0x1800A60C
+#define REGSRAM_388                                                                    0x1800A610
+#define REGSRAM_389                                                                    0x1800A614
+#define REGSRAM_390                                                                    0x1800A618
+#define REGSRAM_391                                                                    0x1800A61C
+#define REGSRAM_392                                                                    0x1800A620
+#define REGSRAM_393                                                                    0x1800A624
+#define REGSRAM_394                                                                    0x1800A628
+#define REGSRAM_395                                                                    0x1800A62C
+#define REGSRAM_396                                                                    0x1800A630
+#define REGSRAM_397                                                                    0x1800A634
+#define REGSRAM_398                                                                    0x1800A638
+#define REGSRAM_399                                                                    0x1800A63C
+#define REGSRAM_400                                                                    0x1800A640
+#define REGSRAM_401                                                                    0x1800A644
+#define REGSRAM_402                                                                    0x1800A648
+#define REGSRAM_403                                                                    0x1800A64C
+#define REGSRAM_404                                                                    0x1800A650
+#define REGSRAM_405                                                                    0x1800A654
+#define REGSRAM_406                                                                    0x1800A658
+#define REGSRAM_407                                                                    0x1800A65C
+#define REGSRAM_408                                                                    0x1800A660
+#define REGSRAM_409                                                                    0x1800A664
+#define REGSRAM_410                                                                    0x1800A668
+#define REGSRAM_411                                                                    0x1800A66C
+#define REGSRAM_412                                                                    0x1800A670
+#define REGSRAM_413                                                                    0x1800A674
+#define REGSRAM_414                                                                    0x1800A678
+#define REGSRAM_415                                                                    0x1800A67C
+#define REGSRAM_416                                                                    0x1800A680
+#define REGSRAM_417                                                                    0x1800A684
+#define REGSRAM_418                                                                    0x1800A688
+#define REGSRAM_419                                                                    0x1800A68C
+#define REGSRAM_420                                                                    0x1800A690
+#define REGSRAM_421                                                                    0x1800A694
+#define REGSRAM_422                                                                    0x1800A698
+#define REGSRAM_423                                                                    0x1800A69C
+#define REGSRAM_424                                                                    0x1800A6A0
+#define REGSRAM_425                                                                    0x1800A6A4
+#define REGSRAM_426                                                                    0x1800A6A8
+#define REGSRAM_427                                                                    0x1800A6AC
+#define REGSRAM_428                                                                    0x1800A6B0
+#define REGSRAM_429                                                                    0x1800A6B4
+#define REGSRAM_430                                                                    0x1800A6B8
+#define REGSRAM_431                                                                    0x1800A6BC
+#define REGSRAM_432                                                                    0x1800A6C0
+#define REGSRAM_433                                                                    0x1800A6C4
+#define REGSRAM_434                                                                    0x1800A6C8
+#define REGSRAM_435                                                                    0x1800A6CC
+#define REGSRAM_436                                                                    0x1800A6D0
+#define REGSRAM_437                                                                    0x1800A6D4
+#define REGSRAM_438                                                                    0x1800A6D8
+#define REGSRAM_439                                                                    0x1800A6DC
+#define REGSRAM_440                                                                    0x1800A6E0
+#define REGSRAM_441                                                                    0x1800A6E4
+#define REGSRAM_442                                                                    0x1800A6E8
+#define REGSRAM_443                                                                    0x1800A6EC
+#define REGSRAM_444                                                                    0x1800A6F0
+#define REGSRAM_445                                                                    0x1800A6F4
+#define REGSRAM_446                                                                    0x1800A6F8
+#define REGSRAM_447                                                                    0x1800A6FC
+#define REGSRAM_448                                                                    0x1800A700
+#define REGSRAM_449                                                                    0x1800A704
+#define REGSRAM_450                                                                    0x1800A708
+#define REGSRAM_451                                                                    0x1800A70C
+#define REGSRAM_452                                                                    0x1800A710
+#define REGSRAM_453                                                                    0x1800A714
+#define REGSRAM_454                                                                    0x1800A718
+#define REGSRAM_455                                                                    0x1800A71C
+#define REGSRAM_456                                                                    0x1800A720
+#define REGSRAM_457                                                                    0x1800A724
+#define REGSRAM_458                                                                    0x1800A728
+#define REGSRAM_459                                                                    0x1800A72C
+#define REGSRAM_460                                                                    0x1800A730
+#define REGSRAM_461                                                                    0x1800A734
+#define REGSRAM_462                                                                    0x1800A738
+#define REGSRAM_463                                                                    0x1800A73C
+#define REGSRAM_464                                                                    0x1800A740
+#define REGSRAM_465                                                                    0x1800A744
+#define REGSRAM_466                                                                    0x1800A748
+#define REGSRAM_467                                                                    0x1800A74C
+#define REGSRAM_468                                                                    0x1800A750
+#define REGSRAM_469                                                                    0x1800A754
+#define REGSRAM_470                                                                    0x1800A758
+#define REGSRAM_471                                                                    0x1800A75C
+#define REGSRAM_472                                                                    0x1800A760
+#define REGSRAM_473                                                                    0x1800A764
+#define REGSRAM_474                                                                    0x1800A768
+#define REGSRAM_475                                                                    0x1800A76C
+#define REGSRAM_476                                                                    0x1800A770
+#define REGSRAM_477                                                                    0x1800A774
+#define REGSRAM_478                                                                    0x1800A778
+#define REGSRAM_479                                                                    0x1800A77C
+#define REGSRAM_480                                                                    0x1800A780
+#define REGSRAM_481                                                                    0x1800A784
+#define REGSRAM_482                                                                    0x1800A788
+#define REGSRAM_483                                                                    0x1800A78C
+#define REGSRAM_484                                                                    0x1800A790
+#define REGSRAM_485                                                                    0x1800A794
+#define REGSRAM_486                                                                    0x1800A798
+#define REGSRAM_487                                                                    0x1800A79C
+#define REGSRAM_488                                                                    0x1800A7A0
+#define REGSRAM_489                                                                    0x1800A7A4
+#define REGSRAM_490                                                                    0x1800A7A8
+#define REGSRAM_491                                                                    0x1800A7AC
+#define REGSRAM_492                                                                    0x1800A7B0
+#define REGSRAM_493                                                                    0x1800A7B4
+#define REGSRAM_494                                                                    0x1800A7B8
+#define REGSRAM_495                                                                    0x1800A7BC
+#define REGSRAM_496                                                                    0x1800A7C0
+#define REGSRAM_497                                                                    0x1800A7C4
+#define REGSRAM_498                                                                    0x1800A7C8
+#define REGSRAM_499                                                                    0x1800A7CC
+#define REGSRAM_500                                                                    0x1800A7D0
+#define REGSRAM_501                                                                    0x1800A7D4
+#define REGSRAM_502                                                                    0x1800A7D8
+#define REGSRAM_503                                                                    0x1800A7DC
+#define REGSRAM_504                                                                    0x1800A7E0
+#define REGSRAM_505                                                                    0x1800A7E4
+#define REGSRAM_506                                                                    0x1800A7E8
+#define REGSRAM_507                                                                    0x1800A7EC
+#define REGSRAM_508                                                                    0x1800A7F0
+#define REGSRAM_509                                                                    0x1800A7F4
+#define REGSRAM_510                                                                    0x1800A7F8
+#define REGSRAM_511                                                                    0x1800A7FC
+#define REGSRAM_512                                                                    0x1800A800
+#define REGSRAM_513                                                                    0x1800A804
+#define REGSRAM_514                                                                    0x1800A808
+#define REGSRAM_515                                                                    0x1800A80C
+#define REGSRAM_516                                                                    0x1800A810
+#define REGSRAM_517                                                                    0x1800A814
+#define REGSRAM_518                                                                    0x1800A818
+#define REGSRAM_519                                                                    0x1800A81C
+#define REGSRAM_520                                                                    0x1800A820
+#define REGSRAM_521                                                                    0x1800A824
+#define REGSRAM_522                                                                    0x1800A828
+#define REGSRAM_523                                                                    0x1800A82C
+#define REGSRAM_524                                                                    0x1800A830
+#define REGSRAM_525                                                                    0x1800A834
+#define REGSRAM_526                                                                    0x1800A838
+#define REGSRAM_527                                                                    0x1800A83C
+#define REGSRAM_528                                                                    0x1800A840
+#define REGSRAM_529                                                                    0x1800A844
+#define REGSRAM_530                                                                    0x1800A848
+#define REGSRAM_531                                                                    0x1800A84C
+#define REGSRAM_532                                                                    0x1800A850
+#define REGSRAM_533                                                                    0x1800A854
+#define REGSRAM_534                                                                    0x1800A858
+#define REGSRAM_535                                                                    0x1800A85C
+#define REGSRAM_536                                                                    0x1800A860
+#define REGSRAM_537                                                                    0x1800A864
+#define REGSRAM_538                                                                    0x1800A868
+#define REGSRAM_539                                                                    0x1800A86C
+#define REGSRAM_540                                                                    0x1800A870
+#define REGSRAM_541                                                                    0x1800A874
+#define REGSRAM_542                                                                    0x1800A878
+#define REGSRAM_543                                                                    0x1800A87C
+#define REGSRAM_544                                                                    0x1800A880
+#define REGSRAM_545                                                                    0x1800A884
+#define REGSRAM_546                                                                    0x1800A888
+#define REGSRAM_547                                                                    0x1800A88C
+#define REGSRAM_548                                                                    0x1800A890
+#define REGSRAM_549                                                                    0x1800A894
+#define REGSRAM_550                                                                    0x1800A898
+#define REGSRAM_551                                                                    0x1800A89C
+#define REGSRAM_552                                                                    0x1800A8A0
+#define REGSRAM_553                                                                    0x1800A8A4
+#define REGSRAM_554                                                                    0x1800A8A8
+#define REGSRAM_555                                                                    0x1800A8AC
+#define REGSRAM_556                                                                    0x1800A8B0
+#define REGSRAM_557                                                                    0x1800A8B4
+#define REGSRAM_558                                                                    0x1800A8B8
+#define REGSRAM_559                                                                    0x1800A8BC
+#define REGSRAM_560                                                                    0x1800A8C0
+#define REGSRAM_561                                                                    0x1800A8C4
+#define REGSRAM_562                                                                    0x1800A8C8
+#define REGSRAM_563                                                                    0x1800A8CC
+#define REGSRAM_564                                                                    0x1800A8D0
+#define REGSRAM_565                                                                    0x1800A8D4
+#define REGSRAM_566                                                                    0x1800A8D8
+#define REGSRAM_567                                                                    0x1800A8DC
+#define REGSRAM_568                                                                    0x1800A8E0
+#define REGSRAM_569                                                                    0x1800A8E4
+#define REGSRAM_570                                                                    0x1800A8E8
+#define REGSRAM_571                                                                    0x1800A8EC
+#define REGSRAM_572                                                                    0x1800A8F0
+#define REGSRAM_573                                                                    0x1800A8F4
+#define REGSRAM_574                                                                    0x1800A8F8
+#define REGSRAM_575                                                                    0x1800A8FC
+#define REGSRAM_576                                                                    0x1800A900
+#define REGSRAM_577                                                                    0x1800A904
+#define REGSRAM_578                                                                    0x1800A908
+#define REGSRAM_579                                                                    0x1800A90C
+#define REGSRAM_580                                                                    0x1800A910
+#define REGSRAM_581                                                                    0x1800A914
+#define REGSRAM_582                                                                    0x1800A918
+#define REGSRAM_583                                                                    0x1800A91C
+#define REGSRAM_584                                                                    0x1800A920
+#define REGSRAM_585                                                                    0x1800A924
+#define REGSRAM_586                                                                    0x1800A928
+#define REGSRAM_587                                                                    0x1800A92C
+#define REGSRAM_588                                                                    0x1800A930
+#define REGSRAM_589                                                                    0x1800A934
+#define REGSRAM_590                                                                    0x1800A938
+#define REGSRAM_591                                                                    0x1800A93C
+#define REGSRAM_592                                                                    0x1800A940
+#define REGSRAM_593                                                                    0x1800A944
+#define REGSRAM_594                                                                    0x1800A948
+#define REGSRAM_595                                                                    0x1800A94C
+#define REGSRAM_596                                                                    0x1800A950
+#define REGSRAM_597                                                                    0x1800A954
+#define REGSRAM_598                                                                    0x1800A958
+#define REGSRAM_599                                                                    0x1800A95C
+#define REGSRAM_600                                                                    0x1800A960
+#define REGSRAM_601                                                                    0x1800A964
+#define REGSRAM_602                                                                    0x1800A968
+#define REGSRAM_603                                                                    0x1800A96C
+#define REGSRAM_604                                                                    0x1800A970
+#define REGSRAM_605                                                                    0x1800A974
+#define REGSRAM_606                                                                    0x1800A978
+#define REGSRAM_607                                                                    0x1800A97C
+#define REGSRAM_608                                                                    0x1800A980
+#define REGSRAM_609                                                                    0x1800A984
+#define REGSRAM_610                                                                    0x1800A988
+#define REGSRAM_611                                                                    0x1800A98C
+#define REGSRAM_612                                                                    0x1800A990
+#define REGSRAM_613                                                                    0x1800A994
+#define REGSRAM_614                                                                    0x1800A998
+#define REGSRAM_615                                                                    0x1800A99C
+#define REGSRAM_616                                                                    0x1800A9A0
+#define REGSRAM_617                                                                    0x1800A9A4
+#define REGSRAM_618                                                                    0x1800A9A8
+#define REGSRAM_619                                                                    0x1800A9AC
+#define REGSRAM_620                                                                    0x1800A9B0
+#define REGSRAM_621                                                                    0x1800A9B4
+#define REGSRAM_622                                                                    0x1800A9B8
+#define REGSRAM_623                                                                    0x1800A9BC
+#define REGSRAM_624                                                                    0x1800A9C0
+#define REGSRAM_625                                                                    0x1800A9C4
+#define REGSRAM_626                                                                    0x1800A9C8
+#define REGSRAM_627                                                                    0x1800A9CC
+#define REGSRAM_628                                                                    0x1800A9D0
+#define REGSRAM_629                                                                    0x1800A9D4
+#define REGSRAM_630                                                                    0x1800A9D8
+#define REGSRAM_631                                                                    0x1800A9DC
+#define REGSRAM_632                                                                    0x1800A9E0
+#define REGSRAM_633                                                                    0x1800A9E4
+#define REGSRAM_634                                                                    0x1800A9E8
+#define REGSRAM_635                                                                    0x1800A9EC
+#define REGSRAM_636                                                                    0x1800A9F0
+#define REGSRAM_637                                                                    0x1800A9F4
+#define REGSRAM_638                                                                    0x1800A9F8
+#define REGSRAM_639                                                                    0x1800A9FC
+#define REGSRAM_640                                                                    0x1800AA00
+#define REGSRAM_641                                                                    0x1800AA04
+#define REGSRAM_642                                                                    0x1800AA08
+#define REGSRAM_643                                                                    0x1800AA0C
+#define REGSRAM_644                                                                    0x1800AA10
+#define REGSRAM_645                                                                    0x1800AA14
+#define REGSRAM_646                                                                    0x1800AA18
+#define REGSRAM_647                                                                    0x1800AA1C
+#define REGSRAM_648                                                                    0x1800AA20
+#define REGSRAM_649                                                                    0x1800AA24
+#define REGSRAM_650                                                                    0x1800AA28
+#define REGSRAM_651                                                                    0x1800AA2C
+#define REGSRAM_652                                                                    0x1800AA30
+#define REGSRAM_653                                                                    0x1800AA34
+#define REGSRAM_654                                                                    0x1800AA38
+#define REGSRAM_655                                                                    0x1800AA3C
+#define REGSRAM_656                                                                    0x1800AA40
+#define REGSRAM_657                                                                    0x1800AA44
+#define REGSRAM_658                                                                    0x1800AA48
+#define REGSRAM_659                                                                    0x1800AA4C
+#define REGSRAM_660                                                                    0x1800AA50
+#define REGSRAM_661                                                                    0x1800AA54
+#define REGSRAM_662                                                                    0x1800AA58
+#define REGSRAM_663                                                                    0x1800AA5C
+#define REGSRAM_664                                                                    0x1800AA60
+#define REGSRAM_665                                                                    0x1800AA64
+#define REGSRAM_666                                                                    0x1800AA68
+#define REGSRAM_667                                                                    0x1800AA6C
+#define REGSRAM_668                                                                    0x1800AA70
+#define REGSRAM_669                                                                    0x1800AA74
+#define REGSRAM_670                                                                    0x1800AA78
+#define REGSRAM_671                                                                    0x1800AA7C
+#define REGSRAM_672                                                                    0x1800AA80
+#define REGSRAM_673                                                                    0x1800AA84
+#define REGSRAM_674                                                                    0x1800AA88
+#define REGSRAM_675                                                                    0x1800AA8C
+#define REGSRAM_676                                                                    0x1800AA90
+#define REGSRAM_677                                                                    0x1800AA94
+#define REGSRAM_678                                                                    0x1800AA98
+#define REGSRAM_679                                                                    0x1800AA9C
+#define REGSRAM_680                                                                    0x1800AAA0
+#define REGSRAM_681                                                                    0x1800AAA4
+#define REGSRAM_682                                                                    0x1800AAA8
+#define REGSRAM_683                                                                    0x1800AAAC
+#define REGSRAM_684                                                                    0x1800AAB0
+#define REGSRAM_685                                                                    0x1800AAB4
+#define REGSRAM_686                                                                    0x1800AAB8
+#define REGSRAM_687                                                                    0x1800AABC
+#define REGSRAM_688                                                                    0x1800AAC0
+#define REGSRAM_689                                                                    0x1800AAC4
+#define REGSRAM_690                                                                    0x1800AAC8
+#define REGSRAM_691                                                                    0x1800AACC
+#define REGSRAM_692                                                                    0x1800AAD0
+#define REGSRAM_693                                                                    0x1800AAD4
+#define REGSRAM_694                                                                    0x1800AAD8
+#define REGSRAM_695                                                                    0x1800AADC
+#define REGSRAM_696                                                                    0x1800AAE0
+#define REGSRAM_697                                                                    0x1800AAE4
+#define REGSRAM_698                                                                    0x1800AAE8
+#define REGSRAM_699                                                                    0x1800AAEC
+#define REGSRAM_700                                                                    0x1800AAF0
+#define REGSRAM_701                                                                    0x1800AAF4
+#define REGSRAM_702                                                                    0x1800AAF8
+#define REGSRAM_703                                                                    0x1800AAFC
+#define REGSRAM_704                                                                    0x1800AB00
+#define REGSRAM_705                                                                    0x1800AB04
+#define REGSRAM_706                                                                    0x1800AB08
+#define REGSRAM_707                                                                    0x1800AB0C
+#define REGSRAM_708                                                                    0x1800AB10
+#define REGSRAM_709                                                                    0x1800AB14
+#define REGSRAM_710                                                                    0x1800AB18
+#define REGSRAM_711                                                                    0x1800AB1C
+#define REGSRAM_712                                                                    0x1800AB20
+#define REGSRAM_713                                                                    0x1800AB24
+#define REGSRAM_714                                                                    0x1800AB28
+#define REGSRAM_715                                                                    0x1800AB2C
+#define REGSRAM_716                                                                    0x1800AB30
+#define REGSRAM_717                                                                    0x1800AB34
+#define REGSRAM_718                                                                    0x1800AB38
+#define REGSRAM_719                                                                    0x1800AB3C
+#define REGSRAM_720                                                                    0x1800AB40
+#define REGSRAM_721                                                                    0x1800AB44
+#define REGSRAM_722                                                                    0x1800AB48
+#define REGSRAM_723                                                                    0x1800AB4C
+#define REGSRAM_724                                                                    0x1800AB50
+#define REGSRAM_725                                                                    0x1800AB54
+#define REGSRAM_726                                                                    0x1800AB58
+#define REGSRAM_727                                                                    0x1800AB5C
+#define REGSRAM_728                                                                    0x1800AB60
+#define REGSRAM_729                                                                    0x1800AB64
+#define REGSRAM_730                                                                    0x1800AB68
+#define REGSRAM_731                                                                    0x1800AB6C
+#define REGSRAM_732                                                                    0x1800AB70
+#define REGSRAM_733                                                                    0x1800AB74
+#define REGSRAM_734                                                                    0x1800AB78
+#define REGSRAM_735                                                                    0x1800AB7C
+#define REGSRAM_736                                                                    0x1800AB80
+#define REGSRAM_737                                                                    0x1800AB84
+#define REGSRAM_738                                                                    0x1800AB88
+#define REGSRAM_739                                                                    0x1800AB8C
+#define REGSRAM_740                                                                    0x1800AB90
+#define REGSRAM_741                                                                    0x1800AB94
+#define REGSRAM_742                                                                    0x1800AB98
+#define REGSRAM_743                                                                    0x1800AB9C
+#define REGSRAM_744                                                                    0x1800ABA0
+#define REGSRAM_745                                                                    0x1800ABA4
+#define REGSRAM_746                                                                    0x1800ABA8
+#define REGSRAM_747                                                                    0x1800ABAC
+#define REGSRAM_748                                                                    0x1800ABB0
+#define REGSRAM_749                                                                    0x1800ABB4
+#define REGSRAM_750                                                                    0x1800ABB8
+#define REGSRAM_751                                                                    0x1800ABBC
+#define REGSRAM_752                                                                    0x1800ABC0
+#define REGSRAM_753                                                                    0x1800ABC4
+#define REGSRAM_754                                                                    0x1800ABC8
+#define REGSRAM_755                                                                    0x1800ABCC
+#define REGSRAM_756                                                                    0x1800ABD0
+#define REGSRAM_757                                                                    0x1800ABD4
+#define REGSRAM_758                                                                    0x1800ABD8
+#define REGSRAM_759                                                                    0x1800ABDC
+#define REGSRAM_760                                                                    0x1800ABE0
+#define REGSRAM_761                                                                    0x1800ABE4
+#define REGSRAM_762                                                                    0x1800ABE8
+#define REGSRAM_763                                                                    0x1800ABEC
+#define REGSRAM_764                                                                    0x1800ABF0
+#define REGSRAM_765                                                                    0x1800ABF4
+#define REGSRAM_766                                                                    0x1800ABF8
+#define REGSRAM_767                                                                    0x1800ABFC
+#define REGSRAM_768                                                                    0x1800AC00
+#define REGSRAM_769                                                                    0x1800AC04
+#define REGSRAM_770                                                                    0x1800AC08
+#define REGSRAM_771                                                                    0x1800AC0C
+#define REGSRAM_772                                                                    0x1800AC10
+#define REGSRAM_773                                                                    0x1800AC14
+#define REGSRAM_774                                                                    0x1800AC18
+#define REGSRAM_775                                                                    0x1800AC1C
+#define REGSRAM_776                                                                    0x1800AC20
+#define REGSRAM_777                                                                    0x1800AC24
+#define REGSRAM_778                                                                    0x1800AC28
+#define REGSRAM_779                                                                    0x1800AC2C
+#define REGSRAM_780                                                                    0x1800AC30
+#define REGSRAM_781                                                                    0x1800AC34
+#define REGSRAM_782                                                                    0x1800AC38
+#define REGSRAM_783                                                                    0x1800AC3C
+#define REGSRAM_784                                                                    0x1800AC40
+#define REGSRAM_785                                                                    0x1800AC44
+#define REGSRAM_786                                                                    0x1800AC48
+#define REGSRAM_787                                                                    0x1800AC4C
+#define REGSRAM_788                                                                    0x1800AC50
+#define REGSRAM_789                                                                    0x1800AC54
+#define REGSRAM_790                                                                    0x1800AC58
+#define REGSRAM_791                                                                    0x1800AC5C
+#define REGSRAM_792                                                                    0x1800AC60
+#define REGSRAM_793                                                                    0x1800AC64
+#define REGSRAM_794                                                                    0x1800AC68
+#define REGSRAM_795                                                                    0x1800AC6C
+#define REGSRAM_796                                                                    0x1800AC70
+#define REGSRAM_797                                                                    0x1800AC74
+#define REGSRAM_798                                                                    0x1800AC78
+#define REGSRAM_799                                                                    0x1800AC7C
+#define REGSRAM_800                                                                    0x1800AC80
+#define REGSRAM_801                                                                    0x1800AC84
+#define REGSRAM_802                                                                    0x1800AC88
+#define REGSRAM_803                                                                    0x1800AC8C
+#define REGSRAM_804                                                                    0x1800AC90
+#define REGSRAM_805                                                                    0x1800AC94
+#define REGSRAM_806                                                                    0x1800AC98
+#define REGSRAM_807                                                                    0x1800AC9C
+#define REGSRAM_808                                                                    0x1800ACA0
+#define REGSRAM_809                                                                    0x1800ACA4
+#define REGSRAM_810                                                                    0x1800ACA8
+#define REGSRAM_811                                                                    0x1800ACAC
+#define REGSRAM_812                                                                    0x1800ACB0
+#define REGSRAM_813                                                                    0x1800ACB4
+#define REGSRAM_814                                                                    0x1800ACB8
+#define REGSRAM_815                                                                    0x1800ACBC
+#define REGSRAM_816                                                                    0x1800ACC0
+#define REGSRAM_817                                                                    0x1800ACC4
+#define REGSRAM_818                                                                    0x1800ACC8
+#define REGSRAM_819                                                                    0x1800ACCC
+#define REGSRAM_820                                                                    0x1800ACD0
+#define REGSRAM_821                                                                    0x1800ACD4
+#define REGSRAM_822                                                                    0x1800ACD8
+#define REGSRAM_823                                                                    0x1800ACDC
+#define REGSRAM_824                                                                    0x1800ACE0
+#define REGSRAM_825                                                                    0x1800ACE4
+#define REGSRAM_826                                                                    0x1800ACE8
+#define REGSRAM_827                                                                    0x1800ACEC
+#define REGSRAM_828                                                                    0x1800ACF0
+#define REGSRAM_829                                                                    0x1800ACF4
+#define REGSRAM_830                                                                    0x1800ACF8
+#define REGSRAM_831                                                                    0x1800ACFC
+#define REGSRAM_832                                                                    0x1800AD00
+#define REGSRAM_833                                                                    0x1800AD04
+#define REGSRAM_834                                                                    0x1800AD08
+#define REGSRAM_835                                                                    0x1800AD0C
+#define REGSRAM_836                                                                    0x1800AD10
+#define REGSRAM_837                                                                    0x1800AD14
+#define REGSRAM_838                                                                    0x1800AD18
+#define REGSRAM_839                                                                    0x1800AD1C
+#define REGSRAM_840                                                                    0x1800AD20
+#define REGSRAM_841                                                                    0x1800AD24
+#define REGSRAM_842                                                                    0x1800AD28
+#define REGSRAM_843                                                                    0x1800AD2C
+#define REGSRAM_844                                                                    0x1800AD30
+#define REGSRAM_845                                                                    0x1800AD34
+#define REGSRAM_846                                                                    0x1800AD38
+#define REGSRAM_847                                                                    0x1800AD3C
+#define REGSRAM_848                                                                    0x1800AD40
+#define REGSRAM_849                                                                    0x1800AD44
+#define REGSRAM_850                                                                    0x1800AD48
+#define REGSRAM_851                                                                    0x1800AD4C
+#define REGSRAM_852                                                                    0x1800AD50
+#define REGSRAM_853                                                                    0x1800AD54
+#define REGSRAM_854                                                                    0x1800AD58
+#define REGSRAM_855                                                                    0x1800AD5C
+#define REGSRAM_856                                                                    0x1800AD60
+#define REGSRAM_857                                                                    0x1800AD64
+#define REGSRAM_858                                                                    0x1800AD68
+#define REGSRAM_859                                                                    0x1800AD6C
+#define REGSRAM_860                                                                    0x1800AD70
+#define REGSRAM_861                                                                    0x1800AD74
+#define REGSRAM_862                                                                    0x1800AD78
+#define REGSRAM_863                                                                    0x1800AD7C
+#define REGSRAM_864                                                                    0x1800AD80
+#define REGSRAM_865                                                                    0x1800AD84
+#define REGSRAM_866                                                                    0x1800AD88
+#define REGSRAM_867                                                                    0x1800AD8C
+#define REGSRAM_868                                                                    0x1800AD90
+#define REGSRAM_869                                                                    0x1800AD94
+#define REGSRAM_870                                                                    0x1800AD98
+#define REGSRAM_871                                                                    0x1800AD9C
+#define REGSRAM_872                                                                    0x1800ADA0
+#define REGSRAM_873                                                                    0x1800ADA4
+#define REGSRAM_874                                                                    0x1800ADA8
+#define REGSRAM_875                                                                    0x1800ADAC
+#define REGSRAM_876                                                                    0x1800ADB0
+#define REGSRAM_877                                                                    0x1800ADB4
+#define REGSRAM_878                                                                    0x1800ADB8
+#define REGSRAM_879                                                                    0x1800ADBC
+#define REGSRAM_880                                                                    0x1800ADC0
+#define REGSRAM_881                                                                    0x1800ADC4
+#define REGSRAM_882                                                                    0x1800ADC8
+#define REGSRAM_883                                                                    0x1800ADCC
+#define REGSRAM_884                                                                    0x1800ADD0
+#define REGSRAM_885                                                                    0x1800ADD4
+#define REGSRAM_886                                                                    0x1800ADD8
+#define REGSRAM_887                                                                    0x1800ADDC
+#define REGSRAM_888                                                                    0x1800ADE0
+#define REGSRAM_889                                                                    0x1800ADE4
+#define REGSRAM_890                                                                    0x1800ADE8
+#define REGSRAM_891                                                                    0x1800ADEC
+#define REGSRAM_892                                                                    0x1800ADF0
+#define REGSRAM_893                                                                    0x1800ADF4
+#define REGSRAM_894                                                                    0x1800ADF8
+#define REGSRAM_895                                                                    0x1800ADFC
+#define REGSRAM_896                                                                    0x1800AE00
+#define REGSRAM_897                                                                    0x1800AE04
+#define REGSRAM_898                                                                    0x1800AE08
+#define REGSRAM_899                                                                    0x1800AE0C
+#define REGSRAM_900                                                                    0x1800AE10
+#define REGSRAM_901                                                                    0x1800AE14
+#define REGSRAM_902                                                                    0x1800AE18
+#define REGSRAM_903                                                                    0x1800AE1C
+#define REGSRAM_904                                                                    0x1800AE20
+#define REGSRAM_905                                                                    0x1800AE24
+#define REGSRAM_906                                                                    0x1800AE28
+#define REGSRAM_907                                                                    0x1800AE2C
+#define REGSRAM_908                                                                    0x1800AE30
+#define REGSRAM_909                                                                    0x1800AE34
+#define REGSRAM_910                                                                    0x1800AE38
+#define REGSRAM_911                                                                    0x1800AE3C
+#define REGSRAM_912                                                                    0x1800AE40
+#define REGSRAM_913                                                                    0x1800AE44
+#define REGSRAM_914                                                                    0x1800AE48
+#define REGSRAM_915                                                                    0x1800AE4C
+#define REGSRAM_916                                                                    0x1800AE50
+#define REGSRAM_917                                                                    0x1800AE54
+#define REGSRAM_918                                                                    0x1800AE58
+#define REGSRAM_919                                                                    0x1800AE5C
+#define REGSRAM_920                                                                    0x1800AE60
+#define REGSRAM_921                                                                    0x1800AE64
+#define REGSRAM_922                                                                    0x1800AE68
+#define REGSRAM_923                                                                    0x1800AE6C
+#define REGSRAM_924                                                                    0x1800AE70
+#define REGSRAM_925                                                                    0x1800AE74
+#define REGSRAM_926                                                                    0x1800AE78
+#define REGSRAM_927                                                                    0x1800AE7C
+#define REGSRAM_928                                                                    0x1800AE80
+#define REGSRAM_929                                                                    0x1800AE84
+#define REGSRAM_930                                                                    0x1800AE88
+#define REGSRAM_931                                                                    0x1800AE8C
+#define REGSRAM_932                                                                    0x1800AE90
+#define REGSRAM_933                                                                    0x1800AE94
+#define REGSRAM_934                                                                    0x1800AE98
+#define REGSRAM_935                                                                    0x1800AE9C
+#define REGSRAM_936                                                                    0x1800AEA0
+#define REGSRAM_937                                                                    0x1800AEA4
+#define REGSRAM_938                                                                    0x1800AEA8
+#define REGSRAM_939                                                                    0x1800AEAC
+#define REGSRAM_940                                                                    0x1800AEB0
+#define REGSRAM_941                                                                    0x1800AEB4
+#define REGSRAM_942                                                                    0x1800AEB8
+#define REGSRAM_943                                                                    0x1800AEBC
+#define REGSRAM_944                                                                    0x1800AEC0
+#define REGSRAM_945                                                                    0x1800AEC4
+#define REGSRAM_946                                                                    0x1800AEC8
+#define REGSRAM_947                                                                    0x1800AECC
+#define REGSRAM_948                                                                    0x1800AED0
+#define REGSRAM_949                                                                    0x1800AED4
+#define REGSRAM_950                                                                    0x1800AED8
+#define REGSRAM_951                                                                    0x1800AEDC
+#define REGSRAM_952                                                                    0x1800AEE0
+#define REGSRAM_953                                                                    0x1800AEE4
+#define REGSRAM_954                                                                    0x1800AEE8
+#define REGSRAM_955                                                                    0x1800AEEC
+#define REGSRAM_956                                                                    0x1800AEF0
+#define REGSRAM_957                                                                    0x1800AEF4
+#define REGSRAM_958                                                                    0x1800AEF8
+#define REGSRAM_959                                                                    0x1800AEFC
+#define REGSRAM_960                                                                    0x1800AF00
+#define REGSRAM_961                                                                    0x1800AF04
+#define REGSRAM_962                                                                    0x1800AF08
+#define REGSRAM_963                                                                    0x1800AF0C
+#define REGSRAM_964                                                                    0x1800AF10
+#define REGSRAM_965                                                                    0x1800AF14
+#define REGSRAM_966                                                                    0x1800AF18
+#define REGSRAM_967                                                                    0x1800AF1C
+#define REGSRAM_968                                                                    0x1800AF20
+#define REGSRAM_969                                                                    0x1800AF24
+#define REGSRAM_970                                                                    0x1800AF28
+#define REGSRAM_971                                                                    0x1800AF2C
+#define REGSRAM_972                                                                    0x1800AF30
+#define REGSRAM_973                                                                    0x1800AF34
+#define REGSRAM_974                                                                    0x1800AF38
+#define REGSRAM_975                                                                    0x1800AF3C
+#define REGSRAM_976                                                                    0x1800AF40
+#define REGSRAM_977                                                                    0x1800AF44
+#define REGSRAM_978                                                                    0x1800AF48
+#define REGSRAM_979                                                                    0x1800AF4C
+#define REGSRAM_980                                                                    0x1800AF50
+#define REGSRAM_981                                                                    0x1800AF54
+#define REGSRAM_982                                                                    0x1800AF58
+#define REGSRAM_983                                                                    0x1800AF5C
+#define REGSRAM_984                                                                    0x1800AF60
+#define REGSRAM_985                                                                    0x1800AF64
+#define REGSRAM_986                                                                    0x1800AF68
+#define REGSRAM_987                                                                    0x1800AF6C
+#define REGSRAM_988                                                                    0x1800AF70
+#define REGSRAM_989                                                                    0x1800AF74
+#define REGSRAM_990                                                                    0x1800AF78
+#define REGSRAM_991                                                                    0x1800AF7C
+#define REGSRAM_992                                                                    0x1800AF80
+#define REGSRAM_993                                                                    0x1800AF84
+#define REGSRAM_994                                                                    0x1800AF88
+#define REGSRAM_995                                                                    0x1800AF8C
+#define REGSRAM_996                                                                    0x1800AF90
+#define REGSRAM_997                                                                    0x1800AF94
+#define REGSRAM_998                                                                    0x1800AF98
+#define REGSRAM_999                                                                    0x1800AF9C
+#define REGSRAM_1000                                                                    0x1800AFA0
+#define REGSRAM_1001                                                                    0x1800AFA4
+#define REGSRAM_1002                                                                    0x1800AFA8
+#define REGSRAM_1003                                                                    0x1800AFAC
+#define REGSRAM_1004                                                                    0x1800AFB0
+#define REGSRAM_1005                                                                    0x1800AFB4
+#define REGSRAM_1006                                                                    0x1800AFB8
+#define REGSRAM_1007                                                                    0x1800AFBC
+#define REGSRAM_1008                                                                    0x1800AFC0
+#define REGSRAM_1009                                                                    0x1800AFC4
+#define REGSRAM_1010                                                                    0x1800AFC8
+#define REGSRAM_1011                                                                    0x1800AFCC
+#define REGSRAM_1012                                                                    0x1800AFD0
+#define REGSRAM_1013                                                                    0x1800AFD4
+#define REGSRAM_1014                                                                    0x1800AFD8
+#define REGSRAM_1015                                                                    0x1800AFDC
+#define REGSRAM_1016                                                                    0x1800AFE0
+#define REGSRAM_1017                                                                    0x1800AFE4
+#define REGSRAM_1018                                                                    0x1800AFE8
+#define REGSRAM_1019                                                                    0x1800AFEC
+#define REGSRAM_1020                                                                    0x1800AFF0
+#define REGSRAM_1021                                                                    0x1800AFF4
+#define REGSRAM_1022                                                                    0x1800AFF8
+#define REGSRAM_1023                                                                    0x1800AFFC
+#define REGSRAM_0_reg_addr                                                           "0xB800A000"
+#define REGSRAM_1_reg_addr                                                           "0xB800A004"
+#define REGSRAM_2_reg_addr                                                           "0xB800A008"
+#define REGSRAM_3_reg_addr                                                           "0xB800A00C"
+#define REGSRAM_4_reg_addr                                                           "0xB800A010"
+#define REGSRAM_5_reg_addr                                                           "0xB800A014"
+#define REGSRAM_6_reg_addr                                                           "0xB800A018"
+#define REGSRAM_7_reg_addr                                                           "0xB800A01C"
+#define REGSRAM_8_reg_addr                                                           "0xB800A020"
+#define REGSRAM_9_reg_addr                                                           "0xB800A024"
+#define REGSRAM_10_reg_addr                                                           "0xB800A028"
+#define REGSRAM_11_reg_addr                                                           "0xB800A02C"
+#define REGSRAM_12_reg_addr                                                           "0xB800A030"
+#define REGSRAM_13_reg_addr                                                           "0xB800A034"
+#define REGSRAM_14_reg_addr                                                           "0xB800A038"
+#define REGSRAM_15_reg_addr                                                           "0xB800A03C"
+#define REGSRAM_16_reg_addr                                                           "0xB800A040"
+#define REGSRAM_17_reg_addr                                                           "0xB800A044"
+#define REGSRAM_18_reg_addr                                                           "0xB800A048"
+#define REGSRAM_19_reg_addr                                                           "0xB800A04C"
+#define REGSRAM_20_reg_addr                                                           "0xB800A050"
+#define REGSRAM_21_reg_addr                                                           "0xB800A054"
+#define REGSRAM_22_reg_addr                                                           "0xB800A058"
+#define REGSRAM_23_reg_addr                                                           "0xB800A05C"
+#define REGSRAM_24_reg_addr                                                           "0xB800A060"
+#define REGSRAM_25_reg_addr                                                           "0xB800A064"
+#define REGSRAM_26_reg_addr                                                           "0xB800A068"
+#define REGSRAM_27_reg_addr                                                           "0xB800A06C"
+#define REGSRAM_28_reg_addr                                                           "0xB800A070"
+#define REGSRAM_29_reg_addr                                                           "0xB800A074"
+#define REGSRAM_30_reg_addr                                                           "0xB800A078"
+#define REGSRAM_31_reg_addr                                                           "0xB800A07C"
+#define REGSRAM_32_reg_addr                                                           "0xB800A080"
+#define REGSRAM_33_reg_addr                                                           "0xB800A084"
+#define REGSRAM_34_reg_addr                                                           "0xB800A088"
+#define REGSRAM_35_reg_addr                                                           "0xB800A08C"
+#define REGSRAM_36_reg_addr                                                           "0xB800A090"
+#define REGSRAM_37_reg_addr                                                           "0xB800A094"
+#define REGSRAM_38_reg_addr                                                           "0xB800A098"
+#define REGSRAM_39_reg_addr                                                           "0xB800A09C"
+#define REGSRAM_40_reg_addr                                                           "0xB800A0A0"
+#define REGSRAM_41_reg_addr                                                           "0xB800A0A4"
+#define REGSRAM_42_reg_addr                                                           "0xB800A0A8"
+#define REGSRAM_43_reg_addr                                                           "0xB800A0AC"
+#define REGSRAM_44_reg_addr                                                           "0xB800A0B0"
+#define REGSRAM_45_reg_addr                                                           "0xB800A0B4"
+#define REGSRAM_46_reg_addr                                                           "0xB800A0B8"
+#define REGSRAM_47_reg_addr                                                           "0xB800A0BC"
+#define REGSRAM_48_reg_addr                                                           "0xB800A0C0"
+#define REGSRAM_49_reg_addr                                                           "0xB800A0C4"
+#define REGSRAM_50_reg_addr                                                           "0xB800A0C8"
+#define REGSRAM_51_reg_addr                                                           "0xB800A0CC"
+#define REGSRAM_52_reg_addr                                                           "0xB800A0D0"
+#define REGSRAM_53_reg_addr                                                           "0xB800A0D4"
+#define REGSRAM_54_reg_addr                                                           "0xB800A0D8"
+#define REGSRAM_55_reg_addr                                                           "0xB800A0DC"
+#define REGSRAM_56_reg_addr                                                           "0xB800A0E0"
+#define REGSRAM_57_reg_addr                                                           "0xB800A0E4"
+#define REGSRAM_58_reg_addr                                                           "0xB800A0E8"
+#define REGSRAM_59_reg_addr                                                           "0xB800A0EC"
+#define REGSRAM_60_reg_addr                                                           "0xB800A0F0"
+#define REGSRAM_61_reg_addr                                                           "0xB800A0F4"
+#define REGSRAM_62_reg_addr                                                           "0xB800A0F8"
+#define REGSRAM_63_reg_addr                                                           "0xB800A0FC"
+#define REGSRAM_64_reg_addr                                                           "0xB800A100"
+#define REGSRAM_65_reg_addr                                                           "0xB800A104"
+#define REGSRAM_66_reg_addr                                                           "0xB800A108"
+#define REGSRAM_67_reg_addr                                                           "0xB800A10C"
+#define REGSRAM_68_reg_addr                                                           "0xB800A110"
+#define REGSRAM_69_reg_addr                                                           "0xB800A114"
+#define REGSRAM_70_reg_addr                                                           "0xB800A118"
+#define REGSRAM_71_reg_addr                                                           "0xB800A11C"
+#define REGSRAM_72_reg_addr                                                           "0xB800A120"
+#define REGSRAM_73_reg_addr                                                           "0xB800A124"
+#define REGSRAM_74_reg_addr                                                           "0xB800A128"
+#define REGSRAM_75_reg_addr                                                           "0xB800A12C"
+#define REGSRAM_76_reg_addr                                                           "0xB800A130"
+#define REGSRAM_77_reg_addr                                                           "0xB800A134"
+#define REGSRAM_78_reg_addr                                                           "0xB800A138"
+#define REGSRAM_79_reg_addr                                                           "0xB800A13C"
+#define REGSRAM_80_reg_addr                                                           "0xB800A140"
+#define REGSRAM_81_reg_addr                                                           "0xB800A144"
+#define REGSRAM_82_reg_addr                                                           "0xB800A148"
+#define REGSRAM_83_reg_addr                                                           "0xB800A14C"
+#define REGSRAM_84_reg_addr                                                           "0xB800A150"
+#define REGSRAM_85_reg_addr                                                           "0xB800A154"
+#define REGSRAM_86_reg_addr                                                           "0xB800A158"
+#define REGSRAM_87_reg_addr                                                           "0xB800A15C"
+#define REGSRAM_88_reg_addr                                                           "0xB800A160"
+#define REGSRAM_89_reg_addr                                                           "0xB800A164"
+#define REGSRAM_90_reg_addr                                                           "0xB800A168"
+#define REGSRAM_91_reg_addr                                                           "0xB800A16C"
+#define REGSRAM_92_reg_addr                                                           "0xB800A170"
+#define REGSRAM_93_reg_addr                                                           "0xB800A174"
+#define REGSRAM_94_reg_addr                                                           "0xB800A178"
+#define REGSRAM_95_reg_addr                                                           "0xB800A17C"
+#define REGSRAM_96_reg_addr                                                           "0xB800A180"
+#define REGSRAM_97_reg_addr                                                           "0xB800A184"
+#define REGSRAM_98_reg_addr                                                           "0xB800A188"
+#define REGSRAM_99_reg_addr                                                           "0xB800A18C"
+#define REGSRAM_100_reg_addr                                                           "0xB800A190"
+#define REGSRAM_101_reg_addr                                                           "0xB800A194"
+#define REGSRAM_102_reg_addr                                                           "0xB800A198"
+#define REGSRAM_103_reg_addr                                                           "0xB800A19C"
+#define REGSRAM_104_reg_addr                                                           "0xB800A1A0"
+#define REGSRAM_105_reg_addr                                                           "0xB800A1A4"
+#define REGSRAM_106_reg_addr                                                           "0xB800A1A8"
+#define REGSRAM_107_reg_addr                                                           "0xB800A1AC"
+#define REGSRAM_108_reg_addr                                                           "0xB800A1B0"
+#define REGSRAM_109_reg_addr                                                           "0xB800A1B4"
+#define REGSRAM_110_reg_addr                                                           "0xB800A1B8"
+#define REGSRAM_111_reg_addr                                                           "0xB800A1BC"
+#define REGSRAM_112_reg_addr                                                           "0xB800A1C0"
+#define REGSRAM_113_reg_addr                                                           "0xB800A1C4"
+#define REGSRAM_114_reg_addr                                                           "0xB800A1C8"
+#define REGSRAM_115_reg_addr                                                           "0xB800A1CC"
+#define REGSRAM_116_reg_addr                                                           "0xB800A1D0"
+#define REGSRAM_117_reg_addr                                                           "0xB800A1D4"
+#define REGSRAM_118_reg_addr                                                           "0xB800A1D8"
+#define REGSRAM_119_reg_addr                                                           "0xB800A1DC"
+#define REGSRAM_120_reg_addr                                                           "0xB800A1E0"
+#define REGSRAM_121_reg_addr                                                           "0xB800A1E4"
+#define REGSRAM_122_reg_addr                                                           "0xB800A1E8"
+#define REGSRAM_123_reg_addr                                                           "0xB800A1EC"
+#define REGSRAM_124_reg_addr                                                           "0xB800A1F0"
+#define REGSRAM_125_reg_addr                                                           "0xB800A1F4"
+#define REGSRAM_126_reg_addr                                                           "0xB800A1F8"
+#define REGSRAM_127_reg_addr                                                           "0xB800A1FC"
+#define REGSRAM_128_reg_addr                                                           "0xB800A200"
+#define REGSRAM_129_reg_addr                                                           "0xB800A204"
+#define REGSRAM_130_reg_addr                                                           "0xB800A208"
+#define REGSRAM_131_reg_addr                                                           "0xB800A20C"
+#define REGSRAM_132_reg_addr                                                           "0xB800A210"
+#define REGSRAM_133_reg_addr                                                           "0xB800A214"
+#define REGSRAM_134_reg_addr                                                           "0xB800A218"
+#define REGSRAM_135_reg_addr                                                           "0xB800A21C"
+#define REGSRAM_136_reg_addr                                                           "0xB800A220"
+#define REGSRAM_137_reg_addr                                                           "0xB800A224"
+#define REGSRAM_138_reg_addr                                                           "0xB800A228"
+#define REGSRAM_139_reg_addr                                                           "0xB800A22C"
+#define REGSRAM_140_reg_addr                                                           "0xB800A230"
+#define REGSRAM_141_reg_addr                                                           "0xB800A234"
+#define REGSRAM_142_reg_addr                                                           "0xB800A238"
+#define REGSRAM_143_reg_addr                                                           "0xB800A23C"
+#define REGSRAM_144_reg_addr                                                           "0xB800A240"
+#define REGSRAM_145_reg_addr                                                           "0xB800A244"
+#define REGSRAM_146_reg_addr                                                           "0xB800A248"
+#define REGSRAM_147_reg_addr                                                           "0xB800A24C"
+#define REGSRAM_148_reg_addr                                                           "0xB800A250"
+#define REGSRAM_149_reg_addr                                                           "0xB800A254"
+#define REGSRAM_150_reg_addr                                                           "0xB800A258"
+#define REGSRAM_151_reg_addr                                                           "0xB800A25C"
+#define REGSRAM_152_reg_addr                                                           "0xB800A260"
+#define REGSRAM_153_reg_addr                                                           "0xB800A264"
+#define REGSRAM_154_reg_addr                                                           "0xB800A268"
+#define REGSRAM_155_reg_addr                                                           "0xB800A26C"
+#define REGSRAM_156_reg_addr                                                           "0xB800A270"
+#define REGSRAM_157_reg_addr                                                           "0xB800A274"
+#define REGSRAM_158_reg_addr                                                           "0xB800A278"
+#define REGSRAM_159_reg_addr                                                           "0xB800A27C"
+#define REGSRAM_160_reg_addr                                                           "0xB800A280"
+#define REGSRAM_161_reg_addr                                                           "0xB800A284"
+#define REGSRAM_162_reg_addr                                                           "0xB800A288"
+#define REGSRAM_163_reg_addr                                                           "0xB800A28C"
+#define REGSRAM_164_reg_addr                                                           "0xB800A290"
+#define REGSRAM_165_reg_addr                                                           "0xB800A294"
+#define REGSRAM_166_reg_addr                                                           "0xB800A298"
+#define REGSRAM_167_reg_addr                                                           "0xB800A29C"
+#define REGSRAM_168_reg_addr                                                           "0xB800A2A0"
+#define REGSRAM_169_reg_addr                                                           "0xB800A2A4"
+#define REGSRAM_170_reg_addr                                                           "0xB800A2A8"
+#define REGSRAM_171_reg_addr                                                           "0xB800A2AC"
+#define REGSRAM_172_reg_addr                                                           "0xB800A2B0"
+#define REGSRAM_173_reg_addr                                                           "0xB800A2B4"
+#define REGSRAM_174_reg_addr                                                           "0xB800A2B8"
+#define REGSRAM_175_reg_addr                                                           "0xB800A2BC"
+#define REGSRAM_176_reg_addr                                                           "0xB800A2C0"
+#define REGSRAM_177_reg_addr                                                           "0xB800A2C4"
+#define REGSRAM_178_reg_addr                                                           "0xB800A2C8"
+#define REGSRAM_179_reg_addr                                                           "0xB800A2CC"
+#define REGSRAM_180_reg_addr                                                           "0xB800A2D0"
+#define REGSRAM_181_reg_addr                                                           "0xB800A2D4"
+#define REGSRAM_182_reg_addr                                                           "0xB800A2D8"
+#define REGSRAM_183_reg_addr                                                           "0xB800A2DC"
+#define REGSRAM_184_reg_addr                                                           "0xB800A2E0"
+#define REGSRAM_185_reg_addr                                                           "0xB800A2E4"
+#define REGSRAM_186_reg_addr                                                           "0xB800A2E8"
+#define REGSRAM_187_reg_addr                                                           "0xB800A2EC"
+#define REGSRAM_188_reg_addr                                                           "0xB800A2F0"
+#define REGSRAM_189_reg_addr                                                           "0xB800A2F4"
+#define REGSRAM_190_reg_addr                                                           "0xB800A2F8"
+#define REGSRAM_191_reg_addr                                                           "0xB800A2FC"
+#define REGSRAM_192_reg_addr                                                           "0xB800A300"
+#define REGSRAM_193_reg_addr                                                           "0xB800A304"
+#define REGSRAM_194_reg_addr                                                           "0xB800A308"
+#define REGSRAM_195_reg_addr                                                           "0xB800A30C"
+#define REGSRAM_196_reg_addr                                                           "0xB800A310"
+#define REGSRAM_197_reg_addr                                                           "0xB800A314"
+#define REGSRAM_198_reg_addr                                                           "0xB800A318"
+#define REGSRAM_199_reg_addr                                                           "0xB800A31C"
+#define REGSRAM_200_reg_addr                                                           "0xB800A320"
+#define REGSRAM_201_reg_addr                                                           "0xB800A324"
+#define REGSRAM_202_reg_addr                                                           "0xB800A328"
+#define REGSRAM_203_reg_addr                                                           "0xB800A32C"
+#define REGSRAM_204_reg_addr                                                           "0xB800A330"
+#define REGSRAM_205_reg_addr                                                           "0xB800A334"
+#define REGSRAM_206_reg_addr                                                           "0xB800A338"
+#define REGSRAM_207_reg_addr                                                           "0xB800A33C"
+#define REGSRAM_208_reg_addr                                                           "0xB800A340"
+#define REGSRAM_209_reg_addr                                                           "0xB800A344"
+#define REGSRAM_210_reg_addr                                                           "0xB800A348"
+#define REGSRAM_211_reg_addr                                                           "0xB800A34C"
+#define REGSRAM_212_reg_addr                                                           "0xB800A350"
+#define REGSRAM_213_reg_addr                                                           "0xB800A354"
+#define REGSRAM_214_reg_addr                                                           "0xB800A358"
+#define REGSRAM_215_reg_addr                                                           "0xB800A35C"
+#define REGSRAM_216_reg_addr                                                           "0xB800A360"
+#define REGSRAM_217_reg_addr                                                           "0xB800A364"
+#define REGSRAM_218_reg_addr                                                           "0xB800A368"
+#define REGSRAM_219_reg_addr                                                           "0xB800A36C"
+#define REGSRAM_220_reg_addr                                                           "0xB800A370"
+#define REGSRAM_221_reg_addr                                                           "0xB800A374"
+#define REGSRAM_222_reg_addr                                                           "0xB800A378"
+#define REGSRAM_223_reg_addr                                                           "0xB800A37C"
+#define REGSRAM_224_reg_addr                                                           "0xB800A380"
+#define REGSRAM_225_reg_addr                                                           "0xB800A384"
+#define REGSRAM_226_reg_addr                                                           "0xB800A388"
+#define REGSRAM_227_reg_addr                                                           "0xB800A38C"
+#define REGSRAM_228_reg_addr                                                           "0xB800A390"
+#define REGSRAM_229_reg_addr                                                           "0xB800A394"
+#define REGSRAM_230_reg_addr                                                           "0xB800A398"
+#define REGSRAM_231_reg_addr                                                           "0xB800A39C"
+#define REGSRAM_232_reg_addr                                                           "0xB800A3A0"
+#define REGSRAM_233_reg_addr                                                           "0xB800A3A4"
+#define REGSRAM_234_reg_addr                                                           "0xB800A3A8"
+#define REGSRAM_235_reg_addr                                                           "0xB800A3AC"
+#define REGSRAM_236_reg_addr                                                           "0xB800A3B0"
+#define REGSRAM_237_reg_addr                                                           "0xB800A3B4"
+#define REGSRAM_238_reg_addr                                                           "0xB800A3B8"
+#define REGSRAM_239_reg_addr                                                           "0xB800A3BC"
+#define REGSRAM_240_reg_addr                                                           "0xB800A3C0"
+#define REGSRAM_241_reg_addr                                                           "0xB800A3C4"
+#define REGSRAM_242_reg_addr                                                           "0xB800A3C8"
+#define REGSRAM_243_reg_addr                                                           "0xB800A3CC"
+#define REGSRAM_244_reg_addr                                                           "0xB800A3D0"
+#define REGSRAM_245_reg_addr                                                           "0xB800A3D4"
+#define REGSRAM_246_reg_addr                                                           "0xB800A3D8"
+#define REGSRAM_247_reg_addr                                                           "0xB800A3DC"
+#define REGSRAM_248_reg_addr                                                           "0xB800A3E0"
+#define REGSRAM_249_reg_addr                                                           "0xB800A3E4"
+#define REGSRAM_250_reg_addr                                                           "0xB800A3E8"
+#define REGSRAM_251_reg_addr                                                           "0xB800A3EC"
+#define REGSRAM_252_reg_addr                                                           "0xB800A3F0"
+#define REGSRAM_253_reg_addr                                                           "0xB800A3F4"
+#define REGSRAM_254_reg_addr                                                           "0xB800A3F8"
+#define REGSRAM_255_reg_addr                                                           "0xB800A3FC"
+#define REGSRAM_256_reg_addr                                                           "0xB800A400"
+#define REGSRAM_257_reg_addr                                                           "0xB800A404"
+#define REGSRAM_258_reg_addr                                                           "0xB800A408"
+#define REGSRAM_259_reg_addr                                                           "0xB800A40C"
+#define REGSRAM_260_reg_addr                                                           "0xB800A410"
+#define REGSRAM_261_reg_addr                                                           "0xB800A414"
+#define REGSRAM_262_reg_addr                                                           "0xB800A418"
+#define REGSRAM_263_reg_addr                                                           "0xB800A41C"
+#define REGSRAM_264_reg_addr                                                           "0xB800A420"
+#define REGSRAM_265_reg_addr                                                           "0xB800A424"
+#define REGSRAM_266_reg_addr                                                           "0xB800A428"
+#define REGSRAM_267_reg_addr                                                           "0xB800A42C"
+#define REGSRAM_268_reg_addr                                                           "0xB800A430"
+#define REGSRAM_269_reg_addr                                                           "0xB800A434"
+#define REGSRAM_270_reg_addr                                                           "0xB800A438"
+#define REGSRAM_271_reg_addr                                                           "0xB800A43C"
+#define REGSRAM_272_reg_addr                                                           "0xB800A440"
+#define REGSRAM_273_reg_addr                                                           "0xB800A444"
+#define REGSRAM_274_reg_addr                                                           "0xB800A448"
+#define REGSRAM_275_reg_addr                                                           "0xB800A44C"
+#define REGSRAM_276_reg_addr                                                           "0xB800A450"
+#define REGSRAM_277_reg_addr                                                           "0xB800A454"
+#define REGSRAM_278_reg_addr                                                           "0xB800A458"
+#define REGSRAM_279_reg_addr                                                           "0xB800A45C"
+#define REGSRAM_280_reg_addr                                                           "0xB800A460"
+#define REGSRAM_281_reg_addr                                                           "0xB800A464"
+#define REGSRAM_282_reg_addr                                                           "0xB800A468"
+#define REGSRAM_283_reg_addr                                                           "0xB800A46C"
+#define REGSRAM_284_reg_addr                                                           "0xB800A470"
+#define REGSRAM_285_reg_addr                                                           "0xB800A474"
+#define REGSRAM_286_reg_addr                                                           "0xB800A478"
+#define REGSRAM_287_reg_addr                                                           "0xB800A47C"
+#define REGSRAM_288_reg_addr                                                           "0xB800A480"
+#define REGSRAM_289_reg_addr                                                           "0xB800A484"
+#define REGSRAM_290_reg_addr                                                           "0xB800A488"
+#define REGSRAM_291_reg_addr                                                           "0xB800A48C"
+#define REGSRAM_292_reg_addr                                                           "0xB800A490"
+#define REGSRAM_293_reg_addr                                                           "0xB800A494"
+#define REGSRAM_294_reg_addr                                                           "0xB800A498"
+#define REGSRAM_295_reg_addr                                                           "0xB800A49C"
+#define REGSRAM_296_reg_addr                                                           "0xB800A4A0"
+#define REGSRAM_297_reg_addr                                                           "0xB800A4A4"
+#define REGSRAM_298_reg_addr                                                           "0xB800A4A8"
+#define REGSRAM_299_reg_addr                                                           "0xB800A4AC"
+#define REGSRAM_300_reg_addr                                                           "0xB800A4B0"
+#define REGSRAM_301_reg_addr                                                           "0xB800A4B4"
+#define REGSRAM_302_reg_addr                                                           "0xB800A4B8"
+#define REGSRAM_303_reg_addr                                                           "0xB800A4BC"
+#define REGSRAM_304_reg_addr                                                           "0xB800A4C0"
+#define REGSRAM_305_reg_addr                                                           "0xB800A4C4"
+#define REGSRAM_306_reg_addr                                                           "0xB800A4C8"
+#define REGSRAM_307_reg_addr                                                           "0xB800A4CC"
+#define REGSRAM_308_reg_addr                                                           "0xB800A4D0"
+#define REGSRAM_309_reg_addr                                                           "0xB800A4D4"
+#define REGSRAM_310_reg_addr                                                           "0xB800A4D8"
+#define REGSRAM_311_reg_addr                                                           "0xB800A4DC"
+#define REGSRAM_312_reg_addr                                                           "0xB800A4E0"
+#define REGSRAM_313_reg_addr                                                           "0xB800A4E4"
+#define REGSRAM_314_reg_addr                                                           "0xB800A4E8"
+#define REGSRAM_315_reg_addr                                                           "0xB800A4EC"
+#define REGSRAM_316_reg_addr                                                           "0xB800A4F0"
+#define REGSRAM_317_reg_addr                                                           "0xB800A4F4"
+#define REGSRAM_318_reg_addr                                                           "0xB800A4F8"
+#define REGSRAM_319_reg_addr                                                           "0xB800A4FC"
+#define REGSRAM_320_reg_addr                                                           "0xB800A500"
+#define REGSRAM_321_reg_addr                                                           "0xB800A504"
+#define REGSRAM_322_reg_addr                                                           "0xB800A508"
+#define REGSRAM_323_reg_addr                                                           "0xB800A50C"
+#define REGSRAM_324_reg_addr                                                           "0xB800A510"
+#define REGSRAM_325_reg_addr                                                           "0xB800A514"
+#define REGSRAM_326_reg_addr                                                           "0xB800A518"
+#define REGSRAM_327_reg_addr                                                           "0xB800A51C"
+#define REGSRAM_328_reg_addr                                                           "0xB800A520"
+#define REGSRAM_329_reg_addr                                                           "0xB800A524"
+#define REGSRAM_330_reg_addr                                                           "0xB800A528"
+#define REGSRAM_331_reg_addr                                                           "0xB800A52C"
+#define REGSRAM_332_reg_addr                                                           "0xB800A530"
+#define REGSRAM_333_reg_addr                                                           "0xB800A534"
+#define REGSRAM_334_reg_addr                                                           "0xB800A538"
+#define REGSRAM_335_reg_addr                                                           "0xB800A53C"
+#define REGSRAM_336_reg_addr                                                           "0xB800A540"
+#define REGSRAM_337_reg_addr                                                           "0xB800A544"
+#define REGSRAM_338_reg_addr                                                           "0xB800A548"
+#define REGSRAM_339_reg_addr                                                           "0xB800A54C"
+#define REGSRAM_340_reg_addr                                                           "0xB800A550"
+#define REGSRAM_341_reg_addr                                                           "0xB800A554"
+#define REGSRAM_342_reg_addr                                                           "0xB800A558"
+#define REGSRAM_343_reg_addr                                                           "0xB800A55C"
+#define REGSRAM_344_reg_addr                                                           "0xB800A560"
+#define REGSRAM_345_reg_addr                                                           "0xB800A564"
+#define REGSRAM_346_reg_addr                                                           "0xB800A568"
+#define REGSRAM_347_reg_addr                                                           "0xB800A56C"
+#define REGSRAM_348_reg_addr                                                           "0xB800A570"
+#define REGSRAM_349_reg_addr                                                           "0xB800A574"
+#define REGSRAM_350_reg_addr                                                           "0xB800A578"
+#define REGSRAM_351_reg_addr                                                           "0xB800A57C"
+#define REGSRAM_352_reg_addr                                                           "0xB800A580"
+#define REGSRAM_353_reg_addr                                                           "0xB800A584"
+#define REGSRAM_354_reg_addr                                                           "0xB800A588"
+#define REGSRAM_355_reg_addr                                                           "0xB800A58C"
+#define REGSRAM_356_reg_addr                                                           "0xB800A590"
+#define REGSRAM_357_reg_addr                                                           "0xB800A594"
+#define REGSRAM_358_reg_addr                                                           "0xB800A598"
+#define REGSRAM_359_reg_addr                                                           "0xB800A59C"
+#define REGSRAM_360_reg_addr                                                           "0xB800A5A0"
+#define REGSRAM_361_reg_addr                                                           "0xB800A5A4"
+#define REGSRAM_362_reg_addr                                                           "0xB800A5A8"
+#define REGSRAM_363_reg_addr                                                           "0xB800A5AC"
+#define REGSRAM_364_reg_addr                                                           "0xB800A5B0"
+#define REGSRAM_365_reg_addr                                                           "0xB800A5B4"
+#define REGSRAM_366_reg_addr                                                           "0xB800A5B8"
+#define REGSRAM_367_reg_addr                                                           "0xB800A5BC"
+#define REGSRAM_368_reg_addr                                                           "0xB800A5C0"
+#define REGSRAM_369_reg_addr                                                           "0xB800A5C4"
+#define REGSRAM_370_reg_addr                                                           "0xB800A5C8"
+#define REGSRAM_371_reg_addr                                                           "0xB800A5CC"
+#define REGSRAM_372_reg_addr                                                           "0xB800A5D0"
+#define REGSRAM_373_reg_addr                                                           "0xB800A5D4"
+#define REGSRAM_374_reg_addr                                                           "0xB800A5D8"
+#define REGSRAM_375_reg_addr                                                           "0xB800A5DC"
+#define REGSRAM_376_reg_addr                                                           "0xB800A5E0"
+#define REGSRAM_377_reg_addr                                                           "0xB800A5E4"
+#define REGSRAM_378_reg_addr                                                           "0xB800A5E8"
+#define REGSRAM_379_reg_addr                                                           "0xB800A5EC"
+#define REGSRAM_380_reg_addr                                                           "0xB800A5F0"
+#define REGSRAM_381_reg_addr                                                           "0xB800A5F4"
+#define REGSRAM_382_reg_addr                                                           "0xB800A5F8"
+#define REGSRAM_383_reg_addr                                                           "0xB800A5FC"
+#define REGSRAM_384_reg_addr                                                           "0xB800A600"
+#define REGSRAM_385_reg_addr                                                           "0xB800A604"
+#define REGSRAM_386_reg_addr                                                           "0xB800A608"
+#define REGSRAM_387_reg_addr                                                           "0xB800A60C"
+#define REGSRAM_388_reg_addr                                                           "0xB800A610"
+#define REGSRAM_389_reg_addr                                                           "0xB800A614"
+#define REGSRAM_390_reg_addr                                                           "0xB800A618"
+#define REGSRAM_391_reg_addr                                                           "0xB800A61C"
+#define REGSRAM_392_reg_addr                                                           "0xB800A620"
+#define REGSRAM_393_reg_addr                                                           "0xB800A624"
+#define REGSRAM_394_reg_addr                                                           "0xB800A628"
+#define REGSRAM_395_reg_addr                                                           "0xB800A62C"
+#define REGSRAM_396_reg_addr                                                           "0xB800A630"
+#define REGSRAM_397_reg_addr                                                           "0xB800A634"
+#define REGSRAM_398_reg_addr                                                           "0xB800A638"
+#define REGSRAM_399_reg_addr                                                           "0xB800A63C"
+#define REGSRAM_400_reg_addr                                                           "0xB800A640"
+#define REGSRAM_401_reg_addr                                                           "0xB800A644"
+#define REGSRAM_402_reg_addr                                                           "0xB800A648"
+#define REGSRAM_403_reg_addr                                                           "0xB800A64C"
+#define REGSRAM_404_reg_addr                                                           "0xB800A650"
+#define REGSRAM_405_reg_addr                                                           "0xB800A654"
+#define REGSRAM_406_reg_addr                                                           "0xB800A658"
+#define REGSRAM_407_reg_addr                                                           "0xB800A65C"
+#define REGSRAM_408_reg_addr                                                           "0xB800A660"
+#define REGSRAM_409_reg_addr                                                           "0xB800A664"
+#define REGSRAM_410_reg_addr                                                           "0xB800A668"
+#define REGSRAM_411_reg_addr                                                           "0xB800A66C"
+#define REGSRAM_412_reg_addr                                                           "0xB800A670"
+#define REGSRAM_413_reg_addr                                                           "0xB800A674"
+#define REGSRAM_414_reg_addr                                                           "0xB800A678"
+#define REGSRAM_415_reg_addr                                                           "0xB800A67C"
+#define REGSRAM_416_reg_addr                                                           "0xB800A680"
+#define REGSRAM_417_reg_addr                                                           "0xB800A684"
+#define REGSRAM_418_reg_addr                                                           "0xB800A688"
+#define REGSRAM_419_reg_addr                                                           "0xB800A68C"
+#define REGSRAM_420_reg_addr                                                           "0xB800A690"
+#define REGSRAM_421_reg_addr                                                           "0xB800A694"
+#define REGSRAM_422_reg_addr                                                           "0xB800A698"
+#define REGSRAM_423_reg_addr                                                           "0xB800A69C"
+#define REGSRAM_424_reg_addr                                                           "0xB800A6A0"
+#define REGSRAM_425_reg_addr                                                           "0xB800A6A4"
+#define REGSRAM_426_reg_addr                                                           "0xB800A6A8"
+#define REGSRAM_427_reg_addr                                                           "0xB800A6AC"
+#define REGSRAM_428_reg_addr                                                           "0xB800A6B0"
+#define REGSRAM_429_reg_addr                                                           "0xB800A6B4"
+#define REGSRAM_430_reg_addr                                                           "0xB800A6B8"
+#define REGSRAM_431_reg_addr                                                           "0xB800A6BC"
+#define REGSRAM_432_reg_addr                                                           "0xB800A6C0"
+#define REGSRAM_433_reg_addr                                                           "0xB800A6C4"
+#define REGSRAM_434_reg_addr                                                           "0xB800A6C8"
+#define REGSRAM_435_reg_addr                                                           "0xB800A6CC"
+#define REGSRAM_436_reg_addr                                                           "0xB800A6D0"
+#define REGSRAM_437_reg_addr                                                           "0xB800A6D4"
+#define REGSRAM_438_reg_addr                                                           "0xB800A6D8"
+#define REGSRAM_439_reg_addr                                                           "0xB800A6DC"
+#define REGSRAM_440_reg_addr                                                           "0xB800A6E0"
+#define REGSRAM_441_reg_addr                                                           "0xB800A6E4"
+#define REGSRAM_442_reg_addr                                                           "0xB800A6E8"
+#define REGSRAM_443_reg_addr                                                           "0xB800A6EC"
+#define REGSRAM_444_reg_addr                                                           "0xB800A6F0"
+#define REGSRAM_445_reg_addr                                                           "0xB800A6F4"
+#define REGSRAM_446_reg_addr                                                           "0xB800A6F8"
+#define REGSRAM_447_reg_addr                                                           "0xB800A6FC"
+#define REGSRAM_448_reg_addr                                                           "0xB800A700"
+#define REGSRAM_449_reg_addr                                                           "0xB800A704"
+#define REGSRAM_450_reg_addr                                                           "0xB800A708"
+#define REGSRAM_451_reg_addr                                                           "0xB800A70C"
+#define REGSRAM_452_reg_addr                                                           "0xB800A710"
+#define REGSRAM_453_reg_addr                                                           "0xB800A714"
+#define REGSRAM_454_reg_addr                                                           "0xB800A718"
+#define REGSRAM_455_reg_addr                                                           "0xB800A71C"
+#define REGSRAM_456_reg_addr                                                           "0xB800A720"
+#define REGSRAM_457_reg_addr                                                           "0xB800A724"
+#define REGSRAM_458_reg_addr                                                           "0xB800A728"
+#define REGSRAM_459_reg_addr                                                           "0xB800A72C"
+#define REGSRAM_460_reg_addr                                                           "0xB800A730"
+#define REGSRAM_461_reg_addr                                                           "0xB800A734"
+#define REGSRAM_462_reg_addr                                                           "0xB800A738"
+#define REGSRAM_463_reg_addr                                                           "0xB800A73C"
+#define REGSRAM_464_reg_addr                                                           "0xB800A740"
+#define REGSRAM_465_reg_addr                                                           "0xB800A744"
+#define REGSRAM_466_reg_addr                                                           "0xB800A748"
+#define REGSRAM_467_reg_addr                                                           "0xB800A74C"
+#define REGSRAM_468_reg_addr                                                           "0xB800A750"
+#define REGSRAM_469_reg_addr                                                           "0xB800A754"
+#define REGSRAM_470_reg_addr                                                           "0xB800A758"
+#define REGSRAM_471_reg_addr                                                           "0xB800A75C"
+#define REGSRAM_472_reg_addr                                                           "0xB800A760"
+#define REGSRAM_473_reg_addr                                                           "0xB800A764"
+#define REGSRAM_474_reg_addr                                                           "0xB800A768"
+#define REGSRAM_475_reg_addr                                                           "0xB800A76C"
+#define REGSRAM_476_reg_addr                                                           "0xB800A770"
+#define REGSRAM_477_reg_addr                                                           "0xB800A774"
+#define REGSRAM_478_reg_addr                                                           "0xB800A778"
+#define REGSRAM_479_reg_addr                                                           "0xB800A77C"
+#define REGSRAM_480_reg_addr                                                           "0xB800A780"
+#define REGSRAM_481_reg_addr                                                           "0xB800A784"
+#define REGSRAM_482_reg_addr                                                           "0xB800A788"
+#define REGSRAM_483_reg_addr                                                           "0xB800A78C"
+#define REGSRAM_484_reg_addr                                                           "0xB800A790"
+#define REGSRAM_485_reg_addr                                                           "0xB800A794"
+#define REGSRAM_486_reg_addr                                                           "0xB800A798"
+#define REGSRAM_487_reg_addr                                                           "0xB800A79C"
+#define REGSRAM_488_reg_addr                                                           "0xB800A7A0"
+#define REGSRAM_489_reg_addr                                                           "0xB800A7A4"
+#define REGSRAM_490_reg_addr                                                           "0xB800A7A8"
+#define REGSRAM_491_reg_addr                                                           "0xB800A7AC"
+#define REGSRAM_492_reg_addr                                                           "0xB800A7B0"
+#define REGSRAM_493_reg_addr                                                           "0xB800A7B4"
+#define REGSRAM_494_reg_addr                                                           "0xB800A7B8"
+#define REGSRAM_495_reg_addr                                                           "0xB800A7BC"
+#define REGSRAM_496_reg_addr                                                           "0xB800A7C0"
+#define REGSRAM_497_reg_addr                                                           "0xB800A7C4"
+#define REGSRAM_498_reg_addr                                                           "0xB800A7C8"
+#define REGSRAM_499_reg_addr                                                           "0xB800A7CC"
+#define REGSRAM_500_reg_addr                                                           "0xB800A7D0"
+#define REGSRAM_501_reg_addr                                                           "0xB800A7D4"
+#define REGSRAM_502_reg_addr                                                           "0xB800A7D8"
+#define REGSRAM_503_reg_addr                                                           "0xB800A7DC"
+#define REGSRAM_504_reg_addr                                                           "0xB800A7E0"
+#define REGSRAM_505_reg_addr                                                           "0xB800A7E4"
+#define REGSRAM_506_reg_addr                                                           "0xB800A7E8"
+#define REGSRAM_507_reg_addr                                                           "0xB800A7EC"
+#define REGSRAM_508_reg_addr                                                           "0xB800A7F0"
+#define REGSRAM_509_reg_addr                                                           "0xB800A7F4"
+#define REGSRAM_510_reg_addr                                                           "0xB800A7F8"
+#define REGSRAM_511_reg_addr                                                           "0xB800A7FC"
+#define REGSRAM_512_reg_addr                                                           "0xB800A800"
+#define REGSRAM_513_reg_addr                                                           "0xB800A804"
+#define REGSRAM_514_reg_addr                                                           "0xB800A808"
+#define REGSRAM_515_reg_addr                                                           "0xB800A80C"
+#define REGSRAM_516_reg_addr                                                           "0xB800A810"
+#define REGSRAM_517_reg_addr                                                           "0xB800A814"
+#define REGSRAM_518_reg_addr                                                           "0xB800A818"
+#define REGSRAM_519_reg_addr                                                           "0xB800A81C"
+#define REGSRAM_520_reg_addr                                                           "0xB800A820"
+#define REGSRAM_521_reg_addr                                                           "0xB800A824"
+#define REGSRAM_522_reg_addr                                                           "0xB800A828"
+#define REGSRAM_523_reg_addr                                                           "0xB800A82C"
+#define REGSRAM_524_reg_addr                                                           "0xB800A830"
+#define REGSRAM_525_reg_addr                                                           "0xB800A834"
+#define REGSRAM_526_reg_addr                                                           "0xB800A838"
+#define REGSRAM_527_reg_addr                                                           "0xB800A83C"
+#define REGSRAM_528_reg_addr                                                           "0xB800A840"
+#define REGSRAM_529_reg_addr                                                           "0xB800A844"
+#define REGSRAM_530_reg_addr                                                           "0xB800A848"
+#define REGSRAM_531_reg_addr                                                           "0xB800A84C"
+#define REGSRAM_532_reg_addr                                                           "0xB800A850"
+#define REGSRAM_533_reg_addr                                                           "0xB800A854"
+#define REGSRAM_534_reg_addr                                                           "0xB800A858"
+#define REGSRAM_535_reg_addr                                                           "0xB800A85C"
+#define REGSRAM_536_reg_addr                                                           "0xB800A860"
+#define REGSRAM_537_reg_addr                                                           "0xB800A864"
+#define REGSRAM_538_reg_addr                                                           "0xB800A868"
+#define REGSRAM_539_reg_addr                                                           "0xB800A86C"
+#define REGSRAM_540_reg_addr                                                           "0xB800A870"
+#define REGSRAM_541_reg_addr                                                           "0xB800A874"
+#define REGSRAM_542_reg_addr                                                           "0xB800A878"
+#define REGSRAM_543_reg_addr                                                           "0xB800A87C"
+#define REGSRAM_544_reg_addr                                                           "0xB800A880"
+#define REGSRAM_545_reg_addr                                                           "0xB800A884"
+#define REGSRAM_546_reg_addr                                                           "0xB800A888"
+#define REGSRAM_547_reg_addr                                                           "0xB800A88C"
+#define REGSRAM_548_reg_addr                                                           "0xB800A890"
+#define REGSRAM_549_reg_addr                                                           "0xB800A894"
+#define REGSRAM_550_reg_addr                                                           "0xB800A898"
+#define REGSRAM_551_reg_addr                                                           "0xB800A89C"
+#define REGSRAM_552_reg_addr                                                           "0xB800A8A0"
+#define REGSRAM_553_reg_addr                                                           "0xB800A8A4"
+#define REGSRAM_554_reg_addr                                                           "0xB800A8A8"
+#define REGSRAM_555_reg_addr                                                           "0xB800A8AC"
+#define REGSRAM_556_reg_addr                                                           "0xB800A8B0"
+#define REGSRAM_557_reg_addr                                                           "0xB800A8B4"
+#define REGSRAM_558_reg_addr                                                           "0xB800A8B8"
+#define REGSRAM_559_reg_addr                                                           "0xB800A8BC"
+#define REGSRAM_560_reg_addr                                                           "0xB800A8C0"
+#define REGSRAM_561_reg_addr                                                           "0xB800A8C4"
+#define REGSRAM_562_reg_addr                                                           "0xB800A8C8"
+#define REGSRAM_563_reg_addr                                                           "0xB800A8CC"
+#define REGSRAM_564_reg_addr                                                           "0xB800A8D0"
+#define REGSRAM_565_reg_addr                                                           "0xB800A8D4"
+#define REGSRAM_566_reg_addr                                                           "0xB800A8D8"
+#define REGSRAM_567_reg_addr                                                           "0xB800A8DC"
+#define REGSRAM_568_reg_addr                                                           "0xB800A8E0"
+#define REGSRAM_569_reg_addr                                                           "0xB800A8E4"
+#define REGSRAM_570_reg_addr                                                           "0xB800A8E8"
+#define REGSRAM_571_reg_addr                                                           "0xB800A8EC"
+#define REGSRAM_572_reg_addr                                                           "0xB800A8F0"
+#define REGSRAM_573_reg_addr                                                           "0xB800A8F4"
+#define REGSRAM_574_reg_addr                                                           "0xB800A8F8"
+#define REGSRAM_575_reg_addr                                                           "0xB800A8FC"
+#define REGSRAM_576_reg_addr                                                           "0xB800A900"
+#define REGSRAM_577_reg_addr                                                           "0xB800A904"
+#define REGSRAM_578_reg_addr                                                           "0xB800A908"
+#define REGSRAM_579_reg_addr                                                           "0xB800A90C"
+#define REGSRAM_580_reg_addr                                                           "0xB800A910"
+#define REGSRAM_581_reg_addr                                                           "0xB800A914"
+#define REGSRAM_582_reg_addr                                                           "0xB800A918"
+#define REGSRAM_583_reg_addr                                                           "0xB800A91C"
+#define REGSRAM_584_reg_addr                                                           "0xB800A920"
+#define REGSRAM_585_reg_addr                                                           "0xB800A924"
+#define REGSRAM_586_reg_addr                                                           "0xB800A928"
+#define REGSRAM_587_reg_addr                                                           "0xB800A92C"
+#define REGSRAM_588_reg_addr                                                           "0xB800A930"
+#define REGSRAM_589_reg_addr                                                           "0xB800A934"
+#define REGSRAM_590_reg_addr                                                           "0xB800A938"
+#define REGSRAM_591_reg_addr                                                           "0xB800A93C"
+#define REGSRAM_592_reg_addr                                                           "0xB800A940"
+#define REGSRAM_593_reg_addr                                                           "0xB800A944"
+#define REGSRAM_594_reg_addr                                                           "0xB800A948"
+#define REGSRAM_595_reg_addr                                                           "0xB800A94C"
+#define REGSRAM_596_reg_addr                                                           "0xB800A950"
+#define REGSRAM_597_reg_addr                                                           "0xB800A954"
+#define REGSRAM_598_reg_addr                                                           "0xB800A958"
+#define REGSRAM_599_reg_addr                                                           "0xB800A95C"
+#define REGSRAM_600_reg_addr                                                           "0xB800A960"
+#define REGSRAM_601_reg_addr                                                           "0xB800A964"
+#define REGSRAM_602_reg_addr                                                           "0xB800A968"
+#define REGSRAM_603_reg_addr                                                           "0xB800A96C"
+#define REGSRAM_604_reg_addr                                                           "0xB800A970"
+#define REGSRAM_605_reg_addr                                                           "0xB800A974"
+#define REGSRAM_606_reg_addr                                                           "0xB800A978"
+#define REGSRAM_607_reg_addr                                                           "0xB800A97C"
+#define REGSRAM_608_reg_addr                                                           "0xB800A980"
+#define REGSRAM_609_reg_addr                                                           "0xB800A984"
+#define REGSRAM_610_reg_addr                                                           "0xB800A988"
+#define REGSRAM_611_reg_addr                                                           "0xB800A98C"
+#define REGSRAM_612_reg_addr                                                           "0xB800A990"
+#define REGSRAM_613_reg_addr                                                           "0xB800A994"
+#define REGSRAM_614_reg_addr                                                           "0xB800A998"
+#define REGSRAM_615_reg_addr                                                           "0xB800A99C"
+#define REGSRAM_616_reg_addr                                                           "0xB800A9A0"
+#define REGSRAM_617_reg_addr                                                           "0xB800A9A4"
+#define REGSRAM_618_reg_addr                                                           "0xB800A9A8"
+#define REGSRAM_619_reg_addr                                                           "0xB800A9AC"
+#define REGSRAM_620_reg_addr                                                           "0xB800A9B0"
+#define REGSRAM_621_reg_addr                                                           "0xB800A9B4"
+#define REGSRAM_622_reg_addr                                                           "0xB800A9B8"
+#define REGSRAM_623_reg_addr                                                           "0xB800A9BC"
+#define REGSRAM_624_reg_addr                                                           "0xB800A9C0"
+#define REGSRAM_625_reg_addr                                                           "0xB800A9C4"
+#define REGSRAM_626_reg_addr                                                           "0xB800A9C8"
+#define REGSRAM_627_reg_addr                                                           "0xB800A9CC"
+#define REGSRAM_628_reg_addr                                                           "0xB800A9D0"
+#define REGSRAM_629_reg_addr                                                           "0xB800A9D4"
+#define REGSRAM_630_reg_addr                                                           "0xB800A9D8"
+#define REGSRAM_631_reg_addr                                                           "0xB800A9DC"
+#define REGSRAM_632_reg_addr                                                           "0xB800A9E0"
+#define REGSRAM_633_reg_addr                                                           "0xB800A9E4"
+#define REGSRAM_634_reg_addr                                                           "0xB800A9E8"
+#define REGSRAM_635_reg_addr                                                           "0xB800A9EC"
+#define REGSRAM_636_reg_addr                                                           "0xB800A9F0"
+#define REGSRAM_637_reg_addr                                                           "0xB800A9F4"
+#define REGSRAM_638_reg_addr                                                           "0xB800A9F8"
+#define REGSRAM_639_reg_addr                                                           "0xB800A9FC"
+#define REGSRAM_640_reg_addr                                                           "0xB800AA00"
+#define REGSRAM_641_reg_addr                                                           "0xB800AA04"
+#define REGSRAM_642_reg_addr                                                           "0xB800AA08"
+#define REGSRAM_643_reg_addr                                                           "0xB800AA0C"
+#define REGSRAM_644_reg_addr                                                           "0xB800AA10"
+#define REGSRAM_645_reg_addr                                                           "0xB800AA14"
+#define REGSRAM_646_reg_addr                                                           "0xB800AA18"
+#define REGSRAM_647_reg_addr                                                           "0xB800AA1C"
+#define REGSRAM_648_reg_addr                                                           "0xB800AA20"
+#define REGSRAM_649_reg_addr                                                           "0xB800AA24"
+#define REGSRAM_650_reg_addr                                                           "0xB800AA28"
+#define REGSRAM_651_reg_addr                                                           "0xB800AA2C"
+#define REGSRAM_652_reg_addr                                                           "0xB800AA30"
+#define REGSRAM_653_reg_addr                                                           "0xB800AA34"
+#define REGSRAM_654_reg_addr                                                           "0xB800AA38"
+#define REGSRAM_655_reg_addr                                                           "0xB800AA3C"
+#define REGSRAM_656_reg_addr                                                           "0xB800AA40"
+#define REGSRAM_657_reg_addr                                                           "0xB800AA44"
+#define REGSRAM_658_reg_addr                                                           "0xB800AA48"
+#define REGSRAM_659_reg_addr                                                           "0xB800AA4C"
+#define REGSRAM_660_reg_addr                                                           "0xB800AA50"
+#define REGSRAM_661_reg_addr                                                           "0xB800AA54"
+#define REGSRAM_662_reg_addr                                                           "0xB800AA58"
+#define REGSRAM_663_reg_addr                                                           "0xB800AA5C"
+#define REGSRAM_664_reg_addr                                                           "0xB800AA60"
+#define REGSRAM_665_reg_addr                                                           "0xB800AA64"
+#define REGSRAM_666_reg_addr                                                           "0xB800AA68"
+#define REGSRAM_667_reg_addr                                                           "0xB800AA6C"
+#define REGSRAM_668_reg_addr                                                           "0xB800AA70"
+#define REGSRAM_669_reg_addr                                                           "0xB800AA74"
+#define REGSRAM_670_reg_addr                                                           "0xB800AA78"
+#define REGSRAM_671_reg_addr                                                           "0xB800AA7C"
+#define REGSRAM_672_reg_addr                                                           "0xB800AA80"
+#define REGSRAM_673_reg_addr                                                           "0xB800AA84"
+#define REGSRAM_674_reg_addr                                                           "0xB800AA88"
+#define REGSRAM_675_reg_addr                                                           "0xB800AA8C"
+#define REGSRAM_676_reg_addr                                                           "0xB800AA90"
+#define REGSRAM_677_reg_addr                                                           "0xB800AA94"
+#define REGSRAM_678_reg_addr                                                           "0xB800AA98"
+#define REGSRAM_679_reg_addr                                                           "0xB800AA9C"
+#define REGSRAM_680_reg_addr                                                           "0xB800AAA0"
+#define REGSRAM_681_reg_addr                                                           "0xB800AAA4"
+#define REGSRAM_682_reg_addr                                                           "0xB800AAA8"
+#define REGSRAM_683_reg_addr                                                           "0xB800AAAC"
+#define REGSRAM_684_reg_addr                                                           "0xB800AAB0"
+#define REGSRAM_685_reg_addr                                                           "0xB800AAB4"
+#define REGSRAM_686_reg_addr                                                           "0xB800AAB8"
+#define REGSRAM_687_reg_addr                                                           "0xB800AABC"
+#define REGSRAM_688_reg_addr                                                           "0xB800AAC0"
+#define REGSRAM_689_reg_addr                                                           "0xB800AAC4"
+#define REGSRAM_690_reg_addr                                                           "0xB800AAC8"
+#define REGSRAM_691_reg_addr                                                           "0xB800AACC"
+#define REGSRAM_692_reg_addr                                                           "0xB800AAD0"
+#define REGSRAM_693_reg_addr                                                           "0xB800AAD4"
+#define REGSRAM_694_reg_addr                                                           "0xB800AAD8"
+#define REGSRAM_695_reg_addr                                                           "0xB800AADC"
+#define REGSRAM_696_reg_addr                                                           "0xB800AAE0"
+#define REGSRAM_697_reg_addr                                                           "0xB800AAE4"
+#define REGSRAM_698_reg_addr                                                           "0xB800AAE8"
+#define REGSRAM_699_reg_addr                                                           "0xB800AAEC"
+#define REGSRAM_700_reg_addr                                                           "0xB800AAF0"
+#define REGSRAM_701_reg_addr                                                           "0xB800AAF4"
+#define REGSRAM_702_reg_addr                                                           "0xB800AAF8"
+#define REGSRAM_703_reg_addr                                                           "0xB800AAFC"
+#define REGSRAM_704_reg_addr                                                           "0xB800AB00"
+#define REGSRAM_705_reg_addr                                                           "0xB800AB04"
+#define REGSRAM_706_reg_addr                                                           "0xB800AB08"
+#define REGSRAM_707_reg_addr                                                           "0xB800AB0C"
+#define REGSRAM_708_reg_addr                                                           "0xB800AB10"
+#define REGSRAM_709_reg_addr                                                           "0xB800AB14"
+#define REGSRAM_710_reg_addr                                                           "0xB800AB18"
+#define REGSRAM_711_reg_addr                                                           "0xB800AB1C"
+#define REGSRAM_712_reg_addr                                                           "0xB800AB20"
+#define REGSRAM_713_reg_addr                                                           "0xB800AB24"
+#define REGSRAM_714_reg_addr                                                           "0xB800AB28"
+#define REGSRAM_715_reg_addr                                                           "0xB800AB2C"
+#define REGSRAM_716_reg_addr                                                           "0xB800AB30"
+#define REGSRAM_717_reg_addr                                                           "0xB800AB34"
+#define REGSRAM_718_reg_addr                                                           "0xB800AB38"
+#define REGSRAM_719_reg_addr                                                           "0xB800AB3C"
+#define REGSRAM_720_reg_addr                                                           "0xB800AB40"
+#define REGSRAM_721_reg_addr                                                           "0xB800AB44"
+#define REGSRAM_722_reg_addr                                                           "0xB800AB48"
+#define REGSRAM_723_reg_addr                                                           "0xB800AB4C"
+#define REGSRAM_724_reg_addr                                                           "0xB800AB50"
+#define REGSRAM_725_reg_addr                                                           "0xB800AB54"
+#define REGSRAM_726_reg_addr                                                           "0xB800AB58"
+#define REGSRAM_727_reg_addr                                                           "0xB800AB5C"
+#define REGSRAM_728_reg_addr                                                           "0xB800AB60"
+#define REGSRAM_729_reg_addr                                                           "0xB800AB64"
+#define REGSRAM_730_reg_addr                                                           "0xB800AB68"
+#define REGSRAM_731_reg_addr                                                           "0xB800AB6C"
+#define REGSRAM_732_reg_addr                                                           "0xB800AB70"
+#define REGSRAM_733_reg_addr                                                           "0xB800AB74"
+#define REGSRAM_734_reg_addr                                                           "0xB800AB78"
+#define REGSRAM_735_reg_addr                                                           "0xB800AB7C"
+#define REGSRAM_736_reg_addr                                                           "0xB800AB80"
+#define REGSRAM_737_reg_addr                                                           "0xB800AB84"
+#define REGSRAM_738_reg_addr                                                           "0xB800AB88"
+#define REGSRAM_739_reg_addr                                                           "0xB800AB8C"
+#define REGSRAM_740_reg_addr                                                           "0xB800AB90"
+#define REGSRAM_741_reg_addr                                                           "0xB800AB94"
+#define REGSRAM_742_reg_addr                                                           "0xB800AB98"
+#define REGSRAM_743_reg_addr                                                           "0xB800AB9C"
+#define REGSRAM_744_reg_addr                                                           "0xB800ABA0"
+#define REGSRAM_745_reg_addr                                                           "0xB800ABA4"
+#define REGSRAM_746_reg_addr                                                           "0xB800ABA8"
+#define REGSRAM_747_reg_addr                                                           "0xB800ABAC"
+#define REGSRAM_748_reg_addr                                                           "0xB800ABB0"
+#define REGSRAM_749_reg_addr                                                           "0xB800ABB4"
+#define REGSRAM_750_reg_addr                                                           "0xB800ABB8"
+#define REGSRAM_751_reg_addr                                                           "0xB800ABBC"
+#define REGSRAM_752_reg_addr                                                           "0xB800ABC0"
+#define REGSRAM_753_reg_addr                                                           "0xB800ABC4"
+#define REGSRAM_754_reg_addr                                                           "0xB800ABC8"
+#define REGSRAM_755_reg_addr                                                           "0xB800ABCC"
+#define REGSRAM_756_reg_addr                                                           "0xB800ABD0"
+#define REGSRAM_757_reg_addr                                                           "0xB800ABD4"
+#define REGSRAM_758_reg_addr                                                           "0xB800ABD8"
+#define REGSRAM_759_reg_addr                                                           "0xB800ABDC"
+#define REGSRAM_760_reg_addr                                                           "0xB800ABE0"
+#define REGSRAM_761_reg_addr                                                           "0xB800ABE4"
+#define REGSRAM_762_reg_addr                                                           "0xB800ABE8"
+#define REGSRAM_763_reg_addr                                                           "0xB800ABEC"
+#define REGSRAM_764_reg_addr                                                           "0xB800ABF0"
+#define REGSRAM_765_reg_addr                                                           "0xB800ABF4"
+#define REGSRAM_766_reg_addr                                                           "0xB800ABF8"
+#define REGSRAM_767_reg_addr                                                           "0xB800ABFC"
+#define REGSRAM_768_reg_addr                                                           "0xB800AC00"
+#define REGSRAM_769_reg_addr                                                           "0xB800AC04"
+#define REGSRAM_770_reg_addr                                                           "0xB800AC08"
+#define REGSRAM_771_reg_addr                                                           "0xB800AC0C"
+#define REGSRAM_772_reg_addr                                                           "0xB800AC10"
+#define REGSRAM_773_reg_addr                                                           "0xB800AC14"
+#define REGSRAM_774_reg_addr                                                           "0xB800AC18"
+#define REGSRAM_775_reg_addr                                                           "0xB800AC1C"
+#define REGSRAM_776_reg_addr                                                           "0xB800AC20"
+#define REGSRAM_777_reg_addr                                                           "0xB800AC24"
+#define REGSRAM_778_reg_addr                                                           "0xB800AC28"
+#define REGSRAM_779_reg_addr                                                           "0xB800AC2C"
+#define REGSRAM_780_reg_addr                                                           "0xB800AC30"
+#define REGSRAM_781_reg_addr                                                           "0xB800AC34"
+#define REGSRAM_782_reg_addr                                                           "0xB800AC38"
+#define REGSRAM_783_reg_addr                                                           "0xB800AC3C"
+#define REGSRAM_784_reg_addr                                                           "0xB800AC40"
+#define REGSRAM_785_reg_addr                                                           "0xB800AC44"
+#define REGSRAM_786_reg_addr                                                           "0xB800AC48"
+#define REGSRAM_787_reg_addr                                                           "0xB800AC4C"
+#define REGSRAM_788_reg_addr                                                           "0xB800AC50"
+#define REGSRAM_789_reg_addr                                                           "0xB800AC54"
+#define REGSRAM_790_reg_addr                                                           "0xB800AC58"
+#define REGSRAM_791_reg_addr                                                           "0xB800AC5C"
+#define REGSRAM_792_reg_addr                                                           "0xB800AC60"
+#define REGSRAM_793_reg_addr                                                           "0xB800AC64"
+#define REGSRAM_794_reg_addr                                                           "0xB800AC68"
+#define REGSRAM_795_reg_addr                                                           "0xB800AC6C"
+#define REGSRAM_796_reg_addr                                                           "0xB800AC70"
+#define REGSRAM_797_reg_addr                                                           "0xB800AC74"
+#define REGSRAM_798_reg_addr                                                           "0xB800AC78"
+#define REGSRAM_799_reg_addr                                                           "0xB800AC7C"
+#define REGSRAM_800_reg_addr                                                           "0xB800AC80"
+#define REGSRAM_801_reg_addr                                                           "0xB800AC84"
+#define REGSRAM_802_reg_addr                                                           "0xB800AC88"
+#define REGSRAM_803_reg_addr                                                           "0xB800AC8C"
+#define REGSRAM_804_reg_addr                                                           "0xB800AC90"
+#define REGSRAM_805_reg_addr                                                           "0xB800AC94"
+#define REGSRAM_806_reg_addr                                                           "0xB800AC98"
+#define REGSRAM_807_reg_addr                                                           "0xB800AC9C"
+#define REGSRAM_808_reg_addr                                                           "0xB800ACA0"
+#define REGSRAM_809_reg_addr                                                           "0xB800ACA4"
+#define REGSRAM_810_reg_addr                                                           "0xB800ACA8"
+#define REGSRAM_811_reg_addr                                                           "0xB800ACAC"
+#define REGSRAM_812_reg_addr                                                           "0xB800ACB0"
+#define REGSRAM_813_reg_addr                                                           "0xB800ACB4"
+#define REGSRAM_814_reg_addr                                                           "0xB800ACB8"
+#define REGSRAM_815_reg_addr                                                           "0xB800ACBC"
+#define REGSRAM_816_reg_addr                                                           "0xB800ACC0"
+#define REGSRAM_817_reg_addr                                                           "0xB800ACC4"
+#define REGSRAM_818_reg_addr                                                           "0xB800ACC8"
+#define REGSRAM_819_reg_addr                                                           "0xB800ACCC"
+#define REGSRAM_820_reg_addr                                                           "0xB800ACD0"
+#define REGSRAM_821_reg_addr                                                           "0xB800ACD4"
+#define REGSRAM_822_reg_addr                                                           "0xB800ACD8"
+#define REGSRAM_823_reg_addr                                                           "0xB800ACDC"
+#define REGSRAM_824_reg_addr                                                           "0xB800ACE0"
+#define REGSRAM_825_reg_addr                                                           "0xB800ACE4"
+#define REGSRAM_826_reg_addr                                                           "0xB800ACE8"
+#define REGSRAM_827_reg_addr                                                           "0xB800ACEC"
+#define REGSRAM_828_reg_addr                                                           "0xB800ACF0"
+#define REGSRAM_829_reg_addr                                                           "0xB800ACF4"
+#define REGSRAM_830_reg_addr                                                           "0xB800ACF8"
+#define REGSRAM_831_reg_addr                                                           "0xB800ACFC"
+#define REGSRAM_832_reg_addr                                                           "0xB800AD00"
+#define REGSRAM_833_reg_addr                                                           "0xB800AD04"
+#define REGSRAM_834_reg_addr                                                           "0xB800AD08"
+#define REGSRAM_835_reg_addr                                                           "0xB800AD0C"
+#define REGSRAM_836_reg_addr                                                           "0xB800AD10"
+#define REGSRAM_837_reg_addr                                                           "0xB800AD14"
+#define REGSRAM_838_reg_addr                                                           "0xB800AD18"
+#define REGSRAM_839_reg_addr                                                           "0xB800AD1C"
+#define REGSRAM_840_reg_addr                                                           "0xB800AD20"
+#define REGSRAM_841_reg_addr                                                           "0xB800AD24"
+#define REGSRAM_842_reg_addr                                                           "0xB800AD28"
+#define REGSRAM_843_reg_addr                                                           "0xB800AD2C"
+#define REGSRAM_844_reg_addr                                                           "0xB800AD30"
+#define REGSRAM_845_reg_addr                                                           "0xB800AD34"
+#define REGSRAM_846_reg_addr                                                           "0xB800AD38"
+#define REGSRAM_847_reg_addr                                                           "0xB800AD3C"
+#define REGSRAM_848_reg_addr                                                           "0xB800AD40"
+#define REGSRAM_849_reg_addr                                                           "0xB800AD44"
+#define REGSRAM_850_reg_addr                                                           "0xB800AD48"
+#define REGSRAM_851_reg_addr                                                           "0xB800AD4C"
+#define REGSRAM_852_reg_addr                                                           "0xB800AD50"
+#define REGSRAM_853_reg_addr                                                           "0xB800AD54"
+#define REGSRAM_854_reg_addr                                                           "0xB800AD58"
+#define REGSRAM_855_reg_addr                                                           "0xB800AD5C"
+#define REGSRAM_856_reg_addr                                                           "0xB800AD60"
+#define REGSRAM_857_reg_addr                                                           "0xB800AD64"
+#define REGSRAM_858_reg_addr                                                           "0xB800AD68"
+#define REGSRAM_859_reg_addr                                                           "0xB800AD6C"
+#define REGSRAM_860_reg_addr                                                           "0xB800AD70"
+#define REGSRAM_861_reg_addr                                                           "0xB800AD74"
+#define REGSRAM_862_reg_addr                                                           "0xB800AD78"
+#define REGSRAM_863_reg_addr                                                           "0xB800AD7C"
+#define REGSRAM_864_reg_addr                                                           "0xB800AD80"
+#define REGSRAM_865_reg_addr                                                           "0xB800AD84"
+#define REGSRAM_866_reg_addr                                                           "0xB800AD88"
+#define REGSRAM_867_reg_addr                                                           "0xB800AD8C"
+#define REGSRAM_868_reg_addr                                                           "0xB800AD90"
+#define REGSRAM_869_reg_addr                                                           "0xB800AD94"
+#define REGSRAM_870_reg_addr                                                           "0xB800AD98"
+#define REGSRAM_871_reg_addr                                                           "0xB800AD9C"
+#define REGSRAM_872_reg_addr                                                           "0xB800ADA0"
+#define REGSRAM_873_reg_addr                                                           "0xB800ADA4"
+#define REGSRAM_874_reg_addr                                                           "0xB800ADA8"
+#define REGSRAM_875_reg_addr                                                           "0xB800ADAC"
+#define REGSRAM_876_reg_addr                                                           "0xB800ADB0"
+#define REGSRAM_877_reg_addr                                                           "0xB800ADB4"
+#define REGSRAM_878_reg_addr                                                           "0xB800ADB8"
+#define REGSRAM_879_reg_addr                                                           "0xB800ADBC"
+#define REGSRAM_880_reg_addr                                                           "0xB800ADC0"
+#define REGSRAM_881_reg_addr                                                           "0xB800ADC4"
+#define REGSRAM_882_reg_addr                                                           "0xB800ADC8"
+#define REGSRAM_883_reg_addr                                                           "0xB800ADCC"
+#define REGSRAM_884_reg_addr                                                           "0xB800ADD0"
+#define REGSRAM_885_reg_addr                                                           "0xB800ADD4"
+#define REGSRAM_886_reg_addr                                                           "0xB800ADD8"
+#define REGSRAM_887_reg_addr                                                           "0xB800ADDC"
+#define REGSRAM_888_reg_addr                                                           "0xB800ADE0"
+#define REGSRAM_889_reg_addr                                                           "0xB800ADE4"
+#define REGSRAM_890_reg_addr                                                           "0xB800ADE8"
+#define REGSRAM_891_reg_addr                                                           "0xB800ADEC"
+#define REGSRAM_892_reg_addr                                                           "0xB800ADF0"
+#define REGSRAM_893_reg_addr                                                           "0xB800ADF4"
+#define REGSRAM_894_reg_addr                                                           "0xB800ADF8"
+#define REGSRAM_895_reg_addr                                                           "0xB800ADFC"
+#define REGSRAM_896_reg_addr                                                           "0xB800AE00"
+#define REGSRAM_897_reg_addr                                                           "0xB800AE04"
+#define REGSRAM_898_reg_addr                                                           "0xB800AE08"
+#define REGSRAM_899_reg_addr                                                           "0xB800AE0C"
+#define REGSRAM_900_reg_addr                                                           "0xB800AE10"
+#define REGSRAM_901_reg_addr                                                           "0xB800AE14"
+#define REGSRAM_902_reg_addr                                                           "0xB800AE18"
+#define REGSRAM_903_reg_addr                                                           "0xB800AE1C"
+#define REGSRAM_904_reg_addr                                                           "0xB800AE20"
+#define REGSRAM_905_reg_addr                                                           "0xB800AE24"
+#define REGSRAM_906_reg_addr                                                           "0xB800AE28"
+#define REGSRAM_907_reg_addr                                                           "0xB800AE2C"
+#define REGSRAM_908_reg_addr                                                           "0xB800AE30"
+#define REGSRAM_909_reg_addr                                                           "0xB800AE34"
+#define REGSRAM_910_reg_addr                                                           "0xB800AE38"
+#define REGSRAM_911_reg_addr                                                           "0xB800AE3C"
+#define REGSRAM_912_reg_addr                                                           "0xB800AE40"
+#define REGSRAM_913_reg_addr                                                           "0xB800AE44"
+#define REGSRAM_914_reg_addr                                                           "0xB800AE48"
+#define REGSRAM_915_reg_addr                                                           "0xB800AE4C"
+#define REGSRAM_916_reg_addr                                                           "0xB800AE50"
+#define REGSRAM_917_reg_addr                                                           "0xB800AE54"
+#define REGSRAM_918_reg_addr                                                           "0xB800AE58"
+#define REGSRAM_919_reg_addr                                                           "0xB800AE5C"
+#define REGSRAM_920_reg_addr                                                           "0xB800AE60"
+#define REGSRAM_921_reg_addr                                                           "0xB800AE64"
+#define REGSRAM_922_reg_addr                                                           "0xB800AE68"
+#define REGSRAM_923_reg_addr                                                           "0xB800AE6C"
+#define REGSRAM_924_reg_addr                                                           "0xB800AE70"
+#define REGSRAM_925_reg_addr                                                           "0xB800AE74"
+#define REGSRAM_926_reg_addr                                                           "0xB800AE78"
+#define REGSRAM_927_reg_addr                                                           "0xB800AE7C"
+#define REGSRAM_928_reg_addr                                                           "0xB800AE80"
+#define REGSRAM_929_reg_addr                                                           "0xB800AE84"
+#define REGSRAM_930_reg_addr                                                           "0xB800AE88"
+#define REGSRAM_931_reg_addr                                                           "0xB800AE8C"
+#define REGSRAM_932_reg_addr                                                           "0xB800AE90"
+#define REGSRAM_933_reg_addr                                                           "0xB800AE94"
+#define REGSRAM_934_reg_addr                                                           "0xB800AE98"
+#define REGSRAM_935_reg_addr                                                           "0xB800AE9C"
+#define REGSRAM_936_reg_addr                                                           "0xB800AEA0"
+#define REGSRAM_937_reg_addr                                                           "0xB800AEA4"
+#define REGSRAM_938_reg_addr                                                           "0xB800AEA8"
+#define REGSRAM_939_reg_addr                                                           "0xB800AEAC"
+#define REGSRAM_940_reg_addr                                                           "0xB800AEB0"
+#define REGSRAM_941_reg_addr                                                           "0xB800AEB4"
+#define REGSRAM_942_reg_addr                                                           "0xB800AEB8"
+#define REGSRAM_943_reg_addr                                                           "0xB800AEBC"
+#define REGSRAM_944_reg_addr                                                           "0xB800AEC0"
+#define REGSRAM_945_reg_addr                                                           "0xB800AEC4"
+#define REGSRAM_946_reg_addr                                                           "0xB800AEC8"
+#define REGSRAM_947_reg_addr                                                           "0xB800AECC"
+#define REGSRAM_948_reg_addr                                                           "0xB800AED0"
+#define REGSRAM_949_reg_addr                                                           "0xB800AED4"
+#define REGSRAM_950_reg_addr                                                           "0xB800AED8"
+#define REGSRAM_951_reg_addr                                                           "0xB800AEDC"
+#define REGSRAM_952_reg_addr                                                           "0xB800AEE0"
+#define REGSRAM_953_reg_addr                                                           "0xB800AEE4"
+#define REGSRAM_954_reg_addr                                                           "0xB800AEE8"
+#define REGSRAM_955_reg_addr                                                           "0xB800AEEC"
+#define REGSRAM_956_reg_addr                                                           "0xB800AEF0"
+#define REGSRAM_957_reg_addr                                                           "0xB800AEF4"
+#define REGSRAM_958_reg_addr                                                           "0xB800AEF8"
+#define REGSRAM_959_reg_addr                                                           "0xB800AEFC"
+#define REGSRAM_960_reg_addr                                                           "0xB800AF00"
+#define REGSRAM_961_reg_addr                                                           "0xB800AF04"
+#define REGSRAM_962_reg_addr                                                           "0xB800AF08"
+#define REGSRAM_963_reg_addr                                                           "0xB800AF0C"
+#define REGSRAM_964_reg_addr                                                           "0xB800AF10"
+#define REGSRAM_965_reg_addr                                                           "0xB800AF14"
+#define REGSRAM_966_reg_addr                                                           "0xB800AF18"
+#define REGSRAM_967_reg_addr                                                           "0xB800AF1C"
+#define REGSRAM_968_reg_addr                                                           "0xB800AF20"
+#define REGSRAM_969_reg_addr                                                           "0xB800AF24"
+#define REGSRAM_970_reg_addr                                                           "0xB800AF28"
+#define REGSRAM_971_reg_addr                                                           "0xB800AF2C"
+#define REGSRAM_972_reg_addr                                                           "0xB800AF30"
+#define REGSRAM_973_reg_addr                                                           "0xB800AF34"
+#define REGSRAM_974_reg_addr                                                           "0xB800AF38"
+#define REGSRAM_975_reg_addr                                                           "0xB800AF3C"
+#define REGSRAM_976_reg_addr                                                           "0xB800AF40"
+#define REGSRAM_977_reg_addr                                                           "0xB800AF44"
+#define REGSRAM_978_reg_addr                                                           "0xB800AF48"
+#define REGSRAM_979_reg_addr                                                           "0xB800AF4C"
+#define REGSRAM_980_reg_addr                                                           "0xB800AF50"
+#define REGSRAM_981_reg_addr                                                           "0xB800AF54"
+#define REGSRAM_982_reg_addr                                                           "0xB800AF58"
+#define REGSRAM_983_reg_addr                                                           "0xB800AF5C"
+#define REGSRAM_984_reg_addr                                                           "0xB800AF60"
+#define REGSRAM_985_reg_addr                                                           "0xB800AF64"
+#define REGSRAM_986_reg_addr                                                           "0xB800AF68"
+#define REGSRAM_987_reg_addr                                                           "0xB800AF6C"
+#define REGSRAM_988_reg_addr                                                           "0xB800AF70"
+#define REGSRAM_989_reg_addr                                                           "0xB800AF74"
+#define REGSRAM_990_reg_addr                                                           "0xB800AF78"
+#define REGSRAM_991_reg_addr                                                           "0xB800AF7C"
+#define REGSRAM_992_reg_addr                                                           "0xB800AF80"
+#define REGSRAM_993_reg_addr                                                           "0xB800AF84"
+#define REGSRAM_994_reg_addr                                                           "0xB800AF88"
+#define REGSRAM_995_reg_addr                                                           "0xB800AF8C"
+#define REGSRAM_996_reg_addr                                                           "0xB800AF90"
+#define REGSRAM_997_reg_addr                                                           "0xB800AF94"
+#define REGSRAM_998_reg_addr                                                           "0xB800AF98"
+#define REGSRAM_999_reg_addr                                                           "0xB800AF9C"
+#define REGSRAM_1000_reg_addr                                                           "0xB800AFA0"
+#define REGSRAM_1001_reg_addr                                                           "0xB800AFA4"
+#define REGSRAM_1002_reg_addr                                                           "0xB800AFA8"
+#define REGSRAM_1003_reg_addr                                                           "0xB800AFAC"
+#define REGSRAM_1004_reg_addr                                                           "0xB800AFB0"
+#define REGSRAM_1005_reg_addr                                                           "0xB800AFB4"
+#define REGSRAM_1006_reg_addr                                                           "0xB800AFB8"
+#define REGSRAM_1007_reg_addr                                                           "0xB800AFBC"
+#define REGSRAM_1008_reg_addr                                                           "0xB800AFC0"
+#define REGSRAM_1009_reg_addr                                                           "0xB800AFC4"
+#define REGSRAM_1010_reg_addr                                                           "0xB800AFC8"
+#define REGSRAM_1011_reg_addr                                                           "0xB800AFCC"
+#define REGSRAM_1012_reg_addr                                                           "0xB800AFD0"
+#define REGSRAM_1013_reg_addr                                                           "0xB800AFD4"
+#define REGSRAM_1014_reg_addr                                                           "0xB800AFD8"
+#define REGSRAM_1015_reg_addr                                                           "0xB800AFDC"
+#define REGSRAM_1016_reg_addr                                                           "0xB800AFE0"
+#define REGSRAM_1017_reg_addr                                                           "0xB800AFE4"
+#define REGSRAM_1018_reg_addr                                                           "0xB800AFE8"
+#define REGSRAM_1019_reg_addr                                                           "0xB800AFEC"
+#define REGSRAM_1020_reg_addr                                                           "0xB800AFF0"
+#define REGSRAM_1021_reg_addr                                                           "0xB800AFF4"
+#define REGSRAM_1022_reg_addr                                                           "0xB800AFF8"
+#define REGSRAM_1023_reg_addr                                                           "0xB800AFFC"
+#define REGSRAM_0_reg                                                                0xB800A000
+#define REGSRAM_1_reg                                                                0xB800A004
+#define REGSRAM_2_reg                                                                0xB800A008
+#define REGSRAM_3_reg                                                                0xB800A00C
+#define REGSRAM_4_reg                                                                0xB800A010
+#define REGSRAM_5_reg                                                                0xB800A014
+#define REGSRAM_6_reg                                                                0xB800A018
+#define REGSRAM_7_reg                                                                0xB800A01C
+#define REGSRAM_8_reg                                                                0xB800A020
+#define REGSRAM_9_reg                                                                0xB800A024
+#define REGSRAM_10_reg                                                                0xB800A028
+#define REGSRAM_11_reg                                                                0xB800A02C
+#define REGSRAM_12_reg                                                                0xB800A030
+#define REGSRAM_13_reg                                                                0xB800A034
+#define REGSRAM_14_reg                                                                0xB800A038
+#define REGSRAM_15_reg                                                                0xB800A03C
+#define REGSRAM_16_reg                                                                0xB800A040
+#define REGSRAM_17_reg                                                                0xB800A044
+#define REGSRAM_18_reg                                                                0xB800A048
+#define REGSRAM_19_reg                                                                0xB800A04C
+#define REGSRAM_20_reg                                                                0xB800A050
+#define REGSRAM_21_reg                                                                0xB800A054
+#define REGSRAM_22_reg                                                                0xB800A058
+#define REGSRAM_23_reg                                                                0xB800A05C
+#define REGSRAM_24_reg                                                                0xB800A060
+#define REGSRAM_25_reg                                                                0xB800A064
+#define REGSRAM_26_reg                                                                0xB800A068
+#define REGSRAM_27_reg                                                                0xB800A06C
+#define REGSRAM_28_reg                                                                0xB800A070
+#define REGSRAM_29_reg                                                                0xB800A074
+#define REGSRAM_30_reg                                                                0xB800A078
+#define REGSRAM_31_reg                                                                0xB800A07C
+#define REGSRAM_32_reg                                                                0xB800A080
+#define REGSRAM_33_reg                                                                0xB800A084
+#define REGSRAM_34_reg                                                                0xB800A088
+#define REGSRAM_35_reg                                                                0xB800A08C
+#define REGSRAM_36_reg                                                                0xB800A090
+#define REGSRAM_37_reg                                                                0xB800A094
+#define REGSRAM_38_reg                                                                0xB800A098
+#define REGSRAM_39_reg                                                                0xB800A09C
+#define REGSRAM_40_reg                                                                0xB800A0A0
+#define REGSRAM_41_reg                                                                0xB800A0A4
+#define REGSRAM_42_reg                                                                0xB800A0A8
+#define REGSRAM_43_reg                                                                0xB800A0AC
+#define REGSRAM_44_reg                                                                0xB800A0B0
+#define REGSRAM_45_reg                                                                0xB800A0B4
+#define REGSRAM_46_reg                                                                0xB800A0B8
+#define REGSRAM_47_reg                                                                0xB800A0BC
+#define REGSRAM_48_reg                                                                0xB800A0C0
+#define REGSRAM_49_reg                                                                0xB800A0C4
+#define REGSRAM_50_reg                                                                0xB800A0C8
+#define REGSRAM_51_reg                                                                0xB800A0CC
+#define REGSRAM_52_reg                                                                0xB800A0D0
+#define REGSRAM_53_reg                                                                0xB800A0D4
+#define REGSRAM_54_reg                                                                0xB800A0D8
+#define REGSRAM_55_reg                                                                0xB800A0DC
+#define REGSRAM_56_reg                                                                0xB800A0E0
+#define REGSRAM_57_reg                                                                0xB800A0E4
+#define REGSRAM_58_reg                                                                0xB800A0E8
+#define REGSRAM_59_reg                                                                0xB800A0EC
+#define REGSRAM_60_reg                                                                0xB800A0F0
+#define REGSRAM_61_reg                                                                0xB800A0F4
+#define REGSRAM_62_reg                                                                0xB800A0F8
+#define REGSRAM_63_reg                                                                0xB800A0FC
+#define REGSRAM_64_reg                                                                0xB800A100
+#define REGSRAM_65_reg                                                                0xB800A104
+#define REGSRAM_66_reg                                                                0xB800A108
+#define REGSRAM_67_reg                                                                0xB800A10C
+#define REGSRAM_68_reg                                                                0xB800A110
+#define REGSRAM_69_reg                                                                0xB800A114
+#define REGSRAM_70_reg                                                                0xB800A118
+#define REGSRAM_71_reg                                                                0xB800A11C
+#define REGSRAM_72_reg                                                                0xB800A120
+#define REGSRAM_73_reg                                                                0xB800A124
+#define REGSRAM_74_reg                                                                0xB800A128
+#define REGSRAM_75_reg                                                                0xB800A12C
+#define REGSRAM_76_reg                                                                0xB800A130
+#define REGSRAM_77_reg                                                                0xB800A134
+#define REGSRAM_78_reg                                                                0xB800A138
+#define REGSRAM_79_reg                                                                0xB800A13C
+#define REGSRAM_80_reg                                                                0xB800A140
+#define REGSRAM_81_reg                                                                0xB800A144
+#define REGSRAM_82_reg                                                                0xB800A148
+#define REGSRAM_83_reg                                                                0xB800A14C
+#define REGSRAM_84_reg                                                                0xB800A150
+#define REGSRAM_85_reg                                                                0xB800A154
+#define REGSRAM_86_reg                                                                0xB800A158
+#define REGSRAM_87_reg                                                                0xB800A15C
+#define REGSRAM_88_reg                                                                0xB800A160
+#define REGSRAM_89_reg                                                                0xB800A164
+#define REGSRAM_90_reg                                                                0xB800A168
+#define REGSRAM_91_reg                                                                0xB800A16C
+#define REGSRAM_92_reg                                                                0xB800A170
+#define REGSRAM_93_reg                                                                0xB800A174
+#define REGSRAM_94_reg                                                                0xB800A178
+#define REGSRAM_95_reg                                                                0xB800A17C
+#define REGSRAM_96_reg                                                                0xB800A180
+#define REGSRAM_97_reg                                                                0xB800A184
+#define REGSRAM_98_reg                                                                0xB800A188
+#define REGSRAM_99_reg                                                                0xB800A18C
+#define REGSRAM_100_reg                                                                0xB800A190
+#define REGSRAM_101_reg                                                                0xB800A194
+#define REGSRAM_102_reg                                                                0xB800A198
+#define REGSRAM_103_reg                                                                0xB800A19C
+#define REGSRAM_104_reg                                                                0xB800A1A0
+#define REGSRAM_105_reg                                                                0xB800A1A4
+#define REGSRAM_106_reg                                                                0xB800A1A8
+#define REGSRAM_107_reg                                                                0xB800A1AC
+#define REGSRAM_108_reg                                                                0xB800A1B0
+#define REGSRAM_109_reg                                                                0xB800A1B4
+#define REGSRAM_110_reg                                                                0xB800A1B8
+#define REGSRAM_111_reg                                                                0xB800A1BC
+#define REGSRAM_112_reg                                                                0xB800A1C0
+#define REGSRAM_113_reg                                                                0xB800A1C4
+#define REGSRAM_114_reg                                                                0xB800A1C8
+#define REGSRAM_115_reg                                                                0xB800A1CC
+#define REGSRAM_116_reg                                                                0xB800A1D0
+#define REGSRAM_117_reg                                                                0xB800A1D4
+#define REGSRAM_118_reg                                                                0xB800A1D8
+#define REGSRAM_119_reg                                                                0xB800A1DC
+#define REGSRAM_120_reg                                                                0xB800A1E0
+#define REGSRAM_121_reg                                                                0xB800A1E4
+#define REGSRAM_122_reg                                                                0xB800A1E8
+#define REGSRAM_123_reg                                                                0xB800A1EC
+#define REGSRAM_124_reg                                                                0xB800A1F0
+#define REGSRAM_125_reg                                                                0xB800A1F4
+#define REGSRAM_126_reg                                                                0xB800A1F8
+#define REGSRAM_127_reg                                                                0xB800A1FC
+#define REGSRAM_128_reg                                                                0xB800A200
+#define REGSRAM_129_reg                                                                0xB800A204
+#define REGSRAM_130_reg                                                                0xB800A208
+#define REGSRAM_131_reg                                                                0xB800A20C
+#define REGSRAM_132_reg                                                                0xB800A210
+#define REGSRAM_133_reg                                                                0xB800A214
+#define REGSRAM_134_reg                                                                0xB800A218
+#define REGSRAM_135_reg                                                                0xB800A21C
+#define REGSRAM_136_reg                                                                0xB800A220
+#define REGSRAM_137_reg                                                                0xB800A224
+#define REGSRAM_138_reg                                                                0xB800A228
+#define REGSRAM_139_reg                                                                0xB800A22C
+#define REGSRAM_140_reg                                                                0xB800A230
+#define REGSRAM_141_reg                                                                0xB800A234
+#define REGSRAM_142_reg                                                                0xB800A238
+#define REGSRAM_143_reg                                                                0xB800A23C
+#define REGSRAM_144_reg                                                                0xB800A240
+#define REGSRAM_145_reg                                                                0xB800A244
+#define REGSRAM_146_reg                                                                0xB800A248
+#define REGSRAM_147_reg                                                                0xB800A24C
+#define REGSRAM_148_reg                                                                0xB800A250
+#define REGSRAM_149_reg                                                                0xB800A254
+#define REGSRAM_150_reg                                                                0xB800A258
+#define REGSRAM_151_reg                                                                0xB800A25C
+#define REGSRAM_152_reg                                                                0xB800A260
+#define REGSRAM_153_reg                                                                0xB800A264
+#define REGSRAM_154_reg                                                                0xB800A268
+#define REGSRAM_155_reg                                                                0xB800A26C
+#define REGSRAM_156_reg                                                                0xB800A270
+#define REGSRAM_157_reg                                                                0xB800A274
+#define REGSRAM_158_reg                                                                0xB800A278
+#define REGSRAM_159_reg                                                                0xB800A27C
+#define REGSRAM_160_reg                                                                0xB800A280
+#define REGSRAM_161_reg                                                                0xB800A284
+#define REGSRAM_162_reg                                                                0xB800A288
+#define REGSRAM_163_reg                                                                0xB800A28C
+#define REGSRAM_164_reg                                                                0xB800A290
+#define REGSRAM_165_reg                                                                0xB800A294
+#define REGSRAM_166_reg                                                                0xB800A298
+#define REGSRAM_167_reg                                                                0xB800A29C
+#define REGSRAM_168_reg                                                                0xB800A2A0
+#define REGSRAM_169_reg                                                                0xB800A2A4
+#define REGSRAM_170_reg                                                                0xB800A2A8
+#define REGSRAM_171_reg                                                                0xB800A2AC
+#define REGSRAM_172_reg                                                                0xB800A2B0
+#define REGSRAM_173_reg                                                                0xB800A2B4
+#define REGSRAM_174_reg                                                                0xB800A2B8
+#define REGSRAM_175_reg                                                                0xB800A2BC
+#define REGSRAM_176_reg                                                                0xB800A2C0
+#define REGSRAM_177_reg                                                                0xB800A2C4
+#define REGSRAM_178_reg                                                                0xB800A2C8
+#define REGSRAM_179_reg                                                                0xB800A2CC
+#define REGSRAM_180_reg                                                                0xB800A2D0
+#define REGSRAM_181_reg                                                                0xB800A2D4
+#define REGSRAM_182_reg                                                                0xB800A2D8
+#define REGSRAM_183_reg                                                                0xB800A2DC
+#define REGSRAM_184_reg                                                                0xB800A2E0
+#define REGSRAM_185_reg                                                                0xB800A2E4
+#define REGSRAM_186_reg                                                                0xB800A2E8
+#define REGSRAM_187_reg                                                                0xB800A2EC
+#define REGSRAM_188_reg                                                                0xB800A2F0
+#define REGSRAM_189_reg                                                                0xB800A2F4
+#define REGSRAM_190_reg                                                                0xB800A2F8
+#define REGSRAM_191_reg                                                                0xB800A2FC
+#define REGSRAM_192_reg                                                                0xB800A300
+#define REGSRAM_193_reg                                                                0xB800A304
+#define REGSRAM_194_reg                                                                0xB800A308
+#define REGSRAM_195_reg                                                                0xB800A30C
+#define REGSRAM_196_reg                                                                0xB800A310
+#define REGSRAM_197_reg                                                                0xB800A314
+#define REGSRAM_198_reg                                                                0xB800A318
+#define REGSRAM_199_reg                                                                0xB800A31C
+#define REGSRAM_200_reg                                                                0xB800A320
+#define REGSRAM_201_reg                                                                0xB800A324
+#define REGSRAM_202_reg                                                                0xB800A328
+#define REGSRAM_203_reg                                                                0xB800A32C
+#define REGSRAM_204_reg                                                                0xB800A330
+#define REGSRAM_205_reg                                                                0xB800A334
+#define REGSRAM_206_reg                                                                0xB800A338
+#define REGSRAM_207_reg                                                                0xB800A33C
+#define REGSRAM_208_reg                                                                0xB800A340
+#define REGSRAM_209_reg                                                                0xB800A344
+#define REGSRAM_210_reg                                                                0xB800A348
+#define REGSRAM_211_reg                                                                0xB800A34C
+#define REGSRAM_212_reg                                                                0xB800A350
+#define REGSRAM_213_reg                                                                0xB800A354
+#define REGSRAM_214_reg                                                                0xB800A358
+#define REGSRAM_215_reg                                                                0xB800A35C
+#define REGSRAM_216_reg                                                                0xB800A360
+#define REGSRAM_217_reg                                                                0xB800A364
+#define REGSRAM_218_reg                                                                0xB800A368
+#define REGSRAM_219_reg                                                                0xB800A36C
+#define REGSRAM_220_reg                                                                0xB800A370
+#define REGSRAM_221_reg                                                                0xB800A374
+#define REGSRAM_222_reg                                                                0xB800A378
+#define REGSRAM_223_reg                                                                0xB800A37C
+#define REGSRAM_224_reg                                                                0xB800A380
+#define REGSRAM_225_reg                                                                0xB800A384
+#define REGSRAM_226_reg                                                                0xB800A388
+#define REGSRAM_227_reg                                                                0xB800A38C
+#define REGSRAM_228_reg                                                                0xB800A390
+#define REGSRAM_229_reg                                                                0xB800A394
+#define REGSRAM_230_reg                                                                0xB800A398
+#define REGSRAM_231_reg                                                                0xB800A39C
+#define REGSRAM_232_reg                                                                0xB800A3A0
+#define REGSRAM_233_reg                                                                0xB800A3A4
+#define REGSRAM_234_reg                                                                0xB800A3A8
+#define REGSRAM_235_reg                                                                0xB800A3AC
+#define REGSRAM_236_reg                                                                0xB800A3B0
+#define REGSRAM_237_reg                                                                0xB800A3B4
+#define REGSRAM_238_reg                                                                0xB800A3B8
+#define REGSRAM_239_reg                                                                0xB800A3BC
+#define REGSRAM_240_reg                                                                0xB800A3C0
+#define REGSRAM_241_reg                                                                0xB800A3C4
+#define REGSRAM_242_reg                                                                0xB800A3C8
+#define REGSRAM_243_reg                                                                0xB800A3CC
+#define REGSRAM_244_reg                                                                0xB800A3D0
+#define REGSRAM_245_reg                                                                0xB800A3D4
+#define REGSRAM_246_reg                                                                0xB800A3D8
+#define REGSRAM_247_reg                                                                0xB800A3DC
+#define REGSRAM_248_reg                                                                0xB800A3E0
+#define REGSRAM_249_reg                                                                0xB800A3E4
+#define REGSRAM_250_reg                                                                0xB800A3E8
+#define REGSRAM_251_reg                                                                0xB800A3EC
+#define REGSRAM_252_reg                                                                0xB800A3F0
+#define REGSRAM_253_reg                                                                0xB800A3F4
+#define REGSRAM_254_reg                                                                0xB800A3F8
+#define REGSRAM_255_reg                                                                0xB800A3FC
+#define REGSRAM_256_reg                                                                0xB800A400
+#define REGSRAM_257_reg                                                                0xB800A404
+#define REGSRAM_258_reg                                                                0xB800A408
+#define REGSRAM_259_reg                                                                0xB800A40C
+#define REGSRAM_260_reg                                                                0xB800A410
+#define REGSRAM_261_reg                                                                0xB800A414
+#define REGSRAM_262_reg                                                                0xB800A418
+#define REGSRAM_263_reg                                                                0xB800A41C
+#define REGSRAM_264_reg                                                                0xB800A420
+#define REGSRAM_265_reg                                                                0xB800A424
+#define REGSRAM_266_reg                                                                0xB800A428
+#define REGSRAM_267_reg                                                                0xB800A42C
+#define REGSRAM_268_reg                                                                0xB800A430
+#define REGSRAM_269_reg                                                                0xB800A434
+#define REGSRAM_270_reg                                                                0xB800A438
+#define REGSRAM_271_reg                                                                0xB800A43C
+#define REGSRAM_272_reg                                                                0xB800A440
+#define REGSRAM_273_reg                                                                0xB800A444
+#define REGSRAM_274_reg                                                                0xB800A448
+#define REGSRAM_275_reg                                                                0xB800A44C
+#define REGSRAM_276_reg                                                                0xB800A450
+#define REGSRAM_277_reg                                                                0xB800A454
+#define REGSRAM_278_reg                                                                0xB800A458
+#define REGSRAM_279_reg                                                                0xB800A45C
+#define REGSRAM_280_reg                                                                0xB800A460
+#define REGSRAM_281_reg                                                                0xB800A464
+#define REGSRAM_282_reg                                                                0xB800A468
+#define REGSRAM_283_reg                                                                0xB800A46C
+#define REGSRAM_284_reg                                                                0xB800A470
+#define REGSRAM_285_reg                                                                0xB800A474
+#define REGSRAM_286_reg                                                                0xB800A478
+#define REGSRAM_287_reg                                                                0xB800A47C
+#define REGSRAM_288_reg                                                                0xB800A480
+#define REGSRAM_289_reg                                                                0xB800A484
+#define REGSRAM_290_reg                                                                0xB800A488
+#define REGSRAM_291_reg                                                                0xB800A48C
+#define REGSRAM_292_reg                                                                0xB800A490
+#define REGSRAM_293_reg                                                                0xB800A494
+#define REGSRAM_294_reg                                                                0xB800A498
+#define REGSRAM_295_reg                                                                0xB800A49C
+#define REGSRAM_296_reg                                                                0xB800A4A0
+#define REGSRAM_297_reg                                                                0xB800A4A4
+#define REGSRAM_298_reg                                                                0xB800A4A8
+#define REGSRAM_299_reg                                                                0xB800A4AC
+#define REGSRAM_300_reg                                                                0xB800A4B0
+#define REGSRAM_301_reg                                                                0xB800A4B4
+#define REGSRAM_302_reg                                                                0xB800A4B8
+#define REGSRAM_303_reg                                                                0xB800A4BC
+#define REGSRAM_304_reg                                                                0xB800A4C0
+#define REGSRAM_305_reg                                                                0xB800A4C4
+#define REGSRAM_306_reg                                                                0xB800A4C8
+#define REGSRAM_307_reg                                                                0xB800A4CC
+#define REGSRAM_308_reg                                                                0xB800A4D0
+#define REGSRAM_309_reg                                                                0xB800A4D4
+#define REGSRAM_310_reg                                                                0xB800A4D8
+#define REGSRAM_311_reg                                                                0xB800A4DC
+#define REGSRAM_312_reg                                                                0xB800A4E0
+#define REGSRAM_313_reg                                                                0xB800A4E4
+#define REGSRAM_314_reg                                                                0xB800A4E8
+#define REGSRAM_315_reg                                                                0xB800A4EC
+#define REGSRAM_316_reg                                                                0xB800A4F0
+#define REGSRAM_317_reg                                                                0xB800A4F4
+#define REGSRAM_318_reg                                                                0xB800A4F8
+#define REGSRAM_319_reg                                                                0xB800A4FC
+#define REGSRAM_320_reg                                                                0xB800A500
+#define REGSRAM_321_reg                                                                0xB800A504
+#define REGSRAM_322_reg                                                                0xB800A508
+#define REGSRAM_323_reg                                                                0xB800A50C
+#define REGSRAM_324_reg                                                                0xB800A510
+#define REGSRAM_325_reg                                                                0xB800A514
+#define REGSRAM_326_reg                                                                0xB800A518
+#define REGSRAM_327_reg                                                                0xB800A51C
+#define REGSRAM_328_reg                                                                0xB800A520
+#define REGSRAM_329_reg                                                                0xB800A524
+#define REGSRAM_330_reg                                                                0xB800A528
+#define REGSRAM_331_reg                                                                0xB800A52C
+#define REGSRAM_332_reg                                                                0xB800A530
+#define REGSRAM_333_reg                                                                0xB800A534
+#define REGSRAM_334_reg                                                                0xB800A538
+#define REGSRAM_335_reg                                                                0xB800A53C
+#define REGSRAM_336_reg                                                                0xB800A540
+#define REGSRAM_337_reg                                                                0xB800A544
+#define REGSRAM_338_reg                                                                0xB800A548
+#define REGSRAM_339_reg                                                                0xB800A54C
+#define REGSRAM_340_reg                                                                0xB800A550
+#define REGSRAM_341_reg                                                                0xB800A554
+#define REGSRAM_342_reg                                                                0xB800A558
+#define REGSRAM_343_reg                                                                0xB800A55C
+#define REGSRAM_344_reg                                                                0xB800A560
+#define REGSRAM_345_reg                                                                0xB800A564
+#define REGSRAM_346_reg                                                                0xB800A568
+#define REGSRAM_347_reg                                                                0xB800A56C
+#define REGSRAM_348_reg                                                                0xB800A570
+#define REGSRAM_349_reg                                                                0xB800A574
+#define REGSRAM_350_reg                                                                0xB800A578
+#define REGSRAM_351_reg                                                                0xB800A57C
+#define REGSRAM_352_reg                                                                0xB800A580
+#define REGSRAM_353_reg                                                                0xB800A584
+#define REGSRAM_354_reg                                                                0xB800A588
+#define REGSRAM_355_reg                                                                0xB800A58C
+#define REGSRAM_356_reg                                                                0xB800A590
+#define REGSRAM_357_reg                                                                0xB800A594
+#define REGSRAM_358_reg                                                                0xB800A598
+#define REGSRAM_359_reg                                                                0xB800A59C
+#define REGSRAM_360_reg                                                                0xB800A5A0
+#define REGSRAM_361_reg                                                                0xB800A5A4
+#define REGSRAM_362_reg                                                                0xB800A5A8
+#define REGSRAM_363_reg                                                                0xB800A5AC
+#define REGSRAM_364_reg                                                                0xB800A5B0
+#define REGSRAM_365_reg                                                                0xB800A5B4
+#define REGSRAM_366_reg                                                                0xB800A5B8
+#define REGSRAM_367_reg                                                                0xB800A5BC
+#define REGSRAM_368_reg                                                                0xB800A5C0
+#define REGSRAM_369_reg                                                                0xB800A5C4
+#define REGSRAM_370_reg                                                                0xB800A5C8
+#define REGSRAM_371_reg                                                                0xB800A5CC
+#define REGSRAM_372_reg                                                                0xB800A5D0
+#define REGSRAM_373_reg                                                                0xB800A5D4
+#define REGSRAM_374_reg                                                                0xB800A5D8
+#define REGSRAM_375_reg                                                                0xB800A5DC
+#define REGSRAM_376_reg                                                                0xB800A5E0
+#define REGSRAM_377_reg                                                                0xB800A5E4
+#define REGSRAM_378_reg                                                                0xB800A5E8
+#define REGSRAM_379_reg                                                                0xB800A5EC
+#define REGSRAM_380_reg                                                                0xB800A5F0
+#define REGSRAM_381_reg                                                                0xB800A5F4
+#define REGSRAM_382_reg                                                                0xB800A5F8
+#define REGSRAM_383_reg                                                                0xB800A5FC
+#define REGSRAM_384_reg                                                                0xB800A600
+#define REGSRAM_385_reg                                                                0xB800A604
+#define REGSRAM_386_reg                                                                0xB800A608
+#define REGSRAM_387_reg                                                                0xB800A60C
+#define REGSRAM_388_reg                                                                0xB800A610
+#define REGSRAM_389_reg                                                                0xB800A614
+#define REGSRAM_390_reg                                                                0xB800A618
+#define REGSRAM_391_reg                                                                0xB800A61C
+#define REGSRAM_392_reg                                                                0xB800A620
+#define REGSRAM_393_reg                                                                0xB800A624
+#define REGSRAM_394_reg                                                                0xB800A628
+#define REGSRAM_395_reg                                                                0xB800A62C
+#define REGSRAM_396_reg                                                                0xB800A630
+#define REGSRAM_397_reg                                                                0xB800A634
+#define REGSRAM_398_reg                                                                0xB800A638
+#define REGSRAM_399_reg                                                                0xB800A63C
+#define REGSRAM_400_reg                                                                0xB800A640
+#define REGSRAM_401_reg                                                                0xB800A644
+#define REGSRAM_402_reg                                                                0xB800A648
+#define REGSRAM_403_reg                                                                0xB800A64C
+#define REGSRAM_404_reg                                                                0xB800A650
+#define REGSRAM_405_reg                                                                0xB800A654
+#define REGSRAM_406_reg                                                                0xB800A658
+#define REGSRAM_407_reg                                                                0xB800A65C
+#define REGSRAM_408_reg                                                                0xB800A660
+#define REGSRAM_409_reg                                                                0xB800A664
+#define REGSRAM_410_reg                                                                0xB800A668
+#define REGSRAM_411_reg                                                                0xB800A66C
+#define REGSRAM_412_reg                                                                0xB800A670
+#define REGSRAM_413_reg                                                                0xB800A674
+#define REGSRAM_414_reg                                                                0xB800A678
+#define REGSRAM_415_reg                                                                0xB800A67C
+#define REGSRAM_416_reg                                                                0xB800A680
+#define REGSRAM_417_reg                                                                0xB800A684
+#define REGSRAM_418_reg                                                                0xB800A688
+#define REGSRAM_419_reg                                                                0xB800A68C
+#define REGSRAM_420_reg                                                                0xB800A690
+#define REGSRAM_421_reg                                                                0xB800A694
+#define REGSRAM_422_reg                                                                0xB800A698
+#define REGSRAM_423_reg                                                                0xB800A69C
+#define REGSRAM_424_reg                                                                0xB800A6A0
+#define REGSRAM_425_reg                                                                0xB800A6A4
+#define REGSRAM_426_reg                                                                0xB800A6A8
+#define REGSRAM_427_reg                                                                0xB800A6AC
+#define REGSRAM_428_reg                                                                0xB800A6B0
+#define REGSRAM_429_reg                                                                0xB800A6B4
+#define REGSRAM_430_reg                                                                0xB800A6B8
+#define REGSRAM_431_reg                                                                0xB800A6BC
+#define REGSRAM_432_reg                                                                0xB800A6C0
+#define REGSRAM_433_reg                                                                0xB800A6C4
+#define REGSRAM_434_reg                                                                0xB800A6C8
+#define REGSRAM_435_reg                                                                0xB800A6CC
+#define REGSRAM_436_reg                                                                0xB800A6D0
+#define REGSRAM_437_reg                                                                0xB800A6D4
+#define REGSRAM_438_reg                                                                0xB800A6D8
+#define REGSRAM_439_reg                                                                0xB800A6DC
+#define REGSRAM_440_reg                                                                0xB800A6E0
+#define REGSRAM_441_reg                                                                0xB800A6E4
+#define REGSRAM_442_reg                                                                0xB800A6E8
+#define REGSRAM_443_reg                                                                0xB800A6EC
+#define REGSRAM_444_reg                                                                0xB800A6F0
+#define REGSRAM_445_reg                                                                0xB800A6F4
+#define REGSRAM_446_reg                                                                0xB800A6F8
+#define REGSRAM_447_reg                                                                0xB800A6FC
+#define REGSRAM_448_reg                                                                0xB800A700
+#define REGSRAM_449_reg                                                                0xB800A704
+#define REGSRAM_450_reg                                                                0xB800A708
+#define REGSRAM_451_reg                                                                0xB800A70C
+#define REGSRAM_452_reg                                                                0xB800A710
+#define REGSRAM_453_reg                                                                0xB800A714
+#define REGSRAM_454_reg                                                                0xB800A718
+#define REGSRAM_455_reg                                                                0xB800A71C
+#define REGSRAM_456_reg                                                                0xB800A720
+#define REGSRAM_457_reg                                                                0xB800A724
+#define REGSRAM_458_reg                                                                0xB800A728
+#define REGSRAM_459_reg                                                                0xB800A72C
+#define REGSRAM_460_reg                                                                0xB800A730
+#define REGSRAM_461_reg                                                                0xB800A734
+#define REGSRAM_462_reg                                                                0xB800A738
+#define REGSRAM_463_reg                                                                0xB800A73C
+#define REGSRAM_464_reg                                                                0xB800A740
+#define REGSRAM_465_reg                                                                0xB800A744
+#define REGSRAM_466_reg                                                                0xB800A748
+#define REGSRAM_467_reg                                                                0xB800A74C
+#define REGSRAM_468_reg                                                                0xB800A750
+#define REGSRAM_469_reg                                                                0xB800A754
+#define REGSRAM_470_reg                                                                0xB800A758
+#define REGSRAM_471_reg                                                                0xB800A75C
+#define REGSRAM_472_reg                                                                0xB800A760
+#define REGSRAM_473_reg                                                                0xB800A764
+#define REGSRAM_474_reg                                                                0xB800A768
+#define REGSRAM_475_reg                                                                0xB800A76C
+#define REGSRAM_476_reg                                                                0xB800A770
+#define REGSRAM_477_reg                                                                0xB800A774
+#define REGSRAM_478_reg                                                                0xB800A778
+#define REGSRAM_479_reg                                                                0xB800A77C
+#define REGSRAM_480_reg                                                                0xB800A780
+#define REGSRAM_481_reg                                                                0xB800A784
+#define REGSRAM_482_reg                                                                0xB800A788
+#define REGSRAM_483_reg                                                                0xB800A78C
+#define REGSRAM_484_reg                                                                0xB800A790
+#define REGSRAM_485_reg                                                                0xB800A794
+#define REGSRAM_486_reg                                                                0xB800A798
+#define REGSRAM_487_reg                                                                0xB800A79C
+#define REGSRAM_488_reg                                                                0xB800A7A0
+#define REGSRAM_489_reg                                                                0xB800A7A4
+#define REGSRAM_490_reg                                                                0xB800A7A8
+#define REGSRAM_491_reg                                                                0xB800A7AC
+#define REGSRAM_492_reg                                                                0xB800A7B0
+#define REGSRAM_493_reg                                                                0xB800A7B4
+#define REGSRAM_494_reg                                                                0xB800A7B8
+#define REGSRAM_495_reg                                                                0xB800A7BC
+#define REGSRAM_496_reg                                                                0xB800A7C0
+#define REGSRAM_497_reg                                                                0xB800A7C4
+#define REGSRAM_498_reg                                                                0xB800A7C8
+#define REGSRAM_499_reg                                                                0xB800A7CC
+#define REGSRAM_500_reg                                                                0xB800A7D0
+#define REGSRAM_501_reg                                                                0xB800A7D4
+#define REGSRAM_502_reg                                                                0xB800A7D8
+#define REGSRAM_503_reg                                                                0xB800A7DC
+#define REGSRAM_504_reg                                                                0xB800A7E0
+#define REGSRAM_505_reg                                                                0xB800A7E4
+#define REGSRAM_506_reg                                                                0xB800A7E8
+#define REGSRAM_507_reg                                                                0xB800A7EC
+#define REGSRAM_508_reg                                                                0xB800A7F0
+#define REGSRAM_509_reg                                                                0xB800A7F4
+#define REGSRAM_510_reg                                                                0xB800A7F8
+#define REGSRAM_511_reg                                                                0xB800A7FC
+#define REGSRAM_512_reg                                                                0xB800A800
+#define REGSRAM_513_reg                                                                0xB800A804
+#define REGSRAM_514_reg                                                                0xB800A808
+#define REGSRAM_515_reg                                                                0xB800A80C
+#define REGSRAM_516_reg                                                                0xB800A810
+#define REGSRAM_517_reg                                                                0xB800A814
+#define REGSRAM_518_reg                                                                0xB800A818
+#define REGSRAM_519_reg                                                                0xB800A81C
+#define REGSRAM_520_reg                                                                0xB800A820
+#define REGSRAM_521_reg                                                                0xB800A824
+#define REGSRAM_522_reg                                                                0xB800A828
+#define REGSRAM_523_reg                                                                0xB800A82C
+#define REGSRAM_524_reg                                                                0xB800A830
+#define REGSRAM_525_reg                                                                0xB800A834
+#define REGSRAM_526_reg                                                                0xB800A838
+#define REGSRAM_527_reg                                                                0xB800A83C
+#define REGSRAM_528_reg                                                                0xB800A840
+#define REGSRAM_529_reg                                                                0xB800A844
+#define REGSRAM_530_reg                                                                0xB800A848
+#define REGSRAM_531_reg                                                                0xB800A84C
+#define REGSRAM_532_reg                                                                0xB800A850
+#define REGSRAM_533_reg                                                                0xB800A854
+#define REGSRAM_534_reg                                                                0xB800A858
+#define REGSRAM_535_reg                                                                0xB800A85C
+#define REGSRAM_536_reg                                                                0xB800A860
+#define REGSRAM_537_reg                                                                0xB800A864
+#define REGSRAM_538_reg                                                                0xB800A868
+#define REGSRAM_539_reg                                                                0xB800A86C
+#define REGSRAM_540_reg                                                                0xB800A870
+#define REGSRAM_541_reg                                                                0xB800A874
+#define REGSRAM_542_reg                                                                0xB800A878
+#define REGSRAM_543_reg                                                                0xB800A87C
+#define REGSRAM_544_reg                                                                0xB800A880
+#define REGSRAM_545_reg                                                                0xB800A884
+#define REGSRAM_546_reg                                                                0xB800A888
+#define REGSRAM_547_reg                                                                0xB800A88C
+#define REGSRAM_548_reg                                                                0xB800A890
+#define REGSRAM_549_reg                                                                0xB800A894
+#define REGSRAM_550_reg                                                                0xB800A898
+#define REGSRAM_551_reg                                                                0xB800A89C
+#define REGSRAM_552_reg                                                                0xB800A8A0
+#define REGSRAM_553_reg                                                                0xB800A8A4
+#define REGSRAM_554_reg                                                                0xB800A8A8
+#define REGSRAM_555_reg                                                                0xB800A8AC
+#define REGSRAM_556_reg                                                                0xB800A8B0
+#define REGSRAM_557_reg                                                                0xB800A8B4
+#define REGSRAM_558_reg                                                                0xB800A8B8
+#define REGSRAM_559_reg                                                                0xB800A8BC
+#define REGSRAM_560_reg                                                                0xB800A8C0
+#define REGSRAM_561_reg                                                                0xB800A8C4
+#define REGSRAM_562_reg                                                                0xB800A8C8
+#define REGSRAM_563_reg                                                                0xB800A8CC
+#define REGSRAM_564_reg                                                                0xB800A8D0
+#define REGSRAM_565_reg                                                                0xB800A8D4
+#define REGSRAM_566_reg                                                                0xB800A8D8
+#define REGSRAM_567_reg                                                                0xB800A8DC
+#define REGSRAM_568_reg                                                                0xB800A8E0
+#define REGSRAM_569_reg                                                                0xB800A8E4
+#define REGSRAM_570_reg                                                                0xB800A8E8
+#define REGSRAM_571_reg                                                                0xB800A8EC
+#define REGSRAM_572_reg                                                                0xB800A8F0
+#define REGSRAM_573_reg                                                                0xB800A8F4
+#define REGSRAM_574_reg                                                                0xB800A8F8
+#define REGSRAM_575_reg                                                                0xB800A8FC
+#define REGSRAM_576_reg                                                                0xB800A900
+#define REGSRAM_577_reg                                                                0xB800A904
+#define REGSRAM_578_reg                                                                0xB800A908
+#define REGSRAM_579_reg                                                                0xB800A90C
+#define REGSRAM_580_reg                                                                0xB800A910
+#define REGSRAM_581_reg                                                                0xB800A914
+#define REGSRAM_582_reg                                                                0xB800A918
+#define REGSRAM_583_reg                                                                0xB800A91C
+#define REGSRAM_584_reg                                                                0xB800A920
+#define REGSRAM_585_reg                                                                0xB800A924
+#define REGSRAM_586_reg                                                                0xB800A928
+#define REGSRAM_587_reg                                                                0xB800A92C
+#define REGSRAM_588_reg                                                                0xB800A930
+#define REGSRAM_589_reg                                                                0xB800A934
+#define REGSRAM_590_reg                                                                0xB800A938
+#define REGSRAM_591_reg                                                                0xB800A93C
+#define REGSRAM_592_reg                                                                0xB800A940
+#define REGSRAM_593_reg                                                                0xB800A944
+#define REGSRAM_594_reg                                                                0xB800A948
+#define REGSRAM_595_reg                                                                0xB800A94C
+#define REGSRAM_596_reg                                                                0xB800A950
+#define REGSRAM_597_reg                                                                0xB800A954
+#define REGSRAM_598_reg                                                                0xB800A958
+#define REGSRAM_599_reg                                                                0xB800A95C
+#define REGSRAM_600_reg                                                                0xB800A960
+#define REGSRAM_601_reg                                                                0xB800A964
+#define REGSRAM_602_reg                                                                0xB800A968
+#define REGSRAM_603_reg                                                                0xB800A96C
+#define REGSRAM_604_reg                                                                0xB800A970
+#define REGSRAM_605_reg                                                                0xB800A974
+#define REGSRAM_606_reg                                                                0xB800A978
+#define REGSRAM_607_reg                                                                0xB800A97C
+#define REGSRAM_608_reg                                                                0xB800A980
+#define REGSRAM_609_reg                                                                0xB800A984
+#define REGSRAM_610_reg                                                                0xB800A988
+#define REGSRAM_611_reg                                                                0xB800A98C
+#define REGSRAM_612_reg                                                                0xB800A990
+#define REGSRAM_613_reg                                                                0xB800A994
+#define REGSRAM_614_reg                                                                0xB800A998
+#define REGSRAM_615_reg                                                                0xB800A99C
+#define REGSRAM_616_reg                                                                0xB800A9A0
+#define REGSRAM_617_reg                                                                0xB800A9A4
+#define REGSRAM_618_reg                                                                0xB800A9A8
+#define REGSRAM_619_reg                                                                0xB800A9AC
+#define REGSRAM_620_reg                                                                0xB800A9B0
+#define REGSRAM_621_reg                                                                0xB800A9B4
+#define REGSRAM_622_reg                                                                0xB800A9B8
+#define REGSRAM_623_reg                                                                0xB800A9BC
+#define REGSRAM_624_reg                                                                0xB800A9C0
+#define REGSRAM_625_reg                                                                0xB800A9C4
+#define REGSRAM_626_reg                                                                0xB800A9C8
+#define REGSRAM_627_reg                                                                0xB800A9CC
+#define REGSRAM_628_reg                                                                0xB800A9D0
+#define REGSRAM_629_reg                                                                0xB800A9D4
+#define REGSRAM_630_reg                                                                0xB800A9D8
+#define REGSRAM_631_reg                                                                0xB800A9DC
+#define REGSRAM_632_reg                                                                0xB800A9E0
+#define REGSRAM_633_reg                                                                0xB800A9E4
+#define REGSRAM_634_reg                                                                0xB800A9E8
+#define REGSRAM_635_reg                                                                0xB800A9EC
+#define REGSRAM_636_reg                                                                0xB800A9F0
+#define REGSRAM_637_reg                                                                0xB800A9F4
+#define REGSRAM_638_reg                                                                0xB800A9F8
+#define REGSRAM_639_reg                                                                0xB800A9FC
+#define REGSRAM_640_reg                                                                0xB800AA00
+#define REGSRAM_641_reg                                                                0xB800AA04
+#define REGSRAM_642_reg                                                                0xB800AA08
+#define REGSRAM_643_reg                                                                0xB800AA0C
+#define REGSRAM_644_reg                                                                0xB800AA10
+#define REGSRAM_645_reg                                                                0xB800AA14
+#define REGSRAM_646_reg                                                                0xB800AA18
+#define REGSRAM_647_reg                                                                0xB800AA1C
+#define REGSRAM_648_reg                                                                0xB800AA20
+#define REGSRAM_649_reg                                                                0xB800AA24
+#define REGSRAM_650_reg                                                                0xB800AA28
+#define REGSRAM_651_reg                                                                0xB800AA2C
+#define REGSRAM_652_reg                                                                0xB800AA30
+#define REGSRAM_653_reg                                                                0xB800AA34
+#define REGSRAM_654_reg                                                                0xB800AA38
+#define REGSRAM_655_reg                                                                0xB800AA3C
+#define REGSRAM_656_reg                                                                0xB800AA40
+#define REGSRAM_657_reg                                                                0xB800AA44
+#define REGSRAM_658_reg                                                                0xB800AA48
+#define REGSRAM_659_reg                                                                0xB800AA4C
+#define REGSRAM_660_reg                                                                0xB800AA50
+#define REGSRAM_661_reg                                                                0xB800AA54
+#define REGSRAM_662_reg                                                                0xB800AA58
+#define REGSRAM_663_reg                                                                0xB800AA5C
+#define REGSRAM_664_reg                                                                0xB800AA60
+#define REGSRAM_665_reg                                                                0xB800AA64
+#define REGSRAM_666_reg                                                                0xB800AA68
+#define REGSRAM_667_reg                                                                0xB800AA6C
+#define REGSRAM_668_reg                                                                0xB800AA70
+#define REGSRAM_669_reg                                                                0xB800AA74
+#define REGSRAM_670_reg                                                                0xB800AA78
+#define REGSRAM_671_reg                                                                0xB800AA7C
+#define REGSRAM_672_reg                                                                0xB800AA80
+#define REGSRAM_673_reg                                                                0xB800AA84
+#define REGSRAM_674_reg                                                                0xB800AA88
+#define REGSRAM_675_reg                                                                0xB800AA8C
+#define REGSRAM_676_reg                                                                0xB800AA90
+#define REGSRAM_677_reg                                                                0xB800AA94
+#define REGSRAM_678_reg                                                                0xB800AA98
+#define REGSRAM_679_reg                                                                0xB800AA9C
+#define REGSRAM_680_reg                                                                0xB800AAA0
+#define REGSRAM_681_reg                                                                0xB800AAA4
+#define REGSRAM_682_reg                                                                0xB800AAA8
+#define REGSRAM_683_reg                                                                0xB800AAAC
+#define REGSRAM_684_reg                                                                0xB800AAB0
+#define REGSRAM_685_reg                                                                0xB800AAB4
+#define REGSRAM_686_reg                                                                0xB800AAB8
+#define REGSRAM_687_reg                                                                0xB800AABC
+#define REGSRAM_688_reg                                                                0xB800AAC0
+#define REGSRAM_689_reg                                                                0xB800AAC4
+#define REGSRAM_690_reg                                                                0xB800AAC8
+#define REGSRAM_691_reg                                                                0xB800AACC
+#define REGSRAM_692_reg                                                                0xB800AAD0
+#define REGSRAM_693_reg                                                                0xB800AAD4
+#define REGSRAM_694_reg                                                                0xB800AAD8
+#define REGSRAM_695_reg                                                                0xB800AADC
+#define REGSRAM_696_reg                                                                0xB800AAE0
+#define REGSRAM_697_reg                                                                0xB800AAE4
+#define REGSRAM_698_reg                                                                0xB800AAE8
+#define REGSRAM_699_reg                                                                0xB800AAEC
+#define REGSRAM_700_reg                                                                0xB800AAF0
+#define REGSRAM_701_reg                                                                0xB800AAF4
+#define REGSRAM_702_reg                                                                0xB800AAF8
+#define REGSRAM_703_reg                                                                0xB800AAFC
+#define REGSRAM_704_reg                                                                0xB800AB00
+#define REGSRAM_705_reg                                                                0xB800AB04
+#define REGSRAM_706_reg                                                                0xB800AB08
+#define REGSRAM_707_reg                                                                0xB800AB0C
+#define REGSRAM_708_reg                                                                0xB800AB10
+#define REGSRAM_709_reg                                                                0xB800AB14
+#define REGSRAM_710_reg                                                                0xB800AB18
+#define REGSRAM_711_reg                                                                0xB800AB1C
+#define REGSRAM_712_reg                                                                0xB800AB20
+#define REGSRAM_713_reg                                                                0xB800AB24
+#define REGSRAM_714_reg                                                                0xB800AB28
+#define REGSRAM_715_reg                                                                0xB800AB2C
+#define REGSRAM_716_reg                                                                0xB800AB30
+#define REGSRAM_717_reg                                                                0xB800AB34
+#define REGSRAM_718_reg                                                                0xB800AB38
+#define REGSRAM_719_reg                                                                0xB800AB3C
+#define REGSRAM_720_reg                                                                0xB800AB40
+#define REGSRAM_721_reg                                                                0xB800AB44
+#define REGSRAM_722_reg                                                                0xB800AB48
+#define REGSRAM_723_reg                                                                0xB800AB4C
+#define REGSRAM_724_reg                                                                0xB800AB50
+#define REGSRAM_725_reg                                                                0xB800AB54
+#define REGSRAM_726_reg                                                                0xB800AB58
+#define REGSRAM_727_reg                                                                0xB800AB5C
+#define REGSRAM_728_reg                                                                0xB800AB60
+#define REGSRAM_729_reg                                                                0xB800AB64
+#define REGSRAM_730_reg                                                                0xB800AB68
+#define REGSRAM_731_reg                                                                0xB800AB6C
+#define REGSRAM_732_reg                                                                0xB800AB70
+#define REGSRAM_733_reg                                                                0xB800AB74
+#define REGSRAM_734_reg                                                                0xB800AB78
+#define REGSRAM_735_reg                                                                0xB800AB7C
+#define REGSRAM_736_reg                                                                0xB800AB80
+#define REGSRAM_737_reg                                                                0xB800AB84
+#define REGSRAM_738_reg                                                                0xB800AB88
+#define REGSRAM_739_reg                                                                0xB800AB8C
+#define REGSRAM_740_reg                                                                0xB800AB90
+#define REGSRAM_741_reg                                                                0xB800AB94
+#define REGSRAM_742_reg                                                                0xB800AB98
+#define REGSRAM_743_reg                                                                0xB800AB9C
+#define REGSRAM_744_reg                                                                0xB800ABA0
+#define REGSRAM_745_reg                                                                0xB800ABA4
+#define REGSRAM_746_reg                                                                0xB800ABA8
+#define REGSRAM_747_reg                                                                0xB800ABAC
+#define REGSRAM_748_reg                                                                0xB800ABB0
+#define REGSRAM_749_reg                                                                0xB800ABB4
+#define REGSRAM_750_reg                                                                0xB800ABB8
+#define REGSRAM_751_reg                                                                0xB800ABBC
+#define REGSRAM_752_reg                                                                0xB800ABC0
+#define REGSRAM_753_reg                                                                0xB800ABC4
+#define REGSRAM_754_reg                                                                0xB800ABC8
+#define REGSRAM_755_reg                                                                0xB800ABCC
+#define REGSRAM_756_reg                                                                0xB800ABD0
+#define REGSRAM_757_reg                                                                0xB800ABD4
+#define REGSRAM_758_reg                                                                0xB800ABD8
+#define REGSRAM_759_reg                                                                0xB800ABDC
+#define REGSRAM_760_reg                                                                0xB800ABE0
+#define REGSRAM_761_reg                                                                0xB800ABE4
+#define REGSRAM_762_reg                                                                0xB800ABE8
+#define REGSRAM_763_reg                                                                0xB800ABEC
+#define REGSRAM_764_reg                                                                0xB800ABF0
+#define REGSRAM_765_reg                                                                0xB800ABF4
+#define REGSRAM_766_reg                                                                0xB800ABF8
+#define REGSRAM_767_reg                                                                0xB800ABFC
+#define REGSRAM_768_reg                                                                0xB800AC00
+#define REGSRAM_769_reg                                                                0xB800AC04
+#define REGSRAM_770_reg                                                                0xB800AC08
+#define REGSRAM_771_reg                                                                0xB800AC0C
+#define REGSRAM_772_reg                                                                0xB800AC10
+#define REGSRAM_773_reg                                                                0xB800AC14
+#define REGSRAM_774_reg                                                                0xB800AC18
+#define REGSRAM_775_reg                                                                0xB800AC1C
+#define REGSRAM_776_reg                                                                0xB800AC20
+#define REGSRAM_777_reg                                                                0xB800AC24
+#define REGSRAM_778_reg                                                                0xB800AC28
+#define REGSRAM_779_reg                                                                0xB800AC2C
+#define REGSRAM_780_reg                                                                0xB800AC30
+#define REGSRAM_781_reg                                                                0xB800AC34
+#define REGSRAM_782_reg                                                                0xB800AC38
+#define REGSRAM_783_reg                                                                0xB800AC3C
+#define REGSRAM_784_reg                                                                0xB800AC40
+#define REGSRAM_785_reg                                                                0xB800AC44
+#define REGSRAM_786_reg                                                                0xB800AC48
+#define REGSRAM_787_reg                                                                0xB800AC4C
+#define REGSRAM_788_reg                                                                0xB800AC50
+#define REGSRAM_789_reg                                                                0xB800AC54
+#define REGSRAM_790_reg                                                                0xB800AC58
+#define REGSRAM_791_reg                                                                0xB800AC5C
+#define REGSRAM_792_reg                                                                0xB800AC60
+#define REGSRAM_793_reg                                                                0xB800AC64
+#define REGSRAM_794_reg                                                                0xB800AC68
+#define REGSRAM_795_reg                                                                0xB800AC6C
+#define REGSRAM_796_reg                                                                0xB800AC70
+#define REGSRAM_797_reg                                                                0xB800AC74
+#define REGSRAM_798_reg                                                                0xB800AC78
+#define REGSRAM_799_reg                                                                0xB800AC7C
+#define REGSRAM_800_reg                                                                0xB800AC80
+#define REGSRAM_801_reg                                                                0xB800AC84
+#define REGSRAM_802_reg                                                                0xB800AC88
+#define REGSRAM_803_reg                                                                0xB800AC8C
+#define REGSRAM_804_reg                                                                0xB800AC90
+#define REGSRAM_805_reg                                                                0xB800AC94
+#define REGSRAM_806_reg                                                                0xB800AC98
+#define REGSRAM_807_reg                                                                0xB800AC9C
+#define REGSRAM_808_reg                                                                0xB800ACA0
+#define REGSRAM_809_reg                                                                0xB800ACA4
+#define REGSRAM_810_reg                                                                0xB800ACA8
+#define REGSRAM_811_reg                                                                0xB800ACAC
+#define REGSRAM_812_reg                                                                0xB800ACB0
+#define REGSRAM_813_reg                                                                0xB800ACB4
+#define REGSRAM_814_reg                                                                0xB800ACB8
+#define REGSRAM_815_reg                                                                0xB800ACBC
+#define REGSRAM_816_reg                                                                0xB800ACC0
+#define REGSRAM_817_reg                                                                0xB800ACC4
+#define REGSRAM_818_reg                                                                0xB800ACC8
+#define REGSRAM_819_reg                                                                0xB800ACCC
+#define REGSRAM_820_reg                                                                0xB800ACD0
+#define REGSRAM_821_reg                                                                0xB800ACD4
+#define REGSRAM_822_reg                                                                0xB800ACD8
+#define REGSRAM_823_reg                                                                0xB800ACDC
+#define REGSRAM_824_reg                                                                0xB800ACE0
+#define REGSRAM_825_reg                                                                0xB800ACE4
+#define REGSRAM_826_reg                                                                0xB800ACE8
+#define REGSRAM_827_reg                                                                0xB800ACEC
+#define REGSRAM_828_reg                                                                0xB800ACF0
+#define REGSRAM_829_reg                                                                0xB800ACF4
+#define REGSRAM_830_reg                                                                0xB800ACF8
+#define REGSRAM_831_reg                                                                0xB800ACFC
+#define REGSRAM_832_reg                                                                0xB800AD00
+#define REGSRAM_833_reg                                                                0xB800AD04
+#define REGSRAM_834_reg                                                                0xB800AD08
+#define REGSRAM_835_reg                                                                0xB800AD0C
+#define REGSRAM_836_reg                                                                0xB800AD10
+#define REGSRAM_837_reg                                                                0xB800AD14
+#define REGSRAM_838_reg                                                                0xB800AD18
+#define REGSRAM_839_reg                                                                0xB800AD1C
+#define REGSRAM_840_reg                                                                0xB800AD20
+#define REGSRAM_841_reg                                                                0xB800AD24
+#define REGSRAM_842_reg                                                                0xB800AD28
+#define REGSRAM_843_reg                                                                0xB800AD2C
+#define REGSRAM_844_reg                                                                0xB800AD30
+#define REGSRAM_845_reg                                                                0xB800AD34
+#define REGSRAM_846_reg                                                                0xB800AD38
+#define REGSRAM_847_reg                                                                0xB800AD3C
+#define REGSRAM_848_reg                                                                0xB800AD40
+#define REGSRAM_849_reg                                                                0xB800AD44
+#define REGSRAM_850_reg                                                                0xB800AD48
+#define REGSRAM_851_reg                                                                0xB800AD4C
+#define REGSRAM_852_reg                                                                0xB800AD50
+#define REGSRAM_853_reg                                                                0xB800AD54
+#define REGSRAM_854_reg                                                                0xB800AD58
+#define REGSRAM_855_reg                                                                0xB800AD5C
+#define REGSRAM_856_reg                                                                0xB800AD60
+#define REGSRAM_857_reg                                                                0xB800AD64
+#define REGSRAM_858_reg                                                                0xB800AD68
+#define REGSRAM_859_reg                                                                0xB800AD6C
+#define REGSRAM_860_reg                                                                0xB800AD70
+#define REGSRAM_861_reg                                                                0xB800AD74
+#define REGSRAM_862_reg                                                                0xB800AD78
+#define REGSRAM_863_reg                                                                0xB800AD7C
+#define REGSRAM_864_reg                                                                0xB800AD80
+#define REGSRAM_865_reg                                                                0xB800AD84
+#define REGSRAM_866_reg                                                                0xB800AD88
+#define REGSRAM_867_reg                                                                0xB800AD8C
+#define REGSRAM_868_reg                                                                0xB800AD90
+#define REGSRAM_869_reg                                                                0xB800AD94
+#define REGSRAM_870_reg                                                                0xB800AD98
+#define REGSRAM_871_reg                                                                0xB800AD9C
+#define REGSRAM_872_reg                                                                0xB800ADA0
+#define REGSRAM_873_reg                                                                0xB800ADA4
+#define REGSRAM_874_reg                                                                0xB800ADA8
+#define REGSRAM_875_reg                                                                0xB800ADAC
+#define REGSRAM_876_reg                                                                0xB800ADB0
+#define REGSRAM_877_reg                                                                0xB800ADB4
+#define REGSRAM_878_reg                                                                0xB800ADB8
+#define REGSRAM_879_reg                                                                0xB800ADBC
+#define REGSRAM_880_reg                                                                0xB800ADC0
+#define REGSRAM_881_reg                                                                0xB800ADC4
+#define REGSRAM_882_reg                                                                0xB800ADC8
+#define REGSRAM_883_reg                                                                0xB800ADCC
+#define REGSRAM_884_reg                                                                0xB800ADD0
+#define REGSRAM_885_reg                                                                0xB800ADD4
+#define REGSRAM_886_reg                                                                0xB800ADD8
+#define REGSRAM_887_reg                                                                0xB800ADDC
+#define REGSRAM_888_reg                                                                0xB800ADE0
+#define REGSRAM_889_reg                                                                0xB800ADE4
+#define REGSRAM_890_reg                                                                0xB800ADE8
+#define REGSRAM_891_reg                                                                0xB800ADEC
+#define REGSRAM_892_reg                                                                0xB800ADF0
+#define REGSRAM_893_reg                                                                0xB800ADF4
+#define REGSRAM_894_reg                                                                0xB800ADF8
+#define REGSRAM_895_reg                                                                0xB800ADFC
+#define REGSRAM_896_reg                                                                0xB800AE00
+#define REGSRAM_897_reg                                                                0xB800AE04
+#define REGSRAM_898_reg                                                                0xB800AE08
+#define REGSRAM_899_reg                                                                0xB800AE0C
+#define REGSRAM_900_reg                                                                0xB800AE10
+#define REGSRAM_901_reg                                                                0xB800AE14
+#define REGSRAM_902_reg                                                                0xB800AE18
+#define REGSRAM_903_reg                                                                0xB800AE1C
+#define REGSRAM_904_reg                                                                0xB800AE20
+#define REGSRAM_905_reg                                                                0xB800AE24
+#define REGSRAM_906_reg                                                                0xB800AE28
+#define REGSRAM_907_reg                                                                0xB800AE2C
+#define REGSRAM_908_reg                                                                0xB800AE30
+#define REGSRAM_909_reg                                                                0xB800AE34
+#define REGSRAM_910_reg                                                                0xB800AE38
+#define REGSRAM_911_reg                                                                0xB800AE3C
+#define REGSRAM_912_reg                                                                0xB800AE40
+#define REGSRAM_913_reg                                                                0xB800AE44
+#define REGSRAM_914_reg                                                                0xB800AE48
+#define REGSRAM_915_reg                                                                0xB800AE4C
+#define REGSRAM_916_reg                                                                0xB800AE50
+#define REGSRAM_917_reg                                                                0xB800AE54
+#define REGSRAM_918_reg                                                                0xB800AE58
+#define REGSRAM_919_reg                                                                0xB800AE5C
+#define REGSRAM_920_reg                                                                0xB800AE60
+#define REGSRAM_921_reg                                                                0xB800AE64
+#define REGSRAM_922_reg                                                                0xB800AE68
+#define REGSRAM_923_reg                                                                0xB800AE6C
+#define REGSRAM_924_reg                                                                0xB800AE70
+#define REGSRAM_925_reg                                                                0xB800AE74
+#define REGSRAM_926_reg                                                                0xB800AE78
+#define REGSRAM_927_reg                                                                0xB800AE7C
+#define REGSRAM_928_reg                                                                0xB800AE80
+#define REGSRAM_929_reg                                                                0xB800AE84
+#define REGSRAM_930_reg                                                                0xB800AE88
+#define REGSRAM_931_reg                                                                0xB800AE8C
+#define REGSRAM_932_reg                                                                0xB800AE90
+#define REGSRAM_933_reg                                                                0xB800AE94
+#define REGSRAM_934_reg                                                                0xB800AE98
+#define REGSRAM_935_reg                                                                0xB800AE9C
+#define REGSRAM_936_reg                                                                0xB800AEA0
+#define REGSRAM_937_reg                                                                0xB800AEA4
+#define REGSRAM_938_reg                                                                0xB800AEA8
+#define REGSRAM_939_reg                                                                0xB800AEAC
+#define REGSRAM_940_reg                                                                0xB800AEB0
+#define REGSRAM_941_reg                                                                0xB800AEB4
+#define REGSRAM_942_reg                                                                0xB800AEB8
+#define REGSRAM_943_reg                                                                0xB800AEBC
+#define REGSRAM_944_reg                                                                0xB800AEC0
+#define REGSRAM_945_reg                                                                0xB800AEC4
+#define REGSRAM_946_reg                                                                0xB800AEC8
+#define REGSRAM_947_reg                                                                0xB800AECC
+#define REGSRAM_948_reg                                                                0xB800AED0
+#define REGSRAM_949_reg                                                                0xB800AED4
+#define REGSRAM_950_reg                                                                0xB800AED8
+#define REGSRAM_951_reg                                                                0xB800AEDC
+#define REGSRAM_952_reg                                                                0xB800AEE0
+#define REGSRAM_953_reg                                                                0xB800AEE4
+#define REGSRAM_954_reg                                                                0xB800AEE8
+#define REGSRAM_955_reg                                                                0xB800AEEC
+#define REGSRAM_956_reg                                                                0xB800AEF0
+#define REGSRAM_957_reg                                                                0xB800AEF4
+#define REGSRAM_958_reg                                                                0xB800AEF8
+#define REGSRAM_959_reg                                                                0xB800AEFC
+#define REGSRAM_960_reg                                                                0xB800AF00
+#define REGSRAM_961_reg                                                                0xB800AF04
+#define REGSRAM_962_reg                                                                0xB800AF08
+#define REGSRAM_963_reg                                                                0xB800AF0C
+#define REGSRAM_964_reg                                                                0xB800AF10
+#define REGSRAM_965_reg                                                                0xB800AF14
+#define REGSRAM_966_reg                                                                0xB800AF18
+#define REGSRAM_967_reg                                                                0xB800AF1C
+#define REGSRAM_968_reg                                                                0xB800AF20
+#define REGSRAM_969_reg                                                                0xB800AF24
+#define REGSRAM_970_reg                                                                0xB800AF28
+#define REGSRAM_971_reg                                                                0xB800AF2C
+#define REGSRAM_972_reg                                                                0xB800AF30
+#define REGSRAM_973_reg                                                                0xB800AF34
+#define REGSRAM_974_reg                                                                0xB800AF38
+#define REGSRAM_975_reg                                                                0xB800AF3C
+#define REGSRAM_976_reg                                                                0xB800AF40
+#define REGSRAM_977_reg                                                                0xB800AF44
+#define REGSRAM_978_reg                                                                0xB800AF48
+#define REGSRAM_979_reg                                                                0xB800AF4C
+#define REGSRAM_980_reg                                                                0xB800AF50
+#define REGSRAM_981_reg                                                                0xB800AF54
+#define REGSRAM_982_reg                                                                0xB800AF58
+#define REGSRAM_983_reg                                                                0xB800AF5C
+#define REGSRAM_984_reg                                                                0xB800AF60
+#define REGSRAM_985_reg                                                                0xB800AF64
+#define REGSRAM_986_reg                                                                0xB800AF68
+#define REGSRAM_987_reg                                                                0xB800AF6C
+#define REGSRAM_988_reg                                                                0xB800AF70
+#define REGSRAM_989_reg                                                                0xB800AF74
+#define REGSRAM_990_reg                                                                0xB800AF78
+#define REGSRAM_991_reg                                                                0xB800AF7C
+#define REGSRAM_992_reg                                                                0xB800AF80
+#define REGSRAM_993_reg                                                                0xB800AF84
+#define REGSRAM_994_reg                                                                0xB800AF88
+#define REGSRAM_995_reg                                                                0xB800AF8C
+#define REGSRAM_996_reg                                                                0xB800AF90
+#define REGSRAM_997_reg                                                                0xB800AF94
+#define REGSRAM_998_reg                                                                0xB800AF98
+#define REGSRAM_999_reg                                                                0xB800AF9C
+#define REGSRAM_1000_reg                                                                0xB800AFA0
+#define REGSRAM_1001_reg                                                                0xB800AFA4
+#define REGSRAM_1002_reg                                                                0xB800AFA8
+#define REGSRAM_1003_reg                                                                0xB800AFAC
+#define REGSRAM_1004_reg                                                                0xB800AFB0
+#define REGSRAM_1005_reg                                                                0xB800AFB4
+#define REGSRAM_1006_reg                                                                0xB800AFB8
+#define REGSRAM_1007_reg                                                                0xB800AFBC
+#define REGSRAM_1008_reg                                                                0xB800AFC0
+#define REGSRAM_1009_reg                                                                0xB800AFC4
+#define REGSRAM_1010_reg                                                                0xB800AFC8
+#define REGSRAM_1011_reg                                                                0xB800AFCC
+#define REGSRAM_1012_reg                                                                0xB800AFD0
+#define REGSRAM_1013_reg                                                                0xB800AFD4
+#define REGSRAM_1014_reg                                                                0xB800AFD8
+#define REGSRAM_1015_reg                                                                0xB800AFDC
+#define REGSRAM_1016_reg                                                                0xB800AFE0
+#define REGSRAM_1017_reg                                                                0xB800AFE4
+#define REGSRAM_1018_reg                                                                0xB800AFE8
+#define REGSRAM_1019_reg                                                                0xB800AFEC
+#define REGSRAM_1020_reg                                                                0xB800AFF0
+#define REGSRAM_1021_reg                                                                0xB800AFF4
+#define REGSRAM_1022_reg                                                                0xB800AFF8
+#define REGSRAM_1023_reg                                                                0xB800AFFC
+#define set_REGSRAM_0_reg(data)   (*((volatile unsigned int*) REGSRAM_0_reg)=data)
+#define set_REGSRAM_1_reg(data)   (*((volatile unsigned int*) REGSRAM_1_reg)=data)
+#define set_REGSRAM_2_reg(data)   (*((volatile unsigned int*) REGSRAM_2_reg)=data)
+#define set_REGSRAM_3_reg(data)   (*((volatile unsigned int*) REGSRAM_3_reg)=data)
+#define set_REGSRAM_4_reg(data)   (*((volatile unsigned int*) REGSRAM_4_reg)=data)
+#define set_REGSRAM_5_reg(data)   (*((volatile unsigned int*) REGSRAM_5_reg)=data)
+#define set_REGSRAM_6_reg(data)   (*((volatile unsigned int*) REGSRAM_6_reg)=data)
+#define set_REGSRAM_7_reg(data)   (*((volatile unsigned int*) REGSRAM_7_reg)=data)
+#define set_REGSRAM_8_reg(data)   (*((volatile unsigned int*) REGSRAM_8_reg)=data)
+#define set_REGSRAM_9_reg(data)   (*((volatile unsigned int*) REGSRAM_9_reg)=data)
+#define set_REGSRAM_10_reg(data)   (*((volatile unsigned int*) REGSRAM_10_reg)=data)
+#define set_REGSRAM_11_reg(data)   (*((volatile unsigned int*) REGSRAM_11_reg)=data)
+#define set_REGSRAM_12_reg(data)   (*((volatile unsigned int*) REGSRAM_12_reg)=data)
+#define set_REGSRAM_13_reg(data)   (*((volatile unsigned int*) REGSRAM_13_reg)=data)
+#define set_REGSRAM_14_reg(data)   (*((volatile unsigned int*) REGSRAM_14_reg)=data)
+#define set_REGSRAM_15_reg(data)   (*((volatile unsigned int*) REGSRAM_15_reg)=data)
+#define set_REGSRAM_16_reg(data)   (*((volatile unsigned int*) REGSRAM_16_reg)=data)
+#define set_REGSRAM_17_reg(data)   (*((volatile unsigned int*) REGSRAM_17_reg)=data)
+#define set_REGSRAM_18_reg(data)   (*((volatile unsigned int*) REGSRAM_18_reg)=data)
+#define set_REGSRAM_19_reg(data)   (*((volatile unsigned int*) REGSRAM_19_reg)=data)
+#define set_REGSRAM_20_reg(data)   (*((volatile unsigned int*) REGSRAM_20_reg)=data)
+#define set_REGSRAM_21_reg(data)   (*((volatile unsigned int*) REGSRAM_21_reg)=data)
+#define set_REGSRAM_22_reg(data)   (*((volatile unsigned int*) REGSRAM_22_reg)=data)
+#define set_REGSRAM_23_reg(data)   (*((volatile unsigned int*) REGSRAM_23_reg)=data)
+#define set_REGSRAM_24_reg(data)   (*((volatile unsigned int*) REGSRAM_24_reg)=data)
+#define set_REGSRAM_25_reg(data)   (*((volatile unsigned int*) REGSRAM_25_reg)=data)
+#define set_REGSRAM_26_reg(data)   (*((volatile unsigned int*) REGSRAM_26_reg)=data)
+#define set_REGSRAM_27_reg(data)   (*((volatile unsigned int*) REGSRAM_27_reg)=data)
+#define set_REGSRAM_28_reg(data)   (*((volatile unsigned int*) REGSRAM_28_reg)=data)
+#define set_REGSRAM_29_reg(data)   (*((volatile unsigned int*) REGSRAM_29_reg)=data)
+#define set_REGSRAM_30_reg(data)   (*((volatile unsigned int*) REGSRAM_30_reg)=data)
+#define set_REGSRAM_31_reg(data)   (*((volatile unsigned int*) REGSRAM_31_reg)=data)
+#define set_REGSRAM_32_reg(data)   (*((volatile unsigned int*) REGSRAM_32_reg)=data)
+#define set_REGSRAM_33_reg(data)   (*((volatile unsigned int*) REGSRAM_33_reg)=data)
+#define set_REGSRAM_34_reg(data)   (*((volatile unsigned int*) REGSRAM_34_reg)=data)
+#define set_REGSRAM_35_reg(data)   (*((volatile unsigned int*) REGSRAM_35_reg)=data)
+#define set_REGSRAM_36_reg(data)   (*((volatile unsigned int*) REGSRAM_36_reg)=data)
+#define set_REGSRAM_37_reg(data)   (*((volatile unsigned int*) REGSRAM_37_reg)=data)
+#define set_REGSRAM_38_reg(data)   (*((volatile unsigned int*) REGSRAM_38_reg)=data)
+#define set_REGSRAM_39_reg(data)   (*((volatile unsigned int*) REGSRAM_39_reg)=data)
+#define set_REGSRAM_40_reg(data)   (*((volatile unsigned int*) REGSRAM_40_reg)=data)
+#define set_REGSRAM_41_reg(data)   (*((volatile unsigned int*) REGSRAM_41_reg)=data)
+#define set_REGSRAM_42_reg(data)   (*((volatile unsigned int*) REGSRAM_42_reg)=data)
+#define set_REGSRAM_43_reg(data)   (*((volatile unsigned int*) REGSRAM_43_reg)=data)
+#define set_REGSRAM_44_reg(data)   (*((volatile unsigned int*) REGSRAM_44_reg)=data)
+#define set_REGSRAM_45_reg(data)   (*((volatile unsigned int*) REGSRAM_45_reg)=data)
+#define set_REGSRAM_46_reg(data)   (*((volatile unsigned int*) REGSRAM_46_reg)=data)
+#define set_REGSRAM_47_reg(data)   (*((volatile unsigned int*) REGSRAM_47_reg)=data)
+#define set_REGSRAM_48_reg(data)   (*((volatile unsigned int*) REGSRAM_48_reg)=data)
+#define set_REGSRAM_49_reg(data)   (*((volatile unsigned int*) REGSRAM_49_reg)=data)
+#define set_REGSRAM_50_reg(data)   (*((volatile unsigned int*) REGSRAM_50_reg)=data)
+#define set_REGSRAM_51_reg(data)   (*((volatile unsigned int*) REGSRAM_51_reg)=data)
+#define set_REGSRAM_52_reg(data)   (*((volatile unsigned int*) REGSRAM_52_reg)=data)
+#define set_REGSRAM_53_reg(data)   (*((volatile unsigned int*) REGSRAM_53_reg)=data)
+#define set_REGSRAM_54_reg(data)   (*((volatile unsigned int*) REGSRAM_54_reg)=data)
+#define set_REGSRAM_55_reg(data)   (*((volatile unsigned int*) REGSRAM_55_reg)=data)
+#define set_REGSRAM_56_reg(data)   (*((volatile unsigned int*) REGSRAM_56_reg)=data)
+#define set_REGSRAM_57_reg(data)   (*((volatile unsigned int*) REGSRAM_57_reg)=data)
+#define set_REGSRAM_58_reg(data)   (*((volatile unsigned int*) REGSRAM_58_reg)=data)
+#define set_REGSRAM_59_reg(data)   (*((volatile unsigned int*) REGSRAM_59_reg)=data)
+#define set_REGSRAM_60_reg(data)   (*((volatile unsigned int*) REGSRAM_60_reg)=data)
+#define set_REGSRAM_61_reg(data)   (*((volatile unsigned int*) REGSRAM_61_reg)=data)
+#define set_REGSRAM_62_reg(data)   (*((volatile unsigned int*) REGSRAM_62_reg)=data)
+#define set_REGSRAM_63_reg(data)   (*((volatile unsigned int*) REGSRAM_63_reg)=data)
+#define set_REGSRAM_64_reg(data)   (*((volatile unsigned int*) REGSRAM_64_reg)=data)
+#define set_REGSRAM_65_reg(data)   (*((volatile unsigned int*) REGSRAM_65_reg)=data)
+#define set_REGSRAM_66_reg(data)   (*((volatile unsigned int*) REGSRAM_66_reg)=data)
+#define set_REGSRAM_67_reg(data)   (*((volatile unsigned int*) REGSRAM_67_reg)=data)
+#define set_REGSRAM_68_reg(data)   (*((volatile unsigned int*) REGSRAM_68_reg)=data)
+#define set_REGSRAM_69_reg(data)   (*((volatile unsigned int*) REGSRAM_69_reg)=data)
+#define set_REGSRAM_70_reg(data)   (*((volatile unsigned int*) REGSRAM_70_reg)=data)
+#define set_REGSRAM_71_reg(data)   (*((volatile unsigned int*) REGSRAM_71_reg)=data)
+#define set_REGSRAM_72_reg(data)   (*((volatile unsigned int*) REGSRAM_72_reg)=data)
+#define set_REGSRAM_73_reg(data)   (*((volatile unsigned int*) REGSRAM_73_reg)=data)
+#define set_REGSRAM_74_reg(data)   (*((volatile unsigned int*) REGSRAM_74_reg)=data)
+#define set_REGSRAM_75_reg(data)   (*((volatile unsigned int*) REGSRAM_75_reg)=data)
+#define set_REGSRAM_76_reg(data)   (*((volatile unsigned int*) REGSRAM_76_reg)=data)
+#define set_REGSRAM_77_reg(data)   (*((volatile unsigned int*) REGSRAM_77_reg)=data)
+#define set_REGSRAM_78_reg(data)   (*((volatile unsigned int*) REGSRAM_78_reg)=data)
+#define set_REGSRAM_79_reg(data)   (*((volatile unsigned int*) REGSRAM_79_reg)=data)
+#define set_REGSRAM_80_reg(data)   (*((volatile unsigned int*) REGSRAM_80_reg)=data)
+#define set_REGSRAM_81_reg(data)   (*((volatile unsigned int*) REGSRAM_81_reg)=data)
+#define set_REGSRAM_82_reg(data)   (*((volatile unsigned int*) REGSRAM_82_reg)=data)
+#define set_REGSRAM_83_reg(data)   (*((volatile unsigned int*) REGSRAM_83_reg)=data)
+#define set_REGSRAM_84_reg(data)   (*((volatile unsigned int*) REGSRAM_84_reg)=data)
+#define set_REGSRAM_85_reg(data)   (*((volatile unsigned int*) REGSRAM_85_reg)=data)
+#define set_REGSRAM_86_reg(data)   (*((volatile unsigned int*) REGSRAM_86_reg)=data)
+#define set_REGSRAM_87_reg(data)   (*((volatile unsigned int*) REGSRAM_87_reg)=data)
+#define set_REGSRAM_88_reg(data)   (*((volatile unsigned int*) REGSRAM_88_reg)=data)
+#define set_REGSRAM_89_reg(data)   (*((volatile unsigned int*) REGSRAM_89_reg)=data)
+#define set_REGSRAM_90_reg(data)   (*((volatile unsigned int*) REGSRAM_90_reg)=data)
+#define set_REGSRAM_91_reg(data)   (*((volatile unsigned int*) REGSRAM_91_reg)=data)
+#define set_REGSRAM_92_reg(data)   (*((volatile unsigned int*) REGSRAM_92_reg)=data)
+#define set_REGSRAM_93_reg(data)   (*((volatile unsigned int*) REGSRAM_93_reg)=data)
+#define set_REGSRAM_94_reg(data)   (*((volatile unsigned int*) REGSRAM_94_reg)=data)
+#define set_REGSRAM_95_reg(data)   (*((volatile unsigned int*) REGSRAM_95_reg)=data)
+#define set_REGSRAM_96_reg(data)   (*((volatile unsigned int*) REGSRAM_96_reg)=data)
+#define set_REGSRAM_97_reg(data)   (*((volatile unsigned int*) REGSRAM_97_reg)=data)
+#define set_REGSRAM_98_reg(data)   (*((volatile unsigned int*) REGSRAM_98_reg)=data)
+#define set_REGSRAM_99_reg(data)   (*((volatile unsigned int*) REGSRAM_99_reg)=data)
+#define set_REGSRAM_100_reg(data)   (*((volatile unsigned int*) REGSRAM_100_reg)=data)
+#define set_REGSRAM_101_reg(data)   (*((volatile unsigned int*) REGSRAM_101_reg)=data)
+#define set_REGSRAM_102_reg(data)   (*((volatile unsigned int*) REGSRAM_102_reg)=data)
+#define set_REGSRAM_103_reg(data)   (*((volatile unsigned int*) REGSRAM_103_reg)=data)
+#define set_REGSRAM_104_reg(data)   (*((volatile unsigned int*) REGSRAM_104_reg)=data)
+#define set_REGSRAM_105_reg(data)   (*((volatile unsigned int*) REGSRAM_105_reg)=data)
+#define set_REGSRAM_106_reg(data)   (*((volatile unsigned int*) REGSRAM_106_reg)=data)
+#define set_REGSRAM_107_reg(data)   (*((volatile unsigned int*) REGSRAM_107_reg)=data)
+#define set_REGSRAM_108_reg(data)   (*((volatile unsigned int*) REGSRAM_108_reg)=data)
+#define set_REGSRAM_109_reg(data)   (*((volatile unsigned int*) REGSRAM_109_reg)=data)
+#define set_REGSRAM_110_reg(data)   (*((volatile unsigned int*) REGSRAM_110_reg)=data)
+#define set_REGSRAM_111_reg(data)   (*((volatile unsigned int*) REGSRAM_111_reg)=data)
+#define set_REGSRAM_112_reg(data)   (*((volatile unsigned int*) REGSRAM_112_reg)=data)
+#define set_REGSRAM_113_reg(data)   (*((volatile unsigned int*) REGSRAM_113_reg)=data)
+#define set_REGSRAM_114_reg(data)   (*((volatile unsigned int*) REGSRAM_114_reg)=data)
+#define set_REGSRAM_115_reg(data)   (*((volatile unsigned int*) REGSRAM_115_reg)=data)
+#define set_REGSRAM_116_reg(data)   (*((volatile unsigned int*) REGSRAM_116_reg)=data)
+#define set_REGSRAM_117_reg(data)   (*((volatile unsigned int*) REGSRAM_117_reg)=data)
+#define set_REGSRAM_118_reg(data)   (*((volatile unsigned int*) REGSRAM_118_reg)=data)
+#define set_REGSRAM_119_reg(data)   (*((volatile unsigned int*) REGSRAM_119_reg)=data)
+#define set_REGSRAM_120_reg(data)   (*((volatile unsigned int*) REGSRAM_120_reg)=data)
+#define set_REGSRAM_121_reg(data)   (*((volatile unsigned int*) REGSRAM_121_reg)=data)
+#define set_REGSRAM_122_reg(data)   (*((volatile unsigned int*) REGSRAM_122_reg)=data)
+#define set_REGSRAM_123_reg(data)   (*((volatile unsigned int*) REGSRAM_123_reg)=data)
+#define set_REGSRAM_124_reg(data)   (*((volatile unsigned int*) REGSRAM_124_reg)=data)
+#define set_REGSRAM_125_reg(data)   (*((volatile unsigned int*) REGSRAM_125_reg)=data)
+#define set_REGSRAM_126_reg(data)   (*((volatile unsigned int*) REGSRAM_126_reg)=data)
+#define set_REGSRAM_127_reg(data)   (*((volatile unsigned int*) REGSRAM_127_reg)=data)
+#define set_REGSRAM_128_reg(data)   (*((volatile unsigned int*) REGSRAM_128_reg)=data)
+#define set_REGSRAM_129_reg(data)   (*((volatile unsigned int*) REGSRAM_129_reg)=data)
+#define set_REGSRAM_130_reg(data)   (*((volatile unsigned int*) REGSRAM_130_reg)=data)
+#define set_REGSRAM_131_reg(data)   (*((volatile unsigned int*) REGSRAM_131_reg)=data)
+#define set_REGSRAM_132_reg(data)   (*((volatile unsigned int*) REGSRAM_132_reg)=data)
+#define set_REGSRAM_133_reg(data)   (*((volatile unsigned int*) REGSRAM_133_reg)=data)
+#define set_REGSRAM_134_reg(data)   (*((volatile unsigned int*) REGSRAM_134_reg)=data)
+#define set_REGSRAM_135_reg(data)   (*((volatile unsigned int*) REGSRAM_135_reg)=data)
+#define set_REGSRAM_136_reg(data)   (*((volatile unsigned int*) REGSRAM_136_reg)=data)
+#define set_REGSRAM_137_reg(data)   (*((volatile unsigned int*) REGSRAM_137_reg)=data)
+#define set_REGSRAM_138_reg(data)   (*((volatile unsigned int*) REGSRAM_138_reg)=data)
+#define set_REGSRAM_139_reg(data)   (*((volatile unsigned int*) REGSRAM_139_reg)=data)
+#define set_REGSRAM_140_reg(data)   (*((volatile unsigned int*) REGSRAM_140_reg)=data)
+#define set_REGSRAM_141_reg(data)   (*((volatile unsigned int*) REGSRAM_141_reg)=data)
+#define set_REGSRAM_142_reg(data)   (*((volatile unsigned int*) REGSRAM_142_reg)=data)
+#define set_REGSRAM_143_reg(data)   (*((volatile unsigned int*) REGSRAM_143_reg)=data)
+#define set_REGSRAM_144_reg(data)   (*((volatile unsigned int*) REGSRAM_144_reg)=data)
+#define set_REGSRAM_145_reg(data)   (*((volatile unsigned int*) REGSRAM_145_reg)=data)
+#define set_REGSRAM_146_reg(data)   (*((volatile unsigned int*) REGSRAM_146_reg)=data)
+#define set_REGSRAM_147_reg(data)   (*((volatile unsigned int*) REGSRAM_147_reg)=data)
+#define set_REGSRAM_148_reg(data)   (*((volatile unsigned int*) REGSRAM_148_reg)=data)
+#define set_REGSRAM_149_reg(data)   (*((volatile unsigned int*) REGSRAM_149_reg)=data)
+#define set_REGSRAM_150_reg(data)   (*((volatile unsigned int*) REGSRAM_150_reg)=data)
+#define set_REGSRAM_151_reg(data)   (*((volatile unsigned int*) REGSRAM_151_reg)=data)
+#define set_REGSRAM_152_reg(data)   (*((volatile unsigned int*) REGSRAM_152_reg)=data)
+#define set_REGSRAM_153_reg(data)   (*((volatile unsigned int*) REGSRAM_153_reg)=data)
+#define set_REGSRAM_154_reg(data)   (*((volatile unsigned int*) REGSRAM_154_reg)=data)
+#define set_REGSRAM_155_reg(data)   (*((volatile unsigned int*) REGSRAM_155_reg)=data)
+#define set_REGSRAM_156_reg(data)   (*((volatile unsigned int*) REGSRAM_156_reg)=data)
+#define set_REGSRAM_157_reg(data)   (*((volatile unsigned int*) REGSRAM_157_reg)=data)
+#define set_REGSRAM_158_reg(data)   (*((volatile unsigned int*) REGSRAM_158_reg)=data)
+#define set_REGSRAM_159_reg(data)   (*((volatile unsigned int*) REGSRAM_159_reg)=data)
+#define set_REGSRAM_160_reg(data)   (*((volatile unsigned int*) REGSRAM_160_reg)=data)
+#define set_REGSRAM_161_reg(data)   (*((volatile unsigned int*) REGSRAM_161_reg)=data)
+#define set_REGSRAM_162_reg(data)   (*((volatile unsigned int*) REGSRAM_162_reg)=data)
+#define set_REGSRAM_163_reg(data)   (*((volatile unsigned int*) REGSRAM_163_reg)=data)
+#define set_REGSRAM_164_reg(data)   (*((volatile unsigned int*) REGSRAM_164_reg)=data)
+#define set_REGSRAM_165_reg(data)   (*((volatile unsigned int*) REGSRAM_165_reg)=data)
+#define set_REGSRAM_166_reg(data)   (*((volatile unsigned int*) REGSRAM_166_reg)=data)
+#define set_REGSRAM_167_reg(data)   (*((volatile unsigned int*) REGSRAM_167_reg)=data)
+#define set_REGSRAM_168_reg(data)   (*((volatile unsigned int*) REGSRAM_168_reg)=data)
+#define set_REGSRAM_169_reg(data)   (*((volatile unsigned int*) REGSRAM_169_reg)=data)
+#define set_REGSRAM_170_reg(data)   (*((volatile unsigned int*) REGSRAM_170_reg)=data)
+#define set_REGSRAM_171_reg(data)   (*((volatile unsigned int*) REGSRAM_171_reg)=data)
+#define set_REGSRAM_172_reg(data)   (*((volatile unsigned int*) REGSRAM_172_reg)=data)
+#define set_REGSRAM_173_reg(data)   (*((volatile unsigned int*) REGSRAM_173_reg)=data)
+#define set_REGSRAM_174_reg(data)   (*((volatile unsigned int*) REGSRAM_174_reg)=data)
+#define set_REGSRAM_175_reg(data)   (*((volatile unsigned int*) REGSRAM_175_reg)=data)
+#define set_REGSRAM_176_reg(data)   (*((volatile unsigned int*) REGSRAM_176_reg)=data)
+#define set_REGSRAM_177_reg(data)   (*((volatile unsigned int*) REGSRAM_177_reg)=data)
+#define set_REGSRAM_178_reg(data)   (*((volatile unsigned int*) REGSRAM_178_reg)=data)
+#define set_REGSRAM_179_reg(data)   (*((volatile unsigned int*) REGSRAM_179_reg)=data)
+#define set_REGSRAM_180_reg(data)   (*((volatile unsigned int*) REGSRAM_180_reg)=data)
+#define set_REGSRAM_181_reg(data)   (*((volatile unsigned int*) REGSRAM_181_reg)=data)
+#define set_REGSRAM_182_reg(data)   (*((volatile unsigned int*) REGSRAM_182_reg)=data)
+#define set_REGSRAM_183_reg(data)   (*((volatile unsigned int*) REGSRAM_183_reg)=data)
+#define set_REGSRAM_184_reg(data)   (*((volatile unsigned int*) REGSRAM_184_reg)=data)
+#define set_REGSRAM_185_reg(data)   (*((volatile unsigned int*) REGSRAM_185_reg)=data)
+#define set_REGSRAM_186_reg(data)   (*((volatile unsigned int*) REGSRAM_186_reg)=data)
+#define set_REGSRAM_187_reg(data)   (*((volatile unsigned int*) REGSRAM_187_reg)=data)
+#define set_REGSRAM_188_reg(data)   (*((volatile unsigned int*) REGSRAM_188_reg)=data)
+#define set_REGSRAM_189_reg(data)   (*((volatile unsigned int*) REGSRAM_189_reg)=data)
+#define set_REGSRAM_190_reg(data)   (*((volatile unsigned int*) REGSRAM_190_reg)=data)
+#define set_REGSRAM_191_reg(data)   (*((volatile unsigned int*) REGSRAM_191_reg)=data)
+#define set_REGSRAM_192_reg(data)   (*((volatile unsigned int*) REGSRAM_192_reg)=data)
+#define set_REGSRAM_193_reg(data)   (*((volatile unsigned int*) REGSRAM_193_reg)=data)
+#define set_REGSRAM_194_reg(data)   (*((volatile unsigned int*) REGSRAM_194_reg)=data)
+#define set_REGSRAM_195_reg(data)   (*((volatile unsigned int*) REGSRAM_195_reg)=data)
+#define set_REGSRAM_196_reg(data)   (*((volatile unsigned int*) REGSRAM_196_reg)=data)
+#define set_REGSRAM_197_reg(data)   (*((volatile unsigned int*) REGSRAM_197_reg)=data)
+#define set_REGSRAM_198_reg(data)   (*((volatile unsigned int*) REGSRAM_198_reg)=data)
+#define set_REGSRAM_199_reg(data)   (*((volatile unsigned int*) REGSRAM_199_reg)=data)
+#define set_REGSRAM_200_reg(data)   (*((volatile unsigned int*) REGSRAM_200_reg)=data)
+#define set_REGSRAM_201_reg(data)   (*((volatile unsigned int*) REGSRAM_201_reg)=data)
+#define set_REGSRAM_202_reg(data)   (*((volatile unsigned int*) REGSRAM_202_reg)=data)
+#define set_REGSRAM_203_reg(data)   (*((volatile unsigned int*) REGSRAM_203_reg)=data)
+#define set_REGSRAM_204_reg(data)   (*((volatile unsigned int*) REGSRAM_204_reg)=data)
+#define set_REGSRAM_205_reg(data)   (*((volatile unsigned int*) REGSRAM_205_reg)=data)
+#define set_REGSRAM_206_reg(data)   (*((volatile unsigned int*) REGSRAM_206_reg)=data)
+#define set_REGSRAM_207_reg(data)   (*((volatile unsigned int*) REGSRAM_207_reg)=data)
+#define set_REGSRAM_208_reg(data)   (*((volatile unsigned int*) REGSRAM_208_reg)=data)
+#define set_REGSRAM_209_reg(data)   (*((volatile unsigned int*) REGSRAM_209_reg)=data)
+#define set_REGSRAM_210_reg(data)   (*((volatile unsigned int*) REGSRAM_210_reg)=data)
+#define set_REGSRAM_211_reg(data)   (*((volatile unsigned int*) REGSRAM_211_reg)=data)
+#define set_REGSRAM_212_reg(data)   (*((volatile unsigned int*) REGSRAM_212_reg)=data)
+#define set_REGSRAM_213_reg(data)   (*((volatile unsigned int*) REGSRAM_213_reg)=data)
+#define set_REGSRAM_214_reg(data)   (*((volatile unsigned int*) REGSRAM_214_reg)=data)
+#define set_REGSRAM_215_reg(data)   (*((volatile unsigned int*) REGSRAM_215_reg)=data)
+#define set_REGSRAM_216_reg(data)   (*((volatile unsigned int*) REGSRAM_216_reg)=data)
+#define set_REGSRAM_217_reg(data)   (*((volatile unsigned int*) REGSRAM_217_reg)=data)
+#define set_REGSRAM_218_reg(data)   (*((volatile unsigned int*) REGSRAM_218_reg)=data)
+#define set_REGSRAM_219_reg(data)   (*((volatile unsigned int*) REGSRAM_219_reg)=data)
+#define set_REGSRAM_220_reg(data)   (*((volatile unsigned int*) REGSRAM_220_reg)=data)
+#define set_REGSRAM_221_reg(data)   (*((volatile unsigned int*) REGSRAM_221_reg)=data)
+#define set_REGSRAM_222_reg(data)   (*((volatile unsigned int*) REGSRAM_222_reg)=data)
+#define set_REGSRAM_223_reg(data)   (*((volatile unsigned int*) REGSRAM_223_reg)=data)
+#define set_REGSRAM_224_reg(data)   (*((volatile unsigned int*) REGSRAM_224_reg)=data)
+#define set_REGSRAM_225_reg(data)   (*((volatile unsigned int*) REGSRAM_225_reg)=data)
+#define set_REGSRAM_226_reg(data)   (*((volatile unsigned int*) REGSRAM_226_reg)=data)
+#define set_REGSRAM_227_reg(data)   (*((volatile unsigned int*) REGSRAM_227_reg)=data)
+#define set_REGSRAM_228_reg(data)   (*((volatile unsigned int*) REGSRAM_228_reg)=data)
+#define set_REGSRAM_229_reg(data)   (*((volatile unsigned int*) REGSRAM_229_reg)=data)
+#define set_REGSRAM_230_reg(data)   (*((volatile unsigned int*) REGSRAM_230_reg)=data)
+#define set_REGSRAM_231_reg(data)   (*((volatile unsigned int*) REGSRAM_231_reg)=data)
+#define set_REGSRAM_232_reg(data)   (*((volatile unsigned int*) REGSRAM_232_reg)=data)
+#define set_REGSRAM_233_reg(data)   (*((volatile unsigned int*) REGSRAM_233_reg)=data)
+#define set_REGSRAM_234_reg(data)   (*((volatile unsigned int*) REGSRAM_234_reg)=data)
+#define set_REGSRAM_235_reg(data)   (*((volatile unsigned int*) REGSRAM_235_reg)=data)
+#define set_REGSRAM_236_reg(data)   (*((volatile unsigned int*) REGSRAM_236_reg)=data)
+#define set_REGSRAM_237_reg(data)   (*((volatile unsigned int*) REGSRAM_237_reg)=data)
+#define set_REGSRAM_238_reg(data)   (*((volatile unsigned int*) REGSRAM_238_reg)=data)
+#define set_REGSRAM_239_reg(data)   (*((volatile unsigned int*) REGSRAM_239_reg)=data)
+#define set_REGSRAM_240_reg(data)   (*((volatile unsigned int*) REGSRAM_240_reg)=data)
+#define set_REGSRAM_241_reg(data)   (*((volatile unsigned int*) REGSRAM_241_reg)=data)
+#define set_REGSRAM_242_reg(data)   (*((volatile unsigned int*) REGSRAM_242_reg)=data)
+#define set_REGSRAM_243_reg(data)   (*((volatile unsigned int*) REGSRAM_243_reg)=data)
+#define set_REGSRAM_244_reg(data)   (*((volatile unsigned int*) REGSRAM_244_reg)=data)
+#define set_REGSRAM_245_reg(data)   (*((volatile unsigned int*) REGSRAM_245_reg)=data)
+#define set_REGSRAM_246_reg(data)   (*((volatile unsigned int*) REGSRAM_246_reg)=data)
+#define set_REGSRAM_247_reg(data)   (*((volatile unsigned int*) REGSRAM_247_reg)=data)
+#define set_REGSRAM_248_reg(data)   (*((volatile unsigned int*) REGSRAM_248_reg)=data)
+#define set_REGSRAM_249_reg(data)   (*((volatile unsigned int*) REGSRAM_249_reg)=data)
+#define set_REGSRAM_250_reg(data)   (*((volatile unsigned int*) REGSRAM_250_reg)=data)
+#define set_REGSRAM_251_reg(data)   (*((volatile unsigned int*) REGSRAM_251_reg)=data)
+#define set_REGSRAM_252_reg(data)   (*((volatile unsigned int*) REGSRAM_252_reg)=data)
+#define set_REGSRAM_253_reg(data)   (*((volatile unsigned int*) REGSRAM_253_reg)=data)
+#define set_REGSRAM_254_reg(data)   (*((volatile unsigned int*) REGSRAM_254_reg)=data)
+#define set_REGSRAM_255_reg(data)   (*((volatile unsigned int*) REGSRAM_255_reg)=data)
+#define set_REGSRAM_256_reg(data)   (*((volatile unsigned int*) REGSRAM_256_reg)=data)
+#define set_REGSRAM_257_reg(data)   (*((volatile unsigned int*) REGSRAM_257_reg)=data)
+#define set_REGSRAM_258_reg(data)   (*((volatile unsigned int*) REGSRAM_258_reg)=data)
+#define set_REGSRAM_259_reg(data)   (*((volatile unsigned int*) REGSRAM_259_reg)=data)
+#define set_REGSRAM_260_reg(data)   (*((volatile unsigned int*) REGSRAM_260_reg)=data)
+#define set_REGSRAM_261_reg(data)   (*((volatile unsigned int*) REGSRAM_261_reg)=data)
+#define set_REGSRAM_262_reg(data)   (*((volatile unsigned int*) REGSRAM_262_reg)=data)
+#define set_REGSRAM_263_reg(data)   (*((volatile unsigned int*) REGSRAM_263_reg)=data)
+#define set_REGSRAM_264_reg(data)   (*((volatile unsigned int*) REGSRAM_264_reg)=data)
+#define set_REGSRAM_265_reg(data)   (*((volatile unsigned int*) REGSRAM_265_reg)=data)
+#define set_REGSRAM_266_reg(data)   (*((volatile unsigned int*) REGSRAM_266_reg)=data)
+#define set_REGSRAM_267_reg(data)   (*((volatile unsigned int*) REGSRAM_267_reg)=data)
+#define set_REGSRAM_268_reg(data)   (*((volatile unsigned int*) REGSRAM_268_reg)=data)
+#define set_REGSRAM_269_reg(data)   (*((volatile unsigned int*) REGSRAM_269_reg)=data)
+#define set_REGSRAM_270_reg(data)   (*((volatile unsigned int*) REGSRAM_270_reg)=data)
+#define set_REGSRAM_271_reg(data)   (*((volatile unsigned int*) REGSRAM_271_reg)=data)
+#define set_REGSRAM_272_reg(data)   (*((volatile unsigned int*) REGSRAM_272_reg)=data)
+#define set_REGSRAM_273_reg(data)   (*((volatile unsigned int*) REGSRAM_273_reg)=data)
+#define set_REGSRAM_274_reg(data)   (*((volatile unsigned int*) REGSRAM_274_reg)=data)
+#define set_REGSRAM_275_reg(data)   (*((volatile unsigned int*) REGSRAM_275_reg)=data)
+#define set_REGSRAM_276_reg(data)   (*((volatile unsigned int*) REGSRAM_276_reg)=data)
+#define set_REGSRAM_277_reg(data)   (*((volatile unsigned int*) REGSRAM_277_reg)=data)
+#define set_REGSRAM_278_reg(data)   (*((volatile unsigned int*) REGSRAM_278_reg)=data)
+#define set_REGSRAM_279_reg(data)   (*((volatile unsigned int*) REGSRAM_279_reg)=data)
+#define set_REGSRAM_280_reg(data)   (*((volatile unsigned int*) REGSRAM_280_reg)=data)
+#define set_REGSRAM_281_reg(data)   (*((volatile unsigned int*) REGSRAM_281_reg)=data)
+#define set_REGSRAM_282_reg(data)   (*((volatile unsigned int*) REGSRAM_282_reg)=data)
+#define set_REGSRAM_283_reg(data)   (*((volatile unsigned int*) REGSRAM_283_reg)=data)
+#define set_REGSRAM_284_reg(data)   (*((volatile unsigned int*) REGSRAM_284_reg)=data)
+#define set_REGSRAM_285_reg(data)   (*((volatile unsigned int*) REGSRAM_285_reg)=data)
+#define set_REGSRAM_286_reg(data)   (*((volatile unsigned int*) REGSRAM_286_reg)=data)
+#define set_REGSRAM_287_reg(data)   (*((volatile unsigned int*) REGSRAM_287_reg)=data)
+#define set_REGSRAM_288_reg(data)   (*((volatile unsigned int*) REGSRAM_288_reg)=data)
+#define set_REGSRAM_289_reg(data)   (*((volatile unsigned int*) REGSRAM_289_reg)=data)
+#define set_REGSRAM_290_reg(data)   (*((volatile unsigned int*) REGSRAM_290_reg)=data)
+#define set_REGSRAM_291_reg(data)   (*((volatile unsigned int*) REGSRAM_291_reg)=data)
+#define set_REGSRAM_292_reg(data)   (*((volatile unsigned int*) REGSRAM_292_reg)=data)
+#define set_REGSRAM_293_reg(data)   (*((volatile unsigned int*) REGSRAM_293_reg)=data)
+#define set_REGSRAM_294_reg(data)   (*((volatile unsigned int*) REGSRAM_294_reg)=data)
+#define set_REGSRAM_295_reg(data)   (*((volatile unsigned int*) REGSRAM_295_reg)=data)
+#define set_REGSRAM_296_reg(data)   (*((volatile unsigned int*) REGSRAM_296_reg)=data)
+#define set_REGSRAM_297_reg(data)   (*((volatile unsigned int*) REGSRAM_297_reg)=data)
+#define set_REGSRAM_298_reg(data)   (*((volatile unsigned int*) REGSRAM_298_reg)=data)
+#define set_REGSRAM_299_reg(data)   (*((volatile unsigned int*) REGSRAM_299_reg)=data)
+#define set_REGSRAM_300_reg(data)   (*((volatile unsigned int*) REGSRAM_300_reg)=data)
+#define set_REGSRAM_301_reg(data)   (*((volatile unsigned int*) REGSRAM_301_reg)=data)
+#define set_REGSRAM_302_reg(data)   (*((volatile unsigned int*) REGSRAM_302_reg)=data)
+#define set_REGSRAM_303_reg(data)   (*((volatile unsigned int*) REGSRAM_303_reg)=data)
+#define set_REGSRAM_304_reg(data)   (*((volatile unsigned int*) REGSRAM_304_reg)=data)
+#define set_REGSRAM_305_reg(data)   (*((volatile unsigned int*) REGSRAM_305_reg)=data)
+#define set_REGSRAM_306_reg(data)   (*((volatile unsigned int*) REGSRAM_306_reg)=data)
+#define set_REGSRAM_307_reg(data)   (*((volatile unsigned int*) REGSRAM_307_reg)=data)
+#define set_REGSRAM_308_reg(data)   (*((volatile unsigned int*) REGSRAM_308_reg)=data)
+#define set_REGSRAM_309_reg(data)   (*((volatile unsigned int*) REGSRAM_309_reg)=data)
+#define set_REGSRAM_310_reg(data)   (*((volatile unsigned int*) REGSRAM_310_reg)=data)
+#define set_REGSRAM_311_reg(data)   (*((volatile unsigned int*) REGSRAM_311_reg)=data)
+#define set_REGSRAM_312_reg(data)   (*((volatile unsigned int*) REGSRAM_312_reg)=data)
+#define set_REGSRAM_313_reg(data)   (*((volatile unsigned int*) REGSRAM_313_reg)=data)
+#define set_REGSRAM_314_reg(data)   (*((volatile unsigned int*) REGSRAM_314_reg)=data)
+#define set_REGSRAM_315_reg(data)   (*((volatile unsigned int*) REGSRAM_315_reg)=data)
+#define set_REGSRAM_316_reg(data)   (*((volatile unsigned int*) REGSRAM_316_reg)=data)
+#define set_REGSRAM_317_reg(data)   (*((volatile unsigned int*) REGSRAM_317_reg)=data)
+#define set_REGSRAM_318_reg(data)   (*((volatile unsigned int*) REGSRAM_318_reg)=data)
+#define set_REGSRAM_319_reg(data)   (*((volatile unsigned int*) REGSRAM_319_reg)=data)
+#define set_REGSRAM_320_reg(data)   (*((volatile unsigned int*) REGSRAM_320_reg)=data)
+#define set_REGSRAM_321_reg(data)   (*((volatile unsigned int*) REGSRAM_321_reg)=data)
+#define set_REGSRAM_322_reg(data)   (*((volatile unsigned int*) REGSRAM_322_reg)=data)
+#define set_REGSRAM_323_reg(data)   (*((volatile unsigned int*) REGSRAM_323_reg)=data)
+#define set_REGSRAM_324_reg(data)   (*((volatile unsigned int*) REGSRAM_324_reg)=data)
+#define set_REGSRAM_325_reg(data)   (*((volatile unsigned int*) REGSRAM_325_reg)=data)
+#define set_REGSRAM_326_reg(data)   (*((volatile unsigned int*) REGSRAM_326_reg)=data)
+#define set_REGSRAM_327_reg(data)   (*((volatile unsigned int*) REGSRAM_327_reg)=data)
+#define set_REGSRAM_328_reg(data)   (*((volatile unsigned int*) REGSRAM_328_reg)=data)
+#define set_REGSRAM_329_reg(data)   (*((volatile unsigned int*) REGSRAM_329_reg)=data)
+#define set_REGSRAM_330_reg(data)   (*((volatile unsigned int*) REGSRAM_330_reg)=data)
+#define set_REGSRAM_331_reg(data)   (*((volatile unsigned int*) REGSRAM_331_reg)=data)
+#define set_REGSRAM_332_reg(data)   (*((volatile unsigned int*) REGSRAM_332_reg)=data)
+#define set_REGSRAM_333_reg(data)   (*((volatile unsigned int*) REGSRAM_333_reg)=data)
+#define set_REGSRAM_334_reg(data)   (*((volatile unsigned int*) REGSRAM_334_reg)=data)
+#define set_REGSRAM_335_reg(data)   (*((volatile unsigned int*) REGSRAM_335_reg)=data)
+#define set_REGSRAM_336_reg(data)   (*((volatile unsigned int*) REGSRAM_336_reg)=data)
+#define set_REGSRAM_337_reg(data)   (*((volatile unsigned int*) REGSRAM_337_reg)=data)
+#define set_REGSRAM_338_reg(data)   (*((volatile unsigned int*) REGSRAM_338_reg)=data)
+#define set_REGSRAM_339_reg(data)   (*((volatile unsigned int*) REGSRAM_339_reg)=data)
+#define set_REGSRAM_340_reg(data)   (*((volatile unsigned int*) REGSRAM_340_reg)=data)
+#define set_REGSRAM_341_reg(data)   (*((volatile unsigned int*) REGSRAM_341_reg)=data)
+#define set_REGSRAM_342_reg(data)   (*((volatile unsigned int*) REGSRAM_342_reg)=data)
+#define set_REGSRAM_343_reg(data)   (*((volatile unsigned int*) REGSRAM_343_reg)=data)
+#define set_REGSRAM_344_reg(data)   (*((volatile unsigned int*) REGSRAM_344_reg)=data)
+#define set_REGSRAM_345_reg(data)   (*((volatile unsigned int*) REGSRAM_345_reg)=data)
+#define set_REGSRAM_346_reg(data)   (*((volatile unsigned int*) REGSRAM_346_reg)=data)
+#define set_REGSRAM_347_reg(data)   (*((volatile unsigned int*) REGSRAM_347_reg)=data)
+#define set_REGSRAM_348_reg(data)   (*((volatile unsigned int*) REGSRAM_348_reg)=data)
+#define set_REGSRAM_349_reg(data)   (*((volatile unsigned int*) REGSRAM_349_reg)=data)
+#define set_REGSRAM_350_reg(data)   (*((volatile unsigned int*) REGSRAM_350_reg)=data)
+#define set_REGSRAM_351_reg(data)   (*((volatile unsigned int*) REGSRAM_351_reg)=data)
+#define set_REGSRAM_352_reg(data)   (*((volatile unsigned int*) REGSRAM_352_reg)=data)
+#define set_REGSRAM_353_reg(data)   (*((volatile unsigned int*) REGSRAM_353_reg)=data)
+#define set_REGSRAM_354_reg(data)   (*((volatile unsigned int*) REGSRAM_354_reg)=data)
+#define set_REGSRAM_355_reg(data)   (*((volatile unsigned int*) REGSRAM_355_reg)=data)
+#define set_REGSRAM_356_reg(data)   (*((volatile unsigned int*) REGSRAM_356_reg)=data)
+#define set_REGSRAM_357_reg(data)   (*((volatile unsigned int*) REGSRAM_357_reg)=data)
+#define set_REGSRAM_358_reg(data)   (*((volatile unsigned int*) REGSRAM_358_reg)=data)
+#define set_REGSRAM_359_reg(data)   (*((volatile unsigned int*) REGSRAM_359_reg)=data)
+#define set_REGSRAM_360_reg(data)   (*((volatile unsigned int*) REGSRAM_360_reg)=data)
+#define set_REGSRAM_361_reg(data)   (*((volatile unsigned int*) REGSRAM_361_reg)=data)
+#define set_REGSRAM_362_reg(data)   (*((volatile unsigned int*) REGSRAM_362_reg)=data)
+#define set_REGSRAM_363_reg(data)   (*((volatile unsigned int*) REGSRAM_363_reg)=data)
+#define set_REGSRAM_364_reg(data)   (*((volatile unsigned int*) REGSRAM_364_reg)=data)
+#define set_REGSRAM_365_reg(data)   (*((volatile unsigned int*) REGSRAM_365_reg)=data)
+#define set_REGSRAM_366_reg(data)   (*((volatile unsigned int*) REGSRAM_366_reg)=data)
+#define set_REGSRAM_367_reg(data)   (*((volatile unsigned int*) REGSRAM_367_reg)=data)
+#define set_REGSRAM_368_reg(data)   (*((volatile unsigned int*) REGSRAM_368_reg)=data)
+#define set_REGSRAM_369_reg(data)   (*((volatile unsigned int*) REGSRAM_369_reg)=data)
+#define set_REGSRAM_370_reg(data)   (*((volatile unsigned int*) REGSRAM_370_reg)=data)
+#define set_REGSRAM_371_reg(data)   (*((volatile unsigned int*) REGSRAM_371_reg)=data)
+#define set_REGSRAM_372_reg(data)   (*((volatile unsigned int*) REGSRAM_372_reg)=data)
+#define set_REGSRAM_373_reg(data)   (*((volatile unsigned int*) REGSRAM_373_reg)=data)
+#define set_REGSRAM_374_reg(data)   (*((volatile unsigned int*) REGSRAM_374_reg)=data)
+#define set_REGSRAM_375_reg(data)   (*((volatile unsigned int*) REGSRAM_375_reg)=data)
+#define set_REGSRAM_376_reg(data)   (*((volatile unsigned int*) REGSRAM_376_reg)=data)
+#define set_REGSRAM_377_reg(data)   (*((volatile unsigned int*) REGSRAM_377_reg)=data)
+#define set_REGSRAM_378_reg(data)   (*((volatile unsigned int*) REGSRAM_378_reg)=data)
+#define set_REGSRAM_379_reg(data)   (*((volatile unsigned int*) REGSRAM_379_reg)=data)
+#define set_REGSRAM_380_reg(data)   (*((volatile unsigned int*) REGSRAM_380_reg)=data)
+#define set_REGSRAM_381_reg(data)   (*((volatile unsigned int*) REGSRAM_381_reg)=data)
+#define set_REGSRAM_382_reg(data)   (*((volatile unsigned int*) REGSRAM_382_reg)=data)
+#define set_REGSRAM_383_reg(data)   (*((volatile unsigned int*) REGSRAM_383_reg)=data)
+#define set_REGSRAM_384_reg(data)   (*((volatile unsigned int*) REGSRAM_384_reg)=data)
+#define set_REGSRAM_385_reg(data)   (*((volatile unsigned int*) REGSRAM_385_reg)=data)
+#define set_REGSRAM_386_reg(data)   (*((volatile unsigned int*) REGSRAM_386_reg)=data)
+#define set_REGSRAM_387_reg(data)   (*((volatile unsigned int*) REGSRAM_387_reg)=data)
+#define set_REGSRAM_388_reg(data)   (*((volatile unsigned int*) REGSRAM_388_reg)=data)
+#define set_REGSRAM_389_reg(data)   (*((volatile unsigned int*) REGSRAM_389_reg)=data)
+#define set_REGSRAM_390_reg(data)   (*((volatile unsigned int*) REGSRAM_390_reg)=data)
+#define set_REGSRAM_391_reg(data)   (*((volatile unsigned int*) REGSRAM_391_reg)=data)
+#define set_REGSRAM_392_reg(data)   (*((volatile unsigned int*) REGSRAM_392_reg)=data)
+#define set_REGSRAM_393_reg(data)   (*((volatile unsigned int*) REGSRAM_393_reg)=data)
+#define set_REGSRAM_394_reg(data)   (*((volatile unsigned int*) REGSRAM_394_reg)=data)
+#define set_REGSRAM_395_reg(data)   (*((volatile unsigned int*) REGSRAM_395_reg)=data)
+#define set_REGSRAM_396_reg(data)   (*((volatile unsigned int*) REGSRAM_396_reg)=data)
+#define set_REGSRAM_397_reg(data)   (*((volatile unsigned int*) REGSRAM_397_reg)=data)
+#define set_REGSRAM_398_reg(data)   (*((volatile unsigned int*) REGSRAM_398_reg)=data)
+#define set_REGSRAM_399_reg(data)   (*((volatile unsigned int*) REGSRAM_399_reg)=data)
+#define set_REGSRAM_400_reg(data)   (*((volatile unsigned int*) REGSRAM_400_reg)=data)
+#define set_REGSRAM_401_reg(data)   (*((volatile unsigned int*) REGSRAM_401_reg)=data)
+#define set_REGSRAM_402_reg(data)   (*((volatile unsigned int*) REGSRAM_402_reg)=data)
+#define set_REGSRAM_403_reg(data)   (*((volatile unsigned int*) REGSRAM_403_reg)=data)
+#define set_REGSRAM_404_reg(data)   (*((volatile unsigned int*) REGSRAM_404_reg)=data)
+#define set_REGSRAM_405_reg(data)   (*((volatile unsigned int*) REGSRAM_405_reg)=data)
+#define set_REGSRAM_406_reg(data)   (*((volatile unsigned int*) REGSRAM_406_reg)=data)
+#define set_REGSRAM_407_reg(data)   (*((volatile unsigned int*) REGSRAM_407_reg)=data)
+#define set_REGSRAM_408_reg(data)   (*((volatile unsigned int*) REGSRAM_408_reg)=data)
+#define set_REGSRAM_409_reg(data)   (*((volatile unsigned int*) REGSRAM_409_reg)=data)
+#define set_REGSRAM_410_reg(data)   (*((volatile unsigned int*) REGSRAM_410_reg)=data)
+#define set_REGSRAM_411_reg(data)   (*((volatile unsigned int*) REGSRAM_411_reg)=data)
+#define set_REGSRAM_412_reg(data)   (*((volatile unsigned int*) REGSRAM_412_reg)=data)
+#define set_REGSRAM_413_reg(data)   (*((volatile unsigned int*) REGSRAM_413_reg)=data)
+#define set_REGSRAM_414_reg(data)   (*((volatile unsigned int*) REGSRAM_414_reg)=data)
+#define set_REGSRAM_415_reg(data)   (*((volatile unsigned int*) REGSRAM_415_reg)=data)
+#define set_REGSRAM_416_reg(data)   (*((volatile unsigned int*) REGSRAM_416_reg)=data)
+#define set_REGSRAM_417_reg(data)   (*((volatile unsigned int*) REGSRAM_417_reg)=data)
+#define set_REGSRAM_418_reg(data)   (*((volatile unsigned int*) REGSRAM_418_reg)=data)
+#define set_REGSRAM_419_reg(data)   (*((volatile unsigned int*) REGSRAM_419_reg)=data)
+#define set_REGSRAM_420_reg(data)   (*((volatile unsigned int*) REGSRAM_420_reg)=data)
+#define set_REGSRAM_421_reg(data)   (*((volatile unsigned int*) REGSRAM_421_reg)=data)
+#define set_REGSRAM_422_reg(data)   (*((volatile unsigned int*) REGSRAM_422_reg)=data)
+#define set_REGSRAM_423_reg(data)   (*((volatile unsigned int*) REGSRAM_423_reg)=data)
+#define set_REGSRAM_424_reg(data)   (*((volatile unsigned int*) REGSRAM_424_reg)=data)
+#define set_REGSRAM_425_reg(data)   (*((volatile unsigned int*) REGSRAM_425_reg)=data)
+#define set_REGSRAM_426_reg(data)   (*((volatile unsigned int*) REGSRAM_426_reg)=data)
+#define set_REGSRAM_427_reg(data)   (*((volatile unsigned int*) REGSRAM_427_reg)=data)
+#define set_REGSRAM_428_reg(data)   (*((volatile unsigned int*) REGSRAM_428_reg)=data)
+#define set_REGSRAM_429_reg(data)   (*((volatile unsigned int*) REGSRAM_429_reg)=data)
+#define set_REGSRAM_430_reg(data)   (*((volatile unsigned int*) REGSRAM_430_reg)=data)
+#define set_REGSRAM_431_reg(data)   (*((volatile unsigned int*) REGSRAM_431_reg)=data)
+#define set_REGSRAM_432_reg(data)   (*((volatile unsigned int*) REGSRAM_432_reg)=data)
+#define set_REGSRAM_433_reg(data)   (*((volatile unsigned int*) REGSRAM_433_reg)=data)
+#define set_REGSRAM_434_reg(data)   (*((volatile unsigned int*) REGSRAM_434_reg)=data)
+#define set_REGSRAM_435_reg(data)   (*((volatile unsigned int*) REGSRAM_435_reg)=data)
+#define set_REGSRAM_436_reg(data)   (*((volatile unsigned int*) REGSRAM_436_reg)=data)
+#define set_REGSRAM_437_reg(data)   (*((volatile unsigned int*) REGSRAM_437_reg)=data)
+#define set_REGSRAM_438_reg(data)   (*((volatile unsigned int*) REGSRAM_438_reg)=data)
+#define set_REGSRAM_439_reg(data)   (*((volatile unsigned int*) REGSRAM_439_reg)=data)
+#define set_REGSRAM_440_reg(data)   (*((volatile unsigned int*) REGSRAM_440_reg)=data)
+#define set_REGSRAM_441_reg(data)   (*((volatile unsigned int*) REGSRAM_441_reg)=data)
+#define set_REGSRAM_442_reg(data)   (*((volatile unsigned int*) REGSRAM_442_reg)=data)
+#define set_REGSRAM_443_reg(data)   (*((volatile unsigned int*) REGSRAM_443_reg)=data)
+#define set_REGSRAM_444_reg(data)   (*((volatile unsigned int*) REGSRAM_444_reg)=data)
+#define set_REGSRAM_445_reg(data)   (*((volatile unsigned int*) REGSRAM_445_reg)=data)
+#define set_REGSRAM_446_reg(data)   (*((volatile unsigned int*) REGSRAM_446_reg)=data)
+#define set_REGSRAM_447_reg(data)   (*((volatile unsigned int*) REGSRAM_447_reg)=data)
+#define set_REGSRAM_448_reg(data)   (*((volatile unsigned int*) REGSRAM_448_reg)=data)
+#define set_REGSRAM_449_reg(data)   (*((volatile unsigned int*) REGSRAM_449_reg)=data)
+#define set_REGSRAM_450_reg(data)   (*((volatile unsigned int*) REGSRAM_450_reg)=data)
+#define set_REGSRAM_451_reg(data)   (*((volatile unsigned int*) REGSRAM_451_reg)=data)
+#define set_REGSRAM_452_reg(data)   (*((volatile unsigned int*) REGSRAM_452_reg)=data)
+#define set_REGSRAM_453_reg(data)   (*((volatile unsigned int*) REGSRAM_453_reg)=data)
+#define set_REGSRAM_454_reg(data)   (*((volatile unsigned int*) REGSRAM_454_reg)=data)
+#define set_REGSRAM_455_reg(data)   (*((volatile unsigned int*) REGSRAM_455_reg)=data)
+#define set_REGSRAM_456_reg(data)   (*((volatile unsigned int*) REGSRAM_456_reg)=data)
+#define set_REGSRAM_457_reg(data)   (*((volatile unsigned int*) REGSRAM_457_reg)=data)
+#define set_REGSRAM_458_reg(data)   (*((volatile unsigned int*) REGSRAM_458_reg)=data)
+#define set_REGSRAM_459_reg(data)   (*((volatile unsigned int*) REGSRAM_459_reg)=data)
+#define set_REGSRAM_460_reg(data)   (*((volatile unsigned int*) REGSRAM_460_reg)=data)
+#define set_REGSRAM_461_reg(data)   (*((volatile unsigned int*) REGSRAM_461_reg)=data)
+#define set_REGSRAM_462_reg(data)   (*((volatile unsigned int*) REGSRAM_462_reg)=data)
+#define set_REGSRAM_463_reg(data)   (*((volatile unsigned int*) REGSRAM_463_reg)=data)
+#define set_REGSRAM_464_reg(data)   (*((volatile unsigned int*) REGSRAM_464_reg)=data)
+#define set_REGSRAM_465_reg(data)   (*((volatile unsigned int*) REGSRAM_465_reg)=data)
+#define set_REGSRAM_466_reg(data)   (*((volatile unsigned int*) REGSRAM_466_reg)=data)
+#define set_REGSRAM_467_reg(data)   (*((volatile unsigned int*) REGSRAM_467_reg)=data)
+#define set_REGSRAM_468_reg(data)   (*((volatile unsigned int*) REGSRAM_468_reg)=data)
+#define set_REGSRAM_469_reg(data)   (*((volatile unsigned int*) REGSRAM_469_reg)=data)
+#define set_REGSRAM_470_reg(data)   (*((volatile unsigned int*) REGSRAM_470_reg)=data)
+#define set_REGSRAM_471_reg(data)   (*((volatile unsigned int*) REGSRAM_471_reg)=data)
+#define set_REGSRAM_472_reg(data)   (*((volatile unsigned int*) REGSRAM_472_reg)=data)
+#define set_REGSRAM_473_reg(data)   (*((volatile unsigned int*) REGSRAM_473_reg)=data)
+#define set_REGSRAM_474_reg(data)   (*((volatile unsigned int*) REGSRAM_474_reg)=data)
+#define set_REGSRAM_475_reg(data)   (*((volatile unsigned int*) REGSRAM_475_reg)=data)
+#define set_REGSRAM_476_reg(data)   (*((volatile unsigned int*) REGSRAM_476_reg)=data)
+#define set_REGSRAM_477_reg(data)   (*((volatile unsigned int*) REGSRAM_477_reg)=data)
+#define set_REGSRAM_478_reg(data)   (*((volatile unsigned int*) REGSRAM_478_reg)=data)
+#define set_REGSRAM_479_reg(data)   (*((volatile unsigned int*) REGSRAM_479_reg)=data)
+#define set_REGSRAM_480_reg(data)   (*((volatile unsigned int*) REGSRAM_480_reg)=data)
+#define set_REGSRAM_481_reg(data)   (*((volatile unsigned int*) REGSRAM_481_reg)=data)
+#define set_REGSRAM_482_reg(data)   (*((volatile unsigned int*) REGSRAM_482_reg)=data)
+#define set_REGSRAM_483_reg(data)   (*((volatile unsigned int*) REGSRAM_483_reg)=data)
+#define set_REGSRAM_484_reg(data)   (*((volatile unsigned int*) REGSRAM_484_reg)=data)
+#define set_REGSRAM_485_reg(data)   (*((volatile unsigned int*) REGSRAM_485_reg)=data)
+#define set_REGSRAM_486_reg(data)   (*((volatile unsigned int*) REGSRAM_486_reg)=data)
+#define set_REGSRAM_487_reg(data)   (*((volatile unsigned int*) REGSRAM_487_reg)=data)
+#define set_REGSRAM_488_reg(data)   (*((volatile unsigned int*) REGSRAM_488_reg)=data)
+#define set_REGSRAM_489_reg(data)   (*((volatile unsigned int*) REGSRAM_489_reg)=data)
+#define set_REGSRAM_490_reg(data)   (*((volatile unsigned int*) REGSRAM_490_reg)=data)
+#define set_REGSRAM_491_reg(data)   (*((volatile unsigned int*) REGSRAM_491_reg)=data)
+#define set_REGSRAM_492_reg(data)   (*((volatile unsigned int*) REGSRAM_492_reg)=data)
+#define set_REGSRAM_493_reg(data)   (*((volatile unsigned int*) REGSRAM_493_reg)=data)
+#define set_REGSRAM_494_reg(data)   (*((volatile unsigned int*) REGSRAM_494_reg)=data)
+#define set_REGSRAM_495_reg(data)   (*((volatile unsigned int*) REGSRAM_495_reg)=data)
+#define set_REGSRAM_496_reg(data)   (*((volatile unsigned int*) REGSRAM_496_reg)=data)
+#define set_REGSRAM_497_reg(data)   (*((volatile unsigned int*) REGSRAM_497_reg)=data)
+#define set_REGSRAM_498_reg(data)   (*((volatile unsigned int*) REGSRAM_498_reg)=data)
+#define set_REGSRAM_499_reg(data)   (*((volatile unsigned int*) REGSRAM_499_reg)=data)
+#define set_REGSRAM_500_reg(data)   (*((volatile unsigned int*) REGSRAM_500_reg)=data)
+#define set_REGSRAM_501_reg(data)   (*((volatile unsigned int*) REGSRAM_501_reg)=data)
+#define set_REGSRAM_502_reg(data)   (*((volatile unsigned int*) REGSRAM_502_reg)=data)
+#define set_REGSRAM_503_reg(data)   (*((volatile unsigned int*) REGSRAM_503_reg)=data)
+#define set_REGSRAM_504_reg(data)   (*((volatile unsigned int*) REGSRAM_504_reg)=data)
+#define set_REGSRAM_505_reg(data)   (*((volatile unsigned int*) REGSRAM_505_reg)=data)
+#define set_REGSRAM_506_reg(data)   (*((volatile unsigned int*) REGSRAM_506_reg)=data)
+#define set_REGSRAM_507_reg(data)   (*((volatile unsigned int*) REGSRAM_507_reg)=data)
+#define set_REGSRAM_508_reg(data)   (*((volatile unsigned int*) REGSRAM_508_reg)=data)
+#define set_REGSRAM_509_reg(data)   (*((volatile unsigned int*) REGSRAM_509_reg)=data)
+#define set_REGSRAM_510_reg(data)   (*((volatile unsigned int*) REGSRAM_510_reg)=data)
+#define set_REGSRAM_511_reg(data)   (*((volatile unsigned int*) REGSRAM_511_reg)=data)
+#define set_REGSRAM_512_reg(data)   (*((volatile unsigned int*) REGSRAM_512_reg)=data)
+#define set_REGSRAM_513_reg(data)   (*((volatile unsigned int*) REGSRAM_513_reg)=data)
+#define set_REGSRAM_514_reg(data)   (*((volatile unsigned int*) REGSRAM_514_reg)=data)
+#define set_REGSRAM_515_reg(data)   (*((volatile unsigned int*) REGSRAM_515_reg)=data)
+#define set_REGSRAM_516_reg(data)   (*((volatile unsigned int*) REGSRAM_516_reg)=data)
+#define set_REGSRAM_517_reg(data)   (*((volatile unsigned int*) REGSRAM_517_reg)=data)
+#define set_REGSRAM_518_reg(data)   (*((volatile unsigned int*) REGSRAM_518_reg)=data)
+#define set_REGSRAM_519_reg(data)   (*((volatile unsigned int*) REGSRAM_519_reg)=data)
+#define set_REGSRAM_520_reg(data)   (*((volatile unsigned int*) REGSRAM_520_reg)=data)
+#define set_REGSRAM_521_reg(data)   (*((volatile unsigned int*) REGSRAM_521_reg)=data)
+#define set_REGSRAM_522_reg(data)   (*((volatile unsigned int*) REGSRAM_522_reg)=data)
+#define set_REGSRAM_523_reg(data)   (*((volatile unsigned int*) REGSRAM_523_reg)=data)
+#define set_REGSRAM_524_reg(data)   (*((volatile unsigned int*) REGSRAM_524_reg)=data)
+#define set_REGSRAM_525_reg(data)   (*((volatile unsigned int*) REGSRAM_525_reg)=data)
+#define set_REGSRAM_526_reg(data)   (*((volatile unsigned int*) REGSRAM_526_reg)=data)
+#define set_REGSRAM_527_reg(data)   (*((volatile unsigned int*) REGSRAM_527_reg)=data)
+#define set_REGSRAM_528_reg(data)   (*((volatile unsigned int*) REGSRAM_528_reg)=data)
+#define set_REGSRAM_529_reg(data)   (*((volatile unsigned int*) REGSRAM_529_reg)=data)
+#define set_REGSRAM_530_reg(data)   (*((volatile unsigned int*) REGSRAM_530_reg)=data)
+#define set_REGSRAM_531_reg(data)   (*((volatile unsigned int*) REGSRAM_531_reg)=data)
+#define set_REGSRAM_532_reg(data)   (*((volatile unsigned int*) REGSRAM_532_reg)=data)
+#define set_REGSRAM_533_reg(data)   (*((volatile unsigned int*) REGSRAM_533_reg)=data)
+#define set_REGSRAM_534_reg(data)   (*((volatile unsigned int*) REGSRAM_534_reg)=data)
+#define set_REGSRAM_535_reg(data)   (*((volatile unsigned int*) REGSRAM_535_reg)=data)
+#define set_REGSRAM_536_reg(data)   (*((volatile unsigned int*) REGSRAM_536_reg)=data)
+#define set_REGSRAM_537_reg(data)   (*((volatile unsigned int*) REGSRAM_537_reg)=data)
+#define set_REGSRAM_538_reg(data)   (*((volatile unsigned int*) REGSRAM_538_reg)=data)
+#define set_REGSRAM_539_reg(data)   (*((volatile unsigned int*) REGSRAM_539_reg)=data)
+#define set_REGSRAM_540_reg(data)   (*((volatile unsigned int*) REGSRAM_540_reg)=data)
+#define set_REGSRAM_541_reg(data)   (*((volatile unsigned int*) REGSRAM_541_reg)=data)
+#define set_REGSRAM_542_reg(data)   (*((volatile unsigned int*) REGSRAM_542_reg)=data)
+#define set_REGSRAM_543_reg(data)   (*((volatile unsigned int*) REGSRAM_543_reg)=data)
+#define set_REGSRAM_544_reg(data)   (*((volatile unsigned int*) REGSRAM_544_reg)=data)
+#define set_REGSRAM_545_reg(data)   (*((volatile unsigned int*) REGSRAM_545_reg)=data)
+#define set_REGSRAM_546_reg(data)   (*((volatile unsigned int*) REGSRAM_546_reg)=data)
+#define set_REGSRAM_547_reg(data)   (*((volatile unsigned int*) REGSRAM_547_reg)=data)
+#define set_REGSRAM_548_reg(data)   (*((volatile unsigned int*) REGSRAM_548_reg)=data)
+#define set_REGSRAM_549_reg(data)   (*((volatile unsigned int*) REGSRAM_549_reg)=data)
+#define set_REGSRAM_550_reg(data)   (*((volatile unsigned int*) REGSRAM_550_reg)=data)
+#define set_REGSRAM_551_reg(data)   (*((volatile unsigned int*) REGSRAM_551_reg)=data)
+#define set_REGSRAM_552_reg(data)   (*((volatile unsigned int*) REGSRAM_552_reg)=data)
+#define set_REGSRAM_553_reg(data)   (*((volatile unsigned int*) REGSRAM_553_reg)=data)
+#define set_REGSRAM_554_reg(data)   (*((volatile unsigned int*) REGSRAM_554_reg)=data)
+#define set_REGSRAM_555_reg(data)   (*((volatile unsigned int*) REGSRAM_555_reg)=data)
+#define set_REGSRAM_556_reg(data)   (*((volatile unsigned int*) REGSRAM_556_reg)=data)
+#define set_REGSRAM_557_reg(data)   (*((volatile unsigned int*) REGSRAM_557_reg)=data)
+#define set_REGSRAM_558_reg(data)   (*((volatile unsigned int*) REGSRAM_558_reg)=data)
+#define set_REGSRAM_559_reg(data)   (*((volatile unsigned int*) REGSRAM_559_reg)=data)
+#define set_REGSRAM_560_reg(data)   (*((volatile unsigned int*) REGSRAM_560_reg)=data)
+#define set_REGSRAM_561_reg(data)   (*((volatile unsigned int*) REGSRAM_561_reg)=data)
+#define set_REGSRAM_562_reg(data)   (*((volatile unsigned int*) REGSRAM_562_reg)=data)
+#define set_REGSRAM_563_reg(data)   (*((volatile unsigned int*) REGSRAM_563_reg)=data)
+#define set_REGSRAM_564_reg(data)   (*((volatile unsigned int*) REGSRAM_564_reg)=data)
+#define set_REGSRAM_565_reg(data)   (*((volatile unsigned int*) REGSRAM_565_reg)=data)
+#define set_REGSRAM_566_reg(data)   (*((volatile unsigned int*) REGSRAM_566_reg)=data)
+#define set_REGSRAM_567_reg(data)   (*((volatile unsigned int*) REGSRAM_567_reg)=data)
+#define set_REGSRAM_568_reg(data)   (*((volatile unsigned int*) REGSRAM_568_reg)=data)
+#define set_REGSRAM_569_reg(data)   (*((volatile unsigned int*) REGSRAM_569_reg)=data)
+#define set_REGSRAM_570_reg(data)   (*((volatile unsigned int*) REGSRAM_570_reg)=data)
+#define set_REGSRAM_571_reg(data)   (*((volatile unsigned int*) REGSRAM_571_reg)=data)
+#define set_REGSRAM_572_reg(data)   (*((volatile unsigned int*) REGSRAM_572_reg)=data)
+#define set_REGSRAM_573_reg(data)   (*((volatile unsigned int*) REGSRAM_573_reg)=data)
+#define set_REGSRAM_574_reg(data)   (*((volatile unsigned int*) REGSRAM_574_reg)=data)
+#define set_REGSRAM_575_reg(data)   (*((volatile unsigned int*) REGSRAM_575_reg)=data)
+#define set_REGSRAM_576_reg(data)   (*((volatile unsigned int*) REGSRAM_576_reg)=data)
+#define set_REGSRAM_577_reg(data)   (*((volatile unsigned int*) REGSRAM_577_reg)=data)
+#define set_REGSRAM_578_reg(data)   (*((volatile unsigned int*) REGSRAM_578_reg)=data)
+#define set_REGSRAM_579_reg(data)   (*((volatile unsigned int*) REGSRAM_579_reg)=data)
+#define set_REGSRAM_580_reg(data)   (*((volatile unsigned int*) REGSRAM_580_reg)=data)
+#define set_REGSRAM_581_reg(data)   (*((volatile unsigned int*) REGSRAM_581_reg)=data)
+#define set_REGSRAM_582_reg(data)   (*((volatile unsigned int*) REGSRAM_582_reg)=data)
+#define set_REGSRAM_583_reg(data)   (*((volatile unsigned int*) REGSRAM_583_reg)=data)
+#define set_REGSRAM_584_reg(data)   (*((volatile unsigned int*) REGSRAM_584_reg)=data)
+#define set_REGSRAM_585_reg(data)   (*((volatile unsigned int*) REGSRAM_585_reg)=data)
+#define set_REGSRAM_586_reg(data)   (*((volatile unsigned int*) REGSRAM_586_reg)=data)
+#define set_REGSRAM_587_reg(data)   (*((volatile unsigned int*) REGSRAM_587_reg)=data)
+#define set_REGSRAM_588_reg(data)   (*((volatile unsigned int*) REGSRAM_588_reg)=data)
+#define set_REGSRAM_589_reg(data)   (*((volatile unsigned int*) REGSRAM_589_reg)=data)
+#define set_REGSRAM_590_reg(data)   (*((volatile unsigned int*) REGSRAM_590_reg)=data)
+#define set_REGSRAM_591_reg(data)   (*((volatile unsigned int*) REGSRAM_591_reg)=data)
+#define set_REGSRAM_592_reg(data)   (*((volatile unsigned int*) REGSRAM_592_reg)=data)
+#define set_REGSRAM_593_reg(data)   (*((volatile unsigned int*) REGSRAM_593_reg)=data)
+#define set_REGSRAM_594_reg(data)   (*((volatile unsigned int*) REGSRAM_594_reg)=data)
+#define set_REGSRAM_595_reg(data)   (*((volatile unsigned int*) REGSRAM_595_reg)=data)
+#define set_REGSRAM_596_reg(data)   (*((volatile unsigned int*) REGSRAM_596_reg)=data)
+#define set_REGSRAM_597_reg(data)   (*((volatile unsigned int*) REGSRAM_597_reg)=data)
+#define set_REGSRAM_598_reg(data)   (*((volatile unsigned int*) REGSRAM_598_reg)=data)
+#define set_REGSRAM_599_reg(data)   (*((volatile unsigned int*) REGSRAM_599_reg)=data)
+#define set_REGSRAM_600_reg(data)   (*((volatile unsigned int*) REGSRAM_600_reg)=data)
+#define set_REGSRAM_601_reg(data)   (*((volatile unsigned int*) REGSRAM_601_reg)=data)
+#define set_REGSRAM_602_reg(data)   (*((volatile unsigned int*) REGSRAM_602_reg)=data)
+#define set_REGSRAM_603_reg(data)   (*((volatile unsigned int*) REGSRAM_603_reg)=data)
+#define set_REGSRAM_604_reg(data)   (*((volatile unsigned int*) REGSRAM_604_reg)=data)
+#define set_REGSRAM_605_reg(data)   (*((volatile unsigned int*) REGSRAM_605_reg)=data)
+#define set_REGSRAM_606_reg(data)   (*((volatile unsigned int*) REGSRAM_606_reg)=data)
+#define set_REGSRAM_607_reg(data)   (*((volatile unsigned int*) REGSRAM_607_reg)=data)
+#define set_REGSRAM_608_reg(data)   (*((volatile unsigned int*) REGSRAM_608_reg)=data)
+#define set_REGSRAM_609_reg(data)   (*((volatile unsigned int*) REGSRAM_609_reg)=data)
+#define set_REGSRAM_610_reg(data)   (*((volatile unsigned int*) REGSRAM_610_reg)=data)
+#define set_REGSRAM_611_reg(data)   (*((volatile unsigned int*) REGSRAM_611_reg)=data)
+#define set_REGSRAM_612_reg(data)   (*((volatile unsigned int*) REGSRAM_612_reg)=data)
+#define set_REGSRAM_613_reg(data)   (*((volatile unsigned int*) REGSRAM_613_reg)=data)
+#define set_REGSRAM_614_reg(data)   (*((volatile unsigned int*) REGSRAM_614_reg)=data)
+#define set_REGSRAM_615_reg(data)   (*((volatile unsigned int*) REGSRAM_615_reg)=data)
+#define set_REGSRAM_616_reg(data)   (*((volatile unsigned int*) REGSRAM_616_reg)=data)
+#define set_REGSRAM_617_reg(data)   (*((volatile unsigned int*) REGSRAM_617_reg)=data)
+#define set_REGSRAM_618_reg(data)   (*((volatile unsigned int*) REGSRAM_618_reg)=data)
+#define set_REGSRAM_619_reg(data)   (*((volatile unsigned int*) REGSRAM_619_reg)=data)
+#define set_REGSRAM_620_reg(data)   (*((volatile unsigned int*) REGSRAM_620_reg)=data)
+#define set_REGSRAM_621_reg(data)   (*((volatile unsigned int*) REGSRAM_621_reg)=data)
+#define set_REGSRAM_622_reg(data)   (*((volatile unsigned int*) REGSRAM_622_reg)=data)
+#define set_REGSRAM_623_reg(data)   (*((volatile unsigned int*) REGSRAM_623_reg)=data)
+#define set_REGSRAM_624_reg(data)   (*((volatile unsigned int*) REGSRAM_624_reg)=data)
+#define set_REGSRAM_625_reg(data)   (*((volatile unsigned int*) REGSRAM_625_reg)=data)
+#define set_REGSRAM_626_reg(data)   (*((volatile unsigned int*) REGSRAM_626_reg)=data)
+#define set_REGSRAM_627_reg(data)   (*((volatile unsigned int*) REGSRAM_627_reg)=data)
+#define set_REGSRAM_628_reg(data)   (*((volatile unsigned int*) REGSRAM_628_reg)=data)
+#define set_REGSRAM_629_reg(data)   (*((volatile unsigned int*) REGSRAM_629_reg)=data)
+#define set_REGSRAM_630_reg(data)   (*((volatile unsigned int*) REGSRAM_630_reg)=data)
+#define set_REGSRAM_631_reg(data)   (*((volatile unsigned int*) REGSRAM_631_reg)=data)
+#define set_REGSRAM_632_reg(data)   (*((volatile unsigned int*) REGSRAM_632_reg)=data)
+#define set_REGSRAM_633_reg(data)   (*((volatile unsigned int*) REGSRAM_633_reg)=data)
+#define set_REGSRAM_634_reg(data)   (*((volatile unsigned int*) REGSRAM_634_reg)=data)
+#define set_REGSRAM_635_reg(data)   (*((volatile unsigned int*) REGSRAM_635_reg)=data)
+#define set_REGSRAM_636_reg(data)   (*((volatile unsigned int*) REGSRAM_636_reg)=data)
+#define set_REGSRAM_637_reg(data)   (*((volatile unsigned int*) REGSRAM_637_reg)=data)
+#define set_REGSRAM_638_reg(data)   (*((volatile unsigned int*) REGSRAM_638_reg)=data)
+#define set_REGSRAM_639_reg(data)   (*((volatile unsigned int*) REGSRAM_639_reg)=data)
+#define set_REGSRAM_640_reg(data)   (*((volatile unsigned int*) REGSRAM_640_reg)=data)
+#define set_REGSRAM_641_reg(data)   (*((volatile unsigned int*) REGSRAM_641_reg)=data)
+#define set_REGSRAM_642_reg(data)   (*((volatile unsigned int*) REGSRAM_642_reg)=data)
+#define set_REGSRAM_643_reg(data)   (*((volatile unsigned int*) REGSRAM_643_reg)=data)
+#define set_REGSRAM_644_reg(data)   (*((volatile unsigned int*) REGSRAM_644_reg)=data)
+#define set_REGSRAM_645_reg(data)   (*((volatile unsigned int*) REGSRAM_645_reg)=data)
+#define set_REGSRAM_646_reg(data)   (*((volatile unsigned int*) REGSRAM_646_reg)=data)
+#define set_REGSRAM_647_reg(data)   (*((volatile unsigned int*) REGSRAM_647_reg)=data)
+#define set_REGSRAM_648_reg(data)   (*((volatile unsigned int*) REGSRAM_648_reg)=data)
+#define set_REGSRAM_649_reg(data)   (*((volatile unsigned int*) REGSRAM_649_reg)=data)
+#define set_REGSRAM_650_reg(data)   (*((volatile unsigned int*) REGSRAM_650_reg)=data)
+#define set_REGSRAM_651_reg(data)   (*((volatile unsigned int*) REGSRAM_651_reg)=data)
+#define set_REGSRAM_652_reg(data)   (*((volatile unsigned int*) REGSRAM_652_reg)=data)
+#define set_REGSRAM_653_reg(data)   (*((volatile unsigned int*) REGSRAM_653_reg)=data)
+#define set_REGSRAM_654_reg(data)   (*((volatile unsigned int*) REGSRAM_654_reg)=data)
+#define set_REGSRAM_655_reg(data)   (*((volatile unsigned int*) REGSRAM_655_reg)=data)
+#define set_REGSRAM_656_reg(data)   (*((volatile unsigned int*) REGSRAM_656_reg)=data)
+#define set_REGSRAM_657_reg(data)   (*((volatile unsigned int*) REGSRAM_657_reg)=data)
+#define set_REGSRAM_658_reg(data)   (*((volatile unsigned int*) REGSRAM_658_reg)=data)
+#define set_REGSRAM_659_reg(data)   (*((volatile unsigned int*) REGSRAM_659_reg)=data)
+#define set_REGSRAM_660_reg(data)   (*((volatile unsigned int*) REGSRAM_660_reg)=data)
+#define set_REGSRAM_661_reg(data)   (*((volatile unsigned int*) REGSRAM_661_reg)=data)
+#define set_REGSRAM_662_reg(data)   (*((volatile unsigned int*) REGSRAM_662_reg)=data)
+#define set_REGSRAM_663_reg(data)   (*((volatile unsigned int*) REGSRAM_663_reg)=data)
+#define set_REGSRAM_664_reg(data)   (*((volatile unsigned int*) REGSRAM_664_reg)=data)
+#define set_REGSRAM_665_reg(data)   (*((volatile unsigned int*) REGSRAM_665_reg)=data)
+#define set_REGSRAM_666_reg(data)   (*((volatile unsigned int*) REGSRAM_666_reg)=data)
+#define set_REGSRAM_667_reg(data)   (*((volatile unsigned int*) REGSRAM_667_reg)=data)
+#define set_REGSRAM_668_reg(data)   (*((volatile unsigned int*) REGSRAM_668_reg)=data)
+#define set_REGSRAM_669_reg(data)   (*((volatile unsigned int*) REGSRAM_669_reg)=data)
+#define set_REGSRAM_670_reg(data)   (*((volatile unsigned int*) REGSRAM_670_reg)=data)
+#define set_REGSRAM_671_reg(data)   (*((volatile unsigned int*) REGSRAM_671_reg)=data)
+#define set_REGSRAM_672_reg(data)   (*((volatile unsigned int*) REGSRAM_672_reg)=data)
+#define set_REGSRAM_673_reg(data)   (*((volatile unsigned int*) REGSRAM_673_reg)=data)
+#define set_REGSRAM_674_reg(data)   (*((volatile unsigned int*) REGSRAM_674_reg)=data)
+#define set_REGSRAM_675_reg(data)   (*((volatile unsigned int*) REGSRAM_675_reg)=data)
+#define set_REGSRAM_676_reg(data)   (*((volatile unsigned int*) REGSRAM_676_reg)=data)
+#define set_REGSRAM_677_reg(data)   (*((volatile unsigned int*) REGSRAM_677_reg)=data)
+#define set_REGSRAM_678_reg(data)   (*((volatile unsigned int*) REGSRAM_678_reg)=data)
+#define set_REGSRAM_679_reg(data)   (*((volatile unsigned int*) REGSRAM_679_reg)=data)
+#define set_REGSRAM_680_reg(data)   (*((volatile unsigned int*) REGSRAM_680_reg)=data)
+#define set_REGSRAM_681_reg(data)   (*((volatile unsigned int*) REGSRAM_681_reg)=data)
+#define set_REGSRAM_682_reg(data)   (*((volatile unsigned int*) REGSRAM_682_reg)=data)
+#define set_REGSRAM_683_reg(data)   (*((volatile unsigned int*) REGSRAM_683_reg)=data)
+#define set_REGSRAM_684_reg(data)   (*((volatile unsigned int*) REGSRAM_684_reg)=data)
+#define set_REGSRAM_685_reg(data)   (*((volatile unsigned int*) REGSRAM_685_reg)=data)
+#define set_REGSRAM_686_reg(data)   (*((volatile unsigned int*) REGSRAM_686_reg)=data)
+#define set_REGSRAM_687_reg(data)   (*((volatile unsigned int*) REGSRAM_687_reg)=data)
+#define set_REGSRAM_688_reg(data)   (*((volatile unsigned int*) REGSRAM_688_reg)=data)
+#define set_REGSRAM_689_reg(data)   (*((volatile unsigned int*) REGSRAM_689_reg)=data)
+#define set_REGSRAM_690_reg(data)   (*((volatile unsigned int*) REGSRAM_690_reg)=data)
+#define set_REGSRAM_691_reg(data)   (*((volatile unsigned int*) REGSRAM_691_reg)=data)
+#define set_REGSRAM_692_reg(data)   (*((volatile unsigned int*) REGSRAM_692_reg)=data)
+#define set_REGSRAM_693_reg(data)   (*((volatile unsigned int*) REGSRAM_693_reg)=data)
+#define set_REGSRAM_694_reg(data)   (*((volatile unsigned int*) REGSRAM_694_reg)=data)
+#define set_REGSRAM_695_reg(data)   (*((volatile unsigned int*) REGSRAM_695_reg)=data)
+#define set_REGSRAM_696_reg(data)   (*((volatile unsigned int*) REGSRAM_696_reg)=data)
+#define set_REGSRAM_697_reg(data)   (*((volatile unsigned int*) REGSRAM_697_reg)=data)
+#define set_REGSRAM_698_reg(data)   (*((volatile unsigned int*) REGSRAM_698_reg)=data)
+#define set_REGSRAM_699_reg(data)   (*((volatile unsigned int*) REGSRAM_699_reg)=data)
+#define set_REGSRAM_700_reg(data)   (*((volatile unsigned int*) REGSRAM_700_reg)=data)
+#define set_REGSRAM_701_reg(data)   (*((volatile unsigned int*) REGSRAM_701_reg)=data)
+#define set_REGSRAM_702_reg(data)   (*((volatile unsigned int*) REGSRAM_702_reg)=data)
+#define set_REGSRAM_703_reg(data)   (*((volatile unsigned int*) REGSRAM_703_reg)=data)
+#define set_REGSRAM_704_reg(data)   (*((volatile unsigned int*) REGSRAM_704_reg)=data)
+#define set_REGSRAM_705_reg(data)   (*((volatile unsigned int*) REGSRAM_705_reg)=data)
+#define set_REGSRAM_706_reg(data)   (*((volatile unsigned int*) REGSRAM_706_reg)=data)
+#define set_REGSRAM_707_reg(data)   (*((volatile unsigned int*) REGSRAM_707_reg)=data)
+#define set_REGSRAM_708_reg(data)   (*((volatile unsigned int*) REGSRAM_708_reg)=data)
+#define set_REGSRAM_709_reg(data)   (*((volatile unsigned int*) REGSRAM_709_reg)=data)
+#define set_REGSRAM_710_reg(data)   (*((volatile unsigned int*) REGSRAM_710_reg)=data)
+#define set_REGSRAM_711_reg(data)   (*((volatile unsigned int*) REGSRAM_711_reg)=data)
+#define set_REGSRAM_712_reg(data)   (*((volatile unsigned int*) REGSRAM_712_reg)=data)
+#define set_REGSRAM_713_reg(data)   (*((volatile unsigned int*) REGSRAM_713_reg)=data)
+#define set_REGSRAM_714_reg(data)   (*((volatile unsigned int*) REGSRAM_714_reg)=data)
+#define set_REGSRAM_715_reg(data)   (*((volatile unsigned int*) REGSRAM_715_reg)=data)
+#define set_REGSRAM_716_reg(data)   (*((volatile unsigned int*) REGSRAM_716_reg)=data)
+#define set_REGSRAM_717_reg(data)   (*((volatile unsigned int*) REGSRAM_717_reg)=data)
+#define set_REGSRAM_718_reg(data)   (*((volatile unsigned int*) REGSRAM_718_reg)=data)
+#define set_REGSRAM_719_reg(data)   (*((volatile unsigned int*) REGSRAM_719_reg)=data)
+#define set_REGSRAM_720_reg(data)   (*((volatile unsigned int*) REGSRAM_720_reg)=data)
+#define set_REGSRAM_721_reg(data)   (*((volatile unsigned int*) REGSRAM_721_reg)=data)
+#define set_REGSRAM_722_reg(data)   (*((volatile unsigned int*) REGSRAM_722_reg)=data)
+#define set_REGSRAM_723_reg(data)   (*((volatile unsigned int*) REGSRAM_723_reg)=data)
+#define set_REGSRAM_724_reg(data)   (*((volatile unsigned int*) REGSRAM_724_reg)=data)
+#define set_REGSRAM_725_reg(data)   (*((volatile unsigned int*) REGSRAM_725_reg)=data)
+#define set_REGSRAM_726_reg(data)   (*((volatile unsigned int*) REGSRAM_726_reg)=data)
+#define set_REGSRAM_727_reg(data)   (*((volatile unsigned int*) REGSRAM_727_reg)=data)
+#define set_REGSRAM_728_reg(data)   (*((volatile unsigned int*) REGSRAM_728_reg)=data)
+#define set_REGSRAM_729_reg(data)   (*((volatile unsigned int*) REGSRAM_729_reg)=data)
+#define set_REGSRAM_730_reg(data)   (*((volatile unsigned int*) REGSRAM_730_reg)=data)
+#define set_REGSRAM_731_reg(data)   (*((volatile unsigned int*) REGSRAM_731_reg)=data)
+#define set_REGSRAM_732_reg(data)   (*((volatile unsigned int*) REGSRAM_732_reg)=data)
+#define set_REGSRAM_733_reg(data)   (*((volatile unsigned int*) REGSRAM_733_reg)=data)
+#define set_REGSRAM_734_reg(data)   (*((volatile unsigned int*) REGSRAM_734_reg)=data)
+#define set_REGSRAM_735_reg(data)   (*((volatile unsigned int*) REGSRAM_735_reg)=data)
+#define set_REGSRAM_736_reg(data)   (*((volatile unsigned int*) REGSRAM_736_reg)=data)
+#define set_REGSRAM_737_reg(data)   (*((volatile unsigned int*) REGSRAM_737_reg)=data)
+#define set_REGSRAM_738_reg(data)   (*((volatile unsigned int*) REGSRAM_738_reg)=data)
+#define set_REGSRAM_739_reg(data)   (*((volatile unsigned int*) REGSRAM_739_reg)=data)
+#define set_REGSRAM_740_reg(data)   (*((volatile unsigned int*) REGSRAM_740_reg)=data)
+#define set_REGSRAM_741_reg(data)   (*((volatile unsigned int*) REGSRAM_741_reg)=data)
+#define set_REGSRAM_742_reg(data)   (*((volatile unsigned int*) REGSRAM_742_reg)=data)
+#define set_REGSRAM_743_reg(data)   (*((volatile unsigned int*) REGSRAM_743_reg)=data)
+#define set_REGSRAM_744_reg(data)   (*((volatile unsigned int*) REGSRAM_744_reg)=data)
+#define set_REGSRAM_745_reg(data)   (*((volatile unsigned int*) REGSRAM_745_reg)=data)
+#define set_REGSRAM_746_reg(data)   (*((volatile unsigned int*) REGSRAM_746_reg)=data)
+#define set_REGSRAM_747_reg(data)   (*((volatile unsigned int*) REGSRAM_747_reg)=data)
+#define set_REGSRAM_748_reg(data)   (*((volatile unsigned int*) REGSRAM_748_reg)=data)
+#define set_REGSRAM_749_reg(data)   (*((volatile unsigned int*) REGSRAM_749_reg)=data)
+#define set_REGSRAM_750_reg(data)   (*((volatile unsigned int*) REGSRAM_750_reg)=data)
+#define set_REGSRAM_751_reg(data)   (*((volatile unsigned int*) REGSRAM_751_reg)=data)
+#define set_REGSRAM_752_reg(data)   (*((volatile unsigned int*) REGSRAM_752_reg)=data)
+#define set_REGSRAM_753_reg(data)   (*((volatile unsigned int*) REGSRAM_753_reg)=data)
+#define set_REGSRAM_754_reg(data)   (*((volatile unsigned int*) REGSRAM_754_reg)=data)
+#define set_REGSRAM_755_reg(data)   (*((volatile unsigned int*) REGSRAM_755_reg)=data)
+#define set_REGSRAM_756_reg(data)   (*((volatile unsigned int*) REGSRAM_756_reg)=data)
+#define set_REGSRAM_757_reg(data)   (*((volatile unsigned int*) REGSRAM_757_reg)=data)
+#define set_REGSRAM_758_reg(data)   (*((volatile unsigned int*) REGSRAM_758_reg)=data)
+#define set_REGSRAM_759_reg(data)   (*((volatile unsigned int*) REGSRAM_759_reg)=data)
+#define set_REGSRAM_760_reg(data)   (*((volatile unsigned int*) REGSRAM_760_reg)=data)
+#define set_REGSRAM_761_reg(data)   (*((volatile unsigned int*) REGSRAM_761_reg)=data)
+#define set_REGSRAM_762_reg(data)   (*((volatile unsigned int*) REGSRAM_762_reg)=data)
+#define set_REGSRAM_763_reg(data)   (*((volatile unsigned int*) REGSRAM_763_reg)=data)
+#define set_REGSRAM_764_reg(data)   (*((volatile unsigned int*) REGSRAM_764_reg)=data)
+#define set_REGSRAM_765_reg(data)   (*((volatile unsigned int*) REGSRAM_765_reg)=data)
+#define set_REGSRAM_766_reg(data)   (*((volatile unsigned int*) REGSRAM_766_reg)=data)
+#define set_REGSRAM_767_reg(data)   (*((volatile unsigned int*) REGSRAM_767_reg)=data)
+#define set_REGSRAM_768_reg(data)   (*((volatile unsigned int*) REGSRAM_768_reg)=data)
+#define set_REGSRAM_769_reg(data)   (*((volatile unsigned int*) REGSRAM_769_reg)=data)
+#define set_REGSRAM_770_reg(data)   (*((volatile unsigned int*) REGSRAM_770_reg)=data)
+#define set_REGSRAM_771_reg(data)   (*((volatile unsigned int*) REGSRAM_771_reg)=data)
+#define set_REGSRAM_772_reg(data)   (*((volatile unsigned int*) REGSRAM_772_reg)=data)
+#define set_REGSRAM_773_reg(data)   (*((volatile unsigned int*) REGSRAM_773_reg)=data)
+#define set_REGSRAM_774_reg(data)   (*((volatile unsigned int*) REGSRAM_774_reg)=data)
+#define set_REGSRAM_775_reg(data)   (*((volatile unsigned int*) REGSRAM_775_reg)=data)
+#define set_REGSRAM_776_reg(data)   (*((volatile unsigned int*) REGSRAM_776_reg)=data)
+#define set_REGSRAM_777_reg(data)   (*((volatile unsigned int*) REGSRAM_777_reg)=data)
+#define set_REGSRAM_778_reg(data)   (*((volatile unsigned int*) REGSRAM_778_reg)=data)
+#define set_REGSRAM_779_reg(data)   (*((volatile unsigned int*) REGSRAM_779_reg)=data)
+#define set_REGSRAM_780_reg(data)   (*((volatile unsigned int*) REGSRAM_780_reg)=data)
+#define set_REGSRAM_781_reg(data)   (*((volatile unsigned int*) REGSRAM_781_reg)=data)
+#define set_REGSRAM_782_reg(data)   (*((volatile unsigned int*) REGSRAM_782_reg)=data)
+#define set_REGSRAM_783_reg(data)   (*((volatile unsigned int*) REGSRAM_783_reg)=data)
+#define set_REGSRAM_784_reg(data)   (*((volatile unsigned int*) REGSRAM_784_reg)=data)
+#define set_REGSRAM_785_reg(data)   (*((volatile unsigned int*) REGSRAM_785_reg)=data)
+#define set_REGSRAM_786_reg(data)   (*((volatile unsigned int*) REGSRAM_786_reg)=data)
+#define set_REGSRAM_787_reg(data)   (*((volatile unsigned int*) REGSRAM_787_reg)=data)
+#define set_REGSRAM_788_reg(data)   (*((volatile unsigned int*) REGSRAM_788_reg)=data)
+#define set_REGSRAM_789_reg(data)   (*((volatile unsigned int*) REGSRAM_789_reg)=data)
+#define set_REGSRAM_790_reg(data)   (*((volatile unsigned int*) REGSRAM_790_reg)=data)
+#define set_REGSRAM_791_reg(data)   (*((volatile unsigned int*) REGSRAM_791_reg)=data)
+#define set_REGSRAM_792_reg(data)   (*((volatile unsigned int*) REGSRAM_792_reg)=data)
+#define set_REGSRAM_793_reg(data)   (*((volatile unsigned int*) REGSRAM_793_reg)=data)
+#define set_REGSRAM_794_reg(data)   (*((volatile unsigned int*) REGSRAM_794_reg)=data)
+#define set_REGSRAM_795_reg(data)   (*((volatile unsigned int*) REGSRAM_795_reg)=data)
+#define set_REGSRAM_796_reg(data)   (*((volatile unsigned int*) REGSRAM_796_reg)=data)
+#define set_REGSRAM_797_reg(data)   (*((volatile unsigned int*) REGSRAM_797_reg)=data)
+#define set_REGSRAM_798_reg(data)   (*((volatile unsigned int*) REGSRAM_798_reg)=data)
+#define set_REGSRAM_799_reg(data)   (*((volatile unsigned int*) REGSRAM_799_reg)=data)
+#define set_REGSRAM_800_reg(data)   (*((volatile unsigned int*) REGSRAM_800_reg)=data)
+#define set_REGSRAM_801_reg(data)   (*((volatile unsigned int*) REGSRAM_801_reg)=data)
+#define set_REGSRAM_802_reg(data)   (*((volatile unsigned int*) REGSRAM_802_reg)=data)
+#define set_REGSRAM_803_reg(data)   (*((volatile unsigned int*) REGSRAM_803_reg)=data)
+#define set_REGSRAM_804_reg(data)   (*((volatile unsigned int*) REGSRAM_804_reg)=data)
+#define set_REGSRAM_805_reg(data)   (*((volatile unsigned int*) REGSRAM_805_reg)=data)
+#define set_REGSRAM_806_reg(data)   (*((volatile unsigned int*) REGSRAM_806_reg)=data)
+#define set_REGSRAM_807_reg(data)   (*((volatile unsigned int*) REGSRAM_807_reg)=data)
+#define set_REGSRAM_808_reg(data)   (*((volatile unsigned int*) REGSRAM_808_reg)=data)
+#define set_REGSRAM_809_reg(data)   (*((volatile unsigned int*) REGSRAM_809_reg)=data)
+#define set_REGSRAM_810_reg(data)   (*((volatile unsigned int*) REGSRAM_810_reg)=data)
+#define set_REGSRAM_811_reg(data)   (*((volatile unsigned int*) REGSRAM_811_reg)=data)
+#define set_REGSRAM_812_reg(data)   (*((volatile unsigned int*) REGSRAM_812_reg)=data)
+#define set_REGSRAM_813_reg(data)   (*((volatile unsigned int*) REGSRAM_813_reg)=data)
+#define set_REGSRAM_814_reg(data)   (*((volatile unsigned int*) REGSRAM_814_reg)=data)
+#define set_REGSRAM_815_reg(data)   (*((volatile unsigned int*) REGSRAM_815_reg)=data)
+#define set_REGSRAM_816_reg(data)   (*((volatile unsigned int*) REGSRAM_816_reg)=data)
+#define set_REGSRAM_817_reg(data)   (*((volatile unsigned int*) REGSRAM_817_reg)=data)
+#define set_REGSRAM_818_reg(data)   (*((volatile unsigned int*) REGSRAM_818_reg)=data)
+#define set_REGSRAM_819_reg(data)   (*((volatile unsigned int*) REGSRAM_819_reg)=data)
+#define set_REGSRAM_820_reg(data)   (*((volatile unsigned int*) REGSRAM_820_reg)=data)
+#define set_REGSRAM_821_reg(data)   (*((volatile unsigned int*) REGSRAM_821_reg)=data)
+#define set_REGSRAM_822_reg(data)   (*((volatile unsigned int*) REGSRAM_822_reg)=data)
+#define set_REGSRAM_823_reg(data)   (*((volatile unsigned int*) REGSRAM_823_reg)=data)
+#define set_REGSRAM_824_reg(data)   (*((volatile unsigned int*) REGSRAM_824_reg)=data)
+#define set_REGSRAM_825_reg(data)   (*((volatile unsigned int*) REGSRAM_825_reg)=data)
+#define set_REGSRAM_826_reg(data)   (*((volatile unsigned int*) REGSRAM_826_reg)=data)
+#define set_REGSRAM_827_reg(data)   (*((volatile unsigned int*) REGSRAM_827_reg)=data)
+#define set_REGSRAM_828_reg(data)   (*((volatile unsigned int*) REGSRAM_828_reg)=data)
+#define set_REGSRAM_829_reg(data)   (*((volatile unsigned int*) REGSRAM_829_reg)=data)
+#define set_REGSRAM_830_reg(data)   (*((volatile unsigned int*) REGSRAM_830_reg)=data)
+#define set_REGSRAM_831_reg(data)   (*((volatile unsigned int*) REGSRAM_831_reg)=data)
+#define set_REGSRAM_832_reg(data)   (*((volatile unsigned int*) REGSRAM_832_reg)=data)
+#define set_REGSRAM_833_reg(data)   (*((volatile unsigned int*) REGSRAM_833_reg)=data)
+#define set_REGSRAM_834_reg(data)   (*((volatile unsigned int*) REGSRAM_834_reg)=data)
+#define set_REGSRAM_835_reg(data)   (*((volatile unsigned int*) REGSRAM_835_reg)=data)
+#define set_REGSRAM_836_reg(data)   (*((volatile unsigned int*) REGSRAM_836_reg)=data)
+#define set_REGSRAM_837_reg(data)   (*((volatile unsigned int*) REGSRAM_837_reg)=data)
+#define set_REGSRAM_838_reg(data)   (*((volatile unsigned int*) REGSRAM_838_reg)=data)
+#define set_REGSRAM_839_reg(data)   (*((volatile unsigned int*) REGSRAM_839_reg)=data)
+#define set_REGSRAM_840_reg(data)   (*((volatile unsigned int*) REGSRAM_840_reg)=data)
+#define set_REGSRAM_841_reg(data)   (*((volatile unsigned int*) REGSRAM_841_reg)=data)
+#define set_REGSRAM_842_reg(data)   (*((volatile unsigned int*) REGSRAM_842_reg)=data)
+#define set_REGSRAM_843_reg(data)   (*((volatile unsigned int*) REGSRAM_843_reg)=data)
+#define set_REGSRAM_844_reg(data)   (*((volatile unsigned int*) REGSRAM_844_reg)=data)
+#define set_REGSRAM_845_reg(data)   (*((volatile unsigned int*) REGSRAM_845_reg)=data)
+#define set_REGSRAM_846_reg(data)   (*((volatile unsigned int*) REGSRAM_846_reg)=data)
+#define set_REGSRAM_847_reg(data)   (*((volatile unsigned int*) REGSRAM_847_reg)=data)
+#define set_REGSRAM_848_reg(data)   (*((volatile unsigned int*) REGSRAM_848_reg)=data)
+#define set_REGSRAM_849_reg(data)   (*((volatile unsigned int*) REGSRAM_849_reg)=data)
+#define set_REGSRAM_850_reg(data)   (*((volatile unsigned int*) REGSRAM_850_reg)=data)
+#define set_REGSRAM_851_reg(data)   (*((volatile unsigned int*) REGSRAM_851_reg)=data)
+#define set_REGSRAM_852_reg(data)   (*((volatile unsigned int*) REGSRAM_852_reg)=data)
+#define set_REGSRAM_853_reg(data)   (*((volatile unsigned int*) REGSRAM_853_reg)=data)
+#define set_REGSRAM_854_reg(data)   (*((volatile unsigned int*) REGSRAM_854_reg)=data)
+#define set_REGSRAM_855_reg(data)   (*((volatile unsigned int*) REGSRAM_855_reg)=data)
+#define set_REGSRAM_856_reg(data)   (*((volatile unsigned int*) REGSRAM_856_reg)=data)
+#define set_REGSRAM_857_reg(data)   (*((volatile unsigned int*) REGSRAM_857_reg)=data)
+#define set_REGSRAM_858_reg(data)   (*((volatile unsigned int*) REGSRAM_858_reg)=data)
+#define set_REGSRAM_859_reg(data)   (*((volatile unsigned int*) REGSRAM_859_reg)=data)
+#define set_REGSRAM_860_reg(data)   (*((volatile unsigned int*) REGSRAM_860_reg)=data)
+#define set_REGSRAM_861_reg(data)   (*((volatile unsigned int*) REGSRAM_861_reg)=data)
+#define set_REGSRAM_862_reg(data)   (*((volatile unsigned int*) REGSRAM_862_reg)=data)
+#define set_REGSRAM_863_reg(data)   (*((volatile unsigned int*) REGSRAM_863_reg)=data)
+#define set_REGSRAM_864_reg(data)   (*((volatile unsigned int*) REGSRAM_864_reg)=data)
+#define set_REGSRAM_865_reg(data)   (*((volatile unsigned int*) REGSRAM_865_reg)=data)
+#define set_REGSRAM_866_reg(data)   (*((volatile unsigned int*) REGSRAM_866_reg)=data)
+#define set_REGSRAM_867_reg(data)   (*((volatile unsigned int*) REGSRAM_867_reg)=data)
+#define set_REGSRAM_868_reg(data)   (*((volatile unsigned int*) REGSRAM_868_reg)=data)
+#define set_REGSRAM_869_reg(data)   (*((volatile unsigned int*) REGSRAM_869_reg)=data)
+#define set_REGSRAM_870_reg(data)   (*((volatile unsigned int*) REGSRAM_870_reg)=data)
+#define set_REGSRAM_871_reg(data)   (*((volatile unsigned int*) REGSRAM_871_reg)=data)
+#define set_REGSRAM_872_reg(data)   (*((volatile unsigned int*) REGSRAM_872_reg)=data)
+#define set_REGSRAM_873_reg(data)   (*((volatile unsigned int*) REGSRAM_873_reg)=data)
+#define set_REGSRAM_874_reg(data)   (*((volatile unsigned int*) REGSRAM_874_reg)=data)
+#define set_REGSRAM_875_reg(data)   (*((volatile unsigned int*) REGSRAM_875_reg)=data)
+#define set_REGSRAM_876_reg(data)   (*((volatile unsigned int*) REGSRAM_876_reg)=data)
+#define set_REGSRAM_877_reg(data)   (*((volatile unsigned int*) REGSRAM_877_reg)=data)
+#define set_REGSRAM_878_reg(data)   (*((volatile unsigned int*) REGSRAM_878_reg)=data)
+#define set_REGSRAM_879_reg(data)   (*((volatile unsigned int*) REGSRAM_879_reg)=data)
+#define set_REGSRAM_880_reg(data)   (*((volatile unsigned int*) REGSRAM_880_reg)=data)
+#define set_REGSRAM_881_reg(data)   (*((volatile unsigned int*) REGSRAM_881_reg)=data)
+#define set_REGSRAM_882_reg(data)   (*((volatile unsigned int*) REGSRAM_882_reg)=data)
+#define set_REGSRAM_883_reg(data)   (*((volatile unsigned int*) REGSRAM_883_reg)=data)
+#define set_REGSRAM_884_reg(data)   (*((volatile unsigned int*) REGSRAM_884_reg)=data)
+#define set_REGSRAM_885_reg(data)   (*((volatile unsigned int*) REGSRAM_885_reg)=data)
+#define set_REGSRAM_886_reg(data)   (*((volatile unsigned int*) REGSRAM_886_reg)=data)
+#define set_REGSRAM_887_reg(data)   (*((volatile unsigned int*) REGSRAM_887_reg)=data)
+#define set_REGSRAM_888_reg(data)   (*((volatile unsigned int*) REGSRAM_888_reg)=data)
+#define set_REGSRAM_889_reg(data)   (*((volatile unsigned int*) REGSRAM_889_reg)=data)
+#define set_REGSRAM_890_reg(data)   (*((volatile unsigned int*) REGSRAM_890_reg)=data)
+#define set_REGSRAM_891_reg(data)   (*((volatile unsigned int*) REGSRAM_891_reg)=data)
+#define set_REGSRAM_892_reg(data)   (*((volatile unsigned int*) REGSRAM_892_reg)=data)
+#define set_REGSRAM_893_reg(data)   (*((volatile unsigned int*) REGSRAM_893_reg)=data)
+#define set_REGSRAM_894_reg(data)   (*((volatile unsigned int*) REGSRAM_894_reg)=data)
+#define set_REGSRAM_895_reg(data)   (*((volatile unsigned int*) REGSRAM_895_reg)=data)
+#define set_REGSRAM_896_reg(data)   (*((volatile unsigned int*) REGSRAM_896_reg)=data)
+#define set_REGSRAM_897_reg(data)   (*((volatile unsigned int*) REGSRAM_897_reg)=data)
+#define set_REGSRAM_898_reg(data)   (*((volatile unsigned int*) REGSRAM_898_reg)=data)
+#define set_REGSRAM_899_reg(data)   (*((volatile unsigned int*) REGSRAM_899_reg)=data)
+#define set_REGSRAM_900_reg(data)   (*((volatile unsigned int*) REGSRAM_900_reg)=data)
+#define set_REGSRAM_901_reg(data)   (*((volatile unsigned int*) REGSRAM_901_reg)=data)
+#define set_REGSRAM_902_reg(data)   (*((volatile unsigned int*) REGSRAM_902_reg)=data)
+#define set_REGSRAM_903_reg(data)   (*((volatile unsigned int*) REGSRAM_903_reg)=data)
+#define set_REGSRAM_904_reg(data)   (*((volatile unsigned int*) REGSRAM_904_reg)=data)
+#define set_REGSRAM_905_reg(data)   (*((volatile unsigned int*) REGSRAM_905_reg)=data)
+#define set_REGSRAM_906_reg(data)   (*((volatile unsigned int*) REGSRAM_906_reg)=data)
+#define set_REGSRAM_907_reg(data)   (*((volatile unsigned int*) REGSRAM_907_reg)=data)
+#define set_REGSRAM_908_reg(data)   (*((volatile unsigned int*) REGSRAM_908_reg)=data)
+#define set_REGSRAM_909_reg(data)   (*((volatile unsigned int*) REGSRAM_909_reg)=data)
+#define set_REGSRAM_910_reg(data)   (*((volatile unsigned int*) REGSRAM_910_reg)=data)
+#define set_REGSRAM_911_reg(data)   (*((volatile unsigned int*) REGSRAM_911_reg)=data)
+#define set_REGSRAM_912_reg(data)   (*((volatile unsigned int*) REGSRAM_912_reg)=data)
+#define set_REGSRAM_913_reg(data)   (*((volatile unsigned int*) REGSRAM_913_reg)=data)
+#define set_REGSRAM_914_reg(data)   (*((volatile unsigned int*) REGSRAM_914_reg)=data)
+#define set_REGSRAM_915_reg(data)   (*((volatile unsigned int*) REGSRAM_915_reg)=data)
+#define set_REGSRAM_916_reg(data)   (*((volatile unsigned int*) REGSRAM_916_reg)=data)
+#define set_REGSRAM_917_reg(data)   (*((volatile unsigned int*) REGSRAM_917_reg)=data)
+#define set_REGSRAM_918_reg(data)   (*((volatile unsigned int*) REGSRAM_918_reg)=data)
+#define set_REGSRAM_919_reg(data)   (*((volatile unsigned int*) REGSRAM_919_reg)=data)
+#define set_REGSRAM_920_reg(data)   (*((volatile unsigned int*) REGSRAM_920_reg)=data)
+#define set_REGSRAM_921_reg(data)   (*((volatile unsigned int*) REGSRAM_921_reg)=data)
+#define set_REGSRAM_922_reg(data)   (*((volatile unsigned int*) REGSRAM_922_reg)=data)
+#define set_REGSRAM_923_reg(data)   (*((volatile unsigned int*) REGSRAM_923_reg)=data)
+#define set_REGSRAM_924_reg(data)   (*((volatile unsigned int*) REGSRAM_924_reg)=data)
+#define set_REGSRAM_925_reg(data)   (*((volatile unsigned int*) REGSRAM_925_reg)=data)
+#define set_REGSRAM_926_reg(data)   (*((volatile unsigned int*) REGSRAM_926_reg)=data)
+#define set_REGSRAM_927_reg(data)   (*((volatile unsigned int*) REGSRAM_927_reg)=data)
+#define set_REGSRAM_928_reg(data)   (*((volatile unsigned int*) REGSRAM_928_reg)=data)
+#define set_REGSRAM_929_reg(data)   (*((volatile unsigned int*) REGSRAM_929_reg)=data)
+#define set_REGSRAM_930_reg(data)   (*((volatile unsigned int*) REGSRAM_930_reg)=data)
+#define set_REGSRAM_931_reg(data)   (*((volatile unsigned int*) REGSRAM_931_reg)=data)
+#define set_REGSRAM_932_reg(data)   (*((volatile unsigned int*) REGSRAM_932_reg)=data)
+#define set_REGSRAM_933_reg(data)   (*((volatile unsigned int*) REGSRAM_933_reg)=data)
+#define set_REGSRAM_934_reg(data)   (*((volatile unsigned int*) REGSRAM_934_reg)=data)
+#define set_REGSRAM_935_reg(data)   (*((volatile unsigned int*) REGSRAM_935_reg)=data)
+#define set_REGSRAM_936_reg(data)   (*((volatile unsigned int*) REGSRAM_936_reg)=data)
+#define set_REGSRAM_937_reg(data)   (*((volatile unsigned int*) REGSRAM_937_reg)=data)
+#define set_REGSRAM_938_reg(data)   (*((volatile unsigned int*) REGSRAM_938_reg)=data)
+#define set_REGSRAM_939_reg(data)   (*((volatile unsigned int*) REGSRAM_939_reg)=data)
+#define set_REGSRAM_940_reg(data)   (*((volatile unsigned int*) REGSRAM_940_reg)=data)
+#define set_REGSRAM_941_reg(data)   (*((volatile unsigned int*) REGSRAM_941_reg)=data)
+#define set_REGSRAM_942_reg(data)   (*((volatile unsigned int*) REGSRAM_942_reg)=data)
+#define set_REGSRAM_943_reg(data)   (*((volatile unsigned int*) REGSRAM_943_reg)=data)
+#define set_REGSRAM_944_reg(data)   (*((volatile unsigned int*) REGSRAM_944_reg)=data)
+#define set_REGSRAM_945_reg(data)   (*((volatile unsigned int*) REGSRAM_945_reg)=data)
+#define set_REGSRAM_946_reg(data)   (*((volatile unsigned int*) REGSRAM_946_reg)=data)
+#define set_REGSRAM_947_reg(data)   (*((volatile unsigned int*) REGSRAM_947_reg)=data)
+#define set_REGSRAM_948_reg(data)   (*((volatile unsigned int*) REGSRAM_948_reg)=data)
+#define set_REGSRAM_949_reg(data)   (*((volatile unsigned int*) REGSRAM_949_reg)=data)
+#define set_REGSRAM_950_reg(data)   (*((volatile unsigned int*) REGSRAM_950_reg)=data)
+#define set_REGSRAM_951_reg(data)   (*((volatile unsigned int*) REGSRAM_951_reg)=data)
+#define set_REGSRAM_952_reg(data)   (*((volatile unsigned int*) REGSRAM_952_reg)=data)
+#define set_REGSRAM_953_reg(data)   (*((volatile unsigned int*) REGSRAM_953_reg)=data)
+#define set_REGSRAM_954_reg(data)   (*((volatile unsigned int*) REGSRAM_954_reg)=data)
+#define set_REGSRAM_955_reg(data)   (*((volatile unsigned int*) REGSRAM_955_reg)=data)
+#define set_REGSRAM_956_reg(data)   (*((volatile unsigned int*) REGSRAM_956_reg)=data)
+#define set_REGSRAM_957_reg(data)   (*((volatile unsigned int*) REGSRAM_957_reg)=data)
+#define set_REGSRAM_958_reg(data)   (*((volatile unsigned int*) REGSRAM_958_reg)=data)
+#define set_REGSRAM_959_reg(data)   (*((volatile unsigned int*) REGSRAM_959_reg)=data)
+#define set_REGSRAM_960_reg(data)   (*((volatile unsigned int*) REGSRAM_960_reg)=data)
+#define set_REGSRAM_961_reg(data)   (*((volatile unsigned int*) REGSRAM_961_reg)=data)
+#define set_REGSRAM_962_reg(data)   (*((volatile unsigned int*) REGSRAM_962_reg)=data)
+#define set_REGSRAM_963_reg(data)   (*((volatile unsigned int*) REGSRAM_963_reg)=data)
+#define set_REGSRAM_964_reg(data)   (*((volatile unsigned int*) REGSRAM_964_reg)=data)
+#define set_REGSRAM_965_reg(data)   (*((volatile unsigned int*) REGSRAM_965_reg)=data)
+#define set_REGSRAM_966_reg(data)   (*((volatile unsigned int*) REGSRAM_966_reg)=data)
+#define set_REGSRAM_967_reg(data)   (*((volatile unsigned int*) REGSRAM_967_reg)=data)
+#define set_REGSRAM_968_reg(data)   (*((volatile unsigned int*) REGSRAM_968_reg)=data)
+#define set_REGSRAM_969_reg(data)   (*((volatile unsigned int*) REGSRAM_969_reg)=data)
+#define set_REGSRAM_970_reg(data)   (*((volatile unsigned int*) REGSRAM_970_reg)=data)
+#define set_REGSRAM_971_reg(data)   (*((volatile unsigned int*) REGSRAM_971_reg)=data)
+#define set_REGSRAM_972_reg(data)   (*((volatile unsigned int*) REGSRAM_972_reg)=data)
+#define set_REGSRAM_973_reg(data)   (*((volatile unsigned int*) REGSRAM_973_reg)=data)
+#define set_REGSRAM_974_reg(data)   (*((volatile unsigned int*) REGSRAM_974_reg)=data)
+#define set_REGSRAM_975_reg(data)   (*((volatile unsigned int*) REGSRAM_975_reg)=data)
+#define set_REGSRAM_976_reg(data)   (*((volatile unsigned int*) REGSRAM_976_reg)=data)
+#define set_REGSRAM_977_reg(data)   (*((volatile unsigned int*) REGSRAM_977_reg)=data)
+#define set_REGSRAM_978_reg(data)   (*((volatile unsigned int*) REGSRAM_978_reg)=data)
+#define set_REGSRAM_979_reg(data)   (*((volatile unsigned int*) REGSRAM_979_reg)=data)
+#define set_REGSRAM_980_reg(data)   (*((volatile unsigned int*) REGSRAM_980_reg)=data)
+#define set_REGSRAM_981_reg(data)   (*((volatile unsigned int*) REGSRAM_981_reg)=data)
+#define set_REGSRAM_982_reg(data)   (*((volatile unsigned int*) REGSRAM_982_reg)=data)
+#define set_REGSRAM_983_reg(data)   (*((volatile unsigned int*) REGSRAM_983_reg)=data)
+#define set_REGSRAM_984_reg(data)   (*((volatile unsigned int*) REGSRAM_984_reg)=data)
+#define set_REGSRAM_985_reg(data)   (*((volatile unsigned int*) REGSRAM_985_reg)=data)
+#define set_REGSRAM_986_reg(data)   (*((volatile unsigned int*) REGSRAM_986_reg)=data)
+#define set_REGSRAM_987_reg(data)   (*((volatile unsigned int*) REGSRAM_987_reg)=data)
+#define set_REGSRAM_988_reg(data)   (*((volatile unsigned int*) REGSRAM_988_reg)=data)
+#define set_REGSRAM_989_reg(data)   (*((volatile unsigned int*) REGSRAM_989_reg)=data)
+#define set_REGSRAM_990_reg(data)   (*((volatile unsigned int*) REGSRAM_990_reg)=data)
+#define set_REGSRAM_991_reg(data)   (*((volatile unsigned int*) REGSRAM_991_reg)=data)
+#define set_REGSRAM_992_reg(data)   (*((volatile unsigned int*) REGSRAM_992_reg)=data)
+#define set_REGSRAM_993_reg(data)   (*((volatile unsigned int*) REGSRAM_993_reg)=data)
+#define set_REGSRAM_994_reg(data)   (*((volatile unsigned int*) REGSRAM_994_reg)=data)
+#define set_REGSRAM_995_reg(data)   (*((volatile unsigned int*) REGSRAM_995_reg)=data)
+#define set_REGSRAM_996_reg(data)   (*((volatile unsigned int*) REGSRAM_996_reg)=data)
+#define set_REGSRAM_997_reg(data)   (*((volatile unsigned int*) REGSRAM_997_reg)=data)
+#define set_REGSRAM_998_reg(data)   (*((volatile unsigned int*) REGSRAM_998_reg)=data)
+#define set_REGSRAM_999_reg(data)   (*((volatile unsigned int*) REGSRAM_999_reg)=data)
+#define set_REGSRAM_1000_reg(data)   (*((volatile unsigned int*) REGSRAM_1000_reg)=data)
+#define set_REGSRAM_1001_reg(data)   (*((volatile unsigned int*) REGSRAM_1001_reg)=data)
+#define set_REGSRAM_1002_reg(data)   (*((volatile unsigned int*) REGSRAM_1002_reg)=data)
+#define set_REGSRAM_1003_reg(data)   (*((volatile unsigned int*) REGSRAM_1003_reg)=data)
+#define set_REGSRAM_1004_reg(data)   (*((volatile unsigned int*) REGSRAM_1004_reg)=data)
+#define set_REGSRAM_1005_reg(data)   (*((volatile unsigned int*) REGSRAM_1005_reg)=data)
+#define set_REGSRAM_1006_reg(data)   (*((volatile unsigned int*) REGSRAM_1006_reg)=data)
+#define set_REGSRAM_1007_reg(data)   (*((volatile unsigned int*) REGSRAM_1007_reg)=data)
+#define set_REGSRAM_1008_reg(data)   (*((volatile unsigned int*) REGSRAM_1008_reg)=data)
+#define set_REGSRAM_1009_reg(data)   (*((volatile unsigned int*) REGSRAM_1009_reg)=data)
+#define set_REGSRAM_1010_reg(data)   (*((volatile unsigned int*) REGSRAM_1010_reg)=data)
+#define set_REGSRAM_1011_reg(data)   (*((volatile unsigned int*) REGSRAM_1011_reg)=data)
+#define set_REGSRAM_1012_reg(data)   (*((volatile unsigned int*) REGSRAM_1012_reg)=data)
+#define set_REGSRAM_1013_reg(data)   (*((volatile unsigned int*) REGSRAM_1013_reg)=data)
+#define set_REGSRAM_1014_reg(data)   (*((volatile unsigned int*) REGSRAM_1014_reg)=data)
+#define set_REGSRAM_1015_reg(data)   (*((volatile unsigned int*) REGSRAM_1015_reg)=data)
+#define set_REGSRAM_1016_reg(data)   (*((volatile unsigned int*) REGSRAM_1016_reg)=data)
+#define set_REGSRAM_1017_reg(data)   (*((volatile unsigned int*) REGSRAM_1017_reg)=data)
+#define set_REGSRAM_1018_reg(data)   (*((volatile unsigned int*) REGSRAM_1018_reg)=data)
+#define set_REGSRAM_1019_reg(data)   (*((volatile unsigned int*) REGSRAM_1019_reg)=data)
+#define set_REGSRAM_1020_reg(data)   (*((volatile unsigned int*) REGSRAM_1020_reg)=data)
+#define set_REGSRAM_1021_reg(data)   (*((volatile unsigned int*) REGSRAM_1021_reg)=data)
+#define set_REGSRAM_1022_reg(data)   (*((volatile unsigned int*) REGSRAM_1022_reg)=data)
+#define set_REGSRAM_1023_reg(data)   (*((volatile unsigned int*) REGSRAM_1023_reg)=data)
+#define get_REGSRAM_0_reg   (*((volatile unsigned int*) REGSRAM_0_reg))
+#define get_REGSRAM_1_reg   (*((volatile unsigned int*) REGSRAM_1_reg))
+#define get_REGSRAM_2_reg   (*((volatile unsigned int*) REGSRAM_2_reg))
+#define get_REGSRAM_3_reg   (*((volatile unsigned int*) REGSRAM_3_reg))
+#define get_REGSRAM_4_reg   (*((volatile unsigned int*) REGSRAM_4_reg))
+#define get_REGSRAM_5_reg   (*((volatile unsigned int*) REGSRAM_5_reg))
+#define get_REGSRAM_6_reg   (*((volatile unsigned int*) REGSRAM_6_reg))
+#define get_REGSRAM_7_reg   (*((volatile unsigned int*) REGSRAM_7_reg))
+#define get_REGSRAM_8_reg   (*((volatile unsigned int*) REGSRAM_8_reg))
+#define get_REGSRAM_9_reg   (*((volatile unsigned int*) REGSRAM_9_reg))
+#define get_REGSRAM_10_reg   (*((volatile unsigned int*) REGSRAM_10_reg))
+#define get_REGSRAM_11_reg   (*((volatile unsigned int*) REGSRAM_11_reg))
+#define get_REGSRAM_12_reg   (*((volatile unsigned int*) REGSRAM_12_reg))
+#define get_REGSRAM_13_reg   (*((volatile unsigned int*) REGSRAM_13_reg))
+#define get_REGSRAM_14_reg   (*((volatile unsigned int*) REGSRAM_14_reg))
+#define get_REGSRAM_15_reg   (*((volatile unsigned int*) REGSRAM_15_reg))
+#define get_REGSRAM_16_reg   (*((volatile unsigned int*) REGSRAM_16_reg))
+#define get_REGSRAM_17_reg   (*((volatile unsigned int*) REGSRAM_17_reg))
+#define get_REGSRAM_18_reg   (*((volatile unsigned int*) REGSRAM_18_reg))
+#define get_REGSRAM_19_reg   (*((volatile unsigned int*) REGSRAM_19_reg))
+#define get_REGSRAM_20_reg   (*((volatile unsigned int*) REGSRAM_20_reg))
+#define get_REGSRAM_21_reg   (*((volatile unsigned int*) REGSRAM_21_reg))
+#define get_REGSRAM_22_reg   (*((volatile unsigned int*) REGSRAM_22_reg))
+#define get_REGSRAM_23_reg   (*((volatile unsigned int*) REGSRAM_23_reg))
+#define get_REGSRAM_24_reg   (*((volatile unsigned int*) REGSRAM_24_reg))
+#define get_REGSRAM_25_reg   (*((volatile unsigned int*) REGSRAM_25_reg))
+#define get_REGSRAM_26_reg   (*((volatile unsigned int*) REGSRAM_26_reg))
+#define get_REGSRAM_27_reg   (*((volatile unsigned int*) REGSRAM_27_reg))
+#define get_REGSRAM_28_reg   (*((volatile unsigned int*) REGSRAM_28_reg))
+#define get_REGSRAM_29_reg   (*((volatile unsigned int*) REGSRAM_29_reg))
+#define get_REGSRAM_30_reg   (*((volatile unsigned int*) REGSRAM_30_reg))
+#define get_REGSRAM_31_reg   (*((volatile unsigned int*) REGSRAM_31_reg))
+#define get_REGSRAM_32_reg   (*((volatile unsigned int*) REGSRAM_32_reg))
+#define get_REGSRAM_33_reg   (*((volatile unsigned int*) REGSRAM_33_reg))
+#define get_REGSRAM_34_reg   (*((volatile unsigned int*) REGSRAM_34_reg))
+#define get_REGSRAM_35_reg   (*((volatile unsigned int*) REGSRAM_35_reg))
+#define get_REGSRAM_36_reg   (*((volatile unsigned int*) REGSRAM_36_reg))
+#define get_REGSRAM_37_reg   (*((volatile unsigned int*) REGSRAM_37_reg))
+#define get_REGSRAM_38_reg   (*((volatile unsigned int*) REGSRAM_38_reg))
+#define get_REGSRAM_39_reg   (*((volatile unsigned int*) REGSRAM_39_reg))
+#define get_REGSRAM_40_reg   (*((volatile unsigned int*) REGSRAM_40_reg))
+#define get_REGSRAM_41_reg   (*((volatile unsigned int*) REGSRAM_41_reg))
+#define get_REGSRAM_42_reg   (*((volatile unsigned int*) REGSRAM_42_reg))
+#define get_REGSRAM_43_reg   (*((volatile unsigned int*) REGSRAM_43_reg))
+#define get_REGSRAM_44_reg   (*((volatile unsigned int*) REGSRAM_44_reg))
+#define get_REGSRAM_45_reg   (*((volatile unsigned int*) REGSRAM_45_reg))
+#define get_REGSRAM_46_reg   (*((volatile unsigned int*) REGSRAM_46_reg))
+#define get_REGSRAM_47_reg   (*((volatile unsigned int*) REGSRAM_47_reg))
+#define get_REGSRAM_48_reg   (*((volatile unsigned int*) REGSRAM_48_reg))
+#define get_REGSRAM_49_reg   (*((volatile unsigned int*) REGSRAM_49_reg))
+#define get_REGSRAM_50_reg   (*((volatile unsigned int*) REGSRAM_50_reg))
+#define get_REGSRAM_51_reg   (*((volatile unsigned int*) REGSRAM_51_reg))
+#define get_REGSRAM_52_reg   (*((volatile unsigned int*) REGSRAM_52_reg))
+#define get_REGSRAM_53_reg   (*((volatile unsigned int*) REGSRAM_53_reg))
+#define get_REGSRAM_54_reg   (*((volatile unsigned int*) REGSRAM_54_reg))
+#define get_REGSRAM_55_reg   (*((volatile unsigned int*) REGSRAM_55_reg))
+#define get_REGSRAM_56_reg   (*((volatile unsigned int*) REGSRAM_56_reg))
+#define get_REGSRAM_57_reg   (*((volatile unsigned int*) REGSRAM_57_reg))
+#define get_REGSRAM_58_reg   (*((volatile unsigned int*) REGSRAM_58_reg))
+#define get_REGSRAM_59_reg   (*((volatile unsigned int*) REGSRAM_59_reg))
+#define get_REGSRAM_60_reg   (*((volatile unsigned int*) REGSRAM_60_reg))
+#define get_REGSRAM_61_reg   (*((volatile unsigned int*) REGSRAM_61_reg))
+#define get_REGSRAM_62_reg   (*((volatile unsigned int*) REGSRAM_62_reg))
+#define get_REGSRAM_63_reg   (*((volatile unsigned int*) REGSRAM_63_reg))
+#define get_REGSRAM_64_reg   (*((volatile unsigned int*) REGSRAM_64_reg))
+#define get_REGSRAM_65_reg   (*((volatile unsigned int*) REGSRAM_65_reg))
+#define get_REGSRAM_66_reg   (*((volatile unsigned int*) REGSRAM_66_reg))
+#define get_REGSRAM_67_reg   (*((volatile unsigned int*) REGSRAM_67_reg))
+#define get_REGSRAM_68_reg   (*((volatile unsigned int*) REGSRAM_68_reg))
+#define get_REGSRAM_69_reg   (*((volatile unsigned int*) REGSRAM_69_reg))
+#define get_REGSRAM_70_reg   (*((volatile unsigned int*) REGSRAM_70_reg))
+#define get_REGSRAM_71_reg   (*((volatile unsigned int*) REGSRAM_71_reg))
+#define get_REGSRAM_72_reg   (*((volatile unsigned int*) REGSRAM_72_reg))
+#define get_REGSRAM_73_reg   (*((volatile unsigned int*) REGSRAM_73_reg))
+#define get_REGSRAM_74_reg   (*((volatile unsigned int*) REGSRAM_74_reg))
+#define get_REGSRAM_75_reg   (*((volatile unsigned int*) REGSRAM_75_reg))
+#define get_REGSRAM_76_reg   (*((volatile unsigned int*) REGSRAM_76_reg))
+#define get_REGSRAM_77_reg   (*((volatile unsigned int*) REGSRAM_77_reg))
+#define get_REGSRAM_78_reg   (*((volatile unsigned int*) REGSRAM_78_reg))
+#define get_REGSRAM_79_reg   (*((volatile unsigned int*) REGSRAM_79_reg))
+#define get_REGSRAM_80_reg   (*((volatile unsigned int*) REGSRAM_80_reg))
+#define get_REGSRAM_81_reg   (*((volatile unsigned int*) REGSRAM_81_reg))
+#define get_REGSRAM_82_reg   (*((volatile unsigned int*) REGSRAM_82_reg))
+#define get_REGSRAM_83_reg   (*((volatile unsigned int*) REGSRAM_83_reg))
+#define get_REGSRAM_84_reg   (*((volatile unsigned int*) REGSRAM_84_reg))
+#define get_REGSRAM_85_reg   (*((volatile unsigned int*) REGSRAM_85_reg))
+#define get_REGSRAM_86_reg   (*((volatile unsigned int*) REGSRAM_86_reg))
+#define get_REGSRAM_87_reg   (*((volatile unsigned int*) REGSRAM_87_reg))
+#define get_REGSRAM_88_reg   (*((volatile unsigned int*) REGSRAM_88_reg))
+#define get_REGSRAM_89_reg   (*((volatile unsigned int*) REGSRAM_89_reg))
+#define get_REGSRAM_90_reg   (*((volatile unsigned int*) REGSRAM_90_reg))
+#define get_REGSRAM_91_reg   (*((volatile unsigned int*) REGSRAM_91_reg))
+#define get_REGSRAM_92_reg   (*((volatile unsigned int*) REGSRAM_92_reg))
+#define get_REGSRAM_93_reg   (*((volatile unsigned int*) REGSRAM_93_reg))
+#define get_REGSRAM_94_reg   (*((volatile unsigned int*) REGSRAM_94_reg))
+#define get_REGSRAM_95_reg   (*((volatile unsigned int*) REGSRAM_95_reg))
+#define get_REGSRAM_96_reg   (*((volatile unsigned int*) REGSRAM_96_reg))
+#define get_REGSRAM_97_reg   (*((volatile unsigned int*) REGSRAM_97_reg))
+#define get_REGSRAM_98_reg   (*((volatile unsigned int*) REGSRAM_98_reg))
+#define get_REGSRAM_99_reg   (*((volatile unsigned int*) REGSRAM_99_reg))
+#define get_REGSRAM_100_reg   (*((volatile unsigned int*) REGSRAM_100_reg))
+#define get_REGSRAM_101_reg   (*((volatile unsigned int*) REGSRAM_101_reg))
+#define get_REGSRAM_102_reg   (*((volatile unsigned int*) REGSRAM_102_reg))
+#define get_REGSRAM_103_reg   (*((volatile unsigned int*) REGSRAM_103_reg))
+#define get_REGSRAM_104_reg   (*((volatile unsigned int*) REGSRAM_104_reg))
+#define get_REGSRAM_105_reg   (*((volatile unsigned int*) REGSRAM_105_reg))
+#define get_REGSRAM_106_reg   (*((volatile unsigned int*) REGSRAM_106_reg))
+#define get_REGSRAM_107_reg   (*((volatile unsigned int*) REGSRAM_107_reg))
+#define get_REGSRAM_108_reg   (*((volatile unsigned int*) REGSRAM_108_reg))
+#define get_REGSRAM_109_reg   (*((volatile unsigned int*) REGSRAM_109_reg))
+#define get_REGSRAM_110_reg   (*((volatile unsigned int*) REGSRAM_110_reg))
+#define get_REGSRAM_111_reg   (*((volatile unsigned int*) REGSRAM_111_reg))
+#define get_REGSRAM_112_reg   (*((volatile unsigned int*) REGSRAM_112_reg))
+#define get_REGSRAM_113_reg   (*((volatile unsigned int*) REGSRAM_113_reg))
+#define get_REGSRAM_114_reg   (*((volatile unsigned int*) REGSRAM_114_reg))
+#define get_REGSRAM_115_reg   (*((volatile unsigned int*) REGSRAM_115_reg))
+#define get_REGSRAM_116_reg   (*((volatile unsigned int*) REGSRAM_116_reg))
+#define get_REGSRAM_117_reg   (*((volatile unsigned int*) REGSRAM_117_reg))
+#define get_REGSRAM_118_reg   (*((volatile unsigned int*) REGSRAM_118_reg))
+#define get_REGSRAM_119_reg   (*((volatile unsigned int*) REGSRAM_119_reg))
+#define get_REGSRAM_120_reg   (*((volatile unsigned int*) REGSRAM_120_reg))
+#define get_REGSRAM_121_reg   (*((volatile unsigned int*) REGSRAM_121_reg))
+#define get_REGSRAM_122_reg   (*((volatile unsigned int*) REGSRAM_122_reg))
+#define get_REGSRAM_123_reg   (*((volatile unsigned int*) REGSRAM_123_reg))
+#define get_REGSRAM_124_reg   (*((volatile unsigned int*) REGSRAM_124_reg))
+#define get_REGSRAM_125_reg   (*((volatile unsigned int*) REGSRAM_125_reg))
+#define get_REGSRAM_126_reg   (*((volatile unsigned int*) REGSRAM_126_reg))
+#define get_REGSRAM_127_reg   (*((volatile unsigned int*) REGSRAM_127_reg))
+#define get_REGSRAM_128_reg   (*((volatile unsigned int*) REGSRAM_128_reg))
+#define get_REGSRAM_129_reg   (*((volatile unsigned int*) REGSRAM_129_reg))
+#define get_REGSRAM_130_reg   (*((volatile unsigned int*) REGSRAM_130_reg))
+#define get_REGSRAM_131_reg   (*((volatile unsigned int*) REGSRAM_131_reg))
+#define get_REGSRAM_132_reg   (*((volatile unsigned int*) REGSRAM_132_reg))
+#define get_REGSRAM_133_reg   (*((volatile unsigned int*) REGSRAM_133_reg))
+#define get_REGSRAM_134_reg   (*((volatile unsigned int*) REGSRAM_134_reg))
+#define get_REGSRAM_135_reg   (*((volatile unsigned int*) REGSRAM_135_reg))
+#define get_REGSRAM_136_reg   (*((volatile unsigned int*) REGSRAM_136_reg))
+#define get_REGSRAM_137_reg   (*((volatile unsigned int*) REGSRAM_137_reg))
+#define get_REGSRAM_138_reg   (*((volatile unsigned int*) REGSRAM_138_reg))
+#define get_REGSRAM_139_reg   (*((volatile unsigned int*) REGSRAM_139_reg))
+#define get_REGSRAM_140_reg   (*((volatile unsigned int*) REGSRAM_140_reg))
+#define get_REGSRAM_141_reg   (*((volatile unsigned int*) REGSRAM_141_reg))
+#define get_REGSRAM_142_reg   (*((volatile unsigned int*) REGSRAM_142_reg))
+#define get_REGSRAM_143_reg   (*((volatile unsigned int*) REGSRAM_143_reg))
+#define get_REGSRAM_144_reg   (*((volatile unsigned int*) REGSRAM_144_reg))
+#define get_REGSRAM_145_reg   (*((volatile unsigned int*) REGSRAM_145_reg))
+#define get_REGSRAM_146_reg   (*((volatile unsigned int*) REGSRAM_146_reg))
+#define get_REGSRAM_147_reg   (*((volatile unsigned int*) REGSRAM_147_reg))
+#define get_REGSRAM_148_reg   (*((volatile unsigned int*) REGSRAM_148_reg))
+#define get_REGSRAM_149_reg   (*((volatile unsigned int*) REGSRAM_149_reg))
+#define get_REGSRAM_150_reg   (*((volatile unsigned int*) REGSRAM_150_reg))
+#define get_REGSRAM_151_reg   (*((volatile unsigned int*) REGSRAM_151_reg))
+#define get_REGSRAM_152_reg   (*((volatile unsigned int*) REGSRAM_152_reg))
+#define get_REGSRAM_153_reg   (*((volatile unsigned int*) REGSRAM_153_reg))
+#define get_REGSRAM_154_reg   (*((volatile unsigned int*) REGSRAM_154_reg))
+#define get_REGSRAM_155_reg   (*((volatile unsigned int*) REGSRAM_155_reg))
+#define get_REGSRAM_156_reg   (*((volatile unsigned int*) REGSRAM_156_reg))
+#define get_REGSRAM_157_reg   (*((volatile unsigned int*) REGSRAM_157_reg))
+#define get_REGSRAM_158_reg   (*((volatile unsigned int*) REGSRAM_158_reg))
+#define get_REGSRAM_159_reg   (*((volatile unsigned int*) REGSRAM_159_reg))
+#define get_REGSRAM_160_reg   (*((volatile unsigned int*) REGSRAM_160_reg))
+#define get_REGSRAM_161_reg   (*((volatile unsigned int*) REGSRAM_161_reg))
+#define get_REGSRAM_162_reg   (*((volatile unsigned int*) REGSRAM_162_reg))
+#define get_REGSRAM_163_reg   (*((volatile unsigned int*) REGSRAM_163_reg))
+#define get_REGSRAM_164_reg   (*((volatile unsigned int*) REGSRAM_164_reg))
+#define get_REGSRAM_165_reg   (*((volatile unsigned int*) REGSRAM_165_reg))
+#define get_REGSRAM_166_reg   (*((volatile unsigned int*) REGSRAM_166_reg))
+#define get_REGSRAM_167_reg   (*((volatile unsigned int*) REGSRAM_167_reg))
+#define get_REGSRAM_168_reg   (*((volatile unsigned int*) REGSRAM_168_reg))
+#define get_REGSRAM_169_reg   (*((volatile unsigned int*) REGSRAM_169_reg))
+#define get_REGSRAM_170_reg   (*((volatile unsigned int*) REGSRAM_170_reg))
+#define get_REGSRAM_171_reg   (*((volatile unsigned int*) REGSRAM_171_reg))
+#define get_REGSRAM_172_reg   (*((volatile unsigned int*) REGSRAM_172_reg))
+#define get_REGSRAM_173_reg   (*((volatile unsigned int*) REGSRAM_173_reg))
+#define get_REGSRAM_174_reg   (*((volatile unsigned int*) REGSRAM_174_reg))
+#define get_REGSRAM_175_reg   (*((volatile unsigned int*) REGSRAM_175_reg))
+#define get_REGSRAM_176_reg   (*((volatile unsigned int*) REGSRAM_176_reg))
+#define get_REGSRAM_177_reg   (*((volatile unsigned int*) REGSRAM_177_reg))
+#define get_REGSRAM_178_reg   (*((volatile unsigned int*) REGSRAM_178_reg))
+#define get_REGSRAM_179_reg   (*((volatile unsigned int*) REGSRAM_179_reg))
+#define get_REGSRAM_180_reg   (*((volatile unsigned int*) REGSRAM_180_reg))
+#define get_REGSRAM_181_reg   (*((volatile unsigned int*) REGSRAM_181_reg))
+#define get_REGSRAM_182_reg   (*((volatile unsigned int*) REGSRAM_182_reg))
+#define get_REGSRAM_183_reg   (*((volatile unsigned int*) REGSRAM_183_reg))
+#define get_REGSRAM_184_reg   (*((volatile unsigned int*) REGSRAM_184_reg))
+#define get_REGSRAM_185_reg   (*((volatile unsigned int*) REGSRAM_185_reg))
+#define get_REGSRAM_186_reg   (*((volatile unsigned int*) REGSRAM_186_reg))
+#define get_REGSRAM_187_reg   (*((volatile unsigned int*) REGSRAM_187_reg))
+#define get_REGSRAM_188_reg   (*((volatile unsigned int*) REGSRAM_188_reg))
+#define get_REGSRAM_189_reg   (*((volatile unsigned int*) REGSRAM_189_reg))
+#define get_REGSRAM_190_reg   (*((volatile unsigned int*) REGSRAM_190_reg))
+#define get_REGSRAM_191_reg   (*((volatile unsigned int*) REGSRAM_191_reg))
+#define get_REGSRAM_192_reg   (*((volatile unsigned int*) REGSRAM_192_reg))
+#define get_REGSRAM_193_reg   (*((volatile unsigned int*) REGSRAM_193_reg))
+#define get_REGSRAM_194_reg   (*((volatile unsigned int*) REGSRAM_194_reg))
+#define get_REGSRAM_195_reg   (*((volatile unsigned int*) REGSRAM_195_reg))
+#define get_REGSRAM_196_reg   (*((volatile unsigned int*) REGSRAM_196_reg))
+#define get_REGSRAM_197_reg   (*((volatile unsigned int*) REGSRAM_197_reg))
+#define get_REGSRAM_198_reg   (*((volatile unsigned int*) REGSRAM_198_reg))
+#define get_REGSRAM_199_reg   (*((volatile unsigned int*) REGSRAM_199_reg))
+#define get_REGSRAM_200_reg   (*((volatile unsigned int*) REGSRAM_200_reg))
+#define get_REGSRAM_201_reg   (*((volatile unsigned int*) REGSRAM_201_reg))
+#define get_REGSRAM_202_reg   (*((volatile unsigned int*) REGSRAM_202_reg))
+#define get_REGSRAM_203_reg   (*((volatile unsigned int*) REGSRAM_203_reg))
+#define get_REGSRAM_204_reg   (*((volatile unsigned int*) REGSRAM_204_reg))
+#define get_REGSRAM_205_reg   (*((volatile unsigned int*) REGSRAM_205_reg))
+#define get_REGSRAM_206_reg   (*((volatile unsigned int*) REGSRAM_206_reg))
+#define get_REGSRAM_207_reg   (*((volatile unsigned int*) REGSRAM_207_reg))
+#define get_REGSRAM_208_reg   (*((volatile unsigned int*) REGSRAM_208_reg))
+#define get_REGSRAM_209_reg   (*((volatile unsigned int*) REGSRAM_209_reg))
+#define get_REGSRAM_210_reg   (*((volatile unsigned int*) REGSRAM_210_reg))
+#define get_REGSRAM_211_reg   (*((volatile unsigned int*) REGSRAM_211_reg))
+#define get_REGSRAM_212_reg   (*((volatile unsigned int*) REGSRAM_212_reg))
+#define get_REGSRAM_213_reg   (*((volatile unsigned int*) REGSRAM_213_reg))
+#define get_REGSRAM_214_reg   (*((volatile unsigned int*) REGSRAM_214_reg))
+#define get_REGSRAM_215_reg   (*((volatile unsigned int*) REGSRAM_215_reg))
+#define get_REGSRAM_216_reg   (*((volatile unsigned int*) REGSRAM_216_reg))
+#define get_REGSRAM_217_reg   (*((volatile unsigned int*) REGSRAM_217_reg))
+#define get_REGSRAM_218_reg   (*((volatile unsigned int*) REGSRAM_218_reg))
+#define get_REGSRAM_219_reg   (*((volatile unsigned int*) REGSRAM_219_reg))
+#define get_REGSRAM_220_reg   (*((volatile unsigned int*) REGSRAM_220_reg))
+#define get_REGSRAM_221_reg   (*((volatile unsigned int*) REGSRAM_221_reg))
+#define get_REGSRAM_222_reg   (*((volatile unsigned int*) REGSRAM_222_reg))
+#define get_REGSRAM_223_reg   (*((volatile unsigned int*) REGSRAM_223_reg))
+#define get_REGSRAM_224_reg   (*((volatile unsigned int*) REGSRAM_224_reg))
+#define get_REGSRAM_225_reg   (*((volatile unsigned int*) REGSRAM_225_reg))
+#define get_REGSRAM_226_reg   (*((volatile unsigned int*) REGSRAM_226_reg))
+#define get_REGSRAM_227_reg   (*((volatile unsigned int*) REGSRAM_227_reg))
+#define get_REGSRAM_228_reg   (*((volatile unsigned int*) REGSRAM_228_reg))
+#define get_REGSRAM_229_reg   (*((volatile unsigned int*) REGSRAM_229_reg))
+#define get_REGSRAM_230_reg   (*((volatile unsigned int*) REGSRAM_230_reg))
+#define get_REGSRAM_231_reg   (*((volatile unsigned int*) REGSRAM_231_reg))
+#define get_REGSRAM_232_reg   (*((volatile unsigned int*) REGSRAM_232_reg))
+#define get_REGSRAM_233_reg   (*((volatile unsigned int*) REGSRAM_233_reg))
+#define get_REGSRAM_234_reg   (*((volatile unsigned int*) REGSRAM_234_reg))
+#define get_REGSRAM_235_reg   (*((volatile unsigned int*) REGSRAM_235_reg))
+#define get_REGSRAM_236_reg   (*((volatile unsigned int*) REGSRAM_236_reg))
+#define get_REGSRAM_237_reg   (*((volatile unsigned int*) REGSRAM_237_reg))
+#define get_REGSRAM_238_reg   (*((volatile unsigned int*) REGSRAM_238_reg))
+#define get_REGSRAM_239_reg   (*((volatile unsigned int*) REGSRAM_239_reg))
+#define get_REGSRAM_240_reg   (*((volatile unsigned int*) REGSRAM_240_reg))
+#define get_REGSRAM_241_reg   (*((volatile unsigned int*) REGSRAM_241_reg))
+#define get_REGSRAM_242_reg   (*((volatile unsigned int*) REGSRAM_242_reg))
+#define get_REGSRAM_243_reg   (*((volatile unsigned int*) REGSRAM_243_reg))
+#define get_REGSRAM_244_reg   (*((volatile unsigned int*) REGSRAM_244_reg))
+#define get_REGSRAM_245_reg   (*((volatile unsigned int*) REGSRAM_245_reg))
+#define get_REGSRAM_246_reg   (*((volatile unsigned int*) REGSRAM_246_reg))
+#define get_REGSRAM_247_reg   (*((volatile unsigned int*) REGSRAM_247_reg))
+#define get_REGSRAM_248_reg   (*((volatile unsigned int*) REGSRAM_248_reg))
+#define get_REGSRAM_249_reg   (*((volatile unsigned int*) REGSRAM_249_reg))
+#define get_REGSRAM_250_reg   (*((volatile unsigned int*) REGSRAM_250_reg))
+#define get_REGSRAM_251_reg   (*((volatile unsigned int*) REGSRAM_251_reg))
+#define get_REGSRAM_252_reg   (*((volatile unsigned int*) REGSRAM_252_reg))
+#define get_REGSRAM_253_reg   (*((volatile unsigned int*) REGSRAM_253_reg))
+#define get_REGSRAM_254_reg   (*((volatile unsigned int*) REGSRAM_254_reg))
+#define get_REGSRAM_255_reg   (*((volatile unsigned int*) REGSRAM_255_reg))
+#define get_REGSRAM_256_reg   (*((volatile unsigned int*) REGSRAM_256_reg))
+#define get_REGSRAM_257_reg   (*((volatile unsigned int*) REGSRAM_257_reg))
+#define get_REGSRAM_258_reg   (*((volatile unsigned int*) REGSRAM_258_reg))
+#define get_REGSRAM_259_reg   (*((volatile unsigned int*) REGSRAM_259_reg))
+#define get_REGSRAM_260_reg   (*((volatile unsigned int*) REGSRAM_260_reg))
+#define get_REGSRAM_261_reg   (*((volatile unsigned int*) REGSRAM_261_reg))
+#define get_REGSRAM_262_reg   (*((volatile unsigned int*) REGSRAM_262_reg))
+#define get_REGSRAM_263_reg   (*((volatile unsigned int*) REGSRAM_263_reg))
+#define get_REGSRAM_264_reg   (*((volatile unsigned int*) REGSRAM_264_reg))
+#define get_REGSRAM_265_reg   (*((volatile unsigned int*) REGSRAM_265_reg))
+#define get_REGSRAM_266_reg   (*((volatile unsigned int*) REGSRAM_266_reg))
+#define get_REGSRAM_267_reg   (*((volatile unsigned int*) REGSRAM_267_reg))
+#define get_REGSRAM_268_reg   (*((volatile unsigned int*) REGSRAM_268_reg))
+#define get_REGSRAM_269_reg   (*((volatile unsigned int*) REGSRAM_269_reg))
+#define get_REGSRAM_270_reg   (*((volatile unsigned int*) REGSRAM_270_reg))
+#define get_REGSRAM_271_reg   (*((volatile unsigned int*) REGSRAM_271_reg))
+#define get_REGSRAM_272_reg   (*((volatile unsigned int*) REGSRAM_272_reg))
+#define get_REGSRAM_273_reg   (*((volatile unsigned int*) REGSRAM_273_reg))
+#define get_REGSRAM_274_reg   (*((volatile unsigned int*) REGSRAM_274_reg))
+#define get_REGSRAM_275_reg   (*((volatile unsigned int*) REGSRAM_275_reg))
+#define get_REGSRAM_276_reg   (*((volatile unsigned int*) REGSRAM_276_reg))
+#define get_REGSRAM_277_reg   (*((volatile unsigned int*) REGSRAM_277_reg))
+#define get_REGSRAM_278_reg   (*((volatile unsigned int*) REGSRAM_278_reg))
+#define get_REGSRAM_279_reg   (*((volatile unsigned int*) REGSRAM_279_reg))
+#define get_REGSRAM_280_reg   (*((volatile unsigned int*) REGSRAM_280_reg))
+#define get_REGSRAM_281_reg   (*((volatile unsigned int*) REGSRAM_281_reg))
+#define get_REGSRAM_282_reg   (*((volatile unsigned int*) REGSRAM_282_reg))
+#define get_REGSRAM_283_reg   (*((volatile unsigned int*) REGSRAM_283_reg))
+#define get_REGSRAM_284_reg   (*((volatile unsigned int*) REGSRAM_284_reg))
+#define get_REGSRAM_285_reg   (*((volatile unsigned int*) REGSRAM_285_reg))
+#define get_REGSRAM_286_reg   (*((volatile unsigned int*) REGSRAM_286_reg))
+#define get_REGSRAM_287_reg   (*((volatile unsigned int*) REGSRAM_287_reg))
+#define get_REGSRAM_288_reg   (*((volatile unsigned int*) REGSRAM_288_reg))
+#define get_REGSRAM_289_reg   (*((volatile unsigned int*) REGSRAM_289_reg))
+#define get_REGSRAM_290_reg   (*((volatile unsigned int*) REGSRAM_290_reg))
+#define get_REGSRAM_291_reg   (*((volatile unsigned int*) REGSRAM_291_reg))
+#define get_REGSRAM_292_reg   (*((volatile unsigned int*) REGSRAM_292_reg))
+#define get_REGSRAM_293_reg   (*((volatile unsigned int*) REGSRAM_293_reg))
+#define get_REGSRAM_294_reg   (*((volatile unsigned int*) REGSRAM_294_reg))
+#define get_REGSRAM_295_reg   (*((volatile unsigned int*) REGSRAM_295_reg))
+#define get_REGSRAM_296_reg   (*((volatile unsigned int*) REGSRAM_296_reg))
+#define get_REGSRAM_297_reg   (*((volatile unsigned int*) REGSRAM_297_reg))
+#define get_REGSRAM_298_reg   (*((volatile unsigned int*) REGSRAM_298_reg))
+#define get_REGSRAM_299_reg   (*((volatile unsigned int*) REGSRAM_299_reg))
+#define get_REGSRAM_300_reg   (*((volatile unsigned int*) REGSRAM_300_reg))
+#define get_REGSRAM_301_reg   (*((volatile unsigned int*) REGSRAM_301_reg))
+#define get_REGSRAM_302_reg   (*((volatile unsigned int*) REGSRAM_302_reg))
+#define get_REGSRAM_303_reg   (*((volatile unsigned int*) REGSRAM_303_reg))
+#define get_REGSRAM_304_reg   (*((volatile unsigned int*) REGSRAM_304_reg))
+#define get_REGSRAM_305_reg   (*((volatile unsigned int*) REGSRAM_305_reg))
+#define get_REGSRAM_306_reg   (*((volatile unsigned int*) REGSRAM_306_reg))
+#define get_REGSRAM_307_reg   (*((volatile unsigned int*) REGSRAM_307_reg))
+#define get_REGSRAM_308_reg   (*((volatile unsigned int*) REGSRAM_308_reg))
+#define get_REGSRAM_309_reg   (*((volatile unsigned int*) REGSRAM_309_reg))
+#define get_REGSRAM_310_reg   (*((volatile unsigned int*) REGSRAM_310_reg))
+#define get_REGSRAM_311_reg   (*((volatile unsigned int*) REGSRAM_311_reg))
+#define get_REGSRAM_312_reg   (*((volatile unsigned int*) REGSRAM_312_reg))
+#define get_REGSRAM_313_reg   (*((volatile unsigned int*) REGSRAM_313_reg))
+#define get_REGSRAM_314_reg   (*((volatile unsigned int*) REGSRAM_314_reg))
+#define get_REGSRAM_315_reg   (*((volatile unsigned int*) REGSRAM_315_reg))
+#define get_REGSRAM_316_reg   (*((volatile unsigned int*) REGSRAM_316_reg))
+#define get_REGSRAM_317_reg   (*((volatile unsigned int*) REGSRAM_317_reg))
+#define get_REGSRAM_318_reg   (*((volatile unsigned int*) REGSRAM_318_reg))
+#define get_REGSRAM_319_reg   (*((volatile unsigned int*) REGSRAM_319_reg))
+#define get_REGSRAM_320_reg   (*((volatile unsigned int*) REGSRAM_320_reg))
+#define get_REGSRAM_321_reg   (*((volatile unsigned int*) REGSRAM_321_reg))
+#define get_REGSRAM_322_reg   (*((volatile unsigned int*) REGSRAM_322_reg))
+#define get_REGSRAM_323_reg   (*((volatile unsigned int*) REGSRAM_323_reg))
+#define get_REGSRAM_324_reg   (*((volatile unsigned int*) REGSRAM_324_reg))
+#define get_REGSRAM_325_reg   (*((volatile unsigned int*) REGSRAM_325_reg))
+#define get_REGSRAM_326_reg   (*((volatile unsigned int*) REGSRAM_326_reg))
+#define get_REGSRAM_327_reg   (*((volatile unsigned int*) REGSRAM_327_reg))
+#define get_REGSRAM_328_reg   (*((volatile unsigned int*) REGSRAM_328_reg))
+#define get_REGSRAM_329_reg   (*((volatile unsigned int*) REGSRAM_329_reg))
+#define get_REGSRAM_330_reg   (*((volatile unsigned int*) REGSRAM_330_reg))
+#define get_REGSRAM_331_reg   (*((volatile unsigned int*) REGSRAM_331_reg))
+#define get_REGSRAM_332_reg   (*((volatile unsigned int*) REGSRAM_332_reg))
+#define get_REGSRAM_333_reg   (*((volatile unsigned int*) REGSRAM_333_reg))
+#define get_REGSRAM_334_reg   (*((volatile unsigned int*) REGSRAM_334_reg))
+#define get_REGSRAM_335_reg   (*((volatile unsigned int*) REGSRAM_335_reg))
+#define get_REGSRAM_336_reg   (*((volatile unsigned int*) REGSRAM_336_reg))
+#define get_REGSRAM_337_reg   (*((volatile unsigned int*) REGSRAM_337_reg))
+#define get_REGSRAM_338_reg   (*((volatile unsigned int*) REGSRAM_338_reg))
+#define get_REGSRAM_339_reg   (*((volatile unsigned int*) REGSRAM_339_reg))
+#define get_REGSRAM_340_reg   (*((volatile unsigned int*) REGSRAM_340_reg))
+#define get_REGSRAM_341_reg   (*((volatile unsigned int*) REGSRAM_341_reg))
+#define get_REGSRAM_342_reg   (*((volatile unsigned int*) REGSRAM_342_reg))
+#define get_REGSRAM_343_reg   (*((volatile unsigned int*) REGSRAM_343_reg))
+#define get_REGSRAM_344_reg   (*((volatile unsigned int*) REGSRAM_344_reg))
+#define get_REGSRAM_345_reg   (*((volatile unsigned int*) REGSRAM_345_reg))
+#define get_REGSRAM_346_reg   (*((volatile unsigned int*) REGSRAM_346_reg))
+#define get_REGSRAM_347_reg   (*((volatile unsigned int*) REGSRAM_347_reg))
+#define get_REGSRAM_348_reg   (*((volatile unsigned int*) REGSRAM_348_reg))
+#define get_REGSRAM_349_reg   (*((volatile unsigned int*) REGSRAM_349_reg))
+#define get_REGSRAM_350_reg   (*((volatile unsigned int*) REGSRAM_350_reg))
+#define get_REGSRAM_351_reg   (*((volatile unsigned int*) REGSRAM_351_reg))
+#define get_REGSRAM_352_reg   (*((volatile unsigned int*) REGSRAM_352_reg))
+#define get_REGSRAM_353_reg   (*((volatile unsigned int*) REGSRAM_353_reg))
+#define get_REGSRAM_354_reg   (*((volatile unsigned int*) REGSRAM_354_reg))
+#define get_REGSRAM_355_reg   (*((volatile unsigned int*) REGSRAM_355_reg))
+#define get_REGSRAM_356_reg   (*((volatile unsigned int*) REGSRAM_356_reg))
+#define get_REGSRAM_357_reg   (*((volatile unsigned int*) REGSRAM_357_reg))
+#define get_REGSRAM_358_reg   (*((volatile unsigned int*) REGSRAM_358_reg))
+#define get_REGSRAM_359_reg   (*((volatile unsigned int*) REGSRAM_359_reg))
+#define get_REGSRAM_360_reg   (*((volatile unsigned int*) REGSRAM_360_reg))
+#define get_REGSRAM_361_reg   (*((volatile unsigned int*) REGSRAM_361_reg))
+#define get_REGSRAM_362_reg   (*((volatile unsigned int*) REGSRAM_362_reg))
+#define get_REGSRAM_363_reg   (*((volatile unsigned int*) REGSRAM_363_reg))
+#define get_REGSRAM_364_reg   (*((volatile unsigned int*) REGSRAM_364_reg))
+#define get_REGSRAM_365_reg   (*((volatile unsigned int*) REGSRAM_365_reg))
+#define get_REGSRAM_366_reg   (*((volatile unsigned int*) REGSRAM_366_reg))
+#define get_REGSRAM_367_reg   (*((volatile unsigned int*) REGSRAM_367_reg))
+#define get_REGSRAM_368_reg   (*((volatile unsigned int*) REGSRAM_368_reg))
+#define get_REGSRAM_369_reg   (*((volatile unsigned int*) REGSRAM_369_reg))
+#define get_REGSRAM_370_reg   (*((volatile unsigned int*) REGSRAM_370_reg))
+#define get_REGSRAM_371_reg   (*((volatile unsigned int*) REGSRAM_371_reg))
+#define get_REGSRAM_372_reg   (*((volatile unsigned int*) REGSRAM_372_reg))
+#define get_REGSRAM_373_reg   (*((volatile unsigned int*) REGSRAM_373_reg))
+#define get_REGSRAM_374_reg   (*((volatile unsigned int*) REGSRAM_374_reg))
+#define get_REGSRAM_375_reg   (*((volatile unsigned int*) REGSRAM_375_reg))
+#define get_REGSRAM_376_reg   (*((volatile unsigned int*) REGSRAM_376_reg))
+#define get_REGSRAM_377_reg   (*((volatile unsigned int*) REGSRAM_377_reg))
+#define get_REGSRAM_378_reg   (*((volatile unsigned int*) REGSRAM_378_reg))
+#define get_REGSRAM_379_reg   (*((volatile unsigned int*) REGSRAM_379_reg))
+#define get_REGSRAM_380_reg   (*((volatile unsigned int*) REGSRAM_380_reg))
+#define get_REGSRAM_381_reg   (*((volatile unsigned int*) REGSRAM_381_reg))
+#define get_REGSRAM_382_reg   (*((volatile unsigned int*) REGSRAM_382_reg))
+#define get_REGSRAM_383_reg   (*((volatile unsigned int*) REGSRAM_383_reg))
+#define get_REGSRAM_384_reg   (*((volatile unsigned int*) REGSRAM_384_reg))
+#define get_REGSRAM_385_reg   (*((volatile unsigned int*) REGSRAM_385_reg))
+#define get_REGSRAM_386_reg   (*((volatile unsigned int*) REGSRAM_386_reg))
+#define get_REGSRAM_387_reg   (*((volatile unsigned int*) REGSRAM_387_reg))
+#define get_REGSRAM_388_reg   (*((volatile unsigned int*) REGSRAM_388_reg))
+#define get_REGSRAM_389_reg   (*((volatile unsigned int*) REGSRAM_389_reg))
+#define get_REGSRAM_390_reg   (*((volatile unsigned int*) REGSRAM_390_reg))
+#define get_REGSRAM_391_reg   (*((volatile unsigned int*) REGSRAM_391_reg))
+#define get_REGSRAM_392_reg   (*((volatile unsigned int*) REGSRAM_392_reg))
+#define get_REGSRAM_393_reg   (*((volatile unsigned int*) REGSRAM_393_reg))
+#define get_REGSRAM_394_reg   (*((volatile unsigned int*) REGSRAM_394_reg))
+#define get_REGSRAM_395_reg   (*((volatile unsigned int*) REGSRAM_395_reg))
+#define get_REGSRAM_396_reg   (*((volatile unsigned int*) REGSRAM_396_reg))
+#define get_REGSRAM_397_reg   (*((volatile unsigned int*) REGSRAM_397_reg))
+#define get_REGSRAM_398_reg   (*((volatile unsigned int*) REGSRAM_398_reg))
+#define get_REGSRAM_399_reg   (*((volatile unsigned int*) REGSRAM_399_reg))
+#define get_REGSRAM_400_reg   (*((volatile unsigned int*) REGSRAM_400_reg))
+#define get_REGSRAM_401_reg   (*((volatile unsigned int*) REGSRAM_401_reg))
+#define get_REGSRAM_402_reg   (*((volatile unsigned int*) REGSRAM_402_reg))
+#define get_REGSRAM_403_reg   (*((volatile unsigned int*) REGSRAM_403_reg))
+#define get_REGSRAM_404_reg   (*((volatile unsigned int*) REGSRAM_404_reg))
+#define get_REGSRAM_405_reg   (*((volatile unsigned int*) REGSRAM_405_reg))
+#define get_REGSRAM_406_reg   (*((volatile unsigned int*) REGSRAM_406_reg))
+#define get_REGSRAM_407_reg   (*((volatile unsigned int*) REGSRAM_407_reg))
+#define get_REGSRAM_408_reg   (*((volatile unsigned int*) REGSRAM_408_reg))
+#define get_REGSRAM_409_reg   (*((volatile unsigned int*) REGSRAM_409_reg))
+#define get_REGSRAM_410_reg   (*((volatile unsigned int*) REGSRAM_410_reg))
+#define get_REGSRAM_411_reg   (*((volatile unsigned int*) REGSRAM_411_reg))
+#define get_REGSRAM_412_reg   (*((volatile unsigned int*) REGSRAM_412_reg))
+#define get_REGSRAM_413_reg   (*((volatile unsigned int*) REGSRAM_413_reg))
+#define get_REGSRAM_414_reg   (*((volatile unsigned int*) REGSRAM_414_reg))
+#define get_REGSRAM_415_reg   (*((volatile unsigned int*) REGSRAM_415_reg))
+#define get_REGSRAM_416_reg   (*((volatile unsigned int*) REGSRAM_416_reg))
+#define get_REGSRAM_417_reg   (*((volatile unsigned int*) REGSRAM_417_reg))
+#define get_REGSRAM_418_reg   (*((volatile unsigned int*) REGSRAM_418_reg))
+#define get_REGSRAM_419_reg   (*((volatile unsigned int*) REGSRAM_419_reg))
+#define get_REGSRAM_420_reg   (*((volatile unsigned int*) REGSRAM_420_reg))
+#define get_REGSRAM_421_reg   (*((volatile unsigned int*) REGSRAM_421_reg))
+#define get_REGSRAM_422_reg   (*((volatile unsigned int*) REGSRAM_422_reg))
+#define get_REGSRAM_423_reg   (*((volatile unsigned int*) REGSRAM_423_reg))
+#define get_REGSRAM_424_reg   (*((volatile unsigned int*) REGSRAM_424_reg))
+#define get_REGSRAM_425_reg   (*((volatile unsigned int*) REGSRAM_425_reg))
+#define get_REGSRAM_426_reg   (*((volatile unsigned int*) REGSRAM_426_reg))
+#define get_REGSRAM_427_reg   (*((volatile unsigned int*) REGSRAM_427_reg))
+#define get_REGSRAM_428_reg   (*((volatile unsigned int*) REGSRAM_428_reg))
+#define get_REGSRAM_429_reg   (*((volatile unsigned int*) REGSRAM_429_reg))
+#define get_REGSRAM_430_reg   (*((volatile unsigned int*) REGSRAM_430_reg))
+#define get_REGSRAM_431_reg   (*((volatile unsigned int*) REGSRAM_431_reg))
+#define get_REGSRAM_432_reg   (*((volatile unsigned int*) REGSRAM_432_reg))
+#define get_REGSRAM_433_reg   (*((volatile unsigned int*) REGSRAM_433_reg))
+#define get_REGSRAM_434_reg   (*((volatile unsigned int*) REGSRAM_434_reg))
+#define get_REGSRAM_435_reg   (*((volatile unsigned int*) REGSRAM_435_reg))
+#define get_REGSRAM_436_reg   (*((volatile unsigned int*) REGSRAM_436_reg))
+#define get_REGSRAM_437_reg   (*((volatile unsigned int*) REGSRAM_437_reg))
+#define get_REGSRAM_438_reg   (*((volatile unsigned int*) REGSRAM_438_reg))
+#define get_REGSRAM_439_reg   (*((volatile unsigned int*) REGSRAM_439_reg))
+#define get_REGSRAM_440_reg   (*((volatile unsigned int*) REGSRAM_440_reg))
+#define get_REGSRAM_441_reg   (*((volatile unsigned int*) REGSRAM_441_reg))
+#define get_REGSRAM_442_reg   (*((volatile unsigned int*) REGSRAM_442_reg))
+#define get_REGSRAM_443_reg   (*((volatile unsigned int*) REGSRAM_443_reg))
+#define get_REGSRAM_444_reg   (*((volatile unsigned int*) REGSRAM_444_reg))
+#define get_REGSRAM_445_reg   (*((volatile unsigned int*) REGSRAM_445_reg))
+#define get_REGSRAM_446_reg   (*((volatile unsigned int*) REGSRAM_446_reg))
+#define get_REGSRAM_447_reg   (*((volatile unsigned int*) REGSRAM_447_reg))
+#define get_REGSRAM_448_reg   (*((volatile unsigned int*) REGSRAM_448_reg))
+#define get_REGSRAM_449_reg   (*((volatile unsigned int*) REGSRAM_449_reg))
+#define get_REGSRAM_450_reg   (*((volatile unsigned int*) REGSRAM_450_reg))
+#define get_REGSRAM_451_reg   (*((volatile unsigned int*) REGSRAM_451_reg))
+#define get_REGSRAM_452_reg   (*((volatile unsigned int*) REGSRAM_452_reg))
+#define get_REGSRAM_453_reg   (*((volatile unsigned int*) REGSRAM_453_reg))
+#define get_REGSRAM_454_reg   (*((volatile unsigned int*) REGSRAM_454_reg))
+#define get_REGSRAM_455_reg   (*((volatile unsigned int*) REGSRAM_455_reg))
+#define get_REGSRAM_456_reg   (*((volatile unsigned int*) REGSRAM_456_reg))
+#define get_REGSRAM_457_reg   (*((volatile unsigned int*) REGSRAM_457_reg))
+#define get_REGSRAM_458_reg   (*((volatile unsigned int*) REGSRAM_458_reg))
+#define get_REGSRAM_459_reg   (*((volatile unsigned int*) REGSRAM_459_reg))
+#define get_REGSRAM_460_reg   (*((volatile unsigned int*) REGSRAM_460_reg))
+#define get_REGSRAM_461_reg   (*((volatile unsigned int*) REGSRAM_461_reg))
+#define get_REGSRAM_462_reg   (*((volatile unsigned int*) REGSRAM_462_reg))
+#define get_REGSRAM_463_reg   (*((volatile unsigned int*) REGSRAM_463_reg))
+#define get_REGSRAM_464_reg   (*((volatile unsigned int*) REGSRAM_464_reg))
+#define get_REGSRAM_465_reg   (*((volatile unsigned int*) REGSRAM_465_reg))
+#define get_REGSRAM_466_reg   (*((volatile unsigned int*) REGSRAM_466_reg))
+#define get_REGSRAM_467_reg   (*((volatile unsigned int*) REGSRAM_467_reg))
+#define get_REGSRAM_468_reg   (*((volatile unsigned int*) REGSRAM_468_reg))
+#define get_REGSRAM_469_reg   (*((volatile unsigned int*) REGSRAM_469_reg))
+#define get_REGSRAM_470_reg   (*((volatile unsigned int*) REGSRAM_470_reg))
+#define get_REGSRAM_471_reg   (*((volatile unsigned int*) REGSRAM_471_reg))
+#define get_REGSRAM_472_reg   (*((volatile unsigned int*) REGSRAM_472_reg))
+#define get_REGSRAM_473_reg   (*((volatile unsigned int*) REGSRAM_473_reg))
+#define get_REGSRAM_474_reg   (*((volatile unsigned int*) REGSRAM_474_reg))
+#define get_REGSRAM_475_reg   (*((volatile unsigned int*) REGSRAM_475_reg))
+#define get_REGSRAM_476_reg   (*((volatile unsigned int*) REGSRAM_476_reg))
+#define get_REGSRAM_477_reg   (*((volatile unsigned int*) REGSRAM_477_reg))
+#define get_REGSRAM_478_reg   (*((volatile unsigned int*) REGSRAM_478_reg))
+#define get_REGSRAM_479_reg   (*((volatile unsigned int*) REGSRAM_479_reg))
+#define get_REGSRAM_480_reg   (*((volatile unsigned int*) REGSRAM_480_reg))
+#define get_REGSRAM_481_reg   (*((volatile unsigned int*) REGSRAM_481_reg))
+#define get_REGSRAM_482_reg   (*((volatile unsigned int*) REGSRAM_482_reg))
+#define get_REGSRAM_483_reg   (*((volatile unsigned int*) REGSRAM_483_reg))
+#define get_REGSRAM_484_reg   (*((volatile unsigned int*) REGSRAM_484_reg))
+#define get_REGSRAM_485_reg   (*((volatile unsigned int*) REGSRAM_485_reg))
+#define get_REGSRAM_486_reg   (*((volatile unsigned int*) REGSRAM_486_reg))
+#define get_REGSRAM_487_reg   (*((volatile unsigned int*) REGSRAM_487_reg))
+#define get_REGSRAM_488_reg   (*((volatile unsigned int*) REGSRAM_488_reg))
+#define get_REGSRAM_489_reg   (*((volatile unsigned int*) REGSRAM_489_reg))
+#define get_REGSRAM_490_reg   (*((volatile unsigned int*) REGSRAM_490_reg))
+#define get_REGSRAM_491_reg   (*((volatile unsigned int*) REGSRAM_491_reg))
+#define get_REGSRAM_492_reg   (*((volatile unsigned int*) REGSRAM_492_reg))
+#define get_REGSRAM_493_reg   (*((volatile unsigned int*) REGSRAM_493_reg))
+#define get_REGSRAM_494_reg   (*((volatile unsigned int*) REGSRAM_494_reg))
+#define get_REGSRAM_495_reg   (*((volatile unsigned int*) REGSRAM_495_reg))
+#define get_REGSRAM_496_reg   (*((volatile unsigned int*) REGSRAM_496_reg))
+#define get_REGSRAM_497_reg   (*((volatile unsigned int*) REGSRAM_497_reg))
+#define get_REGSRAM_498_reg   (*((volatile unsigned int*) REGSRAM_498_reg))
+#define get_REGSRAM_499_reg   (*((volatile unsigned int*) REGSRAM_499_reg))
+#define get_REGSRAM_500_reg   (*((volatile unsigned int*) REGSRAM_500_reg))
+#define get_REGSRAM_501_reg   (*((volatile unsigned int*) REGSRAM_501_reg))
+#define get_REGSRAM_502_reg   (*((volatile unsigned int*) REGSRAM_502_reg))
+#define get_REGSRAM_503_reg   (*((volatile unsigned int*) REGSRAM_503_reg))
+#define get_REGSRAM_504_reg   (*((volatile unsigned int*) REGSRAM_504_reg))
+#define get_REGSRAM_505_reg   (*((volatile unsigned int*) REGSRAM_505_reg))
+#define get_REGSRAM_506_reg   (*((volatile unsigned int*) REGSRAM_506_reg))
+#define get_REGSRAM_507_reg   (*((volatile unsigned int*) REGSRAM_507_reg))
+#define get_REGSRAM_508_reg   (*((volatile unsigned int*) REGSRAM_508_reg))
+#define get_REGSRAM_509_reg   (*((volatile unsigned int*) REGSRAM_509_reg))
+#define get_REGSRAM_510_reg   (*((volatile unsigned int*) REGSRAM_510_reg))
+#define get_REGSRAM_511_reg   (*((volatile unsigned int*) REGSRAM_511_reg))
+#define get_REGSRAM_512_reg   (*((volatile unsigned int*) REGSRAM_512_reg))
+#define get_REGSRAM_513_reg   (*((volatile unsigned int*) REGSRAM_513_reg))
+#define get_REGSRAM_514_reg   (*((volatile unsigned int*) REGSRAM_514_reg))
+#define get_REGSRAM_515_reg   (*((volatile unsigned int*) REGSRAM_515_reg))
+#define get_REGSRAM_516_reg   (*((volatile unsigned int*) REGSRAM_516_reg))
+#define get_REGSRAM_517_reg   (*((volatile unsigned int*) REGSRAM_517_reg))
+#define get_REGSRAM_518_reg   (*((volatile unsigned int*) REGSRAM_518_reg))
+#define get_REGSRAM_519_reg   (*((volatile unsigned int*) REGSRAM_519_reg))
+#define get_REGSRAM_520_reg   (*((volatile unsigned int*) REGSRAM_520_reg))
+#define get_REGSRAM_521_reg   (*((volatile unsigned int*) REGSRAM_521_reg))
+#define get_REGSRAM_522_reg   (*((volatile unsigned int*) REGSRAM_522_reg))
+#define get_REGSRAM_523_reg   (*((volatile unsigned int*) REGSRAM_523_reg))
+#define get_REGSRAM_524_reg   (*((volatile unsigned int*) REGSRAM_524_reg))
+#define get_REGSRAM_525_reg   (*((volatile unsigned int*) REGSRAM_525_reg))
+#define get_REGSRAM_526_reg   (*((volatile unsigned int*) REGSRAM_526_reg))
+#define get_REGSRAM_527_reg   (*((volatile unsigned int*) REGSRAM_527_reg))
+#define get_REGSRAM_528_reg   (*((volatile unsigned int*) REGSRAM_528_reg))
+#define get_REGSRAM_529_reg   (*((volatile unsigned int*) REGSRAM_529_reg))
+#define get_REGSRAM_530_reg   (*((volatile unsigned int*) REGSRAM_530_reg))
+#define get_REGSRAM_531_reg   (*((volatile unsigned int*) REGSRAM_531_reg))
+#define get_REGSRAM_532_reg   (*((volatile unsigned int*) REGSRAM_532_reg))
+#define get_REGSRAM_533_reg   (*((volatile unsigned int*) REGSRAM_533_reg))
+#define get_REGSRAM_534_reg   (*((volatile unsigned int*) REGSRAM_534_reg))
+#define get_REGSRAM_535_reg   (*((volatile unsigned int*) REGSRAM_535_reg))
+#define get_REGSRAM_536_reg   (*((volatile unsigned int*) REGSRAM_536_reg))
+#define get_REGSRAM_537_reg   (*((volatile unsigned int*) REGSRAM_537_reg))
+#define get_REGSRAM_538_reg   (*((volatile unsigned int*) REGSRAM_538_reg))
+#define get_REGSRAM_539_reg   (*((volatile unsigned int*) REGSRAM_539_reg))
+#define get_REGSRAM_540_reg   (*((volatile unsigned int*) REGSRAM_540_reg))
+#define get_REGSRAM_541_reg   (*((volatile unsigned int*) REGSRAM_541_reg))
+#define get_REGSRAM_542_reg   (*((volatile unsigned int*) REGSRAM_542_reg))
+#define get_REGSRAM_543_reg   (*((volatile unsigned int*) REGSRAM_543_reg))
+#define get_REGSRAM_544_reg   (*((volatile unsigned int*) REGSRAM_544_reg))
+#define get_REGSRAM_545_reg   (*((volatile unsigned int*) REGSRAM_545_reg))
+#define get_REGSRAM_546_reg   (*((volatile unsigned int*) REGSRAM_546_reg))
+#define get_REGSRAM_547_reg   (*((volatile unsigned int*) REGSRAM_547_reg))
+#define get_REGSRAM_548_reg   (*((volatile unsigned int*) REGSRAM_548_reg))
+#define get_REGSRAM_549_reg   (*((volatile unsigned int*) REGSRAM_549_reg))
+#define get_REGSRAM_550_reg   (*((volatile unsigned int*) REGSRAM_550_reg))
+#define get_REGSRAM_551_reg   (*((volatile unsigned int*) REGSRAM_551_reg))
+#define get_REGSRAM_552_reg   (*((volatile unsigned int*) REGSRAM_552_reg))
+#define get_REGSRAM_553_reg   (*((volatile unsigned int*) REGSRAM_553_reg))
+#define get_REGSRAM_554_reg   (*((volatile unsigned int*) REGSRAM_554_reg))
+#define get_REGSRAM_555_reg   (*((volatile unsigned int*) REGSRAM_555_reg))
+#define get_REGSRAM_556_reg   (*((volatile unsigned int*) REGSRAM_556_reg))
+#define get_REGSRAM_557_reg   (*((volatile unsigned int*) REGSRAM_557_reg))
+#define get_REGSRAM_558_reg   (*((volatile unsigned int*) REGSRAM_558_reg))
+#define get_REGSRAM_559_reg   (*((volatile unsigned int*) REGSRAM_559_reg))
+#define get_REGSRAM_560_reg   (*((volatile unsigned int*) REGSRAM_560_reg))
+#define get_REGSRAM_561_reg   (*((volatile unsigned int*) REGSRAM_561_reg))
+#define get_REGSRAM_562_reg   (*((volatile unsigned int*) REGSRAM_562_reg))
+#define get_REGSRAM_563_reg   (*((volatile unsigned int*) REGSRAM_563_reg))
+#define get_REGSRAM_564_reg   (*((volatile unsigned int*) REGSRAM_564_reg))
+#define get_REGSRAM_565_reg   (*((volatile unsigned int*) REGSRAM_565_reg))
+#define get_REGSRAM_566_reg   (*((volatile unsigned int*) REGSRAM_566_reg))
+#define get_REGSRAM_567_reg   (*((volatile unsigned int*) REGSRAM_567_reg))
+#define get_REGSRAM_568_reg   (*((volatile unsigned int*) REGSRAM_568_reg))
+#define get_REGSRAM_569_reg   (*((volatile unsigned int*) REGSRAM_569_reg))
+#define get_REGSRAM_570_reg   (*((volatile unsigned int*) REGSRAM_570_reg))
+#define get_REGSRAM_571_reg   (*((volatile unsigned int*) REGSRAM_571_reg))
+#define get_REGSRAM_572_reg   (*((volatile unsigned int*) REGSRAM_572_reg))
+#define get_REGSRAM_573_reg   (*((volatile unsigned int*) REGSRAM_573_reg))
+#define get_REGSRAM_574_reg   (*((volatile unsigned int*) REGSRAM_574_reg))
+#define get_REGSRAM_575_reg   (*((volatile unsigned int*) REGSRAM_575_reg))
+#define get_REGSRAM_576_reg   (*((volatile unsigned int*) REGSRAM_576_reg))
+#define get_REGSRAM_577_reg   (*((volatile unsigned int*) REGSRAM_577_reg))
+#define get_REGSRAM_578_reg   (*((volatile unsigned int*) REGSRAM_578_reg))
+#define get_REGSRAM_579_reg   (*((volatile unsigned int*) REGSRAM_579_reg))
+#define get_REGSRAM_580_reg   (*((volatile unsigned int*) REGSRAM_580_reg))
+#define get_REGSRAM_581_reg   (*((volatile unsigned int*) REGSRAM_581_reg))
+#define get_REGSRAM_582_reg   (*((volatile unsigned int*) REGSRAM_582_reg))
+#define get_REGSRAM_583_reg   (*((volatile unsigned int*) REGSRAM_583_reg))
+#define get_REGSRAM_584_reg   (*((volatile unsigned int*) REGSRAM_584_reg))
+#define get_REGSRAM_585_reg   (*((volatile unsigned int*) REGSRAM_585_reg))
+#define get_REGSRAM_586_reg   (*((volatile unsigned int*) REGSRAM_586_reg))
+#define get_REGSRAM_587_reg   (*((volatile unsigned int*) REGSRAM_587_reg))
+#define get_REGSRAM_588_reg   (*((volatile unsigned int*) REGSRAM_588_reg))
+#define get_REGSRAM_589_reg   (*((volatile unsigned int*) REGSRAM_589_reg))
+#define get_REGSRAM_590_reg   (*((volatile unsigned int*) REGSRAM_590_reg))
+#define get_REGSRAM_591_reg   (*((volatile unsigned int*) REGSRAM_591_reg))
+#define get_REGSRAM_592_reg   (*((volatile unsigned int*) REGSRAM_592_reg))
+#define get_REGSRAM_593_reg   (*((volatile unsigned int*) REGSRAM_593_reg))
+#define get_REGSRAM_594_reg   (*((volatile unsigned int*) REGSRAM_594_reg))
+#define get_REGSRAM_595_reg   (*((volatile unsigned int*) REGSRAM_595_reg))
+#define get_REGSRAM_596_reg   (*((volatile unsigned int*) REGSRAM_596_reg))
+#define get_REGSRAM_597_reg   (*((volatile unsigned int*) REGSRAM_597_reg))
+#define get_REGSRAM_598_reg   (*((volatile unsigned int*) REGSRAM_598_reg))
+#define get_REGSRAM_599_reg   (*((volatile unsigned int*) REGSRAM_599_reg))
+#define get_REGSRAM_600_reg   (*((volatile unsigned int*) REGSRAM_600_reg))
+#define get_REGSRAM_601_reg   (*((volatile unsigned int*) REGSRAM_601_reg))
+#define get_REGSRAM_602_reg   (*((volatile unsigned int*) REGSRAM_602_reg))
+#define get_REGSRAM_603_reg   (*((volatile unsigned int*) REGSRAM_603_reg))
+#define get_REGSRAM_604_reg   (*((volatile unsigned int*) REGSRAM_604_reg))
+#define get_REGSRAM_605_reg   (*((volatile unsigned int*) REGSRAM_605_reg))
+#define get_REGSRAM_606_reg   (*((volatile unsigned int*) REGSRAM_606_reg))
+#define get_REGSRAM_607_reg   (*((volatile unsigned int*) REGSRAM_607_reg))
+#define get_REGSRAM_608_reg   (*((volatile unsigned int*) REGSRAM_608_reg))
+#define get_REGSRAM_609_reg   (*((volatile unsigned int*) REGSRAM_609_reg))
+#define get_REGSRAM_610_reg   (*((volatile unsigned int*) REGSRAM_610_reg))
+#define get_REGSRAM_611_reg   (*((volatile unsigned int*) REGSRAM_611_reg))
+#define get_REGSRAM_612_reg   (*((volatile unsigned int*) REGSRAM_612_reg))
+#define get_REGSRAM_613_reg   (*((volatile unsigned int*) REGSRAM_613_reg))
+#define get_REGSRAM_614_reg   (*((volatile unsigned int*) REGSRAM_614_reg))
+#define get_REGSRAM_615_reg   (*((volatile unsigned int*) REGSRAM_615_reg))
+#define get_REGSRAM_616_reg   (*((volatile unsigned int*) REGSRAM_616_reg))
+#define get_REGSRAM_617_reg   (*((volatile unsigned int*) REGSRAM_617_reg))
+#define get_REGSRAM_618_reg   (*((volatile unsigned int*) REGSRAM_618_reg))
+#define get_REGSRAM_619_reg   (*((volatile unsigned int*) REGSRAM_619_reg))
+#define get_REGSRAM_620_reg   (*((volatile unsigned int*) REGSRAM_620_reg))
+#define get_REGSRAM_621_reg   (*((volatile unsigned int*) REGSRAM_621_reg))
+#define get_REGSRAM_622_reg   (*((volatile unsigned int*) REGSRAM_622_reg))
+#define get_REGSRAM_623_reg   (*((volatile unsigned int*) REGSRAM_623_reg))
+#define get_REGSRAM_624_reg   (*((volatile unsigned int*) REGSRAM_624_reg))
+#define get_REGSRAM_625_reg   (*((volatile unsigned int*) REGSRAM_625_reg))
+#define get_REGSRAM_626_reg   (*((volatile unsigned int*) REGSRAM_626_reg))
+#define get_REGSRAM_627_reg   (*((volatile unsigned int*) REGSRAM_627_reg))
+#define get_REGSRAM_628_reg   (*((volatile unsigned int*) REGSRAM_628_reg))
+#define get_REGSRAM_629_reg   (*((volatile unsigned int*) REGSRAM_629_reg))
+#define get_REGSRAM_630_reg   (*((volatile unsigned int*) REGSRAM_630_reg))
+#define get_REGSRAM_631_reg   (*((volatile unsigned int*) REGSRAM_631_reg))
+#define get_REGSRAM_632_reg   (*((volatile unsigned int*) REGSRAM_632_reg))
+#define get_REGSRAM_633_reg   (*((volatile unsigned int*) REGSRAM_633_reg))
+#define get_REGSRAM_634_reg   (*((volatile unsigned int*) REGSRAM_634_reg))
+#define get_REGSRAM_635_reg   (*((volatile unsigned int*) REGSRAM_635_reg))
+#define get_REGSRAM_636_reg   (*((volatile unsigned int*) REGSRAM_636_reg))
+#define get_REGSRAM_637_reg   (*((volatile unsigned int*) REGSRAM_637_reg))
+#define get_REGSRAM_638_reg   (*((volatile unsigned int*) REGSRAM_638_reg))
+#define get_REGSRAM_639_reg   (*((volatile unsigned int*) REGSRAM_639_reg))
+#define get_REGSRAM_640_reg   (*((volatile unsigned int*) REGSRAM_640_reg))
+#define get_REGSRAM_641_reg   (*((volatile unsigned int*) REGSRAM_641_reg))
+#define get_REGSRAM_642_reg   (*((volatile unsigned int*) REGSRAM_642_reg))
+#define get_REGSRAM_643_reg   (*((volatile unsigned int*) REGSRAM_643_reg))
+#define get_REGSRAM_644_reg   (*((volatile unsigned int*) REGSRAM_644_reg))
+#define get_REGSRAM_645_reg   (*((volatile unsigned int*) REGSRAM_645_reg))
+#define get_REGSRAM_646_reg   (*((volatile unsigned int*) REGSRAM_646_reg))
+#define get_REGSRAM_647_reg   (*((volatile unsigned int*) REGSRAM_647_reg))
+#define get_REGSRAM_648_reg   (*((volatile unsigned int*) REGSRAM_648_reg))
+#define get_REGSRAM_649_reg   (*((volatile unsigned int*) REGSRAM_649_reg))
+#define get_REGSRAM_650_reg   (*((volatile unsigned int*) REGSRAM_650_reg))
+#define get_REGSRAM_651_reg   (*((volatile unsigned int*) REGSRAM_651_reg))
+#define get_REGSRAM_652_reg   (*((volatile unsigned int*) REGSRAM_652_reg))
+#define get_REGSRAM_653_reg   (*((volatile unsigned int*) REGSRAM_653_reg))
+#define get_REGSRAM_654_reg   (*((volatile unsigned int*) REGSRAM_654_reg))
+#define get_REGSRAM_655_reg   (*((volatile unsigned int*) REGSRAM_655_reg))
+#define get_REGSRAM_656_reg   (*((volatile unsigned int*) REGSRAM_656_reg))
+#define get_REGSRAM_657_reg   (*((volatile unsigned int*) REGSRAM_657_reg))
+#define get_REGSRAM_658_reg   (*((volatile unsigned int*) REGSRAM_658_reg))
+#define get_REGSRAM_659_reg   (*((volatile unsigned int*) REGSRAM_659_reg))
+#define get_REGSRAM_660_reg   (*((volatile unsigned int*) REGSRAM_660_reg))
+#define get_REGSRAM_661_reg   (*((volatile unsigned int*) REGSRAM_661_reg))
+#define get_REGSRAM_662_reg   (*((volatile unsigned int*) REGSRAM_662_reg))
+#define get_REGSRAM_663_reg   (*((volatile unsigned int*) REGSRAM_663_reg))
+#define get_REGSRAM_664_reg   (*((volatile unsigned int*) REGSRAM_664_reg))
+#define get_REGSRAM_665_reg   (*((volatile unsigned int*) REGSRAM_665_reg))
+#define get_REGSRAM_666_reg   (*((volatile unsigned int*) REGSRAM_666_reg))
+#define get_REGSRAM_667_reg   (*((volatile unsigned int*) REGSRAM_667_reg))
+#define get_REGSRAM_668_reg   (*((volatile unsigned int*) REGSRAM_668_reg))
+#define get_REGSRAM_669_reg   (*((volatile unsigned int*) REGSRAM_669_reg))
+#define get_REGSRAM_670_reg   (*((volatile unsigned int*) REGSRAM_670_reg))
+#define get_REGSRAM_671_reg   (*((volatile unsigned int*) REGSRAM_671_reg))
+#define get_REGSRAM_672_reg   (*((volatile unsigned int*) REGSRAM_672_reg))
+#define get_REGSRAM_673_reg   (*((volatile unsigned int*) REGSRAM_673_reg))
+#define get_REGSRAM_674_reg   (*((volatile unsigned int*) REGSRAM_674_reg))
+#define get_REGSRAM_675_reg   (*((volatile unsigned int*) REGSRAM_675_reg))
+#define get_REGSRAM_676_reg   (*((volatile unsigned int*) REGSRAM_676_reg))
+#define get_REGSRAM_677_reg   (*((volatile unsigned int*) REGSRAM_677_reg))
+#define get_REGSRAM_678_reg   (*((volatile unsigned int*) REGSRAM_678_reg))
+#define get_REGSRAM_679_reg   (*((volatile unsigned int*) REGSRAM_679_reg))
+#define get_REGSRAM_680_reg   (*((volatile unsigned int*) REGSRAM_680_reg))
+#define get_REGSRAM_681_reg   (*((volatile unsigned int*) REGSRAM_681_reg))
+#define get_REGSRAM_682_reg   (*((volatile unsigned int*) REGSRAM_682_reg))
+#define get_REGSRAM_683_reg   (*((volatile unsigned int*) REGSRAM_683_reg))
+#define get_REGSRAM_684_reg   (*((volatile unsigned int*) REGSRAM_684_reg))
+#define get_REGSRAM_685_reg   (*((volatile unsigned int*) REGSRAM_685_reg))
+#define get_REGSRAM_686_reg   (*((volatile unsigned int*) REGSRAM_686_reg))
+#define get_REGSRAM_687_reg   (*((volatile unsigned int*) REGSRAM_687_reg))
+#define get_REGSRAM_688_reg   (*((volatile unsigned int*) REGSRAM_688_reg))
+#define get_REGSRAM_689_reg   (*((volatile unsigned int*) REGSRAM_689_reg))
+#define get_REGSRAM_690_reg   (*((volatile unsigned int*) REGSRAM_690_reg))
+#define get_REGSRAM_691_reg   (*((volatile unsigned int*) REGSRAM_691_reg))
+#define get_REGSRAM_692_reg   (*((volatile unsigned int*) REGSRAM_692_reg))
+#define get_REGSRAM_693_reg   (*((volatile unsigned int*) REGSRAM_693_reg))
+#define get_REGSRAM_694_reg   (*((volatile unsigned int*) REGSRAM_694_reg))
+#define get_REGSRAM_695_reg   (*((volatile unsigned int*) REGSRAM_695_reg))
+#define get_REGSRAM_696_reg   (*((volatile unsigned int*) REGSRAM_696_reg))
+#define get_REGSRAM_697_reg   (*((volatile unsigned int*) REGSRAM_697_reg))
+#define get_REGSRAM_698_reg   (*((volatile unsigned int*) REGSRAM_698_reg))
+#define get_REGSRAM_699_reg   (*((volatile unsigned int*) REGSRAM_699_reg))
+#define get_REGSRAM_700_reg   (*((volatile unsigned int*) REGSRAM_700_reg))
+#define get_REGSRAM_701_reg   (*((volatile unsigned int*) REGSRAM_701_reg))
+#define get_REGSRAM_702_reg   (*((volatile unsigned int*) REGSRAM_702_reg))
+#define get_REGSRAM_703_reg   (*((volatile unsigned int*) REGSRAM_703_reg))
+#define get_REGSRAM_704_reg   (*((volatile unsigned int*) REGSRAM_704_reg))
+#define get_REGSRAM_705_reg   (*((volatile unsigned int*) REGSRAM_705_reg))
+#define get_REGSRAM_706_reg   (*((volatile unsigned int*) REGSRAM_706_reg))
+#define get_REGSRAM_707_reg   (*((volatile unsigned int*) REGSRAM_707_reg))
+#define get_REGSRAM_708_reg   (*((volatile unsigned int*) REGSRAM_708_reg))
+#define get_REGSRAM_709_reg   (*((volatile unsigned int*) REGSRAM_709_reg))
+#define get_REGSRAM_710_reg   (*((volatile unsigned int*) REGSRAM_710_reg))
+#define get_REGSRAM_711_reg   (*((volatile unsigned int*) REGSRAM_711_reg))
+#define get_REGSRAM_712_reg   (*((volatile unsigned int*) REGSRAM_712_reg))
+#define get_REGSRAM_713_reg   (*((volatile unsigned int*) REGSRAM_713_reg))
+#define get_REGSRAM_714_reg   (*((volatile unsigned int*) REGSRAM_714_reg))
+#define get_REGSRAM_715_reg   (*((volatile unsigned int*) REGSRAM_715_reg))
+#define get_REGSRAM_716_reg   (*((volatile unsigned int*) REGSRAM_716_reg))
+#define get_REGSRAM_717_reg   (*((volatile unsigned int*) REGSRAM_717_reg))
+#define get_REGSRAM_718_reg   (*((volatile unsigned int*) REGSRAM_718_reg))
+#define get_REGSRAM_719_reg   (*((volatile unsigned int*) REGSRAM_719_reg))
+#define get_REGSRAM_720_reg   (*((volatile unsigned int*) REGSRAM_720_reg))
+#define get_REGSRAM_721_reg   (*((volatile unsigned int*) REGSRAM_721_reg))
+#define get_REGSRAM_722_reg   (*((volatile unsigned int*) REGSRAM_722_reg))
+#define get_REGSRAM_723_reg   (*((volatile unsigned int*) REGSRAM_723_reg))
+#define get_REGSRAM_724_reg   (*((volatile unsigned int*) REGSRAM_724_reg))
+#define get_REGSRAM_725_reg   (*((volatile unsigned int*) REGSRAM_725_reg))
+#define get_REGSRAM_726_reg   (*((volatile unsigned int*) REGSRAM_726_reg))
+#define get_REGSRAM_727_reg   (*((volatile unsigned int*) REGSRAM_727_reg))
+#define get_REGSRAM_728_reg   (*((volatile unsigned int*) REGSRAM_728_reg))
+#define get_REGSRAM_729_reg   (*((volatile unsigned int*) REGSRAM_729_reg))
+#define get_REGSRAM_730_reg   (*((volatile unsigned int*) REGSRAM_730_reg))
+#define get_REGSRAM_731_reg   (*((volatile unsigned int*) REGSRAM_731_reg))
+#define get_REGSRAM_732_reg   (*((volatile unsigned int*) REGSRAM_732_reg))
+#define get_REGSRAM_733_reg   (*((volatile unsigned int*) REGSRAM_733_reg))
+#define get_REGSRAM_734_reg   (*((volatile unsigned int*) REGSRAM_734_reg))
+#define get_REGSRAM_735_reg   (*((volatile unsigned int*) REGSRAM_735_reg))
+#define get_REGSRAM_736_reg   (*((volatile unsigned int*) REGSRAM_736_reg))
+#define get_REGSRAM_737_reg   (*((volatile unsigned int*) REGSRAM_737_reg))
+#define get_REGSRAM_738_reg   (*((volatile unsigned int*) REGSRAM_738_reg))
+#define get_REGSRAM_739_reg   (*((volatile unsigned int*) REGSRAM_739_reg))
+#define get_REGSRAM_740_reg   (*((volatile unsigned int*) REGSRAM_740_reg))
+#define get_REGSRAM_741_reg   (*((volatile unsigned int*) REGSRAM_741_reg))
+#define get_REGSRAM_742_reg   (*((volatile unsigned int*) REGSRAM_742_reg))
+#define get_REGSRAM_743_reg   (*((volatile unsigned int*) REGSRAM_743_reg))
+#define get_REGSRAM_744_reg   (*((volatile unsigned int*) REGSRAM_744_reg))
+#define get_REGSRAM_745_reg   (*((volatile unsigned int*) REGSRAM_745_reg))
+#define get_REGSRAM_746_reg   (*((volatile unsigned int*) REGSRAM_746_reg))
+#define get_REGSRAM_747_reg   (*((volatile unsigned int*) REGSRAM_747_reg))
+#define get_REGSRAM_748_reg   (*((volatile unsigned int*) REGSRAM_748_reg))
+#define get_REGSRAM_749_reg   (*((volatile unsigned int*) REGSRAM_749_reg))
+#define get_REGSRAM_750_reg   (*((volatile unsigned int*) REGSRAM_750_reg))
+#define get_REGSRAM_751_reg   (*((volatile unsigned int*) REGSRAM_751_reg))
+#define get_REGSRAM_752_reg   (*((volatile unsigned int*) REGSRAM_752_reg))
+#define get_REGSRAM_753_reg   (*((volatile unsigned int*) REGSRAM_753_reg))
+#define get_REGSRAM_754_reg   (*((volatile unsigned int*) REGSRAM_754_reg))
+#define get_REGSRAM_755_reg   (*((volatile unsigned int*) REGSRAM_755_reg))
+#define get_REGSRAM_756_reg   (*((volatile unsigned int*) REGSRAM_756_reg))
+#define get_REGSRAM_757_reg   (*((volatile unsigned int*) REGSRAM_757_reg))
+#define get_REGSRAM_758_reg   (*((volatile unsigned int*) REGSRAM_758_reg))
+#define get_REGSRAM_759_reg   (*((volatile unsigned int*) REGSRAM_759_reg))
+#define get_REGSRAM_760_reg   (*((volatile unsigned int*) REGSRAM_760_reg))
+#define get_REGSRAM_761_reg   (*((volatile unsigned int*) REGSRAM_761_reg))
+#define get_REGSRAM_762_reg   (*((volatile unsigned int*) REGSRAM_762_reg))
+#define get_REGSRAM_763_reg   (*((volatile unsigned int*) REGSRAM_763_reg))
+#define get_REGSRAM_764_reg   (*((volatile unsigned int*) REGSRAM_764_reg))
+#define get_REGSRAM_765_reg   (*((volatile unsigned int*) REGSRAM_765_reg))
+#define get_REGSRAM_766_reg   (*((volatile unsigned int*) REGSRAM_766_reg))
+#define get_REGSRAM_767_reg   (*((volatile unsigned int*) REGSRAM_767_reg))
+#define get_REGSRAM_768_reg   (*((volatile unsigned int*) REGSRAM_768_reg))
+#define get_REGSRAM_769_reg   (*((volatile unsigned int*) REGSRAM_769_reg))
+#define get_REGSRAM_770_reg   (*((volatile unsigned int*) REGSRAM_770_reg))
+#define get_REGSRAM_771_reg   (*((volatile unsigned int*) REGSRAM_771_reg))
+#define get_REGSRAM_772_reg   (*((volatile unsigned int*) REGSRAM_772_reg))
+#define get_REGSRAM_773_reg   (*((volatile unsigned int*) REGSRAM_773_reg))
+#define get_REGSRAM_774_reg   (*((volatile unsigned int*) REGSRAM_774_reg))
+#define get_REGSRAM_775_reg   (*((volatile unsigned int*) REGSRAM_775_reg))
+#define get_REGSRAM_776_reg   (*((volatile unsigned int*) REGSRAM_776_reg))
+#define get_REGSRAM_777_reg   (*((volatile unsigned int*) REGSRAM_777_reg))
+#define get_REGSRAM_778_reg   (*((volatile unsigned int*) REGSRAM_778_reg))
+#define get_REGSRAM_779_reg   (*((volatile unsigned int*) REGSRAM_779_reg))
+#define get_REGSRAM_780_reg   (*((volatile unsigned int*) REGSRAM_780_reg))
+#define get_REGSRAM_781_reg   (*((volatile unsigned int*) REGSRAM_781_reg))
+#define get_REGSRAM_782_reg   (*((volatile unsigned int*) REGSRAM_782_reg))
+#define get_REGSRAM_783_reg   (*((volatile unsigned int*) REGSRAM_783_reg))
+#define get_REGSRAM_784_reg   (*((volatile unsigned int*) REGSRAM_784_reg))
+#define get_REGSRAM_785_reg   (*((volatile unsigned int*) REGSRAM_785_reg))
+#define get_REGSRAM_786_reg   (*((volatile unsigned int*) REGSRAM_786_reg))
+#define get_REGSRAM_787_reg   (*((volatile unsigned int*) REGSRAM_787_reg))
+#define get_REGSRAM_788_reg   (*((volatile unsigned int*) REGSRAM_788_reg))
+#define get_REGSRAM_789_reg   (*((volatile unsigned int*) REGSRAM_789_reg))
+#define get_REGSRAM_790_reg   (*((volatile unsigned int*) REGSRAM_790_reg))
+#define get_REGSRAM_791_reg   (*((volatile unsigned int*) REGSRAM_791_reg))
+#define get_REGSRAM_792_reg   (*((volatile unsigned int*) REGSRAM_792_reg))
+#define get_REGSRAM_793_reg   (*((volatile unsigned int*) REGSRAM_793_reg))
+#define get_REGSRAM_794_reg   (*((volatile unsigned int*) REGSRAM_794_reg))
+#define get_REGSRAM_795_reg   (*((volatile unsigned int*) REGSRAM_795_reg))
+#define get_REGSRAM_796_reg   (*((volatile unsigned int*) REGSRAM_796_reg))
+#define get_REGSRAM_797_reg   (*((volatile unsigned int*) REGSRAM_797_reg))
+#define get_REGSRAM_798_reg   (*((volatile unsigned int*) REGSRAM_798_reg))
+#define get_REGSRAM_799_reg   (*((volatile unsigned int*) REGSRAM_799_reg))
+#define get_REGSRAM_800_reg   (*((volatile unsigned int*) REGSRAM_800_reg))
+#define get_REGSRAM_801_reg   (*((volatile unsigned int*) REGSRAM_801_reg))
+#define get_REGSRAM_802_reg   (*((volatile unsigned int*) REGSRAM_802_reg))
+#define get_REGSRAM_803_reg   (*((volatile unsigned int*) REGSRAM_803_reg))
+#define get_REGSRAM_804_reg   (*((volatile unsigned int*) REGSRAM_804_reg))
+#define get_REGSRAM_805_reg   (*((volatile unsigned int*) REGSRAM_805_reg))
+#define get_REGSRAM_806_reg   (*((volatile unsigned int*) REGSRAM_806_reg))
+#define get_REGSRAM_807_reg   (*((volatile unsigned int*) REGSRAM_807_reg))
+#define get_REGSRAM_808_reg   (*((volatile unsigned int*) REGSRAM_808_reg))
+#define get_REGSRAM_809_reg   (*((volatile unsigned int*) REGSRAM_809_reg))
+#define get_REGSRAM_810_reg   (*((volatile unsigned int*) REGSRAM_810_reg))
+#define get_REGSRAM_811_reg   (*((volatile unsigned int*) REGSRAM_811_reg))
+#define get_REGSRAM_812_reg   (*((volatile unsigned int*) REGSRAM_812_reg))
+#define get_REGSRAM_813_reg   (*((volatile unsigned int*) REGSRAM_813_reg))
+#define get_REGSRAM_814_reg   (*((volatile unsigned int*) REGSRAM_814_reg))
+#define get_REGSRAM_815_reg   (*((volatile unsigned int*) REGSRAM_815_reg))
+#define get_REGSRAM_816_reg   (*((volatile unsigned int*) REGSRAM_816_reg))
+#define get_REGSRAM_817_reg   (*((volatile unsigned int*) REGSRAM_817_reg))
+#define get_REGSRAM_818_reg   (*((volatile unsigned int*) REGSRAM_818_reg))
+#define get_REGSRAM_819_reg   (*((volatile unsigned int*) REGSRAM_819_reg))
+#define get_REGSRAM_820_reg   (*((volatile unsigned int*) REGSRAM_820_reg))
+#define get_REGSRAM_821_reg   (*((volatile unsigned int*) REGSRAM_821_reg))
+#define get_REGSRAM_822_reg   (*((volatile unsigned int*) REGSRAM_822_reg))
+#define get_REGSRAM_823_reg   (*((volatile unsigned int*) REGSRAM_823_reg))
+#define get_REGSRAM_824_reg   (*((volatile unsigned int*) REGSRAM_824_reg))
+#define get_REGSRAM_825_reg   (*((volatile unsigned int*) REGSRAM_825_reg))
+#define get_REGSRAM_826_reg   (*((volatile unsigned int*) REGSRAM_826_reg))
+#define get_REGSRAM_827_reg   (*((volatile unsigned int*) REGSRAM_827_reg))
+#define get_REGSRAM_828_reg   (*((volatile unsigned int*) REGSRAM_828_reg))
+#define get_REGSRAM_829_reg   (*((volatile unsigned int*) REGSRAM_829_reg))
+#define get_REGSRAM_830_reg   (*((volatile unsigned int*) REGSRAM_830_reg))
+#define get_REGSRAM_831_reg   (*((volatile unsigned int*) REGSRAM_831_reg))
+#define get_REGSRAM_832_reg   (*((volatile unsigned int*) REGSRAM_832_reg))
+#define get_REGSRAM_833_reg   (*((volatile unsigned int*) REGSRAM_833_reg))
+#define get_REGSRAM_834_reg   (*((volatile unsigned int*) REGSRAM_834_reg))
+#define get_REGSRAM_835_reg   (*((volatile unsigned int*) REGSRAM_835_reg))
+#define get_REGSRAM_836_reg   (*((volatile unsigned int*) REGSRAM_836_reg))
+#define get_REGSRAM_837_reg   (*((volatile unsigned int*) REGSRAM_837_reg))
+#define get_REGSRAM_838_reg   (*((volatile unsigned int*) REGSRAM_838_reg))
+#define get_REGSRAM_839_reg   (*((volatile unsigned int*) REGSRAM_839_reg))
+#define get_REGSRAM_840_reg   (*((volatile unsigned int*) REGSRAM_840_reg))
+#define get_REGSRAM_841_reg   (*((volatile unsigned int*) REGSRAM_841_reg))
+#define get_REGSRAM_842_reg   (*((volatile unsigned int*) REGSRAM_842_reg))
+#define get_REGSRAM_843_reg   (*((volatile unsigned int*) REGSRAM_843_reg))
+#define get_REGSRAM_844_reg   (*((volatile unsigned int*) REGSRAM_844_reg))
+#define get_REGSRAM_845_reg   (*((volatile unsigned int*) REGSRAM_845_reg))
+#define get_REGSRAM_846_reg   (*((volatile unsigned int*) REGSRAM_846_reg))
+#define get_REGSRAM_847_reg   (*((volatile unsigned int*) REGSRAM_847_reg))
+#define get_REGSRAM_848_reg   (*((volatile unsigned int*) REGSRAM_848_reg))
+#define get_REGSRAM_849_reg   (*((volatile unsigned int*) REGSRAM_849_reg))
+#define get_REGSRAM_850_reg   (*((volatile unsigned int*) REGSRAM_850_reg))
+#define get_REGSRAM_851_reg   (*((volatile unsigned int*) REGSRAM_851_reg))
+#define get_REGSRAM_852_reg   (*((volatile unsigned int*) REGSRAM_852_reg))
+#define get_REGSRAM_853_reg   (*((volatile unsigned int*) REGSRAM_853_reg))
+#define get_REGSRAM_854_reg   (*((volatile unsigned int*) REGSRAM_854_reg))
+#define get_REGSRAM_855_reg   (*((volatile unsigned int*) REGSRAM_855_reg))
+#define get_REGSRAM_856_reg   (*((volatile unsigned int*) REGSRAM_856_reg))
+#define get_REGSRAM_857_reg   (*((volatile unsigned int*) REGSRAM_857_reg))
+#define get_REGSRAM_858_reg   (*((volatile unsigned int*) REGSRAM_858_reg))
+#define get_REGSRAM_859_reg   (*((volatile unsigned int*) REGSRAM_859_reg))
+#define get_REGSRAM_860_reg   (*((volatile unsigned int*) REGSRAM_860_reg))
+#define get_REGSRAM_861_reg   (*((volatile unsigned int*) REGSRAM_861_reg))
+#define get_REGSRAM_862_reg   (*((volatile unsigned int*) REGSRAM_862_reg))
+#define get_REGSRAM_863_reg   (*((volatile unsigned int*) REGSRAM_863_reg))
+#define get_REGSRAM_864_reg   (*((volatile unsigned int*) REGSRAM_864_reg))
+#define get_REGSRAM_865_reg   (*((volatile unsigned int*) REGSRAM_865_reg))
+#define get_REGSRAM_866_reg   (*((volatile unsigned int*) REGSRAM_866_reg))
+#define get_REGSRAM_867_reg   (*((volatile unsigned int*) REGSRAM_867_reg))
+#define get_REGSRAM_868_reg   (*((volatile unsigned int*) REGSRAM_868_reg))
+#define get_REGSRAM_869_reg   (*((volatile unsigned int*) REGSRAM_869_reg))
+#define get_REGSRAM_870_reg   (*((volatile unsigned int*) REGSRAM_870_reg))
+#define get_REGSRAM_871_reg   (*((volatile unsigned int*) REGSRAM_871_reg))
+#define get_REGSRAM_872_reg   (*((volatile unsigned int*) REGSRAM_872_reg))
+#define get_REGSRAM_873_reg   (*((volatile unsigned int*) REGSRAM_873_reg))
+#define get_REGSRAM_874_reg   (*((volatile unsigned int*) REGSRAM_874_reg))
+#define get_REGSRAM_875_reg   (*((volatile unsigned int*) REGSRAM_875_reg))
+#define get_REGSRAM_876_reg   (*((volatile unsigned int*) REGSRAM_876_reg))
+#define get_REGSRAM_877_reg   (*((volatile unsigned int*) REGSRAM_877_reg))
+#define get_REGSRAM_878_reg   (*((volatile unsigned int*) REGSRAM_878_reg))
+#define get_REGSRAM_879_reg   (*((volatile unsigned int*) REGSRAM_879_reg))
+#define get_REGSRAM_880_reg   (*((volatile unsigned int*) REGSRAM_880_reg))
+#define get_REGSRAM_881_reg   (*((volatile unsigned int*) REGSRAM_881_reg))
+#define get_REGSRAM_882_reg   (*((volatile unsigned int*) REGSRAM_882_reg))
+#define get_REGSRAM_883_reg   (*((volatile unsigned int*) REGSRAM_883_reg))
+#define get_REGSRAM_884_reg   (*((volatile unsigned int*) REGSRAM_884_reg))
+#define get_REGSRAM_885_reg   (*((volatile unsigned int*) REGSRAM_885_reg))
+#define get_REGSRAM_886_reg   (*((volatile unsigned int*) REGSRAM_886_reg))
+#define get_REGSRAM_887_reg   (*((volatile unsigned int*) REGSRAM_887_reg))
+#define get_REGSRAM_888_reg   (*((volatile unsigned int*) REGSRAM_888_reg))
+#define get_REGSRAM_889_reg   (*((volatile unsigned int*) REGSRAM_889_reg))
+#define get_REGSRAM_890_reg   (*((volatile unsigned int*) REGSRAM_890_reg))
+#define get_REGSRAM_891_reg   (*((volatile unsigned int*) REGSRAM_891_reg))
+#define get_REGSRAM_892_reg   (*((volatile unsigned int*) REGSRAM_892_reg))
+#define get_REGSRAM_893_reg   (*((volatile unsigned int*) REGSRAM_893_reg))
+#define get_REGSRAM_894_reg   (*((volatile unsigned int*) REGSRAM_894_reg))
+#define get_REGSRAM_895_reg   (*((volatile unsigned int*) REGSRAM_895_reg))
+#define get_REGSRAM_896_reg   (*((volatile unsigned int*) REGSRAM_896_reg))
+#define get_REGSRAM_897_reg   (*((volatile unsigned int*) REGSRAM_897_reg))
+#define get_REGSRAM_898_reg   (*((volatile unsigned int*) REGSRAM_898_reg))
+#define get_REGSRAM_899_reg   (*((volatile unsigned int*) REGSRAM_899_reg))
+#define get_REGSRAM_900_reg   (*((volatile unsigned int*) REGSRAM_900_reg))
+#define get_REGSRAM_901_reg   (*((volatile unsigned int*) REGSRAM_901_reg))
+#define get_REGSRAM_902_reg   (*((volatile unsigned int*) REGSRAM_902_reg))
+#define get_REGSRAM_903_reg   (*((volatile unsigned int*) REGSRAM_903_reg))
+#define get_REGSRAM_904_reg   (*((volatile unsigned int*) REGSRAM_904_reg))
+#define get_REGSRAM_905_reg   (*((volatile unsigned int*) REGSRAM_905_reg))
+#define get_REGSRAM_906_reg   (*((volatile unsigned int*) REGSRAM_906_reg))
+#define get_REGSRAM_907_reg   (*((volatile unsigned int*) REGSRAM_907_reg))
+#define get_REGSRAM_908_reg   (*((volatile unsigned int*) REGSRAM_908_reg))
+#define get_REGSRAM_909_reg   (*((volatile unsigned int*) REGSRAM_909_reg))
+#define get_REGSRAM_910_reg   (*((volatile unsigned int*) REGSRAM_910_reg))
+#define get_REGSRAM_911_reg   (*((volatile unsigned int*) REGSRAM_911_reg))
+#define get_REGSRAM_912_reg   (*((volatile unsigned int*) REGSRAM_912_reg))
+#define get_REGSRAM_913_reg   (*((volatile unsigned int*) REGSRAM_913_reg))
+#define get_REGSRAM_914_reg   (*((volatile unsigned int*) REGSRAM_914_reg))
+#define get_REGSRAM_915_reg   (*((volatile unsigned int*) REGSRAM_915_reg))
+#define get_REGSRAM_916_reg   (*((volatile unsigned int*) REGSRAM_916_reg))
+#define get_REGSRAM_917_reg   (*((volatile unsigned int*) REGSRAM_917_reg))
+#define get_REGSRAM_918_reg   (*((volatile unsigned int*) REGSRAM_918_reg))
+#define get_REGSRAM_919_reg   (*((volatile unsigned int*) REGSRAM_919_reg))
+#define get_REGSRAM_920_reg   (*((volatile unsigned int*) REGSRAM_920_reg))
+#define get_REGSRAM_921_reg   (*((volatile unsigned int*) REGSRAM_921_reg))
+#define get_REGSRAM_922_reg   (*((volatile unsigned int*) REGSRAM_922_reg))
+#define get_REGSRAM_923_reg   (*((volatile unsigned int*) REGSRAM_923_reg))
+#define get_REGSRAM_924_reg   (*((volatile unsigned int*) REGSRAM_924_reg))
+#define get_REGSRAM_925_reg   (*((volatile unsigned int*) REGSRAM_925_reg))
+#define get_REGSRAM_926_reg   (*((volatile unsigned int*) REGSRAM_926_reg))
+#define get_REGSRAM_927_reg   (*((volatile unsigned int*) REGSRAM_927_reg))
+#define get_REGSRAM_928_reg   (*((volatile unsigned int*) REGSRAM_928_reg))
+#define get_REGSRAM_929_reg   (*((volatile unsigned int*) REGSRAM_929_reg))
+#define get_REGSRAM_930_reg   (*((volatile unsigned int*) REGSRAM_930_reg))
+#define get_REGSRAM_931_reg   (*((volatile unsigned int*) REGSRAM_931_reg))
+#define get_REGSRAM_932_reg   (*((volatile unsigned int*) REGSRAM_932_reg))
+#define get_REGSRAM_933_reg   (*((volatile unsigned int*) REGSRAM_933_reg))
+#define get_REGSRAM_934_reg   (*((volatile unsigned int*) REGSRAM_934_reg))
+#define get_REGSRAM_935_reg   (*((volatile unsigned int*) REGSRAM_935_reg))
+#define get_REGSRAM_936_reg   (*((volatile unsigned int*) REGSRAM_936_reg))
+#define get_REGSRAM_937_reg   (*((volatile unsigned int*) REGSRAM_937_reg))
+#define get_REGSRAM_938_reg   (*((volatile unsigned int*) REGSRAM_938_reg))
+#define get_REGSRAM_939_reg   (*((volatile unsigned int*) REGSRAM_939_reg))
+#define get_REGSRAM_940_reg   (*((volatile unsigned int*) REGSRAM_940_reg))
+#define get_REGSRAM_941_reg   (*((volatile unsigned int*) REGSRAM_941_reg))
+#define get_REGSRAM_942_reg   (*((volatile unsigned int*) REGSRAM_942_reg))
+#define get_REGSRAM_943_reg   (*((volatile unsigned int*) REGSRAM_943_reg))
+#define get_REGSRAM_944_reg   (*((volatile unsigned int*) REGSRAM_944_reg))
+#define get_REGSRAM_945_reg   (*((volatile unsigned int*) REGSRAM_945_reg))
+#define get_REGSRAM_946_reg   (*((volatile unsigned int*) REGSRAM_946_reg))
+#define get_REGSRAM_947_reg   (*((volatile unsigned int*) REGSRAM_947_reg))
+#define get_REGSRAM_948_reg   (*((volatile unsigned int*) REGSRAM_948_reg))
+#define get_REGSRAM_949_reg   (*((volatile unsigned int*) REGSRAM_949_reg))
+#define get_REGSRAM_950_reg   (*((volatile unsigned int*) REGSRAM_950_reg))
+#define get_REGSRAM_951_reg   (*((volatile unsigned int*) REGSRAM_951_reg))
+#define get_REGSRAM_952_reg   (*((volatile unsigned int*) REGSRAM_952_reg))
+#define get_REGSRAM_953_reg   (*((volatile unsigned int*) REGSRAM_953_reg))
+#define get_REGSRAM_954_reg   (*((volatile unsigned int*) REGSRAM_954_reg))
+#define get_REGSRAM_955_reg   (*((volatile unsigned int*) REGSRAM_955_reg))
+#define get_REGSRAM_956_reg   (*((volatile unsigned int*) REGSRAM_956_reg))
+#define get_REGSRAM_957_reg   (*((volatile unsigned int*) REGSRAM_957_reg))
+#define get_REGSRAM_958_reg   (*((volatile unsigned int*) REGSRAM_958_reg))
+#define get_REGSRAM_959_reg   (*((volatile unsigned int*) REGSRAM_959_reg))
+#define get_REGSRAM_960_reg   (*((volatile unsigned int*) REGSRAM_960_reg))
+#define get_REGSRAM_961_reg   (*((volatile unsigned int*) REGSRAM_961_reg))
+#define get_REGSRAM_962_reg   (*((volatile unsigned int*) REGSRAM_962_reg))
+#define get_REGSRAM_963_reg   (*((volatile unsigned int*) REGSRAM_963_reg))
+#define get_REGSRAM_964_reg   (*((volatile unsigned int*) REGSRAM_964_reg))
+#define get_REGSRAM_965_reg   (*((volatile unsigned int*) REGSRAM_965_reg))
+#define get_REGSRAM_966_reg   (*((volatile unsigned int*) REGSRAM_966_reg))
+#define get_REGSRAM_967_reg   (*((volatile unsigned int*) REGSRAM_967_reg))
+#define get_REGSRAM_968_reg   (*((volatile unsigned int*) REGSRAM_968_reg))
+#define get_REGSRAM_969_reg   (*((volatile unsigned int*) REGSRAM_969_reg))
+#define get_REGSRAM_970_reg   (*((volatile unsigned int*) REGSRAM_970_reg))
+#define get_REGSRAM_971_reg   (*((volatile unsigned int*) REGSRAM_971_reg))
+#define get_REGSRAM_972_reg   (*((volatile unsigned int*) REGSRAM_972_reg))
+#define get_REGSRAM_973_reg   (*((volatile unsigned int*) REGSRAM_973_reg))
+#define get_REGSRAM_974_reg   (*((volatile unsigned int*) REGSRAM_974_reg))
+#define get_REGSRAM_975_reg   (*((volatile unsigned int*) REGSRAM_975_reg))
+#define get_REGSRAM_976_reg   (*((volatile unsigned int*) REGSRAM_976_reg))
+#define get_REGSRAM_977_reg   (*((volatile unsigned int*) REGSRAM_977_reg))
+#define get_REGSRAM_978_reg   (*((volatile unsigned int*) REGSRAM_978_reg))
+#define get_REGSRAM_979_reg   (*((volatile unsigned int*) REGSRAM_979_reg))
+#define get_REGSRAM_980_reg   (*((volatile unsigned int*) REGSRAM_980_reg))
+#define get_REGSRAM_981_reg   (*((volatile unsigned int*) REGSRAM_981_reg))
+#define get_REGSRAM_982_reg   (*((volatile unsigned int*) REGSRAM_982_reg))
+#define get_REGSRAM_983_reg   (*((volatile unsigned int*) REGSRAM_983_reg))
+#define get_REGSRAM_984_reg   (*((volatile unsigned int*) REGSRAM_984_reg))
+#define get_REGSRAM_985_reg   (*((volatile unsigned int*) REGSRAM_985_reg))
+#define get_REGSRAM_986_reg   (*((volatile unsigned int*) REGSRAM_986_reg))
+#define get_REGSRAM_987_reg   (*((volatile unsigned int*) REGSRAM_987_reg))
+#define get_REGSRAM_988_reg   (*((volatile unsigned int*) REGSRAM_988_reg))
+#define get_REGSRAM_989_reg   (*((volatile unsigned int*) REGSRAM_989_reg))
+#define get_REGSRAM_990_reg   (*((volatile unsigned int*) REGSRAM_990_reg))
+#define get_REGSRAM_991_reg   (*((volatile unsigned int*) REGSRAM_991_reg))
+#define get_REGSRAM_992_reg   (*((volatile unsigned int*) REGSRAM_992_reg))
+#define get_REGSRAM_993_reg   (*((volatile unsigned int*) REGSRAM_993_reg))
+#define get_REGSRAM_994_reg   (*((volatile unsigned int*) REGSRAM_994_reg))
+#define get_REGSRAM_995_reg   (*((volatile unsigned int*) REGSRAM_995_reg))
+#define get_REGSRAM_996_reg   (*((volatile unsigned int*) REGSRAM_996_reg))
+#define get_REGSRAM_997_reg   (*((volatile unsigned int*) REGSRAM_997_reg))
+#define get_REGSRAM_998_reg   (*((volatile unsigned int*) REGSRAM_998_reg))
+#define get_REGSRAM_999_reg   (*((volatile unsigned int*) REGSRAM_999_reg))
+#define get_REGSRAM_1000_reg   (*((volatile unsigned int*) REGSRAM_1000_reg))
+#define get_REGSRAM_1001_reg   (*((volatile unsigned int*) REGSRAM_1001_reg))
+#define get_REGSRAM_1002_reg   (*((volatile unsigned int*) REGSRAM_1002_reg))
+#define get_REGSRAM_1003_reg   (*((volatile unsigned int*) REGSRAM_1003_reg))
+#define get_REGSRAM_1004_reg   (*((volatile unsigned int*) REGSRAM_1004_reg))
+#define get_REGSRAM_1005_reg   (*((volatile unsigned int*) REGSRAM_1005_reg))
+#define get_REGSRAM_1006_reg   (*((volatile unsigned int*) REGSRAM_1006_reg))
+#define get_REGSRAM_1007_reg   (*((volatile unsigned int*) REGSRAM_1007_reg))
+#define get_REGSRAM_1008_reg   (*((volatile unsigned int*) REGSRAM_1008_reg))
+#define get_REGSRAM_1009_reg   (*((volatile unsigned int*) REGSRAM_1009_reg))
+#define get_REGSRAM_1010_reg   (*((volatile unsigned int*) REGSRAM_1010_reg))
+#define get_REGSRAM_1011_reg   (*((volatile unsigned int*) REGSRAM_1011_reg))
+#define get_REGSRAM_1012_reg   (*((volatile unsigned int*) REGSRAM_1012_reg))
+#define get_REGSRAM_1013_reg   (*((volatile unsigned int*) REGSRAM_1013_reg))
+#define get_REGSRAM_1014_reg   (*((volatile unsigned int*) REGSRAM_1014_reg))
+#define get_REGSRAM_1015_reg   (*((volatile unsigned int*) REGSRAM_1015_reg))
+#define get_REGSRAM_1016_reg   (*((volatile unsigned int*) REGSRAM_1016_reg))
+#define get_REGSRAM_1017_reg   (*((volatile unsigned int*) REGSRAM_1017_reg))
+#define get_REGSRAM_1018_reg   (*((volatile unsigned int*) REGSRAM_1018_reg))
+#define get_REGSRAM_1019_reg   (*((volatile unsigned int*) REGSRAM_1019_reg))
+#define get_REGSRAM_1020_reg   (*((volatile unsigned int*) REGSRAM_1020_reg))
+#define get_REGSRAM_1021_reg   (*((volatile unsigned int*) REGSRAM_1021_reg))
+#define get_REGSRAM_1022_reg   (*((volatile unsigned int*) REGSRAM_1022_reg))
+#define get_REGSRAM_1023_reg   (*((volatile unsigned int*) REGSRAM_1023_reg))
+#define REGSRAM_0_inst_adr                                                           "0x0000"
+#define REGSRAM_1_inst_adr                                                           "0x0001"
+#define REGSRAM_2_inst_adr                                                           "0x0002"
+#define REGSRAM_3_inst_adr                                                           "0x0003"
+#define REGSRAM_4_inst_adr                                                           "0x0004"
+#define REGSRAM_5_inst_adr                                                           "0x0005"
+#define REGSRAM_6_inst_adr                                                           "0x0006"
+#define REGSRAM_7_inst_adr                                                           "0x0007"
+#define REGSRAM_8_inst_adr                                                           "0x0008"
+#define REGSRAM_9_inst_adr                                                           "0x0009"
+#define REGSRAM_10_inst_adr                                                           "0x000A"
+#define REGSRAM_11_inst_adr                                                           "0x000B"
+#define REGSRAM_12_inst_adr                                                           "0x000C"
+#define REGSRAM_13_inst_adr                                                           "0x000D"
+#define REGSRAM_14_inst_adr                                                           "0x000E"
+#define REGSRAM_15_inst_adr                                                           "0x000F"
+#define REGSRAM_16_inst_adr                                                           "0x0010"
+#define REGSRAM_17_inst_adr                                                           "0x0011"
+#define REGSRAM_18_inst_adr                                                           "0x0012"
+#define REGSRAM_19_inst_adr                                                           "0x0013"
+#define REGSRAM_20_inst_adr                                                           "0x0014"
+#define REGSRAM_21_inst_adr                                                           "0x0015"
+#define REGSRAM_22_inst_adr                                                           "0x0016"
+#define REGSRAM_23_inst_adr                                                           "0x0017"
+#define REGSRAM_24_inst_adr                                                           "0x0018"
+#define REGSRAM_25_inst_adr                                                           "0x0019"
+#define REGSRAM_26_inst_adr                                                           "0x001A"
+#define REGSRAM_27_inst_adr                                                           "0x001B"
+#define REGSRAM_28_inst_adr                                                           "0x001C"
+#define REGSRAM_29_inst_adr                                                           "0x001D"
+#define REGSRAM_30_inst_adr                                                           "0x001E"
+#define REGSRAM_31_inst_adr                                                           "0x001F"
+#define REGSRAM_32_inst_adr                                                           "0x0020"
+#define REGSRAM_33_inst_adr                                                           "0x0021"
+#define REGSRAM_34_inst_adr                                                           "0x0022"
+#define REGSRAM_35_inst_adr                                                           "0x0023"
+#define REGSRAM_36_inst_adr                                                           "0x0024"
+#define REGSRAM_37_inst_adr                                                           "0x0025"
+#define REGSRAM_38_inst_adr                                                           "0x0026"
+#define REGSRAM_39_inst_adr                                                           "0x0027"
+#define REGSRAM_40_inst_adr                                                           "0x0028"
+#define REGSRAM_41_inst_adr                                                           "0x0029"
+#define REGSRAM_42_inst_adr                                                           "0x002A"
+#define REGSRAM_43_inst_adr                                                           "0x002B"
+#define REGSRAM_44_inst_adr                                                           "0x002C"
+#define REGSRAM_45_inst_adr                                                           "0x002D"
+#define REGSRAM_46_inst_adr                                                           "0x002E"
+#define REGSRAM_47_inst_adr                                                           "0x002F"
+#define REGSRAM_48_inst_adr                                                           "0x0030"
+#define REGSRAM_49_inst_adr                                                           "0x0031"
+#define REGSRAM_50_inst_adr                                                           "0x0032"
+#define REGSRAM_51_inst_adr                                                           "0x0033"
+#define REGSRAM_52_inst_adr                                                           "0x0034"
+#define REGSRAM_53_inst_adr                                                           "0x0035"
+#define REGSRAM_54_inst_adr                                                           "0x0036"
+#define REGSRAM_55_inst_adr                                                           "0x0037"
+#define REGSRAM_56_inst_adr                                                           "0x0038"
+#define REGSRAM_57_inst_adr                                                           "0x0039"
+#define REGSRAM_58_inst_adr                                                           "0x003A"
+#define REGSRAM_59_inst_adr                                                           "0x003B"
+#define REGSRAM_60_inst_adr                                                           "0x003C"
+#define REGSRAM_61_inst_adr                                                           "0x003D"
+#define REGSRAM_62_inst_adr                                                           "0x003E"
+#define REGSRAM_63_inst_adr                                                           "0x003F"
+#define REGSRAM_64_inst_adr                                                           "0x0040"
+#define REGSRAM_65_inst_adr                                                           "0x0041"
+#define REGSRAM_66_inst_adr                                                           "0x0042"
+#define REGSRAM_67_inst_adr                                                           "0x0043"
+#define REGSRAM_68_inst_adr                                                           "0x0044"
+#define REGSRAM_69_inst_adr                                                           "0x0045"
+#define REGSRAM_70_inst_adr                                                           "0x0046"
+#define REGSRAM_71_inst_adr                                                           "0x0047"
+#define REGSRAM_72_inst_adr                                                           "0x0048"
+#define REGSRAM_73_inst_adr                                                           "0x0049"
+#define REGSRAM_74_inst_adr                                                           "0x004A"
+#define REGSRAM_75_inst_adr                                                           "0x004B"
+#define REGSRAM_76_inst_adr                                                           "0x004C"
+#define REGSRAM_77_inst_adr                                                           "0x004D"
+#define REGSRAM_78_inst_adr                                                           "0x004E"
+#define REGSRAM_79_inst_adr                                                           "0x004F"
+#define REGSRAM_80_inst_adr                                                           "0x0050"
+#define REGSRAM_81_inst_adr                                                           "0x0051"
+#define REGSRAM_82_inst_adr                                                           "0x0052"
+#define REGSRAM_83_inst_adr                                                           "0x0053"
+#define REGSRAM_84_inst_adr                                                           "0x0054"
+#define REGSRAM_85_inst_adr                                                           "0x0055"
+#define REGSRAM_86_inst_adr                                                           "0x0056"
+#define REGSRAM_87_inst_adr                                                           "0x0057"
+#define REGSRAM_88_inst_adr                                                           "0x0058"
+#define REGSRAM_89_inst_adr                                                           "0x0059"
+#define REGSRAM_90_inst_adr                                                           "0x005A"
+#define REGSRAM_91_inst_adr                                                           "0x005B"
+#define REGSRAM_92_inst_adr                                                           "0x005C"
+#define REGSRAM_93_inst_adr                                                           "0x005D"
+#define REGSRAM_94_inst_adr                                                           "0x005E"
+#define REGSRAM_95_inst_adr                                                           "0x005F"
+#define REGSRAM_96_inst_adr                                                           "0x0060"
+#define REGSRAM_97_inst_adr                                                           "0x0061"
+#define REGSRAM_98_inst_adr                                                           "0x0062"
+#define REGSRAM_99_inst_adr                                                           "0x0063"
+#define REGSRAM_100_inst_adr                                                           "0x0064"
+#define REGSRAM_101_inst_adr                                                           "0x0065"
+#define REGSRAM_102_inst_adr                                                           "0x0066"
+#define REGSRAM_103_inst_adr                                                           "0x0067"
+#define REGSRAM_104_inst_adr                                                           "0x0068"
+#define REGSRAM_105_inst_adr                                                           "0x0069"
+#define REGSRAM_106_inst_adr                                                           "0x006A"
+#define REGSRAM_107_inst_adr                                                           "0x006B"
+#define REGSRAM_108_inst_adr                                                           "0x006C"
+#define REGSRAM_109_inst_adr                                                           "0x006D"
+#define REGSRAM_110_inst_adr                                                           "0x006E"
+#define REGSRAM_111_inst_adr                                                           "0x006F"
+#define REGSRAM_112_inst_adr                                                           "0x0070"
+#define REGSRAM_113_inst_adr                                                           "0x0071"
+#define REGSRAM_114_inst_adr                                                           "0x0072"
+#define REGSRAM_115_inst_adr                                                           "0x0073"
+#define REGSRAM_116_inst_adr                                                           "0x0074"
+#define REGSRAM_117_inst_adr                                                           "0x0075"
+#define REGSRAM_118_inst_adr                                                           "0x0076"
+#define REGSRAM_119_inst_adr                                                           "0x0077"
+#define REGSRAM_120_inst_adr                                                           "0x0078"
+#define REGSRAM_121_inst_adr                                                           "0x0079"
+#define REGSRAM_122_inst_adr                                                           "0x007A"
+#define REGSRAM_123_inst_adr                                                           "0x007B"
+#define REGSRAM_124_inst_adr                                                           "0x007C"
+#define REGSRAM_125_inst_adr                                                           "0x007D"
+#define REGSRAM_126_inst_adr                                                           "0x007E"
+#define REGSRAM_127_inst_adr                                                           "0x007F"
+#define REGSRAM_128_inst_adr                                                           "0x0080"
+#define REGSRAM_129_inst_adr                                                           "0x0081"
+#define REGSRAM_130_inst_adr                                                           "0x0082"
+#define REGSRAM_131_inst_adr                                                           "0x0083"
+#define REGSRAM_132_inst_adr                                                           "0x0084"
+#define REGSRAM_133_inst_adr                                                           "0x0085"
+#define REGSRAM_134_inst_adr                                                           "0x0086"
+#define REGSRAM_135_inst_adr                                                           "0x0087"
+#define REGSRAM_136_inst_adr                                                           "0x0088"
+#define REGSRAM_137_inst_adr                                                           "0x0089"
+#define REGSRAM_138_inst_adr                                                           "0x008A"
+#define REGSRAM_139_inst_adr                                                           "0x008B"
+#define REGSRAM_140_inst_adr                                                           "0x008C"
+#define REGSRAM_141_inst_adr                                                           "0x008D"
+#define REGSRAM_142_inst_adr                                                           "0x008E"
+#define REGSRAM_143_inst_adr                                                           "0x008F"
+#define REGSRAM_144_inst_adr                                                           "0x0090"
+#define REGSRAM_145_inst_adr                                                           "0x0091"
+#define REGSRAM_146_inst_adr                                                           "0x0092"
+#define REGSRAM_147_inst_adr                                                           "0x0093"
+#define REGSRAM_148_inst_adr                                                           "0x0094"
+#define REGSRAM_149_inst_adr                                                           "0x0095"
+#define REGSRAM_150_inst_adr                                                           "0x0096"
+#define REGSRAM_151_inst_adr                                                           "0x0097"
+#define REGSRAM_152_inst_adr                                                           "0x0098"
+#define REGSRAM_153_inst_adr                                                           "0x0099"
+#define REGSRAM_154_inst_adr                                                           "0x009A"
+#define REGSRAM_155_inst_adr                                                           "0x009B"
+#define REGSRAM_156_inst_adr                                                           "0x009C"
+#define REGSRAM_157_inst_adr                                                           "0x009D"
+#define REGSRAM_158_inst_adr                                                           "0x009E"
+#define REGSRAM_159_inst_adr                                                           "0x009F"
+#define REGSRAM_160_inst_adr                                                           "0x00A0"
+#define REGSRAM_161_inst_adr                                                           "0x00A1"
+#define REGSRAM_162_inst_adr                                                           "0x00A2"
+#define REGSRAM_163_inst_adr                                                           "0x00A3"
+#define REGSRAM_164_inst_adr                                                           "0x00A4"
+#define REGSRAM_165_inst_adr                                                           "0x00A5"
+#define REGSRAM_166_inst_adr                                                           "0x00A6"
+#define REGSRAM_167_inst_adr                                                           "0x00A7"
+#define REGSRAM_168_inst_adr                                                           "0x00A8"
+#define REGSRAM_169_inst_adr                                                           "0x00A9"
+#define REGSRAM_170_inst_adr                                                           "0x00AA"
+#define REGSRAM_171_inst_adr                                                           "0x00AB"
+#define REGSRAM_172_inst_adr                                                           "0x00AC"
+#define REGSRAM_173_inst_adr                                                           "0x00AD"
+#define REGSRAM_174_inst_adr                                                           "0x00AE"
+#define REGSRAM_175_inst_adr                                                           "0x00AF"
+#define REGSRAM_176_inst_adr                                                           "0x00B0"
+#define REGSRAM_177_inst_adr                                                           "0x00B1"
+#define REGSRAM_178_inst_adr                                                           "0x00B2"
+#define REGSRAM_179_inst_adr                                                           "0x00B3"
+#define REGSRAM_180_inst_adr                                                           "0x00B4"
+#define REGSRAM_181_inst_adr                                                           "0x00B5"
+#define REGSRAM_182_inst_adr                                                           "0x00B6"
+#define REGSRAM_183_inst_adr                                                           "0x00B7"
+#define REGSRAM_184_inst_adr                                                           "0x00B8"
+#define REGSRAM_185_inst_adr                                                           "0x00B9"
+#define REGSRAM_186_inst_adr                                                           "0x00BA"
+#define REGSRAM_187_inst_adr                                                           "0x00BB"
+#define REGSRAM_188_inst_adr                                                           "0x00BC"
+#define REGSRAM_189_inst_adr                                                           "0x00BD"
+#define REGSRAM_190_inst_adr                                                           "0x00BE"
+#define REGSRAM_191_inst_adr                                                           "0x00BF"
+#define REGSRAM_192_inst_adr                                                           "0x00C0"
+#define REGSRAM_193_inst_adr                                                           "0x00C1"
+#define REGSRAM_194_inst_adr                                                           "0x00C2"
+#define REGSRAM_195_inst_adr                                                           "0x00C3"
+#define REGSRAM_196_inst_adr                                                           "0x00C4"
+#define REGSRAM_197_inst_adr                                                           "0x00C5"
+#define REGSRAM_198_inst_adr                                                           "0x00C6"
+#define REGSRAM_199_inst_adr                                                           "0x00C7"
+#define REGSRAM_200_inst_adr                                                           "0x00C8"
+#define REGSRAM_201_inst_adr                                                           "0x00C9"
+#define REGSRAM_202_inst_adr                                                           "0x00CA"
+#define REGSRAM_203_inst_adr                                                           "0x00CB"
+#define REGSRAM_204_inst_adr                                                           "0x00CC"
+#define REGSRAM_205_inst_adr                                                           "0x00CD"
+#define REGSRAM_206_inst_adr                                                           "0x00CE"
+#define REGSRAM_207_inst_adr                                                           "0x00CF"
+#define REGSRAM_208_inst_adr                                                           "0x00D0"
+#define REGSRAM_209_inst_adr                                                           "0x00D1"
+#define REGSRAM_210_inst_adr                                                           "0x00D2"
+#define REGSRAM_211_inst_adr                                                           "0x00D3"
+#define REGSRAM_212_inst_adr                                                           "0x00D4"
+#define REGSRAM_213_inst_adr                                                           "0x00D5"
+#define REGSRAM_214_inst_adr                                                           "0x00D6"
+#define REGSRAM_215_inst_adr                                                           "0x00D7"
+#define REGSRAM_216_inst_adr                                                           "0x00D8"
+#define REGSRAM_217_inst_adr                                                           "0x00D9"
+#define REGSRAM_218_inst_adr                                                           "0x00DA"
+#define REGSRAM_219_inst_adr                                                           "0x00DB"
+#define REGSRAM_220_inst_adr                                                           "0x00DC"
+#define REGSRAM_221_inst_adr                                                           "0x00DD"
+#define REGSRAM_222_inst_adr                                                           "0x00DE"
+#define REGSRAM_223_inst_adr                                                           "0x00DF"
+#define REGSRAM_224_inst_adr                                                           "0x00E0"
+#define REGSRAM_225_inst_adr                                                           "0x00E1"
+#define REGSRAM_226_inst_adr                                                           "0x00E2"
+#define REGSRAM_227_inst_adr                                                           "0x00E3"
+#define REGSRAM_228_inst_adr                                                           "0x00E4"
+#define REGSRAM_229_inst_adr                                                           "0x00E5"
+#define REGSRAM_230_inst_adr                                                           "0x00E6"
+#define REGSRAM_231_inst_adr                                                           "0x00E7"
+#define REGSRAM_232_inst_adr                                                           "0x00E8"
+#define REGSRAM_233_inst_adr                                                           "0x00E9"
+#define REGSRAM_234_inst_adr                                                           "0x00EA"
+#define REGSRAM_235_inst_adr                                                           "0x00EB"
+#define REGSRAM_236_inst_adr                                                           "0x00EC"
+#define REGSRAM_237_inst_adr                                                           "0x00ED"
+#define REGSRAM_238_inst_adr                                                           "0x00EE"
+#define REGSRAM_239_inst_adr                                                           "0x00EF"
+#define REGSRAM_240_inst_adr                                                           "0x00F0"
+#define REGSRAM_241_inst_adr                                                           "0x00F1"
+#define REGSRAM_242_inst_adr                                                           "0x00F2"
+#define REGSRAM_243_inst_adr                                                           "0x00F3"
+#define REGSRAM_244_inst_adr                                                           "0x00F4"
+#define REGSRAM_245_inst_adr                                                           "0x00F5"
+#define REGSRAM_246_inst_adr                                                           "0x00F6"
+#define REGSRAM_247_inst_adr                                                           "0x00F7"
+#define REGSRAM_248_inst_adr                                                           "0x00F8"
+#define REGSRAM_249_inst_adr                                                           "0x00F9"
+#define REGSRAM_250_inst_adr                                                           "0x00FA"
+#define REGSRAM_251_inst_adr                                                           "0x00FB"
+#define REGSRAM_252_inst_adr                                                           "0x00FC"
+#define REGSRAM_253_inst_adr                                                           "0x00FD"
+#define REGSRAM_254_inst_adr                                                           "0x00FE"
+#define REGSRAM_255_inst_adr                                                           "0x00FF"
+#define REGSRAM_256_inst_adr                                                           "0x0100"
+#define REGSRAM_257_inst_adr                                                           "0x0101"
+#define REGSRAM_258_inst_adr                                                           "0x0102"
+#define REGSRAM_259_inst_adr                                                           "0x0103"
+#define REGSRAM_260_inst_adr                                                           "0x0104"
+#define REGSRAM_261_inst_adr                                                           "0x0105"
+#define REGSRAM_262_inst_adr                                                           "0x0106"
+#define REGSRAM_263_inst_adr                                                           "0x0107"
+#define REGSRAM_264_inst_adr                                                           "0x0108"
+#define REGSRAM_265_inst_adr                                                           "0x0109"
+#define REGSRAM_266_inst_adr                                                           "0x010A"
+#define REGSRAM_267_inst_adr                                                           "0x010B"
+#define REGSRAM_268_inst_adr                                                           "0x010C"
+#define REGSRAM_269_inst_adr                                                           "0x010D"
+#define REGSRAM_270_inst_adr                                                           "0x010E"
+#define REGSRAM_271_inst_adr                                                           "0x010F"
+#define REGSRAM_272_inst_adr                                                           "0x0110"
+#define REGSRAM_273_inst_adr                                                           "0x0111"
+#define REGSRAM_274_inst_adr                                                           "0x0112"
+#define REGSRAM_275_inst_adr                                                           "0x0113"
+#define REGSRAM_276_inst_adr                                                           "0x0114"
+#define REGSRAM_277_inst_adr                                                           "0x0115"
+#define REGSRAM_278_inst_adr                                                           "0x0116"
+#define REGSRAM_279_inst_adr                                                           "0x0117"
+#define REGSRAM_280_inst_adr                                                           "0x0118"
+#define REGSRAM_281_inst_adr                                                           "0x0119"
+#define REGSRAM_282_inst_adr                                                           "0x011A"
+#define REGSRAM_283_inst_adr                                                           "0x011B"
+#define REGSRAM_284_inst_adr                                                           "0x011C"
+#define REGSRAM_285_inst_adr                                                           "0x011D"
+#define REGSRAM_286_inst_adr                                                           "0x011E"
+#define REGSRAM_287_inst_adr                                                           "0x011F"
+#define REGSRAM_288_inst_adr                                                           "0x0120"
+#define REGSRAM_289_inst_adr                                                           "0x0121"
+#define REGSRAM_290_inst_adr                                                           "0x0122"
+#define REGSRAM_291_inst_adr                                                           "0x0123"
+#define REGSRAM_292_inst_adr                                                           "0x0124"
+#define REGSRAM_293_inst_adr                                                           "0x0125"
+#define REGSRAM_294_inst_adr                                                           "0x0126"
+#define REGSRAM_295_inst_adr                                                           "0x0127"
+#define REGSRAM_296_inst_adr                                                           "0x0128"
+#define REGSRAM_297_inst_adr                                                           "0x0129"
+#define REGSRAM_298_inst_adr                                                           "0x012A"
+#define REGSRAM_299_inst_adr                                                           "0x012B"
+#define REGSRAM_300_inst_adr                                                           "0x012C"
+#define REGSRAM_301_inst_adr                                                           "0x012D"
+#define REGSRAM_302_inst_adr                                                           "0x012E"
+#define REGSRAM_303_inst_adr                                                           "0x012F"
+#define REGSRAM_304_inst_adr                                                           "0x0130"
+#define REGSRAM_305_inst_adr                                                           "0x0131"
+#define REGSRAM_306_inst_adr                                                           "0x0132"
+#define REGSRAM_307_inst_adr                                                           "0x0133"
+#define REGSRAM_308_inst_adr                                                           "0x0134"
+#define REGSRAM_309_inst_adr                                                           "0x0135"
+#define REGSRAM_310_inst_adr                                                           "0x0136"
+#define REGSRAM_311_inst_adr                                                           "0x0137"
+#define REGSRAM_312_inst_adr                                                           "0x0138"
+#define REGSRAM_313_inst_adr                                                           "0x0139"
+#define REGSRAM_314_inst_adr                                                           "0x013A"
+#define REGSRAM_315_inst_adr                                                           "0x013B"
+#define REGSRAM_316_inst_adr                                                           "0x013C"
+#define REGSRAM_317_inst_adr                                                           "0x013D"
+#define REGSRAM_318_inst_adr                                                           "0x013E"
+#define REGSRAM_319_inst_adr                                                           "0x013F"
+#define REGSRAM_320_inst_adr                                                           "0x0140"
+#define REGSRAM_321_inst_adr                                                           "0x0141"
+#define REGSRAM_322_inst_adr                                                           "0x0142"
+#define REGSRAM_323_inst_adr                                                           "0x0143"
+#define REGSRAM_324_inst_adr                                                           "0x0144"
+#define REGSRAM_325_inst_adr                                                           "0x0145"
+#define REGSRAM_326_inst_adr                                                           "0x0146"
+#define REGSRAM_327_inst_adr                                                           "0x0147"
+#define REGSRAM_328_inst_adr                                                           "0x0148"
+#define REGSRAM_329_inst_adr                                                           "0x0149"
+#define REGSRAM_330_inst_adr                                                           "0x014A"
+#define REGSRAM_331_inst_adr                                                           "0x014B"
+#define REGSRAM_332_inst_adr                                                           "0x014C"
+#define REGSRAM_333_inst_adr                                                           "0x014D"
+#define REGSRAM_334_inst_adr                                                           "0x014E"
+#define REGSRAM_335_inst_adr                                                           "0x014F"
+#define REGSRAM_336_inst_adr                                                           "0x0150"
+#define REGSRAM_337_inst_adr                                                           "0x0151"
+#define REGSRAM_338_inst_adr                                                           "0x0152"
+#define REGSRAM_339_inst_adr                                                           "0x0153"
+#define REGSRAM_340_inst_adr                                                           "0x0154"
+#define REGSRAM_341_inst_adr                                                           "0x0155"
+#define REGSRAM_342_inst_adr                                                           "0x0156"
+#define REGSRAM_343_inst_adr                                                           "0x0157"
+#define REGSRAM_344_inst_adr                                                           "0x0158"
+#define REGSRAM_345_inst_adr                                                           "0x0159"
+#define REGSRAM_346_inst_adr                                                           "0x015A"
+#define REGSRAM_347_inst_adr                                                           "0x015B"
+#define REGSRAM_348_inst_adr                                                           "0x015C"
+#define REGSRAM_349_inst_adr                                                           "0x015D"
+#define REGSRAM_350_inst_adr                                                           "0x015E"
+#define REGSRAM_351_inst_adr                                                           "0x015F"
+#define REGSRAM_352_inst_adr                                                           "0x0160"
+#define REGSRAM_353_inst_adr                                                           "0x0161"
+#define REGSRAM_354_inst_adr                                                           "0x0162"
+#define REGSRAM_355_inst_adr                                                           "0x0163"
+#define REGSRAM_356_inst_adr                                                           "0x0164"
+#define REGSRAM_357_inst_adr                                                           "0x0165"
+#define REGSRAM_358_inst_adr                                                           "0x0166"
+#define REGSRAM_359_inst_adr                                                           "0x0167"
+#define REGSRAM_360_inst_adr                                                           "0x0168"
+#define REGSRAM_361_inst_adr                                                           "0x0169"
+#define REGSRAM_362_inst_adr                                                           "0x016A"
+#define REGSRAM_363_inst_adr                                                           "0x016B"
+#define REGSRAM_364_inst_adr                                                           "0x016C"
+#define REGSRAM_365_inst_adr                                                           "0x016D"
+#define REGSRAM_366_inst_adr                                                           "0x016E"
+#define REGSRAM_367_inst_adr                                                           "0x016F"
+#define REGSRAM_368_inst_adr                                                           "0x0170"
+#define REGSRAM_369_inst_adr                                                           "0x0171"
+#define REGSRAM_370_inst_adr                                                           "0x0172"
+#define REGSRAM_371_inst_adr                                                           "0x0173"
+#define REGSRAM_372_inst_adr                                                           "0x0174"
+#define REGSRAM_373_inst_adr                                                           "0x0175"
+#define REGSRAM_374_inst_adr                                                           "0x0176"
+#define REGSRAM_375_inst_adr                                                           "0x0177"
+#define REGSRAM_376_inst_adr                                                           "0x0178"
+#define REGSRAM_377_inst_adr                                                           "0x0179"
+#define REGSRAM_378_inst_adr                                                           "0x017A"
+#define REGSRAM_379_inst_adr                                                           "0x017B"
+#define REGSRAM_380_inst_adr                                                           "0x017C"
+#define REGSRAM_381_inst_adr                                                           "0x017D"
+#define REGSRAM_382_inst_adr                                                           "0x017E"
+#define REGSRAM_383_inst_adr                                                           "0x017F"
+#define REGSRAM_384_inst_adr                                                           "0x0180"
+#define REGSRAM_385_inst_adr                                                           "0x0181"
+#define REGSRAM_386_inst_adr                                                           "0x0182"
+#define REGSRAM_387_inst_adr                                                           "0x0183"
+#define REGSRAM_388_inst_adr                                                           "0x0184"
+#define REGSRAM_389_inst_adr                                                           "0x0185"
+#define REGSRAM_390_inst_adr                                                           "0x0186"
+#define REGSRAM_391_inst_adr                                                           "0x0187"
+#define REGSRAM_392_inst_adr                                                           "0x0188"
+#define REGSRAM_393_inst_adr                                                           "0x0189"
+#define REGSRAM_394_inst_adr                                                           "0x018A"
+#define REGSRAM_395_inst_adr                                                           "0x018B"
+#define REGSRAM_396_inst_adr                                                           "0x018C"
+#define REGSRAM_397_inst_adr                                                           "0x018D"
+#define REGSRAM_398_inst_adr                                                           "0x018E"
+#define REGSRAM_399_inst_adr                                                           "0x018F"
+#define REGSRAM_400_inst_adr                                                           "0x0190"
+#define REGSRAM_401_inst_adr                                                           "0x0191"
+#define REGSRAM_402_inst_adr                                                           "0x0192"
+#define REGSRAM_403_inst_adr                                                           "0x0193"
+#define REGSRAM_404_inst_adr                                                           "0x0194"
+#define REGSRAM_405_inst_adr                                                           "0x0195"
+#define REGSRAM_406_inst_adr                                                           "0x0196"
+#define REGSRAM_407_inst_adr                                                           "0x0197"
+#define REGSRAM_408_inst_adr                                                           "0x0198"
+#define REGSRAM_409_inst_adr                                                           "0x0199"
+#define REGSRAM_410_inst_adr                                                           "0x019A"
+#define REGSRAM_411_inst_adr                                                           "0x019B"
+#define REGSRAM_412_inst_adr                                                           "0x019C"
+#define REGSRAM_413_inst_adr                                                           "0x019D"
+#define REGSRAM_414_inst_adr                                                           "0x019E"
+#define REGSRAM_415_inst_adr                                                           "0x019F"
+#define REGSRAM_416_inst_adr                                                           "0x01A0"
+#define REGSRAM_417_inst_adr                                                           "0x01A1"
+#define REGSRAM_418_inst_adr                                                           "0x01A2"
+#define REGSRAM_419_inst_adr                                                           "0x01A3"
+#define REGSRAM_420_inst_adr                                                           "0x01A4"
+#define REGSRAM_421_inst_adr                                                           "0x01A5"
+#define REGSRAM_422_inst_adr                                                           "0x01A6"
+#define REGSRAM_423_inst_adr                                                           "0x01A7"
+#define REGSRAM_424_inst_adr                                                           "0x01A8"
+#define REGSRAM_425_inst_adr                                                           "0x01A9"
+#define REGSRAM_426_inst_adr                                                           "0x01AA"
+#define REGSRAM_427_inst_adr                                                           "0x01AB"
+#define REGSRAM_428_inst_adr                                                           "0x01AC"
+#define REGSRAM_429_inst_adr                                                           "0x01AD"
+#define REGSRAM_430_inst_adr                                                           "0x01AE"
+#define REGSRAM_431_inst_adr                                                           "0x01AF"
+#define REGSRAM_432_inst_adr                                                           "0x01B0"
+#define REGSRAM_433_inst_adr                                                           "0x01B1"
+#define REGSRAM_434_inst_adr                                                           "0x01B2"
+#define REGSRAM_435_inst_adr                                                           "0x01B3"
+#define REGSRAM_436_inst_adr                                                           "0x01B4"
+#define REGSRAM_437_inst_adr                                                           "0x01B5"
+#define REGSRAM_438_inst_adr                                                           "0x01B6"
+#define REGSRAM_439_inst_adr                                                           "0x01B7"
+#define REGSRAM_440_inst_adr                                                           "0x01B8"
+#define REGSRAM_441_inst_adr                                                           "0x01B9"
+#define REGSRAM_442_inst_adr                                                           "0x01BA"
+#define REGSRAM_443_inst_adr                                                           "0x01BB"
+#define REGSRAM_444_inst_adr                                                           "0x01BC"
+#define REGSRAM_445_inst_adr                                                           "0x01BD"
+#define REGSRAM_446_inst_adr                                                           "0x01BE"
+#define REGSRAM_447_inst_adr                                                           "0x01BF"
+#define REGSRAM_448_inst_adr                                                           "0x01C0"
+#define REGSRAM_449_inst_adr                                                           "0x01C1"
+#define REGSRAM_450_inst_adr                                                           "0x01C2"
+#define REGSRAM_451_inst_adr                                                           "0x01C3"
+#define REGSRAM_452_inst_adr                                                           "0x01C4"
+#define REGSRAM_453_inst_adr                                                           "0x01C5"
+#define REGSRAM_454_inst_adr                                                           "0x01C6"
+#define REGSRAM_455_inst_adr                                                           "0x01C7"
+#define REGSRAM_456_inst_adr                                                           "0x01C8"
+#define REGSRAM_457_inst_adr                                                           "0x01C9"
+#define REGSRAM_458_inst_adr                                                           "0x01CA"
+#define REGSRAM_459_inst_adr                                                           "0x01CB"
+#define REGSRAM_460_inst_adr                                                           "0x01CC"
+#define REGSRAM_461_inst_adr                                                           "0x01CD"
+#define REGSRAM_462_inst_adr                                                           "0x01CE"
+#define REGSRAM_463_inst_adr                                                           "0x01CF"
+#define REGSRAM_464_inst_adr                                                           "0x01D0"
+#define REGSRAM_465_inst_adr                                                           "0x01D1"
+#define REGSRAM_466_inst_adr                                                           "0x01D2"
+#define REGSRAM_467_inst_adr                                                           "0x01D3"
+#define REGSRAM_468_inst_adr                                                           "0x01D4"
+#define REGSRAM_469_inst_adr                                                           "0x01D5"
+#define REGSRAM_470_inst_adr                                                           "0x01D6"
+#define REGSRAM_471_inst_adr                                                           "0x01D7"
+#define REGSRAM_472_inst_adr                                                           "0x01D8"
+#define REGSRAM_473_inst_adr                                                           "0x01D9"
+#define REGSRAM_474_inst_adr                                                           "0x01DA"
+#define REGSRAM_475_inst_adr                                                           "0x01DB"
+#define REGSRAM_476_inst_adr                                                           "0x01DC"
+#define REGSRAM_477_inst_adr                                                           "0x01DD"
+#define REGSRAM_478_inst_adr                                                           "0x01DE"
+#define REGSRAM_479_inst_adr                                                           "0x01DF"
+#define REGSRAM_480_inst_adr                                                           "0x01E0"
+#define REGSRAM_481_inst_adr                                                           "0x01E1"
+#define REGSRAM_482_inst_adr                                                           "0x01E2"
+#define REGSRAM_483_inst_adr                                                           "0x01E3"
+#define REGSRAM_484_inst_adr                                                           "0x01E4"
+#define REGSRAM_485_inst_adr                                                           "0x01E5"
+#define REGSRAM_486_inst_adr                                                           "0x01E6"
+#define REGSRAM_487_inst_adr                                                           "0x01E7"
+#define REGSRAM_488_inst_adr                                                           "0x01E8"
+#define REGSRAM_489_inst_adr                                                           "0x01E9"
+#define REGSRAM_490_inst_adr                                                           "0x01EA"
+#define REGSRAM_491_inst_adr                                                           "0x01EB"
+#define REGSRAM_492_inst_adr                                                           "0x01EC"
+#define REGSRAM_493_inst_adr                                                           "0x01ED"
+#define REGSRAM_494_inst_adr                                                           "0x01EE"
+#define REGSRAM_495_inst_adr                                                           "0x01EF"
+#define REGSRAM_496_inst_adr                                                           "0x01F0"
+#define REGSRAM_497_inst_adr                                                           "0x01F1"
+#define REGSRAM_498_inst_adr                                                           "0x01F2"
+#define REGSRAM_499_inst_adr                                                           "0x01F3"
+#define REGSRAM_500_inst_adr                                                           "0x01F4"
+#define REGSRAM_501_inst_adr                                                           "0x01F5"
+#define REGSRAM_502_inst_adr                                                           "0x01F6"
+#define REGSRAM_503_inst_adr                                                           "0x01F7"
+#define REGSRAM_504_inst_adr                                                           "0x01F8"
+#define REGSRAM_505_inst_adr                                                           "0x01F9"
+#define REGSRAM_506_inst_adr                                                           "0x01FA"
+#define REGSRAM_507_inst_adr                                                           "0x01FB"
+#define REGSRAM_508_inst_adr                                                           "0x01FC"
+#define REGSRAM_509_inst_adr                                                           "0x01FD"
+#define REGSRAM_510_inst_adr                                                           "0x01FE"
+#define REGSRAM_511_inst_adr                                                           "0x01FF"
+#define REGSRAM_512_inst_adr                                                           "0x0200"
+#define REGSRAM_513_inst_adr                                                           "0x0201"
+#define REGSRAM_514_inst_adr                                                           "0x0202"
+#define REGSRAM_515_inst_adr                                                           "0x0203"
+#define REGSRAM_516_inst_adr                                                           "0x0204"
+#define REGSRAM_517_inst_adr                                                           "0x0205"
+#define REGSRAM_518_inst_adr                                                           "0x0206"
+#define REGSRAM_519_inst_adr                                                           "0x0207"
+#define REGSRAM_520_inst_adr                                                           "0x0208"
+#define REGSRAM_521_inst_adr                                                           "0x0209"
+#define REGSRAM_522_inst_adr                                                           "0x020A"
+#define REGSRAM_523_inst_adr                                                           "0x020B"
+#define REGSRAM_524_inst_adr                                                           "0x020C"
+#define REGSRAM_525_inst_adr                                                           "0x020D"
+#define REGSRAM_526_inst_adr                                                           "0x020E"
+#define REGSRAM_527_inst_adr                                                           "0x020F"
+#define REGSRAM_528_inst_adr                                                           "0x0210"
+#define REGSRAM_529_inst_adr                                                           "0x0211"
+#define REGSRAM_530_inst_adr                                                           "0x0212"
+#define REGSRAM_531_inst_adr                                                           "0x0213"
+#define REGSRAM_532_inst_adr                                                           "0x0214"
+#define REGSRAM_533_inst_adr                                                           "0x0215"
+#define REGSRAM_534_inst_adr                                                           "0x0216"
+#define REGSRAM_535_inst_adr                                                           "0x0217"
+#define REGSRAM_536_inst_adr                                                           "0x0218"
+#define REGSRAM_537_inst_adr                                                           "0x0219"
+#define REGSRAM_538_inst_adr                                                           "0x021A"
+#define REGSRAM_539_inst_adr                                                           "0x021B"
+#define REGSRAM_540_inst_adr                                                           "0x021C"
+#define REGSRAM_541_inst_adr                                                           "0x021D"
+#define REGSRAM_542_inst_adr                                                           "0x021E"
+#define REGSRAM_543_inst_adr                                                           "0x021F"
+#define REGSRAM_544_inst_adr                                                           "0x0220"
+#define REGSRAM_545_inst_adr                                                           "0x0221"
+#define REGSRAM_546_inst_adr                                                           "0x0222"
+#define REGSRAM_547_inst_adr                                                           "0x0223"
+#define REGSRAM_548_inst_adr                                                           "0x0224"
+#define REGSRAM_549_inst_adr                                                           "0x0225"
+#define REGSRAM_550_inst_adr                                                           "0x0226"
+#define REGSRAM_551_inst_adr                                                           "0x0227"
+#define REGSRAM_552_inst_adr                                                           "0x0228"
+#define REGSRAM_553_inst_adr                                                           "0x0229"
+#define REGSRAM_554_inst_adr                                                           "0x022A"
+#define REGSRAM_555_inst_adr                                                           "0x022B"
+#define REGSRAM_556_inst_adr                                                           "0x022C"
+#define REGSRAM_557_inst_adr                                                           "0x022D"
+#define REGSRAM_558_inst_adr                                                           "0x022E"
+#define REGSRAM_559_inst_adr                                                           "0x022F"
+#define REGSRAM_560_inst_adr                                                           "0x0230"
+#define REGSRAM_561_inst_adr                                                           "0x0231"
+#define REGSRAM_562_inst_adr                                                           "0x0232"
+#define REGSRAM_563_inst_adr                                                           "0x0233"
+#define REGSRAM_564_inst_adr                                                           "0x0234"
+#define REGSRAM_565_inst_adr                                                           "0x0235"
+#define REGSRAM_566_inst_adr                                                           "0x0236"
+#define REGSRAM_567_inst_adr                                                           "0x0237"
+#define REGSRAM_568_inst_adr                                                           "0x0238"
+#define REGSRAM_569_inst_adr                                                           "0x0239"
+#define REGSRAM_570_inst_adr                                                           "0x023A"
+#define REGSRAM_571_inst_adr                                                           "0x023B"
+#define REGSRAM_572_inst_adr                                                           "0x023C"
+#define REGSRAM_573_inst_adr                                                           "0x023D"
+#define REGSRAM_574_inst_adr                                                           "0x023E"
+#define REGSRAM_575_inst_adr                                                           "0x023F"
+#define REGSRAM_576_inst_adr                                                           "0x0240"
+#define REGSRAM_577_inst_adr                                                           "0x0241"
+#define REGSRAM_578_inst_adr                                                           "0x0242"
+#define REGSRAM_579_inst_adr                                                           "0x0243"
+#define REGSRAM_580_inst_adr                                                           "0x0244"
+#define REGSRAM_581_inst_adr                                                           "0x0245"
+#define REGSRAM_582_inst_adr                                                           "0x0246"
+#define REGSRAM_583_inst_adr                                                           "0x0247"
+#define REGSRAM_584_inst_adr                                                           "0x0248"
+#define REGSRAM_585_inst_adr                                                           "0x0249"
+#define REGSRAM_586_inst_adr                                                           "0x024A"
+#define REGSRAM_587_inst_adr                                                           "0x024B"
+#define REGSRAM_588_inst_adr                                                           "0x024C"
+#define REGSRAM_589_inst_adr                                                           "0x024D"
+#define REGSRAM_590_inst_adr                                                           "0x024E"
+#define REGSRAM_591_inst_adr                                                           "0x024F"
+#define REGSRAM_592_inst_adr                                                           "0x0250"
+#define REGSRAM_593_inst_adr                                                           "0x0251"
+#define REGSRAM_594_inst_adr                                                           "0x0252"
+#define REGSRAM_595_inst_adr                                                           "0x0253"
+#define REGSRAM_596_inst_adr                                                           "0x0254"
+#define REGSRAM_597_inst_adr                                                           "0x0255"
+#define REGSRAM_598_inst_adr                                                           "0x0256"
+#define REGSRAM_599_inst_adr                                                           "0x0257"
+#define REGSRAM_600_inst_adr                                                           "0x0258"
+#define REGSRAM_601_inst_adr                                                           "0x0259"
+#define REGSRAM_602_inst_adr                                                           "0x025A"
+#define REGSRAM_603_inst_adr                                                           "0x025B"
+#define REGSRAM_604_inst_adr                                                           "0x025C"
+#define REGSRAM_605_inst_adr                                                           "0x025D"
+#define REGSRAM_606_inst_adr                                                           "0x025E"
+#define REGSRAM_607_inst_adr                                                           "0x025F"
+#define REGSRAM_608_inst_adr                                                           "0x0260"
+#define REGSRAM_609_inst_adr                                                           "0x0261"
+#define REGSRAM_610_inst_adr                                                           "0x0262"
+#define REGSRAM_611_inst_adr                                                           "0x0263"
+#define REGSRAM_612_inst_adr                                                           "0x0264"
+#define REGSRAM_613_inst_adr                                                           "0x0265"
+#define REGSRAM_614_inst_adr                                                           "0x0266"
+#define REGSRAM_615_inst_adr                                                           "0x0267"
+#define REGSRAM_616_inst_adr                                                           "0x0268"
+#define REGSRAM_617_inst_adr                                                           "0x0269"
+#define REGSRAM_618_inst_adr                                                           "0x026A"
+#define REGSRAM_619_inst_adr                                                           "0x026B"
+#define REGSRAM_620_inst_adr                                                           "0x026C"
+#define REGSRAM_621_inst_adr                                                           "0x026D"
+#define REGSRAM_622_inst_adr                                                           "0x026E"
+#define REGSRAM_623_inst_adr                                                           "0x026F"
+#define REGSRAM_624_inst_adr                                                           "0x0270"
+#define REGSRAM_625_inst_adr                                                           "0x0271"
+#define REGSRAM_626_inst_adr                                                           "0x0272"
+#define REGSRAM_627_inst_adr                                                           "0x0273"
+#define REGSRAM_628_inst_adr                                                           "0x0274"
+#define REGSRAM_629_inst_adr                                                           "0x0275"
+#define REGSRAM_630_inst_adr                                                           "0x0276"
+#define REGSRAM_631_inst_adr                                                           "0x0277"
+#define REGSRAM_632_inst_adr                                                           "0x0278"
+#define REGSRAM_633_inst_adr                                                           "0x0279"
+#define REGSRAM_634_inst_adr                                                           "0x027A"
+#define REGSRAM_635_inst_adr                                                           "0x027B"
+#define REGSRAM_636_inst_adr                                                           "0x027C"
+#define REGSRAM_637_inst_adr                                                           "0x027D"
+#define REGSRAM_638_inst_adr                                                           "0x027E"
+#define REGSRAM_639_inst_adr                                                           "0x027F"
+#define REGSRAM_640_inst_adr                                                           "0x0280"
+#define REGSRAM_641_inst_adr                                                           "0x0281"
+#define REGSRAM_642_inst_adr                                                           "0x0282"
+#define REGSRAM_643_inst_adr                                                           "0x0283"
+#define REGSRAM_644_inst_adr                                                           "0x0284"
+#define REGSRAM_645_inst_adr                                                           "0x0285"
+#define REGSRAM_646_inst_adr                                                           "0x0286"
+#define REGSRAM_647_inst_adr                                                           "0x0287"
+#define REGSRAM_648_inst_adr                                                           "0x0288"
+#define REGSRAM_649_inst_adr                                                           "0x0289"
+#define REGSRAM_650_inst_adr                                                           "0x028A"
+#define REGSRAM_651_inst_adr                                                           "0x028B"
+#define REGSRAM_652_inst_adr                                                           "0x028C"
+#define REGSRAM_653_inst_adr                                                           "0x028D"
+#define REGSRAM_654_inst_adr                                                           "0x028E"
+#define REGSRAM_655_inst_adr                                                           "0x028F"
+#define REGSRAM_656_inst_adr                                                           "0x0290"
+#define REGSRAM_657_inst_adr                                                           "0x0291"
+#define REGSRAM_658_inst_adr                                                           "0x0292"
+#define REGSRAM_659_inst_adr                                                           "0x0293"
+#define REGSRAM_660_inst_adr                                                           "0x0294"
+#define REGSRAM_661_inst_adr                                                           "0x0295"
+#define REGSRAM_662_inst_adr                                                           "0x0296"
+#define REGSRAM_663_inst_adr                                                           "0x0297"
+#define REGSRAM_664_inst_adr                                                           "0x0298"
+#define REGSRAM_665_inst_adr                                                           "0x0299"
+#define REGSRAM_666_inst_adr                                                           "0x029A"
+#define REGSRAM_667_inst_adr                                                           "0x029B"
+#define REGSRAM_668_inst_adr                                                           "0x029C"
+#define REGSRAM_669_inst_adr                                                           "0x029D"
+#define REGSRAM_670_inst_adr                                                           "0x029E"
+#define REGSRAM_671_inst_adr                                                           "0x029F"
+#define REGSRAM_672_inst_adr                                                           "0x02A0"
+#define REGSRAM_673_inst_adr                                                           "0x02A1"
+#define REGSRAM_674_inst_adr                                                           "0x02A2"
+#define REGSRAM_675_inst_adr                                                           "0x02A3"
+#define REGSRAM_676_inst_adr                                                           "0x02A4"
+#define REGSRAM_677_inst_adr                                                           "0x02A5"
+#define REGSRAM_678_inst_adr                                                           "0x02A6"
+#define REGSRAM_679_inst_adr                                                           "0x02A7"
+#define REGSRAM_680_inst_adr                                                           "0x02A8"
+#define REGSRAM_681_inst_adr                                                           "0x02A9"
+#define REGSRAM_682_inst_adr                                                           "0x02AA"
+#define REGSRAM_683_inst_adr                                                           "0x02AB"
+#define REGSRAM_684_inst_adr                                                           "0x02AC"
+#define REGSRAM_685_inst_adr                                                           "0x02AD"
+#define REGSRAM_686_inst_adr                                                           "0x02AE"
+#define REGSRAM_687_inst_adr                                                           "0x02AF"
+#define REGSRAM_688_inst_adr                                                           "0x02B0"
+#define REGSRAM_689_inst_adr                                                           "0x02B1"
+#define REGSRAM_690_inst_adr                                                           "0x02B2"
+#define REGSRAM_691_inst_adr                                                           "0x02B3"
+#define REGSRAM_692_inst_adr                                                           "0x02B4"
+#define REGSRAM_693_inst_adr                                                           "0x02B5"
+#define REGSRAM_694_inst_adr                                                           "0x02B6"
+#define REGSRAM_695_inst_adr                                                           "0x02B7"
+#define REGSRAM_696_inst_adr                                                           "0x02B8"
+#define REGSRAM_697_inst_adr                                                           "0x02B9"
+#define REGSRAM_698_inst_adr                                                           "0x02BA"
+#define REGSRAM_699_inst_adr                                                           "0x02BB"
+#define REGSRAM_700_inst_adr                                                           "0x02BC"
+#define REGSRAM_701_inst_adr                                                           "0x02BD"
+#define REGSRAM_702_inst_adr                                                           "0x02BE"
+#define REGSRAM_703_inst_adr                                                           "0x02BF"
+#define REGSRAM_704_inst_adr                                                           "0x02C0"
+#define REGSRAM_705_inst_adr                                                           "0x02C1"
+#define REGSRAM_706_inst_adr                                                           "0x02C2"
+#define REGSRAM_707_inst_adr                                                           "0x02C3"
+#define REGSRAM_708_inst_adr                                                           "0x02C4"
+#define REGSRAM_709_inst_adr                                                           "0x02C5"
+#define REGSRAM_710_inst_adr                                                           "0x02C6"
+#define REGSRAM_711_inst_adr                                                           "0x02C7"
+#define REGSRAM_712_inst_adr                                                           "0x02C8"
+#define REGSRAM_713_inst_adr                                                           "0x02C9"
+#define REGSRAM_714_inst_adr                                                           "0x02CA"
+#define REGSRAM_715_inst_adr                                                           "0x02CB"
+#define REGSRAM_716_inst_adr                                                           "0x02CC"
+#define REGSRAM_717_inst_adr                                                           "0x02CD"
+#define REGSRAM_718_inst_adr                                                           "0x02CE"
+#define REGSRAM_719_inst_adr                                                           "0x02CF"
+#define REGSRAM_720_inst_adr                                                           "0x02D0"
+#define REGSRAM_721_inst_adr                                                           "0x02D1"
+#define REGSRAM_722_inst_adr                                                           "0x02D2"
+#define REGSRAM_723_inst_adr                                                           "0x02D3"
+#define REGSRAM_724_inst_adr                                                           "0x02D4"
+#define REGSRAM_725_inst_adr                                                           "0x02D5"
+#define REGSRAM_726_inst_adr                                                           "0x02D6"
+#define REGSRAM_727_inst_adr                                                           "0x02D7"
+#define REGSRAM_728_inst_adr                                                           "0x02D8"
+#define REGSRAM_729_inst_adr                                                           "0x02D9"
+#define REGSRAM_730_inst_adr                                                           "0x02DA"
+#define REGSRAM_731_inst_adr                                                           "0x02DB"
+#define REGSRAM_732_inst_adr                                                           "0x02DC"
+#define REGSRAM_733_inst_adr                                                           "0x02DD"
+#define REGSRAM_734_inst_adr                                                           "0x02DE"
+#define REGSRAM_735_inst_adr                                                           "0x02DF"
+#define REGSRAM_736_inst_adr                                                           "0x02E0"
+#define REGSRAM_737_inst_adr                                                           "0x02E1"
+#define REGSRAM_738_inst_adr                                                           "0x02E2"
+#define REGSRAM_739_inst_adr                                                           "0x02E3"
+#define REGSRAM_740_inst_adr                                                           "0x02E4"
+#define REGSRAM_741_inst_adr                                                           "0x02E5"
+#define REGSRAM_742_inst_adr                                                           "0x02E6"
+#define REGSRAM_743_inst_adr                                                           "0x02E7"
+#define REGSRAM_744_inst_adr                                                           "0x02E8"
+#define REGSRAM_745_inst_adr                                                           "0x02E9"
+#define REGSRAM_746_inst_adr                                                           "0x02EA"
+#define REGSRAM_747_inst_adr                                                           "0x02EB"
+#define REGSRAM_748_inst_adr                                                           "0x02EC"
+#define REGSRAM_749_inst_adr                                                           "0x02ED"
+#define REGSRAM_750_inst_adr                                                           "0x02EE"
+#define REGSRAM_751_inst_adr                                                           "0x02EF"
+#define REGSRAM_752_inst_adr                                                           "0x02F0"
+#define REGSRAM_753_inst_adr                                                           "0x02F1"
+#define REGSRAM_754_inst_adr                                                           "0x02F2"
+#define REGSRAM_755_inst_adr                                                           "0x02F3"
+#define REGSRAM_756_inst_adr                                                           "0x02F4"
+#define REGSRAM_757_inst_adr                                                           "0x02F5"
+#define REGSRAM_758_inst_adr                                                           "0x02F6"
+#define REGSRAM_759_inst_adr                                                           "0x02F7"
+#define REGSRAM_760_inst_adr                                                           "0x02F8"
+#define REGSRAM_761_inst_adr                                                           "0x02F9"
+#define REGSRAM_762_inst_adr                                                           "0x02FA"
+#define REGSRAM_763_inst_adr                                                           "0x02FB"
+#define REGSRAM_764_inst_adr                                                           "0x02FC"
+#define REGSRAM_765_inst_adr                                                           "0x02FD"
+#define REGSRAM_766_inst_adr                                                           "0x02FE"
+#define REGSRAM_767_inst_adr                                                           "0x02FF"
+#define REGSRAM_768_inst_adr                                                           "0x0300"
+#define REGSRAM_769_inst_adr                                                           "0x0301"
+#define REGSRAM_770_inst_adr                                                           "0x0302"
+#define REGSRAM_771_inst_adr                                                           "0x0303"
+#define REGSRAM_772_inst_adr                                                           "0x0304"
+#define REGSRAM_773_inst_adr                                                           "0x0305"
+#define REGSRAM_774_inst_adr                                                           "0x0306"
+#define REGSRAM_775_inst_adr                                                           "0x0307"
+#define REGSRAM_776_inst_adr                                                           "0x0308"
+#define REGSRAM_777_inst_adr                                                           "0x0309"
+#define REGSRAM_778_inst_adr                                                           "0x030A"
+#define REGSRAM_779_inst_adr                                                           "0x030B"
+#define REGSRAM_780_inst_adr                                                           "0x030C"
+#define REGSRAM_781_inst_adr                                                           "0x030D"
+#define REGSRAM_782_inst_adr                                                           "0x030E"
+#define REGSRAM_783_inst_adr                                                           "0x030F"
+#define REGSRAM_784_inst_adr                                                           "0x0310"
+#define REGSRAM_785_inst_adr                                                           "0x0311"
+#define REGSRAM_786_inst_adr                                                           "0x0312"
+#define REGSRAM_787_inst_adr                                                           "0x0313"
+#define REGSRAM_788_inst_adr                                                           "0x0314"
+#define REGSRAM_789_inst_adr                                                           "0x0315"
+#define REGSRAM_790_inst_adr                                                           "0x0316"
+#define REGSRAM_791_inst_adr                                                           "0x0317"
+#define REGSRAM_792_inst_adr                                                           "0x0318"
+#define REGSRAM_793_inst_adr                                                           "0x0319"
+#define REGSRAM_794_inst_adr                                                           "0x031A"
+#define REGSRAM_795_inst_adr                                                           "0x031B"
+#define REGSRAM_796_inst_adr                                                           "0x031C"
+#define REGSRAM_797_inst_adr                                                           "0x031D"
+#define REGSRAM_798_inst_adr                                                           "0x031E"
+#define REGSRAM_799_inst_adr                                                           "0x031F"
+#define REGSRAM_800_inst_adr                                                           "0x0320"
+#define REGSRAM_801_inst_adr                                                           "0x0321"
+#define REGSRAM_802_inst_adr                                                           "0x0322"
+#define REGSRAM_803_inst_adr                                                           "0x0323"
+#define REGSRAM_804_inst_adr                                                           "0x0324"
+#define REGSRAM_805_inst_adr                                                           "0x0325"
+#define REGSRAM_806_inst_adr                                                           "0x0326"
+#define REGSRAM_807_inst_adr                                                           "0x0327"
+#define REGSRAM_808_inst_adr                                                           "0x0328"
+#define REGSRAM_809_inst_adr                                                           "0x0329"
+#define REGSRAM_810_inst_adr                                                           "0x032A"
+#define REGSRAM_811_inst_adr                                                           "0x032B"
+#define REGSRAM_812_inst_adr                                                           "0x032C"
+#define REGSRAM_813_inst_adr                                                           "0x032D"
+#define REGSRAM_814_inst_adr                                                           "0x032E"
+#define REGSRAM_815_inst_adr                                                           "0x032F"
+#define REGSRAM_816_inst_adr                                                           "0x0330"
+#define REGSRAM_817_inst_adr                                                           "0x0331"
+#define REGSRAM_818_inst_adr                                                           "0x0332"
+#define REGSRAM_819_inst_adr                                                           "0x0333"
+#define REGSRAM_820_inst_adr                                                           "0x0334"
+#define REGSRAM_821_inst_adr                                                           "0x0335"
+#define REGSRAM_822_inst_adr                                                           "0x0336"
+#define REGSRAM_823_inst_adr                                                           "0x0337"
+#define REGSRAM_824_inst_adr                                                           "0x0338"
+#define REGSRAM_825_inst_adr                                                           "0x0339"
+#define REGSRAM_826_inst_adr                                                           "0x033A"
+#define REGSRAM_827_inst_adr                                                           "0x033B"
+#define REGSRAM_828_inst_adr                                                           "0x033C"
+#define REGSRAM_829_inst_adr                                                           "0x033D"
+#define REGSRAM_830_inst_adr                                                           "0x033E"
+#define REGSRAM_831_inst_adr                                                           "0x033F"
+#define REGSRAM_832_inst_adr                                                           "0x0340"
+#define REGSRAM_833_inst_adr                                                           "0x0341"
+#define REGSRAM_834_inst_adr                                                           "0x0342"
+#define REGSRAM_835_inst_adr                                                           "0x0343"
+#define REGSRAM_836_inst_adr                                                           "0x0344"
+#define REGSRAM_837_inst_adr                                                           "0x0345"
+#define REGSRAM_838_inst_adr                                                           "0x0346"
+#define REGSRAM_839_inst_adr                                                           "0x0347"
+#define REGSRAM_840_inst_adr                                                           "0x0348"
+#define REGSRAM_841_inst_adr                                                           "0x0349"
+#define REGSRAM_842_inst_adr                                                           "0x034A"
+#define REGSRAM_843_inst_adr                                                           "0x034B"
+#define REGSRAM_844_inst_adr                                                           "0x034C"
+#define REGSRAM_845_inst_adr                                                           "0x034D"
+#define REGSRAM_846_inst_adr                                                           "0x034E"
+#define REGSRAM_847_inst_adr                                                           "0x034F"
+#define REGSRAM_848_inst_adr                                                           "0x0350"
+#define REGSRAM_849_inst_adr                                                           "0x0351"
+#define REGSRAM_850_inst_adr                                                           "0x0352"
+#define REGSRAM_851_inst_adr                                                           "0x0353"
+#define REGSRAM_852_inst_adr                                                           "0x0354"
+#define REGSRAM_853_inst_adr                                                           "0x0355"
+#define REGSRAM_854_inst_adr                                                           "0x0356"
+#define REGSRAM_855_inst_adr                                                           "0x0357"
+#define REGSRAM_856_inst_adr                                                           "0x0358"
+#define REGSRAM_857_inst_adr                                                           "0x0359"
+#define REGSRAM_858_inst_adr                                                           "0x035A"
+#define REGSRAM_859_inst_adr                                                           "0x035B"
+#define REGSRAM_860_inst_adr                                                           "0x035C"
+#define REGSRAM_861_inst_adr                                                           "0x035D"
+#define REGSRAM_862_inst_adr                                                           "0x035E"
+#define REGSRAM_863_inst_adr                                                           "0x035F"
+#define REGSRAM_864_inst_adr                                                           "0x0360"
+#define REGSRAM_865_inst_adr                                                           "0x0361"
+#define REGSRAM_866_inst_adr                                                           "0x0362"
+#define REGSRAM_867_inst_adr                                                           "0x0363"
+#define REGSRAM_868_inst_adr                                                           "0x0364"
+#define REGSRAM_869_inst_adr                                                           "0x0365"
+#define REGSRAM_870_inst_adr                                                           "0x0366"
+#define REGSRAM_871_inst_adr                                                           "0x0367"
+#define REGSRAM_872_inst_adr                                                           "0x0368"
+#define REGSRAM_873_inst_adr                                                           "0x0369"
+#define REGSRAM_874_inst_adr                                                           "0x036A"
+#define REGSRAM_875_inst_adr                                                           "0x036B"
+#define REGSRAM_876_inst_adr                                                           "0x036C"
+#define REGSRAM_877_inst_adr                                                           "0x036D"
+#define REGSRAM_878_inst_adr                                                           "0x036E"
+#define REGSRAM_879_inst_adr                                                           "0x036F"
+#define REGSRAM_880_inst_adr                                                           "0x0370"
+#define REGSRAM_881_inst_adr                                                           "0x0371"
+#define REGSRAM_882_inst_adr                                                           "0x0372"
+#define REGSRAM_883_inst_adr                                                           "0x0373"
+#define REGSRAM_884_inst_adr                                                           "0x0374"
+#define REGSRAM_885_inst_adr                                                           "0x0375"
+#define REGSRAM_886_inst_adr                                                           "0x0376"
+#define REGSRAM_887_inst_adr                                                           "0x0377"
+#define REGSRAM_888_inst_adr                                                           "0x0378"
+#define REGSRAM_889_inst_adr                                                           "0x0379"
+#define REGSRAM_890_inst_adr                                                           "0x037A"
+#define REGSRAM_891_inst_adr                                                           "0x037B"
+#define REGSRAM_892_inst_adr                                                           "0x037C"
+#define REGSRAM_893_inst_adr                                                           "0x037D"
+#define REGSRAM_894_inst_adr                                                           "0x037E"
+#define REGSRAM_895_inst_adr                                                           "0x037F"
+#define REGSRAM_896_inst_adr                                                           "0x0380"
+#define REGSRAM_897_inst_adr                                                           "0x0381"
+#define REGSRAM_898_inst_adr                                                           "0x0382"
+#define REGSRAM_899_inst_adr                                                           "0x0383"
+#define REGSRAM_900_inst_adr                                                           "0x0384"
+#define REGSRAM_901_inst_adr                                                           "0x0385"
+#define REGSRAM_902_inst_adr                                                           "0x0386"
+#define REGSRAM_903_inst_adr                                                           "0x0387"
+#define REGSRAM_904_inst_adr                                                           "0x0388"
+#define REGSRAM_905_inst_adr                                                           "0x0389"
+#define REGSRAM_906_inst_adr                                                           "0x038A"
+#define REGSRAM_907_inst_adr                                                           "0x038B"
+#define REGSRAM_908_inst_adr                                                           "0x038C"
+#define REGSRAM_909_inst_adr                                                           "0x038D"
+#define REGSRAM_910_inst_adr                                                           "0x038E"
+#define REGSRAM_911_inst_adr                                                           "0x038F"
+#define REGSRAM_912_inst_adr                                                           "0x0390"
+#define REGSRAM_913_inst_adr                                                           "0x0391"
+#define REGSRAM_914_inst_adr                                                           "0x0392"
+#define REGSRAM_915_inst_adr                                                           "0x0393"
+#define REGSRAM_916_inst_adr                                                           "0x0394"
+#define REGSRAM_917_inst_adr                                                           "0x0395"
+#define REGSRAM_918_inst_adr                                                           "0x0396"
+#define REGSRAM_919_inst_adr                                                           "0x0397"
+#define REGSRAM_920_inst_adr                                                           "0x0398"
+#define REGSRAM_921_inst_adr                                                           "0x0399"
+#define REGSRAM_922_inst_adr                                                           "0x039A"
+#define REGSRAM_923_inst_adr                                                           "0x039B"
+#define REGSRAM_924_inst_adr                                                           "0x039C"
+#define REGSRAM_925_inst_adr                                                           "0x039D"
+#define REGSRAM_926_inst_adr                                                           "0x039E"
+#define REGSRAM_927_inst_adr                                                           "0x039F"
+#define REGSRAM_928_inst_adr                                                           "0x03A0"
+#define REGSRAM_929_inst_adr                                                           "0x03A1"
+#define REGSRAM_930_inst_adr                                                           "0x03A2"
+#define REGSRAM_931_inst_adr                                                           "0x03A3"
+#define REGSRAM_932_inst_adr                                                           "0x03A4"
+#define REGSRAM_933_inst_adr                                                           "0x03A5"
+#define REGSRAM_934_inst_adr                                                           "0x03A6"
+#define REGSRAM_935_inst_adr                                                           "0x03A7"
+#define REGSRAM_936_inst_adr                                                           "0x03A8"
+#define REGSRAM_937_inst_adr                                                           "0x03A9"
+#define REGSRAM_938_inst_adr                                                           "0x03AA"
+#define REGSRAM_939_inst_adr                                                           "0x03AB"
+#define REGSRAM_940_inst_adr                                                           "0x03AC"
+#define REGSRAM_941_inst_adr                                                           "0x03AD"
+#define REGSRAM_942_inst_adr                                                           "0x03AE"
+#define REGSRAM_943_inst_adr                                                           "0x03AF"
+#define REGSRAM_944_inst_adr                                                           "0x03B0"
+#define REGSRAM_945_inst_adr                                                           "0x03B1"
+#define REGSRAM_946_inst_adr                                                           "0x03B2"
+#define REGSRAM_947_inst_adr                                                           "0x03B3"
+#define REGSRAM_948_inst_adr                                                           "0x03B4"
+#define REGSRAM_949_inst_adr                                                           "0x03B5"
+#define REGSRAM_950_inst_adr                                                           "0x03B6"
+#define REGSRAM_951_inst_adr                                                           "0x03B7"
+#define REGSRAM_952_inst_adr                                                           "0x03B8"
+#define REGSRAM_953_inst_adr                                                           "0x03B9"
+#define REGSRAM_954_inst_adr                                                           "0x03BA"
+#define REGSRAM_955_inst_adr                                                           "0x03BB"
+#define REGSRAM_956_inst_adr                                                           "0x03BC"
+#define REGSRAM_957_inst_adr                                                           "0x03BD"
+#define REGSRAM_958_inst_adr                                                           "0x03BE"
+#define REGSRAM_959_inst_adr                                                           "0x03BF"
+#define REGSRAM_960_inst_adr                                                           "0x03C0"
+#define REGSRAM_961_inst_adr                                                           "0x03C1"
+#define REGSRAM_962_inst_adr                                                           "0x03C2"
+#define REGSRAM_963_inst_adr                                                           "0x03C3"
+#define REGSRAM_964_inst_adr                                                           "0x03C4"
+#define REGSRAM_965_inst_adr                                                           "0x03C5"
+#define REGSRAM_966_inst_adr                                                           "0x03C6"
+#define REGSRAM_967_inst_adr                                                           "0x03C7"
+#define REGSRAM_968_inst_adr                                                           "0x03C8"
+#define REGSRAM_969_inst_adr                                                           "0x03C9"
+#define REGSRAM_970_inst_adr                                                           "0x03CA"
+#define REGSRAM_971_inst_adr                                                           "0x03CB"
+#define REGSRAM_972_inst_adr                                                           "0x03CC"
+#define REGSRAM_973_inst_adr                                                           "0x03CD"
+#define REGSRAM_974_inst_adr                                                           "0x03CE"
+#define REGSRAM_975_inst_adr                                                           "0x03CF"
+#define REGSRAM_976_inst_adr                                                           "0x03D0"
+#define REGSRAM_977_inst_adr                                                           "0x03D1"
+#define REGSRAM_978_inst_adr                                                           "0x03D2"
+#define REGSRAM_979_inst_adr                                                           "0x03D3"
+#define REGSRAM_980_inst_adr                                                           "0x03D4"
+#define REGSRAM_981_inst_adr                                                           "0x03D5"
+#define REGSRAM_982_inst_adr                                                           "0x03D6"
+#define REGSRAM_983_inst_adr                                                           "0x03D7"
+#define REGSRAM_984_inst_adr                                                           "0x03D8"
+#define REGSRAM_985_inst_adr                                                           "0x03D9"
+#define REGSRAM_986_inst_adr                                                           "0x03DA"
+#define REGSRAM_987_inst_adr                                                           "0x03DB"
+#define REGSRAM_988_inst_adr                                                           "0x03DC"
+#define REGSRAM_989_inst_adr                                                           "0x03DD"
+#define REGSRAM_990_inst_adr                                                           "0x03DE"
+#define REGSRAM_991_inst_adr                                                           "0x03DF"
+#define REGSRAM_992_inst_adr                                                           "0x03E0"
+#define REGSRAM_993_inst_adr                                                           "0x03E1"
+#define REGSRAM_994_inst_adr                                                           "0x03E2"
+#define REGSRAM_995_inst_adr                                                           "0x03E3"
+#define REGSRAM_996_inst_adr                                                           "0x03E4"
+#define REGSRAM_997_inst_adr                                                           "0x03E5"
+#define REGSRAM_998_inst_adr                                                           "0x03E6"
+#define REGSRAM_999_inst_adr                                                           "0x03E7"
+#define REGSRAM_1000_inst_adr                                                           "0x03E8"
+#define REGSRAM_1001_inst_adr                                                           "0x03E9"
+#define REGSRAM_1002_inst_adr                                                           "0x03EA"
+#define REGSRAM_1003_inst_adr                                                           "0x03EB"
+#define REGSRAM_1004_inst_adr                                                           "0x03EC"
+#define REGSRAM_1005_inst_adr                                                           "0x03ED"
+#define REGSRAM_1006_inst_adr                                                           "0x03EE"
+#define REGSRAM_1007_inst_adr                                                           "0x03EF"
+#define REGSRAM_1008_inst_adr                                                           "0x03F0"
+#define REGSRAM_1009_inst_adr                                                           "0x03F1"
+#define REGSRAM_1010_inst_adr                                                           "0x03F2"
+#define REGSRAM_1011_inst_adr                                                           "0x03F3"
+#define REGSRAM_1012_inst_adr                                                           "0x03F4"
+#define REGSRAM_1013_inst_adr                                                           "0x03F5"
+#define REGSRAM_1014_inst_adr                                                           "0x03F6"
+#define REGSRAM_1015_inst_adr                                                           "0x03F7"
+#define REGSRAM_1016_inst_adr                                                           "0x03F8"
+#define REGSRAM_1017_inst_adr                                                           "0x03F9"
+#define REGSRAM_1018_inst_adr                                                           "0x03FA"
+#define REGSRAM_1019_inst_adr                                                           "0x03FB"
+#define REGSRAM_1020_inst_adr                                                           "0x03FC"
+#define REGSRAM_1021_inst_adr                                                           "0x03FD"
+#define REGSRAM_1022_inst_adr                                                           "0x03FE"
+#define REGSRAM_1023_inst_adr                                                           "0x03FF"
+#define REGSRAM_0_inst                                                               0x0000
+#define REGSRAM_1_inst                                                               0x0001
+#define REGSRAM_2_inst                                                               0x0002
+#define REGSRAM_3_inst                                                               0x0003
+#define REGSRAM_4_inst                                                               0x0004
+#define REGSRAM_5_inst                                                               0x0005
+#define REGSRAM_6_inst                                                               0x0006
+#define REGSRAM_7_inst                                                               0x0007
+#define REGSRAM_8_inst                                                               0x0008
+#define REGSRAM_9_inst                                                               0x0009
+#define REGSRAM_10_inst                                                               0x000A
+#define REGSRAM_11_inst                                                               0x000B
+#define REGSRAM_12_inst                                                               0x000C
+#define REGSRAM_13_inst                                                               0x000D
+#define REGSRAM_14_inst                                                               0x000E
+#define REGSRAM_15_inst                                                               0x000F
+#define REGSRAM_16_inst                                                               0x0010
+#define REGSRAM_17_inst                                                               0x0011
+#define REGSRAM_18_inst                                                               0x0012
+#define REGSRAM_19_inst                                                               0x0013
+#define REGSRAM_20_inst                                                               0x0014
+#define REGSRAM_21_inst                                                               0x0015
+#define REGSRAM_22_inst                                                               0x0016
+#define REGSRAM_23_inst                                                               0x0017
+#define REGSRAM_24_inst                                                               0x0018
+#define REGSRAM_25_inst                                                               0x0019
+#define REGSRAM_26_inst                                                               0x001A
+#define REGSRAM_27_inst                                                               0x001B
+#define REGSRAM_28_inst                                                               0x001C
+#define REGSRAM_29_inst                                                               0x001D
+#define REGSRAM_30_inst                                                               0x001E
+#define REGSRAM_31_inst                                                               0x001F
+#define REGSRAM_32_inst                                                               0x0020
+#define REGSRAM_33_inst                                                               0x0021
+#define REGSRAM_34_inst                                                               0x0022
+#define REGSRAM_35_inst                                                               0x0023
+#define REGSRAM_36_inst                                                               0x0024
+#define REGSRAM_37_inst                                                               0x0025
+#define REGSRAM_38_inst                                                               0x0026
+#define REGSRAM_39_inst                                                               0x0027
+#define REGSRAM_40_inst                                                               0x0028
+#define REGSRAM_41_inst                                                               0x0029
+#define REGSRAM_42_inst                                                               0x002A
+#define REGSRAM_43_inst                                                               0x002B
+#define REGSRAM_44_inst                                                               0x002C
+#define REGSRAM_45_inst                                                               0x002D
+#define REGSRAM_46_inst                                                               0x002E
+#define REGSRAM_47_inst                                                               0x002F
+#define REGSRAM_48_inst                                                               0x0030
+#define REGSRAM_49_inst                                                               0x0031
+#define REGSRAM_50_inst                                                               0x0032
+#define REGSRAM_51_inst                                                               0x0033
+#define REGSRAM_52_inst                                                               0x0034
+#define REGSRAM_53_inst                                                               0x0035
+#define REGSRAM_54_inst                                                               0x0036
+#define REGSRAM_55_inst                                                               0x0037
+#define REGSRAM_56_inst                                                               0x0038
+#define REGSRAM_57_inst                                                               0x0039
+#define REGSRAM_58_inst                                                               0x003A
+#define REGSRAM_59_inst                                                               0x003B
+#define REGSRAM_60_inst                                                               0x003C
+#define REGSRAM_61_inst                                                               0x003D
+#define REGSRAM_62_inst                                                               0x003E
+#define REGSRAM_63_inst                                                               0x003F
+#define REGSRAM_64_inst                                                               0x0040
+#define REGSRAM_65_inst                                                               0x0041
+#define REGSRAM_66_inst                                                               0x0042
+#define REGSRAM_67_inst                                                               0x0043
+#define REGSRAM_68_inst                                                               0x0044
+#define REGSRAM_69_inst                                                               0x0045
+#define REGSRAM_70_inst                                                               0x0046
+#define REGSRAM_71_inst                                                               0x0047
+#define REGSRAM_72_inst                                                               0x0048
+#define REGSRAM_73_inst                                                               0x0049
+#define REGSRAM_74_inst                                                               0x004A
+#define REGSRAM_75_inst                                                               0x004B
+#define REGSRAM_76_inst                                                               0x004C
+#define REGSRAM_77_inst                                                               0x004D
+#define REGSRAM_78_inst                                                               0x004E
+#define REGSRAM_79_inst                                                               0x004F
+#define REGSRAM_80_inst                                                               0x0050
+#define REGSRAM_81_inst                                                               0x0051
+#define REGSRAM_82_inst                                                               0x0052
+#define REGSRAM_83_inst                                                               0x0053
+#define REGSRAM_84_inst                                                               0x0054
+#define REGSRAM_85_inst                                                               0x0055
+#define REGSRAM_86_inst                                                               0x0056
+#define REGSRAM_87_inst                                                               0x0057
+#define REGSRAM_88_inst                                                               0x0058
+#define REGSRAM_89_inst                                                               0x0059
+#define REGSRAM_90_inst                                                               0x005A
+#define REGSRAM_91_inst                                                               0x005B
+#define REGSRAM_92_inst                                                               0x005C
+#define REGSRAM_93_inst                                                               0x005D
+#define REGSRAM_94_inst                                                               0x005E
+#define REGSRAM_95_inst                                                               0x005F
+#define REGSRAM_96_inst                                                               0x0060
+#define REGSRAM_97_inst                                                               0x0061
+#define REGSRAM_98_inst                                                               0x0062
+#define REGSRAM_99_inst                                                               0x0063
+#define REGSRAM_100_inst                                                               0x0064
+#define REGSRAM_101_inst                                                               0x0065
+#define REGSRAM_102_inst                                                               0x0066
+#define REGSRAM_103_inst                                                               0x0067
+#define REGSRAM_104_inst                                                               0x0068
+#define REGSRAM_105_inst                                                               0x0069
+#define REGSRAM_106_inst                                                               0x006A
+#define REGSRAM_107_inst                                                               0x006B
+#define REGSRAM_108_inst                                                               0x006C
+#define REGSRAM_109_inst                                                               0x006D
+#define REGSRAM_110_inst                                                               0x006E
+#define REGSRAM_111_inst                                                               0x006F
+#define REGSRAM_112_inst                                                               0x0070
+#define REGSRAM_113_inst                                                               0x0071
+#define REGSRAM_114_inst                                                               0x0072
+#define REGSRAM_115_inst                                                               0x0073
+#define REGSRAM_116_inst                                                               0x0074
+#define REGSRAM_117_inst                                                               0x0075
+#define REGSRAM_118_inst                                                               0x0076
+#define REGSRAM_119_inst                                                               0x0077
+#define REGSRAM_120_inst                                                               0x0078
+#define REGSRAM_121_inst                                                               0x0079
+#define REGSRAM_122_inst                                                               0x007A
+#define REGSRAM_123_inst                                                               0x007B
+#define REGSRAM_124_inst                                                               0x007C
+#define REGSRAM_125_inst                                                               0x007D
+#define REGSRAM_126_inst                                                               0x007E
+#define REGSRAM_127_inst                                                               0x007F
+#define REGSRAM_128_inst                                                               0x0080
+#define REGSRAM_129_inst                                                               0x0081
+#define REGSRAM_130_inst                                                               0x0082
+#define REGSRAM_131_inst                                                               0x0083
+#define REGSRAM_132_inst                                                               0x0084
+#define REGSRAM_133_inst                                                               0x0085
+#define REGSRAM_134_inst                                                               0x0086
+#define REGSRAM_135_inst                                                               0x0087
+#define REGSRAM_136_inst                                                               0x0088
+#define REGSRAM_137_inst                                                               0x0089
+#define REGSRAM_138_inst                                                               0x008A
+#define REGSRAM_139_inst                                                               0x008B
+#define REGSRAM_140_inst                                                               0x008C
+#define REGSRAM_141_inst                                                               0x008D
+#define REGSRAM_142_inst                                                               0x008E
+#define REGSRAM_143_inst                                                               0x008F
+#define REGSRAM_144_inst                                                               0x0090
+#define REGSRAM_145_inst                                                               0x0091
+#define REGSRAM_146_inst                                                               0x0092
+#define REGSRAM_147_inst                                                               0x0093
+#define REGSRAM_148_inst                                                               0x0094
+#define REGSRAM_149_inst                                                               0x0095
+#define REGSRAM_150_inst                                                               0x0096
+#define REGSRAM_151_inst                                                               0x0097
+#define REGSRAM_152_inst                                                               0x0098
+#define REGSRAM_153_inst                                                               0x0099
+#define REGSRAM_154_inst                                                               0x009A
+#define REGSRAM_155_inst                                                               0x009B
+#define REGSRAM_156_inst                                                               0x009C
+#define REGSRAM_157_inst                                                               0x009D
+#define REGSRAM_158_inst                                                               0x009E
+#define REGSRAM_159_inst                                                               0x009F
+#define REGSRAM_160_inst                                                               0x00A0
+#define REGSRAM_161_inst                                                               0x00A1
+#define REGSRAM_162_inst                                                               0x00A2
+#define REGSRAM_163_inst                                                               0x00A3
+#define REGSRAM_164_inst                                                               0x00A4
+#define REGSRAM_165_inst                                                               0x00A5
+#define REGSRAM_166_inst                                                               0x00A6
+#define REGSRAM_167_inst                                                               0x00A7
+#define REGSRAM_168_inst                                                               0x00A8
+#define REGSRAM_169_inst                                                               0x00A9
+#define REGSRAM_170_inst                                                               0x00AA
+#define REGSRAM_171_inst                                                               0x00AB
+#define REGSRAM_172_inst                                                               0x00AC
+#define REGSRAM_173_inst                                                               0x00AD
+#define REGSRAM_174_inst                                                               0x00AE
+#define REGSRAM_175_inst                                                               0x00AF
+#define REGSRAM_176_inst                                                               0x00B0
+#define REGSRAM_177_inst                                                               0x00B1
+#define REGSRAM_178_inst                                                               0x00B2
+#define REGSRAM_179_inst                                                               0x00B3
+#define REGSRAM_180_inst                                                               0x00B4
+#define REGSRAM_181_inst                                                               0x00B5
+#define REGSRAM_182_inst                                                               0x00B6
+#define REGSRAM_183_inst                                                               0x00B7
+#define REGSRAM_184_inst                                                               0x00B8
+#define REGSRAM_185_inst                                                               0x00B9
+#define REGSRAM_186_inst                                                               0x00BA
+#define REGSRAM_187_inst                                                               0x00BB
+#define REGSRAM_188_inst                                                               0x00BC
+#define REGSRAM_189_inst                                                               0x00BD
+#define REGSRAM_190_inst                                                               0x00BE
+#define REGSRAM_191_inst                                                               0x00BF
+#define REGSRAM_192_inst                                                               0x00C0
+#define REGSRAM_193_inst                                                               0x00C1
+#define REGSRAM_194_inst                                                               0x00C2
+#define REGSRAM_195_inst                                                               0x00C3
+#define REGSRAM_196_inst                                                               0x00C4
+#define REGSRAM_197_inst                                                               0x00C5
+#define REGSRAM_198_inst                                                               0x00C6
+#define REGSRAM_199_inst                                                               0x00C7
+#define REGSRAM_200_inst                                                               0x00C8
+#define REGSRAM_201_inst                                                               0x00C9
+#define REGSRAM_202_inst                                                               0x00CA
+#define REGSRAM_203_inst                                                               0x00CB
+#define REGSRAM_204_inst                                                               0x00CC
+#define REGSRAM_205_inst                                                               0x00CD
+#define REGSRAM_206_inst                                                               0x00CE
+#define REGSRAM_207_inst                                                               0x00CF
+#define REGSRAM_208_inst                                                               0x00D0
+#define REGSRAM_209_inst                                                               0x00D1
+#define REGSRAM_210_inst                                                               0x00D2
+#define REGSRAM_211_inst                                                               0x00D3
+#define REGSRAM_212_inst                                                               0x00D4
+#define REGSRAM_213_inst                                                               0x00D5
+#define REGSRAM_214_inst                                                               0x00D6
+#define REGSRAM_215_inst                                                               0x00D7
+#define REGSRAM_216_inst                                                               0x00D8
+#define REGSRAM_217_inst                                                               0x00D9
+#define REGSRAM_218_inst                                                               0x00DA
+#define REGSRAM_219_inst                                                               0x00DB
+#define REGSRAM_220_inst                                                               0x00DC
+#define REGSRAM_221_inst                                                               0x00DD
+#define REGSRAM_222_inst                                                               0x00DE
+#define REGSRAM_223_inst                                                               0x00DF
+#define REGSRAM_224_inst                                                               0x00E0
+#define REGSRAM_225_inst                                                               0x00E1
+#define REGSRAM_226_inst                                                               0x00E2
+#define REGSRAM_227_inst                                                               0x00E3
+#define REGSRAM_228_inst                                                               0x00E4
+#define REGSRAM_229_inst                                                               0x00E5
+#define REGSRAM_230_inst                                                               0x00E6
+#define REGSRAM_231_inst                                                               0x00E7
+#define REGSRAM_232_inst                                                               0x00E8
+#define REGSRAM_233_inst                                                               0x00E9
+#define REGSRAM_234_inst                                                               0x00EA
+#define REGSRAM_235_inst                                                               0x00EB
+#define REGSRAM_236_inst                                                               0x00EC
+#define REGSRAM_237_inst                                                               0x00ED
+#define REGSRAM_238_inst                                                               0x00EE
+#define REGSRAM_239_inst                                                               0x00EF
+#define REGSRAM_240_inst                                                               0x00F0
+#define REGSRAM_241_inst                                                               0x00F1
+#define REGSRAM_242_inst                                                               0x00F2
+#define REGSRAM_243_inst                                                               0x00F3
+#define REGSRAM_244_inst                                                               0x00F4
+#define REGSRAM_245_inst                                                               0x00F5
+#define REGSRAM_246_inst                                                               0x00F6
+#define REGSRAM_247_inst                                                               0x00F7
+#define REGSRAM_248_inst                                                               0x00F8
+#define REGSRAM_249_inst                                                               0x00F9
+#define REGSRAM_250_inst                                                               0x00FA
+#define REGSRAM_251_inst                                                               0x00FB
+#define REGSRAM_252_inst                                                               0x00FC
+#define REGSRAM_253_inst                                                               0x00FD
+#define REGSRAM_254_inst                                                               0x00FE
+#define REGSRAM_255_inst                                                               0x00FF
+#define REGSRAM_256_inst                                                               0x0100
+#define REGSRAM_257_inst                                                               0x0101
+#define REGSRAM_258_inst                                                               0x0102
+#define REGSRAM_259_inst                                                               0x0103
+#define REGSRAM_260_inst                                                               0x0104
+#define REGSRAM_261_inst                                                               0x0105
+#define REGSRAM_262_inst                                                               0x0106
+#define REGSRAM_263_inst                                                               0x0107
+#define REGSRAM_264_inst                                                               0x0108
+#define REGSRAM_265_inst                                                               0x0109
+#define REGSRAM_266_inst                                                               0x010A
+#define REGSRAM_267_inst                                                               0x010B
+#define REGSRAM_268_inst                                                               0x010C
+#define REGSRAM_269_inst                                                               0x010D
+#define REGSRAM_270_inst                                                               0x010E
+#define REGSRAM_271_inst                                                               0x010F
+#define REGSRAM_272_inst                                                               0x0110
+#define REGSRAM_273_inst                                                               0x0111
+#define REGSRAM_274_inst                                                               0x0112
+#define REGSRAM_275_inst                                                               0x0113
+#define REGSRAM_276_inst                                                               0x0114
+#define REGSRAM_277_inst                                                               0x0115
+#define REGSRAM_278_inst                                                               0x0116
+#define REGSRAM_279_inst                                                               0x0117
+#define REGSRAM_280_inst                                                               0x0118
+#define REGSRAM_281_inst                                                               0x0119
+#define REGSRAM_282_inst                                                               0x011A
+#define REGSRAM_283_inst                                                               0x011B
+#define REGSRAM_284_inst                                                               0x011C
+#define REGSRAM_285_inst                                                               0x011D
+#define REGSRAM_286_inst                                                               0x011E
+#define REGSRAM_287_inst                                                               0x011F
+#define REGSRAM_288_inst                                                               0x0120
+#define REGSRAM_289_inst                                                               0x0121
+#define REGSRAM_290_inst                                                               0x0122
+#define REGSRAM_291_inst                                                               0x0123
+#define REGSRAM_292_inst                                                               0x0124
+#define REGSRAM_293_inst                                                               0x0125
+#define REGSRAM_294_inst                                                               0x0126
+#define REGSRAM_295_inst                                                               0x0127
+#define REGSRAM_296_inst                                                               0x0128
+#define REGSRAM_297_inst                                                               0x0129
+#define REGSRAM_298_inst                                                               0x012A
+#define REGSRAM_299_inst                                                               0x012B
+#define REGSRAM_300_inst                                                               0x012C
+#define REGSRAM_301_inst                                                               0x012D
+#define REGSRAM_302_inst                                                               0x012E
+#define REGSRAM_303_inst                                                               0x012F
+#define REGSRAM_304_inst                                                               0x0130
+#define REGSRAM_305_inst                                                               0x0131
+#define REGSRAM_306_inst                                                               0x0132
+#define REGSRAM_307_inst                                                               0x0133
+#define REGSRAM_308_inst                                                               0x0134
+#define REGSRAM_309_inst                                                               0x0135
+#define REGSRAM_310_inst                                                               0x0136
+#define REGSRAM_311_inst                                                               0x0137
+#define REGSRAM_312_inst                                                               0x0138
+#define REGSRAM_313_inst                                                               0x0139
+#define REGSRAM_314_inst                                                               0x013A
+#define REGSRAM_315_inst                                                               0x013B
+#define REGSRAM_316_inst                                                               0x013C
+#define REGSRAM_317_inst                                                               0x013D
+#define REGSRAM_318_inst                                                               0x013E
+#define REGSRAM_319_inst                                                               0x013F
+#define REGSRAM_320_inst                                                               0x0140
+#define REGSRAM_321_inst                                                               0x0141
+#define REGSRAM_322_inst                                                               0x0142
+#define REGSRAM_323_inst                                                               0x0143
+#define REGSRAM_324_inst                                                               0x0144
+#define REGSRAM_325_inst                                                               0x0145
+#define REGSRAM_326_inst                                                               0x0146
+#define REGSRAM_327_inst                                                               0x0147
+#define REGSRAM_328_inst                                                               0x0148
+#define REGSRAM_329_inst                                                               0x0149
+#define REGSRAM_330_inst                                                               0x014A
+#define REGSRAM_331_inst                                                               0x014B
+#define REGSRAM_332_inst                                                               0x014C
+#define REGSRAM_333_inst                                                               0x014D
+#define REGSRAM_334_inst                                                               0x014E
+#define REGSRAM_335_inst                                                               0x014F
+#define REGSRAM_336_inst                                                               0x0150
+#define REGSRAM_337_inst                                                               0x0151
+#define REGSRAM_338_inst                                                               0x0152
+#define REGSRAM_339_inst                                                               0x0153
+#define REGSRAM_340_inst                                                               0x0154
+#define REGSRAM_341_inst                                                               0x0155
+#define REGSRAM_342_inst                                                               0x0156
+#define REGSRAM_343_inst                                                               0x0157
+#define REGSRAM_344_inst                                                               0x0158
+#define REGSRAM_345_inst                                                               0x0159
+#define REGSRAM_346_inst                                                               0x015A
+#define REGSRAM_347_inst                                                               0x015B
+#define REGSRAM_348_inst                                                               0x015C
+#define REGSRAM_349_inst                                                               0x015D
+#define REGSRAM_350_inst                                                               0x015E
+#define REGSRAM_351_inst                                                               0x015F
+#define REGSRAM_352_inst                                                               0x0160
+#define REGSRAM_353_inst                                                               0x0161
+#define REGSRAM_354_inst                                                               0x0162
+#define REGSRAM_355_inst                                                               0x0163
+#define REGSRAM_356_inst                                                               0x0164
+#define REGSRAM_357_inst                                                               0x0165
+#define REGSRAM_358_inst                                                               0x0166
+#define REGSRAM_359_inst                                                               0x0167
+#define REGSRAM_360_inst                                                               0x0168
+#define REGSRAM_361_inst                                                               0x0169
+#define REGSRAM_362_inst                                                               0x016A
+#define REGSRAM_363_inst                                                               0x016B
+#define REGSRAM_364_inst                                                               0x016C
+#define REGSRAM_365_inst                                                               0x016D
+#define REGSRAM_366_inst                                                               0x016E
+#define REGSRAM_367_inst                                                               0x016F
+#define REGSRAM_368_inst                                                               0x0170
+#define REGSRAM_369_inst                                                               0x0171
+#define REGSRAM_370_inst                                                               0x0172
+#define REGSRAM_371_inst                                                               0x0173
+#define REGSRAM_372_inst                                                               0x0174
+#define REGSRAM_373_inst                                                               0x0175
+#define REGSRAM_374_inst                                                               0x0176
+#define REGSRAM_375_inst                                                               0x0177
+#define REGSRAM_376_inst                                                               0x0178
+#define REGSRAM_377_inst                                                               0x0179
+#define REGSRAM_378_inst                                                               0x017A
+#define REGSRAM_379_inst                                                               0x017B
+#define REGSRAM_380_inst                                                               0x017C
+#define REGSRAM_381_inst                                                               0x017D
+#define REGSRAM_382_inst                                                               0x017E
+#define REGSRAM_383_inst                                                               0x017F
+#define REGSRAM_384_inst                                                               0x0180
+#define REGSRAM_385_inst                                                               0x0181
+#define REGSRAM_386_inst                                                               0x0182
+#define REGSRAM_387_inst                                                               0x0183
+#define REGSRAM_388_inst                                                               0x0184
+#define REGSRAM_389_inst                                                               0x0185
+#define REGSRAM_390_inst                                                               0x0186
+#define REGSRAM_391_inst                                                               0x0187
+#define REGSRAM_392_inst                                                               0x0188
+#define REGSRAM_393_inst                                                               0x0189
+#define REGSRAM_394_inst                                                               0x018A
+#define REGSRAM_395_inst                                                               0x018B
+#define REGSRAM_396_inst                                                               0x018C
+#define REGSRAM_397_inst                                                               0x018D
+#define REGSRAM_398_inst                                                               0x018E
+#define REGSRAM_399_inst                                                               0x018F
+#define REGSRAM_400_inst                                                               0x0190
+#define REGSRAM_401_inst                                                               0x0191
+#define REGSRAM_402_inst                                                               0x0192
+#define REGSRAM_403_inst                                                               0x0193
+#define REGSRAM_404_inst                                                               0x0194
+#define REGSRAM_405_inst                                                               0x0195
+#define REGSRAM_406_inst                                                               0x0196
+#define REGSRAM_407_inst                                                               0x0197
+#define REGSRAM_408_inst                                                               0x0198
+#define REGSRAM_409_inst                                                               0x0199
+#define REGSRAM_410_inst                                                               0x019A
+#define REGSRAM_411_inst                                                               0x019B
+#define REGSRAM_412_inst                                                               0x019C
+#define REGSRAM_413_inst                                                               0x019D
+#define REGSRAM_414_inst                                                               0x019E
+#define REGSRAM_415_inst                                                               0x019F
+#define REGSRAM_416_inst                                                               0x01A0
+#define REGSRAM_417_inst                                                               0x01A1
+#define REGSRAM_418_inst                                                               0x01A2
+#define REGSRAM_419_inst                                                               0x01A3
+#define REGSRAM_420_inst                                                               0x01A4
+#define REGSRAM_421_inst                                                               0x01A5
+#define REGSRAM_422_inst                                                               0x01A6
+#define REGSRAM_423_inst                                                               0x01A7
+#define REGSRAM_424_inst                                                               0x01A8
+#define REGSRAM_425_inst                                                               0x01A9
+#define REGSRAM_426_inst                                                               0x01AA
+#define REGSRAM_427_inst                                                               0x01AB
+#define REGSRAM_428_inst                                                               0x01AC
+#define REGSRAM_429_inst                                                               0x01AD
+#define REGSRAM_430_inst                                                               0x01AE
+#define REGSRAM_431_inst                                                               0x01AF
+#define REGSRAM_432_inst                                                               0x01B0
+#define REGSRAM_433_inst                                                               0x01B1
+#define REGSRAM_434_inst                                                               0x01B2
+#define REGSRAM_435_inst                                                               0x01B3
+#define REGSRAM_436_inst                                                               0x01B4
+#define REGSRAM_437_inst                                                               0x01B5
+#define REGSRAM_438_inst                                                               0x01B6
+#define REGSRAM_439_inst                                                               0x01B7
+#define REGSRAM_440_inst                                                               0x01B8
+#define REGSRAM_441_inst                                                               0x01B9
+#define REGSRAM_442_inst                                                               0x01BA
+#define REGSRAM_443_inst                                                               0x01BB
+#define REGSRAM_444_inst                                                               0x01BC
+#define REGSRAM_445_inst                                                               0x01BD
+#define REGSRAM_446_inst                                                               0x01BE
+#define REGSRAM_447_inst                                                               0x01BF
+#define REGSRAM_448_inst                                                               0x01C0
+#define REGSRAM_449_inst                                                               0x01C1
+#define REGSRAM_450_inst                                                               0x01C2
+#define REGSRAM_451_inst                                                               0x01C3
+#define REGSRAM_452_inst                                                               0x01C4
+#define REGSRAM_453_inst                                                               0x01C5
+#define REGSRAM_454_inst                                                               0x01C6
+#define REGSRAM_455_inst                                                               0x01C7
+#define REGSRAM_456_inst                                                               0x01C8
+#define REGSRAM_457_inst                                                               0x01C9
+#define REGSRAM_458_inst                                                               0x01CA
+#define REGSRAM_459_inst                                                               0x01CB
+#define REGSRAM_460_inst                                                               0x01CC
+#define REGSRAM_461_inst                                                               0x01CD
+#define REGSRAM_462_inst                                                               0x01CE
+#define REGSRAM_463_inst                                                               0x01CF
+#define REGSRAM_464_inst                                                               0x01D0
+#define REGSRAM_465_inst                                                               0x01D1
+#define REGSRAM_466_inst                                                               0x01D2
+#define REGSRAM_467_inst                                                               0x01D3
+#define REGSRAM_468_inst                                                               0x01D4
+#define REGSRAM_469_inst                                                               0x01D5
+#define REGSRAM_470_inst                                                               0x01D6
+#define REGSRAM_471_inst                                                               0x01D7
+#define REGSRAM_472_inst                                                               0x01D8
+#define REGSRAM_473_inst                                                               0x01D9
+#define REGSRAM_474_inst                                                               0x01DA
+#define REGSRAM_475_inst                                                               0x01DB
+#define REGSRAM_476_inst                                                               0x01DC
+#define REGSRAM_477_inst                                                               0x01DD
+#define REGSRAM_478_inst                                                               0x01DE
+#define REGSRAM_479_inst                                                               0x01DF
+#define REGSRAM_480_inst                                                               0x01E0
+#define REGSRAM_481_inst                                                               0x01E1
+#define REGSRAM_482_inst                                                               0x01E2
+#define REGSRAM_483_inst                                                               0x01E3
+#define REGSRAM_484_inst                                                               0x01E4
+#define REGSRAM_485_inst                                                               0x01E5
+#define REGSRAM_486_inst                                                               0x01E6
+#define REGSRAM_487_inst                                                               0x01E7
+#define REGSRAM_488_inst                                                               0x01E8
+#define REGSRAM_489_inst                                                               0x01E9
+#define REGSRAM_490_inst                                                               0x01EA
+#define REGSRAM_491_inst                                                               0x01EB
+#define REGSRAM_492_inst                                                               0x01EC
+#define REGSRAM_493_inst                                                               0x01ED
+#define REGSRAM_494_inst                                                               0x01EE
+#define REGSRAM_495_inst                                                               0x01EF
+#define REGSRAM_496_inst                                                               0x01F0
+#define REGSRAM_497_inst                                                               0x01F1
+#define REGSRAM_498_inst                                                               0x01F2
+#define REGSRAM_499_inst                                                               0x01F3
+#define REGSRAM_500_inst                                                               0x01F4
+#define REGSRAM_501_inst                                                               0x01F5
+#define REGSRAM_502_inst                                                               0x01F6
+#define REGSRAM_503_inst                                                               0x01F7
+#define REGSRAM_504_inst                                                               0x01F8
+#define REGSRAM_505_inst                                                               0x01F9
+#define REGSRAM_506_inst                                                               0x01FA
+#define REGSRAM_507_inst                                                               0x01FB
+#define REGSRAM_508_inst                                                               0x01FC
+#define REGSRAM_509_inst                                                               0x01FD
+#define REGSRAM_510_inst                                                               0x01FE
+#define REGSRAM_511_inst                                                               0x01FF
+#define REGSRAM_512_inst                                                               0x0200
+#define REGSRAM_513_inst                                                               0x0201
+#define REGSRAM_514_inst                                                               0x0202
+#define REGSRAM_515_inst                                                               0x0203
+#define REGSRAM_516_inst                                                               0x0204
+#define REGSRAM_517_inst                                                               0x0205
+#define REGSRAM_518_inst                                                               0x0206
+#define REGSRAM_519_inst                                                               0x0207
+#define REGSRAM_520_inst                                                               0x0208
+#define REGSRAM_521_inst                                                               0x0209
+#define REGSRAM_522_inst                                                               0x020A
+#define REGSRAM_523_inst                                                               0x020B
+#define REGSRAM_524_inst                                                               0x020C
+#define REGSRAM_525_inst                                                               0x020D
+#define REGSRAM_526_inst                                                               0x020E
+#define REGSRAM_527_inst                                                               0x020F
+#define REGSRAM_528_inst                                                               0x0210
+#define REGSRAM_529_inst                                                               0x0211
+#define REGSRAM_530_inst                                                               0x0212
+#define REGSRAM_531_inst                                                               0x0213
+#define REGSRAM_532_inst                                                               0x0214
+#define REGSRAM_533_inst                                                               0x0215
+#define REGSRAM_534_inst                                                               0x0216
+#define REGSRAM_535_inst                                                               0x0217
+#define REGSRAM_536_inst                                                               0x0218
+#define REGSRAM_537_inst                                                               0x0219
+#define REGSRAM_538_inst                                                               0x021A
+#define REGSRAM_539_inst                                                               0x021B
+#define REGSRAM_540_inst                                                               0x021C
+#define REGSRAM_541_inst                                                               0x021D
+#define REGSRAM_542_inst                                                               0x021E
+#define REGSRAM_543_inst                                                               0x021F
+#define REGSRAM_544_inst                                                               0x0220
+#define REGSRAM_545_inst                                                               0x0221
+#define REGSRAM_546_inst                                                               0x0222
+#define REGSRAM_547_inst                                                               0x0223
+#define REGSRAM_548_inst                                                               0x0224
+#define REGSRAM_549_inst                                                               0x0225
+#define REGSRAM_550_inst                                                               0x0226
+#define REGSRAM_551_inst                                                               0x0227
+#define REGSRAM_552_inst                                                               0x0228
+#define REGSRAM_553_inst                                                               0x0229
+#define REGSRAM_554_inst                                                               0x022A
+#define REGSRAM_555_inst                                                               0x022B
+#define REGSRAM_556_inst                                                               0x022C
+#define REGSRAM_557_inst                                                               0x022D
+#define REGSRAM_558_inst                                                               0x022E
+#define REGSRAM_559_inst                                                               0x022F
+#define REGSRAM_560_inst                                                               0x0230
+#define REGSRAM_561_inst                                                               0x0231
+#define REGSRAM_562_inst                                                               0x0232
+#define REGSRAM_563_inst                                                               0x0233
+#define REGSRAM_564_inst                                                               0x0234
+#define REGSRAM_565_inst                                                               0x0235
+#define REGSRAM_566_inst                                                               0x0236
+#define REGSRAM_567_inst                                                               0x0237
+#define REGSRAM_568_inst                                                               0x0238
+#define REGSRAM_569_inst                                                               0x0239
+#define REGSRAM_570_inst                                                               0x023A
+#define REGSRAM_571_inst                                                               0x023B
+#define REGSRAM_572_inst                                                               0x023C
+#define REGSRAM_573_inst                                                               0x023D
+#define REGSRAM_574_inst                                                               0x023E
+#define REGSRAM_575_inst                                                               0x023F
+#define REGSRAM_576_inst                                                               0x0240
+#define REGSRAM_577_inst                                                               0x0241
+#define REGSRAM_578_inst                                                               0x0242
+#define REGSRAM_579_inst                                                               0x0243
+#define REGSRAM_580_inst                                                               0x0244
+#define REGSRAM_581_inst                                                               0x0245
+#define REGSRAM_582_inst                                                               0x0246
+#define REGSRAM_583_inst                                                               0x0247
+#define REGSRAM_584_inst                                                               0x0248
+#define REGSRAM_585_inst                                                               0x0249
+#define REGSRAM_586_inst                                                               0x024A
+#define REGSRAM_587_inst                                                               0x024B
+#define REGSRAM_588_inst                                                               0x024C
+#define REGSRAM_589_inst                                                               0x024D
+#define REGSRAM_590_inst                                                               0x024E
+#define REGSRAM_591_inst                                                               0x024F
+#define REGSRAM_592_inst                                                               0x0250
+#define REGSRAM_593_inst                                                               0x0251
+#define REGSRAM_594_inst                                                               0x0252
+#define REGSRAM_595_inst                                                               0x0253
+#define REGSRAM_596_inst                                                               0x0254
+#define REGSRAM_597_inst                                                               0x0255
+#define REGSRAM_598_inst                                                               0x0256
+#define REGSRAM_599_inst                                                               0x0257
+#define REGSRAM_600_inst                                                               0x0258
+#define REGSRAM_601_inst                                                               0x0259
+#define REGSRAM_602_inst                                                               0x025A
+#define REGSRAM_603_inst                                                               0x025B
+#define REGSRAM_604_inst                                                               0x025C
+#define REGSRAM_605_inst                                                               0x025D
+#define REGSRAM_606_inst                                                               0x025E
+#define REGSRAM_607_inst                                                               0x025F
+#define REGSRAM_608_inst                                                               0x0260
+#define REGSRAM_609_inst                                                               0x0261
+#define REGSRAM_610_inst                                                               0x0262
+#define REGSRAM_611_inst                                                               0x0263
+#define REGSRAM_612_inst                                                               0x0264
+#define REGSRAM_613_inst                                                               0x0265
+#define REGSRAM_614_inst                                                               0x0266
+#define REGSRAM_615_inst                                                               0x0267
+#define REGSRAM_616_inst                                                               0x0268
+#define REGSRAM_617_inst                                                               0x0269
+#define REGSRAM_618_inst                                                               0x026A
+#define REGSRAM_619_inst                                                               0x026B
+#define REGSRAM_620_inst                                                               0x026C
+#define REGSRAM_621_inst                                                               0x026D
+#define REGSRAM_622_inst                                                               0x026E
+#define REGSRAM_623_inst                                                               0x026F
+#define REGSRAM_624_inst                                                               0x0270
+#define REGSRAM_625_inst                                                               0x0271
+#define REGSRAM_626_inst                                                               0x0272
+#define REGSRAM_627_inst                                                               0x0273
+#define REGSRAM_628_inst                                                               0x0274
+#define REGSRAM_629_inst                                                               0x0275
+#define REGSRAM_630_inst                                                               0x0276
+#define REGSRAM_631_inst                                                               0x0277
+#define REGSRAM_632_inst                                                               0x0278
+#define REGSRAM_633_inst                                                               0x0279
+#define REGSRAM_634_inst                                                               0x027A
+#define REGSRAM_635_inst                                                               0x027B
+#define REGSRAM_636_inst                                                               0x027C
+#define REGSRAM_637_inst                                                               0x027D
+#define REGSRAM_638_inst                                                               0x027E
+#define REGSRAM_639_inst                                                               0x027F
+#define REGSRAM_640_inst                                                               0x0280
+#define REGSRAM_641_inst                                                               0x0281
+#define REGSRAM_642_inst                                                               0x0282
+#define REGSRAM_643_inst                                                               0x0283
+#define REGSRAM_644_inst                                                               0x0284
+#define REGSRAM_645_inst                                                               0x0285
+#define REGSRAM_646_inst                                                               0x0286
+#define REGSRAM_647_inst                                                               0x0287
+#define REGSRAM_648_inst                                                               0x0288
+#define REGSRAM_649_inst                                                               0x0289
+#define REGSRAM_650_inst                                                               0x028A
+#define REGSRAM_651_inst                                                               0x028B
+#define REGSRAM_652_inst                                                               0x028C
+#define REGSRAM_653_inst                                                               0x028D
+#define REGSRAM_654_inst                                                               0x028E
+#define REGSRAM_655_inst                                                               0x028F
+#define REGSRAM_656_inst                                                               0x0290
+#define REGSRAM_657_inst                                                               0x0291
+#define REGSRAM_658_inst                                                               0x0292
+#define REGSRAM_659_inst                                                               0x0293
+#define REGSRAM_660_inst                                                               0x0294
+#define REGSRAM_661_inst                                                               0x0295
+#define REGSRAM_662_inst                                                               0x0296
+#define REGSRAM_663_inst                                                               0x0297
+#define REGSRAM_664_inst                                                               0x0298
+#define REGSRAM_665_inst                                                               0x0299
+#define REGSRAM_666_inst                                                               0x029A
+#define REGSRAM_667_inst                                                               0x029B
+#define REGSRAM_668_inst                                                               0x029C
+#define REGSRAM_669_inst                                                               0x029D
+#define REGSRAM_670_inst                                                               0x029E
+#define REGSRAM_671_inst                                                               0x029F
+#define REGSRAM_672_inst                                                               0x02A0
+#define REGSRAM_673_inst                                                               0x02A1
+#define REGSRAM_674_inst                                                               0x02A2
+#define REGSRAM_675_inst                                                               0x02A3
+#define REGSRAM_676_inst                                                               0x02A4
+#define REGSRAM_677_inst                                                               0x02A5
+#define REGSRAM_678_inst                                                               0x02A6
+#define REGSRAM_679_inst                                                               0x02A7
+#define REGSRAM_680_inst                                                               0x02A8
+#define REGSRAM_681_inst                                                               0x02A9
+#define REGSRAM_682_inst                                                               0x02AA
+#define REGSRAM_683_inst                                                               0x02AB
+#define REGSRAM_684_inst                                                               0x02AC
+#define REGSRAM_685_inst                                                               0x02AD
+#define REGSRAM_686_inst                                                               0x02AE
+#define REGSRAM_687_inst                                                               0x02AF
+#define REGSRAM_688_inst                                                               0x02B0
+#define REGSRAM_689_inst                                                               0x02B1
+#define REGSRAM_690_inst                                                               0x02B2
+#define REGSRAM_691_inst                                                               0x02B3
+#define REGSRAM_692_inst                                                               0x02B4
+#define REGSRAM_693_inst                                                               0x02B5
+#define REGSRAM_694_inst                                                               0x02B6
+#define REGSRAM_695_inst                                                               0x02B7
+#define REGSRAM_696_inst                                                               0x02B8
+#define REGSRAM_697_inst                                                               0x02B9
+#define REGSRAM_698_inst                                                               0x02BA
+#define REGSRAM_699_inst                                                               0x02BB
+#define REGSRAM_700_inst                                                               0x02BC
+#define REGSRAM_701_inst                                                               0x02BD
+#define REGSRAM_702_inst                                                               0x02BE
+#define REGSRAM_703_inst                                                               0x02BF
+#define REGSRAM_704_inst                                                               0x02C0
+#define REGSRAM_705_inst                                                               0x02C1
+#define REGSRAM_706_inst                                                               0x02C2
+#define REGSRAM_707_inst                                                               0x02C3
+#define REGSRAM_708_inst                                                               0x02C4
+#define REGSRAM_709_inst                                                               0x02C5
+#define REGSRAM_710_inst                                                               0x02C6
+#define REGSRAM_711_inst                                                               0x02C7
+#define REGSRAM_712_inst                                                               0x02C8
+#define REGSRAM_713_inst                                                               0x02C9
+#define REGSRAM_714_inst                                                               0x02CA
+#define REGSRAM_715_inst                                                               0x02CB
+#define REGSRAM_716_inst                                                               0x02CC
+#define REGSRAM_717_inst                                                               0x02CD
+#define REGSRAM_718_inst                                                               0x02CE
+#define REGSRAM_719_inst                                                               0x02CF
+#define REGSRAM_720_inst                                                               0x02D0
+#define REGSRAM_721_inst                                                               0x02D1
+#define REGSRAM_722_inst                                                               0x02D2
+#define REGSRAM_723_inst                                                               0x02D3
+#define REGSRAM_724_inst                                                               0x02D4
+#define REGSRAM_725_inst                                                               0x02D5
+#define REGSRAM_726_inst                                                               0x02D6
+#define REGSRAM_727_inst                                                               0x02D7
+#define REGSRAM_728_inst                                                               0x02D8
+#define REGSRAM_729_inst                                                               0x02D9
+#define REGSRAM_730_inst                                                               0x02DA
+#define REGSRAM_731_inst                                                               0x02DB
+#define REGSRAM_732_inst                                                               0x02DC
+#define REGSRAM_733_inst                                                               0x02DD
+#define REGSRAM_734_inst                                                               0x02DE
+#define REGSRAM_735_inst                                                               0x02DF
+#define REGSRAM_736_inst                                                               0x02E0
+#define REGSRAM_737_inst                                                               0x02E1
+#define REGSRAM_738_inst                                                               0x02E2
+#define REGSRAM_739_inst                                                               0x02E3
+#define REGSRAM_740_inst                                                               0x02E4
+#define REGSRAM_741_inst                                                               0x02E5
+#define REGSRAM_742_inst                                                               0x02E6
+#define REGSRAM_743_inst                                                               0x02E7
+#define REGSRAM_744_inst                                                               0x02E8
+#define REGSRAM_745_inst                                                               0x02E9
+#define REGSRAM_746_inst                                                               0x02EA
+#define REGSRAM_747_inst                                                               0x02EB
+#define REGSRAM_748_inst                                                               0x02EC
+#define REGSRAM_749_inst                                                               0x02ED
+#define REGSRAM_750_inst                                                               0x02EE
+#define REGSRAM_751_inst                                                               0x02EF
+#define REGSRAM_752_inst                                                               0x02F0
+#define REGSRAM_753_inst                                                               0x02F1
+#define REGSRAM_754_inst                                                               0x02F2
+#define REGSRAM_755_inst                                                               0x02F3
+#define REGSRAM_756_inst                                                               0x02F4
+#define REGSRAM_757_inst                                                               0x02F5
+#define REGSRAM_758_inst                                                               0x02F6
+#define REGSRAM_759_inst                                                               0x02F7
+#define REGSRAM_760_inst                                                               0x02F8
+#define REGSRAM_761_inst                                                               0x02F9
+#define REGSRAM_762_inst                                                               0x02FA
+#define REGSRAM_763_inst                                                               0x02FB
+#define REGSRAM_764_inst                                                               0x02FC
+#define REGSRAM_765_inst                                                               0x02FD
+#define REGSRAM_766_inst                                                               0x02FE
+#define REGSRAM_767_inst                                                               0x02FF
+#define REGSRAM_768_inst                                                               0x0300
+#define REGSRAM_769_inst                                                               0x0301
+#define REGSRAM_770_inst                                                               0x0302
+#define REGSRAM_771_inst                                                               0x0303
+#define REGSRAM_772_inst                                                               0x0304
+#define REGSRAM_773_inst                                                               0x0305
+#define REGSRAM_774_inst                                                               0x0306
+#define REGSRAM_775_inst                                                               0x0307
+#define REGSRAM_776_inst                                                               0x0308
+#define REGSRAM_777_inst                                                               0x0309
+#define REGSRAM_778_inst                                                               0x030A
+#define REGSRAM_779_inst                                                               0x030B
+#define REGSRAM_780_inst                                                               0x030C
+#define REGSRAM_781_inst                                                               0x030D
+#define REGSRAM_782_inst                                                               0x030E
+#define REGSRAM_783_inst                                                               0x030F
+#define REGSRAM_784_inst                                                               0x0310
+#define REGSRAM_785_inst                                                               0x0311
+#define REGSRAM_786_inst                                                               0x0312
+#define REGSRAM_787_inst                                                               0x0313
+#define REGSRAM_788_inst                                                               0x0314
+#define REGSRAM_789_inst                                                               0x0315
+#define REGSRAM_790_inst                                                               0x0316
+#define REGSRAM_791_inst                                                               0x0317
+#define REGSRAM_792_inst                                                               0x0318
+#define REGSRAM_793_inst                                                               0x0319
+#define REGSRAM_794_inst                                                               0x031A
+#define REGSRAM_795_inst                                                               0x031B
+#define REGSRAM_796_inst                                                               0x031C
+#define REGSRAM_797_inst                                                               0x031D
+#define REGSRAM_798_inst                                                               0x031E
+#define REGSRAM_799_inst                                                               0x031F
+#define REGSRAM_800_inst                                                               0x0320
+#define REGSRAM_801_inst                                                               0x0321
+#define REGSRAM_802_inst                                                               0x0322
+#define REGSRAM_803_inst                                                               0x0323
+#define REGSRAM_804_inst                                                               0x0324
+#define REGSRAM_805_inst                                                               0x0325
+#define REGSRAM_806_inst                                                               0x0326
+#define REGSRAM_807_inst                                                               0x0327
+#define REGSRAM_808_inst                                                               0x0328
+#define REGSRAM_809_inst                                                               0x0329
+#define REGSRAM_810_inst                                                               0x032A
+#define REGSRAM_811_inst                                                               0x032B
+#define REGSRAM_812_inst                                                               0x032C
+#define REGSRAM_813_inst                                                               0x032D
+#define REGSRAM_814_inst                                                               0x032E
+#define REGSRAM_815_inst                                                               0x032F
+#define REGSRAM_816_inst                                                               0x0330
+#define REGSRAM_817_inst                                                               0x0331
+#define REGSRAM_818_inst                                                               0x0332
+#define REGSRAM_819_inst                                                               0x0333
+#define REGSRAM_820_inst                                                               0x0334
+#define REGSRAM_821_inst                                                               0x0335
+#define REGSRAM_822_inst                                                               0x0336
+#define REGSRAM_823_inst                                                               0x0337
+#define REGSRAM_824_inst                                                               0x0338
+#define REGSRAM_825_inst                                                               0x0339
+#define REGSRAM_826_inst                                                               0x033A
+#define REGSRAM_827_inst                                                               0x033B
+#define REGSRAM_828_inst                                                               0x033C
+#define REGSRAM_829_inst                                                               0x033D
+#define REGSRAM_830_inst                                                               0x033E
+#define REGSRAM_831_inst                                                               0x033F
+#define REGSRAM_832_inst                                                               0x0340
+#define REGSRAM_833_inst                                                               0x0341
+#define REGSRAM_834_inst                                                               0x0342
+#define REGSRAM_835_inst                                                               0x0343
+#define REGSRAM_836_inst                                                               0x0344
+#define REGSRAM_837_inst                                                               0x0345
+#define REGSRAM_838_inst                                                               0x0346
+#define REGSRAM_839_inst                                                               0x0347
+#define REGSRAM_840_inst                                                               0x0348
+#define REGSRAM_841_inst                                                               0x0349
+#define REGSRAM_842_inst                                                               0x034A
+#define REGSRAM_843_inst                                                               0x034B
+#define REGSRAM_844_inst                                                               0x034C
+#define REGSRAM_845_inst                                                               0x034D
+#define REGSRAM_846_inst                                                               0x034E
+#define REGSRAM_847_inst                                                               0x034F
+#define REGSRAM_848_inst                                                               0x0350
+#define REGSRAM_849_inst                                                               0x0351
+#define REGSRAM_850_inst                                                               0x0352
+#define REGSRAM_851_inst                                                               0x0353
+#define REGSRAM_852_inst                                                               0x0354
+#define REGSRAM_853_inst                                                               0x0355
+#define REGSRAM_854_inst                                                               0x0356
+#define REGSRAM_855_inst                                                               0x0357
+#define REGSRAM_856_inst                                                               0x0358
+#define REGSRAM_857_inst                                                               0x0359
+#define REGSRAM_858_inst                                                               0x035A
+#define REGSRAM_859_inst                                                               0x035B
+#define REGSRAM_860_inst                                                               0x035C
+#define REGSRAM_861_inst                                                               0x035D
+#define REGSRAM_862_inst                                                               0x035E
+#define REGSRAM_863_inst                                                               0x035F
+#define REGSRAM_864_inst                                                               0x0360
+#define REGSRAM_865_inst                                                               0x0361
+#define REGSRAM_866_inst                                                               0x0362
+#define REGSRAM_867_inst                                                               0x0363
+#define REGSRAM_868_inst                                                               0x0364
+#define REGSRAM_869_inst                                                               0x0365
+#define REGSRAM_870_inst                                                               0x0366
+#define REGSRAM_871_inst                                                               0x0367
+#define REGSRAM_872_inst                                                               0x0368
+#define REGSRAM_873_inst                                                               0x0369
+#define REGSRAM_874_inst                                                               0x036A
+#define REGSRAM_875_inst                                                               0x036B
+#define REGSRAM_876_inst                                                               0x036C
+#define REGSRAM_877_inst                                                               0x036D
+#define REGSRAM_878_inst                                                               0x036E
+#define REGSRAM_879_inst                                                               0x036F
+#define REGSRAM_880_inst                                                               0x0370
+#define REGSRAM_881_inst                                                               0x0371
+#define REGSRAM_882_inst                                                               0x0372
+#define REGSRAM_883_inst                                                               0x0373
+#define REGSRAM_884_inst                                                               0x0374
+#define REGSRAM_885_inst                                                               0x0375
+#define REGSRAM_886_inst                                                               0x0376
+#define REGSRAM_887_inst                                                               0x0377
+#define REGSRAM_888_inst                                                               0x0378
+#define REGSRAM_889_inst                                                               0x0379
+#define REGSRAM_890_inst                                                               0x037A
+#define REGSRAM_891_inst                                                               0x037B
+#define REGSRAM_892_inst                                                               0x037C
+#define REGSRAM_893_inst                                                               0x037D
+#define REGSRAM_894_inst                                                               0x037E
+#define REGSRAM_895_inst                                                               0x037F
+#define REGSRAM_896_inst                                                               0x0380
+#define REGSRAM_897_inst                                                               0x0381
+#define REGSRAM_898_inst                                                               0x0382
+#define REGSRAM_899_inst                                                               0x0383
+#define REGSRAM_900_inst                                                               0x0384
+#define REGSRAM_901_inst                                                               0x0385
+#define REGSRAM_902_inst                                                               0x0386
+#define REGSRAM_903_inst                                                               0x0387
+#define REGSRAM_904_inst                                                               0x0388
+#define REGSRAM_905_inst                                                               0x0389
+#define REGSRAM_906_inst                                                               0x038A
+#define REGSRAM_907_inst                                                               0x038B
+#define REGSRAM_908_inst                                                               0x038C
+#define REGSRAM_909_inst                                                               0x038D
+#define REGSRAM_910_inst                                                               0x038E
+#define REGSRAM_911_inst                                                               0x038F
+#define REGSRAM_912_inst                                                               0x0390
+#define REGSRAM_913_inst                                                               0x0391
+#define REGSRAM_914_inst                                                               0x0392
+#define REGSRAM_915_inst                                                               0x0393
+#define REGSRAM_916_inst                                                               0x0394
+#define REGSRAM_917_inst                                                               0x0395
+#define REGSRAM_918_inst                                                               0x0396
+#define REGSRAM_919_inst                                                               0x0397
+#define REGSRAM_920_inst                                                               0x0398
+#define REGSRAM_921_inst                                                               0x0399
+#define REGSRAM_922_inst                                                               0x039A
+#define REGSRAM_923_inst                                                               0x039B
+#define REGSRAM_924_inst                                                               0x039C
+#define REGSRAM_925_inst                                                               0x039D
+#define REGSRAM_926_inst                                                               0x039E
+#define REGSRAM_927_inst                                                               0x039F
+#define REGSRAM_928_inst                                                               0x03A0
+#define REGSRAM_929_inst                                                               0x03A1
+#define REGSRAM_930_inst                                                               0x03A2
+#define REGSRAM_931_inst                                                               0x03A3
+#define REGSRAM_932_inst                                                               0x03A4
+#define REGSRAM_933_inst                                                               0x03A5
+#define REGSRAM_934_inst                                                               0x03A6
+#define REGSRAM_935_inst                                                               0x03A7
+#define REGSRAM_936_inst                                                               0x03A8
+#define REGSRAM_937_inst                                                               0x03A9
+#define REGSRAM_938_inst                                                               0x03AA
+#define REGSRAM_939_inst                                                               0x03AB
+#define REGSRAM_940_inst                                                               0x03AC
+#define REGSRAM_941_inst                                                               0x03AD
+#define REGSRAM_942_inst                                                               0x03AE
+#define REGSRAM_943_inst                                                               0x03AF
+#define REGSRAM_944_inst                                                               0x03B0
+#define REGSRAM_945_inst                                                               0x03B1
+#define REGSRAM_946_inst                                                               0x03B2
+#define REGSRAM_947_inst                                                               0x03B3
+#define REGSRAM_948_inst                                                               0x03B4
+#define REGSRAM_949_inst                                                               0x03B5
+#define REGSRAM_950_inst                                                               0x03B6
+#define REGSRAM_951_inst                                                               0x03B7
+#define REGSRAM_952_inst                                                               0x03B8
+#define REGSRAM_953_inst                                                               0x03B9
+#define REGSRAM_954_inst                                                               0x03BA
+#define REGSRAM_955_inst                                                               0x03BB
+#define REGSRAM_956_inst                                                               0x03BC
+#define REGSRAM_957_inst                                                               0x03BD
+#define REGSRAM_958_inst                                                               0x03BE
+#define REGSRAM_959_inst                                                               0x03BF
+#define REGSRAM_960_inst                                                               0x03C0
+#define REGSRAM_961_inst                                                               0x03C1
+#define REGSRAM_962_inst                                                               0x03C2
+#define REGSRAM_963_inst                                                               0x03C3
+#define REGSRAM_964_inst                                                               0x03C4
+#define REGSRAM_965_inst                                                               0x03C5
+#define REGSRAM_966_inst                                                               0x03C6
+#define REGSRAM_967_inst                                                               0x03C7
+#define REGSRAM_968_inst                                                               0x03C8
+#define REGSRAM_969_inst                                                               0x03C9
+#define REGSRAM_970_inst                                                               0x03CA
+#define REGSRAM_971_inst                                                               0x03CB
+#define REGSRAM_972_inst                                                               0x03CC
+#define REGSRAM_973_inst                                                               0x03CD
+#define REGSRAM_974_inst                                                               0x03CE
+#define REGSRAM_975_inst                                                               0x03CF
+#define REGSRAM_976_inst                                                               0x03D0
+#define REGSRAM_977_inst                                                               0x03D1
+#define REGSRAM_978_inst                                                               0x03D2
+#define REGSRAM_979_inst                                                               0x03D3
+#define REGSRAM_980_inst                                                               0x03D4
+#define REGSRAM_981_inst                                                               0x03D5
+#define REGSRAM_982_inst                                                               0x03D6
+#define REGSRAM_983_inst                                                               0x03D7
+#define REGSRAM_984_inst                                                               0x03D8
+#define REGSRAM_985_inst                                                               0x03D9
+#define REGSRAM_986_inst                                                               0x03DA
+#define REGSRAM_987_inst                                                               0x03DB
+#define REGSRAM_988_inst                                                               0x03DC
+#define REGSRAM_989_inst                                                               0x03DD
+#define REGSRAM_990_inst                                                               0x03DE
+#define REGSRAM_991_inst                                                               0x03DF
+#define REGSRAM_992_inst                                                               0x03E0
+#define REGSRAM_993_inst                                                               0x03E1
+#define REGSRAM_994_inst                                                               0x03E2
+#define REGSRAM_995_inst                                                               0x03E3
+#define REGSRAM_996_inst                                                               0x03E4
+#define REGSRAM_997_inst                                                               0x03E5
+#define REGSRAM_998_inst                                                               0x03E6
+#define REGSRAM_999_inst                                                               0x03E7
+#define REGSRAM_1000_inst                                                               0x03E8
+#define REGSRAM_1001_inst                                                               0x03E9
+#define REGSRAM_1002_inst                                                               0x03EA
+#define REGSRAM_1003_inst                                                               0x03EB
+#define REGSRAM_1004_inst                                                               0x03EC
+#define REGSRAM_1005_inst                                                               0x03ED
+#define REGSRAM_1006_inst                                                               0x03EE
+#define REGSRAM_1007_inst                                                               0x03EF
+#define REGSRAM_1008_inst                                                               0x03F0
+#define REGSRAM_1009_inst                                                               0x03F1
+#define REGSRAM_1010_inst                                                               0x03F2
+#define REGSRAM_1011_inst                                                               0x03F3
+#define REGSRAM_1012_inst                                                               0x03F4
+#define REGSRAM_1013_inst                                                               0x03F5
+#define REGSRAM_1014_inst                                                               0x03F6
+#define REGSRAM_1015_inst                                                               0x03F7
+#define REGSRAM_1016_inst                                                               0x03F8
+#define REGSRAM_1017_inst                                                               0x03F9
+#define REGSRAM_1018_inst                                                               0x03FA
+#define REGSRAM_1019_inst                                                               0x03FB
+#define REGSRAM_1020_inst                                                               0x03FC
+#define REGSRAM_1021_inst                                                               0x03FD
+#define REGSRAM_1022_inst                                                               0x03FE
+#define REGSRAM_1023_inst                                                               0x03FF
+#define REGSRAM_data_shift                                                           (0)
+#define REGSRAM_data_mask                                                            (0xFFFFFFFF)
+#define REGSRAM_data(data)                                                           (0xFFFFFFFF&((data)<<0))
+#define REGSRAM_data_src(data)                                                       ((0xFFFFFFFF&(data))>>0)
+#define REGSRAM_get_data(data)                                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/vp8_p2_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/vp8_p2_reg.h
new file mode 100644
index 00000000..411a1f3
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/vp8_p2_reg.h
@@ -0,0 +1,915 @@
+/**************************************************************
+// Spec Version                  : 0.2
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Module_Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2012/6/22 11:40:33
+***************************************************************/
+
+
+#ifndef _VP8_P2_REG_H_INCLUDED_
+#define _VP8_P2_REG_H_INCLUDED_
+#ifdef  _VP8_P2_USE_STRUCT
+typedef struct 
+{
+unsigned int     reserved_0:1;
+unsigned int     write_enable7:1;
+unsigned int     slice_cnt:8;
+unsigned int     write_enable6:1;
+unsigned int     full_pixel:1;
+unsigned int     write_enable5:1;
+unsigned int     ref_frame_sign_bias:4;
+unsigned int     write_enable4:1;
+unsigned int     mb_no_coeff_skip:1;
+unsigned int     write_enable3:1;
+unsigned int     segmentation_enabled:1;
+unsigned int     write_enable2:1;
+unsigned int     update_mb_segmentation_map:1;
+unsigned int     write_enable1:1;
+unsigned int     prob_skip_false:8;
+}VP8_P2_VP8_P2_FRM1;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable3:1;
+unsigned int     prob_gf:8;
+unsigned int     write_enable2:1;
+unsigned int     prob_last:8;
+unsigned int     write_enable1:1;
+unsigned int     prob_intra:8;
+}VP8_P2_VP8_P2_FRM2;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     write_enable1:1;
+unsigned int     picmb_h:7;
+}VP8_P2_VP8_P2_FRM3;
+
+typedef struct 
+{
+unsigned int     reserved_0:20;
+unsigned int     need_to_clamp_mvs:1;
+unsigned int     ref_frame:2;
+unsigned int     uv_mode:2;
+unsigned int     mode:4;
+unsigned int     mb_skip_coeff:1;
+unsigned int     segment_id:2;
+}VP8_P2_VP8_P2_MB1;
+
+typedef struct 
+{
+unsigned int     reserved_0:5;
+unsigned int     write_enable3:1;
+unsigned int     ndb_p2_flush:1;
+unsigned int     write_enable2:1;
+unsigned int     mby:7;
+unsigned int     write_enable1:1;
+unsigned int     left_sub_block_mode:16;
+}VP8_P2_VP8_P2_MB2;
+
+typedef struct 
+{
+unsigned int     sub_blk_mode_p0:32;
+}VP8_P2_VP8_P2_SUB_BLK0;
+
+typedef struct 
+{
+unsigned int     sub_blk_mode_p1:32;
+}VP8_P2_VP8_P2_SUB_BLK1;
+
+typedef struct 
+{
+unsigned int     reserved_0:6;
+unsigned int     vp8_p2_curmb:9;
+unsigned int     vp8_mbpartition:9;
+unsigned int     vp8_Inter_pred_option:8;
+}VP8_P2_VP8_P2_MB_INFO;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     high:9;
+unsigned int     bits:4;
+unsigned int     code_word:16;
+}VP8_P2_VP8_BAC;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV0;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV1;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV2;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV3;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV4;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV5;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV6;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV7;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV8;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV9;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV10;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV11;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV12;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV13;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV14;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_MV15;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_CH_MV0;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_CH_MV1;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_CH_MV2;
+
+typedef struct 
+{
+unsigned int     reserved_0:3;
+unsigned int     mv_x:15;
+unsigned int     mv_y:14;
+}VP8_P2_VP8_MB_CH_MV3;
+
+#endif
+
+#define VP8_P2_VP8_P2_FRM1                                                           0x1800EF00
+#define VP8_P2_VP8_P2_FRM1_reg_addr                                                  "0xB800EF00"
+#define VP8_P2_VP8_P2_FRM1_reg                                                       0xB800EF00
+#define set_VP8_P2_VP8_P2_FRM1_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_P2_FRM1_reg)=data)
+#define get_VP8_P2_VP8_P2_FRM1_reg   (*((volatile unsigned int*) VP8_P2_VP8_P2_FRM1_reg))
+#define VP8_P2_VP8_P2_FRM1_inst_adr                                                  "0x00C0"
+#define VP8_P2_VP8_P2_FRM1_inst                                                      0x00C0
+#define VP8_P2_VP8_P2_FRM1_write_enable7_shift                                       (30)
+#define VP8_P2_VP8_P2_FRM1_write_enable7_mask                                        (0x40000000)
+#define VP8_P2_VP8_P2_FRM1_write_enable7(data)                                       (0x40000000&((data)<<30))
+#define VP8_P2_VP8_P2_FRM1_write_enable7_src(data)                                   ((0x40000000&(data))>>30)
+#define VP8_P2_VP8_P2_FRM1_get_write_enable7(data)                                   ((0x40000000&(data))>>30)
+#define VP8_P2_VP8_P2_FRM1_slice_cnt_shift                                           (22)
+#define VP8_P2_VP8_P2_FRM1_slice_cnt_mask                                            (0x3FC00000)
+#define VP8_P2_VP8_P2_FRM1_slice_cnt(data)                                           (0x3FC00000&((data)<<22))
+#define VP8_P2_VP8_P2_FRM1_slice_cnt_src(data)                                       ((0x3FC00000&(data))>>22)
+#define VP8_P2_VP8_P2_FRM1_get_slice_cnt(data)                                       ((0x3FC00000&(data))>>22)
+#define VP8_P2_VP8_P2_FRM1_write_enable6_shift                                       (21)
+#define VP8_P2_VP8_P2_FRM1_write_enable6_mask                                        (0x00200000)
+#define VP8_P2_VP8_P2_FRM1_write_enable6(data)                                       (0x00200000&((data)<<21))
+#define VP8_P2_VP8_P2_FRM1_write_enable6_src(data)                                   ((0x00200000&(data))>>21)
+#define VP8_P2_VP8_P2_FRM1_get_write_enable6(data)                                   ((0x00200000&(data))>>21)
+#define VP8_P2_VP8_P2_FRM1_full_pixel_shift                                          (20)
+#define VP8_P2_VP8_P2_FRM1_full_pixel_mask                                           (0x00100000)
+#define VP8_P2_VP8_P2_FRM1_full_pixel(data)                                          (0x00100000&((data)<<20))
+#define VP8_P2_VP8_P2_FRM1_full_pixel_src(data)                                      ((0x00100000&(data))>>20)
+#define VP8_P2_VP8_P2_FRM1_get_full_pixel(data)                                      ((0x00100000&(data))>>20)
+#define VP8_P2_VP8_P2_FRM1_write_enable5_shift                                       (19)
+#define VP8_P2_VP8_P2_FRM1_write_enable5_mask                                        (0x00080000)
+#define VP8_P2_VP8_P2_FRM1_write_enable5(data)                                       (0x00080000&((data)<<19))
+#define VP8_P2_VP8_P2_FRM1_write_enable5_src(data)                                   ((0x00080000&(data))>>19)
+#define VP8_P2_VP8_P2_FRM1_get_write_enable5(data)                                   ((0x00080000&(data))>>19)
+#define VP8_P2_VP8_P2_FRM1_ref_frame_sign_bias_shift                                 (15)
+#define VP8_P2_VP8_P2_FRM1_ref_frame_sign_bias_mask                                  (0x00078000)
+#define VP8_P2_VP8_P2_FRM1_ref_frame_sign_bias(data)                                 (0x00078000&((data)<<15))
+#define VP8_P2_VP8_P2_FRM1_ref_frame_sign_bias_src(data)                             ((0x00078000&(data))>>15)
+#define VP8_P2_VP8_P2_FRM1_get_ref_frame_sign_bias(data)                             ((0x00078000&(data))>>15)
+#define VP8_P2_VP8_P2_FRM1_write_enable4_shift                                       (14)
+#define VP8_P2_VP8_P2_FRM1_write_enable4_mask                                        (0x00004000)
+#define VP8_P2_VP8_P2_FRM1_write_enable4(data)                                       (0x00004000&((data)<<14))
+#define VP8_P2_VP8_P2_FRM1_write_enable4_src(data)                                   ((0x00004000&(data))>>14)
+#define VP8_P2_VP8_P2_FRM1_get_write_enable4(data)                                   ((0x00004000&(data))>>14)
+#define VP8_P2_VP8_P2_FRM1_mb_no_coeff_skip_shift                                    (13)
+#define VP8_P2_VP8_P2_FRM1_mb_no_coeff_skip_mask                                     (0x00002000)
+#define VP8_P2_VP8_P2_FRM1_mb_no_coeff_skip(data)                                    (0x00002000&((data)<<13))
+#define VP8_P2_VP8_P2_FRM1_mb_no_coeff_skip_src(data)                                ((0x00002000&(data))>>13)
+#define VP8_P2_VP8_P2_FRM1_get_mb_no_coeff_skip(data)                                ((0x00002000&(data))>>13)
+#define VP8_P2_VP8_P2_FRM1_write_enable3_shift                                       (12)
+#define VP8_P2_VP8_P2_FRM1_write_enable3_mask                                        (0x00001000)
+#define VP8_P2_VP8_P2_FRM1_write_enable3(data)                                       (0x00001000&((data)<<12))
+#define VP8_P2_VP8_P2_FRM1_write_enable3_src(data)                                   ((0x00001000&(data))>>12)
+#define VP8_P2_VP8_P2_FRM1_get_write_enable3(data)                                   ((0x00001000&(data))>>12)
+#define VP8_P2_VP8_P2_FRM1_segmentation_enabled_shift                                (11)
+#define VP8_P2_VP8_P2_FRM1_segmentation_enabled_mask                                 (0x00000800)
+#define VP8_P2_VP8_P2_FRM1_segmentation_enabled(data)                                (0x00000800&((data)<<11))
+#define VP8_P2_VP8_P2_FRM1_segmentation_enabled_src(data)                            ((0x00000800&(data))>>11)
+#define VP8_P2_VP8_P2_FRM1_get_segmentation_enabled(data)                            ((0x00000800&(data))>>11)
+#define VP8_P2_VP8_P2_FRM1_write_enable2_shift                                       (10)
+#define VP8_P2_VP8_P2_FRM1_write_enable2_mask                                        (0x00000400)
+#define VP8_P2_VP8_P2_FRM1_write_enable2(data)                                       (0x00000400&((data)<<10))
+#define VP8_P2_VP8_P2_FRM1_write_enable2_src(data)                                   ((0x00000400&(data))>>10)
+#define VP8_P2_VP8_P2_FRM1_get_write_enable2(data)                                   ((0x00000400&(data))>>10)
+#define VP8_P2_VP8_P2_FRM1_update_mb_segmentation_map_shift                          (9)
+#define VP8_P2_VP8_P2_FRM1_update_mb_segmentation_map_mask                           (0x00000200)
+#define VP8_P2_VP8_P2_FRM1_update_mb_segmentation_map(data)                          (0x00000200&((data)<<9))
+#define VP8_P2_VP8_P2_FRM1_update_mb_segmentation_map_src(data)                      ((0x00000200&(data))>>9)
+#define VP8_P2_VP8_P2_FRM1_get_update_mb_segmentation_map(data)                      ((0x00000200&(data))>>9)
+#define VP8_P2_VP8_P2_FRM1_write_enable1_shift                                       (8)
+#define VP8_P2_VP8_P2_FRM1_write_enable1_mask                                        (0x00000100)
+#define VP8_P2_VP8_P2_FRM1_write_enable1(data)                                       (0x00000100&((data)<<8))
+#define VP8_P2_VP8_P2_FRM1_write_enable1_src(data)                                   ((0x00000100&(data))>>8)
+#define VP8_P2_VP8_P2_FRM1_get_write_enable1(data)                                   ((0x00000100&(data))>>8)
+#define VP8_P2_VP8_P2_FRM1_prob_skip_false_shift                                     (0)
+#define VP8_P2_VP8_P2_FRM1_prob_skip_false_mask                                      (0x000000FF)
+#define VP8_P2_VP8_P2_FRM1_prob_skip_false(data)                                     (0x000000FF&((data)<<0))
+#define VP8_P2_VP8_P2_FRM1_prob_skip_false_src(data)                                 ((0x000000FF&(data))>>0)
+#define VP8_P2_VP8_P2_FRM1_get_prob_skip_false(data)                                 ((0x000000FF&(data))>>0)
+
+
+#define VP8_P2_VP8_P2_FRM2                                                           0x1800EF04
+#define VP8_P2_VP8_P2_FRM2_reg_addr                                                  "0xB800EF04"
+#define VP8_P2_VP8_P2_FRM2_reg                                                       0xB800EF04
+#define set_VP8_P2_VP8_P2_FRM2_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_P2_FRM2_reg)=data)
+#define get_VP8_P2_VP8_P2_FRM2_reg   (*((volatile unsigned int*) VP8_P2_VP8_P2_FRM2_reg))
+#define VP8_P2_VP8_P2_FRM2_inst_adr                                                  "0x00C1"
+#define VP8_P2_VP8_P2_FRM2_inst                                                      0x00C1
+#define VP8_P2_VP8_P2_FRM2_write_enable3_shift                                       (26)
+#define VP8_P2_VP8_P2_FRM2_write_enable3_mask                                        (0x04000000)
+#define VP8_P2_VP8_P2_FRM2_write_enable3(data)                                       (0x04000000&((data)<<26))
+#define VP8_P2_VP8_P2_FRM2_write_enable3_src(data)                                   ((0x04000000&(data))>>26)
+#define VP8_P2_VP8_P2_FRM2_get_write_enable3(data)                                   ((0x04000000&(data))>>26)
+#define VP8_P2_VP8_P2_FRM2_prob_gf_shift                                             (18)
+#define VP8_P2_VP8_P2_FRM2_prob_gf_mask                                              (0x03FC0000)
+#define VP8_P2_VP8_P2_FRM2_prob_gf(data)                                             (0x03FC0000&((data)<<18))
+#define VP8_P2_VP8_P2_FRM2_prob_gf_src(data)                                         ((0x03FC0000&(data))>>18)
+#define VP8_P2_VP8_P2_FRM2_get_prob_gf(data)                                         ((0x03FC0000&(data))>>18)
+#define VP8_P2_VP8_P2_FRM2_write_enable2_shift                                       (17)
+#define VP8_P2_VP8_P2_FRM2_write_enable2_mask                                        (0x00020000)
+#define VP8_P2_VP8_P2_FRM2_write_enable2(data)                                       (0x00020000&((data)<<17))
+#define VP8_P2_VP8_P2_FRM2_write_enable2_src(data)                                   ((0x00020000&(data))>>17)
+#define VP8_P2_VP8_P2_FRM2_get_write_enable2(data)                                   ((0x00020000&(data))>>17)
+#define VP8_P2_VP8_P2_FRM2_prob_last_shift                                           (9)
+#define VP8_P2_VP8_P2_FRM2_prob_last_mask                                            (0x0001FE00)
+#define VP8_P2_VP8_P2_FRM2_prob_last(data)                                           (0x0001FE00&((data)<<9))
+#define VP8_P2_VP8_P2_FRM2_prob_last_src(data)                                       ((0x0001FE00&(data))>>9)
+#define VP8_P2_VP8_P2_FRM2_get_prob_last(data)                                       ((0x0001FE00&(data))>>9)
+#define VP8_P2_VP8_P2_FRM2_write_enable1_shift                                       (8)
+#define VP8_P2_VP8_P2_FRM2_write_enable1_mask                                        (0x00000100)
+#define VP8_P2_VP8_P2_FRM2_write_enable1(data)                                       (0x00000100&((data)<<8))
+#define VP8_P2_VP8_P2_FRM2_write_enable1_src(data)                                   ((0x00000100&(data))>>8)
+#define VP8_P2_VP8_P2_FRM2_get_write_enable1(data)                                   ((0x00000100&(data))>>8)
+#define VP8_P2_VP8_P2_FRM2_prob_intra_shift                                          (0)
+#define VP8_P2_VP8_P2_FRM2_prob_intra_mask                                           (0x000000FF)
+#define VP8_P2_VP8_P2_FRM2_prob_intra(data)                                          (0x000000FF&((data)<<0))
+#define VP8_P2_VP8_P2_FRM2_prob_intra_src(data)                                      ((0x000000FF&(data))>>0)
+#define VP8_P2_VP8_P2_FRM2_get_prob_intra(data)                                      ((0x000000FF&(data))>>0)
+
+
+#define VP8_P2_VP8_P2_FRM3                                                           0x1800EF08
+#define VP8_P2_VP8_P2_FRM3_reg_addr                                                  "0xB800EF08"
+#define VP8_P2_VP8_P2_FRM3_reg                                                       0xB800EF08
+#define set_VP8_P2_VP8_P2_FRM3_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_P2_FRM3_reg)=data)
+#define get_VP8_P2_VP8_P2_FRM3_reg   (*((volatile unsigned int*) VP8_P2_VP8_P2_FRM3_reg))
+#define VP8_P2_VP8_P2_FRM3_inst_adr                                                  "0x00C2"
+#define VP8_P2_VP8_P2_FRM3_inst                                                      0x00C2
+#define VP8_P2_VP8_P2_FRM3_write_enable1_shift                                       (7)
+#define VP8_P2_VP8_P2_FRM3_write_enable1_mask                                        (0x00000080)
+#define VP8_P2_VP8_P2_FRM3_write_enable1(data)                                       (0x00000080&((data)<<7))
+#define VP8_P2_VP8_P2_FRM3_write_enable1_src(data)                                   ((0x00000080&(data))>>7)
+#define VP8_P2_VP8_P2_FRM3_get_write_enable1(data)                                   ((0x00000080&(data))>>7)
+#define VP8_P2_VP8_P2_FRM3_picmb_h_shift                                             (0)
+#define VP8_P2_VP8_P2_FRM3_picmb_h_mask                                              (0x0000007F)
+#define VP8_P2_VP8_P2_FRM3_picmb_h(data)                                             (0x0000007F&((data)<<0))
+#define VP8_P2_VP8_P2_FRM3_picmb_h_src(data)                                         ((0x0000007F&(data))>>0)
+#define VP8_P2_VP8_P2_FRM3_get_picmb_h(data)                                         ((0x0000007F&(data))>>0)
+
+
+#define VP8_P2_VP8_P2_MB1                                                            0x1800EF0C
+#define VP8_P2_VP8_P2_MB1_reg_addr                                                   "0xB800EF0C"
+#define VP8_P2_VP8_P2_MB1_reg                                                        0xB800EF0C
+#define set_VP8_P2_VP8_P2_MB1_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_P2_MB1_reg)=data)
+#define get_VP8_P2_VP8_P2_MB1_reg   (*((volatile unsigned int*) VP8_P2_VP8_P2_MB1_reg))
+#define VP8_P2_VP8_P2_MB1_inst_adr                                                   "0x00C3"
+#define VP8_P2_VP8_P2_MB1_inst                                                       0x00C3
+#define VP8_P2_VP8_P2_MB1_need_to_clamp_mvs_shift                                    (11)
+#define VP8_P2_VP8_P2_MB1_need_to_clamp_mvs_mask                                     (0x00000800)
+#define VP8_P2_VP8_P2_MB1_need_to_clamp_mvs(data)                                    (0x00000800&((data)<<11))
+#define VP8_P2_VP8_P2_MB1_need_to_clamp_mvs_src(data)                                ((0x00000800&(data))>>11)
+#define VP8_P2_VP8_P2_MB1_get_need_to_clamp_mvs(data)                                ((0x00000800&(data))>>11)
+#define VP8_P2_VP8_P2_MB1_ref_frame_shift                                            (9)
+#define VP8_P2_VP8_P2_MB1_ref_frame_mask                                             (0x00000600)
+#define VP8_P2_VP8_P2_MB1_ref_frame(data)                                            (0x00000600&((data)<<9))
+#define VP8_P2_VP8_P2_MB1_ref_frame_src(data)                                        ((0x00000600&(data))>>9)
+#define VP8_P2_VP8_P2_MB1_get_ref_frame(data)                                        ((0x00000600&(data))>>9)
+#define VP8_P2_VP8_P2_MB1_uv_mode_shift                                              (7)
+#define VP8_P2_VP8_P2_MB1_uv_mode_mask                                               (0x00000180)
+#define VP8_P2_VP8_P2_MB1_uv_mode(data)                                              (0x00000180&((data)<<7))
+#define VP8_P2_VP8_P2_MB1_uv_mode_src(data)                                          ((0x00000180&(data))>>7)
+#define VP8_P2_VP8_P2_MB1_get_uv_mode(data)                                          ((0x00000180&(data))>>7)
+#define VP8_P2_VP8_P2_MB1_mode_shift                                                 (3)
+#define VP8_P2_VP8_P2_MB1_mode_mask                                                  (0x00000078)
+#define VP8_P2_VP8_P2_MB1_mode(data)                                                 (0x00000078&((data)<<3))
+#define VP8_P2_VP8_P2_MB1_mode_src(data)                                             ((0x00000078&(data))>>3)
+#define VP8_P2_VP8_P2_MB1_get_mode(data)                                             ((0x00000078&(data))>>3)
+#define VP8_P2_VP8_P2_MB1_mb_skip_coeff_shift                                        (2)
+#define VP8_P2_VP8_P2_MB1_mb_skip_coeff_mask                                         (0x00000004)
+#define VP8_P2_VP8_P2_MB1_mb_skip_coeff(data)                                        (0x00000004&((data)<<2))
+#define VP8_P2_VP8_P2_MB1_mb_skip_coeff_src(data)                                    ((0x00000004&(data))>>2)
+#define VP8_P2_VP8_P2_MB1_get_mb_skip_coeff(data)                                    ((0x00000004&(data))>>2)
+#define VP8_P2_VP8_P2_MB1_segment_id_shift                                           (0)
+#define VP8_P2_VP8_P2_MB1_segment_id_mask                                            (0x00000003)
+#define VP8_P2_VP8_P2_MB1_segment_id(data)                                           (0x00000003&((data)<<0))
+#define VP8_P2_VP8_P2_MB1_segment_id_src(data)                                       ((0x00000003&(data))>>0)
+#define VP8_P2_VP8_P2_MB1_get_segment_id(data)                                       ((0x00000003&(data))>>0)
+
+
+#define VP8_P2_VP8_P2_MB2                                                            0x1800EF10
+#define VP8_P2_VP8_P2_MB2_reg_addr                                                   "0xB800EF10"
+#define VP8_P2_VP8_P2_MB2_reg                                                        0xB800EF10
+#define set_VP8_P2_VP8_P2_MB2_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_P2_MB2_reg)=data)
+#define get_VP8_P2_VP8_P2_MB2_reg   (*((volatile unsigned int*) VP8_P2_VP8_P2_MB2_reg))
+#define VP8_P2_VP8_P2_MB2_inst_adr                                                   "0x00C4"
+#define VP8_P2_VP8_P2_MB2_inst                                                       0x00C4
+#define VP8_P2_VP8_P2_MB2_write_enable3_shift                                        (26)
+#define VP8_P2_VP8_P2_MB2_write_enable3_mask                                         (0x04000000)
+#define VP8_P2_VP8_P2_MB2_write_enable3(data)                                        (0x04000000&((data)<<26))
+#define VP8_P2_VP8_P2_MB2_write_enable3_src(data)                                    ((0x04000000&(data))>>26)
+#define VP8_P2_VP8_P2_MB2_get_write_enable3(data)                                    ((0x04000000&(data))>>26)
+#define VP8_P2_VP8_P2_MB2_ndb_p2_flush_shift                                         (25)
+#define VP8_P2_VP8_P2_MB2_ndb_p2_flush_mask                                          (0x02000000)
+#define VP8_P2_VP8_P2_MB2_ndb_p2_flush(data)                                         (0x02000000&((data)<<25))
+#define VP8_P2_VP8_P2_MB2_ndb_p2_flush_src(data)                                     ((0x02000000&(data))>>25)
+#define VP8_P2_VP8_P2_MB2_get_ndb_p2_flush(data)                                     ((0x02000000&(data))>>25)
+#define VP8_P2_VP8_P2_MB2_write_enable2_shift                                        (24)
+#define VP8_P2_VP8_P2_MB2_write_enable2_mask                                         (0x01000000)
+#define VP8_P2_VP8_P2_MB2_write_enable2(data)                                        (0x01000000&((data)<<24))
+#define VP8_P2_VP8_P2_MB2_write_enable2_src(data)                                    ((0x01000000&(data))>>24)
+#define VP8_P2_VP8_P2_MB2_get_write_enable2(data)                                    ((0x01000000&(data))>>24)
+#define VP8_P2_VP8_P2_MB2_mby_shift                                                  (17)
+#define VP8_P2_VP8_P2_MB2_mby_mask                                                   (0x00FE0000)
+#define VP8_P2_VP8_P2_MB2_mby(data)                                                  (0x00FE0000&((data)<<17))
+#define VP8_P2_VP8_P2_MB2_mby_src(data)                                              ((0x00FE0000&(data))>>17)
+#define VP8_P2_VP8_P2_MB2_get_mby(data)                                              ((0x00FE0000&(data))>>17)
+#define VP8_P2_VP8_P2_MB2_write_enable1_shift                                        (16)
+#define VP8_P2_VP8_P2_MB2_write_enable1_mask                                         (0x00010000)
+#define VP8_P2_VP8_P2_MB2_write_enable1(data)                                        (0x00010000&((data)<<16))
+#define VP8_P2_VP8_P2_MB2_write_enable1_src(data)                                    ((0x00010000&(data))>>16)
+#define VP8_P2_VP8_P2_MB2_get_write_enable1(data)                                    ((0x00010000&(data))>>16)
+#define VP8_P2_VP8_P2_MB2_left_sub_block_mode_shift                                  (0)
+#define VP8_P2_VP8_P2_MB2_left_sub_block_mode_mask                                   (0x0000FFFF)
+#define VP8_P2_VP8_P2_MB2_left_sub_block_mode(data)                                  (0x0000FFFF&((data)<<0))
+#define VP8_P2_VP8_P2_MB2_left_sub_block_mode_src(data)                              ((0x0000FFFF&(data))>>0)
+#define VP8_P2_VP8_P2_MB2_get_left_sub_block_mode(data)                              ((0x0000FFFF&(data))>>0)
+
+
+#define VP8_P2_VP8_P2_SUB_BLK0                                                       0x1800EF14
+#define VP8_P2_VP8_P2_SUB_BLK0_reg_addr                                              "0xB800EF14"
+#define VP8_P2_VP8_P2_SUB_BLK0_reg                                                   0xB800EF14
+#define set_VP8_P2_VP8_P2_SUB_BLK0_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_P2_SUB_BLK0_reg)=data)
+#define get_VP8_P2_VP8_P2_SUB_BLK0_reg   (*((volatile unsigned int*) VP8_P2_VP8_P2_SUB_BLK0_reg))
+#define VP8_P2_VP8_P2_SUB_BLK0_inst_adr                                              "0x00C5"
+#define VP8_P2_VP8_P2_SUB_BLK0_inst                                                  0x00C5
+#define VP8_P2_VP8_P2_SUB_BLK0_sub_blk_mode_p0_shift                                 (0)
+#define VP8_P2_VP8_P2_SUB_BLK0_sub_blk_mode_p0_mask                                  (0xFFFFFFFF)
+#define VP8_P2_VP8_P2_SUB_BLK0_sub_blk_mode_p0(data)                                 (0xFFFFFFFF&((data)<<0))
+#define VP8_P2_VP8_P2_SUB_BLK0_sub_blk_mode_p0_src(data)                             ((0xFFFFFFFF&(data))>>0)
+#define VP8_P2_VP8_P2_SUB_BLK0_get_sub_blk_mode_p0(data)                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define VP8_P2_VP8_P2_SUB_BLK1                                                       0x1800EF18
+#define VP8_P2_VP8_P2_SUB_BLK1_reg_addr                                              "0xB800EF18"
+#define VP8_P2_VP8_P2_SUB_BLK1_reg                                                   0xB800EF18
+#define set_VP8_P2_VP8_P2_SUB_BLK1_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_P2_SUB_BLK1_reg)=data)
+#define get_VP8_P2_VP8_P2_SUB_BLK1_reg   (*((volatile unsigned int*) VP8_P2_VP8_P2_SUB_BLK1_reg))
+#define VP8_P2_VP8_P2_SUB_BLK1_inst_adr                                              "0x00C6"
+#define VP8_P2_VP8_P2_SUB_BLK1_inst                                                  0x00C6
+#define VP8_P2_VP8_P2_SUB_BLK1_sub_blk_mode_p1_shift                                 (0)
+#define VP8_P2_VP8_P2_SUB_BLK1_sub_blk_mode_p1_mask                                  (0xFFFFFFFF)
+#define VP8_P2_VP8_P2_SUB_BLK1_sub_blk_mode_p1(data)                                 (0xFFFFFFFF&((data)<<0))
+#define VP8_P2_VP8_P2_SUB_BLK1_sub_blk_mode_p1_src(data)                             ((0xFFFFFFFF&(data))>>0)
+#define VP8_P2_VP8_P2_SUB_BLK1_get_sub_blk_mode_p1(data)                             ((0xFFFFFFFF&(data))>>0)
+
+
+#define VP8_P2_VP8_P2_MB_INFO                                                        0x1800EF1C
+#define VP8_P2_VP8_P2_MB_INFO_reg_addr                                               "0xB800EF1C"
+#define VP8_P2_VP8_P2_MB_INFO_reg                                                    0xB800EF1C
+#define set_VP8_P2_VP8_P2_MB_INFO_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_P2_MB_INFO_reg)=data)
+#define get_VP8_P2_VP8_P2_MB_INFO_reg   (*((volatile unsigned int*) VP8_P2_VP8_P2_MB_INFO_reg))
+#define VP8_P2_VP8_P2_MB_INFO_inst_adr                                               "0x00C7"
+#define VP8_P2_VP8_P2_MB_INFO_inst                                                   0x00C7
+#define VP8_P2_VP8_P2_MB_INFO_vp8_p2_curmb_shift                                     (17)
+#define VP8_P2_VP8_P2_MB_INFO_vp8_p2_curmb_mask                                      (0x03FE0000)
+#define VP8_P2_VP8_P2_MB_INFO_vp8_p2_curmb(data)                                     (0x03FE0000&((data)<<17))
+#define VP8_P2_VP8_P2_MB_INFO_vp8_p2_curmb_src(data)                                 ((0x03FE0000&(data))>>17)
+#define VP8_P2_VP8_P2_MB_INFO_get_vp8_p2_curmb(data)                                 ((0x03FE0000&(data))>>17)
+#define VP8_P2_VP8_P2_MB_INFO_vp8_mbpartition_shift                                  (8)
+#define VP8_P2_VP8_P2_MB_INFO_vp8_mbpartition_mask                                   (0x0001FF00)
+#define VP8_P2_VP8_P2_MB_INFO_vp8_mbpartition(data)                                  (0x0001FF00&((data)<<8))
+#define VP8_P2_VP8_P2_MB_INFO_vp8_mbpartition_src(data)                              ((0x0001FF00&(data))>>8)
+#define VP8_P2_VP8_P2_MB_INFO_get_vp8_mbpartition(data)                              ((0x0001FF00&(data))>>8)
+#define VP8_P2_VP8_P2_MB_INFO_vp8_Inter_pred_option_shift                            (0)
+#define VP8_P2_VP8_P2_MB_INFO_vp8_Inter_pred_option_mask                             (0x000000FF)
+#define VP8_P2_VP8_P2_MB_INFO_vp8_Inter_pred_option(data)                            (0x000000FF&((data)<<0))
+#define VP8_P2_VP8_P2_MB_INFO_vp8_Inter_pred_option_src(data)                        ((0x000000FF&(data))>>0)
+#define VP8_P2_VP8_P2_MB_INFO_get_vp8_Inter_pred_option(data)                        ((0x000000FF&(data))>>0)
+
+
+#define VP8_P2_VP8_BAC                                                               0x1800EF20
+#define VP8_P2_VP8_BAC_reg_addr                                                      "0xB800EF20"
+#define VP8_P2_VP8_BAC_reg                                                           0xB800EF20
+#define set_VP8_P2_VP8_BAC_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_BAC_reg)=data)
+#define get_VP8_P2_VP8_BAC_reg   (*((volatile unsigned int*) VP8_P2_VP8_BAC_reg))
+#define VP8_P2_VP8_BAC_inst_adr                                                      "0x00C8"
+#define VP8_P2_VP8_BAC_inst                                                          0x00C8
+#define VP8_P2_VP8_BAC_high_shift                                                    (20)
+#define VP8_P2_VP8_BAC_high_mask                                                     (0x1FF00000)
+#define VP8_P2_VP8_BAC_high(data)                                                    (0x1FF00000&((data)<<20))
+#define VP8_P2_VP8_BAC_high_src(data)                                                ((0x1FF00000&(data))>>20)
+#define VP8_P2_VP8_BAC_get_high(data)                                                ((0x1FF00000&(data))>>20)
+#define VP8_P2_VP8_BAC_bits_shift                                                    (16)
+#define VP8_P2_VP8_BAC_bits_mask                                                     (0x000F0000)
+#define VP8_P2_VP8_BAC_bits(data)                                                    (0x000F0000&((data)<<16))
+#define VP8_P2_VP8_BAC_bits_src(data)                                                ((0x000F0000&(data))>>16)
+#define VP8_P2_VP8_BAC_get_bits(data)                                                ((0x000F0000&(data))>>16)
+#define VP8_P2_VP8_BAC_code_word_shift                                               (0)
+#define VP8_P2_VP8_BAC_code_word_mask                                                (0x0000FFFF)
+#define VP8_P2_VP8_BAC_code_word(data)                                               (0x0000FFFF&((data)<<0))
+#define VP8_P2_VP8_BAC_code_word_src(data)                                           ((0x0000FFFF&(data))>>0)
+#define VP8_P2_VP8_BAC_get_code_word(data)                                           ((0x0000FFFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV0                                                            0x1800EF24
+#define VP8_P2_VP8_MB_MV0_reg_addr                                                   "0xB800EF24"
+#define VP8_P2_VP8_MB_MV0_reg                                                        0xB800EF24
+#define set_VP8_P2_VP8_MB_MV0_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV0_reg)=data)
+#define get_VP8_P2_VP8_MB_MV0_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV0_reg))
+#define VP8_P2_VP8_MB_MV0_inst_adr                                                   "0x00C9"
+#define VP8_P2_VP8_MB_MV0_inst                                                       0x00C9
+#define VP8_P2_VP8_MB_MV0_mv_x_shift                                                 (14)
+#define VP8_P2_VP8_MB_MV0_mv_x_mask                                                  (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV0_mv_x(data)                                                 (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV0_mv_x_src(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV0_get_mv_x(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV0_mv_y_shift                                                 (0)
+#define VP8_P2_VP8_MB_MV0_mv_y_mask                                                  (0x00003FFF)
+#define VP8_P2_VP8_MB_MV0_mv_y(data)                                                 (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV0_mv_y_src(data)                                             ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV0_get_mv_y(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV1                                                            0x1800EF28
+#define VP8_P2_VP8_MB_MV1_reg_addr                                                   "0xB800EF28"
+#define VP8_P2_VP8_MB_MV1_reg                                                        0xB800EF28
+#define set_VP8_P2_VP8_MB_MV1_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV1_reg)=data)
+#define get_VP8_P2_VP8_MB_MV1_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV1_reg))
+#define VP8_P2_VP8_MB_MV1_inst_adr                                                   "0x00CA"
+#define VP8_P2_VP8_MB_MV1_inst                                                       0x00CA
+#define VP8_P2_VP8_MB_MV1_mv_x_shift                                                 (14)
+#define VP8_P2_VP8_MB_MV1_mv_x_mask                                                  (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV1_mv_x(data)                                                 (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV1_mv_x_src(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV1_get_mv_x(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV1_mv_y_shift                                                 (0)
+#define VP8_P2_VP8_MB_MV1_mv_y_mask                                                  (0x00003FFF)
+#define VP8_P2_VP8_MB_MV1_mv_y(data)                                                 (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV1_mv_y_src(data)                                             ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV1_get_mv_y(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV2                                                            0x1800EF2C
+#define VP8_P2_VP8_MB_MV2_reg_addr                                                   "0xB800EF2C"
+#define VP8_P2_VP8_MB_MV2_reg                                                        0xB800EF2C
+#define set_VP8_P2_VP8_MB_MV2_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV2_reg)=data)
+#define get_VP8_P2_VP8_MB_MV2_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV2_reg))
+#define VP8_P2_VP8_MB_MV2_inst_adr                                                   "0x00CB"
+#define VP8_P2_VP8_MB_MV2_inst                                                       0x00CB
+#define VP8_P2_VP8_MB_MV2_mv_x_shift                                                 (14)
+#define VP8_P2_VP8_MB_MV2_mv_x_mask                                                  (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV2_mv_x(data)                                                 (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV2_mv_x_src(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV2_get_mv_x(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV2_mv_y_shift                                                 (0)
+#define VP8_P2_VP8_MB_MV2_mv_y_mask                                                  (0x00003FFF)
+#define VP8_P2_VP8_MB_MV2_mv_y(data)                                                 (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV2_mv_y_src(data)                                             ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV2_get_mv_y(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV3                                                            0x1800EF30
+#define VP8_P2_VP8_MB_MV3_reg_addr                                                   "0xB800EF30"
+#define VP8_P2_VP8_MB_MV3_reg                                                        0xB800EF30
+#define set_VP8_P2_VP8_MB_MV3_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV3_reg)=data)
+#define get_VP8_P2_VP8_MB_MV3_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV3_reg))
+#define VP8_P2_VP8_MB_MV3_inst_adr                                                   "0x00CC"
+#define VP8_P2_VP8_MB_MV3_inst                                                       0x00CC
+#define VP8_P2_VP8_MB_MV3_mv_x_shift                                                 (14)
+#define VP8_P2_VP8_MB_MV3_mv_x_mask                                                  (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV3_mv_x(data)                                                 (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV3_mv_x_src(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV3_get_mv_x(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV3_mv_y_shift                                                 (0)
+#define VP8_P2_VP8_MB_MV3_mv_y_mask                                                  (0x00003FFF)
+#define VP8_P2_VP8_MB_MV3_mv_y(data)                                                 (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV3_mv_y_src(data)                                             ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV3_get_mv_y(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV4                                                            0x1800EF34
+#define VP8_P2_VP8_MB_MV4_reg_addr                                                   "0xB800EF34"
+#define VP8_P2_VP8_MB_MV4_reg                                                        0xB800EF34
+#define set_VP8_P2_VP8_MB_MV4_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV4_reg)=data)
+#define get_VP8_P2_VP8_MB_MV4_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV4_reg))
+#define VP8_P2_VP8_MB_MV4_inst_adr                                                   "0x00CD"
+#define VP8_P2_VP8_MB_MV4_inst                                                       0x00CD
+#define VP8_P2_VP8_MB_MV4_mv_x_shift                                                 (14)
+#define VP8_P2_VP8_MB_MV4_mv_x_mask                                                  (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV4_mv_x(data)                                                 (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV4_mv_x_src(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV4_get_mv_x(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV4_mv_y_shift                                                 (0)
+#define VP8_P2_VP8_MB_MV4_mv_y_mask                                                  (0x00003FFF)
+#define VP8_P2_VP8_MB_MV4_mv_y(data)                                                 (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV4_mv_y_src(data)                                             ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV4_get_mv_y(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV5                                                            0x1800EF38
+#define VP8_P2_VP8_MB_MV5_reg_addr                                                   "0xB800EF38"
+#define VP8_P2_VP8_MB_MV5_reg                                                        0xB800EF38
+#define set_VP8_P2_VP8_MB_MV5_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV5_reg)=data)
+#define get_VP8_P2_VP8_MB_MV5_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV5_reg))
+#define VP8_P2_VP8_MB_MV5_inst_adr                                                   "0x00CE"
+#define VP8_P2_VP8_MB_MV5_inst                                                       0x00CE
+#define VP8_P2_VP8_MB_MV5_mv_x_shift                                                 (14)
+#define VP8_P2_VP8_MB_MV5_mv_x_mask                                                  (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV5_mv_x(data)                                                 (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV5_mv_x_src(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV5_get_mv_x(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV5_mv_y_shift                                                 (0)
+#define VP8_P2_VP8_MB_MV5_mv_y_mask                                                  (0x00003FFF)
+#define VP8_P2_VP8_MB_MV5_mv_y(data)                                                 (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV5_mv_y_src(data)                                             ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV5_get_mv_y(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV6                                                            0x1800EF3C
+#define VP8_P2_VP8_MB_MV6_reg_addr                                                   "0xB800EF3C"
+#define VP8_P2_VP8_MB_MV6_reg                                                        0xB800EF3C
+#define set_VP8_P2_VP8_MB_MV6_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV6_reg)=data)
+#define get_VP8_P2_VP8_MB_MV6_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV6_reg))
+#define VP8_P2_VP8_MB_MV6_inst_adr                                                   "0x00CF"
+#define VP8_P2_VP8_MB_MV6_inst                                                       0x00CF
+#define VP8_P2_VP8_MB_MV6_mv_x_shift                                                 (14)
+#define VP8_P2_VP8_MB_MV6_mv_x_mask                                                  (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV6_mv_x(data)                                                 (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV6_mv_x_src(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV6_get_mv_x(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV6_mv_y_shift                                                 (0)
+#define VP8_P2_VP8_MB_MV6_mv_y_mask                                                  (0x00003FFF)
+#define VP8_P2_VP8_MB_MV6_mv_y(data)                                                 (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV6_mv_y_src(data)                                             ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV6_get_mv_y(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV7                                                            0x1800EF40
+#define VP8_P2_VP8_MB_MV7_reg_addr                                                   "0xB800EF40"
+#define VP8_P2_VP8_MB_MV7_reg                                                        0xB800EF40
+#define set_VP8_P2_VP8_MB_MV7_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV7_reg)=data)
+#define get_VP8_P2_VP8_MB_MV7_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV7_reg))
+#define VP8_P2_VP8_MB_MV7_inst_adr                                                   "0x00D0"
+#define VP8_P2_VP8_MB_MV7_inst                                                       0x00D0
+#define VP8_P2_VP8_MB_MV7_mv_x_shift                                                 (14)
+#define VP8_P2_VP8_MB_MV7_mv_x_mask                                                  (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV7_mv_x(data)                                                 (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV7_mv_x_src(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV7_get_mv_x(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV7_mv_y_shift                                                 (0)
+#define VP8_P2_VP8_MB_MV7_mv_y_mask                                                  (0x00003FFF)
+#define VP8_P2_VP8_MB_MV7_mv_y(data)                                                 (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV7_mv_y_src(data)                                             ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV7_get_mv_y(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV8                                                            0x1800EF44
+#define VP8_P2_VP8_MB_MV8_reg_addr                                                   "0xB800EF44"
+#define VP8_P2_VP8_MB_MV8_reg                                                        0xB800EF44
+#define set_VP8_P2_VP8_MB_MV8_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV8_reg)=data)
+#define get_VP8_P2_VP8_MB_MV8_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV8_reg))
+#define VP8_P2_VP8_MB_MV8_inst_adr                                                   "0x00D1"
+#define VP8_P2_VP8_MB_MV8_inst                                                       0x00D1
+#define VP8_P2_VP8_MB_MV8_mv_x_shift                                                 (14)
+#define VP8_P2_VP8_MB_MV8_mv_x_mask                                                  (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV8_mv_x(data)                                                 (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV8_mv_x_src(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV8_get_mv_x(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV8_mv_y_shift                                                 (0)
+#define VP8_P2_VP8_MB_MV8_mv_y_mask                                                  (0x00003FFF)
+#define VP8_P2_VP8_MB_MV8_mv_y(data)                                                 (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV8_mv_y_src(data)                                             ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV8_get_mv_y(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV9                                                            0x1800EF48
+#define VP8_P2_VP8_MB_MV9_reg_addr                                                   "0xB800EF48"
+#define VP8_P2_VP8_MB_MV9_reg                                                        0xB800EF48
+#define set_VP8_P2_VP8_MB_MV9_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV9_reg)=data)
+#define get_VP8_P2_VP8_MB_MV9_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV9_reg))
+#define VP8_P2_VP8_MB_MV9_inst_adr                                                   "0x00D2"
+#define VP8_P2_VP8_MB_MV9_inst                                                       0x00D2
+#define VP8_P2_VP8_MB_MV9_mv_x_shift                                                 (14)
+#define VP8_P2_VP8_MB_MV9_mv_x_mask                                                  (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV9_mv_x(data)                                                 (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV9_mv_x_src(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV9_get_mv_x(data)                                             ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV9_mv_y_shift                                                 (0)
+#define VP8_P2_VP8_MB_MV9_mv_y_mask                                                  (0x00003FFF)
+#define VP8_P2_VP8_MB_MV9_mv_y(data)                                                 (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV9_mv_y_src(data)                                             ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV9_get_mv_y(data)                                             ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV10                                                           0x1800EF4C
+#define VP8_P2_VP8_MB_MV10_reg_addr                                                  "0xB800EF4C"
+#define VP8_P2_VP8_MB_MV10_reg                                                       0xB800EF4C
+#define set_VP8_P2_VP8_MB_MV10_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV10_reg)=data)
+#define get_VP8_P2_VP8_MB_MV10_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV10_reg))
+#define VP8_P2_VP8_MB_MV10_inst_adr                                                  "0x00D3"
+#define VP8_P2_VP8_MB_MV10_inst                                                      0x00D3
+#define VP8_P2_VP8_MB_MV10_mv_x_shift                                                (14)
+#define VP8_P2_VP8_MB_MV10_mv_x_mask                                                 (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV10_mv_x(data)                                                (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV10_mv_x_src(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV10_get_mv_x(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV10_mv_y_shift                                                (0)
+#define VP8_P2_VP8_MB_MV10_mv_y_mask                                                 (0x00003FFF)
+#define VP8_P2_VP8_MB_MV10_mv_y(data)                                                (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV10_mv_y_src(data)                                            ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV10_get_mv_y(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV11                                                           0x1800EF50
+#define VP8_P2_VP8_MB_MV11_reg_addr                                                  "0xB800EF50"
+#define VP8_P2_VP8_MB_MV11_reg                                                       0xB800EF50
+#define set_VP8_P2_VP8_MB_MV11_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV11_reg)=data)
+#define get_VP8_P2_VP8_MB_MV11_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV11_reg))
+#define VP8_P2_VP8_MB_MV11_inst_adr                                                  "0x00D4"
+#define VP8_P2_VP8_MB_MV11_inst                                                      0x00D4
+#define VP8_P2_VP8_MB_MV11_mv_x_shift                                                (14)
+#define VP8_P2_VP8_MB_MV11_mv_x_mask                                                 (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV11_mv_x(data)                                                (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV11_mv_x_src(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV11_get_mv_x(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV11_mv_y_shift                                                (0)
+#define VP8_P2_VP8_MB_MV11_mv_y_mask                                                 (0x00003FFF)
+#define VP8_P2_VP8_MB_MV11_mv_y(data)                                                (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV11_mv_y_src(data)                                            ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV11_get_mv_y(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV12                                                           0x1800EF54
+#define VP8_P2_VP8_MB_MV12_reg_addr                                                  "0xB800EF54"
+#define VP8_P2_VP8_MB_MV12_reg                                                       0xB800EF54
+#define set_VP8_P2_VP8_MB_MV12_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV12_reg)=data)
+#define get_VP8_P2_VP8_MB_MV12_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV12_reg))
+#define VP8_P2_VP8_MB_MV12_inst_adr                                                  "0x00D5"
+#define VP8_P2_VP8_MB_MV12_inst                                                      0x00D5
+#define VP8_P2_VP8_MB_MV12_mv_x_shift                                                (14)
+#define VP8_P2_VP8_MB_MV12_mv_x_mask                                                 (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV12_mv_x(data)                                                (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV12_mv_x_src(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV12_get_mv_x(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV12_mv_y_shift                                                (0)
+#define VP8_P2_VP8_MB_MV12_mv_y_mask                                                 (0x00003FFF)
+#define VP8_P2_VP8_MB_MV12_mv_y(data)                                                (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV12_mv_y_src(data)                                            ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV12_get_mv_y(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV13                                                           0x1800EF58
+#define VP8_P2_VP8_MB_MV13_reg_addr                                                  "0xB800EF58"
+#define VP8_P2_VP8_MB_MV13_reg                                                       0xB800EF58
+#define set_VP8_P2_VP8_MB_MV13_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV13_reg)=data)
+#define get_VP8_P2_VP8_MB_MV13_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV13_reg))
+#define VP8_P2_VP8_MB_MV13_inst_adr                                                  "0x00D6"
+#define VP8_P2_VP8_MB_MV13_inst                                                      0x00D6
+#define VP8_P2_VP8_MB_MV13_mv_x_shift                                                (14)
+#define VP8_P2_VP8_MB_MV13_mv_x_mask                                                 (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV13_mv_x(data)                                                (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV13_mv_x_src(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV13_get_mv_x(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV13_mv_y_shift                                                (0)
+#define VP8_P2_VP8_MB_MV13_mv_y_mask                                                 (0x00003FFF)
+#define VP8_P2_VP8_MB_MV13_mv_y(data)                                                (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV13_mv_y_src(data)                                            ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV13_get_mv_y(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV14                                                           0x1800EF5C
+#define VP8_P2_VP8_MB_MV14_reg_addr                                                  "0xB800EF5C"
+#define VP8_P2_VP8_MB_MV14_reg                                                       0xB800EF5C
+#define set_VP8_P2_VP8_MB_MV14_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV14_reg)=data)
+#define get_VP8_P2_VP8_MB_MV14_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV14_reg))
+#define VP8_P2_VP8_MB_MV14_inst_adr                                                  "0x00D7"
+#define VP8_P2_VP8_MB_MV14_inst                                                      0x00D7
+#define VP8_P2_VP8_MB_MV14_mv_x_shift                                                (14)
+#define VP8_P2_VP8_MB_MV14_mv_x_mask                                                 (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV14_mv_x(data)                                                (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV14_mv_x_src(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV14_get_mv_x(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV14_mv_y_shift                                                (0)
+#define VP8_P2_VP8_MB_MV14_mv_y_mask                                                 (0x00003FFF)
+#define VP8_P2_VP8_MB_MV14_mv_y(data)                                                (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV14_mv_y_src(data)                                            ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV14_get_mv_y(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_MV15                                                           0x1800EF60
+#define VP8_P2_VP8_MB_MV15_reg_addr                                                  "0xB800EF60"
+#define VP8_P2_VP8_MB_MV15_reg                                                       0xB800EF60
+#define set_VP8_P2_VP8_MB_MV15_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV15_reg)=data)
+#define get_VP8_P2_VP8_MB_MV15_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_MV15_reg))
+#define VP8_P2_VP8_MB_MV15_inst_adr                                                  "0x00D8"
+#define VP8_P2_VP8_MB_MV15_inst                                                      0x00D8
+#define VP8_P2_VP8_MB_MV15_mv_x_shift                                                (14)
+#define VP8_P2_VP8_MB_MV15_mv_x_mask                                                 (0x1FFFC000)
+#define VP8_P2_VP8_MB_MV15_mv_x(data)                                                (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_MV15_mv_x_src(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV15_get_mv_x(data)                                            ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_MV15_mv_y_shift                                                (0)
+#define VP8_P2_VP8_MB_MV15_mv_y_mask                                                 (0x00003FFF)
+#define VP8_P2_VP8_MB_MV15_mv_y(data)                                                (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_MV15_mv_y_src(data)                                            ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_MV15_get_mv_y(data)                                            ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_CH_MV0                                                         0x1800EF64
+#define VP8_P2_VP8_MB_CH_MV0_reg_addr                                                "0xB800EF64"
+#define VP8_P2_VP8_MB_CH_MV0_reg                                                     0xB800EF64
+#define set_VP8_P2_VP8_MB_CH_MV0_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_CH_MV0_reg)=data)
+#define get_VP8_P2_VP8_MB_CH_MV0_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_CH_MV0_reg))
+#define VP8_P2_VP8_MB_CH_MV0_inst_adr                                                "0x00D9"
+#define VP8_P2_VP8_MB_CH_MV0_inst                                                    0x00D9
+#define VP8_P2_VP8_MB_CH_MV0_mv_x_shift                                              (14)
+#define VP8_P2_VP8_MB_CH_MV0_mv_x_mask                                               (0x1FFFC000)
+#define VP8_P2_VP8_MB_CH_MV0_mv_x(data)                                              (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_CH_MV0_mv_x_src(data)                                          ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_CH_MV0_get_mv_x(data)                                          ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_CH_MV0_mv_y_shift                                              (0)
+#define VP8_P2_VP8_MB_CH_MV0_mv_y_mask                                               (0x00003FFF)
+#define VP8_P2_VP8_MB_CH_MV0_mv_y(data)                                              (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_CH_MV0_mv_y_src(data)                                          ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_CH_MV0_get_mv_y(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_CH_MV1                                                         0x1800EF68
+#define VP8_P2_VP8_MB_CH_MV1_reg_addr                                                "0xB800EF68"
+#define VP8_P2_VP8_MB_CH_MV1_reg                                                     0xB800EF68
+#define set_VP8_P2_VP8_MB_CH_MV1_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_CH_MV1_reg)=data)
+#define get_VP8_P2_VP8_MB_CH_MV1_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_CH_MV1_reg))
+#define VP8_P2_VP8_MB_CH_MV1_inst_adr                                                "0x00DA"
+#define VP8_P2_VP8_MB_CH_MV1_inst                                                    0x00DA
+#define VP8_P2_VP8_MB_CH_MV1_mv_x_shift                                              (14)
+#define VP8_P2_VP8_MB_CH_MV1_mv_x_mask                                               (0x1FFFC000)
+#define VP8_P2_VP8_MB_CH_MV1_mv_x(data)                                              (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_CH_MV1_mv_x_src(data)                                          ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_CH_MV1_get_mv_x(data)                                          ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_CH_MV1_mv_y_shift                                              (0)
+#define VP8_P2_VP8_MB_CH_MV1_mv_y_mask                                               (0x00003FFF)
+#define VP8_P2_VP8_MB_CH_MV1_mv_y(data)                                              (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_CH_MV1_mv_y_src(data)                                          ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_CH_MV1_get_mv_y(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_CH_MV2                                                         0x1800EF6C
+#define VP8_P2_VP8_MB_CH_MV2_reg_addr                                                "0xB800EF6C"
+#define VP8_P2_VP8_MB_CH_MV2_reg                                                     0xB800EF6C
+#define set_VP8_P2_VP8_MB_CH_MV2_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_CH_MV2_reg)=data)
+#define get_VP8_P2_VP8_MB_CH_MV2_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_CH_MV2_reg))
+#define VP8_P2_VP8_MB_CH_MV2_inst_adr                                                "0x00DB"
+#define VP8_P2_VP8_MB_CH_MV2_inst                                                    0x00DB
+#define VP8_P2_VP8_MB_CH_MV2_mv_x_shift                                              (14)
+#define VP8_P2_VP8_MB_CH_MV2_mv_x_mask                                               (0x1FFFC000)
+#define VP8_P2_VP8_MB_CH_MV2_mv_x(data)                                              (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_CH_MV2_mv_x_src(data)                                          ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_CH_MV2_get_mv_x(data)                                          ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_CH_MV2_mv_y_shift                                              (0)
+#define VP8_P2_VP8_MB_CH_MV2_mv_y_mask                                               (0x00003FFF)
+#define VP8_P2_VP8_MB_CH_MV2_mv_y(data)                                              (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_CH_MV2_mv_y_src(data)                                          ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_CH_MV2_get_mv_y(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#define VP8_P2_VP8_MB_CH_MV3                                                         0x1800EF70
+#define VP8_P2_VP8_MB_CH_MV3_reg_addr                                                "0xB800EF70"
+#define VP8_P2_VP8_MB_CH_MV3_reg                                                     0xB800EF70
+#define set_VP8_P2_VP8_MB_CH_MV3_reg(data)   (*((volatile unsigned int*) VP8_P2_VP8_MB_CH_MV3_reg)=data)
+#define get_VP8_P2_VP8_MB_CH_MV3_reg   (*((volatile unsigned int*) VP8_P2_VP8_MB_CH_MV3_reg))
+#define VP8_P2_VP8_MB_CH_MV3_inst_adr                                                "0x00DC"
+#define VP8_P2_VP8_MB_CH_MV3_inst                                                    0x00DC
+#define VP8_P2_VP8_MB_CH_MV3_mv_x_shift                                              (14)
+#define VP8_P2_VP8_MB_CH_MV3_mv_x_mask                                               (0x1FFFC000)
+#define VP8_P2_VP8_MB_CH_MV3_mv_x(data)                                              (0x1FFFC000&((data)<<14))
+#define VP8_P2_VP8_MB_CH_MV3_mv_x_src(data)                                          ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_CH_MV3_get_mv_x(data)                                          ((0x1FFFC000&(data))>>14)
+#define VP8_P2_VP8_MB_CH_MV3_mv_y_shift                                              (0)
+#define VP8_P2_VP8_MB_CH_MV3_mv_y_mask                                               (0x00003FFF)
+#define VP8_P2_VP8_MB_CH_MV3_mv_y(data)                                              (0x00003FFF&((data)<<0))
+#define VP8_P2_VP8_MB_CH_MV3_mv_y_src(data)                                          ((0x00003FFF&(data))>>0)
+#define VP8_P2_VP8_MB_CH_MV3_get_mv_y(data)                                          ((0x00003FFF&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/include/wrap_a7_reg.h b/drivers/video/fbdev/rtk/dc2vo/fpga/include/wrap_a7_reg.h
new file mode 100644
index 00000000..d126cd6
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/include/wrap_a7_reg.h
@@ -0,0 +1,2606 @@
+/**************************************************************
+// Spec Version                  : unknown
+// Parser Version                : DVR_Parser_6.11(120105)
+// CModelGen Version             : 5.1 2012.01.05
+// Naming Rule                   :  Register_Name
+// Naming Rule                   : Module_Register_Name_reg
+// Parse Option                  : Only Parse _op1
+// Parse Address Region          : All Address Region 
+// Decode bit number             : 12 bits
+// Firmware Header Generate Date : 2013/7/21 2:27:52
+***************************************************************/
+
+
+#ifndef _WRAP_A7_REG_H_INCLUDED_
+#define _WRAP_A7_REG_H_INCLUDED_
+#ifdef  _WRAP_A7_USE_STRUCT
+typedef struct 
+{
+unsigned int     dc_remote_wdata_num:4;
+unsigned int     dc_remote_cmd_num:4;
+unsigned int     dbus_wr_conti_thresh:4;
+unsigned int     dbus_rd_conti_thresh:4;
+unsigned int     reserved_0:1;
+unsigned int     dbus_rw_reorder_en:1;
+unsigned int     wcmd_bufable_sel:2;
+unsigned int     wr_outstand_num:4;
+unsigned int     reserved_1:3;
+unsigned int     rd_outstand_num:5;
+}WRAP_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     scpu_dbg_sel_top:4;
+unsigned int     reserved_1:5;
+unsigned int     scpu_dbg_mode_sel:3;
+unsigned int     scpu_dbg_sel_cp:4;
+unsigned int     scpu_dbg_sel_dc:4;
+unsigned int     scpu_dbg_sel_sb2:4;
+unsigned int     scpu_dbg_sel:4;
+}A7_DEBUG_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     loop_en_sw:1;
+unsigned int     loop_en_src:1;
+}A7_TEST_LOOP_ENABLE;
+
+typedef struct 
+{
+unsigned int     data_0:32;
+}DUMMY;
+
+typedef struct 
+{
+unsigned int     data_1:32;
+}DUMMY;
+
+typedef struct 
+{
+unsigned int     reserved_0:7;
+unsigned int     EVENTI:1;
+unsigned int     reserved_1:3;
+unsigned int     CLKENTRC:1;
+unsigned int     CLKENAPB:1;
+unsigned int     CLKENATB:1;
+unsigned int     CLKENAPBCS:1;
+unsigned int     CLKENATBCS:1;
+unsigned int     reserved_2:3;
+unsigned int     nSOCDEBUGRESET:1;
+unsigned int     nETMRESET:2;
+unsigned int     nDBGRESET:2;
+unsigned int     reserved_3:2;
+unsigned int     nCORERESET:2;
+unsigned int     reserved_4:1;
+unsigned int     nCOREPORESET:1;
+unsigned int     nL2RESET:1;
+unsigned int     L2RSTDISABLE:1;
+}A7_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     EVENTO:1;
+unsigned int     reserved_1:10;
+unsigned int     STANDBYWFIL2:1;
+unsigned int     STANDBYWFE:2;
+unsigned int     STANDBYWFI:2;
+}A7_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     AXIERRIRQ:1;
+unsigned int     reserved_1:5;
+unsigned int     PMUIRQ:2;
+}A7_STAT;
+
+typedef struct 
+{
+unsigned int     reserved_0:29;
+unsigned int     cfgsdisable_i:1;
+unsigned int     cp15disable_i:2;
+}A7_SEC_CTRL;
+
+typedef struct 
+{
+unsigned int     TRACKCLK_SEL:16;
+unsigned int     reserved_0:13;
+unsigned int     TRACKCLK_DCLK_SEL:1;
+unsigned int     reserved_1:2;
+}A7_TRACKCLK_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     TSCLKCHANGE:1;
+}A7_TSCLK_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     data_in:20;
+unsigned int     reserved_1:2;
+unsigned int     speed_en:1;
+unsigned int     wire_sel:1;
+unsigned int     ro_sel:3;
+unsigned int     dss_rst_n:1;
+}A7_DSS_C35_12D5T_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     count_out:20;
+unsigned int     reserved_1:2;
+unsigned int     wsort_go:1;
+unsigned int     ready:1;
+}A7_DSS_C35_12D5T_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     dbgo:16;
+}A7_DSS_C35_12D5T_DEBUG;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     data_in:20;
+unsigned int     reserved_1:2;
+unsigned int     speed_en:1;
+unsigned int     wire_sel:1;
+unsigned int     ro_sel:3;
+unsigned int     dss_rst_n:1;
+}A7_DSS_C35D5_12D5T_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     count_out:20;
+unsigned int     reserved_1:2;
+unsigned int     wsort_go:1;
+unsigned int     ready:1;
+}A7_DSS_C35D5_12D5T_STATUS;
+
+typedef struct 
+{
+unsigned int     reserved_0:16;
+unsigned int     dbgo:16;
+}A7_DSS_C35D5_12D5T_DEBUG;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     data_sel:2;
+unsigned int     addr:4;
+unsigned int     read_en:1;
+unsigned int     hold:1;
+unsigned int     csm_en:1;
+unsigned int     acc_mode:1;
+unsigned int     in_sel:2;
+unsigned int     reserved_1:1;
+unsigned int     rstn:1;
+}A7_CSM0_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:18;
+unsigned int     data_sel:2;
+unsigned int     addr:4;
+unsigned int     read_en:1;
+unsigned int     hold:1;
+unsigned int     csm_en:1;
+unsigned int     acc_mode:1;
+unsigned int     in_sel:2;
+unsigned int     reserved_1:1;
+unsigned int     rstn:1;
+}A7_CSM1_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     csm1_ready:1;
+unsigned int     csm0_ready:1;
+}A7_CSM_STATUS;
+
+typedef struct 
+{
+unsigned int     data_output:32;
+}A7_CSM0_DO_STATUS;
+
+typedef struct 
+{
+unsigned int     data_output:32;
+}A7_CSM1_DO_STATUS;
+
+typedef struct 
+{
+unsigned int     dbg_start_addr_m1:32;
+}DBG_START;
+
+typedef struct 
+{
+unsigned int     dbg_end_addr_m1:32;
+}DBG_END;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     write_en2:1;
+unsigned int     dbg_wr_chk_m1:2;
+unsigned int     write_en1:1;
+unsigned int     dbg_en_m1:1;
+}DBG_CTRL;
+
+typedef struct 
+{
+unsigned int     reserved_0:27;
+unsigned int     scpu_int_m1:1;
+unsigned int     scpu_int_en_m1:1;
+unsigned int     scpu_neg_int_m1:1;
+unsigned int     scpu_neg_int_en_m1:1;
+unsigned int     write_data:1;
+}DBG_INT;
+
+typedef struct 
+{
+unsigned int     dbg_addr_m1:32;
+}DBG_ADDR;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     scpu_dbg_write_m1:1;
+}DBG_ADDR1;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     scu_mbist_mode:1;
+unsigned int     idata_mbist_mode:1;
+unsigned int     itag_mbist_mode:1;
+unsigned int     ddata_mbist_mode:1;
+unsigned int     dtag_mbist_mode:1;
+unsigned int     ddrity_mbist_mode:1;
+unsigned int     tlb_mbist_mode:1;
+}BIST_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     drf_mbist_mode:1;
+}DRF_BIST_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     drf_test_resume:1;
+}DRF_TEST_RESUME;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     MBISTACK:1;
+unsigned int     scu_mbist_done:1;
+unsigned int     idata_mbist_done:1;
+unsigned int     itag_mbist_done:1;
+unsigned int     ddata_mbist_done:1;
+unsigned int     dtag_mbist_done:1;
+unsigned int     ddirty_mbist_done:1;
+unsigned int     tlb_mbist_done:1;
+}CPU_BIST_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     drf_mbist_done:1;
+}CPU_DRF_BIST_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     drf_start_pause:1;
+}CPU_DRF_START_PAUSE;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     cpu0_scu_mbist_fail_G:1;
+unsigned int     cpu0_idata_mbist_fail_G:1;
+unsigned int     cpu0_itag_mbist_fail_G:1;
+unsigned int     cpu0_ddata_mbist_fail_G:1;
+unsigned int     cpu0_dtag_mbist_fail_G:1;
+unsigned int     cpu0_ddrity_mbist_fail_G:1;
+unsigned int     cpu0_tlb_mbist_fail_G:1;
+}CPU0_BIST_FAIL_GROUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     cpu1_scu_mbist_fail_G:1;
+unsigned int     cpu1_idata_mbist_fail_G:1;
+unsigned int     cpu1_itag_mbist_fail_G:1;
+unsigned int     cpu1_ddata_mbist_fail_G:1;
+unsigned int     cpu1_dtag_mbist_fail_G:1;
+unsigned int     cpu1_ddrity_mbist_fail_G:1;
+unsigned int     cpu1_tlb_mbist_fail_G:1;
+}CPU1_BIST_FAIL_GROUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     cpu0_scu_drf_mbist_fail_G:1;
+unsigned int     cpu0_idata_drf_mbist_fail_G:1;
+unsigned int     cpu0_itag_drf_mbist_fail_G:1;
+unsigned int     cpu0_ddata_drf_mbist_fail_G:1;
+unsigned int     cpu0_dtag_drf_mbist_fail_G:1;
+unsigned int     cpu0_ddrity_drf_mbist_fail_G:1;
+unsigned int     cpu0_tlb_drf_mbist_fail_G:1;
+}CPU0_DRF_BIST_FAIL_GROUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     cpu1_scu_drf_mbist_fail_G:1;
+unsigned int     cpu1_idata_drf_mbist_fail_G:1;
+unsigned int     cpu1_itag_drf_mbist_fail_G:1;
+unsigned int     cpu1_ddata_drf_mbist_fail_G:1;
+unsigned int     cpu1_dtag_drf_mbist_fail_G:1;
+unsigned int     cpu1_ddrity_drf_mbist_fail_G:1;
+unsigned int     cpu1_tlb_drf_mbist_fail_G:1;
+}CPU1_DRF_BIST_FAIL_GROUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu0_idata_mbist_fail:2;
+}CPU0_IDATA_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu1_idata_mbist_fail:2;
+}CPU1_IDATA_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu0_idata_drf_mbist_fail:2;
+}CPU0_IDATA_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu1_idata_drf_mbist_fail:2;
+}CPU1_IDATA_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu0_itag_mbist_fail:2;
+}CPU0_ITAG_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu1_itag_mbist_fail:2;
+}CPU1_ITAG_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu0_itag_drf_mbist_fail:2;
+}CPU0_ITAG_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu1_itag_drf_mbist_fail:2;
+}CPU1_ITAG_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cpu0_ddata_mbist_fail:8;
+}CPU0_DDATA_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cpu1_ddata_mbist_fail:8;
+}CPU1_DDATA_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cpu0_ddata_drf_mbist_fail:8;
+}CPU0_DDATA_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     cpu1_ddata_drf_mbist_fail:8;
+}CPU1_DDATA_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cpu0_dtag_mbist_fail:4;
+}CPU0_DTAG_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cpu1_dtag_mbist_fail:4;
+}CPU1_DTAG_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cpu0_dtag_drf_mbist_fail:4;
+}CPU0_DTAG_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cpu1_dtag_drf_mbist_fail:4;
+}CPU1_DTAG_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     cpu0_ddrity_mbist_fail:1;
+}CPU0_DDRITY_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     cpu1_ddrity_mbist_fail:1;
+}CPU1_DDRITY_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     cpu0_ddrity_drf_mbist_fail:1;
+}CPU0_DDRITY_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     cpu1_ddrity_drf_mbist_fail:1;
+}CPU1_DDRITY_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cpu0_scu_mbist_fail:4;
+}CPU0_SCU_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cpu1_scu_mbist_fail:4;
+}CPU1_SCU_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cpu0_scu_drf_mbist_fail:4;
+}CPU0_SCU_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     cpu1_scu_drf_mbist_fail:4;
+}CPU1_SCU_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu0_tlb_mbist_fail:2;
+}CPU0_TLB_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu1_tlb_mbist_fail:2;
+}CPU1_TLB_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu0_tlb_drf_mbist_fail:2;
+}CPU0_TLB_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     cpu1_tlb_drf_mbist_fail:2;
+}CPU1_TLB_DRF_BIST_FAIL;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     MBIST_RSTN:1;
+unsigned int     L2_TAG_BIST_RSTN:1;
+unsigned int     L2_DATA_PWR_RSTN:1;
+unsigned int     L2_DATA_BISR_RSTN:1;
+}L2_BIST_BISR_RSTN;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     L2_DATA_HOLD_REMAP:1;
+}HOLD_REMAP;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     L2_DATA_SECOND_RUN_EN:1;
+}SECOND_RUN_EN;
+
+typedef struct 
+{
+unsigned int     reserved_0:28;
+unsigned int     L2_TAG_BIST_MODE:1;
+unsigned int     L2_TAG_DRF_BIST_MODE:1;
+unsigned int     reserved_1:1;
+unsigned int     L2_DATA_DRF_BISR_MODE:1;
+}DRF_BIST_BISR_MODE;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     L2_TAG_DRF_TEST_RESUME:1;
+unsigned int     L2_DATA_DRF_BISR_TEST_RESUME:1;
+}DRF_BISR_TEST_RESUME;
+
+typedef struct 
+{
+unsigned int     reserved_0:31;
+unsigned int     L2_DATA_BISR_REPAIRED:1;
+}BISR_REPAIR;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     L2_TAG_BIST_DONE:1;
+unsigned int     L2_DATA_BISR_DONE:1;
+}BISR_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     L2_TAG_DRF_BIST_DONE:1;
+unsigned int     L2_DATA_DRF_BISR_DONE:1;
+}DRF_BISR_DONE;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     L2_TAG_DRF_START_PAUSE:1;
+unsigned int     L2_DATA_DRF_BISR_START_PAUSE:1;
+}DRF_START_PAUSE;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     L2_TAG_BIST_FAIL_G:1;
+unsigned int     L2_DATA_BISR_FAIL_G:1;
+}BISR_FAIL_GROUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     L2_DATA_BISR_FAIL:8;
+}BISR_FAIL_DATA_SEP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     L2_TAG_BIST_FAIL:8;
+}BISR_FAIL_TAG_SEP;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     L2_TAG_DRF_BIST_FAIL_G:1;
+unsigned int     L2_DATA_DRF_BISR_FAIL_G:1;
+}DRF_BISR_FAIL_GROUP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     L2_DATA_DRF_BISR_FAIL:8;
+}DRF_BISR_FAIL_DATA_SEP;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     L2_TAG_DRF_BIST_FAIL:8;
+}DRF_BISR_FAIL_TAG_SEP;
+
+typedef struct 
+{
+unsigned int     L2_DATA_BISR_OUT_31_0:32;
+}L2_DATA_BISR_OUT_1;
+
+typedef struct 
+{
+unsigned int     reserved_0:8;
+unsigned int     L2_DATA_BISR_OUT_55_32:24;
+}L2_DATA_BISR_OUT_2;
+
+typedef struct 
+{
+unsigned int     reserved_0:25;
+unsigned int     scu_ram_RME:1;
+unsigned int     idata_ram_RME:1;
+unsigned int     itag_ram_RME:1;
+unsigned int     ddata_ram_RME:1;
+unsigned int     dtag_ram_RME:1;
+unsigned int     ddrity_ram_RME:1;
+unsigned int     tlb_ram_RME:1;
+}SRAM_RME;
+
+typedef struct 
+{
+unsigned int     reserved_0:4;
+unsigned int     scu_ram_RM:4;
+unsigned int     idata_ram_RM:4;
+unsigned int     itag_ram_RM:4;
+unsigned int     ddata_ram_RM:4;
+unsigned int     dtag_ram_RM:4;
+unsigned int     ddrity_ram_RM:4;
+unsigned int     tlb_ram_RM:4;
+}SRAM_RM;
+
+typedef struct 
+{
+unsigned int     reserved_0:30;
+unsigned int     RME_L2_TAG:1;
+unsigned int     RME_L2_DATA:1;
+}L2_SRAM_RME;
+
+typedef struct 
+{
+unsigned int     reserved_0:24;
+unsigned int     RM_L2_TAG:4;
+unsigned int     RM_L2_DATA:4;
+}L2_SRAM_RM;
+
+#endif
+
+#define WRAP_CTRL                                                                    0x1801D000
+#define WRAP_CTRL_reg_addr                                                           "0xB801D000"
+#define WRAP_CTRL_reg                                                                0xB801D000
+#define set_WRAP_CTRL_reg(data)   (*((volatile unsigned int*) WRAP_CTRL_reg)=data)
+#define get_WRAP_CTRL_reg   (*((volatile unsigned int*) WRAP_CTRL_reg))
+#define WRAP_CTRL_inst_adr                                                           "0x0000"
+#define WRAP_CTRL_inst                                                               0x0000
+#define WRAP_CTRL_dc_remote_wdata_num_shift                                          (28)
+#define WRAP_CTRL_dc_remote_wdata_num_mask                                           (0xF0000000)
+#define WRAP_CTRL_dc_remote_wdata_num(data)                                          (0xF0000000&((data)<<28))
+#define WRAP_CTRL_dc_remote_wdata_num_src(data)                                      ((0xF0000000&(data))>>28)
+#define WRAP_CTRL_get_dc_remote_wdata_num(data)                                      ((0xF0000000&(data))>>28)
+#define WRAP_CTRL_dc_remote_cmd_num_shift                                            (24)
+#define WRAP_CTRL_dc_remote_cmd_num_mask                                             (0x0F000000)
+#define WRAP_CTRL_dc_remote_cmd_num(data)                                            (0x0F000000&((data)<<24))
+#define WRAP_CTRL_dc_remote_cmd_num_src(data)                                        ((0x0F000000&(data))>>24)
+#define WRAP_CTRL_get_dc_remote_cmd_num(data)                                        ((0x0F000000&(data))>>24)
+#define WRAP_CTRL_dbus_wr_conti_thresh_shift                                         (20)
+#define WRAP_CTRL_dbus_wr_conti_thresh_mask                                          (0x00F00000)
+#define WRAP_CTRL_dbus_wr_conti_thresh(data)                                         (0x00F00000&((data)<<20))
+#define WRAP_CTRL_dbus_wr_conti_thresh_src(data)                                     ((0x00F00000&(data))>>20)
+#define WRAP_CTRL_get_dbus_wr_conti_thresh(data)                                     ((0x00F00000&(data))>>20)
+#define WRAP_CTRL_dbus_rd_conti_thresh_shift                                         (16)
+#define WRAP_CTRL_dbus_rd_conti_thresh_mask                                          (0x000F0000)
+#define WRAP_CTRL_dbus_rd_conti_thresh(data)                                         (0x000F0000&((data)<<16))
+#define WRAP_CTRL_dbus_rd_conti_thresh_src(data)                                     ((0x000F0000&(data))>>16)
+#define WRAP_CTRL_get_dbus_rd_conti_thresh(data)                                     ((0x000F0000&(data))>>16)
+#define WRAP_CTRL_dbus_rw_reorder_en_shift                                           (14)
+#define WRAP_CTRL_dbus_rw_reorder_en_mask                                            (0x00004000)
+#define WRAP_CTRL_dbus_rw_reorder_en(data)                                           (0x00004000&((data)<<14))
+#define WRAP_CTRL_dbus_rw_reorder_en_src(data)                                       ((0x00004000&(data))>>14)
+#define WRAP_CTRL_get_dbus_rw_reorder_en(data)                                       ((0x00004000&(data))>>14)
+#define WRAP_CTRL_wcmd_bufable_sel_shift                                             (12)
+#define WRAP_CTRL_wcmd_bufable_sel_mask                                              (0x00003000)
+#define WRAP_CTRL_wcmd_bufable_sel(data)                                             (0x00003000&((data)<<12))
+#define WRAP_CTRL_wcmd_bufable_sel_src(data)                                         ((0x00003000&(data))>>12)
+#define WRAP_CTRL_get_wcmd_bufable_sel(data)                                         ((0x00003000&(data))>>12)
+#define WRAP_CTRL_wr_outstand_num_shift                                              (8)
+#define WRAP_CTRL_wr_outstand_num_mask                                               (0x00000F00)
+#define WRAP_CTRL_wr_outstand_num(data)                                              (0x00000F00&((data)<<8))
+#define WRAP_CTRL_wr_outstand_num_src(data)                                          ((0x00000F00&(data))>>8)
+#define WRAP_CTRL_get_wr_outstand_num(data)                                          ((0x00000F00&(data))>>8)
+#define WRAP_CTRL_rd_outstand_num_shift                                              (0)
+#define WRAP_CTRL_rd_outstand_num_mask                                               (0x0000001F)
+#define WRAP_CTRL_rd_outstand_num(data)                                              (0x0000001F&((data)<<0))
+#define WRAP_CTRL_rd_outstand_num_src(data)                                          ((0x0000001F&(data))>>0)
+#define WRAP_CTRL_get_rd_outstand_num(data)                                          ((0x0000001F&(data))>>0)
+
+
+#define A7_DEBUG_CTRL                                                                0x1801D004
+#define A7_DEBUG_CTRL_reg_addr                                                       "0xB801D004"
+#define A7_DEBUG_CTRL_reg                                                            0xB801D004
+#define set_A7_DEBUG_CTRL_reg(data)   (*((volatile unsigned int*) A7_DEBUG_CTRL_reg)=data)
+#define get_A7_DEBUG_CTRL_reg   (*((volatile unsigned int*) A7_DEBUG_CTRL_reg))
+#define A7_DEBUG_CTRL_inst_adr                                                       "0x0001"
+#define A7_DEBUG_CTRL_inst                                                           0x0001
+#define A7_DEBUG_CTRL_scpu_dbg_sel_top_shift                                         (24)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_top_mask                                          (0x0F000000)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_top(data)                                         (0x0F000000&((data)<<24))
+#define A7_DEBUG_CTRL_scpu_dbg_sel_top_src(data)                                     ((0x0F000000&(data))>>24)
+#define A7_DEBUG_CTRL_get_scpu_dbg_sel_top(data)                                     ((0x0F000000&(data))>>24)
+#define A7_DEBUG_CTRL_scpu_dbg_mode_sel_shift                                        (16)
+#define A7_DEBUG_CTRL_scpu_dbg_mode_sel_mask                                         (0x00070000)
+#define A7_DEBUG_CTRL_scpu_dbg_mode_sel(data)                                        (0x00070000&((data)<<16))
+#define A7_DEBUG_CTRL_scpu_dbg_mode_sel_src(data)                                    ((0x00070000&(data))>>16)
+#define A7_DEBUG_CTRL_get_scpu_dbg_mode_sel(data)                                    ((0x00070000&(data))>>16)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_cp_shift                                          (12)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_cp_mask                                           (0x0000F000)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_cp(data)                                          (0x0000F000&((data)<<12))
+#define A7_DEBUG_CTRL_scpu_dbg_sel_cp_src(data)                                      ((0x0000F000&(data))>>12)
+#define A7_DEBUG_CTRL_get_scpu_dbg_sel_cp(data)                                      ((0x0000F000&(data))>>12)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_dc_shift                                          (8)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_dc_mask                                           (0x00000F00)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_dc(data)                                          (0x00000F00&((data)<<8))
+#define A7_DEBUG_CTRL_scpu_dbg_sel_dc_src(data)                                      ((0x00000F00&(data))>>8)
+#define A7_DEBUG_CTRL_get_scpu_dbg_sel_dc(data)                                      ((0x00000F00&(data))>>8)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_sb2_shift                                         (4)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_sb2_mask                                          (0x000000F0)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_sb2(data)                                         (0x000000F0&((data)<<4))
+#define A7_DEBUG_CTRL_scpu_dbg_sel_sb2_src(data)                                     ((0x000000F0&(data))>>4)
+#define A7_DEBUG_CTRL_get_scpu_dbg_sel_sb2(data)                                     ((0x000000F0&(data))>>4)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_shift                                             (0)
+#define A7_DEBUG_CTRL_scpu_dbg_sel_mask                                              (0x0000000F)
+#define A7_DEBUG_CTRL_scpu_dbg_sel(data)                                             (0x0000000F&((data)<<0))
+#define A7_DEBUG_CTRL_scpu_dbg_sel_src(data)                                         ((0x0000000F&(data))>>0)
+#define A7_DEBUG_CTRL_get_scpu_dbg_sel(data)                                         ((0x0000000F&(data))>>0)
+
+
+#define A7_TEST_LOOP_ENABLE                                                          0x1801D008
+#define A7_TEST_LOOP_ENABLE_reg_addr                                                 "0xB801D008"
+#define A7_TEST_LOOP_ENABLE_reg                                                      0xB801D008
+#define set_A7_TEST_LOOP_ENABLE_reg(data)   (*((volatile unsigned int*) A7_TEST_LOOP_ENABLE_reg)=data)
+#define get_A7_TEST_LOOP_ENABLE_reg   (*((volatile unsigned int*) A7_TEST_LOOP_ENABLE_reg))
+#define A7_TEST_LOOP_ENABLE_inst_adr                                                 "0x0002"
+#define A7_TEST_LOOP_ENABLE_inst                                                     0x0002
+#define A7_TEST_LOOP_ENABLE_loop_en_sw_shift                                         (1)
+#define A7_TEST_LOOP_ENABLE_loop_en_sw_mask                                          (0x00000002)
+#define A7_TEST_LOOP_ENABLE_loop_en_sw(data)                                         (0x00000002&((data)<<1))
+#define A7_TEST_LOOP_ENABLE_loop_en_sw_src(data)                                     ((0x00000002&(data))>>1)
+#define A7_TEST_LOOP_ENABLE_get_loop_en_sw(data)                                     ((0x00000002&(data))>>1)
+#define A7_TEST_LOOP_ENABLE_loop_en_src_shift                                        (0)
+#define A7_TEST_LOOP_ENABLE_loop_en_src_mask                                         (0x00000001)
+#define A7_TEST_LOOP_ENABLE_loop_en_src(data)                                        (0x00000001&((data)<<0))
+#define A7_TEST_LOOP_ENABLE_loop_en_src_src(data)                                    ((0x00000001&(data))>>0)
+#define A7_TEST_LOOP_ENABLE_get_loop_en_src(data)                                    ((0x00000001&(data))>>0)
+
+
+#define DUMMY_0                                                                      0x1801D010
+#define DUMMY_1                                                                      0x1801D014
+#define DUMMY_0_reg_addr                                                             "0xB801D010"
+#define DUMMY_1_reg_addr                                                             "0xB801D014"
+#define DUMMY_0_reg                                                                  0xB801D010
+#define DUMMY_1_reg                                                                  0xB801D014
+#define set_DUMMY_0_reg(data)   (*((volatile unsigned int*) DUMMY_0_reg)=data)
+#define set_DUMMY_1_reg(data)   (*((volatile unsigned int*) DUMMY_1_reg)=data)
+#define get_DUMMY_0_reg   (*((volatile unsigned int*) DUMMY_0_reg))
+#define get_DUMMY_1_reg   (*((volatile unsigned int*) DUMMY_1_reg))
+#define DUMMY_0_inst_adr                                                             "0x0004"
+#define DUMMY_1_inst_adr                                                             "0x0005"
+#define DUMMY_0_inst                                                                 0x0004
+#define DUMMY_1_inst                                                                 0x0005
+#define DUMMY_data_0_shift                                                           (0)
+#define DUMMY_data_0_mask                                                            (0xFFFFFFFF)
+#define DUMMY_data_0(data)                                                           (0xFFFFFFFF&((data)<<0))
+#define DUMMY_data_0_src(data)                                                       ((0xFFFFFFFF&(data))>>0)
+#define DUMMY_get_data_0(data)                                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define DUMMY_0                                                                      0x1801D018
+#define DUMMY_1                                                                      0x1801D01C
+#define DUMMY_0_reg_addr                                                             "0xB801D018"
+#define DUMMY_1_reg_addr                                                             "0xB801D01C"
+#define DUMMY_0_reg                                                                  0xB801D018
+#define DUMMY_1_reg                                                                  0xB801D01C
+#define set_DUMMY_0_reg(data)   (*((volatile unsigned int*) DUMMY_0_reg)=data)
+#define set_DUMMY_1_reg(data)   (*((volatile unsigned int*) DUMMY_1_reg)=data)
+#define get_DUMMY_0_reg   (*((volatile unsigned int*) DUMMY_0_reg))
+#define get_DUMMY_1_reg   (*((volatile unsigned int*) DUMMY_1_reg))
+#define DUMMY_0_inst_adr                                                             "0x0006"
+#define DUMMY_1_inst_adr                                                             "0x0007"
+#define DUMMY_0_inst                                                                 0x0006
+#define DUMMY_1_inst                                                                 0x0007
+#define DUMMY_data_1_shift                                                           (0)
+#define DUMMY_data_1_mask                                                            (0xFFFFFFFF)
+#define DUMMY_data_1(data)                                                           (0xFFFFFFFF&((data)<<0))
+#define DUMMY_data_1_src(data)                                                       ((0xFFFFFFFF&(data))>>0)
+#define DUMMY_get_data_1(data)                                                       ((0xFFFFFFFF&(data))>>0)
+
+
+#define A7_CTRL                                                                      0x1801D100
+#define A7_CTRL_reg_addr                                                             "0xB801D100"
+#define A7_CTRL_reg                                                                  0xB801D100
+#define set_A7_CTRL_reg(data)   (*((volatile unsigned int*) A7_CTRL_reg)=data)
+#define get_A7_CTRL_reg   (*((volatile unsigned int*) A7_CTRL_reg))
+#define A7_CTRL_inst_adr                                                             "0x0040"
+#define A7_CTRL_inst                                                                 0x0040
+#define A7_CTRL_EVENTI_shift                                                         (24)
+#define A7_CTRL_EVENTI_mask                                                          (0x01000000)
+#define A7_CTRL_EVENTI(data)                                                         (0x01000000&((data)<<24))
+#define A7_CTRL_EVENTI_src(data)                                                     ((0x01000000&(data))>>24)
+#define A7_CTRL_get_EVENTI(data)                                                     ((0x01000000&(data))>>24)
+#define A7_CTRL_CLKENTRC_shift                                                       (20)
+#define A7_CTRL_CLKENTRC_mask                                                        (0x00100000)
+#define A7_CTRL_CLKENTRC(data)                                                       (0x00100000&((data)<<20))
+#define A7_CTRL_CLKENTRC_src(data)                                                   ((0x00100000&(data))>>20)
+#define A7_CTRL_get_CLKENTRC(data)                                                   ((0x00100000&(data))>>20)
+#define A7_CTRL_CLKENAPB_shift                                                       (19)
+#define A7_CTRL_CLKENAPB_mask                                                        (0x00080000)
+#define A7_CTRL_CLKENAPB(data)                                                       (0x00080000&((data)<<19))
+#define A7_CTRL_CLKENAPB_src(data)                                                   ((0x00080000&(data))>>19)
+#define A7_CTRL_get_CLKENAPB(data)                                                   ((0x00080000&(data))>>19)
+#define A7_CTRL_CLKENATB_shift                                                       (18)
+#define A7_CTRL_CLKENATB_mask                                                        (0x00040000)
+#define A7_CTRL_CLKENATB(data)                                                       (0x00040000&((data)<<18))
+#define A7_CTRL_CLKENATB_src(data)                                                   ((0x00040000&(data))>>18)
+#define A7_CTRL_get_CLKENATB(data)                                                   ((0x00040000&(data))>>18)
+#define A7_CTRL_CLKENAPBCS_shift                                                     (17)
+#define A7_CTRL_CLKENAPBCS_mask                                                      (0x00020000)
+#define A7_CTRL_CLKENAPBCS(data)                                                     (0x00020000&((data)<<17))
+#define A7_CTRL_CLKENAPBCS_src(data)                                                 ((0x00020000&(data))>>17)
+#define A7_CTRL_get_CLKENAPBCS(data)                                                 ((0x00020000&(data))>>17)
+#define A7_CTRL_CLKENATBCS_shift                                                     (16)
+#define A7_CTRL_CLKENATBCS_mask                                                      (0x00010000)
+#define A7_CTRL_CLKENATBCS(data)                                                     (0x00010000&((data)<<16))
+#define A7_CTRL_CLKENATBCS_src(data)                                                 ((0x00010000&(data))>>16)
+#define A7_CTRL_get_CLKENATBCS(data)                                                 ((0x00010000&(data))>>16)
+#define A7_CTRL_nSOCDEBUGRESET_shift                                                 (12)
+#define A7_CTRL_nSOCDEBUGRESET_mask                                                  (0x00001000)
+#define A7_CTRL_nSOCDEBUGRESET(data)                                                 (0x00001000&((data)<<12))
+#define A7_CTRL_nSOCDEBUGRESET_src(data)                                             ((0x00001000&(data))>>12)
+#define A7_CTRL_get_nSOCDEBUGRESET(data)                                             ((0x00001000&(data))>>12)
+#define A7_CTRL_nETMRESET_shift                                                      (10)
+#define A7_CTRL_nETMRESET_mask                                                       (0x00000C00)
+#define A7_CTRL_nETMRESET(data)                                                      (0x00000C00&((data)<<10))
+#define A7_CTRL_nETMRESET_src(data)                                                  ((0x00000C00&(data))>>10)
+#define A7_CTRL_get_nETMRESET(data)                                                  ((0x00000C00&(data))>>10)
+#define A7_CTRL_nDBGRESET_shift                                                      (8)
+#define A7_CTRL_nDBGRESET_mask                                                       (0x00000300)
+#define A7_CTRL_nDBGRESET(data)                                                      (0x00000300&((data)<<8))
+#define A7_CTRL_nDBGRESET_src(data)                                                  ((0x00000300&(data))>>8)
+#define A7_CTRL_get_nDBGRESET(data)                                                  ((0x00000300&(data))>>8)
+#define A7_CTRL_nCORERESET_shift                                                     (4)
+#define A7_CTRL_nCORERESET_mask                                                      (0x00000030)
+#define A7_CTRL_nCORERESET(data)                                                     (0x00000030&((data)<<4))
+#define A7_CTRL_nCORERESET_src(data)                                                 ((0x00000030&(data))>>4)
+#define A7_CTRL_get_nCORERESET(data)                                                 ((0x00000030&(data))>>4)
+#define A7_CTRL_nCOREPORESET_shift                                                   (2)
+#define A7_CTRL_nCOREPORESET_mask                                                    (0x00000004)
+#define A7_CTRL_nCOREPORESET(data)                                                   (0x00000004&((data)<<2))
+#define A7_CTRL_nCOREPORESET_src(data)                                               ((0x00000004&(data))>>2)
+#define A7_CTRL_get_nCOREPORESET(data)                                               ((0x00000004&(data))>>2)
+#define A7_CTRL_nL2RESET_shift                                                       (1)
+#define A7_CTRL_nL2RESET_mask                                                        (0x00000002)
+#define A7_CTRL_nL2RESET(data)                                                       (0x00000002&((data)<<1))
+#define A7_CTRL_nL2RESET_src(data)                                                   ((0x00000002&(data))>>1)
+#define A7_CTRL_get_nL2RESET(data)                                                   ((0x00000002&(data))>>1)
+#define A7_CTRL_L2RSTDISABLE_shift                                                   (0)
+#define A7_CTRL_L2RSTDISABLE_mask                                                    (0x00000001)
+#define A7_CTRL_L2RSTDISABLE(data)                                                   (0x00000001&((data)<<0))
+#define A7_CTRL_L2RSTDISABLE_src(data)                                               ((0x00000001&(data))>>0)
+#define A7_CTRL_get_L2RSTDISABLE(data)                                               ((0x00000001&(data))>>0)
+
+
+#define A7_STAT                                                                      0x1801D104
+#define A7_STAT_reg_addr                                                             "0xB801D104"
+#define A7_STAT_reg                                                                  0xB801D104
+#define set_A7_STAT_reg(data)   (*((volatile unsigned int*) A7_STAT_reg)=data)
+#define get_A7_STAT_reg   (*((volatile unsigned int*) A7_STAT_reg))
+#define A7_STAT_inst_adr                                                             "0x0041"
+#define A7_STAT_inst                                                                 0x0041
+#define A7_STAT_EVENTO_shift                                                         (15)
+#define A7_STAT_EVENTO_mask                                                          (0x00008000)
+#define A7_STAT_EVENTO(data)                                                         (0x00008000&((data)<<15))
+#define A7_STAT_EVENTO_src(data)                                                     ((0x00008000&(data))>>15)
+#define A7_STAT_get_EVENTO(data)                                                     ((0x00008000&(data))>>15)
+#define A7_STAT_STANDBYWFIL2_shift                                                   (4)
+#define A7_STAT_STANDBYWFIL2_mask                                                    (0x00000010)
+#define A7_STAT_STANDBYWFIL2(data)                                                   (0x00000010&((data)<<4))
+#define A7_STAT_STANDBYWFIL2_src(data)                                               ((0x00000010&(data))>>4)
+#define A7_STAT_get_STANDBYWFIL2(data)                                               ((0x00000010&(data))>>4)
+#define A7_STAT_STANDBYWFE_shift                                                     (2)
+#define A7_STAT_STANDBYWFE_mask                                                      (0x0000000C)
+#define A7_STAT_STANDBYWFE(data)                                                     (0x0000000C&((data)<<2))
+#define A7_STAT_STANDBYWFE_src(data)                                                 ((0x0000000C&(data))>>2)
+#define A7_STAT_get_STANDBYWFE(data)                                                 ((0x0000000C&(data))>>2)
+#define A7_STAT_STANDBYWFI_shift                                                     (0)
+#define A7_STAT_STANDBYWFI_mask                                                      (0x00000003)
+#define A7_STAT_STANDBYWFI(data)                                                     (0x00000003&((data)<<0))
+#define A7_STAT_STANDBYWFI_src(data)                                                 ((0x00000003&(data))>>0)
+#define A7_STAT_get_STANDBYWFI(data)                                                 ((0x00000003&(data))>>0)
+
+
+#define A7_STAT                                                                      0x1801D108
+#define A7_STAT_reg_addr                                                             "0xB801D108"
+#define A7_STAT_reg                                                                  0xB801D108
+#define set_A7_STAT_reg(data)   (*((volatile unsigned int*) A7_STAT_reg)=data)
+#define get_A7_STAT_reg   (*((volatile unsigned int*) A7_STAT_reg))
+#define A7_STAT_inst_adr                                                             "0x0042"
+#define A7_STAT_inst                                                                 0x0042
+#define A7_STAT_AXIERRIRQ_shift                                                      (7)
+#define A7_STAT_AXIERRIRQ_mask                                                       (0x00000080)
+#define A7_STAT_AXIERRIRQ(data)                                                      (0x00000080&((data)<<7))
+#define A7_STAT_AXIERRIRQ_src(data)                                                  ((0x00000080&(data))>>7)
+#define A7_STAT_get_AXIERRIRQ(data)                                                  ((0x00000080&(data))>>7)
+#define A7_STAT_PMUIRQ_shift                                                         (0)
+#define A7_STAT_PMUIRQ_mask                                                          (0x00000003)
+#define A7_STAT_PMUIRQ(data)                                                         (0x00000003&((data)<<0))
+#define A7_STAT_PMUIRQ_src(data)                                                     ((0x00000003&(data))>>0)
+#define A7_STAT_get_PMUIRQ(data)                                                     ((0x00000003&(data))>>0)
+
+
+#define A7_SEC_CTRL                                                                  0x1801D10C
+#define A7_SEC_CTRL_reg_addr                                                         "0xB801D10C"
+#define A7_SEC_CTRL_reg                                                              0xB801D10C
+#define set_A7_SEC_CTRL_reg(data)   (*((volatile unsigned int*) A7_SEC_CTRL_reg)=data)
+#define get_A7_SEC_CTRL_reg   (*((volatile unsigned int*) A7_SEC_CTRL_reg))
+#define A7_SEC_CTRL_inst_adr                                                         "0x0043"
+#define A7_SEC_CTRL_inst                                                             0x0043
+#define A7_SEC_CTRL_cfgsdisable_i_shift                                              (2)
+#define A7_SEC_CTRL_cfgsdisable_i_mask                                               (0x00000004)
+#define A7_SEC_CTRL_cfgsdisable_i(data)                                              (0x00000004&((data)<<2))
+#define A7_SEC_CTRL_cfgsdisable_i_src(data)                                          ((0x00000004&(data))>>2)
+#define A7_SEC_CTRL_get_cfgsdisable_i(data)                                          ((0x00000004&(data))>>2)
+#define A7_SEC_CTRL_cp15disable_i_shift                                              (0)
+#define A7_SEC_CTRL_cp15disable_i_mask                                               (0x00000003)
+#define A7_SEC_CTRL_cp15disable_i(data)                                              (0x00000003&((data)<<0))
+#define A7_SEC_CTRL_cp15disable_i_src(data)                                          ((0x00000003&(data))>>0)
+#define A7_SEC_CTRL_get_cp15disable_i(data)                                          ((0x00000003&(data))>>0)
+
+
+#define A7_TRACKCLK_CTRL                                                             0x1801D110
+#define A7_TRACKCLK_CTRL_reg_addr                                                    "0xB801D110"
+#define A7_TRACKCLK_CTRL_reg                                                         0xB801D110
+#define set_A7_TRACKCLK_CTRL_reg(data)   (*((volatile unsigned int*) A7_TRACKCLK_CTRL_reg)=data)
+#define get_A7_TRACKCLK_CTRL_reg   (*((volatile unsigned int*) A7_TRACKCLK_CTRL_reg))
+#define A7_TRACKCLK_CTRL_inst_adr                                                    "0x0044"
+#define A7_TRACKCLK_CTRL_inst                                                        0x0044
+#define A7_TRACKCLK_CTRL_TRACKCLK_SEL_shift                                          (16)
+#define A7_TRACKCLK_CTRL_TRACKCLK_SEL_mask                                           (0xFFFF0000)
+#define A7_TRACKCLK_CTRL_TRACKCLK_SEL(data)                                          (0xFFFF0000&((data)<<16))
+#define A7_TRACKCLK_CTRL_TRACKCLK_SEL_src(data)                                      ((0xFFFF0000&(data))>>16)
+#define A7_TRACKCLK_CTRL_get_TRACKCLK_SEL(data)                                      ((0xFFFF0000&(data))>>16)
+#define A7_TRACKCLK_CTRL_TRACKCLK_DCLK_SEL_shift                                     (2)
+#define A7_TRACKCLK_CTRL_TRACKCLK_DCLK_SEL_mask                                      (0x00000004)
+#define A7_TRACKCLK_CTRL_TRACKCLK_DCLK_SEL(data)                                     (0x00000004&((data)<<2))
+#define A7_TRACKCLK_CTRL_TRACKCLK_DCLK_SEL_src(data)                                 ((0x00000004&(data))>>2)
+#define A7_TRACKCLK_CTRL_get_TRACKCLK_DCLK_SEL(data)                                 ((0x00000004&(data))>>2)
+
+
+#define A7_TSCLK_CTRL                                                                0x1801D114
+#define A7_TSCLK_CTRL_reg_addr                                                       "0xB801D114"
+#define A7_TSCLK_CTRL_reg                                                            0xB801D114
+#define set_A7_TSCLK_CTRL_reg(data)   (*((volatile unsigned int*) A7_TSCLK_CTRL_reg)=data)
+#define get_A7_TSCLK_CTRL_reg   (*((volatile unsigned int*) A7_TSCLK_CTRL_reg))
+#define A7_TSCLK_CTRL_inst_adr                                                       "0x0045"
+#define A7_TSCLK_CTRL_inst                                                           0x0045
+#define A7_TSCLK_CTRL_TSCLKCHANGE_shift                                              (0)
+#define A7_TSCLK_CTRL_TSCLKCHANGE_mask                                               (0x00000001)
+#define A7_TSCLK_CTRL_TSCLKCHANGE(data)                                              (0x00000001&((data)<<0))
+#define A7_TSCLK_CTRL_TSCLKCHANGE_src(data)                                          ((0x00000001&(data))>>0)
+#define A7_TSCLK_CTRL_get_TSCLKCHANGE(data)                                          ((0x00000001&(data))>>0)
+
+
+#define A7_DSS_C35_12D5T_CTRL                                                        0x1801D120
+#define A7_DSS_C35_12D5T_CTRL_reg_addr                                               "0xB801D120"
+#define A7_DSS_C35_12D5T_CTRL_reg                                                    0xB801D120
+#define set_A7_DSS_C35_12D5T_CTRL_reg(data)   (*((volatile unsigned int*) A7_DSS_C35_12D5T_CTRL_reg)=data)
+#define get_A7_DSS_C35_12D5T_CTRL_reg   (*((volatile unsigned int*) A7_DSS_C35_12D5T_CTRL_reg))
+#define A7_DSS_C35_12D5T_CTRL_inst_adr                                               "0x0048"
+#define A7_DSS_C35_12D5T_CTRL_inst                                                   0x0048
+#define A7_DSS_C35_12D5T_CTRL_data_in_shift                                          (8)
+#define A7_DSS_C35_12D5T_CTRL_data_in_mask                                           (0x0FFFFF00)
+#define A7_DSS_C35_12D5T_CTRL_data_in(data)                                          (0x0FFFFF00&((data)<<8))
+#define A7_DSS_C35_12D5T_CTRL_data_in_src(data)                                      ((0x0FFFFF00&(data))>>8)
+#define A7_DSS_C35_12D5T_CTRL_get_data_in(data)                                      ((0x0FFFFF00&(data))>>8)
+#define A7_DSS_C35_12D5T_CTRL_speed_en_shift                                         (5)
+#define A7_DSS_C35_12D5T_CTRL_speed_en_mask                                          (0x00000020)
+#define A7_DSS_C35_12D5T_CTRL_speed_en(data)                                         (0x00000020&((data)<<5))
+#define A7_DSS_C35_12D5T_CTRL_speed_en_src(data)                                     ((0x00000020&(data))>>5)
+#define A7_DSS_C35_12D5T_CTRL_get_speed_en(data)                                     ((0x00000020&(data))>>5)
+#define A7_DSS_C35_12D5T_CTRL_wire_sel_shift                                         (4)
+#define A7_DSS_C35_12D5T_CTRL_wire_sel_mask                                          (0x00000010)
+#define A7_DSS_C35_12D5T_CTRL_wire_sel(data)                                         (0x00000010&((data)<<4))
+#define A7_DSS_C35_12D5T_CTRL_wire_sel_src(data)                                     ((0x00000010&(data))>>4)
+#define A7_DSS_C35_12D5T_CTRL_get_wire_sel(data)                                     ((0x00000010&(data))>>4)
+#define A7_DSS_C35_12D5T_CTRL_ro_sel_shift                                           (1)
+#define A7_DSS_C35_12D5T_CTRL_ro_sel_mask                                            (0x0000000E)
+#define A7_DSS_C35_12D5T_CTRL_ro_sel(data)                                           (0x0000000E&((data)<<1))
+#define A7_DSS_C35_12D5T_CTRL_ro_sel_src(data)                                       ((0x0000000E&(data))>>1)
+#define A7_DSS_C35_12D5T_CTRL_get_ro_sel(data)                                       ((0x0000000E&(data))>>1)
+#define A7_DSS_C35_12D5T_CTRL_dss_rst_n_shift                                        (0)
+#define A7_DSS_C35_12D5T_CTRL_dss_rst_n_mask                                         (0x00000001)
+#define A7_DSS_C35_12D5T_CTRL_dss_rst_n(data)                                        (0x00000001&((data)<<0))
+#define A7_DSS_C35_12D5T_CTRL_dss_rst_n_src(data)                                    ((0x00000001&(data))>>0)
+#define A7_DSS_C35_12D5T_CTRL_get_dss_rst_n(data)                                    ((0x00000001&(data))>>0)
+
+
+#define A7_DSS_C35_12D5T_STATUS                                                      0x1801D124
+#define A7_DSS_C35_12D5T_STATUS_reg_addr                                             "0xB801D124"
+#define A7_DSS_C35_12D5T_STATUS_reg                                                  0xB801D124
+#define set_A7_DSS_C35_12D5T_STATUS_reg(data)   (*((volatile unsigned int*) A7_DSS_C35_12D5T_STATUS_reg)=data)
+#define get_A7_DSS_C35_12D5T_STATUS_reg   (*((volatile unsigned int*) A7_DSS_C35_12D5T_STATUS_reg))
+#define A7_DSS_C35_12D5T_STATUS_inst_adr                                             "0x0049"
+#define A7_DSS_C35_12D5T_STATUS_inst                                                 0x0049
+#define A7_DSS_C35_12D5T_STATUS_count_out_shift                                      (4)
+#define A7_DSS_C35_12D5T_STATUS_count_out_mask                                       (0x00FFFFF0)
+#define A7_DSS_C35_12D5T_STATUS_count_out(data)                                      (0x00FFFFF0&((data)<<4))
+#define A7_DSS_C35_12D5T_STATUS_count_out_src(data)                                  ((0x00FFFFF0&(data))>>4)
+#define A7_DSS_C35_12D5T_STATUS_get_count_out(data)                                  ((0x00FFFFF0&(data))>>4)
+#define A7_DSS_C35_12D5T_STATUS_wsort_go_shift                                       (1)
+#define A7_DSS_C35_12D5T_STATUS_wsort_go_mask                                        (0x00000002)
+#define A7_DSS_C35_12D5T_STATUS_wsort_go(data)                                       (0x00000002&((data)<<1))
+#define A7_DSS_C35_12D5T_STATUS_wsort_go_src(data)                                   ((0x00000002&(data))>>1)
+#define A7_DSS_C35_12D5T_STATUS_get_wsort_go(data)                                   ((0x00000002&(data))>>1)
+#define A7_DSS_C35_12D5T_STATUS_ready_shift                                          (0)
+#define A7_DSS_C35_12D5T_STATUS_ready_mask                                           (0x00000001)
+#define A7_DSS_C35_12D5T_STATUS_ready(data)                                          (0x00000001&((data)<<0))
+#define A7_DSS_C35_12D5T_STATUS_ready_src(data)                                      ((0x00000001&(data))>>0)
+#define A7_DSS_C35_12D5T_STATUS_get_ready(data)                                      ((0x00000001&(data))>>0)
+
+
+#define A7_DSS_C35_12D5T_DEBUG                                                       0x1801D128
+#define A7_DSS_C35_12D5T_DEBUG_reg_addr                                              "0xB801D128"
+#define A7_DSS_C35_12D5T_DEBUG_reg                                                   0xB801D128
+#define set_A7_DSS_C35_12D5T_DEBUG_reg(data)   (*((volatile unsigned int*) A7_DSS_C35_12D5T_DEBUG_reg)=data)
+#define get_A7_DSS_C35_12D5T_DEBUG_reg   (*((volatile unsigned int*) A7_DSS_C35_12D5T_DEBUG_reg))
+#define A7_DSS_C35_12D5T_DEBUG_inst_adr                                              "0x004A"
+#define A7_DSS_C35_12D5T_DEBUG_inst                                                  0x004A
+#define A7_DSS_C35_12D5T_DEBUG_dbgo_shift                                            (0)
+#define A7_DSS_C35_12D5T_DEBUG_dbgo_mask                                             (0x0000FFFF)
+#define A7_DSS_C35_12D5T_DEBUG_dbgo(data)                                            (0x0000FFFF&((data)<<0))
+#define A7_DSS_C35_12D5T_DEBUG_dbgo_src(data)                                        ((0x0000FFFF&(data))>>0)
+#define A7_DSS_C35_12D5T_DEBUG_get_dbgo(data)                                        ((0x0000FFFF&(data))>>0)
+
+
+#define A7_DSS_C35D5_12D5T_CTRL                                                      0x1801D130
+#define A7_DSS_C35D5_12D5T_CTRL_reg_addr                                             "0xB801D130"
+#define A7_DSS_C35D5_12D5T_CTRL_reg                                                  0xB801D130
+#define set_A7_DSS_C35D5_12D5T_CTRL_reg(data)   (*((volatile unsigned int*) A7_DSS_C35D5_12D5T_CTRL_reg)=data)
+#define get_A7_DSS_C35D5_12D5T_CTRL_reg   (*((volatile unsigned int*) A7_DSS_C35D5_12D5T_CTRL_reg))
+#define A7_DSS_C35D5_12D5T_CTRL_inst_adr                                             "0x004C"
+#define A7_DSS_C35D5_12D5T_CTRL_inst                                                 0x004C
+#define A7_DSS_C35D5_12D5T_CTRL_data_in_shift                                        (8)
+#define A7_DSS_C35D5_12D5T_CTRL_data_in_mask                                         (0x0FFFFF00)
+#define A7_DSS_C35D5_12D5T_CTRL_data_in(data)                                        (0x0FFFFF00&((data)<<8))
+#define A7_DSS_C35D5_12D5T_CTRL_data_in_src(data)                                    ((0x0FFFFF00&(data))>>8)
+#define A7_DSS_C35D5_12D5T_CTRL_get_data_in(data)                                    ((0x0FFFFF00&(data))>>8)
+#define A7_DSS_C35D5_12D5T_CTRL_speed_en_shift                                       (5)
+#define A7_DSS_C35D5_12D5T_CTRL_speed_en_mask                                        (0x00000020)
+#define A7_DSS_C35D5_12D5T_CTRL_speed_en(data)                                       (0x00000020&((data)<<5))
+#define A7_DSS_C35D5_12D5T_CTRL_speed_en_src(data)                                   ((0x00000020&(data))>>5)
+#define A7_DSS_C35D5_12D5T_CTRL_get_speed_en(data)                                   ((0x00000020&(data))>>5)
+#define A7_DSS_C35D5_12D5T_CTRL_wire_sel_shift                                       (4)
+#define A7_DSS_C35D5_12D5T_CTRL_wire_sel_mask                                        (0x00000010)
+#define A7_DSS_C35D5_12D5T_CTRL_wire_sel(data)                                       (0x00000010&((data)<<4))
+#define A7_DSS_C35D5_12D5T_CTRL_wire_sel_src(data)                                   ((0x00000010&(data))>>4)
+#define A7_DSS_C35D5_12D5T_CTRL_get_wire_sel(data)                                   ((0x00000010&(data))>>4)
+#define A7_DSS_C35D5_12D5T_CTRL_ro_sel_shift                                         (1)
+#define A7_DSS_C35D5_12D5T_CTRL_ro_sel_mask                                          (0x0000000E)
+#define A7_DSS_C35D5_12D5T_CTRL_ro_sel(data)                                         (0x0000000E&((data)<<1))
+#define A7_DSS_C35D5_12D5T_CTRL_ro_sel_src(data)                                     ((0x0000000E&(data))>>1)
+#define A7_DSS_C35D5_12D5T_CTRL_get_ro_sel(data)                                     ((0x0000000E&(data))>>1)
+#define A7_DSS_C35D5_12D5T_CTRL_dss_rst_n_shift                                      (0)
+#define A7_DSS_C35D5_12D5T_CTRL_dss_rst_n_mask                                       (0x00000001)
+#define A7_DSS_C35D5_12D5T_CTRL_dss_rst_n(data)                                      (0x00000001&((data)<<0))
+#define A7_DSS_C35D5_12D5T_CTRL_dss_rst_n_src(data)                                  ((0x00000001&(data))>>0)
+#define A7_DSS_C35D5_12D5T_CTRL_get_dss_rst_n(data)                                  ((0x00000001&(data))>>0)
+
+
+#define A7_DSS_C35D5_12D5T_STATUS                                                    0x1801D134
+#define A7_DSS_C35D5_12D5T_STATUS_reg_addr                                           "0xB801D134"
+#define A7_DSS_C35D5_12D5T_STATUS_reg                                                0xB801D134
+#define set_A7_DSS_C35D5_12D5T_STATUS_reg(data)   (*((volatile unsigned int*) A7_DSS_C35D5_12D5T_STATUS_reg)=data)
+#define get_A7_DSS_C35D5_12D5T_STATUS_reg   (*((volatile unsigned int*) A7_DSS_C35D5_12D5T_STATUS_reg))
+#define A7_DSS_C35D5_12D5T_STATUS_inst_adr                                           "0x004D"
+#define A7_DSS_C35D5_12D5T_STATUS_inst                                               0x004D
+#define A7_DSS_C35D5_12D5T_STATUS_count_out_shift                                    (4)
+#define A7_DSS_C35D5_12D5T_STATUS_count_out_mask                                     (0x00FFFFF0)
+#define A7_DSS_C35D5_12D5T_STATUS_count_out(data)                                    (0x00FFFFF0&((data)<<4))
+#define A7_DSS_C35D5_12D5T_STATUS_count_out_src(data)                                ((0x00FFFFF0&(data))>>4)
+#define A7_DSS_C35D5_12D5T_STATUS_get_count_out(data)                                ((0x00FFFFF0&(data))>>4)
+#define A7_DSS_C35D5_12D5T_STATUS_wsort_go_shift                                     (1)
+#define A7_DSS_C35D5_12D5T_STATUS_wsort_go_mask                                      (0x00000002)
+#define A7_DSS_C35D5_12D5T_STATUS_wsort_go(data)                                     (0x00000002&((data)<<1))
+#define A7_DSS_C35D5_12D5T_STATUS_wsort_go_src(data)                                 ((0x00000002&(data))>>1)
+#define A7_DSS_C35D5_12D5T_STATUS_get_wsort_go(data)                                 ((0x00000002&(data))>>1)
+#define A7_DSS_C35D5_12D5T_STATUS_ready_shift                                        (0)
+#define A7_DSS_C35D5_12D5T_STATUS_ready_mask                                         (0x00000001)
+#define A7_DSS_C35D5_12D5T_STATUS_ready(data)                                        (0x00000001&((data)<<0))
+#define A7_DSS_C35D5_12D5T_STATUS_ready_src(data)                                    ((0x00000001&(data))>>0)
+#define A7_DSS_C35D5_12D5T_STATUS_get_ready(data)                                    ((0x00000001&(data))>>0)
+
+
+#define A7_DSS_C35D5_12D5T_DEBUG                                                     0x1801D138
+#define A7_DSS_C35D5_12D5T_DEBUG_reg_addr                                            "0xB801D138"
+#define A7_DSS_C35D5_12D5T_DEBUG_reg                                                 0xB801D138
+#define set_A7_DSS_C35D5_12D5T_DEBUG_reg(data)   (*((volatile unsigned int*) A7_DSS_C35D5_12D5T_DEBUG_reg)=data)
+#define get_A7_DSS_C35D5_12D5T_DEBUG_reg   (*((volatile unsigned int*) A7_DSS_C35D5_12D5T_DEBUG_reg))
+#define A7_DSS_C35D5_12D5T_DEBUG_inst_adr                                            "0x004E"
+#define A7_DSS_C35D5_12D5T_DEBUG_inst                                                0x004E
+#define A7_DSS_C35D5_12D5T_DEBUG_dbgo_shift                                          (0)
+#define A7_DSS_C35D5_12D5T_DEBUG_dbgo_mask                                           (0x0000FFFF)
+#define A7_DSS_C35D5_12D5T_DEBUG_dbgo(data)                                          (0x0000FFFF&((data)<<0))
+#define A7_DSS_C35D5_12D5T_DEBUG_dbgo_src(data)                                      ((0x0000FFFF&(data))>>0)
+#define A7_DSS_C35D5_12D5T_DEBUG_get_dbgo(data)                                      ((0x0000FFFF&(data))>>0)
+
+
+#define A7_CSM0_CTRL                                                                 0x1801D140
+#define A7_CSM0_CTRL_reg_addr                                                        "0xB801D140"
+#define A7_CSM0_CTRL_reg                                                             0xB801D140
+#define set_A7_CSM0_CTRL_reg(data)   (*((volatile unsigned int*) A7_CSM0_CTRL_reg)=data)
+#define get_A7_CSM0_CTRL_reg   (*((volatile unsigned int*) A7_CSM0_CTRL_reg))
+#define A7_CSM0_CTRL_inst_adr                                                        "0x0050"
+#define A7_CSM0_CTRL_inst                                                            0x0050
+#define A7_CSM0_CTRL_data_sel_shift                                                  (12)
+#define A7_CSM0_CTRL_data_sel_mask                                                   (0x00003000)
+#define A7_CSM0_CTRL_data_sel(data)                                                  (0x00003000&((data)<<12))
+#define A7_CSM0_CTRL_data_sel_src(data)                                              ((0x00003000&(data))>>12)
+#define A7_CSM0_CTRL_get_data_sel(data)                                              ((0x00003000&(data))>>12)
+#define A7_CSM0_CTRL_addr_shift                                                      (8)
+#define A7_CSM0_CTRL_addr_mask                                                       (0x00000F00)
+#define A7_CSM0_CTRL_addr(data)                                                      (0x00000F00&((data)<<8))
+#define A7_CSM0_CTRL_addr_src(data)                                                  ((0x00000F00&(data))>>8)
+#define A7_CSM0_CTRL_get_addr(data)                                                  ((0x00000F00&(data))>>8)
+#define A7_CSM0_CTRL_read_en_shift                                                   (7)
+#define A7_CSM0_CTRL_read_en_mask                                                    (0x00000080)
+#define A7_CSM0_CTRL_read_en(data)                                                   (0x00000080&((data)<<7))
+#define A7_CSM0_CTRL_read_en_src(data)                                               ((0x00000080&(data))>>7)
+#define A7_CSM0_CTRL_get_read_en(data)                                               ((0x00000080&(data))>>7)
+#define A7_CSM0_CTRL_hold_shift                                                      (6)
+#define A7_CSM0_CTRL_hold_mask                                                       (0x00000040)
+#define A7_CSM0_CTRL_hold(data)                                                      (0x00000040&((data)<<6))
+#define A7_CSM0_CTRL_hold_src(data)                                                  ((0x00000040&(data))>>6)
+#define A7_CSM0_CTRL_get_hold(data)                                                  ((0x00000040&(data))>>6)
+#define A7_CSM0_CTRL_csm_en_shift                                                    (5)
+#define A7_CSM0_CTRL_csm_en_mask                                                     (0x00000020)
+#define A7_CSM0_CTRL_csm_en(data)                                                    (0x00000020&((data)<<5))
+#define A7_CSM0_CTRL_csm_en_src(data)                                                ((0x00000020&(data))>>5)
+#define A7_CSM0_CTRL_get_csm_en(data)                                                ((0x00000020&(data))>>5)
+#define A7_CSM0_CTRL_acc_mode_shift                                                  (4)
+#define A7_CSM0_CTRL_acc_mode_mask                                                   (0x00000010)
+#define A7_CSM0_CTRL_acc_mode(data)                                                  (0x00000010&((data)<<4))
+#define A7_CSM0_CTRL_acc_mode_src(data)                                              ((0x00000010&(data))>>4)
+#define A7_CSM0_CTRL_get_acc_mode(data)                                              ((0x00000010&(data))>>4)
+#define A7_CSM0_CTRL_in_sel_shift                                                    (2)
+#define A7_CSM0_CTRL_in_sel_mask                                                     (0x0000000C)
+#define A7_CSM0_CTRL_in_sel(data)                                                    (0x0000000C&((data)<<2))
+#define A7_CSM0_CTRL_in_sel_src(data)                                                ((0x0000000C&(data))>>2)
+#define A7_CSM0_CTRL_get_in_sel(data)                                                ((0x0000000C&(data))>>2)
+#define A7_CSM0_CTRL_rstn_shift                                                      (0)
+#define A7_CSM0_CTRL_rstn_mask                                                       (0x00000001)
+#define A7_CSM0_CTRL_rstn(data)                                                      (0x00000001&((data)<<0))
+#define A7_CSM0_CTRL_rstn_src(data)                                                  ((0x00000001&(data))>>0)
+#define A7_CSM0_CTRL_get_rstn(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define A7_CSM1_CTRL                                                                 0x1801D144
+#define A7_CSM1_CTRL_reg_addr                                                        "0xB801D144"
+#define A7_CSM1_CTRL_reg                                                             0xB801D144
+#define set_A7_CSM1_CTRL_reg(data)   (*((volatile unsigned int*) A7_CSM1_CTRL_reg)=data)
+#define get_A7_CSM1_CTRL_reg   (*((volatile unsigned int*) A7_CSM1_CTRL_reg))
+#define A7_CSM1_CTRL_inst_adr                                                        "0x0051"
+#define A7_CSM1_CTRL_inst                                                            0x0051
+#define A7_CSM1_CTRL_data_sel_shift                                                  (12)
+#define A7_CSM1_CTRL_data_sel_mask                                                   (0x00003000)
+#define A7_CSM1_CTRL_data_sel(data)                                                  (0x00003000&((data)<<12))
+#define A7_CSM1_CTRL_data_sel_src(data)                                              ((0x00003000&(data))>>12)
+#define A7_CSM1_CTRL_get_data_sel(data)                                              ((0x00003000&(data))>>12)
+#define A7_CSM1_CTRL_addr_shift                                                      (8)
+#define A7_CSM1_CTRL_addr_mask                                                       (0x00000F00)
+#define A7_CSM1_CTRL_addr(data)                                                      (0x00000F00&((data)<<8))
+#define A7_CSM1_CTRL_addr_src(data)                                                  ((0x00000F00&(data))>>8)
+#define A7_CSM1_CTRL_get_addr(data)                                                  ((0x00000F00&(data))>>8)
+#define A7_CSM1_CTRL_read_en_shift                                                   (7)
+#define A7_CSM1_CTRL_read_en_mask                                                    (0x00000080)
+#define A7_CSM1_CTRL_read_en(data)                                                   (0x00000080&((data)<<7))
+#define A7_CSM1_CTRL_read_en_src(data)                                               ((0x00000080&(data))>>7)
+#define A7_CSM1_CTRL_get_read_en(data)                                               ((0x00000080&(data))>>7)
+#define A7_CSM1_CTRL_hold_shift                                                      (6)
+#define A7_CSM1_CTRL_hold_mask                                                       (0x00000040)
+#define A7_CSM1_CTRL_hold(data)                                                      (0x00000040&((data)<<6))
+#define A7_CSM1_CTRL_hold_src(data)                                                  ((0x00000040&(data))>>6)
+#define A7_CSM1_CTRL_get_hold(data)                                                  ((0x00000040&(data))>>6)
+#define A7_CSM1_CTRL_csm_en_shift                                                    (5)
+#define A7_CSM1_CTRL_csm_en_mask                                                     (0x00000020)
+#define A7_CSM1_CTRL_csm_en(data)                                                    (0x00000020&((data)<<5))
+#define A7_CSM1_CTRL_csm_en_src(data)                                                ((0x00000020&(data))>>5)
+#define A7_CSM1_CTRL_get_csm_en(data)                                                ((0x00000020&(data))>>5)
+#define A7_CSM1_CTRL_acc_mode_shift                                                  (4)
+#define A7_CSM1_CTRL_acc_mode_mask                                                   (0x00000010)
+#define A7_CSM1_CTRL_acc_mode(data)                                                  (0x00000010&((data)<<4))
+#define A7_CSM1_CTRL_acc_mode_src(data)                                              ((0x00000010&(data))>>4)
+#define A7_CSM1_CTRL_get_acc_mode(data)                                              ((0x00000010&(data))>>4)
+#define A7_CSM1_CTRL_in_sel_shift                                                    (2)
+#define A7_CSM1_CTRL_in_sel_mask                                                     (0x0000000C)
+#define A7_CSM1_CTRL_in_sel(data)                                                    (0x0000000C&((data)<<2))
+#define A7_CSM1_CTRL_in_sel_src(data)                                                ((0x0000000C&(data))>>2)
+#define A7_CSM1_CTRL_get_in_sel(data)                                                ((0x0000000C&(data))>>2)
+#define A7_CSM1_CTRL_rstn_shift                                                      (0)
+#define A7_CSM1_CTRL_rstn_mask                                                       (0x00000001)
+#define A7_CSM1_CTRL_rstn(data)                                                      (0x00000001&((data)<<0))
+#define A7_CSM1_CTRL_rstn_src(data)                                                  ((0x00000001&(data))>>0)
+#define A7_CSM1_CTRL_get_rstn(data)                                                  ((0x00000001&(data))>>0)
+
+
+#define A7_CSM_STATUS                                                                0x1801D148
+#define A7_CSM_STATUS_reg_addr                                                       "0xB801D148"
+#define A7_CSM_STATUS_reg                                                            0xB801D148
+#define set_A7_CSM_STATUS_reg(data)   (*((volatile unsigned int*) A7_CSM_STATUS_reg)=data)
+#define get_A7_CSM_STATUS_reg   (*((volatile unsigned int*) A7_CSM_STATUS_reg))
+#define A7_CSM_STATUS_inst_adr                                                       "0x0052"
+#define A7_CSM_STATUS_inst                                                           0x0052
+#define A7_CSM_STATUS_csm1_ready_shift                                               (1)
+#define A7_CSM_STATUS_csm1_ready_mask                                                (0x00000002)
+#define A7_CSM_STATUS_csm1_ready(data)                                               (0x00000002&((data)<<1))
+#define A7_CSM_STATUS_csm1_ready_src(data)                                           ((0x00000002&(data))>>1)
+#define A7_CSM_STATUS_get_csm1_ready(data)                                           ((0x00000002&(data))>>1)
+#define A7_CSM_STATUS_csm0_ready_shift                                               (0)
+#define A7_CSM_STATUS_csm0_ready_mask                                                (0x00000001)
+#define A7_CSM_STATUS_csm0_ready(data)                                               (0x00000001&((data)<<0))
+#define A7_CSM_STATUS_csm0_ready_src(data)                                           ((0x00000001&(data))>>0)
+#define A7_CSM_STATUS_get_csm0_ready(data)                                           ((0x00000001&(data))>>0)
+
+
+#define A7_CSM0_DO_STATUS                                                            0x1801D150
+#define A7_CSM0_DO_STATUS_reg_addr                                                   "0xB801D150"
+#define A7_CSM0_DO_STATUS_reg                                                        0xB801D150
+#define set_A7_CSM0_DO_STATUS_reg(data)   (*((volatile unsigned int*) A7_CSM0_DO_STATUS_reg)=data)
+#define get_A7_CSM0_DO_STATUS_reg   (*((volatile unsigned int*) A7_CSM0_DO_STATUS_reg))
+#define A7_CSM0_DO_STATUS_inst_adr                                                   "0x0054"
+#define A7_CSM0_DO_STATUS_inst                                                       0x0054
+#define A7_CSM0_DO_STATUS_data_output_shift                                          (0)
+#define A7_CSM0_DO_STATUS_data_output_mask                                           (0xFFFFFFFF)
+#define A7_CSM0_DO_STATUS_data_output(data)                                          (0xFFFFFFFF&((data)<<0))
+#define A7_CSM0_DO_STATUS_data_output_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define A7_CSM0_DO_STATUS_get_data_output(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define A7_CSM1_DO_STATUS                                                            0x1801D154
+#define A7_CSM1_DO_STATUS_reg_addr                                                   "0xB801D154"
+#define A7_CSM1_DO_STATUS_reg                                                        0xB801D154
+#define set_A7_CSM1_DO_STATUS_reg(data)   (*((volatile unsigned int*) A7_CSM1_DO_STATUS_reg)=data)
+#define get_A7_CSM1_DO_STATUS_reg   (*((volatile unsigned int*) A7_CSM1_DO_STATUS_reg))
+#define A7_CSM1_DO_STATUS_inst_adr                                                   "0x0055"
+#define A7_CSM1_DO_STATUS_inst                                                       0x0055
+#define A7_CSM1_DO_STATUS_data_output_shift                                          (0)
+#define A7_CSM1_DO_STATUS_data_output_mask                                           (0xFFFFFFFF)
+#define A7_CSM1_DO_STATUS_data_output(data)                                          (0xFFFFFFFF&((data)<<0))
+#define A7_CSM1_DO_STATUS_data_output_src(data)                                      ((0xFFFFFFFF&(data))>>0)
+#define A7_CSM1_DO_STATUS_get_data_output(data)                                      ((0xFFFFFFFF&(data))>>0)
+
+
+#define DBG_START_0                                                                  0x1801D200
+#define DBG_START_1                                                                  0x1801D204
+#define DBG_START_2                                                                  0x1801D208
+#define DBG_START_3                                                                  0x1801D20C
+#define DBG_START_0_reg_addr                                                         "0xB801D200"
+#define DBG_START_1_reg_addr                                                         "0xB801D204"
+#define DBG_START_2_reg_addr                                                         "0xB801D208"
+#define DBG_START_3_reg_addr                                                         "0xB801D20C"
+#define DBG_START_0_reg                                                              0xB801D200
+#define DBG_START_1_reg                                                              0xB801D204
+#define DBG_START_2_reg                                                              0xB801D208
+#define DBG_START_3_reg                                                              0xB801D20C
+#define set_DBG_START_0_reg(data)   (*((volatile unsigned int*) DBG_START_0_reg)=data)
+#define set_DBG_START_1_reg(data)   (*((volatile unsigned int*) DBG_START_1_reg)=data)
+#define set_DBG_START_2_reg(data)   (*((volatile unsigned int*) DBG_START_2_reg)=data)
+#define set_DBG_START_3_reg(data)   (*((volatile unsigned int*) DBG_START_3_reg)=data)
+#define get_DBG_START_0_reg   (*((volatile unsigned int*) DBG_START_0_reg))
+#define get_DBG_START_1_reg   (*((volatile unsigned int*) DBG_START_1_reg))
+#define get_DBG_START_2_reg   (*((volatile unsigned int*) DBG_START_2_reg))
+#define get_DBG_START_3_reg   (*((volatile unsigned int*) DBG_START_3_reg))
+#define DBG_START_0_inst_adr                                                         "0x0080"
+#define DBG_START_1_inst_adr                                                         "0x0081"
+#define DBG_START_2_inst_adr                                                         "0x0082"
+#define DBG_START_3_inst_adr                                                         "0x0083"
+#define DBG_START_0_inst                                                             0x0080
+#define DBG_START_1_inst                                                             0x0081
+#define DBG_START_2_inst                                                             0x0082
+#define DBG_START_3_inst                                                             0x0083
+#define DBG_START_dbg_start_addr_m1_shift                                            (0)
+#define DBG_START_dbg_start_addr_m1_mask                                             (0xFFFFFFFF)
+#define DBG_START_dbg_start_addr_m1(data)                                            (0xFFFFFFFF&((data)<<0))
+#define DBG_START_dbg_start_addr_m1_src(data)                                        ((0xFFFFFFFF&(data))>>0)
+#define DBG_START_get_dbg_start_addr_m1(data)                                        ((0xFFFFFFFF&(data))>>0)
+
+
+#define DBG_END_0                                                                    0x1801D210
+#define DBG_END_1                                                                    0x1801D214
+#define DBG_END_2                                                                    0x1801D218
+#define DBG_END_3                                                                    0x1801D21C
+#define DBG_END_0_reg_addr                                                           "0xB801D210"
+#define DBG_END_1_reg_addr                                                           "0xB801D214"
+#define DBG_END_2_reg_addr                                                           "0xB801D218"
+#define DBG_END_3_reg_addr                                                           "0xB801D21C"
+#define DBG_END_0_reg                                                                0xB801D210
+#define DBG_END_1_reg                                                                0xB801D214
+#define DBG_END_2_reg                                                                0xB801D218
+#define DBG_END_3_reg                                                                0xB801D21C
+#define set_DBG_END_0_reg(data)   (*((volatile unsigned int*) DBG_END_0_reg)=data)
+#define set_DBG_END_1_reg(data)   (*((volatile unsigned int*) DBG_END_1_reg)=data)
+#define set_DBG_END_2_reg(data)   (*((volatile unsigned int*) DBG_END_2_reg)=data)
+#define set_DBG_END_3_reg(data)   (*((volatile unsigned int*) DBG_END_3_reg)=data)
+#define get_DBG_END_0_reg   (*((volatile unsigned int*) DBG_END_0_reg))
+#define get_DBG_END_1_reg   (*((volatile unsigned int*) DBG_END_1_reg))
+#define get_DBG_END_2_reg   (*((volatile unsigned int*) DBG_END_2_reg))
+#define get_DBG_END_3_reg   (*((volatile unsigned int*) DBG_END_3_reg))
+#define DBG_END_0_inst_adr                                                           "0x0084"
+#define DBG_END_1_inst_adr                                                           "0x0085"
+#define DBG_END_2_inst_adr                                                           "0x0086"
+#define DBG_END_3_inst_adr                                                           "0x0087"
+#define DBG_END_0_inst                                                               0x0084
+#define DBG_END_1_inst                                                               0x0085
+#define DBG_END_2_inst                                                               0x0086
+#define DBG_END_3_inst                                                               0x0087
+#define DBG_END_dbg_end_addr_m1_shift                                                (0)
+#define DBG_END_dbg_end_addr_m1_mask                                                 (0xFFFFFFFF)
+#define DBG_END_dbg_end_addr_m1(data)                                                (0xFFFFFFFF&((data)<<0))
+#define DBG_END_dbg_end_addr_m1_src(data)                                            ((0xFFFFFFFF&(data))>>0)
+#define DBG_END_get_dbg_end_addr_m1(data)                                            ((0xFFFFFFFF&(data))>>0)
+
+
+#define DBG_CTRL_0                                                                   0x1801D220
+#define DBG_CTRL_1                                                                   0x1801D224
+#define DBG_CTRL_2                                                                   0x1801D228
+#define DBG_CTRL_3                                                                   0x1801D22C
+#define DBG_CTRL_0_reg_addr                                                          "0xB801D220"
+#define DBG_CTRL_1_reg_addr                                                          "0xB801D224"
+#define DBG_CTRL_2_reg_addr                                                          "0xB801D228"
+#define DBG_CTRL_3_reg_addr                                                          "0xB801D22C"
+#define DBG_CTRL_0_reg                                                               0xB801D220
+#define DBG_CTRL_1_reg                                                               0xB801D224
+#define DBG_CTRL_2_reg                                                               0xB801D228
+#define DBG_CTRL_3_reg                                                               0xB801D22C
+#define set_DBG_CTRL_0_reg(data)   (*((volatile unsigned int*) DBG_CTRL_0_reg)=data)
+#define set_DBG_CTRL_1_reg(data)   (*((volatile unsigned int*) DBG_CTRL_1_reg)=data)
+#define set_DBG_CTRL_2_reg(data)   (*((volatile unsigned int*) DBG_CTRL_2_reg)=data)
+#define set_DBG_CTRL_3_reg(data)   (*((volatile unsigned int*) DBG_CTRL_3_reg)=data)
+#define get_DBG_CTRL_0_reg   (*((volatile unsigned int*) DBG_CTRL_0_reg))
+#define get_DBG_CTRL_1_reg   (*((volatile unsigned int*) DBG_CTRL_1_reg))
+#define get_DBG_CTRL_2_reg   (*((volatile unsigned int*) DBG_CTRL_2_reg))
+#define get_DBG_CTRL_3_reg   (*((volatile unsigned int*) DBG_CTRL_3_reg))
+#define DBG_CTRL_0_inst_adr                                                          "0x0088"
+#define DBG_CTRL_1_inst_adr                                                          "0x0089"
+#define DBG_CTRL_2_inst_adr                                                          "0x008A"
+#define DBG_CTRL_3_inst_adr                                                          "0x008B"
+#define DBG_CTRL_0_inst                                                              0x0088
+#define DBG_CTRL_1_inst                                                              0x0089
+#define DBG_CTRL_2_inst                                                              0x008A
+#define DBG_CTRL_3_inst                                                              0x008B
+#define DBG_CTRL_write_en2_shift                                                     (4)
+#define DBG_CTRL_write_en2_mask                                                      (0x00000010)
+#define DBG_CTRL_write_en2(data)                                                     (0x00000010&((data)<<4))
+#define DBG_CTRL_write_en2_src(data)                                                 ((0x00000010&(data))>>4)
+#define DBG_CTRL_get_write_en2(data)                                                 ((0x00000010&(data))>>4)
+#define DBG_CTRL_dbg_wr_chk_m1_shift                                                 (2)
+#define DBG_CTRL_dbg_wr_chk_m1_mask                                                  (0x0000000C)
+#define DBG_CTRL_dbg_wr_chk_m1(data)                                                 (0x0000000C&((data)<<2))
+#define DBG_CTRL_dbg_wr_chk_m1_src(data)                                             ((0x0000000C&(data))>>2)
+#define DBG_CTRL_get_dbg_wr_chk_m1(data)                                             ((0x0000000C&(data))>>2)
+#define DBG_CTRL_write_en1_shift                                                     (1)
+#define DBG_CTRL_write_en1_mask                                                      (0x00000002)
+#define DBG_CTRL_write_en1(data)                                                     (0x00000002&((data)<<1))
+#define DBG_CTRL_write_en1_src(data)                                                 ((0x00000002&(data))>>1)
+#define DBG_CTRL_get_write_en1(data)                                                 ((0x00000002&(data))>>1)
+#define DBG_CTRL_dbg_en_m1_shift                                                     (0)
+#define DBG_CTRL_dbg_en_m1_mask                                                      (0x00000001)
+#define DBG_CTRL_dbg_en_m1(data)                                                     (0x00000001&((data)<<0))
+#define DBG_CTRL_dbg_en_m1_src(data)                                                 ((0x00000001&(data))>>0)
+#define DBG_CTRL_get_dbg_en_m1(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define DBG_INT                                                                      0x1801D230
+#define DBG_INT_reg_addr                                                             "0xB801D230"
+#define DBG_INT_reg                                                                  0xB801D230
+#define set_DBG_INT_reg(data)   (*((volatile unsigned int*) DBG_INT_reg)=data)
+#define get_DBG_INT_reg   (*((volatile unsigned int*) DBG_INT_reg))
+#define DBG_INT_inst_adr                                                             "0x008C"
+#define DBG_INT_inst                                                                 0x008C
+#define DBG_INT_scpu_int_m1_shift                                                    (4)
+#define DBG_INT_scpu_int_m1_mask                                                     (0x00000010)
+#define DBG_INT_scpu_int_m1(data)                                                    (0x00000010&((data)<<4))
+#define DBG_INT_scpu_int_m1_src(data)                                                ((0x00000010&(data))>>4)
+#define DBG_INT_get_scpu_int_m1(data)                                                ((0x00000010&(data))>>4)
+#define DBG_INT_scpu_int_en_m1_shift                                                 (3)
+#define DBG_INT_scpu_int_en_m1_mask                                                  (0x00000008)
+#define DBG_INT_scpu_int_en_m1(data)                                                 (0x00000008&((data)<<3))
+#define DBG_INT_scpu_int_en_m1_src(data)                                             ((0x00000008&(data))>>3)
+#define DBG_INT_get_scpu_int_en_m1(data)                                             ((0x00000008&(data))>>3)
+#define DBG_INT_scpu_neg_int_m1_shift                                                (2)
+#define DBG_INT_scpu_neg_int_m1_mask                                                 (0x00000004)
+#define DBG_INT_scpu_neg_int_m1(data)                                                (0x00000004&((data)<<2))
+#define DBG_INT_scpu_neg_int_m1_src(data)                                            ((0x00000004&(data))>>2)
+#define DBG_INT_get_scpu_neg_int_m1(data)                                            ((0x00000004&(data))>>2)
+#define DBG_INT_scpu_neg_int_en_m1_shift                                             (1)
+#define DBG_INT_scpu_neg_int_en_m1_mask                                              (0x00000002)
+#define DBG_INT_scpu_neg_int_en_m1(data)                                             (0x00000002&((data)<<1))
+#define DBG_INT_scpu_neg_int_en_m1_src(data)                                         ((0x00000002&(data))>>1)
+#define DBG_INT_get_scpu_neg_int_en_m1(data)                                         ((0x00000002&(data))>>1)
+#define DBG_INT_write_data_shift                                                     (0)
+#define DBG_INT_write_data_mask                                                      (0x00000001)
+#define DBG_INT_write_data(data)                                                     (0x00000001&((data)<<0))
+#define DBG_INT_write_data_src(data)                                                 ((0x00000001&(data))>>0)
+#define DBG_INT_get_write_data(data)                                                 ((0x00000001&(data))>>0)
+
+
+#define DBG_ADDR                                                                     0x1801D234
+#define DBG_ADDR_reg_addr                                                            "0xB801D234"
+#define DBG_ADDR_reg                                                                 0xB801D234
+#define set_DBG_ADDR_reg(data)   (*((volatile unsigned int*) DBG_ADDR_reg)=data)
+#define get_DBG_ADDR_reg   (*((volatile unsigned int*) DBG_ADDR_reg))
+#define DBG_ADDR_inst_adr                                                            "0x008D"
+#define DBG_ADDR_inst                                                                0x008D
+#define DBG_ADDR_dbg_addr_m1_shift                                                   (0)
+#define DBG_ADDR_dbg_addr_m1_mask                                                    (0xFFFFFFFF)
+#define DBG_ADDR_dbg_addr_m1(data)                                                   (0xFFFFFFFF&((data)<<0))
+#define DBG_ADDR_dbg_addr_m1_src(data)                                               ((0xFFFFFFFF&(data))>>0)
+#define DBG_ADDR_get_dbg_addr_m1(data)                                               ((0xFFFFFFFF&(data))>>0)
+
+
+#define DBG_ADDR1                                                                    0x1801D238
+#define DBG_ADDR1_reg_addr                                                           "0xB801D238"
+#define DBG_ADDR1_reg                                                                0xB801D238
+#define set_DBG_ADDR1_reg(data)   (*((volatile unsigned int*) DBG_ADDR1_reg)=data)
+#define get_DBG_ADDR1_reg   (*((volatile unsigned int*) DBG_ADDR1_reg))
+#define DBG_ADDR1_inst_adr                                                           "0x008E"
+#define DBG_ADDR1_inst                                                               0x008E
+#define DBG_ADDR1_scpu_dbg_write_m1_shift                                            (0)
+#define DBG_ADDR1_scpu_dbg_write_m1_mask                                             (0x00000001)
+#define DBG_ADDR1_scpu_dbg_write_m1(data)                                            (0x00000001&((data)<<0))
+#define DBG_ADDR1_scpu_dbg_write_m1_src(data)                                        ((0x00000001&(data))>>0)
+#define DBG_ADDR1_get_scpu_dbg_write_m1(data)                                        ((0x00000001&(data))>>0)
+
+
+#define BIST_MODE                                                                    0x1801D300
+#define BIST_MODE_reg_addr                                                           "0xB801D300"
+#define BIST_MODE_reg                                                                0xB801D300
+#define set_BIST_MODE_reg(data)   (*((volatile unsigned int*) BIST_MODE_reg)=data)
+#define get_BIST_MODE_reg   (*((volatile unsigned int*) BIST_MODE_reg))
+#define BIST_MODE_inst_adr                                                           "0x00C0"
+#define BIST_MODE_inst                                                               0x00C0
+#define BIST_MODE_scu_mbist_mode_shift                                               (6)
+#define BIST_MODE_scu_mbist_mode_mask                                                (0x00000040)
+#define BIST_MODE_scu_mbist_mode(data)                                               (0x00000040&((data)<<6))
+#define BIST_MODE_scu_mbist_mode_src(data)                                           ((0x00000040&(data))>>6)
+#define BIST_MODE_get_scu_mbist_mode(data)                                           ((0x00000040&(data))>>6)
+#define BIST_MODE_idata_mbist_mode_shift                                             (5)
+#define BIST_MODE_idata_mbist_mode_mask                                              (0x00000020)
+#define BIST_MODE_idata_mbist_mode(data)                                             (0x00000020&((data)<<5))
+#define BIST_MODE_idata_mbist_mode_src(data)                                         ((0x00000020&(data))>>5)
+#define BIST_MODE_get_idata_mbist_mode(data)                                         ((0x00000020&(data))>>5)
+#define BIST_MODE_itag_mbist_mode_shift                                              (4)
+#define BIST_MODE_itag_mbist_mode_mask                                               (0x00000010)
+#define BIST_MODE_itag_mbist_mode(data)                                              (0x00000010&((data)<<4))
+#define BIST_MODE_itag_mbist_mode_src(data)                                          ((0x00000010&(data))>>4)
+#define BIST_MODE_get_itag_mbist_mode(data)                                          ((0x00000010&(data))>>4)
+#define BIST_MODE_ddata_mbist_mode_shift                                             (3)
+#define BIST_MODE_ddata_mbist_mode_mask                                              (0x00000008)
+#define BIST_MODE_ddata_mbist_mode(data)                                             (0x00000008&((data)<<3))
+#define BIST_MODE_ddata_mbist_mode_src(data)                                         ((0x00000008&(data))>>3)
+#define BIST_MODE_get_ddata_mbist_mode(data)                                         ((0x00000008&(data))>>3)
+#define BIST_MODE_dtag_mbist_mode_shift                                              (2)
+#define BIST_MODE_dtag_mbist_mode_mask                                               (0x00000004)
+#define BIST_MODE_dtag_mbist_mode(data)                                              (0x00000004&((data)<<2))
+#define BIST_MODE_dtag_mbist_mode_src(data)                                          ((0x00000004&(data))>>2)
+#define BIST_MODE_get_dtag_mbist_mode(data)                                          ((0x00000004&(data))>>2)
+#define BIST_MODE_ddrity_mbist_mode_shift                                            (1)
+#define BIST_MODE_ddrity_mbist_mode_mask                                             (0x00000002)
+#define BIST_MODE_ddrity_mbist_mode(data)                                            (0x00000002&((data)<<1))
+#define BIST_MODE_ddrity_mbist_mode_src(data)                                        ((0x00000002&(data))>>1)
+#define BIST_MODE_get_ddrity_mbist_mode(data)                                        ((0x00000002&(data))>>1)
+#define BIST_MODE_tlb_mbist_mode_shift                                               (0)
+#define BIST_MODE_tlb_mbist_mode_mask                                                (0x00000001)
+#define BIST_MODE_tlb_mbist_mode(data)                                               (0x00000001&((data)<<0))
+#define BIST_MODE_tlb_mbist_mode_src(data)                                           ((0x00000001&(data))>>0)
+#define BIST_MODE_get_tlb_mbist_mode(data)                                           ((0x00000001&(data))>>0)
+
+
+#define DRF_BIST_MODE                                                                0x1801D304
+#define DRF_BIST_MODE_reg_addr                                                       "0xB801D304"
+#define DRF_BIST_MODE_reg                                                            0xB801D304
+#define set_DRF_BIST_MODE_reg(data)   (*((volatile unsigned int*) DRF_BIST_MODE_reg)=data)
+#define get_DRF_BIST_MODE_reg   (*((volatile unsigned int*) DRF_BIST_MODE_reg))
+#define DRF_BIST_MODE_inst_adr                                                       "0x00C1"
+#define DRF_BIST_MODE_inst                                                           0x00C1
+#define DRF_BIST_MODE_drf_mbist_mode_shift                                           (0)
+#define DRF_BIST_MODE_drf_mbist_mode_mask                                            (0x00000001)
+#define DRF_BIST_MODE_drf_mbist_mode(data)                                           (0x00000001&((data)<<0))
+#define DRF_BIST_MODE_drf_mbist_mode_src(data)                                       ((0x00000001&(data))>>0)
+#define DRF_BIST_MODE_get_drf_mbist_mode(data)                                       ((0x00000001&(data))>>0)
+
+
+#define DRF_TEST_RESUME                                                              0x1801D308
+#define DRF_TEST_RESUME_reg_addr                                                     "0xB801D308"
+#define DRF_TEST_RESUME_reg                                                          0xB801D308
+#define set_DRF_TEST_RESUME_reg(data)   (*((volatile unsigned int*) DRF_TEST_RESUME_reg)=data)
+#define get_DRF_TEST_RESUME_reg   (*((volatile unsigned int*) DRF_TEST_RESUME_reg))
+#define DRF_TEST_RESUME_inst_adr                                                     "0x00C2"
+#define DRF_TEST_RESUME_inst                                                         0x00C2
+#define DRF_TEST_RESUME_drf_test_resume_shift                                        (0)
+#define DRF_TEST_RESUME_drf_test_resume_mask                                         (0x00000001)
+#define DRF_TEST_RESUME_drf_test_resume(data)                                        (0x00000001&((data)<<0))
+#define DRF_TEST_RESUME_drf_test_resume_src(data)                                    ((0x00000001&(data))>>0)
+#define DRF_TEST_RESUME_get_drf_test_resume(data)                                    ((0x00000001&(data))>>0)
+
+
+#define CPU_BIST_DONE                                                                0x1801D30C
+#define CPU_BIST_DONE_reg_addr                                                       "0xB801D30C"
+#define CPU_BIST_DONE_reg                                                            0xB801D30C
+#define set_CPU_BIST_DONE_reg(data)   (*((volatile unsigned int*) CPU_BIST_DONE_reg)=data)
+#define get_CPU_BIST_DONE_reg   (*((volatile unsigned int*) CPU_BIST_DONE_reg))
+#define CPU_BIST_DONE_inst_adr                                                       "0x00C3"
+#define CPU_BIST_DONE_inst                                                           0x00C3
+#define CPU_BIST_DONE_MBISTACK_shift                                                 (7)
+#define CPU_BIST_DONE_MBISTACK_mask                                                  (0x00000080)
+#define CPU_BIST_DONE_MBISTACK(data)                                                 (0x00000080&((data)<<7))
+#define CPU_BIST_DONE_MBISTACK_src(data)                                             ((0x00000080&(data))>>7)
+#define CPU_BIST_DONE_get_MBISTACK(data)                                             ((0x00000080&(data))>>7)
+#define CPU_BIST_DONE_scu_mbist_done_shift                                           (6)
+#define CPU_BIST_DONE_scu_mbist_done_mask                                            (0x00000040)
+#define CPU_BIST_DONE_scu_mbist_done(data)                                           (0x00000040&((data)<<6))
+#define CPU_BIST_DONE_scu_mbist_done_src(data)                                       ((0x00000040&(data))>>6)
+#define CPU_BIST_DONE_get_scu_mbist_done(data)                                       ((0x00000040&(data))>>6)
+#define CPU_BIST_DONE_idata_mbist_done_shift                                         (5)
+#define CPU_BIST_DONE_idata_mbist_done_mask                                          (0x00000020)
+#define CPU_BIST_DONE_idata_mbist_done(data)                                         (0x00000020&((data)<<5))
+#define CPU_BIST_DONE_idata_mbist_done_src(data)                                     ((0x00000020&(data))>>5)
+#define CPU_BIST_DONE_get_idata_mbist_done(data)                                     ((0x00000020&(data))>>5)
+#define CPU_BIST_DONE_itag_mbist_done_shift                                          (4)
+#define CPU_BIST_DONE_itag_mbist_done_mask                                           (0x00000010)
+#define CPU_BIST_DONE_itag_mbist_done(data)                                          (0x00000010&((data)<<4))
+#define CPU_BIST_DONE_itag_mbist_done_src(data)                                      ((0x00000010&(data))>>4)
+#define CPU_BIST_DONE_get_itag_mbist_done(data)                                      ((0x00000010&(data))>>4)
+#define CPU_BIST_DONE_ddata_mbist_done_shift                                         (3)
+#define CPU_BIST_DONE_ddata_mbist_done_mask                                          (0x00000008)
+#define CPU_BIST_DONE_ddata_mbist_done(data)                                         (0x00000008&((data)<<3))
+#define CPU_BIST_DONE_ddata_mbist_done_src(data)                                     ((0x00000008&(data))>>3)
+#define CPU_BIST_DONE_get_ddata_mbist_done(data)                                     ((0x00000008&(data))>>3)
+#define CPU_BIST_DONE_dtag_mbist_done_shift                                          (2)
+#define CPU_BIST_DONE_dtag_mbist_done_mask                                           (0x00000004)
+#define CPU_BIST_DONE_dtag_mbist_done(data)                                          (0x00000004&((data)<<2))
+#define CPU_BIST_DONE_dtag_mbist_done_src(data)                                      ((0x00000004&(data))>>2)
+#define CPU_BIST_DONE_get_dtag_mbist_done(data)                                      ((0x00000004&(data))>>2)
+#define CPU_BIST_DONE_ddirty_mbist_done_shift                                        (1)
+#define CPU_BIST_DONE_ddirty_mbist_done_mask                                         (0x00000002)
+#define CPU_BIST_DONE_ddirty_mbist_done(data)                                        (0x00000002&((data)<<1))
+#define CPU_BIST_DONE_ddirty_mbist_done_src(data)                                    ((0x00000002&(data))>>1)
+#define CPU_BIST_DONE_get_ddirty_mbist_done(data)                                    ((0x00000002&(data))>>1)
+#define CPU_BIST_DONE_tlb_mbist_done_shift                                           (0)
+#define CPU_BIST_DONE_tlb_mbist_done_mask                                            (0x00000001)
+#define CPU_BIST_DONE_tlb_mbist_done(data)                                           (0x00000001&((data)<<0))
+#define CPU_BIST_DONE_tlb_mbist_done_src(data)                                       ((0x00000001&(data))>>0)
+#define CPU_BIST_DONE_get_tlb_mbist_done(data)                                       ((0x00000001&(data))>>0)
+
+
+#define CPU_DRF_BIST_DONE                                                            0x1801D310
+#define CPU_DRF_BIST_DONE_reg_addr                                                   "0xB801D310"
+#define CPU_DRF_BIST_DONE_reg                                                        0xB801D310
+#define set_CPU_DRF_BIST_DONE_reg(data)   (*((volatile unsigned int*) CPU_DRF_BIST_DONE_reg)=data)
+#define get_CPU_DRF_BIST_DONE_reg   (*((volatile unsigned int*) CPU_DRF_BIST_DONE_reg))
+#define CPU_DRF_BIST_DONE_inst_adr                                                   "0x00C4"
+#define CPU_DRF_BIST_DONE_inst                                                       0x00C4
+#define CPU_DRF_BIST_DONE_drf_mbist_done_shift                                       (0)
+#define CPU_DRF_BIST_DONE_drf_mbist_done_mask                                        (0x00000001)
+#define CPU_DRF_BIST_DONE_drf_mbist_done(data)                                       (0x00000001&((data)<<0))
+#define CPU_DRF_BIST_DONE_drf_mbist_done_src(data)                                   ((0x00000001&(data))>>0)
+#define CPU_DRF_BIST_DONE_get_drf_mbist_done(data)                                   ((0x00000001&(data))>>0)
+
+
+#define CPU_DRF_START_PAUSE                                                          0x1801D314
+#define CPU_DRF_START_PAUSE_reg_addr                                                 "0xB801D314"
+#define CPU_DRF_START_PAUSE_reg                                                      0xB801D314
+#define set_CPU_DRF_START_PAUSE_reg(data)   (*((volatile unsigned int*) CPU_DRF_START_PAUSE_reg)=data)
+#define get_CPU_DRF_START_PAUSE_reg   (*((volatile unsigned int*) CPU_DRF_START_PAUSE_reg))
+#define CPU_DRF_START_PAUSE_inst_adr                                                 "0x00C5"
+#define CPU_DRF_START_PAUSE_inst                                                     0x00C5
+#define CPU_DRF_START_PAUSE_drf_start_pause_shift                                    (0)
+#define CPU_DRF_START_PAUSE_drf_start_pause_mask                                     (0x00000001)
+#define CPU_DRF_START_PAUSE_drf_start_pause(data)                                    (0x00000001&((data)<<0))
+#define CPU_DRF_START_PAUSE_drf_start_pause_src(data)                                ((0x00000001&(data))>>0)
+#define CPU_DRF_START_PAUSE_get_drf_start_pause(data)                                ((0x00000001&(data))>>0)
+
+
+#define CPU0_BIST_FAIL_GROUP                                                         0x1801D318
+#define CPU0_BIST_FAIL_GROUP_reg_addr                                                "0xB801D318"
+#define CPU0_BIST_FAIL_GROUP_reg                                                     0xB801D318
+#define set_CPU0_BIST_FAIL_GROUP_reg(data)   (*((volatile unsigned int*) CPU0_BIST_FAIL_GROUP_reg)=data)
+#define get_CPU0_BIST_FAIL_GROUP_reg   (*((volatile unsigned int*) CPU0_BIST_FAIL_GROUP_reg))
+#define CPU0_BIST_FAIL_GROUP_inst_adr                                                "0x00C6"
+#define CPU0_BIST_FAIL_GROUP_inst                                                    0x00C6
+#define CPU0_BIST_FAIL_GROUP_cpu0_scu_mbist_fail_G_shift                             (6)
+#define CPU0_BIST_FAIL_GROUP_cpu0_scu_mbist_fail_G_mask                              (0x00000040)
+#define CPU0_BIST_FAIL_GROUP_cpu0_scu_mbist_fail_G(data)                             (0x00000040&((data)<<6))
+#define CPU0_BIST_FAIL_GROUP_cpu0_scu_mbist_fail_G_src(data)                         ((0x00000040&(data))>>6)
+#define CPU0_BIST_FAIL_GROUP_get_cpu0_scu_mbist_fail_G(data)                         ((0x00000040&(data))>>6)
+#define CPU0_BIST_FAIL_GROUP_cpu0_idata_mbist_fail_G_shift                           (5)
+#define CPU0_BIST_FAIL_GROUP_cpu0_idata_mbist_fail_G_mask                            (0x00000020)
+#define CPU0_BIST_FAIL_GROUP_cpu0_idata_mbist_fail_G(data)                           (0x00000020&((data)<<5))
+#define CPU0_BIST_FAIL_GROUP_cpu0_idata_mbist_fail_G_src(data)                       ((0x00000020&(data))>>5)
+#define CPU0_BIST_FAIL_GROUP_get_cpu0_idata_mbist_fail_G(data)                       ((0x00000020&(data))>>5)
+#define CPU0_BIST_FAIL_GROUP_cpu0_itag_mbist_fail_G_shift                            (4)
+#define CPU0_BIST_FAIL_GROUP_cpu0_itag_mbist_fail_G_mask                             (0x00000010)
+#define CPU0_BIST_FAIL_GROUP_cpu0_itag_mbist_fail_G(data)                            (0x00000010&((data)<<4))
+#define CPU0_BIST_FAIL_GROUP_cpu0_itag_mbist_fail_G_src(data)                        ((0x00000010&(data))>>4)
+#define CPU0_BIST_FAIL_GROUP_get_cpu0_itag_mbist_fail_G(data)                        ((0x00000010&(data))>>4)
+#define CPU0_BIST_FAIL_GROUP_cpu0_ddata_mbist_fail_G_shift                           (3)
+#define CPU0_BIST_FAIL_GROUP_cpu0_ddata_mbist_fail_G_mask                            (0x00000008)
+#define CPU0_BIST_FAIL_GROUP_cpu0_ddata_mbist_fail_G(data)                           (0x00000008&((data)<<3))
+#define CPU0_BIST_FAIL_GROUP_cpu0_ddata_mbist_fail_G_src(data)                       ((0x00000008&(data))>>3)
+#define CPU0_BIST_FAIL_GROUP_get_cpu0_ddata_mbist_fail_G(data)                       ((0x00000008&(data))>>3)
+#define CPU0_BIST_FAIL_GROUP_cpu0_dtag_mbist_fail_G_shift                            (2)
+#define CPU0_BIST_FAIL_GROUP_cpu0_dtag_mbist_fail_G_mask                             (0x00000004)
+#define CPU0_BIST_FAIL_GROUP_cpu0_dtag_mbist_fail_G(data)                            (0x00000004&((data)<<2))
+#define CPU0_BIST_FAIL_GROUP_cpu0_dtag_mbist_fail_G_src(data)                        ((0x00000004&(data))>>2)
+#define CPU0_BIST_FAIL_GROUP_get_cpu0_dtag_mbist_fail_G(data)                        ((0x00000004&(data))>>2)
+#define CPU0_BIST_FAIL_GROUP_cpu0_ddrity_mbist_fail_G_shift                          (1)
+#define CPU0_BIST_FAIL_GROUP_cpu0_ddrity_mbist_fail_G_mask                           (0x00000002)
+#define CPU0_BIST_FAIL_GROUP_cpu0_ddrity_mbist_fail_G(data)                          (0x00000002&((data)<<1))
+#define CPU0_BIST_FAIL_GROUP_cpu0_ddrity_mbist_fail_G_src(data)                      ((0x00000002&(data))>>1)
+#define CPU0_BIST_FAIL_GROUP_get_cpu0_ddrity_mbist_fail_G(data)                      ((0x00000002&(data))>>1)
+#define CPU0_BIST_FAIL_GROUP_cpu0_tlb_mbist_fail_G_shift                             (0)
+#define CPU0_BIST_FAIL_GROUP_cpu0_tlb_mbist_fail_G_mask                              (0x00000001)
+#define CPU0_BIST_FAIL_GROUP_cpu0_tlb_mbist_fail_G(data)                             (0x00000001&((data)<<0))
+#define CPU0_BIST_FAIL_GROUP_cpu0_tlb_mbist_fail_G_src(data)                         ((0x00000001&(data))>>0)
+#define CPU0_BIST_FAIL_GROUP_get_cpu0_tlb_mbist_fail_G(data)                         ((0x00000001&(data))>>0)
+
+
+#define CPU1_BIST_FAIL_GROUP                                                         0x1801D31C
+#define CPU1_BIST_FAIL_GROUP_reg_addr                                                "0xB801D31C"
+#define CPU1_BIST_FAIL_GROUP_reg                                                     0xB801D31C
+#define set_CPU1_BIST_FAIL_GROUP_reg(data)   (*((volatile unsigned int*) CPU1_BIST_FAIL_GROUP_reg)=data)
+#define get_CPU1_BIST_FAIL_GROUP_reg   (*((volatile unsigned int*) CPU1_BIST_FAIL_GROUP_reg))
+#define CPU1_BIST_FAIL_GROUP_inst_adr                                                "0x00C7"
+#define CPU1_BIST_FAIL_GROUP_inst                                                    0x00C7
+#define CPU1_BIST_FAIL_GROUP_cpu1_scu_mbist_fail_G_shift                             (6)
+#define CPU1_BIST_FAIL_GROUP_cpu1_scu_mbist_fail_G_mask                              (0x00000040)
+#define CPU1_BIST_FAIL_GROUP_cpu1_scu_mbist_fail_G(data)                             (0x00000040&((data)<<6))
+#define CPU1_BIST_FAIL_GROUP_cpu1_scu_mbist_fail_G_src(data)                         ((0x00000040&(data))>>6)
+#define CPU1_BIST_FAIL_GROUP_get_cpu1_scu_mbist_fail_G(data)                         ((0x00000040&(data))>>6)
+#define CPU1_BIST_FAIL_GROUP_cpu1_idata_mbist_fail_G_shift                           (5)
+#define CPU1_BIST_FAIL_GROUP_cpu1_idata_mbist_fail_G_mask                            (0x00000020)
+#define CPU1_BIST_FAIL_GROUP_cpu1_idata_mbist_fail_G(data)                           (0x00000020&((data)<<5))
+#define CPU1_BIST_FAIL_GROUP_cpu1_idata_mbist_fail_G_src(data)                       ((0x00000020&(data))>>5)
+#define CPU1_BIST_FAIL_GROUP_get_cpu1_idata_mbist_fail_G(data)                       ((0x00000020&(data))>>5)
+#define CPU1_BIST_FAIL_GROUP_cpu1_itag_mbist_fail_G_shift                            (4)
+#define CPU1_BIST_FAIL_GROUP_cpu1_itag_mbist_fail_G_mask                             (0x00000010)
+#define CPU1_BIST_FAIL_GROUP_cpu1_itag_mbist_fail_G(data)                            (0x00000010&((data)<<4))
+#define CPU1_BIST_FAIL_GROUP_cpu1_itag_mbist_fail_G_src(data)                        ((0x00000010&(data))>>4)
+#define CPU1_BIST_FAIL_GROUP_get_cpu1_itag_mbist_fail_G(data)                        ((0x00000010&(data))>>4)
+#define CPU1_BIST_FAIL_GROUP_cpu1_ddata_mbist_fail_G_shift                           (3)
+#define CPU1_BIST_FAIL_GROUP_cpu1_ddata_mbist_fail_G_mask                            (0x00000008)
+#define CPU1_BIST_FAIL_GROUP_cpu1_ddata_mbist_fail_G(data)                           (0x00000008&((data)<<3))
+#define CPU1_BIST_FAIL_GROUP_cpu1_ddata_mbist_fail_G_src(data)                       ((0x00000008&(data))>>3)
+#define CPU1_BIST_FAIL_GROUP_get_cpu1_ddata_mbist_fail_G(data)                       ((0x00000008&(data))>>3)
+#define CPU1_BIST_FAIL_GROUP_cpu1_dtag_mbist_fail_G_shift                            (2)
+#define CPU1_BIST_FAIL_GROUP_cpu1_dtag_mbist_fail_G_mask                             (0x00000004)
+#define CPU1_BIST_FAIL_GROUP_cpu1_dtag_mbist_fail_G(data)                            (0x00000004&((data)<<2))
+#define CPU1_BIST_FAIL_GROUP_cpu1_dtag_mbist_fail_G_src(data)                        ((0x00000004&(data))>>2)
+#define CPU1_BIST_FAIL_GROUP_get_cpu1_dtag_mbist_fail_G(data)                        ((0x00000004&(data))>>2)
+#define CPU1_BIST_FAIL_GROUP_cpu1_ddrity_mbist_fail_G_shift                          (1)
+#define CPU1_BIST_FAIL_GROUP_cpu1_ddrity_mbist_fail_G_mask                           (0x00000002)
+#define CPU1_BIST_FAIL_GROUP_cpu1_ddrity_mbist_fail_G(data)                          (0x00000002&((data)<<1))
+#define CPU1_BIST_FAIL_GROUP_cpu1_ddrity_mbist_fail_G_src(data)                      ((0x00000002&(data))>>1)
+#define CPU1_BIST_FAIL_GROUP_get_cpu1_ddrity_mbist_fail_G(data)                      ((0x00000002&(data))>>1)
+#define CPU1_BIST_FAIL_GROUP_cpu1_tlb_mbist_fail_G_shift                             (0)
+#define CPU1_BIST_FAIL_GROUP_cpu1_tlb_mbist_fail_G_mask                              (0x00000001)
+#define CPU1_BIST_FAIL_GROUP_cpu1_tlb_mbist_fail_G(data)                             (0x00000001&((data)<<0))
+#define CPU1_BIST_FAIL_GROUP_cpu1_tlb_mbist_fail_G_src(data)                         ((0x00000001&(data))>>0)
+#define CPU1_BIST_FAIL_GROUP_get_cpu1_tlb_mbist_fail_G(data)                         ((0x00000001&(data))>>0)
+
+
+#define CPU0_DRF_BIST_FAIL_GROUP                                                     0x1801D320
+#define CPU0_DRF_BIST_FAIL_GROUP_reg_addr                                            "0xB801D320"
+#define CPU0_DRF_BIST_FAIL_GROUP_reg                                                 0xB801D320
+#define set_CPU0_DRF_BIST_FAIL_GROUP_reg(data)   (*((volatile unsigned int*) CPU0_DRF_BIST_FAIL_GROUP_reg)=data)
+#define get_CPU0_DRF_BIST_FAIL_GROUP_reg   (*((volatile unsigned int*) CPU0_DRF_BIST_FAIL_GROUP_reg))
+#define CPU0_DRF_BIST_FAIL_GROUP_inst_adr                                            "0x00C8"
+#define CPU0_DRF_BIST_FAIL_GROUP_inst                                                0x00C8
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_scu_drf_mbist_fail_G_shift                     (6)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_scu_drf_mbist_fail_G_mask                      (0x00000040)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_scu_drf_mbist_fail_G(data)                     (0x00000040&((data)<<6))
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_scu_drf_mbist_fail_G_src(data)                 ((0x00000040&(data))>>6)
+#define CPU0_DRF_BIST_FAIL_GROUP_get_cpu0_scu_drf_mbist_fail_G(data)                 ((0x00000040&(data))>>6)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_idata_drf_mbist_fail_G_shift                   (5)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_idata_drf_mbist_fail_G_mask                    (0x00000020)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_idata_drf_mbist_fail_G(data)                   (0x00000020&((data)<<5))
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_idata_drf_mbist_fail_G_src(data)               ((0x00000020&(data))>>5)
+#define CPU0_DRF_BIST_FAIL_GROUP_get_cpu0_idata_drf_mbist_fail_G(data)               ((0x00000020&(data))>>5)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_itag_drf_mbist_fail_G_shift                    (4)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_itag_drf_mbist_fail_G_mask                     (0x00000010)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_itag_drf_mbist_fail_G(data)                    (0x00000010&((data)<<4))
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_itag_drf_mbist_fail_G_src(data)                ((0x00000010&(data))>>4)
+#define CPU0_DRF_BIST_FAIL_GROUP_get_cpu0_itag_drf_mbist_fail_G(data)                ((0x00000010&(data))>>4)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_ddata_drf_mbist_fail_G_shift                   (3)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_ddata_drf_mbist_fail_G_mask                    (0x00000008)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_ddata_drf_mbist_fail_G(data)                   (0x00000008&((data)<<3))
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_ddata_drf_mbist_fail_G_src(data)               ((0x00000008&(data))>>3)
+#define CPU0_DRF_BIST_FAIL_GROUP_get_cpu0_ddata_drf_mbist_fail_G(data)               ((0x00000008&(data))>>3)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_dtag_drf_mbist_fail_G_shift                    (2)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_dtag_drf_mbist_fail_G_mask                     (0x00000004)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_dtag_drf_mbist_fail_G(data)                    (0x00000004&((data)<<2))
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_dtag_drf_mbist_fail_G_src(data)                ((0x00000004&(data))>>2)
+#define CPU0_DRF_BIST_FAIL_GROUP_get_cpu0_dtag_drf_mbist_fail_G(data)                ((0x00000004&(data))>>2)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_ddrity_drf_mbist_fail_G_shift                  (1)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_ddrity_drf_mbist_fail_G_mask                   (0x00000002)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_ddrity_drf_mbist_fail_G(data)                  (0x00000002&((data)<<1))
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_ddrity_drf_mbist_fail_G_src(data)              ((0x00000002&(data))>>1)
+#define CPU0_DRF_BIST_FAIL_GROUP_get_cpu0_ddrity_drf_mbist_fail_G(data)              ((0x00000002&(data))>>1)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_tlb_drf_mbist_fail_G_shift                     (0)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_tlb_drf_mbist_fail_G_mask                      (0x00000001)
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_tlb_drf_mbist_fail_G(data)                     (0x00000001&((data)<<0))
+#define CPU0_DRF_BIST_FAIL_GROUP_cpu0_tlb_drf_mbist_fail_G_src(data)                 ((0x00000001&(data))>>0)
+#define CPU0_DRF_BIST_FAIL_GROUP_get_cpu0_tlb_drf_mbist_fail_G(data)                 ((0x00000001&(data))>>0)
+
+
+#define CPU1_DRF_BIST_FAIL_GROUP                                                     0x1801D324
+#define CPU1_DRF_BIST_FAIL_GROUP_reg_addr                                            "0xB801D324"
+#define CPU1_DRF_BIST_FAIL_GROUP_reg                                                 0xB801D324
+#define set_CPU1_DRF_BIST_FAIL_GROUP_reg(data)   (*((volatile unsigned int*) CPU1_DRF_BIST_FAIL_GROUP_reg)=data)
+#define get_CPU1_DRF_BIST_FAIL_GROUP_reg   (*((volatile unsigned int*) CPU1_DRF_BIST_FAIL_GROUP_reg))
+#define CPU1_DRF_BIST_FAIL_GROUP_inst_adr                                            "0x00C9"
+#define CPU1_DRF_BIST_FAIL_GROUP_inst                                                0x00C9
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_scu_drf_mbist_fail_G_shift                     (6)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_scu_drf_mbist_fail_G_mask                      (0x00000040)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_scu_drf_mbist_fail_G(data)                     (0x00000040&((data)<<6))
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_scu_drf_mbist_fail_G_src(data)                 ((0x00000040&(data))>>6)
+#define CPU1_DRF_BIST_FAIL_GROUP_get_cpu1_scu_drf_mbist_fail_G(data)                 ((0x00000040&(data))>>6)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_idata_drf_mbist_fail_G_shift                   (5)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_idata_drf_mbist_fail_G_mask                    (0x00000020)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_idata_drf_mbist_fail_G(data)                   (0x00000020&((data)<<5))
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_idata_drf_mbist_fail_G_src(data)               ((0x00000020&(data))>>5)
+#define CPU1_DRF_BIST_FAIL_GROUP_get_cpu1_idata_drf_mbist_fail_G(data)               ((0x00000020&(data))>>5)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_itag_drf_mbist_fail_G_shift                    (4)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_itag_drf_mbist_fail_G_mask                     (0x00000010)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_itag_drf_mbist_fail_G(data)                    (0x00000010&((data)<<4))
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_itag_drf_mbist_fail_G_src(data)                ((0x00000010&(data))>>4)
+#define CPU1_DRF_BIST_FAIL_GROUP_get_cpu1_itag_drf_mbist_fail_G(data)                ((0x00000010&(data))>>4)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_ddata_drf_mbist_fail_G_shift                   (3)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_ddata_drf_mbist_fail_G_mask                    (0x00000008)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_ddata_drf_mbist_fail_G(data)                   (0x00000008&((data)<<3))
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_ddata_drf_mbist_fail_G_src(data)               ((0x00000008&(data))>>3)
+#define CPU1_DRF_BIST_FAIL_GROUP_get_cpu1_ddata_drf_mbist_fail_G(data)               ((0x00000008&(data))>>3)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_dtag_drf_mbist_fail_G_shift                    (2)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_dtag_drf_mbist_fail_G_mask                     (0x00000004)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_dtag_drf_mbist_fail_G(data)                    (0x00000004&((data)<<2))
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_dtag_drf_mbist_fail_G_src(data)                ((0x00000004&(data))>>2)
+#define CPU1_DRF_BIST_FAIL_GROUP_get_cpu1_dtag_drf_mbist_fail_G(data)                ((0x00000004&(data))>>2)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_ddrity_drf_mbist_fail_G_shift                  (1)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_ddrity_drf_mbist_fail_G_mask                   (0x00000002)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_ddrity_drf_mbist_fail_G(data)                  (0x00000002&((data)<<1))
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_ddrity_drf_mbist_fail_G_src(data)              ((0x00000002&(data))>>1)
+#define CPU1_DRF_BIST_FAIL_GROUP_get_cpu1_ddrity_drf_mbist_fail_G(data)              ((0x00000002&(data))>>1)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_tlb_drf_mbist_fail_G_shift                     (0)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_tlb_drf_mbist_fail_G_mask                      (0x00000001)
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_tlb_drf_mbist_fail_G(data)                     (0x00000001&((data)<<0))
+#define CPU1_DRF_BIST_FAIL_GROUP_cpu1_tlb_drf_mbist_fail_G_src(data)                 ((0x00000001&(data))>>0)
+#define CPU1_DRF_BIST_FAIL_GROUP_get_cpu1_tlb_drf_mbist_fail_G(data)                 ((0x00000001&(data))>>0)
+
+
+#define CPU0_IDATA_BIST_FAIL                                                         0x1801D328
+#define CPU0_IDATA_BIST_FAIL_reg_addr                                                "0xB801D328"
+#define CPU0_IDATA_BIST_FAIL_reg                                                     0xB801D328
+#define set_CPU0_IDATA_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_IDATA_BIST_FAIL_reg)=data)
+#define get_CPU0_IDATA_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_IDATA_BIST_FAIL_reg))
+#define CPU0_IDATA_BIST_FAIL_inst_adr                                                "0x00CA"
+#define CPU0_IDATA_BIST_FAIL_inst                                                    0x00CA
+#define CPU0_IDATA_BIST_FAIL_cpu0_idata_mbist_fail_shift                             (0)
+#define CPU0_IDATA_BIST_FAIL_cpu0_idata_mbist_fail_mask                              (0x00000003)
+#define CPU0_IDATA_BIST_FAIL_cpu0_idata_mbist_fail(data)                             (0x00000003&((data)<<0))
+#define CPU0_IDATA_BIST_FAIL_cpu0_idata_mbist_fail_src(data)                         ((0x00000003&(data))>>0)
+#define CPU0_IDATA_BIST_FAIL_get_cpu0_idata_mbist_fail(data)                         ((0x00000003&(data))>>0)
+
+
+#define CPU1_IDATA_BIST_FAIL                                                         0x1801D32C
+#define CPU1_IDATA_BIST_FAIL_reg_addr                                                "0xB801D32C"
+#define CPU1_IDATA_BIST_FAIL_reg                                                     0xB801D32C
+#define set_CPU1_IDATA_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_IDATA_BIST_FAIL_reg)=data)
+#define get_CPU1_IDATA_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_IDATA_BIST_FAIL_reg))
+#define CPU1_IDATA_BIST_FAIL_inst_adr                                                "0x00CB"
+#define CPU1_IDATA_BIST_FAIL_inst                                                    0x00CB
+#define CPU1_IDATA_BIST_FAIL_cpu1_idata_mbist_fail_shift                             (0)
+#define CPU1_IDATA_BIST_FAIL_cpu1_idata_mbist_fail_mask                              (0x00000003)
+#define CPU1_IDATA_BIST_FAIL_cpu1_idata_mbist_fail(data)                             (0x00000003&((data)<<0))
+#define CPU1_IDATA_BIST_FAIL_cpu1_idata_mbist_fail_src(data)                         ((0x00000003&(data))>>0)
+#define CPU1_IDATA_BIST_FAIL_get_cpu1_idata_mbist_fail(data)                         ((0x00000003&(data))>>0)
+
+
+#define CPU0_IDATA_DRF_BIST_FAIL                                                     0x1801D330
+#define CPU0_IDATA_DRF_BIST_FAIL_reg_addr                                            "0xB801D330"
+#define CPU0_IDATA_DRF_BIST_FAIL_reg                                                 0xB801D330
+#define set_CPU0_IDATA_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_IDATA_DRF_BIST_FAIL_reg)=data)
+#define get_CPU0_IDATA_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_IDATA_DRF_BIST_FAIL_reg))
+#define CPU0_IDATA_DRF_BIST_FAIL_inst_adr                                            "0x00CC"
+#define CPU0_IDATA_DRF_BIST_FAIL_inst                                                0x00CC
+#define CPU0_IDATA_DRF_BIST_FAIL_cpu0_idata_drf_mbist_fail_shift                     (0)
+#define CPU0_IDATA_DRF_BIST_FAIL_cpu0_idata_drf_mbist_fail_mask                      (0x00000003)
+#define CPU0_IDATA_DRF_BIST_FAIL_cpu0_idata_drf_mbist_fail(data)                     (0x00000003&((data)<<0))
+#define CPU0_IDATA_DRF_BIST_FAIL_cpu0_idata_drf_mbist_fail_src(data)                 ((0x00000003&(data))>>0)
+#define CPU0_IDATA_DRF_BIST_FAIL_get_cpu0_idata_drf_mbist_fail(data)                 ((0x00000003&(data))>>0)
+
+
+#define CPU1_IDATA_DRF_BIST_FAIL                                                     0x1801D334
+#define CPU1_IDATA_DRF_BIST_FAIL_reg_addr                                            "0xB801D334"
+#define CPU1_IDATA_DRF_BIST_FAIL_reg                                                 0xB801D334
+#define set_CPU1_IDATA_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_IDATA_DRF_BIST_FAIL_reg)=data)
+#define get_CPU1_IDATA_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_IDATA_DRF_BIST_FAIL_reg))
+#define CPU1_IDATA_DRF_BIST_FAIL_inst_adr                                            "0x00CD"
+#define CPU1_IDATA_DRF_BIST_FAIL_inst                                                0x00CD
+#define CPU1_IDATA_DRF_BIST_FAIL_cpu1_idata_drf_mbist_fail_shift                     (0)
+#define CPU1_IDATA_DRF_BIST_FAIL_cpu1_idata_drf_mbist_fail_mask                      (0x00000003)
+#define CPU1_IDATA_DRF_BIST_FAIL_cpu1_idata_drf_mbist_fail(data)                     (0x00000003&((data)<<0))
+#define CPU1_IDATA_DRF_BIST_FAIL_cpu1_idata_drf_mbist_fail_src(data)                 ((0x00000003&(data))>>0)
+#define CPU1_IDATA_DRF_BIST_FAIL_get_cpu1_idata_drf_mbist_fail(data)                 ((0x00000003&(data))>>0)
+
+
+#define CPU0_ITAG_BIST_FAIL                                                          0x1801D338
+#define CPU0_ITAG_BIST_FAIL_reg_addr                                                 "0xB801D338"
+#define CPU0_ITAG_BIST_FAIL_reg                                                      0xB801D338
+#define set_CPU0_ITAG_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_ITAG_BIST_FAIL_reg)=data)
+#define get_CPU0_ITAG_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_ITAG_BIST_FAIL_reg))
+#define CPU0_ITAG_BIST_FAIL_inst_adr                                                 "0x00CE"
+#define CPU0_ITAG_BIST_FAIL_inst                                                     0x00CE
+#define CPU0_ITAG_BIST_FAIL_cpu0_itag_mbist_fail_shift                               (0)
+#define CPU0_ITAG_BIST_FAIL_cpu0_itag_mbist_fail_mask                                (0x00000003)
+#define CPU0_ITAG_BIST_FAIL_cpu0_itag_mbist_fail(data)                               (0x00000003&((data)<<0))
+#define CPU0_ITAG_BIST_FAIL_cpu0_itag_mbist_fail_src(data)                           ((0x00000003&(data))>>0)
+#define CPU0_ITAG_BIST_FAIL_get_cpu0_itag_mbist_fail(data)                           ((0x00000003&(data))>>0)
+
+
+#define CPU1_ITAG_BIST_FAIL                                                          0x1801D33C
+#define CPU1_ITAG_BIST_FAIL_reg_addr                                                 "0xB801D33C"
+#define CPU1_ITAG_BIST_FAIL_reg                                                      0xB801D33C
+#define set_CPU1_ITAG_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_ITAG_BIST_FAIL_reg)=data)
+#define get_CPU1_ITAG_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_ITAG_BIST_FAIL_reg))
+#define CPU1_ITAG_BIST_FAIL_inst_adr                                                 "0x00CF"
+#define CPU1_ITAG_BIST_FAIL_inst                                                     0x00CF
+#define CPU1_ITAG_BIST_FAIL_cpu1_itag_mbist_fail_shift                               (0)
+#define CPU1_ITAG_BIST_FAIL_cpu1_itag_mbist_fail_mask                                (0x00000003)
+#define CPU1_ITAG_BIST_FAIL_cpu1_itag_mbist_fail(data)                               (0x00000003&((data)<<0))
+#define CPU1_ITAG_BIST_FAIL_cpu1_itag_mbist_fail_src(data)                           ((0x00000003&(data))>>0)
+#define CPU1_ITAG_BIST_FAIL_get_cpu1_itag_mbist_fail(data)                           ((0x00000003&(data))>>0)
+
+
+#define CPU0_ITAG_DRF_BIST_FAIL                                                      0x1801D340
+#define CPU0_ITAG_DRF_BIST_FAIL_reg_addr                                             "0xB801D340"
+#define CPU0_ITAG_DRF_BIST_FAIL_reg                                                  0xB801D340
+#define set_CPU0_ITAG_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_ITAG_DRF_BIST_FAIL_reg)=data)
+#define get_CPU0_ITAG_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_ITAG_DRF_BIST_FAIL_reg))
+#define CPU0_ITAG_DRF_BIST_FAIL_inst_adr                                             "0x00D0"
+#define CPU0_ITAG_DRF_BIST_FAIL_inst                                                 0x00D0
+#define CPU0_ITAG_DRF_BIST_FAIL_cpu0_itag_drf_mbist_fail_shift                       (0)
+#define CPU0_ITAG_DRF_BIST_FAIL_cpu0_itag_drf_mbist_fail_mask                        (0x00000003)
+#define CPU0_ITAG_DRF_BIST_FAIL_cpu0_itag_drf_mbist_fail(data)                       (0x00000003&((data)<<0))
+#define CPU0_ITAG_DRF_BIST_FAIL_cpu0_itag_drf_mbist_fail_src(data)                   ((0x00000003&(data))>>0)
+#define CPU0_ITAG_DRF_BIST_FAIL_get_cpu0_itag_drf_mbist_fail(data)                   ((0x00000003&(data))>>0)
+
+
+#define CPU1_ITAG_DRF_BIST_FAIL                                                      0x1801D344
+#define CPU1_ITAG_DRF_BIST_FAIL_reg_addr                                             "0xB801D344"
+#define CPU1_ITAG_DRF_BIST_FAIL_reg                                                  0xB801D344
+#define set_CPU1_ITAG_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_ITAG_DRF_BIST_FAIL_reg)=data)
+#define get_CPU1_ITAG_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_ITAG_DRF_BIST_FAIL_reg))
+#define CPU1_ITAG_DRF_BIST_FAIL_inst_adr                                             "0x00D1"
+#define CPU1_ITAG_DRF_BIST_FAIL_inst                                                 0x00D1
+#define CPU1_ITAG_DRF_BIST_FAIL_cpu1_itag_drf_mbist_fail_shift                       (0)
+#define CPU1_ITAG_DRF_BIST_FAIL_cpu1_itag_drf_mbist_fail_mask                        (0x00000003)
+#define CPU1_ITAG_DRF_BIST_FAIL_cpu1_itag_drf_mbist_fail(data)                       (0x00000003&((data)<<0))
+#define CPU1_ITAG_DRF_BIST_FAIL_cpu1_itag_drf_mbist_fail_src(data)                   ((0x00000003&(data))>>0)
+#define CPU1_ITAG_DRF_BIST_FAIL_get_cpu1_itag_drf_mbist_fail(data)                   ((0x00000003&(data))>>0)
+
+
+#define CPU0_DDATA_BIST_FAIL                                                         0x1801D348
+#define CPU0_DDATA_BIST_FAIL_reg_addr                                                "0xB801D348"
+#define CPU0_DDATA_BIST_FAIL_reg                                                     0xB801D348
+#define set_CPU0_DDATA_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_DDATA_BIST_FAIL_reg)=data)
+#define get_CPU0_DDATA_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_DDATA_BIST_FAIL_reg))
+#define CPU0_DDATA_BIST_FAIL_inst_adr                                                "0x00D2"
+#define CPU0_DDATA_BIST_FAIL_inst                                                    0x00D2
+#define CPU0_DDATA_BIST_FAIL_cpu0_ddata_mbist_fail_shift                             (0)
+#define CPU0_DDATA_BIST_FAIL_cpu0_ddata_mbist_fail_mask                              (0x000000FF)
+#define CPU0_DDATA_BIST_FAIL_cpu0_ddata_mbist_fail(data)                             (0x000000FF&((data)<<0))
+#define CPU0_DDATA_BIST_FAIL_cpu0_ddata_mbist_fail_src(data)                         ((0x000000FF&(data))>>0)
+#define CPU0_DDATA_BIST_FAIL_get_cpu0_ddata_mbist_fail(data)                         ((0x000000FF&(data))>>0)
+
+
+#define CPU1_DDATA_BIST_FAIL                                                         0x1801D34C
+#define CPU1_DDATA_BIST_FAIL_reg_addr                                                "0xB801D34C"
+#define CPU1_DDATA_BIST_FAIL_reg                                                     0xB801D34C
+#define set_CPU1_DDATA_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_DDATA_BIST_FAIL_reg)=data)
+#define get_CPU1_DDATA_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_DDATA_BIST_FAIL_reg))
+#define CPU1_DDATA_BIST_FAIL_inst_adr                                                "0x00D3"
+#define CPU1_DDATA_BIST_FAIL_inst                                                    0x00D3
+#define CPU1_DDATA_BIST_FAIL_cpu1_ddata_mbist_fail_shift                             (0)
+#define CPU1_DDATA_BIST_FAIL_cpu1_ddata_mbist_fail_mask                              (0x000000FF)
+#define CPU1_DDATA_BIST_FAIL_cpu1_ddata_mbist_fail(data)                             (0x000000FF&((data)<<0))
+#define CPU1_DDATA_BIST_FAIL_cpu1_ddata_mbist_fail_src(data)                         ((0x000000FF&(data))>>0)
+#define CPU1_DDATA_BIST_FAIL_get_cpu1_ddata_mbist_fail(data)                         ((0x000000FF&(data))>>0)
+
+
+#define CPU0_DDATA_DRF_BIST_FAIL                                                     0x1801D350
+#define CPU0_DDATA_DRF_BIST_FAIL_reg_addr                                            "0xB801D350"
+#define CPU0_DDATA_DRF_BIST_FAIL_reg                                                 0xB801D350
+#define set_CPU0_DDATA_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_DDATA_DRF_BIST_FAIL_reg)=data)
+#define get_CPU0_DDATA_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_DDATA_DRF_BIST_FAIL_reg))
+#define CPU0_DDATA_DRF_BIST_FAIL_inst_adr                                            "0x00D4"
+#define CPU0_DDATA_DRF_BIST_FAIL_inst                                                0x00D4
+#define CPU0_DDATA_DRF_BIST_FAIL_cpu0_ddata_drf_mbist_fail_shift                     (0)
+#define CPU0_DDATA_DRF_BIST_FAIL_cpu0_ddata_drf_mbist_fail_mask                      (0x000000FF)
+#define CPU0_DDATA_DRF_BIST_FAIL_cpu0_ddata_drf_mbist_fail(data)                     (0x000000FF&((data)<<0))
+#define CPU0_DDATA_DRF_BIST_FAIL_cpu0_ddata_drf_mbist_fail_src(data)                 ((0x000000FF&(data))>>0)
+#define CPU0_DDATA_DRF_BIST_FAIL_get_cpu0_ddata_drf_mbist_fail(data)                 ((0x000000FF&(data))>>0)
+
+
+#define CPU1_DDATA_DRF_BIST_FAIL                                                     0x1801D354
+#define CPU1_DDATA_DRF_BIST_FAIL_reg_addr                                            "0xB801D354"
+#define CPU1_DDATA_DRF_BIST_FAIL_reg                                                 0xB801D354
+#define set_CPU1_DDATA_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_DDATA_DRF_BIST_FAIL_reg)=data)
+#define get_CPU1_DDATA_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_DDATA_DRF_BIST_FAIL_reg))
+#define CPU1_DDATA_DRF_BIST_FAIL_inst_adr                                            "0x00D5"
+#define CPU1_DDATA_DRF_BIST_FAIL_inst                                                0x00D5
+#define CPU1_DDATA_DRF_BIST_FAIL_cpu1_ddata_drf_mbist_fail_shift                     (0)
+#define CPU1_DDATA_DRF_BIST_FAIL_cpu1_ddata_drf_mbist_fail_mask                      (0x000000FF)
+#define CPU1_DDATA_DRF_BIST_FAIL_cpu1_ddata_drf_mbist_fail(data)                     (0x000000FF&((data)<<0))
+#define CPU1_DDATA_DRF_BIST_FAIL_cpu1_ddata_drf_mbist_fail_src(data)                 ((0x000000FF&(data))>>0)
+#define CPU1_DDATA_DRF_BIST_FAIL_get_cpu1_ddata_drf_mbist_fail(data)                 ((0x000000FF&(data))>>0)
+
+
+#define CPU0_DTAG_BIST_FAIL                                                          0x1801D358
+#define CPU0_DTAG_BIST_FAIL_reg_addr                                                 "0xB801D358"
+#define CPU0_DTAG_BIST_FAIL_reg                                                      0xB801D358
+#define set_CPU0_DTAG_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_DTAG_BIST_FAIL_reg)=data)
+#define get_CPU0_DTAG_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_DTAG_BIST_FAIL_reg))
+#define CPU0_DTAG_BIST_FAIL_inst_adr                                                 "0x00D6"
+#define CPU0_DTAG_BIST_FAIL_inst                                                     0x00D6
+#define CPU0_DTAG_BIST_FAIL_cpu0_dtag_mbist_fail_shift                               (0)
+#define CPU0_DTAG_BIST_FAIL_cpu0_dtag_mbist_fail_mask                                (0x0000000F)
+#define CPU0_DTAG_BIST_FAIL_cpu0_dtag_mbist_fail(data)                               (0x0000000F&((data)<<0))
+#define CPU0_DTAG_BIST_FAIL_cpu0_dtag_mbist_fail_src(data)                           ((0x0000000F&(data))>>0)
+#define CPU0_DTAG_BIST_FAIL_get_cpu0_dtag_mbist_fail(data)                           ((0x0000000F&(data))>>0)
+
+
+#define CPU1_DTAG_BIST_FAIL                                                          0x1801D35C
+#define CPU1_DTAG_BIST_FAIL_reg_addr                                                 "0xB801D35C"
+#define CPU1_DTAG_BIST_FAIL_reg                                                      0xB801D35C
+#define set_CPU1_DTAG_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_DTAG_BIST_FAIL_reg)=data)
+#define get_CPU1_DTAG_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_DTAG_BIST_FAIL_reg))
+#define CPU1_DTAG_BIST_FAIL_inst_adr                                                 "0x00D7"
+#define CPU1_DTAG_BIST_FAIL_inst                                                     0x00D7
+#define CPU1_DTAG_BIST_FAIL_cpu1_dtag_mbist_fail_shift                               (0)
+#define CPU1_DTAG_BIST_FAIL_cpu1_dtag_mbist_fail_mask                                (0x0000000F)
+#define CPU1_DTAG_BIST_FAIL_cpu1_dtag_mbist_fail(data)                               (0x0000000F&((data)<<0))
+#define CPU1_DTAG_BIST_FAIL_cpu1_dtag_mbist_fail_src(data)                           ((0x0000000F&(data))>>0)
+#define CPU1_DTAG_BIST_FAIL_get_cpu1_dtag_mbist_fail(data)                           ((0x0000000F&(data))>>0)
+
+
+#define CPU0_DTAG_DRF_BIST_FAIL                                                      0x1801D360
+#define CPU0_DTAG_DRF_BIST_FAIL_reg_addr                                             "0xB801D360"
+#define CPU0_DTAG_DRF_BIST_FAIL_reg                                                  0xB801D360
+#define set_CPU0_DTAG_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_DTAG_DRF_BIST_FAIL_reg)=data)
+#define get_CPU0_DTAG_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_DTAG_DRF_BIST_FAIL_reg))
+#define CPU0_DTAG_DRF_BIST_FAIL_inst_adr                                             "0x00D8"
+#define CPU0_DTAG_DRF_BIST_FAIL_inst                                                 0x00D8
+#define CPU0_DTAG_DRF_BIST_FAIL_cpu0_dtag_drf_mbist_fail_shift                       (0)
+#define CPU0_DTAG_DRF_BIST_FAIL_cpu0_dtag_drf_mbist_fail_mask                        (0x0000000F)
+#define CPU0_DTAG_DRF_BIST_FAIL_cpu0_dtag_drf_mbist_fail(data)                       (0x0000000F&((data)<<0))
+#define CPU0_DTAG_DRF_BIST_FAIL_cpu0_dtag_drf_mbist_fail_src(data)                   ((0x0000000F&(data))>>0)
+#define CPU0_DTAG_DRF_BIST_FAIL_get_cpu0_dtag_drf_mbist_fail(data)                   ((0x0000000F&(data))>>0)
+
+
+#define CPU1_DTAG_DRF_BIST_FAIL                                                      0x1801D364
+#define CPU1_DTAG_DRF_BIST_FAIL_reg_addr                                             "0xB801D364"
+#define CPU1_DTAG_DRF_BIST_FAIL_reg                                                  0xB801D364
+#define set_CPU1_DTAG_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_DTAG_DRF_BIST_FAIL_reg)=data)
+#define get_CPU1_DTAG_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_DTAG_DRF_BIST_FAIL_reg))
+#define CPU1_DTAG_DRF_BIST_FAIL_inst_adr                                             "0x00D9"
+#define CPU1_DTAG_DRF_BIST_FAIL_inst                                                 0x00D9
+#define CPU1_DTAG_DRF_BIST_FAIL_cpu1_dtag_drf_mbist_fail_shift                       (0)
+#define CPU1_DTAG_DRF_BIST_FAIL_cpu1_dtag_drf_mbist_fail_mask                        (0x0000000F)
+#define CPU1_DTAG_DRF_BIST_FAIL_cpu1_dtag_drf_mbist_fail(data)                       (0x0000000F&((data)<<0))
+#define CPU1_DTAG_DRF_BIST_FAIL_cpu1_dtag_drf_mbist_fail_src(data)                   ((0x0000000F&(data))>>0)
+#define CPU1_DTAG_DRF_BIST_FAIL_get_cpu1_dtag_drf_mbist_fail(data)                   ((0x0000000F&(data))>>0)
+
+
+#define CPU0_DDRITY_BIST_FAIL                                                        0x1801D368
+#define CPU0_DDRITY_BIST_FAIL_reg_addr                                               "0xB801D368"
+#define CPU0_DDRITY_BIST_FAIL_reg                                                    0xB801D368
+#define set_CPU0_DDRITY_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_DDRITY_BIST_FAIL_reg)=data)
+#define get_CPU0_DDRITY_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_DDRITY_BIST_FAIL_reg))
+#define CPU0_DDRITY_BIST_FAIL_inst_adr                                               "0x00DA"
+#define CPU0_DDRITY_BIST_FAIL_inst                                                   0x00DA
+#define CPU0_DDRITY_BIST_FAIL_cpu0_ddrity_mbist_fail_shift                           (0)
+#define CPU0_DDRITY_BIST_FAIL_cpu0_ddrity_mbist_fail_mask                            (0x00000001)
+#define CPU0_DDRITY_BIST_FAIL_cpu0_ddrity_mbist_fail(data)                           (0x00000001&((data)<<0))
+#define CPU0_DDRITY_BIST_FAIL_cpu0_ddrity_mbist_fail_src(data)                       ((0x00000001&(data))>>0)
+#define CPU0_DDRITY_BIST_FAIL_get_cpu0_ddrity_mbist_fail(data)                       ((0x00000001&(data))>>0)
+
+
+#define CPU1_DDRITY_BIST_FAIL                                                        0x1801D36C
+#define CPU1_DDRITY_BIST_FAIL_reg_addr                                               "0xB801D36C"
+#define CPU1_DDRITY_BIST_FAIL_reg                                                    0xB801D36C
+#define set_CPU1_DDRITY_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_DDRITY_BIST_FAIL_reg)=data)
+#define get_CPU1_DDRITY_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_DDRITY_BIST_FAIL_reg))
+#define CPU1_DDRITY_BIST_FAIL_inst_adr                                               "0x00DB"
+#define CPU1_DDRITY_BIST_FAIL_inst                                                   0x00DB
+#define CPU1_DDRITY_BIST_FAIL_cpu1_ddrity_mbist_fail_shift                           (0)
+#define CPU1_DDRITY_BIST_FAIL_cpu1_ddrity_mbist_fail_mask                            (0x00000001)
+#define CPU1_DDRITY_BIST_FAIL_cpu1_ddrity_mbist_fail(data)                           (0x00000001&((data)<<0))
+#define CPU1_DDRITY_BIST_FAIL_cpu1_ddrity_mbist_fail_src(data)                       ((0x00000001&(data))>>0)
+#define CPU1_DDRITY_BIST_FAIL_get_cpu1_ddrity_mbist_fail(data)                       ((0x00000001&(data))>>0)
+
+
+#define CPU0_DDRITY_DRF_BIST_FAIL                                                    0x1801D370
+#define CPU0_DDRITY_DRF_BIST_FAIL_reg_addr                                           "0xB801D370"
+#define CPU0_DDRITY_DRF_BIST_FAIL_reg                                                0xB801D370
+#define set_CPU0_DDRITY_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_DDRITY_DRF_BIST_FAIL_reg)=data)
+#define get_CPU0_DDRITY_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_DDRITY_DRF_BIST_FAIL_reg))
+#define CPU0_DDRITY_DRF_BIST_FAIL_inst_adr                                           "0x00DC"
+#define CPU0_DDRITY_DRF_BIST_FAIL_inst                                               0x00DC
+#define CPU0_DDRITY_DRF_BIST_FAIL_cpu0_ddrity_drf_mbist_fail_shift                   (0)
+#define CPU0_DDRITY_DRF_BIST_FAIL_cpu0_ddrity_drf_mbist_fail_mask                    (0x00000001)
+#define CPU0_DDRITY_DRF_BIST_FAIL_cpu0_ddrity_drf_mbist_fail(data)                   (0x00000001&((data)<<0))
+#define CPU0_DDRITY_DRF_BIST_FAIL_cpu0_ddrity_drf_mbist_fail_src(data)               ((0x00000001&(data))>>0)
+#define CPU0_DDRITY_DRF_BIST_FAIL_get_cpu0_ddrity_drf_mbist_fail(data)               ((0x00000001&(data))>>0)
+
+
+#define CPU1_DDRITY_DRF_BIST_FAIL                                                    0x1801D374
+#define CPU1_DDRITY_DRF_BIST_FAIL_reg_addr                                           "0xB801D374"
+#define CPU1_DDRITY_DRF_BIST_FAIL_reg                                                0xB801D374
+#define set_CPU1_DDRITY_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_DDRITY_DRF_BIST_FAIL_reg)=data)
+#define get_CPU1_DDRITY_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_DDRITY_DRF_BIST_FAIL_reg))
+#define CPU1_DDRITY_DRF_BIST_FAIL_inst_adr                                           "0x00DD"
+#define CPU1_DDRITY_DRF_BIST_FAIL_inst                                               0x00DD
+#define CPU1_DDRITY_DRF_BIST_FAIL_cpu1_ddrity_drf_mbist_fail_shift                   (0)
+#define CPU1_DDRITY_DRF_BIST_FAIL_cpu1_ddrity_drf_mbist_fail_mask                    (0x00000001)
+#define CPU1_DDRITY_DRF_BIST_FAIL_cpu1_ddrity_drf_mbist_fail(data)                   (0x00000001&((data)<<0))
+#define CPU1_DDRITY_DRF_BIST_FAIL_cpu1_ddrity_drf_mbist_fail_src(data)               ((0x00000001&(data))>>0)
+#define CPU1_DDRITY_DRF_BIST_FAIL_get_cpu1_ddrity_drf_mbist_fail(data)               ((0x00000001&(data))>>0)
+
+
+#define CPU0_SCU_BIST_FAIL                                                           0x1801D378
+#define CPU0_SCU_BIST_FAIL_reg_addr                                                  "0xB801D378"
+#define CPU0_SCU_BIST_FAIL_reg                                                       0xB801D378
+#define set_CPU0_SCU_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_SCU_BIST_FAIL_reg)=data)
+#define get_CPU0_SCU_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_SCU_BIST_FAIL_reg))
+#define CPU0_SCU_BIST_FAIL_inst_adr                                                  "0x00DE"
+#define CPU0_SCU_BIST_FAIL_inst                                                      0x00DE
+#define CPU0_SCU_BIST_FAIL_cpu0_scu_mbist_fail_shift                                 (0)
+#define CPU0_SCU_BIST_FAIL_cpu0_scu_mbist_fail_mask                                  (0x0000000F)
+#define CPU0_SCU_BIST_FAIL_cpu0_scu_mbist_fail(data)                                 (0x0000000F&((data)<<0))
+#define CPU0_SCU_BIST_FAIL_cpu0_scu_mbist_fail_src(data)                             ((0x0000000F&(data))>>0)
+#define CPU0_SCU_BIST_FAIL_get_cpu0_scu_mbist_fail(data)                             ((0x0000000F&(data))>>0)
+
+
+#define CPU1_SCU_BIST_FAIL                                                           0x1801D37C
+#define CPU1_SCU_BIST_FAIL_reg_addr                                                  "0xB801D37C"
+#define CPU1_SCU_BIST_FAIL_reg                                                       0xB801D37C
+#define set_CPU1_SCU_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_SCU_BIST_FAIL_reg)=data)
+#define get_CPU1_SCU_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_SCU_BIST_FAIL_reg))
+#define CPU1_SCU_BIST_FAIL_inst_adr                                                  "0x00DF"
+#define CPU1_SCU_BIST_FAIL_inst                                                      0x00DF
+#define CPU1_SCU_BIST_FAIL_cpu1_scu_mbist_fail_shift                                 (0)
+#define CPU1_SCU_BIST_FAIL_cpu1_scu_mbist_fail_mask                                  (0x0000000F)
+#define CPU1_SCU_BIST_FAIL_cpu1_scu_mbist_fail(data)                                 (0x0000000F&((data)<<0))
+#define CPU1_SCU_BIST_FAIL_cpu1_scu_mbist_fail_src(data)                             ((0x0000000F&(data))>>0)
+#define CPU1_SCU_BIST_FAIL_get_cpu1_scu_mbist_fail(data)                             ((0x0000000F&(data))>>0)
+
+
+#define CPU0_SCU_DRF_BIST_FAIL                                                       0x1801D380
+#define CPU0_SCU_DRF_BIST_FAIL_reg_addr                                              "0xB801D380"
+#define CPU0_SCU_DRF_BIST_FAIL_reg                                                   0xB801D380
+#define set_CPU0_SCU_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_SCU_DRF_BIST_FAIL_reg)=data)
+#define get_CPU0_SCU_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_SCU_DRF_BIST_FAIL_reg))
+#define CPU0_SCU_DRF_BIST_FAIL_inst_adr                                              "0x00E0"
+#define CPU0_SCU_DRF_BIST_FAIL_inst                                                  0x00E0
+#define CPU0_SCU_DRF_BIST_FAIL_cpu0_scu_drf_mbist_fail_shift                         (0)
+#define CPU0_SCU_DRF_BIST_FAIL_cpu0_scu_drf_mbist_fail_mask                          (0x0000000F)
+#define CPU0_SCU_DRF_BIST_FAIL_cpu0_scu_drf_mbist_fail(data)                         (0x0000000F&((data)<<0))
+#define CPU0_SCU_DRF_BIST_FAIL_cpu0_scu_drf_mbist_fail_src(data)                     ((0x0000000F&(data))>>0)
+#define CPU0_SCU_DRF_BIST_FAIL_get_cpu0_scu_drf_mbist_fail(data)                     ((0x0000000F&(data))>>0)
+
+
+#define CPU1_SCU_DRF_BIST_FAIL                                                       0x1801D384
+#define CPU1_SCU_DRF_BIST_FAIL_reg_addr                                              "0xB801D384"
+#define CPU1_SCU_DRF_BIST_FAIL_reg                                                   0xB801D384
+#define set_CPU1_SCU_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_SCU_DRF_BIST_FAIL_reg)=data)
+#define get_CPU1_SCU_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_SCU_DRF_BIST_FAIL_reg))
+#define CPU1_SCU_DRF_BIST_FAIL_inst_adr                                              "0x00E1"
+#define CPU1_SCU_DRF_BIST_FAIL_inst                                                  0x00E1
+#define CPU1_SCU_DRF_BIST_FAIL_cpu1_scu_drf_mbist_fail_shift                         (0)
+#define CPU1_SCU_DRF_BIST_FAIL_cpu1_scu_drf_mbist_fail_mask                          (0x0000000F)
+#define CPU1_SCU_DRF_BIST_FAIL_cpu1_scu_drf_mbist_fail(data)                         (0x0000000F&((data)<<0))
+#define CPU1_SCU_DRF_BIST_FAIL_cpu1_scu_drf_mbist_fail_src(data)                     ((0x0000000F&(data))>>0)
+#define CPU1_SCU_DRF_BIST_FAIL_get_cpu1_scu_drf_mbist_fail(data)                     ((0x0000000F&(data))>>0)
+
+
+#define CPU0_TLB_BIST_FAIL                                                           0x1801D388
+#define CPU0_TLB_BIST_FAIL_reg_addr                                                  "0xB801D388"
+#define CPU0_TLB_BIST_FAIL_reg                                                       0xB801D388
+#define set_CPU0_TLB_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_TLB_BIST_FAIL_reg)=data)
+#define get_CPU0_TLB_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_TLB_BIST_FAIL_reg))
+#define CPU0_TLB_BIST_FAIL_inst_adr                                                  "0x00E2"
+#define CPU0_TLB_BIST_FAIL_inst                                                      0x00E2
+#define CPU0_TLB_BIST_FAIL_cpu0_tlb_mbist_fail_shift                                 (0)
+#define CPU0_TLB_BIST_FAIL_cpu0_tlb_mbist_fail_mask                                  (0x00000003)
+#define CPU0_TLB_BIST_FAIL_cpu0_tlb_mbist_fail(data)                                 (0x00000003&((data)<<0))
+#define CPU0_TLB_BIST_FAIL_cpu0_tlb_mbist_fail_src(data)                             ((0x00000003&(data))>>0)
+#define CPU0_TLB_BIST_FAIL_get_cpu0_tlb_mbist_fail(data)                             ((0x00000003&(data))>>0)
+
+
+#define CPU1_TLB_BIST_FAIL                                                           0x1801D38C
+#define CPU1_TLB_BIST_FAIL_reg_addr                                                  "0xB801D38C"
+#define CPU1_TLB_BIST_FAIL_reg                                                       0xB801D38C
+#define set_CPU1_TLB_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_TLB_BIST_FAIL_reg)=data)
+#define get_CPU1_TLB_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_TLB_BIST_FAIL_reg))
+#define CPU1_TLB_BIST_FAIL_inst_adr                                                  "0x00E3"
+#define CPU1_TLB_BIST_FAIL_inst                                                      0x00E3
+#define CPU1_TLB_BIST_FAIL_cpu1_tlb_mbist_fail_shift                                 (0)
+#define CPU1_TLB_BIST_FAIL_cpu1_tlb_mbist_fail_mask                                  (0x00000003)
+#define CPU1_TLB_BIST_FAIL_cpu1_tlb_mbist_fail(data)                                 (0x00000003&((data)<<0))
+#define CPU1_TLB_BIST_FAIL_cpu1_tlb_mbist_fail_src(data)                             ((0x00000003&(data))>>0)
+#define CPU1_TLB_BIST_FAIL_get_cpu1_tlb_mbist_fail(data)                             ((0x00000003&(data))>>0)
+
+
+#define CPU0_TLB_DRF_BIST_FAIL                                                       0x1801D390
+#define CPU0_TLB_DRF_BIST_FAIL_reg_addr                                              "0xB801D390"
+#define CPU0_TLB_DRF_BIST_FAIL_reg                                                   0xB801D390
+#define set_CPU0_TLB_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU0_TLB_DRF_BIST_FAIL_reg)=data)
+#define get_CPU0_TLB_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU0_TLB_DRF_BIST_FAIL_reg))
+#define CPU0_TLB_DRF_BIST_FAIL_inst_adr                                              "0x00E4"
+#define CPU0_TLB_DRF_BIST_FAIL_inst                                                  0x00E4
+#define CPU0_TLB_DRF_BIST_FAIL_cpu0_tlb_drf_mbist_fail_shift                         (0)
+#define CPU0_TLB_DRF_BIST_FAIL_cpu0_tlb_drf_mbist_fail_mask                          (0x00000003)
+#define CPU0_TLB_DRF_BIST_FAIL_cpu0_tlb_drf_mbist_fail(data)                         (0x00000003&((data)<<0))
+#define CPU0_TLB_DRF_BIST_FAIL_cpu0_tlb_drf_mbist_fail_src(data)                     ((0x00000003&(data))>>0)
+#define CPU0_TLB_DRF_BIST_FAIL_get_cpu0_tlb_drf_mbist_fail(data)                     ((0x00000003&(data))>>0)
+
+
+#define CPU1_TLB_DRF_BIST_FAIL                                                       0x1801D394
+#define CPU1_TLB_DRF_BIST_FAIL_reg_addr                                              "0xB801D394"
+#define CPU1_TLB_DRF_BIST_FAIL_reg                                                   0xB801D394
+#define set_CPU1_TLB_DRF_BIST_FAIL_reg(data)   (*((volatile unsigned int*) CPU1_TLB_DRF_BIST_FAIL_reg)=data)
+#define get_CPU1_TLB_DRF_BIST_FAIL_reg   (*((volatile unsigned int*) CPU1_TLB_DRF_BIST_FAIL_reg))
+#define CPU1_TLB_DRF_BIST_FAIL_inst_adr                                              "0x00E5"
+#define CPU1_TLB_DRF_BIST_FAIL_inst                                                  0x00E5
+#define CPU1_TLB_DRF_BIST_FAIL_cpu1_tlb_drf_mbist_fail_shift                         (0)
+#define CPU1_TLB_DRF_BIST_FAIL_cpu1_tlb_drf_mbist_fail_mask                          (0x00000003)
+#define CPU1_TLB_DRF_BIST_FAIL_cpu1_tlb_drf_mbist_fail(data)                         (0x00000003&((data)<<0))
+#define CPU1_TLB_DRF_BIST_FAIL_cpu1_tlb_drf_mbist_fail_src(data)                     ((0x00000003&(data))>>0)
+#define CPU1_TLB_DRF_BIST_FAIL_get_cpu1_tlb_drf_mbist_fail(data)                     ((0x00000003&(data))>>0)
+
+
+#define L2_BIST_BISR_RSTN                                                            0x1801D400
+#define L2_BIST_BISR_RSTN_reg_addr                                                   "0xB801D400"
+#define L2_BIST_BISR_RSTN_reg                                                        0xB801D400
+#define set_L2_BIST_BISR_RSTN_reg(data)   (*((volatile unsigned int*) L2_BIST_BISR_RSTN_reg)=data)
+#define get_L2_BIST_BISR_RSTN_reg   (*((volatile unsigned int*) L2_BIST_BISR_RSTN_reg))
+#define L2_BIST_BISR_RSTN_inst_adr                                                   "0x0000"
+#define L2_BIST_BISR_RSTN_inst                                                       0x0000
+#define L2_BIST_BISR_RSTN_MBIST_RSTN_shift                                           (3)
+#define L2_BIST_BISR_RSTN_MBIST_RSTN_mask                                            (0x00000008)
+#define L2_BIST_BISR_RSTN_MBIST_RSTN(data)                                           (0x00000008&((data)<<3))
+#define L2_BIST_BISR_RSTN_MBIST_RSTN_src(data)                                       ((0x00000008&(data))>>3)
+#define L2_BIST_BISR_RSTN_get_MBIST_RSTN(data)                                       ((0x00000008&(data))>>3)
+#define L2_BIST_BISR_RSTN_L2_TAG_BIST_RSTN_shift                                     (2)
+#define L2_BIST_BISR_RSTN_L2_TAG_BIST_RSTN_mask                                      (0x00000004)
+#define L2_BIST_BISR_RSTN_L2_TAG_BIST_RSTN(data)                                     (0x00000004&((data)<<2))
+#define L2_BIST_BISR_RSTN_L2_TAG_BIST_RSTN_src(data)                                 ((0x00000004&(data))>>2)
+#define L2_BIST_BISR_RSTN_get_L2_TAG_BIST_RSTN(data)                                 ((0x00000004&(data))>>2)
+#define L2_BIST_BISR_RSTN_L2_DATA_PWR_RSTN_shift                                     (1)
+#define L2_BIST_BISR_RSTN_L2_DATA_PWR_RSTN_mask                                      (0x00000002)
+#define L2_BIST_BISR_RSTN_L2_DATA_PWR_RSTN(data)                                     (0x00000002&((data)<<1))
+#define L2_BIST_BISR_RSTN_L2_DATA_PWR_RSTN_src(data)                                 ((0x00000002&(data))>>1)
+#define L2_BIST_BISR_RSTN_get_L2_DATA_PWR_RSTN(data)                                 ((0x00000002&(data))>>1)
+#define L2_BIST_BISR_RSTN_L2_DATA_BISR_RSTN_shift                                    (0)
+#define L2_BIST_BISR_RSTN_L2_DATA_BISR_RSTN_mask                                     (0x00000001)
+#define L2_BIST_BISR_RSTN_L2_DATA_BISR_RSTN(data)                                    (0x00000001&((data)<<0))
+#define L2_BIST_BISR_RSTN_L2_DATA_BISR_RSTN_src(data)                                ((0x00000001&(data))>>0)
+#define L2_BIST_BISR_RSTN_get_L2_DATA_BISR_RSTN(data)                                ((0x00000001&(data))>>0)
+
+
+#define HOLD_REMAP                                                                   0x1801D404
+#define HOLD_REMAP_reg_addr                                                          "0xB801D404"
+#define HOLD_REMAP_reg                                                               0xB801D404
+#define set_HOLD_REMAP_reg(data)   (*((volatile unsigned int*) HOLD_REMAP_reg)=data)
+#define get_HOLD_REMAP_reg   (*((volatile unsigned int*) HOLD_REMAP_reg))
+#define HOLD_REMAP_inst_adr                                                          "0x0001"
+#define HOLD_REMAP_inst                                                              0x0001
+#define HOLD_REMAP_L2_DATA_HOLD_REMAP_shift                                          (0)
+#define HOLD_REMAP_L2_DATA_HOLD_REMAP_mask                                           (0x00000001)
+#define HOLD_REMAP_L2_DATA_HOLD_REMAP(data)                                          (0x00000001&((data)<<0))
+#define HOLD_REMAP_L2_DATA_HOLD_REMAP_src(data)                                      ((0x00000001&(data))>>0)
+#define HOLD_REMAP_get_L2_DATA_HOLD_REMAP(data)                                      ((0x00000001&(data))>>0)
+
+
+#define SECOND_RUN_EN                                                                0x1801D408
+#define SECOND_RUN_EN_reg_addr                                                       "0xB801D408"
+#define SECOND_RUN_EN_reg                                                            0xB801D408
+#define set_SECOND_RUN_EN_reg(data)   (*((volatile unsigned int*) SECOND_RUN_EN_reg)=data)
+#define get_SECOND_RUN_EN_reg   (*((volatile unsigned int*) SECOND_RUN_EN_reg))
+#define SECOND_RUN_EN_inst_adr                                                       "0x0002"
+#define SECOND_RUN_EN_inst                                                           0x0002
+#define SECOND_RUN_EN_L2_DATA_SECOND_RUN_EN_shift                                    (0)
+#define SECOND_RUN_EN_L2_DATA_SECOND_RUN_EN_mask                                     (0x00000001)
+#define SECOND_RUN_EN_L2_DATA_SECOND_RUN_EN(data)                                    (0x00000001&((data)<<0))
+#define SECOND_RUN_EN_L2_DATA_SECOND_RUN_EN_src(data)                                ((0x00000001&(data))>>0)
+#define SECOND_RUN_EN_get_L2_DATA_SECOND_RUN_EN(data)                                ((0x00000001&(data))>>0)
+
+
+#define DRF_BIST_BISR_MODE                                                           0x1801D40C
+#define DRF_BIST_BISR_MODE_reg_addr                                                  "0xB801D40C"
+#define DRF_BIST_BISR_MODE_reg                                                       0xB801D40C
+#define set_DRF_BIST_BISR_MODE_reg(data)   (*((volatile unsigned int*) DRF_BIST_BISR_MODE_reg)=data)
+#define get_DRF_BIST_BISR_MODE_reg   (*((volatile unsigned int*) DRF_BIST_BISR_MODE_reg))
+#define DRF_BIST_BISR_MODE_inst_adr                                                  "0x0003"
+#define DRF_BIST_BISR_MODE_inst                                                      0x0003
+#define DRF_BIST_BISR_MODE_L2_TAG_BIST_MODE_shift                                    (3)
+#define DRF_BIST_BISR_MODE_L2_TAG_BIST_MODE_mask                                     (0x00000008)
+#define DRF_BIST_BISR_MODE_L2_TAG_BIST_MODE(data)                                    (0x00000008&((data)<<3))
+#define DRF_BIST_BISR_MODE_L2_TAG_BIST_MODE_src(data)                                ((0x00000008&(data))>>3)
+#define DRF_BIST_BISR_MODE_get_L2_TAG_BIST_MODE(data)                                ((0x00000008&(data))>>3)
+#define DRF_BIST_BISR_MODE_L2_TAG_DRF_BIST_MODE_shift                                (2)
+#define DRF_BIST_BISR_MODE_L2_TAG_DRF_BIST_MODE_mask                                 (0x00000004)
+#define DRF_BIST_BISR_MODE_L2_TAG_DRF_BIST_MODE(data)                                (0x00000004&((data)<<2))
+#define DRF_BIST_BISR_MODE_L2_TAG_DRF_BIST_MODE_src(data)                            ((0x00000004&(data))>>2)
+#define DRF_BIST_BISR_MODE_get_L2_TAG_DRF_BIST_MODE(data)                            ((0x00000004&(data))>>2)
+#define DRF_BIST_BISR_MODE_L2_DATA_DRF_BISR_MODE_shift                               (0)
+#define DRF_BIST_BISR_MODE_L2_DATA_DRF_BISR_MODE_mask                                (0x00000001)
+#define DRF_BIST_BISR_MODE_L2_DATA_DRF_BISR_MODE(data)                               (0x00000001&((data)<<0))
+#define DRF_BIST_BISR_MODE_L2_DATA_DRF_BISR_MODE_src(data)                           ((0x00000001&(data))>>0)
+#define DRF_BIST_BISR_MODE_get_L2_DATA_DRF_BISR_MODE(data)                           ((0x00000001&(data))>>0)
+
+
+#define DRF_BISR_TEST_RESUME                                                         0x1801D410
+#define DRF_BISR_TEST_RESUME_reg_addr                                                "0xB801D410"
+#define DRF_BISR_TEST_RESUME_reg                                                     0xB801D410
+#define set_DRF_BISR_TEST_RESUME_reg(data)   (*((volatile unsigned int*) DRF_BISR_TEST_RESUME_reg)=data)
+#define get_DRF_BISR_TEST_RESUME_reg   (*((volatile unsigned int*) DRF_BISR_TEST_RESUME_reg))
+#define DRF_BISR_TEST_RESUME_inst_adr                                                "0x0004"
+#define DRF_BISR_TEST_RESUME_inst                                                    0x0004
+#define DRF_BISR_TEST_RESUME_L2_TAG_DRF_TEST_RESUME_shift                            (1)
+#define DRF_BISR_TEST_RESUME_L2_TAG_DRF_TEST_RESUME_mask                             (0x00000002)
+#define DRF_BISR_TEST_RESUME_L2_TAG_DRF_TEST_RESUME(data)                            (0x00000002&((data)<<1))
+#define DRF_BISR_TEST_RESUME_L2_TAG_DRF_TEST_RESUME_src(data)                        ((0x00000002&(data))>>1)
+#define DRF_BISR_TEST_RESUME_get_L2_TAG_DRF_TEST_RESUME(data)                        ((0x00000002&(data))>>1)
+#define DRF_BISR_TEST_RESUME_L2_DATA_DRF_BISR_TEST_RESUME_shift                      (0)
+#define DRF_BISR_TEST_RESUME_L2_DATA_DRF_BISR_TEST_RESUME_mask                       (0x00000001)
+#define DRF_BISR_TEST_RESUME_L2_DATA_DRF_BISR_TEST_RESUME(data)                      (0x00000001&((data)<<0))
+#define DRF_BISR_TEST_RESUME_L2_DATA_DRF_BISR_TEST_RESUME_src(data)                  ((0x00000001&(data))>>0)
+#define DRF_BISR_TEST_RESUME_get_L2_DATA_DRF_BISR_TEST_RESUME(data)                  ((0x00000001&(data))>>0)
+
+
+#define BISR_REPAIR                                                                  0x1801D414
+#define BISR_REPAIR_reg_addr                                                         "0xB801D414"
+#define BISR_REPAIR_reg                                                              0xB801D414
+#define set_BISR_REPAIR_reg(data)   (*((volatile unsigned int*) BISR_REPAIR_reg)=data)
+#define get_BISR_REPAIR_reg   (*((volatile unsigned int*) BISR_REPAIR_reg))
+#define BISR_REPAIR_inst_adr                                                         "0x0005"
+#define BISR_REPAIR_inst                                                             0x0005
+#define BISR_REPAIR_L2_DATA_BISR_REPAIRED_shift                                      (0)
+#define BISR_REPAIR_L2_DATA_BISR_REPAIRED_mask                                       (0x00000001)
+#define BISR_REPAIR_L2_DATA_BISR_REPAIRED(data)                                      (0x00000001&((data)<<0))
+#define BISR_REPAIR_L2_DATA_BISR_REPAIRED_src(data)                                  ((0x00000001&(data))>>0)
+#define BISR_REPAIR_get_L2_DATA_BISR_REPAIRED(data)                                  ((0x00000001&(data))>>0)
+
+
+#define BISR_DONE                                                                    0x1801D418
+#define BISR_DONE_reg_addr                                                           "0xB801D418"
+#define BISR_DONE_reg                                                                0xB801D418
+#define set_BISR_DONE_reg(data)   (*((volatile unsigned int*) BISR_DONE_reg)=data)
+#define get_BISR_DONE_reg   (*((volatile unsigned int*) BISR_DONE_reg))
+#define BISR_DONE_inst_adr                                                           "0x0006"
+#define BISR_DONE_inst                                                               0x0006
+#define BISR_DONE_L2_TAG_BIST_DONE_shift                                             (1)
+#define BISR_DONE_L2_TAG_BIST_DONE_mask                                              (0x00000002)
+#define BISR_DONE_L2_TAG_BIST_DONE(data)                                             (0x00000002&((data)<<1))
+#define BISR_DONE_L2_TAG_BIST_DONE_src(data)                                         ((0x00000002&(data))>>1)
+#define BISR_DONE_get_L2_TAG_BIST_DONE(data)                                         ((0x00000002&(data))>>1)
+#define BISR_DONE_L2_DATA_BISR_DONE_shift                                            (0)
+#define BISR_DONE_L2_DATA_BISR_DONE_mask                                             (0x00000001)
+#define BISR_DONE_L2_DATA_BISR_DONE(data)                                            (0x00000001&((data)<<0))
+#define BISR_DONE_L2_DATA_BISR_DONE_src(data)                                        ((0x00000001&(data))>>0)
+#define BISR_DONE_get_L2_DATA_BISR_DONE(data)                                        ((0x00000001&(data))>>0)
+
+
+#define DRF_BISR_DONE                                                                0x1801D41C
+#define DRF_BISR_DONE_reg_addr                                                       "0xB801D41C"
+#define DRF_BISR_DONE_reg                                                            0xB801D41C
+#define set_DRF_BISR_DONE_reg(data)   (*((volatile unsigned int*) DRF_BISR_DONE_reg)=data)
+#define get_DRF_BISR_DONE_reg   (*((volatile unsigned int*) DRF_BISR_DONE_reg))
+#define DRF_BISR_DONE_inst_adr                                                       "0x0007"
+#define DRF_BISR_DONE_inst                                                           0x0007
+#define DRF_BISR_DONE_L2_TAG_DRF_BIST_DONE_shift                                     (1)
+#define DRF_BISR_DONE_L2_TAG_DRF_BIST_DONE_mask                                      (0x00000002)
+#define DRF_BISR_DONE_L2_TAG_DRF_BIST_DONE(data)                                     (0x00000002&((data)<<1))
+#define DRF_BISR_DONE_L2_TAG_DRF_BIST_DONE_src(data)                                 ((0x00000002&(data))>>1)
+#define DRF_BISR_DONE_get_L2_TAG_DRF_BIST_DONE(data)                                 ((0x00000002&(data))>>1)
+#define DRF_BISR_DONE_L2_DATA_DRF_BISR_DONE_shift                                    (0)
+#define DRF_BISR_DONE_L2_DATA_DRF_BISR_DONE_mask                                     (0x00000001)
+#define DRF_BISR_DONE_L2_DATA_DRF_BISR_DONE(data)                                    (0x00000001&((data)<<0))
+#define DRF_BISR_DONE_L2_DATA_DRF_BISR_DONE_src(data)                                ((0x00000001&(data))>>0)
+#define DRF_BISR_DONE_get_L2_DATA_DRF_BISR_DONE(data)                                ((0x00000001&(data))>>0)
+
+
+#define DRF_START_PAUSE                                                              0x1801D420
+#define DRF_START_PAUSE_reg_addr                                                     "0xB801D420"
+#define DRF_START_PAUSE_reg                                                          0xB801D420
+#define set_DRF_START_PAUSE_reg(data)   (*((volatile unsigned int*) DRF_START_PAUSE_reg)=data)
+#define get_DRF_START_PAUSE_reg   (*((volatile unsigned int*) DRF_START_PAUSE_reg))
+#define DRF_START_PAUSE_inst_adr                                                     "0x0008"
+#define DRF_START_PAUSE_inst                                                         0x0008
+#define DRF_START_PAUSE_L2_TAG_DRF_START_PAUSE_shift                                 (1)
+#define DRF_START_PAUSE_L2_TAG_DRF_START_PAUSE_mask                                  (0x00000002)
+#define DRF_START_PAUSE_L2_TAG_DRF_START_PAUSE(data)                                 (0x00000002&((data)<<1))
+#define DRF_START_PAUSE_L2_TAG_DRF_START_PAUSE_src(data)                             ((0x00000002&(data))>>1)
+#define DRF_START_PAUSE_get_L2_TAG_DRF_START_PAUSE(data)                             ((0x00000002&(data))>>1)
+#define DRF_START_PAUSE_L2_DATA_DRF_BISR_START_PAUSE_shift                           (0)
+#define DRF_START_PAUSE_L2_DATA_DRF_BISR_START_PAUSE_mask                            (0x00000001)
+#define DRF_START_PAUSE_L2_DATA_DRF_BISR_START_PAUSE(data)                           (0x00000001&((data)<<0))
+#define DRF_START_PAUSE_L2_DATA_DRF_BISR_START_PAUSE_src(data)                       ((0x00000001&(data))>>0)
+#define DRF_START_PAUSE_get_L2_DATA_DRF_BISR_START_PAUSE(data)                       ((0x00000001&(data))>>0)
+
+
+#define BISR_FAIL_GROUP                                                              0x1801D424
+#define BISR_FAIL_GROUP_reg_addr                                                     "0xB801D424"
+#define BISR_FAIL_GROUP_reg                                                          0xB801D424
+#define set_BISR_FAIL_GROUP_reg(data)   (*((volatile unsigned int*) BISR_FAIL_GROUP_reg)=data)
+#define get_BISR_FAIL_GROUP_reg   (*((volatile unsigned int*) BISR_FAIL_GROUP_reg))
+#define BISR_FAIL_GROUP_inst_adr                                                     "0x0009"
+#define BISR_FAIL_GROUP_inst                                                         0x0009
+#define BISR_FAIL_GROUP_L2_TAG_BIST_FAIL_G_shift                                     (1)
+#define BISR_FAIL_GROUP_L2_TAG_BIST_FAIL_G_mask                                      (0x00000002)
+#define BISR_FAIL_GROUP_L2_TAG_BIST_FAIL_G(data)                                     (0x00000002&((data)<<1))
+#define BISR_FAIL_GROUP_L2_TAG_BIST_FAIL_G_src(data)                                 ((0x00000002&(data))>>1)
+#define BISR_FAIL_GROUP_get_L2_TAG_BIST_FAIL_G(data)                                 ((0x00000002&(data))>>1)
+#define BISR_FAIL_GROUP_L2_DATA_BISR_FAIL_G_shift                                    (0)
+#define BISR_FAIL_GROUP_L2_DATA_BISR_FAIL_G_mask                                     (0x00000001)
+#define BISR_FAIL_GROUP_L2_DATA_BISR_FAIL_G(data)                                    (0x00000001&((data)<<0))
+#define BISR_FAIL_GROUP_L2_DATA_BISR_FAIL_G_src(data)                                ((0x00000001&(data))>>0)
+#define BISR_FAIL_GROUP_get_L2_DATA_BISR_FAIL_G(data)                                ((0x00000001&(data))>>0)
+
+
+#define BISR_FAIL_DATA_SEP                                                           0x1801D428
+#define BISR_FAIL_DATA_SEP_reg_addr                                                  "0xB801D428"
+#define BISR_FAIL_DATA_SEP_reg                                                       0xB801D428
+#define set_BISR_FAIL_DATA_SEP_reg(data)   (*((volatile unsigned int*) BISR_FAIL_DATA_SEP_reg)=data)
+#define get_BISR_FAIL_DATA_SEP_reg   (*((volatile unsigned int*) BISR_FAIL_DATA_SEP_reg))
+#define BISR_FAIL_DATA_SEP_inst_adr                                                  "0x000A"
+#define BISR_FAIL_DATA_SEP_inst                                                      0x000A
+#define BISR_FAIL_DATA_SEP_L2_DATA_BISR_FAIL_shift                                   (0)
+#define BISR_FAIL_DATA_SEP_L2_DATA_BISR_FAIL_mask                                    (0x000000FF)
+#define BISR_FAIL_DATA_SEP_L2_DATA_BISR_FAIL(data)                                   (0x000000FF&((data)<<0))
+#define BISR_FAIL_DATA_SEP_L2_DATA_BISR_FAIL_src(data)                               ((0x000000FF&(data))>>0)
+#define BISR_FAIL_DATA_SEP_get_L2_DATA_BISR_FAIL(data)                               ((0x000000FF&(data))>>0)
+
+
+#define BISR_FAIL_TAG_SEP                                                            0x1801D42C
+#define BISR_FAIL_TAG_SEP_reg_addr                                                   "0xB801D42C"
+#define BISR_FAIL_TAG_SEP_reg                                                        0xB801D42C
+#define set_BISR_FAIL_TAG_SEP_reg(data)   (*((volatile unsigned int*) BISR_FAIL_TAG_SEP_reg)=data)
+#define get_BISR_FAIL_TAG_SEP_reg   (*((volatile unsigned int*) BISR_FAIL_TAG_SEP_reg))
+#define BISR_FAIL_TAG_SEP_inst_adr                                                   "0x000B"
+#define BISR_FAIL_TAG_SEP_inst                                                       0x000B
+#define BISR_FAIL_TAG_SEP_L2_TAG_BIST_FAIL_shift                                     (0)
+#define BISR_FAIL_TAG_SEP_L2_TAG_BIST_FAIL_mask                                      (0x000000FF)
+#define BISR_FAIL_TAG_SEP_L2_TAG_BIST_FAIL(data)                                     (0x000000FF&((data)<<0))
+#define BISR_FAIL_TAG_SEP_L2_TAG_BIST_FAIL_src(data)                                 ((0x000000FF&(data))>>0)
+#define BISR_FAIL_TAG_SEP_get_L2_TAG_BIST_FAIL(data)                                 ((0x000000FF&(data))>>0)
+
+
+#define DRF_BISR_FAIL_GROUP                                                          0x1801D430
+#define DRF_BISR_FAIL_GROUP_reg_addr                                                 "0xB801D430"
+#define DRF_BISR_FAIL_GROUP_reg                                                      0xB801D430
+#define set_DRF_BISR_FAIL_GROUP_reg(data)   (*((volatile unsigned int*) DRF_BISR_FAIL_GROUP_reg)=data)
+#define get_DRF_BISR_FAIL_GROUP_reg   (*((volatile unsigned int*) DRF_BISR_FAIL_GROUP_reg))
+#define DRF_BISR_FAIL_GROUP_inst_adr                                                 "0x000C"
+#define DRF_BISR_FAIL_GROUP_inst                                                     0x000C
+#define DRF_BISR_FAIL_GROUP_L2_TAG_DRF_BIST_FAIL_G_shift                             (1)
+#define DRF_BISR_FAIL_GROUP_L2_TAG_DRF_BIST_FAIL_G_mask                              (0x00000002)
+#define DRF_BISR_FAIL_GROUP_L2_TAG_DRF_BIST_FAIL_G(data)                             (0x00000002&((data)<<1))
+#define DRF_BISR_FAIL_GROUP_L2_TAG_DRF_BIST_FAIL_G_src(data)                         ((0x00000002&(data))>>1)
+#define DRF_BISR_FAIL_GROUP_get_L2_TAG_DRF_BIST_FAIL_G(data)                         ((0x00000002&(data))>>1)
+#define DRF_BISR_FAIL_GROUP_L2_DATA_DRF_BISR_FAIL_G_shift                            (0)
+#define DRF_BISR_FAIL_GROUP_L2_DATA_DRF_BISR_FAIL_G_mask                             (0x00000001)
+#define DRF_BISR_FAIL_GROUP_L2_DATA_DRF_BISR_FAIL_G(data)                            (0x00000001&((data)<<0))
+#define DRF_BISR_FAIL_GROUP_L2_DATA_DRF_BISR_FAIL_G_src(data)                        ((0x00000001&(data))>>0)
+#define DRF_BISR_FAIL_GROUP_get_L2_DATA_DRF_BISR_FAIL_G(data)                        ((0x00000001&(data))>>0)
+
+
+#define DRF_BISR_FAIL_DATA_SEP                                                       0x1801D434
+#define DRF_BISR_FAIL_DATA_SEP_reg_addr                                              "0xB801D434"
+#define DRF_BISR_FAIL_DATA_SEP_reg                                                   0xB801D434
+#define set_DRF_BISR_FAIL_DATA_SEP_reg(data)   (*((volatile unsigned int*) DRF_BISR_FAIL_DATA_SEP_reg)=data)
+#define get_DRF_BISR_FAIL_DATA_SEP_reg   (*((volatile unsigned int*) DRF_BISR_FAIL_DATA_SEP_reg))
+#define DRF_BISR_FAIL_DATA_SEP_inst_adr                                              "0x000D"
+#define DRF_BISR_FAIL_DATA_SEP_inst                                                  0x000D
+#define DRF_BISR_FAIL_DATA_SEP_L2_DATA_DRF_BISR_FAIL_shift                           (0)
+#define DRF_BISR_FAIL_DATA_SEP_L2_DATA_DRF_BISR_FAIL_mask                            (0x000000FF)
+#define DRF_BISR_FAIL_DATA_SEP_L2_DATA_DRF_BISR_FAIL(data)                           (0x000000FF&((data)<<0))
+#define DRF_BISR_FAIL_DATA_SEP_L2_DATA_DRF_BISR_FAIL_src(data)                       ((0x000000FF&(data))>>0)
+#define DRF_BISR_FAIL_DATA_SEP_get_L2_DATA_DRF_BISR_FAIL(data)                       ((0x000000FF&(data))>>0)
+
+
+#define DRF_BISR_FAIL_TAG_SEP                                                        0x1801D438
+#define DRF_BISR_FAIL_TAG_SEP_reg_addr                                               "0xB801D438"
+#define DRF_BISR_FAIL_TAG_SEP_reg                                                    0xB801D438
+#define set_DRF_BISR_FAIL_TAG_SEP_reg(data)   (*((volatile unsigned int*) DRF_BISR_FAIL_TAG_SEP_reg)=data)
+#define get_DRF_BISR_FAIL_TAG_SEP_reg   (*((volatile unsigned int*) DRF_BISR_FAIL_TAG_SEP_reg))
+#define DRF_BISR_FAIL_TAG_SEP_inst_adr                                               "0x000E"
+#define DRF_BISR_FAIL_TAG_SEP_inst                                                   0x000E
+#define DRF_BISR_FAIL_TAG_SEP_L2_TAG_DRF_BIST_FAIL_shift                             (0)
+#define DRF_BISR_FAIL_TAG_SEP_L2_TAG_DRF_BIST_FAIL_mask                              (0x000000FF)
+#define DRF_BISR_FAIL_TAG_SEP_L2_TAG_DRF_BIST_FAIL(data)                             (0x000000FF&((data)<<0))
+#define DRF_BISR_FAIL_TAG_SEP_L2_TAG_DRF_BIST_FAIL_src(data)                         ((0x000000FF&(data))>>0)
+#define DRF_BISR_FAIL_TAG_SEP_get_L2_TAG_DRF_BIST_FAIL(data)                         ((0x000000FF&(data))>>0)
+
+
+#define L2_DATA_BISR_OUT_1                                                           0x1801D43C
+#define L2_DATA_BISR_OUT_1_reg_addr                                                  "0xB801D43C"
+#define L2_DATA_BISR_OUT_1_reg                                                       0xB801D43C
+#define set_L2_DATA_BISR_OUT_1_reg(data)   (*((volatile unsigned int*) L2_DATA_BISR_OUT_1_reg)=data)
+#define get_L2_DATA_BISR_OUT_1_reg   (*((volatile unsigned int*) L2_DATA_BISR_OUT_1_reg))
+#define L2_DATA_BISR_OUT_1_inst_adr                                                  "0x000F"
+#define L2_DATA_BISR_OUT_1_inst                                                      0x000F
+#define L2_DATA_BISR_OUT_1_L2_DATA_BISR_OUT_31_0_shift                               (0)
+#define L2_DATA_BISR_OUT_1_L2_DATA_BISR_OUT_31_0_mask                                (0xFFFFFFFF)
+#define L2_DATA_BISR_OUT_1_L2_DATA_BISR_OUT_31_0(data)                               (0xFFFFFFFF&((data)<<0))
+#define L2_DATA_BISR_OUT_1_L2_DATA_BISR_OUT_31_0_src(data)                           ((0xFFFFFFFF&(data))>>0)
+#define L2_DATA_BISR_OUT_1_get_L2_DATA_BISR_OUT_31_0(data)                           ((0xFFFFFFFF&(data))>>0)
+
+
+#define L2_DATA_BISR_OUT_2                                                           0x1801D440
+#define L2_DATA_BISR_OUT_2_reg_addr                                                  "0xB801D440"
+#define L2_DATA_BISR_OUT_2_reg                                                       0xB801D440
+#define set_L2_DATA_BISR_OUT_2_reg(data)   (*((volatile unsigned int*) L2_DATA_BISR_OUT_2_reg)=data)
+#define get_L2_DATA_BISR_OUT_2_reg   (*((volatile unsigned int*) L2_DATA_BISR_OUT_2_reg))
+#define L2_DATA_BISR_OUT_2_inst_adr                                                  "0x0010"
+#define L2_DATA_BISR_OUT_2_inst                                                      0x0010
+#define L2_DATA_BISR_OUT_2_L2_DATA_BISR_OUT_55_32_shift                              (0)
+#define L2_DATA_BISR_OUT_2_L2_DATA_BISR_OUT_55_32_mask                               (0x00FFFFFF)
+#define L2_DATA_BISR_OUT_2_L2_DATA_BISR_OUT_55_32(data)                              (0x00FFFFFF&((data)<<0))
+#define L2_DATA_BISR_OUT_2_L2_DATA_BISR_OUT_55_32_src(data)                          ((0x00FFFFFF&(data))>>0)
+#define L2_DATA_BISR_OUT_2_get_L2_DATA_BISR_OUT_55_32(data)                          ((0x00FFFFFF&(data))>>0)
+
+
+#define SRAM_RME                                                                     0x1801D480
+#define SRAM_RME_reg_addr                                                            "0xB801D480"
+#define SRAM_RME_reg                                                                 0xB801D480
+#define set_SRAM_RME_reg(data)   (*((volatile unsigned int*) SRAM_RME_reg)=data)
+#define get_SRAM_RME_reg   (*((volatile unsigned int*) SRAM_RME_reg))
+#define SRAM_RME_inst_adr                                                            "0x0020"
+#define SRAM_RME_inst                                                                0x0020
+#define SRAM_RME_scu_ram_RME_shift                                                   (6)
+#define SRAM_RME_scu_ram_RME_mask                                                    (0x00000040)
+#define SRAM_RME_scu_ram_RME(data)                                                   (0x00000040&((data)<<6))
+#define SRAM_RME_scu_ram_RME_src(data)                                               ((0x00000040&(data))>>6)
+#define SRAM_RME_get_scu_ram_RME(data)                                               ((0x00000040&(data))>>6)
+#define SRAM_RME_idata_ram_RME_shift                                                 (5)
+#define SRAM_RME_idata_ram_RME_mask                                                  (0x00000020)
+#define SRAM_RME_idata_ram_RME(data)                                                 (0x00000020&((data)<<5))
+#define SRAM_RME_idata_ram_RME_src(data)                                             ((0x00000020&(data))>>5)
+#define SRAM_RME_get_idata_ram_RME(data)                                             ((0x00000020&(data))>>5)
+#define SRAM_RME_itag_ram_RME_shift                                                  (4)
+#define SRAM_RME_itag_ram_RME_mask                                                   (0x00000010)
+#define SRAM_RME_itag_ram_RME(data)                                                  (0x00000010&((data)<<4))
+#define SRAM_RME_itag_ram_RME_src(data)                                              ((0x00000010&(data))>>4)
+#define SRAM_RME_get_itag_ram_RME(data)                                              ((0x00000010&(data))>>4)
+#define SRAM_RME_ddata_ram_RME_shift                                                 (3)
+#define SRAM_RME_ddata_ram_RME_mask                                                  (0x00000008)
+#define SRAM_RME_ddata_ram_RME(data)                                                 (0x00000008&((data)<<3))
+#define SRAM_RME_ddata_ram_RME_src(data)                                             ((0x00000008&(data))>>3)
+#define SRAM_RME_get_ddata_ram_RME(data)                                             ((0x00000008&(data))>>3)
+#define SRAM_RME_dtag_ram_RME_shift                                                  (2)
+#define SRAM_RME_dtag_ram_RME_mask                                                   (0x00000004)
+#define SRAM_RME_dtag_ram_RME(data)                                                  (0x00000004&((data)<<2))
+#define SRAM_RME_dtag_ram_RME_src(data)                                              ((0x00000004&(data))>>2)
+#define SRAM_RME_get_dtag_ram_RME(data)                                              ((0x00000004&(data))>>2)
+#define SRAM_RME_ddrity_ram_RME_shift                                                (1)
+#define SRAM_RME_ddrity_ram_RME_mask                                                 (0x00000002)
+#define SRAM_RME_ddrity_ram_RME(data)                                                (0x00000002&((data)<<1))
+#define SRAM_RME_ddrity_ram_RME_src(data)                                            ((0x00000002&(data))>>1)
+#define SRAM_RME_get_ddrity_ram_RME(data)                                            ((0x00000002&(data))>>1)
+#define SRAM_RME_tlb_ram_RME_shift                                                   (0)
+#define SRAM_RME_tlb_ram_RME_mask                                                    (0x00000001)
+#define SRAM_RME_tlb_ram_RME(data)                                                   (0x00000001&((data)<<0))
+#define SRAM_RME_tlb_ram_RME_src(data)                                               ((0x00000001&(data))>>0)
+#define SRAM_RME_get_tlb_ram_RME(data)                                               ((0x00000001&(data))>>0)
+
+
+#define SRAM_RM                                                                      0x1801D484
+#define SRAM_RM_reg_addr                                                             "0xB801D484"
+#define SRAM_RM_reg                                                                  0xB801D484
+#define set_SRAM_RM_reg(data)   (*((volatile unsigned int*) SRAM_RM_reg)=data)
+#define get_SRAM_RM_reg   (*((volatile unsigned int*) SRAM_RM_reg))
+#define SRAM_RM_inst_adr                                                             "0x0021"
+#define SRAM_RM_inst                                                                 0x0021
+#define SRAM_RM_scu_ram_RM_shift                                                     (24)
+#define SRAM_RM_scu_ram_RM_mask                                                      (0x0F000000)
+#define SRAM_RM_scu_ram_RM(data)                                                     (0x0F000000&((data)<<24))
+#define SRAM_RM_scu_ram_RM_src(data)                                                 ((0x0F000000&(data))>>24)
+#define SRAM_RM_get_scu_ram_RM(data)                                                 ((0x0F000000&(data))>>24)
+#define SRAM_RM_idata_ram_RM_shift                                                   (20)
+#define SRAM_RM_idata_ram_RM_mask                                                    (0x00F00000)
+#define SRAM_RM_idata_ram_RM(data)                                                   (0x00F00000&((data)<<20))
+#define SRAM_RM_idata_ram_RM_src(data)                                               ((0x00F00000&(data))>>20)
+#define SRAM_RM_get_idata_ram_RM(data)                                               ((0x00F00000&(data))>>20)
+#define SRAM_RM_itag_ram_RM_shift                                                    (16)
+#define SRAM_RM_itag_ram_RM_mask                                                     (0x000F0000)
+#define SRAM_RM_itag_ram_RM(data)                                                    (0x000F0000&((data)<<16))
+#define SRAM_RM_itag_ram_RM_src(data)                                                ((0x000F0000&(data))>>16)
+#define SRAM_RM_get_itag_ram_RM(data)                                                ((0x000F0000&(data))>>16)
+#define SRAM_RM_ddata_ram_RM_shift                                                   (12)
+#define SRAM_RM_ddata_ram_RM_mask                                                    (0x0000F000)
+#define SRAM_RM_ddata_ram_RM(data)                                                   (0x0000F000&((data)<<12))
+#define SRAM_RM_ddata_ram_RM_src(data)                                               ((0x0000F000&(data))>>12)
+#define SRAM_RM_get_ddata_ram_RM(data)                                               ((0x0000F000&(data))>>12)
+#define SRAM_RM_dtag_ram_RM_shift                                                    (8)
+#define SRAM_RM_dtag_ram_RM_mask                                                     (0x00000F00)
+#define SRAM_RM_dtag_ram_RM(data)                                                    (0x00000F00&((data)<<8))
+#define SRAM_RM_dtag_ram_RM_src(data)                                                ((0x00000F00&(data))>>8)
+#define SRAM_RM_get_dtag_ram_RM(data)                                                ((0x00000F00&(data))>>8)
+#define SRAM_RM_ddrity_ram_RM_shift                                                  (4)
+#define SRAM_RM_ddrity_ram_RM_mask                                                   (0x000000F0)
+#define SRAM_RM_ddrity_ram_RM(data)                                                  (0x000000F0&((data)<<4))
+#define SRAM_RM_ddrity_ram_RM_src(data)                                              ((0x000000F0&(data))>>4)
+#define SRAM_RM_get_ddrity_ram_RM(data)                                              ((0x000000F0&(data))>>4)
+#define SRAM_RM_tlb_ram_RM_shift                                                     (0)
+#define SRAM_RM_tlb_ram_RM_mask                                                      (0x0000000F)
+#define SRAM_RM_tlb_ram_RM(data)                                                     (0x0000000F&((data)<<0))
+#define SRAM_RM_tlb_ram_RM_src(data)                                                 ((0x0000000F&(data))>>0)
+#define SRAM_RM_get_tlb_ram_RM(data)                                                 ((0x0000000F&(data))>>0)
+
+
+#define L2_SRAM_RME                                                                  0x1801D48C
+#define L2_SRAM_RME_reg_addr                                                         "0xB801D48C"
+#define L2_SRAM_RME_reg                                                              0xB801D48C
+#define set_L2_SRAM_RME_reg(data)   (*((volatile unsigned int*) L2_SRAM_RME_reg)=data)
+#define get_L2_SRAM_RME_reg   (*((volatile unsigned int*) L2_SRAM_RME_reg))
+#define L2_SRAM_RME_inst_adr                                                         "0x0023"
+#define L2_SRAM_RME_inst                                                             0x0023
+#define L2_SRAM_RME_RME_L2_TAG_shift                                                 (1)
+#define L2_SRAM_RME_RME_L2_TAG_mask                                                  (0x00000002)
+#define L2_SRAM_RME_RME_L2_TAG(data)                                                 (0x00000002&((data)<<1))
+#define L2_SRAM_RME_RME_L2_TAG_src(data)                                             ((0x00000002&(data))>>1)
+#define L2_SRAM_RME_get_RME_L2_TAG(data)                                             ((0x00000002&(data))>>1)
+#define L2_SRAM_RME_RME_L2_DATA_shift                                                (0)
+#define L2_SRAM_RME_RME_L2_DATA_mask                                                 (0x00000001)
+#define L2_SRAM_RME_RME_L2_DATA(data)                                                (0x00000001&((data)<<0))
+#define L2_SRAM_RME_RME_L2_DATA_src(data)                                            ((0x00000001&(data))>>0)
+#define L2_SRAM_RME_get_RME_L2_DATA(data)                                            ((0x00000001&(data))>>0)
+
+
+#define L2_SRAM_RM                                                                   0x1801D490
+#define L2_SRAM_RM_reg_addr                                                          "0xB801D490"
+#define L2_SRAM_RM_reg                                                               0xB801D490
+#define set_L2_SRAM_RM_reg(data)   (*((volatile unsigned int*) L2_SRAM_RM_reg)=data)
+#define get_L2_SRAM_RM_reg   (*((volatile unsigned int*) L2_SRAM_RM_reg))
+#define L2_SRAM_RM_inst_adr                                                          "0x0024"
+#define L2_SRAM_RM_inst                                                              0x0024
+#define L2_SRAM_RM_RM_L2_TAG_shift                                                   (4)
+#define L2_SRAM_RM_RM_L2_TAG_mask                                                    (0x000000F0)
+#define L2_SRAM_RM_RM_L2_TAG(data)                                                   (0x000000F0&((data)<<4))
+#define L2_SRAM_RM_RM_L2_TAG_src(data)                                               ((0x000000F0&(data))>>4)
+#define L2_SRAM_RM_get_RM_L2_TAG(data)                                               ((0x000000F0&(data))>>4)
+#define L2_SRAM_RM_RM_L2_DATA_shift                                                  (0)
+#define L2_SRAM_RM_RM_L2_DATA_mask                                                   (0x0000000F)
+#define L2_SRAM_RM_RM_L2_DATA(data)                                                  (0x0000000F&((data)<<0))
+#define L2_SRAM_RM_RM_L2_DATA_src(data)                                              ((0x0000000F&(data))>>0)
+#define L2_SRAM_RM_get_RM_L2_DATA(data)                                              ((0x0000000F&(data))>>0)
+
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/main/fpga.c b/drivers/video/fbdev/rtk/dc2vo/fpga/main/fpga.c
new file mode 100644
index 00000000..8822518
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/main/fpga.c
@@ -0,0 +1,253 @@
+#include <generated/autoconf.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/string.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <asm/io.h>
+#include "../include/os/type.h"
+#include "../include/vo_reg.h"
+#include "../include/tve_reg.h"
+#include "../include/hdmi_reg.h"
+#include "../example/example.h"
+#include "../osd/osd.h"
+#include "../vo/vo.h"
+#include "../hdmi/hdmi.h"
+#include "../../../debug.h"
+
+static int debug    = 1;
+#if 0
+#define dprintk(msg...) if (debug)   { printk(KERN_DEBUG    "D/DC: " msg); }
+#else
+#define dprintk(msg...) if (debug)   { dbg_info(KERN_DEBUG    "D/RTK_FB: " msg); }
+#endif
+
+#include <linux/kthread.h>
+static struct task_struct *brook_tsk;
+static int data;
+static int kbrook(void *arg);
+int FPGAGo(void);
+
+int Timing_Gen = 1;
+
+static int kbrook(void *arg)
+{
+    unsigned int timeout;
+    int *d = (int *) arg;
+
+    for(;;) {
+        if (kthread_should_stop()) break;
+        //dprintk("%s(): %d\n", __FUNCTION__, (*d)++);
+        do {
+            set_current_state(TASK_INTERRUPTIBLE);
+            timeout = schedule_timeout(HZ/60);
+        } while(timeout);
+        FPGAGo();
+    }
+    printk("break\n");
+
+    return 0;
+}
+
+int FPGAGo(void)
+{
+#if 1
+    int Enable_3D = 0;
+    if(Enable_3D==1) //3D
+    {
+    }
+    else //2D
+    {
+        if(HDMI_INTSTV_get_vsyncupdated(READ_REG_INT32U(HDMI_INTSTV)))
+        {
+            //0xb800d278
+            WRITE_REG_INT32U(HDMI_INTSTV,
+                    HDMI_INTSTV_vendupdated(0)|
+                    HDMI_INTSTV_vsyncupdated(0));
+            //0xb80056d0
+            WRITE_REG_INT32U(VO_INTST,
+                    VO_INTST_h_under(0)|
+                    VO_INTST_i_under(0)|
+                    VO_INTST_p_under(0)|
+                    VO_INTST_sub1(0)|
+                    VO_INTST_wbfin(0)|
+                    VO_INTST_m2fin(0)|
+                    VO_INTST_m1fin(1)|
+                    VO_INTST_write_data(0));
+            //0xb8005018
+            WRITE_REG_INT32U(VO_FC,
+                    VO_FC_wbgo(0)|
+                    VO_FC_m2go(0)|
+                    VO_FC_m1go(1)|
+                    VO_FC_write_data(1));
+            if(Timing_Gen)
+            {
+                if(VO_INTST_get_h_under(READ_REG_INT32U(VO_INTST)))
+                {
+                    //0xb80056d0
+                    WRITE_REG_INT32U(VO_INTST,
+                            VO_INTST_h_under(1)|
+                            VO_INTST_i_under(0)|
+                            VO_INTST_p_under(0)|
+                            VO_INTST_sub1(0)|
+                            VO_INTST_wbfin(0)|
+                            VO_INTST_m2fin(0)|
+                            VO_INTST_m1fin(0)|
+                            VO_INTST_write_data(0));
+                }
+            }
+            else
+            {
+                if(VO_INTST_get_p_under(READ_REG_INT32U(VO_INTST)))
+                {
+                    //0xb80056d0
+                    WRITE_REG_INT32U(VO_INTST,
+                            VO_INTST_h_under(0)|
+                            VO_INTST_i_under(0)|
+                            VO_INTST_p_under(1)|
+                            VO_INTST_sub1(0)|
+                            VO_INTST_wbfin(0)|
+                            VO_INTST_m2fin(0)|
+                            VO_INTST_m1fin(0)|
+                            VO_INTST_write_data(0));
+                }                            	
+            }
+        }
+    }
+#else
+    WRITE_REG_INT32U(TVE_AV_CTRL,
+            TVE_AV_CTRL_h_colorbar_ebl(1)|
+            TVE_AV_CTRL_h_black_ebl(1)|
+            TVE_AV_CTRL_i_colorbar_ebl(1)|
+            TVE_AV_CTRL_p_colorbar_ebl(1)|
+            TVE_AV_CTRL_i_black_ebl(1)|
+            TVE_AV_CTRL_p_black_ebl(1)|
+            TVE_AV_CTRL_write_data(0));
+
+    //0xb8018028
+    WRITE_REG_INT32U(TVE_INTPOS_P1,
+            TVE_INTPOS_P1_write_en2(1)|TVE_INTPOS_P1_int_vpos(2)|
+            TVE_INTPOS_P1_write_en1(1)|TVE_INTPOS_P1_int_hpos(0));
+
+    //0xb8018020
+    WRITE_REG_INT32U(TVE_INTST,
+            TVE_INTST_intst_h(1)|
+            TVE_INTST_intst_i(1)|
+            TVE_INTST_intst_p(1)|
+            TVE_INTST_write_data(0));
+
+    //0xb800d278
+    WRITE_REG_INT32U(HDMI_INTSTV,
+            HDMI_INTSTV_vendupdated(0)|
+            HDMI_INTSTV_vsyncupdated(0));
+
+    //0xb80056d0
+    WRITE_REG_INT32U(VO_INTST,
+            VO_INTST_h_under(0)|
+            VO_INTST_i_under(0)|
+            VO_INTST_p_under(0)|
+            VO_INTST_sub1(0)|
+            VO_INTST_wbfin(0)|
+            VO_INTST_m2fin(0)|
+            VO_INTST_m1fin(1)|
+            VO_INTST_write_data(0));
+
+    //0xb8005018
+    WRITE_REG_INT32U(VO_FC,
+            VO_FC_wbgo(0)|
+            VO_FC_m2go(0)|
+            VO_FC_m1go(1)|
+            VO_FC_write_data(1));
+
+    //0xb80056d0
+    WRITE_REG_INT32U(VO_INTST,
+            VO_INTST_h_under(1)|
+            VO_INTST_i_under(0)|
+            VO_INTST_p_under(0)|
+            VO_INTST_sub1(0)|
+            VO_INTST_wbfin(0)|
+            VO_INTST_m2fin(0)|
+            VO_INTST_m1fin(0)|
+            VO_INTST_write_data(0));
+
+#endif
+
+}
+
+int FPGAInit(void)
+{
+    brook_tsk = kthread_create(kbrook, &data, "brook");
+    if (IS_ERR(brook_tsk)) {
+        brook_tsk = NULL;
+        dprintk("[%s %d] ERROR!\n",__func__,__LINE__);
+    } else {
+        wake_up_process(brook_tsk);
+    }
+    WRITE_REG_INT32U(0x18000190,0x0000001f);
+    WRITE_REG_INT32U(0x1800001c,0x00000603);
+    WRITE_REG_INT32U(0x18000024,0x00018100);
+    WRITE_REG_INT32U(0x1800d044,0x5afc9014);
+    WRITE_REG_INT32U(0x18000194,0x0001c044);
+    WRITE_REG_INT32U(0x1800d040,0x0df61891);
+    WRITE_REG_INT32U(0x1800d230,0x00002217);
+    WRITE_REG_INT32U(0x1800d2a4,0x0000aa22);
+
+    SET_HDMI_Video_480p(
+            2, //INT8U Pixel_Colocr_Format,
+            0, //INT8U DVI_or_HDMI,
+            1, //INT8U Deep_Color,
+            4, //INT8U Deep_Depth,
+            0, //INT8U xv_YCC,
+            Timing_Gen, //INT8U Timing_Gen,
+            0, //INT8U En_3D,
+            0); //INT8U Format_3D);
+
+    WRITE_REG_INT32U(VO_MODE,
+            VO_MODE_ch2i(0)|
+            VO_MODE_ch2(0)|
+            VO_MODE_ch1i(0)|
+            VO_MODE_ch1(1)|
+            VO_MODE_write_data(1));
+
+    WRITE_REG_INT32U(VO_MODE,
+            VO_MODE_ch2i(1)|
+            VO_MODE_ch2(1)|
+            VO_MODE_ch1i(1)|
+            VO_MODE_ch1(0)|
+            VO_MODE_write_data(0));
+
+    WRITE_REG_INT32U(VO_OUT,
+            VO_OUT_write_en3(1)|VO_OUT_h(1)|
+            VO_OUT_write_en2(1)|VO_OUT_i(0)|
+            VO_OUT_write_en1(1)|VO_OUT_p(0));
+}
+
+int FPGAShowPic(unsigned int srcW,unsigned int srcH,unsigned int pImage)
+{
+    static int init = 0;
+    if (init == 0) {
+        FPGAInit();
+        init = 1;
+    }
+
+    GO_function(
+            0,  //INT32U display_mode,
+            0,  //INT8U DVI_or_HDMI,
+            Timing_Gen);  //INT8U Timing_Gen);
+
+#if 1
+    OSDShowPic(srcW,srcH,pImage);
+#else
+    VO_480p(
+            0,//INT8U Test_Pattern,
+            Timing_Gen,//INT8U Timing_Gen,
+            0,//INT8U Enable_3D,
+            0,//INT8U Format_3D,
+            pImage,//unsigned int YPhyAddr,
+            0); //pImage);//unsigned int CPhyAddr);`
+#endif
+
+
+    //FPGAGo();
+    return 0;
+}
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/main/fpga.h b/drivers/video/fbdev/rtk/dc2vo/fpga/main/fpga.h
new file mode 100644
index 00000000..05fe6f2
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/main/fpga.h
@@ -0,0 +1,4 @@
+#ifndef __FPGA_FPGA_H__
+#define __FPGA_FPGA_H__
+int FPGAShowPic(unsigned int srcW,unsigned int srcH,unsigned int pImage);
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/osd/osd.c b/drivers/video/fbdev/rtk/dc2vo/fpga/osd/osd.c
new file mode 100644
index 00000000..0620f6b
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/osd/osd.c
@@ -0,0 +1,686 @@
+#include <generated/autoconf.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/string.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/ioctl.h> /* needed for the _IOW etc stuff used later */
+#include <asm/io.h>
+#include <asm/uaccess.h>
+#include "../include/os/type.h"
+#include "../include/vo_reg.h"
+#include "../include/tve_reg.h"
+#include "../hdmi/hdmi.h"
+#include "../include/hdmi_reg.h"
+#include "../example/example.h"
+#include "osd.h"
+#include "../../../debug.h"
+#include "../../dc_rpc.h"
+
+static int debug    = 0;
+static int error    = 1;
+#define dprintk(msg...) if (debug)   { dbg_info(KERN_DEBUG    "D/OSD: " msg); }
+#define eprintk(msg...) if (error)   { dbg_info(KERN_DEBUG    "E/OSD: " msg); }
+
+#define OSD_WRITE_REG_INT32U(addr,val) {                                            \
+    WRITE_REG_INT32U(addr,val);                                                     \
+    dprintk(" [0x%08x] w:0x%08x => r:0x%08x",(addr),(val),READ_REG_INT32U(addr));   \
+}
+
+
+typedef struct {
+    unsigned int init;
+    unsigned int output_w;
+    unsigned int output_h;
+    unsigned int mix1w;
+    unsigned int mix1h;
+} _OSDSTATE;
+
+#define OFFSET_BASE             0x18070000
+#define OFFSET_OSD_STRUCT       ( OFFSET_BASE + 0      ) // OSD Struct           (SCPU Write)
+#define OFFSET_VO_OSD_WIN       ( OFFSET_BASE + 0x100  ) // VO_OSD_WIN           (SCPU Write)
+#define OFFSET_RET_TOP_ADDR     ( OFFSET_BASE + 0x1000 ) // return top_addr      (ACPU Write)
+#define OFFSET_VO_RESOLUTION    ( OFFSET_BASE + 0x1100 ) // VO_RESOLUTION_INFO   (ACPU Write)
+#define OFFSET_YUV_STRUCT       ( OFFSET_BASE + 0x2000 ) // YUV Struct           (SCPU Write)
+#define OFFSET_RET_Y_ADDR       ( OFFSET_BASE + 0x3000 ) // return Y_addr        (ACPU Write)
+
+static  VO_RETURN * vo_return = NULL; // 0x18071000
+static  OSD_STATE * osd_state = NULL; // 0x18070000
+static  OSD_STATE * _osd_state = NULL;// page alloc
+static  YUV_STATE * yuv_state = NULL; // 0x18072000
+static  YUV_STATE * _yuv_state = NULL; // page alloc
+static  VO_RESOLUTION_INFO * vo_res_info = NULL;
+
+static int yuv_flag = NULL;
+enum {
+    v1_ready = 0x1,
+    hwc_ready = 0x2,
+};
+
+static WINDOW_INFO osd_window = {
+    .dst_x = 0,
+    .dst_y = 0,
+    .dst_width = 1920,
+    .dst_height = 1080,
+};
+
+static WINDOW_INFO vo_window = {
+    .dst_x = 0,
+    .dst_y = 0,
+    .dst_width = 1920,
+    .dst_height = 1080,
+};
+
+#define DEAFULT_OSD_STATE 1 // 0:ON 1:OFF
+#define DEAFULT_OSD_ORDER 2 // 0 ~ 2 top:2
+
+static _OSDSTATE OSDSTATE = {
+    .init = 0,
+    .output_w = 720,
+    .output_h = 480,
+    .mix1w = 0,
+    .mix1h = 0,
+};
+
+
+int OSDInit(void)
+{
+
+    /*
+     * set mix1 plane
+     */
+    OSD_WRITE_REG_INT32U(VO_MIX1,
+                     VO_MIX1_i_vbi(1)|
+                     VO_MIX1_vbi(1)|
+                     VO_MIX1_osd1(0)|
+                     VO_MIX1_sub1(1)|
+                     VO_MIX1_v1(1)|
+                     VO_MIX1_bg(1)|
+                     VO_MIX1_write_data(0));
+
+    OSD_WRITE_REG_INT32U(VO_MIX1,
+                     VO_MIX1_i_vbi(0)|
+                     VO_MIX1_vbi(0)|
+                     VO_MIX1_osd1(1)|
+                     VO_MIX1_sub1(0)|
+                     VO_MIX1_v1(0)|
+                     VO_MIX1_bg(0)|
+                     VO_MIX1_write_data(1));
+
+    OSDSTATE.init = 1;
+    return 0;
+}
+
+int OSDSetMix1(unsigned int w, unsigned int h)
+{
+   /*
+     * set mix1 size
+     */
+#if 0
+    unsigned int mix1w = (w * OSDSTATE.output_w)/OSDSTATE.output_w;
+    unsigned int mix1h = (h * OSDSTATE.output_h)/OSDSTATE.output_h;
+#else
+#if 0
+    unsigned int mix1w = (OSDSTATE.output_w * w) / w;
+    unsigned int mix1h = (OSDSTATE.output_h * h) / h;
+#else
+    unsigned int mix1w = w;
+    unsigned int mix1h = h;
+#endif
+#endif
+    OSD_WRITE_REG_INT32U(VO_MODE,
+            VO_MODE_shut_down_enable(0)|
+            VO_MODE_gating_enable(1)|
+            VO_MODE_write_data(1));
+
+
+    OSD_WRITE_REG_INT32U(VO_M1_SIZE,
+            VO_M1_SIZE_w(mix1w)|
+            VO_M1_SIZE_h(mix1h));
+
+    OSD_WRITE_REG_INT32U(VO_INTEN,
+            VO_INTEN_h_under(1)|
+            VO_INTEN_i_under(1)|
+            VO_INTEN_sub1(1)|
+            VO_INTEN_wbfin(1)|
+            VO_INTEN_m1fin(1)|
+            VO_INTEN_m2fin(1)|
+            VO_INTEN_write_data(1));
+
+    OSDSTATE.mix1w = w;
+    OSDSTATE.mix1h = h;
+    return 0;
+}
+
+int OSDShowPic(unsigned int srcW,unsigned int srcH,unsigned int pImage)
+{
+#if 0
+    unsigned int srcW    = 1280 ;
+    unsigned int srcH    = 720 ;
+    unsigned int pImage = 0x83900000 ;
+#endif
+    unsigned int byteCnt = 4 ;//ARGB8888
+    unsigned int pitch = srcW*byteCnt ;
+
+#if 1
+    unsigned int dstW = srcW;
+    unsigned int dstH = srcH;
+#else
+    unsigned int dstW = OSDSTATE.output_w;
+    unsigned int dstH = OSDSTATE.output_h;
+#endif
+
+    static VO_OSD_WIN *win = NULL;
+
+    if (OSDSTATE.init == 0)
+        OSDInit();
+
+    if (srcW != OSDSTATE.mix1w || srcH != OSDSTATE.mix1h)
+        OSDSetMix1(srcW,srcH);
+
+#if 0
+    if (win == NULL)
+        win = (VO_OSD_WIN*) kmalloc(sizeof(VO_OSD_WIN)+20,GFP_KERNEL|__GFP_ZERO);
+#else
+    if (win == NULL) {
+        win = (void *) __get_free_pages(__GFP_ZERO|GFP_KERNEL, get_order((sizeof(VO_OSD_WIN)+20)));
+        memset(win, 0, (sizeof(VO_OSD_WIN)+20));
+    }
+#endif
+
+
+    dprintk(" Image phyaddr = 0x%08x\n",pImage);
+    win->nxtAddr.addr         = 0;
+    win->nxtAddr.last         = 1;
+    win->winXY.x              = 0;
+    win->winXY.y              = 0;
+    win->winWH.width          = srcW;
+    win->winWH.height         = srcH;
+    win->attr.extendMode      = 0 ;
+    //win->attr.extendMode      = 1 ;
+    win->attr.littleEndian    = 1 ;
+    win->attr.rgbOrder        = 0 ; //RGB
+    win->attr.alphaType       = 0 ;
+    win->attr.alphaEn         = 1 ;
+    win->attr.storageMode     = 1 ; //sequential
+    win->attr.alpha           = 255 ;
+    win->attr.type            = 7 ;//ARGB8888
+    win->colorKey.keyEn       = 0 ;
+    /* top or progressive OSD start address (sequential) or index (block mode) */
+    win->top_addr             = pImage ;
+    win->pitch                = pitch ;
+    win->objOffset.objYoffset =0 ;
+    win->objOffset.objXoffset =0 ;
+
+
+    /*
+     * vo->OSD1_size.w = srcW ;
+     * vo->OSD1_size.h = srcH ;
+     */
+    OSD_WRITE_REG_INT32U(VO_OSD1_SIZE,
+            VO_OSD1_SIZE_w(srcW)|
+            VO_OSD1_SIZE_h(srcH));
+
+    /*
+     * vo->OSD1_ctrl.fetch_1080i = 0 ;
+     */
+    OSD_WRITE_REG_INT32U(VO_OSD1,
+            VO_OSD1_fetch_1080i(1)|
+            VO_OSD1_write_data(0));
+
+#if 1   /* dstW== srcW && dstH==srcH */
+
+
+    /*
+     * vo->OSD1_ctrl.vs =       //v scale enable
+     * vo->OSD1_ctrl.hs = 0 ;   //h scale enable
+     */
+    OSD_WRITE_REG_INT32U(VO_OSD1,
+            VO_OSD1_d3_dbh(1)|
+            VO_OSD1_d3_vdup(1)|
+            VO_OSD1_write_data(0));
+
+
+#else  /* dstW!= srcW or dstH!=srcH, need to calculate phase, offset, delta */
+    /*
+     * vo->OSD1_ctrl.vs =
+     * vo->OSD1_ctrl.hs = 1 ;
+     * vo->OSD1_VS_i.phase  =
+     * vo->OSD1_HS_i.phase  =
+     * vo->OSD1_VS_i.offset =
+     * vo->OSD1_HS_i.offset = 0 ;
+     * vo->OSD1_VS_d.delta = 0x10000 ;
+     * vo->OSD1_HS_d.delta = 0x10000 ;
+     */
+    OSD_WRITE_REG_INT32U(VO_OSD1,
+            VO_OSD1_d3_dbh(1)|
+            VO_OSD1_d3_vdup(1)|
+            VO_OSD1_write_data(1));
+    OSD_WRITE_REG_INT32U(VO_OSD1_VSI,
+            VO_OSD1_VSI_offset(0)|
+            VO_OSD1_VSI_phase(0));
+    OSD_WRITE_REG_INT32U(VO_OSD1_HSI,
+            VO_OSD1_HSI_offset(0)|
+            VO_OSD1_HSI_phase(0));
+    OSD_WRITE_REG_INT32U(VO_OSD1_VSD,
+            VO_OSD1_VSD_delta(dstW));
+    OSD_WRITE_REG_INT32U(VO_OSD1_HSD,
+            VO_OSD1_HSD_delta(dstH));
+#endif
+
+    /*
+     * vo->OSD1_xy.y = 0 ;
+     * vo->OSD1_xy.x = 0 ;
+     */
+    OSD_WRITE_REG_INT32U(VO_OSD1_XY,
+            VO_OSD1_XY_x(0)|
+            VO_OSD1_XY_y(0));
+
+
+    /*
+     * vo->OSD1_VS_d.out = dstW ;
+     */
+    OSD_WRITE_REG_INT32U(VO_OSD1_VSD,
+            VO_OSD1_VSD_delta(dstW));
+
+    /*
+     * vo->OSD1_HS_d.out = dstH ;
+     */
+    OSD_WRITE_REG_INT32U(VO_OSD1_HSD,
+            VO_OSD1_HSD_delta(dstH));
+
+    /*
+     * vo->OSD1_ctrl.dvb = 0 ;
+     */
+    OSD_WRITE_REG_INT32U(VO_OSD1,
+            VO_OSD1_dvb(1)|
+            VO_OSD1_write_data(0));
+
+    /*
+     * vo->OSD1_ctrl.osd = 1 ;
+     */
+    OSD_WRITE_REG_INT32U(VO_OSD1,
+            VO_OSD1_osd(1)|
+            VO_OSD1_write_data(1));
+
+    /*
+     * TODO: window infomation addr
+     * vo->OSD1_wi.a = ((unsigned int) &win ) & ~0xe0000000 ; //window infomation addr
+     */
+    dprintk("set window infomation addr = 0x%08x\n",(unsigned int)(virt_to_phys(win)));
+
+    OSD_WRITE_REG_INT32U(VO_OSD1_WI,
+            VO_OSD1_WI_endian(0)|
+            VO_OSD1_WI_a((virt_to_phys(win))));
+
+    OSD_WRITE_REG_INT32U(VO_FC,
+            VO_FC_m1go(1)|
+            VO_FC_m2go(0)|
+            VO_FC_write_data(1));
+
+    return 0;
+}
+
+void UpdateVORes(void)
+{
+    if (vo_res_info == NULL)
+        vo_res_info= (VO_RESOLUTION_INFO *) ioremap(OFFSET_VO_RESOLUTION,sizeof(VO_RESOLUTION_INFO));
+
+    VO_RESOLUTION_INFO vo_resolution_info;
+    pli_ipcCopyMemory((unsigned char*)&vo_resolution_info, (unsigned char*)vo_res_info, sizeof(VO_RESOLUTION_INFO));
+    vo_window.dst_width = vo_resolution_info.width;
+    vo_window.dst_height= vo_resolution_info.height;
+}
+
+int OSDShowPic2(unsigned int srcW,unsigned int srcH,unsigned int pImage)
+{
+
+    enum {
+        RGB = 0,   // 000:0
+        BGR,       // 001:1
+        GRB,       // 010:2
+        GBR,       // 011:3
+        RBG,       // 100:4
+        BRG,       // 101:5
+    };
+#if 0
+    {
+        static VO_OSD_WIN *win = NULL;
+        static VO_OSD_WIN *_win = NULL;
+        if (win == NULL)
+            win = (VO_OSD_WIN *) ioremap(0x18070100,sizeof(VO_OSD_WIN)+20);
+        if (_win == NULL) {
+            _win = (void *) __get_free_pages(__GFP_ZERO|GFP_KERNEL, get_order((sizeof(VO_OSD_WIN)+20)));
+            memset(_win, 0, (sizeof(VO_OSD_WIN)+20));
+        }
+
+
+        _win->nxtAddr.last         = 1;
+        _win->nxtAddr.addr         = 0;
+        _win->winXY.x              = 0;
+        _win->winXY.y              = 0;
+        _win->winWH.width          = srcW;
+        _win->winWH.height         = srcH;
+        _win->attr.extendMode      = 0 ;
+        _win->attr.rgbOrder        = RGB;
+        _win->attr.alphaType       = 0 ;
+        _win->attr.alphaEn         = 1 ;
+        _win->attr.storageMode     = 1 ; //sequential   
+        _win->attr.alpha           = 255 ;
+        _win->attr.littleEndian    = 1;
+        _win->attr.type            = 7 ;//ARGB8888
+        _win->colorKey.keyEn       = 0 ;
+        _win->top_addr             = pImage;   
+        _win->pitch                = srcW*4 ;
+        _win->objOffset.objYoffset =0 ;
+        _win->objOffset.objXoffset =0 ;
+
+        pli_ipcCopyMemory((unsigned char*)win, (unsigned char*)_win,sizeof(VO_OSD_WIN));
+        //memcpy((void*)win,(void *)_win,sizeof(VO_OSD_WIN));
+    }
+#endif
+
+#if 1
+    {
+        if (vo_return == NULL)
+            vo_return = (VO_RETURN *) ioremap(OFFSET_RET_TOP_ADDR,sizeof(VO_RETURN));
+
+        if (osd_state == NULL)
+            osd_state = (OSD_STATE *) ioremap(OFFSET_OSD_STRUCT,sizeof(OSD_STATE));
+
+        #if 0
+        if (vo_res_info == NULL) {
+            VO_RESOLUTION_INFO temp_vo_res_iofo;
+            vo_res_info= (VO_RESOLUTION_INFO *) ioremap(OFFSET_VO_RESOLUTION,sizeof(VO_RESOLUTION_INFO));
+            pli_ipcCopyMemory((unsigned char*)&temp_vo_res_iofo, (unsigned char*)vo_res_info, sizeof(VO_RESOLUTION_INFO));
+            vo_window.dst_width = temp_vo_res_iofo.width;
+            vo_window.dst_height = temp_vo_res_iofo.height;
+        }
+        #else
+        UpdateVORes();
+        #endif
+
+        if (_osd_state == NULL) {
+            _osd_state = (void *) __get_free_pages(__GFP_ZERO|GFP_KERNEL, get_order((sizeof(OSD_STATE))));
+            memset(_osd_state, 0, (sizeof(OSD_STATE)));
+            _osd_state->state = DEAFULT_OSD_STATE;
+            _osd_state->order = DEAFULT_OSD_ORDER;
+        }
+
+        if (_yuv_state == NULL) {
+            _yuv_state = (void *) __get_free_pages(__GFP_ZERO|GFP_KERNEL, get_order((sizeof(YUV_STATE))));
+            memset(_yuv_state, 0, (sizeof(YUV_STATE)));
+            _yuv_state->state = 0;
+            _yuv_state->dst_width    = 1920;
+            _yuv_state->dst_height   = 1080;
+            _yuv_state->dst_x        = 0;
+            _yuv_state->dst_y        = 0;
+        }
+
+        if (yuv_state == NULL)
+            yuv_state = (YUV_STATE *) ioremap(OFFSET_YUV_STRUCT,sizeof(YUV_STATE));
+
+        osd_window.dst_width = srcW;
+        osd_window.dst_height = srcH;
+
+        _osd_state->magic = 0x11223344;
+        _osd_state->phyAddr = pImage;
+        _osd_state->Height  = srcH;
+        _osd_state->Width   = srcW;
+        _osd_state->attr_rgbOrder   = BGR;//RGB
+        _osd_state->attr_type       = 7;//ARGB8888
+
+        pli_ipcCopyMemory((unsigned char*)osd_state, (unsigned char*)_osd_state,sizeof(OSD_STATE));
+
+#if 0
+        { /* Wait OSD Complete */
+            const int MaxWaitCount = 30;
+            int waitCount = 0;
+            do {
+                msleep(1);
+                VO_RETURN _vo_return;
+                pli_ipcCopyMemory((unsigned char*)&_vo_return,(unsigned char*)vo_return,sizeof(VO_RETURN));
+                if (_vo_return.phyAddr == pImage) {
+                    dprintk("[%s] OSD Complete. (%d, 0x%08x)",__func__,waitCount,pImage);
+                    break;
+                }
+                waitCount++;
+            } while (waitCount <= MaxWaitCount);
+
+            if (waitCount >= MaxWaitCount) {
+                //eprintk("[%s] Wait OSD Complete. Time Out!",__func__);
+            }
+        }
+#endif
+    }
+#endif
+
+    return 0;
+}
+
+int OSD_Ioctl (unsigned int cmd, unsigned int arg)
+{
+    int retval = 0;
+    switch (cmd) {
+        case GET_OSD_STATE:
+            {
+                if (_osd_state == NULL) goto err;
+                if (copy_to_user((void *)arg, _osd_state, sizeof(OSD_STATE)) != 0) goto err;
+                retval = 0;
+                break;
+            }
+        case SET_OSD_STATE:
+            {
+                OSD_STATE osd_state_;
+                if (_osd_state == NULL) goto err;
+                if (copy_from_user(&osd_state_, (void *)arg,sizeof(OSD_STATE)) != 0) goto err;
+                dprintk("[%s] SET state=%d order=%d",__func__,osd_state_.state,osd_state_.order);
+                _osd_state->state = osd_state_.state;
+                _osd_state->order = osd_state_.order;
+                pli_ipcCopyMemory((unsigned char*)osd_state, (unsigned char*)_osd_state,sizeof(OSD_STATE));
+                retval = 0;
+                break;
+            }
+        case OSD_STATE_RESET:
+            {
+                if (_osd_state == NULL) goto err;
+                _osd_state->state = DEAFULT_OSD_STATE;
+                _osd_state->order = DEAFULT_OSD_ORDER;
+                dprintk("[%s] RESET state=%d order=%d",__func__,_osd_state->state,_osd_state->order);
+                pli_ipcCopyMemory((unsigned char*)osd_state, (unsigned char*)_osd_state,sizeof(OSD_STATE));
+                retval = 0;
+                break;
+            }
+        #if 0
+        case OSD_STATE_CLOSE:
+            {
+                if (_osd_state == NULL) goto err;
+                //_osd_state->state = 0;
+                _osd_state->order = 2;
+                dprintk("[%s] CLOSE state=%d order=%d",__func__,_osd_state->state,_osd_state->order);
+                pli_ipcCopyMemory((unsigned char*)osd_state, (unsigned char*)_osd_state,sizeof(OSD_STATE));
+                retval = 0;
+                break;
+            }
+        case OSD_STATE_OPEN:
+            {
+                if (_osd_state == NULL) goto err;
+                //_osd_state->state = 1;
+                _osd_state->order = DEAFULT_OSD_ORDER;
+                dprintk("[%s] OPEN state=%d order=%d",__func__,_osd_state->state,_osd_state->order);
+                pli_ipcCopyMemory((unsigned char*)osd_state, (unsigned char*)_osd_state,sizeof(OSD_STATE));
+                retval = 0;
+                break;
+            }
+        #else
+        case OSD_STATE_CLOSE:
+        case OSD_STATE_OPEN:
+            {
+                retval = 0;
+                break;
+            }
+        #endif
+        case WRITE_YUV_STATE:
+            {
+                YUV_STATE temp_yuv_state;
+                if (copy_from_user(&temp_yuv_state, (void *)arg,sizeof(YUV_STATE_V0)) != 0) goto err;
+                _yuv_state->magic       = temp_yuv_state.magic;
+                if (temp_yuv_state.state)
+                    yuv_flag |= v1_ready;
+                if ((yuv_flag & hwc_ready) && (yuv_flag & v1_ready)) {
+                    _yuv_state->state       = temp_yuv_state.state;
+                }
+
+                _yuv_state->state       = temp_yuv_state.state;
+
+                _yuv_state->Y_addr      = temp_yuv_state.Y_addr;
+                _yuv_state->U_addr      = temp_yuv_state.U_addr;
+                _yuv_state->YUVFormat   = temp_yuv_state.YUVFormat;
+                _yuv_state->width       = temp_yuv_state.width;
+                _yuv_state->height      = temp_yuv_state.height;
+                _yuv_state->Y_pitch     = temp_yuv_state.Y_pitch;
+                _yuv_state->C_pitch     = temp_yuv_state.C_pitch;
+                _yuv_state->first       = temp_yuv_state.first;
+                _yuv_state->pts_inc     = temp_yuv_state.pts_inc;
+                _yuv_state->PTSH        = temp_yuv_state.PTSH;
+                _yuv_state->PTSL        = temp_yuv_state.PTSL;
+                pli_ipcCopyMemory((unsigned char*)yuv_state, (unsigned char*)_yuv_state,sizeof(YUV_STATE));
+                retval = 0;
+                break;
+            }
+        case READ_YUV_STATE:
+            {
+                if (copy_to_user((void *)arg, _yuv_state, sizeof(YUV_STATE)) != 0) goto err;
+                retval = 0;
+                break;
+            }
+        case READ_YUV_RETURN:
+            {
+                static unsigned int * yuv_return = NULL;
+                unsigned int yuv_return_;
+                if (yuv_return == NULL)
+                    yuv_return = (unsigned int *) ioremap(OFFSET_RET_Y_ADDR,sizeof(unsigned int));
+                pli_ipcCopyMemory((unsigned char*)&yuv_return_, (unsigned char*)yuv_return,sizeof(unsigned int));
+                if (copy_to_user((void *)arg, &yuv_return_, sizeof(unsigned int)) != 0) goto err;
+                retval = 0;
+                break;
+            }
+        case YUV_WINDOW_GET:
+            {
+                WINDOW_INFO yuv_window;
+                yuv_window.dst_width    = _yuv_state->dst_width;
+                yuv_window.dst_height   = _yuv_state->dst_height;
+                yuv_window.dst_x        = _yuv_state->dst_x;
+                yuv_window.dst_y        = _yuv_state->dst_y;
+                if (copy_to_user((void *)arg, &yuv_window, sizeof(WINDOW_INFO)) != 0) goto err;
+                retval = 0;
+                break;
+            }
+        case YUV_WINDOW_SET:
+            {
+                #define SCALE_PRECISION 1000
+                WINDOW_INFO temp_window;
+                unsigned int  w_scale = SCALE_PRECISION;
+                unsigned int h_scale = SCALE_PRECISION;
+                if (copy_from_user(&temp_window, (void *)arg,sizeof(WINDOW_INFO)) != 0) goto err;
+                UpdateVORes();
+                w_scale *= vo_window.dst_width;
+                h_scale *= vo_window.dst_height;
+                w_scale /= osd_window.dst_width;
+                h_scale /= osd_window.dst_height;
+                temp_window.dst_width   *= w_scale;
+                temp_window.dst_height  *= h_scale;
+                temp_window.dst_x       *= w_scale;
+                temp_window.dst_y       *= h_scale;
+                temp_window.dst_width   /= SCALE_PRECISION;
+                temp_window.dst_height  /= SCALE_PRECISION;
+                temp_window.dst_x       /= SCALE_PRECISION;
+                temp_window.dst_y       /= SCALE_PRECISION;
+                #undef SCALE_PRECISION
+
+                _yuv_state->dst_width    = temp_window.dst_width;
+                _yuv_state->dst_height   = temp_window.dst_height;
+                _yuv_state->dst_x        = temp_window.dst_x;
+                _yuv_state->dst_y        = temp_window.dst_y;
+
+                pli_ipcCopyMemory((unsigned char*)yuv_state, (unsigned char*)_yuv_state,sizeof(YUV_STATE));
+                retval = 0;
+                break;
+            }
+        case YUV_WINDOW_OPEN:
+            {
+                yuv_flag |= hwc_ready;
+                if ((yuv_flag & hwc_ready) && (yuv_flag & v1_ready)) {
+                    _yuv_state->state = 1;
+                    pli_ipcCopyMemory((unsigned char*)yuv_state, (unsigned char*)_yuv_state,sizeof(YUV_STATE));
+                }
+                #if 0
+                OSD_Ioctl(OSD_STATE_CLOSE,NULL);
+                #else
+                {
+                    _osd_state->order = 2;
+                    pli_ipcCopyMemory((unsigned char*)osd_state, (unsigned char*)_osd_state,sizeof(OSD_STATE));
+                }
+                #endif
+                retval = 0;
+                break;
+            }
+        case YUV_WINDOW_CLOSE:
+            {
+                yuv_flag = 0;
+                _yuv_state->state = 0;
+                _yuv_state->dst_x = _yuv_state->dst_y = 0;
+                _yuv_state->dst_width    = vo_window.dst_width;
+                _yuv_state->dst_height   = vo_window.dst_height;
+                pli_ipcCopyMemory((unsigned char*)yuv_state, (unsigned char*)_yuv_state,sizeof(YUV_STATE));
+                #if 0
+                #if 0
+                OSD_Ioctl(OSD_STATE_OPEN,NULL);
+                #else
+                {
+                    _osd_state->order = DEAFULT_OSD_ORDER;
+                    pli_ipcCopyMemory((unsigned char*)osd_state, (unsigned char*)_osd_state,sizeof(OSD_STATE));
+                }
+                #endif
+                #endif
+                retval = 0;
+                break;
+            }
+        #if 1
+        case VO_RESOLUTION_GET:
+            {
+                VO_RESOLUTION_INFO temp_vo_res_iofo;
+                pli_ipcCopyMemory((unsigned char*)&temp_vo_res_iofo, (unsigned char*)vo_res_info, sizeof(VO_RESOLUTION_INFO));
+                vo_window.dst_width = temp_vo_res_iofo.width;
+                vo_window.dst_height = temp_vo_res_iofo.height;
+                if (copy_to_user((void *)arg, &temp_vo_res_iofo, sizeof(VO_RESOLUTION_INFO)) != 0) goto err;
+                retval = 0;
+                break;
+            }
+        case VO_RESOLUTION_SET:
+            {
+                VO_RESOLUTION_INFO temp_vo_res_iofo;
+                if (copy_from_user(&temp_vo_res_iofo, (void *)arg,sizeof(VO_RESOLUTION_INFO)) != 0) goto err;
+                temp_vo_res_iofo.magic = 0x11223344;
+                pli_ipcCopyMemory((unsigned char*)vo_res_info, (unsigned char*)&temp_vo_res_iofo, sizeof(VO_RESOLUTION_INFO));
+                vo_window.dst_width = temp_vo_res_iofo.width;
+                vo_window.dst_height = temp_vo_res_iofo.height;
+                retval = 0;
+                break;
+            }
+        #else
+        case VO_RESOLUTION_GET:
+        case VO_RESOLUTION_SET:
+            {
+                retval = 0;
+                break;
+            }
+        #endif
+        default:
+            retval = -2;
+    }
+    return retval;
+err:
+    return -1;
+}
+
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/osd/osd.h b/drivers/video/fbdev/rtk/dc2vo/fpga/osd/osd.h
new file mode 100644
index 00000000..fe007fe
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/osd/osd.h
@@ -0,0 +1,169 @@
+#ifndef __FPGA_OSD_H__
+#define __FPGA_OSD_H__
+typedef struct
+{
+  unsigned int last:1 ;
+  unsigned int addr:31 ;
+
+} VO_OSD_WIN_NEXT_ADDR ;
+
+typedef struct
+{
+  unsigned int y:16 ;
+  unsigned int x:16 ;
+
+} VO_OSD_WIN_XY ;
+
+typedef struct
+{
+  unsigned int height:16 ;
+  unsigned int width:16 ;
+
+} VO_OSD_WIN_WH ;
+
+
+typedef struct
+{
+  unsigned int extendMode:1 ;
+  unsigned int rgbOrder:3 ;
+  unsigned int alphaType:1 ;
+  unsigned int alphaEn:1 ;
+  unsigned int storageMode:1 ;
+  unsigned int objType:1 ;
+  unsigned int alpha:8 ;
+  unsigned int reserved1:6 ;
+  unsigned int littleEndian:1 ;
+  unsigned int keepPreCLUT:1 ;
+  unsigned int reserved2:3 ;
+  unsigned int type:5 ;
+
+} VO_OSD_WIN_ATTR ;
+
+
+typedef struct
+{
+  unsigned int reserved:7 ;
+  unsigned int keyEn:1 ;
+  unsigned int key:24 ;
+
+}VO_OSD_WIN_KEY ;
+
+
+typedef struct
+{
+  unsigned int objYoffset:16 ;
+  unsigned int objXoffset:16 ;
+
+} VO_OSD_WIN_INIT ;
+
+
+typedef struct
+{
+  VO_OSD_WIN_NEXT_ADDR nxtAddr ;
+  /* Window Region */
+  VO_OSD_WIN_XY   winXY ;
+  VO_OSD_WIN_WH   winWH ;
+  /* Window Attribute */
+  VO_OSD_WIN_ATTR attr ;
+  unsigned int    CLUT_addr ;
+  VO_OSD_WIN_KEY  colorKey ;
+  unsigned int    top_addr ;    /* top or progressive OSD start address (sequential) or index (block mode) */
+  unsigned int    bot_addr ;    /* bottom OSD start address (sequential) or index (block mode) */
+  unsigned int    pitch ;
+  VO_OSD_WIN_INIT objOffset ;
+
+  unsigned int    reserved1;
+  unsigned int    reserved2;
+
+} VO_OSD_WIN ;
+
+typedef struct {
+    unsigned int magic; //11223344 means OK
+    unsigned int state;//0:OFF 1:ON
+    unsigned int order;//0~2:
+    unsigned int phyAddr;
+    unsigned int Height;
+    unsigned int Width;
+    unsigned int attr_rgbOrder;
+    unsigned int attr_type;
+    unsigned int reserve[6];
+} OSD_STATE;
+
+typedef struct {
+    unsigned int magic; //11223344 means OK
+    unsigned int state;  //0:OFF 1:ON
+    unsigned int Y_addr;
+    unsigned int U_addr;
+    unsigned int YUVFormat; //0:420 1:422
+    unsigned int width;
+    unsigned int height;
+    unsigned int Y_pitch;
+    unsigned int C_pitch;
+    unsigned int first;  // 0~2 top:2
+    unsigned int pts_inc;
+    unsigned int PTSH;
+    unsigned int PTSL;
+//    unsigned int pRefClock;
+} YUV_STATE_V0;
+
+typedef struct {
+    unsigned int magic; //11223344 means OK
+    unsigned int state;  //0:OFF 1:ON
+    unsigned int Y_addr;
+    unsigned int U_addr;
+    unsigned int YUVFormat; //0:420 1:422
+    unsigned int width;
+    unsigned int height;
+    unsigned int Y_pitch;
+    unsigned int C_pitch;
+    unsigned int first;  // 0~2 top:2
+    unsigned int pts_inc;
+    unsigned int PTSH;
+    unsigned int PTSL;
+    unsigned int pRefClock;
+    unsigned int dst_x;
+    unsigned int dst_y;
+    unsigned int dst_width;
+    unsigned int dst_height;
+} YUV_STATE;
+
+typedef struct {
+    unsigned int dst_x;
+    unsigned int dst_y;
+    unsigned int dst_width;
+    unsigned int dst_height;
+} WINDOW_INFO;
+
+typedef struct {
+    unsigned int phyAddr;
+    unsigned int reserve[7];
+} VO_RETURN;
+
+typedef struct{
+    unsigned int magic;  //0x11223344 means valid data
+    unsigned int width;  //vo resolution: width
+    unsigned int height; //vo resolution: height
+} VO_RESOLUTION_INFO ;
+
+#define OSD_IOC_MAGIC 'e'
+#define GET_OSD_STATE   _IO (OSD_IOC_MAGIC, 100)
+#define SET_OSD_STATE   _IO (OSD_IOC_MAGIC, 101)
+#define OSD_STATE_RESET _IO (OSD_IOC_MAGIC, 102)
+#define OSD_STATE_CLOSE _IO (OSD_IOC_MAGIC, 103)
+#define OSD_STATE_OPEN  _IO (OSD_IOC_MAGIC, 104)
+#define WRITE_YUV_STATE _IO (OSD_IOC_MAGIC, 105)
+#define READ_YUV_STATE  _IO (OSD_IOC_MAGIC, 106)
+#define READ_YUV_RETURN _IO (OSD_IOC_MAGIC, 107)
+#define YUV_WINDOW_GET  _IO (OSD_IOC_MAGIC, 108)
+#define YUV_WINDOW_SET  _IO (OSD_IOC_MAGIC, 109)
+#define YUV_WINDOW_OPEN  _IO (OSD_IOC_MAGIC, 110)
+#define YUV_WINDOW_CLOSE _IO (OSD_IOC_MAGIC, 111)
+
+#define VO_RESOLUTION_GET _IO (OSD_IOC_MAGIC, 200)
+#define VO_RESOLUTION_SET _IO (OSD_IOC_MAGIC, 201)
+
+int OSDShowPic(unsigned int srcW,unsigned int srcH,unsigned int pImage);
+int OSDShowPic2(unsigned int srcW,unsigned int srcH,unsigned int pImage);
+int OSD_Ioctl(unsigned int cmd, unsigned int arg);
+
+#endif
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/vo/VO_480p.c b/drivers/video/fbdev/rtk/dc2vo/fpga/vo/VO_480p.c
new file mode 100644
index 00000000..77c6922
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/vo/VO_480p.c
@@ -0,0 +1,539 @@
+#include <generated/autoconf.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/string.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <asm/io.h>
+#include "../include/os/type.h"
+#include "../include/hdmi_reg.h"
+#include "../include/tve_reg.h"
+#include "../include/aio_reg.h"
+#include "../include/vo_reg.h"
+//#######################################################################################################
+//
+//  File Name:      VO_480p.C
+//  Description:    Vedio Output 720x480p setting
+//
+//#######################################################################################################
+void VO_480p(INT8U Test_Pattern, INT8U Timing_Gen, INT8U Enable_3D, INT8U Format_3D, unsigned int YPhyAddr, unsigned int CPhyAddr)
+{
+    int leftflag = 0;
+    //0xb8005008
+    WRITE_REG_INT32U(VO_MIX1,
+                     VO_MIX1_i_vbi(1)|
+                     VO_MIX1_vbi(1)|
+                     VO_MIX1_osd1(1)|
+                     VO_MIX1_sub1(1)|
+                     VO_MIX1_v1(1)|
+                     VO_MIX1_bg(1)|
+                     VO_MIX1_write_data(0));
+    //0xb8005008
+    WRITE_REG_INT32U(VO_MIX1,
+                     VO_MIX1_i_vbi(0)|
+                     VO_MIX1_vbi(0)|
+                     VO_MIX1_osd1(0)|
+                     VO_MIX1_sub1(0)|
+                     VO_MIX1_v1(1)|
+                     VO_MIX1_bg(0)|
+                     VO_MIX1_write_data(1));
+    //0xb8005014
+    WRITE_REG_INT32U(VO_3D,
+                     VO_3D_top_and_bottom(1)|
+                     VO_3D_side_by_side(1)|
+                     VO_3D_right(1)|
+                     VO_3D_write_data(0));
+    //0xb8005020
+    WRITE_REG_INT32U(VO_V1,
+                     VO_V1_d3_dbh(1)|
+                     VO_V1_d3_dbw(1)|
+                     VO_V1_d3_dup(1)|
+                     VO_V1_st(1)|
+                     VO_V1_seq(1)|
+                     VO_V1_di(1)|
+                     VO_V1_f422(1)|
+                     VO_V1_vs(1)|
+                     VO_V1_vs_near(1)|
+                     VO_V1_vs_yodd(1)|
+                     VO_V1_vs_codd(1)|
+                     VO_V1_hs(1)|
+                     VO_V1_hs_yodd(1)|
+                     VO_V1_hs_codd(1)|
+                     VO_V1_topfield(1)|
+                     VO_V1_dmaweave(1)|
+                     VO_V1_write_data(0));
+#if 0
+    if(Enable_3D==1) //3D
+    {
+        //0xb8005000
+        WRITE_REG_INT32U(VO_MODE,
+                         VO_MODE_ch2i(0)|
+                         VO_MODE_ch2(0)|
+                         VO_MODE_ch1i(0)|
+                         VO_MODE_ch1(1)|
+                         VO_MODE_write_data(1));
+        //0xb8005000
+        WRITE_REG_INT32U(VO_MODE,
+                         VO_MODE_ch2i(1)|
+                         VO_MODE_ch2(1)|
+                         VO_MODE_ch1i(1)|
+                         VO_MODE_ch1(0)|
+                         VO_MODE_write_data(0));
+        //0xb8005004
+        WRITE_REG_INT32U(VO_OUT,
+                         VO_OUT_write_en3(1)|VO_OUT_h(1)|
+                         VO_OUT_write_en2(1)|VO_OUT_i(0)|
+                         VO_OUT_write_en1(1)|VO_OUT_p(0));
+        if(Format_3D==0)
+        {
+            //0xb8005020
+            WRITE_REG_INT32U(VO_V1,
+                             VO_V1_d3_dbh(0)|
+                             VO_V1_d3_dbw(0)|
+                             VO_V1_d3_dup(0)|
+                             VO_V1_st(0)|
+                             VO_V1_seq(1)|
+                             VO_V1_di(0)|
+                             VO_V1_f422(1)|
+                             VO_V1_vs(0)|
+                             VO_V1_vs_near(0)|
+                             VO_V1_vs_yodd(0)|
+                             VO_V1_vs_codd(0)|
+                             VO_V1_hs(0)|
+                             VO_V1_hs_yodd(0)|
+                             VO_V1_hs_codd(0)|
+                             VO_V1_topfield(0)|
+                             VO_V1_dmaweave(0)|
+                             VO_V1_write_data(1));
+            //0xb8005038
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_Y, VO_V1_SEQ_SA_C_Y_a(0xe000000));
+            //0xb800503c
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_C, VO_V1_SEQ_SA_C_C_a(0xe060000));
+            //0xb8005058
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_Y_3D, VO_V1_SEQ_SA_C_Y_3D_a(0xe7b8000));
+            //0xb800505c
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_C_3D, VO_V1_SEQ_SA_C_C_3D_a(0xe818000));
+            //0xb8005048
+            WRITE_REG_INT32U(VO_V1_SEQ_PITCH_C_Y, VO_V1_SEQ_PITCH_C_Y_p(720));
+            //0xb800504c
+            WRITE_REG_INT32U(VO_V1_SEQ_PITCH_C_C, VO_V1_SEQ_PITCH_C_C_p(720));
+            //0xb8005068
+            WRITE_REG_INT32U(VO_V1_SIZE,
+                             VO_V1_SIZE_w(720)|
+                             VO_V1_SIZE_h(480));
+            //0xb8005604
+            WRITE_REG_INT32U(VO_M1_SIZE,
+                             VO_M1_SIZE_w(720)|
+                             VO_M1_SIZE_h(480));
+        }
+        if(Format_3D==6)
+        {
+            //0xb8005020
+            WRITE_REG_INT32U(VO_V1,
+                             VO_V1_d3_dbh(1)|
+                             VO_V1_d3_dbw(0)|
+                             VO_V1_d3_dup(0)|
+                             VO_V1_st(0)|
+                             VO_V1_seq(1)|
+                             VO_V1_di(0)|
+                             VO_V1_f422(1)|
+                             VO_V1_vs(0)|
+                             VO_V1_vs_near(0)|
+                             VO_V1_vs_yodd(0)|
+                             VO_V1_vs_codd(0)|
+                             VO_V1_hs(0)|
+                             VO_V1_hs_yodd(0)|
+                             VO_V1_hs_codd(0)|
+                             VO_V1_topfield(0)|
+                             VO_V1_dmaweave(0)|
+                             VO_V1_write_data(1));
+            //0xb8005038
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_Y, VO_V1_SEQ_SA_C_Y_a(0xd000000));
+            //0xb800503c
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_C, VO_V1_SEQ_SA_C_C_a(0xd060000));
+            //0xb8005048
+            WRITE_REG_INT32U(VO_V1_SEQ_PITCH_C_Y, VO_V1_SEQ_PITCH_C_Y_p(720));
+            //0xb800504c
+            WRITE_REG_INT32U(VO_V1_SEQ_PITCH_C_C, VO_V1_SEQ_PITCH_C_C_p(720));
+            //0xb8005068
+            WRITE_REG_INT32U(VO_V1_SIZE,
+                             VO_V1_SIZE_w(720)|
+                             VO_V1_SIZE_h(240));
+            //0xb8005604
+            WRITE_REG_INT32U(VO_M1_SIZE,
+                             VO_M1_SIZE_w(720)|
+                             VO_M1_SIZE_h(240));
+        }
+        if(Format_3D==8)
+        {
+            //0xb8005020
+            WRITE_REG_INT32U(VO_V1,
+                             VO_V1_d3_dbh(0)|
+                             VO_V1_d3_dbw(1)|
+                             VO_V1_d3_dup(0)|
+                             VO_V1_st(0)|
+                             VO_V1_seq(1)|
+                             VO_V1_di(0)|
+                             VO_V1_f422(1)|
+                             VO_V1_vs(0)|
+                             VO_V1_vs_near(0)|
+                             VO_V1_vs_yodd(0)|
+                             VO_V1_vs_codd(0)|
+                             VO_V1_hs(0)|
+                             VO_V1_hs_yodd(0)|
+                             VO_V1_hs_codd(0)|
+                             VO_V1_topfield(0)|
+                             VO_V1_dmaweave(0)|
+                             VO_V1_write_data(1));
+            //0xb8005038
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_Y, VO_V1_SEQ_SA_C_Y_a(0xd7b8000));
+            //0xb800503c
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_C, VO_V1_SEQ_SA_C_C_a(0xd818000));
+            //0xb8005048
+            WRITE_REG_INT32U(VO_V1_SEQ_PITCH_C_Y, VO_V1_SEQ_PITCH_C_Y_p(720));
+            //0xb800504c
+            WRITE_REG_INT32U(VO_V1_SEQ_PITCH_C_C, VO_V1_SEQ_PITCH_C_C_p(720));
+            //0xb8005068
+            WRITE_REG_INT32U(VO_V1_SIZE,
+                             VO_V1_SIZE_w(360)|
+                             VO_V1_SIZE_h(480));
+            //0xb8005604
+            WRITE_REG_INT32U(VO_M1_SIZE,
+                             VO_M1_SIZE_w(360)|
+                             VO_M1_SIZE_h(480));
+        }
+        //0xb8005610
+        WRITE_REG_INT32U(VO_V1_XY,
+                         VO_V1_XY_x(0)|
+                         VO_V1_XY_y(0));
+        //0xb8005644
+        WRITE_REG_INT32U(VO_CH1,
+                         VO_CH1_itop(1)|
+                         VO_CH1_ireint(1)|
+                         VO_CH1_top(1)|
+                         VO_CH1_reint(1)|
+                         VO_CH1_write_data(0));
+    }
+    else //2D
+#endif
+    {
+        //0xb8005000
+        WRITE_REG_INT32U(VO_MODE,
+                         VO_MODE_ch2i(0)|
+                         VO_MODE_ch2(0)|
+                         VO_MODE_ch1i(0)|
+                         VO_MODE_ch1(1)|
+                         VO_MODE_write_data(1));
+        //0xb8005000
+        WRITE_REG_INT32U(VO_MODE,
+                         VO_MODE_ch2i(1)|
+                         VO_MODE_ch2(1)|
+                         VO_MODE_ch1i(1)|
+                         VO_MODE_ch1(0)|
+                         VO_MODE_write_data(0));
+        if(Timing_Gen)
+        {
+            //0xb8005004
+            WRITE_REG_INT32U(VO_OUT,
+                             VO_OUT_write_en3(1)|VO_OUT_h(1)|
+                             VO_OUT_write_en2(1)|VO_OUT_i(0)|
+                             VO_OUT_write_en1(1)|VO_OUT_p(0));
+        }
+        else
+        {
+            //0xb8005004
+            WRITE_REG_INT32U(VO_OUT,
+                             VO_OUT_write_en3(1)|VO_OUT_h(0)|
+                             VO_OUT_write_en2(1)|VO_OUT_i(0)|
+                             VO_OUT_write_en1(1)|VO_OUT_p(1));
+        }
+        //0xb8005020
+        WRITE_REG_INT32U(VO_V1,
+                         VO_V1_d3_dbh(0)|
+                         VO_V1_d3_dbw(0)|
+                         VO_V1_d3_dup(0)|
+                         VO_V1_st(0)|
+                         VO_V1_seq(1)|
+                         VO_V1_di(0)|
+                         VO_V1_f422(1)|
+                         VO_V1_vs(0)|
+                         VO_V1_vs_near(0)|
+                         VO_V1_vs_yodd(0)|
+                         VO_V1_vs_codd(0)|
+                         VO_V1_hs(0)|
+                         VO_V1_hs_yodd(0)|
+                         VO_V1_hs_codd(0)|
+                         VO_V1_topfield(0)|
+                         VO_V1_dmaweave(0)|
+                         VO_V1_write_data(1));
+        if(Test_Pattern)
+        {
+            //0xb8005038
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_Y, VO_V1_SEQ_SA_C_Y_a(YPhyAddr));
+            //0xb800503c
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_C, VO_V1_SEQ_SA_C_C_a(CPhyAddr));
+        }
+        else
+        {
+            //0xb8005038
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_Y, VO_V1_SEQ_SA_C_Y_a(YPhyAddr));
+            //0xb800503c
+            WRITE_REG_INT32U(VO_V1_SEQ_SA_C_C, VO_V1_SEQ_SA_C_C_a(CPhyAddr));
+        }
+        //0xb8005048
+        WRITE_REG_INT32U(VO_V1_SEQ_PITCH_C_Y, VO_V1_SEQ_PITCH_C_Y_p(720));
+        //0xb800504c
+        WRITE_REG_INT32U(VO_V1_SEQ_PITCH_C_C, VO_V1_SEQ_PITCH_C_C_p(720));
+        //0xb8005068
+        WRITE_REG_INT32U(VO_V1_SIZE,
+                         VO_V1_SIZE_w(720)|
+                         VO_V1_SIZE_h(480));
+        //0xb8005604
+        WRITE_REG_INT32U(VO_M1_SIZE,
+                         VO_M1_SIZE_w(720)|
+                         VO_M1_SIZE_h(480));
+        //0xb8005610
+        WRITE_REG_INT32U(VO_V1_XY,
+                         VO_V1_XY_x(0)|
+                         VO_V1_XY_y(0));
+        //0xb8005644
+        WRITE_REG_INT32U(VO_CH1,
+                         VO_CH1_itop(1)|
+                         VO_CH1_ireint(1)|
+                         VO_CH1_top(1)|
+                         VO_CH1_reint(1)|
+                         VO_CH1_write_data(0));
+    }
+
+    //--------------------------------------------------------------
+    //Set TVE general control
+    //--------------------------------------------------------------
+    //0xb8018040
+    WRITE_REG_INT32U(TVE_AV_CTRL,
+                     TVE_AV_CTRL_h_colorbar_ebl(1)|
+                     TVE_AV_CTRL_h_black_ebl(1)|
+                     TVE_AV_CTRL_i_colorbar_ebl(1)|
+                     TVE_AV_CTRL_p_colorbar_ebl(1)|
+                     TVE_AV_CTRL_i_black_ebl(1)|
+                     TVE_AV_CTRL_p_black_ebl(1)|
+                     TVE_AV_CTRL_write_data(0));
+    //0xb8018028
+    WRITE_REG_INT32U(TVE_INTPOS_P1,
+                     TVE_INTPOS_P1_write_en2(1)|TVE_INTPOS_P1_int_vpos(2)|
+                     TVE_INTPOS_P1_write_en1(1)|TVE_INTPOS_P1_int_hpos(0));
+    //0xb8018020
+    WRITE_REG_INT32U(TVE_INTST,
+                     TVE_INTST_intst_h(1)|
+                     TVE_INTST_intst_i(1)|
+                     TVE_INTST_intst_p(1)|
+                     TVE_INTST_write_data(0));
+
+#if 0
+
+    while(*UART_flag==1)
+    {
+        UART_READ();
+        if(Enable_3D==1) //3D
+        {
+            if(Format_3D==0)
+            {
+                if(HDMI_INTSTV_get_vsyncupdated(*(volatile unsigned int *)HDMI_INTSTV))
+                {
+                    leftflag = 1;
+                    //0xb800d278
+                    WRITE_REG_INT32U(HDMI_INTSTV,
+                                     HDMI_INTSTV_vendupdated(0)|
+                                     HDMI_INTSTV_vsyncupdated(0));
+                    //0xb8005014
+                    WRITE_REG_INT32U(VO_3D,
+                                     VO_3D_top_and_bottom(0)|
+                                     VO_3D_side_by_side(0)|
+                                     VO_3D_right(1)|
+                                     VO_3D_write_data(0));
+                    //0xb80056d0
+                    WRITE_REG_INT32U(VO_INTST,
+                                     VO_INTST_h_under(0)|
+                                     VO_INTST_i_under(0)|
+                                     VO_INTST_p_under(0)|
+                                     VO_INTST_sub1(0)|
+                                     VO_INTST_wbfin(0)|
+                                     VO_INTST_m2fin(0)|
+                                     VO_INTST_m1fin(1)|
+                                     VO_INTST_write_data(0));
+                    //0xb8005018
+                    WRITE_REG_INT32U(VO_FC,
+                                     VO_FC_wbgo(0)|
+                                     VO_FC_m2go(0)|
+                                     VO_FC_m1go(1)|
+                                     VO_FC_write_data(1));                            
+                }
+                if(HDMI_INTSTV_get_vendupdated(*(volatile unsigned int *)HDMI_INTSTV) && leftflag)
+                {
+                    leftflag = 0;                                
+                    //0xb800d278
+                    WRITE_REG_INT32U(HDMI_INTSTV,
+                                     HDMI_INTSTV_vendupdated(0)|
+                                     HDMI_INTSTV_vsyncupdated(0));
+                    //0xb8005014
+                    WRITE_REG_INT32U(VO_3D,
+                                     VO_3D_top_and_bottom(0)|
+                                     VO_3D_side_by_side(0)|
+                                     VO_3D_right(1)|
+                                     VO_3D_write_data(1));
+                    //0xb80056d0
+                    WRITE_REG_INT32U(VO_INTST,
+                                     VO_INTST_h_under(0)|
+                                     VO_INTST_i_under(0)|
+                                     VO_INTST_p_under(0)|
+                                     VO_INTST_sub1(0)|
+                                     VO_INTST_wbfin(0)|
+                                     VO_INTST_m2fin(0)|
+                                     VO_INTST_m1fin(1)|
+                                     VO_INTST_write_data(0));
+                    //0xb8005018
+                    WRITE_REG_INT32U(VO_FC,
+                                     VO_FC_wbgo(0)|
+                                     VO_FC_m2go(0)|
+                                     VO_FC_m1go(1)|
+                                     VO_FC_write_data(1));
+                }
+            }
+            if(Format_3D==6)
+            {
+                if(HDMI_INTSTV_get_vsyncupdated(*(volatile unsigned int *)HDMI_INTSTV))
+                {
+                    //0xb800d278
+                    WRITE_REG_INT32U(HDMI_INTSTV,
+                                     HDMI_INTSTV_vendupdated(0)|
+                                     HDMI_INTSTV_vsyncupdated(0));
+                    //0xb8005014
+                    WRITE_REG_INT32U(VO_3D,
+                                     VO_3D_top_and_bottom(1)|
+                                     VO_3D_side_by_side(0)|
+                                     VO_3D_right(0)|
+                                     VO_3D_write_data(1));
+                    //0xb80056d0
+                    WRITE_REG_INT32U(VO_INTST,
+                                     VO_INTST_h_under(0)|
+                                     VO_INTST_i_under(0)|
+                                     VO_INTST_p_under(0)|
+                                     VO_INTST_sub1(0)|
+                                     VO_INTST_wbfin(0)|
+                                     VO_INTST_m2fin(0)|
+                                     VO_INTST_m1fin(1)|
+                                     VO_INTST_write_data(0));
+                    //0xb8005018
+                    WRITE_REG_INT32U(VO_FC,
+                                     VO_FC_wbgo(0)|
+                                     VO_FC_m2go(0)|
+                                     VO_FC_m1go(1)|
+                                     VO_FC_write_data(1));                            
+                }
+            } 
+            if(Format_3D==8)
+            {
+                if(HDMI_INTSTV_get_vsyncupdated(*(volatile unsigned int *)HDMI_INTSTV))
+                {
+                    //0xb800d278
+                    WRITE_REG_INT32U(HDMI_INTSTV,
+                                     HDMI_INTSTV_vendupdated(0)|
+                                     HDMI_INTSTV_vsyncupdated(0));
+                    //0xb8005014
+                    WRITE_REG_INT32U(VO_3D,
+                                     VO_3D_top_and_bottom(0)|
+                                     VO_3D_side_by_side(1)|
+                                     VO_3D_right(0)|
+                                     VO_3D_write_data(1));
+                    //0xb80056d0
+                    WRITE_REG_INT32U(VO_INTST,
+                                     VO_INTST_h_under(0)|
+                                     VO_INTST_i_under(0)|
+                                     VO_INTST_p_under(0)|
+                                     VO_INTST_sub1(0)|
+                                     VO_INTST_wbfin(0)|
+                                     VO_INTST_m2fin(0)|
+                                     VO_INTST_m1fin(1)|
+                                     VO_INTST_write_data(0));
+                    //0xb8005018
+                    WRITE_REG_INT32U(VO_FC,
+                                     VO_FC_wbgo(0)|
+                                     VO_FC_m2go(0)|
+                                     VO_FC_m1go(1)|
+                                     VO_FC_write_data(1));                            
+                }
+            }
+            if(VO_INTST_get_h_under(*(volatile unsigned int *)VO_INTST))
+            {
+                //0xb80056d0
+                WRITE_REG_INT32U(VO_INTST,
+                                 VO_INTST_h_under(1)|
+                                 VO_INTST_i_under(0)|
+                                 VO_INTST_p_under(0)|
+                                 VO_INTST_sub1(0)|
+                                 VO_INTST_wbfin(0)|
+                                 VO_INTST_m2fin(0)|
+                                 VO_INTST_m1fin(0)|
+                                 VO_INTST_write_data(0));
+            }
+        }
+        else //2D
+        {
+            if(HDMI_INTSTV_get_vsyncupdated(*(volatile unsigned int *)HDMI_INTSTV))
+            {
+                //0xb800d278
+                WRITE_REG_INT32U(HDMI_INTSTV,
+                                 HDMI_INTSTV_vendupdated(0)|
+                                 HDMI_INTSTV_vsyncupdated(0));
+                //0xb80056d0
+                WRITE_REG_INT32U(VO_INTST,
+                                 VO_INTST_h_under(0)|
+                                 VO_INTST_i_under(0)|
+                                 VO_INTST_p_under(0)|
+                                 VO_INTST_sub1(0)|
+                                 VO_INTST_wbfin(0)|
+                                 VO_INTST_m2fin(0)|
+                                 VO_INTST_m1fin(1)|
+                                 VO_INTST_write_data(0));
+                //0xb8005018
+                WRITE_REG_INT32U(VO_FC,
+                                 VO_FC_wbgo(0)|
+                                 VO_FC_m2go(0)|
+                                 VO_FC_m1go(1)|
+                                 VO_FC_write_data(1));
+                if(Timing_Gen)
+                {
+                    if(VO_INTST_get_h_under(*(volatile unsigned int *)VO_INTST))
+                    {
+                        //0xb80056d0
+                        WRITE_REG_INT32U(VO_INTST,
+                                         VO_INTST_h_under(1)|
+                                         VO_INTST_i_under(0)|
+                                         VO_INTST_p_under(0)|
+                                         VO_INTST_sub1(0)|
+                                         VO_INTST_wbfin(0)|
+                                         VO_INTST_m2fin(0)|
+                                         VO_INTST_m1fin(0)|
+                                         VO_INTST_write_data(0));
+                    }
+                }
+                else
+                {
+                    if(VO_INTST_get_p_under(*(volatile unsigned int *)VO_INTST))
+                    {
+                        //0xb80056d0
+                        WRITE_REG_INT32U(VO_INTST,
+                                         VO_INTST_h_under(0)|
+                                         VO_INTST_i_under(0)|
+                                         VO_INTST_p_under(1)|
+                                         VO_INTST_sub1(0)|
+                                         VO_INTST_wbfin(0)|
+                                         VO_INTST_m2fin(0)|
+                                         VO_INTST_m1fin(0)|
+                                         VO_INTST_write_data(0));
+                    }                            	
+                }
+            }
+        }
+    }
+#endif
+}
diff --git a/drivers/video/fbdev/rtk/dc2vo/fpga/vo/vo.h b/drivers/video/fbdev/rtk/dc2vo/fpga/vo/vo.h
new file mode 100644
index 00000000..769c8a5
--- /dev/null
+++ b/drivers/video/fbdev/rtk/dc2vo/fpga/vo/vo.h
@@ -0,0 +1,4 @@
+#ifndef __FPGA_VO_H__
+#define __FPGA_VO_H__
+void VO_480p(INT8U Test_Pattern, INT8U Timing_Gen, INT8U Enable_3D, INT8U Format_3D, unsigned int YPhyAddr, unsigned int CPhyAddr);
+#endif
diff --git a/drivers/video/fbdev/rtk/debug.h b/drivers/video/fbdev/rtk/debug.h
new file mode 100644
index 00000000..ff5f859
--- /dev/null
+++ b/drivers/video/fbdev/rtk/debug.h
@@ -0,0 +1,56 @@
+#ifndef __DEBUG_RTK_H__
+#define __DEBUG_RTK_H__
+
+#define NONE            "\033[m"
+#define RED             "\033[0;32;31m"
+#define LIGHT_RED       "\033[1;31m"
+#define GREEN           "\033[0;32;32m"
+#define LIGHT_GREEN     "\033[1;32m"
+#define BLUE            "\033[0;32;34m"
+#define LIGHT_BLUE      "\033[1;34m"
+#define DARY_GRAY       "\033[1;30m"
+#define CYAN            "\033[0;36m"
+#define LIGHT_CYAN      "\033[1;36m"
+#define PURPLE          "\033[0;35m"
+#define LIGHT_PURPLE    "\033[1;35m"
+#define BROWN           "\033[0;33m"
+#define YELLOW          "\033[1;33m"
+#define LIGHT_GRAY      "\033[0;37m"
+#define WHITE           "\033[1;37m"
+
+#define ATTR_OFF        "\033[0m"
+#define BOLD            "\033[1m"
+#define UNDERSCORE      "\033[4m"
+#define BLINK           "\033[5m"
+#define REVERSE         "\033[7m"
+#define CONCEALED       "\033[8m"
+
+#define dbg_fmt(fmt) fmt
+
+#define dbg_err(fmt, ...) \
+	printk(KERN_ERR RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_emerg(fmt, ...) \
+	printk(KERN_EMERG RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_alert(fmt, ...) \
+	printk(KERN_ALERT RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_crit(fmt, ...) \
+	printk(KERN_CRIT RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_warning(fmt, ...) \
+	printk(KERN_WARNING RED dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_warn dbg_warning
+
+#define dbg_info(fmt, ...) \
+	printk(KERN_INFO CYAN dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_notice(fmt, ...) \
+	printk(KERN_NOTICE CYAN dbg_fmt(fmt) NONE"\n", ##__VA_ARGS__)
+
+#define dbg_cont(fmt, ...) \
+	printk(KERN_CONT CYAN fmt NONE"\n", ##__VA_ARGS__)
+
+#endif /* __DEBUG_RTK_H__ */
diff --git a/drivers/video/fbdev/rtk/rtk_fb.c b/drivers/video/fbdev/rtk/rtk_fb.c
new file mode 100644
index 00000000..b82c0280
--- /dev/null
+++ b/drivers/video/fbdev/rtk/rtk_fb.c
@@ -0,0 +1,840 @@
+/*
+ *  android_fb.c
+ * 
+ *  Copyright 2007, The Android Open Source Project
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 2 as
+ *  published by the Free Software Foundation.
+ */
+
+
+/*
+ * ANDROID PORTING GUIDE: FRAME BUFFER DRIVER TEMPLATE
+ *
+ * This template is designed to provide the minimum frame buffer
+ * functionality necessary for Android to display properly on a new
+ * device.  The PGUIDE_FB macros are meant as pointers indicating
+ * where to implement the hardware specific code necessary for the new
+ * device.  The existence of the macros is not meant to trivialize the
+ * work required, just as an indication of where the work needs to be
+ * done.
+ */
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/string.h>
+#include <linux/slab.h>
+#include <linux/delay.h>
+#include <linux/mm.h>
+
+#include <linux/uaccess.h>
+#include <linux/init.h>
+#include <linux/platform_device.h>
+#include <linux/init.h>
+#include <linux/dma-mapping.h>
+#include <linux/of_device.h>
+#include <linux/of_platform.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/io.h>
+#include <linux/dma-contiguous.h>
+#include <asm/div64.h>
+
+#include "debug.h"
+#include "rtk_fb.h"
+
+#include "dc2vo/dc2vo.h"
+#include "rtk_fb_RPC.h"
+#include "rtk_fb_freelogo.h"
+
+#ifdef CONFIG_REALTEK_AVCPU
+#include "avcpu.h"
+#endif
+
+
+#define USE_UMP 1
+#ifdef USE_UMP
+#include <linux/ump.h>
+#include <linux/ump_fb.h>
+#define IOCTL_GET_FB_UMP_SECURE_ID _IOWR('m', 0xF8, __u32)
+static ump_dd_handle ump_wrapped_buffer = UMP_DD_INVALID_MEMORY_HANDLE;
+#endif
+
+struct fb_dmabuf_export
+{
+	__u32 fd;
+	__u32 flags;
+};
+#define FBIOGET_DMABUF  _IOR('F', 0x21, struct fb_dmabuf_export)
+
+struct fb_resize
+{
+	__u32 width;
+	__u32 height;
+	__u32 count;
+	__u32 byte_per_pixel;
+	__u32 reserve[16-4];
+};
+#define FBIOSET_RESIZE  _IOWR('F', 0x22, struct fb_resize)
+
+
+#include "../../../../drivers/staging/android/ion/ion.h"
+#include "../../../../drivers/staging/android/uapi/ion_rtk.h"
+extern struct ion_device *rtk_phoenix_ion_device;
+
+#define ANDROID_NUMBER_OF_FPS 60
+#define ANDROID_BYTES_PER_PIXEL 4
+static int debug = 0;
+static uint32_t my_fb_node=0; //__LINUX_MEDIA_NAS__
+#define dprintk(msg...) if (debug)   { printk(KERN_ALERT	"D/RTK_FB: " msg); }
+//#define dprintk(msg...) if (debug)   { dbg_info(KERN_DEBUG	"D/RTK_FB: " msg); }
+
+#define MEMORY_ALIGN( value, base ) (((value) + ((base) - 1)) & ~((base) - 1))
+
+#ifdef USE_UMP
+static struct ump_operations ump_ops;
+
+int ump_ops_register(struct ump_operations *cb)
+{
+	printk(KERN_ALERT "register ump cb\n");
+	ump_ops.create_from_phys_blocks_64 = cb->create_from_phys_blocks_64;
+	ump_ops.create_from_phys_blocks = cb->create_from_phys_blocks;
+	ump_ops.secure_id_get = cb->secure_id_get;
+	return 1;
+}
+
+//EXPORT_SYMBOL(ump_ops);
+EXPORT_SYMBOL(ump_ops_register);
+#endif
+
+enum rtk_fb_memory_flags {
+	RTK_FB_MEM_ALLOC_ALGO_LAST_FIT = 0x1 << 0,
+	RTK_FB_MEM_FREE_FB = 0x1 << 1,
+};
+
+__maybe_unused static int rtk_fb_set_size (struct rtk_fb *fb, int width, int height, int count, int byte_per_pixel, int flags);
+
+__maybe_unused static int rtk_fb_memory_alloc (struct rtk_fb_memory **ppMem, int width, int height, int byte_per_pixel ,int align, int count, int flags);
+__maybe_unused static void rtk_fb_memory_destroy (struct rtk_fb_memory **ppMem);
+__maybe_unused static unsigned long rtk_fb_memory_phy (struct rtk_fb_memory *pMem);
+__maybe_unused static void *rtk_fb_memory_map (struct rtk_fb_memory *pMem);
+__maybe_unused static int rtk_fb_memory_share_fd (struct rtk_fb_memory *pMem);
+__maybe_unused static inline size_t rtk_fb_memory_size (struct rtk_fb_memory *pMem) { return (pMem != NULL) ? pMem->alloc_size:0;}
+__maybe_unused static inline int	rtk_fb_memory_width (struct rtk_fb_memory *pMem) { return (pMem != NULL) ? pMem->width:0;}
+__maybe_unused static inline int	rtk_fb_memory_height (struct rtk_fb_memory *pMem) { return (pMem != NULL) ? pMem->height:0;}
+__maybe_unused static inline int	rtk_fb_memory_align (struct rtk_fb_memory *pMem) { return (pMem != NULL) ? pMem->align:0;}
+__maybe_unused static inline int	rtk_fb_memory_count (struct rtk_fb_memory *pMem) { return (pMem != NULL) ? pMem->count:0;}
+__maybe_unused static inline int	rtk_fb_memory_bypePrePixel  (struct rtk_fb_memory *pMem) { return (pMem != NULL) ? pMem->byte_per_pixel:ANDROID_BYTES_PER_PIXEL;}
+
+int osd_status;
+
+static int fb_avcpu_event_notify(struct notifier_block *self, unsigned long action, void *data)
+{
+	struct fb_info *info = (struct fb_info *)registered_fb[my_fb_node]; //__LINUX_MEDIA_NAS__
+	struct rtk_fb *fb = container_of(info, struct rtk_fb, fb);
+	return DC_avcpu_event_notify(action, &fb->video_info);
+}
+
+__maybe_unused static struct notifier_block fb_avcpu_event_notifier = {
+	.notifier_call = fb_avcpu_event_notify,
+};
+
+static inline u32 convert_bitfield(int val, struct fb_bitfield *bf)
+{
+	unsigned int mask = (1 << bf->length) - 1;
+
+	return (val >> (16 - bf->length) & mask) << bf->offset;
+}
+
+/* set the software color map.  Probably doesn't need modifying. */
+static int rtk_fb_setcolreg(unsigned int regno, unsigned int red, unsigned int green,
+	unsigned int blue, unsigned int transp, struct fb_info *info)
+{
+	struct rtk_fb *fb = container_of(info, struct rtk_fb, fb);
+
+	if (regno < 16) {
+		fb->cmap[regno] = convert_bitfield(transp, &fb->fb.var.transp) |
+			convert_bitfield(blue, &fb->fb.var.blue) |
+			convert_bitfield(green, &fb->fb.var.green) |
+			convert_bitfield(red, &fb->fb.var.red);
+		return 0;
+	} else {
+		return 1;
+	}
+}
+
+/* check var to see if supported by this device.  Probably doesn't
+ * need modifying.
+ */
+static int rtk_fb_check_var(struct fb_var_screeninfo *var, struct fb_info *info)
+{
+	struct rtk_fb *fb = container_of(info, struct rtk_fb, fb);
+
+	dprintk("[%s %d]\n", __func__, __LINE__);
+#if 0
+	if ((var->rotate & 1) != (info->var.rotate & 1)) {
+		if ((var->xres != info->var.yres) ||
+			(var->yres != info->var.xres) ||
+			(var->xres_virtual != info->var.yres) ||
+			(var->yres_virtual > info->var.xres * ANDROID_NUMBER_OF_BUFFERS) ||
+			(var->yres_virtual < info->var.xres )) {
+			return -EINVAL;
+		}
+	} else {
+		if ((var->xres != info->var.xres) ||
+			(var->yres != info->var.yres) ||
+			(var->xres_virtual != info->var.xres) ||
+			(var->yres_virtual > info->var.yres * ANDROID_NUMBER_OF_BUFFERS) ||
+			(var->yres_virtual < info->var.yres )) {
+			return -EINVAL;
+		}
+	}
+	if ((var->xoffset != info->var.xoffset) ||
+		(var->bits_per_pixel != info->var.bits_per_pixel) ||
+		(var->grayscale != info->var.grayscale)) {
+		return -EINVAL;
+	}
+#endif
+
+	if (info->var.xres_virtual > rtk_fb_memory_width(fb->pMem))
+		info->var.xres_virtual = rtk_fb_memory_width(fb->pMem);
+	if (info->var.yres_virtual > (rtk_fb_memory_height(fb->pMem) *rtk_fb_memory_count(fb->pMem)))
+		info->var.yres_virtual = rtk_fb_memory_height(fb->pMem) *rtk_fb_memory_count(fb->pMem);
+
+	return 0;
+}
+
+static int rtk_fb_set_par(struct fb_info *info)
+{
+	struct rtk_fb *fb = container_of(info, struct rtk_fb, fb);
+	if (fb->rotation != fb->fb.var.rotate) {
+		dbg_info("[%s %d] TODO: FB_ROTATE\n",__func__,__LINE__);
+
+		info->fix.line_length   = info->var.xres * rtk_fb_memory_bypePrePixel(fb->pMem);
+		fb->rotation = fb->fb.var.rotate;
+	}
+
+	if (info->var.xres_virtual > rtk_fb_memory_width(fb->pMem))
+		info->var.xres_virtual = rtk_fb_memory_width(fb->pMem);
+	if (info->var.yres_virtual > (rtk_fb_memory_height(fb->pMem) * rtk_fb_memory_count(fb->pMem)))
+		info->var.yres_virtual = rtk_fb_memory_height(fb->pMem) * rtk_fb_memory_count(fb->pMem);
+
+	return 0;
+}
+
+__maybe_unused static int rtk_fb_blank(int blank_mode, struct fb_info *info)
+{
+	return 0;
+}
+
+static int rtk_fb_pan_display(struct fb_var_screeninfo *var, struct fb_info *info)
+{
+	struct rtk_fb *fb __attribute__ ((unused)) = container_of(info, struct rtk_fb, fb);
+
+	/* Set the frame buffer base to something like:
+	 * fb->fb.fix.smem_start + fb->fb.var.xres *
+	 * ANDROID_BYTES_PER_PIXEL * var->yoffset
+	*/
+	fb->fb.var.xoffset = var->xoffset;
+	fb->fb.var.yoffset = var->yoffset;
+	fb->fb.var.xres_virtual = var->xres_virtual;
+	fb->fb.var.yres_virtual = var->yres_virtual;
+
+	return DC_Swap_Buffer(info, &fb->video_info);
+}
+
+static int rtk_fb_mmap(struct fb_info *info, struct vm_area_struct *vma)
+{
+	struct rtk_fb *fb __attribute__ ((unused)) = container_of(info, struct rtk_fb, fb);
+	unsigned long start;
+	unsigned long mmio_pgoff;
+	u32 len;
+
+	start = info->fix.smem_start;
+	len = info->fix.smem_len;
+	mmio_pgoff  = PAGE_ALIGN((start & ~PAGE_MASK) + len) >> PAGE_SHIFT;
+
+	if (vma->vm_pgoff >= mmio_pgoff) {
+		if (info->var.accel_flags) {
+			return -EINVAL;
+		}
+
+		vma->vm_pgoff -= mmio_pgoff;
+		start   = info->fix.mmio_start;
+		len	 = info->fix.mmio_len;
+	}
+	//vma->vm_page_prot = vm_get_page_prot(vma->vm_flags);
+	//vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+	vma->vm_page_prot = pgprot_writecombine(vma->vm_page_prot);
+	return vm_iomap_memory(vma, start, len);
+}
+
+#ifdef USE_UMP
+static int ump_wrapper(struct fb_info *info)
+{
+	ump_dd_physical_block blocks;
+	unsigned long block_num = 1;
+
+	if (ump_wrapped_buffer != UMP_DD_INVALID_MEMORY_HANDLE)
+		return 1;
+
+	blocks.addr = info->fix.smem_start;
+	blocks.size = info->fix.smem_len;
+	ump_wrapped_buffer = ump_ops.create_from_phys_blocks(&blocks, block_num);
+
+	if (ump_wrapped_buffer == UMP_DD_INVALID_MEMORY_HANDLE)
+		return 0;
+	else
+		return 1;
+}
+#endif
+
+static int rtk_fb_ioctl(struct fb_info *info, unsigned int cmd, unsigned long arg)
+{
+	struct rtk_fb *fb __attribute__ ((unused)) = container_of(info, struct rtk_fb, fb);
+	int gat_cmd = 0;
+	int ret = 0;
+
+	switch (cmd) {
+	case FBIOSET_RESIZE:
+		{
+			struct fb_resize sNewSize;
+
+			if (copy_from_user(&sNewSize, (void *)arg, sizeof(sNewSize)) == 0) {
+				rtk_fb_set_size(fb, sNewSize.width, sNewSize.height, sNewSize.count, sNewSize.byte_per_pixel, RTK_FB_MEM_FREE_FB);
+			}
+			gat_cmd = 1;
+			break;
+		}
+	case FBIOGET_DMABUF:
+		{
+			struct fb_dmabuf_export __user *up_dmabuf_export = (struct fb_dmabuf_export __user *) arg;
+			struct fb_dmabuf_export dmabuf_export;
+
+			dmabuf_export.flags = 0;
+			dmabuf_export.fd = (__u32) rtk_fb_memory_share_fd(fb->pMem);
+#if defined(CONFIG_CPU_V7)
+			ret = copy_to_user(arg, &dmabuf_export, sizeof(dmabuf_export));
+#else
+			ret = put_user(dmabuf_export, up_dmabuf_export);
+#endif /* CONFIG_CPU_V7 */
+			dprintk("[%s] FBIOGET_DMABUF return[ret:%d fd:%d]\n", __func__, ret, dmabuf_export.fd);
+			gat_cmd = 1;
+			break;
+		}
+#ifdef USE_UMP
+	case IOCTL_GET_FB_UMP_SECURE_ID:
+		{
+			//dprintk(KERN_ALERT "%s %d IOCTL GET FB UMP\n", __FUNCTION__, __LINE__);
+			u32 __user *psecureid;
+			ump_secure_id secure_id;
+
+			if (ump_wrapper(info) == 0) {
+				printk(KERN_ALERT "Unable to wrap ump memory\n");
+				break;
+			}
+			psecureid = (u32 __user *)arg;
+			//secure_id = 0;//ump_dd_secure_id_get(ump_wrapped_buffer);
+			secure_id = ump_ops.secure_id_get(ump_wrapped_buffer);
+			dprintk(KERN_ALERT "UMP secure ID %d\n", secure_id);
+			ret = put_user((u32)secure_id, psecureid);
+			gat_cmd = 1;
+			break;
+		}
+#endif
+	default:
+		break;
+	}
+
+	if (gat_cmd)
+		return ret;
+
+    {
+        bool skip_lock = false;
+        if (mutex_is_locked(&info->lock))
+            skip_lock = true;
+
+        if (skip_lock)
+            unlock_fb_info(info);
+
+        ret = DC_Ioctl(info, (void *)&fb->video_info, cmd, arg);
+        if (skip_lock)
+            lock_fb_info(info);
+    }
+    return ret;
+}
+
+static int rtk_fb_memory_alloc(struct rtk_fb_memory ** ppMem, int width,
+	int height, int byte_per_pixel ,int align, int count, int flags)
+{
+	uint32_t allocate_size =
+		MEMORY_ALIGN((width * height * byte_per_pixel * count), align);
+	uint32_t ion_heap_mask =
+		RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+	uint32_t ion_heap_flag = ION_FLAG_SCPUACC | ION_FLAG_HWIPACC;
+	struct rtk_fb_memory *pMem = NULL;
+
+	if (*ppMem != NULL)
+		goto err;
+
+	if (flags & RTK_FB_MEM_ALLOC_ALGO_LAST_FIT)
+		ion_heap_flag |= ION_USAGE_ALGO_LAST_FIT;
+
+	*ppMem = (struct rtk_fb_memory *)kzalloc(sizeof(struct rtk_fb_memory),
+		GFP_KERNEL);
+	pMem = *ppMem;
+
+	pMem->fb_client = ion_client_create(rtk_phoenix_ion_device, "android_fb");
+
+	pMem->fb_handle = ion_alloc(pMem->fb_client, allocate_size,
+		align, ion_heap_mask, ion_heap_flag);
+	pMem->alloc_size = allocate_size;
+	pMem->width = width;
+	pMem->height = height;
+	pMem->align = align;
+	pMem->count = count;
+	pMem->byte_per_pixel = byte_per_pixel;
+	pMem->flags = flags;
+
+	return 0;
+err:
+	if (pMem != NULL)
+		kfree(pMem);
+
+	*ppMem = NULL;
+
+	return -1;
+}
+
+static void rtk_fb_memory_destroy(struct rtk_fb_memory ** ppMem)
+{
+	struct rtk_fb_memory *pMem;
+
+	if (ppMem == NULL || *ppMem == NULL)
+		return;
+
+	pMem = *ppMem;
+	ion_free(pMem->fb_client, pMem->fb_handle);
+	ion_client_destroy(pMem->fb_client);
+	kfree(pMem);
+	*ppMem = NULL;
+}
+
+static unsigned long rtk_fb_memory_phy(struct rtk_fb_memory *pMem)
+{
+	unsigned long ret = -1UL;
+	size_t len;
+
+	if (pMem == NULL)
+		goto err;
+
+	if (ion_phys(pMem->fb_client, pMem->fb_handle, &ret, &len) != 0) {
+		dbg_err("[%s %s] ion_phys error size=%ld\n", __FILE__, __func__, pMem->alloc_size);
+		ret = -1UL;
+	}
+
+err:
+	return ret;
+}
+
+static void *rtk_fb_memory_map(struct rtk_fb_memory *pMem)
+{
+	void *ret = NULL;
+
+	if (pMem == NULL)
+		goto err;
+
+	if (pMem->virAddr == NULL)
+		pMem->virAddr = ion_map_kernel(pMem->fb_client, pMem->fb_handle);
+
+	ret = pMem->virAddr;
+err:
+	return ret;
+}
+
+static int rtk_fb_memory_share_fd(struct rtk_fb_memory *pMem)
+{
+	int ret = -1;
+
+	if (pMem == NULL)
+		goto err;
+
+	ret = ion_share_dma_buf_fd(pMem->fb_client, pMem->fb_handle);
+
+err:
+	return ret;
+}
+
+static struct fb_ops rtk_fb_ops = {
+	.owner = THIS_MODULE,
+	.fb_blank = rtk_fb_blank,
+	.fb_check_var = rtk_fb_check_var,
+	.fb_set_par = rtk_fb_set_par,
+	.fb_setcolreg = rtk_fb_setcolreg,
+	.fb_pan_display = rtk_fb_pan_display,
+	.fb_ioctl = rtk_fb_ioctl,
+	.fb_mmap = rtk_fb_mmap,
+#ifdef CONFIG_COMPAT
+	.fb_compat_ioctl = rtk_fb_ioctl,
+#endif
+	/* These are generic software based fb functions */
+#ifdef CONFIG_FB_CFB_FILLRECT
+	.fb_fillrect = cfb_fillrect,
+#endif
+#ifdef CONFIG_FB_CFB_COPYAREA
+	.fb_copyarea = cfb_copyarea,
+#endif
+#ifdef CONFIG_FB_CFB_IMAGEBLIT
+	.fb_imageblit = cfb_imageblit,
+#endif
+};
+
+static int rtk_fb_update_by_memory(struct rtk_fb *fb, struct rtk_fb_memory *pMem)
+{
+	int ret = -1;
+	int fb_width;
+	int fb_height;
+	dma_addr_t fb_phys;
+	size_t	  fb_size;
+	int fb_cnt;
+	void *fb_virAddr;
+	int fb_byte_per_pixel;
+	long long temp;
+	long long temp2;
+
+	if (fb == NULL || pMem == NULL)
+		goto err_fb_set_var_failed;
+
+	fb_phys = rtk_fb_memory_phy(pMem);
+	fb_size = rtk_fb_memory_size(pMem);
+	fb_width = rtk_fb_memory_width(pMem);
+	fb_height = rtk_fb_memory_height(pMem);
+	fb_virAddr = rtk_fb_memory_map(pMem);
+	fb_byte_per_pixel = rtk_fb_memory_bypePrePixel(pMem);
+
+	dbg_info("[%s %s] [%d x %d] addr:0x%lx size:0x%lx irq:%d\n",
+		__FILE__, __func__, fb_width, fb_height, (unsigned long)fb_phys, fb_size, fb->irq);
+
+	fb->fb.flags	 = FBINFO_FLAG_DEFAULT;
+	fb->fb.pseudo_palette = fb->cmap;
+	fb->fb.fix.type = FB_TYPE_PACKED_PIXELS;
+	fb->fb.fix.visual = FB_VISUAL_TRUECOLOR;
+	fb->fb.fix.line_length = fb_width *fb_byte_per_pixel;
+	fb->fb.fix.accel = FB_ACCEL_NONE;
+	fb->fb.fix.ypanstep = 1;
+
+	fb_cnt = (fb_size)/(fb->fb.fix.line_length * fb_height);
+
+	if (fb_cnt > rtk_fb_memory_count(pMem))
+		fb_cnt = rtk_fb_memory_count(pMem);
+
+	dbg_info("[%s %s] numberofbuffers %d\n",
+		__FILE__, __func__, fb_cnt);
+
+	fb->fb.var.xres = fb_width;
+	fb->fb.var.yres = fb_height;
+	fb->fb.var.xres_virtual = fb_width;
+	fb->fb.var.yres_virtual = fb_height * fb_cnt;
+	fb->fb.var.activate = FB_ACTIVATE_NOW;
+	fb->fb.var.height = fb_height;
+	fb->fb.var.width = fb_width;
+
+	if (fb_byte_per_pixel == 4) {
+		/* ARGB 8888 */
+		fb->fb.var.bits_per_pixel = 32;
+		fb->fb.var.transp.offset = 24;
+		fb->fb.var.transp.length = 8;
+		fb->fb.var.red.offset = 16;
+		fb->fb.var.red.length = 8;
+		fb->fb.var.green.offset = 8;
+		fb->fb.var.green.length = 8;
+		fb->fb.var.blue.offset = 0;
+		fb->fb.var.blue.length = 8;
+	} else {
+		/* RGB 565 */
+		fb->fb.var.bits_per_pixel = 16;
+		fb->fb.var.red.offset = 11;
+		fb->fb.var.red.length = 5;
+		fb->fb.var.green.offset = 5;
+		fb->fb.var.green.length = 6;
+		fb->fb.var.blue.offset = 0;
+		fb->fb.var.blue.length = 5;
+	}
+
+	fb->fb.var.width = 0;
+	fb->fb.var.height = 0;
+
+	switch (fb_width) {
+	case 1920:
+	case 720:
+		fb->fb.var.vsync_len = 1;
+		fb->fb.var.hsync_len = 2;
+		break;
+	case 1280:
+		fb->fb.var.vsync_len = 11;
+		fb->fb.var.hsync_len = 3;
+	default:
+		break;
+	}
+
+	temp = (fb->fb.var.xres+fb->fb.var.vsync_len) * (fb->fb.var.yres+fb->fb.var.hsync_len);
+	temp2 = 1000000000000;
+	do_div(temp2, temp);
+	fb->fb.var.pixclock = temp2;
+	fb->fb.var.pixclock /= fb->fps;
+	fb->fb.fix.smem_len = fb_size;
+	fb->fb.fix.smem_start = fb_phys;
+	fb->fb.screen_base = fb_virAddr;
+	if (!fb->fb.screen_base) {
+		dbg_err("Could not allocate frame buffer memory");
+		goto err_fb_set_var_failed;
+	}
+	if (fb_set_var(&fb->fb, &fb->fb.var) != 0) {
+		goto err_fb_set_var_failed;
+	}
+
+	ret = 0;
+err_fb_set_var_failed:
+	return ret ;
+}
+
+static int rtk_fb_set_size (struct rtk_fb *fb, int width, int height,
+	int count, int _byte_per_pixel, int flags)
+{
+	int ret = -1;
+	struct rtk_fb_memory *pMem = NULL;
+	int byte_per_pixel = ANDROID_BYTES_PER_PIXEL;
+
+    if (flags == RTK_FB_MEM_FREE_FB) {
+        if (fb->pMem != NULL) {
+            rtk_fb_memory_destroy(&fb->pMem);
+        }
+        fb->pMem = NULL;
+        goto done;
+    }
+
+	/* Only support 4 byte or 2 byte */
+	switch (_byte_per_pixel) {
+	case 4:
+	case 2:
+		byte_per_pixel = _byte_per_pixel;
+		break;
+	default:
+		break;
+	}
+
+	if (fb->pMem != NULL &&
+		width	== rtk_fb_memory_width(fb->pMem) &&
+		height == rtk_fb_memory_height(fb->pMem) &&
+		count == rtk_fb_memory_count(fb->pMem) &&
+		byte_per_pixel == rtk_fb_memory_bypePrePixel(fb->pMem))
+		goto done;
+
+	ret = rtk_fb_memory_alloc(&pMem, width, height, byte_per_pixel, PAGE_SIZE, count, flags);
+	if (ret != 0) {
+		dbg_err("[%s %s] rtk_fb_memory_alloc return error! ([%dx%d] bypePrePixel=%d align=%ld count=%d) \n",
+			__FILE__, __func__, width, height, byte_per_pixel, PAGE_SIZE, count);
+		goto err;
+	}
+
+
+	ret = rtk_fb_update_by_memory(fb, pMem);
+	if (ret != 0) {
+		dbg_err("[%s %s] rtk_fb_update_by_memory return error! ([%dx%d] bypePrePixel=%d align=%ld count=%d) \n",
+			__FILE__, __func__, width, height, byte_per_pixel, PAGE_SIZE, count);
+		goto err;
+	}
+
+	if (fb->pMem != NULL){
+		rtk_fb_memory_destroy(&fb->pMem);
+	}
+
+	fb->pMem = pMem;
+
+done:
+	ret = 0;
+err:
+	return ret;
+}
+
+static DEVICE_ATTR(freelogo, S_IWUSR, NULL, freelogo_store);
+
+static int rtk_fb_probe(struct platform_device *pdev)
+{
+	int ret = 0;
+	struct rtk_fb *fb;
+	int width;
+	int height;
+	int count;
+	const u32 *prop;
+	int size;
+
+	dbg_warn("[%s %s] \n", __FILE__, __func__);
+
+	fb = kzalloc(sizeof(*fb), GFP_KERNEL);
+	if (fb == NULL) {
+		ret = -ENOMEM;
+		goto err_fb_alloc_failed;
+	}
+
+	fb->fps = ANDROID_NUMBER_OF_FPS;
+
+	prop = of_get_property(pdev->dev.of_node, "resolution", &size);
+	if ((prop) && (size >= sizeof(u32)*2)) {
+		width = of_read_number(prop, 1);
+		height = of_read_number(prop, 2);
+	} else {
+		width = 1280;
+		height = 720;
+		dbg_warn("[%s %s] Use default w:%d h:%d\n", __FILE__, __func__, width, height);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "buffer-cnt", &size);
+	if ((prop) && (size >= sizeof(u32) * 1)) {
+		count = of_read_number(prop, 1);
+	} else {
+		count = 1;
+		dbg_warn("[%s %s] Use default count:%d\n", __FILE__, __func__, count);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "osd-init", &size);
+	if ((prop) && (size >= sizeof(u32) * 1)) {
+		osd_status = of_read_number(prop, 1);
+		dbg_info("[%s %s] Enable osd-init\n", __FILE__, __func__);
+	}else{
+		dbg_warn("[%s %s] osd-init not enabled\n", __FILE__, __func__);
+	}
+
+	fb->irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+
+	prop = of_get_property(pdev->dev.of_node, "fps", &size);
+	if ((prop) && (size >= sizeof(u32) * 1))
+		fb->fps = of_read_number(prop, 1);
+	else
+		dbg_warn("[%s %s] Use default fps:%d\n", __FILE__, __func__, fb->fps);
+
+	ret = rtk_fb_set_size(fb, width, height, count, ANDROID_BYTES_PER_PIXEL, RTK_FB_MEM_ALLOC_ALGO_LAST_FIT);
+	if (ret != 0) {
+		dbg_err("[%s %s] rtk_fb_set_size return error! ([%dx%d] bypePrePixel=%d align=%ld count=%d) \n",
+			__FILE__, __func__, width, height, ANDROID_BYTES_PER_PIXEL, PAGE_SIZE, count);
+		goto err_fb_set_var_failed;
+	}
+
+	dev_set_drvdata(&pdev->dev, fb);
+
+	DC_Init(&fb->video_info, &fb->fb, fb->irq);
+
+	fb->fb.fbops = &rtk_fb_ops;
+
+	/* Avoid black screen */
+	//memset(fb->fb.screen_base,0, fb_size);
+
+	ret = register_framebuffer(&fb->fb);
+	if(ret)
+		goto err_register_framebuffer_failed;
+
+	my_fb_node=fb->fb.node; //__LINUX_MEDIA_NAS__
+#ifdef CONFIG_REALTEK_AVCPU
+	register_avcpu_notifier(&fb_avcpu_event_notifier);
+#endif
+
+	ret = device_create_file(&pdev->dev, &dev_attr_freelogo);
+	if (ret < 0)
+		goto err_create_devfile_failed;
+
+	if (osd_status == 1) {
+		ret = RTK_FB_RPC_OSD_init(fb);
+		if (ret < 0)
+			goto err_osd_init_failed;
+	}
+
+	return 0;
+
+err_osd_init_failed:
+err_create_devfile_failed:
+	unregister_framebuffer(&fb->fb);
+err_register_framebuffer_failed:
+
+err_fb_set_var_failed:
+	DC_Deinit(&fb->video_info);
+	kfree(fb);
+
+err_fb_alloc_failed:
+
+	return ret;
+}
+
+static int rtk_fb_suspend(struct device *dev)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_fb *fb = platform_get_drvdata(pdev);
+
+	return DC_Suspend(&fb->video_info);
+}
+
+static int rtk_fb_resume(struct device *dev)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_fb *fb = platform_get_drvdata(pdev);
+
+	return DC_Resume(&fb->video_info);
+}
+
+static int rtk_fb_remove(struct platform_device *pdev)
+{
+	struct rtk_fb *fb = platform_get_drvdata(pdev);
+
+	if (osd_status == 1) {
+		RTK_FB_RPC_OSD_uninit();
+	}
+
+	device_remove_file(&pdev->dev, &dev_attr_freelogo);
+#ifdef CONFIG_REALTEK_AVCPU
+	unregister_avcpu_notifier(&fb_avcpu_event_notifier);
+#endif
+	DC_Deinit(&fb->video_info);
+	unregister_framebuffer(&fb->fb);
+    if (fb->pMem != NULL)
+        rtk_fb_memory_destroy(&fb->pMem);
+	if (fb != NULL)
+		kfree(fb);
+	dev_set_drvdata(&pdev->dev, NULL);
+
+	return 0;
+}
+
+static struct of_device_id rtk_fb_ids[] = {
+	{ .compatible = "Realtek,rtk-fb" },
+	{ /* Sentinel */ },
+};
+
+MODULE_DEVICE_TABLE(of, rtk_fb_ids);
+
+static const struct dev_pm_ops rtk_fb_pm_ops = {
+	.suspend = rtk_fb_suspend,
+	.resume  = rtk_fb_resume,
+};
+
+static struct platform_driver rtkfb_of_driver = {
+	.probe  = rtk_fb_probe,
+	.remove	= rtk_fb_remove,
+	.driver = {
+		.name = "rtk-fb",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_fb_ids,
+#ifdef CONFIG_PM
+		.pm = &rtk_fb_pm_ops,
+#endif
+	},
+};
+
+//module_platform_driver_probe(rtkfb_of_driver, rtk_fb_probe);
+
+static int rtk_fb_init(void)
+{
+	return platform_driver_register(&rtkfb_of_driver);
+}
+late_initcall(rtk_fb_init);
+
+MODULE_LICENSE("GPL");
diff --git a/drivers/video/fbdev/rtk/rtk_fb.h b/drivers/video/fbdev/rtk/rtk_fb.h
new file mode 100644
index 00000000..8471e2e
--- /dev/null
+++ b/drivers/video/fbdev/rtk/rtk_fb.h
@@ -0,0 +1,46 @@
+#ifndef __RTK_FB_DRIVER_H__
+#define __RTK_FB_DRIVER_H__
+
+#include <linux/fb.h>
+
+typedef struct venusfb_mach_info {
+	void *dc_info;
+} VENUSFB_MACH_INFO;
+
+struct rtk_fb_memory {
+	struct ion_client *fb_client;
+	struct ion_handle *fb_handle;
+	size_t alloc_size;
+	int width;
+	int height;
+	int align;
+	int count;
+	void *virAddr;
+	int byte_per_pixel;
+	int flags;
+};
+
+struct rtk_fb {
+	struct fb_info fb;
+	int rotation;
+	u32 cmap[16];
+	VENUSFB_MACH_INFO video_info;
+	struct rtk_fb_memory *pMem;
+	int fps;
+	int irq;
+};
+
+#if 1//def __LINUX_MEDIA_NAS__
+typedef struct FBDev_PARAM_BUF_ADDR
+{
+    unsigned int video_buf_Paddr;
+    unsigned int video_buf_count;
+    unsigned int video_buf_size;
+    unsigned int width;
+    unsigned int height;
+    unsigned int misc_buf_Paddr;
+    unsigned int misc_buf_size;
+} FBDev_PARAM_BUF_ADDR;
+#endif
+
+#endif
diff --git a/drivers/video/fbdev/rtk/rtk_fb_RPC.c b/drivers/video/fbdev/rtk/rtk_fb_RPC.c
new file mode 100644
index 00000000..9c64ba6
--- /dev/null
+++ b/drivers/video/fbdev/rtk/rtk_fb_RPC.c
@@ -0,0 +1,1015 @@
+/**
+ * rtk_fb_RPC.c - Realtek frame buffer driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+#include <linux/init.h>
+#include <linux/jiffies.h>
+#include <linux/slab.h>
+#include <linux/time.h>
+#include <linux/wait.h>
+#include <linux/moduleparam.h>
+#include <linux/delay.h>
+#include <sound/core.h>
+#include <sound/control.h>
+#include <sound/pcm.h>
+#include <sound/rawmidi.h>
+#include <sound/initval.h>
+#include <linux/mutex.h>
+#include <linux/ioctl.h> /* needed for the _IOW etc stuff used later */
+#include <linux/syscalls.h> /* needed for the _IOW etc stuff used later */
+#include <linux/mpage.h>
+#include <linux/dcache.h>
+#include <linux/timer.h>
+#include <linux/workqueue.h>
+#include <linux/dma-mapping.h>
+#include <sound/asound.h>
+#include <asm/cacheflush.h>
+#include <soc/realtek/kernel-rpc.h>
+#include "debug.h"
+
+#include "rtk_fb.h"
+#include "rtk_fb_RPC.h"
+#include "dc2vo/dc2vo.h"
+
+#include "dc2vo/dc_rpc.h"
+
+//////////////////
+// Main Control //
+//////////////////
+#define USE_ION_FB_HEAP
+//#define CAPTURE_USE_PTS_RING
+//#define USE_COPY_OPS
+
+///////////////////
+// Debug Control //
+///////////////////
+//#define _TRACE_FB_RPC
+
+#ifdef _TRACE_FB_RPC
+#define TRACE_RPC() printk(KERN_ALERT "�� fb %s\n", __FUNCTION__);
+#else
+#define TRACE_RPC()
+#endif
+
+#ifdef USE_ION_FB_HEAP
+#include "../../../../drivers/staging/android/ion/ion.h"
+#include "../../../../drivers/staging/android/uapi/ion_rtk.h"
+extern struct ion_device *rtk_phoenix_ion_device;
+
+#endif
+
+static struct ion_client *rtkfb_client;
+static struct ion_handle *rtkfb_handle;
+#define HDMI_OUT_EN         1
+#define HDMI_VER            2
+#define HDMI_EDID_SIZE      5
+
+//extern struct ion_client *rtkfb_client;
+
+#define S_OK        0x10000000
+
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+#define CONVERT_FOR_AVCPU(x)        ((unsigned int)(x) | 0xA0000000)
+#else
+#define CONVERT_FOR_AVCPU(x)        (x)
+#endif
+#define AUDIO_ION_FLAG              (ION_FLAG_NONCACHED |ION_FLAG_SCPUACC | ION_FLAG_ACPUACC)
+
+typedef enum
+{
+    ENUM_KERNEL_RPC_CREATE_AGENT,   // 0
+    ENUM_KERNEL_RPC_INIT_RINGBUF,
+    ENUM_KERNEL_RPC_PRIVATEINFO,
+    ENUM_KERNEL_RPC_RUN,
+    ENUM_KERNEL_RPC_PAUSE,
+    ENUM_KERNEL_RPC_SWITCH_FOCUS,   // 5
+    ENUM_KERNEL_RPC_MALLOC_ADDR,
+    ENUM_KERNEL_RPC_VOLUME_CONTROL,      // AUDIO_CONFIG_COMMAND
+    ENUM_KERNEL_RPC_FLUSH,               // AUDIO_RPC_SENDIO
+    ENUM_KERNEL_RPC_CONNECT,             // AUDIO_RPC_CONNECTION
+    ENUM_KERNEL_RPC_SETREFCLOCK,    // 10     // AUDIO_RPC_REFCLOCK
+    ENUM_KERNEL_RPC_DAC_I2S_CONFIG,      // AUDIO_CONFIG_DAC_I2S
+    ENUM_KERNEL_RPC_DAC_SPDIF_CONFIG,    // AUDIO_CONFIG_DAC_SPDIF
+    ENUM_KERNEL_RPC_HDMI_OUT_EDID,       // AUDIO_HDMI_OUT_EDID_DATA
+    ENUM_KERNEL_RPC_HDMI_OUT_EDID2,      // AUDIO_HDMI_OUT_EDID_DATA2
+    ENUM_KERNEL_RPC_HDMI_SET,       // 15     // AUDIO_HDMI_SET
+    ENUM_KERNEL_RPC_HDMI_MUTE,           //AUDIO_HDMI_MUTE_INFO
+    ENUM_KERNEL_RPC_ASK_DBG_MEM_ADDR,
+    ENUM_KERNEL_RPC_DESTROY,
+    ENUM_KERNEL_RPC_STOP,
+    ENUM_KERNEL_RPC_CHECK_READY,     // 20    // check if Audio get memory pool from AP
+    ENUM_KERNEL_RPC_GET_MUTE_N_VOLUME,   // get mute and volume level
+    ENUM_KERNEL_RPC_EOS,
+    ENUM_KERNEL_RPC_ADC0_CONFIG,
+    ENUM_KERNEL_RPC_ADC1_CONFIG,
+    ENUM_KERNEL_RPC_ADC2_CONFIG,    // 25
+#if defined(AUDIO_TV_PLATFORM)
+    ENUM_KERNEL_RPC_BBADC_CONFIG,
+    ENUM_KERNEL_RPC_I2SI_CONFIG,
+    ENUM_KERNEL_RPC_SPDIFI_CONFIG,
+#endif // AUDIO_TV_PLATFORM
+    ENUM_KERNEL_RPC_HDMI_OUT_VSDB,
+    ENUM_VIDEO_KERNEL_RPC_CONFIG_TV_SYSTEM,
+    ENUM_VIDEO_KERNEL_RPC_CONFIG_HDMI_INFO_FRAME,
+    ENUM_VIDEO_KERNEL_RPC_QUERY_DISPLAY_WIN,
+    ENUM_VIDEO_KERNEL_RPC_PP_INIT_PIN,
+    ENUM_KERNEL_RPC_INIT_RINGBUF_AO, //need check this enum
+    ENUM_VIDEO_KERNEL_RPC_VOUT_EDID_DATA,
+    ENUM_KERNEL_RPC_AUDIO_POWER_SET,
+    ENUM_VIDEO_KERNEL_RPC_VOUT_VDAC_SET,
+    ENUM_VIDEO_KERNEL_RPC_QUERY_CONFIG_TV_SYSTEM,
+    ENUM_KERNEL_RPC_AUDIO_CONFIG,
+    ENUM_KERNEL_RPC_AIO_PRIVATEINFO,
+    ENUM_KERNEL_RPC_QUERY_FW_DEBUG_INFO,
+    ENUM_KERNEL_RPC_HDMI_RX_LATENCY_MEM,
+    ENUM_KERNEL_RPC_EQ_CONFIG,
+    ENUM_VIDEO_KERNEL_RPC_CREATE,
+    ENUM_VIDEO_KERNEL_RPC_DISPLAY,
+    ENUM_VIDEO_KERNEL_RPC_CONFIGUREDISPLAYWINDOW,
+    ENUM_VIDEO_KERNEL_RPC_SETREFCLOCK,
+    ENUM_VIDEO_KERNEL_RPC_RUN,
+    ENUM_VIDEO_KERNEL_RPC_INITRINGBUFFER,
+    ENUM_VIDEO_KERNEL_RPC_SETRESCALEMODE
+} ENUM_FB_KERNEL_RPC_CMD;
+
+enum VIDEO_VF_TYPE {
+    VF_TYPE_VIDEO_MPEG2_DECODER = 0,
+    VF_TYPE_VIDEO_MPEG4_DECODER = 1,
+    VF_TYPE_VIDEO_DIVX_DECODER = 2,
+    VF_TYPE_VIDEO_H263_DECODER = 3,
+    VF_TYPE_VIDEO_H264_DECODER = 4,
+    VF_TYPE_VIDEO_VC1_DECODER = 5,
+    VF_TYPE_VIDEO_REAL_DECODER = 6,
+    VF_TYPE_VIDEO_JPEG_DECODER = 7,
+    VF_TYPE_VIDEO_MJPEG_DECODER = 8,
+    VF_TYPE_SPU_DECODER = 9,
+    VF_TYPE_VIDEO_OUT = 10,
+    VF_TYPE_TRANSITION = 11,
+    VF_TYPE_THUMBNAIL = 12,
+    VF_TYPE_VIDEO_VP6_DECODER = 13,
+    VF_TYPE_VIDEO_IMAGE_DECODER = 14,
+    VF_TYPE_FLASH = 15,
+    VF_TYPE_VIDEO_AVS_DECODER = 16,
+    VF_TYPE_MIXER = 17,
+    VF_TYPE_VIDEO_VP8_DECODER = 18,
+    VF_TYPE_VIDEO_WMV7_DECODER = 19,
+    VF_TYPE_VIDEO_WMV8_DECODER = 20,
+    VF_TYPE_VIDEO_RAW_DECODER = 21,
+    VF_TYPE_VIDEO_THEORA_DECODER = 22,
+    VF_TYPE_VIDEO_FJPEG_DECODER = 23,
+    VF_TYPE_VIDEO_H265_DECODER = 24,
+    VF_TYPE_VIDEO_VP9_DECODER = 25,
+};
+typedef enum VIDEO_VF_TYPE VIDEO_VF_TYPE;
+
+enum VO_VIDEO_PLANE {
+    VO_VIDEO_PLANE_V1 = 0,
+    VO_VIDEO_PLANE_V2 = 1,
+    VO_VIDEO_PLANE_SUB1 = 2,
+    VO_VIDEO_PLANE_OSD1 = 3,
+    VO_VIDEO_PLANE_OSD2 = 4,
+    VO_VIDEO_PLANE_WIN1 = 5,
+    VO_VIDEO_PLANE_WIN2 = 6,
+    VO_VIDEO_PLANE_WIN3 = 7,
+    VO_VIDEO_PLANE_WIN4 = 8,
+    VO_VIDEO_PLANE_WIN5 = 9,
+    VO_VIDEO_PLANE_WIN6 = 10,
+    VO_VIDEO_PLANE_WIN7 = 11,
+    VO_VIDEO_PLANE_WIN8 = 12,
+    VO_VIDEO_PLANE_SUB2 = 13,
+    VO_VIDEO_PLANE_CSR = 14,
+    VO_VIDEO_PLANE_NONE = 255,
+};
+typedef enum VO_VIDEO_PLANE VO_VIDEO_PLANE;
+
+enum VO_RESCALE_MODE {
+    VO_RESCALE_MODE_KEEP_AR_AUTO = 0,
+    VO_RESCALE_MODE_KEEP_AR_LB_CNTR = 1,
+    VO_RESCALE_MODE_KEEP_AR_LB_TOP = 2,
+    VO_RESCALE_MODE_KEEP_AR_PS_CNTR = 3,
+    VO_RESCALE_MODE_KEEP_AR_PS_AUTO = 4,
+    VO_RESCALE_MODE_FULL_SCALE = 5,
+    VO_RESCALE_MODE_USER_DEFINE = 6,
+};
+typedef enum VO_RESCALE_MODE VO_RESCALE_MODE;
+
+////////////////////////////////
+
+typedef uint32_t HRESULT;
+
+typedef struct RPCRES_LONG {
+    HRESULT result;
+    int data;
+}RPCRES_LONG;
+
+typedef struct {
+    uint32_t inst_id;
+    RPCRES_LONG retval;
+    HRESULT res;
+} VIDEO_RPC_RUN_T;
+
+struct VIDEO_RPC_INSTANCE {
+    enum VIDEO_VF_TYPE type;
+};
+typedef struct VIDEO_RPC_INSTANCE VIDEO_RPC_INSTANCE;
+
+typedef struct {
+    VIDEO_RPC_INSTANCE info;
+    RPCRES_LONG retval;
+    HRESULT ret;
+} RPC_CREATE_VIDEO_AGENT_T;
+
+struct VIDEO_RPC_VO_FILTER_DISPLAY {
+    u_int instanceID;
+    enum VO_VIDEO_PLANE videoPlane;
+    u_char zeroBuffer;
+    u_char realTimeSrc;
+};
+typedef struct VIDEO_RPC_VO_FILTER_DISPLAY VIDEO_RPC_VO_FILTER_DISPLAY;
+
+typedef struct {
+    u_int instanceID;
+    enum VO_VIDEO_PLANE videoPlane;
+    u_char zeroBuffer;
+    u_char realTimeSrc;
+    RPCRES_LONG retval;
+    HRESULT ret;
+} VIDEO_RPC_VO_FILTER_DISPLAY_T;
+
+struct VO_COLOR {
+    u_char c1;
+    u_char c2;
+    u_char c3;
+    u_char isRGB;
+};
+typedef struct VO_COLOR VO_COLOR;
+
+struct VIDEO_RPC_VOUT_CONFIG_DISP_WIN {
+    enum VO_VIDEO_PLANE videoPlane;
+    struct VO_RECTANGLE videoWin;
+    struct VO_RECTANGLE borderWin;
+    struct VO_COLOR borderColor;
+    u_char enBorder;
+};
+typedef struct VIDEO_RPC_VOUT_CONFIG_DISP_WIN VIDEO_RPC_VOUT_CONFIG_DISP_WIN;
+
+typedef struct {
+    enum VO_VIDEO_PLANE videoPlane;
+    struct VO_RECTANGLE videoWin;
+    struct VO_RECTANGLE borderWin;
+    struct VO_COLOR borderColor;
+    u_char enBorder;
+    RPCRES_LONG retval;
+    HRESULT ret;
+} VIDEO_RPC_VOUT_CONFIG_DISP_WIN_T;
+
+typedef struct {
+    int instanceID;
+    int pRefClock;
+} VIDEO_RPC_REFCLOCK;
+
+typedef struct {
+    int instanceID;
+    int pRefClock;
+    RPCRES_LONG ret;
+    HRESULT res;
+} VIDEO_RPC_REFCLOCK_T;
+
+typedef enum _tagAutoMasterState{
+  AUTOMASTER_NOT_MASTER,
+  AUTOMASTER_IS_MASTER
+} AUTOMASTER_STATE;
+
+typedef struct {
+    u_int instanceID;
+    u_int pinID;
+    u_int readPtrIndex;
+    u_int pRINGBUFF_HEADER;
+}VIDEO_RPC_RINGBUFFER;
+
+typedef struct {
+    RPCRES_LONG ret;
+    HRESULT         res;
+    u_int instanceID;
+    u_int pinID;
+    u_int readPtrIndex;
+    u_int pRINGBUFF_HEADER;
+} VIDEO_RPC_RINGBUFFER_T;
+
+struct VIDEO_RPC_VOUT_SET_RESCALE_MODE {
+    enum VO_VIDEO_PLANE videoPlane;
+    enum VO_RESCALE_MODE rescaleMode;
+    struct VO_RECTANGLE rescaleWindow;
+    u_char delayExec;
+};
+typedef struct VIDEO_RPC_VOUT_SET_RESCALE_MODE VIDEO_RPC_VOUT_SET_RESCALE_MODE;
+
+typedef struct {
+    enum VO_VIDEO_PLANE videoPlane;
+    enum VO_RESCALE_MODE rescaleMode;
+    struct VO_RECTANGLE rescaleWindow;
+    u_char delayExec;
+    RPCRES_LONG retval;
+    HRESULT ret;
+} VIDEO_RPC_VOUT_SET_RESCALE_MODE_T;
+
+struct AUDIO_HDMI_OUT_EDID_DATA2 {
+    u_int Version;
+    u_int HDMI_output_enable;
+    u_int EDID_DATA_addr;
+};
+typedef struct AUDIO_HDMI_OUT_EDID_DATA2 AUDIO_HDMI_OUT_EDID_DATA2;
+
+typedef struct {
+    u_int Version;
+    u_int HDMI_output_enable;
+    u_int EDID_DATA_addr;
+    RPCRES_LONG retval;
+    HRESULT ret;
+} AUDIO_HDMI_OUT_EDID_DATA2_T;
+
+///////////////////////////////
+
+
+uint64_t htonll(long long val) {
+    return (((long long) htonl(val)) << 32) + htonl(val >> 32);
+}
+
+int RPC_TOAGENT_CREATE_VIDEO_AGENT(uint32_t* videoId, VIDEO_VF_TYPE pinId)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    RPC_CREATE_VIDEO_AGENT_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(rtkfb_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        dbg_warn("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(rtkfb_client, handle, &dat, &len) != 0) {
+        dbg_warn("[RTKFB %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(rtkfb_client, handle);
+    memset(rpc, 0, 4096);
+    rpc->info.type = htonl(pinId);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_VIDEO_KERNEL_RPC_CREATE,
+        CONVERT_FOR_AVCPU(dat), //rpc->info address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->info))),//rpc->retval address
+        &rpc->ret)) {
+        dbg_warn("[RTKFB %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ntohl(rpc->retval.result) != S_OK || rpc->ret != S_OK) {
+        dbg_warn("[RTKFB %x %x %s %d RPC fail]\n", rpc->retval.result, rpc->ret, __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    *videoId = ntohl(rpc->retval.data);
+
+    //TRACE_CODE("[%s %s %d] videoId %u success\n", __FILE__, __FUNCTION__, __LINE__, *videoId);
+    ret = 0;
+
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(rtkfb_client, handle);
+        ion_free(rtkfb_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_VIDEO_DISPLAY(VIDEO_RPC_VO_FILTER_DISPLAY* argp)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    VIDEO_RPC_VO_FILTER_DISPLAY_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(rtkfb_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        dbg_warn("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(rtkfb_client, handle, &dat, &len) != 0) {
+        dbg_warn("[RTKFB %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(rtkfb_client, handle);
+    memset(rpc, 0, 4096);
+    rpc->instanceID = htonl(argp->instanceID);
+    rpc->videoPlane = htonl(argp->videoPlane);
+    rpc->zeroBuffer = htonl(argp->zeroBuffer);
+    rpc->realTimeSrc = htonl(argp->realTimeSrc);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_VIDEO_KERNEL_RPC_DISPLAY,
+        CONVERT_FOR_AVCPU(dat), //rpc->info address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(VIDEO_RPC_VO_FILTER_DISPLAY))),//rpc->retval address
+        &rpc->ret)) {
+        dbg_warn("[RTKFB %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ntohl(rpc->retval.result) != S_OK || rpc->ret != S_OK) {
+        dbg_warn("[RTKFB %x %x %s %d RPC fail]\n", rpc->retval.result, rpc->ret, __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(rtkfb_client, handle);
+        ion_free(rtkfb_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_VIDEO_CONFIGUREDISPLAYWINDOW(VIDEO_RPC_VOUT_CONFIG_DISP_WIN* argp)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    VIDEO_RPC_VOUT_CONFIG_DISP_WIN_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(rtkfb_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        dbg_warn("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(rtkfb_client, handle, &dat, &len) != 0) {
+        dbg_warn("[RTKFB %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(rtkfb_client, handle);
+    memset(rpc, 0, 4096);
+    rpc->videoPlane = htonl(argp->videoPlane);
+    rpc->videoWin.x = htons(argp->videoWin.x);
+    rpc->videoWin.y = htons(argp->videoWin.y);
+    rpc->videoWin.width = htons(argp->videoWin.width);
+    rpc->videoWin.height = htons(argp->videoWin.height);
+    rpc->borderWin.x = htons(argp->borderWin.x);
+    rpc->borderWin.y = htons(argp->borderWin.y);
+    rpc->borderWin.width = htons(argp->borderWin.width);
+    rpc->borderWin.height = htons(argp->borderWin.height);
+    rpc->borderColor.c1 = htonl(argp->borderColor.c1);
+    rpc->borderColor.c2 = htonl(argp->borderColor.c2);
+    rpc->borderColor.c3 = htonl(argp->borderColor.c3);
+    rpc->borderColor.isRGB = htonl(argp->borderColor.isRGB);
+    rpc->enBorder = htonl(argp->enBorder);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_VIDEO_KERNEL_RPC_CONFIGUREDISPLAYWINDOW,
+        CONVERT_FOR_AVCPU(dat), //rpc->info address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(VIDEO_RPC_VOUT_CONFIG_DISP_WIN))),//rpc->retval address
+        &rpc->ret)) {
+        dbg_warn("[RTKFB %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ntohl(rpc->retval.result) != S_OK || rpc->ret != S_OK) {
+        dbg_warn("[RTKFB %x %x %s %d RPC fail]\n", rpc->retval.result, rpc->ret, __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(rtkfb_client, handle);
+        ion_free(rtkfb_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_VIDEO_SETREFCLOCK(VIDEO_RPC_REFCLOCK *pClock)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    VIDEO_RPC_REFCLOCK_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    handle = ion_alloc(rtkfb_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        dbg_warn("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(rtkfb_client, handle, &dat, &len) != 0) {
+        dbg_warn("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(rtkfb_client, handle);
+    memset(rpc, 0, 4096);
+    rpc->instanceID = htonl(pClock->instanceID);
+    rpc->pRefClock = htonl(pClock->pRefClock);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_VIDEO_KERNEL_RPC_SETREFCLOCK,
+        CONVERT_FOR_AVCPU(dat), //rpc->out address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->instanceID) + sizeof(rpc->pRefClock))), //rpc->ret
+        &rpc->res)) {
+        dbg_warn("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->ret.result) != S_OK) {
+        dbg_warn("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(rtkfb_client, handle);
+        ion_free(rtkfb_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_VIDEO_RUN(uint32_t instance_id)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    VIDEO_RPC_RUN_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(rtkfb_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        dbg_warn("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(rtkfb_client, handle, &dat, &len) != 0) {
+        dbg_warn("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(rtkfb_client, handle);
+    memset(rpc, 0, 4096);
+    rpc->inst_id = htonl(instance_id);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_VIDEO_KERNEL_RPC_RUN,
+        CONVERT_FOR_AVCPU(dat), //rpc->inst_id address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->inst_id))), //rpc->retval address
+        &rpc->res)) {
+        dbg_warn("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->retval.result) != S_OK) {
+        dbg_warn("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(rtkfb_client, handle);
+        ion_free(rtkfb_client, handle);
+    }
+    return ret;
+}
+
+// data of AUDIO_RPC_RINGBUFFER_HEADER is "hose side"
+int RPC_TOAGENT_VIDEO_INITRINGBUFFER(VIDEO_RPC_RINGBUFFER* argp)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    VIDEO_RPC_RINGBUFFER_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(rtkfb_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        dbg_warn("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(rtkfb_client, handle, &dat, &len) != 0) {
+        dbg_warn("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(rtkfb_client, handle);
+    memset(rpc, 0, 4096);
+    rpc->instanceID = htonl(argp->instanceID);
+    rpc->readPtrIndex = htonl(argp->readPtrIndex);
+    rpc->pinID = htonl(argp->pinID);
+    rpc->pRINGBUFF_HEADER = htonl(argp->pRINGBUFF_HEADER);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_VIDEO_KERNEL_RPC_INITRINGBUFFER,
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->ret) + sizeof(rpc->res))), //rpc->header address
+        CONVERT_FOR_AVCPU(dat), //rpc->ret address
+        &rpc->res)) {
+        dbg_warn("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->ret.result) != S_OK) {
+        dbg_warn("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(rtkfb_client, handle);
+        ion_free(rtkfb_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_VIDEO_SETRESCALEMODE(VIDEO_RPC_VOUT_SET_RESCALE_MODE* argp)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    VIDEO_RPC_VOUT_SET_RESCALE_MODE_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(rtkfb_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        dbg_warn("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(rtkfb_client, handle, &dat, &len) != 0) {
+        dbg_warn("[RTKFB %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(rtkfb_client, handle);
+    memset(rpc, 0, 4096);
+    rpc->videoPlane = htonl(argp->videoPlane);
+    rpc->rescaleMode = htonl(argp->rescaleMode);
+    rpc->rescaleWindow.x = htonl(argp->rescaleWindow.x);
+    rpc->rescaleWindow.y = htonl(argp->rescaleWindow.y);
+    rpc->rescaleWindow.width = htonl(argp->rescaleWindow.width);
+    rpc->rescaleWindow.height = htonl(argp->rescaleWindow.height);
+    rpc->delayExec = htonl(argp->delayExec);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_VIDEO_KERNEL_RPC_SETRESCALEMODE,
+        CONVERT_FOR_AVCPU(dat), //rpc->info address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(VIDEO_RPC_VOUT_SET_RESCALE_MODE))),//rpc->retval address
+        &rpc->ret)) {
+        dbg_warn("[RTKFB %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ntohl(rpc->retval.result) != S_OK || rpc->ret != S_OK) {
+        dbg_warn("[RTKFB %x %x %s %d RPC fail]\n", rpc->retval.result, rpc->ret, __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(rtkfb_client, handle);
+        ion_free(rtkfb_client, handle);
+    }
+    return ret;
+}
+
+int RPC_ToAgent_AUDIO_HDMI_OUT_EDID_0(struct AUDIO_HDMI_OUT_EDID_DATA2 *argp)
+{
+    AUDIO_HDMI_OUT_EDID_DATA2_T *rpc = NULL;
+    int ret = -1;
+    u32 RPC_ret;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    handle = ion_alloc(rtkfb_client, 4096, 1024,
+                RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+                ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+    if (IS_ERR(handle)) {
+        dbg_warn("[%s %d ion_alloc fail]", __func__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(rtkfb_client, handle, &dat, &len) != 0) {
+        dbg_warn("[%s %d fail]", __func__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(rtkfb_client, handle);
+    memset(rpc, 0, 4096);
+    rpc->Version = htonl(argp->Version);
+    rpc->HDMI_output_enable = htonl(argp->HDMI_output_enable);
+    rpc->EDID_DATA_addr = htonl(argp->EDID_DATA_addr);
+
+    /*
+    pli_ipcCopyMemory((unsigned char *)rpc, (unsigned char *)arg,
+        sizeof(struct AUDIO_HDMI_OUT_EDID_DATA2));
+        */
+
+    if (send_rpc_command(RPC_AUDIO, ENUM_KERNEL_RPC_HDMI_OUT_EDID2,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(AUDIO_HDMI_OUT_EDID_DATA2))),
+        &RPC_ret)) {
+
+        dbg_warn("[%s %d RPC fail]", __func__, __LINE__);
+        goto exit;
+    }
+
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(rtkfb_client, handle);
+        ion_free(rtkfb_client, handle);
+    }
+    return ret;
+}
+
+void SetAudioHdmiOutEdid2(unsigned char *ion_virt, unsigned long ion_phy)
+{
+    struct AUDIO_HDMI_OUT_EDID_DATA2 audio_edid_data2;
+    //unsigned char edid[HDMI_EDID_SIZE] = { 0x04, 0x09, 0x04, 0x07, 0x00 };
+
+    audio_edid_data2.HDMI_output_enable = HDMI_OUT_EN;
+    audio_edid_data2.Version = HDMI_VER;
+    //memcpy((void*)ion_virt, edid, HDMI_EDID_SIZE);
+    ion_virt[0]=0x04;
+    ion_virt[1]=0x09;
+    ion_virt[2]=0x04;
+    ion_virt[3]=0x07;
+    ion_virt[4]=0x00;
+    audio_edid_data2.EDID_DATA_addr = (long)(0xffffffff&ion_phy);
+
+    if (RPC_ToAgent_AUDIO_HDMI_OUT_EDID_0(&audio_edid_data2) < 0) {
+        dbg_warn("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        //return -1;
+    };
+}
+
+int RTK_FB_RPC_OSD_init(struct rtk_fb *fb)
+{
+    void *ion_virt;
+    ion_phys_addr_t ion_phy;
+    size_t len = 0;
+    unsigned int osd_width = 1920, osd_height = 1080;
+    VO_RECTANGLE rect;
+    REFCLOCK* m_core;
+    RINGBUFFER_HEADER *ringheader;
+    uint32_t VIDEOAgentID = 0;
+    VIDEO_VF_TYPE type;
+    DCRT_PARAM_RATE_INFO rateParam;
+    unsigned int hz=60;
+    VIDEO_RPC_VO_FILTER_DISPLAY info;
+    VO_COLOR blueBorder = {0,0,255,1};
+    VIDEO_RPC_VOUT_CONFIG_DISP_WIN structConfigDispWin;
+    VIDEO_RPC_REFCLOCK rpc_refclock;
+    VIDEO_RPC_RINGBUFFER ringbuffer;
+    DC_ION_SHARE_MEMORY ion_share_memory;
+    DCRT_PARAM_RPC_ADDR inbandParam;
+
+    /* osd init */
+    dbg_warn("osd init,[%s %s][%d] \n", __FILE__, __func__, __LINE__);
+
+    /* allocate ion memory for RPC: SetRefClock, InitRingBuffer, SetAudioHdmiOutEdid2 */
+    rtkfb_client = ion_client_create(rtk_phoenix_ion_device, "RTKFBDriver");
+
+    rtkfb_handle = ion_alloc(rtkfb_client, 67*1024, 1<<12, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, (ION_FLAG_NONCACHED | ION_FLAG_ACPUACC | ION_FLAG_SCPUACC));
+    if (IS_ERR(rtkfb_handle)) {
+        dbg_warn("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+
+    if (ion_phys(rtkfb_client, rtkfb_handle, &ion_phy, &len) != 0) {
+        dbg_warn("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    ion_virt = ion_map_kernel(rtkfb_client, rtkfb_handle);
+
+    if (0)
+    {
+        memset(ion_virt, 0, 67*1024);
+    }
+    else
+    {
+        uint64_t *ptr=(uint64_t *)ion_virt;
+        uint32_t i;
+        for (i=0;i<((67*1024)/sizeof(uint64_t));i++)
+        {
+            ptr[i]=0;
+        }
+    }
+
+    /* gldc_osd_main */
+    m_core=(REFCLOCK*)((unsigned long)(ion_virt)+(65*1024));
+    ringheader=(RINGBUFFER_HEADER*)((unsigned long)(ion_virt)+(64*1024));
+
+    osd_width = fb->fb.var.xres;
+    osd_height = fb->fb.var.yres;
+
+    rect.x = 0;
+    rect.y = 0;
+    rect.width = osd_width;
+    rect.height = osd_height;
+
+    /* VIDEO_RPC_ToAgent_Create_0 */
+    type = VF_TYPE_VIDEO_OUT;
+    if (RPC_TOAGENT_CREATE_VIDEO_AGENT(&VIDEOAgentID, type))
+    {
+        dbg_warn("[No Video agent %s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    /* DCRT_CMD_SET_OUT_RATE_INFO */
+    memset(&rateParam, 0, sizeof(rateParam));
+    rateParam.param_size = sizeof(rateParam);
+    rateParam.pts_gap =  (unsigned int)90000/hz;
+    rateParam.hz = hz*1000;
+    rateParam.clockAddrLow = 0x1801B540;
+    rateParam.clockAddrHi =  0x1801B544;
+
+    if (DC_Set_RateInfo(&fb->fb, &fb->video_info, &rateParam) != 0){
+        dbg_warn("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+
+    /* VIDEO_RPC_VO_FILTER_ToAgent_Display_0 */
+    memset(&info, 0, sizeof(info));
+    info.instanceID = VIDEOAgentID;
+    info.videoPlane = VO_VIDEO_PLANE_OSD1;
+    info.zeroBuffer  = 0;
+    info.realTimeSrc = 0;
+    if (RPC_TOAGENT_VIDEO_DISPLAY(&info))
+    {
+        dbg_warn("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    /* VIDEO_RPC_VOUT_ToAgent_ConfigureDisplayWindow_0 */
+    memset(&structConfigDispWin, 0, sizeof(structConfigDispWin));
+    structConfigDispWin.videoPlane = VO_VIDEO_PLANE_OSD1;
+    structConfigDispWin.videoWin = rect;
+    structConfigDispWin.borderWin = rect;
+    structConfigDispWin.borderColor = blueBorder;
+    structConfigDispWin.enBorder = 0;
+    if (RPC_TOAGENT_VIDEO_CONFIGUREDISPLAYWINDOW(&structConfigDispWin))
+    {
+        dbg_warn("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    /* VIDEO_RPC_ToAgent_SetRefClock_0 */
+    m_core->RCD = htonll(-1LL);
+    m_core->RCD_ext = htonl(-1L);
+    m_core->masterGPTS = htonll(-1LL);
+    m_core->GPTSTimeout = htonll(0LL);
+    m_core->videoSystemPTS = htonll(-1LL);
+    m_core->audioSystemPTS = htonll(-1LL);
+    m_core->videoRPTS = htonll(-1LL);
+    m_core->audioRPTS = htonll(-1LL);
+    m_core->videoContext = htonl(-1);
+    m_core->audioContext = htonl(-1);
+    m_core->videoEndOfSegment = htonl(-1);
+    m_core->videoFreeRunThreshold = htonl(0x7FFFFFFF);
+    m_core->audioFreeRunThreshold = htonl(0x7FFFFFFF);
+    m_core->VO_Underflow = htonl(0);
+    m_core->AO_Underflow = htonl(0);
+    m_core->mastership.systemMode  = (unsigned char)AVSYNC_FORCED_SLAVE;
+    m_core->mastership.videoMode   = (unsigned char)AVSYNC_FORCED_MASTER;
+    m_core->mastership.audioMode   = (unsigned char)AVSYNC_FORCED_MASTER;
+    m_core->mastership.masterState = (unsigned char)AUTOMASTER_NOT_MASTER;
+    memset(&rpc_refclock, 0, sizeof(rpc_refclock));
+    rpc_refclock.instanceID = VIDEOAgentID;
+    rpc_refclock.pRefClock = (long)(0xffffffff&ion_phy)+65*1024;
+    if (RPC_TOAGENT_VIDEO_SETREFCLOCK(&rpc_refclock)) {
+        dbg_warn("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    /* VIDEO_RPC_ToAgent_Run_0 */
+    if (RPC_TOAGENT_VIDEO_RUN(VIDEOAgentID)){
+            dbg_warn("[%s %d]\n", __FUNCTION__, __LINE__);
+         return -1;
+    }
+
+    /*  VIDEO_RPC_ToAgent_InitRingBuffer_0 */
+    ringheader->beginAddr=htonl((long)(0xffffffff&ion_phy));
+    ringheader->size=htonl(64*1024);
+    ringheader->writePtr=ringheader->beginAddr;
+    ringheader->readPtr[0]=ringheader->beginAddr;
+    ringheader->bufferID=htonl(1);
+    memset(&ringbuffer, 0, sizeof(ringbuffer));
+    ringbuffer.instanceID = VIDEOAgentID;
+    ringbuffer.readPtrIndex = 0;
+    ringbuffer.pinID = 0;
+    ringbuffer.pRINGBUFF_HEADER=(long)(0xffffffff&ion_phy)+64*1024;
+    if (RPC_TOAGENT_VIDEO_INITRINGBUFFER(&ringbuffer) < 0) {
+        dbg_warn("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    };
+
+    /* DC2VO_SET_ION_SHARE_MEMORY */
+#if 1
+    DCRT_PARAM_RPC_VIRT_ADDR inbandParam_virt;
+    memset(&inbandParam_virt, 0, sizeof(inbandParam_virt));
+    inbandParam_virt.ringheaderbaseVirtAddr=(void *)((unsigned long)(ion_virt));
+    inbandParam_virt.ringVirtAddr=(void *)((unsigned long)(ion_virt)+(64*1024));
+    inbandParam_virt.refclockVirtAddr=(void *)((unsigned long)(ion_virt)+(65*1024));
+
+    if (DC_Set_RPCAddr_Virt(&fb->fb, &fb->video_info, &inbandParam_virt)!= 0){
+        dbg_warn("SET_RING_INFO_VIRT fail \n");
+        return -1;
+    }
+#else
+    memset(&ion_share_memory, 0, sizeof(ion_share_memory));
+    ion_share_memory.sfd_refclk=0;
+    ion_share_memory.sfd_rbHeader=0;
+    ion_share_memory.sfd_rbBase=0;
+
+    if (DC_Set_ION_Share_Memory(&fb->fb, &fb->video_info, &ion_share_memory)!= 0){
+        dbg_warn("!!ERROR!! [ %s %d ] \n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+#endif
+
+    /* DCRT_CMD_SET_RING_INFO DC2VO_SET_RING_INFO */
+    memset(&inbandParam, 0, sizeof(inbandParam));
+    inbandParam.ringPhyAddr=ringbuffer.pRINGBUFF_HEADER;
+    inbandParam.refclockAddr=rpc_refclock.pRefClock;
+
+    if (DC_Set_RPCAddr(&fb->fb, &fb->video_info, &inbandParam)!= 0){
+        dbg_warn("SET_RING_INFO fail \n");
+        return -1;
+    }
+
+    /* VIDEO_RPC_VO_FILTER_ToAgent_Display_0 */
+    memset(&info, 0, sizeof(info));
+    info.instanceID = VIDEOAgentID;
+    info.videoPlane = VO_VIDEO_PLANE_OSD1;
+    info.zeroBuffer  = 1;
+    info.realTimeSrc = 0;
+    if (RPC_TOAGENT_VIDEO_DISPLAY(&info))
+    {
+        dbg_warn("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    SetAudioHdmiOutEdid2((unsigned char*)((unsigned long)ion_virt+66*1024), ion_phy+66*1024);
+
+    return 0;
+}
+
+void RTK_FB_RPC_OSD_uninit(void)
+{
+    if (rtkfb_handle != NULL) {
+        ion_unmap_kernel(rtkfb_client, rtkfb_handle);
+        ion_free(rtkfb_client, rtkfb_handle);
+        ion_client_destroy(rtkfb_client);
+    }
+}
\ No newline at end of file
diff --git a/drivers/video/fbdev/rtk/rtk_fb_RPC.h b/drivers/video/fbdev/rtk/rtk_fb_RPC.h
new file mode 100644
index 00000000..505e9bd
--- /dev/null
+++ b/drivers/video/fbdev/rtk/rtk_fb_RPC.h
@@ -0,0 +1,20 @@
+/**
+ * snd-realtek_common.h - Realtek alsa driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTK_FB_RPC_H
+#define RTK_FB_RPC_H
+
+int RTK_FB_RPC_OSD_init(struct rtk_fb *fb);
+void RTK_FB_RPC_OSD_uninit(void);
+
+#endif
+
+
diff --git a/drivers/video/fbdev/rtk/rtk_fb_freelogo.c b/drivers/video/fbdev/rtk/rtk_fb_freelogo.c
new file mode 100644
index 00000000..33a24d6
--- /dev/null
+++ b/drivers/video/fbdev/rtk/rtk_fb_freelogo.c
@@ -0,0 +1,78 @@
+/**
+ * rtk_fb_freelogo.c - Provide function to free bootlogo reserved mem
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+#include <linux/delay.h>
+#include <linux/mm.h>
+#include <linux/kthread.h>
+#include <linux/sched.h>
+
+static DEFINE_MUTEX(free_logo_mutex);
+
+#define INVERT_BITVAL_1 ~1
+
+static struct task_struct *free_logo_task;
+
+static void free_logo_rsv_mem(void *data) {
+	mutex_lock(&free_logo_mutex);
+	free_reserved_area(phys_to_virt(0x30000000),
+					   phys_to_virt(0x30900000),
+					   0,
+					   "logo area"
+					   );
+	mutex_unlock(&free_logo_mutex);
+}
+
+static int free_logo_threadfn(void *data) {
+	struct sched_param param = {
+		.sched_priority = MAX_RT_PRIO - 2,
+	};
+	int timeout = 5;
+
+	sched_setscheduler(current, SCHED_FIFO, &param);
+	while (1) {
+		if (kthread_should_stop() || timeout == 0)
+			break;
+		msleep(1000);
+		timeout--;
+	}
+	free_logo_rsv_mem(data);
+	return 0;
+}
+
+static void rtk_fb_free_logo_rsv_mem_init (void)
+{
+	/* create a thread to sleep N sec, then free logo reserved mem. area */
+	/* disabled by default */
+	#if 0
+	free_logo_task = kthread_create(free_logo_threadfn, NULL, "free_logo_area" );
+	if (IS_ERR(free_logo_task)) {
+		printk(KERN_ERR "\033[1;33m" "Failed to create free logo kthread task" "\033[m\n");
+		return 0;
+	}
+	kthread_bind(free_logo_task, 0);
+	wake_up_process(free_logo_task);
+	#endif
+	free_logo_rsv_mem(NULL);
+}
+EXPORT_SYMBOL(rtk_fb_free_logo_rsv_mem_init);
+
+ssize_t freelogo_store(struct device *dev, struct device_attribute *attr, const char *buf, size_t count) {
+	unsigned long state;
+	int ret;
+	ret = kstrtol(buf, 0, &state);
+	/* valid input value: 0 or 1 */
+	if (ret != 0 || state & INVERT_BITVAL_1)
+		return -EINVAL;
+
+	if (state == 1)
+		free_logo_rsv_mem(NULL);
+
+	return count;
+}
\ No newline at end of file
diff --git a/drivers/video/fbdev/rtk/rtk_fb_freelogo.h b/drivers/video/fbdev/rtk/rtk_fb_freelogo.h
new file mode 100644
index 00000000..ca0820d
--- /dev/null
+++ b/drivers/video/fbdev/rtk/rtk_fb_freelogo.h
@@ -0,0 +1,6 @@
+#ifndef __RTK_FB_FREELOGO_H__
+#define __RTK_FB_FREELOGO_H__
+
+ssize_t freelogo_store(struct device *dev, struct device_attribute *attr, const char *buf, size_t count);
+
+#endif
diff --git a/drivers/video/fbdev/rtk/rtk_vfb.c b/drivers/video/fbdev/rtk/rtk_vfb.c
new file mode 100644
index 00000000..05b0243
--- /dev/null
+++ b/drivers/video/fbdev/rtk/rtk_vfb.c
@@ -0,0 +1,868 @@
+/*
+ *  android_fb.c
+ * 
+ *  Copyright 2007, The Android Open Source Project
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 2 as
+ *  published by the Free Software Foundation.
+ */
+
+
+/*
+ * ANDROID PORTING GUIDE: FRAME BUFFER DRIVER TEMPLATE
+ *
+ * This template is designed to provide the minimum frame buffer
+ * functionality necessary for Android to display properly on a new
+ * device.  The PGUIDE_FB macros are meant as pointers indicating
+ * where to implement the hardware specific code necessary for the new
+ * device.  The existence of the macros is not meant to trivialize the
+ * work required, just as an indication of where the work needs to be
+ * done.
+ */
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/string.h>
+#include <linux/slab.h>
+#include <linux/delay.h>
+#include <linux/mm.h>
+#include <linux/fb.h>
+#include <linux/uaccess.h>
+#include <linux/init.h>
+#include <linux/platform_device.h>
+#include <linux/init.h>
+#include <linux/dma-mapping.h>
+#include <linux/of_device.h>
+#include <linux/of_platform.h>
+#include <linux/of_address.h>
+#include <linux/of_irq.h>
+#include <linux/io.h>
+#include <linux/dma-contiguous.h>
+#include <linux/kthread.h>
+#include <linux/sched.h>
+#include <asm/div64.h>
+
+#include "debug.h"
+#include "rtk_fb.h"
+#include "dc2vo/dc2vo.h"
+
+static DEFINE_MUTEX(free_logo_mutex);
+
+#define INVERT_BITVAL_1 ~1
+
+#ifdef CONFIG_REALTEK_AVCPU
+#include "avcpu.h"
+#endif
+
+
+
+struct fb_dmabuf_export
+{
+	__u32 fd;
+	__u32 flags;
+};
+#define FBIOGET_DMABUF  _IOR('F', 0x21, struct fb_dmabuf_export)
+
+struct fb_resize
+{
+	__u32 width;
+	__u32 height;
+	__u32 count;
+	__u32 byte_per_pixel;
+	__u32 reserve[16-4];
+};
+#define FBIOSET_RESIZE  _IOWR('F', 0x22, struct fb_resize)
+#define FBIOSET_GETBUFFER  _IO('F', 0x23)
+
+
+#include "../../../../drivers/staging/android/ion/ion.h"
+#include "../../../../drivers/staging/android/uapi/ion_rtk.h"
+extern struct ion_device *rtk_phoenix_ion_device;
+
+#define ANDROID_NUMBER_OF_FPS 60
+#define VIDEO_BYTES_PER_PIXEL 2
+static int debug = 0;
+static uint32_t my_fb_node=0;
+#define dprintk(msg...) if (debug)   { printk(KERN_ALERT	"D/RTK_VFB: " msg); }
+//#define dprintk(msg...) if (debug)   { dbg_info(KERN_DEBUG	"D/RTK_FB: " msg); }
+
+#define MEMORY_ALIGN( value, base ) (((value) + ((base) - 1)) & ~((base) - 1))
+#define ICQ_RING_BUFFER_SIZE 512*1024
+
+
+struct rtk_vfb_memory {
+	struct ion_client *fb_client;
+	struct ion_handle *fb_handle;
+	size_t alloc_size;
+	int width;
+	int height;
+	int align;
+	int count;
+	void *virAddr;
+	int byte_per_pixel;
+	int flags;
+    uint32_t                    VideoAddr;    
+    uint32_t                    VideoSize;     
+};
+
+struct rtk_vfb {
+	struct fb_info fb;
+	int rotation;
+	u32 cmap[16];
+	VENUSFB_MACH_INFO video_info;
+	struct rtk_vfb_memory *pMem;
+	int fps;
+	int irq;
+};
+
+enum rtk_vfb_memory_flags {
+	RTK_FB_MEM_ALLOC_ALGO_LAST_FIT = 0x1 << 0,
+	RTK_FB_MEM_FREE_FB = 0x1 << 1,
+};
+
+static struct task_struct *free_logo_task;
+uint32_t vfb_phyaddr;
+EXPORT_SYMBOL(vfb_phyaddr);
+struct ion_handle * vfb_handle;
+EXPORT_SYMBOL(vfb_handle);
+
+__maybe_unused static int rtk_vfb_set_size (struct rtk_vfb *fb, int width, int height, int count, int byte_per_pixel, int flags);
+__maybe_unused static int rtk_vfb_get_bufinfo(struct fb_info *info,struct FBDev_PARAM_BUF_ADDR *pbufinfo);
+
+__maybe_unused static int rtk_vfb_memory_alloc (struct rtk_vfb_memory **ppMem, int width, int height, int byte_per_pixel ,int align, int count, int flags);
+__maybe_unused static void rtk_vfb_memory_destroy (struct rtk_vfb_memory **ppMem);
+__maybe_unused static unsigned long rtk_vfb_memory_phy (struct rtk_vfb_memory *pMem);
+__maybe_unused static void *rtk_vfb_memory_map (struct rtk_vfb_memory *pMem);
+__maybe_unused static int rtk_vfb_memory_share_fd (struct rtk_vfb_memory *pMem);
+__maybe_unused static inline size_t rtk_vfb_memory_size (struct rtk_vfb_memory *pMem) { return (pMem != NULL) ? pMem->alloc_size:0;}
+__maybe_unused static inline int	rtk_vfb_memory_width (struct rtk_vfb_memory *pMem) { return (pMem != NULL) ? pMem->width:0;}
+__maybe_unused static inline int	rtk_vfb_memory_height (struct rtk_vfb_memory *pMem) { return (pMem != NULL) ? pMem->height:0;}
+__maybe_unused static inline int	rtk_vfb_memory_align (struct rtk_vfb_memory *pMem) { return (pMem != NULL) ? pMem->align:0;}
+__maybe_unused static inline int	rtk_vfb_memory_count (struct rtk_vfb_memory *pMem) { return (pMem != NULL) ? pMem->count:0;}
+__maybe_unused static inline int	rtk_vfb_memory_bypePrePixel  (struct rtk_vfb_memory *pMem) { return (pMem != NULL) ? pMem->byte_per_pixel:VIDEO_BYTES_PER_PIXEL;}
+
+static int fb_avcpu_event_notify(struct notifier_block *self, unsigned long action, void *data)
+{
+	struct fb_info *info = (struct fb_info *)registered_fb[my_fb_node];
+	struct rtk_vfb *fb = container_of(info, struct rtk_vfb, fb);
+	return DC_avcpu_event_notify(action, &fb->video_info);
+}
+
+__maybe_unused static struct notifier_block fb_avcpu_event_notifier = {
+	.notifier_call = fb_avcpu_event_notify,
+};
+
+static inline u32 convert_bitfield(int val, struct fb_bitfield *bf)
+{
+	unsigned int mask = (1 << bf->length) - 1;
+
+	return (val >> (16 - bf->length) & mask) << bf->offset;
+}
+
+/* set the software color map.  Probably doesn't need modifying. */
+static int rtk_vfb_setcolreg(unsigned int regno, unsigned int red, unsigned int green,
+	unsigned int blue, unsigned int transp, struct fb_info *info)
+{
+	struct rtk_vfb *fb = container_of(info, struct rtk_vfb, fb);
+
+	if (regno < 16) {
+		fb->cmap[regno] = convert_bitfield(transp, &fb->fb.var.transp) |
+			convert_bitfield(blue, &fb->fb.var.blue) |
+			convert_bitfield(green, &fb->fb.var.green) |
+			convert_bitfield(red, &fb->fb.var.red);
+		return 0;
+	} else {
+		return 1;
+	}
+}
+
+/* check var to see if supported by this device.  Probably doesn't
+ * need modifying.
+ */
+static int rtk_vfb_check_var(struct fb_var_screeninfo *var, struct fb_info *info)
+{
+	dprintk("[%s %d]\n", __func__, __LINE__);
+#if 0
+	if ((var->rotate & 1) != (info->var.rotate & 1)) {
+		if ((var->xres != info->var.yres) ||
+			(var->yres != info->var.xres) ||
+			(var->xres_virtual != info->var.yres) ||
+			(var->yres_virtual > info->var.xres * ANDROID_NUMBER_OF_BUFFERS) ||
+			(var->yres_virtual < info->var.xres )) {
+			return -EINVAL;
+		}
+	} else {
+		if ((var->xres != info->var.xres) ||
+			(var->yres != info->var.yres) ||
+			(var->xres_virtual != info->var.xres) ||
+			(var->yres_virtual > info->var.yres * ANDROID_NUMBER_OF_BUFFERS) ||
+			(var->yres_virtual < info->var.yres )) {
+			return -EINVAL;
+		}
+	}
+	if ((var->xoffset != info->var.xoffset) ||
+		(var->bits_per_pixel != info->var.bits_per_pixel) ||
+		(var->grayscale != info->var.grayscale)) {
+		return -EINVAL;
+	}
+#endif
+	return 0;
+}
+
+static int rtk_vfb_set_par(struct fb_info *info)
+{
+	struct rtk_vfb *fb = container_of(info, struct rtk_vfb, fb);
+	if (fb->rotation != fb->fb.var.rotate) {
+		dbg_info("[%s %d] TODO: FB_ROTATE\n",__func__,__LINE__);
+
+		info->fix.line_length   = info->var.xres * rtk_vfb_memory_bypePrePixel(fb->pMem);
+		fb->rotation = fb->fb.var.rotate;
+	}
+	return 0;
+}
+
+__maybe_unused static int rtk_vfb_blank(int blank_mode, struct fb_info *info)
+{
+	return 0;
+}
+
+static int rtk_vfb_pan_display(struct fb_var_screeninfo *var, struct fb_info *info)
+{
+	struct rtk_vfb *fb __attribute__ ((unused)) = container_of(info, struct rtk_vfb, fb);
+
+	/* Set the frame buffer base to something like:
+	 * fb->fb.fix.smem_start + fb->fb.var.xres *
+	 * VIDEO_BYTES_PER_PIXEL * var->yoffset
+	*/
+	fb->fb.var.xoffset = var->xoffset;
+	fb->fb.var.yoffset = var->yoffset;
+	fb->fb.var.xres_virtual = var->xres_virtual;
+	fb->fb.var.yres_virtual = var->yres_virtual;
+
+	return DC_Swap_Buffer(info, &fb->video_info);
+}
+
+static int rtk_vfb_mmap(struct fb_info *info, struct vm_area_struct *vma)
+{
+	struct rtk_vfb *fb __attribute__ ((unused)) = container_of(info, struct rtk_vfb, fb);
+	unsigned long start;
+	unsigned long mmio_pgoff;
+	u32 len;
+
+	start = info->fix.smem_start;
+	len = info->fix.smem_len;
+	mmio_pgoff  = PAGE_ALIGN((start & ~PAGE_MASK) + len) >> PAGE_SHIFT;
+
+	if (vma->vm_pgoff >= mmio_pgoff) {
+		if (info->var.accel_flags) {
+			return -EINVAL;
+		}
+
+		vma->vm_pgoff -= mmio_pgoff;
+		start   = info->fix.mmio_start;
+		len	 = info->fix.mmio_len;
+	}
+	//vma->vm_page_prot = vm_get_page_prot(vma->vm_flags);
+	vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+	return vm_iomap_memory(vma, start, len);
+}
+
+
+static int rtk_vfb_ioctl(struct fb_info *info, unsigned int cmd, unsigned long arg)
+{
+	struct rtk_vfb *fb __attribute__ ((unused)) = container_of(info, struct rtk_vfb, fb);
+	int gat_cmd = 0;
+	int ret = 0;
+
+	switch (cmd) {
+        case FBIOSET_GETBUFFER           :
+            {
+                struct FBDev_PARAM_BUF_ADDR bufinfo;
+                struct FBDev_PARAM_BUF_ADDR __user * up_bufinfo = (struct FBDev_PARAM_BUF_ADDR __user *) arg;
+                rtk_vfb_get_bufinfo(info, &bufinfo);
+                ret=copy_to_user(up_bufinfo, &bufinfo, sizeof(FBDev_PARAM_BUF_ADDR));
+                gat_cmd = 1;
+                break;
+            }
+	case FBIOSET_RESIZE:
+		{
+			struct fb_resize sNewSize;
+
+			if (copy_from_user(&sNewSize, (void *)arg, sizeof(sNewSize)) == 0) {
+				rtk_vfb_set_size(fb, sNewSize.width, sNewSize.height, sNewSize.count, sNewSize.byte_per_pixel, RTK_FB_MEM_FREE_FB);
+			}
+			gat_cmd = 1;
+			break;
+		}
+	case FBIOGET_DMABUF:
+		{
+			struct fb_dmabuf_export __user *up_dmabuf_export = (struct fb_dmabuf_export __user *) arg;
+			struct fb_dmabuf_export dmabuf_export;
+
+			dmabuf_export.flags = 0;
+			dmabuf_export.fd = (__u32) rtk_vfb_memory_share_fd(fb->pMem);
+#if defined(CONFIG_CPU_V7)
+			ret = copy_to_user(arg, &dmabuf_export, sizeof(dmabuf_export));
+#else
+			ret = put_user(dmabuf_export, up_dmabuf_export);
+#endif /* CONFIG_CPU_V7 */
+			dprintk("[%s] FBIOGET_DMABUF return[ret:%d fd:%d]\n", __func__, ret, dmabuf_export.fd);
+			gat_cmd = 1;
+			break;
+		}
+	default:
+		break;
+	}
+
+	if (gat_cmd)
+		return ret;
+
+    {
+        bool skip_lock = false;
+        if (mutex_is_locked(&info->lock))
+            skip_lock = true;
+
+        if (skip_lock)
+            unlock_fb_info(info);
+
+        ret = DC_Ioctl(info, (void *)&fb->video_info, cmd, arg);
+        if (skip_lock)
+            lock_fb_info(info);
+    }
+    return ret;
+}
+
+static int rtk_vfb_memory_alloc(struct rtk_vfb_memory ** ppMem, int width,
+	int height, int byte_per_pixel ,int align, int count, int flags)
+{
+	uint32_t video_size =
+		MEMORY_ALIGN((width * height * byte_per_pixel * count), align);
+	uint32_t ion_heap_mask =
+		RTK_PHOENIX_ION_HEAP_MEDIA_MASK;
+	uint32_t ion_heap_flag = ION_FLAG_NONCACHED | ION_FLAG_SCPUACC | ION_FLAG_HWIPACC;
+	struct rtk_vfb_memory *pMem = NULL;
+
+	if (*ppMem != NULL)
+		goto err;
+
+	if (flags & RTK_FB_MEM_ALLOC_ALGO_LAST_FIT)
+		ion_heap_flag |= ION_USAGE_ALGO_LAST_FIT;
+
+	*ppMem = (struct rtk_vfb_memory *)kzalloc(sizeof(struct rtk_vfb_memory),
+		GFP_KERNEL);
+	pMem = *ppMem;
+
+    pMem->alloc_size        = MEMORY_ALIGN(video_size+PAGE_SIZE/*for misc buffer*/,align);
+	pMem->fb_client = ion_client_create(rtk_phoenix_ion_device, "video_fb");
+
+	pMem->fb_handle = ion_alloc(pMem->fb_client, pMem->alloc_size,
+		align, ion_heap_mask, ion_heap_flag);
+	pMem->width = width;
+	pMem->height = height;
+	pMem->align = align;
+	pMem->count = count;
+	pMem->byte_per_pixel = byte_per_pixel;
+	pMem->flags = flags;
+    pMem->VideoAddr         = (uint32_t)rtk_vfb_memory_phy(pMem);
+    pMem->VideoSize         = video_size;    
+
+    vfb_phyaddr = pMem->VideoAddr;
+    vfb_handle = pMem->fb_handle;
+    dprintk("[%s] PAGE_SIZE:%d,PAGE_SHIFT:%d,video_size:%d,width:%d,height:%d,byte_per_pixel:%d,count:%d\n", __func__, PAGE_SIZE,PAGE_SHIFT,video_size,width,height,byte_per_pixel,count);
+
+	return 0;
+err:
+	if (pMem != NULL)
+		kfree(pMem);
+
+	*ppMem = NULL;
+
+	return -1;
+}
+
+static void rtk_vfb_memory_destroy(struct rtk_vfb_memory ** ppMem)
+{
+	struct rtk_vfb_memory *pMem;
+
+	if (ppMem == NULL || *ppMem == NULL)
+		return;
+
+	pMem = *ppMem;
+	ion_free(pMem->fb_client, pMem->fb_handle);
+	ion_client_destroy(pMem->fb_client);
+	kfree(pMem);
+	*ppMem = NULL;
+}
+
+static unsigned long rtk_vfb_memory_phy(struct rtk_vfb_memory *pMem)
+{
+	unsigned long ret = -1UL;
+	size_t len;
+
+	if (pMem == NULL)
+		goto err;
+
+	if (ion_phys(pMem->fb_client, pMem->fb_handle, &ret, &len) != 0) {
+		dbg_err("[%s %s] ion_phys error size=%ld\n", __FILE__, __func__, pMem->alloc_size);
+		ret = -1UL;
+	}
+
+err:
+	return ret;
+}
+
+static void *rtk_vfb_memory_map(struct rtk_vfb_memory *pMem)
+{
+	void *ret = NULL;
+
+	if (pMem == NULL)
+		goto err;
+
+	if (pMem->virAddr == NULL)
+		pMem->virAddr = ion_map_kernel(pMem->fb_client, pMem->fb_handle);
+
+	ret = pMem->virAddr;
+err:
+	return ret;
+}
+
+static int rtk_vfb_memory_share_fd(struct rtk_vfb_memory *pMem)
+{
+	int ret = -1;
+
+	if (pMem == NULL)
+		goto err;
+
+	ret = ion_share_dma_buf_fd(pMem->fb_client, pMem->fb_handle);
+
+err:
+	return ret;
+}
+
+static struct fb_ops rtk_vfb_ops = {
+	.owner = THIS_MODULE,
+	.fb_blank = rtk_vfb_blank,
+	.fb_check_var = rtk_vfb_check_var,
+	.fb_set_par = rtk_vfb_set_par,
+	.fb_setcolreg = rtk_vfb_setcolreg,
+	.fb_pan_display = rtk_vfb_pan_display,
+	.fb_ioctl = rtk_vfb_ioctl,
+	.fb_mmap = rtk_vfb_mmap,
+#ifdef CONFIG_COMPAT
+	.fb_compat_ioctl = rtk_vfb_ioctl,
+#endif
+	/* These are generic software based fb functions */
+#ifdef CONFIG_FB_CFB_FILLRECT
+	.fb_fillrect = cfb_fillrect,
+#endif
+#ifdef CONFIG_FB_CFB_COPYAREA
+	.fb_copyarea = cfb_copyarea,
+#endif
+#ifdef CONFIG_FB_CFB_IMAGEBLIT
+	.fb_imageblit = cfb_imageblit,
+#endif
+};
+
+static int rtk_vfb_update_by_memory(struct rtk_vfb *fb, struct rtk_vfb_memory *pMem)
+{
+	int ret = -1;
+	int fb_width;
+	int fb_height;
+	dma_addr_t fb_phys;
+	size_t	  fb_size;
+	int fb_cnt;
+	void *fb_virAddr;
+	int fb_byte_per_pixel;
+	long long temp;
+	long long temp2;
+
+	if (fb == NULL || pMem == NULL)
+		goto err_fb_set_var_failed;
+
+	fb_phys = rtk_vfb_memory_phy(pMem);
+	fb_size = rtk_vfb_memory_size(pMem);
+	fb_width = rtk_vfb_memory_width(pMem);
+	fb_height = rtk_vfb_memory_height(pMem);
+	fb_virAddr = rtk_vfb_memory_map(pMem);
+	fb_byte_per_pixel = rtk_vfb_memory_bypePrePixel(pMem);
+
+	dbg_info("[%s %s] [%d x %d] addr:0x%lx size:0x%lx irq:%d\n",
+		__FILE__, __func__, fb_width, fb_height, (unsigned long)fb_phys, fb_size, fb->irq);
+
+	fb->fb.flags	 = FBINFO_FLAG_DEFAULT;
+	fb->fb.pseudo_palette = fb->cmap;
+	fb->fb.fix.type = FB_TYPE_PACKED_PIXELS;
+	fb->fb.fix.visual = FB_VISUAL_TRUECOLOR;
+	fb->fb.fix.line_length = fb_width *fb_byte_per_pixel;
+	fb->fb.fix.accel = FB_ACCEL_NONE;
+	fb->fb.fix.ypanstep = 1;
+
+	fb_cnt = (fb_size)/(fb->fb.fix.line_length * fb_height);
+
+	if (fb_cnt > rtk_vfb_memory_count(pMem))
+		fb_cnt = rtk_vfb_memory_count(pMem);
+
+	dbg_info("[%s %s] numberofbuffers %d\n",
+		__FILE__, __func__, fb_cnt);
+
+	fb->fb.var.xres = fb_width;
+	fb->fb.var.yres = fb_height;
+	fb->fb.var.xres_virtual = fb_width;
+	fb->fb.var.yres_virtual = fb_height * fb_cnt;
+	fb->fb.var.activate = FB_ACTIVATE_NOW;
+	fb->fb.var.height = fb_height;
+	fb->fb.var.width = fb_width;
+
+	if (fb_byte_per_pixel == 4) {
+		/* ARGB 8888 */
+		fb->fb.var.bits_per_pixel = 32;
+		fb->fb.var.transp.offset = 24;
+		fb->fb.var.transp.length = 8;
+		fb->fb.var.red.offset = 16;
+		fb->fb.var.red.length = 8;
+		fb->fb.var.green.offset = 8;
+		fb->fb.var.green.length = 8;
+		fb->fb.var.blue.offset = 0;
+		fb->fb.var.blue.length = 8;
+	} else {
+		/* RGB 565 */
+		fb->fb.var.bits_per_pixel = 16;
+		fb->fb.var.red.offset = 11;
+		fb->fb.var.red.length = 5;
+		fb->fb.var.green.offset = 5;
+		fb->fb.var.green.length = 6;
+		fb->fb.var.blue.offset = 0;
+		fb->fb.var.blue.length = 5;
+	}
+
+	fb->fb.var.width = 0;
+	fb->fb.var.height = 0;
+
+	switch (fb_width) {
+	case 1920:
+	case 720:
+		fb->fb.var.vsync_len = 1;
+		fb->fb.var.hsync_len = 2;
+		break;
+	case 1280:
+		fb->fb.var.vsync_len = 11;
+		fb->fb.var.hsync_len = 3;
+	default:
+		break;
+	}
+
+	temp = (fb->fb.var.xres+fb->fb.var.vsync_len) * (fb->fb.var.yres+fb->fb.var.hsync_len);
+	temp2 = 1000000000000;
+	do_div(temp2, temp);
+	fb->fb.var.pixclock = temp2;
+	fb->fb.var.pixclock /= fb->fps;
+	fb->fb.fix.smem_len = fb_size;
+	fb->fb.fix.smem_start = fb_phys;
+	fb->fb.screen_base = fb_virAddr;
+	if (!fb->fb.screen_base) {
+		dbg_err("Could not allocate frame buffer memory");
+		goto err_fb_set_var_failed;
+	}
+	if (fb_set_var(&fb->fb, &fb->fb.var) != 0) {
+		goto err_fb_set_var_failed;
+	}
+
+	ret = 0;
+err_fb_set_var_failed:
+	return ret ;
+}
+
+static void free_logo_rsv_mem(void *data) {
+	mutex_lock(&free_logo_mutex);
+	free_reserved_area(phys_to_virt(0x30000000),
+					   phys_to_virt(0x30900000),
+					   0,
+					   "logo area"
+					   );
+	mutex_unlock(&free_logo_mutex);
+}
+
+static int free_logo_threadfn(void *data) {
+	struct sched_param param = {
+		.sched_priority = MAX_RT_PRIO - 2,
+	};
+	int timeout = 5;
+
+	sched_setscheduler(current, SCHED_FIFO, &param);
+	while (1) {
+		if (kthread_should_stop() || timeout == 0)
+			break;
+		msleep(1000);
+		timeout--;
+	}
+	free_logo_rsv_mem(data);
+	return 0;
+}
+
+static void rtk_vfb_free_logo_rsv_mem_init (void)
+{
+	/* create a thread to sleep N sec, then free logo reserved mem. area */
+	/* disabled by default */
+	#if 0
+	free_logo_task = kthread_create(free_logo_threadfn, NULL, "free_logo_area" );
+	if (IS_ERR(free_logo_task)) {
+		printk(KERN_ERR "\033[1;33m" "Failed to create free logo kthread task" "\033[m\n");
+		return 0;
+	}
+	kthread_bind(free_logo_task, 0);
+	wake_up_process(free_logo_task);
+	#endif
+	free_logo_rsv_mem(NULL);
+}
+EXPORT_SYMBOL(rtk_vfb_free_logo_rsv_mem_init);
+
+static ssize_t freelogo_store(struct device *dev, struct device_attribute *attr, const char *buf, size_t count) {
+	unsigned long state;
+	int ret;
+	ret = kstrtol(buf, 0, &state);
+	/* valid input value: 0 or 1 */
+	if (ret != 0 || state & INVERT_BITVAL_1)
+		return -EINVAL;
+
+	if (state == 1)
+		free_logo_rsv_mem(NULL);
+	
+	return count;
+}
+
+static DEVICE_ATTR(freelogo, S_IWUSR, NULL, freelogo_store);
+  
+static int rtk_vfb_get_bufinfo (struct fb_info *info,struct FBDev_PARAM_BUF_ADDR *pbufinfo)
+{
+    struct rtk_vfb *fb = container_of(info, struct rtk_vfb, fb);
+
+    pbufinfo->video_buf_Paddr=fb->pMem->VideoAddr;
+    pbufinfo->video_buf_count=fb->pMem->count;
+    pbufinfo->video_buf_size=fb->pMem->VideoSize;
+    pbufinfo->width=fb->pMem->width;
+    pbufinfo->height=fb->pMem->height;
+    pbufinfo->misc_buf_Paddr=pbufinfo->video_buf_Paddr + pbufinfo->video_buf_size;
+    pbufinfo->misc_buf_size=PAGE_SIZE;
+    return 0;
+}
+
+
+static int rtk_vfb_set_size (struct rtk_vfb *fb, int width, int height,
+	int count, int _byte_per_pixel, int flags)
+{
+	int ret = -1;
+	struct rtk_vfb_memory *pMem = NULL;
+	int byte_per_pixel = VIDEO_BYTES_PER_PIXEL;
+
+    if (flags == RTK_FB_MEM_FREE_FB) {
+        if (fb->pMem != NULL) {
+            rtk_vfb_memory_destroy(&fb->pMem);
+        }
+        fb->pMem = NULL;
+        goto done;
+    }
+
+	/* Only support 4 byte or 2 byte */
+	switch (_byte_per_pixel) {
+	case 4:
+	case 2:
+		byte_per_pixel = _byte_per_pixel;
+		break;
+	default:
+		break;
+	}
+
+	if (fb->pMem != NULL &&
+		width	== rtk_vfb_memory_width(fb->pMem) &&
+		height == rtk_vfb_memory_height(fb->pMem) &&
+		count == rtk_vfb_memory_count(fb->pMem) &&
+		byte_per_pixel == rtk_vfb_memory_bypePrePixel(fb->pMem))
+		goto done;
+
+	ret = rtk_vfb_memory_alloc(&pMem, MEMORY_ALIGN(width,16), MEMORY_ALIGN(height,16), byte_per_pixel, PAGE_SIZE, count, flags);
+	if (ret != 0) {
+		dbg_err("[%s %s] rtk_vfb_memory_alloc return error! ([%dx%d] bypePrePixel=%d align=%ld count=%d) \n",
+			__FILE__, __func__, width, height, byte_per_pixel, PAGE_SIZE, count);
+		goto err;
+	}
+
+
+	ret = rtk_vfb_update_by_memory(fb, pMem);
+	if (ret != 0) {
+		dbg_err("[%s %s] rtk_vfb_update_by_memory return error! ([%dx%d] bypePrePixel=%d align=%ld count=%d) \n",
+			__FILE__, __func__, width, height, byte_per_pixel, PAGE_SIZE, count);
+		goto err;
+	}
+
+	if (fb->pMem != NULL){
+		rtk_vfb_memory_destroy(&fb->pMem);
+	}
+
+	fb->pMem = pMem;
+
+done:
+	ret = 0;
+err:
+	return ret;
+}
+
+static int rtk_vfb_probe(struct platform_device *pdev)
+{
+	int ret = 0;
+	struct rtk_vfb *fb;
+	int width;
+	int height;
+	int count;
+	const u32 *prop;
+	int size;
+
+	dbg_warn("[%s %s] \n", __FILE__, __func__);
+
+	fb = kzalloc(sizeof(*fb), GFP_KERNEL);
+	if (fb == NULL) {
+		ret = -ENOMEM;
+		goto err_fb_alloc_failed;
+	}
+
+	fb->fps = ANDROID_NUMBER_OF_FPS;
+
+	prop = of_get_property(pdev->dev.of_node, "resolution", &size);
+	if ((prop) && (size >= sizeof(u32)*2)) {
+		width = of_read_number(prop, 1);
+		height = of_read_number(prop, 2);
+	} else {
+		width = 1280;
+		height = 720;
+		dbg_warn("[%s %s] Use default w:%d h:%d\n", __FILE__, __func__, width, height);
+	}
+
+	prop = of_get_property(pdev->dev.of_node, "buffer-cnt", &size);
+	if ((prop) && (size >= sizeof(u32) * 1)) {
+		count = of_read_number(prop, 1);
+	} else {
+		count = 3;
+		dbg_warn("[%s %s] Use default count:%d\n", __FILE__, __func__, count);
+	}
+
+	fb->irq = irq_of_parse_and_map(pdev->dev.of_node, 0);
+
+	prop = of_get_property(pdev->dev.of_node, "fps", &size);
+	if ((prop) && (size >= sizeof(u32) * 1))
+		fb->fps = of_read_number(prop, 1);
+	else
+		dbg_warn("[%s %s] Use default fps:%d\n", __FILE__, __func__, fb->fps);
+
+	ret = rtk_vfb_set_size(fb, width, height, count,  VIDEO_BYTES_PER_PIXEL, RTK_FB_MEM_ALLOC_ALGO_LAST_FIT);
+	if (ret != 0) {
+		dbg_err("[%s %s] rtk_vfb_set_size return error! ([%dx%d] bypePrePixel=%d align=%ld count=%d) \n",
+			__FILE__, __func__, width, height,  VIDEO_BYTES_PER_PIXEL, PAGE_SIZE, count);
+		goto err_fb_set_var_failed;
+	}
+
+	dev_set_drvdata(&pdev->dev, fb);
+
+	DC_Init(&fb->video_info, &fb->fb, fb->irq);
+
+	fb->fb.fbops = &rtk_vfb_ops;
+
+	/* Avoid black screen */
+	//memset(fb->fb.screen_base,0, fb_size);
+
+	ret = register_framebuffer(&fb->fb);
+	if(ret)
+		goto err_register_framebuffer_failed;
+
+	my_fb_node=fb->fb.node;
+
+#ifdef CONFIG_REALTEK_AVCPU
+	register_avcpu_notifier(&fb_avcpu_event_notifier);
+#endif
+
+	ret = device_create_file(&pdev->dev, &dev_attr_freelogo);
+	if (ret < 0)
+		goto err_create_devfile_failed;
+
+	return 0;
+
+err_create_devfile_failed:
+	unregister_framebuffer(&fb->fb);
+err_register_framebuffer_failed:
+err_fb_set_var_failed:
+	DC_Deinit(&fb->video_info);
+	kfree(fb);
+
+err_fb_alloc_failed:
+
+	return ret;
+}
+
+static int rtk_vfb_suspend(struct device *dev)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_vfb *fb = platform_get_drvdata(pdev);
+
+	return DC_Suspend(&fb->video_info);
+}
+
+static int rtk_vfb_resume(struct device *dev)
+{
+	struct platform_device *pdev = to_platform_device(dev);
+	struct rtk_vfb *fb = platform_get_drvdata(pdev);
+
+	return DC_Resume(&fb->video_info);
+}
+
+static int rtk_vfb_remove(struct platform_device *pdev)
+{
+	struct rtk_vfb *fb = platform_get_drvdata(pdev);
+
+	device_remove_file(&pdev->dev, &dev_attr_freelogo);
+#ifdef CONFIG_REALTEK_AVCPU
+	unregister_avcpu_notifier(&fb_avcpu_event_notifier);
+#endif
+	DC_Deinit(&fb->video_info);
+	unregister_framebuffer(&fb->fb);
+    if (fb->pMem != NULL)
+        rtk_vfb_memory_destroy(&fb->pMem);
+	if (fb != NULL)
+		kfree(fb);
+	dev_set_drvdata(&pdev->dev, NULL);
+
+	return 0;
+}
+
+static struct of_device_id rtk_vfb_ids[] = {
+	{ .compatible = "Realtek,rtk-vfb" },
+	{ /* Sentinel */ },
+};
+
+MODULE_DEVICE_TABLE(of, rtk_vfb_ids);
+
+static const struct dev_pm_ops rtk_vfb_pm_ops = {
+	.suspend = rtk_vfb_suspend,
+	.resume  = rtk_vfb_resume,
+};
+
+static struct platform_driver rtkvfb_of_driver = {
+	.probe  = rtk_vfb_probe,
+	.remove	= rtk_vfb_remove,
+	.driver = {
+		.name = "rtk-vfb",
+		.owner = THIS_MODULE,
+		.of_match_table = rtk_vfb_ids,
+#ifdef CONFIG_PM
+		.pm = &rtk_vfb_pm_ops,
+#endif
+	},
+};
+
+//module_platform_driver_probe(rtkvfb_of_driver, rtk_vfb_probe);
+
+static int rtk_vfb_init(void)
+{
+	return platform_driver_register(&rtkvfb_of_driver);
+}
+late_initcall(rtk_vfb_init);
+
+MODULE_LICENSE("GPL");
diff --git a/drivers/w1/masters/ds2482.c b/drivers/w1/masters/ds2482.c
index 2e30db1..fa13fa8 100644
--- a/drivers/w1/masters/ds2482.c
+++ b/drivers/w1/masters/ds2482.c
@@ -18,6 +18,8 @@
 #include <linux/slab.h>
 #include <linux/i2c.h>
 #include <linux/delay.h>
+#include <linux/gpio.h>
+#include <linux/platform_data/ds2482.h>
 #include <asm/delay.h>
 
 #include "../w1.h"
@@ -97,7 +99,8 @@
 static int ds2482_probe(struct i2c_client *client,
 			const struct i2c_device_id *id);
 static int ds2482_remove(struct i2c_client *client);
-
+static int ds2482_suspend(struct device *dev);
+static int ds2482_resume(struct device *dev);
 
 /**
  * Driver data (common to all clients)
@@ -108,9 +111,15 @@ static int ds2482_probe(struct i2c_client *client,
 };
 MODULE_DEVICE_TABLE(i2c, ds2482_id);
 
+static const struct dev_pm_ops ds2482_pm_ops = {
+	.suspend = ds2482_suspend,
+	.resume = ds2482_resume,
+};
+
 static struct i2c_driver ds2482_driver = {
 	.driver = {
 		.name	= "ds2482",
+		.pm = &ds2482_pm_ops,
 	},
 	.probe		= ds2482_probe,
 	.remove		= ds2482_remove,
@@ -132,6 +141,7 @@ struct ds2482_w1_chan {
 struct ds2482_data {
 	struct i2c_client	*client;
 	struct mutex		access_lock;
+	int			slpz_gpio;
 
 	/* 1-wire interface(s) */
 	int			w1_count;	/* 1 or 8 */
@@ -460,11 +470,31 @@ static u8 ds2482_w1_set_pullup(void *data, int delay)
 	return retval;
 }
 
+static int ds2482_suspend(struct device *dev)
+{
+	struct i2c_client *client = to_i2c_client(dev);
+	struct ds2482_data *data = i2c_get_clientdata(client);
+
+	if (data->slpz_gpio >= 0)
+		gpio_set_value(data->slpz_gpio, 0);
+	return 0;
+}
+
+static int ds2482_resume(struct device *dev)
+{
+	struct i2c_client *client = to_i2c_client(dev);
+	struct ds2482_data *data = i2c_get_clientdata(client);
+
+	if (data->slpz_gpio >= 0)
+		gpio_set_value(data->slpz_gpio, 1);
+	return 0;
+}
 
 static int ds2482_probe(struct i2c_client *client,
 			const struct i2c_device_id *id)
 {
 	struct ds2482_data *data;
+	struct ds2482_platform_data *pdata;
 	int err = -ENODEV;
 	int temp1;
 	int idx;
@@ -531,6 +561,16 @@ static int ds2482_probe(struct i2c_client *client,
 		}
 	}
 
+	pdata = client->dev.platform_data;
+	data->slpz_gpio = pdata ? pdata->slpz_gpio : -1;
+
+	if (data->slpz_gpio >= 0) {
+		err = gpio_request_one(data->slpz_gpio, GPIOF_OUT_INIT_HIGH,
+				       "ds2482.slpz");
+		if (err < 0)
+			goto exit_w1_remove;
+	}
+
 	return 0;
 
 exit_w1_remove:
@@ -555,6 +595,11 @@ static int ds2482_remove(struct i2c_client *client)
 			w1_remove_master_device(&data->w1_ch[idx].w1_bm);
 	}
 
+	if (data->slpz_gpio >= 0) {
+		gpio_set_value(data->slpz_gpio, 0);
+		gpio_free(data->slpz_gpio);
+	}
+
 	/* Free the memory */
 	kfree(data);
 	return 0;
diff --git a/drivers/watchdog/Kconfig b/drivers/watchdog/Kconfig
index 8f8909a..d38794f 100644
--- a/drivers/watchdog/Kconfig
+++ b/drivers/watchdog/Kconfig
@@ -714,6 +714,13 @@ config ASPEED_WATCHDOG
 	  To compile this driver as a module, choose M here: the
 	  module will be called aspeed_wdt.
 
+config RTK_WATCHDOG
+    tristate "Realtek watchdog support"
+    depends on RTK_PLATFORM
+    select WATCHDOG_CORE
+    help
+      Realtek  watchdog support.
+
 # AVR32 Architecture
 
 config AT32AP700X_WDT
diff --git a/drivers/watchdog/Makefile b/drivers/watchdog/Makefile
index caa9f4a..877d93b 100644
--- a/drivers/watchdog/Makefile
+++ b/drivers/watchdog/Makefile
@@ -82,6 +82,7 @@ obj-$(CONFIG_BCM7038_WDT) += bcm7038_wdt.o
 obj-$(CONFIG_ATLAS7_WATCHDOG) += atlas7_wdt.o
 obj-$(CONFIG_RENESAS_WDT) += renesas_wdt.o
 obj-$(CONFIG_ASPEED_WATCHDOG) += aspeed_wdt.o
+obj-$(CONFIG_RTK_WATCHDOG) += rtk_wdt.o
 
 # AVR32 Architecture
 obj-$(CONFIG_AT32AP700X_WDT) += at32ap700x_wdt.o
diff --git a/drivers/watchdog/rtk_wdt.c b/drivers/watchdog/rtk_wdt.c
new file mode 100644
index 00000000..0d8b0be
--- /dev/null
+++ b/drivers/watchdog/rtk_wdt.c
@@ -0,0 +1,459 @@
+/*
+ * rtk_wdt.c -  Realtek watchdog driver
+ *
+ * Copyright (c) 2018 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#include <linux/io.h>
+#include <linux/clk.h>
+#include <linux/delay.h>
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/jiffies.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/notifier.h>
+#include <linux/of_address.h>
+#include <linux/platform_device.h>
+#include <linux/reboot.h>
+#include <linux/regmap.h>
+#include <linux/timer.h>
+#include <linux/watchdog.h>
+#include <linux/interrupt.h>
+#include <linux/sysrq.h>
+#include <soc/realtek/rtk_wdt.h>
+
+#define TCWCR 0x0
+#define TCWTR 0x4
+#define TCWNMI 0x8
+#define TCWOV 0xc
+
+
+#define MSK_ISR	0x0c
+
+
+#define TCWOV_RSTB_CNT 0x40
+#define TCWOV_RSTB_PAD 0x44
+static int watchdog_oe = -1;
+
+#define ISO_WDT_CLK (27000000) /* 27 MHz */
+#define ISO_WDT_1MS_CNT (27000)
+
+struct rtk_wdt {
+	struct watchdog_device wdt;
+	struct clk *clk;
+	unsigned long rate;
+	struct notifier_block restart_nb;
+	void __iomem *wdt_base;
+	void __iomem *misc_base;
+	void __iomem *iso_base;
+	unsigned int expire;
+	int 	irq;
+	struct notifier_block iso_reset_nb;
+	struct notifier_block sysrq_nb;
+};
+
+typedef enum {
+	WAKE_PWR = 0,
+	WAKE_SOFT,
+	WAKE_WDT,
+	WAKE_BUTTON,
+} WAKE_UP_REAONS;
+
+static WAKE_UP_REAONS wake_up_reason = WAKE_PWR;
+struct rtk_wdt *rtk_wdt_p = NULL;
+static ATOMIC_NOTIFIER_HEAD(rtk_wdt_notifier_chain);
+
+int rtk_wdt_register_notifier(struct notifier_block *nb)
+{
+	return atomic_notifier_chain_register(&rtk_wdt_notifier_chain, nb);
+}
+EXPORT_SYMBOL_GPL(rtk_wdt_register_notifier);
+
+int rtk_wdt_unregister_notifier(struct notifier_block *nb)
+{
+	return atomic_notifier_chain_unregister(&rtk_wdt_notifier_chain, nb);
+}
+EXPORT_SYMBOL_GPL(rtk_wdt_unregister_notifier);
+
+static int __rtk_wdt_notify(void)
+{
+	return atomic_notifier_call_chain(&rtk_wdt_notifier_chain, 0 , NULL);
+}
+
+static int wakeupreason_config(char *str)
+{
+	if (!str)
+		return -EINVAL;
+	if (strcmp(str, "software") == 0)
+		wake_up_reason = WAKE_SOFT;
+	else if (strcmp(str, "watchdog") == 0)
+		wake_up_reason = WAKE_WDT;
+	else
+		pr_err("%s: invalid wakeupreason \"%s\"\n", __func__, str);
+
+	return 0;
+}
+early_param("wakeupreason", wakeupreason_config);
+
+static int rtk_wdt_start(struct watchdog_device *wdd)
+{
+	int ret = 0;
+	struct rtk_wdt *wdt = container_of(wdd, struct rtk_wdt, wdt);
+	void __iomem *base = wdt->iso_base;
+
+	if (base)	
+		writel(0x00800000, base + TCWOV_RSTB_CNT);
+
+	base = wdt->wdt_base;	
+	writel(0x800000FF, base + TCWCR);                           /* enable Watchdog & NMI */  
+
+	wdt->expire = wdd->timeout + ktime_to_timespec(ktime_get()).tv_sec;	
+	return ret;
+}
+
+static int rtk_wdt_stop(struct watchdog_device *wdd)
+{
+	int ret = 0;
+	struct rtk_wdt *wdt = container_of(wdd, struct rtk_wdt, wdt);
+	void __iomem *base = wdt->wdt_base;
+
+	writel(0xA5, base + TCWCR );
+
+	return ret;
+}
+
+static int rtk_wdt_ping(struct watchdog_device *wdd)
+{
+	int ret = 0;
+	struct rtk_wdt *wdt = container_of(wdd, struct rtk_wdt, wdt);
+	void __iomem *base = wdt->wdt_base;
+
+	writel(0x01, base + TCWTR);
+	wdt->expire = wdd->timeout + ktime_to_timespec(ktime_get()).tv_sec;	
+
+	return ret;
+}
+
+static int rtk_wdt_set_timeout(struct watchdog_device *wdd,
+	unsigned int timeout)
+{
+	int ret = 0;
+	struct rtk_wdt *wdt = container_of(wdd, struct rtk_wdt, wdt);
+	void __iomem *base = wdt->wdt_base;
+
+	writel(0xA5, base + TCWCR);
+	writel(0x01, base + TCWTR);
+	writel((timeout * 1000 * ISO_WDT_1MS_CNT), base + TCWOV);
+	writel(0x800000FF, base + TCWCR);                           /* enable Watchdog & NMI */  
+
+	wdd->timeout = timeout;	
+	wdt->expire = wdd->timeout + ktime_to_timespec(ktime_get()).tv_sec;	
+
+	return ret;
+}
+
+
+static int rtk_wdt_set_pretimeout(struct watchdog_device *wdd,
+	unsigned int timeout)
+{
+	int ret = 0;
+	struct rtk_wdt *wdt = container_of(wdd, struct rtk_wdt, wdt);
+	void __iomem *base = wdt->wdt_base;
+	unsigned int tmp_timeout;
+
+	if (timeout == 0) {
+		/* disable NMI interrupt */
+		writel(0x00, base + TCWCR);
+		return ret;	
+	}
+
+	tmp_timeout = wdd->timeout - timeout ;
+
+	writel(0xA5, base + TCWCR);
+	writel(0x01, base + TCWTR);
+	writel((tmp_timeout * 1000 * ISO_WDT_1MS_CNT), base + TCWNMI);
+	writel(0x800000FF, base + TCWCR);                           /* enable Watchdog & NMI */  
+
+	wdd->pretimeout = timeout;
+	
+	return ret;
+}
+
+static unsigned int rtk_wdt_gettimeleft(struct watchdog_device *wdd)
+{
+	struct rtk_wdt *wdt = container_of(wdd, struct rtk_wdt, wdt);
+
+	return wdt->expire - ktime_to_timespec(ktime_get()).tv_sec;
+}
+
+static void  rtk_wdt_set_bootstatus(struct watchdog_device *wdd)
+{
+	switch (wake_up_reason) {
+		case WAKE_PWR:
+			wdd->bootstatus = WDIOF_POWERUNDER;
+			break;
+		case WAKE_SOFT:
+			wdd->bootstatus = WDIOF_EXTERN1;
+			break;
+		case WAKE_WDT:
+			wdd->bootstatus = WDIOF_CARDRESET;
+			break;
+		case WAKE_BUTTON:
+			wdd->bootstatus = WDIOF_EXTERN2;
+			break;
+		default:
+			pr_err("%s: invalid wake_up_reason %d\n", __func__, wake_up_reason);
+			wdd->bootstatus = WDIOF_POWERUNDER;
+	}
+}
+
+static int rtk_wdt_restart(struct notifier_block *nb, unsigned long action,
+	void *data)
+{
+	struct rtk_wdt *wdt = container_of(nb, struct rtk_wdt, restart_nb);
+	struct watchdog_device *wdd;
+	void __iomem *base = wdt->wdt_base;
+	u32 timeout = 20 * 1000;
+
+	wdd = &(wdt->wdt); 
+	writel(0xA5, base + TCWCR);
+	writel(0x01, base + TCWTR);
+	writel((timeout * ISO_WDT_1MS_CNT), base + TCWOV);
+	writel(((timeout - 2) * ISO_WDT_1MS_CNT), base + TCWNMI);   /* for NMI */
+	writel(0x800000FF, base + TCWCR);                           /* enable Watchdog & NMI */  
+
+	wdt->wdt.timeout = 20;
+	wdt->expire = wdd->timeout + ktime_to_timespec(ktime_get()).tv_sec;	
+
+	msleep(150);
+	return NOTIFY_DONE;
+}
+
+static irqreturn_t rtk_wdt_irq(int irq, void *devid)
+{
+        struct rtk_wdt *wdt = devid;
+	void __iomem *base = wdt->misc_base;	
+	int value = readl(base + MSK_ISR);
+	/* check watchdog NMI INT status */
+    	if(!(value & 0x04)) 
+        	return IRQ_NONE;
+
+	pr_err("%s WATCHDOG NMI INT \n", __func__);
+	/* clear watchdog NMI INT status */
+	writel(0x04, base + MSK_ISR);     
+
+	rtk_wdt_stop(&(wdt->wdt));
+
+	__rtk_wdt_notify();
+        return IRQ_HANDLED;
+}
+
+static int rtk_wdt_sysrq_cb(struct notifier_block *nb,
+			    unsigned long v, void *p)
+{
+	handle_sysrq('9');
+	dump_stack();
+	handle_sysrq('w');
+	handle_sysrq('l');
+	/* dump memory stats */
+	handle_sysrq('m');
+	handle_sysrq('p');
+	handle_sysrq('q');
+	/* dump scheduler state */
+	handle_sysrq('t');
+	handle_sysrq('z');
+	return NOTIFY_OK;
+}
+
+static int rtk_wdt_iso_reset_cb(struct notifier_block *nb,
+				unsigned long v, void *p)
+{
+	struct rtk_wdt *wdt = container_of(nb, struct rtk_wdt, iso_reset_nb);
+	void *base = wdt->iso_base;
+
+	mdelay(200);
+	/* only ISO watchdog can handle oe ouptput , force us to use it instead of MISC watchdog*/
+	writel(0xA5, base + TCWCR);
+	writel(0x01, base + TCWTR);
+	writel((0x0 * ISO_WDT_1MS_CNT), base + TCWOV);
+	writel(0x000000FF, base + TCWCR);
+	for (;;);
+	return NOTIFY_OK;
+}
+
+int set_wdt_oe(void)
+{
+	if (watchdog_oe < 0)
+		return -EINVAL;
+
+	if (!rtk_wdt_p || !rtk_wdt_p->iso_base)
+		return -ENXIO;
+
+	writel(watchdog_oe, rtk_wdt_p->iso_base + TCWOV_RSTB_PAD);
+	pr_info("[%s] set watchdog-oe to %d\n", KBUILD_MODNAME, watchdog_oe);
+
+	return 0;
+}
+EXPORT_SYMBOL(set_wdt_oe);
+
+static const struct watchdog_info rtk_wdt_info = {
+	.identity = "Realtek watchdog",
+	.options = WDIOF_KEEPALIVEPING | WDIOF_SETTIMEOUT | WDIOF_MAGICCLOSE,
+};
+
+static const struct watchdog_ops rtk_wdt_ops = {
+	.owner = THIS_MODULE,
+	.start = rtk_wdt_start,
+	.stop = rtk_wdt_stop,
+	.ping = rtk_wdt_ping,
+	.set_timeout = rtk_wdt_set_timeout,
+	.set_pretimeout = rtk_wdt_set_pretimeout,
+	.get_timeleft	= rtk_wdt_gettimeleft,
+
+};
+
+static int rtk_wdt_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *np;
+	struct rtk_wdt *rtk_wdt;
+	struct resource *res;
+	int ret = 0;
+	int init_oe = 0;
+
+	pr_err("[%s] %s enter\n", KBUILD_MODNAME, __func__);
+
+	rtk_wdt = devm_kzalloc(&pdev->dev, sizeof(*rtk_wdt), GFP_KERNEL);
+	if (!rtk_wdt)
+		return -ENOMEM;
+
+	if (WARN_ON(!(pdev->dev.of_node))) {
+		pr_err("Error: No node\n");
+		return -ENODEV;
+	}
+
+	np = pdev->dev.of_node;
+
+	rtk_wdt->wdt_base =of_iomap(np, 0);
+	if (IS_ERR(rtk_wdt->wdt_base))
+		return PTR_ERR(rtk_wdt->wdt_base);
+
+	rtk_wdt->iso_base = of_iomap(np, 2);
+	if (IS_ERR(rtk_wdt->iso_base))
+		return PTR_ERR(rtk_wdt->iso_base);
+
+	/* set pin direction for pmic reset signal */
+	if (!of_property_read_u32_index(np,
+		"rst-oe-for-init", 0, &init_oe)) {
+		pr_err("[%s] init_oe = 0x%x \n", KBUILD_MODNAME, init_oe);
+		writel(0x00800000, rtk_wdt->iso_base + TCWOV_RSTB_CNT);
+		writel(init_oe, rtk_wdt->iso_base + TCWOV_RSTB_PAD);
+	}
+
+	if (!of_property_read_u32_index(np,
+		"rst-oe", 0, &watchdog_oe))
+		pr_info("[%s] rst-oe = 0x%x\n", KBUILD_MODNAME, watchdog_oe);
+
+	rtk_wdt->wdt.info = &rtk_wdt_info;
+	rtk_wdt->wdt.ops = &rtk_wdt_ops;
+	rtk_wdt->wdt.min_timeout = 1;
+	rtk_wdt->wdt.max_timeout = 128;
+
+	watchdog_init_timeout(&rtk_wdt->wdt, 0, &pdev->dev);
+
+	/* Set default timeout value 20s*/
+	rtk_wdt_set_timeout(&rtk_wdt->wdt, 20);
+	rtk_wdt_set_pretimeout(&rtk_wdt->wdt, 8);
+	rtk_wdt_stop(&rtk_wdt->wdt);
+
+	watchdog_set_drvdata(&rtk_wdt->wdt, rtk_wdt);
+	ret = watchdog_register_device(&rtk_wdt->wdt);
+	if (ret) {
+		dev_err(&pdev->dev, "cannot register watchdog device\n");
+		return ret;
+	}
+
+	rtk_wdt->restart_nb.notifier_call = rtk_wdt_restart;
+	ret = register_restart_handler(&rtk_wdt->restart_nb);
+	if (ret)
+		dev_err(&pdev->dev, "failed to setup restart handler\n");
+
+	rtk_wdt->iso_reset_nb.notifier_call = rtk_wdt_iso_reset_cb;
+	rtk_wdt->iso_reset_nb.priority = RTK_WATCHDOG_NMI_PRI_ISO_RESET;
+	ret = rtk_wdt_register_notifier(&rtk_wdt->iso_reset_nb);
+	if (ret)
+		dev_warn(dev, "failed to register rtk_wdt notifier: %d\n", ret);
+
+	rtk_wdt->sysrq_nb.notifier_call = rtk_wdt_sysrq_cb;
+	rtk_wdt->sysrq_nb.priority = RTK_WATCHDOG_NMI_PRI_SYSRQ;
+	ret = rtk_wdt_register_notifier(&rtk_wdt->sysrq_nb);
+	if (ret)
+		dev_warn(dev, "failed to register rtk_wdt notifier: %d\n", ret);
+
+	platform_set_drvdata(pdev, rtk_wdt);
+
+	rtk_wdt->irq = platform_get_irq(pdev, 0);
+        if (rtk_wdt->irq > 0) {
+		/* ARM does not support NMI interrupt directly so software can configure
+		 the GIC to come up a non-maskable interrupt.*/	
+		ret = devm_request_irq(&pdev->dev, rtk_wdt->irq,
+			rtk_wdt_irq, 0, pdev->name, rtk_wdt);
+		if (ret < 0){
+                        dev_err(&pdev->dev, "failed to request IRQ\n");
+		}
+		else {
+			res = platform_get_resource(pdev, IORESOURCE_MEM, 1);
+			rtk_wdt->misc_base = devm_ioremap_resource(&pdev->dev, res);
+			if (IS_ERR(rtk_wdt->misc_base))
+				return PTR_ERR(rtk_wdt->misc_base);
+		}
+		
+	}
+	else {
+        	dev_err(&pdev->dev, "no irq specified\n");
+        }
+
+	rtk_wdt_set_bootstatus(&rtk_wdt->wdt);
+	rtk_wdt_p = rtk_wdt;
+
+	pr_err("[%s] %s exit\n", KBUILD_MODNAME, __func__);
+
+	return ret;
+}
+
+static int rtk_wdt_remove(struct platform_device *pdev)
+{
+	struct rtk_wdt *wdt = platform_get_drvdata(pdev);
+
+	rtk_wdt_unregister_notifier(&wdt->sysrq_nb);
+	rtk_wdt_unregister_notifier(&wdt->iso_reset_nb);
+	unregister_restart_handler(&wdt->restart_nb);
+	watchdog_unregister_device(&wdt->wdt);
+
+	return 0;
+}
+
+static const struct of_device_id rtk_wdt_of_table[] = {
+	{ .compatible = "realtek,rtk-watchdog" },
+	{ },
+};
+MODULE_DEVICE_TABLE(of, rtk_wdt_of_table);
+
+static struct platform_driver rtk_watchdog_driver = {
+	.probe = rtk_wdt_probe,
+	.remove = rtk_wdt_remove,
+	.driver = {
+		.name = KBUILD_MODNAME,
+		.of_match_table = rtk_wdt_of_table,
+	},
+};
+module_platform_driver(rtk_watchdog_driver);
+
+MODULE_DESCRIPTION("Realtek Watchdog Driver");
+MODULE_LICENSE("GPL v2");
diff --git a/drivers/xen/Kconfig b/drivers/xen/Kconfig
index 98b8f32..2a71971 100644
--- a/drivers/xen/Kconfig
+++ b/drivers/xen/Kconfig
@@ -298,4 +298,6 @@ config XEN_SYMS
 config XEN_HAVE_VPMU
        bool
 
+source drivers/xen/xenusb/Kconfig
+
 endmenu
diff --git a/drivers/xen/Makefile b/drivers/xen/Makefile
index 8feab810..564c167 100644
--- a/drivers/xen/Makefile
+++ b/drivers/xen/Makefile
@@ -3,12 +3,15 @@ obj-$(CONFIG_X86)			+= fallback.o
 obj-y	+= grant-table.o features.o balloon.o manage.o preempt.o time.o
 obj-y	+= events/
 obj-y	+= xenbus/
+obj-y	+= xenusb/
 
 nostackp := $(call cc-option, -fno-stack-protector)
 CFLAGS_features.o			:= $(nostackp)
 
+ifndef CONFIG_LTO_CLANG
 CFLAGS_efi.o				+= -fshort-wchar
 LDFLAGS					+= $(call ld-option, --no-wchar-size-warning)
+endif
 
 dom0-$(CONFIG_ARM64) += arm-device.o
 dom0-$(CONFIG_PCI) += pci.o
diff --git a/drivers/xen/events/events_base.c b/drivers/xen/events/events_base.c
index 1435d8c..b7aa359 100644
--- a/drivers/xen/events/events_base.c
+++ b/drivers/xen/events/events_base.c
@@ -1203,6 +1203,12 @@ void evtchn_put(unsigned int evtchn)
 }
 EXPORT_SYMBOL_GPL(evtchn_put);
 
+void evtirq_put(unsigned int irq)
+{
+	unbind_from_irq(irq);
+}
+EXPORT_SYMBOL_GPL(evtirq_put);
+
 void xen_send_IPI_one(unsigned int cpu, enum ipi_vector vector)
 {
 	int irq;
diff --git a/drivers/xen/manage.c b/drivers/xen/manage.c
index 9122ba2..e9c0898 100644
--- a/drivers/xen/manage.c
+++ b/drivers/xen/manage.c
@@ -25,6 +25,14 @@
 #include <asm/xen/hypercall.h>
 #include <asm/xen/hypervisor.h>
 
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <../../kernel/power/power.h>
+#include <xen/xen-ops.h>
+#include <soc/realtek/rtk_ipc_shm.h>
+
+void rtk_domu_suspend_context_increase(void);
+#endif
+
 enum shutdown_state {
 	SHUTDOWN_INVALID = -1,
 	SHUTDOWN_POWEROFF = 0,
@@ -57,7 +65,7 @@ void xen_resume_notifier_unregister(struct notifier_block *nb)
 }
 EXPORT_SYMBOL_GPL(xen_resume_notifier_unregister);
 
-#ifdef CONFIG_HIBERNATE_CALLBACKS
+#if defined(CONFIG_HIBERNATE_CALLBACKS) || defined(CONFIG_RTK_XEN_SUPPORT)
 static int xen_suspend(void *data)
 {
 	struct suspend_info *si = data;
@@ -82,6 +90,11 @@ static int xen_suspend(void *data)
 	si->cancelled = HYPERVISOR_suspend(xen_pv_domain()
                                            ? virt_to_gfn(xen_start_info)
                                            : 0);
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	/* Always resume from same domain context */
+	si->cancelled = 1;
+	rtk_domu_suspend_context_increase();
+#endif
 
 	xen_arch_post_suspend(si->cancelled);
 	gnttab_resume();
@@ -103,6 +116,14 @@ static void do_suspend(void)
 
 	shutting_down = SHUTDOWN_SUSPEND;
 
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	err = pm_notifier_call_chain(PM_SUSPEND_PREPARE);
+	if (err) {
+		pr_err("%s: notify PM_SUSPEND_PREPARE failed %d\n", __func__, err);
+		goto out;
+	}
+#endif
+
 	err = freeze_processes();
 	if (err) {
 		pr_err("%s: freeze processes failed %d\n", __func__, err);
@@ -131,6 +152,10 @@ static void do_suspend(void)
 		goto out_resume;
 	}
 
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	rtk_xen_acpu_notify(XEN_DOMU_BOOT_ST_STATE_SCPU_SUSPEND);
+#endif
+
 	xen_arch_suspend();
 
 	si.cancelled = 1;
@@ -143,6 +168,10 @@ static void do_suspend(void)
 
 	raw_notifier_call_chain(&xen_resume_notifier, 0, NULL);
 
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	rtk_xen_acpu_notify(XEN_DOMU_BOOT_ST_STATE_SCPU_RESUME);
+#endif
+
 	dpm_resume_start(si.cancelled ? PMSG_THAW : PMSG_RESTORE);
 
 	if (err) {
@@ -163,9 +192,19 @@ static void do_suspend(void)
 out_thaw:
 	thaw_processes();
 out:
+#ifdef CONFIG_RTK_XEN_SUPPORT
+	pm_notifier_call_chain(PM_POST_SUSPEND);
+#endif
 	shutting_down = SHUTDOWN_INVALID;
 }
-#endif	/* CONFIG_HIBERNATE_CALLBACKS */
+
+int xen_suspend_to_ram(void)
+{
+	do_suspend();
+	return 0;
+}
+
+#endif	/* CONFIG_HIBERNATE_CALLBACKS || CONFIG_RTK_XEN_SUPPORT */
 
 struct shutdown_handler {
 #define SHUTDOWN_CMD_SIZE 11
@@ -212,7 +251,7 @@ static void do_reboot(void)
 	{ "poweroff",	true,	do_poweroff },
 	{ "halt",	false,	do_poweroff },
 	{ "reboot",	true,	do_reboot   },
-#ifdef CONFIG_HIBERNATE_CALLBACKS
+#if defined(CONFIG_HIBERNATE_CALLBACKS) || defined(CONFIG_RTK_XEN_SUPPORT)
 	{ "suspend",	true,	do_suspend  },
 #endif
 };
diff --git a/drivers/xen/xenusb/Kconfig b/drivers/xen/xenusb/Kconfig
new file mode 100644
index 00000000..8a56643
--- /dev/null
+++ b/drivers/xen/xenusb/Kconfig
@@ -0,0 +1,15 @@
+
+config XEN_USBHOST_FRONTEND
+	tristate "Xen USB-host irq frontend driver"
+	depends on XEN
+	default n
+	help
+	  Xen USB-host irq frontend driver
+
+config XEN_USBHOST_BACKEND
+	tristate "Xen USB-host irq backend driver"
+	depends on XEN_BACKEND
+	default n
+	help
+	  Xen USB-host irq backend driver
+
diff --git a/drivers/xen/xenusb/Makefile b/drivers/xen/xenusb/Makefile
new file mode 100644
index 00000000..b940858
--- /dev/null
+++ b/drivers/xen/xenusb/Makefile
@@ -0,0 +1,6 @@
+#
+# Makefile for Xen pvUSB drivers
+#
+
+obj-$(CONFIG_XEN_USBHOST_FRONTEND)		+= xen-usbhost-front.o
+obj-$(CONFIG_XEN_USBHOST_BACKEND)		+= xen-usbhost-back.o
diff --git a/drivers/xen/xenusb/xen-usbhost-back.c b/drivers/xen/xenusb/xen-usbhost-back.c
new file mode 100644
index 00000000..e2fb367
--- /dev/null
+++ b/drivers/xen/xenusb/xen-usbhost-back.c
@@ -0,0 +1,322 @@
+/*
+ * xen-usbback.c
+ *
+ * Xen USB backend driver.
+ *
+ */
+
+#include <linux/module.h>
+#include <linux/interrupt.h>
+#include <linux/slab.h>
+#include <linux/usb.h>
+#include <linux/wait.h>
+#include <linux/list.h>
+#include <linux/kref.h>
+#include <linux/usb/ch11.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_gpio.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+#include <xen/xen.h>
+#include <xen/balloon.h>
+#include <xen/events.h>
+#include <xen/xenbus.h>
+#include <xen/grant_table.h>
+#include <xen/page.h>
+
+extern int rtk_usb_host_gpio_power_on(void);
+extern int rtk_usb_host_gpio_power_off(void);
+extern void evtirq_put(unsigned int irq);
+
+static struct timer_list usbhost_poweron_timer;
+
+struct usbback_info {
+	domid_t domid;
+	unsigned long handle;
+	struct xenbus_device *xbdev;
+	unsigned int real_irq;
+	unsigned int irq;
+	void __iomem *base;
+};
+
+static int usbhost_poweron(void)
+{
+	rtk_usb_host_gpio_power_on();
+}
+
+static void usbhost_poweron_init_timer(void)
+{
+	init_timer(&usbhost_poweron_timer);
+	usbhost_poweron_timer.function = usbhost_poweron;
+	usbhost_poweron_timer.data = ((unsigned long) 0);
+	usbhost_poweron_timer.expires = jiffies + 5*HZ;
+	add_timer(&usbhost_poweron_timer);
+}
+
+static irqreturn_t usbback_usb_isr(int irq, void *dev_id)
+{
+        struct usbback_info *info = (struct usbback_info *)dev_id;
+
+	if (info->irq && readl(info->base+0x4)) {
+		writel((0x1 << 8) | readl(info->base+0x150), info->base+0x150); /* mask host irq */
+		notify_remote_via_irq(info->irq);
+	}
+
+        return IRQ_HANDLED;
+}
+
+static void usbback_disconnect(struct usbback_info *usbif)
+{
+	writel((0x1 << 8) | readl(usbif->base+0x150), usbif->base+0x150); /* mask host irq */
+	rtk_usb_host_gpio_power_off();
+	mdelay(1200);
+
+	return ;
+}
+
+static void usbback_free(struct usbback_info *usbif)
+{
+	kfree(usbif);
+
+	return;
+}
+
+static int usbback_remove(struct xenbus_device *dev)
+{
+	struct usbback_info *usbif = dev_get_drvdata(&dev->dev);
+
+	if (!usbif)
+		return 0;
+
+	evtirq_put(usbif->irq);
+
+	usbif->irq = 0;
+
+	free_irq(usbif->real_irq, usbif);
+
+	usbback_free(usbif);
+
+	dev_set_drvdata(&dev->dev, NULL);
+
+	return 0;
+}
+
+static struct usbback_info *usbback_alloc(domid_t domid, unsigned long handle)
+{
+	struct usbback_info *usbif;
+
+	usbif = kzalloc(sizeof(struct usbback_info), GFP_KERNEL);
+	if (!usbif)
+		return NULL;
+
+	usbif->domid = domid;
+	usbif->handle = handle;
+
+	return usbif;
+}
+
+static int rtk_dwc3_host_irq_init(struct usbback_info *usbif)
+{
+	int irq;
+        struct device_node *np = NULL;
+	int ret = 0;
+
+        np = of_find_node_by_name(NULL, "rtk_dwc3_u2host");
+        if(np == NULL) {
+                printk(KERN_ERR "get node point fail!!!!!!\n");
+		return -1;
+        } else {
+		irq = irq_of_parse_and_map(np, 0);
+		usbif->real_irq = irq;
+
+		usbif->base = of_iomap(np, 0);
+		if (!usbif->base) {
+			printk(KERN_ERR "base iomap fail.\n");
+			return -EINVAL;
+		}
+        }
+
+        if (request_irq(irq, usbback_usb_isr, IRQF_SHARED, "XEN-USB-HOST", (void *)usbif) < 0)
+        {
+                printk(KERN_ERR "unable to request irq:%d\n", irq);
+		return -1;
+        }
+
+	return ret;
+}
+
+static int usbback_probe(struct xenbus_device *dev,
+			  const struct xenbus_device_id *id)
+{
+	struct usbback_info *usbif;
+	unsigned long handle;
+	int ret;
+
+	if (usb_disabled())
+		return -ENODEV;
+
+	if (kstrtoul(strrchr(dev->otherend, '/') + 1, 0, &handle))
+		return -EINVAL;
+
+	usbif = usbback_alloc(dev->otherend_id, handle);
+	if (!usbif) {
+		xenbus_dev_fatal(dev, -ENOMEM, "allocating backend interface");
+		return -ENOMEM;
+	}
+
+	ret = rtk_dwc3_host_irq_init(usbif);
+	if (ret)
+		goto fail;
+
+	usbif->xbdev = dev;
+	dev_set_drvdata(&dev->dev, usbif);
+	
+	ret = xenbus_switch_state(dev, XenbusStateConnected);
+	if (ret)
+		goto fail;
+
+	return 0;
+fail:
+	usbback_remove(dev);
+	return ret;
+}
+
+static int usbback_map(struct usbback_info *usbif,
+		      evtchn_port_t evtchn)
+{
+	int err;
+
+	if (usbif->irq)
+		return 0;
+
+	err = bind_interdomain_evtchn_to_irq(usbif->domid, evtchn);
+	if (err < 0)
+		goto fail_evtchn;
+
+	usbif->irq = err;
+
+	return 0;
+
+fail_evtchn:
+	unbind_from_irqhandler(usbif->irq, usbif);
+	usbif->irq = 0;
+
+	return err;
+}
+
+static int usbback_connect_rings(struct usbback_info *usbif)
+{
+	struct xenbus_device *dev = usbif->xbdev;
+	evtchn_port_t evtchn;
+	int err;
+
+	err = xenbus_gather(XBT_NIL, dev->otherend, "event-channel", "%u", &evtchn, NULL);
+	if (err) {
+		xenbus_dev_fatal(dev, err,
+				 "reading %s/ring-ref and event-channel",
+				 dev->otherend);
+		return err;
+	}
+	pr_info("xen-pvusb: event-channel %u\n", evtchn);
+
+	err = usbback_map(usbif, evtchn);
+	if (err)
+		xenbus_dev_fatal(dev, err, "mapping evtchn %u", evtchn);
+
+	writel((readl(usbif->base+0x150) & 0xFFFFFEFF), usbif->base+0x150); /* unmask host irq */
+
+	usbhost_poweron_init_timer();
+
+	return err;
+}
+
+static void usbback_frontend_changed(struct xenbus_device *dev,
+				     enum xenbus_state frontend_state)
+{
+	struct usbback_info *usbif = dev_get_drvdata(&dev->dev);
+
+	switch (frontend_state) {
+	case XenbusStateInitialised:
+	case XenbusStateReconfiguring:
+	case XenbusStateReconfigured:
+		break;
+
+	case XenbusStateInitialising:
+		if (dev->state == XenbusStateClosed) {
+			pr_info("xen-pvusb: %s: prepare for reconnect\n",
+				dev->nodename);
+			xenbus_switch_state(dev, XenbusStateInitWait);
+		}
+		break;
+
+	case XenbusStateConnected:
+		if (dev->state != XenbusStateConnected)
+			xenbus_switch_state(dev, XenbusStateConnected);
+
+		if (usbback_connect_rings(usbif))
+			break;
+
+		break;
+
+	case XenbusStateClosing:
+		usbback_disconnect(usbif);
+		xenbus_switch_state(dev, XenbusStateClosing);
+		break;
+
+	case XenbusStateClosed:
+		xenbus_switch_state(dev, XenbusStateClosed);
+		if (xenbus_dev_is_online(dev))
+			break;
+		/* fall through if not online */
+	case XenbusStateUnknown:
+		device_unregister(&dev->dev);
+		break;
+
+	default:
+		xenbus_dev_fatal(dev, -EINVAL, "saw state %d at frontend",
+				 frontend_state);
+		break;
+	}
+}
+
+static const struct xenbus_device_id usbback_ids[] = {
+	{ "vusbhost" },
+	{ "" },
+};
+
+static struct xenbus_driver usbback_driver = {
+	.ids			= usbback_ids,
+	.probe			= usbback_probe,
+	.otherend_changed	= usbback_frontend_changed,
+	.remove			= usbback_remove,
+};
+
+static int __init usbback_init(void)
+{
+	int err;
+
+	if (!xen_domain())
+		return -ENODEV;
+
+	err = xenbus_register_backend(&usbback_driver);
+	if (err)
+		goto out_mem;
+
+	return 0;
+
+out_mem:
+	return err;
+}
+module_init(usbback_init);
+
+static void __exit usbback_exit(void)
+{
+	xenbus_unregister_driver(&usbback_driver);
+}
+module_exit(usbback_exit);
+
+MODULE_ALIAS("xen-backend:usb-host-irq");
+MODULE_AUTHOR("Realtek");
+MODULE_DESCRIPTION("Xen USB HOST IRQ backend driver (usbback)");
+MODULE_LICENSE("Dual BSD/GPL");
diff --git a/drivers/xen/xenusb/xen-usbhost-front.c b/drivers/xen/xenusb/xen-usbhost-front.c
new file mode 100644
index 00000000..555bc8f
--- /dev/null
+++ b/drivers/xen/xenusb/xen-usbhost-front.c
@@ -0,0 +1,456 @@
+/*
+ * xen-usbfront.c
+ *
+ * Xen USB Virtual Host Controller driver
+ *
+ */
+
+#include <linux/module.h>
+#include <linux/usb.h>
+#include <linux/list.h>
+#include <linux/usb/hcd.h>
+#include <linux/io.h>
+#include <xen/xen.h>
+#include <xen/xenbus.h>
+#include <xen/grant_table.h>
+#include <xen/events.h>
+#include <xen/page.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_gpio.h>
+#include <linux/of_platform.h>
+#include <linux/of_irq.h>
+
+#define DEVICETREE_NODENAME	"rtk_dwc3_u2host"
+
+#ifdef CONFIG_PM
+int port1_pow_gpio = -1;
+int port2_pow_gpio = -1;
+bool power_low_active;
+#endif
+
+struct usbfront_info {
+	struct xenbus_device *xbdev;
+	evtchn_port_t evtchn;
+	int irq;
+};
+
+int rtk_xen_usb_host_irq = 0;
+EXPORT_SYMBOL(rtk_xen_usb_host_irq);
+
+static void __iomem *host_regs = NULL;
+void rtk_hostirq_unmask(void)
+{
+        if(host_regs) {
+                writel((readl(host_regs+0x150) & 0xFFFFFEFF), host_regs+0x150);
+        }
+}
+EXPORT_SYMBOL(rtk_hostirq_unmask);
+
+static void *xenusb_unflatten_dt_alloc(void **mem, unsigned long size,
+                                       unsigned long align)
+{
+        void *res;
+
+        *mem = PTR_ALIGN(*mem, align);
+        res = *mem;
+        *mem += size;
+
+        return res;
+}
+
+static struct property * create_new_property(char* name, void *value, int value_len)
+{
+        struct property *new_prop;
+        void *mem;
+        int malloc_size = 0;
+
+        malloc_size = strlen(name)+1;
+        malloc_size += value_len;
+        malloc_size += sizeof(struct property);
+
+        mem = kzalloc(malloc_size + 4, GFP_KERNEL);
+        memset(mem, 0, malloc_size + 4);
+        new_prop = xenusb_unflatten_dt_alloc(&mem, sizeof(struct property),
+                                        __alignof__(struct property));
+        new_prop->value = xenusb_unflatten_dt_alloc(&mem, value_len, 1);
+        new_prop->name = (char*)xenusb_unflatten_dt_alloc(&mem, strlen(name)+1, 1);
+
+        memcpy(new_prop->value, value, value_len);
+        new_prop->length = value_len;
+        strcpy(new_prop->name, name);
+
+        return new_prop;
+}
+
+static void usbfront_destroy_rings(struct usbfront_info *info)
+{
+	if (info->irq) {
+		info->irq = 0;
+	}
+}
+
+static int usbfront_setup_rings(struct xenbus_device *dev,
+				struct usbfront_info *info)
+{
+	int err;
+	struct device_node *np;
+        struct property *prop;
+        const char *str;
+        const char *str2;
+
+	err = xenbus_alloc_evtchn(dev, &info->evtchn);
+	if (err) {
+		xenbus_dev_fatal(dev, err, "xenbus_alloc_evtchn");
+		goto fail;
+	}
+
+	err = bind_evtchn_to_irq(info->evtchn);
+	if (err <= 0) {
+		xenbus_dev_fatal(dev, err, "bind_evtchn_to_irq");
+		goto fail;
+	}
+
+	info->irq = err;
+
+	rtk_xen_usb_host_irq = info->irq;
+
+	np = of_find_node_by_name(NULL, DEVICETREE_NODENAME);
+        if(np != NULL) {
+                of_property_read_string(np, "status", &str);
+                prop = create_new_property("status", "okay", sizeof("okay"));
+                of_update_property(np, prop);
+		of_property_read_string(np, "status", &str2);
+
+                err = of_platform_populate(np, NULL, NULL, NULL);
+                if (err) {
+                        printk(KERN_ERR "%s() failed to add dwc3 core.\n", __func__);
+                }
+        }	
+
+	return 0;
+
+fail:
+	usbfront_destroy_rings(info);
+
+	return err;
+}
+
+static int usbfront_talk_to_backend(struct xenbus_device *dev,
+				    struct usbfront_info *info)
+{
+	const char *message;
+	struct xenbus_transaction xbt;
+	int err;
+
+	err = usbfront_setup_rings(dev, info);
+	if (err)
+		return err;
+
+again:
+	err = xenbus_transaction_start(&xbt);
+	if (err) {
+		xenbus_dev_fatal(dev, err, "starting transaction");
+		goto destroy_ring;
+	}
+
+	err = xenbus_printf(xbt, dev->nodename, "event-channel", "%u",
+			    info->evtchn);
+	if (err) {
+		message = "writing event-channel";
+		goto abort_transaction;
+	}
+
+	err = xenbus_transaction_end(xbt, 0);
+	if (err) {
+		if (err == -EAGAIN)
+			goto again;
+		xenbus_dev_fatal(dev, err, "completing transaction");
+		goto destroy_ring;
+	}
+
+	return 0;
+
+abort_transaction:
+	xenbus_transaction_end(xbt, 1);
+	xenbus_dev_fatal(dev, err, "%s", message);
+
+destroy_ring:
+	usbfront_destroy_rings(info);
+
+	return err;
+}
+
+static int usbfront_connect(struct xenbus_device *dev)
+{
+	struct usbfront_info *info = dev_get_drvdata(&dev->dev);
+	int err;
+
+	err = usbfront_talk_to_backend(dev, info);
+	if (err)
+		return err;
+
+	return 0;
+}
+
+static void usbfront_disconnect(struct xenbus_device *dev)
+{
+	struct usbfront_info *info = dev_get_drvdata(&dev->dev);
+
+	if (info->irq) {
+		evtchn_put(info->evtchn);
+		info->irq = 0;
+	}
+
+	if (info->evtchn) {
+		xenbus_free_evtchn(dev, info->evtchn);
+		info->evtchn = 0;
+	}
+
+	xenbus_frontend_closed(dev);
+}
+
+static void usbfront_backend_changed(struct xenbus_device *dev,
+			    enum xenbus_state backend_state)
+{
+	switch (backend_state) {
+	case XenbusStateInitialising:
+	case XenbusStateReconfiguring:
+	case XenbusStateReconfigured:
+	case XenbusStateUnknown:
+		break;
+
+	case XenbusStateInitWait:
+	case XenbusStateInitialised:
+	case XenbusStateConnected:
+		if (dev->state != XenbusStateInitialising)
+			break;
+		if (!usbfront_connect(dev))
+			xenbus_switch_state(dev, XenbusStateConnected);
+		break;
+
+	case XenbusStateClosed:
+		if (dev->state == XenbusStateClosed)
+			break;
+		/* Missed the backend's Closing state -- fallthrough */
+	case XenbusStateClosing:
+		usbfront_disconnect(dev);
+		break;
+
+	default:
+		xenbus_dev_fatal(dev, -EINVAL, "saw state %d at frontend",
+				 backend_state);
+		break;
+	}
+}
+
+static int usbfront_remove(struct xenbus_device *dev)
+{
+	struct usbfront_info *info = dev_get_drvdata(&dev->dev);
+
+	usbfront_destroy_rings(info);
+
+        kfree(info);
+
+        dev_set_drvdata(&dev->dev, NULL);
+
+	return 0;
+}
+
+static struct usbfront_info *usbfront_alloc(domid_t domid)
+{
+        struct usbfront_info *info;
+
+        info = kzalloc(sizeof(struct usbfront_info), GFP_KERNEL);
+        if (!info)
+                return NULL;
+
+        return info;
+}
+
+static int usbfront_probe(struct xenbus_device *dev,
+			  const struct xenbus_device_id *id)
+{
+	struct usbfront_info *info;
+
+	if (usb_disabled())
+		return -ENODEV;
+
+	info = usbfront_alloc(dev->otherend_id);
+        if (!info) {
+                xenbus_dev_fatal(dev, -ENOMEM, "allocating frontend interface");
+                return -ENOMEM;
+        }
+
+	dev->dev.driver_data = info;
+
+	dev_set_drvdata(&dev->dev, info);
+
+	host_regs = ioremap(0x98013C00, 0x200);
+	
+	return 0;
+}
+
+static const struct xenbus_device_id usbfront_ids[] = {
+	{ "vusbhost" },
+	{ "" },
+};
+
+static struct xenbus_driver usbfront_driver = {
+	.ids			= usbfront_ids,
+	.probe			= usbfront_probe,
+	.otherend_changed	= usbfront_backend_changed,
+	.remove			= usbfront_remove,
+};
+
+static int rtk_usbhost_frontend_probe(struct platform_device *pdev)
+{
+        struct device_node *np;
+
+        np = of_find_node_by_name(NULL, "rtk_usb_power_manager");
+        if(np == NULL) {
+                printk(KERN_ERR "get usb-manager node point fail!!!!!!\n");
+        } else {
+		port1_pow_gpio = of_get_named_gpio(np, "realtek,port1-power-gpio", 0);
+		if (gpio_is_valid(port1_pow_gpio)) {
+			printk(KERN_INFO "%s get port1-power-gpio (id=%d) OK\n", __func__, port1_pow_gpio);
+		} else {
+			printk(KERN_INFO "port1-power-gpio no found\n");
+		}
+
+		port2_pow_gpio = of_get_named_gpio(np, "realtek,port2-power-gpio", 0);
+		if (gpio_is_valid(port2_pow_gpio)) {
+			printk(KERN_INFO "%s get port2-power-gpio (id=%d) OK\n", __func__, port2_pow_gpio);
+		} else {
+			printk(KERN_INFO "port2-power-gpio no found\n");
+		}
+
+		if (of_property_read_bool(np, "power_low_active"))
+			power_low_active = true;
+		else
+			power_low_active = false;
+	}
+
+	if (!xen_domain())
+		return -ENODEV;
+
+	return xenbus_register_frontend(&usbfront_driver);
+}
+
+static int rtk_usbhost_frontend_remove(struct platform_device *pdev)
+{
+	xenbus_unregister_driver(&usbfront_driver);
+
+	return 0;
+}
+
+static struct platform_device rtk_usbhost_frontend_device = {
+	.name = "rtk-usbhost-frontend",
+};
+
+#ifdef CONFIG_PM
+static void rtk_usbport_power_on_off(bool on)
+{
+	if (gpio_is_valid(port1_pow_gpio)) {
+                if (gpio_request(port1_pow_gpio, "port1_pow_gpio"))
+                        printk(KERN_ERR "%s ERROR Request port1_pow_gpio (id=%d) fail\n", __func__, port1_pow_gpio);
+                else if (port1_pow_gpio != -1) {
+                        if (gpio_direction_output(port1_pow_gpio, power_low_active?!on:on)) {
+                                printk(KERN_INFO "%s ERROR port1 power %s fail\n", __func__, on?"on":"off");
+                        } else {
+                                printk(KERN_INFO "%s to set port1 power %s by gpio (id=%d) OK\n", __func__, on?"on":"off", port1_pow_gpio);
+                        }
+                        gpio_free(port1_pow_gpio);
+                }
+        }
+
+	if (gpio_is_valid(port2_pow_gpio)) {
+                if (gpio_request(port2_pow_gpio, "port2_pow_gpio"))
+                        printk(KERN_ERR "%s ERROR Request port1_pow_gpio (id=%d) fail\n", __func__, port2_pow_gpio);
+                else if (port2_pow_gpio != -1) {
+                        if (gpio_direction_output(port2_pow_gpio, power_low_active?!on:on)) {
+                                printk(KERN_INFO "%s ERROR port2 power %s fail\n", __func__, on?"on":"off");
+                        } else {
+                                printk(KERN_INFO "%s to set port2 power %s by gpio (id=%d) OK\n", __func__, on?"on":"off", port2_pow_gpio);
+                        }
+                        gpio_free(port2_pow_gpio);
+                }
+        }
+
+	return;
+}
+
+static int rtk_usbhost_frontend_pm_suspend(struct device *dev)
+{
+	int ret = 0;
+
+	rtk_usbport_power_on_off(false);
+
+	return ret;
+}
+
+static int rtk_usbhost_frontend_pm_resume(struct device *dev)
+{
+	int ret = 0;
+
+	rtk_usbport_power_on_off(true);
+
+	return ret;
+}
+
+static const struct dev_pm_ops rtk_usbhost_frontend_pm_ops = {
+        SET_SYSTEM_SLEEP_PM_OPS(rtk_usbhost_frontend_pm_suspend, rtk_usbhost_frontend_pm_resume)
+};
+#endif
+
+static struct platform_driver rtk_usbhost_frontend_driver = {
+	.driver = {
+		.name  = "rtk-usbhost-frontend",
+		.owner = THIS_MODULE,
+#ifdef CONFIG_PM
+                .pm = &rtk_usbhost_frontend_pm_ops,
+#endif
+
+	},
+        .probe = rtk_usbhost_frontend_probe,
+        .remove = rtk_usbhost_frontend_remove,
+};
+
+static int __init usbfront_init(void)
+{
+	int err;
+
+	err = platform_device_register(&rtk_usbhost_frontend_device);
+	if (err) {
+		printk(KERN_ERR "%s(#%d): platform_device_register failed(%d)\n", __func__, __LINE__, err);
+		return err;
+	}
+
+	err = platform_driver_register(&rtk_usbhost_frontend_driver);
+	if (err) {
+		printk(KERN_ERR "%s(#%d): platform_driver_register fail(%d)\n", __func__, __LINE__, err);
+		goto dev_reg_fail;
+	}
+
+	return err;
+
+dev_reg_fail:
+	platform_device_unregister(&rtk_usbhost_frontend_device);
+
+	return err;
+}
+module_init(usbfront_init);
+
+static void __exit usbfront_exit(void)
+{
+	platform_device_unregister(&rtk_usbhost_frontend_device);
+	platform_driver_unregister(&rtk_usbhost_frontend_driver);
+}
+module_exit(usbfront_exit);
+
+
+MODULE_ALIAS("xen-frontend:usb-host-irq");
+MODULE_AUTHOR("Realtek");
+MODULE_DESCRIPTION("Xen USB HOST IRQ frontend driver (usbfront)");
+MODULE_LICENSE("Dual BSD/GPL");
+
diff --git a/fs/Kconfig b/fs/Kconfig
index 4bd03a2..77413fa 100644
--- a/fs/Kconfig
+++ b/fs/Kconfig
@@ -227,11 +227,13 @@ source "fs/orangefs/Kconfig"
 source "fs/adfs/Kconfig"
 source "fs/affs/Kconfig"
 source "fs/ecryptfs/Kconfig"
+source "fs/sdcardfs/Kconfig"
 source "fs/hfs/Kconfig"
 source "fs/hfsplus/Kconfig"
 source "fs/befs/Kconfig"
 source "fs/bfs/Kconfig"
 source "fs/efs/Kconfig"
+source "fs/yaffs2/Kconfig"
 source "fs/jffs2/Kconfig"
 # UBIFS File system configuration
 source "fs/ubifs/Kconfig"
diff --git a/fs/Makefile b/fs/Makefile
index ed2b632..f19de74 100644
--- a/fs/Makefile
+++ b/fs/Makefile
@@ -3,7 +3,7 @@
 #
 # 14 Sep 2000, Christoph Hellwig <hch@infradead.org>
 # Rewritten to use lists instead of if-statements.
-# 
+#
 
 obj-y :=	open.o read_write.o file_table.o super.o \
 		char_dev.o stat.o exec.o pipe.o namei.o fcntl.o \
@@ -61,7 +61,7 @@ obj-y				+= devpts/
 
 obj-$(CONFIG_PROFILING)		+= dcookies.o
 obj-$(CONFIG_DLM)		+= dlm/
- 
+
 # Do not add any filesystems before this line
 obj-$(CONFIG_FSCACHE)		+= fscache/
 obj-$(CONFIG_REISERFS_FS)	+= reiserfs/
@@ -83,6 +83,7 @@ obj-$(CONFIG_ISO9660_FS)	+= isofs/
 obj-$(CONFIG_HFSPLUS_FS)	+= hfsplus/ # Before hfs to find wrapped HFS+
 obj-$(CONFIG_HFS_FS)		+= hfs/
 obj-$(CONFIG_ECRYPT_FS)		+= ecryptfs/
+obj-$(CONFIG_SDCARD_FS)		+= sdcardfs/
 obj-$(CONFIG_VXFS_FS)		+= freevxfs/
 obj-$(CONFIG_NFS_FS)		+= nfs/
 obj-$(CONFIG_EXPORTFS)		+= exportfs/
@@ -129,3 +130,4 @@ obj-y				+= exofs/ # Multiple modules
 obj-$(CONFIG_CEPH_FS)		+= ceph/
 obj-$(CONFIG_PSTORE)		+= pstore/
 obj-$(CONFIG_EFIVAR_FS)		+= efivarfs/
+obj-$(CONFIG_YAFFS_FS)		+= yaffs2/
diff --git a/fs/afs/file.c b/fs/afs/file.c
index 7237297..37f97ba 100644
--- a/fs/afs/file.c
+++ b/fs/afs/file.c
@@ -123,11 +123,10 @@ static void afs_file_readpage_read_complete(struct page *page,
 /*
  * read page from file, directory or symlink, given a key to use
  */
-int afs_page_filler(void *data, struct page *page)
+static int __afs_page_filler(struct key *key, struct page *page)
 {
 	struct inode *inode = page->mapping->host;
 	struct afs_vnode *vnode = AFS_FS_I(inode);
-	struct key *key = data;
 	size_t len;
 	off_t offset;
 	int ret;
@@ -209,6 +208,13 @@ int afs_page_filler(void *data, struct page *page)
 	return ret;
 }
 
+int afs_page_filler(struct file *data, struct page *page)
+{
+	struct key *key = (struct key *)data;
+
+	return __afs_page_filler(key, page);
+}
+
 /*
  * read page from file, directory or symlink, given a file to nominate the key
  * to be used
@@ -221,14 +227,14 @@ static int afs_readpage(struct file *file, struct page *page)
 	if (file) {
 		key = file->private_data;
 		ASSERT(key != NULL);
-		ret = afs_page_filler(key, page);
+		ret = __afs_page_filler(key, page);
 	} else {
 		struct inode *inode = page->mapping->host;
 		key = afs_request_key(AFS_FS_S(inode->i_sb)->volume->cell);
 		if (IS_ERR(key)) {
 			ret = PTR_ERR(key);
 		} else {
-			ret = afs_page_filler(key, page);
+			ret = __afs_page_filler(key, page);
 			key_put(key);
 		}
 	}
diff --git a/fs/afs/internal.h b/fs/afs/internal.h
index dd98dcd..b4165cc 100644
--- a/fs/afs/internal.h
+++ b/fs/afs/internal.h
@@ -497,7 +497,7 @@ extern void afs_break_callbacks(struct afs_server *, size_t,
 
 extern int afs_open(struct inode *, struct file *);
 extern int afs_release(struct inode *, struct file *);
-extern int afs_page_filler(void *, struct page *);
+extern int afs_page_filler(struct file *, struct page *);
 
 /*
  * flock.c
diff --git a/fs/attr.c b/fs/attr.c
index c902b3d..c4093c5 100644
--- a/fs/attr.c
+++ b/fs/attr.c
@@ -200,7 +200,7 @@ void setattr_copy(struct inode *inode, const struct iattr *attr)
  * the file open for write, as there can be no conflicting delegation in
  * that case.
  */
-int notify_change(struct dentry * dentry, struct iattr * attr, struct inode **delegated_inode)
+int notify_change2(struct vfsmount *mnt, struct dentry * dentry, struct iattr * attr, struct inode **delegated_inode)
 {
 	struct inode *inode = dentry->d_inode;
 	umode_t mode = inode->i_mode;
@@ -224,7 +224,7 @@ int notify_change(struct dentry * dentry, struct iattr * attr, struct inode **de
 			return -EPERM;
 
 		if (!inode_owner_or_capable(inode)) {
-			error = inode_permission(inode, MAY_WRITE);
+			error = inode_permission2(mnt, inode, MAY_WRITE);
 			if (error)
 				return error;
 		}
@@ -307,7 +307,9 @@ int notify_change(struct dentry * dentry, struct iattr * attr, struct inode **de
 	if (error)
 		return error;
 
-	if (inode->i_op->setattr)
+	if (mnt && inode->i_op->setattr2)
+		error = inode->i_op->setattr2(mnt, dentry, attr);
+	else if (inode->i_op->setattr)
 		error = inode->i_op->setattr(dentry, attr);
 	else
 		error = simple_setattr(dentry, attr);
@@ -320,4 +322,10 @@ int notify_change(struct dentry * dentry, struct iattr * attr, struct inode **de
 
 	return error;
 }
+EXPORT_SYMBOL(notify_change2);
+
+int notify_change(struct dentry * dentry, struct iattr * attr, struct inode **delegated_inode)
+{
+	return notify_change2(NULL, dentry, attr, delegated_inode);
+}
 EXPORT_SYMBOL(notify_change);
diff --git a/fs/block_dev.c b/fs/block_dev.c
index cb936c9..c46d0dd 100644
--- a/fs/block_dev.c
+++ b/fs/block_dev.c
@@ -307,6 +307,41 @@ int thaw_bdev(struct block_device *bdev, struct super_block *sb)
 }
 EXPORT_SYMBOL(thaw_bdev);
 
+int thaw_bdev_force(struct block_device *bdev, struct super_block *sb)
+{
+	int error = 0;
+	int bak_cnt = bdev->bd_fsfreeze_count;
+	char b[BDEVNAME_SIZE];
+
+	mutex_lock(&bdev->bd_fsfreeze_mutex);
+	if (!bdev->bd_fsfreeze_count)
+		goto out;
+
+	if (bdev->bd_fsfreeze_count > 0) {
+		printk(KERN_WARNING "Force reset %s bd_fsfreeze_count to 0\n",
+			bdevname(bdev, b));
+		bdev->bd_fsfreeze_count = 0;
+	}
+
+	if (!sb)
+		goto out;
+
+        if (sb->s_op->thaw_super)
+                error = sb->s_op->thaw_super(sb);
+        else
+                error = thaw_super(sb);
+        if (error) {
+                bdev->bd_fsfreeze_count = bak_cnt;
+                mutex_unlock(&bdev->bd_fsfreeze_mutex);
+                return error;
+        }
+
+out:
+	mutex_unlock(&bdev->bd_fsfreeze_mutex);
+	return error;
+}
+EXPORT_SYMBOL(thaw_bdev_force);
+
 static int blkdev_writepage(struct page *page, struct writeback_control *wbc)
 {
 	return block_write_full_page(page, blkdev_get_block, wbc);
diff --git a/fs/btrfs/extent_io.c b/fs/btrfs/extent_io.c
index 2b96ca6..a1615e8 100644
--- a/fs/btrfs/extent_io.c
+++ b/fs/btrfs/extent_io.c
@@ -3830,8 +3830,8 @@ int btree_write_cache_pages(struct address_space *mapping,
 	if (wbc->sync_mode == WB_SYNC_ALL)
 		tag_pages_for_writeback(mapping, index, end);
 	while (!done && !nr_to_write_done && (index <= end) &&
-	       (nr_pages = pagevec_lookup_tag(&pvec, mapping, &index, tag,
-			min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1))) {
+	       (nr_pages = pagevec_lookup_range_tag(&pvec, mapping, &index, end,
+			tag))) {
 		unsigned i;
 
 		scanned = 1;
@@ -3841,11 +3841,6 @@ int btree_write_cache_pages(struct address_space *mapping,
 			if (!PagePrivate(page))
 				continue;
 
-			if (!wbc->range_cyclic && page->index > end) {
-				done = 1;
-				break;
-			}
-
 			spin_lock(&mapping->private_lock);
 			if (!PagePrivate(page)) {
 				spin_unlock(&mapping->private_lock);
@@ -3978,8 +3973,8 @@ static int extent_write_cache_pages(struct extent_io_tree *tree,
 		tag_pages_for_writeback(mapping, index, end);
 	done_index = index;
 	while (!done && !nr_to_write_done && (index <= end) &&
-	       (nr_pages = pagevec_lookup_tag(&pvec, mapping, &index, tag,
-			min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1))) {
+			(nr_pages = pagevec_lookup_range_tag(&pvec, mapping,
+						&index, end, tag))) {
 		unsigned i;
 
 		scanned = 1;
@@ -4004,12 +3999,6 @@ static int extent_write_cache_pages(struct extent_io_tree *tree,
 				continue;
 			}
 
-			if (!wbc->range_cyclic && page->index > end) {
-				done = 1;
-				unlock_page(page);
-				continue;
-			}
-
 			if (wbc->sync_mode != WB_SYNC_NONE) {
 				if (PageWriteback(page))
 					flush_fn(data);
diff --git a/fs/buffer.c b/fs/buffer.c
index 5d8f496..950317d 100644
--- a/fs/buffer.c
+++ b/fs/buffer.c
@@ -527,8 +527,11 @@ static int osync_buffers_list(spinlock_t *lock, struct list_head *list)
 
 static void do_thaw_one(struct super_block *sb, void *unused)
 {
-	while (sb->s_bdev && !thaw_bdev(sb->s_bdev, sb))
-		printk(KERN_WARNING "Emergency Thaw on %pg\n", sb->s_bdev);
+	char b[BDEVNAME_SIZE];
+
+	while (sb->s_bdev && thaw_bdev_force(sb->s_bdev, sb))
+		printk(KERN_WARNING "Emergency Thaw on %s\n",
+		       bdevname(sb->s_bdev, b));
 }
 
 static void do_thaw_all(struct work_struct *work)
@@ -547,6 +550,8 @@ void emergency_thaw_all(void)
 {
 	struct work_struct *work;
 
+	printk("%s\n", __func__);
+	dump_stack();
 	work = kmalloc(sizeof(*work), GFP_ATOMIC);
 	if (work) {
 		INIT_WORK(work, do_thaw_all);
diff --git a/fs/ceph/addr.c b/fs/ceph/addr.c
index 7b79a54..546d643 100644
--- a/fs/ceph/addr.c
+++ b/fs/ceph/addr.c
@@ -838,21 +838,15 @@ static int ceph_writepages_start(struct address_space *mapping,
 		struct page **pages = NULL, **data_pages;
 		mempool_t *pool = NULL;	/* Becomes non-null if mempool used */
 		struct page *page;
-		int want;
 		u64 offset = 0, len = 0;
 
 		max_pages = max_pages_ever;
 
 get_more_pages:
 		first = -1;
-		want = min(end - index,
-			   min((pgoff_t)PAGEVEC_SIZE,
-			       max_pages - (pgoff_t)locked_pages) - 1)
-			+ 1;
-		pvec_pages = pagevec_lookup_tag(&pvec, mapping, &index,
-						PAGECACHE_TAG_DIRTY,
-						want);
-		dout("pagevec_lookup_tag got %d\n", pvec_pages);
+		pvec_pages = pagevec_lookup_range_tag(&pvec, mapping, &index,
+						end, PAGECACHE_TAG_DIRTY);
+		dout("pagevec_lookup_range_tag got %d\n", pvec_pages);
 		if (!pvec_pages && !locked_pages)
 			break;
 		for (i = 0; i < pvec_pages && locked_pages < max_pages; i++) {
@@ -870,12 +864,6 @@ static int ceph_writepages_start(struct address_space *mapping,
 				unlock_page(page);
 				break;
 			}
-			if (!wbc->range_cyclic && page->index > end) {
-				dout("end of range %p\n", page);
-				done = 1;
-				unlock_page(page);
-				break;
-			}
 			if (strip_unit_end && (page->index > strip_unit_end)) {
 				dout("end of strip unit %p\n", page);
 				unlock_page(page);
diff --git a/fs/cifs/connect.c b/fs/cifs/connect.c
index 441d434..c4a27f6 100644
--- a/fs/cifs/connect.c
+++ b/fs/cifs/connect.c
@@ -2439,7 +2439,7 @@ static int match_session(struct cifs_ses *ses, struct smb_vol *vol)
 	}
 
 	down_read(&key->sem);
-	upayload = user_key_payload(key);
+	upayload = user_key_payload_locked(key);
 	if (IS_ERR_OR_NULL(upayload)) {
 		rc = upayload ? PTR_ERR(upayload) : -EINVAL;
 		goto out_key_put;
diff --git a/fs/coredump.c b/fs/coredump.c
index 4407e27..00a900a 100644
--- a/fs/coredump.c
+++ b/fs/coredump.c
@@ -744,7 +744,7 @@ void do_coredump(const siginfo_t *siginfo)
 			goto close_fail;
 		if (!(cprm.file->f_mode & FMODE_CAN_WRITE))
 			goto close_fail;
-		if (do_truncate(cprm.file->f_path.dentry, 0, 0, cprm.file))
+		if (do_truncate2(cprm.file->f_path.mnt, cprm.file->f_path.dentry, 0, 0, cprm.file))
 			goto close_fail;
 	}
 
diff --git a/fs/crypto/Kconfig b/fs/crypto/Kconfig
index 92348fa..08b46e6 100644
--- a/fs/crypto/Kconfig
+++ b/fs/crypto/Kconfig
@@ -1,6 +1,5 @@
 config FS_ENCRYPTION
 	tristate "FS Encryption (Per-file encryption)"
-	depends on BLOCK
 	select CRYPTO
 	select CRYPTO_AES
 	select CRYPTO_CBC
@@ -8,9 +7,7 @@ config FS_ENCRYPTION
 	select CRYPTO_XTS
 	select CRYPTO_CTS
 	select CRYPTO_CTR
-	select CRYPTO_SHA256
 	select KEYS
-	select ENCRYPTED_KEYS
 	help
 	  Enable encryption of files and directories.  This
 	  feature is similar to ecryptfs, but it is more memory
diff --git a/fs/crypto/Makefile b/fs/crypto/Makefile
index f17684c..cb49698 100644
--- a/fs/crypto/Makefile
+++ b/fs/crypto/Makefile
@@ -1,3 +1,4 @@
 obj-$(CONFIG_FS_ENCRYPTION)	+= fscrypto.o
 
-fscrypto-y := crypto.o fname.o policy.o keyinfo.o
+fscrypto-y := crypto.o fname.o hooks.o keyinfo.o policy.o
+fscrypto-$(CONFIG_BLOCK) += bio.o
diff --git a/fs/crypto/bio.c b/fs/crypto/bio.c
new file mode 100644
index 00000000..d7b4c48
--- /dev/null
+++ b/fs/crypto/bio.c
@@ -0,0 +1,154 @@
+/*
+ * This contains encryption functions for per-file encryption.
+ *
+ * Copyright (C) 2015, Google, Inc.
+ * Copyright (C) 2015, Motorola Mobility
+ *
+ * Written by Michael Halcrow, 2014.
+ *
+ * Filename encryption additions
+ *	Uday Savagaonkar, 2014
+ * Encryption policy handling additions
+ *	Ildar Muslukhov, 2014
+ * Add fscrypt_pullback_bio_page()
+ *	Jaegeuk Kim, 2015.
+ *
+ * This has not yet undergone a rigorous security audit.
+ *
+ * The usage of AES-XTS should conform to recommendations in NIST
+ * Special Publication 800-38E and IEEE P1619/D16.
+ */
+
+#include <linux/pagemap.h>
+#include <linux/module.h>
+#include <linux/bio.h>
+#include <linux/namei.h>
+#include "fscrypt_private.h"
+
+static void __fscrypt_decrypt_bio(struct bio *bio, bool done)
+{
+	struct bio_vec *bv;
+	int i;
+
+	bio_for_each_segment_all(bv, bio, i) {
+		struct page *page = bv->bv_page;
+		int ret = fscrypt_decrypt_page(page->mapping->host, page,
+				PAGE_SIZE, 0, page->index);
+
+		if (ret) {
+			WARN_ON_ONCE(1);
+			SetPageError(page);
+		} else if (done) {
+			SetPageUptodate(page);
+		}
+		if (done)
+			unlock_page(page);
+	}
+}
+
+void fscrypt_decrypt_bio(struct bio *bio)
+{
+	__fscrypt_decrypt_bio(bio, false);
+}
+EXPORT_SYMBOL(fscrypt_decrypt_bio);
+
+static void completion_pages(struct work_struct *work)
+{
+	struct fscrypt_ctx *ctx =
+		container_of(work, struct fscrypt_ctx, r.work);
+	struct bio *bio = ctx->r.bio;
+
+	__fscrypt_decrypt_bio(bio, true);
+	fscrypt_release_ctx(ctx);
+	bio_put(bio);
+}
+
+void fscrypt_enqueue_decrypt_bio(struct fscrypt_ctx *ctx, struct bio *bio)
+{
+	INIT_WORK(&ctx->r.work, completion_pages);
+	ctx->r.bio = bio;
+	fscrypt_enqueue_decrypt_work(&ctx->r.work);
+}
+EXPORT_SYMBOL(fscrypt_enqueue_decrypt_bio);
+
+void fscrypt_pullback_bio_page(struct page **page, bool restore)
+{
+	struct fscrypt_ctx *ctx;
+	struct page *bounce_page;
+
+	/* The bounce data pages are unmapped. */
+	if ((*page)->mapping)
+		return;
+
+	/* The bounce data page is unmapped. */
+	bounce_page = *page;
+	ctx = (struct fscrypt_ctx *)page_private(bounce_page);
+
+	/* restore control page */
+	*page = ctx->w.control_page;
+
+	if (restore)
+		fscrypt_restore_control_page(bounce_page);
+}
+EXPORT_SYMBOL(fscrypt_pullback_bio_page);
+
+int fscrypt_zeroout_range(const struct inode *inode, pgoff_t lblk,
+				sector_t pblk, unsigned int len)
+{
+	struct fscrypt_ctx *ctx;
+	struct page *ciphertext_page = NULL;
+	struct bio *bio;
+	int ret, err = 0;
+
+	BUG_ON(inode->i_sb->s_blocksize != PAGE_SIZE);
+
+	ctx = fscrypt_get_ctx(inode, GFP_NOFS);
+	if (IS_ERR(ctx))
+		return PTR_ERR(ctx);
+
+	ciphertext_page = fscrypt_alloc_bounce_page(ctx, GFP_NOWAIT);
+	if (IS_ERR(ciphertext_page)) {
+		err = PTR_ERR(ciphertext_page);
+		goto errout;
+	}
+
+	while (len--) {
+		err = fscrypt_do_page_crypto(inode, FS_ENCRYPT, lblk,
+					     ZERO_PAGE(0), ciphertext_page,
+					     PAGE_SIZE, 0, GFP_NOFS);
+		if (err)
+			goto errout;
+
+		bio = bio_alloc(GFP_NOWAIT, 1);
+		if (!bio) {
+			err = -ENOMEM;
+			goto errout;
+		}
+		bio->bi_bdev = inode->i_sb->s_bdev;
+		bio->bi_iter.bi_sector =
+			pblk << (inode->i_sb->s_blocksize_bits - 9);
+		bio_set_op_attrs(bio, REQ_OP_WRITE, 0);
+		ret = bio_add_page(bio, ciphertext_page,
+					inode->i_sb->s_blocksize, 0);
+		if (ret != inode->i_sb->s_blocksize) {
+			/* should never happen! */
+			WARN_ON(1);
+			bio_put(bio);
+			err = -EIO;
+			goto errout;
+		}
+		err = submit_bio_wait(bio);
+		if (err == 0 && bio->bi_error)
+			err = -EIO;
+		bio_put(bio);
+		if (err)
+			goto errout;
+		lblk++;
+		pblk++;
+	}
+	err = 0;
+errout:
+	fscrypt_release_ctx(ctx);
+	return err;
+}
+EXPORT_SYMBOL(fscrypt_zeroout_range);
diff --git a/fs/crypto/crypto.c b/fs/crypto/crypto.c
index 1a89625..0f46cf5 100644
--- a/fs/crypto/crypto.c
+++ b/fs/crypto/crypto.c
@@ -24,10 +24,11 @@
 #include <linux/module.h>
 #include <linux/scatterlist.h>
 #include <linux/ratelimit.h>
-#include <linux/bio.h>
 #include <linux/dcache.h>
 #include <linux/namei.h>
-#include <linux/fscrypto.h>
+#include <crypto/aes.h>
+#include <crypto/skcipher.h>
+#include "fscrypt_private.h"
 
 static unsigned int num_prealloc_crypto_pages = 32;
 static unsigned int num_prealloc_crypto_ctxs = 128;
@@ -50,6 +51,12 @@
 static struct kmem_cache *fscrypt_ctx_cachep;
 struct kmem_cache *fscrypt_info_cachep;
 
+void fscrypt_enqueue_decrypt_work(struct work_struct *work)
+{
+	queue_work(fscrypt_read_workqueue, work);
+}
+EXPORT_SYMBOL(fscrypt_enqueue_decrypt_work);
+
 /**
  * fscrypt_release_ctx() - Releases an encryption context
  * @ctx: The encryption context to release.
@@ -63,7 +70,7 @@ void fscrypt_release_ctx(struct fscrypt_ctx *ctx)
 {
 	unsigned long flags;
 
-	if (ctx->flags & FS_WRITE_PATH_FL && ctx->w.bounce_page) {
+	if (ctx->flags & FS_CTX_HAS_BOUNCE_BUFFER_FL && ctx->w.bounce_page) {
 		mempool_free(ctx->w.bounce_page, fscrypt_bounce_page_pool);
 		ctx->w.bounce_page = NULL;
 	}
@@ -88,7 +95,7 @@ void fscrypt_release_ctx(struct fscrypt_ctx *ctx)
  * Return: An allocated and initialized encryption context on success; error
  * value or NULL otherwise.
  */
-struct fscrypt_ctx *fscrypt_get_ctx(struct inode *inode, gfp_t gfp_flags)
+struct fscrypt_ctx *fscrypt_get_ctx(const struct inode *inode, gfp_t gfp_flags)
 {
 	struct fscrypt_ctx *ctx = NULL;
 	struct fscrypt_info *ci = inode->i_crypt_info;
@@ -121,134 +128,147 @@ struct fscrypt_ctx *fscrypt_get_ctx(struct inode *inode, gfp_t gfp_flags)
 	} else {
 		ctx->flags &= ~FS_CTX_REQUIRES_FREE_ENCRYPT_FL;
 	}
-	ctx->flags &= ~FS_WRITE_PATH_FL;
+	ctx->flags &= ~FS_CTX_HAS_BOUNCE_BUFFER_FL;
 	return ctx;
 }
 EXPORT_SYMBOL(fscrypt_get_ctx);
 
-/**
- * page_crypt_complete() - completion callback for page crypto
- * @req: The asynchronous cipher request context
- * @res: The result of the cipher operation
- */
-static void page_crypt_complete(struct crypto_async_request *req, int res)
-{
-	struct fscrypt_completion_result *ecr = req->data;
-
-	if (res == -EINPROGRESS)
-		return;
-	ecr->res = res;
-	complete(&ecr->completion);
-}
-
-typedef enum {
-	FS_DECRYPT = 0,
-	FS_ENCRYPT,
-} fscrypt_direction_t;
-
-static int do_page_crypto(struct inode *inode,
-			fscrypt_direction_t rw, pgoff_t index,
-			struct page *src_page, struct page *dest_page,
-			gfp_t gfp_flags)
+int fscrypt_do_page_crypto(const struct inode *inode, fscrypt_direction_t rw,
+			   u64 lblk_num, struct page *src_page,
+			   struct page *dest_page, unsigned int len,
+			   unsigned int offs, gfp_t gfp_flags)
 {
 	struct {
 		__le64 index;
-		u8 padding[FS_XTS_TWEAK_SIZE - sizeof(__le64)];
-	} xts_tweak;
+		u8 padding[FS_IV_SIZE - sizeof(__le64)];
+	} iv;
 	struct skcipher_request *req = NULL;
-	DECLARE_FS_COMPLETION_RESULT(ecr);
+	DECLARE_CRYPTO_WAIT(wait);
 	struct scatterlist dst, src;
 	struct fscrypt_info *ci = inode->i_crypt_info;
 	struct crypto_skcipher *tfm = ci->ci_ctfm;
 	int res = 0;
 
+	BUG_ON(len == 0);
+
+	BUILD_BUG_ON(sizeof(iv) != FS_IV_SIZE);
+	BUILD_BUG_ON(AES_BLOCK_SIZE != FS_IV_SIZE);
+	iv.index = cpu_to_le64(lblk_num);
+	memset(iv.padding, 0, sizeof(iv.padding));
+
+	if (ci->ci_essiv_tfm != NULL) {
+		crypto_cipher_encrypt_one(ci->ci_essiv_tfm, (u8 *)&iv,
+					  (u8 *)&iv);
+	}
+
 	req = skcipher_request_alloc(tfm, gfp_flags);
-	if (!req) {
-		printk_ratelimited(KERN_ERR
-				"%s: crypto_request_alloc() failed\n",
-				__func__);
+	if (!req)
 		return -ENOMEM;
-	}
 
 	skcipher_request_set_callback(
 		req, CRYPTO_TFM_REQ_MAY_BACKLOG | CRYPTO_TFM_REQ_MAY_SLEEP,
-		page_crypt_complete, &ecr);
-
-	BUILD_BUG_ON(sizeof(xts_tweak) != FS_XTS_TWEAK_SIZE);
-	xts_tweak.index = cpu_to_le64(index);
-	memset(xts_tweak.padding, 0, sizeof(xts_tweak.padding));
+		crypto_req_done, &wait);
 
 	sg_init_table(&dst, 1);
-	sg_set_page(&dst, dest_page, PAGE_SIZE, 0);
+	sg_set_page(&dst, dest_page, len, offs);
 	sg_init_table(&src, 1);
-	sg_set_page(&src, src_page, PAGE_SIZE, 0);
-	skcipher_request_set_crypt(req, &src, &dst, PAGE_SIZE, &xts_tweak);
+	sg_set_page(&src, src_page, len, offs);
+	skcipher_request_set_crypt(req, &src, &dst, len, &iv);
 	if (rw == FS_DECRYPT)
-		res = crypto_skcipher_decrypt(req);
+		res = crypto_wait_req(crypto_skcipher_decrypt(req), &wait);
 	else
-		res = crypto_skcipher_encrypt(req);
-	if (res == -EINPROGRESS || res == -EBUSY) {
-		BUG_ON(req->base.data != &ecr);
-		wait_for_completion(&ecr.completion);
-		res = ecr.res;
-	}
+		res = crypto_wait_req(crypto_skcipher_encrypt(req), &wait);
 	skcipher_request_free(req);
 	if (res) {
-		printk_ratelimited(KERN_ERR
-			"%s: crypto_skcipher_encrypt() returned %d\n",
-			__func__, res);
+		fscrypt_err(inode->i_sb,
+			    "%scryption failed for inode %lu, block %llu: %d",
+			    (rw == FS_DECRYPT ? "de" : "en"),
+			    inode->i_ino, lblk_num, res);
 		return res;
 	}
 	return 0;
 }
 
-static struct page *alloc_bounce_page(struct fscrypt_ctx *ctx, gfp_t gfp_flags)
+struct page *fscrypt_alloc_bounce_page(struct fscrypt_ctx *ctx,
+				       gfp_t gfp_flags)
 {
 	ctx->w.bounce_page = mempool_alloc(fscrypt_bounce_page_pool, gfp_flags);
 	if (ctx->w.bounce_page == NULL)
 		return ERR_PTR(-ENOMEM);
-	ctx->flags |= FS_WRITE_PATH_FL;
+	ctx->flags |= FS_CTX_HAS_BOUNCE_BUFFER_FL;
 	return ctx->w.bounce_page;
 }
 
 /**
  * fscypt_encrypt_page() - Encrypts a page
- * @inode:          The inode for which the encryption should take place
- * @plaintext_page: The page to encrypt. Must be locked.
- * @gfp_flags:      The gfp flag for memory allocation
+ * @inode:     The inode for which the encryption should take place
+ * @page:      The page to encrypt. Must be locked for bounce-page
+ *             encryption.
+ * @len:       Length of data to encrypt in @page and encrypted
+ *             data in returned page.
+ * @offs:      Offset of data within @page and returned
+ *             page holding encrypted data.
+ * @lblk_num:  Logical block number. This must be unique for multiple
+ *             calls with same inode, except when overwriting
+ *             previously written data.
+ * @gfp_flags: The gfp flag for memory allocation
  *
- * Allocates a ciphertext page and encrypts plaintext_page into it using the ctx
- * encryption context.
+ * Encrypts @page using the ctx encryption context. Performs encryption
+ * either in-place or into a newly allocated bounce page.
+ * Called on the page write path.
  *
- * Called on the page write path.  The caller must call
+ * Bounce page allocation is the default.
+ * In this case, the contents of @page are encrypted and stored in an
+ * allocated bounce page. @page has to be locked and the caller must call
  * fscrypt_restore_control_page() on the returned ciphertext page to
  * release the bounce buffer and the encryption context.
  *
- * Return: An allocated page with the encrypted content on success. Else, an
+ * In-place encryption is used by setting the FS_CFLG_OWN_PAGES flag in
+ * fscrypt_operations. Here, the input-page is returned with its content
+ * encrypted.
+ *
+ * Return: A page with the encrypted content on success. Else, an
  * error value or NULL.
  */
-struct page *fscrypt_encrypt_page(struct inode *inode,
-				struct page *plaintext_page, gfp_t gfp_flags)
+struct page *fscrypt_encrypt_page(const struct inode *inode,
+				struct page *page,
+				unsigned int len,
+				unsigned int offs,
+				u64 lblk_num, gfp_t gfp_flags)
+
 {
 	struct fscrypt_ctx *ctx;
-	struct page *ciphertext_page = NULL;
+	struct page *ciphertext_page = page;
 	int err;
 
-	BUG_ON(!PageLocked(plaintext_page));
+	BUG_ON(len % FS_CRYPTO_BLOCK_SIZE != 0);
+
+	if (inode->i_sb->s_cop->flags & FS_CFLG_OWN_PAGES) {
+		/* with inplace-encryption we just encrypt the page */
+		err = fscrypt_do_page_crypto(inode, FS_ENCRYPT, lblk_num, page,
+					     ciphertext_page, len, offs,
+					     gfp_flags);
+		if (err)
+			return ERR_PTR(err);
+
+		return ciphertext_page;
+	}
+
+	BUG_ON(!PageLocked(page));
 
 	ctx = fscrypt_get_ctx(inode, gfp_flags);
 	if (IS_ERR(ctx))
 		return (struct page *)ctx;
 
 	/* The encryption operation will require a bounce page. */
-	ciphertext_page = alloc_bounce_page(ctx, gfp_flags);
+	ciphertext_page = fscrypt_alloc_bounce_page(ctx, gfp_flags);
 	if (IS_ERR(ciphertext_page))
 		goto errout;
 
-	ctx->w.control_page = plaintext_page;
-	err = do_page_crypto(inode, FS_ENCRYPT, plaintext_page->index,
-					plaintext_page, ciphertext_page,
-					gfp_flags);
+	ctx->w.control_page = page;
+	err = fscrypt_do_page_crypto(inode, FS_ENCRYPT, lblk_num,
+				     page, ciphertext_page, len, offs,
+				     gfp_flags);
 	if (err) {
 		ciphertext_page = ERR_PTR(err);
 		goto errout;
@@ -265,8 +285,13 @@ struct page *fscrypt_encrypt_page(struct inode *inode,
 EXPORT_SYMBOL(fscrypt_encrypt_page);
 
 /**
- * f2crypt_decrypt_page() - Decrypts a page in-place
- * @page: The page to decrypt. Must be locked.
+ * fscrypt_decrypt_page() - Decrypts a page in-place
+ * @inode:     The corresponding inode for the page to decrypt.
+ * @page:      The page to decrypt. Must be locked in case
+ *             it is a writeback page (FS_CFLG_OWN_PAGES unset).
+ * @len:       Number of bytes in @page to be decrypted.
+ * @offs:      Start of data in @page.
+ * @lblk_num:  Logical block number.
  *
  * Decrypts page in-place using the ctx encryption context.
  *
@@ -274,76 +299,17 @@ struct page *fscrypt_encrypt_page(struct inode *inode,
  *
  * Return: Zero on success, non-zero otherwise.
  */
-int fscrypt_decrypt_page(struct page *page)
+int fscrypt_decrypt_page(const struct inode *inode, struct page *page,
+			unsigned int len, unsigned int offs, u64 lblk_num)
 {
-	BUG_ON(!PageLocked(page));
+	if (!(inode->i_sb->s_cop->flags & FS_CFLG_OWN_PAGES))
+		BUG_ON(!PageLocked(page));
 
-	return do_page_crypto(page->mapping->host,
-			FS_DECRYPT, page->index, page, page, GFP_NOFS);
+	return fscrypt_do_page_crypto(inode, FS_DECRYPT, lblk_num, page, page,
+				      len, offs, GFP_NOFS);
 }
 EXPORT_SYMBOL(fscrypt_decrypt_page);
 
-int fscrypt_zeroout_range(struct inode *inode, pgoff_t lblk,
-				sector_t pblk, unsigned int len)
-{
-	struct fscrypt_ctx *ctx;
-	struct page *ciphertext_page = NULL;
-	struct bio *bio;
-	int ret, err = 0;
-
-	BUG_ON(inode->i_sb->s_blocksize != PAGE_SIZE);
-
-	ctx = fscrypt_get_ctx(inode, GFP_NOFS);
-	if (IS_ERR(ctx))
-		return PTR_ERR(ctx);
-
-	ciphertext_page = alloc_bounce_page(ctx, GFP_NOWAIT);
-	if (IS_ERR(ciphertext_page)) {
-		err = PTR_ERR(ciphertext_page);
-		goto errout;
-	}
-
-	while (len--) {
-		err = do_page_crypto(inode, FS_ENCRYPT, lblk,
-					ZERO_PAGE(0), ciphertext_page,
-					GFP_NOFS);
-		if (err)
-			goto errout;
-
-		bio = bio_alloc(GFP_NOWAIT, 1);
-		if (!bio) {
-			err = -ENOMEM;
-			goto errout;
-		}
-		bio->bi_bdev = inode->i_sb->s_bdev;
-		bio->bi_iter.bi_sector =
-			pblk << (inode->i_sb->s_blocksize_bits - 9);
-		bio_set_op_attrs(bio, REQ_OP_WRITE, 0);
-		ret = bio_add_page(bio, ciphertext_page,
-					inode->i_sb->s_blocksize, 0);
-		if (ret != inode->i_sb->s_blocksize) {
-			/* should never happen! */
-			WARN_ON(1);
-			bio_put(bio);
-			err = -EIO;
-			goto errout;
-		}
-		err = submit_bio_wait(bio);
-		if ((err == 0) && bio->bi_error)
-			err = -EIO;
-		bio_put(bio);
-		if (err)
-			goto errout;
-		lblk++;
-		pblk++;
-	}
-	err = 0;
-errout:
-	fscrypt_release_ctx(ctx);
-	return err;
-}
-EXPORT_SYMBOL(fscrypt_zeroout_range);
-
 /*
  * Validate dentries for encrypted directories to make sure we aren't
  * potentially caching stale data after a key has been added or
@@ -358,12 +324,11 @@ static int fscrypt_d_revalidate(struct dentry *dentry, unsigned int flags)
 		return -ECHILD;
 
 	dir = dget_parent(dentry);
-	if (!d_inode(dir)->i_sb->s_cop->is_encrypted(d_inode(dir))) {
+	if (!IS_ENCRYPTED(d_inode(dir))) {
 		dput(dir);
 		return 0;
 	}
 
-	/* this should eventually be an flag in d_flags */
 	spin_lock(&dentry->d_lock);
 	cached_with_key = dentry->d_flags & DCACHE_ENCRYPTED_WITH_KEY;
 	spin_unlock(&dentry->d_lock);
@@ -390,64 +355,6 @@ static int fscrypt_d_revalidate(struct dentry *dentry, unsigned int flags)
 const struct dentry_operations fscrypt_d_ops = {
 	.d_revalidate = fscrypt_d_revalidate,
 };
-EXPORT_SYMBOL(fscrypt_d_ops);
-
-/*
- * Call fscrypt_decrypt_page on every single page, reusing the encryption
- * context.
- */
-static void completion_pages(struct work_struct *work)
-{
-	struct fscrypt_ctx *ctx =
-		container_of(work, struct fscrypt_ctx, r.work);
-	struct bio *bio = ctx->r.bio;
-	struct bio_vec *bv;
-	int i;
-
-	bio_for_each_segment_all(bv, bio, i) {
-		struct page *page = bv->bv_page;
-		int ret = fscrypt_decrypt_page(page);
-
-		if (ret) {
-			WARN_ON_ONCE(1);
-			SetPageError(page);
-		} else {
-			SetPageUptodate(page);
-		}
-		unlock_page(page);
-	}
-	fscrypt_release_ctx(ctx);
-	bio_put(bio);
-}
-
-void fscrypt_decrypt_bio_pages(struct fscrypt_ctx *ctx, struct bio *bio)
-{
-	INIT_WORK(&ctx->r.work, completion_pages);
-	ctx->r.bio = bio;
-	queue_work(fscrypt_read_workqueue, &ctx->r.work);
-}
-EXPORT_SYMBOL(fscrypt_decrypt_bio_pages);
-
-void fscrypt_pullback_bio_page(struct page **page, bool restore)
-{
-	struct fscrypt_ctx *ctx;
-	struct page *bounce_page;
-
-	/* The bounce data pages are unmapped. */
-	if ((*page)->mapping)
-		return;
-
-	/* The bounce data page is unmapped. */
-	bounce_page = *page;
-	ctx = (struct fscrypt_ctx *)page_private(bounce_page);
-
-	/* restore control page */
-	*page = ctx->w.control_page;
-
-	if (restore)
-		fscrypt_restore_control_page(bounce_page);
-}
-EXPORT_SYMBOL(fscrypt_pullback_bio_page);
 
 void fscrypt_restore_control_page(struct page *page)
 {
@@ -474,16 +381,21 @@ static void fscrypt_destroy(void)
 
 /**
  * fscrypt_initialize() - allocate major buffers for fs encryption.
+ * @cop_flags:  fscrypt operations flags
  *
  * We only call this when we start accessing encrypted files, since it
  * results in memory getting allocated that wouldn't otherwise be used.
  *
  * Return: Zero on success, non-zero otherwise.
  */
-int fscrypt_initialize(void)
+int fscrypt_initialize(unsigned int cop_flags)
 {
 	int i, res = -ENOMEM;
 
+	/* No need to allocate a bounce page pool if this FS won't use it. */
+	if (cop_flags & FS_CFLG_OWN_PAGES)
+		return 0;
+
 	mutex_lock(&fscrypt_init_mutex);
 	if (fscrypt_bounce_page_pool)
 		goto already_initialized;
@@ -510,7 +422,27 @@ int fscrypt_initialize(void)
 	mutex_unlock(&fscrypt_init_mutex);
 	return res;
 }
-EXPORT_SYMBOL(fscrypt_initialize);
+
+void fscrypt_msg(struct super_block *sb, const char *level,
+		 const char *fmt, ...)
+{
+	static DEFINE_RATELIMIT_STATE(rs, DEFAULT_RATELIMIT_INTERVAL,
+				      DEFAULT_RATELIMIT_BURST);
+	struct va_format vaf;
+	va_list args;
+
+	if (!__ratelimit(&rs))
+		return;
+
+	va_start(args, fmt);
+	vaf.fmt = fmt;
+	vaf.va = &args;
+	if (sb)
+		printk("%sfscrypt (%s): %pV\n", level, sb->s_id, &vaf);
+	else
+		printk("%sfscrypt: %pV\n", level, &vaf);
+	va_end(args);
+}
 
 /**
  * fscrypt_init() - Set up for fs encryption.
@@ -561,6 +493,8 @@ static void __exit fscrypt_exit(void)
 		destroy_workqueue(fscrypt_read_workqueue);
 	kmem_cache_destroy(fscrypt_ctx_cachep);
 	kmem_cache_destroy(fscrypt_info_cachep);
+
+	fscrypt_essiv_cleanup();
 }
 module_exit(fscrypt_exit);
 
diff --git a/fs/crypto/fname.c b/fs/crypto/fname.c
index e14bb7b..1bdb9f2 100644
--- a/fs/crypto/fname.c
+++ b/fs/crypto/fname.c
@@ -12,89 +12,70 @@
 
 #include <linux/scatterlist.h>
 #include <linux/ratelimit.h>
-#include <linux/fscrypto.h>
+#include <crypto/skcipher.h>
+#include "fscrypt_private.h"
 
-/**
- * fname_crypt_complete() - completion callback for filename crypto
- * @req: The asynchronous cipher request context
- * @res: The result of the cipher operation
- */
-static void fname_crypt_complete(struct crypto_async_request *req, int res)
+static inline bool fscrypt_is_dot_dotdot(const struct qstr *str)
 {
-	struct fscrypt_completion_result *ecr = req->data;
+	if (str->len == 1 && str->name[0] == '.')
+		return true;
 
-	if (res == -EINPROGRESS)
-		return;
-	ecr->res = res;
-	complete(&ecr->completion);
+	if (str->len == 2 && str->name[0] == '.' && str->name[1] == '.')
+		return true;
+
+	return false;
 }
 
 /**
  * fname_encrypt() - encrypt a filename
  *
- * The caller must have allocated sufficient memory for the @oname string.
+ * The output buffer must be at least as large as the input buffer.
+ * Any extra space is filled with NUL padding before encryption.
  *
  * Return: 0 on success, -errno on failure
  */
-static int fname_encrypt(struct inode *inode,
-			const struct qstr *iname, struct fscrypt_str *oname)
+int fname_encrypt(struct inode *inode, const struct qstr *iname,
+		  u8 *out, unsigned int olen)
 {
 	struct skcipher_request *req = NULL;
-	DECLARE_FS_COMPLETION_RESULT(ecr);
-	struct fscrypt_info *ci = inode->i_crypt_info;
-	struct crypto_skcipher *tfm = ci->ci_ctfm;
+	DECLARE_CRYPTO_WAIT(wait);
+	struct crypto_skcipher *tfm = inode->i_crypt_info->ci_ctfm;
 	int res = 0;
 	char iv[FS_CRYPTO_BLOCK_SIZE];
 	struct scatterlist sg;
-	int padding = 4 << (ci->ci_flags & FS_POLICY_FLAGS_PAD_MASK);
-	unsigned int lim;
-	unsigned int cryptlen;
-
-	lim = inode->i_sb->s_cop->max_namelen(inode);
-	if (iname->len <= 0 || iname->len > lim)
-		return -EIO;
 
 	/*
 	 * Copy the filename to the output buffer for encrypting in-place and
 	 * pad it with the needed number of NUL bytes.
 	 */
-	cryptlen = max_t(unsigned int, iname->len, FS_CRYPTO_BLOCK_SIZE);
-	cryptlen = round_up(cryptlen, padding);
-	cryptlen = min(cryptlen, lim);
-	memcpy(oname->name, iname->name, iname->len);
-	memset(oname->name + iname->len, 0, cryptlen - iname->len);
+	if (WARN_ON(olen < iname->len))
+		return -ENOBUFS;
+	memcpy(out, iname->name, iname->len);
+	memset(out + iname->len, 0, olen - iname->len);
 
 	/* Initialize the IV */
 	memset(iv, 0, FS_CRYPTO_BLOCK_SIZE);
 
 	/* Set up the encryption request */
 	req = skcipher_request_alloc(tfm, GFP_NOFS);
-	if (!req) {
-		printk_ratelimited(KERN_ERR
-			"%s: skcipher_request_alloc() failed\n", __func__);
+	if (!req)
 		return -ENOMEM;
-	}
 	skcipher_request_set_callback(req,
 			CRYPTO_TFM_REQ_MAY_BACKLOG | CRYPTO_TFM_REQ_MAY_SLEEP,
-			fname_crypt_complete, &ecr);
-	sg_init_one(&sg, oname->name, cryptlen);
-	skcipher_request_set_crypt(req, &sg, &sg, cryptlen, iv);
+			crypto_req_done, &wait);
+	sg_init_one(&sg, out, olen);
+	skcipher_request_set_crypt(req, &sg, &sg, olen, iv);
 
 	/* Do the encryption */
-	res = crypto_skcipher_encrypt(req);
-	if (res == -EINPROGRESS || res == -EBUSY) {
-		/* Request is being completed asynchronously; wait for it */
-		wait_for_completion(&ecr.completion);
-		res = ecr.res;
-	}
+	res = crypto_wait_req(crypto_skcipher_encrypt(req), &wait);
 	skcipher_request_free(req);
 	if (res < 0) {
-		printk_ratelimited(KERN_ERR
-				"%s: Error (error code %d)\n", __func__, res);
+		fscrypt_err(inode->i_sb,
+			    "Filename encryption failed for inode %lu: %d",
+			    inode->i_ino, res);
 		return res;
 	}
 
-	oname->len = cryptlen;
 	return 0;
 }
 
@@ -110,28 +91,19 @@ static int fname_decrypt(struct inode *inode,
 				struct fscrypt_str *oname)
 {
 	struct skcipher_request *req = NULL;
-	DECLARE_FS_COMPLETION_RESULT(ecr);
+	DECLARE_CRYPTO_WAIT(wait);
 	struct scatterlist src_sg, dst_sg;
-	struct fscrypt_info *ci = inode->i_crypt_info;
-	struct crypto_skcipher *tfm = ci->ci_ctfm;
+	struct crypto_skcipher *tfm = inode->i_crypt_info->ci_ctfm;
 	int res = 0;
 	char iv[FS_CRYPTO_BLOCK_SIZE];
-	unsigned lim;
-
-	lim = inode->i_sb->s_cop->max_namelen(inode);
-	if (iname->len <= 0 || iname->len > lim)
-		return -EIO;
 
 	/* Allocate request */
 	req = skcipher_request_alloc(tfm, GFP_NOFS);
-	if (!req) {
-		printk_ratelimited(KERN_ERR
-			"%s: crypto_request_alloc() failed\n",  __func__);
+	if (!req)
 		return -ENOMEM;
-	}
 	skcipher_request_set_callback(req,
 		CRYPTO_TFM_REQ_MAY_BACKLOG | CRYPTO_TFM_REQ_MAY_SLEEP,
-		fname_crypt_complete, &ecr);
+		crypto_req_done, &wait);
 
 	/* Initialize IV */
 	memset(iv, 0, FS_CRYPTO_BLOCK_SIZE);
@@ -140,15 +112,12 @@ static int fname_decrypt(struct inode *inode,
 	sg_init_one(&src_sg, iname->name, iname->len);
 	sg_init_one(&dst_sg, oname->name, oname->len);
 	skcipher_request_set_crypt(req, &src_sg, &dst_sg, iname->len, iv);
-	res = crypto_skcipher_decrypt(req);
-	if (res == -EINPROGRESS || res == -EBUSY) {
-		wait_for_completion(&ecr.completion);
-		res = ecr.res;
-	}
+	res = crypto_wait_req(crypto_skcipher_decrypt(req), &wait);
 	skcipher_request_free(req);
 	if (res < 0) {
-		printk_ratelimited(KERN_ERR
-				"%s: Error (error code %d)\n", __func__, res);
+		fscrypt_err(inode->i_sb,
+			    "Filename decryption failed for inode %lu: %d",
+			    inode->i_ino, res);
 		return res;
 	}
 
@@ -159,6 +128,8 @@ static int fname_decrypt(struct inode *inode,
 static const char *lookup_table =
 	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+,";
 
+#define BASE64_CHARS(nbytes)	DIV_ROUND_UP((nbytes) * 4, 3)
+
 /**
  * digest_encode() -
  *
@@ -209,47 +180,52 @@ static int digest_decode(const char *src, int len, char *dst)
 	return cp - dst;
 }
 
-u32 fscrypt_fname_encrypted_size(struct inode *inode, u32 ilen)
+bool fscrypt_fname_encrypted_size(const struct inode *inode, u32 orig_len,
+				  u32 max_len, u32 *encrypted_len_ret)
 {
-	int padding = 32;
-	struct fscrypt_info *ci = inode->i_crypt_info;
-
-	if (ci)
-		padding = 4 << (ci->ci_flags & FS_POLICY_FLAGS_PAD_MASK);
-	ilen = max(ilen, (u32)FS_CRYPTO_BLOCK_SIZE);
-	return round_up(ilen, padding);
+	int padding = 4 << (inode->i_crypt_info->ci_flags &
+			    FS_POLICY_FLAGS_PAD_MASK);
+	u32 encrypted_len;
+
+	if (orig_len > max_len)
+		return false;
+	encrypted_len = max(orig_len, (u32)FS_CRYPTO_BLOCK_SIZE);
+	encrypted_len = round_up(encrypted_len, padding);
+	*encrypted_len_ret = min(encrypted_len, max_len);
+	return true;
 }
-EXPORT_SYMBOL(fscrypt_fname_encrypted_size);
 
 /**
- * fscrypt_fname_crypto_alloc_obuff() -
+ * fscrypt_fname_alloc_buffer - allocate a buffer for presented filenames
+ *
+ * Allocate a buffer that is large enough to hold any decrypted or encoded
+ * filename (null-terminated), for the given maximum encrypted filename length.
  *
- * Allocates an output buffer that is sufficient for the crypto operation
- * specified by the context and the direction.
+ * Return: 0 on success, -errno on failure
  */
-int fscrypt_fname_alloc_buffer(struct inode *inode,
-				u32 ilen, struct fscrypt_str *crypto_str)
+int fscrypt_fname_alloc_buffer(const struct inode *inode,
+			       u32 max_encrypted_len,
+			       struct fscrypt_str *crypto_str)
 {
-	unsigned int olen = fscrypt_fname_encrypted_size(inode, ilen);
+	const u32 max_encoded_len =
+		max_t(u32, BASE64_CHARS(FSCRYPT_FNAME_MAX_UNDIGESTED_SIZE),
+		      1 + BASE64_CHARS(sizeof(struct fscrypt_digested_name)));
+	u32 max_presented_len;
 
-	crypto_str->len = olen;
-	if (olen < FS_FNAME_CRYPTO_DIGEST_SIZE * 2)
-		olen = FS_FNAME_CRYPTO_DIGEST_SIZE * 2;
-	/*
-	 * Allocated buffer can hold one more character to null-terminate the
-	 * string
-	 */
-	crypto_str->name = kmalloc(olen + 1, GFP_NOFS);
-	if (!(crypto_str->name))
+	max_presented_len = max(max_encoded_len, max_encrypted_len);
+
+	crypto_str->name = kmalloc(max_presented_len + 1, GFP_NOFS);
+	if (!crypto_str->name)
 		return -ENOMEM;
+	crypto_str->len = max_presented_len;
 	return 0;
 }
 EXPORT_SYMBOL(fscrypt_fname_alloc_buffer);
 
 /**
- * fscrypt_fname_crypto_free_buffer() -
+ * fscrypt_fname_free_buffer - free the buffer for presented filenames
  *
- * Frees the buffer allocated for crypto operation.
+ * Free the buffer allocated by fscrypt_fname_alloc_buffer().
  */
 void fscrypt_fname_free_buffer(struct fscrypt_str *crypto_str)
 {
@@ -266,6 +242,10 @@ void fscrypt_fname_free_buffer(struct fscrypt_str *crypto_str)
  *
  * The caller must have allocated sufficient memory for the @oname string.
  *
+ * If the key is available, we'll decrypt the disk name; otherwise, we'll encode
+ * it for presentation.  Short names are directly base64-encoded, while long
+ * names are encoded in fscrypt_digested_name format.
+ *
  * Return: 0 on success, -errno on failure
  */
 int fscrypt_fname_disk_to_usr(struct inode *inode,
@@ -274,7 +254,7 @@ int fscrypt_fname_disk_to_usr(struct inode *inode,
 			struct fscrypt_str *oname)
 {
 	const struct qstr qname = FSTR_TO_QSTR(iname);
-	char buf[24];
+	struct fscrypt_digested_name digested_name;
 
 	if (fscrypt_is_dot_dotdot(&qname)) {
 		oname->name[0] = '.';
@@ -289,77 +269,82 @@ int fscrypt_fname_disk_to_usr(struct inode *inode,
 	if (inode->i_crypt_info)
 		return fname_decrypt(inode, iname, oname);
 
-	if (iname->len <= FS_FNAME_CRYPTO_DIGEST_SIZE) {
+	if (iname->len <= FSCRYPT_FNAME_MAX_UNDIGESTED_SIZE) {
 		oname->len = digest_encode(iname->name, iname->len,
 					   oname->name);
 		return 0;
 	}
 	if (hash) {
-		memcpy(buf, &hash, 4);
-		memcpy(buf + 4, &minor_hash, 4);
+		digested_name.hash = hash;
+		digested_name.minor_hash = minor_hash;
 	} else {
-		memset(buf, 0, 8);
+		digested_name.hash = 0;
+		digested_name.minor_hash = 0;
 	}
-	memcpy(buf + 8, iname->name + ((iname->len - 17) & ~15), 16);
+	memcpy(digested_name.digest,
+	       FSCRYPT_FNAME_DIGEST(iname->name, iname->len),
+	       FSCRYPT_FNAME_DIGEST_SIZE);
 	oname->name[0] = '_';
-	oname->len = 1 + digest_encode(buf, 24, oname->name + 1);
+	oname->len = 1 + digest_encode((const char *)&digested_name,
+				       sizeof(digested_name), oname->name + 1);
 	return 0;
 }
 EXPORT_SYMBOL(fscrypt_fname_disk_to_usr);
 
 /**
- * fscrypt_fname_usr_to_disk() - converts a filename from user space to disk
- * space
+ * fscrypt_setup_filename() - prepare to search a possibly encrypted directory
+ * @dir: the directory that will be searched
+ * @iname: the user-provided filename being searched for
+ * @lookup: 1 if we're allowed to proceed without the key because it's
+ *	->lookup() or we're finding the dir_entry for deletion; 0 if we cannot
+ *	proceed without the key because we're going to create the dir_entry.
+ * @fname: the filename information to be filled in
  *
- * The caller must have allocated sufficient memory for the @oname string.
+ * Given a user-provided filename @iname, this function sets @fname->disk_name
+ * to the name that would be stored in the on-disk directory entry, if possible.
+ * If the directory is unencrypted this is simply @iname.  Else, if we have the
+ * directory's encryption key, then @iname is the plaintext, so we encrypt it to
+ * get the disk_name.
+ *
+ * Else, for keyless @lookup operations, @iname is the presented ciphertext, so
+ * we decode it to get either the ciphertext disk_name (for short names) or the
+ * fscrypt_digested_name (for long names).  Non-@lookup operations will be
+ * impossible in this case, so we fail them with ENOKEY.
+ *
+ * If successful, fscrypt_free_filename() must be called later to clean up.
  *
  * Return: 0 on success, -errno on failure
  */
-int fscrypt_fname_usr_to_disk(struct inode *inode,
-			const struct qstr *iname,
-			struct fscrypt_str *oname)
-{
-	if (fscrypt_is_dot_dotdot(iname)) {
-		oname->name[0] = '.';
-		oname->name[iname->len - 1] = '.';
-		oname->len = iname->len;
-		return 0;
-	}
-	if (inode->i_crypt_info)
-		return fname_encrypt(inode, iname, oname);
-	/*
-	 * Without a proper key, a user is not allowed to modify the filenames
-	 * in a directory. Consequently, a user space name cannot be mapped to
-	 * a disk-space name
-	 */
-	return -ENOKEY;
-}
-EXPORT_SYMBOL(fscrypt_fname_usr_to_disk);
-
 int fscrypt_setup_filename(struct inode *dir, const struct qstr *iname,
 			      int lookup, struct fscrypt_name *fname)
 {
-	int ret = 0, bigname = 0;
+	int ret;
+	int digested;
 
 	memset(fname, 0, sizeof(struct fscrypt_name));
 	fname->usr_fname = iname;
 
-	if (!dir->i_sb->s_cop->is_encrypted(dir) ||
-				fscrypt_is_dot_dotdot(iname)) {
+	if (!IS_ENCRYPTED(dir) || fscrypt_is_dot_dotdot(iname)) {
 		fname->disk_name.name = (unsigned char *)iname->name;
 		fname->disk_name.len = iname->len;
 		return 0;
 	}
 	ret = fscrypt_get_encryption_info(dir);
-	if (ret && ret != -EOPNOTSUPP)
+	if (ret)
 		return ret;
 
 	if (dir->i_crypt_info) {
-		ret = fscrypt_fname_alloc_buffer(dir, iname->len,
-							&fname->crypto_buf);
-		if (ret)
-			return ret;
-		ret = fname_encrypt(dir, iname, &fname->crypto_buf);
+		if (!fscrypt_fname_encrypted_size(dir, iname->len,
+						  dir->i_sb->s_cop->max_namelen,
+						  &fname->crypto_buf.len))
+			return -ENAMETOOLONG;
+		fname->crypto_buf.name = kmalloc(fname->crypto_buf.len,
+						 GFP_NOFS);
+		if (!fname->crypto_buf.name)
+			return -ENOMEM;
+
+		ret = fname_encrypt(dir, iname, fname->crypto_buf.name,
+				    fname->crypto_buf.len);
 		if (ret)
 			goto errout;
 		fname->disk_name.name = fname->crypto_buf.name;
@@ -373,25 +358,37 @@ int fscrypt_setup_filename(struct inode *dir, const struct qstr *iname,
 	 * We don't have the key and we are doing a lookup; decode the
 	 * user-supplied name
 	 */
-	if (iname->name[0] == '_')
-		bigname = 1;
-	if ((bigname && (iname->len != 33)) || (!bigname && (iname->len > 43)))
-		return -ENOENT;
+	if (iname->name[0] == '_') {
+		if (iname->len !=
+		    1 + BASE64_CHARS(sizeof(struct fscrypt_digested_name)))
+			return -ENOENT;
+		digested = 1;
+	} else {
+		if (iname->len >
+		    BASE64_CHARS(FSCRYPT_FNAME_MAX_UNDIGESTED_SIZE))
+			return -ENOENT;
+		digested = 0;
+	}
 
-	fname->crypto_buf.name = kmalloc(32, GFP_KERNEL);
+	fname->crypto_buf.name =
+		kmalloc(max_t(size_t, FSCRYPT_FNAME_MAX_UNDIGESTED_SIZE,
+			      sizeof(struct fscrypt_digested_name)),
+			GFP_KERNEL);
 	if (fname->crypto_buf.name == NULL)
 		return -ENOMEM;
 
-	ret = digest_decode(iname->name + bigname, iname->len - bigname,
+	ret = digest_decode(iname->name + digested, iname->len - digested,
 				fname->crypto_buf.name);
 	if (ret < 0) {
 		ret = -ENOENT;
 		goto errout;
 	}
 	fname->crypto_buf.len = ret;
-	if (bigname) {
-		memcpy(&fname->hash, fname->crypto_buf.name, 4);
-		memcpy(&fname->minor_hash, fname->crypto_buf.name + 4, 4);
+	if (digested) {
+		const struct fscrypt_digested_name *n =
+			(const void *)fname->crypto_buf.name;
+		fname->hash = n->hash;
+		fname->minor_hash = n->minor_hash;
 	} else {
 		fname->disk_name.name = fname->crypto_buf.name;
 		fname->disk_name.len = fname->crypto_buf.len;
@@ -399,16 +396,7 @@ int fscrypt_setup_filename(struct inode *dir, const struct qstr *iname,
 	return 0;
 
 errout:
-	fscrypt_fname_free_buffer(&fname->crypto_buf);
+	kfree(fname->crypto_buf.name);
 	return ret;
 }
 EXPORT_SYMBOL(fscrypt_setup_filename);
-
-void fscrypt_free_filename(struct fscrypt_name *fname)
-{
-	kfree(fname->crypto_buf.name);
-	fname->crypto_buf.name = NULL;
-	fname->usr_fname = NULL;
-	fname->disk_name.name = NULL;
-}
-EXPORT_SYMBOL(fscrypt_free_filename);
diff --git a/fs/crypto/fscrypt_private.h b/fs/crypto/fscrypt_private.h
new file mode 100644
index 00000000..d608237
--- /dev/null
+++ b/fs/crypto/fscrypt_private.h
@@ -0,0 +1,123 @@
+/*
+ * fscrypt_private.h
+ *
+ * Copyright (C) 2015, Google, Inc.
+ *
+ * This contains encryption key functions.
+ *
+ * Written by Michael Halcrow, Ildar Muslukhov, and Uday Savagaonkar, 2015.
+ */
+
+#ifndef _FSCRYPT_PRIVATE_H
+#define _FSCRYPT_PRIVATE_H
+
+#define __FS_HAS_ENCRYPTION 1
+#include <linux/fscrypt.h>
+#include <crypto/hash.h>
+
+/* Encryption parameters */
+#define FS_IV_SIZE			16
+#define FS_KEY_DERIVATION_NONCE_SIZE	16
+
+/**
+ * Encryption context for inode
+ *
+ * Protector format:
+ *  1 byte: Protector format (1 = this version)
+ *  1 byte: File contents encryption mode
+ *  1 byte: File names encryption mode
+ *  1 byte: Flags
+ *  8 bytes: Master Key descriptor
+ *  16 bytes: Encryption Key derivation nonce
+ */
+struct fscrypt_context {
+	u8 format;
+	u8 contents_encryption_mode;
+	u8 filenames_encryption_mode;
+	u8 flags;
+	u8 master_key_descriptor[FS_KEY_DESCRIPTOR_SIZE];
+	u8 nonce[FS_KEY_DERIVATION_NONCE_SIZE];
+} __packed;
+
+#define FS_ENCRYPTION_CONTEXT_FORMAT_V1		1
+
+/**
+ * For encrypted symlinks, the ciphertext length is stored at the beginning
+ * of the string in little-endian format.
+ */
+struct fscrypt_symlink_data {
+	__le16 len;
+	char encrypted_path[1];
+} __packed;
+
+/*
+ * A pointer to this structure is stored in the file system's in-core
+ * representation of an inode.
+ */
+struct fscrypt_info {
+	u8 ci_data_mode;
+	u8 ci_filename_mode;
+	u8 ci_flags;
+	struct crypto_skcipher *ci_ctfm;
+	struct crypto_cipher *ci_essiv_tfm;
+	u8 ci_master_key[FS_KEY_DESCRIPTOR_SIZE];
+};
+
+typedef enum {
+	FS_DECRYPT = 0,
+	FS_ENCRYPT,
+} fscrypt_direction_t;
+
+#define FS_CTX_REQUIRES_FREE_ENCRYPT_FL		0x00000001
+#define FS_CTX_HAS_BOUNCE_BUFFER_FL		0x00000002
+
+static inline bool fscrypt_valid_enc_modes(u32 contents_mode,
+					   u32 filenames_mode)
+{
+	if (contents_mode == FS_ENCRYPTION_MODE_AES_128_CBC &&
+	    filenames_mode == FS_ENCRYPTION_MODE_AES_128_CTS)
+		return true;
+
+	if (contents_mode == FS_ENCRYPTION_MODE_AES_256_XTS &&
+	    filenames_mode == FS_ENCRYPTION_MODE_AES_256_CTS)
+		return true;
+
+	if (contents_mode == FS_ENCRYPTION_MODE_SPECK128_256_XTS &&
+	    filenames_mode == FS_ENCRYPTION_MODE_SPECK128_256_CTS)
+		return true;
+
+	return false;
+}
+
+/* crypto.c */
+extern struct kmem_cache *fscrypt_info_cachep;
+extern int fscrypt_initialize(unsigned int cop_flags);
+extern int fscrypt_do_page_crypto(const struct inode *inode,
+				  fscrypt_direction_t rw, u64 lblk_num,
+				  struct page *src_page,
+				  struct page *dest_page,
+				  unsigned int len, unsigned int offs,
+				  gfp_t gfp_flags);
+extern struct page *fscrypt_alloc_bounce_page(struct fscrypt_ctx *ctx,
+					      gfp_t gfp_flags);
+extern const struct dentry_operations fscrypt_d_ops;
+
+extern void __printf(3, 4) __cold
+fscrypt_msg(struct super_block *sb, const char *level, const char *fmt, ...);
+
+#define fscrypt_warn(sb, fmt, ...)		\
+	fscrypt_msg(sb, KERN_WARNING, fmt, ##__VA_ARGS__)
+#define fscrypt_err(sb, fmt, ...)		\
+	fscrypt_msg(sb, KERN_ERR, fmt, ##__VA_ARGS__)
+
+/* fname.c */
+extern int fname_encrypt(struct inode *inode, const struct qstr *iname,
+			 u8 *out, unsigned int olen);
+extern bool fscrypt_fname_encrypted_size(const struct inode *inode,
+					 u32 orig_len, u32 max_len,
+					 u32 *encrypted_len_ret);
+
+/* keyinfo.c */
+extern void __exit fscrypt_essiv_cleanup(void);
+
+#endif /* _FSCRYPT_PRIVATE_H */
diff --git a/fs/crypto/hooks.c b/fs/crypto/hooks.c
new file mode 100644
index 00000000..926e5df
--- /dev/null
+++ b/fs/crypto/hooks.c
@@ -0,0 +1,271 @@
+/*
+ * fs/crypto/hooks.c
+ *
+ * Encryption hooks for higher-level filesystem operations.
+ */
+
+#include <linux/ratelimit.h>
+#include "fscrypt_private.h"
+
+/**
+ * fscrypt_file_open - prepare to open a possibly-encrypted regular file
+ * @inode: the inode being opened
+ * @filp: the struct file being set up
+ *
+ * Currently, an encrypted regular file can only be opened if its encryption key
+ * is available; access to the raw encrypted contents is not supported.
+ * Therefore, we first set up the inode's encryption key (if not already done)
+ * and return an error if it's unavailable.
+ *
+ * We also verify that if the parent directory (from the path via which the file
+ * is being opened) is encrypted, then the inode being opened uses the same
+ * encryption policy.  This is needed as part of the enforcement that all files
+ * in an encrypted directory tree use the same encryption policy, as a
+ * protection against certain types of offline attacks.  Note that this check is
+ * needed even when opening an *unencrypted* file, since it's forbidden to have
+ * an unencrypted file in an encrypted directory.
+ *
+ * Return: 0 on success, -ENOKEY if the key is missing, or another -errno code
+ */
+int fscrypt_file_open(struct inode *inode, struct file *filp)
+{
+	int err;
+	struct dentry *dir;
+
+	err = fscrypt_require_key(inode);
+	if (err)
+		return err;
+
+	dir = dget_parent(file_dentry(filp));
+	if (IS_ENCRYPTED(d_inode(dir)) &&
+	    !fscrypt_has_permitted_context(d_inode(dir), inode)) {
+		fscrypt_warn(inode->i_sb,
+			     "inconsistent encryption contexts: %lu/%lu",
+			     d_inode(dir)->i_ino, inode->i_ino);
+		err = -EPERM;
+	}
+	dput(dir);
+	return err;
+}
+EXPORT_SYMBOL_GPL(fscrypt_file_open);
+
+int __fscrypt_prepare_link(struct inode *inode, struct inode *dir)
+{
+	int err;
+
+	err = fscrypt_require_key(dir);
+	if (err)
+		return err;
+
+	if (!fscrypt_has_permitted_context(dir, inode))
+		return -EPERM;
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(__fscrypt_prepare_link);
+
+int __fscrypt_prepare_rename(struct inode *old_dir, struct dentry *old_dentry,
+			     struct inode *new_dir, struct dentry *new_dentry,
+			     unsigned int flags)
+{
+	int err;
+
+	err = fscrypt_require_key(old_dir);
+	if (err)
+		return err;
+
+	err = fscrypt_require_key(new_dir);
+	if (err)
+		return err;
+
+	if (old_dir != new_dir) {
+		if (IS_ENCRYPTED(new_dir) &&
+		    !fscrypt_has_permitted_context(new_dir,
+						   d_inode(old_dentry)))
+			return -EPERM;
+
+		if ((flags & RENAME_EXCHANGE) &&
+		    IS_ENCRYPTED(old_dir) &&
+		    !fscrypt_has_permitted_context(old_dir,
+						   d_inode(new_dentry)))
+			return -EPERM;
+	}
+	return 0;
+}
+EXPORT_SYMBOL_GPL(__fscrypt_prepare_rename);
+
+int __fscrypt_prepare_lookup(struct inode *dir, struct dentry *dentry)
+{
+	int err = fscrypt_get_encryption_info(dir);
+
+	if (err)
+		return err;
+
+	if (fscrypt_has_encryption_key(dir)) {
+		spin_lock(&dentry->d_lock);
+		dentry->d_flags |= DCACHE_ENCRYPTED_WITH_KEY;
+		spin_unlock(&dentry->d_lock);
+	}
+
+	d_set_d_op(dentry, &fscrypt_d_ops);
+	return 0;
+}
+EXPORT_SYMBOL_GPL(__fscrypt_prepare_lookup);
+
+int __fscrypt_prepare_symlink(struct inode *dir, unsigned int len,
+			      unsigned int max_len,
+			      struct fscrypt_str *disk_link)
+{
+	int err;
+
+	/*
+	 * To calculate the size of the encrypted symlink target we need to know
+	 * the amount of NUL padding, which is determined by the flags set in
+	 * the encryption policy which will be inherited from the directory.
+	 * The easiest way to get access to this is to just load the directory's
+	 * fscrypt_info, since we'll need it to create the dir_entry anyway.
+	 *
+	 * Note: in test_dummy_encryption mode, @dir may be unencrypted.
+	 */
+	err = fscrypt_get_encryption_info(dir);
+	if (err)
+		return err;
+	if (!fscrypt_has_encryption_key(dir))
+		return -ENOKEY;
+
+	/*
+	 * Calculate the size of the encrypted symlink and verify it won't
+	 * exceed max_len.  Note that for historical reasons, encrypted symlink
+	 * targets are prefixed with the ciphertext length, despite this
+	 * actually being redundant with i_size.  This decreases by 2 bytes the
+	 * longest symlink target we can accept.
+	 *
+	 * We could recover 1 byte by not counting a null terminator, but
+	 * counting it (even though it is meaningless for ciphertext) is simpler
+	 * for now since filesystems will assume it is there and subtract it.
+	 */
+	if (!fscrypt_fname_encrypted_size(dir, len,
+					  max_len - sizeof(struct fscrypt_symlink_data),
+					  &disk_link->len))
+		return -ENAMETOOLONG;
+	disk_link->len += sizeof(struct fscrypt_symlink_data);
+
+	disk_link->name = NULL;
+	return 0;
+}
+EXPORT_SYMBOL_GPL(__fscrypt_prepare_symlink);
+
+int __fscrypt_encrypt_symlink(struct inode *inode, const char *target,
+			      unsigned int len, struct fscrypt_str *disk_link)
+{
+	int err;
+	struct qstr iname = QSTR_INIT(target, len);
+	struct fscrypt_symlink_data *sd;
+	unsigned int ciphertext_len;
+
+	err = fscrypt_require_key(inode);
+	if (err)
+		return err;
+
+	if (disk_link->name) {
+		/* filesystem-provided buffer */
+		sd = (struct fscrypt_symlink_data *)disk_link->name;
+	} else {
+		sd = kmalloc(disk_link->len, GFP_NOFS);
+		if (!sd)
+			return -ENOMEM;
+	}
+	ciphertext_len = disk_link->len - sizeof(*sd);
+	sd->len = cpu_to_le16(ciphertext_len);
+
+	err = fname_encrypt(inode, &iname, sd->encrypted_path, ciphertext_len);
+	if (err) {
+		if (!disk_link->name)
+			kfree(sd);
+		return err;
+	}
+	/*
+	 * Null-terminating the ciphertext doesn't make sense, but we still
+	 * count the null terminator in the length, so we might as well
+	 * initialize it just in case the filesystem writes it out.
+	 */
+	sd->encrypted_path[ciphertext_len] = '\0';
+
+	if (!disk_link->name)
+		disk_link->name = (unsigned char *)sd;
+	return 0;
+}
+EXPORT_SYMBOL_GPL(__fscrypt_encrypt_symlink);
+
+/**
+ * fscrypt_get_symlink - get the target of an encrypted symlink
+ * @inode: the symlink inode
+ * @caddr: the on-disk contents of the symlink
+ * @max_size: size of @caddr buffer
+ * @done: if successful, will be set up to free the returned target
+ *
+ * If the symlink's encryption key is available, we decrypt its target.
+ * Otherwise, we encode its target for presentation.
+ *
+ * This may sleep, so the filesystem must have dropped out of RCU mode already.
+ *
+ * Return: the presentable symlink target or an ERR_PTR()
+ */
+const char *fscrypt_get_symlink(struct inode *inode, const void *caddr,
+				unsigned int max_size,
+				struct delayed_call *done)
+{
+	const struct fscrypt_symlink_data *sd;
+	struct fscrypt_str cstr, pstr;
+	int err;
+
+	/* This is for encrypted symlinks only */
+	if (WARN_ON(!IS_ENCRYPTED(inode)))
+		return ERR_PTR(-EINVAL);
+
+	/*
+	 * Try to set up the symlink's encryption key, but we can continue
+	 * regardless of whether the key is available or not.
+	 */
+	err = fscrypt_get_encryption_info(inode);
+	if (err)
+		return ERR_PTR(err);
+
+	/*
+	 * For historical reasons, encrypted symlink targets are prefixed with
+	 * the ciphertext length, even though this is redundant with i_size.
+	 */
+
+	if (max_size < sizeof(*sd))
+		return ERR_PTR(-EUCLEAN);
+	sd = caddr;
+	cstr.name = (unsigned char *)sd->encrypted_path;
+	cstr.len = le16_to_cpu(sd->len);
+
+	if (cstr.len == 0)
+		return ERR_PTR(-EUCLEAN);
+
+	if (cstr.len + sizeof(*sd) - 1 > max_size)
+		return ERR_PTR(-EUCLEAN);
+
+	err = fscrypt_fname_alloc_buffer(inode, cstr.len, &pstr);
+	if (err)
+		return ERR_PTR(err);
+
+	err = fscrypt_fname_disk_to_usr(inode, 0, 0, &cstr, &pstr);
+	if (err)
+		goto err_kfree;
+
+	err = -EUCLEAN;
+	if (pstr.name[0] == '\0')
+		goto err_kfree;
+
+	pstr.name[pstr.len] = '\0';
+	set_delayed_call(done, kfree_link, pstr.name);
+	return pstr.name;
+
+err_kfree:
+	kfree(pstr.name);
+	return ERR_PTR(err);
+}
+EXPORT_SYMBOL_GPL(fscrypt_get_symlink);
diff --git a/fs/crypto/keyinfo.c b/fs/crypto/keyinfo.c
index a755fa1..70c0cca 100644
--- a/fs/crypto/keyinfo.c
+++ b/fs/crypto/keyinfo.c
@@ -10,34 +10,28 @@
 
 #include <keys/user-type.h>
 #include <linux/scatterlist.h>
-#include <linux/fscrypto.h>
+#include <linux/ratelimit.h>
+#include <crypto/aes.h>
+#include <crypto/sha.h>
+#include <crypto/skcipher.h>
+#include "fscrypt_private.h"
 
-static void derive_crypt_complete(struct crypto_async_request *req, int rc)
-{
-	struct fscrypt_completion_result *ecr = req->data;
-
-	if (rc == -EINPROGRESS)
-		return;
-
-	ecr->res = rc;
-	complete(&ecr->completion);
-}
+static struct crypto_shash *essiv_hash_tfm;
 
-/**
- * derive_key_aes() - Derive a key using AES-128-ECB
- * @deriving_key: Encryption key used for derivation.
- * @source_key:   Source key to which to apply derivation.
- * @derived_key:  Derived key.
+/*
+ * Key derivation function.  This generates the derived key by encrypting the
+ * master key with AES-128-ECB using the inode's nonce as the AES key.
  *
- * Return: Zero on success; non-zero otherwise.
+ * The master key must be at least as long as the derived key.  If the master
+ * key is longer, then only the first 'derived_keysize' bytes are used.
  */
-static int derive_key_aes(u8 deriving_key[FS_AES_128_ECB_KEY_SIZE],
-				u8 source_key[FS_AES_256_XTS_KEY_SIZE],
-				u8 derived_key[FS_AES_256_XTS_KEY_SIZE])
+static int derive_key_aes(const u8 *master_key,
+			  const struct fscrypt_context *ctx,
+			  u8 *derived_key, unsigned int derived_keysize)
 {
 	int res = 0;
 	struct skcipher_request *req = NULL;
-	DECLARE_FS_COMPLETION_RESULT(ecr);
+	DECLARE_CRYPTO_WAIT(wait);
 	struct scatterlist src_sg, dst_sg;
 	struct crypto_skcipher *tfm = crypto_alloc_skcipher("ecb(aes)", 0, 0);
 
@@ -54,116 +48,163 @@ static int derive_key_aes(u8 deriving_key[FS_AES_128_ECB_KEY_SIZE],
 	}
 	skcipher_request_set_callback(req,
 			CRYPTO_TFM_REQ_MAY_BACKLOG | CRYPTO_TFM_REQ_MAY_SLEEP,
-			derive_crypt_complete, &ecr);
-	res = crypto_skcipher_setkey(tfm, deriving_key,
-					FS_AES_128_ECB_KEY_SIZE);
+			crypto_req_done, &wait);
+	res = crypto_skcipher_setkey(tfm, ctx->nonce, sizeof(ctx->nonce));
 	if (res < 0)
 		goto out;
 
-	sg_init_one(&src_sg, source_key, FS_AES_256_XTS_KEY_SIZE);
-	sg_init_one(&dst_sg, derived_key, FS_AES_256_XTS_KEY_SIZE);
-	skcipher_request_set_crypt(req, &src_sg, &dst_sg,
-					FS_AES_256_XTS_KEY_SIZE, NULL);
-	res = crypto_skcipher_encrypt(req);
-	if (res == -EINPROGRESS || res == -EBUSY) {
-		wait_for_completion(&ecr.completion);
-		res = ecr.res;
-	}
+	sg_init_one(&src_sg, master_key, derived_keysize);
+	sg_init_one(&dst_sg, derived_key, derived_keysize);
+	skcipher_request_set_crypt(req, &src_sg, &dst_sg, derived_keysize,
+				   NULL);
+	res = crypto_wait_req(crypto_skcipher_encrypt(req), &wait);
 out:
 	skcipher_request_free(req);
 	crypto_free_skcipher(tfm);
 	return res;
 }
 
-static int validate_user_key(struct fscrypt_info *crypt_info,
-			struct fscrypt_context *ctx, u8 *raw_key,
-			u8 *prefix, int prefix_size)
+/*
+ * Search the current task's subscribed keyrings for a "logon" key with
+ * description prefix:descriptor, and if found acquire a read lock on it and
+ * return a pointer to its validated payload in *payload_ret.
+ */
+static struct key *
+find_and_lock_process_key(const char *prefix,
+			  const u8 descriptor[FS_KEY_DESCRIPTOR_SIZE],
+			  unsigned int min_keysize,
+			  const struct fscrypt_key **payload_ret)
 {
-	u8 *full_key_descriptor;
-	struct key *keyring_key;
-	struct fscrypt_key *master_key;
+	char *description;
+	struct key *key;
 	const struct user_key_payload *ukp;
-	int full_key_len = prefix_size + (FS_KEY_DESCRIPTOR_SIZE * 2) + 1;
-	int res;
+	const struct fscrypt_key *payload;
 
-	full_key_descriptor = kmalloc(full_key_len, GFP_NOFS);
-	if (!full_key_descriptor)
-		return -ENOMEM;
+	description = kasprintf(GFP_NOFS, "%s%*phN", prefix,
+				FS_KEY_DESCRIPTOR_SIZE, descriptor);
+	if (!description)
+		return ERR_PTR(-ENOMEM);
 
-	memcpy(full_key_descriptor, prefix, prefix_size);
-	sprintf(full_key_descriptor + prefix_size,
-			"%*phN", FS_KEY_DESCRIPTOR_SIZE,
-			ctx->master_key_descriptor);
-	full_key_descriptor[full_key_len - 1] = '\0';
-	keyring_key = request_key(&key_type_logon, full_key_descriptor, NULL);
-	kfree(full_key_descriptor);
-	if (IS_ERR(keyring_key))
-		return PTR_ERR(keyring_key);
-	down_read(&keyring_key->sem);
-
-	if (keyring_key->type != &key_type_logon) {
-		printk_once(KERN_WARNING
-				"%s: key type must be logon\n", __func__);
-		res = -ENOKEY;
-		goto out;
-	}
-	ukp = user_key_payload(keyring_key);
-	if (!ukp) {
-		/* key was revoked before we acquired its semaphore */
-		res = -EKEYREVOKED;
-		goto out;
-	}
-	if (ukp->datalen != sizeof(struct fscrypt_key)) {
-		res = -EINVAL;
-		goto out;
+	key = request_key(&key_type_logon, description, NULL);
+	kfree(description);
+	if (IS_ERR(key))
+		return key;
+
+	down_read(&key->sem);
+	ukp = user_key_payload_locked(key);
+
+	if (!ukp) /* was the key revoked before we acquired its semaphore? */
+		goto invalid;
+
+	payload = (const struct fscrypt_key *)ukp->data;
+
+	if (ukp->datalen != sizeof(struct fscrypt_key) ||
+	    payload->size < 1 || payload->size > FS_MAX_KEY_SIZE) {
+		fscrypt_warn(NULL,
+			     "key with description '%s' has invalid payload",
+			     key->description);
+		goto invalid;
 	}
-	master_key = (struct fscrypt_key *)ukp->data;
-	BUILD_BUG_ON(FS_AES_128_ECB_KEY_SIZE != FS_KEY_DERIVATION_NONCE_SIZE);
-
-	if (master_key->size != FS_AES_256_XTS_KEY_SIZE) {
-		printk_once(KERN_WARNING
-				"%s: key size incorrect: %d\n",
-				__func__, master_key->size);
-		res = -ENOKEY;
-		goto out;
+
+	if (payload->size < min_keysize) {
+		fscrypt_warn(NULL,
+			     "key with description '%s' is too short (got %u bytes, need %u+ bytes)",
+			     key->description, payload->size, min_keysize);
+		goto invalid;
 	}
-	res = derive_key_aes(ctx->nonce, master_key->raw, raw_key);
-out:
-	up_read(&keyring_key->sem);
-	key_put(keyring_key);
-	return res;
+
+	*payload_ret = payload;
+	return key;
+
+invalid:
+	up_read(&key->sem);
+	key_put(key);
+	return ERR_PTR(-ENOKEY);
 }
 
-static int determine_cipher_type(struct fscrypt_info *ci, struct inode *inode,
-				 const char **cipher_str_ret, int *keysize_ret)
+/* Find the master key, then derive the inode's actual encryption key */
+static int find_and_derive_key(const struct inode *inode,
+			       const struct fscrypt_context *ctx,
+			       u8 *derived_key, unsigned int derived_keysize)
 {
-	if (S_ISREG(inode->i_mode)) {
-		if (ci->ci_data_mode == FS_ENCRYPTION_MODE_AES_256_XTS) {
-			*cipher_str_ret = "xts(aes)";
-			*keysize_ret = FS_AES_256_XTS_KEY_SIZE;
-			return 0;
-		}
-		pr_warn_once("fscrypto: unsupported contents encryption mode "
-			     "%d for inode %lu\n",
-			     ci->ci_data_mode, inode->i_ino);
-		return -ENOKEY;
+	struct key *key;
+	const struct fscrypt_key *payload;
+	int err;
+
+	key = find_and_lock_process_key(FS_KEY_DESC_PREFIX,
+					ctx->master_key_descriptor,
+					derived_keysize, &payload);
+	if (key == ERR_PTR(-ENOKEY) && inode->i_sb->s_cop->key_prefix) {
+		key = find_and_lock_process_key(inode->i_sb->s_cop->key_prefix,
+						ctx->master_key_descriptor,
+						derived_keysize, &payload);
 	}
+	if (IS_ERR(key))
+		return PTR_ERR(key);
+	err = derive_key_aes(payload->raw, ctx, derived_key, derived_keysize);
+	up_read(&key->sem);
+	key_put(key);
+	return err;
+}
 
-	if (S_ISDIR(inode->i_mode) || S_ISLNK(inode->i_mode)) {
-		if (ci->ci_filename_mode == FS_ENCRYPTION_MODE_AES_256_CTS) {
-			*cipher_str_ret = "cts(cbc(aes))";
-			*keysize_ret = FS_AES_256_CTS_KEY_SIZE;
-			return 0;
-		}
-		pr_warn_once("fscrypto: unsupported filenames encryption mode "
-			     "%d for inode %lu\n",
-			     ci->ci_filename_mode, inode->i_ino);
-		return -ENOKEY;
+static struct fscrypt_mode {
+	const char *friendly_name;
+	const char *cipher_str;
+	int keysize;
+	bool logged_impl_name;
+} available_modes[] = {
+	[FS_ENCRYPTION_MODE_AES_256_XTS] = {
+		.friendly_name = "AES-256-XTS",
+		.cipher_str = "xts(aes)",
+		.keysize = 64,
+	},
+	[FS_ENCRYPTION_MODE_AES_256_CTS] = {
+		.friendly_name = "AES-256-CTS-CBC",
+		.cipher_str = "cts(cbc(aes))",
+		.keysize = 32,
+	},
+	[FS_ENCRYPTION_MODE_AES_128_CBC] = {
+		.friendly_name = "AES-128-CBC",
+		.cipher_str = "cbc(aes)",
+		.keysize = 16,
+	},
+	[FS_ENCRYPTION_MODE_AES_128_CTS] = {
+		.friendly_name = "AES-128-CTS-CBC",
+		.cipher_str = "cts(cbc(aes))",
+		.keysize = 16,
+	},
+	[FS_ENCRYPTION_MODE_SPECK128_256_XTS] = {
+		.friendly_name = "Speck128/256-XTS",
+		.cipher_str = "xts(speck128)",
+		.keysize = 64,
+	},
+	[FS_ENCRYPTION_MODE_SPECK128_256_CTS] = {
+		.friendly_name = "Speck128/256-CTS-CBC",
+		.cipher_str = "cts(cbc(speck128))",
+		.keysize = 32,
+	},
+};
+
+static struct fscrypt_mode *
+select_encryption_mode(const struct fscrypt_info *ci, const struct inode *inode)
+{
+	if (!fscrypt_valid_enc_modes(ci->ci_data_mode, ci->ci_filename_mode)) {
+		fscrypt_warn(inode->i_sb,
+			     "inode %lu uses unsupported encryption modes (contents mode %d, filenames mode %d)",
+			     inode->i_ino, ci->ci_data_mode,
+			     ci->ci_filename_mode);
+		return ERR_PTR(-EINVAL);
 	}
 
-	pr_warn_once("fscrypto: unsupported file type %d for inode %lu\n",
-		     (inode->i_mode & S_IFMT), inode->i_ino);
-	return -ENOKEY;
+	if (S_ISREG(inode->i_mode))
+		return &available_modes[ci->ci_data_mode];
+
+	if (S_ISDIR(inode->i_mode) || S_ISLNK(inode->i_mode))
+		return &available_modes[ci->ci_filename_mode];
+
+	WARN_ONCE(1, "fscrypt: filesystem tried to load encryption info for inode %lu, which is not encryptable (file type %d)\n",
+		  inode->i_ino, (inode->i_mode & S_IFMT));
+	return ERR_PTR(-EINVAL);
 }
 
 static void put_crypt_info(struct fscrypt_info *ci)
@@ -172,37 +213,104 @@ static void put_crypt_info(struct fscrypt_info *ci)
 		return;
 
 	crypto_free_skcipher(ci->ci_ctfm);
+	crypto_free_cipher(ci->ci_essiv_tfm);
 	kmem_cache_free(fscrypt_info_cachep, ci);
 }
 
+static int derive_essiv_salt(const u8 *key, int keysize, u8 *salt)
+{
+	struct crypto_shash *tfm = READ_ONCE(essiv_hash_tfm);
+
+	/* init hash transform on demand */
+	if (unlikely(!tfm)) {
+		struct crypto_shash *prev_tfm;
+
+		tfm = crypto_alloc_shash("sha256", 0, 0);
+		if (IS_ERR(tfm)) {
+			fscrypt_warn(NULL,
+				     "error allocating SHA-256 transform: %ld",
+				     PTR_ERR(tfm));
+			return PTR_ERR(tfm);
+		}
+		prev_tfm = cmpxchg(&essiv_hash_tfm, NULL, tfm);
+		if (prev_tfm) {
+			crypto_free_shash(tfm);
+			tfm = prev_tfm;
+		}
+	}
+
+	{
+		SHASH_DESC_ON_STACK(desc, tfm);
+		desc->tfm = tfm;
+		desc->flags = 0;
+
+		return crypto_shash_digest(desc, key, keysize, salt);
+	}
+}
+
+static int init_essiv_generator(struct fscrypt_info *ci, const u8 *raw_key,
+				int keysize)
+{
+	int err;
+	struct crypto_cipher *essiv_tfm;
+	u8 salt[SHA256_DIGEST_SIZE];
+
+	essiv_tfm = crypto_alloc_cipher("aes", 0, 0);
+	if (IS_ERR(essiv_tfm))
+		return PTR_ERR(essiv_tfm);
+
+	ci->ci_essiv_tfm = essiv_tfm;
+
+	err = derive_essiv_salt(raw_key, keysize, salt);
+	if (err)
+		goto out;
+
+	/*
+	 * Using SHA256 to derive the salt/key will result in AES-256 being
+	 * used for IV generation. File contents encryption will still use the
+	 * configured keysize (AES-128) nevertheless.
+	 */
+	err = crypto_cipher_setkey(essiv_tfm, salt, sizeof(salt));
+	if (err)
+		goto out;
+
+out:
+	memzero_explicit(salt, sizeof(salt));
+	return err;
+}
+
+void __exit fscrypt_essiv_cleanup(void)
+{
+	crypto_free_shash(essiv_hash_tfm);
+}
+
 int fscrypt_get_encryption_info(struct inode *inode)
 {
 	struct fscrypt_info *crypt_info;
 	struct fscrypt_context ctx;
 	struct crypto_skcipher *ctfm;
-	const char *cipher_str;
-	int keysize;
+	struct fscrypt_mode *mode;
 	u8 *raw_key = NULL;
 	int res;
 
 	if (inode->i_crypt_info)
 		return 0;
 
-	res = fscrypt_initialize();
+	res = fscrypt_initialize(inode->i_sb->s_cop->flags);
 	if (res)
 		return res;
 
-	if (!inode->i_sb->s_cop->get_context)
-		return -EOPNOTSUPP;
-
 	res = inode->i_sb->s_cop->get_context(inode, &ctx, sizeof(ctx));
 	if (res < 0) {
-		if (!fscrypt_dummy_context_enabled(inode))
+		if (!fscrypt_dummy_context_enabled(inode) ||
+		    IS_ENCRYPTED(inode))
 			return res;
+		/* Fake up a context for an unencrypted directory */
+		memset(&ctx, 0, sizeof(ctx));
 		ctx.format = FS_ENCRYPTION_CONTEXT_FORMAT_V1;
 		ctx.contents_encryption_mode = FS_ENCRYPTION_MODE_AES_256_XTS;
 		ctx.filenames_encryption_mode = FS_ENCRYPTION_MODE_AES_256_CTS;
-		ctx.flags = 0;
+		memset(ctx.master_key_descriptor, 0x42, FS_KEY_DESCRIPTOR_SIZE);
 	} else if (res != sizeof(ctx)) {
 		return -EINVAL;
 	}
@@ -221,60 +329,66 @@ int fscrypt_get_encryption_info(struct inode *inode)
 	crypt_info->ci_data_mode = ctx.contents_encryption_mode;
 	crypt_info->ci_filename_mode = ctx.filenames_encryption_mode;
 	crypt_info->ci_ctfm = NULL;
+	crypt_info->ci_essiv_tfm = NULL;
 	memcpy(crypt_info->ci_master_key, ctx.master_key_descriptor,
 				sizeof(crypt_info->ci_master_key));
 
-	res = determine_cipher_type(crypt_info, inode, &cipher_str, &keysize);
-	if (res)
+	mode = select_encryption_mode(crypt_info, inode);
+	if (IS_ERR(mode)) {
+		res = PTR_ERR(mode);
 		goto out;
+	}
 
 	/*
 	 * This cannot be a stack buffer because it is passed to the scatterlist
 	 * crypto API as part of key derivation.
 	 */
 	res = -ENOMEM;
-	raw_key = kmalloc(FS_MAX_KEY_SIZE, GFP_NOFS);
+	raw_key = kmalloc(mode->keysize, GFP_NOFS);
 	if (!raw_key)
 		goto out;
 
-	if (fscrypt_dummy_context_enabled(inode)) {
-		memset(raw_key, 0x42, FS_AES_256_XTS_KEY_SIZE);
-		goto got_key;
-	}
+	res = find_and_derive_key(inode, &ctx, raw_key, mode->keysize);
+	if (res)
+		goto out;
 
-	res = validate_user_key(crypt_info, &ctx, raw_key,
-			FS_KEY_DESC_PREFIX, FS_KEY_DESC_PREFIX_SIZE);
-	if (res && inode->i_sb->s_cop->key_prefix) {
-		u8 *prefix = NULL;
-		int prefix_size, res2;
-
-		prefix_size = inode->i_sb->s_cop->key_prefix(inode, &prefix);
-		res2 = validate_user_key(crypt_info, &ctx, raw_key,
-							prefix, prefix_size);
-		if (res2) {
-			if (res2 == -ENOKEY)
-				res = -ENOKEY;
-			goto out;
-		}
-	} else if (res) {
+	ctfm = crypto_alloc_skcipher(mode->cipher_str, 0, 0);
+	if (IS_ERR(ctfm)) {
+		res = PTR_ERR(ctfm);
+		fscrypt_warn(inode->i_sb,
+			     "error allocating '%s' transform for inode %lu: %d",
+			     mode->cipher_str, inode->i_ino, res);
 		goto out;
 	}
-got_key:
-	ctfm = crypto_alloc_skcipher(cipher_str, 0, 0);
-	if (!ctfm || IS_ERR(ctfm)) {
-		res = ctfm ? PTR_ERR(ctfm) : -ENOMEM;
-		printk(KERN_DEBUG
-		       "%s: error %d (inode %u) allocating crypto tfm\n",
-		       __func__, res, (unsigned) inode->i_ino);
-		goto out;
+	if (unlikely(!mode->logged_impl_name)) {
+		/*
+		 * fscrypt performance can vary greatly depending on which
+		 * crypto algorithm implementation is used.  Help people debug
+		 * performance problems by logging the ->cra_driver_name the
+		 * first time a mode is used.  Note that multiple threads can
+		 * race here, but it doesn't really matter.
+		 */
+		mode->logged_impl_name = true;
+		pr_info("fscrypt: %s using implementation \"%s\"\n",
+			mode->friendly_name,
+			crypto_skcipher_alg(ctfm)->base.cra_driver_name);
 	}
 	crypt_info->ci_ctfm = ctfm;
-	crypto_skcipher_clear_flags(ctfm, ~0);
 	crypto_skcipher_set_flags(ctfm, CRYPTO_TFM_REQ_WEAK_KEY);
-	res = crypto_skcipher_setkey(ctfm, raw_key, keysize);
+	res = crypto_skcipher_setkey(ctfm, raw_key, mode->keysize);
 	if (res)
 		goto out;
 
+	if (S_ISREG(inode->i_mode) &&
+	    crypt_info->ci_data_mode == FS_ENCRYPTION_MODE_AES_128_CBC) {
+		res = init_essiv_generator(crypt_info, raw_key, mode->keysize);
+		if (res) {
+			fscrypt_warn(inode->i_sb,
+				     "error initializing ESSIV generator for inode %lu: %d",
+				     inode->i_ino, res);
+			goto out;
+		}
+	}
 	if (cmpxchg(&inode->i_crypt_info, NULL, crypt_info) == NULL)
 		crypt_info = NULL;
 out:
@@ -286,19 +400,9 @@ int fscrypt_get_encryption_info(struct inode *inode)
 }
 EXPORT_SYMBOL(fscrypt_get_encryption_info);
 
-void fscrypt_put_encryption_info(struct inode *inode, struct fscrypt_info *ci)
+void fscrypt_put_encryption_info(struct inode *inode)
 {
-	struct fscrypt_info *prev;
-
-	if (ci == NULL)
-		ci = ACCESS_ONCE(inode->i_crypt_info);
-	if (ci == NULL)
-		return;
-
-	prev = cmpxchg(&inode->i_crypt_info, ci, NULL);
-	if (prev != ci)
-		return;
-
-	put_crypt_info(ci);
+	put_crypt_info(inode->i_crypt_info);
+	inode->i_crypt_info = NULL;
 }
 EXPORT_SYMBOL(fscrypt_put_encryption_info);
diff --git a/fs/crypto/policy.c b/fs/crypto/policy.c
index c160d2d..2f2c53f 100644
--- a/fs/crypto/policy.c
+++ b/fs/crypto/policy.c
@@ -10,76 +10,37 @@
 
 #include <linux/random.h>
 #include <linux/string.h>
-#include <linux/fscrypto.h>
 #include <linux/mount.h>
-
-static int inode_has_encryption_context(struct inode *inode)
-{
-	if (!inode->i_sb->s_cop->get_context)
-		return 0;
-	return (inode->i_sb->s_cop->get_context(inode, NULL, 0L) > 0);
-}
+#include "fscrypt_private.h"
 
 /*
- * check whether the policy is consistent with the encryption context
- * for the inode
+ * check whether an encryption policy is consistent with an encryption context
  */
-static int is_encryption_context_consistent_with_policy(struct inode *inode,
+static bool is_encryption_context_consistent_with_policy(
+				const struct fscrypt_context *ctx,
 				const struct fscrypt_policy *policy)
 {
-	struct fscrypt_context ctx;
-	int res;
-
-	if (!inode->i_sb->s_cop->get_context)
-		return 0;
-
-	res = inode->i_sb->s_cop->get_context(inode, &ctx, sizeof(ctx));
-	if (res != sizeof(ctx))
-		return 0;
-
-	return (memcmp(ctx.master_key_descriptor, policy->master_key_descriptor,
-			FS_KEY_DESCRIPTOR_SIZE) == 0 &&
-			(ctx.flags == policy->flags) &&
-			(ctx.contents_encryption_mode ==
-			 policy->contents_encryption_mode) &&
-			(ctx.filenames_encryption_mode ==
-			 policy->filenames_encryption_mode));
+	return memcmp(ctx->master_key_descriptor, policy->master_key_descriptor,
+		      FS_KEY_DESCRIPTOR_SIZE) == 0 &&
+		(ctx->flags == policy->flags) &&
+		(ctx->contents_encryption_mode ==
+		 policy->contents_encryption_mode) &&
+		(ctx->filenames_encryption_mode ==
+		 policy->filenames_encryption_mode);
 }
 
 static int create_encryption_context_from_policy(struct inode *inode,
 				const struct fscrypt_policy *policy)
 {
 	struct fscrypt_context ctx;
-	int res;
-
-	if (!inode->i_sb->s_cop->set_context)
-		return -EOPNOTSUPP;
-
-	if (inode->i_sb->s_cop->prepare_context) {
-		res = inode->i_sb->s_cop->prepare_context(inode);
-		if (res)
-			return res;
-	}
 
 	ctx.format = FS_ENCRYPTION_CONTEXT_FORMAT_V1;
 	memcpy(ctx.master_key_descriptor, policy->master_key_descriptor,
 					FS_KEY_DESCRIPTOR_SIZE);
 
-	if (!fscrypt_valid_contents_enc_mode(
-				policy->contents_encryption_mode)) {
-		printk(KERN_WARNING
-		       "%s: Invalid contents encryption mode %d\n", __func__,
-			policy->contents_encryption_mode);
-		return -EINVAL;
-	}
-
-	if (!fscrypt_valid_filenames_enc_mode(
-				policy->filenames_encryption_mode)) {
-		printk(KERN_WARNING
-			"%s: Invalid filenames encryption mode %d\n", __func__,
-			policy->filenames_encryption_mode);
+	if (!fscrypt_valid_enc_modes(policy->contents_encryption_mode,
+				     policy->filenames_encryption_mode))
 		return -EINVAL;
-	}
 
 	if (policy->flags & ~FS_POLICY_FLAGS_VALID)
 		return -EINVAL;
@@ -93,16 +54,20 @@ static int create_encryption_context_from_policy(struct inode *inode,
 	return inode->i_sb->s_cop->set_context(inode, &ctx, sizeof(ctx), NULL);
 }
 
-int fscrypt_process_policy(struct file *filp,
-				const struct fscrypt_policy *policy)
+int fscrypt_ioctl_set_policy(struct file *filp, const void __user *arg)
 {
+	struct fscrypt_policy policy;
 	struct inode *inode = file_inode(filp);
 	int ret;
+	struct fscrypt_context ctx;
+
+	if (copy_from_user(&policy, arg, sizeof(policy)))
+		return -EFAULT;
 
 	if (!inode_owner_or_capable(inode))
 		return -EACCES;
 
-	if (policy->version != 0)
+	if (policy.version != 0)
 		return -EINVAL;
 
 	ret = mnt_want_write_file(filp);
@@ -111,22 +76,23 @@ int fscrypt_process_policy(struct file *filp,
 
 	inode_lock(inode);
 
-	if (!inode_has_encryption_context(inode)) {
+	ret = inode->i_sb->s_cop->get_context(inode, &ctx, sizeof(ctx));
+	if (ret == -ENODATA) {
 		if (!S_ISDIR(inode->i_mode))
 			ret = -ENOTDIR;
-		else if (!inode->i_sb->s_cop->empty_dir)
-			ret = -EOPNOTSUPP;
 		else if (!inode->i_sb->s_cop->empty_dir(inode))
 			ret = -ENOTEMPTY;
 		else
 			ret = create_encryption_context_from_policy(inode,
-								    policy);
-	} else if (!is_encryption_context_consistent_with_policy(inode,
-								 policy)) {
-		printk(KERN_WARNING
-		       "%s: Policy inconsistent with encryption context\n",
-		       __func__);
-		ret = -EINVAL;
+								    &policy);
+	} else if (ret == sizeof(ctx) &&
+		   is_encryption_context_consistent_with_policy(&ctx,
+								&policy)) {
+		/* The file already uses the same encryption policy. */
+		ret = 0;
+	} else if (ret >= 0 || ret == -ERANGE) {
+		/* The file already uses a different encryption policy. */
+		ret = -EEXIST;
 	}
 
 	inode_unlock(inode);
@@ -134,32 +100,38 @@ int fscrypt_process_policy(struct file *filp,
 	mnt_drop_write_file(filp);
 	return ret;
 }
-EXPORT_SYMBOL(fscrypt_process_policy);
+EXPORT_SYMBOL(fscrypt_ioctl_set_policy);
 
-int fscrypt_get_policy(struct inode *inode, struct fscrypt_policy *policy)
+int fscrypt_ioctl_get_policy(struct file *filp, void __user *arg)
 {
+	struct inode *inode = file_inode(filp);
 	struct fscrypt_context ctx;
+	struct fscrypt_policy policy;
 	int res;
 
-	if (!inode->i_sb->s_cop->get_context ||
-			!inode->i_sb->s_cop->is_encrypted(inode))
+	if (!IS_ENCRYPTED(inode))
 		return -ENODATA;
 
 	res = inode->i_sb->s_cop->get_context(inode, &ctx, sizeof(ctx));
+	if (res < 0 && res != -ERANGE)
+		return res;
 	if (res != sizeof(ctx))
-		return -ENODATA;
+		return -EINVAL;
 	if (ctx.format != FS_ENCRYPTION_CONTEXT_FORMAT_V1)
 		return -EINVAL;
 
-	policy->version = 0;
-	policy->contents_encryption_mode = ctx.contents_encryption_mode;
-	policy->filenames_encryption_mode = ctx.filenames_encryption_mode;
-	policy->flags = ctx.flags;
-	memcpy(&policy->master_key_descriptor, ctx.master_key_descriptor,
+	policy.version = 0;
+	policy.contents_encryption_mode = ctx.contents_encryption_mode;
+	policy.filenames_encryption_mode = ctx.filenames_encryption_mode;
+	policy.flags = ctx.flags;
+	memcpy(policy.master_key_descriptor, ctx.master_key_descriptor,
 				FS_KEY_DESCRIPTOR_SIZE);
+
+	if (copy_to_user(arg, &policy, sizeof(policy)))
+		return -EFAULT;
 	return 0;
 }
-EXPORT_SYMBOL(fscrypt_get_policy);
+EXPORT_SYMBOL(fscrypt_ioctl_get_policy);
 
 /**
  * fscrypt_has_permitted_context() - is a file's encryption policy permitted
@@ -194,11 +166,11 @@ int fscrypt_has_permitted_context(struct inode *parent, struct inode *child)
 		return 1;
 
 	/* No restrictions if the parent directory is unencrypted */
-	if (!cops->is_encrypted(parent))
+	if (!IS_ENCRYPTED(parent))
 		return 1;
 
 	/* Encrypted directories must not contain unencrypted files */
-	if (!cops->is_encrypted(child))
+	if (!IS_ENCRYPTED(child))
 		return 0;
 
 	/*
@@ -258,9 +230,9 @@ int fscrypt_has_permitted_context(struct inode *parent, struct inode *child)
  * @parent: Parent inode from which the context is inherited.
  * @child:  Child inode that inherits the context from @parent.
  * @fs_data:  private data given by FS.
- * @preload:  preload child i_crypt_info
+ * @preload:  preload child i_crypt_info if true
  *
- * Return: Zero on success, non-zero otherwise
+ * Return: 0 on success, -errno on failure
  */
 int fscrypt_inherit_context(struct inode *parent, struct inode *child,
 						void *fs_data, bool preload)
@@ -269,9 +241,6 @@ int fscrypt_inherit_context(struct inode *parent, struct inode *child,
 	struct fscrypt_info *ci;
 	int res;
 
-	if (!parent->i_sb->s_cop->set_context)
-		return -EOPNOTSUPP;
-
 	res = fscrypt_get_encryption_info(parent);
 	if (res < 0)
 		return res;
@@ -281,19 +250,11 @@ int fscrypt_inherit_context(struct inode *parent, struct inode *child,
 		return -ENOKEY;
 
 	ctx.format = FS_ENCRYPTION_CONTEXT_FORMAT_V1;
-	if (fscrypt_dummy_context_enabled(parent)) {
-		ctx.contents_encryption_mode = FS_ENCRYPTION_MODE_AES_256_XTS;
-		ctx.filenames_encryption_mode = FS_ENCRYPTION_MODE_AES_256_CTS;
-		ctx.flags = 0;
-		memset(ctx.master_key_descriptor, 0x42, FS_KEY_DESCRIPTOR_SIZE);
-		res = 0;
-	} else {
-		ctx.contents_encryption_mode = ci->ci_data_mode;
-		ctx.filenames_encryption_mode = ci->ci_filename_mode;
-		ctx.flags = ci->ci_flags;
-		memcpy(ctx.master_key_descriptor, ci->ci_master_key,
-				FS_KEY_DESCRIPTOR_SIZE);
-	}
+	ctx.contents_encryption_mode = ci->ci_data_mode;
+	ctx.filenames_encryption_mode = ci->ci_filename_mode;
+	ctx.flags = ci->ci_flags;
+	memcpy(ctx.master_key_descriptor, ci->ci_master_key,
+	       FS_KEY_DESCRIPTOR_SIZE);
 	get_random_bytes(ctx.nonce, FS_KEY_DERIVATION_NONCE_SIZE);
 	res = parent->i_sb->s_cop->set_context(child, &ctx,
 						sizeof(ctx), fs_data);
diff --git a/fs/dcache.c b/fs/dcache.c
index 7a5e6f9..5ff9b41 100644
--- a/fs/dcache.c
+++ b/fs/dcache.c
@@ -3257,6 +3257,7 @@ char *d_absolute_path(const struct path *path,
 		return ERR_PTR(error);
 	return res;
 }
+EXPORT_SYMBOL(d_absolute_path);
 
 /*
  * same as __d_path but appends "(deleted)" for unlinked files.
diff --git a/fs/ecryptfs/ecryptfs_kernel.h b/fs/ecryptfs/ecryptfs_kernel.h
index a896e46..d4d8ad1 100644
--- a/fs/ecryptfs/ecryptfs_kernel.h
+++ b/fs/ecryptfs/ecryptfs_kernel.h
@@ -125,7 +125,7 @@ static inline struct key *ecryptfs_get_encrypted_key(char *sig)
 	if (auth_tok)
 		return auth_tok;
 
-	ukp = user_key_payload(key);
+	ukp = user_key_payload_locked(key);
 	if (!ukp)
 		return ERR_PTR(-EKEYREVOKED);
 
diff --git a/fs/eventpoll.c b/fs/eventpoll.c
index 3cbc304..5b96ba7 100644
--- a/fs/eventpoll.c
+++ b/fs/eventpoll.c
@@ -34,6 +34,7 @@
 #include <linux/mutex.h>
 #include <linux/anon_inodes.h>
 #include <linux/device.h>
+#include <linux/freezer.h>
 #include <asm/uaccess.h>
 #include <asm/io.h>
 #include <asm/mman.h>
@@ -1673,7 +1674,8 @@ static int ep_poll(struct eventpoll *ep, struct epoll_event __user *events,
 			}
 
 			spin_unlock_irqrestore(&ep->lock, flags);
-			if (!schedule_hrtimeout_range(to, slack, HRTIMER_MODE_ABS))
+			if (!freezable_schedule_hrtimeout_range(to, slack,
+								HRTIMER_MODE_ABS))
 				timed_out = 1;
 
 			spin_lock_irqsave(&ep->lock, flags);
diff --git a/fs/exec.c b/fs/exec.c
index fcd8642e..df13a19 100644
--- a/fs/exec.c
+++ b/fs/exec.c
@@ -1303,7 +1303,7 @@ int flush_old_exec(struct linux_binprm * bprm)
 void would_dump(struct linux_binprm *bprm, struct file *file)
 {
 	struct inode *inode = file_inode(file);
-	if (inode_permission(inode, MAY_READ) < 0) {
+	if (inode_permission2(file->f_path.mnt, inode, MAY_READ) < 0) {
 		struct user_namespace *old, *user_ns;
 		bprm->interp_flags |= BINPRM_FLAGS_ENFORCE_NONDUMP;
 
diff --git a/fs/exofs/inode.c b/fs/exofs/inode.c
index d8072bc..7f5b735 100644
--- a/fs/exofs/inode.c
+++ b/fs/exofs/inode.c
@@ -377,9 +377,8 @@ static int read_exec(struct page_collect *pcol)
  * and will start a new collection. Eventually caller must submit the last
  * segment if present.
  */
-static int readpage_strip(void *data, struct page *page)
+static int __readpage_strip(struct page_collect *pcol, struct page *page)
 {
-	struct page_collect *pcol = data;
 	struct inode *inode = pcol->inode;
 	struct exofs_i_info *oi = exofs_i(inode);
 	loff_t i_size = i_size_read(inode);
@@ -470,6 +469,13 @@ static int readpage_strip(void *data, struct page *page)
 	return ret;
 }
 
+static int readpage_strip(struct file *data, struct page *page)
+{
+	struct page_collect *pcol = (struct page_collect *)data;
+
+	return __readpage_strip(pcol, page);
+}
+
 static int exofs_readpages(struct file *file, struct address_space *mapping,
 			   struct list_head *pages, unsigned nr_pages)
 {
@@ -499,7 +505,7 @@ static int _readpage(struct page *page, bool read_4_write)
 	_pcol_init(&pcol, 1, page->mapping->host);
 
 	pcol.read_4_write = read_4_write;
-	ret = readpage_strip(&pcol, page);
+	ret = __readpage_strip(&pcol, page);
 	if (ret) {
 		EXOFS_ERR("_readpage => %d\n", ret);
 		return ret;
diff --git a/fs/ext4/ext4.h b/fs/ext4/ext4.h
index 43e27d8..0647538 100644
--- a/fs/ext4/ext4.h
+++ b/fs/ext4/ext4.h
@@ -32,13 +32,15 @@
 #include <linux/percpu_counter.h>
 #include <linux/ratelimit.h>
 #include <crypto/hash.h>
-#include <linux/fscrypto.h>
 #include <linux/falloc.h>
 #include <linux/percpu-rwsem.h>
 #ifdef __KERNEL__
 #include <linux/compat.h>
 #endif
 
+#define __FS_HAS_ENCRYPTION IS_ENABLED(CONFIG_EXT4_FS_ENCRYPTION)
+#include <linux/fscrypt.h>
+
 /*
  * The fourth extended filesystem constants/structures
  */
@@ -1342,11 +1344,6 @@ struct ext4_super_block {
 /* Number of quota types we support */
 #define EXT4_MAXQUOTAS 3
 
-#ifdef CONFIG_EXT4_FS_ENCRYPTION
-#define EXT4_KEY_DESC_PREFIX "ext4:"
-#define EXT4_KEY_DESC_PREFIX_SIZE 5
-#endif
-
 /*
  * fourth extended-fs super-block data in memory
  */
@@ -1516,12 +1513,6 @@ struct ext4_sb_info {
 
 	/* Barrier between changing inodes' journal flags and writepages ops. */
 	struct percpu_rw_semaphore s_journal_flag_rwsem;
-
-	/* Encryption support */
-#ifdef CONFIG_EXT4_FS_ENCRYPTION
-	u8 key_prefix[EXT4_KEY_DESC_PREFIX_SIZE];
-	u8 key_prefix_size;
-#endif
 };
 
 static inline struct ext4_sb_info *EXT4_SB(struct super_block *sb)
@@ -2272,11 +2263,6 @@ extern unsigned ext4_free_clusters_after_init(struct super_block *sb,
 					      struct ext4_group_desc *gdp);
 ext4_fsblk_t ext4_inode_to_goal_block(struct inode *);
 
-static inline int ext4_sb_has_crypto(struct super_block *sb)
-{
-	return ext4_has_feature_encrypt(sb);
-}
-
 static inline bool ext4_encrypted_inode(struct inode *inode)
 {
 	return ext4_test_inode_flag(inode, EXT4_INODE_ENCRYPT);
@@ -2325,28 +2311,6 @@ static inline int ext4_fname_setup_filename(struct inode *dir,
 }
 static inline void ext4_fname_free_filename(struct ext4_filename *fname) { }
 
-#define fscrypt_set_d_op(i)
-#define fscrypt_get_ctx			fscrypt_notsupp_get_ctx
-#define fscrypt_release_ctx		fscrypt_notsupp_release_ctx
-#define fscrypt_encrypt_page		fscrypt_notsupp_encrypt_page
-#define fscrypt_decrypt_page		fscrypt_notsupp_decrypt_page
-#define fscrypt_decrypt_bio_pages	fscrypt_notsupp_decrypt_bio_pages
-#define fscrypt_pullback_bio_page	fscrypt_notsupp_pullback_bio_page
-#define fscrypt_restore_control_page	fscrypt_notsupp_restore_control_page
-#define fscrypt_zeroout_range		fscrypt_notsupp_zeroout_range
-#define fscrypt_process_policy		fscrypt_notsupp_process_policy
-#define fscrypt_get_policy		fscrypt_notsupp_get_policy
-#define fscrypt_has_permitted_context	fscrypt_notsupp_has_permitted_context
-#define fscrypt_inherit_context		fscrypt_notsupp_inherit_context
-#define fscrypt_get_encryption_info	fscrypt_notsupp_get_encryption_info
-#define fscrypt_put_encryption_info	fscrypt_notsupp_put_encryption_info
-#define fscrypt_setup_filename		fscrypt_notsupp_setup_filename
-#define fscrypt_free_filename		fscrypt_notsupp_free_filename
-#define fscrypt_fname_encrypted_size	fscrypt_notsupp_fname_encrypted_size
-#define fscrypt_fname_alloc_buffer	fscrypt_notsupp_fname_alloc_buffer
-#define fscrypt_fname_free_buffer	fscrypt_notsupp_fname_free_buffer
-#define fscrypt_fname_disk_to_usr	fscrypt_notsupp_fname_disk_to_usr
-#define fscrypt_fname_usr_to_disk	fscrypt_notsupp_fname_usr_to_disk
 #endif
 
 /* dir.c */
@@ -2368,17 +2332,16 @@ extern int ext4_find_dest_de(struct inode *dir, struct inode *inode,
 			     void *buf, int buf_size,
 			     struct ext4_filename *fname,
 			     struct ext4_dir_entry_2 **dest_de);
-int ext4_insert_dentry(struct inode *dir,
-		       struct inode *inode,
-		       struct ext4_dir_entry_2 *de,
-		       int buf_size,
-		       struct ext4_filename *fname);
+void ext4_insert_dentry(struct inode *inode,
+			struct ext4_dir_entry_2 *de,
+			int buf_size,
+			struct ext4_filename *fname);
 static inline void ext4_update_dx_flag(struct inode *inode)
 {
 	if (!ext4_has_feature_dir_index(inode->i_sb))
 		ext4_clear_inode_flag(inode, EXT4_INODE_INDEX);
 }
-static unsigned char ext4_filetype_table[] = {
+static const unsigned char ext4_filetype_table[] = {
 	DT_UNKNOWN, DT_REG, DT_DIR, DT_CHR, DT_BLK, DT_FIFO, DT_SOCK, DT_LNK
 };
 
@@ -2445,7 +2408,8 @@ extern int ext4_mb_add_groupinfo(struct super_block *sb,
 		ext4_group_t i, struct ext4_group_desc *desc);
 extern int ext4_group_add_blocks(handle_t *handle, struct super_block *sb,
 				ext4_fsblk_t block, unsigned long count);
-extern int ext4_trim_fs(struct super_block *, struct fstrim_range *);
+extern int ext4_trim_fs(struct super_block *, struct fstrim_range *,
+				unsigned long blkdev_flags);
 
 /* inode.c */
 int ext4_inode_is_fast_symlink(struct inode *inode);
@@ -3065,7 +3029,7 @@ extern int ext4_handle_dirty_dirent_node(handle_t *handle,
 					 struct inode *inode,
 					 struct buffer_head *bh);
 #define S_SHIFT 12
-static unsigned char ext4_type_by_mode[S_IFMT >> S_SHIFT] = {
+static const unsigned char ext4_type_by_mode[S_IFMT >> S_SHIFT] = {
 	[S_IFREG >> S_SHIFT]	= EXT4_FT_REG_FILE,
 	[S_IFDIR >> S_SHIFT]	= EXT4_FT_DIR,
 	[S_IFCHR >> S_SHIFT]	= EXT4_FT_CHRDEV,
diff --git a/fs/ext4/ialloc.c b/fs/ext4/ialloc.c
index ffaf66a..004c088 100644
--- a/fs/ext4/ialloc.c
+++ b/fs/ext4/ialloc.c
@@ -1072,6 +1072,17 @@ struct inode *__ext4_new_inode(handle_t *handle, struct inode *dir,
 	if (err)
 		goto fail_drop;
 
+	/*
+	 * Since the encryption xattr will always be unique, create it first so
+	 * that it's less likely to end up in an external xattr block and
+	 * prevent its deduplication.
+	 */
+	if (encrypt) {
+		err = fscrypt_inherit_context(dir, inode, handle, true);
+		if (err)
+			goto fail_free_drop;
+	}
+
 	err = ext4_init_acl(handle, inode, dir);
 	if (err)
 		goto fail_free_drop;
@@ -1093,13 +1104,6 @@ struct inode *__ext4_new_inode(handle_t *handle, struct inode *dir,
 		ei->i_datasync_tid = handle->h_transaction->t_tid;
 	}
 
-	if (encrypt) {
-		/* give pointer to avoid set_context with journal ops. */
-		err = fscrypt_inherit_context(dir, inode, &encrypt, true);
-		if (err)
-			goto fail_free_drop;
-	}
-
 	err = ext4_mark_inode_dirty(handle, inode);
 	if (err) {
 		ext4_std_error(sb, err);
@@ -1316,7 +1320,10 @@ int ext4_init_inode_table(struct super_block *sb, ext4_group_t group,
 			    ext4_itable_unused_count(sb, gdp)),
 			    sbi->s_inodes_per_block);
 
-	if ((used_blks < 0) || (used_blks > sbi->s_itb_per_group)) {
+	if ((used_blks < 0) || (used_blks > sbi->s_itb_per_group) ||
+	    ((group == 0) && ((EXT4_INODES_PER_GROUP(sb) -
+			       ext4_itable_unused_count(sb, gdp)) <
+			      EXT4_FIRST_INO(sb)))) {
 		ext4_error(sb, "Something is wrong with group %u: "
 			   "used itable blocks: %d; "
 			   "itable unused count: %u",
diff --git a/fs/ext4/inline.c b/fs/ext4/inline.c
index 436baf7..74e831f 100644
--- a/fs/ext4/inline.c
+++ b/fs/ext4/inline.c
@@ -18,6 +18,7 @@
 #include "ext4.h"
 #include "xattr.h"
 #include "truncate.h"
+#include <trace/events/android_fs.h>
 
 #define EXT4_XATTR_SYSTEM_DATA	"data"
 #define EXT4_MIN_INLINE_DATA_SIZE	((sizeof(__le32) * EXT4_N_BLOCKS))
@@ -502,6 +503,17 @@ int ext4_readpage_inline(struct inode *inode, struct page *page)
 		return -EAGAIN;
 	}
 
+	if (trace_android_fs_dataread_start_enabled()) {
+		char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+		path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    inode);
+		trace_android_fs_dataread_start(inode, page_offset(page),
+						PAGE_SIZE, current->pid,
+						path, current->comm);
+	}
+
 	/*
 	 * Current inline data can only exist in the 1st page,
 	 * So for all the other pages, just set them uptodate.
@@ -513,6 +525,8 @@ int ext4_readpage_inline(struct inode *inode, struct page *page)
 		SetPageUptodate(page);
 	}
 
+	trace_android_fs_dataread_end(inode, page_offset(page), PAGE_SIZE);
+
 	up_read(&EXT4_I(inode)->xattr_sem);
 
 	unlock_page(page);
@@ -1025,7 +1039,7 @@ static int ext4_add_dirent_to_inline(handle_t *handle,
 	err = ext4_journal_get_write_access(handle, iloc->bh);
 	if (err)
 		return err;
-	ext4_insert_dentry(dir, inode, de, inline_size, fname);
+	ext4_insert_dentry(inode, de, inline_size, fname);
 
 	ext4_show_inline_dir(dir, iloc->bh, inline_start, inline_size);
 
diff --git a/fs/ext4/inode.c b/fs/ext4/inode.c
index f62eca8..ba50c10 100644
--- a/fs/ext4/inode.c
+++ b/fs/ext4/inode.c
@@ -44,6 +44,7 @@
 #include "truncate.h"
 
 #include <trace/events/ext4.h>
+#include <trace/events/android_fs.h>
 
 #define MPAGE_DA_EXTENT_TAIL 0x01
 
@@ -1165,7 +1166,8 @@ static int ext4_block_write_begin(struct page *page, loff_t pos, unsigned len,
 	if (unlikely(err))
 		page_zero_new_buffers(page, from, to);
 	else if (decrypt)
-		err = fscrypt_decrypt_page(page);
+		err = fscrypt_decrypt_page(page->mapping->host, page,
+				PAGE_SIZE, 0, page->index);
 	return err;
 }
 #endif
@@ -1182,6 +1184,16 @@ static int ext4_write_begin(struct file *file, struct address_space *mapping,
 	pgoff_t index;
 	unsigned from, to;
 
+	if (trace_android_fs_datawrite_start_enabled()) {
+		char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+		path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    inode);
+		trace_android_fs_datawrite_start(inode, pos, len,
+						 current->pid, path,
+						 current->comm);
+	}
 	trace_ext4_write_begin(inode, pos, len, flags);
 	/*
 	 * Reserve one block more for addition to orphan list in case
@@ -1320,6 +1332,7 @@ static int ext4_write_end(struct file *file,
 	int i_size_changed = 0;
 	int inline_data = ext4_has_inline_data(inode);
 
+	trace_android_fs_datawrite_end(inode, pos, len);
 	trace_ext4_write_end(inode, pos, len, copied);
 	if (inline_data) {
 		ret = ext4_write_inline_data_end(inode, pos, len,
@@ -1425,6 +1438,7 @@ static int ext4_journalled_write_end(struct file *file,
 	int size_changed = 0;
 	int inline_data = ext4_has_inline_data(inode);
 
+	trace_android_fs_datawrite_end(inode, pos, len);
 	trace_ext4_journalled_write_end(inode, pos, len, copied);
 	from = pos & (PAGE_SIZE - 1);
 	to = from + len;
@@ -2553,8 +2567,8 @@ static int mpage_prepare_extent_to_map(struct mpage_da_data *mpd)
 	mpd->map.m_len = 0;
 	mpd->next_page = index;
 	while (index <= end) {
-		nr_pages = pagevec_lookup_tag(&pvec, mapping, &index, tag,
-			      min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1);
+		nr_pages = pagevec_lookup_range_tag(&pvec, mapping, &index, end,
+				tag);
 		if (nr_pages == 0)
 			goto out;
 
@@ -2562,16 +2576,6 @@ static int mpage_prepare_extent_to_map(struct mpage_da_data *mpd)
 			struct page *page = pvec.pages[i];
 
 			/*
-			 * At this point, the page may be truncated or
-			 * invalidated (changing page->mapping to NULL), or
-			 * even swizzled back from swapper_space to tmpfs file
-			 * mapping. However, page->index will not change
-			 * because we have a reference on the page.
-			 */
-			if (page->index > end)
-				goto out;
-
-			/*
 			 * Accumulated enough dirty pages? This doesn't apply
 			 * to WB_SYNC_ALL mode. For integrity sync we have to
 			 * keep going because someone may be concurrently
@@ -2921,6 +2925,16 @@ static int ext4_da_write_begin(struct file *file, struct address_space *mapping,
 					len, flags, pagep, fsdata);
 	}
 	*fsdata = (void *)0;
+	if (trace_android_fs_datawrite_start_enabled()) {
+		char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+		path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    inode);
+		trace_android_fs_datawrite_start(inode, pos, len,
+						 current->pid,
+						 path, current->comm);
+	}
 	trace_ext4_da_write_begin(inode, pos, len, flags);
 
 	if (ext4_test_inode_state(inode, EXT4_STATE_MAY_INLINE_DATA)) {
@@ -3039,6 +3053,7 @@ static int ext4_da_write_end(struct file *file,
 		return ext4_write_end(file, mapping, pos,
 				      len, copied, page, fsdata);
 
+	trace_android_fs_datawrite_end(inode, pos, len);
 	trace_ext4_da_write_end(inode, pos, len, copied);
 	start = pos & (PAGE_SIZE - 1);
 	end = start + copied - 1;
@@ -3602,6 +3617,7 @@ static ssize_t ext4_direct_IO(struct kiocb *iocb, struct iov_iter *iter)
 	size_t count = iov_iter_count(iter);
 	loff_t offset = iocb->ki_pos;
 	ssize_t ret;
+	int rw = iov_iter_rw(iter);
 
 #ifdef CONFIG_EXT4_FS_ENCRYPTION
 	if (ext4_encrypted_inode(inode) && S_ISREG(inode->i_mode))
@@ -3618,12 +3634,42 @@ static ssize_t ext4_direct_IO(struct kiocb *iocb, struct iov_iter *iter)
 	if (ext4_has_inline_data(inode))
 		return 0;
 
+	if (trace_android_fs_dataread_start_enabled() &&
+	    (rw == READ)) {
+		char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+		path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    inode);
+		trace_android_fs_dataread_start(inode, offset, count,
+						current->pid, path,
+						current->comm);
+	}
+	if (trace_android_fs_datawrite_start_enabled() &&
+	    (rw == WRITE)) {
+		char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+		path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    inode);
+		trace_android_fs_datawrite_start(inode, offset, count,
+						 current->pid, path,
+						 current->comm);
+	}
 	trace_ext4_direct_IO_enter(inode, offset, count, iov_iter_rw(iter));
 	if (iov_iter_rw(iter) == READ)
 		ret = ext4_direct_IO_read(iocb, iter);
 	else
 		ret = ext4_direct_IO_write(iocb, iter);
 	trace_ext4_direct_IO_exit(inode, offset, count, iov_iter_rw(iter), ret);
+
+	if (trace_android_fs_dataread_start_enabled() &&
+	    (rw == READ))
+		trace_android_fs_dataread_end(inode, offset, count);
+	if (trace_android_fs_datawrite_start_enabled() &&
+	    (rw == WRITE))
+		trace_android_fs_datawrite_end(inode, offset, count);
+
 	return ret;
 }
 
@@ -3774,7 +3820,8 @@ static int __ext4_block_zero_page_range(handle_t *handle,
 			/* We expect the key to be set. */
 			BUG_ON(!fscrypt_has_encryption_key(inode));
 			BUG_ON(blocksize != PAGE_SIZE);
-			WARN_ON_ONCE(fscrypt_decrypt_page(page));
+			WARN_ON_ONCE(fscrypt_decrypt_page(page->mapping->host,
+						page, PAGE_SIZE, 0, page->index));
 		}
 	}
 	if (ext4_should_journal_data(inode)) {
@@ -4392,8 +4439,11 @@ void ext4_set_inode_flags(struct inode *inode)
 		new_fl |= S_DIRSYNC;
 	if (test_opt(inode->i_sb, DAX) && S_ISREG(inode->i_mode))
 		new_fl |= S_DAX;
+	if (flags & EXT4_ENCRYPT_FL)
+		new_fl |= S_ENCRYPTED;
 	inode_set_flags(inode, new_fl,
-			S_SYNC|S_APPEND|S_IMMUTABLE|S_NOATIME|S_DIRSYNC|S_DAX);
+			S_SYNC|S_APPEND|S_IMMUTABLE|S_NOATIME|S_DIRSYNC|S_DAX|
+			S_ENCRYPTED);
 }
 
 /* Propagate flags from i_flags to EXT4_I(inode)->i_flags */
diff --git a/fs/ext4/ioctl.c b/fs/ext4/ioctl.c
index bf5ae8e..15ca15c 100644
--- a/fs/ext4/ioctl.c
+++ b/fs/ext4/ioctl.c
@@ -191,6 +191,7 @@ static long swap_inode_boot_loader(struct super_block *sb,
 	return err;
 }
 
+#ifdef CONFIG_EXT4_FS_ENCRYPTION
 static int uuid_is_zero(__u8 u[16])
 {
 	int	i;
@@ -200,6 +201,7 @@ static int uuid_is_zero(__u8 u[16])
 			return 0;
 	return 1;
 }
+#endif
 
 static int ext4_ioctl_setflags(struct inode *inode,
 			       unsigned int flags)
@@ -735,11 +737,13 @@ long ext4_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 		return err;
 	}
 
+	case FIDTRIM:
 	case FITRIM:
 	{
 		struct request_queue *q = bdev_get_queue(sb->s_bdev);
 		struct fstrim_range range;
 		int ret = 0;
+		int flags  = cmd == FIDTRIM ? BLKDEV_DISCARD_SECURE : 0;
 
 		if (!capable(CAP_SYS_ADMIN))
 			return -EPERM;
@@ -747,13 +751,16 @@ long ext4_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 		if (!blk_queue_discard(q))
 			return -EOPNOTSUPP;
 
+		if ((flags & BLKDEV_DISCARD_SECURE) && !blk_queue_secure_erase(q))
+			return -EOPNOTSUPP;
+
 		if (copy_from_user(&range, (struct fstrim_range __user *)arg,
 		    sizeof(range)))
 			return -EFAULT;
 
 		range.minlen = max((unsigned int)range.minlen,
 				   q->limits.discard_granularity);
-		ret = ext4_trim_fs(sb, &range);
+		ret = ext4_trim_fs(sb, &range, flags);
 		if (ret < 0)
 			return ret;
 
@@ -765,28 +772,19 @@ long ext4_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 	}
 	case EXT4_IOC_PRECACHE_EXTENTS:
 		return ext4_ext_precache(inode);
-	case EXT4_IOC_SET_ENCRYPTION_POLICY: {
-#ifdef CONFIG_EXT4_FS_ENCRYPTION
-		struct fscrypt_policy policy;
 
+	case EXT4_IOC_SET_ENCRYPTION_POLICY:
 		if (!ext4_has_feature_encrypt(sb))
 			return -EOPNOTSUPP;
+		return fscrypt_ioctl_set_policy(filp, (const void __user *)arg);
 
-		if (copy_from_user(&policy,
-				   (struct fscrypt_policy __user *)arg,
-				   sizeof(policy)))
-			return -EFAULT;
-		return fscrypt_process_policy(filp, &policy);
-#else
-		return -EOPNOTSUPP;
-#endif
-	}
 	case EXT4_IOC_GET_ENCRYPTION_PWSALT: {
+#ifdef CONFIG_EXT4_FS_ENCRYPTION
 		int err, err2;
 		struct ext4_sb_info *sbi = EXT4_SB(sb);
 		handle_t *handle;
 
-		if (!ext4_sb_has_crypto(sb))
+		if (!ext4_has_feature_encrypt(sb))
 			return -EOPNOTSUPP;
 		if (uuid_is_zero(sbi->s_es->s_encrypt_pw_salt)) {
 			err = mnt_want_write_file(filp);
@@ -816,30 +814,18 @@ long ext4_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 				 sbi->s_es->s_encrypt_pw_salt, 16))
 			return -EFAULT;
 		return 0;
-	}
-	case EXT4_IOC_GET_ENCRYPTION_POLICY: {
-#ifdef CONFIG_EXT4_FS_ENCRYPTION
-		struct fscrypt_policy policy;
-		int err = 0;
-
-		if (!ext4_encrypted_inode(inode))
-			return -ENOENT;
-		err = fscrypt_get_policy(inode, &policy);
-		if (err)
-			return err;
-		if (copy_to_user((void __user *)arg, &policy, sizeof(policy)))
-			return -EFAULT;
-		return 0;
 #else
 		return -EOPNOTSUPP;
 #endif
 	}
+	case EXT4_IOC_GET_ENCRYPTION_POLICY:
+		return fscrypt_ioctl_get_policy(filp, (void __user *)arg);
+
 	case EXT4_IOC_FSGETXATTR:
 	{
 		struct fsxattr fa;
 
 		memset(&fa, 0, sizeof(struct fsxattr));
-		ext4_get_inode_flags(ei);
 		fa.fsx_xflags = ext4_iflags_to_xflags(ei->i_flags & EXT4_FL_USER_VISIBLE);
 
 		if (ext4_has_feature_project(inode->i_sb)) {
diff --git a/fs/ext4/mballoc.c b/fs/ext4/mballoc.c
index 53e1890..0fcc336 100644
--- a/fs/ext4/mballoc.c
+++ b/fs/ext4/mballoc.c
@@ -2773,7 +2773,8 @@ int ext4_mb_release(struct super_block *sb)
 }
 
 static inline int ext4_issue_discard(struct super_block *sb,
-		ext4_group_t block_group, ext4_grpblk_t cluster, int count)
+		ext4_group_t block_group, ext4_grpblk_t cluster, int count,
+		unsigned long flags)
 {
 	ext4_fsblk_t discard_block;
 
@@ -2782,7 +2783,7 @@ static inline int ext4_issue_discard(struct super_block *sb,
 	count = EXT4_C2B(EXT4_SB(sb), count);
 	trace_ext4_discard_blocks(sb,
 			(unsigned long long) discard_block, count);
-	return sb_issue_discard(sb, discard_block, count, GFP_NOFS, 0);
+	return sb_issue_discard(sb, discard_block, count, GFP_NOFS, flags);
 }
 
 /*
@@ -2804,7 +2805,7 @@ static void ext4_free_data_callback(struct super_block *sb,
 	if (test_opt(sb, DISCARD)) {
 		err = ext4_issue_discard(sb, entry->efd_group,
 					 entry->efd_start_cluster,
-					 entry->efd_count);
+					 entry->efd_count, 0);
 		if (err && err != -EOPNOTSUPP)
 			ext4_msg(sb, KERN_WARNING, "discard request in"
 				 " group:%d block:%d count:%d failed"
@@ -4863,7 +4864,8 @@ void ext4_free_blocks(handle_t *handle, struct inode *inode,
 		 * them with group lock_held
 		 */
 		if (test_opt(sb, DISCARD)) {
-			err = ext4_issue_discard(sb, block_group, bit, count);
+			err = ext4_issue_discard(sb, block_group, bit, count,
+						 0);
 			if (err && err != -EOPNOTSUPP)
 				ext4_msg(sb, KERN_WARNING, "discard request in"
 					 " group:%d block:%d count:%lu failed"
@@ -5059,13 +5061,15 @@ int ext4_group_add_blocks(handle_t *handle, struct super_block *sb,
  * @count:	number of blocks to TRIM
  * @group:	alloc. group we are working with
  * @e4b:	ext4 buddy for the group
+ * @blkdev_flags: flags for the block device
  *
  * Trim "count" blocks starting at "start" in the "group". To assure that no
  * one will allocate those blocks, mark it as used in buddy bitmap. This must
  * be called with under the group lock.
  */
 static int ext4_trim_extent(struct super_block *sb, int start, int count,
-			     ext4_group_t group, struct ext4_buddy *e4b)
+			    ext4_group_t group, struct ext4_buddy *e4b,
+			    unsigned long blkdev_flags)
 __releases(bitlock)
 __acquires(bitlock)
 {
@@ -5086,7 +5090,7 @@ static int ext4_trim_extent(struct super_block *sb, int start, int count,
 	 */
 	mb_mark_used(e4b, &ex);
 	ext4_unlock_group(sb, group);
-	ret = ext4_issue_discard(sb, group, start, count);
+	ret = ext4_issue_discard(sb, group, start, count, blkdev_flags);
 	ext4_lock_group(sb, group);
 	mb_free_blocks(NULL, e4b, start, ex.fe_len);
 	return ret;
@@ -5099,6 +5103,7 @@ static int ext4_trim_extent(struct super_block *sb, int start, int count,
  * @start:		first group block to examine
  * @max:		last group block to examine
  * @minblocks:		minimum extent block count
+ * @blkdev_flags:	flags for the block device
  *
  * ext4_trim_all_free walks through group's buddy bitmap searching for free
  * extents. When the free block is found, ext4_trim_extent is called to TRIM
@@ -5113,7 +5118,7 @@ static int ext4_trim_extent(struct super_block *sb, int start, int count,
 static ext4_grpblk_t
 ext4_trim_all_free(struct super_block *sb, ext4_group_t group,
 		   ext4_grpblk_t start, ext4_grpblk_t max,
-		   ext4_grpblk_t minblocks)
+		   ext4_grpblk_t minblocks, unsigned long blkdev_flags)
 {
 	void *bitmap;
 	ext4_grpblk_t next, count = 0, free_count = 0;
@@ -5146,7 +5151,8 @@ static int ext4_trim_extent(struct super_block *sb, int start, int count,
 
 		if ((next - start) >= minblocks) {
 			ret = ext4_trim_extent(sb, start,
-					       next - start, group, &e4b);
+					       next - start, group, &e4b,
+					       blkdev_flags);
 			if (ret && ret != -EOPNOTSUPP)
 				break;
 			ret = 0;
@@ -5188,6 +5194,7 @@ static int ext4_trim_extent(struct super_block *sb, int start, int count,
  * ext4_trim_fs() -- trim ioctl handle function
  * @sb:			superblock for filesystem
  * @range:		fstrim_range structure
+ * @blkdev_flags:	flags for the block device
  *
  * start:	First Byte to trim
  * len:		number of Bytes to trim from start
@@ -5196,7 +5203,8 @@ static int ext4_trim_extent(struct super_block *sb, int start, int count,
  * start to start+len. For each such a group ext4_trim_all_free function
  * is invoked to trim all free space.
  */
-int ext4_trim_fs(struct super_block *sb, struct fstrim_range *range)
+int ext4_trim_fs(struct super_block *sb, struct fstrim_range *range,
+			unsigned long blkdev_flags)
 {
 	struct ext4_group_info *grp;
 	ext4_group_t group, first_group, last_group;
@@ -5252,7 +5260,7 @@ int ext4_trim_fs(struct super_block *sb, struct fstrim_range *range)
 
 		if (grp->bb_free >= minlen) {
 			cnt = ext4_trim_all_free(sb, group, first_cluster,
-						end, minlen);
+						end, minlen, blkdev_flags);
 			if (cnt < 0) {
 				ret = cnt;
 				break;
diff --git a/fs/ext4/namei.c b/fs/ext4/namei.c
index 248c43b..ac0b6335 100644
--- a/fs/ext4/namei.c
+++ b/fs/ext4/namei.c
@@ -1237,37 +1237,24 @@ static void dx_insert_block(struct dx_frame *frame, u32 hash, ext4_lblk_t block)
 }
 
 /*
- * NOTE! unlike strncmp, ext4_match returns 1 for success, 0 for failure.
+ * Test whether a directory entry matches the filename being searched for.
  *
- * `len <= EXT4_NAME_LEN' is guaranteed by caller.
- * `de != NULL' is guaranteed by caller.
+ * Return: %true if the directory entry matches, otherwise %false.
  */
-static inline int ext4_match(struct ext4_filename *fname,
-			     struct ext4_dir_entry_2 *de)
+static inline bool ext4_match(const struct ext4_filename *fname,
+			      const struct ext4_dir_entry_2 *de)
 {
-	const void *name = fname_name(fname);
-	u32 len = fname_len(fname);
+	struct fscrypt_name f;
 
 	if (!de->inode)
-		return 0;
+		return false;
 
+	f.usr_fname = fname->usr_fname;
+	f.disk_name = fname->disk_name;
 #ifdef CONFIG_EXT4_FS_ENCRYPTION
-	if (unlikely(!name)) {
-		if (fname->usr_fname->name[0] == '_') {
-			int ret;
-			if (de->name_len <= 32)
-				return 0;
-			ret = memcmp(de->name + ((de->name_len - 17) & ~15),
-				     fname->crypto_buf.name + 8, 16);
-			return (ret == 0) ? 1 : 0;
-		}
-		name = fname->crypto_buf.name;
-		len = fname->crypto_buf.len;
-	}
+	f.crypto_buf = fname->crypto_buf;
 #endif
-	if (de->name_len != len)
-		return 0;
-	return (memcmp(de->name, name, len) == 0) ? 1 : 0;
+	return fscrypt_match_name(&f, de->name, de->name_len);
 }
 
 /*
@@ -1281,48 +1268,31 @@ int ext4_search_dir(struct buffer_head *bh, char *search_buf, int buf_size,
 	struct ext4_dir_entry_2 * de;
 	char * dlimit;
 	int de_len;
-	int res;
 
 	de = (struct ext4_dir_entry_2 *)search_buf;
 	dlimit = search_buf + buf_size;
 	while ((char *) de < dlimit) {
 		/* this code is executed quadratically often */
 		/* do minimal checking `by hand' */
-		if ((char *) de + de->name_len <= dlimit) {
-			res = ext4_match(fname, de);
-			if (res < 0) {
-				res = -1;
-				goto return_result;
-			}
-			if (res > 0) {
-				/* found a match - just to be sure, do
-				 * a full check */
-				if (ext4_check_dir_entry(dir, NULL, de, bh,
-						bh->b_data,
-						 bh->b_size, offset)) {
-					res = -1;
-					goto return_result;
-				}
-				*res_dir = de;
-				res = 1;
-				goto return_result;
-			}
-
+		if ((char *) de + de->name_len <= dlimit &&
+		    ext4_match(fname, de)) {
+			/* found a match - just to be sure, do
+			 * a full check */
+			if (ext4_check_dir_entry(dir, NULL, de, bh, bh->b_data,
+						 bh->b_size, offset))
+				return -1;
+			*res_dir = de;
+			return 1;
 		}
 		/* prevent looping on a bad block */
 		de_len = ext4_rec_len_from_disk(de->rec_len,
 						dir->i_sb->s_blocksize);
-		if (de_len <= 0) {
-			res = -1;
-			goto return_result;
-		}
+		if (de_len <= 0)
+			return -1;
 		offset += de_len;
 		de = (struct ext4_dir_entry_2 *) ((char *) de + de_len);
 	}
-
-	res = 0;
-return_result:
-	return res;
+	return 0;
 }
 
 static int is_dx_internal_node(struct inode *dir, ext4_lblk_t block,
@@ -1575,24 +1545,14 @@ static struct dentry *ext4_lookup(struct inode *dir, struct dentry *dentry, unsi
 	struct inode *inode;
 	struct ext4_dir_entry_2 *de;
 	struct buffer_head *bh;
+	int err;
 
-	if (ext4_encrypted_inode(dir)) {
-		int res = fscrypt_get_encryption_info(dir);
-
-		/*
-		 * DCACHE_ENCRYPTED_WITH_KEY is set if the dentry is
-		 * created while the directory was encrypted and we
-		 * have access to the key.
-		 */
-		if (fscrypt_has_encryption_key(dir))
-			fscrypt_set_encrypted_dentry(dentry);
-		fscrypt_set_d_op(dentry);
-		if (res && res != -ENOKEY)
-			return ERR_PTR(res);
-	}
+	err = fscrypt_prepare_lookup(dir, dentry, flags);
+	if (err)
+		return ERR_PTR(err);
 
-       if (dentry->d_name.len > EXT4_NAME_LEN)
-	       return ERR_PTR(-ENAMETOOLONG);
+	if (dentry->d_name.len > EXT4_NAME_LEN)
+		return ERR_PTR(-ENAMETOOLONG);
 
 	bh = ext4_find_entry(dir, &dentry->d_name, &de, NULL);
 	if (IS_ERR(bh))
@@ -1620,16 +1580,9 @@ static struct dentry *ext4_lookup(struct inode *dir, struct dentry *dentry, unsi
 		if (!IS_ERR(inode) && ext4_encrypted_inode(dir) &&
 		    (S_ISDIR(inode->i_mode) || S_ISLNK(inode->i_mode)) &&
 		    !fscrypt_has_permitted_context(dir, inode)) {
-			int nokey = ext4_encrypted_inode(inode) &&
-				!fscrypt_has_encryption_key(inode);
-			if (nokey) {
-				iput(inode);
-				return ERR_PTR(-ENOKEY);
-			}
 			ext4_warning(inode->i_sb,
 				     "Inconsistent encryption contexts: %lu/%lu",
-				     (unsigned long) dir->i_ino,
-				     (unsigned long) inode->i_ino);
+				     dir->i_ino, inode->i_ino);
 			iput(inode);
 			return ERR_PTR(-EPERM);
 		}
@@ -1837,24 +1790,15 @@ int ext4_find_dest_de(struct inode *dir, struct inode *inode,
 	int nlen, rlen;
 	unsigned int offset = 0;
 	char *top;
-	int res;
 
 	de = (struct ext4_dir_entry_2 *)buf;
 	top = buf + buf_size - reclen;
 	while ((char *) de <= top) {
 		if (ext4_check_dir_entry(dir, NULL, de, bh,
-					 buf, buf_size, offset)) {
-			res = -EFSCORRUPTED;
-			goto return_result;
-		}
-		/* Provide crypto context and crypto buffer to ext4 match */
-		res = ext4_match(fname, de);
-		if (res < 0)
-			goto return_result;
-		if (res > 0) {
-			res = -EEXIST;
-			goto return_result;
-		}
+					 buf, buf_size, offset))
+			return -EFSCORRUPTED;
+		if (ext4_match(fname, de))
+			return -EEXIST;
 		nlen = EXT4_DIR_REC_LEN(de->name_len);
 		rlen = ext4_rec_len_from_disk(de->rec_len, buf_size);
 		if ((de->inode ? rlen - nlen : rlen) >= reclen)
@@ -1862,22 +1806,17 @@ int ext4_find_dest_de(struct inode *dir, struct inode *inode,
 		de = (struct ext4_dir_entry_2 *)((char *)de + rlen);
 		offset += rlen;
 	}
-
 	if ((char *) de > top)
-		res = -ENOSPC;
-	else {
-		*dest_de = de;
-		res = 0;
-	}
-return_result:
-	return res;
+		return -ENOSPC;
+
+	*dest_de = de;
+	return 0;
 }
 
-int ext4_insert_dentry(struct inode *dir,
-		       struct inode *inode,
-		       struct ext4_dir_entry_2 *de,
-		       int buf_size,
-		       struct ext4_filename *fname)
+void ext4_insert_dentry(struct inode *inode,
+			struct ext4_dir_entry_2 *de,
+			int buf_size,
+			struct ext4_filename *fname)
 {
 
 	int nlen, rlen;
@@ -1896,7 +1835,6 @@ int ext4_insert_dentry(struct inode *dir,
 	ext4_set_de_type(inode->i_sb, de, inode->i_mode);
 	de->name_len = fname_len(fname);
 	memcpy(de->name, fname_name(fname), fname_len(fname));
-	return 0;
 }
 
 /*
@@ -1932,11 +1870,8 @@ static int add_dirent_to_buf(handle_t *handle, struct ext4_filename *fname,
 		return err;
 	}
 
-	/* By now the buffer is marked for journaling. Due to crypto operations,
-	 * the following function call may fail */
-	err = ext4_insert_dentry(dir, inode, de, blocksize, fname);
-	if (err < 0)
-		return err;
+	/* By now the buffer is marked for journaling */
+	ext4_insert_dentry(inode, de, blocksize, fname);
 
 	/*
 	 * XXX shouldn't update any times until successful
@@ -3080,36 +3015,16 @@ static int ext4_symlink(struct inode *dir,
 	struct inode *inode;
 	int err, len = strlen(symname);
 	int credits;
-	bool encryption_required;
 	struct fscrypt_str disk_link;
-	struct fscrypt_symlink_data *sd = NULL;
-
-	disk_link.len = len + 1;
-	disk_link.name = (char *) symname;
 
-	encryption_required = (ext4_encrypted_inode(dir) ||
-			       DUMMY_ENCRYPTION_ENABLED(EXT4_SB(dir->i_sb)));
-	if (encryption_required) {
-		err = fscrypt_get_encryption_info(dir);
-		if (err)
-			return err;
-		if (!fscrypt_has_encryption_key(dir))
-			return -ENOKEY;
-		disk_link.len = (fscrypt_fname_encrypted_size(dir, len) +
-				 sizeof(struct fscrypt_symlink_data));
-		sd = kzalloc(disk_link.len, GFP_KERNEL);
-		if (!sd)
-			return -ENOMEM;
-	}
-
-	if (disk_link.len > dir->i_sb->s_blocksize) {
-		err = -ENAMETOOLONG;
-		goto err_free_sd;
-	}
+	err = fscrypt_prepare_symlink(dir, symname, len, dir->i_sb->s_blocksize,
+				      &disk_link);
+	if (err)
+		return err;
 
 	err = dquot_initialize(dir);
 	if (err)
-		goto err_free_sd;
+		return err;
 
 	if ((disk_link.len > EXT4_N_BLOCKS * 4)) {
 		/*
@@ -3138,27 +3053,18 @@ static int ext4_symlink(struct inode *dir,
 	if (IS_ERR(inode)) {
 		if (handle)
 			ext4_journal_stop(handle);
-		err = PTR_ERR(inode);
-		goto err_free_sd;
+		return PTR_ERR(inode);
 	}
 
-	if (encryption_required) {
-		struct qstr istr;
-		struct fscrypt_str ostr =
-			FSTR_INIT(sd->encrypted_path, disk_link.len);
-
-		istr.name = (const unsigned char *) symname;
-		istr.len = len;
-		err = fscrypt_fname_usr_to_disk(inode, &istr, &ostr);
+	if (IS_ENCRYPTED(inode)) {
+		err = fscrypt_encrypt_symlink(inode, symname, len, &disk_link);
 		if (err)
 			goto err_drop_inode;
-		sd->len = cpu_to_le16(ostr.len);
-		disk_link.name = (char *) sd;
 		inode->i_op = &ext4_encrypted_symlink_inode_operations;
 	}
 
 	if ((disk_link.len > EXT4_N_BLOCKS * 4)) {
-		if (!encryption_required)
+		if (!IS_ENCRYPTED(inode))
 			inode->i_op = &ext4_symlink_inode_operations;
 		inode_nohighmem(inode);
 		ext4_set_aops(inode);
@@ -3200,7 +3106,7 @@ static int ext4_symlink(struct inode *dir,
 	} else {
 		/* clear the extent format for fast symlink */
 		ext4_clear_inode_flag(inode, EXT4_INODE_EXTENTS);
-		if (!encryption_required) {
+		if (!IS_ENCRYPTED(inode)) {
 			inode->i_op = &ext4_fast_symlink_inode_operations;
 			inode->i_link = (char *)&EXT4_I(inode)->i_data;
 		}
@@ -3215,16 +3121,17 @@ static int ext4_symlink(struct inode *dir,
 
 	if (handle)
 		ext4_journal_stop(handle);
-	kfree(sd);
-	return err;
+	goto out_free_encrypted_link;
+
 err_drop_inode:
 	if (handle)
 		ext4_journal_stop(handle);
 	clear_nlink(inode);
 	unlock_new_inode(inode);
 	iput(inode);
-err_free_sd:
-	kfree(sd);
+out_free_encrypted_link:
+	if (disk_link.name != (unsigned char *)symname)
+		kfree(disk_link.name);
 	return err;
 }
 
diff --git a/fs/ext4/page-io.c b/fs/ext4/page-io.c
index 0094923..0718a86 100644
--- a/fs/ext4/page-io.c
+++ b/fs/ext4/page-io.c
@@ -24,7 +24,6 @@
 #include <linux/slab.h>
 #include <linux/mm.h>
 #include <linux/backing-dev.h>
-#include <linux/fscrypto.h>
 
 #include "ext4_jbd2.h"
 #include "xattr.h"
@@ -470,7 +469,8 @@ int ext4_bio_write_page(struct ext4_io_submit *io,
 		gfp_t gfp_flags = GFP_NOFS;
 
 	retry_encrypt:
-		data_page = fscrypt_encrypt_page(inode, page, gfp_flags);
+		data_page = fscrypt_encrypt_page(inode, page, PAGE_SIZE, 0,
+						page->index, gfp_flags);
 		if (IS_ERR(data_page)) {
 			ret = PTR_ERR(data_page);
 			if (ret == -ENOMEM && wbc->sync_mode == WB_SYNC_ALL) {
diff --git a/fs/ext4/readpage.c b/fs/ext4/readpage.c
index a81b829..c39a12d 100644
--- a/fs/ext4/readpage.c
+++ b/fs/ext4/readpage.c
@@ -45,6 +45,7 @@
 #include <linux/cleancache.h>
 
 #include "ext4.h"
+#include <trace/events/android_fs.h>
 
 static inline bool ext4_bio_encrypted(struct bio *bio)
 {
@@ -55,6 +56,17 @@ static inline bool ext4_bio_encrypted(struct bio *bio)
 #endif
 }
 
+static void
+ext4_trace_read_completion(struct bio *bio)
+{
+	struct page *first_page = bio->bi_io_vec[0].bv_page;
+
+	if (first_page != NULL)
+		trace_android_fs_dataread_end(first_page->mapping->host,
+					      page_offset(first_page),
+					      bio->bi_iter.bi_size);
+}
+
 /*
  * I/O completion handler for multipage BIOs.
  *
@@ -72,11 +84,14 @@ static void mpage_end_io(struct bio *bio)
 	struct bio_vec *bv;
 	int i;
 
+	if (trace_android_fs_dataread_start_enabled())
+		ext4_trace_read_completion(bio);
+
 	if (ext4_bio_encrypted(bio)) {
 		if (bio->bi_error) {
 			fscrypt_release_ctx(bio->bi_private);
 		} else {
-			fscrypt_decrypt_bio_pages(bio->bi_private, bio);
+			fscrypt_enqueue_decrypt_bio(bio->bi_private, bio);
 			return;
 		}
 	}
@@ -95,6 +110,30 @@ static void mpage_end_io(struct bio *bio)
 	bio_put(bio);
 }
 
+static void
+ext4_submit_bio_read(struct bio *bio)
+{
+	if (trace_android_fs_dataread_start_enabled()) {
+		struct page *first_page = bio->bi_io_vec[0].bv_page;
+
+		if (first_page != NULL) {
+			char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+			path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    first_page->mapping->host);
+			trace_android_fs_dataread_start(
+				first_page->mapping->host,
+				page_offset(first_page),
+				bio->bi_iter.bi_size,
+				current->pid,
+				path,
+				current->comm);
+		}
+	}
+	submit_bio(bio);
+}
+
 int ext4_mpage_readpages(struct address_space *mapping,
 			 struct list_head *pages, struct page *page,
 			 unsigned nr_pages)
@@ -235,7 +274,7 @@ int ext4_mpage_readpages(struct address_space *mapping,
 		 */
 		if (bio && (last_block_in_bio != blocks[0] - 1)) {
 		submit_and_realloc:
-			submit_bio(bio);
+			ext4_submit_bio_read(bio);
 			bio = NULL;
 		}
 		if (bio == NULL) {
@@ -268,14 +307,14 @@ int ext4_mpage_readpages(struct address_space *mapping,
 		if (((map.m_flags & EXT4_MAP_BOUNDARY) &&
 		     (relative_block == map.m_len)) ||
 		    (first_hole != blocks_per_page)) {
-			submit_bio(bio);
+			ext4_submit_bio_read(bio);
 			bio = NULL;
 		} else
 			last_block_in_bio = blocks[blocks_per_page - 1];
 		goto next_page;
 	confused:
 		if (bio) {
-			submit_bio(bio);
+			ext4_submit_bio_read(bio);
 			bio = NULL;
 		}
 		if (!PageUptodate(page))
@@ -288,6 +327,6 @@ int ext4_mpage_readpages(struct address_space *mapping,
 	}
 	BUG_ON(pages && !list_empty(pages));
 	if (bio)
-		submit_bio(bio);
+		ext4_submit_bio_read(bio);
 	return 0;
 }
diff --git a/fs/ext4/super.c b/fs/ext4/super.c
index 6cbb0f7e..1a2c223 100644
--- a/fs/ext4/super.c
+++ b/fs/ext4/super.c
@@ -1028,9 +1028,7 @@ void ext4_clear_inode(struct inode *inode)
 		jbd2_free_inode(EXT4_I(inode)->jinode);
 		EXT4_I(inode)->jinode = NULL;
 	}
-#ifdef CONFIG_EXT4_FS_ENCRYPTION
-	fscrypt_put_encryption_info(inode, NULL);
-#endif
+	fscrypt_put_encryption_info(inode);
 }
 
 static struct inode *ext4_nfs_get_inode(struct super_block *sb,
@@ -1103,80 +1101,86 @@ static int ext4_get_context(struct inode *inode, void *ctx, size_t len)
 				 EXT4_XATTR_NAME_ENCRYPTION_CONTEXT, ctx, len);
 }
 
-static int ext4_key_prefix(struct inode *inode, u8 **key)
-{
-	*key = EXT4_SB(inode->i_sb)->key_prefix;
-	return EXT4_SB(inode->i_sb)->key_prefix_size;
-}
-
-static int ext4_prepare_context(struct inode *inode)
-{
-	return ext4_convert_inline_data(inode);
-}
-
 static int ext4_set_context(struct inode *inode, const void *ctx, size_t len,
 							void *fs_data)
 {
-	handle_t *handle;
-	int res, res2;
+	handle_t *handle = fs_data;
+	int res, res2, retries = 0;
+
+	res = ext4_convert_inline_data(inode);
+	if (res)
+		return res;
+
+	/*
+	 * If a journal handle was specified, then the encryption context is
+	 * being set on a new inode via inheritance and is part of a larger
+	 * transaction to create the inode.  Otherwise the encryption context is
+	 * being set on an existing inode in its own transaction.  Only in the
+	 * latter case should the "retry on ENOSPC" logic be used.
+	 */
 
-	/* fs_data is null when internally used. */
-	if (fs_data) {
-		res  = ext4_xattr_set(inode, EXT4_XATTR_INDEX_ENCRYPTION,
-				EXT4_XATTR_NAME_ENCRYPTION_CONTEXT, ctx,
-				len, 0);
+	if (handle) {
+		res = ext4_xattr_set_handle(handle, inode,
+					    EXT4_XATTR_INDEX_ENCRYPTION,
+					    EXT4_XATTR_NAME_ENCRYPTION_CONTEXT,
+					    ctx, len, 0);
 		if (!res) {
 			ext4_set_inode_flag(inode, EXT4_INODE_ENCRYPT);
 			ext4_clear_inode_state(inode,
 					EXT4_STATE_MAY_INLINE_DATA);
+			/*
+			 * Update inode->i_flags - S_ENCRYPTED will be enabled,
+			 * S_DAX may be disabled
+			 */
+			ext4_set_inode_flags(inode);
 		}
 		return res;
 	}
 
+	res = dquot_initialize(inode);
+	if (res)
+		return res;
+retry:
 	handle = ext4_journal_start(inode, EXT4_HT_MISC,
 			ext4_jbd2_credits_xattr(inode));
 	if (IS_ERR(handle))
 		return PTR_ERR(handle);
 
-	res = ext4_xattr_set(inode, EXT4_XATTR_INDEX_ENCRYPTION,
-			EXT4_XATTR_NAME_ENCRYPTION_CONTEXT, ctx,
-			len, 0);
+	res = ext4_xattr_set_handle(handle, inode, EXT4_XATTR_INDEX_ENCRYPTION,
+				    EXT4_XATTR_NAME_ENCRYPTION_CONTEXT,
+				    ctx, len, 0);
 	if (!res) {
 		ext4_set_inode_flag(inode, EXT4_INODE_ENCRYPT);
+		/*
+		 * Update inode->i_flags - S_ENCRYPTED will be enabled,
+		 * S_DAX may be disabled
+		 */
+		ext4_set_inode_flags(inode);
 		res = ext4_mark_inode_dirty(handle, inode);
 		if (res)
 			EXT4_ERROR_INODE(inode, "Failed to mark inode dirty");
 	}
 	res2 = ext4_journal_stop(handle);
+
+	if (res == -ENOSPC && ext4_should_retry_alloc(inode->i_sb, &retries))
+		goto retry;
 	if (!res)
 		res = res2;
 	return res;
 }
 
-static int ext4_dummy_context(struct inode *inode)
+static bool ext4_dummy_context(struct inode *inode)
 {
 	return DUMMY_ENCRYPTION_ENABLED(EXT4_SB(inode->i_sb));
 }
 
-static unsigned ext4_max_namelen(struct inode *inode)
-{
-	return S_ISLNK(inode->i_mode) ? inode->i_sb->s_blocksize :
-		EXT4_NAME_LEN;
-}
-
-static struct fscrypt_operations ext4_cryptops = {
+static const struct fscrypt_operations ext4_cryptops = {
+	.key_prefix		= "ext4:",
 	.get_context		= ext4_get_context,
-	.key_prefix		= ext4_key_prefix,
-	.prepare_context	= ext4_prepare_context,
 	.set_context		= ext4_set_context,
 	.dummy_context		= ext4_dummy_context,
-	.is_encrypted		= ext4_encrypted_inode,
 	.empty_dir		= ext4_empty_dir,
-	.max_namelen		= ext4_max_namelen,
-};
-#else
-static struct fscrypt_operations ext4_cryptops = {
-	.is_encrypted		= ext4_encrypted_inode,
+	.max_namelen		= EXT4_NAME_LEN,
 };
 #endif
 
@@ -3031,14 +3035,8 @@ static ext4_group_t ext4_has_uninit_itable(struct super_block *sb)
 		if (!gdp)
 			continue;
 
-		if (gdp->bg_flags & cpu_to_le16(EXT4_BG_INODE_ZEROED))
-			continue;
-		if (group != 0)
+		if (!(gdp->bg_flags & cpu_to_le16(EXT4_BG_INODE_ZEROED)))
 			break;
-		ext4_error(sb, "Inode table for bg 0 marked as "
-			   "needing zeroing");
-		if (sb->s_flags & MS_RDONLY)
-			return ngroups;
 	}
 
 	return group;
@@ -3967,7 +3965,9 @@ static int ext4_fill_super(struct super_block *sb, void *data, int silent)
 	sb->s_op = &ext4_sops;
 	sb->s_export_op = &ext4_export_ops;
 	sb->s_xattr = ext4_xattr_handlers;
+#ifdef CONFIG_EXT4_FS_ENCRYPTION
 	sb->s_cop = &ext4_cryptops;
+#endif
 #ifdef CONFIG_QUOTA
 	sb->dq_op = &ext4_quota_operations;
 	if (ext4_has_feature_quota(sb))
@@ -4281,11 +4281,6 @@ static int ext4_fill_super(struct super_block *sb, void *data, int silent)
 	ratelimit_state_init(&sbi->s_msg_ratelimit_state, 5 * HZ, 10);
 
 	kfree(orig_data);
-#ifdef CONFIG_EXT4_FS_ENCRYPTION
-	memcpy(sbi->key_prefix, EXT4_KEY_DESC_PREFIX,
-				EXT4_KEY_DESC_PREFIX_SIZE);
-	sbi->key_prefix_size = EXT4_KEY_DESC_PREFIX_SIZE;
-#endif
 	return 0;
 
 cantfind_ext4:
diff --git a/fs/ext4/symlink.c b/fs/ext4/symlink.c
index 557b3b0..d4ce3af 100644
--- a/fs/ext4/symlink.c
+++ b/fs/ext4/symlink.c
@@ -27,59 +27,28 @@ static const char *ext4_encrypted_get_link(struct dentry *dentry,
 					   struct delayed_call *done)
 {
 	struct page *cpage = NULL;
-	char *caddr, *paddr = NULL;
-	struct fscrypt_str cstr, pstr;
-	struct fscrypt_symlink_data *sd;
-	int res;
-	u32 max_size = inode->i_sb->s_blocksize;
+	const void *caddr;
+	unsigned int max_size;
+	const char *paddr;
 
 	if (!dentry)
 		return ERR_PTR(-ECHILD);
 
-	res = fscrypt_get_encryption_info(inode);
-	if (res)
-		return ERR_PTR(res);
-
 	if (ext4_inode_is_fast_symlink(inode)) {
-		caddr = (char *) EXT4_I(inode)->i_data;
+		caddr = EXT4_I(inode)->i_data;
 		max_size = sizeof(EXT4_I(inode)->i_data);
 	} else {
 		cpage = read_mapping_page(inode->i_mapping, 0, NULL);
 		if (IS_ERR(cpage))
 			return ERR_CAST(cpage);
 		caddr = page_address(cpage);
+		max_size = inode->i_sb->s_blocksize;
 	}
 
-	/* Symlink is encrypted */
-	sd = (struct fscrypt_symlink_data *)caddr;
-	cstr.name = sd->encrypted_path;
-	cstr.len  = le16_to_cpu(sd->len);
-	if ((cstr.len + sizeof(struct fscrypt_symlink_data) - 1) > max_size) {
-		/* Symlink data on the disk is corrupted */
-		res = -EFSCORRUPTED;
-		goto errout;
-	}
-
-	res = fscrypt_fname_alloc_buffer(inode, cstr.len, &pstr);
-	if (res)
-		goto errout;
-	paddr = pstr.name;
-
-	res = fscrypt_fname_disk_to_usr(inode, 0, 0, &cstr, &pstr);
-	if (res)
-		goto errout;
-
-	/* Null-terminate the name */
-	paddr[pstr.len] = '\0';
+	paddr = fscrypt_get_symlink(inode, caddr, max_size, done);
 	if (cpage)
 		put_page(cpage);
-	set_delayed_call(done, kfree_link, paddr);
 	return paddr;
-errout:
-	if (cpage)
-		put_page(cpage);
-	kfree(paddr);
-	return ERR_PTR(res);
 }
 
 const struct inode_operations ext4_encrypted_symlink_inode_operations = {
diff --git a/fs/f2fs/Makefile b/fs/f2fs/Makefile
index ca949ea..a0dc559 100644
--- a/fs/f2fs/Makefile
+++ b/fs/f2fs/Makefile
@@ -2,7 +2,7 @@ obj-$(CONFIG_F2FS_FS) += f2fs.o
 
 f2fs-y		:= dir.o file.o inode.o namei.o hash.o super.o inline.o
 f2fs-y		+= checkpoint.o gc.o data.o node.o segment.o recovery.o
-f2fs-y		+= shrinker.o extent_cache.o
+f2fs-y		+= shrinker.o extent_cache.o sysfs.o
 f2fs-$(CONFIG_F2FS_STAT_FS) += debug.o
 f2fs-$(CONFIG_F2FS_FS_XATTR) += xattr.o
 f2fs-$(CONFIG_F2FS_FS_POSIX_ACL) += acl.o
diff --git a/fs/f2fs/acl.c b/fs/f2fs/acl.c
index 55aa29c..2bb7c9f 100644
--- a/fs/f2fs/acl.c
+++ b/fs/f2fs/acl.c
@@ -207,15 +207,16 @@ static int __f2fs_set_acl(struct inode *inode, int type,
 	void *value = NULL;
 	size_t size = 0;
 	int error;
+	umode_t mode = inode->i_mode;
 
 	switch (type) {
 	case ACL_TYPE_ACCESS:
 		name_index = F2FS_XATTR_INDEX_POSIX_ACL_ACCESS;
 		if (acl && !ipage) {
-			error = posix_acl_update_mode(inode, &inode->i_mode, &acl);
+			error = posix_acl_update_mode(inode, &mode, &acl);
 			if (error)
 				return error;
-			set_acl_inode(inode, inode->i_mode);
+			set_acl_inode(inode, mode);
 		}
 		break;
 
@@ -233,7 +234,7 @@ static int __f2fs_set_acl(struct inode *inode, int type,
 		value = f2fs_acl_to_disk(F2FS_I_SB(inode), acl, &size);
 		if (IS_ERR(value)) {
 			clear_inode_flag(inode, FI_ACL_MODE);
-			return (int)PTR_ERR(value);
+			return PTR_ERR(value);
 		}
 	}
 
@@ -249,6 +250,9 @@ static int __f2fs_set_acl(struct inode *inode, int type,
 
 int f2fs_set_acl(struct inode *inode, struct posix_acl *acl, int type)
 {
+	if (unlikely(f2fs_cp_error(F2FS_I_SB(inode))))
+		return -EIO;
+
 	return __f2fs_set_acl(inode, type, acl, NULL);
 }
 
@@ -384,7 +388,7 @@ int f2fs_init_acl(struct inode *inode, struct inode *dir, struct page *ipage,
 	if (error)
 		return error;
 
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, true);
 
 	if (default_acl) {
 		error = __f2fs_set_acl(inode, ACL_TYPE_DEFAULT, default_acl,
diff --git a/fs/f2fs/checkpoint.c b/fs/f2fs/checkpoint.c
index b4dbc2f..d7a53c6 100644
--- a/fs/f2fs/checkpoint.c
+++ b/fs/f2fs/checkpoint.c
@@ -24,20 +24,19 @@
 #include <trace/events/f2fs.h>
 
 static struct kmem_cache *ino_entry_slab;
-struct kmem_cache *inode_entry_slab;
+struct kmem_cache *f2fs_inode_entry_slab;
 
 void f2fs_stop_checkpoint(struct f2fs_sb_info *sbi, bool end_io)
 {
 	set_ckpt_flags(sbi, CP_ERROR_FLAG);
-	sbi->sb->s_flags |= MS_RDONLY;
 	if (!end_io)
-		f2fs_flush_merged_bios(sbi);
+		f2fs_flush_merged_writes(sbi);
 }
 
 /*
  * We guarantee no failure on the returned page.
  */
-struct page *grab_meta_page(struct f2fs_sb_info *sbi, pgoff_t index)
+struct page *f2fs_grab_meta_page(struct f2fs_sb_info *sbi, pgoff_t index)
 {
 	struct address_space *mapping = META_MAPPING(sbi);
 	struct page *page = NULL;
@@ -65,10 +64,11 @@ static struct page *__get_meta_page(struct f2fs_sb_info *sbi, pgoff_t index,
 		.sbi = sbi,
 		.type = META,
 		.op = REQ_OP_READ,
-		.op_flags = READ_SYNC | REQ_META | REQ_PRIO,
+		.op_flags = REQ_META | REQ_PRIO,
 		.old_blkaddr = index,
 		.new_blkaddr = index,
 		.encrypted_page = NULL,
+		.is_meta = is_meta,
 	};
 
 	if (unlikely(!is_meta))
@@ -100,24 +100,27 @@ static struct page *__get_meta_page(struct f2fs_sb_info *sbi, pgoff_t index,
 	 * readonly and make sure do not write checkpoint with non-uptodate
 	 * meta page.
 	 */
-	if (unlikely(!PageUptodate(page)))
+	if (unlikely(!PageUptodate(page))) {
+		memset(page_address(page), 0, PAGE_SIZE);
 		f2fs_stop_checkpoint(sbi, false);
+	}
 out:
 	return page;
 }
 
-struct page *get_meta_page(struct f2fs_sb_info *sbi, pgoff_t index)
+struct page *f2fs_get_meta_page(struct f2fs_sb_info *sbi, pgoff_t index)
 {
 	return __get_meta_page(sbi, index, true);
 }
 
 /* for POR only */
-struct page *get_tmp_page(struct f2fs_sb_info *sbi, pgoff_t index)
+struct page *f2fs_get_tmp_page(struct f2fs_sb_info *sbi, pgoff_t index)
 {
 	return __get_meta_page(sbi, index, false);
 }
 
-bool is_valid_blkaddr(struct f2fs_sb_info *sbi, block_t blkaddr, int type)
+bool f2fs_is_valid_meta_blkaddr(struct f2fs_sb_info *sbi,
+					block_t blkaddr, int type)
 {
 	switch (type) {
 	case META_NAT:
@@ -151,7 +154,7 @@ bool is_valid_blkaddr(struct f2fs_sb_info *sbi, block_t blkaddr, int type)
 /*
  * Readahead CP/NAT/SIT/SSA pages
  */
-int ra_meta_pages(struct f2fs_sb_info *sbi, block_t start, int nrpages,
+int f2fs_ra_meta_pages(struct f2fs_sb_info *sbi, block_t start, int nrpages,
 							int type, bool sync)
 {
 	struct page *page;
@@ -160,8 +163,10 @@ int ra_meta_pages(struct f2fs_sb_info *sbi, block_t start, int nrpages,
 		.sbi = sbi,
 		.type = META,
 		.op = REQ_OP_READ,
-		.op_flags = sync ? (READ_SYNC | REQ_META | REQ_PRIO) : REQ_RAHEAD,
+		.op_flags = sync ? (REQ_META | REQ_PRIO) : REQ_RAHEAD,
 		.encrypted_page = NULL,
+		.in_list = false,
+		.is_meta = (type != META_POR),
 	};
 	struct blk_plug plug;
 
@@ -171,7 +176,7 @@ int ra_meta_pages(struct f2fs_sb_info *sbi, block_t start, int nrpages,
 	blk_start_plug(&plug);
 	for (; nrpages-- > 0; blkno++) {
 
-		if (!is_valid_blkaddr(sbi, blkno, type))
+		if (!f2fs_is_valid_meta_blkaddr(sbi, blkno, type))
 			goto out;
 
 		switch (type) {
@@ -207,17 +212,15 @@ int ra_meta_pages(struct f2fs_sb_info *sbi, block_t start, int nrpages,
 		}
 
 		fio.page = page;
-		fio.old_blkaddr = fio.new_blkaddr;
-		f2fs_submit_page_mbio(&fio);
+		f2fs_submit_page_bio(&fio);
 		f2fs_put_page(page, 0);
 	}
 out:
-	f2fs_submit_merged_bio(sbi, META, READ);
 	blk_finish_plug(&plug);
 	return blkno - start;
 }
 
-void ra_meta_pages_cond(struct f2fs_sb_info *sbi, pgoff_t index)
+void f2fs_ra_meta_pages_cond(struct f2fs_sb_info *sbi, pgoff_t index)
 {
 	struct page *page;
 	bool readahead = false;
@@ -228,33 +231,38 @@ void ra_meta_pages_cond(struct f2fs_sb_info *sbi, pgoff_t index)
 	f2fs_put_page(page, 0);
 
 	if (readahead)
-		ra_meta_pages(sbi, index, MAX_BIO_BLOCKS(sbi), META_POR, true);
+		f2fs_ra_meta_pages(sbi, index, BIO_MAX_PAGES, META_POR, true);
 }
 
-static int f2fs_write_meta_page(struct page *page,
-				struct writeback_control *wbc)
+static int __f2fs_write_meta_page(struct page *page,
+				struct writeback_control *wbc,
+				enum iostat_type io_type)
 {
 	struct f2fs_sb_info *sbi = F2FS_P_SB(page);
 
 	trace_f2fs_writepage(page, META);
 
+	if (unlikely(f2fs_cp_error(sbi))) {
+		dec_page_count(sbi, F2FS_DIRTY_META);
+		unlock_page(page);
+		return 0;
+	}
 	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
 		goto redirty_out;
 	if (wbc->for_reclaim && page->index < GET_SUM_BLOCK(sbi, 0))
 		goto redirty_out;
-	if (unlikely(f2fs_cp_error(sbi)))
-		goto redirty_out;
 
-	write_meta_page(sbi, page);
+	f2fs_do_write_meta_page(sbi, page, io_type);
 	dec_page_count(sbi, F2FS_DIRTY_META);
 
 	if (wbc->for_reclaim)
-		f2fs_submit_merged_bio_cond(sbi, NULL, page, 0, META, WRITE);
+		f2fs_submit_merged_write_cond(sbi, page->mapping->host,
+						0, page->index, META);
 
 	unlock_page(page);
 
 	if (unlikely(f2fs_cp_error(sbi)))
-		f2fs_submit_merged_bio(sbi, META, WRITE);
+		f2fs_submit_merged_write(sbi, META);
 
 	return 0;
 
@@ -263,23 +271,33 @@ static int f2fs_write_meta_page(struct page *page,
 	return AOP_WRITEPAGE_ACTIVATE;
 }
 
+static int f2fs_write_meta_page(struct page *page,
+				struct writeback_control *wbc)
+{
+	return __f2fs_write_meta_page(page, wbc, FS_META_IO);
+}
+
 static int f2fs_write_meta_pages(struct address_space *mapping,
 				struct writeback_control *wbc)
 {
 	struct f2fs_sb_info *sbi = F2FS_M_SB(mapping);
 	long diff, written;
 
+	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
+		goto skip_write;
+
 	/* collect a number of dirty meta pages and write together */
 	if (wbc->for_kupdate ||
 		get_pages(sbi, F2FS_DIRTY_META) < nr_pages_to_skip(sbi, META))
 		goto skip_write;
 
-	trace_f2fs_writepages(mapping->host, wbc, META);
+	/* if locked failed, cp will flush dirty pages instead */
+	if (!mutex_trylock(&sbi->cp_mutex))
+		goto skip_write;
 
-	/* if mounting is failed, skip writing node pages */
-	mutex_lock(&sbi->cp_mutex);
+	trace_f2fs_writepages(mapping->host, wbc, META);
 	diff = nr_pages_to_write(sbi, META, wbc);
-	written = sync_meta_pages(sbi, META, wbc->nr_to_write);
+	written = f2fs_sync_meta_pages(sbi, META, wbc->nr_to_write, FS_META_IO);
 	mutex_unlock(&sbi->cp_mutex);
 	wbc->nr_to_write = max((long)0, wbc->nr_to_write - written - diff);
 	return 0;
@@ -290,13 +308,14 @@ static int f2fs_write_meta_pages(struct address_space *mapping,
 	return 0;
 }
 
-long sync_meta_pages(struct f2fs_sb_info *sbi, enum page_type type,
-						long nr_to_write)
+long f2fs_sync_meta_pages(struct f2fs_sb_info *sbi, enum page_type type,
+				long nr_to_write, enum iostat_type io_type)
 {
 	struct address_space *mapping = META_MAPPING(sbi);
-	pgoff_t index = 0, end = ULONG_MAX, prev = ULONG_MAX;
+	pgoff_t index = 0, prev = ULONG_MAX;
 	struct pagevec pvec;
 	long nwritten = 0;
+	int nr_pages;
 	struct writeback_control wbc = {
 		.for_reclaim = 0,
 	};
@@ -306,13 +325,9 @@ long sync_meta_pages(struct f2fs_sb_info *sbi, enum page_type type,
 
 	blk_start_plug(&plug);
 
-	while (index <= end) {
-		int i, nr_pages;
-		nr_pages = pagevec_lookup_tag(&pvec, mapping, &index,
-				PAGECACHE_TAG_DIRTY,
-				min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1);
-		if (unlikely(nr_pages == 0))
-			break;
+	while ((nr_pages = pagevec_lookup_tag(&pvec, mapping, &index,
+				PAGECACHE_TAG_DIRTY))) {
+		int i;
 
 		for (i = 0; i < nr_pages; i++) {
 			struct page *page = pvec.pages[i];
@@ -342,7 +357,7 @@ long sync_meta_pages(struct f2fs_sb_info *sbi, enum page_type type,
 			if (!clear_page_dirty_for_io(page))
 				goto continue_unlock;
 
-			if (mapping->a_ops->writepage(page, &wbc)) {
+			if (__f2fs_write_meta_page(page, &wbc, io_type)) {
 				unlock_page(page);
 				break;
 			}
@@ -356,7 +371,7 @@ long sync_meta_pages(struct f2fs_sb_info *sbi, enum page_type type,
 	}
 stop:
 	if (nwritten)
-		f2fs_submit_merged_bio(sbi, type, WRITE);
+		f2fs_submit_merged_write(sbi, type);
 
 	blk_finish_plug(&plug);
 
@@ -370,7 +385,7 @@ static int f2fs_set_meta_page_dirty(struct page *page)
 	if (!PageUptodate(page))
 		SetPageUptodate(page);
 	if (!PageDirty(page)) {
-		f2fs_set_page_dirty_nobuffers(page);
+		__set_page_dirty_nobuffers(page);
 		inc_page_count(F2FS_P_SB(page), F2FS_DIRTY_META);
 		SetPagePrivate(page);
 		f2fs_trace_pid(page);
@@ -390,24 +405,23 @@ static int f2fs_set_meta_page_dirty(struct page *page)
 #endif
 };
 
-static void __add_ino_entry(struct f2fs_sb_info *sbi, nid_t ino, int type)
+static void __add_ino_entry(struct f2fs_sb_info *sbi, nid_t ino,
+						unsigned int devidx, int type)
 {
 	struct inode_management *im = &sbi->im[type];
 	struct ino_entry *e, *tmp;
 
 	tmp = f2fs_kmem_cache_alloc(ino_entry_slab, GFP_NOFS);
-retry:
+
 	radix_tree_preload(GFP_NOFS | __GFP_NOFAIL);
 
 	spin_lock(&im->ino_lock);
 	e = radix_tree_lookup(&im->ino_root, ino);
 	if (!e) {
 		e = tmp;
-		if (radix_tree_insert(&im->ino_root, ino, e)) {
-			spin_unlock(&im->ino_lock);
-			radix_tree_preload_end();
-			goto retry;
-		}
+		if (unlikely(radix_tree_insert(&im->ino_root, ino, e)))
+			f2fs_bug_on(sbi, 1);
+
 		memset(e, 0, sizeof(struct ino_entry));
 		e->ino = ino;
 
@@ -415,6 +429,10 @@ static void __add_ino_entry(struct f2fs_sb_info *sbi, nid_t ino, int type)
 		if (type != ORPHAN_INO)
 			im->ino_num++;
 	}
+
+	if (type == FLUSH_INO)
+		f2fs_set_bit(devidx, (char *)&e->dirty_device);
+
 	spin_unlock(&im->ino_lock);
 	radix_tree_preload_end();
 
@@ -440,20 +458,20 @@ static void __remove_ino_entry(struct f2fs_sb_info *sbi, nid_t ino, int type)
 	spin_unlock(&im->ino_lock);
 }
 
-void add_ino_entry(struct f2fs_sb_info *sbi, nid_t ino, int type)
+void f2fs_add_ino_entry(struct f2fs_sb_info *sbi, nid_t ino, int type)
 {
 	/* add new dirty ino entry into list */
-	__add_ino_entry(sbi, ino, type);
+	__add_ino_entry(sbi, ino, 0, type);
 }
 
-void remove_ino_entry(struct f2fs_sb_info *sbi, nid_t ino, int type)
+void f2fs_remove_ino_entry(struct f2fs_sb_info *sbi, nid_t ino, int type)
 {
 	/* remove dirty ino entry from list */
 	__remove_ino_entry(sbi, ino, type);
 }
 
 /* mode should be APPEND_INO or UPDATE_INO */
-bool exist_written_data(struct f2fs_sb_info *sbi, nid_t ino, int mode)
+bool f2fs_exist_written_data(struct f2fs_sb_info *sbi, nid_t ino, int mode)
 {
 	struct inode_management *im = &sbi->im[mode];
 	struct ino_entry *e;
@@ -464,12 +482,12 @@ bool exist_written_data(struct f2fs_sb_info *sbi, nid_t ino, int mode)
 	return e ? true : false;
 }
 
-void release_ino_entry(struct f2fs_sb_info *sbi, bool all)
+void f2fs_release_ino_entry(struct f2fs_sb_info *sbi, bool all)
 {
 	struct ino_entry *e, *tmp;
 	int i;
 
-	for (i = all ? ORPHAN_INO: APPEND_INO; i <= UPDATE_INO; i++) {
+	for (i = all ? ORPHAN_INO : APPEND_INO; i < MAX_INO_ENTRY; i++) {
 		struct inode_management *im = &sbi->im[i];
 
 		spin_lock(&im->ino_lock);
@@ -483,7 +501,28 @@ void release_ino_entry(struct f2fs_sb_info *sbi, bool all)
 	}
 }
 
-int acquire_orphan_inode(struct f2fs_sb_info *sbi)
+void f2fs_set_dirty_device(struct f2fs_sb_info *sbi, nid_t ino,
+					unsigned int devidx, int type)
+{
+	__add_ino_entry(sbi, ino, devidx, type);
+}
+
+bool f2fs_is_dirty_device(struct f2fs_sb_info *sbi, nid_t ino,
+					unsigned int devidx, int type)
+{
+	struct inode_management *im = &sbi->im[type];
+	struct ino_entry *e;
+	bool is_dirty = false;
+
+	spin_lock(&im->ino_lock);
+	e = radix_tree_lookup(&im->ino_root, ino);
+	if (e && f2fs_test_bit(devidx, (char *)&e->dirty_device))
+		is_dirty = true;
+	spin_unlock(&im->ino_lock);
+	return is_dirty;
+}
+
+int f2fs_acquire_orphan_inode(struct f2fs_sb_info *sbi)
 {
 	struct inode_management *im = &sbi->im[ORPHAN_INO];
 	int err = 0;
@@ -493,6 +532,7 @@ int acquire_orphan_inode(struct f2fs_sb_info *sbi)
 #ifdef CONFIG_F2FS_FAULT_INJECTION
 	if (time_to_inject(sbi, FAULT_ORPHAN)) {
 		spin_unlock(&im->ino_lock);
+		f2fs_show_injection_info(FAULT_ORPHAN);
 		return -ENOSPC;
 	}
 #endif
@@ -505,7 +545,7 @@ int acquire_orphan_inode(struct f2fs_sb_info *sbi)
 	return err;
 }
 
-void release_orphan_inode(struct f2fs_sb_info *sbi)
+void f2fs_release_orphan_inode(struct f2fs_sb_info *sbi)
 {
 	struct inode_management *im = &sbi->im[ORPHAN_INO];
 
@@ -515,14 +555,14 @@ void release_orphan_inode(struct f2fs_sb_info *sbi)
 	spin_unlock(&im->ino_lock);
 }
 
-void add_orphan_inode(struct inode *inode)
+void f2fs_add_orphan_inode(struct inode *inode)
 {
 	/* add new orphan ino entry into list */
-	__add_ino_entry(F2FS_I_SB(inode), inode->i_ino, ORPHAN_INO);
-	update_inode_page(inode);
+	__add_ino_entry(F2FS_I_SB(inode), inode->i_ino, 0, ORPHAN_INO);
+	f2fs_update_inode_page(inode);
 }
 
-void remove_orphan_inode(struct f2fs_sb_info *sbi, nid_t ino)
+void f2fs_remove_orphan_inode(struct f2fs_sb_info *sbi, nid_t ino)
 {
 	/* remove orphan entry from orphan list */
 	__remove_ino_entry(sbi, ino, ORPHAN_INO);
@@ -532,17 +572,12 @@ static int recover_orphan_inode(struct f2fs_sb_info *sbi, nid_t ino)
 {
 	struct inode *inode;
 	struct node_info ni;
-	int err = acquire_orphan_inode(sbi);
+	int err = f2fs_acquire_orphan_inode(sbi);
 
-	if (err) {
-		set_sbi_flag(sbi, SBI_NEED_FSCK);
-		f2fs_msg(sbi->sb, KERN_WARNING,
-				"%s: orphan failed (ino=%x), run fsck to fix.",
-				__func__, ino);
-		return err;
-	}
+	if (err)
+		goto err_out;
 
-	__add_ino_entry(sbi, ino, ORPHAN_INO);
+	__add_ino_entry(sbi, ino, 0, ORPHAN_INO);
 
 	inode = f2fs_iget_retry(sbi->sb, ino);
 	if (IS_ERR(inode)) {
@@ -554,40 +589,67 @@ static int recover_orphan_inode(struct f2fs_sb_info *sbi, nid_t ino)
 		return PTR_ERR(inode);
 	}
 
+	err = dquot_initialize(inode);
+	if (err) {
+		iput(inode);
+		goto err_out;
+	}
+
 	clear_nlink(inode);
 
 	/* truncate all the data during iput */
 	iput(inode);
 
-	get_node_info(sbi, ino, &ni);
+	f2fs_get_node_info(sbi, ino, &ni);
 
 	/* ENOMEM was fully retried in f2fs_evict_inode. */
 	if (ni.blk_addr != NULL_ADDR) {
-		set_sbi_flag(sbi, SBI_NEED_FSCK);
-		f2fs_msg(sbi->sb, KERN_WARNING,
-			"%s: orphan failed (ino=%x), run fsck to fix.",
-				__func__, ino);
-		return -EIO;
+		err = -EIO;
+		goto err_out;
 	}
 	__remove_ino_entry(sbi, ino, ORPHAN_INO);
 	return 0;
+
+err_out:
+	set_sbi_flag(sbi, SBI_NEED_FSCK);
+	f2fs_msg(sbi->sb, KERN_WARNING,
+			"%s: orphan failed (ino=%x), run fsck to fix.",
+			__func__, ino);
+	return err;
 }
 
-int recover_orphan_inodes(struct f2fs_sb_info *sbi)
+int f2fs_recover_orphan_inodes(struct f2fs_sb_info *sbi)
 {
 	block_t start_blk, orphan_blocks, i, j;
-	int err;
+	unsigned int s_flags = sbi->sb->s_flags;
+	int err = 0;
+#ifdef CONFIG_QUOTA
+	int quota_enabled;
+#endif
 
 	if (!is_set_ckpt_flags(sbi, CP_ORPHAN_PRESENT_FLAG))
 		return 0;
 
+	if (s_flags & MS_RDONLY) {
+		f2fs_msg(sbi->sb, KERN_INFO, "orphan cleanup on readonly fs");
+		sbi->sb->s_flags &= ~MS_RDONLY;
+	}
+
+#ifdef CONFIG_QUOTA
+	/* Needed for iput() to work correctly and not trash data */
+	sbi->sb->s_flags |= MS_ACTIVE;
+
+	/* Turn on quotas so that they are updated correctly */
+	quota_enabled = f2fs_enable_quota_files(sbi, s_flags & MS_RDONLY);
+#endif
+
 	start_blk = __start_cp_addr(sbi) + 1 + __cp_payload(sbi);
 	orphan_blocks = __start_sum_addr(sbi) - 1 - __cp_payload(sbi);
 
-	ra_meta_pages(sbi, start_blk, orphan_blocks, META_CP, true);
+	f2fs_ra_meta_pages(sbi, start_blk, orphan_blocks, META_CP, true);
 
 	for (i = 0; i < orphan_blocks; i++) {
-		struct page *page = get_meta_page(sbi, start_blk + i);
+		struct page *page = f2fs_get_meta_page(sbi, start_blk + i);
 		struct f2fs_orphan_block *orphan_blk;
 
 		orphan_blk = (struct f2fs_orphan_block *)page_address(page);
@@ -596,14 +658,22 @@ int recover_orphan_inodes(struct f2fs_sb_info *sbi)
 			err = recover_orphan_inode(sbi, ino);
 			if (err) {
 				f2fs_put_page(page, 1);
-				return err;
+				goto out;
 			}
 		}
 		f2fs_put_page(page, 1);
 	}
 	/* clear Orphan Flag */
 	clear_ckpt_flags(sbi, CP_ORPHAN_PRESENT_FLAG);
-	return 0;
+out:
+#ifdef CONFIG_QUOTA
+	/* Turn quotas off */
+	if (quota_enabled)
+		f2fs_quota_off_umount(sbi->sb);
+#endif
+	sbi->sb->s_flags = s_flags; /* Restore MS_RDONLY status */
+
+	return err;
 }
 
 static void write_orphan_inodes(struct f2fs_sb_info *sbi, block_t start_blk)
@@ -629,7 +699,7 @@ static void write_orphan_inodes(struct f2fs_sb_info *sbi, block_t start_blk)
 	/* loop for each orphan inode entry and write them in Jornal block */
 	list_for_each_entry(orphan, head, list) {
 		if (!page) {
-			page = grab_meta_page(sbi, start_blk++);
+			page = f2fs_grab_meta_page(sbi, start_blk++);
 			orphan_blk =
 				(struct f2fs_orphan_block *)page_address(page);
 			memset(orphan_blk, 0, sizeof(*orphan_blk));
@@ -671,18 +741,17 @@ static int get_checkpoint_version(struct f2fs_sb_info *sbi, block_t cp_addr,
 	size_t crc_offset = 0;
 	__u32 crc = 0;
 
-	*cp_page = get_meta_page(sbi, cp_addr);
+	*cp_page = f2fs_get_meta_page(sbi, cp_addr);
 	*cp_block = (struct f2fs_checkpoint *)page_address(*cp_page);
 
 	crc_offset = le32_to_cpu((*cp_block)->checksum_offset);
-	if (crc_offset >= blk_size) {
+	if (crc_offset > (blk_size - sizeof(__le32))) {
 		f2fs_msg(sbi->sb, KERN_WARNING,
 			"invalid crc_offset: %zu", crc_offset);
 		return -EINVAL;
 	}
 
-	crc = le32_to_cpu(*((__le32 *)((unsigned char *)*cp_block
-							+ crc_offset)));
+	crc = cur_cp_crc(*cp_block);
 	if (!f2fs_crc_valid(sbi, crc, *cp_block, crc_offset)) {
 		f2fs_msg(sbi->sb, KERN_WARNING, "invalid crc value");
 		return -EINVAL;
@@ -725,7 +794,7 @@ static struct page *validate_checkpoint(struct f2fs_sb_info *sbi,
 	return NULL;
 }
 
-int get_valid_checkpoint(struct f2fs_sb_info *sbi)
+int f2fs_get_valid_checkpoint(struct f2fs_sb_info *sbi)
 {
 	struct f2fs_checkpoint *cp_block;
 	struct f2fs_super_block *fsb = sbi->raw_super;
@@ -737,7 +806,8 @@ int get_valid_checkpoint(struct f2fs_sb_info *sbi)
 	block_t cp_blk_no;
 	int i;
 
-	sbi->ckpt = kzalloc(cp_blks * blk_size, GFP_KERNEL);
+	sbi->ckpt = f2fs_kzalloc(sbi, array_size(blk_size, cp_blks),
+				 GFP_KERNEL);
 	if (!sbi->ckpt)
 		return -ENOMEM;
 	/*
@@ -769,8 +839,8 @@ int get_valid_checkpoint(struct f2fs_sb_info *sbi)
 	memcpy(sbi->ckpt, cp_block, blk_size);
 
 	/* Sanity checking of checkpoint */
-	if (sanity_check_ckpt(sbi))
-		goto fail_no_cp;
+	if (f2fs_sanity_check_ckpt(sbi))
+		goto free_fail_no_cp;
 
 	if (cur_page == cp1)
 		sbi->cur_cp_pack = 1;
@@ -788,7 +858,7 @@ int get_valid_checkpoint(struct f2fs_sb_info *sbi)
 		void *sit_bitmap_ptr;
 		unsigned char *ckpt = (unsigned char *)sbi->ckpt;
 
-		cur_page = get_meta_page(sbi, cp_blk_no + i);
+		cur_page = f2fs_get_meta_page(sbi, cp_blk_no + i);
 		sit_bitmap_ptr = page_address(cur_page);
 		memcpy(ckpt + i * blk_size, sit_bitmap_ptr, blk_size);
 		f2fs_put_page(cur_page, 1);
@@ -798,6 +868,9 @@ int get_valid_checkpoint(struct f2fs_sb_info *sbi)
 	f2fs_put_page(cp2, 1);
 	return 0;
 
+free_fail_no_cp:
+	f2fs_put_page(cp1, 1);
+	f2fs_put_page(cp2, 1);
 fail_no_cp:
 	kfree(sbi->ckpt);
 	return -EINVAL;
@@ -812,7 +885,9 @@ static void __add_dirty_inode(struct inode *inode, enum inode_type type)
 		return;
 
 	set_inode_flag(inode, flag);
-	list_add_tail(&F2FS_I(inode)->dirty_list, &sbi->inode_list[type]);
+	if (!f2fs_is_volatile_file(inode))
+		list_add_tail(&F2FS_I(inode)->dirty_list,
+						&sbi->inode_list[type]);
 	stat_inc_dirty_inode(sbi, type);
 }
 
@@ -828,7 +903,7 @@ static void __remove_dirty_inode(struct inode *inode, enum inode_type type)
 	stat_dec_dirty_inode(F2FS_I_SB(inode), type);
 }
 
-void update_dirty_page(struct inode *inode, struct page *page)
+void f2fs_update_dirty_page(struct inode *inode, struct page *page)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	enum inode_type type = S_ISDIR(inode->i_mode) ? DIR_INODE : FILE_INODE;
@@ -847,7 +922,7 @@ void update_dirty_page(struct inode *inode, struct page *page)
 	f2fs_trace_pid(page);
 }
 
-void remove_dirty_inode(struct inode *inode)
+void f2fs_remove_dirty_inode(struct inode *inode)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	enum inode_type type = S_ISDIR(inode->i_mode) ? DIR_INODE : FILE_INODE;
@@ -864,12 +939,13 @@ void remove_dirty_inode(struct inode *inode)
 	spin_unlock(&sbi->inode_lock[type]);
 }
 
-int sync_dirty_inodes(struct f2fs_sb_info *sbi, enum inode_type type)
+int f2fs_sync_dirty_inodes(struct f2fs_sb_info *sbi, enum inode_type type)
 {
 	struct list_head *head;
 	struct inode *inode;
 	struct f2fs_inode_info *fi;
 	bool is_dir = (type == DIR_INODE);
+	unsigned long ino = 0;
 
 	trace_f2fs_sync_dirty_inodes_enter(sbi->sb, is_dir,
 				get_pages(sbi, is_dir ?
@@ -888,18 +964,34 @@ int sync_dirty_inodes(struct f2fs_sb_info *sbi, enum inode_type type)
 				F2FS_DIRTY_DENTS : F2FS_DIRTY_DATA));
 		return 0;
 	}
-	fi = list_entry(head->next, struct f2fs_inode_info, dirty_list);
+	fi = list_first_entry(head, struct f2fs_inode_info, dirty_list);
 	inode = igrab(&fi->vfs_inode);
 	spin_unlock(&sbi->inode_lock[type]);
 	if (inode) {
+		unsigned long cur_ino = inode->i_ino;
+
+		if (is_dir)
+			F2FS_I(inode)->cp_task = current;
+
 		filemap_fdatawrite(inode->i_mapping);
+
+		if (is_dir)
+			F2FS_I(inode)->cp_task = NULL;
+
 		iput(inode);
+		/* We need to give cpu to another writers. */
+		if (ino == cur_ino) {
+			congestion_wait(BLK_RW_ASYNC, HZ/50);
+			cond_resched();
+		} else {
+			ino = cur_ino;
+		}
 	} else {
 		/*
 		 * We should submit bio, since it exists several
 		 * wribacking dentry pages in the freeing inode.
 		 */
-		f2fs_submit_merged_bio(sbi, DATA, WRITE);
+		f2fs_submit_merged_write(sbi, DATA);
 		cond_resched();
 	}
 	goto retry;
@@ -921,18 +1013,35 @@ int f2fs_sync_inode_meta(struct f2fs_sb_info *sbi)
 			spin_unlock(&sbi->inode_lock[DIRTY_META]);
 			return 0;
 		}
-		fi = list_entry(head->next, struct f2fs_inode_info,
+		fi = list_first_entry(head, struct f2fs_inode_info,
 							gdirty_list);
 		inode = igrab(&fi->vfs_inode);
 		spin_unlock(&sbi->inode_lock[DIRTY_META]);
 		if (inode) {
-			update_inode_page(inode);
+			sync_inode_metadata(inode, 0);
+
+			/* it's on eviction */
+			if (is_inode_flag_set(inode, FI_DIRTY_INODE))
+				f2fs_update_inode_page(inode);
 			iput(inode);
 		}
-	};
+	}
 	return 0;
 }
 
+static void __prepare_cp_block(struct f2fs_sb_info *sbi)
+{
+	struct f2fs_checkpoint *ckpt = F2FS_CKPT(sbi);
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
+	nid_t last_nid = nm_i->next_scan_nid;
+
+	next_free_nid(sbi, &last_nid);
+	ckpt->valid_block_count = cpu_to_le64(valid_user_blocks(sbi));
+	ckpt->valid_node_count = cpu_to_le32(valid_node_count(sbi));
+	ckpt->valid_inode_count = cpu_to_le32(valid_inode_count(sbi));
+	ckpt->next_free_nid = cpu_to_le32(last_nid);
+}
+
 /*
  * Freeze all the FS-operations for checkpoint.
  */
@@ -953,36 +1062,52 @@ static int block_operations(struct f2fs_sb_info *sbi)
 	/* write all the dirty dentry pages */
 	if (get_pages(sbi, F2FS_DIRTY_DENTS)) {
 		f2fs_unlock_all(sbi);
-		err = sync_dirty_inodes(sbi, DIR_INODE);
+		err = f2fs_sync_dirty_inodes(sbi, DIR_INODE);
 		if (err)
 			goto out;
+		cond_resched();
 		goto retry_flush_dents;
 	}
 
+	/*
+	 * POR: we should ensure that there are no dirty node pages
+	 * until finishing nat/sit flush. inode->i_blocks can be updated.
+	 */
+	down_write(&sbi->node_change);
+
 	if (get_pages(sbi, F2FS_DIRTY_IMETA)) {
+		up_write(&sbi->node_change);
 		f2fs_unlock_all(sbi);
 		err = f2fs_sync_inode_meta(sbi);
 		if (err)
 			goto out;
+		cond_resched();
 		goto retry_flush_dents;
 	}
 
-	/*
-	 * POR: we should ensure that there are no dirty node pages
-	 * until finishing nat/sit flush.
-	 */
 retry_flush_nodes:
 	down_write(&sbi->node_write);
 
 	if (get_pages(sbi, F2FS_DIRTY_NODES)) {
 		up_write(&sbi->node_write);
-		err = sync_node_pages(sbi, &wbc);
+		atomic_inc(&sbi->wb_sync_req[NODE]);
+		err = f2fs_sync_node_pages(sbi, &wbc, false, FS_CP_NODE_IO);
+		atomic_dec(&sbi->wb_sync_req[NODE]);
 		if (err) {
+			up_write(&sbi->node_change);
 			f2fs_unlock_all(sbi);
 			goto out;
 		}
+		cond_resched();
 		goto retry_flush_nodes;
 	}
+
+	/*
+	 * sbi->node_change is used only for AIO write_begin path which produces
+	 * dirty node blocks and some checkpoint values by block allocation.
+	 */
+	__prepare_cp_block(sbi);
+	up_write(&sbi->node_change);
 out:
 	blk_finish_plug(&plug);
 	return err;
@@ -991,8 +1116,6 @@ static int block_operations(struct f2fs_sb_info *sbi)
 static void unblock_operations(struct f2fs_sb_info *sbi)
 {
 	up_write(&sbi->node_write);
-
-	build_free_nids(sbi);
 	f2fs_unlock_all(sbi);
 }
 
@@ -1003,7 +1126,7 @@ static void wait_on_all_pages_writeback(struct f2fs_sb_info *sbi)
 	for (;;) {
 		prepare_to_wait(&sbi->cp_wait, &wait, TASK_UNINTERRUPTIBLE);
 
-		if (!atomic_read(&sbi->nr_wb_bios))
+		if (!get_pages(sbi, F2FS_WB_CP_DATA))
 			break;
 
 		io_schedule_timeout(5*HZ);
@@ -1015,15 +1138,26 @@ static void update_ckpt_flags(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 {
 	unsigned long orphan_num = sbi->im[ORPHAN_INO].ino_num;
 	struct f2fs_checkpoint *ckpt = F2FS_CKPT(sbi);
+	unsigned long flags;
+
+	spin_lock_irqsave(&sbi->cp_lock, flags);
+
+	if ((cpc->reason & CP_UMOUNT) &&
+			le32_to_cpu(ckpt->cp_pack_total_block_count) >
+			sbi->blocks_per_seg - NM_I(sbi)->nat_bits_blocks)
+		disable_nat_bits(sbi, false);
 
-	spin_lock(&sbi->cp_lock);
+	if (cpc->reason & CP_TRIMMED)
+		__set_ckpt_flags(ckpt, CP_TRIMMED_FLAG);
+	else
+		__clear_ckpt_flags(ckpt, CP_TRIMMED_FLAG);
 
-	if (cpc->reason == CP_UMOUNT)
+	if (cpc->reason & CP_UMOUNT)
 		__set_ckpt_flags(ckpt, CP_UMOUNT_FLAG);
 	else
 		__clear_ckpt_flags(ckpt, CP_UMOUNT_FLAG);
 
-	if (cpc->reason == CP_FASTBOOT)
+	if (cpc->reason & CP_FASTBOOT)
 		__set_ckpt_flags(ckpt, CP_FASTBOOT_FLAG);
 	else
 		__clear_ckpt_flags(ckpt, CP_FASTBOOT_FLAG);
@@ -1038,16 +1172,49 @@ static void update_ckpt_flags(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 
 	/* set this flag to activate crc|cp_ver for recovery */
 	__set_ckpt_flags(ckpt, CP_CRC_RECOVERY_FLAG);
+	__clear_ckpt_flags(ckpt, CP_NOCRC_RECOVERY_FLAG);
 
-	spin_unlock(&sbi->cp_lock);
+	spin_unlock_irqrestore(&sbi->cp_lock, flags);
+}
+
+static void commit_checkpoint(struct f2fs_sb_info *sbi,
+	void *src, block_t blk_addr)
+{
+	struct writeback_control wbc = {
+		.for_reclaim = 0,
+	};
+
+	/*
+	 * pagevec_lookup_tag and lock_page again will take
+	 * some extra time. Therefore, f2fs_update_meta_pages and
+	 * f2fs_sync_meta_pages are combined in this function.
+	 */
+	struct page *page = f2fs_grab_meta_page(sbi, blk_addr);
+	int err;
+
+	memcpy(page_address(page), src, PAGE_SIZE);
+	set_page_dirty(page);
+
+	f2fs_wait_on_page_writeback(page, META, true);
+	f2fs_bug_on(sbi, PageWriteback(page));
+	if (unlikely(!clear_page_dirty_for_io(page)))
+		f2fs_bug_on(sbi, 1);
+
+	/* writeout cp pack 2 page */
+	err = __f2fs_write_meta_page(page, &wbc, FS_CP_META_IO);
+	f2fs_bug_on(sbi, err);
+
+	f2fs_put_page(page, 0);
+
+	/* submit checkpoint (with barrier if NOBARRIER is not set) */
+	f2fs_submit_merged_write(sbi, META_FLUSH);
 }
 
 static int do_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 {
 	struct f2fs_checkpoint *ckpt = F2FS_CKPT(sbi);
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
-	unsigned long orphan_num = sbi->im[ORPHAN_INO].ino_num;
-	nid_t last_nid = nm_i->next_scan_nid;
+	unsigned long orphan_num = sbi->im[ORPHAN_INO].ino_num, flags;
 	block_t start_blk;
 	unsigned int data_sum_blocks, orphan_blocks;
 	__u32 crc32 = 0;
@@ -1056,22 +1223,20 @@ static int do_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 	struct super_block *sb = sbi->sb;
 	struct curseg_info *seg_i = CURSEG_I(sbi, CURSEG_HOT_NODE);
 	u64 kbytes_written;
+	int err;
 
 	/* Flush all the NAT/SIT pages */
 	while (get_pages(sbi, F2FS_DIRTY_META)) {
-		sync_meta_pages(sbi, META, LONG_MAX);
+		f2fs_sync_meta_pages(sbi, META, LONG_MAX, FS_CP_META_IO);
 		if (unlikely(f2fs_cp_error(sbi)))
 			return -EIO;
 	}
 
-	next_free_nid(sbi, &last_nid);
-
 	/*
 	 * modify checkpoint
 	 * version number is already updated
 	 */
-	ckpt->elapsed_time = cpu_to_le64(get_mtime(sbi));
-	ckpt->valid_block_count = cpu_to_le64(valid_user_blocks(sbi));
+	ckpt->elapsed_time = cpu_to_le64(get_mtime(sbi, true));
 	ckpt->free_segment_count = cpu_to_le32(free_segments(sbi));
 	for (i = 0; i < NR_CURSEG_NODE_TYPE; i++) {
 		ckpt->cur_node_segno[i] =
@@ -1090,18 +1255,14 @@ static int do_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 				curseg_alloc_type(sbi, i + CURSEG_HOT_DATA);
 	}
 
-	ckpt->valid_node_count = cpu_to_le32(valid_node_count(sbi));
-	ckpt->valid_inode_count = cpu_to_le32(valid_inode_count(sbi));
-	ckpt->next_free_nid = cpu_to_le32(last_nid);
-
 	/* 2 cp  + n data seg summary + orphan inode blocks */
-	data_sum_blocks = npages_for_summary_flush(sbi, false);
-	spin_lock(&sbi->cp_lock);
+	data_sum_blocks = f2fs_npages_for_summary_flush(sbi, false);
+	spin_lock_irqsave(&sbi->cp_lock, flags);
 	if (data_sum_blocks < NR_CURSEG_DATA_TYPE)
 		__set_ckpt_flags(ckpt, CP_COMPACT_SUM_FLAG);
 	else
 		__clear_ckpt_flags(ckpt, CP_COMPACT_SUM_FLAG);
-	spin_unlock(&sbi->cp_lock);
+	spin_unlock_irqrestore(&sbi->cp_lock, flags);
 
 	orphan_blocks = GET_ORPHAN_BLOCKS(orphan_num);
 	ckpt->cp_pack_start_sum = cpu_to_le32(1 + cp_payload_blks +
@@ -1130,16 +1291,33 @@ static int do_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 
 	start_blk = __start_cp_next_addr(sbi);
 
-	/* need to wait for end_io results */
-	wait_on_all_pages_writeback(sbi);
-	if (unlikely(f2fs_cp_error(sbi)))
-		return -EIO;
+	/* write nat bits */
+	if (enabled_nat_bits(sbi, cpc)) {
+		__u64 cp_ver = cur_cp_version(ckpt);
+		block_t blk;
+
+		cp_ver |= ((__u64)crc32 << 32);
+		*(__le64 *)nm_i->nat_bits = cpu_to_le64(cp_ver);
+
+		blk = start_blk + sbi->blocks_per_seg - nm_i->nat_bits_blocks;
+		for (i = 0; i < nm_i->nat_bits_blocks; i++)
+			f2fs_update_meta_page(sbi, nm_i->nat_bits +
+					(i << F2FS_BLKSIZE_BITS), blk + i);
+
+		/* Flush all the NAT BITS pages */
+		while (get_pages(sbi, F2FS_DIRTY_META)) {
+			f2fs_sync_meta_pages(sbi, META, LONG_MAX,
+							FS_CP_META_IO);
+			if (unlikely(f2fs_cp_error(sbi)))
+				return -EIO;
+		}
+	}
 
 	/* write out checkpoint buffer at block 0 */
-	update_meta_page(sbi, ckpt, start_blk++);
+	f2fs_update_meta_page(sbi, ckpt, start_blk++);
 
 	for (i = 1; i < 1 + cp_payload_blks; i++)
-		update_meta_page(sbi, (char *)ckpt + i * F2FS_BLKSIZE,
+		f2fs_update_meta_page(sbi, (char *)ckpt + i * F2FS_BLKSIZE,
 							start_blk++);
 
 	if (orphan_num) {
@@ -1147,7 +1325,7 @@ static int do_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 		start_blk += orphan_blocks;
 	}
 
-	write_data_summaries(sbi, start_blk);
+	f2fs_write_data_summaries(sbi, start_blk);
 	start_blk += data_sum_blocks;
 
 	/* Record write statistics in the hot node summary */
@@ -1158,38 +1336,37 @@ static int do_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 	seg_i->journal->info.kbytes_written = cpu_to_le64(kbytes_written);
 
 	if (__remain_node_summaries(cpc->reason)) {
-		write_node_summaries(sbi, start_blk);
+		f2fs_write_node_summaries(sbi, start_blk);
 		start_blk += NR_CURSEG_NODE_TYPE;
 	}
 
-	/* writeout checkpoint block */
-	update_meta_page(sbi, ckpt, start_blk);
+	/* update user_block_counts */
+	sbi->last_valid_block_count = sbi->total_valid_block_count;
+	percpu_counter_set(&sbi->alloc_valid_block_count, 0);
+
+	/* Here, we have one bio having CP pack except cp pack 2 page */
+	f2fs_sync_meta_pages(sbi, META, LONG_MAX, FS_CP_META_IO);
 
-	/* wait for previous submitted node/meta pages writeback */
+	/* wait for previous submitted meta pages writeback */
 	wait_on_all_pages_writeback(sbi);
 
 	if (unlikely(f2fs_cp_error(sbi)))
 		return -EIO;
 
-	filemap_fdatawait_range(NODE_MAPPING(sbi), 0, LLONG_MAX);
-	filemap_fdatawait_range(META_MAPPING(sbi), 0, LLONG_MAX);
-
-	/* update user_block_counts */
-	sbi->last_valid_block_count = sbi->total_valid_block_count;
-	percpu_counter_set(&sbi->alloc_valid_block_count, 0);
-
-	/* Here, we only have one bio having CP pack */
-	sync_meta_pages(sbi, META_FLUSH, LONG_MAX);
+	/* flush all device cache */
+	err = f2fs_flush_device_cache(sbi);
+	if (err)
+		return err;
 
-	/* wait for previous submitted meta pages writeback */
+	/* barrier and flush checkpoint cp pack 2 page if it can */
+	commit_checkpoint(sbi, ckpt, start_blk);
 	wait_on_all_pages_writeback(sbi);
 
-	release_ino_entry(sbi, false);
+	f2fs_release_ino_entry(sbi, false);
 
 	if (unlikely(f2fs_cp_error(sbi)))
 		return -EIO;
 
-	clear_prefree_segments(sbi, cpc);
 	clear_sbi_flag(sbi, SBI_IS_DIRTY);
 	clear_sbi_flag(sbi, SBI_NEED_CP);
 	__set_cp_next_pack(sbi);
@@ -1210,7 +1387,7 @@ static int do_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 /*
  * We guarantee that this checkpoint procedure will not fail.
  */
-int write_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
+int f2fs_write_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 {
 	struct f2fs_checkpoint *ckpt = F2FS_CKPT(sbi);
 	unsigned long long ckpt_ver;
@@ -1219,8 +1396,8 @@ int write_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 	mutex_lock(&sbi->cp_mutex);
 
 	if (!is_sbi_flag_set(sbi, SBI_IS_DIRTY) &&
-		(cpc->reason == CP_FASTBOOT || cpc->reason == CP_SYNC ||
-		(cpc->reason == CP_DISCARD && !sbi->discard_blks)))
+		((cpc->reason & CP_FASTBOOT) || (cpc->reason & CP_SYNC) ||
+		((cpc->reason & CP_DISCARD) && !sbi->discard_blks)))
 		goto out;
 	if (unlikely(f2fs_cp_error(sbi))) {
 		err = -EIO;
@@ -1239,18 +1416,23 @@ int write_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 
 	trace_f2fs_write_checkpoint(sbi->sb, cpc->reason, "finish block_ops");
 
-	f2fs_flush_merged_bios(sbi);
+	f2fs_flush_merged_writes(sbi);
 
 	/* this is the case of multiple fstrims without any changes */
-	if (cpc->reason == CP_DISCARD && !is_sbi_flag_set(sbi, SBI_IS_DIRTY)) {
-		f2fs_bug_on(sbi, NM_I(sbi)->dirty_nat_cnt);
-		f2fs_bug_on(sbi, SIT_I(sbi)->dirty_sentries);
-		f2fs_bug_on(sbi, prefree_segments(sbi));
-		flush_sit_entries(sbi, cpc);
-		clear_prefree_segments(sbi, cpc);
-		f2fs_wait_all_discard_bio(sbi);
-		unblock_operations(sbi);
-		goto out;
+	if (cpc->reason & CP_DISCARD) {
+		if (!f2fs_exist_trim_candidates(sbi, cpc)) {
+			unblock_operations(sbi);
+			goto out;
+		}
+
+		if (NM_I(sbi)->dirty_nat_cnt == 0 &&
+				SIT_I(sbi)->dirty_sentries == 0 &&
+				prefree_segments(sbi) == 0) {
+			f2fs_flush_sit_entries(sbi, cpc);
+			f2fs_clear_prefree_segments(sbi, cpc);
+			unblock_operations(sbi);
+			goto out;
+		}
 	}
 
 	/*
@@ -1262,18 +1444,20 @@ int write_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 	ckpt->checkpoint_ver = cpu_to_le64(++ckpt_ver);
 
 	/* write cached NAT/SIT entries to NAT/SIT area */
-	flush_nat_entries(sbi);
-	flush_sit_entries(sbi, cpc);
+	f2fs_flush_nat_entries(sbi, cpc);
+	f2fs_flush_sit_entries(sbi, cpc);
 
 	/* unlock all the fs_lock[] in do_checkpoint() */
 	err = do_checkpoint(sbi, cpc);
-
-	f2fs_wait_all_discard_bio(sbi);
+	if (err)
+		f2fs_release_discard_addrs(sbi);
+	else
+		f2fs_clear_prefree_segments(sbi, cpc);
 
 	unblock_operations(sbi);
 	stat_inc_cp_count(sbi->stat_info);
 
-	if (cpc->reason == CP_RECOVERY)
+	if (cpc->reason & CP_RECOVERY)
 		f2fs_msg(sbi->sb, KERN_NOTICE,
 			"checkpoint: version = %llx", ckpt_ver);
 
@@ -1285,7 +1469,7 @@ int write_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 	return err;
 }
 
-void init_ino_entry_info(struct f2fs_sb_info *sbi)
+void f2fs_init_ino_entry_info(struct f2fs_sb_info *sbi)
 {
 	int i;
 
@@ -1303,23 +1487,23 @@ void init_ino_entry_info(struct f2fs_sb_info *sbi)
 				F2FS_ORPHANS_PER_BLOCK;
 }
 
-int __init create_checkpoint_caches(void)
+int __init f2fs_create_checkpoint_caches(void)
 {
 	ino_entry_slab = f2fs_kmem_cache_create("f2fs_ino_entry",
 			sizeof(struct ino_entry));
 	if (!ino_entry_slab)
 		return -ENOMEM;
-	inode_entry_slab = f2fs_kmem_cache_create("f2fs_inode_entry",
+	f2fs_inode_entry_slab = f2fs_kmem_cache_create("f2fs_inode_entry",
 			sizeof(struct inode_entry));
-	if (!inode_entry_slab) {
+	if (!f2fs_inode_entry_slab) {
 		kmem_cache_destroy(ino_entry_slab);
 		return -ENOMEM;
 	}
 	return 0;
 }
 
-void destroy_checkpoint_caches(void)
+void f2fs_destroy_checkpoint_caches(void)
 {
 	kmem_cache_destroy(ino_entry_slab);
-	kmem_cache_destroy(inode_entry_slab);
+	kmem_cache_destroy(f2fs_inode_entry_slab);
 }
diff --git a/fs/f2fs/data.c b/fs/f2fs/data.c
index ae354ac..fc4a3a6 100644
--- a/fs/f2fs/data.c
+++ b/fs/f2fs/data.c
@@ -19,8 +19,6 @@
 #include <linux/bio.h>
 #include <linux/prefetch.h>
 #include <linux/uio.h>
-#include <linux/mm.h>
-#include <linux/memcontrol.h>
 #include <linux/cleancache.h>
 
 #include "f2fs.h"
@@ -28,41 +26,124 @@
 #include "segment.h"
 #include "trace.h"
 #include <trace/events/f2fs.h>
+#include <trace/events/android_fs.h>
 
-static void f2fs_read_end_io(struct bio *bio)
+#define NUM_PREALLOC_POST_READ_CTXS	128
+
+static struct kmem_cache *bio_post_read_ctx_cache;
+static mempool_t *bio_post_read_ctx_pool;
+
+static bool __is_cp_guaranteed(struct page *page)
 {
-	struct bio_vec *bvec;
-	int i;
+	struct address_space *mapping = page->mapping;
+	struct inode *inode;
+	struct f2fs_sb_info *sbi;
 
-#ifdef CONFIG_F2FS_FAULT_INJECTION
-	if (time_to_inject(F2FS_P_SB(bio->bi_io_vec->bv_page), FAULT_IO))
-		bio->bi_error = -EIO;
-#endif
+	if (!mapping)
+		return false;
 
-	if (f2fs_bio_encrypted(bio)) {
-		if (bio->bi_error) {
-			fscrypt_release_ctx(bio->bi_private);
-		} else {
-			fscrypt_decrypt_bio_pages(bio->bi_private, bio);
-			return;
-		}
-	}
+	inode = mapping->host;
+	sbi = F2FS_I_SB(inode);
 
-	bio_for_each_segment_all(bvec, bio, i) {
-		struct page *page = bvec->bv_page;
+	if (inode->i_ino == F2FS_META_INO(sbi) ||
+			inode->i_ino ==  F2FS_NODE_INO(sbi) ||
+			S_ISDIR(inode->i_mode) ||
+			(S_ISREG(inode->i_mode) &&
+			is_inode_flag_set(inode, FI_ATOMIC_FILE)) ||
+			is_cold_data(page))
+		return true;
+	return false;
+}
 
-		if (!bio->bi_error) {
-			if (!PageUptodate(page))
-				SetPageUptodate(page);
-		} else {
+/* postprocessing steps for read bios */
+enum bio_post_read_step {
+	STEP_INITIAL = 0,
+	STEP_DECRYPT,
+};
+
+struct bio_post_read_ctx {
+	struct bio *bio;
+	struct work_struct work;
+	unsigned int cur_step;
+	unsigned int enabled_steps;
+};
+
+static void __read_end_io(struct bio *bio)
+{
+	struct page *page;
+	struct bio_vec *bv;
+	int i;
+
+	bio_for_each_segment_all(bv, bio, i) {
+		page = bv->bv_page;
+
+		/* PG_error was set if any post_read step failed */
+		if (bio->bi_error || PageError(page)) {
 			ClearPageUptodate(page);
 			SetPageError(page);
+		} else {
+			SetPageUptodate(page);
 		}
 		unlock_page(page);
 	}
+	if (bio->bi_private)
+		mempool_free(bio->bi_private, bio_post_read_ctx_pool);
 	bio_put(bio);
 }
 
+static void bio_post_read_processing(struct bio_post_read_ctx *ctx);
+
+static void decrypt_work(struct work_struct *work)
+{
+	struct bio_post_read_ctx *ctx =
+		container_of(work, struct bio_post_read_ctx, work);
+
+	fscrypt_decrypt_bio(ctx->bio);
+
+	bio_post_read_processing(ctx);
+}
+
+static void bio_post_read_processing(struct bio_post_read_ctx *ctx)
+{
+	switch (++ctx->cur_step) {
+	case STEP_DECRYPT:
+		if (ctx->enabled_steps & (1 << STEP_DECRYPT)) {
+			INIT_WORK(&ctx->work, decrypt_work);
+			fscrypt_enqueue_decrypt_work(&ctx->work);
+			return;
+		}
+		ctx->cur_step++;
+		/* fall-through */
+	default:
+		__read_end_io(ctx->bio);
+	}
+}
+
+static bool f2fs_bio_post_read_required(struct bio *bio)
+{
+	return bio->bi_private && !bio->bi_error;
+}
+
+static void f2fs_read_end_io(struct bio *bio)
+{
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	if (time_to_inject(F2FS_P_SB(bio->bi_io_vec->bv_page), FAULT_IO)) {
+		f2fs_show_injection_info(FAULT_IO);
+		bio->bi_error = -EIO;
+	}
+#endif
+
+	if (f2fs_bio_post_read_required(bio)) {
+		struct bio_post_read_ctx *ctx = bio->bi_private;
+
+		ctx->cur_step = STEP_INITIAL;
+		bio_post_read_processing(ctx);
+		return;
+	}
+
+	__read_end_io(bio);
+}
+
 static void f2fs_write_end_io(struct bio *bio)
 {
 	struct f2fs_sb_info *sbi = bio->bi_private;
@@ -71,16 +152,35 @@ static void f2fs_write_end_io(struct bio *bio)
 
 	bio_for_each_segment_all(bvec, bio, i) {
 		struct page *page = bvec->bv_page;
+		enum count_type type = WB_DATA_TYPE(page);
+
+		if (IS_DUMMY_WRITTEN_PAGE(page)) {
+			set_page_private(page, (unsigned long)NULL);
+			ClearPagePrivate(page);
+			unlock_page(page);
+			mempool_free(page, sbi->write_io_dummy);
+
+			if (unlikely(bio->bi_error))
+				f2fs_stop_checkpoint(sbi, true);
+			continue;
+		}
 
 		fscrypt_pullback_bio_page(&page, true);
 
 		if (unlikely(bio->bi_error)) {
 			mapping_set_error(page->mapping, -EIO);
-			f2fs_stop_checkpoint(sbi, true);
+			if (type == F2FS_WB_CP_DATA)
+				f2fs_stop_checkpoint(sbi, true);
 		}
+
+		f2fs_bug_on(sbi, page->mapping == NODE_MAPPING(sbi) &&
+					page->index != nid_of_node(page));
+
+		dec_page_count(sbi, type);
+		clear_cold_data(page);
 		end_page_writeback(page);
 	}
-	if (atomic_dec_and_test(&sbi->nr_wb_bios) &&
+	if (!get_pages(sbi, F2FS_WB_CP_DATA) &&
 				wq_has_sleeper(&sbi->cp_wait))
 		wake_up(&sbi->cp_wait);
 
@@ -88,19 +188,68 @@ static void f2fs_write_end_io(struct bio *bio)
 }
 
 /*
+ * Return true, if pre_bio's bdev is same as its target device.
+ */
+struct block_device *f2fs_target_device(struct f2fs_sb_info *sbi,
+				block_t blk_addr, struct bio *bio)
+{
+	struct block_device *bdev = sbi->sb->s_bdev;
+	int i;
+
+	for (i = 0; i < sbi->s_ndevs; i++) {
+		if (FDEV(i).start_blk <= blk_addr &&
+					FDEV(i).end_blk >= blk_addr) {
+			blk_addr -= FDEV(i).start_blk;
+			bdev = FDEV(i).bdev;
+			break;
+		}
+	}
+	if (bio) {
+		bio->bi_bdev = bdev;
+		bio->bi_iter.bi_sector = SECTOR_FROM_BLOCK(blk_addr);
+	}
+	return bdev;
+}
+
+int f2fs_target_device_index(struct f2fs_sb_info *sbi, block_t blkaddr)
+{
+	int i;
+
+	for (i = 0; i < sbi->s_ndevs; i++)
+		if (FDEV(i).start_blk <= blkaddr && FDEV(i).end_blk >= blkaddr)
+			return i;
+	return 0;
+}
+
+static bool __same_bdev(struct f2fs_sb_info *sbi,
+				block_t blk_addr, struct bio *bio)
+{
+	return f2fs_target_device(sbi, blk_addr, NULL) == bio->bi_bdev;
+}
+
+/*
  * Low-level block read/write IO operations.
  */
 static struct bio *__bio_alloc(struct f2fs_sb_info *sbi, block_t blk_addr,
-				int npages, bool is_read)
+				struct writeback_control *wbc,
+				int npages, bool is_read,
+				enum page_type type, enum temp_type temp)
 {
 	struct bio *bio;
 
-	bio = f2fs_bio_alloc(npages);
+	bio = f2fs_bio_alloc(sbi, npages, true);
 
-	bio->bi_bdev = sbi->sb->s_bdev;
-	bio->bi_iter.bi_sector = SECTOR_FROM_BLOCK(blk_addr);
-	bio->bi_end_io = is_read ? f2fs_read_end_io : f2fs_write_end_io;
-	bio->bi_private = is_read ? NULL : sbi;
+	f2fs_target_device(sbi, blk_addr, bio);
+	if (is_read) {
+		bio->bi_end_io = f2fs_read_end_io;
+		bio->bi_private = NULL;
+	} else {
+		bio->bi_end_io = f2fs_write_end_io;
+		bio->bi_private = sbi;
+		bio->bi_write_hint = f2fs_io_type_to_rw_hint(sbi, type, temp);
+	}
+	if (wbc)
+		wbc_init_bio(wbc, bio);
 
 	return bio;
 }
@@ -109,11 +258,45 @@ static inline void __submit_bio(struct f2fs_sb_info *sbi,
 				struct bio *bio, enum page_type type)
 {
 	if (!is_read_io(bio_op(bio))) {
-		atomic_inc(&sbi->nr_wb_bios);
-		if (f2fs_sb_mounted_hmsmr(sbi->sb) &&
-			current->plug && (type == DATA || type == NODE))
+		unsigned int start;
+
+		if (type != DATA && type != NODE)
+			goto submit_io;
+
+		if (f2fs_sb_has_blkzoned(sbi->sb) && current->plug)
 			blk_finish_plug(current->plug);
+
+		start = bio->bi_iter.bi_size >> F2FS_BLKSIZE_BITS;
+		start %= F2FS_IO_SIZE(sbi);
+
+		if (start == 0)
+			goto submit_io;
+
+		/* fill dummy pages */
+		for (; start < F2FS_IO_SIZE(sbi); start++) {
+			struct page *page =
+				mempool_alloc(sbi->write_io_dummy,
+					GFP_NOIO | __GFP_ZERO | __GFP_NOFAIL);
+			f2fs_bug_on(sbi, !page);
+
+			SetPagePrivate(page);
+			set_page_private(page, (unsigned long)DUMMY_WRITTEN_PAGE);
+			lock_page(page);
+			if (bio_add_page(bio, page, PAGE_SIZE, 0) < PAGE_SIZE)
+				f2fs_bug_on(sbi, 1);
+		}
+		/*
+		 * In the NODE case, we lose next block address chain. So, we
+		 * need to do checkpoint in f2fs_sync_file.
+		 */
+		if (type == NODE)
+			set_sbi_flag(sbi, SBI_NEED_CP);
 	}
+submit_io:
+	if (is_read_io(bio_op(bio)))
+		trace_f2fs_submit_read_bio(sbi->sb, type, bio);
+	else
+		trace_f2fs_submit_write_bio(sbi->sb, type, bio);
 	submit_bio(bio);
 }
 
@@ -124,19 +307,19 @@ static void __submit_merged_bio(struct f2fs_bio_info *io)
 	if (!io->bio)
 		return;
 
+	bio_set_op_attrs(io->bio, fio->op, fio->op_flags);
+
 	if (is_read_io(fio->op))
-		trace_f2fs_submit_read_bio(io->sbi->sb, fio, io->bio);
+		trace_f2fs_prepare_read_bio(io->sbi->sb, fio->type, io->bio);
 	else
-		trace_f2fs_submit_write_bio(io->sbi->sb, fio, io->bio);
-
-	bio_set_op_attrs(io->bio, fio->op, fio->op_flags);
+		trace_f2fs_prepare_write_bio(io->sbi->sb, fio->type, io->bio);
 
 	__submit_bio(io->sbi, io->bio, fio->type);
 	io->bio = NULL;
 }
 
-static bool __has_merged_page(struct f2fs_bio_info *io, struct inode *inode,
-						struct page *page, nid_t ino)
+static bool __has_merged_page(struct f2fs_bio_info *io,
+				struct inode *inode, nid_t ino, pgoff_t idx)
 {
 	struct bio_vec *bvec;
 	struct page *target;
@@ -145,7 +328,7 @@ static bool __has_merged_page(struct f2fs_bio_info *io, struct inode *inode,
 	if (!io->bio)
 		return false;
 
-	if (!inode && !page && !ino)
+	if (!inode && !ino)
 		return true;
 
 	bio_for_each_segment_all(bvec, io->bio, i) {
@@ -155,10 +338,11 @@ static bool __has_merged_page(struct f2fs_bio_info *io, struct inode *inode,
 		else
 			target = fscrypt_control_page(bvec->bv_page);
 
+		if (idx != target->index)
+			continue;
+
 		if (inode && inode == target->mapping->host)
 			return true;
-		if (page && page == target)
-			return true;
 		if (ino && ino == ino_of_node(target))
 			return true;
 	}
@@ -167,72 +351,88 @@ static bool __has_merged_page(struct f2fs_bio_info *io, struct inode *inode,
 }
 
 static bool has_merged_page(struct f2fs_sb_info *sbi, struct inode *inode,
-						struct page *page, nid_t ino,
-						enum page_type type)
+				nid_t ino, pgoff_t idx, enum page_type type)
 {
 	enum page_type btype = PAGE_TYPE_OF_BIO(type);
-	struct f2fs_bio_info *io = &sbi->write_io[btype];
-	bool ret;
+	enum temp_type temp;
+	struct f2fs_bio_info *io;
+	bool ret = false;
+
+	for (temp = HOT; temp < NR_TEMP_TYPE; temp++) {
+		io = sbi->write_io[btype] + temp;
+
+		down_read(&io->io_rwsem);
+		ret = __has_merged_page(io, inode, ino, idx);
+		up_read(&io->io_rwsem);
 
-	down_read(&io->io_rwsem);
-	ret = __has_merged_page(io, inode, page, ino);
-	up_read(&io->io_rwsem);
+		/* TODO: use HOT temp only for meta pages now. */
+		if (ret || btype == META)
+			break;
+	}
 	return ret;
 }
 
-static void __f2fs_submit_merged_bio(struct f2fs_sb_info *sbi,
-				struct inode *inode, struct page *page,
-				nid_t ino, enum page_type type, int rw)
+static void __f2fs_submit_merged_write(struct f2fs_sb_info *sbi,
+				enum page_type type, enum temp_type temp)
 {
 	enum page_type btype = PAGE_TYPE_OF_BIO(type);
-	struct f2fs_bio_info *io;
-
-	io = is_read_io(rw) ? &sbi->read_io : &sbi->write_io[btype];
+	struct f2fs_bio_info *io = sbi->write_io[btype] + temp;
 
 	down_write(&io->io_rwsem);
 
-	if (!__has_merged_page(io, inode, page, ino))
-		goto out;
-
 	/* change META to META_FLUSH in the checkpoint procedure */
 	if (type >= META_FLUSH) {
 		io->fio.type = META_FLUSH;
 		io->fio.op = REQ_OP_WRITE;
-		if (test_opt(sbi, NOBARRIER))
-			io->fio.op_flags = WRITE_FLUSH | REQ_META | REQ_PRIO;
-		else
-			io->fio.op_flags = WRITE_FLUSH_FUA | REQ_META |
-								REQ_PRIO;
+		io->fio.op_flags = REQ_META | REQ_PRIO | REQ_SYNC;
+		if (!test_opt(sbi, NOBARRIER))
+			io->fio.op_flags |= REQ_PREFLUSH | REQ_FUA;
 	}
 	__submit_merged_bio(io);
-out:
 	up_write(&io->io_rwsem);
 }
 
-void f2fs_submit_merged_bio(struct f2fs_sb_info *sbi, enum page_type type,
-									int rw)
+static void __submit_merged_write_cond(struct f2fs_sb_info *sbi,
+				struct inode *inode, nid_t ino, pgoff_t idx,
+				enum page_type type, bool force)
 {
-	__f2fs_submit_merged_bio(sbi, NULL, NULL, 0, type, rw);
+	enum temp_type temp;
+
+	if (!force && !has_merged_page(sbi, inode, ino, idx, type))
+		return;
+
+	for (temp = HOT; temp < NR_TEMP_TYPE; temp++) {
+
+		__f2fs_submit_merged_write(sbi, type, temp);
+
+		/* TODO: use HOT temp only for meta pages now. */
+		if (type >= META)
+			break;
+	}
 }
 
-void f2fs_submit_merged_bio_cond(struct f2fs_sb_info *sbi,
-				struct inode *inode, struct page *page,
-				nid_t ino, enum page_type type, int rw)
+void f2fs_submit_merged_write(struct f2fs_sb_info *sbi, enum page_type type)
 {
-	if (has_merged_page(sbi, inode, page, ino, type))
-		__f2fs_submit_merged_bio(sbi, inode, page, ino, type, rw);
+	__submit_merged_write_cond(sbi, NULL, 0, 0, type, true);
 }
 
-void f2fs_flush_merged_bios(struct f2fs_sb_info *sbi)
+void f2fs_submit_merged_write_cond(struct f2fs_sb_info *sbi,
+				struct inode *inode, nid_t ino, pgoff_t idx,
+				enum page_type type)
 {
-	f2fs_submit_merged_bio(sbi, DATA, WRITE);
-	f2fs_submit_merged_bio(sbi, NODE, WRITE);
-	f2fs_submit_merged_bio(sbi, META, WRITE);
+	__submit_merged_write_cond(sbi, inode, ino, idx, type, false);
+}
+
+void f2fs_flush_merged_writes(struct f2fs_sb_info *sbi)
+{
+	f2fs_submit_merged_write(sbi, DATA);
+	f2fs_submit_merged_write(sbi, NODE);
+	f2fs_submit_merged_write(sbi, META);
 }
 
 /*
  * Fill the locked page with data located in the block address.
- * Return unlocked page.
+ * A caller needs to unlock the page on failure.
  */
 int f2fs_submit_page_bio(struct f2fs_io_info *fio)
 {
@@ -240,11 +440,13 @@ int f2fs_submit_page_bio(struct f2fs_io_info *fio)
 	struct page *page = fio->encrypted_page ?
 			fio->encrypted_page : fio->page;
 
+	verify_block_addr(fio, fio->new_blkaddr);
 	trace_f2fs_submit_page_bio(page, fio);
 	f2fs_trace_ios(fio, 0);
 
 	/* Allocate a new bio */
-	bio = __bio_alloc(fio->sbi, fio->new_blkaddr, 1, is_read_io(fio->op));
+	bio = __bio_alloc(fio->sbi, fio->new_blkaddr, fio->io_wbc,
+				1, is_read_io(fio->op), fio->type, fio->temp);
 
 	if (bio_add_page(bio, page, PAGE_SIZE, 0) < PAGE_SIZE) {
 		bio_put(bio);
@@ -253,60 +455,146 @@ int f2fs_submit_page_bio(struct f2fs_io_info *fio)
 	bio_set_op_attrs(bio, fio->op, fio->op_flags);
 
 	__submit_bio(fio->sbi, bio, fio->type);
+
+	if (!is_read_io(fio->op))
+		inc_page_count(fio->sbi, WB_DATA_TYPE(fio->page));
 	return 0;
 }
 
-void f2fs_submit_page_mbio(struct f2fs_io_info *fio)
+void f2fs_submit_page_write(struct f2fs_io_info *fio)
 {
 	struct f2fs_sb_info *sbi = fio->sbi;
 	enum page_type btype = PAGE_TYPE_OF_BIO(fio->type);
-	struct f2fs_bio_info *io;
-	bool is_read = is_read_io(fio->op);
+	struct f2fs_bio_info *io = sbi->write_io[btype] + fio->temp;
 	struct page *bio_page;
 
-	io = is_read ? &sbi->read_io : &sbi->write_io[btype];
-
-	if (fio->old_blkaddr != NEW_ADDR)
-		verify_block_addr(sbi, fio->old_blkaddr);
-	verify_block_addr(sbi, fio->new_blkaddr);
+	f2fs_bug_on(sbi, is_read_io(fio->op));
 
 	down_write(&io->io_rwsem);
+next:
+	if (fio->in_list) {
+		spin_lock(&io->io_lock);
+		if (list_empty(&io->io_list)) {
+			spin_unlock(&io->io_lock);
+			goto out;
+		}
+		fio = list_first_entry(&io->io_list,
+						struct f2fs_io_info, list);
+		list_del(&fio->list);
+		spin_unlock(&io->io_lock);
+	}
+
+	if (is_valid_blkaddr(fio->old_blkaddr))
+		verify_block_addr(fio, fio->old_blkaddr);
+	verify_block_addr(fio, fio->new_blkaddr);
+
+	bio_page = fio->encrypted_page ? fio->encrypted_page : fio->page;
+
+	/* set submitted = true as a return value */
+	fio->submitted = true;
+
+	inc_page_count(sbi, WB_DATA_TYPE(bio_page));
 
 	if (io->bio && (io->last_block_in_bio != fio->new_blkaddr - 1 ||
-	    (io->fio.op != fio->op || io->fio.op_flags != fio->op_flags)))
+	    (io->fio.op != fio->op || io->fio.op_flags != fio->op_flags) ||
+			!__same_bdev(sbi, fio->new_blkaddr, io->bio)))
 		__submit_merged_bio(io);
 alloc_new:
 	if (io->bio == NULL) {
-		int bio_blocks = MAX_BIO_BLOCKS(sbi);
-
-		io->bio = __bio_alloc(sbi, fio->new_blkaddr,
-						bio_blocks, is_read);
+		if ((fio->type == DATA || fio->type == NODE) &&
+				fio->new_blkaddr & F2FS_IO_SIZE_MASK(sbi)) {
+			dec_page_count(sbi, WB_DATA_TYPE(bio_page));
+			fio->retry = true;
+			goto skip;
+		}
+		io->bio = __bio_alloc(sbi, fio->new_blkaddr, fio->io_wbc,
+						BIO_MAX_PAGES, false,
+						fio->type, fio->temp);
 		io->fio = *fio;
 	}
 
-	bio_page = fio->encrypted_page ? fio->encrypted_page : fio->page;
-
-	if (bio_add_page(io->bio, bio_page, PAGE_SIZE, 0) <
-							PAGE_SIZE) {
+	if (bio_add_page(io->bio, bio_page, PAGE_SIZE, 0) < PAGE_SIZE) {
 		__submit_merged_bio(io);
 		goto alloc_new;
 	}
 
+	if (fio->io_wbc)
+		wbc_account_io(fio->io_wbc, bio_page, PAGE_SIZE);
+
 	io->last_block_in_bio = fio->new_blkaddr;
 	f2fs_trace_ios(fio, 0);
 
+	trace_f2fs_submit_page_write(fio->page, fio);
+skip:
+	if (fio->in_list)
+		goto next;
+out:
 	up_write(&io->io_rwsem);
-	trace_f2fs_submit_page_mbio(fio->page, fio);
+}
+
+static struct bio *f2fs_grab_read_bio(struct inode *inode, block_t blkaddr,
+							 unsigned nr_pages)
+{
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+	struct bio *bio;
+	struct bio_post_read_ctx *ctx;
+	unsigned int post_read_steps = 0;
+
+	bio = f2fs_bio_alloc(sbi, min_t(int, nr_pages, BIO_MAX_PAGES), false);
+	if (!bio)
+		return ERR_PTR(-ENOMEM);
+	f2fs_target_device(sbi, blkaddr, bio);
+	bio->bi_end_io = f2fs_read_end_io;
+	bio_set_op_attrs(bio, REQ_OP_READ, 0);
+
+	if (f2fs_encrypted_file(inode))
+		post_read_steps |= 1 << STEP_DECRYPT;
+	if (post_read_steps) {
+		ctx = mempool_alloc(bio_post_read_ctx_pool, GFP_NOFS);
+		if (!ctx) {
+			bio_put(bio);
+			return ERR_PTR(-ENOMEM);
+		}
+		ctx->bio = bio;
+		ctx->enabled_steps = post_read_steps;
+		bio->bi_private = ctx;
+
+		/* wait the page to be moved by cleaning */
+		f2fs_wait_on_block_writeback(sbi, blkaddr);
+	}
+
+	return bio;
+}
+
+/* This can handle encryption stuffs */
+static int f2fs_submit_page_read(struct inode *inode, struct page *page,
+							block_t blkaddr)
+{
+	struct bio *bio = f2fs_grab_read_bio(inode, blkaddr, 1);
+
+	if (IS_ERR(bio))
+		return PTR_ERR(bio);
+
+	if (bio_add_page(bio, page, PAGE_SIZE, 0) < PAGE_SIZE) {
+		bio_put(bio);
+		return -EFAULT;
+	}
+	__submit_bio(F2FS_I_SB(inode), bio, DATA);
+	return 0;
 }
 
 static void __set_data_blkaddr(struct dnode_of_data *dn)
 {
 	struct f2fs_node *rn = F2FS_NODE(dn->node_page);
 	__le32 *addr_array;
+	int base = 0;
+
+	if (IS_INODE(dn->node_page) && f2fs_has_extra_attr(dn->inode))
+		base = get_extra_isize(dn->inode);
 
 	/* Get physical address of data block */
 	addr_array = blkaddr_in_node(rn);
-	addr_array[dn->ofs_in_node] = cpu_to_le32(dn->data_blkaddr);
+	addr_array[base + dn->ofs_in_node] = cpu_to_le32(dn->data_blkaddr);
 }
 
 /*
@@ -315,7 +603,7 @@ static void __set_data_blkaddr(struct dnode_of_data *dn)
  *  ->node_page
  *    update block addresses in the node page
  */
-void set_data_blkaddr(struct dnode_of_data *dn)
+void f2fs_set_data_blkaddr(struct dnode_of_data *dn)
 {
 	f2fs_wait_on_page_writeback(dn->node_page, NODE, true);
 	__set_data_blkaddr(dn);
@@ -326,22 +614,23 @@ void set_data_blkaddr(struct dnode_of_data *dn)
 void f2fs_update_data_blkaddr(struct dnode_of_data *dn, block_t blkaddr)
 {
 	dn->data_blkaddr = blkaddr;
-	set_data_blkaddr(dn);
+	f2fs_set_data_blkaddr(dn);
 	f2fs_update_extent_cache(dn);
 }
 
 /* dn->ofs_in_node will be returned with up-to-date last block pointer */
-int reserve_new_blocks(struct dnode_of_data *dn, blkcnt_t count)
+int f2fs_reserve_new_blocks(struct dnode_of_data *dn, blkcnt_t count)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(dn->inode);
+	int err;
 
 	if (!count)
 		return 0;
 
 	if (unlikely(is_inode_flag_set(dn->inode, FI_NO_ALLOC)))
 		return -EPERM;
-	if (unlikely(!inc_valid_block_count(sbi, dn->inode, &count)))
-		return -ENOSPC;
+	if (unlikely((err = inc_valid_block_count(sbi, dn->inode, &count))))
+		return err;
 
 	trace_f2fs_reserve_new_blocks(dn->inode, dn->nid,
 						dn->ofs_in_node, count);
@@ -349,8 +638,8 @@ int reserve_new_blocks(struct dnode_of_data *dn, blkcnt_t count)
 	f2fs_wait_on_page_writeback(dn->node_page, NODE, true);
 
 	for (; count > 0; dn->ofs_in_node++) {
-		block_t blkaddr =
-			datablock_addr(dn->node_page, dn->ofs_in_node);
+		block_t blkaddr = datablock_addr(dn->inode,
+					dn->node_page, dn->ofs_in_node);
 		if (blkaddr == NULL_ADDR) {
 			dn->data_blkaddr = NEW_ADDR;
 			__set_data_blkaddr(dn);
@@ -364,12 +653,12 @@ int reserve_new_blocks(struct dnode_of_data *dn, blkcnt_t count)
 }
 
 /* Should keep dn->ofs_in_node unchanged */
-int reserve_new_block(struct dnode_of_data *dn)
+int f2fs_reserve_new_block(struct dnode_of_data *dn)
 {
 	unsigned int ofs_in_node = dn->ofs_in_node;
 	int ret;
 
-	ret = reserve_new_blocks(dn, 1);
+	ret = f2fs_reserve_new_blocks(dn, 1);
 	dn->ofs_in_node = ofs_in_node;
 	return ret;
 }
@@ -379,12 +668,12 @@ int f2fs_reserve_block(struct dnode_of_data *dn, pgoff_t index)
 	bool need_put = dn->inode_page ? false : true;
 	int err;
 
-	err = get_dnode_of_data(dn, index, ALLOC_NODE);
+	err = f2fs_get_dnode_of_data(dn, index, ALLOC_NODE);
 	if (err)
 		return err;
 
 	if (dn->data_blkaddr == NULL_ADDR)
-		err = reserve_new_block(dn);
+		err = f2fs_reserve_new_block(dn);
 	if (err || need_put)
 		f2fs_put_dnode(dn);
 	return err;
@@ -392,7 +681,7 @@ int f2fs_reserve_block(struct dnode_of_data *dn, pgoff_t index)
 
 int f2fs_get_block(struct dnode_of_data *dn, pgoff_t index)
 {
-	struct extent_info ei;
+	struct extent_info ei  = {0,0,0};
 	struct inode *inode = dn->inode;
 
 	if (f2fs_lookup_extent_cache(inode, index, &ei)) {
@@ -403,24 +692,14 @@ int f2fs_get_block(struct dnode_of_data *dn, pgoff_t index)
 	return f2fs_reserve_block(dn, index);
 }
 
-struct page *get_read_data_page(struct inode *inode, pgoff_t index,
+struct page *f2fs_get_read_data_page(struct inode *inode, pgoff_t index,
 						int op_flags, bool for_write)
 {
 	struct address_space *mapping = inode->i_mapping;
 	struct dnode_of_data dn;
 	struct page *page;
-	struct extent_info ei;
+	struct extent_info ei = {0,0,0};
 	int err;
-	struct f2fs_io_info fio = {
-		.sbi = F2FS_I_SB(inode),
-		.type = DATA,
-		.op = REQ_OP_READ,
-		.op_flags = op_flags,
-		.encrypted_page = NULL,
-	};
-
-	if (f2fs_encrypted_inode(inode) && S_ISREG(inode->i_mode))
-		return read_mapping_page(mapping, index, NULL);
 
 	page = f2fs_grab_cache_page(mapping, index, for_write);
 	if (!page)
@@ -432,7 +711,7 @@ struct page *get_read_data_page(struct inode *inode, pgoff_t index,
 	}
 
 	set_new_dnode(&dn, inode, NULL, NULL, 0);
-	err = get_dnode_of_data(&dn, index, LOOKUP_NODE);
+	err = f2fs_get_dnode_of_data(&dn, index, LOOKUP_NODE);
 	if (err)
 		goto put_err;
 	f2fs_put_dnode(&dn);
@@ -451,7 +730,8 @@ struct page *get_read_data_page(struct inode *inode, pgoff_t index,
 	 * A new dentry page is allocated but not able to be written, since its
 	 * new inode page couldn't be allocated due to -ENOSPC.
 	 * In such the case, its blkaddr can be remained as NEW_ADDR.
-	 * see, f2fs_add_link -> get_new_data_page -> init_inode_metadata.
+	 * see, f2fs_add_link -> f2fs_get_new_data_page ->
+	 * f2fs_init_inode_metadata.
 	 */
 	if (dn.data_blkaddr == NEW_ADDR) {
 		zero_user_segment(page, 0, PAGE_SIZE);
@@ -461,9 +741,7 @@ struct page *get_read_data_page(struct inode *inode, pgoff_t index,
 		return page;
 	}
 
-	fio.new_blkaddr = fio.old_blkaddr = dn.data_blkaddr;
-	fio.page = page;
-	err = f2fs_submit_page_bio(&fio);
+	err = f2fs_submit_page_read(inode, page, dn.data_blkaddr);
 	if (err)
 		goto put_err;
 	return page;
@@ -473,7 +751,7 @@ struct page *get_read_data_page(struct inode *inode, pgoff_t index,
 	return ERR_PTR(err);
 }
 
-struct page *find_data_page(struct inode *inode, pgoff_t index)
+struct page *f2fs_find_data_page(struct inode *inode, pgoff_t index)
 {
 	struct address_space *mapping = inode->i_mapping;
 	struct page *page;
@@ -483,7 +761,7 @@ struct page *find_data_page(struct inode *inode, pgoff_t index)
 		return page;
 	f2fs_put_page(page, 0);
 
-	page = get_read_data_page(inode, index, READ_SYNC, false);
+	page = f2fs_get_read_data_page(inode, index, 0, false);
 	if (IS_ERR(page))
 		return page;
 
@@ -503,13 +781,13 @@ struct page *find_data_page(struct inode *inode, pgoff_t index)
  * Because, the callers, functions in dir.c and GC, should be able to know
  * whether this page exists or not.
  */
-struct page *get_lock_data_page(struct inode *inode, pgoff_t index,
+struct page *f2fs_get_lock_data_page(struct inode *inode, pgoff_t index,
 							bool for_write)
 {
 	struct address_space *mapping = inode->i_mapping;
 	struct page *page;
 repeat:
-	page = get_read_data_page(inode, index, READ_SYNC, for_write);
+	page = f2fs_get_read_data_page(inode, index, 0, for_write);
 	if (IS_ERR(page))
 		return page;
 
@@ -535,7 +813,7 @@ struct page *get_lock_data_page(struct inode *inode, pgoff_t index,
  * Note that, ipage is set only by make_empty_dir, and if any error occur,
  * ipage should be released by this function.
  */
-struct page *get_new_data_page(struct inode *inode,
+struct page *f2fs_get_new_data_page(struct inode *inode,
 		struct page *ipage, pgoff_t index, bool new_i_size)
 {
 	struct address_space *mapping = inode->i_mapping;
@@ -574,7 +852,7 @@ struct page *get_new_data_page(struct inode *inode,
 
 		/* if ipage exists, blkaddr should be NEW_ADDR */
 		f2fs_bug_on(F2FS_I_SB(inode), ipage);
-		page = get_lock_data_page(inode, index, true);
+		page = f2fs_get_lock_data_page(inode, index, true);
 		if (IS_ERR(page))
 			return page;
 	}
@@ -585,38 +863,36 @@ struct page *get_new_data_page(struct inode *inode,
 	return page;
 }
 
-static int __allocate_data_block(struct dnode_of_data *dn)
+static int __allocate_data_block(struct dnode_of_data *dn, int seg_type)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(dn->inode);
 	struct f2fs_summary sum;
 	struct node_info ni;
-	int seg = CURSEG_WARM_DATA;
 	pgoff_t fofs;
 	blkcnt_t count = 1;
+	int err;
 
 	if (unlikely(is_inode_flag_set(dn->inode, FI_NO_ALLOC)))
 		return -EPERM;
 
-	dn->data_blkaddr = datablock_addr(dn->node_page, dn->ofs_in_node);
+	dn->data_blkaddr = datablock_addr(dn->inode,
+				dn->node_page, dn->ofs_in_node);
 	if (dn->data_blkaddr == NEW_ADDR)
 		goto alloc;
 
-	if (unlikely(!inc_valid_block_count(sbi, dn->inode, &count)))
-		return -ENOSPC;
+	if (unlikely((err = inc_valid_block_count(sbi, dn->inode, &count))))
+		return err;
 
 alloc:
-	get_node_info(sbi, dn->nid, &ni);
+	f2fs_get_node_info(sbi, dn->nid, &ni);
 	set_summary(&sum, dn->nid, dn->ofs_in_node, ni.version);
 
-	if (dn->ofs_in_node == 0 && dn->inode_page == dn->node_page)
-		seg = CURSEG_DIRECT_IO;
-
-	allocate_data_block(sbi, NULL, dn->data_blkaddr, &dn->data_blkaddr,
-								&sum, seg);
-	set_data_blkaddr(dn);
+	f2fs_allocate_data_block(sbi, NULL, dn->data_blkaddr, &dn->data_blkaddr,
+					&sum, seg_type, NULL, false);
+	f2fs_set_data_blkaddr(dn);
 
 	/* update i_size */
-	fofs = start_bidx_of_node(ofs_of_node(dn->node_page), dn->inode) +
+	fofs = f2fs_start_bidx_of_node(ofs_of_node(dn->node_page), dn->inode) +
 							dn->ofs_in_node;
 	if (i_size_read(dn->inode) < ((loff_t)(fofs + 1) << PAGE_SHIFT))
 		f2fs_i_size_write(dn->inode,
@@ -624,11 +900,23 @@ static int __allocate_data_block(struct dnode_of_data *dn)
 	return 0;
 }
 
-ssize_t f2fs_preallocate_blocks(struct kiocb *iocb, struct iov_iter *from)
+int f2fs_preallocate_blocks(struct kiocb *iocb, struct iov_iter *from)
 {
 	struct inode *inode = file_inode(iocb->ki_filp);
 	struct f2fs_map_blocks map;
-	ssize_t ret = 0;
+	int flag;
+	int err = 0;
+	bool direct_io = iocb->ki_flags & IOCB_DIRECT;
+
+	/* convert inline data for Direct I/O*/
+	if (direct_io) {
+		err = f2fs_convert_inline_inode(inode);
+		if (err)
+			return err;
+	}
+
+	if (is_inode_flag_set(inode, FI_NO_PREALLOC))
+		return 0;
 
 	map.m_lblk = F2FS_BLK_ALIGN(iocb->ki_pos);
 	map.m_len = F2FS_BYTES_TO_BLK(iocb->ki_pos + iov_iter_count(from));
@@ -638,21 +926,49 @@ ssize_t f2fs_preallocate_blocks(struct kiocb *iocb, struct iov_iter *from)
 		map.m_len = 0;
 
 	map.m_next_pgofs = NULL;
+	map.m_next_extent = NULL;
+	map.m_seg_type = NO_CHECK_TYPE;
+
+	if (direct_io) {
+		map.m_seg_type = f2fs_rw_hint_to_seg_type(iocb->ki_hint);
+		flag = f2fs_force_buffered_io(inode, WRITE) ?
+					F2FS_GET_BLOCK_PRE_AIO :
+					F2FS_GET_BLOCK_PRE_DIO;
+		goto map_blocks;
+	}
+	if (iocb->ki_pos + iov_iter_count(from) > MAX_INLINE_DATA(inode)) {
+		err = f2fs_convert_inline_inode(inode);
+		if (err)
+			return err;
+	}
+	if (f2fs_has_inline_data(inode))
+		return err;
 
-	if (iocb->ki_flags & IOCB_DIRECT) {
-		ret = f2fs_convert_inline_inode(inode);
-		if (ret)
-			return ret;
-		return f2fs_map_blocks(inode, &map, 1, F2FS_GET_BLOCK_PRE_DIO);
+	flag = F2FS_GET_BLOCK_PRE_AIO;
+
+map_blocks:
+	err = f2fs_map_blocks(inode, &map, 1, flag);
+	if (map.m_len > 0 && err == -ENOSPC) {
+		if (!direct_io)
+			set_inode_flag(inode, FI_NO_PREALLOC);
+		err = 0;
 	}
-	if (iocb->ki_pos + iov_iter_count(from) > MAX_INLINE_DATA) {
-		ret = f2fs_convert_inline_inode(inode);
-		if (ret)
-			return ret;
+	return err;
+}
+
+static inline void __do_map_lock(struct f2fs_sb_info *sbi, int flag, bool lock)
+{
+	if (flag == F2FS_GET_BLOCK_PRE_AIO) {
+		if (lock)
+			down_read(&sbi->node_change);
+		else
+			up_read(&sbi->node_change);
+	} else {
+		if (lock)
+			f2fs_lock_op(sbi);
+		else
+			f2fs_unlock_op(sbi);
 	}
-	if (!f2fs_has_inline_data(inode))
-		return f2fs_map_blocks(inode, &map, 1, F2FS_GET_BLOCK_PRE_AIO);
-	return ret;
 }
 
 /*
@@ -675,9 +991,9 @@ int f2fs_map_blocks(struct inode *inode, struct f2fs_map_blocks *map,
 	int err = 0, ofs = 1;
 	unsigned int ofs_in_node, last_ofs_in_node;
 	blkcnt_t prealloc;
-	struct extent_info ei;
-	bool allocated = false;
+	struct extent_info ei = {0,0,0};
 	block_t blkaddr;
+	unsigned int start_pgofs;
 
 	if (!maxblocks)
 		return 0;
@@ -693,16 +1009,18 @@ int f2fs_map_blocks(struct inode *inode, struct f2fs_map_blocks *map,
 		map->m_pblk = ei.blk + pgofs - ei.fofs;
 		map->m_len = min((pgoff_t)maxblocks, ei.fofs + ei.len - pgofs);
 		map->m_flags = F2FS_MAP_MAPPED;
+		if (map->m_next_extent)
+			*map->m_next_extent = pgofs + map->m_len;
 		goto out;
 	}
 
 next_dnode:
 	if (create)
-		f2fs_lock_op(sbi);
+		__do_map_lock(sbi, flag, true);
 
 	/* When reading holes, we need its node page */
 	set_new_dnode(&dn, inode, NULL, NULL, 0);
-	err = get_dnode_of_data(&dn, pgofs, mode);
+	err = f2fs_get_dnode_of_data(&dn, pgofs, mode);
 	if (err) {
 		if (flag == F2FS_GET_BLOCK_BMAP)
 			map->m_pblk = 0;
@@ -710,19 +1028,23 @@ int f2fs_map_blocks(struct inode *inode, struct f2fs_map_blocks *map,
 			err = 0;
 			if (map->m_next_pgofs)
 				*map->m_next_pgofs =
-					get_next_page_offset(&dn, pgofs);
+					f2fs_get_next_page_offset(&dn, pgofs);
+			if (map->m_next_extent)
+				*map->m_next_extent =
+					f2fs_get_next_page_offset(&dn, pgofs);
 		}
 		goto unlock_out;
 	}
 
+	start_pgofs = pgofs;
 	prealloc = 0;
 	last_ofs_in_node = ofs_in_node = dn.ofs_in_node;
 	end_offset = ADDRS_PER_PAGE(dn.node_page, inode);
 
 next_block:
-	blkaddr = datablock_addr(dn.node_page, dn.ofs_in_node);
+	blkaddr = datablock_addr(dn.inode, dn.node_page, dn.ofs_in_node);
 
-	if (blkaddr == NEW_ADDR || blkaddr == NULL_ADDR) {
+	if (!is_valid_blkaddr(blkaddr)) {
 		if (create) {
 			if (unlikely(f2fs_cp_error(sbi))) {
 				err = -EIO;
@@ -734,29 +1056,34 @@ int f2fs_map_blocks(struct inode *inode, struct f2fs_map_blocks *map,
 					last_ofs_in_node = dn.ofs_in_node;
 				}
 			} else {
-				err = __allocate_data_block(&dn);
-				if (!err) {
+				err = __allocate_data_block(&dn,
+							map->m_seg_type);
+				if (!err)
 					set_inode_flag(inode, FI_APPEND_WRITE);
-					allocated = true;
-				}
 			}
 			if (err)
 				goto sync_out;
-			map->m_flags = F2FS_MAP_NEW;
+			map->m_flags |= F2FS_MAP_NEW;
 			blkaddr = dn.data_blkaddr;
 		} else {
 			if (flag == F2FS_GET_BLOCK_BMAP) {
 				map->m_pblk = 0;
 				goto sync_out;
 			}
+			if (flag == F2FS_GET_BLOCK_PRECACHE)
+				goto sync_out;
 			if (flag == F2FS_GET_BLOCK_FIEMAP &&
 						blkaddr == NULL_ADDR) {
 				if (map->m_next_pgofs)
 					*map->m_next_pgofs = pgofs + 1;
+				goto sync_out;
 			}
-			if (flag != F2FS_GET_BLOCK_FIEMAP ||
-						blkaddr != NEW_ADDR)
+			if (flag != F2FS_GET_BLOCK_FIEMAP) {
+				/* for defragment case */
+				if (map->m_next_pgofs)
+					*map->m_next_pgofs = pgofs + 1;
 				goto sync_out;
+			}
 		}
 	}
 
@@ -790,10 +1117,9 @@ int f2fs_map_blocks(struct inode *inode, struct f2fs_map_blocks *map,
 			(pgofs == end || dn.ofs_in_node == end_offset)) {
 
 		dn.ofs_in_node = ofs_in_node;
-		err = reserve_new_blocks(&dn, prealloc);
+		err = f2fs_reserve_new_blocks(&dn, prealloc);
 		if (err)
 			goto sync_out;
-		allocated = dn.node_changed;
 
 		map->m_len += dn.ofs_in_node - ofs_in_node;
 		if (prealloc && dn.ofs_in_node != last_ofs_in_node + 1) {
@@ -808,45 +1134,92 @@ int f2fs_map_blocks(struct inode *inode, struct f2fs_map_blocks *map,
 	else if (dn.ofs_in_node < end_offset)
 		goto next_block;
 
+	if (flag == F2FS_GET_BLOCK_PRECACHE) {
+		if (map->m_flags & F2FS_MAP_MAPPED) {
+			unsigned int ofs = start_pgofs - map->m_lblk;
+
+			f2fs_update_extent_cache_range(&dn,
+				start_pgofs, map->m_pblk + ofs,
+				map->m_len - ofs);
+		}
+	}
+
 	f2fs_put_dnode(&dn);
 
 	if (create) {
-		f2fs_unlock_op(sbi);
-		f2fs_balance_fs(sbi, allocated);
+		__do_map_lock(sbi, flag, false);
+		f2fs_balance_fs(sbi, dn.node_changed);
 	}
-	allocated = false;
 	goto next_dnode;
 
 sync_out:
+	if (flag == F2FS_GET_BLOCK_PRECACHE) {
+		if (map->m_flags & F2FS_MAP_MAPPED) {
+			unsigned int ofs = start_pgofs - map->m_lblk;
+
+			f2fs_update_extent_cache_range(&dn,
+				start_pgofs, map->m_pblk + ofs,
+				map->m_len - ofs);
+		}
+		if (map->m_next_extent)
+			*map->m_next_extent = pgofs + 1;
+	}
 	f2fs_put_dnode(&dn);
 unlock_out:
 	if (create) {
-		f2fs_unlock_op(sbi);
-		f2fs_balance_fs(sbi, allocated);
+		__do_map_lock(sbi, flag, false);
+		f2fs_balance_fs(sbi, dn.node_changed);
 	}
 out:
 	trace_f2fs_map_blocks(inode, map, err);
 	return err;
 }
 
+bool f2fs_overwrite_io(struct inode *inode, loff_t pos, size_t len)
+{
+	struct f2fs_map_blocks map;
+	block_t last_lblk;
+	int err;
+
+	if (pos + len > i_size_read(inode))
+		return false;
+
+	map.m_lblk = F2FS_BYTES_TO_BLK(pos);
+	map.m_next_pgofs = NULL;
+	map.m_next_extent = NULL;
+	map.m_seg_type = NO_CHECK_TYPE;
+	last_lblk = F2FS_BLK_ALIGN(pos + len);
+
+	while (map.m_lblk < last_lblk) {
+		map.m_len = last_lblk - map.m_lblk;
+		err = f2fs_map_blocks(inode, &map, 0, F2FS_GET_BLOCK_DEFAULT);
+		if (err || map.m_len == 0)
+			return false;
+		map.m_lblk += map.m_len;
+	}
+	return true;
+}
+
 static int __get_data_block(struct inode *inode, sector_t iblock,
 			struct buffer_head *bh, int create, int flag,
-			pgoff_t *next_pgofs)
+			pgoff_t *next_pgofs, int seg_type)
 {
 	struct f2fs_map_blocks map;
-	int ret;
+	int err;
 
 	map.m_lblk = iblock;
 	map.m_len = bh->b_size >> inode->i_blkbits;
 	map.m_next_pgofs = next_pgofs;
+	map.m_next_extent = NULL;
+	map.m_seg_type = seg_type;
 
-	ret = f2fs_map_blocks(inode, &map, create, flag);
-	if (!ret) {
+	err = f2fs_map_blocks(inode, &map, create, flag);
+	if (!err) {
 		map_bh(bh, inode->i_sb, map.m_pblk);
 		bh->b_state = (bh->b_state & ~F2FS_MAP_FLAGS) | map.m_flags;
 		bh->b_size = (u64)map.m_len << inode->i_blkbits;
 	}
-	return ret;
+	return err;
 }
 
 static int get_data_block(struct inode *inode, sector_t iblock,
@@ -854,14 +1227,17 @@ static int get_data_block(struct inode *inode, sector_t iblock,
 			pgoff_t *next_pgofs)
 {
 	return __get_data_block(inode, iblock, bh_result, create,
-							flag, next_pgofs);
+							flag, next_pgofs,
+							NO_CHECK_TYPE);
 }
 
 static int get_data_block_dio(struct inode *inode, sector_t iblock,
 			struct buffer_head *bh_result, int create)
 {
 	return __get_data_block(inode, iblock, bh_result, create,
-						F2FS_GET_BLOCK_DIO, NULL);
+						F2FS_GET_BLOCK_DEFAULT, NULL,
+						f2fs_rw_hint_to_seg_type(
+							inode->i_write_hint));
 }
 
 static int get_data_block_bmap(struct inode *inode, sector_t iblock,
@@ -872,7 +1248,8 @@ static int get_data_block_bmap(struct inode *inode, sector_t iblock,
 		return -EFBIG;
 
 	return __get_data_block(inode, iblock, bh_result, create,
-						F2FS_GET_BLOCK_BMAP, NULL);
+						F2FS_GET_BLOCK_BMAP, NULL,
+						NO_CHECK_TYPE);
 }
 
 static inline sector_t logical_to_blk(struct inode *inode, loff_t offset)
@@ -885,35 +1262,100 @@ static inline loff_t blk_to_logical(struct inode *inode, sector_t blk)
 	return (blk << inode->i_blkbits);
 }
 
+static int f2fs_xattr_fiemap(struct inode *inode,
+				struct fiemap_extent_info *fieinfo)
+{
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+	struct page *page;
+	struct node_info ni;
+	__u64 phys = 0, len;
+	__u32 flags;
+	nid_t xnid = F2FS_I(inode)->i_xattr_nid;
+	int err = 0;
+
+	if (f2fs_has_inline_xattr(inode)) {
+		int offset;
+
+		page = f2fs_grab_cache_page(NODE_MAPPING(sbi),
+						inode->i_ino, false);
+		if (!page)
+			return -ENOMEM;
+
+		f2fs_get_node_info(sbi, inode->i_ino, &ni);
+
+		phys = (__u64)blk_to_logical(inode, ni.blk_addr);
+		offset = offsetof(struct f2fs_inode, i_addr) +
+					sizeof(__le32) * (DEF_ADDRS_PER_INODE -
+					get_inline_xattr_addrs(inode));
+
+		phys += offset;
+		len = inline_xattr_size(inode);
+
+		f2fs_put_page(page, 1);
+
+		flags = FIEMAP_EXTENT_DATA_INLINE | FIEMAP_EXTENT_NOT_ALIGNED;
+
+		if (!xnid)
+			flags |= FIEMAP_EXTENT_LAST;
+
+		err = fiemap_fill_next_extent(fieinfo, 0, phys, len, flags);
+		if (err || err == 1)
+			return err;
+	}
+
+	if (xnid) {
+		page = f2fs_grab_cache_page(NODE_MAPPING(sbi), xnid, false);
+		if (!page)
+			return -ENOMEM;
+
+		f2fs_get_node_info(sbi, xnid, &ni);
+
+		phys = (__u64)blk_to_logical(inode, ni.blk_addr);
+		len = inode->i_sb->s_blocksize;
+
+		f2fs_put_page(page, 1);
+
+		flags = FIEMAP_EXTENT_LAST;
+	}
+
+	if (phys)
+		err = fiemap_fill_next_extent(fieinfo, 0, phys, len, flags);
+
+	return (err < 0 ? err : 0);
+}
+
 int f2fs_fiemap(struct inode *inode, struct fiemap_extent_info *fieinfo,
 		u64 start, u64 len)
 {
 	struct buffer_head map_bh;
 	sector_t start_blk, last_blk;
 	pgoff_t next_pgofs;
-	loff_t isize;
 	u64 logical = 0, phys = 0, size = 0;
-	u32 flags = 0;
-	int ret = 0;
-
-	ret = fiemap_check_flags(fieinfo, FIEMAP_FLAG_SYNC);
-	if (ret)
-		return ret;
+	u32 flags = 0;
+	int ret = 0;
 
-	if (f2fs_has_inline_data(inode)) {
-		ret = f2fs_inline_data_fiemap(inode, fieinfo, start, len);
-		if (ret != -EAGAIN)
+	if (fieinfo->fi_flags & FIEMAP_FLAG_CACHE) {
+		ret = f2fs_precache_extents(inode);
+		if (ret)
 			return ret;
 	}
 
+	ret = fiemap_check_flags(fieinfo, FIEMAP_FLAG_SYNC | FIEMAP_FLAG_XATTR);
+	if (ret)
+		return ret;
+
 	inode_lock(inode);
 
-	isize = i_size_read(inode);
-	if (start >= isize)
+	if (fieinfo->fi_flags & FIEMAP_FLAG_XATTR) {
+		ret = f2fs_xattr_fiemap(inode, fieinfo);
 		goto out;
+	}
 
-	if (start + len > isize)
-		len = isize - start;
+	if (f2fs_has_inline_data(inode)) {
+		ret = f2fs_inline_data_fiemap(inode, fieinfo, start, len);
+		if (ret != -EAGAIN)
+			goto out;
+	}
 
 	if (logical_to_blk(inode, len) == 0)
 		len = blk_to_logical(inode, 1);
@@ -933,13 +1375,11 @@ int f2fs_fiemap(struct inode *inode, struct fiemap_extent_info *fieinfo,
 	/* HOLE */
 	if (!buffer_mapped(&map_bh)) {
 		start_blk = next_pgofs;
-		/* Go through holes util pass the EOF */
-		if (blk_to_logical(inode, start_blk) < isize)
+
+		if (blk_to_logical(inode, start_blk) < blk_to_logical(inode,
+					F2FS_I_SB(inode)->max_file_blocks))
 			goto prep_next;
-		/* Found a hole beyond isize means no more extents.
-		 * Note that the premise is that filesystems don't
-		 * punch holes beyond isize and keep size unchanged.
-		 */
+
 		flags |= FIEMAP_EXTENT_LAST;
 	}
 
@@ -977,37 +1417,6 @@ int f2fs_fiemap(struct inode *inode, struct fiemap_extent_info *fieinfo,
 	return ret;
 }
 
-static struct bio *f2fs_grab_bio(struct inode *inode, block_t blkaddr,
-				 unsigned nr_pages)
-{
-	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
-	struct fscrypt_ctx *ctx = NULL;
-	struct block_device *bdev = sbi->sb->s_bdev;
-	struct bio *bio;
-
-	if (f2fs_encrypted_inode(inode) && S_ISREG(inode->i_mode)) {
-		ctx = fscrypt_get_ctx(inode, GFP_NOFS);
-		if (IS_ERR(ctx))
-			return ERR_CAST(ctx);
-
-		/* wait the page to be moved by cleaning */
-		f2fs_wait_on_encrypted_page_writeback(sbi, blkaddr);
-	}
-
-	bio = bio_alloc(GFP_KERNEL, min_t(int, nr_pages, BIO_MAX_PAGES));
-	if (!bio) {
-		if (ctx)
-			fscrypt_release_ctx(ctx);
-		return ERR_PTR(-ENOMEM);
-	}
-	bio->bi_bdev = bdev;
-	bio->bi_iter.bi_sector = SECTOR_FROM_BLOCK(blkaddr);
-	bio->bi_end_io = f2fs_read_end_io;
-	bio->bi_private = ctx;
-
-	return bio;
-}
-
 /*
  * This function was originally taken from fs/mpage.c, and customized for f2fs.
  * Major change was from block_size == page_size in f2fs by default.
@@ -1017,7 +1426,6 @@ static int f2fs_mpage_readpages(struct address_space *mapping,
 			unsigned nr_pages)
 {
 	struct bio *bio = NULL;
-	unsigned page_idx;
 	sector_t last_block_in_bio = 0;
 	struct inode *inode = mapping->host;
 	const unsigned blkbits = inode->i_blkbits;
@@ -1033,12 +1441,14 @@ static int f2fs_mpage_readpages(struct address_space *mapping,
 	map.m_len = 0;
 	map.m_flags = 0;
 	map.m_next_pgofs = NULL;
+	map.m_next_extent = NULL;
+	map.m_seg_type = NO_CHECK_TYPE;
 
-	for (page_idx = 0; nr_pages; page_idx++, nr_pages--) {
-
-		prefetchw(&page->flags);
+	for (; nr_pages; nr_pages--) {
 		if (pages) {
-			page = list_entry(pages->prev, struct page, lru);
+			page = list_last_entry(pages, struct page, lru);
+
+			prefetchw(&page->flags);
 			list_del(&page->lru);
 			if (add_to_page_cache_lru(page, mapping,
 						  page->index,
@@ -1072,7 +1482,7 @@ static int f2fs_mpage_readpages(struct address_space *mapping,
 			map.m_len = last_block - block_in_file;
 
 			if (f2fs_map_blocks(inode, &map, 0,
-						F2FS_GET_BLOCK_READ))
+						F2FS_GET_BLOCK_DEFAULT))
 				goto set_error_page;
 		}
 got_it:
@@ -1096,18 +1506,18 @@ static int f2fs_mpage_readpages(struct address_space *mapping,
 		 * This page will go to BIO.  Do we need to send this
 		 * BIO off first?
 		 */
-		if (bio && (last_block_in_bio != block_nr - 1)) {
+		if (bio && (last_block_in_bio != block_nr - 1 ||
+			!__same_bdev(F2FS_I_SB(inode), block_nr, bio))) {
 submit_and_realloc:
 			__submit_bio(F2FS_I_SB(inode), bio, DATA);
 			bio = NULL;
 		}
 		if (bio == NULL) {
-			bio = f2fs_grab_bio(inode, block_nr, nr_pages);
+			bio = f2fs_grab_read_bio(inode, block_nr, nr_pages);
 			if (IS_ERR(bio)) {
 				bio = NULL;
 				goto set_error_page;
 			}
-			bio_set_op_attrs(bio, REQ_OP_READ, 0);
 		}
 
 		if (bio_add_page(bio, page, blocksize, 0) < blocksize)
@@ -1155,8 +1565,8 @@ static int f2fs_read_data_pages(struct file *file,
 			struct address_space *mapping,
 			struct list_head *pages, unsigned nr_pages)
 {
-	struct inode *inode = file->f_mapping->host;
-	struct page *page = list_entry(pages->prev, struct page, lru);
+	struct inode *inode = mapping->host;
+	struct page *page = list_last_entry(pages, struct page, lru);
 
 	trace_f2fs_readpages(inode, page, nr_pages);
 
@@ -1167,17 +1577,136 @@ static int f2fs_read_data_pages(struct file *file,
 	return f2fs_mpage_readpages(mapping, pages, NULL, nr_pages);
 }
 
-int do_write_data_page(struct f2fs_io_info *fio)
+static int encrypt_one_page(struct f2fs_io_info *fio)
+{
+	struct inode *inode = fio->page->mapping->host;
+	gfp_t gfp_flags = GFP_NOFS;
+
+	if (!f2fs_encrypted_file(inode))
+		return 0;
+
+	/* wait for GCed page writeback via META_MAPPING */
+	f2fs_wait_on_block_writeback(fio->sbi, fio->old_blkaddr);
+
+retry_encrypt:
+	fio->encrypted_page = fscrypt_encrypt_page(inode, fio->page,
+			PAGE_SIZE, 0, fio->page->index, gfp_flags);
+	if (!IS_ERR(fio->encrypted_page))
+		return 0;
+
+	/* flush pending IOs and wait for a while in the ENOMEM case */
+	if (PTR_ERR(fio->encrypted_page) == -ENOMEM) {
+		f2fs_flush_merged_writes(fio->sbi);
+		congestion_wait(BLK_RW_ASYNC, HZ/50);
+		gfp_flags |= __GFP_NOFAIL;
+		goto retry_encrypt;
+	}
+	return PTR_ERR(fio->encrypted_page);
+}
+
+static inline bool check_inplace_update_policy(struct inode *inode,
+				struct f2fs_io_info *fio)
+{
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+	unsigned int policy = SM_I(sbi)->ipu_policy;
+
+	if (policy & (0x1 << F2FS_IPU_FORCE))
+		return true;
+	if (policy & (0x1 << F2FS_IPU_SSR) && f2fs_need_SSR(sbi))
+		return true;
+	if (policy & (0x1 << F2FS_IPU_UTIL) &&
+			utilization(sbi) > SM_I(sbi)->min_ipu_util)
+		return true;
+	if (policy & (0x1 << F2FS_IPU_SSR_UTIL) && f2fs_need_SSR(sbi) &&
+			utilization(sbi) > SM_I(sbi)->min_ipu_util)
+		return true;
+
+	/*
+	 * IPU for rewrite async pages
+	 */
+	if (policy & (0x1 << F2FS_IPU_ASYNC) &&
+			fio && fio->op == REQ_OP_WRITE &&
+			!(fio->op_flags & REQ_SYNC) &&
+			!f2fs_encrypted_inode(inode))
+		return true;
+
+	/* this is only set during fdatasync */
+	if (policy & (0x1 << F2FS_IPU_FSYNC) &&
+			is_inode_flag_set(inode, FI_NEED_IPU))
+		return true;
+
+	return false;
+}
+
+bool f2fs_should_update_inplace(struct inode *inode, struct f2fs_io_info *fio)
+{
+	if (f2fs_is_pinned_file(inode))
+		return true;
+
+	/* if this is cold file, we should overwrite to avoid fragmentation */
+	if (file_is_cold(inode))
+		return true;
+
+	return check_inplace_update_policy(inode, fio);
+}
+
+bool f2fs_should_update_outplace(struct inode *inode, struct f2fs_io_info *fio)
+{
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+
+	if (test_opt(sbi, LFS))
+		return true;
+	if (S_ISDIR(inode->i_mode))
+		return true;
+	if (f2fs_is_atomic_file(inode))
+		return true;
+	if (fio) {
+		if (is_cold_data(fio->page))
+			return true;
+		if (IS_ATOMIC_WRITTEN_PAGE(fio->page))
+			return true;
+	}
+	return false;
+}
+
+static inline bool need_inplace_update(struct f2fs_io_info *fio)
+{
+	struct inode *inode = fio->page->mapping->host;
+
+	if (f2fs_should_update_outplace(inode, fio))
+		return false;
+
+	return f2fs_should_update_inplace(inode, fio);
+}
+
+int f2fs_do_write_data_page(struct f2fs_io_info *fio)
 {
 	struct page *page = fio->page;
 	struct inode *inode = page->mapping->host;
 	struct dnode_of_data dn;
+	struct extent_info ei = {0,0,0};
+	bool ipu_force = false;
 	int err = 0;
 
 	set_new_dnode(&dn, inode, NULL, NULL, 0);
-	err = get_dnode_of_data(&dn, page->index, LOOKUP_NODE);
+	if (need_inplace_update(fio) &&
+			f2fs_lookup_extent_cache(inode, page->index, &ei)) {
+		fio->old_blkaddr = ei.blk + page->index - ei.fofs;
+
+		if (is_valid_blkaddr(fio->old_blkaddr)) {
+			ipu_force = true;
+			fio->need_lock = LOCK_DONE;
+			goto got_it;
+		}
+	}
+
+	/* Deadlock due to between page->lock and f2fs_lock_op */
+	if (fio->need_lock == LOCK_REQ && !f2fs_trylock_op(fio->sbi))
+		return -EAGAIN;
+
+	err = f2fs_get_dnode_of_data(&dn, page->index, LOOKUP_NODE);
 	if (err)
-		return err;
+		goto out;
 
 	fio->old_blkaddr = dn.data_blkaddr;
 
@@ -1186,57 +1715,60 @@ int do_write_data_page(struct f2fs_io_info *fio)
 		ClearPageUptodate(page);
 		goto out_writepage;
 	}
+got_it:
+	/*
+	 * If current allocation needs SSR,
+	 * it had better in-place writes for updated data.
+	 */
+	if (ipu_force || (is_valid_blkaddr(fio->old_blkaddr) &&
+					need_inplace_update(fio))) {
+		err = encrypt_one_page(fio);
+		if (err)
+			goto out_writepage;
 
-	if (f2fs_encrypted_inode(inode) && S_ISREG(inode->i_mode)) {
-		gfp_t gfp_flags = GFP_NOFS;
+		set_page_writeback(page);
+		ClearPageError(page);
+		f2fs_put_dnode(&dn);
+		if (fio->need_lock == LOCK_REQ)
+			f2fs_unlock_op(fio->sbi);
+		err = f2fs_inplace_write_data(fio);
+		trace_f2fs_do_write_data_page(fio->page, IPU);
+		set_inode_flag(inode, FI_UPDATE_WRITE);
+		return err;
+	}
 
-		/* wait for GCed encrypted page writeback */
-		f2fs_wait_on_encrypted_page_writeback(F2FS_I_SB(inode),
-							fio->old_blkaddr);
-retry_encrypt:
-		fio->encrypted_page = fscrypt_encrypt_page(inode, fio->page,
-								gfp_flags);
-		if (IS_ERR(fio->encrypted_page)) {
-			err = PTR_ERR(fio->encrypted_page);
-			if (err == -ENOMEM) {
-				/* flush pending ios and wait for a while */
-				f2fs_flush_merged_bios(F2FS_I_SB(inode));
-				congestion_wait(BLK_RW_ASYNC, HZ/50);
-				gfp_flags |= __GFP_NOFAIL;
-				err = 0;
-				goto retry_encrypt;
-			}
+	if (fio->need_lock == LOCK_RETRY) {
+		if (!f2fs_trylock_op(fio->sbi)) {
+			err = -EAGAIN;
 			goto out_writepage;
 		}
+		fio->need_lock = LOCK_REQ;
 	}
 
-	set_page_writeback(page);
+	err = encrypt_one_page(fio);
+	if (err)
+		goto out_writepage;
 
-	/*
-	 * If current allocation needs SSR,
-	 * it had better in-place writes for updated data.
-	 */
-	if (unlikely(fio->old_blkaddr != NEW_ADDR &&
-			!is_cold_data(page) &&
-			!IS_ATOMIC_WRITTEN_PAGE(page) &&
-			need_inplace_update(inode))) {
-		rewrite_data_page(fio);
-		set_inode_flag(inode, FI_UPDATE_WRITE);
-		trace_f2fs_do_write_data_page(page, IPU);
-	} else {
-		write_data_page(&dn, fio);
-		trace_f2fs_do_write_data_page(page, OPU);
-		set_inode_flag(inode, FI_APPEND_WRITE);
-		if (page->index == 0)
-			set_inode_flag(inode, FI_FIRST_BLOCK_WRITTEN);
-	}
+	set_page_writeback(page);
+	ClearPageError(page);
+
+	/* LFS mode write path */
+	f2fs_outplace_write_data(&dn, fio);
+	trace_f2fs_do_write_data_page(page, OPU);
+	set_inode_flag(inode, FI_APPEND_WRITE);
+	if (page->index == 0)
+		set_inode_flag(inode, FI_FIRST_BLOCK_WRITTEN);
 out_writepage:
 	f2fs_put_dnode(&dn);
+out:
+	if (fio->need_lock == LOCK_REQ)
+		f2fs_unlock_op(fio->sbi);
 	return err;
 }
 
-static int f2fs_write_data_page(struct page *page,
-					struct writeback_control *wbc)
+static int __write_data_page(struct page *page, bool *submitted,
+				struct writeback_control *wbc,
+				enum iostat_type io_type)
 {
 	struct inode *inode = page->mapping->host;
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
@@ -1249,15 +1781,36 @@ static int f2fs_write_data_page(struct page *page,
 	int err = 0;
 	struct f2fs_io_info fio = {
 		.sbi = sbi,
+		.ino = inode->i_ino,
 		.type = DATA,
 		.op = REQ_OP_WRITE,
-		.op_flags = (wbc->sync_mode == WB_SYNC_ALL) ? WRITE_SYNC : 0,
+		.op_flags = wbc_to_write_flags(wbc),
+		.old_blkaddr = NULL_ADDR,
 		.page = page,
 		.encrypted_page = NULL,
+		.submitted = false,
+		.need_lock = LOCK_RETRY,
+		.io_type = io_type,
+		.io_wbc = wbc,
 	};
 
 	trace_f2fs_writepage(page, DATA);
 
+	/* we should bypass data pages to proceed the kworkder jobs */
+	if (unlikely(f2fs_cp_error(sbi))) {
+		mapping_set_error(page->mapping, -EIO);
+		/*
+		 * don't drop any dirty dentry pages for keeping lastest
+		 * directory structure.
+		 */
+		if (S_ISDIR(inode->i_mode))
+			goto redirty_out;
+		goto out;
+	}
+
+	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
+		goto redirty_out;
+
 	if (page->index < end_index)
 		goto write;
 
@@ -1271,25 +1824,18 @@ static int f2fs_write_data_page(struct page *page,
 
 	zero_user_segment(page, offset, PAGE_SIZE);
 write:
-	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
-		goto redirty_out;
 	if (f2fs_is_drop_cache(inode))
 		goto out;
 	/* we should not write 0'th page having journal header */
 	if (f2fs_is_volatile_file(inode) && (!page->index ||
 			(!wbc->for_reclaim &&
-			available_free_memory(sbi, BASE_CHECK))))
+			f2fs_available_free_memory(sbi, BASE_CHECK))))
 		goto redirty_out;
 
-	/* we should bypass data pages to proceed the kworkder jobs */
-	if (unlikely(f2fs_cp_error(sbi))) {
-		mapping_set_error(page->mapping, -EIO);
-		goto out;
-	}
-
 	/* Dentry blocks are controlled by checkpoint */
 	if (S_ISDIR(inode->i_mode)) {
-		err = do_write_data_page(&fio);
+		fio.need_lock = LOCK_DONE;
+		err = f2fs_do_write_data_page(&fio);
 		goto done;
 	}
 
@@ -1297,68 +1843,114 @@ static int f2fs_write_data_page(struct page *page,
 		need_balance_fs = true;
 	else if (has_not_enough_free_secs(sbi, 0, 0))
 		goto redirty_out;
+	else
+		set_inode_flag(inode, FI_HOT_DATA);
 
 	err = -EAGAIN;
-	f2fs_lock_op(sbi);
-	if (f2fs_has_inline_data(inode))
+	if (f2fs_has_inline_data(inode)) {
 		err = f2fs_write_inline_data(inode, page);
-	if (err == -EAGAIN)
-		err = do_write_data_page(&fio);
-	if (F2FS_I(inode)->last_disk_size < psize)
-		F2FS_I(inode)->last_disk_size = psize;
-	f2fs_unlock_op(sbi);
+		if (!err)
+			goto out;
+	}
+
+	if (err == -EAGAIN) {
+		err = f2fs_do_write_data_page(&fio);
+		if (err == -EAGAIN) {
+			fio.need_lock = LOCK_REQ;
+			err = f2fs_do_write_data_page(&fio);
+		}
+	}
+
+	if (err) {
+		file_set_keep_isize(inode);
+	} else {
+		down_write(&F2FS_I(inode)->i_sem);
+		if (F2FS_I(inode)->last_disk_size < psize)
+			F2FS_I(inode)->last_disk_size = psize;
+		up_write(&F2FS_I(inode)->i_sem);
+	}
+
 done:
 	if (err && err != -ENOENT)
 		goto redirty_out;
 
-	clear_cold_data(page);
 out:
 	inode_dec_dirty_pages(inode);
 	if (err)
 		ClearPageUptodate(page);
 
 	if (wbc->for_reclaim) {
-		f2fs_submit_merged_bio_cond(sbi, NULL, page, 0, DATA, WRITE);
-		remove_dirty_inode(inode);
+		f2fs_submit_merged_write_cond(sbi, inode, 0, page->index, DATA);
+		clear_inode_flag(inode, FI_HOT_DATA);
+		f2fs_remove_dirty_inode(inode);
+		submitted = NULL;
 	}
 
 	unlock_page(page);
-	f2fs_balance_fs(sbi, need_balance_fs);
+	if (!S_ISDIR(inode->i_mode))
+		f2fs_balance_fs(sbi, need_balance_fs);
 
-	if (unlikely(f2fs_cp_error(sbi)))
-		f2fs_submit_merged_bio(sbi, DATA, WRITE);
+	if (unlikely(f2fs_cp_error(sbi))) {
+		f2fs_submit_merged_write(sbi, DATA);
+		submitted = NULL;
+	}
+
+	if (submitted)
+		*submitted = fio.submitted;
 
 	return 0;
 
 redirty_out:
 	redirty_page_for_writepage(wbc, page);
+	/*
+	 * pageout() in MM traslates EAGAIN, so calls handle_write_error()
+	 * -> mapping_set_error() -> set_bit(AS_EIO, ...).
+	 * file_write_and_wait_range() will see EIO error, which is critical
+	 * to return value of fsync() followed by atomic_write failure to user.
+	 */
+	if (!err || wbc->for_reclaim)
+		return AOP_WRITEPAGE_ACTIVATE;
 	unlock_page(page);
 	return err;
 }
 
+static int f2fs_write_data_page(struct page *page,
+					struct writeback_control *wbc)
+{
+	return __write_data_page(page, NULL, wbc, FS_DATA_IO);
+}
+
 /*
  * This function was copied from write_cche_pages from mm/page-writeback.c.
  * The major change is making write step of cold data page separately from
  * warm/hot data page.
  */
 static int f2fs_write_cache_pages(struct address_space *mapping,
-					struct writeback_control *wbc)
+					struct writeback_control *wbc,
+					enum iostat_type io_type)
 {
 	int ret = 0;
 	int done = 0;
 	struct pagevec pvec;
+	struct f2fs_sb_info *sbi = F2FS_M_SB(mapping);
 	int nr_pages;
 	pgoff_t uninitialized_var(writeback_index);
 	pgoff_t index;
 	pgoff_t end;		/* Inclusive */
 	pgoff_t done_index;
+	pgoff_t last_idx = ULONG_MAX;
 	int cycled;
 	int range_whole = 0;
 	int tag;
-	int nwritten = 0;
 
 	pagevec_init(&pvec, 0);
 
+	if (get_dirty_pages(mapping->host) <=
+				SM_I(F2FS_M_SB(mapping))->min_hot_blocks)
+		set_inode_flag(mapping->host, FI_HOT_DATA);
+	else
+		clear_inode_flag(mapping->host, FI_HOT_DATA);
+
 	if (wbc->range_cyclic) {
 		writeback_index = mapping->writeback_index; /* prev offset */
 		index = writeback_index;
@@ -1385,21 +1977,24 @@ static int f2fs_write_cache_pages(struct address_space *mapping,
 	while (!done && (index <= end)) {
 		int i;
 
-		nr_pages = pagevec_lookup_tag(&pvec, mapping, &index, tag,
-			      min(end - index, (pgoff_t)PAGEVEC_SIZE - 1) + 1);
+		nr_pages = pagevec_lookup_range_tag(&pvec, mapping, &index, end,
+				tag);
 		if (nr_pages == 0)
 			break;
 
 		for (i = 0; i < nr_pages; i++) {
 			struct page *page = pvec.pages[i];
+			bool submitted = false;
 
-			if (page->index > end) {
+			/* give a priority to WB_SYNC threads */
+			if (atomic_read(&sbi->wb_sync_req[DATA]) &&
+					wbc->sync_mode == WB_SYNC_NONE) {
 				done = 1;
 				break;
 			}
 
 			done_index = page->index;
-
+retry_write:
 			lock_page(page);
 
 			if (unlikely(page->mapping != mapping)) {
@@ -1425,17 +2020,35 @@ static int f2fs_write_cache_pages(struct address_space *mapping,
 			if (!clear_page_dirty_for_io(page))
 				goto continue_unlock;
 
-			ret = mapping->a_ops->writepage(page, wbc);
+			ret = __write_data_page(page, &submitted, wbc, io_type);
 			if (unlikely(ret)) {
+				/*
+				 * keep nr_to_write, since vfs uses this to
+				 * get # of written pages.
+				 */
+				if (ret == AOP_WRITEPAGE_ACTIVATE) {
+					unlock_page(page);
+					ret = 0;
+					continue;
+				} else if (ret == -EAGAIN) {
+					ret = 0;
+					if (wbc->sync_mode == WB_SYNC_ALL) {
+						cond_resched();
+						congestion_wait(BLK_RW_ASYNC,
+									HZ/50);
+						goto retry_write;
+					}
+					continue;
+				}
 				done_index = page->index + 1;
 				done = 1;
 				break;
-			} else {
-				nwritten++;
+			} else if (submitted) {
+				last_idx = page->index;
 			}
 
 			if (--wbc->nr_to_write <= 0 &&
-			    wbc->sync_mode == WB_SYNC_NONE) {
+					wbc->sync_mode == WB_SYNC_NONE) {
 				done = 1;
 				break;
 			}
@@ -1453,15 +2066,16 @@ static int f2fs_write_cache_pages(struct address_space *mapping,
 	if (wbc->range_cyclic || (range_whole && wbc->nr_to_write > 0))
 		mapping->writeback_index = done_index;
 
-	if (nwritten)
-		f2fs_submit_merged_bio_cond(F2FS_M_SB(mapping), mapping->host,
-							NULL, 0, DATA, WRITE);
+	if (last_idx != ULONG_MAX)
+		f2fs_submit_merged_write_cond(F2FS_M_SB(mapping), mapping->host,
+						0, last_idx, DATA);
 
 	return ret;
 }
 
-static int f2fs_write_data_pages(struct address_space *mapping,
-			    struct writeback_control *wbc)
+static int __f2fs_write_data_pages(struct address_space *mapping,
+						struct writeback_control *wbc,
+						enum iostat_type io_type)
 {
 	struct inode *inode = mapping->host;
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
@@ -1476,30 +2090,39 @@ static int f2fs_write_data_pages(struct address_space *mapping,
 	if (!get_dirty_pages(inode) && wbc->sync_mode == WB_SYNC_NONE)
 		return 0;
 
+	/* during POR, we don't need to trigger writepage at all. */
+	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
+		goto skip_write;
+
 	if (S_ISDIR(inode->i_mode) && wbc->sync_mode == WB_SYNC_NONE &&
 			get_dirty_pages(inode) < nr_pages_to_skip(sbi, DATA) &&
-			available_free_memory(sbi, DIRTY_DENTS))
+			f2fs_available_free_memory(sbi, DIRTY_DENTS))
 		goto skip_write;
 
 	/* skip writing during file defragment */
 	if (is_inode_flag_set(inode, FI_DO_DEFRAG))
 		goto skip_write;
 
-	/* during POR, we don't need to trigger writepage at all. */
-	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
-		goto skip_write;
-
 	trace_f2fs_writepages(mapping->host, wbc, DATA);
 
+	/* to avoid spliting IOs due to mixed WB_SYNC_ALL and WB_SYNC_NONE */
+	if (wbc->sync_mode == WB_SYNC_ALL)
+		atomic_inc(&sbi->wb_sync_req[DATA]);
+	else if (atomic_read(&sbi->wb_sync_req[DATA]))
+		goto skip_write;
+
 	blk_start_plug(&plug);
-	ret = f2fs_write_cache_pages(mapping, wbc);
+	ret = f2fs_write_cache_pages(mapping, wbc, io_type);
 	blk_finish_plug(&plug);
+
+	if (wbc->sync_mode == WB_SYNC_ALL)
+		atomic_dec(&sbi->wb_sync_req[DATA]);
 	/*
 	 * if some pages were truncated, we cannot guarantee its mapping->host
 	 * to detect pending bios.
 	 */
 
-	remove_dirty_inode(inode);
+	f2fs_remove_dirty_inode(inode);
 	return ret;
 
 skip_write:
@@ -1508,14 +2131,26 @@ static int f2fs_write_data_pages(struct address_space *mapping,
 	return 0;
 }
 
+static int f2fs_write_data_pages(struct address_space *mapping,
+			    struct writeback_control *wbc)
+{
+	struct inode *inode = mapping->host;
+
+	return __f2fs_write_data_pages(mapping, wbc,
+			F2FS_I(inode)->cp_task == current ?
+			FS_CP_DATA_IO : FS_DATA_IO);
+}
+
 static void f2fs_write_failed(struct address_space *mapping, loff_t to)
 {
 	struct inode *inode = mapping->host;
 	loff_t i_size = i_size_read(inode);
 
 	if (to > i_size) {
+		down_write(&F2FS_I(inode)->i_mmap_sem);
 		truncate_pagecache(inode, i_size);
-		truncate_blocks(inode, i_size, true);
+		f2fs_truncate_blocks(inode, i_size, true);
+		up_write(&F2FS_I(inode)->i_mmap_sem);
 	}
 }
 
@@ -1528,24 +2163,25 @@ static int prepare_write_begin(struct f2fs_sb_info *sbi,
 	struct dnode_of_data dn;
 	struct page *ipage;
 	bool locked = false;
-	struct extent_info ei;
+	struct extent_info ei = {0,0,0};
 	int err = 0;
 
 	/*
 	 * we already allocated all the blocks, so we don't need to get
 	 * the block addresses when there is no need to fill the page.
 	 */
-	if (!f2fs_has_inline_data(inode) && len == PAGE_SIZE)
+	if (!f2fs_has_inline_data(inode) && len == PAGE_SIZE &&
+			!is_inode_flag_set(inode, FI_NO_PREALLOC))
 		return 0;
 
 	if (f2fs_has_inline_data(inode) ||
 			(pos & PAGE_MASK) >= i_size_read(inode)) {
-		f2fs_lock_op(sbi);
+		__do_map_lock(sbi, F2FS_GET_BLOCK_PRE_AIO, true);
 		locked = true;
 	}
 restart:
 	/* check inline_data */
-	ipage = get_node_page(sbi, inode->i_ino);
+	ipage = f2fs_get_node_page(sbi, inode->i_ino);
 	if (IS_ERR(ipage)) {
 		err = PTR_ERR(ipage);
 		goto unlock_out;
@@ -1554,8 +2190,8 @@ static int prepare_write_begin(struct f2fs_sb_info *sbi,
 	set_new_dnode(&dn, inode, ipage, ipage, 0);
 
 	if (f2fs_has_inline_data(inode)) {
-		if (pos + len <= MAX_INLINE_DATA) {
-			read_inline_data(page, ipage);
+		if (pos + len <= MAX_INLINE_DATA(inode)) {
+			f2fs_do_read_inline_data(page, ipage);
 			set_inode_flag(inode, FI_DATA_EXIST);
 			if (inode->i_nlink)
 				set_inline_node(ipage);
@@ -1573,10 +2209,11 @@ static int prepare_write_begin(struct f2fs_sb_info *sbi,
 			dn.data_blkaddr = ei.blk + index - ei.fofs;
 		} else {
 			/* hole case */
-			err = get_dnode_of_data(&dn, index, LOOKUP_NODE);
+			err = f2fs_get_dnode_of_data(&dn, index, LOOKUP_NODE);
 			if (err || dn.data_blkaddr == NULL_ADDR) {
 				f2fs_put_dnode(&dn);
-				f2fs_lock_op(sbi);
+				__do_map_lock(sbi, F2FS_GET_BLOCK_PRE_AIO,
+								true);
 				locked = true;
 				goto restart;
 			}
@@ -1590,7 +2227,7 @@ static int prepare_write_begin(struct f2fs_sb_info *sbi,
 	f2fs_put_dnode(&dn);
 unlock_out:
 	if (locked)
-		f2fs_unlock_op(sbi);
+		__do_map_lock(sbi, F2FS_GET_BLOCK_PRE_AIO, false);
 	return err;
 }
 
@@ -1602,12 +2239,29 @@ static int f2fs_write_begin(struct file *file, struct address_space *mapping,
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	struct page *page = NULL;
 	pgoff_t index = ((unsigned long long) pos) >> PAGE_SHIFT;
-	bool need_balance = false;
+	bool need_balance = false, drop_atomic = false;
 	block_t blkaddr = NULL_ADDR;
 	int err = 0;
 
+	if (trace_android_fs_datawrite_start_enabled()) {
+		char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+		path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    inode);
+		trace_android_fs_datawrite_start(inode, pos, len,
+						 current->pid, path,
+						 current->comm);
+	}
 	trace_f2fs_write_begin(inode, pos, len, flags);
 
+	if (f2fs_is_atomic_file(inode) &&
+			!f2fs_available_free_memory(sbi, INMEM_PAGES)) {
+		err = -ENOMEM;
+		drop_atomic = true;
+		goto fail;
+	}
+
 	/*
 	 * We should check this at this moment to avoid deadlock on inode page
 	 * and #0 page. The locking rule for inline_data conversion should be:
@@ -1623,7 +2277,7 @@ static int f2fs_write_begin(struct file *file, struct address_space *mapping,
 	 * Do not use grab_cache_page_write_begin() to avoid deadlock due to
 	 * wait_for_stable_page. Will wait that below with our IO control.
 	 */
-	page = pagecache_get_page(mapping, index,
+	page = f2fs_pagecache_get_page(mapping, index,
 				FGP_LOCK | FGP_WRITE | FGP_CREAT, GFP_NOFS);
 	if (!page) {
 		err = -ENOMEM;
@@ -1650,32 +2304,25 @@ static int f2fs_write_begin(struct file *file, struct address_space *mapping,
 
 	f2fs_wait_on_page_writeback(page, DATA, false);
 
-	/* wait for GCed encrypted page writeback */
-	if (f2fs_encrypted_inode(inode) && S_ISREG(inode->i_mode))
-		f2fs_wait_on_encrypted_page_writeback(sbi, blkaddr);
+	/* wait for GCed page writeback via META_MAPPING */
+	if (f2fs_post_read_required(inode))
+		f2fs_wait_on_block_writeback(sbi, blkaddr);
 
 	if (len == PAGE_SIZE || PageUptodate(page))
 		return 0;
 
+	if (!(pos & (PAGE_SIZE - 1)) && (pos + len) >= i_size_read(inode)) {
+		zero_user_segment(page, len, PAGE_SIZE);
+		return 0;
+	}
+
 	if (blkaddr == NEW_ADDR) {
 		zero_user_segment(page, 0, PAGE_SIZE);
 		SetPageUptodate(page);
 	} else {
-		struct bio *bio;
-
-		bio = f2fs_grab_bio(inode, blkaddr, 1);
-		if (IS_ERR(bio)) {
-			err = PTR_ERR(bio);
-			goto fail;
-		}
-		bio_set_op_attrs(bio, REQ_OP_READ, READ_SYNC);
-		if (bio_add_page(bio, page, PAGE_SIZE, 0) < PAGE_SIZE) {
-			bio_put(bio);
-			err = -EFAULT;
+		err = f2fs_submit_page_read(inode, page, blkaddr);
+		if (err)
 			goto fail;
-		}
-
-		__submit_bio(sbi, bio, DATA);
 
 		lock_page(page);
 		if (unlikely(page->mapping != mapping)) {
@@ -1692,6 +2339,8 @@ static int f2fs_write_begin(struct file *file, struct address_space *mapping,
 fail:
 	f2fs_put_page(page, 1);
 	f2fs_write_failed(mapping, pos + len);
+	if (drop_atomic)
+		f2fs_drop_inmem_pages_all(sbi, false);
 	return err;
 }
 
@@ -1702,6 +2351,7 @@ static int f2fs_write_end(struct file *file,
 {
 	struct inode *inode = page->mapping->host;
 
+	trace_android_fs_datawrite_end(inode, pos, len);
 	trace_f2fs_write_end(inode, pos, len, copied);
 
 	/*
@@ -1710,7 +2360,7 @@ static int f2fs_write_end(struct file *file,
 	 * let generic_perform_write() try to copy data again through copied=0.
 	 */
 	if (!PageUptodate(page)) {
-		if (unlikely(copied != PAGE_SIZE))
+		if (unlikely(copied != len))
 			copied = 0;
 		else
 			SetPageUptodate(page);
@@ -1719,7 +2369,6 @@ static int f2fs_write_end(struct file *file,
 		goto unlock_out;
 
 	set_page_dirty(page);
-	clear_cold_data(page);
 
 	if (pos + copied > i_size_read(inode))
 		f2fs_i_size_write(inode, pos + copied);
@@ -1747,32 +2396,78 @@ static ssize_t f2fs_direct_IO(struct kiocb *iocb, struct iov_iter *iter)
 {
 	struct address_space *mapping = iocb->ki_filp->f_mapping;
 	struct inode *inode = mapping->host;
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	size_t count = iov_iter_count(iter);
 	loff_t offset = iocb->ki_pos;
 	int rw = iov_iter_rw(iter);
 	int err;
+	enum rw_hint hint = iocb->ki_hint;
+	int whint_mode = F2FS_OPTION(sbi).whint_mode;
 
 	err = check_direct_IO(inode, iter, offset);
 	if (err)
 		return err;
 
-	if (f2fs_encrypted_inode(inode) && S_ISREG(inode->i_mode))
-		return 0;
-	if (test_opt(F2FS_I_SB(inode), LFS))
+	if (f2fs_force_buffered_io(inode, rw))
 		return 0;
 
 	trace_f2fs_direct_IO_enter(inode, offset, count, rw);
 
-	down_read(&F2FS_I(inode)->dio_rwsem[rw]);
+	if (trace_android_fs_dataread_start_enabled() &&
+	    (rw == READ)) {
+		char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+		path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    inode);
+		trace_android_fs_dataread_start(inode, offset,
+						count, current->pid, path,
+						current->comm);
+	}
+	if (trace_android_fs_datawrite_start_enabled() &&
+	    (rw == WRITE)) {
+		char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+		path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    inode);
+		trace_android_fs_datawrite_start(inode, offset, count,
+						 current->pid, path,
+						 current->comm);
+	}
+	if (rw == WRITE && whint_mode == WHINT_MODE_OFF)
+		iocb->ki_hint = WRITE_LIFE_NOT_SET;
+
+	if (!down_read_trylock(&F2FS_I(inode)->i_gc_rwsem[rw])) {
+		if (iocb->ki_flags & IOCB_NOWAIT) {
+			iocb->ki_hint = hint;
+			err = -EAGAIN;
+			goto out;
+		}
+		down_read(&F2FS_I(inode)->i_gc_rwsem[rw]);
+	}
+
 	err = blockdev_direct_IO(iocb, inode, iter, get_data_block_dio);
-	up_read(&F2FS_I(inode)->dio_rwsem[rw]);
+	up_read(&F2FS_I(inode)->i_gc_rwsem[rw]);
 
 	if (rw == WRITE) {
-		if (err > 0)
+		if (whint_mode == WHINT_MODE_OFF)
+			iocb->ki_hint = hint;
+		if (err > 0) {
+			f2fs_update_iostat(F2FS_I_SB(inode), APP_DIRECT_IO,
+									err);
 			set_inode_flag(inode, FI_UPDATE_WRITE);
-		else if (err < 0)
+		} else if (err < 0) {
 			f2fs_write_failed(mapping, offset + count);
+		}
 	}
+out:
+	if (trace_android_fs_dataread_start_enabled() &&
+	    (rw == READ))
+		trace_android_fs_dataread_end(inode, offset, count);
+	if (trace_android_fs_datawrite_start_enabled() &&
+	    (rw == WRITE))
+		trace_android_fs_datawrite_end(inode, offset, count);
 
 	trace_f2fs_direct_IO_exit(inode, offset, count, rw, err);
 
@@ -1790,17 +2485,19 @@ void f2fs_invalidate_page(struct page *page, unsigned int offset,
 		return;
 
 	if (PageDirty(page)) {
-		if (inode->i_ino == F2FS_META_INO(sbi))
+		if (inode->i_ino == F2FS_META_INO(sbi)) {
 			dec_page_count(sbi, F2FS_DIRTY_META);
-		else if (inode->i_ino == F2FS_NODE_INO(sbi))
+		} else if (inode->i_ino == F2FS_NODE_INO(sbi)) {
 			dec_page_count(sbi, F2FS_DIRTY_NODES);
-		else
+		} else {
 			inode_dec_dirty_pages(inode);
+			f2fs_remove_dirty_inode(inode);
+		}
 	}
 
 	/* This is atomic written page, keep Private */
 	if (IS_ATOMIC_WRITTEN_PAGE(page))
-		return;
+		return f2fs_drop_inmem_page(inode, page);
 
 	set_page_private(page, 0);
 	ClearPagePrivate(page);
@@ -1821,35 +2518,6 @@ int f2fs_release_page(struct page *page, gfp_t wait)
 	return 1;
 }
 
-/*
- * This was copied from __set_page_dirty_buffers which gives higher performance
- * in very high speed storages. (e.g., pmem)
- */
-void f2fs_set_page_dirty_nobuffers(struct page *page)
-{
-	struct address_space *mapping = page->mapping;
-	unsigned long flags;
-
-	if (unlikely(!mapping))
-		return;
-
-	spin_lock(&mapping->private_lock);
-	lock_page_memcg(page);
-	SetPageDirty(page);
-	spin_unlock(&mapping->private_lock);
-
-	spin_lock_irqsave(&mapping->tree_lock, flags);
-	WARN_ON_ONCE(!PageUptodate(page));
-	account_page_dirtied(page, mapping);
-	radix_tree_tag_set(&mapping->page_tree,
-			page_index(page), PAGECACHE_TAG_DIRTY);
-	spin_unlock_irqrestore(&mapping->tree_lock, flags);
-	unlock_page_memcg(page);
-
-	__mark_inode_dirty(mapping->host, I_DIRTY_PAGES);
-	return;
-}
-
 static int f2fs_set_data_page_dirty(struct page *page)
 {
 	struct address_space *mapping = page->mapping;
@@ -1860,9 +2528,9 @@ static int f2fs_set_data_page_dirty(struct page *page)
 	if (!PageUptodate(page))
 		SetPageUptodate(page);
 
-	if (f2fs_is_atomic_file(inode)) {
+	if (f2fs_is_atomic_file(inode) && !f2fs_is_commit_atomic_write(inode)) {
 		if (!IS_ATOMIC_WRITTEN_PAGE(page)) {
-			register_inmem_page(inode, page);
+			f2fs_register_inmem_page(inode, page);
 			return 1;
 		}
 		/*
@@ -1873,8 +2541,8 @@ static int f2fs_set_data_page_dirty(struct page *page)
 	}
 
 	if (!PageDirty(page)) {
-		f2fs_set_page_dirty_nobuffers(page);
-		update_dirty_page(inode, page);
+		__set_page_dirty_nobuffers(page);
+		f2fs_update_dirty_page(inode, page);
 		return 1;
 	}
 	return 0;
@@ -1907,8 +2575,12 @@ int f2fs_migrate_page(struct address_space *mapping,
 	BUG_ON(PageWriteback(page));
 
 	/* migrating an atomic written page is safe with the inmem_lock hold */
-	if (atomic_written && !mutex_trylock(&fi->inmem_lock))
-		return -EAGAIN;
+	if (atomic_written) {
+		if (mode != MIGRATE_SYNC)
+			return -EBUSY;
+		if (!mutex_trylock(&fi->inmem_lock))
+			return -EAGAIN;
+	}
 
 	/*
 	 * A reference is expected if PagePrivate set when move mapping,
@@ -1962,3 +2634,38 @@ int f2fs_migrate_page(struct address_space *mapping,
 	.migratepage    = f2fs_migrate_page,
 #endif
 };
+
+void f2fs_clear_radix_tree_dirty_tag(struct page *page)
+{
+	struct address_space *mapping = page_mapping(page);
+	unsigned long flags;
+
+	spin_lock_irqsave(&mapping->tree_lock, flags);
+	radix_tree_tag_clear(&mapping->page_tree, page_index(page),
+					PAGECACHE_TAG_DIRTY);
+	spin_unlock_irqrestore(&mapping->tree_lock, flags);
+}
+
+int __init f2fs_init_post_read_processing(void)
+{
+	bio_post_read_ctx_cache = KMEM_CACHE(bio_post_read_ctx, 0);
+	if (!bio_post_read_ctx_cache)
+		goto fail;
+	bio_post_read_ctx_pool =
+		mempool_create_slab_pool(NUM_PREALLOC_POST_READ_CTXS,
+					 bio_post_read_ctx_cache);
+	if (!bio_post_read_ctx_pool)
+		goto fail_free_cache;
+	return 0;
+
+fail_free_cache:
+	kmem_cache_destroy(bio_post_read_ctx_cache);
+fail:
+	return -ENOMEM;
+}
+
+void __exit f2fs_destroy_post_read_processing(void)
+{
+	mempool_destroy(bio_post_read_ctx_pool);
+	kmem_cache_destroy(bio_post_read_ctx_cache);
+}
diff --git a/fs/f2fs/debug.c b/fs/f2fs/debug.c
index 687998e9..2d65e77 100644
--- a/fs/f2fs/debug.c
+++ b/fs/f2fs/debug.c
@@ -45,12 +45,36 @@ static void update_general_status(struct f2fs_sb_info *sbi)
 	si->ndirty_dent = get_pages(sbi, F2FS_DIRTY_DENTS);
 	si->ndirty_meta = get_pages(sbi, F2FS_DIRTY_META);
 	si->ndirty_data = get_pages(sbi, F2FS_DIRTY_DATA);
+	si->ndirty_qdata = get_pages(sbi, F2FS_DIRTY_QDATA);
 	si->ndirty_imeta = get_pages(sbi, F2FS_DIRTY_IMETA);
 	si->ndirty_dirs = sbi->ndirty_inode[DIR_INODE];
 	si->ndirty_files = sbi->ndirty_inode[FILE_INODE];
+	si->nquota_files = sbi->nquota_files;
 	si->ndirty_all = sbi->ndirty_inode[DIRTY_META];
 	si->inmem_pages = get_pages(sbi, F2FS_INMEM_PAGES);
-	si->wb_bios = atomic_read(&sbi->nr_wb_bios);
+	si->aw_cnt = atomic_read(&sbi->aw_cnt);
+	si->vw_cnt = atomic_read(&sbi->vw_cnt);
+	si->max_aw_cnt = atomic_read(&sbi->max_aw_cnt);
+	si->max_vw_cnt = atomic_read(&sbi->max_vw_cnt);
+	si->nr_wb_cp_data = get_pages(sbi, F2FS_WB_CP_DATA);
+	si->nr_wb_data = get_pages(sbi, F2FS_WB_DATA);
+	if (SM_I(sbi) && SM_I(sbi)->fcc_info) {
+		si->nr_flushed =
+			atomic_read(&SM_I(sbi)->fcc_info->issued_flush);
+		si->nr_flushing =
+			atomic_read(&SM_I(sbi)->fcc_info->issing_flush);
+		si->flush_list_empty =
+			llist_empty(&SM_I(sbi)->fcc_info->issue_list);
+	}
+	if (SM_I(sbi) && SM_I(sbi)->dcc_info) {
+		si->nr_discarded =
+			atomic_read(&SM_I(sbi)->dcc_info->issued_discard);
+		si->nr_discarding =
+			atomic_read(&SM_I(sbi)->dcc_info->issing_discard);
+		si->nr_discard_cmd =
+			atomic_read(&SM_I(sbi)->dcc_info->discard_cmd_cnt);
+		si->undiscard_blks = SM_I(sbi)->dcc_info->undiscard_blks;
+	}
 	si->total_count = (int)sbi->user_block_count / sbi->blocks_per_seg;
 	si->rsvd_segs = reserved_segments(sbi);
 	si->overp_segs = overprovision_segments(sbi);
@@ -61,6 +85,8 @@ static void update_general_status(struct f2fs_sb_info *sbi)
 	si->inline_xattr = atomic_read(&sbi->inline_xattr);
 	si->inline_inode = atomic_read(&sbi->inline_inode);
 	si->inline_dir = atomic_read(&sbi->inline_dir);
+	si->append = sbi->im[APPEND_INO].ino_num;
+	si->update = sbi->im[UPDATE_INO].ino_num;
 	si->orphans = sbi->im[ORPHAN_INO].ino_num;
 	si->utilization = utilization(sbi);
 
@@ -74,8 +100,12 @@ static void update_general_status(struct f2fs_sb_info *sbi)
 	si->dirty_nats = NM_I(sbi)->dirty_nat_cnt;
 	si->sits = MAIN_SEGS(sbi);
 	si->dirty_sits = SIT_I(sbi)->dirty_sentries;
-	si->fnids = NM_I(sbi)->fcnt;
+	si->free_nids = NM_I(sbi)->nid_cnt[FREE_NID];
+	si->avail_nids = NM_I(sbi)->available_nids;
+	si->alloc_nids = NM_I(sbi)->nid_cnt[PREALLOC_NID];
 	si->bg_gc = sbi->bg_gc;
+	si->skipped_atomic_files[BG_GC] = sbi->skipped_atomic_files[BG_GC];
+	si->skipped_atomic_files[FG_GC] = sbi->skipped_atomic_files[FG_GC];
 	si->util_free = (int)(free_user_blocks(sbi) >> sbi->log_blocks_per_seg)
 		* 100 / (int)(sbi->user_block_count >> sbi->log_blocks_per_seg)
 		/ 2;
@@ -87,8 +117,8 @@ static void update_general_status(struct f2fs_sb_info *sbi)
 	for (i = CURSEG_HOT_DATA; i <= CURSEG_COLD_NODE; i++) {
 		struct curseg_info *curseg = CURSEG_I(sbi, i);
 		si->curseg[i] = curseg->segno;
-		si->cursec[i] = curseg->segno / sbi->segs_per_sec;
-		si->curzone[i] = si->cursec[i] / sbi->secs_per_zone;
+		si->cursec[i] = GET_SEC_FROM_SEG(sbi, curseg->segno);
+		si->curzone[i] = GET_ZONE_FROM_SEC(sbi, si->cursec[i]);
 	}
 
 	for (i = 0; i < 2; i++) {
@@ -112,10 +142,10 @@ static void update_sit_info(struct f2fs_sb_info *sbi)
 
 	bimodal = 0;
 	total_vblocks = 0;
-	blks_per_sec = sbi->segs_per_sec * sbi->blocks_per_seg;
+	blks_per_sec = BLKS_PER_SEC(sbi);
 	hblks_per_sec = blks_per_sec / 2;
 	for (segno = 0; segno < MAIN_SEGS(sbi); segno += sbi->segs_per_sec) {
-		vblocks = get_valid_blocks(sbi, segno, sbi->segs_per_sec);
+		vblocks = get_valid_blocks(sbi, segno, true);
 		dist = abs(vblocks - hblks_per_sec);
 		bimodal += dist * dist;
 
@@ -144,10 +174,13 @@ static void update_mem_info(struct f2fs_sb_info *sbi)
 	if (si->base_mem)
 		goto get_cache;
 
-	si->base_mem = sizeof(struct f2fs_sb_info) + sbi->sb->s_blocksize;
+	/* build stat */
+	si->base_mem = sizeof(struct f2fs_stat_info);
+
+	/* build superblock */
+	si->base_mem += sizeof(struct f2fs_sb_info) + sbi->sb->s_blocksize;
 	si->base_mem += 2 * sizeof(struct f2fs_inode_info);
 	si->base_mem += sizeof(*sbi->ckpt);
-	si->base_mem += sizeof(struct percpu_counter) * NR_COUNT_TYPE;
 
 	/* build sm */
 	si->base_mem += sizeof(struct f2fs_sm_info);
@@ -181,6 +214,10 @@ static void update_mem_info(struct f2fs_sb_info *sbi)
 	/* build nm */
 	si->base_mem += sizeof(struct f2fs_nm_info);
 	si->base_mem += __bitmap_size(sbi, NAT_BITMAP);
+	si->base_mem += (NM_I(sbi)->nat_bits_blocks << F2FS_BLKSIZE_BITS);
+	si->base_mem += NM_I(sbi)->nat_blocks * NAT_ENTRY_BITMAP_SIZE;
+	si->base_mem += NM_I(sbi)->nat_blocks / 8;
+	si->base_mem += NM_I(sbi)->nat_blocks * sizeof(unsigned short);
 
 get_cache:
 	si->cache_mem = 0;
@@ -190,16 +227,23 @@ static void update_mem_info(struct f2fs_sb_info *sbi)
 		si->cache_mem += sizeof(struct f2fs_gc_kthread);
 
 	/* build merge flush thread */
-	if (SM_I(sbi)->cmd_control_info)
+	if (SM_I(sbi)->fcc_info)
 		si->cache_mem += sizeof(struct flush_cmd_control);
+	if (SM_I(sbi)->dcc_info) {
+		si->cache_mem += sizeof(struct discard_cmd_control);
+		si->cache_mem += sizeof(struct discard_cmd) *
+			atomic_read(&SM_I(sbi)->dcc_info->discard_cmd_cnt);
+	}
 
 	/* free nids */
-	si->cache_mem += NM_I(sbi)->fcnt * sizeof(struct free_nid);
+	si->cache_mem += (NM_I(sbi)->nid_cnt[FREE_NID] +
+				NM_I(sbi)->nid_cnt[PREALLOC_NID]) *
+				sizeof(struct free_nid);
 	si->cache_mem += NM_I(sbi)->nat_cnt * sizeof(struct nat_entry);
 	si->cache_mem += NM_I(sbi)->dirty_nat_cnt *
 					sizeof(struct nat_entry_set);
 	si->cache_mem += si->inmem_pages * sizeof(struct inmem_pages);
-	for (i = 0; i <= ORPHAN_INO; i++)
+	for (i = 0; i < MAX_INO_ENTRY; i++)
 		si->cache_mem += sbi->im[i].ino_num * sizeof(struct ino_entry);
 	si->cache_mem += atomic_read(&sbi->total_ext_tree) *
 						sizeof(struct extent_tree);
@@ -223,9 +267,10 @@ static int stat_show(struct seq_file *s, void *v)
 	list_for_each_entry(si, &f2fs_stat_list, stat_list) {
 		update_general_status(si->sbi);
 
-		seq_printf(s, "\n=====[ partition info(%pg). #%d, %s]=====\n",
+		seq_printf(s, "\n=====[ partition info(%pg). #%d, %s, CP: %s]=====\n",
 			si->sbi->sb->s_bdev, i++,
-			f2fs_readonly(si->sbi->sb) ? "RO": "RW");
+			f2fs_readonly(si->sbi->sb) ? "RO": "RW",
+			f2fs_cp_error(si->sbi) ? "Error": "Good");
 		seq_printf(s, "[SB: 1] [CP: 2] [SIT: %d] [NAT: %d] ",
 			   si->sit_area_segs, si->nat_area_segs);
 		seq_printf(s, "[SSA: %d] [MAIN: %d",
@@ -250,8 +295,8 @@ static int stat_show(struct seq_file *s, void *v)
 			   si->inline_inode);
 		seq_printf(s, "  - Inline_dentry Inode: %u\n",
 			   si->inline_dir);
-		seq_printf(s, "  - Orphan Inode: %u\n",
-			   si->orphans);
+		seq_printf(s, "  - Orphan/Append/Update Inode: %u, %u, %u\n",
+			   si->orphans, si->append, si->update);
 		seq_printf(s, "\nMain area: %d segs, %d secs %d zones\n",
 			   si->main_area_segs, si->main_area_sections,
 			   si->main_area_zones);
@@ -299,6 +344,10 @@ static int stat_show(struct seq_file *s, void *v)
 				si->bg_data_blks);
 		seq_printf(s, "  - node blocks : %d (%d)\n", si->node_blks,
 				si->bg_node_blks);
+		seq_printf(s, "Skipped : atomic write %llu (%llu)\n",
+				si->skipped_atomic_files[BG_GC] +
+				si->skipped_atomic_files[FG_GC],
+				si->skipped_atomic_files[BG_GC]);
 		seq_puts(s, "\nExtent Cache:\n");
 		seq_printf(s, "  - Hit Count: L1-1:%llu L1-2:%llu L2:%llu\n",
 				si->hit_largest, si->hit_cached,
@@ -310,22 +359,33 @@ static int stat_show(struct seq_file *s, void *v)
 		seq_printf(s, "  - Inner Struct Count: tree: %d(%d), node: %d\n",
 				si->ext_tree, si->zombie_tree, si->ext_node);
 		seq_puts(s, "\nBalancing F2FS Async:\n");
-		seq_printf(s, "  - inmem: %4d, wb_bios: %4d\n",
-			   si->inmem_pages, si->wb_bios);
+		seq_printf(s, "  - IO (CP: %4d, Data: %4d, Flush: (%4d %4d %4d), "
+			"Discard: (%4d %4d)) cmd: %4d undiscard:%4u\n",
+			   si->nr_wb_cp_data, si->nr_wb_data,
+			   si->nr_flushing, si->nr_flushed,
+			   si->flush_list_empty,
+			   si->nr_discarding, si->nr_discarded,
+			   si->nr_discard_cmd, si->undiscard_blks);
+		seq_printf(s, "  - inmem: %4d, atomic IO: %4d (Max. %4d), "
+			"volatile IO: %4d (Max. %4d)\n",
+			   si->inmem_pages, si->aw_cnt, si->max_aw_cnt,
+			   si->vw_cnt, si->max_vw_cnt);
 		seq_printf(s, "  - nodes: %4d in %4d\n",
 			   si->ndirty_node, si->node_pages);
 		seq_printf(s, "  - dents: %4d in dirs:%4d (%4d)\n",
 			   si->ndirty_dent, si->ndirty_dirs, si->ndirty_all);
 		seq_printf(s, "  - datas: %4d in files:%4d\n",
 			   si->ndirty_data, si->ndirty_files);
+		seq_printf(s, "  - quota datas: %4d in quota files:%4d\n",
+			   si->ndirty_qdata, si->nquota_files);
 		seq_printf(s, "  - meta: %4d in %4d\n",
 			   si->ndirty_meta, si->meta_pages);
 		seq_printf(s, "  - imeta: %4d\n",
 			   si->ndirty_imeta);
 		seq_printf(s, "  - NATs: %9d/%9d\n  - SITs: %9d/%9d\n",
 			   si->dirty_nats, si->nats, si->dirty_sits, si->sits);
-		seq_printf(s, "  - free_nids: %9d\n",
-			   si->fnids);
+		seq_printf(s, "  - free_nids: %9d/%9d\n  - alloc_nids: %9d\n",
+			   si->free_nids, si->avail_nids, si->alloc_nids);
 		seq_puts(s, "\nDistribution of User Blocks:");
 		seq_puts(s, " [ valid | invalid | free ]\n");
 		seq_puts(s, "  [");
@@ -385,7 +445,7 @@ int f2fs_build_stats(struct f2fs_sb_info *sbi)
 	struct f2fs_super_block *raw_super = F2FS_RAW_SUPER(sbi);
 	struct f2fs_stat_info *si;
 
-	si = kzalloc(sizeof(struct f2fs_stat_info), GFP_KERNEL);
+	si = f2fs_kzalloc(sbi, sizeof(struct f2fs_stat_info), GFP_KERNEL);
 	if (!si)
 		return -ENOMEM;
 
@@ -410,6 +470,11 @@ int f2fs_build_stats(struct f2fs_sb_info *sbi)
 	atomic_set(&sbi->inline_dir, 0);
 	atomic_set(&sbi->inplace_count, 0);
 
+	atomic_set(&sbi->aw_cnt, 0);
+	atomic_set(&sbi->vw_cnt, 0);
+	atomic_set(&sbi->max_aw_cnt, 0);
+	atomic_set(&sbi->max_vw_cnt, 0);
+
 	mutex_lock(&f2fs_stat_mutex);
 	list_add_tail(&si->stat_list, &f2fs_stat_list);
 	mutex_unlock(&f2fs_stat_mutex);
diff --git a/fs/f2fs/dir.c b/fs/f2fs/dir.c
index 8add4e8..63c0732 100644
--- a/fs/f2fs/dir.c
+++ b/fs/f2fs/dir.c
@@ -10,10 +10,12 @@
  */
 #include <linux/fs.h>
 #include <linux/f2fs_fs.h>
+#include <linux/sched.h>
 #include "f2fs.h"
 #include "node.h"
 #include "acl.h"
 #include "xattr.h"
+#include <trace/events/f2fs.h>
 
 static unsigned long dir_blocks(struct inode *inode)
 {
@@ -58,12 +60,12 @@ static unsigned int bucket_blocks(unsigned int level)
 	[S_IFLNK >> S_SHIFT]	= F2FS_FT_SYMLINK,
 };
 
-void set_de_type(struct f2fs_dir_entry *de, umode_t mode)
+static void set_de_type(struct f2fs_dir_entry *de, umode_t mode)
 {
 	de->file_type = f2fs_type_by_mode[(mode & S_IFMT) >> S_SHIFT];
 }
 
-unsigned char get_de_type(struct f2fs_dir_entry *de)
+unsigned char f2fs_get_de_type(struct f2fs_dir_entry *de)
 {
 	if (de->file_type < F2FS_FT_MAX)
 		return f2fs_filetype_table[de->file_type];
@@ -92,27 +94,23 @@ static struct f2fs_dir_entry *find_in_block(struct page *dentry_page,
 	struct f2fs_dir_entry *de;
 	struct f2fs_dentry_ptr d;
 
-	dentry_blk = (struct f2fs_dentry_block *)kmap(dentry_page);
+	dentry_blk = (struct f2fs_dentry_block *)page_address(dentry_page);
 
-	make_dentry_ptr(NULL, &d, (void *)dentry_blk, 1);
-	de = find_target_dentry(fname, namehash, max_slots, &d);
+	make_dentry_ptr_block(NULL, &d, dentry_blk);
+	de = f2fs_find_target_dentry(fname, namehash, max_slots, &d);
 	if (de)
 		*res_page = dentry_page;
-	else
-		kunmap(dentry_page);
 
 	return de;
 }
 
-struct f2fs_dir_entry *find_target_dentry(struct fscrypt_name *fname,
+struct f2fs_dir_entry *f2fs_find_target_dentry(struct fscrypt_name *fname,
 			f2fs_hash_t namehash, int *max_slots,
 			struct f2fs_dentry_ptr *d)
 {
 	struct f2fs_dir_entry *de;
 	unsigned long bit_pos = 0;
 	int max_len = 0;
-	struct fscrypt_str de_name = FSTR_INIT(NULL, 0);
-	struct fscrypt_str *name = &fname->disk_name;
 
 	if (max_slots)
 		*max_slots = 0;
@@ -130,29 +128,11 @@ struct f2fs_dir_entry *find_target_dentry(struct fscrypt_name *fname,
 			continue;
 		}
 
-		if (de->hash_code != namehash)
-			goto not_match;
-
-		de_name.name = d->filename[bit_pos];
-		de_name.len = le16_to_cpu(de->name_len);
-
-#ifdef CONFIG_F2FS_FS_ENCRYPTION
-		if (unlikely(!name->name)) {
-			if (fname->usr_fname->name[0] == '_') {
-				if (de_name.len > 32 &&
-					!memcmp(de_name.name + ((de_name.len - 17) & ~15),
-						fname->crypto_buf.name + 8, 16))
-					goto found;
-				goto not_match;
-			}
-			name->name = fname->crypto_buf.name;
-			name->len = fname->crypto_buf.len;
-		}
-#endif
-		if (de_name.len == name->len &&
-				!memcmp(de_name.name, name->name, name->len))
+		if (de->hash_code == namehash &&
+		    fscrypt_match_name(fname, d->filename[bit_pos],
+				       le16_to_cpu(de->name_len)))
 			goto found;
-not_match:
+
 		if (max_slots && max_len > *max_slots)
 			*max_slots = max_len;
 		max_len = 0;
@@ -191,7 +171,7 @@ static struct f2fs_dir_entry *find_in_level(struct inode *dir,
 
 	for (; bidx < end_block; bidx++) {
 		/* no need to allocate new dentry pages to all the indices */
-		dentry_page = find_data_page(dir, bidx);
+		dentry_page = f2fs_find_data_page(dir, bidx);
 		if (IS_ERR(dentry_page)) {
 			if (PTR_ERR(dentry_page) == -ENOENT) {
 				room = true;
@@ -212,13 +192,9 @@ static struct f2fs_dir_entry *find_in_level(struct inode *dir,
 		f2fs_put_page(dentry_page, 0);
 	}
 
-	/* This is to increase the speed of f2fs_create */
-	if (!de && room) {
-		F2FS_I(dir)->task = current;
-		if (F2FS_I(dir)->chash != namehash) {
-			F2FS_I(dir)->chash = namehash;
-			F2FS_I(dir)->clevel = level;
-		}
+	if (!de && room && F2FS_I(dir)->chash != namehash) {
+		F2FS_I(dir)->chash = namehash;
+		F2FS_I(dir)->clevel = level;
 	}
 
 	return de;
@@ -234,7 +210,7 @@ struct f2fs_dir_entry *__f2fs_find_entry(struct inode *dir,
 
 	if (f2fs_has_inline_dentry(dir)) {
 		*res_page = NULL;
-		de = find_in_inline_dir(dir, fname, res_page);
+		de = f2fs_find_in_inline_dir(dir, fname, res_page);
 		goto out;
 	}
 
@@ -259,6 +235,9 @@ struct f2fs_dir_entry *__f2fs_find_entry(struct inode *dir,
 			break;
 	}
 out:
+	/* This is to increase the speed of f2fs_create */
+	if (!de)
+		F2FS_I(dir)->task = current;
 	return de;
 }
 
@@ -306,7 +285,6 @@ ino_t f2fs_inode_by_name(struct inode *dir, const struct qstr *qstr,
 	de = f2fs_find_entry(dir, qstr, page);
 	if (de) {
 		res = le32_to_cpu(de->ino);
-		f2fs_dentry_kunmap(dir, *page);
 		f2fs_put_page(*page, 0);
 	}
 
@@ -321,11 +299,10 @@ void f2fs_set_link(struct inode *dir, struct f2fs_dir_entry *de,
 	f2fs_wait_on_page_writeback(page, type, true);
 	de->ino = cpu_to_le32(inode->i_ino);
 	set_de_type(de, inode->i_mode);
-	f2fs_dentry_kunmap(dir, page);
 	set_page_dirty(page);
 
 	dir->i_mtime = dir->i_ctime = current_time(dir);
-	f2fs_mark_inode_dirty_sync(dir);
+	f2fs_mark_inode_dirty_sync(dir, false);
 	f2fs_put_page(page, 1);
 }
 
@@ -342,25 +319,7 @@ static void init_dent_inode(const struct qstr *name, struct page *ipage)
 	set_page_dirty(ipage);
 }
 
-int update_dent_inode(struct inode *inode, struct inode *to,
-					const struct qstr *name)
-{
-	struct page *page;
-
-	if (file_enc_name(to))
-		return 0;
-
-	page = get_node_page(F2FS_I_SB(inode), inode->i_ino);
-	if (IS_ERR(page))
-		return PTR_ERR(page);
-
-	init_dent_inode(name, page);
-	f2fs_put_page(page, 1);
-
-	return 0;
-}
-
-void do_make_empty_dir(struct inode *inode, struct inode *parent,
+void f2fs_do_make_empty_dir(struct inode *inode, struct inode *parent,
 					struct f2fs_dentry_ptr *d)
 {
 	struct qstr dot = QSTR_INIT(".", 1);
@@ -381,33 +340,32 @@ static int make_empty_dir(struct inode *inode,
 	struct f2fs_dentry_ptr d;
 
 	if (f2fs_has_inline_dentry(inode))
-		return make_empty_inline_dir(inode, parent, page);
+		return f2fs_make_empty_inline_dir(inode, parent, page);
 
-	dentry_page = get_new_data_page(inode, page, 0, true);
+	dentry_page = f2fs_get_new_data_page(inode, page, 0, true);
 	if (IS_ERR(dentry_page))
 		return PTR_ERR(dentry_page);
 
-	dentry_blk = kmap_atomic(dentry_page);
-
-	make_dentry_ptr(NULL, &d, (void *)dentry_blk, 1);
-	do_make_empty_dir(inode, parent, &d);
+	dentry_blk = page_address(dentry_page);
 
-	kunmap_atomic(dentry_blk);
+	make_dentry_ptr_block(NULL, &d, dentry_blk);
+	f2fs_do_make_empty_dir(inode, parent, &d);
 
 	set_page_dirty(dentry_page);
 	f2fs_put_page(dentry_page, 1);
 	return 0;
 }
 
-struct page *init_inode_metadata(struct inode *inode, struct inode *dir,
+struct page *f2fs_init_inode_metadata(struct inode *inode, struct inode *dir,
 			const struct qstr *new_name, const struct qstr *orig_name,
 			struct page *dpage)
 {
 	struct page *page;
+	int dummy_encrypt = DUMMY_ENCRYPTION_ENABLED(F2FS_I_SB(dir));
 	int err;
 
 	if (is_inode_flag_set(inode, FI_NEW_INODE)) {
-		page = new_inode_page(inode);
+		page = f2fs_new_inode_page(inode);
 		if (IS_ERR(page))
 			return page;
 
@@ -430,46 +388,49 @@ struct page *init_inode_metadata(struct inode *inode, struct inode *dir,
 		if (err)
 			goto put_error;
 
-		if (f2fs_encrypted_inode(dir) && f2fs_may_encrypt(inode)) {
+		if ((f2fs_encrypted_inode(dir) || dummy_encrypt) &&
+					f2fs_may_encrypt(inode)) {
 			err = fscrypt_inherit_context(dir, inode, page, false);
 			if (err)
 				goto put_error;
 		}
 	} else {
-		page = get_node_page(F2FS_I_SB(dir), inode->i_ino);
+		page = f2fs_get_node_page(F2FS_I_SB(dir), inode->i_ino);
 		if (IS_ERR(page))
 			return page;
-
-		set_cold_node(inode, page);
 	}
 
-	if (new_name)
+	if (new_name) {
 		init_dent_inode(new_name, page);
+		if (f2fs_encrypted_inode(dir))
+			file_set_enc_name(inode);
+	}
 
 	/*
 	 * This file should be checkpointed during fsync.
 	 * We lost i_pino from now on.
 	 */
 	if (is_inode_flag_set(inode, FI_INC_LINK)) {
-		file_lost_pino(inode);
+		if (!S_ISDIR(inode->i_mode))
+			file_lost_pino(inode);
 		/*
 		 * If link the tmpfile to alias through linkat path,
 		 * we should remove this inode from orphan list.
 		 */
 		if (inode->i_nlink == 0)
-			remove_orphan_inode(F2FS_I_SB(dir), inode->i_ino);
+			f2fs_remove_orphan_inode(F2FS_I_SB(dir), inode->i_ino);
 		f2fs_i_links_write(inode, true);
 	}
 	return page;
 
 put_error:
 	clear_nlink(inode);
-	update_inode(inode, page);
+	f2fs_update_inode(inode, page);
 	f2fs_put_page(page, 1);
 	return ERR_PTR(err);
 }
 
-void update_parent_metadata(struct inode *dir, struct inode *inode,
+void f2fs_update_parent_metadata(struct inode *dir, struct inode *inode,
 						unsigned int current_depth)
 {
 	if (inode && is_inode_flag_set(inode, FI_NEW_INODE)) {
@@ -478,7 +439,7 @@ void update_parent_metadata(struct inode *dir, struct inode *inode,
 		clear_inode_flag(inode, FI_NEW_INODE);
 	}
 	dir->i_mtime = dir->i_ctime = current_time(dir);
-	f2fs_mark_inode_dirty_sync(dir);
+	f2fs_mark_inode_dirty_sync(dir, false);
 
 	if (F2FS_I(dir)->i_current_depth != current_depth)
 		f2fs_i_depth_write(dir, current_depth);
@@ -487,7 +448,7 @@ void update_parent_metadata(struct inode *dir, struct inode *inode,
 		clear_inode_flag(inode, FI_INC_LINK);
 }
 
-int room_for_filename(const void *bitmap, int slots, int max_slots)
+int f2fs_room_for_filename(const void *bitmap, int slots, int max_slots)
 {
 	int bit_start = 0;
 	int zero_start, zero_end;
@@ -557,8 +518,10 @@ int f2fs_add_regular_entry(struct inode *dir, const struct qstr *new_name,
 
 start:
 #ifdef CONFIG_F2FS_FAULT_INJECTION
-	if (time_to_inject(F2FS_I_SB(dir), FAULT_DIR_DEPTH))
+	if (time_to_inject(F2FS_I_SB(dir), FAULT_DIR_DEPTH)) {
+		f2fs_show_injection_info(FAULT_DIR_DEPTH);
 		return -ENOSPC;
+	}
 #endif
 	if (unlikely(current_depth == MAX_DIR_HASH_DEPTH))
 		return -ENOSPC;
@@ -574,17 +537,16 @@ int f2fs_add_regular_entry(struct inode *dir, const struct qstr *new_name,
 				(le32_to_cpu(dentry_hash) % nbucket));
 
 	for (block = bidx; block <= (bidx + nblock - 1); block++) {
-		dentry_page = get_new_data_page(dir, NULL, block, true);
+		dentry_page = f2fs_get_new_data_page(dir, NULL, block, true);
 		if (IS_ERR(dentry_page))
 			return PTR_ERR(dentry_page);
 
-		dentry_blk = kmap(dentry_page);
-		bit_pos = room_for_filename(&dentry_blk->dentry_bitmap,
+		dentry_blk = page_address(dentry_page);
+		bit_pos = f2fs_room_for_filename(&dentry_blk->dentry_bitmap,
 						slots, NR_DENTRY_IN_BLOCK);
 		if (bit_pos < NR_DENTRY_IN_BLOCK)
 			goto add_dentry;
 
-		kunmap(dentry_page);
 		f2fs_put_page(dentry_page, 1);
 	}
 
@@ -596,17 +558,15 @@ int f2fs_add_regular_entry(struct inode *dir, const struct qstr *new_name,
 
 	if (inode) {
 		down_write(&F2FS_I(inode)->i_sem);
-		page = init_inode_metadata(inode, dir, new_name,
+		page = f2fs_init_inode_metadata(inode, dir, new_name,
 						orig_name, NULL);
 		if (IS_ERR(page)) {
 			err = PTR_ERR(page);
 			goto fail;
 		}
-		if (f2fs_encrypted_inode(dir))
-			file_set_enc_name(inode);
 	}
 
-	make_dentry_ptr(NULL, &d, (void *)dentry_blk, 1);
+	make_dentry_ptr_block(NULL, &d, dentry_blk);
 	f2fs_update_dentry(ino, mode, &d, new_name, dentry_hash, bit_pos);
 
 	set_page_dirty(dentry_page);
@@ -616,18 +576,17 @@ int f2fs_add_regular_entry(struct inode *dir, const struct qstr *new_name,
 		f2fs_put_page(page, 1);
 	}
 
-	update_parent_metadata(dir, inode, current_depth);
+	f2fs_update_parent_metadata(dir, inode, current_depth);
 fail:
 	if (inode)
 		up_write(&F2FS_I(inode)->i_sem);
 
-	kunmap(dentry_page);
 	f2fs_put_page(dentry_page, 1);
 
 	return err;
 }
 
-int __f2fs_do_add_link(struct inode *dir, struct fscrypt_name *fname,
+int f2fs_add_dentry(struct inode *dir, struct fscrypt_name *fname,
 				struct inode *inode, nid_t ino, umode_t mode)
 {
 	struct qstr new_name;
@@ -651,7 +610,7 @@ int __f2fs_do_add_link(struct inode *dir, struct fscrypt_name *fname,
  * Caller should grab and release a rwsem by calling f2fs_lock_op() and
  * f2fs_unlock_op().
  */
-int __f2fs_add_link(struct inode *dir, const struct qstr *name,
+int f2fs_do_add_link(struct inode *dir, const struct qstr *name,
 				struct inode *inode, nid_t ino, umode_t mode)
 {
 	struct fscrypt_name fname;
@@ -675,13 +634,12 @@ int __f2fs_add_link(struct inode *dir, const struct qstr *name,
 		F2FS_I(dir)->task = NULL;
 	}
 	if (de) {
-		f2fs_dentry_kunmap(dir, page);
 		f2fs_put_page(page, 0);
 		err = -EEXIST;
 	} else if (IS_ERR(page)) {
 		err = PTR_ERR(page);
 	} else {
-		err = __f2fs_do_add_link(dir, &fname, inode, ino, mode);
+		err = f2fs_add_dentry(dir, &fname, inode, ino, mode);
 	}
 	fscrypt_free_filename(&fname);
 	return err;
@@ -693,7 +651,7 @@ int f2fs_do_tmpfile(struct inode *inode, struct inode *dir)
 	int err = 0;
 
 	down_write(&F2FS_I(inode)->i_sem);
-	page = init_inode_metadata(inode, dir, NULL, NULL, NULL);
+	page = f2fs_init_inode_metadata(inode, dir, NULL, NULL, NULL);
 	if (IS_ERR(page)) {
 		err = PTR_ERR(page);
 		goto fail;
@@ -725,9 +683,9 @@ void f2fs_drop_nlink(struct inode *dir, struct inode *inode)
 	up_write(&F2FS_I(inode)->i_sem);
 
 	if (inode->i_nlink == 0)
-		add_orphan_inode(inode);
+		f2fs_add_orphan_inode(inode);
 	else
-		release_orphan_inode(sbi);
+		f2fs_release_orphan_inode(sbi);
 }
 
 /*
@@ -744,6 +702,9 @@ void f2fs_delete_entry(struct f2fs_dir_entry *dentry, struct page *page,
 
 	f2fs_update_time(F2FS_I_SB(dir), REQ_TIME);
 
+	if (F2FS_OPTION(F2FS_I_SB(dir)).fsync_mode == FSYNC_MODE_STRICT)
+		f2fs_add_ino_entry(F2FS_I_SB(dir), dir->i_ino, TRANS_DIR_INO);
+
 	if (f2fs_has_inline_dentry(dir))
 		return f2fs_delete_inline_entry(dentry, page, dir, inode);
 
@@ -753,27 +714,28 @@ void f2fs_delete_entry(struct f2fs_dir_entry *dentry, struct page *page,
 	dentry_blk = page_address(page);
 	bit_pos = dentry - dentry_blk->dentry;
 	for (i = 0; i < slots; i++)
-		clear_bit_le(bit_pos + i, &dentry_blk->dentry_bitmap);
+		__clear_bit_le(bit_pos + i, &dentry_blk->dentry_bitmap);
 
 	/* Let's check and deallocate this dentry page */
 	bit_pos = find_next_bit_le(&dentry_blk->dentry_bitmap,
 			NR_DENTRY_IN_BLOCK,
 			0);
-	kunmap(page); /* kunmap - pair of f2fs_find_entry */
 	set_page_dirty(page);
 
 	dir->i_ctime = dir->i_mtime = current_time(dir);
-	f2fs_mark_inode_dirty_sync(dir);
+	f2fs_mark_inode_dirty_sync(dir, false);
 
 	if (inode)
 		f2fs_drop_nlink(dir, inode);
 
 	if (bit_pos == NR_DENTRY_IN_BLOCK &&
-			!truncate_hole(dir, page->index, page->index + 1)) {
+		!f2fs_truncate_hole(dir, page->index, page->index + 1)) {
+		f2fs_clear_radix_tree_dirty_tag(page);
 		clear_page_dirty_for_io(page);
 		ClearPagePrivate(page);
 		ClearPageUptodate(page);
 		inode_dec_dirty_pages(dir);
+		f2fs_remove_dirty_inode(dir);
 	}
 	f2fs_put_page(page, 1);
 }
@@ -790,7 +752,7 @@ bool f2fs_empty_dir(struct inode *dir)
 		return f2fs_empty_inline_dir(dir);
 
 	for (bidx = 0; bidx < nblock; bidx++) {
-		dentry_page = get_lock_data_page(dir, bidx, false);
+		dentry_page = f2fs_get_lock_data_page(dir, bidx, false);
 		if (IS_ERR(dentry_page)) {
 			if (PTR_ERR(dentry_page) == -ENOENT)
 				continue;
@@ -798,7 +760,7 @@ bool f2fs_empty_dir(struct inode *dir)
 				return false;
 		}
 
-		dentry_blk = kmap_atomic(dentry_page);
+		dentry_blk = page_address(dentry_page);
 		if (bidx == 0)
 			bit_pos = 2;
 		else
@@ -806,7 +768,6 @@ bool f2fs_empty_dir(struct inode *dir)
 		bit_pos = find_next_bit_le(&dentry_blk->dentry_bitmap,
 						NR_DENTRY_IN_BLOCK,
 						bit_pos);
-		kunmap_atomic(dentry_blk);
 
 		f2fs_put_page(dentry_page, 1);
 
@@ -816,13 +777,14 @@ bool f2fs_empty_dir(struct inode *dir)
 	return true;
 }
 
-bool f2fs_fill_dentries(struct dir_context *ctx, struct f2fs_dentry_ptr *d,
+int f2fs_fill_dentries(struct dir_context *ctx, struct f2fs_dentry_ptr *d,
 			unsigned int start_pos, struct fscrypt_str *fstr)
 {
 	unsigned char d_type = DT_UNKNOWN;
 	unsigned int bit_pos;
 	struct f2fs_dir_entry *de = NULL;
 	struct fscrypt_str de_name = FSTR_INIT(NULL, 0);
+	struct f2fs_sb_info *sbi = F2FS_I_SB(d->inode);
 
 	bit_pos = ((unsigned long)ctx->pos % d->max);
 
@@ -838,7 +800,7 @@ bool f2fs_fill_dentries(struct dir_context *ctx, struct f2fs_dentry_ptr *d,
 			continue;
 		}
 
-		d_type = get_de_type(de);
+		d_type = f2fs_get_de_type(de);
 
 		de_name.name = d->filename[bit_pos];
 		de_name.len = le16_to_cpu(de->name_len);
@@ -851,7 +813,7 @@ bool f2fs_fill_dentries(struct dir_context *ctx, struct f2fs_dentry_ptr *d,
 						(u32)de->hash_code, 0,
 						&de_name, fstr);
 			if (err)
-				return true;
+				return err;
 
 			de_name = *fstr;
 			fstr->len = save_len;
@@ -859,12 +821,15 @@ bool f2fs_fill_dentries(struct dir_context *ctx, struct f2fs_dentry_ptr *d,
 
 		if (!dir_emit(ctx, de_name.name, de_name.len,
 					le32_to_cpu(de->ino), d_type))
-			return true;
+			return 1;
+
+		if (sbi->readdir_ra == 1)
+			f2fs_ra_node_page(sbi, le32_to_cpu(de->ino));
 
 		bit_pos += GET_DENTRY_SLOTS(le16_to_cpu(de->name_len));
 		ctx->pos = start_pos + bit_pos;
 	}
-	return false;
+	return 0;
 }
 
 static int f2fs_readdir(struct file *file, struct dir_context *ctx)
@@ -874,6 +839,7 @@ static int f2fs_readdir(struct file *file, struct dir_context *ctx)
 	struct f2fs_dentry_block *dentry_blk = NULL;
 	struct page *dentry_page = NULL;
 	struct file_ra_state *ra = &file->f_ra;
+	loff_t start_pos = ctx->pos;
 	unsigned int n = ((unsigned long)ctx->pos / NR_DENTRY_IN_BLOCK);
 	struct f2fs_dentry_ptr d;
 	struct fscrypt_str fstr = FSTR_INIT(NULL, 0);
@@ -882,51 +848,61 @@ static int f2fs_readdir(struct file *file, struct dir_context *ctx)
 	if (f2fs_encrypted_inode(inode)) {
 		err = fscrypt_get_encryption_info(inode);
 		if (err && err != -ENOKEY)
-			return err;
+			goto out;
 
 		err = fscrypt_fname_alloc_buffer(inode, F2FS_NAME_LEN, &fstr);
 		if (err < 0)
-			return err;
+			goto out;
 	}
 
 	if (f2fs_has_inline_dentry(inode)) {
 		err = f2fs_read_inline_dir(file, ctx, &fstr);
-		goto out;
+		goto out_free;
 	}
 
-	/* readahead for multi pages of dir */
-	if (npages - n > 1 && !ra_has_index(ra, n))
-		page_cache_sync_readahead(inode->i_mapping, ra, file, n,
+	for (; n < npages; n++, ctx->pos = n * NR_DENTRY_IN_BLOCK) {
+
+		/* allow readdir() to be interrupted */
+		if (fatal_signal_pending(current)) {
+			err = -ERESTARTSYS;
+			goto out_free;
+		}
+		cond_resched();
+
+		/* readahead for multi pages of dir */
+		if (npages - n > 1 && !ra_has_index(ra, n))
+			page_cache_sync_readahead(inode->i_mapping, ra, file, n,
 				min(npages - n, (pgoff_t)MAX_DIR_RA_PAGES));
 
-	for (; n < npages; n++) {
-		dentry_page = get_lock_data_page(inode, n, false);
+		dentry_page = f2fs_get_lock_data_page(inode, n, false);
 		if (IS_ERR(dentry_page)) {
 			err = PTR_ERR(dentry_page);
-			if (err == -ENOENT)
+			if (err == -ENOENT) {
+				err = 0;
 				continue;
-			else
-				goto out;
+			} else {
+				goto out_free;
+			}
 		}
 
-		dentry_blk = kmap(dentry_page);
+		dentry_blk = page_address(dentry_page);
 
-		make_dentry_ptr(inode, &d, (void *)dentry_blk, 1);
+		make_dentry_ptr_block(inode, &d, dentry_blk);
 
-		if (f2fs_fill_dentries(ctx, &d, n * NR_DENTRY_IN_BLOCK, &fstr)) {
-			kunmap(dentry_page);
+		err = f2fs_fill_dentries(ctx, &d,
+				n * NR_DENTRY_IN_BLOCK, &fstr);
+		if (err) {
 			f2fs_put_page(dentry_page, 1);
 			break;
 		}
 
-		ctx->pos = (n + 1) * NR_DENTRY_IN_BLOCK;
-		kunmap(dentry_page);
 		f2fs_put_page(dentry_page, 1);
 	}
-	err = 0;
-out:
+out_free:
 	fscrypt_fname_free_buffer(&fstr);
-	return err;
+out:
+	trace_f2fs_readdir(inode, start_pos, ctx->pos, err);
+	return err < 0 ? err : 0;
 }
 
 static int f2fs_dir_open(struct inode *inode, struct file *filp)
diff --git a/fs/f2fs/extent_cache.c b/fs/f2fs/extent_cache.c
index d7b8c8b..231b77e 100644
--- a/fs/f2fs/extent_cache.c
+++ b/fs/f2fs/extent_cache.c
@@ -18,6 +18,179 @@
 #include "node.h"
 #include <trace/events/f2fs.h>
 
+static struct rb_entry *__lookup_rb_tree_fast(struct rb_entry *cached_re,
+							unsigned int ofs)
+{
+	if (cached_re) {
+		if (cached_re->ofs <= ofs &&
+				cached_re->ofs + cached_re->len > ofs) {
+			return cached_re;
+		}
+	}
+	return NULL;
+}
+
+static struct rb_entry *__lookup_rb_tree_slow(struct rb_root *root,
+							unsigned int ofs)
+{
+	struct rb_node *node = root->rb_node;
+	struct rb_entry *re;
+
+	while (node) {
+		re = rb_entry(node, struct rb_entry, rb_node);
+
+		if (ofs < re->ofs)
+			node = node->rb_left;
+		else if (ofs >= re->ofs + re->len)
+			node = node->rb_right;
+		else
+			return re;
+	}
+	return NULL;
+}
+
+struct rb_entry *f2fs_lookup_rb_tree(struct rb_root *root,
+				struct rb_entry *cached_re, unsigned int ofs)
+{
+	struct rb_entry *re;
+
+	re = __lookup_rb_tree_fast(cached_re, ofs);
+	if (!re)
+		return __lookup_rb_tree_slow(root, ofs);
+
+	return re;
+}
+
+struct rb_node **f2fs_lookup_rb_tree_for_insert(struct f2fs_sb_info *sbi,
+				struct rb_root *root, struct rb_node **parent,
+				unsigned int ofs)
+{
+	struct rb_node **p = &root->rb_node;
+	struct rb_entry *re;
+
+	while (*p) {
+		*parent = *p;
+		re = rb_entry(*parent, struct rb_entry, rb_node);
+
+		if (ofs < re->ofs)
+			p = &(*p)->rb_left;
+		else if (ofs >= re->ofs + re->len)
+			p = &(*p)->rb_right;
+		else
+			f2fs_bug_on(sbi, 1);
+	}
+
+	return p;
+}
+
+/*
+ * lookup rb entry in position of @ofs in rb-tree,
+ * if hit, return the entry, otherwise, return NULL
+ * @prev_ex: extent before ofs
+ * @next_ex: extent after ofs
+ * @insert_p: insert point for new extent at ofs
+ * in order to simpfy the insertion after.
+ * tree must stay unchanged between lookup and insertion.
+ */
+struct rb_entry *f2fs_lookup_rb_tree_ret(struct rb_root *root,
+				struct rb_entry *cached_re,
+				unsigned int ofs,
+				struct rb_entry **prev_entry,
+				struct rb_entry **next_entry,
+				struct rb_node ***insert_p,
+				struct rb_node **insert_parent,
+				bool force)
+{
+	struct rb_node **pnode = &root->rb_node;
+	struct rb_node *parent = NULL, *tmp_node;
+	struct rb_entry *re = cached_re;
+
+	*insert_p = NULL;
+	*insert_parent = NULL;
+	*prev_entry = NULL;
+	*next_entry = NULL;
+
+	if (RB_EMPTY_ROOT(root))
+		return NULL;
+
+	if (re) {
+		if (re->ofs <= ofs && re->ofs + re->len > ofs)
+			goto lookup_neighbors;
+	}
+
+	while (*pnode) {
+		parent = *pnode;
+		re = rb_entry(*pnode, struct rb_entry, rb_node);
+
+		if (ofs < re->ofs)
+			pnode = &(*pnode)->rb_left;
+		else if (ofs >= re->ofs + re->len)
+			pnode = &(*pnode)->rb_right;
+		else
+			goto lookup_neighbors;
+	}
+
+	*insert_p = pnode;
+	*insert_parent = parent;
+
+	re = rb_entry(parent, struct rb_entry, rb_node);
+	tmp_node = parent;
+	if (parent && ofs > re->ofs)
+		tmp_node = rb_next(parent);
+	*next_entry = rb_entry_safe(tmp_node, struct rb_entry, rb_node);
+
+	tmp_node = parent;
+	if (parent && ofs < re->ofs)
+		tmp_node = rb_prev(parent);
+	*prev_entry = rb_entry_safe(tmp_node, struct rb_entry, rb_node);
+	return NULL;
+
+lookup_neighbors:
+	if (ofs == re->ofs || force) {
+		/* lookup prev node for merging backward later */
+		tmp_node = rb_prev(&re->rb_node);
+		*prev_entry = rb_entry_safe(tmp_node, struct rb_entry, rb_node);
+	}
+	if (ofs == re->ofs + re->len - 1 || force) {
+		/* lookup next node for merging frontward later */
+		tmp_node = rb_next(&re->rb_node);
+		*next_entry = rb_entry_safe(tmp_node, struct rb_entry, rb_node);
+	}
+	return re;
+}
+
+bool f2fs_check_rb_tree_consistence(struct f2fs_sb_info *sbi,
+						struct rb_root *root)
+{
+#ifdef CONFIG_F2FS_CHECK_FS
+	struct rb_node *cur = rb_first(root), *next;
+	struct rb_entry *cur_re, *next_re;
+
+	if (!cur)
+		return true;
+
+	while (cur) {
+		next = rb_next(cur);
+		if (!next)
+			return true;
+
+		cur_re = rb_entry(cur, struct rb_entry, rb_node);
+		next_re = rb_entry(next, struct rb_entry, rb_node);
+
+		if (cur_re->ofs + cur_re->len > next_re->ofs) {
+			f2fs_msg(sbi->sb, KERN_INFO, "inconsistent rbtree, "
+				"cur(%u, %u) next(%u, %u)",
+				cur_re->ofs, cur_re->len,
+				next_re->ofs, next_re->len);
+			return false;
+		}
+
+		cur = next;
+	}
+#endif
+	return true;
+}
+
 static struct kmem_cache *extent_tree_slab;
 static struct kmem_cache *extent_node_slab;
 
@@ -77,7 +250,7 @@ static struct extent_tree *__grab_extent_tree(struct inode *inode)
 	struct extent_tree *et;
 	nid_t ino = inode->i_ino;
 
-	down_write(&sbi->extent_tree_lock);
+	mutex_lock(&sbi->extent_tree_lock);
 	et = radix_tree_lookup(&sbi->extent_tree_root, ino);
 	if (!et) {
 		et = f2fs_kmem_cache_alloc(extent_tree_slab, GFP_NOFS);
@@ -94,7 +267,7 @@ static struct extent_tree *__grab_extent_tree(struct inode *inode)
 		atomic_dec(&sbi->total_zombie_tree);
 		list_del_init(&et->list);
 	}
-	up_write(&sbi->extent_tree_lock);
+	mutex_unlock(&sbi->extent_tree_lock);
 
 	/* never died until evict_inode */
 	F2FS_I(inode)->extent_tree = et;
@@ -102,36 +275,6 @@ static struct extent_tree *__grab_extent_tree(struct inode *inode)
 	return et;
 }
 
-static struct extent_node *__lookup_extent_tree(struct f2fs_sb_info *sbi,
-				struct extent_tree *et, unsigned int fofs)
-{
-	struct rb_node *node = et->root.rb_node;
-	struct extent_node *en = et->cached_en;
-
-	if (en) {
-		struct extent_info *cei = &en->ei;
-
-		if (cei->fofs <= fofs && cei->fofs + cei->len > fofs) {
-			stat_inc_cached_node_hit(sbi);
-			return en;
-		}
-	}
-
-	while (node) {
-		en = rb_entry(node, struct extent_node, rb_node);
-
-		if (fofs < en->ei.fofs) {
-			node = node->rb_left;
-		} else if (fofs >= en->ei.fofs + en->ei.len) {
-			node = node->rb_right;
-		} else {
-			stat_inc_rbtree_node_hit(sbi);
-			return en;
-		}
-	}
-	return NULL;
-}
-
 static struct extent_node *__init_extent_tree(struct f2fs_sb_info *sbi,
 				struct extent_tree *et, struct extent_info *ei)
 {
@@ -172,7 +315,7 @@ static void __drop_largest_extent(struct inode *inode,
 
 	if (fofs < largest->fofs + largest->len && fofs + len > largest->fofs) {
 		largest->len = 0;
-		f2fs_mark_inode_dirty_sync(inode);
+		f2fs_mark_inode_dirty_sync(inode, true);
 	}
 }
 
@@ -247,17 +390,24 @@ static bool f2fs_lookup_extent_tree(struct inode *inode, pgoff_t pgofs,
 		goto out;
 	}
 
-	en = __lookup_extent_tree(sbi, et, pgofs);
-	if (en) {
-		*ei = en->ei;
-		spin_lock(&sbi->extent_lock);
-		if (!list_empty(&en->list)) {
-			list_move_tail(&en->list, &sbi->extent_list);
-			et->cached_en = en;
-		}
-		spin_unlock(&sbi->extent_lock);
-		ret = true;
+	en = (struct extent_node *)f2fs_lookup_rb_tree(&et->root,
+				(struct rb_entry *)et->cached_en, pgofs);
+	if (!en)
+		goto out;
+
+	if (en == et->cached_en)
+		stat_inc_cached_node_hit(sbi);
+	else
+		stat_inc_rbtree_node_hit(sbi);
+
+	*ei = en->ei;
+	spin_lock(&sbi->extent_lock);
+	if (!list_empty(&en->list)) {
+		list_move_tail(&en->list, &sbi->extent_list);
+		et->cached_en = en;
 	}
+	spin_unlock(&sbi->extent_lock);
+	ret = true;
 out:
 	stat_inc_total_hit(sbi);
 	read_unlock(&et->lock);
@@ -266,87 +416,6 @@ static bool f2fs_lookup_extent_tree(struct inode *inode, pgoff_t pgofs,
 	return ret;
 }
 
-
-/*
- * lookup extent at @fofs, if hit, return the extent
- * if not, return NULL and
- * @prev_ex: extent before fofs
- * @next_ex: extent after fofs
- * @insert_p: insert point for new extent at fofs
- * in order to simpfy the insertion after.
- * tree must stay unchanged between lookup and insertion.
- */
-static struct extent_node *__lookup_extent_tree_ret(struct extent_tree *et,
-				unsigned int fofs,
-				struct extent_node **prev_ex,
-				struct extent_node **next_ex,
-				struct rb_node ***insert_p,
-				struct rb_node **insert_parent)
-{
-	struct rb_node **pnode = &et->root.rb_node;
-	struct rb_node *parent = NULL, *tmp_node;
-	struct extent_node *en = et->cached_en;
-
-	*insert_p = NULL;
-	*insert_parent = NULL;
-	*prev_ex = NULL;
-	*next_ex = NULL;
-
-	if (RB_EMPTY_ROOT(&et->root))
-		return NULL;
-
-	if (en) {
-		struct extent_info *cei = &en->ei;
-
-		if (cei->fofs <= fofs && cei->fofs + cei->len > fofs)
-			goto lookup_neighbors;
-	}
-
-	while (*pnode) {
-		parent = *pnode;
-		en = rb_entry(*pnode, struct extent_node, rb_node);
-
-		if (fofs < en->ei.fofs)
-			pnode = &(*pnode)->rb_left;
-		else if (fofs >= en->ei.fofs + en->ei.len)
-			pnode = &(*pnode)->rb_right;
-		else
-			goto lookup_neighbors;
-	}
-
-	*insert_p = pnode;
-	*insert_parent = parent;
-
-	en = rb_entry(parent, struct extent_node, rb_node);
-	tmp_node = parent;
-	if (parent && fofs > en->ei.fofs)
-		tmp_node = rb_next(parent);
-	*next_ex = tmp_node ?
-		rb_entry(tmp_node, struct extent_node, rb_node) : NULL;
-
-	tmp_node = parent;
-	if (parent && fofs < en->ei.fofs)
-		tmp_node = rb_prev(parent);
-	*prev_ex = tmp_node ?
-		rb_entry(tmp_node, struct extent_node, rb_node) : NULL;
-	return NULL;
-
-lookup_neighbors:
-	if (fofs == en->ei.fofs) {
-		/* lookup prev node for merging backward later */
-		tmp_node = rb_prev(&en->rb_node);
-		*prev_ex = tmp_node ?
-			rb_entry(tmp_node, struct extent_node, rb_node) : NULL;
-	}
-	if (fofs == en->ei.fofs + en->ei.len - 1) {
-		/* lookup next node for merging frontward later */
-		tmp_node = rb_next(&en->rb_node);
-		*next_ex = tmp_node ?
-			rb_entry(tmp_node, struct extent_node, rb_node) : NULL;
-	}
-	return en;
-}
-
 static struct extent_node *__try_merge_extent_node(struct inode *inode,
 				struct extent_tree *et, struct extent_info *ei,
 				struct extent_node *prev_ex,
@@ -391,7 +460,7 @@ static struct extent_node *__insert_extent_tree(struct inode *inode,
 				struct rb_node *insert_parent)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
-	struct rb_node **p = &et->root.rb_node;
+	struct rb_node **p;
 	struct rb_node *parent = NULL;
 	struct extent_node *en = NULL;
 
@@ -401,17 +470,7 @@ static struct extent_node *__insert_extent_tree(struct inode *inode,
 		goto do_insert;
 	}
 
-	while (*p) {
-		parent = *p;
-		en = rb_entry(parent, struct extent_node, rb_node);
-
-		if (ei->fofs < en->ei.fofs)
-			p = &(*p)->rb_left;
-		else if (ei->fofs >= en->ei.fofs + en->ei.len)
-			p = &(*p)->rb_right;
-		else
-			f2fs_bug_on(sbi, 1);
-	}
+	p = f2fs_lookup_rb_tree_for_insert(sbi, &et->root, &parent, ei->fofs);
 do_insert:
 	en = __attach_extent_node(sbi, et, ei, parent, p);
 	if (!en)
@@ -427,7 +486,7 @@ static struct extent_node *__insert_extent_tree(struct inode *inode,
 	return en;
 }
 
-static unsigned int f2fs_update_extent_tree_range(struct inode *inode,
+static void f2fs_update_extent_tree_range(struct inode *inode,
 				pgoff_t fofs, block_t blkaddr, unsigned int len)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
@@ -440,7 +499,7 @@ static unsigned int f2fs_update_extent_tree_range(struct inode *inode,
 	unsigned int pos = (unsigned int)fofs;
 
 	if (!et)
-		return false;
+		return;
 
 	trace_f2fs_update_extent_tree_range(inode, fofs, blkaddr, len);
 
@@ -448,7 +507,7 @@ static unsigned int f2fs_update_extent_tree_range(struct inode *inode,
 
 	if (is_inode_flag_set(inode, FI_NO_EXTENT)) {
 		write_unlock(&et->lock);
-		return false;
+		return;
 	}
 
 	prev = et->largest;
@@ -461,8 +520,11 @@ static unsigned int f2fs_update_extent_tree_range(struct inode *inode,
 	__drop_largest_extent(inode, fofs, len);
 
 	/* 1. lookup first extent node in range [fofs, fofs + len - 1] */
-	en = __lookup_extent_tree_ret(et, fofs, &prev_en, &next_en,
-					&insert_p, &insert_parent);
+	en = (struct extent_node *)f2fs_lookup_rb_tree_ret(&et->root,
+					(struct rb_entry *)et->cached_en, fofs,
+					(struct rb_entry **)&prev_en,
+					(struct rb_entry **)&next_en,
+					&insert_p, &insert_parent, false);
 	if (!en)
 		en = next_en;
 
@@ -503,9 +565,8 @@ static unsigned int f2fs_update_extent_tree_range(struct inode *inode,
 		if (!next_en) {
 			struct rb_node *node = rb_next(&en->rb_node);
 
-			next_en = node ?
-				rb_entry(node, struct extent_node, rb_node)
-				: NULL;
+			next_en = rb_entry_safe(node, struct extent_node,
+						rb_node);
 		}
 
 		if (parts)
@@ -546,8 +607,6 @@ static unsigned int f2fs_update_extent_tree_range(struct inode *inode,
 		__free_extent_tree(sbi, et);
 
 	write_unlock(&et->lock);
-
-	return !__is_extent_same(&prev, &et->largest);
 }
 
 unsigned int f2fs_shrink_extent_tree(struct f2fs_sb_info *sbi, int nr_shrink)
@@ -563,7 +622,7 @@ unsigned int f2fs_shrink_extent_tree(struct f2fs_sb_info *sbi, int nr_shrink)
 	if (!atomic_read(&sbi->total_zombie_tree))
 		goto free_node;
 
-	if (!down_write_trylock(&sbi->extent_tree_lock))
+	if (!mutex_trylock(&sbi->extent_tree_lock))
 		goto out;
 
 	/* 1. remove unreferenced extent tree */
@@ -585,11 +644,11 @@ unsigned int f2fs_shrink_extent_tree(struct f2fs_sb_info *sbi, int nr_shrink)
 			goto unlock_out;
 		cond_resched();
 	}
-	up_write(&sbi->extent_tree_lock);
+	mutex_unlock(&sbi->extent_tree_lock);
 
 free_node:
 	/* 2. remove LRU extent entries */
-	if (!down_write_trylock(&sbi->extent_tree_lock))
+	if (!mutex_trylock(&sbi->extent_tree_lock))
 		goto out;
 
 	remained = nr_shrink - (node_cnt + tree_cnt);
@@ -619,7 +678,7 @@ unsigned int f2fs_shrink_extent_tree(struct f2fs_sb_info *sbi, int nr_shrink)
 	spin_unlock(&sbi->extent_lock);
 
 unlock_out:
-	up_write(&sbi->extent_tree_lock);
+	mutex_unlock(&sbi->extent_tree_lock);
 out:
 	trace_f2fs_shrink_extent_tree(sbi, node_cnt, tree_cnt);
 
@@ -669,10 +728,10 @@ void f2fs_destroy_extent_tree(struct inode *inode)
 
 	if (inode->i_nlink && !is_bad_inode(inode) &&
 					atomic_read(&et->node_cnt)) {
-		down_write(&sbi->extent_tree_lock);
+		mutex_lock(&sbi->extent_tree_lock);
 		list_add_tail(&et->list, &sbi->zombie_list);
 		atomic_inc(&sbi->total_zombie_tree);
-		up_write(&sbi->extent_tree_lock);
+		mutex_unlock(&sbi->extent_tree_lock);
 		return;
 	}
 
@@ -680,12 +739,12 @@ void f2fs_destroy_extent_tree(struct inode *inode)
 	node_cnt = f2fs_destroy_extent_node(inode);
 
 	/* delete extent tree entry in radix tree */
-	down_write(&sbi->extent_tree_lock);
+	mutex_lock(&sbi->extent_tree_lock);
 	f2fs_bug_on(sbi, atomic_read(&et->node_cnt));
 	radix_tree_delete(&sbi->extent_tree_root, inode->i_ino);
 	kmem_cache_free(extent_tree_slab, et);
 	atomic_dec(&sbi->total_ext_tree);
-	up_write(&sbi->extent_tree_lock);
+	mutex_unlock(&sbi->extent_tree_lock);
 
 	F2FS_I(inode)->extent_tree = NULL;
 
@@ -714,7 +773,7 @@ void f2fs_update_extent_cache(struct dnode_of_data *dn)
 	else
 		blkaddr = dn->data_blkaddr;
 
-	fofs = start_bidx_of_node(ofs_of_node(dn->node_page), dn->inode) +
+	fofs = f2fs_start_bidx_of_node(ofs_of_node(dn->node_page), dn->inode) +
 								dn->ofs_in_node;
 	f2fs_update_extent_tree_range(dn->inode, fofs, blkaddr, 1);
 }
@@ -729,10 +788,10 @@ void f2fs_update_extent_cache_range(struct dnode_of_data *dn,
 	f2fs_update_extent_tree_range(dn->inode, fofs, blkaddr, len);
 }
 
-void init_extent_cache_info(struct f2fs_sb_info *sbi)
+void f2fs_init_extent_cache_info(struct f2fs_sb_info *sbi)
 {
 	INIT_RADIX_TREE(&sbi->extent_tree_root, GFP_NOIO);
-	init_rwsem(&sbi->extent_tree_lock);
+	mutex_init(&sbi->extent_tree_lock);
 	INIT_LIST_HEAD(&sbi->extent_list);
 	spin_lock_init(&sbi->extent_lock);
 	atomic_set(&sbi->total_ext_tree, 0);
@@ -741,7 +800,7 @@ void init_extent_cache_info(struct f2fs_sb_info *sbi)
 	atomic_set(&sbi->total_ext_node, 0);
 }
 
-int __init create_extent_cache(void)
+int __init f2fs_create_extent_cache(void)
 {
 	extent_tree_slab = f2fs_kmem_cache_create("f2fs_extent_tree",
 			sizeof(struct extent_tree));
@@ -756,7 +815,7 @@ int __init create_extent_cache(void)
 	return 0;
 }
 
-void destroy_extent_cache(void)
+void f2fs_destroy_extent_cache(void)
 {
 	kmem_cache_destroy(extent_node_slab);
 	kmem_cache_destroy(extent_tree_slab);
diff --git a/fs/f2fs/f2fs.h b/fs/f2fs/f2fs.h
index 88e111a..9a6f02b 100644
--- a/fs/f2fs/f2fs.h
+++ b/fs/f2fs/f2fs.h
@@ -19,11 +19,17 @@
 #include <linux/magic.h>
 #include <linux/kobject.h>
 #include <linux/sched.h>
+#include <linux/writeback.h>
+#include <linux/cred.h>
 #include <linux/vmalloc.h>
 #include <linux/bio.h>
 #include <linux/blkdev.h>
-#include <linux/fscrypto.h>
+#include <linux/quotaops.h>
 #include <crypto/hash.h>
+#include <linux/overflow.h>
+
+#define __FS_HAS_ENCRYPTION IS_ENABLED(CONFIG_F2FS_FS_ENCRYPTION)
+#include <linux/fscrypt.h>
 
 #ifdef CONFIG_F2FS_CHECK_FS
 #define f2fs_bug_on(sbi, condition)	BUG_ON(condition)
@@ -40,12 +46,16 @@
 #ifdef CONFIG_F2FS_FAULT_INJECTION
 enum {
 	FAULT_KMALLOC,
+	FAULT_KVMALLOC,
 	FAULT_PAGE_ALLOC,
+	FAULT_PAGE_GET,
+	FAULT_ALLOC_BIO,
 	FAULT_ALLOC_NID,
 	FAULT_ORPHAN,
 	FAULT_BLOCK,
 	FAULT_DIR_DEPTH,
 	FAULT_EVICT_INODE,
+	FAULT_TRUNCATE,
 	FAULT_IO,
 	FAULT_CHECKPOINT,
 	FAULT_MAX,
@@ -58,7 +68,7 @@ struct f2fs_fault_info {
 };
 
 extern char *fault_name[FAULT_MAX];
-#define IS_FAULT_SET(fi, type) (fi->inject_type & (1 << (type)))
+#define IS_FAULT_SET(fi, type) ((fi)->inject_type & (1 << (type)))
 #endif
 
 /*
@@ -83,10 +93,17 @@ struct f2fs_fault_info {
 #define F2FS_MOUNT_FAULT_INJECTION	0x00010000
 #define F2FS_MOUNT_ADAPTIVE		0x00020000
 #define F2FS_MOUNT_LFS			0x00040000
-
-#define clear_opt(sbi, option)	(sbi->mount_opt.opt &= ~F2FS_MOUNT_##option)
-#define set_opt(sbi, option)	(sbi->mount_opt.opt |= F2FS_MOUNT_##option)
-#define test_opt(sbi, option)	(sbi->mount_opt.opt & F2FS_MOUNT_##option)
+#define F2FS_MOUNT_USRQUOTA		0x00080000
+#define F2FS_MOUNT_GRPQUOTA		0x00100000
+#define F2FS_MOUNT_PRJQUOTA		0x00200000
+#define F2FS_MOUNT_QUOTA		0x00400000
+#define F2FS_MOUNT_INLINE_XATTR_SIZE	0x00800000
+#define F2FS_MOUNT_RESERVE_ROOT		0x01000000
+
+#define F2FS_OPTION(sbi)	((sbi)->mount_opt)
+#define clear_opt(sbi, option)	(F2FS_OPTION(sbi).opt &= ~F2FS_MOUNT_##option)
+#define set_opt(sbi, option)	(F2FS_OPTION(sbi).opt |= F2FS_MOUNT_##option)
+#define test_opt(sbi, option)	(F2FS_OPTION(sbi).opt & F2FS_MOUNT_##option)
 
 #define ver_after(a, b)	(typecheck(unsigned long long, a) &&		\
 		typecheck(unsigned long long, b) &&			\
@@ -99,18 +116,52 @@ struct f2fs_fault_info {
 typedef u32 nid_t;
 
 struct f2fs_mount_info {
-	unsigned int	opt;
+	unsigned int opt;
+	int write_io_size_bits;		/* Write IO size bits */
+	block_t root_reserved_blocks;	/* root reserved blocks */
+	kuid_t s_resuid;		/* reserved blocks for uid */
+	kgid_t s_resgid;		/* reserved blocks for gid */
+	int active_logs;		/* # of active logs */
+	int inline_xattr_size;		/* inline xattr size */
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	struct f2fs_fault_info fault_info;	/* For fault injection */
+#endif
+#ifdef CONFIG_QUOTA
+	/* Names of quota files with journalled quota */
+	char *s_qf_names[MAXQUOTAS];
+	int s_jquota_fmt;			/* Format of quota to use */
+#endif
+	/* For which write hints are passed down to block layer */
+	int whint_mode;
+	int alloc_mode;			/* segment allocation policy */
+	int fsync_mode;			/* fsync policy */
+	bool test_dummy_encryption;	/* test dummy encryption */
 };
 
-#define F2FS_FEATURE_ENCRYPT	0x0001
-#define F2FS_FEATURE_HMSMR	0x0002
+#define F2FS_FEATURE_ENCRYPT		0x0001
+#define F2FS_FEATURE_BLKZONED		0x0002
+#define F2FS_FEATURE_ATOMIC_WRITE	0x0004
+#define F2FS_FEATURE_EXTRA_ATTR		0x0008
+#define F2FS_FEATURE_PRJQUOTA		0x0010
+#define F2FS_FEATURE_INODE_CHKSUM	0x0020
+#define F2FS_FEATURE_FLEXIBLE_INLINE_XATTR	0x0040
+#define F2FS_FEATURE_QUOTA_INO		0x0080
+#define F2FS_FEATURE_INODE_CRTIME	0x0100
+#define F2FS_FEATURE_LOST_FOUND		0x0200
+#define F2FS_FEATURE_VERITY		0x0400	/* reserved */
 
 #define F2FS_HAS_FEATURE(sb, mask)					\
 	((F2FS_SB(sb)->raw_super->feature & cpu_to_le32(mask)) != 0)
 #define F2FS_SET_FEATURE(sb, mask)					\
-	F2FS_SB(sb)->raw_super->feature |= cpu_to_le32(mask)
+	(F2FS_SB(sb)->raw_super->feature |= cpu_to_le32(mask))
 #define F2FS_CLEAR_FEATURE(sb, mask)					\
-	F2FS_SB(sb)->raw_super->feature &= ~cpu_to_le32(mask)
+	(F2FS_SB(sb)->raw_super->feature &= ~cpu_to_le32(mask))
+
+/*
+ * Default values for user and/or group using reserved blocks
+ */
+#define	F2FS_DEF_RESUID		0
+#define	F2FS_DEF_RESGID		0
 
 /*
  * For checkpoint manager
@@ -120,19 +171,20 @@ enum {
 	SIT_BITMAP
 };
 
-enum {
-	CP_UMOUNT,
-	CP_FASTBOOT,
-	CP_SYNC,
-	CP_RECOVERY,
-	CP_DISCARD,
-};
-
-#define DEF_BATCHED_TRIM_SECTIONS	2
-#define BATCHED_TRIM_SEGMENTS(sbi)	\
-		(SM_I(sbi)->trim_sections * (sbi)->segs_per_sec)
-#define BATCHED_TRIM_BLOCKS(sbi)	\
-		(BATCHED_TRIM_SEGMENTS(sbi) << (sbi)->log_blocks_per_seg)
+#define	CP_UMOUNT	0x00000001
+#define	CP_FASTBOOT	0x00000002
+#define	CP_SYNC		0x00000004
+#define	CP_RECOVERY	0x00000008
+#define	CP_DISCARD	0x00000010
+#define CP_TRIMMED	0x00000020
+
+#define MAX_DISCARD_BLOCKS(sbi)		BLKS_PER_SEC(sbi)
+#define DEF_MAX_DISCARD_REQUEST		8	/* issue 8 discards per round */
+#define DEF_MAX_DISCARD_LEN		512	/* Max. 2MB per discard */
+#define DEF_MIN_DISCARD_ISSUE_TIME	50	/* 50 ms, if exists */
+#define DEF_MID_DISCARD_ISSUE_TIME	500	/* 500 ms, if device busy */
+#define DEF_MAX_DISCARD_ISSUE_TIME	60000	/* 60 s, if no candidates */
+#define DEF_DISCARD_URGENT_UTIL		80	/* do more discard over 80% */
 #define DEF_CP_INTERVAL			60	/* 60 secs */
 #define DEF_IDLE_INTERVAL		5	/* 5 secs */
 
@@ -141,7 +193,6 @@ struct cp_control {
 	__u64 trim_start;
 	__u64 trim_end;
 	__u64 trim_minlen;
-	__u64 trimmed;
 };
 
 /*
@@ -160,12 +211,15 @@ enum {
 	ORPHAN_INO,		/* for orphan ino list */
 	APPEND_INO,		/* for append ino list */
 	UPDATE_INO,		/* for update ino list */
+	TRANS_DIR_INO,		/* for trasactions dir ino list */
+	FLUSH_INO,		/* for multiple device flushing */
 	MAX_INO_ENTRY,		/* max. list */
 };
 
 struct ino_entry {
-	struct list_head list;	/* list head */
-	nid_t ino;		/* inode number */
+	struct list_head list;		/* list head */
+	nid_t ino;			/* inode number */
+	unsigned int dirty_device;	/* dirty device bitmap */
 };
 
 /* for the list of inodes to be GCed */
@@ -174,18 +228,89 @@ struct inode_entry {
 	struct inode *inode;	/* vfs inode pointer */
 };
 
-/* for the list of blockaddresses to be discarded */
+/* for the bitmap indicate blocks to be discarded */
 struct discard_entry {
 	struct list_head list;	/* list head */
-	block_t blkaddr;	/* block address to be discarded */
-	int len;		/* # of consecutive blocks of the discard */
+	block_t start_blkaddr;	/* start blockaddr of current segment */
+	unsigned char discard_map[SIT_VBLOCK_MAP_SIZE];	/* segment discard bitmap */
 };
 
-struct bio_entry {
-	struct list_head list;
-	struct bio *bio;
-	struct completion event;
-	int error;
+/* default discard granularity of inner discard thread, unit: block count */
+#define DEFAULT_DISCARD_GRANULARITY		16
+
+/* max discard pend list number */
+#define MAX_PLIST_NUM		512
+#define plist_idx(blk_num)	((blk_num) >= MAX_PLIST_NUM ?		\
+					(MAX_PLIST_NUM - 1) : (blk_num - 1))
+
+enum {
+	D_PREP,
+	D_SUBMIT,
+	D_DONE,
+};
+
+struct discard_info {
+	block_t lstart;			/* logical start address */
+	block_t len;			/* length */
+	block_t start;			/* actual start address in dev */
+};
+
+struct discard_cmd {
+	struct rb_node rb_node;		/* rb node located in rb-tree */
+	union {
+		struct {
+			block_t lstart;	/* logical start address */
+			block_t len;	/* length */
+			block_t start;	/* actual start address in dev */
+		};
+		struct discard_info di;	/* discard info */
+
+	};
+	struct list_head list;		/* command list */
+	struct completion wait;		/* compleation */
+	struct block_device *bdev;	/* bdev */
+	unsigned short ref;		/* reference count */
+	unsigned char state;		/* state */
+	int error;			/* bio error */
+};
+
+enum {
+	DPOLICY_BG,
+	DPOLICY_FORCE,
+	DPOLICY_FSTRIM,
+	DPOLICY_UMOUNT,
+	MAX_DPOLICY,
+};
+
+struct discard_policy {
+	int type;			/* type of discard */
+	unsigned int min_interval;	/* used for candidates exist */
+	unsigned int mid_interval;	/* used for device busy */
+	unsigned int max_interval;	/* used for candidates not exist */
+	unsigned int max_requests;	/* # of discards issued per round */
+	unsigned int io_aware_gran;	/* minimum granularity discard not be aware of I/O */
+	bool io_aware;			/* issue discard in idle time */
+	bool sync;			/* submit discard with REQ_SYNC flag */
+	unsigned int granularity;	/* discard granularity */
+};
+
+struct discard_cmd_control {
+	struct task_struct *f2fs_issue_discard;	/* discard thread */
+	struct list_head entry_list;		/* 4KB discard entry list */
+	struct list_head pend_list[MAX_PLIST_NUM];/* store pending entries */
+	struct list_head wait_list;		/* store on-flushing entries */
+	struct list_head fstrim_list;		/* in-flight discard from fstrim */
+	wait_queue_head_t discard_wait_queue;	/* waiting queue for wake-up */
+	unsigned int discard_wake;		/* to wake up discard thread */
+	struct mutex cmd_lock;
+	unsigned int nr_discards;		/* # of discards in the list */
+	unsigned int max_discards;		/* max. discards to be issued */
+	unsigned int discard_granularity;	/* discard granularity */
+	unsigned int undiscard_blks;		/* # of undiscard blocks */
+	atomic_t issued_discard;		/* # of issued discard */
+	atomic_t issing_discard;		/* # of issing discard */
+	atomic_t discard_cmd_cnt;		/* # of cached cmd count */
+	struct rb_root root;			/* root of discard rb-tree */
 };
 
 /* for the list of fsync inodes, used only during recovery */
@@ -196,13 +321,13 @@ struct fsync_inode_entry {
 	block_t last_dentry;	/* block address locating the last dentry */
 };
 
-#define nats_in_cursum(jnl)		(le16_to_cpu(jnl->n_nats))
-#define sits_in_cursum(jnl)		(le16_to_cpu(jnl->n_sits))
+#define nats_in_cursum(jnl)		(le16_to_cpu((jnl)->n_nats))
+#define sits_in_cursum(jnl)		(le16_to_cpu((jnl)->n_sits))
 
-#define nat_in_journal(jnl, i)		(jnl->nat_j.entries[i].ne)
-#define nid_in_journal(jnl, i)		(jnl->nat_j.entries[i].nid)
-#define sit_in_journal(jnl, i)		(jnl->sit_j.entries[i].se)
-#define segno_in_journal(jnl, i)	(jnl->sit_j.entries[i].segno)
+#define nat_in_journal(jnl, i)		((jnl)->nat_j.entries[i].ne)
+#define nid_in_journal(jnl, i)		((jnl)->nat_j.entries[i].nid)
+#define sit_in_journal(jnl, i)		((jnl)->sit_j.entries[i].se)
+#define segno_in_journal(jnl, i)	((jnl)->sit_j.entries[i].segno)
 
 #define MAX_NAT_JENTRIES(jnl)	(NAT_JOURNAL_ENTRIES - nats_in_cursum(jnl))
 #define MAX_SIT_JENTRIES(jnl)	(SIT_JOURNAL_ENTRIES - sits_in_cursum(jnl))
@@ -210,6 +335,7 @@ struct fsync_inode_entry {
 static inline int update_nats_in_cursum(struct f2fs_journal *journal, int i)
 {
 	int before = nats_in_cursum(journal);
+
 	journal->n_nats = cpu_to_le16(before + i);
 	return before;
 }
@@ -217,6 +343,7 @@ static inline int update_nats_in_cursum(struct f2fs_journal *journal, int i)
 static inline int update_sits_in_cursum(struct f2fs_journal *journal, int i)
 {
 	int before = sits_in_cursum(journal);
+
 	journal->n_sits = cpu_to_le16(before + i);
 	return before;
 }
@@ -242,11 +369,20 @@ static inline bool __has_cursum_space(struct f2fs_journal *journal,
 #define F2FS_IOC_START_VOLATILE_WRITE	_IO(F2FS_IOCTL_MAGIC, 3)
 #define F2FS_IOC_RELEASE_VOLATILE_WRITE	_IO(F2FS_IOCTL_MAGIC, 4)
 #define F2FS_IOC_ABORT_VOLATILE_WRITE	_IO(F2FS_IOCTL_MAGIC, 5)
-#define F2FS_IOC_GARBAGE_COLLECT	_IO(F2FS_IOCTL_MAGIC, 6)
+#define F2FS_IOC_GARBAGE_COLLECT	_IOW(F2FS_IOCTL_MAGIC, 6, __u32)
 #define F2FS_IOC_WRITE_CHECKPOINT	_IO(F2FS_IOCTL_MAGIC, 7)
-#define F2FS_IOC_DEFRAGMENT		_IO(F2FS_IOCTL_MAGIC, 8)
+#define F2FS_IOC_DEFRAGMENT		_IOWR(F2FS_IOCTL_MAGIC, 8,	\
+						struct f2fs_defragment)
 #define F2FS_IOC_MOVE_RANGE		_IOWR(F2FS_IOCTL_MAGIC, 9,	\
 						struct f2fs_move_range)
+#define F2FS_IOC_FLUSH_DEVICE		_IOW(F2FS_IOCTL_MAGIC, 10,	\
+						struct f2fs_flush_device)
+#define F2FS_IOC_GARBAGE_COLLECT_RANGE	_IOW(F2FS_IOCTL_MAGIC, 11,	\
+						struct f2fs_gc_range)
+#define F2FS_IOC_GET_FEATURES		_IOR(F2FS_IOCTL_MAGIC, 12, __u32)
+#define F2FS_IOC_SET_PIN_FILE		_IOW(F2FS_IOCTL_MAGIC, 13, __u32)
+#define F2FS_IOC_GET_PIN_FILE		_IOR(F2FS_IOCTL_MAGIC, 14, __u32)
+#define F2FS_IOC_PRECACHE_EXTENTS	_IO(F2FS_IOCTL_MAGIC, 15)
 
 #define F2FS_IOC_SET_ENCRYPTION_POLICY	FS_IOC_SET_ENCRYPTION_POLICY
 #define F2FS_IOC_GET_ENCRYPTION_POLICY	FS_IOC_GET_ENCRYPTION_POLICY
@@ -271,6 +407,12 @@ static inline bool __has_cursum_space(struct f2fs_journal *journal,
 #define F2FS_IOC32_GETVERSION		FS_IOC32_GETVERSION
 #endif
 
+struct f2fs_gc_range {
+	u32 sync;
+	u64 start;
+	u64 len;
+};
+
 struct f2fs_defragment {
 	u64 start;
 	u64 len;
@@ -283,36 +425,70 @@ struct f2fs_move_range {
 	u64 len;		/* size to move */
 };
 
+struct f2fs_flush_device {
+	u32 dev_num;		/* device number to flush */
+	u32 segments;		/* # of segments to flush */
+};
+
+/* for inline stuff */
+#define DEF_INLINE_RESERVED_SIZE	1
+#define DEF_MIN_INLINE_SIZE		1
+static inline int get_extra_isize(struct inode *inode);
+static inline int get_inline_xattr_addrs(struct inode *inode);
+#define MAX_INLINE_DATA(inode)	(sizeof(__le32) *			\
+				(CUR_ADDRS_PER_INODE(inode) -		\
+				get_inline_xattr_addrs(inode) -	\
+				DEF_INLINE_RESERVED_SIZE))
+
+/* for inline dir */
+#define NR_INLINE_DENTRY(inode)	(MAX_INLINE_DATA(inode) * BITS_PER_BYTE / \
+				((SIZE_OF_DIR_ENTRY + F2FS_SLOT_LEN) * \
+				BITS_PER_BYTE + 1))
+#define INLINE_DENTRY_BITMAP_SIZE(inode)	((NR_INLINE_DENTRY(inode) + \
+					BITS_PER_BYTE - 1) / BITS_PER_BYTE)
+#define INLINE_RESERVED_SIZE(inode)	(MAX_INLINE_DATA(inode) - \
+				((SIZE_OF_DIR_ENTRY + F2FS_SLOT_LEN) * \
+				NR_INLINE_DENTRY(inode) + \
+				INLINE_DENTRY_BITMAP_SIZE(inode)))
+
 /*
  * For INODE and NODE manager
  */
 /* for directory operations */
 struct f2fs_dentry_ptr {
 	struct inode *inode;
-	const void *bitmap;
+	void *bitmap;
 	struct f2fs_dir_entry *dentry;
 	__u8 (*filename)[F2FS_SLOT_LEN];
 	int max;
+	int nr_bitmap;
 };
 
-static inline void make_dentry_ptr(struct inode *inode,
-		struct f2fs_dentry_ptr *d, void *src, int type)
+static inline void make_dentry_ptr_block(struct inode *inode,
+		struct f2fs_dentry_ptr *d, struct f2fs_dentry_block *t)
 {
 	d->inode = inode;
+	d->max = NR_DENTRY_IN_BLOCK;
+	d->nr_bitmap = SIZE_OF_DENTRY_BITMAP;
+	d->bitmap = t->dentry_bitmap;
+	d->dentry = t->dentry;
+	d->filename = t->filename;
+}
 
-	if (type == 1) {
-		struct f2fs_dentry_block *t = (struct f2fs_dentry_block *)src;
-		d->max = NR_DENTRY_IN_BLOCK;
-		d->bitmap = &t->dentry_bitmap;
-		d->dentry = t->dentry;
-		d->filename = t->filename;
-	} else {
-		struct f2fs_inline_dentry *t = (struct f2fs_inline_dentry *)src;
-		d->max = NR_INLINE_DENTRY;
-		d->bitmap = &t->dentry_bitmap;
-		d->dentry = t->dentry;
-		d->filename = t->filename;
-	}
+static inline void make_dentry_ptr_inline(struct inode *inode,
+					struct f2fs_dentry_ptr *d, void *t)
+{
+	int entry_cnt = NR_INLINE_DENTRY(inode);
+	int bitmap_size = INLINE_DENTRY_BITMAP_SIZE(inode);
+	int reserved_size = INLINE_RESERVED_SIZE(inode);
+
+	d->inode = inode;
+	d->max = entry_cnt;
+	d->nr_bitmap = bitmap_size;
+	d->bitmap = t;
+	d->dentry = t + bitmap_size + reserved_size;
+	d->filename = t + bitmap_size + reserved_size +
+					SIZE_OF_DIR_ENTRY * entry_cnt;
 }
 
 /*
@@ -344,16 +520,30 @@ enum {
 /* number of extent info in extent cache we try to shrink */
 #define EXTENT_CACHE_SHRINK_NUMBER	128
 
+struct rb_entry {
+	struct rb_node rb_node;		/* rb node located in rb-tree */
+	unsigned int ofs;		/* start offset of the entry */
+	unsigned int len;		/* length of the entry */
+};
+
 struct extent_info {
 	unsigned int fofs;		/* start offset in a file */
-	u32 blk;			/* start block address of the extent */
 	unsigned int len;		/* length of the extent */
+	u32 blk;			/* start block address of the extent */
 };
 
 struct extent_node {
-	struct rb_node rb_node;		/* rb node located in rb-tree */
+	struct rb_node rb_node;
+	union {
+		struct {
+			unsigned int fofs;
+			unsigned int len;
+			u32 blk;
+		};
+		struct extent_info ei;	/* extent info */
+
+	};
 	struct list_head list;		/* node in global extent list of sbi */
-	struct extent_info ei;		/* extent info */
 	struct extent_tree *et;		/* extent tree pointer */
 };
 
@@ -384,15 +574,19 @@ struct f2fs_map_blocks {
 	unsigned int m_len;
 	unsigned int m_flags;
 	pgoff_t *m_next_pgofs;		/* point next possible non-hole pgofs */
+	pgoff_t *m_next_extent;		/* point to next possible extent */
+	int m_seg_type;
 };
 
 /* for flag in get_data_block */
-#define F2FS_GET_BLOCK_READ		0
-#define F2FS_GET_BLOCK_DIO		1
-#define F2FS_GET_BLOCK_FIEMAP		2
-#define F2FS_GET_BLOCK_BMAP		3
-#define F2FS_GET_BLOCK_PRE_DIO		4
-#define F2FS_GET_BLOCK_PRE_AIO		5
+enum {
+	F2FS_GET_BLOCK_DEFAULT,
+	F2FS_GET_BLOCK_FIEMAP,
+	F2FS_GET_BLOCK_BMAP,
+	F2FS_GET_BLOCK_PRE_DIO,
+	F2FS_GET_BLOCK_PRE_AIO,
+	F2FS_GET_BLOCK_PRECACHE,
+};
 
 /*
  * i_advise uses FADVISE_XXX_BIT. We can add additional hints later.
@@ -401,6 +595,9 @@ struct f2fs_map_blocks {
 #define FADVISE_LOST_PINO_BIT	0x02
 #define FADVISE_ENCRYPT_BIT	0x04
 #define FADVISE_ENC_NAME_BIT	0x08
+#define FADVISE_KEEP_SIZE_BIT	0x10
+#define FADVISE_HOT_BIT		0x20
+#define FADVISE_VERITY_BIT	0x40	/* reserved */
 
 #define file_is_cold(inode)	is_file(inode, FADVISE_COLD_BIT)
 #define file_wrong_pino(inode)	is_file(inode, FADVISE_LOST_PINO_BIT)
@@ -413,15 +610,28 @@ struct f2fs_map_blocks {
 #define file_clear_encrypt(inode) clear_file(inode, FADVISE_ENCRYPT_BIT)
 #define file_enc_name(inode)	is_file(inode, FADVISE_ENC_NAME_BIT)
 #define file_set_enc_name(inode) set_file(inode, FADVISE_ENC_NAME_BIT)
+#define file_keep_isize(inode)	is_file(inode, FADVISE_KEEP_SIZE_BIT)
+#define file_set_keep_isize(inode) set_file(inode, FADVISE_KEEP_SIZE_BIT)
+#define file_is_hot(inode)	is_file(inode, FADVISE_HOT_BIT)
+#define file_set_hot(inode)	set_file(inode, FADVISE_HOT_BIT)
+#define file_clear_hot(inode)	clear_file(inode, FADVISE_HOT_BIT)
 
 #define DEF_DIR_LEVEL		0
 
+enum {
+	GC_FAILURE_PIN,
+	GC_FAILURE_ATOMIC,
+	MAX_GC_FAILURE
+};
+
 struct f2fs_inode_info {
 	struct inode vfs_inode;		/* serve a vfs inode */
 	unsigned long i_flags;		/* keep an inode flags for ioctl */
 	unsigned char i_advise;		/* use to give file attribute hints */
 	unsigned char i_dir_level;	/* use for dentry level for large dir */
-	unsigned int i_current_depth;	/* use only in directory structure */
+	unsigned int i_current_depth;	/* only for directory depth */
+	/* for gc failure statistic */
+	unsigned int i_gc_failures[MAX_GC_FAILURE];
 	unsigned int i_pino;		/* parent inode number */
 	umode_t i_acl_mode;		/* keep file acl mode temporarily */
 
@@ -432,16 +642,34 @@ struct f2fs_inode_info {
 	f2fs_hash_t chash;		/* hash value of given file name */
 	unsigned int clevel;		/* maximum level of given file name */
 	struct task_struct *task;	/* lookup and create consistency */
+	struct task_struct *cp_task;	/* separate cp/wb IO stats*/
 	nid_t i_xattr_nid;		/* node id that contains xattrs */
-	unsigned long long xattr_ver;	/* cp version of xattr modification */
 	loff_t	last_disk_size;		/* lastly written file size */
 
+#ifdef CONFIG_QUOTA
+	struct dquot *i_dquot[MAXQUOTAS];
+
+	/* quota space reservation, managed internally by quota code */
+	qsize_t i_reserved_quota;
+#endif
 	struct list_head dirty_list;	/* dirty list for dirs and files */
 	struct list_head gdirty_list;	/* linked in global dirty list */
+	struct list_head inmem_ilist;	/* list for inmem inodes */
 	struct list_head inmem_pages;	/* inmemory pages managed by f2fs */
+	struct task_struct *inmem_task;	/* store inmemory task */
 	struct mutex inmem_lock;	/* lock for inmemory pages */
 	struct extent_tree *extent_tree;	/* cached extent_tree entry */
-	struct rw_semaphore dio_rwsem[2];/* avoid racing between dio and gc */
+
+	/* avoid racing between foreground op and gc */
+	struct rw_semaphore i_gc_rwsem[2];
+	struct rw_semaphore i_mmap_sem;
+	struct rw_semaphore i_xattr_sem; /* avoid racing between reading and changing EAs */
+
+	int i_extra_isize;		/* size of extra space located in i_addr */
+	kprojid_t i_projid;		/* id for project quota */
+	int i_inline_xattr_size;	/* inline xattr size */
+	struct timespec i_crtime;	/* inode creation time */
+	struct timespec i_disk_time[4];	/* inode disk times */
 };
 
 static inline void get_extent_info(struct extent_info *ext,
@@ -468,11 +696,23 @@ static inline void set_extent_info(struct extent_info *ei, unsigned int fofs,
 	ei->len = len;
 }
 
-static inline bool __is_extent_same(struct extent_info *ei1,
-						struct extent_info *ei2)
+static inline bool __is_discard_mergeable(struct discard_info *back,
+						struct discard_info *front)
 {
-	return (ei1->fofs == ei2->fofs && ei1->blk == ei2->blk &&
-						ei1->len == ei2->len);
+	return (back->lstart + back->len == front->lstart) &&
+		(back->len + front->len < DEF_MAX_DISCARD_LEN);
+}
+
+static inline bool __is_discard_back_mergeable(struct discard_info *cur,
+						struct discard_info *back)
+{
+	return __is_discard_mergeable(back, cur);
+}
+
+static inline bool __is_discard_front_mergeable(struct discard_info *cur,
+						struct discard_info *front)
+{
+	return __is_discard_mergeable(cur, front);
 }
 
 static inline bool __is_extent_mergeable(struct extent_info *back,
@@ -494,20 +734,29 @@ static inline bool __is_front_mergeable(struct extent_info *cur,
 	return __is_extent_mergeable(cur, front);
 }
 
-extern void f2fs_mark_inode_dirty_sync(struct inode *);
+extern void f2fs_mark_inode_dirty_sync(struct inode *inode, bool sync);
 static inline void __try_update_largest_extent(struct inode *inode,
 			struct extent_tree *et, struct extent_node *en)
 {
 	if (en->ei.len > et->largest.len) {
 		et->largest = en->ei;
-		f2fs_mark_inode_dirty_sync(inode);
+		f2fs_mark_inode_dirty_sync(inode, true);
 	}
 }
 
+/*
+ * For free nid management
+ */
+enum nid_state {
+	FREE_NID,		/* newly added to free nid list */
+	PREALLOC_NID,		/* it is preallocated */
+	MAX_NID_STATE,
+};
+
 struct f2fs_nm_info {
 	block_t nat_blkaddr;		/* base disk address of NAT */
 	nid_t max_nid;			/* maximum possible node ids */
-	nid_t available_nids;		/* maximum available node ids */
+	nid_t available_nids;		/* # of available node ids */
 	nid_t next_scan_nid;		/* the next nid to be scanned */
 	unsigned int ram_thresh;	/* control the memory footprint */
 	unsigned int ra_nid_pages;	/* # of nid pages to be readaheaded */
@@ -520,16 +769,28 @@ struct f2fs_nm_info {
 	struct list_head nat_entries;	/* cached nat entry list (clean) */
 	unsigned int nat_cnt;		/* the # of cached nat entries */
 	unsigned int dirty_nat_cnt;	/* total num of nat entries in set */
+	unsigned int nat_blocks;	/* # of nat blocks */
 
 	/* free node ids management */
 	struct radix_tree_root free_nid_root;/* root of the free_nid cache */
-	struct list_head free_nid_list;	/* a list for free nids */
-	spinlock_t free_nid_list_lock;	/* protect free nid list */
-	unsigned int fcnt;		/* the number of free node id */
+	struct list_head free_nid_list;		/* list for free nids excluding preallocated nids */
+	unsigned int nid_cnt[MAX_NID_STATE];	/* the number of free node id */
+	spinlock_t nid_list_lock;	/* protect nid lists ops */
 	struct mutex build_lock;	/* lock for build free nids */
+	unsigned char **free_nid_bitmap;
+	unsigned char *nat_block_bitmap;
+	unsigned short *free_nid_count;	/* free nid count of NAT block */
 
 	/* for checkpoint */
 	char *nat_bitmap;		/* NAT bitmap pointer */
+
+	unsigned int nat_bits_blocks;	/* # of nat bits blocks */
+	unsigned char *nat_bits;	/* NAT bits blocks */
+	unsigned char *full_nat_bits;	/* full NAT pages */
+	unsigned char *empty_nat_bits;	/* empty NAT pages */
+#ifdef CONFIG_F2FS_CHECK_FS
+	char *nat_bitmap_mir;		/* NAT bitmap mirror */
+#endif
 	int bitmap_size;		/* bitmap size */
 };
 
@@ -586,19 +847,20 @@ enum {
 	CURSEG_WARM_NODE,	/* direct node blocks of normal files */
 	CURSEG_COLD_NODE,	/* indirect node blocks */
 	NO_CHECK_TYPE,
-	CURSEG_DIRECT_IO,	/* to use for the direct IO path */
 };
 
 struct flush_cmd {
 	struct completion wait;
 	struct llist_node llnode;
+	nid_t ino;
 	int ret;
 };
 
 struct flush_cmd_control {
 	struct task_struct *f2fs_issue_flush;	/* flush thread */
 	wait_queue_head_t flush_wait_queue;	/* waiting queue for wake-up */
-	atomic_t submit_flush;			/* # of issued flushes */
+	atomic_t issued_flush;			/* # of issued flushes */
+	atomic_t issing_flush;			/* # of issing flushes */
 	struct llist_head issue_list;		/* list for command issue */
 	struct llist_node *dispatch_list;	/* list for command dispatch */
 };
@@ -609,6 +871,8 @@ struct f2fs_sm_info {
 	struct dirty_seglist_info *dirty_info;	/* dirty segment information */
 	struct curseg_info *curseg_array;	/* active segment information */
 
+	struct rw_semaphore curseg_lock;	/* for preventing curseg change */
+
 	block_t seg0_blkaddr;		/* block address of 0'th segment */
 	block_t main_blkaddr;		/* start block address of main area */
 	block_t ssa_blkaddr;		/* start block address of SSA area */
@@ -621,12 +885,6 @@ struct f2fs_sm_info {
 	/* a threshold to reclaim prefree segments */
 	unsigned int rec_prefree_segments;
 
-	/* for small discard management */
-	struct list_head discard_list;		/* 4KB discard list */
-	struct list_head wait_list;		/* linked with issued discard bio */
-	int nr_discards;			/* # of discards in the list */
-	int max_discards;			/* max. discards to be issued */
-
 	/* for batched trimming */
 	unsigned int trim_sections;		/* # of sections to trim */
 
@@ -635,10 +893,14 @@ struct f2fs_sm_info {
 	unsigned int ipu_policy;	/* in-place-update policy */
 	unsigned int min_ipu_util;	/* in-place-update threshold */
 	unsigned int min_fsync_blocks;	/* threshold for fsync */
+	unsigned int min_hot_blocks;	/* threshold for hot block allocation */
+	unsigned int min_ssr_sections;	/* threshold to trigger SSR allocation */
 
 	/* for flush command control */
-	struct flush_cmd_control *cmd_control_info;
+	struct flush_cmd_control *fcc_info;
 
+	/* for discard command control */
+	struct discard_cmd_control *dcc_info;
 };
 
 /*
@@ -650,13 +912,17 @@ struct f2fs_sm_info {
  * f2fs monitors the number of several block types such as on-writeback,
  * dirty dentry blocks, dirty node blocks, and dirty meta blocks.
  */
+#define WB_DATA_TYPE(p)	(__is_cp_guaranteed(p) ? F2FS_WB_CP_DATA : F2FS_WB_DATA)
 enum count_type {
 	F2FS_DIRTY_DENTS,
 	F2FS_DIRTY_DATA,
+	F2FS_DIRTY_QDATA,
 	F2FS_DIRTY_NODES,
 	F2FS_DIRTY_META,
 	F2FS_INMEM_PAGES,
 	F2FS_DIRTY_IMETA,
+	F2FS_WB_CP_DATA,
+	F2FS_WB_DATA,
 	NR_COUNT_TYPE,
 };
 
@@ -680,35 +946,106 @@ enum page_type {
 	META_FLUSH,
 	INMEM,		/* the below types are used by tracepoints only. */
 	INMEM_DROP,
+	INMEM_INVALIDATE,
 	INMEM_REVOKE,
 	IPU,
 	OPU,
 };
 
+enum temp_type {
+	HOT = 0,	/* must be zero for meta bio */
+	WARM,
+	COLD,
+	NR_TEMP_TYPE,
+};
+
+enum need_lock_type {
+	LOCK_REQ = 0,
+	LOCK_DONE,
+	LOCK_RETRY,
+};
+
+enum cp_reason_type {
+	CP_NO_NEEDED,
+	CP_NON_REGULAR,
+	CP_HARDLINK,
+	CP_SB_NEED_CP,
+	CP_WRONG_PINO,
+	CP_NO_SPC_ROLL,
+	CP_NODE_NEED_CP,
+	CP_FASTBOOT_MODE,
+	CP_SPEC_LOG_NUM,
+	CP_RECOVER_DIR,
+};
+
+enum iostat_type {
+	APP_DIRECT_IO,			/* app direct IOs */
+	APP_BUFFERED_IO,		/* app buffered IOs */
+	APP_WRITE_IO,			/* app write IOs */
+	APP_MAPPED_IO,			/* app mapped IOs */
+	FS_DATA_IO,			/* data IOs from kworker/fsync/reclaimer */
+	FS_NODE_IO,			/* node IOs from kworker/fsync/reclaimer */
+	FS_META_IO,			/* meta IOs from kworker/reclaimer */
+	FS_GC_DATA_IO,			/* data IOs from forground gc */
+	FS_GC_NODE_IO,			/* node IOs from forground gc */
+	FS_CP_DATA_IO,			/* data IOs from checkpoint */
+	FS_CP_NODE_IO,			/* node IOs from checkpoint */
+	FS_CP_META_IO,			/* meta IOs from checkpoint */
+	FS_DISCARD,			/* discard */
+	NR_IO_TYPE,
+};
+
 struct f2fs_io_info {
 	struct f2fs_sb_info *sbi;	/* f2fs_sb_info pointer */
+	nid_t ino;		/* inode number */
 	enum page_type type;	/* contains DATA/NODE/META/META_FLUSH */
+	enum temp_type temp;	/* contains HOT/WARM/COLD */
 	int op;			/* contains REQ_OP_ */
-	int op_flags;		/* rq_flag_bits */
+	int op_flags;		/* req_flag_bits */
 	block_t new_blkaddr;	/* new block address to be written */
 	block_t old_blkaddr;	/* old block address before Cow */
 	struct page *page;	/* page to be written */
 	struct page *encrypted_page;	/* encrypted page */
+	struct list_head list;		/* serialize IOs */
+	bool submitted;		/* indicate IO submission */
+	int need_lock;		/* indicate we need to lock cp_rwsem */
+	bool in_list;		/* indicate fio is in io_list */
+	bool is_meta;		/* indicate borrow meta inode mapping or not */
+	bool retry;		/* need to reallocate block address */
+	enum iostat_type io_type;	/* io type */
+	struct writeback_control *io_wbc; /* writeback control */
 };
 
-#define is_read_io(rw) (rw == READ)
+#define is_read_io(rw) ((rw) == READ)
 struct f2fs_bio_info {
 	struct f2fs_sb_info *sbi;	/* f2fs superblock */
 	struct bio *bio;		/* bios to merge */
 	sector_t last_block_in_bio;	/* last block number */
 	struct f2fs_io_info fio;	/* store buffered io info. */
 	struct rw_semaphore io_rwsem;	/* blocking op for bio */
+	spinlock_t io_lock;		/* serialize DATA/NODE IOs */
+	struct list_head io_list;	/* track fios */
+};
+
+#define FDEV(i)				(sbi->devs[i])
+#define RDEV(i)				(raw_super->devs[i])
+struct f2fs_dev_info {
+	struct block_device *bdev;
+	char path[MAX_PATH_LEN];
+	unsigned int total_segments;
+	block_t start_blk;
+	block_t end_blk;
+#ifdef CONFIG_BLK_DEV_ZONED
+	unsigned int nr_blkz;			/* Total number of zones */
+	u8 *blkz_type;				/* Array of zones type */
+#endif
 };
 
 enum inode_type {
 	DIR_INODE,			/* for dirty dir inode */
 	FILE_INODE,			/* for dirty regular/symlink inode */
 	DIRTY_META,			/* for all dirtied inode metadata */
+	ATOMIC_FILE,			/* for all atomic files */
 	NR_INODE_TYPE,
 };
 
@@ -736,21 +1073,50 @@ enum {
 	MAX_TIME,
 };
 
+enum {
+	GC_NORMAL,
+	GC_IDLE_CB,
+	GC_IDLE_GREEDY,
+	GC_URGENT,
+};
+
+enum {
+	WHINT_MODE_OFF,		/* not pass down write hints */
+	WHINT_MODE_USER,	/* try to pass down hints given by users */
+	WHINT_MODE_FS,		/* pass down hints with F2FS policy */
+};
+
+enum {
+	ALLOC_MODE_DEFAULT,	/* stay default */
+	ALLOC_MODE_REUSE,	/* reuse segments as much as possible */
+};
+
+enum fsync_mode {
+	FSYNC_MODE_POSIX,	/* fsync follows posix semantics */
+	FSYNC_MODE_STRICT,	/* fsync behaves in line with ext4 */
+	FSYNC_MODE_NOBARRIER,	/* fsync behaves nobarrier based on posix */
+};
+
 #ifdef CONFIG_F2FS_FS_ENCRYPTION
-#define F2FS_KEY_DESC_PREFIX "f2fs:"
-#define F2FS_KEY_DESC_PREFIX_SIZE 5
+#define DUMMY_ENCRYPTION_ENABLED(sbi) \
+			(unlikely(F2FS_OPTION(sbi).test_dummy_encryption))
+#else
+#define DUMMY_ENCRYPTION_ENABLED(sbi) (0)
 #endif
+
 struct f2fs_sb_info {
 	struct super_block *sb;			/* pointer to VFS super block */
 	struct proc_dir_entry *s_proc;		/* proc entry */
 	struct f2fs_super_block *raw_super;	/* raw super block pointer */
+	struct rw_semaphore sb_lock;		/* lock for raw super block */
 	int valid_super_block;			/* valid super block no */
 	unsigned long s_flag;				/* flags for sbi */
 
-#ifdef CONFIG_F2FS_FS_ENCRYPTION
-	u8 key_prefix[F2FS_KEY_DESC_PREFIX_SIZE];
-	u8 key_prefix_size;
+#ifdef CONFIG_BLK_DEV_ZONED
+	unsigned int blocks_per_blkz;		/* F2FS blocks per zone */
+	unsigned int log_blocks_per_blkz;	/* log2 F2FS blocks per zone */
 #endif
+
 	/* for node-related operations */
 	struct f2fs_nm_info *nm_info;		/* node manager */
 	struct inode *node_inode;		/* cache node blocks */
@@ -759,9 +1125,12 @@ struct f2fs_sb_info {
 	struct f2fs_sm_info *sm_info;		/* segment manager */
 
 	/* for bio operations */
-	struct f2fs_bio_info read_io;			/* for read bios */
-	struct f2fs_bio_info write_io[NR_PAGE_TYPE];	/* for write bios */
-	struct mutex wio_mutex[NODE + 1];	/* bio ordering for NODE/DATA */
+	struct f2fs_bio_info *write_io[NR_PAGE_TYPE];	/* for write bios */
+	struct mutex wio_mutex[NR_PAGE_TYPE - 1][NR_TEMP_TYPE];
+						/* bio ordering for NODE/DATA */
+	/* keep migration IO order for LFS mode */
+	struct rw_semaphore io_order_lock;
+	mempool_t *write_io_dummy;		/* Dummy pages */
 
 	/* for checkpoint */
 	struct f2fs_checkpoint *ckpt;		/* raw checkpoint pointer */
@@ -771,6 +1140,7 @@ struct f2fs_sb_info {
 	struct mutex cp_mutex;			/* checkpoint procedure lock */
 	struct rw_semaphore cp_rwsem;		/* blocking FS operations */
 	struct rw_semaphore node_write;		/* locking node writes */
+	struct rw_semaphore node_change;	/* locking node change */
 	wait_queue_head_t cp_wait;
 	unsigned long last_time[MAX_TIME];	/* to store time in jiffies */
 	long interval_time[MAX_TIME];		/* to store thresholds */
@@ -786,7 +1156,7 @@ struct f2fs_sb_info {
 
 	/* for extent tree cache */
 	struct radix_tree_root extent_tree_root;/* cache extent cache entries */
-	struct rw_semaphore extent_tree_lock;	/* locking extent radix tree */
+	struct mutex extent_tree_lock;	/* locking extent radix tree */
 	struct list_head extent_list;		/* lru list for shrinker */
 	spinlock_t extent_lock;			/* locking extent lru list */
 	atomic_t total_ext_tree;		/* extent tree count */
@@ -809,21 +1179,29 @@ struct f2fs_sb_info {
 	unsigned int total_node_count;		/* total node block count */
 	unsigned int total_valid_node_count;	/* valid node block count */
 	loff_t max_file_blocks;			/* max block index of file */
-	int active_logs;			/* # of active logs */
 	int dir_level;				/* directory level */
+	unsigned int trigger_ssr_threshold;	/* threshold to trigger ssr */
+	int readdir_ra;				/* readahead inode in readdir */
 
 	block_t user_block_count;		/* # of user blocks */
 	block_t total_valid_block_count;	/* # of valid blocks */
 	block_t discard_blks;			/* discard command candidats */
 	block_t last_valid_block_count;		/* for recovery */
+	block_t reserved_blocks;		/* configurable reserved blocks */
+	block_t current_reserved_blocks;	/* current reserved blocks */
+
+	unsigned int nquota_files;		/* # of quota sysfile */
+
 	u32 s_next_generation;			/* for NFS support */
-	atomic_t nr_wb_bios;			/* # of writeback bios */
 
 	/* # of pages, see count_type */
 	atomic_t nr_pages[NR_COUNT_TYPE];
 	/* # of allocated blocks */
 	struct percpu_counter alloc_valid_block_count;
 
+	/* writeback control */
+	atomic_t wb_sync_req[META];	/* count # of WB_SYNC threads */
+
 	/* valid inode count */
 	struct percpu_counter total_valid_inode_count;
 
@@ -833,9 +1211,12 @@ struct f2fs_sb_info {
 	struct mutex gc_mutex;			/* mutex for GC */
 	struct f2fs_gc_kthread	*gc_thread;	/* GC thread */
 	unsigned int cur_victim_sec;		/* current victim section num */
+	unsigned int gc_mode;			/* current GC state */
+	/* for skip statistic */
+	unsigned long long skipped_atomic_files[2];	/* FG_GC and BG_GC */
 
-	/* threshold for converting bg victims for fg */
-	u64 fggc_threshold;
+	/* threshold for gc trials on pinned files */
+	u64 gc_pin_file_threshold;
 
 	/* maximum # of trials to find a victim segment for SSR and GC */
 	unsigned int max_victim_search;
@@ -856,18 +1237,30 @@ struct f2fs_sb_info {
 	atomic_t inline_xattr;			/* # of inline_xattr inodes */
 	atomic_t inline_inode;			/* # of inline_data inodes */
 	atomic_t inline_dir;			/* # of inline_dentry inodes */
+	atomic_t aw_cnt;			/* # of atomic writes */
+	atomic_t vw_cnt;			/* # of volatile writes */
+	atomic_t max_aw_cnt;			/* max # of atomic writes */
+	atomic_t max_vw_cnt;			/* max # of volatile writes */
 	int bg_gc;				/* background gc calls */
 	unsigned int ndirty_inode[NR_INODE_TYPE];	/* # of dirty inodes */
 #endif
-	unsigned int last_victim[2];		/* last victim segment # */
 	spinlock_t stat_lock;			/* lock for stat operations */
 
+	/* For app/fs IO statistics */
+	spinlock_t iostat_lock;
+	unsigned long long write_iostat[NR_IO_TYPE];
+	bool iostat_enable;
+
 	/* For sysfs suppport */
 	struct kobject s_kobj;
 	struct completion s_kobj_unregister;
 
 	/* For shrinker support */
 	struct list_head s_list;
+	int s_ndevs;				/* number of devices */
+	struct f2fs_dev_info *devs;		/* for device list */
+	unsigned int dirty_device;		/* for checkpoint data flush */
+	spinlock_t dev_lock;			/* protect dirty_device */
 	struct mutex umount_mutex;
 	unsigned int shrinker_run_no;
 
@@ -878,16 +1271,18 @@ struct f2fs_sb_info {
 	/* Reference to checksum algorithm driver via cryptoapi */
 	struct crypto_shash *s_chksum_driver;
 
-	/* For fault injection */
-#ifdef CONFIG_F2FS_FAULT_INJECTION
-	struct f2fs_fault_info fault_info;
-#endif
+	/* Precomputed FS UUID checksum for seeding other checksums */
+	__u32 s_chksum_seed;
 };
 
 #ifdef CONFIG_F2FS_FAULT_INJECTION
+#define f2fs_show_injection_info(type)				\
+	printk("%sF2FS-fs : inject %s in %s of %pF\n",		\
+		KERN_INFO, fault_name[type],			\
+		__func__, __builtin_return_address(0))
 static inline bool time_to_inject(struct f2fs_sb_info *sbi, int type)
 {
-	struct f2fs_fault_info *ffi = &sbi->fault_info;
+	struct f2fs_fault_info *ffi = &F2FS_OPTION(sbi).fault_info;
 
 	if (!ffi->inject_rate)
 		return false;
@@ -898,10 +1293,6 @@ static inline bool time_to_inject(struct f2fs_sb_info *sbi, int type)
 	atomic_inc(&ffi->inject_ops);
 	if (atomic_read(&ffi->inject_ops) >= ffi->inject_rate) {
 		atomic_set(&ffi->inject_ops, 0);
-		printk("%sF2FS-fs : inject %s in %pF\n",
-				KERN_INFO,
-				fault_name[type],
-				__builtin_return_address(0));
 		return true;
 	}
 	return false;
@@ -912,8 +1303,8 @@ static inline bool time_to_inject(struct f2fs_sb_info *sbi, int type)
  * and the return value is in kbytes. s is of struct f2fs_sb_info.
  */
 #define BD_PART_WRITTEN(s)						 \
-(((u64)part_stat_read(s->sb->s_bdev->bd_part, sectors[1]) -		 \
-		s->sectors_written_start) >> 1)
+(((u64)part_stat_read((s)->sb->s_bdev->bd_part, sectors[1]) -		 \
+		(s)->sectors_written_start) >> 1)
 
 static inline void f2fs_update_time(struct f2fs_sb_info *sbi, int type)
 {
@@ -922,8 +1313,7 @@ static inline void f2fs_update_time(struct f2fs_sb_info *sbi, int type)
 
 static inline bool f2fs_time_over(struct f2fs_sb_info *sbi, int type)
 {
-	struct timespec ts = {sbi->interval_time[type], 0};
-	unsigned long interval = timespec_to_jiffies(&ts);
+	unsigned long interval = sbi->interval_time[type] * HZ;
 
 	return time_after(jiffies, sbi->last_time[type] + interval);
 }
@@ -943,24 +1333,31 @@ static inline bool is_idle(struct f2fs_sb_info *sbi)
 /*
  * Inline functions
  */
-static inline u32 f2fs_crc32(struct f2fs_sb_info *sbi, const void *address,
-			   unsigned int length)
+static inline u32 __f2fs_crc32(struct f2fs_sb_info *sbi, u32 crc,
+			      const void *address, unsigned int length)
 {
-	SHASH_DESC_ON_STACK(shash, sbi->s_chksum_driver);
-	u32 *ctx = (u32 *)shash_desc_ctx(shash);
-	u32 retval;
+	struct {
+		struct shash_desc shash;
+		char ctx[4];
+	} desc;
 	int err;
 
-	shash->tfm = sbi->s_chksum_driver;
-	shash->flags = 0;
-	*ctx = F2FS_SUPER_MAGIC;
+	BUG_ON(crypto_shash_descsize(sbi->s_chksum_driver) != sizeof(desc.ctx));
+
+	desc.shash.tfm = sbi->s_chksum_driver;
+	desc.shash.flags = 0;
+	*(u32 *)desc.ctx = crc;
 
-	err = crypto_shash_update(shash, address, length);
+	err = crypto_shash_update(&desc.shash, address, length);
 	BUG_ON(err);
 
-	retval = *ctx;
-	barrier_data(ctx);
-	return retval;
+	return *(u32 *)desc.ctx;
+}
+
+static inline u32 f2fs_crc32(struct f2fs_sb_info *sbi, const void *address,
+			   unsigned int length)
+{
+	return __f2fs_crc32(sbi, F2FS_SUPER_MAGIC, address, length);
 }
 
 static inline bool f2fs_crc_valid(struct f2fs_sb_info *sbi, __u32 blk_crc,
@@ -969,6 +1366,12 @@ static inline bool f2fs_crc_valid(struct f2fs_sb_info *sbi, __u32 blk_crc,
 	return f2fs_crc32(sbi, buf, buf_size) == blk_crc;
 }
 
+static inline u32 f2fs_chksum(struct f2fs_sb_info *sbi, u32 crc,
+			      const void *address, unsigned int length)
+{
+	return __f2fs_crc32(sbi, crc, address, length);
+}
+
 static inline struct f2fs_inode_info *F2FS_I(struct inode *inode)
 {
 	return container_of(inode, struct f2fs_inode_info, vfs_inode);
@@ -1069,6 +1472,19 @@ static inline unsigned long long cur_cp_version(struct f2fs_checkpoint *cp)
 	return le64_to_cpu(cp->checkpoint_ver);
 }
 
+static inline unsigned long f2fs_qf_ino(struct super_block *sb, int type)
+{
+	if (type < F2FS_MAX_QUOTAS)
+		return le32_to_cpu(F2FS_SB(sb)->raw_super->qf_ino[type]);
+	return 0;
+}
+
+static inline __u64 cur_cp_crc(struct f2fs_checkpoint *cp)
+{
+	size_t crc_offset = le32_to_cpu(cp->checksum_offset);
+	return le32_to_cpu(*((__le32 *)((unsigned char *)cp + crc_offset)));
+}
+
 static inline bool __is_set_ckpt_flags(struct f2fs_checkpoint *cp, unsigned int f)
 {
 	unsigned int ckpt_flags = le32_to_cpu(cp->ckpt_flags);
@@ -1092,9 +1508,11 @@ static inline void __set_ckpt_flags(struct f2fs_checkpoint *cp, unsigned int f)
 
 static inline void set_ckpt_flags(struct f2fs_sb_info *sbi, unsigned int f)
 {
-	spin_lock(&sbi->cp_lock);
+	unsigned long flags;
+
+	spin_lock_irqsave(&sbi->cp_lock, flags);
 	__set_ckpt_flags(F2FS_CKPT(sbi), f);
-	spin_unlock(&sbi->cp_lock);
+	spin_unlock_irqrestore(&sbi->cp_lock, flags);
 }
 
 static inline void __clear_ckpt_flags(struct f2fs_checkpoint *cp, unsigned int f)
@@ -1108,16 +1526,34 @@ static inline void __clear_ckpt_flags(struct f2fs_checkpoint *cp, unsigned int f
 
 static inline void clear_ckpt_flags(struct f2fs_sb_info *sbi, unsigned int f)
 {
-	spin_lock(&sbi->cp_lock);
+	unsigned long flags;
+
+	spin_lock_irqsave(&sbi->cp_lock, flags);
 	__clear_ckpt_flags(F2FS_CKPT(sbi), f);
-	spin_unlock(&sbi->cp_lock);
+	spin_unlock_irqrestore(&sbi->cp_lock, flags);
 }
 
-static inline bool f2fs_discard_en(struct f2fs_sb_info *sbi)
+static inline void disable_nat_bits(struct f2fs_sb_info *sbi, bool lock)
 {
-	struct request_queue *q = bdev_get_queue(sbi->sb->s_bdev);
+	unsigned long flags;
+
+	set_sbi_flag(sbi, SBI_NEED_FSCK);
+
+	if (lock)
+		spin_lock_irqsave(&sbi->cp_lock, flags);
+	__clear_ckpt_flags(F2FS_CKPT(sbi), CP_NAT_BITS_FLAG);
+	kfree(NM_I(sbi)->nat_bits);
+	NM_I(sbi)->nat_bits = NULL;
+	if (lock)
+		spin_unlock_irqrestore(&sbi->cp_lock, flags);
+}
 
-	return blk_queue_discard(q);
+static inline bool enabled_nat_bits(struct f2fs_sb_info *sbi,
+					struct cp_control *cpc)
+{
+	bool set = is_set_ckpt_flags(sbi, CP_NAT_BITS_FLAG);
+
+	return (cpc) ? (cpc->reason & CP_UMOUNT) && set : set;
 }
 
 static inline void f2fs_lock_op(struct f2fs_sb_info *sbi)
@@ -1125,6 +1561,11 @@ static inline void f2fs_lock_op(struct f2fs_sb_info *sbi)
 	down_read(&sbi->cp_rwsem);
 }
 
+static inline int f2fs_trylock_op(struct f2fs_sb_info *sbi)
+{
+	return down_read_trylock(&sbi->cp_rwsem);
+}
+
 static inline void f2fs_unlock_op(struct f2fs_sb_info *sbi)
 {
 	up_read(&sbi->cp_rwsem);
@@ -1153,7 +1594,7 @@ static inline int __get_cp_reason(struct f2fs_sb_info *sbi)
 
 static inline bool __remain_node_summaries(int reason)
 {
-	return (reason == CP_UMOUNT || reason == CP_FASTBOOT);
+	return (reason & (CP_UMOUNT | CP_FASTBOOT));
 }
 
 static inline bool __exist_node_summaries(struct f2fs_sb_info *sbi)
@@ -1163,28 +1604,13 @@ static inline bool __exist_node_summaries(struct f2fs_sb_info *sbi)
 }
 
 /*
- * Check whether the given nid is within node id range.
- */
-static inline int check_nid_range(struct f2fs_sb_info *sbi, nid_t nid)
-{
-	if (unlikely(nid < F2FS_ROOT_INO(sbi)))
-		return -EINVAL;
-	if (unlikely(nid >= NM_I(sbi)->max_nid))
-		return -EINVAL;
-	return 0;
-}
-
-#define F2FS_DEFAULT_ALLOCATED_BLOCKS	1
-
-/*
  * Check whether the inode has blocks or not
  */
 static inline int F2FS_HAS_BLOCKS(struct inode *inode)
 {
-	if (F2FS_I(inode)->i_xattr_nid)
-		return inode->i_blocks > F2FS_DEFAULT_ALLOCATED_BLOCKS + 1;
-	else
-		return inode->i_blocks > F2FS_DEFAULT_ALLOCATED_BLOCKS;
+	block_t xattr_block = F2FS_I(inode)->i_xattr_nid ? 1 : 0;
+
+	return (inode->i_blocks >> F2FS_LOG_SECTORS_PER_BLOCK) > xattr_block;
 }
 
 static inline bool f2fs_has_xattr_block(unsigned int ofs)
@@ -1192,15 +1618,43 @@ static inline bool f2fs_has_xattr_block(unsigned int ofs)
 	return ofs == XATTR_NODE_OFFSET;
 }
 
-static inline void f2fs_i_blocks_write(struct inode *, blkcnt_t, bool);
-static inline bool inc_valid_block_count(struct f2fs_sb_info *sbi,
+static inline bool __allow_reserved_blocks(struct f2fs_sb_info *sbi,
+					struct inode *inode, bool cap)
+{
+	if (!inode)
+		return true;
+	if (!test_opt(sbi, RESERVE_ROOT))
+		return false;
+	if (IS_NOQUOTA(inode))
+		return true;
+	if (uid_eq(F2FS_OPTION(sbi).s_resuid, current_fsuid()))
+		return true;
+	if (!gid_eq(F2FS_OPTION(sbi).s_resgid, GLOBAL_ROOT_GID) &&
+					in_group_p(F2FS_OPTION(sbi).s_resgid))
+		return true;
+	if (cap && capable(CAP_SYS_RESOURCE))
+		return true;
+	return false;
+}
+
+static inline void f2fs_i_blocks_write(struct inode *, block_t, bool, bool);
+static inline int inc_valid_block_count(struct f2fs_sb_info *sbi,
 				 struct inode *inode, blkcnt_t *count)
 {
-	blkcnt_t diff;
+	blkcnt_t diff = 0, release = 0;
+	block_t avail_user_block_count;
+	int ret;
+
+	ret = dquot_reserve_block(inode, *count);
+	if (ret)
+		return ret;
 
 #ifdef CONFIG_F2FS_FAULT_INJECTION
-	if (time_to_inject(sbi, FAULT_BLOCK))
-		return false;
+	if (time_to_inject(sbi, FAULT_BLOCK)) {
+		f2fs_show_injection_info(FAULT_BLOCK);
+		release = *count;
+		goto enospc;
+	}
 #endif
 	/*
 	 * let's increase this in prior to actual block count change in order
@@ -1210,39 +1664,61 @@ static inline bool inc_valid_block_count(struct f2fs_sb_info *sbi,
 
 	spin_lock(&sbi->stat_lock);
 	sbi->total_valid_block_count += (block_t)(*count);
-	if (unlikely(sbi->total_valid_block_count > sbi->user_block_count)) {
-		diff = sbi->total_valid_block_count - sbi->user_block_count;
+	avail_user_block_count = sbi->user_block_count -
+					sbi->current_reserved_blocks;
+
+	if (!__allow_reserved_blocks(sbi, inode, true))
+		avail_user_block_count -= F2FS_OPTION(sbi).root_reserved_blocks;
+
+	if (unlikely(sbi->total_valid_block_count > avail_user_block_count)) {
+		diff = sbi->total_valid_block_count - avail_user_block_count;
+		if (diff > *count)
+			diff = *count;
 		*count -= diff;
-		sbi->total_valid_block_count = sbi->user_block_count;
+		release = diff;
+		sbi->total_valid_block_count -= diff;
 		if (!*count) {
 			spin_unlock(&sbi->stat_lock);
 			percpu_counter_sub(&sbi->alloc_valid_block_count, diff);
-			return false;
+			goto enospc;
 		}
 	}
 	spin_unlock(&sbi->stat_lock);
 
-	f2fs_i_blocks_write(inode, *count, true);
-	return true;
+	if (unlikely(release))
+		dquot_release_reservation_block(inode, release);
+	f2fs_i_blocks_write(inode, *count, true, true);
+	return 0;
+
+enospc:
+	dquot_release_reservation_block(inode, release);
+	return -ENOSPC;
 }
 
 static inline void dec_valid_block_count(struct f2fs_sb_info *sbi,
 						struct inode *inode,
-						blkcnt_t count)
+						block_t count)
 {
+	blkcnt_t sectors = count << F2FS_LOG_SECTORS_PER_BLOCK;
+
 	spin_lock(&sbi->stat_lock);
 	f2fs_bug_on(sbi, sbi->total_valid_block_count < (block_t) count);
-	f2fs_bug_on(sbi, inode->i_blocks < count);
+	f2fs_bug_on(sbi, inode->i_blocks < sectors);
 	sbi->total_valid_block_count -= (block_t)count;
+	if (sbi->reserved_blocks &&
+		sbi->current_reserved_blocks < sbi->reserved_blocks)
+		sbi->current_reserved_blocks = min(sbi->reserved_blocks,
+					sbi->current_reserved_blocks + count);
 	spin_unlock(&sbi->stat_lock);
-	f2fs_i_blocks_write(inode, count, false);
+	f2fs_i_blocks_write(inode, count, false, true);
 }
 
 static inline void inc_page_count(struct f2fs_sb_info *sbi, int count_type)
 {
 	atomic_inc(&sbi->nr_pages[count_type]);
 
-	if (count_type == F2FS_DIRTY_DATA || count_type == F2FS_INMEM_PAGES)
+	if (count_type == F2FS_DIRTY_DATA || count_type == F2FS_INMEM_PAGES ||
+		count_type == F2FS_WB_CP_DATA || count_type == F2FS_WB_DATA)
 		return;
 
 	set_sbi_flag(sbi, SBI_IS_DIRTY);
@@ -1253,6 +1729,8 @@ static inline void inode_inc_dirty_pages(struct inode *inode)
 	atomic_inc(&F2FS_I(inode)->dirty_pages);
 	inc_page_count(F2FS_I_SB(inode), S_ISDIR(inode->i_mode) ?
 				F2FS_DIRTY_DENTS : F2FS_DIRTY_DATA);
+	if (IS_NOQUOTA(inode))
+		inc_page_count(F2FS_I_SB(inode), F2FS_DIRTY_QDATA);
 }
 
 static inline void dec_page_count(struct f2fs_sb_info *sbi, int count_type)
@@ -1269,6 +1747,8 @@ static inline void inode_dec_dirty_pages(struct inode *inode)
 	atomic_dec(&F2FS_I(inode)->dirty_pages);
 	dec_page_count(F2FS_I_SB(inode), S_ISDIR(inode->i_mode) ?
 				F2FS_DIRTY_DENTS : F2FS_DIRTY_DATA);
+	if (IS_NOQUOTA(inode))
+		dec_page_count(F2FS_I_SB(inode), F2FS_DIRTY_QDATA);
 }
 
 static inline s64 get_pages(struct f2fs_sb_info *sbi, int count_type)
@@ -1323,6 +1803,12 @@ static inline void *__bitmap_ptr(struct f2fs_sb_info *sbi, int flag)
 	struct f2fs_checkpoint *ckpt = F2FS_CKPT(sbi);
 	int offset;
 
+	if (is_set_ckpt_flags(sbi, CP_LARGE_NAT_BITMAP_FLAG)) {
+		offset = (flag == SIT_BITMAP) ?
+			le32_to_cpu(ckpt->nat_ver_bitmap_bytesize) : 0;
+		return &ckpt->sit_nat_version_bitmap + offset;
+	}
+
 	if (__cp_payload(sbi) > 0) {
 		if (flag == NAT_BITMAP)
 			return &ckpt->sit_nat_version_bitmap;
@@ -1363,51 +1849,84 @@ static inline block_t __start_sum_addr(struct f2fs_sb_info *sbi)
 	return le32_to_cpu(F2FS_CKPT(sbi)->cp_pack_start_sum);
 }
 
-static inline bool inc_valid_node_count(struct f2fs_sb_info *sbi,
-						struct inode *inode)
+static inline int inc_valid_node_count(struct f2fs_sb_info *sbi,
+					struct inode *inode, bool is_inode)
 {
 	block_t	valid_block_count;
 	unsigned int valid_node_count;
+	bool quota = inode && !is_inode;
+
+	if (quota) {
+		int ret = dquot_reserve_block(inode, 1);
+		if (ret)
+			return ret;
+	}
+
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	if (time_to_inject(sbi, FAULT_BLOCK)) {
+		f2fs_show_injection_info(FAULT_BLOCK);
+		goto enospc;
+	}
+#endif
 
 	spin_lock(&sbi->stat_lock);
 
-	valid_block_count = sbi->total_valid_block_count + 1;
+	valid_block_count = sbi->total_valid_block_count +
+					sbi->current_reserved_blocks + 1;
+
+	if (!__allow_reserved_blocks(sbi, inode, false))
+		valid_block_count += F2FS_OPTION(sbi).root_reserved_blocks;
+
 	if (unlikely(valid_block_count > sbi->user_block_count)) {
 		spin_unlock(&sbi->stat_lock);
-		return false;
+		goto enospc;
 	}
 
 	valid_node_count = sbi->total_valid_node_count + 1;
 	if (unlikely(valid_node_count > sbi->total_node_count)) {
 		spin_unlock(&sbi->stat_lock);
-		return false;
+		goto enospc;
 	}
 
-	if (inode)
-		f2fs_i_blocks_write(inode, 1, true);
-
 	sbi->total_valid_node_count++;
 	sbi->total_valid_block_count++;
 	spin_unlock(&sbi->stat_lock);
 
+	if (inode) {
+		if (is_inode)
+			f2fs_mark_inode_dirty_sync(inode, true);
+		else
+			f2fs_i_blocks_write(inode, 1, true, true);
+	}
+
 	percpu_counter_inc(&sbi->alloc_valid_block_count);
-	return true;
+	return 0;
+
+enospc:
+	if (quota)
+		dquot_release_reservation_block(inode, 1);
+	return -ENOSPC;
 }
 
 static inline void dec_valid_node_count(struct f2fs_sb_info *sbi,
-						struct inode *inode)
+					struct inode *inode, bool is_inode)
 {
 	spin_lock(&sbi->stat_lock);
 
 	f2fs_bug_on(sbi, !sbi->total_valid_block_count);
 	f2fs_bug_on(sbi, !sbi->total_valid_node_count);
-	f2fs_bug_on(sbi, !inode->i_blocks);
+	f2fs_bug_on(sbi, !is_inode && !inode->i_blocks);
 
-	f2fs_i_blocks_write(inode, 1, false);
 	sbi->total_valid_node_count--;
 	sbi->total_valid_block_count--;
+	if (sbi->reserved_blocks &&
+		sbi->current_reserved_blocks < sbi->reserved_blocks)
+		sbi->current_reserved_blocks++;
 
 	spin_unlock(&sbi->stat_lock);
+
+	if (!is_inode)
+		f2fs_i_blocks_write(inode, 1, false, true);
 }
 
 static inline unsigned int valid_node_count(struct f2fs_sb_info *sbi)
@@ -1435,17 +1954,33 @@ static inline struct page *f2fs_grab_cache_page(struct address_space *mapping,
 {
 #ifdef CONFIG_F2FS_FAULT_INJECTION
 	struct page *page = find_lock_page(mapping, index);
+
 	if (page)
 		return page;
 
-	if (time_to_inject(F2FS_M_SB(mapping), FAULT_PAGE_ALLOC))
+	if (time_to_inject(F2FS_M_SB(mapping), FAULT_PAGE_ALLOC)) {
+		f2fs_show_injection_info(FAULT_PAGE_ALLOC);
 		return NULL;
+	}
 #endif
 	if (!for_write)
 		return grab_cache_page(mapping, index);
 	return grab_cache_page_write_begin(mapping, index, AOP_FLAG_NOFS);
 }
 
+static inline struct page *f2fs_pagecache_get_page(
+				struct address_space *mapping, pgoff_t index,
+				int fgp_flags, gfp_t gfp_mask)
+{
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	if (time_to_inject(F2FS_M_SB(mapping), FAULT_PAGE_GET)) {
+		f2fs_show_injection_info(FAULT_PAGE_GET);
+		return NULL;
+	}
+#endif
+	return pagecache_get_page(mapping, index, fgp_flags, gfp_mask);
+}
+
 static inline void f2fs_copy_page(struct page *src, struct page *dst)
 {
 	char *src_kaddr = kmap(src);
@@ -1495,15 +2030,25 @@ static inline void *f2fs_kmem_cache_alloc(struct kmem_cache *cachep,
 	return entry;
 }
 
-static inline struct bio *f2fs_bio_alloc(int npages)
+static inline struct bio *f2fs_bio_alloc(struct f2fs_sb_info *sbi,
+						int npages, bool no_fail)
 {
 	struct bio *bio;
 
-	/* No failure on bio allocation */
-	bio = bio_alloc(GFP_NOIO, npages);
-	if (!bio)
-		bio = bio_alloc(GFP_NOIO | __GFP_NOFAIL, npages);
-	return bio;
+	if (no_fail) {
+		/* No failure on bio allocation */
+		bio = bio_alloc(GFP_NOIO, npages);
+		if (!bio)
+			bio = bio_alloc(GFP_NOIO | __GFP_NOFAIL, npages);
+		return bio;
+	}
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	if (time_to_inject(sbi, FAULT_ALLOC_BIO)) {
+		f2fs_show_injection_info(FAULT_ALLOC_BIO);
+		return NULL;
+	}
+#endif
+	return bio_alloc(GFP_KERNEL, npages);
 }
 
 static inline void f2fs_radix_tree_insert(struct radix_tree_root *root,
@@ -1518,22 +2063,42 @@ static inline void f2fs_radix_tree_insert(struct radix_tree_root *root,
 static inline bool IS_INODE(struct page *page)
 {
 	struct f2fs_node *p = F2FS_NODE(page);
+
 	return RAW_IS_INODE(p);
 }
 
+static inline int offset_in_addr(struct f2fs_inode *i)
+{
+	return (i->i_inline & F2FS_EXTRA_ATTR) ?
+			(le16_to_cpu(i->i_extra_isize) / sizeof(__le32)) : 0;
+}
+
 static inline __le32 *blkaddr_in_node(struct f2fs_node *node)
 {
 	return RAW_IS_INODE(node) ? node->i.i_addr : node->dn.addr;
 }
 
-static inline block_t datablock_addr(struct page *node_page,
-		unsigned int offset)
+static inline int f2fs_has_extra_attr(struct inode *inode);
+static inline block_t datablock_addr(struct inode *inode,
+			struct page *node_page, unsigned int offset)
 {
 	struct f2fs_node *raw_node;
 	__le32 *addr_array;
+	int base = 0;
+	bool is_inode = IS_INODE(node_page);
+
 	raw_node = F2FS_NODE(node_page);
+
+	/* from GC path only */
+	if (is_inode) {
+		if (!inode)
+			base = offset_in_addr(&raw_node->i);
+		else if (f2fs_has_extra_attr(inode))
+			base = get_extra_isize(inode);
+	}
+
 	addr_array = blkaddr_in_node(raw_node);
-	return le32_to_cpu(addr_array[offset]);
+	return le32_to_cpu(addr_array[base + offset]);
 }
 
 static inline int f2fs_test_bit(unsigned int nr, char *addr)
@@ -1596,6 +2161,71 @@ static inline void f2fs_change_bit(unsigned int nr, char *addr)
 	*addr ^= mask;
 }
 
+/*
+ * Inode flags
+ */
+#define F2FS_SECRM_FL			0x00000001 /* Secure deletion */
+#define F2FS_UNRM_FL			0x00000002 /* Undelete */
+#define F2FS_COMPR_FL			0x00000004 /* Compress file */
+#define F2FS_SYNC_FL			0x00000008 /* Synchronous updates */
+#define F2FS_IMMUTABLE_FL		0x00000010 /* Immutable file */
+#define F2FS_APPEND_FL			0x00000020 /* writes to file may only append */
+#define F2FS_NODUMP_FL			0x00000040 /* do not dump file */
+#define F2FS_NOATIME_FL			0x00000080 /* do not update atime */
+/* Reserved for compression usage... */
+#define F2FS_DIRTY_FL			0x00000100
+#define F2FS_COMPRBLK_FL		0x00000200 /* One or more compressed clusters */
+#define F2FS_NOCOMPR_FL			0x00000400 /* Don't compress */
+#define F2FS_ENCRYPT_FL			0x00000800 /* encrypted file */
+/* End compression flags --- maybe not all used */
+#define F2FS_INDEX_FL			0x00001000 /* hash-indexed directory */
+#define F2FS_IMAGIC_FL			0x00002000 /* AFS directory */
+#define F2FS_JOURNAL_DATA_FL		0x00004000 /* file data should be journaled */
+#define F2FS_NOTAIL_FL			0x00008000 /* file tail should not be merged */
+#define F2FS_DIRSYNC_FL			0x00010000 /* dirsync behaviour (directories only) */
+#define F2FS_TOPDIR_FL			0x00020000 /* Top of directory hierarchies*/
+#define F2FS_HUGE_FILE_FL               0x00040000 /* Set to each huge file */
+#define F2FS_EXTENTS_FL			0x00080000 /* Inode uses extents */
+#define F2FS_EA_INODE_FL	        0x00200000 /* Inode used for large EA */
+#define F2FS_EOFBLOCKS_FL		0x00400000 /* Blocks allocated beyond EOF */
+#define F2FS_INLINE_DATA_FL		0x10000000 /* Inode has inline data. */
+#define F2FS_PROJINHERIT_FL		0x20000000 /* Create with parents projid */
+#define F2FS_RESERVED_FL		0x80000000 /* reserved for ext4 lib */
+
+#define F2FS_FL_USER_VISIBLE		0x304BDFFF /* User visible flags */
+#define F2FS_FL_USER_MODIFIABLE		0x204BC0FF /* User modifiable flags */
+
+/* Flags we can manipulate with through F2FS_IOC_FSSETXATTR */
+#define F2FS_FL_XFLAG_VISIBLE		(F2FS_SYNC_FL | \
+					 F2FS_IMMUTABLE_FL | \
+					 F2FS_APPEND_FL | \
+					 F2FS_NODUMP_FL | \
+					 F2FS_NOATIME_FL | \
+					 F2FS_PROJINHERIT_FL)
+
+/* Flags that should be inherited by new inodes from their parent. */
+#define F2FS_FL_INHERITED (F2FS_SECRM_FL | F2FS_UNRM_FL | F2FS_COMPR_FL |\
+			   F2FS_SYNC_FL | F2FS_NODUMP_FL | F2FS_NOATIME_FL |\
+			   F2FS_NOCOMPR_FL | F2FS_JOURNAL_DATA_FL |\
+			   F2FS_NOTAIL_FL | F2FS_DIRSYNC_FL |\
+			   F2FS_PROJINHERIT_FL)
+
+/* Flags that are appropriate for regular files (all but dir-specific ones). */
+#define F2FS_REG_FLMASK		(~(F2FS_DIRSYNC_FL | F2FS_TOPDIR_FL))
+
+/* Flags that are appropriate for non-directories/regular files. */
+#define F2FS_OTHER_FLMASK	(F2FS_NODUMP_FL | F2FS_NOATIME_FL)
+
+static inline __u32 f2fs_mask_flags(umode_t mode, __u32 flags)
+{
+	if (S_ISDIR(mode))
+		return flags;
+	else if (S_ISREG(mode))
+		return flags & F2FS_REG_FLMASK;
+	else
+		return flags & F2FS_OTHER_FLMASK;
+}
+
 /* used for f2fs_inode_info->flags */
 enum {
 	FI_NEW_INODE,		/* indicate newly allocated inode */
@@ -1614,6 +2244,7 @@ enum {
 	FI_UPDATE_WRITE,	/* inode has in-place-update data */
 	FI_NEED_IPU,		/* used for ipu per file */
 	FI_ATOMIC_FILE,		/* indicate atomic file */
+	FI_ATOMIC_COMMIT,	/* indicate the state of atomical committing */
 	FI_VOLATILE_FILE,	/* indicate volatile file */
 	FI_FIRST_BLOCK_WRITTEN,	/* indicate #0 data block was written */
 	FI_DROP_CACHE,		/* drop dirty page cache */
@@ -1621,6 +2252,12 @@ enum {
 	FI_INLINE_DOTS,		/* indicate inline dot dentries */
 	FI_DO_DEFRAG,		/* indicate defragment is running */
 	FI_DIRTY_FILE,		/* indicate regular/symlink has dirty pages */
+	FI_NO_PREALLOC,		/* indicate skipped preallocated blocks */
+	FI_HOT_DATA,		/* indicate file is hot */
+	FI_EXTRA_ATTR,		/* indicate file has extra attribute */
+	FI_PROJ_INHERIT,	/* indicate file inherits projectid */
+	FI_PIN_FILE,		/* indicate file should not be gced */
+	FI_ATOMIC_REVOKE_REQUEST, /* request to drop atomic data */
 };
 
 static inline void __mark_inode_dirty_flag(struct inode *inode,
@@ -1630,11 +2267,13 @@ static inline void __mark_inode_dirty_flag(struct inode *inode,
 	case FI_INLINE_XATTR:
 	case FI_INLINE_DATA:
 	case FI_INLINE_DENTRY:
+	case FI_NEW_INODE:
 		if (set)
 			return;
 	case FI_DATA_EXIST:
 	case FI_INLINE_DOTS:
-		f2fs_mark_inode_dirty_sync(inode);
+	case FI_PIN_FILE:
+		f2fs_mark_inode_dirty_sync(inode, true);
 	}
 }
 
@@ -1661,7 +2300,7 @@ static inline void set_acl_inode(struct inode *inode, umode_t mode)
 {
 	F2FS_I(inode)->i_acl_mode = mode;
 	set_inode_flag(inode, FI_ACL_MODE);
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, false);
 }
 
 static inline void f2fs_i_links_write(struct inode *inode, bool inc)
@@ -1670,18 +2309,26 @@ static inline void f2fs_i_links_write(struct inode *inode, bool inc)
 		inc_nlink(inode);
 	else
 		drop_nlink(inode);
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, true);
 }
 
 static inline void f2fs_i_blocks_write(struct inode *inode,
-					blkcnt_t diff, bool add)
+					block_t diff, bool add, bool claim)
 {
 	bool clean = !is_inode_flag_set(inode, FI_DIRTY_INODE);
 	bool recover = is_inode_flag_set(inode, FI_AUTO_RECOVER);
 
-	inode->i_blocks = add ? inode->i_blocks + diff :
-				inode->i_blocks - diff;
-	f2fs_mark_inode_dirty_sync(inode);
+	/* add = 1, claim = 1 should be dquot_reserve_block in pair */
+	if (add) {
+		if (claim)
+			dquot_claim_block(inode, diff);
+		else
+			dquot_alloc_block_nofail(inode, diff);
+	} else {
+		dquot_free_block(inode, diff);
+	}
+
+	f2fs_mark_inode_dirty_sync(inode, true);
 	if (clean || recover)
 		set_inode_flag(inode, FI_AUTO_RECOVER);
 }
@@ -1695,34 +2342,34 @@ static inline void f2fs_i_size_write(struct inode *inode, loff_t i_size)
 		return;
 
 	i_size_write(inode, i_size);
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, true);
 	if (clean || recover)
 		set_inode_flag(inode, FI_AUTO_RECOVER);
 }
 
-static inline bool f2fs_skip_inode_update(struct inode *inode)
+static inline void f2fs_i_depth_write(struct inode *inode, unsigned int depth)
 {
-	if (!is_inode_flag_set(inode, FI_AUTO_RECOVER))
-		return false;
-	return F2FS_I(inode)->last_disk_size == i_size_read(inode);
+	F2FS_I(inode)->i_current_depth = depth;
+	f2fs_mark_inode_dirty_sync(inode, true);
 }
 
-static inline void f2fs_i_depth_write(struct inode *inode, unsigned int depth)
+static inline void f2fs_i_gc_failures_write(struct inode *inode,
+					unsigned int count)
 {
-	F2FS_I(inode)->i_current_depth = depth;
-	f2fs_mark_inode_dirty_sync(inode);
+	F2FS_I(inode)->i_gc_failures[GC_FAILURE_PIN] = count;
+	f2fs_mark_inode_dirty_sync(inode, true);
 }
 
 static inline void f2fs_i_xnid_write(struct inode *inode, nid_t xnid)
 {
 	F2FS_I(inode)->i_xattr_nid = xnid;
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, true);
 }
 
 static inline void f2fs_i_pino_write(struct inode *inode, nid_t pino)
 {
 	F2FS_I(inode)->i_pino = pino;
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, true);
 }
 
 static inline void get_inline_info(struct inode *inode, struct f2fs_inode *ri)
@@ -1739,6 +2386,10 @@ static inline void get_inline_info(struct inode *inode, struct f2fs_inode *ri)
 		set_bit(FI_DATA_EXIST, &fi->flags);
 	if (ri->i_inline & F2FS_INLINE_DOTS)
 		set_bit(FI_INLINE_DOTS, &fi->flags);
+	if (ri->i_inline & F2FS_EXTRA_ATTR)
+		set_bit(FI_EXTRA_ATTR, &fi->flags);
+	if (ri->i_inline & F2FS_PIN_FILE)
+		set_bit(FI_PIN_FILE, &fi->flags);
 }
 
 static inline void set_raw_inline(struct inode *inode, struct f2fs_inode *ri)
@@ -1755,6 +2406,15 @@ static inline void set_raw_inline(struct inode *inode, struct f2fs_inode *ri)
 		ri->i_inline |= F2FS_DATA_EXIST;
 	if (is_inode_flag_set(inode, FI_INLINE_DOTS))
 		ri->i_inline |= F2FS_INLINE_DOTS;
+	if (is_inode_flag_set(inode, FI_EXTRA_ATTR))
+		ri->i_inline |= F2FS_EXTRA_ATTR;
+	if (is_inode_flag_set(inode, FI_PIN_FILE))
+		ri->i_inline |= F2FS_PIN_FILE;
+}
+
+static inline int f2fs_has_extra_attr(struct inode *inode)
+{
+	return is_inode_flag_set(inode, FI_EXTRA_ATTR);
 }
 
 static inline int f2fs_has_inline_xattr(struct inode *inode)
@@ -1764,24 +2424,20 @@ static inline int f2fs_has_inline_xattr(struct inode *inode)
 
 static inline unsigned int addrs_per_inode(struct inode *inode)
 {
-	if (f2fs_has_inline_xattr(inode))
-		return DEF_ADDRS_PER_INODE - F2FS_INLINE_XATTR_ADDRS;
-	return DEF_ADDRS_PER_INODE;
+	return CUR_ADDRS_PER_INODE(inode) - get_inline_xattr_addrs(inode);
 }
 
-static inline void *inline_xattr_addr(struct page *page)
+static inline void *inline_xattr_addr(struct inode *inode, struct page *page)
 {
 	struct f2fs_inode *ri = F2FS_INODE(page);
+
 	return (void *)&(ri->i_addr[DEF_ADDRS_PER_INODE -
-					F2FS_INLINE_XATTR_ADDRS]);
+					get_inline_xattr_addrs(inode)]);
 }
 
 static inline int inline_xattr_size(struct inode *inode)
 {
-	if (f2fs_has_inline_xattr(inode))
-		return F2FS_INLINE_XATTR_ADDRS << 2;
-	else
-		return 0;
+	return get_inline_xattr_addrs(inode) * sizeof(__le32);
 }
 
 static inline int f2fs_has_inline_data(struct inode *inode)
@@ -1789,12 +2445,6 @@ static inline int f2fs_has_inline_data(struct inode *inode)
 	return is_inode_flag_set(inode, FI_INLINE_DATA);
 }
 
-static inline void f2fs_clear_inline_inode(struct inode *inode)
-{
-	clear_inode_flag(inode, FI_INLINE_DATA);
-	clear_inode_flag(inode, FI_DATA_EXIST);
-}
-
 static inline int f2fs_exist_data(struct inode *inode)
 {
 	return is_inode_flag_set(inode, FI_DATA_EXIST);
@@ -1805,11 +2455,21 @@ static inline int f2fs_has_inline_dots(struct inode *inode)
 	return is_inode_flag_set(inode, FI_INLINE_DOTS);
 }
 
+static inline bool f2fs_is_pinned_file(struct inode *inode)
+{
+	return is_inode_flag_set(inode, FI_PIN_FILE);
+}
+
 static inline bool f2fs_is_atomic_file(struct inode *inode)
 {
 	return is_inode_flag_set(inode, FI_ATOMIC_FILE);
 }
 
+static inline bool f2fs_is_commit_atomic_write(struct inode *inode)
+{
+	return is_inode_flag_set(inode, FI_ATOMIC_COMMIT);
+}
+
 static inline bool f2fs_is_volatile_file(struct inode *inode)
 {
 	return is_inode_flag_set(inode, FI_VOLATILE_FILE);
@@ -1825,10 +2485,12 @@ static inline bool f2fs_is_drop_cache(struct inode *inode)
 	return is_inode_flag_set(inode, FI_DROP_CACHE);
 }
 
-static inline void *inline_data_addr(struct page *page)
+static inline void *inline_data_addr(struct inode *inode, struct page *page)
 {
 	struct f2fs_inode *ri = F2FS_INODE(page);
-	return (void *)&(ri->i_addr[1]);
+	int extra_size = get_extra_isize(inode);
+
+	return (void *)&(ri->i_addr[extra_size + DEF_INLINE_RESERVED_SIZE]);
 }
 
 static inline int f2fs_has_inline_dentry(struct inode *inode)
@@ -1836,12 +2498,6 @@ static inline int f2fs_has_inline_dentry(struct inode *inode)
 	return is_inode_flag_set(inode, FI_INLINE_DENTRY);
 }
 
-static inline void f2fs_dentry_kunmap(struct inode *dir, struct page *page)
-{
-	if (!f2fs_has_inline_dentry(dir))
-		kunmap(page);
-}
-
 static inline int is_file(struct inode *inode, int type)
 {
 	return F2FS_I(inode)->i_advise & type;
@@ -1850,16 +2506,50 @@ static inline int is_file(struct inode *inode, int type)
 static inline void set_file(struct inode *inode, int type)
 {
 	F2FS_I(inode)->i_advise |= type;
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, true);
 }
 
 static inline void clear_file(struct inode *inode, int type)
 {
 	F2FS_I(inode)->i_advise &= ~type;
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, true);
 }
 
-static inline int f2fs_readonly(struct super_block *sb)
+static inline bool f2fs_skip_inode_update(struct inode *inode, int dsync)
+{
+	bool ret;
+
+	if (dsync) {
+		struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+
+		spin_lock(&sbi->inode_lock[DIRTY_META]);
+		ret = list_empty(&F2FS_I(inode)->gdirty_list);
+		spin_unlock(&sbi->inode_lock[DIRTY_META]);
+		return ret;
+	}
+	if (!is_inode_flag_set(inode, FI_AUTO_RECOVER) ||
+			file_keep_isize(inode) ||
+			i_size_read(inode) & ~PAGE_MASK)
+		return false;
+
+	if (!timespec_equal(F2FS_I(inode)->i_disk_time, &inode->i_atime))
+		return false;
+	if (!timespec_equal(F2FS_I(inode)->i_disk_time + 1, &inode->i_ctime))
+		return false;
+	if (!timespec_equal(F2FS_I(inode)->i_disk_time + 2, &inode->i_mtime))
+		return false;
+	if (!timespec_equal(F2FS_I(inode)->i_disk_time + 3,
+						&F2FS_I(inode)->i_crtime))
+		return false;
+
+	down_read(&F2FS_I(inode)->i_sem);
+	ret = F2FS_I(inode)->last_disk_size == i_size_read(inode);
+	up_read(&F2FS_I(inode)->i_sem);
+
+	return ret;
+}
+
+static inline bool f2fs_readonly(struct super_block *sb)
 {
 	return sb->s_flags & MS_RDONLY;
 }
@@ -1893,13 +2583,15 @@ static inline void *f2fs_kmalloc(struct f2fs_sb_info *sbi,
 					size_t size, gfp_t flags)
 {
 #ifdef CONFIG_F2FS_FAULT_INJECTION
-	if (time_to_inject(sbi, FAULT_KMALLOC))
+	if (time_to_inject(sbi, FAULT_KMALLOC)) {
+		f2fs_show_injection_info(FAULT_KMALLOC);
 		return NULL;
+	}
 #endif
 	return kmalloc(size, flags);
 }
 
-static inline void *f2fs_kvmalloc(size_t size, gfp_t flags)
+static inline void *kvmalloc(size_t size, gfp_t flags)
 {
 	void *ret;
 
@@ -1909,7 +2601,7 @@ static inline void *f2fs_kvmalloc(size_t size, gfp_t flags)
 	return ret;
 }
 
-static inline void *f2fs_kvzalloc(size_t size, gfp_t flags)
+static inline void *kvzalloc(size_t size, gfp_t flags)
 {
 	void *ret;
 
@@ -1919,102 +2611,195 @@ static inline void *f2fs_kvzalloc(size_t size, gfp_t flags)
 	return ret;
 }
 
-#define get_inode_mode(i) \
+static inline int wbc_to_write_flags(struct writeback_control *wbc)
+{
+	if (wbc->sync_mode == WB_SYNC_ALL)
+		return REQ_SYNC;
+	else if (wbc->for_kupdate || wbc->for_background)
+		return 0;
+
+	return 0;
+}
+
+static inline void *f2fs_kzalloc(struct f2fs_sb_info *sbi,
+					size_t size, gfp_t flags)
+{
+	return f2fs_kmalloc(sbi, size, flags | __GFP_ZERO);
+}
+
+static inline void *f2fs_kvmalloc(struct f2fs_sb_info *sbi,
+					size_t size, gfp_t flags)
+{
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	if (time_to_inject(sbi, FAULT_KVMALLOC)) {
+		f2fs_show_injection_info(FAULT_KVMALLOC);
+		return NULL;
+	}
+#endif
+	return kvmalloc(size, flags);
+}
+
+static inline void *f2fs_kvzalloc(struct f2fs_sb_info *sbi,
+					size_t size, gfp_t flags)
+{
+	return f2fs_kvmalloc(sbi, size, flags | __GFP_ZERO);
+}
+
+static inline int get_extra_isize(struct inode *inode)
+{
+	return F2FS_I(inode)->i_extra_isize / sizeof(__le32);
+}
+
+static inline int get_inline_xattr_addrs(struct inode *inode)
+{
+	return F2FS_I(inode)->i_inline_xattr_size;
+}
+
+#define f2fs_get_inode_mode(i) \
 	((is_inode_flag_set(i, FI_ACL_MODE)) ? \
 	 (F2FS_I(i)->i_acl_mode) : ((i)->i_mode))
 
-/* get offset of first page in next direct node */
-#define PGOFS_OF_NEXT_DNODE(pgofs, inode)				\
-	((pgofs < ADDRS_PER_INODE(inode)) ? ADDRS_PER_INODE(inode) :	\
-	(pgofs - ADDRS_PER_INODE(inode) + ADDRS_PER_BLOCK) /	\
-	ADDRS_PER_BLOCK * ADDRS_PER_BLOCK + ADDRS_PER_INODE(inode))
+#define F2FS_TOTAL_EXTRA_ATTR_SIZE			\
+	(offsetof(struct f2fs_inode, i_extra_end) -	\
+	offsetof(struct f2fs_inode, i_extra_isize))	\
+
+#define F2FS_OLD_ATTRIBUTE_SIZE	(offsetof(struct f2fs_inode, i_addr))
+#define F2FS_FITS_IN_INODE(f2fs_inode, extra_isize, field)		\
+		((offsetof(typeof(*f2fs_inode), field) +	\
+		sizeof((f2fs_inode)->field))			\
+		<= (F2FS_OLD_ATTRIBUTE_SIZE + extra_isize))	\
+
+static inline void f2fs_reset_iostat(struct f2fs_sb_info *sbi)
+{
+	int i;
+
+	spin_lock(&sbi->iostat_lock);
+	for (i = 0; i < NR_IO_TYPE; i++)
+		sbi->write_iostat[i] = 0;
+	spin_unlock(&sbi->iostat_lock);
+}
+
+static inline void f2fs_update_iostat(struct f2fs_sb_info *sbi,
+			enum iostat_type type, unsigned long long io_bytes)
+{
+	if (!sbi->iostat_enable)
+		return;
+	spin_lock(&sbi->iostat_lock);
+	sbi->write_iostat[type] += io_bytes;
+
+	if (type == APP_WRITE_IO || type == APP_DIRECT_IO)
+		sbi->write_iostat[APP_BUFFERED_IO] =
+			sbi->write_iostat[APP_WRITE_IO] -
+			sbi->write_iostat[APP_DIRECT_IO];
+	spin_unlock(&sbi->iostat_lock);
+}
+
+static inline bool is_valid_blkaddr(block_t blkaddr)
+{
+	if (blkaddr == NEW_ADDR || blkaddr == NULL_ADDR)
+		return false;
+	return true;
+}
 
 /*
  * file.c
  */
-int f2fs_sync_file(struct file *, loff_t, loff_t, int);
-void truncate_data_blocks(struct dnode_of_data *);
-int truncate_blocks(struct inode *, u64, bool);
-int f2fs_truncate(struct inode *);
-int f2fs_getattr(struct vfsmount *, struct dentry *, struct kstat *);
-int f2fs_setattr(struct dentry *, struct iattr *);
-int truncate_hole(struct inode *, pgoff_t, pgoff_t);
-int truncate_data_blocks_range(struct dnode_of_data *, int);
-long f2fs_ioctl(struct file *, unsigned int, unsigned long);
-long f2fs_compat_ioctl(struct file *, unsigned int, unsigned long);
+int f2fs_sync_file(struct file *file, loff_t start, loff_t end, int datasync);
+void f2fs_truncate_data_blocks(struct dnode_of_data *dn);
+int f2fs_truncate_blocks(struct inode *inode, u64 from, bool lock);
+int f2fs_truncate(struct inode *inode);
+int f2fs_getattr(struct vfsmount *mnt, struct dentry *dentry,
+			struct kstat *stat);
+int f2fs_setattr(struct dentry *dentry, struct iattr *attr);
+int f2fs_truncate_hole(struct inode *inode, pgoff_t pg_start, pgoff_t pg_end);
+void f2fs_truncate_data_blocks_range(struct dnode_of_data *dn, int count);
+int f2fs_precache_extents(struct inode *inode);
+long f2fs_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
+long f2fs_compat_ioctl(struct file *file, unsigned int cmd, unsigned long arg);
+int f2fs_pin_file_control(struct inode *inode, bool inc);
 
 /*
  * inode.c
  */
-void f2fs_set_inode_flags(struct inode *);
-struct inode *f2fs_iget(struct super_block *, unsigned long);
-struct inode *f2fs_iget_retry(struct super_block *, unsigned long);
-int try_to_free_nats(struct f2fs_sb_info *, int);
-int update_inode(struct inode *, struct page *);
-int update_inode_page(struct inode *);
-int f2fs_write_inode(struct inode *, struct writeback_control *);
-void f2fs_evict_inode(struct inode *);
-void handle_failed_inode(struct inode *);
+void f2fs_set_inode_flags(struct inode *inode);
+bool f2fs_inode_chksum_verify(struct f2fs_sb_info *sbi, struct page *page);
+void f2fs_inode_chksum_set(struct f2fs_sb_info *sbi, struct page *page);
+struct inode *f2fs_iget(struct super_block *sb, unsigned long ino);
+struct inode *f2fs_iget_retry(struct super_block *sb, unsigned long ino);
+int f2fs_try_to_free_nats(struct f2fs_sb_info *sbi, int nr_shrink);
+void f2fs_update_inode(struct inode *inode, struct page *node_page);
+void f2fs_update_inode_page(struct inode *inode);
+int f2fs_write_inode(struct inode *inode, struct writeback_control *wbc);
+void f2fs_evict_inode(struct inode *inode);
+void f2fs_handle_failed_inode(struct inode *inode);
 
 /*
  * namei.c
  */
+int f2fs_update_extension_list(struct f2fs_sb_info *sbi, const char *name,
+							bool hot, bool set);
 struct dentry *f2fs_get_parent(struct dentry *child);
 
 /*
  * dir.c
  */
-void set_de_type(struct f2fs_dir_entry *, umode_t);
-unsigned char get_de_type(struct f2fs_dir_entry *);
-struct f2fs_dir_entry *find_target_dentry(struct fscrypt_name *,
-			f2fs_hash_t, int *, struct f2fs_dentry_ptr *);
-bool f2fs_fill_dentries(struct dir_context *, struct f2fs_dentry_ptr *,
-			unsigned int, struct fscrypt_str *);
-void do_make_empty_dir(struct inode *, struct inode *,
-			struct f2fs_dentry_ptr *);
-struct page *init_inode_metadata(struct inode *, struct inode *,
-		const struct qstr *, const struct qstr *, struct page *);
-void update_parent_metadata(struct inode *, struct inode *, unsigned int);
-int room_for_filename(const void *, int, int);
-void f2fs_drop_nlink(struct inode *, struct inode *);
-struct f2fs_dir_entry *__f2fs_find_entry(struct inode *, struct fscrypt_name *,
-							struct page **);
-struct f2fs_dir_entry *f2fs_find_entry(struct inode *, const struct qstr *,
-							struct page **);
-struct f2fs_dir_entry *f2fs_parent_dir(struct inode *, struct page **);
-ino_t f2fs_inode_by_name(struct inode *, const struct qstr *, struct page **);
-void f2fs_set_link(struct inode *, struct f2fs_dir_entry *,
-				struct page *, struct inode *);
-int update_dent_inode(struct inode *, struct inode *, const struct qstr *);
-void f2fs_update_dentry(nid_t ino, umode_t mode, struct f2fs_dentry_ptr *,
-			const struct qstr *, f2fs_hash_t , unsigned int);
-int f2fs_add_regular_entry(struct inode *, const struct qstr *,
-			const struct qstr *, struct inode *, nid_t, umode_t);
-int __f2fs_do_add_link(struct inode *, struct fscrypt_name*, struct inode *,
-			nid_t, umode_t);
-int __f2fs_add_link(struct inode *, const struct qstr *, struct inode *, nid_t,
-			umode_t);
-void f2fs_delete_entry(struct f2fs_dir_entry *, struct page *, struct inode *,
-							struct inode *);
-int f2fs_do_tmpfile(struct inode *, struct inode *);
-bool f2fs_empty_dir(struct inode *);
+unsigned char f2fs_get_de_type(struct f2fs_dir_entry *de);
+struct f2fs_dir_entry *f2fs_find_target_dentry(struct fscrypt_name *fname,
+			f2fs_hash_t namehash, int *max_slots,
+			struct f2fs_dentry_ptr *d);
+int f2fs_fill_dentries(struct dir_context *ctx, struct f2fs_dentry_ptr *d,
+			unsigned int start_pos, struct fscrypt_str *fstr);
+void f2fs_do_make_empty_dir(struct inode *inode, struct inode *parent,
+			struct f2fs_dentry_ptr *d);
+struct page *f2fs_init_inode_metadata(struct inode *inode, struct inode *dir,
+			const struct qstr *new_name,
+			const struct qstr *orig_name, struct page *dpage);
+void f2fs_update_parent_metadata(struct inode *dir, struct inode *inode,
+			unsigned int current_depth);
+int f2fs_room_for_filename(const void *bitmap, int slots, int max_slots);
+void f2fs_drop_nlink(struct inode *dir, struct inode *inode);
+struct f2fs_dir_entry *__f2fs_find_entry(struct inode *dir,
+			struct fscrypt_name *fname, struct page **res_page);
+struct f2fs_dir_entry *f2fs_find_entry(struct inode *dir,
+			const struct qstr *child, struct page **res_page);
+struct f2fs_dir_entry *f2fs_parent_dir(struct inode *dir, struct page **p);
+ino_t f2fs_inode_by_name(struct inode *dir, const struct qstr *qstr,
+			struct page **page);
+void f2fs_set_link(struct inode *dir, struct f2fs_dir_entry *de,
+			struct page *page, struct inode *inode);
+void f2fs_update_dentry(nid_t ino, umode_t mode, struct f2fs_dentry_ptr *d,
+			const struct qstr *name, f2fs_hash_t name_hash,
+			unsigned int bit_pos);
+int f2fs_add_regular_entry(struct inode *dir, const struct qstr *new_name,
+			const struct qstr *orig_name,
+			struct inode *inode, nid_t ino, umode_t mode);
+int f2fs_add_dentry(struct inode *dir, struct fscrypt_name *fname,
+			struct inode *inode, nid_t ino, umode_t mode);
+int f2fs_do_add_link(struct inode *dir, const struct qstr *name,
+			struct inode *inode, nid_t ino, umode_t mode);
+void f2fs_delete_entry(struct f2fs_dir_entry *dentry, struct page *page,
+			struct inode *dir, struct inode *inode);
+int f2fs_do_tmpfile(struct inode *inode, struct inode *dir);
+bool f2fs_empty_dir(struct inode *dir);
 
 static inline int f2fs_add_link(struct dentry *dentry, struct inode *inode)
 {
-	return __f2fs_add_link(d_inode(dentry->d_parent), &dentry->d_name,
+	return f2fs_do_add_link(d_inode(dentry->d_parent), &dentry->d_name,
 				inode, inode->i_ino, inode->i_mode);
 }
 
 /*
  * super.c
  */
-int f2fs_inode_dirtied(struct inode *);
-void f2fs_inode_synced(struct inode *);
-int f2fs_commit_super(struct f2fs_sb_info *, bool);
-int f2fs_sync_fs(struct super_block *, int);
+int f2fs_inode_dirtied(struct inode *inode, bool sync);
+void f2fs_inode_synced(struct inode *inode);
+int f2fs_enable_quota_files(struct f2fs_sb_info *sbi, bool rdonly);
+void f2fs_quota_off_umount(struct super_block *sb);
+int f2fs_commit_super(struct f2fs_sb_info *sbi, bool recover);
+int f2fs_sync_fs(struct super_block *sb, int sync);
 extern __printf(3, 4)
-void f2fs_msg(struct super_block *, const char *, const char *, ...);
-int sanity_check_ckpt(struct f2fs_sb_info *sbi);
+void f2fs_msg(struct super_block *sb, const char *level, const char *fmt, ...);
+int f2fs_sanity_check_ckpt(struct f2fs_sb_info *sbi);
 
 /*
  * hash.c
@@ -2028,160 +2813,208 @@ f2fs_hash_t f2fs_dentry_hash(const struct qstr *name_info,
 struct dnode_of_data;
 struct node_info;
 
-bool available_free_memory(struct f2fs_sb_info *, int);
-int need_dentry_mark(struct f2fs_sb_info *, nid_t);
-bool is_checkpointed_node(struct f2fs_sb_info *, nid_t);
-bool need_inode_block_update(struct f2fs_sb_info *, nid_t);
-void get_node_info(struct f2fs_sb_info *, nid_t, struct node_info *);
-pgoff_t get_next_page_offset(struct dnode_of_data *, pgoff_t);
-int get_dnode_of_data(struct dnode_of_data *, pgoff_t, int);
-int truncate_inode_blocks(struct inode *, pgoff_t);
-int truncate_xattr_node(struct inode *, struct page *);
-int wait_on_node_pages_writeback(struct f2fs_sb_info *, nid_t);
-int remove_inode_page(struct inode *);
-struct page *new_inode_page(struct inode *);
-struct page *new_node_page(struct dnode_of_data *, unsigned int, struct page *);
-void ra_node_page(struct f2fs_sb_info *, nid_t);
-struct page *get_node_page(struct f2fs_sb_info *, pgoff_t);
-struct page *get_node_page_ra(struct page *, int);
-void move_node_page(struct page *, int);
-int fsync_node_pages(struct f2fs_sb_info *, struct inode *,
-			struct writeback_control *, bool);
-int sync_node_pages(struct f2fs_sb_info *, struct writeback_control *);
-void build_free_nids(struct f2fs_sb_info *);
-bool alloc_nid(struct f2fs_sb_info *, nid_t *);
-void alloc_nid_done(struct f2fs_sb_info *, nid_t);
-void alloc_nid_failed(struct f2fs_sb_info *, nid_t);
-int try_to_free_nids(struct f2fs_sb_info *, int);
-void recover_inline_xattr(struct inode *, struct page *);
-void recover_xattr_data(struct inode *, struct page *, block_t);
-int recover_inode_page(struct f2fs_sb_info *, struct page *);
-int restore_node_summary(struct f2fs_sb_info *, unsigned int,
-				struct f2fs_summary_block *);
-void flush_nat_entries(struct f2fs_sb_info *);
-int build_node_manager(struct f2fs_sb_info *);
-void destroy_node_manager(struct f2fs_sb_info *);
-int __init create_node_manager_caches(void);
-void destroy_node_manager_caches(void);
+int f2fs_check_nid_range(struct f2fs_sb_info *sbi, nid_t nid);
+bool f2fs_available_free_memory(struct f2fs_sb_info *sbi, int type);
+int f2fs_need_dentry_mark(struct f2fs_sb_info *sbi, nid_t nid);
+bool f2fs_is_checkpointed_node(struct f2fs_sb_info *sbi, nid_t nid);
+bool f2fs_need_inode_block_update(struct f2fs_sb_info *sbi, nid_t ino);
+void f2fs_get_node_info(struct f2fs_sb_info *sbi, nid_t nid,
+						struct node_info *ni);
+pgoff_t f2fs_get_next_page_offset(struct dnode_of_data *dn, pgoff_t pgofs);
+int f2fs_get_dnode_of_data(struct dnode_of_data *dn, pgoff_t index, int mode);
+int f2fs_truncate_inode_blocks(struct inode *inode, pgoff_t from);
+int f2fs_truncate_xattr_node(struct inode *inode);
+int f2fs_wait_on_node_pages_writeback(struct f2fs_sb_info *sbi, nid_t ino);
+int f2fs_remove_inode_page(struct inode *inode);
+struct page *f2fs_new_inode_page(struct inode *inode);
+struct page *f2fs_new_node_page(struct dnode_of_data *dn, unsigned int ofs);
+void f2fs_ra_node_page(struct f2fs_sb_info *sbi, nid_t nid);
+struct page *f2fs_get_node_page(struct f2fs_sb_info *sbi, pgoff_t nid);
+struct page *f2fs_get_node_page_ra(struct page *parent, int start);
+void f2fs_move_node_page(struct page *node_page, int gc_type);
+int f2fs_fsync_node_pages(struct f2fs_sb_info *sbi, struct inode *inode,
+			struct writeback_control *wbc, bool atomic);
+int f2fs_sync_node_pages(struct f2fs_sb_info *sbi,
+			struct writeback_control *wbc,
+			bool do_balance, enum iostat_type io_type);
+void f2fs_build_free_nids(struct f2fs_sb_info *sbi, bool sync, bool mount);
+bool f2fs_alloc_nid(struct f2fs_sb_info *sbi, nid_t *nid);
+void f2fs_alloc_nid_done(struct f2fs_sb_info *sbi, nid_t nid);
+void f2fs_alloc_nid_failed(struct f2fs_sb_info *sbi, nid_t nid);
+int f2fs_try_to_free_nids(struct f2fs_sb_info *sbi, int nr_shrink);
+void f2fs_recover_inline_xattr(struct inode *inode, struct page *page);
+int f2fs_recover_xattr_data(struct inode *inode, struct page *page);
+int f2fs_recover_inode_page(struct f2fs_sb_info *sbi, struct page *page);
+void f2fs_restore_node_summary(struct f2fs_sb_info *sbi,
+			unsigned int segno, struct f2fs_summary_block *sum);
+void f2fs_flush_nat_entries(struct f2fs_sb_info *sbi, struct cp_control *cpc);
+int f2fs_build_node_manager(struct f2fs_sb_info *sbi);
+void f2fs_destroy_node_manager(struct f2fs_sb_info *sbi);
+int __init f2fs_create_node_manager_caches(void);
+void f2fs_destroy_node_manager_caches(void);
 
 /*
  * segment.c
  */
-void register_inmem_page(struct inode *, struct page *);
-void drop_inmem_pages(struct inode *);
-int commit_inmem_pages(struct inode *);
-void f2fs_balance_fs(struct f2fs_sb_info *, bool);
-void f2fs_balance_fs_bg(struct f2fs_sb_info *);
-int f2fs_issue_flush(struct f2fs_sb_info *);
-int create_flush_cmd_control(struct f2fs_sb_info *);
-void destroy_flush_cmd_control(struct f2fs_sb_info *);
-void invalidate_blocks(struct f2fs_sb_info *, block_t);
-bool is_checkpointed_data(struct f2fs_sb_info *, block_t);
-void refresh_sit_entry(struct f2fs_sb_info *, block_t, block_t);
-void f2fs_wait_all_discard_bio(struct f2fs_sb_info *);
-void clear_prefree_segments(struct f2fs_sb_info *, struct cp_control *);
-void release_discard_addrs(struct f2fs_sb_info *);
-int npages_for_summary_flush(struct f2fs_sb_info *, bool);
-void allocate_new_segments(struct f2fs_sb_info *);
-int f2fs_trim_fs(struct f2fs_sb_info *, struct fstrim_range *);
-struct page *get_sum_page(struct f2fs_sb_info *, unsigned int);
-void update_meta_page(struct f2fs_sb_info *, void *, block_t);
-void write_meta_page(struct f2fs_sb_info *, struct page *);
-void write_node_page(unsigned int, struct f2fs_io_info *);
-void write_data_page(struct dnode_of_data *, struct f2fs_io_info *);
-void rewrite_data_page(struct f2fs_io_info *);
-void __f2fs_replace_block(struct f2fs_sb_info *, struct f2fs_summary *,
-					block_t, block_t, bool, bool);
-void f2fs_replace_block(struct f2fs_sb_info *, struct dnode_of_data *,
-				block_t, block_t, unsigned char, bool, bool);
-void allocate_data_block(struct f2fs_sb_info *, struct page *,
-		block_t, block_t *, struct f2fs_summary *, int);
-void f2fs_wait_on_page_writeback(struct page *, enum page_type, bool);
-void f2fs_wait_on_encrypted_page_writeback(struct f2fs_sb_info *, block_t);
-void write_data_summaries(struct f2fs_sb_info *, block_t);
-void write_node_summaries(struct f2fs_sb_info *, block_t);
-int lookup_journal_in_cursum(struct f2fs_journal *, int, unsigned int, int);
-void flush_sit_entries(struct f2fs_sb_info *, struct cp_control *);
-int build_segment_manager(struct f2fs_sb_info *);
-void destroy_segment_manager(struct f2fs_sb_info *);
-int __init create_segment_manager_caches(void);
-void destroy_segment_manager_caches(void);
+bool f2fs_need_SSR(struct f2fs_sb_info *sbi);
+void f2fs_register_inmem_page(struct inode *inode, struct page *page);
+void f2fs_drop_inmem_pages_all(struct f2fs_sb_info *sbi, bool gc_failure);
+void f2fs_drop_inmem_pages(struct inode *inode);
+void f2fs_drop_inmem_page(struct inode *inode, struct page *page);
+int f2fs_commit_inmem_pages(struct inode *inode);
+void f2fs_balance_fs(struct f2fs_sb_info *sbi, bool need);
+void f2fs_balance_fs_bg(struct f2fs_sb_info *sbi);
+int f2fs_issue_flush(struct f2fs_sb_info *sbi, nid_t ino);
+int f2fs_create_flush_cmd_control(struct f2fs_sb_info *sbi);
+int f2fs_flush_device_cache(struct f2fs_sb_info *sbi);
+void f2fs_destroy_flush_cmd_control(struct f2fs_sb_info *sbi, bool free);
+void f2fs_invalidate_blocks(struct f2fs_sb_info *sbi, block_t addr);
+bool f2fs_is_checkpointed_data(struct f2fs_sb_info *sbi, block_t blkaddr);
+void f2fs_drop_discard_cmd(struct f2fs_sb_info *sbi);
+void f2fs_stop_discard_thread(struct f2fs_sb_info *sbi);
+bool f2fs_wait_discard_bios(struct f2fs_sb_info *sbi);
+void f2fs_clear_prefree_segments(struct f2fs_sb_info *sbi,
+					struct cp_control *cpc);
+void f2fs_release_discard_addrs(struct f2fs_sb_info *sbi);
+int f2fs_npages_for_summary_flush(struct f2fs_sb_info *sbi, bool for_ra);
+void f2fs_allocate_new_segments(struct f2fs_sb_info *sbi);
+int f2fs_trim_fs(struct f2fs_sb_info *sbi, struct fstrim_range *range);
+bool f2fs_exist_trim_candidates(struct f2fs_sb_info *sbi,
+					struct cp_control *cpc);
+struct page *f2fs_get_sum_page(struct f2fs_sb_info *sbi, unsigned int segno);
+void f2fs_update_meta_page(struct f2fs_sb_info *sbi, void *src,
+					block_t blk_addr);
+void f2fs_do_write_meta_page(struct f2fs_sb_info *sbi, struct page *page,
+						enum iostat_type io_type);
+void f2fs_do_write_node_page(unsigned int nid, struct f2fs_io_info *fio);
+void f2fs_outplace_write_data(struct dnode_of_data *dn,
+			struct f2fs_io_info *fio);
+int f2fs_inplace_write_data(struct f2fs_io_info *fio);
+void f2fs_do_replace_block(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
+			block_t old_blkaddr, block_t new_blkaddr,
+			bool recover_curseg, bool recover_newaddr);
+void f2fs_replace_block(struct f2fs_sb_info *sbi, struct dnode_of_data *dn,
+			block_t old_addr, block_t new_addr,
+			unsigned char version, bool recover_curseg,
+			bool recover_newaddr);
+void f2fs_allocate_data_block(struct f2fs_sb_info *sbi, struct page *page,
+			block_t old_blkaddr, block_t *new_blkaddr,
+			struct f2fs_summary *sum, int type,
+			struct f2fs_io_info *fio, bool add_list);
+void f2fs_wait_on_page_writeback(struct page *page,
+			enum page_type type, bool ordered);
+void f2fs_wait_on_block_writeback(struct f2fs_sb_info *sbi, block_t blkaddr);
+void f2fs_write_data_summaries(struct f2fs_sb_info *sbi, block_t start_blk);
+void f2fs_write_node_summaries(struct f2fs_sb_info *sbi, block_t start_blk);
+int f2fs_lookup_journal_in_cursum(struct f2fs_journal *journal, int type,
+			unsigned int val, int alloc);
+void f2fs_flush_sit_entries(struct f2fs_sb_info *sbi, struct cp_control *cpc);
+int f2fs_build_segment_manager(struct f2fs_sb_info *sbi);
+void f2fs_destroy_segment_manager(struct f2fs_sb_info *sbi);
+int __init f2fs_create_segment_manager_caches(void);
+void f2fs_destroy_segment_manager_caches(void);
+int f2fs_rw_hint_to_seg_type(enum rw_hint hint);
+enum rw_hint f2fs_io_type_to_rw_hint(struct f2fs_sb_info *sbi,
+			enum page_type type, enum temp_type temp);
 
 /*
  * checkpoint.c
  */
-void f2fs_stop_checkpoint(struct f2fs_sb_info *, bool);
-struct page *grab_meta_page(struct f2fs_sb_info *, pgoff_t);
-struct page *get_meta_page(struct f2fs_sb_info *, pgoff_t);
-struct page *get_tmp_page(struct f2fs_sb_info *, pgoff_t);
-bool is_valid_blkaddr(struct f2fs_sb_info *, block_t, int);
-int ra_meta_pages(struct f2fs_sb_info *, block_t, int, int, bool);
-void ra_meta_pages_cond(struct f2fs_sb_info *, pgoff_t);
-long sync_meta_pages(struct f2fs_sb_info *, enum page_type, long);
-void add_ino_entry(struct f2fs_sb_info *, nid_t, int type);
-void remove_ino_entry(struct f2fs_sb_info *, nid_t, int type);
-void release_ino_entry(struct f2fs_sb_info *, bool);
-bool exist_written_data(struct f2fs_sb_info *, nid_t, int);
-int f2fs_sync_inode_meta(struct f2fs_sb_info *);
-int acquire_orphan_inode(struct f2fs_sb_info *);
-void release_orphan_inode(struct f2fs_sb_info *);
-void add_orphan_inode(struct inode *);
-void remove_orphan_inode(struct f2fs_sb_info *, nid_t);
-int recover_orphan_inodes(struct f2fs_sb_info *);
-int get_valid_checkpoint(struct f2fs_sb_info *);
-void update_dirty_page(struct inode *, struct page *);
-void remove_dirty_inode(struct inode *);
-int sync_dirty_inodes(struct f2fs_sb_info *, enum inode_type);
-int write_checkpoint(struct f2fs_sb_info *, struct cp_control *);
-void init_ino_entry_info(struct f2fs_sb_info *);
-int __init create_checkpoint_caches(void);
-void destroy_checkpoint_caches(void);
+void f2fs_stop_checkpoint(struct f2fs_sb_info *sbi, bool end_io);
+struct page *f2fs_grab_meta_page(struct f2fs_sb_info *sbi, pgoff_t index);
+struct page *f2fs_get_meta_page(struct f2fs_sb_info *sbi, pgoff_t index);
+struct page *f2fs_get_tmp_page(struct f2fs_sb_info *sbi, pgoff_t index);
+bool f2fs_is_valid_meta_blkaddr(struct f2fs_sb_info *sbi,
+			block_t blkaddr, int type);
+int f2fs_ra_meta_pages(struct f2fs_sb_info *sbi, block_t start, int nrpages,
+			int type, bool sync);
+void f2fs_ra_meta_pages_cond(struct f2fs_sb_info *sbi, pgoff_t index);
+long f2fs_sync_meta_pages(struct f2fs_sb_info *sbi, enum page_type type,
+			long nr_to_write, enum iostat_type io_type);
+void f2fs_add_ino_entry(struct f2fs_sb_info *sbi, nid_t ino, int type);
+void f2fs_remove_ino_entry(struct f2fs_sb_info *sbi, nid_t ino, int type);
+void f2fs_release_ino_entry(struct f2fs_sb_info *sbi, bool all);
+bool f2fs_exist_written_data(struct f2fs_sb_info *sbi, nid_t ino, int mode);
+void f2fs_set_dirty_device(struct f2fs_sb_info *sbi, nid_t ino,
+					unsigned int devidx, int type);
+bool f2fs_is_dirty_device(struct f2fs_sb_info *sbi, nid_t ino,
+					unsigned int devidx, int type);
+int f2fs_sync_inode_meta(struct f2fs_sb_info *sbi);
+int f2fs_acquire_orphan_inode(struct f2fs_sb_info *sbi);
+void f2fs_release_orphan_inode(struct f2fs_sb_info *sbi);
+void f2fs_add_orphan_inode(struct inode *inode);
+void f2fs_remove_orphan_inode(struct f2fs_sb_info *sbi, nid_t ino);
+int f2fs_recover_orphan_inodes(struct f2fs_sb_info *sbi);
+int f2fs_get_valid_checkpoint(struct f2fs_sb_info *sbi);
+void f2fs_update_dirty_page(struct inode *inode, struct page *page);
+void f2fs_remove_dirty_inode(struct inode *inode);
+int f2fs_sync_dirty_inodes(struct f2fs_sb_info *sbi, enum inode_type type);
+int f2fs_write_checkpoint(struct f2fs_sb_info *sbi, struct cp_control *cpc);
+void f2fs_init_ino_entry_info(struct f2fs_sb_info *sbi);
+int __init f2fs_create_checkpoint_caches(void);
+void f2fs_destroy_checkpoint_caches(void);
 
 /*
  * data.c
  */
-void f2fs_submit_merged_bio(struct f2fs_sb_info *, enum page_type, int);
-void f2fs_submit_merged_bio_cond(struct f2fs_sb_info *, struct inode *,
-				struct page *, nid_t, enum page_type, int);
-void f2fs_flush_merged_bios(struct f2fs_sb_info *);
-int f2fs_submit_page_bio(struct f2fs_io_info *);
-void f2fs_submit_page_mbio(struct f2fs_io_info *);
-void set_data_blkaddr(struct dnode_of_data *);
-void f2fs_update_data_blkaddr(struct dnode_of_data *, block_t);
-int reserve_new_blocks(struct dnode_of_data *, blkcnt_t);
-int reserve_new_block(struct dnode_of_data *);
-int f2fs_get_block(struct dnode_of_data *, pgoff_t);
-ssize_t f2fs_preallocate_blocks(struct kiocb *, struct iov_iter *);
-int f2fs_reserve_block(struct dnode_of_data *, pgoff_t);
-struct page *get_read_data_page(struct inode *, pgoff_t, int, bool);
-struct page *find_data_page(struct inode *, pgoff_t);
-struct page *get_lock_data_page(struct inode *, pgoff_t, bool);
-struct page *get_new_data_page(struct inode *, struct page *, pgoff_t, bool);
-int do_write_data_page(struct f2fs_io_info *);
-int f2fs_map_blocks(struct inode *, struct f2fs_map_blocks *, int, int);
-int f2fs_fiemap(struct inode *inode, struct fiemap_extent_info *, u64, u64);
-void f2fs_set_page_dirty_nobuffers(struct page *);
-void f2fs_invalidate_page(struct page *, unsigned int, unsigned int);
-int f2fs_release_page(struct page *, gfp_t);
+int f2fs_init_post_read_processing(void);
+void f2fs_destroy_post_read_processing(void);
+void f2fs_submit_merged_write(struct f2fs_sb_info *sbi, enum page_type type);
+void f2fs_submit_merged_write_cond(struct f2fs_sb_info *sbi,
+				struct inode *inode, nid_t ino, pgoff_t idx,
+				enum page_type type);
+void f2fs_flush_merged_writes(struct f2fs_sb_info *sbi);
+int f2fs_submit_page_bio(struct f2fs_io_info *fio);
+void f2fs_submit_page_write(struct f2fs_io_info *fio);
+struct block_device *f2fs_target_device(struct f2fs_sb_info *sbi,
+			block_t blk_addr, struct bio *bio);
+int f2fs_target_device_index(struct f2fs_sb_info *sbi, block_t blkaddr);
+void f2fs_set_data_blkaddr(struct dnode_of_data *dn);
+void f2fs_update_data_blkaddr(struct dnode_of_data *dn, block_t blkaddr);
+int f2fs_reserve_new_blocks(struct dnode_of_data *dn, blkcnt_t count);
+int f2fs_reserve_new_block(struct dnode_of_data *dn);
+int f2fs_get_block(struct dnode_of_data *dn, pgoff_t index);
+int f2fs_preallocate_blocks(struct kiocb *iocb, struct iov_iter *from);
+int f2fs_reserve_block(struct dnode_of_data *dn, pgoff_t index);
+struct page *f2fs_get_read_data_page(struct inode *inode, pgoff_t index,
+			int op_flags, bool for_write);
+struct page *f2fs_find_data_page(struct inode *inode, pgoff_t index);
+struct page *f2fs_get_lock_data_page(struct inode *inode, pgoff_t index,
+			bool for_write);
+struct page *f2fs_get_new_data_page(struct inode *inode,
+			struct page *ipage, pgoff_t index, bool new_i_size);
+int f2fs_do_write_data_page(struct f2fs_io_info *fio);
+int f2fs_map_blocks(struct inode *inode, struct f2fs_map_blocks *map,
+			int create, int flag);
+int f2fs_fiemap(struct inode *inode, struct fiemap_extent_info *fieinfo,
+			u64 start, u64 len);
+bool f2fs_should_update_inplace(struct inode *inode, struct f2fs_io_info *fio);
+bool f2fs_should_update_outplace(struct inode *inode, struct f2fs_io_info *fio);
+void f2fs_invalidate_page(struct page *page, unsigned int offset,
+			unsigned int length);
+int f2fs_release_page(struct page *page, gfp_t wait);
 #ifdef CONFIG_MIGRATION
-int f2fs_migrate_page(struct address_space *, struct page *, struct page *,
-				enum migrate_mode);
+int f2fs_migrate_page(struct address_space *mapping, struct page *newpage,
+			struct page *page, enum migrate_mode mode);
 #endif
+bool f2fs_overwrite_io(struct inode *inode, loff_t pos, size_t len);
+void f2fs_clear_radix_tree_dirty_tag(struct page *page);
 
 /*
  * gc.c
  */
-int start_gc_thread(struct f2fs_sb_info *);
-void stop_gc_thread(struct f2fs_sb_info *);
-block_t start_bidx_of_node(unsigned int, struct inode *);
-int f2fs_gc(struct f2fs_sb_info *, bool);
-void build_gc_manager(struct f2fs_sb_info *);
+int f2fs_start_gc_thread(struct f2fs_sb_info *sbi);
+void f2fs_stop_gc_thread(struct f2fs_sb_info *sbi);
+block_t f2fs_start_bidx_of_node(unsigned int node_ofs, struct inode *inode);
+int f2fs_gc(struct f2fs_sb_info *sbi, bool sync, bool background,
+			unsigned int segno);
+void f2fs_build_gc_manager(struct f2fs_sb_info *sbi);
 
 /*
  * recovery.c
  */
-int recover_fsync_data(struct f2fs_sb_info *, bool);
-bool space_for_roll_forward(struct f2fs_sb_info *);
+int f2fs_recover_fsync_data(struct f2fs_sb_info *sbi, bool check_only);
+bool f2fs_space_for_roll_forward(struct f2fs_sb_info *sbi);
 
 /*
  * debug.c
@@ -2195,13 +3028,20 @@ struct f2fs_stat_info {
 	unsigned long long hit_largest, hit_cached, hit_rbtree;
 	unsigned long long hit_total, total_ext;
 	int ext_tree, zombie_tree, ext_node;
-	int ndirty_node, ndirty_dent, ndirty_meta, ndirty_data, ndirty_imeta;
+	int ndirty_node, ndirty_dent, ndirty_meta, ndirty_imeta;
+	int ndirty_data, ndirty_qdata;
 	int inmem_pages;
-	unsigned int ndirty_dirs, ndirty_files, ndirty_all;
-	int nats, dirty_nats, sits, dirty_sits, fnids;
+	unsigned int ndirty_dirs, ndirty_files, nquota_files, ndirty_all;
+	int nats, dirty_nats, sits, dirty_sits;
+	int free_nids, avail_nids, alloc_nids;
 	int total_count, utilization;
-	int bg_gc, wb_bios;
-	int inline_xattr, inline_inode, inline_dir, orphans;
+	int bg_gc, nr_wb_cp_data, nr_wb_data;
+	int nr_flushing, nr_flushed, flush_list_empty;
+	int nr_discarding, nr_discarded;
+	int nr_discard_cmd;
+	unsigned int undiscard_blks;
+	int inline_xattr, inline_inode, inline_dir, append, update, orphans;
+	int aw_cnt, max_aw_cnt, vw_cnt, max_vw_cnt;
 	unsigned int valid_count, valid_node_count, valid_inode_count, discard_blks;
 	unsigned int bimodal, avg_vblocks;
 	int util_free, util_valid, util_invalid;
@@ -2212,6 +3052,7 @@ struct f2fs_stat_info {
 	int bg_node_segs, bg_data_segs;
 	int tot_blks, data_blks, node_blks;
 	int bg_data_blks, bg_node_blks;
+	unsigned long long skipped_atomic_files[2];
 	int curseg[NR_CURSEG_TYPE];
 	int cursec[NR_CURSEG_TYPE];
 	int curzone[NR_CURSEG_TYPE];
@@ -2273,11 +3114,33 @@ static inline struct f2fs_stat_info *F2FS_STAT(struct f2fs_sb_info *sbi)
 		((sbi)->block_count[(curseg)->alloc_type]++)
 #define stat_inc_inplace_blocks(sbi)					\
 		(atomic_inc(&(sbi)->inplace_count))
+#define stat_inc_atomic_write(inode)					\
+		(atomic_inc(&F2FS_I_SB(inode)->aw_cnt))
+#define stat_dec_atomic_write(inode)					\
+		(atomic_dec(&F2FS_I_SB(inode)->aw_cnt))
+#define stat_update_max_atomic_write(inode)				\
+	do {								\
+		int cur = atomic_read(&F2FS_I_SB(inode)->aw_cnt);	\
+		int max = atomic_read(&F2FS_I_SB(inode)->max_aw_cnt);	\
+		if (cur > max)						\
+			atomic_set(&F2FS_I_SB(inode)->max_aw_cnt, cur);	\
+	} while (0)
+#define stat_inc_volatile_write(inode)					\
+		(atomic_inc(&F2FS_I_SB(inode)->vw_cnt))
+#define stat_dec_volatile_write(inode)					\
+		(atomic_dec(&F2FS_I_SB(inode)->vw_cnt))
+#define stat_update_max_volatile_write(inode)				\
+	do {								\
+		int cur = atomic_read(&F2FS_I_SB(inode)->vw_cnt);	\
+		int max = atomic_read(&F2FS_I_SB(inode)->max_vw_cnt);	\
+		if (cur > max)						\
+			atomic_set(&F2FS_I_SB(inode)->max_vw_cnt, cur);	\
+	} while (0)
 #define stat_inc_seg_count(sbi, type, gc_type)				\
 	do {								\
 		struct f2fs_stat_info *si = F2FS_STAT(sbi);		\
-		(si)->tot_segs++;					\
-		if (type == SUM_TYPE_DATA) {				\
+		si->tot_segs++;						\
+		if ((type) == SUM_TYPE_DATA) {				\
 			si->data_segs++;				\
 			si->bg_data_segs += (gc_type == BG_GC) ? 1 : 0;	\
 		} else {						\
@@ -2287,14 +3150,14 @@ static inline struct f2fs_stat_info *F2FS_STAT(struct f2fs_sb_info *sbi)
 	} while (0)
 
 #define stat_inc_tot_blk_count(si, blks)				\
-	(si->tot_blks += (blks))
+	((si)->tot_blks += (blks))
 
 #define stat_inc_data_blk_count(sbi, blks, gc_type)			\
 	do {								\
 		struct f2fs_stat_info *si = F2FS_STAT(sbi);		\
 		stat_inc_tot_blk_count(si, blks);			\
 		si->data_blks += (blks);				\
-		si->bg_data_blks += (gc_type == BG_GC) ? (blks) : 0;	\
+		si->bg_data_blks += ((gc_type) == BG_GC) ? (blks) : 0;	\
 	} while (0)
 
 #define stat_inc_node_blk_count(sbi, blks, gc_type)			\
@@ -2302,37 +3165,43 @@ static inline struct f2fs_stat_info *F2FS_STAT(struct f2fs_sb_info *sbi)
 		struct f2fs_stat_info *si = F2FS_STAT(sbi);		\
 		stat_inc_tot_blk_count(si, blks);			\
 		si->node_blks += (blks);				\
-		si->bg_node_blks += (gc_type == BG_GC) ? (blks) : 0;	\
+		si->bg_node_blks += ((gc_type) == BG_GC) ? (blks) : 0;	\
 	} while (0)
 
-int f2fs_build_stats(struct f2fs_sb_info *);
-void f2fs_destroy_stats(struct f2fs_sb_info *);
+int f2fs_build_stats(struct f2fs_sb_info *sbi);
+void f2fs_destroy_stats(struct f2fs_sb_info *sbi);
 int __init f2fs_create_root_stats(void);
 void f2fs_destroy_root_stats(void);
 #else
-#define stat_inc_cp_count(si)
-#define stat_inc_bg_cp_count(si)
-#define stat_inc_call_count(si)
-#define stat_inc_bggc_count(si)
-#define stat_inc_dirty_inode(sbi, type)
-#define stat_dec_dirty_inode(sbi, type)
-#define stat_inc_total_hit(sb)
-#define stat_inc_rbtree_node_hit(sb)
-#define stat_inc_largest_node_hit(sbi)
-#define stat_inc_cached_node_hit(sbi)
-#define stat_inc_inline_xattr(inode)
-#define stat_dec_inline_xattr(inode)
-#define stat_inc_inline_inode(inode)
-#define stat_dec_inline_inode(inode)
-#define stat_inc_inline_dir(inode)
-#define stat_dec_inline_dir(inode)
-#define stat_inc_seg_type(sbi, curseg)
-#define stat_inc_block_count(sbi, curseg)
-#define stat_inc_inplace_blocks(sbi)
-#define stat_inc_seg_count(sbi, type, gc_type)
-#define stat_inc_tot_blk_count(si, blks)
-#define stat_inc_data_blk_count(sbi, blks, gc_type)
-#define stat_inc_node_blk_count(sbi, blks, gc_type)
+#define stat_inc_cp_count(si)				do { } while (0)
+#define stat_inc_bg_cp_count(si)			do { } while (0)
+#define stat_inc_call_count(si)				do { } while (0)
+#define stat_inc_bggc_count(si)				do { } while (0)
+#define stat_inc_dirty_inode(sbi, type)			do { } while (0)
+#define stat_dec_dirty_inode(sbi, type)			do { } while (0)
+#define stat_inc_total_hit(sb)				do { } while (0)
+#define stat_inc_rbtree_node_hit(sb)			do { } while (0)
+#define stat_inc_largest_node_hit(sbi)			do { } while (0)
+#define stat_inc_cached_node_hit(sbi)			do { } while (0)
+#define stat_inc_inline_xattr(inode)			do { } while (0)
+#define stat_dec_inline_xattr(inode)			do { } while (0)
+#define stat_inc_inline_inode(inode)			do { } while (0)
+#define stat_dec_inline_inode(inode)			do { } while (0)
+#define stat_inc_inline_dir(inode)			do { } while (0)
+#define stat_dec_inline_dir(inode)			do { } while (0)
+#define stat_inc_atomic_write(inode)			do { } while (0)
+#define stat_dec_atomic_write(inode)			do { } while (0)
+#define stat_update_max_atomic_write(inode)		do { } while (0)
+#define stat_inc_volatile_write(inode)			do { } while (0)
+#define stat_dec_volatile_write(inode)			do { } while (0)
+#define stat_update_max_volatile_write(inode)		do { } while (0)
+#define stat_inc_seg_type(sbi, curseg)			do { } while (0)
+#define stat_inc_block_count(sbi, curseg)		do { } while (0)
+#define stat_inc_inplace_blocks(sbi)			do { } while (0)
+#define stat_inc_seg_count(sbi, type, gc_type)		do { } while (0)
+#define stat_inc_tot_blk_count(si, blks)		do { } while (0)
+#define stat_inc_data_blk_count(sbi, blks, gc_type)	do { } while (0)
+#define stat_inc_node_blk_count(sbi, blks, gc_type)	do { } while (0)
 
 static inline int f2fs_build_stats(struct f2fs_sb_info *sbi) { return 0; }
 static inline void f2fs_destroy_stats(struct f2fs_sb_info *sbi) { }
@@ -2350,56 +3219,84 @@ static inline void f2fs_destroy_root_stats(void) { }
 extern const struct inode_operations f2fs_symlink_inode_operations;
 extern const struct inode_operations f2fs_encrypted_symlink_inode_operations;
 extern const struct inode_operations f2fs_special_inode_operations;
-extern struct kmem_cache *inode_entry_slab;
+extern struct kmem_cache *f2fs_inode_entry_slab;
 
 /*
  * inline.c
  */
-bool f2fs_may_inline_data(struct inode *);
-bool f2fs_may_inline_dentry(struct inode *);
-void read_inline_data(struct page *, struct page *);
-bool truncate_inline_inode(struct page *, u64);
-int f2fs_read_inline_data(struct inode *, struct page *);
-int f2fs_convert_inline_page(struct dnode_of_data *, struct page *);
-int f2fs_convert_inline_inode(struct inode *);
-int f2fs_write_inline_data(struct inode *, struct page *);
-bool recover_inline_data(struct inode *, struct page *);
-struct f2fs_dir_entry *find_in_inline_dir(struct inode *,
-				struct fscrypt_name *, struct page **);
-int make_empty_inline_dir(struct inode *inode, struct inode *, struct page *);
-int f2fs_add_inline_entry(struct inode *, const struct qstr *,
-		const struct qstr *, struct inode *, nid_t, umode_t);
-void f2fs_delete_inline_entry(struct f2fs_dir_entry *, struct page *,
-						struct inode *, struct inode *);
-bool f2fs_empty_inline_dir(struct inode *);
-int f2fs_read_inline_dir(struct file *, struct dir_context *,
-						struct fscrypt_str *);
-int f2fs_inline_data_fiemap(struct inode *,
-		struct fiemap_extent_info *, __u64, __u64);
+bool f2fs_may_inline_data(struct inode *inode);
+bool f2fs_may_inline_dentry(struct inode *inode);
+void f2fs_do_read_inline_data(struct page *page, struct page *ipage);
+void f2fs_truncate_inline_inode(struct inode *inode,
+						struct page *ipage, u64 from);
+int f2fs_read_inline_data(struct inode *inode, struct page *page);
+int f2fs_convert_inline_page(struct dnode_of_data *dn, struct page *page);
+int f2fs_convert_inline_inode(struct inode *inode);
+int f2fs_write_inline_data(struct inode *inode, struct page *page);
+bool f2fs_recover_inline_data(struct inode *inode, struct page *npage);
+struct f2fs_dir_entry *f2fs_find_in_inline_dir(struct inode *dir,
+			struct fscrypt_name *fname, struct page **res_page);
+int f2fs_make_empty_inline_dir(struct inode *inode, struct inode *parent,
+			struct page *ipage);
+int f2fs_add_inline_entry(struct inode *dir, const struct qstr *new_name,
+			const struct qstr *orig_name,
+			struct inode *inode, nid_t ino, umode_t mode);
+void f2fs_delete_inline_entry(struct f2fs_dir_entry *dentry,
+				struct page *page, struct inode *dir,
+				struct inode *inode);
+bool f2fs_empty_inline_dir(struct inode *dir);
+int f2fs_read_inline_dir(struct file *file, struct dir_context *ctx,
+			struct fscrypt_str *fstr);
+int f2fs_inline_data_fiemap(struct inode *inode,
+			struct fiemap_extent_info *fieinfo,
+			__u64 start, __u64 len);
 
 /*
  * shrinker.c
  */
-unsigned long f2fs_shrink_count(struct shrinker *, struct shrink_control *);
-unsigned long f2fs_shrink_scan(struct shrinker *, struct shrink_control *);
-void f2fs_join_shrinker(struct f2fs_sb_info *);
-void f2fs_leave_shrinker(struct f2fs_sb_info *);
+unsigned long f2fs_shrink_count(struct shrinker *shrink,
+			struct shrink_control *sc);
+unsigned long f2fs_shrink_scan(struct shrinker *shrink,
+			struct shrink_control *sc);
+void f2fs_join_shrinker(struct f2fs_sb_info *sbi);
+void f2fs_leave_shrinker(struct f2fs_sb_info *sbi);
 
 /*
  * extent_cache.c
  */
-unsigned int f2fs_shrink_extent_tree(struct f2fs_sb_info *, int);
-bool f2fs_init_extent_tree(struct inode *, struct f2fs_extent *);
-void f2fs_drop_extent_tree(struct inode *);
-unsigned int f2fs_destroy_extent_node(struct inode *);
-void f2fs_destroy_extent_tree(struct inode *);
-bool f2fs_lookup_extent_cache(struct inode *, pgoff_t, struct extent_info *);
-void f2fs_update_extent_cache(struct dnode_of_data *);
+struct rb_entry *f2fs_lookup_rb_tree(struct rb_root *root,
+				struct rb_entry *cached_re, unsigned int ofs);
+struct rb_node **f2fs_lookup_rb_tree_for_insert(struct f2fs_sb_info *sbi,
+				struct rb_root *root, struct rb_node **parent,
+				unsigned int ofs);
+struct rb_entry *f2fs_lookup_rb_tree_ret(struct rb_root *root,
+		struct rb_entry *cached_re, unsigned int ofs,
+		struct rb_entry **prev_entry, struct rb_entry **next_entry,
+		struct rb_node ***insert_p, struct rb_node **insert_parent,
+		bool force);
+bool f2fs_check_rb_tree_consistence(struct f2fs_sb_info *sbi,
+						struct rb_root *root);
+unsigned int f2fs_shrink_extent_tree(struct f2fs_sb_info *sbi, int nr_shrink);
+bool f2fs_init_extent_tree(struct inode *inode, struct f2fs_extent *i_ext);
+void f2fs_drop_extent_tree(struct inode *inode);
+unsigned int f2fs_destroy_extent_node(struct inode *inode);
+void f2fs_destroy_extent_tree(struct inode *inode);
+bool f2fs_lookup_extent_cache(struct inode *inode, pgoff_t pgofs,
+			struct extent_info *ei);
+void f2fs_update_extent_cache(struct dnode_of_data *dn);
 void f2fs_update_extent_cache_range(struct dnode_of_data *dn,
-						pgoff_t, block_t, unsigned int);
-void init_extent_cache_info(struct f2fs_sb_info *);
-int __init create_extent_cache(void);
-void destroy_extent_cache(void);
+			pgoff_t fofs, block_t blkaddr, unsigned int len);
+void f2fs_init_extent_cache_info(struct f2fs_sb_info *sbi);
+int __init f2fs_create_extent_cache(void);
+void f2fs_destroy_extent_cache(void);
+
+/*
+ * sysfs.c
+ */
+int __init f2fs_init_sysfs(void);
+void f2fs_exit_sysfs(void);
+int f2fs_register_sysfs(struct f2fs_sb_info *sbi);
+void f2fs_unregister_sysfs(struct f2fs_sb_info *sbi);
 
 /*
  * crypto support
@@ -2409,26 +3306,63 @@ static inline bool f2fs_encrypted_inode(struct inode *inode)
 	return file_is_encrypt(inode);
 }
 
+static inline bool f2fs_encrypted_file(struct inode *inode)
+{
+	return f2fs_encrypted_inode(inode) && S_ISREG(inode->i_mode);
+}
+
 static inline void f2fs_set_encrypted_inode(struct inode *inode)
 {
 #ifdef CONFIG_F2FS_FS_ENCRYPTION
 	file_set_encrypt(inode);
+	inode->i_flags |= S_ENCRYPTED;
 #endif
 }
 
-static inline bool f2fs_bio_encrypted(struct bio *bio)
+/*
+ * Returns true if the reads of the inode's data need to undergo some
+ * postprocessing step, like decryption or authenticity verification.
+ */
+static inline bool f2fs_post_read_required(struct inode *inode)
 {
-	return bio->bi_private != NULL;
+	return f2fs_encrypted_file(inode);
+}
+
+#define F2FS_FEATURE_FUNCS(name, flagname) \
+static inline int f2fs_sb_has_##name(struct super_block *sb) \
+{ \
+	return F2FS_HAS_FEATURE(sb, F2FS_FEATURE_##flagname); \
 }
 
-static inline int f2fs_sb_has_crypto(struct super_block *sb)
+F2FS_FEATURE_FUNCS(encrypt, ENCRYPT);
+F2FS_FEATURE_FUNCS(blkzoned, BLKZONED);
+F2FS_FEATURE_FUNCS(extra_attr, EXTRA_ATTR);
+F2FS_FEATURE_FUNCS(project_quota, PRJQUOTA);
+F2FS_FEATURE_FUNCS(inode_chksum, INODE_CHKSUM);
+F2FS_FEATURE_FUNCS(flexible_inline_xattr, FLEXIBLE_INLINE_XATTR);
+F2FS_FEATURE_FUNCS(quota_ino, QUOTA_INO);
+F2FS_FEATURE_FUNCS(inode_crtime, INODE_CRTIME);
+F2FS_FEATURE_FUNCS(lost_found, LOST_FOUND);
+
+#ifdef CONFIG_BLK_DEV_ZONED
+static inline int get_blkz_type(struct f2fs_sb_info *sbi,
+			struct block_device *bdev, block_t blkaddr)
 {
-	return F2FS_HAS_FEATURE(sb, F2FS_FEATURE_ENCRYPT);
+	unsigned int zno = blkaddr >> sbi->log_blocks_per_blkz;
+	int i;
+
+	for (i = 0; i < sbi->s_ndevs; i++)
+		if (FDEV(i).bdev == bdev)
+			return FDEV(i).blkz_type[zno];
+	return -EINVAL;
 }
+#endif
 
-static inline int f2fs_sb_mounted_hmsmr(struct super_block *sb)
+static inline bool f2fs_discard_en(struct f2fs_sb_info *sbi)
 {
-	return F2FS_HAS_FEATURE(sb, F2FS_FEATURE_HMSMR);
+	struct request_queue *q = bdev_get_queue(sbi->sb->s_bdev);
+
+	return blk_queue_discard(q) || f2fs_sb_has_blkzoned(sbi->sb);
 }
 
 static inline void set_opt_mode(struct f2fs_sb_info *sbi, unsigned int mt)
@@ -2457,28 +3391,11 @@ static inline bool f2fs_may_encrypt(struct inode *inode)
 #endif
 }
 
-#ifndef CONFIG_F2FS_FS_ENCRYPTION
-#define fscrypt_set_d_op(i)
-#define fscrypt_get_ctx			fscrypt_notsupp_get_ctx
-#define fscrypt_release_ctx		fscrypt_notsupp_release_ctx
-#define fscrypt_encrypt_page		fscrypt_notsupp_encrypt_page
-#define fscrypt_decrypt_page		fscrypt_notsupp_decrypt_page
-#define fscrypt_decrypt_bio_pages	fscrypt_notsupp_decrypt_bio_pages
-#define fscrypt_pullback_bio_page	fscrypt_notsupp_pullback_bio_page
-#define fscrypt_restore_control_page	fscrypt_notsupp_restore_control_page
-#define fscrypt_zeroout_range		fscrypt_notsupp_zeroout_range
-#define fscrypt_process_policy		fscrypt_notsupp_process_policy
-#define fscrypt_get_policy		fscrypt_notsupp_get_policy
-#define fscrypt_has_permitted_context	fscrypt_notsupp_has_permitted_context
-#define fscrypt_inherit_context		fscrypt_notsupp_inherit_context
-#define fscrypt_get_encryption_info	fscrypt_notsupp_get_encryption_info
-#define fscrypt_put_encryption_info	fscrypt_notsupp_put_encryption_info
-#define fscrypt_setup_filename		fscrypt_notsupp_setup_filename
-#define fscrypt_free_filename		fscrypt_notsupp_free_filename
-#define fscrypt_fname_encrypted_size	fscrypt_notsupp_fname_encrypted_size
-#define fscrypt_fname_alloc_buffer	fscrypt_notsupp_fname_alloc_buffer
-#define fscrypt_fname_free_buffer	fscrypt_notsupp_fname_free_buffer
-#define fscrypt_fname_disk_to_usr	fscrypt_notsupp_fname_disk_to_usr
-#define fscrypt_fname_usr_to_disk	fscrypt_notsupp_fname_usr_to_disk
-#endif
+static inline bool f2fs_force_buffered_io(struct inode *inode, int rw)
+{
+	return (f2fs_post_read_required(inode) ||
+			(rw == WRITE && test_opt(F2FS_I_SB(inode), LFS)) ||
+			F2FS_I_SB(inode)->s_ndevs);
+}
+
 #endif
diff --git a/fs/f2fs/file.c b/fs/f2fs/file.c
index 7d0e8d6..1ac5f4d 100644
--- a/fs/f2fs/file.c
+++ b/fs/f2fs/file.c
@@ -20,6 +20,7 @@
 #include <linux/uaccess.h>
 #include <linux/mount.h>
 #include <linux/pagevec.h>
+#include <linux/uio.h>
 #include <linux/uuid.h>
 #include <linux/file.h>
 
@@ -32,6 +33,19 @@
 #include "trace.h"
 #include <trace/events/f2fs.h>
 
+static int f2fs_filemap_fault(struct vm_area_struct *vma,
+					struct vm_fault *vmf)
+{
+	struct inode *inode = file_inode(vma->vm_file);
+	int err;
+
+	down_read(&F2FS_I(inode)->i_mmap_sem);
+	err = filemap_fault(vma, vmf);
+	up_read(&F2FS_I(inode)->i_mmap_sem);
+
+	return err;
+}
+
 static int f2fs_vm_page_mkwrite(struct vm_area_struct *vma,
 						struct vm_fault *vmf)
 {
@@ -41,6 +55,11 @@ static int f2fs_vm_page_mkwrite(struct vm_area_struct *vma,
 	struct dnode_of_data dn;
 	int err;
 
+	if (unlikely(f2fs_cp_error(sbi))) {
+		err = -EIO;
+		goto err;
+	}
+
 	sb_start_pagefault(inode->i_sb);
 
 	f2fs_bug_on(sbi, f2fs_has_inline_data(inode));
@@ -59,13 +78,14 @@ static int f2fs_vm_page_mkwrite(struct vm_area_struct *vma,
 	f2fs_balance_fs(sbi, dn.node_changed);
 
 	file_update_time(vma->vm_file);
+	down_read(&F2FS_I(inode)->i_mmap_sem);
 	lock_page(page);
 	if (unlikely(page->mapping != inode->i_mapping ||
 			page_offset(page) > i_size_read(inode) ||
 			!PageUptodate(page))) {
 		unlock_page(page);
 		err = -EFAULT;
-		goto out;
+		goto out_sem;
 	}
 
 	/*
@@ -77,7 +97,8 @@ static int f2fs_vm_page_mkwrite(struct vm_area_struct *vma,
 	/* page is wholly or partially inside EOF */
 	if (((loff_t)(page->index + 1) << PAGE_SHIFT) >
 						i_size_read(inode)) {
-		unsigned offset;
+		loff_t offset;
+
 		offset = i_size_read(inode) & ~PAGE_MASK;
 		zero_user_segment(page, offset, PAGE_SIZE);
 	}
@@ -85,25 +106,28 @@ static int f2fs_vm_page_mkwrite(struct vm_area_struct *vma,
 	if (!PageUptodate(page))
 		SetPageUptodate(page);
 
+	f2fs_update_iostat(sbi, APP_MAPPED_IO, F2FS_BLKSIZE);
+
 	trace_f2fs_vm_page_mkwrite(page, DATA);
 mapped:
 	/* fill the page */
 	f2fs_wait_on_page_writeback(page, DATA, false);
 
-	/* wait for GCed encrypted page writeback */
-	if (f2fs_encrypted_inode(inode) && S_ISREG(inode->i_mode))
-		f2fs_wait_on_encrypted_page_writeback(sbi, dn.data_blkaddr);
+	/* wait for GCed page writeback via META_MAPPING */
+	if (f2fs_post_read_required(inode))
+		f2fs_wait_on_block_writeback(sbi, dn.data_blkaddr);
 
-	/* if gced page is attached, don't write to cold segment */
-	clear_cold_data(page);
+out_sem:
+	up_read(&F2FS_I(inode)->i_mmap_sem);
 out:
 	sb_end_pagefault(inode->i_sb);
 	f2fs_update_time(sbi, REQ_TIME);
+err:
 	return block_page_mkwrite_return(err);
 }
 
 static const struct vm_operations_struct f2fs_file_vm_ops = {
-	.fault		= filemap_fault,
+	.fault		= f2fs_filemap_fault,
 	.map_pages	= filemap_map_pages,
 	.page_mkwrite	= f2fs_vm_page_mkwrite,
 };
@@ -118,39 +142,39 @@ static int get_parent_ino(struct inode *inode, nid_t *pino)
 	if (!dentry)
 		return 0;
 
-	if (update_dent_inode(inode, inode, &dentry->d_name)) {
-		dput(dentry);
-		return 0;
-	}
-
 	*pino = parent_ino(dentry);
 	dput(dentry);
 	return 1;
 }
 
-static inline bool need_do_checkpoint(struct inode *inode)
+static inline enum cp_reason_type need_do_checkpoint(struct inode *inode)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
-	bool need_cp = false;
+	enum cp_reason_type cp_reason = CP_NO_NEEDED;
 
-	if (!S_ISREG(inode->i_mode) || inode->i_nlink != 1)
-		need_cp = true;
+	if (!S_ISREG(inode->i_mode))
+		cp_reason = CP_NON_REGULAR;
+	else if (inode->i_nlink != 1)
+		cp_reason = CP_HARDLINK;
 	else if (is_sbi_flag_set(sbi, SBI_NEED_CP))
-		need_cp = true;
+		cp_reason = CP_SB_NEED_CP;
 	else if (file_wrong_pino(inode))
-		need_cp = true;
-	else if (!space_for_roll_forward(sbi))
-		need_cp = true;
-	else if (!is_checkpointed_node(sbi, F2FS_I(inode)->i_pino))
-		need_cp = true;
-	else if (F2FS_I(inode)->xattr_ver == cur_cp_version(F2FS_CKPT(sbi)))
-		need_cp = true;
+		cp_reason = CP_WRONG_PINO;
+	else if (!f2fs_space_for_roll_forward(sbi))
+		cp_reason = CP_NO_SPC_ROLL;
+	else if (!f2fs_is_checkpointed_node(sbi, F2FS_I(inode)->i_pino))
+		cp_reason = CP_NODE_NEED_CP;
 	else if (test_opt(sbi, FASTBOOT))
-		need_cp = true;
-	else if (sbi->active_logs == 2)
-		need_cp = true;
-
-	return need_cp;
+		cp_reason = CP_FASTBOOT_MODE;
+	else if (F2FS_OPTION(sbi).active_logs == 2)
+		cp_reason = CP_SPEC_LOG_NUM;
+	else if (F2FS_OPTION(sbi).fsync_mode == FSYNC_MODE_STRICT &&
+		f2fs_need_dentry_mark(sbi, inode->i_ino) &&
+		f2fs_exist_written_data(sbi, F2FS_I(inode)->i_pino,
+							TRANS_DIR_INO))
+		cp_reason = CP_RECOVER_DIR;
+
+	return cp_reason;
 }
 
 static bool need_inode_page_update(struct f2fs_sb_info *sbi, nid_t ino)
@@ -158,7 +182,7 @@ static bool need_inode_page_update(struct f2fs_sb_info *sbi, nid_t ino)
 	struct page *i = find_get_page(NODE_MAPPING(sbi), ino);
 	bool ret = false;
 	/* But we need to avoid that there are some inode updates */
-	if ((i && PageDirty(i)) || need_inode_block_update(sbi, ino))
+	if ((i && PageDirty(i)) || f2fs_need_inode_block_update(sbi, ino))
 		ret = true;
 	f2fs_put_page(i, 0);
 	return ret;
@@ -170,7 +194,6 @@ static void try_to_fix_pino(struct inode *inode)
 	nid_t pino;
 
 	down_write(&fi->i_sem);
-	fi->xattr_ver = 0;
 	if (file_wrong_pino(inode) && inode->i_nlink == 1 &&
 			get_parent_ino(inode, &pino)) {
 		f2fs_i_pino_write(inode, pino);
@@ -186,7 +209,7 @@ static int f2fs_do_sync_file(struct file *file, loff_t start, loff_t end,
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	nid_t ino = inode->i_ino;
 	int ret = 0;
-	bool need_cp = false;
+	enum cp_reason_type cp_reason = 0;
 	struct writeback_control wbc = {
 		.sync_mode = WB_SYNC_ALL,
 		.nr_to_write = LONG_MAX,
@@ -205,12 +228,12 @@ static int f2fs_do_sync_file(struct file *file, loff_t start, loff_t end,
 	clear_inode_flag(inode, FI_NEED_IPU);
 
 	if (ret) {
-		trace_f2fs_sync_file_exit(inode, need_cp, datasync, ret);
+		trace_f2fs_sync_file_exit(inode, cp_reason, datasync, ret);
 		return ret;
 	}
 
 	/* if the inode is dirty, let's recover all the time */
-	if (!datasync && !f2fs_skip_inode_update(inode)) {
+	if (!f2fs_skip_inode_update(inode, datasync)) {
 		f2fs_write_inode(inode, NULL);
 		goto go_write;
 	}
@@ -219,14 +242,14 @@ static int f2fs_do_sync_file(struct file *file, loff_t start, loff_t end,
 	 * if there is no written data, don't waste time to write recovery info.
 	 */
 	if (!is_inode_flag_set(inode, FI_APPEND_WRITE) &&
-			!exist_written_data(sbi, ino, APPEND_INO)) {
+			!f2fs_exist_written_data(sbi, ino, APPEND_INO)) {
 
 		/* it may call write_inode just prior to fsync */
 		if (need_inode_page_update(sbi, ino))
 			goto go_write;
 
 		if (is_inode_flag_set(inode, FI_UPDATE_WRITE) ||
-				exist_written_data(sbi, ino, UPDATE_INO))
+				f2fs_exist_written_data(sbi, ino, UPDATE_INO))
 			goto flush_out;
 		goto out;
 	}
@@ -236,10 +259,10 @@ static int f2fs_do_sync_file(struct file *file, loff_t start, loff_t end,
 	 * sudden-power-off.
 	 */
 	down_read(&F2FS_I(inode)->i_sem);
-	need_cp = need_do_checkpoint(inode);
+	cp_reason = need_do_checkpoint(inode);
 	up_read(&F2FS_I(inode)->i_sem);
 
-	if (need_cp) {
+	if (cp_reason) {
 		/* all the dirty node pages should be flushed for POR */
 		ret = f2fs_sync_fs(inode->i_sb, 1);
 
@@ -253,7 +276,9 @@ static int f2fs_do_sync_file(struct file *file, loff_t start, loff_t end,
 		goto out;
 	}
 sync_nodes:
-	ret = fsync_node_pages(sbi, inode, &wbc, atomic);
+	atomic_inc(&sbi->wb_sync_req[NODE]);
+	ret = f2fs_fsync_node_pages(sbi, inode, &wbc, atomic);
+	atomic_dec(&sbi->wb_sync_req[NODE]);
 	if (ret)
 		goto out;
 
@@ -263,50 +288,67 @@ static int f2fs_do_sync_file(struct file *file, loff_t start, loff_t end,
 		goto out;
 	}
 
-	if (need_inode_block_update(sbi, ino)) {
-		f2fs_mark_inode_dirty_sync(inode);
+	if (f2fs_need_inode_block_update(sbi, ino)) {
+		f2fs_mark_inode_dirty_sync(inode, true);
 		f2fs_write_inode(inode, NULL);
 		goto sync_nodes;
 	}
 
-	ret = wait_on_node_pages_writeback(sbi, ino);
-	if (ret)
-		goto out;
+	/*
+	 * If it's atomic_write, it's just fine to keep write ordering. So
+	 * here we don't need to wait for node write completion, since we use
+	 * node chain which serializes node blocks. If one of node writes are
+	 * reordered, we can see simply broken chain, resulting in stopping
+	 * roll-forward recovery. It means we'll recover all or none node blocks
+	 * given fsync mark.
+	 */
+	if (!atomic) {
+		ret = f2fs_wait_on_node_pages_writeback(sbi, ino);
+		if (ret)
+			goto out;
+	}
 
 	/* once recovery info is written, don't need to tack this */
-	remove_ino_entry(sbi, ino, APPEND_INO);
+	f2fs_remove_ino_entry(sbi, ino, APPEND_INO);
 	clear_inode_flag(inode, FI_APPEND_WRITE);
 flush_out:
-	remove_ino_entry(sbi, ino, UPDATE_INO);
-	clear_inode_flag(inode, FI_UPDATE_WRITE);
-	ret = f2fs_issue_flush(sbi);
+	if (!atomic && F2FS_OPTION(sbi).fsync_mode != FSYNC_MODE_NOBARRIER)
+		ret = f2fs_issue_flush(sbi, inode->i_ino);
+	if (!ret) {
+		f2fs_remove_ino_entry(sbi, ino, UPDATE_INO);
+		clear_inode_flag(inode, FI_UPDATE_WRITE);
+		f2fs_remove_ino_entry(sbi, ino, FLUSH_INO);
+	}
 	f2fs_update_time(sbi, REQ_TIME);
 out:
-	trace_f2fs_sync_file_exit(inode, need_cp, datasync, ret);
+	trace_f2fs_sync_file_exit(inode, cp_reason, datasync, ret);
 	f2fs_trace_ios(NULL, 1);
 	return ret;
 }
 
 int f2fs_sync_file(struct file *file, loff_t start, loff_t end, int datasync)
 {
+	if (unlikely(f2fs_cp_error(F2FS_I_SB(file_inode(file)))))
+		return -EIO;
 	return f2fs_do_sync_file(file, start, end, datasync, false);
 }
 
 static pgoff_t __get_first_dirty_index(struct address_space *mapping,
 						pgoff_t pgofs, int whence)
 {
-	struct pagevec pvec;
+	struct page *page;
 	int nr_pages;
 
 	if (whence != SEEK_DATA)
 		return 0;
 
 	/* find first dirty page index */
-	pagevec_init(&pvec, 0);
-	nr_pages = pagevec_lookup_tag(&pvec, mapping, &pgofs,
-					PAGECACHE_TAG_DIRTY, 1);
-	pgofs = nr_pages ? pvec.pages[0]->index : ULONG_MAX;
-	pagevec_release(&pvec);
+	nr_pages = find_get_pages_tag(mapping, &pgofs, PAGECACHE_TAG_DIRTY,
+				      1, &page);
+	if (!nr_pages)
+		return ULONG_MAX;
+	pgofs = page->index;
+	put_page(page);
 	return pgofs;
 }
 
@@ -316,7 +358,7 @@ static bool __found_offset(block_t blkaddr, pgoff_t dirty, pgoff_t pgofs,
 	switch (whence) {
 	case SEEK_DATA:
 		if ((blkaddr == NEW_ADDR && dirty == pgofs) ||
-			(blkaddr != NEW_ADDR && blkaddr != NULL_ADDR))
+			is_valid_blkaddr(blkaddr))
 			return true;
 		break;
 	case SEEK_HOLE:
@@ -356,13 +398,13 @@ static loff_t f2fs_seek_block(struct file *file, loff_t offset, int whence)
 
 	for (; data_ofs < isize; data_ofs = (loff_t)pgofs << PAGE_SHIFT) {
 		set_new_dnode(&dn, inode, NULL, NULL, 0);
-		err = get_dnode_of_data(&dn, pgofs, LOOKUP_NODE);
+		err = f2fs_get_dnode_of_data(&dn, pgofs, LOOKUP_NODE);
 		if (err && err != -ENOENT) {
 			goto fail;
 		} else if (err == -ENOENT) {
 			/* direct node does not exists */
 			if (whence == SEEK_DATA) {
-				pgofs = get_next_page_offset(&dn, pgofs);
+				pgofs = f2fs_get_next_page_offset(&dn, pgofs);
 				continue;
 			} else {
 				goto found;
@@ -376,7 +418,9 @@ static loff_t f2fs_seek_block(struct file *file, loff_t offset, int whence)
 				dn.ofs_in_node++, pgofs++,
 				data_ofs = (loff_t)pgofs << PAGE_SHIFT) {
 			block_t blkaddr;
-			blkaddr = datablock_addr(dn.node_page, dn.ofs_in_node);
+
+			blkaddr = datablock_addr(dn.inode,
+					dn.node_page, dn.ofs_in_node);
 
 			if (__found_offset(blkaddr, dirty, pgofs, whence)) {
 				f2fs_put_dnode(&dn);
@@ -424,13 +468,8 @@ static int f2fs_file_mmap(struct file *file, struct vm_area_struct *vma)
 	struct inode *inode = file_inode(file);
 	int err;
 
-	if (f2fs_encrypted_inode(inode)) {
-		err = fscrypt_get_encryption_info(inode);
-		if (err)
-			return 0;
-		if (!f2fs_encrypted_inode(inode))
-			return -ENOKEY;
-	}
+	if (unlikely(f2fs_cp_error(F2FS_I_SB(inode))))
+		return -EIO;
 
 	/* we don't need to use inline_data strictly */
 	err = f2fs_convert_inline_inode(inode);
@@ -444,44 +483,39 @@ static int f2fs_file_mmap(struct file *file, struct vm_area_struct *vma)
 
 static int f2fs_file_open(struct inode *inode, struct file *filp)
 {
-	int ret = generic_file_open(inode, filp);
-	struct dentry *dir;
+	int err = fscrypt_file_open(inode, filp);
 
-	if (!ret && f2fs_encrypted_inode(inode)) {
-		ret = fscrypt_get_encryption_info(inode);
-		if (ret)
-			return -EACCES;
-		if (!fscrypt_has_encryption_key(inode))
-			return -ENOKEY;
-	}
-	dir = dget_parent(file_dentry(filp));
-	if (f2fs_encrypted_inode(d_inode(dir)) &&
-			!fscrypt_has_permitted_context(d_inode(dir), inode)) {
-		dput(dir);
-		return -EPERM;
-	}
-	dput(dir);
-	return ret;
+	if (err)
+		return err;
+
+	filp->f_mode |= FMODE_NOWAIT;
+
+	return dquot_file_open(inode, filp);
 }
 
-int truncate_data_blocks_range(struct dnode_of_data *dn, int count)
+void f2fs_truncate_data_blocks_range(struct dnode_of_data *dn, int count)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(dn->inode);
 	struct f2fs_node *raw_node;
 	int nr_free = 0, ofs = dn->ofs_in_node, len = count;
 	__le32 *addr;
+	int base = 0;
+
+	if (IS_INODE(dn->node_page) && f2fs_has_extra_attr(dn->inode))
+		base = get_extra_isize(dn->inode);
 
 	raw_node = F2FS_NODE(dn->node_page);
-	addr = blkaddr_in_node(raw_node) + ofs;
+	addr = blkaddr_in_node(raw_node) + base + ofs;
 
 	for (; count > 0; count--, addr++, dn->ofs_in_node++) {
 		block_t blkaddr = le32_to_cpu(*addr);
+
 		if (blkaddr == NULL_ADDR)
 			continue;
 
 		dn->data_blkaddr = NULL_ADDR;
-		set_data_blkaddr(dn);
-		invalidate_blocks(sbi, blkaddr);
+		f2fs_set_data_blkaddr(dn);
+		f2fs_invalidate_blocks(sbi, blkaddr);
 		if (dn->ofs_in_node == 0 && IS_INODE(dn->node_page))
 			clear_inode_flag(dn->inode, FI_FIRST_BLOCK_WRITTEN);
 		nr_free++;
@@ -493,7 +527,7 @@ int truncate_data_blocks_range(struct dnode_of_data *dn, int count)
 		 * once we invalidate valid blkaddr in range [ofs, ofs + count],
 		 * we will invalidate all blkaddr in the whole range.
 		 */
-		fofs = start_bidx_of_node(ofs_of_node(dn->node_page),
+		fofs = f2fs_start_bidx_of_node(ofs_of_node(dn->node_page),
 							dn->inode) + ofs;
 		f2fs_update_extent_cache_range(dn, fofs, 0, len);
 		dec_valid_block_count(sbi, dn->inode, nr_free);
@@ -503,18 +537,17 @@ int truncate_data_blocks_range(struct dnode_of_data *dn, int count)
 	f2fs_update_time(sbi, REQ_TIME);
 	trace_f2fs_truncate_data_blocks_range(dn->inode, dn->nid,
 					 dn->ofs_in_node, nr_free);
-	return nr_free;
 }
 
-void truncate_data_blocks(struct dnode_of_data *dn)
+void f2fs_truncate_data_blocks(struct dnode_of_data *dn)
 {
-	truncate_data_blocks_range(dn, ADDRS_PER_BLOCK);
+	f2fs_truncate_data_blocks_range(dn, ADDRS_PER_BLOCK);
 }
 
 static int truncate_partial_data_page(struct inode *inode, u64 from,
 								bool cache_only)
 {
-	unsigned offset = from & (PAGE_SIZE - 1);
+	loff_t offset = from & (PAGE_SIZE - 1);
 	pgoff_t index = from >> PAGE_SHIFT;
 	struct address_space *mapping = inode->i_mapping;
 	struct page *page;
@@ -530,23 +563,24 @@ static int truncate_partial_data_page(struct inode *inode, u64 from,
 		return 0;
 	}
 
-	page = get_lock_data_page(inode, index, true);
+	page = f2fs_get_lock_data_page(inode, index, true);
 	if (IS_ERR(page))
-		return 0;
+		return PTR_ERR(page) == -ENOENT ? 0 : PTR_ERR(page);
 truncate_out:
 	f2fs_wait_on_page_writeback(page, DATA, true);
 	zero_user(page, offset, PAGE_SIZE - offset);
-	if (!cache_only || !f2fs_encrypted_inode(inode) ||
-					!S_ISREG(inode->i_mode))
+
+	/* An encrypted inode should have a key and truncate the last page. */
+	f2fs_bug_on(F2FS_I_SB(inode), cache_only && f2fs_encrypted_inode(inode));
+	if (!cache_only)
 		set_page_dirty(page);
 	f2fs_put_page(page, 1);
 	return 0;
 }
 
-int truncate_blocks(struct inode *inode, u64 from, bool lock)
+int f2fs_truncate_blocks(struct inode *inode, u64 from, bool lock)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
-	unsigned int blocksize = inode->i_sb->s_blocksize;
 	struct dnode_of_data dn;
 	pgoff_t free_from;
 	int count = 0, err = 0;
@@ -555,7 +589,7 @@ int truncate_blocks(struct inode *inode, u64 from, bool lock)
 
 	trace_f2fs_truncate_blocks_enter(inode, from);
 
-	free_from = (pgoff_t)F2FS_BYTES_TO_BLK(from + blocksize - 1);
+	free_from = (pgoff_t)F2FS_BLK_ALIGN(from);
 
 	if (free_from >= sbi->max_file_blocks)
 		goto free_partial;
@@ -563,22 +597,21 @@ int truncate_blocks(struct inode *inode, u64 from, bool lock)
 	if (lock)
 		f2fs_lock_op(sbi);
 
-	ipage = get_node_page(sbi, inode->i_ino);
+	ipage = f2fs_get_node_page(sbi, inode->i_ino);
 	if (IS_ERR(ipage)) {
 		err = PTR_ERR(ipage);
 		goto out;
 	}
 
 	if (f2fs_has_inline_data(inode)) {
-		if (truncate_inline_inode(ipage, from))
-			set_page_dirty(ipage);
+		f2fs_truncate_inline_inode(inode, ipage, from);
 		f2fs_put_page(ipage, 1);
 		truncate_page = true;
 		goto out;
 	}
 
 	set_new_dnode(&dn, inode, ipage, NULL, 0);
-	err = get_dnode_of_data(&dn, free_from, LOOKUP_NODE_RA);
+	err = f2fs_get_dnode_of_data(&dn, free_from, LOOKUP_NODE_RA);
 	if (err) {
 		if (err == -ENOENT)
 			goto free_next;
@@ -591,13 +624,13 @@ int truncate_blocks(struct inode *inode, u64 from, bool lock)
 	f2fs_bug_on(sbi, count < 0);
 
 	if (dn.ofs_in_node || IS_INODE(dn.node_page)) {
-		truncate_data_blocks_range(&dn, count);
+		f2fs_truncate_data_blocks_range(&dn, count);
 		free_from += count;
 	}
 
 	f2fs_put_dnode(&dn);
 free_next:
-	err = truncate_inode_blocks(inode, free_from);
+	err = f2fs_truncate_inode_blocks(inode, free_from);
 out:
 	if (lock)
 		f2fs_unlock_op(sbi);
@@ -614,12 +647,21 @@ int f2fs_truncate(struct inode *inode)
 {
 	int err;
 
+	if (unlikely(f2fs_cp_error(F2FS_I_SB(inode))))
+		return -EIO;
+
 	if (!(S_ISREG(inode->i_mode) || S_ISDIR(inode->i_mode) ||
 				S_ISLNK(inode->i_mode)))
 		return 0;
 
 	trace_f2fs_truncate(inode);
 
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	if (time_to_inject(F2FS_I_SB(inode), FAULT_TRUNCATE)) {
+		f2fs_show_injection_info(FAULT_TRUNCATE);
+		return -EIO;
+	}
+#endif
 	/* we should check inline_data size */
 	if (!f2fs_may_inline_data(inode)) {
 		err = f2fs_convert_inline_inode(inode);
@@ -627,21 +669,57 @@ int f2fs_truncate(struct inode *inode)
 			return err;
 	}
 
-	err = truncate_blocks(inode, i_size_read(inode), true);
+	err = f2fs_truncate_blocks(inode, i_size_read(inode), true);
 	if (err)
 		return err;
 
 	inode->i_mtime = inode->i_ctime = current_time(inode);
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, false);
 	return 0;
 }
 
 int f2fs_getattr(struct vfsmount *mnt,
-			 struct dentry *dentry, struct kstat *stat)
+			struct dentry *dentry, struct kstat *stat)
 {
 	struct inode *inode = d_inode(dentry);
+#if 0
+	struct f2fs_inode_info *fi = F2FS_I(inode);
+	struct f2fs_inode *ri;
+	unsigned int flags;
+
+	if (f2fs_has_extra_attr(inode) &&
+			f2fs_sb_has_inode_crtime(inode->i_sb) &&
+			F2FS_FITS_IN_INODE(ri, fi->i_extra_isize, i_crtime)) {
+		stat->result_mask |= STATX_BTIME;
+		stat->btime.tv_sec = fi->i_crtime.tv_sec;
+		stat->btime.tv_nsec = fi->i_crtime.tv_nsec;
+	}
+
+	flags = fi->i_flags & F2FS_FL_USER_VISIBLE;
+	if (flags & F2FS_APPEND_FL)
+		stat->attributes |= STATX_ATTR_APPEND;
+	if (flags & F2FS_COMPR_FL)
+		stat->attributes |= STATX_ATTR_COMPRESSED;
+	if (f2fs_encrypted_inode(inode))
+		stat->attributes |= STATX_ATTR_ENCRYPTED;
+	if (flags & F2FS_IMMUTABLE_FL)
+		stat->attributes |= STATX_ATTR_IMMUTABLE;
+	if (flags & F2FS_NODUMP_FL)
+		stat->attributes |= STATX_ATTR_NODUMP;
+
+	stat->attributes_mask |= (STATX_ATTR_APPEND |
+				  STATX_ATTR_COMPRESSED |
+				  STATX_ATTR_ENCRYPTED |
+				  STATX_ATTR_IMMUTABLE |
+				  STATX_ATTR_NODUMP);
+#endif
 	generic_fillattr(inode, stat);
-	stat->blocks <<= 3;
+
+	/* we need to show initial sectors used for inline_data/dentries */
+	if ((S_ISREG(inode->i_mode) && f2fs_has_inline_data(inode)) ||
+					f2fs_has_inline_dentry(inode))
+		stat->blocks += (stat->size + 511) >> 9;
+
 	return 0;
 }
 
@@ -679,28 +757,49 @@ int f2fs_setattr(struct dentry *dentry, struct iattr *attr)
 {
 	struct inode *inode = d_inode(dentry);
 	int err;
+	bool size_changed = false;
+
+	if (unlikely(f2fs_cp_error(F2FS_I_SB(inode))))
+		return -EIO;
 
 	err = setattr_prepare(dentry, attr);
 	if (err)
 		return err;
 
-	if (attr->ia_valid & ATTR_SIZE) {
-		if (f2fs_encrypted_inode(inode) &&
-				fscrypt_get_encryption_info(inode))
-			return -EACCES;
+	err = fscrypt_prepare_setattr(dentry, attr);
+	if (err)
+		return err;
+
+	if (is_quota_modification(inode, attr)) {
+		err = dquot_initialize(inode);
+		if (err)
+			return err;
+	}
+	if ((attr->ia_valid & ATTR_UID &&
+		!uid_eq(attr->ia_uid, inode->i_uid)) ||
+		(attr->ia_valid & ATTR_GID &&
+		!gid_eq(attr->ia_gid, inode->i_gid))) {
+		err = dquot_transfer(inode, attr);
+		if (err)
+			return err;
+	}
 
+	if (attr->ia_valid & ATTR_SIZE) {
 		if (attr->ia_size <= i_size_read(inode)) {
+			down_write(&F2FS_I(inode)->i_mmap_sem);
 			truncate_setsize(inode, attr->ia_size);
 			err = f2fs_truncate(inode);
+			up_write(&F2FS_I(inode)->i_mmap_sem);
 			if (err)
 				return err;
-			f2fs_balance_fs(F2FS_I_SB(inode), true);
 		} else {
 			/*
 			 * do not trim all blocks after i_size if target size is
 			 * larger than i_size.
 			 */
+			down_write(&F2FS_I(inode)->i_mmap_sem);
 			truncate_setsize(inode, attr->ia_size);
+			up_write(&F2FS_I(inode)->i_mmap_sem);
 
 			/* should convert inline inode here */
 			if (!f2fs_may_inline_data(inode)) {
@@ -710,19 +809,30 @@ int f2fs_setattr(struct dentry *dentry, struct iattr *attr)
 			}
 			inode->i_mtime = inode->i_ctime = current_time(inode);
 		}
+
+		down_write(&F2FS_I(inode)->i_sem);
+		F2FS_I(inode)->last_disk_size = i_size_read(inode);
+		up_write(&F2FS_I(inode)->i_sem);
+
+		size_changed = true;
 	}
 
 	__setattr_copy(inode, attr);
 
 	if (attr->ia_valid & ATTR_MODE) {
-		err = posix_acl_chmod(inode, get_inode_mode(inode));
+		err = posix_acl_chmod(inode, f2fs_get_inode_mode(inode));
 		if (err || is_inode_flag_set(inode, FI_ACL_MODE)) {
 			inode->i_mode = F2FS_I(inode)->i_acl_mode;
 			clear_inode_flag(inode, FI_ACL_MODE);
 		}
 	}
 
-	f2fs_mark_inode_dirty_sync(inode);
+	/* file size may changed here */
+	f2fs_mark_inode_dirty_sync(inode, size_changed);
+
+	/* inode change will produce dirty node pages flushed by checkpoint */
+	f2fs_balance_fs(F2FS_I_SB(inode), true);
+
 	return err;
 }
 
@@ -749,7 +859,7 @@ static int fill_zero(struct inode *inode, pgoff_t index,
 	f2fs_balance_fs(sbi, true);
 
 	f2fs_lock_op(sbi);
-	page = get_new_data_page(inode, NULL, index, false);
+	page = f2fs_get_new_data_page(inode, NULL, index, false);
 	f2fs_unlock_op(sbi);
 
 	if (IS_ERR(page))
@@ -762,7 +872,7 @@ static int fill_zero(struct inode *inode, pgoff_t index,
 	return 0;
 }
 
-int truncate_hole(struct inode *inode, pgoff_t pg_start, pgoff_t pg_end)
+int f2fs_truncate_hole(struct inode *inode, pgoff_t pg_start, pgoff_t pg_end)
 {
 	int err;
 
@@ -771,10 +881,11 @@ int truncate_hole(struct inode *inode, pgoff_t pg_start, pgoff_t pg_end)
 		pgoff_t end_offset, count;
 
 		set_new_dnode(&dn, inode, NULL, NULL, 0);
-		err = get_dnode_of_data(&dn, pg_start, LOOKUP_NODE);
+		err = f2fs_get_dnode_of_data(&dn, pg_start, LOOKUP_NODE);
 		if (err) {
 			if (err == -ENOENT) {
-				pg_start++;
+				pg_start = f2fs_get_next_page_offset(&dn,
+								pg_start);
 				continue;
 			}
 			return err;
@@ -785,7 +896,7 @@ int truncate_hole(struct inode *inode, pgoff_t pg_start, pgoff_t pg_end)
 
 		f2fs_bug_on(F2FS_I_SB(inode), count == 0 || count > end_offset);
 
-		truncate_data_blocks_range(&dn, count);
+		f2fs_truncate_data_blocks_range(&dn, count);
 		f2fs_put_dnode(&dn);
 
 		pg_start += count;
@@ -836,12 +947,14 @@ static int punch_hole(struct inode *inode, loff_t offset, loff_t len)
 
 			blk_start = (loff_t)pg_start << PAGE_SHIFT;
 			blk_end = (loff_t)pg_end << PAGE_SHIFT;
+			down_write(&F2FS_I(inode)->i_mmap_sem);
 			truncate_inode_pages_range(mapping, blk_start,
 					blk_end - 1);
 
 			f2fs_lock_op(sbi);
-			ret = truncate_hole(inode, pg_start, pg_end);
+			ret = f2fs_truncate_hole(inode, pg_start, pg_end);
 			f2fs_unlock_op(sbi);
+			up_write(&F2FS_I(inode)->i_mmap_sem);
 		}
 	}
 
@@ -857,7 +970,7 @@ static int __read_out_blkaddrs(struct inode *inode, block_t *blkaddr,
 
 next_dnode:
 	set_new_dnode(&dn, inode, NULL, NULL, 0);
-	ret = get_dnode_of_data(&dn, off, LOOKUP_NODE_RA);
+	ret = f2fs_get_dnode_of_data(&dn, off, LOOKUP_NODE_RA);
 	if (ret && ret != -ENOENT) {
 		return ret;
 	} else if (ret == -ENOENT) {
@@ -872,8 +985,9 @@ static int __read_out_blkaddrs(struct inode *inode, block_t *blkaddr,
 	done = min((pgoff_t)ADDRS_PER_PAGE(dn.node_page, inode) -
 							dn.ofs_in_node, len);
 	for (i = 0; i < done; i++, blkaddr++, do_replace++, dn.ofs_in_node++) {
-		*blkaddr = datablock_addr(dn.node_page, dn.ofs_in_node);
-		if (!is_checkpointed_data(sbi, *blkaddr)) {
+		*blkaddr = datablock_addr(dn.inode,
+					dn.node_page, dn.ofs_in_node);
+		if (!f2fs_is_checkpointed_data(sbi, *blkaddr)) {
 
 			if (test_opt(sbi, LFS)) {
 				f2fs_put_dnode(&dn);
@@ -906,10 +1020,10 @@ static int __roll_back_blkaddrs(struct inode *inode, block_t *blkaddr,
 			continue;
 
 		set_new_dnode(&dn, inode, NULL, NULL, 0);
-		ret = get_dnode_of_data(&dn, off + i, LOOKUP_NODE_RA);
+		ret = f2fs_get_dnode_of_data(&dn, off + i, LOOKUP_NODE_RA);
 		if (ret) {
 			dec_valid_block_count(sbi, inode, 1);
-			invalidate_blocks(sbi, *blkaddr);
+			f2fs_invalidate_blocks(sbi, *blkaddr);
 		} else {
 			f2fs_update_data_blkaddr(&dn, *blkaddr);
 		}
@@ -939,24 +1053,24 @@ static int __clone_blkaddrs(struct inode *src_inode, struct inode *dst_inode,
 			pgoff_t ilen;
 
 			set_new_dnode(&dn, dst_inode, NULL, NULL, 0);
-			ret = get_dnode_of_data(&dn, dst + i, ALLOC_NODE);
+			ret = f2fs_get_dnode_of_data(&dn, dst + i, ALLOC_NODE);
 			if (ret)
 				return ret;
 
-			get_node_info(sbi, dn.nid, &ni);
+			f2fs_get_node_info(sbi, dn.nid, &ni);
 			ilen = min((pgoff_t)
 				ADDRS_PER_PAGE(dn.node_page, dst_inode) -
 						dn.ofs_in_node, len - i);
 			do {
-				dn.data_blkaddr = datablock_addr(dn.node_page,
-								dn.ofs_in_node);
-				truncate_data_blocks_range(&dn, 1);
+				dn.data_blkaddr = datablock_addr(dn.inode,
+						dn.node_page, dn.ofs_in_node);
+				f2fs_truncate_data_blocks_range(&dn, 1);
 
 				if (do_replace[i]) {
 					f2fs_i_blocks_write(src_inode,
-								1, false);
+							1, false, false);
 					f2fs_i_blocks_write(dst_inode,
-								1, true);
+							1, true, false);
 					f2fs_replace_block(sbi, &dn, dn.data_blkaddr,
 					blkaddr[i], ni.version, true, false);
 
@@ -973,10 +1087,11 @@ static int __clone_blkaddrs(struct inode *src_inode, struct inode *dst_inode,
 		} else {
 			struct page *psrc, *pdst;
 
-			psrc = get_lock_data_page(src_inode, src + i, true);
+			psrc = f2fs_get_lock_data_page(src_inode,
+							src + i, true);
 			if (IS_ERR(psrc))
 				return PTR_ERR(psrc);
-			pdst = get_new_data_page(dst_inode, NULL, dst + i,
+			pdst = f2fs_get_new_data_page(dst_inode, NULL, dst + i,
 								true);
 			if (IS_ERR(pdst)) {
 				f2fs_put_page(psrc, 1);
@@ -987,7 +1102,8 @@ static int __clone_blkaddrs(struct inode *src_inode, struct inode *dst_inode,
 			f2fs_put_page(pdst, 1);
 			f2fs_put_page(psrc, 1);
 
-			ret = truncate_hole(src_inode, src + i, src + i + 1);
+			ret = f2fs_truncate_hole(src_inode,
+						src + i, src + i + 1);
 			if (ret)
 				return ret;
 			i++;
@@ -1008,11 +1124,15 @@ static int __exchange_data_block(struct inode *src_inode,
 	while (len) {
 		olen = min((pgoff_t)4 * ADDRS_PER_BLOCK, len);
 
-		src_blkaddr = f2fs_kvzalloc(sizeof(block_t) * olen, GFP_KERNEL);
+		src_blkaddr = f2fs_kvzalloc(F2FS_I_SB(src_inode),
+					array_size(olen, sizeof(block_t)),
+					GFP_KERNEL);
 		if (!src_blkaddr)
 			return -ENOMEM;
 
-		do_replace = f2fs_kvzalloc(sizeof(int) * olen, GFP_KERNEL);
+		do_replace = f2fs_kvzalloc(F2FS_I_SB(src_inode),
+					array_size(olen, sizeof(int)),
+					GFP_KERNEL);
 		if (!do_replace) {
 			kvfree(src_blkaddr);
 			return -ENOMEM;
@@ -1038,7 +1158,7 @@ static int __exchange_data_block(struct inode *src_inode,
 	return 0;
 
 roll_back:
-	__roll_back_blkaddrs(src_inode, src_blkaddr, do_replace, src, len);
+	__roll_back_blkaddrs(src_inode, src_blkaddr, do_replace, src, olen);
 	kvfree(src_blkaddr);
 	kvfree(do_replace);
 	return ret;
@@ -1080,16 +1200,20 @@ static int f2fs_collapse_range(struct inode *inode, loff_t offset, loff_t len)
 	pg_start = offset >> PAGE_SHIFT;
 	pg_end = (offset + len) >> PAGE_SHIFT;
 
+	/* avoid gc operation during block exchange */
+	down_write(&F2FS_I(inode)->i_gc_rwsem[WRITE]);
+
+	down_write(&F2FS_I(inode)->i_mmap_sem);
 	/* write out all dirty pages from offset */
 	ret = filemap_write_and_wait_range(inode->i_mapping, offset, LLONG_MAX);
 	if (ret)
-		return ret;
+		goto out_unlock;
 
 	truncate_pagecache(inode, offset);
 
 	ret = f2fs_do_collapse(inode, pg_start, pg_end);
 	if (ret)
-		return ret;
+		goto out_unlock;
 
 	/* write out all moved pages, if possible */
 	filemap_write_and_wait_range(inode->i_mapping, offset, LLONG_MAX);
@@ -1098,10 +1222,12 @@ static int f2fs_collapse_range(struct inode *inode, loff_t offset, loff_t len)
 	new_size = i_size_read(inode) - len;
 	truncate_pagecache(inode, new_size);
 
-	ret = truncate_blocks(inode, new_size, true);
+	ret = f2fs_truncate_blocks(inode, new_size, true);
 	if (!ret)
 		f2fs_i_size_write(inode, new_size);
-
+out_unlock:
+	up_write(&F2FS_I(inode)->i_mmap_sem);
+	up_write(&F2FS_I(inode)->i_gc_rwsem[WRITE]);
 	return ret;
 }
 
@@ -1115,21 +1241,22 @@ static int f2fs_do_zero_range(struct dnode_of_data *dn, pgoff_t start,
 	int ret;
 
 	for (; index < end; index++, dn->ofs_in_node++) {
-		if (datablock_addr(dn->node_page, dn->ofs_in_node) == NULL_ADDR)
+		if (datablock_addr(dn->inode, dn->node_page,
+					dn->ofs_in_node) == NULL_ADDR)
 			count++;
 	}
 
 	dn->ofs_in_node = ofs_in_node;
-	ret = reserve_new_blocks(dn, count);
+	ret = f2fs_reserve_new_blocks(dn, count);
 	if (ret)
 		return ret;
 
 	dn->ofs_in_node = ofs_in_node;
 	for (index = start; index < end; index++, dn->ofs_in_node++) {
-		dn->data_blkaddr =
-				datablock_addr(dn->node_page, dn->ofs_in_node);
+		dn->data_blkaddr = datablock_addr(dn->inode,
+					dn->node_page, dn->ofs_in_node);
 		/*
-		 * reserve_new_blocks will not guarantee entire block
+		 * f2fs_reserve_new_blocks will not guarantee entire block
 		 * allocation.
 		 */
 		if (dn->data_blkaddr == NULL_ADDR) {
@@ -1137,9 +1264,9 @@ static int f2fs_do_zero_range(struct dnode_of_data *dn, pgoff_t start,
 			break;
 		}
 		if (dn->data_blkaddr != NEW_ADDR) {
-			invalidate_blocks(sbi, dn->data_blkaddr);
+			f2fs_invalidate_blocks(sbi, dn->data_blkaddr);
 			dn->data_blkaddr = NEW_ADDR;
-			set_data_blkaddr(dn);
+			f2fs_set_data_blkaddr(dn);
 		}
 	}
 
@@ -1166,9 +1293,10 @@ static int f2fs_zero_range(struct inode *inode, loff_t offset, loff_t len,
 	if (ret)
 		return ret;
 
+	down_write(&F2FS_I(inode)->i_mmap_sem);
 	ret = filemap_write_and_wait_range(mapping, offset, offset + len - 1);
 	if (ret)
-		return ret;
+		goto out_sem;
 
 	truncate_pagecache_range(inode, offset, offset + len - 1);
 
@@ -1182,17 +1310,15 @@ static int f2fs_zero_range(struct inode *inode, loff_t offset, loff_t len,
 		ret = fill_zero(inode, pg_start, off_start,
 						off_end - off_start);
 		if (ret)
-			return ret;
+			goto out_sem;
 
-		if (offset + len > new_size)
-			new_size = offset + len;
 		new_size = max_t(loff_t, new_size, offset + len);
 	} else {
 		if (off_start) {
 			ret = fill_zero(inode, pg_start++, off_start,
 						PAGE_SIZE - off_start);
 			if (ret)
-				return ret;
+				goto out_sem;
 
 			new_size = max_t(loff_t, new_size,
 					(loff_t)pg_start << PAGE_SHIFT);
@@ -1206,7 +1332,7 @@ static int f2fs_zero_range(struct inode *inode, loff_t offset, loff_t len,
 			f2fs_lock_op(sbi);
 
 			set_new_dnode(&dn, inode, NULL, NULL, 0);
-			ret = get_dnode_of_data(&dn, index, ALLOC_NODE);
+			ret = f2fs_get_dnode_of_data(&dn, index, ALLOC_NODE);
 			if (ret) {
 				f2fs_unlock_op(sbi);
 				goto out;
@@ -1218,6 +1344,9 @@ static int f2fs_zero_range(struct inode *inode, loff_t offset, loff_t len,
 			ret = f2fs_do_zero_range(&dn, index, end);
 			f2fs_put_dnode(&dn);
 			f2fs_unlock_op(sbi);
+
+			f2fs_balance_fs(sbi, dn.node_changed);
+
 			if (ret)
 				goto out;
 
@@ -1236,8 +1365,14 @@ static int f2fs_zero_range(struct inode *inode, loff_t offset, loff_t len,
 	}
 
 out:
-	if (!(mode & FALLOC_FL_KEEP_SIZE) && i_size_read(inode) < new_size)
-		f2fs_i_size_write(inode, new_size);
+	if (new_size > i_size_read(inode)) {
+		if (mode & FALLOC_FL_KEEP_SIZE)
+			file_set_keep_isize(inode);
+		else
+			f2fs_i_size_write(inode, new_size);
+	}
+out_sem:
+	up_write(&F2FS_I(inode)->i_mmap_sem);
 
 	return ret;
 }
@@ -1250,8 +1385,9 @@ static int f2fs_insert_range(struct inode *inode, loff_t offset, loff_t len)
 	int ret = 0;
 
 	new_size = i_size_read(inode) + len;
-	if (new_size > inode->i_sb->s_maxbytes)
-		return -EFBIG;
+	ret = inode_newsize_ok(inode, new_size);
+	if (ret)
+		return ret;
 
 	if (offset >= i_size_read(inode))
 		return -EINVAL;
@@ -1266,14 +1402,18 @@ static int f2fs_insert_range(struct inode *inode, loff_t offset, loff_t len)
 
 	f2fs_balance_fs(sbi, true);
 
-	ret = truncate_blocks(inode, i_size_read(inode), true);
+	/* avoid gc operation during block exchange */
+	down_write(&F2FS_I(inode)->i_gc_rwsem[WRITE]);
+
+	down_write(&F2FS_I(inode)->i_mmap_sem);
+	ret = f2fs_truncate_blocks(inode, i_size_read(inode), true);
 	if (ret)
-		return ret;
+		goto out;
 
 	/* write out all dirty pages from offset */
 	ret = filemap_write_and_wait_range(inode->i_mapping, offset, LLONG_MAX);
 	if (ret)
-		return ret;
+		goto out;
 
 	truncate_pagecache(inode, offset);
 
@@ -1302,6 +1442,9 @@ static int f2fs_insert_range(struct inode *inode, loff_t offset, loff_t len)
 
 	if (!ret)
 		f2fs_i_size_write(inode, new_size);
+out:
+	up_write(&F2FS_I(inode)->i_mmap_sem);
+	up_write(&F2FS_I(inode)->i_gc_rwsem[WRITE]);
 	return ret;
 }
 
@@ -1309,19 +1452,20 @@ static int expand_inode_data(struct inode *inode, loff_t offset,
 					loff_t len, int mode)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
-	struct f2fs_map_blocks map = { .m_next_pgofs = NULL };
+	struct f2fs_map_blocks map = { .m_next_pgofs = NULL,
+			.m_next_extent = NULL, .m_seg_type = NO_CHECK_TYPE };
 	pgoff_t pg_end;
 	loff_t new_size = i_size_read(inode);
 	loff_t off_end;
-	int ret;
+	int err;
 
-	ret = inode_newsize_ok(inode, (len + offset));
-	if (ret)
-		return ret;
+	err = inode_newsize_ok(inode, (len + offset));
+	if (err)
+		return err;
 
-	ret = f2fs_convert_inline_inode(inode);
-	if (ret)
-		return ret;
+	err = f2fs_convert_inline_inode(inode);
+	if (err)
+		return err;
 
 	f2fs_balance_fs(sbi, true);
 
@@ -1333,26 +1477,30 @@ static int expand_inode_data(struct inode *inode, loff_t offset,
 	if (off_end)
 		map.m_len++;
 
-	ret = f2fs_map_blocks(inode, &map, 1, F2FS_GET_BLOCK_PRE_AIO);
-	if (ret) {
+	err = f2fs_map_blocks(inode, &map, 1, F2FS_GET_BLOCK_PRE_AIO);
+	if (err) {
 		pgoff_t last_off;
 
 		if (!map.m_len)
-			return ret;
+			return err;
 
 		last_off = map.m_lblk + map.m_len - 1;
 
 		/* update new size to the failed position */
-		new_size = (last_off == pg_end) ? offset + len:
+		new_size = (last_off == pg_end) ? offset + len :
 					(loff_t)(last_off + 1) << PAGE_SHIFT;
 	} else {
 		new_size = ((loff_t)pg_end << PAGE_SHIFT) + off_end;
 	}
 
-	if (!(mode & FALLOC_FL_KEEP_SIZE) && i_size_read(inode) < new_size)
-		f2fs_i_size_write(inode, new_size);
+	if (new_size > i_size_read(inode)) {
+		if (mode & FALLOC_FL_KEEP_SIZE)
+			file_set_keep_isize(inode);
+		else
+			f2fs_i_size_write(inode, new_size);
+	}
 
-	return ret;
+	return err;
 }
 
 static long f2fs_fallocate(struct file *file, int mode,
@@ -1361,6 +1509,9 @@ static long f2fs_fallocate(struct file *file, int mode,
 	struct inode *inode = file_inode(file);
 	long ret = 0;
 
+	if (unlikely(f2fs_cp_error(F2FS_I_SB(inode))))
+		return -EIO;
+
 	/* f2fs only support ->fallocate for regular file */
 	if (!S_ISREG(inode->i_mode))
 		return -EINVAL;
@@ -1393,7 +1544,7 @@ static long f2fs_fallocate(struct file *file, int mode,
 
 	if (!ret) {
 		inode->i_mtime = inode->i_ctime = current_time(inode);
-		f2fs_mark_inode_dirty_sync(inode);
+		f2fs_mark_inode_dirty_sync(inode, false);
 		f2fs_update_time(F2FS_I_SB(inode), REQ_TIME);
 	}
 
@@ -1416,34 +1567,46 @@ static int f2fs_release_file(struct inode *inode, struct file *filp)
 
 	/* some remained atomic pages should discarded */
 	if (f2fs_is_atomic_file(inode))
-		drop_inmem_pages(inode);
+		f2fs_drop_inmem_pages(inode);
 	if (f2fs_is_volatile_file(inode)) {
-		clear_inode_flag(inode, FI_VOLATILE_FILE);
 		set_inode_flag(inode, FI_DROP_CACHE);
 		filemap_fdatawrite(inode->i_mapping);
 		clear_inode_flag(inode, FI_DROP_CACHE);
+		clear_inode_flag(inode, FI_VOLATILE_FILE);
+		stat_dec_volatile_write(inode);
 	}
 	return 0;
 }
 
-#define F2FS_REG_FLMASK		(~(FS_DIRSYNC_FL | FS_TOPDIR_FL))
-#define F2FS_OTHER_FLMASK	(FS_NODUMP_FL | FS_NOATIME_FL)
-
-static inline __u32 f2fs_mask_flags(umode_t mode, __u32 flags)
+static int f2fs_file_flush(struct file *file, fl_owner_t id)
 {
-	if (S_ISDIR(mode))
-		return flags;
-	else if (S_ISREG(mode))
-		return flags & F2FS_REG_FLMASK;
-	else
-		return flags & F2FS_OTHER_FLMASK;
+	struct inode *inode = file_inode(file);
+
+	/*
+	 * If the process doing a transaction is crashed, we should do
+	 * roll-back. Otherwise, other reader/write can see corrupted database
+	 * until all the writers close its file. Since this should be done
+	 * before dropping file lock, it needs to do in ->flush.
+	 */
+	if (f2fs_is_atomic_file(inode) &&
+			F2FS_I(inode)->inmem_task == current)
+		f2fs_drop_inmem_pages(inode);
+	return 0;
 }
 
 static int f2fs_ioc_getflags(struct file *filp, unsigned long arg)
 {
 	struct inode *inode = file_inode(filp);
 	struct f2fs_inode_info *fi = F2FS_I(inode);
-	unsigned int flags = fi->i_flags & FS_FL_USER_VISIBLE;
+	unsigned int flags = fi->i_flags;
+
+	if (file_is_encrypt(inode))
+		flags |= F2FS_ENCRYPT_FL;
+	if (f2fs_has_inline_data(inode) || f2fs_has_inline_dentry(inode))
+		flags |= F2FS_INLINE_DATA_FL;
+
+	flags &= F2FS_FL_USER_VISIBLE;
+
 	return put_user(flags, (int __user *)arg);
 }
 
@@ -1465,28 +1628,34 @@ static int f2fs_ioc_setflags(struct file *filp, unsigned long arg)
 	if (ret)
 		return ret;
 
-	flags = f2fs_mask_flags(inode->i_mode, flags);
-
 	inode_lock(inode);
 
+	/* Is it quota file? Do not allow user to mess with it */
+	if (IS_NOQUOTA(inode)) {
+		ret = -EPERM;
+		goto unlock_out;
+	}
+
+	flags = f2fs_mask_flags(inode->i_mode, flags);
+
 	oldflags = fi->i_flags;
 
-	if ((flags ^ oldflags) & (FS_APPEND_FL | FS_IMMUTABLE_FL)) {
+	if ((flags ^ oldflags) & (F2FS_APPEND_FL | F2FS_IMMUTABLE_FL)) {
 		if (!capable(CAP_LINUX_IMMUTABLE)) {
-			inode_unlock(inode);
 			ret = -EPERM;
-			goto out;
+			goto unlock_out;
 		}
 	}
 
-	flags = flags & FS_FL_USER_MODIFIABLE;
-	flags |= oldflags & ~FS_FL_USER_MODIFIABLE;
+	flags = flags & (F2FS_FL_USER_MODIFIABLE);
+	flags |= oldflags & ~(F2FS_FL_USER_MODIFIABLE);
 	fi->i_flags = flags;
-	inode_unlock(inode);
 
 	inode->i_ctime = current_time(inode);
 	f2fs_set_inode_flags(inode);
-out:
+	f2fs_mark_inode_dirty_sync(inode, false);
+unlock_out:
+	inode_unlock(inode);
 	mnt_drop_write_file(filp);
 	return ret;
 }
@@ -1506,13 +1675,16 @@ static int f2fs_ioc_start_atomic_write(struct file *filp)
 	if (!inode_owner_or_capable(inode))
 		return -EACCES;
 
+	if (!S_ISREG(inode->i_mode))
+		return -EINVAL;
+
 	ret = mnt_want_write_file(filp);
 	if (ret)
 		return ret;
 
 	inode_lock(inode);
 
-	down_write(&F2FS_I(inode)->dio_rwsem[WRITE]);
+	down_write(&F2FS_I(inode)->i_gc_rwsem[WRITE]);
 
 	if (f2fs_is_atomic_file(inode))
 		goto out;
@@ -1521,20 +1693,25 @@ static int f2fs_ioc_start_atomic_write(struct file *filp)
 	if (ret)
 		goto out;
 
-	set_inode_flag(inode, FI_ATOMIC_FILE);
-	f2fs_update_time(F2FS_I_SB(inode), REQ_TIME);
-
 	if (!get_dirty_pages(inode))
-		goto out;
+		goto skip_flush;
 
 	f2fs_msg(F2FS_I_SB(inode)->sb, KERN_WARNING,
 		"Unexpected flush for atomic writes: ino=%lu, npages=%u",
 					inode->i_ino, get_dirty_pages(inode));
 	ret = filemap_write_and_wait_range(inode->i_mapping, 0, LLONG_MAX);
 	if (ret)
-		clear_inode_flag(inode, FI_ATOMIC_FILE);
+		goto out;
+skip_flush:
+	set_inode_flag(inode, FI_ATOMIC_FILE);
+	clear_inode_flag(inode, FI_ATOMIC_REVOKE_REQUEST);
+	f2fs_update_time(F2FS_I_SB(inode), REQ_TIME);
+
+	F2FS_I(inode)->inmem_task = current;
+	stat_inc_atomic_write(inode);
+	stat_update_max_atomic_write(inode);
 out:
-	up_write(&F2FS_I(inode)->dio_rwsem[WRITE]);
+	up_write(&F2FS_I(inode)->i_gc_rwsem[WRITE]);
 	inode_unlock(inode);
 	mnt_drop_write_file(filp);
 	return ret;
@@ -1554,20 +1731,33 @@ static int f2fs_ioc_commit_atomic_write(struct file *filp)
 
 	inode_lock(inode);
 
-	if (f2fs_is_volatile_file(inode))
+	down_write(&F2FS_I(inode)->i_gc_rwsem[WRITE]);
+
+	if (f2fs_is_volatile_file(inode)) {
+		ret = -EINVAL;
 		goto err_out;
+	}
 
 	if (f2fs_is_atomic_file(inode)) {
-		clear_inode_flag(inode, FI_ATOMIC_FILE);
-		ret = commit_inmem_pages(inode);
-		if (ret) {
-			set_inode_flag(inode, FI_ATOMIC_FILE);
+		ret = f2fs_commit_inmem_pages(inode);
+		if (ret)
 			goto err_out;
+
+		ret = f2fs_do_sync_file(filp, 0, LLONG_MAX, 0, true);
+		if (!ret) {
+			clear_inode_flag(inode, FI_ATOMIC_FILE);
+			F2FS_I(inode)->i_gc_failures[GC_FAILURE_ATOMIC] = 0;
+			stat_dec_atomic_write(inode);
 		}
+	} else {
+		ret = f2fs_do_sync_file(filp, 0, LLONG_MAX, 1, false);
 	}
-
-	ret = f2fs_do_sync_file(filp, 0, LLONG_MAX, 0, true);
 err_out:
+	if (is_inode_flag_set(inode, FI_ATOMIC_REVOKE_REQUEST)) {
+		clear_inode_flag(inode, FI_ATOMIC_REVOKE_REQUEST);
+		ret = -EINVAL;
+	}
+	up_write(&F2FS_I(inode)->i_gc_rwsem[WRITE]);
 	inode_unlock(inode);
 	mnt_drop_write_file(filp);
 	return ret;
@@ -1581,6 +1771,9 @@ static int f2fs_ioc_start_volatile_write(struct file *filp)
 	if (!inode_owner_or_capable(inode))
 		return -EACCES;
 
+	if (!S_ISREG(inode->i_mode))
+		return -EINVAL;
+
 	ret = mnt_want_write_file(filp);
 	if (ret)
 		return ret;
@@ -1594,6 +1787,9 @@ static int f2fs_ioc_start_volatile_write(struct file *filp)
 	if (ret)
 		goto out;
 
+	stat_inc_volatile_write(inode);
+	stat_update_max_volatile_write(inode);
+
 	set_inode_flag(inode, FI_VOLATILE_FILE);
 	f2fs_update_time(F2FS_I_SB(inode), REQ_TIME);
 out:
@@ -1646,9 +1842,10 @@ static int f2fs_ioc_abort_volatile_write(struct file *filp)
 	inode_lock(inode);
 
 	if (f2fs_is_atomic_file(inode))
-		drop_inmem_pages(inode);
+		f2fs_drop_inmem_pages(inode);
 	if (f2fs_is_volatile_file(inode)) {
 		clear_inode_flag(inode, FI_VOLATILE_FILE);
+		stat_dec_volatile_write(inode);
 		ret = f2fs_do_sync_file(filp, 0, LLONG_MAX, 0, true);
 	}
 
@@ -1682,27 +1879,40 @@ static int f2fs_ioc_shutdown(struct file *filp, unsigned long arg)
 	switch (in) {
 	case F2FS_GOING_DOWN_FULLSYNC:
 		sb = freeze_bdev(sb->s_bdev);
-		if (sb && !IS_ERR(sb)) {
+		if (IS_ERR(sb)) {
+			ret = PTR_ERR(sb);
+			goto out;
+		}
+		if (sb) {
 			f2fs_stop_checkpoint(sbi, false);
 			thaw_bdev(sb->s_bdev, sb);
 		}
 		break;
 	case F2FS_GOING_DOWN_METASYNC:
 		/* do checkpoint only */
-		f2fs_sync_fs(sb, 1);
+		ret = f2fs_sync_fs(sb, 1);
+		if (ret)
+			goto out;
 		f2fs_stop_checkpoint(sbi, false);
 		break;
 	case F2FS_GOING_DOWN_NOSYNC:
 		f2fs_stop_checkpoint(sbi, false);
 		break;
 	case F2FS_GOING_DOWN_METAFLUSH:
-		sync_meta_pages(sbi, META, LONG_MAX);
+		f2fs_sync_meta_pages(sbi, META, LONG_MAX, FS_META_IO);
 		f2fs_stop_checkpoint(sbi, false);
 		break;
 	default:
 		ret = -EINVAL;
 		goto out;
 	}
+
+	f2fs_stop_gc_thread(sbi);
+	f2fs_stop_discard_thread(sbi);
+
+	f2fs_drop_discard_cmd(sbi);
+	clear_opt(sbi, DISCARD);
+
 	f2fs_update_time(sbi, REQ_TIME);
 out:
 	if (in != F2FS_GOING_DOWN_FULLSYNC)
@@ -1758,31 +1968,21 @@ static bool uuid_is_nonzero(__u8 u[16])
 
 static int f2fs_ioc_set_encryption_policy(struct file *filp, unsigned long arg)
 {
-	struct fscrypt_policy policy;
 	struct inode *inode = file_inode(filp);
 
-	if (copy_from_user(&policy, (struct fscrypt_policy __user *)arg,
-							sizeof(policy)))
-		return -EFAULT;
+	if (!f2fs_sb_has_encrypt(inode->i_sb))
+		return -EOPNOTSUPP;
 
 	f2fs_update_time(F2FS_I_SB(inode), REQ_TIME);
 
-	return fscrypt_process_policy(filp, &policy);
+	return fscrypt_ioctl_set_policy(filp, (const void __user *)arg);
 }
 
 static int f2fs_ioc_get_encryption_policy(struct file *filp, unsigned long arg)
 {
-	struct fscrypt_policy policy;
-	struct inode *inode = file_inode(filp);
-	int err;
-
-	err = fscrypt_get_policy(inode, &policy);
-	if (err)
-		return err;
-
-	if (copy_to_user((struct fscrypt_policy __user *)arg, &policy, sizeof(policy)))
-		return -EFAULT;
-	return 0;
+	if (!f2fs_sb_has_encrypt(file_inode(filp)->i_sb))
+		return -EOPNOTSUPP;
+	return fscrypt_ioctl_get_policy(filp, (void __user *)arg);
 }
 
 static int f2fs_ioc_get_encryption_pwsalt(struct file *filp, unsigned long arg)
@@ -1791,16 +1991,18 @@ static int f2fs_ioc_get_encryption_pwsalt(struct file *filp, unsigned long arg)
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	int err;
 
-	if (!f2fs_sb_has_crypto(inode->i_sb))
+	if (!f2fs_sb_has_encrypt(inode->i_sb))
 		return -EOPNOTSUPP;
 
-	if (uuid_is_nonzero(sbi->raw_super->encrypt_pw_salt))
-		goto got_it;
-
 	err = mnt_want_write_file(filp);
 	if (err)
 		return err;
 
+	down_write(&sbi->sb_lock);
+
+	if (uuid_is_nonzero(sbi->raw_super->encrypt_pw_salt))
+		goto got_it;
+
 	/* update superblock with uuid */
 	generate_random_uuid(sbi->raw_super->encrypt_pw_salt);
 
@@ -1808,15 +2010,16 @@ static int f2fs_ioc_get_encryption_pwsalt(struct file *filp, unsigned long arg)
 	if (err) {
 		/* undo new data */
 		memset(sbi->raw_super->encrypt_pw_salt, 0, 16);
-		mnt_drop_write_file(filp);
-		return err;
+		goto out_err;
 	}
-	mnt_drop_write_file(filp);
 got_it:
 	if (copy_to_user((__u8 __user *)arg, sbi->raw_super->encrypt_pw_salt,
 									16))
-		return -EFAULT;
-	return 0;
+		err = -EFAULT;
+out_err:
+	up_write(&sbi->sb_lock);
+	mnt_drop_write_file(filp);
+	return err;
 }
 
 static int f2fs_ioc_gc(struct file *filp, unsigned long arg)
@@ -1848,13 +2051,59 @@ static int f2fs_ioc_gc(struct file *filp, unsigned long arg)
 		mutex_lock(&sbi->gc_mutex);
 	}
 
-	ret = f2fs_gc(sbi, sync);
+	ret = f2fs_gc(sbi, sync, true, NULL_SEGNO);
 out:
 	mnt_drop_write_file(filp);
 	return ret;
 }
 
-static int f2fs_ioc_write_checkpoint(struct file *filp, unsigned long arg)
+static int f2fs_ioc_gc_range(struct file *filp, unsigned long arg)
+{
+	struct inode *inode = file_inode(filp);
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+	struct f2fs_gc_range range;
+	u64 end;
+	int ret;
+
+	if (!capable(CAP_SYS_ADMIN))
+		return -EPERM;
+
+	if (copy_from_user(&range, (struct f2fs_gc_range __user *)arg,
+							sizeof(range)))
+		return -EFAULT;
+
+	if (f2fs_readonly(sbi->sb))
+		return -EROFS;
+
+	end = range.start + range.len;
+	if (range.start < MAIN_BLKADDR(sbi) || end >= MAX_BLKADDR(sbi)) {
+		return -EINVAL;
+	}
+
+	ret = mnt_want_write_file(filp);
+	if (ret)
+		return ret;
+
+do_more:
+	if (!range.sync) {
+		if (!mutex_trylock(&sbi->gc_mutex)) {
+			ret = -EBUSY;
+			goto out;
+		}
+	} else {
+		mutex_lock(&sbi->gc_mutex);
+	}
+
+	ret = f2fs_gc(sbi, range.sync, true, GET_SEGNO(sbi, range.start));
+	range.start += sbi->blocks_per_seg;
+	if (range.start <= end)
+		goto do_more;
+out:
+	mnt_drop_write_file(filp);
+	return ret;
+}
+
+static int f2fs_ioc_f2fs_write_checkpoint(struct file *filp, unsigned long arg)
 {
 	struct inode *inode = file_inode(filp);
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
@@ -1881,18 +2130,18 @@ static int f2fs_defragment_range(struct f2fs_sb_info *sbi,
 					struct f2fs_defragment *range)
 {
 	struct inode *inode = file_inode(filp);
-	struct f2fs_map_blocks map = { .m_next_pgofs = NULL };
-	struct extent_info ei;
-	pgoff_t pg_start, pg_end;
+	struct f2fs_map_blocks map = { .m_next_extent = NULL,
+					.m_seg_type = NO_CHECK_TYPE };
+	struct extent_info ei = {0, 0, 0};
+	pgoff_t pg_start, pg_end, next_pgofs;
 	unsigned int blk_per_seg = sbi->blocks_per_seg;
 	unsigned int total = 0, sec_num;
-	unsigned int pages_per_sec = sbi->segs_per_sec * blk_per_seg;
 	block_t blk_end = 0;
 	bool fragmented = false;
 	int err;
 
 	/* if in-place-update policy is enabled, don't waste time here */
-	if (need_inplace_update(inode))
+	if (f2fs_should_update_inplace(inode, NULL))
 		return -EINVAL;
 
 	pg_start = range->start >> PAGE_SHIFT;
@@ -1918,6 +2167,7 @@ static int f2fs_defragment_range(struct f2fs_sb_info *sbi,
 	}
 
 	map.m_lblk = pg_start;
+	map.m_next_pgofs = &next_pgofs;
 
 	/*
 	 * lookup mapping info in dnode page cache, skip defragmenting if all
@@ -1926,19 +2176,21 @@ static int f2fs_defragment_range(struct f2fs_sb_info *sbi,
 	 */
 	while (map.m_lblk < pg_end) {
 		map.m_len = pg_end - map.m_lblk;
-		err = f2fs_map_blocks(inode, &map, 0, F2FS_GET_BLOCK_READ);
+		err = f2fs_map_blocks(inode, &map, 0, F2FS_GET_BLOCK_DEFAULT);
 		if (err)
 			goto out;
 
 		if (!(map.m_flags & F2FS_MAP_FLAGS)) {
-			map.m_lblk++;
+			map.m_lblk = next_pgofs;
 			continue;
 		}
 
-		if (blk_end && blk_end != map.m_pblk) {
+		if (blk_end && blk_end != map.m_pblk)
 			fragmented = true;
-			break;
-		}
+
+		/* record total count of block that we're going to move */
+		total += map.m_len;
+
 		blk_end = map.m_pblk + map.m_len;
 
 		map.m_lblk += map.m_len;
@@ -1947,10 +2199,7 @@ static int f2fs_defragment_range(struct f2fs_sb_info *sbi,
 	if (!fragmented)
 		goto out;
 
-	map.m_lblk = pg_start;
-	map.m_len = pg_end - pg_start;
-
-	sec_num = (map.m_len + pages_per_sec - 1) / pages_per_sec;
+	sec_num = (total + BLKS_PER_SEC(sbi) - 1) / BLKS_PER_SEC(sbi);
 
 	/*
 	 * make sure there are enough free section for LFS allocation, this can
@@ -1962,18 +2211,22 @@ static int f2fs_defragment_range(struct f2fs_sb_info *sbi,
 		goto out;
 	}
 
+	map.m_lblk = pg_start;
+	map.m_len = pg_end - pg_start;
+	total = 0;
+
 	while (map.m_lblk < pg_end) {
 		pgoff_t idx;
 		int cnt = 0;
 
 do_map:
 		map.m_len = pg_end - map.m_lblk;
-		err = f2fs_map_blocks(inode, &map, 0, F2FS_GET_BLOCK_READ);
+		err = f2fs_map_blocks(inode, &map, 0, F2FS_GET_BLOCK_DEFAULT);
 		if (err)
 			goto clear_out;
 
 		if (!(map.m_flags & F2FS_MAP_FLAGS)) {
-			map.m_lblk++;
+			map.m_lblk = next_pgofs;
 			continue;
 		}
 
@@ -1983,7 +2236,7 @@ static int f2fs_defragment_range(struct f2fs_sb_info *sbi,
 		while (idx < map.m_lblk + map.m_len && cnt < blk_per_seg) {
 			struct page *page;
 
-			page = get_lock_data_page(inode, idx, true);
+			page = f2fs_get_lock_data_page(inode, idx, true);
 			if (IS_ERR(page)) {
 				err = PTR_ERR(page);
 				goto clear_out;
@@ -2027,42 +2280,40 @@ static int f2fs_ioc_defragment(struct file *filp, unsigned long arg)
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
-	if (!S_ISREG(inode->i_mode))
+	if (!S_ISREG(inode->i_mode) || f2fs_is_atomic_file(inode))
 		return -EINVAL;
 
-	err = mnt_want_write_file(filp);
-	if (err)
-		return err;
-
-	if (f2fs_readonly(sbi->sb)) {
-		err = -EROFS;
-		goto out;
-	}
+	if (f2fs_readonly(sbi->sb))
+		return -EROFS;
 
 	if (copy_from_user(&range, (struct f2fs_defragment __user *)arg,
-							sizeof(range))) {
-		err = -EFAULT;
-		goto out;
-	}
+							sizeof(range)))
+		return -EFAULT;
 
 	/* verify alignment of offset & size */
-	if (range.start & (F2FS_BLKSIZE - 1) ||
-		range.len & (F2FS_BLKSIZE - 1)) {
-		err = -EINVAL;
-		goto out;
-	}
+	if (range.start & (F2FS_BLKSIZE - 1) || range.len & (F2FS_BLKSIZE - 1))
+		return -EINVAL;
+
+	if (unlikely((range.start + range.len) >> PAGE_SHIFT >
+					sbi->max_file_blocks))
+		return -EINVAL;
+
+	err = mnt_want_write_file(filp);
+	if (err)
+		return err;
 
 	err = f2fs_defragment_range(sbi, filp, &range);
+	mnt_drop_write_file(filp);
+
 	f2fs_update_time(sbi, REQ_TIME);
 	if (err < 0)
-		goto out;
+		return err;
 
 	if (copy_to_user((struct f2fs_defragment __user *)arg, &range,
 							sizeof(range)))
-		err = -EFAULT;
-out:
-	mnt_drop_write_file(filp);
-	return err;
+		return -EFAULT;
+
+	return 0;
 }
 
 static int f2fs_move_file_range(struct file *file_in, loff_t pos_in,
@@ -2096,9 +2347,13 @@ static int f2fs_move_file_range(struct file *file_in, loff_t pos_in,
 	}
 
 	inode_lock(src);
+	down_write(&F2FS_I(src)->i_gc_rwsem[WRITE]);
 	if (src != dst) {
-		if (!inode_trylock(dst)) {
-			ret = -EBUSY;
+		ret = -EBUSY;
+		if (!inode_trylock(dst))
+			goto out;
+		if (!down_write_trylock(&F2FS_I(dst)->i_gc_rwsem[WRITE])) {
+			inode_unlock(dst);
 			goto out;
 		}
 	}
@@ -2158,9 +2413,12 @@ static int f2fs_move_file_range(struct file *file_in, loff_t pos_in,
 	}
 	f2fs_unlock_op(sbi);
 out_unlock:
-	if (src != dst)
+	if (src != dst) {
+		up_write(&F2FS_I(dst)->i_gc_rwsem[WRITE]);
 		inode_unlock(dst);
+	}
 out:
+	up_write(&F2FS_I(src)->i_gc_rwsem[WRITE]);
 	inode_unlock(src);
 	return ret;
 }
@@ -2196,6 +2454,8 @@ static int f2fs_ioc_move_range(struct file *filp, unsigned long arg)
 					range.pos_out, range.len);
 
 	mnt_drop_write_file(filp);
+	if (err)
+		goto err_out;
 
 	if (copy_to_user((struct f2fs_move_range __user *)arg,
 						&range, sizeof(range)))
@@ -2205,8 +2465,205 @@ static int f2fs_ioc_move_range(struct file *filp, unsigned long arg)
 	return err;
 }
 
+static int f2fs_ioc_flush_device(struct file *filp, unsigned long arg)
+{
+	struct inode *inode = file_inode(filp);
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+	struct sit_info *sm = SIT_I(sbi);
+	unsigned int start_segno = 0, end_segno = 0;
+	unsigned int dev_start_segno = 0, dev_end_segno = 0;
+	struct f2fs_flush_device range;
+	int ret;
+
+	if (!capable(CAP_SYS_ADMIN))
+		return -EPERM;
+
+	if (f2fs_readonly(sbi->sb))
+		return -EROFS;
+
+	if (copy_from_user(&range, (struct f2fs_flush_device __user *)arg,
+							sizeof(range)))
+		return -EFAULT;
+
+	if (sbi->s_ndevs <= 1 || sbi->s_ndevs - 1 <= range.dev_num ||
+			sbi->segs_per_sec != 1) {
+		f2fs_msg(sbi->sb, KERN_WARNING,
+			"Can't flush %u in %d for segs_per_sec %u != 1\n",
+				range.dev_num, sbi->s_ndevs,
+				sbi->segs_per_sec);
+		return -EINVAL;
+	}
+
+	ret = mnt_want_write_file(filp);
+	if (ret)
+		return ret;
+
+	if (range.dev_num != 0)
+		dev_start_segno = GET_SEGNO(sbi, FDEV(range.dev_num).start_blk);
+	dev_end_segno = GET_SEGNO(sbi, FDEV(range.dev_num).end_blk);
+
+	start_segno = sm->last_victim[FLUSH_DEVICE];
+	if (start_segno < dev_start_segno || start_segno >= dev_end_segno)
+		start_segno = dev_start_segno;
+	end_segno = min(start_segno + range.segments, dev_end_segno);
+
+	while (start_segno < end_segno) {
+		if (!mutex_trylock(&sbi->gc_mutex)) {
+			ret = -EBUSY;
+			goto out;
+		}
+		sm->last_victim[GC_CB] = end_segno + 1;
+		sm->last_victim[GC_GREEDY] = end_segno + 1;
+		sm->last_victim[ALLOC_NEXT] = end_segno + 1;
+		ret = f2fs_gc(sbi, true, true, start_segno);
+		if (ret == -EAGAIN)
+			ret = 0;
+		else if (ret < 0)
+			break;
+		start_segno++;
+	}
+out:
+	mnt_drop_write_file(filp);
+	return ret;
+}
+
+static int f2fs_ioc_get_features(struct file *filp, unsigned long arg)
+{
+	struct inode *inode = file_inode(filp);
+	u32 sb_feature = le32_to_cpu(F2FS_I_SB(inode)->raw_super->feature);
+
+	/* Must validate to set it with SQLite behavior in Android. */
+	sb_feature |= F2FS_FEATURE_ATOMIC_WRITE;
+
+	return put_user(sb_feature, (u32 __user *)arg);
+}
+
+int f2fs_pin_file_control(struct inode *inode, bool inc)
+{
+	struct f2fs_inode_info *fi = F2FS_I(inode);
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+
+	/* Use i_gc_failures for normal file as a risk signal. */
+	if (inc)
+		f2fs_i_gc_failures_write(inode,
+				fi->i_gc_failures[GC_FAILURE_PIN] + 1);
+
+	if (fi->i_gc_failures[GC_FAILURE_PIN] > sbi->gc_pin_file_threshold) {
+		f2fs_msg(sbi->sb, KERN_WARNING,
+			"%s: Enable GC = ino %lx after %x GC trials\n",
+			__func__, inode->i_ino,
+			fi->i_gc_failures[GC_FAILURE_PIN]);
+		clear_inode_flag(inode, FI_PIN_FILE);
+		return -EAGAIN;
+	}
+	return 0;
+}
+
+static int f2fs_ioc_set_pin_file(struct file *filp, unsigned long arg)
+{
+	struct inode *inode = file_inode(filp);
+	__u32 pin;
+	int ret = 0;
+
+	if (!inode_owner_or_capable(inode))
+		return -EACCES;
+
+	if (get_user(pin, (__u32 __user *)arg))
+		return -EFAULT;
+
+	if (!S_ISREG(inode->i_mode))
+		return -EINVAL;
+
+	if (f2fs_readonly(F2FS_I_SB(inode)->sb))
+		return -EROFS;
+
+	ret = mnt_want_write_file(filp);
+	if (ret)
+		return ret;
+
+	inode_lock(inode);
+
+	if (f2fs_should_update_outplace(inode, NULL)) {
+		ret = -EINVAL;
+		goto out;
+	}
+
+	if (!pin) {
+		clear_inode_flag(inode, FI_PIN_FILE);
+		F2FS_I(inode)->i_gc_failures[GC_FAILURE_PIN] = 1;
+		goto done;
+	}
+
+	if (f2fs_pin_file_control(inode, false)) {
+		ret = -EAGAIN;
+		goto out;
+	}
+	ret = f2fs_convert_inline_inode(inode);
+	if (ret)
+		goto out;
+
+	set_inode_flag(inode, FI_PIN_FILE);
+	ret = F2FS_I(inode)->i_gc_failures[GC_FAILURE_PIN];
+done:
+	f2fs_update_time(F2FS_I_SB(inode), REQ_TIME);
+out:
+	inode_unlock(inode);
+	mnt_drop_write_file(filp);
+	return ret;
+}
+
+static int f2fs_ioc_get_pin_file(struct file *filp, unsigned long arg)
+{
+	struct inode *inode = file_inode(filp);
+	__u32 pin = 0;
+
+	if (is_inode_flag_set(inode, FI_PIN_FILE))
+		pin = F2FS_I(inode)->i_gc_failures[GC_FAILURE_PIN];
+	return put_user(pin, (u32 __user *)arg);
+}
+
+int f2fs_precache_extents(struct inode *inode)
+{
+	struct f2fs_inode_info *fi = F2FS_I(inode);
+	struct f2fs_map_blocks map;
+	pgoff_t m_next_extent;
+	loff_t end;
+	int err;
+
+	if (is_inode_flag_set(inode, FI_NO_EXTENT))
+		return -EOPNOTSUPP;
+
+	map.m_lblk = 0;
+	map.m_next_pgofs = NULL;
+	map.m_next_extent = &m_next_extent;
+	map.m_seg_type = NO_CHECK_TYPE;
+	end = F2FS_I_SB(inode)->max_file_blocks;
+
+	while (map.m_lblk < end) {
+		map.m_len = end - map.m_lblk;
+
+		down_write(&fi->i_gc_rwsem[WRITE]);
+		err = f2fs_map_blocks(inode, &map, 0, F2FS_GET_BLOCK_PRECACHE);
+		up_write(&fi->i_gc_rwsem[WRITE]);
+		if (err)
+			return err;
+
+		map.m_lblk = m_next_extent;
+	}
+
+	return err;
+}
+
+static int f2fs_ioc_precache_extents(struct file *filp, unsigned long arg)
+{
+	return f2fs_precache_extents(file_inode(filp));
+}
+
 long f2fs_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 {
+	if (unlikely(f2fs_cp_error(F2FS_I_SB(file_inode(filp)))))
+		return -EIO;
+
 	switch (cmd) {
 	case F2FS_IOC_GETFLAGS:
 		return f2fs_ioc_getflags(filp, arg);
@@ -2236,12 +2693,24 @@ long f2fs_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 		return f2fs_ioc_get_encryption_pwsalt(filp, arg);
 	case F2FS_IOC_GARBAGE_COLLECT:
 		return f2fs_ioc_gc(filp, arg);
+	case F2FS_IOC_GARBAGE_COLLECT_RANGE:
+		return f2fs_ioc_gc_range(filp, arg);
 	case F2FS_IOC_WRITE_CHECKPOINT:
-		return f2fs_ioc_write_checkpoint(filp, arg);
+		return f2fs_ioc_f2fs_write_checkpoint(filp, arg);
 	case F2FS_IOC_DEFRAGMENT:
 		return f2fs_ioc_defragment(filp, arg);
 	case F2FS_IOC_MOVE_RANGE:
 		return f2fs_ioc_move_range(filp, arg);
+	case F2FS_IOC_FLUSH_DEVICE:
+		return f2fs_ioc_flush_device(filp, arg);
+	case F2FS_IOC_GET_FEATURES:
+		return f2fs_ioc_get_features(filp, arg);
+	case F2FS_IOC_GET_PIN_FILE:
+		return f2fs_ioc_get_pin_file(filp, arg);
+	case F2FS_IOC_SET_PIN_FILE:
+		return f2fs_ioc_set_pin_file(filp, arg);
+	case F2FS_IOC_PRECACHE_EXTENTS:
+		return f2fs_ioc_precache_extents(filp, arg);
 	default:
 		return -ENOTTY;
 	}
@@ -2251,23 +2720,61 @@ static ssize_t f2fs_file_write_iter(struct kiocb *iocb, struct iov_iter *from)
 {
 	struct file *file = iocb->ki_filp;
 	struct inode *inode = file_inode(file);
-	struct blk_plug plug;
 	ssize_t ret;
 
-	if (f2fs_encrypted_inode(inode) &&
-				!fscrypt_has_encryption_key(inode) &&
-				fscrypt_get_encryption_info(inode))
-		return -EACCES;
+	if (unlikely(f2fs_cp_error(F2FS_I_SB(inode))))
+		return -EIO;
+
+	if ((iocb->ki_flags & IOCB_NOWAIT) && !(iocb->ki_flags & IOCB_DIRECT))
+		return -EINVAL;
+
+	if (!inode_trylock(inode)) {
+		if (iocb->ki_flags & IOCB_NOWAIT)
+			return -EAGAIN;
+		inode_lock(inode);
+	}
 
-	inode_lock(inode);
 	ret = generic_write_checks(iocb, from);
 	if (ret > 0) {
-		ret = f2fs_preallocate_blocks(iocb, from);
-		if (!ret) {
-			blk_start_plug(&plug);
-			ret = __generic_file_write_iter(iocb, from);
-			blk_finish_plug(&plug);
+		bool preallocated = false;
+		size_t target_size = 0;
+		int err;
+
+		if (iov_iter_fault_in_readable(from, iov_iter_count(from)))
+			set_inode_flag(inode, FI_NO_PREALLOC);
+
+		if ((iocb->ki_flags & IOCB_NOWAIT) &&
+			(iocb->ki_flags & IOCB_DIRECT)) {
+				if (!f2fs_overwrite_io(inode, iocb->ki_pos,
+						iov_iter_count(from)) ||
+					f2fs_has_inline_data(inode) ||
+					f2fs_force_buffered_io(inode, WRITE)) {
+						clear_inode_flag(inode,
+								FI_NO_PREALLOC);
+						inode_unlock(inode);
+						return -EAGAIN;
+				}
+
+		} else {
+			preallocated = true;
+			target_size = iocb->ki_pos + iov_iter_count(from);
+
+			err = f2fs_preallocate_blocks(iocb, from);
+			if (err) {
+				clear_inode_flag(inode, FI_NO_PREALLOC);
+				inode_unlock(inode);
+				return err;
+			}
 		}
+		ret = __generic_file_write_iter(iocb, from);
+		clear_inode_flag(inode, FI_NO_PREALLOC);
+
+		/* if we couldn't write data, we should deallocate blocks. */
+		if (preallocated && i_size_read(inode) < target_size)
+			f2fs_truncate(inode);
+
+		if (ret > 0)
+			f2fs_update_iostat(F2FS_I_SB(inode), APP_WRITE_IO, ret);
 	}
 	inode_unlock(inode);
 
@@ -2299,10 +2806,15 @@ long f2fs_compat_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
 	case F2FS_IOC_GET_ENCRYPTION_PWSALT:
 	case F2FS_IOC_GET_ENCRYPTION_POLICY:
 	case F2FS_IOC_GARBAGE_COLLECT:
+	case F2FS_IOC_GARBAGE_COLLECT_RANGE:
 	case F2FS_IOC_WRITE_CHECKPOINT:
 	case F2FS_IOC_DEFRAGMENT:
-		break;
 	case F2FS_IOC_MOVE_RANGE:
+	case F2FS_IOC_FLUSH_DEVICE:
+	case F2FS_IOC_GET_FEATURES:
+	case F2FS_IOC_GET_PIN_FILE:
+	case F2FS_IOC_SET_PIN_FILE:
+	case F2FS_IOC_PRECACHE_EXTENTS:
 		break;
 	default:
 		return -ENOIOCTLCMD;
@@ -2318,6 +2830,7 @@ long f2fs_compat_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
 	.open		= f2fs_file_open,
 	.release	= f2fs_release_file,
 	.mmap		= f2fs_file_mmap,
+	.flush		= f2fs_file_flush,
 	.fsync		= f2fs_sync_file,
 	.fallocate	= f2fs_fallocate,
 	.unlocked_ioctl	= f2fs_ioctl,
diff --git a/fs/f2fs/gc.c b/fs/f2fs/gc.c
index ad4dfd2..857dcc0 100644
--- a/fs/f2fs/gc.c
+++ b/fs/f2fs/gc.c
@@ -28,17 +28,23 @@ static int gc_thread_func(void *data)
 	struct f2fs_sb_info *sbi = data;
 	struct f2fs_gc_kthread *gc_th = sbi->gc_thread;
 	wait_queue_head_t *wq = &sbi->gc_thread->gc_wait_queue_head;
-	long wait_ms;
+	unsigned int wait_ms;
 
 	wait_ms = gc_th->min_sleep_time;
 
+	set_freezable();
 	do {
+		wait_event_interruptible_timeout(*wq,
+				kthread_should_stop() || freezing(current) ||
+				gc_th->gc_wake,
+				msecs_to_jiffies(wait_ms));
+
+		/* give it a try one time */
+		if (gc_th->gc_wake)
+			gc_th->gc_wake = 0;
+
 		if (try_to_freeze())
 			continue;
-		else
-			wait_event_interruptible_timeout(*wq,
-						kthread_should_stop(),
-						msecs_to_jiffies(wait_ms));
 		if (kthread_should_stop())
 			break;
 
@@ -48,10 +54,15 @@ static int gc_thread_func(void *data)
 		}
 
 #ifdef CONFIG_F2FS_FAULT_INJECTION
-		if (time_to_inject(sbi, FAULT_CHECKPOINT))
+		if (time_to_inject(sbi, FAULT_CHECKPOINT)) {
+			f2fs_show_injection_info(FAULT_CHECKPOINT);
 			f2fs_stop_checkpoint(sbi, false);
+		}
 #endif
 
+		if (!sb_start_write_trylock(sbi->sb))
+			continue;
+
 		/*
 		 * [GC triggering condition]
 		 * 0. GC is not conducted currently.
@@ -65,24 +76,30 @@ static int gc_thread_func(void *data)
 		 * invalidated soon after by user update or deletion.
 		 * So, I'd like to wait some time to collect dirty segments.
 		 */
+		if (sbi->gc_mode == GC_URGENT) {
+			wait_ms = gc_th->urgent_sleep_time;
+			mutex_lock(&sbi->gc_mutex);
+			goto do_gc;
+		}
+
 		if (!mutex_trylock(&sbi->gc_mutex))
-			continue;
+			goto next;
 
 		if (!is_idle(sbi)) {
 			increase_sleep_time(gc_th, &wait_ms);
 			mutex_unlock(&sbi->gc_mutex);
-			continue;
+			goto next;
 		}
 
 		if (has_enough_invalid_blocks(sbi))
 			decrease_sleep_time(gc_th, &wait_ms);
 		else
 			increase_sleep_time(gc_th, &wait_ms);
-
+do_gc:
 		stat_inc_bggc_count(sbi);
 
 		/* if return value is not zero, no victim was selected */
-		if (f2fs_gc(sbi, test_opt(sbi, FORCE_FG_GC)))
+		if (f2fs_gc(sbi, test_opt(sbi, FORCE_FG_GC), true, NULL_SEGNO))
 			wait_ms = gc_th->no_gc_sleep_time;
 
 		trace_f2fs_background_gc(sbi->sb, wait_ms,
@@ -90,12 +107,14 @@ static int gc_thread_func(void *data)
 
 		/* balancing f2fs's metadata periodically */
 		f2fs_balance_fs_bg(sbi);
+next:
+		sb_end_write(sbi->sb);
 
 	} while (!kthread_should_stop());
 	return 0;
 }
 
-int start_gc_thread(struct f2fs_sb_info *sbi)
+int f2fs_start_gc_thread(struct f2fs_sb_info *sbi)
 {
 	struct f2fs_gc_kthread *gc_th;
 	dev_t dev = sbi->sb->s_bdev->bd_dev;
@@ -107,11 +126,12 @@ int start_gc_thread(struct f2fs_sb_info *sbi)
 		goto out;
 	}
 
+	gc_th->urgent_sleep_time = DEF_GC_THREAD_URGENT_SLEEP_TIME;
 	gc_th->min_sleep_time = DEF_GC_THREAD_MIN_SLEEP_TIME;
 	gc_th->max_sleep_time = DEF_GC_THREAD_MAX_SLEEP_TIME;
 	gc_th->no_gc_sleep_time = DEF_GC_THREAD_NOGC_SLEEP_TIME;
 
-	gc_th->gc_idle = 0;
+	gc_th->gc_wake= 0;
 
 	sbi->gc_thread = gc_th;
 	init_waitqueue_head(&sbi->gc_thread->gc_wait_queue_head);
@@ -126,7 +146,7 @@ int start_gc_thread(struct f2fs_sb_info *sbi)
 	return err;
 }
 
-void stop_gc_thread(struct f2fs_sb_info *sbi)
+void f2fs_stop_gc_thread(struct f2fs_sb_info *sbi)
 {
 	struct f2fs_gc_kthread *gc_th = sbi->gc_thread;
 	if (!gc_th)
@@ -136,15 +156,18 @@ void stop_gc_thread(struct f2fs_sb_info *sbi)
 	sbi->gc_thread = NULL;
 }
 
-static int select_gc_type(struct f2fs_gc_kthread *gc_th, int gc_type)
+static int select_gc_type(struct f2fs_sb_info *sbi, int gc_type)
 {
 	int gc_mode = (gc_type == BG_GC) ? GC_CB : GC_GREEDY;
 
-	if (gc_th && gc_th->gc_idle) {
-		if (gc_th->gc_idle == 1)
-			gc_mode = GC_CB;
-		else if (gc_th->gc_idle == 2)
-			gc_mode = GC_GREEDY;
+	switch (sbi->gc_mode) {
+	case GC_IDLE_CB:
+		gc_mode = GC_CB;
+		break;
+	case GC_IDLE_GREEDY:
+	case GC_URGENT:
+		gc_mode = GC_GREEDY;
+		break;
 	}
 	return gc_mode;
 }
@@ -160,17 +183,24 @@ static void select_policy(struct f2fs_sb_info *sbi, int gc_type,
 		p->max_search = dirty_i->nr_dirty[type];
 		p->ofs_unit = 1;
 	} else {
-		p->gc_mode = select_gc_type(sbi->gc_thread, gc_type);
+		p->gc_mode = select_gc_type(sbi, gc_type);
 		p->dirty_segmap = dirty_i->dirty_segmap[DIRTY];
 		p->max_search = dirty_i->nr_dirty[DIRTY];
 		p->ofs_unit = sbi->segs_per_sec;
 	}
 
 	/* we need to check every dirty segments in the FG_GC case */
-	if (gc_type != FG_GC && p->max_search > sbi->max_victim_search)
+	if (gc_type != FG_GC &&
+			(sbi->gc_mode != GC_URGENT) &&
+			p->max_search > sbi->max_victim_search)
 		p->max_search = sbi->max_victim_search;
 
-	p->offset = sbi->last_victim[p->gc_mode];
+	/* let's select beginning hot/small space first in no_heap mode*/
+	if (test_opt(sbi, NOHEAP) &&
+		(type == CURSEG_HOT_DATA || IS_NODESEG(type)))
+		p->offset = 0;
+	else
+		p->offset = SIT_I(sbi)->last_victim[p->gc_mode];
 }
 
 static unsigned int get_max_cost(struct f2fs_sb_info *sbi,
@@ -180,7 +210,7 @@ static unsigned int get_max_cost(struct f2fs_sb_info *sbi,
 	if (p->alloc_mode == SSR)
 		return sbi->blocks_per_seg;
 	if (p->gc_mode == GC_GREEDY)
-		return sbi->blocks_per_seg * p->ofs_unit;
+		return 2 * sbi->blocks_per_seg * p->ofs_unit;
 	else if (p->gc_mode == GC_CB)
 		return UINT_MAX;
 	else /* No other gc_mode */
@@ -200,12 +230,8 @@ static unsigned int check_bg_victims(struct f2fs_sb_info *sbi)
 	for_each_set_bit(secno, dirty_i->victim_secmap, MAIN_SECS(sbi)) {
 		if (sec_usage_check(sbi, secno))
 			continue;
-
-		if (no_fggc_candidate(sbi, secno))
-			continue;
-
 		clear_bit(secno, dirty_i->victim_secmap);
-		return secno * sbi->segs_per_sec;
+		return GET_SEG_FROM_SEC(sbi, secno);
 	}
 	return NULL_SEGNO;
 }
@@ -213,8 +239,8 @@ static unsigned int check_bg_victims(struct f2fs_sb_info *sbi)
 static unsigned int get_cb_cost(struct f2fs_sb_info *sbi, unsigned int segno)
 {
 	struct sit_info *sit_i = SIT_I(sbi);
-	unsigned int secno = GET_SECNO(sbi, segno);
-	unsigned int start = secno * sbi->segs_per_sec;
+	unsigned int secno = GET_SEC_FROM_SEG(sbi, segno);
+	unsigned int start = GET_SEG_FROM_SEC(sbi, secno);
 	unsigned long long mtime = 0;
 	unsigned int vblocks;
 	unsigned char age = 0;
@@ -223,7 +249,7 @@ static unsigned int get_cb_cost(struct f2fs_sb_info *sbi, unsigned int segno)
 
 	for (i = 0; i < sbi->segs_per_sec; i++)
 		mtime += get_seg_entry(sbi, start + i)->mtime;
-	vblocks = get_valid_blocks(sbi, segno, sbi->segs_per_sec);
+	vblocks = get_valid_blocks(sbi, segno, true);
 
 	mtime = div_u64(mtime, sbi->segs_per_sec);
 	vblocks = div_u64(vblocks, sbi->segs_per_sec);
@@ -250,7 +276,7 @@ static inline unsigned int get_gc_cost(struct f2fs_sb_info *sbi,
 
 	/* alloc_mode == LFS */
 	if (p->gc_mode == GC_GREEDY)
-		return get_valid_blocks(sbi, segno, sbi->segs_per_sec);
+		return get_valid_blocks(sbi, segno, true);
 	else
 		return get_cb_cost(sbi, segno);
 }
@@ -279,6 +305,7 @@ static int get_victim_by_default(struct f2fs_sb_info *sbi,
 		unsigned int *result, int gc_type, int type, char alloc_mode)
 {
 	struct dirty_seglist_info *dirty_i = DIRTY_I(sbi);
+	struct sit_info *sm = SIT_I(sbi);
 	struct victim_sel_policy p;
 	unsigned int secno, last_victim;
 	unsigned int last_segment = MAIN_SEGS(sbi);
@@ -292,10 +319,18 @@ static int get_victim_by_default(struct f2fs_sb_info *sbi,
 	p.min_segno = NULL_SEGNO;
 	p.min_cost = get_max_cost(sbi, &p);
 
+	if (*result != NULL_SEGNO) {
+		if (IS_DATASEG(get_seg_entry(sbi, *result)->type) &&
+			get_valid_blocks(sbi, *result, false) &&
+			!sec_usage_check(sbi, GET_SEC_FROM_SEG(sbi, *result)))
+			p.min_segno = *result;
+		goto out;
+	}
+
 	if (p.max_search == 0)
 		goto out;
 
-	last_victim = sbi->last_victim[p.gc_mode];
+	last_victim = sm->last_victim[p.gc_mode];
 	if (p.alloc_mode == LFS && gc_type == FG_GC) {
 		p.min_segno = check_bg_victims(sbi);
 		if (p.min_segno != NULL_SEGNO)
@@ -308,9 +343,10 @@ static int get_victim_by_default(struct f2fs_sb_info *sbi,
 
 		segno = find_next_bit(p.dirty_segmap, last_segment, p.offset);
 		if (segno >= last_segment) {
-			if (sbi->last_victim[p.gc_mode]) {
-				last_segment = sbi->last_victim[p.gc_mode];
-				sbi->last_victim[p.gc_mode] = 0;
+			if (sm->last_victim[p.gc_mode]) {
+				last_segment =
+					sm->last_victim[p.gc_mode];
+				sm->last_victim[p.gc_mode] = 0;
 				p.offset = 0;
 				continue;
 			}
@@ -327,15 +363,12 @@ static int get_victim_by_default(struct f2fs_sb_info *sbi,
 			nsearched++;
 		}
 
-		secno = GET_SECNO(sbi, segno);
+		secno = GET_SEC_FROM_SEG(sbi, segno);
 
 		if (sec_usage_check(sbi, secno))
 			goto next;
 		if (gc_type == BG_GC && test_bit(secno, dirty_i->victim_secmap))
 			goto next;
-		if (gc_type == FG_GC && p.alloc_mode == LFS &&
-					no_fggc_candidate(sbi, secno))
-			goto next;
 
 		cost = get_gc_cost(sbi, segno, &p);
 
@@ -345,17 +378,18 @@ static int get_victim_by_default(struct f2fs_sb_info *sbi,
 		}
 next:
 		if (nsearched >= p.max_search) {
-			if (!sbi->last_victim[p.gc_mode] && segno <= last_victim)
-				sbi->last_victim[p.gc_mode] = last_victim + 1;
+			if (!sm->last_victim[p.gc_mode] && segno <= last_victim)
+				sm->last_victim[p.gc_mode] = last_victim + 1;
 			else
-				sbi->last_victim[p.gc_mode] = segno + 1;
+				sm->last_victim[p.gc_mode] = segno + 1;
+			sm->last_victim[p.gc_mode] %= MAIN_SEGS(sbi);
 			break;
 		}
 	}
 	if (p.min_segno != NULL_SEGNO) {
 got_it:
 		if (p.alloc_mode == LFS) {
-			secno = GET_SECNO(sbi, p.min_segno);
+			secno = GET_SEC_FROM_SEG(sbi, p.min_segno);
 			if (gc_type == FG_GC)
 				sbi->cur_victim_sec = secno;
 			else
@@ -395,7 +429,7 @@ static void add_gc_inode(struct gc_inode_list *gc_list, struct inode *inode)
 		iput(inode);
 		return;
 	}
-	new_ie = f2fs_kmem_cache_alloc(inode_entry_slab, GFP_NOFS);
+	new_ie = f2fs_kmem_cache_alloc(f2fs_inode_entry_slab, GFP_NOFS);
 	new_ie->inode = inode;
 
 	f2fs_radix_tree_insert(&gc_list->iroot, inode->i_ino, new_ie);
@@ -409,7 +443,7 @@ static void put_gc_inode(struct gc_inode_list *gc_list)
 		radix_tree_delete(&gc_list->iroot, ie->inode->i_ino);
 		iput(ie->inode);
 		list_del(&ie->list);
-		kmem_cache_free(inode_entry_slab, ie);
+		kmem_cache_free(f2fs_inode_entry_slab, ie);
 	}
 }
 
@@ -420,10 +454,10 @@ static int check_valid_map(struct f2fs_sb_info *sbi,
 	struct seg_entry *sentry;
 	int ret;
 
-	mutex_lock(&sit_i->sentry_lock);
+	down_read(&sit_i->sentry_lock);
 	sentry = get_seg_entry(sbi, segno);
 	ret = f2fs_test_bit(offset, sentry->cur_valid_map);
-	mutex_unlock(&sit_i->sentry_lock);
+	up_read(&sit_i->sentry_lock);
 	return ret;
 }
 
@@ -439,12 +473,16 @@ static void gc_node_segment(struct f2fs_sb_info *sbi,
 	block_t start_addr;
 	int off;
 	int phase = 0;
+	bool fggc = (gc_type == FG_GC);
 
 	start_addr = START_BLOCK(sbi, segno);
 
 next_step:
 	entry = sum;
 
+	if (fggc && phase == 2)
+		atomic_inc(&sbi->wb_sync_req[NODE]);
+
 	for (off = 0; off < sbi->blocks_per_seg; off++, entry++) {
 		nid_t nid = le32_to_cpu(entry->nid);
 		struct page *node_page;
@@ -458,39 +496,42 @@ static void gc_node_segment(struct f2fs_sb_info *sbi,
 			continue;
 
 		if (phase == 0) {
-			ra_meta_pages(sbi, NAT_BLOCK_OFFSET(nid), 1,
+			f2fs_ra_meta_pages(sbi, NAT_BLOCK_OFFSET(nid), 1,
 							META_NAT, true);
 			continue;
 		}
 
 		if (phase == 1) {
-			ra_node_page(sbi, nid);
+			f2fs_ra_node_page(sbi, nid);
 			continue;
 		}
 
 		/* phase == 2 */
-		node_page = get_node_page(sbi, nid);
+		node_page = f2fs_get_node_page(sbi, nid);
 		if (IS_ERR(node_page))
 			continue;
 
-		/* block may become invalid during get_node_page */
+		/* block may become invalid during f2fs_get_node_page */
 		if (check_valid_map(sbi, segno, off) == 0) {
 			f2fs_put_page(node_page, 1);
 			continue;
 		}
 
-		get_node_info(sbi, nid, &ni);
+		f2fs_get_node_info(sbi, nid, &ni);
 		if (ni.blk_addr != start_addr + off) {
 			f2fs_put_page(node_page, 1);
 			continue;
 		}
 
-		move_node_page(node_page, gc_type);
+		f2fs_move_node_page(node_page, gc_type);
 		stat_inc_node_blk_count(sbi, 1, gc_type);
 	}
 
 	if (++phase < 3)
 		goto next_step;
+
+	if (fggc)
+		atomic_dec(&sbi->wb_sync_req[NODE]);
 }
 
 /*
@@ -500,7 +541,7 @@ static void gc_node_segment(struct f2fs_sb_info *sbi,
  * as indirect or double indirect node blocks, are given, it must be a caller's
  * bug.
  */
-block_t start_bidx_of_node(unsigned int node_ofs, struct inode *inode)
+block_t f2fs_start_bidx_of_node(unsigned int node_ofs, struct inode *inode)
 {
 	unsigned int indirect_blks = 2 * NIDS_PER_BLOCK + 4;
 	unsigned int bidx;
@@ -531,11 +572,11 @@ static bool is_alive(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 	nid = le32_to_cpu(sum->nid);
 	ofs_in_node = le16_to_cpu(sum->ofs_in_node);
 
-	node_page = get_node_page(sbi, nid);
+	node_page = f2fs_get_node_page(sbi, nid);
 	if (IS_ERR(node_page))
 		return false;
 
-	get_node_info(sbi, nid, dni);
+	f2fs_get_node_info(sbi, nid, dni);
 
 	if (sum->version != dni->version) {
 		f2fs_msg(sbi->sb, KERN_WARNING,
@@ -545,7 +586,7 @@ static bool is_alive(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 	}
 
 	*nofs = ofs_of_node(node_page);
-	source_blkaddr = datablock_addr(node_page, ofs_in_node);
+	source_blkaddr = datablock_addr(NULL, node_page, ofs_in_node);
 	f2fs_put_page(node_page, 1);
 
 	if (source_blkaddr != blkaddr)
@@ -553,14 +594,23 @@ static bool is_alive(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 	return true;
 }
 
-static void move_encrypted_block(struct inode *inode, block_t bidx)
+/*
+ * Move data block via META_MAPPING while keeping locked data page.
+ * This can be used to move blocks, aka LBAs, directly on disk.
+ */
+static void move_data_block(struct inode *inode, block_t bidx,
+				int gc_type, unsigned int segno, int off)
 {
 	struct f2fs_io_info fio = {
 		.sbi = F2FS_I_SB(inode),
+		.ino = inode->i_ino,
 		.type = DATA,
+		.temp = COLD,
 		.op = REQ_OP_READ,
-		.op_flags = READ_SYNC,
+		.op_flags = 0,
 		.encrypted_page = NULL,
+		.in_list = false,
+		.retry = false,
 	};
 	struct dnode_of_data dn;
 	struct f2fs_summary sum;
@@ -568,14 +618,29 @@ static void move_encrypted_block(struct inode *inode, block_t bidx)
 	struct page *page;
 	block_t newaddr;
 	int err;
+	bool lfs_mode = test_opt(fio.sbi, LFS);
 
 	/* do not read out */
 	page = f2fs_grab_cache_page(inode->i_mapping, bidx, false);
 	if (!page)
 		return;
 
+	if (!check_valid_map(F2FS_I_SB(inode), segno, off))
+		goto out;
+
+	if (f2fs_is_atomic_file(inode)) {
+		F2FS_I(inode)->i_gc_failures[GC_FAILURE_ATOMIC]++;
+		F2FS_I_SB(inode)->skipped_atomic_files[gc_type]++;
+		goto out;
+	}
+
+	if (f2fs_is_pinned_file(inode)) {
+		f2fs_pin_file_control(inode, true);
+		goto out;
+	}
+
 	set_new_dnode(&dn, inode, NULL, NULL, 0);
-	err = get_dnode_of_data(&dn, bidx, LOOKUP_NODE);
+	err = f2fs_get_dnode_of_data(&dn, bidx, LOOKUP_NODE);
 	if (err)
 		goto out;
 
@@ -590,18 +655,21 @@ static void move_encrypted_block(struct inode *inode, block_t bidx)
 	 */
 	f2fs_wait_on_page_writeback(page, DATA, true);
 
-	get_node_info(fio.sbi, dn.nid, &ni);
+	f2fs_get_node_info(fio.sbi, dn.nid, &ni);
 	set_summary(&sum, dn.nid, dn.ofs_in_node, ni.version);
 
 	/* read page */
 	fio.page = page;
 	fio.new_blkaddr = fio.old_blkaddr = dn.data_blkaddr;
 
-	allocate_data_block(fio.sbi, NULL, fio.old_blkaddr, &newaddr,
-							&sum, CURSEG_COLD_DATA);
+	if (lfs_mode)
+		down_write(&fio.sbi->io_order_lock);
+
+	f2fs_allocate_data_block(fio.sbi, NULL, fio.old_blkaddr, &newaddr,
+					&sum, CURSEG_COLD_DATA, NULL, false);
 
-	fio.encrypted_page = pagecache_get_page(META_MAPPING(fio.sbi), newaddr,
-					FGP_LOCK | FGP_CREAT, GFP_NOFS);
+	fio.encrypted_page = f2fs_pagecache_get_page(META_MAPPING(fio.sbi),
+				newaddr, FGP_LOCK | FGP_CREAT, GFP_NOFS);
 	if (!fio.encrypted_page) {
 		err = -ENOMEM;
 		goto recover_block;
@@ -629,14 +697,22 @@ static void move_encrypted_block(struct inode *inode, block_t bidx)
 		dec_page_count(fio.sbi, F2FS_DIRTY_META);
 
 	set_page_writeback(fio.encrypted_page);
+	ClearPageError(page);
 
 	/* allocate block address */
 	f2fs_wait_on_page_writeback(dn.node_page, NODE, true);
 
 	fio.op = REQ_OP_WRITE;
-	fio.op_flags = WRITE_SYNC;
+	fio.op_flags = REQ_SYNC;
 	fio.new_blkaddr = newaddr;
-	f2fs_submit_page_mbio(&fio);
+	f2fs_submit_page_write(&fio);
+	if (fio.retry) {
+		if (PageWriteback(fio.encrypted_page))
+			end_page_writeback(fio.encrypted_page);
+		goto put_page_out;
+	}
+
+	f2fs_update_iostat(fio.sbi, FS_GC_DATA_IO, F2FS_BLKSIZE);
 
 	f2fs_update_data_blkaddr(&dn, newaddr);
 	set_inode_flag(inode, FI_APPEND_WRITE);
@@ -645,8 +721,10 @@ static void move_encrypted_block(struct inode *inode, block_t bidx)
 put_page_out:
 	f2fs_put_page(fio.encrypted_page, 1);
 recover_block:
+	if (lfs_mode)
+		up_write(&fio.sbi->io_order_lock);
 	if (err)
-		__f2fs_replace_block(fio.sbi, &sum, newaddr, fio.old_blkaddr,
+		f2fs_do_replace_block(fio.sbi, &sum, newaddr, fio.old_blkaddr,
 								true, true);
 put_out:
 	f2fs_put_dnode(&dn);
@@ -654,14 +732,29 @@ static void move_encrypted_block(struct inode *inode, block_t bidx)
 	f2fs_put_page(page, 1);
 }
 
-static void move_data_page(struct inode *inode, block_t bidx, int gc_type)
+static void move_data_page(struct inode *inode, block_t bidx, int gc_type,
+							unsigned int segno, int off)
 {
 	struct page *page;
 
-	page = get_lock_data_page(inode, bidx, true);
+	page = f2fs_get_lock_data_page(inode, bidx, true);
 	if (IS_ERR(page))
 		return;
 
+	if (!check_valid_map(F2FS_I_SB(inode), segno, off))
+		goto out;
+
+	if (f2fs_is_atomic_file(inode)) {
+		F2FS_I(inode)->i_gc_failures[GC_FAILURE_ATOMIC]++;
+		F2FS_I_SB(inode)->skipped_atomic_files[gc_type]++;
+		goto out;
+	}
+	if (f2fs_is_pinned_file(inode)) {
+		if (gc_type == FG_GC)
+			f2fs_pin_file_control(inode, true);
+		goto out;
+	}
+
 	if (gc_type == BG_GC) {
 		if (PageWriteback(page))
 			goto out;
@@ -670,11 +763,16 @@ static void move_data_page(struct inode *inode, block_t bidx, int gc_type)
 	} else {
 		struct f2fs_io_info fio = {
 			.sbi = F2FS_I_SB(inode),
+			.ino = inode->i_ino,
 			.type = DATA,
+			.temp = COLD,
 			.op = REQ_OP_WRITE,
-			.op_flags = WRITE_SYNC,
+			.op_flags = REQ_SYNC,
+			.old_blkaddr = NULL_ADDR,
 			.page = page,
 			.encrypted_page = NULL,
+			.need_lock = LOCK_REQ,
+			.io_type = FS_GC_DATA_IO,
 		};
 		bool is_dirty = PageDirty(page);
 		int err;
@@ -682,12 +780,14 @@ static void move_data_page(struct inode *inode, block_t bidx, int gc_type)
 retry:
 		set_page_dirty(page);
 		f2fs_wait_on_page_writeback(page, DATA, true);
-		if (clear_page_dirty_for_io(page))
+		if (clear_page_dirty_for_io(page)) {
 			inode_dec_dirty_pages(inode);
+			f2fs_remove_dirty_inode(inode);
+		}
 
 		set_cold_data(page);
 
-		err = do_write_data_page(&fio);
+		err = f2fs_do_write_data_page(&fio);
 		if (err) {
 			clear_cold_data(page);
 			if (err == -ENOMEM) {
@@ -697,8 +797,6 @@ static void move_data_page(struct inode *inode, block_t bidx, int gc_type)
 			if (is_dirty)
 				set_page_dirty(page);
 		}
-
-		clear_cold_data(page);
 	}
 out:
 	f2fs_put_page(page, 1);
@@ -741,13 +839,13 @@ static void gc_data_segment(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 			continue;
 
 		if (phase == 0) {
-			ra_meta_pages(sbi, NAT_BLOCK_OFFSET(nid), 1,
+			f2fs_ra_meta_pages(sbi, NAT_BLOCK_OFFSET(nid), 1,
 							META_NAT, true);
 			continue;
 		}
 
 		if (phase == 1) {
-			ra_node_page(sbi, nid);
+			f2fs_ra_node_page(sbi, nid);
 			continue;
 		}
 
@@ -756,7 +854,7 @@ static void gc_data_segment(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 			continue;
 
 		if (phase == 2) {
-			ra_node_page(sbi, dni.ino);
+			f2fs_ra_node_page(sbi, dni.ino);
 			continue;
 		}
 
@@ -767,17 +865,23 @@ static void gc_data_segment(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 			if (IS_ERR(inode) || is_bad_inode(inode))
 				continue;
 
-			/* if encrypted inode, let's go phase 3 */
-			if (f2fs_encrypted_inode(inode) &&
-						S_ISREG(inode->i_mode)) {
+			/* if inode uses special I/O path, let's go phase 3 */
+			if (f2fs_post_read_required(inode)) {
 				add_gc_inode(gc_list, inode);
 				continue;
 			}
 
-			start_bidx = start_bidx_of_node(nofs, inode);
-			data_page = get_read_data_page(inode,
+			if (!down_write_trylock(
+				&F2FS_I(inode)->i_gc_rwsem[WRITE])) {
+				iput(inode);
+				continue;
+			}
+
+			start_bidx = f2fs_start_bidx_of_node(nofs, inode);
+			data_page = f2fs_get_read_data_page(inode,
 					start_bidx + ofs_in_node, REQ_RAHEAD,
 					true);
+			up_write(&F2FS_I(inode)->i_gc_rwsem[WRITE]);
 			if (IS_ERR(data_page)) {
 				iput(inode);
 				continue;
@@ -795,26 +899,31 @@ static void gc_data_segment(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 			bool locked = false;
 
 			if (S_ISREG(inode->i_mode)) {
-				if (!down_write_trylock(&fi->dio_rwsem[READ]))
+				if (!down_write_trylock(&fi->i_gc_rwsem[READ]))
 					continue;
 				if (!down_write_trylock(
-						&fi->dio_rwsem[WRITE])) {
-					up_write(&fi->dio_rwsem[READ]);
+						&fi->i_gc_rwsem[WRITE])) {
+					up_write(&fi->i_gc_rwsem[READ]);
 					continue;
 				}
 				locked = true;
+
+				/* wait for all inflight aio data */
+				inode_dio_wait(inode);
 			}
 
-			start_bidx = start_bidx_of_node(nofs, inode)
+			start_bidx = f2fs_start_bidx_of_node(nofs, inode)
 								+ ofs_in_node;
-			if (f2fs_encrypted_inode(inode) && S_ISREG(inode->i_mode))
-				move_encrypted_block(inode, start_bidx);
+			if (f2fs_post_read_required(inode))
+				move_data_block(inode, start_bidx, gc_type,
+								segno, off);
 			else
-				move_data_page(inode, start_bidx, gc_type);
+				move_data_page(inode, start_bidx, gc_type,
+								segno, off);
 
 			if (locked) {
-				up_write(&fi->dio_rwsem[WRITE]);
-				up_write(&fi->dio_rwsem[READ]);
+				up_write(&fi->i_gc_rwsem[WRITE]);
+				up_write(&fi->i_gc_rwsem[READ]);
 			}
 
 			stat_inc_data_blk_count(sbi, 1, gc_type);
@@ -831,10 +940,10 @@ static int __get_victim(struct f2fs_sb_info *sbi, unsigned int *victim,
 	struct sit_info *sit_i = SIT_I(sbi);
 	int ret;
 
-	mutex_lock(&sit_i->sentry_lock);
+	down_write(&sit_i->sentry_lock);
 	ret = DIRTY_I(sbi)->v_ops->get_victim(sbi, victim, gc_type,
 					      NO_CHECK_TYPE, LFS);
-	mutex_unlock(&sit_i->sentry_lock);
+	up_write(&sit_i->sentry_lock);
 	return ret;
 }
 
@@ -847,18 +956,18 @@ static int do_garbage_collect(struct f2fs_sb_info *sbi,
 	struct blk_plug plug;
 	unsigned int segno = start_segno;
 	unsigned int end_segno = start_segno + sbi->segs_per_sec;
-	int sec_freed = 0;
+	int seg_freed = 0;
 	unsigned char type = IS_DATASEG(get_seg_entry(sbi, segno)->type) ?
 						SUM_TYPE_DATA : SUM_TYPE_NODE;
 
 	/* readahead multi ssa blocks those have contiguous address */
 	if (sbi->segs_per_sec > 1)
-		ra_meta_pages(sbi, GET_SUM_BLOCK(sbi, segno),
+		f2fs_ra_meta_pages(sbi, GET_SUM_BLOCK(sbi, segno),
 					sbi->segs_per_sec, META_SSA, true);
 
 	/* reference all summary page */
 	while (segno < end_segno) {
-		sum_page = get_sum_page(sbi, segno++);
+		sum_page = f2fs_get_sum_page(sbi, segno++);
 		unlock_page(sum_page);
 	}
 
@@ -871,7 +980,7 @@ static int do_garbage_collect(struct f2fs_sb_info *sbi,
 					GET_SUM_BLOCK(sbi, segno));
 		f2fs_put_page(sum_page, 0);
 
-		if (get_valid_blocks(sbi, segno, 1) == 0 ||
+		if (get_valid_blocks(sbi, segno, false) == 0 ||
 				!PageUptodate(sum_page) ||
 				unlikely(f2fs_cp_error(sbi)))
 			goto next;
@@ -882,11 +991,10 @@ static int do_garbage_collect(struct f2fs_sb_info *sbi,
 		/*
 		 * this is to avoid deadlock:
 		 * - lock_page(sum_page)         - f2fs_replace_block
-		 *  - check_valid_map()            - mutex_lock(sentry_lock)
-		 *   - mutex_lock(sentry_lock)     - change_curseg()
+		 *  - check_valid_map()            - down_write(sentry_lock)
+		 *   - down_read(sentry_lock)     - change_curseg()
 		 *                                  - lock_page(sum_page)
 		 */
-
 		if (type == SUM_TYPE_NODE)
 			gc_node_segment(sbi, sum->entries, segno, gc_type);
 		else
@@ -894,87 +1002,125 @@ static int do_garbage_collect(struct f2fs_sb_info *sbi,
 								gc_type);
 
 		stat_inc_seg_count(sbi, type, gc_type);
+
+		if (gc_type == FG_GC &&
+				get_valid_blocks(sbi, segno, false) == 0)
+			seg_freed++;
 next:
 		f2fs_put_page(sum_page, 0);
 	}
 
 	if (gc_type == FG_GC)
-		f2fs_submit_merged_bio(sbi,
-				(type == SUM_TYPE_NODE) ? NODE : DATA, WRITE);
+		f2fs_submit_merged_write(sbi,
+				(type == SUM_TYPE_NODE) ? NODE : DATA);
 
 	blk_finish_plug(&plug);
 
-	if (gc_type == FG_GC &&
-		get_valid_blocks(sbi, start_segno, sbi->segs_per_sec) == 0)
-		sec_freed = 1;
-
 	stat_inc_call_count(sbi->stat_info);
 
-	return sec_freed;
+	return seg_freed;
 }
 
-int f2fs_gc(struct f2fs_sb_info *sbi, bool sync)
+int f2fs_gc(struct f2fs_sb_info *sbi, bool sync,
+			bool background, unsigned int segno)
 {
-	unsigned int segno;
 	int gc_type = sync ? FG_GC : BG_GC;
-	int sec_freed = 0;
-	int ret = -EINVAL;
+	int sec_freed = 0, seg_freed = 0, total_freed = 0;
+	int ret = 0;
 	struct cp_control cpc;
+	unsigned int init_segno = segno;
 	struct gc_inode_list gc_list = {
 		.ilist = LIST_HEAD_INIT(gc_list.ilist),
 		.iroot = RADIX_TREE_INIT(GFP_NOFS),
 	};
+	unsigned long long last_skipped = sbi->skipped_atomic_files[FG_GC];
+	unsigned int skipped_round = 0, round = 0;
+
+	trace_f2fs_gc_begin(sbi->sb, sync, background,
+				get_pages(sbi, F2FS_DIRTY_NODES),
+				get_pages(sbi, F2FS_DIRTY_DENTS),
+				get_pages(sbi, F2FS_DIRTY_IMETA),
+				free_sections(sbi),
+				free_segments(sbi),
+				reserved_segments(sbi),
+				prefree_segments(sbi));
 
 	cpc.reason = __get_cp_reason(sbi);
 gc_more:
-	segno = NULL_SEGNO;
-
-	if (unlikely(!(sbi->sb->s_flags & MS_ACTIVE)))
+	if (unlikely(!(sbi->sb->s_flags & MS_ACTIVE))) {
+		ret = -EINVAL;
 		goto stop;
+	}
 	if (unlikely(f2fs_cp_error(sbi))) {
 		ret = -EIO;
 		goto stop;
 	}
 
-	if (gc_type == BG_GC && has_not_enough_free_secs(sbi, sec_freed, 0)) {
-		gc_type = FG_GC;
+	if (gc_type == BG_GC && has_not_enough_free_secs(sbi, 0, 0)) {
 		/*
-		 * If there is no victim and no prefree segment but still not
-		 * enough free sections, we should flush dent/node blocks and do
-		 * garbage collections.
+		 * For example, if there are many prefree_segments below given
+		 * threshold, we can make them free by checkpoint. Then, we
+		 * secure free segments which doesn't need fggc any more.
 		 */
-		if (__get_victim(sbi, &segno, gc_type) ||
-						prefree_segments(sbi)) {
-			ret = write_checkpoint(sbi, &cpc);
-			if (ret)
-				goto stop;
-			segno = NULL_SEGNO;
-		} else if (has_not_enough_free_secs(sbi, 0, 0)) {
-			ret = write_checkpoint(sbi, &cpc);
+		if (prefree_segments(sbi)) {
+			ret = f2fs_write_checkpoint(sbi, &cpc);
 			if (ret)
 				goto stop;
 		}
+		if (has_not_enough_free_secs(sbi, 0, 0))
+			gc_type = FG_GC;
 	}
 
-	if (segno == NULL_SEGNO && !__get_victim(sbi, &segno, gc_type))
+	/* f2fs_balance_fs doesn't need to do BG_GC in critical path. */
+	if (gc_type == BG_GC && !background) {
+		ret = -EINVAL;
 		goto stop;
-	ret = 0;
+	}
+	if (!__get_victim(sbi, &segno, gc_type)) {
+		ret = -ENODATA;
+		goto stop;
+	}
 
-	if (do_garbage_collect(sbi, segno, &gc_list, gc_type) &&
-			gc_type == FG_GC)
+	seg_freed = do_garbage_collect(sbi, segno, &gc_list, gc_type);
+	if (gc_type == FG_GC && seg_freed == sbi->segs_per_sec)
 		sec_freed++;
+	total_freed += seg_freed;
+
+	if (gc_type == FG_GC) {
+		if (sbi->skipped_atomic_files[FG_GC] > last_skipped)
+			skipped_round++;
+		last_skipped = sbi->skipped_atomic_files[FG_GC];
+		round++;
+	}
 
 	if (gc_type == FG_GC)
 		sbi->cur_victim_sec = NULL_SEGNO;
 
 	if (!sync) {
-		if (has_not_enough_free_secs(sbi, sec_freed, 0))
+		if (has_not_enough_free_secs(sbi, sec_freed, 0)) {
+			if (skipped_round > MAX_SKIP_ATOMIC_COUNT &&
+				skipped_round * 2 >= round)
+				f2fs_drop_inmem_pages_all(sbi, true);
+			segno = NULL_SEGNO;
 			goto gc_more;
+		}
 
 		if (gc_type == FG_GC)
-			ret = write_checkpoint(sbi, &cpc);
+			ret = f2fs_write_checkpoint(sbi, &cpc);
 	}
 stop:
+	SIT_I(sbi)->last_victim[ALLOC_NEXT] = 0;
+	SIT_I(sbi)->last_victim[FLUSH_DEVICE] = init_segno;
+
+	trace_f2fs_gc_end(sbi->sb, ret, total_freed, sec_freed,
+				get_pages(sbi, F2FS_DIRTY_NODES),
+				get_pages(sbi, F2FS_DIRTY_DENTS),
+				get_pages(sbi, F2FS_DIRTY_IMETA),
+				free_sections(sbi),
+				free_segments(sbi),
+				reserved_segments(sbi),
+				prefree_segments(sbi));
+
 	mutex_unlock(&sbi->gc_mutex);
 
 	put_gc_inode(&gc_list);
@@ -984,18 +1130,14 @@ int f2fs_gc(struct f2fs_sb_info *sbi, bool sync)
 	return ret;
 }
 
-void build_gc_manager(struct f2fs_sb_info *sbi)
+void f2fs_build_gc_manager(struct f2fs_sb_info *sbi)
 {
-	u64 main_count, resv_count, ovp_count, blocks_per_sec;
-
 	DIRTY_I(sbi)->v_ops = &default_v_ops;
 
-	/* threshold of # of valid blocks in a section for victims of FG_GC */
-	main_count = SM_I(sbi)->main_segments << sbi->log_blocks_per_seg;
-	resv_count = SM_I(sbi)->reserved_segments << sbi->log_blocks_per_seg;
-	ovp_count = SM_I(sbi)->ovp_segments << sbi->log_blocks_per_seg;
-	blocks_per_sec = sbi->blocks_per_seg * sbi->segs_per_sec;
+	sbi->gc_pin_file_threshold = DEF_GC_FAILED_PINNED_FILES;
 
-	sbi->fggc_threshold = div_u64((main_count - ovp_count) * blocks_per_sec,
-					(main_count - resv_count));
+	/* give warm/cold data area from slower device */
+	if (sbi->s_ndevs && sbi->segs_per_sec == 1)
+		SIT_I(sbi)->last_victim[ALLOC_NEXT] =
+				GET_SEGNO(sbi, FDEV(0).end_blk) + 1;
 }
diff --git a/fs/f2fs/gc.h b/fs/f2fs/gc.h
index a993967..c8619e4 100644
--- a/fs/f2fs/gc.h
+++ b/fs/f2fs/gc.h
@@ -13,12 +13,15 @@
 						 * whether IO subsystem is idle
 						 * or not
 						 */
+#define DEF_GC_THREAD_URGENT_SLEEP_TIME	500	/* 500 ms */
 #define DEF_GC_THREAD_MIN_SLEEP_TIME	30000	/* milliseconds */
 #define DEF_GC_THREAD_MAX_SLEEP_TIME	60000
 #define DEF_GC_THREAD_NOGC_SLEEP_TIME	300000	/* wait 5 min */
 #define LIMIT_INVALID_BLOCK	40 /* percentage over total user space */
 #define LIMIT_FREE_BLOCK	40 /* percentage over invalid + free space */
 
+#define DEF_GC_FAILED_PINNED_FILES	2048
+
 /* Search max. number of dirty segments to select a victim segment */
 #define DEF_MAX_VICTIM_SEARCH 4096 /* covers 8GB */
 
@@ -27,12 +30,13 @@ struct f2fs_gc_kthread {
 	wait_queue_head_t gc_wait_queue_head;
 
 	/* for gc sleep time */
+	unsigned int urgent_sleep_time;
 	unsigned int min_sleep_time;
 	unsigned int max_sleep_time;
 	unsigned int no_gc_sleep_time;
 
 	/* for changing gc mode */
-	unsigned int gc_idle;
+	unsigned int gc_wake;
 };
 
 struct gc_inode_list {
@@ -65,25 +69,32 @@ static inline block_t limit_free_user_blocks(struct f2fs_sb_info *sbi)
 }
 
 static inline void increase_sleep_time(struct f2fs_gc_kthread *gc_th,
-								long *wait)
+							unsigned int *wait)
 {
+	unsigned int min_time = gc_th->min_sleep_time;
+	unsigned int max_time = gc_th->max_sleep_time;
+
 	if (*wait == gc_th->no_gc_sleep_time)
 		return;
 
-	*wait += gc_th->min_sleep_time;
-	if (*wait > gc_th->max_sleep_time)
-		*wait = gc_th->max_sleep_time;
+	if ((long long)*wait + (long long)min_time > (long long)max_time)
+		*wait = max_time;
+	else
+		*wait += min_time;
 }
 
 static inline void decrease_sleep_time(struct f2fs_gc_kthread *gc_th,
-								long *wait)
+							unsigned int *wait)
 {
+	unsigned int min_time = gc_th->min_sleep_time;
+
 	if (*wait == gc_th->no_gc_sleep_time)
 		*wait = gc_th->max_sleep_time;
 
-	*wait -= gc_th->min_sleep_time;
-	if (*wait <= gc_th->min_sleep_time)
-		*wait = gc_th->min_sleep_time;
+	if ((long long)*wait - (long long)min_time < (long long)min_time)
+		*wait = min_time;
+	else
+		*wait -= min_time;
 }
 
 static inline bool has_enough_invalid_blocks(struct f2fs_sb_info *sbi)
diff --git a/fs/f2fs/inline.c b/fs/f2fs/inline.c
index a21faa1..3f0c74d 100644
--- a/fs/f2fs/inline.c
+++ b/fs/f2fs/inline.c
@@ -13,6 +13,7 @@
 
 #include "f2fs.h"
 #include "node.h"
+#include <trace/events/android_fs.h>
 
 bool f2fs_may_inline_data(struct inode *inode)
 {
@@ -22,10 +23,10 @@ bool f2fs_may_inline_data(struct inode *inode)
 	if (!S_ISREG(inode->i_mode) && !S_ISLNK(inode->i_mode))
 		return false;
 
-	if (i_size_read(inode) > MAX_INLINE_DATA)
+	if (i_size_read(inode) > MAX_INLINE_DATA(inode))
 		return false;
 
-	if (f2fs_encrypted_inode(inode) && S_ISREG(inode->i_mode))
+	if (f2fs_post_read_required(inode))
 		return false;
 
 	return true;
@@ -42,8 +43,9 @@ bool f2fs_may_inline_dentry(struct inode *inode)
 	return true;
 }
 
-void read_inline_data(struct page *page, struct page *ipage)
+void f2fs_do_read_inline_data(struct page *page, struct page *ipage)
 {
+	struct inode *inode = page->mapping->host;
 	void *src_addr, *dst_addr;
 
 	if (PageUptodate(page))
@@ -51,56 +53,76 @@ void read_inline_data(struct page *page, struct page *ipage)
 
 	f2fs_bug_on(F2FS_P_SB(page), page->index);
 
-	zero_user_segment(page, MAX_INLINE_DATA, PAGE_SIZE);
+	zero_user_segment(page, MAX_INLINE_DATA(inode), PAGE_SIZE);
 
 	/* Copy the whole inline data block */
-	src_addr = inline_data_addr(ipage);
+	src_addr = inline_data_addr(inode, ipage);
 	dst_addr = kmap_atomic(page);
-	memcpy(dst_addr, src_addr, MAX_INLINE_DATA);
+	memcpy(dst_addr, src_addr, MAX_INLINE_DATA(inode));
 	flush_dcache_page(page);
 	kunmap_atomic(dst_addr);
 	if (!PageUptodate(page))
 		SetPageUptodate(page);
 }
 
-bool truncate_inline_inode(struct page *ipage, u64 from)
+void f2fs_truncate_inline_inode(struct inode *inode,
+					struct page *ipage, u64 from)
 {
 	void *addr;
 
-	if (from >= MAX_INLINE_DATA)
-		return false;
+	if (from >= MAX_INLINE_DATA(inode))
+		return;
 
-	addr = inline_data_addr(ipage);
+	addr = inline_data_addr(inode, ipage);
 
 	f2fs_wait_on_page_writeback(ipage, NODE, true);
-	memset(addr + from, 0, MAX_INLINE_DATA - from);
+	memset(addr + from, 0, MAX_INLINE_DATA(inode) - from);
 	set_page_dirty(ipage);
-	return true;
+
+	if (from == 0)
+		clear_inode_flag(inode, FI_DATA_EXIST);
 }
 
 int f2fs_read_inline_data(struct inode *inode, struct page *page)
 {
 	struct page *ipage;
 
-	ipage = get_node_page(F2FS_I_SB(inode), inode->i_ino);
+	if (trace_android_fs_dataread_start_enabled()) {
+		char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+		path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    inode);
+		trace_android_fs_dataread_start(inode, page_offset(page),
+						PAGE_SIZE, current->pid,
+						path, current->comm);
+	}
+
+	ipage = f2fs_get_node_page(F2FS_I_SB(inode), inode->i_ino);
 	if (IS_ERR(ipage)) {
+		trace_android_fs_dataread_end(inode, page_offset(page),
+					      PAGE_SIZE);
 		unlock_page(page);
 		return PTR_ERR(ipage);
 	}
 
 	if (!f2fs_has_inline_data(inode)) {
 		f2fs_put_page(ipage, 1);
+		trace_android_fs_dataread_end(inode, page_offset(page),
+					      PAGE_SIZE);
 		return -EAGAIN;
 	}
 
 	if (page->index)
 		zero_user_segment(page, 0, PAGE_SIZE);
 	else
-		read_inline_data(page, ipage);
+		f2fs_do_read_inline_data(page, ipage);
 
 	if (!PageUptodate(page))
 		SetPageUptodate(page);
 	f2fs_put_page(ipage, 1);
+	trace_android_fs_dataread_end(inode, page_offset(page),
+				      PAGE_SIZE);
 	unlock_page(page);
 	return 0;
 }
@@ -109,11 +131,13 @@ int f2fs_convert_inline_page(struct dnode_of_data *dn, struct page *page)
 {
 	struct f2fs_io_info fio = {
 		.sbi = F2FS_I_SB(dn->inode),
+		.ino = dn->inode->i_ino,
 		.type = DATA,
 		.op = REQ_OP_WRITE,
-		.op_flags = WRITE_SYNC | REQ_PRIO,
+		.op_flags = REQ_SYNC | REQ_PRIO,
 		.page = page,
 		.encrypted_page = NULL,
+		.io_type = FS_DATA_IO,
 	};
 	int dirty, err;
 
@@ -126,7 +150,7 @@ int f2fs_convert_inline_page(struct dnode_of_data *dn, struct page *page)
 
 	f2fs_bug_on(F2FS_P_SB(page), PageWriteback(page));
 
-	read_inline_data(page, dn->inode_page);
+	f2fs_do_read_inline_data(page, dn->inode_page);
 	set_page_dirty(page);
 
 	/* clear dirty state */
@@ -134,21 +158,25 @@ int f2fs_convert_inline_page(struct dnode_of_data *dn, struct page *page)
 
 	/* write data page to try to make data consistent */
 	set_page_writeback(page);
+	ClearPageError(page);
 	fio.old_blkaddr = dn->data_blkaddr;
-	write_data_page(dn, &fio);
+	set_inode_flag(dn->inode, FI_HOT_DATA);
+	f2fs_outplace_write_data(dn, &fio);
 	f2fs_wait_on_page_writeback(page, DATA, true);
-	if (dirty)
+	if (dirty) {
 		inode_dec_dirty_pages(dn->inode);
+		f2fs_remove_dirty_inode(dn->inode);
+	}
 
 	/* this converted inline_data should be recovered. */
 	set_inode_flag(dn->inode, FI_APPEND_WRITE);
 
 	/* clear inline data and flag after data writeback */
-	truncate_inline_inode(dn->inode_page, 0);
+	f2fs_truncate_inline_inode(dn->inode, dn->inode_page, 0);
 	clear_inline_node(dn->inode_page);
 clear_out:
 	stat_dec_inline_inode(dn->inode);
-	f2fs_clear_inline_inode(dn->inode);
+	clear_inode_flag(dn->inode, FI_INLINE_DATA);
 	f2fs_put_dnode(dn);
 	return 0;
 }
@@ -169,7 +197,7 @@ int f2fs_convert_inline_inode(struct inode *inode)
 
 	f2fs_lock_op(sbi);
 
-	ipage = get_node_page(sbi, inode->i_ino);
+	ipage = f2fs_get_node_page(sbi, inode->i_ino);
 	if (IS_ERR(ipage)) {
 		err = PTR_ERR(ipage);
 		goto out;
@@ -198,7 +226,7 @@ int f2fs_write_inline_data(struct inode *inode, struct page *page)
 	int err;
 
 	set_new_dnode(&dn, inode, NULL, NULL, 0);
-	err = get_dnode_of_data(&dn, 0, LOOKUP_NODE);
+	err = f2fs_get_dnode_of_data(&dn, 0, LOOKUP_NODE);
 	if (err)
 		return err;
 
@@ -211,11 +239,13 @@ int f2fs_write_inline_data(struct inode *inode, struct page *page)
 
 	f2fs_wait_on_page_writeback(dn.inode_page, NODE, true);
 	src_addr = kmap_atomic(page);
-	dst_addr = inline_data_addr(dn.inode_page);
-	memcpy(dst_addr, src_addr, MAX_INLINE_DATA);
+	dst_addr = inline_data_addr(inode, dn.inode_page);
+	memcpy(dst_addr, src_addr, MAX_INLINE_DATA(inode));
 	kunmap_atomic(src_addr);
 	set_page_dirty(dn.inode_page);
 
+	f2fs_clear_radix_tree_dirty_tag(page);
+
 	set_inode_flag(inode, FI_APPEND_WRITE);
 	set_inode_flag(inode, FI_DATA_EXIST);
 
@@ -224,7 +254,7 @@ int f2fs_write_inline_data(struct inode *inode, struct page *page)
 	return 0;
 }
 
-bool recover_inline_data(struct inode *inode, struct page *npage)
+bool f2fs_recover_inline_data(struct inode *inode, struct page *npage)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	struct f2fs_inode *ri = NULL;
@@ -245,14 +275,14 @@ bool recover_inline_data(struct inode *inode, struct page *npage)
 	if (f2fs_has_inline_data(inode) &&
 			ri && (ri->i_inline & F2FS_INLINE_DATA)) {
 process_inline:
-		ipage = get_node_page(sbi, inode->i_ino);
+		ipage = f2fs_get_node_page(sbi, inode->i_ino);
 		f2fs_bug_on(sbi, IS_ERR(ipage));
 
 		f2fs_wait_on_page_writeback(ipage, NODE, true);
 
-		src_addr = inline_data_addr(npage);
-		dst_addr = inline_data_addr(ipage);
-		memcpy(dst_addr, src_addr, MAX_INLINE_DATA);
+		src_addr = inline_data_addr(inode, npage);
+		dst_addr = inline_data_addr(inode, ipage);
+		memcpy(dst_addr, src_addr, MAX_INLINE_DATA(inode));
 
 		set_inode_flag(inode, FI_INLINE_DATA);
 		set_inode_flag(inode, FI_DATA_EXIST);
@@ -263,32 +293,31 @@ bool recover_inline_data(struct inode *inode, struct page *npage)
 	}
 
 	if (f2fs_has_inline_data(inode)) {
-		ipage = get_node_page(sbi, inode->i_ino);
+		ipage = f2fs_get_node_page(sbi, inode->i_ino);
 		f2fs_bug_on(sbi, IS_ERR(ipage));
-		if (!truncate_inline_inode(ipage, 0))
-			return false;
-		f2fs_clear_inline_inode(inode);
+		f2fs_truncate_inline_inode(inode, ipage, 0);
+		clear_inode_flag(inode, FI_INLINE_DATA);
 		f2fs_put_page(ipage, 1);
 	} else if (ri && (ri->i_inline & F2FS_INLINE_DATA)) {
-		if (truncate_blocks(inode, 0, false))
+		if (f2fs_truncate_blocks(inode, 0, false))
 			return false;
 		goto process_inline;
 	}
 	return false;
 }
 
-struct f2fs_dir_entry *find_in_inline_dir(struct inode *dir,
+struct f2fs_dir_entry *f2fs_find_in_inline_dir(struct inode *dir,
 			struct fscrypt_name *fname, struct page **res_page)
 {
 	struct f2fs_sb_info *sbi = F2FS_SB(dir->i_sb);
-	struct f2fs_inline_dentry *inline_dentry;
 	struct qstr name = FSTR_TO_QSTR(&fname->disk_name);
 	struct f2fs_dir_entry *de;
 	struct f2fs_dentry_ptr d;
 	struct page *ipage;
+	void *inline_dentry;
 	f2fs_hash_t namehash;
 
-	ipage = get_node_page(sbi, dir->i_ino);
+	ipage = f2fs_get_node_page(sbi, dir->i_ino);
 	if (IS_ERR(ipage)) {
 		*res_page = ipage;
 		return NULL;
@@ -296,10 +325,10 @@ struct f2fs_dir_entry *find_in_inline_dir(struct inode *dir,
 
 	namehash = f2fs_dentry_hash(&name, fname);
 
-	inline_dentry = inline_data_addr(ipage);
+	inline_dentry = inline_data_addr(dir, ipage);
 
-	make_dentry_ptr(NULL, &d, (void *)inline_dentry, 2);
-	de = find_target_dentry(fname, namehash, NULL, &d);
+	make_dentry_ptr_inline(dir, &d, inline_dentry);
+	de = f2fs_find_target_dentry(fname, namehash, NULL, &d);
 	unlock_page(ipage);
 	if (de)
 		*res_page = ipage;
@@ -309,22 +338,22 @@ struct f2fs_dir_entry *find_in_inline_dir(struct inode *dir,
 	return de;
 }
 
-int make_empty_inline_dir(struct inode *inode, struct inode *parent,
+int f2fs_make_empty_inline_dir(struct inode *inode, struct inode *parent,
 							struct page *ipage)
 {
-	struct f2fs_inline_dentry *dentry_blk;
 	struct f2fs_dentry_ptr d;
+	void *inline_dentry;
 
-	dentry_blk = inline_data_addr(ipage);
+	inline_dentry = inline_data_addr(inode, ipage);
 
-	make_dentry_ptr(NULL, &d, (void *)dentry_blk, 2);
-	do_make_empty_dir(inode, parent, &d);
+	make_dentry_ptr_inline(inode, &d, inline_dentry);
+	f2fs_do_make_empty_dir(inode, parent, &d);
 
 	set_page_dirty(ipage);
 
 	/* update i_size to MAX_INLINE_DATA */
-	if (i_size_read(inode) < MAX_INLINE_DATA)
-		f2fs_i_size_write(inode, MAX_INLINE_DATA);
+	if (i_size_read(inode) < MAX_INLINE_DATA(inode))
+		f2fs_i_size_write(inode, MAX_INLINE_DATA(inode));
 	return 0;
 }
 
@@ -333,11 +362,12 @@ int make_empty_inline_dir(struct inode *inode, struct inode *parent,
  * release ipage in this function.
  */
 static int f2fs_move_inline_dirents(struct inode *dir, struct page *ipage,
-				struct f2fs_inline_dentry *inline_dentry)
+							void *inline_dentry)
 {
 	struct page *page;
 	struct dnode_of_data dn;
 	struct f2fs_dentry_block *dentry_blk;
+	struct f2fs_dentry_ptr src, dst;
 	int err;
 
 	page = f2fs_grab_cache_page(dir->i_mapping, 0, false);
@@ -352,33 +382,30 @@ static int f2fs_move_inline_dirents(struct inode *dir, struct page *ipage,
 		goto out;
 
 	f2fs_wait_on_page_writeback(page, DATA, true);
-	zero_user_segment(page, MAX_INLINE_DATA, PAGE_SIZE);
 
-	dentry_blk = kmap_atomic(page);
+	dentry_blk = page_address(page);
+
+	make_dentry_ptr_inline(dir, &src, inline_dentry);
+	make_dentry_ptr_block(dir, &dst, dentry_blk);
 
 	/* copy data from inline dentry block to new dentry block */
-	memcpy(dentry_blk->dentry_bitmap, inline_dentry->dentry_bitmap,
-					INLINE_DENTRY_BITMAP_SIZE);
-	memset(dentry_blk->dentry_bitmap + INLINE_DENTRY_BITMAP_SIZE, 0,
-			SIZE_OF_DENTRY_BITMAP - INLINE_DENTRY_BITMAP_SIZE);
+	memcpy(dst.bitmap, src.bitmap, src.nr_bitmap);
+	memset(dst.bitmap + src.nr_bitmap, 0, dst.nr_bitmap - src.nr_bitmap);
 	/*
 	 * we do not need to zero out remainder part of dentry and filename
 	 * field, since we have used bitmap for marking the usage status of
 	 * them, besides, we can also ignore copying/zeroing reserved space
 	 * of dentry block, because them haven't been used so far.
 	 */
-	memcpy(dentry_blk->dentry, inline_dentry->dentry,
-			sizeof(struct f2fs_dir_entry) * NR_INLINE_DENTRY);
-	memcpy(dentry_blk->filename, inline_dentry->filename,
-					NR_INLINE_DENTRY * F2FS_SLOT_LEN);
+	memcpy(dst.dentry, src.dentry, SIZE_OF_DIR_ENTRY * src.max);
+	memcpy(dst.filename, src.filename, src.max * F2FS_SLOT_LEN);
 
-	kunmap_atomic(dentry_blk);
 	if (!PageUptodate(page))
 		SetPageUptodate(page);
 	set_page_dirty(page);
 
 	/* clear inline dir and flag after data writeback */
-	truncate_inline_inode(ipage, 0);
+	f2fs_truncate_inline_inode(dir, ipage, 0);
 
 	stat_dec_inline_dir(dir);
 	clear_inode_flag(dir, FI_INLINE_DENTRY);
@@ -391,14 +418,13 @@ static int f2fs_move_inline_dirents(struct inode *dir, struct page *ipage,
 	return err;
 }
 
-static int f2fs_add_inline_entries(struct inode *dir,
-			struct f2fs_inline_dentry *inline_dentry)
+static int f2fs_add_inline_entries(struct inode *dir, void *inline_dentry)
 {
 	struct f2fs_dentry_ptr d;
 	unsigned long bit_pos = 0;
 	int err = 0;
 
-	make_dentry_ptr(NULL, &d, (void *)inline_dentry, 2);
+	make_dentry_ptr_inline(dir, &d, inline_dentry);
 
 	while (bit_pos < d.max) {
 		struct f2fs_dir_entry *de;
@@ -419,10 +445,10 @@ static int f2fs_add_inline_entries(struct inode *dir,
 		}
 
 		new_name.name = d.filename[bit_pos];
-		new_name.len = de->name_len;
+		new_name.len = le16_to_cpu(de->name_len);
 
 		ino = le32_to_cpu(de->ino);
-		fake_mode = get_de_type(de) << S_SHIFT;
+		fake_mode = f2fs_get_de_type(de) << S_SHIFT;
 
 		err = f2fs_add_regular_entry(dir, &new_name, NULL, NULL,
 							ino, fake_mode);
@@ -434,26 +460,26 @@ static int f2fs_add_inline_entries(struct inode *dir,
 	return 0;
 punch_dentry_pages:
 	truncate_inode_pages(&dir->i_data, 0);
-	truncate_blocks(dir, 0, false);
-	remove_dirty_inode(dir);
+	f2fs_truncate_blocks(dir, 0, false);
+	f2fs_remove_dirty_inode(dir);
 	return err;
 }
 
 static int f2fs_move_rehashed_dirents(struct inode *dir, struct page *ipage,
-				struct f2fs_inline_dentry *inline_dentry)
+							void *inline_dentry)
 {
-	struct f2fs_inline_dentry *backup_dentry;
+	void *backup_dentry;
 	int err;
 
 	backup_dentry = f2fs_kmalloc(F2FS_I_SB(dir),
-			sizeof(struct f2fs_inline_dentry), GFP_F2FS_ZERO);
+				MAX_INLINE_DATA(dir), GFP_F2FS_ZERO);
 	if (!backup_dentry) {
 		f2fs_put_page(ipage, 1);
 		return -ENOMEM;
 	}
 
-	memcpy(backup_dentry, inline_dentry, MAX_INLINE_DATA);
-	truncate_inline_inode(ipage, 0);
+	memcpy(backup_dentry, inline_dentry, MAX_INLINE_DATA(dir));
+	f2fs_truncate_inline_inode(dir, ipage, 0);
 
 	unlock_page(ipage);
 
@@ -469,9 +495,9 @@ static int f2fs_move_rehashed_dirents(struct inode *dir, struct page *ipage,
 	return 0;
 recover:
 	lock_page(ipage);
-	memcpy(inline_dentry, backup_dentry, MAX_INLINE_DATA);
+	memcpy(inline_dentry, backup_dentry, MAX_INLINE_DATA(dir));
 	f2fs_i_depth_write(dir, 0);
-	f2fs_i_size_write(dir, MAX_INLINE_DATA);
+	f2fs_i_size_write(dir, MAX_INLINE_DATA(dir));
 	set_page_dirty(ipage);
 	f2fs_put_page(ipage, 1);
 
@@ -480,7 +506,7 @@ static int f2fs_move_rehashed_dirents(struct inode *dir, struct page *ipage,
 }
 
 static int f2fs_convert_inline_dir(struct inode *dir, struct page *ipage,
-				struct f2fs_inline_dentry *inline_dentry)
+							void *inline_dentry)
 {
 	if (!F2FS_I(dir)->i_dir_level)
 		return f2fs_move_inline_dirents(dir, ipage, inline_dentry);
@@ -496,21 +522,22 @@ int f2fs_add_inline_entry(struct inode *dir, const struct qstr *new_name,
 	struct page *ipage;
 	unsigned int bit_pos;
 	f2fs_hash_t name_hash;
-	struct f2fs_inline_dentry *dentry_blk = NULL;
+	void *inline_dentry = NULL;
 	struct f2fs_dentry_ptr d;
 	int slots = GET_DENTRY_SLOTS(new_name->len);
 	struct page *page = NULL;
 	int err = 0;
 
-	ipage = get_node_page(sbi, dir->i_ino);
+	ipage = f2fs_get_node_page(sbi, dir->i_ino);
 	if (IS_ERR(ipage))
 		return PTR_ERR(ipage);
 
-	dentry_blk = inline_data_addr(ipage);
-	bit_pos = room_for_filename(&dentry_blk->dentry_bitmap,
-						slots, NR_INLINE_DENTRY);
-	if (bit_pos >= NR_INLINE_DENTRY) {
-		err = f2fs_convert_inline_dir(dir, ipage, dentry_blk);
+	inline_dentry = inline_data_addr(dir, ipage);
+	make_dentry_ptr_inline(dir, &d, inline_dentry);
+
+	bit_pos = f2fs_room_for_filename(d.bitmap, slots, d.max);
+	if (bit_pos >= d.max) {
+		err = f2fs_convert_inline_dir(dir, ipage, inline_dentry);
 		if (err)
 			return err;
 		err = -EAGAIN;
@@ -519,20 +546,17 @@ int f2fs_add_inline_entry(struct inode *dir, const struct qstr *new_name,
 
 	if (inode) {
 		down_write(&F2FS_I(inode)->i_sem);
-		page = init_inode_metadata(inode, dir, new_name,
+		page = f2fs_init_inode_metadata(inode, dir, new_name,
 						orig_name, ipage);
 		if (IS_ERR(page)) {
 			err = PTR_ERR(page);
 			goto fail;
 		}
-		if (f2fs_encrypted_inode(dir))
-			file_set_enc_name(inode);
 	}
 
 	f2fs_wait_on_page_writeback(ipage, NODE, true);
 
 	name_hash = f2fs_dentry_hash(new_name, NULL);
-	make_dentry_ptr(NULL, &d, (void *)dentry_blk, 2);
 	f2fs_update_dentry(ino, mode, &d, new_name, name_hash, bit_pos);
 
 	set_page_dirty(ipage);
@@ -543,7 +567,7 @@ int f2fs_add_inline_entry(struct inode *dir, const struct qstr *new_name,
 		f2fs_put_page(page, 1);
 	}
 
-	update_parent_metadata(dir, inode, 0);
+	f2fs_update_parent_metadata(dir, inode, 0);
 fail:
 	if (inode)
 		up_write(&F2FS_I(inode)->i_sem);
@@ -555,7 +579,8 @@ int f2fs_add_inline_entry(struct inode *dir, const struct qstr *new_name,
 void f2fs_delete_inline_entry(struct f2fs_dir_entry *dentry, struct page *page,
 					struct inode *dir, struct inode *inode)
 {
-	struct f2fs_inline_dentry *inline_dentry;
+	struct f2fs_dentry_ptr d;
+	void *inline_dentry;
 	int slots = GET_DENTRY_SLOTS(le16_to_cpu(dentry->name_len));
 	unsigned int bit_pos;
 	int i;
@@ -563,17 +588,18 @@ void f2fs_delete_inline_entry(struct f2fs_dir_entry *dentry, struct page *page,
 	lock_page(page);
 	f2fs_wait_on_page_writeback(page, NODE, true);
 
-	inline_dentry = inline_data_addr(page);
-	bit_pos = dentry - inline_dentry->dentry;
+	inline_dentry = inline_data_addr(dir, page);
+	make_dentry_ptr_inline(dir, &d, inline_dentry);
+
+	bit_pos = dentry - d.dentry;
 	for (i = 0; i < slots; i++)
-		__clear_bit_le(bit_pos + i,
-				&inline_dentry->dentry_bitmap);
+		__clear_bit_le(bit_pos + i, d.bitmap);
 
 	set_page_dirty(page);
 	f2fs_put_page(page, 1);
 
 	dir->i_ctime = dir->i_mtime = current_time(dir);
-	f2fs_mark_inode_dirty_sync(dir);
+	f2fs_mark_inode_dirty_sync(dir, false);
 
 	if (inode)
 		f2fs_drop_nlink(dir, inode);
@@ -584,20 +610,21 @@ bool f2fs_empty_inline_dir(struct inode *dir)
 	struct f2fs_sb_info *sbi = F2FS_I_SB(dir);
 	struct page *ipage;
 	unsigned int bit_pos = 2;
-	struct f2fs_inline_dentry *dentry_blk;
+	void *inline_dentry;
+	struct f2fs_dentry_ptr d;
 
-	ipage = get_node_page(sbi, dir->i_ino);
+	ipage = f2fs_get_node_page(sbi, dir->i_ino);
 	if (IS_ERR(ipage))
 		return false;
 
-	dentry_blk = inline_data_addr(ipage);
-	bit_pos = find_next_bit_le(&dentry_blk->dentry_bitmap,
-					NR_INLINE_DENTRY,
-					bit_pos);
+	inline_dentry = inline_data_addr(dir, ipage);
+	make_dentry_ptr_inline(dir, &d, inline_dentry);
+
+	bit_pos = find_next_bit_le(d.bitmap, d.max, bit_pos);
 
 	f2fs_put_page(ipage, 1);
 
-	if (bit_pos < NR_INLINE_DENTRY)
+	if (bit_pos < d.max)
 		return false;
 
 	return true;
@@ -607,26 +634,30 @@ int f2fs_read_inline_dir(struct file *file, struct dir_context *ctx,
 				struct fscrypt_str *fstr)
 {
 	struct inode *inode = file_inode(file);
-	struct f2fs_inline_dentry *inline_dentry = NULL;
 	struct page *ipage = NULL;
 	struct f2fs_dentry_ptr d;
+	void *inline_dentry = NULL;
+	int err;
 
-	if (ctx->pos == NR_INLINE_DENTRY)
+	make_dentry_ptr_inline(inode, &d, inline_dentry);
+
+	if (ctx->pos == d.max)
 		return 0;
 
-	ipage = get_node_page(F2FS_I_SB(inode), inode->i_ino);
+	ipage = f2fs_get_node_page(F2FS_I_SB(inode), inode->i_ino);
 	if (IS_ERR(ipage))
 		return PTR_ERR(ipage);
 
-	inline_dentry = inline_data_addr(ipage);
+	inline_dentry = inline_data_addr(inode, ipage);
 
-	make_dentry_ptr(inode, &d, (void *)inline_dentry, 2);
+	make_dentry_ptr_inline(inode, &d, inline_dentry);
 
-	if (!f2fs_fill_dentries(ctx, &d, 0, fstr))
-		ctx->pos = NR_INLINE_DENTRY;
+	err = f2fs_fill_dentries(ctx, &d, 0, fstr);
+	if (!err)
+		ctx->pos = d.max;
 
 	f2fs_put_page(ipage, 1);
-	return 0;
+	return err < 0 ? err : 0;
 }
 
 int f2fs_inline_data_fiemap(struct inode *inode,
@@ -639,7 +670,7 @@ int f2fs_inline_data_fiemap(struct inode *inode,
 	struct page *ipage;
 	int err = 0;
 
-	ipage = get_node_page(F2FS_I_SB(inode), inode->i_ino);
+	ipage = f2fs_get_node_page(F2FS_I_SB(inode), inode->i_ino);
 	if (IS_ERR(ipage))
 		return PTR_ERR(ipage);
 
@@ -648,16 +679,17 @@ int f2fs_inline_data_fiemap(struct inode *inode,
 		goto out;
 	}
 
-	ilen = min_t(size_t, MAX_INLINE_DATA, i_size_read(inode));
+	ilen = min_t(size_t, MAX_INLINE_DATA(inode), i_size_read(inode));
 	if (start >= ilen)
 		goto out;
 	if (start + len < ilen)
 		ilen = start + len;
 	ilen -= start;
 
-	get_node_info(F2FS_I_SB(inode), inode->i_ino, &ni);
+	f2fs_get_node_info(F2FS_I_SB(inode), inode->i_ino, &ni);
 	byteaddr = (__u64)ni.blk_addr << inode->i_sb->s_blocksize_bits;
-	byteaddr += (char *)inline_data_addr(ipage) - (char *)F2FS_INODE(ipage);
+	byteaddr += (char *)inline_data_addr(inode, ipage) -
+					(char *)F2FS_INODE(ipage);
 	err = fiemap_fill_next_extent(fieinfo, start, byteaddr, ilen, flags);
 out:
 	f2fs_put_page(ipage, 1);
diff --git a/fs/f2fs/inode.c b/fs/f2fs/inode.c
index d736989..30a7773 100644
--- a/fs/f2fs/inode.c
+++ b/fs/f2fs/inode.c
@@ -16,13 +16,18 @@
 
 #include "f2fs.h"
 #include "node.h"
+#include "segment.h"
 
 #include <trace/events/f2fs.h>
 
-void f2fs_mark_inode_dirty_sync(struct inode *inode)
+void f2fs_mark_inode_dirty_sync(struct inode *inode, bool sync)
 {
-	if (f2fs_inode_dirtied(inode))
+	if (is_inode_flag_set(inode, FI_NEW_INODE))
 		return;
+
+	if (f2fs_inode_dirtied(inode, sync))
+		return;
+
 	mark_inode_dirty_sync(inode);
 }
 
@@ -31,64 +36,70 @@ void f2fs_set_inode_flags(struct inode *inode)
 	unsigned int flags = F2FS_I(inode)->i_flags;
 	unsigned int new_fl = 0;
 
-	if (flags & FS_SYNC_FL)
+	if (flags & F2FS_SYNC_FL)
 		new_fl |= S_SYNC;
-	if (flags & FS_APPEND_FL)
+	if (flags & F2FS_APPEND_FL)
 		new_fl |= S_APPEND;
-	if (flags & FS_IMMUTABLE_FL)
+	if (flags & F2FS_IMMUTABLE_FL)
 		new_fl |= S_IMMUTABLE;
-	if (flags & FS_NOATIME_FL)
+	if (flags & F2FS_NOATIME_FL)
 		new_fl |= S_NOATIME;
-	if (flags & FS_DIRSYNC_FL)
+	if (flags & F2FS_DIRSYNC_FL)
 		new_fl |= S_DIRSYNC;
+	if (f2fs_encrypted_inode(inode))
+		new_fl |= S_ENCRYPTED;
 	inode_set_flags(inode, new_fl,
-			S_SYNC|S_APPEND|S_IMMUTABLE|S_NOATIME|S_DIRSYNC);
-	f2fs_mark_inode_dirty_sync(inode);
+			S_SYNC|S_APPEND|S_IMMUTABLE|S_NOATIME|S_DIRSYNC|
+			S_ENCRYPTED);
 }
 
 static void __get_inode_rdev(struct inode *inode, struct f2fs_inode *ri)
 {
+	int extra_size = get_extra_isize(inode);
+
 	if (S_ISCHR(inode->i_mode) || S_ISBLK(inode->i_mode) ||
 			S_ISFIFO(inode->i_mode) || S_ISSOCK(inode->i_mode)) {
-		if (ri->i_addr[0])
-			inode->i_rdev =
-				old_decode_dev(le32_to_cpu(ri->i_addr[0]));
+		if (ri->i_addr[extra_size])
+			inode->i_rdev = old_decode_dev(
+				le32_to_cpu(ri->i_addr[extra_size]));
 		else
-			inode->i_rdev =
-				new_decode_dev(le32_to_cpu(ri->i_addr[1]));
+			inode->i_rdev = new_decode_dev(
+				le32_to_cpu(ri->i_addr[extra_size + 1]));
 	}
 }
 
 static bool __written_first_block(struct f2fs_inode *ri)
 {
-	block_t addr = le32_to_cpu(ri->i_addr[0]);
+	block_t addr = le32_to_cpu(ri->i_addr[offset_in_addr(ri)]);
 
-	if (addr != NEW_ADDR && addr != NULL_ADDR)
+	if (is_valid_blkaddr(addr))
 		return true;
 	return false;
 }
 
 static void __set_inode_rdev(struct inode *inode, struct f2fs_inode *ri)
 {
+	int extra_size = get_extra_isize(inode);
+
 	if (S_ISCHR(inode->i_mode) || S_ISBLK(inode->i_mode)) {
 		if (old_valid_dev(inode->i_rdev)) {
-			ri->i_addr[0] =
+			ri->i_addr[extra_size] =
 				cpu_to_le32(old_encode_dev(inode->i_rdev));
-			ri->i_addr[1] = 0;
+			ri->i_addr[extra_size + 1] = 0;
 		} else {
-			ri->i_addr[0] = 0;
-			ri->i_addr[1] =
+			ri->i_addr[extra_size] = 0;
+			ri->i_addr[extra_size + 1] =
 				cpu_to_le32(new_encode_dev(inode->i_rdev));
-			ri->i_addr[2] = 0;
+			ri->i_addr[extra_size + 2] = 0;
 		}
 	}
 }
 
 static void __recover_inline_status(struct inode *inode, struct page *ipage)
 {
-	void *inline_data = inline_data_addr(ipage);
+	void *inline_data = inline_data_addr(inode, ipage);
 	__le32 *start = inline_data;
-	__le32 *end = start + MAX_INLINE_DATA / sizeof(__le32);
+	__le32 *end = start + MAX_INLINE_DATA(inode) / sizeof(__le32);
 
 	while (start < end) {
 		if (*start++) {
@@ -103,22 +114,105 @@ static void __recover_inline_status(struct inode *inode, struct page *ipage)
 	return;
 }
 
+static bool f2fs_enable_inode_chksum(struct f2fs_sb_info *sbi, struct page *page)
+{
+	struct f2fs_inode *ri = &F2FS_NODE(page)->i;
+
+	if (!f2fs_sb_has_inode_chksum(sbi->sb))
+		return false;
+
+	if (!RAW_IS_INODE(F2FS_NODE(page)) || !(ri->i_inline & F2FS_EXTRA_ATTR))
+		return false;
+
+	if (!F2FS_FITS_IN_INODE(ri, le16_to_cpu(ri->i_extra_isize),
+				i_inode_checksum))
+		return false;
+
+	return true;
+}
+
+static __u32 f2fs_inode_chksum(struct f2fs_sb_info *sbi, struct page *page)
+{
+	struct f2fs_node *node = F2FS_NODE(page);
+	struct f2fs_inode *ri = &node->i;
+	__le32 ino = node->footer.ino;
+	__le32 gen = ri->i_generation;
+	__u32 chksum, chksum_seed;
+	__u32 dummy_cs = 0;
+	unsigned int offset = offsetof(struct f2fs_inode, i_inode_checksum);
+	unsigned int cs_size = sizeof(dummy_cs);
+
+	chksum = f2fs_chksum(sbi, sbi->s_chksum_seed, (__u8 *)&ino,
+							sizeof(ino));
+	chksum_seed = f2fs_chksum(sbi, chksum, (__u8 *)&gen, sizeof(gen));
+
+	chksum = f2fs_chksum(sbi, chksum_seed, (__u8 *)ri, offset);
+	chksum = f2fs_chksum(sbi, chksum, (__u8 *)&dummy_cs, cs_size);
+	offset += cs_size;
+	chksum = f2fs_chksum(sbi, chksum, (__u8 *)ri + offset,
+						F2FS_BLKSIZE - offset);
+	return chksum;
+}
+
+bool f2fs_inode_chksum_verify(struct f2fs_sb_info *sbi, struct page *page)
+{
+	struct f2fs_inode *ri;
+	__u32 provided, calculated;
+
+	if (!f2fs_enable_inode_chksum(sbi, page) ||
+			PageDirty(page) || PageWriteback(page))
+		return true;
+
+	ri = &F2FS_NODE(page)->i;
+	provided = le32_to_cpu(ri->i_inode_checksum);
+	calculated = f2fs_inode_chksum(sbi, page);
+
+	if (provided != calculated)
+		f2fs_msg(sbi->sb, KERN_WARNING,
+			"checksum invalid, ino = %x, %x vs. %x",
+			ino_of_node(page), provided, calculated);
+
+	return provided == calculated;
+}
+
+void f2fs_inode_chksum_set(struct f2fs_sb_info *sbi, struct page *page)
+{
+	struct f2fs_inode *ri = &F2FS_NODE(page)->i;
+
+	if (!f2fs_enable_inode_chksum(sbi, page))
+		return;
+
+	ri->i_inode_checksum = cpu_to_le32(f2fs_inode_chksum(sbi, page));
+}
+
+static bool sanity_check_inode(struct inode *inode)
+{
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+
+	if (f2fs_sb_has_flexible_inline_xattr(sbi->sb)
+			&& !f2fs_has_extra_attr(inode)) {
+		set_sbi_flag(sbi, SBI_NEED_FSCK);
+		f2fs_msg(sbi->sb, KERN_WARNING,
+			"%s: corrupted inode ino=%lx, run fsck to fix.",
+			__func__, inode->i_ino);
+		return false;
+	}
+	return true;
+}
+
 static int do_read_inode(struct inode *inode)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	struct f2fs_inode_info *fi = F2FS_I(inode);
 	struct page *node_page;
 	struct f2fs_inode *ri;
+	projid_t i_projid;
 
 	/* Check if ino is within scope */
-	if (check_nid_range(sbi, inode->i_ino)) {
-		f2fs_msg(inode->i_sb, KERN_ERR, "bad inode number: %lu",
-			 (unsigned long) inode->i_ino);
-		WARN_ON(1);
+	if (f2fs_check_nid_range(sbi, inode->i_ino))
 		return -EINVAL;
-	}
 
-	node_page = get_node_page(sbi, inode->i_ino);
+	node_page = f2fs_get_node_page(sbi, inode->i_ino);
 	if (IS_ERR(node_page))
 		return PTR_ERR(node_page);
 
@@ -129,7 +223,7 @@ static int do_read_inode(struct inode *inode)
 	i_gid_write(inode, le32_to_cpu(ri->i_gid));
 	set_nlink(inode, le32_to_cpu(ri->i_links));
 	inode->i_size = le64_to_cpu(ri->i_size);
-	inode->i_blocks = le64_to_cpu(ri->i_blocks);
+	inode->i_blocks = SECTOR_FROM_BLOCK(le64_to_cpu(ri->i_blocks) - 1);
 
 	inode->i_atime.tv_sec = le64_to_cpu(ri->i_atime);
 	inode->i_ctime.tv_sec = le64_to_cpu(ri->i_ctime);
@@ -138,8 +232,11 @@ static int do_read_inode(struct inode *inode)
 	inode->i_ctime.tv_nsec = le32_to_cpu(ri->i_ctime_nsec);
 	inode->i_mtime.tv_nsec = le32_to_cpu(ri->i_mtime_nsec);
 	inode->i_generation = le32_to_cpu(ri->i_generation);
-
-	fi->i_current_depth = le32_to_cpu(ri->i_current_depth);
+	if (S_ISDIR(inode->i_mode))
+		fi->i_current_depth = le32_to_cpu(ri->i_current_depth);
+	else if (S_ISREG(inode->i_mode))
+		fi->i_gc_failures[GC_FAILURE_PIN] =
+					le16_to_cpu(ri->i_gc_failures);
 	fi->i_xattr_nid = le32_to_cpu(ri->i_xattr_nid);
 	fi->i_flags = le32_to_cpu(ri->i_flags);
 	fi->flags = 0;
@@ -152,6 +249,25 @@ static int do_read_inode(struct inode *inode)
 
 	get_inline_info(inode, ri);
 
+	fi->i_extra_isize = f2fs_has_extra_attr(inode) ?
+					le16_to_cpu(ri->i_extra_isize) : 0;
+
+	if (f2fs_sb_has_flexible_inline_xattr(sbi->sb)) {
+		fi->i_inline_xattr_size = le16_to_cpu(ri->i_inline_xattr_size);
+	} else if (f2fs_has_inline_xattr(inode) ||
+				f2fs_has_inline_dentry(inode)) {
+		fi->i_inline_xattr_size = DEFAULT_INLINE_XATTR_ADDRS;
+	} else {
+
+		/*
+		 * Previous inline data or directory always reserved 200 bytes
+		 * in inode layout, even if inline_xattr is disabled. In order
+		 * to keep inline_dentry's structure for backward compatibility,
+		 * we get the space back only from inline_data.
+		 */
+		fi->i_inline_xattr_size = 0;
+	}
+
 	/* check data exist */
 	if (f2fs_has_inline_data(inode) && !f2fs_exist_data(inode))
 		__recover_inline_status(inode, node_page);
@@ -162,9 +278,29 @@ static int do_read_inode(struct inode *inode)
 	if (__written_first_block(ri))
 		set_inode_flag(inode, FI_FIRST_BLOCK_WRITTEN);
 
-	if (!need_inode_block_update(sbi, inode->i_ino))
+	if (!f2fs_need_inode_block_update(sbi, inode->i_ino))
 		fi->last_disk_size = inode->i_size;
 
+	if (fi->i_flags & F2FS_PROJINHERIT_FL)
+		set_inode_flag(inode, FI_PROJ_INHERIT);
+
+	if (f2fs_has_extra_attr(inode) && f2fs_sb_has_project_quota(sbi->sb) &&
+			F2FS_FITS_IN_INODE(ri, fi->i_extra_isize, i_projid))
+		i_projid = (projid_t)le32_to_cpu(ri->i_projid);
+	else
+		i_projid = F2FS_DEF_PROJID;
+	fi->i_projid = make_kprojid(&init_user_ns, i_projid);
+
+	if (f2fs_has_extra_attr(inode) && f2fs_sb_has_inode_crtime(sbi->sb) &&
+			F2FS_FITS_IN_INODE(ri, fi->i_extra_isize, i_crtime)) {
+		fi->i_crtime.tv_sec = le64_to_cpu(ri->i_crtime);
+		fi->i_crtime.tv_nsec = le32_to_cpu(ri->i_crtime_nsec);
+	}
+
+	F2FS_I(inode)->i_disk_time[0] = inode->i_atime;
+	F2FS_I(inode)->i_disk_time[1] = inode->i_ctime;
+	F2FS_I(inode)->i_disk_time[2] = inode->i_mtime;
+	F2FS_I(inode)->i_disk_time[3] = F2FS_I(inode)->i_crtime;
 	f2fs_put_page(node_page, 1);
 
 	stat_inc_inline_xattr(inode);
@@ -194,13 +330,17 @@ struct inode *f2fs_iget(struct super_block *sb, unsigned long ino)
 	ret = do_read_inode(inode);
 	if (ret)
 		goto bad_inode;
+	if (!sanity_check_inode(inode)) {
+		ret = -EINVAL;
+		goto bad_inode;
+	}
 make_now:
 	if (ino == F2FS_NODE_INO(sbi)) {
 		inode->i_mapping->a_ops = &f2fs_node_aops;
-		mapping_set_gfp_mask(inode->i_mapping, GFP_F2FS_ZERO);
+		mapping_set_gfp_mask(inode->i_mapping, GFP_NOFS);
 	} else if (ino == F2FS_META_INO(sbi)) {
 		inode->i_mapping->a_ops = &f2fs_meta_aops;
-		mapping_set_gfp_mask(inode->i_mapping, GFP_F2FS_ZERO);
+		mapping_set_gfp_mask(inode->i_mapping, GFP_NOFS);
 	} else if (S_ISREG(inode->i_mode)) {
 		inode->i_op = &f2fs_file_inode_operations;
 		inode->i_fop = &f2fs_file_operations;
@@ -209,7 +349,7 @@ struct inode *f2fs_iget(struct super_block *sb, unsigned long ino)
 		inode->i_op = &f2fs_dir_inode_operations;
 		inode->i_fop = &f2fs_dir_operations;
 		inode->i_mapping->a_ops = &f2fs_dblock_aops;
-		mapping_set_gfp_mask(inode->i_mapping, GFP_F2FS_HIGH_ZERO);
+		inode_nohighmem(inode);
 	} else if (S_ISLNK(inode->i_mode)) {
 		if (f2fs_encrypted_inode(inode))
 			inode->i_op = &f2fs_encrypted_symlink_inode_operations;
@@ -225,6 +365,7 @@ struct inode *f2fs_iget(struct super_block *sb, unsigned long ino)
 		ret = -EIO;
 		goto bad_inode;
 	}
+	f2fs_set_inode_flags(inode);
 	unlock_new_inode(inode);
 	trace_f2fs_iget(inode);
 	return inode;
@@ -249,13 +390,15 @@ struct inode *f2fs_iget_retry(struct super_block *sb, unsigned long ino)
 	return inode;
 }
 
-int update_inode(struct inode *inode, struct page *node_page)
+void f2fs_update_inode(struct inode *inode, struct page *node_page)
 {
 	struct f2fs_inode *ri;
-
-	f2fs_inode_synced(inode);
+	struct extent_tree *et = F2FS_I(inode)->extent_tree;
 
 	f2fs_wait_on_page_writeback(node_page, NODE, true);
+	set_page_dirty(node_page);
+
+	f2fs_inode_synced(inode);
 
 	ri = F2FS_INODE(node_page);
 
@@ -265,13 +408,15 @@ int update_inode(struct inode *inode, struct page *node_page)
 	ri->i_gid = cpu_to_le32(i_gid_read(inode));
 	ri->i_links = cpu_to_le32(inode->i_nlink);
 	ri->i_size = cpu_to_le64(i_size_read(inode));
-	ri->i_blocks = cpu_to_le64(inode->i_blocks);
+	ri->i_blocks = cpu_to_le64(SECTOR_TO_BLOCK(inode->i_blocks) + 1);
 
-	if (F2FS_I(inode)->extent_tree)
-		set_raw_extent(&F2FS_I(inode)->extent_tree->largest,
-							&ri->i_ext);
-	else
+	if (et) {
+		read_lock(&et->lock);
+		set_raw_extent(&et->largest, &ri->i_ext);
+		read_unlock(&et->lock);
+	} else {
 		memset(&ri->i_ext, 0, sizeof(ri->i_ext));
+	}
 	set_raw_inline(inode, ri);
 
 	ri->i_atime = cpu_to_le64(inode->i_atime.tv_sec);
@@ -280,30 +425,63 @@ int update_inode(struct inode *inode, struct page *node_page)
 	ri->i_atime_nsec = cpu_to_le32(inode->i_atime.tv_nsec);
 	ri->i_ctime_nsec = cpu_to_le32(inode->i_ctime.tv_nsec);
 	ri->i_mtime_nsec = cpu_to_le32(inode->i_mtime.tv_nsec);
-	ri->i_current_depth = cpu_to_le32(F2FS_I(inode)->i_current_depth);
+	if (S_ISDIR(inode->i_mode))
+		ri->i_current_depth =
+			cpu_to_le32(F2FS_I(inode)->i_current_depth);
+	else if (S_ISREG(inode->i_mode))
+		ri->i_gc_failures =
+			cpu_to_le16(F2FS_I(inode)->i_gc_failures[GC_FAILURE_PIN]);
 	ri->i_xattr_nid = cpu_to_le32(F2FS_I(inode)->i_xattr_nid);
 	ri->i_flags = cpu_to_le32(F2FS_I(inode)->i_flags);
 	ri->i_pino = cpu_to_le32(F2FS_I(inode)->i_pino);
 	ri->i_generation = cpu_to_le32(inode->i_generation);
 	ri->i_dir_level = F2FS_I(inode)->i_dir_level;
 
+	if (f2fs_has_extra_attr(inode)) {
+		ri->i_extra_isize = cpu_to_le16(F2FS_I(inode)->i_extra_isize);
+
+		if (f2fs_sb_has_flexible_inline_xattr(F2FS_I_SB(inode)->sb))
+			ri->i_inline_xattr_size =
+				cpu_to_le16(F2FS_I(inode)->i_inline_xattr_size);
+
+		if (f2fs_sb_has_project_quota(F2FS_I_SB(inode)->sb) &&
+			F2FS_FITS_IN_INODE(ri, F2FS_I(inode)->i_extra_isize,
+								i_projid)) {
+			projid_t i_projid;
+
+			i_projid = from_kprojid(&init_user_ns,
+						F2FS_I(inode)->i_projid);
+			ri->i_projid = cpu_to_le32(i_projid);
+		}
+
+		if (f2fs_sb_has_inode_crtime(F2FS_I_SB(inode)->sb) &&
+			F2FS_FITS_IN_INODE(ri, F2FS_I(inode)->i_extra_isize,
+								i_crtime)) {
+			ri->i_crtime =
+				cpu_to_le64(F2FS_I(inode)->i_crtime.tv_sec);
+			ri->i_crtime_nsec =
+				cpu_to_le32(F2FS_I(inode)->i_crtime.tv_nsec);
+		}
+	}
+
 	__set_inode_rdev(inode, ri);
-	set_cold_node(inode, node_page);
 
 	/* deleted inode */
 	if (inode->i_nlink == 0)
 		clear_inline_node(node_page);
 
-	return set_page_dirty(node_page);
+	F2FS_I(inode)->i_disk_time[0] = inode->i_atime;
+	F2FS_I(inode)->i_disk_time[1] = inode->i_ctime;
+	F2FS_I(inode)->i_disk_time[2] = inode->i_mtime;
+	F2FS_I(inode)->i_disk_time[3] = F2FS_I(inode)->i_crtime;
 }
 
-int update_inode_page(struct inode *inode)
+void f2fs_update_inode_page(struct inode *inode)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	struct page *node_page;
-	int ret = 0;
 retry:
-	node_page = get_node_page(sbi, inode->i_ino);
+	node_page = f2fs_get_node_page(sbi, inode->i_ino);
 	if (IS_ERR(node_page)) {
 		int err = PTR_ERR(node_page);
 		if (err == -ENOMEM) {
@@ -312,12 +490,10 @@ int update_inode_page(struct inode *inode)
 		} else if (err != -ENOENT) {
 			f2fs_stop_checkpoint(sbi, false);
 		}
-		f2fs_inode_synced(inode);
-		return 0;
+		return;
 	}
-	ret = update_inode(inode, node_page);
+	f2fs_update_inode(inode, node_page);
 	f2fs_put_page(node_page, 1);
-	return ret;
 }
 
 int f2fs_write_inode(struct inode *inode, struct writeback_control *wbc)
@@ -335,7 +511,8 @@ int f2fs_write_inode(struct inode *inode, struct writeback_control *wbc)
 	 * We need to balance fs here to prevent from producing dirty node pages
 	 * during the urgent cleaning time when runing out of free sections.
 	 */
-	if (update_inode_page(inode))
+	f2fs_update_inode_page(inode);
+	if (wbc && wbc->nr_to_write)
 		f2fs_balance_fs(sbi, true);
 	return 0;
 }
@@ -351,7 +528,7 @@ void f2fs_evict_inode(struct inode *inode)
 
 	/* some remained atomic pages should discarded */
 	if (f2fs_is_atomic_file(inode))
-		drop_inmem_pages(inode);
+		f2fs_drop_inmem_pages(inode);
 
 	trace_f2fs_evict_inode(inode);
 	truncate_inode_pages_final(&inode->i_data);
@@ -361,17 +538,18 @@ void f2fs_evict_inode(struct inode *inode)
 		goto out_clear;
 
 	f2fs_bug_on(sbi, get_dirty_pages(inode));
-	remove_dirty_inode(inode);
+	f2fs_remove_dirty_inode(inode);
 
 	f2fs_destroy_extent_tree(inode);
 
 	if (inode->i_nlink || is_bad_inode(inode))
 		goto no_delete;
 
-#ifdef CONFIG_F2FS_FAULT_INJECTION
-	if (time_to_inject(sbi, FAULT_EVICT_INODE))
-		goto no_delete;
-#endif
+	dquot_initialize(inode);
+
+	f2fs_remove_ino_entry(sbi, inode->i_ino, APPEND_INO);
+	f2fs_remove_ino_entry(sbi, inode->i_ino, UPDATE_INO);
+	f2fs_remove_ino_entry(sbi, inode->i_ino, FLUSH_INO);
 
 	sb_start_intwrite(inode->i_sb);
 	set_inode_flag(inode, FI_NO_ALLOC);
@@ -380,10 +558,18 @@ void f2fs_evict_inode(struct inode *inode)
 	if (F2FS_HAS_BLOCKS(inode))
 		err = f2fs_truncate(inode);
 
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	if (time_to_inject(sbi, FAULT_EVICT_INODE)) {
+		f2fs_show_injection_info(FAULT_EVICT_INODE);
+		err = -EIO;
+	}
+#endif
 	if (!err) {
 		f2fs_lock_op(sbi);
-		err = remove_inode_page(inode);
+		err = f2fs_remove_inode_page(inode);
 		f2fs_unlock_op(sbi);
+		if (err == -ENOENT)
+			err = 0;
 	}
 
 	/* give more chances, if ENOMEM case */
@@ -393,37 +579,67 @@ void f2fs_evict_inode(struct inode *inode)
 	}
 
 	if (err)
-		update_inode_page(inode);
+		f2fs_update_inode_page(inode);
+	dquot_free_inode(inode);
 	sb_end_intwrite(inode->i_sb);
 no_delete:
+	dquot_drop(inode);
+
 	stat_dec_inline_xattr(inode);
 	stat_dec_inline_dir(inode);
 	stat_dec_inline_inode(inode);
 
-	invalidate_mapping_pages(NODE_MAPPING(sbi), inode->i_ino, inode->i_ino);
+	if (likely(!is_set_ckpt_flags(sbi, CP_ERROR_FLAG)))
+		f2fs_bug_on(sbi, is_inode_flag_set(inode, FI_DIRTY_INODE));
+	else
+		f2fs_inode_synced(inode);
+
+	/* ino == 0, if f2fs_new_inode() was failed t*/
+	if (inode->i_ino)
+		invalidate_mapping_pages(NODE_MAPPING(sbi), inode->i_ino,
+							inode->i_ino);
 	if (xnid)
 		invalidate_mapping_pages(NODE_MAPPING(sbi), xnid, xnid);
-	if (is_inode_flag_set(inode, FI_APPEND_WRITE))
-		add_ino_entry(sbi, inode->i_ino, APPEND_INO);
-	if (is_inode_flag_set(inode, FI_UPDATE_WRITE))
-		add_ino_entry(sbi, inode->i_ino, UPDATE_INO);
+	if (inode->i_nlink) {
+		if (is_inode_flag_set(inode, FI_APPEND_WRITE))
+			f2fs_add_ino_entry(sbi, inode->i_ino, APPEND_INO);
+		if (is_inode_flag_set(inode, FI_UPDATE_WRITE))
+			f2fs_add_ino_entry(sbi, inode->i_ino, UPDATE_INO);
+	}
 	if (is_inode_flag_set(inode, FI_FREE_NID)) {
-		alloc_nid_failed(sbi, inode->i_ino);
+		f2fs_alloc_nid_failed(sbi, inode->i_ino);
 		clear_inode_flag(inode, FI_FREE_NID);
+	} else {
+		/*
+		 * If xattr nid is corrupted, we can reach out error condition,
+		 * err & !f2fs_exist_written_data(sbi, inode->i_ino, ORPHAN_INO)).
+		 * In that case, f2fs_check_nid_range() is enough to give a clue.
+		 */
 	}
-	f2fs_bug_on(sbi, err &&
-		!exist_written_data(sbi, inode->i_ino, ORPHAN_INO));
 out_clear:
-	fscrypt_put_encryption_info(inode, NULL);
+	fscrypt_put_encryption_info(inode);
 	clear_inode(inode);
 }
 
 /* caller should call f2fs_lock_op() */
-void handle_failed_inode(struct inode *inode)
+void f2fs_handle_failed_inode(struct inode *inode)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	struct node_info ni;
 
+	/*
+	 * clear nlink of inode in order to release resource of inode
+	 * immediately.
+	 */
+	clear_nlink(inode);
+
+	/*
+	 * we must call this to avoid inode being remained as dirty, resulting
+	 * in a panic when flushing dirty inodes in gdirty_list.
+	 */
+	f2fs_update_inode_page(inode);
+	f2fs_inode_synced(inode);
+
 	/* don't make bad inode, since it becomes a regular file. */
 	unlock_new_inode(inode);
 
@@ -432,18 +648,18 @@ void handle_failed_inode(struct inode *inode)
 	 * so we can prevent losing this orphan when encoutering checkpoint
 	 * and following suddenly power-off.
 	 */
-	get_node_info(sbi, inode->i_ino, &ni);
+	f2fs_get_node_info(sbi, inode->i_ino, &ni);
 
 	if (ni.blk_addr != NULL_ADDR) {
-		int err = acquire_orphan_inode(sbi);
+		int err = f2fs_acquire_orphan_inode(sbi);
 		if (err) {
 			set_sbi_flag(sbi, SBI_NEED_FSCK);
 			f2fs_msg(sbi->sb, KERN_WARNING,
 				"Too many orphan inodes, run fsck to fix.");
 		} else {
-			add_orphan_inode(inode);
+			f2fs_add_orphan_inode(inode);
 		}
-		alloc_nid_done(sbi, inode->i_ino);
+		f2fs_alloc_nid_done(sbi, inode->i_ino);
 	} else {
 		set_inode_flag(inode, FI_FREE_NID);
 	}
diff --git a/fs/f2fs/namei.c b/fs/f2fs/namei.c
index ccb99d5..c53760e 100644
--- a/fs/f2fs/namei.c
+++ b/fs/f2fs/namei.c
@@ -15,6 +15,7 @@
 #include <linux/ctype.h>
 #include <linux/dcache.h>
 #include <linux/namei.h>
+#include <linux/quotaops.h>
 
 #include "f2fs.h"
 #include "node.h"
@@ -28,6 +29,7 @@ static struct inode *f2fs_new_inode(struct inode *dir, umode_t mode)
 	nid_t ino;
 	struct inode *inode;
 	bool nid_free = false;
+	int xattr_size = 0;
 	int err;
 
 	inode = new_inode(dir->i_sb);
@@ -35,46 +37,93 @@ static struct inode *f2fs_new_inode(struct inode *dir, umode_t mode)
 		return ERR_PTR(-ENOMEM);
 
 	f2fs_lock_op(sbi);
-	if (!alloc_nid(sbi, &ino)) {
+	if (!f2fs_alloc_nid(sbi, &ino)) {
 		f2fs_unlock_op(sbi);
 		err = -ENOSPC;
 		goto fail;
 	}
 	f2fs_unlock_op(sbi);
 
+	nid_free = true;
+
 	inode_init_owner(inode, dir, mode);
 
 	inode->i_ino = ino;
 	inode->i_blocks = 0;
-	inode->i_mtime = inode->i_atime = inode->i_ctime = current_time(inode);
+	inode->i_mtime = inode->i_atime = inode->i_ctime =
+			F2FS_I(inode)->i_crtime = current_time(inode);
 	inode->i_generation = sbi->s_next_generation++;
 
+	if (S_ISDIR(inode->i_mode))
+		F2FS_I(inode)->i_current_depth = 1;
+
 	err = insert_inode_locked(inode);
 	if (err) {
 		err = -EINVAL;
-		nid_free = true;
 		goto fail;
 	}
 
+	if (f2fs_sb_has_project_quota(sbi->sb) &&
+		(F2FS_I(dir)->i_flags & F2FS_PROJINHERIT_FL))
+		F2FS_I(inode)->i_projid = F2FS_I(dir)->i_projid;
+	else
+		F2FS_I(inode)->i_projid = make_kprojid(&init_user_ns,
+							F2FS_DEF_PROJID);
+
+	err = dquot_initialize(inode);
+	if (err)
+		goto fail_drop;
+
+	err = dquot_alloc_inode(inode);
+	if (err)
+		goto fail_drop;
+
+	set_inode_flag(inode, FI_NEW_INODE);
+
 	/* If the directory encrypted, then we should encrypt the inode. */
-	if (f2fs_encrypted_inode(dir) && f2fs_may_encrypt(inode))
+	if ((f2fs_encrypted_inode(dir) || DUMMY_ENCRYPTION_ENABLED(sbi)) &&
+				f2fs_may_encrypt(inode))
 		f2fs_set_encrypted_inode(inode);
 
-	set_inode_flag(inode, FI_NEW_INODE);
+	if (f2fs_sb_has_extra_attr(sbi->sb)) {
+		set_inode_flag(inode, FI_EXTRA_ATTR);
+		F2FS_I(inode)->i_extra_isize = F2FS_TOTAL_EXTRA_ATTR_SIZE;
+	}
 
 	if (test_opt(sbi, INLINE_XATTR))
 		set_inode_flag(inode, FI_INLINE_XATTR);
+
 	if (test_opt(sbi, INLINE_DATA) && f2fs_may_inline_data(inode))
 		set_inode_flag(inode, FI_INLINE_DATA);
 	if (f2fs_may_inline_dentry(inode))
 		set_inode_flag(inode, FI_INLINE_DENTRY);
 
+	if (f2fs_sb_has_flexible_inline_xattr(sbi->sb)) {
+		f2fs_bug_on(sbi, !f2fs_has_extra_attr(inode));
+		if (f2fs_has_inline_xattr(inode))
+			xattr_size = F2FS_OPTION(sbi).inline_xattr_size;
+		/* Otherwise, will be 0 */
+	} else if (f2fs_has_inline_xattr(inode) ||
+				f2fs_has_inline_dentry(inode)) {
+		xattr_size = DEFAULT_INLINE_XATTR_ADDRS;
+	}
+	F2FS_I(inode)->i_inline_xattr_size = xattr_size;
+
 	f2fs_init_extent_tree(inode, NULL);
 
 	stat_inc_inline_xattr(inode);
 	stat_inc_inline_inode(inode);
 	stat_inc_inline_dir(inode);
 
+	F2FS_I(inode)->i_flags =
+		f2fs_mask_flags(mode, F2FS_I(dir)->i_flags & F2FS_FL_INHERITED);
+
+	if (S_ISDIR(inode->i_mode))
+		F2FS_I(inode)->i_flags |= F2FS_INDEX_FL;
+
+	if (F2FS_I(inode)->i_flags & F2FS_PROJINHERIT_FL)
+		set_inode_flag(inode, FI_PROJ_INHERIT);
+
 	trace_f2fs_new_inode(inode, 0);
 	return inode;
 
@@ -85,9 +134,19 @@ static struct inode *f2fs_new_inode(struct inode *dir, umode_t mode)
 		set_inode_flag(inode, FI_FREE_NID);
 	iput(inode);
 	return ERR_PTR(err);
+fail_drop:
+	trace_f2fs_new_inode(inode, err);
+	dquot_drop(inode);
+	inode->i_flags |= S_NOQUOTA;
+	if (nid_free)
+		set_inode_flag(inode, FI_FREE_NID);
+	clear_nlink(inode);
+	unlock_new_inode(inode);
+	iput(inode);
+	return ERR_PTR(err);
 }
 
-static int is_multimedia_file(const unsigned char *s, const char *sub)
+static int is_extension_exist(const unsigned char *s, const char *sub)
 {
 	size_t slen = strlen(s);
 	size_t sublen = strlen(sub);
@@ -113,19 +172,94 @@ static int is_multimedia_file(const unsigned char *s, const char *sub)
 /*
  * Set multimedia files as cold files for hot/cold data separation
  */
-static inline void set_cold_files(struct f2fs_sb_info *sbi, struct inode *inode,
+static inline void set_file_temperature(struct f2fs_sb_info *sbi, struct inode *inode,
 		const unsigned char *name)
 {
-	int i;
-	__u8 (*extlist)[8] = sbi->raw_super->extension_list;
+	__u8 (*extlist)[F2FS_EXTENSION_LEN] = sbi->raw_super->extension_list;
+	int i, cold_count, hot_count;
+
+	down_read(&sbi->sb_lock);
 
-	int count = le32_to_cpu(sbi->raw_super->extension_count);
-	for (i = 0; i < count; i++) {
-		if (is_multimedia_file(name, extlist[i])) {
+	cold_count = le32_to_cpu(sbi->raw_super->extension_count);
+	hot_count = sbi->raw_super->hot_ext_count;
+
+	for (i = 0; i < cold_count + hot_count; i++) {
+		if (!is_extension_exist(name, extlist[i]))
+			continue;
+		if (i < cold_count)
 			file_set_cold(inode);
-			break;
-		}
+		else
+			file_set_hot(inode);
+		break;
 	}
+
+	up_read(&sbi->sb_lock);
+}
+
+int f2fs_update_extension_list(struct f2fs_sb_info *sbi, const char *name,
+							bool hot, bool set)
+{
+	__u8 (*extlist)[F2FS_EXTENSION_LEN] = sbi->raw_super->extension_list;
+	int cold_count = le32_to_cpu(sbi->raw_super->extension_count);
+	int hot_count = sbi->raw_super->hot_ext_count;
+	int total_count = cold_count + hot_count;
+	int start, count;
+	int i;
+
+	if (set) {
+		if (total_count == F2FS_MAX_EXTENSION)
+			return -EINVAL;
+	} else {
+		if (!hot && !cold_count)
+			return -EINVAL;
+		if (hot && !hot_count)
+			return -EINVAL;
+	}
+
+	if (hot) {
+		start = cold_count;
+		count = total_count;
+	} else {
+		start = 0;
+		count = cold_count;
+	}
+
+	for (i = start; i < count; i++) {
+		if (strcmp(name, extlist[i]))
+			continue;
+
+		if (set)
+			return -EINVAL;
+
+		memcpy(extlist[i], extlist[i + 1],
+				F2FS_EXTENSION_LEN * (total_count - i - 1));
+		memset(extlist[total_count - 1], 0, F2FS_EXTENSION_LEN);
+		if (hot)
+			sbi->raw_super->hot_ext_count = hot_count - 1;
+		else
+			sbi->raw_super->extension_count =
+						cpu_to_le32(cold_count - 1);
+		return 0;
+	}
+
+	if (!set)
+		return -EINVAL;
+
+	if (hot) {
+		strncpy(extlist[count], name, strlen(name));
+		sbi->raw_super->hot_ext_count = hot_count + 1;
+	} else {
+		char buf[F2FS_MAX_EXTENSION][F2FS_EXTENSION_LEN];
+
+		memcpy(buf, &extlist[cold_count],
+				F2FS_EXTENSION_LEN * hot_count);
+		memset(extlist[cold_count], 0, F2FS_EXTENSION_LEN);
+		strncpy(extlist[cold_count], name, strlen(name));
+		memcpy(&extlist[cold_count + 1], buf,
+				F2FS_EXTENSION_LEN * hot_count);
+		sbi->raw_super->extension_count = cpu_to_le32(cold_count + 1);
+	}
+	return 0;
 }
 
 static int f2fs_create(struct inode *dir, struct dentry *dentry, umode_t mode,
@@ -136,35 +270,42 @@ static int f2fs_create(struct inode *dir, struct dentry *dentry, umode_t mode,
 	nid_t ino = 0;
 	int err;
 
+	if (unlikely(f2fs_cp_error(sbi)))
+		return -EIO;
+
+	err = dquot_initialize(dir);
+	if (err)
+		return err;
+
 	inode = f2fs_new_inode(dir, mode);
 	if (IS_ERR(inode))
 		return PTR_ERR(inode);
 
 	if (!test_opt(sbi, DISABLE_EXT_IDENTIFY))
-		set_cold_files(sbi, inode, dentry->d_name.name);
+		set_file_temperature(sbi, inode, dentry->d_name.name);
 
 	inode->i_op = &f2fs_file_inode_operations;
 	inode->i_fop = &f2fs_file_operations;
 	inode->i_mapping->a_ops = &f2fs_dblock_aops;
 	ino = inode->i_ino;
 
-	f2fs_balance_fs(sbi, true);
-
 	f2fs_lock_op(sbi);
 	err = f2fs_add_link(dentry, inode);
 	if (err)
 		goto out;
 	f2fs_unlock_op(sbi);
 
-	alloc_nid_done(sbi, ino);
+	f2fs_alloc_nid_done(sbi, ino);
 
 	d_instantiate_new(dentry, inode);
 
 	if (IS_DIRSYNC(dir))
 		f2fs_sync_fs(sbi->sb, 1);
+
+	f2fs_balance_fs(sbi, true);
 	return 0;
 out:
-	handle_failed_inode(inode);
+	f2fs_handle_failed_inode(inode);
 	return err;
 }
 
@@ -175,9 +316,21 @@ static int f2fs_link(struct dentry *old_dentry, struct inode *dir,
 	struct f2fs_sb_info *sbi = F2FS_I_SB(dir);
 	int err;
 
-	if (f2fs_encrypted_inode(dir) &&
-			!fscrypt_has_permitted_context(dir, inode))
-		return -EPERM;
+	if (unlikely(f2fs_cp_error(sbi)))
+		return -EIO;
+
+	err = fscrypt_prepare_link(old_dentry, dir, dentry);
+	if (err)
+		return err;
+
+	if (is_inode_flag_set(dir, FI_PROJ_INHERIT) &&
+			(!projid_eq(F2FS_I(dir)->i_projid,
+			F2FS_I(old_dentry->d_inode)->i_projid)))
+		return -EXDEV;
+
+	err = dquot_initialize(dir);
+	if (err)
+		return err;
 
 	f2fs_balance_fs(sbi, true);
 
@@ -232,32 +385,33 @@ static int __recover_dot_dentries(struct inode *dir, nid_t pino)
 		return 0;
 	}
 
+	err = dquot_initialize(dir);
+	if (err)
+		return err;
+
 	f2fs_balance_fs(sbi, true);
 
 	f2fs_lock_op(sbi);
 
 	de = f2fs_find_entry(dir, &dot, &page);
 	if (de) {
-		f2fs_dentry_kunmap(dir, page);
 		f2fs_put_page(page, 0);
 	} else if (IS_ERR(page)) {
 		err = PTR_ERR(page);
 		goto out;
 	} else {
-		err = __f2fs_add_link(dir, &dot, NULL, dir->i_ino, S_IFDIR);
+		err = f2fs_do_add_link(dir, &dot, NULL, dir->i_ino, S_IFDIR);
 		if (err)
 			goto out;
 	}
 
 	de = f2fs_find_entry(dir, &dotdot, &page);
-	if (de) {
-		f2fs_dentry_kunmap(dir, page);
+	if (de)
 		f2fs_put_page(page, 0);
-	} else if (IS_ERR(page)) {
+	else if (IS_ERR(page))
 		err = PTR_ERR(page);
-	} else {
-		err = __f2fs_add_link(dir, &dotdot, NULL, pino, S_IFDIR);
-	}
+	else
+		err = f2fs_do_add_link(dir, &dotdot, NULL, pino, S_IFDIR);
 out:
 	if (!err)
 		clear_inode_flag(dir, FI_INLINE_DOTS);
@@ -272,66 +426,70 @@ static struct dentry *f2fs_lookup(struct inode *dir, struct dentry *dentry,
 	struct inode *inode = NULL;
 	struct f2fs_dir_entry *de;
 	struct page *page;
-	nid_t ino;
+	struct dentry *new;
+	nid_t ino = -1;
 	int err = 0;
 	unsigned int root_ino = F2FS_ROOT_INO(F2FS_I_SB(dir));
 
-	if (f2fs_encrypted_inode(dir)) {
-		int res = fscrypt_get_encryption_info(dir);
+	trace_f2fs_lookup_start(dir, dentry, flags);
 
-		/*
-		 * DCACHE_ENCRYPTED_WITH_KEY is set if the dentry is
-		 * created while the directory was encrypted and we
-		 * don't have access to the key.
-		 */
-		if (fscrypt_has_encryption_key(dir))
-			fscrypt_set_encrypted_dentry(dentry);
-		fscrypt_set_d_op(dentry);
-		if (res && res != -ENOKEY)
-			return ERR_PTR(res);
-	}
+	err = fscrypt_prepare_lookup(dir, dentry, flags);
+	if (err)
+		goto out;
 
-	if (dentry->d_name.len > F2FS_NAME_LEN)
-		return ERR_PTR(-ENAMETOOLONG);
+	if (dentry->d_name.len > F2FS_NAME_LEN) {
+		err = -ENAMETOOLONG;
+		goto out;
+	}
 
 	de = f2fs_find_entry(dir, &dentry->d_name, &page);
 	if (!de) {
-		if (IS_ERR(page))
-			return (struct dentry *)page;
-		return d_splice_alias(inode, dentry);
+		if (IS_ERR(page)) {
+			err = PTR_ERR(page);
+			goto out;
+		}
+		goto out_splice;
 	}
 
 	ino = le32_to_cpu(de->ino);
-	f2fs_dentry_kunmap(dir, page);
 	f2fs_put_page(page, 0);
 
 	inode = f2fs_iget(dir->i_sb, ino);
-	if (IS_ERR(inode))
-		return ERR_CAST(inode);
+	if (IS_ERR(inode)) {
+		err = PTR_ERR(inode);
+		goto out;
+	}
 
 	if ((dir->i_ino == root_ino) && f2fs_has_inline_dots(dir)) {
 		err = __recover_dot_dentries(dir, root_ino);
 		if (err)
-			goto err_out;
+			goto out_iput;
 	}
 
 	if (f2fs_has_inline_dots(inode)) {
 		err = __recover_dot_dentries(inode, dir->i_ino);
 		if (err)
-			goto err_out;
+			goto out_iput;
 	}
-	if (!IS_ERR(inode) && f2fs_encrypted_inode(dir) &&
-			(S_ISDIR(inode->i_mode) || S_ISLNK(inode->i_mode)) &&
-			!fscrypt_has_permitted_context(dir, inode)) {
-		bool nokey = f2fs_encrypted_inode(inode) &&
-			!fscrypt_has_encryption_key(inode);
-		err = nokey ? -ENOKEY : -EPERM;
-		goto err_out;
+	if (f2fs_encrypted_inode(dir) &&
+	    (S_ISDIR(inode->i_mode) || S_ISLNK(inode->i_mode)) &&
+	    !fscrypt_has_permitted_context(dir, inode)) {
+		f2fs_msg(inode->i_sb, KERN_WARNING,
+			 "Inconsistent encryption contexts: %lu/%lu",
+			 dir->i_ino, inode->i_ino);
+		err = -EPERM;
+		goto out_iput;
 	}
-	return d_splice_alias(inode, dentry);
-
-err_out:
+out_splice:
+	new = d_splice_alias(inode, dentry);
+	if (IS_ERR(new))
+		err = PTR_ERR(new);
+	trace_f2fs_lookup_end(dir, dentry, ino, err);
+	return new;
+out_iput:
 	iput(inode);
+out:
+	trace_f2fs_lookup_end(dir, dentry, ino, err);
 	return ERR_PTR(err);
 }
 
@@ -345,6 +503,16 @@ static int f2fs_unlink(struct inode *dir, struct dentry *dentry)
 
 	trace_f2fs_unlink_enter(dir, dentry);
 
+	if (unlikely(f2fs_cp_error(sbi)))
+		return -EIO;
+
+	err = dquot_initialize(dir);
+	if (err)
+		return err;
+	err = dquot_initialize(inode);
+	if (err)
+		return err;
+
 	de = f2fs_find_entry(dir, &dentry->d_name, &page);
 	if (!de) {
 		if (IS_ERR(page))
@@ -355,10 +523,9 @@ static int f2fs_unlink(struct inode *dir, struct dentry *dentry)
 	f2fs_balance_fs(sbi, true);
 
 	f2fs_lock_op(sbi);
-	err = acquire_orphan_inode(sbi);
+	err = f2fs_acquire_orphan_inode(sbi);
 	if (err) {
 		f2fs_unlock_op(sbi);
-		f2fs_dentry_kunmap(dir, page);
 		f2fs_put_page(page, 0);
 		goto fail;
 	}
@@ -392,73 +559,42 @@ static int f2fs_symlink(struct inode *dir, struct dentry *dentry,
 	struct f2fs_sb_info *sbi = F2FS_I_SB(dir);
 	struct inode *inode;
 	size_t len = strlen(symname);
-	struct fscrypt_str disk_link = FSTR_INIT((char *)symname, len + 1);
-	struct fscrypt_symlink_data *sd = NULL;
+	struct fscrypt_str disk_link;
 	int err;
 
-	if (f2fs_encrypted_inode(dir)) {
-		err = fscrypt_get_encryption_info(dir);
-		if (err)
-			return err;
+	if (unlikely(f2fs_cp_error(sbi)))
+		return -EIO;
 
-		if (!fscrypt_has_encryption_key(dir))
-			return -ENOKEY;
-
-		disk_link.len = (fscrypt_fname_encrypted_size(dir, len) +
-				sizeof(struct fscrypt_symlink_data));
-	}
+	err = fscrypt_prepare_symlink(dir, symname, len, dir->i_sb->s_blocksize,
+				      &disk_link);
+	if (err)
+		return err;
 
-	if (disk_link.len > dir->i_sb->s_blocksize)
-		return -ENAMETOOLONG;
+	err = dquot_initialize(dir);
+	if (err)
+		return err;
 
 	inode = f2fs_new_inode(dir, S_IFLNK | S_IRWXUGO);
 	if (IS_ERR(inode))
 		return PTR_ERR(inode);
 
-	if (f2fs_encrypted_inode(inode))
+	if (IS_ENCRYPTED(inode))
 		inode->i_op = &f2fs_encrypted_symlink_inode_operations;
 	else
 		inode->i_op = &f2fs_symlink_inode_operations;
 	inode_nohighmem(inode);
 	inode->i_mapping->a_ops = &f2fs_dblock_aops;
 
-	f2fs_balance_fs(sbi, true);
-
 	f2fs_lock_op(sbi);
 	err = f2fs_add_link(dentry, inode);
 	if (err)
-		goto out;
+		goto out_f2fs_handle_failed_inode;
 	f2fs_unlock_op(sbi);
-	alloc_nid_done(sbi, inode->i_ino);
+	f2fs_alloc_nid_done(sbi, inode->i_ino);
 
-	if (f2fs_encrypted_inode(inode)) {
-		struct qstr istr = QSTR_INIT(symname, len);
-		struct fscrypt_str ostr;
-
-		sd = kzalloc(disk_link.len, GFP_NOFS);
-		if (!sd) {
-			err = -ENOMEM;
-			goto err_out;
-		}
-
-		err = fscrypt_get_encryption_info(inode);
-		if (err)
-			goto err_out;
-
-		if (!fscrypt_has_encryption_key(inode)) {
-			err = -ENOKEY;
-			goto err_out;
-		}
-
-		ostr.name = sd->encrypted_path;
-		ostr.len = disk_link.len;
-		err = fscrypt_fname_usr_to_disk(inode, &istr, &ostr);
-		if (err)
-			goto err_out;
-
-		sd->len = cpu_to_le16(ostr.len);
-		disk_link.name = (char *)sd;
-	}
+	err = fscrypt_encrypt_symlink(inode, symname, len, &disk_link);
+	if (err)
+		goto err_out;
 
 	err = page_symlink(inode, disk_link.name, disk_link.len);
 
@@ -484,10 +620,14 @@ static int f2fs_symlink(struct inode *dir, struct dentry *dentry,
 		f2fs_unlink(dir, dentry);
 	}
 
-	kfree(sd);
-	return err;
-out:
-	handle_failed_inode(inode);
+	f2fs_balance_fs(sbi, true);
+	goto out_free_encrypted_link;
+
+out_f2fs_handle_failed_inode:
+	f2fs_handle_failed_inode(inode);
+out_free_encrypted_link:
+	if (disk_link.name != (unsigned char *)symname)
+		kfree(disk_link.name);
 	return err;
 }
 
@@ -497,6 +637,13 @@ static int f2fs_mkdir(struct inode *dir, struct dentry *dentry, umode_t mode)
 	struct inode *inode;
 	int err;
 
+	if (unlikely(f2fs_cp_error(sbi)))
+		return -EIO;
+
+	err = dquot_initialize(dir);
+	if (err)
+		return err;
+
 	inode = f2fs_new_inode(dir, S_IFDIR | mode);
 	if (IS_ERR(inode))
 		return PTR_ERR(inode);
@@ -504,9 +651,7 @@ static int f2fs_mkdir(struct inode *dir, struct dentry *dentry, umode_t mode)
 	inode->i_op = &f2fs_dir_inode_operations;
 	inode->i_fop = &f2fs_dir_operations;
 	inode->i_mapping->a_ops = &f2fs_dblock_aops;
-	mapping_set_gfp_mask(inode->i_mapping, GFP_F2FS_HIGH_ZERO);
-
-	f2fs_balance_fs(sbi, true);
+	inode_nohighmem(inode);
 
 	set_inode_flag(inode, FI_INC_LINK);
 	f2fs_lock_op(sbi);
@@ -515,17 +660,19 @@ static int f2fs_mkdir(struct inode *dir, struct dentry *dentry, umode_t mode)
 		goto out_fail;
 	f2fs_unlock_op(sbi);
 
-	alloc_nid_done(sbi, inode->i_ino);
+	f2fs_alloc_nid_done(sbi, inode->i_ino);
 
 	d_instantiate_new(dentry, inode);
 
 	if (IS_DIRSYNC(dir))
 		f2fs_sync_fs(sbi->sb, 1);
+
+	f2fs_balance_fs(sbi, true);
 	return 0;
 
 out_fail:
 	clear_inode_flag(inode, FI_INC_LINK);
-	handle_failed_inode(inode);
+	f2fs_handle_failed_inode(inode);
 	return err;
 }
 
@@ -544,6 +691,13 @@ static int f2fs_mknod(struct inode *dir, struct dentry *dentry,
 	struct inode *inode;
 	int err = 0;
 
+	if (unlikely(f2fs_cp_error(sbi)))
+		return -EIO;
+
+	err = dquot_initialize(dir);
+	if (err)
+		return err;
+
 	inode = f2fs_new_inode(dir, mode);
 	if (IS_ERR(inode))
 		return PTR_ERR(inode);
@@ -551,23 +705,23 @@ static int f2fs_mknod(struct inode *dir, struct dentry *dentry,
 	init_special_inode(inode, inode->i_mode, rdev);
 	inode->i_op = &f2fs_special_inode_operations;
 
-	f2fs_balance_fs(sbi, true);
-
 	f2fs_lock_op(sbi);
 	err = f2fs_add_link(dentry, inode);
 	if (err)
 		goto out;
 	f2fs_unlock_op(sbi);
 
-	alloc_nid_done(sbi, inode->i_ino);
+	f2fs_alloc_nid_done(sbi, inode->i_ino);
 
 	d_instantiate_new(dentry, inode);
 
 	if (IS_DIRSYNC(dir))
 		f2fs_sync_fs(sbi->sb, 1);
+
+	f2fs_balance_fs(sbi, true);
 	return 0;
 out:
-	handle_failed_inode(inode);
+	f2fs_handle_failed_inode(inode);
 	return err;
 }
 
@@ -578,6 +732,10 @@ static int __f2fs_tmpfile(struct inode *dir, struct dentry *dentry,
 	struct inode *inode;
 	int err;
 
+	err = dquot_initialize(dir);
+	if (err)
+		return err;
+
 	inode = f2fs_new_inode(dir, mode);
 	if (IS_ERR(inode))
 		return PTR_ERR(inode);
@@ -591,10 +749,8 @@ static int __f2fs_tmpfile(struct inode *dir, struct dentry *dentry,
 		inode->i_mapping->a_ops = &f2fs_dblock_aops;
 	}
 
-	f2fs_balance_fs(sbi, true);
-
 	f2fs_lock_op(sbi);
-	err = acquire_orphan_inode(sbi);
+	err = f2fs_acquire_orphan_inode(sbi);
 	if (err)
 		goto out;
 
@@ -606,8 +762,8 @@ static int __f2fs_tmpfile(struct inode *dir, struct dentry *dentry,
 	 * add this non-linked tmpfile to orphan list, in this way we could
 	 * remove all unused data of tmpfile after abnormal power-off.
 	 */
-	add_orphan_inode(inode);
-	alloc_nid_done(sbi, inode->i_ino);
+	f2fs_add_orphan_inode(inode);
+	f2fs_alloc_nid_done(sbi, inode->i_ino);
 
 	if (whiteout) {
 		f2fs_i_links_write(inode, false);
@@ -618,18 +774,25 @@ static int __f2fs_tmpfile(struct inode *dir, struct dentry *dentry,
 	/* link_count was changed by d_tmpfile as well. */
 	f2fs_unlock_op(sbi);
 	unlock_new_inode(inode);
+
+	f2fs_balance_fs(sbi, true);
 	return 0;
 
 release_out:
-	release_orphan_inode(sbi);
+	f2fs_release_orphan_inode(sbi);
 out:
-	handle_failed_inode(inode);
+	f2fs_handle_failed_inode(inode);
 	return err;
 }
 
 static int f2fs_tmpfile(struct inode *dir, struct dentry *dentry, umode_t mode)
 {
-	if (f2fs_encrypted_inode(dir)) {
+	struct f2fs_sb_info *sbi = F2FS_I_SB(dir);
+
+	if (unlikely(f2fs_cp_error(sbi)))
+		return -EIO;
+
+	if (f2fs_encrypted_inode(dir) || DUMMY_ENCRYPTION_ENABLED(sbi)) {
 		int err = fscrypt_get_encryption_info(dir);
 		if (err)
 			return err;
@@ -640,6 +803,9 @@ static int f2fs_tmpfile(struct inode *dir, struct dentry *dentry, umode_t mode)
 
 static int f2fs_create_whiteout(struct inode *dir, struct inode **whiteout)
 {
+	if (unlikely(f2fs_cp_error(F2FS_I_SB(dir))))
+		return -EIO;
+
 	return __f2fs_tmpfile(dir, NULL, S_IFCHR | WHITEOUT_MODE, whiteout);
 }
 
@@ -659,16 +825,26 @@ static int f2fs_rename(struct inode *old_dir, struct dentry *old_dentry,
 	bool is_old_inline = f2fs_has_inline_dentry(old_dir);
 	int err = -ENOENT;
 
-	if ((f2fs_encrypted_inode(old_dir) &&
-			!fscrypt_has_encryption_key(old_dir)) ||
-			(f2fs_encrypted_inode(new_dir) &&
-			!fscrypt_has_encryption_key(new_dir)))
-		return -ENOKEY;
+	if (unlikely(f2fs_cp_error(sbi)))
+		return -EIO;
 
-	if ((old_dir != new_dir) && f2fs_encrypted_inode(new_dir) &&
-			!fscrypt_has_permitted_context(new_dir, old_inode)) {
-		err = -EPERM;
+	if (is_inode_flag_set(new_dir, FI_PROJ_INHERIT) &&
+			(!projid_eq(F2FS_I(new_dir)->i_projid,
+			F2FS_I(old_dentry->d_inode)->i_projid)))
+		return -EXDEV;
+
+	err = dquot_initialize(old_dir);
+	if (err)
+		goto out;
+
+	err = dquot_initialize(new_dir);
+	if (err)
 		goto out;
+
+	if (new_inode) {
+		err = dquot_initialize(new_inode);
+		if (err)
+			goto out;
 	}
 
 	old_entry = f2fs_find_entry(old_dir, &old_dentry->d_name, &old_page);
@@ -712,17 +888,10 @@ static int f2fs_rename(struct inode *old_dir, struct dentry *old_dentry,
 
 		f2fs_lock_op(sbi);
 
-		err = acquire_orphan_inode(sbi);
+		err = f2fs_acquire_orphan_inode(sbi);
 		if (err)
 			goto put_out_dir;
 
-		err = update_dent_inode(old_inode, new_inode,
-						&new_dentry->d_name);
-		if (err) {
-			release_orphan_inode(sbi);
-			goto put_out_dir;
-		}
-
 		f2fs_set_link(new_dir, new_entry, new_page, old_inode);
 
 		new_inode->i_ctime = current_time(new_inode);
@@ -733,9 +902,9 @@ static int f2fs_rename(struct inode *old_dir, struct dentry *old_dentry,
 		up_write(&F2FS_I(new_inode)->i_sem);
 
 		if (!new_inode->i_nlink)
-			add_orphan_inode(new_inode);
+			f2fs_add_orphan_inode(new_inode);
 		else
-			release_orphan_inode(sbi);
+			f2fs_release_orphan_inode(sbi);
 	} else {
 		f2fs_balance_fs(sbi, true);
 
@@ -774,13 +943,14 @@ static int f2fs_rename(struct inode *old_dir, struct dentry *old_dentry,
 	}
 
 	down_write(&F2FS_I(old_inode)->i_sem);
-	file_lost_pino(old_inode);
-	if (new_inode && file_enc_name(new_inode))
-		file_set_enc_name(old_inode);
+	if (!old_dir_entry || whiteout)
+		file_lost_pino(old_inode);
+	else
+		F2FS_I(old_inode)->i_pino = new_dir->i_ino;
 	up_write(&F2FS_I(old_inode)->i_sem);
 
 	old_inode->i_ctime = current_time(old_inode);
-	f2fs_mark_inode_dirty_sync(old_inode);
+	f2fs_mark_inode_dirty_sync(old_inode, false);
 
 	f2fs_delete_entry(old_entry, old_page, old_dir, NULL);
 
@@ -795,15 +965,19 @@ static int f2fs_rename(struct inode *old_dir, struct dentry *old_dentry,
 	}
 
 	if (old_dir_entry) {
-		if (old_dir != new_dir && !whiteout) {
+		if (old_dir != new_dir && !whiteout)
 			f2fs_set_link(old_inode, old_dir_entry,
 						old_dir_page, new_dir);
-		} else {
-			f2fs_dentry_kunmap(old_inode, old_dir_page);
+		else
 			f2fs_put_page(old_dir_page, 0);
-		}
 		f2fs_i_links_write(old_dir, false);
 	}
+	if (F2FS_OPTION(sbi).fsync_mode == FSYNC_MODE_STRICT) {
+		f2fs_add_ino_entry(sbi, new_dir->i_ino, TRANS_DIR_INO);
+		if (S_ISDIR(old_inode->i_mode))
+			f2fs_add_ino_entry(sbi, old_inode->i_ino,
+							TRANS_DIR_INO);
+	}
 
 	f2fs_unlock_op(sbi);
 
@@ -813,20 +987,15 @@ static int f2fs_rename(struct inode *old_dir, struct dentry *old_dentry,
 
 put_out_dir:
 	f2fs_unlock_op(sbi);
-	if (new_page) {
-		f2fs_dentry_kunmap(new_dir, new_page);
+	if (new_page)
 		f2fs_put_page(new_page, 0);
-	}
 out_whiteout:
 	if (whiteout)
 		iput(whiteout);
 out_dir:
-	if (old_dir_entry) {
-		f2fs_dentry_kunmap(old_inode, old_dir_page);
+	if (old_dir_entry)
 		f2fs_put_page(old_dir_page, 0);
-	}
 out_old:
-	f2fs_dentry_kunmap(old_dir, old_page);
 	f2fs_put_page(old_page, 0);
 out:
 	return err;
@@ -845,17 +1014,24 @@ static int f2fs_cross_rename(struct inode *old_dir, struct dentry *old_dentry,
 	int old_nlink = 0, new_nlink = 0;
 	int err = -ENOENT;
 
-	if ((f2fs_encrypted_inode(old_dir) &&
-			!fscrypt_has_encryption_key(old_dir)) ||
-			(f2fs_encrypted_inode(new_dir) &&
-			!fscrypt_has_encryption_key(new_dir)))
-		return -ENOKEY;
+	if (unlikely(f2fs_cp_error(sbi)))
+		return -EIO;
+
+	if ((is_inode_flag_set(new_dir, FI_PROJ_INHERIT) &&
+			!projid_eq(F2FS_I(new_dir)->i_projid,
+			F2FS_I(old_dentry->d_inode)->i_projid)) ||
+	    (is_inode_flag_set(new_dir, FI_PROJ_INHERIT) &&
+			!projid_eq(F2FS_I(old_dir)->i_projid,
+			F2FS_I(new_dentry->d_inode)->i_projid)))
+		return -EXDEV;
+
+	err = dquot_initialize(old_dir);
+	if (err)
+		goto out;
 
-	if ((f2fs_encrypted_inode(old_dir) || f2fs_encrypted_inode(new_dir)) &&
-			(old_dir != new_dir) &&
-			(!fscrypt_has_permitted_context(new_dir, old_inode) ||
-			 !fscrypt_has_permitted_context(old_dir, new_inode)))
-		return -EPERM;
+	err = dquot_initialize(new_dir);
+	if (err)
+		goto out;
 
 	old_entry = f2fs_find_entry(old_dir, &old_dentry->d_name, &old_page);
 	if (!old_entry) {
@@ -904,8 +1080,8 @@ static int f2fs_cross_rename(struct inode *old_dir, struct dentry *old_dentry,
 		old_nlink = old_dir_entry ? -1 : 1;
 		new_nlink = -old_nlink;
 		err = -EMLINK;
-		if ((old_nlink > 0 && old_inode->i_nlink >= F2FS_LINK_MAX) ||
-			(new_nlink > 0 && new_inode->i_nlink >= F2FS_LINK_MAX))
+		if ((old_nlink > 0 && old_dir->i_nlink >= F2FS_LINK_MAX) ||
+			(new_nlink > 0 && new_dir->i_nlink >= F2FS_LINK_MAX))
 			goto out_new_dir;
 	}
 
@@ -913,18 +1089,6 @@ static int f2fs_cross_rename(struct inode *old_dir, struct dentry *old_dentry,
 
 	f2fs_lock_op(sbi);
 
-	err = update_dent_inode(old_inode, new_inode, &new_dentry->d_name);
-	if (err)
-		goto out_unlock;
-	if (file_enc_name(new_inode))
-		file_set_enc_name(old_inode);
-
-	err = update_dent_inode(new_inode, old_inode, &old_dentry->d_name);
-	if (err)
-		goto out_undo;
-	if (file_enc_name(old_inode))
-		file_set_enc_name(new_inode);
-
 	/* update ".." directory entry info of old dentry */
 	if (old_dir_entry)
 		f2fs_set_link(old_inode, old_dir_entry, old_dir_page, new_dir);
@@ -946,7 +1110,7 @@ static int f2fs_cross_rename(struct inode *old_dir, struct dentry *old_dentry,
 		f2fs_i_links_write(old_dir, old_nlink > 0);
 		up_write(&F2FS_I(old_dir)->i_sem);
 	}
-	f2fs_mark_inode_dirty_sync(old_dir);
+	f2fs_mark_inode_dirty_sync(old_dir, false);
 
 	/* update directory entry info of new dir inode */
 	f2fs_set_link(new_dir, new_entry, new_page, old_inode);
@@ -961,36 +1125,29 @@ static int f2fs_cross_rename(struct inode *old_dir, struct dentry *old_dentry,
 		f2fs_i_links_write(new_dir, new_nlink > 0);
 		up_write(&F2FS_I(new_dir)->i_sem);
 	}
-	f2fs_mark_inode_dirty_sync(new_dir);
+	f2fs_mark_inode_dirty_sync(new_dir, false);
+
+	if (F2FS_OPTION(sbi).fsync_mode == FSYNC_MODE_STRICT) {
+		f2fs_add_ino_entry(sbi, old_dir->i_ino, TRANS_DIR_INO);
+		f2fs_add_ino_entry(sbi, new_dir->i_ino, TRANS_DIR_INO);
+	}
 
 	f2fs_unlock_op(sbi);
 
 	if (IS_DIRSYNC(old_dir) || IS_DIRSYNC(new_dir))
 		f2fs_sync_fs(sbi->sb, 1);
 	return 0;
-out_undo:
-	/*
-	 * Still we may fail to recover name info of f2fs_inode here
-	 * Drop it, once its name is set as encrypted
-	 */
-	update_dent_inode(old_inode, old_inode, &old_dentry->d_name);
-out_unlock:
-	f2fs_unlock_op(sbi);
 out_new_dir:
 	if (new_dir_entry) {
-		f2fs_dentry_kunmap(new_inode, new_dir_page);
 		f2fs_put_page(new_dir_page, 0);
 	}
 out_old_dir:
 	if (old_dir_entry) {
-		f2fs_dentry_kunmap(old_inode, old_dir_page);
 		f2fs_put_page(old_dir_page, 0);
 	}
 out_new:
-	f2fs_dentry_kunmap(new_dir, new_page);
 	f2fs_put_page(new_page, 0);
 out_old:
-	f2fs_dentry_kunmap(old_dir, old_page);
 	f2fs_put_page(old_page, 0);
 out:
 	return err;
@@ -1000,9 +1157,16 @@ static int f2fs_rename2(struct inode *old_dir, struct dentry *old_dentry,
 			struct inode *new_dir, struct dentry *new_dentry,
 			unsigned int flags)
 {
+	int err;
+
 	if (flags & ~(RENAME_NOREPLACE | RENAME_EXCHANGE | RENAME_WHITEOUT))
 		return -EINVAL;
 
+	err = fscrypt_prepare_rename(old_dir, old_dentry, new_dir, new_dentry,
+				     flags);
+	if (err)
+		return err;
+
 	if (flags & RENAME_EXCHANGE) {
 		return f2fs_cross_rename(old_dir, old_dentry,
 					 new_dir, new_dentry);
@@ -1018,68 +1182,20 @@ static const char *f2fs_encrypted_get_link(struct dentry *dentry,
 					   struct inode *inode,
 					   struct delayed_call *done)
 {
-	struct page *cpage = NULL;
-	char *caddr, *paddr = NULL;
-	struct fscrypt_str cstr = FSTR_INIT(NULL, 0);
-	struct fscrypt_str pstr = FSTR_INIT(NULL, 0);
-	struct fscrypt_symlink_data *sd;
-	u32 max_size = inode->i_sb->s_blocksize;
-	int res;
+	struct page *page;
+	const char *target;
 
 	if (!dentry)
 		return ERR_PTR(-ECHILD);
 
-	res = fscrypt_get_encryption_info(inode);
-	if (res)
-		return ERR_PTR(res);
-
-	cpage = read_mapping_page(inode->i_mapping, 0, NULL);
-	if (IS_ERR(cpage))
-		return ERR_CAST(cpage);
-	caddr = page_address(cpage);
-
-	/* Symlink is encrypted */
-	sd = (struct fscrypt_symlink_data *)caddr;
-	cstr.name = sd->encrypted_path;
-	cstr.len = le16_to_cpu(sd->len);
-
-	/* this is broken symlink case */
-	if (unlikely(cstr.len == 0)) {
-		res = -ENOENT;
-		goto errout;
-	}
-
-	if ((cstr.len + sizeof(struct fscrypt_symlink_data) - 1) > max_size) {
-		/* Symlink data on the disk is corrupted */
-		res = -EIO;
-		goto errout;
-	}
-	res = fscrypt_fname_alloc_buffer(inode, cstr.len, &pstr);
-	if (res)
-		goto errout;
-
-	res = fscrypt_fname_disk_to_usr(inode, 0, 0, &cstr, &pstr);
-	if (res)
-		goto errout;
-
-	/* this is broken symlink case */
-	if (unlikely(pstr.name[0] == 0)) {
-		res = -ENOENT;
-		goto errout;
-	}
-
-	paddr = pstr.name;
-
-	/* Null-terminate the name */
-	paddr[pstr.len] = '\0';
+	page = read_mapping_page(inode->i_mapping, 0, NULL);
+	if (IS_ERR(page))
+		return ERR_CAST(page);
 
-	put_page(cpage);
-	set_delayed_call(done, kfree_link, paddr);
-	return paddr;
-errout:
-	fscrypt_fname_free_buffer(&pstr);
-	put_page(cpage);
-	return ERR_PTR(res);
+	target = fscrypt_get_symlink(inode, page_address(page),
+				     inode->i_sb->s_blocksize, done);
+	put_page(page);
+	return target;
 }
 
 const struct inode_operations f2fs_encrypted_symlink_inode_operations = {
diff --git a/fs/f2fs/node.c b/fs/f2fs/node.c
index 01177ec..874b0a1 100644
--- a/fs/f2fs/node.c
+++ b/fs/f2fs/node.c
@@ -19,16 +19,32 @@
 #include "f2fs.h"
 #include "node.h"
 #include "segment.h"
+#include "xattr.h"
 #include "trace.h"
 #include <trace/events/f2fs.h>
 
-#define on_build_free_nids(nmi) mutex_is_locked(&nm_i->build_lock)
+#define on_f2fs_build_free_nids(nmi) mutex_is_locked(&(nm_i)->build_lock)
 
 static struct kmem_cache *nat_entry_slab;
 static struct kmem_cache *free_nid_slab;
 static struct kmem_cache *nat_entry_set_slab;
 
-bool available_free_memory(struct f2fs_sb_info *sbi, int type)
+/*
+ * Check whether the given nid is within node id range.
+ */
+int f2fs_check_nid_range(struct f2fs_sb_info *sbi, nid_t nid)
+{
+	if (unlikely(nid < F2FS_ROOT_INO(sbi) || nid >= NM_I(sbi)->max_nid)) {
+		set_sbi_flag(sbi, SBI_NEED_FSCK);
+		f2fs_msg(sbi->sb, KERN_WARNING,
+				"%s: out-of-range nid=%x, run fsck to fix.",
+				__func__, nid);
+		return -EINVAL;
+	}
+	return 0;
+}
+
+bool f2fs_available_free_memory(struct f2fs_sb_info *sbi, int type)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct sysinfo val;
@@ -45,8 +61,8 @@ bool available_free_memory(struct f2fs_sb_info *sbi, int type)
 	 * give 25%, 25%, 50%, 50%, 50% memory for each components respectively
 	 */
 	if (type == FREE_NIDS) {
-		mem_size = (nm_i->fcnt * sizeof(struct free_nid)) >>
-							PAGE_SHIFT;
+		mem_size = (nm_i->nid_cnt[FREE_NID] *
+				sizeof(struct free_nid)) >> PAGE_SHIFT;
 		res = mem_size < ((avail_ram * nm_i->ram_thresh / 100) >> 2);
 	} else if (type == NAT_ENTRIES) {
 		mem_size = (nm_i->nat_cnt * sizeof(struct nat_entry)) >>
@@ -62,9 +78,10 @@ bool available_free_memory(struct f2fs_sb_info *sbi, int type)
 	} else if (type == INO_ENTRIES) {
 		int i;
 
-		for (i = 0; i <= UPDATE_INO; i++)
-			mem_size += (sbi->im[i].ino_num *
-				sizeof(struct ino_entry)) >> PAGE_SHIFT;
+		for (i = 0; i < MAX_INO_ENTRY; i++)
+			mem_size += sbi->im[i].ino_num *
+						sizeof(struct ino_entry);
+		mem_size >>= PAGE_SHIFT;
 		res = mem_size < ((avail_ram * nm_i->ram_thresh / 100) >> 1);
 	} else if (type == EXTENT_CACHE) {
 		mem_size = (atomic_read(&sbi->total_ext_tree) *
@@ -72,6 +89,10 @@ bool available_free_memory(struct f2fs_sb_info *sbi, int type)
 				atomic_read(&sbi->total_ext_node) *
 				sizeof(struct extent_node)) >> PAGE_SHIFT;
 		res = mem_size < ((avail_ram * nm_i->ram_thresh / 100) >> 1);
+	} else if (type == INMEM_PAGES) {
+		/* it allows 20% / total_ram for inmemory pages */
+		mem_size = get_pages(sbi, F2FS_INMEM_PAGES);
+		res = mem_size < (val.totalram / 5);
 	} else {
 		if (!sbi->sb->s_bdi->wb.dirty_exceeded)
 			return true;
@@ -81,18 +102,10 @@ bool available_free_memory(struct f2fs_sb_info *sbi, int type)
 
 static void clear_node_page_dirty(struct page *page)
 {
-	struct address_space *mapping = page->mapping;
-	unsigned int long flags;
-
 	if (PageDirty(page)) {
-		spin_lock_irqsave(&mapping->tree_lock, flags);
-		radix_tree_tag_clear(&mapping->page_tree,
-				page_index(page),
-				PAGECACHE_TAG_DIRTY);
-		spin_unlock_irqrestore(&mapping->tree_lock, flags);
-
+		f2fs_clear_radix_tree_dirty_tag(page);
 		clear_page_dirty_for_io(page);
-		dec_page_count(F2FS_M_SB(mapping), F2FS_DIRTY_NODES);
+		dec_page_count(F2FS_P_SB(page), F2FS_DIRTY_NODES);
 	}
 	ClearPageUptodate(page);
 }
@@ -100,7 +113,7 @@ static void clear_node_page_dirty(struct page *page)
 static struct page *get_current_nat_page(struct f2fs_sb_info *sbi, nid_t nid)
 {
 	pgoff_t index = current_nat_addr(sbi, nid);
-	return get_meta_page(sbi, index);
+	return f2fs_get_meta_page(sbi, index);
 }
 
 static struct page *get_next_nat_page(struct f2fs_sb_info *sbi, nid_t nid)
@@ -117,8 +130,8 @@ static struct page *get_next_nat_page(struct f2fs_sb_info *sbi, nid_t nid)
 	dst_off = next_nat_addr(sbi, src_off);
 
 	/* get current nat block page with lock */
-	src_page = get_meta_page(sbi, src_off);
-	dst_page = grab_meta_page(sbi, dst_off);
+	src_page = f2fs_get_meta_page(sbi, src_off);
+	dst_page = f2fs_grab_meta_page(sbi, dst_off);
 	f2fs_bug_on(sbi, PageDirty(src_page));
 
 	src_addr = page_address(src_page);
@@ -132,6 +145,42 @@ static struct page *get_next_nat_page(struct f2fs_sb_info *sbi, nid_t nid)
 	return dst_page;
 }
 
+static struct nat_entry *__alloc_nat_entry(nid_t nid, bool no_fail)
+{
+	struct nat_entry *new;
+
+	if (no_fail)
+		new = f2fs_kmem_cache_alloc(nat_entry_slab, GFP_F2FS_ZERO);
+	else
+		new = kmem_cache_alloc(nat_entry_slab, GFP_F2FS_ZERO);
+	if (new) {
+		nat_set_nid(new, nid);
+		nat_reset_flag(new);
+	}
+	return new;
+}
+
+static void __free_nat_entry(struct nat_entry *e)
+{
+	kmem_cache_free(nat_entry_slab, e);
+}
+
+/* must be locked by nat_tree_lock */
+static struct nat_entry *__init_nat_entry(struct f2fs_nm_info *nm_i,
+	struct nat_entry *ne, struct f2fs_nat_entry *raw_ne, bool no_fail)
+{
+	if (no_fail)
+		f2fs_radix_tree_insert(&nm_i->nat_root, nat_get_nid(ne), ne);
+	else if (radix_tree_insert(&nm_i->nat_root, nat_get_nid(ne), ne))
+		return NULL;
+
+	if (raw_ne)
+		node_info_from_raw_nat(&ne->ni, raw_ne);
+	list_add_tail(&ne->list, &nm_i->nat_entries);
+	nm_i->nat_cnt++;
+	return ne;
+}
+
 static struct nat_entry *__lookup_nat_cache(struct f2fs_nm_info *nm_i, nid_t n)
 {
 	return radix_tree_lookup(&nm_i->nat_root, n);
@@ -148,18 +197,15 @@ static void __del_from_nat_cache(struct f2fs_nm_info *nm_i, struct nat_entry *e)
 	list_del(&e->list);
 	radix_tree_delete(&nm_i->nat_root, nat_get_nid(e));
 	nm_i->nat_cnt--;
-	kmem_cache_free(nat_entry_slab, e);
+	__free_nat_entry(e);
 }
 
-static void __set_nat_cache_dirty(struct f2fs_nm_info *nm_i,
-						struct nat_entry *ne)
+static struct nat_entry_set *__grab_nat_entry_set(struct f2fs_nm_info *nm_i,
+							struct nat_entry *ne)
 {
 	nid_t set = NAT_BLOCK_OFFSET(ne->ni.nid);
 	struct nat_entry_set *head;
 
-	if (get_nat_flag(ne, IS_DIRTY))
-		return;
-
 	head = radix_tree_lookup(&nm_i->nat_set_root, set);
 	if (!head) {
 		head = f2fs_kmem_cache_alloc(nat_entry_set_slab, GFP_NOFS);
@@ -170,25 +216,48 @@ static void __set_nat_cache_dirty(struct f2fs_nm_info *nm_i,
 		head->entry_cnt = 0;
 		f2fs_radix_tree_insert(&nm_i->nat_set_root, set, head);
 	}
-	list_move_tail(&ne->list, &head->entry_list);
-	nm_i->dirty_nat_cnt++;
-	head->entry_cnt++;
-	set_nat_flag(ne, IS_DIRTY, true);
+	return head;
 }
 
-static void __clear_nat_cache_dirty(struct f2fs_nm_info *nm_i,
+static void __set_nat_cache_dirty(struct f2fs_nm_info *nm_i,
 						struct nat_entry *ne)
 {
-	nid_t set = NAT_BLOCK_OFFSET(ne->ni.nid);
 	struct nat_entry_set *head;
+	bool new_ne = nat_get_blkaddr(ne) == NEW_ADDR;
 
-	head = radix_tree_lookup(&nm_i->nat_set_root, set);
-	if (head) {
-		list_move_tail(&ne->list, &nm_i->nat_entries);
-		set_nat_flag(ne, IS_DIRTY, false);
-		head->entry_cnt--;
-		nm_i->dirty_nat_cnt--;
-	}
+	if (!new_ne)
+		head = __grab_nat_entry_set(nm_i, ne);
+
+	/*
+	 * update entry_cnt in below condition:
+	 * 1. update NEW_ADDR to valid block address;
+	 * 2. update old block address to new one;
+	 */
+	if (!new_ne && (get_nat_flag(ne, IS_PREALLOC) ||
+				!get_nat_flag(ne, IS_DIRTY)))
+		head->entry_cnt++;
+
+	set_nat_flag(ne, IS_PREALLOC, new_ne);
+
+	if (get_nat_flag(ne, IS_DIRTY))
+		goto refresh_list;
+
+	nm_i->dirty_nat_cnt++;
+	set_nat_flag(ne, IS_DIRTY, true);
+refresh_list:
+	if (new_ne)
+		list_del_init(&ne->list);
+	else
+		list_move_tail(&ne->list, &head->entry_list);
+}
+
+static void __clear_nat_cache_dirty(struct f2fs_nm_info *nm_i,
+		struct nat_entry_set *set, struct nat_entry *ne)
+{
+	list_move_tail(&ne->list, &nm_i->nat_entries);
+	set_nat_flag(ne, IS_DIRTY, false);
+	set->entry_cnt--;
+	nm_i->dirty_nat_cnt--;
 }
 
 static unsigned int __gang_lookup_nat_set(struct f2fs_nm_info *nm_i,
@@ -198,7 +267,7 @@ static unsigned int __gang_lookup_nat_set(struct f2fs_nm_info *nm_i,
 							start, nr);
 }
 
-int need_dentry_mark(struct f2fs_sb_info *sbi, nid_t nid)
+int f2fs_need_dentry_mark(struct f2fs_sb_info *sbi, nid_t nid)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct nat_entry *e;
@@ -215,7 +284,7 @@ int need_dentry_mark(struct f2fs_sb_info *sbi, nid_t nid)
 	return need;
 }
 
-bool is_checkpointed_node(struct f2fs_sb_info *sbi, nid_t nid)
+bool f2fs_is_checkpointed_node(struct f2fs_sb_info *sbi, nid_t nid)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct nat_entry *e;
@@ -229,7 +298,7 @@ bool is_checkpointed_node(struct f2fs_sb_info *sbi, nid_t nid)
 	return is_cp;
 }
 
-bool need_inode_block_update(struct f2fs_sb_info *sbi, nid_t ino)
+bool f2fs_need_inode_block_update(struct f2fs_sb_info *sbi, nid_t ino)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct nat_entry *e;
@@ -245,35 +314,29 @@ bool need_inode_block_update(struct f2fs_sb_info *sbi, nid_t ino)
 	return need_update;
 }
 
-static struct nat_entry *grab_nat_entry(struct f2fs_nm_info *nm_i, nid_t nid)
-{
-	struct nat_entry *new;
-
-	new = f2fs_kmem_cache_alloc(nat_entry_slab, GFP_NOFS);
-	f2fs_radix_tree_insert(&nm_i->nat_root, nid, new);
-	memset(new, 0, sizeof(struct nat_entry));
-	nat_set_nid(new, nid);
-	nat_reset_flag(new);
-	list_add_tail(&new->list, &nm_i->nat_entries);
-	nm_i->nat_cnt++;
-	return new;
-}
-
+/* must be locked by nat_tree_lock */
 static void cache_nat_entry(struct f2fs_sb_info *sbi, nid_t nid,
 						struct f2fs_nat_entry *ne)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
-	struct nat_entry *e;
+	struct nat_entry *new, *e;
+
+	new = __alloc_nat_entry(nid, false);
+	if (!new)
+		return;
 
+	down_write(&nm_i->nat_tree_lock);
 	e = __lookup_nat_cache(nm_i, nid);
-	if (!e) {
-		e = grab_nat_entry(nm_i, nid);
-		node_info_from_raw_nat(&e->ni, ne);
-	} else {
-		f2fs_bug_on(sbi, nat_get_ino(e) != ne->ino ||
-				nat_get_blkaddr(e) != ne->block_addr ||
+	if (!e)
+		e = __init_nat_entry(nm_i, new, ne, false);
+	else
+		f2fs_bug_on(sbi, nat_get_ino(e) != le32_to_cpu(ne->ino) ||
+				nat_get_blkaddr(e) !=
+					le32_to_cpu(ne->block_addr) ||
 				nat_get_version(e) != ne->version);
-	}
+	up_write(&nm_i->nat_tree_lock);
+	if (e != new)
+		__free_nat_entry(new);
 }
 
 static void set_node_addr(struct f2fs_sb_info *sbi, struct node_info *ni,
@@ -281,11 +344,12 @@ static void set_node_addr(struct f2fs_sb_info *sbi, struct node_info *ni,
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct nat_entry *e;
+	struct nat_entry *new = __alloc_nat_entry(ni->nid, true);
 
 	down_write(&nm_i->nat_tree_lock);
 	e = __lookup_nat_cache(nm_i, ni->nid);
 	if (!e) {
-		e = grab_nat_entry(nm_i, ni->nid);
+		e = __init_nat_entry(nm_i, new, NULL, true);
 		copy_node_info(&e->ni, ni);
 		f2fs_bug_on(sbi, ni->blk_addr == NEW_ADDR);
 	} else if (new_blkaddr == NEW_ADDR) {
@@ -297,6 +361,9 @@ static void set_node_addr(struct f2fs_sb_info *sbi, struct node_info *ni,
 		copy_node_info(&e->ni, ni);
 		f2fs_bug_on(sbi, ni->blk_addr != NULL_ADDR);
 	}
+	/* let's free early to reduce memory consumption */
+	if (e != new)
+		__free_nat_entry(new);
 
 	/* sanity check */
 	f2fs_bug_on(sbi, nat_get_blkaddr(e) != ni->blk_addr);
@@ -304,23 +371,18 @@ static void set_node_addr(struct f2fs_sb_info *sbi, struct node_info *ni,
 			new_blkaddr == NULL_ADDR);
 	f2fs_bug_on(sbi, nat_get_blkaddr(e) == NEW_ADDR &&
 			new_blkaddr == NEW_ADDR);
-	f2fs_bug_on(sbi, nat_get_blkaddr(e) != NEW_ADDR &&
-			nat_get_blkaddr(e) != NULL_ADDR &&
+	f2fs_bug_on(sbi, is_valid_blkaddr(nat_get_blkaddr(e)) &&
 			new_blkaddr == NEW_ADDR);
 
 	/* increment version no as node is removed */
 	if (nat_get_blkaddr(e) != NEW_ADDR && new_blkaddr == NULL_ADDR) {
 		unsigned char version = nat_get_version(e);
 		nat_set_version(e, inc_node_version(version));
-
-		/* in order to reuse the nid */
-		if (nm_i->next_scan_nid > ni->nid)
-			nm_i->next_scan_nid = ni->nid;
 	}
 
 	/* change address */
 	nat_set_blkaddr(e, new_blkaddr);
-	if (new_blkaddr == NEW_ADDR || new_blkaddr == NULL_ADDR)
+	if (!is_valid_blkaddr(new_blkaddr))
 		set_nat_flag(e, IS_CHECKPOINTED, false);
 	__set_nat_cache_dirty(nm_i, e);
 
@@ -335,7 +397,7 @@ static void set_node_addr(struct f2fs_sb_info *sbi, struct node_info *ni,
 	up_write(&nm_i->nat_tree_lock);
 }
 
-int try_to_free_nats(struct f2fs_sb_info *sbi, int nr_shrink)
+int f2fs_try_to_free_nats(struct f2fs_sb_info *sbi, int nr_shrink)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	int nr = nr_shrink;
@@ -357,7 +419,8 @@ int try_to_free_nats(struct f2fs_sb_info *sbi, int nr_shrink)
 /*
  * This function always returns success
  */
-void get_node_info(struct f2fs_sb_info *sbi, nid_t nid, struct node_info *ni)
+void f2fs_get_node_info(struct f2fs_sb_info *sbi, nid_t nid,
+						struct node_info *ni)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct curseg_info *curseg = CURSEG_I(sbi, CURSEG_HOT_DATA);
@@ -367,6 +430,7 @@ void get_node_info(struct f2fs_sb_info *sbi, nid_t nid, struct node_info *ni)
 	struct page *page = NULL;
 	struct f2fs_nat_entry ne;
 	struct nat_entry *e;
+	pgoff_t index;
 	int i;
 
 	ni->nid = nid;
@@ -386,33 +450,35 @@ void get_node_info(struct f2fs_sb_info *sbi, nid_t nid, struct node_info *ni)
 
 	/* Check current segment summary */
 	down_read(&curseg->journal_rwsem);
-	i = lookup_journal_in_cursum(journal, NAT_JOURNAL, nid, 0);
+	i = f2fs_lookup_journal_in_cursum(journal, NAT_JOURNAL, nid, 0);
 	if (i >= 0) {
 		ne = nat_in_journal(journal, i);
 		node_info_from_raw_nat(ni, &ne);
 	}
 	up_read(&curseg->journal_rwsem);
-	if (i >= 0)
+	if (i >= 0) {
+		up_read(&nm_i->nat_tree_lock);
 		goto cache;
+	}
 
 	/* Fill node_info from nat page */
-	page = get_current_nat_page(sbi, start_nid);
+	index = current_nat_addr(sbi, nid);
+	up_read(&nm_i->nat_tree_lock);
+
+	page = f2fs_get_meta_page(sbi, index);
 	nat_blk = (struct f2fs_nat_block *)page_address(page);
 	ne = nat_blk->entries[nid - start_nid];
 	node_info_from_raw_nat(ni, &ne);
 	f2fs_put_page(page, 1);
 cache:
-	up_read(&nm_i->nat_tree_lock);
 	/* cache nat entry */
-	down_write(&nm_i->nat_tree_lock);
 	cache_nat_entry(sbi, nid, &ne);
-	up_write(&nm_i->nat_tree_lock);
 }
 
 /*
  * readahead MAX_RA_NODE number of node pages.
  */
-static void ra_node_pages(struct page *parent, int start, int n)
+static void f2fs_ra_node_pages(struct page *parent, int start, int n)
 {
 	struct f2fs_sb_info *sbi = F2FS_P_SB(parent);
 	struct blk_plug plug;
@@ -426,13 +492,13 @@ static void ra_node_pages(struct page *parent, int start, int n)
 	end = min(end, NIDS_PER_BLOCK);
 	for (i = start; i < end; i++) {
 		nid = get_nid(parent, i, false);
-		ra_node_page(sbi, nid);
+		f2fs_ra_node_page(sbi, nid);
 	}
 
 	blk_finish_plug(&plug);
 }
 
-pgoff_t get_next_page_offset(struct dnode_of_data *dn, pgoff_t pgofs)
+pgoff_t f2fs_get_next_page_offset(struct dnode_of_data *dn, pgoff_t pgofs)
 {
 	const long direct_index = ADDRS_PER_INODE(dn->inode);
 	const long direct_blks = ADDRS_PER_BLOCK;
@@ -535,7 +601,7 @@ static int get_node_path(struct inode *inode, long block,
 		level = 3;
 		goto got;
 	} else {
-		BUG();
+		return -E2BIG;
 	}
 got:
 	return level;
@@ -547,7 +613,7 @@ static int get_node_path(struct inode *inode, long block,
  * f2fs_unlock_op() only if ro is not set RDONLY_NODE.
  * In the case of RDONLY_NODE, we don't need to care about mutex.
  */
-int get_dnode_of_data(struct dnode_of_data *dn, pgoff_t index, int mode)
+int f2fs_get_dnode_of_data(struct dnode_of_data *dn, pgoff_t index, int mode)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(dn->inode);
 	struct page *npage[4];
@@ -559,12 +625,14 @@ int get_dnode_of_data(struct dnode_of_data *dn, pgoff_t index, int mode)
 	int err = 0;
 
 	level = get_node_path(dn->inode, index, offset, noffset);
+	if (level < 0)
+		return level;
 
 	nids[0] = dn->inode->i_ino;
 	npage[0] = dn->inode_page;
 
 	if (!npage[0]) {
-		npage[0] = get_node_page(sbi, nids[0]);
+		npage[0] = f2fs_get_node_page(sbi, nids[0]);
 		if (IS_ERR(npage[0]))
 			return PTR_ERR(npage[0]);
 	}
@@ -588,24 +656,24 @@ int get_dnode_of_data(struct dnode_of_data *dn, pgoff_t index, int mode)
 
 		if (!nids[i] && mode == ALLOC_NODE) {
 			/* alloc new node */
-			if (!alloc_nid(sbi, &(nids[i]))) {
+			if (!f2fs_alloc_nid(sbi, &(nids[i]))) {
 				err = -ENOSPC;
 				goto release_pages;
 			}
 
 			dn->nid = nids[i];
-			npage[i] = new_node_page(dn, noffset[i], NULL);
+			npage[i] = f2fs_new_node_page(dn, noffset[i]);
 			if (IS_ERR(npage[i])) {
-				alloc_nid_failed(sbi, nids[i]);
+				f2fs_alloc_nid_failed(sbi, nids[i]);
 				err = PTR_ERR(npage[i]);
 				goto release_pages;
 			}
 
 			set_nid(parent, offset[i - 1], nids[i], i == 1);
-			alloc_nid_done(sbi, nids[i]);
+			f2fs_alloc_nid_done(sbi, nids[i]);
 			done = true;
 		} else if (mode == LOOKUP_NODE_RA && i == level && level > 1) {
-			npage[i] = get_node_page_ra(parent, offset[i - 1]);
+			npage[i] = f2fs_get_node_page_ra(parent, offset[i - 1]);
 			if (IS_ERR(npage[i])) {
 				err = PTR_ERR(npage[i]);
 				goto release_pages;
@@ -620,7 +688,7 @@ int get_dnode_of_data(struct dnode_of_data *dn, pgoff_t index, int mode)
 		}
 
 		if (!done) {
-			npage[i] = get_node_page(sbi, nids[i]);
+			npage[i] = f2fs_get_node_page(sbi, nids[i]);
 			if (IS_ERR(npage[i])) {
 				err = PTR_ERR(npage[i]);
 				f2fs_put_page(npage[0], 0);
@@ -635,7 +703,8 @@ int get_dnode_of_data(struct dnode_of_data *dn, pgoff_t index, int mode)
 	dn->nid = nids[level];
 	dn->ofs_in_node = offset[level];
 	dn->node_page = npage[level];
-	dn->data_blkaddr = datablock_addr(dn->node_page, dn->ofs_in_node);
+	dn->data_blkaddr = datablock_addr(dn->inode,
+				dn->node_page, dn->ofs_in_node);
 	return 0;
 
 release_pages:
@@ -658,24 +727,19 @@ static void truncate_node(struct dnode_of_data *dn)
 	struct f2fs_sb_info *sbi = F2FS_I_SB(dn->inode);
 	struct node_info ni;
 
-	get_node_info(sbi, dn->nid, &ni);
-	if (dn->inode->i_blocks == 0) {
-		f2fs_bug_on(sbi, ni.blk_addr != NULL_ADDR);
-		goto invalidate;
-	}
-	f2fs_bug_on(sbi, ni.blk_addr == NULL_ADDR);
+	f2fs_get_node_info(sbi, dn->nid, &ni);
 
 	/* Deallocate node address */
-	invalidate_blocks(sbi, ni.blk_addr);
-	dec_valid_node_count(sbi, dn->inode);
+	f2fs_invalidate_blocks(sbi, ni.blk_addr);
+	dec_valid_node_count(sbi, dn->inode, dn->nid == dn->inode->i_ino);
 	set_node_addr(sbi, &ni, NULL_ADDR, false);
 
 	if (dn->nid == dn->inode->i_ino) {
-		remove_orphan_inode(sbi, dn->nid);
+		f2fs_remove_orphan_inode(sbi, dn->nid);
 		dec_valid_inode_count(sbi);
 		f2fs_inode_synced(dn->inode);
 	}
-invalidate:
+
 	clear_node_page_dirty(dn->node_page);
 	set_sbi_flag(sbi, SBI_IS_DIRTY);
 
@@ -696,7 +760,7 @@ static int truncate_dnode(struct dnode_of_data *dn)
 		return 1;
 
 	/* get direct node */
-	page = get_node_page(F2FS_I_SB(dn->inode), dn->nid);
+	page = f2fs_get_node_page(F2FS_I_SB(dn->inode), dn->nid);
 	if (IS_ERR(page) && PTR_ERR(page) == -ENOENT)
 		return 1;
 	else if (IS_ERR(page))
@@ -705,7 +769,7 @@ static int truncate_dnode(struct dnode_of_data *dn)
 	/* Make dnode_of_data for parameter */
 	dn->node_page = page;
 	dn->ofs_in_node = 0;
-	truncate_data_blocks(dn);
+	f2fs_truncate_data_blocks(dn);
 	truncate_node(dn);
 	return 1;
 }
@@ -726,13 +790,13 @@ static int truncate_nodes(struct dnode_of_data *dn, unsigned int nofs,
 
 	trace_f2fs_truncate_nodes_enter(dn->inode, dn->nid, dn->data_blkaddr);
 
-	page = get_node_page(F2FS_I_SB(dn->inode), dn->nid);
+	page = f2fs_get_node_page(F2FS_I_SB(dn->inode), dn->nid);
 	if (IS_ERR(page)) {
 		trace_f2fs_truncate_nodes_exit(dn->inode, PTR_ERR(page));
 		return PTR_ERR(page);
 	}
 
-	ra_node_pages(page, ofs, NIDS_PER_BLOCK);
+	f2fs_ra_node_pages(page, ofs, NIDS_PER_BLOCK);
 
 	rn = F2FS_NODE(page);
 	if (depth < 3) {
@@ -802,7 +866,7 @@ static int truncate_partial_nodes(struct dnode_of_data *dn,
 	/* get indirect nodes in the path */
 	for (i = 0; i < idx + 1; i++) {
 		/* reference count'll be increased */
-		pages[i] = get_node_page(F2FS_I_SB(dn->inode), nid[i]);
+		pages[i] = f2fs_get_node_page(F2FS_I_SB(dn->inode), nid[i]);
 		if (IS_ERR(pages[i])) {
 			err = PTR_ERR(pages[i]);
 			idx = i - 1;
@@ -811,7 +875,7 @@ static int truncate_partial_nodes(struct dnode_of_data *dn,
 		nid[i + 1] = get_nid(pages[i], offset[i + 1], false);
 	}
 
-	ra_node_pages(pages[idx], offset[idx + 1], NIDS_PER_BLOCK);
+	f2fs_ra_node_pages(pages[idx], offset[idx + 1], NIDS_PER_BLOCK);
 
 	/* free direct nodes linked to a partial indirect node */
 	for (i = offset[idx + 1]; i < NIDS_PER_BLOCK; i++) {
@@ -848,7 +912,7 @@ static int truncate_partial_nodes(struct dnode_of_data *dn,
 /*
  * All the block addresses of data and nodes should be nullified.
  */
-int truncate_inode_blocks(struct inode *inode, pgoff_t from)
+int f2fs_truncate_inode_blocks(struct inode *inode, pgoff_t from)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	int err = 0, cont = 1;
@@ -861,8 +925,10 @@ int truncate_inode_blocks(struct inode *inode, pgoff_t from)
 	trace_f2fs_truncate_inode_blocks_enter(inode, from);
 
 	level = get_node_path(inode, from, offset, noffset);
+	if (level < 0)
+		return level;
 
-	page = get_node_page(sbi, inode->i_ino);
+	page = f2fs_get_node_page(sbi, inode->i_ino);
 	if (IS_ERR(page)) {
 		trace_f2fs_truncate_inode_blocks_exit(inode, PTR_ERR(page));
 		return PTR_ERR(page);
@@ -941,7 +1007,8 @@ int truncate_inode_blocks(struct inode *inode, pgoff_t from)
 	return err > 0 ? 0 : err;
 }
 
-int truncate_xattr_node(struct inode *inode, struct page *page)
+/* caller must lock inode page */
+int f2fs_truncate_xattr_node(struct inode *inode)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	nid_t nid = F2FS_I(inode)->i_xattr_nid;
@@ -951,19 +1018,13 @@ int truncate_xattr_node(struct inode *inode, struct page *page)
 	if (!nid)
 		return 0;
 
-	npage = get_node_page(sbi, nid);
+	npage = f2fs_get_node_page(sbi, nid);
 	if (IS_ERR(npage))
 		return PTR_ERR(npage);
 
 	f2fs_i_xnid_write(inode, 0);
 
-	/* need to do checkpoint during fsync */
-	F2FS_I(inode)->xattr_ver = cur_cp_version(F2FS_CKPT(sbi));
-
-	set_new_dnode(&dn, inode, page, npage, nid);
-
-	if (page)
-		dn.inode_page_locked = true;
+	set_new_dnode(&dn, inode, NULL, npage, nid);
 	truncate_node(&dn);
 	return 0;
 }
@@ -972,17 +1033,17 @@ int truncate_xattr_node(struct inode *inode, struct page *page)
  * Caller should grab and release a rwsem by calling f2fs_lock_op() and
  * f2fs_unlock_op().
  */
-int remove_inode_page(struct inode *inode)
+int f2fs_remove_inode_page(struct inode *inode)
 {
 	struct dnode_of_data dn;
 	int err;
 
 	set_new_dnode(&dn, inode, NULL, NULL, inode->i_ino);
-	err = get_dnode_of_data(&dn, 0, LOOKUP_NODE);
+	err = f2fs_get_dnode_of_data(&dn, 0, LOOKUP_NODE);
 	if (err)
 		return err;
 
-	err = truncate_xattr_node(inode, dn.inode_page);
+	err = f2fs_truncate_xattr_node(inode);
 	if (err) {
 		f2fs_put_dnode(&dn);
 		return err;
@@ -991,18 +1052,18 @@ int remove_inode_page(struct inode *inode)
 	/* remove potential inline_data blocks */
 	if (S_ISREG(inode->i_mode) || S_ISDIR(inode->i_mode) ||
 				S_ISLNK(inode->i_mode))
-		truncate_data_blocks_range(&dn, 1);
+		f2fs_truncate_data_blocks_range(&dn, 1);
 
 	/* 0 is possible, after f2fs_new_inode() has failed */
 	f2fs_bug_on(F2FS_I_SB(inode),
-			inode->i_blocks != 0 && inode->i_blocks != 1);
+			inode->i_blocks != 0 && inode->i_blocks != 8);
 
 	/* will put inode & node pages */
 	truncate_node(&dn);
 	return 0;
 }
 
-struct page *new_inode_page(struct inode *inode)
+struct page *f2fs_new_inode_page(struct inode *inode)
 {
 	struct dnode_of_data dn;
 
@@ -1010,14 +1071,13 @@ struct page *new_inode_page(struct inode *inode)
 	set_new_dnode(&dn, inode, NULL, NULL, inode->i_ino);
 
 	/* caller should f2fs_put_page(page, 1); */
-	return new_node_page(&dn, 0, NULL);
+	return f2fs_new_node_page(&dn, 0);
 }
 
-struct page *new_node_page(struct dnode_of_data *dn,
-				unsigned int ofs, struct page *ipage)
+struct page *f2fs_new_node_page(struct dnode_of_data *dn, unsigned int ofs)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(dn->inode);
-	struct node_info old_ni, new_ni;
+	struct node_info new_ni;
 	struct page *page;
 	int err;
 
@@ -1028,22 +1088,23 @@ struct page *new_node_page(struct dnode_of_data *dn,
 	if (!page)
 		return ERR_PTR(-ENOMEM);
 
-	if (unlikely(!inc_valid_node_count(sbi, dn->inode))) {
-		err = -ENOSPC;
+	if (unlikely((err = inc_valid_node_count(sbi, dn->inode, !ofs))))
 		goto fail;
-	}
-
-	get_node_info(sbi, dn->nid, &old_ni);
 
-	/* Reinitialize old_ni with new node page */
-	f2fs_bug_on(sbi, old_ni.blk_addr != NULL_ADDR);
-	new_ni = old_ni;
+#ifdef CONFIG_F2FS_CHECK_FS
+	f2fs_get_node_info(sbi, dn->nid, &new_ni);
+	f2fs_bug_on(sbi, new_ni.blk_addr != NULL_ADDR);
+#endif
+	new_ni.nid = dn->nid;
 	new_ni.ino = dn->inode->i_ino;
+	new_ni.blk_addr = NULL_ADDR;
+	new_ni.flag = 0;
+	new_ni.version = 0;
 	set_node_addr(sbi, &new_ni, NEW_ADDR, false);
 
 	f2fs_wait_on_page_writeback(page, NODE, true);
 	fill_node_footer(page, dn->nid, dn->inode->i_ino, ofs, true);
-	set_cold_node(dn->inode, page);
+	set_cold_node(page, S_ISDIR(dn->inode->i_mode));
 	if (!PageUptodate(page))
 		SetPageUptodate(page);
 	if (set_page_dirty(page))
@@ -1083,7 +1144,7 @@ static int read_node_page(struct page *page, int op_flags)
 	if (PageUptodate(page))
 		return LOCKED_PAGE;
 
-	get_node_info(sbi, page->index, &ni);
+	f2fs_get_node_info(sbi, page->index, &ni);
 
 	if (unlikely(ni.blk_addr == NULL_ADDR)) {
 		ClearPageUptodate(page);
@@ -1097,14 +1158,15 @@ static int read_node_page(struct page *page, int op_flags)
 /*
  * Readahead a node page
  */
-void ra_node_page(struct f2fs_sb_info *sbi, nid_t nid)
+void f2fs_ra_node_page(struct f2fs_sb_info *sbi, nid_t nid)
 {
 	struct page *apage;
 	int err;
 
 	if (!nid)
 		return;
-	f2fs_bug_on(sbi, check_nid_range(sbi, nid));
+	if (f2fs_check_nid_range(sbi, nid))
+		return;
 
 	rcu_read_lock();
 	apage = radix_tree_lookup(&NODE_MAPPING(sbi)->page_tree, nid);
@@ -1128,22 +1190,24 @@ static struct page *__get_node_page(struct f2fs_sb_info *sbi, pgoff_t nid,
 
 	if (!nid)
 		return ERR_PTR(-ENOENT);
-	f2fs_bug_on(sbi, check_nid_range(sbi, nid));
+	if (f2fs_check_nid_range(sbi, nid))
+		return ERR_PTR(-EINVAL);
 repeat:
 	page = f2fs_grab_cache_page(NODE_MAPPING(sbi), nid, false);
 	if (!page)
 		return ERR_PTR(-ENOMEM);
 
-	err = read_node_page(page, READ_SYNC);
+	err = read_node_page(page, 0);
 	if (err < 0) {
 		f2fs_put_page(page, 1);
 		return ERR_PTR(err);
 	} else if (err == LOCKED_PAGE) {
+		err = 0;
 		goto page_hit;
 	}
 
 	if (parent)
-		ra_node_pages(parent, start + 1, MAX_RA_NODE);
+		f2fs_ra_node_pages(parent, start + 1, MAX_RA_NODE);
 
 	lock_page(page);
 
@@ -1152,25 +1216,37 @@ static struct page *__get_node_page(struct f2fs_sb_info *sbi, pgoff_t nid,
 		goto repeat;
 	}
 
-	if (unlikely(!PageUptodate(page)))
+	if (unlikely(!PageUptodate(page))) {
+		err = -EIO;
+		goto out_err;
+	}
+
+	if (!f2fs_inode_chksum_verify(sbi, page)) {
+		err = -EBADMSG;
 		goto out_err;
+	}
 page_hit:
 	if(unlikely(nid != nid_of_node(page))) {
-		f2fs_bug_on(sbi, 1);
-		ClearPageUptodate(page);
+		f2fs_msg(sbi->sb, KERN_WARNING, "inconsistent node block, "
+			"nid:%lu, node_footer[nid:%u,ino:%u,ofs:%u,cpver:%llu,blkaddr:%u]",
+			nid, nid_of_node(page), ino_of_node(page),
+			ofs_of_node(page), cpver_of_node(page),
+			next_blkaddr_of_node(page));
+		err = -EINVAL;
 out_err:
+		ClearPageUptodate(page);
 		f2fs_put_page(page, 1);
-		return ERR_PTR(-EIO);
+		return ERR_PTR(err);
 	}
 	return page;
 }
 
-struct page *get_node_page(struct f2fs_sb_info *sbi, pgoff_t nid)
+struct page *f2fs_get_node_page(struct f2fs_sb_info *sbi, pgoff_t nid)
 {
 	return __get_node_page(sbi, nid, NULL, 0);
 }
 
-struct page *get_node_page_ra(struct page *parent, int start)
+struct page *f2fs_get_node_page_ra(struct page *parent, int start)
 {
 	struct f2fs_sb_info *sbi = F2FS_P_SB(parent);
 	nid_t nid = get_nid(parent, start, false);
@@ -1189,7 +1265,8 @@ static void flush_inline_data(struct f2fs_sb_info *sbi, nid_t ino)
 	if (!inode)
 		return;
 
-	page = pagecache_get_page(inode->i_mapping, 0, FGP_LOCK|FGP_NOWAIT, 0);
+	page = f2fs_pagecache_get_page(inode->i_mapping, 0,
+					FGP_LOCK|FGP_NOWAIT, 0);
 	if (!page)
 		goto iput_out;
 
@@ -1204,6 +1281,7 @@ static void flush_inline_data(struct f2fs_sb_info *sbi, nid_t ino)
 
 	ret = f2fs_write_inline_data(inode, page);
 	inode_dec_dirty_pages(inode);
+	f2fs_remove_dirty_inode(inode);
 	if (ret)
 		set_page_dirty(page);
 page_out:
@@ -1212,54 +1290,19 @@ static void flush_inline_data(struct f2fs_sb_info *sbi, nid_t ino)
 	iput(inode);
 }
 
-void move_node_page(struct page *node_page, int gc_type)
-{
-	if (gc_type == FG_GC) {
-		struct f2fs_sb_info *sbi = F2FS_P_SB(node_page);
-		struct writeback_control wbc = {
-			.sync_mode = WB_SYNC_ALL,
-			.nr_to_write = 1,
-			.for_reclaim = 0,
-		};
-
-		set_page_dirty(node_page);
-		f2fs_wait_on_page_writeback(node_page, NODE, true);
-
-		f2fs_bug_on(sbi, PageWriteback(node_page));
-		if (!clear_page_dirty_for_io(node_page))
-			goto out_page;
-
-		if (NODE_MAPPING(sbi)->a_ops->writepage(node_page, &wbc))
-			unlock_page(node_page);
-		goto release_page;
-	} else {
-		/* set page dirty and write it */
-		if (!PageWriteback(node_page))
-			set_page_dirty(node_page);
-	}
-out_page:
-	unlock_page(node_page);
-release_page:
-	f2fs_put_page(node_page, 0);
-}
-
 static struct page *last_fsync_dnode(struct f2fs_sb_info *sbi, nid_t ino)
 {
-	pgoff_t index, end;
+	pgoff_t index;
 	struct pagevec pvec;
 	struct page *last_page = NULL;
+	int nr_pages;
 
 	pagevec_init(&pvec, 0);
 	index = 0;
-	end = ULONG_MAX;
-
-	while (index <= end) {
-		int i, nr_pages;
-		nr_pages = pagevec_lookup_tag(&pvec, NODE_MAPPING(sbi), &index,
-				PAGECACHE_TAG_DIRTY,
-				min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1);
-		if (nr_pages == 0)
-			break;
+
+	while ((nr_pages = pagevec_lookup_tag(&pvec, NODE_MAPPING(sbi), &index,
+				PAGECACHE_TAG_DIRTY))) {
+		int i;
 
 		for (i = 0; i < nr_pages; i++) {
 			struct page *page = pvec.pages[i];
@@ -1303,16 +1346,139 @@ static struct page *last_fsync_dnode(struct f2fs_sb_info *sbi, nid_t ino)
 	return last_page;
 }
 
-int fsync_node_pages(struct f2fs_sb_info *sbi, struct inode *inode,
+static int __write_node_page(struct page *page, bool atomic, bool *submitted,
+				struct writeback_control *wbc, bool do_balance,
+				enum iostat_type io_type)
+{
+	struct f2fs_sb_info *sbi = F2FS_P_SB(page);
+	nid_t nid;
+	struct node_info ni;
+	struct f2fs_io_info fio = {
+		.sbi = sbi,
+		.ino = ino_of_node(page),
+		.type = NODE,
+		.op = REQ_OP_WRITE,
+		.op_flags = wbc_to_write_flags(wbc),
+		.page = page,
+		.encrypted_page = NULL,
+		.submitted = false,
+		.io_type = io_type,
+		.io_wbc = wbc,
+	};
+
+	trace_f2fs_writepage(page, NODE);
+
+	if (unlikely(f2fs_cp_error(sbi)))
+		goto redirty_out;
+
+	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
+		goto redirty_out;
+
+	/* get old block addr of this node page */
+	nid = nid_of_node(page);
+	f2fs_bug_on(sbi, page->index != nid);
+
+	if (wbc->for_reclaim) {
+		if (!down_read_trylock(&sbi->node_write))
+			goto redirty_out;
+	} else {
+		down_read(&sbi->node_write);
+	}
+
+	f2fs_get_node_info(sbi, nid, &ni);
+
+	/* This page is already truncated */
+	if (unlikely(ni.blk_addr == NULL_ADDR)) {
+		ClearPageUptodate(page);
+		dec_page_count(sbi, F2FS_DIRTY_NODES);
+		up_read(&sbi->node_write);
+		unlock_page(page);
+		return 0;
+	}
+
+	if (atomic && !test_opt(sbi, NOBARRIER))
+		fio.op_flags |= REQ_PREFLUSH | REQ_FUA;
+
+	set_page_writeback(page);
+	ClearPageError(page);
+	fio.old_blkaddr = ni.blk_addr;
+	f2fs_do_write_node_page(nid, &fio);
+	set_node_addr(sbi, &ni, fio.new_blkaddr, is_fsync_dnode(page));
+	dec_page_count(sbi, F2FS_DIRTY_NODES);
+	up_read(&sbi->node_write);
+
+	if (wbc->for_reclaim) {
+		f2fs_submit_merged_write_cond(sbi, page->mapping->host, 0,
+						page->index, NODE);
+		submitted = NULL;
+	}
+
+	unlock_page(page);
+
+	if (unlikely(f2fs_cp_error(sbi))) {
+		f2fs_submit_merged_write(sbi, NODE);
+		submitted = NULL;
+	}
+	if (submitted)
+		*submitted = fio.submitted;
+
+	if (do_balance)
+		f2fs_balance_fs(sbi, false);
+	return 0;
+
+redirty_out:
+	redirty_page_for_writepage(wbc, page);
+	return AOP_WRITEPAGE_ACTIVATE;
+}
+
+void f2fs_move_node_page(struct page *node_page, int gc_type)
+{
+	if (gc_type == FG_GC) {
+		struct writeback_control wbc = {
+			.sync_mode = WB_SYNC_ALL,
+			.nr_to_write = 1,
+			.for_reclaim = 0,
+		};
+
+		set_page_dirty(node_page);
+		f2fs_wait_on_page_writeback(node_page, NODE, true);
+
+		f2fs_bug_on(F2FS_P_SB(node_page), PageWriteback(node_page));
+		if (!clear_page_dirty_for_io(node_page))
+			goto out_page;
+
+		if (__write_node_page(node_page, false, NULL,
+					&wbc, false, FS_GC_NODE_IO))
+			unlock_page(node_page);
+		goto release_page;
+	} else {
+		/* set page dirty and write it */
+		if (!PageWriteback(node_page))
+			set_page_dirty(node_page);
+	}
+out_page:
+	unlock_page(node_page);
+release_page:
+	f2fs_put_page(node_page, 0);
+}
+
+static int f2fs_write_node_page(struct page *page,
+				struct writeback_control *wbc)
+{
+	return __write_node_page(page, false, NULL, wbc, false, FS_NODE_IO);
+}
+
+int f2fs_fsync_node_pages(struct f2fs_sb_info *sbi, struct inode *inode,
 			struct writeback_control *wbc, bool atomic)
 {
-	pgoff_t index, end;
+	pgoff_t index;
+	pgoff_t last_idx = ULONG_MAX;
 	struct pagevec pvec;
 	int ret = 0;
 	struct page *last_page = NULL;
 	bool marked = false;
 	nid_t ino = inode->i_ino;
-	int nwritten = 0;
+	int nr_pages;
 
 	if (atomic) {
 		last_page = last_fsync_dnode(sbi, ino);
@@ -1322,23 +1488,20 @@ int fsync_node_pages(struct f2fs_sb_info *sbi, struct inode *inode,
 retry:
 	pagevec_init(&pvec, 0);
 	index = 0;
-	end = ULONG_MAX;
-
-	while (index <= end) {
-		int i, nr_pages;
-		nr_pages = pagevec_lookup_tag(&pvec, NODE_MAPPING(sbi), &index,
-				PAGECACHE_TAG_DIRTY,
-				min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1);
-		if (nr_pages == 0)
-			break;
+
+	while ((nr_pages = pagevec_lookup_tag(&pvec, NODE_MAPPING(sbi), &index,
+				PAGECACHE_TAG_DIRTY))) {
+		int i;
 
 		for (i = 0; i < nr_pages; i++) {
 			struct page *page = pvec.pages[i];
+			bool submitted = false;
 
 			if (unlikely(f2fs_cp_error(sbi))) {
 				f2fs_put_page(last_page, 0);
 				pagevec_release(&pvec);
-				return -EIO;
+				ret = -EIO;
+				goto out;
 			}
 
 			if (!IS_DNODE(page) || !is_cold_node(page))
@@ -1364,14 +1527,17 @@ int fsync_node_pages(struct f2fs_sb_info *sbi, struct inode *inode,
 			f2fs_wait_on_page_writeback(page, NODE, true);
 			BUG_ON(PageWriteback(page));
 
+			set_fsync_mark(page, 0);
+			set_dentry_mark(page, 0);
+
 			if (!atomic || page == last_page) {
 				set_fsync_mark(page, 1);
 				if (IS_INODE(page)) {
 					if (is_inode_flag_set(inode,
 								FI_DIRTY_INODE))
-						update_inode(inode, page);
+						f2fs_update_inode(inode, page);
 					set_dentry_mark(page,
-						need_dentry_mark(sbi, ino));
+						f2fs_need_dentry_mark(sbi, ino));
 				}
 				/*  may be written by other thread */
 				if (!PageDirty(page))
@@ -1381,13 +1547,16 @@ int fsync_node_pages(struct f2fs_sb_info *sbi, struct inode *inode,
 			if (!clear_page_dirty_for_io(page))
 				goto continue_unlock;
 
-			ret = NODE_MAPPING(sbi)->a_ops->writepage(page, wbc);
+			ret = __write_node_page(page, atomic &&
+						page == last_page,
+						&submitted, wbc, true,
+						FS_NODE_IO);
 			if (ret) {
 				unlock_page(page);
 				f2fs_put_page(last_page, 0);
 				break;
-			} else {
-				nwritten++;
+			} else if (submitted) {
+				last_idx = page->index;
 			}
 
 			if (page == last_page) {
@@ -1407,45 +1576,46 @@ int fsync_node_pages(struct f2fs_sb_info *sbi, struct inode *inode,
 			"Retry to write fsync mark: ino=%u, idx=%lx",
 					ino, last_page->index);
 		lock_page(last_page);
+		f2fs_wait_on_page_writeback(last_page, NODE, true);
 		set_page_dirty(last_page);
 		unlock_page(last_page);
 		goto retry;
 	}
-
-	if (nwritten)
-		f2fs_submit_merged_bio_cond(sbi, NULL, NULL, ino, NODE, WRITE);
+out:
+	if (last_idx != ULONG_MAX)
+		f2fs_submit_merged_write_cond(sbi, NULL, ino, last_idx, NODE);
 	return ret ? -EIO: 0;
 }
 
-int sync_node_pages(struct f2fs_sb_info *sbi, struct writeback_control *wbc)
+int f2fs_sync_node_pages(struct f2fs_sb_info *sbi,
+				struct writeback_control *wbc,
+				bool do_balance, enum iostat_type io_type)
 {
-	pgoff_t index, end;
+	pgoff_t index;
 	struct pagevec pvec;
 	int step = 0;
 	int nwritten = 0;
 	int ret = 0;
+	int nr_pages, done = 0;
 
 	pagevec_init(&pvec, 0);
 
 next_step:
 	index = 0;
-	end = ULONG_MAX;
-
-	while (index <= end) {
-		int i, nr_pages;
-		nr_pages = pagevec_lookup_tag(&pvec, NODE_MAPPING(sbi), &index,
-				PAGECACHE_TAG_DIRTY,
-				min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1);
-		if (nr_pages == 0)
-			break;
+
+	while (!done && (nr_pages = pagevec_lookup_tag(&pvec,
+			NODE_MAPPING(sbi), &index, PAGECACHE_TAG_DIRTY))) {
+		int i;
 
 		for (i = 0; i < nr_pages; i++) {
 			struct page *page = pvec.pages[i];
+			bool submitted = false;
 
-			if (unlikely(f2fs_cp_error(sbi))) {
-				pagevec_release(&pvec);
-				ret = -EIO;
-				goto out;
+			/* give a priority to WB_SYNC threads */
+			if (atomic_read(&sbi->wb_sync_req[NODE]) &&
+					wbc->sync_mode == WB_SYNC_NONE) {
+				done = 1;
+				break;
 			}
 
 			/*
@@ -1494,9 +1664,11 @@ int sync_node_pages(struct f2fs_sb_info *sbi, struct writeback_control *wbc)
 			set_fsync_mark(page, 0);
 			set_dentry_mark(page, 0);
 
-			if (NODE_MAPPING(sbi)->a_ops->writepage(page, wbc))
+			ret = __write_node_page(page, false, &submitted,
+						wbc, do_balance, io_type);
+			if (ret)
 				unlock_page(page);
-			else
+			else if (submitted)
 				nwritten++;
 
 			if (--wbc->nr_to_write == 0)
@@ -1515,35 +1687,31 @@ int sync_node_pages(struct f2fs_sb_info *sbi, struct writeback_control *wbc)
 		step++;
 		goto next_step;
 	}
-out:
+
 	if (nwritten)
-		f2fs_submit_merged_bio(sbi, NODE, WRITE);
+		f2fs_submit_merged_write(sbi, NODE);
+
+	if (unlikely(f2fs_cp_error(sbi)))
+		return -EIO;
 	return ret;
 }
 
-int wait_on_node_pages_writeback(struct f2fs_sb_info *sbi, nid_t ino)
+int f2fs_wait_on_node_pages_writeback(struct f2fs_sb_info *sbi, nid_t ino)
 {
-	pgoff_t index = 0, end = ULONG_MAX;
+	pgoff_t index = 0;
 	struct pagevec pvec;
 	int ret2, ret = 0;
+	int nr_pages;
 
 	pagevec_init(&pvec, 0);
 
-	while (index <= end) {
-		int i, nr_pages;
-		nr_pages = pagevec_lookup_tag(&pvec, NODE_MAPPING(sbi), &index,
-				PAGECACHE_TAG_WRITEBACK,
-				min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1);
-		if (nr_pages == 0)
-			break;
+	while ((nr_pages = pagevec_lookup_tag(&pvec, NODE_MAPPING(sbi), &index,
+				PAGECACHE_TAG_WRITEBACK))) {
+		int i;
 
 		for (i = 0; i < nr_pages; i++) {
 			struct page *page = pvec.pages[i];
 
-			/* until radix tree lookup accepts end_index */
-			if (unlikely(page->index > end))
-				continue;
-
 			if (ino && ino_of_node(page) == ino) {
 				f2fs_wait_on_page_writeback(page, NODE, true);
 				if (TestClearPageError(page))
@@ -1560,79 +1728,16 @@ int wait_on_node_pages_writeback(struct f2fs_sb_info *sbi, nid_t ino)
 	return ret;
 }
 
-static int f2fs_write_node_page(struct page *page,
-				struct writeback_control *wbc)
-{
-	struct f2fs_sb_info *sbi = F2FS_P_SB(page);
-	nid_t nid;
-	struct node_info ni;
-	struct f2fs_io_info fio = {
-		.sbi = sbi,
-		.type = NODE,
-		.op = REQ_OP_WRITE,
-		.op_flags = (wbc->sync_mode == WB_SYNC_ALL) ? WRITE_SYNC : 0,
-		.page = page,
-		.encrypted_page = NULL,
-	};
-
-	trace_f2fs_writepage(page, NODE);
-
-	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
-		goto redirty_out;
-	if (unlikely(f2fs_cp_error(sbi)))
-		goto redirty_out;
-
-	/* get old block addr of this node page */
-	nid = nid_of_node(page);
-	f2fs_bug_on(sbi, page->index != nid);
-
-	if (wbc->for_reclaim) {
-		if (!down_read_trylock(&sbi->node_write))
-			goto redirty_out;
-	} else {
-		down_read(&sbi->node_write);
-	}
-
-	get_node_info(sbi, nid, &ni);
-
-	/* This page is already truncated */
-	if (unlikely(ni.blk_addr == NULL_ADDR)) {
-		ClearPageUptodate(page);
-		dec_page_count(sbi, F2FS_DIRTY_NODES);
-		up_read(&sbi->node_write);
-		unlock_page(page);
-		return 0;
-	}
-
-	set_page_writeback(page);
-	fio.old_blkaddr = ni.blk_addr;
-	write_node_page(nid, &fio);
-	set_node_addr(sbi, &ni, fio.new_blkaddr, is_fsync_dnode(page));
-	dec_page_count(sbi, F2FS_DIRTY_NODES);
-	up_read(&sbi->node_write);
-
-	if (wbc->for_reclaim)
-		f2fs_submit_merged_bio_cond(sbi, NULL, page, 0, NODE, WRITE);
-
-	unlock_page(page);
-
-	if (unlikely(f2fs_cp_error(sbi)))
-		f2fs_submit_merged_bio(sbi, NODE, WRITE);
-
-	return 0;
-
-redirty_out:
-	redirty_page_for_writepage(wbc, page);
-	return AOP_WRITEPAGE_ACTIVATE;
-}
-
-static int f2fs_write_node_pages(struct address_space *mapping,
-			    struct writeback_control *wbc)
+static int f2fs_write_node_pages(struct address_space *mapping,
+			    struct writeback_control *wbc)
 {
 	struct f2fs_sb_info *sbi = F2FS_M_SB(mapping);
 	struct blk_plug plug;
 	long diff;
 
+	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
+		goto skip_write;
+
 	/* balancing f2fs's metadata in background */
 	f2fs_balance_fs_bg(sbi);
 
@@ -1640,14 +1745,21 @@ static int f2fs_write_node_pages(struct address_space *mapping,
 	if (get_pages(sbi, F2FS_DIRTY_NODES) < nr_pages_to_skip(sbi, NODE))
 		goto skip_write;
 
+	if (wbc->sync_mode == WB_SYNC_ALL)
+		atomic_inc(&sbi->wb_sync_req[NODE]);
+	else if (atomic_read(&sbi->wb_sync_req[NODE]))
+		goto skip_write;
+
 	trace_f2fs_writepages(mapping->host, wbc, NODE);
 
 	diff = nr_pages_to_write(sbi, NODE, wbc);
-	wbc->sync_mode = WB_SYNC_NONE;
 	blk_start_plug(&plug);
-	sync_node_pages(sbi, wbc);
+	f2fs_sync_node_pages(sbi, wbc, true, FS_NODE_IO);
 	blk_finish_plug(&plug);
 	wbc->nr_to_write = max((long)0, wbc->nr_to_write - diff);
+
+	if (wbc->sync_mode == WB_SYNC_ALL)
+		atomic_dec(&sbi->wb_sync_req[NODE]);
 	return 0;
 
 skip_write:
@@ -1663,7 +1775,7 @@ static int f2fs_set_node_page_dirty(struct page *page)
 	if (!PageUptodate(page))
 		SetPageUptodate(page);
 	if (!PageDirty(page)) {
-		f2fs_set_page_dirty_nobuffers(page);
+		__set_page_dirty_nobuffers(page);
 		inc_page_count(F2FS_P_SB(page), F2FS_DIRTY_NODES);
 		SetPagePrivate(page);
 		f2fs_trace_pid(page);
@@ -1692,70 +1804,165 @@ static struct free_nid *__lookup_free_nid_list(struct f2fs_nm_info *nm_i,
 	return radix_tree_lookup(&nm_i->free_nid_root, n);
 }
 
-static void __del_from_free_nid_list(struct f2fs_nm_info *nm_i,
-						struct free_nid *i)
+static int __insert_free_nid(struct f2fs_sb_info *sbi,
+			struct free_nid *i, enum nid_state state)
 {
-	list_del(&i->list);
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
+
+	int err = radix_tree_insert(&nm_i->free_nid_root, i->nid, i);
+	if (err)
+		return err;
+
+	f2fs_bug_on(sbi, state != i->state);
+	nm_i->nid_cnt[state]++;
+	if (state == FREE_NID)
+		list_add_tail(&i->list, &nm_i->free_nid_list);
+	return 0;
+}
+
+static void __remove_free_nid(struct f2fs_sb_info *sbi,
+			struct free_nid *i, enum nid_state state)
+{
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
+
+	f2fs_bug_on(sbi, state != i->state);
+	nm_i->nid_cnt[state]--;
+	if (state == FREE_NID)
+		list_del(&i->list);
 	radix_tree_delete(&nm_i->free_nid_root, i->nid);
 }
 
-static int add_free_nid(struct f2fs_sb_info *sbi, nid_t nid, bool build)
+static void __move_free_nid(struct f2fs_sb_info *sbi, struct free_nid *i,
+			enum nid_state org_state, enum nid_state dst_state)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
-	struct free_nid *i;
-	struct nat_entry *ne;
 
-	if (!available_free_memory(sbi, FREE_NIDS))
-		return -1;
+	f2fs_bug_on(sbi, org_state != i->state);
+	i->state = dst_state;
+	nm_i->nid_cnt[org_state]--;
+	nm_i->nid_cnt[dst_state]++;
+
+	switch (dst_state) {
+	case PREALLOC_NID:
+		list_del(&i->list);
+		break;
+	case FREE_NID:
+		list_add_tail(&i->list, &nm_i->free_nid_list);
+		break;
+	default:
+		BUG_ON(1);
+	}
+}
+
+static void update_free_nid_bitmap(struct f2fs_sb_info *sbi, nid_t nid,
+							bool set, bool build)
+{
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
+	unsigned int nat_ofs = NAT_BLOCK_OFFSET(nid);
+	unsigned int nid_ofs = nid - START_NID(nid);
+
+	if (!test_bit_le(nat_ofs, nm_i->nat_block_bitmap))
+		return;
+
+	if (set) {
+		if (test_bit_le(nid_ofs, nm_i->free_nid_bitmap[nat_ofs]))
+			return;
+		__set_bit_le(nid_ofs, nm_i->free_nid_bitmap[nat_ofs]);
+		nm_i->free_nid_count[nat_ofs]++;
+	} else {
+		if (!test_bit_le(nid_ofs, nm_i->free_nid_bitmap[nat_ofs]))
+			return;
+		__clear_bit_le(nid_ofs, nm_i->free_nid_bitmap[nat_ofs]);
+		if (!build)
+			nm_i->free_nid_count[nat_ofs]--;
+	}
+}
+
+/* return if the nid is recognized as free */
+static bool add_free_nid(struct f2fs_sb_info *sbi,
+				nid_t nid, bool build, bool update)
+{
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
+	struct free_nid *i, *e;
+	struct nat_entry *ne;
+	int err = -EINVAL;
+	bool ret = false;
 
 	/* 0 nid should not be used */
 	if (unlikely(nid == 0))
-		return 0;
+		return false;
+
+	i = f2fs_kmem_cache_alloc(free_nid_slab, GFP_NOFS);
+	i->nid = nid;
+	i->state = FREE_NID;
+
+	radix_tree_preload(GFP_NOFS | __GFP_NOFAIL);
+
+	spin_lock(&nm_i->nid_list_lock);
 
 	if (build) {
-		/* do not add allocated nids */
+		/*
+		 *   Thread A             Thread B
+		 *  - f2fs_create
+		 *   - f2fs_new_inode
+		 *    - f2fs_alloc_nid
+		 *     - __insert_nid_to_list(PREALLOC_NID)
+		 *                     - f2fs_balance_fs_bg
+		 *                      - f2fs_build_free_nids
+		 *                       - __f2fs_build_free_nids
+		 *                        - scan_nat_page
+		 *                         - add_free_nid
+		 *                          - __lookup_nat_cache
+		 *  - f2fs_add_link
+		 *   - f2fs_init_inode_metadata
+		 *    - f2fs_new_inode_page
+		 *     - f2fs_new_node_page
+		 *      - set_node_addr
+		 *  - f2fs_alloc_nid_done
+		 *   - __remove_nid_from_list(PREALLOC_NID)
+		 *                         - __insert_nid_to_list(FREE_NID)
+		 */
 		ne = __lookup_nat_cache(nm_i, nid);
 		if (ne && (!get_nat_flag(ne, IS_CHECKPOINTED) ||
 				nat_get_blkaddr(ne) != NULL_ADDR))
-			return 0;
-	}
+			goto err_out;
 
-	i = f2fs_kmem_cache_alloc(free_nid_slab, GFP_NOFS);
-	i->nid = nid;
-	i->state = NID_NEW;
-
-	if (radix_tree_preload(GFP_NOFS)) {
-		kmem_cache_free(free_nid_slab, i);
-		return 0;
+		e = __lookup_free_nid_list(nm_i, nid);
+		if (e) {
+			if (e->state == FREE_NID)
+				ret = true;
+			goto err_out;
+		}
 	}
-
-	spin_lock(&nm_i->free_nid_list_lock);
-	if (radix_tree_insert(&nm_i->free_nid_root, i->nid, i)) {
-		spin_unlock(&nm_i->free_nid_list_lock);
-		radix_tree_preload_end();
-		kmem_cache_free(free_nid_slab, i);
-		return 0;
+	ret = true;
+	err = __insert_free_nid(sbi, i, FREE_NID);
+err_out:
+	if (update) {
+		update_free_nid_bitmap(sbi, nid, ret, build);
+		if (!build)
+			nm_i->available_nids++;
 	}
-	list_add_tail(&i->list, &nm_i->free_nid_list);
-	nm_i->fcnt++;
-	spin_unlock(&nm_i->free_nid_list_lock);
+	spin_unlock(&nm_i->nid_list_lock);
 	radix_tree_preload_end();
-	return 1;
+
+	if (err)
+		kmem_cache_free(free_nid_slab, i);
+	return ret;
 }
 
-static void remove_free_nid(struct f2fs_nm_info *nm_i, nid_t nid)
+static void remove_free_nid(struct f2fs_sb_info *sbi, nid_t nid)
 {
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct free_nid *i;
 	bool need_free = false;
 
-	spin_lock(&nm_i->free_nid_list_lock);
+	spin_lock(&nm_i->nid_list_lock);
 	i = __lookup_free_nid_list(nm_i, nid);
-	if (i && i->state == NID_NEW) {
-		__del_from_free_nid_list(nm_i, i);
-		nm_i->fcnt--;
+	if (i && i->state == FREE_NID) {
+		__remove_free_nid(sbi, i, FREE_NID);
 		need_free = true;
 	}
-	spin_unlock(&nm_i->free_nid_list_lock);
+	spin_unlock(&nm_i->nid_list_lock);
 
 	if (need_free)
 		kmem_cache_free(free_nid_slab, i);
@@ -1767,47 +1974,121 @@ static void scan_nat_page(struct f2fs_sb_info *sbi,
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct f2fs_nat_block *nat_blk = page_address(nat_page);
 	block_t blk_addr;
+	unsigned int nat_ofs = NAT_BLOCK_OFFSET(start_nid);
 	int i;
 
+	__set_bit_le(nat_ofs, nm_i->nat_block_bitmap);
+
 	i = start_nid % NAT_ENTRY_PER_BLOCK;
 
 	for (; i < NAT_ENTRY_PER_BLOCK; i++, start_nid++) {
-
 		if (unlikely(start_nid >= nm_i->max_nid))
 			break;
 
 		blk_addr = le32_to_cpu(nat_blk->entries[i].block_addr);
 		f2fs_bug_on(sbi, blk_addr == NEW_ADDR);
 		if (blk_addr == NULL_ADDR) {
-			if (add_free_nid(sbi, start_nid, true) < 0)
-				break;
+			add_free_nid(sbi, start_nid, true, true);
+		} else {
+			spin_lock(&NM_I(sbi)->nid_list_lock);
+			update_free_nid_bitmap(sbi, start_nid, false, true);
+			spin_unlock(&NM_I(sbi)->nid_list_lock);
 		}
 	}
 }
 
-void build_free_nids(struct f2fs_sb_info *sbi)
+static void scan_curseg_cache(struct f2fs_sb_info *sbi)
 {
-	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct curseg_info *curseg = CURSEG_I(sbi, CURSEG_HOT_DATA);
 	struct f2fs_journal *journal = curseg->journal;
+	int i;
+
+	down_read(&curseg->journal_rwsem);
+	for (i = 0; i < nats_in_cursum(journal); i++) {
+		block_t addr;
+		nid_t nid;
+
+		addr = le32_to_cpu(nat_in_journal(journal, i).block_addr);
+		nid = le32_to_cpu(nid_in_journal(journal, i));
+		if (addr == NULL_ADDR)
+			add_free_nid(sbi, nid, true, false);
+		else
+			remove_free_nid(sbi, nid);
+	}
+	up_read(&curseg->journal_rwsem);
+}
+
+static void scan_free_nid_bits(struct f2fs_sb_info *sbi)
+{
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
+	unsigned int i, idx;
+	nid_t nid;
+
+	down_read(&nm_i->nat_tree_lock);
+
+	for (i = 0; i < nm_i->nat_blocks; i++) {
+		if (!test_bit_le(i, nm_i->nat_block_bitmap))
+			continue;
+		if (!nm_i->free_nid_count[i])
+			continue;
+		for (idx = 0; idx < NAT_ENTRY_PER_BLOCK; idx++) {
+			idx = find_next_bit_le(nm_i->free_nid_bitmap[i],
+						NAT_ENTRY_PER_BLOCK, idx);
+			if (idx >= NAT_ENTRY_PER_BLOCK)
+				break;
+
+			nid = i * NAT_ENTRY_PER_BLOCK + idx;
+			add_free_nid(sbi, nid, true, false);
+
+			if (nm_i->nid_cnt[FREE_NID] >= MAX_FREE_NIDS)
+				goto out;
+		}
+	}
+out:
+	scan_curseg_cache(sbi);
+
+	up_read(&nm_i->nat_tree_lock);
+}
+
+static void __f2fs_build_free_nids(struct f2fs_sb_info *sbi,
+						bool sync, bool mount)
+{
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	int i = 0;
 	nid_t nid = nm_i->next_scan_nid;
 
+	if (unlikely(nid >= nm_i->max_nid))
+		nid = 0;
+
 	/* Enough entries */
-	if (nm_i->fcnt >= NAT_ENTRY_PER_BLOCK)
+	if (nm_i->nid_cnt[FREE_NID] >= NAT_ENTRY_PER_BLOCK)
 		return;
 
+	if (!sync && !f2fs_available_free_memory(sbi, FREE_NIDS))
+		return;
+
+	if (!mount) {
+		/* try to find free nids in free_nid_bitmap */
+		scan_free_nid_bits(sbi);
+
+		if (nm_i->nid_cnt[FREE_NID] >= NAT_ENTRY_PER_BLOCK)
+			return;
+	}
+
 	/* readahead nat pages to be scanned */
-	ra_meta_pages(sbi, NAT_BLOCK_OFFSET(nid), FREE_NID_PAGES,
+	f2fs_ra_meta_pages(sbi, NAT_BLOCK_OFFSET(nid), FREE_NID_PAGES,
 							META_NAT, true);
 
 	down_read(&nm_i->nat_tree_lock);
 
 	while (1) {
-		struct page *page = get_current_nat_page(sbi, nid);
+		if (!test_bit_le(NAT_BLOCK_OFFSET(nid),
+						nm_i->nat_block_bitmap)) {
+			struct page *page = get_current_nat_page(sbi, nid);
 
-		scan_nat_page(sbi, page, nid);
-		f2fs_put_page(page, 1);
+			scan_nat_page(sbi, page, nid);
+			f2fs_put_page(page, 1);
+		}
 
 		nid += (NAT_ENTRY_PER_BLOCK - (nid % NAT_ENTRY_PER_BLOCK));
 		if (unlikely(nid >= nm_i->max_nid))
@@ -1821,87 +2102,87 @@ void build_free_nids(struct f2fs_sb_info *sbi)
 	nm_i->next_scan_nid = nid;
 
 	/* find free nids from current sum_pages */
-	down_read(&curseg->journal_rwsem);
-	for (i = 0; i < nats_in_cursum(journal); i++) {
-		block_t addr;
+	scan_curseg_cache(sbi);
 
-		addr = le32_to_cpu(nat_in_journal(journal, i).block_addr);
-		nid = le32_to_cpu(nid_in_journal(journal, i));
-		if (addr == NULL_ADDR)
-			add_free_nid(sbi, nid, true);
-		else
-			remove_free_nid(nm_i, nid);
-	}
-	up_read(&curseg->journal_rwsem);
 	up_read(&nm_i->nat_tree_lock);
 
-	ra_meta_pages(sbi, NAT_BLOCK_OFFSET(nm_i->next_scan_nid),
+	f2fs_ra_meta_pages(sbi, NAT_BLOCK_OFFSET(nm_i->next_scan_nid),
 					nm_i->ra_nid_pages, META_NAT, false);
 }
 
+void f2fs_build_free_nids(struct f2fs_sb_info *sbi, bool sync, bool mount)
+{
+	mutex_lock(&NM_I(sbi)->build_lock);
+	__f2fs_build_free_nids(sbi, sync, mount);
+	mutex_unlock(&NM_I(sbi)->build_lock);
+}
+
 /*
  * If this function returns success, caller can obtain a new nid
  * from second parameter of this function.
  * The returned nid could be used ino as well as nid when inode is created.
  */
-bool alloc_nid(struct f2fs_sb_info *sbi, nid_t *nid)
+bool f2fs_alloc_nid(struct f2fs_sb_info *sbi, nid_t *nid)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct free_nid *i = NULL;
 retry:
 #ifdef CONFIG_F2FS_FAULT_INJECTION
-	if (time_to_inject(sbi, FAULT_ALLOC_NID))
+	if (time_to_inject(sbi, FAULT_ALLOC_NID)) {
+		f2fs_show_injection_info(FAULT_ALLOC_NID);
 		return false;
+	}
 #endif
-	if (unlikely(sbi->total_valid_node_count + 1 > nm_i->available_nids))
-		return false;
+	spin_lock(&nm_i->nid_list_lock);
 
-	spin_lock(&nm_i->free_nid_list_lock);
+	if (unlikely(nm_i->available_nids == 0)) {
+		spin_unlock(&nm_i->nid_list_lock);
+		return false;
+	}
 
-	/* We should not use stale free nids created by build_free_nids */
-	if (nm_i->fcnt && !on_build_free_nids(nm_i)) {
+	/* We should not use stale free nids created by f2fs_build_free_nids */
+	if (nm_i->nid_cnt[FREE_NID] && !on_f2fs_build_free_nids(nm_i)) {
 		f2fs_bug_on(sbi, list_empty(&nm_i->free_nid_list));
-		list_for_each_entry(i, &nm_i->free_nid_list, list)
-			if (i->state == NID_NEW)
-				break;
-
-		f2fs_bug_on(sbi, i->state != NID_NEW);
+		i = list_first_entry(&nm_i->free_nid_list,
+					struct free_nid, list);
 		*nid = i->nid;
-		i->state = NID_ALLOC;
-		nm_i->fcnt--;
-		spin_unlock(&nm_i->free_nid_list_lock);
+
+		__move_free_nid(sbi, i, FREE_NID, PREALLOC_NID);
+		nm_i->available_nids--;
+
+		update_free_nid_bitmap(sbi, *nid, false, false);
+
+		spin_unlock(&nm_i->nid_list_lock);
 		return true;
 	}
-	spin_unlock(&nm_i->free_nid_list_lock);
+	spin_unlock(&nm_i->nid_list_lock);
 
 	/* Let's scan nat pages and its caches to get free nids */
-	mutex_lock(&nm_i->build_lock);
-	build_free_nids(sbi);
-	mutex_unlock(&nm_i->build_lock);
+	f2fs_build_free_nids(sbi, true, false);
 	goto retry;
 }
 
 /*
- * alloc_nid() should be called prior to this function.
+ * f2fs_alloc_nid() should be called prior to this function.
  */
-void alloc_nid_done(struct f2fs_sb_info *sbi, nid_t nid)
+void f2fs_alloc_nid_done(struct f2fs_sb_info *sbi, nid_t nid)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct free_nid *i;
 
-	spin_lock(&nm_i->free_nid_list_lock);
+	spin_lock(&nm_i->nid_list_lock);
 	i = __lookup_free_nid_list(nm_i, nid);
-	f2fs_bug_on(sbi, !i || i->state != NID_ALLOC);
-	__del_from_free_nid_list(nm_i, i);
-	spin_unlock(&nm_i->free_nid_list_lock);
+	f2fs_bug_on(sbi, !i);
+	__remove_free_nid(sbi, i, PREALLOC_NID);
+	spin_unlock(&nm_i->nid_list_lock);
 
 	kmem_cache_free(free_nid_slab, i);
 }
 
 /*
- * alloc_nid() should be called prior to this function.
+ * f2fs_alloc_nid() should be called prior to this function.
  */
-void alloc_nid_failed(struct f2fs_sb_info *sbi, nid_t nid)
+void f2fs_alloc_nid_failed(struct f2fs_sb_info *sbi, nid_t nid)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct free_nid *i;
@@ -1910,120 +2191,134 @@ void alloc_nid_failed(struct f2fs_sb_info *sbi, nid_t nid)
 	if (!nid)
 		return;
 
-	spin_lock(&nm_i->free_nid_list_lock);
+	spin_lock(&nm_i->nid_list_lock);
 	i = __lookup_free_nid_list(nm_i, nid);
-	f2fs_bug_on(sbi, !i || i->state != NID_ALLOC);
-	if (!available_free_memory(sbi, FREE_NIDS)) {
-		__del_from_free_nid_list(nm_i, i);
+	f2fs_bug_on(sbi, !i);
+
+	if (!f2fs_available_free_memory(sbi, FREE_NIDS)) {
+		__remove_free_nid(sbi, i, PREALLOC_NID);
 		need_free = true;
 	} else {
-		i->state = NID_NEW;
-		nm_i->fcnt++;
+		__move_free_nid(sbi, i, PREALLOC_NID, FREE_NID);
 	}
-	spin_unlock(&nm_i->free_nid_list_lock);
+
+	nm_i->available_nids++;
+
+	update_free_nid_bitmap(sbi, nid, true, false);
+
+	spin_unlock(&nm_i->nid_list_lock);
 
 	if (need_free)
 		kmem_cache_free(free_nid_slab, i);
 }
 
-int try_to_free_nids(struct f2fs_sb_info *sbi, int nr_shrink)
+int f2fs_try_to_free_nids(struct f2fs_sb_info *sbi, int nr_shrink)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct free_nid *i, *next;
 	int nr = nr_shrink;
 
-	if (nm_i->fcnt <= MAX_FREE_NIDS)
+	if (nm_i->nid_cnt[FREE_NID] <= MAX_FREE_NIDS)
 		return 0;
 
 	if (!mutex_trylock(&nm_i->build_lock))
 		return 0;
 
-	spin_lock(&nm_i->free_nid_list_lock);
+	spin_lock(&nm_i->nid_list_lock);
 	list_for_each_entry_safe(i, next, &nm_i->free_nid_list, list) {
-		if (nr_shrink <= 0 || nm_i->fcnt <= MAX_FREE_NIDS)
+		if (nr_shrink <= 0 ||
+				nm_i->nid_cnt[FREE_NID] <= MAX_FREE_NIDS)
 			break;
-		if (i->state == NID_ALLOC)
-			continue;
-		__del_from_free_nid_list(nm_i, i);
+
+		__remove_free_nid(sbi, i, FREE_NID);
 		kmem_cache_free(free_nid_slab, i);
-		nm_i->fcnt--;
 		nr_shrink--;
 	}
-	spin_unlock(&nm_i->free_nid_list_lock);
+	spin_unlock(&nm_i->nid_list_lock);
 	mutex_unlock(&nm_i->build_lock);
 
 	return nr - nr_shrink;
 }
 
-void recover_inline_xattr(struct inode *inode, struct page *page)
+void f2fs_recover_inline_xattr(struct inode *inode, struct page *page)
 {
 	void *src_addr, *dst_addr;
 	size_t inline_size;
 	struct page *ipage;
 	struct f2fs_inode *ri;
 
-	ipage = get_node_page(F2FS_I_SB(inode), inode->i_ino);
+	ipage = f2fs_get_node_page(F2FS_I_SB(inode), inode->i_ino);
 	f2fs_bug_on(F2FS_I_SB(inode), IS_ERR(ipage));
 
 	ri = F2FS_INODE(page);
-	if (!(ri->i_inline & F2FS_INLINE_XATTR)) {
+	if (ri->i_inline & F2FS_INLINE_XATTR) {
+		set_inode_flag(inode, FI_INLINE_XATTR);
+	} else {
 		clear_inode_flag(inode, FI_INLINE_XATTR);
 		goto update_inode;
 	}
 
-	dst_addr = inline_xattr_addr(ipage);
-	src_addr = inline_xattr_addr(page);
+	dst_addr = inline_xattr_addr(inode, ipage);
+	src_addr = inline_xattr_addr(inode, page);
 	inline_size = inline_xattr_size(inode);
 
 	f2fs_wait_on_page_writeback(ipage, NODE, true);
 	memcpy(dst_addr, src_addr, inline_size);
 update_inode:
-	update_inode(inode, ipage);
+	f2fs_update_inode(inode, ipage);
 	f2fs_put_page(ipage, 1);
 }
 
-void recover_xattr_data(struct inode *inode, struct page *page, block_t blkaddr)
+int f2fs_recover_xattr_data(struct inode *inode, struct page *page)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	nid_t prev_xnid = F2FS_I(inode)->i_xattr_nid;
-	nid_t new_xnid = nid_of_node(page);
+	nid_t new_xnid;
+	struct dnode_of_data dn;
 	struct node_info ni;
+	struct page *xpage;
 
-	/* 1: invalidate the previous xattr nid */
 	if (!prev_xnid)
 		goto recover_xnid;
 
-	/* Deallocate node address */
-	get_node_info(sbi, prev_xnid, &ni);
-	f2fs_bug_on(sbi, ni.blk_addr == NULL_ADDR);
-	invalidate_blocks(sbi, ni.blk_addr);
-	dec_valid_node_count(sbi, inode);
+	/* 1: invalidate the previous xattr nid */
+	f2fs_get_node_info(sbi, prev_xnid, &ni);
+	f2fs_invalidate_blocks(sbi, ni.blk_addr);
+	dec_valid_node_count(sbi, inode, false);
 	set_node_addr(sbi, &ni, NULL_ADDR, false);
 
 recover_xnid:
-	/* 2: allocate new xattr nid */
-	if (unlikely(!inc_valid_node_count(sbi, inode)))
-		f2fs_bug_on(sbi, 1);
+	/* 2: update xattr nid in inode */
+	if (!f2fs_alloc_nid(sbi, &new_xnid))
+		return -ENOSPC;
+
+	set_new_dnode(&dn, inode, NULL, NULL, new_xnid);
+	xpage = f2fs_new_node_page(&dn, XATTR_NODE_OFFSET);
+	if (IS_ERR(xpage)) {
+		f2fs_alloc_nid_failed(sbi, new_xnid);
+		return PTR_ERR(xpage);
+	}
 
-	remove_free_nid(NM_I(sbi), new_xnid);
-	get_node_info(sbi, new_xnid, &ni);
-	ni.ino = inode->i_ino;
-	set_node_addr(sbi, &ni, NEW_ADDR, false);
-	f2fs_i_xnid_write(inode, new_xnid);
+	f2fs_alloc_nid_done(sbi, new_xnid);
+	f2fs_update_inode_page(inode);
 
-	/* 3: update xattr blkaddr */
-	refresh_sit_entry(sbi, NEW_ADDR, blkaddr);
-	set_node_addr(sbi, &ni, blkaddr, false);
+	/* 3: update and set xattr node page dirty */
+	memcpy(F2FS_NODE(xpage), F2FS_NODE(page), VALID_XATTR_BLOCK_SIZE);
+
+	set_page_dirty(xpage);
+	f2fs_put_page(xpage, 1);
+
+	return 0;
 }
 
-int recover_inode_page(struct f2fs_sb_info *sbi, struct page *page)
+int f2fs_recover_inode_page(struct f2fs_sb_info *sbi, struct page *page)
 {
 	struct f2fs_inode *src, *dst;
 	nid_t ino = ino_of_node(page);
 	struct node_info old_ni, new_ni;
 	struct page *ipage;
 
-	get_node_info(sbi, ino, &old_ni);
+	f2fs_get_node_info(sbi, ino, &old_ni);
 
 	if (unlikely(old_ni.blk_addr != NULL_ADDR))
 		return -EINVAL;
@@ -2035,11 +2330,12 @@ int recover_inode_page(struct f2fs_sb_info *sbi, struct page *page)
 	}
 
 	/* Should not use this inode from free nid list */
-	remove_free_nid(NM_I(sbi), ino);
+	remove_free_nid(sbi, ino);
 
 	if (!PageUptodate(ipage))
 		SetPageUptodate(ipage);
 	fill_node_footer(ipage, ino, ino, 0, true);
+	set_cold_node(page, false);
 
 	src = F2FS_INODE(page);
 	dst = F2FS_INODE(ipage);
@@ -2049,12 +2345,25 @@ int recover_inode_page(struct f2fs_sb_info *sbi, struct page *page)
 	dst->i_blocks = cpu_to_le64(1);
 	dst->i_links = cpu_to_le32(1);
 	dst->i_xattr_nid = 0;
-	dst->i_inline = src->i_inline & F2FS_INLINE_XATTR;
+	dst->i_inline = src->i_inline & (F2FS_INLINE_XATTR | F2FS_EXTRA_ATTR);
+	if (dst->i_inline & F2FS_EXTRA_ATTR) {
+		dst->i_extra_isize = src->i_extra_isize;
+
+		if (f2fs_sb_has_flexible_inline_xattr(sbi->sb) &&
+			F2FS_FITS_IN_INODE(src, le16_to_cpu(src->i_extra_isize),
+							i_inline_xattr_size))
+			dst->i_inline_xattr_size = src->i_inline_xattr_size;
+
+		if (f2fs_sb_has_project_quota(sbi->sb) &&
+			F2FS_FITS_IN_INODE(src, le16_to_cpu(src->i_extra_isize),
+								i_projid))
+			dst->i_projid = src->i_projid;
+	}
 
 	new_ni = old_ni;
 	new_ni.ino = ino;
 
-	if (unlikely(!inc_valid_node_count(sbi, NULL)))
+	if (unlikely(inc_valid_node_count(sbi, NULL, true)))
 		WARN_ON(1);
 	set_node_addr(sbi, &new_ni, NEW_ADDR, false);
 	inc_valid_inode_count(sbi);
@@ -2063,13 +2372,12 @@ int recover_inode_page(struct f2fs_sb_info *sbi, struct page *page)
 	return 0;
 }
 
-int restore_node_summary(struct f2fs_sb_info *sbi,
+void f2fs_restore_node_summary(struct f2fs_sb_info *sbi,
 			unsigned int segno, struct f2fs_summary_block *sum)
 {
 	struct f2fs_node *rn;
 	struct f2fs_summary *sum_entry;
 	block_t addr;
-	int bio_blocks = MAX_BIO_BLOCKS(sbi);
 	int i, idx, last_offset, nrpages;
 
 	/* scan the node segment */
@@ -2078,13 +2386,13 @@ int restore_node_summary(struct f2fs_sb_info *sbi,
 	sum_entry = &sum->entries[0];
 
 	for (i = 0; i < last_offset; i += nrpages, addr += nrpages) {
-		nrpages = min(last_offset - i, bio_blocks);
+		nrpages = min(last_offset - i, BIO_MAX_PAGES);
 
 		/* readahead node pages */
-		ra_meta_pages(sbi, addr, nrpages, META_POR, true);
+		f2fs_ra_meta_pages(sbi, addr, nrpages, META_POR, true);
 
 		for (idx = addr; idx < addr + nrpages; idx++) {
-			struct page *page = get_tmp_page(sbi, idx);
+			struct page *page = f2fs_get_tmp_page(sbi, idx);
 
 			rn = F2FS_NODE(page);
 			sum_entry->nid = rn->footer.nid;
@@ -2097,7 +2405,6 @@ int restore_node_summary(struct f2fs_sb_info *sbi,
 		invalidate_mapping_pages(META_MAPPING(sbi), addr,
 							addr + nrpages);
 	}
-	return 0;
 }
 
 static void remove_nats_in_journal(struct f2fs_sb_info *sbi)
@@ -2117,9 +2424,22 @@ static void remove_nats_in_journal(struct f2fs_sb_info *sbi)
 
 		ne = __lookup_nat_cache(nm_i, nid);
 		if (!ne) {
-			ne = grab_nat_entry(nm_i, nid);
-			node_info_from_raw_nat(&ne->ni, &raw_ne);
+			ne = __alloc_nat_entry(nid, true);
+			__init_nat_entry(nm_i, ne, &raw_ne, true);
+		}
+
+		/*
+		 * if a free nat in journal has not been used after last
+		 * checkpoint, we should remove it from available nids,
+		 * since later we will add it again.
+		 */
+		if (!get_nat_flag(ne, IS_DIRTY) &&
+				le32_to_cpu(raw_ne.block_addr) == NULL_ADDR) {
+			spin_lock(&nm_i->nid_list_lock);
+			nm_i->available_nids--;
+			spin_unlock(&nm_i->nid_list_lock);
 		}
+
 		__set_nat_cache_dirty(nm_i, ne);
 	}
 	update_nats_in_cursum(journal, -i);
@@ -2144,8 +2464,41 @@ static void __adjust_nat_entry_set(struct nat_entry_set *nes,
 	list_add_tail(&nes->set_list, head);
 }
 
+static void __update_nat_bits(struct f2fs_sb_info *sbi, nid_t start_nid,
+						struct page *page)
+{
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
+	unsigned int nat_index = start_nid / NAT_ENTRY_PER_BLOCK;
+	struct f2fs_nat_block *nat_blk = page_address(page);
+	int valid = 0;
+	int i = 0;
+
+	if (!enabled_nat_bits(sbi, NULL))
+		return;
+
+	if (nat_index == 0) {
+		valid = 1;
+		i = 1;
+	}
+	for (; i < NAT_ENTRY_PER_BLOCK; i++) {
+		if (nat_blk->entries[i].block_addr != NULL_ADDR)
+			valid++;
+	}
+	if (valid == 0) {
+		__set_bit_le(nat_index, nm_i->empty_nat_bits);
+		__clear_bit_le(nat_index, nm_i->full_nat_bits);
+		return;
+	}
+
+	__clear_bit_le(nat_index, nm_i->empty_nat_bits);
+	if (valid == NAT_ENTRY_PER_BLOCK)
+		__set_bit_le(nat_index, nm_i->full_nat_bits);
+	else
+		__clear_bit_le(nat_index, nm_i->full_nat_bits);
+}
+
 static void __flush_nat_entry_set(struct f2fs_sb_info *sbi,
-					struct nat_entry_set *set)
+		struct nat_entry_set *set, struct cp_control *cpc)
 {
 	struct curseg_info *curseg = CURSEG_I(sbi, CURSEG_HOT_DATA);
 	struct f2fs_journal *journal = curseg->journal;
@@ -2160,7 +2513,8 @@ static void __flush_nat_entry_set(struct f2fs_sb_info *sbi,
 	 * #1, flush nat entries to journal in current hot data summary block.
 	 * #2, flush nat entries to nat page.
 	 */
-	if (!__has_cursum_space(journal, set->entry_cnt, NAT_JOURNAL))
+	if (enabled_nat_bits(sbi, cpc) ||
+		!__has_cursum_space(journal, set->entry_cnt, NAT_JOURNAL))
 		to_journal = false;
 
 	if (to_journal) {
@@ -2177,11 +2531,10 @@ static void __flush_nat_entry_set(struct f2fs_sb_info *sbi,
 		nid_t nid = nat_get_nid(ne);
 		int offset;
 
-		if (nat_get_blkaddr(ne) == NEW_ADDR)
-			continue;
+		f2fs_bug_on(sbi, nat_get_blkaddr(ne) == NEW_ADDR);
 
 		if (to_journal) {
-			offset = lookup_journal_in_cursum(journal,
+			offset = f2fs_lookup_journal_in_cursum(journal,
 							NAT_JOURNAL, nid, 1);
 			f2fs_bug_on(sbi, offset < 0);
 			raw_ne = &nat_in_journal(journal, offset);
@@ -2191,26 +2544,34 @@ static void __flush_nat_entry_set(struct f2fs_sb_info *sbi,
 		}
 		raw_nat_from_node_info(raw_ne, &ne->ni);
 		nat_reset_flag(ne);
-		__clear_nat_cache_dirty(NM_I(sbi), ne);
-		if (nat_get_blkaddr(ne) == NULL_ADDR)
-			add_free_nid(sbi, nid, false);
+		__clear_nat_cache_dirty(NM_I(sbi), set, ne);
+		if (nat_get_blkaddr(ne) == NULL_ADDR) {
+			add_free_nid(sbi, nid, false, true);
+		} else {
+			spin_lock(&NM_I(sbi)->nid_list_lock);
+			update_free_nid_bitmap(sbi, nid, false, false);
+			spin_unlock(&NM_I(sbi)->nid_list_lock);
+		}
 	}
 
-	if (to_journal)
+	if (to_journal) {
 		up_write(&curseg->journal_rwsem);
-	else
+	} else {
+		__update_nat_bits(sbi, start_nid, page);
 		f2fs_put_page(page, 1);
+	}
 
-	f2fs_bug_on(sbi, set->entry_cnt);
-
-	radix_tree_delete(&NM_I(sbi)->nat_set_root, set->set);
-	kmem_cache_free(nat_entry_set_slab, set);
+	/* Allow dirty nats by node block allocation in write_begin */
+	if (!set->entry_cnt) {
+		radix_tree_delete(&NM_I(sbi)->nat_set_root, set->set);
+		kmem_cache_free(nat_entry_set_slab, set);
+	}
 }
 
 /*
  * This function is called during the checkpointing process.
  */
-void flush_nat_entries(struct f2fs_sb_info *sbi)
+void f2fs_flush_nat_entries(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct curseg_info *curseg = CURSEG_I(sbi, CURSEG_HOT_DATA);
@@ -2231,7 +2592,8 @@ void flush_nat_entries(struct f2fs_sb_info *sbi)
 	 * entries, remove all entries from journal and merge them
 	 * into nat entry set.
 	 */
-	if (!__has_cursum_space(journal, nm_i->dirty_nat_cnt, NAT_JOURNAL))
+	if (enabled_nat_bits(sbi, cpc) ||
+		!__has_cursum_space(journal, nm_i->dirty_nat_cnt, NAT_JOURNAL))
 		remove_nats_in_journal(sbi);
 
 	while ((found = __gang_lookup_nat_set(nm_i,
@@ -2245,11 +2607,85 @@ void flush_nat_entries(struct f2fs_sb_info *sbi)
 
 	/* flush dirty nats in nat entry set */
 	list_for_each_entry_safe(set, tmp, &sets, set_list)
-		__flush_nat_entry_set(sbi, set);
+		__flush_nat_entry_set(sbi, set, cpc);
 
 	up_write(&nm_i->nat_tree_lock);
+	/* Allow dirty nats by node block allocation in write_begin */
+}
+
+static int __get_nat_bitmaps(struct f2fs_sb_info *sbi)
+{
+	struct f2fs_checkpoint *ckpt = F2FS_CKPT(sbi);
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
+	unsigned int nat_bits_bytes = nm_i->nat_blocks / BITS_PER_BYTE;
+	unsigned int i;
+	__u64 cp_ver = cur_cp_version(ckpt);
+	block_t nat_bits_addr;
+
+	if (!enabled_nat_bits(sbi, NULL))
+		return 0;
+
+	nm_i->nat_bits_blocks = F2FS_BLK_ALIGN((nat_bits_bytes << 1) + 8);
+	nm_i->nat_bits = f2fs_kzalloc(sbi,
+			nm_i->nat_bits_blocks << F2FS_BLKSIZE_BITS, GFP_KERNEL);
+	if (!nm_i->nat_bits)
+		return -ENOMEM;
+
+	nat_bits_addr = __start_cp_addr(sbi) + sbi->blocks_per_seg -
+						nm_i->nat_bits_blocks;
+	for (i = 0; i < nm_i->nat_bits_blocks; i++) {
+		struct page *page = f2fs_get_meta_page(sbi, nat_bits_addr++);
 
-	f2fs_bug_on(sbi, nm_i->dirty_nat_cnt);
+		memcpy(nm_i->nat_bits + (i << F2FS_BLKSIZE_BITS),
+					page_address(page), F2FS_BLKSIZE);
+		f2fs_put_page(page, 1);
+	}
+
+	cp_ver |= (cur_cp_crc(ckpt) << 32);
+	if (cpu_to_le64(cp_ver) != *(__le64 *)nm_i->nat_bits) {
+		disable_nat_bits(sbi, true);
+		return 0;
+	}
+
+	nm_i->full_nat_bits = nm_i->nat_bits + 8;
+	nm_i->empty_nat_bits = nm_i->full_nat_bits + nat_bits_bytes;
+
+	f2fs_msg(sbi->sb, KERN_NOTICE, "Found nat_bits in checkpoint");
+	return 0;
+}
+
+static inline void load_free_nid_bitmap(struct f2fs_sb_info *sbi)
+{
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
+	unsigned int i = 0;
+	nid_t nid, last_nid;
+
+	if (!enabled_nat_bits(sbi, NULL))
+		return;
+
+	for (i = 0; i < nm_i->nat_blocks; i++) {
+		i = find_next_bit_le(nm_i->empty_nat_bits, nm_i->nat_blocks, i);
+		if (i >= nm_i->nat_blocks)
+			break;
+
+		__set_bit_le(i, nm_i->nat_block_bitmap);
+
+		nid = i * NAT_ENTRY_PER_BLOCK;
+		last_nid = nid + NAT_ENTRY_PER_BLOCK;
+
+		spin_lock(&NM_I(sbi)->nid_list_lock);
+		for (; nid < last_nid; nid++)
+			update_free_nid_bitmap(sbi, nid, true, true);
+		spin_unlock(&NM_I(sbi)->nid_list_lock);
+	}
+
+	for (i = 0; i < nm_i->nat_blocks; i++) {
+		i = find_next_bit_le(nm_i->full_nat_bits, nm_i->nat_blocks, i);
+		if (i >= nm_i->nat_blocks)
+			break;
+
+		__set_bit_le(i, nm_i->nat_block_bitmap);
+	}
 }
 
 static int init_node_manager(struct f2fs_sb_info *sbi)
@@ -2257,19 +2693,21 @@ static int init_node_manager(struct f2fs_sb_info *sbi)
 	struct f2fs_super_block *sb_raw = F2FS_RAW_SUPER(sbi);
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	unsigned char *version_bitmap;
-	unsigned int nat_segs, nat_blocks;
+	unsigned int nat_segs;
+	int err;
 
 	nm_i->nat_blkaddr = le32_to_cpu(sb_raw->nat_blkaddr);
 
 	/* segment_count_nat includes pair segment so divide to 2. */
 	nat_segs = le32_to_cpu(sb_raw->segment_count_nat) >> 1;
-	nat_blocks = nat_segs << le32_to_cpu(sb_raw->log_blocks_per_seg);
-
-	nm_i->max_nid = NAT_ENTRY_PER_BLOCK * nat_blocks;
+	nm_i->nat_blocks = nat_segs << le32_to_cpu(sb_raw->log_blocks_per_seg);
+	nm_i->max_nid = NAT_ENTRY_PER_BLOCK * nm_i->nat_blocks;
 
 	/* not used nids: 0, node, meta, (and root counted as valid node) */
-	nm_i->available_nids = nm_i->max_nid - F2FS_RESERVED_NODE_NUM;
-	nm_i->fcnt = 0;
+	nm_i->available_nids = nm_i->max_nid - sbi->total_valid_node_count -
+				sbi->nquota_files - F2FS_RESERVED_NODE_NUM;
+	nm_i->nid_cnt[FREE_NID] = 0;
+	nm_i->nid_cnt[PREALLOC_NID] = 0;
 	nm_i->nat_cnt = 0;
 	nm_i->ram_thresh = DEF_RAM_THRESHOLD;
 	nm_i->ra_nid_pages = DEF_RA_NID_PAGES;
@@ -2282,7 +2720,7 @@ static int init_node_manager(struct f2fs_sb_info *sbi)
 	INIT_LIST_HEAD(&nm_i->nat_entries);
 
 	mutex_init(&nm_i->build_lock);
-	spin_lock_init(&nm_i->free_nid_list_lock);
+	spin_lock_init(&nm_i->nid_list_lock);
 	init_rwsem(&nm_i->nat_tree_lock);
 
 	nm_i->next_scan_nid = le32_to_cpu(sbi->ckpt->next_free_nid);
@@ -2295,14 +2733,60 @@ static int init_node_manager(struct f2fs_sb_info *sbi)
 					GFP_KERNEL);
 	if (!nm_i->nat_bitmap)
 		return -ENOMEM;
+
+	err = __get_nat_bitmaps(sbi);
+	if (err)
+		return err;
+
+#ifdef CONFIG_F2FS_CHECK_FS
+	nm_i->nat_bitmap_mir = kmemdup(version_bitmap, nm_i->bitmap_size,
+					GFP_KERNEL);
+	if (!nm_i->nat_bitmap_mir)
+		return -ENOMEM;
+#endif
+
+	return 0;
+}
+
+static int init_free_nid_cache(struct f2fs_sb_info *sbi)
+{
+	struct f2fs_nm_info *nm_i = NM_I(sbi);
+	int i;
+
+	nm_i->free_nid_bitmap =
+		f2fs_kzalloc(sbi, array_size(sizeof(unsigned char *),
+					     nm_i->nat_blocks),
+			     GFP_KERNEL);
+	if (!nm_i->free_nid_bitmap)
+		return -ENOMEM;
+
+	for (i = 0; i < nm_i->nat_blocks; i++) {
+		nm_i->free_nid_bitmap[i] = f2fs_kvzalloc(sbi,
+				NAT_ENTRY_BITMAP_SIZE_ALIGNED, GFP_KERNEL);
+		if (!nm_i->free_nid_bitmap)
+			return -ENOMEM;
+	}
+
+	nm_i->nat_block_bitmap = f2fs_kvzalloc(sbi, nm_i->nat_blocks / 8,
+								GFP_KERNEL);
+	if (!nm_i->nat_block_bitmap)
+		return -ENOMEM;
+
+	nm_i->free_nid_count =
+		f2fs_kvzalloc(sbi, array_size(sizeof(unsigned short),
+					      nm_i->nat_blocks),
+			      GFP_KERNEL);
+	if (!nm_i->free_nid_count)
+		return -ENOMEM;
 	return 0;
 }
 
-int build_node_manager(struct f2fs_sb_info *sbi)
+int f2fs_build_node_manager(struct f2fs_sb_info *sbi)
 {
 	int err;
 
-	sbi->nm_info = kzalloc(sizeof(struct f2fs_nm_info), GFP_KERNEL);
+	sbi->nm_info = f2fs_kzalloc(sbi, sizeof(struct f2fs_nm_info),
+							GFP_KERNEL);
 	if (!sbi->nm_info)
 		return -ENOMEM;
 
@@ -2310,11 +2794,18 @@ int build_node_manager(struct f2fs_sb_info *sbi)
 	if (err)
 		return err;
 
-	build_free_nids(sbi);
+	err = init_free_nid_cache(sbi);
+	if (err)
+		return err;
+
+	/* load free nid status from nat_bits table */
+	load_free_nid_bitmap(sbi);
+
+	f2fs_build_free_nids(sbi, true, true);
 	return 0;
 }
 
-void destroy_node_manager(struct f2fs_sb_info *sbi)
+void f2fs_destroy_node_manager(struct f2fs_sb_info *sbi)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct free_nid *i, *next_i;
@@ -2327,17 +2818,17 @@ void destroy_node_manager(struct f2fs_sb_info *sbi)
 		return;
 
 	/* destroy free nid list */
-	spin_lock(&nm_i->free_nid_list_lock);
+	spin_lock(&nm_i->nid_list_lock);
 	list_for_each_entry_safe(i, next_i, &nm_i->free_nid_list, list) {
-		f2fs_bug_on(sbi, i->state == NID_ALLOC);
-		__del_from_free_nid_list(nm_i, i);
-		nm_i->fcnt--;
-		spin_unlock(&nm_i->free_nid_list_lock);
+		__remove_free_nid(sbi, i, FREE_NID);
+		spin_unlock(&nm_i->nid_list_lock);
 		kmem_cache_free(free_nid_slab, i);
-		spin_lock(&nm_i->free_nid_list_lock);
+		spin_lock(&nm_i->nid_list_lock);
 	}
-	f2fs_bug_on(sbi, nm_i->fcnt);
-	spin_unlock(&nm_i->free_nid_list_lock);
+	f2fs_bug_on(sbi, nm_i->nid_cnt[FREE_NID]);
+	f2fs_bug_on(sbi, nm_i->nid_cnt[PREALLOC_NID]);
+	f2fs_bug_on(sbi, !list_empty(&nm_i->free_nid_list));
+	spin_unlock(&nm_i->nid_list_lock);
 
 	/* destroy nat cache */
 	down_write(&nm_i->nat_tree_lock);
@@ -2367,12 +2858,26 @@ void destroy_node_manager(struct f2fs_sb_info *sbi)
 	}
 	up_write(&nm_i->nat_tree_lock);
 
+	kvfree(nm_i->nat_block_bitmap);
+	if (nm_i->free_nid_bitmap) {
+		int i;
+
+		for (i = 0; i < nm_i->nat_blocks; i++)
+			kvfree(nm_i->free_nid_bitmap[i]);
+		kfree(nm_i->free_nid_bitmap);
+	}
+	kvfree(nm_i->free_nid_count);
+
 	kfree(nm_i->nat_bitmap);
+	kfree(nm_i->nat_bits);
+#ifdef CONFIG_F2FS_CHECK_FS
+	kfree(nm_i->nat_bitmap_mir);
+#endif
 	sbi->nm_info = NULL;
 	kfree(nm_i);
 }
 
-int __init create_node_manager_caches(void)
+int __init f2fs_create_node_manager_caches(void)
 {
 	nat_entry_slab = f2fs_kmem_cache_create("nat_entry",
 			sizeof(struct nat_entry));
@@ -2398,7 +2903,7 @@ int __init create_node_manager_caches(void)
 	return -ENOMEM;
 }
 
-void destroy_node_manager_caches(void)
+void f2fs_destroy_node_manager_caches(void)
 {
 	kmem_cache_destroy(nat_entry_set_slab);
 	kmem_cache_destroy(free_nid_slab);
diff --git a/fs/f2fs/node.h b/fs/f2fs/node.h
index 868bec6..b95e49e 100644
--- a/fs/f2fs/node.h
+++ b/fs/f2fs/node.h
@@ -9,10 +9,10 @@
  * published by the Free Software Foundation.
  */
 /* start node id of a node block dedicated to the given node id */
-#define	START_NID(nid) ((nid / NAT_ENTRY_PER_BLOCK) * NAT_ENTRY_PER_BLOCK)
+#define	START_NID(nid) (((nid) / NAT_ENTRY_PER_BLOCK) * NAT_ENTRY_PER_BLOCK)
 
 /* node block offset on the NAT area dedicated to the given start node id */
-#define	NAT_BLOCK_OFFSET(start_nid) (start_nid / NAT_ENTRY_PER_BLOCK)
+#define	NAT_BLOCK_OFFSET(start_nid) ((start_nid) / NAT_ENTRY_PER_BLOCK)
 
 /* # of pages to perform synchronous readahead before building free nids */
 #define FREE_NID_PAGES	8
@@ -44,6 +44,7 @@ enum {
 	HAS_FSYNCED_INODE,	/* is the inode fsynced before? */
 	HAS_LAST_FSYNC,		/* has the latest node fsync mark? */
 	IS_DIRTY,		/* this nat entry is dirty? */
+	IS_PREALLOC,		/* nat entry is preallocated */
 };
 
 /*
@@ -62,16 +63,16 @@ struct nat_entry {
 	struct node_info ni;	/* in-memory node information */
 };
 
-#define nat_get_nid(nat)		(nat->ni.nid)
-#define nat_set_nid(nat, n)		(nat->ni.nid = n)
-#define nat_get_blkaddr(nat)		(nat->ni.blk_addr)
-#define nat_set_blkaddr(nat, b)		(nat->ni.blk_addr = b)
-#define nat_get_ino(nat)		(nat->ni.ino)
-#define nat_set_ino(nat, i)		(nat->ni.ino = i)
-#define nat_get_version(nat)		(nat->ni.version)
-#define nat_set_version(nat, v)		(nat->ni.version = v)
+#define nat_get_nid(nat)		((nat)->ni.nid)
+#define nat_set_nid(nat, n)		((nat)->ni.nid = (n))
+#define nat_get_blkaddr(nat)		((nat)->ni.blk_addr)
+#define nat_set_blkaddr(nat, b)		((nat)->ni.blk_addr = (b))
+#define nat_get_ino(nat)		((nat)->ni.ino)
+#define nat_set_ino(nat, i)		((nat)->ni.ino = (i))
+#define nat_get_version(nat)		((nat)->ni.version)
+#define nat_set_version(nat, v)		((nat)->ni.version = (v))
 
-#define inc_node_version(version)	(++version)
+#define inc_node_version(version)	(++(version))
 
 static inline void copy_node_info(struct node_info *dst,
 						struct node_info *src)
@@ -140,6 +141,7 @@ enum mem_type {
 	DIRTY_DENTS,	/* indicates dirty dentry pages */
 	INO_ENTRIES,	/* indicates inode entries */
 	EXTENT_CACHE,	/* indicates extent cache */
+	INMEM_PAGES,	/* indicates inmemory pages */
 	BASE_CHECK,	/* check kernel status */
 };
 
@@ -150,18 +152,10 @@ struct nat_entry_set {
 	unsigned int entry_cnt;		/* the # of nat entries in set */
 };
 
-/*
- * For free nid mangement
- */
-enum nid_state {
-	NID_NEW,	/* newly added to free nid list */
-	NID_ALLOC	/* it is allocated */
-};
-
 struct free_nid {
 	struct list_head list;	/* for free node id list */
 	nid_t nid;		/* node id */
-	int state;		/* in use or not: NID_NEW or NID_ALLOC */
+	int state;		/* in use or not: FREE_NID or PREALLOC_NID */
 };
 
 static inline void next_free_nid(struct f2fs_sb_info *sbi, nid_t *nid)
@@ -169,14 +163,14 @@ static inline void next_free_nid(struct f2fs_sb_info *sbi, nid_t *nid)
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	struct free_nid *fnid;
 
-	spin_lock(&nm_i->free_nid_list_lock);
-	if (nm_i->fcnt <= 0) {
-		spin_unlock(&nm_i->free_nid_list_lock);
+	spin_lock(&nm_i->nid_list_lock);
+	if (nm_i->nid_cnt[FREE_NID] <= 0) {
+		spin_unlock(&nm_i->nid_list_lock);
 		return;
 	}
-	fnid = list_entry(nm_i->free_nid_list.next, struct free_nid, list);
+	fnid = list_first_entry(&nm_i->free_nid_list, struct free_nid, list);
 	*nid = fnid->nid;
-	spin_unlock(&nm_i->free_nid_list_lock);
+	spin_unlock(&nm_i->nid_list_lock);
 }
 
 /*
@@ -185,6 +179,12 @@ static inline void next_free_nid(struct f2fs_sb_info *sbi, nid_t *nid)
 static inline void get_nat_bitmap(struct f2fs_sb_info *sbi, void *addr)
 {
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
+
+#ifdef CONFIG_F2FS_CHECK_FS
+	if (memcmp(nm_i->nat_bitmap, nm_i->nat_bitmap_mir,
+						nm_i->bitmap_size))
+		f2fs_bug_on(sbi, 1);
+#endif
 	memcpy(addr, nm_i->nat_bitmap, nm_i->bitmap_size);
 }
 
@@ -193,13 +193,16 @@ static inline pgoff_t current_nat_addr(struct f2fs_sb_info *sbi, nid_t start)
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 	pgoff_t block_off;
 	pgoff_t block_addr;
-	int seg_off;
 
+	/*
+	 * block_off = segment_off * 512 + off_in_segment
+	 * OLD = (segment_off * 512) * 2 + off_in_segment
+	 * NEW = 2 * (segment_off * 512 + off_in_segment) - off_in_segment
+	 */
 	block_off = NAT_BLOCK_OFFSET(start);
-	seg_off = block_off >> sbi->log_blocks_per_seg;
 
 	block_addr = (pgoff_t)(nm_i->nat_blkaddr +
-		(seg_off << sbi->log_blocks_per_seg << 1) +
+		(block_off << 1) -
 		(block_off & (sbi->blocks_per_seg - 1)));
 
 	if (f2fs_test_bit(block_off, nm_i->nat_bitmap))
@@ -214,11 +217,7 @@ static inline pgoff_t next_nat_addr(struct f2fs_sb_info *sbi,
 	struct f2fs_nm_info *nm_i = NM_I(sbi);
 
 	block_addr -= nm_i->nat_blkaddr;
-	if ((block_addr >> sbi->log_blocks_per_seg) % 2)
-		block_addr -= sbi->blocks_per_seg;
-	else
-		block_addr += sbi->blocks_per_seg;
-
+	block_addr ^= 1 << sbi->log_blocks_per_seg;
 	return block_addr + nm_i->nat_blkaddr;
 }
 
@@ -227,6 +226,9 @@ static inline void set_to_next_nat(struct f2fs_nm_info *nm_i, nid_t start_nid)
 	unsigned int block_off = NAT_BLOCK_OFFSET(start_nid);
 
 	f2fs_change_bit(block_off, nm_i->nat_bitmap);
+#ifdef CONFIG_F2FS_CHECK_FS
+	f2fs_change_bit(block_off, nm_i->nat_bitmap_mir);
+#endif
 }
 
 static inline nid_t ino_of_node(struct page *node_page)
@@ -290,14 +292,11 @@ static inline void fill_node_footer_blkaddr(struct page *page, block_t blkaddr)
 {
 	struct f2fs_checkpoint *ckpt = F2FS_CKPT(F2FS_P_SB(page));
 	struct f2fs_node *rn = F2FS_NODE(page);
-	size_t crc_offset = le32_to_cpu(ckpt->checksum_offset);
-	__u64 cp_ver = le64_to_cpu(ckpt->checkpoint_ver);
+	__u64 cp_ver = cur_cp_version(ckpt);
+
+	if (__is_set_ckpt_flags(ckpt, CP_CRC_RECOVERY_FLAG))
+		cp_ver |= (cur_cp_crc(ckpt) << 32);
 
-	if (__is_set_ckpt_flags(ckpt, CP_CRC_RECOVERY_FLAG)) {
-		__u64 crc = le32_to_cpu(*((__le32 *)
-				((unsigned char *)ckpt + crc_offset)));
-		cp_ver |= (crc << 32);
-	}
 	rn->footer.cp_ver = cpu_to_le64(cp_ver);
 	rn->footer.next_blkaddr = cpu_to_le32(blkaddr);
 }
@@ -305,15 +304,16 @@ static inline void fill_node_footer_blkaddr(struct page *page, block_t blkaddr)
 static inline bool is_recoverable_dnode(struct page *page)
 {
 	struct f2fs_checkpoint *ckpt = F2FS_CKPT(F2FS_P_SB(page));
-	size_t crc_offset = le32_to_cpu(ckpt->checksum_offset);
 	__u64 cp_ver = cur_cp_version(ckpt);
 
-	if (__is_set_ckpt_flags(ckpt, CP_CRC_RECOVERY_FLAG)) {
-		__u64 crc = le32_to_cpu(*((__le32 *)
-				((unsigned char *)ckpt + crc_offset)));
-		cp_ver |= (crc << 32);
-	}
-	return cpu_to_le64(cp_ver) == cpver_of_node(page);
+	/* Don't care crc part, if fsck.f2fs sets it. */
+	if (__is_set_ckpt_flags(ckpt, CP_NOCRC_RECOVERY_FLAG))
+		return (cp_ver << 32) == (cpver_of_node(page) << 32);
+
+	if (__is_set_ckpt_flags(ckpt, CP_CRC_RECOVERY_FLAG))
+		cp_ver |= (cur_cp_crc(ckpt) << 32);
+
+	return cp_ver == cpver_of_node(page);
 }
 
 /*
@@ -342,7 +342,7 @@ static inline bool IS_DNODE(struct page *node_page)
 	unsigned int ofs = ofs_of_node(node_page);
 
 	if (f2fs_has_xattr_block(ofs))
-		return false;
+		return true;
 
 	if (ofs == 3 || ofs == 4 + NIDS_PER_BLOCK ||
 			ofs == 5 + 2 * NIDS_PER_BLOCK)
@@ -423,12 +423,12 @@ static inline void clear_inline_node(struct page *page)
 	ClearPageChecked(page);
 }
 
-static inline void set_cold_node(struct inode *inode, struct page *page)
+static inline void set_cold_node(struct page *page, bool is_dir)
 {
 	struct f2fs_node *rn = F2FS_NODE(page);
 	unsigned int flag = le32_to_cpu(rn->footer.flag);
 
-	if (S_ISDIR(inode->i_mode))
+	if (is_dir)
 		flag &= ~(0x1 << COLD_BIT_SHIFT);
 	else
 		flag |= (0x1 << COLD_BIT_SHIFT);
diff --git a/fs/f2fs/recovery.c b/fs/f2fs/recovery.c
index 98c1a63..daf81d4 100644
--- a/fs/f2fs/recovery.c
+++ b/fs/f2fs/recovery.c
@@ -47,7 +47,7 @@
 
 static struct kmem_cache *fsync_entry_slab;
 
-bool space_for_roll_forward(struct f2fs_sb_info *sbi)
+bool f2fs_space_for_roll_forward(struct f2fs_sb_info *sbi)
 {
 	s64 nalloc = percpu_counter_sum_positive(&sbi->alloc_valid_block_count);
 
@@ -69,20 +69,34 @@ static struct fsync_inode_entry *get_fsync_inode(struct list_head *head,
 }
 
 static struct fsync_inode_entry *add_fsync_inode(struct f2fs_sb_info *sbi,
-					struct list_head *head, nid_t ino)
+			struct list_head *head, nid_t ino, bool quota_inode)
 {
 	struct inode *inode;
 	struct fsync_inode_entry *entry;
+	int err;
 
 	inode = f2fs_iget_retry(sbi->sb, ino);
 	if (IS_ERR(inode))
 		return ERR_CAST(inode);
 
+	err = dquot_initialize(inode);
+	if (err)
+		goto err_out;
+
+	if (quota_inode) {
+		err = dquot_alloc_inode(inode);
+		if (err)
+			goto err_out;
+	}
+
 	entry = f2fs_kmem_cache_alloc(fsync_entry_slab, GFP_F2FS_ZERO);
 	entry->inode = inode;
 	list_add_tail(&entry->list, head);
 
 	return entry;
+err_out:
+	iput(inode);
+	return ERR_PTR(err);
 }
 
 static void del_fsync_inode(struct fsync_inode_entry *entry)
@@ -107,7 +121,8 @@ static int recover_dentry(struct inode *inode, struct page *ipage,
 
 	entry = get_fsync_inode(dir_list, pino);
 	if (!entry) {
-		entry = add_fsync_inode(F2FS_I_SB(inode), dir_list, pino);
+		entry = add_fsync_inode(F2FS_I_SB(inode), dir_list,
+							pino, false);
 		if (IS_ERR(entry)) {
 			dir = ERR_CAST(entry);
 			err = PTR_ERR(entry);
@@ -129,7 +144,7 @@ static int recover_dentry(struct inode *inode, struct page *ipage,
 retry:
 	de = __f2fs_find_entry(dir, &fname, &page);
 	if (de && inode->i_ino == le32_to_cpu(de->ino))
-		goto out_unmap_put;
+		goto out_put;
 
 	if (de) {
 		einode = f2fs_iget_retry(inode->i_sb, le32_to_cpu(de->ino));
@@ -138,12 +153,19 @@ static int recover_dentry(struct inode *inode, struct page *ipage,
 			err = PTR_ERR(einode);
 			if (err == -ENOENT)
 				err = -EEXIST;
-			goto out_unmap_put;
+			goto out_put;
+		}
+
+		err = dquot_initialize(einode);
+		if (err) {
+			iput(einode);
+			goto out_put;
 		}
-		err = acquire_orphan_inode(F2FS_I_SB(inode));
+
+		err = f2fs_acquire_orphan_inode(F2FS_I_SB(inode));
 		if (err) {
 			iput(einode);
-			goto out_unmap_put;
+			goto out_put;
 		}
 		f2fs_delete_entry(de, page, dir, einode);
 		iput(einode);
@@ -151,15 +173,14 @@ static int recover_dentry(struct inode *inode, struct page *ipage,
 	} else if (IS_ERR(page)) {
 		err = PTR_ERR(page);
 	} else {
-		err = __f2fs_do_add_link(dir, &fname, inode,
+		err = f2fs_add_dentry(dir, &fname, inode,
 					inode->i_ino, inode->i_mode);
 	}
 	if (err == -ENOMEM)
 		goto retry;
 	goto out;
 
-out_unmap_put:
-	f2fs_dentry_kunmap(dir, page);
+out_put:
 	f2fs_put_page(page, 0);
 out:
 	if (file_enc_name(inode))
@@ -173,6 +194,18 @@ static int recover_dentry(struct inode *inode, struct page *ipage,
 	return err;
 }
 
+static void recover_inline_flags(struct inode *inode, struct f2fs_inode *ri)
+{
+	if (ri->i_inline & F2FS_PIN_FILE)
+		set_inode_flag(inode, FI_PIN_FILE);
+	else
+		clear_inode_flag(inode, FI_PIN_FILE);
+	if (ri->i_inline & F2FS_DATA_EXIST)
+		set_inode_flag(inode, FI_DATA_EXIST);
+	else
+		clear_inode_flag(inode, FI_DATA_EXIST);
+}
+
 static void recover_inode(struct inode *inode, struct page *page)
 {
 	struct f2fs_inode *raw = F2FS_INODE(page);
@@ -180,53 +213,36 @@ static void recover_inode(struct inode *inode, struct page *page)
 
 	inode->i_mode = le16_to_cpu(raw->i_mode);
 	f2fs_i_size_write(inode, le64_to_cpu(raw->i_size));
-	inode->i_atime.tv_sec = le64_to_cpu(raw->i_mtime);
+	inode->i_atime.tv_sec = le64_to_cpu(raw->i_atime);
 	inode->i_ctime.tv_sec = le64_to_cpu(raw->i_ctime);
 	inode->i_mtime.tv_sec = le64_to_cpu(raw->i_mtime);
-	inode->i_atime.tv_nsec = le32_to_cpu(raw->i_mtime_nsec);
+	inode->i_atime.tv_nsec = le32_to_cpu(raw->i_atime_nsec);
 	inode->i_ctime.tv_nsec = le32_to_cpu(raw->i_ctime_nsec);
 	inode->i_mtime.tv_nsec = le32_to_cpu(raw->i_mtime_nsec);
 
+	F2FS_I(inode)->i_advise = raw->i_advise;
+
+	recover_inline_flags(inode, raw);
+
 	if (file_enc_name(inode))
 		name = "<encrypted>";
 	else
 		name = F2FS_INODE(page)->i_name;
 
-	f2fs_msg(inode->i_sb, KERN_NOTICE, "recover_inode: ino = %x, name = %s",
-			ino_of_node(page), name);
-}
-
-static bool is_same_inode(struct inode *inode, struct page *ipage)
-{
-	struct f2fs_inode *ri = F2FS_INODE(ipage);
-	struct timespec disk;
-
-	if (!IS_INODE(ipage))
-		return true;
-
-	disk.tv_sec = le64_to_cpu(ri->i_ctime);
-	disk.tv_nsec = le32_to_cpu(ri->i_ctime_nsec);
-	if (timespec_compare(&inode->i_ctime, &disk) > 0)
-		return false;
-
-	disk.tv_sec = le64_to_cpu(ri->i_atime);
-	disk.tv_nsec = le32_to_cpu(ri->i_atime_nsec);
-	if (timespec_compare(&inode->i_atime, &disk) > 0)
-		return false;
-
-	disk.tv_sec = le64_to_cpu(ri->i_mtime);
-	disk.tv_nsec = le32_to_cpu(ri->i_mtime_nsec);
-	if (timespec_compare(&inode->i_mtime, &disk) > 0)
-		return false;
-
-	return true;
+	f2fs_msg(inode->i_sb, KERN_NOTICE,
+		"recover_inode: ino = %x, name = %s, inline = %x",
+			ino_of_node(page), name, raw->i_inline);
 }
 
-static int find_fsync_dnodes(struct f2fs_sb_info *sbi, struct list_head *head)
+static int find_fsync_dnodes(struct f2fs_sb_info *sbi, struct list_head *head,
+				bool check_only)
 {
 	struct curseg_info *curseg;
 	struct page *page = NULL;
 	block_t blkaddr;
+	unsigned int loop_cnt = 0;
+	unsigned int free_blocks = sbi->user_block_count -
+					valid_user_blocks(sbi);
 	int err = 0;
 
 	/* get node pages in the current segment */
@@ -236,10 +252,10 @@ static int find_fsync_dnodes(struct f2fs_sb_info *sbi, struct list_head *head)
 	while (1) {
 		struct fsync_inode_entry *entry;
 
-		if (!is_valid_blkaddr(sbi, blkaddr, META_POR))
+		if (!f2fs_is_valid_meta_blkaddr(sbi, blkaddr, META_POR))
 			return 0;
 
-		page = get_tmp_page(sbi, blkaddr);
+		page = f2fs_get_tmp_page(sbi, blkaddr);
 
 		if (!is_recoverable_dnode(page))
 			break;
@@ -248,21 +264,23 @@ static int find_fsync_dnodes(struct f2fs_sb_info *sbi, struct list_head *head)
 			goto next;
 
 		entry = get_fsync_inode(head, ino_of_node(page));
-		if (entry) {
-			if (!is_same_inode(entry->inode, page))
-				goto next;
-		} else {
-			if (IS_INODE(page) && is_dent_dnode(page)) {
-				err = recover_inode_page(sbi, page);
+		if (!entry) {
+			bool quota_inode = false;
+
+			if (!check_only &&
+					IS_INODE(page) && is_dent_dnode(page)) {
+				err = f2fs_recover_inode_page(sbi, page);
 				if (err)
 					break;
+				quota_inode = true;
 			}
 
 			/*
 			 * CP | dnode(F) | inode(DF)
 			 * For this case, we should not give up now.
 			 */
-			entry = add_fsync_inode(sbi, head, ino_of_node(page));
+			entry = add_fsync_inode(sbi, head, ino_of_node(page),
+								quota_inode);
 			if (IS_ERR(entry)) {
 				err = PTR_ERR(entry);
 				if (err == -ENOENT) {
@@ -277,11 +295,22 @@ static int find_fsync_dnodes(struct f2fs_sb_info *sbi, struct list_head *head)
 		if (IS_INODE(page) && is_dent_dnode(page))
 			entry->last_dentry = blkaddr;
 next:
+		/* sanity check in order to detect looped node chain */
+		if (++loop_cnt >= free_blocks ||
+			blkaddr == next_blkaddr_of_node(page)) {
+			f2fs_msg(sbi->sb, KERN_NOTICE,
+				"%s: detect looped node chain, "
+				"blkaddr:%u, next:%u",
+				__func__, blkaddr, next_blkaddr_of_node(page));
+			err = -EINVAL;
+			break;
+		}
+
 		/* check next segment */
 		blkaddr = next_blkaddr_of_node(page);
 		f2fs_put_page(page, 1);
 
-		ra_meta_pages_cond(sbi, blkaddr);
+		f2fs_ra_meta_pages_cond(sbi, blkaddr);
 	}
 	f2fs_put_page(page, 1);
 	return err;
@@ -324,7 +353,7 @@ static int check_index_in_prev_nodes(struct f2fs_sb_info *sbi,
 		}
 	}
 
-	sum_page = get_sum_page(sbi, segno);
+	sum_page = f2fs_get_sum_page(sbi, segno);
 	sum_node = (struct f2fs_summary_block *)page_address(sum_page);
 	sum = sum_node->entries[blkoff];
 	f2fs_put_page(sum_page, 1);
@@ -344,7 +373,7 @@ static int check_index_in_prev_nodes(struct f2fs_sb_info *sbi,
 	}
 
 	/* Get the node page */
-	node_page = get_node_page(sbi, nid);
+	node_page = f2fs_get_node_page(sbi, nid);
 	if (IS_ERR(node_page))
 		return PTR_ERR(node_page);
 
@@ -353,15 +382,24 @@ static int check_index_in_prev_nodes(struct f2fs_sb_info *sbi,
 	f2fs_put_page(node_page, 1);
 
 	if (ino != dn->inode->i_ino) {
+		int ret;
+
 		/* Deallocate previous index in the node page */
 		inode = f2fs_iget_retry(sbi->sb, ino);
 		if (IS_ERR(inode))
 			return PTR_ERR(inode);
+
+		ret = dquot_initialize(inode);
+		if (ret) {
+			iput(inode);
+			return ret;
+		}
 	} else {
 		inode = dn->inode;
 	}
 
-	bidx = start_bidx_of_node(offset, inode) + le16_to_cpu(sum.ofs_in_node);
+	bidx = f2fs_start_bidx_of_node(offset, inode) +
+				le16_to_cpu(sum.ofs_in_node);
 
 	/*
 	 * if inode page is locked, unlock temporarily, but its reference
@@ -371,11 +409,11 @@ static int check_index_in_prev_nodes(struct f2fs_sb_info *sbi,
 		unlock_page(dn->inode_page);
 
 	set_new_dnode(&tdn, inode, NULL, NULL, 0);
-	if (get_dnode_of_data(&tdn, bidx, LOOKUP_NODE))
+	if (f2fs_get_dnode_of_data(&tdn, bidx, LOOKUP_NODE))
 		goto out;
 
 	if (tdn.data_blkaddr == blkaddr)
-		truncate_data_blocks_range(&tdn, 1);
+		f2fs_truncate_data_blocks_range(&tdn, 1);
 
 	f2fs_put_dnode(&tdn);
 out:
@@ -386,15 +424,16 @@ static int check_index_in_prev_nodes(struct f2fs_sb_info *sbi,
 	return 0;
 
 truncate_out:
-	if (datablock_addr(tdn.node_page, tdn.ofs_in_node) == blkaddr)
-		truncate_data_blocks_range(&tdn, 1);
+	if (datablock_addr(tdn.inode, tdn.node_page,
+					tdn.ofs_in_node) == blkaddr)
+		f2fs_truncate_data_blocks_range(&tdn, 1);
 	if (dn->inode->i_ino == nid && !dn->inode_page_locked)
 		unlock_page(dn->inode_page);
 	return 0;
 }
 
 static int do_recover_data(struct f2fs_sb_info *sbi, struct inode *inode,
-					struct page *page, block_t blkaddr)
+					struct page *page)
 {
 	struct dnode_of_data dn;
 	struct node_info ni;
@@ -403,27 +442,25 @@ static int do_recover_data(struct f2fs_sb_info *sbi, struct inode *inode,
 
 	/* step 1: recover xattr */
 	if (IS_INODE(page)) {
-		recover_inline_xattr(inode, page);
+		f2fs_recover_inline_xattr(inode, page);
 	} else if (f2fs_has_xattr_block(ofs_of_node(page))) {
-		/*
-		 * Deprecated; xattr blocks should be found from cold log.
-		 * But, we should remain this for backward compatibility.
-		 */
-		recover_xattr_data(inode, page, blkaddr);
+		err = f2fs_recover_xattr_data(inode, page);
+		if (!err)
+			recovered++;
 		goto out;
 	}
 
 	/* step 2: recover inline data */
-	if (recover_inline_data(inode, page))
+	if (f2fs_recover_inline_data(inode, page))
 		goto out;
 
 	/* step 3: recover data indices */
-	start = start_bidx_of_node(ofs_of_node(page), inode);
+	start = f2fs_start_bidx_of_node(ofs_of_node(page), inode);
 	end = start + ADDRS_PER_PAGE(page, inode);
 
 	set_new_dnode(&dn, inode, NULL, NULL, 0);
 retry_dn:
-	err = get_dnode_of_data(&dn, start, ALLOC_NODE);
+	err = f2fs_get_dnode_of_data(&dn, start, ALLOC_NODE);
 	if (err) {
 		if (err == -ENOMEM) {
 			congestion_wait(BLK_RW_ASYNC, HZ/50);
@@ -434,15 +471,15 @@ static int do_recover_data(struct f2fs_sb_info *sbi, struct inode *inode,
 
 	f2fs_wait_on_page_writeback(dn.node_page, NODE, true);
 
-	get_node_info(sbi, dn.nid, &ni);
+	f2fs_get_node_info(sbi, dn.nid, &ni);
 	f2fs_bug_on(sbi, ni.ino != ino_of_node(page));
 	f2fs_bug_on(sbi, ofs_of_node(dn.node_page) != ofs_of_node(page));
 
 	for (; start < end; start++, dn.ofs_in_node++) {
 		block_t src, dest;
 
-		src = datablock_addr(dn.node_page, dn.ofs_in_node);
-		dest = datablock_addr(page, dn.ofs_in_node);
+		src = datablock_addr(dn.inode, dn.node_page, dn.ofs_in_node);
+		dest = datablock_addr(dn.inode, page, dn.ofs_in_node);
 
 		/* skip recovering if dest is the same as src */
 		if (src == dest)
@@ -450,31 +487,33 @@ static int do_recover_data(struct f2fs_sb_info *sbi, struct inode *inode,
 
 		/* dest is invalid, just invalidate src block */
 		if (dest == NULL_ADDR) {
-			truncate_data_blocks_range(&dn, 1);
+			f2fs_truncate_data_blocks_range(&dn, 1);
 			continue;
 		}
 
-		if ((start + 1) << PAGE_SHIFT > i_size_read(inode))
-			f2fs_i_size_write(inode, (start + 1) << PAGE_SHIFT);
+		if (!file_keep_isize(inode) &&
+			(i_size_read(inode) <= ((loff_t)start << PAGE_SHIFT)))
+			f2fs_i_size_write(inode,
+				(loff_t)(start + 1) << PAGE_SHIFT);
 
 		/*
 		 * dest is reserved block, invalidate src block
 		 * and then reserve one new block in dnode page.
 		 */
 		if (dest == NEW_ADDR) {
-			truncate_data_blocks_range(&dn, 1);
-			reserve_new_block(&dn);
+			f2fs_truncate_data_blocks_range(&dn, 1);
+			f2fs_reserve_new_block(&dn);
 			continue;
 		}
 
 		/* dest is valid block, try to recover from src to dest */
-		if (is_valid_blkaddr(sbi, dest, META_POR)) {
+		if (f2fs_is_valid_meta_blkaddr(sbi, dest, META_POR)) {
 
 			if (src == NULL_ADDR) {
-				err = reserve_new_block(&dn);
+				err = f2fs_reserve_new_block(&dn);
 #ifdef CONFIG_F2FS_FAULT_INJECTION
 				while (err)
-					err = reserve_new_block(&dn);
+					err = f2fs_reserve_new_block(&dn);
 #endif
 				/* We should not get -ENOSPC */
 				f2fs_bug_on(sbi, err);
@@ -507,8 +546,10 @@ static int do_recover_data(struct f2fs_sb_info *sbi, struct inode *inode,
 	f2fs_put_dnode(&dn);
 out:
 	f2fs_msg(sbi->sb, KERN_NOTICE,
-		"recover_data: ino = %lx, recovered = %d blocks, err = %d",
-		inode->i_ino, recovered, err);
+		"recover_data: ino = %lx (i_size: %s) recovered = %d, err = %d",
+		inode->i_ino,
+		file_keep_isize(inode) ? "keep" : "recover",
+		recovered, err);
 	return err;
 }
 
@@ -527,12 +568,12 @@ static int recover_data(struct f2fs_sb_info *sbi, struct list_head *inode_list,
 	while (1) {
 		struct fsync_inode_entry *entry;
 
-		if (!is_valid_blkaddr(sbi, blkaddr, META_POR))
+		if (!f2fs_is_valid_meta_blkaddr(sbi, blkaddr, META_POR))
 			break;
 
-		ra_meta_pages_cond(sbi, blkaddr);
+		f2fs_ra_meta_pages_cond(sbi, blkaddr);
 
-		page = get_tmp_page(sbi, blkaddr);
+		page = f2fs_get_tmp_page(sbi, blkaddr);
 
 		if (!is_recoverable_dnode(page)) {
 			f2fs_put_page(page, 1);
@@ -556,7 +597,7 @@ static int recover_data(struct f2fs_sb_info *sbi, struct list_head *inode_list,
 				break;
 			}
 		}
-		err = do_recover_data(sbi, entry->inode, page, blkaddr);
+		err = do_recover_data(sbi, entry->inode, page);
 		if (err) {
 			f2fs_put_page(page, 1);
 			break;
@@ -570,24 +611,40 @@ static int recover_data(struct f2fs_sb_info *sbi, struct list_head *inode_list,
 		f2fs_put_page(page, 1);
 	}
 	if (!err)
-		allocate_new_segments(sbi);
+		f2fs_allocate_new_segments(sbi);
 	return err;
 }
 
-int recover_fsync_data(struct f2fs_sb_info *sbi, bool check_only)
+int f2fs_recover_fsync_data(struct f2fs_sb_info *sbi, bool check_only)
 {
-	struct curseg_info *curseg = CURSEG_I(sbi, CURSEG_WARM_NODE);
 	struct list_head inode_list;
 	struct list_head dir_list;
-	block_t blkaddr;
 	int err;
 	int ret = 0;
+	unsigned long s_flags = sbi->sb->s_flags;
 	bool need_writecp = false;
+#ifdef CONFIG_QUOTA
+	int quota_enabled;
+#endif
+
+	if (s_flags & MS_RDONLY) {
+		f2fs_msg(sbi->sb, KERN_INFO, "orphan cleanup on readonly fs");
+		sbi->sb->s_flags &= ~MS_RDONLY;
+	}
+
+#ifdef CONFIG_QUOTA
+	/* Needed for iput() to work correctly and not trash data */
+	sbi->sb->s_flags |= MS_ACTIVE;
+	/* Turn on quotas so that they are updated correctly */
+	quota_enabled = f2fs_enable_quota_files(sbi, s_flags & MS_RDONLY);
+#endif
 
 	fsync_entry_slab = f2fs_kmem_cache_create("f2fs_fsync_inode_entry",
 			sizeof(struct fsync_inode_entry));
-	if (!fsync_entry_slab)
-		return -ENOMEM;
+	if (!fsync_entry_slab) {
+		err = -ENOMEM;
+		goto out;
+	}
 
 	INIT_LIST_HEAD(&inode_list);
 	INIT_LIST_HEAD(&dir_list);
@@ -595,16 +652,14 @@ int recover_fsync_data(struct f2fs_sb_info *sbi, bool check_only)
 	/* prevent checkpoint */
 	mutex_lock(&sbi->cp_mutex);
 
-	blkaddr = NEXT_FREE_BLKADDR(sbi, curseg);
-
 	/* step #1: find fsynced inode numbers */
-	err = find_fsync_dnodes(sbi, &inode_list);
+	err = find_fsync_dnodes(sbi, &inode_list, check_only);
 	if (err || list_empty(&inode_list))
-		goto out;
+		goto skip;
 
 	if (check_only) {
 		ret = 1;
-		goto out;
+		goto skip;
 	}
 
 	need_writecp = true;
@@ -613,7 +668,7 @@ int recover_fsync_data(struct f2fs_sb_info *sbi, bool check_only)
 	err = recover_data(sbi, &inode_list, &dir_list);
 	if (!err)
 		f2fs_bug_on(sbi, !list_empty(&inode_list));
-out:
+skip:
 	destroy_fsync_dnodes(&inode_list);
 
 	/* truncate meta pages to be used by the recovery */
@@ -635,9 +690,17 @@ int recover_fsync_data(struct f2fs_sb_info *sbi, bool check_only)
 		struct cp_control cpc = {
 			.reason = CP_RECOVERY,
 		};
-		err = write_checkpoint(sbi, &cpc);
+		err = f2fs_write_checkpoint(sbi, &cpc);
 	}
 
 	kmem_cache_destroy(fsync_entry_slab);
+out:
+#ifdef CONFIG_QUOTA
+	/* Turn quotas off */
+	if (quota_enabled)
+		f2fs_quota_off_umount(sbi->sb);
+#endif
+	sbi->sb->s_flags = s_flags; /* Restore MS_RDONLY status */
+
 	return ret ? ret: err;
 }
diff --git a/fs/f2fs/segment.c b/fs/f2fs/segment.c
index 35d48ef..8e6455c 100644
--- a/fs/f2fs/segment.c
+++ b/fs/f2fs/segment.c
@@ -16,17 +16,20 @@
 #include <linux/kthread.h>
 #include <linux/swap.h>
 #include <linux/timer.h>
+#include <linux/freezer.h>
+#include <linux/sched.h>
 
 #include "f2fs.h"
 #include "segment.h"
 #include "node.h"
+#include "gc.h"
 #include "trace.h"
 #include <trace/events/f2fs.h>
 
 #define __reverse_ffz(x) __reverse_ffs(~(x))
 
 static struct kmem_cache *discard_entry_slab;
-static struct kmem_cache *bio_entry_slab;
+static struct kmem_cache *discard_cmd_slab;
 static struct kmem_cache *sit_entry_set_slab;
 static struct kmem_cache *inmem_entry_slab;
 
@@ -166,8 +169,24 @@ static unsigned long __find_rev_next_zero_bit(const unsigned long *addr,
 	return result - size + __reverse_ffz(tmp);
 }
 
-void register_inmem_page(struct inode *inode, struct page *page)
+bool f2fs_need_SSR(struct f2fs_sb_info *sbi)
 {
+	int node_secs = get_blocktype_secs(sbi, F2FS_DIRTY_NODES);
+	int dent_secs = get_blocktype_secs(sbi, F2FS_DIRTY_DENTS);
+	int imeta_secs = get_blocktype_secs(sbi, F2FS_DIRTY_IMETA);
+
+	if (test_opt(sbi, LFS))
+		return false;
+	if (sbi->gc_mode == GC_URGENT)
+		return true;
+
+	return free_sections(sbi) <= (node_secs + 2 * dent_secs + imeta_secs +
+			SM_I(sbi)->min_ssr_sections + reserved_sections(sbi));
+}
+
+void f2fs_register_inmem_page(struct inode *inode, struct page *page)
+{
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	struct f2fs_inode_info *fi = F2FS_I(inode);
 	struct inmem_pages *new;
 
@@ -186,6 +205,10 @@ void register_inmem_page(struct inode *inode, struct page *page)
 	mutex_lock(&fi->inmem_lock);
 	get_page(page);
 	list_add_tail(&new->list, &fi->inmem_pages);
+	spin_lock(&sbi->inode_lock[ATOMIC_FILE]);
+	if (list_empty(&fi->inmem_ilist))
+		list_add_tail(&fi->inmem_ilist, &sbi->inode_list[ATOMIC_FILE]);
+	spin_unlock(&sbi->inode_lock[ATOMIC_FILE]);
 	inc_page_count(F2FS_I_SB(inode), F2FS_INMEM_PAGES);
 	mutex_unlock(&fi->inmem_lock);
 
@@ -214,14 +237,25 @@ static int __revoke_inmem_pages(struct inode *inode,
 			struct node_info ni;
 
 			trace_f2fs_commit_inmem_page(page, INMEM_REVOKE);
-
+retry:
 			set_new_dnode(&dn, inode, NULL, NULL, 0);
-			if (get_dnode_of_data(&dn, page->index, LOOKUP_NODE)) {
+			err = f2fs_get_dnode_of_data(&dn, page->index,
+								LOOKUP_NODE);
+			if (err) {
+				if (err == -ENOMEM) {
+					congestion_wait(BLK_RW_ASYNC, HZ/50);
+					cond_resched();
+					goto retry;
+				}
 				err = -EAGAIN;
 				goto next;
 			}
-			get_node_info(sbi, dn.nid, &ni);
-			f2fs_replace_block(sbi, &dn, dn.data_blkaddr,
+			f2fs_get_node_info(sbi, dn.nid, &ni);
+			if (cur->old_addr == NEW_ADDR) {
+				f2fs_invalidate_blocks(sbi, dn.data_blkaddr);
+				f2fs_update_data_blkaddr(&dn, NEW_ADDR);
+			} else
+				f2fs_replace_block(sbi, &dn, dn.data_blkaddr,
 					cur->old_addr, ni.version, true, true);
 			f2fs_put_dnode(&dn);
 		}
@@ -240,33 +274,105 @@ static int __revoke_inmem_pages(struct inode *inode,
 	return err;
 }
 
-void drop_inmem_pages(struct inode *inode)
+void f2fs_drop_inmem_pages_all(struct f2fs_sb_info *sbi, bool gc_failure)
 {
+	struct list_head *head = &sbi->inode_list[ATOMIC_FILE];
+	struct inode *inode;
+	struct f2fs_inode_info *fi;
+next:
+	spin_lock(&sbi->inode_lock[ATOMIC_FILE]);
+	if (list_empty(head)) {
+		spin_unlock(&sbi->inode_lock[ATOMIC_FILE]);
+		return;
+	}
+	fi = list_first_entry(head, struct f2fs_inode_info, inmem_ilist);
+	inode = igrab(&fi->vfs_inode);
+	spin_unlock(&sbi->inode_lock[ATOMIC_FILE]);
+
+	if (inode) {
+		if (gc_failure) {
+			if (fi->i_gc_failures[GC_FAILURE_ATOMIC])
+				goto drop;
+			goto skip;
+		}
+drop:
+		set_inode_flag(inode, FI_ATOMIC_REVOKE_REQUEST);
+		f2fs_drop_inmem_pages(inode);
+		iput(inode);
+	}
+skip:
+	congestion_wait(BLK_RW_ASYNC, HZ/50);
+	cond_resched();
+	goto next;
+}
+
+void f2fs_drop_inmem_pages(struct inode *inode)
+{
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	struct f2fs_inode_info *fi = F2FS_I(inode);
 
+	mutex_lock(&fi->inmem_lock);
+	__revoke_inmem_pages(inode, &fi->inmem_pages, true, false);
+	spin_lock(&sbi->inode_lock[ATOMIC_FILE]);
+	if (!list_empty(&fi->inmem_ilist))
+		list_del_init(&fi->inmem_ilist);
+	spin_unlock(&sbi->inode_lock[ATOMIC_FILE]);
+	mutex_unlock(&fi->inmem_lock);
+
 	clear_inode_flag(inode, FI_ATOMIC_FILE);
+	fi->i_gc_failures[GC_FAILURE_ATOMIC] = 0;
+	stat_dec_atomic_write(inode);
+}
+
+void f2fs_drop_inmem_page(struct inode *inode, struct page *page)
+{
+	struct f2fs_inode_info *fi = F2FS_I(inode);
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+	struct list_head *head = &fi->inmem_pages;
+	struct inmem_pages *cur = NULL;
+
+	f2fs_bug_on(sbi, !IS_ATOMIC_WRITTEN_PAGE(page));
 
 	mutex_lock(&fi->inmem_lock);
-	__revoke_inmem_pages(inode, &fi->inmem_pages, true, false);
+	list_for_each_entry(cur, head, list) {
+		if (cur->page == page)
+			break;
+	}
+
+	f2fs_bug_on(sbi, list_empty(head) || cur->page != page);
+	list_del(&cur->list);
 	mutex_unlock(&fi->inmem_lock);
+
+	dec_page_count(sbi, F2FS_INMEM_PAGES);
+	kmem_cache_free(inmem_entry_slab, cur);
+
+	ClearPageUptodate(page);
+	set_page_private(page, 0);
+	ClearPagePrivate(page);
+	f2fs_put_page(page, 0);
+
+	trace_f2fs_commit_inmem_page(page, INMEM_INVALIDATE);
 }
 
-static int __commit_inmem_pages(struct inode *inode,
-					struct list_head *revoke_list)
+static int __f2fs_commit_inmem_pages(struct inode *inode)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	struct f2fs_inode_info *fi = F2FS_I(inode);
 	struct inmem_pages *cur, *tmp;
 	struct f2fs_io_info fio = {
 		.sbi = sbi,
+		.ino = inode->i_ino,
 		.type = DATA,
 		.op = REQ_OP_WRITE,
-		.op_flags = WRITE_SYNC | REQ_PRIO,
-		.encrypted_page = NULL,
+		.op_flags = REQ_SYNC | REQ_PRIO,
+		.io_type = FS_DATA_IO,
 	};
-	bool submit_bio = false;
+	struct list_head revoke_list;
+	pgoff_t last_idx = ULONG_MAX;
 	int err = 0;
 
+	INIT_LIST_HEAD(&revoke_list);
+
 	list_for_each_entry_safe(cur, tmp, &fi->inmem_pages, list) {
 		struct page *page = cur->page;
 
@@ -276,67 +382,78 @@ static int __commit_inmem_pages(struct inode *inode,
 
 			set_page_dirty(page);
 			f2fs_wait_on_page_writeback(page, DATA, true);
-			if (clear_page_dirty_for_io(page))
+			if (clear_page_dirty_for_io(page)) {
 				inode_dec_dirty_pages(inode);
-
+				f2fs_remove_dirty_inode(inode);
+			}
+retry:
 			fio.page = page;
-			err = do_write_data_page(&fio);
+			fio.old_blkaddr = NULL_ADDR;
+			fio.encrypted_page = NULL;
+			fio.need_lock = LOCK_DONE;
+			err = f2fs_do_write_data_page(&fio);
 			if (err) {
+				if (err == -ENOMEM) {
+					congestion_wait(BLK_RW_ASYNC, HZ/50);
+					cond_resched();
+					goto retry;
+				}
 				unlock_page(page);
 				break;
 			}
-
 			/* record old blkaddr for revoking */
 			cur->old_addr = fio.old_blkaddr;
-
-			clear_cold_data(page);
-			submit_bio = true;
+			last_idx = page->index;
 		}
 		unlock_page(page);
-		list_move_tail(&cur->list, revoke_list);
+		list_move_tail(&cur->list, &revoke_list);
 	}
 
-	if (submit_bio)
-		f2fs_submit_merged_bio_cond(sbi, inode, NULL, 0, DATA, WRITE);
+	if (last_idx != ULONG_MAX)
+		f2fs_submit_merged_write_cond(sbi, inode, 0, last_idx, DATA);
 
-	if (!err)
-		__revoke_inmem_pages(inode, revoke_list, false, false);
+	if (err) {
+		/*
+		 * try to revoke all committed pages, but still we could fail
+		 * due to no memory or other reason, if that happened, EAGAIN
+		 * will be returned, which means in such case, transaction is
+		 * already not integrity, caller should use journal to do the
+		 * recovery or rewrite & commit last transaction. For other
+		 * error number, revoking was done by filesystem itself.
+		 */
+		err = __revoke_inmem_pages(inode, &revoke_list, false, true);
+
+		/* drop all uncommitted pages */
+		__revoke_inmem_pages(inode, &fi->inmem_pages, true, false);
+	} else {
+		__revoke_inmem_pages(inode, &revoke_list, false, false);
+	}
 
 	return err;
 }
 
-int commit_inmem_pages(struct inode *inode)
+int f2fs_commit_inmem_pages(struct inode *inode)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	struct f2fs_inode_info *fi = F2FS_I(inode);
-	struct list_head revoke_list;
 	int err;
 
-	INIT_LIST_HEAD(&revoke_list);
 	f2fs_balance_fs(sbi, true);
 	f2fs_lock_op(sbi);
 
+	set_inode_flag(inode, FI_ATOMIC_COMMIT);
+
 	mutex_lock(&fi->inmem_lock);
-	err = __commit_inmem_pages(inode, &revoke_list);
-	if (err) {
-		int ret;
-		/*
-		 * try to revoke all committed pages, but still we could fail
-		 * due to no memory or other reason, if that happened, EAGAIN
-		 * will be returned, which means in such case, transaction is
-		 * already not integrity, caller should use journal to do the
-		 * recovery or rewrite & commit last transaction. For other
-		 * error number, revoking was done by filesystem itself.
-		 */
-		ret = __revoke_inmem_pages(inode, &revoke_list, false, true);
-		if (ret)
-			err = ret;
+	err = __f2fs_commit_inmem_pages(inode);
 
-		/* drop all uncommitted pages */
-		__revoke_inmem_pages(inode, &fi->inmem_pages, true, false);
-	}
+	spin_lock(&sbi->inode_lock[ATOMIC_FILE]);
+	if (!list_empty(&fi->inmem_ilist))
+		list_del_init(&fi->inmem_ilist);
+	spin_unlock(&sbi->inode_lock[ATOMIC_FILE]);
 	mutex_unlock(&fi->inmem_lock);
 
+	clear_inode_flag(inode, FI_ATOMIC_COMMIT);
+
 	f2fs_unlock_op(sbi);
 	return err;
 }
@@ -348,15 +465,14 @@ int commit_inmem_pages(struct inode *inode)
 void f2fs_balance_fs(struct f2fs_sb_info *sbi, bool need)
 {
 #ifdef CONFIG_F2FS_FAULT_INJECTION
-	if (time_to_inject(sbi, FAULT_CHECKPOINT))
+	if (time_to_inject(sbi, FAULT_CHECKPOINT)) {
+		f2fs_show_injection_info(FAULT_CHECKPOINT);
 		f2fs_stop_checkpoint(sbi, false);
+	}
 #endif
 
-	if (!need)
-		return;
-
 	/* balance_fs_bg is able to be pending */
-	if (excess_cached_nats(sbi))
+	if (need && excess_cached_nats(sbi))
 		f2fs_balance_fs_bg(sbi);
 
 	/*
@@ -365,7 +481,7 @@ void f2fs_balance_fs(struct f2fs_sb_info *sbi, bool need)
 	 */
 	if (has_not_enough_free_secs(sbi, 0, 0)) {
 		mutex_lock(&sbi->gc_mutex);
-		f2fs_gc(sbi, false);
+		f2fs_gc(sbi, false, false, NULL_SEGNO);
 	}
 }
 
@@ -375,29 +491,32 @@ void f2fs_balance_fs_bg(struct f2fs_sb_info *sbi)
 		return;
 
 	/* try to shrink extent cache when there is no enough memory */
-	if (!available_free_memory(sbi, EXTENT_CACHE))
+	if (!f2fs_available_free_memory(sbi, EXTENT_CACHE))
 		f2fs_shrink_extent_tree(sbi, EXTENT_CACHE_SHRINK_NUMBER);
 
 	/* check the # of cached NAT entries */
-	if (!available_free_memory(sbi, NAT_ENTRIES))
-		try_to_free_nats(sbi, NAT_ENTRY_PER_BLOCK);
+	if (!f2fs_available_free_memory(sbi, NAT_ENTRIES))
+		f2fs_try_to_free_nats(sbi, NAT_ENTRY_PER_BLOCK);
 
-	if (!available_free_memory(sbi, FREE_NIDS))
-		try_to_free_nids(sbi, MAX_FREE_NIDS);
+	if (!f2fs_available_free_memory(sbi, FREE_NIDS))
+		f2fs_try_to_free_nids(sbi, MAX_FREE_NIDS);
 	else
-		build_free_nids(sbi);
+		f2fs_build_free_nids(sbi, false, false);
+
+	if (!is_idle(sbi) && !excess_dirty_nats(sbi))
+		return;
 
 	/* checkpoint is the only way to shrink partial cached entries */
-	if (!available_free_memory(sbi, NAT_ENTRIES) ||
-			!available_free_memory(sbi, INO_ENTRIES) ||
+	if (!f2fs_available_free_memory(sbi, NAT_ENTRIES) ||
+			!f2fs_available_free_memory(sbi, INO_ENTRIES) ||
 			excess_prefree_segs(sbi) ||
 			excess_dirty_nats(sbi) ||
-			(is_idle(sbi) && f2fs_time_over(sbi, CP_TIME))) {
+			f2fs_time_over(sbi, CP_TIME)) {
 		if (test_opt(sbi, DATA_FLUSH)) {
 			struct blk_plug plug;
 
 			blk_start_plug(&plug);
-			sync_dirty_inodes(sbi, FILE_INODE);
+			f2fs_sync_dirty_inodes(sbi, FILE_INODE);
 			blk_finish_plug(&plug);
 		}
 		f2fs_sync_fs(sbi->sb, true);
@@ -405,114 +524,215 @@ void f2fs_balance_fs_bg(struct f2fs_sb_info *sbi)
 	}
 }
 
+static int __submit_flush_wait(struct f2fs_sb_info *sbi,
+				struct block_device *bdev)
+{
+	struct bio *bio = f2fs_bio_alloc(sbi, 0, true);
+	int ret;
+
+	bio->bi_opf = REQ_OP_WRITE | REQ_SYNC | REQ_PREFLUSH;
+	bio->bi_bdev = bdev;
+	ret = submit_bio_wait(bio);
+	bio_put(bio);
+
+	trace_f2fs_issue_flush(bdev, test_opt(sbi, NOBARRIER),
+				test_opt(sbi, FLUSH_MERGE), ret);
+	return ret;
+}
+
+static int submit_flush_wait(struct f2fs_sb_info *sbi, nid_t ino)
+{
+	int ret = 0;
+	int i;
+
+	if (!sbi->s_ndevs)
+		return __submit_flush_wait(sbi, sbi->sb->s_bdev);
+
+	for (i = 0; i < sbi->s_ndevs; i++) {
+		if (!f2fs_is_dirty_device(sbi, ino, i, FLUSH_INO))
+			continue;
+		ret = __submit_flush_wait(sbi, FDEV(i).bdev);
+		if (ret)
+			break;
+	}
+	return ret;
+}
+
 static int issue_flush_thread(void *data)
 {
 	struct f2fs_sb_info *sbi = data;
-	struct flush_cmd_control *fcc = SM_I(sbi)->cmd_control_info;
+	struct flush_cmd_control *fcc = SM_I(sbi)->fcc_info;
 	wait_queue_head_t *q = &fcc->flush_wait_queue;
 repeat:
 	if (kthread_should_stop())
 		return 0;
 
+	sb_start_intwrite(sbi->sb);
+
 	if (!llist_empty(&fcc->issue_list)) {
-		struct bio *bio;
 		struct flush_cmd *cmd, *next;
 		int ret;
 
-		bio = f2fs_bio_alloc(0);
-
 		fcc->dispatch_list = llist_del_all(&fcc->issue_list);
 		fcc->dispatch_list = llist_reverse_order(fcc->dispatch_list);
 
-		bio->bi_bdev = sbi->sb->s_bdev;
-		bio_set_op_attrs(bio, REQ_OP_WRITE, WRITE_FLUSH);
-		ret = submit_bio_wait(bio);
+		cmd = llist_entry(fcc->dispatch_list, struct flush_cmd, llnode);
+
+		ret = submit_flush_wait(sbi, cmd->ino);
+		atomic_inc(&fcc->issued_flush);
 
 		llist_for_each_entry_safe(cmd, next,
 					  fcc->dispatch_list, llnode) {
 			cmd->ret = ret;
 			complete(&cmd->wait);
 		}
-		bio_put(bio);
 		fcc->dispatch_list = NULL;
 	}
 
+	sb_end_intwrite(sbi->sb);
+
 	wait_event_interruptible(*q,
 		kthread_should_stop() || !llist_empty(&fcc->issue_list));
 	goto repeat;
 }
 
-int f2fs_issue_flush(struct f2fs_sb_info *sbi)
+int f2fs_issue_flush(struct f2fs_sb_info *sbi, nid_t ino)
 {
-	struct flush_cmd_control *fcc = SM_I(sbi)->cmd_control_info;
+	struct flush_cmd_control *fcc = SM_I(sbi)->fcc_info;
 	struct flush_cmd cmd;
-
-	trace_f2fs_issue_flush(sbi->sb, test_opt(sbi, NOBARRIER),
-					test_opt(sbi, FLUSH_MERGE));
+	int ret;
 
 	if (test_opt(sbi, NOBARRIER))
 		return 0;
 
-	if (!test_opt(sbi, FLUSH_MERGE) || !atomic_read(&fcc->submit_flush)) {
-		struct bio *bio = f2fs_bio_alloc(0);
-		int ret;
+	if (!test_opt(sbi, FLUSH_MERGE)) {
+		ret = submit_flush_wait(sbi, ino);
+		atomic_inc(&fcc->issued_flush);
+		return ret;
+	}
 
-		atomic_inc(&fcc->submit_flush);
-		bio->bi_bdev = sbi->sb->s_bdev;
-		bio_set_op_attrs(bio, REQ_OP_WRITE, WRITE_FLUSH);
-		ret = submit_bio_wait(bio);
-		atomic_dec(&fcc->submit_flush);
-		bio_put(bio);
+	if (atomic_inc_return(&fcc->issing_flush) == 1 || sbi->s_ndevs > 1) {
+		ret = submit_flush_wait(sbi, ino);
+		atomic_dec(&fcc->issing_flush);
+
+		atomic_inc(&fcc->issued_flush);
 		return ret;
 	}
 
+	cmd.ino = ino;
 	init_completion(&cmd.wait);
 
-	atomic_inc(&fcc->submit_flush);
 	llist_add(&cmd.llnode, &fcc->issue_list);
 
-	if (!fcc->dispatch_list)
+	/* update issue_list before we wake up issue_flush thread */
+	smp_mb();
+
+	if (waitqueue_active(&fcc->flush_wait_queue))
 		wake_up(&fcc->flush_wait_queue);
 
-	wait_for_completion(&cmd.wait);
-	atomic_dec(&fcc->submit_flush);
+	if (fcc->f2fs_issue_flush) {
+		wait_for_completion(&cmd.wait);
+		atomic_dec(&fcc->issing_flush);
+	} else {
+		struct llist_node *list;
+
+		list = llist_del_all(&fcc->issue_list);
+		if (!list) {
+			wait_for_completion(&cmd.wait);
+			atomic_dec(&fcc->issing_flush);
+		} else {
+			struct flush_cmd *tmp, *next;
+
+			ret = submit_flush_wait(sbi, ino);
+
+			llist_for_each_entry_safe(tmp, next, list, llnode) {
+				if (tmp == &cmd) {
+					cmd.ret = ret;
+					atomic_dec(&fcc->issing_flush);
+					continue;
+				}
+				tmp->ret = ret;
+				complete(&tmp->wait);
+			}
+		}
+	}
 
 	return cmd.ret;
 }
 
-int create_flush_cmd_control(struct f2fs_sb_info *sbi)
+int f2fs_create_flush_cmd_control(struct f2fs_sb_info *sbi)
 {
 	dev_t dev = sbi->sb->s_bdev->bd_dev;
 	struct flush_cmd_control *fcc;
 	int err = 0;
 
-	fcc = kzalloc(sizeof(struct flush_cmd_control), GFP_KERNEL);
+	if (SM_I(sbi)->fcc_info) {
+		fcc = SM_I(sbi)->fcc_info;
+		if (fcc->f2fs_issue_flush)
+			return err;
+		goto init_thread;
+	}
+
+	fcc = f2fs_kzalloc(sbi, sizeof(struct flush_cmd_control), GFP_KERNEL);
 	if (!fcc)
 		return -ENOMEM;
-	atomic_set(&fcc->submit_flush, 0);
+	atomic_set(&fcc->issued_flush, 0);
+	atomic_set(&fcc->issing_flush, 0);
 	init_waitqueue_head(&fcc->flush_wait_queue);
 	init_llist_head(&fcc->issue_list);
-	SM_I(sbi)->cmd_control_info = fcc;
+	SM_I(sbi)->fcc_info = fcc;
+	if (!test_opt(sbi, FLUSH_MERGE))
+		return err;
+
+init_thread:
 	fcc->f2fs_issue_flush = kthread_run(issue_flush_thread, sbi,
 				"f2fs_flush-%u:%u", MAJOR(dev), MINOR(dev));
 	if (IS_ERR(fcc->f2fs_issue_flush)) {
 		err = PTR_ERR(fcc->f2fs_issue_flush);
 		kfree(fcc);
-		SM_I(sbi)->cmd_control_info = NULL;
+		SM_I(sbi)->fcc_info = NULL;
 		return err;
 	}
 
 	return err;
 }
 
-void destroy_flush_cmd_control(struct f2fs_sb_info *sbi)
+void f2fs_destroy_flush_cmd_control(struct f2fs_sb_info *sbi, bool free)
 {
-	struct flush_cmd_control *fcc = SM_I(sbi)->cmd_control_info;
+	struct flush_cmd_control *fcc = SM_I(sbi)->fcc_info;
+
+	if (fcc && fcc->f2fs_issue_flush) {
+		struct task_struct *flush_thread = fcc->f2fs_issue_flush;
 
-	if (fcc && fcc->f2fs_issue_flush)
-		kthread_stop(fcc->f2fs_issue_flush);
-	kfree(fcc);
-	SM_I(sbi)->cmd_control_info = NULL;
+		fcc->f2fs_issue_flush = NULL;
+		kthread_stop(flush_thread);
+	}
+	if (free) {
+		kfree(fcc);
+		SM_I(sbi)->fcc_info = NULL;
+	}
+}
+
+int f2fs_flush_device_cache(struct f2fs_sb_info *sbi)
+{
+	int ret = 0, i;
+
+	if (!sbi->s_ndevs)
+		return 0;
+
+	for (i = 1; i < sbi->s_ndevs; i++) {
+		if (!f2fs_test_bit(i, (char *)&sbi->dirty_device))
+			continue;
+		ret = __submit_flush_wait(sbi, FDEV(i).bdev);
+		if (ret)
+			break;
+
+		spin_lock(&sbi->dev_lock);
+		f2fs_clear_bit(i, (char *)&sbi->dirty_device);
+		spin_unlock(&sbi->dev_lock);
+	}
+
+	return ret;
 }
 
 static void __locate_dirty_segment(struct f2fs_sb_info *sbi, unsigned int segno,
@@ -555,8 +775,8 @@ static void __remove_dirty_segment(struct f2fs_sb_info *sbi, unsigned int segno,
 		if (test_and_clear_bit(segno, dirty_i->dirty_segmap[t]))
 			dirty_i->nr_dirty[t]--;
 
-		if (get_valid_blocks(sbi, segno, sbi->segs_per_sec) == 0)
-			clear_bit(GET_SECNO(sbi, segno),
+		if (get_valid_blocks(sbi, segno, true) == 0)
+			clear_bit(GET_SEC_FROM_SEG(sbi, segno),
 						dirty_i->victim_secmap);
 	}
 }
@@ -576,7 +796,7 @@ static void locate_dirty_segment(struct f2fs_sb_info *sbi, unsigned int segno)
 
 	mutex_lock(&dirty_i->seglist_lock);
 
-	valid_blocks = get_valid_blocks(sbi, segno, 0);
+	valid_blocks = get_valid_blocks(sbi, segno, false);
 
 	if (valid_blocks == 0) {
 		__locate_dirty_segment(sbi, segno, PRE);
@@ -591,120 +811,739 @@ static void locate_dirty_segment(struct f2fs_sb_info *sbi, unsigned int segno)
 	mutex_unlock(&dirty_i->seglist_lock);
 }
 
-static struct bio_entry *__add_bio_entry(struct f2fs_sb_info *sbi,
-							struct bio *bio)
+static struct discard_cmd *__create_discard_cmd(struct f2fs_sb_info *sbi,
+		struct block_device *bdev, block_t lstart,
+		block_t start, block_t len)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct list_head *pend_list;
+	struct discard_cmd *dc;
+
+	f2fs_bug_on(sbi, !len);
+
+	pend_list = &dcc->pend_list[plist_idx(len)];
+
+	dc = f2fs_kmem_cache_alloc(discard_cmd_slab, GFP_NOFS);
+	INIT_LIST_HEAD(&dc->list);
+	dc->bdev = bdev;
+	dc->lstart = lstart;
+	dc->start = start;
+	dc->len = len;
+	dc->ref = 0;
+	dc->state = D_PREP;
+	dc->error = 0;
+	init_completion(&dc->wait);
+	list_add_tail(&dc->list, pend_list);
+	atomic_inc(&dcc->discard_cmd_cnt);
+	dcc->undiscard_blks += len;
+
+	return dc;
+}
+
+static struct discard_cmd *__attach_discard_cmd(struct f2fs_sb_info *sbi,
+				struct block_device *bdev, block_t lstart,
+				block_t start, block_t len,
+				struct rb_node *parent, struct rb_node **p)
 {
-	struct list_head *wait_list = &(SM_I(sbi)->wait_list);
-	struct bio_entry *be = f2fs_kmem_cache_alloc(bio_entry_slab, GFP_NOFS);
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct discard_cmd *dc;
+
+	dc = __create_discard_cmd(sbi, bdev, lstart, start, len);
 
-	INIT_LIST_HEAD(&be->list);
-	be->bio = bio;
-	init_completion(&be->event);
-	list_add_tail(&be->list, wait_list);
+	rb_link_node(&dc->rb_node, parent, p);
+	rb_insert_color(&dc->rb_node, &dcc->root);
 
-	return be;
+	return dc;
 }
 
-void f2fs_wait_all_discard_bio(struct f2fs_sb_info *sbi)
+static void __detach_discard_cmd(struct discard_cmd_control *dcc,
+							struct discard_cmd *dc)
 {
-	struct list_head *wait_list = &(SM_I(sbi)->wait_list);
-	struct bio_entry *be, *tmp;
+	if (dc->state == D_DONE)
+		atomic_dec(&dcc->issing_discard);
 
-	list_for_each_entry_safe(be, tmp, wait_list, list) {
-		struct bio *bio = be->bio;
-		int err;
+	list_del(&dc->list);
+	rb_erase(&dc->rb_node, &dcc->root);
+	dcc->undiscard_blks -= dc->len;
 
-		wait_for_completion_io(&be->event);
-		err = be->error;
-		if (err == -EOPNOTSUPP)
-			err = 0;
+	kmem_cache_free(discard_cmd_slab, dc);
 
-		if (err)
-			f2fs_msg(sbi->sb, KERN_INFO,
-				"Issue discard failed, ret: %d", err);
+	atomic_dec(&dcc->discard_cmd_cnt);
+}
 
-		bio_put(bio);
-		list_del(&be->list);
-		kmem_cache_free(bio_entry_slab, be);
-	}
+static void __remove_discard_cmd(struct f2fs_sb_info *sbi,
+							struct discard_cmd *dc)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+
+	trace_f2fs_remove_discard(dc->bdev, dc->start, dc->len);
+
+	f2fs_bug_on(sbi, dc->ref);
+
+	if (dc->error == -EOPNOTSUPP)
+		dc->error = 0;
+
+	if (dc->error)
+		f2fs_msg(sbi->sb, KERN_INFO,
+			"Issue discard(%u, %u, %u) failed, ret: %d",
+			dc->lstart, dc->start, dc->len, dc->error);
+	__detach_discard_cmd(dcc, dc);
 }
 
-static void f2fs_submit_bio_wait_endio(struct bio *bio)
+static void f2fs_submit_discard_endio(struct bio *bio)
 {
-	struct bio_entry *be = (struct bio_entry *)bio->bi_private;
+	struct discard_cmd *dc = (struct discard_cmd *)bio->bi_private;
 
-	be->error = bio->bi_error;
-	complete(&be->event);
+	dc->error = bio->bi_error;
+	dc->state = D_DONE;
+	complete_all(&dc->wait);
+	bio_put(bio);
 }
 
+static void __check_sit_bitmap(struct f2fs_sb_info *sbi,
+				block_t start, block_t end)
+{
+#ifdef CONFIG_F2FS_CHECK_FS
+	struct seg_entry *sentry;
+	unsigned int segno;
+	block_t blk = start;
+	unsigned long offset, size, max_blocks = sbi->blocks_per_seg;
+	unsigned long *map;
+
+	while (blk < end) {
+		segno = GET_SEGNO(sbi, blk);
+		sentry = get_seg_entry(sbi, segno);
+		offset = GET_BLKOFF_FROM_SEG0(sbi, blk);
+
+		if (end < START_BLOCK(sbi, segno + 1))
+			size = GET_BLKOFF_FROM_SEG0(sbi, end);
+		else
+			size = max_blocks;
+		map = (unsigned long *)(sentry->cur_valid_map);
+		offset = __find_rev_next_bit(map, size, offset);
+		f2fs_bug_on(sbi, offset != size);
+		blk = START_BLOCK(sbi, segno + 1);
+	}
+#endif
+}
+
+static void __init_discard_policy(struct f2fs_sb_info *sbi,
+				struct discard_policy *dpolicy,
+				int discard_type, unsigned int granularity)
+{
+	/* common policy */
+	dpolicy->type = discard_type;
+	dpolicy->sync = true;
+	dpolicy->granularity = granularity;
+
+	dpolicy->max_requests = DEF_MAX_DISCARD_REQUEST;
+	dpolicy->io_aware_gran = MAX_PLIST_NUM;
+
+	if (discard_type == DPOLICY_BG) {
+		dpolicy->min_interval = DEF_MIN_DISCARD_ISSUE_TIME;
+		dpolicy->mid_interval = DEF_MID_DISCARD_ISSUE_TIME;
+		dpolicy->max_interval = DEF_MAX_DISCARD_ISSUE_TIME;
+		dpolicy->io_aware = true;
+		dpolicy->sync = false;
+		if (utilization(sbi) > DEF_DISCARD_URGENT_UTIL) {
+			dpolicy->granularity = 1;
+			dpolicy->max_interval = DEF_MIN_DISCARD_ISSUE_TIME;
+		}
+	} else if (discard_type == DPOLICY_FORCE) {
+		dpolicy->min_interval = DEF_MIN_DISCARD_ISSUE_TIME;
+		dpolicy->mid_interval = DEF_MID_DISCARD_ISSUE_TIME;
+		dpolicy->max_interval = DEF_MAX_DISCARD_ISSUE_TIME;
+		dpolicy->io_aware = false;
+	} else if (discard_type == DPOLICY_FSTRIM) {
+		dpolicy->io_aware = false;
+	} else if (discard_type == DPOLICY_UMOUNT) {
+		dpolicy->max_requests = UINT_MAX;
+		dpolicy->io_aware = false;
+	}
+}
+
+
 /* this function is copied from blkdev_issue_discard from block/blk-lib.c */
-int __f2fs_issue_discard_async(struct f2fs_sb_info *sbi, sector_t sector,
-		sector_t nr_sects, gfp_t gfp_mask, unsigned long flags)
+static void __submit_discard_cmd(struct f2fs_sb_info *sbi,
+						struct discard_policy *dpolicy,
+						struct discard_cmd *dc)
 {
-	struct block_device *bdev = sbi->sb->s_bdev;
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct list_head *wait_list = (dpolicy->type == DPOLICY_FSTRIM) ?
+					&(dcc->fstrim_list) : &(dcc->wait_list);
 	struct bio *bio = NULL;
-	int err;
+	int flag = dpolicy->sync ? REQ_SYNC : 0;
 
-	err = __blkdev_issue_discard(bdev, sector, nr_sects, gfp_mask, flags,
-			&bio);
-	if (!err && bio) {
-		struct bio_entry *be = __add_bio_entry(sbi, bio);
+	if (dc->state != D_PREP)
+		return;
+
+	if (is_sbi_flag_set(sbi, SBI_NEED_FSCK))
+		return;
 
-		bio->bi_private = be;
-		bio->bi_end_io = f2fs_submit_bio_wait_endio;
-		bio->bi_opf |= REQ_SYNC;
-		submit_bio(bio);
+	trace_f2fs_issue_discard(dc->bdev, dc->start, dc->len);
+
+	dc->error = __blkdev_issue_discard(dc->bdev,
+				SECTOR_FROM_BLOCK(dc->start),
+				SECTOR_FROM_BLOCK(dc->len),
+				GFP_NOFS, 0, &bio);
+	if (!dc->error) {
+		/* should keep before submission to avoid D_DONE right away */
+		dc->state = D_SUBMIT;
+		atomic_inc(&dcc->issued_discard);
+		atomic_inc(&dcc->issing_discard);
+		if (bio) {
+			bio->bi_private = dc;
+			bio->bi_end_io = f2fs_submit_discard_endio;
+			bio->bi_opf |= flag;
+			submit_bio(bio);
+			list_move_tail(&dc->list, wait_list);
+			__check_sit_bitmap(sbi, dc->start, dc->start + dc->len);
+
+			f2fs_update_iostat(sbi, FS_DISCARD, 1);
+		}
+	} else {
+		__remove_discard_cmd(sbi, dc);
 	}
+}
 
-	return err;
+static struct discard_cmd *__insert_discard_tree(struct f2fs_sb_info *sbi,
+				struct block_device *bdev, block_t lstart,
+				block_t start, block_t len,
+				struct rb_node **insert_p,
+				struct rb_node *insert_parent)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct rb_node **p;
+	struct rb_node *parent = NULL;
+	struct discard_cmd *dc = NULL;
+
+	if (insert_p && insert_parent) {
+		parent = insert_parent;
+		p = insert_p;
+		goto do_insert;
+	}
+
+	p = f2fs_lookup_rb_tree_for_insert(sbi, &dcc->root, &parent, lstart);
+do_insert:
+	dc = __attach_discard_cmd(sbi, bdev, lstart, start, len, parent, p);
+	if (!dc)
+		return NULL;
+
+	return dc;
+}
+
+static void __relocate_discard_cmd(struct discard_cmd_control *dcc,
+						struct discard_cmd *dc)
+{
+	list_move_tail(&dc->list, &dcc->pend_list[plist_idx(dc->len)]);
+}
+
+static void __punch_discard_cmd(struct f2fs_sb_info *sbi,
+				struct discard_cmd *dc, block_t blkaddr)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct discard_info di = dc->di;
+	bool modified = false;
+
+	if (dc->state == D_DONE || dc->len == 1) {
+		__remove_discard_cmd(sbi, dc);
+		return;
+	}
+
+	dcc->undiscard_blks -= di.len;
+
+	if (blkaddr > di.lstart) {
+		dc->len = blkaddr - dc->lstart;
+		dcc->undiscard_blks += dc->len;
+		__relocate_discard_cmd(dcc, dc);
+		modified = true;
+	}
+
+	if (blkaddr < di.lstart + di.len - 1) {
+		if (modified) {
+			__insert_discard_tree(sbi, dc->bdev, blkaddr + 1,
+					di.start + blkaddr + 1 - di.lstart,
+					di.lstart + di.len - 1 - blkaddr,
+					NULL, NULL);
+		} else {
+			dc->lstart++;
+			dc->len--;
+			dc->start++;
+			dcc->undiscard_blks += dc->len;
+			__relocate_discard_cmd(dcc, dc);
+		}
+	}
+}
+
+static void __update_discard_tree_range(struct f2fs_sb_info *sbi,
+				struct block_device *bdev, block_t lstart,
+				block_t start, block_t len)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct discard_cmd *prev_dc = NULL, *next_dc = NULL;
+	struct discard_cmd *dc;
+	struct discard_info di = {0};
+	struct rb_node **insert_p = NULL, *insert_parent = NULL;
+	block_t end = lstart + len;
+
+	mutex_lock(&dcc->cmd_lock);
+
+	dc = (struct discard_cmd *)f2fs_lookup_rb_tree_ret(&dcc->root,
+					NULL, lstart,
+					(struct rb_entry **)&prev_dc,
+					(struct rb_entry **)&next_dc,
+					&insert_p, &insert_parent, true);
+	if (dc)
+		prev_dc = dc;
+
+	if (!prev_dc) {
+		di.lstart = lstart;
+		di.len = next_dc ? next_dc->lstart - lstart : len;
+		di.len = min(di.len, len);
+		di.start = start;
+	}
+
+	while (1) {
+		struct rb_node *node;
+		bool merged = false;
+		struct discard_cmd *tdc = NULL;
+
+		if (prev_dc) {
+			di.lstart = prev_dc->lstart + prev_dc->len;
+			if (di.lstart < lstart)
+				di.lstart = lstart;
+			if (di.lstart >= end)
+				break;
+
+			if (!next_dc || next_dc->lstart > end)
+				di.len = end - di.lstart;
+			else
+				di.len = next_dc->lstart - di.lstart;
+			di.start = start + di.lstart - lstart;
+		}
+
+		if (!di.len)
+			goto next;
+
+		if (prev_dc && prev_dc->state == D_PREP &&
+			prev_dc->bdev == bdev &&
+			__is_discard_back_mergeable(&di, &prev_dc->di)) {
+			prev_dc->di.len += di.len;
+			dcc->undiscard_blks += di.len;
+			__relocate_discard_cmd(dcc, prev_dc);
+			di = prev_dc->di;
+			tdc = prev_dc;
+			merged = true;
+		}
+
+		if (next_dc && next_dc->state == D_PREP &&
+			next_dc->bdev == bdev &&
+			__is_discard_front_mergeable(&di, &next_dc->di)) {
+			next_dc->di.lstart = di.lstart;
+			next_dc->di.len += di.len;
+			next_dc->di.start = di.start;
+			dcc->undiscard_blks += di.len;
+			__relocate_discard_cmd(dcc, next_dc);
+			if (tdc)
+				__remove_discard_cmd(sbi, tdc);
+			merged = true;
+		}
+
+		if (!merged) {
+			__insert_discard_tree(sbi, bdev, di.lstart, di.start,
+							di.len, NULL, NULL);
+		}
+ next:
+		prev_dc = next_dc;
+		if (!prev_dc)
+			break;
+
+		node = rb_next(&prev_dc->rb_node);
+		next_dc = rb_entry_safe(node, struct discard_cmd, rb_node);
+	}
+
+	mutex_unlock(&dcc->cmd_lock);
+}
+
+static int __queue_discard_cmd(struct f2fs_sb_info *sbi,
+		struct block_device *bdev, block_t blkstart, block_t blklen)
+{
+	block_t lblkstart = blkstart;
+
+	trace_f2fs_queue_discard(bdev, blkstart, blklen);
+
+	if (sbi->s_ndevs) {
+		int devi = f2fs_target_device_index(sbi, blkstart);
+
+		blkstart -= FDEV(devi).start_blk;
+	}
+	__update_discard_tree_range(sbi, bdev, lblkstart, blkstart, blklen);
+	return 0;
+}
+
+static int __issue_discard_cmd(struct f2fs_sb_info *sbi,
+					struct discard_policy *dpolicy)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct list_head *pend_list;
+	struct discard_cmd *dc, *tmp;
+	struct blk_plug plug;
+	int i, iter = 0, issued = 0;
+	bool io_interrupted = false;
+
+	for (i = MAX_PLIST_NUM - 1; i >= 0; i--) {
+		if (i + 1 < dpolicy->granularity)
+			break;
+		pend_list = &dcc->pend_list[i];
+
+		mutex_lock(&dcc->cmd_lock);
+		if (list_empty(pend_list))
+			goto next;
+		f2fs_bug_on(sbi,
+			!f2fs_check_rb_tree_consistence(sbi, &dcc->root));
+		blk_start_plug(&plug);
+		list_for_each_entry_safe(dc, tmp, pend_list, list) {
+			f2fs_bug_on(sbi, dc->state != D_PREP);
+
+			if (dpolicy->io_aware && i < dpolicy->io_aware_gran &&
+								!is_idle(sbi)) {
+				io_interrupted = true;
+				goto skip;
+			}
+
+			__submit_discard_cmd(sbi, dpolicy, dc);
+			issued++;
+skip:
+			if (++iter >= dpolicy->max_requests)
+				break;
+		}
+		blk_finish_plug(&plug);
+next:
+		mutex_unlock(&dcc->cmd_lock);
+
+		if (iter >= dpolicy->max_requests)
+			break;
+	}
+
+	if (!issued && io_interrupted)
+		issued = -1;
+
+	return issued;
+}
+
+static bool __drop_discard_cmd(struct f2fs_sb_info *sbi)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct list_head *pend_list;
+	struct discard_cmd *dc, *tmp;
+	int i;
+	bool dropped = false;
+
+	mutex_lock(&dcc->cmd_lock);
+	for (i = MAX_PLIST_NUM - 1; i >= 0; i--) {
+		pend_list = &dcc->pend_list[i];
+		list_for_each_entry_safe(dc, tmp, pend_list, list) {
+			f2fs_bug_on(sbi, dc->state != D_PREP);
+			__remove_discard_cmd(sbi, dc);
+			dropped = true;
+		}
+	}
+	mutex_unlock(&dcc->cmd_lock);
+
+	return dropped;
+}
+
+void f2fs_drop_discard_cmd(struct f2fs_sb_info *sbi)
+{
+	__drop_discard_cmd(sbi);
+}
+
+static unsigned int __wait_one_discard_bio(struct f2fs_sb_info *sbi,
+							struct discard_cmd *dc)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	unsigned int len = 0;
+
+	wait_for_completion_io(&dc->wait);
+	mutex_lock(&dcc->cmd_lock);
+	f2fs_bug_on(sbi, dc->state != D_DONE);
+	dc->ref--;
+	if (!dc->ref) {
+		if (!dc->error)
+			len = dc->len;
+		__remove_discard_cmd(sbi, dc);
+	}
+	mutex_unlock(&dcc->cmd_lock);
+
+	return len;
+}
+
+static unsigned int __wait_discard_cmd_range(struct f2fs_sb_info *sbi,
+						struct discard_policy *dpolicy,
+						block_t start, block_t end)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct list_head *wait_list = (dpolicy->type == DPOLICY_FSTRIM) ?
+					&(dcc->fstrim_list) : &(dcc->wait_list);
+	struct discard_cmd *dc, *tmp;
+	bool need_wait;
+	unsigned int trimmed = 0;
+
+next:
+	need_wait = false;
+
+	mutex_lock(&dcc->cmd_lock);
+	list_for_each_entry_safe(dc, tmp, wait_list, list) {
+		if (dc->lstart + dc->len <= start || end <= dc->lstart)
+			continue;
+		if (dc->len < dpolicy->granularity)
+			continue;
+		if (dc->state == D_DONE && !dc->ref) {
+			wait_for_completion_io(&dc->wait);
+			if (!dc->error)
+				trimmed += dc->len;
+			__remove_discard_cmd(sbi, dc);
+		} else {
+			dc->ref++;
+			need_wait = true;
+			break;
+		}
+	}
+	mutex_unlock(&dcc->cmd_lock);
+
+	if (need_wait) {
+		trimmed += __wait_one_discard_bio(sbi, dc);
+		goto next;
+	}
+
+	return trimmed;
+}
+
+static void __wait_all_discard_cmd(struct f2fs_sb_info *sbi,
+						struct discard_policy *dpolicy)
+{
+	struct discard_policy dp;
+
+	if (dpolicy) {
+		__wait_discard_cmd_range(sbi, dpolicy, 0, UINT_MAX);
+		return;
+	}
+
+	/* wait all */
+	__init_discard_policy(sbi, &dp, DPOLICY_FSTRIM, 1);
+	__wait_discard_cmd_range(sbi, &dp, 0, UINT_MAX);
+	__init_discard_policy(sbi, &dp, DPOLICY_UMOUNT, 1);
+	__wait_discard_cmd_range(sbi, &dp, 0, UINT_MAX);
+}
+
+/* This should be covered by global mutex, &sit_i->sentry_lock */
+static void f2fs_wait_discard_bio(struct f2fs_sb_info *sbi, block_t blkaddr)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct discard_cmd *dc;
+	bool need_wait = false;
+
+	mutex_lock(&dcc->cmd_lock);
+	dc = (struct discard_cmd *)f2fs_lookup_rb_tree(&dcc->root,
+							NULL, blkaddr);
+	if (dc) {
+		if (dc->state == D_PREP) {
+			__punch_discard_cmd(sbi, dc, blkaddr);
+		} else {
+			dc->ref++;
+			need_wait = true;
+		}
+	}
+	mutex_unlock(&dcc->cmd_lock);
+
+	if (need_wait)
+		__wait_one_discard_bio(sbi, dc);
+}
+
+void f2fs_stop_discard_thread(struct f2fs_sb_info *sbi)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+
+	if (dcc && dcc->f2fs_issue_discard) {
+		struct task_struct *discard_thread = dcc->f2fs_issue_discard;
+
+		dcc->f2fs_issue_discard = NULL;
+		kthread_stop(discard_thread);
+	}
+}
+
+/* This comes from f2fs_put_super */
+bool f2fs_wait_discard_bios(struct f2fs_sb_info *sbi)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct discard_policy dpolicy;
+	bool dropped;
+
+	__init_discard_policy(sbi, &dpolicy, DPOLICY_UMOUNT,
+					dcc->discard_granularity);
+	__issue_discard_cmd(sbi, &dpolicy);
+	dropped = __drop_discard_cmd(sbi);
+
+	/* just to make sure there is no pending discard commands */
+	__wait_all_discard_cmd(sbi, NULL);
+	return dropped;
+}
+
+static int issue_discard_thread(void *data)
+{
+	struct f2fs_sb_info *sbi = data;
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	wait_queue_head_t *q = &dcc->discard_wait_queue;
+	struct discard_policy dpolicy;
+	unsigned int wait_ms = DEF_MIN_DISCARD_ISSUE_TIME;
+	int issued;
+
+	set_freezable();
+
+	do {
+		__init_discard_policy(sbi, &dpolicy, DPOLICY_BG,
+					dcc->discard_granularity);
+
+		wait_event_interruptible_timeout(*q,
+				kthread_should_stop() || freezing(current) ||
+				dcc->discard_wake,
+				msecs_to_jiffies(wait_ms));
+
+		if (dcc->discard_wake)
+			dcc->discard_wake = 0;
+
+		if (try_to_freeze())
+			continue;
+		if (f2fs_readonly(sbi->sb))
+			continue;
+		if (kthread_should_stop())
+			return 0;
+		if (is_sbi_flag_set(sbi, SBI_NEED_FSCK)) {
+			wait_ms = dpolicy.max_interval;
+			continue;
+		}
+
+		if (sbi->gc_mode == GC_URGENT)
+			__init_discard_policy(sbi, &dpolicy, DPOLICY_FORCE, 1);
+
+		sb_start_intwrite(sbi->sb);
+
+		issued = __issue_discard_cmd(sbi, &dpolicy);
+		if (issued > 0) {
+			__wait_all_discard_cmd(sbi, &dpolicy);
+			wait_ms = dpolicy.min_interval;
+		} else if (issued == -1){
+			wait_ms = dpolicy.mid_interval;
+		} else {
+			wait_ms = dpolicy.max_interval;
+		}
+
+		sb_end_intwrite(sbi->sb);
+
+	} while (!kthread_should_stop());
+	return 0;
+}
+
+#ifdef CONFIG_BLK_DEV_ZONED
+static int __f2fs_issue_discard_zone(struct f2fs_sb_info *sbi,
+		struct block_device *bdev, block_t blkstart, block_t blklen)
+{
+	sector_t sector, nr_sects;
+	block_t lblkstart = blkstart;
+	int devi = 0;
+
+	if (sbi->s_ndevs) {
+		devi = f2fs_target_device_index(sbi, blkstart);
+		blkstart -= FDEV(devi).start_blk;
+	}
+
+	/*
+	 * We need to know the type of the zone: for conventional zones,
+	 * use regular discard if the drive supports it. For sequential
+	 * zones, reset the zone write pointer.
+	 */
+	switch (get_blkz_type(sbi, bdev, blkstart)) {
+
+	case BLK_ZONE_TYPE_CONVENTIONAL:
+		if (!blk_queue_discard(bdev_get_queue(bdev)))
+			return 0;
+		return __queue_discard_cmd(sbi, bdev, lblkstart, blklen);
+	case BLK_ZONE_TYPE_SEQWRITE_REQ:
+	case BLK_ZONE_TYPE_SEQWRITE_PREF:
+		sector = SECTOR_FROM_BLOCK(blkstart);
+		nr_sects = SECTOR_FROM_BLOCK(blklen);
+
+		if (sector & (bdev_zone_sectors(bdev) - 1) ||
+				nr_sects != bdev_zone_sectors(bdev)) {
+			f2fs_msg(sbi->sb, KERN_INFO,
+				"(%d) %s: Unaligned discard attempted (block %x + %x)",
+				devi, sbi->s_ndevs ? FDEV(devi).path: "",
+				blkstart, blklen);
+			return -EIO;
+		}
+		trace_f2fs_issue_reset_zone(bdev, blkstart);
+		return blkdev_reset_zones(bdev, sector,
+					  nr_sects, GFP_NOFS);
+	default:
+		/* Unknown zone type: broken device ? */
+		return -EIO;
+	}
+}
+#endif
+
+static int __issue_discard_async(struct f2fs_sb_info *sbi,
+		struct block_device *bdev, block_t blkstart, block_t blklen)
+{
+#ifdef CONFIG_BLK_DEV_ZONED
+	if (f2fs_sb_has_blkzoned(sbi->sb) &&
+				bdev_zoned_model(bdev) != BLK_ZONED_NONE)
+		return __f2fs_issue_discard_zone(sbi, bdev, blkstart, blklen);
+#endif
+	return __queue_discard_cmd(sbi, bdev, blkstart, blklen);
 }
 
 static int f2fs_issue_discard(struct f2fs_sb_info *sbi,
 				block_t blkstart, block_t blklen)
 {
-	sector_t start = SECTOR_FROM_BLOCK(blkstart);
-	sector_t len = SECTOR_FROM_BLOCK(blklen);
+	sector_t start = blkstart, len = 0;
+	struct block_device *bdev;
 	struct seg_entry *se;
 	unsigned int offset;
 	block_t i;
+	int err = 0;
+
+	bdev = f2fs_target_device(sbi, blkstart, NULL);
+
+	for (i = blkstart; i < blkstart + blklen; i++, len++) {
+		if (i != start) {
+			struct block_device *bdev2 =
+				f2fs_target_device(sbi, i, NULL);
+
+			if (bdev2 != bdev) {
+				err = __issue_discard_async(sbi, bdev,
+						start, len);
+				if (err)
+					return err;
+				bdev = bdev2;
+				start = i;
+				len = 0;
+			}
+		}
 
-	for (i = blkstart; i < blkstart + blklen; i++) {
 		se = get_seg_entry(sbi, GET_SEGNO(sbi, i));
 		offset = GET_BLKOFF_FROM_SEG0(sbi, i);
 
 		if (!f2fs_test_and_set_bit(offset, se->discard_map))
 			sbi->discard_blks--;
 	}
-	trace_f2fs_issue_discard(sbi->sb, blkstart, blklen);
-	return __f2fs_issue_discard_async(sbi, start, len, GFP_NOFS, 0);
-}
-
-static void __add_discard_entry(struct f2fs_sb_info *sbi,
-		struct cp_control *cpc, struct seg_entry *se,
-		unsigned int start, unsigned int end)
-{
-	struct list_head *head = &SM_I(sbi)->discard_list;
-	struct discard_entry *new, *last;
-
-	if (!list_empty(head)) {
-		last = list_last_entry(head, struct discard_entry, list);
-		if (START_BLOCK(sbi, cpc->trim_start) + start ==
-						last->blkaddr + last->len) {
-			last->len += end - start;
-			goto done;
-		}
-	}
 
-	new = f2fs_kmem_cache_alloc(discard_entry_slab, GFP_NOFS);
-	INIT_LIST_HEAD(&new->list);
-	new->blkaddr = START_BLOCK(sbi, cpc->trim_start) + start;
-	new->len = end - start;
-	list_add_tail(&new->list, head);
-done:
-	SM_I(sbi)->nr_discards += end - start;
+	if (len)
+		err = __issue_discard_async(sbi, bdev, start, len);
+	return err;
 }
 
-static void add_discard_addrs(struct f2fs_sb_info *sbi, struct cp_control *cpc)
+static bool add_discard_addrs(struct f2fs_sb_info *sbi, struct cp_control *cpc,
+							bool check_only)
 {
 	int entries = SIT_VBLOCK_MAP_SIZE / sizeof(unsigned long);
 	int max_blocks = sbi->blocks_per_seg;
@@ -714,16 +1553,19 @@ static void add_discard_addrs(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 	unsigned long *discard_map = (unsigned long *)se->discard_map;
 	unsigned long *dmap = SIT_I(sbi)->tmp_map;
 	unsigned int start = 0, end = -1;
-	bool force = (cpc->reason == CP_DISCARD);
+	bool force = (cpc->reason & CP_DISCARD);
+	struct discard_entry *de = NULL;
+	struct list_head *head = &SM_I(sbi)->dcc_info->entry_list;
 	int i;
 
 	if (se->valid_blocks == max_blocks || !f2fs_discard_en(sbi))
-		return;
+		return false;
 
 	if (!force) {
 		if (!test_opt(sbi, DISCARD) || !se->valid_blocks ||
-		    SM_I(sbi)->nr_discards >= SM_I(sbi)->max_discards)
-			return;
+			SM_I(sbi)->dcc_info->nr_discards >=
+				SM_I(sbi)->dcc_info->max_discards)
+			return false;
 	}
 
 	/* SIT_VBLOCK_MAP_SIZE should be multiple of sizeof(unsigned long) */
@@ -731,7 +1573,8 @@ static void add_discard_addrs(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 		dmap[i] = force ? ~ckpt_map[i] & ~discard_map[i] :
 				(cur_map[i] ^ ckpt_map[i]) & ckpt_map[i];
 
-	while (force || SM_I(sbi)->nr_discards <= SM_I(sbi)->max_discards) {
+	while (force || SM_I(sbi)->dcc_info->nr_discards <=
+				SM_I(sbi)->dcc_info->max_discards) {
 		start = __find_rev_next_bit(dmap, max_blocks, end + 1);
 		if (start >= max_blocks)
 			break;
@@ -741,24 +1584,42 @@ static void add_discard_addrs(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 					&& (end - start) < cpc->trim_minlen)
 			continue;
 
-		__add_discard_entry(sbi, cpc, se, start, end);
+		if (check_only)
+			return true;
+
+		if (!de) {
+			de = f2fs_kmem_cache_alloc(discard_entry_slab,
+								GFP_F2FS_ZERO);
+			de->start_blkaddr = START_BLOCK(sbi, cpc->trim_start);
+			list_add_tail(&de->list, head);
+		}
+
+		for (i = start; i < end; i++)
+			__set_bit_le(i, (void *)de->discard_map);
+
+		SM_I(sbi)->dcc_info->nr_discards += end - start;
 	}
+	return false;
+}
+
+static void release_discard_addr(struct discard_entry *entry)
+{
+	list_del(&entry->list);
+	kmem_cache_free(discard_entry_slab, entry);
 }
 
-void release_discard_addrs(struct f2fs_sb_info *sbi)
+void f2fs_release_discard_addrs(struct f2fs_sb_info *sbi)
 {
-	struct list_head *head = &(SM_I(sbi)->discard_list);
+	struct list_head *head = &(SM_I(sbi)->dcc_info->entry_list);
 	struct discard_entry *entry, *this;
 
 	/* drop caches */
-	list_for_each_entry_safe(entry, this, head, list) {
-		list_del(&entry->list);
-		kmem_cache_free(discard_entry_slab, entry);
-	}
+	list_for_each_entry_safe(entry, this, head, list)
+		release_discard_addr(entry);
 }
 
 /*
- * Should call clear_prefree_segments after checkpoint is done.
+ * Should call f2fs_clear_prefree_segments after checkpoint is done.
  */
 static void set_prefree_as_free_segments(struct f2fs_sb_info *sbi)
 {
@@ -771,18 +1632,17 @@ static void set_prefree_as_free_segments(struct f2fs_sb_info *sbi)
 	mutex_unlock(&dirty_i->seglist_lock);
 }
 
-void clear_prefree_segments(struct f2fs_sb_info *sbi, struct cp_control *cpc)
+void f2fs_clear_prefree_segments(struct f2fs_sb_info *sbi,
+						struct cp_control *cpc)
 {
-	struct list_head *head = &(SM_I(sbi)->discard_list);
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct list_head *head = &dcc->entry_list;
 	struct discard_entry *entry, *this;
 	struct dirty_seglist_info *dirty_i = DIRTY_I(sbi);
-	struct blk_plug plug;
 	unsigned long *prefree_map = dirty_i->dirty_segmap[PRE];
 	unsigned int start = 0, end = -1;
 	unsigned int secno, start_segno;
-	bool force = (cpc->reason == CP_DISCARD);
-
-	blk_start_plug(&plug);
+	bool force = (cpc->reason & CP_DISCARD);
 
 	mutex_lock(&dirty_i->seglist_lock);
 
@@ -799,19 +1659,23 @@ void clear_prefree_segments(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 
 		dirty_i->nr_dirty[PRE] -= end - start;
 
-		if (force || !test_opt(sbi, DISCARD))
+		if (!test_opt(sbi, DISCARD))
 			continue;
 
+		if (force && start >= cpc->trim_start &&
+					(end - 1) <= cpc->trim_end)
+				continue;
+
 		if (!test_opt(sbi, LFS) || sbi->segs_per_sec == 1) {
 			f2fs_issue_discard(sbi, START_BLOCK(sbi, start),
 				(end - start) << sbi->log_blocks_per_seg);
 			continue;
 		}
 next:
-		secno = GET_SECNO(sbi, start);
-		start_segno = secno * sbi->segs_per_sec;
+		secno = GET_SEC_FROM_SEG(sbi, start);
+		start_segno = GET_SEG_FROM_SEC(sbi, secno);
 		if (!IS_CURSEC(sbi, secno) &&
-			!get_valid_blocks(sbi, start, sbi->segs_per_sec))
+			!get_valid_blocks(sbi, start, true))
 			f2fs_issue_discard(sbi, START_BLOCK(sbi, start_segno),
 				sbi->segs_per_sec << sbi->log_blocks_per_seg);
 
@@ -825,17 +1689,96 @@ void clear_prefree_segments(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 
 	/* send small discards */
 	list_for_each_entry_safe(entry, this, head, list) {
-		if (force && entry->len < cpc->trim_minlen)
-			goto skip;
-		f2fs_issue_discard(sbi, entry->blkaddr, entry->len);
-		cpc->trimmed += entry->len;
+		unsigned int cur_pos = 0, next_pos, len, total_len = 0;
+		bool is_valid = test_bit_le(0, entry->discard_map);
+
+find_next:
+		if (is_valid) {
+			next_pos = find_next_zero_bit_le(entry->discard_map,
+					sbi->blocks_per_seg, cur_pos);
+			len = next_pos - cur_pos;
+
+			if (f2fs_sb_has_blkzoned(sbi->sb) ||
+			    (force && len < cpc->trim_minlen))
+				goto skip;
+
+			f2fs_issue_discard(sbi, entry->start_blkaddr + cur_pos,
+									len);
+			total_len += len;
+		} else {
+			next_pos = find_next_bit_le(entry->discard_map,
+					sbi->blocks_per_seg, cur_pos);
+		}
 skip:
-		list_del(&entry->list);
-		SM_I(sbi)->nr_discards -= entry->len;
-		kmem_cache_free(discard_entry_slab, entry);
+		cur_pos = next_pos;
+		is_valid = !is_valid;
+
+		if (cur_pos < sbi->blocks_per_seg)
+			goto find_next;
+
+		release_discard_addr(entry);
+		dcc->nr_discards -= total_len;
 	}
 
-	blk_finish_plug(&plug);
+	wake_up_discard_thread(sbi, false);
+}
+
+static int create_discard_cmd_control(struct f2fs_sb_info *sbi)
+{
+	dev_t dev = sbi->sb->s_bdev->bd_dev;
+	struct discard_cmd_control *dcc;
+	int err = 0, i;
+
+	if (SM_I(sbi)->dcc_info) {
+		dcc = SM_I(sbi)->dcc_info;
+		goto init_thread;
+	}
+
+	dcc = f2fs_kzalloc(sbi, sizeof(struct discard_cmd_control), GFP_KERNEL);
+	if (!dcc)
+		return -ENOMEM;
+
+	dcc->discard_granularity = DEFAULT_DISCARD_GRANULARITY;
+	INIT_LIST_HEAD(&dcc->entry_list);
+	for (i = 0; i < MAX_PLIST_NUM; i++)
+		INIT_LIST_HEAD(&dcc->pend_list[i]);
+	INIT_LIST_HEAD(&dcc->wait_list);
+	INIT_LIST_HEAD(&dcc->fstrim_list);
+	mutex_init(&dcc->cmd_lock);
+	atomic_set(&dcc->issued_discard, 0);
+	atomic_set(&dcc->issing_discard, 0);
+	atomic_set(&dcc->discard_cmd_cnt, 0);
+	dcc->nr_discards = 0;
+	dcc->max_discards = MAIN_SEGS(sbi) << sbi->log_blocks_per_seg;
+	dcc->undiscard_blks = 0;
+	dcc->root = RB_ROOT;
+
+	init_waitqueue_head(&dcc->discard_wait_queue);
+	SM_I(sbi)->dcc_info = dcc;
+init_thread:
+	dcc->f2fs_issue_discard = kthread_run(issue_discard_thread, sbi,
+				"f2fs_discard-%u:%u", MAJOR(dev), MINOR(dev));
+	if (IS_ERR(dcc->f2fs_issue_discard)) {
+		err = PTR_ERR(dcc->f2fs_issue_discard);
+		kfree(dcc);
+		SM_I(sbi)->dcc_info = NULL;
+		return err;
+	}
+
+	return err;
+}
+
+static void destroy_discard_cmd_control(struct f2fs_sb_info *sbi)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+
+	if (!dcc)
+		return;
+
+	f2fs_stop_discard_thread(sbi);
+
+	kfree(dcc);
+	SM_I(sbi)->dcc_info = NULL;
 }
 
 static bool __mark_sit_entry_dirty(struct f2fs_sb_info *sbi, unsigned int segno)
@@ -864,6 +1807,10 @@ static void update_sit_entry(struct f2fs_sb_info *sbi, block_t blkaddr, int del)
 	struct seg_entry *se;
 	unsigned int segno, offset;
 	long int new_vblocks;
+	bool exist;
+#ifdef CONFIG_F2FS_CHECK_FS
+	bool mir_exist;
+#endif
 
 	segno = GET_SEGNO(sbi, blkaddr);
 
@@ -875,19 +1822,60 @@ static void update_sit_entry(struct f2fs_sb_info *sbi, block_t blkaddr, int del)
 				(new_vblocks > sbi->blocks_per_seg)));
 
 	se->valid_blocks = new_vblocks;
-	se->mtime = get_mtime(sbi);
-	SIT_I(sbi)->max_mtime = se->mtime;
+	se->mtime = get_mtime(sbi, false);
+	if (se->mtime > SIT_I(sbi)->max_mtime)
+		SIT_I(sbi)->max_mtime = se->mtime;
 
 	/* Update valid block bitmap */
 	if (del > 0) {
-		if (f2fs_test_and_set_bit(offset, se->cur_valid_map))
+		exist = f2fs_test_and_set_bit(offset, se->cur_valid_map);
+#ifdef CONFIG_F2FS_CHECK_FS
+		mir_exist = f2fs_test_and_set_bit(offset,
+						se->cur_valid_map_mir);
+		if (unlikely(exist != mir_exist)) {
+			f2fs_msg(sbi->sb, KERN_ERR, "Inconsistent error "
+				"when setting bitmap, blk:%u, old bit:%d",
+				blkaddr, exist);
 			f2fs_bug_on(sbi, 1);
+		}
+#endif
+		if (unlikely(exist)) {
+			f2fs_msg(sbi->sb, KERN_ERR,
+				"Bitmap was wrongly set, blk:%u", blkaddr);
+			f2fs_bug_on(sbi, 1);
+			se->valid_blocks--;
+			del = 0;
+		}
+
 		if (f2fs_discard_en(sbi) &&
 			!f2fs_test_and_set_bit(offset, se->discard_map))
 			sbi->discard_blks--;
+
+		/* don't overwrite by SSR to keep node chain */
+		if (IS_NODESEG(se->type)) {
+			if (!f2fs_test_and_set_bit(offset, se->ckpt_valid_map))
+				se->ckpt_valid_blocks++;
+		}
 	} else {
-		if (!f2fs_test_and_clear_bit(offset, se->cur_valid_map))
+		exist = f2fs_test_and_clear_bit(offset, se->cur_valid_map);
+#ifdef CONFIG_F2FS_CHECK_FS
+		mir_exist = f2fs_test_and_clear_bit(offset,
+						se->cur_valid_map_mir);
+		if (unlikely(exist != mir_exist)) {
+			f2fs_msg(sbi->sb, KERN_ERR, "Inconsistent error "
+				"when clearing bitmap, blk:%u, old bit:%d",
+				blkaddr, exist);
+			f2fs_bug_on(sbi, 1);
+		}
+#endif
+		if (unlikely(!exist)) {
+			f2fs_msg(sbi->sb, KERN_ERR,
+				"Bitmap was wrongly cleared, blk:%u", blkaddr);
 			f2fs_bug_on(sbi, 1);
+			se->valid_blocks++;
+			del = 0;
+		}
+
 		if (f2fs_discard_en(sbi) &&
 			f2fs_test_and_clear_bit(offset, se->discard_map))
 			sbi->discard_blks++;
@@ -904,17 +1892,7 @@ static void update_sit_entry(struct f2fs_sb_info *sbi, block_t blkaddr, int del)
 		get_sec_entry(sbi, segno)->valid_blocks += del;
 }
 
-void refresh_sit_entry(struct f2fs_sb_info *sbi, block_t old, block_t new)
-{
-	update_sit_entry(sbi, new, 1);
-	if (GET_SEGNO(sbi, old) != NULL_SEGNO)
-		update_sit_entry(sbi, old, -1);
-
-	locate_dirty_segment(sbi, GET_SEGNO(sbi, old));
-	locate_dirty_segment(sbi, GET_SEGNO(sbi, new));
-}
-
-void invalidate_blocks(struct f2fs_sb_info *sbi, block_t addr)
+void f2fs_invalidate_blocks(struct f2fs_sb_info *sbi, block_t addr)
 {
 	unsigned int segno = GET_SEGNO(sbi, addr);
 	struct sit_info *sit_i = SIT_I(sbi);
@@ -924,27 +1902,27 @@ void invalidate_blocks(struct f2fs_sb_info *sbi, block_t addr)
 		return;
 
 	/* add it into sit main buffer */
-	mutex_lock(&sit_i->sentry_lock);
+	down_write(&sit_i->sentry_lock);
 
 	update_sit_entry(sbi, addr, -1);
 
 	/* add it into dirty seglist */
 	locate_dirty_segment(sbi, segno);
 
-	mutex_unlock(&sit_i->sentry_lock);
+	up_write(&sit_i->sentry_lock);
 }
 
-bool is_checkpointed_data(struct f2fs_sb_info *sbi, block_t blkaddr)
+bool f2fs_is_checkpointed_data(struct f2fs_sb_info *sbi, block_t blkaddr)
 {
 	struct sit_info *sit_i = SIT_I(sbi);
 	unsigned int segno, offset;
 	struct seg_entry *se;
 	bool is_cp = false;
 
-	if (blkaddr == NEW_ADDR || blkaddr == NULL_ADDR)
+	if (!is_valid_blkaddr(blkaddr))
 		return true;
 
-	mutex_lock(&sit_i->sentry_lock);
+	down_read(&sit_i->sentry_lock);
 
 	segno = GET_SEGNO(sbi, blkaddr);
 	se = get_seg_entry(sbi, segno);
@@ -953,7 +1931,7 @@ bool is_checkpointed_data(struct f2fs_sb_info *sbi, block_t blkaddr)
 	if (f2fs_test_bit(offset, se->ckpt_valid_map))
 		is_cp = true;
 
-	mutex_unlock(&sit_i->sentry_lock);
+	up_read(&sit_i->sentry_lock);
 
 	return is_cp;
 }
@@ -973,7 +1951,7 @@ static void __add_sum_entry(struct f2fs_sb_info *sbi, int type,
 /*
  * Calculate the number of current summary pages for writing
  */
-int npages_for_summary_flush(struct f2fs_sb_info *sbi, bool for_ra)
+int f2fs_npages_for_summary_flush(struct f2fs_sb_info *sbi, bool for_ra)
 {
 	int valid_sum_count = 0;
 	int i, sum_in_page;
@@ -1003,20 +1981,17 @@ int npages_for_summary_flush(struct f2fs_sb_info *sbi, bool for_ra)
 /*
  * Caller should put this summary page
  */
-struct page *get_sum_page(struct f2fs_sb_info *sbi, unsigned int segno)
+struct page *f2fs_get_sum_page(struct f2fs_sb_info *sbi, unsigned int segno)
 {
-	return get_meta_page(sbi, GET_SUM_BLOCK(sbi, segno));
+	return f2fs_get_meta_page(sbi, GET_SUM_BLOCK(sbi, segno));
 }
 
-void update_meta_page(struct f2fs_sb_info *sbi, void *src, block_t blk_addr)
+void f2fs_update_meta_page(struct f2fs_sb_info *sbi,
+					void *src, block_t blk_addr)
 {
-	struct page *page = grab_meta_page(sbi, blk_addr);
-	void *dst = page_address(page);
+	struct page *page = f2fs_grab_meta_page(sbi, blk_addr);
 
-	if (src)
-		memcpy(dst, src, PAGE_SIZE);
-	else
-		memset(dst, 0, PAGE_SIZE);
+	memcpy(page_address(page), src, PAGE_SIZE);
 	set_page_dirty(page);
 	f2fs_put_page(page, 1);
 }
@@ -1024,18 +1999,19 @@ void update_meta_page(struct f2fs_sb_info *sbi, void *src, block_t blk_addr)
 static void write_sum_page(struct f2fs_sb_info *sbi,
 			struct f2fs_summary_block *sum_blk, block_t blk_addr)
 {
-	update_meta_page(sbi, (void *)sum_blk, blk_addr);
+	f2fs_update_meta_page(sbi, (void *)sum_blk, blk_addr);
 }
 
 static void write_current_sum_page(struct f2fs_sb_info *sbi,
 						int type, block_t blk_addr)
 {
 	struct curseg_info *curseg = CURSEG_I(sbi, type);
-	struct page *page = grab_meta_page(sbi, blk_addr);
+	struct page *page = f2fs_grab_meta_page(sbi, blk_addr);
 	struct f2fs_summary_block *src = curseg->sum_blk;
 	struct f2fs_summary_block *dst;
 
 	dst = (struct f2fs_summary_block *)page_address(page);
+	memset(dst, 0, PAGE_SIZE);
 
 	mutex_lock(&curseg->curseg_mutex);
 
@@ -1073,8 +2049,8 @@ static void get_new_segment(struct f2fs_sb_info *sbi,
 	struct free_segmap_info *free_i = FREE_I(sbi);
 	unsigned int segno, secno, zoneno;
 	unsigned int total_zones = MAIN_SECS(sbi) / sbi->secs_per_zone;
-	unsigned int hint = *newseg / sbi->segs_per_sec;
-	unsigned int old_zoneno = GET_ZONENO_FROM_SEGNO(sbi, *newseg);
+	unsigned int hint = GET_SEC_FROM_SEG(sbi, *newseg);
+	unsigned int old_zoneno = GET_ZONE_FROM_SEG(sbi, *newseg);
 	unsigned int left_start = hint;
 	bool init = true;
 	int go_left = 0;
@@ -1084,8 +2060,8 @@ static void get_new_segment(struct f2fs_sb_info *sbi,
 
 	if (!new_sec && ((*newseg + 1) % sbi->segs_per_sec)) {
 		segno = find_next_zero_bit(free_i->free_segmap,
-				(hint + 1) * sbi->segs_per_sec, *newseg + 1);
-		if (segno < (hint + 1) * sbi->segs_per_sec)
+			GET_SEG_FROM_SEC(sbi, hint + 1), *newseg + 1);
+		if (segno < GET_SEG_FROM_SEC(sbi, hint + 1))
 			goto got_it;
 	}
 find_other_zone:
@@ -1115,9 +2091,8 @@ static void get_new_segment(struct f2fs_sb_info *sbi,
 	}
 	secno = left_start;
 skip_left:
-	hint = secno;
-	segno = secno * sbi->segs_per_sec;
-	zoneno = secno / sbi->secs_per_zone;
+	segno = GET_SEG_FROM_SEC(sbi, secno);
+	zoneno = GET_ZONE_FROM_SEC(sbi, secno);
 
 	/* give up on finding another zone */
 	if (!init)
@@ -1161,7 +2136,7 @@ static void reset_curseg(struct f2fs_sb_info *sbi, int type, int modified)
 	struct summary_footer *sum_footer;
 
 	curseg->segno = curseg->next_segno;
-	curseg->zone = GET_ZONENO_FROM_SEGNO(sbi, curseg->segno);
+	curseg->zone = GET_ZONE_FROM_SEG(sbi, curseg->segno);
 	curseg->next_blkoff = 0;
 	curseg->next_segno = NULL_SEGNO;
 
@@ -1174,6 +2149,26 @@ static void reset_curseg(struct f2fs_sb_info *sbi, int type, int modified)
 	__set_sit_entry_type(sbi, type, curseg->segno, modified);
 }
 
+static unsigned int __get_next_segno(struct f2fs_sb_info *sbi, int type)
+{
+	/* if segs_per_sec is large than 1, we need to keep original policy. */
+	if (sbi->segs_per_sec != 1)
+		return CURSEG_I(sbi, type)->segno;
+
+	if (test_opt(sbi, NOHEAP) &&
+		(type == CURSEG_HOT_DATA || IS_NODESEG(type)))
+		return 0;
+
+	if (SIT_I(sbi)->last_victim[ALLOC_NEXT])
+		return SIT_I(sbi)->last_victim[ALLOC_NEXT];
+
+	/* find segments from 0 to reuse freed segments */
+	if (F2FS_OPTION(sbi).alloc_mode == ALLOC_MODE_REUSE)
+		return 0;
+
+	return CURSEG_I(sbi, type)->segno;
+}
+
 /*
  * Allocate a current working segment.
  * This function always allocates a free segment in LFS manner.
@@ -1192,6 +2187,7 @@ static void new_curseg(struct f2fs_sb_info *sbi, int type, bool new_sec)
 	if (test_opt(sbi, NOHEAP))
 		dir = ALLOC_RIGHT;
 
+	segno = __get_next_segno(sbi, type);
 	get_new_segment(sbi, &segno, new_sec, dir);
 	curseg->next_segno = segno;
 	reset_curseg(sbi, type, 1);
@@ -1234,7 +2230,7 @@ static void __refresh_next_blkoff(struct f2fs_sb_info *sbi,
  * This function always allocates a used segment(from dirty seglist) by SSR
  * manner, so it should recover the existing segment information of valid blocks
  */
-static void change_curseg(struct f2fs_sb_info *sbi, int type, bool reuse)
+static void change_curseg(struct f2fs_sb_info *sbi, int type)
 {
 	struct dirty_seglist_info *dirty_i = DIRTY_I(sbi);
 	struct curseg_info *curseg = CURSEG_I(sbi, type);
@@ -1255,28 +2251,53 @@ static void change_curseg(struct f2fs_sb_info *sbi, int type, bool reuse)
 	curseg->alloc_type = SSR;
 	__next_free_blkoff(sbi, curseg, 0);
 
-	if (reuse) {
-		sum_page = get_sum_page(sbi, new_segno);
-		sum_node = (struct f2fs_summary_block *)page_address(sum_page);
-		memcpy(curseg->sum_blk, sum_node, SUM_ENTRY_SIZE);
-		f2fs_put_page(sum_page, 1);
-	}
+	sum_page = f2fs_get_sum_page(sbi, new_segno);
+	sum_node = (struct f2fs_summary_block *)page_address(sum_page);
+	memcpy(curseg->sum_blk, sum_node, SUM_ENTRY_SIZE);
+	f2fs_put_page(sum_page, 1);
 }
 
 static int get_ssr_segment(struct f2fs_sb_info *sbi, int type)
 {
 	struct curseg_info *curseg = CURSEG_I(sbi, type);
 	const struct victim_selection *v_ops = DIRTY_I(sbi)->v_ops;
+	unsigned segno = NULL_SEGNO;
+	int i, cnt;
+	bool reversed = false;
 
-	if (IS_NODESEG(type))
-		return v_ops->get_victim(sbi,
-				&(curseg)->next_segno, BG_GC, type, SSR);
+	/* f2fs_need_SSR() already forces to do this */
+	if (v_ops->get_victim(sbi, &segno, BG_GC, type, SSR)) {
+		curseg->next_segno = segno;
+		return 1;
+	}
+
+	/* For node segments, let's do SSR more intensively */
+	if (IS_NODESEG(type)) {
+		if (type >= CURSEG_WARM_NODE) {
+			reversed = true;
+			i = CURSEG_COLD_NODE;
+		} else {
+			i = CURSEG_HOT_NODE;
+		}
+		cnt = NR_CURSEG_NODE_TYPE;
+	} else {
+		if (type >= CURSEG_WARM_DATA) {
+			reversed = true;
+			i = CURSEG_COLD_DATA;
+		} else {
+			i = CURSEG_HOT_DATA;
+		}
+		cnt = NR_CURSEG_DATA_TYPE;
+	}
 
-	/* For data segments, let's do SSR more intensively */
-	for (; type >= CURSEG_HOT_DATA; type--)
-		if (v_ops->get_victim(sbi, &(curseg)->next_segno,
-						BG_GC, type, SSR))
+	for (; cnt-- > 0; reversed ? i-- : i++) {
+		if (i == type)
+			continue;
+		if (v_ops->get_victim(sbi, &segno, BG_GC, i, SSR)) {
+			curseg->next_segno = segno;
 			return 1;
+		}
+	}
 	return 0;
 }
 
@@ -1291,95 +2312,181 @@ static void allocate_segment_by_default(struct f2fs_sb_info *sbi,
 
 	if (force)
 		new_curseg(sbi, type, true);
-	else if (type == CURSEG_WARM_NODE)
+	else if (!is_set_ckpt_flags(sbi, CP_CRC_RECOVERY_FLAG) &&
+					type == CURSEG_WARM_NODE)
 		new_curseg(sbi, type, false);
 	else if (curseg->alloc_type == LFS && is_next_segment_free(sbi, type))
 		new_curseg(sbi, type, false);
-	else if (need_SSR(sbi) && get_ssr_segment(sbi, type))
-		change_curseg(sbi, type, true);
+	else if (f2fs_need_SSR(sbi) && get_ssr_segment(sbi, type))
+		change_curseg(sbi, type);
 	else
 		new_curseg(sbi, type, false);
 
 	stat_inc_seg_type(sbi, curseg);
 }
 
-static void __allocate_new_segments(struct f2fs_sb_info *sbi, int type)
+void f2fs_allocate_new_segments(struct f2fs_sb_info *sbi)
 {
-	struct curseg_info *curseg = CURSEG_I(sbi, type);
+	struct curseg_info *curseg;
 	unsigned int old_segno;
-
-	old_segno = curseg->segno;
-	SIT_I(sbi)->s_ops->allocate_segment(sbi, type, true);
-	locate_dirty_segment(sbi, old_segno);
-}
-
-void allocate_new_segments(struct f2fs_sb_info *sbi)
-{
 	int i;
 
-	if (test_opt(sbi, LFS))
-		return;
+	down_write(&SIT_I(sbi)->sentry_lock);
+
+	for (i = CURSEG_HOT_DATA; i <= CURSEG_COLD_DATA; i++) {
+		curseg = CURSEG_I(sbi, i);
+		old_segno = curseg->segno;
+		SIT_I(sbi)->s_ops->allocate_segment(sbi, i, true);
+		locate_dirty_segment(sbi, old_segno);
+	}
 
-	for (i = CURSEG_HOT_DATA; i <= CURSEG_COLD_DATA; i++)
-		__allocate_new_segments(sbi, i);
+	up_write(&SIT_I(sbi)->sentry_lock);
 }
 
 static const struct segment_allocation default_salloc_ops = {
 	.allocate_segment = allocate_segment_by_default,
 };
 
+bool f2fs_exist_trim_candidates(struct f2fs_sb_info *sbi,
+						struct cp_control *cpc)
+{
+	__u64 trim_start = cpc->trim_start;
+	bool has_candidate = false;
+
+	down_write(&SIT_I(sbi)->sentry_lock);
+	for (; cpc->trim_start <= cpc->trim_end; cpc->trim_start++) {
+		if (add_discard_addrs(sbi, cpc, true)) {
+			has_candidate = true;
+			break;
+		}
+	}
+	up_write(&SIT_I(sbi)->sentry_lock);
+
+	cpc->trim_start = trim_start;
+	return has_candidate;
+}
+
+static void __issue_discard_cmd_range(struct f2fs_sb_info *sbi,
+					struct discard_policy *dpolicy,
+					unsigned int start, unsigned int end)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	struct discard_cmd *prev_dc = NULL, *next_dc = NULL;
+	struct rb_node **insert_p = NULL, *insert_parent = NULL;
+	struct discard_cmd *dc;
+	struct blk_plug plug;
+	int issued;
+
+next:
+	issued = 0;
+
+	mutex_lock(&dcc->cmd_lock);
+	f2fs_bug_on(sbi, !f2fs_check_rb_tree_consistence(sbi, &dcc->root));
+
+	dc = (struct discard_cmd *)f2fs_lookup_rb_tree_ret(&dcc->root,
+					NULL, start,
+					(struct rb_entry **)&prev_dc,
+					(struct rb_entry **)&next_dc,
+					&insert_p, &insert_parent, true);
+	if (!dc)
+		dc = next_dc;
+
+	blk_start_plug(&plug);
+
+	while (dc && dc->lstart <= end) {
+		struct rb_node *node;
+
+		if (dc->len < dpolicy->granularity)
+			goto skip;
+
+		if (dc->state != D_PREP) {
+			list_move_tail(&dc->list, &dcc->fstrim_list);
+			goto skip;
+		}
+
+		__submit_discard_cmd(sbi, dpolicy, dc);
+
+		if (++issued >= dpolicy->max_requests) {
+			start = dc->lstart + dc->len;
+
+			blk_finish_plug(&plug);
+			mutex_unlock(&dcc->cmd_lock);
+			__wait_all_discard_cmd(sbi, NULL);
+			congestion_wait(BLK_RW_ASYNC, HZ/50);
+			goto next;
+		}
+skip:
+		node = rb_next(&dc->rb_node);
+		dc = rb_entry_safe(node, struct discard_cmd, rb_node);
+
+		if (fatal_signal_pending(current))
+			break;
+	}
+
+	blk_finish_plug(&plug);
+	mutex_unlock(&dcc->cmd_lock);
+}
+
 int f2fs_trim_fs(struct f2fs_sb_info *sbi, struct fstrim_range *range)
 {
 	__u64 start = F2FS_BYTES_TO_BLK(range->start);
 	__u64 end = start + F2FS_BYTES_TO_BLK(range->len) - 1;
 	unsigned int start_segno, end_segno;
+	block_t start_block, end_block;
 	struct cp_control cpc;
+	struct discard_policy dpolicy;
+	unsigned long long trimmed = 0;
 	int err = 0;
 
 	if (start >= MAX_BLKADDR(sbi) || range->len < sbi->blocksize)
 		return -EINVAL;
 
-	cpc.trimmed = 0;
 	if (end <= MAIN_BLKADDR(sbi))
-		goto out;
+		return -EINVAL;
 
 	if (is_sbi_flag_set(sbi, SBI_NEED_FSCK)) {
 		f2fs_msg(sbi->sb, KERN_WARNING,
 			"Found FS corruption, run fsck to fix.");
-		goto out;
+		return -EIO;
 	}
 
 	/* start/end segment number in main_area */
 	start_segno = (start <= MAIN_BLKADDR(sbi)) ? 0 : GET_SEGNO(sbi, start);
 	end_segno = (end >= MAX_BLKADDR(sbi)) ? MAIN_SEGS(sbi) - 1 :
 						GET_SEGNO(sbi, end);
+
 	cpc.reason = CP_DISCARD;
 	cpc.trim_minlen = max_t(__u64, 1, F2FS_BYTES_TO_BLK(range->minlen));
+	cpc.trim_start = start_segno;
+	cpc.trim_end = end_segno;
 
-	/* do checkpoint to issue discard commands safely */
-	for (; start_segno <= end_segno; start_segno = cpc.trim_end + 1) {
-		cpc.trim_start = start_segno;
+	if (sbi->discard_blks == 0)
+		goto out;
 
-		if (sbi->discard_blks == 0)
-			break;
-		else if (sbi->discard_blks < BATCHED_TRIM_BLOCKS(sbi))
-			cpc.trim_end = end_segno;
-		else
-			cpc.trim_end = min_t(unsigned int,
-				rounddown(start_segno +
-				BATCHED_TRIM_SEGMENTS(sbi),
-				sbi->segs_per_sec) - 1, end_segno);
+	mutex_lock(&sbi->gc_mutex);
+	err = f2fs_write_checkpoint(sbi, &cpc);
+	mutex_unlock(&sbi->gc_mutex);
+	if (err)
+		goto out;
 
-		mutex_lock(&sbi->gc_mutex);
-		err = write_checkpoint(sbi, &cpc);
-		mutex_unlock(&sbi->gc_mutex);
-		if (err)
-			break;
+	start_block = START_BLOCK(sbi, start_segno);
+	end_block = START_BLOCK(sbi, end_segno + 1);
+
+	__init_discard_policy(sbi, &dpolicy, DPOLICY_FSTRIM, cpc.trim_minlen);
+	__issue_discard_cmd_range(sbi, &dpolicy, start_block, end_block);
 
-		schedule();
+	/*
+	 * We filed discard candidates, but actually we don't need to wait for
+	 * all of them, since they'll be issued in idle time along with runtime
+	 * discard option. User configuration looks like using runtime discard
+	 * or periodic fstrim instead of it.
+	 */
+	if (!test_opt(sbi, DISCARD)) {
+		trimmed = __wait_discard_cmd_range(sbi, &dpolicy,
+					start_block, end_block);
+		range->len = F2FS_BLK_TO_BYTES(trimmed);
 	}
 out:
-	range->len = F2FS_BLK_TO_BYTES(cpc.trimmed);
 	return err;
 }
 
@@ -1391,87 +2498,204 @@ static bool __has_curseg_space(struct f2fs_sb_info *sbi, int type)
 	return false;
 }
 
-static int __get_segment_type_2(struct page *page, enum page_type p_type)
+int f2fs_rw_hint_to_seg_type(enum rw_hint hint)
+{
+	switch (hint) {
+	case WRITE_LIFE_SHORT:
+		return CURSEG_HOT_DATA;
+	case WRITE_LIFE_EXTREME:
+		return CURSEG_COLD_DATA;
+	default:
+		return CURSEG_WARM_DATA;
+	}
+}
+
+/* This returns write hints for each segment type. This hints will be
+ * passed down to block layer. There are mapping tables which depend on
+ * the mount option 'whint_mode'.
+ *
+ * 1) whint_mode=off. F2FS only passes down WRITE_LIFE_NOT_SET.
+ *
+ * 2) whint_mode=user-based. F2FS tries to pass down hints given by users.
+ *
+ * User                  F2FS                     Block
+ * ----                  ----                     -----
+ *                       META                     WRITE_LIFE_NOT_SET
+ *                       HOT_NODE                 "
+ *                       WARM_NODE                "
+ *                       COLD_NODE                "
+ * ioctl(COLD)           COLD_DATA                WRITE_LIFE_EXTREME
+ * extension list        "                        "
+ *
+ * -- buffered io
+ * WRITE_LIFE_EXTREME    COLD_DATA                WRITE_LIFE_EXTREME
+ * WRITE_LIFE_SHORT      HOT_DATA                 WRITE_LIFE_SHORT
+ * WRITE_LIFE_NOT_SET    WARM_DATA                WRITE_LIFE_NOT_SET
+ * WRITE_LIFE_NONE       "                        "
+ * WRITE_LIFE_MEDIUM     "                        "
+ * WRITE_LIFE_LONG       "                        "
+ *
+ * -- direct io
+ * WRITE_LIFE_EXTREME    COLD_DATA                WRITE_LIFE_EXTREME
+ * WRITE_LIFE_SHORT      HOT_DATA                 WRITE_LIFE_SHORT
+ * WRITE_LIFE_NOT_SET    WARM_DATA                WRITE_LIFE_NOT_SET
+ * WRITE_LIFE_NONE       "                        WRITE_LIFE_NONE
+ * WRITE_LIFE_MEDIUM     "                        WRITE_LIFE_MEDIUM
+ * WRITE_LIFE_LONG       "                        WRITE_LIFE_LONG
+ *
+ * 3) whint_mode=fs-based. F2FS passes down hints with its policy.
+ *
+ * User                  F2FS                     Block
+ * ----                  ----                     -----
+ *                       META                     WRITE_LIFE_MEDIUM;
+ *                       HOT_NODE                 WRITE_LIFE_NOT_SET
+ *                       WARM_NODE                "
+ *                       COLD_NODE                WRITE_LIFE_NONE
+ * ioctl(COLD)           COLD_DATA                WRITE_LIFE_EXTREME
+ * extension list        "                        "
+ *
+ * -- buffered io
+ * WRITE_LIFE_EXTREME    COLD_DATA                WRITE_LIFE_EXTREME
+ * WRITE_LIFE_SHORT      HOT_DATA                 WRITE_LIFE_SHORT
+ * WRITE_LIFE_NOT_SET    WARM_DATA                WRITE_LIFE_LONG
+ * WRITE_LIFE_NONE       "                        "
+ * WRITE_LIFE_MEDIUM     "                        "
+ * WRITE_LIFE_LONG       "                        "
+ *
+ * -- direct io
+ * WRITE_LIFE_EXTREME    COLD_DATA                WRITE_LIFE_EXTREME
+ * WRITE_LIFE_SHORT      HOT_DATA                 WRITE_LIFE_SHORT
+ * WRITE_LIFE_NOT_SET    WARM_DATA                WRITE_LIFE_NOT_SET
+ * WRITE_LIFE_NONE       "                        WRITE_LIFE_NONE
+ * WRITE_LIFE_MEDIUM     "                        WRITE_LIFE_MEDIUM
+ * WRITE_LIFE_LONG       "                        WRITE_LIFE_LONG
+ */
+
+enum rw_hint f2fs_io_type_to_rw_hint(struct f2fs_sb_info *sbi,
+				enum page_type type, enum temp_type temp)
+{
+	if (F2FS_OPTION(sbi).whint_mode == WHINT_MODE_USER) {
+		if (type == DATA) {
+			if (temp == WARM)
+				return WRITE_LIFE_NOT_SET;
+			else if (temp == HOT)
+				return WRITE_LIFE_SHORT;
+			else if (temp == COLD)
+				return WRITE_LIFE_EXTREME;
+		} else {
+			return WRITE_LIFE_NOT_SET;
+		}
+	} else if (F2FS_OPTION(sbi).whint_mode == WHINT_MODE_FS) {
+		if (type == DATA) {
+			if (temp == WARM)
+				return WRITE_LIFE_LONG;
+			else if (temp == HOT)
+				return WRITE_LIFE_SHORT;
+			else if (temp == COLD)
+				return WRITE_LIFE_EXTREME;
+		} else if (type == NODE) {
+			if (temp == WARM || temp == HOT)
+				return WRITE_LIFE_NOT_SET;
+			else if (temp == COLD)
+				return WRITE_LIFE_NONE;
+		} else if (type == META) {
+			return WRITE_LIFE_MEDIUM;
+		}
+	}
+	return WRITE_LIFE_NOT_SET;
+}
+
+static int __get_segment_type_2(struct f2fs_io_info *fio)
 {
-	if (p_type == DATA)
+	if (fio->type == DATA)
 		return CURSEG_HOT_DATA;
 	else
 		return CURSEG_HOT_NODE;
 }
 
-static int __get_segment_type_4(struct page *page, enum page_type p_type)
+static int __get_segment_type_4(struct f2fs_io_info *fio)
 {
-	if (p_type == DATA) {
-		struct inode *inode = page->mapping->host;
+	if (fio->type == DATA) {
+		struct inode *inode = fio->page->mapping->host;
 
 		if (S_ISDIR(inode->i_mode))
 			return CURSEG_HOT_DATA;
 		else
 			return CURSEG_COLD_DATA;
 	} else {
-		if (IS_DNODE(page) && is_cold_node(page))
+		if (IS_DNODE(fio->page) && is_cold_node(fio->page))
 			return CURSEG_WARM_NODE;
 		else
 			return CURSEG_COLD_NODE;
 	}
 }
 
-static int __get_segment_type_6(struct page *page, enum page_type p_type)
+static int __get_segment_type_6(struct f2fs_io_info *fio)
 {
-	if (p_type == DATA) {
-		struct inode *inode = page->mapping->host;
+	if (fio->type == DATA) {
+		struct inode *inode = fio->page->mapping->host;
 
-		if (S_ISDIR(inode->i_mode))
-			return CURSEG_HOT_DATA;
-		else if (is_cold_data(page) || file_is_cold(inode))
+		if (is_cold_data(fio->page) || file_is_cold(inode))
 			return CURSEG_COLD_DATA;
-		else
-			return CURSEG_WARM_DATA;
+		if (file_is_hot(inode) ||
+				is_inode_flag_set(inode, FI_HOT_DATA) ||
+				is_inode_flag_set(inode, FI_ATOMIC_FILE) ||
+				is_inode_flag_set(inode, FI_VOLATILE_FILE))
+			return CURSEG_HOT_DATA;
+		/* f2fs_rw_hint_to_seg_type(inode->i_write_hint); */
+		return CURSEG_WARM_DATA;
 	} else {
-		if (IS_DNODE(page))
-			return is_cold_node(page) ? CURSEG_WARM_NODE :
+		if (IS_DNODE(fio->page))
+			return is_cold_node(fio->page) ? CURSEG_WARM_NODE :
 						CURSEG_HOT_NODE;
-		else
-			return CURSEG_COLD_NODE;
+		return CURSEG_COLD_NODE;
 	}
 }
 
-static int __get_segment_type(struct page *page, enum page_type p_type)
+static int __get_segment_type(struct f2fs_io_info *fio)
 {
-	switch (F2FS_P_SB(page)->active_logs) {
+	int type = 0;
+
+	switch (F2FS_OPTION(fio->sbi).active_logs) {
 	case 2:
-		return __get_segment_type_2(page, p_type);
+		type = __get_segment_type_2(fio);
+		break;
 	case 4:
-		return __get_segment_type_4(page, p_type);
+		type = __get_segment_type_4(fio);
+		break;
+	case 6:
+		type = __get_segment_type_6(fio);
+		break;
+	default:
+		f2fs_bug_on(fio->sbi, true);
 	}
-	/* NR_CURSEG_TYPE(6) logs by default */
-	f2fs_bug_on(F2FS_P_SB(page),
-		F2FS_P_SB(page)->active_logs != NR_CURSEG_TYPE);
-	return __get_segment_type_6(page, p_type);
+
+	if (IS_HOT(type))
+		fio->temp = HOT;
+	else if (IS_WARM(type))
+		fio->temp = WARM;
+	else
+		fio->temp = COLD;
+	return type;
 }
 
-void allocate_data_block(struct f2fs_sb_info *sbi, struct page *page,
+void f2fs_allocate_data_block(struct f2fs_sb_info *sbi, struct page *page,
 		block_t old_blkaddr, block_t *new_blkaddr,
-		struct f2fs_summary *sum, int type)
+		struct f2fs_summary *sum, int type,
+		struct f2fs_io_info *fio, bool add_list)
 {
 	struct sit_info *sit_i = SIT_I(sbi);
-	struct curseg_info *curseg;
-	bool direct_io = (type == CURSEG_DIRECT_IO);
-
-	type = direct_io ? CURSEG_WARM_DATA : type;
+	struct curseg_info *curseg = CURSEG_I(sbi, type);
 
-	curseg = CURSEG_I(sbi, type);
+	down_read(&SM_I(sbi)->curseg_lock);
 
 	mutex_lock(&curseg->curseg_mutex);
-	mutex_lock(&sit_i->sentry_lock);
-
-	/* direct_io'ed data is aligned to the segment for better performance */
-	if (direct_io && curseg->next_blkoff &&
-				!has_not_enough_free_secs(sbi, 0, 0))
-		__allocate_new_segments(sbi, type);
+	down_write(&sit_i->sentry_lock);
 
 	*new_blkaddr = NEXT_FREE_BLKADDR(sbi, curseg);
 
+	f2fs_wait_discard_bio(sbi, *new_blkaddr);
+
 	/*
 	 * __add_sum_entry should be resided under the curseg_mutex
 	 * because, this function updates a summary entry in the
@@ -1483,88 +2707,183 @@ void allocate_data_block(struct f2fs_sb_info *sbi, struct page *page,
 
 	stat_inc_block_count(sbi, curseg);
 
-	if (!__has_curseg_space(sbi, type))
-		sit_i->s_ops->allocate_segment(sbi, type, false);
 	/*
 	 * SIT information should be updated before segment allocation,
 	 * since SSR needs latest valid block information.
 	 */
-	refresh_sit_entry(sbi, old_blkaddr, *new_blkaddr);
+	update_sit_entry(sbi, *new_blkaddr, 1);
+	if (GET_SEGNO(sbi, old_blkaddr) != NULL_SEGNO)
+		update_sit_entry(sbi, old_blkaddr, -1);
+
+	if (!__has_curseg_space(sbi, type))
+		sit_i->s_ops->allocate_segment(sbi, type, false);
+
+	/*
+	 * segment dirty status should be updated after segment allocation,
+	 * so we just need to update status only one time after previous
+	 * segment being closed.
+	 */
+	locate_dirty_segment(sbi, GET_SEGNO(sbi, old_blkaddr));
+	locate_dirty_segment(sbi, GET_SEGNO(sbi, *new_blkaddr));
 
-	mutex_unlock(&sit_i->sentry_lock);
+	up_write(&sit_i->sentry_lock);
 
-	if (page && IS_NODESEG(type))
+	if (page && IS_NODESEG(type)) {
 		fill_node_footer_blkaddr(page, NEXT_FREE_BLKADDR(sbi, curseg));
 
+		f2fs_inode_chksum_set(sbi, page);
+	}
+
+	if (add_list) {
+		struct f2fs_bio_info *io;
+
+		INIT_LIST_HEAD(&fio->list);
+		fio->in_list = true;
+		fio->retry = false;
+		io = sbi->write_io[fio->type] + fio->temp;
+		spin_lock(&io->io_lock);
+		list_add_tail(&fio->list, &io->io_list);
+		spin_unlock(&io->io_lock);
+	}
+
 	mutex_unlock(&curseg->curseg_mutex);
+
+	up_read(&SM_I(sbi)->curseg_lock);
 }
 
-static void do_write_page(struct f2fs_summary *sum, struct f2fs_io_info *fio)
+static void update_device_state(struct f2fs_io_info *fio)
 {
-	int type = __get_segment_type(fio->page, fio->type);
+	struct f2fs_sb_info *sbi = fio->sbi;
+	unsigned int devidx;
+
+	if (!sbi->s_ndevs)
+		return;
+
+	devidx = f2fs_target_device_index(sbi, fio->new_blkaddr);
+
+	/* update device state for fsync */
+	f2fs_set_dirty_device(sbi, fio->ino, devidx, FLUSH_INO);
 
-	if (fio->type == NODE || fio->type == DATA)
-		mutex_lock(&fio->sbi->wio_mutex[fio->type]);
+	/* update device state for checkpoint */
+	if (!f2fs_test_bit(devidx, (char *)&sbi->dirty_device)) {
+		spin_lock(&sbi->dev_lock);
+		f2fs_set_bit(devidx, (char *)&sbi->dirty_device);
+		spin_unlock(&sbi->dev_lock);
+	}
+}
+
+static void do_write_page(struct f2fs_summary *sum, struct f2fs_io_info *fio)
+{
+	int type = __get_segment_type(fio);
+	bool keep_order = (test_opt(fio->sbi, LFS) && type == CURSEG_COLD_DATA);
 
-	allocate_data_block(fio->sbi, fio->page, fio->old_blkaddr,
-					&fio->new_blkaddr, sum, type);
+	if (keep_order)
+		down_read(&fio->sbi->io_order_lock);
+reallocate:
+	f2fs_allocate_data_block(fio->sbi, fio->page, fio->old_blkaddr,
+			&fio->new_blkaddr, sum, type, fio, true);
 
 	/* writeout dirty page into bdev */
-	f2fs_submit_page_mbio(fio);
+	f2fs_submit_page_write(fio);
+	if (fio->retry) {
+		fio->old_blkaddr = fio->new_blkaddr;
+		goto reallocate;
+	}
 
-	if (fio->type == NODE || fio->type == DATA)
-		mutex_unlock(&fio->sbi->wio_mutex[fio->type]);
+	update_device_state(fio);
+
+	if (keep_order)
+		up_read(&fio->sbi->io_order_lock);
 }
 
-void write_meta_page(struct f2fs_sb_info *sbi, struct page *page)
+void f2fs_do_write_meta_page(struct f2fs_sb_info *sbi, struct page *page,
+					enum iostat_type io_type)
 {
 	struct f2fs_io_info fio = {
 		.sbi = sbi,
 		.type = META,
+		.temp = HOT,
 		.op = REQ_OP_WRITE,
-		.op_flags = WRITE_SYNC | REQ_META | REQ_PRIO,
+		.op_flags = REQ_SYNC | REQ_META | REQ_PRIO,
 		.old_blkaddr = page->index,
 		.new_blkaddr = page->index,
 		.page = page,
 		.encrypted_page = NULL,
+		.in_list = false,
 	};
 
 	if (unlikely(page->index >= MAIN_BLKADDR(sbi)))
 		fio.op_flags &= ~REQ_META;
 
 	set_page_writeback(page);
-	f2fs_submit_page_mbio(&fio);
+	ClearPageError(page);
+	f2fs_submit_page_write(&fio);
+
+	f2fs_update_iostat(sbi, io_type, F2FS_BLKSIZE);
 }
 
-void write_node_page(unsigned int nid, struct f2fs_io_info *fio)
+void f2fs_do_write_node_page(unsigned int nid, struct f2fs_io_info *fio)
 {
 	struct f2fs_summary sum;
 
 	set_summary(&sum, nid, 0, 0);
 	do_write_page(&sum, fio);
+
+	f2fs_update_iostat(fio->sbi, fio->io_type, F2FS_BLKSIZE);
 }
 
-void write_data_page(struct dnode_of_data *dn, struct f2fs_io_info *fio)
+void f2fs_outplace_write_data(struct dnode_of_data *dn,
+					struct f2fs_io_info *fio)
 {
 	struct f2fs_sb_info *sbi = fio->sbi;
 	struct f2fs_summary sum;
 	struct node_info ni;
 
 	f2fs_bug_on(sbi, dn->data_blkaddr == NULL_ADDR);
-	get_node_info(sbi, dn->nid, &ni);
+	f2fs_get_node_info(sbi, dn->nid, &ni);
 	set_summary(&sum, dn->nid, dn->ofs_in_node, ni.version);
 	do_write_page(&sum, fio);
 	f2fs_update_data_blkaddr(dn, fio->new_blkaddr);
+
+	f2fs_update_iostat(sbi, fio->io_type, F2FS_BLKSIZE);
 }
 
-void rewrite_data_page(struct f2fs_io_info *fio)
+int f2fs_inplace_write_data(struct f2fs_io_info *fio)
 {
+	int err;
+	struct f2fs_sb_info *sbi = fio->sbi;
+
 	fio->new_blkaddr = fio->old_blkaddr;
+	/* i/o temperature is needed for passing down write hints */
+	__get_segment_type(fio);
+
+	f2fs_bug_on(sbi, !IS_DATASEG(get_seg_entry(sbi,
+			GET_SEGNO(sbi, fio->new_blkaddr))->type));
+
 	stat_inc_inplace_blocks(fio->sbi);
-	f2fs_submit_page_mbio(fio);
+
+	err = f2fs_submit_page_bio(fio);
+	if (!err)
+		update_device_state(fio);
+
+	f2fs_update_iostat(fio->sbi, fio->io_type, F2FS_BLKSIZE);
+
+	return err;
+}
+
+static inline int __f2fs_get_curseg(struct f2fs_sb_info *sbi,
+						unsigned int segno)
+{
+	int i;
+
+	for (i = CURSEG_HOT_DATA; i < NO_CHECK_TYPE; i++) {
+		if (CURSEG_I(sbi, i)->segno == segno)
+			break;
+	}
+	return i;
 }
 
-void __f2fs_replace_block(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
+void f2fs_do_replace_block(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 				block_t old_blkaddr, block_t new_blkaddr,
 				bool recover_curseg, bool recover_newaddr)
 {
@@ -1579,6 +2898,8 @@ void __f2fs_replace_block(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 	se = get_seg_entry(sbi, segno);
 	type = se->type;
 
+	down_write(&SM_I(sbi)->curseg_lock);
+
 	if (!recover_curseg) {
 		/* for recovery flow */
 		if (se->valid_blocks == 0 && !IS_CURSEG(sbi, segno)) {
@@ -1588,14 +2909,20 @@ void __f2fs_replace_block(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 				type = CURSEG_WARM_DATA;
 		}
 	} else {
-		if (!IS_CURSEG(sbi, segno))
+		if (IS_CURSEG(sbi, segno)) {
+			/* se->type is volatile as SSR allocation */
+			type = __f2fs_get_curseg(sbi, segno);
+			f2fs_bug_on(sbi, type == NO_CHECK_TYPE);
+		} else {
 			type = CURSEG_WARM_DATA;
+		}
 	}
 
+	f2fs_bug_on(sbi, !IS_DATASEG(type));
 	curseg = CURSEG_I(sbi, type);
 
 	mutex_lock(&curseg->curseg_mutex);
-	mutex_lock(&sit_i->sentry_lock);
+	down_write(&sit_i->sentry_lock);
 
 	old_cursegno = curseg->segno;
 	old_blkoff = curseg->next_blkoff;
@@ -1603,7 +2930,7 @@ void __f2fs_replace_block(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 	/* change the current segment */
 	if (segno != curseg->segno) {
 		curseg->next_segno = segno;
-		change_curseg(sbi, type, true);
+		change_curseg(sbi, type);
 	}
 
 	curseg->next_blkoff = GET_BLKOFF_FROM_SEG0(sbi, new_blkaddr);
@@ -1622,13 +2949,14 @@ void __f2fs_replace_block(struct f2fs_sb_info *sbi, struct f2fs_summary *sum,
 	if (recover_curseg) {
 		if (old_cursegno != curseg->segno) {
 			curseg->next_segno = old_cursegno;
-			change_curseg(sbi, type, true);
+			change_curseg(sbi, type);
 		}
 		curseg->next_blkoff = old_blkoff;
 	}
 
-	mutex_unlock(&sit_i->sentry_lock);
+	up_write(&sit_i->sentry_lock);
 	mutex_unlock(&curseg->curseg_mutex);
+	up_write(&SM_I(sbi)->curseg_lock);
 }
 
 void f2fs_replace_block(struct f2fs_sb_info *sbi, struct dnode_of_data *dn,
@@ -1640,7 +2968,7 @@ void f2fs_replace_block(struct f2fs_sb_info *sbi, struct dnode_of_data *dn,
 
 	set_summary(&sum, dn->nid, dn->ofs_in_node, version);
 
-	__f2fs_replace_block(sbi, &sum, old_addr, new_addr,
+	f2fs_do_replace_block(sbi, &sum, old_addr, new_addr,
 					recover_curseg, recover_newaddr);
 
 	f2fs_update_data_blkaddr(dn, new_addr);
@@ -1652,7 +2980,8 @@ void f2fs_wait_on_page_writeback(struct page *page,
 	if (PageWriteback(page)) {
 		struct f2fs_sb_info *sbi = F2FS_P_SB(page);
 
-		f2fs_submit_merged_bio_cond(sbi, NULL, page, 0, type, WRITE);
+		f2fs_submit_merged_write_cond(sbi, page->mapping->host,
+						0, page->index, type);
 		if (ordered)
 			wait_on_page_writeback(page);
 		else
@@ -1660,12 +2989,11 @@ void f2fs_wait_on_page_writeback(struct page *page,
 	}
 }
 
-void f2fs_wait_on_encrypted_page_writeback(struct f2fs_sb_info *sbi,
-							block_t blkaddr)
+void f2fs_wait_on_block_writeback(struct f2fs_sb_info *sbi, block_t blkaddr)
 {
 	struct page *cpage;
 
-	if (blkaddr == NEW_ADDR || blkaddr == NULL_ADDR)
+	if (!is_valid_blkaddr(blkaddr))
 		return;
 
 	cpage = find_lock_page(META_MAPPING(sbi), blkaddr);
@@ -1675,7 +3003,7 @@ void f2fs_wait_on_encrypted_page_writeback(struct f2fs_sb_info *sbi,
 	}
 }
 
-static int read_compacted_summaries(struct f2fs_sb_info *sbi)
+static void read_compacted_summaries(struct f2fs_sb_info *sbi)
 {
 	struct f2fs_checkpoint *ckpt = F2FS_CKPT(sbi);
 	struct curseg_info *seg_i;
@@ -1686,7 +3014,7 @@ static int read_compacted_summaries(struct f2fs_sb_info *sbi)
 
 	start = start_sum_block(sbi);
 
-	page = get_meta_page(sbi, start++);
+	page = f2fs_get_meta_page(sbi, start++);
 	kaddr = (unsigned char *)page_address(page);
 
 	/* Step 1: restore nat cache */
@@ -1726,13 +3054,12 @@ static int read_compacted_summaries(struct f2fs_sb_info *sbi)
 			f2fs_put_page(page, 1);
 			page = NULL;
 
-			page = get_meta_page(sbi, start++);
+			page = f2fs_get_meta_page(sbi, start++);
 			kaddr = (unsigned char *)page_address(page);
 			offset = 0;
 		}
 	}
 	f2fs_put_page(page, 1);
-	return 0;
 }
 
 static int read_normal_summaries(struct f2fs_sb_info *sbi, int type)
@@ -1766,7 +3093,7 @@ static int read_normal_summaries(struct f2fs_sb_info *sbi, int type)
 			blk_addr = GET_SUM_BLOCK(sbi, segno);
 	}
 
-	new = get_meta_page(sbi, blk_addr);
+	new = f2fs_get_meta_page(sbi, blk_addr);
 	sum = (struct f2fs_summary_block *)page_address(new);
 
 	if (IS_NODESEG(type)) {
@@ -1778,13 +3105,7 @@ static int read_normal_summaries(struct f2fs_sb_info *sbi, int type)
 				ns->ofs_in_node = 0;
 			}
 		} else {
-			int err;
-
-			err = restore_node_summary(sbi, segno, sum);
-			if (err) {
-				f2fs_put_page(new, 1);
-				return err;
-			}
+			f2fs_restore_node_summary(sbi, segno, sum);
 		}
 	}
 
@@ -1816,20 +3137,19 @@ static int restore_curseg_summaries(struct f2fs_sb_info *sbi)
 	int err;
 
 	if (is_set_ckpt_flags(sbi, CP_COMPACT_SUM_FLAG)) {
-		int npages = npages_for_summary_flush(sbi, true);
+		int npages = f2fs_npages_for_summary_flush(sbi, true);
 
 		if (npages >= 2)
-			ra_meta_pages(sbi, start_sum_block(sbi), npages,
+			f2fs_ra_meta_pages(sbi, start_sum_block(sbi), npages,
 							META_CP, true);
 
 		/* restore for compacted data summary */
-		if (read_compacted_summaries(sbi))
-			return -EINVAL;
+		read_compacted_summaries(sbi);
 		type = CURSEG_HOT_NODE;
 	}
 
 	if (__exist_node_summaries(sbi))
-		ra_meta_pages(sbi, sum_blk_addr(sbi, NR_CURSEG_TYPE, type),
+		f2fs_ra_meta_pages(sbi, sum_blk_addr(sbi, NR_CURSEG_TYPE, type),
 					NR_CURSEG_TYPE - type, META_CP, true);
 
 	for (; type <= CURSEG_COLD_NODE; type++) {
@@ -1855,8 +3175,9 @@ static void write_compacted_summaries(struct f2fs_sb_info *sbi, block_t blkaddr)
 	int written_size = 0;
 	int i, j;
 
-	page = grab_meta_page(sbi, blkaddr++);
+	page = f2fs_grab_meta_page(sbi, blkaddr++);
 	kaddr = (unsigned char *)page_address(page);
+	memset(kaddr, 0, PAGE_SIZE);
 
 	/* Step 1: write nat cache */
 	seg_i = CURSEG_I(sbi, CURSEG_HOT_DATA);
@@ -1879,8 +3200,9 @@ static void write_compacted_summaries(struct f2fs_sb_info *sbi, block_t blkaddr)
 
 		for (j = 0; j < blkoff; j++) {
 			if (!page) {
-				page = grab_meta_page(sbi, blkaddr++);
+				page = f2fs_grab_meta_page(sbi, blkaddr++);
 				kaddr = (unsigned char *)page_address(page);
+				memset(kaddr, 0, PAGE_SIZE);
 				written_size = 0;
 			}
 			summary = (struct f2fs_summary *)(kaddr + written_size);
@@ -1915,7 +3237,7 @@ static void write_normal_summaries(struct f2fs_sb_info *sbi,
 		write_current_sum_page(sbi, i, blkaddr + (i - type));
 }
 
-void write_data_summaries(struct f2fs_sb_info *sbi, block_t start_blk)
+void f2fs_write_data_summaries(struct f2fs_sb_info *sbi, block_t start_blk)
 {
 	if (is_set_ckpt_flags(sbi, CP_COMPACT_SUM_FLAG))
 		write_compacted_summaries(sbi, start_blk);
@@ -1923,12 +3245,12 @@ void write_data_summaries(struct f2fs_sb_info *sbi, block_t start_blk)
 		write_normal_summaries(sbi, start_blk, CURSEG_HOT_DATA);
 }
 
-void write_node_summaries(struct f2fs_sb_info *sbi, block_t start_blk)
+void f2fs_write_node_summaries(struct f2fs_sb_info *sbi, block_t start_blk)
 {
 	write_normal_summaries(sbi, start_blk, CURSEG_HOT_NODE);
 }
 
-int lookup_journal_in_cursum(struct f2fs_journal *journal, int type,
+int f2fs_lookup_journal_in_cursum(struct f2fs_journal *journal, int type,
 					unsigned int val, int alloc)
 {
 	int i;
@@ -1953,35 +3275,26 @@ int lookup_journal_in_cursum(struct f2fs_journal *journal, int type,
 static struct page *get_current_sit_page(struct f2fs_sb_info *sbi,
 					unsigned int segno)
 {
-	return get_meta_page(sbi, current_sit_addr(sbi, segno));
+	return f2fs_get_meta_page(sbi, current_sit_addr(sbi, segno));
 }
 
 static struct page *get_next_sit_page(struct f2fs_sb_info *sbi,
 					unsigned int start)
 {
 	struct sit_info *sit_i = SIT_I(sbi);
-	struct page *src_page, *dst_page;
+	struct page *page;
 	pgoff_t src_off, dst_off;
-	void *src_addr, *dst_addr;
 
 	src_off = current_sit_addr(sbi, start);
 	dst_off = next_sit_addr(sbi, src_off);
 
-	/* get current sit block page without lock */
-	src_page = get_meta_page(sbi, src_off);
-	dst_page = grab_meta_page(sbi, dst_off);
-	f2fs_bug_on(sbi, PageDirty(src_page));
-
-	src_addr = page_address(src_page);
-	dst_addr = page_address(dst_page);
-	memcpy(dst_addr, src_addr, PAGE_SIZE);
-
-	set_page_dirty(dst_page);
-	f2fs_put_page(src_page, 1);
+	page = f2fs_grab_meta_page(sbi, dst_off);
+	seg_info_to_sit_page(sbi, page, start);
 
+	set_page_dirty(page);
 	set_to_next_sit(sit_i, start);
 
-	return dst_page;
+	return page;
 }
 
 static struct sit_entry_set *grab_sit_entry_set(void)
@@ -2071,7 +3384,7 @@ static void remove_sits_in_journal(struct f2fs_sb_info *sbi)
  * CP calls this function, which flushes SIT entries including sit_journal,
  * and moves prefree segs to free segs.
  */
-void flush_sit_entries(struct f2fs_sb_info *sbi, struct cp_control *cpc)
+void f2fs_flush_sit_entries(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 {
 	struct sit_info *sit_i = SIT_I(sbi);
 	unsigned long *bitmap = sit_i->dirty_sentries_bitmap;
@@ -2082,7 +3395,7 @@ void flush_sit_entries(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 	bool to_journal = true;
 	struct seg_entry *se;
 
-	mutex_lock(&sit_i->sentry_lock);
+	down_write(&sit_i->sentry_lock);
 
 	if (!sit_i->dirty_sentries)
 		goto out;
@@ -2130,25 +3443,34 @@ void flush_sit_entries(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 			int offset, sit_offset;
 
 			se = get_seg_entry(sbi, segno);
+#ifdef CONFIG_F2FS_CHECK_FS
+			if (memcmp(se->cur_valid_map, se->cur_valid_map_mir,
+						SIT_VBLOCK_MAP_SIZE))
+				f2fs_bug_on(sbi, 1);
+#endif
 
 			/* add discard candidates */
-			if (cpc->reason != CP_DISCARD) {
+			if (!(cpc->reason & CP_DISCARD)) {
 				cpc->trim_start = segno;
-				add_discard_addrs(sbi, cpc);
+				add_discard_addrs(sbi, cpc, false);
 			}
 
 			if (to_journal) {
-				offset = lookup_journal_in_cursum(journal,
+				offset = f2fs_lookup_journal_in_cursum(journal,
 							SIT_JOURNAL, segno, 1);
 				f2fs_bug_on(sbi, offset < 0);
 				segno_in_journal(journal, offset) =
 							cpu_to_le32(segno);
 				seg_info_to_raw_sit(se,
 					&sit_in_journal(journal, offset));
+				check_block_count(sbi, segno,
+					&sit_in_journal(journal, offset));
 			} else {
 				sit_offset = SIT_ENTRY_OFFSET(sit_i, segno);
 				seg_info_to_raw_sit(se,
 						&raw_sit->entries[sit_offset]);
+				check_block_count(sbi, segno,
+						&raw_sit->entries[sit_offset]);
 			}
 
 			__clear_bit(segno, bitmap);
@@ -2168,11 +3490,15 @@ void flush_sit_entries(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 	f2fs_bug_on(sbi, !list_empty(head));
 	f2fs_bug_on(sbi, sit_i->dirty_sentries);
 out:
-	if (cpc->reason == CP_DISCARD) {
+	if (cpc->reason & CP_DISCARD) {
+		__u64 trim_start = cpc->trim_start;
+
 		for (; cpc->trim_start <= cpc->trim_end; cpc->trim_start++)
-			add_discard_addrs(sbi, cpc);
+			add_discard_addrs(sbi, cpc, false);
+
+		cpc->trim_start = trim_start;
 	}
-	mutex_unlock(&sit_i->sentry_lock);
+	up_write(&sit_i->sentry_lock);
 
 	set_prefree_as_free_segments(sbi);
 }
@@ -2180,53 +3506,65 @@ void flush_sit_entries(struct f2fs_sb_info *sbi, struct cp_control *cpc)
 static int build_sit_info(struct f2fs_sb_info *sbi)
 {
 	struct f2fs_super_block *raw_super = F2FS_RAW_SUPER(sbi);
-	struct f2fs_checkpoint *ckpt = F2FS_CKPT(sbi);
 	struct sit_info *sit_i;
 	unsigned int sit_segs, start;
-	char *src_bitmap, *dst_bitmap;
+	char *src_bitmap;
 	unsigned int bitmap_size;
 
 	/* allocate memory for SIT information */
-	sit_i = kzalloc(sizeof(struct sit_info), GFP_KERNEL);
+	sit_i = f2fs_kzalloc(sbi, sizeof(struct sit_info), GFP_KERNEL);
 	if (!sit_i)
 		return -ENOMEM;
 
 	SM_I(sbi)->sit_info = sit_i;
 
-	sit_i->sentries = f2fs_kvzalloc(MAIN_SEGS(sbi) *
-					sizeof(struct seg_entry), GFP_KERNEL);
+	sit_i->sentries =
+		f2fs_kvzalloc(sbi, array_size(sizeof(struct seg_entry),
+					      MAIN_SEGS(sbi)),
+			      GFP_KERNEL);
 	if (!sit_i->sentries)
 		return -ENOMEM;
 
 	bitmap_size = f2fs_bitmap_size(MAIN_SEGS(sbi));
-	sit_i->dirty_sentries_bitmap = f2fs_kvzalloc(bitmap_size, GFP_KERNEL);
+	sit_i->dirty_sentries_bitmap = f2fs_kvzalloc(sbi, bitmap_size,
+								GFP_KERNEL);
 	if (!sit_i->dirty_sentries_bitmap)
 		return -ENOMEM;
 
 	for (start = 0; start < MAIN_SEGS(sbi); start++) {
 		sit_i->sentries[start].cur_valid_map
-			= kzalloc(SIT_VBLOCK_MAP_SIZE, GFP_KERNEL);
+			= f2fs_kzalloc(sbi, SIT_VBLOCK_MAP_SIZE, GFP_KERNEL);
 		sit_i->sentries[start].ckpt_valid_map
-			= kzalloc(SIT_VBLOCK_MAP_SIZE, GFP_KERNEL);
+			= f2fs_kzalloc(sbi, SIT_VBLOCK_MAP_SIZE, GFP_KERNEL);
 		if (!sit_i->sentries[start].cur_valid_map ||
 				!sit_i->sentries[start].ckpt_valid_map)
 			return -ENOMEM;
 
+#ifdef CONFIG_F2FS_CHECK_FS
+		sit_i->sentries[start].cur_valid_map_mir
+			= f2fs_kzalloc(sbi, SIT_VBLOCK_MAP_SIZE, GFP_KERNEL);
+		if (!sit_i->sentries[start].cur_valid_map_mir)
+			return -ENOMEM;
+#endif
+
 		if (f2fs_discard_en(sbi)) {
 			sit_i->sentries[start].discard_map
-				= kzalloc(SIT_VBLOCK_MAP_SIZE, GFP_KERNEL);
+				= f2fs_kzalloc(sbi, SIT_VBLOCK_MAP_SIZE,
+								GFP_KERNEL);
 			if (!sit_i->sentries[start].discard_map)
 				return -ENOMEM;
 		}
 	}
 
-	sit_i->tmp_map = kzalloc(SIT_VBLOCK_MAP_SIZE, GFP_KERNEL);
+	sit_i->tmp_map = f2fs_kzalloc(sbi, SIT_VBLOCK_MAP_SIZE, GFP_KERNEL);
 	if (!sit_i->tmp_map)
 		return -ENOMEM;
 
 	if (sbi->segs_per_sec > 1) {
-		sit_i->sec_entries = f2fs_kvzalloc(MAIN_SECS(sbi) *
-					sizeof(struct sec_entry), GFP_KERNEL);
+		sit_i->sec_entries =
+			f2fs_kvzalloc(sbi, array_size(sizeof(struct sec_entry),
+						      MAIN_SECS(sbi)),
+				      GFP_KERNEL);
 		if (!sit_i->sec_entries)
 			return -ENOMEM;
 	}
@@ -2238,23 +3576,28 @@ static int build_sit_info(struct f2fs_sb_info *sbi)
 	bitmap_size = __bitmap_size(sbi, SIT_BITMAP);
 	src_bitmap = __bitmap_ptr(sbi, SIT_BITMAP);
 
-	dst_bitmap = kmemdup(src_bitmap, bitmap_size, GFP_KERNEL);
-	if (!dst_bitmap)
+	sit_i->sit_bitmap = kmemdup(src_bitmap, bitmap_size, GFP_KERNEL);
+	if (!sit_i->sit_bitmap)
 		return -ENOMEM;
 
+#ifdef CONFIG_F2FS_CHECK_FS
+	sit_i->sit_bitmap_mir = kmemdup(src_bitmap, bitmap_size, GFP_KERNEL);
+	if (!sit_i->sit_bitmap_mir)
+		return -ENOMEM;
+#endif
+
 	/* init SIT information */
 	sit_i->s_ops = &default_salloc_ops;
 
 	sit_i->sit_base_addr = le32_to_cpu(raw_super->sit_blkaddr);
 	sit_i->sit_blocks = sit_segs << sbi->log_blocks_per_seg;
-	sit_i->written_valid_blocks = le64_to_cpu(ckpt->valid_block_count);
-	sit_i->sit_bitmap = dst_bitmap;
+	sit_i->written_valid_blocks = 0;
 	sit_i->bitmap_size = bitmap_size;
 	sit_i->dirty_sentries = 0;
 	sit_i->sents_per_block = SIT_ENTRY_PER_BLOCK;
 	sit_i->elapsed_time = le64_to_cpu(sbi->ckpt->elapsed_time);
-	sit_i->mounted_time = CURRENT_TIME_SEC.tv_sec;
-	mutex_init(&sit_i->sentry_lock);
+	sit_i->mounted_time = ktime_get_real_seconds();
+	init_rwsem(&sit_i->sentry_lock);
 	return 0;
 }
 
@@ -2264,19 +3607,19 @@ static int build_free_segmap(struct f2fs_sb_info *sbi)
 	unsigned int bitmap_size, sec_bitmap_size;
 
 	/* allocate memory for free segmap information */
-	free_i = kzalloc(sizeof(struct free_segmap_info), GFP_KERNEL);
+	free_i = f2fs_kzalloc(sbi, sizeof(struct free_segmap_info), GFP_KERNEL);
 	if (!free_i)
 		return -ENOMEM;
 
 	SM_I(sbi)->free_info = free_i;
 
 	bitmap_size = f2fs_bitmap_size(MAIN_SEGS(sbi));
-	free_i->free_segmap = f2fs_kvmalloc(bitmap_size, GFP_KERNEL);
+	free_i->free_segmap = f2fs_kvmalloc(sbi, bitmap_size, GFP_KERNEL);
 	if (!free_i->free_segmap)
 		return -ENOMEM;
 
 	sec_bitmap_size = f2fs_bitmap_size(MAIN_SECS(sbi));
-	free_i->free_secmap = f2fs_kvmalloc(sec_bitmap_size, GFP_KERNEL);
+	free_i->free_secmap = f2fs_kvmalloc(sbi, sec_bitmap_size, GFP_KERNEL);
 	if (!free_i->free_secmap)
 		return -ENOMEM;
 
@@ -2297,7 +3640,8 @@ static int build_curseg(struct f2fs_sb_info *sbi)
 	struct curseg_info *array;
 	int i;
 
-	array = kcalloc(NR_CURSEG_TYPE, sizeof(*array), GFP_KERNEL);
+	array = f2fs_kzalloc(sbi, array_size(NR_CURSEG_TYPE, sizeof(*array)),
+			     GFP_KERNEL);
 	if (!array)
 		return -ENOMEM;
 
@@ -2305,12 +3649,12 @@ static int build_curseg(struct f2fs_sb_info *sbi)
 
 	for (i = 0; i < NR_CURSEG_TYPE; i++) {
 		mutex_init(&array[i].curseg_mutex);
-		array[i].sum_blk = kzalloc(PAGE_SIZE, GFP_KERNEL);
+		array[i].sum_blk = f2fs_kzalloc(sbi, PAGE_SIZE, GFP_KERNEL);
 		if (!array[i].sum_blk)
 			return -ENOMEM;
 		init_rwsem(&array[i].journal_rwsem);
-		array[i].journal = kzalloc(sizeof(struct f2fs_journal),
-							GFP_KERNEL);
+		array[i].journal = f2fs_kzalloc(sbi,
+				sizeof(struct f2fs_journal), GFP_KERNEL);
 		if (!array[i].journal)
 			return -ENOMEM;
 		array[i].segno = NULL_SEGNO;
@@ -2319,7 +3663,7 @@ static int build_curseg(struct f2fs_sb_info *sbi)
 	return restore_curseg_summaries(sbi);
 }
 
-static void build_sit_entries(struct f2fs_sb_info *sbi)
+static int build_sit_entries(struct f2fs_sb_info *sbi)
 {
 	struct sit_info *sit_i = SIT_I(sbi);
 	struct curseg_info *curseg = CURSEG_I(sbi, CURSEG_COLD_DATA);
@@ -2329,10 +3673,12 @@ static void build_sit_entries(struct f2fs_sb_info *sbi)
 	int sit_blk_cnt = SIT_BLK_CNT(sbi);
 	unsigned int i, start, end;
 	unsigned int readed, start_blk = 0;
-	int nrpages = MAX_BIO_BLOCKS(sbi) * 8;
+	int err = 0;
+	block_t total_node_blocks = 0;
 
 	do {
-		readed = ra_meta_pages(sbi, start_blk, nrpages, META_SIT, true);
+		readed = f2fs_ra_meta_pages(sbi, start_blk, BIO_MAX_PAGES,
+							META_SIT, true);
 
 		start = start_blk * sit_i->sents_per_block;
 		end = (start_blk + readed) * sit_i->sents_per_block;
@@ -2347,15 +3693,26 @@ static void build_sit_entries(struct f2fs_sb_info *sbi)
 			sit = sit_blk->entries[SIT_ENTRY_OFFSET(sit_i, start)];
 			f2fs_put_page(page, 1);
 
-			check_block_count(sbi, start, &sit);
+			err = check_block_count(sbi, start, &sit);
+			if (err)
+				return err;
 			seg_info_from_raw_sit(se, &sit);
+			if (IS_NODESEG(se->type))
+				total_node_blocks += se->valid_blocks;
 
 			/* build discard map only one time */
 			if (f2fs_discard_en(sbi)) {
-				memcpy(se->discard_map, se->cur_valid_map,
-							SIT_VBLOCK_MAP_SIZE);
-				sbi->discard_blks += sbi->blocks_per_seg -
-							se->valid_blocks;
+				if (is_set_ckpt_flags(sbi, CP_TRIMMED_FLAG)) {
+					memset(se->discard_map, 0xff,
+						SIT_VBLOCK_MAP_SIZE);
+				} else {
+					memcpy(se->discard_map,
+						se->cur_valid_map,
+						SIT_VBLOCK_MAP_SIZE);
+					sbi->discard_blks +=
+						sbi->blocks_per_seg -
+						se->valid_blocks;
+				}
 			}
 
 			if (sbi->segs_per_sec > 1)
@@ -2370,26 +3727,59 @@ static void build_sit_entries(struct f2fs_sb_info *sbi)
 		unsigned int old_valid_blocks;
 
 		start = le32_to_cpu(segno_in_journal(journal, i));
+		if (start >= MAIN_SEGS(sbi)) {
+			f2fs_msg(sbi->sb, KERN_ERR,
+					"Wrong journal entry on segno %u",
+					start);
+			set_sbi_flag(sbi, SBI_NEED_FSCK);
+			err = -EINVAL;
+			break;
+		}
+
 		se = &sit_i->sentries[start];
 		sit = sit_in_journal(journal, i);
 
 		old_valid_blocks = se->valid_blocks;
+		if (IS_NODESEG(se->type))
+			total_node_blocks -= old_valid_blocks;
 
-		check_block_count(sbi, start, &sit);
+		err = check_block_count(sbi, start, &sit);
+		if (err)
+			break;
 		seg_info_from_raw_sit(se, &sit);
+		if (IS_NODESEG(se->type))
+			total_node_blocks += se->valid_blocks;
 
 		if (f2fs_discard_en(sbi)) {
-			memcpy(se->discard_map, se->cur_valid_map,
-						SIT_VBLOCK_MAP_SIZE);
-			sbi->discard_blks += old_valid_blocks -
-						se->valid_blocks;
+			if (is_set_ckpt_flags(sbi, CP_TRIMMED_FLAG)) {
+				memset(se->discard_map, 0xff,
+							SIT_VBLOCK_MAP_SIZE);
+			} else {
+				memcpy(se->discard_map, se->cur_valid_map,
+							SIT_VBLOCK_MAP_SIZE);
+				sbi->discard_blks += old_valid_blocks;
+				sbi->discard_blks -= se->valid_blocks;
+			}
 		}
 
-		if (sbi->segs_per_sec > 1)
+		if (sbi->segs_per_sec > 1) {
 			get_sec_entry(sbi, start)->valid_blocks +=
-				se->valid_blocks - old_valid_blocks;
+							se->valid_blocks;
+			get_sec_entry(sbi, start)->valid_blocks -=
+							old_valid_blocks;
+		}
 	}
 	up_read(&curseg->journal_rwsem);
+
+	if (!err && total_node_blocks != valid_node_count(sbi)) {
+		f2fs_msg(sbi->sb, KERN_ERR,
+			"SIT is corrupted node# %u vs %u",
+			total_node_blocks, valid_node_count(sbi));
+		set_sbi_flag(sbi, SBI_NEED_FSCK);
+		err = -EINVAL;
+	}
+
+	return err;
 }
 
 static void init_free_segmap(struct f2fs_sb_info *sbi)
@@ -2401,6 +3791,9 @@ static void init_free_segmap(struct f2fs_sb_info *sbi)
 		struct seg_entry *sentry = get_seg_entry(sbi, start);
 		if (!sentry->valid_blocks)
 			__set_free(sbi, start);
+		else
+			SIT_I(sbi)->written_valid_blocks +=
+						sentry->valid_blocks;
 	}
 
 	/* set use the current segments */
@@ -2423,7 +3816,7 @@ static void init_dirty_segmap(struct f2fs_sb_info *sbi)
 		if (segno >= MAIN_SEGS(sbi))
 			break;
 		offset = segno + 1;
-		valid_blocks = get_valid_blocks(sbi, segno, 0);
+		valid_blocks = get_valid_blocks(sbi, segno, false);
 		if (valid_blocks == sbi->blocks_per_seg || !valid_blocks)
 			continue;
 		if (valid_blocks > sbi->blocks_per_seg) {
@@ -2441,7 +3834,7 @@ static int init_victim_secmap(struct f2fs_sb_info *sbi)
 	struct dirty_seglist_info *dirty_i = DIRTY_I(sbi);
 	unsigned int bitmap_size = f2fs_bitmap_size(MAIN_SECS(sbi));
 
-	dirty_i->victim_secmap = f2fs_kvzalloc(bitmap_size, GFP_KERNEL);
+	dirty_i->victim_secmap = f2fs_kvzalloc(sbi, bitmap_size, GFP_KERNEL);
 	if (!dirty_i->victim_secmap)
 		return -ENOMEM;
 	return 0;
@@ -2453,7 +3846,8 @@ static int build_dirty_segmap(struct f2fs_sb_info *sbi)
 	unsigned int bitmap_size, i;
 
 	/* allocate memory for dirty segments list information */
-	dirty_i = kzalloc(sizeof(struct dirty_seglist_info), GFP_KERNEL);
+	dirty_i = f2fs_kzalloc(sbi, sizeof(struct dirty_seglist_info),
+								GFP_KERNEL);
 	if (!dirty_i)
 		return -ENOMEM;
 
@@ -2463,7 +3857,8 @@ static int build_dirty_segmap(struct f2fs_sb_info *sbi)
 	bitmap_size = f2fs_bitmap_size(MAIN_SEGS(sbi));
 
 	for (i = 0; i < NR_DIRTY_TYPE; i++) {
-		dirty_i->dirty_segmap[i] = f2fs_kvzalloc(bitmap_size, GFP_KERNEL);
+		dirty_i->dirty_segmap[i] = f2fs_kvzalloc(sbi, bitmap_size,
+								GFP_KERNEL);
 		if (!dirty_i->dirty_segmap[i])
 			return -ENOMEM;
 	}
@@ -2480,9 +3875,9 @@ static void init_min_max_mtime(struct f2fs_sb_info *sbi)
 	struct sit_info *sit_i = SIT_I(sbi);
 	unsigned int segno;
 
-	mutex_lock(&sit_i->sentry_lock);
+	down_write(&sit_i->sentry_lock);
 
-	sit_i->min_mtime = LLONG_MAX;
+	sit_i->min_mtime = ULLONG_MAX;
 
 	for (segno = 0; segno < MAIN_SEGS(sbi); segno += sbi->segs_per_sec) {
 		unsigned int i;
@@ -2496,18 +3891,18 @@ static void init_min_max_mtime(struct f2fs_sb_info *sbi)
 		if (sit_i->min_mtime > mtime)
 			sit_i->min_mtime = mtime;
 	}
-	sit_i->max_mtime = get_mtime(sbi);
-	mutex_unlock(&sit_i->sentry_lock);
+	sit_i->max_mtime = get_mtime(sbi, false);
+	up_write(&sit_i->sentry_lock);
 }
 
-int build_segment_manager(struct f2fs_sb_info *sbi)
+int f2fs_build_segment_manager(struct f2fs_sb_info *sbi)
 {
 	struct f2fs_super_block *raw_super = F2FS_RAW_SUPER(sbi);
 	struct f2fs_checkpoint *ckpt = F2FS_CKPT(sbi);
 	struct f2fs_sm_info *sm_info;
 	int err;
 
-	sm_info = kzalloc(sizeof(struct f2fs_sm_info), GFP_KERNEL);
+	sm_info = f2fs_kzalloc(sbi, sizeof(struct f2fs_sm_info), GFP_KERNEL);
 	if (!sm_info)
 		return -ENOMEM;
 
@@ -2529,22 +3924,23 @@ int build_segment_manager(struct f2fs_sb_info *sbi)
 		sm_info->ipu_policy = 1 << F2FS_IPU_FSYNC;
 	sm_info->min_ipu_util = DEF_MIN_IPU_UTIL;
 	sm_info->min_fsync_blocks = DEF_MIN_FSYNC_BLOCKS;
-
-	INIT_LIST_HEAD(&sm_info->discard_list);
-	INIT_LIST_HEAD(&sm_info->wait_list);
-	sm_info->nr_discards = 0;
-	sm_info->max_discards = 0;
-
-	sm_info->trim_sections = DEF_BATCHED_TRIM_SECTIONS;
+	sm_info->min_hot_blocks = DEF_MIN_HOT_BLOCKS;
+	sm_info->min_ssr_sections = reserved_sections(sbi);
 
 	INIT_LIST_HEAD(&sm_info->sit_entry_set);
 
-	if (test_opt(sbi, FLUSH_MERGE) && !f2fs_readonly(sbi->sb)) {
-		err = create_flush_cmd_control(sbi);
+	init_rwsem(&sm_info->curseg_lock);
+
+	if (!f2fs_readonly(sbi->sb)) {
+		err = f2fs_create_flush_cmd_control(sbi);
 		if (err)
 			return err;
 	}
 
+	err = create_discard_cmd_control(sbi);
+	if (err)
+		return err;
+
 	err = build_sit_info(sbi);
 	if (err)
 		return err;
@@ -2556,7 +3952,9 @@ int build_segment_manager(struct f2fs_sb_info *sbi)
 		return err;
 
 	/* reinit free segmap based on SIT */
-	build_sit_entries(sbi);
+	err = build_sit_entries(sbi);
+	if (err)
+		return err;
 
 	init_free_segmap(sbi);
 	err = build_dirty_segmap(sbi);
@@ -2638,6 +4036,9 @@ static void destroy_sit_info(struct f2fs_sb_info *sbi)
 	if (sit_i->sentries) {
 		for (start = 0; start < MAIN_SEGS(sbi); start++) {
 			kfree(sit_i->sentries[start].cur_valid_map);
+#ifdef CONFIG_F2FS_CHECK_FS
+			kfree(sit_i->sentries[start].cur_valid_map_mir);
+#endif
 			kfree(sit_i->sentries[start].ckpt_valid_map);
 			kfree(sit_i->sentries[start].discard_map);
 		}
@@ -2650,16 +4051,20 @@ static void destroy_sit_info(struct f2fs_sb_info *sbi)
 
 	SM_I(sbi)->sit_info = NULL;
 	kfree(sit_i->sit_bitmap);
+#ifdef CONFIG_F2FS_CHECK_FS
+	kfree(sit_i->sit_bitmap_mir);
+#endif
 	kfree(sit_i);
 }
 
-void destroy_segment_manager(struct f2fs_sb_info *sbi)
+void f2fs_destroy_segment_manager(struct f2fs_sb_info *sbi)
 {
 	struct f2fs_sm_info *sm_info = SM_I(sbi);
 
 	if (!sm_info)
 		return;
-	destroy_flush_cmd_control(sbi);
+	f2fs_destroy_flush_cmd_control(sbi, true);
+	destroy_discard_cmd_control(sbi);
 	destroy_dirty_segmap(sbi);
 	destroy_curseg(sbi);
 	destroy_free_segmap(sbi);
@@ -2668,22 +4073,22 @@ void destroy_segment_manager(struct f2fs_sb_info *sbi)
 	kfree(sm_info);
 }
 
-int __init create_segment_manager_caches(void)
+int __init f2fs_create_segment_manager_caches(void)
 {
 	discard_entry_slab = f2fs_kmem_cache_create("discard_entry",
 			sizeof(struct discard_entry));
 	if (!discard_entry_slab)
 		goto fail;
 
-	bio_entry_slab = f2fs_kmem_cache_create("bio_entry",
-			sizeof(struct bio_entry));
-	if (!bio_entry_slab)
+	discard_cmd_slab = f2fs_kmem_cache_create("discard_cmd",
+			sizeof(struct discard_cmd));
+	if (!discard_cmd_slab)
 		goto destroy_discard_entry;
 
 	sit_entry_set_slab = f2fs_kmem_cache_create("sit_entry_set",
 			sizeof(struct sit_entry_set));
 	if (!sit_entry_set_slab)
-		goto destroy_bio_entry;
+		goto destroy_discard_cmd;
 
 	inmem_entry_slab = f2fs_kmem_cache_create("inmem_page_entry",
 			sizeof(struct inmem_pages));
@@ -2693,18 +4098,18 @@ int __init create_segment_manager_caches(void)
 
 destroy_sit_entry_set:
 	kmem_cache_destroy(sit_entry_set_slab);
-destroy_bio_entry:
-	kmem_cache_destroy(bio_entry_slab);
+destroy_discard_cmd:
+	kmem_cache_destroy(discard_cmd_slab);
 destroy_discard_entry:
 	kmem_cache_destroy(discard_entry_slab);
 fail:
 	return -ENOMEM;
 }
 
-void destroy_segment_manager_caches(void)
+void f2fs_destroy_segment_manager_caches(void)
 {
 	kmem_cache_destroy(sit_entry_set_slab);
-	kmem_cache_destroy(bio_entry_slab);
+	kmem_cache_destroy(discard_cmd_slab);
 	kmem_cache_destroy(discard_entry_slab);
 	kmem_cache_destroy(inmem_entry_slab);
 }
diff --git a/fs/f2fs/segment.h b/fs/f2fs/segment.h
index b164f83..f18fc82 100644
--- a/fs/f2fs/segment.h
+++ b/fs/f2fs/segment.h
@@ -18,79 +18,97 @@
 #define DEF_RECLAIM_PREFREE_SEGMENTS	5	/* 5% over total segments */
 #define DEF_MAX_RECLAIM_PREFREE_SEGMENTS	4096	/* 8GB in maximum */
 
+#define F2FS_MIN_SEGMENTS	9 /* SB + 2 (CP + SIT + NAT) + SSA + MAIN */
+
 /* L: Logical segment # in volume, R: Relative segment # in main area */
-#define GET_L2R_SEGNO(free_i, segno)	(segno - free_i->start_segno)
-#define GET_R2L_SEGNO(free_i, segno)	(segno + free_i->start_segno)
+#define GET_L2R_SEGNO(free_i, segno)	((segno) - (free_i)->start_segno)
+#define GET_R2L_SEGNO(free_i, segno)	((segno) + (free_i)->start_segno)
+
+#define IS_DATASEG(t)	((t) <= CURSEG_COLD_DATA)
+#define IS_NODESEG(t)	((t) >= CURSEG_HOT_NODE)
 
-#define IS_DATASEG(t)	(t <= CURSEG_COLD_DATA)
-#define IS_NODESEG(t)	(t >= CURSEG_HOT_NODE)
+#define IS_HOT(t)	((t) == CURSEG_HOT_NODE || (t) == CURSEG_HOT_DATA)
+#define IS_WARM(t)	((t) == CURSEG_WARM_NODE || (t) == CURSEG_WARM_DATA)
+#define IS_COLD(t)	((t) == CURSEG_COLD_NODE || (t) == CURSEG_COLD_DATA)
 
 #define IS_CURSEG(sbi, seg)						\
-	((seg == CURSEG_I(sbi, CURSEG_HOT_DATA)->segno) ||	\
-	 (seg == CURSEG_I(sbi, CURSEG_WARM_DATA)->segno) ||	\
-	 (seg == CURSEG_I(sbi, CURSEG_COLD_DATA)->segno) ||	\
-	 (seg == CURSEG_I(sbi, CURSEG_HOT_NODE)->segno) ||	\
-	 (seg == CURSEG_I(sbi, CURSEG_WARM_NODE)->segno) ||	\
-	 (seg == CURSEG_I(sbi, CURSEG_COLD_NODE)->segno))
+	(((seg) == CURSEG_I(sbi, CURSEG_HOT_DATA)->segno) ||	\
+	 ((seg) == CURSEG_I(sbi, CURSEG_WARM_DATA)->segno) ||	\
+	 ((seg) == CURSEG_I(sbi, CURSEG_COLD_DATA)->segno) ||	\
+	 ((seg) == CURSEG_I(sbi, CURSEG_HOT_NODE)->segno) ||	\
+	 ((seg) == CURSEG_I(sbi, CURSEG_WARM_NODE)->segno) ||	\
+	 ((seg) == CURSEG_I(sbi, CURSEG_COLD_NODE)->segno))
 
 #define IS_CURSEC(sbi, secno)						\
-	((secno == CURSEG_I(sbi, CURSEG_HOT_DATA)->segno /		\
-	  sbi->segs_per_sec) ||	\
-	 (secno == CURSEG_I(sbi, CURSEG_WARM_DATA)->segno /		\
-	  sbi->segs_per_sec) ||	\
-	 (secno == CURSEG_I(sbi, CURSEG_COLD_DATA)->segno /		\
-	  sbi->segs_per_sec) ||	\
-	 (secno == CURSEG_I(sbi, CURSEG_HOT_NODE)->segno /		\
-	  sbi->segs_per_sec) ||	\
-	 (secno == CURSEG_I(sbi, CURSEG_WARM_NODE)->segno /		\
-	  sbi->segs_per_sec) ||	\
-	 (secno == CURSEG_I(sbi, CURSEG_COLD_NODE)->segno /		\
-	  sbi->segs_per_sec))	\
-
-#define MAIN_BLKADDR(sbi)	(SM_I(sbi)->main_blkaddr)
-#define SEG0_BLKADDR(sbi)	(SM_I(sbi)->seg0_blkaddr)
+	(((secno) == CURSEG_I(sbi, CURSEG_HOT_DATA)->segno /		\
+	  (sbi)->segs_per_sec) ||	\
+	 ((secno) == CURSEG_I(sbi, CURSEG_WARM_DATA)->segno /		\
+	  (sbi)->segs_per_sec) ||	\
+	 ((secno) == CURSEG_I(sbi, CURSEG_COLD_DATA)->segno /		\
+	  (sbi)->segs_per_sec) ||	\
+	 ((secno) == CURSEG_I(sbi, CURSEG_HOT_NODE)->segno /		\
+	  (sbi)->segs_per_sec) ||	\
+	 ((secno) == CURSEG_I(sbi, CURSEG_WARM_NODE)->segno /		\
+	  (sbi)->segs_per_sec) ||	\
+	 ((secno) == CURSEG_I(sbi, CURSEG_COLD_NODE)->segno /		\
+	  (sbi)->segs_per_sec))	\
+
+#define MAIN_BLKADDR(sbi)						\
+	(SM_I(sbi) ? SM_I(sbi)->main_blkaddr : 				\
+		le32_to_cpu(F2FS_RAW_SUPER(sbi)->main_blkaddr))
+#define SEG0_BLKADDR(sbi)						\
+	(SM_I(sbi) ? SM_I(sbi)->seg0_blkaddr : 				\
+		le32_to_cpu(F2FS_RAW_SUPER(sbi)->segment0_blkaddr))
 
 #define MAIN_SEGS(sbi)	(SM_I(sbi)->main_segments)
-#define MAIN_SECS(sbi)	(sbi->total_sections)
+#define MAIN_SECS(sbi)	((sbi)->total_sections)
 
-#define TOTAL_SEGS(sbi)	(SM_I(sbi)->segment_count)
-#define TOTAL_BLKS(sbi)	(TOTAL_SEGS(sbi) << sbi->log_blocks_per_seg)
+#define TOTAL_SEGS(sbi)							\
+	(SM_I(sbi) ? SM_I(sbi)->segment_count : 				\
+		le32_to_cpu(F2FS_RAW_SUPER(sbi)->segment_count))
+#define TOTAL_BLKS(sbi)	(TOTAL_SEGS(sbi) << (sbi)->log_blocks_per_seg)
 
 #define MAX_BLKADDR(sbi)	(SEG0_BLKADDR(sbi) + TOTAL_BLKS(sbi))
-#define SEGMENT_SIZE(sbi)	(1ULL << (sbi->log_blocksize +		\
-					sbi->log_blocks_per_seg))
+#define SEGMENT_SIZE(sbi)	(1ULL << ((sbi)->log_blocksize +	\
+					(sbi)->log_blocks_per_seg))
 
 #define START_BLOCK(sbi, segno)	(SEG0_BLKADDR(sbi) +			\
-	 (GET_R2L_SEGNO(FREE_I(sbi), segno) << sbi->log_blocks_per_seg))
+	 (GET_R2L_SEGNO(FREE_I(sbi), segno) << (sbi)->log_blocks_per_seg))
 
 #define NEXT_FREE_BLKADDR(sbi, curseg)					\
-	(START_BLOCK(sbi, curseg->segno) + curseg->next_blkoff)
+	(START_BLOCK(sbi, (curseg)->segno) + (curseg)->next_blkoff)
 
 #define GET_SEGOFF_FROM_SEG0(sbi, blk_addr)	((blk_addr) - SEG0_BLKADDR(sbi))
 #define GET_SEGNO_FROM_SEG0(sbi, blk_addr)				\
-	(GET_SEGOFF_FROM_SEG0(sbi, blk_addr) >> sbi->log_blocks_per_seg)
+	(GET_SEGOFF_FROM_SEG0(sbi, blk_addr) >> (sbi)->log_blocks_per_seg)
 #define GET_BLKOFF_FROM_SEG0(sbi, blk_addr)				\
-	(GET_SEGOFF_FROM_SEG0(sbi, blk_addr) & (sbi->blocks_per_seg - 1))
+	(GET_SEGOFF_FROM_SEG0(sbi, blk_addr) & ((sbi)->blocks_per_seg - 1))
 
 #define GET_SEGNO(sbi, blk_addr)					\
-	(((blk_addr == NULL_ADDR) || (blk_addr == NEW_ADDR)) ?		\
+	((!is_valid_blkaddr(blk_addr)) ?			\
 	NULL_SEGNO : GET_L2R_SEGNO(FREE_I(sbi),			\
 		GET_SEGNO_FROM_SEG0(sbi, blk_addr)))
-#define GET_SECNO(sbi, segno)					\
-	((segno) / sbi->segs_per_sec)
-#define GET_ZONENO_FROM_SEGNO(sbi, segno)				\
-	((segno / sbi->segs_per_sec) / sbi->secs_per_zone)
+#define BLKS_PER_SEC(sbi)					\
+	((sbi)->segs_per_sec * (sbi)->blocks_per_seg)
+#define GET_SEC_FROM_SEG(sbi, segno)				\
+	((segno) / (sbi)->segs_per_sec)
+#define GET_SEG_FROM_SEC(sbi, secno)				\
+	((secno) * (sbi)->segs_per_sec)
+#define GET_ZONE_FROM_SEC(sbi, secno)				\
+	((secno) / (sbi)->secs_per_zone)
+#define GET_ZONE_FROM_SEG(sbi, segno)				\
+	GET_ZONE_FROM_SEC(sbi, GET_SEC_FROM_SEG(sbi, segno))
 
 #define GET_SUM_BLOCK(sbi, segno)				\
-	((sbi->sm_info->ssa_blkaddr) + segno)
+	((sbi)->sm_info->ssa_blkaddr + (segno))
 
 #define GET_SUM_TYPE(footer) ((footer)->entry_type)
-#define SET_SUM_TYPE(footer, type) ((footer)->entry_type = type)
+#define SET_SUM_TYPE(footer, type) ((footer)->entry_type = (type))
 
 #define SIT_ENTRY_OFFSET(sit_i, segno)					\
-	(segno % sit_i->sents_per_block)
+	((segno) % (sit_i)->sents_per_block)
 #define SIT_BLOCK_OFFSET(segno)					\
-	(segno / SIT_ENTRY_PER_BLOCK)
+	((segno) / SIT_ENTRY_PER_BLOCK)
 #define	START_SEGNO(segno)		\
 	(SIT_BLOCK_OFFSET(segno) * SIT_ENTRY_PER_BLOCK)
 #define SIT_BLK_CNT(sbi)			\
@@ -101,9 +119,7 @@
 #define SECTOR_FROM_BLOCK(blk_addr)					\
 	(((sector_t)blk_addr) << F2FS_LOG_SECTORS_PER_BLOCK)
 #define SECTOR_TO_BLOCK(sectors)					\
-	(sectors >> F2FS_LOG_SECTORS_PER_BLOCK)
-#define MAX_BIO_BLOCKS(sbi)						\
-	((int)min((int)max_hw_blocks(sbi), BIO_MAX_PAGES))
+	((sectors) >> F2FS_LOG_SECTORS_PER_BLOCK)
 
 /*
  * indicate a block allocation direction: RIGHT and LEFT.
@@ -132,7 +148,10 @@ enum {
  */
 enum {
 	GC_CB = 0,
-	GC_GREEDY
+	GC_GREEDY,
+	ALLOC_NEXT,
+	FLUSH_DEVICE,
+	MAX_GC_POLICY,
 };
 
 /*
@@ -164,6 +183,9 @@ struct seg_entry {
 	unsigned int ckpt_valid_blocks:10;	/* # of valid blocks last cp */
 	unsigned int padding:6;		/* padding */
 	unsigned char *cur_valid_map;	/* validity bitmap of blocks */
+#ifdef CONFIG_F2FS_CHECK_FS
+	unsigned char *cur_valid_map_mir;	/* mirror of current valid bitmap */
+#endif
 	/*
 	 * # of valid blocks and the validity bitmap stored in the the last
 	 * checkpoint pack. This information is used by the SSR mode.
@@ -186,9 +208,14 @@ struct segment_allocation {
  * the page is atomically written, and it is in inmem_pages list.
  */
 #define ATOMIC_WRITTEN_PAGE		((unsigned long)-1)
+#define DUMMY_WRITTEN_PAGE		((unsigned long)-2)
 
 #define IS_ATOMIC_WRITTEN_PAGE(page)			\
 		(page_private(page) == (unsigned long)ATOMIC_WRITTEN_PAGE)
+#define IS_DUMMY_WRITTEN_PAGE(page)			\
+		(page_private(page) == (unsigned long)DUMMY_WRITTEN_PAGE)
+
+#define MAX_SKIP_ATOMIC_COUNT			16
 
 struct inmem_pages {
 	struct list_head list;
@@ -203,13 +230,16 @@ struct sit_info {
 	block_t sit_blocks;		/* # of blocks used by SIT area */
 	block_t written_valid_blocks;	/* # of valid blocks in main area */
 	char *sit_bitmap;		/* SIT bitmap pointer */
+#ifdef CONFIG_F2FS_CHECK_FS
+	char *sit_bitmap_mir;		/* SIT bitmap mirror */
+#endif
 	unsigned int bitmap_size;	/* SIT bitmap size */
 
 	unsigned long *tmp_map;			/* bitmap for temporal use */
 	unsigned long *dirty_sentries_bitmap;	/* bitmap for dirty sentries */
 	unsigned int dirty_sentries;		/* # of dirty sentries */
 	unsigned int sents_per_block;		/* # of SIT entries per block */
-	struct mutex sentry_lock;		/* to protect SIT cache */
+	struct rw_semaphore sentry_lock;	/* to protect SIT cache */
 	struct seg_entry *sentries;		/* SIT segment-level cache */
 	struct sec_entry *sec_entries;		/* SIT section-level cache */
 
@@ -218,6 +248,8 @@ struct sit_info {
 	unsigned long long mounted_time;	/* mount time */
 	unsigned long long min_mtime;		/* min. modification time */
 	unsigned long long max_mtime;		/* max. modification time */
+
+	unsigned int last_victim[MAX_GC_POLICY]; /* last victim segment # */
 };
 
 struct free_segmap_info {
@@ -294,17 +326,17 @@ static inline struct sec_entry *get_sec_entry(struct f2fs_sb_info *sbi,
 						unsigned int segno)
 {
 	struct sit_info *sit_i = SIT_I(sbi);
-	return &sit_i->sec_entries[GET_SECNO(sbi, segno)];
+	return &sit_i->sec_entries[GET_SEC_FROM_SEG(sbi, segno)];
 }
 
 static inline unsigned int get_valid_blocks(struct f2fs_sb_info *sbi,
-				unsigned int segno, int section)
+				unsigned int segno, bool use_section)
 {
 	/*
 	 * In order to get # of valid blocks in a section instantly from many
 	 * segments, f2fs manages two counting structures separately.
 	 */
-	if (section > 1)
+	if (use_section && sbi->segs_per_sec > 1)
 		return get_sec_entry(sbi, segno)->valid_blocks;
 	else
 		return get_seg_entry(sbi, segno)->valid_blocks;
@@ -317,20 +349,49 @@ static inline void seg_info_from_raw_sit(struct seg_entry *se,
 	se->ckpt_valid_blocks = GET_SIT_VBLOCKS(rs);
 	memcpy(se->cur_valid_map, rs->valid_map, SIT_VBLOCK_MAP_SIZE);
 	memcpy(se->ckpt_valid_map, rs->valid_map, SIT_VBLOCK_MAP_SIZE);
+#ifdef CONFIG_F2FS_CHECK_FS
+	memcpy(se->cur_valid_map_mir, rs->valid_map, SIT_VBLOCK_MAP_SIZE);
+#endif
 	se->type = GET_SIT_TYPE(rs);
 	se->mtime = le64_to_cpu(rs->mtime);
 }
 
-static inline void seg_info_to_raw_sit(struct seg_entry *se,
+static inline void __seg_info_to_raw_sit(struct seg_entry *se,
 					struct f2fs_sit_entry *rs)
 {
 	unsigned short raw_vblocks = (se->type << SIT_VBLOCKS_SHIFT) |
 					se->valid_blocks;
 	rs->vblocks = cpu_to_le16(raw_vblocks);
 	memcpy(rs->valid_map, se->cur_valid_map, SIT_VBLOCK_MAP_SIZE);
+	rs->mtime = cpu_to_le64(se->mtime);
+}
+
+static inline void seg_info_to_sit_page(struct f2fs_sb_info *sbi,
+				struct page *page, unsigned int start)
+{
+	struct f2fs_sit_block *raw_sit;
+	struct seg_entry *se;
+	struct f2fs_sit_entry *rs;
+	unsigned int end = min(start + SIT_ENTRY_PER_BLOCK,
+					(unsigned long)MAIN_SEGS(sbi));
+	int i;
+
+	raw_sit = (struct f2fs_sit_block *)page_address(page);
+	memset(raw_sit, 0, PAGE_SIZE);
+	for (i = 0; i < end - start; i++) {
+		rs = &raw_sit->entries[i];
+		se = get_seg_entry(sbi, start + i);
+		__seg_info_to_raw_sit(se, rs);
+	}
+}
+
+static inline void seg_info_to_raw_sit(struct seg_entry *se,
+					struct f2fs_sit_entry *rs)
+{
+	__seg_info_to_raw_sit(se, rs);
+
 	memcpy(se->ckpt_valid_map, rs->valid_map, SIT_VBLOCK_MAP_SIZE);
 	se->ckpt_valid_blocks = se->valid_blocks;
-	rs->mtime = cpu_to_le64(se->mtime);
 }
 
 static inline unsigned int find_next_inuse(struct free_segmap_info *free_i,
@@ -346,8 +407,8 @@ static inline unsigned int find_next_inuse(struct free_segmap_info *free_i,
 static inline void __set_free(struct f2fs_sb_info *sbi, unsigned int segno)
 {
 	struct free_segmap_info *free_i = FREE_I(sbi);
-	unsigned int secno = segno / sbi->segs_per_sec;
-	unsigned int start_segno = secno * sbi->segs_per_sec;
+	unsigned int secno = GET_SEC_FROM_SEG(sbi, segno);
+	unsigned int start_segno = GET_SEG_FROM_SEC(sbi, secno);
 	unsigned int next;
 
 	spin_lock(&free_i->segmap_lock);
@@ -367,7 +428,8 @@ static inline void __set_inuse(struct f2fs_sb_info *sbi,
 		unsigned int segno)
 {
 	struct free_segmap_info *free_i = FREE_I(sbi);
-	unsigned int secno = segno / sbi->segs_per_sec;
+	unsigned int secno = GET_SEC_FROM_SEG(sbi, segno);
+
 	set_bit(segno, free_i->free_segmap);
 	free_i->free_segments--;
 	if (!test_and_set_bit(secno, free_i->free_secmap))
@@ -378,8 +440,8 @@ static inline void __set_test_and_free(struct f2fs_sb_info *sbi,
 		unsigned int segno)
 {
 	struct free_segmap_info *free_i = FREE_I(sbi);
-	unsigned int secno = segno / sbi->segs_per_sec;
-	unsigned int start_segno = secno * sbi->segs_per_sec;
+	unsigned int secno = GET_SEC_FROM_SEG(sbi, segno);
+	unsigned int start_segno = GET_SEG_FROM_SEC(sbi, secno);
 	unsigned int next;
 
 	spin_lock(&free_i->segmap_lock);
@@ -400,7 +462,8 @@ static inline void __set_test_and_inuse(struct f2fs_sb_info *sbi,
 		unsigned int segno)
 {
 	struct free_segmap_info *free_i = FREE_I(sbi);
-	unsigned int secno = segno / sbi->segs_per_sec;
+	unsigned int secno = GET_SEC_FROM_SEG(sbi, segno);
+
 	spin_lock(&free_i->segmap_lock);
 	if (!test_and_set_bit(segno, free_i->free_segmap)) {
 		free_i->free_segments--;
@@ -414,6 +477,12 @@ static inline void get_sit_bitmap(struct f2fs_sb_info *sbi,
 		void *dst_addr)
 {
 	struct sit_info *sit_i = SIT_I(sbi);
+
+#ifdef CONFIG_F2FS_CHECK_FS
+	if (memcmp(sit_i->sit_bitmap, sit_i->sit_bitmap_mir,
+						sit_i->bitmap_size))
+		f2fs_bug_on(sbi, 1);
+#endif
 	memcpy(dst_addr, sit_i->sit_bitmap, sit_i->bitmap_size);
 }
 
@@ -457,26 +526,36 @@ static inline int overprovision_segments(struct f2fs_sb_info *sbi)
 	return SM_I(sbi)->ovp_segments;
 }
 
-static inline int overprovision_sections(struct f2fs_sb_info *sbi)
-{
-	return ((unsigned int) overprovision_segments(sbi)) / sbi->segs_per_sec;
-}
-
 static inline int reserved_sections(struct f2fs_sb_info *sbi)
 {
-	return ((unsigned int) reserved_segments(sbi)) / sbi->segs_per_sec;
+	return GET_SEC_FROM_SEG(sbi, (unsigned int)reserved_segments(sbi));
 }
 
-static inline bool need_SSR(struct f2fs_sb_info *sbi)
+static inline bool has_curseg_enough_space(struct f2fs_sb_info *sbi)
 {
-	int node_secs = get_blocktype_secs(sbi, F2FS_DIRTY_NODES);
-	int dent_secs = get_blocktype_secs(sbi, F2FS_DIRTY_DENTS);
+	unsigned int node_blocks = get_pages(sbi, F2FS_DIRTY_NODES) +
+					get_pages(sbi, F2FS_DIRTY_DENTS);
+	unsigned int dent_blocks = get_pages(sbi, F2FS_DIRTY_DENTS);
+	unsigned int segno, left_blocks;
+	int i;
 
-	if (test_opt(sbi, LFS))
-		return false;
+	/* check current node segment */
+	for (i = CURSEG_HOT_NODE; i <= CURSEG_COLD_NODE; i++) {
+		segno = CURSEG_I(sbi, i)->segno;
+		left_blocks = sbi->blocks_per_seg -
+			get_seg_entry(sbi, segno)->ckpt_valid_blocks;
+
+		if (node_blocks > left_blocks)
+			return false;
+	}
 
-	return free_sections(sbi) <= (node_secs + 2 * dent_secs +
-						reserved_sections(sbi) + 1);
+	/* check current data segment */
+	segno = CURSEG_I(sbi, CURSEG_HOT_DATA)->segno;
+	left_blocks = sbi->blocks_per_seg -
+			get_seg_entry(sbi, segno)->ckpt_valid_blocks;
+	if (dent_blocks > left_blocks)
+		return false;
+	return true;
 }
 
 static inline bool has_not_enough_free_secs(struct f2fs_sb_info *sbi,
@@ -484,14 +563,17 @@ static inline bool has_not_enough_free_secs(struct f2fs_sb_info *sbi,
 {
 	int node_secs = get_blocktype_secs(sbi, F2FS_DIRTY_NODES);
 	int dent_secs = get_blocktype_secs(sbi, F2FS_DIRTY_DENTS);
-
-	node_secs += get_blocktype_secs(sbi, F2FS_DIRTY_IMETA);
+	int imeta_secs = get_blocktype_secs(sbi, F2FS_DIRTY_IMETA);
 
 	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
 		return false;
 
+	if (free_sections(sbi) + freed == reserved_sections(sbi) + needed &&
+			has_curseg_enough_space(sbi))
+		return false;
 	return (free_sections(sbi) + freed) <=
-		(node_secs + 2 * dent_secs + reserved_sections(sbi) + needed);
+		(node_secs + 2 * dent_secs + imeta_secs +
+		reserved_sections(sbi) + needed);
 }
 
 static inline bool excess_prefree_segs(struct f2fs_sb_info *sbi)
@@ -521,6 +603,9 @@ static inline int utilization(struct f2fs_sb_info *sbi)
  */
 #define DEF_MIN_IPU_UTIL	70
 #define DEF_MIN_FSYNC_BLOCKS	8
+#define DEF_MIN_HOT_BLOCKS	16
+
+#define SMALL_VOLUME_SEGMENTS	(16 * 512)	/* 16GB */
 
 enum {
 	F2FS_IPU_FORCE,
@@ -528,39 +613,9 @@ enum {
 	F2FS_IPU_UTIL,
 	F2FS_IPU_SSR_UTIL,
 	F2FS_IPU_FSYNC,
+	F2FS_IPU_ASYNC,
 };
 
-static inline bool need_inplace_update(struct inode *inode)
-{
-	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
-	unsigned int policy = SM_I(sbi)->ipu_policy;
-
-	/* IPU can be done only for the user data */
-	if (S_ISDIR(inode->i_mode) || f2fs_is_atomic_file(inode))
-		return false;
-
-	if (test_opt(sbi, LFS))
-		return false;
-
-	if (policy & (0x1 << F2FS_IPU_FORCE))
-		return true;
-	if (policy & (0x1 << F2FS_IPU_SSR) && need_SSR(sbi))
-		return true;
-	if (policy & (0x1 << F2FS_IPU_UTIL) &&
-			utilization(sbi) > SM_I(sbi)->min_ipu_util)
-		return true;
-	if (policy & (0x1 << F2FS_IPU_SSR_UTIL) && need_SSR(sbi) &&
-			utilization(sbi) > SM_I(sbi)->min_ipu_util)
-		return true;
-
-	/* this is only set during fdatasync */
-	if (policy & (0x1 << F2FS_IPU_FSYNC) &&
-			is_inode_flag_set(inode, FI_NEED_IPU))
-		return true;
-
-	return false;
-}
-
 static inline unsigned int curseg_segno(struct f2fs_sb_info *sbi,
 		int type)
 {
@@ -586,16 +641,23 @@ static inline void check_seg_range(struct f2fs_sb_info *sbi, unsigned int segno)
 	f2fs_bug_on(sbi, segno > TOTAL_SEGS(sbi) - 1);
 }
 
-static inline void verify_block_addr(struct f2fs_sb_info *sbi, block_t blk_addr)
+static inline void verify_block_addr(struct f2fs_io_info *fio, block_t blk_addr)
 {
-	BUG_ON(blk_addr < SEG0_BLKADDR(sbi)
-			|| blk_addr >= MAX_BLKADDR(sbi));
+	struct f2fs_sb_info *sbi = fio->sbi;
+
+	if (PAGE_TYPE_OF_BIO(fio->type) == META &&
+				(!is_read_io(fio->op) || fio->is_meta))
+		BUG_ON(blk_addr < SEG0_BLKADDR(sbi) ||
+				blk_addr >= MAIN_BLKADDR(sbi));
+	else
+		BUG_ON(blk_addr < MAIN_BLKADDR(sbi) ||
+				blk_addr >= MAX_BLKADDR(sbi));
 }
 
 /*
  * Summary block is always treated as an invalid block
  */
-static inline void check_block_count(struct f2fs_sb_info *sbi,
+static inline int check_block_count(struct f2fs_sb_info *sbi,
 		int segno, struct f2fs_sit_entry *raw_sit)
 {
 #ifdef CONFIG_F2FS_CHECK_FS
@@ -617,11 +679,25 @@ static inline void check_block_count(struct f2fs_sb_info *sbi,
 		cur_pos = next_pos;
 		is_valid = !is_valid;
 	} while (cur_pos < sbi->blocks_per_seg);
-	BUG_ON(GET_SIT_VBLOCKS(raw_sit) != valid_blocks);
+
+	if (unlikely(GET_SIT_VBLOCKS(raw_sit) != valid_blocks)) {
+		f2fs_msg(sbi->sb, KERN_ERR,
+				"Mismatch valid blocks %d vs. %d",
+					GET_SIT_VBLOCKS(raw_sit), valid_blocks);
+		set_sbi_flag(sbi, SBI_NEED_FSCK);
+		return -EINVAL;
+	}
 #endif
 	/* check segment usage, and check boundary of a given segment number */
-	f2fs_bug_on(sbi, GET_SIT_VBLOCKS(raw_sit) > sbi->blocks_per_seg
-					|| segno > TOTAL_SEGS(sbi) - 1);
+	if (unlikely(GET_SIT_VBLOCKS(raw_sit) > sbi->blocks_per_seg
+					|| segno > TOTAL_SEGS(sbi) - 1)) {
+		f2fs_msg(sbi->sb, KERN_ERR,
+				"Wrong valid blocks %d or segno %u",
+					GET_SIT_VBLOCKS(raw_sit), segno);
+		set_sbi_flag(sbi, SBI_NEED_FSCK);
+		return -EINVAL;
+	}
+	return 0;
 }
 
 static inline pgoff_t current_sit_addr(struct f2fs_sb_info *sbi,
@@ -633,6 +709,12 @@ static inline pgoff_t current_sit_addr(struct f2fs_sb_info *sbi,
 
 	check_seg_range(sbi, start);
 
+#ifdef CONFIG_F2FS_CHECK_FS
+	if (f2fs_test_bit(offset, sit_i->sit_bitmap) !=
+			f2fs_test_bit(offset, sit_i->sit_bitmap_mir))
+		f2fs_bug_on(sbi, 1);
+#endif
+
 	/* calculate sit block address */
 	if (f2fs_test_bit(offset, sit_i->sit_bitmap))
 		blk_addr += sit_i->sit_blocks;
@@ -658,13 +740,28 @@ static inline void set_to_next_sit(struct sit_info *sit_i, unsigned int start)
 	unsigned int block_off = SIT_BLOCK_OFFSET(start);
 
 	f2fs_change_bit(block_off, sit_i->sit_bitmap);
+#ifdef CONFIG_F2FS_CHECK_FS
+	f2fs_change_bit(block_off, sit_i->sit_bitmap_mir);
+#endif
 }
 
-static inline unsigned long long get_mtime(struct f2fs_sb_info *sbi)
+static inline unsigned long long get_mtime(struct f2fs_sb_info *sbi,
+						bool base_time)
 {
 	struct sit_info *sit_i = SIT_I(sbi);
-	return sit_i->elapsed_time + CURRENT_TIME_SEC.tv_sec -
-						sit_i->mounted_time;
+	time64_t diff, now = ktime_get_real_seconds();
+
+	if (now >= sit_i->mounted_time)
+		return sit_i->elapsed_time + now - sit_i->mounted_time;
+
+	/* system time is set to the past */
+	if (!base_time) {
+		diff = sit_i->mounted_time - now;
+		if (sit_i->elapsed_time >= diff)
+			return sit_i->elapsed_time - diff;
+		return 0;
+	}
+	return sit_i->elapsed_time;
 }
 
 static inline void set_summary(struct f2fs_summary *sum, nid_t nid,
@@ -688,15 +785,6 @@ static inline block_t sum_blk_addr(struct f2fs_sb_info *sbi, int base, int type)
 				- (base + 1) + type;
 }
 
-static inline bool no_fggc_candidate(struct f2fs_sb_info *sbi,
-						unsigned int secno)
-{
-	if (get_valid_blocks(sbi, secno, sbi->segs_per_sec) >=
-						sbi->fggc_threshold)
-		return true;
-	return false;
-}
-
 static inline bool sec_usage_check(struct f2fs_sb_info *sbi, unsigned int secno)
 {
 	if (IS_CURSEC(sbi, secno) || (sbi->cur_victim_sec == secno))
@@ -704,19 +792,12 @@ static inline bool sec_usage_check(struct f2fs_sb_info *sbi, unsigned int secno)
 	return false;
 }
 
-static inline unsigned int max_hw_blocks(struct f2fs_sb_info *sbi)
-{
-	struct block_device *bdev = sbi->sb->s_bdev;
-	struct request_queue *q = bdev_get_queue(bdev);
-	return SECTOR_TO_BLOCK(queue_max_sectors(q));
-}
-
 /*
  * It is very important to gather dirty pages and write at once, so that we can
  * submit a big bio without interfering other data writes.
  * By default, 512 pages for directory data,
- * 512 pages (2MB) * 3 for three types of nodes, and
- * max_bio_blocks for meta are set.
+ * 512 pages (2MB) * 8 for nodes, and
+ * 256 pages * 8 for meta are set.
  */
 static inline int nr_pages_to_skip(struct f2fs_sb_info *sbi, int type)
 {
@@ -728,7 +809,7 @@ static inline int nr_pages_to_skip(struct f2fs_sb_info *sbi, int type)
 	else if (type == NODE)
 		return 8 * sbi->blocks_per_seg;
 	else if (type == META)
-		return 8 * MAX_BIO_BLOCKS(sbi);
+		return 8 * BIO_MAX_PAGES;
 	else
 		return 0;
 }
@@ -745,12 +826,36 @@ static inline long nr_pages_to_write(struct f2fs_sb_info *sbi, int type,
 		return 0;
 
 	nr_to_write = wbc->nr_to_write;
-
+	desired = BIO_MAX_PAGES;
 	if (type == NODE)
-		desired = 2 * max_hw_blocks(sbi);
-	else
-		desired = MAX_BIO_BLOCKS(sbi);
+		desired <<= 1;
 
 	wbc->nr_to_write = desired;
 	return desired - nr_to_write;
 }
+
+static inline void wake_up_discard_thread(struct f2fs_sb_info *sbi, bool force)
+{
+	struct discard_cmd_control *dcc = SM_I(sbi)->dcc_info;
+	bool wakeup = false;
+	int i;
+
+	if (force)
+		goto wake_up;
+
+	mutex_lock(&dcc->cmd_lock);
+	for (i = MAX_PLIST_NUM - 1; i >= 0; i--) {
+		if (i + 1 < dcc->discard_granularity)
+			break;
+		if (!list_empty(&dcc->pend_list[i])) {
+			wakeup = true;
+			break;
+		}
+	}
+	mutex_unlock(&dcc->cmd_lock);
+	if (!wakeup)
+		return;
+wake_up:
+	dcc->discard_wake = 1;
+	wake_up_interruptible_all(&dcc->discard_wait_queue);
+}
diff --git a/fs/f2fs/shrinker.c b/fs/f2fs/shrinker.c
index 46c9154..36cfd81 100644
--- a/fs/f2fs/shrinker.c
+++ b/fs/f2fs/shrinker.c
@@ -21,14 +21,16 @@
 
 static unsigned long __count_nat_entries(struct f2fs_sb_info *sbi)
 {
-	return NM_I(sbi)->nat_cnt - NM_I(sbi)->dirty_nat_cnt;
+	long count = NM_I(sbi)->nat_cnt - NM_I(sbi)->dirty_nat_cnt;
+
+	return count > 0 ? count : 0;
 }
 
 static unsigned long __count_free_nids(struct f2fs_sb_info *sbi)
 {
-	if (NM_I(sbi)->fcnt > MAX_FREE_NIDS)
-		return NM_I(sbi)->fcnt - MAX_FREE_NIDS;
-	return 0;
+	long count = NM_I(sbi)->nid_cnt[FREE_NID] - MAX_FREE_NIDS;
+
+	return count > 0 ? count : 0;
 }
 
 static unsigned long __count_extent_cache(struct f2fs_sb_info *sbi)
@@ -107,11 +109,11 @@ unsigned long f2fs_shrink_scan(struct shrinker *shrink,
 
 		/* shrink clean nat cache entries */
 		if (freed < nr)
-			freed += try_to_free_nats(sbi, nr - freed);
+			freed += f2fs_try_to_free_nats(sbi, nr - freed);
 
 		/* shrink free nids cache entries */
 		if (freed < nr)
-			freed += try_to_free_nids(sbi, nr - freed);
+			freed += f2fs_try_to_free_nids(sbi, nr - freed);
 
 		spin_lock(&f2fs_list_lock);
 		p = p->next;
diff --git a/fs/f2fs/super.c b/fs/f2fs/super.c
index e627671..df2a9e6d 100644
--- a/fs/f2fs/super.c
+++ b/fs/f2fs/super.c
@@ -22,8 +22,10 @@
 #include <linux/random.h>
 #include <linux/exportfs.h>
 #include <linux/blkdev.h>
+#include <linux/quotaops.h>
 #include <linux/f2fs_fs.h>
 #include <linux/sysfs.h>
+#include <linux/quota.h>
 
 #include "f2fs.h"
 #include "node.h"
@@ -35,20 +37,22 @@
 #define CREATE_TRACE_POINTS
 #include <trace/events/f2fs.h>
 
-static struct proc_dir_entry *f2fs_proc_root;
 static struct kmem_cache *f2fs_inode_cachep;
-static struct kset *f2fs_kset;
 
 #ifdef CONFIG_F2FS_FAULT_INJECTION
 
 char *fault_name[FAULT_MAX] = {
 	[FAULT_KMALLOC]		= "kmalloc",
+	[FAULT_KVMALLOC]	= "kvmalloc",
 	[FAULT_PAGE_ALLOC]	= "page alloc",
+	[FAULT_PAGE_GET]	= "page get",
+	[FAULT_ALLOC_BIO]	= "alloc bio",
 	[FAULT_ALLOC_NID]	= "alloc nid",
 	[FAULT_ORPHAN]		= "orphan",
 	[FAULT_BLOCK]		= "no more block",
 	[FAULT_DIR_DEPTH]	= "too big dir depth",
 	[FAULT_EVICT_INODE]	= "evict_inode fail",
+	[FAULT_TRUNCATE]	= "truncate fail",
 	[FAULT_IO]		= "IO error",
 	[FAULT_CHECKPOINT]	= "checkpoint error",
 };
@@ -56,7 +60,7 @@
 static void f2fs_build_fault_attr(struct f2fs_sb_info *sbi,
 						unsigned int rate)
 {
-	struct f2fs_fault_info *ffi = &sbi->fault_info;
+	struct f2fs_fault_info *ffi = &F2FS_OPTION(sbi).fault_info;
 
 	if (rate) {
 		atomic_set(&ffi->inject_ops, 0);
@@ -82,6 +86,7 @@ enum {
 	Opt_discard,
 	Opt_nodiscard,
 	Opt_noheap,
+	Opt_heap,
 	Opt_user_xattr,
 	Opt_nouser_xattr,
 	Opt_acl,
@@ -89,6 +94,8 @@ enum {
 	Opt_active_logs,
 	Opt_disable_ext_identify,
 	Opt_inline_xattr,
+	Opt_noinline_xattr,
+	Opt_inline_xattr_size,
 	Opt_inline_data,
 	Opt_inline_dentry,
 	Opt_noinline_dentry,
@@ -100,10 +107,32 @@ enum {
 	Opt_noextent_cache,
 	Opt_noinline_data,
 	Opt_data_flush,
+	Opt_reserve_root,
+	Opt_resgid,
+	Opt_resuid,
 	Opt_mode,
+	Opt_io_size_bits,
 	Opt_fault_injection,
 	Opt_lazytime,
 	Opt_nolazytime,
+	Opt_quota,
+	Opt_noquota,
+	Opt_usrquota,
+	Opt_grpquota,
+	Opt_prjquota,
+	Opt_usrjquota,
+	Opt_grpjquota,
+	Opt_prjjquota,
+	Opt_offusrjquota,
+	Opt_offgrpjquota,
+	Opt_offprjjquota,
+	Opt_jqfmt_vfsold,
+	Opt_jqfmt_vfsv0,
+	Opt_jqfmt_vfsv1,
+	Opt_whint,
+	Opt_alloc,
+	Opt_fsync,
+	Opt_test_dummy_encryption,
 	Opt_err,
 };
 
@@ -114,6 +143,7 @@ enum {
 	{Opt_discard, "discard"},
 	{Opt_nodiscard, "nodiscard"},
 	{Opt_noheap, "no_heap"},
+	{Opt_heap, "heap"},
 	{Opt_user_xattr, "user_xattr"},
 	{Opt_nouser_xattr, "nouser_xattr"},
 	{Opt_acl, "acl"},
@@ -121,6 +151,8 @@ enum {
 	{Opt_active_logs, "active_logs=%u"},
 	{Opt_disable_ext_identify, "disable_ext_identify"},
 	{Opt_inline_xattr, "inline_xattr"},
+	{Opt_noinline_xattr, "noinline_xattr"},
+	{Opt_inline_xattr_size, "inline_xattr_size=%u"},
 	{Opt_inline_data, "inline_data"},
 	{Opt_inline_dentry, "inline_dentry"},
 	{Opt_noinline_dentry, "noinline_dentry"},
@@ -132,229 +164,198 @@ enum {
 	{Opt_noextent_cache, "noextent_cache"},
 	{Opt_noinline_data, "noinline_data"},
 	{Opt_data_flush, "data_flush"},
+	{Opt_reserve_root, "reserve_root=%u"},
+	{Opt_resgid, "resgid=%u"},
+	{Opt_resuid, "resuid=%u"},
 	{Opt_mode, "mode=%s"},
+	{Opt_io_size_bits, "io_bits=%u"},
 	{Opt_fault_injection, "fault_injection=%u"},
 	{Opt_lazytime, "lazytime"},
 	{Opt_nolazytime, "nolazytime"},
+	{Opt_quota, "quota"},
+	{Opt_noquota, "noquota"},
+	{Opt_usrquota, "usrquota"},
+	{Opt_grpquota, "grpquota"},
+	{Opt_prjquota, "prjquota"},
+	{Opt_usrjquota, "usrjquota=%s"},
+	{Opt_grpjquota, "grpjquota=%s"},
+	{Opt_prjjquota, "prjjquota=%s"},
+	{Opt_offusrjquota, "usrjquota="},
+	{Opt_offgrpjquota, "grpjquota="},
+	{Opt_offprjjquota, "prjjquota="},
+	{Opt_jqfmt_vfsold, "jqfmt=vfsold"},
+	{Opt_jqfmt_vfsv0, "jqfmt=vfsv0"},
+	{Opt_jqfmt_vfsv1, "jqfmt=vfsv1"},
+	{Opt_whint, "whint_mode=%s"},
+	{Opt_alloc, "alloc_mode=%s"},
+	{Opt_fsync, "fsync_mode=%s"},
+	{Opt_test_dummy_encryption, "test_dummy_encryption"},
 	{Opt_err, NULL},
 };
 
-/* Sysfs support for f2fs */
-enum {
-	GC_THREAD,	/* struct f2fs_gc_thread */
-	SM_INFO,	/* struct f2fs_sm_info */
-	NM_INFO,	/* struct f2fs_nm_info */
-	F2FS_SBI,	/* struct f2fs_sb_info */
-#ifdef CONFIG_F2FS_FAULT_INJECTION
-	FAULT_INFO_RATE,	/* struct f2fs_fault_info */
-	FAULT_INFO_TYPE,	/* struct f2fs_fault_info */
-#endif
-};
-
-struct f2fs_attr {
-	struct attribute attr;
-	ssize_t (*show)(struct f2fs_attr *, struct f2fs_sb_info *, char *);
-	ssize_t (*store)(struct f2fs_attr *, struct f2fs_sb_info *,
-			 const char *, size_t);
-	int struct_type;
-	int offset;
-};
-
-static unsigned char *__struct_ptr(struct f2fs_sb_info *sbi, int struct_type)
+void f2fs_msg(struct super_block *sb, const char *level, const char *fmt, ...)
 {
-	if (struct_type == GC_THREAD)
-		return (unsigned char *)sbi->gc_thread;
-	else if (struct_type == SM_INFO)
-		return (unsigned char *)SM_I(sbi);
-	else if (struct_type == NM_INFO)
-		return (unsigned char *)NM_I(sbi);
-	else if (struct_type == F2FS_SBI)
-		return (unsigned char *)sbi;
-#ifdef CONFIG_F2FS_FAULT_INJECTION
-	else if (struct_type == FAULT_INFO_RATE ||
-					struct_type == FAULT_INFO_TYPE)
-		return (unsigned char *)&sbi->fault_info;
-#endif
-	return NULL;
+	struct va_format vaf;
+	va_list args;
+
+	va_start(args, fmt);
+	vaf.fmt = fmt;
+	vaf.va = &args;
+	printk_ratelimited("%sF2FS-fs (%s): %pV\n", level, sb->s_id, &vaf);
+	va_end(args);
 }
 
-static ssize_t lifetime_write_kbytes_show(struct f2fs_attr *a,
-		struct f2fs_sb_info *sbi, char *buf)
+static inline void limit_reserve_root(struct f2fs_sb_info *sbi)
 {
-	struct super_block *sb = sbi->sb;
-
-	if (!sb->s_bdev->bd_part)
-		return snprintf(buf, PAGE_SIZE, "0\n");
-
-	return snprintf(buf, PAGE_SIZE, "%llu\n",
-		(unsigned long long)(sbi->kbytes_written +
-			BD_PART_WRITTEN(sbi)));
+	block_t limit = (sbi->user_block_count << 1) / 1000;
+
+	/* limit is 0.2% */
+	if (test_opt(sbi, RESERVE_ROOT) &&
+			F2FS_OPTION(sbi).root_reserved_blocks > limit) {
+		F2FS_OPTION(sbi).root_reserved_blocks = limit;
+		f2fs_msg(sbi->sb, KERN_INFO,
+			"Reduce reserved blocks for root = %u",
+			F2FS_OPTION(sbi).root_reserved_blocks);
+	}
+	if (!test_opt(sbi, RESERVE_ROOT) &&
+		(!uid_eq(F2FS_OPTION(sbi).s_resuid,
+				make_kuid(&init_user_ns, F2FS_DEF_RESUID)) ||
+		!gid_eq(F2FS_OPTION(sbi).s_resgid,
+				make_kgid(&init_user_ns, F2FS_DEF_RESGID))))
+		f2fs_msg(sbi->sb, KERN_INFO,
+			"Ignore s_resuid=%u, s_resgid=%u w/o reserve_root",
+				from_kuid_munged(&init_user_ns,
+					F2FS_OPTION(sbi).s_resuid),
+				from_kgid_munged(&init_user_ns,
+					F2FS_OPTION(sbi).s_resgid));
 }
 
-static ssize_t f2fs_sbi_show(struct f2fs_attr *a,
-			struct f2fs_sb_info *sbi, char *buf)
+static void init_once(void *foo)
 {
-	unsigned char *ptr = NULL;
-	unsigned int *ui;
-
-	ptr = __struct_ptr(sbi, a->struct_type);
-	if (!ptr)
-		return -EINVAL;
-
-	ui = (unsigned int *)(ptr + a->offset);
+	struct f2fs_inode_info *fi = (struct f2fs_inode_info *) foo;
 
-	return snprintf(buf, PAGE_SIZE, "%u\n", *ui);
+	inode_init_once(&fi->vfs_inode);
 }
 
-static ssize_t f2fs_sbi_store(struct f2fs_attr *a,
-			struct f2fs_sb_info *sbi,
-			const char *buf, size_t count)
+#ifdef CONFIG_QUOTA
+static const char * const quotatypes[] = INITQFNAMES;
+#define QTYPE2NAME(t) (quotatypes[t])
+static int f2fs_set_qf_name(struct super_block *sb, int qtype,
+							substring_t *args)
 {
-	unsigned char *ptr;
-	unsigned long t;
-	unsigned int *ui;
-	ssize_t ret;
+	struct f2fs_sb_info *sbi = F2FS_SB(sb);
+	char *qname;
+	int ret = -EINVAL;
 
-	ptr = __struct_ptr(sbi, a->struct_type);
-	if (!ptr)
+	if (sb_any_quota_loaded(sb) && !F2FS_OPTION(sbi).s_qf_names[qtype]) {
+		f2fs_msg(sb, KERN_ERR,
+			"Cannot change journaled "
+			"quota options when quota turned on");
 		return -EINVAL;
+	}
+	if (f2fs_sb_has_quota_ino(sb)) {
+		f2fs_msg(sb, KERN_INFO,
+			"QUOTA feature is enabled, so ignore qf_name");
+		return 0;
+	}
 
-	ui = (unsigned int *)(ptr + a->offset);
-
-	ret = kstrtoul(skip_spaces(buf), 0, &t);
-	if (ret < 0)
-		return ret;
-#ifdef CONFIG_F2FS_FAULT_INJECTION
-	if (a->struct_type == FAULT_INFO_TYPE && t >= (1 << FAULT_MAX))
+	qname = match_strdup(args);
+	if (!qname) {
+		f2fs_msg(sb, KERN_ERR,
+			"Not enough memory for storing quotafile name");
 		return -EINVAL;
-#endif
-	*ui = t;
-	return count;
+	}
+	if (F2FS_OPTION(sbi).s_qf_names[qtype]) {
+		if (strcmp(F2FS_OPTION(sbi).s_qf_names[qtype], qname) == 0)
+			ret = 0;
+		else
+			f2fs_msg(sb, KERN_ERR,
+				 "%s quota file already specified",
+				 QTYPE2NAME(qtype));
+		goto errout;
+	}
+	if (strchr(qname, '/')) {
+		f2fs_msg(sb, KERN_ERR,
+			"quotafile must be on filesystem root");
+		goto errout;
+	}
+	F2FS_OPTION(sbi).s_qf_names[qtype] = qname;
+	set_opt(sbi, QUOTA);
+	return 0;
+errout:
+	kfree(qname);
+	return ret;
 }
 
-static ssize_t f2fs_attr_show(struct kobject *kobj,
-				struct attribute *attr, char *buf)
+static int f2fs_clear_qf_name(struct super_block *sb, int qtype)
 {
-	struct f2fs_sb_info *sbi = container_of(kobj, struct f2fs_sb_info,
-								s_kobj);
-	struct f2fs_attr *a = container_of(attr, struct f2fs_attr, attr);
+	struct f2fs_sb_info *sbi = F2FS_SB(sb);
 
-	return a->show ? a->show(a, sbi, buf) : 0;
+	if (sb_any_quota_loaded(sb) && F2FS_OPTION(sbi).s_qf_names[qtype]) {
+		f2fs_msg(sb, KERN_ERR, "Cannot change journaled quota options"
+			" when quota turned on");
+		return -EINVAL;
+	}
+	kfree(F2FS_OPTION(sbi).s_qf_names[qtype]);
+	F2FS_OPTION(sbi).s_qf_names[qtype] = NULL;
+	return 0;
 }
 
-static ssize_t f2fs_attr_store(struct kobject *kobj, struct attribute *attr,
-						const char *buf, size_t len)
+static int f2fs_check_quota_options(struct f2fs_sb_info *sbi)
 {
-	struct f2fs_sb_info *sbi = container_of(kobj, struct f2fs_sb_info,
-									s_kobj);
-	struct f2fs_attr *a = container_of(attr, struct f2fs_attr, attr);
-
-	return a->store ? a->store(a, sbi, buf, len) : 0;
-}
+	/*
+	 * We do the test below only for project quotas. 'usrquota' and
+	 * 'grpquota' mount options are allowed even without quota feature
+	 * to support legacy quotas in quota files.
+	 */
+	if (test_opt(sbi, PRJQUOTA) && !f2fs_sb_has_project_quota(sbi->sb)) {
+		f2fs_msg(sbi->sb, KERN_ERR, "Project quota feature not enabled. "
+			 "Cannot enable project quota enforcement.");
+		return -1;
+	}
+	if (F2FS_OPTION(sbi).s_qf_names[USRQUOTA] ||
+			F2FS_OPTION(sbi).s_qf_names[GRPQUOTA] ||
+			F2FS_OPTION(sbi).s_qf_names[PRJQUOTA]) {
+		if (test_opt(sbi, USRQUOTA) &&
+				F2FS_OPTION(sbi).s_qf_names[USRQUOTA])
+			clear_opt(sbi, USRQUOTA);
+
+		if (test_opt(sbi, GRPQUOTA) &&
+				F2FS_OPTION(sbi).s_qf_names[GRPQUOTA])
+			clear_opt(sbi, GRPQUOTA);
+
+		if (test_opt(sbi, PRJQUOTA) &&
+				F2FS_OPTION(sbi).s_qf_names[PRJQUOTA])
+			clear_opt(sbi, PRJQUOTA);
+
+		if (test_opt(sbi, GRPQUOTA) || test_opt(sbi, USRQUOTA) ||
+				test_opt(sbi, PRJQUOTA)) {
+			f2fs_msg(sbi->sb, KERN_ERR, "old and new quota "
+					"format mixing");
+			return -1;
+		}
 
-static void f2fs_sb_release(struct kobject *kobj)
-{
-	struct f2fs_sb_info *sbi = container_of(kobj, struct f2fs_sb_info,
-								s_kobj);
-	complete(&sbi->s_kobj_unregister);
-}
+		if (!F2FS_OPTION(sbi).s_jquota_fmt) {
+			f2fs_msg(sbi->sb, KERN_ERR, "journaled quota format "
+					"not specified");
+			return -1;
+		}
+	}
 
-#define F2FS_ATTR_OFFSET(_struct_type, _name, _mode, _show, _store, _offset) \
-static struct f2fs_attr f2fs_attr_##_name = {			\
-	.attr = {.name = __stringify(_name), .mode = _mode },	\
-	.show	= _show,					\
-	.store	= _store,					\
-	.struct_type = _struct_type,				\
-	.offset = _offset					\
+	if (f2fs_sb_has_quota_ino(sbi->sb) && F2FS_OPTION(sbi).s_jquota_fmt) {
+		f2fs_msg(sbi->sb, KERN_INFO,
+			"QUOTA feature is enabled, so ignore jquota_fmt");
+		F2FS_OPTION(sbi).s_jquota_fmt = 0;
+	}
+	if (f2fs_sb_has_quota_ino(sbi->sb) && f2fs_readonly(sbi->sb)) {
+		f2fs_msg(sbi->sb, KERN_INFO,
+			 "Filesystem with quota feature cannot be mounted RDWR "
+			 "without CONFIG_QUOTA");
+		return -1;
+	}
+	return 0;
 }
-
-#define F2FS_RW_ATTR(struct_type, struct_name, name, elname)	\
-	F2FS_ATTR_OFFSET(struct_type, name, 0644,		\
-		f2fs_sbi_show, f2fs_sbi_store,			\
-		offsetof(struct struct_name, elname))
-
-#define F2FS_GENERAL_RO_ATTR(name) \
-static struct f2fs_attr f2fs_attr_##name = __ATTR(name, 0444, name##_show, NULL)
-
-F2FS_RW_ATTR(GC_THREAD, f2fs_gc_kthread, gc_min_sleep_time, min_sleep_time);
-F2FS_RW_ATTR(GC_THREAD, f2fs_gc_kthread, gc_max_sleep_time, max_sleep_time);
-F2FS_RW_ATTR(GC_THREAD, f2fs_gc_kthread, gc_no_gc_sleep_time, no_gc_sleep_time);
-F2FS_RW_ATTR(GC_THREAD, f2fs_gc_kthread, gc_idle, gc_idle);
-F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, reclaim_segments, rec_prefree_segments);
-F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, max_small_discards, max_discards);
-F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, batched_trim_sections, trim_sections);
-F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, ipu_policy, ipu_policy);
-F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, min_ipu_util, min_ipu_util);
-F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, min_fsync_blocks, min_fsync_blocks);
-F2FS_RW_ATTR(NM_INFO, f2fs_nm_info, ram_thresh, ram_thresh);
-F2FS_RW_ATTR(NM_INFO, f2fs_nm_info, ra_nid_pages, ra_nid_pages);
-F2FS_RW_ATTR(NM_INFO, f2fs_nm_info, dirty_nats_ratio, dirty_nats_ratio);
-F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, max_victim_search, max_victim_search);
-F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, dir_level, dir_level);
-F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, cp_interval, interval_time[CP_TIME]);
-F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, idle_interval, interval_time[REQ_TIME]);
-#ifdef CONFIG_F2FS_FAULT_INJECTION
-F2FS_RW_ATTR(FAULT_INFO_RATE, f2fs_fault_info, inject_rate, inject_rate);
-F2FS_RW_ATTR(FAULT_INFO_TYPE, f2fs_fault_info, inject_type, inject_type);
 #endif
-F2FS_GENERAL_RO_ATTR(lifetime_write_kbytes);
-
-#define ATTR_LIST(name) (&f2fs_attr_##name.attr)
-static struct attribute *f2fs_attrs[] = {
-	ATTR_LIST(gc_min_sleep_time),
-	ATTR_LIST(gc_max_sleep_time),
-	ATTR_LIST(gc_no_gc_sleep_time),
-	ATTR_LIST(gc_idle),
-	ATTR_LIST(reclaim_segments),
-	ATTR_LIST(max_small_discards),
-	ATTR_LIST(batched_trim_sections),
-	ATTR_LIST(ipu_policy),
-	ATTR_LIST(min_ipu_util),
-	ATTR_LIST(min_fsync_blocks),
-	ATTR_LIST(max_victim_search),
-	ATTR_LIST(dir_level),
-	ATTR_LIST(ram_thresh),
-	ATTR_LIST(ra_nid_pages),
-	ATTR_LIST(dirty_nats_ratio),
-	ATTR_LIST(cp_interval),
-	ATTR_LIST(idle_interval),
-#ifdef CONFIG_F2FS_FAULT_INJECTION
-	ATTR_LIST(inject_rate),
-	ATTR_LIST(inject_type),
-#endif
-	ATTR_LIST(lifetime_write_kbytes),
-	NULL,
-};
-
-static const struct sysfs_ops f2fs_attr_ops = {
-	.show	= f2fs_attr_show,
-	.store	= f2fs_attr_store,
-};
-
-static struct kobj_type f2fs_ktype = {
-	.default_attrs	= f2fs_attrs,
-	.sysfs_ops	= &f2fs_attr_ops,
-	.release	= f2fs_sb_release,
-};
-
-void f2fs_msg(struct super_block *sb, const char *level, const char *fmt, ...)
-{
-	struct va_format vaf;
-	va_list args;
-
-	va_start(args, fmt);
-	vaf.fmt = fmt;
-	vaf.va = &args;
-	printk("%sF2FS-fs (%s): %pV\n", level, sb->s_id, &vaf);
-	va_end(args);
-}
-
-static void init_once(void *foo)
-{
-	struct f2fs_inode_info *fi = (struct f2fs_inode_info *) foo;
-
-	inode_init_once(&fi->vfs_inode);
-}
 
 static int parse_options(struct super_block *sb, char *options)
 {
@@ -363,6 +364,11 @@ static int parse_options(struct super_block *sb, char *options)
 	substring_t args[MAX_OPT_ARGS];
 	char *p, *name;
 	int arg = 0;
+	kuid_t uid;
+	kgid_t gid;
+#ifdef CONFIG_QUOTA
+	int ret;
+#endif
 
 	if (!options)
 		return 0;
@@ -412,17 +418,26 @@ static int parse_options(struct super_block *sb, char *options)
 			q = bdev_get_queue(sb->s_bdev);
 			if (blk_queue_discard(q)) {
 				set_opt(sbi, DISCARD);
-			} else {
+			} else if (!f2fs_sb_has_blkzoned(sb)) {
 				f2fs_msg(sb, KERN_WARNING,
 					"mounting with \"discard\" option, but "
 					"the device does not support discard");
 			}
 			break;
 		case Opt_nodiscard:
+			if (f2fs_sb_has_blkzoned(sb)) {
+				f2fs_msg(sb, KERN_WARNING,
+					"discard is required for zoned block devices");
+				return -EINVAL;
+			}
 			clear_opt(sbi, DISCARD);
+			break;
 		case Opt_noheap:
 			set_opt(sbi, NOHEAP);
 			break;
+		case Opt_heap:
+			clear_opt(sbi, NOHEAP);
+			break;
 #ifdef CONFIG_F2FS_FS_XATTR
 		case Opt_user_xattr:
 			set_opt(sbi, XATTR_USER);
@@ -433,6 +448,15 @@ static int parse_options(struct super_block *sb, char *options)
 		case Opt_inline_xattr:
 			set_opt(sbi, INLINE_XATTR);
 			break;
+		case Opt_noinline_xattr:
+			clear_opt(sbi, INLINE_XATTR);
+			break;
+		case Opt_inline_xattr_size:
+			if (args->from && match_int(args, &arg))
+				return -EINVAL;
+			set_opt(sbi, INLINE_XATTR_SIZE);
+			F2FS_OPTION(sbi).inline_xattr_size = arg;
+			break;
 #else
 		case Opt_user_xattr:
 			f2fs_msg(sb, KERN_INFO,
@@ -446,6 +470,10 @@ static int parse_options(struct super_block *sb, char *options)
 			f2fs_msg(sb, KERN_INFO,
 				"inline_xattr options not supported");
 			break;
+		case Opt_noinline_xattr:
+			f2fs_msg(sb, KERN_INFO,
+				"noinline_xattr options not supported");
+			break;
 #endif
 #ifdef CONFIG_F2FS_FS_POSIX_ACL
 		case Opt_acl:
@@ -467,7 +495,7 @@ static int parse_options(struct super_block *sb, char *options)
 				return -EINVAL;
 			if (arg != 2 && arg != 4 && arg != NR_CURSEG_TYPE)
 				return -EINVAL;
-			sbi->active_logs = arg;
+			F2FS_OPTION(sbi).active_logs = arg;
 			break;
 		case Opt_disable_ext_identify:
 			set_opt(sbi, DISABLE_EXT_IDENTIFY);
@@ -505,6 +533,40 @@ static int parse_options(struct super_block *sb, char *options)
 		case Opt_data_flush:
 			set_opt(sbi, DATA_FLUSH);
 			break;
+		case Opt_reserve_root:
+			if (args->from && match_int(args, &arg))
+				return -EINVAL;
+			if (test_opt(sbi, RESERVE_ROOT)) {
+				f2fs_msg(sb, KERN_INFO,
+					"Preserve previous reserve_root=%u",
+					F2FS_OPTION(sbi).root_reserved_blocks);
+			} else {
+				F2FS_OPTION(sbi).root_reserved_blocks = arg;
+				set_opt(sbi, RESERVE_ROOT);
+			}
+			break;
+		case Opt_resuid:
+			if (args->from && match_int(args, &arg))
+				return -EINVAL;
+			uid = make_kuid(current_user_ns(), arg);
+			if (!uid_valid(uid)) {
+				f2fs_msg(sb, KERN_ERR,
+					"Invalid uid value %d", arg);
+				return -EINVAL;
+			}
+			F2FS_OPTION(sbi).s_resuid = uid;
+			break;
+		case Opt_resgid:
+			if (args->from && match_int(args, &arg))
+				return -EINVAL;
+			gid = make_kgid(current_user_ns(), arg);
+			if (!gid_valid(gid)) {
+				f2fs_msg(sb, KERN_ERR,
+					"Invalid gid value %d", arg);
+				return -EINVAL;
+			}
+			F2FS_OPTION(sbi).s_resgid = gid;
+			break;
 		case Opt_mode:
 			name = match_strdup(&args[0]);
 
@@ -512,6 +574,13 @@ static int parse_options(struct super_block *sb, char *options)
 				return -ENOMEM;
 			if (strlen(name) == 8 &&
 					!strncmp(name, "adaptive", 8)) {
+				if (f2fs_sb_has_blkzoned(sb)) {
+					f2fs_msg(sb, KERN_WARNING,
+						 "adaptive mode is not allowed with "
+						 "zoned block device feature");
+					kfree(name);
+					return -EINVAL;
+				}
 				set_opt_mode(sbi, F2FS_MOUNT_ADAPTIVE);
 			} else if (strlen(name) == 3 &&
 					!strncmp(name, "lfs", 3)) {
@@ -522,11 +591,23 @@ static int parse_options(struct super_block *sb, char *options)
 			}
 			kfree(name);
 			break;
+		case Opt_io_size_bits:
+			if (args->from && match_int(args, &arg))
+				return -EINVAL;
+			if (arg > __ilog2_u32(BIO_MAX_PAGES)) {
+				f2fs_msg(sb, KERN_WARNING,
+					"Not support %d, larger than %d",
+					1 << arg, BIO_MAX_PAGES);
+				return -EINVAL;
+			}
+			F2FS_OPTION(sbi).write_io_size_bits = arg;
+			break;
 		case Opt_fault_injection:
 			if (args->from && match_int(args, &arg))
 				return -EINVAL;
 #ifdef CONFIG_F2FS_FAULT_INJECTION
 			f2fs_build_fault_attr(sbi, arg);
+			set_opt(sbi, FAULT_INJECTION);
 #else
 			f2fs_msg(sb, KERN_INFO,
 				"FAULT_INJECTION was not selected");
@@ -538,6 +619,152 @@ static int parse_options(struct super_block *sb, char *options)
 		case Opt_nolazytime:
 			sb->s_flags &= ~MS_LAZYTIME;
 			break;
+#ifdef CONFIG_QUOTA
+		case Opt_quota:
+		case Opt_usrquota:
+			set_opt(sbi, USRQUOTA);
+			break;
+		case Opt_grpquota:
+			set_opt(sbi, GRPQUOTA);
+			break;
+		case Opt_prjquota:
+			set_opt(sbi, PRJQUOTA);
+			break;
+		case Opt_usrjquota:
+			ret = f2fs_set_qf_name(sb, USRQUOTA, &args[0]);
+			if (ret)
+				return ret;
+			break;
+		case Opt_grpjquota:
+			ret = f2fs_set_qf_name(sb, GRPQUOTA, &args[0]);
+			if (ret)
+				return ret;
+			break;
+		case Opt_prjjquota:
+			ret = f2fs_set_qf_name(sb, PRJQUOTA, &args[0]);
+			if (ret)
+				return ret;
+			break;
+		case Opt_offusrjquota:
+			ret = f2fs_clear_qf_name(sb, USRQUOTA);
+			if (ret)
+				return ret;
+			break;
+		case Opt_offgrpjquota:
+			ret = f2fs_clear_qf_name(sb, GRPQUOTA);
+			if (ret)
+				return ret;
+			break;
+		case Opt_offprjjquota:
+			ret = f2fs_clear_qf_name(sb, PRJQUOTA);
+			if (ret)
+				return ret;
+			break;
+		case Opt_jqfmt_vfsold:
+			F2FS_OPTION(sbi).s_jquota_fmt = QFMT_VFS_OLD;
+			break;
+		case Opt_jqfmt_vfsv0:
+			F2FS_OPTION(sbi).s_jquota_fmt = QFMT_VFS_V0;
+			break;
+		case Opt_jqfmt_vfsv1:
+			F2FS_OPTION(sbi).s_jquota_fmt = QFMT_VFS_V1;
+			break;
+		case Opt_noquota:
+			clear_opt(sbi, QUOTA);
+			clear_opt(sbi, USRQUOTA);
+			clear_opt(sbi, GRPQUOTA);
+			clear_opt(sbi, PRJQUOTA);
+			break;
+#else
+		case Opt_quota:
+		case Opt_usrquota:
+		case Opt_grpquota:
+		case Opt_prjquota:
+		case Opt_usrjquota:
+		case Opt_grpjquota:
+		case Opt_prjjquota:
+		case Opt_offusrjquota:
+		case Opt_offgrpjquota:
+		case Opt_offprjjquota:
+		case Opt_jqfmt_vfsold:
+		case Opt_jqfmt_vfsv0:
+		case Opt_jqfmt_vfsv1:
+		case Opt_noquota:
+			f2fs_msg(sb, KERN_INFO,
+					"quota operations not supported");
+			break;
+#endif
+		case Opt_whint:
+			name = match_strdup(&args[0]);
+			if (!name)
+				return -ENOMEM;
+			if (strlen(name) == 10 &&
+					!strncmp(name, "user-based", 10)) {
+				F2FS_OPTION(sbi).whint_mode = WHINT_MODE_USER;
+			} else if (strlen(name) == 3 &&
+					!strncmp(name, "off", 3)) {
+				F2FS_OPTION(sbi).whint_mode = WHINT_MODE_OFF;
+			} else if (strlen(name) == 8 &&
+					!strncmp(name, "fs-based", 8)) {
+				F2FS_OPTION(sbi).whint_mode = WHINT_MODE_FS;
+			} else {
+				kfree(name);
+				return -EINVAL;
+			}
+			kfree(name);
+			break;
+		case Opt_alloc:
+			name = match_strdup(&args[0]);
+			if (!name)
+				return -ENOMEM;
+
+			if (strlen(name) == 7 &&
+					!strncmp(name, "default", 7)) {
+				F2FS_OPTION(sbi).alloc_mode = ALLOC_MODE_DEFAULT;
+			} else if (strlen(name) == 5 &&
+					!strncmp(name, "reuse", 5)) {
+				F2FS_OPTION(sbi).alloc_mode = ALLOC_MODE_REUSE;
+			} else {
+				kfree(name);
+				return -EINVAL;
+			}
+			kfree(name);
+			break;
+		case Opt_fsync:
+			name = match_strdup(&args[0]);
+			if (!name)
+				return -ENOMEM;
+			if (strlen(name) == 5 &&
+					!strncmp(name, "posix", 5)) {
+				F2FS_OPTION(sbi).fsync_mode = FSYNC_MODE_POSIX;
+			} else if (strlen(name) == 6 &&
+					!strncmp(name, "strict", 6)) {
+				F2FS_OPTION(sbi).fsync_mode = FSYNC_MODE_STRICT;
+			} else if (strlen(name) == 9 &&
+					!strncmp(name, "nobarrier", 9)) {
+				F2FS_OPTION(sbi).fsync_mode =
+							FSYNC_MODE_NOBARRIER;
+			} else {
+				kfree(name);
+				return -EINVAL;
+			}
+			kfree(name);
+			break;
+		case Opt_test_dummy_encryption:
+#ifdef CONFIG_F2FS_FS_ENCRYPTION
+			if (!f2fs_sb_has_encrypt(sb)) {
+				f2fs_msg(sb, KERN_ERR, "Encrypt feature is off");
+				return -EINVAL;
+			}
+
+			F2FS_OPTION(sbi).test_dummy_encryption = true;
+			f2fs_msg(sb, KERN_INFO,
+					"Test dummy encryption mode enabled");
+#else
+			f2fs_msg(sb, KERN_INFO,
+					"Test dummy encryption mount option ignored");
+#endif
+			break;
 		default:
 			f2fs_msg(sb, KERN_ERR,
 				"Unrecognized mount option \"%s\" or missing value",
@@ -545,6 +772,49 @@ static int parse_options(struct super_block *sb, char *options)
 			return -EINVAL;
 		}
 	}
+#ifdef CONFIG_QUOTA
+	if (f2fs_check_quota_options(sbi))
+		return -EINVAL;
+#endif
+
+	if (F2FS_IO_SIZE_BITS(sbi) && !test_opt(sbi, LFS)) {
+		f2fs_msg(sb, KERN_ERR,
+				"Should set mode=lfs with %uKB-sized IO",
+				F2FS_IO_SIZE_KB(sbi));
+		return -EINVAL;
+	}
+
+	if (test_opt(sbi, INLINE_XATTR_SIZE)) {
+		if (!f2fs_sb_has_extra_attr(sb) ||
+			!f2fs_sb_has_flexible_inline_xattr(sb)) {
+			f2fs_msg(sb, KERN_ERR,
+					"extra_attr or flexible_inline_xattr "
+					"feature is off");
+			return -EINVAL;
+		}
+		if (!test_opt(sbi, INLINE_XATTR)) {
+			f2fs_msg(sb, KERN_ERR,
+					"inline_xattr_size option should be "
+					"set with inline_xattr option");
+			return -EINVAL;
+		}
+		if (!F2FS_OPTION(sbi).inline_xattr_size ||
+			F2FS_OPTION(sbi).inline_xattr_size >=
+					DEF_ADDRS_PER_INODE -
+					F2FS_TOTAL_EXTRA_ATTR_SIZE -
+					DEF_INLINE_RESERVED_SIZE -
+					DEF_MIN_INLINE_SIZE) {
+			f2fs_msg(sb, KERN_ERR,
+					"inline xattr size is out of range");
+			return -EINVAL;
+		}
+	}
+
+	/* Not pass down write hints if the number of active logs is lesser
+	 * than NR_CURSEG_TYPE.
+	 */
+	if (F2FS_OPTION(sbi).active_logs != NR_CURSEG_TYPE)
+		F2FS_OPTION(sbi).whint_mode = WHINT_MODE_OFF;
 	return 0;
 }
 
@@ -559,25 +829,27 @@ static struct inode *f2fs_alloc_inode(struct super_block *sb)
 	init_once((void *) fi);
 
 	/* Initialize f2fs-specific inode info */
-	fi->vfs_inode.i_version = 1;
 	atomic_set(&fi->dirty_pages, 0);
-	fi->i_current_depth = 1;
-	fi->i_advise = 0;
 	init_rwsem(&fi->i_sem);
 	INIT_LIST_HEAD(&fi->dirty_list);
 	INIT_LIST_HEAD(&fi->gdirty_list);
+	INIT_LIST_HEAD(&fi->inmem_ilist);
 	INIT_LIST_HEAD(&fi->inmem_pages);
 	mutex_init(&fi->inmem_lock);
-	init_rwsem(&fi->dio_rwsem[READ]);
-	init_rwsem(&fi->dio_rwsem[WRITE]);
+	init_rwsem(&fi->i_gc_rwsem[READ]);
+	init_rwsem(&fi->i_gc_rwsem[WRITE]);
+	init_rwsem(&fi->i_mmap_sem);
+	init_rwsem(&fi->i_xattr_sem);
 
 	/* Will be used by directory only */
 	fi->i_dir_level = F2FS_SB(sb)->dir_level;
+
 	return &fi->vfs_inode;
 }
 
 static int f2fs_drop_inode(struct inode *inode)
 {
+	int ret;
 	/*
 	 * This is to avoid a deadlock condition like below.
 	 * writeback_single_inode(inode)
@@ -593,7 +865,7 @@ static int f2fs_drop_inode(struct inode *inode)
 
 			/* some remained atomic pages should discarded */
 			if (f2fs_is_atomic_file(inode))
-				drop_inmem_pages(inode);
+				f2fs_drop_inmem_pages(inode);
 
 			/* should remain fi->extent_tree for writepage */
 			f2fs_destroy_extent_node(inode);
@@ -606,34 +878,36 @@ static int f2fs_drop_inode(struct inode *inode)
 
 			sb_end_intwrite(inode->i_sb);
 
-			fscrypt_put_encryption_info(inode, NULL);
 			spin_lock(&inode->i_lock);
 			atomic_dec(&inode->i_count);
 		}
+		trace_f2fs_drop_inode(inode, 0);
 		return 0;
 	}
-
-	return generic_drop_inode(inode);
+	ret = generic_drop_inode(inode);
+	trace_f2fs_drop_inode(inode, ret);
+	return ret;
 }
 
-int f2fs_inode_dirtied(struct inode *inode)
+int f2fs_inode_dirtied(struct inode *inode, bool sync)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+	int ret = 0;
 
 	spin_lock(&sbi->inode_lock[DIRTY_META]);
 	if (is_inode_flag_set(inode, FI_DIRTY_INODE)) {
-		spin_unlock(&sbi->inode_lock[DIRTY_META]);
-		return 1;
+		ret = 1;
+	} else {
+		set_inode_flag(inode, FI_DIRTY_INODE);
+		stat_inc_dirty_inode(sbi, DIRTY_META);
 	}
-
-	set_inode_flag(inode, FI_DIRTY_INODE);
-	list_add_tail(&F2FS_I(inode)->gdirty_list,
+	if (sync && list_empty(&F2FS_I(inode)->gdirty_list)) {
+		list_add_tail(&F2FS_I(inode)->gdirty_list,
 				&sbi->inode_list[DIRTY_META]);
-	inc_page_count(sbi, F2FS_DIRTY_IMETA);
-	stat_inc_dirty_inode(sbi, DIRTY_META);
+		inc_page_count(sbi, F2FS_DIRTY_IMETA);
+	}
 	spin_unlock(&sbi->inode_lock[DIRTY_META]);
-
-	return 0;
+	return ret;
 }
 
 void f2fs_inode_synced(struct inode *inode)
@@ -645,10 +919,12 @@ void f2fs_inode_synced(struct inode *inode)
 		spin_unlock(&sbi->inode_lock[DIRTY_META]);
 		return;
 	}
-	list_del_init(&F2FS_I(inode)->gdirty_list);
+	if (!list_empty(&F2FS_I(inode)->gdirty_list)) {
+		list_del_init(&F2FS_I(inode)->gdirty_list);
+		dec_page_count(sbi, F2FS_DIRTY_IMETA);
+	}
 	clear_inode_flag(inode, FI_DIRTY_INODE);
 	clear_inode_flag(inode, FI_AUTO_RECOVER);
-	dec_page_count(sbi, F2FS_DIRTY_IMETA);
 	stat_dec_dirty_inode(F2FS_I_SB(inode), DIRTY_META);
 	spin_unlock(&sbi->inode_lock[DIRTY_META]);
 }
@@ -672,7 +948,7 @@ static void f2fs_dirty_inode(struct inode *inode, int flags)
 	if (is_inode_flag_set(inode, FI_AUTO_RECOVER))
 		clear_inode_flag(inode, FI_AUTO_RECOVER);
 
-	f2fs_inode_dirtied(inode);
+	f2fs_inode_dirtied(inode, false);
 }
 
 static void f2fs_i_callback(struct rcu_head *head)
@@ -692,18 +968,26 @@ static void destroy_percpu_info(struct f2fs_sb_info *sbi)
 	percpu_counter_destroy(&sbi->total_valid_inode_count);
 }
 
-static void f2fs_put_super(struct super_block *sb)
+static void destroy_device_list(struct f2fs_sb_info *sbi)
 {
-	struct f2fs_sb_info *sbi = F2FS_SB(sb);
+	int i;
 
-	if (sbi->s_proc) {
-		remove_proc_entry("segment_info", sbi->s_proc);
-		remove_proc_entry("segment_bits", sbi->s_proc);
-		remove_proc_entry(sb->s_id, f2fs_proc_root);
+	for (i = 0; i < sbi->s_ndevs; i++) {
+		blkdev_put(FDEV(i).bdev, FMODE_EXCL);
+#ifdef CONFIG_BLK_DEV_ZONED
+		kfree(FDEV(i).blkz_type);
+#endif
 	}
-	kobject_del(&sbi->s_kobj);
+	kfree(sbi->devs);
+}
+
+static void f2fs_put_super(struct super_block *sb)
+{
+	struct f2fs_sb_info *sbi = F2FS_SB(sb);
+	int i;
+	bool dropped;
 
-	stop_gc_thread(sbi);
+	f2fs_quota_off_umount(sb);
 
 	/* prevent remaining shrinker jobs */
 	mutex_lock(&sbi->umount_mutex);
@@ -718,42 +1002,59 @@ static void f2fs_put_super(struct super_block *sb)
 		struct cp_control cpc = {
 			.reason = CP_UMOUNT,
 		};
-		write_checkpoint(sbi, &cpc);
+		f2fs_write_checkpoint(sbi, &cpc);
 	}
 
-	/* write_checkpoint can update stat informaion */
+	/* be sure to wait for any on-going discard commands */
+	dropped = f2fs_wait_discard_bios(sbi);
+
+	if (f2fs_discard_en(sbi) && !sbi->discard_blks && !dropped) {
+		struct cp_control cpc = {
+			.reason = CP_UMOUNT | CP_TRIMMED,
+		};
+		f2fs_write_checkpoint(sbi, &cpc);
+	}
+
+	/* f2fs_write_checkpoint can update stat informaion */
 	f2fs_destroy_stats(sbi);
 
 	/*
 	 * normally superblock is clean, so we need to release this.
 	 * In addition, EIO will skip do checkpoint, we need this as well.
 	 */
-	release_ino_entry(sbi, true);
-	release_discard_addrs(sbi);
+	f2fs_release_ino_entry(sbi, true);
 
 	f2fs_leave_shrinker(sbi);
 	mutex_unlock(&sbi->umount_mutex);
 
 	/* our cp_error case, we can wait for any writeback page */
-	f2fs_flush_merged_bios(sbi);
+	f2fs_flush_merged_writes(sbi);
 
 	iput(sbi->node_inode);
 	iput(sbi->meta_inode);
 
 	/* destroy f2fs internal modules */
-	destroy_node_manager(sbi);
-	destroy_segment_manager(sbi);
+	f2fs_destroy_node_manager(sbi);
+	f2fs_destroy_segment_manager(sbi);
 
 	kfree(sbi->ckpt);
-	kobject_put(&sbi->s_kobj);
-	wait_for_completion(&sbi->s_kobj_unregister);
+
+	f2fs_unregister_sysfs(sbi);
 
 	sb->s_fs_info = NULL;
 	if (sbi->s_chksum_driver)
 		crypto_free_shash(sbi->s_chksum_driver);
 	kfree(sbi->raw_super);
 
+	destroy_device_list(sbi);
+	mempool_destroy(sbi->write_io_dummy);
+#ifdef CONFIG_QUOTA
+	for (i = 0; i < MAXQUOTAS; i++)
+		kfree(F2FS_OPTION(sbi).s_qf_names[i]);
+#endif
 	destroy_percpu_info(sbi);
+	for (i = 0; i < NR_PAGE_TYPE; i++)
+		kfree(sbi->write_io[i]);
 	kfree(sbi);
 }
 
@@ -762,15 +1063,21 @@ int f2fs_sync_fs(struct super_block *sb, int sync)
 	struct f2fs_sb_info *sbi = F2FS_SB(sb);
 	int err = 0;
 
+	if (unlikely(f2fs_cp_error(sbi)))
+		return 0;
+
 	trace_f2fs_sync_fs(sb, sync);
 
+	if (unlikely(is_sbi_flag_set(sbi, SBI_POR_DOING)))
+		return -EAGAIN;
+
 	if (sync) {
 		struct cp_control cpc;
 
 		cpc.reason = __get_cp_reason(sbi);
 
 		mutex_lock(&sbi->gc_mutex);
-		err = write_checkpoint(sbi, &cpc);
+		err = f2fs_write_checkpoint(sbi, &cpc);
 		mutex_unlock(&sbi->gc_mutex);
 	}
 	f2fs_trace_ios(NULL, 1);
@@ -780,13 +1087,17 @@ int f2fs_sync_fs(struct super_block *sb, int sync)
 
 static int f2fs_freeze(struct super_block *sb)
 {
-	int err;
-
 	if (f2fs_readonly(sb))
 		return 0;
 
-	err = f2fs_sync_fs(sb, 1);
-	return err;
+	/* IO error happened before */
+	if (unlikely(f2fs_cp_error(F2FS_SB(sb))))
+		return -EIO;
+
+	/* must be clean, since sync_filesystem() was already called */
+	if (is_sbi_flag_set(F2FS_SB(sb), SBI_IS_DIRTY))
+		return -EINVAL;
+	return 0;
 }
 
 static int f2fs_unfreeze(struct super_block *sb)
@@ -794,34 +1105,133 @@ static int f2fs_unfreeze(struct super_block *sb)
 	return 0;
 }
 
+#ifdef CONFIG_QUOTA
+static int f2fs_statfs_project(struct super_block *sb,
+				kprojid_t projid, struct kstatfs *buf)
+{
+	struct kqid qid;
+	struct dquot *dquot;
+	u64 limit;
+	u64 curblock;
+
+	qid = make_kqid_projid(projid);
+	dquot = dqget(sb, qid);
+	if (IS_ERR(dquot))
+		return PTR_ERR(dquot);
+	spin_lock(&dq_data_lock);
+
+	limit = (dquot->dq_dqb.dqb_bsoftlimit ?
+		 dquot->dq_dqb.dqb_bsoftlimit :
+		 dquot->dq_dqb.dqb_bhardlimit) >> sb->s_blocksize_bits;
+	if (limit && buf->f_blocks > limit) {
+		curblock = dquot->dq_dqb.dqb_curspace >> sb->s_blocksize_bits;
+		buf->f_blocks = limit;
+		buf->f_bfree = buf->f_bavail =
+			(buf->f_blocks > curblock) ?
+			 (buf->f_blocks - curblock) : 0;
+	}
+
+	limit = dquot->dq_dqb.dqb_isoftlimit ?
+		dquot->dq_dqb.dqb_isoftlimit :
+		dquot->dq_dqb.dqb_ihardlimit;
+	if (limit && buf->f_files > limit) {
+		buf->f_files = limit;
+		buf->f_ffree =
+			(buf->f_files > dquot->dq_dqb.dqb_curinodes) ?
+			 (buf->f_files - dquot->dq_dqb.dqb_curinodes) : 0;
+	}
+
+	spin_unlock(&dq_data_lock);
+	dqput(dquot);
+	return 0;
+}
+#endif
+
 static int f2fs_statfs(struct dentry *dentry, struct kstatfs *buf)
 {
 	struct super_block *sb = dentry->d_sb;
 	struct f2fs_sb_info *sbi = F2FS_SB(sb);
 	u64 id = huge_encode_dev(sb->s_bdev->bd_dev);
-	block_t total_count, user_block_count, start_count, ovp_count;
+	block_t total_count, user_block_count, start_count;
+	u64 avail_node_count;
 
 	total_count = le64_to_cpu(sbi->raw_super->block_count);
 	user_block_count = sbi->user_block_count;
 	start_count = le32_to_cpu(sbi->raw_super->segment0_blkaddr);
-	ovp_count = SM_I(sbi)->ovp_segments << sbi->log_blocks_per_seg;
 	buf->f_type = F2FS_SUPER_MAGIC;
 	buf->f_bsize = sbi->blocksize;
 
 	buf->f_blocks = total_count - start_count;
-	buf->f_bfree = user_block_count - valid_user_blocks(sbi) + ovp_count;
-	buf->f_bavail = user_block_count - valid_user_blocks(sbi);
+	buf->f_bfree = user_block_count - valid_user_blocks(sbi) -
+						sbi->current_reserved_blocks;
+	if (buf->f_bfree > F2FS_OPTION(sbi).root_reserved_blocks)
+		buf->f_bavail = buf->f_bfree -
+				F2FS_OPTION(sbi).root_reserved_blocks;
+	else
+		buf->f_bavail = 0;
+
+	avail_node_count = sbi->total_node_count - sbi->nquota_files -
+						F2FS_RESERVED_NODE_NUM;
 
-	buf->f_files = sbi->total_node_count - F2FS_RESERVED_NODE_NUM;
-	buf->f_ffree = buf->f_files - valid_inode_count(sbi);
+	if (avail_node_count > user_block_count) {
+		buf->f_files = user_block_count;
+		buf->f_ffree = buf->f_bavail;
+	} else {
+		buf->f_files = avail_node_count;
+		buf->f_ffree = min(avail_node_count - valid_node_count(sbi),
+					buf->f_bavail);
+	}
 
 	buf->f_namelen = F2FS_NAME_LEN;
 	buf->f_fsid.val[0] = (u32)id;
 	buf->f_fsid.val[1] = (u32)(id >> 32);
 
+#ifdef CONFIG_QUOTA
+	if (is_inode_flag_set(dentry->d_inode, FI_PROJ_INHERIT) &&
+			sb_has_quota_limits_enabled(sb, PRJQUOTA)) {
+		f2fs_statfs_project(sb, F2FS_I(dentry->d_inode)->i_projid, buf);
+	}
+#endif
 	return 0;
 }
 
+static inline void f2fs_show_quota_options(struct seq_file *seq,
+					   struct super_block *sb)
+{
+#ifdef CONFIG_QUOTA
+	struct f2fs_sb_info *sbi = F2FS_SB(sb);
+
+	if (F2FS_OPTION(sbi).s_jquota_fmt) {
+		char *fmtname = "";
+
+		switch (F2FS_OPTION(sbi).s_jquota_fmt) {
+		case QFMT_VFS_OLD:
+			fmtname = "vfsold";
+			break;
+		case QFMT_VFS_V0:
+			fmtname = "vfsv0";
+			break;
+		case QFMT_VFS_V1:
+			fmtname = "vfsv1";
+			break;
+		}
+		seq_printf(seq, ",jqfmt=%s", fmtname);
+	}
+
+	if (F2FS_OPTION(sbi).s_qf_names[USRQUOTA])
+		seq_show_option(seq, "usrjquota",
+			F2FS_OPTION(sbi).s_qf_names[USRQUOTA]);
+
+	if (F2FS_OPTION(sbi).s_qf_names[GRPQUOTA])
+		seq_show_option(seq, "grpjquota",
+			F2FS_OPTION(sbi).s_qf_names[GRPQUOTA]);
+
+	if (F2FS_OPTION(sbi).s_qf_names[PRJQUOTA])
+		seq_show_option(seq, "prjjquota",
+			F2FS_OPTION(sbi).s_qf_names[PRJQUOTA]);
+#endif
+}
+
 static int f2fs_show_options(struct seq_file *seq, struct dentry *root)
 {
 	struct f2fs_sb_info *sbi = F2FS_SB(root->d_sb);
@@ -839,7 +1249,9 @@ static int f2fs_show_options(struct seq_file *seq, struct dentry *root)
 	if (test_opt(sbi, DISCARD))
 		seq_puts(seq, ",discard");
 	if (test_opt(sbi, NOHEAP))
-		seq_puts(seq, ",no_heap_alloc");
+		seq_puts(seq, ",no_heap");
+	else
+		seq_puts(seq, ",heap");
 #ifdef CONFIG_F2FS_FS_XATTR
 	if (test_opt(sbi, XATTR_USER))
 		seq_puts(seq, ",user_xattr");
@@ -847,6 +1259,11 @@ static int f2fs_show_options(struct seq_file *seq, struct dentry *root)
 		seq_puts(seq, ",nouser_xattr");
 	if (test_opt(sbi, INLINE_XATTR))
 		seq_puts(seq, ",inline_xattr");
+	else
+		seq_puts(seq, ",noinline_xattr");
+	if (test_opt(sbi, INLINE_XATTR_SIZE))
+		seq_printf(seq, ",inline_xattr_size=%u",
+					F2FS_OPTION(sbi).inline_xattr_size);
 #endif
 #ifdef CONFIG_F2FS_FS_POSIX_ACL
 	if (test_opt(sbi, POSIX_ACL))
@@ -882,90 +1299,73 @@ static int f2fs_show_options(struct seq_file *seq, struct dentry *root)
 		seq_puts(seq, "adaptive");
 	else if (test_opt(sbi, LFS))
 		seq_puts(seq, "lfs");
-	seq_printf(seq, ",active_logs=%u", sbi->active_logs);
-
-	return 0;
-}
-
-static int segment_info_seq_show(struct seq_file *seq, void *offset)
-{
-	struct super_block *sb = seq->private;
-	struct f2fs_sb_info *sbi = F2FS_SB(sb);
-	unsigned int total_segs =
-			le32_to_cpu(sbi->raw_super->segment_count_main);
-	int i;
-
-	seq_puts(seq, "format: segment_type|valid_blocks\n"
-		"segment_type(0:HD, 1:WD, 2:CD, 3:HN, 4:WN, 5:CN)\n");
-
-	for (i = 0; i < total_segs; i++) {
-		struct seg_entry *se = get_seg_entry(sbi, i);
-
-		if ((i % 10) == 0)
-			seq_printf(seq, "%-10d", i);
-		seq_printf(seq, "%d|%-3u", se->type,
-					get_valid_blocks(sbi, i, 1));
-		if ((i % 10) == 9 || i == (total_segs - 1))
-			seq_putc(seq, '\n');
-		else
-			seq_putc(seq, ' ');
-	}
-
-	return 0;
-}
-
-static int segment_bits_seq_show(struct seq_file *seq, void *offset)
-{
-	struct super_block *sb = seq->private;
-	struct f2fs_sb_info *sbi = F2FS_SB(sb);
-	unsigned int total_segs =
-			le32_to_cpu(sbi->raw_super->segment_count_main);
-	int i, j;
-
-	seq_puts(seq, "format: segment_type|valid_blocks|bitmaps\n"
-		"segment_type(0:HD, 1:WD, 2:CD, 3:HN, 4:WN, 5:CN)\n");
+	seq_printf(seq, ",active_logs=%u", F2FS_OPTION(sbi).active_logs);
+	if (test_opt(sbi, RESERVE_ROOT))
+		seq_printf(seq, ",reserve_root=%u,resuid=%u,resgid=%u",
+				F2FS_OPTION(sbi).root_reserved_blocks,
+				from_kuid_munged(&init_user_ns,
+					F2FS_OPTION(sbi).s_resuid),
+				from_kgid_munged(&init_user_ns,
+					F2FS_OPTION(sbi).s_resgid));
+	if (F2FS_IO_SIZE_BITS(sbi))
+		seq_printf(seq, ",io_size=%uKB", F2FS_IO_SIZE_KB(sbi));
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	if (test_opt(sbi, FAULT_INJECTION))
+		seq_printf(seq, ",fault_injection=%u",
+				F2FS_OPTION(sbi).fault_info.inject_rate);
+#endif
+#ifdef CONFIG_QUOTA
+	if (test_opt(sbi, QUOTA))
+		seq_puts(seq, ",quota");
+	if (test_opt(sbi, USRQUOTA))
+		seq_puts(seq, ",usrquota");
+	if (test_opt(sbi, GRPQUOTA))
+		seq_puts(seq, ",grpquota");
+	if (test_opt(sbi, PRJQUOTA))
+		seq_puts(seq, ",prjquota");
+#endif
+	f2fs_show_quota_options(seq, sbi->sb);
+	if (F2FS_OPTION(sbi).whint_mode == WHINT_MODE_USER)
+		seq_printf(seq, ",whint_mode=%s", "user-based");
+	else if (F2FS_OPTION(sbi).whint_mode == WHINT_MODE_FS)
+		seq_printf(seq, ",whint_mode=%s", "fs-based");
+#ifdef CONFIG_F2FS_FS_ENCRYPTION
+	if (F2FS_OPTION(sbi).test_dummy_encryption)
+		seq_puts(seq, ",test_dummy_encryption");
+#endif
 
-	for (i = 0; i < total_segs; i++) {
-		struct seg_entry *se = get_seg_entry(sbi, i);
+	if (F2FS_OPTION(sbi).alloc_mode == ALLOC_MODE_DEFAULT)
+		seq_printf(seq, ",alloc_mode=%s", "default");
+	else if (F2FS_OPTION(sbi).alloc_mode == ALLOC_MODE_REUSE)
+		seq_printf(seq, ",alloc_mode=%s", "reuse");
 
-		seq_printf(seq, "%-10d", i);
-		seq_printf(seq, "%d|%-3u|", se->type,
-					get_valid_blocks(sbi, i, 1));
-		for (j = 0; j < SIT_VBLOCK_MAP_SIZE; j++)
-			seq_printf(seq, " %.2x", se->cur_valid_map[j]);
-		seq_putc(seq, '\n');
-	}
+	if (F2FS_OPTION(sbi).fsync_mode == FSYNC_MODE_POSIX)
+		seq_printf(seq, ",fsync_mode=%s", "posix");
+	else if (F2FS_OPTION(sbi).fsync_mode == FSYNC_MODE_STRICT)
+		seq_printf(seq, ",fsync_mode=%s", "strict");
 	return 0;
 }
 
-#define F2FS_PROC_FILE_DEF(_name)					\
-static int _name##_open_fs(struct inode *inode, struct file *file)	\
-{									\
-	return single_open(file, _name##_seq_show, PDE_DATA(inode));	\
-}									\
-									\
-static const struct file_operations f2fs_seq_##_name##_fops = {		\
-	.open = _name##_open_fs,					\
-	.read = seq_read,						\
-	.llseek = seq_lseek,						\
-	.release = single_release,					\
-};
-
-F2FS_PROC_FILE_DEF(segment_info);
-F2FS_PROC_FILE_DEF(segment_bits);
-
 static void default_options(struct f2fs_sb_info *sbi)
 {
 	/* init some FS parameters */
-	sbi->active_logs = NR_CURSEG_TYPE;
+	F2FS_OPTION(sbi).active_logs = NR_CURSEG_TYPE;
+	F2FS_OPTION(sbi).inline_xattr_size = DEFAULT_INLINE_XATTR_ADDRS;
+	F2FS_OPTION(sbi).whint_mode = WHINT_MODE_OFF;
+	F2FS_OPTION(sbi).alloc_mode = ALLOC_MODE_DEFAULT;
+	F2FS_OPTION(sbi).fsync_mode = FSYNC_MODE_POSIX;
+	F2FS_OPTION(sbi).test_dummy_encryption = false;
+	sbi->readdir_ra = 1;
 
 	set_opt(sbi, BG_GC);
+	set_opt(sbi, INLINE_XATTR);
 	set_opt(sbi, INLINE_DATA);
 	set_opt(sbi, INLINE_DENTRY);
 	set_opt(sbi, EXTENT_CACHE);
+	set_opt(sbi, NOHEAP);
 	sbi->sb->s_flags |= MS_LAZYTIME;
 	set_opt(sbi, FLUSH_MERGE);
-	if (f2fs_sb_mounted_hmsmr(sbi->sb)) {
+	if (f2fs_sb_has_blkzoned(sbi->sb)) {
 		set_opt_mode(sbi, F2FS_MOUNT_LFS);
 		set_opt(sbi, DISCARD);
 	} else {
@@ -984,16 +1384,20 @@ static void default_options(struct f2fs_sb_info *sbi)
 #endif
 }
 
+#ifdef CONFIG_QUOTA
+static int f2fs_enable_quotas(struct super_block *sb);
+#endif
 static int f2fs_remount(struct super_block *sb, int *flags, char *data)
 {
 	struct f2fs_sb_info *sbi = F2FS_SB(sb);
 	struct f2fs_mount_info org_mount_opt;
-	int err, active_logs;
+	unsigned long old_sb_flags;
+	int err;
 	bool need_restart_gc = false;
 	bool need_stop_gc = false;
 	bool no_extent_cache = !test_opt(sbi, EXTENT_CACHE);
-#ifdef CONFIG_F2FS_FAULT_INJECTION
-	struct f2fs_fault_info ffi = sbi->fault_info;
+#ifdef CONFIG_QUOTA
+	int i, j;
 #endif
 
 	/*
@@ -1001,7 +1405,25 @@ static int f2fs_remount(struct super_block *sb, int *flags, char *data)
 	 * need to restore them.
 	 */
 	org_mount_opt = sbi->mount_opt;
-	active_logs = sbi->active_logs;
+	old_sb_flags = sb->s_flags;
+
+#ifdef CONFIG_QUOTA
+	org_mount_opt.s_jquota_fmt = F2FS_OPTION(sbi).s_jquota_fmt;
+	for (i = 0; i < MAXQUOTAS; i++) {
+		if (F2FS_OPTION(sbi).s_qf_names[i]) {
+			org_mount_opt.s_qf_names[i] =
+				kstrdup(F2FS_OPTION(sbi).s_qf_names[i],
+				GFP_KERNEL);
+			if (!org_mount_opt.s_qf_names[i]) {
+				for (j = 0; j < i; j++)
+					kfree(org_mount_opt.s_qf_names[j]);
+				return -ENOMEM;
+			}
+		} else {
+			org_mount_opt.s_qf_names[i] = NULL;
+		}
+	}
+#endif
 
 	/* recover superblocks we couldn't write due to previous RO mount */
 	if (!(*flags & MS_RDONLY) && is_sbi_flag_set(sbi, SBI_NEED_SB_WRITE)) {
@@ -1012,7 +1434,6 @@ static int f2fs_remount(struct super_block *sb, int *flags, char *data)
 			clear_sbi_flag(sbi, SBI_NEED_SB_WRITE);
 	}
 
-	sbi->mount_opt.opt = 0;
 	default_options(sbi);
 
 	/* parse mount options */
@@ -1027,6 +1448,23 @@ static int f2fs_remount(struct super_block *sb, int *flags, char *data)
 	if (f2fs_readonly(sb) && (*flags & MS_RDONLY))
 		goto skip;
 
+#ifdef CONFIG_QUOTA
+	if (!f2fs_readonly(sb) && (*flags & MS_RDONLY)) {
+		err = dquot_suspend(sb, -1);
+		if (err < 0)
+			goto restore_opts;
+	} else if (f2fs_readonly(sb) && !(*flags & MS_RDONLY)) {
+		/* dquot_resume needs RW */
+		sb->s_flags &= ~MS_RDONLY;
+		if (sb_any_quota_suspended(sb)) {
+			dquot_resume(sb, -1);
+		} else if (f2fs_sb_has_quota_ino(sb)) {
+			err = f2fs_enable_quotas(sb);
+			if (err)
+				goto restore_opts;
+		}
+	}
+#endif
 	/* disallow enable/disable extent_cache dynamically */
 	if (no_extent_cache == !!test_opt(sbi, EXTENT_CACHE)) {
 		err = -EINVAL;
@@ -1042,17 +1480,18 @@ static int f2fs_remount(struct super_block *sb, int *flags, char *data)
 	 */
 	if ((*flags & MS_RDONLY) || !test_opt(sbi, BG_GC)) {
 		if (sbi->gc_thread) {
-			stop_gc_thread(sbi);
+			f2fs_stop_gc_thread(sbi);
 			need_restart_gc = true;
 		}
 	} else if (!sbi->gc_thread) {
-		err = start_gc_thread(sbi);
+		err = f2fs_start_gc_thread(sbi);
 		if (err)
 			goto restore_opts;
 		need_stop_gc = true;
 	}
 
-	if (*flags & MS_RDONLY) {
+	if (*flags & MS_RDONLY ||
+		F2FS_OPTION(sbi).whint_mode != org_mount_opt.whint_mode) {
 		writeback_inodes_sb(sb, WB_REASON_SYNC);
 		sync_inodes_sb(sb);
 
@@ -1063,46 +1502,395 @@ static int f2fs_remount(struct super_block *sb, int *flags, char *data)
 	}
 
 	/*
-	 * We stop issue flush thread if FS is mounted as RO
-	 * or if flush_merge is not passed in mount option.
+	 * We stop issue flush thread if FS is mounted as RO
+	 * or if flush_merge is not passed in mount option.
+	 */
+	if ((*flags & MS_RDONLY) || !test_opt(sbi, FLUSH_MERGE)) {
+		clear_opt(sbi, FLUSH_MERGE);
+		f2fs_destroy_flush_cmd_control(sbi, false);
+	} else {
+		err = f2fs_create_flush_cmd_control(sbi);
+		if (err)
+			goto restore_gc;
+	}
+skip:
+#ifdef CONFIG_QUOTA
+	/* Release old quota file names */
+	for (i = 0; i < MAXQUOTAS; i++)
+		kfree(org_mount_opt.s_qf_names[i]);
+#endif
+	/* Update the POSIXACL Flag */
+	sb->s_flags = (sb->s_flags & ~MS_POSIXACL) |
+		(test_opt(sbi, POSIX_ACL) ? MS_POSIXACL : 0);
+
+	limit_reserve_root(sbi);
+	return 0;
+restore_gc:
+	if (need_restart_gc) {
+		if (f2fs_start_gc_thread(sbi))
+			f2fs_msg(sbi->sb, KERN_WARNING,
+				"background gc thread has stopped");
+	} else if (need_stop_gc) {
+		f2fs_stop_gc_thread(sbi);
+	}
+restore_opts:
+#ifdef CONFIG_QUOTA
+	F2FS_OPTION(sbi).s_jquota_fmt = org_mount_opt.s_jquota_fmt;
+	for (i = 0; i < MAXQUOTAS; i++) {
+		kfree(F2FS_OPTION(sbi).s_qf_names[i]);
+		F2FS_OPTION(sbi).s_qf_names[i] = org_mount_opt.s_qf_names[i];
+	}
+#endif
+	sbi->mount_opt = org_mount_opt;
+	sb->s_flags = old_sb_flags;
+	return err;
+}
+
+#ifdef CONFIG_QUOTA
+/* Read data from quotafile */
+static ssize_t f2fs_quota_read(struct super_block *sb, int type, char *data,
+			       size_t len, loff_t off)
+{
+	struct inode *inode = sb_dqopt(sb)->files[type];
+	struct address_space *mapping = inode->i_mapping;
+	block_t blkidx = F2FS_BYTES_TO_BLK(off);
+	int offset = off & (sb->s_blocksize - 1);
+	int tocopy;
+	size_t toread;
+	loff_t i_size = i_size_read(inode);
+	struct page *page;
+	char *kaddr;
+
+	if (off > i_size)
+		return 0;
+
+	if (off + len > i_size)
+		len = i_size - off;
+	toread = len;
+	while (toread > 0) {
+		tocopy = min_t(unsigned long, sb->s_blocksize - offset, toread);
+repeat:
+		page = read_cache_page_gfp(mapping, blkidx, GFP_NOFS);
+		if (IS_ERR(page)) {
+			if (PTR_ERR(page) == -ENOMEM) {
+				congestion_wait(BLK_RW_ASYNC, HZ/50);
+				goto repeat;
+			}
+			return PTR_ERR(page);
+		}
+
+		lock_page(page);
+
+		if (unlikely(page->mapping != mapping)) {
+			f2fs_put_page(page, 1);
+			goto repeat;
+		}
+		if (unlikely(!PageUptodate(page))) {
+			f2fs_put_page(page, 1);
+			return -EIO;
+		}
+
+		kaddr = kmap_atomic(page);
+		memcpy(data, kaddr + offset, tocopy);
+		kunmap_atomic(kaddr);
+		f2fs_put_page(page, 1);
+
+		offset = 0;
+		toread -= tocopy;
+		data += tocopy;
+		blkidx++;
+	}
+	return len;
+}
+
+/* Write to quotafile */
+static ssize_t f2fs_quota_write(struct super_block *sb, int type,
+				const char *data, size_t len, loff_t off)
+{
+	struct inode *inode = sb_dqopt(sb)->files[type];
+	struct address_space *mapping = inode->i_mapping;
+	const struct address_space_operations *a_ops = mapping->a_ops;
+	int offset = off & (sb->s_blocksize - 1);
+	size_t towrite = len;
+	struct page *page;
+	char *kaddr;
+	int err = 0;
+	int tocopy;
+
+	while (towrite > 0) {
+		tocopy = min_t(unsigned long, sb->s_blocksize - offset,
+								towrite);
+retry:
+		err = a_ops->write_begin(NULL, mapping, off, tocopy, 0,
+							&page, NULL);
+		if (unlikely(err)) {
+			if (err == -ENOMEM) {
+				congestion_wait(BLK_RW_ASYNC, HZ/50);
+				goto retry;
+			}
+			break;
+		}
+
+		kaddr = kmap_atomic(page);
+		memcpy(kaddr + offset, data, tocopy);
+		kunmap_atomic(kaddr);
+		flush_dcache_page(page);
+
+		a_ops->write_end(NULL, mapping, off, tocopy, tocopy,
+						page, NULL);
+		offset = 0;
+		towrite -= tocopy;
+		off += tocopy;
+		data += tocopy;
+		cond_resched();
+	}
+
+	if (len == towrite)
+		return err;
+	inode->i_mtime = inode->i_ctime = current_time(inode);
+	f2fs_mark_inode_dirty_sync(inode, false);
+	return len - towrite;
+}
+
+static struct dquot **f2fs_get_dquots(struct inode *inode)
+{
+	return F2FS_I(inode)->i_dquot;
+}
+
+static qsize_t *f2fs_get_reserved_space(struct inode *inode)
+{
+	return &F2FS_I(inode)->i_reserved_quota;
+}
+
+static int f2fs_quota_on_mount(struct f2fs_sb_info *sbi, int type)
+{
+	return dquot_quota_on_mount(sbi->sb, F2FS_OPTION(sbi).s_qf_names[type],
+					F2FS_OPTION(sbi).s_jquota_fmt, type);
+}
+
+int f2fs_enable_quota_files(struct f2fs_sb_info *sbi, bool rdonly)
+{
+	int enabled = 0;
+	int i, err;
+
+	if (f2fs_sb_has_quota_ino(sbi->sb) && rdonly) {
+		err = f2fs_enable_quotas(sbi->sb);
+		if (err) {
+			f2fs_msg(sbi->sb, KERN_ERR,
+					"Cannot turn on quota_ino: %d", err);
+			return 0;
+		}
+		return 1;
+	}
+
+	for (i = 0; i < MAXQUOTAS; i++) {
+		if (F2FS_OPTION(sbi).s_qf_names[i]) {
+			err = f2fs_quota_on_mount(sbi, i);
+			if (!err) {
+				enabled = 1;
+				continue;
+			}
+			f2fs_msg(sbi->sb, KERN_ERR,
+				"Cannot turn on quotas: %d on %d", err, i);
+		}
+	}
+	return enabled;
+}
+
+static int f2fs_quota_enable(struct super_block *sb, int type, int format_id,
+			     unsigned int flags)
+{
+	struct inode *qf_inode;
+	unsigned long qf_inum;
+	int err;
+
+	BUG_ON(!f2fs_sb_has_quota_ino(sb));
+
+	qf_inum = f2fs_qf_ino(sb, type);
+	if (!qf_inum)
+		return -EPERM;
+
+	qf_inode = f2fs_iget(sb, qf_inum);
+	if (IS_ERR(qf_inode)) {
+		f2fs_msg(sb, KERN_ERR,
+			"Bad quota inode %u:%lu", type, qf_inum);
+		return PTR_ERR(qf_inode);
+	}
+
+	/* Don't account quota for quota files to avoid recursion */
+	qf_inode->i_flags |= S_NOQUOTA;
+	err = dquot_enable(qf_inode, type, format_id, flags);
+	iput(qf_inode);
+	return err;
+}
+
+static int f2fs_enable_quotas(struct super_block *sb)
+{
+	int type, err = 0;
+	unsigned long qf_inum;
+	bool quota_mopt[MAXQUOTAS] = {
+		test_opt(F2FS_SB(sb), USRQUOTA),
+		test_opt(F2FS_SB(sb), GRPQUOTA),
+		test_opt(F2FS_SB(sb), PRJQUOTA),
+	};
+
+	sb_dqopt(sb)->flags |= DQUOT_QUOTA_SYS_FILE;
+	for (type = 0; type < MAXQUOTAS; type++) {
+		qf_inum = f2fs_qf_ino(sb, type);
+		if (qf_inum) {
+			err = f2fs_quota_enable(sb, type, QFMT_VFS_V1,
+				DQUOT_USAGE_ENABLED |
+				(quota_mopt[type] ? DQUOT_LIMITS_ENABLED : 0));
+			if (err) {
+				f2fs_msg(sb, KERN_ERR,
+					"Failed to enable quota tracking "
+					"(type=%d, err=%d). Please run "
+					"fsck to fix.", type, err);
+				for (type--; type >= 0; type--)
+					dquot_quota_off(sb, type);
+				return err;
+			}
+		}
+	}
+	return 0;
+}
+
+static int f2fs_quota_sync(struct super_block *sb, int type)
+{
+	struct quota_info *dqopt = sb_dqopt(sb);
+	int cnt;
+	int ret;
+
+	ret = dquot_writeback_dquots(sb, type);
+	if (ret)
+		return ret;
+
+	/*
+	 * Now when everything is written we can discard the pagecache so
+	 * that userspace sees the changes.
 	 */
-	if ((*flags & MS_RDONLY) || !test_opt(sbi, FLUSH_MERGE)) {
-		destroy_flush_cmd_control(sbi);
-	} else if (!SM_I(sbi)->cmd_control_info) {
-		err = create_flush_cmd_control(sbi);
-		if (err)
-			goto restore_gc;
+	for (cnt = 0; cnt < MAXQUOTAS; cnt++) {
+		if (type != -1 && cnt != type)
+			continue;
+		if (!sb_has_quota_active(sb, cnt))
+			continue;
+
+		ret = filemap_write_and_wait(dqopt->files[cnt]->i_mapping);
+		if (ret)
+			return ret;
+
+		inode_lock(dqopt->files[cnt]);
+		truncate_inode_pages(&dqopt->files[cnt]->i_data, 0);
+		inode_unlock(dqopt->files[cnt]);
 	}
-skip:
-	/* Update the POSIXACL Flag */
-	sb->s_flags = (sb->s_flags & ~MS_POSIXACL) |
-		(test_opt(sbi, POSIX_ACL) ? MS_POSIXACL : 0);
+	return 0;
+}
+
+static int f2fs_quota_on(struct super_block *sb, int type, int format_id,
+							struct path *path)
+{
+	struct inode *inode;
+	int err;
+
+	err = f2fs_quota_sync(sb, type);
+	if (err)
+		return err;
+
+	err = dquot_quota_on(sb, type, format_id, path);
+	if (err)
+		return err;
+
+	inode = d_inode(path->dentry);
+
+	inode_lock(inode);
+	F2FS_I(inode)->i_flags |= F2FS_NOATIME_FL | F2FS_IMMUTABLE_FL;
+	inode_set_flags(inode, S_NOATIME | S_IMMUTABLE,
+					S_NOATIME | S_IMMUTABLE);
+	inode_unlock(inode);
+	f2fs_mark_inode_dirty_sync(inode, false);
 
 	return 0;
-restore_gc:
-	if (need_restart_gc) {
-		if (start_gc_thread(sbi))
-			f2fs_msg(sbi->sb, KERN_WARNING,
-				"background gc thread has stopped");
-	} else if (need_stop_gc) {
-		stop_gc_thread(sbi);
-	}
-restore_opts:
-	sbi->mount_opt = org_mount_opt;
-	sbi->active_logs = active_logs;
-#ifdef CONFIG_F2FS_FAULT_INJECTION
-	sbi->fault_info = ffi;
-#endif
+}
+
+static int f2fs_quota_off(struct super_block *sb, int type)
+{
+	struct inode *inode = sb_dqopt(sb)->files[type];
+	int err;
+
+	if (!inode || !igrab(inode))
+		return dquot_quota_off(sb, type);
+
+	f2fs_quota_sync(sb, type);
+
+	err = dquot_quota_off(sb, type);
+	if (err || f2fs_sb_has_quota_ino(sb))
+		goto out_put;
+
+	inode_lock(inode);
+	F2FS_I(inode)->i_flags &= ~(F2FS_NOATIME_FL | F2FS_IMMUTABLE_FL);
+	inode_set_flags(inode, 0, S_NOATIME | S_IMMUTABLE);
+	inode_unlock(inode);
+	f2fs_mark_inode_dirty_sync(inode, false);
+out_put:
+	iput(inode);
 	return err;
 }
 
-static struct super_operations f2fs_sops = {
+void f2fs_quota_off_umount(struct super_block *sb)
+{
+	int type;
+
+	for (type = 0; type < MAXQUOTAS; type++)
+		f2fs_quota_off(sb, type);
+}
+
+static int f2fs_get_projid(struct inode *inode, kprojid_t *projid)
+{
+	*projid = F2FS_I(inode)->i_projid;
+	return 0;
+}
+
+static const struct dquot_operations f2fs_quota_operations = {
+	.get_reserved_space = f2fs_get_reserved_space,
+	.write_dquot	= dquot_commit,
+	.acquire_dquot	= dquot_acquire,
+	.release_dquot	= dquot_release,
+	.mark_dirty	= dquot_mark_dquot_dirty,
+	.write_info	= dquot_commit_info,
+	.alloc_dquot	= dquot_alloc,
+	.destroy_dquot	= dquot_destroy,
+	.get_projid	= f2fs_get_projid,
+	.get_next_id	= dquot_get_next_id,
+};
+
+static const struct quotactl_ops f2fs_quotactl_ops = {
+	.quota_on	= f2fs_quota_on,
+	.quota_off	= f2fs_quota_off,
+	.quota_sync	= f2fs_quota_sync,
+	.get_state	= dquot_get_state,
+	.set_info	= dquot_set_dqinfo,
+	.get_dqblk	= dquot_get_dqblk,
+	.set_dqblk	= dquot_set_dqblk,
+	.get_nextdqblk	= dquot_get_next_dqblk,
+};
+#else
+void f2fs_quota_off_umount(struct super_block *sb)
+{
+}
+#endif
+
+static const struct super_operations f2fs_sops = {
 	.alloc_inode	= f2fs_alloc_inode,
 	.drop_inode	= f2fs_drop_inode,
 	.destroy_inode	= f2fs_destroy_inode,
 	.write_inode	= f2fs_write_inode,
 	.dirty_inode	= f2fs_dirty_inode,
 	.show_options	= f2fs_show_options,
+#ifdef CONFIG_QUOTA
+	.quota_read	= f2fs_quota_read,
+	.quota_write	= f2fs_quota_write,
+	.get_dquots	= f2fs_get_dquots,
+#endif
 	.evict_inode	= f2fs_evict_inode,
 	.put_super	= f2fs_put_super,
 	.sync_fs	= f2fs_sync_fs,
@@ -1120,37 +1908,38 @@ static int f2fs_get_context(struct inode *inode, void *ctx, size_t len)
 				ctx, len, NULL);
 }
 
-static int f2fs_key_prefix(struct inode *inode, u8 **key)
-{
-	*key = F2FS_I_SB(inode)->key_prefix;
-	return F2FS_I_SB(inode)->key_prefix_size;
-}
-
 static int f2fs_set_context(struct inode *inode, const void *ctx, size_t len,
 							void *fs_data)
 {
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+
+	/*
+	 * Encrypting the root directory is not allowed because fsck
+	 * expects lost+found directory to exist and remain unencrypted
+	 * if LOST_FOUND feature is enabled.
+	 *
+	 */
+	if (f2fs_sb_has_lost_found(sbi->sb) &&
+			inode->i_ino == F2FS_ROOT_INO(sbi))
+		return -EPERM;
+
 	return f2fs_setxattr(inode, F2FS_XATTR_INDEX_ENCRYPTION,
 				F2FS_XATTR_NAME_ENCRYPTION_CONTEXT,
 				ctx, len, fs_data, XATTR_CREATE);
 }
 
-static unsigned f2fs_max_namelen(struct inode *inode)
+static bool f2fs_dummy_context(struct inode *inode)
 {
-	return S_ISLNK(inode->i_mode) ?
-			inode->i_sb->s_blocksize : F2FS_NAME_LEN;
+	return DUMMY_ENCRYPTION_ENABLED(F2FS_I_SB(inode));
 }
 
-static struct fscrypt_operations f2fs_cryptops = {
+static const struct fscrypt_operations f2fs_cryptops = {
+	.key_prefix	= "f2fs:",
 	.get_context	= f2fs_get_context,
-	.key_prefix	= f2fs_key_prefix,
 	.set_context	= f2fs_set_context,
-	.is_encrypted	= f2fs_encrypted_inode,
+	.dummy_context	= f2fs_dummy_context,
 	.empty_dir	= f2fs_empty_dir,
-	.max_namelen	= f2fs_max_namelen,
-};
-#else
-static struct fscrypt_operations f2fs_cryptops = {
-	.is_encrypted	= f2fs_encrypted_inode,
+	.max_namelen	= F2FS_NAME_LEN,
 };
 #endif
 
@@ -1160,7 +1949,7 @@ static struct inode *f2fs_nfs_get_inode(struct super_block *sb,
 	struct f2fs_sb_info *sbi = F2FS_SB(sb);
 	struct inode *inode;
 
-	if (check_nid_range(sbi, ino))
+	if (f2fs_check_nid_range(sbi, ino))
 		return ERR_PTR(-ESTALE);
 
 	/*
@@ -1201,9 +1990,16 @@ static struct dentry *f2fs_fh_to_parent(struct super_block *sb, struct fid *fid,
 
 static loff_t max_file_blocks(void)
 {
-	loff_t result = (DEF_ADDRS_PER_INODE - F2FS_INLINE_XATTR_ADDRS);
+	loff_t result = 0;
 	loff_t leaf_count = ADDRS_PER_BLOCK;
 
+	/*
+	 * note: previously, result is equal to (DEF_ADDRS_PER_INODE -
+	 * DEFAULT_INLINE_XATTR_ADDRS), but now f2fs try to reserve more
+	 * space in inode.i_addr, it will be more safe to reassign
+	 * result as zero.
+	 */
+
 	/* two direct node blocks */
 	result += (leaf_count * 2);
 
@@ -1224,12 +2020,11 @@ static int __f2fs_commit_super(struct buffer_head *bh,
 	lock_buffer(bh);
 	if (super)
 		memcpy(bh->b_data + F2FS_SUPER_OFFSET, super, sizeof(*super));
-	set_buffer_uptodate(bh);
 	set_buffer_dirty(bh);
 	unlock_buffer(bh);
 
 	/* it's rare case, we can do fua all the time */
-	return __sync_dirty_buffer(bh, WRITE_FLUSH_FUA);
+	return __sync_dirty_buffer(bh, REQ_SYNC | REQ_PREFLUSH | REQ_FUA);
 }
 
 static inline bool sanity_check_area_boundary(struct f2fs_sb_info *sbi,
@@ -1337,6 +2132,8 @@ static inline bool sanity_check_area_boundary(struct f2fs_sb_info *sbi,
 static int sanity_check_raw_super(struct f2fs_sb_info *sbi,
 				struct buffer_head *bh)
 {
+	block_t segment_count, segs_per_sec, secs_per_zone;
+	block_t total_sections, blocks_per_seg;
 	struct f2fs_super_block *raw_super = (struct f2fs_super_block *)
 					(bh->b_data + F2FS_SUPER_OFFSET);
 	struct super_block *sb = sbi->sb;
@@ -1393,6 +2190,72 @@ static int sanity_check_raw_super(struct f2fs_sb_info *sbi,
 		return 1;
 	}
 
+	segment_count = le32_to_cpu(raw_super->segment_count);
+	segs_per_sec = le32_to_cpu(raw_super->segs_per_sec);
+	secs_per_zone = le32_to_cpu(raw_super->secs_per_zone);
+	total_sections = le32_to_cpu(raw_super->section_count);
+
+	/* blocks_per_seg should be 512, given the above check */
+	blocks_per_seg = 1 << le32_to_cpu(raw_super->log_blocks_per_seg);
+
+	if (segment_count > F2FS_MAX_SEGMENT ||
+				segment_count < F2FS_MIN_SEGMENTS) {
+		f2fs_msg(sb, KERN_INFO,
+			"Invalid segment count (%u)",
+			segment_count);
+		return 1;
+	}
+
+	if (total_sections > segment_count ||
+			total_sections < F2FS_MIN_SEGMENTS ||
+			segs_per_sec > segment_count || !segs_per_sec) {
+		f2fs_msg(sb, KERN_INFO,
+			"Invalid segment/section count (%u, %u x %u)",
+			segment_count, total_sections, segs_per_sec);
+		return 1;
+	}
+
+	if ((segment_count / segs_per_sec) < total_sections) {
+		f2fs_msg(sb, KERN_INFO,
+			"Small segment_count (%u < %u * %u)",
+			segment_count, segs_per_sec, total_sections);
+		return 1;
+	}
+
+	if (segment_count > (le32_to_cpu(raw_super->block_count) >> 9)) {
+		f2fs_msg(sb, KERN_INFO,
+			"Wrong segment_count / block_count (%u > %u)",
+			segment_count, le32_to_cpu(raw_super->block_count));
+		return 1;
+	}
+
+	if (secs_per_zone > total_sections) {
+		f2fs_msg(sb, KERN_INFO,
+			"Wrong secs_per_zone (%u > %u)",
+			secs_per_zone, total_sections);
+		return 1;
+	}
+	if (le32_to_cpu(raw_super->extension_count) > F2FS_MAX_EXTENSION ||
+			raw_super->hot_ext_count > F2FS_MAX_EXTENSION ||
+			(le32_to_cpu(raw_super->extension_count) +
+			raw_super->hot_ext_count) > F2FS_MAX_EXTENSION) {
+		f2fs_msg(sb, KERN_INFO,
+			"Corrupted extension count (%u + %u > %u)",
+			le32_to_cpu(raw_super->extension_count),
+			raw_super->hot_ext_count,
+			F2FS_MAX_EXTENSION);
+		return 1;
+	}
+
+	if (le32_to_cpu(raw_super->cp_payload) >
+				(blocks_per_seg - F2FS_CP_PACKS)) {
+		f2fs_msg(sb, KERN_INFO,
+			"Insane cp_payload (%u > %u)",
+			le32_to_cpu(raw_super->cp_payload),
+			blocks_per_seg - F2FS_CP_PACKS);
+		return 1;
+	}
+
 	/* check reserved ino info */
 	if (le32_to_cpu(raw_super->node_ino) != 1 ||
 		le32_to_cpu(raw_super->meta_ino) != 2 ||
@@ -1405,13 +2268,6 @@ static int sanity_check_raw_super(struct f2fs_sb_info *sbi,
 		return 1;
 	}
 
-	if (le32_to_cpu(raw_super->segment_count) > F2FS_MAX_SEGMENT) {
-		f2fs_msg(sb, KERN_INFO,
-			"Invalid segment count (%u)",
-			le32_to_cpu(raw_super->segment_count));
-		return 1;
-	}
-
 	/* check CP/SIT/NAT/SSA/MAIN_AREA area boundary */
 	if (sanity_check_area_boundary(sbi, bh))
 		return 1;
@@ -1419,11 +2275,12 @@ static int sanity_check_raw_super(struct f2fs_sb_info *sbi,
 	return 0;
 }
 
-int sanity_check_ckpt(struct f2fs_sb_info *sbi)
+int f2fs_sanity_check_ckpt(struct f2fs_sb_info *sbi)
 {
 	unsigned int total, fsmeta;
 	struct f2fs_super_block *raw_super = F2FS_RAW_SUPER(sbi);
 	struct f2fs_checkpoint *ckpt = F2FS_CKPT(sbi);
+	unsigned int ovp_segments, reserved_segments;
 	unsigned int main_segs, blocks_per_seg;
 	int i;
 
@@ -1437,6 +2294,16 @@ int sanity_check_ckpt(struct f2fs_sb_info *sbi)
 	if (unlikely(fsmeta >= total))
 		return 1;
 
+	ovp_segments = le32_to_cpu(ckpt->overprov_segment_count);
+	reserved_segments = le32_to_cpu(ckpt->rsvd_segment_count);
+
+	if (unlikely(fsmeta < F2FS_MIN_SEGMENTS ||
+			ovp_segments == 0 || reserved_segments == 0)) {
+		f2fs_msg(sbi->sb, KERN_ERR,
+			"Wrong layout: check mkfs.f2fs version");
+		return 1;
+	}
+
 	main_segs = le32_to_cpu(raw_super->segment_count_main);
 	blocks_per_seg = sbi->blocks_per_seg;
 
@@ -1461,7 +2328,7 @@ int sanity_check_ckpt(struct f2fs_sb_info *sbi)
 static void init_sb_info(struct f2fs_sb_info *sbi)
 {
 	struct f2fs_super_block *raw_super = sbi->raw_super;
-	int i;
+	int i, j;
 
 	sbi->log_sectors_per_block =
 		le32_to_cpu(raw_super->log_sectors_per_block);
@@ -1489,17 +2356,21 @@ static void init_sb_info(struct f2fs_sb_info *sbi)
 	for (i = 0; i < NR_COUNT_TYPE; i++)
 		atomic_set(&sbi->nr_pages[i], 0);
 
+	for (i = 0; i < META; i++)
+		atomic_set(&sbi->wb_sync_req[i], 0);
+
 	INIT_LIST_HEAD(&sbi->s_list);
 	mutex_init(&sbi->umount_mutex);
-	mutex_init(&sbi->wio_mutex[NODE]);
-	mutex_init(&sbi->wio_mutex[DATA]);
+	for (i = 0; i < NR_PAGE_TYPE - 1; i++)
+		for (j = HOT; j < NR_TEMP_TYPE; j++)
+			mutex_init(&sbi->wio_mutex[i][j]);
+	init_rwsem(&sbi->io_order_lock);
 	spin_lock_init(&sbi->cp_lock);
 
-#ifdef CONFIG_F2FS_FS_ENCRYPTION
-	memcpy(sbi->key_prefix, F2FS_KEY_DESC_PREFIX,
-				F2FS_KEY_DESC_PREFIX_SIZE);
-	sbi->key_prefix_size = F2FS_KEY_DESC_PREFIX_SIZE;
-#endif
+	sbi->dirty_device = 0;
+	spin_lock_init(&sbi->dev_lock);
+
+	init_rwsem(&sbi->sb_lock);
 }
 
 static int init_percpu_info(struct f2fs_sb_info *sbi)
@@ -1514,6 +2385,74 @@ static int init_percpu_info(struct f2fs_sb_info *sbi)
 								GFP_KERNEL);
 }
 
+#ifdef CONFIG_BLK_DEV_ZONED
+static int init_blkz_info(struct f2fs_sb_info *sbi, int devi)
+{
+	struct block_device *bdev = FDEV(devi).bdev;
+	sector_t nr_sectors = bdev->bd_part->nr_sects;
+	sector_t sector = 0;
+	struct blk_zone *zones;
+	unsigned int i, nr_zones;
+	unsigned int n = 0;
+	int err = -EIO;
+
+	if (!f2fs_sb_has_blkzoned(sbi->sb))
+		return 0;
+
+	if (sbi->blocks_per_blkz && sbi->blocks_per_blkz !=
+				SECTOR_TO_BLOCK(bdev_zone_sectors(bdev)))
+		return -EINVAL;
+	sbi->blocks_per_blkz = SECTOR_TO_BLOCK(bdev_zone_sectors(bdev));
+	if (sbi->log_blocks_per_blkz && sbi->log_blocks_per_blkz !=
+				__ilog2_u32(sbi->blocks_per_blkz))
+		return -EINVAL;
+	sbi->log_blocks_per_blkz = __ilog2_u32(sbi->blocks_per_blkz);
+	FDEV(devi).nr_blkz = SECTOR_TO_BLOCK(nr_sectors) >>
+					sbi->log_blocks_per_blkz;
+	if (nr_sectors & (bdev_zone_sectors(bdev) - 1))
+		FDEV(devi).nr_blkz++;
+
+	FDEV(devi).blkz_type = f2fs_kmalloc(sbi, FDEV(devi).nr_blkz,
+								GFP_KERNEL);
+	if (!FDEV(devi).blkz_type)
+		return -ENOMEM;
+
+#define F2FS_REPORT_NR_ZONES   4096
+
+	zones = f2fs_kzalloc(sbi,
+			     array_size(F2FS_REPORT_NR_ZONES,
+					sizeof(struct blk_zone)),
+			     GFP_KERNEL);
+	if (!zones)
+		return -ENOMEM;
+
+	/* Get block zones type */
+	while (zones && sector < nr_sectors) {
+
+		nr_zones = F2FS_REPORT_NR_ZONES;
+		err = blkdev_report_zones(bdev, sector,
+					  zones, &nr_zones,
+					  GFP_KERNEL);
+		if (err)
+			break;
+		if (!nr_zones) {
+			err = -EIO;
+			break;
+		}
+
+		for (i = 0; i < nr_zones; i++) {
+			FDEV(devi).blkz_type[n] = zones[i].type;
+			sector += zones[i].len;
+			n++;
+		}
+	}
+
+	kfree(zones);
+
+	return err;
+}
+#endif
+
 /*
  * Read f2fs raw super block.
  * Because we have two copies of super block, so read both of them
@@ -1587,7 +2526,7 @@ int f2fs_commit_super(struct f2fs_sb_info *sbi, bool recover)
 	}
 
 	/* write back-up superblock first */
-	bh = sb_getblk(sbi->sb, sbi->valid_super_block ? 0: 1);
+	bh = sb_bread(sbi->sb, sbi->valid_super_block ? 0 : 1);
 	if (!bh)
 		return -EIO;
 	err = __f2fs_commit_super(bh, F2FS_RAW_SUPER(sbi));
@@ -1598,7 +2537,7 @@ int f2fs_commit_super(struct f2fs_sb_info *sbi, bool recover)
 		return err;
 
 	/* write current valid superblock */
-	bh = sb_getblk(sbi->sb, sbi->valid_super_block);
+	bh = sb_bread(sbi->sb, sbi->valid_super_block);
 	if (!bh)
 		return -EIO;
 	err = __f2fs_commit_super(bh, F2FS_RAW_SUPER(sbi));
@@ -1606,6 +2545,118 @@ int f2fs_commit_super(struct f2fs_sb_info *sbi, bool recover)
 	return err;
 }
 
+static int f2fs_scan_devices(struct f2fs_sb_info *sbi)
+{
+	struct f2fs_super_block *raw_super = F2FS_RAW_SUPER(sbi);
+	unsigned int max_devices = MAX_DEVICES;
+	int i;
+
+	/* Initialize single device information */
+	if (!RDEV(0).path[0]) {
+#ifdef CONFIG_BLK_DEV_ZONED
+		if (!bdev_is_zoned(sbi->sb->s_bdev))
+			return 0;
+		max_devices = 1;
+#else
+		return 0;
+#endif
+	}
+
+	/*
+	 * Initialize multiple devices information, or single
+	 * zoned block device information.
+	 */
+	sbi->devs = f2fs_kzalloc(sbi,
+				 array_size(max_devices,
+					    sizeof(struct f2fs_dev_info)),
+				 GFP_KERNEL);
+	if (!sbi->devs)
+		return -ENOMEM;
+
+	for (i = 0; i < max_devices; i++) {
+
+		if (i > 0 && !RDEV(i).path[0])
+			break;
+
+		if (max_devices == 1) {
+			/* Single zoned block device mount */
+			FDEV(0).bdev =
+				blkdev_get_by_dev(sbi->sb->s_bdev->bd_dev,
+					sbi->sb->s_mode, sbi->sb->s_type);
+		} else {
+			/* Multi-device mount */
+			memcpy(FDEV(i).path, RDEV(i).path, MAX_PATH_LEN);
+			FDEV(i).total_segments =
+				le32_to_cpu(RDEV(i).total_segments);
+			if (i == 0) {
+				FDEV(i).start_blk = 0;
+				FDEV(i).end_blk = FDEV(i).start_blk +
+				    (FDEV(i).total_segments <<
+				    sbi->log_blocks_per_seg) - 1 +
+				    le32_to_cpu(raw_super->segment0_blkaddr);
+			} else {
+				FDEV(i).start_blk = FDEV(i - 1).end_blk + 1;
+				FDEV(i).end_blk = FDEV(i).start_blk +
+					(FDEV(i).total_segments <<
+					sbi->log_blocks_per_seg) - 1;
+			}
+			FDEV(i).bdev = blkdev_get_by_path(FDEV(i).path,
+					sbi->sb->s_mode, sbi->sb->s_type);
+		}
+		if (IS_ERR(FDEV(i).bdev))
+			return PTR_ERR(FDEV(i).bdev);
+
+		/* to release errored devices */
+		sbi->s_ndevs = i + 1;
+
+#ifdef CONFIG_BLK_DEV_ZONED
+		if (bdev_zoned_model(FDEV(i).bdev) == BLK_ZONED_HM &&
+				!f2fs_sb_has_blkzoned(sbi->sb)) {
+			f2fs_msg(sbi->sb, KERN_ERR,
+				"Zoned block device feature not enabled\n");
+			return -EINVAL;
+		}
+		if (bdev_zoned_model(FDEV(i).bdev) != BLK_ZONED_NONE) {
+			if (init_blkz_info(sbi, i)) {
+				f2fs_msg(sbi->sb, KERN_ERR,
+					"Failed to initialize F2FS blkzone information");
+				return -EINVAL;
+			}
+			if (max_devices == 1)
+				break;
+			f2fs_msg(sbi->sb, KERN_INFO,
+				"Mount Device [%2d]: %20s, %8u, %8x - %8x (zone: %s)",
+				i, FDEV(i).path,
+				FDEV(i).total_segments,
+				FDEV(i).start_blk, FDEV(i).end_blk,
+				bdev_zoned_model(FDEV(i).bdev) == BLK_ZONED_HA ?
+				"Host-aware" : "Host-managed");
+			continue;
+		}
+#endif
+		f2fs_msg(sbi->sb, KERN_INFO,
+			"Mount Device [%2d]: %20s, %8u, %8x - %8x",
+				i, FDEV(i).path,
+				FDEV(i).total_segments,
+				FDEV(i).start_blk, FDEV(i).end_blk);
+	}
+	f2fs_msg(sbi->sb, KERN_INFO,
+			"IO Block Size: %8d KB", F2FS_IO_SIZE_KB(sbi));
+	return 0;
+}
+
+static void f2fs_tuning_parameters(struct f2fs_sb_info *sbi)
+{
+	struct f2fs_sm_info *sm_i = SM_I(sbi);
+
+	/* adjust parameters according to the volume size */
+	if (sm_i->main_segments <= SMALL_VOLUME_SEGMENTS) {
+		F2FS_OPTION(sbi).alloc_mode = ALLOC_MODE_REUSE;
+		sm_i->dcc_info->discard_granularity = 1;
+		sm_i->ipu_policy = 1 << F2FS_IPU_FORCE;
+	}
+}
+
 static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 {
 	struct f2fs_sb_info *sbi;
@@ -1653,6 +2704,27 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 	sb->s_fs_info = sbi;
 	sbi->raw_super = raw_super;
 
+	F2FS_OPTION(sbi).s_resuid = make_kuid(&init_user_ns, F2FS_DEF_RESUID);
+	F2FS_OPTION(sbi).s_resgid = make_kgid(&init_user_ns, F2FS_DEF_RESGID);
+
+	/* precompute checksum seed for metadata */
+	if (f2fs_sb_has_inode_chksum(sb))
+		sbi->s_chksum_seed = f2fs_chksum(sbi, ~0, raw_super->uuid,
+						sizeof(raw_super->uuid));
+
+	/*
+	 * The BLKZONED feature indicates that the drive was formatted with
+	 * zone alignment optimization. This is optional for host-aware
+	 * devices, but mandatory for host-managed zoned block devices.
+	 */
+#ifndef CONFIG_BLK_DEV_ZONED
+	if (f2fs_sb_has_blkzoned(sb)) {
+		f2fs_msg(sb, KERN_ERR,
+			 "Zoned block device support is not enabled\n");
+		err = -EOPNOTSUPP;
+		goto free_sb_buf;
+	}
+#endif
 	default_options(sbi);
 	/* parse mount options */
 	options = kstrdup((const char *)data, GFP_KERNEL);
@@ -1671,33 +2743,71 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 	sb->s_max_links = F2FS_LINK_MAX;
 	get_random_bytes(&sbi->s_next_generation, sizeof(u32));
 
+#ifdef CONFIG_QUOTA
+	sb->dq_op = &f2fs_quota_operations;
+	if (f2fs_sb_has_quota_ino(sb))
+		sb->s_qcop = &dquot_quotactl_sysfile_ops;
+	else
+		sb->s_qcop = &f2fs_quotactl_ops;
+	sb->s_quota_types = QTYPE_MASK_USR | QTYPE_MASK_GRP | QTYPE_MASK_PRJ;
+
+	if (f2fs_sb_has_quota_ino(sbi->sb)) {
+		for (i = 0; i < MAXQUOTAS; i++) {
+			if (f2fs_qf_ino(sbi->sb, i))
+				sbi->nquota_files++;
+		}
+	}
+#endif
+
 	sb->s_op = &f2fs_sops;
+#ifdef CONFIG_F2FS_FS_ENCRYPTION
 	sb->s_cop = &f2fs_cryptops;
+#endif
 	sb->s_xattr = f2fs_xattr_handlers;
 	sb->s_export_op = &f2fs_export_ops;
 	sb->s_magic = F2FS_SUPER_MAGIC;
 	sb->s_time_gran = 1;
 	sb->s_flags = (sb->s_flags & ~MS_POSIXACL) |
 		(test_opt(sbi, POSIX_ACL) ? MS_POSIXACL : 0);
-	memcpy(sb->s_uuid, raw_super->uuid, sizeof(raw_super->uuid));
+	memcpy(&sb->s_uuid, raw_super->uuid, sizeof(raw_super->uuid));
+	sb->s_iflags |= SB_I_CGROUPWB;
 
 	/* init f2fs-specific super block info */
 	sbi->valid_super_block = valid_super_block;
 	mutex_init(&sbi->gc_mutex);
 	mutex_init(&sbi->cp_mutex);
 	init_rwsem(&sbi->node_write);
+	init_rwsem(&sbi->node_change);
 
 	/* disallow all the data/node/meta page writes */
 	set_sbi_flag(sbi, SBI_POR_DOING);
 	spin_lock_init(&sbi->stat_lock);
 
-	init_rwsem(&sbi->read_io.io_rwsem);
-	sbi->read_io.sbi = sbi;
-	sbi->read_io.bio = NULL;
+	/* init iostat info */
+	spin_lock_init(&sbi->iostat_lock);
+	sbi->iostat_enable = false;
+
 	for (i = 0; i < NR_PAGE_TYPE; i++) {
-		init_rwsem(&sbi->write_io[i].io_rwsem);
-		sbi->write_io[i].sbi = sbi;
-		sbi->write_io[i].bio = NULL;
+		int n = (i == META) ? 1: NR_TEMP_TYPE;
+		int j;
+
+		sbi->write_io[i] =
+			f2fs_kmalloc(sbi,
+				     array_size(n,
+						sizeof(struct f2fs_bio_info)),
+				     GFP_KERNEL);
+		if (!sbi->write_io[i]) {
+			err = -ENOMEM;
+			goto free_options;
+		}
+
+		for (j = HOT; j < n; j++) {
+			init_rwsem(&sbi->write_io[i][j].io_rwsem);
+			sbi->write_io[i][j].sbi = sbi;
+			sbi->write_io[i][j].bio = NULL;
+			spin_lock_init(&sbi->write_io[i][j].io_lock);
+			INIT_LIST_HEAD(&sbi->write_io[i][j].io_list);
+		}
 	}
 
 	init_rwsem(&sbi->cp_rwsem);
@@ -1706,22 +2816,38 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 
 	err = init_percpu_info(sbi);
 	if (err)
-		goto free_options;
+		goto free_bio_info;
+
+	if (F2FS_IO_SIZE(sbi) > 1) {
+		sbi->write_io_dummy =
+			mempool_create_page_pool(2 * (F2FS_IO_SIZE(sbi) - 1), 0);
+		if (!sbi->write_io_dummy) {
+			err = -ENOMEM;
+			goto free_percpu;
+		}
+	}
 
 	/* get an inode for meta space */
 	sbi->meta_inode = f2fs_iget(sb, F2FS_META_INO(sbi));
 	if (IS_ERR(sbi->meta_inode)) {
 		f2fs_msg(sb, KERN_ERR, "Failed to read F2FS meta data inode");
 		err = PTR_ERR(sbi->meta_inode);
-		goto free_options;
+		goto free_io_dummy;
 	}
 
-	err = get_valid_checkpoint(sbi);
+	err = f2fs_get_valid_checkpoint(sbi);
 	if (err) {
 		f2fs_msg(sb, KERN_ERR, "Failed to get valid F2FS checkpoint");
 		goto free_meta_inode;
 	}
 
+	/* Initialize device list */
+	err = f2fs_scan_devices(sbi);
+	if (err) {
+		f2fs_msg(sb, KERN_ERR, "Failed to find devices");
+		goto free_devices;
+	}
+
 	sbi->total_valid_node_count =
 				le32_to_cpu(sbi->ckpt->valid_node_count);
 	percpu_counter_set(&sbi->total_valid_inode_count,
@@ -1730,24 +2856,27 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 	sbi->total_valid_block_count =
 				le64_to_cpu(sbi->ckpt->valid_block_count);
 	sbi->last_valid_block_count = sbi->total_valid_block_count;
+	sbi->reserved_blocks = 0;
+	sbi->current_reserved_blocks = 0;
+	limit_reserve_root(sbi);
 
 	for (i = 0; i < NR_INODE_TYPE; i++) {
 		INIT_LIST_HEAD(&sbi->inode_list[i]);
 		spin_lock_init(&sbi->inode_lock[i]);
 	}
 
-	init_extent_cache_info(sbi);
+	f2fs_init_extent_cache_info(sbi);
 
-	init_ino_entry_info(sbi);
+	f2fs_init_ino_entry_info(sbi);
 
 	/* setup f2fs internal modules */
-	err = build_segment_manager(sbi);
+	err = f2fs_build_segment_manager(sbi);
 	if (err) {
 		f2fs_msg(sb, KERN_ERR,
 			"Failed to initialize F2FS segment manager");
 		goto free_sm;
 	}
-	err = build_node_manager(sbi);
+	err = f2fs_build_node_manager(sbi);
 	if (err) {
 		f2fs_msg(sb, KERN_ERR,
 			"Failed to initialize F2FS node manager");
@@ -1765,7 +2894,7 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 		sbi->kbytes_written =
 			le64_to_cpu(seg_i->journal->info.kbytes_written);
 
-	build_gc_manager(sbi);
+	f2fs_build_gc_manager(sbi);
 
 	/* get an inode for node space */
 	sbi->node_inode = f2fs_iget(sb, F2FS_NODE_INO(sbi));
@@ -1775,10 +2904,7 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 		goto free_nm;
 	}
 
-	f2fs_join_shrinker(sbi);
-
-	/* if there are nt orphan nodes free them */
-	err = recover_orphan_inodes(sbi);
+	err = f2fs_build_stats(sbi);
 	if (err)
 		goto free_node_inode;
 
@@ -1787,7 +2913,7 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 	if (IS_ERR(root)) {
 		f2fs_msg(sb, KERN_ERR, "Failed to read root inode");
 		err = PTR_ERR(root);
-		goto free_node_inode;
+		goto free_stats;
 	}
 	if (!S_ISDIR(root->i_mode) || !root->i_blocks || !root->i_size) {
 		iput(root);
@@ -1801,26 +2927,28 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 		goto free_root_inode;
 	}
 
-	err = f2fs_build_stats(sbi);
+	err = f2fs_register_sysfs(sbi);
 	if (err)
 		goto free_root_inode;
 
-	if (f2fs_proc_root)
-		sbi->s_proc = proc_mkdir(sb->s_id, f2fs_proc_root);
-
-	if (sbi->s_proc) {
-		proc_create_data("segment_info", S_IRUGO, sbi->s_proc,
-				 &f2fs_seq_segment_info_fops, sb);
-		proc_create_data("segment_bits", S_IRUGO, sbi->s_proc,
-				 &f2fs_seq_segment_bits_fops, sb);
+#ifdef CONFIG_QUOTA
+	/*
+	 * Turn on quotas which were not enabled for read-only mounts if
+	 * filesystem has quota feature, so that they are updated correctly.
+	 */
+	if (f2fs_sb_has_quota_ino(sb) && !f2fs_readonly(sb)) {
+		err = f2fs_enable_quotas(sb);
+		if (err) {
+			f2fs_msg(sb, KERN_ERR,
+				"Cannot turn on quotas: error %d", err);
+			goto free_sysfs;
+		}
 	}
-
-	sbi->s_kobj.kset = f2fs_kset;
-	init_completion(&sbi->s_kobj_unregister);
-	err = kobject_init_and_add(&sbi->s_kobj, &f2fs_ktype, NULL,
-							"%s", sb->s_id);
+#endif
+	/* if there are nt orphan nodes free them */
+	err = f2fs_recover_orphan_inodes(sbi);
 	if (err)
-		goto free_proc;
+		goto free_meta;
 
 	/* recover fsynced data */
 	if (!test_opt(sbi, DISABLE_ROLL_FORWARD)) {
@@ -1831,7 +2959,7 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 		if (bdev_read_only(sb->s_bdev) &&
 				!is_set_ckpt_flags(sbi, CP_UMOUNT_FLAG)) {
 			err = -EROFS;
-			goto free_kobj;
+			goto free_meta;
 		}
 
 		if (need_fsck)
@@ -1840,25 +2968,25 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 		if (!retry)
 			goto skip_recovery;
 
-		err = recover_fsync_data(sbi, false);
+		err = f2fs_recover_fsync_data(sbi, false);
 		if (err < 0) {
 			need_fsck = true;
 			f2fs_msg(sb, KERN_ERR,
 				"Cannot recover all fsync data errno=%d", err);
-			goto free_kobj;
+			goto free_meta;
 		}
 	} else {
-		err = recover_fsync_data(sbi, true);
+		err = f2fs_recover_fsync_data(sbi, true);
 
 		if (!f2fs_readonly(sb) && err > 0) {
 			err = -EINVAL;
 			f2fs_msg(sb, KERN_ERR,
 				"Need to recover fsync data");
-			goto free_kobj;
+			goto free_meta;
 		}
 	}
 skip_recovery:
-	/* recover_fsync_data() cleared this already */
+	/* f2fs_recover_fsync_data() cleared this already */
 	clear_sbi_flag(sbi, SBI_POR_DOING);
 
 	/*
@@ -1867,9 +2995,9 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 	 */
 	if (test_opt(sbi, BG_GC) && !f2fs_readonly(sb)) {
 		/* After POR, we can run background GC thread.*/
-		err = start_gc_thread(sbi);
+		err = f2fs_start_gc_thread(sbi);
 		if (err)
-			goto free_kobj;
+			goto free_meta;
 	}
 	kfree(options);
 
@@ -1881,42 +3009,64 @@ static int f2fs_fill_super(struct super_block *sb, void *data, int silent)
 			sbi->valid_super_block ? 1 : 2, err);
 	}
 
+	f2fs_join_shrinker(sbi);
+
+	f2fs_tuning_parameters(sbi);
+
+	f2fs_msg(sbi->sb, KERN_NOTICE, "Mounted with checkpoint version = %llx",
+				cur_cp_version(F2FS_CKPT(sbi)));
 	f2fs_update_time(sbi, CP_TIME);
 	f2fs_update_time(sbi, REQ_TIME);
 	return 0;
 
-free_kobj:
+free_meta:
+#ifdef CONFIG_QUOTA
+	if (f2fs_sb_has_quota_ino(sb) && !f2fs_readonly(sb))
+		f2fs_quota_off_umount(sbi->sb);
+#endif
 	f2fs_sync_inode_meta(sbi);
-	kobject_del(&sbi->s_kobj);
-	kobject_put(&sbi->s_kobj);
-	wait_for_completion(&sbi->s_kobj_unregister);
-free_proc:
-	if (sbi->s_proc) {
-		remove_proc_entry("segment_info", sbi->s_proc);
-		remove_proc_entry("segment_bits", sbi->s_proc);
-		remove_proc_entry(sb->s_id, f2fs_proc_root);
-	}
-	f2fs_destroy_stats(sbi);
+	/*
+	 * Some dirty meta pages can be produced by f2fs_recover_orphan_inodes()
+	 * failed by EIO. Then, iput(node_inode) can trigger balance_fs_bg()
+	 * followed by f2fs_write_checkpoint() through f2fs_write_node_pages(), which
+	 * falls into an infinite loop in f2fs_sync_meta_pages().
+	 */
+	truncate_inode_pages_final(META_MAPPING(sbi));
+#ifdef CONFIG_QUOTA
+free_sysfs:
+#endif
+	f2fs_unregister_sysfs(sbi);
 free_root_inode:
 	dput(sb->s_root);
 	sb->s_root = NULL;
+free_stats:
+	f2fs_destroy_stats(sbi);
 free_node_inode:
+	f2fs_release_ino_entry(sbi, true);
 	truncate_inode_pages_final(NODE_MAPPING(sbi));
-	mutex_lock(&sbi->umount_mutex);
-	release_ino_entry(sbi, true);
-	f2fs_leave_shrinker(sbi);
 	iput(sbi->node_inode);
-	mutex_unlock(&sbi->umount_mutex);
 free_nm:
-	destroy_node_manager(sbi);
+	f2fs_destroy_node_manager(sbi);
 free_sm:
-	destroy_segment_manager(sbi);
+	f2fs_destroy_segment_manager(sbi);
+free_devices:
+	destroy_device_list(sbi);
 	kfree(sbi->ckpt);
 free_meta_inode:
 	make_bad_inode(sbi->meta_inode);
 	iput(sbi->meta_inode);
-free_options:
+free_io_dummy:
+	mempool_destroy(sbi->write_io_dummy);
+free_percpu:
 	destroy_percpu_info(sbi);
+free_bio_info:
+	for (i = 0; i < NR_PAGE_TYPE; i++)
+		kfree(sbi->write_io[i]);
+free_options:
+#ifdef CONFIG_QUOTA
+	for (i = 0; i < MAXQUOTAS; i++)
+		kfree(F2FS_OPTION(sbi).s_qf_names[i]);
+#endif
 	kfree(options);
 free_sb_buf:
 	kfree(raw_super);
@@ -1942,8 +3092,11 @@ static struct dentry *f2fs_mount(struct file_system_type *fs_type, int flags,
 
 static void kill_f2fs_super(struct super_block *sb)
 {
-	if (sb->s_root)
+	if (sb->s_root) {
 		set_sbi_flag(F2FS_SB(sb), SBI_IS_CLOSE);
+		f2fs_stop_gc_thread(F2FS_SB(sb));
+		f2fs_stop_discard_thread(F2FS_SB(sb));
+	}
 	kill_block_super(sb);
 }
 
@@ -1991,50 +3144,51 @@ static int __init init_f2fs_fs(void)
 	err = init_inodecache();
 	if (err)
 		goto fail;
-	err = create_node_manager_caches();
+	err = f2fs_create_node_manager_caches();
 	if (err)
 		goto free_inodecache;
-	err = create_segment_manager_caches();
+	err = f2fs_create_segment_manager_caches();
 	if (err)
 		goto free_node_manager_caches;
-	err = create_checkpoint_caches();
+	err = f2fs_create_checkpoint_caches();
 	if (err)
 		goto free_segment_manager_caches;
-	err = create_extent_cache();
+	err = f2fs_create_extent_cache();
 	if (err)
 		goto free_checkpoint_caches;
-	f2fs_kset = kset_create_and_add("f2fs", NULL, fs_kobj);
-	if (!f2fs_kset) {
-		err = -ENOMEM;
+	err = f2fs_init_sysfs();
+	if (err)
 		goto free_extent_cache;
-	}
 	err = register_shrinker(&f2fs_shrinker_info);
 	if (err)
-		goto free_kset;
-
+		goto free_sysfs;
 	err = register_filesystem(&f2fs_fs_type);
 	if (err)
 		goto free_shrinker;
 	err = f2fs_create_root_stats();
 	if (err)
 		goto free_filesystem;
-	f2fs_proc_root = proc_mkdir("fs/f2fs", NULL);
+	err = f2fs_init_post_read_processing();
+	if (err)
+		goto free_root_stats;
 	return 0;
 
+free_root_stats:
+	f2fs_destroy_root_stats();
 free_filesystem:
 	unregister_filesystem(&f2fs_fs_type);
 free_shrinker:
 	unregister_shrinker(&f2fs_shrinker_info);
-free_kset:
-	kset_unregister(f2fs_kset);
+free_sysfs:
+	f2fs_exit_sysfs();
 free_extent_cache:
-	destroy_extent_cache();
+	f2fs_destroy_extent_cache();
 free_checkpoint_caches:
-	destroy_checkpoint_caches();
+	f2fs_destroy_checkpoint_caches();
 free_segment_manager_caches:
-	destroy_segment_manager_caches();
+	f2fs_destroy_segment_manager_caches();
 free_node_manager_caches:
-	destroy_node_manager_caches();
+	f2fs_destroy_node_manager_caches();
 free_inodecache:
 	destroy_inodecache();
 fail:
@@ -2043,15 +3197,15 @@ static int __init init_f2fs_fs(void)
 
 static void __exit exit_f2fs_fs(void)
 {
-	remove_proc_entry("fs/f2fs", NULL);
+	f2fs_destroy_post_read_processing();
 	f2fs_destroy_root_stats();
 	unregister_filesystem(&f2fs_fs_type);
 	unregister_shrinker(&f2fs_shrinker_info);
-	kset_unregister(f2fs_kset);
-	destroy_extent_cache();
-	destroy_checkpoint_caches();
-	destroy_segment_manager_caches();
-	destroy_node_manager_caches();
+	f2fs_exit_sysfs();
+	f2fs_destroy_extent_cache();
+	f2fs_destroy_checkpoint_caches();
+	f2fs_destroy_segment_manager_caches();
+	f2fs_destroy_node_manager_caches();
 	destroy_inodecache();
 	f2fs_destroy_trace_ios();
 }
@@ -2062,3 +3216,4 @@ static void __exit exit_f2fs_fs(void)
 MODULE_AUTHOR("Samsung Electronics's Praesto Team");
 MODULE_DESCRIPTION("Flash Friendly File System");
 MODULE_LICENSE("GPL");
+
diff --git a/fs/f2fs/sysfs.c b/fs/f2fs/sysfs.c
new file mode 100644
index 00000000..60c827e
--- /dev/null
+++ b/fs/f2fs/sysfs.c
@@ -0,0 +1,691 @@
+/*
+ * f2fs sysfs interface
+ *
+ * Copyright (c) 2012 Samsung Electronics Co., Ltd.
+ *             http://www.samsung.com/
+ * Copyright (c) 2017 Chao Yu <chao@kernel.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#include <linux/proc_fs.h>
+#include <linux/f2fs_fs.h>
+#include <linux/seq_file.h>
+
+#include "f2fs.h"
+#include "segment.h"
+#include "gc.h"
+
+static struct proc_dir_entry *f2fs_proc_root;
+
+/* Sysfs support for f2fs */
+enum {
+	GC_THREAD,	/* struct f2fs_gc_thread */
+	SM_INFO,	/* struct f2fs_sm_info */
+	DCC_INFO,	/* struct discard_cmd_control */
+	NM_INFO,	/* struct f2fs_nm_info */
+	F2FS_SBI,	/* struct f2fs_sb_info */
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	FAULT_INFO_RATE,	/* struct f2fs_fault_info */
+	FAULT_INFO_TYPE,	/* struct f2fs_fault_info */
+#endif
+	RESERVED_BLOCKS,	/* struct f2fs_sb_info */
+};
+
+struct f2fs_attr {
+	struct attribute attr;
+	ssize_t (*show)(struct f2fs_attr *, struct f2fs_sb_info *, char *);
+	ssize_t (*store)(struct f2fs_attr *, struct f2fs_sb_info *,
+			 const char *, size_t);
+	int struct_type;
+	int offset;
+	int id;
+};
+
+static unsigned char *__struct_ptr(struct f2fs_sb_info *sbi, int struct_type)
+{
+	if (struct_type == GC_THREAD)
+		return (unsigned char *)sbi->gc_thread;
+	else if (struct_type == SM_INFO)
+		return (unsigned char *)SM_I(sbi);
+	else if (struct_type == DCC_INFO)
+		return (unsigned char *)SM_I(sbi)->dcc_info;
+	else if (struct_type == NM_INFO)
+		return (unsigned char *)NM_I(sbi);
+	else if (struct_type == F2FS_SBI || struct_type == RESERVED_BLOCKS)
+		return (unsigned char *)sbi;
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	else if (struct_type == FAULT_INFO_RATE ||
+					struct_type == FAULT_INFO_TYPE)
+		return (unsigned char *)&F2FS_OPTION(sbi).fault_info;
+#endif
+	return NULL;
+}
+
+static ssize_t dirty_segments_show(struct f2fs_attr *a,
+		struct f2fs_sb_info *sbi, char *buf)
+{
+	return snprintf(buf, PAGE_SIZE, "%llu\n",
+		(unsigned long long)(dirty_segments(sbi)));
+}
+
+static ssize_t lifetime_write_kbytes_show(struct f2fs_attr *a,
+		struct f2fs_sb_info *sbi, char *buf)
+{
+	struct super_block *sb = sbi->sb;
+
+	if (!sb->s_bdev->bd_part)
+		return snprintf(buf, PAGE_SIZE, "0\n");
+
+	return snprintf(buf, PAGE_SIZE, "%llu\n",
+		(unsigned long long)(sbi->kbytes_written +
+			BD_PART_WRITTEN(sbi)));
+}
+
+static ssize_t features_show(struct f2fs_attr *a,
+		struct f2fs_sb_info *sbi, char *buf)
+{
+	struct super_block *sb = sbi->sb;
+	int len = 0;
+
+	if (!sb->s_bdev->bd_part)
+		return snprintf(buf, PAGE_SIZE, "0\n");
+
+	if (f2fs_sb_has_encrypt(sb))
+		len += snprintf(buf, PAGE_SIZE - len, "%s",
+						"encryption");
+	if (f2fs_sb_has_blkzoned(sb))
+		len += snprintf(buf + len, PAGE_SIZE - len, "%s%s",
+				len ? ", " : "", "blkzoned");
+	if (f2fs_sb_has_extra_attr(sb))
+		len += snprintf(buf + len, PAGE_SIZE - len, "%s%s",
+				len ? ", " : "", "extra_attr");
+	if (f2fs_sb_has_project_quota(sb))
+		len += snprintf(buf + len, PAGE_SIZE - len, "%s%s",
+				len ? ", " : "", "projquota");
+	if (f2fs_sb_has_inode_chksum(sb))
+		len += snprintf(buf + len, PAGE_SIZE - len, "%s%s",
+				len ? ", " : "", "inode_checksum");
+	if (f2fs_sb_has_flexible_inline_xattr(sb))
+		len += snprintf(buf + len, PAGE_SIZE - len, "%s%s",
+				len ? ", " : "", "flexible_inline_xattr");
+	if (f2fs_sb_has_quota_ino(sb))
+		len += snprintf(buf + len, PAGE_SIZE - len, "%s%s",
+				len ? ", " : "", "quota_ino");
+	if (f2fs_sb_has_inode_crtime(sb))
+		len += snprintf(buf + len, PAGE_SIZE - len, "%s%s",
+				len ? ", " : "", "inode_crtime");
+	if (f2fs_sb_has_lost_found(sb))
+		len += snprintf(buf + len, PAGE_SIZE - len, "%s%s",
+				len ? ", " : "", "lost_found");
+	len += snprintf(buf + len, PAGE_SIZE - len, "\n");
+	return len;
+}
+
+static ssize_t current_reserved_blocks_show(struct f2fs_attr *a,
+					struct f2fs_sb_info *sbi, char *buf)
+{
+	return snprintf(buf, PAGE_SIZE, "%u\n", sbi->current_reserved_blocks);
+}
+
+static ssize_t f2fs_sbi_show(struct f2fs_attr *a,
+			struct f2fs_sb_info *sbi, char *buf)
+{
+	unsigned char *ptr = NULL;
+	unsigned int *ui;
+
+	ptr = __struct_ptr(sbi, a->struct_type);
+	if (!ptr)
+		return -EINVAL;
+
+	if (!strcmp(a->attr.name, "extension_list")) {
+		__u8 (*extlist)[F2FS_EXTENSION_LEN] =
+					sbi->raw_super->extension_list;
+		int cold_count = le32_to_cpu(sbi->raw_super->extension_count);
+		int hot_count = sbi->raw_super->hot_ext_count;
+		int len = 0, i;
+
+		len += snprintf(buf + len, PAGE_SIZE - len,
+						"cold file extension:\n");
+		for (i = 0; i < cold_count; i++)
+			len += snprintf(buf + len, PAGE_SIZE - len, "%s\n",
+								extlist[i]);
+
+		len += snprintf(buf + len, PAGE_SIZE - len,
+						"hot file extension:\n");
+		for (i = cold_count; i < cold_count + hot_count; i++)
+			len += snprintf(buf + len, PAGE_SIZE - len, "%s\n",
+								extlist[i]);
+		return len;
+	}
+
+	ui = (unsigned int *)(ptr + a->offset);
+
+	return snprintf(buf, PAGE_SIZE, "%u\n", *ui);
+}
+
+static ssize_t __sbi_store(struct f2fs_attr *a,
+			struct f2fs_sb_info *sbi,
+			const char *buf, size_t count)
+{
+	unsigned char *ptr;
+	unsigned long t;
+	unsigned int *ui;
+	ssize_t ret;
+
+	ptr = __struct_ptr(sbi, a->struct_type);
+	if (!ptr)
+		return -EINVAL;
+
+	if (!strcmp(a->attr.name, "extension_list")) {
+		const char *name = strim((char *)buf);
+		bool set = true, hot;
+
+		if (!strncmp(name, "[h]", 3))
+			hot = true;
+		else if (!strncmp(name, "[c]", 3))
+			hot = false;
+		else
+			return -EINVAL;
+
+		name += 3;
+
+		if (*name == '!') {
+			name++;
+			set = false;
+		}
+
+		if (strlen(name) >= F2FS_EXTENSION_LEN)
+			return -EINVAL;
+
+		down_write(&sbi->sb_lock);
+
+		ret = f2fs_update_extension_list(sbi, name, hot, set);
+		if (ret)
+			goto out;
+
+		ret = f2fs_commit_super(sbi, false);
+		if (ret)
+			f2fs_update_extension_list(sbi, name, hot, !set);
+out:
+		up_write(&sbi->sb_lock);
+		return ret ? ret : count;
+	}
+
+	ui = (unsigned int *)(ptr + a->offset);
+
+	ret = kstrtoul(skip_spaces(buf), 0, &t);
+	if (ret < 0)
+		return ret;
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	if (a->struct_type == FAULT_INFO_TYPE && t >= (1 << FAULT_MAX))
+		return -EINVAL;
+#endif
+	if (a->struct_type == RESERVED_BLOCKS) {
+		spin_lock(&sbi->stat_lock);
+		if (t > (unsigned long)(sbi->user_block_count -
+				F2FS_OPTION(sbi).root_reserved_blocks)) {
+			spin_unlock(&sbi->stat_lock);
+			return -EINVAL;
+		}
+		*ui = t;
+		sbi->current_reserved_blocks = min(sbi->reserved_blocks,
+				sbi->user_block_count - valid_user_blocks(sbi));
+		spin_unlock(&sbi->stat_lock);
+		return count;
+	}
+
+	if (!strcmp(a->attr.name, "discard_granularity")) {
+		if (t == 0 || t > MAX_PLIST_NUM)
+			return -EINVAL;
+		if (t == *ui)
+			return count;
+		*ui = t;
+		return count;
+	}
+
+	if (!strcmp(a->attr.name, "trim_sections"))
+		return -EINVAL;
+
+	if (!strcmp(a->attr.name, "gc_urgent")) {
+		if (t >= 1) {
+			sbi->gc_mode = GC_URGENT;
+			if (sbi->gc_thread) {
+				wake_up_interruptible_all(
+					&sbi->gc_thread->gc_wait_queue_head);
+				wake_up_discard_thread(sbi, true);
+			}
+		} else {
+			sbi->gc_mode = GC_NORMAL;
+		}
+		return count;
+	}
+	if (!strcmp(a->attr.name, "gc_idle")) {
+		if (t == GC_IDLE_CB)
+			sbi->gc_mode = GC_IDLE_CB;
+		else if (t == GC_IDLE_GREEDY)
+			sbi->gc_mode = GC_IDLE_GREEDY;
+		else
+			sbi->gc_mode = GC_NORMAL;
+		return count;
+	}
+
+	*ui = t;
+
+	if (!strcmp(a->attr.name, "iostat_enable") && *ui == 0)
+		f2fs_reset_iostat(sbi);
+	return count;
+}
+
+static ssize_t f2fs_sbi_store(struct f2fs_attr *a,
+			struct f2fs_sb_info *sbi,
+			const char *buf, size_t count)
+{
+	ssize_t ret;
+	bool gc_entry = (!strcmp(a->attr.name, "gc_urgent") ||
+					a->struct_type == GC_THREAD);
+
+	if (gc_entry)
+		down_read(&sbi->sb->s_umount);
+	ret = __sbi_store(a, sbi, buf, count);
+	if (gc_entry)
+		up_read(&sbi->sb->s_umount);
+
+	return ret;
+}
+
+static ssize_t f2fs_attr_show(struct kobject *kobj,
+				struct attribute *attr, char *buf)
+{
+	struct f2fs_sb_info *sbi = container_of(kobj, struct f2fs_sb_info,
+								s_kobj);
+	struct f2fs_attr *a = container_of(attr, struct f2fs_attr, attr);
+
+	return a->show ? a->show(a, sbi, buf) : 0;
+}
+
+static ssize_t f2fs_attr_store(struct kobject *kobj, struct attribute *attr,
+						const char *buf, size_t len)
+{
+	struct f2fs_sb_info *sbi = container_of(kobj, struct f2fs_sb_info,
+									s_kobj);
+	struct f2fs_attr *a = container_of(attr, struct f2fs_attr, attr);
+
+	return a->store ? a->store(a, sbi, buf, len) : 0;
+}
+
+static void f2fs_sb_release(struct kobject *kobj)
+{
+	struct f2fs_sb_info *sbi = container_of(kobj, struct f2fs_sb_info,
+								s_kobj);
+	complete(&sbi->s_kobj_unregister);
+}
+
+enum feat_id {
+	FEAT_CRYPTO = 0,
+	FEAT_BLKZONED,
+	FEAT_ATOMIC_WRITE,
+	FEAT_EXTRA_ATTR,
+	FEAT_PROJECT_QUOTA,
+	FEAT_INODE_CHECKSUM,
+	FEAT_FLEXIBLE_INLINE_XATTR,
+	FEAT_QUOTA_INO,
+	FEAT_INODE_CRTIME,
+	FEAT_LOST_FOUND,
+};
+
+static ssize_t f2fs_feature_show(struct f2fs_attr *a,
+		struct f2fs_sb_info *sbi, char *buf)
+{
+	switch (a->id) {
+	case FEAT_CRYPTO:
+	case FEAT_BLKZONED:
+	case FEAT_ATOMIC_WRITE:
+	case FEAT_EXTRA_ATTR:
+	case FEAT_PROJECT_QUOTA:
+	case FEAT_INODE_CHECKSUM:
+	case FEAT_FLEXIBLE_INLINE_XATTR:
+	case FEAT_QUOTA_INO:
+	case FEAT_INODE_CRTIME:
+	case FEAT_LOST_FOUND:
+		return snprintf(buf, PAGE_SIZE, "supported\n");
+	}
+	return 0;
+}
+
+#define F2FS_ATTR_OFFSET(_struct_type, _name, _mode, _show, _store, _offset) \
+static struct f2fs_attr f2fs_attr_##_name = {			\
+	.attr = {.name = __stringify(_name), .mode = _mode },	\
+	.show	= _show,					\
+	.store	= _store,					\
+	.struct_type = _struct_type,				\
+	.offset = _offset					\
+}
+
+#define F2FS_RW_ATTR(struct_type, struct_name, name, elname)	\
+	F2FS_ATTR_OFFSET(struct_type, name, 0644,		\
+		f2fs_sbi_show, f2fs_sbi_store,			\
+		offsetof(struct struct_name, elname))
+
+#define F2FS_GENERAL_RO_ATTR(name) \
+static struct f2fs_attr f2fs_attr_##name = __ATTR(name, 0444, name##_show, NULL)
+
+#define F2FS_FEATURE_RO_ATTR(_name, _id)			\
+static struct f2fs_attr f2fs_attr_##_name = {			\
+	.attr = {.name = __stringify(_name), .mode = 0444 },	\
+	.show	= f2fs_feature_show,				\
+	.id	= _id,						\
+}
+
+F2FS_RW_ATTR(GC_THREAD, f2fs_gc_kthread, gc_urgent_sleep_time,
+							urgent_sleep_time);
+F2FS_RW_ATTR(GC_THREAD, f2fs_gc_kthread, gc_min_sleep_time, min_sleep_time);
+F2FS_RW_ATTR(GC_THREAD, f2fs_gc_kthread, gc_max_sleep_time, max_sleep_time);
+F2FS_RW_ATTR(GC_THREAD, f2fs_gc_kthread, gc_no_gc_sleep_time, no_gc_sleep_time);
+F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, gc_idle, gc_mode);
+F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, gc_urgent, gc_mode);
+F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, reclaim_segments, rec_prefree_segments);
+F2FS_RW_ATTR(DCC_INFO, discard_cmd_control, max_small_discards, max_discards);
+F2FS_RW_ATTR(DCC_INFO, discard_cmd_control, discard_granularity, discard_granularity);
+F2FS_RW_ATTR(RESERVED_BLOCKS, f2fs_sb_info, reserved_blocks, reserved_blocks);
+F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, batched_trim_sections, trim_sections);
+F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, ipu_policy, ipu_policy);
+F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, min_ipu_util, min_ipu_util);
+F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, min_fsync_blocks, min_fsync_blocks);
+F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, min_hot_blocks, min_hot_blocks);
+F2FS_RW_ATTR(SM_INFO, f2fs_sm_info, min_ssr_sections, min_ssr_sections);
+F2FS_RW_ATTR(NM_INFO, f2fs_nm_info, ram_thresh, ram_thresh);
+F2FS_RW_ATTR(NM_INFO, f2fs_nm_info, ra_nid_pages, ra_nid_pages);
+F2FS_RW_ATTR(NM_INFO, f2fs_nm_info, dirty_nats_ratio, dirty_nats_ratio);
+F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, max_victim_search, max_victim_search);
+F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, dir_level, dir_level);
+F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, cp_interval, interval_time[CP_TIME]);
+F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, idle_interval, interval_time[REQ_TIME]);
+F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, iostat_enable, iostat_enable);
+F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, readdir_ra, readdir_ra);
+F2FS_RW_ATTR(F2FS_SBI, f2fs_sb_info, gc_pin_file_thresh, gc_pin_file_threshold);
+F2FS_RW_ATTR(F2FS_SBI, f2fs_super_block, extension_list, extension_list);
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+F2FS_RW_ATTR(FAULT_INFO_RATE, f2fs_fault_info, inject_rate, inject_rate);
+F2FS_RW_ATTR(FAULT_INFO_TYPE, f2fs_fault_info, inject_type, inject_type);
+#endif
+F2FS_GENERAL_RO_ATTR(dirty_segments);
+F2FS_GENERAL_RO_ATTR(lifetime_write_kbytes);
+F2FS_GENERAL_RO_ATTR(features);
+F2FS_GENERAL_RO_ATTR(current_reserved_blocks);
+
+#ifdef CONFIG_F2FS_FS_ENCRYPTION
+F2FS_FEATURE_RO_ATTR(encryption, FEAT_CRYPTO);
+#endif
+#ifdef CONFIG_BLK_DEV_ZONED
+F2FS_FEATURE_RO_ATTR(block_zoned, FEAT_BLKZONED);
+#endif
+F2FS_FEATURE_RO_ATTR(atomic_write, FEAT_ATOMIC_WRITE);
+F2FS_FEATURE_RO_ATTR(extra_attr, FEAT_EXTRA_ATTR);
+F2FS_FEATURE_RO_ATTR(project_quota, FEAT_PROJECT_QUOTA);
+F2FS_FEATURE_RO_ATTR(inode_checksum, FEAT_INODE_CHECKSUM);
+F2FS_FEATURE_RO_ATTR(flexible_inline_xattr, FEAT_FLEXIBLE_INLINE_XATTR);
+F2FS_FEATURE_RO_ATTR(quota_ino, FEAT_QUOTA_INO);
+F2FS_FEATURE_RO_ATTR(inode_crtime, FEAT_INODE_CRTIME);
+F2FS_FEATURE_RO_ATTR(lost_found, FEAT_LOST_FOUND);
+
+#define ATTR_LIST(name) (&f2fs_attr_##name.attr)
+static struct attribute *f2fs_attrs[] = {
+	ATTR_LIST(gc_urgent_sleep_time),
+	ATTR_LIST(gc_min_sleep_time),
+	ATTR_LIST(gc_max_sleep_time),
+	ATTR_LIST(gc_no_gc_sleep_time),
+	ATTR_LIST(gc_idle),
+	ATTR_LIST(gc_urgent),
+	ATTR_LIST(reclaim_segments),
+	ATTR_LIST(max_small_discards),
+	ATTR_LIST(discard_granularity),
+	ATTR_LIST(batched_trim_sections),
+	ATTR_LIST(ipu_policy),
+	ATTR_LIST(min_ipu_util),
+	ATTR_LIST(min_fsync_blocks),
+	ATTR_LIST(min_hot_blocks),
+	ATTR_LIST(min_ssr_sections),
+	ATTR_LIST(max_victim_search),
+	ATTR_LIST(dir_level),
+	ATTR_LIST(ram_thresh),
+	ATTR_LIST(ra_nid_pages),
+	ATTR_LIST(dirty_nats_ratio),
+	ATTR_LIST(cp_interval),
+	ATTR_LIST(idle_interval),
+	ATTR_LIST(iostat_enable),
+	ATTR_LIST(readdir_ra),
+	ATTR_LIST(gc_pin_file_thresh),
+	ATTR_LIST(extension_list),
+#ifdef CONFIG_F2FS_FAULT_INJECTION
+	ATTR_LIST(inject_rate),
+	ATTR_LIST(inject_type),
+#endif
+	ATTR_LIST(dirty_segments),
+	ATTR_LIST(lifetime_write_kbytes),
+	ATTR_LIST(features),
+	ATTR_LIST(reserved_blocks),
+	ATTR_LIST(current_reserved_blocks),
+	NULL,
+};
+
+static struct attribute *f2fs_feat_attrs[] = {
+#ifdef CONFIG_F2FS_FS_ENCRYPTION
+	ATTR_LIST(encryption),
+#endif
+#ifdef CONFIG_BLK_DEV_ZONED
+	ATTR_LIST(block_zoned),
+#endif
+	ATTR_LIST(atomic_write),
+	ATTR_LIST(extra_attr),
+	ATTR_LIST(project_quota),
+	ATTR_LIST(inode_checksum),
+	ATTR_LIST(flexible_inline_xattr),
+	ATTR_LIST(quota_ino),
+	ATTR_LIST(inode_crtime),
+	ATTR_LIST(lost_found),
+	NULL,
+};
+
+static const struct sysfs_ops f2fs_attr_ops = {
+	.show	= f2fs_attr_show,
+	.store	= f2fs_attr_store,
+};
+
+static struct kobj_type f2fs_sb_ktype = {
+	.default_attrs	= f2fs_attrs,
+	.sysfs_ops	= &f2fs_attr_ops,
+	.release	= f2fs_sb_release,
+};
+
+static struct kobj_type f2fs_ktype = {
+	.sysfs_ops	= &f2fs_attr_ops,
+};
+
+static struct kset f2fs_kset = {
+	.kobj   = {.ktype = &f2fs_ktype},
+};
+
+static struct kobj_type f2fs_feat_ktype = {
+	.default_attrs	= f2fs_feat_attrs,
+	.sysfs_ops	= &f2fs_attr_ops,
+};
+
+static struct kobject f2fs_feat = {
+	.kset	= &f2fs_kset,
+};
+
+static int segment_info_seq_show(struct seq_file *seq, void *offset)
+{
+	struct super_block *sb = seq->private;
+	struct f2fs_sb_info *sbi = F2FS_SB(sb);
+	unsigned int total_segs =
+			le32_to_cpu(sbi->raw_super->segment_count_main);
+	int i;
+
+	seq_puts(seq, "format: segment_type|valid_blocks\n"
+		"segment_type(0:HD, 1:WD, 2:CD, 3:HN, 4:WN, 5:CN)\n");
+
+	for (i = 0; i < total_segs; i++) {
+		struct seg_entry *se = get_seg_entry(sbi, i);
+
+		if ((i % 10) == 0)
+			seq_printf(seq, "%-10d", i);
+		seq_printf(seq, "%d|%-3u", se->type,
+					get_valid_blocks(sbi, i, false));
+		if ((i % 10) == 9 || i == (total_segs - 1))
+			seq_putc(seq, '\n');
+		else
+			seq_putc(seq, ' ');
+	}
+
+	return 0;
+}
+
+static int segment_bits_seq_show(struct seq_file *seq, void *offset)
+{
+	struct super_block *sb = seq->private;
+	struct f2fs_sb_info *sbi = F2FS_SB(sb);
+	unsigned int total_segs =
+			le32_to_cpu(sbi->raw_super->segment_count_main);
+	int i, j;
+
+	seq_puts(seq, "format: segment_type|valid_blocks|bitmaps\n"
+		"segment_type(0:HD, 1:WD, 2:CD, 3:HN, 4:WN, 5:CN)\n");
+
+	for (i = 0; i < total_segs; i++) {
+		struct seg_entry *se = get_seg_entry(sbi, i);
+
+		seq_printf(seq, "%-10d", i);
+		seq_printf(seq, "%d|%-3u|", se->type,
+					get_valid_blocks(sbi, i, false));
+		for (j = 0; j < SIT_VBLOCK_MAP_SIZE; j++)
+			seq_printf(seq, " %.2x", se->cur_valid_map[j]);
+		seq_putc(seq, '\n');
+	}
+	return 0;
+}
+
+static int iostat_info_seq_show(struct seq_file *seq, void *offset)
+{
+	struct super_block *sb = seq->private;
+	struct f2fs_sb_info *sbi = F2FS_SB(sb);
+	time64_t now = ktime_get_real_seconds();
+
+	if (!sbi->iostat_enable)
+		return 0;
+
+	seq_printf(seq, "time:		%-16llu\n", now);
+
+	/* print app IOs */
+	seq_printf(seq, "app buffered:	%-16llu\n",
+				sbi->write_iostat[APP_BUFFERED_IO]);
+	seq_printf(seq, "app direct:	%-16llu\n",
+				sbi->write_iostat[APP_DIRECT_IO]);
+	seq_printf(seq, "app mapped:	%-16llu\n",
+				sbi->write_iostat[APP_MAPPED_IO]);
+
+	/* print fs IOs */
+	seq_printf(seq, "fs data:	%-16llu\n",
+				sbi->write_iostat[FS_DATA_IO]);
+	seq_printf(seq, "fs node:	%-16llu\n",
+				sbi->write_iostat[FS_NODE_IO]);
+	seq_printf(seq, "fs meta:	%-16llu\n",
+				sbi->write_iostat[FS_META_IO]);
+	seq_printf(seq, "fs gc data:	%-16llu\n",
+				sbi->write_iostat[FS_GC_DATA_IO]);
+	seq_printf(seq, "fs gc node:	%-16llu\n",
+				sbi->write_iostat[FS_GC_NODE_IO]);
+	seq_printf(seq, "fs cp data:	%-16llu\n",
+				sbi->write_iostat[FS_CP_DATA_IO]);
+	seq_printf(seq, "fs cp node:	%-16llu\n",
+				sbi->write_iostat[FS_CP_NODE_IO]);
+	seq_printf(seq, "fs cp meta:	%-16llu\n",
+				sbi->write_iostat[FS_CP_META_IO]);
+	seq_printf(seq, "fs discard:	%-16llu\n",
+				sbi->write_iostat[FS_DISCARD]);
+
+	return 0;
+}
+
+#define F2FS_PROC_FILE_DEF(_name)					\
+static int _name##_open_fs(struct inode *inode, struct file *file)	\
+{									\
+	return single_open(file, _name##_seq_show, PDE_DATA(inode));	\
+}									\
+									\
+static const struct file_operations f2fs_seq_##_name##_fops = {		\
+	.open = _name##_open_fs,					\
+	.read = seq_read,						\
+	.llseek = seq_lseek,						\
+	.release = single_release,					\
+};
+
+F2FS_PROC_FILE_DEF(segment_info);
+F2FS_PROC_FILE_DEF(segment_bits);
+F2FS_PROC_FILE_DEF(iostat_info);
+
+int __init f2fs_init_sysfs(void)
+{
+	int ret;
+
+	kobject_set_name(&f2fs_kset.kobj, "f2fs");
+	f2fs_kset.kobj.parent = fs_kobj;
+	ret = kset_register(&f2fs_kset);
+	if (ret)
+		return ret;
+
+	ret = kobject_init_and_add(&f2fs_feat, &f2fs_feat_ktype,
+				   NULL, "features");
+	if (ret)
+		kset_unregister(&f2fs_kset);
+	else
+		f2fs_proc_root = proc_mkdir("fs/f2fs", NULL);
+	return ret;
+}
+
+void f2fs_exit_sysfs(void)
+{
+	kobject_put(&f2fs_feat);
+	kset_unregister(&f2fs_kset);
+	remove_proc_entry("fs/f2fs", NULL);
+	f2fs_proc_root = NULL;
+}
+
+int f2fs_register_sysfs(struct f2fs_sb_info *sbi)
+{
+	struct super_block *sb = sbi->sb;
+	int err;
+
+	sbi->s_kobj.kset = &f2fs_kset;
+	init_completion(&sbi->s_kobj_unregister);
+	err = kobject_init_and_add(&sbi->s_kobj, &f2fs_sb_ktype, NULL,
+				"%s", sb->s_id);
+	if (err)
+		return err;
+
+	if (f2fs_proc_root)
+		sbi->s_proc = proc_mkdir(sb->s_id, f2fs_proc_root);
+
+	if (sbi->s_proc) {
+		proc_create_data("segment_info", S_IRUGO, sbi->s_proc,
+				 &f2fs_seq_segment_info_fops, sb);
+		proc_create_data("segment_bits", S_IRUGO, sbi->s_proc,
+				 &f2fs_seq_segment_bits_fops, sb);
+		proc_create_data("iostat_info", S_IRUGO, sbi->s_proc,
+				&f2fs_seq_iostat_info_fops, sb);
+	}
+	return 0;
+}
+
+void f2fs_unregister_sysfs(struct f2fs_sb_info *sbi)
+{
+	if (sbi->s_proc) {
+		remove_proc_entry("iostat_info", sbi->s_proc);
+		remove_proc_entry("segment_info", sbi->s_proc);
+		remove_proc_entry("segment_bits", sbi->s_proc);
+		remove_proc_entry(sbi->sb->s_id, f2fs_proc_root);
+	}
+	kobject_del(&sbi->s_kobj);
+}
diff --git a/fs/f2fs/trace.c b/fs/f2fs/trace.c
index 73b4e1d..a1fcd00 100644
--- a/fs/f2fs/trace.c
+++ b/fs/f2fs/trace.c
@@ -17,7 +17,7 @@
 #include "trace.h"
 
 static RADIX_TREE(pids, GFP_ATOMIC);
-static spinlock_t pids_lock;
+static struct mutex pids_lock;
 static struct last_io_info last_io;
 
 static inline void __print_last_io(void)
@@ -59,12 +59,12 @@ void f2fs_trace_pid(struct page *page)
 	pid_t pid = task_pid_nr(current);
 	void *p;
 
-	page->private = pid;
+	set_page_private(page, (unsigned long)pid);
 
 	if (radix_tree_preload(GFP_NOFS))
 		return;
 
-	spin_lock(&pids_lock);
+	mutex_lock(&pids_lock);
 	p = radix_tree_lookup(&pids, pid);
 	if (p == current)
 		goto out;
@@ -77,7 +77,7 @@ void f2fs_trace_pid(struct page *page)
 			MAJOR(inode->i_sb->s_dev), MINOR(inode->i_sb->s_dev),
 			pid, current->comm);
 out:
-	spin_unlock(&pids_lock);
+	mutex_unlock(&pids_lock);
 	radix_tree_preload_end();
 }
 
@@ -122,7 +122,7 @@ void f2fs_trace_ios(struct f2fs_io_info *fio, int flush)
 
 void f2fs_build_trace_ios(void)
 {
-	spin_lock_init(&pids_lock);
+	mutex_init(&pids_lock);
 }
 
 #define PIDVEC_SIZE	128
@@ -138,7 +138,7 @@ static unsigned int gang_lookup_pids(pid_t *results, unsigned long first_index,
 
 	radix_tree_for_each_slot(slot, &pids, &iter, first_index) {
 		results[ret] = iter.index;
-		if (++ret == PIDVEC_SIZE)
+		if (++ret == max_items)
 			break;
 	}
 	return ret;
@@ -150,7 +150,7 @@ void f2fs_destroy_trace_ios(void)
 	pid_t next_pid = 0;
 	unsigned int found;
 
-	spin_lock(&pids_lock);
+	mutex_lock(&pids_lock);
 	while ((found = gang_lookup_pids(pid, next_pid, PIDVEC_SIZE))) {
 		unsigned idx;
 
@@ -158,5 +158,5 @@ void f2fs_destroy_trace_ios(void)
 		for (idx = 0; idx < found; idx++)
 			radix_tree_delete(&pids, pid[idx]);
 	}
-	spin_unlock(&pids_lock);
+	mutex_unlock(&pids_lock);
 }
diff --git a/fs/f2fs/xattr.c b/fs/f2fs/xattr.c
index 3e1c028..7082718 100644
--- a/fs/f2fs/xattr.c
+++ b/fs/f2fs/xattr.c
@@ -106,7 +106,7 @@ static int f2fs_xattr_advise_set(const struct xattr_handler *handler,
 		return -EINVAL;
 
 	F2FS_I(inode)->i_advise |= *(char *)value;
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, true);
 	return 0;
 }
 
@@ -217,55 +217,157 @@ static struct f2fs_xattr_entry *__find_xattr(void *base_addr, int index,
 	return entry;
 }
 
+static struct f2fs_xattr_entry *__find_inline_xattr(struct inode *inode,
+				void *base_addr, void **last_addr, int index,
+				size_t len, const char *name)
+{
+	struct f2fs_xattr_entry *entry;
+	unsigned int inline_size = inline_xattr_size(inode);
+
+	list_for_each_xattr(entry, base_addr) {
+		if ((void *)entry + sizeof(__u32) > base_addr + inline_size ||
+			(void *)XATTR_NEXT_ENTRY(entry) + sizeof(__u32) >
+			base_addr + inline_size) {
+			*last_addr = entry;
+			return NULL;
+		}
+		if (entry->e_name_index != index)
+			continue;
+		if (entry->e_name_len != len)
+			continue;
+		if (!memcmp(entry->e_name, name, len))
+			break;
+	}
+	return entry;
+}
+
+static int read_inline_xattr(struct inode *inode, struct page *ipage,
+							void *txattr_addr)
+{
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+	unsigned int inline_size = inline_xattr_size(inode);
+	struct page *page = NULL;
+	void *inline_addr;
+
+	if (ipage) {
+		inline_addr = inline_xattr_addr(inode, ipage);
+	} else {
+		page = f2fs_get_node_page(sbi, inode->i_ino);
+		if (IS_ERR(page))
+			return PTR_ERR(page);
+
+		inline_addr = inline_xattr_addr(inode, page);
+	}
+	memcpy(txattr_addr, inline_addr, inline_size);
+	f2fs_put_page(page, 1);
+
+	return 0;
+}
+
+static int read_xattr_block(struct inode *inode, void *txattr_addr)
+{
+	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
+	nid_t xnid = F2FS_I(inode)->i_xattr_nid;
+	unsigned int inline_size = inline_xattr_size(inode);
+	struct page *xpage;
+	void *xattr_addr;
+
+	/* The inode already has an extended attribute block. */
+	xpage = f2fs_get_node_page(sbi, xnid);
+	if (IS_ERR(xpage))
+		return PTR_ERR(xpage);
+
+	xattr_addr = page_address(xpage);
+	memcpy(txattr_addr + inline_size, xattr_addr, VALID_XATTR_BLOCK_SIZE);
+	f2fs_put_page(xpage, 1);
+
+	return 0;
+}
+
+static int lookup_all_xattrs(struct inode *inode, struct page *ipage,
+				unsigned int index, unsigned int len,
+				const char *name, struct f2fs_xattr_entry **xe,
+				void **base_addr)
+{
+	void *cur_addr, *txattr_addr, *last_addr = NULL;
+	nid_t xnid = F2FS_I(inode)->i_xattr_nid;
+	unsigned int size = xnid ? VALID_XATTR_BLOCK_SIZE : 0;
+	unsigned int inline_size = inline_xattr_size(inode);
+	int err = 0;
+
+	if (!size && !inline_size)
+		return -ENODATA;
+
+	txattr_addr = f2fs_kzalloc(F2FS_I_SB(inode),
+			inline_size + size + XATTR_PADDING_SIZE, GFP_NOFS);
+	if (!txattr_addr)
+		return -ENOMEM;
+
+	/* read from inline xattr */
+	if (inline_size) {
+		err = read_inline_xattr(inode, ipage, txattr_addr);
+		if (err)
+			goto out;
+
+		*xe = __find_inline_xattr(inode, txattr_addr, &last_addr,
+						index, len, name);
+		if (*xe)
+			goto check;
+	}
+
+	/* read from xattr node block */
+	if (xnid) {
+		err = read_xattr_block(inode, txattr_addr);
+		if (err)
+			goto out;
+	}
+
+	if (last_addr)
+		cur_addr = XATTR_HDR(last_addr) - 1;
+	else
+		cur_addr = txattr_addr;
+
+	*xe = __find_xattr(cur_addr, index, len, name);
+check:
+	if (IS_XATTR_LAST_ENTRY(*xe)) {
+		err = -ENODATA;
+		goto out;
+	}
+
+	*base_addr = txattr_addr;
+	return 0;
+out:
+	kzfree(txattr_addr);
+	return err;
+}
+
 static int read_all_xattrs(struct inode *inode, struct page *ipage,
 							void **base_addr)
 {
-	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	struct f2fs_xattr_header *header;
-	size_t size = PAGE_SIZE, inline_size = 0;
+	nid_t xnid = F2FS_I(inode)->i_xattr_nid;
+	unsigned int size = VALID_XATTR_BLOCK_SIZE;
+	unsigned int inline_size = inline_xattr_size(inode);
 	void *txattr_addr;
 	int err;
 
-	inline_size = inline_xattr_size(inode);
-
-	txattr_addr = kzalloc(inline_size + size, GFP_F2FS_ZERO);
+	txattr_addr = f2fs_kzalloc(F2FS_I_SB(inode),
+			inline_size + size + XATTR_PADDING_SIZE, GFP_NOFS);
 	if (!txattr_addr)
 		return -ENOMEM;
 
 	/* read from inline xattr */
 	if (inline_size) {
-		struct page *page = NULL;
-		void *inline_addr;
-
-		if (ipage) {
-			inline_addr = inline_xattr_addr(ipage);
-		} else {
-			page = get_node_page(sbi, inode->i_ino);
-			if (IS_ERR(page)) {
-				err = PTR_ERR(page);
-				goto fail;
-			}
-			inline_addr = inline_xattr_addr(page);
-		}
-		memcpy(txattr_addr, inline_addr, inline_size);
-		f2fs_put_page(page, 1);
+		err = read_inline_xattr(inode, ipage, txattr_addr);
+		if (err)
+			goto fail;
 	}
 
 	/* read from xattr node block */
-	if (F2FS_I(inode)->i_xattr_nid) {
-		struct page *xpage;
-		void *xattr_addr;
-
-		/* The inode already has an extended attribute block. */
-		xpage = get_node_page(sbi, F2FS_I(inode)->i_xattr_nid);
-		if (IS_ERR(xpage)) {
-			err = PTR_ERR(xpage);
+	if (xnid) {
+		err = read_xattr_block(inode, txattr_addr);
+		if (err)
 			goto fail;
-		}
-
-		xattr_addr = page_address(xpage);
-		memcpy(txattr_addr + inline_size, xattr_addr, PAGE_SIZE);
-		f2fs_put_page(xpage, 1);
 	}
 
 	header = XATTR_HDR(txattr_addr);
@@ -286,85 +388,91 @@ static inline int write_all_xattrs(struct inode *inode, __u32 hsize,
 				void *txattr_addr, struct page *ipage)
 {
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
-	size_t inline_size = 0;
+	size_t inline_size = inline_xattr_size(inode);
+	struct page *in_page = NULL;
 	void *xattr_addr;
+	void *inline_addr = NULL;
 	struct page *xpage;
 	nid_t new_nid = 0;
-	int err;
-
-	inline_size = inline_xattr_size(inode);
+	int err = 0;
 
 	if (hsize > inline_size && !F2FS_I(inode)->i_xattr_nid)
-		if (!alloc_nid(sbi, &new_nid))
+		if (!f2fs_alloc_nid(sbi, &new_nid))
 			return -ENOSPC;
 
 	/* write to inline xattr */
 	if (inline_size) {
-		struct page *page = NULL;
-		void *inline_addr;
-
 		if (ipage) {
-			inline_addr = inline_xattr_addr(ipage);
-			f2fs_wait_on_page_writeback(ipage, NODE, true);
-			set_page_dirty(ipage);
+			inline_addr = inline_xattr_addr(inode, ipage);
 		} else {
-			page = get_node_page(sbi, inode->i_ino);
-			if (IS_ERR(page)) {
-				alloc_nid_failed(sbi, new_nid);
-				return PTR_ERR(page);
+			in_page = f2fs_get_node_page(sbi, inode->i_ino);
+			if (IS_ERR(in_page)) {
+				f2fs_alloc_nid_failed(sbi, new_nid);
+				return PTR_ERR(in_page);
 			}
-			inline_addr = inline_xattr_addr(page);
-			f2fs_wait_on_page_writeback(page, NODE, true);
+			inline_addr = inline_xattr_addr(inode, in_page);
 		}
-		memcpy(inline_addr, txattr_addr, inline_size);
-		f2fs_put_page(page, 1);
 
+		f2fs_wait_on_page_writeback(ipage ? ipage : in_page,
+							NODE, true);
 		/* no need to use xattr node block */
 		if (hsize <= inline_size) {
-			err = truncate_xattr_node(inode, ipage);
-			alloc_nid_failed(sbi, new_nid);
-			return err;
+			err = f2fs_truncate_xattr_node(inode);
+			f2fs_alloc_nid_failed(sbi, new_nid);
+			if (err) {
+				f2fs_put_page(in_page, 1);
+				return err;
+			}
+			memcpy(inline_addr, txattr_addr, inline_size);
+			set_page_dirty(ipage ? ipage : in_page);
+			goto in_page_out;
 		}
 	}
 
 	/* write to xattr node block */
 	if (F2FS_I(inode)->i_xattr_nid) {
-		xpage = get_node_page(sbi, F2FS_I(inode)->i_xattr_nid);
+		xpage = f2fs_get_node_page(sbi, F2FS_I(inode)->i_xattr_nid);
 		if (IS_ERR(xpage)) {
-			alloc_nid_failed(sbi, new_nid);
-			return PTR_ERR(xpage);
+			err = PTR_ERR(xpage);
+			f2fs_alloc_nid_failed(sbi, new_nid);
+			goto in_page_out;
 		}
 		f2fs_bug_on(sbi, new_nid);
 		f2fs_wait_on_page_writeback(xpage, NODE, true);
 	} else {
 		struct dnode_of_data dn;
 		set_new_dnode(&dn, inode, NULL, NULL, new_nid);
-		xpage = new_node_page(&dn, XATTR_NODE_OFFSET, ipage);
+		xpage = f2fs_new_node_page(&dn, XATTR_NODE_OFFSET);
 		if (IS_ERR(xpage)) {
-			alloc_nid_failed(sbi, new_nid);
-			return PTR_ERR(xpage);
+			err = PTR_ERR(xpage);
+			f2fs_alloc_nid_failed(sbi, new_nid);
+			goto in_page_out;
 		}
-		alloc_nid_done(sbi, new_nid);
+		f2fs_alloc_nid_done(sbi, new_nid);
 	}
-
 	xattr_addr = page_address(xpage);
-	memcpy(xattr_addr, txattr_addr + inline_size, PAGE_SIZE -
-						sizeof(struct node_footer));
+
+	if (inline_size)
+		memcpy(inline_addr, txattr_addr, inline_size);
+	memcpy(xattr_addr, txattr_addr + inline_size, VALID_XATTR_BLOCK_SIZE);
+
+	if (inline_size)
+		set_page_dirty(ipage ? ipage : in_page);
 	set_page_dirty(xpage);
-	f2fs_put_page(xpage, 1);
 
-	/* need to checkpoint during fsync */
-	F2FS_I(inode)->xattr_ver = cur_cp_version(F2FS_CKPT(sbi));
-	return 0;
+	f2fs_put_page(xpage, 1);
+in_page_out:
+	f2fs_put_page(in_page, 1);
+	return err;
 }
 
 int f2fs_getxattr(struct inode *inode, int index, const char *name,
 		void *buffer, size_t buffer_size, struct page *ipage)
 {
-	struct f2fs_xattr_entry *entry;
-	void *base_addr;
+	struct f2fs_xattr_entry *entry = NULL;
 	int error = 0;
-	size_t size, len;
+	unsigned int size, len;
+	void *base_addr = NULL;
 
 	if (name == NULL)
 		return -EINVAL;
@@ -373,21 +481,18 @@ int f2fs_getxattr(struct inode *inode, int index, const char *name,
 	if (len > F2FS_NAME_LEN)
 		return -ERANGE;
 
-	error = read_all_xattrs(inode, ipage, &base_addr);
+	down_read(&F2FS_I(inode)->i_xattr_sem);
+	error = lookup_all_xattrs(inode, ipage, index, len, name,
+				&entry, &base_addr);
+	up_read(&F2FS_I(inode)->i_xattr_sem);
 	if (error)
 		return error;
 
-	entry = __find_xattr(base_addr, index, len, name);
-	if (IS_XATTR_LAST_ENTRY(entry)) {
-		error = -ENODATA;
-		goto cleanup;
-	}
-
 	size = le16_to_cpu(entry->e_value_size);
 
 	if (buffer && size > buffer_size) {
 		error = -ERANGE;
-		goto cleanup;
+		goto out;
 	}
 
 	if (buffer) {
@@ -395,8 +500,7 @@ int f2fs_getxattr(struct inode *inode, int index, const char *name,
 		memcpy(buffer, pval, size);
 	}
 	error = size;
-
-cleanup:
+out:
 	kzfree(base_addr);
 	return error;
 }
@@ -409,7 +513,9 @@ ssize_t f2fs_listxattr(struct dentry *dentry, char *buffer, size_t buffer_size)
 	int error = 0;
 	size_t rest = buffer_size;
 
+	down_read(&F2FS_I(inode)->i_xattr_sem);
 	error = read_all_xattrs(inode, NULL, &base_addr);
+	up_read(&F2FS_I(inode)->i_xattr_sem);
 	if (error)
 		return error;
 
@@ -445,6 +551,15 @@ ssize_t f2fs_listxattr(struct dentry *dentry, char *buffer, size_t buffer_size)
 	return error;
 }
 
+static bool f2fs_xattr_value_same(struct f2fs_xattr_entry *entry,
+					const void *value, size_t size)
+{
+	void *pval = entry->e_name + entry->e_name_len;
+
+	return (le16_to_cpu(entry->e_value_size) == size) &&
+					!memcmp(pval, value, size);
+}
+
 static int __f2fs_setxattr(struct inode *inode, int index,
 			const char *name, const void *value, size_t size,
 			struct page *ipage, int flags)
@@ -479,12 +594,17 @@ static int __f2fs_setxattr(struct inode *inode, int index,
 
 	found = IS_XATTR_LAST_ENTRY(here) ? 0 : 1;
 
-	if ((flags & XATTR_REPLACE) && !found) {
+	if (found) {
+		if ((flags & XATTR_CREATE)) {
+			error = -EEXIST;
+			goto exit;
+		}
+
+		if (value && f2fs_xattr_value_same(here, value, size))
+			goto exit;
+	} else if ((flags & XATTR_REPLACE)) {
 		error = -ENODATA;
 		goto exit;
-	} else if ((flags & XATTR_CREATE) && found) {
-		error = -EEXIST;
-		goto exit;
 	}
 
 	last = here;
@@ -554,7 +674,7 @@ static int __f2fs_setxattr(struct inode *inode, int index,
 	if (index == F2FS_XATTR_INDEX_ENCRYPTION &&
 			!strcmp(name, F2FS_XATTR_NAME_ENCRYPTION_CONTEXT))
 		f2fs_set_encrypted_inode(inode);
-	f2fs_mark_inode_dirty_sync(inode);
+	f2fs_mark_inode_dirty_sync(inode, true);
 	if (!error && S_ISDIR(inode->i_mode))
 		set_sbi_flag(F2FS_I_SB(inode), SBI_NEED_CP);
 exit:
@@ -569,7 +689,11 @@ int f2fs_setxattr(struct inode *inode, int index, const char *name,
 	struct f2fs_sb_info *sbi = F2FS_I_SB(inode);
 	int err;
 
-	/* this case is only from init_inode_metadata */
+	err = dquot_initialize(inode);
+	if (err)
+		return err;
+
+	/* this case is only from f2fs_init_inode_metadata */
 	if (ipage)
 		return __f2fs_setxattr(inode, index, name, value,
 						size, ipage, flags);
@@ -578,7 +702,9 @@ int f2fs_setxattr(struct inode *inode, int index, const char *name,
 	f2fs_lock_op(sbi);
 	/* protect xattr_ver */
 	down_write(&F2FS_I(inode)->i_sem);
+	down_write(&F2FS_I(inode)->i_xattr_sem);
 	err = __f2fs_setxattr(inode, index, name, value, size, ipage, flags);
+	up_write(&F2FS_I(inode)->i_xattr_sem);
 	up_write(&F2FS_I(inode)->i_sem);
 	f2fs_unlock_op(sbi);
 
diff --git a/fs/f2fs/xattr.h b/fs/f2fs/xattr.h
index f990de2..dbcd1d1 100644
--- a/fs/f2fs/xattr.h
+++ b/fs/f2fs/xattr.h
@@ -58,10 +58,10 @@ struct f2fs_xattr_entry {
 #define XATTR_FIRST_ENTRY(ptr)	(XATTR_ENTRY(XATTR_HDR(ptr) + 1))
 #define XATTR_ROUND		(3)
 
-#define XATTR_ALIGN(size)	((size + XATTR_ROUND) & ~XATTR_ROUND)
+#define XATTR_ALIGN(size)	(((size) + XATTR_ROUND) & ~XATTR_ROUND)
 
 #define ENTRY_SIZE(entry) (XATTR_ALIGN(sizeof(struct f2fs_xattr_entry) + \
-			entry->e_name_len + le16_to_cpu(entry->e_value_size)))
+			(entry)->e_name_len + le16_to_cpu((entry)->e_value_size)))
 
 #define XATTR_NEXT_ENTRY(entry)	((struct f2fs_xattr_entry *)((char *)(entry) +\
 			ENTRY_SIZE(entry)))
@@ -72,9 +72,10 @@ struct f2fs_xattr_entry {
 		for (entry = XATTR_FIRST_ENTRY(addr);\
 				!IS_XATTR_LAST_ENTRY(entry);\
 				entry = XATTR_NEXT_ENTRY(entry))
-
-#define MIN_OFFSET(i)	XATTR_ALIGN(inline_xattr_size(i) + PAGE_SIZE -	\
-				sizeof(struct node_footer) - sizeof(__u32))
+#define VALID_XATTR_BLOCK_SIZE	(PAGE_SIZE - sizeof(struct node_footer))
+#define XATTR_PADDING_SIZE	(sizeof(__u32))
+#define MIN_OFFSET(i)		XATTR_ALIGN(inline_xattr_size(i) +	\
+						VALID_XATTR_BLOCK_SIZE)
 
 #define MAX_VALUE_LEN(i)	(MIN_OFFSET(i) -			\
 				sizeof(struct f2fs_xattr_header) -	\
diff --git a/fs/fs-writeback.c b/fs/fs-writeback.c
index f3aea1b..17ad41d 100644
--- a/fs/fs-writeback.c
+++ b/fs/fs-writeback.c
@@ -2112,7 +2112,7 @@ void __mark_inode_dirty(struct inode *inode, int flags)
 	    (dirtytime && (inode->i_state & I_DIRTY_INODE)))
 		return;
 
-	if (unlikely(block_dump))
+	if (unlikely(block_dump > 1))
 		block_dump___mark_inode_dirty(inode);
 
 	spin_lock(&inode->i_lock);
diff --git a/fs/fs_struct.c b/fs/fs_struct.c
index 7dca743..940c683 100644
--- a/fs/fs_struct.c
+++ b/fs/fs_struct.c
@@ -44,6 +44,7 @@ void set_fs_pwd(struct fs_struct *fs, const struct path *path)
 	if (old_pwd.dentry)
 		path_put(&old_pwd);
 }
+EXPORT_SYMBOL(set_fs_pwd);
 
 static inline int replace_path(struct path *p, const struct path *old, const struct path *new)
 {
@@ -89,6 +90,7 @@ void free_fs_struct(struct fs_struct *fs)
 	path_put(&fs->pwd);
 	kmem_cache_free(fs_cachep, fs);
 }
+EXPORT_SYMBOL(free_fs_struct);
 
 void exit_fs(struct task_struct *tsk)
 {
@@ -127,6 +129,7 @@ struct fs_struct *copy_fs_struct(struct fs_struct *old)
 	}
 	return fs;
 }
+EXPORT_SYMBOL_GPL(copy_fs_struct);
 
 int unshare_fs_struct(void)
 {
diff --git a/fs/fscache/object-list.c b/fs/fscache/object-list.c
index 37e0c31d..5eb2e24 100644
--- a/fs/fscache/object-list.c
+++ b/fs/fscache/object-list.c
@@ -329,7 +329,7 @@ static void fscache_objlist_config(struct fscache_objlist_data *data)
 	config = 0;
 	rcu_read_lock();
 
-	confkey = user_key_payload(key);
+	confkey = user_key_payload_rcu(key);
 	if (!confkey) {
 		/* key was revoked */
 		rcu_read_unlock();
diff --git a/fs/fuse/dev.c b/fs/fuse/dev.c
index f117926..2ca3c1e 100644
--- a/fs/fuse/dev.c
+++ b/fs/fuse/dev.c
@@ -13,12 +13,14 @@
 #include <linux/poll.h>
 #include <linux/uio.h>
 #include <linux/miscdevice.h>
+#include <linux/namei.h>
 #include <linux/pagemap.h>
 #include <linux/file.h>
 #include <linux/slab.h>
 #include <linux/pipe_fs_i.h>
 #include <linux/swap.h>
 #include <linux/splice.h>
+#include <linux/freezer.h>
 
 MODULE_ALIAS_MISCDEV(FUSE_MINOR);
 MODULE_ALIAS("devname:fuse");
@@ -453,7 +455,9 @@ static void request_wait_answer(struct fuse_conn *fc, struct fuse_req *req)
 	 * Either request is already in userspace, or it was forced.
 	 * Wait it out.
 	 */
-	wait_event(req->waitq, test_bit(FR_FINISHED, &req->flags));
+	while (!test_bit(FR_FINISHED, &req->flags))
+		wait_event_freezable(req->waitq,
+				test_bit(FR_FINISHED, &req->flags));
 }
 
 static void __fuse_request_send(struct fuse_conn *fc, struct fuse_req *req)
@@ -1880,6 +1884,12 @@ static ssize_t fuse_dev_do_write(struct fuse_dev *fud,
 		cs->move_pages = 0;
 
 	err = copy_out_args(cs, &req->out, nbytes);
+	if (req->in.h.opcode == FUSE_CANONICAL_PATH) {
+		char *path = (char *)req->out.args[0].value;
+
+		path[req->out.args[0].size - 1] = 0;
+		req->out.h.error = kern_path(path, 0, req->canonical_path);
+	}
 	fuse_copy_finish(cs);
 
 	spin_lock(&fpq->lock);
diff --git a/fs/fuse/dir.c b/fs/fuse/dir.c
index cca8dd3..8045366 100644
--- a/fs/fuse/dir.c
+++ b/fs/fuse/dir.c
@@ -262,6 +262,50 @@ static int fuse_dentry_revalidate(struct dentry *entry, unsigned int flags)
 	goto out;
 }
 
+/*
+ * Get the canonical path. Since we must translate to a path, this must be done
+ * in the context of the userspace daemon, however, the userspace daemon cannot
+ * look up paths on its own. Instead, we handle the lookup as a special case
+ * inside of the write request.
+ */
+static void fuse_dentry_canonical_path(const struct path *path, struct path *canonical_path) {
+	struct inode *inode = path->dentry->d_inode;
+	struct fuse_conn *fc = get_fuse_conn(inode);
+	struct fuse_req *req;
+	int err;
+	char *path_name;
+
+	req = fuse_get_req(fc, 1);
+	err = PTR_ERR(req);
+	if (IS_ERR(req))
+		goto default_path;
+
+	path_name = (char*)__get_free_page(GFP_KERNEL);
+	if (!path_name) {
+		fuse_put_request(fc, req);
+		goto default_path;
+	}
+
+	req->in.h.opcode = FUSE_CANONICAL_PATH;
+	req->in.h.nodeid = get_node_id(inode);
+	req->in.numargs = 0;
+	req->out.numargs = 1;
+	req->out.args[0].size = PATH_MAX;
+	req->out.args[0].value = path_name;
+	req->canonical_path = canonical_path;
+	req->out.argvar = 1;
+	fuse_request_send(fc, req);
+	err = req->out.h.error;
+	fuse_put_request(fc, req);
+	free_page((unsigned long)path_name);
+	if (!err)
+		return;
+default_path:
+	canonical_path->dentry = path->dentry;
+	canonical_path->mnt = path->mnt;
+	path_get(canonical_path);
+}
+
 static int invalid_nodeid(u64 nodeid)
 {
 	return !nodeid || nodeid == FUSE_ROOT_ID;
@@ -284,11 +328,13 @@ static void fuse_dentry_release(struct dentry *dentry)
 	.d_revalidate	= fuse_dentry_revalidate,
 	.d_init		= fuse_dentry_init,
 	.d_release	= fuse_dentry_release,
+	.d_canonical_path = fuse_dentry_canonical_path,
 };
 
 const struct dentry_operations fuse_root_dentry_operations = {
 	.d_init		= fuse_dentry_init,
 	.d_release	= fuse_dentry_release,
+	.d_canonical_path = fuse_dentry_canonical_path,
 };
 
 int fuse_valid_type(int m)
diff --git a/fs/fuse/file.c b/fs/fuse/file.c
index 996aa23..c4353da 100644
--- a/fs/fuse/file.c
+++ b/fs/fuse/file.c
@@ -839,9 +839,9 @@ struct fuse_fill_data {
 	unsigned nr_pages;
 };
 
-static int fuse_readpages_fill(void *_data, struct page *page)
+static int fuse_readpages_fill(struct file *_data, struct page *page)
 {
-	struct fuse_fill_data *data = _data;
+	struct fuse_fill_data *data = (struct fuse_fill_data *)_data;
 	struct fuse_req *req = data->req;
 	struct inode *inode = data->inode;
 	struct fuse_conn *fc = get_fuse_conn(inode);
diff --git a/fs/fuse/fuse_i.h b/fs/fuse/fuse_i.h
index 9130794..6b30a12 100644
--- a/fs/fuse/fuse_i.h
+++ b/fs/fuse/fuse_i.h
@@ -368,6 +368,9 @@ struct fuse_req {
 	/** Inode used in the request or NULL */
 	struct inode *inode;
 
+	/** Path used for completing d_canonical_path */
+	struct path *canonical_path;
+
 	/** AIO control block */
 	struct fuse_io_priv *io;
 
diff --git a/fs/fuse/inode.c b/fs/fuse/inode.c
index f95e1d4..b1c6c96 100644
--- a/fs/fuse/inode.c
+++ b/fs/fuse/inode.c
@@ -30,7 +30,7 @@
 struct list_head fuse_conn_list;
 DEFINE_MUTEX(fuse_mutex);
 
-static int set_global_limit(const char *val, struct kernel_param *kp);
+static int set_global_limit(const char *val, const struct kernel_param *kp);
 
 unsigned max_user_bgreq;
 module_param_call(max_user_bgreq, set_global_limit, param_get_uint,
@@ -827,7 +827,7 @@ static void sanitize_global_limit(unsigned *limit)
 		*limit = (1 << 16) - 1;
 }
 
-static int set_global_limit(const char *val, struct kernel_param *kp)
+static int set_global_limit(const char *val, const struct kernel_param *kp)
 {
 	int rv;
 
diff --git a/fs/gfs2/aops.c b/fs/gfs2/aops.c
index 5a6f52e..0283ee0 100644
--- a/fs/gfs2/aops.c
+++ b/fs/gfs2/aops.c
@@ -268,22 +268,6 @@ static int gfs2_write_jdata_pagevec(struct address_space *mapping,
 	for(i = 0; i < nr_pages; i++) {
 		struct page *page = pvec->pages[i];
 
-		/*
-		 * At this point, the page may be truncated or
-		 * invalidated (changing page->mapping to NULL), or
-		 * even swizzled back from swapper_space to tmpfs file
-		 * mapping. However, page->index will not change
-		 * because we have a reference on the page.
-		 */
-		if (page->index > end) {
-			/*
-			 * can't be range_cyclic (1st pass) because
-			 * end == -1 in that case.
-			 */
-			ret = 1;
-			break;
-		}
-
 		*done_index = page->index;
 
 		lock_page(page);
@@ -401,8 +385,8 @@ static int gfs2_write_cache_jdata(struct address_space *mapping,
 		tag_pages_for_writeback(mapping, index, end);
 	done_index = index;
 	while (!done && (index <= end)) {
-		nr_pages = pagevec_lookup_tag(&pvec, mapping, &index, tag,
-			      min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1);
+		nr_pages = pagevec_lookup_range_tag(&pvec, mapping, &index, end,
+				tag);
 		if (nr_pages == 0)
 			break;
 
@@ -511,7 +495,7 @@ static int stuffed_readpage(struct gfs2_inode *ip, struct page *page)
  *
  */
 
-static int __gfs2_readpage(void *file, struct page *page)
+static int __gfs2_readpage(struct file *file, struct page *page)
 {
 	struct gfs2_inode *ip = GFS2_I(page->mapping->host);
 	struct gfs2_sbd *sdp = GFS2_SB(page->mapping->host);
diff --git a/fs/inode.c b/fs/inode.c
index 2071ff5..1d1a957 100644
--- a/fs/inode.c
+++ b/fs/inode.c
@@ -1781,7 +1781,7 @@ int dentry_needs_remove_privs(struct dentry *dentry)
 	return mask;
 }
 
-static int __remove_privs(struct dentry *dentry, int kill)
+static int __remove_privs(struct vfsmount *mnt, struct dentry *dentry, int kill)
 {
 	struct iattr newattrs;
 
@@ -1790,7 +1790,7 @@ static int __remove_privs(struct dentry *dentry, int kill)
 	 * Note we call this on write, so notify_change will not
 	 * encounter any conflicting delegations:
 	 */
-	return notify_change(dentry, &newattrs, NULL);
+	return notify_change2(mnt, dentry, &newattrs, NULL);
 }
 
 /*
@@ -1812,7 +1812,7 @@ int file_remove_privs(struct file *file)
 	if (kill < 0)
 		return kill;
 	if (kill)
-		error = __remove_privs(dentry, kill);
+		error = __remove_privs(file->f_path.mnt, dentry, kill);
 	if (!error)
 		inode_has_no_xattr(inode);
 
diff --git a/fs/internal.h b/fs/internal.h
index 8b7143b..3e58863 100644
--- a/fs/internal.h
+++ b/fs/internal.h
@@ -88,9 +88,11 @@ extern int vfs_path_lookup(struct dentry *, struct vfsmount *,
  * super.c
  */
 extern int do_remount_sb(struct super_block *, int, void *, int);
+extern int do_remount_sb2(struct vfsmount *, struct super_block *, int,
+								void *, int);
 extern bool trylock_super(struct super_block *sb);
 extern struct dentry *mount_fs(struct file_system_type *,
-			       int, const char *, void *);
+			       int, const char *, struct vfsmount *, void *);
 extern struct super_block *user_get_super(dev_t);
 
 /*
diff --git a/fs/lockd/svc.c b/fs/lockd/svc.c
index c19123d..d484c63 100644
--- a/fs/lockd/svc.c
+++ b/fs/lockd/svc.c
@@ -600,7 +600,7 @@ int lockd_up(struct net *net)
  */
 
 #define param_set_min_max(name, type, which_strtol, min, max)		\
-static int param_set_##name(const char *val, struct kernel_param *kp)	\
+static int param_set_##name(const char *val, const struct kernel_param *kp) \
 {									\
 	char *endp;							\
 	__typeof__(type) num = which_strtol(val, &endp, 0);		\
diff --git a/fs/logfs/dev_bdev.c b/fs/logfs/dev_bdev.c
index a8329cc..fdf844f 100644
--- a/fs/logfs/dev_bdev.c
+++ b/fs/logfs/dev_bdev.c
@@ -34,9 +34,9 @@ static int sync_request(struct page *page, struct block_device *bdev, int op)
 	return submit_bio_wait(&bio);
 }
 
-static int bdev_readpage(void *_sb, struct page *page)
+static int bdev_readpage(struct file *_sb, struct page *page)
 {
-	struct super_block *sb = _sb;
+	struct super_block *sb = (struct super_block *)_sb;
 	struct block_device *bdev = logfs_super(sb)->s_bdev;
 	int err;
 
diff --git a/fs/logfs/dev_mtd.c b/fs/logfs/dev_mtd.c
index b76a62b..9ec8e8f 100644
--- a/fs/logfs/dev_mtd.c
+++ b/fs/logfs/dev_mtd.c
@@ -122,9 +122,9 @@ static void logfs_mtd_sync(struct super_block *sb)
 	mtd_sync(mtd);
 }
 
-static int logfs_mtd_readpage(void *_sb, struct page *page)
+static int logfs_mtd_readpage(struct file *_sb, struct page *page)
 {
-	struct super_block *sb = _sb;
+	struct super_block *sb = (struct super_block *)_sb;
 	int err;
 
 	err = logfs_mtd_read(sb, page->index << PAGE_SHIFT, PAGE_SIZE,
diff --git a/fs/logfs/dir.c b/fs/logfs/dir.c
index c87ea52..8ddacc1 100644
--- a/fs/logfs/dir.c
+++ b/fs/logfs/dir.c
@@ -174,7 +174,7 @@ static struct page *logfs_get_dd_page(struct inode *dir, struct dentry *dentry)
 		if (!logfs_exist_block(dir, index))
 			continue;
 		page = read_cache_page(dir->i_mapping, index,
-				(filler_t *)logfs_readpage, NULL);
+				logfs_readpage, NULL);
 		if (IS_ERR(page))
 			return page;
 		dd = kmap_atomic(page);
@@ -306,7 +306,7 @@ static int logfs_readdir(struct file *file, struct dir_context *ctx)
 			continue;
 		}
 		page = read_cache_page(dir->i_mapping, pos,
-				(filler_t *)logfs_readpage, NULL);
+				logfs_readpage, NULL);
 		if (IS_ERR(page))
 			return PTR_ERR(page);
 		dd = kmap(page);
diff --git a/fs/logfs/logfs.h b/fs/logfs/logfs.h
index 27d040e..1a7c0b0 100644
--- a/fs/logfs/logfs.h
+++ b/fs/logfs/logfs.h
@@ -151,7 +151,7 @@ struct logfs_device_ops {
 	struct page *(*find_first_sb)(struct super_block *sb, u64 *ofs);
 	struct page *(*find_last_sb)(struct super_block *sb, u64 *ofs);
 	int (*write_sb)(struct super_block *sb, struct page *page);
-	int (*readpage)(void *_sb, struct page *page);
+	int (*readpage)(struct file *_sb, struct page *page);
 	void (*writeseg)(struct super_block *sb, u64 ofs, size_t len);
 	int (*erase)(struct super_block *sb, loff_t ofs, size_t len,
 			int ensure_write);
diff --git a/fs/mpage.c b/fs/mpage.c
index e2ea442..d4e17c8 100644
--- a/fs/mpage.c
+++ b/fs/mpage.c
@@ -31,6 +31,14 @@
 #include <linux/cleancache.h>
 #include "internal.h"
 
+#define CREATE_TRACE_POINTS
+#include <trace/events/android_fs.h>
+
+EXPORT_TRACEPOINT_SYMBOL(android_fs_datawrite_start);
+EXPORT_TRACEPOINT_SYMBOL(android_fs_datawrite_end);
+EXPORT_TRACEPOINT_SYMBOL(android_fs_dataread_start);
+EXPORT_TRACEPOINT_SYMBOL(android_fs_dataread_end);
+
 /*
  * I/O completion handler for multipage BIOs.
  *
@@ -48,6 +56,16 @@ static void mpage_end_io(struct bio *bio)
 	struct bio_vec *bv;
 	int i;
 
+	if (trace_android_fs_dataread_end_enabled() &&
+	    (bio_data_dir(bio) == READ)) {
+		struct page *first_page = bio->bi_io_vec[0].bv_page;
+
+		if (first_page != NULL)
+			trace_android_fs_dataread_end(first_page->mapping->host,
+						      page_offset(first_page),
+						      bio->bi_iter.bi_size);
+	}
+
 	bio_for_each_segment_all(bv, bio, i) {
 		struct page *page = bv->bv_page;
 		page_endio(page, op_is_write(bio_op(bio)), bio->bi_error);
@@ -58,6 +76,24 @@ static void mpage_end_io(struct bio *bio)
 
 static struct bio *mpage_bio_submit(int op, int op_flags, struct bio *bio)
 {
+	if (trace_android_fs_dataread_start_enabled() && (op == REQ_OP_READ)) {
+		struct page *first_page = bio->bi_io_vec[0].bv_page;
+
+		if (first_page != NULL) {
+			char *path, pathbuf[MAX_TRACE_PATHBUF_LEN];
+
+			path = android_fstrace_get_pathname(pathbuf,
+						    MAX_TRACE_PATHBUF_LEN,
+						    first_page->mapping->host);
+			trace_android_fs_dataread_start(
+				first_page->mapping->host,
+				page_offset(first_page),
+				bio->bi_iter.bi_size,
+				current->pid,
+				path,
+				current->comm);
+		}
+	}
 	bio->bi_end_io = mpage_end_io;
 	bio_set_op_attrs(bio, op, op_flags);
 	guard_bio_eod(op, bio);
diff --git a/fs/namei.c b/fs/namei.c
index 85ac38b..a5a05d3 100644
--- a/fs/namei.c
+++ b/fs/namei.c
@@ -376,9 +376,11 @@ int generic_permission(struct inode *inode, int mask)
  * flag in inode->i_opflags, that says "this has not special
  * permission function, use the fast case".
  */
-static inline int do_inode_permission(struct inode *inode, int mask)
+static inline int do_inode_permission(struct vfsmount *mnt, struct inode *inode, int mask)
 {
 	if (unlikely(!(inode->i_opflags & IOP_FASTPERM))) {
+		if (likely(mnt && inode->i_op->permission2))
+			return inode->i_op->permission2(mnt, inode, mask);
 		if (likely(inode->i_op->permission))
 			return inode->i_op->permission(inode, mask);
 
@@ -402,7 +404,7 @@ static inline int do_inode_permission(struct inode *inode, int mask)
  * This does not check for a read-only file system.  You probably want
  * inode_permission().
  */
-int __inode_permission(struct inode *inode, int mask)
+int __inode_permission2(struct vfsmount *mnt, struct inode *inode, int mask)
 {
 	int retval;
 
@@ -422,7 +424,7 @@ int __inode_permission(struct inode *inode, int mask)
 			return -EACCES;
 	}
 
-	retval = do_inode_permission(inode, mask);
+	retval = do_inode_permission(mnt, inode, mask);
 	if (retval)
 		return retval;
 
@@ -430,7 +432,14 @@ int __inode_permission(struct inode *inode, int mask)
 	if (retval)
 		return retval;
 
-	return security_inode_permission(inode, mask);
+	retval = security_inode_permission(inode, mask);
+	return retval;
+}
+EXPORT_SYMBOL(__inode_permission2);
+
+int __inode_permission(struct inode *inode, int mask)
+{
+	return __inode_permission2(NULL, inode, mask);
 }
 EXPORT_SYMBOL(__inode_permission);
 
@@ -466,14 +475,20 @@ static int sb_permission(struct super_block *sb, struct inode *inode, int mask)
  *
  * When checking for MAY_APPEND, MAY_WRITE must also be set in @mask.
  */
-int inode_permission(struct inode *inode, int mask)
+int inode_permission2(struct vfsmount *mnt, struct inode *inode, int mask)
 {
 	int retval;
 
 	retval = sb_permission(inode->i_sb, inode, mask);
 	if (retval)
 		return retval;
-	return __inode_permission(inode, mask);
+	return __inode_permission2(mnt, inode, mask);
+}
+EXPORT_SYMBOL(inode_permission2);
+
+int inode_permission(struct inode *inode, int mask)
+{
+	return inode_permission2(NULL, inode, mask);
 }
 EXPORT_SYMBOL(inode_permission);
 
@@ -1665,13 +1680,13 @@ static struct dentry *lookup_slow(const struct qstr *name,
 static inline int may_lookup(struct nameidata *nd)
 {
 	if (nd->flags & LOOKUP_RCU) {
-		int err = inode_permission(nd->inode, MAY_EXEC|MAY_NOT_BLOCK);
+		int err = inode_permission2(nd->path.mnt, nd->inode, MAY_EXEC|MAY_NOT_BLOCK);
 		if (err != -ECHILD)
 			return err;
 		if (unlazy_walk(nd, NULL, 0))
 			return -ECHILD;
 	}
-	return inode_permission(nd->inode, MAY_EXEC);
+	return inode_permission2(nd->path.mnt, nd->inode, MAY_EXEC);
 }
 
 static inline int handle_dots(struct nameidata *nd, int type)
@@ -2145,11 +2160,12 @@ static const char *path_init(struct nameidata *nd, unsigned flags)
 	nd->depth = 0;
 	if (flags & LOOKUP_ROOT) {
 		struct dentry *root = nd->root.dentry;
+		struct vfsmount *mnt = nd->root.mnt;
 		struct inode *inode = root->d_inode;
 		if (*s) {
 			if (!d_can_lookup(root))
 				return ERR_PTR(-ENOTDIR);
-			retval = inode_permission(inode, MAY_EXEC);
+			retval = inode_permission2(mnt, inode, MAY_EXEC);
 			if (retval)
 				return ERR_PTR(retval);
 		}
@@ -2414,6 +2430,7 @@ int vfs_path_lookup(struct dentry *dentry, struct vfsmount *mnt,
 /**
  * lookup_one_len - filesystem helper to lookup single pathname component
  * @name:	pathname component to lookup
+ * @mnt:	mount we are looking up on
  * @base:	base directory to lookup from
  * @len:	maximum length @len should be interpreted to
  *
@@ -2422,7 +2439,7 @@ int vfs_path_lookup(struct dentry *dentry, struct vfsmount *mnt,
  *
  * The caller must hold base->i_mutex.
  */
-struct dentry *lookup_one_len(const char *name, struct dentry *base, int len)
+struct dentry *lookup_one_len2(const char *name, struct vfsmount *mnt, struct dentry *base, int len)
 {
 	struct qstr this;
 	unsigned int c;
@@ -2456,12 +2473,18 @@ struct dentry *lookup_one_len(const char *name, struct dentry *base, int len)
 			return ERR_PTR(err);
 	}
 
-	err = inode_permission(base->d_inode, MAY_EXEC);
+	err = inode_permission2(mnt, base->d_inode, MAY_EXEC);
 	if (err)
 		return ERR_PTR(err);
 
 	return __lookup_hash(&this, base, 0);
 }
+EXPORT_SYMBOL(lookup_one_len2);
+
+struct dentry *lookup_one_len(const char *name, struct dentry *base, int len)
+{
+	return lookup_one_len2(name, NULL, base, len);
+}
 EXPORT_SYMBOL(lookup_one_len);
 
 /**
@@ -2764,7 +2787,7 @@ int __check_sticky(struct inode *dir, struct inode *inode)
  * 11. We don't allow removal of NFS sillyrenamed files; it's handled by
  *     nfs_async_unlink().
  */
-static int may_delete(struct inode *dir, struct dentry *victim, bool isdir)
+static int may_delete(struct vfsmount *mnt, struct inode *dir, struct dentry *victim, bool isdir)
 {
 	struct inode *inode = d_backing_inode(victim);
 	int error;
@@ -2776,7 +2799,7 @@ static int may_delete(struct inode *dir, struct dentry *victim, bool isdir)
 	BUG_ON(victim->d_parent->d_inode != dir);
 	audit_inode_child(dir, victim, AUDIT_TYPE_CHILD_DELETE);
 
-	error = inode_permission(dir, MAY_WRITE | MAY_EXEC);
+	error = inode_permission2(mnt, dir, MAY_WRITE | MAY_EXEC);
 	if (error)
 		return error;
 	if (IS_APPEND(dir))
@@ -2808,7 +2831,7 @@ static int may_delete(struct inode *dir, struct dentry *victim, bool isdir)
  *  4. We should have write and exec permissions on dir
  *  5. We can't do it if dir is immutable (done in permission())
  */
-static inline int may_create(struct inode *dir, struct dentry *child)
+static inline int may_create(struct vfsmount *mnt, struct inode *dir, struct dentry *child)
 {
 	struct user_namespace *s_user_ns;
 	audit_inode_child(dir, child, AUDIT_TYPE_CHILD_CREATE);
@@ -2820,7 +2843,7 @@ static inline int may_create(struct inode *dir, struct dentry *child)
 	if (!kuid_has_mapping(s_user_ns, current_fsuid()) ||
 	    !kgid_has_mapping(s_user_ns, current_fsgid()))
 		return -EOVERFLOW;
-	return inode_permission(dir, MAY_WRITE | MAY_EXEC);
+	return inode_permission2(mnt, dir, MAY_WRITE | MAY_EXEC);
 }
 
 /*
@@ -2867,10 +2890,10 @@ void unlock_rename(struct dentry *p1, struct dentry *p2)
 }
 EXPORT_SYMBOL(unlock_rename);
 
-int vfs_create(struct inode *dir, struct dentry *dentry, umode_t mode,
-		bool want_excl)
+int vfs_create2(struct vfsmount *mnt, struct inode *dir, struct dentry *dentry,
+		umode_t mode, bool want_excl)
 {
-	int error = may_create(dir, dentry);
+	int error = may_create(mnt, dir, dentry);
 	if (error)
 		return error;
 
@@ -2886,6 +2909,13 @@ int vfs_create(struct inode *dir, struct dentry *dentry, umode_t mode,
 		fsnotify_create(dir, dentry);
 	return error;
 }
+EXPORT_SYMBOL(vfs_create2);
+
+int vfs_create(struct inode *dir, struct dentry *dentry, umode_t mode,
+		bool want_excl)
+{
+	return vfs_create2(NULL, dir, dentry, mode, want_excl);
+}
 EXPORT_SYMBOL(vfs_create);
 
 bool may_open_dev(const struct path *path)
@@ -2897,6 +2927,7 @@ bool may_open_dev(const struct path *path)
 static int may_open(struct path *path, int acc_mode, int flag)
 {
 	struct dentry *dentry = path->dentry;
+	struct vfsmount *mnt = path->mnt;
 	struct inode *inode = dentry->d_inode;
 	int error;
 
@@ -2921,7 +2952,7 @@ static int may_open(struct path *path, int acc_mode, int flag)
 		break;
 	}
 
-	error = inode_permission(inode, MAY_OPEN | acc_mode);
+	error = inode_permission2(mnt, inode, MAY_OPEN | acc_mode);
 	if (error)
 		return error;
 
@@ -2956,7 +2987,7 @@ static int handle_truncate(struct file *filp)
 	if (!error)
 		error = security_path_truncate(path);
 	if (!error) {
-		error = do_truncate(path->dentry, 0,
+		error = do_truncate2(path->mnt, path->dentry, 0,
 				    ATTR_MTIME|ATTR_CTIME|ATTR_OPEN,
 				    filp);
 	}
@@ -2983,7 +3014,7 @@ static int may_o_create(const struct path *dir, struct dentry *dentry, umode_t m
 	    !kgid_has_mapping(s_user_ns, current_fsgid()))
 		return -EOVERFLOW;
 
-	error = inode_permission(dir->dentry->d_inode, MAY_WRITE | MAY_EXEC);
+	error = inode_permission2(dir->mnt, dir->dentry->d_inode, MAY_WRITE | MAY_EXEC);
 	if (error)
 		return error;
 
@@ -3414,7 +3445,7 @@ static int do_tmpfile(struct nameidata *nd, unsigned flags,
 		goto out;
 	dir = path.dentry->d_inode;
 	/* we want directory to be writable */
-	error = inode_permission(dir, MAY_WRITE | MAY_EXEC);
+	error = inode_permission2(nd->path.mnt, dir, MAY_WRITE | MAY_EXEC);
 	if (error)
 		goto out2;
 	if (!dir->i_op->tmpfile) {
@@ -3667,9 +3698,9 @@ inline struct dentry *user_path_create(int dfd, const char __user *pathname,
 }
 EXPORT_SYMBOL(user_path_create);
 
-int vfs_mknod(struct inode *dir, struct dentry *dentry, umode_t mode, dev_t dev)
+int vfs_mknod2(struct vfsmount *mnt, struct inode *dir, struct dentry *dentry, umode_t mode, dev_t dev)
 {
-	int error = may_create(dir, dentry);
+	int error = may_create(mnt, dir, dentry);
 
 	if (error)
 		return error;
@@ -3693,6 +3724,12 @@ int vfs_mknod(struct inode *dir, struct dentry *dentry, umode_t mode, dev_t dev)
 		fsnotify_create(dir, dentry);
 	return error;
 }
+EXPORT_SYMBOL(vfs_mknod2);
+
+int vfs_mknod(struct inode *dir, struct dentry *dentry, umode_t mode, dev_t dev)
+{
+	return vfs_mknod2(NULL, dir, dentry, mode, dev);
+}
 EXPORT_SYMBOL(vfs_mknod);
 
 static int may_mknod(umode_t mode)
@@ -3735,12 +3772,12 @@ static int may_mknod(umode_t mode)
 		goto out;
 	switch (mode & S_IFMT) {
 		case 0: case S_IFREG:
-			error = vfs_create(path.dentry->d_inode,dentry,mode,true);
+			error = vfs_create2(path.mnt, path.dentry->d_inode,dentry,mode,true);
 			if (!error)
 				ima_post_path_mknod(dentry);
 			break;
 		case S_IFCHR: case S_IFBLK:
-			error = vfs_mknod(path.dentry->d_inode,dentry,mode,
+			error = vfs_mknod2(path.mnt, path.dentry->d_inode,dentry,mode,
 					new_decode_dev(dev));
 			break;
 		case S_IFIFO: case S_IFSOCK:
@@ -3761,9 +3798,9 @@ static int may_mknod(umode_t mode)
 	return sys_mknodat(AT_FDCWD, filename, mode, dev);
 }
 
-int vfs_mkdir(struct inode *dir, struct dentry *dentry, umode_t mode)
+int vfs_mkdir2(struct vfsmount *mnt, struct inode *dir, struct dentry *dentry, umode_t mode)
 {
-	int error = may_create(dir, dentry);
+	int error = may_create(mnt, dir, dentry);
 	unsigned max_links = dir->i_sb->s_max_links;
 
 	if (error)
@@ -3785,6 +3822,12 @@ int vfs_mkdir(struct inode *dir, struct dentry *dentry, umode_t mode)
 		fsnotify_mkdir(dir, dentry);
 	return error;
 }
+EXPORT_SYMBOL(vfs_mkdir2);
+
+int vfs_mkdir(struct inode *dir, struct dentry *dentry, umode_t mode)
+{
+	return vfs_mkdir2(NULL, dir, dentry, mode);
+}
 EXPORT_SYMBOL(vfs_mkdir);
 
 SYSCALL_DEFINE3(mkdirat, int, dfd, const char __user *, pathname, umode_t, mode)
@@ -3803,7 +3846,7 @@ int vfs_mkdir(struct inode *dir, struct dentry *dentry, umode_t mode)
 		mode &= ~current_umask();
 	error = security_path_mkdir(&path, dentry, mode);
 	if (!error)
-		error = vfs_mkdir(path.dentry->d_inode, dentry, mode);
+		error = vfs_mkdir2(path.mnt, path.dentry->d_inode, dentry, mode);
 	done_path_create(&path, dentry);
 	if (retry_estale(error, lookup_flags)) {
 		lookup_flags |= LOOKUP_REVAL;
@@ -3817,9 +3860,9 @@ int vfs_mkdir(struct inode *dir, struct dentry *dentry, umode_t mode)
 	return sys_mkdirat(AT_FDCWD, pathname, mode);
 }
 
-int vfs_rmdir(struct inode *dir, struct dentry *dentry)
+int vfs_rmdir2(struct vfsmount *mnt, struct inode *dir, struct dentry *dentry)
 {
-	int error = may_delete(dir, dentry, 1);
+	int error = may_delete(mnt, dir, dentry, 1);
 
 	if (error)
 		return error;
@@ -3854,6 +3897,12 @@ int vfs_rmdir(struct inode *dir, struct dentry *dentry)
 		d_delete(dentry);
 	return error;
 }
+EXPORT_SYMBOL(vfs_rmdir2);
+
+int vfs_rmdir(struct inode *dir, struct dentry *dentry)
+{
+	return vfs_rmdir2(NULL, dir, dentry);
+}
 EXPORT_SYMBOL(vfs_rmdir);
 
 static long do_rmdir(int dfd, const char __user *pathname)
@@ -3899,7 +3948,7 @@ static long do_rmdir(int dfd, const char __user *pathname)
 	error = security_path_rmdir(&path, dentry);
 	if (error)
 		goto exit3;
-	error = vfs_rmdir(path.dentry->d_inode, dentry);
+	error = vfs_rmdir2(path.mnt, path.dentry->d_inode, dentry);
 exit3:
 	dput(dentry);
 exit2:
@@ -3938,10 +3987,10 @@ static long do_rmdir(int dfd, const char __user *pathname)
  * be appropriate for callers that expect the underlying filesystem not
  * to be NFS exported.
  */
-int vfs_unlink(struct inode *dir, struct dentry *dentry, struct inode **delegated_inode)
+int vfs_unlink2(struct vfsmount *mnt, struct inode *dir, struct dentry *dentry, struct inode **delegated_inode)
 {
 	struct inode *target = dentry->d_inode;
-	int error = may_delete(dir, dentry, 0);
+	int error = may_delete(mnt, dir, dentry, 0);
 
 	if (error)
 		return error;
@@ -3976,6 +4025,12 @@ int vfs_unlink(struct inode *dir, struct dentry *dentry, struct inode **delegate
 
 	return error;
 }
+EXPORT_SYMBOL(vfs_unlink2);
+
+int vfs_unlink(struct inode *dir, struct dentry *dentry, struct inode **delegated_inode)
+{
+	return vfs_unlink2(NULL, dir, dentry, delegated_inode);
+}
 EXPORT_SYMBOL(vfs_unlink);
 
 /*
@@ -4023,7 +4078,7 @@ static long do_unlinkat(int dfd, const char __user *pathname)
 		error = security_path_unlink(&path, dentry);
 		if (error)
 			goto exit2;
-		error = vfs_unlink(path.dentry->d_inode, dentry, &delegated_inode);
+		error = vfs_unlink2(path.mnt, path.dentry->d_inode, dentry, &delegated_inode);
 exit2:
 		dput(dentry);
 	}
@@ -4073,9 +4128,9 @@ static long do_unlinkat(int dfd, const char __user *pathname)
 	return do_unlinkat(AT_FDCWD, pathname);
 }
 
-int vfs_symlink(struct inode *dir, struct dentry *dentry, const char *oldname)
+int vfs_symlink2(struct vfsmount *mnt, struct inode *dir, struct dentry *dentry, const char *oldname)
 {
-	int error = may_create(dir, dentry);
+	int error = may_create(mnt, dir, dentry);
 
 	if (error)
 		return error;
@@ -4092,6 +4147,12 @@ int vfs_symlink(struct inode *dir, struct dentry *dentry, const char *oldname)
 		fsnotify_create(dir, dentry);
 	return error;
 }
+EXPORT_SYMBOL(vfs_symlink2);
+
+int vfs_symlink(struct inode *dir, struct dentry *dentry, const char *oldname)
+{
+	return vfs_symlink2(NULL, dir, dentry, oldname);
+}
 EXPORT_SYMBOL(vfs_symlink);
 
 SYSCALL_DEFINE3(symlinkat, const char __user *, oldname,
@@ -4114,7 +4175,7 @@ int vfs_symlink(struct inode *dir, struct dentry *dentry, const char *oldname)
 
 	error = security_path_symlink(&path, dentry, from->name);
 	if (!error)
-		error = vfs_symlink(path.dentry->d_inode, dentry, from->name);
+		error = vfs_symlink2(path.mnt, path.dentry->d_inode, dentry, from->name);
 	done_path_create(&path, dentry);
 	if (retry_estale(error, lookup_flags)) {
 		lookup_flags |= LOOKUP_REVAL;
@@ -4149,7 +4210,7 @@ int vfs_symlink(struct inode *dir, struct dentry *dentry, const char *oldname)
  * be appropriate for callers that expect the underlying filesystem not
  * to be NFS exported.
  */
-int vfs_link(struct dentry *old_dentry, struct inode *dir, struct dentry *new_dentry, struct inode **delegated_inode)
+int vfs_link2(struct vfsmount *mnt, struct dentry *old_dentry, struct inode *dir, struct dentry *new_dentry, struct inode **delegated_inode)
 {
 	struct inode *inode = old_dentry->d_inode;
 	unsigned max_links = dir->i_sb->s_max_links;
@@ -4158,7 +4219,7 @@ int vfs_link(struct dentry *old_dentry, struct inode *dir, struct dentry *new_de
 	if (!inode)
 		return -ENOENT;
 
-	error = may_create(dir, new_dentry);
+	error = may_create(mnt, dir, new_dentry);
 	if (error)
 		return error;
 
@@ -4208,6 +4269,12 @@ int vfs_link(struct dentry *old_dentry, struct inode *dir, struct dentry *new_de
 		fsnotify_link(dir, inode, new_dentry);
 	return error;
 }
+EXPORT_SYMBOL(vfs_link2);
+
+int vfs_link(struct dentry *old_dentry, struct inode *dir, struct dentry *new_dentry, struct inode **delegated_inode)
+{
+	return vfs_link2(NULL, old_dentry, dir, new_dentry, delegated_inode);
+}
 EXPORT_SYMBOL(vfs_link);
 
 /*
@@ -4263,7 +4330,7 @@ int vfs_link(struct dentry *old_dentry, struct inode *dir, struct dentry *new_de
 	error = security_path_link(old_path.dentry, &new_path, new_dentry);
 	if (error)
 		goto out_dput;
-	error = vfs_link(old_path.dentry, new_path.dentry->d_inode, new_dentry, &delegated_inode);
+	error = vfs_link2(old_path.mnt, old_path.dentry, new_path.dentry->d_inode, new_dentry, &delegated_inode);
 out_dput:
 	done_path_create(&new_path, new_dentry);
 	if (delegated_inode) {
@@ -4338,7 +4405,8 @@ int vfs_link(struct dentry *old_dentry, struct inode *dir, struct dentry *new_de
  *	   ->i_mutex on parents, which works but leads to some truly excessive
  *	   locking].
  */
-int vfs_rename(struct inode *old_dir, struct dentry *old_dentry,
+int vfs_rename2(struct vfsmount *mnt,
+	       struct inode *old_dir, struct dentry *old_dentry,
 	       struct inode *new_dir, struct dentry *new_dentry,
 	       struct inode **delegated_inode, unsigned int flags)
 {
@@ -4357,19 +4425,19 @@ int vfs_rename(struct inode *old_dir, struct dentry *old_dentry,
 	if (d_real_inode(old_dentry) == d_real_inode(new_dentry))
 		return 0;
 
-	error = may_delete(old_dir, old_dentry, is_dir);
+	error = may_delete(mnt, old_dir, old_dentry, is_dir);
 	if (error)
 		return error;
 
 	if (!target) {
-		error = may_create(new_dir, new_dentry);
+		error = may_create(mnt, new_dir, new_dentry);
 	} else {
 		new_is_dir = d_is_dir(new_dentry);
 
 		if (!(flags & RENAME_EXCHANGE))
-			error = may_delete(new_dir, new_dentry, is_dir);
+			error = may_delete(mnt, new_dir, new_dentry, is_dir);
 		else
-			error = may_delete(new_dir, new_dentry, new_is_dir);
+			error = may_delete(mnt, new_dir, new_dentry, new_is_dir);
 	}
 	if (error)
 		return error;
@@ -4383,12 +4451,12 @@ int vfs_rename(struct inode *old_dir, struct dentry *old_dentry,
 	 */
 	if (new_dir != old_dir) {
 		if (is_dir) {
-			error = inode_permission(source, MAY_WRITE);
+			error = inode_permission2(mnt, source, MAY_WRITE);
 			if (error)
 				return error;
 		}
 		if ((flags & RENAME_EXCHANGE) && new_is_dir) {
-			error = inode_permission(target, MAY_WRITE);
+			error = inode_permission2(mnt, target, MAY_WRITE);
 			if (error)
 				return error;
 		}
@@ -4465,6 +4533,14 @@ int vfs_rename(struct inode *old_dir, struct dentry *old_dentry,
 
 	return error;
 }
+EXPORT_SYMBOL(vfs_rename2);
+
+int vfs_rename(struct inode *old_dir, struct dentry *old_dentry,
+	       struct inode *new_dir, struct dentry *new_dentry,
+	       struct inode **delegated_inode, unsigned int flags)
+{
+	return vfs_rename2(NULL, old_dir, old_dentry, new_dir, new_dentry, delegated_inode, flags);
+}
 EXPORT_SYMBOL(vfs_rename);
 
 SYSCALL_DEFINE5(renameat2, int, olddfd, const char __user *, oldname,
@@ -4578,7 +4654,7 @@ int vfs_rename(struct inode *old_dir, struct dentry *old_dentry,
 				     &new_path, new_dentry, flags);
 	if (error)
 		goto exit5;
-	error = vfs_rename(old_path.dentry->d_inode, old_dentry,
+	error = vfs_rename2(old_path.mnt, old_path.dentry->d_inode, old_dentry,
 			   new_path.dentry->d_inode, new_dentry,
 			   &delegated_inode, flags);
 exit5:
@@ -4623,7 +4699,7 @@ int vfs_rename(struct inode *old_dir, struct dentry *old_dentry,
 
 int vfs_whiteout(struct inode *dir, struct dentry *dentry)
 {
-	int error = may_create(dir, dentry);
+	int error = may_create(NULL, dir, dentry);
 	if (error)
 		return error;
 
diff --git a/fs/namespace.c b/fs/namespace.c
index 6c873b3..4628d08c 100644
--- a/fs/namespace.c
+++ b/fs/namespace.c
@@ -227,6 +227,7 @@ static struct mount *alloc_vfsmnt(const char *name)
 		mnt->mnt_count = 1;
 		mnt->mnt_writers = 0;
 #endif
+		mnt->mnt.data = NULL;
 
 		INIT_HLIST_NODE(&mnt->mnt_hash);
 		INIT_LIST_HEAD(&mnt->mnt_child);
@@ -581,6 +582,7 @@ int sb_prepare_remount_readonly(struct super_block *sb)
 
 static void free_vfsmnt(struct mount *mnt)
 {
+	kfree(mnt->mnt.data);
 	kfree_const(mnt->mnt_devname);
 #ifdef CONFIG_SMP
 	free_percpu(mnt->mnt_pcp);
@@ -975,10 +977,18 @@ struct vfsmount *
 	if (!mnt)
 		return ERR_PTR(-ENOMEM);
 
+	if (type->alloc_mnt_data) {
+		mnt->mnt.data = type->alloc_mnt_data();
+		if (!mnt->mnt.data) {
+			mnt_free_id(mnt);
+			free_vfsmnt(mnt);
+			return ERR_PTR(-ENOMEM);
+		}
+	}
 	if (flags & MS_KERNMOUNT)
 		mnt->mnt.mnt_flags = MNT_INTERNAL;
 
-	root = mount_fs(type, flags, name, data);
+	root = mount_fs(type, flags, name, &mnt->mnt, data);
 	if (IS_ERR(root)) {
 		mnt_free_id(mnt);
 		free_vfsmnt(mnt);
@@ -1022,6 +1032,14 @@ static struct mount *clone_mnt(struct mount *old, struct dentry *root,
 	if (!mnt)
 		return ERR_PTR(-ENOMEM);
 
+	if (sb->s_op->clone_mnt_data) {
+		mnt->mnt.data = sb->s_op->clone_mnt_data(old->mnt.data);
+		if (!mnt->mnt.data) {
+			err = -ENOMEM;
+			goto out_free;
+		}
+	}
+
 	if (flag & (CL_SLAVE | CL_PRIVATE | CL_SHARED_TO_SLAVE))
 		mnt->mnt_group_id = 0; /* not a peer of original */
 	else
@@ -2306,8 +2324,14 @@ static int do_remount(struct path *path, int flags, int mnt_flags,
 		err = change_mount_flags(path->mnt, flags);
 	else if (!capable(CAP_SYS_ADMIN))
 		err = -EPERM;
-	else
-		err = do_remount_sb(sb, flags, data, 0);
+	else {
+		err = do_remount_sb2(path->mnt, sb, flags, data, 0);
+		namespace_lock();
+		lock_mount_hash();
+		propagate_remount(mnt);
+		unlock_mount_hash();
+		namespace_unlock();
+	}
 	if (!err) {
 		lock_mount_hash();
 		mnt_flags |= mnt->mnt.mnt_flags & ~MNT_USER_SETTABLE_MASK;
diff --git a/fs/nfs/nfs4idmap.c b/fs/nfs/nfs4idmap.c
index 3d4602d6..b5f02f1 100644
--- a/fs/nfs/nfs4idmap.c
+++ b/fs/nfs/nfs4idmap.c
@@ -316,7 +316,7 @@ static ssize_t nfs_idmap_get_key(const char *name, size_t namelen,
 	if (ret < 0)
 		goto out_up;
 
-	payload = user_key_payload(rkey);
+	payload = user_key_payload_rcu(rkey);
 	if (IS_ERR_OR_NULL(payload)) {
 		ret = PTR_ERR(payload);
 		goto out_up;
diff --git a/fs/nfs/read.c b/fs/nfs/read.c
index defc923..67b8000 100644
--- a/fs/nfs/read.c
+++ b/fs/nfs/read.c
@@ -346,7 +346,7 @@ struct nfs_readdesc {
 };
 
 static int
-readpage_async_filler(void *data, struct page *page)
+readpage_async_filler(struct file *data, struct page *page)
 {
 	struct nfs_readdesc *desc = (struct nfs_readdesc *)data;
 	struct nfs_page *new;
diff --git a/fs/nilfs2/btree.c b/fs/nilfs2/btree.c
index 2e315f9..ac1ec8f 100644
--- a/fs/nilfs2/btree.c
+++ b/fs/nilfs2/btree.c
@@ -2158,8 +2158,8 @@ static void nilfs_btree_lookup_dirty_buffers(struct nilfs_bmap *btree,
 
 	pagevec_init(&pvec, 0);
 
-	while (pagevec_lookup_tag(&pvec, btcache, &index, PAGECACHE_TAG_DIRTY,
-				  PAGEVEC_SIZE)) {
+	while (pagevec_lookup_tag(&pvec, btcache, &index,
+					PAGECACHE_TAG_DIRTY)) {
 		for (i = 0; i < pagevec_count(&pvec); i++) {
 			bh = head = page_buffers(pvec.pages[i]);
 			do {
diff --git a/fs/nilfs2/page.c b/fs/nilfs2/page.c
index f11a3ad..454ee52 100644
--- a/fs/nilfs2/page.c
+++ b/fs/nilfs2/page.c
@@ -257,8 +257,7 @@ int nilfs_copy_dirty_pages(struct address_space *dmap,
 
 	pagevec_init(&pvec, 0);
 repeat:
-	if (!pagevec_lookup_tag(&pvec, smap, &index, PAGECACHE_TAG_DIRTY,
-				PAGEVEC_SIZE))
+	if (!pagevec_lookup_tag(&pvec, smap, &index, PAGECACHE_TAG_DIRTY))
 		return 0;
 
 	for (i = 0; i < pagevec_count(&pvec); i++) {
@@ -377,8 +376,8 @@ void nilfs_clear_dirty_pages(struct address_space *mapping, bool silent)
 
 	pagevec_init(&pvec, 0);
 
-	while (pagevec_lookup_tag(&pvec, mapping, &index, PAGECACHE_TAG_DIRTY,
-				  PAGEVEC_SIZE)) {
+	while (pagevec_lookup_tag(&pvec, mapping, &index,
+					PAGECACHE_TAG_DIRTY)) {
 		for (i = 0; i < pagevec_count(&pvec); i++) {
 			struct page *page = pvec.pages[i];
 
diff --git a/fs/nilfs2/segment.c b/fs/nilfs2/segment.c
index 36362d4..b0eb58c 100644
--- a/fs/nilfs2/segment.c
+++ b/fs/nilfs2/segment.c
@@ -709,18 +709,14 @@ static size_t nilfs_lookup_dirty_data_buffers(struct inode *inode,
 	pagevec_init(&pvec, 0);
  repeat:
 	if (unlikely(index > last) ||
-	    !pagevec_lookup_tag(&pvec, mapping, &index, PAGECACHE_TAG_DIRTY,
-				min_t(pgoff_t, last - index,
-				      PAGEVEC_SIZE - 1) + 1))
+	    !pagevec_lookup_range_tag(&pvec, mapping, &index, last,
+				PAGECACHE_TAG_DIRTY))
 		return ndirties;
 
 	for (i = 0; i < pagevec_count(&pvec); i++) {
 		struct buffer_head *bh, *head;
 		struct page *page = pvec.pages[i];
 
-		if (unlikely(page->index > last))
-			break;
-
 		lock_page(page);
 		if (!page_has_buffers(page))
 			create_empty_buffers(page, i_blocksize(inode), 0);
@@ -757,8 +753,8 @@ static void nilfs_lookup_dirty_node_buffers(struct inode *inode,
 
 	pagevec_init(&pvec, 0);
 
-	while (pagevec_lookup_tag(&pvec, mapping, &index, PAGECACHE_TAG_DIRTY,
-				  PAGEVEC_SIZE)) {
+	while (pagevec_lookup_tag(&pvec, mapping, &index,
+					PAGECACHE_TAG_DIRTY)) {
 		for (i = 0; i < pagevec_count(&pvec); i++) {
 			bh = head = page_buffers(pvec.pages[i]);
 			do {
diff --git a/fs/notify/fanotify/fanotify_user.c b/fs/notify/fanotify/fanotify_user.c
index 258e8f6..cef9885 100644
--- a/fs/notify/fanotify/fanotify_user.c
+++ b/fs/notify/fanotify/fanotify_user.c
@@ -498,7 +498,7 @@ static int fanotify_find_path(int dfd, const char __user *filename,
 	}
 
 	/* you can only watch an inode if you have read permissions on it */
-	ret = inode_permission(path->dentry->d_inode, MAY_READ);
+	ret = inode_permission2(path->mnt, path->dentry->d_inode, MAY_READ);
 	if (ret)
 		path_put(path);
 out:
diff --git a/fs/notify/inotify/inotify_user.c b/fs/notify/inotify/inotify_user.c
index 69d1ea3..4da5c6a 100644
--- a/fs/notify/inotify/inotify_user.c
+++ b/fs/notify/inotify/inotify_user.c
@@ -337,7 +337,7 @@ static int inotify_find_inode(const char __user *dirname, struct path *path, uns
 	if (error)
 		return error;
 	/* you can only watch an inode if you have read permissions on it */
-	error = inode_permission(path->dentry->d_inode, MAY_READ);
+	error = inode_permission2(path->mnt, path->dentry->d_inode, MAY_READ);
 	if (error)
 		path_put(path);
 	return error;
@@ -702,6 +702,8 @@ static struct fsnotify_group *inotify_new_group(unsigned int max_events)
 	struct fsnotify_group *group;
 	struct inode *inode;
 	struct path path;
+	struct path alteredpath;
+	struct path *canonical_path = &path;
 	struct fd f;
 	int ret;
 	unsigned flags = 0;
@@ -741,13 +743,22 @@ static struct fsnotify_group *inotify_new_group(unsigned int max_events)
 	if (ret)
 		goto fput_and_out;
 
+	/* support stacked filesystems */
+	if(path.dentry && path.dentry->d_op) {
+		if (path.dentry->d_op->d_canonical_path) {
+			path.dentry->d_op->d_canonical_path(&path, &alteredpath);
+			canonical_path = &alteredpath;
+			path_put(&path);
+		}
+	}
+
 	/* inode held in place by reference to path; group by fget on fd */
-	inode = path.dentry->d_inode;
+	inode = canonical_path->dentry->d_inode;
 	group = f.file->private_data;
 
 	/* create/update an inode mark */
 	ret = inotify_update_watch(group, inode, mask);
-	path_put(&path);
+	path_put(canonical_path);
 fput_and_out:
 	fdput(f);
 	return ret;
diff --git a/fs/ocfs2/dlmfs/dlmfs.c b/fs/ocfs2/dlmfs/dlmfs.c
index 1079fae..47e08e4 100644
--- a/fs/ocfs2/dlmfs/dlmfs.c
+++ b/fs/ocfs2/dlmfs/dlmfs.c
@@ -88,13 +88,13 @@
  */
 #define DLMFS_CAPABILITIES "bast stackglue"
 static int param_set_dlmfs_capabilities(const char *val,
-					struct kernel_param *kp)
+					const struct kernel_param *kp)
 {
 	printk(KERN_ERR "%s: readonly parameter\n", kp->name);
 	return -EINVAL;
 }
 static int param_get_dlmfs_capabilities(char *buffer,
-					struct kernel_param *kp)
+					const struct kernel_param *kp)
 {
 	return strlcpy(buffer, DLMFS_CAPABILITIES,
 		       strlen(DLMFS_CAPABILITIES) + 1);
diff --git a/fs/open.c b/fs/open.c
index a6c6244..73b7d19 100644
--- a/fs/open.c
+++ b/fs/open.c
@@ -34,8 +34,8 @@
 
 #include "internal.h"
 
-int do_truncate(struct dentry *dentry, loff_t length, unsigned int time_attrs,
-	struct file *filp)
+int do_truncate2(struct vfsmount *mnt, struct dentry *dentry, loff_t length,
+		unsigned int time_attrs, struct file *filp)
 {
 	int ret;
 	struct iattr newattrs;
@@ -60,18 +60,25 @@ int do_truncate(struct dentry *dentry, loff_t length, unsigned int time_attrs,
 
 	inode_lock(dentry->d_inode);
 	/* Note any delegations or leases have already been broken: */
-	ret = notify_change(dentry, &newattrs, NULL);
+	ret = notify_change2(mnt, dentry, &newattrs, NULL);
 	inode_unlock(dentry->d_inode);
 	return ret;
 }
+int do_truncate(struct dentry *dentry, loff_t length, unsigned int time_attrs,
+	struct file *filp)
+{
+	return do_truncate2(NULL, dentry, length, time_attrs, filp);
+}
 
 long vfs_truncate(const struct path *path, loff_t length)
 {
 	struct inode *inode;
+	struct vfsmount *mnt;
 	struct dentry *upperdentry;
 	long error;
 
 	inode = path->dentry->d_inode;
+	mnt = path->mnt;
 
 	/* For directories it's -EISDIR, for other non-regulars - -EINVAL */
 	if (S_ISDIR(inode->i_mode))
@@ -83,7 +90,7 @@ long vfs_truncate(const struct path *path, loff_t length)
 	if (error)
 		goto out;
 
-	error = inode_permission(inode, MAY_WRITE);
+	error = inode_permission2(mnt, inode, MAY_WRITE);
 	if (error)
 		goto mnt_drop_write_and_out;
 
@@ -117,7 +124,7 @@ long vfs_truncate(const struct path *path, loff_t length)
 	if (!error)
 		error = security_path_truncate(path);
 	if (!error)
-		error = do_truncate(path->dentry, length, 0, NULL);
+		error = do_truncate2(mnt, path->dentry, length, 0, NULL);
 
 put_write_and_out:
 	put_write_access(upperdentry->d_inode);
@@ -166,6 +173,7 @@ static long do_sys_ftruncate(unsigned int fd, loff_t length, int small)
 {
 	struct inode *inode;
 	struct dentry *dentry;
+	struct vfsmount *mnt;
 	struct fd f;
 	int error;
 
@@ -182,6 +190,7 @@ static long do_sys_ftruncate(unsigned int fd, loff_t length, int small)
 		small = 0;
 
 	dentry = f.file->f_path.dentry;
+	mnt = f.file->f_path.mnt;
 	inode = dentry->d_inode;
 	error = -EINVAL;
 	if (!S_ISREG(inode->i_mode) || !(f.file->f_mode & FMODE_WRITE))
@@ -201,7 +210,7 @@ static long do_sys_ftruncate(unsigned int fd, loff_t length, int small)
 	if (!error)
 		error = security_path_truncate(&f.file->f_path);
 	if (!error)
-		error = do_truncate(dentry, length, ATTR_MTIME|ATTR_CTIME, f.file);
+		error = do_truncate2(mnt, dentry, length, ATTR_MTIME|ATTR_CTIME, f.file);
 	sb_end_write(inode->i_sb);
 out_putf:
 	fdput(f);
@@ -357,6 +366,7 @@ int vfs_fallocate(struct file *file, int mode, loff_t offset, loff_t len)
 	struct cred *override_cred;
 	struct path path;
 	struct inode *inode;
+	struct vfsmount *mnt;
 	int res;
 	unsigned int lookup_flags = LOOKUP_FOLLOW;
 
@@ -387,6 +397,7 @@ int vfs_fallocate(struct file *file, int mode, loff_t offset, loff_t len)
 		goto out;
 
 	inode = d_backing_inode(path.dentry);
+	mnt = path.mnt;
 
 	if ((mode & MAY_EXEC) && S_ISREG(inode->i_mode)) {
 		/*
@@ -398,7 +409,7 @@ int vfs_fallocate(struct file *file, int mode, loff_t offset, loff_t len)
 			goto out_path_release;
 	}
 
-	res = inode_permission(inode, mode | MAY_ACCESS);
+	res = inode_permission2(mnt, inode, mode | MAY_ACCESS);
 	/* SuS v2 requires we report a read only fs too */
 	if (res || !(mode & S_IWOTH) || special_file(inode->i_mode))
 		goto out_path_release;
@@ -442,7 +453,7 @@ int vfs_fallocate(struct file *file, int mode, loff_t offset, loff_t len)
 	if (error)
 		goto out;
 
-	error = inode_permission(path.dentry->d_inode, MAY_EXEC | MAY_CHDIR);
+	error = inode_permission2(path.mnt, path.dentry->d_inode, MAY_EXEC | MAY_CHDIR);
 	if (error)
 		goto dput_and_out;
 
@@ -462,6 +473,7 @@ int vfs_fallocate(struct file *file, int mode, loff_t offset, loff_t len)
 {
 	struct fd f = fdget_raw(fd);
 	struct inode *inode;
+	struct vfsmount *mnt;
 	int error = -EBADF;
 
 	error = -EBADF;
@@ -469,12 +481,13 @@ int vfs_fallocate(struct file *file, int mode, loff_t offset, loff_t len)
 		goto out;
 
 	inode = file_inode(f.file);
+	mnt = f.file->f_path.mnt;
 
 	error = -ENOTDIR;
 	if (!S_ISDIR(inode->i_mode))
 		goto out_putf;
 
-	error = inode_permission(inode, MAY_EXEC | MAY_CHDIR);
+	error = inode_permission2(mnt, inode, MAY_EXEC | MAY_CHDIR);
 	if (!error)
 		set_fs_pwd(current->fs, &f.file->f_path);
 out_putf:
@@ -493,7 +506,7 @@ int vfs_fallocate(struct file *file, int mode, loff_t offset, loff_t len)
 	if (error)
 		goto out;
 
-	error = inode_permission(path.dentry->d_inode, MAY_EXEC | MAY_CHDIR);
+	error = inode_permission2(path.mnt, path.dentry->d_inode, MAY_EXEC | MAY_CHDIR);
 	if (error)
 		goto dput_and_out;
 
@@ -533,7 +546,7 @@ static int chmod_common(const struct path *path, umode_t mode)
 		goto out_unlock;
 	newattrs.ia_mode = (mode & S_IALLUGO) | (inode->i_mode & ~S_IALLUGO);
 	newattrs.ia_valid = ATTR_MODE | ATTR_CTIME;
-	error = notify_change(path->dentry, &newattrs, &delegated_inode);
+	error = notify_change2(path->mnt, path->dentry, &newattrs, &delegated_inode);
 out_unlock:
 	inode_unlock(inode);
 	if (delegated_inode) {
@@ -613,7 +626,7 @@ static int chown_common(const struct path *path, uid_t user, gid_t group)
 	inode_lock(inode);
 	error = security_path_chown(path, uid, gid);
 	if (!error)
-		error = notify_change(path->dentry, &newattrs, &delegated_inode);
+		error = notify_change2(path->mnt, path->dentry, &newattrs, &delegated_inode);
 	inode_unlock(inode);
 	if (delegated_inode) {
 		error = break_deleg_wait(&delegated_inode);
diff --git a/fs/pnode.c b/fs/pnode.c
index d15c63e..ddb846f8 100644
--- a/fs/pnode.c
+++ b/fs/pnode.c
@@ -609,3 +609,37 @@ int propagate_umount(struct list_head *list)
 
 	return 0;
 }
+
+/*
+ *  Iterates over all slaves, and slaves of slaves.
+ */
+static struct mount *next_descendent(struct mount *root, struct mount *cur)
+{
+	if (!IS_MNT_NEW(cur) && !list_empty(&cur->mnt_slave_list))
+		return first_slave(cur);
+	do {
+		struct mount *master = cur->mnt_master;
+
+		if (!master || cur->mnt_slave.next != &master->mnt_slave_list) {
+			struct mount *next = next_slave(cur);
+
+			return (next == root) ? NULL : next;
+		}
+		cur = master;
+	} while (cur != root);
+	return NULL;
+}
+
+void propagate_remount(struct mount *mnt)
+{
+	struct mount *m = mnt;
+	struct super_block *sb = mnt->mnt.mnt_sb;
+
+	if (sb->s_op->copy_mnt_data) {
+		m = next_descendent(mnt, m);
+		while (m) {
+			sb->s_op->copy_mnt_data(m->mnt.data, mnt->mnt.data);
+			m = next_descendent(mnt, m);
+		}
+	}
+}
diff --git a/fs/pnode.h b/fs/pnode.h
index dc87e65..a9a6576 100644
--- a/fs/pnode.h
+++ b/fs/pnode.h
@@ -44,6 +44,7 @@ int propagate_mnt(struct mount *, struct mountpoint *, struct mount *,
 int propagate_umount(struct list_head *);
 int propagate_mount_busy(struct mount *, int);
 void propagate_mount_unlock(struct mount *);
+void propagate_remount(struct mount *);
 void mnt_release_group_id(struct mount *);
 int get_dominating_id(struct mount *mnt, const struct path *root);
 unsigned int mnt_get_count(struct mount *mnt);
diff --git a/fs/proc/Kconfig b/fs/proc/Kconfig
index 1ade120..08dce22 100644
--- a/fs/proc/Kconfig
+++ b/fs/proc/Kconfig
@@ -81,3 +81,10 @@ config PROC_CHILDREN
 
 	  Say Y if you are running any user-space software which takes benefit from
 	  this interface. For example, rkt is such a piece of software.
+
+config PROC_UID
+	bool "Include /proc/uid/ files"
+	default y
+	depends on PROC_FS && RT_MUTEXES
+	help
+	Provides aggregated per-uid information under /proc/uid.
diff --git a/fs/proc/Makefile b/fs/proc/Makefile
index 12c6922..dea53ba 100644
--- a/fs/proc/Makefile
+++ b/fs/proc/Makefile
@@ -25,6 +25,7 @@ proc-y	+= softirqs.o
 proc-y	+= namespaces.o
 proc-y	+= self.o
 proc-y	+= thread_self.o
+proc-$(CONFIG_PROC_UID)  += uid.o
 proc-$(CONFIG_PROC_SYSCTL)	+= proc_sysctl.o
 proc-$(CONFIG_NET)		+= proc_net.o
 proc-$(CONFIG_PROC_KCORE)	+= kcore.o
diff --git a/fs/proc/base.c b/fs/proc/base.c
index 591bf2b..9223080 100644
--- a/fs/proc/base.c
+++ b/fs/proc/base.c
@@ -87,6 +87,7 @@
 #include <linux/slab.h>
 #include <linux/flex_array.h>
 #include <linux/posix-timers.h>
+#include <linux/cpufreq_times.h>
 #ifdef CONFIG_HARDWALL
 #include <asm/hardwall.h>
 #endif
@@ -2967,6 +2968,9 @@ static int proc_pid_personality(struct seq_file *m, struct pid_namespace *ns,
 	REG("timers",	  S_IRUGO, proc_timers_operations),
 #endif
 	REG("timerslack_ns", S_IRUGO|S_IWUGO, proc_pid_set_timerslack_ns_operations),
+#ifdef CONFIG_CPU_FREQ_TIMES
+	ONE("time_in_state", 0444, proc_time_in_state_show),
+#endif
 };
 
 static int proc_tgid_base_readdir(struct file *file, struct dir_context *ctx)
@@ -3351,6 +3355,9 @@ static int proc_tid_comm_permission(struct inode *inode, int mask)
 	REG("projid_map", S_IRUGO|S_IWUSR, proc_projid_map_operations),
 	REG("setgroups",  S_IRUGO|S_IWUSR, proc_setgroups_operations),
 #endif
+#ifdef CONFIG_CPU_FREQ_TIMES
+	ONE("time_in_state", 0444, proc_time_in_state_show),
+#endif
 };
 
 static int proc_tid_base_readdir(struct file *file, struct dir_context *ctx)
diff --git a/fs/proc/internal.h b/fs/proc/internal.h
index 5378441..288a7ea 100644
--- a/fs/proc/internal.h
+++ b/fs/proc/internal.h
@@ -256,6 +256,15 @@ static inline void sysctl_head_put(struct ctl_table_header *head) { }
 #endif
 
 /*
+ * uid.c
+ */
+#ifdef CONFIG_PROC_UID
+extern int proc_uid_init(void);
+#else
+static inline void proc_uid_init(void) { }
+#endif
+
+/*
  * proc_tty.c
  */
 #ifdef CONFIG_TTY
diff --git a/fs/proc/meminfo.c b/fs/proc/meminfo.c
index 8a42849..7417951 100644
--- a/fs/proc/meminfo.c
+++ b/fs/proc/meminfo.c
@@ -152,6 +152,8 @@ static int meminfo_proc_show(struct seq_file *m, void *v)
 	show_val_kb(m, "CmaTotal:       ", totalcma_pages);
 	show_val_kb(m, "CmaFree:        ",
 		    global_page_state(NR_FREE_CMA_PAGES));
+	seq_printf(m, "cma_area_count: %d\n", cma_area_count);
+	seq_printf(m, "MAX_CMA_AREAS: %d\n", MAX_CMA_AREAS);
 #endif
 
 	hugetlb_report_meminfo(m);
diff --git a/fs/proc/root.c b/fs/proc/root.c
index 8d3e484..c2f5014 100644
--- a/fs/proc/root.c
+++ b/fs/proc/root.c
@@ -131,7 +131,7 @@ void __init proc_root_init(void)
 	proc_symlink("mounts", NULL, "self/mounts");
 
 	proc_net_init();
-
+	proc_uid_init();
 #ifdef CONFIG_SYSVIPC
 	proc_mkdir("sysvipc", NULL);
 #endif
diff --git a/fs/proc/task_mmu.c b/fs/proc/task_mmu.c
index 5138e78..6f50f01 100644
--- a/fs/proc/task_mmu.c
+++ b/fs/proc/task_mmu.c
@@ -127,6 +127,56 @@ static void release_task_mempolicy(struct proc_maps_private *priv)
 }
 #endif
 
+static void seq_print_vma_name(struct seq_file *m, struct vm_area_struct *vma)
+{
+	const char __user *name = vma_get_anon_name(vma);
+	struct mm_struct *mm = vma->vm_mm;
+
+	unsigned long page_start_vaddr;
+	unsigned long page_offset;
+	unsigned long num_pages;
+	unsigned long max_len = NAME_MAX;
+	int i;
+
+	page_start_vaddr = (unsigned long)name & PAGE_MASK;
+	page_offset = (unsigned long)name - page_start_vaddr;
+	num_pages = DIV_ROUND_UP(page_offset + max_len, PAGE_SIZE);
+
+	seq_puts(m, "[anon:");
+
+	for (i = 0; i < num_pages; i++) {
+		int len;
+		int write_len;
+		const char *kaddr;
+		long pages_pinned;
+		struct page *page;
+
+		pages_pinned = get_user_pages_remote(current, mm,
+				page_start_vaddr, 1, 0, &page, NULL);
+		if (pages_pinned < 1) {
+			seq_puts(m, "<fault>]");
+			return;
+		}
+
+		kaddr = (const char *)kmap(page);
+		len = min(max_len, PAGE_SIZE - page_offset);
+		write_len = strnlen(kaddr + page_offset, len);
+		seq_write(m, kaddr + page_offset, write_len);
+		kunmap(page);
+		put_page(page);
+
+		/* if strnlen hit a null terminator then we're done */
+		if (write_len != len)
+			break;
+
+		max_len -= len;
+		page_offset = 0;
+		page_start_vaddr += PAGE_SIZE;
+	}
+
+	seq_putc(m, ']');
+}
+
 static void vma_stop(struct proc_maps_private *priv)
 {
 	struct mm_struct *mm = priv->mm;
@@ -341,8 +391,15 @@ static int is_stack(struct proc_maps_private *priv,
 			goto done;
 		}
 
-		if (is_stack(priv, vma))
+		if (is_stack(priv, vma)) {
 			name = "[stack]";
+			goto done;
+		}
+
+		if (vma_get_anon_name(vma)) {
+			seq_pad(m, ' ');
+			seq_print_vma_name(m, vma);
+		}
 	}
 
 done:
@@ -756,6 +813,12 @@ static int show_smap(struct seq_file *m, void *v, int is_pid)
 
 	show_map_vma(m, vma, is_pid);
 
+	if (vma_get_anon_name(vma)) {
+		seq_puts(m, "Name:           ");
+		seq_print_vma_name(m, vma);
+		seq_putc(m, '\n');
+	}
+
 	seq_printf(m,
 		   "Size:           %8lu kB\n"
 		   "Rss:            %8lu kB\n"
@@ -1437,6 +1500,10 @@ static ssize_t pagemap_read(struct file *file, char __user *buf,
 
 static int pagemap_open(struct inode *inode, struct file *file)
 {
+	/* do not disclose physical addresses: attack vector */
+	if (!capable(CAP_SYS_ADMIN))
+		return -EPERM;
+
 	struct mm_struct *mm;
 
 	mm = proc_mem_open(inode, PTRACE_MODE_READ);
diff --git a/fs/proc/uid.c b/fs/proc/uid.c
new file mode 100644
index 00000000..b2bb085
--- /dev/null
+++ b/fs/proc/uid.c
@@ -0,0 +1,295 @@
+/*
+ * /proc/uid support
+ */
+
+#include <linux/cpufreq_times.h>
+#include <linux/fs.h>
+#include <linux/hashtable.h>
+#include <linux/init.h>
+#include <linux/proc_fs.h>
+#include <linux/rtmutex.h>
+#include <linux/sched.h>
+#include <linux/seq_file.h>
+#include <linux/slab.h>
+#include "internal.h"
+
+static struct proc_dir_entry *proc_uid;
+
+#define UID_HASH_BITS 10
+
+static DECLARE_HASHTABLE(proc_uid_hash_table, UID_HASH_BITS);
+
+/*
+ * use rt_mutex here to avoid priority inversion between high-priority readers
+ * of these files and tasks calling proc_register_uid().
+ */
+static DEFINE_RT_MUTEX(proc_uid_lock); /* proc_uid_hash_table */
+
+struct uid_hash_entry {
+	uid_t uid;
+	struct hlist_node hash;
+};
+
+/* Caller must hold proc_uid_lock */
+static bool uid_hash_entry_exists_locked(uid_t uid)
+{
+	struct uid_hash_entry *entry;
+
+	hash_for_each_possible(proc_uid_hash_table, entry, hash, uid) {
+		if (entry->uid == uid)
+			return true;
+	}
+	return false;
+}
+
+void proc_register_uid(kuid_t kuid)
+{
+	struct uid_hash_entry *entry;
+	bool exists;
+	uid_t uid = from_kuid_munged(current_user_ns(), kuid);
+
+	rt_mutex_lock(&proc_uid_lock);
+	exists = uid_hash_entry_exists_locked(uid);
+	rt_mutex_unlock(&proc_uid_lock);
+	if (exists)
+		return;
+
+	entry = kzalloc(sizeof(struct uid_hash_entry), GFP_KERNEL);
+	if (!entry)
+		return;
+	entry->uid = uid;
+
+	rt_mutex_lock(&proc_uid_lock);
+	if (uid_hash_entry_exists_locked(uid))
+		kfree(entry);
+	else
+		hash_add(proc_uid_hash_table, &entry->hash, uid);
+	rt_mutex_unlock(&proc_uid_lock);
+}
+
+struct uid_entry {
+	const char *name;
+	int len;
+	umode_t mode;
+	const struct inode_operations *iop;
+	const struct file_operations *fop;
+};
+
+#define NOD(NAME, MODE, IOP, FOP) {			\
+	.name	= (NAME),				\
+	.len	= sizeof(NAME) - 1,			\
+	.mode	= MODE,					\
+	.iop	= IOP,					\
+	.fop	= FOP,					\
+}
+
+#ifdef CONFIG_CPU_FREQ_TIMES
+static const struct file_operations proc_uid_time_in_state_operations = {
+	.open		= single_uid_time_in_state_open,
+	.read		= seq_read,
+	.llseek		= seq_lseek,
+	.release	= single_release,
+};
+#endif
+
+static const struct uid_entry uid_base_stuff[] = {
+#ifdef CONFIG_CPU_FREQ_TIMES
+	NOD("time_in_state", 0444, NULL, &proc_uid_time_in_state_operations),
+#endif
+};
+
+static const struct inode_operations proc_uid_def_inode_operations = {
+	.setattr	= proc_setattr,
+};
+
+static struct inode *proc_uid_make_inode(struct super_block *sb, kuid_t kuid)
+{
+	struct inode *inode;
+
+	inode = new_inode(sb);
+	if (!inode)
+		return NULL;
+
+	inode->i_ino = get_next_ino();
+	inode->i_mtime = inode->i_atime = inode->i_ctime = CURRENT_TIME;
+	inode->i_op = &proc_uid_def_inode_operations;
+	inode->i_uid = kuid;
+
+	return inode;
+}
+
+static int proc_uident_instantiate(struct inode *dir, struct dentry *dentry,
+				   struct task_struct *unused, const void *ptr)
+{
+	const struct uid_entry *u = ptr;
+	struct inode *inode;
+
+	inode = proc_uid_make_inode(dir->i_sb, dir->i_uid);
+	if (!inode)
+		return -ENOENT;
+
+	inode->i_mode = u->mode;
+	if (S_ISDIR(inode->i_mode))
+		set_nlink(inode, 2);
+	if (u->iop)
+		inode->i_op = u->iop;
+	if (u->fop)
+		inode->i_fop = u->fop;
+	d_add(dentry, inode);
+	return 0;
+}
+
+static struct dentry *proc_uid_base_lookup(struct inode *dir,
+					   struct dentry *dentry,
+					   unsigned int flags)
+{
+	const struct uid_entry *u, *last;
+	unsigned int nents = ARRAY_SIZE(uid_base_stuff);
+
+	if (nents == 0)
+		return ERR_PTR(-ENOENT);
+
+	last = &uid_base_stuff[nents - 1];
+	for (u = uid_base_stuff; u <= last; u++) {
+		if (u->len != dentry->d_name.len)
+			continue;
+		if (!memcmp(dentry->d_name.name, u->name, u->len))
+			break;
+	}
+	if (u > last)
+		return ERR_PTR(-ENOENT);
+
+	return ERR_PTR(proc_uident_instantiate(dir, dentry, NULL, u));
+}
+
+static int proc_uid_base_readdir(struct file *file, struct dir_context *ctx)
+{
+	unsigned int nents = ARRAY_SIZE(uid_base_stuff);
+	const struct uid_entry *u;
+
+	if (!dir_emit_dots(file, ctx))
+		return 0;
+
+	if (ctx->pos >= nents + 2)
+		return 0;
+
+	for (u = uid_base_stuff + (ctx->pos - 2);
+	     u < uid_base_stuff + nents; u++) {
+		if (!proc_fill_cache(file, ctx, u->name, u->len,
+				     proc_uident_instantiate, NULL, u))
+			break;
+		ctx->pos++;
+	}
+
+	return 0;
+}
+
+static const struct inode_operations proc_uid_base_inode_operations = {
+	.lookup		= proc_uid_base_lookup,
+	.setattr	= proc_setattr,
+};
+
+static const struct file_operations proc_uid_base_operations = {
+	.read		= generic_read_dir,
+	.iterate	= proc_uid_base_readdir,
+	.llseek		= default_llseek,
+};
+
+static int proc_uid_instantiate(struct inode *dir, struct dentry *dentry,
+				struct task_struct *unused, const void *ptr)
+{
+	unsigned int i, len;
+	nlink_t nlinks;
+	kuid_t *kuid = (kuid_t *)ptr;
+	struct inode *inode = proc_uid_make_inode(dir->i_sb, *kuid);
+
+	if (!inode)
+		return -ENOENT;
+
+	inode->i_mode = S_IFDIR | 0555;
+	inode->i_op = &proc_uid_base_inode_operations;
+	inode->i_fop = &proc_uid_base_operations;
+	inode->i_flags |= S_IMMUTABLE;
+
+	nlinks = 2;
+	len = ARRAY_SIZE(uid_base_stuff);
+	for (i = 0; i < len; ++i) {
+		if (S_ISDIR(uid_base_stuff[i].mode))
+			++nlinks;
+	}
+	set_nlink(inode, nlinks);
+
+	d_add(dentry, inode);
+
+	return 0;
+}
+
+static int proc_uid_readdir(struct file *file, struct dir_context *ctx)
+{
+	int last_shown, i;
+	unsigned long bkt;
+	struct uid_hash_entry *entry;
+
+	if (!dir_emit_dots(file, ctx))
+		return 0;
+
+	i = 0;
+	last_shown = ctx->pos - 2;
+	rt_mutex_lock(&proc_uid_lock);
+	hash_for_each(proc_uid_hash_table, bkt, entry, hash) {
+		int len;
+		char buf[PROC_NUMBUF];
+
+		if (i < last_shown)
+			continue;
+		len = snprintf(buf, sizeof(buf), "%u", entry->uid);
+		if (!proc_fill_cache(file, ctx, buf, len,
+				     proc_uid_instantiate, NULL, &entry->uid))
+			break;
+		i++;
+		ctx->pos++;
+	}
+	rt_mutex_unlock(&proc_uid_lock);
+	return 0;
+}
+
+static struct dentry *proc_uid_lookup(struct inode *dir, struct dentry *dentry,
+				      unsigned int flags)
+{
+	int result = -ENOENT;
+
+	uid_t uid = name_to_int(&dentry->d_name);
+	bool uid_exists;
+
+	rt_mutex_lock(&proc_uid_lock);
+	uid_exists = uid_hash_entry_exists_locked(uid);
+	rt_mutex_unlock(&proc_uid_lock);
+	if (uid_exists) {
+		kuid_t kuid = make_kuid(current_user_ns(), uid);
+
+		result = proc_uid_instantiate(dir, dentry, NULL, &kuid);
+	}
+	return ERR_PTR(result);
+}
+
+static const struct file_operations proc_uid_operations = {
+	.read		= generic_read_dir,
+	.iterate	= proc_uid_readdir,
+	.llseek		= default_llseek,
+};
+
+static const struct inode_operations proc_uid_inode_operations = {
+	.lookup		= proc_uid_lookup,
+	.setattr	= proc_setattr,
+};
+
+int __init proc_uid_init(void)
+{
+	proc_uid = proc_mkdir("uid", NULL);
+	if (!proc_uid)
+		return -ENOMEM;
+	proc_uid->proc_iops = &proc_uid_inode_operations;
+	proc_uid->proc_fops = &proc_uid_operations;
+
+	return 0;
+}
diff --git a/fs/proc_namespace.c b/fs/proc_namespace.c
index 3f1190d..6863773 100644
--- a/fs/proc_namespace.c
+++ b/fs/proc_namespace.c
@@ -118,7 +118,9 @@ static int show_vfsmnt(struct seq_file *m, struct vfsmount *mnt)
 	if (err)
 		goto out;
 	show_mnt_opts(m, mnt);
-	if (sb->s_op->show_options)
+	if (sb->s_op->show_options2)
+			err = sb->s_op->show_options2(mnt, m, mnt_path.dentry);
+	else if (sb->s_op->show_options)
 		err = sb->s_op->show_options(m, mnt_path.dentry);
 	seq_puts(m, " 0 0\n");
 out:
@@ -180,7 +182,9 @@ static int show_mountinfo(struct seq_file *m, struct vfsmount *mnt)
 	err = show_sb_opts(m, sb);
 	if (err)
 		goto out;
-	if (sb->s_op->show_options)
+	if (sb->s_op->show_options2) {
+		err = sb->s_op->show_options2(mnt, m, mnt->mnt_root);
+	} else if (sb->s_op->show_options)
 		err = sb->s_op->show_options(m, mnt->mnt_root);
 	seq_putc(m, '\n');
 out:
diff --git a/fs/pstore/ram.c b/fs/pstore/ram.c
index 8b09271..8e151fb 100644
--- a/fs/pstore/ram.c
+++ b/fs/pstore/ram.c
@@ -550,6 +550,12 @@ static int ramoops_parse_dt(struct platform_device *pdev,
 	return 0;
 }
 
+void notrace ramoops_console_write_buf(const char *buf, size_t size)
+{
+	struct ramoops_context *cxt = &oops_cxt;
+	persistent_ram_write(cxt->cprz, buf, size);
+}
+
 static int ramoops_probe(struct platform_device *pdev)
 {
 	struct device *dev = &pdev->dev;
diff --git a/fs/read_write.c b/fs/read_write.c
index ba28059..2f1027d 100644
--- a/fs/read_write.c
+++ b/fs/read_write.c
@@ -23,9 +23,6 @@
 #include <asm/uaccess.h>
 #include <asm/unistd.h>
 
-typedef ssize_t (*io_fn_t)(struct file *, char __user *, size_t, loff_t *);
-typedef ssize_t (*iter_fn_t)(struct kiocb *, struct iov_iter *);
-
 const struct file_operations generic_ro_fops = {
 	.llseek		= generic_file_llseek,
 	.read_iter	= generic_file_read_iter,
@@ -675,7 +672,7 @@ unsigned long iov_shorten(struct iovec *iov, unsigned long nr_segs, size_t to)
 EXPORT_SYMBOL(iov_shorten);
 
 static ssize_t do_iter_readv_writev(struct file *filp, struct iov_iter *iter,
-		loff_t *ppos, iter_fn_t fn, int flags)
+		loff_t *ppos, int type, int flags)
 {
 	struct kiocb kiocb;
 	ssize_t ret;
@@ -692,7 +689,10 @@ static ssize_t do_iter_readv_writev(struct file *filp, struct iov_iter *iter,
 		kiocb.ki_flags |= (IOCB_DSYNC | IOCB_SYNC);
 	kiocb.ki_pos = *ppos;
 
-	ret = fn(&kiocb, iter);
+	if (type == READ)
+		ret = filp->f_op->read_iter(&kiocb, iter);
+	else
+		ret = filp->f_op->write_iter(&kiocb, iter);
 	BUG_ON(ret == -EIOCBQUEUED);
 	*ppos = kiocb.ki_pos;
 	return ret;
@@ -700,7 +700,7 @@ static ssize_t do_iter_readv_writev(struct file *filp, struct iov_iter *iter,
 
 /* Do it by hand, with file-ops */
 static ssize_t do_loop_readv_writev(struct file *filp, struct iov_iter *iter,
-		loff_t *ppos, io_fn_t fn, int flags)
+		loff_t *ppos, int type, int flags)
 {
 	ssize_t ret = 0;
 
@@ -711,7 +711,13 @@ static ssize_t do_loop_readv_writev(struct file *filp, struct iov_iter *iter,
 		struct iovec iovec = iov_iter_iovec(iter);
 		ssize_t nr;
 
-		nr = fn(filp, iovec.iov_base, iovec.iov_len, ppos);
+		if (type == READ) {
+			nr = filp->f_op->read(filp, iovec.iov_base,
+					      iovec.iov_len, ppos);
+		} else {
+			nr = filp->f_op->write(filp, iovec.iov_base,
+					       iovec.iov_len, ppos);
+		}
 
 		if (nr < 0) {
 			if (!ret)
@@ -844,8 +850,6 @@ static ssize_t do_readv_writev(int type, struct file *file,
 	struct iovec *iov = iovstack;
 	struct iov_iter iter;
 	ssize_t ret;
-	io_fn_t fn;
-	iter_fn_t iter_fn;
 
 	ret = import_iovec(type, uvector, nr_segs,
 			   ARRAY_SIZE(iovstack), &iov, &iter);
@@ -859,19 +863,14 @@ static ssize_t do_readv_writev(int type, struct file *file,
 	if (ret < 0)
 		goto out;
 
-	if (type == READ) {
-		fn = file->f_op->read;
-		iter_fn = file->f_op->read_iter;
-	} else {
-		fn = (io_fn_t)file->f_op->write;
-		iter_fn = file->f_op->write_iter;
+	if (type != READ)
 		file_start_write(file);
-	}
 
-	if (iter_fn)
-		ret = do_iter_readv_writev(file, &iter, pos, iter_fn, flags);
+	if ((type == READ && file->f_op->read_iter) ||
+	    (type == WRITE && file->f_op->write_iter))
+		ret = do_iter_readv_writev(file, &iter, pos, type, flags);
 	else
-		ret = do_loop_readv_writev(file, &iter, pos, fn, flags);
+		ret = do_loop_readv_writev(file, &iter, pos, type, flags);
 
 	if (type != READ)
 		file_end_write(file);
@@ -1069,8 +1068,6 @@ static ssize_t compat_do_readv_writev(int type, struct file *file,
 	struct iovec *iov = iovstack;
 	struct iov_iter iter;
 	ssize_t ret;
-	io_fn_t fn;
-	iter_fn_t iter_fn;
 
 	ret = compat_import_iovec(type, uvector, nr_segs,
 				  UIO_FASTIOV, &iov, &iter);
@@ -1084,19 +1081,14 @@ static ssize_t compat_do_readv_writev(int type, struct file *file,
 	if (ret < 0)
 		goto out;
 
-	if (type == READ) {
-		fn = file->f_op->read;
-		iter_fn = file->f_op->read_iter;
-	} else {
-		fn = (io_fn_t)file->f_op->write;
-		iter_fn = file->f_op->write_iter;
+	if (type != READ)
 		file_start_write(file);
-	}
 
-	if (iter_fn)
-		ret = do_iter_readv_writev(file, &iter, pos, iter_fn, flags);
+	if ((type == READ && file->f_op->read_iter) ||
+	    (type == WRITE && file->f_op->write_iter))
+		ret = do_iter_readv_writev(file, &iter, pos, type, flags);
 	else
-		ret = do_loop_readv_writev(file, &iter, pos, fn, flags);
+		ret = do_loop_readv_writev(file, &iter, pos, type, flags);
 
 	if (type != READ)
 		file_end_write(file);
diff --git a/fs/sdcardfs/Kconfig b/fs/sdcardfs/Kconfig
new file mode 100644
index 00000000..a1c1033
--- /dev/null
+++ b/fs/sdcardfs/Kconfig
@@ -0,0 +1,13 @@
+config SDCARD_FS
+	tristate "sdcard file system"
+	depends on CONFIGFS_FS
+	default n
+	help
+	  Sdcardfs is based on Wrapfs file system.
+
+config SDCARD_FS_FADV_NOACTIVE
+	bool "sdcardfs fadvise noactive support"
+	depends on FADV_NOACTIVE
+	default y
+	help
+	  Sdcardfs supports fadvise noactive mode.
diff --git a/fs/sdcardfs/Makefile b/fs/sdcardfs/Makefile
new file mode 100644
index 00000000..b84fbb2
--- /dev/null
+++ b/fs/sdcardfs/Makefile
@@ -0,0 +1,7 @@
+SDCARDFS_VERSION="0.1"
+
+EXTRA_CFLAGS += -DSDCARDFS_VERSION=\"$(SDCARDFS_VERSION)\"
+
+obj-$(CONFIG_SDCARD_FS) += sdcardfs.o
+
+sdcardfs-y := dentry.o file.o inode.o main.o super.o lookup.o mmap.o packagelist.o derived_perm.o
diff --git a/fs/sdcardfs/dentry.c b/fs/sdcardfs/dentry.c
new file mode 100644
index 00000000..776d549
--- /dev/null
+++ b/fs/sdcardfs/dentry.c
@@ -0,0 +1,189 @@
+/*
+ * fs/sdcardfs/dentry.c
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#include "sdcardfs.h"
+#include "linux/ctype.h"
+
+/*
+ * returns: -ERRNO if error (returned to user)
+ *          0: tell VFS to invalidate dentry
+ *          1: dentry is valid
+ */
+static int sdcardfs_d_revalidate(struct dentry *dentry, unsigned int flags)
+{
+	int err = 1;
+	struct path parent_lower_path, lower_path;
+	struct dentry *parent_dentry = NULL;
+	struct dentry *parent_lower_dentry = NULL;
+	struct dentry *lower_cur_parent_dentry = NULL;
+	struct dentry *lower_dentry = NULL;
+	struct inode *inode;
+	struct sdcardfs_inode_data *data;
+
+	if (flags & LOOKUP_RCU)
+		return -ECHILD;
+
+	spin_lock(&dentry->d_lock);
+	if (IS_ROOT(dentry)) {
+		spin_unlock(&dentry->d_lock);
+		return 1;
+	}
+	spin_unlock(&dentry->d_lock);
+
+	/* check uninitialized obb_dentry and
+	 * whether the base obbpath has been changed or not
+	 */
+	if (is_obbpath_invalid(dentry)) {
+		return 0;
+	}
+
+	parent_dentry = dget_parent(dentry);
+	sdcardfs_get_lower_path(parent_dentry, &parent_lower_path);
+	sdcardfs_get_real_lower(dentry, &lower_path);
+	parent_lower_dentry = parent_lower_path.dentry;
+	lower_dentry = lower_path.dentry;
+	lower_cur_parent_dentry = dget_parent(lower_dentry);
+
+	if ((lower_dentry->d_flags & DCACHE_OP_REVALIDATE)) {
+		err = lower_dentry->d_op->d_revalidate(lower_dentry, flags);
+		if (err == 0) {
+			goto out;
+		}
+	}
+
+	spin_lock(&lower_dentry->d_lock);
+	if (d_unhashed(lower_dentry)) {
+		spin_unlock(&lower_dentry->d_lock);
+		err = 0;
+		goto out;
+	}
+	spin_unlock(&lower_dentry->d_lock);
+
+	if (parent_lower_dentry != lower_cur_parent_dentry) {
+		err = 0;
+		goto out;
+	}
+
+	if (dentry < lower_dentry) {
+		spin_lock(&dentry->d_lock);
+		spin_lock_nested(&lower_dentry->d_lock, DENTRY_D_LOCK_NESTED);
+	} else {
+		spin_lock(&lower_dentry->d_lock);
+		spin_lock_nested(&dentry->d_lock, DENTRY_D_LOCK_NESTED);
+	}
+
+	if (!qstr_case_eq(&dentry->d_name, &lower_dentry->d_name)) {
+		err = 0;
+	}
+
+	if (dentry < lower_dentry) {
+		spin_unlock(&lower_dentry->d_lock);
+		spin_unlock(&dentry->d_lock);
+	} else {
+		spin_unlock(&dentry->d_lock);
+		spin_unlock(&lower_dentry->d_lock);
+	}
+	if (!err)
+		goto out;
+
+	/* If our top's inode is gone, we may be out of date */
+	inode = igrab(d_inode(dentry));
+	if (inode) {
+		data = top_data_get(SDCARDFS_I(inode));
+		if (!data || data->abandoned) {
+			err = 0;
+		}
+		if (data)
+			data_put(data);
+		iput(inode);
+	}
+
+out:
+	dput(parent_dentry);
+	dput(lower_cur_parent_dentry);
+	sdcardfs_put_lower_path(parent_dentry, &parent_lower_path);
+	sdcardfs_put_real_lower(dentry, &lower_path);
+	return err;
+}
+
+static void sdcardfs_d_release(struct dentry *dentry)
+{
+	if (!dentry || !dentry->d_fsdata)
+		return;
+	/* release and reset the lower paths */
+	if (has_graft_path(dentry))
+		sdcardfs_put_reset_orig_path(dentry);
+	sdcardfs_put_reset_lower_path(dentry);
+	free_dentry_private_data(dentry);
+}
+
+static int sdcardfs_hash_ci(const struct dentry *dentry,
+				struct qstr *qstr)
+{
+	/*
+	 * This function is copy of vfat_hashi.
+	 * FIXME Should we support national language?
+	 *       Refer to vfat_hashi()
+	 * struct nls_table *t = MSDOS_SB(dentry->d_sb)->nls_io;
+	 */
+	const unsigned char *name;
+	unsigned int len;
+	unsigned long hash;
+
+	name = qstr->name;
+	len = qstr->len;
+
+	hash = init_name_hash(dentry);
+	while (len--)
+		hash = partial_name_hash(tolower(*name++), hash);
+	qstr->hash = end_name_hash(hash);
+
+	return 0;
+}
+
+/*
+ * Case insensitive compare of two vfat names.
+ */
+static int sdcardfs_cmp_ci(const struct dentry *dentry,
+		unsigned int len, const char *str, const struct qstr *name)
+{
+	/* FIXME Should we support national language? */
+
+	if (name->len == len) {
+		if (str_n_case_eq(name->name, str, len))
+			return 0;
+	}
+	return 1;
+}
+
+static void sdcardfs_canonical_path(const struct path *path,
+				struct path *actual_path)
+{
+	sdcardfs_get_real_lower(path->dentry, actual_path);
+}
+
+const struct dentry_operations sdcardfs_ci_dops = {
+	.d_revalidate	= sdcardfs_d_revalidate,
+	.d_release	= sdcardfs_d_release,
+	.d_hash	= sdcardfs_hash_ci,
+	.d_compare	= sdcardfs_cmp_ci,
+	.d_canonical_path = sdcardfs_canonical_path,
+};
+
diff --git a/fs/sdcardfs/derived_perm.c b/fs/sdcardfs/derived_perm.c
new file mode 100644
index 00000000..0b3b223
--- /dev/null
+++ b/fs/sdcardfs/derived_perm.c
@@ -0,0 +1,472 @@
+/*
+ * fs/sdcardfs/derived_perm.c
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#include "sdcardfs.h"
+
+/* copy derived state from parent inode */
+static void inherit_derived_state(struct inode *parent, struct inode *child)
+{
+	struct sdcardfs_inode_info *pi = SDCARDFS_I(parent);
+	struct sdcardfs_inode_info *ci = SDCARDFS_I(child);
+
+	ci->data->perm = PERM_INHERIT;
+	ci->data->userid = pi->data->userid;
+	ci->data->d_uid = pi->data->d_uid;
+	ci->data->under_android = pi->data->under_android;
+	ci->data->under_cache = pi->data->under_cache;
+	ci->data->under_obb = pi->data->under_obb;
+}
+
+/* helper function for derived state */
+void setup_derived_state(struct inode *inode, perm_t perm, userid_t userid,
+					uid_t uid)
+{
+	struct sdcardfs_inode_info *info = SDCARDFS_I(inode);
+
+	info->data->perm = perm;
+	info->data->userid = userid;
+	info->data->d_uid = uid;
+	info->data->under_android = false;
+	info->data->under_cache = false;
+	info->data->under_obb = false;
+}
+
+/* While renaming, there is a point where we want the path from dentry,
+ * but the name from newdentry
+ */
+void get_derived_permission_new(struct dentry *parent, struct dentry *dentry,
+				const struct qstr *name)
+{
+	struct sdcardfs_inode_info *info = SDCARDFS_I(d_inode(dentry));
+	struct sdcardfs_inode_info *parent_info = SDCARDFS_I(d_inode(parent));
+	struct sdcardfs_inode_data *parent_data = parent_info->data;
+	appid_t appid;
+	unsigned long user_num;
+	int err;
+	struct qstr q_Android = QSTR_LITERAL("Android");
+	struct qstr q_data = QSTR_LITERAL("data");
+	struct qstr q_obb = QSTR_LITERAL("obb");
+	struct qstr q_media = QSTR_LITERAL("media");
+	struct qstr q_cache = QSTR_LITERAL("cache");
+
+	/* By default, each inode inherits from its parent.
+	 * the properties are maintained on its private fields
+	 * because the inode attributes will be modified with that of
+	 * its lower inode.
+	 * These values are used by our custom permission call instead
+	 * of using the inode permissions.
+	 */
+
+	inherit_derived_state(d_inode(parent), d_inode(dentry));
+
+	/* Files don't get special labels */
+	if (!S_ISDIR(d_inode(dentry)->i_mode)) {
+		set_top(info, parent_info);
+		return;
+	}
+	/* Derive custom permissions based on parent and current node */
+	switch (parent_data->perm) {
+	case PERM_INHERIT:
+	case PERM_ANDROID_PACKAGE_CACHE:
+		set_top(info, parent_info);
+		break;
+	case PERM_PRE_ROOT:
+		/* Legacy internal layout places users at top level */
+		info->data->perm = PERM_ROOT;
+		err = kstrtoul(name->name, 10, &user_num);
+		if (err)
+			info->data->userid = 0;
+		else
+			info->data->userid = user_num;
+		break;
+	case PERM_ROOT:
+		/* Assume masked off by default. */
+		if (qstr_case_eq(name, &q_Android)) {
+			/* App-specific directories inside; let anyone traverse */
+			info->data->perm = PERM_ANDROID;
+			info->data->under_android = true;
+		} else {
+			set_top(info, parent_info);
+		}
+		break;
+	case PERM_ANDROID:
+		if (qstr_case_eq(name, &q_data)) {
+			/* App-specific directories inside; let anyone traverse */
+			info->data->perm = PERM_ANDROID_DATA;
+		} else if (qstr_case_eq(name, &q_obb)) {
+			/* App-specific directories inside; let anyone traverse */
+			info->data->perm = PERM_ANDROID_OBB;
+			info->data->under_obb = true;
+			/* Single OBB directory is always shared */
+		} else if (qstr_case_eq(name, &q_media)) {
+			/* App-specific directories inside; let anyone traverse */
+			info->data->perm = PERM_ANDROID_MEDIA;
+		} else {
+			set_top(info, parent_info);
+		}
+		break;
+	case PERM_ANDROID_OBB:
+	case PERM_ANDROID_DATA:
+	case PERM_ANDROID_MEDIA:
+		info->data->perm = PERM_ANDROID_PACKAGE;
+		appid = get_appid(name->name);
+		if (appid != 0 && !is_excluded(name->name, parent_data->userid))
+			info->data->d_uid =
+				multiuser_get_uid(parent_data->userid, appid);
+		break;
+	case PERM_ANDROID_PACKAGE:
+		if (qstr_case_eq(name, &q_cache)) {
+			info->data->perm = PERM_ANDROID_PACKAGE_CACHE;
+			info->data->under_cache = true;
+		}
+		set_top(info, parent_info);
+		break;
+	}
+}
+
+void get_derived_permission(struct dentry *parent, struct dentry *dentry)
+{
+	get_derived_permission_new(parent, dentry, &dentry->d_name);
+}
+
+static appid_t get_type(const char *name)
+{
+	const char *ext = strrchr(name, '.');
+	appid_t id;
+
+	if (ext && ext[0]) {
+		ext = &ext[1];
+		id = get_ext_gid(ext);
+		return id?:AID_MEDIA_RW;
+	}
+	return AID_MEDIA_RW;
+}
+
+void fixup_lower_ownership(struct dentry *dentry, const char *name)
+{
+	struct path path;
+	struct inode *inode;
+	struct inode *delegated_inode = NULL;
+	int error;
+	struct sdcardfs_inode_info *info;
+	struct sdcardfs_inode_data *info_d;
+	struct sdcardfs_inode_data *info_top;
+	perm_t perm;
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dentry->d_sb);
+	uid_t uid = sbi->options.fs_low_uid;
+	gid_t gid = sbi->options.fs_low_gid;
+	struct iattr newattrs;
+
+	if (!sbi->options.gid_derivation)
+		return;
+
+	info = SDCARDFS_I(d_inode(dentry));
+	info_d = info->data;
+	perm = info_d->perm;
+	if (info_d->under_obb) {
+		perm = PERM_ANDROID_OBB;
+	} else if (info_d->under_cache) {
+		perm = PERM_ANDROID_PACKAGE_CACHE;
+	} else if (perm == PERM_INHERIT) {
+		info_top = top_data_get(info);
+		perm = info_top->perm;
+		data_put(info_top);
+	}
+
+	switch (perm) {
+	case PERM_ROOT:
+	case PERM_ANDROID:
+	case PERM_ANDROID_DATA:
+	case PERM_ANDROID_MEDIA:
+	case PERM_ANDROID_PACKAGE:
+	case PERM_ANDROID_PACKAGE_CACHE:
+		uid = multiuser_get_uid(info_d->userid, uid);
+		break;
+	case PERM_ANDROID_OBB:
+		uid = AID_MEDIA_OBB;
+		break;
+	case PERM_PRE_ROOT:
+	default:
+		break;
+	}
+	switch (perm) {
+	case PERM_ROOT:
+	case PERM_ANDROID:
+	case PERM_ANDROID_DATA:
+	case PERM_ANDROID_MEDIA:
+		if (S_ISDIR(d_inode(dentry)->i_mode))
+			gid = multiuser_get_uid(info_d->userid, AID_MEDIA_RW);
+		else
+			gid = multiuser_get_uid(info_d->userid, get_type(name));
+		break;
+	case PERM_ANDROID_OBB:
+		gid = AID_MEDIA_OBB;
+		break;
+	case PERM_ANDROID_PACKAGE:
+		if (uid_is_app(info_d->d_uid))
+			gid = multiuser_get_ext_gid(info_d->d_uid);
+		else
+			gid = multiuser_get_uid(info_d->userid, AID_MEDIA_RW);
+		break;
+	case PERM_ANDROID_PACKAGE_CACHE:
+		if (uid_is_app(info_d->d_uid))
+			gid = multiuser_get_ext_cache_gid(info_d->d_uid);
+		else
+			gid = multiuser_get_uid(info_d->userid, AID_MEDIA_RW);
+		break;
+	case PERM_PRE_ROOT:
+	default:
+		break;
+	}
+
+	sdcardfs_get_lower_path(dentry, &path);
+	inode = d_inode(path.dentry);
+	if (d_inode(path.dentry)->i_gid.val != gid || d_inode(path.dentry)->i_uid.val != uid) {
+retry_deleg:
+		newattrs.ia_valid = ATTR_GID | ATTR_UID | ATTR_FORCE;
+		newattrs.ia_uid = make_kuid(current_user_ns(), uid);
+		newattrs.ia_gid = make_kgid(current_user_ns(), gid);
+		if (!S_ISDIR(inode->i_mode))
+			newattrs.ia_valid |=
+				ATTR_KILL_SUID | ATTR_KILL_SGID | ATTR_KILL_PRIV;
+		inode_lock(inode);
+		error = security_path_chown(&path, newattrs.ia_uid, newattrs.ia_gid);
+		if (!error)
+			error = notify_change2(path.mnt, path.dentry, &newattrs, &delegated_inode);
+		inode_unlock(inode);
+		if (delegated_inode) {
+			error = break_deleg_wait(&delegated_inode);
+			if (!error)
+				goto retry_deleg;
+		}
+		if (error)
+			pr_debug("sdcardfs: Failed to touch up lower fs gid/uid for %s\n", name);
+	}
+	sdcardfs_put_lower_path(dentry, &path);
+}
+
+static int descendant_may_need_fixup(struct sdcardfs_inode_data *data,
+		struct limit_search *limit)
+{
+	if (data->perm == PERM_ROOT)
+		return (limit->flags & BY_USERID) ?
+				data->userid == limit->userid : 1;
+	if (data->perm == PERM_PRE_ROOT || data->perm == PERM_ANDROID)
+		return 1;
+	return 0;
+}
+
+static int needs_fixup(perm_t perm)
+{
+	if (perm == PERM_ANDROID_DATA || perm == PERM_ANDROID_OBB
+			|| perm == PERM_ANDROID_MEDIA)
+		return 1;
+	return 0;
+}
+
+static void __fixup_perms_recursive(struct dentry *dentry, struct limit_search *limit, int depth)
+{
+	struct dentry *child;
+	struct sdcardfs_inode_info *info;
+
+	/*
+	 * All paths will terminate their recursion on hitting PERM_ANDROID_OBB,
+	 * PERM_ANDROID_MEDIA, or PERM_ANDROID_DATA. This happens at a depth of
+	 * at most 3.
+	 */
+	WARN(depth > 3, "%s: Max expected depth exceeded!\n", __func__);
+	spin_lock_nested(&dentry->d_lock, depth);
+	if (!d_inode(dentry)) {
+		spin_unlock(&dentry->d_lock);
+		return;
+	}
+	info = SDCARDFS_I(d_inode(dentry));
+
+	if (needs_fixup(info->data->perm)) {
+		list_for_each_entry(child, &dentry->d_subdirs, d_child) {
+			spin_lock_nested(&child->d_lock, depth + 1);
+			if (!(limit->flags & BY_NAME) || qstr_case_eq(&child->d_name, &limit->name)) {
+				if (d_inode(child)) {
+					get_derived_permission(dentry, child);
+					fixup_tmp_permissions(d_inode(child));
+					spin_unlock(&child->d_lock);
+					break;
+				}
+			}
+			spin_unlock(&child->d_lock);
+		}
+	} else if (descendant_may_need_fixup(info->data, limit)) {
+		list_for_each_entry(child, &dentry->d_subdirs, d_child) {
+			__fixup_perms_recursive(child, limit, depth + 1);
+		}
+	}
+	spin_unlock(&dentry->d_lock);
+}
+
+void fixup_perms_recursive(struct dentry *dentry, struct limit_search *limit)
+{
+	__fixup_perms_recursive(dentry, limit, 0);
+}
+
+/* main function for updating derived permission */
+inline void update_derived_permission_lock(struct dentry *dentry)
+{
+	struct dentry *parent;
+
+	if (!dentry || !d_inode(dentry)) {
+		pr_err("sdcardfs: %s: invalid dentry\n", __func__);
+		return;
+	}
+	/* FIXME:
+	 * 1. need to check whether the dentry is updated or not
+	 * 2. remove the root dentry update
+	 */
+	if (!IS_ROOT(dentry)) {
+		parent = dget_parent(dentry);
+		if (parent) {
+			get_derived_permission(parent, dentry);
+			dput(parent);
+		}
+	}
+	fixup_tmp_permissions(d_inode(dentry));
+}
+
+int need_graft_path(struct dentry *dentry)
+{
+	int ret = 0;
+	struct dentry *parent = dget_parent(dentry);
+	struct sdcardfs_inode_info *parent_info = SDCARDFS_I(d_inode(parent));
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dentry->d_sb);
+	struct qstr obb = QSTR_LITERAL("obb");
+
+	if (parent_info->data->perm == PERM_ANDROID &&
+			qstr_case_eq(&dentry->d_name, &obb)) {
+
+		/* /Android/obb is the base obbpath of DERIVED_UNIFIED */
+		if (!(sbi->options.multiuser == false
+				&& parent_info->data->userid == 0)) {
+			ret = 1;
+		}
+	}
+	dput(parent);
+	return ret;
+}
+
+int is_obbpath_invalid(struct dentry *dent)
+{
+	int ret = 0;
+	struct sdcardfs_dentry_info *di = SDCARDFS_D(dent);
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dent->d_sb);
+	char *path_buf, *obbpath_s;
+	int need_put = 0;
+	struct path lower_path;
+
+	/* check the base obbpath has been changed.
+	 * this routine can check an uninitialized obb dentry as well.
+	 * regarding the uninitialized obb, refer to the sdcardfs_mkdir()
+	 */
+	spin_lock(&di->lock);
+	if (di->orig_path.dentry) {
+		if (!di->lower_path.dentry) {
+			ret = 1;
+		} else {
+			path_get(&di->lower_path);
+
+			path_buf = kmalloc(PATH_MAX, GFP_ATOMIC);
+			if (!path_buf) {
+				ret = 1;
+				pr_err("sdcardfs: fail to allocate path_buf in %s.\n", __func__);
+			} else {
+				obbpath_s = d_path(&di->lower_path, path_buf, PATH_MAX);
+				if (d_unhashed(di->lower_path.dentry) ||
+					!str_case_eq(sbi->obbpath_s, obbpath_s)) {
+					ret = 1;
+				}
+				kfree(path_buf);
+			}
+
+			pathcpy(&lower_path, &di->lower_path);
+			need_put = 1;
+		}
+	}
+	spin_unlock(&di->lock);
+	if (need_put)
+		path_put(&lower_path);
+	return ret;
+}
+
+int is_base_obbpath(struct dentry *dentry)
+{
+	int ret = 0;
+	struct dentry *parent = dget_parent(dentry);
+	struct sdcardfs_inode_info *parent_info = SDCARDFS_I(d_inode(parent));
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dentry->d_sb);
+	struct qstr q_obb = QSTR_LITERAL("obb");
+
+	spin_lock(&SDCARDFS_D(dentry)->lock);
+	if (sbi->options.multiuser) {
+		if (parent_info->data->perm == PERM_PRE_ROOT &&
+				qstr_case_eq(&dentry->d_name, &q_obb)) {
+			ret = 1;
+		}
+	} else  if (parent_info->data->perm == PERM_ANDROID &&
+			qstr_case_eq(&dentry->d_name, &q_obb)) {
+		ret = 1;
+	}
+	spin_unlock(&SDCARDFS_D(dentry)->lock);
+	return ret;
+}
+
+/* The lower_path will be stored to the dentry's orig_path
+ * and the base obbpath will be copyed to the lower_path variable.
+ * if an error returned, there's no change in the lower_path
+ * returns: -ERRNO if error (0: no error)
+ */
+int setup_obb_dentry(struct dentry *dentry, struct path *lower_path)
+{
+	int err = 0;
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dentry->d_sb);
+	struct path obbpath;
+
+	/* A local obb dentry must have its own orig_path to support rmdir
+	 * and mkdir of itself. Usually, we expect that the sbi->obbpath
+	 * is avaiable on this stage.
+	 */
+	sdcardfs_set_orig_path(dentry, lower_path);
+
+	err = kern_path(sbi->obbpath_s,
+			LOOKUP_FOLLOW | LOOKUP_DIRECTORY, &obbpath);
+
+	if (!err) {
+		/* the obbpath base has been found */
+		pathcpy(lower_path, &obbpath);
+	} else {
+		/* if the sbi->obbpath is not available, we can optionally
+		 * setup the lower_path with its orig_path.
+		 * but, the current implementation just returns an error
+		 * because the sdcard daemon also regards this case as
+		 * a lookup fail.
+		 */
+		pr_info("sdcardfs: the sbi->obbpath is not available\n");
+	}
+	return err;
+}
+
+
diff --git a/fs/sdcardfs/file.c b/fs/sdcardfs/file.c
new file mode 100644
index 00000000..b3bd2fd
--- /dev/null
+++ b/fs/sdcardfs/file.c
@@ -0,0 +1,468 @@
+/*
+ * fs/sdcardfs/file.c
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#include "sdcardfs.h"
+#ifdef CONFIG_SDCARD_FS_FADV_NOACTIVE
+#include <linux/backing-dev.h>
+#endif
+
+static ssize_t sdcardfs_read(struct file *file, char __user *buf,
+			   size_t count, loff_t *ppos)
+{
+	int err;
+	struct file *lower_file;
+	struct dentry *dentry = file->f_path.dentry;
+#ifdef CONFIG_SDCARD_FS_FADV_NOACTIVE
+	struct backing_dev_info *bdi;
+#endif
+
+	lower_file = sdcardfs_lower_file(file);
+
+#ifdef CONFIG_SDCARD_FS_FADV_NOACTIVE
+	if (file->f_mode & FMODE_NOACTIVE) {
+		if (!(lower_file->f_mode & FMODE_NOACTIVE)) {
+			bdi = lower_file->f_mapping->backing_dev_info;
+			lower_file->f_ra.ra_pages = bdi->ra_pages * 2;
+			spin_lock(&lower_file->f_lock);
+			lower_file->f_mode |= FMODE_NOACTIVE;
+			spin_unlock(&lower_file->f_lock);
+		}
+	}
+#endif
+
+	err = vfs_read(lower_file, buf, count, ppos);
+	/* update our inode atime upon a successful lower read */
+	if (err >= 0)
+		fsstack_copy_attr_atime(d_inode(dentry),
+					file_inode(lower_file));
+
+	return err;
+}
+
+static ssize_t sdcardfs_write(struct file *file, const char __user *buf,
+			    size_t count, loff_t *ppos)
+{
+	int err;
+	struct file *lower_file;
+	struct dentry *dentry = file->f_path.dentry;
+	struct inode *inode = d_inode(dentry);
+
+	/* check disk space */
+	if (!check_min_free_space(dentry, count, 0)) {
+		pr_err("No minimum free space.\n");
+		return -ENOSPC;
+	}
+
+	lower_file = sdcardfs_lower_file(file);
+	err = vfs_write(lower_file, buf, count, ppos);
+	/* update our inode times+sizes upon a successful lower write */
+	if (err >= 0) {
+		if (sizeof(loff_t) > sizeof(long))
+			inode_lock(inode);
+		fsstack_copy_inode_size(inode, file_inode(lower_file));
+		fsstack_copy_attr_times(inode, file_inode(lower_file));
+		if (sizeof(loff_t) > sizeof(long))
+			inode_unlock(inode);
+	}
+
+	return err;
+}
+
+static int sdcardfs_readdir(struct file *file, struct dir_context *ctx)
+{
+	int err;
+	struct file *lower_file = NULL;
+	struct dentry *dentry = file->f_path.dentry;
+
+	lower_file = sdcardfs_lower_file(file);
+
+	lower_file->f_pos = file->f_pos;
+	err = iterate_dir(lower_file, ctx);
+	file->f_pos = lower_file->f_pos;
+	if (err >= 0)		/* copy the atime */
+		fsstack_copy_attr_atime(d_inode(dentry),
+					file_inode(lower_file));
+	return err;
+}
+
+static long sdcardfs_unlocked_ioctl(struct file *file, unsigned int cmd,
+				  unsigned long arg)
+{
+	long err = -ENOTTY;
+	struct file *lower_file;
+	const struct cred *saved_cred = NULL;
+	struct dentry *dentry = file->f_path.dentry;
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dentry->d_sb);
+
+	lower_file = sdcardfs_lower_file(file);
+
+	/* XXX: use vfs_ioctl if/when VFS exports it */
+	if (!lower_file || !lower_file->f_op)
+		goto out;
+
+	/* save current_cred and override it */
+	OVERRIDE_CRED(sbi, saved_cred, SDCARDFS_I(file_inode(file)));
+
+	if (lower_file->f_op->unlocked_ioctl)
+		err = lower_file->f_op->unlocked_ioctl(lower_file, cmd, arg);
+
+	/* some ioctls can change inode attributes (EXT2_IOC_SETFLAGS) */
+	if (!err)
+		sdcardfs_copy_and_fix_attrs(file_inode(file),
+				      file_inode(lower_file));
+	REVERT_CRED(saved_cred);
+out:
+	return err;
+}
+
+#ifdef CONFIG_COMPAT
+static long sdcardfs_compat_ioctl(struct file *file, unsigned int cmd,
+				unsigned long arg)
+{
+	long err = -ENOTTY;
+	struct file *lower_file;
+	const struct cred *saved_cred = NULL;
+	struct dentry *dentry = file->f_path.dentry;
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dentry->d_sb);
+
+	lower_file = sdcardfs_lower_file(file);
+
+	/* XXX: use vfs_ioctl if/when VFS exports it */
+	if (!lower_file || !lower_file->f_op)
+		goto out;
+
+	/* save current_cred and override it */
+	OVERRIDE_CRED(sbi, saved_cred, SDCARDFS_I(file_inode(file)));
+
+	if (lower_file->f_op->compat_ioctl)
+		err = lower_file->f_op->compat_ioctl(lower_file, cmd, arg);
+
+	REVERT_CRED(saved_cred);
+out:
+	return err;
+}
+#endif
+
+static int sdcardfs_mmap(struct file *file, struct vm_area_struct *vma)
+{
+	int err = 0;
+	bool willwrite;
+	struct file *lower_file;
+	const struct vm_operations_struct *saved_vm_ops = NULL;
+
+	/* this might be deferred to mmap's writepage */
+	willwrite = ((vma->vm_flags | VM_SHARED | VM_WRITE) == vma->vm_flags);
+
+	/*
+	 * File systems which do not implement ->writepage may use
+	 * generic_file_readonly_mmap as their ->mmap op.  If you call
+	 * generic_file_readonly_mmap with VM_WRITE, you'd get an -EINVAL.
+	 * But we cannot call the lower ->mmap op, so we can't tell that
+	 * writeable mappings won't work.  Therefore, our only choice is to
+	 * check if the lower file system supports the ->writepage, and if
+	 * not, return EINVAL (the same error that
+	 * generic_file_readonly_mmap returns in that case).
+	 */
+	lower_file = sdcardfs_lower_file(file);
+	if (willwrite && !lower_file->f_mapping->a_ops->writepage) {
+		err = -EINVAL;
+		pr_err("sdcardfs: lower file system does not support writeable mmap\n");
+		goto out;
+	}
+
+	/*
+	 * find and save lower vm_ops.
+	 *
+	 * XXX: the VFS should have a cleaner way of finding the lower vm_ops
+	 */
+	if (!SDCARDFS_F(file)->lower_vm_ops) {
+		err = lower_file->f_op->mmap(lower_file, vma);
+		if (err) {
+			pr_err("sdcardfs: lower mmap failed %d\n", err);
+			goto out;
+		}
+#ifdef CONFIG_RTK_PLATFORM
+		saved_vm_ops = vma->vm_rtk_ops; /* save: came from lower ->mmap */
+#else
+		saved_vm_ops = vma->vm_ops; /* save: came from lower ->mmap */
+#endif /*CONFIG_RTK_PLATFORM*/
+	}
+
+	/*
+	 * Next 3 lines are all I need from generic_file_mmap.  I definitely
+	 * don't want its test for ->readpage which returns -ENOEXEC.
+	 */
+	file_accessed(file);
+#ifdef CONFIG_RTK_PLATFORM
+	vma->vm_rtk_ops = &sdcardfs_vm_ops;
+#else
+	vma->vm_ops = &sdcardfs_vm_ops;
+#endif /*CONFIG_RTK_PLATFORM*/
+
+	file->f_mapping->a_ops = &sdcardfs_aops; /* set our aops */
+	if (!SDCARDFS_F(file)->lower_vm_ops) /* save for our ->fault */
+		SDCARDFS_F(file)->lower_vm_ops = saved_vm_ops;
+#ifdef CONFIG_RTK_PLATFORM
+	vma->vm_rtk_private_data = file;
+#else
+	vma->vm_private_data = file;
+#endif /*CONFIG_RTK_PLATFORM*/
+
+	get_file(lower_file);
+	vma->vm_file = lower_file;
+
+out:
+	return err;
+}
+
+static int sdcardfs_open(struct inode *inode, struct file *file)
+{
+	int err = 0;
+	struct file *lower_file = NULL;
+	struct path lower_path;
+	struct dentry *dentry = file->f_path.dentry;
+	struct dentry *parent = dget_parent(dentry);
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dentry->d_sb);
+	const struct cred *saved_cred = NULL;
+
+	/* don't open unhashed/deleted files */
+	if (d_unhashed(dentry)) {
+		err = -ENOENT;
+		goto out_err;
+	}
+
+	if (!check_caller_access_to_name(d_inode(parent), &dentry->d_name)) {
+		err = -EACCES;
+		goto out_err;
+	}
+
+	/* save current_cred and override it */
+	OVERRIDE_CRED(sbi, saved_cred, SDCARDFS_I(inode));
+
+	file->private_data =
+		kzalloc(sizeof(struct sdcardfs_file_info), GFP_KERNEL);
+	if (!SDCARDFS_F(file)) {
+		err = -ENOMEM;
+		goto out_revert_cred;
+	}
+
+	/* open lower object and link sdcardfs's file struct to lower's */
+	sdcardfs_get_lower_path(file->f_path.dentry, &lower_path);
+	lower_file = dentry_open(&lower_path, file->f_flags, current_cred());
+	path_put(&lower_path);
+	if (IS_ERR(lower_file)) {
+		err = PTR_ERR(lower_file);
+		lower_file = sdcardfs_lower_file(file);
+		if (lower_file) {
+			sdcardfs_set_lower_file(file, NULL);
+			fput(lower_file); /* fput calls dput for lower_dentry */
+		}
+	} else {
+		sdcardfs_set_lower_file(file, lower_file);
+	}
+
+	if (err)
+		kfree(SDCARDFS_F(file));
+	else
+		sdcardfs_copy_and_fix_attrs(inode, sdcardfs_lower_inode(inode));
+
+out_revert_cred:
+	REVERT_CRED(saved_cred);
+out_err:
+	dput(parent);
+	return err;
+}
+
+static int sdcardfs_flush(struct file *file, fl_owner_t id)
+{
+	int err = 0;
+	struct file *lower_file = NULL;
+
+	lower_file = sdcardfs_lower_file(file);
+	if (lower_file && lower_file->f_op && lower_file->f_op->flush) {
+		filemap_write_and_wait(file->f_mapping);
+		err = lower_file->f_op->flush(lower_file, id);
+	}
+
+	return err;
+}
+
+/* release all lower object references & free the file info structure */
+static int sdcardfs_file_release(struct inode *inode, struct file *file)
+{
+	struct file *lower_file;
+
+	lower_file = sdcardfs_lower_file(file);
+	if (lower_file) {
+		sdcardfs_set_lower_file(file, NULL);
+		fput(lower_file);
+	}
+
+	kfree(SDCARDFS_F(file));
+	return 0;
+}
+
+static int sdcardfs_fsync(struct file *file, loff_t start, loff_t end,
+			int datasync)
+{
+	int err;
+	struct file *lower_file;
+	struct path lower_path;
+	struct dentry *dentry = file->f_path.dentry;
+
+	err = __generic_file_fsync(file, start, end, datasync);
+	if (err)
+		goto out;
+
+	lower_file = sdcardfs_lower_file(file);
+	sdcardfs_get_lower_path(dentry, &lower_path);
+	err = vfs_fsync_range(lower_file, start, end, datasync);
+	sdcardfs_put_lower_path(dentry, &lower_path);
+out:
+	return err;
+}
+
+static int sdcardfs_fasync(int fd, struct file *file, int flag)
+{
+	int err = 0;
+	struct file *lower_file = NULL;
+
+	lower_file = sdcardfs_lower_file(file);
+	if (lower_file->f_op && lower_file->f_op->fasync)
+		err = lower_file->f_op->fasync(fd, lower_file, flag);
+
+	return err;
+}
+
+/*
+ * Sdcardfs cannot use generic_file_llseek as ->llseek, because it would
+ * only set the offset of the upper file.  So we have to implement our
+ * own method to set both the upper and lower file offsets
+ * consistently.
+ */
+static loff_t sdcardfs_file_llseek(struct file *file, loff_t offset, int whence)
+{
+	int err;
+	struct file *lower_file;
+
+	err = generic_file_llseek(file, offset, whence);
+	if (err < 0)
+		goto out;
+
+	lower_file = sdcardfs_lower_file(file);
+	err = generic_file_llseek(lower_file, offset, whence);
+
+out:
+	return err;
+}
+
+/*
+ * Sdcardfs read_iter, redirect modified iocb to lower read_iter
+ */
+ssize_t sdcardfs_read_iter(struct kiocb *iocb, struct iov_iter *iter)
+{
+	int err;
+	struct file *file = iocb->ki_filp, *lower_file;
+
+	lower_file = sdcardfs_lower_file(file);
+	if (!lower_file->f_op->read_iter) {
+		err = -EINVAL;
+		goto out;
+	}
+
+	get_file(lower_file); /* prevent lower_file from being released */
+	iocb->ki_filp = lower_file;
+	err = lower_file->f_op->read_iter(iocb, iter);
+	iocb->ki_filp = file;
+	fput(lower_file);
+	/* update upper inode atime as needed */
+	if (err >= 0 || err == -EIOCBQUEUED)
+		fsstack_copy_attr_atime(file->f_path.dentry->d_inode,
+					file_inode(lower_file));
+out:
+	return err;
+}
+
+/*
+ * Sdcardfs write_iter, redirect modified iocb to lower write_iter
+ */
+ssize_t sdcardfs_write_iter(struct kiocb *iocb, struct iov_iter *iter)
+{
+	int err;
+	struct file *file = iocb->ki_filp, *lower_file;
+	struct inode *inode = file->f_path.dentry->d_inode;
+
+	lower_file = sdcardfs_lower_file(file);
+	if (!lower_file->f_op->write_iter) {
+		err = -EINVAL;
+		goto out;
+	}
+
+	get_file(lower_file); /* prevent lower_file from being released */
+	iocb->ki_filp = lower_file;
+	err = lower_file->f_op->write_iter(iocb, iter);
+	iocb->ki_filp = file;
+	fput(lower_file);
+	/* update upper inode times/sizes as needed */
+	if (err >= 0 || err == -EIOCBQUEUED) {
+		if (sizeof(loff_t) > sizeof(long))
+			inode_lock(inode);
+		fsstack_copy_inode_size(inode, file_inode(lower_file));
+		fsstack_copy_attr_times(inode, file_inode(lower_file));
+		if (sizeof(loff_t) > sizeof(long))
+			inode_unlock(inode);
+	}
+out:
+	return err;
+}
+
+const struct file_operations sdcardfs_main_fops = {
+	.llseek		= generic_file_llseek,
+	.read		= sdcardfs_read,
+	.write		= sdcardfs_write,
+	.unlocked_ioctl	= sdcardfs_unlocked_ioctl,
+#ifdef CONFIG_COMPAT
+	.compat_ioctl	= sdcardfs_compat_ioctl,
+#endif
+	.mmap		= sdcardfs_mmap,
+	.open		= sdcardfs_open,
+	.flush		= sdcardfs_flush,
+	.release	= sdcardfs_file_release,
+	.fsync		= sdcardfs_fsync,
+	.fasync		= sdcardfs_fasync,
+	.read_iter	= sdcardfs_read_iter,
+	.write_iter	= sdcardfs_write_iter,
+};
+
+/* trimmed directory options */
+const struct file_operations sdcardfs_dir_fops = {
+	.llseek		= sdcardfs_file_llseek,
+	.read		= generic_read_dir,
+	.iterate	= sdcardfs_readdir,
+	.unlocked_ioctl	= sdcardfs_unlocked_ioctl,
+#ifdef CONFIG_COMPAT
+	.compat_ioctl	= sdcardfs_compat_ioctl,
+#endif
+	.open		= sdcardfs_open,
+	.release	= sdcardfs_file_release,
+	.flush		= sdcardfs_flush,
+	.fsync		= sdcardfs_fsync,
+	.fasync		= sdcardfs_fasync,
+};
diff --git a/fs/sdcardfs/inode.c b/fs/sdcardfs/inode.c
new file mode 100644
index 00000000..81fe9e6
--- /dev/null
+++ b/fs/sdcardfs/inode.c
@@ -0,0 +1,923 @@
+/*
+ * fs/sdcardfs/inode.c
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#include "sdcardfs.h"
+#include <linux/fs_struct.h>
+#include <linux/ratelimit.h>
+
+/* Do not directly use this function. Use OVERRIDE_CRED() instead. */
+const struct cred *override_fsids(struct sdcardfs_sb_info *sbi,
+		struct sdcardfs_inode_data *data)
+{
+	struct cred *cred;
+	const struct cred *old_cred;
+	uid_t uid;
+
+	cred = prepare_creds();
+	if (!cred)
+		return NULL;
+
+	if (sbi->options.gid_derivation) {
+		if (data->under_obb)
+			uid = AID_MEDIA_OBB;
+		else
+			uid = multiuser_get_uid(data->userid, sbi->options.fs_low_uid);
+	} else {
+		uid = sbi->options.fs_low_uid;
+	}
+	cred->fsuid = make_kuid(&init_user_ns, uid);
+	cred->fsgid = make_kgid(&init_user_ns, sbi->options.fs_low_gid);
+
+	old_cred = override_creds(cred);
+
+	return old_cred;
+}
+
+/* Do not directly use this function, use REVERT_CRED() instead. */
+void revert_fsids(const struct cred *old_cred)
+{
+	const struct cred *cur_cred;
+
+	cur_cred = current->cred;
+	revert_creds(old_cred);
+	put_cred(cur_cred);
+}
+
+static int sdcardfs_create(struct inode *dir, struct dentry *dentry,
+			 umode_t mode, bool want_excl)
+{
+	int err;
+	struct dentry *lower_dentry;
+	struct vfsmount *lower_dentry_mnt;
+	struct dentry *lower_parent_dentry = NULL;
+	struct path lower_path;
+	const struct cred *saved_cred = NULL;
+	struct fs_struct *saved_fs;
+	struct fs_struct *copied_fs;
+
+	if (!check_caller_access_to_name(dir, &dentry->d_name)) {
+		err = -EACCES;
+		goto out_eacces;
+	}
+
+	/* save current_cred and override it */
+	OVERRIDE_CRED(SDCARDFS_SB(dir->i_sb), saved_cred, SDCARDFS_I(dir));
+
+	sdcardfs_get_lower_path(dentry, &lower_path);
+	lower_dentry = lower_path.dentry;
+	lower_dentry_mnt = lower_path.mnt;
+	lower_parent_dentry = lock_parent(lower_dentry);
+
+	/* set last 16bytes of mode field to 0664 */
+	mode = (mode & S_IFMT) | 00664;
+
+	/* temporarily change umask for lower fs write */
+	saved_fs = current->fs;
+	copied_fs = copy_fs_struct(current->fs);
+	if (!copied_fs) {
+		err = -ENOMEM;
+		goto out_unlock;
+	}
+	current->fs = copied_fs;
+	current->fs->umask = 0;
+	err = vfs_create2(lower_dentry_mnt, d_inode(lower_parent_dentry), lower_dentry, mode, want_excl);
+	if (err)
+		goto out;
+
+	err = sdcardfs_interpose(dentry, dir->i_sb, &lower_path,
+			SDCARDFS_I(dir)->data->userid);
+	if (err)
+		goto out;
+	fsstack_copy_attr_times(dir, sdcardfs_lower_inode(dir));
+	fsstack_copy_inode_size(dir, d_inode(lower_parent_dentry));
+	fixup_lower_ownership(dentry, dentry->d_name.name);
+
+out:
+	current->fs = saved_fs;
+	free_fs_struct(copied_fs);
+out_unlock:
+	unlock_dir(lower_parent_dentry);
+	sdcardfs_put_lower_path(dentry, &lower_path);
+	REVERT_CRED(saved_cred);
+out_eacces:
+	return err;
+}
+
+#if 0
+static int sdcardfs_link(struct dentry *old_dentry, struct inode *dir,
+		       struct dentry *new_dentry)
+{
+	struct dentry *lower_old_dentry;
+	struct dentry *lower_new_dentry;
+	struct dentry *lower_dir_dentry;
+	u64 file_size_save;
+	int err;
+	struct path lower_old_path, lower_new_path;
+
+	OVERRIDE_CRED(SDCARDFS_SB(dir->i_sb));
+
+	file_size_save = i_size_read(d_inode(old_dentry));
+	sdcardfs_get_lower_path(old_dentry, &lower_old_path);
+	sdcardfs_get_lower_path(new_dentry, &lower_new_path);
+	lower_old_dentry = lower_old_path.dentry;
+	lower_new_dentry = lower_new_path.dentry;
+	lower_dir_dentry = lock_parent(lower_new_dentry);
+
+	err = vfs_link(lower_old_dentry, d_inode(lower_dir_dentry),
+		       lower_new_dentry, NULL);
+	if (err || !d_inode(lower_new_dentry))
+		goto out;
+
+	err = sdcardfs_interpose(new_dentry, dir->i_sb, &lower_new_path);
+	if (err)
+		goto out;
+	fsstack_copy_attr_times(dir, d_inode(lower_new_dentry));
+	fsstack_copy_inode_size(dir, d_inode(lower_new_dentry));
+	set_nlink(d_inode(old_dentry),
+		  sdcardfs_lower_inode(d_inode(old_dentry))->i_nlink);
+	i_size_write(d_inode(new_dentry), file_size_save);
+out:
+	unlock_dir(lower_dir_dentry);
+	sdcardfs_put_lower_path(old_dentry, &lower_old_path);
+	sdcardfs_put_lower_path(new_dentry, &lower_new_path);
+	REVERT_CRED();
+	return err;
+}
+#endif
+
+static int sdcardfs_unlink(struct inode *dir, struct dentry *dentry)
+{
+	int err;
+	struct dentry *lower_dentry;
+	struct vfsmount *lower_mnt;
+	struct inode *lower_dir_inode = sdcardfs_lower_inode(dir);
+	struct dentry *lower_dir_dentry;
+	struct path lower_path;
+	const struct cred *saved_cred = NULL;
+
+	if (!check_caller_access_to_name(dir, &dentry->d_name)) {
+		err = -EACCES;
+		goto out_eacces;
+	}
+
+	/* save current_cred and override it */
+	OVERRIDE_CRED(SDCARDFS_SB(dir->i_sb), saved_cred, SDCARDFS_I(dir));
+
+	sdcardfs_get_lower_path(dentry, &lower_path);
+	lower_dentry = lower_path.dentry;
+	lower_mnt = lower_path.mnt;
+	dget(lower_dentry);
+	lower_dir_dentry = lock_parent(lower_dentry);
+
+	err = vfs_unlink2(lower_mnt, lower_dir_inode, lower_dentry, NULL);
+
+	/*
+	 * Note: unlinking on top of NFS can cause silly-renamed files.
+	 * Trying to delete such files results in EBUSY from NFS
+	 * below.  Silly-renamed files will get deleted by NFS later on, so
+	 * we just need to detect them here and treat such EBUSY errors as
+	 * if the upper file was successfully deleted.
+	 */
+	if (err == -EBUSY && lower_dentry->d_flags & DCACHE_NFSFS_RENAMED)
+		err = 0;
+	if (err)
+		goto out;
+	fsstack_copy_attr_times(dir, lower_dir_inode);
+	fsstack_copy_inode_size(dir, lower_dir_inode);
+	set_nlink(d_inode(dentry),
+		  sdcardfs_lower_inode(d_inode(dentry))->i_nlink);
+	d_inode(dentry)->i_ctime = dir->i_ctime;
+	d_drop(dentry); /* this is needed, else LTP fails (VFS won't do it) */
+out:
+	unlock_dir(lower_dir_dentry);
+	dput(lower_dentry);
+	sdcardfs_put_lower_path(dentry, &lower_path);
+	REVERT_CRED(saved_cred);
+out_eacces:
+	return err;
+}
+
+#if 0
+static int sdcardfs_symlink(struct inode *dir, struct dentry *dentry,
+			  const char *symname)
+{
+	int err;
+	struct dentry *lower_dentry;
+	struct dentry *lower_parent_dentry = NULL;
+	struct path lower_path;
+
+	OVERRIDE_CRED(SDCARDFS_SB(dir->i_sb));
+
+	sdcardfs_get_lower_path(dentry, &lower_path);
+	lower_dentry = lower_path.dentry;
+	lower_parent_dentry = lock_parent(lower_dentry);
+
+	err = vfs_symlink(d_inode(lower_parent_dentry), lower_dentry, symname);
+	if (err)
+		goto out;
+	err = sdcardfs_interpose(dentry, dir->i_sb, &lower_path);
+	if (err)
+		goto out;
+	fsstack_copy_attr_times(dir, sdcardfs_lower_inode(dir));
+	fsstack_copy_inode_size(dir, d_inode(lower_parent_dentry));
+
+out:
+	unlock_dir(lower_parent_dentry);
+	sdcardfs_put_lower_path(dentry, &lower_path);
+	REVERT_CRED();
+	return err;
+}
+#endif
+
+static int touch(char *abs_path, mode_t mode)
+{
+	struct file *filp = filp_open(abs_path, O_RDWR|O_CREAT|O_EXCL|O_NOFOLLOW, mode);
+
+	if (IS_ERR(filp)) {
+		if (PTR_ERR(filp) == -EEXIST) {
+			return 0;
+		} else {
+			pr_err("sdcardfs: failed to open(%s): %ld\n",
+						abs_path, PTR_ERR(filp));
+			return PTR_ERR(filp);
+		}
+	}
+	filp_close(filp, current->files);
+	return 0;
+}
+
+static int sdcardfs_mkdir(struct inode *dir, struct dentry *dentry, umode_t mode)
+{
+	int err;
+	int make_nomedia_in_obb = 0;
+	struct dentry *lower_dentry;
+	struct vfsmount *lower_mnt;
+	struct dentry *lower_parent_dentry = NULL;
+	struct dentry *parent_dentry = NULL;
+	struct path lower_path;
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dentry->d_sb);
+	const struct cred *saved_cred = NULL;
+	struct sdcardfs_inode_data *pd = SDCARDFS_I(dir)->data;
+	int touch_err = 0;
+	struct fs_struct *saved_fs;
+	struct fs_struct *copied_fs;
+	struct qstr q_obb = QSTR_LITERAL("obb");
+	struct qstr q_data = QSTR_LITERAL("data");
+
+	if (!check_caller_access_to_name(dir, &dentry->d_name)) {
+		err = -EACCES;
+		goto out_eacces;
+	}
+
+	/* save current_cred and override it */
+	OVERRIDE_CRED(SDCARDFS_SB(dir->i_sb), saved_cred, SDCARDFS_I(dir));
+
+	/* check disk space */
+	parent_dentry = dget_parent(dentry);
+	if (!check_min_free_space(parent_dentry, 0, 1)) {
+		pr_err("sdcardfs: No minimum free space.\n");
+		err = -ENOSPC;
+		dput(parent_dentry);
+		goto out_revert;
+	}
+	dput(parent_dentry);
+
+	/* the lower_dentry is negative here */
+	sdcardfs_get_lower_path(dentry, &lower_path);
+	lower_dentry = lower_path.dentry;
+	lower_mnt = lower_path.mnt;
+	lower_parent_dentry = lock_parent(lower_dentry);
+
+	/* set last 16bytes of mode field to 0775 */
+	mode = (mode & S_IFMT) | 00775;
+
+	/* temporarily change umask for lower fs write */
+	saved_fs = current->fs;
+	copied_fs = copy_fs_struct(current->fs);
+	if (!copied_fs) {
+		err = -ENOMEM;
+		unlock_dir(lower_parent_dentry);
+		goto out_unlock;
+	}
+	current->fs = copied_fs;
+	current->fs->umask = 0;
+	err = vfs_mkdir2(lower_mnt, d_inode(lower_parent_dentry), lower_dentry, mode);
+
+	if (err) {
+		unlock_dir(lower_parent_dentry);
+		goto out;
+	}
+
+	/* if it is a local obb dentry, setup it with the base obbpath */
+	if (need_graft_path(dentry)) {
+
+		err = setup_obb_dentry(dentry, &lower_path);
+		if (err) {
+			/* if the sbi->obbpath is not available, the lower_path won't be
+			 * changed by setup_obb_dentry() but the lower path is saved to
+			 * its orig_path. this dentry will be revalidated later.
+			 * but now, the lower_path should be NULL
+			 */
+			sdcardfs_put_reset_lower_path(dentry);
+
+			/* the newly created lower path which saved to its orig_path or
+			 * the lower_path is the base obbpath.
+			 * therefore, an additional path_get is required
+			 */
+			path_get(&lower_path);
+		} else
+			make_nomedia_in_obb = 1;
+	}
+
+	err = sdcardfs_interpose(dentry, dir->i_sb, &lower_path, pd->userid);
+	if (err) {
+		unlock_dir(lower_parent_dentry);
+		goto out;
+	}
+
+	fsstack_copy_attr_times(dir, sdcardfs_lower_inode(dir));
+	fsstack_copy_inode_size(dir, d_inode(lower_parent_dentry));
+	/* update number of links on parent directory */
+	set_nlink(dir, sdcardfs_lower_inode(dir)->i_nlink);
+	fixup_lower_ownership(dentry, dentry->d_name.name);
+	unlock_dir(lower_parent_dentry);
+	if ((!sbi->options.multiuser) && (qstr_case_eq(&dentry->d_name, &q_obb))
+		&& (pd->perm == PERM_ANDROID) && (pd->userid == 0))
+		make_nomedia_in_obb = 1;
+
+	/* When creating /Android/data and /Android/obb, mark them as .nomedia */
+	if (make_nomedia_in_obb ||
+		((pd->perm == PERM_ANDROID)
+				&& (qstr_case_eq(&dentry->d_name, &q_data)))) {
+		REVERT_CRED(saved_cred);
+		OVERRIDE_CRED(SDCARDFS_SB(dir->i_sb), saved_cred, SDCARDFS_I(d_inode(dentry)));
+		set_fs_pwd(current->fs, &lower_path);
+		touch_err = touch(".nomedia", 0664);
+		if (touch_err) {
+			pr_err("sdcardfs: failed to create .nomedia in %s: %d\n",
+							lower_path.dentry->d_name.name, touch_err);
+			goto out;
+		}
+	}
+out:
+	current->fs = saved_fs;
+	free_fs_struct(copied_fs);
+out_unlock:
+	sdcardfs_put_lower_path(dentry, &lower_path);
+out_revert:
+	REVERT_CRED(saved_cred);
+out_eacces:
+	return err;
+}
+
+static int sdcardfs_rmdir(struct inode *dir, struct dentry *dentry)
+{
+	struct dentry *lower_dentry;
+	struct dentry *lower_dir_dentry;
+	struct vfsmount *lower_mnt;
+	int err;
+	struct path lower_path;
+	const struct cred *saved_cred = NULL;
+
+	if (!check_caller_access_to_name(dir, &dentry->d_name)) {
+		err = -EACCES;
+		goto out_eacces;
+	}
+
+	/* save current_cred and override it */
+	OVERRIDE_CRED(SDCARDFS_SB(dir->i_sb), saved_cred, SDCARDFS_I(dir));
+
+	/* sdcardfs_get_real_lower(): in case of remove an user's obb dentry
+	 * the dentry on the original path should be deleted.
+	 */
+	sdcardfs_get_real_lower(dentry, &lower_path);
+
+	lower_dentry = lower_path.dentry;
+	lower_mnt = lower_path.mnt;
+	lower_dir_dentry = lock_parent(lower_dentry);
+
+	err = vfs_rmdir2(lower_mnt, d_inode(lower_dir_dentry), lower_dentry);
+	if (err)
+		goto out;
+
+	d_drop(dentry);	/* drop our dentry on success (why not VFS's job?) */
+	if (d_inode(dentry))
+		clear_nlink(d_inode(dentry));
+	fsstack_copy_attr_times(dir, d_inode(lower_dir_dentry));
+	fsstack_copy_inode_size(dir, d_inode(lower_dir_dentry));
+	set_nlink(dir, d_inode(lower_dir_dentry)->i_nlink);
+
+out:
+	unlock_dir(lower_dir_dentry);
+	sdcardfs_put_real_lower(dentry, &lower_path);
+	REVERT_CRED(saved_cred);
+out_eacces:
+	return err;
+}
+
+#if 0
+static int sdcardfs_mknod(struct inode *dir, struct dentry *dentry, umode_t mode,
+			dev_t dev)
+{
+	int err;
+	struct dentry *lower_dentry;
+	struct dentry *lower_parent_dentry = NULL;
+	struct path lower_path;
+
+	OVERRIDE_CRED(SDCARDFS_SB(dir->i_sb));
+
+	sdcardfs_get_lower_path(dentry, &lower_path);
+	lower_dentry = lower_path.dentry;
+	lower_parent_dentry = lock_parent(lower_dentry);
+
+	err = vfs_mknod(d_inode(lower_parent_dentry), lower_dentry, mode, dev);
+	if (err)
+		goto out;
+
+	err = sdcardfs_interpose(dentry, dir->i_sb, &lower_path);
+	if (err)
+		goto out;
+	fsstack_copy_attr_times(dir, sdcardfs_lower_inode(dir));
+	fsstack_copy_inode_size(dir, d_inode(lower_parent_dentry));
+
+out:
+	unlock_dir(lower_parent_dentry);
+	sdcardfs_put_lower_path(dentry, &lower_path);
+	REVERT_CRED();
+	return err;
+}
+#endif
+
+/*
+ * The locking rules in sdcardfs_rename are complex.  We could use a simpler
+ * superblock-level name-space lock for renames and copy-ups.
+ */
+static int sdcardfs_rename(struct inode *old_dir, struct dentry *old_dentry,
+			 struct inode *new_dir, struct dentry *new_dentry,
+			 unsigned int flags)
+{
+	int err = 0;
+	struct dentry *lower_old_dentry = NULL;
+	struct dentry *lower_new_dentry = NULL;
+	struct dentry *lower_old_dir_dentry = NULL;
+	struct dentry *lower_new_dir_dentry = NULL;
+	struct vfsmount *lower_mnt = NULL;
+	struct dentry *trap = NULL;
+	struct path lower_old_path, lower_new_path;
+	const struct cred *saved_cred = NULL;
+
+	if (flags)
+		return -EINVAL;
+
+	if (!check_caller_access_to_name(old_dir, &old_dentry->d_name) ||
+		!check_caller_access_to_name(new_dir, &new_dentry->d_name)) {
+		err = -EACCES;
+		goto out_eacces;
+	}
+
+	/* save current_cred and override it */
+	OVERRIDE_CRED(SDCARDFS_SB(old_dir->i_sb), saved_cred, SDCARDFS_I(new_dir));
+
+	sdcardfs_get_real_lower(old_dentry, &lower_old_path);
+	sdcardfs_get_lower_path(new_dentry, &lower_new_path);
+	lower_old_dentry = lower_old_path.dentry;
+	lower_new_dentry = lower_new_path.dentry;
+	lower_mnt = lower_old_path.mnt;
+	lower_old_dir_dentry = dget_parent(lower_old_dentry);
+	lower_new_dir_dentry = dget_parent(lower_new_dentry);
+
+	trap = lock_rename(lower_old_dir_dentry, lower_new_dir_dentry);
+	/* source should not be ancestor of target */
+	if (trap == lower_old_dentry) {
+		err = -EINVAL;
+		goto out;
+	}
+	/* target should not be ancestor of source */
+	if (trap == lower_new_dentry) {
+		err = -ENOTEMPTY;
+		goto out;
+	}
+
+	err = vfs_rename2(lower_mnt,
+			 d_inode(lower_old_dir_dentry), lower_old_dentry,
+			 d_inode(lower_new_dir_dentry), lower_new_dentry,
+			 NULL, 0);
+	if (err)
+		goto out;
+
+	/* Copy attrs from lower dir, but i_uid/i_gid */
+	sdcardfs_copy_and_fix_attrs(new_dir, d_inode(lower_new_dir_dentry));
+	fsstack_copy_inode_size(new_dir, d_inode(lower_new_dir_dentry));
+
+	if (new_dir != old_dir) {
+		sdcardfs_copy_and_fix_attrs(old_dir, d_inode(lower_old_dir_dentry));
+		fsstack_copy_inode_size(old_dir, d_inode(lower_old_dir_dentry));
+	}
+	get_derived_permission_new(new_dentry->d_parent, old_dentry, &new_dentry->d_name);
+	fixup_tmp_permissions(d_inode(old_dentry));
+	fixup_lower_ownership(old_dentry, new_dentry->d_name.name);
+	d_invalidate(old_dentry); /* Can't fixup ownership recursively :( */
+out:
+	unlock_rename(lower_old_dir_dentry, lower_new_dir_dentry);
+	dput(lower_old_dir_dentry);
+	dput(lower_new_dir_dentry);
+	sdcardfs_put_real_lower(old_dentry, &lower_old_path);
+	sdcardfs_put_lower_path(new_dentry, &lower_new_path);
+	REVERT_CRED(saved_cred);
+out_eacces:
+	return err;
+}
+
+#if 0
+static int sdcardfs_readlink(struct dentry *dentry, char __user *buf, int bufsiz)
+{
+	int err;
+	struct dentry *lower_dentry;
+	struct path lower_path;
+	/* XXX readlink does not requires overriding credential */
+
+	sdcardfs_get_lower_path(dentry, &lower_path);
+	lower_dentry = lower_path.dentry;
+	if (!d_inode(lower_dentry)->i_op ||
+	    !d_inode(lower_dentry)->i_op->readlink) {
+		err = -EINVAL;
+		goto out;
+	}
+
+	err = d_inode(lower_dentry)->i_op->readlink(lower_dentry,
+						    buf, bufsiz);
+	if (err < 0)
+		goto out;
+	fsstack_copy_attr_atime(d_inode(dentry), d_inode(lower_dentry));
+
+out:
+	sdcardfs_put_lower_path(dentry, &lower_path);
+	return err;
+}
+#endif
+
+#if 0
+static const char *sdcardfs_follow_link(struct dentry *dentry, void **cookie)
+{
+	char *buf;
+	int len = PAGE_SIZE, err;
+	mm_segment_t old_fs;
+
+	/* This is freed by the put_link method assuming a successful call. */
+	buf = kmalloc(len, GFP_KERNEL);
+	if (!buf) {
+		buf = ERR_PTR(-ENOMEM);
+		return buf;
+	}
+
+	/* read the symlink, and then we will follow it */
+	old_fs = get_fs();
+	set_fs(KERNEL_DS);
+	err = sdcardfs_readlink(dentry, buf, len);
+	set_fs(old_fs);
+	if (err < 0) {
+		kfree(buf);
+		buf = ERR_PTR(err);
+	} else {
+		buf[err] = '\0';
+	}
+	return *cookie = buf;
+}
+#endif
+
+static int sdcardfs_permission_wrn(struct inode *inode, int mask)
+{
+	WARN_RATELIMIT(1, "sdcardfs does not support permission. Use permission2.\n");
+	return -EINVAL;
+}
+
+void copy_attrs(struct inode *dest, const struct inode *src)
+{
+	dest->i_mode = src->i_mode;
+	dest->i_uid = src->i_uid;
+	dest->i_gid = src->i_gid;
+	dest->i_rdev = src->i_rdev;
+	dest->i_atime = src->i_atime;
+	dest->i_mtime = src->i_mtime;
+	dest->i_ctime = src->i_ctime;
+	dest->i_blkbits = src->i_blkbits;
+	dest->i_flags = src->i_flags;
+#ifdef CONFIG_FS_POSIX_ACL
+	dest->i_acl = src->i_acl;
+#endif
+#ifdef CONFIG_SECURITY
+	dest->i_security = src->i_security;
+#endif
+}
+
+static int sdcardfs_permission(struct vfsmount *mnt, struct inode *inode, int mask)
+{
+	int err;
+	struct inode tmp;
+	struct sdcardfs_inode_data *top = top_data_get(SDCARDFS_I(inode));
+
+	if (IS_ERR(mnt))
+		return PTR_ERR(mnt);
+	if (!top)
+		return -EINVAL;
+
+	/*
+	 * Permission check on sdcardfs inode.
+	 * Calling process should have AID_SDCARD_RW permission
+	 * Since generic_permission only needs i_mode, i_uid,
+	 * i_gid, and i_sb, we can create a fake inode to pass
+	 * this information down in.
+	 *
+	 * The underlying code may attempt to take locks in some
+	 * cases for features we're not using, but if that changes,
+	 * locks must be dealt with to avoid undefined behavior.
+	 */
+	copy_attrs(&tmp, inode);
+	tmp.i_uid = make_kuid(&init_user_ns, top->d_uid);
+	tmp.i_gid = make_kgid(&init_user_ns, get_gid(mnt, inode->i_sb, top));
+	tmp.i_mode = (inode->i_mode & S_IFMT)
+			| get_mode(mnt, SDCARDFS_I(inode), top);
+	data_put(top);
+	tmp.i_sb = inode->i_sb;
+	if (IS_POSIXACL(inode))
+		pr_warn("%s: This may be undefined behavior...\n", __func__);
+	err = generic_permission(&tmp, mask);
+	/* XXX
+	 * Original sdcardfs code calls inode_permission(lower_inode,.. )
+	 * for checking inode permission. But doing such things here seems
+	 * duplicated work, because the functions called after this func,
+	 * such as vfs_create, vfs_unlink, vfs_rename, and etc,
+	 * does exactly same thing, i.e., they calls inode_permission().
+	 * So we just let they do the things.
+	 * If there are any security hole, just uncomment following if block.
+	 */
+#if 0
+	if (!err) {
+		/*
+		 * Permission check on lower_inode(=EXT4).
+		 * we check it with AID_MEDIA_RW permission
+		 */
+		struct inode *lower_inode;
+
+		OVERRIDE_CRED(SDCARDFS_SB(inode->sb));
+
+		lower_inode = sdcardfs_lower_inode(inode);
+		err = inode_permission(lower_inode, mask);
+
+		REVERT_CRED();
+	}
+#endif
+	return err;
+
+}
+
+static int sdcardfs_setattr_wrn(struct dentry *dentry, struct iattr *ia)
+{
+	WARN_RATELIMIT(1, "sdcardfs does not support setattr. User setattr2.\n");
+	return -EINVAL;
+}
+
+static int sdcardfs_setattr(struct vfsmount *mnt, struct dentry *dentry, struct iattr *ia)
+{
+	int err;
+	struct dentry *lower_dentry;
+	struct vfsmount *lower_mnt;
+	struct inode *inode;
+	struct inode *lower_inode;
+	struct path lower_path;
+	struct iattr lower_ia;
+	struct dentry *parent;
+	struct inode tmp;
+	struct dentry tmp_d;
+	struct sdcardfs_inode_data *top;
+
+	const struct cred *saved_cred = NULL;
+
+	inode = d_inode(dentry);
+	top = top_data_get(SDCARDFS_I(inode));
+
+	if (!top)
+		return -EINVAL;
+
+	/*
+	 * Permission check on sdcardfs inode.
+	 * Calling process should have AID_SDCARD_RW permission
+	 * Since generic_permission only needs i_mode, i_uid,
+	 * i_gid, and i_sb, we can create a fake inode to pass
+	 * this information down in.
+	 *
+	 * The underlying code may attempt to take locks in some
+	 * cases for features we're not using, but if that changes,
+	 * locks must be dealt with to avoid undefined behavior.
+	 *
+	 */
+	copy_attrs(&tmp, inode);
+	tmp.i_uid = make_kuid(&init_user_ns, top->d_uid);
+	tmp.i_gid = make_kgid(&init_user_ns, get_gid(mnt, dentry->d_sb, top));
+	tmp.i_mode = (inode->i_mode & S_IFMT)
+			| get_mode(mnt, SDCARDFS_I(inode), top);
+	tmp.i_size = i_size_read(inode);
+	data_put(top);
+	tmp.i_sb = inode->i_sb;
+	tmp_d.d_inode = &tmp;
+
+	/*
+	 * Check if user has permission to change dentry.  We don't check if
+	 * this user can change the lower inode: that should happen when
+	 * calling notify_change on the lower inode.
+	 */
+	/* prepare our own lower struct iattr (with the lower file) */
+	memcpy(&lower_ia, ia, sizeof(lower_ia));
+	/* Allow touch updating timestamps. A previous permission check ensures
+	 * we have write access. Changes to mode, owner, and group are ignored
+	 */
+	ia->ia_valid |= ATTR_FORCE;
+	err = setattr_prepare(&tmp_d, ia);
+
+	if (!err) {
+		/* check the Android group ID */
+		parent = dget_parent(dentry);
+		if (!check_caller_access_to_name(d_inode(parent), &dentry->d_name))
+			err = -EACCES;
+		dput(parent);
+	}
+
+	if (err)
+		goto out_err;
+
+	/* save current_cred and override it */
+	OVERRIDE_CRED(SDCARDFS_SB(dentry->d_sb), saved_cred, SDCARDFS_I(inode));
+
+	sdcardfs_get_lower_path(dentry, &lower_path);
+	lower_dentry = lower_path.dentry;
+	lower_mnt = lower_path.mnt;
+	lower_inode = sdcardfs_lower_inode(inode);
+
+	if (ia->ia_valid & ATTR_FILE)
+		lower_ia.ia_file = sdcardfs_lower_file(ia->ia_file);
+
+	lower_ia.ia_valid &= ~(ATTR_UID | ATTR_GID | ATTR_MODE);
+
+	/*
+	 * If shrinking, first truncate upper level to cancel writing dirty
+	 * pages beyond the new eof; and also if its' maxbytes is more
+	 * limiting (fail with -EFBIG before making any change to the lower
+	 * level).  There is no need to vmtruncate the upper level
+	 * afterwards in the other cases: we fsstack_copy_inode_size from
+	 * the lower level.
+	 */
+	if (ia->ia_valid & ATTR_SIZE) {
+		err = inode_newsize_ok(&tmp, ia->ia_size);
+		if (err) {
+			goto out;
+		}
+		truncate_setsize(inode, ia->ia_size);
+	}
+
+	/*
+	 * mode change is for clearing setuid/setgid bits. Allow lower fs
+	 * to interpret this in its own way.
+	 */
+	if (lower_ia.ia_valid & (ATTR_KILL_SUID | ATTR_KILL_SGID))
+		lower_ia.ia_valid &= ~ATTR_MODE;
+
+	/* notify the (possibly copied-up) lower inode */
+	/*
+	 * Note: we use d_inode(lower_dentry), because lower_inode may be
+	 * unlinked (no inode->i_sb and i_ino==0.  This happens if someone
+	 * tries to open(), unlink(), then ftruncate() a file.
+	 */
+	inode_lock(d_inode(lower_dentry));
+	err = notify_change2(lower_mnt, lower_dentry, &lower_ia, /* note: lower_ia */
+			NULL);
+	inode_unlock(d_inode(lower_dentry));
+	if (err)
+		goto out;
+
+	/* get attributes from the lower inode and update derived permissions */
+	sdcardfs_copy_and_fix_attrs(inode, lower_inode);
+
+	/*
+	 * Not running fsstack_copy_inode_size(inode, lower_inode), because
+	 * VFS should update our inode size, and notify_change on
+	 * lower_inode should update its size.
+	 */
+
+out:
+	sdcardfs_put_lower_path(dentry, &lower_path);
+	REVERT_CRED(saved_cred);
+out_err:
+	return err;
+}
+
+static int sdcardfs_fillattr(struct vfsmount *mnt, struct inode *inode,
+				struct kstat *lower_stat, struct kstat *stat)
+{
+	struct sdcardfs_inode_info *info = SDCARDFS_I(inode);
+	struct sdcardfs_inode_data *top = top_data_get(info);
+	struct super_block *sb = inode->i_sb;
+
+	if (!top)
+		return -EINVAL;
+
+	stat->dev = inode->i_sb->s_dev;
+	stat->ino = inode->i_ino;
+	stat->mode = (inode->i_mode  & S_IFMT) | get_mode(mnt, info, top);
+	stat->nlink = inode->i_nlink;
+	stat->uid = make_kuid(&init_user_ns, top->d_uid);
+	stat->gid = make_kgid(&init_user_ns, get_gid(mnt, sb, top));
+	stat->rdev = inode->i_rdev;
+	stat->size = lower_stat->size;
+	stat->atime = lower_stat->atime;
+	stat->mtime = lower_stat->mtime;
+	stat->ctime = lower_stat->ctime;
+	stat->blksize = lower_stat->blksize;
+	stat->blocks = lower_stat->blocks;
+	data_put(top);
+	return 0;
+}
+
+static int sdcardfs_getattr(struct vfsmount *mnt, struct dentry *dentry,
+		 struct kstat *stat)
+{
+	struct kstat lower_stat;
+	struct path lower_path;
+	struct dentry *parent;
+	int err;
+
+	parent = dget_parent(dentry);
+	if (!check_caller_access_to_name(d_inode(parent), &dentry->d_name)) {
+		dput(parent);
+		return -EACCES;
+	}
+	dput(parent);
+
+	sdcardfs_get_lower_path(dentry, &lower_path);
+	err = vfs_getattr(&lower_path, &lower_stat);
+	if (err)
+		goto out;
+	sdcardfs_copy_and_fix_attrs(d_inode(dentry),
+			      d_inode(lower_path.dentry));
+	err = sdcardfs_fillattr(mnt, d_inode(dentry), &lower_stat, stat);
+out:
+	sdcardfs_put_lower_path(dentry, &lower_path);
+	return err;
+}
+
+const struct inode_operations sdcardfs_symlink_iops = {
+	.permission2	= sdcardfs_permission,
+	.setattr2	= sdcardfs_setattr,
+	/* XXX Following operations are implemented,
+	 *     but FUSE(sdcard) or FAT does not support them
+	 *     These methods are *NOT* perfectly tested.
+	.readlink	= sdcardfs_readlink,
+	.follow_link	= sdcardfs_follow_link,
+	.put_link	= kfree_put_link,
+	 */
+};
+
+const struct inode_operations sdcardfs_dir_iops = {
+	.create		= sdcardfs_create,
+	.lookup		= sdcardfs_lookup,
+	.permission	= sdcardfs_permission_wrn,
+	.permission2	= sdcardfs_permission,
+	.unlink		= sdcardfs_unlink,
+	.mkdir		= sdcardfs_mkdir,
+	.rmdir		= sdcardfs_rmdir,
+	.rename		= sdcardfs_rename,
+	.setattr	= sdcardfs_setattr_wrn,
+	.setattr2	= sdcardfs_setattr,
+	.getattr	= sdcardfs_getattr,
+	/* XXX Following operations are implemented,
+	 *     but FUSE(sdcard) or FAT does not support them
+	 *     These methods are *NOT* perfectly tested.
+	.symlink	= sdcardfs_symlink,
+	.link		= sdcardfs_link,
+	.mknod		= sdcardfs_mknod,
+	 */
+};
+
+const struct inode_operations sdcardfs_main_iops = {
+	.permission	= sdcardfs_permission_wrn,
+	.permission2	= sdcardfs_permission,
+	.setattr	= sdcardfs_setattr_wrn,
+	.setattr2	= sdcardfs_setattr,
+	.getattr	= sdcardfs_getattr,
+};
diff --git a/fs/sdcardfs/lookup.c b/fs/sdcardfs/lookup.c
new file mode 100644
index 00000000..98051996
--- /dev/null
+++ b/fs/sdcardfs/lookup.c
@@ -0,0 +1,464 @@
+/*
+ * fs/sdcardfs/lookup.c
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#include "sdcardfs.h"
+#include "linux/delay.h"
+
+/* The dentry cache is just so we have properly sized dentries */
+static struct kmem_cache *sdcardfs_dentry_cachep;
+
+int sdcardfs_init_dentry_cache(void)
+{
+	sdcardfs_dentry_cachep =
+		kmem_cache_create("sdcardfs_dentry",
+				  sizeof(struct sdcardfs_dentry_info),
+				  0, SLAB_RECLAIM_ACCOUNT, NULL);
+
+	return sdcardfs_dentry_cachep ? 0 : -ENOMEM;
+}
+
+void sdcardfs_destroy_dentry_cache(void)
+{
+	kmem_cache_destroy(sdcardfs_dentry_cachep);
+}
+
+void free_dentry_private_data(struct dentry *dentry)
+{
+	kmem_cache_free(sdcardfs_dentry_cachep, dentry->d_fsdata);
+	dentry->d_fsdata = NULL;
+}
+
+/* allocate new dentry private data */
+int new_dentry_private_data(struct dentry *dentry)
+{
+	struct sdcardfs_dentry_info *info = SDCARDFS_D(dentry);
+
+	/* use zalloc to init dentry_info.lower_path */
+	info = kmem_cache_zalloc(sdcardfs_dentry_cachep, GFP_ATOMIC);
+	if (!info)
+		return -ENOMEM;
+
+	spin_lock_init(&info->lock);
+	dentry->d_fsdata = info;
+
+	return 0;
+}
+
+struct inode_data {
+	struct inode *lower_inode;
+	userid_t id;
+};
+
+static int sdcardfs_inode_test(struct inode *inode, void *candidate_data/*void *candidate_lower_inode*/)
+{
+	struct inode *current_lower_inode = sdcardfs_lower_inode(inode);
+	userid_t current_userid = SDCARDFS_I(inode)->data->userid;
+
+	if (current_lower_inode == ((struct inode_data *)candidate_data)->lower_inode &&
+			current_userid == ((struct inode_data *)candidate_data)->id)
+		return 1; /* found a match */
+	else
+		return 0; /* no match */
+}
+
+static int sdcardfs_inode_set(struct inode *inode, void *lower_inode)
+{
+	/* we do actual inode initialization in sdcardfs_iget */
+	return 0;
+}
+
+struct inode *sdcardfs_iget(struct super_block *sb, struct inode *lower_inode, userid_t id)
+{
+	struct sdcardfs_inode_info *info;
+	struct inode_data data;
+	struct inode *inode; /* the new inode to return */
+
+	if (!igrab(lower_inode))
+		return ERR_PTR(-ESTALE);
+
+	data.id = id;
+	data.lower_inode = lower_inode;
+	inode = iget5_locked(sb, /* our superblock */
+			     /*
+			      * hashval: we use inode number, but we can
+			      * also use "(unsigned long)lower_inode"
+			      * instead.
+			      */
+			     lower_inode->i_ino, /* hashval */
+			     sdcardfs_inode_test, /* inode comparison function */
+			     sdcardfs_inode_set, /* inode init function */
+			     &data); /* data passed to test+set fxns */
+	if (!inode) {
+		iput(lower_inode);
+		return ERR_PTR(-ENOMEM);
+	}
+	/* if found a cached inode, then just return it (after iput) */
+	if (!(inode->i_state & I_NEW)) {
+		iput(lower_inode);
+		return inode;
+	}
+
+	/* initialize new inode */
+	info = SDCARDFS_I(inode);
+
+	inode->i_ino = lower_inode->i_ino;
+	sdcardfs_set_lower_inode(inode, lower_inode);
+
+	inode->i_version++;
+
+	/* use different set of inode ops for symlinks & directories */
+	if (S_ISDIR(lower_inode->i_mode))
+		inode->i_op = &sdcardfs_dir_iops;
+	else if (S_ISLNK(lower_inode->i_mode))
+		inode->i_op = &sdcardfs_symlink_iops;
+	else
+		inode->i_op = &sdcardfs_main_iops;
+
+	/* use different set of file ops for directories */
+	if (S_ISDIR(lower_inode->i_mode))
+		inode->i_fop = &sdcardfs_dir_fops;
+	else
+		inode->i_fop = &sdcardfs_main_fops;
+
+	inode->i_mapping->a_ops = &sdcardfs_aops;
+
+	inode->i_atime.tv_sec = 0;
+	inode->i_atime.tv_nsec = 0;
+	inode->i_mtime.tv_sec = 0;
+	inode->i_mtime.tv_nsec = 0;
+	inode->i_ctime.tv_sec = 0;
+	inode->i_ctime.tv_nsec = 0;
+
+	/* properly initialize special inodes */
+	if (S_ISBLK(lower_inode->i_mode) || S_ISCHR(lower_inode->i_mode) ||
+	    S_ISFIFO(lower_inode->i_mode) || S_ISSOCK(lower_inode->i_mode))
+		init_special_inode(inode, lower_inode->i_mode,
+				   lower_inode->i_rdev);
+
+	/* all well, copy inode attributes */
+	sdcardfs_copy_and_fix_attrs(inode, lower_inode);
+	fsstack_copy_inode_size(inode, lower_inode);
+
+	unlock_new_inode(inode);
+	return inode;
+}
+
+/*
+ * Helper interpose routine, called directly by ->lookup to handle
+ * spliced dentries.
+ */
+static struct dentry *__sdcardfs_interpose(struct dentry *dentry,
+					 struct super_block *sb,
+					 struct path *lower_path,
+					 userid_t id)
+{
+	struct inode *inode;
+	struct inode *lower_inode;
+	struct super_block *lower_sb;
+	struct dentry *ret_dentry;
+
+	lower_inode = d_inode(lower_path->dentry);
+	lower_sb = sdcardfs_lower_super(sb);
+
+	/* check that the lower file system didn't cross a mount point */
+	if (lower_inode->i_sb != lower_sb) {
+		ret_dentry = ERR_PTR(-EXDEV);
+		goto out;
+	}
+
+	/*
+	 * We allocate our new inode below by calling sdcardfs_iget,
+	 * which will initialize some of the new inode's fields
+	 */
+
+	/* inherit lower inode number for sdcardfs's inode */
+	inode = sdcardfs_iget(sb, lower_inode, id);
+	if (IS_ERR(inode)) {
+		ret_dentry = ERR_CAST(inode);
+		goto out;
+	}
+
+	ret_dentry = d_splice_alias(inode, dentry);
+	dentry = ret_dentry ?: dentry;
+	if (!IS_ERR(dentry))
+		update_derived_permission_lock(dentry);
+out:
+	return ret_dentry;
+}
+
+/*
+ * Connect an sdcardfs inode dentry/inode with several lower ones.  This is
+ * the classic stackable file system "vnode interposition" action.
+ *
+ * @dentry: sdcardfs's dentry which interposes on lower one
+ * @sb: sdcardfs's super_block
+ * @lower_path: the lower path (caller does path_get/put)
+ */
+int sdcardfs_interpose(struct dentry *dentry, struct super_block *sb,
+		     struct path *lower_path, userid_t id)
+{
+	struct dentry *ret_dentry;
+
+	ret_dentry = __sdcardfs_interpose(dentry, sb, lower_path, id);
+	return PTR_ERR(ret_dentry);
+}
+
+struct sdcardfs_name_data {
+	struct dir_context ctx;
+	const struct qstr *to_find;
+	char *name;
+	bool found;
+};
+
+static int sdcardfs_name_match(struct dir_context *ctx, const char *name,
+		int namelen, loff_t offset, u64 ino, unsigned int d_type)
+{
+	struct sdcardfs_name_data *buf = container_of(ctx, struct sdcardfs_name_data, ctx);
+	struct qstr candidate = QSTR_INIT(name, namelen);
+
+	if (qstr_case_eq(buf->to_find, &candidate)) {
+		memcpy(buf->name, name, namelen);
+		buf->name[namelen] = 0;
+		buf->found = true;
+		return 1;
+	}
+	return 0;
+}
+
+/*
+ * Main driver function for sdcardfs's lookup.
+ *
+ * Returns: NULL (ok), ERR_PTR if an error occurred.
+ * Fills in lower_parent_path with <dentry,mnt> on success.
+ */
+static struct dentry *__sdcardfs_lookup(struct dentry *dentry,
+		unsigned int flags, struct path *lower_parent_path, userid_t id)
+{
+	int err = 0;
+	struct vfsmount *lower_dir_mnt;
+	struct dentry *lower_dir_dentry = NULL;
+	struct dentry *lower_dentry;
+	const struct qstr *name;
+	struct path lower_path;
+	struct qstr dname;
+	struct dentry *ret_dentry = NULL;
+	struct sdcardfs_sb_info *sbi;
+
+	sbi = SDCARDFS_SB(dentry->d_sb);
+	/* must initialize dentry operations */
+	d_set_d_op(dentry, &sdcardfs_ci_dops);
+
+	if (IS_ROOT(dentry))
+		goto out;
+
+	name = &dentry->d_name;
+
+	/* now start the actual lookup procedure */
+	lower_dir_dentry = lower_parent_path->dentry;
+	lower_dir_mnt = lower_parent_path->mnt;
+
+	/* Use vfs_path_lookup to check if the dentry exists or not */
+	err = vfs_path_lookup(lower_dir_dentry, lower_dir_mnt, name->name, 0,
+				&lower_path);
+	/* check for other cases */
+	if (err == -ENOENT) {
+		struct file *file;
+		const struct cred *cred = current_cred();
+
+		struct sdcardfs_name_data buffer = {
+			.ctx.actor = sdcardfs_name_match,
+			.to_find = name,
+			.name = __getname(),
+			.found = false,
+		};
+
+		if (!buffer.name) {
+			err = -ENOMEM;
+			goto out;
+		}
+		file = dentry_open(lower_parent_path, O_RDONLY, cred);
+		if (IS_ERR(file)) {
+			err = PTR_ERR(file);
+			goto put_name;
+		}
+		err = iterate_dir(file, &buffer.ctx);
+		fput(file);
+		if (err)
+			goto put_name;
+
+		if (buffer.found)
+			err = vfs_path_lookup(lower_dir_dentry,
+						lower_dir_mnt,
+						buffer.name, 0,
+						&lower_path);
+		else
+			err = -ENOENT;
+put_name:
+		__putname(buffer.name);
+	}
+
+	/* no error: handle positive dentries */
+	if (!err) {
+		/* check if the dentry is an obb dentry
+		 * if true, the lower_inode must be replaced with
+		 * the inode of the graft path
+		 */
+
+		if (need_graft_path(dentry)) {
+
+			/* setup_obb_dentry()
+			 * The lower_path will be stored to the dentry's orig_path
+			 * and the base obbpath will be copyed to the lower_path variable.
+			 * if an error returned, there's no change in the lower_path
+			 * returns: -ERRNO if error (0: no error)
+			 */
+			err = setup_obb_dentry(dentry, &lower_path);
+
+			if (err) {
+				/* if the sbi->obbpath is not available, we can optionally
+				 * setup the lower_path with its orig_path.
+				 * but, the current implementation just returns an error
+				 * because the sdcard daemon also regards this case as
+				 * a lookup fail.
+				 */
+				pr_info("sdcardfs: base obbpath is not available\n");
+				sdcardfs_put_reset_orig_path(dentry);
+				goto out;
+			}
+		}
+
+		sdcardfs_set_lower_path(dentry, &lower_path);
+		ret_dentry =
+			__sdcardfs_interpose(dentry, dentry->d_sb, &lower_path, id);
+		if (IS_ERR(ret_dentry)) {
+			err = PTR_ERR(ret_dentry);
+			 /* path_put underlying path on error */
+			sdcardfs_put_reset_lower_path(dentry);
+		}
+		goto out;
+	}
+
+	/*
+	 * We don't consider ENOENT an error, and we want to return a
+	 * negative dentry.
+	 */
+	if (err && err != -ENOENT)
+		goto out;
+
+	/* instatiate a new negative dentry */
+	dname.name = name->name;
+	dname.len = name->len;
+
+	/* See if the low-level filesystem might want
+	 * to use its own hash
+	 */
+	lower_dentry = d_hash_and_lookup(lower_dir_dentry, &dname);
+	if (IS_ERR(lower_dentry))
+		return lower_dentry;
+	if (!lower_dentry) {
+		/* We called vfs_path_lookup earlier, and did not get a negative
+		 * dentry then. Don't confuse the lower filesystem by forcing
+		 * one on it now...
+		 */
+		err = -ENOENT;
+		goto out;
+	}
+
+	lower_path.dentry = lower_dentry;
+	lower_path.mnt = mntget(lower_dir_mnt);
+	sdcardfs_set_lower_path(dentry, &lower_path);
+
+	/*
+	 * If the intent is to create a file, then don't return an error, so
+	 * the VFS will continue the process of making this negative dentry
+	 * into a positive one.
+	 */
+	if (flags & (LOOKUP_CREATE|LOOKUP_RENAME_TARGET))
+		err = 0;
+
+out:
+	if (err)
+		return ERR_PTR(err);
+	return ret_dentry;
+}
+
+/*
+ * On success:
+ * fills dentry object appropriate values and returns NULL.
+ * On fail (== error)
+ * returns error ptr
+ *
+ * @dir : Parent inode.
+ * @dentry : Target dentry to lookup. we should set each of fields.
+ *	     (dentry->d_name is initialized already)
+ * @nd : nameidata of parent inode
+ */
+struct dentry *sdcardfs_lookup(struct inode *dir, struct dentry *dentry,
+			     unsigned int flags)
+{
+	struct dentry *ret = NULL, *parent;
+	struct path lower_parent_path;
+	int err = 0;
+	const struct cred *saved_cred = NULL;
+
+	parent = dget_parent(dentry);
+
+	if (!check_caller_access_to_name(d_inode(parent), &dentry->d_name)) {
+		ret = ERR_PTR(-EACCES);
+		goto out_err;
+	}
+
+	/* save current_cred and override it */
+	OVERRIDE_CRED_PTR(SDCARDFS_SB(dir->i_sb), saved_cred, SDCARDFS_I(dir));
+
+	sdcardfs_get_lower_path(parent, &lower_parent_path);
+
+	/* allocate dentry private data.  We free it in ->d_release */
+	err = new_dentry_private_data(dentry);
+	if (err) {
+		ret = ERR_PTR(err);
+		goto out;
+	}
+
+	ret = __sdcardfs_lookup(dentry, flags, &lower_parent_path,
+				SDCARDFS_I(dir)->data->userid);
+	if (IS_ERR(ret))
+		goto out;
+	if (ret)
+		dentry = ret;
+	if (d_inode(dentry)) {
+		fsstack_copy_attr_times(d_inode(dentry),
+					sdcardfs_lower_inode(d_inode(dentry)));
+		/* get derived permission */
+		get_derived_permission(parent, dentry);
+		fixup_tmp_permissions(d_inode(dentry));
+		fixup_lower_ownership(dentry, dentry->d_name.name);
+	}
+	/* update parent directory's atime */
+	fsstack_copy_attr_atime(d_inode(parent),
+				sdcardfs_lower_inode(d_inode(parent)));
+
+out:
+	sdcardfs_put_lower_path(parent, &lower_parent_path);
+	REVERT_CRED(saved_cred);
+out_err:
+	dput(parent);
+	return ret;
+}
diff --git a/fs/sdcardfs/main.c b/fs/sdcardfs/main.c
new file mode 100644
index 00000000..27ec726
--- /dev/null
+++ b/fs/sdcardfs/main.c
@@ -0,0 +1,497 @@
+/*
+ * fs/sdcardfs/main.c
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#include "sdcardfs.h"
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/parser.h>
+
+enum {
+	Opt_fsuid,
+	Opt_fsgid,
+	Opt_gid,
+	Opt_debug,
+	Opt_mask,
+	Opt_multiuser,
+	Opt_userid,
+	Opt_reserved_mb,
+	Opt_gid_derivation,
+	Opt_default_normal,
+	Opt_err,
+};
+
+static const match_table_t sdcardfs_tokens = {
+	{Opt_fsuid, "fsuid=%u"},
+	{Opt_fsgid, "fsgid=%u"},
+	{Opt_gid, "gid=%u"},
+	{Opt_debug, "debug"},
+	{Opt_mask, "mask=%u"},
+	{Opt_userid, "userid=%d"},
+	{Opt_multiuser, "multiuser"},
+	{Opt_gid_derivation, "derive_gid"},
+	{Opt_default_normal, "default_normal"},
+	{Opt_reserved_mb, "reserved_mb=%u"},
+	{Opt_err, NULL}
+};
+
+static int parse_options(struct super_block *sb, char *options, int silent,
+				int *debug, struct sdcardfs_vfsmount_options *vfsopts,
+				struct sdcardfs_mount_options *opts)
+{
+	char *p;
+	substring_t args[MAX_OPT_ARGS];
+	int option;
+
+	/* by default, we use AID_MEDIA_RW as uid, gid */
+	opts->fs_low_uid = AID_MEDIA_RW;
+	opts->fs_low_gid = AID_MEDIA_RW;
+	vfsopts->mask = 0;
+	opts->multiuser = false;
+	opts->fs_user_id = 0;
+	vfsopts->gid = 0;
+	/* by default, 0MB is reserved */
+	opts->reserved_mb = 0;
+	/* by default, gid derivation is off */
+	opts->gid_derivation = false;
+	opts->default_normal = false;
+
+	*debug = 0;
+
+	if (!options)
+		return 0;
+
+	while ((p = strsep(&options, ",")) != NULL) {
+		int token;
+
+		if (!*p)
+			continue;
+
+		token = match_token(p, sdcardfs_tokens, args);
+
+		switch (token) {
+		case Opt_debug:
+			*debug = 1;
+			break;
+		case Opt_fsuid:
+			if (match_int(&args[0], &option))
+				return 0;
+			opts->fs_low_uid = option;
+			break;
+		case Opt_fsgid:
+			if (match_int(&args[0], &option))
+				return 0;
+			opts->fs_low_gid = option;
+			break;
+		case Opt_gid:
+			if (match_int(&args[0], &option))
+				return 0;
+			vfsopts->gid = option;
+			break;
+		case Opt_userid:
+			if (match_int(&args[0], &option))
+				return 0;
+			opts->fs_user_id = option;
+			break;
+		case Opt_mask:
+			if (match_int(&args[0], &option))
+				return 0;
+			vfsopts->mask = option;
+			break;
+		case Opt_multiuser:
+			opts->multiuser = true;
+			break;
+		case Opt_reserved_mb:
+			if (match_int(&args[0], &option))
+				return 0;
+			opts->reserved_mb = option;
+			break;
+		case Opt_gid_derivation:
+			opts->gid_derivation = true;
+			break;
+		case Opt_default_normal:
+			opts->default_normal = true;
+			break;
+		/* unknown option */
+		default:
+			if (!silent)
+				pr_err("Unrecognized mount option \"%s\" or missing value", p);
+			return -EINVAL;
+		}
+	}
+
+	if (*debug) {
+		pr_info("sdcardfs : options - debug:%d\n", *debug);
+		pr_info("sdcardfs : options - uid:%d\n",
+							opts->fs_low_uid);
+		pr_info("sdcardfs : options - gid:%d\n",
+							opts->fs_low_gid);
+	}
+
+	return 0;
+}
+
+int parse_options_remount(struct super_block *sb, char *options, int silent,
+				struct sdcardfs_vfsmount_options *vfsopts)
+{
+	char *p;
+	substring_t args[MAX_OPT_ARGS];
+	int option;
+	int debug;
+
+	if (!options)
+		return 0;
+
+	while ((p = strsep(&options, ",")) != NULL) {
+		int token;
+
+		if (!*p)
+			continue;
+
+		token = match_token(p, sdcardfs_tokens, args);
+
+		switch (token) {
+		case Opt_debug:
+			debug = 1;
+			break;
+		case Opt_gid:
+			if (match_int(&args[0], &option))
+				return 0;
+			vfsopts->gid = option;
+
+			break;
+		case Opt_mask:
+			if (match_int(&args[0], &option))
+				return 0;
+			vfsopts->mask = option;
+			break;
+		case Opt_default_normal:
+		case Opt_multiuser:
+		case Opt_userid:
+		case Opt_fsuid:
+		case Opt_fsgid:
+		case Opt_reserved_mb:
+			pr_warn("Option \"%s\" can't be changed during remount\n", p);
+			break;
+		/* unknown option */
+		default:
+			if (!silent)
+				pr_err("Unrecognized mount option \"%s\" or missing value", p);
+			return -EINVAL;
+		}
+	}
+
+	if (debug) {
+		pr_info("sdcardfs : options - debug:%d\n", debug);
+		pr_info("sdcardfs : options - gid:%d\n", vfsopts->gid);
+		pr_info("sdcardfs : options - mask:%d\n", vfsopts->mask);
+	}
+
+	return 0;
+}
+
+#if 0
+/*
+ * our custom d_alloc_root work-alike
+ *
+ * we can't use d_alloc_root if we want to use our own interpose function
+ * unchanged, so we simply call our own "fake" d_alloc_root
+ */
+static struct dentry *sdcardfs_d_alloc_root(struct super_block *sb)
+{
+	struct dentry *ret = NULL;
+
+	if (sb) {
+		static const struct qstr name = {
+			.name = "/",
+			.len = 1
+		};
+
+		ret = d_alloc(NULL, &name);
+		if (ret) {
+			d_set_d_op(ret, &sdcardfs_ci_dops);
+			ret->d_sb = sb;
+			ret->d_parent = ret;
+		}
+	}
+	return ret;
+}
+#endif
+
+DEFINE_MUTEX(sdcardfs_super_list_lock);
+EXPORT_SYMBOL_GPL(sdcardfs_super_list_lock);
+LIST_HEAD(sdcardfs_super_list);
+EXPORT_SYMBOL_GPL(sdcardfs_super_list);
+
+/*
+ * There is no need to lock the sdcardfs_super_info's rwsem as there is no
+ * way anyone can have a reference to the superblock at this point in time.
+ */
+static int sdcardfs_read_super(struct vfsmount *mnt, struct super_block *sb,
+		const char *dev_name, void *raw_data, int silent)
+{
+	int err = 0;
+	int debug;
+	struct super_block *lower_sb;
+	struct path lower_path;
+	struct sdcardfs_sb_info *sb_info;
+	struct sdcardfs_vfsmount_options *mnt_opt = mnt->data;
+	struct inode *inode;
+
+	pr_info("sdcardfs version 2.0\n");
+
+	if (!dev_name) {
+		pr_err("sdcardfs: read_super: missing dev_name argument\n");
+		err = -EINVAL;
+		goto out;
+	}
+
+	pr_info("sdcardfs: dev_name -> %s\n", dev_name);
+	pr_info("sdcardfs: options -> %s\n", (char *)raw_data);
+	pr_info("sdcardfs: mnt -> %p\n", mnt);
+
+	/* parse lower path */
+	err = kern_path(dev_name, LOOKUP_FOLLOW | LOOKUP_DIRECTORY,
+			&lower_path);
+	if (err) {
+		pr_err("sdcardfs: error accessing lower directory '%s'\n", dev_name);
+		goto out;
+	}
+
+	/* allocate superblock private data */
+	sb->s_fs_info = kzalloc(sizeof(struct sdcardfs_sb_info), GFP_KERNEL);
+	if (!SDCARDFS_SB(sb)) {
+		pr_crit("sdcardfs: read_super: out of memory\n");
+		err = -ENOMEM;
+		goto out_free;
+	}
+
+	sb_info = sb->s_fs_info;
+	/* parse options */
+	err = parse_options(sb, raw_data, silent, &debug, mnt_opt, &sb_info->options);
+	if (err) {
+		pr_err("sdcardfs: invalid options\n");
+		goto out_freesbi;
+	}
+
+	/* set the lower superblock field of upper superblock */
+	lower_sb = lower_path.dentry->d_sb;
+	atomic_inc(&lower_sb->s_active);
+	sdcardfs_set_lower_super(sb, lower_sb);
+
+	sb->s_stack_depth = lower_sb->s_stack_depth + 1;
+	if (sb->s_stack_depth > FILESYSTEM_MAX_STACK_DEPTH) {
+		pr_err("sdcardfs: maximum fs stacking depth exceeded\n");
+		err = -EINVAL;
+		goto out_sput;
+	}
+
+	/* inherit maxbytes from lower file system */
+	sb->s_maxbytes = lower_sb->s_maxbytes;
+
+	/*
+	 * Our c/m/atime granularity is 1 ns because we may stack on file
+	 * systems whose granularity is as good.
+	 */
+	sb->s_time_gran = 1;
+
+	sb->s_magic = SDCARDFS_SUPER_MAGIC;
+	sb->s_op = &sdcardfs_sops;
+
+	/* get a new inode and allocate our root dentry */
+	inode = sdcardfs_iget(sb, d_inode(lower_path.dentry), 0);
+	if (IS_ERR(inode)) {
+		err = PTR_ERR(inode);
+		goto out_sput;
+	}
+	sb->s_root = d_make_root(inode);
+	if (!sb->s_root) {
+		err = -ENOMEM;
+		goto out_sput;
+	}
+	d_set_d_op(sb->s_root, &sdcardfs_ci_dops);
+
+	/* link the upper and lower dentries */
+	sb->s_root->d_fsdata = NULL;
+	err = new_dentry_private_data(sb->s_root);
+	if (err)
+		goto out_freeroot;
+
+	/* set the lower dentries for s_root */
+	sdcardfs_set_lower_path(sb->s_root, &lower_path);
+
+	/*
+	 * No need to call interpose because we already have a positive
+	 * dentry, which was instantiated by d_make_root.  Just need to
+	 * d_rehash it.
+	 */
+	d_rehash(sb->s_root);
+
+	/* setup permission policy */
+	sb_info->obbpath_s = kzalloc(PATH_MAX, GFP_KERNEL);
+	mutex_lock(&sdcardfs_super_list_lock);
+	if (sb_info->options.multiuser) {
+		setup_derived_state(d_inode(sb->s_root), PERM_PRE_ROOT,
+				sb_info->options.fs_user_id, AID_ROOT);
+		snprintf(sb_info->obbpath_s, PATH_MAX, "%s/obb", dev_name);
+	} else {
+		setup_derived_state(d_inode(sb->s_root), PERM_ROOT,
+				sb_info->options.fs_user_id, AID_ROOT);
+		snprintf(sb_info->obbpath_s, PATH_MAX, "%s/Android/obb", dev_name);
+	}
+	fixup_tmp_permissions(d_inode(sb->s_root));
+	sb_info->sb = sb;
+	list_add(&sb_info->list, &sdcardfs_super_list);
+	mutex_unlock(&sdcardfs_super_list_lock);
+
+	if (!silent)
+		pr_info("sdcardfs: mounted on top of %s type %s\n",
+				dev_name, lower_sb->s_type->name);
+	goto out; /* all is well */
+
+	/* no longer needed: free_dentry_private_data(sb->s_root); */
+out_freeroot:
+	dput(sb->s_root);
+	sb->s_root = NULL;
+out_sput:
+	/* drop refs we took earlier */
+	atomic_dec(&lower_sb->s_active);
+out_freesbi:
+	kfree(SDCARDFS_SB(sb));
+	sb->s_fs_info = NULL;
+out_free:
+	path_put(&lower_path);
+
+out:
+	return err;
+}
+
+struct sdcardfs_mount_private {
+	struct vfsmount *mnt;
+	const char *dev_name;
+	void *raw_data;
+};
+
+static int __sdcardfs_fill_super(
+	struct super_block *sb,
+	void *_priv, int silent)
+{
+	struct sdcardfs_mount_private *priv = _priv;
+
+	return sdcardfs_read_super(priv->mnt,
+		sb, priv->dev_name, priv->raw_data, silent);
+}
+
+static struct dentry *sdcardfs_mount(struct vfsmount *mnt,
+		struct file_system_type *fs_type, int flags,
+			    const char *dev_name, void *raw_data)
+{
+	struct sdcardfs_mount_private priv = {
+		.mnt = mnt,
+		.dev_name = dev_name,
+		.raw_data = raw_data
+	};
+
+	return mount_nodev(fs_type, flags,
+		&priv, __sdcardfs_fill_super);
+}
+
+static struct dentry *sdcardfs_mount_wrn(struct file_system_type *fs_type,
+		    int flags, const char *dev_name, void *raw_data)
+{
+	WARN(1, "sdcardfs does not support mount. Use mount2.\n");
+	return ERR_PTR(-EINVAL);
+}
+
+void *sdcardfs_alloc_mnt_data(void)
+{
+	return kmalloc(sizeof(struct sdcardfs_vfsmount_options), GFP_KERNEL);
+}
+
+void sdcardfs_kill_sb(struct super_block *sb)
+{
+	struct sdcardfs_sb_info *sbi;
+
+	if (sb->s_magic == SDCARDFS_SUPER_MAGIC && sb->s_fs_info) {
+		sbi = SDCARDFS_SB(sb);
+		mutex_lock(&sdcardfs_super_list_lock);
+		list_del(&sbi->list);
+		mutex_unlock(&sdcardfs_super_list_lock);
+	}
+	kill_anon_super(sb);
+}
+
+static struct file_system_type sdcardfs_fs_type = {
+	.owner		= THIS_MODULE,
+	.name		= SDCARDFS_NAME,
+	.mount		= sdcardfs_mount_wrn,
+	.mount2		= sdcardfs_mount,
+	.alloc_mnt_data = sdcardfs_alloc_mnt_data,
+	.kill_sb	= sdcardfs_kill_sb,
+	.fs_flags	= 0,
+};
+MODULE_ALIAS_FS(SDCARDFS_NAME);
+
+static int __init init_sdcardfs_fs(void)
+{
+	int err;
+
+	pr_info("Registering sdcardfs " SDCARDFS_VERSION "\n");
+
+	err = sdcardfs_init_inode_cache();
+	if (err)
+		goto out;
+	err = sdcardfs_init_dentry_cache();
+	if (err)
+		goto out;
+	err = packagelist_init();
+	if (err)
+		goto out;
+	err = register_filesystem(&sdcardfs_fs_type);
+out:
+	if (err) {
+		sdcardfs_destroy_inode_cache();
+		sdcardfs_destroy_dentry_cache();
+		packagelist_exit();
+	}
+	return err;
+}
+
+static void __exit exit_sdcardfs_fs(void)
+{
+	sdcardfs_destroy_inode_cache();
+	sdcardfs_destroy_dentry_cache();
+	packagelist_exit();
+	unregister_filesystem(&sdcardfs_fs_type);
+	pr_info("Completed sdcardfs module unload\n");
+}
+
+/* Original wrapfs authors */
+MODULE_AUTHOR("Erez Zadok, Filesystems and Storage Lab, Stony Brook University (http://www.fsl.cs.sunysb.edu/)");
+
+/* Original sdcardfs authors */
+MODULE_AUTHOR("Woojoong Lee, Daeho Jeong, Kitae Lee, Yeongjin Gil System Memory Lab., Samsung Electronics");
+
+/* Current maintainer */
+MODULE_AUTHOR("Daniel Rosenberg, Google");
+MODULE_DESCRIPTION("Sdcardfs " SDCARDFS_VERSION);
+MODULE_LICENSE("GPL");
+
+module_init(init_sdcardfs_fs);
+module_exit(exit_sdcardfs_fs);
diff --git a/fs/sdcardfs/mmap.c b/fs/sdcardfs/mmap.c
new file mode 100644
index 00000000..e427f94
--- /dev/null
+++ b/fs/sdcardfs/mmap.c
@@ -0,0 +1,109 @@
+/*
+ * fs/sdcardfs/mmap.c
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#include "sdcardfs.h"
+
+static int sdcardfs_fault(struct vm_area_struct *vma, struct vm_fault *vmf)
+{
+	int err;
+	struct file *file;
+	const struct vm_operations_struct *lower_vm_ops;
+
+#ifdef CONFIG_RTK_PLATFORM
+	file = (struct file *)vma->vm_rtk_private_data;
+#else
+	file = (struct file *)vma->vm_private_data;
+#endif /* CONFIG_RTK_PLATFORM */
+
+	lower_vm_ops = SDCARDFS_F(file)->lower_vm_ops;
+
+	BUG_ON(!lower_vm_ops);
+
+	err = lower_vm_ops->fault(vma, vmf);
+
+	return err;
+}
+
+static void sdcardfs_vm_open(struct vm_area_struct *vma)
+{
+#ifdef CONFIG_RTK_PLATFORM
+	struct file *file = (struct file *)vma->vm_rtk_private_data;
+#else
+	struct file *file = (struct file *)vma->vm_private_data;
+#endif /* CONFIG_RTK_PLATFORM */
+
+	get_file(file);
+
+}
+
+static void sdcardfs_vm_close(struct vm_area_struct *vma)
+{
+#ifdef CONFIG_RTK_PLATFORM
+	struct file *file = (struct file *)vma->vm_rtk_private_data;
+#else
+	struct file *file = (struct file *)vma->vm_private_data;
+#endif /* CONFIG_RTK_PLATFORM */
+
+	fput(file);
+}
+
+static int sdcardfs_page_mkwrite(struct vm_area_struct *vma,
+			       struct vm_fault *vmf)
+{
+	int err = 0;
+	struct file *file;
+	const struct vm_operations_struct *lower_vm_ops;
+
+#ifdef CONFIG_RTK_PLATFORM
+	file = (struct file *)vma->vm_rtk_private_data;
+#else
+	file = (struct file *)vma->vm_private_data;
+#endif /* CONFIG_RTK_PLATFORM */
+
+	lower_vm_ops = SDCARDFS_F(file)->lower_vm_ops;
+	BUG_ON(!lower_vm_ops);
+	if (!lower_vm_ops->page_mkwrite)
+		goto out;
+
+	err = lower_vm_ops->page_mkwrite(vma, vmf);
+out:
+	return err;
+}
+
+static ssize_t sdcardfs_direct_IO(struct kiocb *iocb, struct iov_iter *iter)
+{
+	/*
+	 * This function should never be called directly.  We need it
+	 * to exist, to get past a check in open_check_o_direct(),
+	 * which is called from do_last().
+	 */
+	return -EINVAL;
+}
+
+const struct address_space_operations sdcardfs_aops = {
+	.direct_IO	= sdcardfs_direct_IO,
+};
+
+const struct vm_operations_struct sdcardfs_vm_ops = {
+	.fault		= sdcardfs_fault,
+	.page_mkwrite	= sdcardfs_page_mkwrite,
+	.open		= sdcardfs_vm_open,
+	.close		= sdcardfs_vm_close,
+};
diff --git a/fs/sdcardfs/multiuser.h b/fs/sdcardfs/multiuser.h
new file mode 100644
index 00000000..85341e7
--- /dev/null
+++ b/fs/sdcardfs/multiuser.h
@@ -0,0 +1,53 @@
+/*
+ * fs/sdcardfs/multiuser.h
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#define AID_USER_OFFSET     100000 /* offset for uid ranges for each user */
+#define AID_APP_START        10000 /* first app user */
+#define AID_APP_END          19999 /* last app user */
+#define AID_CACHE_GID_START  20000 /* start of gids for apps to mark cached data */
+#define AID_EXT_GID_START    30000 /* start of gids for apps to mark external data */
+#define AID_EXT_CACHE_GID_START 40000 /* start of gids for apps to mark external cached data */
+#define AID_EXT_CACHE_GID_END 49999   /* end of gids for apps to mark external cached data */
+#define AID_SHARED_GID_START 50000 /* start of gids for apps in each user to share */
+
+typedef uid_t userid_t;
+typedef uid_t appid_t;
+
+static inline uid_t multiuser_get_uid(userid_t user_id, appid_t app_id)
+{
+	return (user_id * AID_USER_OFFSET) + (app_id % AID_USER_OFFSET);
+}
+
+static inline bool uid_is_app(uid_t uid)
+{
+	appid_t appid = uid % AID_USER_OFFSET;
+
+	return appid >= AID_APP_START && appid <= AID_APP_END;
+}
+
+static inline gid_t multiuser_get_ext_cache_gid(uid_t uid)
+{
+	return uid - AID_APP_START + AID_EXT_CACHE_GID_START;
+}
+
+static inline gid_t multiuser_get_ext_gid(uid_t uid)
+{
+	return uid - AID_APP_START + AID_EXT_GID_START;
+}
diff --git a/fs/sdcardfs/packagelist.c b/fs/sdcardfs/packagelist.c
new file mode 100644
index 00000000..4b9a563
--- /dev/null
+++ b/fs/sdcardfs/packagelist.c
@@ -0,0 +1,882 @@
+/*
+ * fs/sdcardfs/packagelist.c
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#include "sdcardfs.h"
+#include <linux/hashtable.h>
+#include <linux/ctype.h>
+#include <linux/delay.h>
+#include <linux/radix-tree.h>
+#include <linux/dcache.h>
+
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+
+#include <linux/configfs.h>
+
+struct hashtable_entry {
+	struct hlist_node hlist;
+	struct hlist_node dlist; /* for deletion cleanup */
+	struct qstr key;
+	atomic_t value;
+};
+
+static DEFINE_HASHTABLE(package_to_appid, 8);
+static DEFINE_HASHTABLE(package_to_userid, 8);
+static DEFINE_HASHTABLE(ext_to_groupid, 8);
+
+
+static struct kmem_cache *hashtable_entry_cachep;
+
+static unsigned int full_name_case_hash(const void *salt, const unsigned char *name, unsigned int len)
+{
+	unsigned long hash = init_name_hash(salt);
+
+	while (len--)
+		hash = partial_name_hash(tolower(*name++), hash);
+	return end_name_hash(hash);
+}
+
+static inline void qstr_init(struct qstr *q, const char *name)
+{
+	q->name = name;
+	q->len = strlen(q->name);
+	q->hash = full_name_case_hash(0, q->name, q->len);
+}
+
+static inline int qstr_copy(const struct qstr *src, struct qstr *dest)
+{
+	dest->name = kstrdup(src->name, GFP_KERNEL);
+	dest->hash_len = src->hash_len;
+	return !!dest->name;
+}
+
+
+static appid_t __get_appid(const struct qstr *key)
+{
+	struct hashtable_entry *hash_cur;
+	unsigned int hash = key->hash;
+	appid_t ret_id;
+
+	rcu_read_lock();
+	hash_for_each_possible_rcu(package_to_appid, hash_cur, hlist, hash) {
+		if (qstr_case_eq(key, &hash_cur->key)) {
+			ret_id = atomic_read(&hash_cur->value);
+			rcu_read_unlock();
+			return ret_id;
+		}
+	}
+	rcu_read_unlock();
+	return 0;
+}
+
+appid_t get_appid(const char *key)
+{
+	struct qstr q;
+
+	qstr_init(&q, key);
+	return __get_appid(&q);
+}
+
+static appid_t __get_ext_gid(const struct qstr *key)
+{
+	struct hashtable_entry *hash_cur;
+	unsigned int hash = key->hash;
+	appid_t ret_id;
+
+	rcu_read_lock();
+	hash_for_each_possible_rcu(ext_to_groupid, hash_cur, hlist, hash) {
+		if (qstr_case_eq(key, &hash_cur->key)) {
+			ret_id = atomic_read(&hash_cur->value);
+			rcu_read_unlock();
+			return ret_id;
+		}
+	}
+	rcu_read_unlock();
+	return 0;
+}
+
+appid_t get_ext_gid(const char *key)
+{
+	struct qstr q;
+
+	qstr_init(&q, key);
+	return __get_ext_gid(&q);
+}
+
+static appid_t __is_excluded(const struct qstr *app_name, userid_t user)
+{
+	struct hashtable_entry *hash_cur;
+	unsigned int hash = app_name->hash;
+
+	rcu_read_lock();
+	hash_for_each_possible_rcu(package_to_userid, hash_cur, hlist, hash) {
+		if (atomic_read(&hash_cur->value) == user &&
+				qstr_case_eq(app_name, &hash_cur->key)) {
+			rcu_read_unlock();
+			return 1;
+		}
+	}
+	rcu_read_unlock();
+	return 0;
+}
+
+appid_t is_excluded(const char *key, userid_t user)
+{
+	struct qstr q;
+	qstr_init(&q, key);
+	return __is_excluded(&q, user);
+}
+
+/* Kernel has already enforced everything we returned through
+ * derive_permissions_locked(), so this is used to lock down access
+ * even further, such as enforcing that apps hold sdcard_rw.
+ */
+int check_caller_access_to_name(struct inode *parent_node, const struct qstr *name)
+{
+	struct qstr q_autorun = QSTR_LITERAL("autorun.inf");
+	struct qstr q__android_secure = QSTR_LITERAL(".android_secure");
+	struct qstr q_android_secure = QSTR_LITERAL("android_secure");
+
+	/* Always block security-sensitive files at root */
+	if (parent_node && SDCARDFS_I(parent_node)->data->perm == PERM_ROOT) {
+		if (qstr_case_eq(name, &q_autorun)
+			|| qstr_case_eq(name, &q__android_secure)
+			|| qstr_case_eq(name, &q_android_secure)) {
+			return 0;
+		}
+	}
+
+	/* Root always has access; access for any other UIDs should always
+	 * be controlled through packages.list.
+	 */
+	if (from_kuid(&init_user_ns, current_fsuid()) == 0)
+		return 1;
+
+	/* No extra permissions to enforce */
+	return 1;
+}
+
+static struct hashtable_entry *alloc_hashtable_entry(const struct qstr *key,
+		appid_t value)
+{
+	struct hashtable_entry *ret = kmem_cache_alloc(hashtable_entry_cachep,
+			GFP_KERNEL);
+	if (!ret)
+		return NULL;
+	INIT_HLIST_NODE(&ret->dlist);
+	INIT_HLIST_NODE(&ret->hlist);
+
+	if (!qstr_copy(key, &ret->key)) {
+		kmem_cache_free(hashtable_entry_cachep, ret);
+		return NULL;
+	}
+
+	atomic_set(&ret->value, value);
+	return ret;
+}
+
+static int insert_packagelist_appid_entry_locked(const struct qstr *key, appid_t value)
+{
+	struct hashtable_entry *hash_cur;
+	struct hashtable_entry *new_entry;
+	unsigned int hash = key->hash;
+
+	hash_for_each_possible_rcu(package_to_appid, hash_cur, hlist, hash) {
+		if (qstr_case_eq(key, &hash_cur->key)) {
+			atomic_set(&hash_cur->value, value);
+			return 0;
+		}
+	}
+	new_entry = alloc_hashtable_entry(key, value);
+	if (!new_entry)
+		return -ENOMEM;
+	hash_add_rcu(package_to_appid, &new_entry->hlist, hash);
+	return 0;
+}
+
+static int insert_ext_gid_entry_locked(const struct qstr *key, appid_t value)
+{
+	struct hashtable_entry *hash_cur;
+	struct hashtable_entry *new_entry;
+	unsigned int hash = key->hash;
+
+	/* An extension can only belong to one gid */
+	hash_for_each_possible_rcu(ext_to_groupid, hash_cur, hlist, hash) {
+		if (qstr_case_eq(key, &hash_cur->key))
+			return -EINVAL;
+	}
+	new_entry = alloc_hashtable_entry(key, value);
+	if (!new_entry)
+		return -ENOMEM;
+	hash_add_rcu(ext_to_groupid, &new_entry->hlist, hash);
+	return 0;
+}
+
+static int insert_userid_exclude_entry_locked(const struct qstr *key, userid_t value)
+{
+	struct hashtable_entry *hash_cur;
+	struct hashtable_entry *new_entry;
+	unsigned int hash = key->hash;
+
+	/* Only insert if not already present */
+	hash_for_each_possible_rcu(package_to_userid, hash_cur, hlist, hash) {
+		if (atomic_read(&hash_cur->value) == value &&
+				qstr_case_eq(key, &hash_cur->key))
+			return 0;
+	}
+	new_entry = alloc_hashtable_entry(key, value);
+	if (!new_entry)
+		return -ENOMEM;
+	hash_add_rcu(package_to_userid, &new_entry->hlist, hash);
+	return 0;
+}
+
+static void fixup_all_perms_name(const struct qstr *key)
+{
+	struct sdcardfs_sb_info *sbinfo;
+	struct limit_search limit = {
+		.flags = BY_NAME,
+		.name = QSTR_INIT(key->name, key->len),
+	};
+	list_for_each_entry(sbinfo, &sdcardfs_super_list, list) {
+		if (sbinfo_has_sdcard_magic(sbinfo))
+			fixup_perms_recursive(sbinfo->sb->s_root, &limit);
+	}
+}
+
+static void fixup_all_perms_name_userid(const struct qstr *key, userid_t userid)
+{
+	struct sdcardfs_sb_info *sbinfo;
+	struct limit_search limit = {
+		.flags = BY_NAME | BY_USERID,
+		.name = QSTR_INIT(key->name, key->len),
+		.userid = userid,
+	};
+	list_for_each_entry(sbinfo, &sdcardfs_super_list, list) {
+		if (sbinfo_has_sdcard_magic(sbinfo))
+			fixup_perms_recursive(sbinfo->sb->s_root, &limit);
+	}
+}
+
+static void fixup_all_perms_userid(userid_t userid)
+{
+	struct sdcardfs_sb_info *sbinfo;
+	struct limit_search limit = {
+		.flags = BY_USERID,
+		.userid = userid,
+	};
+	list_for_each_entry(sbinfo, &sdcardfs_super_list, list) {
+		if (sbinfo_has_sdcard_magic(sbinfo))
+			fixup_perms_recursive(sbinfo->sb->s_root, &limit);
+	}
+}
+
+static int insert_packagelist_entry(const struct qstr *key, appid_t value)
+{
+	int err;
+
+	mutex_lock(&sdcardfs_super_list_lock);
+	err = insert_packagelist_appid_entry_locked(key, value);
+	if (!err)
+		fixup_all_perms_name(key);
+	mutex_unlock(&sdcardfs_super_list_lock);
+
+	return err;
+}
+
+static int insert_ext_gid_entry(const struct qstr *key, appid_t value)
+{
+	int err;
+
+	mutex_lock(&sdcardfs_super_list_lock);
+	err = insert_ext_gid_entry_locked(key, value);
+	mutex_unlock(&sdcardfs_super_list_lock);
+
+	return err;
+}
+
+static int insert_userid_exclude_entry(const struct qstr *key, userid_t value)
+{
+	int err;
+
+	mutex_lock(&sdcardfs_super_list_lock);
+	err = insert_userid_exclude_entry_locked(key, value);
+	if (!err)
+		fixup_all_perms_name_userid(key, value);
+	mutex_unlock(&sdcardfs_super_list_lock);
+
+	return err;
+}
+
+static void free_hashtable_entry(struct hashtable_entry *entry)
+{
+	kfree(entry->key.name);
+	kmem_cache_free(hashtable_entry_cachep, entry);
+}
+
+static void remove_packagelist_entry_locked(const struct qstr *key)
+{
+	struct hashtable_entry *hash_cur;
+	unsigned int hash = key->hash;
+	struct hlist_node *h_t;
+	HLIST_HEAD(free_list);
+
+	hash_for_each_possible_rcu(package_to_userid, hash_cur, hlist, hash) {
+		if (qstr_case_eq(key, &hash_cur->key)) {
+			hash_del_rcu(&hash_cur->hlist);
+			hlist_add_head(&hash_cur->dlist, &free_list);
+		}
+	}
+	hash_for_each_possible_rcu(package_to_appid, hash_cur, hlist, hash) {
+		if (qstr_case_eq(key, &hash_cur->key)) {
+			hash_del_rcu(&hash_cur->hlist);
+			hlist_add_head(&hash_cur->dlist, &free_list);
+			break;
+		}
+	}
+	synchronize_rcu();
+	hlist_for_each_entry_safe(hash_cur, h_t, &free_list, dlist)
+		free_hashtable_entry(hash_cur);
+}
+
+static void remove_packagelist_entry(const struct qstr *key)
+{
+	mutex_lock(&sdcardfs_super_list_lock);
+	remove_packagelist_entry_locked(key);
+	fixup_all_perms_name(key);
+	mutex_unlock(&sdcardfs_super_list_lock);
+}
+
+static void remove_ext_gid_entry_locked(const struct qstr *key, gid_t group)
+{
+	struct hashtable_entry *hash_cur;
+	unsigned int hash = key->hash;
+
+	hash_for_each_possible_rcu(ext_to_groupid, hash_cur, hlist, hash) {
+		if (qstr_case_eq(key, &hash_cur->key) && atomic_read(&hash_cur->value) == group) {
+			hash_del_rcu(&hash_cur->hlist);
+			synchronize_rcu();
+			free_hashtable_entry(hash_cur);
+			break;
+		}
+	}
+}
+
+static void remove_ext_gid_entry(const struct qstr *key, gid_t group)
+{
+	mutex_lock(&sdcardfs_super_list_lock);
+	remove_ext_gid_entry_locked(key, group);
+	mutex_unlock(&sdcardfs_super_list_lock);
+}
+
+static void remove_userid_all_entry_locked(userid_t userid)
+{
+	struct hashtable_entry *hash_cur;
+	struct hlist_node *h_t;
+	HLIST_HEAD(free_list);
+	int i;
+
+	hash_for_each_rcu(package_to_userid, i, hash_cur, hlist) {
+		if (atomic_read(&hash_cur->value) == userid) {
+			hash_del_rcu(&hash_cur->hlist);
+			hlist_add_head(&hash_cur->dlist, &free_list);
+		}
+	}
+	synchronize_rcu();
+	hlist_for_each_entry_safe(hash_cur, h_t, &free_list, dlist) {
+		free_hashtable_entry(hash_cur);
+	}
+}
+
+static void remove_userid_all_entry(userid_t userid)
+{
+	mutex_lock(&sdcardfs_super_list_lock);
+	remove_userid_all_entry_locked(userid);
+	fixup_all_perms_userid(userid);
+	mutex_unlock(&sdcardfs_super_list_lock);
+}
+
+static void remove_userid_exclude_entry_locked(const struct qstr *key, userid_t userid)
+{
+	struct hashtable_entry *hash_cur;
+	unsigned int hash = key->hash;
+
+	hash_for_each_possible_rcu(package_to_userid, hash_cur, hlist, hash) {
+		if (qstr_case_eq(key, &hash_cur->key) &&
+				atomic_read(&hash_cur->value) == userid) {
+			hash_del_rcu(&hash_cur->hlist);
+			synchronize_rcu();
+			free_hashtable_entry(hash_cur);
+			break;
+		}
+	}
+}
+
+static void remove_userid_exclude_entry(const struct qstr *key, userid_t userid)
+{
+	mutex_lock(&sdcardfs_super_list_lock);
+	remove_userid_exclude_entry_locked(key, userid);
+	fixup_all_perms_name_userid(key, userid);
+	mutex_unlock(&sdcardfs_super_list_lock);
+}
+
+static void packagelist_destroy(void)
+{
+	struct hashtable_entry *hash_cur;
+	struct hlist_node *h_t;
+	HLIST_HEAD(free_list);
+	int i;
+
+	mutex_lock(&sdcardfs_super_list_lock);
+	hash_for_each_rcu(package_to_appid, i, hash_cur, hlist) {
+		hash_del_rcu(&hash_cur->hlist);
+		hlist_add_head(&hash_cur->dlist, &free_list);
+	}
+	hash_for_each_rcu(package_to_userid, i, hash_cur, hlist) {
+		hash_del_rcu(&hash_cur->hlist);
+		hlist_add_head(&hash_cur->dlist, &free_list);
+	}
+	synchronize_rcu();
+	hlist_for_each_entry_safe(hash_cur, h_t, &free_list, dlist)
+		free_hashtable_entry(hash_cur);
+	mutex_unlock(&sdcardfs_super_list_lock);
+	pr_info("sdcardfs: destroyed packagelist pkgld\n");
+}
+
+#define SDCARDFS_CONFIGFS_ATTR(_pfx, _name)			\
+static struct configfs_attribute _pfx##attr_##_name = {	\
+	.ca_name	= __stringify(_name),		\
+	.ca_mode	= S_IRUGO | S_IWUGO,		\
+	.ca_owner	= THIS_MODULE,			\
+	.show		= _pfx##_name##_show,		\
+	.store		= _pfx##_name##_store,		\
+}
+
+#define SDCARDFS_CONFIGFS_ATTR_RO(_pfx, _name)			\
+static struct configfs_attribute _pfx##attr_##_name = {	\
+	.ca_name	= __stringify(_name),		\
+	.ca_mode	= S_IRUGO,			\
+	.ca_owner	= THIS_MODULE,			\
+	.show		= _pfx##_name##_show,		\
+}
+
+#define SDCARDFS_CONFIGFS_ATTR_WO(_pfx, _name)			\
+static struct configfs_attribute _pfx##attr_##_name = {	\
+	.ca_name	= __stringify(_name),		\
+	.ca_mode	= S_IWUGO,			\
+	.ca_owner	= THIS_MODULE,			\
+	.store		= _pfx##_name##_store,		\
+}
+
+struct package_details {
+	struct config_item item;
+	struct qstr name;
+};
+
+static inline struct package_details *to_package_details(struct config_item *item)
+{
+	return item ? container_of(item, struct package_details, item) : NULL;
+}
+
+static ssize_t package_details_appid_show(struct config_item *item, char *page)
+{
+	return scnprintf(page, PAGE_SIZE, "%u\n", __get_appid(&to_package_details(item)->name));
+}
+
+static ssize_t package_details_appid_store(struct config_item *item,
+				       const char *page, size_t count)
+{
+	unsigned int tmp;
+	int ret;
+
+	ret = kstrtouint(page, 10, &tmp);
+	if (ret)
+		return ret;
+
+	ret = insert_packagelist_entry(&to_package_details(item)->name, tmp);
+
+	if (ret)
+		return ret;
+
+	return count;
+}
+
+static ssize_t package_details_excluded_userids_show(struct config_item *item,
+				      char *page)
+{
+	struct package_details *package_details = to_package_details(item);
+	struct hashtable_entry *hash_cur;
+	unsigned int hash = package_details->name.hash;
+	int count = 0;
+
+	rcu_read_lock();
+	hash_for_each_possible_rcu(package_to_userid, hash_cur, hlist, hash) {
+		if (qstr_case_eq(&package_details->name, &hash_cur->key))
+			count += scnprintf(page + count, PAGE_SIZE - count,
+					"%d ", atomic_read(&hash_cur->value));
+	}
+	rcu_read_unlock();
+	if (count)
+		count--;
+	count += scnprintf(page + count, PAGE_SIZE - count, "\n");
+	return count;
+}
+
+static ssize_t package_details_excluded_userids_store(struct config_item *item,
+				       const char *page, size_t count)
+{
+	unsigned int tmp;
+	int ret;
+
+	ret = kstrtouint(page, 10, &tmp);
+	if (ret)
+		return ret;
+
+	ret = insert_userid_exclude_entry(&to_package_details(item)->name, tmp);
+
+	if (ret)
+		return ret;
+
+	return count;
+}
+
+static ssize_t package_details_clear_userid_store(struct config_item *item,
+				       const char *page, size_t count)
+{
+	unsigned int tmp;
+	int ret;
+
+	ret = kstrtouint(page, 10, &tmp);
+	if (ret)
+		return ret;
+	remove_userid_exclude_entry(&to_package_details(item)->name, tmp);
+	return count;
+}
+
+static void package_details_release(struct config_item *item)
+{
+	struct package_details *package_details = to_package_details(item);
+
+	pr_info("sdcardfs: removing %s\n", package_details->name.name);
+	remove_packagelist_entry(&package_details->name);
+	kfree(package_details->name.name);
+	kfree(package_details);
+}
+
+SDCARDFS_CONFIGFS_ATTR(package_details_, appid);
+SDCARDFS_CONFIGFS_ATTR(package_details_, excluded_userids);
+SDCARDFS_CONFIGFS_ATTR_WO(package_details_, clear_userid);
+
+static struct configfs_attribute *package_details_attrs[] = {
+	&package_details_attr_appid,
+	&package_details_attr_excluded_userids,
+	&package_details_attr_clear_userid,
+	NULL,
+};
+
+static struct configfs_item_operations package_details_item_ops = {
+	.release = package_details_release,
+};
+
+static struct config_item_type package_appid_type = {
+	.ct_item_ops	= &package_details_item_ops,
+	.ct_attrs	= package_details_attrs,
+	.ct_owner	= THIS_MODULE,
+};
+
+struct extensions_value {
+	struct config_group group;
+	unsigned int num;
+};
+
+struct extension_details {
+	struct config_item item;
+	struct qstr name;
+	unsigned int num;
+};
+
+static inline struct extensions_value *to_extensions_value(struct config_item *item)
+{
+	return item ? container_of(to_config_group(item), struct extensions_value, group) : NULL;
+}
+
+static inline struct extension_details *to_extension_details(struct config_item *item)
+{
+	return item ? container_of(item, struct extension_details, item) : NULL;
+}
+
+static void extension_details_release(struct config_item *item)
+{
+	struct extension_details *extension_details = to_extension_details(item);
+
+	pr_info("sdcardfs: No longer mapping %s files to gid %d\n",
+			extension_details->name.name, extension_details->num);
+	remove_ext_gid_entry(&extension_details->name, extension_details->num);
+	kfree(extension_details->name.name);
+	kfree(extension_details);
+}
+
+static struct configfs_item_operations extension_details_item_ops = {
+	.release = extension_details_release,
+};
+
+static struct config_item_type extension_details_type = {
+	.ct_item_ops = &extension_details_item_ops,
+	.ct_owner = THIS_MODULE,
+};
+
+static struct config_item *extension_details_make_item(struct config_group *group, const char *name)
+{
+	struct extensions_value *extensions_value = to_extensions_value(&group->cg_item);
+	struct extension_details *extension_details = kzalloc(sizeof(struct extension_details), GFP_KERNEL);
+	const char *tmp;
+	int ret;
+
+	if (!extension_details)
+		return ERR_PTR(-ENOMEM);
+
+	tmp = kstrdup(name, GFP_KERNEL);
+	if (!tmp) {
+		kfree(extension_details);
+		return ERR_PTR(-ENOMEM);
+	}
+	qstr_init(&extension_details->name, tmp);
+	extension_details->num = extensions_value->num;
+	ret = insert_ext_gid_entry(&extension_details->name, extensions_value->num);
+
+	if (ret) {
+		kfree(extension_details->name.name);
+		kfree(extension_details);
+		return ERR_PTR(ret);
+	}
+	config_item_init_type_name(&extension_details->item, name, &extension_details_type);
+
+	return &extension_details->item;
+}
+
+static struct configfs_group_operations extensions_value_group_ops = {
+	.make_item = extension_details_make_item,
+};
+
+static struct config_item_type extensions_name_type = {
+	.ct_group_ops	= &extensions_value_group_ops,
+	.ct_owner	= THIS_MODULE,
+};
+
+static struct config_group *extensions_make_group(struct config_group *group, const char *name)
+{
+	struct extensions_value *extensions_value;
+	unsigned int tmp;
+	int ret;
+
+	extensions_value = kzalloc(sizeof(struct extensions_value), GFP_KERNEL);
+	if (!extensions_value)
+		return ERR_PTR(-ENOMEM);
+	ret = kstrtouint(name, 10, &tmp);
+	if (ret) {
+		kfree(extensions_value);
+		return ERR_PTR(ret);
+	}
+
+	extensions_value->num = tmp;
+	config_group_init_type_name(&extensions_value->group, name,
+						&extensions_name_type);
+	return &extensions_value->group;
+}
+
+static void extensions_drop_group(struct config_group *group, struct config_item *item)
+{
+	struct extensions_value *value = to_extensions_value(item);
+
+	pr_info("sdcardfs: No longer mapping any files to gid %d\n", value->num);
+	kfree(value);
+}
+
+static struct configfs_group_operations extensions_group_ops = {
+	.make_group	= extensions_make_group,
+	.drop_item	= extensions_drop_group,
+};
+
+static struct config_item_type extensions_type = {
+	.ct_group_ops	= &extensions_group_ops,
+	.ct_owner	= THIS_MODULE,
+};
+
+struct config_group extension_group = {
+	.cg_item = {
+		.ci_namebuf = "extensions",
+		.ci_type = &extensions_type,
+	},
+};
+
+static struct config_item *packages_make_item(struct config_group *group, const char *name)
+{
+	struct package_details *package_details;
+	const char *tmp;
+
+	package_details = kzalloc(sizeof(struct package_details), GFP_KERNEL);
+	if (!package_details)
+		return ERR_PTR(-ENOMEM);
+	tmp = kstrdup(name, GFP_KERNEL);
+	if (!tmp) {
+		kfree(package_details);
+		return ERR_PTR(-ENOMEM);
+	}
+	qstr_init(&package_details->name, tmp);
+	config_item_init_type_name(&package_details->item, name,
+						&package_appid_type);
+
+	return &package_details->item;
+}
+
+static ssize_t packages_list_show(struct config_item *item, char *page)
+{
+	struct hashtable_entry *hash_cur_app;
+	struct hashtable_entry *hash_cur_user;
+	int i;
+	int count = 0, written = 0;
+	const char errormsg[] = "<truncated>\n";
+	unsigned int hash;
+
+	rcu_read_lock();
+	hash_for_each_rcu(package_to_appid, i, hash_cur_app, hlist) {
+		written = scnprintf(page + count, PAGE_SIZE - sizeof(errormsg) - count, "%s %d\n",
+					hash_cur_app->key.name, atomic_read(&hash_cur_app->value));
+		hash = hash_cur_app->key.hash;
+		hash_for_each_possible_rcu(package_to_userid, hash_cur_user, hlist, hash) {
+			if (qstr_case_eq(&hash_cur_app->key, &hash_cur_user->key)) {
+				written += scnprintf(page + count + written - 1,
+					PAGE_SIZE - sizeof(errormsg) - count - written + 1,
+					" %d\n", atomic_read(&hash_cur_user->value)) - 1;
+			}
+		}
+		if (count + written == PAGE_SIZE - sizeof(errormsg) - 1) {
+			count += scnprintf(page + count, PAGE_SIZE - count, errormsg);
+			break;
+		}
+		count += written;
+	}
+	rcu_read_unlock();
+
+	return count;
+}
+
+static ssize_t packages_remove_userid_store(struct config_item *item,
+				       const char *page, size_t count)
+{
+	unsigned int tmp;
+	int ret;
+
+	ret = kstrtouint(page, 10, &tmp);
+	if (ret)
+		return ret;
+	remove_userid_all_entry(tmp);
+	return count;
+}
+
+static struct configfs_attribute packages_attr_packages_gid_list = {
+	.ca_name	= "packages_gid.list",
+	.ca_mode	= S_IRUGO,
+	.ca_owner	= THIS_MODULE,
+	.show		= packages_list_show,
+};
+
+SDCARDFS_CONFIGFS_ATTR_WO(packages_, remove_userid);
+
+static struct configfs_attribute *packages_attrs[] = {
+	&packages_attr_packages_gid_list,
+	&packages_attr_remove_userid,
+	NULL,
+};
+
+/*
+ * Note that, since no extra work is required on ->drop_item(),
+ * no ->drop_item() is provided.
+ */
+static struct configfs_group_operations packages_group_ops = {
+	.make_item	= packages_make_item,
+};
+
+static struct config_item_type packages_type = {
+	.ct_group_ops	= &packages_group_ops,
+	.ct_attrs	= packages_attrs,
+	.ct_owner	= THIS_MODULE,
+};
+
+struct config_group *sd_default_groups[] = {
+	&extension_group,
+	NULL,
+};
+
+static struct configfs_subsystem sdcardfs_packages = {
+	.su_group = {
+		.cg_item = {
+			.ci_namebuf = "sdcardfs",
+			.ci_type = &packages_type,
+		},
+	},
+};
+
+static int configfs_sdcardfs_init(void)
+{
+	int ret, i;
+	struct configfs_subsystem *subsys = &sdcardfs_packages;
+
+	config_group_init(&subsys->su_group);
+	for (i = 0; sd_default_groups[i]; i++) {
+		config_group_init(sd_default_groups[i]);
+		configfs_add_default_group(sd_default_groups[i], &subsys->su_group);
+	}
+	mutex_init(&subsys->su_mutex);
+	ret = configfs_register_subsystem(subsys);
+	if (ret) {
+		pr_err("Error %d while registering subsystem %s\n",
+		       ret,
+		       subsys->su_group.cg_item.ci_namebuf);
+	}
+	return ret;
+}
+
+static void configfs_sdcardfs_exit(void)
+{
+	configfs_unregister_subsystem(&sdcardfs_packages);
+}
+
+int packagelist_init(void)
+{
+	hashtable_entry_cachep =
+		kmem_cache_create("packagelist_hashtable_entry",
+					sizeof(struct hashtable_entry), 0, 0, NULL);
+	if (!hashtable_entry_cachep) {
+		pr_err("sdcardfs: failed creating pkgl_hashtable entry slab cache\n");
+		return -ENOMEM;
+	}
+
+	configfs_sdcardfs_init();
+	return 0;
+}
+
+void packagelist_exit(void)
+{
+	configfs_sdcardfs_exit();
+	packagelist_destroy();
+	kmem_cache_destroy(hashtable_entry_cachep);
+}
diff --git a/fs/sdcardfs/sdcardfs.h b/fs/sdcardfs/sdcardfs.h
new file mode 100644
index 00000000..826afb5
--- /dev/null
+++ b/fs/sdcardfs/sdcardfs.h
@@ -0,0 +1,677 @@
+/*
+ * fs/sdcardfs/sdcardfs.h
+ *
+ * The sdcardfs v2.0
+ *   This file system replaces the sdcard daemon on Android
+ *   On version 2.0, some of the daemon functions have been ported
+ *   to support the multi-user concepts of Android 4.4
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#ifndef _SDCARDFS_H_
+#define _SDCARDFS_H_
+
+#include <linux/dcache.h>
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/aio.h>
+#include <linux/kref.h>
+#include <linux/mm.h>
+#include <linux/mount.h>
+#include <linux/namei.h>
+#include <linux/seq_file.h>
+#include <linux/statfs.h>
+#include <linux/fs_stack.h>
+#include <linux/magic.h>
+#include <linux/uaccess.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/types.h>
+#include <linux/security.h>
+#include <linux/string.h>
+#include <linux/list.h>
+#include "multiuser.h"
+
+/* the file system name */
+#define SDCARDFS_NAME "sdcardfs"
+
+/* sdcardfs root inode number */
+#define SDCARDFS_ROOT_INO     1
+
+/* useful for tracking code reachability */
+#define UDBG pr_default("DBG:%s:%s:%d\n", __FILE__, __func__, __LINE__)
+
+#define SDCARDFS_DIRENT_SIZE 256
+
+/* temporary static uid settings for development */
+#define AID_ROOT             0	/* uid for accessing /mnt/sdcard & extSdcard */
+#define AID_MEDIA_RW      1023	/* internal media storage write access */
+
+#define AID_SDCARD_RW     1015	/* external storage write access */
+#define AID_SDCARD_R      1028	/* external storage read access */
+#define AID_SDCARD_PICS   1033	/* external storage photos access */
+#define AID_SDCARD_AV     1034	/* external storage audio/video access */
+#define AID_SDCARD_ALL    1035	/* access all users external storage */
+#define AID_MEDIA_OBB     1059  /* obb files */
+
+#define AID_SDCARD_IMAGE  1057
+
+#define AID_PACKAGE_INFO  1027
+
+
+/*
+ * Permissions are handled by our permission function.
+ * We don't want anyone who happens to look at our inode value to prematurely
+ * block access, so store more permissive values. These are probably never
+ * used.
+ */
+#define fixup_tmp_permissions(x)	\
+	do {						\
+		(x)->i_uid = make_kuid(&init_user_ns,	\
+				SDCARDFS_I(x)->data->d_uid);	\
+		(x)->i_gid = make_kgid(&init_user_ns, AID_SDCARD_RW);	\
+		(x)->i_mode = ((x)->i_mode & S_IFMT) | 0775;\
+	} while (0)
+
+/* OVERRIDE_CRED() and REVERT_CRED()
+ *	OVERRIDE_CRED()
+ *		backup original task->cred
+ *		and modifies task->cred->fsuid/fsgid to specified value.
+ *	REVERT_CRED()
+ *		restore original task->cred->fsuid/fsgid.
+ * These two macro should be used in pair, and OVERRIDE_CRED() should be
+ * placed at the beginning of a function, right after variable declaration.
+ */
+#define OVERRIDE_CRED(sdcardfs_sbi, saved_cred, info)		\
+	do {	\
+		saved_cred = override_fsids(sdcardfs_sbi, info->data);	\
+		if (!saved_cred)	\
+			return -ENOMEM;	\
+	} while (0)
+
+#define OVERRIDE_CRED_PTR(sdcardfs_sbi, saved_cred, info)	\
+	do {	\
+		saved_cred = override_fsids(sdcardfs_sbi, info->data);	\
+		if (!saved_cred)	\
+			return ERR_PTR(-ENOMEM);	\
+	} while (0)
+
+#define REVERT_CRED(saved_cred)	revert_fsids(saved_cred)
+
+/* Android 5.0 support */
+
+/* Permission mode for a specific node. Controls how file permissions
+ * are derived for children nodes.
+ */
+typedef enum {
+	/* Nothing special; this node should just inherit from its parent. */
+	PERM_INHERIT,
+	/* This node is one level above a normal root; used for legacy layouts
+	 * which use the first level to represent user_id.
+	 */
+	PERM_PRE_ROOT,
+	/* This node is "/" */
+	PERM_ROOT,
+	/* This node is "/Android" */
+	PERM_ANDROID,
+	/* This node is "/Android/data" */
+	PERM_ANDROID_DATA,
+	/* This node is "/Android/obb" */
+	PERM_ANDROID_OBB,
+	/* This node is "/Android/media" */
+	PERM_ANDROID_MEDIA,
+	/* This node is "/Android/[data|media|obb]/[package]" */
+	PERM_ANDROID_PACKAGE,
+	/* This node is "/Android/[data|media|obb]/[package]/cache" */
+	PERM_ANDROID_PACKAGE_CACHE,
+} perm_t;
+
+struct sdcardfs_sb_info;
+struct sdcardfs_mount_options;
+struct sdcardfs_inode_info;
+struct sdcardfs_inode_data;
+
+/* Do not directly use this function. Use OVERRIDE_CRED() instead. */
+const struct cred *override_fsids(struct sdcardfs_sb_info *sbi,
+			struct sdcardfs_inode_data *data);
+/* Do not directly use this function, use REVERT_CRED() instead. */
+void revert_fsids(const struct cred *old_cred);
+
+/* operations vectors defined in specific files */
+extern const struct file_operations sdcardfs_main_fops;
+extern const struct file_operations sdcardfs_dir_fops;
+extern const struct inode_operations sdcardfs_main_iops;
+extern const struct inode_operations sdcardfs_dir_iops;
+extern const struct inode_operations sdcardfs_symlink_iops;
+extern const struct super_operations sdcardfs_sops;
+extern const struct dentry_operations sdcardfs_ci_dops;
+extern const struct address_space_operations sdcardfs_aops, sdcardfs_dummy_aops;
+extern const struct vm_operations_struct sdcardfs_vm_ops;
+
+extern int sdcardfs_init_inode_cache(void);
+extern void sdcardfs_destroy_inode_cache(void);
+extern int sdcardfs_init_dentry_cache(void);
+extern void sdcardfs_destroy_dentry_cache(void);
+extern int new_dentry_private_data(struct dentry *dentry);
+extern void free_dentry_private_data(struct dentry *dentry);
+extern struct dentry *sdcardfs_lookup(struct inode *dir, struct dentry *dentry,
+				unsigned int flags);
+extern struct inode *sdcardfs_iget(struct super_block *sb,
+				 struct inode *lower_inode, userid_t id);
+extern int sdcardfs_interpose(struct dentry *dentry, struct super_block *sb,
+			    struct path *lower_path, userid_t id);
+
+/* file private data */
+struct sdcardfs_file_info {
+	struct file *lower_file;
+	const struct vm_operations_struct *lower_vm_ops;
+};
+
+struct sdcardfs_inode_data {
+	struct kref refcount;
+	bool abandoned;
+
+	perm_t perm;
+	userid_t userid;
+	uid_t d_uid;
+	bool under_android;
+	bool under_cache;
+	bool under_obb;
+};
+
+/* sdcardfs inode data in memory */
+struct sdcardfs_inode_info {
+	struct inode *lower_inode;
+	/* state derived based on current position in hierarchy */
+	struct sdcardfs_inode_data *data;
+
+	/* top folder for ownership */
+	spinlock_t top_lock;
+	struct sdcardfs_inode_data *top_data;
+
+	struct inode vfs_inode;
+};
+
+
+/* sdcardfs dentry data in memory */
+struct sdcardfs_dentry_info {
+	spinlock_t lock;	/* protects lower_path */
+	struct path lower_path;
+	struct path orig_path;
+};
+
+struct sdcardfs_mount_options {
+	uid_t fs_low_uid;
+	gid_t fs_low_gid;
+	userid_t fs_user_id;
+	bool multiuser;
+	bool gid_derivation;
+	bool default_normal;
+	unsigned int reserved_mb;
+};
+
+struct sdcardfs_vfsmount_options {
+	gid_t gid;
+	mode_t mask;
+};
+
+extern int parse_options_remount(struct super_block *sb, char *options, int silent,
+		struct sdcardfs_vfsmount_options *vfsopts);
+
+/* sdcardfs super-block data in memory */
+struct sdcardfs_sb_info {
+	struct super_block *sb;
+	struct super_block *lower_sb;
+	/* derived perm policy : some of options have been added
+	 * to sdcardfs_mount_options (Android 4.4 support)
+	 */
+	struct sdcardfs_mount_options options;
+	spinlock_t lock;	/* protects obbpath */
+	char *obbpath_s;
+	struct path obbpath;
+	void *pkgl_id;
+	struct list_head list;
+};
+
+/*
+ * inode to private data
+ *
+ * Since we use containers and the struct inode is _inside_ the
+ * sdcardfs_inode_info structure, SDCARDFS_I will always (given a non-NULL
+ * inode pointer), return a valid non-NULL pointer.
+ */
+static inline struct sdcardfs_inode_info *SDCARDFS_I(const struct inode *inode)
+{
+	return container_of(inode, struct sdcardfs_inode_info, vfs_inode);
+}
+
+/* dentry to private data */
+#define SDCARDFS_D(dent) ((struct sdcardfs_dentry_info *)(dent)->d_fsdata)
+
+/* superblock to private data */
+#define SDCARDFS_SB(super) ((struct sdcardfs_sb_info *)(super)->s_fs_info)
+
+/* file to private Data */
+#define SDCARDFS_F(file) ((struct sdcardfs_file_info *)((file)->private_data))
+
+/* file to lower file */
+static inline struct file *sdcardfs_lower_file(const struct file *f)
+{
+	return SDCARDFS_F(f)->lower_file;
+}
+
+static inline void sdcardfs_set_lower_file(struct file *f, struct file *val)
+{
+	SDCARDFS_F(f)->lower_file = val;
+}
+
+/* inode to lower inode. */
+static inline struct inode *sdcardfs_lower_inode(const struct inode *i)
+{
+	return SDCARDFS_I(i)->lower_inode;
+}
+
+static inline void sdcardfs_set_lower_inode(struct inode *i, struct inode *val)
+{
+	SDCARDFS_I(i)->lower_inode = val;
+}
+
+/* superblock to lower superblock */
+static inline struct super_block *sdcardfs_lower_super(
+	const struct super_block *sb)
+{
+	return SDCARDFS_SB(sb)->lower_sb;
+}
+
+static inline void sdcardfs_set_lower_super(struct super_block *sb,
+					  struct super_block *val)
+{
+	SDCARDFS_SB(sb)->lower_sb = val;
+}
+
+/* path based (dentry/mnt) macros */
+static inline void pathcpy(struct path *dst, const struct path *src)
+{
+	dst->dentry = src->dentry;
+	dst->mnt = src->mnt;
+}
+
+/* sdcardfs_get_pname functions calls path_get()
+ * therefore, the caller must call "proper" path_put functions
+ */
+#define SDCARDFS_DENT_FUNC(pname) \
+static inline void sdcardfs_get_##pname(const struct dentry *dent, \
+					struct path *pname) \
+{ \
+	spin_lock(&SDCARDFS_D(dent)->lock); \
+	pathcpy(pname, &SDCARDFS_D(dent)->pname); \
+	path_get(pname); \
+	spin_unlock(&SDCARDFS_D(dent)->lock); \
+	return; \
+} \
+static inline void sdcardfs_put_##pname(const struct dentry *dent, \
+					struct path *pname) \
+{ \
+	path_put(pname); \
+	return; \
+} \
+static inline void sdcardfs_set_##pname(const struct dentry *dent, \
+					struct path *pname) \
+{ \
+	spin_lock(&SDCARDFS_D(dent)->lock); \
+	pathcpy(&SDCARDFS_D(dent)->pname, pname); \
+	spin_unlock(&SDCARDFS_D(dent)->lock); \
+	return; \
+} \
+static inline void sdcardfs_reset_##pname(const struct dentry *dent) \
+{ \
+	spin_lock(&SDCARDFS_D(dent)->lock); \
+	SDCARDFS_D(dent)->pname.dentry = NULL; \
+	SDCARDFS_D(dent)->pname.mnt = NULL; \
+	spin_unlock(&SDCARDFS_D(dent)->lock); \
+	return; \
+} \
+static inline void sdcardfs_put_reset_##pname(const struct dentry *dent) \
+{ \
+	struct path pname; \
+	spin_lock(&SDCARDFS_D(dent)->lock); \
+	if (SDCARDFS_D(dent)->pname.dentry) { \
+		pathcpy(&pname, &SDCARDFS_D(dent)->pname); \
+		SDCARDFS_D(dent)->pname.dentry = NULL; \
+		SDCARDFS_D(dent)->pname.mnt = NULL; \
+		spin_unlock(&SDCARDFS_D(dent)->lock); \
+		path_put(&pname); \
+	} else \
+		spin_unlock(&SDCARDFS_D(dent)->lock); \
+	return; \
+}
+
+SDCARDFS_DENT_FUNC(lower_path)
+SDCARDFS_DENT_FUNC(orig_path)
+
+static inline bool sbinfo_has_sdcard_magic(struct sdcardfs_sb_info *sbinfo)
+{
+	return sbinfo && sbinfo->sb
+			&& sbinfo->sb->s_magic == SDCARDFS_SUPER_MAGIC;
+}
+
+static inline struct sdcardfs_inode_data *data_get(
+		struct sdcardfs_inode_data *data)
+{
+	if (data)
+		kref_get(&data->refcount);
+	return data;
+}
+
+static inline struct sdcardfs_inode_data *top_data_get(
+		struct sdcardfs_inode_info *info)
+{
+	struct sdcardfs_inode_data *top_data;
+
+	spin_lock(&info->top_lock);
+	top_data = data_get(info->top_data);
+	spin_unlock(&info->top_lock);
+	return top_data;
+}
+
+extern void data_release(struct kref *ref);
+
+static inline void data_put(struct sdcardfs_inode_data *data)
+{
+	kref_put(&data->refcount, data_release);
+}
+
+static inline void release_own_data(struct sdcardfs_inode_info *info)
+{
+	/*
+	 * This happens exactly once per inode. At this point, the inode that
+	 * originally held this data is about to be freed, and all references
+	 * to it are held as a top value, and will likely be released soon.
+	 */
+	info->data->abandoned = true;
+	data_put(info->data);
+}
+
+static inline void set_top(struct sdcardfs_inode_info *info,
+			struct sdcardfs_inode_info *top_owner)
+{
+	struct sdcardfs_inode_data *old_top;
+	struct sdcardfs_inode_data *new_top = NULL;
+
+	if (top_owner)
+		new_top = top_data_get(top_owner);
+
+	spin_lock(&info->top_lock);
+	old_top = info->top_data;
+	info->top_data = new_top;
+	if (old_top)
+		data_put(old_top);
+	spin_unlock(&info->top_lock);
+}
+
+static inline int get_gid(struct vfsmount *mnt,
+		struct super_block *sb,
+		struct sdcardfs_inode_data *data)
+{
+	struct sdcardfs_vfsmount_options *vfsopts = mnt->data;
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(sb);
+
+	if (vfsopts->gid == AID_SDCARD_RW && !sbi->options.default_normal)
+		/* As an optimization, certain trusted system components only run
+		 * as owner but operate across all users. Since we're now handing
+		 * out the sdcard_rw GID only to trusted apps, we're okay relaxing
+		 * the user boundary enforcement for the default view. The UIDs
+		 * assigned to app directories are still multiuser aware.
+		 */
+		return AID_SDCARD_RW;
+	else
+		return multiuser_get_uid(data->userid, vfsopts->gid);
+}
+
+static inline int get_mode(struct vfsmount *mnt,
+		struct sdcardfs_inode_info *info,
+		struct sdcardfs_inode_data *data)
+{
+	int owner_mode;
+	int filtered_mode;
+	struct sdcardfs_vfsmount_options *opts = mnt->data;
+	int visible_mode = 0775 & ~opts->mask;
+
+
+	if (data->perm == PERM_PRE_ROOT) {
+		/* Top of multi-user view should always be visible to ensure
+		* secondary users can traverse inside.
+		*/
+		visible_mode = 0711;
+	} else if (data->under_android) {
+		/* Block "other" access to Android directories, since only apps
+		* belonging to a specific user should be in there; we still
+		* leave +x open for the default view.
+		*/
+		if (opts->gid == AID_SDCARD_RW)
+			visible_mode = visible_mode & ~0006;
+		else
+			visible_mode = visible_mode & ~0007;
+	}
+	owner_mode = info->lower_inode->i_mode & 0700;
+	filtered_mode = visible_mode & (owner_mode | (owner_mode >> 3) | (owner_mode >> 6));
+	return filtered_mode;
+}
+
+static inline int has_graft_path(const struct dentry *dent)
+{
+	int ret = 0;
+
+	spin_lock(&SDCARDFS_D(dent)->lock);
+	if (SDCARDFS_D(dent)->orig_path.dentry != NULL)
+		ret = 1;
+	spin_unlock(&SDCARDFS_D(dent)->lock);
+
+	return ret;
+}
+
+static inline void sdcardfs_get_real_lower(const struct dentry *dent,
+						struct path *real_lower)
+{
+	/* in case of a local obb dentry
+	 * the orig_path should be returned
+	 */
+	if (has_graft_path(dent))
+		sdcardfs_get_orig_path(dent, real_lower);
+	else
+		sdcardfs_get_lower_path(dent, real_lower);
+}
+
+static inline void sdcardfs_put_real_lower(const struct dentry *dent,
+						struct path *real_lower)
+{
+	if (has_graft_path(dent))
+		sdcardfs_put_orig_path(dent, real_lower);
+	else
+		sdcardfs_put_lower_path(dent, real_lower);
+}
+
+extern struct mutex sdcardfs_super_list_lock;
+extern struct list_head sdcardfs_super_list;
+
+/* for packagelist.c */
+extern appid_t get_appid(const char *app_name);
+extern appid_t get_ext_gid(const char *app_name);
+extern appid_t is_excluded(const char *app_name, userid_t userid);
+extern int check_caller_access_to_name(struct inode *parent_node, const struct qstr *name);
+extern int packagelist_init(void);
+extern void packagelist_exit(void);
+
+/* for derived_perm.c */
+#define BY_NAME		(1 << 0)
+#define BY_USERID	(1 << 1)
+struct limit_search {
+	unsigned int flags;
+	struct qstr name;
+	userid_t userid;
+};
+
+extern void setup_derived_state(struct inode *inode, perm_t perm,
+			userid_t userid, uid_t uid);
+extern void get_derived_permission(struct dentry *parent, struct dentry *dentry);
+extern void get_derived_permission_new(struct dentry *parent, struct dentry *dentry, const struct qstr *name);
+extern void fixup_perms_recursive(struct dentry *dentry, struct limit_search *limit);
+
+extern void update_derived_permission_lock(struct dentry *dentry);
+void fixup_lower_ownership(struct dentry *dentry, const char *name);
+extern int need_graft_path(struct dentry *dentry);
+extern int is_base_obbpath(struct dentry *dentry);
+extern int is_obbpath_invalid(struct dentry *dentry);
+extern int setup_obb_dentry(struct dentry *dentry, struct path *lower_path);
+
+/* locking helpers */
+static inline struct dentry *lock_parent(struct dentry *dentry)
+{
+	struct dentry *dir = dget_parent(dentry);
+
+	inode_lock_nested(d_inode(dir), I_MUTEX_PARENT);
+	return dir;
+}
+
+static inline void unlock_dir(struct dentry *dir)
+{
+	inode_unlock(d_inode(dir));
+	dput(dir);
+}
+
+static inline int prepare_dir(const char *path_s, uid_t uid, gid_t gid, mode_t mode)
+{
+	int err;
+	struct dentry *dent;
+	struct iattr attrs;
+	struct path parent;
+
+	dent = kern_path_locked(path_s, &parent);
+	if (IS_ERR(dent)) {
+		err = PTR_ERR(dent);
+		if (err == -EEXIST)
+			err = 0;
+		goto out_unlock;
+	}
+
+	err = vfs_mkdir2(parent.mnt, d_inode(parent.dentry), dent, mode);
+	if (err) {
+		if (err == -EEXIST)
+			err = 0;
+		goto out_dput;
+	}
+
+	attrs.ia_uid = make_kuid(&init_user_ns, uid);
+	attrs.ia_gid = make_kgid(&init_user_ns, gid);
+	attrs.ia_valid = ATTR_UID | ATTR_GID;
+	inode_lock(d_inode(dent));
+	notify_change2(parent.mnt, dent, &attrs, NULL);
+	inode_unlock(d_inode(dent));
+
+out_dput:
+	dput(dent);
+
+out_unlock:
+	/* parent dentry locked by lookup_create */
+	inode_unlock(d_inode(parent.dentry));
+	path_put(&parent);
+	return err;
+}
+
+/*
+ * Return 1, if a disk has enough free space, otherwise 0.
+ * We assume that any files can not be overwritten.
+ */
+static inline int check_min_free_space(struct dentry *dentry, size_t size, int dir)
+{
+	int err;
+	struct path lower_path;
+	struct kstatfs statfs;
+	u64 avail;
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dentry->d_sb);
+
+	if (sbi->options.reserved_mb) {
+		/* Get fs stat of lower filesystem. */
+		sdcardfs_get_lower_path(dentry, &lower_path);
+		err = vfs_statfs(&lower_path, &statfs);
+		sdcardfs_put_lower_path(dentry, &lower_path);
+
+		if (unlikely(err))
+			return 0;
+
+		/* Invalid statfs informations. */
+		if (unlikely(statfs.f_bsize == 0))
+			return 0;
+
+		/* if you are checking directory, set size to f_bsize. */
+		if (unlikely(dir))
+			size = statfs.f_bsize;
+
+		/* available size */
+		avail = statfs.f_bavail * statfs.f_bsize;
+
+		/* not enough space */
+		if ((u64)size > avail)
+			return 0;
+
+		/* enough space */
+		if ((avail - size) > (sbi->options.reserved_mb * 1024 * 1024))
+			return 1;
+
+		return 0;
+	} else
+		return 1;
+}
+
+/*
+ * Copies attrs and maintains sdcardfs managed attrs
+ * Since our permission check handles all special permissions, set those to be open
+ */
+static inline void sdcardfs_copy_and_fix_attrs(struct inode *dest, const struct inode *src)
+{
+	dest->i_mode = (src->i_mode  & S_IFMT) | S_IRWXU | S_IRWXG |
+			S_IROTH | S_IXOTH; /* 0775 */
+	dest->i_uid = make_kuid(&init_user_ns, SDCARDFS_I(dest)->data->d_uid);
+	dest->i_gid = make_kgid(&init_user_ns, AID_SDCARD_RW);
+	dest->i_rdev = src->i_rdev;
+	dest->i_atime = src->i_atime;
+	dest->i_mtime = src->i_mtime;
+	dest->i_ctime = src->i_ctime;
+	dest->i_blkbits = src->i_blkbits;
+	dest->i_flags = src->i_flags;
+	set_nlink(dest, src->i_nlink);
+}
+
+static inline bool str_case_eq(const char *s1, const char *s2)
+{
+	return !strcasecmp(s1, s2);
+}
+
+static inline bool str_n_case_eq(const char *s1, const char *s2, size_t len)
+{
+	return !strncasecmp(s1, s2, len);
+}
+
+static inline bool qstr_case_eq(const struct qstr *q1, const struct qstr *q2)
+{
+	return q1->len == q2->len && str_n_case_eq(q1->name, q2->name, q2->len);
+}
+
+#define QSTR_LITERAL(string) QSTR_INIT(string, sizeof(string)-1)
+
+#endif	/* not _SDCARDFS_H_ */
diff --git a/fs/sdcardfs/super.c b/fs/sdcardfs/super.c
new file mode 100644
index 00000000..cffcdb1
--- /dev/null
+++ b/fs/sdcardfs/super.c
@@ -0,0 +1,331 @@
+/*
+ * fs/sdcardfs/super.c
+ *
+ * Copyright (c) 2013 Samsung Electronics Co. Ltd
+ *   Authors: Daeho Jeong, Woojoong Lee, Seunghwan Hyun,
+ *               Sunghwan Yun, Sungjong Seo
+ *
+ * This program has been developed as a stackable file system based on
+ * the WrapFS which written by
+ *
+ * Copyright (c) 1998-2011 Erez Zadok
+ * Copyright (c) 2009     Shrikar Archak
+ * Copyright (c) 2003-2011 Stony Brook University
+ * Copyright (c) 2003-2011 The Research Foundation of SUNY
+ *
+ * This file is dual licensed.  It may be redistributed and/or modified
+ * under the terms of the Apache 2.0 License OR version 2 of the GNU
+ * General Public License.
+ */
+
+#include "sdcardfs.h"
+
+/*
+ * The inode cache is used with alloc_inode for both our inode info and the
+ * vfs inode.
+ */
+static struct kmem_cache *sdcardfs_inode_cachep;
+
+/*
+ * To support the top references, we must track some data separately.
+ * An sdcardfs_inode_info always has a reference to its data, and once set up,
+ * also has a reference to its top. The top may be itself, in which case it
+ * holds two references to its data. When top is changed, it takes a ref to the
+ * new data and then drops the ref to the old data.
+ */
+static struct kmem_cache *sdcardfs_inode_data_cachep;
+
+void data_release(struct kref *ref)
+{
+	struct sdcardfs_inode_data *data =
+		container_of(ref, struct sdcardfs_inode_data, refcount);
+
+	kmem_cache_free(sdcardfs_inode_data_cachep, data);
+}
+
+/* final actions when unmounting a file system */
+static void sdcardfs_put_super(struct super_block *sb)
+{
+	struct sdcardfs_sb_info *spd;
+	struct super_block *s;
+
+	spd = SDCARDFS_SB(sb);
+	if (!spd)
+		return;
+
+	if (spd->obbpath_s) {
+		kfree(spd->obbpath_s);
+		path_put(&spd->obbpath);
+	}
+
+	/* decrement lower super references */
+	s = sdcardfs_lower_super(sb);
+	sdcardfs_set_lower_super(sb, NULL);
+	atomic_dec(&s->s_active);
+
+	kfree(spd);
+	sb->s_fs_info = NULL;
+}
+
+static int sdcardfs_statfs(struct dentry *dentry, struct kstatfs *buf)
+{
+	int err;
+	struct path lower_path;
+	u32 min_blocks;
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(dentry->d_sb);
+
+	sdcardfs_get_lower_path(dentry, &lower_path);
+	err = vfs_statfs(&lower_path, buf);
+	sdcardfs_put_lower_path(dentry, &lower_path);
+
+	if (sbi->options.reserved_mb) {
+		/* Invalid statfs informations. */
+		if (buf->f_bsize == 0) {
+			pr_err("Returned block size is zero.\n");
+			return -EINVAL;
+		}
+
+		min_blocks = ((sbi->options.reserved_mb * 1024 * 1024)/buf->f_bsize);
+		buf->f_blocks -= min_blocks;
+
+		if (buf->f_bavail > min_blocks)
+			buf->f_bavail -= min_blocks;
+		else
+			buf->f_bavail = 0;
+
+		/* Make reserved blocks invisiable to media storage */
+		buf->f_bfree = buf->f_bavail;
+	}
+
+	/* set return buf to our f/s to avoid confusing user-level utils */
+	buf->f_type = SDCARDFS_SUPER_MAGIC;
+
+	return err;
+}
+
+/*
+ * @flags: numeric mount options
+ * @options: mount options string
+ */
+static int sdcardfs_remount_fs(struct super_block *sb, int *flags, char *options)
+{
+	int err = 0;
+
+	/*
+	 * The VFS will take care of "ro" and "rw" flags among others.  We
+	 * can safely accept a few flags (RDONLY, MANDLOCK), and honor
+	 * SILENT, but anything else left over is an error.
+	 */
+	if ((*flags & ~(MS_RDONLY | MS_MANDLOCK | MS_SILENT)) != 0) {
+		pr_err("sdcardfs: remount flags 0x%x unsupported\n", *flags);
+		err = -EINVAL;
+	}
+
+	return err;
+}
+
+/*
+ * @mnt: mount point we are remounting
+ * @sb: superblock we are remounting
+ * @flags: numeric mount options
+ * @options: mount options string
+ */
+static int sdcardfs_remount_fs2(struct vfsmount *mnt, struct super_block *sb,
+						int *flags, char *options)
+{
+	int err = 0;
+
+	/*
+	 * The VFS will take care of "ro" and "rw" flags among others.  We
+	 * can safely accept a few flags (RDONLY, MANDLOCK), and honor
+	 * SILENT, but anything else left over is an error.
+	 */
+	if ((*flags & ~(MS_RDONLY | MS_MANDLOCK | MS_SILENT | MS_REMOUNT)) != 0) {
+		pr_err("sdcardfs: remount flags 0x%x unsupported\n", *flags);
+		err = -EINVAL;
+	}
+	pr_info("Remount options were %s for vfsmnt %p.\n", options, mnt);
+	err = parse_options_remount(sb, options, *flags & ~MS_SILENT, mnt->data);
+
+
+	return err;
+}
+
+static void *sdcardfs_clone_mnt_data(void *data)
+{
+	struct sdcardfs_vfsmount_options *opt = kmalloc(sizeof(struct sdcardfs_vfsmount_options), GFP_KERNEL);
+	struct sdcardfs_vfsmount_options *old = data;
+
+	if (!opt)
+		return NULL;
+	opt->gid = old->gid;
+	opt->mask = old->mask;
+	return opt;
+}
+
+static void sdcardfs_copy_mnt_data(void *data, void *newdata)
+{
+	struct sdcardfs_vfsmount_options *old = data;
+	struct sdcardfs_vfsmount_options *new = newdata;
+
+	old->gid = new->gid;
+	old->mask = new->mask;
+}
+
+/*
+ * Called by iput() when the inode reference count reached zero
+ * and the inode is not hashed anywhere.  Used to clear anything
+ * that needs to be, before the inode is completely destroyed and put
+ * on the inode free list.
+ */
+static void sdcardfs_evict_inode(struct inode *inode)
+{
+	struct inode *lower_inode;
+
+	truncate_inode_pages(&inode->i_data, 0);
+	set_top(SDCARDFS_I(inode), NULL);
+	clear_inode(inode);
+	/*
+	 * Decrement a reference to a lower_inode, which was incremented
+	 * by our read_inode when it was created initially.
+	 */
+	lower_inode = sdcardfs_lower_inode(inode);
+	sdcardfs_set_lower_inode(inode, NULL);
+	iput(lower_inode);
+}
+
+static struct inode *sdcardfs_alloc_inode(struct super_block *sb)
+{
+	struct sdcardfs_inode_info *i;
+	struct sdcardfs_inode_data *d;
+
+	i = kmem_cache_alloc(sdcardfs_inode_cachep, GFP_KERNEL);
+	if (!i)
+		return NULL;
+
+	/* memset everything up to the inode to 0 */
+	memset(i, 0, offsetof(struct sdcardfs_inode_info, vfs_inode));
+
+	d = kmem_cache_alloc(sdcardfs_inode_data_cachep,
+					GFP_KERNEL | __GFP_ZERO);
+	if (!d) {
+		kmem_cache_free(sdcardfs_inode_cachep, i);
+		return NULL;
+	}
+
+	i->data = d;
+	kref_init(&d->refcount);
+	i->top_data = d;
+	spin_lock_init(&i->top_lock);
+	kref_get(&d->refcount);
+
+	i->vfs_inode.i_version = 1;
+	return &i->vfs_inode;
+}
+
+static void i_callback(struct rcu_head *head)
+{
+	struct inode *inode = container_of(head, struct inode, i_rcu);
+
+	release_own_data(SDCARDFS_I(inode));
+	kmem_cache_free(sdcardfs_inode_cachep, SDCARDFS_I(inode));
+}
+
+static void sdcardfs_destroy_inode(struct inode *inode)
+{
+	call_rcu(&inode->i_rcu, i_callback);
+}
+
+/* sdcardfs inode cache constructor */
+static void init_once(void *obj)
+{
+	struct sdcardfs_inode_info *i = obj;
+
+	inode_init_once(&i->vfs_inode);
+}
+
+int sdcardfs_init_inode_cache(void)
+{
+	sdcardfs_inode_cachep =
+		kmem_cache_create("sdcardfs_inode_cache",
+				  sizeof(struct sdcardfs_inode_info), 0,
+				  SLAB_RECLAIM_ACCOUNT, init_once);
+
+	if (!sdcardfs_inode_cachep)
+		return -ENOMEM;
+
+	sdcardfs_inode_data_cachep =
+		kmem_cache_create("sdcardfs_inode_data_cache",
+				  sizeof(struct sdcardfs_inode_data), 0,
+				  SLAB_RECLAIM_ACCOUNT, NULL);
+	if (!sdcardfs_inode_data_cachep) {
+		kmem_cache_destroy(sdcardfs_inode_cachep);
+		return -ENOMEM;
+	}
+
+	return 0;
+}
+
+/* sdcardfs inode cache destructor */
+void sdcardfs_destroy_inode_cache(void)
+{
+	kmem_cache_destroy(sdcardfs_inode_data_cachep);
+	kmem_cache_destroy(sdcardfs_inode_cachep);
+}
+
+/*
+ * Used only in nfs, to kill any pending RPC tasks, so that subsequent
+ * code can actually succeed and won't leave tasks that need handling.
+ */
+static void sdcardfs_umount_begin(struct super_block *sb)
+{
+	struct super_block *lower_sb;
+
+	lower_sb = sdcardfs_lower_super(sb);
+	if (lower_sb && lower_sb->s_op && lower_sb->s_op->umount_begin)
+		lower_sb->s_op->umount_begin(lower_sb);
+}
+
+static int sdcardfs_show_options(struct vfsmount *mnt, struct seq_file *m,
+			struct dentry *root)
+{
+	struct sdcardfs_sb_info *sbi = SDCARDFS_SB(root->d_sb);
+	struct sdcardfs_mount_options *opts = &sbi->options;
+	struct sdcardfs_vfsmount_options *vfsopts = mnt->data;
+
+	if (opts->fs_low_uid != 0)
+		seq_printf(m, ",fsuid=%u", opts->fs_low_uid);
+	if (opts->fs_low_gid != 0)
+		seq_printf(m, ",fsgid=%u", opts->fs_low_gid);
+	if (vfsopts->gid != 0)
+		seq_printf(m, ",gid=%u", vfsopts->gid);
+	if (opts->multiuser)
+		seq_puts(m, ",multiuser");
+	if (vfsopts->mask)
+		seq_printf(m, ",mask=%u", vfsopts->mask);
+	if (opts->fs_user_id)
+		seq_printf(m, ",userid=%u", opts->fs_user_id);
+	if (opts->gid_derivation)
+		seq_puts(m, ",derive_gid");
+	if (opts->default_normal)
+		seq_puts(m, ",default_normal");
+	if (opts->reserved_mb != 0)
+		seq_printf(m, ",reserved=%uMB", opts->reserved_mb);
+
+	return 0;
+};
+
+const struct super_operations sdcardfs_sops = {
+	.put_super	= sdcardfs_put_super,
+	.statfs		= sdcardfs_statfs,
+	.remount_fs	= sdcardfs_remount_fs,
+	.remount_fs2	= sdcardfs_remount_fs2,
+	.clone_mnt_data	= sdcardfs_clone_mnt_data,
+	.copy_mnt_data	= sdcardfs_copy_mnt_data,
+	.evict_inode	= sdcardfs_evict_inode,
+	.umount_begin	= sdcardfs_umount_begin,
+	.show_options2	= sdcardfs_show_options,
+	.alloc_inode	= sdcardfs_alloc_inode,
+	.destroy_inode	= sdcardfs_destroy_inode,
+	.drop_inode	= generic_delete_inode,
+};
diff --git a/fs/squashfs/Kconfig b/fs/squashfs/Kconfig
index ffb093e..6dd158a 100644
--- a/fs/squashfs/Kconfig
+++ b/fs/squashfs/Kconfig
@@ -26,34 +26,6 @@ config SQUASHFS
 	  If unsure, say N.
 
 choice
-	prompt "File decompression options"
-	depends on SQUASHFS
-	help
-	  Squashfs now supports two options for decompressing file
-	  data.  Traditionally Squashfs has decompressed into an
-	  intermediate buffer and then memcopied it into the page cache.
-	  Squashfs now supports the ability to decompress directly into
-	  the page cache.
-
-	  If unsure, select "Decompress file data into an intermediate buffer"
-
-config SQUASHFS_FILE_CACHE
-	bool "Decompress file data into an intermediate buffer"
-	help
-	  Decompress file data into an intermediate buffer and then
-	  memcopy it into the page cache.
-
-config SQUASHFS_FILE_DIRECT
-	bool "Decompress files directly into the page cache"
-	help
-	  Directly decompress file data into the page cache.
-	  Doing so can significantly improve performance because
-	  it eliminates a memcpy and it also removes the lock contention
-	  on the single buffer.
-
-endchoice
-
-choice
 	prompt "Decompressor parallelisation options"
 	depends on SQUASHFS
 	help
diff --git a/fs/squashfs/Makefile b/fs/squashfs/Makefile
index 246a6f3..fe51f15 100644
--- a/fs/squashfs/Makefile
+++ b/fs/squashfs/Makefile
@@ -5,8 +5,7 @@
 obj-$(CONFIG_SQUASHFS) += squashfs.o
 squashfs-y += block.o cache.o dir.o export.o file.o fragment.o id.o inode.o
 squashfs-y += namei.o super.o symlink.o decompressor.o
-squashfs-$(CONFIG_SQUASHFS_FILE_CACHE) += file_cache.o
-squashfs-$(CONFIG_SQUASHFS_FILE_DIRECT) += file_direct.o page_actor.o
+squashfs-y += file_direct.o page_actor.o
 squashfs-$(CONFIG_SQUASHFS_DECOMP_SINGLE) += decompressor_single.o
 squashfs-$(CONFIG_SQUASHFS_DECOMP_MULTI) += decompressor_multi.o
 squashfs-$(CONFIG_SQUASHFS_DECOMP_MULTI_PERCPU) += decompressor_multi_percpu.o
diff --git a/fs/squashfs/block.c b/fs/squashfs/block.c
index cec0fa2..7077476 100644
--- a/fs/squashfs/block.c
+++ b/fs/squashfs/block.c
@@ -28,9 +28,12 @@
 
 #include <linux/fs.h>
 #include <linux/vfs.h>
+#include <linux/bio.h>
 #include <linux/slab.h>
 #include <linux/string.h>
+#include <linux/pagemap.h>
 #include <linux/buffer_head.h>
+#include <linux/workqueue.h>
 
 #include "squashfs_fs.h"
 #include "squashfs_fs_sb.h"
@@ -38,179 +41,436 @@
 #include "decompressor.h"
 #include "page_actor.h"
 
-/*
- * Read the metadata block length, this is stored in the first two
- * bytes of the metadata block.
- */
-static struct buffer_head *get_block_length(struct super_block *sb,
-			u64 *cur_index, int *offset, int *length)
+static struct workqueue_struct *squashfs_read_wq;
+
+struct squashfs_read_request {
+	struct super_block *sb;
+	u64 index;
+	int length;
+	int compressed;
+	int offset;
+	u64 read_end;
+	struct squashfs_page_actor *output;
+	enum {
+		SQUASHFS_COPY,
+		SQUASHFS_DECOMPRESS,
+		SQUASHFS_METADATA,
+	} data_processing;
+	bool synchronous;
+
+	/*
+	 * If the read is synchronous, it is possible to retrieve information
+	 * about the request by setting these pointers.
+	 */
+	int *res;
+	int *bytes_read;
+	int *bytes_uncompressed;
+
+	int nr_buffers;
+	struct buffer_head **bh;
+	struct work_struct offload;
+};
+
+struct squashfs_bio_request {
+	struct buffer_head **bh;
+	int nr_buffers;
+};
+
+static int squashfs_bio_submit(struct squashfs_read_request *req);
+
+int squashfs_init_read_wq(void)
 {
-	struct squashfs_sb_info *msblk = sb->s_fs_info;
-	struct buffer_head *bh;
+	squashfs_read_wq = create_workqueue("SquashFS read wq");
+	return !!squashfs_read_wq;
+}
+
+void squashfs_destroy_read_wq(void)
+{
+	flush_workqueue(squashfs_read_wq);
+	destroy_workqueue(squashfs_read_wq);
+}
+
+static void free_read_request(struct squashfs_read_request *req, int error)
+{
+	if (!req->synchronous)
+		squashfs_page_actor_free(req->output, error);
+	if (req->res)
+		*(req->res) = error;
+	kfree(req->bh);
+	kfree(req);
+}
+
+static void squashfs_process_blocks(struct squashfs_read_request *req)
+{
+	int error = 0;
+	int bytes, i, length;
+	struct squashfs_sb_info *msblk = req->sb->s_fs_info;
+	struct squashfs_page_actor *actor = req->output;
+	struct buffer_head **bh = req->bh;
+	int nr_buffers = req->nr_buffers;
+
+	for (i = 0; i < nr_buffers; ++i) {
+		if (!bh[i])
+			continue;
+		wait_on_buffer(bh[i]);
+		if (!buffer_uptodate(bh[i]))
+			error = -EIO;
+	}
+	if (error)
+		goto cleanup;
+
+	if (req->data_processing == SQUASHFS_METADATA) {
+		/* Extract the length of the metadata block */
+		if (req->offset != msblk->devblksize - 1) {
+			length = le16_to_cpup((__le16 *)
+					(bh[0]->b_data + req->offset));
+		} else {
+			length = (unsigned char)bh[0]->b_data[req->offset];
+			length |= (unsigned char)bh[1]->b_data[0] << 8;
+		}
+		req->compressed = SQUASHFS_COMPRESSED(length);
+		req->data_processing = req->compressed ? SQUASHFS_DECOMPRESS
+						       : SQUASHFS_COPY;
+		length = SQUASHFS_COMPRESSED_SIZE(length);
+		if (req->index + length + 2 > req->read_end) {
+			for (i = 0; i < nr_buffers; ++i)
+				put_bh(bh[i]);
+			kfree(bh);
+			req->length = length;
+			req->index += 2;
+			squashfs_bio_submit(req);
+			return;
+		}
+		req->length = length;
+		req->offset = (req->offset + 2) % PAGE_SIZE;
+		if (req->offset < 2) {
+			put_bh(bh[0]);
+			++bh;
+			--nr_buffers;
+		}
+	}
+	if (req->bytes_read)
+		*(req->bytes_read) = req->length;
 
-	bh = sb_bread(sb, *cur_index);
-	if (bh == NULL)
-		return NULL;
-
-	if (msblk->devblksize - *offset == 1) {
-		*length = (unsigned char) bh->b_data[*offset];
-		put_bh(bh);
-		bh = sb_bread(sb, ++(*cur_index));
-		if (bh == NULL)
-			return NULL;
-		*length |= (unsigned char) bh->b_data[0] << 8;
-		*offset = 1;
-	} else {
-		*length = (unsigned char) bh->b_data[*offset] |
-			(unsigned char) bh->b_data[*offset + 1] << 8;
-		*offset += 2;
-
-		if (*offset == msblk->devblksize) {
-			put_bh(bh);
-			bh = sb_bread(sb, ++(*cur_index));
-			if (bh == NULL)
-				return NULL;
-			*offset = 0;
+	if (req->data_processing == SQUASHFS_COPY) {
+		squashfs_bh_to_actor(bh, nr_buffers, req->output, req->offset,
+			req->length, msblk->devblksize);
+	} else if (req->data_processing == SQUASHFS_DECOMPRESS) {
+		req->length = squashfs_decompress(msblk, bh, nr_buffers,
+			req->offset, req->length, actor);
+		if (req->length < 0) {
+			error = -EIO;
+			goto cleanup;
 		}
 	}
 
-	return bh;
+	/* Last page may have trailing bytes not filled */
+	bytes = req->length % PAGE_SIZE;
+	if (bytes && actor->page[actor->pages - 1])
+		zero_user_segment(actor->page[actor->pages - 1], bytes,
+				  PAGE_SIZE);
+
+cleanup:
+	if (req->bytes_uncompressed)
+		*(req->bytes_uncompressed) = req->length;
+	if (error) {
+		for (i = 0; i < nr_buffers; ++i)
+			if (bh[i])
+				put_bh(bh[i]);
+	}
+	free_read_request(req, error);
 }
 
+static void read_wq_handler(struct work_struct *work)
+{
+	squashfs_process_blocks(container_of(work,
+		    struct squashfs_read_request, offload));
+}
 
-/*
- * Read and decompress a metadata block or datablock.  Length is non-zero
- * if a datablock is being read (the size is stored elsewhere in the
- * filesystem), otherwise the length is obtained from the first two bytes of
- * the metadata block.  A bit in the length field indicates if the block
- * is stored uncompressed in the filesystem (usually because compression
- * generated a larger block - this does occasionally happen with compression
- * algorithms).
- */
-int squashfs_read_data(struct super_block *sb, u64 index, int length,
-		u64 *next_index, struct squashfs_page_actor *output)
+static void squashfs_bio_end_io(struct bio *bio)
 {
-	struct squashfs_sb_info *msblk = sb->s_fs_info;
-	struct buffer_head **bh;
-	int offset = index & ((1 << msblk->devblksize_log2) - 1);
-	u64 cur_index = index >> msblk->devblksize_log2;
-	int bytes, compressed, b = 0, k = 0, avail, i;
+	int i;
+	int error = bio->bi_error;
+	struct squashfs_bio_request *bio_req = bio->bi_private;
+
+	bio_put(bio);
+
+	for (i = 0; i < bio_req->nr_buffers; ++i) {
+		if (!bio_req->bh[i])
+			continue;
+		if (!error)
+			set_buffer_uptodate(bio_req->bh[i]);
+		else
+			clear_buffer_uptodate(bio_req->bh[i]);
+		unlock_buffer(bio_req->bh[i]);
+	}
+	kfree(bio_req);
+}
+
+static int bh_is_optional(struct squashfs_read_request *req, int idx)
+{
+	int start_idx, end_idx;
+	struct squashfs_sb_info *msblk = req->sb->s_fs_info;
 
-	bh = kcalloc(((output->length + msblk->devblksize - 1)
-		>> msblk->devblksize_log2) + 1, sizeof(*bh), GFP_KERNEL);
-	if (bh == NULL)
+	start_idx = (idx * msblk->devblksize - req->offset) >> PAGE_SHIFT;
+	end_idx = ((idx + 1) * msblk->devblksize - req->offset + 1) >> PAGE_SHIFT;
+	if (start_idx >= req->output->pages)
+		return 1;
+	if (start_idx < 0)
+		start_idx = end_idx;
+	if (end_idx >= req->output->pages)
+		end_idx = start_idx;
+	return !req->output->page[start_idx] && !req->output->page[end_idx];
+}
+
+static int actor_getblks(struct squashfs_read_request *req, u64 block)
+{
+	int i;
+
+	req->bh = kmalloc_array(req->nr_buffers, sizeof(*(req->bh)), GFP_NOIO);
+	if (!req->bh)
 		return -ENOMEM;
 
-	if (length) {
+	for (i = 0; i < req->nr_buffers; ++i) {
 		/*
-		 * Datablock.
+		 * When dealing with an uncompressed block, the actor may
+		 * contains NULL pages. There's no need to read the buffers
+		 * associated with these pages.
 		 */
-		bytes = -offset;
-		compressed = SQUASHFS_COMPRESSED_BLOCK(length);
-		length = SQUASHFS_COMPRESSED_SIZE_BLOCK(length);
-		if (next_index)
-			*next_index = index + length;
-
-		TRACE("Block @ 0x%llx, %scompressed size %d, src size %d\n",
-			index, compressed ? "" : "un", length, output->length);
-
-		if (length < 0 || length > output->length ||
-				(index + length) > msblk->bytes_used)
-			goto read_failure;
-
-		for (b = 0; bytes < length; b++, cur_index++) {
-			bh[b] = sb_getblk(sb, cur_index);
-			if (bh[b] == NULL)
-				goto block_release;
-			bytes += msblk->devblksize;
+		if (!req->compressed && bh_is_optional(req, i)) {
+			req->bh[i] = NULL;
+			continue;
 		}
-		ll_rw_block(REQ_OP_READ, 0, b, bh);
-	} else {
-		/*
-		 * Metadata block.
-		 */
-		if ((index + 2) > msblk->bytes_used)
-			goto read_failure;
+		req->bh[i] = sb_getblk(req->sb, block + i);
+		if (!req->bh[i]) {
+			while (--i) {
+				if (req->bh[i])
+					put_bh(req->bh[i]);
+			}
+			return -1;
+		}
+	}
+	return 0;
+}
 
-		bh[0] = get_block_length(sb, &cur_index, &offset, &length);
-		if (bh[0] == NULL)
-			goto read_failure;
-		b = 1;
+static int squashfs_bio_submit(struct squashfs_read_request *req)
+{
+	struct bio *bio = NULL;
+	struct buffer_head *bh;
+	struct squashfs_bio_request *bio_req = NULL;
+	int b = 0, prev_block = 0;
+	struct squashfs_sb_info *msblk = req->sb->s_fs_info;
 
-		bytes = msblk->devblksize - offset;
-		compressed = SQUASHFS_COMPRESSED(length);
-		length = SQUASHFS_COMPRESSED_SIZE(length);
-		if (next_index)
-			*next_index = index + length + 2;
+	u64 read_start = round_down(req->index, msblk->devblksize);
+	u64 read_end = round_up(req->index + req->length, msblk->devblksize);
+	sector_t block = read_start >> msblk->devblksize_log2;
+	sector_t block_end = read_end >> msblk->devblksize_log2;
+	int offset = read_start - round_down(req->index, PAGE_SIZE);
+	int nr_buffers = block_end - block;
+	int blksz = msblk->devblksize;
+	int bio_max_pages = nr_buffers > BIO_MAX_PAGES ? BIO_MAX_PAGES
+						       : nr_buffers;
 
-		TRACE("Block @ 0x%llx, %scompressed size %d\n", index,
-				compressed ? "" : "un", length);
+	/* Setup the request */
+	req->read_end = read_end;
+	req->offset = req->index - read_start;
+	req->nr_buffers = nr_buffers;
+	if (actor_getblks(req, block) < 0)
+		goto getblk_failed;
 
-		if (length < 0 || length > output->length ||
-					(index + length) > msblk->bytes_used)
-			goto block_release;
+	/* Create and submit the BIOs */
+	for (b = 0; b < nr_buffers; ++b, offset += blksz) {
+		bh = req->bh[b];
+		if (!bh || !trylock_buffer(bh))
+			continue;
+		if (buffer_uptodate(bh)) {
+			unlock_buffer(bh);
+			continue;
+		}
+		offset %= PAGE_SIZE;
 
-		for (; bytes < length; b++) {
-			bh[b] = sb_getblk(sb, ++cur_index);
-			if (bh[b] == NULL)
-				goto block_release;
-			bytes += msblk->devblksize;
+		/* Append the buffer to the current BIO if it is contiguous */
+		if (bio && bio_req && prev_block + 1 == b) {
+			if (bio_add_page(bio, bh->b_page, blksz, offset)) {
+				bio_req->nr_buffers += 1;
+				prev_block = b;
+				continue;
+			}
 		}
-		ll_rw_block(REQ_OP_READ, 0, b - 1, bh + 1);
+
+		/* Otherwise, submit the current BIO and create a new one */
+		if (bio)
+			submit_bio(bio);
+		bio_req = kcalloc(1, sizeof(struct squashfs_bio_request),
+				  GFP_NOIO);
+		if (!bio_req)
+			goto req_alloc_failed;
+		bio_req->bh = &req->bh[b];
+		bio = bio_alloc(GFP_NOIO, bio_max_pages);
+		if (!bio)
+			goto bio_alloc_failed;
+		bio->bi_bdev = req->sb->s_bdev;
+		bio->bi_iter.bi_sector = (block + b)
+				       << (msblk->devblksize_log2 - 9);
+		bio_set_op_attrs(bio, REQ_OP_READ, 0);
+		bio->bi_private = bio_req;
+		bio->bi_end_io = squashfs_bio_end_io;
+
+		bio_add_page(bio, bh->b_page, blksz, offset);
+		bio_req->nr_buffers += 1;
+		prev_block = b;
 	}
+	if (bio)
+		submit_bio(bio);
 
-	for (i = 0; i < b; i++) {
-		wait_on_buffer(bh[i]);
-		if (!buffer_uptodate(bh[i]))
-			goto block_release;
+	if (req->synchronous)
+		squashfs_process_blocks(req);
+	else {
+		INIT_WORK(&req->offload, read_wq_handler);
+		schedule_work(&req->offload);
 	}
+	return 0;
 
-	if (compressed) {
-		if (!msblk->stream)
-			goto read_failure;
-		length = squashfs_decompress(msblk, bh, b, offset, length,
-			output);
-		if (length < 0)
-			goto read_failure;
-	} else {
-		/*
-		 * Block is uncompressed.
-		 */
-		int in, pg_offset = 0;
-		void *data = squashfs_first_page(output);
-
-		for (bytes = length; k < b; k++) {
-			in = min(bytes, msblk->devblksize - offset);
-			bytes -= in;
-			while (in) {
-				if (pg_offset == PAGE_SIZE) {
-					data = squashfs_next_page(output);
-					pg_offset = 0;
-				}
-				avail = min_t(int, in, PAGE_SIZE -
-						pg_offset);
-				memcpy(data + pg_offset, bh[k]->b_data + offset,
-						avail);
-				in -= avail;
-				pg_offset += avail;
-				offset += avail;
-			}
-			offset = 0;
-			put_bh(bh[k]);
-		}
-		squashfs_finish_page(output);
+bio_alloc_failed:
+	kfree(bio_req);
+req_alloc_failed:
+	unlock_buffer(bh);
+	while (--nr_buffers >= b)
+		if (req->bh[nr_buffers])
+			put_bh(req->bh[nr_buffers]);
+	while (--b >= 0)
+		if (req->bh[b])
+			wait_on_buffer(req->bh[b]);
+getblk_failed:
+	free_read_request(req, -ENOMEM);
+	return -ENOMEM;
+}
+
+static int read_metadata_block(struct squashfs_read_request *req,
+			       u64 *next_index)
+{
+	int ret, error, bytes_read = 0, bytes_uncompressed = 0;
+	struct squashfs_sb_info *msblk = req->sb->s_fs_info;
+
+	if (req->index + 2 > msblk->bytes_used) {
+		free_read_request(req, -EINVAL);
+		return -EINVAL;
+	}
+	req->length = 2;
+
+	/* Do not read beyond the end of the device */
+	if (req->index + req->length > msblk->bytes_used)
+		req->length = msblk->bytes_used - req->index;
+	req->data_processing = SQUASHFS_METADATA;
+
+	/*
+	 * Reading metadata is always synchronous because we don't know the
+	 * length in advance and the function is expected to update
+	 * 'next_index' and return the length.
+	 */
+	req->synchronous = true;
+	req->res = &error;
+	req->bytes_read = &bytes_read;
+	req->bytes_uncompressed = &bytes_uncompressed;
+
+	TRACE("Metadata block @ 0x%llx, %scompressed size %d, src size %d\n",
+	      req->index, req->compressed ? "" : "un", bytes_read,
+	      req->output->length);
+
+	ret = squashfs_bio_submit(req);
+	if (ret)
+		return ret;
+	if (error)
+		return error;
+	if (next_index)
+		*next_index += 2 + bytes_read;
+	return bytes_uncompressed;
+}
+
+static int read_data_block(struct squashfs_read_request *req, int length,
+			   u64 *next_index, bool synchronous)
+{
+	int ret, error = 0, bytes_uncompressed = 0, bytes_read = 0;
+
+	req->compressed = SQUASHFS_COMPRESSED_BLOCK(length);
+	req->length = length = SQUASHFS_COMPRESSED_SIZE_BLOCK(length);
+	req->data_processing = req->compressed ? SQUASHFS_DECOMPRESS
+					       : SQUASHFS_COPY;
+
+	req->synchronous = synchronous;
+	if (synchronous) {
+		req->res = &error;
+		req->bytes_read = &bytes_read;
+		req->bytes_uncompressed = &bytes_uncompressed;
+	}
+
+	TRACE("Data block @ 0x%llx, %scompressed size %d, src size %d\n",
+	      req->index, req->compressed ? "" : "un", req->length,
+	      req->output->length);
+
+	ret = squashfs_bio_submit(req);
+	if (ret)
+		return ret;
+	if (synchronous)
+		ret = error ? error : bytes_uncompressed;
+	if (next_index)
+		*next_index += length;
+	return ret;
+}
+
+/*
+ * Read and decompress a metadata block or datablock.  Length is non-zero
+ * if a datablock is being read (the size is stored elsewhere in the
+ * filesystem), otherwise the length is obtained from the first two bytes of
+ * the metadata block.  A bit in the length field indicates if the block
+ * is stored uncompressed in the filesystem (usually because compression
+ * generated a larger block - this does occasionally happen with compression
+ * algorithms).
+ */
+static int __squashfs_read_data(struct super_block *sb, u64 index, int length,
+	u64 *next_index, struct squashfs_page_actor *output, bool sync)
+{
+	struct squashfs_read_request *req;
+
+	req = kcalloc(1, sizeof(struct squashfs_read_request), GFP_KERNEL);
+	if (!req) {
+		if (!sync)
+			squashfs_page_actor_free(output, -ENOMEM);
+		return -ENOMEM;
+	}
+
+	req->sb = sb;
+	req->index = index;
+	req->output = output;
+
+	if (next_index)
+		*next_index = index;
+
+	if (length)
+		length = read_data_block(req, length, next_index, sync);
+	else
+		length = read_metadata_block(req, next_index);
+
+	if (length < 0) {
+		ERROR("squashfs_read_data failed to read block 0x%llx\n",
+		      (unsigned long long)index);
+		return -EIO;
 	}
 
-	kfree(bh);
 	return length;
+}
 
-block_release:
-	for (; k < b; k++)
-		put_bh(bh[k]);
+int squashfs_read_data(struct super_block *sb, u64 index, int length,
+	u64 *next_index, struct squashfs_page_actor *output)
+{
+	return __squashfs_read_data(sb, index, length, next_index, output,
+				    true);
+}
+
+int squashfs_read_data_async(struct super_block *sb, u64 index, int length,
+	u64 *next_index, struct squashfs_page_actor *output)
+{
 
-read_failure:
-	ERROR("squashfs_read_data failed to read block 0x%llx\n",
-					(unsigned long long) index);
-	kfree(bh);
-	return -EIO;
+	return __squashfs_read_data(sb, index, length, next_index, output,
+				    false);
 }
diff --git a/fs/squashfs/cache.c b/fs/squashfs/cache.c
index 0839efa..9d9d4aa 100644
--- a/fs/squashfs/cache.c
+++ b/fs/squashfs/cache.c
@@ -209,17 +209,14 @@ void squashfs_cache_put(struct squashfs_cache_entry *entry)
  */
 void squashfs_cache_delete(struct squashfs_cache *cache)
 {
-	int i, j;
+	int i;
 
 	if (cache == NULL)
 		return;
 
 	for (i = 0; i < cache->entries; i++) {
-		if (cache->entry[i].data) {
-			for (j = 0; j < cache->pages; j++)
-				kfree(cache->entry[i].data[j]);
-			kfree(cache->entry[i].data);
-		}
+		if (cache->entry[i].page)
+			free_page_array(cache->entry[i].page, cache->pages);
 		kfree(cache->entry[i].actor);
 	}
 
@@ -236,7 +233,7 @@ void squashfs_cache_delete(struct squashfs_cache *cache)
 struct squashfs_cache *squashfs_cache_init(char *name, int entries,
 	int block_size)
 {
-	int i, j;
+	int i;
 	struct squashfs_cache *cache = kzalloc(sizeof(*cache), GFP_KERNEL);
 
 	if (cache == NULL) {
@@ -268,22 +265,13 @@ struct squashfs_cache *squashfs_cache_init(char *name, int entries,
 		init_waitqueue_head(&cache->entry[i].wait_queue);
 		entry->cache = cache;
 		entry->block = SQUASHFS_INVALID_BLK;
-		entry->data = kcalloc(cache->pages, sizeof(void *), GFP_KERNEL);
-		if (entry->data == NULL) {
+		entry->page = alloc_page_array(cache->pages, GFP_KERNEL);
+		if (!entry->page) {
 			ERROR("Failed to allocate %s cache entry\n", name);
 			goto cleanup;
 		}
-
-		for (j = 0; j < cache->pages; j++) {
-			entry->data[j] = kmalloc(PAGE_SIZE, GFP_KERNEL);
-			if (entry->data[j] == NULL) {
-				ERROR("Failed to allocate %s buffer\n", name);
-				goto cleanup;
-			}
-		}
-
-		entry->actor = squashfs_page_actor_init(entry->data,
-						cache->pages, 0);
+		entry->actor = squashfs_page_actor_init(entry->page,
+			cache->pages, 0, NULL);
 		if (entry->actor == NULL) {
 			ERROR("Failed to allocate %s cache entry\n", name);
 			goto cleanup;
@@ -314,18 +302,20 @@ int squashfs_copy_data(void *buffer, struct squashfs_cache_entry *entry,
 		return min(length, entry->length - offset);
 
 	while (offset < entry->length) {
-		void *buff = entry->data[offset / PAGE_SIZE]
-				+ (offset % PAGE_SIZE);
+		void *buff = kmap_atomic(entry->page[offset / PAGE_SIZE])
+			     + (offset % PAGE_SIZE);
 		int bytes = min_t(int, entry->length - offset,
 				PAGE_SIZE - (offset % PAGE_SIZE));
 
 		if (bytes >= remaining) {
 			memcpy(buffer, buff, remaining);
+			kunmap_atomic(buff);
 			remaining = 0;
 			break;
 		}
 
 		memcpy(buffer, buff, bytes);
+		kunmap_atomic(buff);
 		buffer += bytes;
 		remaining -= bytes;
 		offset += bytes;
@@ -419,43 +409,38 @@ struct squashfs_cache_entry *squashfs_get_datablock(struct super_block *sb,
 void *squashfs_read_table(struct super_block *sb, u64 block, int length)
 {
 	int pages = (length + PAGE_SIZE - 1) >> PAGE_SHIFT;
-	int i, res;
-	void *table, *buffer, **data;
+	struct page **page;
+	void *buff;
+	int res;
 	struct squashfs_page_actor *actor;
 
-	table = buffer = kmalloc(length, GFP_KERNEL);
-	if (table == NULL)
+	page = alloc_page_array(pages, GFP_KERNEL);
+	if (!page)
 		return ERR_PTR(-ENOMEM);
 
-	data = kcalloc(pages, sizeof(void *), GFP_KERNEL);
-	if (data == NULL) {
-		res = -ENOMEM;
-		goto failed;
-	}
-
-	actor = squashfs_page_actor_init(data, pages, length);
+	actor = squashfs_page_actor_init(page, pages, length, NULL);
 	if (actor == NULL) {
 		res = -ENOMEM;
-		goto failed2;
+		goto failed;
 	}
 
-	for (i = 0; i < pages; i++, buffer += PAGE_SIZE)
-		data[i] = buffer;
-
 	res = squashfs_read_data(sb, block, length |
 		SQUASHFS_COMPRESSED_BIT_BLOCK, NULL, actor);
 
-	kfree(data);
-	kfree(actor);
-
 	if (res < 0)
-		goto failed;
+		goto failed2;
 
-	return table;
+	buff = kmalloc(length, GFP_KERNEL);
+	if (!buff)
+		goto failed2;
+	squashfs_actor_to_buf(actor, buff, length);
+	squashfs_page_actor_free(actor, 0);
+	free_page_array(page, pages);
+	return buff;
 
 failed2:
-	kfree(data);
+	squashfs_page_actor_free(actor, 0);
 failed:
-	kfree(table);
+	free_page_array(page, pages);
 	return ERR_PTR(res);
 }
diff --git a/fs/squashfs/decompressor.c b/fs/squashfs/decompressor.c
index d2bc136..7de35bf 100644
--- a/fs/squashfs/decompressor.c
+++ b/fs/squashfs/decompressor.c
@@ -24,7 +24,8 @@
 #include <linux/types.h>
 #include <linux/mutex.h>
 #include <linux/slab.h>
-#include <linux/buffer_head.h>
+#include <linux/highmem.h>
+#include <linux/fs.h>
 
 #include "squashfs_fs.h"
 #include "squashfs_fs_sb.h"
@@ -94,40 +95,44 @@ const struct squashfs_decompressor *squashfs_lookup_decompressor(int id)
 static void *get_comp_opts(struct super_block *sb, unsigned short flags)
 {
 	struct squashfs_sb_info *msblk = sb->s_fs_info;
-	void *buffer = NULL, *comp_opts;
+	void *comp_opts, *buffer = NULL;
+	struct page *page;
 	struct squashfs_page_actor *actor = NULL;
 	int length = 0;
 
+	if (!SQUASHFS_COMP_OPTS(flags))
+		return squashfs_comp_opts(msblk, buffer, length);
+
 	/*
 	 * Read decompressor specific options from file system if present
 	 */
-	if (SQUASHFS_COMP_OPTS(flags)) {
-		buffer = kmalloc(PAGE_SIZE, GFP_KERNEL);
-		if (buffer == NULL) {
-			comp_opts = ERR_PTR(-ENOMEM);
-			goto out;
-		}
-
-		actor = squashfs_page_actor_init(&buffer, 1, 0);
-		if (actor == NULL) {
-			comp_opts = ERR_PTR(-ENOMEM);
-			goto out;
-		}
-
-		length = squashfs_read_data(sb,
-			sizeof(struct squashfs_super_block), 0, NULL, actor);
-
-		if (length < 0) {
-			comp_opts = ERR_PTR(length);
-			goto out;
-		}
+
+	page = alloc_page(GFP_KERNEL);
+	if (!page)
+		return ERR_PTR(-ENOMEM);
+
+	actor = squashfs_page_actor_init(&page, 1, 0, NULL);
+	if (actor == NULL) {
+		comp_opts = ERR_PTR(-ENOMEM);
+		goto actor_error;
+	}
+
+	length = squashfs_read_data(sb,
+		sizeof(struct squashfs_super_block), 0, NULL, actor);
+
+	if (length < 0) {
+		comp_opts = ERR_PTR(length);
+		goto read_error;
 	}
 
+	buffer = kmap_atomic(page);
 	comp_opts = squashfs_comp_opts(msblk, buffer, length);
+	kunmap_atomic(buffer);
 
-out:
-	kfree(actor);
-	kfree(buffer);
+read_error:
+	squashfs_page_actor_free(actor, 0);
+actor_error:
+	__free_page(page);
 	return comp_opts;
 }
 
diff --git a/fs/squashfs/file.c b/fs/squashfs/file.c
index fcff2e0..cd3c5c8 100644
--- a/fs/squashfs/file.c
+++ b/fs/squashfs/file.c
@@ -47,6 +47,7 @@
 #include <linux/string.h>
 #include <linux/pagemap.h>
 #include <linux/mutex.h>
+#include <linux/mm_inline.h>
 
 #include "squashfs_fs.h"
 #include "squashfs_fs_sb.h"
@@ -442,6 +443,21 @@ static int squashfs_readpage_fragment(struct page *page)
 	return res;
 }
 
+static int squashfs_readpages_fragment(struct page *page,
+	struct list_head *readahead_pages, struct address_space *mapping)
+{
+	if (!page) {
+		page = lru_to_page(readahead_pages);
+		list_del(&page->lru);
+		if (add_to_page_cache_lru(page, mapping, page->index,
+			mapping_gfp_constraint(mapping, GFP_KERNEL))) {
+			put_page(page);
+			return 0;
+		}
+	}
+	return squashfs_readpage_fragment(page);
+}
+
 static int squashfs_readpage_sparse(struct page *page, int index, int file_end)
 {
 	struct inode *inode = page->mapping->host;
@@ -454,54 +470,105 @@ static int squashfs_readpage_sparse(struct page *page, int index, int file_end)
 	return 0;
 }
 
-static int squashfs_readpage(struct file *file, struct page *page)
+static int squashfs_readpages_sparse(struct page *page,
+	struct list_head *readahead_pages, int index, int file_end,
+	struct address_space *mapping)
 {
-	struct inode *inode = page->mapping->host;
+	if (!page) {
+		page = lru_to_page(readahead_pages);
+		list_del(&page->lru);
+		if (add_to_page_cache_lru(page, mapping, page->index,
+			mapping_gfp_constraint(mapping, GFP_KERNEL))) {
+			put_page(page);
+			return 0;
+		}
+	}
+	return squashfs_readpage_sparse(page, index, file_end);
+}
+
+static int __squashfs_readpages(struct file *file, struct page *page,
+	struct list_head *readahead_pages, unsigned int nr_pages,
+	struct address_space *mapping)
+{
+	struct inode *inode = mapping->host;
 	struct squashfs_sb_info *msblk = inode->i_sb->s_fs_info;
-	int index = page->index >> (msblk->block_log - PAGE_SHIFT);
 	int file_end = i_size_read(inode) >> msblk->block_log;
 	int res;
-	void *pageaddr;
 
-	TRACE("Entered squashfs_readpage, page index %lx, start block %llx\n",
-				page->index, squashfs_i(inode)->start);
+	do {
+		struct page *cur_page = page ? page
+					     : lru_to_page(readahead_pages);
+		int page_index = cur_page->index;
+		int index = page_index >> (msblk->block_log - PAGE_SHIFT);
+
+		if (page_index >= ((i_size_read(inode) + PAGE_SIZE - 1) >>
+						PAGE_SHIFT))
+			return 1;
+
+		if (index < file_end || squashfs_i(inode)->fragment_block ==
+						SQUASHFS_INVALID_BLK) {
+			u64 block = 0;
+			int bsize = read_blocklist(inode, index, &block);
+
+			if (bsize < 0)
+				return -1;
+
+			if (bsize == 0) {
+				res = squashfs_readpages_sparse(page,
+					readahead_pages, index, file_end,
+					mapping);
+			} else {
+				res = squashfs_readpages_block(page,
+					readahead_pages, &nr_pages, mapping,
+					page_index, block, bsize);
+			}
+		} else {
+			res = squashfs_readpages_fragment(page,
+				readahead_pages, mapping);
+		}
+		if (res)
+			return 0;
+		page = NULL;
+	} while (readahead_pages && !list_empty(readahead_pages));
+
+	return 0;
+}
+
+static int squashfs_readpage(struct file *file, struct page *page)
+{
+	int ret;
 
-	if (page->index >= ((i_size_read(inode) + PAGE_SIZE - 1) >>
-					PAGE_SHIFT))
-		goto out;
+	TRACE("Entered squashfs_readpage, page index %lx, start block %llx\n",
+	      page->index, squashfs_i(page->mapping->host)->start);
 
-	if (index < file_end || squashfs_i(inode)->fragment_block ==
-					SQUASHFS_INVALID_BLK) {
-		u64 block = 0;
-		int bsize = read_blocklist(inode, index, &block);
-		if (bsize < 0)
-			goto error_out;
+	get_page(page);
 
-		if (bsize == 0)
-			res = squashfs_readpage_sparse(page, index, file_end);
+	ret = __squashfs_readpages(file, page, NULL, 1, page->mapping);
+	if (ret) {
+		flush_dcache_page(page);
+		if (ret < 0)
+			SetPageError(page);
 		else
-			res = squashfs_readpage_block(page, block, bsize);
-	} else
-		res = squashfs_readpage_fragment(page);
-
-	if (!res)
-		return 0;
-
-error_out:
-	SetPageError(page);
-out:
-	pageaddr = kmap_atomic(page);
-	memset(pageaddr, 0, PAGE_SIZE);
-	kunmap_atomic(pageaddr);
-	flush_dcache_page(page);
-	if (!PageError(page))
-		SetPageUptodate(page);
-	unlock_page(page);
+			SetPageUptodate(page);
+		zero_user_segment(page, 0, PAGE_SIZE);
+		unlock_page(page);
+		put_page(page);
+	}
 
 	return 0;
 }
 
+static int squashfs_readpages(struct file *file, struct address_space *mapping,
+			      struct list_head *pages, unsigned int nr_pages)
+{
+	TRACE("Entered squashfs_readpages, %u pages, first page index %lx\n",
+		nr_pages, lru_to_page(pages)->index);
+	__squashfs_readpages(file, NULL, pages, nr_pages, mapping);
+	return 0;
+}
+
 
 const struct address_space_operations squashfs_aops = {
-	.readpage = squashfs_readpage
+	.readpage = squashfs_readpage,
+	.readpages = squashfs_readpages,
 };
diff --git a/fs/squashfs/file_cache.c b/fs/squashfs/file_cache.c
deleted file mode 100644
index f2310d2..00000000
--- a/fs/squashfs/file_cache.c
+++ /dev/null
@@ -1,38 +0,0 @@
-/*
- * Copyright (c) 2013
- * Phillip Lougher <phillip@squashfs.org.uk>
- *
- * This work is licensed under the terms of the GNU GPL, version 2. See
- * the COPYING file in the top-level directory.
- */
-
-#include <linux/fs.h>
-#include <linux/vfs.h>
-#include <linux/kernel.h>
-#include <linux/slab.h>
-#include <linux/string.h>
-#include <linux/pagemap.h>
-#include <linux/mutex.h>
-
-#include "squashfs_fs.h"
-#include "squashfs_fs_sb.h"
-#include "squashfs_fs_i.h"
-#include "squashfs.h"
-
-/* Read separately compressed datablock and memcopy into page cache */
-int squashfs_readpage_block(struct page *page, u64 block, int bsize)
-{
-	struct inode *i = page->mapping->host;
-	struct squashfs_cache_entry *buffer = squashfs_get_datablock(i->i_sb,
-		block, bsize);
-	int res = buffer->error;
-
-	if (res)
-		ERROR("Unable to read page, block %llx, size %x\n", block,
-			bsize);
-	else
-		squashfs_copy_cache(page, buffer, buffer->length, 0);
-
-	squashfs_cache_put(buffer);
-	return res;
-}
diff --git a/fs/squashfs/file_direct.c b/fs/squashfs/file_direct.c
index cb485d8..dc87f77 100644
--- a/fs/squashfs/file_direct.c
+++ b/fs/squashfs/file_direct.c
@@ -13,6 +13,7 @@
 #include <linux/string.h>
 #include <linux/pagemap.h>
 #include <linux/mutex.h>
+#include <linux/mm_inline.h>
 
 #include "squashfs_fs.h"
 #include "squashfs_fs_sb.h"
@@ -20,157 +21,136 @@
 #include "squashfs.h"
 #include "page_actor.h"
 
-static int squashfs_read_cache(struct page *target_page, u64 block, int bsize,
-	int pages, struct page **page);
+static void release_actor_pages(struct page **page, int pages, int error)
+{
+	int i;
 
-/* Read separately compressed datablock directly into page cache */
-int squashfs_readpage_block(struct page *target_page, u64 block, int bsize)
+	for (i = 0; i < pages; i++) {
+		if (!page[i])
+			continue;
+		flush_dcache_page(page[i]);
+		if (!error)
+			SetPageUptodate(page[i]);
+		else {
+			SetPageError(page[i]);
+			zero_user_segment(page[i], 0, PAGE_SIZE);
+		}
+		unlock_page(page[i]);
+		put_page(page[i]);
+	}
+	kfree(page);
+}
 
+/*
+ * Create a "page actor" which will kmap and kunmap the
+ * page cache pages appropriately within the decompressor
+ */
+static struct squashfs_page_actor *actor_from_page_cache(
+	unsigned int actor_pages, struct page *target_page,
+	struct list_head *rpages, unsigned int *nr_pages, int start_index,
+	struct address_space *mapping)
 {
-	struct inode *inode = target_page->mapping->host;
-	struct squashfs_sb_info *msblk = inode->i_sb->s_fs_info;
-
-	int file_end = (i_size_read(inode) - 1) >> PAGE_SHIFT;
-	int mask = (1 << (msblk->block_log - PAGE_SHIFT)) - 1;
-	int start_index = target_page->index & ~mask;
-	int end_index = start_index | mask;
-	int i, n, pages, missing_pages, bytes, res = -ENOMEM;
 	struct page **page;
 	struct squashfs_page_actor *actor;
-	void *pageaddr;
-
-	if (end_index > file_end)
-		end_index = file_end;
-
-	pages = end_index - start_index + 1;
-
-	page = kmalloc_array(pages, sizeof(void *), GFP_KERNEL);
-	if (page == NULL)
-		return res;
-
-	/*
-	 * Create a "page actor" which will kmap and kunmap the
-	 * page cache pages appropriately within the decompressor
-	 */
-	actor = squashfs_page_actor_init_special(page, pages, 0);
-	if (actor == NULL)
-		goto out;
-
-	/* Try to grab all the pages covered by the Squashfs block */
-	for (missing_pages = 0, i = 0, n = start_index; i < pages; i++, n++) {
-		page[i] = (n == target_page->index) ? target_page :
-			grab_cache_page_nowait(target_page->mapping, n);
+	int i, n;
+	gfp_t gfp = mapping_gfp_constraint(mapping, GFP_KERNEL);
+
+	page = kmalloc_array(actor_pages, sizeof(void *), GFP_KERNEL);
+	if (!page)
+		return NULL;
+
+	for (i = 0, n = start_index; i < actor_pages; i++, n++) {
+		if (target_page == NULL && rpages && !list_empty(rpages)) {
+			struct page *cur_page = lru_to_page(rpages);
+
+			if (cur_page->index < start_index + actor_pages) {
+				list_del(&cur_page->lru);
+				--(*nr_pages);
+				if (add_to_page_cache_lru(cur_page, mapping,
+							  cur_page->index, gfp))
+					put_page(cur_page);
+				else
+					target_page = cur_page;
+			} else
+				rpages = NULL;
+		}
 
-		if (page[i] == NULL) {
-			missing_pages++;
-			continue;
+		if (target_page && target_page->index == n) {
+			page[i] = target_page;
+			target_page = NULL;
+		} else {
+			page[i] = grab_cache_page_nowait(mapping, n);
+			if (page[i] == NULL)
+				continue;
 		}
 
 		if (PageUptodate(page[i])) {
 			unlock_page(page[i]);
 			put_page(page[i]);
 			page[i] = NULL;
-			missing_pages++;
 		}
 	}
 
-	if (missing_pages) {
-		/*
-		 * Couldn't get one or more pages, this page has either
-		 * been VM reclaimed, but others are still in the page cache
-		 * and uptodate, or we're racing with another thread in
-		 * squashfs_readpage also trying to grab them.  Fall back to
-		 * using an intermediate buffer.
-		 */
-		res = squashfs_read_cache(target_page, block, bsize, pages,
-								page);
-		if (res < 0)
-			goto mark_errored;
-
-		goto out;
+	actor = squashfs_page_actor_init(page, actor_pages, 0,
+			release_actor_pages);
+	if (!actor) {
+		release_actor_pages(page, actor_pages, -ENOMEM);
+		kfree(page);
+		return NULL;
 	}
-
-	/* Decompress directly into the page cache buffers */
-	res = squashfs_read_data(inode->i_sb, block, bsize, NULL, actor);
-	if (res < 0)
-		goto mark_errored;
-
-	/* Last page may have trailing bytes not filled */
-	bytes = res % PAGE_SIZE;
-	if (bytes) {
-		pageaddr = kmap_atomic(page[pages - 1]);
-		memset(pageaddr + bytes, 0, PAGE_SIZE - bytes);
-		kunmap_atomic(pageaddr);
-	}
-
-	/* Mark pages as uptodate, unlock and release */
-	for (i = 0; i < pages; i++) {
-		flush_dcache_page(page[i]);
-		SetPageUptodate(page[i]);
-		unlock_page(page[i]);
-		if (page[i] != target_page)
-			put_page(page[i]);
-	}
-
-	kfree(actor);
-	kfree(page);
-
-	return 0;
-
-mark_errored:
-	/* Decompression failed, mark pages as errored.  Target_page is
-	 * dealt with by the caller
-	 */
-	for (i = 0; i < pages; i++) {
-		if (page[i] == NULL || page[i] == target_page)
-			continue;
-		flush_dcache_page(page[i]);
-		SetPageError(page[i]);
-		unlock_page(page[i]);
-		put_page(page[i]);
-	}
-
-out:
-	kfree(actor);
-	kfree(page);
-	return res;
+	return actor;
 }
 
+int squashfs_readpages_block(struct page *target_page,
+			     struct list_head *readahead_pages,
+			     unsigned int *nr_pages,
+			     struct address_space *mapping,
+			     int page_index, u64 block, int bsize)
 
-static int squashfs_read_cache(struct page *target_page, u64 block, int bsize,
-	int pages, struct page **page)
 {
-	struct inode *i = target_page->mapping->host;
-	struct squashfs_cache_entry *buffer = squashfs_get_datablock(i->i_sb,
-						 block, bsize);
-	int bytes = buffer->length, res = buffer->error, n, offset = 0;
-	void *pageaddr;
-
-	if (res) {
-		ERROR("Unable to read page, block %llx, size %x\n", block,
-			bsize);
-		goto out;
-	}
-
-	for (n = 0; n < pages && bytes > 0; n++,
-			bytes -= PAGE_SIZE, offset += PAGE_SIZE) {
-		int avail = min_t(int, bytes, PAGE_SIZE);
-
-		if (page[n] == NULL)
-			continue;
+	struct squashfs_page_actor *actor;
+	struct inode *inode = mapping->host;
+	struct squashfs_sb_info *msblk = inode->i_sb->s_fs_info;
+	int start_index, end_index, file_end, actor_pages, res;
+	int mask = (1 << (msblk->block_log - PAGE_SHIFT)) - 1;
 
-		pageaddr = kmap_atomic(page[n]);
-		squashfs_copy_data(pageaddr, buffer, offset, avail);
-		memset(pageaddr + avail, 0, PAGE_SIZE - avail);
-		kunmap_atomic(pageaddr);
-		flush_dcache_page(page[n]);
-		SetPageUptodate(page[n]);
-		unlock_page(page[n]);
-		if (page[n] != target_page)
-			put_page(page[n]);
+	/*
+	 * If readpage() is called on an uncompressed datablock, we can just
+	 * read the pages instead of fetching the whole block.
+	 * This greatly improves the performance when a process keep doing
+	 * random reads because we only fetch the necessary data.
+	 * The readahead algorithm will take care of doing speculative reads
+	 * if necessary.
+	 * We can't read more than 1 block even if readahead provides use more
+	 * pages because we don't know yet if the next block is compressed or
+	 * not.
+	 */
+	if (bsize && !SQUASHFS_COMPRESSED_BLOCK(bsize)) {
+		u64 block_end = block + msblk->block_size;
+
+		block += (page_index & mask) * PAGE_SIZE;
+		actor_pages = (block_end - block) / PAGE_SIZE;
+		if (*nr_pages < actor_pages)
+			actor_pages = *nr_pages;
+		start_index = page_index;
+		bsize = min_t(int, bsize, (PAGE_SIZE * actor_pages)
+					  | SQUASHFS_COMPRESSED_BIT_BLOCK);
+	} else {
+		file_end = (i_size_read(inode) - 1) >> PAGE_SHIFT;
+		start_index = page_index & ~mask;
+		end_index = start_index | mask;
+		if (end_index > file_end)
+			end_index = file_end;
+		actor_pages = end_index - start_index + 1;
 	}
 
-out:
-	squashfs_cache_put(buffer);
-	return res;
+	actor = actor_from_page_cache(actor_pages, target_page,
+				      readahead_pages, nr_pages, start_index,
+				      mapping);
+	if (!actor)
+		return -ENOMEM;
+
+	res = squashfs_read_data_async(inode->i_sb, block, bsize, NULL,
+				       actor);
+	return res < 0 ? res : 0;
 }
diff --git a/fs/squashfs/lz4_wrapper.c b/fs/squashfs/lz4_wrapper.c
index ff4468b..df4fa3c 100644
--- a/fs/squashfs/lz4_wrapper.c
+++ b/fs/squashfs/lz4_wrapper.c
@@ -94,39 +94,17 @@ static int lz4_uncompress(struct squashfs_sb_info *msblk, void *strm,
 	struct buffer_head **bh, int b, int offset, int length,
 	struct squashfs_page_actor *output)
 {
-	struct squashfs_lz4 *stream = strm;
-	void *buff = stream->input, *data;
-	int avail, i, bytes = length, res;
+	int res;
 	size_t dest_len = output->length;
+	struct squashfs_lz4 *stream = strm;
 
-	for (i = 0; i < b; i++) {
-		avail = min(bytes, msblk->devblksize - offset);
-		memcpy(buff, bh[i]->b_data + offset, avail);
-		buff += avail;
-		bytes -= avail;
-		offset = 0;
-		put_bh(bh[i]);
-	}
-
+	squashfs_bh_to_buf(bh, b, stream->input, offset, length,
+		msblk->devblksize);
 	res = lz4_decompress_unknownoutputsize(stream->input, length,
 					stream->output, &dest_len);
 	if (res)
 		return -EIO;
-
-	bytes = dest_len;
-	data = squashfs_first_page(output);
-	buff = stream->output;
-	while (data) {
-		if (bytes <= PAGE_SIZE) {
-			memcpy(data, buff, bytes);
-			break;
-		}
-		memcpy(data, buff, PAGE_SIZE);
-		buff += PAGE_SIZE;
-		bytes -= PAGE_SIZE;
-		data = squashfs_next_page(output);
-	}
-	squashfs_finish_page(output);
+	squashfs_buf_to_actor(stream->output, output, dest_len);
 
 	return dest_len;
 }
diff --git a/fs/squashfs/lzo_wrapper.c b/fs/squashfs/lzo_wrapper.c
index 934c17e..2c844d5 100644
--- a/fs/squashfs/lzo_wrapper.c
+++ b/fs/squashfs/lzo_wrapper.c
@@ -79,45 +79,19 @@ static int lzo_uncompress(struct squashfs_sb_info *msblk, void *strm,
 	struct buffer_head **bh, int b, int offset, int length,
 	struct squashfs_page_actor *output)
 {
-	struct squashfs_lzo *stream = strm;
-	void *buff = stream->input, *data;
-	int avail, i, bytes = length, res;
+	int res;
 	size_t out_len = output->length;
+	struct squashfs_lzo *stream = strm;
 
-	for (i = 0; i < b; i++) {
-		avail = min(bytes, msblk->devblksize - offset);
-		memcpy(buff, bh[i]->b_data + offset, avail);
-		buff += avail;
-		bytes -= avail;
-		offset = 0;
-		put_bh(bh[i]);
-	}
-
+	squashfs_bh_to_buf(bh, b, stream->input, offset, length,
+		msblk->devblksize);
 	res = lzo1x_decompress_safe(stream->input, (size_t)length,
 					stream->output, &out_len);
 	if (res != LZO_E_OK)
-		goto failed;
+		return -EIO;
+	squashfs_buf_to_actor(stream->output, output, out_len);
 
-	res = bytes = (int)out_len;
-	data = squashfs_first_page(output);
-	buff = stream->output;
-	while (data) {
-		if (bytes <= PAGE_SIZE) {
-			memcpy(data, buff, bytes);
-			break;
-		} else {
-			memcpy(data, buff, PAGE_SIZE);
-			buff += PAGE_SIZE;
-			bytes -= PAGE_SIZE;
-			data = squashfs_next_page(output);
-		}
-	}
-	squashfs_finish_page(output);
-
-	return res;
-
-failed:
-	return -EIO;
+	return out_len;
 }
 
 const struct squashfs_decompressor squashfs_lzo_comp_ops = {
diff --git a/fs/squashfs/page_actor.c b/fs/squashfs/page_actor.c
index 9b7b1b6..e348f56 100644
--- a/fs/squashfs/page_actor.c
+++ b/fs/squashfs/page_actor.c
@@ -9,39 +9,11 @@
 #include <linux/kernel.h>
 #include <linux/slab.h>
 #include <linux/pagemap.h>
+#include <linux/buffer_head.h>
 #include "page_actor.h"
 
-/*
- * This file contains implementations of page_actor for decompressing into
- * an intermediate buffer, and for decompressing directly into the
- * page cache.
- *
- * Calling code should avoid sleeping between calls to squashfs_first_page()
- * and squashfs_finish_page().
- */
-
-/* Implementation of page_actor for decompressing into intermediate buffer */
-static void *cache_first_page(struct squashfs_page_actor *actor)
-{
-	actor->next_page = 1;
-	return actor->buffer[0];
-}
-
-static void *cache_next_page(struct squashfs_page_actor *actor)
-{
-	if (actor->next_page == actor->pages)
-		return NULL;
-
-	return actor->buffer[actor->next_page++];
-}
-
-static void cache_finish_page(struct squashfs_page_actor *actor)
-{
-	/* empty */
-}
-
-struct squashfs_page_actor *squashfs_page_actor_init(void **buffer,
-	int pages, int length)
+struct squashfs_page_actor *squashfs_page_actor_init(struct page **page,
+	int pages, int length, void (*release_pages)(struct page **, int, int))
 {
 	struct squashfs_page_actor *actor = kmalloc(sizeof(*actor), GFP_KERNEL);
 
@@ -49,52 +21,133 @@ struct squashfs_page_actor *squashfs_page_actor_init(void **buffer,
 		return NULL;
 
 	actor->length = length ? : pages * PAGE_SIZE;
-	actor->buffer = buffer;
+	actor->page = page;
 	actor->pages = pages;
 	actor->next_page = 0;
-	actor->squashfs_first_page = cache_first_page;
-	actor->squashfs_next_page = cache_next_page;
-	actor->squashfs_finish_page = cache_finish_page;
+	actor->pageaddr = NULL;
+	actor->release_pages = release_pages;
 	return actor;
 }
 
-/* Implementation of page_actor for decompressing directly into page cache. */
-static void *direct_first_page(struct squashfs_page_actor *actor)
+void squashfs_page_actor_free(struct squashfs_page_actor *actor, int error)
+{
+	if (!actor)
+		return;
+
+	if (actor->release_pages)
+		actor->release_pages(actor->page, actor->pages, error);
+	kfree(actor);
+}
+
+void squashfs_actor_to_buf(struct squashfs_page_actor *actor, void *buf,
+	int length)
 {
-	actor->next_page = 1;
-	return actor->pageaddr = kmap_atomic(actor->page[0]);
+	void *pageaddr;
+	int pos = 0, avail, i;
+
+	for (i = 0; i < actor->pages && pos < length; ++i) {
+		avail = min_t(int, length - pos, PAGE_SIZE);
+		if (actor->page[i]) {
+			pageaddr = kmap_atomic(actor->page[i]);
+			memcpy(buf + pos, pageaddr, avail);
+			kunmap_atomic(pageaddr);
+		}
+		pos += avail;
+	}
 }
 
-static void *direct_next_page(struct squashfs_page_actor *actor)
+void squashfs_buf_to_actor(void *buf, struct squashfs_page_actor *actor,
+	int length)
 {
-	if (actor->pageaddr)
-		kunmap_atomic(actor->pageaddr);
+	void *pageaddr;
+	int pos = 0, avail, i;
+
+	for (i = 0; i < actor->pages && pos < length; ++i) {
+		avail = min_t(int, length - pos, PAGE_SIZE);
+		if (actor->page[i]) {
+			pageaddr = kmap_atomic(actor->page[i]);
+			memcpy(pageaddr, buf + pos, avail);
+			kunmap_atomic(pageaddr);
+		}
+		pos += avail;
+	}
+}
 
-	return actor->pageaddr = actor->next_page == actor->pages ? NULL :
-		kmap_atomic(actor->page[actor->next_page++]);
+void squashfs_bh_to_actor(struct buffer_head **bh, int nr_buffers,
+	struct squashfs_page_actor *actor, int offset, int length, int blksz)
+{
+	void *kaddr = NULL;
+	int bytes = 0, pgoff = 0, b = 0, p = 0, avail, i;
+
+	while (bytes < length) {
+		if (actor->page[p]) {
+			kaddr = kmap_atomic(actor->page[p]);
+			while (pgoff < PAGE_SIZE && bytes < length) {
+				avail = min_t(int, blksz - offset,
+						PAGE_SIZE - pgoff);
+				memcpy(kaddr + pgoff, bh[b]->b_data + offset,
+				       avail);
+				pgoff += avail;
+				bytes += avail;
+				offset = (offset + avail) % blksz;
+				if (!offset) {
+					put_bh(bh[b]);
+					++b;
+				}
+			}
+			kunmap_atomic(kaddr);
+			pgoff = 0;
+		} else {
+			for (i = 0; i < PAGE_SIZE / blksz; ++i) {
+				if (bh[b])
+					put_bh(bh[b]);
+				++b;
+			}
+			bytes += PAGE_SIZE;
+		}
+		++p;
+	}
 }
 
-static void direct_finish_page(struct squashfs_page_actor *actor)
+void squashfs_bh_to_buf(struct buffer_head **bh, int nr_buffers, void *buf,
+	int offset, int length, int blksz)
 {
-	if (actor->pageaddr)
-		kunmap_atomic(actor->pageaddr);
+	int i, avail, bytes = 0;
+
+	for (i = 0; i < nr_buffers && bytes < length; ++i) {
+		avail = min_t(int, length - bytes, blksz - offset);
+		if (bh[i]) {
+			memcpy(buf + bytes, bh[i]->b_data + offset, avail);
+			put_bh(bh[i]);
+		}
+		bytes += avail;
+		offset = 0;
+	}
 }
 
-struct squashfs_page_actor *squashfs_page_actor_init_special(struct page **page,
-	int pages, int length)
+void free_page_array(struct page **page, int nr_pages)
 {
-	struct squashfs_page_actor *actor = kmalloc(sizeof(*actor), GFP_KERNEL);
+	int i;
 
-	if (actor == NULL)
-		return NULL;
+	for (i = 0; i < nr_pages; ++i)
+		__free_page(page[i]);
+	kfree(page);
+}
 
-	actor->length = length ? : pages * PAGE_SIZE;
-	actor->page = page;
-	actor->pages = pages;
-	actor->next_page = 0;
-	actor->pageaddr = NULL;
-	actor->squashfs_first_page = direct_first_page;
-	actor->squashfs_next_page = direct_next_page;
-	actor->squashfs_finish_page = direct_finish_page;
-	return actor;
+struct page **alloc_page_array(int nr_pages, int gfp_mask)
+{
+	int i;
+	struct page **page;
+
+	page = kcalloc(nr_pages, sizeof(struct page *), gfp_mask);
+	if (!page)
+		return NULL;
+	for (i = 0; i < nr_pages; ++i) {
+		page[i] = alloc_page(gfp_mask);
+		if (!page[i]) {
+			free_page_array(page, i);
+			return NULL;
+		}
+	}
+	return page;
 }
diff --git a/fs/squashfs/page_actor.h b/fs/squashfs/page_actor.h
index 98537ea..aa1ed79 100644
--- a/fs/squashfs/page_actor.h
+++ b/fs/squashfs/page_actor.h
@@ -5,77 +5,61 @@
  * Phillip Lougher <phillip@squashfs.org.uk>
  *
  * This work is licensed under the terms of the GNU GPL, version 2. See
- * the COPYING file in the top-level directory.
+ * the COPYING file in the top-level squashfsory.
  */
 
-#ifndef CONFIG_SQUASHFS_FILE_DIRECT
 struct squashfs_page_actor {
-	void	**page;
+	struct page	**page;
+	void	*pageaddr;
 	int	pages;
 	int	length;
 	int	next_page;
+	void	(*release_pages)(struct page **, int, int);
 };
 
-static inline struct squashfs_page_actor *squashfs_page_actor_init(void **page,
-	int pages, int length)
-{
-	struct squashfs_page_actor *actor = kmalloc(sizeof(*actor), GFP_KERNEL);
-
-	if (actor == NULL)
-		return NULL;
+extern struct squashfs_page_actor *squashfs_page_actor_init(struct page **,
+	int, int, void (*)(struct page **, int, int));
+extern void squashfs_page_actor_free(struct squashfs_page_actor *, int);
 
-	actor->length = length ? : pages * PAGE_SIZE;
-	actor->page = page;
-	actor->pages = pages;
-	actor->next_page = 0;
-	return actor;
-}
+extern void squashfs_actor_to_buf(struct squashfs_page_actor *, void *, int);
+extern void squashfs_buf_to_actor(void *, struct squashfs_page_actor *, int);
+extern void squashfs_bh_to_actor(struct buffer_head **, int,
+	struct squashfs_page_actor *, int, int, int);
+extern void squashfs_bh_to_buf(struct buffer_head **, int, void *, int, int,
+	int);
 
+/*
+ * Calling code should avoid sleeping between calls to squashfs_first_page()
+ * and squashfs_finish_page().
+ */
 static inline void *squashfs_first_page(struct squashfs_page_actor *actor)
 {
 	actor->next_page = 1;
-	return actor->page[0];
+	return actor->pageaddr = actor->page[0] ? kmap_atomic(actor->page[0])
+						: NULL;
 }
 
 static inline void *squashfs_next_page(struct squashfs_page_actor *actor)
 {
-	return actor->next_page == actor->pages ? NULL :
-		actor->page[actor->next_page++];
-}
+	if (!IS_ERR_OR_NULL(actor->pageaddr))
+		kunmap_atomic(actor->pageaddr);
 
-static inline void squashfs_finish_page(struct squashfs_page_actor *actor)
-{
-	/* empty */
-}
-#else
-struct squashfs_page_actor {
-	union {
-		void		**buffer;
-		struct page	**page;
-	};
-	void	*pageaddr;
-	void    *(*squashfs_first_page)(struct squashfs_page_actor *);
-	void    *(*squashfs_next_page)(struct squashfs_page_actor *);
-	void    (*squashfs_finish_page)(struct squashfs_page_actor *);
-	int	pages;
-	int	length;
-	int	next_page;
-};
+	if (actor->next_page == actor->pages)
+		return actor->pageaddr = ERR_PTR(-ENODATA);
 
-extern struct squashfs_page_actor *squashfs_page_actor_init(void **, int, int);
-extern struct squashfs_page_actor *squashfs_page_actor_init_special(struct page
-							 **, int, int);
-static inline void *squashfs_first_page(struct squashfs_page_actor *actor)
-{
-	return actor->squashfs_first_page(actor);
-}
-static inline void *squashfs_next_page(struct squashfs_page_actor *actor)
-{
-	return actor->squashfs_next_page(actor);
+	actor->pageaddr = actor->page[actor->next_page] ?
+	    kmap_atomic(actor->page[actor->next_page]) : NULL;
+	++actor->next_page;
+	return actor->pageaddr;
 }
+
 static inline void squashfs_finish_page(struct squashfs_page_actor *actor)
 {
-	actor->squashfs_finish_page(actor);
+	if (!IS_ERR_OR_NULL(actor->pageaddr))
+		kunmap_atomic(actor->pageaddr);
 }
-#endif
+
+extern struct page **alloc_page_array(int, int);
+extern void free_page_array(struct page **, int);
+
 #endif
diff --git a/fs/squashfs/squashfs.h b/fs/squashfs/squashfs.h
index 887d6d2..f4faab5 100644
--- a/fs/squashfs/squashfs.h
+++ b/fs/squashfs/squashfs.h
@@ -28,8 +28,12 @@
 #define WARNING(s, args...)	pr_warn("SQUASHFS: "s, ## args)
 
 /* block.c */
+extern int squashfs_init_read_wq(void);
+extern void squashfs_destroy_read_wq(void);
 extern int squashfs_read_data(struct super_block *, u64, int, u64 *,
 				struct squashfs_page_actor *);
+extern int squashfs_read_data_async(struct super_block *, u64, int, u64 *,
+				struct squashfs_page_actor *);
 
 /* cache.c */
 extern struct squashfs_cache *squashfs_cache_init(char *, int, int);
@@ -70,8 +74,9 @@ extern __le64 *squashfs_read_fragment_index_table(struct super_block *,
 void squashfs_copy_cache(struct page *, struct squashfs_cache_entry *, int,
 				int);
 
-/* file_xxx.c */
-extern int squashfs_readpage_block(struct page *, u64, int);
+/* file_direct.c */
+extern int squashfs_readpages_block(struct page *, struct list_head *,
+	unsigned int *, struct address_space *, int, u64, int);
 
 /* id.c */
 extern int squashfs_get_id(struct super_block *, unsigned int, unsigned int *);
diff --git a/fs/squashfs/squashfs_fs_sb.h b/fs/squashfs/squashfs_fs_sb.h
index ef69c31..3b767ce 100644
--- a/fs/squashfs/squashfs_fs_sb.h
+++ b/fs/squashfs/squashfs_fs_sb.h
@@ -49,7 +49,7 @@ struct squashfs_cache_entry {
 	int			num_waiters;
 	wait_queue_head_t	wait_queue;
 	struct squashfs_cache	*cache;
-	void			**data;
+	struct page		**page;
 	struct squashfs_page_actor	*actor;
 };
 
diff --git a/fs/squashfs/super.c b/fs/squashfs/super.c
index 1516bb7..445ce58 100644
--- a/fs/squashfs/super.c
+++ b/fs/squashfs/super.c
@@ -445,9 +445,15 @@ static int __init init_squashfs_fs(void)
 	if (err)
 		return err;
 
+	if (!squashfs_init_read_wq()) {
+		destroy_inodecache();
+		return -ENOMEM;
+	}
+
 	err = register_filesystem(&squashfs_fs_type);
 	if (err) {
 		destroy_inodecache();
+		squashfs_destroy_read_wq();
 		return err;
 	}
 
@@ -461,6 +467,7 @@ static void __exit exit_squashfs_fs(void)
 {
 	unregister_filesystem(&squashfs_fs_type);
 	destroy_inodecache();
+	squashfs_destroy_read_wq();
 }
 
 
diff --git a/fs/squashfs/xz_wrapper.c b/fs/squashfs/xz_wrapper.c
index 6bfaef7..2f7be1f 100644
--- a/fs/squashfs/xz_wrapper.c
+++ b/fs/squashfs/xz_wrapper.c
@@ -55,7 +55,7 @@ static void *squashfs_xz_comp_opts(struct squashfs_sb_info *msblk,
 	struct comp_opts *opts;
 	int err = 0, n;
 
-	opts = kmalloc(sizeof(*opts), GFP_KERNEL);
+	opts = kmalloc(sizeof(*opts), GFP_ATOMIC);
 	if (opts == NULL) {
 		err = -ENOMEM;
 		goto out2;
@@ -136,6 +136,7 @@ static int squashfs_xz_uncompress(struct squashfs_sb_info *msblk, void *strm,
 	enum xz_ret xz_err;
 	int avail, total = 0, k = 0;
 	struct squashfs_xz *stream = strm;
+	void *buf = NULL;
 
 	xz_dec_reset(stream->state);
 	stream->buf.in_pos = 0;
@@ -156,12 +157,20 @@ static int squashfs_xz_uncompress(struct squashfs_sb_info *msblk, void *strm,
 
 		if (stream->buf.out_pos == stream->buf.out_size) {
 			stream->buf.out = squashfs_next_page(output);
-			if (stream->buf.out != NULL) {
+			if (!IS_ERR(stream->buf.out)) {
 				stream->buf.out_pos = 0;
 				total += PAGE_SIZE;
 			}
 		}
 
+		if (!stream->buf.out) {
+			if (!buf) {
+				buf = kmalloc(PAGE_SIZE, GFP_ATOMIC);
+				if (!buf)
+					goto out;
+			}
+			stream->buf.out = buf;
+		}
 		xz_err = xz_dec_run(stream->state, &stream->buf);
 
 		if (stream->buf.in_pos == stream->buf.in_size && k < b)
@@ -173,11 +182,13 @@ static int squashfs_xz_uncompress(struct squashfs_sb_info *msblk, void *strm,
 	if (xz_err != XZ_STREAM_END || k < b)
 		goto out;
 
+	kfree(buf);
 	return total + stream->buf.out_pos;
 
 out:
 	for (; k < b; k++)
 		put_bh(bh[k]);
+	kfree(buf);
 
 	return -EIO;
 }
diff --git a/fs/squashfs/zlib_wrapper.c b/fs/squashfs/zlib_wrapper.c
index 2ec24d1..d917c72 100644
--- a/fs/squashfs/zlib_wrapper.c
+++ b/fs/squashfs/zlib_wrapper.c
@@ -66,6 +66,7 @@ static int zlib_uncompress(struct squashfs_sb_info *msblk, void *strm,
 	struct buffer_head **bh, int b, int offset, int length,
 	struct squashfs_page_actor *output)
 {
+	void *buf = NULL;
 	int zlib_err, zlib_init = 0, k = 0;
 	z_stream *stream = strm;
 
@@ -84,10 +85,19 @@ static int zlib_uncompress(struct squashfs_sb_info *msblk, void *strm,
 
 		if (stream->avail_out == 0) {
 			stream->next_out = squashfs_next_page(output);
-			if (stream->next_out != NULL)
+			if (!IS_ERR(stream->next_out))
 				stream->avail_out = PAGE_SIZE;
 		}
 
+		if (!stream->next_out) {
+			if (!buf) {
+				buf = kmalloc(PAGE_SIZE, GFP_ATOMIC);
+				if (!buf)
+					goto out;
+			}
+			stream->next_out = buf;
+		}
+
 		if (!zlib_init) {
 			zlib_err = zlib_inflateInit(stream);
 			if (zlib_err != Z_OK) {
@@ -115,11 +125,13 @@ static int zlib_uncompress(struct squashfs_sb_info *msblk, void *strm,
 	if (k < b)
 		goto out;
 
+	kfree(buf);
 	return stream->total_out;
 
 out:
 	for (; k < b; k++)
 		put_bh(bh[k]);
+	kfree(buf);
 
 	return -EIO;
 }
diff --git a/fs/super.c b/fs/super.c
index 7e9beab..d80a1d2 100644
--- a/fs/super.c
+++ b/fs/super.c
@@ -761,7 +761,8 @@ struct super_block *user_get_super(dev_t dev)
 }
 
 /**
- *	do_remount_sb - asks filesystem to change mount options.
+ *	do_remount_sb2 - asks filesystem to change mount options.
+ *	@mnt:   mount we are looking at
  *	@sb:	superblock in question
  *	@flags:	numeric part of options
  *	@data:	the rest of options
@@ -769,7 +770,7 @@ struct super_block *user_get_super(dev_t dev)
  *
  *	Alters the mount options of a mounted file system.
  */
-int do_remount_sb(struct super_block *sb, int flags, void *data, int force)
+int do_remount_sb2(struct vfsmount *mnt, struct super_block *sb, int flags, void *data, int force)
 {
 	int retval;
 	int remount_ro;
@@ -811,7 +812,16 @@ int do_remount_sb(struct super_block *sb, int flags, void *data, int force)
 		}
 	}
 
-	if (sb->s_op->remount_fs) {
+	if (mnt && sb->s_op->remount_fs2) {
+		retval = sb->s_op->remount_fs2(mnt, sb, &flags, data);
+		if (retval) {
+			if (!force)
+				goto cancel_readonly;
+			/* If forced remount, go ahead despite any errors */
+			WARN(1, "forced remount of a %s fs returned %i\n",
+			     sb->s_type->name, retval);
+		}
+	} else if (sb->s_op->remount_fs) {
 		retval = sb->s_op->remount_fs(sb, &flags, data);
 		if (retval) {
 			if (!force)
@@ -843,12 +853,17 @@ int do_remount_sb(struct super_block *sb, int flags, void *data, int force)
 	return retval;
 }
 
+int do_remount_sb(struct super_block *sb, int flags, void *data, int force)
+{
+	return do_remount_sb2(NULL, sb, flags, data, force);
+}
+
 static void do_emergency_remount(struct work_struct *work)
 {
 	struct super_block *sb, *p = NULL;
 
 	spin_lock(&sb_lock);
-	list_for_each_entry(sb, &super_blocks, s_list) {
+	list_for_each_entry_reverse(sb, &super_blocks, s_list) {
 		if (hlist_unhashed(&sb->s_instances))
 			continue;
 		sb->s_count++;
@@ -1168,7 +1183,7 @@ struct dentry *mount_single(struct file_system_type *fs_type,
 EXPORT_SYMBOL(mount_single);
 
 struct dentry *
-mount_fs(struct file_system_type *type, int flags, const char *name, void *data)
+mount_fs(struct file_system_type *type, int flags, const char *name, struct vfsmount *mnt, void *data)
 {
 	struct dentry *root;
 	struct super_block *sb;
@@ -1185,7 +1200,10 @@ struct dentry *
 			goto out_free_secdata;
 	}
 
-	root = type->mount(type, flags, name, data);
+	if (type->mount2)
+		root = type->mount2(mnt, type, flags, name, data);
+	else
+		root = type->mount(type, flags, name, data);
 	if (IS_ERR(root)) {
 		error = PTR_ERR(root);
 		goto out_free_secdata;
diff --git a/fs/sync.c b/fs/sync.c
index 2a54c1f..5c2420c 100644
--- a/fs/sync.c
+++ b/fs/sync.c
@@ -218,6 +218,7 @@ static int do_fsync(unsigned int fd, int datasync)
 	if (f.file) {
 		ret = vfs_fsync(f.file, datasync);
 		fdput(f);
+		inc_syscfs(current);
 	}
 	return ret;
 }
diff --git a/fs/timerfd.c b/fs/timerfd.c
index ab8dd15..ffa0247 100644
--- a/fs/timerfd.c
+++ b/fs/timerfd.c
@@ -400,10 +400,13 @@ static int timerfd_fget(int fd, struct fd *p)
 	     clockid != CLOCK_BOOTTIME_ALARM))
 		return -EINVAL;
 
+#ifdef CONFIG_RTK_PLATFORM
+#else
 	if (!capable(CAP_WAKE_ALARM) &&
 	    (clockid == CLOCK_REALTIME_ALARM ||
 	     clockid == CLOCK_BOOTTIME_ALARM))
 		return -EPERM;
+#endif /* CONFIG_RTK_PLATFORM */
 
 	ctx = kzalloc(sizeof(*ctx), GFP_KERNEL);
 	if (!ctx)
@@ -449,10 +452,13 @@ static int do_timerfd_settime(int ufd, int flags,
 		return ret;
 	ctx = f.file->private_data;
 
+#ifdef CONFIG_RTK_PLATFORM
+#else
 	if (!capable(CAP_WAKE_ALARM) && isalarm(ctx)) {
 		fdput(f);
 		return -EPERM;
 	}
+#endif /* CONFIG_RTK_PLATFORM */
 
 	timerfd_setup_cancel(ctx, flags);
 
diff --git a/fs/userfaultfd.c b/fs/userfaultfd.c
index 784d667..9d9c032 100644
--- a/fs/userfaultfd.c
+++ b/fs/userfaultfd.c
@@ -493,7 +493,8 @@ static int userfaultfd_release(struct inode *inode, struct file *file)
 				 new_flags, vma->anon_vma,
 				 vma->vm_file, vma->vm_pgoff,
 				 vma_policy(vma),
-				 NULL_VM_UFFD_CTX);
+				 NULL_VM_UFFD_CTX,
+				 vma_get_anon_name(vma));
 		if (prev)
 			vma = prev;
 		else
@@ -872,7 +873,8 @@ static int userfaultfd_register(struct userfaultfd_ctx *ctx,
 		prev = vma_merge(mm, prev, start, vma_end, new_flags,
 				 vma->anon_vma, vma->vm_file, vma->vm_pgoff,
 				 vma_policy(vma),
-				 ((struct vm_userfaultfd_ctx){ ctx }));
+				 ((struct vm_userfaultfd_ctx){ ctx }),
+				 vma_get_anon_name(vma));
 		if (prev) {
 			vma = prev;
 			goto next;
@@ -1009,7 +1011,8 @@ static int userfaultfd_unregister(struct userfaultfd_ctx *ctx,
 		prev = vma_merge(mm, prev, start, vma_end, new_flags,
 				 vma->anon_vma, vma->vm_file, vma->vm_pgoff,
 				 vma_policy(vma),
-				 NULL_VM_UFFD_CTX);
+				 NULL_VM_UFFD_CTX,
+				 vma_get_anon_name(vma));
 		if (prev) {
 			vma = prev;
 			goto next;
diff --git a/fs/utimes.c b/fs/utimes.c
index 22307cd..87ce37b 100644
--- a/fs/utimes.c
+++ b/fs/utimes.c
@@ -91,7 +91,7 @@ static int utimes_common(struct path *path, struct timespec *times)
 	}
 retry_deleg:
 	inode_lock(inode);
-	error = notify_change(path->dentry, &newattrs, &delegated_inode);
+	error = notify_change2(path->mnt, path->dentry, &newattrs, &delegated_inode);
 	inode_unlock(inode);
 	if (delegated_inode) {
 		error = break_deleg_wait(&delegated_inode);
diff --git a/fs/xattr.c b/fs/xattr.c
index 932b906..1b00bab 100644
--- a/fs/xattr.c
+++ b/fs/xattr.c
@@ -130,7 +130,7 @@
 			return -EPERM;
 	}
 
-	return inode_permission(inode, mask);
+	return inode_permission2(ERR_PTR(-EOPNOTSUPP), inode, mask);
 }
 
 int
diff --git a/fs/yaffs2/Kconfig b/fs/yaffs2/Kconfig
new file mode 100644
index 00000000..408570f
--- /dev/null
+++ b/fs/yaffs2/Kconfig
@@ -0,0 +1,171 @@
+#
+# yaffs file system configurations
+#
+
+config YAFFS_FS
+	tristate "yaffs2 file system support"
+	default n
+	depends on MTD_BLOCK
+	select YAFFS_YAFFS1
+	select YAFFS_YAFFS2
+	help
+	  yaffs2, or Yet Another Flash File System, is a file system
+	  optimised for NAND Flash chips.
+
+	  To compile the yaffs2 file system support as a module, choose M
+	  here: the module will be called yaffs2.
+
+	  If unsure, say N.
+
+	  Further information on yaffs2 is available at
+	  <http://www.aleph1.co.uk/yaffs/>.
+
+config YAFFS_YAFFS1
+	bool "512 byte / page devices"
+	depends on YAFFS_FS
+	default y
+	help
+	  Enable yaffs1 support -- yaffs for 512 byte / page devices
+
+	  Not needed for 2K-page devices.
+
+	  If unsure, say Y.
+
+config YAFFS_9BYTE_TAGS
+	bool "Use older-style on-NAND data format with pageStatus byte"
+	depends on YAFFS_YAFFS1
+	default n
+	help
+
+	  Older-style on-NAND data format has a "pageStatus" byte to record
+	  chunk/page state.  This byte is zero when the page is discarded.
+	  Choose this option if you have existing on-NAND data using this
+	  format that you need to continue to support.  New data written
+	  also uses the older-style format.  Note: Use of this option
+	  generally requires that MTD's oob layout be adjusted to use the
+	  older-style format.  See notes on tags formats and MTD versions
+	  in yaffs_mtdif1.c.
+
+	  If unsure, say N.
+
+config YAFFS_DOES_ECC
+	bool "Lets yaffs do its own ECC"
+	depends on YAFFS_FS && YAFFS_YAFFS1 && !YAFFS_9BYTE_TAGS
+	default n
+	help
+	  This enables yaffs to use its own ECC functions instead of using
+	  the ones from the generic MTD-NAND driver.
+
+	  If unsure, say N.
+
+config YAFFS_ECC_WRONG_ORDER
+	bool "Use the same ecc byte order as Steven Hill's nand_ecc.c"
+	depends on YAFFS_FS && YAFFS_DOES_ECC && !YAFFS_9BYTE_TAGS
+	default n
+	help
+	  This makes yaffs_ecc.c use the same ecc byte order as Steven
+	  Hill's nand_ecc.c. If not set, then you get the same ecc byte
+	  order as SmartMedia.
+
+	  If unsure, say N.
+
+config YAFFS_YAFFS2
+	bool "2048 byte (or larger) / page devices"
+	depends on YAFFS_FS
+	default y
+	help
+	  Enable yaffs2 support -- yaffs for >= 2K bytes per page devices
+
+	  If unsure, say Y.
+
+config YAFFS_AUTO_YAFFS2
+	bool "Autoselect yaffs2 format"
+	depends on YAFFS_YAFFS2
+	default y
+	help
+	  Without this, you need to explicitely use yaffs2 as the file
+	  system type. With this, you can say "yaffs" and yaffs or yaffs2
+	  will be used depending on the device page size (yaffs on
+	  512-byte page devices, yaffs2 on 2K page devices).
+
+	  If unsure, say Y.
+
+config YAFFS_DISABLE_TAGS_ECC
+	bool "Disable yaffs from doing ECC on tags by default"
+	depends on YAFFS_FS && YAFFS_YAFFS2
+	default n
+	help
+	  This defaults yaffs to using its own ECC calculations on tags instead of
+	  just relying on the MTD.
+	  This behavior can also be overridden with tags_ecc_on and
+	  tags_ecc_off mount options.
+
+	  If unsure, say N.
+
+config YAFFS_ALWAYS_CHECK_CHUNK_ERASED
+	bool "Force chunk erase check"
+	depends on YAFFS_FS
+	default n
+	help
+          Normally yaffs only checks chunks before writing until an erased
+	  chunk is found. This helps to detect any partially written
+	  chunks that might have happened due to power loss.
+
+	  Enabling this forces on the test that chunks are erased in flash
+	  before writing to them. This takes more time but is potentially
+	  a bit more secure.
+
+	  Suggest setting Y during development and ironing out driver
+	  issues etc. Suggest setting to N if you want faster writing.
+
+	  If unsure, say Y.
+
+config YAFFS_EMPTY_LOST_AND_FOUND
+	bool "Empty lost and found on boot"
+	depends on YAFFS_FS
+	default n
+	help
+	  If this is enabled then the contents of lost and found is
+	  automatically dumped at mount.
+
+	  If unsure, say N.
+
+config YAFFS_DISABLE_BLOCK_REFRESHING
+	bool "Disable yaffs2 block refreshing"
+	depends on YAFFS_FS
+	default n
+	help
+	 If this is set, then block refreshing is disabled.
+	 Block refreshing infrequently refreshes the oldest block in
+	 a yaffs2 file system. This mechanism helps to refresh flash to
+	 mitigate against data loss. This is particularly useful for MLC.
+
+	  If unsure, say N.
+
+config YAFFS_DISABLE_BACKGROUND
+	bool "Disable yaffs2 background processing"
+	depends on YAFFS_FS
+	default n
+	help
+	 If this is set, then background processing is disabled.
+	 Background processing makes many foreground activities faster.
+
+	 If unsure, say N.
+
+config YAFFS_DISABLE_BAD_BLOCK_MARKING
+	bool "Disable yaffs2 bad block marking"
+	depends on YAFFS_FS
+	default n
+	help
+	 Useful during early flash bring up to prevent problems causing
+	 lots of bad block marking.
+
+	 If unsure, say N.
+
+config YAFFS_XATTR
+	bool "Enable yaffs2 xattr support"
+	depends on YAFFS_FS
+	default y
+	help
+	 If this is set then yaffs2 will provide xattr support.
+	 If unsure, say Y.
diff --git a/fs/yaffs2/Makefile b/fs/yaffs2/Makefile
new file mode 100644
index 00000000..c052395
--- /dev/null
+++ b/fs/yaffs2/Makefile
@@ -0,0 +1,19 @@
+#
+# Makefile for the linux YAFFS filesystem routines.
+#
+
+obj-$(CONFIG_YAFFS_FS) += yaffs.o
+
+yaffs-y := yaffs_ecc.o yaffs_vfs.o yaffs_guts.o yaffs_checkptrw.o
+yaffs-y += yaffs_packedtags1.o yaffs_packedtags2.o yaffs_nand.o
+yaffs-y += yaffs_tagscompat.o yaffs_tagsmarshall.o
+yaffs-y += yaffs_endian.o
+yaffs-y += yaffs_mtdif.o
+yaffs-y += yaffs_nameval.o yaffs_attribs.o
+yaffs-y += yaffs_allocator.o
+yaffs-y += yaffs_yaffs1.o
+yaffs-y += yaffs_yaffs2.o
+yaffs-y += yaffs_bitmap.o
+yaffs-y += yaffs_summary.o
+yaffs-y += yaffs_verify.o
+
diff --git a/fs/yaffs2/yaffs_allocator.c b/fs/yaffs2/yaffs_allocator.c
new file mode 100644
index 00000000..be27833
--- /dev/null
+++ b/fs/yaffs2/yaffs_allocator.c
@@ -0,0 +1,356 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yaffs_allocator.h"
+#include "yaffs_guts.h"
+#include "yaffs_trace.h"
+#include "yportenv.h"
+
+/*
+ * Each entry in yaffs_tnode_list and yaffs_obj_list hold blocks
+ * of approx 100 objects that are themn allocated singly.
+ * This is basically a simplified slab allocator.
+ *
+ * We don't use the Linux slab allocator because slab does not allow
+ * us to dump all the objects in one hit when we do a umount and tear
+ * down  all the tnodes and objects. slab requires that we first free
+ * the individual objects.
+ *
+ * Once yaffs has been mainlined I shall try to motivate for a change
+ * to slab to provide the extra features we need here.
+ */
+
+struct yaffs_tnode_list {
+	struct yaffs_tnode_list *next;
+	struct yaffs_tnode *tnodes;
+};
+
+struct yaffs_obj_list {
+	struct yaffs_obj_list *next;
+	struct yaffs_obj *objects;
+};
+
+struct yaffs_allocator {
+	int n_tnodes_created;
+	struct yaffs_tnode *free_tnodes;
+	int n_free_tnodes;
+	struct yaffs_tnode_list *alloc_tnode_list;
+
+	int n_obj_created;
+	struct list_head free_objs;
+	int n_free_objects;
+
+	struct yaffs_obj_list *allocated_obj_list;
+};
+
+static void yaffs_deinit_raw_tnodes(struct yaffs_dev *dev)
+{
+	struct yaffs_allocator *allocator =
+	    (struct yaffs_allocator *)dev->allocator;
+	struct yaffs_tnode_list *tmp;
+
+	if (!allocator) {
+		BUG();
+		return;
+	}
+
+	while (allocator->alloc_tnode_list) {
+		tmp = allocator->alloc_tnode_list->next;
+
+		kfree(allocator->alloc_tnode_list->tnodes);
+		kfree(allocator->alloc_tnode_list);
+		allocator->alloc_tnode_list = tmp;
+	}
+
+	allocator->free_tnodes = NULL;
+	allocator->n_free_tnodes = 0;
+	allocator->n_tnodes_created = 0;
+}
+
+static void yaffs_init_raw_tnodes(struct yaffs_dev *dev)
+{
+	struct yaffs_allocator *allocator = dev->allocator;
+
+	if (!allocator) {
+		BUG();
+		return;
+	}
+
+	allocator->alloc_tnode_list = NULL;
+	allocator->free_tnodes = NULL;
+	allocator->n_free_tnodes = 0;
+	allocator->n_tnodes_created = 0;
+}
+
+static int yaffs_create_tnodes(struct yaffs_dev *dev, int n_tnodes)
+{
+	struct yaffs_allocator *allocator =
+	    (struct yaffs_allocator *)dev->allocator;
+	int i;
+	struct yaffs_tnode *new_tnodes;
+	u8 *mem;
+	struct yaffs_tnode *curr;
+	struct yaffs_tnode *next;
+	struct yaffs_tnode_list *tnl;
+
+	if (!allocator) {
+		BUG();
+		return YAFFS_FAIL;
+	}
+
+	if (n_tnodes < 1)
+		return YAFFS_OK;
+
+	/* make these things */
+	new_tnodes = kmalloc(n_tnodes * dev->tnode_size, GFP_NOFS);
+	mem = (u8 *) new_tnodes;
+
+	if (!new_tnodes) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"yaffs: Could not allocate Tnodes");
+		return YAFFS_FAIL;
+	}
+
+	/* New hookup for wide tnodes */
+	for (i = 0; i < n_tnodes - 1; i++) {
+		curr = (struct yaffs_tnode *)&mem[i * dev->tnode_size];
+		next = (struct yaffs_tnode *)&mem[(i + 1) * dev->tnode_size];
+		curr->internal[0] = next;
+	}
+
+	curr = (struct yaffs_tnode *)&mem[(n_tnodes - 1) * dev->tnode_size];
+	curr->internal[0] = allocator->free_tnodes;
+	allocator->free_tnodes = (struct yaffs_tnode *)mem;
+
+	allocator->n_free_tnodes += n_tnodes;
+	allocator->n_tnodes_created += n_tnodes;
+
+	/* Now add this bunch of tnodes to a list for freeing up.
+	 * NB If we can't add this to the management list it isn't fatal
+	 * but it just means we can't free this bunch of tnodes later.
+	 */
+	tnl = kmalloc(sizeof(struct yaffs_tnode_list), GFP_NOFS);
+	if (!tnl) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"Could not add tnodes to management list");
+		return YAFFS_FAIL;
+	} else {
+		tnl->tnodes = new_tnodes;
+		tnl->next = allocator->alloc_tnode_list;
+		allocator->alloc_tnode_list = tnl;
+	}
+
+	yaffs_trace(YAFFS_TRACE_ALLOCATE, "Tnodes added");
+
+	return YAFFS_OK;
+}
+
+struct yaffs_tnode *yaffs_alloc_raw_tnode(struct yaffs_dev *dev)
+{
+	struct yaffs_allocator *allocator =
+	    (struct yaffs_allocator *)dev->allocator;
+	struct yaffs_tnode *tn = NULL;
+
+	if (!allocator) {
+		BUG();
+		return NULL;
+	}
+
+	/* If there are none left make more */
+	if (!allocator->free_tnodes)
+		yaffs_create_tnodes(dev, YAFFS_ALLOCATION_NTNODES);
+
+	if (allocator->free_tnodes) {
+		tn = allocator->free_tnodes;
+		allocator->free_tnodes = allocator->free_tnodes->internal[0];
+		allocator->n_free_tnodes--;
+	}
+
+	return tn;
+}
+
+/* FreeTnode frees up a tnode and puts it back on the free list */
+void yaffs_free_raw_tnode(struct yaffs_dev *dev, struct yaffs_tnode *tn)
+{
+	struct yaffs_allocator *allocator = dev->allocator;
+
+	if (!allocator) {
+		BUG();
+		return;
+	}
+
+	if (tn) {
+		tn->internal[0] = allocator->free_tnodes;
+		allocator->free_tnodes = tn;
+		allocator->n_free_tnodes++;
+	}
+	dev->checkpoint_blocks_required = 0;	/* force recalculation */
+}
+
+/*--------------- yaffs_obj alloaction ------------------------
+ *
+ * Free yaffs_objs are stored in a list using obj->siblings.
+ * The blocks of allocated objects are stored in a linked list.
+ */
+
+static void yaffs_init_raw_objs(struct yaffs_dev *dev)
+{
+	struct yaffs_allocator *allocator = dev->allocator;
+
+	if (!allocator) {
+		BUG();
+		return;
+	}
+
+	allocator->allocated_obj_list = NULL;
+	INIT_LIST_HEAD(&allocator->free_objs);
+	allocator->n_free_objects = 0;
+}
+
+static void yaffs_deinit_raw_objs(struct yaffs_dev *dev)
+{
+	struct yaffs_allocator *allocator = dev->allocator;
+	struct yaffs_obj_list *tmp;
+
+	if (!allocator) {
+		BUG();
+		return;
+	}
+
+	while (allocator->allocated_obj_list) {
+		tmp = allocator->allocated_obj_list->next;
+		kfree(allocator->allocated_obj_list->objects);
+		kfree(allocator->allocated_obj_list);
+		allocator->allocated_obj_list = tmp;
+	}
+
+	INIT_LIST_HEAD(&allocator->free_objs);
+	allocator->n_free_objects = 0;
+	allocator->n_obj_created = 0;
+}
+
+static int yaffs_create_free_objs(struct yaffs_dev *dev, int n_obj)
+{
+	struct yaffs_allocator *allocator = dev->allocator;
+	int i;
+	struct yaffs_obj *new_objs;
+	struct yaffs_obj_list *list;
+
+	if (!allocator) {
+		BUG();
+		return YAFFS_FAIL;
+	}
+
+	if (n_obj < 1)
+		return YAFFS_OK;
+
+	/* make these things */
+	new_objs = kmalloc(n_obj * sizeof(struct yaffs_obj), GFP_NOFS);
+	list = kmalloc(sizeof(struct yaffs_obj_list), GFP_NOFS);
+
+	if (!new_objs || !list) {
+		kfree(new_objs);
+		new_objs = NULL;
+		kfree(list);
+		list = NULL;
+		yaffs_trace(YAFFS_TRACE_ALLOCATE,
+			"Could not allocate more objects");
+		return YAFFS_FAIL;
+	}
+
+	/* Hook them into the free list */
+	for (i = 0; i < n_obj; i++)
+		list_add(&new_objs[i].siblings, &allocator->free_objs);
+
+	allocator->n_free_objects += n_obj;
+	allocator->n_obj_created += n_obj;
+
+	/* Now add this bunch of Objects to a list for freeing up. */
+
+	list->objects = new_objs;
+	list->next = allocator->allocated_obj_list;
+	allocator->allocated_obj_list = list;
+
+	return YAFFS_OK;
+}
+
+struct yaffs_obj *yaffs_alloc_raw_obj(struct yaffs_dev *dev)
+{
+	struct yaffs_obj *obj = NULL;
+	struct list_head *lh;
+	struct yaffs_allocator *allocator = dev->allocator;
+
+	if (!allocator) {
+		BUG();
+		return obj;
+	}
+
+	/* If there are none left make more */
+	if (list_empty(&allocator->free_objs))
+		yaffs_create_free_objs(dev, YAFFS_ALLOCATION_NOBJECTS);
+
+	if (!list_empty(&allocator->free_objs)) {
+		lh = allocator->free_objs.next;
+		obj = list_entry(lh, struct yaffs_obj, siblings);
+		list_del_init(lh);
+		allocator->n_free_objects--;
+	}
+
+	return obj;
+}
+
+void yaffs_free_raw_obj(struct yaffs_dev *dev, struct yaffs_obj *obj)
+{
+
+	struct yaffs_allocator *allocator = dev->allocator;
+
+	if (!allocator) {
+		BUG();
+		return;
+	}
+
+	/* Link into the free list. */
+	list_add(&obj->siblings, &allocator->free_objs);
+	allocator->n_free_objects++;
+}
+
+void yaffs_deinit_raw_tnodes_and_objs(struct yaffs_dev *dev)
+{
+
+	if (!dev->allocator) {
+		BUG();
+		return;
+	}
+
+	yaffs_deinit_raw_tnodes(dev);
+	yaffs_deinit_raw_objs(dev);
+	kfree(dev->allocator);
+	dev->allocator = NULL;
+}
+
+void yaffs_init_raw_tnodes_and_objs(struct yaffs_dev *dev)
+{
+	struct yaffs_allocator *allocator;
+
+	if (dev->allocator) {
+		BUG();
+		return;
+	}
+
+	allocator = kmalloc(sizeof(struct yaffs_allocator), GFP_NOFS);
+	if (allocator) {
+		dev->allocator = allocator;
+		yaffs_init_raw_tnodes(dev);
+		yaffs_init_raw_objs(dev);
+	}
+}
+
diff --git a/fs/yaffs2/yaffs_allocator.h b/fs/yaffs2/yaffs_allocator.h
new file mode 100644
index 00000000..0dacd9f
--- /dev/null
+++ b/fs/yaffs2/yaffs_allocator.h
@@ -0,0 +1,29 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_ALLOCATOR_H__
+#define __YAFFS_ALLOCATOR_H__
+
+#include "yaffs_guts.h"
+
+void yaffs_init_raw_tnodes_and_objs(struct yaffs_dev *dev);
+void yaffs_deinit_raw_tnodes_and_objs(struct yaffs_dev *dev);
+
+struct yaffs_tnode *yaffs_alloc_raw_tnode(struct yaffs_dev *dev);
+void yaffs_free_raw_tnode(struct yaffs_dev *dev, struct yaffs_tnode *tn);
+
+struct yaffs_obj *yaffs_alloc_raw_obj(struct yaffs_dev *dev);
+void yaffs_free_raw_obj(struct yaffs_dev *dev, struct yaffs_obj *obj);
+
+#endif
diff --git a/fs/yaffs2/yaffs_attribs.c b/fs/yaffs2/yaffs_attribs.c
new file mode 100644
index 00000000..a9ced27
--- /dev/null
+++ b/fs/yaffs2/yaffs_attribs.c
@@ -0,0 +1,135 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yaffs_guts.h"
+#include "yaffs_attribs.h"
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(3, 14, 0))
+#define IATTR_UID ia_uid
+#define IATTR_GID ia_gid
+#else
+#define IATTR_UID ia_uid.val
+#define IATTR_GID ia_gid.val
+#endif
+
+/*
+ * Loading attibs from/to object header assumes the object header
+ * is in cpu endian.
+ */
+void yaffs_load_attribs(struct yaffs_obj *obj, struct yaffs_obj_hdr *oh)
+{
+	obj->yst_uid = oh->yst_uid;
+	obj->yst_gid = oh->yst_gid;
+	obj->yst_atime = oh->yst_atime;
+	obj->yst_mtime = oh->yst_mtime;
+	obj->yst_ctime = oh->yst_ctime;
+	obj->yst_rdev = oh->yst_rdev;
+}
+
+void yaffs_load_attribs_oh(struct yaffs_obj_hdr *oh, struct yaffs_obj *obj)
+{
+	oh->yst_uid = obj->yst_uid;
+	oh->yst_gid = obj->yst_gid;
+	oh->yst_atime = obj->yst_atime;
+	oh->yst_mtime = obj->yst_mtime;
+	oh->yst_ctime = obj->yst_ctime;
+	oh->yst_rdev = obj->yst_rdev;
+
+}
+
+void yaffs_load_current_time(struct yaffs_obj *obj, int do_a, int do_c)
+{
+	obj->yst_mtime = Y_CURRENT_TIME;
+	if (do_a)
+		obj->yst_atime = obj->yst_mtime;
+	if (do_c)
+		obj->yst_ctime = obj->yst_mtime;
+}
+
+void yaffs_attribs_init(struct yaffs_obj *obj, u32 gid, u32 uid, u32 rdev)
+{
+	yaffs_load_current_time(obj, 1, 1);
+	obj->yst_rdev = rdev;
+	obj->yst_uid = uid;
+	obj->yst_gid = gid;
+}
+
+static loff_t yaffs_get_file_size(struct yaffs_obj *obj)
+{
+	YCHAR *alias = NULL;
+	obj = yaffs_get_equivalent_obj(obj);
+
+	switch (obj->variant_type) {
+	case YAFFS_OBJECT_TYPE_FILE:
+		return obj->variant.file_variant.file_size;
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+		alias = obj->variant.symlink_variant.alias;
+		if (!alias)
+			return 0;
+		return strnlen(alias, YAFFS_MAX_ALIAS_LENGTH);
+	default:
+		return 0;
+	}
+}
+
+int yaffs_set_attribs(struct yaffs_obj *obj, struct iattr *attr)
+{
+	unsigned int valid = attr->ia_valid;
+
+	if (valid & ATTR_MODE)
+		obj->yst_mode = attr->ia_mode;
+	if (valid & ATTR_UID)
+		obj->yst_uid = attr->IATTR_UID;
+	if (valid & ATTR_GID)
+		obj->yst_gid = attr->IATTR_GID;
+
+	if (valid & ATTR_ATIME)
+		obj->yst_atime = Y_TIME_CONVERT(attr->ia_atime);
+	if (valid & ATTR_CTIME)
+		obj->yst_ctime = Y_TIME_CONVERT(attr->ia_ctime);
+	if (valid & ATTR_MTIME)
+		obj->yst_mtime = Y_TIME_CONVERT(attr->ia_mtime);
+
+	if (valid & ATTR_SIZE)
+		yaffs_resize_file(obj, attr->ia_size);
+
+	yaffs_update_oh(obj, NULL, 1, 0, 0, NULL);
+
+	return YAFFS_OK;
+
+}
+
+int yaffs_get_attribs(struct yaffs_obj *obj, struct iattr *attr)
+{
+	unsigned int valid = 0;
+
+	attr->ia_mode = obj->yst_mode;
+	valid |= ATTR_MODE;
+	attr->IATTR_UID = obj->yst_uid;
+	valid |= ATTR_UID;
+	attr->IATTR_GID = obj->yst_gid;
+	valid |= ATTR_GID;
+
+	Y_TIME_CONVERT(attr->ia_atime) = obj->yst_atime;
+	valid |= ATTR_ATIME;
+	Y_TIME_CONVERT(attr->ia_ctime) = obj->yst_ctime;
+	valid |= ATTR_CTIME;
+	Y_TIME_CONVERT(attr->ia_mtime) = obj->yst_mtime;
+	valid |= ATTR_MTIME;
+
+	attr->ia_size = yaffs_get_file_size(obj);
+	valid |= ATTR_SIZE;
+
+	attr->ia_valid = valid;
+
+	return YAFFS_OK;
+}
diff --git a/fs/yaffs2/yaffs_attribs.h b/fs/yaffs2/yaffs_attribs.h
new file mode 100644
index 00000000..4ce6550
--- /dev/null
+++ b/fs/yaffs2/yaffs_attribs.h
@@ -0,0 +1,27 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_ATTRIBS_H__
+#define __YAFFS_ATTRIBS_H__
+
+#include "yaffs_guts.h"
+
+void yaffs_load_attribs(struct yaffs_obj *obj, struct yaffs_obj_hdr *oh);
+void yaffs_load_attribs_oh(struct yaffs_obj_hdr *oh, struct yaffs_obj *obj);
+void yaffs_attribs_init(struct yaffs_obj *obj, u32 gid, u32 uid, u32 rdev);
+void yaffs_load_current_time(struct yaffs_obj *obj, int do_a, int do_c);
+int yaffs_set_attribs(struct yaffs_obj *obj, struct iattr *attr);
+int yaffs_get_attribs(struct yaffs_obj *obj, struct iattr *attr);
+
+#endif
diff --git a/fs/yaffs2/yaffs_bitmap.c b/fs/yaffs2/yaffs_bitmap.c
new file mode 100644
index 00000000..4815580
--- /dev/null
+++ b/fs/yaffs2/yaffs_bitmap.c
@@ -0,0 +1,98 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yaffs_bitmap.h"
+#include "yaffs_trace.h"
+/*
+ * Chunk bitmap manipulations
+ */
+
+static inline u8 *yaffs_block_bits(struct yaffs_dev *dev, int blk)
+{
+	if (blk < (int)dev->internal_start_block ||
+	    blk > (int)dev->internal_end_block) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"BlockBits block %d is not valid",
+			blk);
+		BUG();
+	}
+	return dev->chunk_bits +
+	    (dev->chunk_bit_stride * (blk - dev->internal_start_block));
+}
+
+void yaffs_verify_chunk_bit_id(struct yaffs_dev *dev, int blk, int chunk)
+{
+	if (blk < (int)dev->internal_start_block ||
+	    blk > (int)dev->internal_end_block ||
+	    chunk < 0 || chunk >= (int)dev->param.chunks_per_block) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"Chunk Id (%d:%d) invalid",
+			blk, chunk);
+		BUG();
+	}
+}
+
+void yaffs_clear_chunk_bits(struct yaffs_dev *dev, int blk)
+{
+	u8 *blk_bits = yaffs_block_bits(dev, blk);
+
+	memset(blk_bits, 0, dev->chunk_bit_stride);
+}
+
+void yaffs_clear_chunk_bit(struct yaffs_dev *dev, int blk, int chunk)
+{
+	u8 *blk_bits = yaffs_block_bits(dev, blk);
+
+	yaffs_verify_chunk_bit_id(dev, blk, chunk);
+	blk_bits[chunk / 8] &= ~(1 << (chunk & 7));
+}
+
+void yaffs_set_chunk_bit(struct yaffs_dev *dev, int blk, int chunk)
+{
+	u8 *blk_bits = yaffs_block_bits(dev, blk);
+
+	yaffs_verify_chunk_bit_id(dev, blk, chunk);
+	blk_bits[chunk / 8] |= (1 << (chunk & 7));
+}
+
+int yaffs_check_chunk_bit(struct yaffs_dev *dev, int blk, int chunk)
+{
+	u8 *blk_bits = yaffs_block_bits(dev, blk);
+
+	yaffs_verify_chunk_bit_id(dev, blk, chunk);
+	return (blk_bits[chunk / 8] & (1 << (chunk & 7))) ? 1 : 0;
+}
+
+int yaffs_still_some_chunks(struct yaffs_dev *dev, int blk)
+{
+	u8 *blk_bits = yaffs_block_bits(dev, blk);
+	int i;
+
+	for (i = 0; i < dev->chunk_bit_stride; i++) {
+		if (*blk_bits)
+			return 1;
+		blk_bits++;
+	}
+	return 0;
+}
+
+int yaffs_count_chunk_bits(struct yaffs_dev *dev, int blk)
+{
+	u8 *blk_bits = yaffs_block_bits(dev, blk);
+	int i;
+	int n = 0;
+
+	for (i = 0; i < dev->chunk_bit_stride; i++, blk_bits++)
+		n += hweight8(*blk_bits);
+
+	return n;
+}
diff --git a/fs/yaffs2/yaffs_bitmap.h b/fs/yaffs2/yaffs_bitmap.h
new file mode 100644
index 00000000..30bbd3b
--- /dev/null
+++ b/fs/yaffs2/yaffs_bitmap.h
@@ -0,0 +1,32 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+/*
+ * Chunk bitmap manipulations
+ */
+
+#ifndef __YAFFS_BITMAP_H__
+#define __YAFFS_BITMAP_H__
+
+#include "yaffs_guts.h"
+
+void yaffs_verify_chunk_bit_id(struct yaffs_dev *dev, int blk, int chunk);
+void yaffs_clear_chunk_bits(struct yaffs_dev *dev, int blk);
+void yaffs_clear_chunk_bit(struct yaffs_dev *dev, int blk, int chunk);
+void yaffs_set_chunk_bit(struct yaffs_dev *dev, int blk, int chunk);
+int yaffs_check_chunk_bit(struct yaffs_dev *dev, int blk, int chunk);
+int yaffs_still_some_chunks(struct yaffs_dev *dev, int blk);
+int yaffs_count_chunk_bits(struct yaffs_dev *dev, int blk);
+
+#endif
diff --git a/fs/yaffs2/yaffs_checkptrw.c b/fs/yaffs2/yaffs_checkptrw.c
new file mode 100644
index 00000000..53688b5
--- /dev/null
+++ b/fs/yaffs2/yaffs_checkptrw.c
@@ -0,0 +1,480 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yaffs_checkptrw.h"
+#include "yaffs_getblockinfo.h"
+#include "yaffs_endian.h"
+
+struct yaffs_checkpt_chunk_hdr {
+	int version;
+	int seq;
+	u32 sum;
+	u32 xor;
+} ;
+
+
+static int apply_chunk_offset(struct yaffs_dev *dev, int chunk)
+{
+	return chunk - dev->chunk_offset;
+}
+
+static int apply_block_offset(struct yaffs_dev *dev, int block)
+{
+	return block - dev->block_offset;
+}
+
+
+static void yaffs2_do_endian_hdr(struct yaffs_dev *dev,
+				 struct yaffs_checkpt_chunk_hdr *hdr)
+{
+	if (!dev->swap_endian)
+		return;
+	hdr->version = swap_s32(hdr->version);
+	hdr->seq     = swap_s32(hdr->seq);
+	hdr->sum     = swap_u32(hdr->sum);
+	hdr->xor     = swap_u32(hdr->xor);
+}
+
+static void yaffs2_checkpt_init_chunk_hdr(struct yaffs_dev *dev)
+{
+	struct yaffs_checkpt_chunk_hdr hdr;
+
+	hdr.version = YAFFS_CHECKPOINT_VERSION;
+	hdr.seq = dev->checkpt_page_seq;
+	hdr.sum = dev->checkpt_sum;
+	hdr.xor = dev->checkpt_xor;
+
+	dev->checkpt_byte_offs = sizeof(hdr);
+
+	yaffs2_do_endian_hdr(dev, &hdr);
+	memcpy(dev->checkpt_buffer, &hdr, sizeof(hdr));
+}
+
+static int yaffs2_checkpt_check_chunk_hdr(struct yaffs_dev *dev)
+{
+	struct yaffs_checkpt_chunk_hdr hdr;
+
+	memcpy(&hdr, dev->checkpt_buffer, sizeof(hdr));
+	yaffs2_do_endian_hdr(dev, &hdr);
+
+	dev->checkpt_byte_offs = sizeof(hdr);
+
+	return hdr.version == YAFFS_CHECKPOINT_VERSION &&
+		hdr.seq == dev->checkpt_page_seq &&
+		hdr.sum == dev->checkpt_sum &&
+		hdr.xor == dev->checkpt_xor;
+}
+
+static int yaffs2_checkpt_space_ok(struct yaffs_dev *dev)
+{
+	int blocks_avail = dev->n_erased_blocks - dev->param.n_reserved_blocks;
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+		"checkpt blocks_avail = %d", blocks_avail);
+
+	return (blocks_avail <= 0) ? 0 : 1;
+}
+
+static int yaffs_checkpt_erase(struct yaffs_dev *dev)
+{
+	u32 i;
+
+	if (!dev->drv.drv_erase_fn)
+		return 0;
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+		"checking blocks %d to %d",
+		dev->internal_start_block, dev->internal_end_block);
+
+	for (i = dev->internal_start_block; i <= dev->internal_end_block; i++) {
+		struct yaffs_block_info *bi = yaffs_get_block_info(dev, i);
+		int offset_i = apply_block_offset(dev, i);
+		int result;
+
+		if (bi->block_state == YAFFS_BLOCK_STATE_CHECKPOINT) {
+			yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"erasing checkpt block %d", i);
+
+			dev->n_erasures++;
+
+			result = dev->drv.drv_erase_fn(dev, offset_i);
+			if(result) {
+				bi->block_state = YAFFS_BLOCK_STATE_EMPTY;
+				dev->n_erased_blocks++;
+				dev->n_free_chunks +=
+				    dev->param.chunks_per_block;
+			} else {
+				dev->drv.drv_mark_bad_fn(dev, offset_i);
+				bi->block_state = YAFFS_BLOCK_STATE_DEAD;
+			}
+		}
+	}
+
+	dev->blocks_in_checkpt = 0;
+
+	return 1;
+}
+
+static void yaffs2_checkpt_find_erased_block(struct yaffs_dev *dev)
+{
+	u32 i;
+	int blocks_avail = dev->n_erased_blocks - dev->param.n_reserved_blocks;
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+		"allocating checkpt block: erased %d reserved %d avail %d next %d ",
+		dev->n_erased_blocks, dev->param.n_reserved_blocks,
+		blocks_avail, dev->checkpt_next_block);
+
+	if (dev->checkpt_next_block >= 0 &&
+	    dev->checkpt_next_block <= (int)dev->internal_end_block &&
+	    blocks_avail > 0) {
+
+		for (i = dev->checkpt_next_block; i <= dev->internal_end_block;
+		     i++) {
+			struct yaffs_block_info *bi;
+
+			bi = yaffs_get_block_info(dev, i);
+			if (bi->block_state == YAFFS_BLOCK_STATE_EMPTY) {
+				dev->checkpt_next_block = i + 1;
+				dev->checkpt_cur_block = i;
+				yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+					"allocating checkpt block %d", i);
+				return;
+			}
+		}
+	}
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT, "out of checkpt blocks");
+
+	dev->checkpt_next_block = -1;
+	dev->checkpt_cur_block = -1;
+}
+
+static void yaffs2_checkpt_find_block(struct yaffs_dev *dev)
+{
+	u32 i;
+	struct yaffs_ext_tags tags;
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+		"find next checkpt block: start:  blocks %d next %d",
+		dev->blocks_in_checkpt, dev->checkpt_next_block);
+
+	if (dev->blocks_in_checkpt < dev->checkpt_max_blocks)
+		for (i = dev->checkpt_next_block; i <= dev->internal_end_block;
+		     i++) {
+			int chunk = i * dev->param.chunks_per_block;
+			enum yaffs_block_state state;
+			u32 seq;
+
+			dev->tagger.read_chunk_tags_fn(dev,
+					apply_chunk_offset(dev, chunk),
+					NULL, &tags);
+			yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+				"find next checkpt block: search: block %d state %d oid %d seq %d eccr %d",
+				i, (int) state,
+				tags.obj_id, tags.seq_number,
+				tags.ecc_result);
+
+			if (tags.seq_number != YAFFS_SEQUENCE_CHECKPOINT_DATA)
+				continue;
+
+			dev->tagger.query_block_fn(dev,
+						apply_block_offset(dev, i),
+						&state, &seq);
+			if (state == YAFFS_BLOCK_STATE_DEAD)
+				continue;
+
+			/* Right kind of block */
+			dev->checkpt_next_block = tags.obj_id;
+			dev->checkpt_cur_block = i;
+			dev->checkpt_block_list[dev->blocks_in_checkpt] = i;
+			dev->blocks_in_checkpt++;
+			yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+				"found checkpt block %d", i);
+			return;
+		}
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT, "found no more checkpt blocks");
+
+	dev->checkpt_next_block = -1;
+	dev->checkpt_cur_block = -1;
+}
+
+int yaffs2_checkpt_open(struct yaffs_dev *dev, int writing)
+{
+	u32 i;
+
+	dev->checkpt_open_write = writing;
+
+	/* Got the functions we need? */
+	if (!dev->tagger.write_chunk_tags_fn ||
+	    !dev->tagger.read_chunk_tags_fn ||
+	    !dev->drv.drv_erase_fn ||
+	    !dev->drv.drv_mark_bad_fn)
+		return 0;
+
+	if (writing && !yaffs2_checkpt_space_ok(dev))
+		return 0;
+
+	if (!dev->checkpt_buffer)
+		dev->checkpt_buffer =
+		    kmalloc(dev->param.total_bytes_per_chunk, GFP_NOFS);
+	if (!dev->checkpt_buffer)
+		return 0;
+
+	dev->checkpt_page_seq = 0;
+	dev->checkpt_byte_count = 0;
+	dev->checkpt_sum = 0;
+	dev->checkpt_xor = 0;
+	dev->checkpt_cur_block = -1;
+	dev->checkpt_cur_chunk = -1;
+	dev->checkpt_next_block = dev->internal_start_block;
+
+	if (writing) {
+		memset(dev->checkpt_buffer, 0, dev->data_bytes_per_chunk);
+		yaffs2_checkpt_init_chunk_hdr(dev);
+		return yaffs_checkpt_erase(dev);
+	}
+
+	/* Opening for a read */
+	/* Set to a value that will kick off a read */
+	dev->checkpt_byte_offs = dev->data_bytes_per_chunk;
+	/* A checkpoint block list of 1 checkpoint block per 16 block is
+	 * (hopefully) going to be way more than we need */
+	dev->blocks_in_checkpt = 0;
+	dev->checkpt_max_blocks =
+	    (dev->internal_end_block - dev->internal_start_block) / 16 + 2;
+	if (!dev->checkpt_block_list)
+		dev->checkpt_block_list =
+		      kmalloc(sizeof(int) * dev->checkpt_max_blocks, GFP_NOFS);
+
+	if (!dev->checkpt_block_list)
+		return 0;
+
+	for (i = 0; i < dev->checkpt_max_blocks; i++)
+		dev->checkpt_block_list[i] = -1;
+
+	return 1;
+}
+
+int yaffs2_get_checkpt_sum(struct yaffs_dev *dev, u32 * sum)
+{
+	u32 composite_sum;
+
+	composite_sum = (dev->checkpt_sum << 8) | (dev->checkpt_xor & 0xff);
+	*sum = composite_sum;
+	return 1;
+}
+
+static int yaffs2_checkpt_flush_buffer(struct yaffs_dev *dev)
+{
+	int chunk;
+	int offset_chunk;
+	struct yaffs_ext_tags tags;
+
+	if (dev->checkpt_cur_block < 0) {
+		yaffs2_checkpt_find_erased_block(dev);
+		dev->checkpt_cur_chunk = 0;
+	}
+
+	if (dev->checkpt_cur_block < 0)
+		return 0;
+
+	tags.is_deleted = 0;
+	tags.obj_id = dev->checkpt_next_block;	/* Hint to next place to look */
+	tags.chunk_id = dev->checkpt_page_seq + 1;
+	tags.seq_number = YAFFS_SEQUENCE_CHECKPOINT_DATA;
+	tags.n_bytes = dev->data_bytes_per_chunk;
+	if (dev->checkpt_cur_chunk == 0) {
+		/* First chunk we write for the block? Set block state to
+		   checkpoint */
+		struct yaffs_block_info *bi =
+		    yaffs_get_block_info(dev, dev->checkpt_cur_block);
+		bi->block_state = YAFFS_BLOCK_STATE_CHECKPOINT;
+		dev->blocks_in_checkpt++;
+	}
+
+	chunk =
+	    dev->checkpt_cur_block * dev->param.chunks_per_block +
+	    dev->checkpt_cur_chunk;
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+		"checkpoint wite buffer nand %d(%d:%d) objid %d chId %d",
+		chunk, dev->checkpt_cur_block, dev->checkpt_cur_chunk,
+		tags.obj_id, tags.chunk_id);
+
+	offset_chunk = apply_chunk_offset(dev, chunk);
+
+	dev->n_page_writes++;
+
+	dev->tagger.write_chunk_tags_fn(dev, offset_chunk,
+				       dev->checkpt_buffer, &tags);
+	dev->checkpt_page_seq++;
+	dev->checkpt_cur_chunk++;
+	if (dev->checkpt_cur_chunk >= (int)dev->param.chunks_per_block) {
+		dev->checkpt_cur_chunk = 0;
+		dev->checkpt_cur_block = -1;
+	}
+	memset(dev->checkpt_buffer, 0, dev->data_bytes_per_chunk);
+
+	yaffs2_checkpt_init_chunk_hdr(dev);
+
+
+	return 1;
+}
+
+int yaffs2_checkpt_wr(struct yaffs_dev *dev, const void *data, int n_bytes)
+{
+	int i = 0;
+	int ok = 1;
+	u8 *data_bytes = (u8 *) data;
+
+	if (!dev->checkpt_buffer)
+		return 0;
+
+	if (!dev->checkpt_open_write)
+		return -1;
+
+	while (i < n_bytes && ok) {
+		dev->checkpt_buffer[dev->checkpt_byte_offs] = *data_bytes;
+		dev->checkpt_sum += *data_bytes;
+		dev->checkpt_xor ^= *data_bytes;
+
+		dev->checkpt_byte_offs++;
+		i++;
+		data_bytes++;
+		dev->checkpt_byte_count++;
+
+		if (dev->checkpt_byte_offs < 0 ||
+		    dev->checkpt_byte_offs >= (int)dev->data_bytes_per_chunk)
+			ok = yaffs2_checkpt_flush_buffer(dev);
+	}
+
+	return i;
+}
+
+int yaffs2_checkpt_rd(struct yaffs_dev *dev, void *data, int n_bytes)
+{
+	int i = 0;
+	struct yaffs_ext_tags tags;
+	int chunk;
+	int offset_chunk;
+	u8 *data_bytes = (u8 *) data;
+
+	if (!dev->checkpt_buffer)
+		return 0;
+
+	if (dev->checkpt_open_write)
+		return -1;
+
+	while (i < n_bytes) {
+
+		if (dev->checkpt_byte_offs < 0 ||
+		    dev->checkpt_byte_offs >= (int)dev->data_bytes_per_chunk) {
+
+			if (dev->checkpt_cur_block < 0) {
+				yaffs2_checkpt_find_block(dev);
+				dev->checkpt_cur_chunk = 0;
+			}
+
+			/* Bail out if we can't find a checpoint block */
+			if (dev->checkpt_cur_block < 0)
+				break;
+
+			chunk = dev->checkpt_cur_block *
+			    dev->param.chunks_per_block +
+			    dev->checkpt_cur_chunk;
+
+			offset_chunk = apply_chunk_offset(dev, chunk);
+			dev->n_page_reads++;
+
+			/* Read in the next chunk */
+			dev->tagger.read_chunk_tags_fn(dev,
+						offset_chunk,
+						dev->checkpt_buffer,
+						&tags);
+
+			/* Bail out if the chunk is corrupted. */
+			if (tags.chunk_id != (u32)(dev->checkpt_page_seq + 1) ||
+			    tags.ecc_result > YAFFS_ECC_RESULT_FIXED ||
+			    tags.seq_number != YAFFS_SEQUENCE_CHECKPOINT_DATA)
+				break;
+
+			/* Bail out if it is not a checkpoint chunk. */
+			if(!yaffs2_checkpt_check_chunk_hdr(dev))
+				break;
+
+			dev->checkpt_page_seq++;
+			dev->checkpt_cur_chunk++;
+
+			if (dev->checkpt_cur_chunk >=
+					(int)dev->param.chunks_per_block)
+				dev->checkpt_cur_block = -1;
+
+		}
+
+		*data_bytes = dev->checkpt_buffer[dev->checkpt_byte_offs];
+		dev->checkpt_sum += *data_bytes;
+		dev->checkpt_xor ^= *data_bytes;
+		dev->checkpt_byte_offs++;
+		i++;
+		data_bytes++;
+		dev->checkpt_byte_count++;
+	}
+
+	return i; /* Number of bytes read */
+}
+
+int yaffs_checkpt_close(struct yaffs_dev *dev)
+{
+	u32 i;
+
+	if (dev->checkpt_open_write) {
+		if (dev->checkpt_byte_offs !=
+			sizeof(sizeof(struct yaffs_checkpt_chunk_hdr)))
+			yaffs2_checkpt_flush_buffer(dev);
+	} else if (dev->checkpt_block_list) {
+		for (i = 0;
+		     i < dev->blocks_in_checkpt &&
+		     dev->checkpt_block_list[i] >= 0; i++) {
+			int blk = dev->checkpt_block_list[i];
+			struct yaffs_block_info *bi = NULL;
+
+			if ((int)dev->internal_start_block <= blk &&
+			    blk <= (int)dev->internal_end_block)
+				bi = yaffs_get_block_info(dev, blk);
+			if (bi && bi->block_state == YAFFS_BLOCK_STATE_EMPTY)
+				bi->block_state = YAFFS_BLOCK_STATE_CHECKPOINT;
+		}
+	}
+
+	dev->n_free_chunks -=
+		dev->blocks_in_checkpt * dev->param.chunks_per_block;
+	dev->n_erased_blocks -= dev->blocks_in_checkpt;
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT, "checkpoint byte count %d",
+		dev->checkpt_byte_count);
+
+	if (dev->checkpt_buffer)
+		return 1;
+	else
+		return 0;
+}
+
+int yaffs2_checkpt_invalidate_stream(struct yaffs_dev *dev)
+{
+	/* Erase the checkpoint data */
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+		"checkpoint invalidate of %d blocks",
+		dev->blocks_in_checkpt);
+
+	return yaffs_checkpt_erase(dev);
+}
diff --git a/fs/yaffs2/yaffs_checkptrw.h b/fs/yaffs2/yaffs_checkptrw.h
new file mode 100644
index 00000000..4820fb0
--- /dev/null
+++ b/fs/yaffs2/yaffs_checkptrw.h
@@ -0,0 +1,32 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_CHECKPTRW_H__
+#define __YAFFS_CHECKPTRW_H__
+
+#include "yaffs_guts.h"
+
+int yaffs2_checkpt_open(struct yaffs_dev *dev, int writing);
+
+int yaffs2_checkpt_wr(struct yaffs_dev *dev, const void *data, int n_bytes);
+
+int yaffs2_checkpt_rd(struct yaffs_dev *dev, void *data, int n_bytes);
+
+int yaffs2_get_checkpt_sum(struct yaffs_dev *dev, u32 * sum);
+
+int yaffs_checkpt_close(struct yaffs_dev *dev);
+
+int yaffs2_checkpt_invalidate_stream(struct yaffs_dev *dev);
+
+#endif
diff --git a/fs/yaffs2/yaffs_ecc.c b/fs/yaffs2/yaffs_ecc.c
new file mode 100644
index 00000000..911f8f7
--- /dev/null
+++ b/fs/yaffs2/yaffs_ecc.c
@@ -0,0 +1,280 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+/*
+ * This code implements the ECC algorithm used in SmartMedia.
+ *
+ * The ECC comprises 22 bits of parity information and is stuffed into 3 bytes.
+ * The two unused bit are set to 1.
+ * The ECC can correct single bit errors in a 256-byte page of data. Thus, two
+ * such ECC blocks are used on a 512-byte NAND page.
+ *
+ */
+
+#include "yportenv.h"
+
+#include "yaffs_ecc.h"
+
+/* Table generated by gen-ecc.c
+ * Using a table means we do not have to calculate p1..p4 and p1'..p4'
+ * for each byte of data. These are instead provided in a table in bits7..2.
+ * Bit 0 of each entry indicates whether the entry has an odd or even parity,
+ * and therefore this bytes influence on the line parity.
+ */
+
+static const unsigned char column_parity_table[] = {
+	0x00, 0x55, 0x59, 0x0c, 0x65, 0x30, 0x3c, 0x69,
+	0x69, 0x3c, 0x30, 0x65, 0x0c, 0x59, 0x55, 0x00,
+	0x95, 0xc0, 0xcc, 0x99, 0xf0, 0xa5, 0xa9, 0xfc,
+	0xfc, 0xa9, 0xa5, 0xf0, 0x99, 0xcc, 0xc0, 0x95,
+	0x99, 0xcc, 0xc0, 0x95, 0xfc, 0xa9, 0xa5, 0xf0,
+	0xf0, 0xa5, 0xa9, 0xfc, 0x95, 0xc0, 0xcc, 0x99,
+	0x0c, 0x59, 0x55, 0x00, 0x69, 0x3c, 0x30, 0x65,
+	0x65, 0x30, 0x3c, 0x69, 0x00, 0x55, 0x59, 0x0c,
+	0xa5, 0xf0, 0xfc, 0xa9, 0xc0, 0x95, 0x99, 0xcc,
+	0xcc, 0x99, 0x95, 0xc0, 0xa9, 0xfc, 0xf0, 0xa5,
+	0x30, 0x65, 0x69, 0x3c, 0x55, 0x00, 0x0c, 0x59,
+	0x59, 0x0c, 0x00, 0x55, 0x3c, 0x69, 0x65, 0x30,
+	0x3c, 0x69, 0x65, 0x30, 0x59, 0x0c, 0x00, 0x55,
+	0x55, 0x00, 0x0c, 0x59, 0x30, 0x65, 0x69, 0x3c,
+	0xa9, 0xfc, 0xf0, 0xa5, 0xcc, 0x99, 0x95, 0xc0,
+	0xc0, 0x95, 0x99, 0xcc, 0xa5, 0xf0, 0xfc, 0xa9,
+	0xa9, 0xfc, 0xf0, 0xa5, 0xcc, 0x99, 0x95, 0xc0,
+	0xc0, 0x95, 0x99, 0xcc, 0xa5, 0xf0, 0xfc, 0xa9,
+	0x3c, 0x69, 0x65, 0x30, 0x59, 0x0c, 0x00, 0x55,
+	0x55, 0x00, 0x0c, 0x59, 0x30, 0x65, 0x69, 0x3c,
+	0x30, 0x65, 0x69, 0x3c, 0x55, 0x00, 0x0c, 0x59,
+	0x59, 0x0c, 0x00, 0x55, 0x3c, 0x69, 0x65, 0x30,
+	0xa5, 0xf0, 0xfc, 0xa9, 0xc0, 0x95, 0x99, 0xcc,
+	0xcc, 0x99, 0x95, 0xc0, 0xa9, 0xfc, 0xf0, 0xa5,
+	0x0c, 0x59, 0x55, 0x00, 0x69, 0x3c, 0x30, 0x65,
+	0x65, 0x30, 0x3c, 0x69, 0x00, 0x55, 0x59, 0x0c,
+	0x99, 0xcc, 0xc0, 0x95, 0xfc, 0xa9, 0xa5, 0xf0,
+	0xf0, 0xa5, 0xa9, 0xfc, 0x95, 0xc0, 0xcc, 0x99,
+	0x95, 0xc0, 0xcc, 0x99, 0xf0, 0xa5, 0xa9, 0xfc,
+	0xfc, 0xa9, 0xa5, 0xf0, 0x99, 0xcc, 0xc0, 0x95,
+	0x00, 0x55, 0x59, 0x0c, 0x65, 0x30, 0x3c, 0x69,
+	0x69, 0x3c, 0x30, 0x65, 0x0c, 0x59, 0x55, 0x00,
+};
+
+
+/* Calculate the ECC for a 256-byte block of data */
+void yaffs_ecc_calc(const unsigned char *data, unsigned char *ecc)
+{
+	unsigned int i;
+	unsigned char col_parity = 0;
+	unsigned char line_parity = 0;
+	unsigned char line_parity_prime = 0;
+	unsigned char t;
+	unsigned char b;
+
+	for (i = 0; i < 256; i++) {
+		b = column_parity_table[*data++];
+		col_parity ^= b;
+
+		if (b & 0x01) {	/* odd number of bits in the byte */
+			line_parity ^= i;
+			line_parity_prime ^= ~i;
+		}
+	}
+
+	ecc[2] = (~col_parity) | 0x03;
+
+	t = 0;
+	if (line_parity & 0x80)
+		t |= 0x80;
+	if (line_parity_prime & 0x80)
+		t |= 0x40;
+	if (line_parity & 0x40)
+		t |= 0x20;
+	if (line_parity_prime & 0x40)
+		t |= 0x10;
+	if (line_parity & 0x20)
+		t |= 0x08;
+	if (line_parity_prime & 0x20)
+		t |= 0x04;
+	if (line_parity & 0x10)
+		t |= 0x02;
+	if (line_parity_prime & 0x10)
+		t |= 0x01;
+	ecc[1] = ~t;
+
+	t = 0;
+	if (line_parity & 0x08)
+		t |= 0x80;
+	if (line_parity_prime & 0x08)
+		t |= 0x40;
+	if (line_parity & 0x04)
+		t |= 0x20;
+	if (line_parity_prime & 0x04)
+		t |= 0x10;
+	if (line_parity & 0x02)
+		t |= 0x08;
+	if (line_parity_prime & 0x02)
+		t |= 0x04;
+	if (line_parity & 0x01)
+		t |= 0x02;
+	if (line_parity_prime & 0x01)
+		t |= 0x01;
+	ecc[0] = ~t;
+
+}
+
+/* Correct the ECC on a 256 byte block of data */
+
+int yaffs_ecc_correct(unsigned char *data, unsigned char *read_ecc,
+		      const unsigned char *test_ecc)
+{
+	unsigned char d0, d1, d2;	/* deltas */
+
+	d0 = read_ecc[0] ^ test_ecc[0];
+	d1 = read_ecc[1] ^ test_ecc[1];
+	d2 = read_ecc[2] ^ test_ecc[2];
+
+	if ((d0 | d1 | d2) == 0)
+		return 0;	/* no error */
+
+	if (((d0 ^ (d0 >> 1)) & 0x55) == 0x55 &&
+	    ((d1 ^ (d1 >> 1)) & 0x55) == 0x55 &&
+	    ((d2 ^ (d2 >> 1)) & 0x54) == 0x54) {
+		/* Single bit (recoverable) error in data */
+
+		unsigned byte;
+		unsigned bit;
+
+		bit = byte = 0;
+
+		if (d1 & 0x80)
+			byte |= 0x80;
+		if (d1 & 0x20)
+			byte |= 0x40;
+		if (d1 & 0x08)
+			byte |= 0x20;
+		if (d1 & 0x02)
+			byte |= 0x10;
+		if (d0 & 0x80)
+			byte |= 0x08;
+		if (d0 & 0x20)
+			byte |= 0x04;
+		if (d0 & 0x08)
+			byte |= 0x02;
+		if (d0 & 0x02)
+			byte |= 0x01;
+
+		if (d2 & 0x80)
+			bit |= 0x04;
+		if (d2 & 0x20)
+			bit |= 0x02;
+		if (d2 & 0x08)
+			bit |= 0x01;
+
+		data[byte] ^= (1 << bit);
+
+		return 1;	/* Corrected the error */
+	}
+
+	if ((hweight8(d0) + hweight8(d1) + hweight8(d2)) == 1) {
+		/* Reccoverable error in ecc */
+
+		read_ecc[0] = test_ecc[0];
+		read_ecc[1] = test_ecc[1];
+		read_ecc[2] = test_ecc[2];
+
+		return 1;	/* Corrected the error */
+	}
+
+	/* Unrecoverable error */
+
+	return -1;
+
+}
+
+/*
+ * ECCxxxOther does ECC calcs on arbitrary n bytes of data
+ */
+void yaffs_ecc_calc_other(const unsigned char *data, unsigned n_bytes,
+			  struct yaffs_ecc_other *ecc_other)
+{
+	unsigned int i;
+	unsigned char col_parity = 0;
+	unsigned line_parity = 0;
+	unsigned line_parity_prime = 0;
+	unsigned char b;
+
+	for (i = 0; i < n_bytes; i++) {
+		b = column_parity_table[*data++];
+		col_parity ^= b;
+
+		if (b & 0x01) {
+			/* odd number of bits in the byte */
+			line_parity ^= i;
+			line_parity_prime ^= ~i;
+		}
+
+	}
+
+	ecc_other->col_parity = (col_parity >> 2) & 0x3f;
+	ecc_other->line_parity = line_parity;
+	ecc_other->line_parity_prime = line_parity_prime;
+}
+
+int yaffs_ecc_correct_other(unsigned char *data, unsigned n_bytes,
+			    struct yaffs_ecc_other *read_ecc,
+			    const struct yaffs_ecc_other *test_ecc)
+{
+	unsigned char delta_col;	/* column parity delta */
+	unsigned delta_line;	/* line parity delta */
+	unsigned delta_line_prime;	/* line parity delta */
+	unsigned bit;
+
+	delta_col = read_ecc->col_parity ^ test_ecc->col_parity;
+	delta_line = read_ecc->line_parity ^ test_ecc->line_parity;
+	delta_line_prime =
+	    read_ecc->line_parity_prime ^ test_ecc->line_parity_prime;
+
+	if ((delta_col | delta_line | delta_line_prime) == 0)
+		return 0;	/* no error */
+
+	if (delta_line == ~delta_line_prime &&
+	    (((delta_col ^ (delta_col >> 1)) & 0x15) == 0x15)) {
+		/* Single bit (recoverable) error in data */
+
+		bit = 0;
+
+		if (delta_col & 0x20)
+			bit |= 0x04;
+		if (delta_col & 0x08)
+			bit |= 0x02;
+		if (delta_col & 0x02)
+			bit |= 0x01;
+
+		if (delta_line >= n_bytes)
+			return -1;
+
+		data[delta_line] ^= (1 << bit);
+
+		return 1;	/* corrected */
+	}
+
+	if ((hweight32(delta_line) +
+	     hweight32(delta_line_prime) +
+	     hweight8(delta_col)) == 1) {
+		/* Reccoverable error in ecc */
+
+		*read_ecc = *test_ecc;
+		return 1;	/* corrected */
+	}
+
+	/* Unrecoverable error */
+
+	return -1;
+}
diff --git a/fs/yaffs2/yaffs_ecc.h b/fs/yaffs2/yaffs_ecc.h
new file mode 100644
index 00000000..1dc6441
--- /dev/null
+++ b/fs/yaffs2/yaffs_ecc.h
@@ -0,0 +1,43 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+/*
+ * This code implements the ECC algorithm used in SmartMedia.
+ *
+ * The ECC comprises 22 bits of parity information and is stuffed into 3 bytes.
+ * The two unused bit are set to 1.
+ * The ECC can correct single bit errors in a 256-byte page of data.
+ * Thus, two such ECC blocks are used on a 512-byte NAND page.
+ *
+ */
+
+#ifndef __YAFFS_ECC_H__
+#define __YAFFS_ECC_H__
+
+struct yaffs_ecc_other {
+	unsigned char col_parity;
+	unsigned line_parity;
+	unsigned line_parity_prime;
+};
+
+void yaffs_ecc_calc(const unsigned char *data, unsigned char *ecc);
+int yaffs_ecc_correct(unsigned char *data, unsigned char *read_ecc,
+		      const unsigned char *test_ecc);
+
+void yaffs_ecc_calc_other(const unsigned char *data, unsigned n_bytes,
+			  struct yaffs_ecc_other *ecc);
+int yaffs_ecc_correct_other(unsigned char *data, unsigned n_bytes,
+			    struct yaffs_ecc_other *read_ecc,
+			    const struct yaffs_ecc_other *test_ecc);
+#endif
diff --git a/fs/yaffs2/yaffs_endian.c b/fs/yaffs2/yaffs_endian.c
new file mode 100644
index 00000000..6103f4e
--- /dev/null
+++ b/fs/yaffs2/yaffs_endian.c
@@ -0,0 +1,105 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * Endian processing functions.
+ */
+
+#include "yaffs_endian.h"
+#include "yaffs_guts.h"
+
+
+void yaffs_do_endian_u32(struct yaffs_dev *dev, u32 *val)
+{
+	if (!dev->swap_endian)
+		return;
+	*val = swap_u32(*val);
+}
+
+void yaffs_do_endian_s32(struct yaffs_dev *dev, s32 *val)
+{
+	if (!dev->swap_endian)
+		return;
+	*val = swap_s32(*val);
+}
+
+void yaffs_do_endian_oh(struct yaffs_dev *dev, struct yaffs_obj_hdr *oh)
+{
+	if (!dev->swap_endian)
+		return;
+	/* Change every field */
+	oh->type = swap_u32(oh->type);
+	oh->parent_obj_id = swap_u32(oh->parent_obj_id);
+
+	oh->yst_mode = swap_u32(oh->yst_mode);
+
+	oh->yst_uid = swap_u32(oh->yst_uid);
+	oh->yst_gid = swap_u32(oh->yst_gid);
+	oh->yst_atime = swap_u32(oh->yst_atime);
+	oh->yst_mtime = swap_u32(oh->yst_mtime);
+	oh->yst_ctime = swap_u32(oh->yst_ctime);
+
+	oh->file_size_low = swap_u32(oh->file_size_low);
+
+	oh->equiv_id = swap_u32(oh->equiv_id);
+
+	oh->yst_rdev = swap_u32(oh->yst_rdev);
+
+	oh->win_ctime[0] = swap_u32(oh->win_ctime[0]);
+	oh->win_ctime[1] = swap_u32(oh->win_ctime[1]);
+	oh->win_atime[0] = swap_u32(oh->win_atime[0]);
+	oh->win_atime[1] = swap_u32(oh->win_atime[1]);
+	oh->win_mtime[0] = swap_u32(oh->win_mtime[0]);
+	oh->win_mtime[1] = swap_u32(oh->win_mtime[1]);
+
+	oh->inband_shadowed_obj_id = swap_u32(oh->inband_shadowed_obj_id);
+	oh->inband_is_shrink = swap_u32(oh->inband_is_shrink);
+
+	oh->file_size_high = swap_u32(oh->file_size_high);
+	oh->reserved[0] = swap_u32(oh->reserved[0]);
+	oh->shadows_obj = swap_s32(oh->shadows_obj);
+
+	oh->is_shrink = swap_u32(oh->is_shrink);
+}
+
+
+void yaffs_do_endian_packed_tags2(struct yaffs_dev *dev,
+				struct yaffs_packed_tags2_tags_only *ptt)
+{
+	if (!dev->swap_endian)
+		return;
+	ptt->seq_number = swap_u32(ptt->seq_number);
+	ptt->obj_id = swap_u32(ptt->obj_id);
+	ptt->chunk_id = swap_u32(ptt->chunk_id);
+	ptt->n_bytes = swap_u32(ptt->n_bytes);
+}
+
+void yaffs_endian_config(struct yaffs_dev *dev)
+{
+	u32 x = 1;
+
+	if (dev->tnode_size < 1)
+		BUG();
+
+	dev->swap_endian = 0;
+
+	if (((char *)&x)[0] == 1) {
+		/* Little Endian. */
+		if (dev->param.stored_endian == 2 /* big endian */)
+			dev->swap_endian = 1;
+	} else  {
+		/* Big Endian. */
+		if (dev->param.stored_endian == 1 /* little endian */)
+			dev->swap_endian = 1;
+	}
+
+	if (dev->swap_endian)
+		dev->tn_swap_buffer = kmalloc(dev->tnode_size, GFP_NOFS);
+}
diff --git a/fs/yaffs2/yaffs_endian.h b/fs/yaffs2/yaffs_endian.h
new file mode 100644
index 00000000..8c27189
--- /dev/null
+++ b/fs/yaffs2/yaffs_endian.h
@@ -0,0 +1,54 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_ENDIAN_H__
+#define __YAFFS_ENDIAN_H__
+#include "yaffs_guts.h"
+#include "yaffs_packedtags2.h"
+
+static inline u32 swap_u32(u32 val)
+{
+	return ((val >>24) & 0x000000ff) |
+	       ((val >> 8) & 0x0000ff00) |
+	       ((val << 8) & 0x00ff0000) |
+	       ((val <<24) & 0xff000000);
+}
+
+#define swap_s32(val) \
+	(s32)(swap_u32((u32)(val)))
+
+static inline loff_t swap_loff_t(loff_t lval)
+{
+	u32 vall = swap_u32(FSIZE_LOW(lval));
+	u32 valh;
+
+	if (sizeof(loff_t) == sizeof(u32))
+		return (loff_t) vall;
+
+	valh = swap_u32(FSIZE_HIGH(lval));
+
+	return FSIZE_COMBINE(vall, valh); /*NB: h and l are swapped. */
+}
+
+
+
+struct yaffs_dev;
+void yaffs_do_endian_s32(struct yaffs_dev *dev, s32 *val);
+void yaffs_do_endian_u32(struct yaffs_dev *dev, u32 *val);
+void yaffs_do_endian_oh(struct yaffs_dev *dev, struct yaffs_obj_hdr *oh);
+void yaffs_do_endian_packed_tags2(struct yaffs_dev *dev,
+				struct yaffs_packed_tags2_tags_only *ptt);
+void yaffs_endian_config(struct yaffs_dev *dev);
+
+#endif
diff --git a/fs/yaffs2/yaffs_getblockinfo.h b/fs/yaffs2/yaffs_getblockinfo.h
new file mode 100644
index 00000000..e84ccf8
--- /dev/null
+++ b/fs/yaffs2/yaffs_getblockinfo.h
@@ -0,0 +1,35 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_GETBLOCKINFO_H__
+#define __YAFFS_GETBLOCKINFO_H__
+
+#include "yaffs_guts.h"
+#include "yaffs_trace.h"
+
+/* Function to manipulate block info */
+static inline struct yaffs_block_info *yaffs_get_block_info(struct yaffs_dev
+							      *dev, int blk)
+{
+	if (blk < (int)dev->internal_start_block ||
+	    blk > (int)dev->internal_end_block) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"**>> yaffs: get_block_info block %d is not valid",
+			blk);
+		BUG();
+	}
+	return &dev->block_info[blk - dev->internal_start_block];
+}
+
+#endif
diff --git a/fs/yaffs2/yaffs_guts.c b/fs/yaffs2/yaffs_guts.c
new file mode 100644
index 00000000..7678896
--- /dev/null
+++ b/fs/yaffs2/yaffs_guts.c
@@ -0,0 +1,5214 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yportenv.h"
+#include "yaffs_trace.h"
+
+#include "yaffs_guts.h"
+#include "yaffs_endian.h"
+#include "yaffs_getblockinfo.h"
+#include "yaffs_tagscompat.h"
+#include "yaffs_tagsmarshall.h"
+#include "yaffs_nand.h"
+#include "yaffs_yaffs1.h"
+#include "yaffs_yaffs2.h"
+#include "yaffs_bitmap.h"
+#include "yaffs_verify.h"
+#include "yaffs_nand.h"
+#include "yaffs_packedtags2.h"
+#include "yaffs_nameval.h"
+#include "yaffs_allocator.h"
+#include "yaffs_attribs.h"
+#include "yaffs_summary.h"
+
+/* Note YAFFS_GC_GOOD_ENOUGH must be <= YAFFS_GC_PASSIVE_THRESHOLD */
+#define YAFFS_GC_GOOD_ENOUGH 2
+#define YAFFS_GC_PASSIVE_THRESHOLD 4
+
+#include "yaffs_ecc.h"
+
+/* Forward declarations */
+
+static int yaffs_wr_data_obj(struct yaffs_obj *in, int inode_chunk,
+			     const u8 *buffer, int n_bytes, int use_reserve);
+
+static void yaffs_fix_null_name(struct yaffs_obj *obj, YCHAR *name,
+				int buffer_size);
+
+/* Function to calculate chunk and offset */
+
+void yaffs_addr_to_chunk(struct yaffs_dev *dev, loff_t addr,
+				int *chunk_out, u32 *offset_out)
+{
+	int chunk;
+	u32 offset;
+
+	chunk = (u32) (addr >> dev->chunk_shift);
+
+	if (dev->chunk_div == 1) {
+		/* easy power of 2 case */
+		offset = (u32) (addr & dev->chunk_mask);
+	} else {
+		/* Non power-of-2 case */
+
+		loff_t chunk_base;
+
+		chunk /= dev->chunk_div;
+
+		chunk_base = ((loff_t) chunk) * dev->data_bytes_per_chunk;
+		offset = (u32) (addr - chunk_base);
+	}
+
+	*chunk_out = chunk;
+	*offset_out = offset;
+}
+
+/* Function to return the number of shifts for a power of 2 greater than or
+ * equal to the given number
+ * Note we don't try to cater for all possible numbers and this does not have to
+ * be hellishly efficient.
+ */
+
+static inline u32 calc_shifts_ceiling(u32 x)
+{
+	int extra_bits;
+	int shifts;
+
+	shifts = extra_bits = 0;
+
+	while (x > 1) {
+		if (x & 1)
+			extra_bits++;
+		x >>= 1;
+		shifts++;
+	}
+
+	if (extra_bits)
+		shifts++;
+
+	return shifts;
+}
+
+/* Function to return the number of shifts to get a 1 in bit 0
+ */
+
+static inline u32 calc_shifts(u32 x)
+{
+	u32 shifts;
+
+	shifts = 0;
+
+	if (!x)
+		return 0;
+
+	while (!(x & 1)) {
+		x >>= 1;
+		shifts++;
+	}
+
+	return shifts;
+}
+
+/*
+ * Temporary buffer manipulations.
+ */
+
+static int yaffs_init_tmp_buffers(struct yaffs_dev *dev)
+{
+	int i;
+	u8 *buf = (u8 *) 1;
+
+	memset(dev->temp_buffer, 0, sizeof(dev->temp_buffer));
+
+	for (i = 0; buf && i < YAFFS_N_TEMP_BUFFERS; i++) {
+		dev->temp_buffer[i].in_use = 0;
+		buf = kmalloc(dev->param.total_bytes_per_chunk, GFP_NOFS);
+		dev->temp_buffer[i].buffer = buf;
+	}
+
+	return buf ? YAFFS_OK : YAFFS_FAIL;
+}
+
+u8 *yaffs_get_temp_buffer(struct yaffs_dev * dev)
+{
+	int i;
+
+	dev->temp_in_use++;
+	if (dev->temp_in_use > dev->max_temp)
+		dev->max_temp = dev->temp_in_use;
+
+	for (i = 0; i < YAFFS_N_TEMP_BUFFERS; i++) {
+		if (dev->temp_buffer[i].in_use == 0) {
+			dev->temp_buffer[i].in_use = 1;
+			return dev->temp_buffer[i].buffer;
+		}
+	}
+
+	yaffs_trace(YAFFS_TRACE_BUFFERS, "Out of temp buffers");
+	/*
+	 * If we got here then we have to allocate an unmanaged one
+	 * This is not good.
+	 */
+
+	dev->unmanaged_buffer_allocs++;
+	return kmalloc(dev->data_bytes_per_chunk, GFP_NOFS);
+
+}
+
+void yaffs_release_temp_buffer(struct yaffs_dev *dev, u8 *buffer)
+{
+	int i;
+
+	dev->temp_in_use--;
+
+	for (i = 0; i < YAFFS_N_TEMP_BUFFERS; i++) {
+		if (dev->temp_buffer[i].buffer == buffer) {
+			dev->temp_buffer[i].in_use = 0;
+			return;
+		}
+	}
+
+	if (buffer) {
+		/* assume it is an unmanaged one. */
+		yaffs_trace(YAFFS_TRACE_BUFFERS,
+			"Releasing unmanaged temp buffer");
+		kfree(buffer);
+		dev->unmanaged_buffer_deallocs++;
+	}
+
+}
+
+/*
+ * Functions for robustisizing TODO
+ *
+ */
+
+static void yaffs_handle_chunk_wr_ok(struct yaffs_dev *dev, int nand_chunk,
+				     const u8 *data,
+				     const struct yaffs_ext_tags *tags)
+{
+	(void) dev;
+	(void) nand_chunk;
+	(void) data;
+	(void) tags;
+}
+
+static void yaffs_handle_chunk_update(struct yaffs_dev *dev, int nand_chunk,
+				      const struct yaffs_ext_tags *tags)
+{
+	(void) dev;
+	(void) nand_chunk;
+	(void) tags;
+}
+
+void yaffs_handle_chunk_error(struct yaffs_dev *dev,
+			      struct yaffs_block_info *bi)
+{
+	if (!bi->gc_prioritise) {
+		bi->gc_prioritise = 1;
+		dev->has_pending_prioritised_gc = 1;
+		bi->chunk_error_strikes++;
+
+		if (bi->chunk_error_strikes > 3) {
+			bi->needs_retiring = 1;	/* Too many stikes, so retire */
+			yaffs_trace(YAFFS_TRACE_ALWAYS,
+				"yaffs: Block struck out");
+
+		}
+	}
+}
+
+static void yaffs_handle_chunk_wr_error(struct yaffs_dev *dev, int nand_chunk,
+					int erased_ok)
+{
+	int flash_block = nand_chunk / dev->param.chunks_per_block;
+	struct yaffs_block_info *bi = yaffs_get_block_info(dev, flash_block);
+
+	yaffs_handle_chunk_error(dev, bi);
+
+	if (erased_ok) {
+		/* Was an actual write failure,
+		 * so mark the block for retirement.*/
+		bi->needs_retiring = 1;
+		yaffs_trace(YAFFS_TRACE_ERROR | YAFFS_TRACE_BAD_BLOCKS,
+		  "**>> Block %d needs retiring", flash_block);
+	}
+
+	/* Delete the chunk */
+	yaffs_chunk_del(dev, nand_chunk, 1, __LINE__);
+	yaffs_skip_rest_of_block(dev);
+}
+
+/*
+ * Verification code
+ */
+
+/*
+ *  Simple hash function. Needs to have a reasonable spread
+ */
+
+static inline int yaffs_hash_fn(int n)
+{
+	if (n < 0)
+		n = -n;
+	return n % YAFFS_NOBJECT_BUCKETS;
+}
+
+/*
+ * Access functions to useful fake objects.
+ * Note that root might have a presence in NAND if permissions are set.
+ */
+
+struct yaffs_obj *yaffs_root(struct yaffs_dev *dev)
+{
+	return dev->root_dir;
+}
+
+struct yaffs_obj *yaffs_lost_n_found(struct yaffs_dev *dev)
+{
+	return dev->lost_n_found;
+}
+
+/*
+ *  Erased NAND checking functions
+ */
+
+int yaffs_check_ff(u8 *buffer, int n_bytes)
+{
+	/* Horrible, slow implementation */
+	while (n_bytes--) {
+		if (*buffer != 0xff)
+			return 0;
+		buffer++;
+	}
+	return 1;
+}
+
+static int yaffs_check_chunk_erased(struct yaffs_dev *dev, int nand_chunk)
+{
+	int retval = YAFFS_OK;
+	u8 *data = yaffs_get_temp_buffer(dev);
+	struct yaffs_ext_tags tags;
+	int result;
+
+	result = yaffs_rd_chunk_tags_nand(dev, nand_chunk, data, &tags);
+
+	if (result == YAFFS_FAIL ||
+	    tags.ecc_result > YAFFS_ECC_RESULT_NO_ERROR)
+		retval = YAFFS_FAIL;
+
+	if (!yaffs_check_ff(data, dev->data_bytes_per_chunk) ||
+		tags.chunk_used) {
+		yaffs_trace(YAFFS_TRACE_NANDACCESS,
+			"Chunk %d not erased", nand_chunk);
+		retval = YAFFS_FAIL;
+	}
+
+	yaffs_release_temp_buffer(dev, data);
+
+	return retval;
+
+}
+
+static int yaffs_verify_chunk_written(struct yaffs_dev *dev,
+				      int nand_chunk,
+				      const u8 *data,
+				      struct yaffs_ext_tags *tags)
+{
+	int retval = YAFFS_OK;
+	struct yaffs_ext_tags temp_tags;
+	u8 *buffer = yaffs_get_temp_buffer(dev);
+	int result;
+
+	result = yaffs_rd_chunk_tags_nand(dev, nand_chunk, buffer, &temp_tags);
+	if (result == YAFFS_FAIL ||
+	    memcmp(buffer, data, dev->data_bytes_per_chunk) ||
+	    temp_tags.obj_id != tags->obj_id ||
+	    temp_tags.chunk_id != tags->chunk_id ||
+	    temp_tags.n_bytes != tags->n_bytes)
+		retval = YAFFS_FAIL;
+
+	yaffs_release_temp_buffer(dev, buffer);
+
+	return retval;
+}
+
+
+int yaffs_check_alloc_available(struct yaffs_dev *dev, int n_chunks)
+{
+	int reserved_chunks;
+	int reserved_blocks = dev->param.n_reserved_blocks;
+	int checkpt_blocks;
+
+	checkpt_blocks = yaffs_calc_checkpt_blocks_required(dev);
+
+	reserved_chunks =
+	    (reserved_blocks + checkpt_blocks) * dev->param.chunks_per_block;
+
+	return (dev->n_free_chunks > (reserved_chunks + n_chunks));
+}
+
+static int yaffs_find_alloc_block(struct yaffs_dev *dev)
+{
+	u32 i;
+	struct yaffs_block_info *bi;
+
+	if (dev->n_erased_blocks < 1) {
+		/* Hoosterman we've got a problem.
+		 * Can't get space to gc
+		 */
+		yaffs_trace(YAFFS_TRACE_ERROR,
+		  "yaffs tragedy: no more erased blocks");
+
+		return -1;
+	}
+
+	/* Find an empty block. */
+
+	for (i = dev->internal_start_block; i <= dev->internal_end_block; i++) {
+		dev->alloc_block_finder++;
+		if (dev->alloc_block_finder < (int)dev->internal_start_block
+		    || dev->alloc_block_finder > (int)dev->internal_end_block) {
+			dev->alloc_block_finder = dev->internal_start_block;
+		}
+
+		bi = yaffs_get_block_info(dev, dev->alloc_block_finder);
+
+		if (bi->block_state == YAFFS_BLOCK_STATE_EMPTY) {
+			bi->block_state = YAFFS_BLOCK_STATE_ALLOCATING;
+			dev->seq_number++;
+			bi->seq_number = dev->seq_number;
+			dev->n_erased_blocks--;
+			yaffs_trace(YAFFS_TRACE_ALLOCATE,
+			  "Allocated block %d, seq  %d, %d left" ,
+			   dev->alloc_block_finder, dev->seq_number,
+			   dev->n_erased_blocks);
+			return dev->alloc_block_finder;
+		}
+	}
+
+	yaffs_trace(YAFFS_TRACE_ALWAYS,
+		"yaffs tragedy: no more erased blocks, but there should have been %d",
+		dev->n_erased_blocks);
+
+	return -1;
+}
+
+static int yaffs_alloc_chunk(struct yaffs_dev *dev, int use_reserver,
+			     struct yaffs_block_info **block_ptr)
+{
+	int ret_val;
+	struct yaffs_block_info *bi;
+
+	if (dev->alloc_block < 0) {
+		/* Get next block to allocate off */
+		dev->alloc_block = yaffs_find_alloc_block(dev);
+		dev->alloc_page = 0;
+	}
+
+	if (!use_reserver && !yaffs_check_alloc_available(dev, 1)) {
+		/* No space unless we're allowed to use the reserve. */
+		return -1;
+	}
+
+	if (dev->n_erased_blocks < (int)dev->param.n_reserved_blocks
+	    && dev->alloc_page == 0)
+		yaffs_trace(YAFFS_TRACE_ALLOCATE, "Allocating reserve");
+
+	/* Next page please.... */
+	if (dev->alloc_block >= 0) {
+		bi = yaffs_get_block_info(dev, dev->alloc_block);
+
+		ret_val = (dev->alloc_block * dev->param.chunks_per_block) +
+		    dev->alloc_page;
+		bi->pages_in_use++;
+		yaffs_set_chunk_bit(dev, dev->alloc_block, dev->alloc_page);
+
+		dev->alloc_page++;
+
+		dev->n_free_chunks--;
+
+		/* If the block is full set the state to full */
+		if (dev->alloc_page >= dev->param.chunks_per_block) {
+			bi->block_state = YAFFS_BLOCK_STATE_FULL;
+			dev->alloc_block = -1;
+		}
+
+		if (block_ptr)
+			*block_ptr = bi;
+
+		return ret_val;
+	}
+
+	yaffs_trace(YAFFS_TRACE_ERROR,
+		"!!!!!!!!! Allocator out !!!!!!!!!!!!!!!!!");
+
+	return -1;
+}
+
+static int yaffs_get_erased_chunks(struct yaffs_dev *dev)
+{
+	int n;
+
+	n = dev->n_erased_blocks * dev->param.chunks_per_block;
+
+	if (dev->alloc_block > 0)
+		n += (dev->param.chunks_per_block - dev->alloc_page);
+
+	return n;
+
+}
+
+/*
+ * yaffs_skip_rest_of_block() skips over the rest of the allocation block
+ * if we don't want to write to it.
+ */
+void yaffs_skip_rest_of_block(struct yaffs_dev *dev)
+{
+	struct yaffs_block_info *bi;
+
+	if (dev->alloc_block > 0) {
+		bi = yaffs_get_block_info(dev, dev->alloc_block);
+		if (bi->block_state == YAFFS_BLOCK_STATE_ALLOCATING) {
+			bi->block_state = YAFFS_BLOCK_STATE_FULL;
+			dev->alloc_block = -1;
+		}
+	}
+}
+
+static int yaffs_write_new_chunk(struct yaffs_dev *dev,
+				 const u8 *data,
+				 struct yaffs_ext_tags *tags, int use_reserver)
+{
+	u32 attempts = 0;
+	int write_ok = 0;
+	int chunk;
+
+	yaffs2_checkpt_invalidate(dev);
+
+	do {
+		struct yaffs_block_info *bi = 0;
+		int erased_ok = 0;
+
+		chunk = yaffs_alloc_chunk(dev, use_reserver, &bi);
+		if (chunk < 0) {
+			/* no space */
+			break;
+		}
+
+		/* First check this chunk is erased, if it needs
+		 * checking.  The checking policy (unless forced
+		 * always on) is as follows:
+		 *
+		 * Check the first page we try to write in a block.
+		 * If the check passes then we don't need to check any
+		 * more.        If the check fails, we check again...
+		 * If the block has been erased, we don't need to check.
+		 *
+		 * However, if the block has been prioritised for gc,
+		 * then we think there might be something odd about
+		 * this block and stop using it.
+		 *
+		 * Rationale: We should only ever see chunks that have
+		 * not been erased if there was a partially written
+		 * chunk due to power loss.  This checking policy should
+		 * catch that case with very few checks and thus save a
+		 * lot of checks that are most likely not needed.
+		 *
+		 * Mods to the above
+		 * If an erase check fails or the write fails we skip the
+		 * rest of the block.
+		 */
+
+		/* let's give it a try */
+		attempts++;
+
+		if (dev->param.always_check_erased)
+			bi->skip_erased_check = 0;
+
+		if (!bi->skip_erased_check) {
+			erased_ok = yaffs_check_chunk_erased(dev, chunk);
+			if (erased_ok != YAFFS_OK) {
+				yaffs_trace(YAFFS_TRACE_ERROR,
+				  "**>> yaffs chunk %d was not erased",
+				  chunk);
+
+				/* If not erased, delete this one,
+				 * skip rest of block and
+				 * try another chunk */
+				yaffs_chunk_del(dev, chunk, 1, __LINE__);
+				yaffs_skip_rest_of_block(dev);
+				continue;
+			}
+		}
+
+		write_ok = yaffs_wr_chunk_tags_nand(dev, chunk, data, tags);
+
+		if (!bi->skip_erased_check)
+			write_ok =
+			    yaffs_verify_chunk_written(dev, chunk, data, tags);
+
+		if (write_ok != YAFFS_OK) {
+			/* Clean up aborted write, skip to next block and
+			 * try another chunk */
+			yaffs_handle_chunk_wr_error(dev, chunk, erased_ok);
+			continue;
+		}
+
+		bi->skip_erased_check = 1;
+
+		/* Copy the data into the robustification buffer */
+		yaffs_handle_chunk_wr_ok(dev, chunk, data, tags);
+
+	} while (write_ok != YAFFS_OK &&
+		 (yaffs_wr_attempts == 0 || attempts <= yaffs_wr_attempts));
+
+	if (!write_ok)
+		chunk = -1;
+
+	if (attempts > 1) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"**>> yaffs write required %d attempts",
+			attempts);
+		dev->n_retried_writes += (attempts - 1);
+	}
+
+	return chunk;
+}
+
+/*
+ * Block retiring for handling a broken block.
+ */
+
+static void yaffs_retire_block(struct yaffs_dev *dev, int flash_block)
+{
+	struct yaffs_block_info *bi = yaffs_get_block_info(dev, flash_block);
+
+	yaffs2_checkpt_invalidate(dev);
+
+	yaffs2_clear_oldest_dirty_seq(dev, bi);
+
+	if (yaffs_mark_bad(dev, flash_block) != YAFFS_OK) {
+		if (yaffs_erase_block(dev, flash_block) != YAFFS_OK) {
+			yaffs_trace(YAFFS_TRACE_ALWAYS,
+				"yaffs: Failed to mark bad and erase block %d",
+				flash_block);
+		} else {
+			struct yaffs_ext_tags tags;
+			int chunk_id =
+			    flash_block * dev->param.chunks_per_block;
+
+			u8 *buffer = yaffs_get_temp_buffer(dev);
+
+			memset(buffer, 0xff, dev->data_bytes_per_chunk);
+			memset(&tags, 0, sizeof(tags));
+			tags.seq_number = YAFFS_SEQUENCE_BAD_BLOCK;
+			if (dev->tagger.write_chunk_tags_fn(dev, chunk_id -
+							dev->chunk_offset,
+							buffer,
+							&tags) != YAFFS_OK)
+				yaffs_trace(YAFFS_TRACE_ALWAYS,
+					"yaffs: Failed to write bad block marker to block %d",
+					flash_block);
+
+			yaffs_release_temp_buffer(dev, buffer);
+		}
+	}
+
+	bi->block_state = YAFFS_BLOCK_STATE_DEAD;
+	bi->gc_prioritise = 0;
+	bi->needs_retiring = 0;
+
+	dev->n_retired_blocks++;
+}
+
+/*---------------- Name handling functions ------------*/
+
+static void yaffs_load_name_from_oh(struct yaffs_dev *dev, YCHAR *name,
+				    const YCHAR *oh_name, int buff_size)
+{
+#ifdef CONFIG_YAFFS_AUTO_UNICODE
+	if (dev->param.auto_unicode) {
+		if (*oh_name) {
+			/* It is an ASCII name, do an ASCII to
+			 * unicode conversion */
+			const char *ascii_oh_name = (const char *)oh_name;
+			int n = buff_size - 1;
+			while (n > 0 && *ascii_oh_name) {
+				*name = *ascii_oh_name;
+				name++;
+				ascii_oh_name++;
+				n--;
+			}
+		} else {
+			strncpy(name, oh_name + 1, buff_size - 1);
+		}
+	} else {
+#else
+	(void) dev;
+	{
+#endif
+		strncpy(name, oh_name, buff_size - 1);
+	}
+}
+
+static void yaffs_load_oh_from_name(struct yaffs_dev *dev, YCHAR *oh_name,
+				    const YCHAR *name)
+{
+#ifdef CONFIG_YAFFS_AUTO_UNICODE
+
+	int is_ascii;
+	const YCHAR *w;
+
+	if (dev->param.auto_unicode) {
+
+		is_ascii = 1;
+		w = name;
+
+		/* Figure out if the name will fit in ascii character set */
+		while (is_ascii && *w) {
+			if ((*w) & 0xff00)
+				is_ascii = 0;
+			w++;
+		}
+
+		if (is_ascii) {
+			/* It is an ASCII name, so convert unicode to ascii */
+			char *ascii_oh_name = (char *)oh_name;
+			int n = YAFFS_MAX_NAME_LENGTH - 1;
+			while (n > 0 && *name) {
+				*ascii_oh_name = *name;
+				name++;
+				ascii_oh_name++;
+				n--;
+			}
+		} else {
+			/* Unicode name, so save starting at the second YCHAR */
+			*oh_name = 0;
+			strncpy(oh_name + 1, name, YAFFS_MAX_NAME_LENGTH - 2);
+		}
+	} else {
+#else
+	dev = dev;
+	{
+#endif
+		strncpy(oh_name, name, YAFFS_MAX_NAME_LENGTH - 1);
+	}
+}
+
+static u16 yaffs_calc_name_sum(const YCHAR *name)
+{
+	u16 sum = 0;
+	u16 i = 1;
+
+	if (!name)
+		return 0;
+
+	while ((*name) && i < (YAFFS_MAX_NAME_LENGTH / 2)) {
+
+		/* 0x1f mask is case insensitive */
+		sum += ((*name) & 0x1f) * i;
+		i++;
+		name++;
+	}
+	return sum;
+}
+
+
+void yaffs_set_obj_name(struct yaffs_obj *obj, const YCHAR * name)
+{
+	memset(obj->short_name, 0, sizeof(obj->short_name));
+
+	if (name && !name[0]) {
+		yaffs_fix_null_name(obj, obj->short_name,
+				YAFFS_SHORT_NAME_LENGTH);
+		name = obj->short_name;
+	} else if (name &&
+		strnlen(name, YAFFS_SHORT_NAME_LENGTH + 1) <=
+		YAFFS_SHORT_NAME_LENGTH)  {
+		strcpy(obj->short_name, name);
+	}
+
+	obj->sum = yaffs_calc_name_sum(name);
+}
+
+void yaffs_set_obj_name_from_oh(struct yaffs_obj *obj,
+				const struct yaffs_obj_hdr *oh)
+{
+#ifdef CONFIG_YAFFS_AUTO_UNICODE
+	YCHAR tmp_name[YAFFS_MAX_NAME_LENGTH + 1];
+	memset(tmp_name, 0, sizeof(tmp_name));
+	yaffs_load_name_from_oh(obj->my_dev, tmp_name, oh->name,
+				YAFFS_MAX_NAME_LENGTH + 1);
+	yaffs_set_obj_name(obj, tmp_name);
+#else
+	yaffs_set_obj_name(obj, oh->name);
+#endif
+}
+
+loff_t yaffs_max_file_size(struct yaffs_dev *dev)
+{
+	if (sizeof(loff_t) < 8)
+		return YAFFS_MAX_FILE_SIZE_32;
+	else
+		return ((loff_t) YAFFS_MAX_CHUNK_ID) * dev->data_bytes_per_chunk;
+}
+
+/*-------------------- TNODES -------------------
+
+ * List of spare tnodes
+ * The list is hooked together using the first pointer
+ * in the tnode.
+ */
+
+struct yaffs_tnode *yaffs_get_tnode(struct yaffs_dev *dev)
+{
+	struct yaffs_tnode *tn = yaffs_alloc_raw_tnode(dev);
+
+	if (tn) {
+		memset(tn, 0, dev->tnode_size);
+		dev->n_tnodes++;
+	}
+
+	dev->checkpoint_blocks_required = 0;	/* force recalculation */
+
+	return tn;
+}
+
+/* FreeTnode frees up a tnode and puts it back on the free list */
+static void yaffs_free_tnode(struct yaffs_dev *dev, struct yaffs_tnode *tn)
+{
+	yaffs_free_raw_tnode(dev, tn);
+	dev->n_tnodes--;
+	dev->checkpoint_blocks_required = 0;	/* force recalculation */
+}
+
+static void yaffs_deinit_tnodes_and_objs(struct yaffs_dev *dev)
+{
+	yaffs_deinit_raw_tnodes_and_objs(dev);
+	dev->n_obj = 0;
+	dev->n_tnodes = 0;
+}
+
+static void yaffs_load_tnode_0(struct yaffs_dev *dev, struct yaffs_tnode *tn,
+			unsigned pos, unsigned val)
+{
+	u32 *map = (u32 *) tn;
+	u32 bit_in_map;
+	u32 bit_in_word;
+	u32 word_in_map;
+	u32 mask;
+
+	pos &= YAFFS_TNODES_LEVEL0_MASK;
+	val >>= dev->chunk_grp_bits;
+
+	bit_in_map = pos * dev->tnode_width;
+	word_in_map = bit_in_map / 32;
+	bit_in_word = bit_in_map & (32 - 1);
+
+	mask = dev->tnode_mask << bit_in_word;
+
+	map[word_in_map] &= ~mask;
+	map[word_in_map] |= (mask & (val << bit_in_word));
+
+	if (dev->tnode_width > (32 - bit_in_word)) {
+		bit_in_word = (32 - bit_in_word);
+		word_in_map++;
+		mask =
+		    dev->tnode_mask >> bit_in_word;
+		map[word_in_map] &= ~mask;
+		map[word_in_map] |= (mask & (val >> bit_in_word));
+	}
+}
+
+u32 yaffs_get_group_base(struct yaffs_dev *dev, struct yaffs_tnode *tn,
+			 unsigned pos)
+{
+	u32 *map = (u32 *) tn;
+	u32 bit_in_map;
+	u32 bit_in_word;
+	u32 word_in_map;
+	u32 val;
+
+	pos &= YAFFS_TNODES_LEVEL0_MASK;
+
+	bit_in_map = pos * dev->tnode_width;
+	word_in_map = bit_in_map / 32;
+	bit_in_word = bit_in_map & (32 - 1);
+
+	val = map[word_in_map] >> bit_in_word;
+
+	if (dev->tnode_width > (32 - bit_in_word)) {
+		bit_in_word = (32 - bit_in_word);
+		word_in_map++;
+		val |= (map[word_in_map] << bit_in_word);
+	}
+
+	val &= dev->tnode_mask;
+	val <<= dev->chunk_grp_bits;
+
+	return val;
+}
+
+/* ------------------- End of individual tnode manipulation -----------------*/
+
+/* ---------Functions to manipulate the look-up tree (made up of tnodes) ------
+ * The look up tree is represented by the top tnode and the number of top_level
+ * in the tree. 0 means only the level 0 tnode is in the tree.
+ */
+
+/* FindLevel0Tnode finds the level 0 tnode, if one exists. */
+struct yaffs_tnode *yaffs_find_tnode_0(struct yaffs_dev *dev,
+				       struct yaffs_file_var *file_struct,
+				       u32 chunk_id)
+{
+	struct yaffs_tnode *tn = file_struct->top;
+	u32 i;
+	int required_depth;
+	int level = file_struct->top_level;
+
+	(void) dev;
+
+	/* Check sane level and chunk Id */
+	if (level < 0 || level > YAFFS_TNODES_MAX_LEVEL)
+		return NULL;
+
+	if (chunk_id > YAFFS_MAX_CHUNK_ID)
+		return NULL;
+
+	/* First check we're tall enough (ie enough top_level) */
+
+	i = chunk_id >> YAFFS_TNODES_LEVEL0_BITS;
+	required_depth = 0;
+	while (i) {
+		i >>= YAFFS_TNODES_INTERNAL_BITS;
+		required_depth++;
+	}
+
+	if (required_depth > file_struct->top_level)
+		return NULL;	/* Not tall enough, so we can't find it */
+
+	/* Traverse down to level 0 */
+	while (level > 0 && tn) {
+		tn = tn->internal[(chunk_id >>
+				   (YAFFS_TNODES_LEVEL0_BITS +
+				    (level - 1) *
+				    YAFFS_TNODES_INTERNAL_BITS)) &
+				  YAFFS_TNODES_INTERNAL_MASK];
+		level--;
+	}
+
+	return tn;
+}
+
+/* add_find_tnode_0 finds the level 0 tnode if it exists,
+ * otherwise first expands the tree.
+ * This happens in two steps:
+ *  1. If the tree isn't tall enough, then make it taller.
+ *  2. Scan down the tree towards the level 0 tnode adding tnodes if required.
+ *
+ * Used when modifying the tree.
+ *
+ *  If the tn argument is NULL, then a fresh tnode will be added otherwise the
+ *  specified tn will be plugged into the ttree.
+ */
+
+struct yaffs_tnode *yaffs_add_find_tnode_0(struct yaffs_dev *dev,
+					   struct yaffs_file_var *file_struct,
+					   u32 chunk_id,
+					   struct yaffs_tnode *passed_tn)
+{
+	int required_depth;
+	int i;
+	int l;
+	struct yaffs_tnode *tn;
+	u32 x;
+
+	/* Check sane level and page Id */
+	if (file_struct->top_level < 0 ||
+	    file_struct->top_level > YAFFS_TNODES_MAX_LEVEL)
+		return NULL;
+
+	if (chunk_id > YAFFS_MAX_CHUNK_ID)
+		return NULL;
+
+	/* First check we're tall enough (ie enough top_level) */
+
+	x = chunk_id >> YAFFS_TNODES_LEVEL0_BITS;
+	required_depth = 0;
+	while (x) {
+		x >>= YAFFS_TNODES_INTERNAL_BITS;
+		required_depth++;
+	}
+
+	if (required_depth > file_struct->top_level) {
+		/* Not tall enough, gotta make the tree taller */
+		for (i = file_struct->top_level; i < required_depth; i++) {
+
+			tn = yaffs_get_tnode(dev);
+
+			if (tn) {
+				tn->internal[0] = file_struct->top;
+				file_struct->top = tn;
+				file_struct->top_level++;
+			} else {
+				yaffs_trace(YAFFS_TRACE_ERROR,
+					"yaffs: no more tnodes");
+				return NULL;
+			}
+		}
+	}
+
+	/* Traverse down to level 0, adding anything we need */
+
+	l = file_struct->top_level;
+	tn = file_struct->top;
+
+	if (l > 0) {
+		while (l > 0 && tn) {
+			x = (chunk_id >>
+			     (YAFFS_TNODES_LEVEL0_BITS +
+			      (l - 1) * YAFFS_TNODES_INTERNAL_BITS)) &
+			    YAFFS_TNODES_INTERNAL_MASK;
+
+			if ((l > 1) && !tn->internal[x]) {
+				/* Add missing non-level-zero tnode */
+				tn->internal[x] = yaffs_get_tnode(dev);
+				if (!tn->internal[x])
+					return NULL;
+			} else if (l == 1) {
+				/* Looking from level 1 at level 0 */
+				if (passed_tn) {
+					/* If we already have one, release it */
+					if (tn->internal[x])
+						yaffs_free_tnode(dev,
+							tn->internal[x]);
+					tn->internal[x] = passed_tn;
+
+				} else if (!tn->internal[x]) {
+					/* Don't have one, none passed in */
+					tn->internal[x] = yaffs_get_tnode(dev);
+					if (!tn->internal[x])
+						return NULL;
+				}
+			}
+
+			tn = tn->internal[x];
+			l--;
+		}
+	} else {
+		/* top is level 0 */
+		if (passed_tn) {
+			memcpy(tn, passed_tn,
+			       (dev->tnode_width * YAFFS_NTNODES_LEVEL0) / 8);
+			yaffs_free_tnode(dev, passed_tn);
+		}
+	}
+
+	return tn;
+}
+
+static int yaffs_tags_match(const struct yaffs_ext_tags *tags, int obj_id,
+			    int chunk_obj)
+{
+	return (tags->chunk_id == (u32)chunk_obj &&
+		tags->obj_id == (u32)obj_id &&
+		!tags->is_deleted) ? 1 : 0;
+
+}
+
+static int yaffs_find_chunk_in_group(struct yaffs_dev *dev, int the_chunk,
+					struct yaffs_ext_tags *tags, int obj_id,
+					int inode_chunk)
+{
+	int j;
+
+	for (j = 0; the_chunk && j < dev->chunk_grp_size; j++) {
+		if (yaffs_check_chunk_bit
+		    (dev, the_chunk / dev->param.chunks_per_block,
+		     the_chunk % dev->param.chunks_per_block)) {
+
+			if (dev->chunk_grp_size == 1)
+				return the_chunk;
+			else {
+				yaffs_rd_chunk_tags_nand(dev, the_chunk, NULL,
+							 tags);
+				if (yaffs_tags_match(tags,
+							obj_id, inode_chunk)) {
+					/* found it; */
+					return the_chunk;
+				}
+			}
+		}
+		the_chunk++;
+	}
+	return -1;
+}
+
+int yaffs_find_chunk_in_file(struct yaffs_obj *in, int inode_chunk,
+				    struct yaffs_ext_tags *tags)
+{
+	/*Get the Tnode, then get the level 0 offset chunk offset */
+	struct yaffs_tnode *tn;
+	int the_chunk = -1;
+	struct yaffs_ext_tags local_tags;
+	int ret_val = -1;
+	struct yaffs_dev *dev = in->my_dev;
+
+	if (!tags) {
+		/* Passed a NULL, so use our own tags space */
+		tags = &local_tags;
+	}
+
+	tn = yaffs_find_tnode_0(dev, &in->variant.file_variant, inode_chunk);
+
+	if (!tn)
+		return ret_val;
+
+	the_chunk = yaffs_get_group_base(dev, tn, inode_chunk);
+
+	ret_val = yaffs_find_chunk_in_group(dev, the_chunk, tags, in->obj_id,
+					      inode_chunk);
+	return ret_val;
+}
+
+static int yaffs_find_del_file_chunk(struct yaffs_obj *in, int inode_chunk,
+				     struct yaffs_ext_tags *tags)
+{
+	/* Get the Tnode, then get the level 0 offset chunk offset */
+	struct yaffs_tnode *tn;
+	int the_chunk = -1;
+	struct yaffs_ext_tags local_tags;
+	struct yaffs_dev *dev = in->my_dev;
+	int ret_val = -1;
+
+	if (!tags) {
+		/* Passed a NULL, so use our own tags space */
+		tags = &local_tags;
+	}
+
+	tn = yaffs_find_tnode_0(dev, &in->variant.file_variant, inode_chunk);
+
+	if (!tn)
+		return ret_val;
+
+	the_chunk = yaffs_get_group_base(dev, tn, inode_chunk);
+
+	ret_val = yaffs_find_chunk_in_group(dev, the_chunk, tags, in->obj_id,
+					      inode_chunk);
+
+	/* Delete the entry in the filestructure (if found) */
+	if (ret_val != -1)
+		yaffs_load_tnode_0(dev, tn, inode_chunk, 0);
+
+	return ret_val;
+}
+
+int yaffs_put_chunk_in_file(struct yaffs_obj *in, int inode_chunk,
+			    int nand_chunk, int in_scan)
+{
+	/* NB in_scan is zero unless scanning.
+	 * For forward scanning, in_scan is > 0;
+	 * for backward scanning in_scan is < 0
+	 *
+	 * nand_chunk = 0 is a dummy insert to make sure the tnodes are there.
+	 */
+
+	struct yaffs_tnode *tn;
+	struct yaffs_dev *dev = in->my_dev;
+	int existing_cunk;
+	struct yaffs_ext_tags existing_tags;
+	struct yaffs_ext_tags new_tags;
+	unsigned existing_serial, new_serial;
+
+	if (in->variant_type != YAFFS_OBJECT_TYPE_FILE) {
+		/* Just ignore an attempt at putting a chunk into a non-file
+		 * during scanning.
+		 * If it is not during Scanning then something went wrong!
+		 */
+		if (!in_scan) {
+			yaffs_trace(YAFFS_TRACE_ERROR,
+				"yaffs tragedy:attempt to put data chunk into a non-file"
+				);
+			BUG();
+		}
+
+		yaffs_chunk_del(dev, nand_chunk, 1, __LINE__);
+		return YAFFS_OK;
+	}
+
+	tn = yaffs_add_find_tnode_0(dev,
+				    &in->variant.file_variant,
+				    inode_chunk, NULL);
+	if (!tn)
+		return YAFFS_FAIL;
+
+	if (!nand_chunk)
+		/* Dummy insert, bail now */
+		return YAFFS_OK;
+
+	existing_cunk = yaffs_get_group_base(dev, tn, inode_chunk);
+
+	if (in_scan != 0) {
+		/* If we're scanning then we need to test for duplicates
+		 * NB This does not need to be efficient since it should only
+		 * happen when the power fails during a write, then only one
+		 * chunk should ever be affected.
+		 *
+		 * Correction for YAFFS2: This could happen quite a lot and we
+		 * need to think about efficiency! TODO
+		 * Update: For backward scanning we don't need to re-read tags
+		 * so this is quite cheap.
+		 */
+
+		if (existing_cunk > 0) {
+			/* NB Right now existing chunk will not be real
+			 * chunk_id if the chunk group size > 1
+			 * thus we have to do a FindChunkInFile to get the
+			 * real chunk id.
+			 *
+			 * We have a duplicate now we need to decide which
+			 * one to use:
+			 *
+			 * Backwards scanning YAFFS2: The old one is what
+			 * we use, dump the new one.
+			 * YAFFS1: Get both sets of tags and compare serial
+			 * numbers.
+			 */
+
+			if (in_scan > 0) {
+				/* Only do this for forward scanning */
+				yaffs_rd_chunk_tags_nand(dev,
+							 nand_chunk,
+							 NULL, &new_tags);
+
+				/* Do a proper find */
+				existing_cunk =
+				    yaffs_find_chunk_in_file(in, inode_chunk,
+							     &existing_tags);
+			}
+
+			if (existing_cunk <= 0) {
+				/*Hoosterman - how did this happen? */
+
+				yaffs_trace(YAFFS_TRACE_ERROR,
+					"yaffs tragedy: existing chunk < 0 in scan"
+					);
+
+			}
+
+			/* NB The deleted flags should be false, otherwise
+			 * the chunks will not be loaded during a scan
+			 */
+
+			if (in_scan > 0) {
+				new_serial = new_tags.serial_number;
+				existing_serial = existing_tags.serial_number;
+			}
+
+			if ((in_scan > 0) &&
+			    (existing_cunk <= 0 ||
+			     ((existing_serial + 1) & 3) == new_serial)) {
+				/* Forward scanning.
+				 * Use new
+				 * Delete the old one and drop through to
+				 * update the tnode
+				 */
+				yaffs_chunk_del(dev, existing_cunk, 1,
+						__LINE__);
+			} else {
+				/* Backward scanning or we want to use the
+				 * existing one
+				 * Delete the new one and return early so that
+				 * the tnode isn't changed
+				 */
+				yaffs_chunk_del(dev, nand_chunk, 1, __LINE__);
+				return YAFFS_OK;
+			}
+		}
+
+	}
+
+	if (existing_cunk == 0)
+		in->n_data_chunks++;
+
+	yaffs_load_tnode_0(dev, tn, inode_chunk, nand_chunk);
+
+	return YAFFS_OK;
+}
+
+static void yaffs_soft_del_chunk(struct yaffs_dev *dev, int chunk)
+{
+	struct yaffs_block_info *the_block;
+	unsigned block_no;
+
+	yaffs_trace(YAFFS_TRACE_DELETION, "soft delete chunk %d", chunk);
+
+	block_no = chunk / dev->param.chunks_per_block;
+	the_block = yaffs_get_block_info(dev, block_no);
+	if (the_block) {
+		the_block->soft_del_pages++;
+		dev->n_free_chunks++;
+		yaffs2_update_oldest_dirty_seq(dev, block_no, the_block);
+	}
+}
+
+/* SoftDeleteWorker scans backwards through the tnode tree and soft deletes all
+ * the chunks in the file.
+ * All soft deleting does is increment the block's softdelete count and pulls
+ * the chunk out of the tnode.
+ * Thus, essentially this is the same as DeleteWorker except that the chunks
+ * are soft deleted.
+ */
+
+static int yaffs_soft_del_worker(struct yaffs_obj *in, struct yaffs_tnode *tn,
+				 u32 level, int chunk_offset)
+{
+	int i;
+	int the_chunk;
+	int all_done = 1;
+	struct yaffs_dev *dev = in->my_dev;
+
+	if (!tn)
+		return 1;
+
+	if (level > 0) {
+		for (i = YAFFS_NTNODES_INTERNAL - 1;
+			all_done && i >= 0;
+			i--) {
+			if (tn->internal[i]) {
+				all_done =
+				    yaffs_soft_del_worker(in,
+					tn->internal[i],
+					level - 1,
+					(chunk_offset <<
+					YAFFS_TNODES_INTERNAL_BITS)
+					+ i);
+				if (all_done) {
+					yaffs_free_tnode(dev,
+						tn->internal[i]);
+					tn->internal[i] = NULL;
+				} else {
+					/* Can this happen? */
+				}
+			}
+		}
+		return (all_done) ? 1 : 0;
+	}
+
+	/* level 0 */
+	 for (i = YAFFS_NTNODES_LEVEL0 - 1; i >= 0; i--) {
+		the_chunk = yaffs_get_group_base(dev, tn, i);
+		if (the_chunk) {
+			yaffs_soft_del_chunk(dev, the_chunk);
+			yaffs_load_tnode_0(dev, tn, i, 0);
+		}
+	}
+	return 1;
+}
+
+static void yaffs_remove_obj_from_dir(struct yaffs_obj *obj)
+{
+	struct yaffs_dev *dev = obj->my_dev;
+	struct yaffs_obj *parent;
+
+	yaffs_verify_obj_in_dir(obj);
+	parent = obj->parent;
+
+	yaffs_verify_dir(parent);
+
+	if (dev && dev->param.remove_obj_fn)
+		dev->param.remove_obj_fn(obj);
+
+	list_del_init(&obj->siblings);
+	obj->parent = NULL;
+
+	yaffs_verify_dir(parent);
+}
+
+void yaffs_add_obj_to_dir(struct yaffs_obj *directory, struct yaffs_obj *obj)
+{
+	if (!directory) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"tragedy: Trying to add an object to a null pointer directory"
+			);
+		BUG();
+		return;
+	}
+	if (directory->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"tragedy: Trying to add an object to a non-directory"
+			);
+		BUG();
+	}
+
+	if (obj->siblings.prev == NULL) {
+		/* Not initialised */
+		BUG();
+	}
+
+	yaffs_verify_dir(directory);
+
+	yaffs_remove_obj_from_dir(obj);
+
+	/* Now add it */
+	list_add(&obj->siblings, &directory->variant.dir_variant.children);
+	obj->parent = directory;
+
+	if (directory == obj->my_dev->unlinked_dir
+	    || directory == obj->my_dev->del_dir) {
+		obj->unlinked = 1;
+		obj->my_dev->n_unlinked_files++;
+		obj->rename_allowed = 0;
+	}
+
+	yaffs_verify_dir(directory);
+	yaffs_verify_obj_in_dir(obj);
+}
+
+static int yaffs_change_obj_name(struct yaffs_obj *obj,
+				 struct yaffs_obj *new_dir,
+				 const YCHAR *new_name, int force, int shadows)
+{
+	int unlink_op;
+	int del_op;
+	struct yaffs_obj *existing_target;
+
+	if (new_dir == NULL)
+		new_dir = obj->parent;	/* use the old directory */
+
+	if (new_dir->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"tragedy: yaffs_change_obj_name: new_dir is not a directory"
+			);
+		BUG();
+	}
+
+	unlink_op = (new_dir == obj->my_dev->unlinked_dir);
+	del_op = (new_dir == obj->my_dev->del_dir);
+
+	existing_target = yaffs_find_by_name(new_dir, new_name);
+
+	/* If the object is a file going into the unlinked directory,
+	 *   then it is OK to just stuff it in since duplicate names are OK.
+	 *   else only proceed if the new name does not exist and we're putting
+	 *   it into a directory.
+	 */
+	if (!(unlink_op || del_op || force ||
+	      shadows > 0 || !existing_target) ||
+	      new_dir->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY)
+		return YAFFS_FAIL;
+
+	yaffs_set_obj_name(obj, new_name);
+	obj->dirty = 1;
+	yaffs_add_obj_to_dir(new_dir, obj);
+
+	if (unlink_op)
+		obj->unlinked = 1;
+
+	/* If it is a deletion then we mark it as a shrink for gc  */
+	if (yaffs_update_oh(obj, new_name, 0, del_op, shadows, NULL) >= 0)
+		return YAFFS_OK;
+
+	return YAFFS_FAIL;
+}
+
+/*------------------------ Short Operations Cache ------------------------------
+ *   In many situations where there is no high level buffering  a lot of
+ *   reads might be short sequential reads, and a lot of writes may be short
+ *   sequential writes. eg. scanning/writing a jpeg file.
+ *   In these cases, a short read/write cache can provide a huge perfomance
+ *   benefit with dumb-as-a-rock code.
+ *   In Linux, the page cache provides read buffering and the short op cache
+ *   provides write buffering.
+ *
+ *   There are a small number (~10) of cache chunks per device so that we don't
+ *   need a very intelligent search.
+ */
+
+static int yaffs_obj_cache_dirty(struct yaffs_obj *obj)
+{
+	struct yaffs_dev *dev = obj->my_dev;
+	int i;
+	struct yaffs_cache *cache;
+	int n_caches = obj->my_dev->param.n_caches;
+
+	for (i = 0; i < n_caches; i++) {
+		cache = &dev->cache[i];
+		if (cache->object == obj && cache->dirty)
+			return 1;
+	}
+
+	return 0;
+}
+
+static void yaffs_flush_single_cache(struct yaffs_cache *cache, int discard)
+{
+
+	if (!cache || cache->locked)
+		return;
+
+	/* Write it out and free it up  if need be.*/
+	if (cache->dirty) {
+		yaffs_wr_data_obj(cache->object,
+				  cache->chunk_id,
+				  cache->data,
+				  cache->n_bytes,
+				  1);
+
+		cache->dirty = 0;
+	}
+
+	if (discard)
+		cache->object = NULL;
+}
+
+static void yaffs_flush_file_cache(struct yaffs_obj *obj, int discard)
+{
+	struct yaffs_dev *dev = obj->my_dev;
+	int i;
+	struct yaffs_cache *cache;
+	int n_caches = obj->my_dev->param.n_caches;
+
+	if (n_caches < 1)
+		return;
+
+
+	/* Find the chunks for this object and flush them. */
+	for (i = 0; i < n_caches; i++) {
+		cache = &dev->cache[i];
+		if (cache->object == obj)
+			yaffs_flush_single_cache(cache, discard);
+	}
+
+}
+
+
+void yaffs_flush_whole_cache(struct yaffs_dev *dev, int discard)
+{
+	struct yaffs_obj *obj;
+	int n_caches = dev->param.n_caches;
+	int i;
+
+	/* Find a dirty object in the cache and flush it...
+	 * until there are no further dirty objects.
+	 */
+	do {
+		obj = NULL;
+		for (i = 0; i < n_caches && !obj; i++) {
+			if (dev->cache[i].object && dev->cache[i].dirty)
+				obj = dev->cache[i].object;
+		}
+		if (obj)
+			yaffs_flush_file_cache(obj, discard);
+	} while (obj);
+
+}
+
+/* Grab us an unused cache chunk for use.
+ * First look for an empty one.
+ * Then look for the least recently used non-dirty one.
+ * Then look for the least recently used dirty one...., flush and look again.
+ */
+static struct yaffs_cache *yaffs_grab_chunk_worker(struct yaffs_dev *dev)
+{
+	u32 i;
+
+	if (dev->param.n_caches > 0) {
+		for (i = 0; i < dev->param.n_caches; i++) {
+			if (!dev->cache[i].object)
+				return &dev->cache[i];
+		}
+	}
+
+	return NULL;
+}
+
+static struct yaffs_cache *yaffs_grab_chunk_cache(struct yaffs_dev *dev)
+{
+	struct yaffs_cache *cache;
+	int usage;
+	u32 i;
+
+	if (dev->param.n_caches < 1)
+		return NULL;
+
+	/* First look for an unused cache */
+
+	cache = yaffs_grab_chunk_worker(dev);
+
+	if (cache)
+		return cache;
+
+	/*
+	 * Thery were all in use.
+	 * Find the LRU cache and flush it if it is dirty.
+	 */
+
+	usage = -1;
+	cache = NULL;
+
+	for (i = 0; i < dev->param.n_caches; i++) {
+		if (dev->cache[i].object &&
+		    !dev->cache[i].locked &&
+		    (dev->cache[i].last_use < usage || !cache)) {
+				usage = dev->cache[i].last_use;
+				cache = &dev->cache[i];
+		}
+	}
+
+#if 1
+	yaffs_flush_single_cache(cache, 1);
+#else
+	yaffs_flush_file_cache(cache->object, 1);
+	cache = yaffs_grab_chunk_worker(dev);
+#endif
+
+	return cache;
+}
+
+/* Find a cached chunk */
+static struct yaffs_cache *yaffs_find_chunk_cache(const struct yaffs_obj *obj,
+						  int chunk_id)
+{
+	struct yaffs_dev *dev = obj->my_dev;
+	u32 i;
+
+	if (dev->param.n_caches < 1)
+		return NULL;
+
+	for (i = 0; i < dev->param.n_caches; i++) {
+		if (dev->cache[i].object == obj &&
+		    dev->cache[i].chunk_id == chunk_id) {
+			dev->cache_hits++;
+
+			return &dev->cache[i];
+		}
+	}
+	return NULL;
+}
+
+/* Mark the chunk for the least recently used algorithym */
+static void yaffs_use_cache(struct yaffs_dev *dev, struct yaffs_cache *cache,
+			    int is_write)
+{
+	u32 i;
+
+	if (dev->param.n_caches < 1)
+		return;
+
+	if (dev->cache_last_use < 0 ||
+		dev->cache_last_use > 100000000) {
+		/* Reset the cache usages */
+		for (i = 1; i < dev->param.n_caches; i++)
+			dev->cache[i].last_use = 0;
+
+		dev->cache_last_use = 0;
+	}
+	dev->cache_last_use++;
+	cache->last_use = dev->cache_last_use;
+
+	if (is_write)
+		cache->dirty = 1;
+}
+
+/* Invalidate a single cache page.
+ * Do this when a whole page gets written,
+ * ie the short cache for this page is no longer valid.
+ */
+static void yaffs_invalidate_chunk_cache(struct yaffs_obj *object, int chunk_id)
+{
+	struct yaffs_cache *cache;
+
+	if (object->my_dev->param.n_caches > 0) {
+		cache = yaffs_find_chunk_cache(object, chunk_id);
+
+		if (cache)
+			cache->object = NULL;
+	}
+}
+
+/* Invalidate all the cache pages associated with this object
+ * Do this whenever ther file is deleted or resized.
+ */
+static void yaffs_invalidate_whole_cache(struct yaffs_obj *in)
+{
+	u32 i;
+	struct yaffs_dev *dev = in->my_dev;
+
+	if (dev->param.n_caches > 0) {
+		/* Invalidate it. */
+		for (i = 0; i < dev->param.n_caches; i++) {
+			if (dev->cache[i].object == in)
+				dev->cache[i].object = NULL;
+		}
+	}
+}
+
+static void yaffs_unhash_obj(struct yaffs_obj *obj)
+{
+	int bucket;
+	struct yaffs_dev *dev = obj->my_dev;
+
+	/* If it is still linked into the bucket list, free from the list */
+	if (!list_empty(&obj->hash_link)) {
+		list_del_init(&obj->hash_link);
+		bucket = yaffs_hash_fn(obj->obj_id);
+		dev->obj_bucket[bucket].count--;
+	}
+}
+
+/*  FreeObject frees up a Object and puts it back on the free list */
+static void yaffs_free_obj(struct yaffs_obj *obj)
+{
+	struct yaffs_dev *dev;
+
+	if (!obj) {
+		BUG();
+		return;
+	}
+	dev = obj->my_dev;
+	yaffs_trace(YAFFS_TRACE_OS, "FreeObject %p inode %p",
+		obj, obj->my_inode);
+	if (obj->parent)
+		BUG();
+	if (!list_empty(&obj->siblings))
+		BUG();
+
+	if (obj->my_inode) {
+		/* We're still hooked up to a cached inode.
+		 * Don't delete now, but mark for later deletion
+		 */
+		obj->defered_free = 1;
+		return;
+	}
+
+	yaffs_unhash_obj(obj);
+
+	yaffs_free_raw_obj(dev, obj);
+	dev->n_obj--;
+	dev->checkpoint_blocks_required = 0;	/* force recalculation */
+}
+
+void yaffs_handle_defered_free(struct yaffs_obj *obj)
+{
+	if (obj->defered_free)
+		yaffs_free_obj(obj);
+}
+
+static int yaffs_generic_obj_del(struct yaffs_obj *in)
+{
+	/* Iinvalidate the file's data in the cache, without flushing. */
+	yaffs_invalidate_whole_cache(in);
+
+	if (in->my_dev->param.is_yaffs2 && in->parent != in->my_dev->del_dir) {
+		/* Move to unlinked directory so we have a deletion record */
+		yaffs_change_obj_name(in, in->my_dev->del_dir, _Y("deleted"), 0,
+				      0);
+	}
+
+	yaffs_remove_obj_from_dir(in);
+	yaffs_chunk_del(in->my_dev, in->hdr_chunk, 1, __LINE__);
+	in->hdr_chunk = 0;
+
+	yaffs_free_obj(in);
+	return YAFFS_OK;
+
+}
+
+static void yaffs_soft_del_file(struct yaffs_obj *obj)
+{
+	if (!obj->deleted ||
+	    obj->variant_type != YAFFS_OBJECT_TYPE_FILE ||
+	    obj->soft_del)
+		return;
+
+	if (obj->n_data_chunks <= 0) {
+		/* Empty file with no duplicate object headers,
+		 * just delete it immediately */
+		yaffs_free_tnode(obj->my_dev, obj->variant.file_variant.top);
+		obj->variant.file_variant.top = NULL;
+		yaffs_trace(YAFFS_TRACE_TRACING,
+			"yaffs: Deleting empty file %d",
+			obj->obj_id);
+		yaffs_generic_obj_del(obj);
+	} else {
+		yaffs_soft_del_worker(obj,
+				      obj->variant.file_variant.top,
+				      obj->variant.
+				      file_variant.top_level, 0);
+		obj->soft_del = 1;
+	}
+}
+
+/* Pruning removes any part of the file structure tree that is beyond the
+ * bounds of the file (ie that does not point to chunks).
+ *
+ * A file should only get pruned when its size is reduced.
+ *
+ * Before pruning, the chunks must be pulled from the tree and the
+ * level 0 tnode entries must be zeroed out.
+ * Could also use this for file deletion, but that's probably better handled
+ * by a special case.
+ *
+ * This function is recursive. For levels > 0 the function is called again on
+ * any sub-tree. For level == 0 we just check if the sub-tree has data.
+ * If there is no data in a subtree then it is pruned.
+ */
+
+static struct yaffs_tnode *yaffs_prune_worker(struct yaffs_dev *dev,
+					      struct yaffs_tnode *tn, u32 level,
+					      int del0)
+{
+	int i;
+	int has_data;
+
+	if (!tn)
+		return tn;
+
+	has_data = 0;
+
+	if (level > 0) {
+		for (i = 0; i < YAFFS_NTNODES_INTERNAL; i++) {
+			if (tn->internal[i]) {
+				tn->internal[i] =
+				    yaffs_prune_worker(dev,
+						tn->internal[i],
+						level - 1,
+						(i == 0) ? del0 : 1);
+			}
+
+			if (tn->internal[i])
+				has_data++;
+		}
+	} else {
+		int tnode_size_u32 = dev->tnode_size / sizeof(u32);
+		u32 *map = (u32 *) tn;
+
+		for (i = 0; !has_data && i < tnode_size_u32; i++) {
+			if (map[i])
+				has_data++;
+		}
+	}
+
+	if (has_data == 0 && del0) {
+		/* Free and return NULL */
+		yaffs_free_tnode(dev, tn);
+		tn = NULL;
+	}
+	return tn;
+}
+
+static int yaffs_prune_tree(struct yaffs_dev *dev,
+			    struct yaffs_file_var *file_struct)
+{
+	int i;
+	int has_data;
+	int done = 0;
+	struct yaffs_tnode *tn;
+
+	if (file_struct->top_level < 1)
+		return YAFFS_OK;
+
+	file_struct->top =
+	   yaffs_prune_worker(dev, file_struct->top, file_struct->top_level, 0);
+
+	/* Now we have a tree with all the non-zero branches NULL but
+	 * the height is the same as it was.
+	 * Let's see if we can trim internal tnodes to shorten the tree.
+	 * We can do this if only the 0th element in the tnode is in use
+	 * (ie all the non-zero are NULL)
+	 */
+
+	while (file_struct->top_level && !done) {
+		tn = file_struct->top;
+
+		has_data = 0;
+		for (i = 1; i < YAFFS_NTNODES_INTERNAL; i++) {
+			if (tn->internal[i])
+				has_data++;
+		}
+
+		if (!has_data) {
+			file_struct->top = tn->internal[0];
+			file_struct->top_level--;
+			yaffs_free_tnode(dev, tn);
+		} else {
+			done = 1;
+		}
+	}
+
+	return YAFFS_OK;
+}
+
+/*-------------------- End of File Structure functions.-------------------*/
+
+/* alloc_empty_obj gets us a clean Object.*/
+static struct yaffs_obj *yaffs_alloc_empty_obj(struct yaffs_dev *dev)
+{
+	struct yaffs_obj *obj = yaffs_alloc_raw_obj(dev);
+
+	if (!obj)
+		return obj;
+
+	dev->n_obj++;
+
+	/* Now sweeten it up... */
+
+	memset(obj, 0, sizeof(struct yaffs_obj));
+	obj->being_created = 1;
+
+	obj->my_dev = dev;
+	obj->hdr_chunk = 0;
+	obj->variant_type = YAFFS_OBJECT_TYPE_UNKNOWN;
+	INIT_LIST_HEAD(&(obj->hard_links));
+	INIT_LIST_HEAD(&(obj->hash_link));
+	INIT_LIST_HEAD(&obj->siblings);
+
+	/* Now make the directory sane */
+	if (dev->root_dir) {
+		obj->parent = dev->root_dir;
+		list_add(&(obj->siblings),
+			 &dev->root_dir->variant.dir_variant.children);
+	}
+
+	/* Add it to the lost and found directory.
+	 * NB Can't put root or lost-n-found in lost-n-found so
+	 * check if lost-n-found exists first
+	 */
+	if (dev->lost_n_found)
+		yaffs_add_obj_to_dir(dev->lost_n_found, obj);
+
+	obj->being_created = 0;
+
+	dev->checkpoint_blocks_required = 0;	/* force recalculation */
+
+	return obj;
+}
+
+static int yaffs_find_nice_bucket(struct yaffs_dev *dev)
+{
+	int i;
+	int l = 999;
+	int lowest = 999999;
+
+	/* Search for the shortest list or one that
+	 * isn't too long.
+	 */
+
+	for (i = 0; i < 10 && lowest > 4; i++) {
+		dev->bucket_finder++;
+		dev->bucket_finder %= YAFFS_NOBJECT_BUCKETS;
+		if (dev->obj_bucket[dev->bucket_finder].count < lowest) {
+			lowest = dev->obj_bucket[dev->bucket_finder].count;
+			l = dev->bucket_finder;
+		}
+	}
+
+	return l;
+}
+
+static int yaffs_new_obj_id(struct yaffs_dev *dev)
+{
+	int bucket = yaffs_find_nice_bucket(dev);
+	int found = 0;
+	struct list_head *i;
+	u32 n = (u32) bucket;
+
+	/*
+	 * Now find an object value that has not already been taken
+	 * by scanning the list, incrementing each time by number of buckets.
+	 */
+	while (!found) {
+		found = 1;
+		n += YAFFS_NOBJECT_BUCKETS;
+		list_for_each(i, &dev->obj_bucket[bucket].list) {
+			/* Check if this value is already taken. */
+			if (i && list_entry(i, struct yaffs_obj,
+					    hash_link)->obj_id == n)
+				found = 0;
+		}
+	}
+	return n;
+}
+
+static void yaffs_hash_obj(struct yaffs_obj *in)
+{
+	int bucket = yaffs_hash_fn(in->obj_id);
+	struct yaffs_dev *dev = in->my_dev;
+
+	list_add(&in->hash_link, &dev->obj_bucket[bucket].list);
+	dev->obj_bucket[bucket].count++;
+}
+
+struct yaffs_obj *yaffs_find_by_number(struct yaffs_dev *dev, u32 number)
+{
+	int bucket = yaffs_hash_fn(number);
+	struct list_head *i;
+	struct yaffs_obj *in;
+
+	list_for_each(i, &dev->obj_bucket[bucket].list) {
+		/* Look if it is in the list */
+		in = list_entry(i, struct yaffs_obj, hash_link);
+		if (in->obj_id == number) {
+			/* Don't show if it is defered free */
+			if (in->defered_free)
+				return NULL;
+			return in;
+		}
+	}
+
+	return NULL;
+}
+
+static struct yaffs_obj *yaffs_new_obj(struct yaffs_dev *dev, int number,
+				enum yaffs_obj_type type)
+{
+	struct yaffs_obj *the_obj = NULL;
+	struct yaffs_tnode *tn = NULL;
+
+	if (number < 0)
+		number = yaffs_new_obj_id(dev);
+
+	if (type == YAFFS_OBJECT_TYPE_FILE) {
+		tn = yaffs_get_tnode(dev);
+		if (!tn)
+			return NULL;
+	}
+
+	the_obj = yaffs_alloc_empty_obj(dev);
+	if (!the_obj) {
+		if (tn)
+			yaffs_free_tnode(dev, tn);
+		return NULL;
+	}
+
+	the_obj->fake = 0;
+	the_obj->rename_allowed = 1;
+	the_obj->unlink_allowed = 1;
+	the_obj->obj_id = number;
+	yaffs_hash_obj(the_obj);
+	the_obj->variant_type = type;
+	yaffs_load_current_time(the_obj, 1, 1);
+
+	switch (type) {
+	case YAFFS_OBJECT_TYPE_FILE:
+		the_obj->variant.file_variant.file_size = 0;
+		the_obj->variant.file_variant.stored_size = 0;
+		the_obj->variant.file_variant.shrink_size =
+						yaffs_max_file_size(dev);
+		the_obj->variant.file_variant.top_level = 0;
+		the_obj->variant.file_variant.top = tn;
+		break;
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+		INIT_LIST_HEAD(&the_obj->variant.dir_variant.children);
+		INIT_LIST_HEAD(&the_obj->variant.dir_variant.dirty);
+		break;
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+	case YAFFS_OBJECT_TYPE_SPECIAL:
+		/* No action required */
+		break;
+	case YAFFS_OBJECT_TYPE_UNKNOWN:
+		/* todo this should not happen */
+		break;
+	}
+	return the_obj;
+}
+
+static struct yaffs_obj *yaffs_create_fake_dir(struct yaffs_dev *dev,
+					       int number, u32 mode)
+{
+
+	struct yaffs_obj *obj =
+	    yaffs_new_obj(dev, number, YAFFS_OBJECT_TYPE_DIRECTORY);
+
+	if (!obj)
+		return NULL;
+
+	obj->fake = 1;	/* it is fake so it might not use NAND */
+	obj->rename_allowed = 0;
+	obj->unlink_allowed = 0;
+	obj->deleted = 0;
+	obj->unlinked = 0;
+	obj->yst_mode = mode;
+	obj->my_dev = dev;
+	obj->hdr_chunk = 0;	/* Not a valid chunk. */
+	return obj;
+
+}
+
+
+static void yaffs_init_tnodes_and_objs(struct yaffs_dev *dev)
+{
+	int i;
+
+	dev->n_obj = 0;
+	dev->n_tnodes = 0;
+	yaffs_init_raw_tnodes_and_objs(dev);
+
+	for (i = 0; i < YAFFS_NOBJECT_BUCKETS; i++) {
+		INIT_LIST_HEAD(&dev->obj_bucket[i].list);
+		dev->obj_bucket[i].count = 0;
+	}
+}
+
+struct yaffs_obj *yaffs_find_or_create_by_number(struct yaffs_dev *dev,
+						 int number,
+						 enum yaffs_obj_type type)
+{
+	struct yaffs_obj *the_obj = NULL;
+
+	if (number > 0)
+		the_obj = yaffs_find_by_number(dev, number);
+
+	if (!the_obj)
+		the_obj = yaffs_new_obj(dev, number, type);
+
+	return the_obj;
+
+}
+
+YCHAR *yaffs_clone_str(const YCHAR *str)
+{
+	YCHAR *new_str = NULL;
+	int len;
+
+	if (!str)
+		str = _Y("");
+
+	len = strnlen(str, YAFFS_MAX_ALIAS_LENGTH);
+	new_str = kmalloc((len + 1) * sizeof(YCHAR), GFP_NOFS);
+	if (new_str) {
+		strncpy(new_str, str, len);
+		new_str[len] = 0;
+	}
+	return new_str;
+
+}
+/*
+ *yaffs_update_parent() handles fixing a directories mtime and ctime when a new
+ * link (ie. name) is created or deleted in the directory.
+ *
+ * ie.
+ *   create dir/a : update dir's mtime/ctime
+ *   rm dir/a:   update dir's mtime/ctime
+ *   modify dir/a: don't update dir's mtimme/ctime
+ *
+ * This can be handled immediately or defered. Defering helps reduce the number
+ * of updates when many files in a directory are changed within a brief period.
+ *
+ * If the directory updating is defered then yaffs_update_dirty_dirs must be
+ * called periodically.
+ */
+
+static void yaffs_update_parent(struct yaffs_obj *obj)
+{
+	struct yaffs_dev *dev;
+
+	if (!obj)
+		return;
+	dev = obj->my_dev;
+	obj->dirty = 1;
+	yaffs_load_current_time(obj, 0, 1);
+	if (dev->param.defered_dir_update) {
+		struct list_head *link = &obj->variant.dir_variant.dirty;
+
+		if (list_empty(link)) {
+			list_add(link, &dev->dirty_dirs);
+			yaffs_trace(YAFFS_TRACE_BACKGROUND,
+			  "Added object %d to dirty directories",
+			   obj->obj_id);
+		}
+
+	} else {
+		yaffs_update_oh(obj, NULL, 0, 0, 0, NULL);
+	}
+}
+
+void yaffs_update_dirty_dirs(struct yaffs_dev *dev)
+{
+	struct list_head *link;
+	struct yaffs_obj *obj;
+	struct yaffs_dir_var *d_s;
+	union yaffs_obj_var *o_v;
+
+	yaffs_trace(YAFFS_TRACE_BACKGROUND, "Update dirty directories");
+
+	while (!list_empty(&dev->dirty_dirs)) {
+		link = dev->dirty_dirs.next;
+		list_del_init(link);
+
+		d_s = list_entry(link, struct yaffs_dir_var, dirty);
+		o_v = list_entry(d_s, union yaffs_obj_var, dir_variant);
+		obj = list_entry(o_v, struct yaffs_obj, variant);
+
+		yaffs_trace(YAFFS_TRACE_BACKGROUND, "Update directory %d",
+			obj->obj_id);
+
+		if (obj->dirty)
+			yaffs_update_oh(obj, NULL, 0, 0, 0, NULL);
+	}
+}
+
+/*
+ * Mknod (create) a new object.
+ * equiv_obj only has meaning for a hard link;
+ * alias_str only has meaning for a symlink.
+ * rdev only has meaning for devices (a subset of special objects)
+ */
+
+static struct yaffs_obj *yaffs_create_obj(enum yaffs_obj_type type,
+					  struct yaffs_obj *parent,
+					  const YCHAR *name,
+					  u32 mode,
+					  u32 uid,
+					  u32 gid,
+					  struct yaffs_obj *equiv_obj,
+					  const YCHAR *alias_str, u32 rdev)
+{
+	struct yaffs_obj *in;
+	YCHAR *str = NULL;
+	struct yaffs_dev *dev = parent->my_dev;
+
+	/* Check if the entry exists.
+	 * If it does then fail the call since we don't want a dup. */
+	if (yaffs_find_by_name(parent, name))
+		return NULL;
+
+	if (type == YAFFS_OBJECT_TYPE_SYMLINK) {
+		str = yaffs_clone_str(alias_str);
+		if (!str)
+			return NULL;
+	}
+
+	in = yaffs_new_obj(dev, -1, type);
+
+	if (!in) {
+		kfree(str);
+		return NULL;
+	}
+
+	in->hdr_chunk = 0;
+	in->valid = 1;
+	in->variant_type = type;
+
+	in->yst_mode = mode;
+
+	yaffs_attribs_init(in, gid, uid, rdev);
+
+	in->n_data_chunks = 0;
+
+	yaffs_set_obj_name(in, name);
+	in->dirty = 1;
+
+	yaffs_add_obj_to_dir(parent, in);
+
+	in->my_dev = parent->my_dev;
+
+	switch (type) {
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+		in->variant.symlink_variant.alias = str;
+		break;
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+		in->variant.hardlink_variant.equiv_obj = equiv_obj;
+		in->variant.hardlink_variant.equiv_id = equiv_obj->obj_id;
+		list_add(&in->hard_links, &equiv_obj->hard_links);
+		break;
+	case YAFFS_OBJECT_TYPE_FILE:
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+	case YAFFS_OBJECT_TYPE_SPECIAL:
+	case YAFFS_OBJECT_TYPE_UNKNOWN:
+		/* do nothing */
+		break;
+	}
+
+	if (yaffs_update_oh(in, name, 0, 0, 0, NULL) < 0) {
+		/* Could not create the object header, fail */
+		yaffs_del_obj(in);
+		in = NULL;
+	}
+
+	if (in)
+		yaffs_update_parent(parent);
+
+	return in;
+}
+
+struct yaffs_obj *yaffs_create_file(struct yaffs_obj *parent,
+				    const YCHAR *name, u32 mode, u32 uid,
+				    u32 gid)
+{
+	return yaffs_create_obj(YAFFS_OBJECT_TYPE_FILE, parent, name, mode,
+				uid, gid, NULL, NULL, 0);
+}
+
+struct yaffs_obj *yaffs_create_dir(struct yaffs_obj *parent, const YCHAR *name,
+				   u32 mode, u32 uid, u32 gid)
+{
+	return yaffs_create_obj(YAFFS_OBJECT_TYPE_DIRECTORY, parent, name,
+				mode, uid, gid, NULL, NULL, 0);
+}
+
+struct yaffs_obj *yaffs_create_special(struct yaffs_obj *parent,
+				       const YCHAR *name, u32 mode, u32 uid,
+				       u32 gid, u32 rdev)
+{
+	return yaffs_create_obj(YAFFS_OBJECT_TYPE_SPECIAL, parent, name, mode,
+				uid, gid, NULL, NULL, rdev);
+}
+
+struct yaffs_obj *yaffs_create_symlink(struct yaffs_obj *parent,
+				       const YCHAR *name, u32 mode, u32 uid,
+				       u32 gid, const YCHAR *alias)
+{
+	return yaffs_create_obj(YAFFS_OBJECT_TYPE_SYMLINK, parent, name, mode,
+				uid, gid, NULL, alias, 0);
+}
+
+/* yaffs_link_obj returns the object id of the equivalent object.*/
+struct yaffs_obj *yaffs_link_obj(struct yaffs_obj *parent, const YCHAR * name,
+				 struct yaffs_obj *equiv_obj)
+{
+	/* Get the real object in case we were fed a hard link obj */
+	equiv_obj = yaffs_get_equivalent_obj(equiv_obj);
+
+	if (yaffs_create_obj(YAFFS_OBJECT_TYPE_HARDLINK,
+			parent, name, 0, 0, 0,
+			equiv_obj, NULL, 0))
+		return equiv_obj;
+
+	return NULL;
+
+}
+
+
+
+/*---------------------- Block Management and Page Allocation -------------*/
+
+static void yaffs_deinit_blocks(struct yaffs_dev *dev)
+{
+	if (dev->block_info_alt && dev->block_info)
+		vfree(dev->block_info);
+	else
+		kfree(dev->block_info);
+
+	dev->block_info_alt = 0;
+
+	dev->block_info = NULL;
+
+	if (dev->chunk_bits_alt && dev->chunk_bits)
+		vfree(dev->chunk_bits);
+	else
+		kfree(dev->chunk_bits);
+	dev->chunk_bits_alt = 0;
+	dev->chunk_bits = NULL;
+}
+
+static int yaffs_init_blocks(struct yaffs_dev *dev)
+{
+	int n_blocks = dev->internal_end_block - dev->internal_start_block + 1;
+
+	dev->block_info = NULL;
+	dev->chunk_bits = NULL;
+	dev->alloc_block = -1;	/* force it to get a new one */
+
+	/* If the first allocation strategy fails, thry the alternate one */
+	dev->block_info =
+		kmalloc(n_blocks * sizeof(struct yaffs_block_info), GFP_NOFS);
+	if (!dev->block_info) {
+		dev->block_info =
+		    vmalloc(n_blocks * sizeof(struct yaffs_block_info));
+		dev->block_info_alt = 1;
+	} else {
+		dev->block_info_alt = 0;
+	}
+
+	if (!dev->block_info)
+		goto alloc_error;
+
+	/* Set up dynamic blockinfo stuff. Round up bytes. */
+	dev->chunk_bit_stride = (dev->param.chunks_per_block + 7) / 8;
+	dev->chunk_bits =
+		kmalloc(dev->chunk_bit_stride * n_blocks, GFP_NOFS);
+	if (!dev->chunk_bits) {
+		dev->chunk_bits =
+		    vmalloc(dev->chunk_bit_stride * n_blocks);
+		dev->chunk_bits_alt = 1;
+	} else {
+		dev->chunk_bits_alt = 0;
+	}
+	if (!dev->chunk_bits)
+		goto alloc_error;
+
+
+	memset(dev->block_info, 0, n_blocks * sizeof(struct yaffs_block_info));
+	memset(dev->chunk_bits, 0, dev->chunk_bit_stride * n_blocks);
+	return YAFFS_OK;
+
+alloc_error:
+	yaffs_deinit_blocks(dev);
+	return YAFFS_FAIL;
+}
+
+
+void yaffs_block_became_dirty(struct yaffs_dev *dev, int block_no)
+{
+	struct yaffs_block_info *bi = yaffs_get_block_info(dev, block_no);
+	int erased_ok = 0;
+	u32 i;
+
+	/* If the block is still healthy erase it and mark as clean.
+	 * If the block has had a data failure, then retire it.
+	 */
+
+	yaffs_trace(YAFFS_TRACE_GC | YAFFS_TRACE_ERASE,
+		"yaffs_block_became_dirty block %d state %d %s",
+		block_no, bi->block_state,
+		(bi->needs_retiring) ? "needs retiring" : "");
+
+	yaffs2_clear_oldest_dirty_seq(dev, bi);
+
+	bi->block_state = YAFFS_BLOCK_STATE_DIRTY;
+
+	/* If this is the block being garbage collected then stop gc'ing */
+	if (block_no == (int)dev->gc_block)
+		dev->gc_block = 0;
+
+	/* If this block is currently the best candidate for gc
+	 * then drop as a candidate */
+	if (block_no == (int)dev->gc_dirtiest) {
+		dev->gc_dirtiest = 0;
+		dev->gc_pages_in_use = 0;
+	}
+
+	if (!bi->needs_retiring) {
+		yaffs2_checkpt_invalidate(dev);
+		erased_ok = yaffs_erase_block(dev, block_no);
+		if (!erased_ok) {
+			dev->n_erase_failures++;
+			yaffs_trace(YAFFS_TRACE_ERROR | YAFFS_TRACE_BAD_BLOCKS,
+			  "**>> Erasure failed %d", block_no);
+		}
+	}
+
+	/* Verify erasure if needed */
+	if (erased_ok &&
+	    ((yaffs_trace_mask & YAFFS_TRACE_ERASE) ||
+	     !yaffs_skip_verification(dev))) {
+		for (i = 0; i < dev->param.chunks_per_block; i++) {
+			if (!yaffs_check_chunk_erased(dev,
+				block_no * dev->param.chunks_per_block + i)) {
+				yaffs_trace(YAFFS_TRACE_ERROR,
+					">>Block %d erasure supposedly OK, but chunk %d not erased",
+					block_no, i);
+			}
+		}
+	}
+
+	if (!erased_ok) {
+		/* We lost a block of free space */
+		dev->n_free_chunks -= dev->param.chunks_per_block;
+		yaffs_retire_block(dev, block_no);
+		yaffs_trace(YAFFS_TRACE_ERROR | YAFFS_TRACE_BAD_BLOCKS,
+			"**>> Block %d retired", block_no);
+		return;
+	}
+
+	/* Clean it up... */
+	bi->block_state = YAFFS_BLOCK_STATE_EMPTY;
+	bi->seq_number = 0;
+	dev->n_erased_blocks++;
+	bi->pages_in_use = 0;
+	bi->soft_del_pages = 0;
+	bi->has_shrink_hdr = 0;
+	bi->skip_erased_check = 1;	/* Clean, so no need to check */
+	bi->gc_prioritise = 0;
+	bi->has_summary = 0;
+
+	yaffs_clear_chunk_bits(dev, block_no);
+
+	yaffs_trace(YAFFS_TRACE_ERASE, "Erased block %d", block_no);
+}
+
+static inline int yaffs_gc_process_chunk(struct yaffs_dev *dev,
+					struct yaffs_block_info *bi,
+					int old_chunk, u8 *buffer)
+{
+	int new_chunk;
+	int mark_flash = 1;
+	struct yaffs_ext_tags tags;
+	struct yaffs_obj *object;
+	int matching_chunk;
+	int ret_val = YAFFS_OK;
+
+	memset(&tags, 0, sizeof(tags));
+	yaffs_rd_chunk_tags_nand(dev, old_chunk,
+				 buffer, &tags);
+	object = yaffs_find_by_number(dev, tags.obj_id);
+
+	yaffs_trace(YAFFS_TRACE_GC_DETAIL,
+		"Collecting chunk in block %d, %d %d %d ",
+		dev->gc_chunk, tags.obj_id,
+		tags.chunk_id, tags.n_bytes);
+
+	if (object && !yaffs_skip_verification(dev)) {
+		if (tags.chunk_id == 0)
+			matching_chunk =
+			    object->hdr_chunk;
+		else if (object->soft_del)
+			/* Defeat the test */
+			matching_chunk = old_chunk;
+		else
+			matching_chunk =
+			    yaffs_find_chunk_in_file
+			    (object, tags.chunk_id,
+			     NULL);
+
+		if (old_chunk != matching_chunk)
+			yaffs_trace(YAFFS_TRACE_ERROR,
+				"gc: page in gc mismatch: %d %d %d %d",
+				old_chunk,
+				matching_chunk,
+				tags.obj_id,
+				tags.chunk_id);
+	}
+
+	if (!object) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"page %d in gc has no object: %d %d %d ",
+			old_chunk,
+			tags.obj_id, tags.chunk_id,
+			tags.n_bytes);
+	}
+
+	if (object &&
+	    object->deleted &&
+	    object->soft_del && tags.chunk_id != 0) {
+		/* Data chunk in a soft deleted file,
+		 * throw it away.
+		 * It's a soft deleted data chunk,
+		 * No need to copy this, just forget
+		 * about it and fix up the object.
+		 */
+
+		/* Free chunks already includes
+		 * softdeleted chunks, how ever this
+		 * chunk is going to soon be really
+		 * deleted which will increment free
+		 * chunks. We have to decrement free
+		 * chunks so this works out properly.
+		 */
+		dev->n_free_chunks--;
+		bi->soft_del_pages--;
+
+		object->n_data_chunks--;
+		if (object->n_data_chunks <= 0) {
+			/* remeber to clean up obj */
+			dev->gc_cleanup_list[dev->n_clean_ups] = tags.obj_id;
+			dev->n_clean_ups++;
+		}
+		mark_flash = 0;
+	} else if (object) {
+		/* It's either a data chunk in a live
+		 * file or an ObjectHeader, so we're
+		 * interested in it.
+		 * NB Need to keep the ObjectHeaders of
+		 * deleted files until the whole file
+		 * has been deleted off
+		 */
+		tags.serial_number++;
+		dev->n_gc_copies++;
+
+		if (tags.chunk_id == 0) {
+			/* It is an object Id,
+			 * We need to nuke the shrinkheader flags since its
+			 * work is done.
+			 * Also need to clean up shadowing.
+			 * NB We don't want to do all the work of translating
+			 * object header endianism back and forth so we leave
+			 * the oh endian in its stored order.
+			 */
+
+			struct yaffs_obj_hdr *oh;
+			oh = (struct yaffs_obj_hdr *) buffer;
+
+			oh->is_shrink = 0;
+			tags.extra_is_shrink = 0;
+			oh->shadows_obj = 0;
+			oh->inband_shadowed_obj_id = 0;
+			tags.extra_shadows = 0;
+
+			/* Update file size */
+			if (object->variant_type == YAFFS_OBJECT_TYPE_FILE) {
+				yaffs_oh_size_load(dev, oh,
+				    object->variant.file_variant.stored_size, 1);
+				tags.extra_file_size =
+				    object->variant.file_variant.stored_size;
+			}
+
+			yaffs_verify_oh(object, oh, &tags, 1);
+			new_chunk =
+			    yaffs_write_new_chunk(dev, (u8 *) oh, &tags, 1);
+		} else {
+			new_chunk =
+			    yaffs_write_new_chunk(dev, buffer, &tags, 1);
+		}
+
+		if (new_chunk < 0) {
+			ret_val = YAFFS_FAIL;
+		} else {
+
+			/* Now fix up the Tnodes etc. */
+
+			if (tags.chunk_id == 0) {
+				/* It's a header */
+				object->hdr_chunk = new_chunk;
+				object->serial = tags.serial_number;
+			} else {
+				/* It's a data chunk */
+				yaffs_put_chunk_in_file(object, tags.chunk_id,
+							new_chunk, 0);
+			}
+		}
+	}
+	if (ret_val == YAFFS_OK)
+		yaffs_chunk_del(dev, old_chunk, mark_flash, __LINE__);
+	return ret_val;
+}
+
+static int yaffs_gc_block(struct yaffs_dev *dev, int block, int whole_block)
+{
+	int old_chunk;
+	int ret_val = YAFFS_OK;
+	u32 i;
+	int is_checkpt_block;
+	int max_copies;
+	int chunks_before = yaffs_get_erased_chunks(dev);
+	int chunks_after;
+	struct yaffs_block_info *bi = yaffs_get_block_info(dev, block);
+
+	is_checkpt_block = (bi->block_state == YAFFS_BLOCK_STATE_CHECKPOINT);
+
+	yaffs_trace(YAFFS_TRACE_TRACING,
+		"Collecting block %d, in use %d, shrink %d, whole_block %d",
+		block, bi->pages_in_use, bi->has_shrink_hdr,
+		whole_block);
+
+	/*yaffs_verify_free_chunks(dev); */
+
+	if (bi->block_state == YAFFS_BLOCK_STATE_FULL)
+		bi->block_state = YAFFS_BLOCK_STATE_COLLECTING;
+
+	bi->has_shrink_hdr = 0;	/* clear the flag so that the block can erase */
+
+	dev->gc_disable = 1;
+
+	yaffs_summary_gc(dev, block);
+
+	if (is_checkpt_block || !yaffs_still_some_chunks(dev, block)) {
+		yaffs_trace(YAFFS_TRACE_TRACING,
+			"Collecting block %d that has no chunks in use",
+			block);
+		yaffs_block_became_dirty(dev, block);
+	} else {
+
+		u8 *buffer = yaffs_get_temp_buffer(dev);
+
+		yaffs_verify_blk(dev, bi, block);
+
+		max_copies = (whole_block) ? dev->param.chunks_per_block : 5;
+		old_chunk = block * dev->param.chunks_per_block + dev->gc_chunk;
+
+		for (/* init already done */ ;
+		     ret_val == YAFFS_OK &&
+		     dev->gc_chunk < dev->param.chunks_per_block &&
+		     (bi->block_state == YAFFS_BLOCK_STATE_COLLECTING) &&
+		     max_copies > 0;
+		     dev->gc_chunk++, old_chunk++) {
+			if (yaffs_check_chunk_bit(dev, block, dev->gc_chunk)) {
+				/* Page is in use and might need to be copied */
+				max_copies--;
+				ret_val = yaffs_gc_process_chunk(dev, bi,
+							old_chunk, buffer);
+			}
+		}
+		yaffs_release_temp_buffer(dev, buffer);
+	}
+
+	yaffs_verify_collected_blk(dev, bi, block);
+
+	if (bi->block_state == YAFFS_BLOCK_STATE_COLLECTING) {
+		/*
+		 * The gc did not complete. Set block state back to FULL
+		 * because checkpointing does not restore gc.
+		 */
+		bi->block_state = YAFFS_BLOCK_STATE_FULL;
+	} else {
+		/* The gc completed. */
+		/* Do any required cleanups */
+		for (i = 0; i < dev->n_clean_ups; i++) {
+			/* Time to delete the file too */
+			struct yaffs_obj *object =
+			    yaffs_find_by_number(dev, dev->gc_cleanup_list[i]);
+			if (object) {
+				yaffs_free_tnode(dev,
+					  object->variant.file_variant.top);
+				object->variant.file_variant.top = NULL;
+				yaffs_trace(YAFFS_TRACE_GC,
+					"yaffs: About to finally delete object %d",
+					object->obj_id);
+				yaffs_generic_obj_del(object);
+				object->my_dev->n_deleted_files--;
+			}
+
+		}
+		chunks_after = yaffs_get_erased_chunks(dev);
+		if (chunks_before >= chunks_after)
+			yaffs_trace(YAFFS_TRACE_GC,
+				"gc did not increase free chunks before %d after %d",
+				chunks_before, chunks_after);
+		dev->gc_block = 0;
+		dev->gc_chunk = 0;
+		dev->n_clean_ups = 0;
+	}
+
+	dev->gc_disable = 0;
+
+	return ret_val;
+}
+
+/*
+ * find_gc_block() selects the dirtiest block (or close enough)
+ * for garbage collection.
+ */
+
+static unsigned yaffs_find_gc_block(struct yaffs_dev *dev,
+				    int aggressive, int background)
+{
+	u32 i;
+	u32 iterations;
+	u32 selected = 0;
+	int prioritised = 0;
+	int prioritised_exist = 0;
+	struct yaffs_block_info *bi;
+	u32 threshold;
+
+	/* First let's see if we need to grab a prioritised block */
+	if (dev->has_pending_prioritised_gc && !aggressive) {
+		dev->gc_dirtiest = 0;
+		bi = dev->block_info;
+		for (i = dev->internal_start_block;
+		     i <= dev->internal_end_block && !selected; i++) {
+
+			if (bi->gc_prioritise) {
+				prioritised_exist = 1;
+				if (bi->block_state == YAFFS_BLOCK_STATE_FULL &&
+				    yaffs_block_ok_for_gc(dev, bi)) {
+					selected = i;
+					prioritised = 1;
+				}
+			}
+			bi++;
+		}
+
+		/*
+		 * If there is a prioritised block and none was selected then
+		 * this happened because there is at least one old dirty block
+		 * gumming up the works. Let's gc the oldest dirty block.
+		 */
+
+		if (prioritised_exist &&
+		    !selected && dev->oldest_dirty_block > 0)
+			selected = dev->oldest_dirty_block;
+
+		if (!prioritised_exist)	/* None found, so we can clear this */
+			dev->has_pending_prioritised_gc = 0;
+	}
+
+	/* If we're doing aggressive GC then we are happy to take a less-dirty
+	 * block, and search harder.
+	 * else (leasurely gc), then we only bother to do this if the
+	 * block has only a few pages in use.
+	 */
+
+	if (!selected) {
+		u32 pages_used;
+		int n_blocks =
+		    dev->internal_end_block - dev->internal_start_block + 1;
+		if (aggressive) {
+			threshold = dev->param.chunks_per_block;
+			iterations = n_blocks;
+		} else {
+			u32 max_threshold;
+
+			if (background)
+				max_threshold = dev->param.chunks_per_block / 2;
+			else
+				max_threshold = dev->param.chunks_per_block / 8;
+
+			if (max_threshold < YAFFS_GC_PASSIVE_THRESHOLD)
+				max_threshold = YAFFS_GC_PASSIVE_THRESHOLD;
+
+			threshold = background ? (dev->gc_not_done + 2) * 2 : 0;
+			if (threshold < YAFFS_GC_PASSIVE_THRESHOLD)
+				threshold = YAFFS_GC_PASSIVE_THRESHOLD;
+			if (threshold > max_threshold)
+				threshold = max_threshold;
+
+			iterations = n_blocks / 16 + 1;
+			if (iterations > 100)
+				iterations = 100;
+		}
+
+		for (i = 0;
+		     i < iterations &&
+		     (dev->gc_dirtiest < 1 ||
+		      dev->gc_pages_in_use > YAFFS_GC_GOOD_ENOUGH);
+		     i++) {
+			dev->gc_block_finder++;
+			if (dev->gc_block_finder < dev->internal_start_block ||
+			    dev->gc_block_finder > dev->internal_end_block)
+				dev->gc_block_finder =
+				    dev->internal_start_block;
+
+			bi = yaffs_get_block_info(dev, dev->gc_block_finder);
+
+			pages_used = bi->pages_in_use - bi->soft_del_pages;
+
+			if (bi->block_state == YAFFS_BLOCK_STATE_FULL &&
+			    pages_used < dev->param.chunks_per_block &&
+			    (dev->gc_dirtiest < 1 ||
+			     pages_used < dev->gc_pages_in_use) &&
+			    yaffs_block_ok_for_gc(dev, bi)) {
+				dev->gc_dirtiest = dev->gc_block_finder;
+				dev->gc_pages_in_use = pages_used;
+			}
+		}
+
+		if (dev->gc_dirtiest > 0 && dev->gc_pages_in_use <= threshold)
+			selected = dev->gc_dirtiest;
+	}
+
+	/*
+	 * If nothing has been selected for a while, try the oldest dirty
+	 * because that's gumming up the works.
+	 */
+
+	if (!selected && dev->param.is_yaffs2 &&
+	    dev->gc_not_done >= (background ? 10 : 20)) {
+		yaffs2_find_oldest_dirty_seq(dev);
+		if (dev->oldest_dirty_block > 0) {
+			selected = dev->oldest_dirty_block;
+			dev->gc_dirtiest = selected;
+			dev->oldest_dirty_gc_count++;
+			bi = yaffs_get_block_info(dev, selected);
+			dev->gc_pages_in_use =
+			    bi->pages_in_use - bi->soft_del_pages;
+		} else {
+			dev->gc_not_done = 0;
+		}
+	}
+
+	if (selected) {
+		yaffs_trace(YAFFS_TRACE_GC,
+			"GC Selected block %d with %d free, prioritised:%d",
+			selected,
+			dev->param.chunks_per_block - dev->gc_pages_in_use,
+			prioritised);
+
+		dev->n_gc_blocks++;
+		if (background)
+			dev->bg_gcs++;
+
+		dev->gc_dirtiest = 0;
+		dev->gc_pages_in_use = 0;
+		dev->gc_not_done = 0;
+		if (dev->refresh_skip > 0)
+			dev->refresh_skip--;
+	} else {
+		dev->gc_not_done++;
+		yaffs_trace(YAFFS_TRACE_GC,
+			"GC none: finder %d skip %d threshold %d dirtiest %d using %d oldest %d%s",
+			dev->gc_block_finder, dev->gc_not_done, threshold,
+			dev->gc_dirtiest, dev->gc_pages_in_use,
+			dev->oldest_dirty_block, background ? " bg" : "");
+	}
+
+	return selected;
+}
+
+/* New garbage collector
+ * If we're very low on erased blocks then we do aggressive garbage collection
+ * otherwise we do "leasurely" garbage collection.
+ * Aggressive gc looks further (whole array) and will accept less dirty blocks.
+ * Passive gc only inspects smaller areas and only accepts more dirty blocks.
+ *
+ * The idea is to help clear out space in a more spread-out manner.
+ * Dunno if it really does anything useful.
+ */
+static int yaffs_check_gc(struct yaffs_dev *dev, int background)
+{
+	int aggressive = 0;
+	int gc_ok = YAFFS_OK;
+	int max_tries = 0;
+	int min_erased;
+	int erased_chunks;
+	int checkpt_block_adjust;
+
+	if (dev->param.gc_control_fn &&
+		(dev->param.gc_control_fn(dev) & 1) == 0)
+		return YAFFS_OK;
+
+	if (dev->gc_disable)
+		/* Bail out so we don't get recursive gc */
+		return YAFFS_OK;
+
+	/* This loop should pass the first time.
+	 * Only loops here if the collection does not increase space.
+	 */
+
+	do {
+		max_tries++;
+
+		checkpt_block_adjust = yaffs_calc_checkpt_blocks_required(dev);
+
+		min_erased =
+		    dev->param.n_reserved_blocks + checkpt_block_adjust + 1;
+		erased_chunks =
+		    dev->n_erased_blocks * dev->param.chunks_per_block;
+
+		/* If we need a block soon then do aggressive gc. */
+		if (dev->n_erased_blocks < min_erased)
+			aggressive = 1;
+		else {
+			if (!background
+			    && erased_chunks > (dev->n_free_chunks / 4))
+				break;
+
+			if (dev->gc_skip > 20)
+				dev->gc_skip = 20;
+			if (erased_chunks < dev->n_free_chunks / 2 ||
+			    dev->gc_skip < 1 || background)
+				aggressive = 0;
+			else {
+				dev->gc_skip--;
+				break;
+			}
+		}
+
+		dev->gc_skip = 5;
+
+		/* If we don't already have a block being gc'd then see if we
+		 * should start another */
+
+		if (dev->gc_block < 1 && !aggressive) {
+			dev->gc_block = yaffs2_find_refresh_block(dev);
+			dev->gc_chunk = 0;
+			dev->n_clean_ups = 0;
+		}
+		if (dev->gc_block < 1) {
+			dev->gc_block =
+			    yaffs_find_gc_block(dev, aggressive, background);
+			dev->gc_chunk = 0;
+			dev->n_clean_ups = 0;
+		}
+
+		if (dev->gc_block > 0) {
+			dev->all_gcs++;
+			if (!aggressive)
+				dev->passive_gc_count++;
+
+			yaffs_trace(YAFFS_TRACE_GC,
+				"yaffs: GC n_erased_blocks %d aggressive %d",
+				dev->n_erased_blocks, aggressive);
+
+			gc_ok = yaffs_gc_block(dev, dev->gc_block, aggressive);
+		}
+
+		if (dev->n_erased_blocks < (int)dev->param.n_reserved_blocks &&
+		    dev->gc_block > 0) {
+			yaffs_trace(YAFFS_TRACE_GC,
+				"yaffs: GC !!!no reclaim!!! n_erased_blocks %d after try %d block %d",
+				dev->n_erased_blocks, max_tries,
+				dev->gc_block);
+		}
+	} while ((dev->n_erased_blocks < (int)dev->param.n_reserved_blocks) &&
+		 (dev->gc_block > 0) && (max_tries < 2));
+
+	return aggressive ? gc_ok : YAFFS_OK;
+}
+
+/*
+ * yaffs_bg_gc()
+ * Garbage collects. Intended to be called from a background thread.
+ * Returns non-zero if at least half the free chunks are erased.
+ */
+int yaffs_bg_gc(struct yaffs_dev *dev, unsigned urgency)
+{
+	int erased_chunks = dev->n_erased_blocks * dev->param.chunks_per_block;
+
+	yaffs_trace(YAFFS_TRACE_BACKGROUND, "Background gc %u", urgency);
+
+	yaffs_check_gc(dev, 1);
+	return erased_chunks > dev->n_free_chunks / 2;
+}
+
+/*-------------------- Data file manipulation -----------------*/
+
+static int yaffs_rd_data_obj(struct yaffs_obj *in, int inode_chunk, u8 * buffer)
+{
+	int nand_chunk = yaffs_find_chunk_in_file(in, inode_chunk, NULL);
+
+	if (nand_chunk >= 0)
+		return yaffs_rd_chunk_tags_nand(in->my_dev, nand_chunk,
+						buffer, NULL);
+	else {
+		yaffs_trace(YAFFS_TRACE_NANDACCESS,
+			"Chunk %d not found zero instead",
+			nand_chunk);
+		/* get sane (zero) data if you read a hole */
+		memset(buffer, 0, in->my_dev->data_bytes_per_chunk);
+		return 0;
+	}
+
+}
+
+void yaffs_chunk_del(struct yaffs_dev *dev, int chunk_id, int mark_flash,
+		     int lyn)
+{
+	int block;
+	int page;
+	struct yaffs_ext_tags tags;
+	struct yaffs_block_info *bi;
+
+	if (chunk_id <= 0)
+		return;
+
+	dev->n_deletions++;
+	block = chunk_id / dev->param.chunks_per_block;
+	page = chunk_id % dev->param.chunks_per_block;
+
+	if (!yaffs_check_chunk_bit(dev, block, page))
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Deleting invalid chunk %d", chunk_id);
+
+	bi = yaffs_get_block_info(dev, block);
+
+	yaffs2_update_oldest_dirty_seq(dev, block, bi);
+
+	yaffs_trace(YAFFS_TRACE_DELETION,
+		"line %d delete of chunk %d",
+		lyn, chunk_id);
+
+	if (!dev->param.is_yaffs2 && mark_flash &&
+	    bi->block_state != YAFFS_BLOCK_STATE_COLLECTING) {
+
+		memset(&tags, 0, sizeof(tags));
+		tags.is_deleted = 1;
+		yaffs_wr_chunk_tags_nand(dev, chunk_id, NULL, &tags);
+		yaffs_handle_chunk_update(dev, chunk_id, &tags);
+	} else {
+		dev->n_unmarked_deletions++;
+	}
+
+	/* Pull out of the management area.
+	 * If the whole block became dirty, this will kick off an erasure.
+	 */
+	if (bi->block_state == YAFFS_BLOCK_STATE_ALLOCATING ||
+	    bi->block_state == YAFFS_BLOCK_STATE_FULL ||
+	    bi->block_state == YAFFS_BLOCK_STATE_NEEDS_SCAN ||
+	    bi->block_state == YAFFS_BLOCK_STATE_COLLECTING) {
+		dev->n_free_chunks++;
+		yaffs_clear_chunk_bit(dev, block, page);
+		bi->pages_in_use--;
+
+		if (bi->pages_in_use == 0 &&
+		    !bi->has_shrink_hdr &&
+		    bi->block_state != YAFFS_BLOCK_STATE_ALLOCATING &&
+		    bi->block_state != YAFFS_BLOCK_STATE_NEEDS_SCAN) {
+			yaffs_block_became_dirty(dev, block);
+		}
+	}
+}
+
+static int yaffs_wr_data_obj(struct yaffs_obj *in, int inode_chunk,
+			     const u8 *buffer, int n_bytes, int use_reserve)
+{
+	/* Find old chunk Need to do this to get serial number
+	 * Write new one and patch into tree.
+	 * Invalidate old tags.
+	 */
+
+	int prev_chunk_id;
+	struct yaffs_ext_tags prev_tags;
+	int new_chunk_id;
+	struct yaffs_ext_tags new_tags;
+	struct yaffs_dev *dev = in->my_dev;
+	loff_t endpos;
+
+	yaffs_check_gc(dev, 0);
+
+	/* Get the previous chunk at this location in the file if it exists.
+	 * If it does not exist then put a zero into the tree. This creates
+	 * the tnode now, rather than later when it is harder to clean up.
+	 */
+	prev_chunk_id = yaffs_find_chunk_in_file(in, inode_chunk, &prev_tags);
+	if (prev_chunk_id < 1 &&
+	    !yaffs_put_chunk_in_file(in, inode_chunk, 0, 0))
+		return 0;
+
+	/* Set up new tags */
+	memset(&new_tags, 0, sizeof(new_tags));
+
+	new_tags.chunk_id = inode_chunk;
+	new_tags.obj_id = in->obj_id;
+	new_tags.serial_number =
+	    (prev_chunk_id > 0) ? prev_tags.serial_number + 1 : 1;
+	new_tags.n_bytes = n_bytes;
+
+	if (n_bytes < 1 || n_bytes > (int)dev->data_bytes_per_chunk) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+		  "Writing %d bytes to chunk!!!!!!!!!",
+		   n_bytes);
+		BUG();
+	}
+
+	/*
+	 * If this is a data chunk and the write goes past the end of the stored
+	 * size then update the stored_size.
+	 */
+	if (inode_chunk > 0) {
+		endpos =  (inode_chunk - 1) * dev->data_bytes_per_chunk +
+				n_bytes;
+		if (in->variant.file_variant.stored_size < endpos)
+			in->variant.file_variant.stored_size = endpos;
+	}
+
+	new_chunk_id =
+	    yaffs_write_new_chunk(dev, buffer, &new_tags, use_reserve);
+
+	if (new_chunk_id > 0) {
+		yaffs_put_chunk_in_file(in, inode_chunk, new_chunk_id, 0);
+
+		if (prev_chunk_id > 0)
+			yaffs_chunk_del(dev, prev_chunk_id, 1, __LINE__);
+
+		yaffs_verify_file_sane(in);
+	}
+	return new_chunk_id;
+}
+
+
+
+static int yaffs_do_xattrib_mod(struct yaffs_obj *obj, int set,
+				const YCHAR *name, const void *value, int size,
+				int flags)
+{
+	struct yaffs_xattr_mod xmod;
+	int result;
+
+	xmod.set = set;
+	xmod.name = name;
+	xmod.data = value;
+	xmod.size = size;
+	xmod.flags = flags;
+	xmod.result = -ENOSPC;
+
+	result = yaffs_update_oh(obj, NULL, 0, 0, 0, &xmod);
+
+	if (result > 0)
+		return xmod.result;
+	else
+		return -ENOSPC;
+}
+
+static int yaffs_apply_xattrib_mod(struct yaffs_obj *obj, char *buffer,
+				   struct yaffs_xattr_mod *xmod)
+{
+	int retval = 0;
+	int x_offs = sizeof(struct yaffs_obj_hdr);
+	struct yaffs_dev *dev = obj->my_dev;
+	int x_size = dev->data_bytes_per_chunk - sizeof(struct yaffs_obj_hdr);
+	char *x_buffer = buffer + x_offs;
+
+	if (xmod->set)
+		retval =
+		    nval_set(dev, x_buffer, x_size, xmod->name, xmod->data,
+			     xmod->size, xmod->flags);
+	else
+		retval = nval_del(dev, x_buffer, x_size, xmod->name);
+
+	obj->has_xattr = nval_hasvalues(dev, x_buffer, x_size);
+	obj->xattr_known = 1;
+	xmod->result = retval;
+
+	return retval;
+}
+
+static int yaffs_do_xattrib_fetch(struct yaffs_obj *obj, const YCHAR *name,
+				  void *value, int size)
+{
+	char *buffer = NULL;
+	int result;
+	struct yaffs_ext_tags tags;
+	struct yaffs_dev *dev = obj->my_dev;
+	int x_offs = sizeof(struct yaffs_obj_hdr);
+	int x_size = dev->data_bytes_per_chunk - sizeof(struct yaffs_obj_hdr);
+	char *x_buffer;
+	int retval = 0;
+
+	if (obj->hdr_chunk < 1)
+		return -ENODATA;
+
+	/* If we know that the object has no xattribs then don't do all the
+	 * reading and parsing.
+	 */
+	if (obj->xattr_known && !obj->has_xattr) {
+		if (name)
+			return -ENODATA;
+		else
+			return 0;
+	}
+
+	buffer = (char *)yaffs_get_temp_buffer(dev);
+	if (!buffer)
+		return -ENOMEM;
+
+	result =
+	    yaffs_rd_chunk_tags_nand(dev, obj->hdr_chunk, (u8 *) buffer, &tags);
+
+	if (result != YAFFS_OK)
+		retval = -ENOENT;
+	else {
+		x_buffer = buffer + x_offs;
+
+		if (!obj->xattr_known) {
+			obj->has_xattr = nval_hasvalues(dev, x_buffer, x_size);
+			obj->xattr_known = 1;
+		}
+
+		if (name)
+			retval = nval_get(dev, x_buffer, x_size,
+						name, value, size);
+		else
+			retval = nval_list(dev, x_buffer, x_size, value, size);
+	}
+	yaffs_release_temp_buffer(dev, (u8 *) buffer);
+	return retval;
+}
+
+int yaffs_set_xattrib(struct yaffs_obj *obj, const YCHAR * name,
+		      const void *value, int size, int flags)
+{
+	return yaffs_do_xattrib_mod(obj, 1, name, value, size, flags);
+}
+
+int yaffs_remove_xattrib(struct yaffs_obj *obj, const YCHAR * name)
+{
+	return yaffs_do_xattrib_mod(obj, 0, name, NULL, 0, 0);
+}
+
+int yaffs_get_xattrib(struct yaffs_obj *obj, const YCHAR * name, void *value,
+		      int size)
+{
+	return yaffs_do_xattrib_fetch(obj, name, value, size);
+}
+
+int yaffs_list_xattrib(struct yaffs_obj *obj, char *buffer, int size)
+{
+	return yaffs_do_xattrib_fetch(obj, NULL, buffer, size);
+}
+
+static void yaffs_check_obj_details_loaded(struct yaffs_obj *in)
+{
+	u8 *buf;
+	struct yaffs_obj_hdr *oh;
+	struct yaffs_dev *dev;
+	struct yaffs_ext_tags tags;
+	int result;
+
+	if (!in || !in->lazy_loaded || in->hdr_chunk < 1)
+		return;
+
+	dev = in->my_dev;
+	buf = yaffs_get_temp_buffer(dev);
+
+	result = yaffs_rd_chunk_tags_nand(dev, in->hdr_chunk, buf, &tags);
+
+	if (result == YAFFS_FAIL)
+		return;
+
+	oh = (struct yaffs_obj_hdr *)buf;
+
+	yaffs_do_endian_oh(dev, oh);
+
+	in->lazy_loaded = 0;
+	in->yst_mode = oh->yst_mode;
+	yaffs_load_attribs(in, oh);
+	yaffs_set_obj_name_from_oh(in, oh);
+
+	if (in->variant_type == YAFFS_OBJECT_TYPE_SYMLINK)
+		in->variant.symlink_variant.alias =
+		    yaffs_clone_str(oh->alias);
+	yaffs_release_temp_buffer(dev, buf);
+}
+
+/* UpdateObjectHeader updates the header on NAND for an object.
+ * If name is not NULL, then that new name is used.
+ *
+ * We're always creating the obj header from scratch (except reading
+ * the old name) so first set up in cpu endianness then run it through
+ * endian fixing at the end.
+ *
+ * However, a twist: If there are xattribs we leave them as they were.
+ *
+ * Careful! The buffer holds the whole chunk. Part of the chunk holds the
+ * object header and the rest holds the xattribs, therefore we use a buffer
+ * pointer and an oh pointer to point to the same memory.
+ */
+
+int yaffs_update_oh(struct yaffs_obj *in, const YCHAR *name, int force,
+		    int is_shrink, int shadows, struct yaffs_xattr_mod *xmod)
+{
+
+	struct yaffs_block_info *bi;
+	struct yaffs_dev *dev = in->my_dev;
+	int prev_chunk_id;
+	int ret_val = 0;
+	int result = 0;
+	int new_chunk_id;
+	struct yaffs_ext_tags new_tags;
+	struct yaffs_ext_tags old_tags;
+	const YCHAR *alias = NULL;
+	u8 *buffer = NULL;
+	YCHAR old_name[YAFFS_MAX_NAME_LENGTH + 1];
+	struct yaffs_obj_hdr *oh = NULL;
+	loff_t file_size = 0;
+
+	strcpy(old_name, _Y("silly old name"));
+
+	if (in->fake && in != dev->root_dir && !force && !xmod)
+		return ret_val;
+
+	yaffs_check_gc(dev, 0);
+	yaffs_check_obj_details_loaded(in);
+
+	buffer = yaffs_get_temp_buffer(in->my_dev);
+	oh = (struct yaffs_obj_hdr *)buffer;
+
+	prev_chunk_id = in->hdr_chunk;
+
+	if (prev_chunk_id > 0) {
+		/* Access the old obj header just to read the name. */
+		result = yaffs_rd_chunk_tags_nand(dev, prev_chunk_id,
+						  buffer, &old_tags);
+		if (result == YAFFS_OK) {
+			yaffs_verify_oh(in, oh, &old_tags, 0);
+			memcpy(old_name, oh->name, sizeof(oh->name));
+
+			/*
+			* NB We only wipe the object header area because the rest of
+			* the buffer might contain xattribs.
+			*/
+			memset(oh, 0xff, sizeof(*oh));
+		}
+	} else {
+		memset(buffer, 0xff, dev->data_bytes_per_chunk);
+	}
+
+	oh->type = in->variant_type;
+	oh->yst_mode = in->yst_mode;
+	oh->shadows_obj = oh->inband_shadowed_obj_id = shadows;
+
+	yaffs_load_attribs_oh(oh, in);
+
+	if (in->parent)
+		oh->parent_obj_id = in->parent->obj_id;
+	else
+		oh->parent_obj_id = 0;
+
+	if (name && *name) {
+		memset(oh->name, 0, sizeof(oh->name));
+		yaffs_load_oh_from_name(dev, oh->name, name);
+	} else if (prev_chunk_id > 0) {
+		memcpy(oh->name, old_name, sizeof(oh->name));
+	} else {
+		memset(oh->name, 0, sizeof(oh->name));
+	}
+
+	oh->is_shrink = is_shrink;
+
+	switch (in->variant_type) {
+	case YAFFS_OBJECT_TYPE_UNKNOWN:
+		/* Should not happen */
+		break;
+	case YAFFS_OBJECT_TYPE_FILE:
+		if (oh->parent_obj_id != YAFFS_OBJECTID_DELETED &&
+		    oh->parent_obj_id != YAFFS_OBJECTID_UNLINKED)
+			file_size = in->variant.file_variant.stored_size;
+		yaffs_oh_size_load(dev, oh, file_size, 0);
+		break;
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+		oh->equiv_id = in->variant.hardlink_variant.equiv_id;
+		break;
+	case YAFFS_OBJECT_TYPE_SPECIAL:
+		/* Do nothing */
+		break;
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+		/* Do nothing */
+		break;
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+		alias = in->variant.symlink_variant.alias;
+		if (!alias)
+			alias = _Y("no alias");
+		strncpy(oh->alias, alias, YAFFS_MAX_ALIAS_LENGTH);
+		oh->alias[YAFFS_MAX_ALIAS_LENGTH] = 0;
+		break;
+	}
+
+	/* process any xattrib modifications */
+	if (xmod)
+		yaffs_apply_xattrib_mod(in, (char *)buffer, xmod);
+
+	/* Tags */
+	memset(&new_tags, 0, sizeof(new_tags));
+	in->serial++;
+	new_tags.chunk_id = 0;
+	new_tags.obj_id = in->obj_id;
+	new_tags.serial_number = in->serial;
+
+	/* Add extra info for file header */
+	new_tags.extra_available = 1;
+	new_tags.extra_parent_id = oh->parent_obj_id;
+	new_tags.extra_file_size = file_size;
+	new_tags.extra_is_shrink = oh->is_shrink;
+	new_tags.extra_equiv_id = oh->equiv_id;
+	new_tags.extra_shadows = (oh->shadows_obj > 0) ? 1 : 0;
+	new_tags.extra_obj_type = in->variant_type;
+
+	/* Now endian swizzle the oh if needed. */
+	yaffs_do_endian_oh(dev, oh);
+
+	yaffs_verify_oh(in, oh, &new_tags, 1);
+
+	/* Create new chunk in NAND */
+	new_chunk_id =
+	    yaffs_write_new_chunk(dev, buffer, &new_tags,
+				  (prev_chunk_id > 0) ? 1 : 0);
+
+	if (buffer)
+		yaffs_release_temp_buffer(dev, buffer);
+
+	if (new_chunk_id < 0)
+		return new_chunk_id;
+
+	in->hdr_chunk = new_chunk_id;
+
+	if (prev_chunk_id > 0)
+		yaffs_chunk_del(dev, prev_chunk_id, 1, __LINE__);
+
+	if (!yaffs_obj_cache_dirty(in))
+		in->dirty = 0;
+
+	/* If this was a shrink, then mark the block
+	 * that the chunk lives on */
+	if (is_shrink) {
+		bi = yaffs_get_block_info(in->my_dev,
+					  new_chunk_id /
+					  in->my_dev->param.chunks_per_block);
+		bi->has_shrink_hdr = 1;
+	}
+
+
+	return new_chunk_id;
+}
+
+/*--------------------- File read/write ------------------------
+ * Read and write have very similar structures.
+ * In general the read/write has three parts to it
+ * An incomplete chunk to start with (if the read/write is not chunk-aligned)
+ * Some complete chunks
+ * An incomplete chunk to end off with
+ *
+ * Curve-balls: the first chunk might also be the last chunk.
+ */
+
+int yaffs_file_rd(struct yaffs_obj *in, u8 * buffer, loff_t offset, int n_bytes)
+{
+	int chunk;
+	u32 start;
+	int n_copy;
+	int n = n_bytes;
+	int n_done = 0;
+	struct yaffs_cache *cache;
+	struct yaffs_dev *dev;
+
+	dev = in->my_dev;
+
+	while (n > 0) {
+		yaffs_addr_to_chunk(dev, offset, &chunk, &start);
+		chunk++;
+
+		/* OK now check for the curveball where the start and end are in
+		 * the same chunk.
+		 */
+		if ((start + n) < dev->data_bytes_per_chunk)
+			n_copy = n;
+		else
+			n_copy = dev->data_bytes_per_chunk - start;
+
+		cache = yaffs_find_chunk_cache(in, chunk);
+
+		/* If the chunk is already in the cache or it is less than
+		 * a whole chunk or we're using inband tags then use the cache
+		 * (if there is caching) else bypass the cache.
+		 */
+		if (cache || n_copy != (int)dev->data_bytes_per_chunk ||
+		    dev->param.inband_tags) {
+			if (dev->param.n_caches > 0) {
+
+				/* If we can't find the data in the cache,
+				 * then load it up. */
+
+				if (!cache) {
+					cache =
+					    yaffs_grab_chunk_cache(in->my_dev);
+					cache->object = in;
+					cache->chunk_id = chunk;
+					cache->dirty = 0;
+					cache->locked = 0;
+					yaffs_rd_data_obj(in, chunk,
+							  cache->data);
+					cache->n_bytes = 0;
+				}
+
+				yaffs_use_cache(dev, cache, 0);
+
+				cache->locked = 1;
+
+				memcpy(buffer, &cache->data[start], n_copy);
+
+				cache->locked = 0;
+			} else {
+				/* Read into the local buffer then copy.. */
+
+				u8 *local_buffer =
+				    yaffs_get_temp_buffer(dev);
+				yaffs_rd_data_obj(in, chunk, local_buffer);
+
+				memcpy(buffer, &local_buffer[start], n_copy);
+
+				yaffs_release_temp_buffer(dev, local_buffer);
+			}
+		} else {
+			/* A full chunk. Read directly into the buffer. */
+			yaffs_rd_data_obj(in, chunk, buffer);
+		}
+		n -= n_copy;
+		offset += n_copy;
+		buffer += n_copy;
+		n_done += n_copy;
+	}
+	return n_done;
+}
+
+int yaffs_do_file_wr(struct yaffs_obj *in, const u8 *buffer, loff_t offset,
+		     int n_bytes, int write_through)
+{
+
+	int chunk;
+	u32 start;
+	int n_copy;
+	int n = n_bytes;
+	int n_done = 0;
+	int n_writeback;
+	loff_t start_write = offset;
+	int chunk_written = 0;
+	u32 n_bytes_read;
+	loff_t chunk_start;
+	struct yaffs_dev *dev;
+
+	dev = in->my_dev;
+
+	while (n > 0 && chunk_written >= 0) {
+		yaffs_addr_to_chunk(dev, offset, &chunk, &start);
+
+		if (((loff_t)chunk) *
+		    dev->data_bytes_per_chunk + start != offset ||
+		    start >= dev->data_bytes_per_chunk) {
+			yaffs_trace(YAFFS_TRACE_ERROR,
+				"AddrToChunk of offset %lld gives chunk %d start %d",
+				(long  long)offset, chunk, start);
+		}
+		chunk++;	/* File pos to chunk in file offset */
+
+		/* OK now check for the curveball where the start and end are in
+		 * the same chunk.
+		 */
+
+		if ((start + n) < dev->data_bytes_per_chunk) {
+			n_copy = n;
+
+			/* Now calculate how many bytes to write back....
+			 * If we're overwriting and not writing to then end of
+			 * file then we need to write back as much as was there
+			 * before.
+			 */
+
+			chunk_start = (((loff_t)(chunk - 1)) *
+					dev->data_bytes_per_chunk);
+
+			if (chunk_start > in->variant.file_variant.file_size)
+				n_bytes_read = 0;	/* Past end of file */
+			else
+				n_bytes_read =
+				    in->variant.file_variant.file_size -
+				    chunk_start;
+
+			if (n_bytes_read > dev->data_bytes_per_chunk)
+				n_bytes_read = dev->data_bytes_per_chunk;
+
+			n_writeback =
+			    (n_bytes_read >
+			     (start + n)) ? n_bytes_read : (start + n);
+
+			if (n_writeback < 0 ||
+			    n_writeback > (int)dev->data_bytes_per_chunk)
+				BUG();
+
+		} else {
+			n_copy = dev->data_bytes_per_chunk - start;
+			n_writeback = dev->data_bytes_per_chunk;
+		}
+
+		if (n_copy != (int)dev->data_bytes_per_chunk ||
+		    !dev->param.cache_bypass_aligned ||
+		    dev->param.inband_tags) {
+			/* An incomplete start or end chunk (or maybe both
+			 * start and end chunk), or we're using inband tags,
+			 * or we're forcing writes through the cache,
+			 * so we want to use the cache buffers.
+			 */
+			if (dev->param.n_caches > 0) {
+				struct yaffs_cache *cache;
+
+				/* If we can't find the data in the cache, then
+				 * load the cache */
+				cache = yaffs_find_chunk_cache(in, chunk);
+
+				if (!cache &&
+				    yaffs_check_alloc_available(dev, 1)) {
+					cache = yaffs_grab_chunk_cache(dev);
+					cache->object = in;
+					cache->chunk_id = chunk;
+					cache->dirty = 0;
+					cache->locked = 0;
+					yaffs_rd_data_obj(in, chunk,
+							  cache->data);
+				} else if (cache &&
+					   !cache->dirty &&
+					   !yaffs_check_alloc_available(dev,
+									1)) {
+					/* Drop the cache if it was a read cache
+					 * item and no space check has been made
+					 * for it.
+					 */
+					cache = NULL;
+				}
+
+				if (cache) {
+					yaffs_use_cache(dev, cache, 1);
+					cache->locked = 1;
+
+					memcpy(&cache->data[start], buffer,
+					       n_copy);
+
+					cache->locked = 0;
+					cache->n_bytes = n_writeback;
+
+					if (write_through) {
+						chunk_written =
+						    yaffs_wr_data_obj
+						    (cache->object,
+						     cache->chunk_id,
+						     cache->data,
+						     cache->n_bytes, 1);
+						cache->dirty = 0;
+					}
+				} else {
+					chunk_written = -1;	/* fail write */
+				}
+			} else {
+				/* An incomplete start or end chunk (or maybe
+				 * both start and end chunk). Read into the
+				 * local buffer then copy over and write back.
+				 */
+
+				u8 *local_buffer = yaffs_get_temp_buffer(dev);
+
+				yaffs_rd_data_obj(in, chunk, local_buffer);
+				memcpy(&local_buffer[start], buffer, n_copy);
+
+				chunk_written =
+				    yaffs_wr_data_obj(in, chunk,
+						      local_buffer,
+						      n_writeback, 0);
+
+				yaffs_release_temp_buffer(dev, local_buffer);
+			}
+		} else {
+			/* A full chunk. Write directly from the buffer. */
+
+			chunk_written =
+			    yaffs_wr_data_obj(in, chunk, buffer,
+					      dev->data_bytes_per_chunk, 0);
+
+			/* Since we've overwritten the cached data,
+			 * we better invalidate it. */
+			yaffs_invalidate_chunk_cache(in, chunk);
+		}
+
+		if (chunk_written >= 0) {
+			n -= n_copy;
+			offset += n_copy;
+			buffer += n_copy;
+			n_done += n_copy;
+		}
+	}
+
+	/* Update file object */
+
+	if ((start_write + n_done) > in->variant.file_variant.file_size)
+		in->variant.file_variant.file_size = (start_write + n_done);
+
+	in->dirty = 1;
+	return n_done;
+}
+
+int yaffs_wr_file(struct yaffs_obj *in, const u8 *buffer, loff_t offset,
+		  int n_bytes, int write_through)
+{
+	yaffs2_handle_hole(in, offset);
+	return yaffs_do_file_wr(in, buffer, offset, n_bytes, write_through);
+}
+
+/* ---------------------- File resizing stuff ------------------ */
+
+static void yaffs_prune_chunks(struct yaffs_obj *in, loff_t new_size)
+{
+
+	struct yaffs_dev *dev = in->my_dev;
+	loff_t old_size = in->variant.file_variant.file_size;
+	int i;
+	int chunk_id;
+	u32 dummy;
+	int last_del;
+	int start_del;
+
+	if (old_size > 0)
+		yaffs_addr_to_chunk(dev, old_size - 1, &last_del, &dummy);
+	else
+		last_del = 0;
+
+	yaffs_addr_to_chunk(dev, new_size + dev->data_bytes_per_chunk - 1,
+				&start_del, &dummy);
+	last_del++;
+	start_del++;
+
+	/* Delete backwards so that we don't end up with holes if
+	 * power is lost part-way through the operation.
+	 */
+	for (i = last_del; i >= start_del; i--) {
+		/* NB this could be optimised somewhat,
+		 * eg. could retrieve the tags and write them without
+		 * using yaffs_chunk_del
+		 */
+
+		chunk_id = yaffs_find_del_file_chunk(in, i, NULL);
+
+		if (chunk_id < 1)
+			continue;
+
+		if ((u32)chunk_id <
+		    (dev->internal_start_block * dev->param.chunks_per_block) ||
+		    (u32)chunk_id >=
+		    ((dev->internal_end_block + 1) *
+		      dev->param.chunks_per_block)) {
+			yaffs_trace(YAFFS_TRACE_ALWAYS,
+				"Found daft chunk_id %d for %d",
+				chunk_id, i);
+		} else {
+			in->n_data_chunks--;
+			yaffs_chunk_del(dev, chunk_id, 1, __LINE__);
+		}
+	}
+}
+
+void yaffs_resize_file_down(struct yaffs_obj *obj, loff_t new_size)
+{
+	int new_full;
+	u32 new_partial;
+	struct yaffs_dev *dev = obj->my_dev;
+
+	yaffs_addr_to_chunk(dev, new_size, &new_full, &new_partial);
+
+	yaffs_prune_chunks(obj, new_size);
+
+	if (new_partial != 0) {
+		int last_chunk = 1 + new_full;
+		u8 *local_buffer = yaffs_get_temp_buffer(dev);
+
+		/* Rewrite the last chunk with its new size and zero pad */
+		yaffs_rd_data_obj(obj, last_chunk, local_buffer);
+		memset(local_buffer + new_partial, 0,
+		       dev->data_bytes_per_chunk - new_partial);
+
+		yaffs_wr_data_obj(obj, last_chunk, local_buffer,
+				  new_partial, 1);
+
+		yaffs_release_temp_buffer(dev, local_buffer);
+	}
+
+	obj->variant.file_variant.file_size = new_size;
+	obj->variant.file_variant.stored_size = new_size;
+
+	yaffs_prune_tree(dev, &obj->variant.file_variant);
+}
+
+int yaffs_resize_file(struct yaffs_obj *in, loff_t new_size)
+{
+	struct yaffs_dev *dev = in->my_dev;
+	loff_t old_size = in->variant.file_variant.file_size;
+
+	yaffs_flush_file_cache(in, 1);
+	yaffs_invalidate_whole_cache(in);
+
+	yaffs_check_gc(dev, 0);
+
+	if (in->variant_type != YAFFS_OBJECT_TYPE_FILE)
+		return YAFFS_FAIL;
+
+	if (new_size == old_size)
+		return YAFFS_OK;
+
+	if (new_size > old_size) {
+		yaffs2_handle_hole(in, new_size);
+		in->variant.file_variant.file_size = new_size;
+	} else {
+		/* new_size < old_size */
+		yaffs_resize_file_down(in, new_size);
+	}
+
+	/* Write a new object header to reflect the resize.
+	 * show we've shrunk the file, if need be
+	 * Do this only if the file is not in the deleted directories
+	 * and is not shadowed.
+	 */
+	if (in->parent &&
+	    !in->is_shadowed &&
+	    in->parent->obj_id != YAFFS_OBJECTID_UNLINKED &&
+	    in->parent->obj_id != YAFFS_OBJECTID_DELETED)
+		yaffs_update_oh(in, NULL, 0, 0, 0, NULL);
+
+	return YAFFS_OK;
+}
+
+int yaffs_flush_file(struct yaffs_obj *in,
+		     int update_time,
+		     int data_sync,
+		     int discard_cache)
+{
+	if (!in->dirty)
+		return YAFFS_OK;
+
+	yaffs_flush_file_cache(in, discard_cache);
+
+	if (data_sync)
+		return YAFFS_OK;
+
+	if (update_time)
+		yaffs_load_current_time(in, 0, 0);
+
+	return (yaffs_update_oh(in, NULL, 0, 0, 0, NULL) >= 0) ?
+				YAFFS_OK : YAFFS_FAIL;
+}
+
+
+/* yaffs_del_file deletes the whole file data
+ * and the inode associated with the file.
+ * It does not delete the links associated with the file.
+ */
+static int yaffs_unlink_file_if_needed(struct yaffs_obj *in)
+{
+	int ret_val;
+	int del_now = 0;
+	struct yaffs_dev *dev = in->my_dev;
+
+	if (!in->my_inode)
+		del_now = 1;
+
+	if (del_now) {
+		ret_val =
+		    yaffs_change_obj_name(in, in->my_dev->del_dir,
+					  _Y("deleted"), 0, 0);
+		yaffs_trace(YAFFS_TRACE_TRACING,
+			"yaffs: immediate deletion of file %d",
+			in->obj_id);
+		in->deleted = 1;
+		in->my_dev->n_deleted_files++;
+		if (dev->param.disable_soft_del || dev->param.is_yaffs2)
+			yaffs_resize_file(in, 0);
+		yaffs_soft_del_file(in);
+	} else {
+		ret_val =
+		    yaffs_change_obj_name(in, in->my_dev->unlinked_dir,
+					  _Y("unlinked"), 0, 0);
+	}
+	return ret_val;
+}
+
+static int yaffs_del_file(struct yaffs_obj *in)
+{
+	int ret_val = YAFFS_OK;
+	int deleted;	/* Need to cache value on stack if in is freed */
+	struct yaffs_dev *dev = in->my_dev;
+
+	if (dev->param.disable_soft_del || dev->param.is_yaffs2)
+		yaffs_resize_file(in, 0);
+
+	if (in->n_data_chunks > 0) {
+		/* Use soft deletion if there is data in the file.
+		 * That won't be the case if it has been resized to zero.
+		 */
+		if (!in->unlinked)
+			ret_val = yaffs_unlink_file_if_needed(in);
+
+		deleted = in->deleted;
+
+		if (ret_val == YAFFS_OK && in->unlinked && !in->deleted) {
+			in->deleted = 1;
+			deleted = 1;
+			in->my_dev->n_deleted_files++;
+			yaffs_soft_del_file(in);
+		}
+		return deleted ? YAFFS_OK : YAFFS_FAIL;
+	} else {
+		/* The file has no data chunks so we toss it immediately */
+		yaffs_free_tnode(in->my_dev, in->variant.file_variant.top);
+		in->variant.file_variant.top = NULL;
+		yaffs_generic_obj_del(in);
+
+		return YAFFS_OK;
+	}
+}
+
+int yaffs_is_non_empty_dir(struct yaffs_obj *obj)
+{
+	return (obj &&
+		obj->variant_type == YAFFS_OBJECT_TYPE_DIRECTORY) &&
+		!(list_empty(&obj->variant.dir_variant.children));
+}
+
+static int yaffs_del_dir(struct yaffs_obj *obj)
+{
+	/* First check that the directory is empty. */
+	if (yaffs_is_non_empty_dir(obj))
+		return YAFFS_FAIL;
+
+	return yaffs_generic_obj_del(obj);
+}
+
+static int yaffs_del_symlink(struct yaffs_obj *in)
+{
+	kfree(in->variant.symlink_variant.alias);
+	in->variant.symlink_variant.alias = NULL;
+
+	return yaffs_generic_obj_del(in);
+}
+
+static int yaffs_del_link(struct yaffs_obj *in)
+{
+	/* remove this hardlink from the list associated with the equivalent
+	 * object
+	 */
+	list_del_init(&in->hard_links);
+	return yaffs_generic_obj_del(in);
+}
+
+int yaffs_del_obj(struct yaffs_obj *obj)
+{
+	int ret_val = -1;
+
+	switch (obj->variant_type) {
+	case YAFFS_OBJECT_TYPE_FILE:
+		ret_val = yaffs_del_file(obj);
+		break;
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+		if (!list_empty(&obj->variant.dir_variant.dirty)) {
+			yaffs_trace(YAFFS_TRACE_BACKGROUND,
+				"Remove object %d from dirty directories",
+				obj->obj_id);
+			list_del_init(&obj->variant.dir_variant.dirty);
+		}
+		return yaffs_del_dir(obj);
+		break;
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+		ret_val = yaffs_del_symlink(obj);
+		break;
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+		ret_val = yaffs_del_link(obj);
+		break;
+	case YAFFS_OBJECT_TYPE_SPECIAL:
+		ret_val = yaffs_generic_obj_del(obj);
+		break;
+	case YAFFS_OBJECT_TYPE_UNKNOWN:
+		ret_val = 0;
+		break;		/* should not happen. */
+	}
+	return ret_val;
+}
+
+
+static void yaffs_empty_dir_to_dir(struct yaffs_obj *from_dir,
+				   struct yaffs_obj *to_dir)
+{
+	struct yaffs_obj *obj;
+	struct list_head *lh;
+	struct list_head *n;
+
+	list_for_each_safe(lh, n, &from_dir->variant.dir_variant.children) {
+		obj = list_entry(lh, struct yaffs_obj, siblings);
+		yaffs_add_obj_to_dir(to_dir, obj);
+	}
+}
+
+struct yaffs_obj *yaffs_retype_obj(struct yaffs_obj *obj,
+				   enum yaffs_obj_type type)
+{
+	/* Tear down the old variant */
+	switch (obj->variant_type) {
+	case YAFFS_OBJECT_TYPE_FILE:
+		/* Nuke file data */
+		yaffs_resize_file(obj, 0);
+		yaffs_free_tnode(obj->my_dev, obj->variant.file_variant.top);
+		obj->variant.file_variant.top = NULL;
+		break;
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+		/* Put the children in lost and found. */
+		yaffs_empty_dir_to_dir(obj, obj->my_dev->lost_n_found);
+		if (!list_empty(&obj->variant.dir_variant.dirty))
+			list_del_init(&obj->variant.dir_variant.dirty);
+		break;
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+		/* Nuke symplink data */
+		kfree(obj->variant.symlink_variant.alias);
+		obj->variant.symlink_variant.alias = NULL;
+		break;
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+		list_del_init(&obj->hard_links);
+		break;
+	default:
+		break;
+	}
+
+	memset(&obj->variant, 0, sizeof(obj->variant));
+
+	/*Set up new variant if the memset is not enough. */
+	switch (type) {
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+		INIT_LIST_HEAD(&obj->variant.dir_variant.children);
+		INIT_LIST_HEAD(&obj->variant.dir_variant.dirty);
+		break;
+	case YAFFS_OBJECT_TYPE_FILE:
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+	default:
+		break;
+	}
+
+	obj->variant_type = type;
+
+	return obj;
+
+}
+
+static int yaffs_unlink_worker(struct yaffs_obj *obj)
+{
+	int del_now = 0;
+
+	if (!obj)
+		return YAFFS_FAIL;
+
+	if (!obj->my_inode)
+		del_now = 1;
+
+	yaffs_update_parent(obj->parent);
+
+	if (obj->variant_type == YAFFS_OBJECT_TYPE_HARDLINK) {
+		return yaffs_del_link(obj);
+	} else if (!list_empty(&obj->hard_links)) {
+		/* Curve ball: We're unlinking an object that has a hardlink.
+		 *
+		 * This problem arises because we are not strictly following
+		 * The Linux link/inode model.
+		 *
+		 * We can't really delete the object.
+		 * Instead, we do the following:
+		 * - Select a hardlink.
+		 * - Unhook it from the hard links
+		 * - Move it from its parent directory so that the rename works.
+		 * - Rename the object to the hardlink's name.
+		 * - Delete the hardlink
+		 */
+
+		struct yaffs_obj *hl;
+		struct yaffs_obj *parent;
+		int ret_val;
+		YCHAR name[YAFFS_MAX_NAME_LENGTH + 1];
+
+		hl = list_entry(obj->hard_links.next, struct yaffs_obj,
+				hard_links);
+
+		yaffs_get_obj_name(hl, name, YAFFS_MAX_NAME_LENGTH + 1);
+		parent = hl->parent;
+
+		list_del_init(&hl->hard_links);
+
+		yaffs_add_obj_to_dir(obj->my_dev->unlinked_dir, hl);
+
+		ret_val = yaffs_change_obj_name(obj, parent, name, 0, 0);
+
+		if (ret_val == YAFFS_OK)
+			ret_val = yaffs_generic_obj_del(hl);
+
+		return ret_val;
+
+	} else if (del_now) {
+		switch (obj->variant_type) {
+		case YAFFS_OBJECT_TYPE_FILE:
+			return yaffs_del_file(obj);
+			break;
+		case YAFFS_OBJECT_TYPE_DIRECTORY:
+			list_del_init(&obj->variant.dir_variant.dirty);
+			return yaffs_del_dir(obj);
+			break;
+		case YAFFS_OBJECT_TYPE_SYMLINK:
+			return yaffs_del_symlink(obj);
+			break;
+		case YAFFS_OBJECT_TYPE_SPECIAL:
+			return yaffs_generic_obj_del(obj);
+			break;
+		case YAFFS_OBJECT_TYPE_HARDLINK:
+		case YAFFS_OBJECT_TYPE_UNKNOWN:
+		default:
+			return YAFFS_FAIL;
+		}
+	} else if (yaffs_is_non_empty_dir(obj)) {
+		return YAFFS_FAIL;
+	} else {
+		return yaffs_change_obj_name(obj, obj->my_dev->unlinked_dir,
+						_Y("unlinked"), 0, 0);
+	}
+}
+
+int yaffs_unlink_obj(struct yaffs_obj *obj)
+{
+	if (obj && obj->unlink_allowed)
+		return yaffs_unlink_worker(obj);
+
+	return YAFFS_FAIL;
+}
+
+int yaffs_unlinker(struct yaffs_obj *dir, const YCHAR *name)
+{
+	struct yaffs_obj *obj;
+
+	obj = yaffs_find_by_name(dir, name);
+	return yaffs_unlink_obj(obj);
+}
+
+/* Note:
+ * If old_name is NULL then we take old_dir as the object to be renamed.
+ */
+int yaffs_rename_obj(struct yaffs_obj *old_dir, const YCHAR *old_name,
+		     struct yaffs_obj *new_dir, const YCHAR *new_name)
+{
+	struct yaffs_obj *obj = NULL;
+	struct yaffs_obj *existing_target = NULL;
+	int force = 0;
+	int result;
+	struct yaffs_dev *dev;
+
+	if (!old_dir || old_dir->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+		BUG();
+		return YAFFS_FAIL;
+	}
+	if (!new_dir || new_dir->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+		BUG();
+		return YAFFS_FAIL;
+	}
+
+	dev = old_dir->my_dev;
+
+#ifdef CONFIG_YAFFS_CASE_INSENSITIVE
+	/* Special case for case insemsitive systems.
+	 * While look-up is case insensitive, the name isn't.
+	 * Therefore we might want to change x.txt to X.txt
+	 */
+	if (old_dir == new_dir &&
+		old_name && new_name &&
+		strcmp(old_name, new_name) == 0)
+		force = 1;
+#endif
+
+	if (strnlen(new_name, YAFFS_MAX_NAME_LENGTH + 1) >
+	    YAFFS_MAX_NAME_LENGTH)
+		/* ENAMETOOLONG */
+		return YAFFS_FAIL;
+
+	if (old_name)
+		obj = yaffs_find_by_name(old_dir, old_name);
+	else{
+		obj = old_dir;
+		old_dir = obj->parent;
+	}
+
+	if (obj && obj->rename_allowed) {
+		/* Now handle an existing target, if there is one */
+		existing_target = yaffs_find_by_name(new_dir, new_name);
+		if (yaffs_is_non_empty_dir(existing_target)) {
+			return YAFFS_FAIL;	/* ENOTEMPTY */
+		} else if (existing_target && existing_target != obj) {
+			/* Nuke the target first, using shadowing,
+			 * but only if it isn't the same object.
+			 *
+			 * Note we must disable gc here otherwise it can mess
+			 * up the shadowing.
+			 *
+			 */
+			dev->gc_disable = 1;
+			yaffs_change_obj_name(obj, new_dir, new_name, force,
+					      existing_target->obj_id);
+			existing_target->is_shadowed = 1;
+			yaffs_unlink_obj(existing_target);
+			dev->gc_disable = 0;
+		}
+
+		result = yaffs_change_obj_name(obj, new_dir, new_name, 1, 0);
+
+		yaffs_update_parent(old_dir);
+		if (new_dir != old_dir)
+			yaffs_update_parent(new_dir);
+
+		return result;
+	}
+	return YAFFS_FAIL;
+}
+
+/*----------------------- Initialisation Scanning ---------------------- */
+
+void yaffs_handle_shadowed_obj(struct yaffs_dev *dev, int obj_id,
+			       int backward_scanning)
+{
+	struct yaffs_obj *obj;
+
+	if (backward_scanning) {
+		/* Handle YAFFS2 case (backward scanning)
+		 * If the shadowed object exists then ignore.
+		 */
+		obj = yaffs_find_by_number(dev, obj_id);
+		if (obj)
+			return;
+	}
+
+	/* Let's create it (if it does not exist) assuming it is a file so that
+	 * it can do shrinking etc.
+	 * We put it in unlinked dir to be cleaned up after the scanning
+	 */
+	obj =
+	    yaffs_find_or_create_by_number(dev, obj_id, YAFFS_OBJECT_TYPE_FILE);
+	if (!obj)
+		return;
+	obj->is_shadowed = 1;
+	yaffs_add_obj_to_dir(dev->unlinked_dir, obj);
+	obj->variant.file_variant.shrink_size = 0;
+	obj->valid = 1;		/* So that we don't read any other info. */
+}
+
+void yaffs_link_fixup(struct yaffs_dev *dev, struct list_head *hard_list)
+{
+	struct list_head *lh;
+	struct list_head *save;
+	struct yaffs_obj *hl;
+	struct yaffs_obj *in;
+
+	list_for_each_safe(lh, save, hard_list) {
+		hl = list_entry(lh, struct yaffs_obj, hard_links);
+		in = yaffs_find_by_number(dev,
+					hl->variant.hardlink_variant.equiv_id);
+
+		if (in) {
+			/* Add the hardlink pointers */
+			hl->variant.hardlink_variant.equiv_obj = in;
+			list_add(&hl->hard_links, &in->hard_links);
+		} else {
+			/* Todo Need to report/handle this better.
+			 * Got a problem... hardlink to a non-existant object
+			 */
+			hl->variant.hardlink_variant.equiv_obj = NULL;
+			INIT_LIST_HEAD(&hl->hard_links);
+		}
+	}
+}
+
+static void yaffs_strip_deleted_objs(struct yaffs_dev *dev)
+{
+	/*
+	 *  Sort out state of unlinked and deleted objects after scanning.
+	 */
+	struct list_head *i;
+	struct list_head *n;
+	struct yaffs_obj *l;
+
+	if (dev->read_only)
+		return;
+
+	/* Soft delete all the unlinked files */
+	list_for_each_safe(i, n,
+			   &dev->unlinked_dir->variant.dir_variant.children) {
+		l = list_entry(i, struct yaffs_obj, siblings);
+		yaffs_del_obj(l);
+	}
+
+	list_for_each_safe(i, n, &dev->del_dir->variant.dir_variant.children) {
+		l = list_entry(i, struct yaffs_obj, siblings);
+		yaffs_del_obj(l);
+	}
+}
+
+/*
+ * This code iterates through all the objects making sure that they are rooted.
+ * Any unrooted objects are re-rooted in lost+found.
+ * An object needs to be in one of:
+ * - Directly under deleted, unlinked
+ * - Directly or indirectly under root.
+ *
+ * Note:
+ *  This code assumes that we don't ever change the current relationships
+ *  between directories:
+ *   root_dir->parent == unlinked_dir->parent == del_dir->parent == NULL
+ *   lost-n-found->parent == root_dir
+ *
+ * This fixes the problem where directories might have inadvertently been
+ * deleted leaving the object "hanging" without being rooted in the
+ * directory tree.
+ */
+
+static int yaffs_has_null_parent(struct yaffs_dev *dev, struct yaffs_obj *obj)
+{
+	return (obj == dev->del_dir ||
+		obj == dev->unlinked_dir || obj == dev->root_dir);
+}
+
+static void yaffs_fix_hanging_objs(struct yaffs_dev *dev)
+{
+	struct yaffs_obj *obj;
+	struct yaffs_obj *parent;
+	int i;
+	struct list_head *lh;
+	struct list_head *n;
+	int depth_limit;
+	int hanging;
+
+	if (dev->read_only)
+		return;
+
+	/* Iterate through the objects in each hash entry,
+	 * looking at each object.
+	 * Make sure it is rooted.
+	 */
+
+	for (i = 0; i < YAFFS_NOBJECT_BUCKETS; i++) {
+		list_for_each_safe(lh, n, &dev->obj_bucket[i].list) {
+			obj = list_entry(lh, struct yaffs_obj, hash_link);
+			parent = obj->parent;
+
+			if (yaffs_has_null_parent(dev, obj)) {
+				/* These directories are not hanging */
+				hanging = 0;
+			} else if (!parent ||
+				   parent->variant_type !=
+				   YAFFS_OBJECT_TYPE_DIRECTORY) {
+				hanging = 1;
+			} else if (yaffs_has_null_parent(dev, parent)) {
+				hanging = 0;
+			} else {
+				/*
+				 * Need to follow the parent chain to
+				 * see if it is hanging.
+				 */
+				hanging = 0;
+				depth_limit = 100;
+
+				while (parent != dev->root_dir &&
+				       parent->parent &&
+				       parent->parent->variant_type ==
+				       YAFFS_OBJECT_TYPE_DIRECTORY &&
+				       depth_limit > 0) {
+					parent = parent->parent;
+					depth_limit--;
+				}
+				if (parent != dev->root_dir)
+					hanging = 1;
+			}
+			if (hanging) {
+				yaffs_trace(YAFFS_TRACE_SCAN,
+					"Hanging object %d moved to lost and found",
+					obj->obj_id);
+				yaffs_add_obj_to_dir(dev->lost_n_found, obj);
+			}
+		}
+	}
+}
+
+/*
+ * Delete directory contents for cleaning up lost and found.
+ */
+static void yaffs_del_dir_contents(struct yaffs_obj *dir)
+{
+	struct yaffs_obj *obj;
+	struct list_head *lh;
+	struct list_head *n;
+
+	if (dir->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY)
+		BUG();
+
+	list_for_each_safe(lh, n, &dir->variant.dir_variant.children) {
+		obj = list_entry(lh, struct yaffs_obj, siblings);
+		if (obj->variant_type == YAFFS_OBJECT_TYPE_DIRECTORY)
+			yaffs_del_dir_contents(obj);
+		yaffs_trace(YAFFS_TRACE_SCAN,
+			"Deleting lost_found object %d",
+			obj->obj_id);
+		yaffs_unlink_obj(obj);
+	}
+}
+
+static void yaffs_empty_l_n_f(struct yaffs_dev *dev)
+{
+	yaffs_del_dir_contents(dev->lost_n_found);
+}
+
+
+struct yaffs_obj *yaffs_find_by_name(struct yaffs_obj *directory,
+				     const YCHAR *name)
+{
+	int sum;
+	struct list_head *i;
+	YCHAR buffer[YAFFS_MAX_NAME_LENGTH + 1];
+	struct yaffs_obj *l;
+
+	if (!name)
+		return NULL;
+
+	if (!directory) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"tragedy: yaffs_find_by_name: null pointer directory"
+			);
+		BUG();
+		return NULL;
+	}
+	if (directory->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"tragedy: yaffs_find_by_name: non-directory"
+			);
+		BUG();
+	}
+
+	sum = yaffs_calc_name_sum(name);
+
+	list_for_each(i, &directory->variant.dir_variant.children) {
+		l = list_entry(i, struct yaffs_obj, siblings);
+
+		if (l->parent != directory)
+			BUG();
+
+		yaffs_check_obj_details_loaded(l);
+
+		/* Special case for lost-n-found */
+		if (l->obj_id == YAFFS_OBJECTID_LOSTNFOUND) {
+			if (!strcmp(name, YAFFS_LOSTNFOUND_NAME))
+				return l;
+		} else if (l->sum == sum || l->hdr_chunk <= 0) {
+			/* LostnFound chunk called Objxxx
+			 * Do a real check
+			 */
+			yaffs_get_obj_name(l, buffer,
+				YAFFS_MAX_NAME_LENGTH + 1);
+			if (!strncmp(name, buffer, YAFFS_MAX_NAME_LENGTH))
+				return l;
+		}
+	}
+	return NULL;
+}
+
+/* GetEquivalentObject dereferences any hard links to get to the
+ * actual object.
+ */
+
+struct yaffs_obj *yaffs_get_equivalent_obj(struct yaffs_obj *obj)
+{
+	if (obj && obj->variant_type == YAFFS_OBJECT_TYPE_HARDLINK) {
+		obj = obj->variant.hardlink_variant.equiv_obj;
+		yaffs_check_obj_details_loaded(obj);
+	}
+	return obj;
+}
+
+/*
+ *  A note or two on object names.
+ *  * If the object name is missing, we then make one up in the form objnnn
+ *
+ *  * ASCII names are stored in the object header's name field from byte zero
+ *  * Unicode names are historically stored starting from byte zero.
+ *
+ * Then there are automatic Unicode names...
+ * The purpose of these is to save names in a way that can be read as
+ * ASCII or Unicode names as appropriate, thus allowing a Unicode and ASCII
+ * system to share files.
+ *
+ * These automatic unicode are stored slightly differently...
+ *  - If the name can fit in the ASCII character space then they are saved as
+ *    ascii names as per above.
+ *  - If the name needs Unicode then the name is saved in Unicode
+ *    starting at oh->name[1].
+
+ */
+static void yaffs_fix_null_name(struct yaffs_obj *obj, YCHAR *name,
+				int buffer_size)
+{
+	/* Create an object name if we could not find one. */
+	if (strnlen(name, YAFFS_MAX_NAME_LENGTH) == 0) {
+		YCHAR local_name[20];
+		YCHAR num_string[20];
+		YCHAR *x = &num_string[19];
+		unsigned v = obj->obj_id;
+		num_string[19] = 0;
+		while (v > 0) {
+			x--;
+			*x = '0' + (v % 10);
+			v /= 10;
+		}
+		/* make up a name */
+		strcpy(local_name, YAFFS_LOSTNFOUND_PREFIX);
+		strcat(local_name, x);
+		strncpy(name, local_name, buffer_size - 1);
+	}
+}
+
+int yaffs_get_obj_name(struct yaffs_obj *obj, YCHAR *name, int buffer_size)
+{
+	memset(name, 0, buffer_size * sizeof(YCHAR));
+	yaffs_check_obj_details_loaded(obj);
+	if (obj->obj_id == YAFFS_OBJECTID_LOSTNFOUND) {
+		strncpy(name, YAFFS_LOSTNFOUND_NAME, buffer_size - 1);
+	} else if (obj->short_name[0]) {
+		strcpy(name, obj->short_name);
+	} else if (obj->hdr_chunk > 0) {
+		int result;
+		u8 *buffer = yaffs_get_temp_buffer(obj->my_dev);
+
+		struct yaffs_obj_hdr *oh = (struct yaffs_obj_hdr *)buffer;
+
+		memset(buffer, 0, obj->my_dev->data_bytes_per_chunk);
+
+		if (obj->hdr_chunk > 0) {
+			result = yaffs_rd_chunk_tags_nand(obj->my_dev,
+							  obj->hdr_chunk,
+							  buffer, NULL);
+		}
+		if (result == YAFFS_OK)
+			yaffs_load_name_from_oh(obj->my_dev, name, oh->name,
+					buffer_size);
+
+		yaffs_release_temp_buffer(obj->my_dev, buffer);
+	}
+
+	yaffs_fix_null_name(obj, name, buffer_size);
+
+	return strnlen(name, YAFFS_MAX_NAME_LENGTH);
+}
+
+loff_t yaffs_get_obj_length(struct yaffs_obj *obj)
+{
+	/* Dereference any hard linking */
+	obj = yaffs_get_equivalent_obj(obj);
+
+	if (obj->variant_type == YAFFS_OBJECT_TYPE_FILE)
+		return obj->variant.file_variant.file_size;
+	if (obj->variant_type == YAFFS_OBJECT_TYPE_SYMLINK) {
+		if (!obj->variant.symlink_variant.alias)
+			return 0;
+		return strnlen(obj->variant.symlink_variant.alias,
+				     YAFFS_MAX_ALIAS_LENGTH);
+	} else {
+		/* Only a directory should drop through to here */
+		return obj->my_dev->data_bytes_per_chunk;
+	}
+}
+
+int yaffs_get_obj_link_count(struct yaffs_obj *obj)
+{
+	int count = 0;
+	struct list_head *i;
+
+	if (!obj->unlinked)
+		count++;	/* the object itself */
+
+	list_for_each(i, &obj->hard_links)
+	    count++;		/* add the hard links; */
+
+	return count;
+}
+
+int yaffs_get_obj_inode(struct yaffs_obj *obj)
+{
+	obj = yaffs_get_equivalent_obj(obj);
+
+	return obj->obj_id;
+}
+
+unsigned yaffs_get_obj_type(struct yaffs_obj *obj)
+{
+	obj = yaffs_get_equivalent_obj(obj);
+
+	switch (obj->variant_type) {
+	case YAFFS_OBJECT_TYPE_FILE:
+		return DT_REG;
+		break;
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+		return DT_DIR;
+		break;
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+		return DT_LNK;
+		break;
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+		return DT_REG;
+		break;
+	case YAFFS_OBJECT_TYPE_SPECIAL:
+		if (S_ISFIFO(obj->yst_mode))
+			return DT_FIFO;
+		if (S_ISCHR(obj->yst_mode))
+			return DT_CHR;
+		if (S_ISBLK(obj->yst_mode))
+			return DT_BLK;
+		if (S_ISSOCK(obj->yst_mode))
+			return DT_SOCK;
+		return DT_REG;
+		break;
+	default:
+		return DT_REG;
+		break;
+	}
+}
+
+YCHAR *yaffs_get_symlink_alias(struct yaffs_obj *obj)
+{
+	obj = yaffs_get_equivalent_obj(obj);
+	if (obj->variant_type == YAFFS_OBJECT_TYPE_SYMLINK)
+		return yaffs_clone_str(obj->variant.symlink_variant.alias);
+	else
+		return yaffs_clone_str(_Y(""));
+}
+
+/*--------------------------- Initialisation code -------------------------- */
+
+static int yaffs_check_dev_fns(struct yaffs_dev *dev)
+{
+	struct yaffs_driver *drv = &dev->drv;
+	struct yaffs_tags_handler *tagger = &dev->tagger;
+
+	/* Common functions, gotta have */
+	if (!drv->drv_read_chunk_fn ||
+	    !drv->drv_write_chunk_fn ||
+	    !drv->drv_erase_fn)
+		return 0;
+
+	if (dev->param.is_yaffs2 &&
+	     (!drv->drv_mark_bad_fn  || !drv->drv_check_bad_fn))
+		return 0;
+
+	/* Install the default tags marshalling functions if needed. */
+	yaffs_tags_compat_install(dev);
+	yaffs_tags_marshall_install(dev);
+
+	/* Check we now have the marshalling functions required. */
+	if (!tagger->write_chunk_tags_fn ||
+	    !tagger->read_chunk_tags_fn ||
+	    !tagger->query_block_fn ||
+	    !tagger->mark_bad_fn)
+		return 0;
+
+	return 1;
+}
+
+static int yaffs_create_initial_dir(struct yaffs_dev *dev)
+{
+	/* Initialise the unlinked, deleted, root and lost+found directories */
+	dev->lost_n_found = NULL;
+	dev->root_dir = NULL;
+	dev->unlinked_dir = NULL;
+	dev->del_dir = NULL;
+
+	dev->unlinked_dir =
+	    yaffs_create_fake_dir(dev, YAFFS_OBJECTID_UNLINKED, S_IFDIR);
+	dev->del_dir =
+	    yaffs_create_fake_dir(dev, YAFFS_OBJECTID_DELETED, S_IFDIR);
+	dev->root_dir =
+	    yaffs_create_fake_dir(dev, YAFFS_OBJECTID_ROOT,
+				  YAFFS_ROOT_MODE | S_IFDIR);
+	dev->lost_n_found =
+	    yaffs_create_fake_dir(dev, YAFFS_OBJECTID_LOSTNFOUND,
+				  YAFFS_LOSTNFOUND_MODE | S_IFDIR);
+
+	if (dev->lost_n_found &&
+		dev->root_dir &&
+		dev->unlinked_dir &&
+		dev->del_dir) {
+			/* If lost-n-found is hidden then yank it out of the directory tree. */
+			if (dev->param.hide_lost_n_found)
+				list_del_init(&dev->lost_n_found->siblings);
+			else
+				yaffs_add_obj_to_dir(dev->root_dir, dev->lost_n_found);
+		return YAFFS_OK;
+	}
+	return YAFFS_FAIL;
+}
+
+/* Low level init.
+ * Typically only used by yaffs_guts_initialise, but also used by the
+ * Low level yaffs driver tests.
+ */
+
+int yaffs_guts_ll_init(struct yaffs_dev *dev)
+{
+
+
+	yaffs_trace(YAFFS_TRACE_TRACING, "yaffs: yaffs_ll_init()");
+
+	if (!dev) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"yaffs: Need a device"
+			);
+		return YAFFS_FAIL;
+	}
+
+	if (dev->ll_init)
+		return YAFFS_OK;
+
+	dev->internal_start_block = dev->param.start_block;
+	dev->internal_end_block = dev->param.end_block;
+	dev->block_offset = 0;
+	dev->chunk_offset = 0;
+	dev->n_free_chunks = 0;
+
+	dev->gc_block = 0;
+
+	if (dev->param.start_block == 0) {
+		dev->internal_start_block = dev->param.start_block + 1;
+		dev->internal_end_block = dev->param.end_block + 1;
+		dev->block_offset = 1;
+		dev->chunk_offset = dev->param.chunks_per_block;
+	}
+
+	/* Check geometry parameters. */
+
+	if ((!dev->param.inband_tags && dev->param.is_yaffs2 &&
+		dev->param.total_bytes_per_chunk < 1024) ||
+		(!dev->param.is_yaffs2 &&
+			dev->param.total_bytes_per_chunk < 512) ||
+		(dev->param.inband_tags && !dev->param.is_yaffs2) ||
+		 dev->param.chunks_per_block < 2 ||
+		 dev->param.n_reserved_blocks < 2 ||
+		dev->internal_start_block <= 0 ||
+		dev->internal_end_block <= 0 ||
+		dev->internal_end_block <=
+		(dev->internal_start_block + dev->param.n_reserved_blocks + 2)
+		) {
+		/* otherwise it is too small */
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"NAND geometry problems: chunk size %d, type is yaffs%s, inband_tags %d ",
+			dev->param.total_bytes_per_chunk,
+			dev->param.is_yaffs2 ? "2" : "",
+			dev->param.inband_tags);
+		return YAFFS_FAIL;
+	}
+
+	/* Sort out space for inband tags, if required */
+	if (dev->param.inband_tags)
+		dev->data_bytes_per_chunk =
+		    dev->param.total_bytes_per_chunk -
+		    sizeof(struct yaffs_packed_tags2_tags_only);
+	else
+		dev->data_bytes_per_chunk = dev->param.total_bytes_per_chunk;
+
+	/* Got the right mix of functions? */
+	if (!yaffs_check_dev_fns(dev)) {
+		/* Function missing */
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"device function(s) missing or wrong");
+
+		return YAFFS_FAIL;
+	}
+
+	if (yaffs_init_nand(dev) != YAFFS_OK) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS, "InitialiseNAND failed");
+		return YAFFS_FAIL;
+	}
+
+	return YAFFS_OK;
+}
+
+
+int yaffs_guts_format_dev(struct yaffs_dev *dev)
+{
+	u32 i;
+	enum yaffs_block_state state;
+	u32 dummy;
+
+	if(yaffs_guts_ll_init(dev) != YAFFS_OK)
+		return YAFFS_FAIL;
+
+	if(dev->is_mounted)
+		return YAFFS_FAIL;
+
+	for (i = dev->internal_start_block; i <= dev->internal_end_block; i++) {
+		yaffs_query_init_block_state(dev, i, &state, &dummy);
+		if (state != YAFFS_BLOCK_STATE_DEAD)
+			yaffs_erase_block(dev, i);
+	}
+
+	return YAFFS_OK;
+}
+
+
+int yaffs_guts_initialise(struct yaffs_dev *dev)
+{
+	int init_failed = 0;
+	u32 x;
+	u32 bits;
+
+	if(yaffs_guts_ll_init(dev) != YAFFS_OK)
+		return YAFFS_FAIL;
+
+	if (dev->is_mounted) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS, "device already mounted");
+		return YAFFS_FAIL;
+	}
+
+	dev->is_mounted = 1;
+
+	/* OK now calculate a few things for the device */
+
+	/*
+	 *  Calculate all the chunk size manipulation numbers:
+	 */
+	x = dev->data_bytes_per_chunk;
+	/* We always use dev->chunk_shift and dev->chunk_div */
+	dev->chunk_shift = calc_shifts(x);
+	x >>= dev->chunk_shift;
+	dev->chunk_div = x;
+	/* We only use chunk mask if chunk_div is 1 */
+	dev->chunk_mask = (1 << dev->chunk_shift) - 1;
+
+	/*
+	 * Calculate chunk_grp_bits.
+	 * We need to find the next power of 2 > than internal_end_block
+	 */
+
+	x = dev->param.chunks_per_block * (dev->internal_end_block + 1);
+
+	bits = calc_shifts_ceiling(x);
+
+	/* Set up tnode width if wide tnodes are enabled. */
+	if (!dev->param.wide_tnodes_disabled) {
+		/* bits must be even so that we end up with 32-bit words */
+		if (bits & 1)
+			bits++;
+		if (bits < 16)
+			dev->tnode_width = 16;
+		else
+			dev->tnode_width = bits;
+	} else {
+		dev->tnode_width = 16;
+	}
+
+	dev->tnode_mask = (1 << dev->tnode_width) - 1;
+
+	/* Level0 Tnodes are 16 bits or wider (if wide tnodes are enabled),
+	 * so if the bitwidth of the
+	 * chunk range we're using is greater than 16 we need
+	 * to figure out chunk shift and chunk_grp_size
+	 */
+
+	if (bits <= dev->tnode_width)
+		dev->chunk_grp_bits = 0;
+	else
+		dev->chunk_grp_bits = bits - dev->tnode_width;
+
+	dev->tnode_size = (dev->tnode_width * YAFFS_NTNODES_LEVEL0) / 8;
+	if (dev->tnode_size < sizeof(struct yaffs_tnode))
+		dev->tnode_size = sizeof(struct yaffs_tnode);
+
+	dev->chunk_grp_size = 1 << dev->chunk_grp_bits;
+
+	if (dev->param.chunks_per_block < dev->chunk_grp_size) {
+		/* We have a problem because the soft delete won't work if
+		 * the chunk group size > chunks per block.
+		 * This can be remedied by using larger "virtual blocks".
+		 */
+		yaffs_trace(YAFFS_TRACE_ALWAYS, "chunk group too large");
+
+		return YAFFS_FAIL;
+	}
+
+	/* Finished verifying the device, continue with initialisation */
+
+	/* More device initialisation */
+	dev->all_gcs = 0;
+	dev->passive_gc_count = 0;
+	dev->oldest_dirty_gc_count = 0;
+	dev->bg_gcs = 0;
+	dev->gc_block_finder = 0;
+	dev->buffered_block = -1;
+	dev->doing_buffered_block_rewrite = 0;
+	dev->n_deleted_files = 0;
+	dev->n_bg_deletions = 0;
+	dev->n_unlinked_files = 0;
+	dev->n_ecc_fixed = 0;
+	dev->n_ecc_unfixed = 0;
+	dev->n_tags_ecc_fixed = 0;
+	dev->n_tags_ecc_unfixed = 0;
+	dev->n_erase_failures = 0;
+	dev->n_erased_blocks = 0;
+	dev->gc_disable = 0;
+	dev->has_pending_prioritised_gc = 1; /* Assume the worst for now,
+					      * will get fixed on first GC */
+	INIT_LIST_HEAD(&dev->dirty_dirs);
+	dev->oldest_dirty_seq = 0;
+	dev->oldest_dirty_block = 0;
+
+	yaffs_endian_config(dev);
+
+	/* Initialise temporary buffers and caches. */
+	if (!yaffs_init_tmp_buffers(dev))
+		init_failed = 1;
+
+	dev->cache = NULL;
+	dev->gc_cleanup_list = NULL;
+
+	if (!init_failed && dev->param.n_caches > 0) {
+		u32 i;
+		void *buf;
+		u32 cache_bytes =
+		    dev->param.n_caches * sizeof(struct yaffs_cache);
+
+		if (dev->param.n_caches > YAFFS_MAX_SHORT_OP_CACHES)
+			dev->param.n_caches = YAFFS_MAX_SHORT_OP_CACHES;
+
+		dev->cache = kmalloc(cache_bytes, GFP_NOFS);
+
+		buf = (u8 *) dev->cache;
+
+		if (dev->cache)
+			memset(dev->cache, 0, cache_bytes);
+
+		for (i = 0; i < dev->param.n_caches && buf; i++) {
+			dev->cache[i].object = NULL;
+			dev->cache[i].last_use = 0;
+			dev->cache[i].dirty = 0;
+			dev->cache[i].data = buf =
+			    kmalloc(dev->param.total_bytes_per_chunk, GFP_NOFS);
+		}
+		if (!buf)
+			init_failed = 1;
+
+		dev->cache_last_use = 0;
+	}
+
+	dev->cache_hits = 0;
+
+	if (!init_failed) {
+		dev->gc_cleanup_list =
+		    kmalloc(dev->param.chunks_per_block * sizeof(u32),
+					GFP_NOFS);
+		if (!dev->gc_cleanup_list)
+			init_failed = 1;
+	}
+
+	if (dev->param.is_yaffs2)
+		dev->param.use_header_file_size = 1;
+
+	if (!init_failed && !yaffs_init_blocks(dev))
+		init_failed = 1;
+
+	yaffs_init_tnodes_and_objs(dev);
+
+	if (!init_failed && !yaffs_create_initial_dir(dev))
+		init_failed = 1;
+
+	if (!init_failed && dev->param.is_yaffs2 &&
+		!dev->param.disable_summary &&
+		!yaffs_summary_init(dev))
+		init_failed = 1;
+
+	if (!init_failed) {
+		/* Now scan the flash. */
+		if (dev->param.is_yaffs2) {
+			if (yaffs2_checkpt_restore(dev)) {
+				yaffs_check_obj_details_loaded(dev->root_dir);
+				yaffs_trace(YAFFS_TRACE_CHECKPOINT |
+					YAFFS_TRACE_MOUNT,
+					"yaffs: restored from checkpoint"
+					);
+			} else {
+
+				/* Clean up the mess caused by an aborted
+				 * checkpoint load then scan backwards.
+				 */
+				yaffs_deinit_blocks(dev);
+
+				yaffs_deinit_tnodes_and_objs(dev);
+
+				dev->n_erased_blocks = 0;
+				dev->n_free_chunks = 0;
+				dev->alloc_block = -1;
+				dev->alloc_page = -1;
+				dev->n_deleted_files = 0;
+				dev->n_unlinked_files = 0;
+				dev->n_bg_deletions = 0;
+
+				if (!init_failed && !yaffs_init_blocks(dev))
+					init_failed = 1;
+
+				yaffs_init_tnodes_and_objs(dev);
+
+				if (!init_failed
+				    && !yaffs_create_initial_dir(dev))
+					init_failed = 1;
+
+				if (!init_failed && !yaffs2_scan_backwards(dev))
+					init_failed = 1;
+			}
+		} else if (!yaffs1_scan(dev)) {
+			init_failed = 1;
+		}
+
+		yaffs_strip_deleted_objs(dev);
+		yaffs_fix_hanging_objs(dev);
+		if (dev->param.empty_lost_n_found)
+			yaffs_empty_l_n_f(dev);
+	}
+
+	if (init_failed) {
+		/* Clean up the mess */
+		yaffs_trace(YAFFS_TRACE_TRACING,
+		  "yaffs: yaffs_guts_initialise() aborted.");
+
+		yaffs_deinitialise(dev);
+		return YAFFS_FAIL;
+	}
+
+	/* Zero out stats */
+	dev->n_page_reads = 0;
+	dev->n_page_writes = 0;
+	dev->n_erasures = 0;
+	dev->n_gc_copies = 0;
+	dev->n_retried_writes = 0;
+
+	dev->n_retired_blocks = 0;
+
+	yaffs_verify_free_chunks(dev);
+	yaffs_verify_blocks(dev);
+
+	/* Clean up any aborted checkpoint data */
+	if (!dev->is_checkpointed && dev->blocks_in_checkpt > 0)
+		yaffs2_checkpt_invalidate(dev);
+
+	yaffs_trace(YAFFS_TRACE_TRACING,
+	  "yaffs: yaffs_guts_initialise() done.");
+	return YAFFS_OK;
+}
+
+void yaffs_deinitialise(struct yaffs_dev *dev)
+{
+	if (dev->is_mounted) {
+		u32 i;
+
+		yaffs_deinit_blocks(dev);
+		yaffs_deinit_tnodes_and_objs(dev);
+		yaffs_summary_deinit(dev);
+
+		if (dev->param.n_caches > 0 && dev->cache) {
+
+			for (i = 0; i < dev->param.n_caches; i++) {
+				kfree(dev->cache[i].data);
+				dev->cache[i].data = NULL;
+			}
+
+			kfree(dev->cache);
+			dev->cache = NULL;
+		}
+
+		kfree(dev->gc_cleanup_list);
+
+		for (i = 0; i < YAFFS_N_TEMP_BUFFERS; i++) {
+			kfree(dev->temp_buffer[i].buffer);
+			dev->temp_buffer[i].buffer = NULL;
+		}
+
+		kfree(dev->checkpt_buffer);
+		dev->checkpt_buffer = NULL;
+		kfree(dev->checkpt_block_list);
+		dev->checkpt_block_list = NULL;
+
+		dev->is_mounted = 0;
+
+		yaffs_deinit_nand(dev);
+	}
+}
+
+int yaffs_count_free_chunks(struct yaffs_dev *dev)
+{
+	int n_free = 0;
+	u32 b;
+	struct yaffs_block_info *blk;
+
+	blk = dev->block_info;
+	for (b = dev->internal_start_block; b <= dev->internal_end_block; b++) {
+		switch (blk->block_state) {
+		case YAFFS_BLOCK_STATE_EMPTY:
+		case YAFFS_BLOCK_STATE_ALLOCATING:
+		case YAFFS_BLOCK_STATE_COLLECTING:
+		case YAFFS_BLOCK_STATE_FULL:
+			n_free +=
+			    (dev->param.chunks_per_block - blk->pages_in_use +
+			     blk->soft_del_pages);
+			break;
+		default:
+			break;
+		}
+		blk++;
+	}
+	return n_free;
+}
+
+int yaffs_get_n_free_chunks(struct yaffs_dev *dev)
+{
+	/* This is what we report to the outside world */
+	int n_free;
+	int n_dirty_caches;
+	int blocks_for_checkpt;
+	u32 i;
+
+	n_free = dev->n_free_chunks;
+	n_free += dev->n_deleted_files;
+
+	/* Now count and subtract the number of dirty chunks in the cache. */
+
+	for (n_dirty_caches = 0, i = 0; i < dev->param.n_caches; i++) {
+		if (dev->cache[i].dirty)
+			n_dirty_caches++;
+	}
+
+	n_free -= n_dirty_caches;
+
+	n_free -=
+	    ((dev->param.n_reserved_blocks + 1) * dev->param.chunks_per_block);
+
+	/* Now figure checkpoint space and report that... */
+	blocks_for_checkpt = yaffs_calc_checkpt_blocks_required(dev);
+
+	n_free -= (blocks_for_checkpt * dev->param.chunks_per_block);
+
+	if (n_free < 0)
+		n_free = 0;
+
+	return n_free;
+}
+
+
+/*
+ * Marshalling functions to get loff_t file sizes into and out of
+ * object headers.
+ */
+void yaffs_oh_size_load(struct yaffs_dev *dev,
+			struct yaffs_obj_hdr *oh,
+			loff_t fsize,
+			int do_endian)
+{
+	oh->file_size_low = FSIZE_LOW(fsize);
+
+	oh->file_size_high = FSIZE_HIGH(fsize);
+
+	if (do_endian) {
+		yaffs_do_endian_u32(dev, &oh->file_size_low);
+		yaffs_do_endian_u32(dev, &oh->file_size_high);
+	}
+}
+
+loff_t yaffs_oh_to_size(struct yaffs_dev *dev, struct yaffs_obj_hdr *oh,
+			int do_endian)
+{
+	loff_t retval;
+
+
+	if (sizeof(loff_t) >= 8 && ~(oh->file_size_high)) {
+		u32 low = oh->file_size_low;
+		u32 high = oh->file_size_high;
+
+		if (do_endian) {
+			yaffs_do_endian_u32 (dev, &low);
+			yaffs_do_endian_u32 (dev, &high);
+		}
+		retval = FSIZE_COMBINE(high, low);
+	} else {
+		u32 low = oh->file_size_low;
+
+		if (do_endian)
+			yaffs_do_endian_u32(dev, &low);
+		retval = (loff_t)low;
+	}
+
+	return retval;
+}
+
+
+void yaffs_count_blocks_by_state(struct yaffs_dev *dev, int bs[10])
+{
+	u32 i;
+	struct yaffs_block_info *bi;
+	int s;
+
+	for(i = 0; i < 10; i++)
+		bs[i] = 0;
+
+	for(i = dev->internal_start_block; i <= dev->internal_end_block; i++) {
+		bi = yaffs_get_block_info(dev, i);
+		s = bi->block_state;
+		if(s > YAFFS_BLOCK_STATE_DEAD || s < YAFFS_BLOCK_STATE_UNKNOWN)
+			bs[0]++;
+		else
+			bs[s]++;
+	}
+}
diff --git a/fs/yaffs2/yaffs_guts.h b/fs/yaffs2/yaffs_guts.h
new file mode 100644
index 00000000..5ebc378
--- /dev/null
+++ b/fs/yaffs2/yaffs_guts.h
@@ -0,0 +1,1069 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_GUTS_H__
+#define __YAFFS_GUTS_H__
+
+#include "yportenv.h"
+
+#define YAFFS_OK	1
+#define YAFFS_FAIL  0
+
+/* Give us a  Y=0x59,
+ * Give us an A=0x41,
+ * Give us an FF=0xff
+ * Give us an S=0x53
+ * And what have we got...
+ */
+#define YAFFS_MAGIC			0x5941ff53
+
+/*
+ * Tnodes form a tree with the tnodes in "levels"
+ * Levels greater than 0 hold 8 slots which point to other tnodes.
+ * Those at level 0 hold 16 slots which point to chunks in NAND.
+ *
+ * A maximum level of 8 thust supports files of size up to:
+ *
+ * 2^(3*MAX_LEVEL+4)
+ *
+ * Thus a max level of 8 supports files with up to 2^^28 chunks which gives
+ * a maximum file size of around 512Gbytees with 2k chunks.
+ */
+#define YAFFS_NTNODES_LEVEL0		16
+#define YAFFS_TNODES_LEVEL0_BITS	4
+#define YAFFS_TNODES_LEVEL0_MASK	0xf
+
+#define YAFFS_NTNODES_INTERNAL		(YAFFS_NTNODES_LEVEL0 / 2)
+#define YAFFS_TNODES_INTERNAL_BITS	(YAFFS_TNODES_LEVEL0_BITS - 1)
+#define YAFFS_TNODES_INTERNAL_MASK	0x7
+#define YAFFS_TNODES_MAX_LEVEL		8
+#define YAFFS_TNODES_MAX_BITS		(YAFFS_TNODES_LEVEL0_BITS + \
+					YAFFS_TNODES_INTERNAL_BITS * \
+					YAFFS_TNODES_MAX_LEVEL)
+#define YAFFS_MAX_CHUNK_ID		((1 << YAFFS_TNODES_MAX_BITS) - 1)
+
+#define YAFFS_MAX_FILE_SIZE_32		0x7fffffff
+
+/* Constants for YAFFS1 mode */
+#define YAFFS_BYTES_PER_SPARE		16
+#define YAFFS_BYTES_PER_CHUNK		512
+#define YAFFS_CHUNK_SIZE_SHIFT		9
+#define YAFFS_CHUNKS_PER_BLOCK		32
+#define YAFFS_BYTES_PER_BLOCK	(YAFFS_CHUNKS_PER_BLOCK*YAFFS_BYTES_PER_CHUNK)
+
+#define YAFFS_MIN_YAFFS2_CHUNK_SIZE	1024
+#define YAFFS_MIN_YAFFS2_SPARE_SIZE	32
+
+
+
+#define YAFFS_ALLOCATION_NOBJECTS	100
+#define YAFFS_ALLOCATION_NTNODES	100
+#define YAFFS_ALLOCATION_NLINKS		100
+
+#define YAFFS_NOBJECT_BUCKETS		256
+
+#define YAFFS_OBJECT_SPACE		0x40000
+#define YAFFS_MAX_OBJECT_ID		(YAFFS_OBJECT_SPACE - 1)
+
+/* Binary data version stamps */
+#define YAFFS_SUMMARY_VERSION		1
+
+#ifdef CONFIG_YAFFS_UNICODE
+#define YAFFS_MAX_NAME_LENGTH		127
+#define YAFFS_MAX_ALIAS_LENGTH		79
+#else
+#define YAFFS_MAX_NAME_LENGTH		255
+#define YAFFS_MAX_ALIAS_LENGTH		159
+#endif
+
+#define YAFFS_SHORT_NAME_LENGTH		15
+
+/* Some special object ids for pseudo objects */
+#define YAFFS_OBJECTID_ROOT		1
+#define YAFFS_OBJECTID_LOSTNFOUND	2
+#define YAFFS_OBJECTID_UNLINKED		3
+#define YAFFS_OBJECTID_DELETED		4
+
+/* Fake object Id for summary data */
+#define YAFFS_OBJECTID_SUMMARY		0x10
+
+/* Pseudo object ids for checkpointing */
+#define YAFFS_OBJECTID_CHECKPOINT_DATA	0x20
+#define YAFFS_SEQUENCE_CHECKPOINT_DATA	0x21
+
+#define YAFFS_MAX_SHORT_OP_CACHES	20
+
+#define YAFFS_N_TEMP_BUFFERS		6
+
+/* We limit the number attempts at sucessfully saving a chunk of data.
+ * Small-page devices have 32 pages per block; large-page devices have 64.
+ * Default to something in the order of 5 to 10 blocks worth of chunks.
+ */
+#define YAFFS_WR_ATTEMPTS		(5*64)
+
+/* Sequence numbers are used in YAFFS2 to determine block allocation order.
+ * The range is limited slightly to help distinguish bad numbers from good.
+ * This also allows us to perhaps in the future use special numbers for
+ * special purposes.
+ * EFFFFF00 allows the allocation of 8 blocks/second (~1Mbytes) for 15 years,
+ * and is a larger number than the lifetime of a 2GB device.
+ */
+#define YAFFS_LOWEST_SEQUENCE_NUMBER	0x00001000
+#define YAFFS_HIGHEST_SEQUENCE_NUMBER	0xefffff00
+
+/* Special sequence number for bad block that failed to be marked bad */
+#define YAFFS_SEQUENCE_BAD_BLOCK	0xffff0000
+
+/* ChunkCache is used for short read/write operations.*/
+struct yaffs_cache {
+	struct yaffs_obj *object;
+	int chunk_id;
+	int last_use;
+	int dirty;
+	int n_bytes;		/* Only valid if the cache is dirty */
+	int locked;		/* Can't push out or flush while locked. */
+	u8 *data;
+};
+
+/* yaffs1 tags structures in RAM
+ * NB This uses bitfield. Bitfields should not straddle a u32 boundary
+ * otherwise the structure size will get blown out.
+ */
+
+struct yaffs_tags {
+	u32 chunk_id:20;
+	u32 serial_number:2;
+	u32 n_bytes_lsb:10;
+	u32 obj_id:18;
+	u32 ecc:12;
+	u32 n_bytes_msb:2;
+};
+
+union yaffs_tags_union {
+	struct yaffs_tags as_tags;
+	u8  as_bytes[8];
+	u32 as_u32[2];
+};
+
+
+/* Stuff used for extended tags in YAFFS2 */
+
+enum yaffs_ecc_result {
+	YAFFS_ECC_RESULT_UNKNOWN,
+	YAFFS_ECC_RESULT_NO_ERROR,
+	YAFFS_ECC_RESULT_FIXED,
+	YAFFS_ECC_RESULT_UNFIXED
+};
+
+/*
+ * Object type enum:
+ * When this is stored in flash we store it as a u32 instead
+ * to prevent any alignment change issues as compiler variants change.
+ */
+
+enum yaffs_obj_type {
+	YAFFS_OBJECT_TYPE_UNKNOWN,
+	YAFFS_OBJECT_TYPE_FILE,
+	YAFFS_OBJECT_TYPE_SYMLINK,
+	YAFFS_OBJECT_TYPE_DIRECTORY,
+	YAFFS_OBJECT_TYPE_HARDLINK,
+	YAFFS_OBJECT_TYPE_SPECIAL
+};
+
+#define YAFFS_OBJECT_TYPE_MAX YAFFS_OBJECT_TYPE_SPECIAL
+
+struct yaffs_ext_tags {
+	unsigned chunk_used;	/*  Status of the chunk: used or unused */
+	unsigned obj_id;	/* If 0 this is not used */
+	unsigned chunk_id;	/* If 0 this is a header, else a data chunk */
+	unsigned n_bytes;	/* Only valid for data chunks */
+
+	/* The following stuff only has meaning when we read */
+	enum yaffs_ecc_result ecc_result;
+	unsigned block_bad;
+
+	/* YAFFS 1 stuff */
+	unsigned is_deleted;	/* The chunk is marked deleted */
+	unsigned serial_number;	/* Yaffs1 2-bit serial number */
+
+	/* YAFFS2 stuff */
+	unsigned seq_number;	/* The sequence number of this block */
+
+	/* Extra info if this is an object header (YAFFS2 only) */
+
+	unsigned extra_available;	/* Extra info available if not zero */
+	unsigned extra_parent_id;	/* The parent object */
+	unsigned extra_is_shrink;	/* Is it a shrink header? */
+	unsigned extra_shadows;	/* Does this shadow another object? */
+
+	enum yaffs_obj_type extra_obj_type;	/* What object type? */
+
+	loff_t extra_file_size;		/* Length if it is a file */
+	unsigned extra_equiv_id;	/* Equivalent object for a hard link */
+};
+
+/* Spare structure for YAFFS1 */
+struct yaffs_spare {
+	u8 tb0;
+	u8 tb1;
+	u8 tb2;
+	u8 tb3;
+	u8 page_status;		/* set to 0 to delete the chunk */
+	u8 block_status;
+	u8 tb4;
+	u8 tb5;
+	u8 ecc1[3];
+	u8 tb6;
+	u8 tb7;
+	u8 ecc2[3];
+};
+
+/*Special structure for passing through to mtd */
+struct yaffs_nand_spare {
+	struct yaffs_spare spare;
+	int eccres1;
+	int eccres2;
+};
+
+/* Block data in RAM */
+
+enum yaffs_block_state {
+	YAFFS_BLOCK_STATE_UNKNOWN = 0,
+
+	YAFFS_BLOCK_STATE_SCANNING,
+	/* Being scanned */
+
+	YAFFS_BLOCK_STATE_NEEDS_SCAN,
+	/* The block might have something on it (ie it is allocating or full,
+	 * perhaps empty) but it needs to be scanned to determine its true
+	 * state.
+	 * This state is only valid during scanning.
+	 * NB We tolerate empty because the pre-scanner might be incapable of
+	 * deciding
+	 * However, if this state is returned on a YAFFS2 device,
+	 * then we expect a sequence number
+	 */
+
+	YAFFS_BLOCK_STATE_EMPTY,
+	/* This block is empty */
+
+	YAFFS_BLOCK_STATE_ALLOCATING,
+	/* This block is partially allocated.
+	 * At least one page holds valid data.
+	 * This is the one currently being used for page
+	 * allocation. Should never be more than one of these.
+	 * If a block is only partially allocated at mount it is treated as
+	 * full.
+	 */
+
+	YAFFS_BLOCK_STATE_FULL,
+	/* All the pages in this block have been allocated.
+	 * If a block was only partially allocated when mounted we treat
+	 * it as fully allocated.
+	 */
+
+	YAFFS_BLOCK_STATE_DIRTY,
+	/* The block was full and now all chunks have been deleted.
+	 * Erase me, reuse me.
+	 */
+
+	YAFFS_BLOCK_STATE_CHECKPOINT,
+	/* This block is assigned to holding checkpoint data. */
+
+	YAFFS_BLOCK_STATE_COLLECTING,
+	/* This block is being garbage collected */
+
+	YAFFS_BLOCK_STATE_DEAD
+	    /* This block has failed and is not in use */
+};
+
+#define	YAFFS_NUMBER_OF_BLOCK_STATES (YAFFS_BLOCK_STATE_DEAD + 1)
+
+struct yaffs_block_info {
+
+	s32 soft_del_pages:10;	/* number of soft deleted pages */
+	s32 pages_in_use:10;	/* number of pages in use */
+	u32 block_state:4;	/* One of the above block states. */
+				/* NB use unsigned because enum is sometimes
+				 * an int */
+	u32 needs_retiring:1;	/* Data has failed on this block, */
+				/*need to get valid data off and retire*/
+	u32 skip_erased_check:1;/* Skip the erased check on this block */
+	u32 gc_prioritise:1;	/* An ECC check or blank check has failed.
+				   Block should be prioritised for GC */
+	u32 chunk_error_strikes:3;	/* How many times we've had ecc etc
+				failures on this block and tried to reuse it */
+	u32 has_summary:1;	/* The block has a summary */
+
+	u32 has_shrink_hdr:1;	/* This block has at least one shrink header */
+	u32 seq_number;		/* block sequence number for yaffs2 */
+
+};
+
+union yaffs_block_info_union {
+	struct yaffs_block_info bi;
+	u32	as_u32[2];
+};
+
+/* -------------------------- Object structure -------------------------------*/
+/* This is the object structure as stored on NAND */
+
+struct yaffs_obj_hdr {
+	u32 type;  /* enum yaffs_obj_type  */
+
+	/* Apply to everything  */
+	u32 parent_obj_id;
+	u16 sum_no_longer_used;	/* checksum of name. No longer used */
+	YCHAR name[YAFFS_MAX_NAME_LENGTH + 1];
+
+	/* The following apply to all object types except for hard links */
+	u32 yst_mode;		/* protection */
+
+	u32 yst_uid;
+	u32 yst_gid;
+	u32 yst_atime;
+	u32 yst_mtime;
+	u32 yst_ctime;
+
+	/* File size  applies to files only */
+	u32 file_size_low;
+
+	/* Equivalent object id applies to hard links only. */
+	int equiv_id;
+
+	/* Alias is for symlinks only. */
+	YCHAR alias[YAFFS_MAX_ALIAS_LENGTH + 1];
+
+	u32 yst_rdev;	/* stuff for block and char devices (major/min) */
+
+	u32 win_ctime[2];
+	u32 win_atime[2];
+	u32 win_mtime[2];
+
+	u32 inband_shadowed_obj_id;
+	u32 inband_is_shrink;
+
+	u32 file_size_high;
+	u32 reserved[1];
+	int shadows_obj;	/* This object header shadows the
+				specified object if > 0 */
+
+	/* is_shrink applies to object headers written when wemake a hole. */
+	u32 is_shrink;
+
+};
+
+/*--------------------------- Tnode -------------------------- */
+
+struct yaffs_tnode {
+	struct yaffs_tnode *internal[YAFFS_NTNODES_INTERNAL];
+};
+
+/*------------------------  Object -----------------------------*/
+/* An object can be one of:
+ * - a directory (no data, has children links
+ * - a regular file (data.... not prunes :->).
+ * - a symlink [symbolic link] (the alias).
+ * - a hard link
+ */
+
+/* The file variant has three file sizes:
+ *  - file_size : size of file as written into Yaffs - including data in cache.
+ *  - stored_size - size of file as stored on media.
+ *  - shrink_size - size of file that has been shrunk back to.
+ *
+ * The stored_size and file_size might be different because the data written
+ * into the cache will increase the file_size but the stored_size will only
+ * change when the data is actually stored.
+ *
+ */
+struct yaffs_file_var {
+	loff_t file_size;
+	loff_t stored_size;
+	loff_t shrink_size;
+	int top_level;
+	struct yaffs_tnode *top;
+};
+
+struct yaffs_dir_var {
+	struct list_head children;	/* list of child links */
+	struct list_head dirty;	/* Entry for list of dirty directories */
+};
+
+struct yaffs_symlink_var {
+	YCHAR *alias;
+};
+
+struct yaffs_hardlink_var {
+	struct yaffs_obj *equiv_obj;
+	u32 equiv_id;
+};
+
+union yaffs_obj_var {
+	struct yaffs_file_var file_variant;
+	struct yaffs_dir_var dir_variant;
+	struct yaffs_symlink_var symlink_variant;
+	struct yaffs_hardlink_var hardlink_variant;
+};
+
+struct yaffs_obj {
+	u8 deleted:1;		/* This should only apply to unlinked files. */
+	u8 soft_del:1;		/* it has also been soft deleted */
+	u8 unlinked:1;		/* An unlinked file.*/
+	u8 fake:1;		/* A fake object has no presence on NAND. */
+	u8 rename_allowed:1;	/* Some objects cannot be renamed. */
+	u8 unlink_allowed:1;
+	u8 dirty:1;		/* the object needs to be written to flash */
+	u8 valid:1;		/* When the file system is being loaded up, this
+				 * object might be created before the data
+				 * is available
+				 * ie. file data chunks encountered before
+				* the header.
+				 */
+	u8 lazy_loaded:1;	/* This object has been lazy loaded and
+				 * is missing some detail */
+
+	u8 defered_free:1;	/* Object is removed from NAND, but is
+				 * still in the inode cache.
+				 * Free of object is defered.
+				 * until the inode is released.
+				 */
+	u8 being_created:1;	/* This object is still being created
+				 * so skip some verification checks. */
+	u8 is_shadowed:1;	/* This object is shadowed on the way
+				 * to being renamed. */
+
+	u8 xattr_known:1;	/* We know if this has object has xattribs
+				 * or not. */
+	u8 has_xattr:1;		/* This object has xattribs.
+				 * Only valid if xattr_known. */
+
+	u8 serial;		/* serial number of chunk in NAND.*/
+	u16 sum;		/* sum of the name to speed searching */
+
+	struct yaffs_dev *my_dev;	/* The device I'm on */
+
+	struct list_head hash_link;	/* list of objects in hash bucket */
+
+	struct list_head hard_links;	/* hard linked object chain*/
+
+	/* directory structure stuff */
+	/* also used for linking up the free list */
+	struct yaffs_obj *parent;
+	struct list_head siblings;
+
+	/* Where's my object header in NAND? */
+	int hdr_chunk;
+
+	int n_data_chunks;	/* Number of data chunks for this file. */
+
+	u32 obj_id;		/* the object id value */
+
+	u32 yst_mode;
+
+	YCHAR short_name[YAFFS_SHORT_NAME_LENGTH + 1];
+
+#ifdef CONFIG_YAFFS_WINCE
+	u32 win_ctime[2];
+	u32 win_mtime[2];
+	u32 win_atime[2];
+#else
+	u32 yst_uid;
+	u32 yst_gid;
+	u32 yst_atime;
+	u32 yst_mtime;
+	u32 yst_ctime;
+#endif
+
+	u32 yst_rdev;
+
+	void *my_inode;
+
+	u32 variant_type; /* enum yaffs_object_type */
+
+	union yaffs_obj_var variant;
+
+};
+
+struct yaffs_obj_bucket {
+	struct list_head list;
+	int count;
+};
+
+
+/*--------------------- Temporary buffers ----------------
+ *
+ * These are chunk-sized working buffers. Each device has a few.
+ */
+
+struct yaffs_buffer {
+	u8 *buffer;
+	int in_use;
+};
+
+/*----------------- Device ---------------------------------*/
+
+struct yaffs_param {
+	const YCHAR *name;
+
+	/*
+	 * Entry parameters set up way early. Yaffs sets up the rest.
+	 * The structure should be zeroed out before use so that unused
+	 * and default values are zero.
+	 */
+
+	int inband_tags;	/* Use unband tags */
+	u32 total_bytes_per_chunk;	/* Should be >= 512, does not need to
+					 be a power of 2 */
+	u32 chunks_per_block;	/* does not need to be a power of 2 */
+	u32 spare_bytes_per_chunk;	/* spare area size */
+	u32 start_block;	/* Start block we're allowed to use */
+	u32 end_block;		/* End block we're allowed to use */
+	u32 n_reserved_blocks;	/* Tuneable so that we can reduce
+				 * reserved blocks on NOR and RAM. */
+
+	u32 n_caches;		/* If == 0, then short op caching is disabled,
+				 * else the number of short op caches.
+				 */
+	int cache_bypass_aligned; /* If non-zero then bypass the cache for
+				   * aligned writes.
+				   */
+
+	int use_nand_ecc;	/* Flag to decide whether or not to use
+				 * NAND driver ECC on data (yaffs1) */
+	int tags_9bytes;	/* Use 9 byte tags */
+	int no_tags_ecc;	/* Flag to decide whether or not to do ECC
+				 * on packed tags (yaffs2) */
+
+	int is_yaffs2;		/* Use yaffs2 mode on this device */
+
+	int empty_lost_n_found;	/* Auto-empty lost+found directory on mount */
+
+	int refresh_period;	/* How often to check for a block refresh */
+
+	/* Checkpoint control. Can be set before or after initialisation */
+	u8 skip_checkpt_rd;
+	u8 skip_checkpt_wr;
+
+	int enable_xattr;	/* Enable xattribs */
+
+	int max_objects;	/*
+				 * Set to limit the number of objects created.
+				 * 0 = no limit.
+				*/
+
+	int hide_lost_n_found;  /* Set non-zero to hide the lost-n-found dir. */
+
+	int stored_endian; /* 0=cpu endian, 1=little endian, 2=big endian */
+
+	/* The remove_obj_fn function must be supplied by OS flavours that
+	 * need it.
+	 * yaffs direct uses it to implement the faster readdir.
+	 * Linux uses it to protect the directory during unlocking.
+	 */
+	void (*remove_obj_fn) (struct yaffs_obj *obj);
+
+	/* Callback to mark the superblock dirty */
+	void (*sb_dirty_fn) (struct yaffs_dev *dev);
+
+	/*  Callback to control garbage collection. */
+	unsigned (*gc_control_fn) (struct yaffs_dev *dev);
+
+	/* Debug control flags. Don't use unless you know what you're doing */
+	int use_header_file_size;	/* Flag to determine if we should use
+					 * file sizes from the header */
+	int disable_lazy_load;	/* Disable lazy loading on this device */
+	int wide_tnodes_disabled;	/* Set to disable wide tnodes */
+	int disable_soft_del;	/* yaffs 1 only: Set to disable the use of
+				 * softdeletion. */
+
+	int defered_dir_update;	/* Set to defer directory updates */
+
+#ifdef CONFIG_YAFFS_AUTO_UNICODE
+	int auto_unicode;
+#endif
+	int always_check_erased;	/* Force chunk erased check always on */
+
+	int disable_summary;
+	int disable_bad_block_marking;
+
+};
+
+struct yaffs_driver {
+	int (*drv_write_chunk_fn) (struct yaffs_dev *dev, int nand_chunk,
+				   const u8 *data, int data_len,
+				   const u8 *oob, int oob_len);
+	int (*drv_read_chunk_fn) (struct yaffs_dev *dev, int nand_chunk,
+				   u8 *data, int data_len,
+				   u8 *oob, int oob_len,
+				   enum yaffs_ecc_result *ecc_result);
+	int (*drv_erase_fn) (struct yaffs_dev *dev, int block_no);
+	int (*drv_mark_bad_fn) (struct yaffs_dev *dev, int block_no);
+	int (*drv_check_bad_fn) (struct yaffs_dev *dev, int block_no);
+	int (*drv_initialise_fn) (struct yaffs_dev *dev);
+	int (*drv_deinitialise_fn) (struct yaffs_dev *dev);
+};
+
+struct yaffs_tags_handler {
+	int (*write_chunk_tags_fn) (struct yaffs_dev *dev,
+				    int nand_chunk, const u8 *data,
+				    const struct yaffs_ext_tags *tags);
+	int (*read_chunk_tags_fn) (struct yaffs_dev *dev,
+				   int nand_chunk, u8 *data,
+				   struct yaffs_ext_tags *tags);
+
+	int (*query_block_fn) (struct yaffs_dev *dev, int block_no,
+			       enum yaffs_block_state *state,
+			       u32 *seq_number);
+	int (*mark_bad_fn) (struct yaffs_dev *dev, int block_no);
+};
+
+struct yaffs_dev {
+	struct yaffs_param param;
+	struct yaffs_driver drv;
+	struct yaffs_tags_handler tagger;
+
+	/* Context storage. Holds extra OS specific data for this device */
+
+	void *os_context;
+	void *driver_context;
+
+	struct list_head dev_list;
+
+	int ll_init;
+	/* Runtime parameters. Set up by YAFFS. */
+	u32 data_bytes_per_chunk;
+
+	/* Non-wide tnode stuff */
+	u16 chunk_grp_bits;	/* Number of bits that need to be resolved if
+				 * the tnodes are not wide enough.
+				 */
+	u16 chunk_grp_size;	/* == 2^^chunk_grp_bits */
+
+	struct yaffs_tnode *tn_swap_buffer;
+
+	/* Stuff to support wide tnodes */
+	u32 tnode_width;
+	u32 tnode_mask;
+	u32 tnode_size;
+
+	/* Stuff for figuring out file offset to chunk conversions */
+	u32 chunk_shift;	/* Shift value */
+	u32 chunk_div;		/* Divisor after shifting: 1 for 2^n sizes */
+	u32 chunk_mask;		/* Mask to use for power-of-2 case */
+
+	int is_mounted;
+	int read_only;
+	int is_checkpointed;
+	int swap_endian;	/* Stored endian needs endian swap. */
+
+	/* Stuff to support block offsetting to support start block zero */
+	u32 internal_start_block;
+	u32 internal_end_block;
+	int block_offset;
+	int chunk_offset;
+
+	/* Runtime checkpointing stuff */
+	int checkpt_page_seq;	/* running sequence number of checkpt pages */
+	int checkpt_byte_count;
+	int checkpt_byte_offs;
+	u8 *checkpt_buffer;
+	int checkpt_open_write;
+	u32 blocks_in_checkpt;
+	int checkpt_cur_chunk;
+	int checkpt_cur_block;
+	int checkpt_next_block;
+	int *checkpt_block_list;
+	u32 checkpt_max_blocks;
+	u32 checkpt_sum;
+	u32 checkpt_xor;
+
+	int checkpoint_blocks_required;	/* Number of blocks needed to store
+					 * current checkpoint set */
+
+	/* Block Info */
+	struct yaffs_block_info *block_info;
+	u8 *chunk_bits;		/* bitmap of chunks in use */
+	u8 block_info_alt:1;	/* allocated using alternative alloc */
+	u8 chunk_bits_alt:1;	/* allocated using alternative alloc */
+	int chunk_bit_stride;	/* Number of bytes of chunk_bits per block.
+				 * Must be consistent with chunks_per_block.
+				 */
+
+	int n_erased_blocks;
+	int alloc_block;	/* Current block being allocated off */
+	u32 alloc_page;
+	int alloc_block_finder;	/* Used to search for next allocation block */
+
+	/* Object and Tnode memory management */
+	void *allocator;
+	int n_obj;
+	int n_tnodes;
+
+	int n_hardlinks;
+
+	struct yaffs_obj_bucket obj_bucket[YAFFS_NOBJECT_BUCKETS];
+	u32 bucket_finder;
+
+	int n_free_chunks;
+
+	/* Garbage collection control */
+	u32 *gc_cleanup_list;	/* objects to delete at the end of a GC. */
+	u32 n_clean_ups;
+
+	unsigned has_pending_prioritised_gc;	/* We think this device might
+						have pending prioritised gcs */
+	unsigned gc_disable;
+	unsigned gc_block_finder;
+	unsigned gc_dirtiest;
+	unsigned gc_pages_in_use;
+	unsigned gc_not_done;
+	unsigned gc_block;
+	unsigned gc_chunk;
+	unsigned gc_skip;
+	struct yaffs_summary_tags *gc_sum_tags;
+
+	/* Special directories */
+	struct yaffs_obj *root_dir;
+	struct yaffs_obj *lost_n_found;
+
+	int buffered_block;	/* Which block is buffered here? */
+	int doing_buffered_block_rewrite;
+
+	struct yaffs_cache *cache;
+	int cache_last_use;
+
+	/* Stuff for background deletion and unlinked files. */
+	struct yaffs_obj *unlinked_dir;	/* Directory where unlinked and deleted
+					 files live. */
+	struct yaffs_obj *del_dir;	/* Directory where deleted objects are
+					sent to disappear. */
+	struct yaffs_obj *unlinked_deletion;	/* Current file being
+							background deleted. */
+	int n_deleted_files;	/* Count of files awaiting deletion; */
+	int n_unlinked_files;	/* Count of unlinked files. */
+	int n_bg_deletions;	/* Count of background deletions. */
+
+	/* Temporary buffer management */
+	struct yaffs_buffer temp_buffer[YAFFS_N_TEMP_BUFFERS];
+	int max_temp;
+	int temp_in_use;
+	int unmanaged_buffer_allocs;
+	int unmanaged_buffer_deallocs;
+
+	/* yaffs2 runtime stuff */
+	unsigned seq_number;	/* Sequence number of currently
+					allocating block */
+	unsigned oldest_dirty_seq;
+	unsigned oldest_dirty_block;
+
+	/* Block refreshing */
+	int refresh_skip;	/* A skip down counter.
+				 * Refresh happens when this gets to zero. */
+
+	/* Dirty directory handling */
+	struct list_head dirty_dirs;	/* List of dirty directories */
+
+	/* Summary */
+	int chunks_per_summary;
+	struct yaffs_summary_tags *sum_tags;
+
+	/* Statistics */
+	u32 n_page_writes;
+	u32 n_page_reads;
+	u32 n_erasures;
+	u32 n_bad_queries;
+	u32 n_bad_markings;
+	u32 n_erase_failures;
+	u32 n_gc_copies;
+	u32 all_gcs;
+	u32 passive_gc_count;
+	u32 oldest_dirty_gc_count;
+	u32 n_gc_blocks;
+	u32 bg_gcs;
+	u32 n_retried_writes;
+	u32 n_retired_blocks;
+	u32 n_ecc_fixed;
+	u32 n_ecc_unfixed;
+	u32 n_tags_ecc_fixed;
+	u32 n_tags_ecc_unfixed;
+	u32 n_deletions;
+	u32 n_unmarked_deletions;
+	u32 refresh_count;
+	u32 cache_hits;
+	u32 tags_used;
+	u32 summary_used;
+
+};
+
+/*
+ * Checkpointing definitions.
+ */
+
+#define YAFFS_CHECKPOINT_VERSION	8
+
+/* yaffs_checkpt_obj holds the definition of an object as dumped
+ * by checkpointing.
+ */
+
+
+/*  Checkpint object bits in bitfield: offset, length */
+#define CHECKPOINT_VARIANT_BITS		0, 3
+#define CHECKPOINT_DELETED_BITS		3, 1
+#define CHECKPOINT_SOFT_DEL_BITS	4, 1
+#define CHECKPOINT_UNLINKED_BITS	5, 1
+#define CHECKPOINT_FAKE_BITS		6, 1
+#define CHECKPOINT_RENAME_ALLOWED_BITS	7, 1
+#define CHECKPOINT_UNLINK_ALLOWED_BITS	8, 1
+#define CHECKPOINT_SERIAL_BITS		9, 8
+
+struct yaffs_checkpt_obj {
+	int struct_type;
+	u32 obj_id;
+	u32 parent_id;
+	int hdr_chunk;
+	u32 bit_field;
+	int n_data_chunks;
+	loff_t size_or_equiv_obj;
+};
+
+/* The CheckpointDevice structure holds the device information that changes
+ *at runtime and must be preserved over unmount/mount cycles.
+ */
+struct yaffs_checkpt_dev {
+	int struct_type;
+	int n_erased_blocks;
+	int alloc_block;	/* Current block being allocated off */
+	u32 alloc_page;
+	int n_free_chunks;
+
+	int n_deleted_files;	/* Count of files awaiting deletion; */
+	int n_unlinked_files;	/* Count of unlinked files. */
+	int n_bg_deletions;	/* Count of background deletions. */
+
+	/* yaffs2 runtime stuff */
+	unsigned seq_number;	/* Sequence number of currently
+				 * allocating block */
+
+};
+
+struct yaffs_checkpt_validity {
+	int struct_type;
+	u32 magic;
+	u32 version;
+	u32 head;
+};
+
+struct yaffs_shadow_fixer {
+	int obj_id;
+	int shadowed_id;
+	struct yaffs_shadow_fixer *next;
+};
+
+/* Structure for doing xattr modifications */
+struct yaffs_xattr_mod {
+	int set;		/* If 0 then this is a deletion */
+	const YCHAR *name;
+	const void *data;
+	int size;
+	int flags;
+	int result;
+};
+
+/*----------------------- YAFFS Functions -----------------------*/
+
+int yaffs_guts_initialise(struct yaffs_dev *dev);
+void yaffs_deinitialise(struct yaffs_dev *dev);
+
+int yaffs_get_n_free_chunks(struct yaffs_dev *dev);
+
+int yaffs_rename_obj(struct yaffs_obj *old_dir, const YCHAR * old_name,
+		     struct yaffs_obj *new_dir, const YCHAR * new_name);
+
+int yaffs_unlink_obj(struct yaffs_obj *obj);
+
+int yaffs_unlinker(struct yaffs_obj *dir, const YCHAR * name);
+int yaffs_del_obj(struct yaffs_obj *obj);
+struct yaffs_obj *yaffs_retype_obj(struct yaffs_obj *obj,
+				   enum yaffs_obj_type type);
+
+
+int yaffs_get_obj_name(struct yaffs_obj *obj, YCHAR * name, int buffer_size);
+loff_t yaffs_get_obj_length(struct yaffs_obj *obj);
+int yaffs_get_obj_inode(struct yaffs_obj *obj);
+unsigned yaffs_get_obj_type(struct yaffs_obj *obj);
+int yaffs_get_obj_link_count(struct yaffs_obj *obj);
+
+/* File operations */
+int yaffs_file_rd(struct yaffs_obj *obj, u8 * buffer, loff_t offset,
+		  int n_bytes);
+int yaffs_wr_file(struct yaffs_obj *obj, const u8 * buffer, loff_t offset,
+		  int n_bytes, int write_trhrough);
+int yaffs_resize_file(struct yaffs_obj *obj, loff_t new_size);
+
+struct yaffs_obj *yaffs_create_file(struct yaffs_obj *parent,
+				    const YCHAR *name, u32 mode, u32 uid,
+				    u32 gid);
+
+int yaffs_flush_file(struct yaffs_obj *in,
+		     int update_time,
+		     int data_sync,
+		     int discard_cache);
+
+/* Flushing and checkpointing */
+void yaffs_flush_whole_cache(struct yaffs_dev *dev, int discard);
+
+int yaffs_checkpoint_save(struct yaffs_dev *dev);
+int yaffs_checkpoint_restore(struct yaffs_dev *dev);
+
+/* Directory operations */
+struct yaffs_obj *yaffs_create_dir(struct yaffs_obj *parent, const YCHAR *name,
+				   u32 mode, u32 uid, u32 gid);
+struct yaffs_obj *yaffs_find_by_name(struct yaffs_obj *the_dir,
+				     const YCHAR *name);
+struct yaffs_obj *yaffs_find_by_number(struct yaffs_dev *dev, u32 number);
+
+/* Link operations */
+struct yaffs_obj *yaffs_link_obj(struct yaffs_obj *parent, const YCHAR *name,
+				 struct yaffs_obj *equiv_obj);
+
+struct yaffs_obj *yaffs_get_equivalent_obj(struct yaffs_obj *obj);
+
+/* Symlink operations */
+struct yaffs_obj *yaffs_create_symlink(struct yaffs_obj *parent,
+				       const YCHAR *name, u32 mode, u32 uid,
+				       u32 gid, const YCHAR *alias);
+YCHAR *yaffs_get_symlink_alias(struct yaffs_obj *obj);
+
+/* Special inodes (fifos, sockets and devices) */
+struct yaffs_obj *yaffs_create_special(struct yaffs_obj *parent,
+				       const YCHAR *name, u32 mode, u32 uid,
+				       u32 gid, u32 rdev);
+
+int yaffs_set_xattrib(struct yaffs_obj *obj, const YCHAR *name,
+		      const void *value, int size, int flags);
+int yaffs_get_xattrib(struct yaffs_obj *obj, const YCHAR *name, void *value,
+		      int size);
+int yaffs_list_xattrib(struct yaffs_obj *obj, char *buffer, int size);
+int yaffs_remove_xattrib(struct yaffs_obj *obj, const YCHAR *name);
+
+/* Special directories */
+struct yaffs_obj *yaffs_root(struct yaffs_dev *dev);
+struct yaffs_obj *yaffs_lost_n_found(struct yaffs_dev *dev);
+
+void yaffs_handle_defered_free(struct yaffs_obj *obj);
+
+void yaffs_update_dirty_dirs(struct yaffs_dev *dev);
+
+int yaffs_bg_gc(struct yaffs_dev *dev, unsigned urgency);
+
+/* Debug dump  */
+int yaffs_dump_obj(struct yaffs_obj *obj);
+
+void yaffs_guts_test(struct yaffs_dev *dev);
+int yaffs_guts_ll_init(struct yaffs_dev *dev);
+
+
+/* A few useful functions to be used within the core files*/
+void yaffs_chunk_del(struct yaffs_dev *dev, int chunk_id, int mark_flash,
+		     int lyn);
+int yaffs_check_ff(u8 *buffer, int n_bytes);
+void yaffs_handle_chunk_error(struct yaffs_dev *dev,
+			      struct yaffs_block_info *bi);
+
+u8 *yaffs_get_temp_buffer(struct yaffs_dev *dev);
+void yaffs_release_temp_buffer(struct yaffs_dev *dev, u8 *buffer);
+
+struct yaffs_obj *yaffs_find_or_create_by_number(struct yaffs_dev *dev,
+						 int number,
+						 enum yaffs_obj_type type);
+int yaffs_put_chunk_in_file(struct yaffs_obj *in, int inode_chunk,
+			    int nand_chunk, int in_scan);
+void yaffs_set_obj_name(struct yaffs_obj *obj, const YCHAR *name);
+void yaffs_set_obj_name_from_oh(struct yaffs_obj *obj,
+				const struct yaffs_obj_hdr *oh);
+void yaffs_add_obj_to_dir(struct yaffs_obj *directory, struct yaffs_obj *obj);
+YCHAR *yaffs_clone_str(const YCHAR *str);
+void yaffs_link_fixup(struct yaffs_dev *dev, struct list_head *hard_list);
+void yaffs_block_became_dirty(struct yaffs_dev *dev, int block_no);
+int yaffs_update_oh(struct yaffs_obj *in, const YCHAR *name,
+		    int force, int is_shrink, int shadows,
+		    struct yaffs_xattr_mod *xop);
+void yaffs_handle_shadowed_obj(struct yaffs_dev *dev, int obj_id,
+			       int backward_scanning);
+int yaffs_check_alloc_available(struct yaffs_dev *dev, int n_chunks);
+struct yaffs_tnode *yaffs_get_tnode(struct yaffs_dev *dev);
+struct yaffs_tnode *yaffs_add_find_tnode_0(struct yaffs_dev *dev,
+					   struct yaffs_file_var *file_struct,
+					   u32 chunk_id,
+					   struct yaffs_tnode *passed_tn);
+
+int yaffs_do_file_wr(struct yaffs_obj *in, const u8 *buffer, loff_t offset,
+		     int n_bytes, int write_trhrough);
+void yaffs_resize_file_down(struct yaffs_obj *obj, loff_t new_size);
+void yaffs_skip_rest_of_block(struct yaffs_dev *dev);
+
+int yaffs_count_free_chunks(struct yaffs_dev *dev);
+
+struct yaffs_tnode *yaffs_find_tnode_0(struct yaffs_dev *dev,
+				       struct yaffs_file_var *file_struct,
+				       u32 chunk_id);
+
+u32 yaffs_get_group_base(struct yaffs_dev *dev, struct yaffs_tnode *tn,
+			 unsigned pos);
+
+int yaffs_is_non_empty_dir(struct yaffs_obj *obj);
+
+int yaffs_guts_format_dev(struct yaffs_dev *dev);
+
+void yaffs_addr_to_chunk(struct yaffs_dev *dev, loff_t addr,
+				int *chunk_out, u32 *offset_out);
+/*
+ * Marshalling functions to get loff_t file sizes into and out of
+ * object headers.
+ */
+void yaffs_oh_size_load(struct yaffs_dev *dev, struct yaffs_obj_hdr *oh,
+			loff_t fsize, int do_endian);
+loff_t yaffs_oh_to_size(struct yaffs_dev *dev, struct yaffs_obj_hdr *oh,
+			int do_endian);
+loff_t yaffs_max_file_size(struct yaffs_dev *dev);
+
+/*
+ * Debug function to count number of blocks in each state
+ * NB Needs to be called with correct number of integers
+ */
+
+void yaffs_count_blocks_by_state(struct yaffs_dev *dev, int bs[10]);
+
+int yaffs_find_chunk_in_file(struct yaffs_obj *in, int inode_chunk,
+				    struct yaffs_ext_tags *tags);
+
+/*
+ * Define LOFF_T_32_BIT if a 32-bit LOFF_T is being used.
+ * Not serious if you get this wrong - you might just get some warnings.
+*/
+
+#ifdef  LOFF_T_32_BIT
+#define FSIZE_LOW(fsize) (fsize)
+#define FSIZE_HIGH(fsize) 0
+#define FSIZE_COMBINE(high, low) (low)
+#else
+#define FSIZE_LOW(fsize) ((fsize) & 0xffffffff)
+#define FSIZE_HIGH(fsize)(((fsize) >> 32) & 0xffffffff)
+#define FSIZE_COMBINE(high, low) ((((loff_t) (high)) << 32) | \
+					(((loff_t) (low)) & 0xFFFFFFFF))
+#endif
+
+
+#endif
diff --git a/fs/yaffs2/yaffs_linux.h b/fs/yaffs2/yaffs_linux.h
new file mode 100644
index 00000000..68e33f1
--- /dev/null
+++ b/fs/yaffs2/yaffs_linux.h
@@ -0,0 +1,47 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_LINUX_H__
+#define __YAFFS_LINUX_H__
+
+#include "yportenv.h"
+
+struct yaffs_linux_context {
+	struct list_head context_list;	/* List of these we have mounted */
+	struct yaffs_dev *dev;
+	struct super_block *super;
+	struct task_struct *bg_thread;	/* Background thread for this device */
+	int bg_running;
+	struct mutex gross_lock;	/* Gross locking mutex*/
+	u8 *spare_buffer;	/* For mtdif2 use. Don't know the buffer size
+				 * at compile time so we have to allocate it.
+				 */
+	struct list_head search_contexts;
+	struct task_struct *readdir_process;
+	unsigned mount_id;
+	int dirty;
+};
+
+#define yaffs_dev_to_lc(dev) ((struct yaffs_linux_context *)((dev)->os_context))
+#define yaffs_dev_to_mtd(dev) ((struct mtd_info *)((dev)->driver_context))
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 17))
+#define WRITE_SIZE_STR "writesize"
+#define WRITE_SIZE(mtd) ((mtd)->writesize)
+#else
+#define WRITE_SIZE_STR "oobblock"
+#define WRITE_SIZE(mtd) ((mtd)->oobblock)
+#endif
+
+#endif
diff --git a/fs/yaffs2/yaffs_mtdif.c b/fs/yaffs2/yaffs_mtdif.c
new file mode 100644
index 00000000..5b0e4fe
--- /dev/null
+++ b/fs/yaffs2/yaffs_mtdif.c
@@ -0,0 +1,309 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yportenv.h"
+
+#include "yaffs_mtdif.h"
+
+#include "linux/mtd/mtd.h"
+#include "linux/types.h"
+#include "linux/time.h"
+#include "linux/mtd/nand.h"
+#include "linux/kernel.h"
+#include "linux/version.h"
+#include "linux/types.h"
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 14, 0))
+#include "uapi/linux/major.h"
+#endif
+
+#include "yaffs_trace.h"
+#include "yaffs_guts.h"
+#include "yaffs_linux.h"
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(3, 2, 0))
+#define MTD_OPS_AUTO_OOB MTD_OOB_AUTO
+#endif
+
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(3, 4, 0))
+#define mtd_erase(m, ei) (m)->erase(m, ei)
+#define mtd_write_oob(m, addr, pops) (m)->write_oob(m, addr, pops)
+#define mtd_read_oob(m, addr, pops) (m)->read_oob(m, addr, pops)
+#define mtd_block_isbad(m, offs) (m)->block_isbad(m, offs)
+#define mtd_block_markbad(m, offs) (m)->block_markbad(m, offs)
+#endif
+
+
+
+int nandmtd_erase_block(struct yaffs_dev *dev, int block_no)
+{
+	struct mtd_info *mtd = yaffs_dev_to_mtd(dev);
+	u32 addr =
+	    ((loff_t) block_no) * dev->param.total_bytes_per_chunk *
+	    dev->param.chunks_per_block;
+	struct erase_info ei;
+	int retval = 0;
+
+	ei.mtd = mtd;
+	ei.addr = addr;
+	ei.len = dev->param.total_bytes_per_chunk * dev->param.chunks_per_block;
+	ei.time = 1000;
+	ei.retries = 2;
+	ei.callback = NULL;
+	ei.priv = (u_long) dev;
+
+	retval = mtd_erase(mtd, &ei);
+
+	if (retval == 0)
+		return YAFFS_OK;
+
+	return YAFFS_FAIL;
+}
+
+
+static 	int yaffs_mtd_write(struct yaffs_dev *dev, int nand_chunk,
+				   const u8 *data, int data_len,
+				   const u8 *oob, int oob_len)
+{
+	struct mtd_info *mtd = yaffs_dev_to_mtd(dev);
+	loff_t addr;
+	struct mtd_oob_ops ops;
+	int retval;
+
+	yaffs_trace(YAFFS_TRACE_MTD,
+			"yaffs_mtd_write(%p, %d, %p, %d, %p, %d)\n",
+			dev, nand_chunk, data, data_len, oob, oob_len);
+
+	if (!data || !data_len) {
+		data = NULL;
+		data_len = 0;
+	}
+
+	if (!oob || !oob_len) {
+		oob = NULL;
+		oob_len = 0;
+	}
+
+	addr = ((loff_t) nand_chunk) * dev->param.total_bytes_per_chunk;
+	memset(&ops, 0, sizeof(ops));
+	ops.mode = MTD_OPS_AUTO_OOB;
+	ops.len = (data) ? data_len : 0;
+	ops.ooblen = oob_len;
+	ops.datbuf = (u8 *)data;
+	ops.oobbuf = (u8 *)oob;
+
+	retval = mtd_write_oob(mtd, addr, &ops);
+	if (retval) {
+		yaffs_trace(YAFFS_TRACE_MTD,
+			"write_oob failed, chunk %d, mtd error %d",
+			nand_chunk, retval);
+	}
+	return retval ? YAFFS_FAIL : YAFFS_OK;
+}
+
+static int yaffs_mtd_read(struct yaffs_dev *dev, int nand_chunk,
+				   u8 *data, int data_len,
+				   u8 *oob, int oob_len,
+				   enum yaffs_ecc_result *ecc_result)
+{
+	struct mtd_info *mtd = yaffs_dev_to_mtd(dev);
+	loff_t addr;
+	struct mtd_oob_ops ops;
+	int retval;
+
+	addr = ((loff_t) nand_chunk) * dev->param.total_bytes_per_chunk;
+	memset(&ops, 0, sizeof(ops));
+	ops.mode = MTD_OPS_AUTO_OOB;
+	ops.len = (data) ? data_len : 0;
+	ops.ooblen = oob_len;
+	ops.datbuf = data;
+	ops.oobbuf = oob;
+
+#if (MTD_VERSION_CODE < MTD_VERSION(2, 6, 20))
+	/* In MTD 2.6.18 to 2.6.19 nand_base.c:nand_do_read_oob() has a bug;
+	 * help it out with ops.len = ops.ooblen when ops.datbuf == NULL.
+	 */
+	ops.len = (ops.datbuf) ? ops.len : ops.ooblen;
+#endif
+	/* Read page and oob using MTD.
+	 * Check status and determine ECC result.
+	 */
+	retval = mtd_read_oob(mtd, addr, &ops);
+	if (retval)
+		yaffs_trace(YAFFS_TRACE_MTD,
+			"read_oob failed, chunk %d, mtd error %d",
+			nand_chunk, retval);
+
+	switch (retval) {
+	case 0:
+		/* no error */
+		if(ecc_result)
+			*ecc_result = YAFFS_ECC_RESULT_NO_ERROR;
+		break;
+
+	case -EUCLEAN:
+		/* MTD's ECC fixed the data */
+		if(ecc_result)
+			*ecc_result = YAFFS_ECC_RESULT_FIXED;
+		dev->n_ecc_fixed++;
+		break;
+
+	case -EBADMSG:
+	default:
+		/* MTD's ECC could not fix the data */
+		dev->n_ecc_unfixed++;
+		if(ecc_result)
+			*ecc_result = YAFFS_ECC_RESULT_UNFIXED;
+		return YAFFS_FAIL;
+	}
+
+	return YAFFS_OK;
+}
+
+static 	int yaffs_mtd_erase(struct yaffs_dev *dev, int block_no)
+{
+	struct mtd_info *mtd = yaffs_dev_to_mtd(dev);
+
+	loff_t addr;
+	struct erase_info ei;
+	int retval = 0;
+	u32 block_size;
+
+	block_size = dev->param.total_bytes_per_chunk *
+		     dev->param.chunks_per_block;
+	addr = ((loff_t) block_no) * block_size;
+
+	ei.mtd = mtd;
+	ei.addr = addr;
+	ei.len = block_size;
+	ei.time = 1000;
+	ei.retries = 2;
+	ei.callback = NULL;
+	ei.priv = (u_long) dev;
+
+	retval = mtd_erase(mtd, &ei);
+
+	if (retval == 0)
+		return YAFFS_OK;
+
+	return YAFFS_FAIL;
+}
+
+static int yaffs_mtd_mark_bad(struct yaffs_dev *dev, int block_no)
+{
+	struct mtd_info *mtd = yaffs_dev_to_mtd(dev);
+	int blocksize = dev->param.chunks_per_block * dev->param.total_bytes_per_chunk;
+	int retval;
+
+	yaffs_trace(YAFFS_TRACE_BAD_BLOCKS, "marking block %d bad", block_no);
+
+	retval = mtd_block_markbad(mtd, (loff_t) blocksize * block_no);
+	return (retval) ? YAFFS_FAIL : YAFFS_OK;
+}
+
+static int yaffs_mtd_check_bad(struct yaffs_dev *dev, int block_no)
+{
+	struct mtd_info *mtd = yaffs_dev_to_mtd(dev);
+	int blocksize = dev->param.chunks_per_block * dev->param.total_bytes_per_chunk;
+	int retval;
+
+	yaffs_trace(YAFFS_TRACE_MTD, "checking block %d bad", block_no);
+
+	retval = mtd_block_isbad(mtd, (loff_t) blocksize * block_no);
+	return (retval) ? YAFFS_FAIL : YAFFS_OK;
+}
+
+static int yaffs_mtd_initialise(struct yaffs_dev *dev)
+{
+	return YAFFS_OK;
+}
+
+static int yaffs_mtd_deinitialise(struct yaffs_dev *dev)
+{
+	return YAFFS_OK;
+}
+
+
+void yaffs_mtd_drv_install(struct yaffs_dev *dev)
+{
+	struct yaffs_driver *drv = &dev->drv;
+
+	drv->drv_write_chunk_fn = yaffs_mtd_write;
+	drv->drv_read_chunk_fn = yaffs_mtd_read;
+	drv->drv_erase_fn = yaffs_mtd_erase;
+	drv->drv_mark_bad_fn = yaffs_mtd_mark_bad;
+	drv->drv_check_bad_fn = yaffs_mtd_check_bad;
+	drv->drv_initialise_fn = yaffs_mtd_initialise;
+	drv->drv_deinitialise_fn = yaffs_mtd_deinitialise;
+}
+
+
+struct mtd_info * yaffs_get_mtd_device(dev_t sdev)
+{
+	struct mtd_info *mtd;
+
+	mtd = yaffs_get_mtd_device(sdev);
+
+	/* Check it's an mtd device..... */
+	if (MAJOR(sdev) != MTD_BLOCK_MAJOR)
+		return NULL;	/* This isn't an mtd device */
+
+	/* Check it's NAND */
+	if (mtd->type != MTD_NANDFLASH) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"yaffs: MTD device is not NAND it's type %d",
+			mtd->type);
+		return NULL;
+	}
+
+	yaffs_trace(YAFFS_TRACE_OS, " %s %d", WRITE_SIZE_STR, WRITE_SIZE(mtd));
+	yaffs_trace(YAFFS_TRACE_OS, " oobsize %d", mtd->oobsize);
+	yaffs_trace(YAFFS_TRACE_OS, " erasesize %d", mtd->erasesize);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 29)
+	yaffs_trace(YAFFS_TRACE_OS, " size %u", mtd->size);
+#else
+	yaffs_trace(YAFFS_TRACE_OS, " size %lld", mtd->size);
+#endif
+
+	return mtd;
+}
+
+int yaffs_verify_mtd(struct mtd_info *mtd, int yaffs_version, int inband_tags)
+{
+	if (yaffs_version == 2) {
+		if ((WRITE_SIZE(mtd) < YAFFS_MIN_YAFFS2_CHUNK_SIZE ||
+		     mtd->oobsize < YAFFS_MIN_YAFFS2_SPARE_SIZE) &&
+		    !inband_tags) {
+			yaffs_trace(YAFFS_TRACE_ALWAYS,
+				"MTD device does not have the right page sizes"
+			);
+			return -1;
+		}
+	} else {
+		if (WRITE_SIZE(mtd) < YAFFS_BYTES_PER_CHUNK ||
+		    mtd->oobsize != YAFFS_BYTES_PER_SPARE) {
+			yaffs_trace(YAFFS_TRACE_ALWAYS,
+				"MTD device does not support have the right page sizes"
+			);
+			return -1;
+		}
+	}
+
+	return 0;
+}
+
+
+void yaffs_put_mtd_device(struct mtd_info *mtd)
+{
+	if(mtd)
+		put_mtd_device(mtd);
+}
diff --git a/fs/yaffs2/yaffs_mtdif.h b/fs/yaffs2/yaffs_mtdif.h
new file mode 100644
index 00000000..54d0d62
--- /dev/null
+++ b/fs/yaffs2/yaffs_mtdif.h
@@ -0,0 +1,24 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_MTDIF_H__
+#define __YAFFS_MTDIF_H__
+
+#include "yaffs_guts.h"
+
+void yaffs_mtd_drv_install(struct yaffs_dev *dev);
+struct mtd_info * yaffs_get_mtd_device(dev_t sdev);
+void yaffs_put_mtd_device(struct mtd_info *mtd);
+int yaffs_verify_mtd(struct mtd_info *mtd, int yaffs_version, int inband_tags);
+#endif
diff --git a/fs/yaffs2/yaffs_nameval.c b/fs/yaffs2/yaffs_nameval.c
new file mode 100644
index 00000000..b855365
--- /dev/null
+++ b/fs/yaffs2/yaffs_nameval.c
@@ -0,0 +1,229 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+/*
+ * This simple implementation of a name-value store assumes a small number of
+* values and fits into a small finite buffer.
+ *
+ * Each attribute is stored as a record:
+ *  sizeof(size) bytes   record size.
+ *  strnlen+1 bytes name null terminated.
+ *  nbytes    value.
+ *  ----------
+ *  total size  stored in record size
+ *
+ * This code has not been tested with unicode yet.
+ */
+
+#include "yaffs_nameval.h"
+#include "yaffs_guts.h"
+#include "yportenv.h"
+#include "yaffs_endian.h"
+
+static int nval_find(struct yaffs_dev *dev,
+		     const char *xb, int xb_size, const YCHAR *name,
+		     int *exist_size)
+{
+	int pos = 0;
+	s32 size;
+
+	memcpy(&size, xb, sizeof(size));
+	yaffs_do_endian_s32(dev, &size);
+
+	while (size > 0 && (size < xb_size) && (pos + size < xb_size)) {
+		if (!strncmp((YCHAR *) (xb + pos + sizeof(size)),
+				name, size)) {
+			if (exist_size)
+				*exist_size = size;
+			return pos;
+		}
+		pos += size;
+		if (pos < (int)(xb_size - sizeof(size))) {
+			memcpy(&size, xb + pos, sizeof(size));
+			yaffs_do_endian_s32(dev, &size);
+
+		} else
+			size = 0;
+	}
+	if (exist_size)
+		*exist_size = 0;
+	return -ENODATA;
+}
+
+static int nval_used(struct yaffs_dev *dev, const char *xb, int xb_size)
+{
+	int pos = 0;
+	s32 size;
+
+	memcpy(&size, xb + pos, sizeof(size));
+	yaffs_do_endian_s32(dev, &size);
+
+	while (size > 0 && (size < xb_size) && (pos + size < xb_size)) {
+		pos += size;
+		if (pos < (int)(xb_size - sizeof(size))) {
+			memcpy(&size, xb + pos, sizeof(size));
+			yaffs_do_endian_s32(dev, &size);
+		} else
+			size = 0;
+	}
+	return pos;
+}
+
+int nval_del(struct yaffs_dev *dev, char *xb, int xb_size, const YCHAR *name)
+{
+	int pos = nval_find(dev, xb, xb_size, name, NULL);
+	s32 size;
+
+	if (pos < 0 || pos >= xb_size)
+		return -ENODATA;
+
+	/* Find size, shift rest over this record,
+	 * then zero out the rest of buffer */
+	memcpy(&size, xb + pos, sizeof(size));
+	yaffs_do_endian_s32(dev, &size);
+
+	memcpy(xb + pos, xb + pos + size, xb_size - (pos + size));
+	memset(xb + (xb_size - size), 0, size);
+	return 0;
+}
+
+int nval_set(struct yaffs_dev *dev,
+	     char *xb, int xb_size, const YCHAR *name, const char *buf,
+	     int bsize, int flags)
+{
+	int pos;
+	int namelen = strnlen(name, xb_size);
+	int size_exist = 0;
+	int space;
+	int start;
+	s32 reclen;
+	s32 reclen_endianised;
+
+	pos = nval_find(dev, xb, xb_size, name, &size_exist);
+
+	if (flags & XATTR_CREATE && pos >= 0)
+		return -EEXIST;
+	if (flags & XATTR_REPLACE && pos < 0)
+		return -ENODATA;
+
+	start = nval_used(dev, xb, xb_size);
+	space = xb_size - start + size_exist;
+
+	reclen = (sizeof(reclen) + namelen + 1 + bsize);
+
+	if (reclen > space)
+		return -ENOSPC;
+
+	if (pos >= 0) {
+		/* Exists, so delete it. */
+		nval_del(dev, xb, xb_size, name);
+		start = nval_used(dev, xb, xb_size);
+	}
+
+	pos = start;
+
+	reclen_endianised = reclen;
+	yaffs_do_endian_s32(dev, &reclen_endianised);
+	memcpy(xb + pos, &reclen_endianised, sizeof(reclen_endianised));
+	pos += sizeof(reclen_endianised);
+	strncpy((YCHAR *) (xb + pos), name, reclen);
+	pos += (namelen + 1);
+	memcpy(xb + pos, buf, bsize);
+	return 0;
+}
+
+int nval_get(struct yaffs_dev *dev,
+	     const char *xb, int xb_size, const YCHAR * name, char *buf,
+	     int bsize)
+{
+	int pos = nval_find(dev, xb, xb_size, name, NULL);
+	s32 size;
+
+	if (pos >= 0 && pos < xb_size) {
+
+		memcpy(&size, xb + pos, sizeof(size));
+		yaffs_do_endian_s32(dev, &size);
+		pos += sizeof(size);	/* advance past record length */
+		size -= sizeof(size);
+
+		/* Advance over name string */
+		while (xb[pos] && size > 0 && pos < xb_size) {
+			pos++;
+			size--;
+		}
+		/*Advance over NUL */
+		pos++;
+		size--;
+
+		/* If bsize is zero then this is a size query.
+		 * Return the size, but don't copy.
+		 */
+		if (!bsize)
+			return size;
+
+		if (size <= bsize) {
+			memcpy(buf, xb + pos, size);
+			return size;
+		}
+	}
+	if (pos >= 0)
+		return -ERANGE;
+
+	return -ENODATA;
+}
+
+int nval_list(struct yaffs_dev *dev, const char *xb, int xb_size, char *buf, int bsize)
+{
+	int pos = 0;
+	s32 size;
+	int name_len;
+	int ncopied = 0;
+	int filled = 0;
+
+	memcpy(&size, xb + pos, sizeof(size));
+	yaffs_do_endian_s32(dev, &size);
+
+	while (size > (int)(sizeof(size)) &&
+		size <= xb_size &&
+		(pos + size) < xb_size &&
+		!filled) {
+		pos += sizeof(size);
+		size -= sizeof(size);
+		name_len = strnlen((YCHAR *) (xb + pos), size);
+		if (ncopied + name_len + 1 < bsize) {
+			memcpy(buf, xb + pos, name_len * sizeof(YCHAR));
+			buf += name_len;
+			*buf = '\0';
+			buf++;
+			if (sizeof(YCHAR) > 1) {
+				*buf = '\0';
+				buf++;
+			}
+			ncopied += (name_len + 1);
+		} else {
+			filled = 1;
+		}
+		pos += size;
+		if (pos < (int)(xb_size - sizeof(size))) {
+			memcpy(&size, xb + pos, sizeof(size));
+			yaffs_do_endian_s32(dev, &size);
+		}
+		else
+			size = 0;
+	}
+	return ncopied;
+}
+
+int nval_hasvalues(struct yaffs_dev *dev, const char *xb, int xb_size)
+{
+	return nval_used(dev, xb, xb_size) > 0;
+}
diff --git a/fs/yaffs2/yaffs_nameval.h b/fs/yaffs2/yaffs_nameval.h
new file mode 100644
index 00000000..7dbdbb6
--- /dev/null
+++ b/fs/yaffs2/yaffs_nameval.h
@@ -0,0 +1,32 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __NAMEVAL_H__
+#define __NAMEVAL_H__
+
+#include "yportenv.h"
+
+struct yaffs_dev;
+
+int nval_del(struct yaffs_dev *dev, char *xb, int xb_size, const YCHAR * name);
+int nval_set(struct yaffs_dev *dev,
+	     char *xb, int xb_size, const YCHAR * name, const char *buf,
+	     int bsize, int flags);
+int nval_get(struct yaffs_dev *dev,
+	     const char *xb, int xb_size, const YCHAR * name, char *buf,
+	     int bsize);
+int nval_list(struct yaffs_dev *dev,
+	      const char *xb, int xb_size, char *buf, int bsize);
+int nval_hasvalues(struct yaffs_dev *dev, const char *xb, int xb_size);
+#endif
diff --git a/fs/yaffs2/yaffs_nand.c b/fs/yaffs2/yaffs_nand.c
new file mode 100644
index 00000000..fe12190
--- /dev/null
+++ b/fs/yaffs2/yaffs_nand.c
@@ -0,0 +1,121 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yaffs_nand.h"
+#include "yaffs_tagscompat.h"
+
+#include "yaffs_getblockinfo.h"
+#include "yaffs_summary.h"
+
+static int apply_chunk_offset(struct yaffs_dev *dev, int chunk)
+{
+	return chunk - dev->chunk_offset;
+}
+
+int yaffs_rd_chunk_tags_nand(struct yaffs_dev *dev, int nand_chunk,
+			     u8 *buffer, struct yaffs_ext_tags *tags)
+{
+	int result;
+	struct yaffs_ext_tags local_tags;
+	int flash_chunk = apply_chunk_offset(dev, nand_chunk);
+
+	dev->n_page_reads++;
+
+	/* If there are no tags provided use local tags. */
+	if (!tags)
+		tags = &local_tags;
+
+	result = dev->tagger.read_chunk_tags_fn(dev, flash_chunk, buffer, tags);
+	if (tags && tags->ecc_result > YAFFS_ECC_RESULT_NO_ERROR) {
+
+		struct yaffs_block_info *bi;
+		bi = yaffs_get_block_info(dev,
+					  nand_chunk /
+					  dev->param.chunks_per_block);
+		yaffs_handle_chunk_error(dev, bi);
+	}
+	return result;
+}
+
+int yaffs_wr_chunk_tags_nand(struct yaffs_dev *dev,
+				int nand_chunk,
+				const u8 *buffer, struct yaffs_ext_tags *tags)
+{
+	int result;
+	int flash_chunk = apply_chunk_offset(dev, nand_chunk);
+
+	dev->n_page_writes++;
+
+	if (!tags) {
+		yaffs_trace(YAFFS_TRACE_ERROR, "Writing with no tags");
+		BUG();
+		return YAFFS_FAIL;
+	}
+
+	tags->seq_number = dev->seq_number;
+	tags->chunk_used = 1;
+	yaffs_trace(YAFFS_TRACE_WRITE,
+		"Writing chunk %d tags %d %d",
+		nand_chunk, tags->obj_id, tags->chunk_id);
+
+	result = dev->tagger.write_chunk_tags_fn(dev, flash_chunk,
+							buffer, tags);
+
+	yaffs_summary_add(dev, tags, nand_chunk);
+
+	return result;
+}
+
+int yaffs_mark_bad(struct yaffs_dev *dev, int block_no)
+{
+	block_no -= dev->block_offset;
+	dev->n_bad_markings++;
+
+	if (dev->param.disable_bad_block_marking)
+		return YAFFS_OK;
+
+	return dev->tagger.mark_bad_fn(dev, block_no);
+}
+
+
+int yaffs_query_init_block_state(struct yaffs_dev *dev,
+				 int block_no,
+				 enum yaffs_block_state *state,
+				 u32 *seq_number)
+{
+	block_no -= dev->block_offset;
+	return dev->tagger.query_block_fn(dev, block_no, state, seq_number);
+}
+
+int yaffs_erase_block(struct yaffs_dev *dev, int block_no)
+{
+	int result;
+
+	block_no -= dev->block_offset;
+	dev->n_erasures++;
+	result = dev->drv.drv_erase_fn(dev, block_no);
+	return result;
+}
+
+int yaffs_init_nand(struct yaffs_dev *dev)
+{
+	if (dev->drv.drv_initialise_fn)
+		return dev->drv.drv_initialise_fn(dev);
+	return YAFFS_OK;
+}
+
+int yaffs_deinit_nand(struct yaffs_dev *dev)
+{
+	if (dev->drv.drv_deinitialise_fn)
+		return dev->drv.drv_deinitialise_fn(dev);
+	return YAFFS_OK;
+}
diff --git a/fs/yaffs2/yaffs_nand.h b/fs/yaffs2/yaffs_nand.h
new file mode 100644
index 00000000..8964db0
--- /dev/null
+++ b/fs/yaffs2/yaffs_nand.h
@@ -0,0 +1,38 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_NAND_H__
+#define __YAFFS_NAND_H__
+#include "yaffs_guts.h"
+
+int yaffs_rd_chunk_tags_nand(struct yaffs_dev *dev, int nand_chunk,
+			     u8 *buffer, struct yaffs_ext_tags *tags);
+
+int yaffs_wr_chunk_tags_nand(struct yaffs_dev *dev,
+			     int nand_chunk,
+			     const u8 *buffer, struct yaffs_ext_tags *tags);
+
+int yaffs_mark_bad(struct yaffs_dev *dev, int block_no);
+
+int yaffs_query_init_block_state(struct yaffs_dev *dev,
+				 int block_no,
+				 enum yaffs_block_state *state,
+				 unsigned *seq_number);
+
+int yaffs_erase_block(struct yaffs_dev *dev, int flash_block);
+
+int yaffs_init_nand(struct yaffs_dev *dev);
+int yaffs_deinit_nand(struct yaffs_dev *dev);
+
+#endif
diff --git a/fs/yaffs2/yaffs_packedtags1.c b/fs/yaffs2/yaffs_packedtags1.c
new file mode 100644
index 00000000..fab4fc1
--- /dev/null
+++ b/fs/yaffs2/yaffs_packedtags1.c
@@ -0,0 +1,54 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yaffs_packedtags1.h"
+#include "yportenv.h"
+
+static const u8 all_ff[20] = {
+	0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff
+};
+
+void yaffs_pack_tags1(struct yaffs_packed_tags1 *pt,
+		      const struct yaffs_ext_tags *t)
+{
+	pt->chunk_id = t->chunk_id;
+	pt->serial_number = t->serial_number;
+	pt->n_bytes = t->n_bytes;
+	pt->obj_id = t->obj_id;
+	pt->ecc = 0;
+	pt->deleted = (t->is_deleted) ? 0 : 1;
+	pt->unused_stuff = 0;
+	pt->should_be_ff = 0xffffffff;
+}
+
+void yaffs_unpack_tags1(struct yaffs_ext_tags *t,
+			const struct yaffs_packed_tags1 *pt)
+{
+	if (memcmp(all_ff, pt, sizeof(struct yaffs_packed_tags1))) {
+		t->block_bad = 0;
+		if (pt->should_be_ff != 0xffffffff)
+			t->block_bad = 1;
+		t->chunk_used = 1;
+		t->obj_id = pt->obj_id;
+		t->chunk_id = pt->chunk_id;
+		t->n_bytes = pt->n_bytes;
+		t->ecc_result = YAFFS_ECC_RESULT_NO_ERROR;
+		t->is_deleted = (pt->deleted) ? 0 : 1;
+		t->serial_number = pt->serial_number;
+	} else {
+		memset(t, 0, sizeof(struct yaffs_ext_tags));
+	}
+}
diff --git a/fs/yaffs2/yaffs_packedtags1.h b/fs/yaffs2/yaffs_packedtags1.h
new file mode 100644
index 00000000..aef36d9
--- /dev/null
+++ b/fs/yaffs2/yaffs_packedtags1.h
@@ -0,0 +1,38 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+/* This is used to pack YAFFS1 tags, not YAFFS2 tags. */
+
+#ifndef __YAFFS_PACKEDTAGS1_H__
+#define __YAFFS_PACKEDTAGS1_H__
+
+#include "yaffs_guts.h"
+
+struct yaffs_packed_tags1 {
+	u32 chunk_id:20;
+	u32 serial_number:2;
+	u32 n_bytes:10;
+	u32 obj_id:18;
+	u32 ecc:12;
+	u32 deleted:1;
+	u32 unused_stuff:1;
+	unsigned should_be_ff;
+
+};
+
+void yaffs_pack_tags1(struct yaffs_packed_tags1 *pt,
+		      const struct yaffs_ext_tags *t);
+void yaffs_unpack_tags1(struct yaffs_ext_tags *t,
+			const struct yaffs_packed_tags1 *pt);
+#endif
diff --git a/fs/yaffs2/yaffs_packedtags2.c b/fs/yaffs2/yaffs_packedtags2.c
new file mode 100644
index 00000000..e8fd945
--- /dev/null
+++ b/fs/yaffs2/yaffs_packedtags2.c
@@ -0,0 +1,207 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yaffs_packedtags2.h"
+#include "yportenv.h"
+#include "yaffs_trace.h"
+#include "yaffs_endian.h"
+
+/* This code packs a set of extended tags into a binary structure for
+ * NAND storage
+ */
+
+/* Some of the information is "extra" struff which can be packed in to
+ * speed scanning
+ * This is defined by having the EXTRA_HEADER_INFO_FLAG set.
+ */
+
+/* Extra flags applied to chunk_id */
+
+#define EXTRA_HEADER_INFO_FLAG	0x80000000
+#define EXTRA_SHRINK_FLAG	0x40000000
+#define EXTRA_SHADOWS_FLAG	0x20000000
+#define EXTRA_SPARE_FLAGS	0x10000000
+
+#define ALL_EXTRA_FLAGS		0xf0000000
+
+/* Also, the top 4 bits of the object Id are set to the object type. */
+#define EXTRA_OBJECT_TYPE_SHIFT (28)
+#define EXTRA_OBJECT_TYPE_MASK  ((0x0f) << EXTRA_OBJECT_TYPE_SHIFT)
+
+static void yaffs_dump_packed_tags2_tags_only(
+				const struct yaffs_packed_tags2_tags_only *ptt)
+{
+	yaffs_trace(YAFFS_TRACE_MTD,
+		"packed tags obj %d chunk %d byte %d seq %d",
+		ptt->obj_id, ptt->chunk_id, ptt->n_bytes, ptt->seq_number);
+}
+
+static void yaffs_dump_packed_tags2(const struct yaffs_packed_tags2 *pt)
+{
+	yaffs_dump_packed_tags2_tags_only(&pt->t);
+}
+
+static void yaffs_dump_tags2(const struct yaffs_ext_tags *t)
+{
+	yaffs_trace(YAFFS_TRACE_MTD,
+		"ext.tags eccres %d blkbad %d chused %d obj %d chunk%d byte %d del %d ser %d seq %d",
+		t->ecc_result, t->block_bad, t->chunk_used, t->obj_id,
+		t->chunk_id, t->n_bytes, t->is_deleted, t->serial_number,
+		t->seq_number);
+
+}
+
+static int yaffs_check_tags_extra_packable(const struct yaffs_ext_tags *t)
+{
+	if (t->chunk_id != 0 || !t->extra_available)
+		return 0;
+
+	/* Check if the file size is too long to store */
+	if (t->extra_obj_type == YAFFS_OBJECT_TYPE_FILE &&
+	    (t->extra_file_size >> 31) != 0)
+		return 0;
+	return 1;
+}
+
+void yaffs_pack_tags2_tags_only(struct yaffs_dev *dev,
+				struct yaffs_packed_tags2_tags_only *ptt,
+				const struct yaffs_ext_tags *t)
+{
+	ptt->chunk_id = t->chunk_id;
+	ptt->seq_number = t->seq_number;
+	ptt->n_bytes = t->n_bytes;
+	ptt->obj_id = t->obj_id;
+
+	/* Only store extra tags for object headers.
+	 * If it is a file then only store  if the file size is short\
+	 * enough to fit.
+	 */
+	if (yaffs_check_tags_extra_packable(t)) {
+		/* Store the extra header info instead */
+		/* We save the parent object in the chunk_id */
+		ptt->chunk_id = EXTRA_HEADER_INFO_FLAG | t->extra_parent_id;
+		if (t->extra_is_shrink)
+			ptt->chunk_id |= EXTRA_SHRINK_FLAG;
+		if (t->extra_shadows)
+			ptt->chunk_id |= EXTRA_SHADOWS_FLAG;
+
+		ptt->obj_id &= ~EXTRA_OBJECT_TYPE_MASK;
+		ptt->obj_id |= (t->extra_obj_type << EXTRA_OBJECT_TYPE_SHIFT);
+
+		if (t->extra_obj_type == YAFFS_OBJECT_TYPE_HARDLINK)
+			ptt->n_bytes = t->extra_equiv_id;
+		else if (t->extra_obj_type == YAFFS_OBJECT_TYPE_FILE)
+			ptt->n_bytes = (unsigned) t->extra_file_size;
+		else
+			ptt->n_bytes = 0;
+	}
+
+	yaffs_dump_packed_tags2_tags_only(ptt);
+	yaffs_dump_tags2(t);
+	yaffs_do_endian_packed_tags2(dev, ptt);
+}
+
+void yaffs_pack_tags2(struct yaffs_dev *dev,
+		      struct yaffs_packed_tags2 *pt,
+		      const struct yaffs_ext_tags *t, int tags_ecc)
+{
+	yaffs_pack_tags2_tags_only(dev, &pt->t, t);
+
+	if (tags_ecc)
+		yaffs_ecc_calc_other((unsigned char *)&pt->t,
+				    sizeof(struct yaffs_packed_tags2_tags_only),
+				    &pt->ecc);
+}
+
+void yaffs_unpack_tags2_tags_only(struct yaffs_dev *dev,
+				  struct yaffs_ext_tags *t,
+				  struct yaffs_packed_tags2_tags_only *ptt_ptr)
+{
+	struct yaffs_packed_tags2_tags_only ptt_copy = *ptt_ptr;
+
+	memset(t, 0, sizeof(struct yaffs_ext_tags));
+
+	if (ptt_copy.seq_number == 0xffffffff)
+		return;
+
+	yaffs_do_endian_packed_tags2(dev, &ptt_copy);
+
+	t->block_bad = 0;
+	t->chunk_used = 1;
+	t->obj_id = ptt_copy.obj_id;
+	t->chunk_id = ptt_copy.chunk_id;
+	t->n_bytes = ptt_copy.n_bytes;
+	t->is_deleted = 0;
+	t->serial_number = 0;
+	t->seq_number = ptt_copy.seq_number;
+
+	/* Do extra header info stuff */
+	if (ptt_copy.chunk_id & EXTRA_HEADER_INFO_FLAG) {
+		t->chunk_id = 0;
+		t->n_bytes = 0;
+
+		t->extra_available = 1;
+		t->extra_parent_id = ptt_copy.chunk_id & (~(ALL_EXTRA_FLAGS));
+		t->extra_is_shrink = ptt_copy.chunk_id & EXTRA_SHRINK_FLAG ? 1 : 0;
+		t->extra_shadows = ptt_copy.chunk_id & EXTRA_SHADOWS_FLAG ? 1 : 0;
+		t->extra_obj_type = ptt_copy.obj_id >> EXTRA_OBJECT_TYPE_SHIFT;
+		t->obj_id &= ~EXTRA_OBJECT_TYPE_MASK;
+
+		if (t->extra_obj_type == YAFFS_OBJECT_TYPE_HARDLINK)
+			t->extra_equiv_id = ptt_copy.n_bytes;
+		else
+			t->extra_file_size = ptt_copy.n_bytes;
+	}
+	yaffs_dump_packed_tags2_tags_only(ptt_ptr);
+	yaffs_dump_tags2(t);
+}
+
+void yaffs_unpack_tags2(struct yaffs_dev *dev,
+			struct yaffs_ext_tags *t,
+			struct yaffs_packed_tags2 *pt,
+			int tags_ecc)
+{
+	enum yaffs_ecc_result ecc_result = YAFFS_ECC_RESULT_NO_ERROR;
+
+	if (pt->t.seq_number != 0xffffffff && tags_ecc) {
+		/* Chunk is in use and we need to do ECC */
+
+		struct yaffs_ecc_other ecc;
+		int result;
+		yaffs_ecc_calc_other((unsigned char *)&pt->t,
+				sizeof(struct yaffs_packed_tags2_tags_only),
+				&ecc);
+		result =
+		    yaffs_ecc_correct_other((unsigned char *)&pt->t,
+				sizeof(struct yaffs_packed_tags2_tags_only),
+				&pt->ecc, &ecc);
+		switch (result) {
+		case 0:
+			ecc_result = YAFFS_ECC_RESULT_NO_ERROR;
+			break;
+		case 1:
+			ecc_result = YAFFS_ECC_RESULT_FIXED;
+			break;
+		case -1:
+			ecc_result = YAFFS_ECC_RESULT_UNFIXED;
+			break;
+		default:
+			ecc_result = YAFFS_ECC_RESULT_UNKNOWN;
+		}
+	}
+	yaffs_unpack_tags2_tags_only(dev, t, &pt->t);
+
+	t->ecc_result = ecc_result;
+
+	yaffs_dump_packed_tags2(pt);
+	yaffs_dump_tags2(t);
+}
diff --git a/fs/yaffs2/yaffs_packedtags2.h b/fs/yaffs2/yaffs_packedtags2.h
new file mode 100644
index 00000000..5980326
--- /dev/null
+++ b/fs/yaffs2/yaffs_packedtags2.h
@@ -0,0 +1,50 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+/* This is used to pack YAFFS2 tags, not YAFFS1tags. */
+
+#ifndef __YAFFS_PACKEDTAGS2_H__
+#define __YAFFS_PACKEDTAGS2_H__
+
+#include "yaffs_guts.h"
+#include "yaffs_ecc.h"
+
+struct yaffs_packed_tags2_tags_only {
+	unsigned seq_number;
+	unsigned obj_id;
+	unsigned chunk_id;
+	unsigned n_bytes;
+};
+
+struct yaffs_packed_tags2 {
+	struct yaffs_packed_tags2_tags_only t;
+	struct yaffs_ecc_other ecc;
+};
+
+/* Full packed tags with ECC, used for oob tags */
+void yaffs_pack_tags2(struct yaffs_dev *dev,
+		      struct yaffs_packed_tags2 *pt,
+		      const struct yaffs_ext_tags *t, int tags_ecc);
+void yaffs_unpack_tags2(struct yaffs_dev *dev,
+			struct yaffs_ext_tags *t, struct yaffs_packed_tags2 *pt,
+			int tags_ecc);
+
+/* Only the tags part (no ECC for use with inband tags */
+void yaffs_pack_tags2_tags_only(struct yaffs_dev *dev,
+				struct yaffs_packed_tags2_tags_only *pt,
+				const struct yaffs_ext_tags *t);
+void yaffs_unpack_tags2_tags_only(struct yaffs_dev *dev,
+				  struct yaffs_ext_tags *t,
+				  struct yaffs_packed_tags2_tags_only *pt);
+#endif
diff --git a/fs/yaffs2/yaffs_summary.c b/fs/yaffs2/yaffs_summary.c
new file mode 100644
index 00000000..50a6919
--- /dev/null
+++ b/fs/yaffs2/yaffs_summary.c
@@ -0,0 +1,309 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+/* Summaries write the useful part of the tags for the chunks in a block into an
+ * an array which is written to the last n chunks of the block.
+ * Reading the summaries gives all the tags for the block in one read. Much
+ * faster.
+ *
+ * Chunks holding summaries are marked with tags making it look like
+ * they are part of a fake file.
+ *
+ * The summary could also be used during gc.
+ *
+ */
+
+#include "yaffs_summary.h"
+#include "yaffs_packedtags2.h"
+#include "yaffs_nand.h"
+#include "yaffs_getblockinfo.h"
+#include "yaffs_bitmap.h"
+
+/*
+ * The summary is built up in an array of summary tags.
+ * This gets written to the last one or two (maybe more) chunks in a block.
+ * A summary header is written as the first part of each chunk of summary data.
+ * The summary header must match or the summary is rejected.
+ */
+
+/* Summary tags don't need the sequence number because that is redundant. */
+struct yaffs_summary_tags {
+	unsigned obj_id;
+	unsigned chunk_id;
+	unsigned n_bytes;
+};
+
+/* Summary header */
+struct yaffs_summary_header {
+	unsigned version;	/* Must match current version */
+	unsigned block;		/* Must be this block */
+	unsigned seq;		/* Must be this sequence number */
+	unsigned sum;		/* Just add up all the bytes in the tags */
+};
+
+
+static void yaffs_summary_clear(struct yaffs_dev *dev)
+{
+	if (!dev->sum_tags)
+		return;
+	memset(dev->sum_tags, 0, dev->chunks_per_summary *
+		sizeof(struct yaffs_summary_tags));
+}
+
+
+void yaffs_summary_deinit(struct yaffs_dev *dev)
+{
+	kfree(dev->sum_tags);
+	dev->sum_tags = NULL;
+	kfree(dev->gc_sum_tags);
+	dev->gc_sum_tags = NULL;
+	dev->chunks_per_summary = 0;
+}
+
+int yaffs_summary_init(struct yaffs_dev *dev)
+{
+	int sum_bytes;
+	int chunks_used; /* Number of chunks used by summary */
+	int sum_tags_bytes;
+
+	sum_bytes = dev->param.chunks_per_block *
+			sizeof(struct yaffs_summary_tags);
+
+	chunks_used = (sum_bytes + dev->data_bytes_per_chunk - 1)/
+			(dev->data_bytes_per_chunk -
+				sizeof(struct yaffs_summary_header));
+
+	dev->chunks_per_summary = dev->param.chunks_per_block - chunks_used;
+	sum_tags_bytes = sizeof(struct yaffs_summary_tags) *
+				dev->chunks_per_summary;
+	dev->sum_tags = kmalloc(sum_tags_bytes, GFP_NOFS);
+	dev->gc_sum_tags = kmalloc(sum_tags_bytes, GFP_NOFS);
+	if (!dev->sum_tags || !dev->gc_sum_tags) {
+		yaffs_summary_deinit(dev);
+		return YAFFS_FAIL;
+	}
+
+	yaffs_summary_clear(dev);
+
+	return YAFFS_OK;
+}
+
+static unsigned yaffs_summary_sum(struct yaffs_dev *dev)
+{
+	u8 *sum_buffer = (u8 *)dev->sum_tags;
+	int i;
+	unsigned sum = 0;
+
+	i = sizeof(struct yaffs_summary_tags) *
+				dev->chunks_per_summary;
+	while (i > 0) {
+		sum += *sum_buffer;
+		sum_buffer++;
+		i--;
+	}
+
+	return sum;
+}
+
+static int yaffs_summary_write(struct yaffs_dev *dev, int blk)
+{
+	struct yaffs_ext_tags tags;
+	u8 *buffer;
+	u8 *sum_buffer = (u8 *)dev->sum_tags;
+	int n_bytes;
+	int chunk_in_nand;
+	int chunk_in_block;
+	int result;
+	int this_tx;
+	struct yaffs_summary_header hdr;
+	int sum_bytes_per_chunk = dev->data_bytes_per_chunk - sizeof(hdr);
+	struct yaffs_block_info *bi = yaffs_get_block_info(dev, blk);
+
+	buffer = yaffs_get_temp_buffer(dev);
+	n_bytes = sizeof(struct yaffs_summary_tags) *
+				dev->chunks_per_summary;
+	memset(&tags, 0, sizeof(struct yaffs_ext_tags));
+	tags.obj_id = YAFFS_OBJECTID_SUMMARY;
+	tags.chunk_id = 1;
+	chunk_in_block = dev->chunks_per_summary;
+	chunk_in_nand = dev->alloc_block * dev->param.chunks_per_block +
+						dev->chunks_per_summary;
+	hdr.version = YAFFS_SUMMARY_VERSION;
+	hdr.block = blk;
+	hdr.seq = bi->seq_number;
+	hdr.sum = yaffs_summary_sum(dev);
+
+	do {
+		this_tx = n_bytes;
+		if (this_tx > sum_bytes_per_chunk)
+			this_tx = sum_bytes_per_chunk;
+		memcpy(buffer, &hdr, sizeof(hdr));
+		memcpy(buffer + sizeof(hdr), sum_buffer, this_tx);
+		tags.n_bytes = this_tx + sizeof(hdr);
+		result = yaffs_wr_chunk_tags_nand(dev, chunk_in_nand,
+						buffer, &tags);
+
+		if (result != YAFFS_OK)
+			break;
+		yaffs_set_chunk_bit(dev, blk, chunk_in_block);
+		bi->pages_in_use++;
+		dev->n_free_chunks--;
+
+		n_bytes -= this_tx;
+		sum_buffer += this_tx;
+		chunk_in_nand++;
+		chunk_in_block++;
+		tags.chunk_id++;
+	} while (result == YAFFS_OK && n_bytes > 0);
+	yaffs_release_temp_buffer(dev, buffer);
+
+
+	if (result == YAFFS_OK)
+		bi->has_summary = 1;
+
+
+	return result;
+}
+
+int yaffs_summary_read(struct yaffs_dev *dev,
+			struct yaffs_summary_tags *st,
+			int blk)
+{
+	struct yaffs_ext_tags tags;
+	u8 *buffer;
+	u8 *sum_buffer = (u8 *)st;
+	int n_bytes;
+	u32 chunk_id;
+	int chunk_in_nand;
+	int chunk_in_block;
+	int result;
+	int this_tx;
+	struct yaffs_summary_header hdr;
+	struct yaffs_block_info *bi = yaffs_get_block_info(dev, blk);
+	int sum_bytes_per_chunk = dev->data_bytes_per_chunk - sizeof(hdr);
+
+	buffer = yaffs_get_temp_buffer(dev);
+	n_bytes = sizeof(struct yaffs_summary_tags) * dev->chunks_per_summary;
+	chunk_in_block = dev->chunks_per_summary;
+	chunk_in_nand = blk * dev->param.chunks_per_block +
+							dev->chunks_per_summary;
+	chunk_id = 1;
+	do {
+		this_tx = n_bytes;
+		if (this_tx > sum_bytes_per_chunk)
+			this_tx = sum_bytes_per_chunk;
+		result = yaffs_rd_chunk_tags_nand(dev, chunk_in_nand,
+						buffer, &tags);
+
+		if (tags.chunk_id != chunk_id ||
+			tags.obj_id != YAFFS_OBJECTID_SUMMARY ||
+			tags.chunk_used == 0 ||
+			tags.ecc_result > YAFFS_ECC_RESULT_FIXED ||
+			tags.n_bytes != (this_tx + sizeof(hdr)))
+				result = YAFFS_FAIL;
+		if (result != YAFFS_OK)
+			break;
+
+		if (st == dev->sum_tags) {
+			/* If we're scanning then update the block info */
+			yaffs_set_chunk_bit(dev, blk, chunk_in_block);
+			bi->pages_in_use++;
+		}
+		memcpy(&hdr, buffer, sizeof(hdr));
+		memcpy(sum_buffer, buffer + sizeof(hdr), this_tx);
+		n_bytes -= this_tx;
+		sum_buffer += this_tx;
+		chunk_in_nand++;
+		chunk_in_block++;
+		chunk_id++;
+	} while (result == YAFFS_OK && n_bytes > 0);
+	yaffs_release_temp_buffer(dev, buffer);
+
+	if (result == YAFFS_OK) {
+		/* Verify header */
+		if (hdr.version != YAFFS_SUMMARY_VERSION ||
+		    hdr.seq != bi->seq_number ||
+		    hdr.sum != yaffs_summary_sum(dev))
+			result = YAFFS_FAIL;
+	}
+
+	if (st == dev->sum_tags && result == YAFFS_OK)
+		bi->has_summary = 1;
+
+	return result;
+}
+
+int yaffs_summary_add(struct yaffs_dev *dev,
+			struct yaffs_ext_tags *tags,
+			int chunk_in_nand)
+{
+	struct yaffs_packed_tags2_tags_only tags_only;
+	struct yaffs_summary_tags *sum_tags;
+	int block_in_nand = chunk_in_nand / dev->param.chunks_per_block;
+	int chunk_in_block = chunk_in_nand % dev->param.chunks_per_block;
+
+	if (!dev->sum_tags)
+		return YAFFS_OK;
+
+	if (chunk_in_block >= 0 && chunk_in_block < dev->chunks_per_summary) {
+		yaffs_pack_tags2_tags_only(dev, &tags_only, tags);
+		sum_tags = &dev->sum_tags[chunk_in_block];
+
+		sum_tags->chunk_id = tags_only.chunk_id;
+		sum_tags->n_bytes = tags_only.n_bytes;
+		sum_tags->obj_id = tags_only.obj_id;
+
+		if (chunk_in_block == dev->chunks_per_summary - 1) {
+			/* Time to write out the summary */
+			yaffs_summary_write(dev, block_in_nand);
+			yaffs_summary_clear(dev);
+			yaffs_skip_rest_of_block(dev);
+		}
+	}
+	return YAFFS_OK;
+}
+
+int yaffs_summary_fetch(struct yaffs_dev *dev,
+			struct yaffs_ext_tags *tags,
+			int chunk_in_block)
+{
+	struct yaffs_packed_tags2_tags_only tags_only;
+	struct yaffs_summary_tags *sum_tags;
+	if (chunk_in_block >= 0 && chunk_in_block < dev->chunks_per_summary) {
+		sum_tags = &dev->sum_tags[chunk_in_block];
+		tags_only.chunk_id = sum_tags->chunk_id;
+		tags_only.n_bytes = sum_tags->n_bytes;
+		tags_only.obj_id = sum_tags->obj_id;
+		yaffs_unpack_tags2_tags_only(dev, tags, &tags_only);
+		return YAFFS_OK;
+	}
+	return YAFFS_FAIL;
+}
+
+void yaffs_summary_gc(struct yaffs_dev *dev, int blk)
+{
+	struct yaffs_block_info *bi = yaffs_get_block_info(dev, blk);
+	u32 i;
+
+	if (!bi->has_summary)
+		return;
+
+	for (i = dev->chunks_per_summary;
+	     i < dev->param.chunks_per_block;
+	     i++) {
+		if (yaffs_check_chunk_bit(dev, blk, i)) {
+			yaffs_clear_chunk_bit(dev, blk, i);
+			bi->pages_in_use--;
+			dev->n_free_chunks++;
+		}
+	}
+}
diff --git a/fs/yaffs2/yaffs_summary.h b/fs/yaffs2/yaffs_summary.h
new file mode 100644
index 00000000..0d0a26a
--- /dev/null
+++ b/fs/yaffs2/yaffs_summary.h
@@ -0,0 +1,36 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_SUMMARY_H__
+#define __YAFFS_SUMMARY_H__
+
+#include "yaffs_packedtags2.h"
+
+
+int yaffs_summary_init(struct yaffs_dev *dev);
+void yaffs_summary_deinit(struct yaffs_dev *dev);
+
+int yaffs_summary_add(struct yaffs_dev *dev,
+			struct yaffs_ext_tags *tags,
+			int chunk_in_block);
+int yaffs_summary_fetch(struct yaffs_dev *dev,
+			struct yaffs_ext_tags *tags,
+			int chunk_in_block);
+int yaffs_summary_read(struct yaffs_dev *dev,
+			struct yaffs_summary_tags *st,
+			int blk);
+void yaffs_summary_gc(struct yaffs_dev *dev, int blk);
+
+
+#endif
diff --git a/fs/yaffs2/yaffs_tagscompat.c b/fs/yaffs2/yaffs_tagscompat.c
new file mode 100644
index 00000000..14532b9
--- /dev/null
+++ b/fs/yaffs2/yaffs_tagscompat.c
@@ -0,0 +1,399 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This file handles yaffs1-style tags to allow compatibility with Yaffs1 style
+ * flash layouts.
+ */
+
+#include "yaffs_guts.h"
+#include "yaffs_tagscompat.h"
+#include "yaffs_ecc.h"
+#include "yaffs_getblockinfo.h"
+#include "yaffs_trace.h"
+#include "yaffs_endian.h"
+
+static void yaffs_handle_rd_data_error(struct yaffs_dev *dev, int nand_chunk);
+
+
+/********** Tags ECC calculations  *********/
+
+void yaffs_calc_tags_ecc(struct yaffs_tags *tags)
+{
+	/* Calculate an ecc */
+	unsigned char *b = ((union yaffs_tags_union *)tags)->as_bytes;
+	unsigned i, j;
+	unsigned ecc = 0;
+	unsigned bit = 0;
+
+	tags->ecc = 0;
+
+	for (i = 0; i < 8; i++) {
+		for (j = 1; j & 0xff; j <<= 1) {
+			bit++;
+			if (b[i] & j)
+				ecc ^= bit;
+		}
+	}
+	tags->ecc = ecc;
+}
+
+int yaffs_check_tags_ecc(struct yaffs_tags *tags)
+{
+	unsigned ecc = tags->ecc;
+
+	yaffs_calc_tags_ecc(tags);
+
+	ecc ^= tags->ecc;
+
+	if (ecc && ecc <= 64) {
+		/* TODO: Handle the failure better. Retire? */
+		unsigned char *b = ((union yaffs_tags_union *)tags)->as_bytes;
+
+		ecc--;
+
+		b[ecc / 8] ^= (1 << (ecc & 7));
+
+		/* Now recvalc the ecc */
+		yaffs_calc_tags_ecc(tags);
+
+		return 1;	/* recovered error */
+	} else if (ecc) {
+		/* Wierd ecc failure value */
+		/* TODO Need to do somethiong here */
+		return -1;	/* unrecovered error */
+	}
+	return 0;
+}
+
+/********** Tags **********/
+
+/*
+ * During tags storing/retireval we use a copy of the tags so that
+ * we can modify the endian etc without damaging the previous structure.
+ */
+static void yaffs_load_tags_to_spare(struct yaffs_dev *dev,
+				     struct yaffs_spare *spare_ptr,
+				     struct yaffs_tags *tags_ptr)
+{
+	union yaffs_tags_union *tu_ptr = (union yaffs_tags_union *)tags_ptr;
+	union yaffs_tags_union tags_stored = *tu_ptr;
+
+	yaffs_calc_tags_ecc(&tags_stored.as_tags);
+
+	yaffs_do_endian_u32(dev, &tags_stored.as_u32[0]);
+	yaffs_do_endian_u32(dev, &tags_stored.as_u32[1]);
+
+	spare_ptr->tb0 = tags_stored.as_bytes[0];
+	spare_ptr->tb1 = tags_stored.as_bytes[1];
+	spare_ptr->tb2 = tags_stored.as_bytes[2];
+	spare_ptr->tb3 = tags_stored.as_bytes[3];
+	spare_ptr->tb4 = tags_stored.as_bytes[4];
+	spare_ptr->tb5 = tags_stored.as_bytes[5];
+	spare_ptr->tb6 = tags_stored.as_bytes[6];
+	spare_ptr->tb7 = tags_stored.as_bytes[7];
+}
+
+static void yaffs_get_tags_from_spare(struct yaffs_dev *dev,
+				      struct yaffs_spare *spare_ptr,
+				      struct yaffs_tags *tags_ptr)
+{
+	union yaffs_tags_union *tu = (union yaffs_tags_union *)tags_ptr;
+	union yaffs_tags_union tags_stored;
+	int result;
+
+	tags_stored.as_bytes[0] = spare_ptr->tb0;
+	tags_stored.as_bytes[1] = spare_ptr->tb1;
+	tags_stored.as_bytes[2] = spare_ptr->tb2;
+	tags_stored.as_bytes[3] = spare_ptr->tb3;
+	tags_stored.as_bytes[4] = spare_ptr->tb4;
+	tags_stored.as_bytes[5] = spare_ptr->tb5;
+	tags_stored.as_bytes[6] = spare_ptr->tb6;
+	tags_stored.as_bytes[7] = spare_ptr->tb7;
+
+	yaffs_do_endian_u32(dev, &tags_stored.as_u32[0]);
+	yaffs_do_endian_u32(dev, &tags_stored.as_u32[1]);
+
+	*tu = tags_stored;
+
+	result = yaffs_check_tags_ecc(tags_ptr);
+	if (result > 0)
+		dev->n_tags_ecc_fixed++;
+	else if (result < 0)
+		dev->n_tags_ecc_unfixed++;
+}
+
+static void yaffs_spare_init(struct yaffs_spare *spare)
+{
+	memset(spare, 0xff, sizeof(struct yaffs_spare));
+}
+
+static int yaffs_wr_nand(struct yaffs_dev *dev,
+			 int nand_chunk, const u8 *data,
+			 struct yaffs_spare *spare)
+{
+	int data_size = dev->data_bytes_per_chunk;
+
+	return dev->drv.drv_write_chunk_fn(dev, nand_chunk,
+				data, data_size,
+				(u8 *) spare, sizeof(*spare));
+}
+
+static int yaffs_rd_chunk_nand(struct yaffs_dev *dev,
+			       int nand_chunk,
+			       u8 *data,
+			       struct yaffs_spare *spare,
+			       enum yaffs_ecc_result *ecc_result,
+			       int correct_errors)
+{
+	int ret_val;
+	struct yaffs_spare local_spare;
+	int data_size;
+	int spare_size;
+	int ecc_result1, ecc_result2;
+	u8 calc_ecc[3];
+
+	if (!spare) {
+		/* If we don't have a real spare, then we use a local one. */
+		/* Need this for the calculation of the ecc */
+		spare = &local_spare;
+	}
+	data_size = dev->data_bytes_per_chunk;
+	spare_size = sizeof(struct yaffs_spare);
+
+	if (dev->param.use_nand_ecc)
+		return dev->drv.drv_read_chunk_fn(dev, nand_chunk,
+						data, data_size,
+						(u8 *) spare, spare_size,
+						ecc_result);
+
+
+	/* Handle the ECC at this level. */
+
+	ret_val = dev->drv.drv_read_chunk_fn(dev, nand_chunk,
+						 data, data_size,
+						 (u8 *)spare, spare_size,
+						NULL);
+	if (!data || !correct_errors)
+		return ret_val;
+
+	/* Do ECC correction if needed. */
+	yaffs_ecc_calc(data, calc_ecc);
+	ecc_result1 = yaffs_ecc_correct(data, spare->ecc1, calc_ecc);
+	yaffs_ecc_calc(&data[256], calc_ecc);
+	ecc_result2 = yaffs_ecc_correct(&data[256], spare->ecc2, calc_ecc);
+
+	if (ecc_result1 > 0) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"**>>yaffs ecc error fix performed on chunk %d:0",
+			nand_chunk);
+		dev->n_ecc_fixed++;
+	} else if (ecc_result1 < 0) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"**>>yaffs ecc error unfixed on chunk %d:0",
+			nand_chunk);
+		dev->n_ecc_unfixed++;
+	}
+
+	if (ecc_result2 > 0) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"**>>yaffs ecc error fix performed on chunk %d:1",
+			nand_chunk);
+		dev->n_ecc_fixed++;
+	} else if (ecc_result2 < 0) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"**>>yaffs ecc error unfixed on chunk %d:1",
+			nand_chunk);
+		dev->n_ecc_unfixed++;
+	}
+
+	if (ecc_result1 || ecc_result2) {
+		/* We had a data problem on this page */
+		yaffs_handle_rd_data_error(dev, nand_chunk);
+	}
+
+	if (ecc_result1 < 0 || ecc_result2 < 0)
+		*ecc_result = YAFFS_ECC_RESULT_UNFIXED;
+	else if (ecc_result1 > 0 || ecc_result2 > 0)
+		*ecc_result = YAFFS_ECC_RESULT_FIXED;
+	else
+		*ecc_result = YAFFS_ECC_RESULT_NO_ERROR;
+
+	return ret_val;
+}
+
+/*
+ * Functions for robustisizing
+ */
+
+static void yaffs_handle_rd_data_error(struct yaffs_dev *dev, int nand_chunk)
+{
+	int flash_block = nand_chunk / dev->param.chunks_per_block;
+
+	/* Mark the block for retirement */
+	yaffs_get_block_info(dev, flash_block + dev->block_offset)->
+		needs_retiring = 1;
+	yaffs_trace(YAFFS_TRACE_ERROR | YAFFS_TRACE_BAD_BLOCKS,
+		"**>>Block %d marked for retirement",
+		flash_block);
+
+	/* TODO:
+	 * Just do a garbage collection on the affected block
+	 * then retire the block
+	 * NB recursion
+	 */
+}
+
+static int yaffs_tags_compat_wr(struct yaffs_dev *dev,
+			 int nand_chunk,
+			 const u8 *data, const struct yaffs_ext_tags *ext_tags)
+{
+	struct yaffs_spare spare;
+	struct yaffs_tags tags;
+
+	yaffs_spare_init(&spare);
+
+	if (ext_tags->is_deleted)
+		spare.page_status = 0;
+	else {
+		tags.obj_id = ext_tags->obj_id;
+		tags.chunk_id = ext_tags->chunk_id;
+
+		tags.n_bytes_lsb = ext_tags->n_bytes & (1024 - 1);
+
+		if (dev->data_bytes_per_chunk >= 1024)
+			tags.n_bytes_msb = (ext_tags->n_bytes >> 10) & 3;
+		else
+			tags.n_bytes_msb = 3;
+
+		tags.serial_number = ext_tags->serial_number;
+
+		if (!dev->param.use_nand_ecc && data) {
+			yaffs_ecc_calc(data, spare.ecc1);
+			yaffs_ecc_calc(&data[256], spare.ecc2);
+		}
+
+		yaffs_load_tags_to_spare(dev, &spare, &tags);
+	}
+	return yaffs_wr_nand(dev, nand_chunk, data, &spare);
+}
+
+static int yaffs_tags_compat_rd(struct yaffs_dev *dev,
+			 int nand_chunk,
+			 u8 *data, struct yaffs_ext_tags *ext_tags)
+{
+	struct yaffs_spare spare;
+	struct yaffs_tags tags;
+	enum yaffs_ecc_result ecc_result = YAFFS_ECC_RESULT_UNKNOWN;
+	static struct yaffs_spare spare_ff;
+	static int init;
+	int deleted;
+
+	if (!init) {
+		memset(&spare_ff, 0xff, sizeof(spare_ff));
+		init = 1;
+	}
+
+	if (!yaffs_rd_chunk_nand(dev, nand_chunk,
+					data, &spare, &ecc_result, 1))
+		return YAFFS_FAIL;
+
+	/* ext_tags may be NULL */
+	if (!ext_tags)
+		return YAFFS_OK;
+
+	deleted = (hweight8(spare.page_status) < 7) ? 1 : 0;
+
+	ext_tags->is_deleted = deleted;
+	ext_tags->ecc_result = ecc_result;
+	ext_tags->block_bad = 0;	/* We're reading it */
+	/* therefore it is not a bad block */
+	ext_tags->chunk_used =
+		memcmp(&spare_ff, &spare, sizeof(spare_ff)) ? 1 : 0;
+
+	if (ext_tags->chunk_used) {
+		yaffs_get_tags_from_spare(dev, &spare, &tags);
+
+		ext_tags->obj_id = tags.obj_id;
+		ext_tags->chunk_id = tags.chunk_id;
+		ext_tags->n_bytes = tags.n_bytes_lsb;
+
+		if (dev->data_bytes_per_chunk >= 1024)
+			ext_tags->n_bytes |=
+				(((unsigned)tags.n_bytes_msb) << 10);
+
+		ext_tags->serial_number = tags.serial_number;
+	}
+
+	return YAFFS_OK;
+}
+
+static int yaffs_tags_compat_mark_bad(struct yaffs_dev *dev, int flash_block)
+{
+	struct yaffs_spare spare;
+
+	memset(&spare, 0xff, sizeof(struct yaffs_spare));
+
+	spare.block_status = 'Y';
+
+	yaffs_wr_nand(dev, flash_block * dev->param.chunks_per_block, NULL,
+		      &spare);
+	yaffs_wr_nand(dev, flash_block * dev->param.chunks_per_block + 1,
+		      NULL, &spare);
+
+	return YAFFS_OK;
+}
+
+static int yaffs_tags_compat_query_block(struct yaffs_dev *dev,
+				  int block_no,
+				  enum yaffs_block_state *state,
+				  u32 *seq_number)
+{
+	struct yaffs_spare spare0, spare1;
+	static struct yaffs_spare spare_ff;
+	static int init;
+	enum yaffs_ecc_result dummy;
+
+	if (!init) {
+		memset(&spare_ff, 0xff, sizeof(spare_ff));
+		init = 1;
+	}
+
+	*seq_number = 0;
+
+	/* Look for bad block markers in the first two chunks */
+	yaffs_rd_chunk_nand(dev, block_no * dev->param.chunks_per_block,
+			    NULL, &spare0, &dummy, 0);
+	yaffs_rd_chunk_nand(dev, block_no * dev->param.chunks_per_block + 1,
+			    NULL, &spare1, &dummy, 0);
+
+	if (hweight8(spare0.block_status & spare1.block_status) < 7)
+		*state = YAFFS_BLOCK_STATE_DEAD;
+	else if (memcmp(&spare_ff, &spare0, sizeof(spare_ff)) == 0)
+		*state = YAFFS_BLOCK_STATE_EMPTY;
+	else
+		*state = YAFFS_BLOCK_STATE_NEEDS_SCAN;
+
+	return YAFFS_OK;
+}
+
+void yaffs_tags_compat_install(struct yaffs_dev *dev)
+{
+	if(dev->param.is_yaffs2)
+		return;
+	if(!dev->tagger.write_chunk_tags_fn)
+		dev->tagger.write_chunk_tags_fn = yaffs_tags_compat_wr;
+	if(!dev->tagger.read_chunk_tags_fn)
+		dev->tagger.read_chunk_tags_fn = yaffs_tags_compat_rd;
+	if(!dev->tagger.query_block_fn)
+		dev->tagger.query_block_fn = yaffs_tags_compat_query_block;
+	if(!dev->tagger.mark_bad_fn)
+		dev->tagger.mark_bad_fn = yaffs_tags_compat_mark_bad;
+}
diff --git a/fs/yaffs2/yaffs_tagscompat.h b/fs/yaffs2/yaffs_tagscompat.h
new file mode 100644
index 00000000..a3cbf8d
--- /dev/null
+++ b/fs/yaffs2/yaffs_tagscompat.h
@@ -0,0 +1,43 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_TAGSCOMPAT_H__
+#define __YAFFS_TAGSCOMPAT_H__
+
+
+#include "yaffs_guts.h"
+
+#if 0
+
+
+int yaffs_tags_compat_wr(struct yaffs_dev *dev,
+			 int nand_chunk,
+			 const u8 *data, const struct yaffs_ext_tags *tags);
+int yaffs_tags_compat_rd(struct yaffs_dev *dev,
+			 int nand_chunk,
+			 u8 *data, struct yaffs_ext_tags *tags);
+int yaffs_tags_compat_mark_bad(struct yaffs_dev *dev, int block_no);
+int yaffs_tags_compat_query_block(struct yaffs_dev *dev,
+				  int block_no,
+				  enum yaffs_block_state *state,
+				  u32 *seq_number);
+
+#endif
+
+
+void yaffs_tags_compat_install(struct yaffs_dev *dev);
+void yaffs_calc_tags_ecc(struct yaffs_tags *tags);
+int yaffs_check_tags_ecc(struct yaffs_tags *tags);
+
+#endif
diff --git a/fs/yaffs2/yaffs_tagsmarshall.c b/fs/yaffs2/yaffs_tagsmarshall.c
new file mode 100644
index 00000000..cded165
--- /dev/null
+++ b/fs/yaffs2/yaffs_tagsmarshall.c
@@ -0,0 +1,205 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This file handles the marshalling (ie internal<-->external structure
+ * translation between the internal tags and the stored tags in Yaffs2-style
+ * tags storage.
+ */
+
+#include "yaffs_guts.h"
+#include "yaffs_trace.h"
+#include "yaffs_packedtags2.h"
+
+static int yaffs_tags_marshall_write(struct yaffs_dev *dev,
+				    int nand_chunk, const u8 *data,
+				    const struct yaffs_ext_tags *tags)
+{
+	struct yaffs_packed_tags2 pt;
+	int retval;
+
+	int packed_tags_size =
+	    dev->param.no_tags_ecc ? sizeof(pt.t) : sizeof(pt);
+	void *packed_tags_ptr =
+	    dev->param.no_tags_ecc ? (void *)&pt.t : (void *)&pt;
+
+	yaffs_trace(YAFFS_TRACE_MTD,
+		"yaffs_tags_marshall_write chunk %d data %p tags %p",
+		nand_chunk, data, tags);
+
+	/* For yaffs2 writing there must be both data and tags.
+	 * If we're using inband tags, then the tags are stuffed into
+	 * the end of the data buffer.
+	 */
+	if (!data || !tags)
+		BUG();
+	else if (dev->param.inband_tags) {
+		struct yaffs_packed_tags2_tags_only *pt2tp;
+		pt2tp =
+		    (struct yaffs_packed_tags2_tags_only *)(data +
+							dev->
+							data_bytes_per_chunk);
+		yaffs_pack_tags2_tags_only(dev, pt2tp, tags);
+	} else {
+		yaffs_pack_tags2(dev, &pt, tags, !dev->param.no_tags_ecc);
+	}
+
+	retval = dev->drv.drv_write_chunk_fn(dev, nand_chunk,
+			data, dev->param.total_bytes_per_chunk,
+			(dev->param.inband_tags) ? NULL : packed_tags_ptr,
+			(dev->param.inband_tags) ? 0 : packed_tags_size);
+
+	return retval;
+}
+
+static int yaffs_tags_marshall_read(struct yaffs_dev *dev,
+				   int nand_chunk, u8 *data,
+				   struct yaffs_ext_tags *tags)
+{
+	int retval = 0;
+	int local_data = 0;
+	u8 spare_buffer[100];
+	enum yaffs_ecc_result ecc_result;
+
+	struct yaffs_packed_tags2 pt;
+
+	int packed_tags_size =
+	    dev->param.no_tags_ecc ? sizeof(pt.t) : sizeof(pt);
+	void *packed_tags_ptr =
+	    dev->param.no_tags_ecc ? (void *)&pt.t : (void *)&pt;
+
+	yaffs_trace(YAFFS_TRACE_MTD,
+		"yaffs_tags_marshall_read chunk %d data %p tags %p",
+		nand_chunk, data, tags);
+
+	if (dev->param.inband_tags) {
+		if (!data) {
+			local_data = 1;
+			data = yaffs_get_temp_buffer(dev);
+		}
+	}
+
+	if (dev->param.inband_tags || (data && !tags))
+		retval = dev->drv.drv_read_chunk_fn(dev, nand_chunk,
+					data, dev->param.total_bytes_per_chunk,
+					NULL, 0,
+					&ecc_result);
+	else if (tags)
+		retval = dev->drv.drv_read_chunk_fn(dev, nand_chunk,
+					data, dev->param.total_bytes_per_chunk,
+					spare_buffer, packed_tags_size,
+					&ecc_result);
+	else
+		BUG();
+
+
+	if (retval == YAFFS_FAIL)
+		return YAFFS_FAIL;
+
+	if (dev->param.inband_tags) {
+		if (tags) {
+			struct yaffs_packed_tags2_tags_only *pt2tp;
+			pt2tp =
+				(struct yaffs_packed_tags2_tags_only *)
+				&data[dev->data_bytes_per_chunk];
+			yaffs_unpack_tags2_tags_only(dev, tags, pt2tp);
+		}
+	} else if (tags) {
+		memcpy(packed_tags_ptr, spare_buffer, packed_tags_size);
+		yaffs_unpack_tags2(dev, tags, &pt, !dev->param.no_tags_ecc);
+	}
+
+	if (local_data)
+		yaffs_release_temp_buffer(dev, data);
+
+	if (tags && ecc_result == YAFFS_ECC_RESULT_UNFIXED) {
+		tags->ecc_result = YAFFS_ECC_RESULT_UNFIXED;
+		dev->n_ecc_unfixed++;
+	}
+
+	if (tags && ecc_result == YAFFS_ECC_RESULT_FIXED) {
+		if (tags->ecc_result <= YAFFS_ECC_RESULT_NO_ERROR)
+			tags->ecc_result = YAFFS_ECC_RESULT_FIXED;
+		dev->n_ecc_fixed++;
+	}
+
+	if (ecc_result < YAFFS_ECC_RESULT_UNFIXED)
+		return YAFFS_OK;
+	else
+		return YAFFS_FAIL;
+}
+
+static int yaffs_tags_marshall_query_block(struct yaffs_dev *dev, int block_no,
+			       enum yaffs_block_state *state,
+			       u32 *seq_number)
+{
+	int retval;
+
+	yaffs_trace(YAFFS_TRACE_MTD, "yaffs_tags_marshall_query_block %d",
+			block_no);
+
+	retval = dev->drv.drv_check_bad_fn(dev, block_no);
+
+	if (retval== YAFFS_FAIL) {
+		yaffs_trace(YAFFS_TRACE_MTD, "block is bad");
+
+		*state = YAFFS_BLOCK_STATE_DEAD;
+		*seq_number = 0;
+	} else {
+		struct yaffs_ext_tags t;
+
+		yaffs_tags_marshall_read(dev,
+				    block_no * dev->param.chunks_per_block,
+				    NULL, &t);
+
+		if (t.chunk_used) {
+			*seq_number = t.seq_number;
+			*state = YAFFS_BLOCK_STATE_NEEDS_SCAN;
+		} else {
+			*seq_number = 0;
+			*state = YAFFS_BLOCK_STATE_EMPTY;
+		}
+	}
+
+	yaffs_trace(YAFFS_TRACE_MTD,
+		"block query returns  seq %d state %d",
+		*seq_number, *state);
+
+	if (retval == 0)
+		return YAFFS_OK;
+	else
+		return YAFFS_FAIL;
+}
+
+static int yaffs_tags_marshall_mark_bad(struct yaffs_dev *dev, int block_no)
+{
+	return dev->drv.drv_mark_bad_fn(dev, block_no);
+
+}
+
+
+void yaffs_tags_marshall_install(struct yaffs_dev *dev)
+{
+	if (!dev->param.is_yaffs2)
+		return;
+
+	if (!dev->tagger.write_chunk_tags_fn)
+		dev->tagger.write_chunk_tags_fn = yaffs_tags_marshall_write;
+
+	if (!dev->tagger.read_chunk_tags_fn)
+		dev->tagger.read_chunk_tags_fn = yaffs_tags_marshall_read;
+
+	if (!dev->tagger.query_block_fn)
+		dev->tagger.query_block_fn = yaffs_tags_marshall_query_block;
+
+	if (!dev->tagger.mark_bad_fn)
+		dev->tagger.mark_bad_fn = yaffs_tags_marshall_mark_bad;
+
+}
diff --git a/fs/yaffs2/yaffs_tagsmarshall.h b/fs/yaffs2/yaffs_tagsmarshall.h
new file mode 100644
index 00000000..e6c0ef6
--- /dev/null
+++ b/fs/yaffs2/yaffs_tagsmarshall.h
@@ -0,0 +1,21 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_TAGSMARSHALL_H__
+#define __YAFFS_TAGSMARSHALL_H__
+
+#include "yaffs_guts.h"
+void yaffs_tags_marshall_install(struct yaffs_dev *dev);
+
+#endif
diff --git a/fs/yaffs2/yaffs_trace.h b/fs/yaffs2/yaffs_trace.h
new file mode 100644
index 00000000..5a6aeed
--- /dev/null
+++ b/fs/yaffs2/yaffs_trace.h
@@ -0,0 +1,56 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YTRACE_H__
+#define __YTRACE_H__
+
+extern unsigned int yaffs_trace_mask;
+extern unsigned int yaffs_wr_attempts;
+
+/*
+ * Tracing flags.
+ * The flags masked in YAFFS_TRACE_ALWAYS are always traced.
+ */
+
+#define YAFFS_TRACE_OS			0x00000002
+#define YAFFS_TRACE_ALLOCATE		0x00000004
+#define YAFFS_TRACE_SCAN		0x00000008
+#define YAFFS_TRACE_BAD_BLOCKS		0x00000010
+#define YAFFS_TRACE_ERASE		0x00000020
+#define YAFFS_TRACE_GC			0x00000040
+#define YAFFS_TRACE_WRITE		0x00000080
+#define YAFFS_TRACE_TRACING		0x00000100
+#define YAFFS_TRACE_DELETION		0x00000200
+#define YAFFS_TRACE_BUFFERS		0x00000400
+#define YAFFS_TRACE_NANDACCESS		0x00000800
+#define YAFFS_TRACE_GC_DETAIL		0x00001000
+#define YAFFS_TRACE_SCAN_DEBUG		0x00002000
+#define YAFFS_TRACE_MTD			0x00004000
+#define YAFFS_TRACE_CHECKPOINT		0x00008000
+
+#define YAFFS_TRACE_VERIFY		0x00010000
+#define YAFFS_TRACE_VERIFY_NAND		0x00020000
+#define YAFFS_TRACE_VERIFY_FULL		0x00040000
+#define YAFFS_TRACE_VERIFY_ALL		0x000f0000
+
+#define YAFFS_TRACE_SYNC		0x00100000
+#define YAFFS_TRACE_BACKGROUND		0x00200000
+#define YAFFS_TRACE_LOCK		0x00400000
+#define YAFFS_TRACE_MOUNT		0x00800000
+
+#define YAFFS_TRACE_ERROR		0x40000000
+#define YAFFS_TRACE_BUG			0x80000000
+#define YAFFS_TRACE_ALWAYS		0xf0000000
+
+#endif
diff --git a/fs/yaffs2/yaffs_verify.c b/fs/yaffs2/yaffs_verify.c
new file mode 100644
index 00000000..9141eb5
--- /dev/null
+++ b/fs/yaffs2/yaffs_verify.c
@@ -0,0 +1,539 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yaffs_verify.h"
+#include "yaffs_trace.h"
+#include "yaffs_bitmap.h"
+#include "yaffs_getblockinfo.h"
+#include "yaffs_nand.h"
+
+int yaffs_skip_verification(struct yaffs_dev *dev)
+{
+	(void) dev;
+	return !(yaffs_trace_mask &
+		 (YAFFS_TRACE_VERIFY | YAFFS_TRACE_VERIFY_FULL));
+}
+
+static int yaffs_skip_full_verification(struct yaffs_dev *dev)
+{
+	(void) dev;
+	return !(yaffs_trace_mask & (YAFFS_TRACE_VERIFY_FULL));
+}
+
+static int yaffs_skip_nand_verification(struct yaffs_dev *dev)
+{
+	(void) dev;
+	return !(yaffs_trace_mask & (YAFFS_TRACE_VERIFY_NAND));
+}
+
+static const char * const block_state_name[] = {
+	"Unknown",
+	"Needs scan",
+	"Scanning",
+	"Empty",
+	"Allocating",
+	"Full",
+	"Dirty",
+	"Checkpoint",
+	"Collecting",
+	"Dead"
+};
+
+void yaffs_verify_blk(struct yaffs_dev *dev, struct yaffs_block_info *bi, int n)
+{
+	int actually_used;
+	int in_use;
+
+	if (yaffs_skip_verification(dev))
+		return;
+
+	/* Report illegal runtime states */
+	if (bi->block_state >= YAFFS_NUMBER_OF_BLOCK_STATES)
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Block %d has undefined state %d",
+			n, bi->block_state);
+
+	switch (bi->block_state) {
+	case YAFFS_BLOCK_STATE_UNKNOWN:
+	case YAFFS_BLOCK_STATE_SCANNING:
+	case YAFFS_BLOCK_STATE_NEEDS_SCAN:
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Block %d has bad run-state %s",
+			n, block_state_name[bi->block_state]);
+	}
+
+	/* Check pages in use and soft deletions are legal */
+
+	actually_used = bi->pages_in_use - bi->soft_del_pages;
+
+	if (bi->pages_in_use < 0 ||
+	    bi->pages_in_use > (int)dev->param.chunks_per_block ||
+	    bi->soft_del_pages < 0 ||
+	    bi->soft_del_pages > (int)dev->param.chunks_per_block ||
+	    actually_used < 0 || actually_used > (int)dev->param.chunks_per_block)
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Block %d has illegal values pages_in_used %d soft_del_pages %d",
+			n, bi->pages_in_use, bi->soft_del_pages);
+
+	/* Check chunk bitmap legal */
+	in_use = yaffs_count_chunk_bits(dev, n);
+	if (in_use != bi->pages_in_use)
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Block %d has inconsistent values pages_in_use %d counted chunk bits %d",
+			n, bi->pages_in_use, in_use);
+}
+
+void yaffs_verify_collected_blk(struct yaffs_dev *dev,
+				struct yaffs_block_info *bi, int n)
+{
+	yaffs_verify_blk(dev, bi, n);
+
+	/* After collection the block should be in the erased state */
+
+	if (bi->block_state != YAFFS_BLOCK_STATE_COLLECTING &&
+	    bi->block_state != YAFFS_BLOCK_STATE_EMPTY) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"Block %d is in state %d after gc, should be erased",
+			n, bi->block_state);
+	}
+}
+
+void yaffs_verify_blocks(struct yaffs_dev *dev)
+{
+	u32 i;
+	u32 state_count[YAFFS_NUMBER_OF_BLOCK_STATES];
+	int illegal_states = 0;
+
+	if (yaffs_skip_verification(dev))
+		return;
+
+	memset(state_count, 0, sizeof(state_count));
+
+	for (i = dev->internal_start_block; i <= dev->internal_end_block; i++) {
+		struct yaffs_block_info *bi = yaffs_get_block_info(dev, i);
+		yaffs_verify_blk(dev, bi, i);
+
+		if (bi->block_state < YAFFS_NUMBER_OF_BLOCK_STATES)
+			state_count[bi->block_state]++;
+		else
+			illegal_states++;
+	}
+
+	yaffs_trace(YAFFS_TRACE_VERIFY,	"Block summary");
+
+	yaffs_trace(YAFFS_TRACE_VERIFY,
+		"%d blocks have illegal states",
+		illegal_states);
+	if (state_count[YAFFS_BLOCK_STATE_ALLOCATING] > 1)
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Too many allocating blocks");
+
+	for (i = 0; i < YAFFS_NUMBER_OF_BLOCK_STATES; i++)
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"%s %d blocks",
+			block_state_name[i], state_count[i]);
+
+	if (dev->blocks_in_checkpt != state_count[YAFFS_BLOCK_STATE_CHECKPOINT])
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Checkpoint block count wrong dev %d count %d",
+			dev->blocks_in_checkpt,
+			state_count[YAFFS_BLOCK_STATE_CHECKPOINT]);
+
+	if (dev->n_erased_blocks != (int)state_count[YAFFS_BLOCK_STATE_EMPTY])
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Erased block count wrong dev %d count %d",
+			dev->n_erased_blocks,
+			state_count[YAFFS_BLOCK_STATE_EMPTY]);
+
+	if (state_count[YAFFS_BLOCK_STATE_COLLECTING] > 1)
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Too many collecting blocks %d (max is 1)",
+			state_count[YAFFS_BLOCK_STATE_COLLECTING]);
+}
+
+/*
+ * Verify the object header. oh must be valid, but obj and tags may be NULL in
+ * which case those tests will not be performed.
+ */
+void yaffs_verify_oh(struct yaffs_obj *obj, struct yaffs_obj_hdr *oh,
+		     struct yaffs_ext_tags *tags, int parent_check)
+{
+	if (obj && yaffs_skip_verification(obj->my_dev))
+		return;
+
+	if (!(tags && obj && oh)) {
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Verifying object header tags %p obj %p oh %p",
+			tags, obj, oh);
+		return;
+	}
+
+	if (oh->type <= YAFFS_OBJECT_TYPE_UNKNOWN ||
+	    oh->type > YAFFS_OBJECT_TYPE_MAX)
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Obj %d header type is illegal value 0x%x",
+			tags->obj_id, oh->type);
+
+	if (tags->obj_id != obj->obj_id)
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Obj %d header mismatch obj_id %d",
+			tags->obj_id, obj->obj_id);
+
+	/*
+	 * Check that the object's parent ids match if parent_check requested.
+	 *
+	 * Tests do not apply to the root object.
+	 */
+
+	if (parent_check && tags->obj_id > 1 && !obj->parent)
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Obj %d header mismatch parent_id %d obj->parent is NULL",
+			tags->obj_id, oh->parent_obj_id);
+
+	if (parent_check && obj->parent &&
+	    oh->parent_obj_id !=  obj->parent->obj_id &&
+	    (oh->parent_obj_id != YAFFS_OBJECTID_UNLINKED ||
+	     obj->parent->obj_id != YAFFS_OBJECTID_DELETED))
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Obj %d header mismatch parent_id %d parent_obj_id %d",
+			tags->obj_id, oh->parent_obj_id,
+			obj->parent->obj_id);
+
+	if (tags->obj_id > 1 && oh->name[0] == 0)	/* Null name */
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Obj %d header name is NULL",
+			obj->obj_id);
+
+	if (tags->obj_id > 1 && ((u8) (oh->name[0])) == 0xff)	/* Junk name */
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Obj %d header name is 0xff",
+			obj->obj_id);
+}
+
+void yaffs_verify_file(struct yaffs_obj *obj)
+{
+	u32 x;
+	int required_depth;
+	int last_chunk;
+	u32 offset_in_chunk;
+	u32 the_chunk;
+
+	int i;
+	struct yaffs_dev *dev;
+	struct yaffs_ext_tags tags;
+	struct yaffs_tnode *tn;
+	u32 obj_id;
+
+	if (!obj)
+		return;
+
+	if (yaffs_skip_verification(obj->my_dev))
+		return;
+
+	dev = obj->my_dev;
+	obj_id = obj->obj_id;
+
+
+	/* Check file size is consistent with tnode depth */
+	yaffs_addr_to_chunk(dev, obj->variant.file_variant.file_size,
+				&last_chunk, &offset_in_chunk);
+	last_chunk++;
+	x = last_chunk >> YAFFS_TNODES_LEVEL0_BITS;
+	required_depth = 0;
+	while (x > 0) {
+		x >>= YAFFS_TNODES_INTERNAL_BITS;
+		required_depth++;
+	}
+
+	/* Check that the chunks in the tnode tree are all correct.
+	 * We do this by scanning through the tnode tree and
+	 * checking the tags for every chunk match.
+	 */
+
+	if (yaffs_skip_nand_verification(dev))
+		return;
+
+	for (i = 1; i <= last_chunk; i++) {
+		tn = yaffs_find_tnode_0(dev, &obj->variant.file_variant, i);
+
+		if (!tn)
+			continue;
+
+		the_chunk = yaffs_get_group_base(dev, tn, i);
+		if (the_chunk > 0) {
+			yaffs_rd_chunk_tags_nand(dev, the_chunk, NULL,
+						 &tags);
+			if (tags.obj_id != obj_id || tags.chunk_id != (u32)i)
+				yaffs_trace(YAFFS_TRACE_VERIFY,
+					"Object %d chunk_id %d NAND mismatch chunk %d tags (%d:%d)",
+					obj_id, i, the_chunk,
+					tags.obj_id, tags.chunk_id);
+		}
+	}
+}
+
+void yaffs_verify_link(struct yaffs_obj *obj)
+{
+	if (obj && yaffs_skip_verification(obj->my_dev))
+		return;
+
+	/* Verify sane equivalent object */
+}
+
+void yaffs_verify_symlink(struct yaffs_obj *obj)
+{
+	if (obj && yaffs_skip_verification(obj->my_dev))
+		return;
+
+	/* Verify symlink string */
+}
+
+void yaffs_verify_special(struct yaffs_obj *obj)
+{
+	if (obj && yaffs_skip_verification(obj->my_dev))
+		return;
+}
+
+void yaffs_verify_obj(struct yaffs_obj *obj)
+{
+	struct yaffs_dev *dev;
+	u32 chunk_min;
+	u32 chunk_max;
+	u32 chunk_id_ok;
+	u32 chunk_in_range;
+	u32 chunk_wrongly_deleted;
+	u32 chunk_valid;
+
+	if (!obj)
+		return;
+
+	if (obj->being_created)
+		return;
+
+	dev = obj->my_dev;
+
+	if (yaffs_skip_verification(dev))
+		return;
+
+	/* Check sane object header chunk */
+
+	chunk_min = dev->internal_start_block * dev->param.chunks_per_block;
+	chunk_max =
+	    (dev->internal_end_block + 1) * dev->param.chunks_per_block - 1;
+
+	chunk_in_range = (((unsigned)(obj->hdr_chunk)) >= chunk_min &&
+			  ((unsigned)(obj->hdr_chunk)) <= chunk_max);
+	chunk_id_ok = chunk_in_range || (obj->hdr_chunk == 0);
+	chunk_valid = chunk_in_range &&
+	    yaffs_check_chunk_bit(dev,
+				  obj->hdr_chunk / dev->param.chunks_per_block,
+				  obj->hdr_chunk % dev->param.chunks_per_block);
+	chunk_wrongly_deleted = chunk_in_range && !chunk_valid;
+
+	if (!obj->fake && (!chunk_id_ok || chunk_wrongly_deleted))
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Obj %d has chunk_id %d %s %s",
+			obj->obj_id, obj->hdr_chunk,
+			chunk_id_ok ? "" : ",out of range",
+			chunk_wrongly_deleted ? ",marked as deleted" : "");
+
+	if (chunk_valid && !yaffs_skip_nand_verification(dev)) {
+		struct yaffs_ext_tags tags;
+		struct yaffs_obj_hdr *oh;
+		u8 *buffer = yaffs_get_temp_buffer(dev);
+
+		oh = (struct yaffs_obj_hdr *)buffer;
+
+		yaffs_rd_chunk_tags_nand(dev, obj->hdr_chunk, buffer, &tags);
+
+		yaffs_verify_oh(obj, oh, &tags, 1);
+
+		yaffs_release_temp_buffer(dev, buffer);
+	}
+
+	/* Verify it has a parent */
+	if (obj && !obj->fake && (!obj->parent || obj->parent->my_dev != dev)) {
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Obj %d has parent pointer %p which does not look like an object",
+			obj->obj_id, obj->parent);
+	}
+
+	/* Verify parent is a directory */
+	if (obj->parent &&
+	    obj->parent->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Obj %d's parent is not a directory (type %d)",
+			obj->obj_id, obj->parent->variant_type);
+	}
+
+	switch (obj->variant_type) {
+	case YAFFS_OBJECT_TYPE_FILE:
+		yaffs_verify_file(obj);
+		break;
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+		yaffs_verify_symlink(obj);
+		break;
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+		yaffs_verify_dir(obj);
+		break;
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+		yaffs_verify_link(obj);
+		break;
+	case YAFFS_OBJECT_TYPE_SPECIAL:
+		yaffs_verify_special(obj);
+		break;
+	case YAFFS_OBJECT_TYPE_UNKNOWN:
+	default:
+		yaffs_trace(YAFFS_TRACE_VERIFY,
+			"Obj %d has illegaltype %d",
+		   obj->obj_id, obj->variant_type);
+		break;
+	}
+}
+
+void yaffs_verify_objects(struct yaffs_dev *dev)
+{
+	struct yaffs_obj *obj;
+	int i;
+	struct list_head *lh;
+
+	if (yaffs_skip_verification(dev))
+		return;
+
+	/* Iterate through the objects in each hash entry */
+
+	for (i = 0; i < YAFFS_NOBJECT_BUCKETS; i++) {
+		list_for_each(lh, &dev->obj_bucket[i].list) {
+			obj = list_entry(lh, struct yaffs_obj, hash_link);
+			yaffs_verify_obj(obj);
+		}
+	}
+}
+
+void yaffs_verify_obj_in_dir(struct yaffs_obj *obj)
+{
+	struct list_head *lh;
+	struct yaffs_obj *list_obj;
+	int count = 0;
+
+	if (!obj) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS, "No object to verify");
+		BUG();
+		return;
+	}
+
+	if (yaffs_skip_verification(obj->my_dev))
+		return;
+
+	if (!obj->parent) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS, "Object does not have parent");
+		BUG();
+		return;
+	}
+
+	if (obj->parent->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS, "Parent is not directory");
+		BUG();
+	}
+
+	/* Iterate through the objects in each hash entry */
+
+	list_for_each(lh, &obj->parent->variant.dir_variant.children) {
+		list_obj = list_entry(lh, struct yaffs_obj, siblings);
+		yaffs_verify_obj(list_obj);
+		if (obj == list_obj)
+			count++;
+	}
+
+	if (count != 1) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"Object in directory %d times",
+			count);
+		BUG();
+	}
+}
+
+void yaffs_verify_dir(struct yaffs_obj *directory)
+{
+	struct list_head *lh;
+	struct yaffs_obj *list_obj;
+	struct yaffs_dev *dev;
+
+	if (!directory) {
+		BUG();
+		return;
+	}
+
+	dev = directory->my_dev;
+
+	if (!dev) {
+		BUG();
+		return;
+	}
+
+	if (directory == dev->root_dir ||
+	    directory == dev->lost_n_found ||
+	    directory == dev->unlinked_dir ||
+	    directory == dev->del_dir)
+		return;
+
+	if (yaffs_skip_full_verification(directory->my_dev))
+		return;
+
+	if (directory->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"Directory has wrong type: %d",
+			directory->variant_type);
+		BUG();
+	}
+
+	/* Iterate through the objects in each hash entry */
+
+	list_for_each(lh, &directory->variant.dir_variant.children) {
+		list_obj = list_entry(lh, struct yaffs_obj, siblings);
+		if (list_obj->parent != directory) {
+			yaffs_trace(YAFFS_TRACE_ALWAYS,
+				"Object in directory list has wrong parent %p",
+				list_obj->parent);
+			BUG();
+		}
+		yaffs_verify_obj_in_dir(list_obj);
+	}
+}
+
+static int yaffs_free_verification_failures;
+
+void yaffs_verify_free_chunks(struct yaffs_dev *dev)
+{
+	int counted;
+	int difference;
+
+	if (yaffs_skip_verification(dev))
+		return;
+
+	counted = yaffs_count_free_chunks(dev);
+
+	difference = dev->n_free_chunks - counted;
+
+	if (difference) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"Freechunks verification failure %d %d %d",
+			dev->n_free_chunks, counted, difference);
+		yaffs_free_verification_failures++;
+	}
+}
+
+int yaffs_verify_file_sane(struct yaffs_obj *in)
+{
+	(void) in;
+	return YAFFS_OK;
+}
diff --git a/fs/yaffs2/yaffs_verify.h b/fs/yaffs2/yaffs_verify.h
new file mode 100644
index 00000000..7571201
--- /dev/null
+++ b/fs/yaffs2/yaffs_verify.h
@@ -0,0 +1,42 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_VERIFY_H__
+#define __YAFFS_VERIFY_H__
+
+#include "yaffs_guts.h"
+
+void yaffs_verify_blk(struct yaffs_dev *dev, struct yaffs_block_info *bi,
+		      int n);
+void yaffs_verify_collected_blk(struct yaffs_dev *dev,
+				struct yaffs_block_info *bi, int n);
+void yaffs_verify_blocks(struct yaffs_dev *dev);
+
+void yaffs_verify_oh(struct yaffs_obj *obj, struct yaffs_obj_hdr *oh,
+		     struct yaffs_ext_tags *tags, int parent_check);
+void yaffs_verify_file(struct yaffs_obj *obj);
+void yaffs_verify_link(struct yaffs_obj *obj);
+void yaffs_verify_symlink(struct yaffs_obj *obj);
+void yaffs_verify_special(struct yaffs_obj *obj);
+void yaffs_verify_obj(struct yaffs_obj *obj);
+void yaffs_verify_objects(struct yaffs_dev *dev);
+void yaffs_verify_obj_in_dir(struct yaffs_obj *obj);
+void yaffs_verify_dir(struct yaffs_obj *directory);
+void yaffs_verify_free_chunks(struct yaffs_dev *dev);
+
+int yaffs_verify_file_sane(struct yaffs_obj *obj);
+
+int yaffs_skip_verification(struct yaffs_dev *dev);
+
+#endif
diff --git a/fs/yaffs2/yaffs_vfs.c b/fs/yaffs2/yaffs_vfs.c
new file mode 100644
index 00000000..de3dd75
--- /dev/null
+++ b/fs/yaffs2/yaffs_vfs.c
@@ -0,0 +1,3752 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ * Acknowledgements:
+ * Luc van OostenRyck for numerous patches.
+ * Nick Bane for numerous patches.
+ * Nick Bane for 2.5/2.6 integration.
+ * Andras Toth for mknod rdev issue.
+ * Michael Fischer for finding the problem with inode inconsistency.
+ * Some code bodily lifted from JFFS
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+/*
+ *
+ * This is the file system front-end to YAFFS that hooks it up to
+ * the VFS.
+ *
+ * Special notes:
+ * >> 2.4: sb->u.generic_sbp points to the struct yaffs_dev associated with
+ *         this superblock
+ * >> 2.6: sb->s_fs_info  points to the struct yaffs_dev associated with this
+ *         superblock
+ * >> inode->u.generic_ip points to the associated struct yaffs_obj.
+ */
+
+/*
+ * There are two variants of the VFS glue code. This variant should compile
+ * for any version of Linux.
+ */
+#include <linux/version.h>
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 10))
+#define YAFFS_COMPILE_BACKGROUND
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 23))
+#define YAFFS_COMPILE_FREEZER
+#endif
+#endif
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 28))
+#define YAFFS_COMPILE_EXPORTFS
+#endif
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 35))
+#define YAFFS_USE_SETATTR_COPY
+#define YAFFS_USE_TRUNCATE_SETSIZE
+#endif
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 35))
+#define YAFFS_HAS_EVICT_INODE
+#endif
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 13)) && \
+    (LINUX_VERSION_CODE < KERNEL_VERSION(4, 8, 0))
+#define YAFFS_NEW_FOLLOW_LINK 1
+#else
+#define YAFFS_NEW_FOLLOW_LINK 0
+#endif
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(3, 6, 0))
+#define YAFFS_HAS_WRITE_SUPER
+#endif
+
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 19))
+#include <linux/config.h>
+#endif
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/fs.h>
+#include <linux/proc_fs.h>
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 39))
+#include <linux/smp_lock.h>
+#endif
+#include <linux/pagemap.h>
+#include <linux/mtd/mtd.h>
+#include <linux/interrupt.h>
+#include <linux/string.h>
+#include <linux/ctype.h>
+
+#if (YAFFS_NEW_FOLLOW_LINK == 1)
+#include <linux/namei.h>
+#endif
+
+#ifdef YAFFS_COMPILE_EXPORTFS
+#include <linux/exportfs.h>
+#endif
+
+#ifdef YAFFS_COMPILE_BACKGROUND
+#include <linux/kthread.h>
+#include <linux/delay.h>
+#endif
+#ifdef YAFFS_COMPILE_FREEZER
+#include <linux/freezer.h>
+#endif
+
+#include <asm/div64.h>
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+
+#include <linux/statfs.h>
+
+#define UnlockPage(p) unlock_page(p)
+#define Page_Uptodate(page)	test_bit(PG_uptodate, &(page)->flags)
+
+/* FIXME: use sb->s_id instead ? */
+#define yaffs_devname(sb, buf)	bdevname(sb->s_bdev, buf)
+
+#else
+
+#include <linux/locks.h>
+#define	BDEVNAME_SIZE		0
+#define	yaffs_devname(sb, buf)	kdevname(sb->s_dev)
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 5, 0))
+/* added NCB 26/5/2006 for 2.4.25-vrs2-tcl1 kernel */
+#define __user
+#endif
+
+#endif
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 26))
+#define YPROC_ROOT  (&proc_root)
+#else
+#define YPROC_ROOT  NULL
+#endif
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 26))
+#define Y_INIT_TIMER(a)	init_timer(a)
+#else
+#define Y_INIT_TIMER(a)	init_timer_on_stack(a)
+#endif
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 27))
+#define YAFFS_USE_WRITE_BEGIN_END 1
+#else
+#define YAFFS_USE_WRITE_BEGIN_END 0
+#endif
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(3, 6, 0))
+#define YAFFS_SUPER_HAS_DIRTY
+#endif
+
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(3, 2, 0))
+#define set_nlink(inode, count)  do { (inode)->i_nlink = (count); } while(0)
+#endif
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 28))
+static uint32_t YCALCBLOCKS(uint64_t partition_size, uint32_t block_size)
+{
+	uint64_t result = partition_size;
+	do_div(result, block_size);
+	return (uint32_t) result;
+}
+#else
+#define YCALCBLOCKS(s, b) ((s)/(b))
+#endif
+
+#include <linux/uaccess.h>
+#include <linux/mtd/mtd.h>
+
+#include "yportenv.h"
+#include "yaffs_trace.h"
+#include "yaffs_guts.h"
+#include "yaffs_attribs.h"
+
+#include "yaffs_linux.h"
+
+#include "yaffs_mtdif.h"
+#include "yaffs_packedtags2.h"
+#include "yaffs_getblockinfo.h"
+
+unsigned int yaffs_trace_mask =
+		YAFFS_TRACE_BAD_BLOCKS |
+		YAFFS_TRACE_ALWAYS |
+		0;
+
+unsigned int yaffs_wr_attempts = YAFFS_WR_ATTEMPTS;
+unsigned int yaffs_auto_checkpoint = 1;
+unsigned int yaffs_gc_control = 1;
+unsigned int yaffs_bg_enable = 1;
+unsigned int yaffs_auto_select = 1;
+/* Module Parameters */
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+module_param(yaffs_trace_mask, uint, 0644);
+module_param(yaffs_wr_attempts, uint, 0644);
+module_param(yaffs_auto_checkpoint, uint, 0644);
+module_param(yaffs_gc_control, uint, 0644);
+module_param(yaffs_bg_enable, uint, 0644);
+#else
+MODULE_PARM(yaffs_trace_mask, "i");
+MODULE_PARM(yaffs_wr_attempts, "i");
+MODULE_PARM(yaffs_auto_checkpoint, "i");
+MODULE_PARM(yaffs_gc_control, "i");
+#endif
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 25))
+/* use iget and read_inode */
+#define Y_IGET(sb, inum) iget((sb), (inum))
+
+#else
+/* Call local equivalent */
+#define YAFFS_USE_OWN_IGET
+#define Y_IGET(sb, inum) yaffs_iget((sb), (inum))
+
+#endif
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 18))
+#define yaffs_inode_to_obj_lv(iptr) ((iptr)->i_private)
+#else
+#define yaffs_inode_to_obj_lv(iptr) ((iptr)->u.generic_ip)
+#endif
+
+#define yaffs_inode_to_obj(iptr) \
+	((struct yaffs_obj *)(yaffs_inode_to_obj_lv(iptr)))
+#define yaffs_dentry_to_obj(dptr) yaffs_inode_to_obj((dptr)->d_inode)
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+#define yaffs_super_to_dev(sb)	((struct yaffs_dev *)sb->s_fs_info)
+#else
+#define yaffs_super_to_dev(sb)	((struct yaffs_dev *)sb->u.generic_sbp)
+#endif
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 5, 0))
+#define Y_CLEAR_INODE(i) clear_inode(i)
+#else
+#define Y_CLEAR_INODE(i) end_writeback(i)
+#endif
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 12, 0))
+#define YAFFS_USE_DIR_ITERATE
+#endif
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(4, 9, 0))
+#define YAFFS_USE_XATTR
+#endif
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(3,12,0))
+#define YAFFS_NEW_PROCFS
+#include <linux/seq_file.h>
+#endif
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(4, 8, 0))
+#define PAGE_CACHE_SIZE PAGE_SIZE
+#define PAGE_CACHE_SHIFT PAGE_SHIFT
+#define Y_GET_DENTRY(f) ((f)->f_path.dentry)
+#define page_cache_release put_page
+#define YAFFS_NEW_XATTR 1
+#define YAFFS_NEW_GET_LINK 1
+#else
+#define Y_GET_DENTRY(f) ((f)->f_dentry)
+#define YAFFS_NEW_XATTR 0
+#define YAFFS_NEW_GET_LINK 0
+#endif
+
+#define update_dir_time(dir) do {\
+			(dir)->i_ctime = (dir)->i_mtime = CURRENT_TIME; \
+		} while (0)
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(4, 9, 0))
+static inline int setattr_prepare(struct dentry *dentry, struct iattr *attr)
+{
+	return inode_change_ok(dentry->d_inode, attr);
+}
+#endif
+
+static void yaffs_fill_inode_from_obj(struct inode *inode,
+				      struct yaffs_obj *obj);
+
+
+static void yaffs_gross_lock(struct yaffs_dev *dev)
+{
+	yaffs_trace(YAFFS_TRACE_LOCK, "yaffs locking %p", current);
+	mutex_lock(&(yaffs_dev_to_lc(dev)->gross_lock));
+	yaffs_trace(YAFFS_TRACE_LOCK, "yaffs locked %p", current);
+}
+
+static void yaffs_gross_unlock(struct yaffs_dev *dev)
+{
+	yaffs_trace(YAFFS_TRACE_LOCK, "yaffs unlocking %p", current);
+	mutex_unlock(&(yaffs_dev_to_lc(dev)->gross_lock));
+}
+
+
+static int yaffs_readpage_nolock(struct file *f, struct page *pg)
+{
+	/* Lifted from jffs2 */
+
+	struct yaffs_obj *obj;
+	unsigned char *pg_buf;
+	int ret;
+	loff_t pos = ((loff_t) pg->index) << PAGE_SHIFT;
+	struct yaffs_dev *dev;
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_readpage_nolock at %lld, size %08x",
+		(long long)pos,
+		(unsigned)PAGE_SIZE);
+
+	obj = yaffs_dentry_to_obj(Y_GET_DENTRY(f));
+
+	dev = obj->my_dev;
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+	BUG_ON(!PageLocked(pg));
+#else
+	if (!PageLocked(pg))
+		PAGE_BUG(pg);
+#endif
+
+	pg_buf = kmap(pg);
+	/* FIXME: Can kmap fail? */
+
+	yaffs_gross_lock(dev);
+
+	ret = yaffs_file_rd(obj, pg_buf, pos, PAGE_CACHE_SIZE);
+
+	yaffs_gross_unlock(dev);
+
+	if (ret >= 0)
+		ret = 0;
+
+	if (ret) {
+		ClearPageUptodate(pg);
+		SetPageError(pg);
+	} else {
+		SetPageUptodate(pg);
+		ClearPageError(pg);
+	}
+
+	flush_dcache_page(pg);
+	kunmap(pg);
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_readpage_nolock done");
+	return ret;
+}
+
+static int yaffs_readpage_unlock(struct file *f, struct page *pg)
+{
+	int ret = yaffs_readpage_nolock(f, pg);
+	UnlockPage(pg);
+	return ret;
+}
+
+static int yaffs_readpage(struct file *f, struct page *pg)
+{
+	int ret;
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_readpage");
+	ret = yaffs_readpage_unlock(f, pg);
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_readpage done");
+	return ret;
+}
+
+
+static void yaffs_set_super_dirty_val(struct yaffs_dev *dev, int val)
+{
+	struct yaffs_linux_context *lc = yaffs_dev_to_lc(dev);
+
+	if (lc)
+		lc->dirty = val;
+
+# ifdef YAFFS_SUPER_HAS_DIRTY
+	{
+		struct super_block *sb = lc->super;
+
+		if (sb)
+			sb->s_dirt = val;
+	}
+#endif
+
+}
+
+static void yaffs_set_super_dirty(struct yaffs_dev *dev)
+{
+	yaffs_set_super_dirty_val(dev, 1);
+}
+
+static void yaffs_clear_super_dirty(struct yaffs_dev *dev)
+{
+	yaffs_set_super_dirty_val(dev, 0);
+}
+
+static int yaffs_check_super_dirty(struct yaffs_dev *dev)
+{
+	struct yaffs_linux_context *lc = yaffs_dev_to_lc(dev);
+
+	if (lc && lc->dirty)
+		return 1;
+
+# ifdef YAFFS_SUPER_HAS_DIRTY
+	{
+		struct super_block *sb = lc->super;
+
+		if (sb && sb->s_dirt)
+			return 1;
+	}
+#endif
+	return 0;
+
+}
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+static int yaffs_writepage(struct page *page, struct writeback_control *wbc)
+#else
+static int yaffs_writepage(struct page *page)
+#endif
+{
+	struct yaffs_dev *dev;
+	struct address_space *mapping = page->mapping;
+	struct inode *inode;
+	unsigned long end_index;
+	char *buffer;
+	struct yaffs_obj *obj;
+	int n_written = 0;
+	unsigned n_bytes;
+	loff_t i_size;
+
+	if (!mapping)
+		BUG();
+	inode = mapping->host;
+	if (!inode)
+		BUG();
+	i_size = i_size_read(inode);
+
+	end_index = i_size >> PAGE_CACHE_SHIFT;
+
+	if (page->index < end_index)
+		n_bytes = PAGE_CACHE_SIZE;
+	else {
+		n_bytes = i_size & (PAGE_CACHE_SIZE - 1);
+
+		if (page->index > end_index || !n_bytes) {
+			yaffs_trace(YAFFS_TRACE_OS,
+				"yaffs_writepage at %lld, inode size = %lld!!",
+				((loff_t)page->index) << PAGE_CACHE_SHIFT,
+				inode->i_size);
+			yaffs_trace(YAFFS_TRACE_OS,
+				"                -> don't care!!");
+
+			zero_user_segment(page, 0, PAGE_CACHE_SIZE);
+			set_page_writeback(page);
+			unlock_page(page);
+			end_page_writeback(page);
+			return 0;
+		}
+	}
+
+	if (n_bytes != PAGE_CACHE_SIZE)
+		zero_user_segment(page, n_bytes, PAGE_CACHE_SIZE);
+
+	get_page(page);
+
+	buffer = kmap(page);
+
+	obj = yaffs_inode_to_obj(inode);
+	dev = obj->my_dev;
+	yaffs_gross_lock(dev);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_writepage at %lld, size %08x",
+		((loff_t)page->index) << PAGE_CACHE_SHIFT, n_bytes);
+	yaffs_trace(YAFFS_TRACE_OS,
+		"writepag0: obj = %lld, ino = %lld",
+		obj->variant.file_variant.file_size, inode->i_size);
+
+	n_written = yaffs_wr_file(obj, buffer,
+				  ((loff_t)page->index) << PAGE_CACHE_SHIFT, n_bytes, 0);
+
+	yaffs_set_super_dirty(dev);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"writepag1: obj = %lld, ino = %lld",
+		obj->variant.file_variant.file_size, inode->i_size);
+
+	yaffs_gross_unlock(dev);
+
+	kunmap(page);
+	set_page_writeback(page);
+	unlock_page(page);
+	end_page_writeback(page);
+	put_page(page);
+
+	return (n_written == n_bytes) ? 0 : -ENOSPC;
+}
+
+/* Space holding and freeing is done to ensure we have space available for write_begin/end */
+/* For now we just assume few parallel writes and check against a small number. */
+/* Todo: need to do this with a counter to handle parallel reads better */
+
+static ssize_t yaffs_hold_space(struct file *f)
+{
+	struct yaffs_obj *obj;
+	struct yaffs_dev *dev;
+
+	int n_free_chunks;
+
+	obj = yaffs_dentry_to_obj(Y_GET_DENTRY(f));
+
+	dev = obj->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	n_free_chunks = yaffs_get_n_free_chunks(dev);
+
+	yaffs_gross_unlock(dev);
+
+	return (n_free_chunks > 20) ? 1 : 0;
+}
+
+static void yaffs_release_space(struct file *f)
+{
+	struct yaffs_obj *obj;
+	struct yaffs_dev *dev;
+
+	obj = yaffs_dentry_to_obj(Y_GET_DENTRY(f));
+
+	dev = obj->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	yaffs_gross_unlock(dev);
+}
+
+#if (YAFFS_USE_WRITE_BEGIN_END > 0)
+static int yaffs_write_begin(struct file *filp, struct address_space *mapping,
+			     loff_t pos, unsigned len, unsigned flags,
+			     struct page **pagep, void **fsdata)
+{
+	struct page *pg = NULL;
+	pgoff_t index = pos >> PAGE_CACHE_SHIFT;
+
+	int ret = 0;
+	int space_held = 0;
+
+	/* Get a page */
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 28)
+	pg = grab_cache_page_write_begin(mapping, index, flags);
+#else
+	pg = __grab_cache_page(mapping, index);
+#endif
+
+	*pagep = pg;
+	if (!pg) {
+		ret = -ENOMEM;
+		goto out;
+	}
+	yaffs_trace(YAFFS_TRACE_OS,
+		"start yaffs_write_begin index %d(%x) uptodate %d",
+		(int)index, (int)index, Page_Uptodate(pg) ? 1 : 0);
+
+	/* Get fs space */
+	space_held = yaffs_hold_space(filp);
+
+	if (!space_held) {
+		ret = -ENOSPC;
+		goto out;
+	}
+
+	/* Update page if required */
+
+	if (!Page_Uptodate(pg))
+		ret = yaffs_readpage_nolock(filp, pg);
+
+	if (ret)
+		goto out;
+
+	/* Happy path return */
+	yaffs_trace(YAFFS_TRACE_OS, "end yaffs_write_begin - ok");
+
+	return 0;
+
+out:
+	yaffs_trace(YAFFS_TRACE_OS,
+		"end yaffs_write_begin fail returning %d", ret);
+	if (space_held)
+		yaffs_release_space(filp);
+	if (pg) {
+		unlock_page(pg);
+		page_cache_release(pg);
+	}
+	return ret;
+}
+
+#else
+
+static int yaffs_prepare_write(struct file *f, struct page *pg,
+			       unsigned offset, unsigned to)
+{
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_prepair_write");
+
+	if (!Page_Uptodate(pg))
+		return yaffs_readpage_nolock(f, pg);
+	return 0;
+}
+#endif
+
+
+static ssize_t yaffs_file_write(struct file *f, const char *buf, size_t n,
+				loff_t * pos)
+{
+	struct yaffs_obj *obj;
+	int n_written;
+	loff_t ipos;
+	struct inode *inode;
+	struct yaffs_dev *dev;
+
+	obj = yaffs_dentry_to_obj(Y_GET_DENTRY(f));
+
+	if (!obj) {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_file_write: hey obj is null!");
+                return -EINVAL;
+        }
+
+	dev = obj->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	inode = Y_GET_DENTRY(f)->d_inode;
+
+	if (!S_ISBLK(inode->i_mode) && f->f_flags & O_APPEND)
+		ipos = inode->i_size;
+	else
+		ipos = *pos;
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_file_write about to write writing %u(%x) bytes to object %d at %lld",
+		(unsigned)n, (unsigned)n, obj->obj_id, ipos);
+
+	n_written = yaffs_wr_file(obj, buf, ipos, n, 0);
+
+	yaffs_set_super_dirty(dev);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_file_write: %d(%x) bytes written",
+		(unsigned)n, (unsigned)n);
+
+	if (n_written > 0) {
+		ipos += n_written;
+		*pos = ipos;
+		if (ipos > inode->i_size) {
+			inode->i_size = ipos;
+			inode->i_blocks = (ipos + 511) >> 9;
+
+			yaffs_trace(YAFFS_TRACE_OS,
+				"yaffs_file_write size updated to %lld bytes, %d blocks",
+				ipos, (int)(inode->i_blocks));
+		}
+
+	}
+	yaffs_gross_unlock(dev);
+	return (n_written == 0) && (n > 0) ? -ENOSPC : n_written;
+}
+
+
+#if (YAFFS_USE_WRITE_BEGIN_END > 0)
+static int yaffs_write_end(struct file *filp, struct address_space *mapping,
+			   loff_t pos, unsigned len, unsigned copied,
+			   struct page *pg, void *fsdadata)
+{
+	int ret = 0;
+	void *addr, *kva;
+	uint32_t offset_into_page = pos & (PAGE_CACHE_SIZE - 1);
+
+	kva = kmap(pg);
+	addr = kva + offset_into_page;
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_write_end addr %p pos %lld n_bytes %d",
+		addr, pos, copied);
+
+	ret = yaffs_file_write(filp, addr, copied, &pos);
+
+	if (ret != copied) {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_write_end not same size ret %d  copied %d",
+			ret, copied);
+		SetPageError(pg);
+	}
+
+	kunmap(pg);
+
+	yaffs_release_space(filp);
+	unlock_page(pg);
+	page_cache_release(pg);
+	return ret;
+}
+#else
+
+static int yaffs_commit_write(struct file *f, struct page *pg, unsigned offset,
+			      unsigned to)
+{
+	void *addr, *kva;
+
+	loff_t pos = (((loff_t) pg->index) << PAGE_CACHE_SHIFT) + offset;
+	int n_bytes = to - offset;
+	int n_written;
+
+	kva = kmap(pg);
+	addr = kva + offset;
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_commit_write addr %p pos %lld n_bytes %d",
+		addr, pos, n_bytes);
+
+	n_written = yaffs_file_write(f, addr, n_bytes, &pos);
+
+	if (n_written != n_bytes) {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_commit_write not same size n_written %d  n_bytes %d",
+			n_written, n_bytes);
+		SetPageError(pg);
+	}
+	kunmap(pg);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_commit_write returning %d",
+		n_written == n_bytes ? 0 : n_written);
+
+	return n_written == n_bytes ? 0 : n_written;
+}
+#endif
+
+static struct address_space_operations yaffs_file_address_operations = {
+	.readpage = yaffs_readpage,
+	.writepage = yaffs_writepage,
+#if (YAFFS_USE_WRITE_BEGIN_END > 0)
+	.write_begin = yaffs_write_begin,
+	.write_end = yaffs_write_end,
+#else
+	.prepare_write = yaffs_prepare_write,
+	.commit_write = yaffs_commit_write,
+#endif
+};
+
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 17))
+static int yaffs_file_flush(struct file *file, fl_owner_t id)
+#else
+static int yaffs_file_flush(struct file *file)
+#endif
+{
+	struct yaffs_obj *obj = yaffs_dentry_to_obj(Y_GET_DENTRY(file));
+
+	struct yaffs_dev *dev = obj->my_dev;
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_file_flush object %d (%s)",
+		obj->obj_id,
+		obj->dirty ? "dirty" : "clean");
+
+	yaffs_gross_lock(dev);
+
+	yaffs_flush_file(obj, 1, 0, 0);
+
+	yaffs_gross_unlock(dev);
+
+	return 0;
+}
+
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 39))
+static int yaffs_sync_object(struct file *file, loff_t start, loff_t end, int datasync)
+#elif (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 34))
+static int yaffs_sync_object(struct file *file, int datasync)
+#else
+static int yaffs_sync_object(struct file *file, struct dentry *dentry,
+			     int datasync)
+#endif
+{
+	struct yaffs_obj *obj;
+	struct yaffs_dev *dev;
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 34))
+	struct dentry *dentry = file->f_path.dentry;
+#endif
+
+	obj = yaffs_dentry_to_obj(dentry);
+
+	dev = obj->my_dev;
+
+	yaffs_trace(YAFFS_TRACE_OS | YAFFS_TRACE_SYNC,
+		"yaffs_sync_object");
+	yaffs_gross_lock(dev);
+	yaffs_flush_file(obj, 1, datasync, 0);
+	yaffs_gross_unlock(dev);
+	return 0;
+}
+
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 22))
+static const struct file_operations yaffs_file_operations = {
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 16, 0)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 8, 0)
+	.read = new_sync_read,
+	.write = new_sync_write,
+#endif
+	.read_iter = generic_file_read_iter,
+	.write_iter = generic_file_write_iter,
+#else
+	.read = do_sync_read,
+	.write = do_sync_write,
+	.aio_read = generic_file_aio_read,
+	.aio_write = generic_file_aio_write,
+#endif
+	.mmap = generic_file_mmap,
+	.flush = yaffs_file_flush,
+	.fsync = yaffs_sync_object,
+	.splice_read = generic_file_splice_read,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 16, 0)
+	.splice_write = iter_file_splice_write,
+#else
+	.splice_write = generic_file_splice_write,
+#endif
+	.llseek = generic_file_llseek,
+};
+
+#elif (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 18))
+
+static const struct file_operations yaffs_file_operations = {
+	.read = do_sync_read,
+	.write = do_sync_write,
+	.aio_read = generic_file_aio_read,
+	.aio_write = generic_file_aio_write,
+	.mmap = generic_file_mmap,
+	.flush = yaffs_file_flush,
+	.fsync = yaffs_sync_object,
+	.sendfile = generic_file_sendfile,
+};
+
+#else
+
+static const struct file_operations yaffs_file_operations = {
+	.read = generic_file_read,
+	.write = generic_file_write,
+	.mmap = generic_file_mmap,
+	.flush = yaffs_file_flush,
+	.fsync = yaffs_sync_object,
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+	.sendfile = generic_file_sendfile,
+#endif
+};
+#endif
+
+
+
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 25))
+static void zero_user_segment(struct page *page, unsigned start, unsigned end)
+{
+	void *kaddr = kmap_atomic(page, KM_USER0);
+	memset(kaddr + start, 0, end - start);
+	kunmap_atomic(kaddr, KM_USER0);
+	flush_dcache_page(page);
+}
+#endif
+
+
+static int yaffs_vfs_setsize(struct inode *inode, loff_t newsize)
+{
+#ifdef YAFFS_USE_TRUNCATE_SETSIZE
+	truncate_setsize(inode, newsize);
+	return 0;
+#else
+	truncate_inode_pages(&inode->i_data, newsize);
+	return 0;
+#endif
+
+}
+
+
+static int yaffs_vfs_setattr(struct inode *inode, struct iattr *attr)
+{
+#ifdef YAFFS_USE_SETATTR_COPY
+	setattr_copy(inode, attr);
+	return 0;
+#else
+	return inode_setattr(inode, attr);
+#endif
+
+}
+
+static int yaffs_setattr(struct dentry *dentry, struct iattr *attr)
+{
+	struct inode *inode = dentry->d_inode;
+	int error = 0;
+	struct yaffs_dev *dev;
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_setattr of object %d",
+		yaffs_inode_to_obj(inode)->obj_id);
+#if 0
+	/* Fail if a requested resize >= 2GB */
+	if (attr->ia_valid & ATTR_SIZE && (attr->ia_size >> 31))
+		error = -EINVAL;
+#endif
+
+	if (error == 0)
+		error = setattr_prepare(dentry, attr);
+	if (error == 0) {
+		int result;
+		if (!error) {
+			error = yaffs_vfs_setattr(inode, attr);
+			yaffs_trace(YAFFS_TRACE_OS, "inode_setattr called");
+			if (attr->ia_valid & ATTR_SIZE) {
+				yaffs_vfs_setsize(inode, attr->ia_size);
+				inode->i_blocks = (inode->i_size + 511) >> 9;
+			}
+		}
+		dev = yaffs_inode_to_obj(inode)->my_dev;
+		if (attr->ia_valid & ATTR_SIZE) {
+			yaffs_trace(YAFFS_TRACE_OS,
+				"resize to %d(%x)",
+				(int)(attr->ia_size),
+				(int)(attr->ia_size));
+		}
+		yaffs_gross_lock(dev);
+		result = yaffs_set_attribs(yaffs_inode_to_obj(inode), attr);
+		if (result == YAFFS_OK) {
+			error = 0;
+		} else {
+			error = -EPERM;
+		}
+		yaffs_gross_unlock(dev);
+
+	}
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_setattr done returning %d", error);
+
+	return error;
+}
+
+#ifdef YAFFS_USE_XATTR
+#if (YAFFS_NEW_XATTR > 0)
+static int yaffs_setxattr(struct dentry *dentry, struct inode *inode,
+		const char *name, const void *value, size_t size, int flags)
+{
+#else
+static int yaffs_setxattr(struct dentry *dentry, const char *name,
+		   const void *value, size_t size, int flags)
+{
+	struct inode *inode = dentry->d_inode;
+#endif
+	int error = 0;
+	struct yaffs_dev *dev;
+	struct yaffs_obj *obj = yaffs_inode_to_obj(inode);
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_setxattr of object %d", obj->obj_id);
+
+	if (error == 0) {
+		int result;
+		dev = obj->my_dev;
+		yaffs_gross_lock(dev);
+		result = yaffs_set_xattrib(obj, name, value, size, flags);
+		if (result == YAFFS_OK)
+			error = 0;
+		else if (result < 0)
+			error = result;
+		yaffs_gross_unlock(dev);
+
+	}
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_setxattr done returning %d", error);
+
+	return error;
+}
+
+#ifdef YAFFS_NEW_XATTR
+static ssize_t yaffs_getxattr(struct dentry * dentry, struct inode *inode,
+	const char *name, void *buff, size_t size)
+{
+#else
+static ssize_t yaffs_getxattr(struct dentry * dentry, const char *name,
+			void *buff, size_t size)
+{
+	struct inode *inode = dentry->d_inode;
+#endif
+	int error = 0;
+	struct yaffs_dev *dev;
+	struct yaffs_obj *obj = yaffs_inode_to_obj(inode);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_getxattr \"%s\" from object %d",
+		name, obj->obj_id);
+
+	if (error == 0) {
+		dev = obj->my_dev;
+		yaffs_gross_lock(dev);
+		error = yaffs_get_xattrib(obj, name, buff, size);
+		yaffs_gross_unlock(dev);
+
+	}
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_getxattr done returning %d", error);
+
+	return error;
+}
+
+static int yaffs_removexattr(struct dentry *dentry, const char *name)
+{
+	struct inode *inode = dentry->d_inode;
+	int error = 0;
+	struct yaffs_dev *dev;
+	struct yaffs_obj *obj = yaffs_inode_to_obj(inode);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_removexattr of object %d", obj->obj_id);
+
+	if (error == 0) {
+		int result;
+		dev = obj->my_dev;
+		yaffs_gross_lock(dev);
+		result = yaffs_remove_xattrib(obj, name);
+		if (result == YAFFS_OK)
+			error = 0;
+		else if (result < 0)
+			error = result;
+		yaffs_gross_unlock(dev);
+
+	}
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_removexattr done returning %d", error);
+
+	return error;
+}
+#endif
+
+static ssize_t yaffs_listxattr(struct dentry * dentry, char *buff, size_t size)
+{
+	struct inode *inode = dentry->d_inode;
+	int error = 0;
+	struct yaffs_dev *dev;
+	struct yaffs_obj *obj = yaffs_inode_to_obj(inode);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_listxattr of object %d", obj->obj_id);
+
+	if (error == 0) {
+		dev = obj->my_dev;
+		yaffs_gross_lock(dev);
+		error = yaffs_list_xattrib(obj, buff, size);
+		yaffs_gross_unlock(dev);
+
+	}
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_listxattr done returning %d", error);
+
+	return error;
+}
+
+
+static const struct inode_operations yaffs_file_inode_operations = {
+	.setattr = yaffs_setattr,
+#ifdef YAFFS_USE_XATTR
+	.setxattr = yaffs_setxattr,
+	.getxattr = yaffs_getxattr,
+	.removexattr = yaffs_removexattr,
+#endif
+	.listxattr = yaffs_listxattr,
+};
+
+
+static int yaffs_readlink(struct dentry *dentry, char __user * buffer,
+			  int buflen)
+{
+	unsigned char *alias;
+	int ret;
+
+	struct yaffs_dev *dev = yaffs_dentry_to_obj(dentry)->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	alias = yaffs_get_symlink_alias(yaffs_dentry_to_obj(dentry));
+
+	yaffs_gross_unlock(dev);
+
+	if (!alias)
+		return -ENOMEM;
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3, 15, 0)
+	ret = vfs_readlink(dentry, buffer, buflen, alias);
+#else
+	ret = readlink_copy(buffer, buflen, alias);
+#endif
+	kfree(alias);
+	return ret;
+}
+
+#if (YAFFS_NEW_GET_LINK == 0)
+#if (YAFFS_NEW_FOLLOW_LINK == 1)
+static void *yaffs_follow_link(struct dentry *dentry, struct nameidata *nd)
+{
+	void *ret;
+#else
+static int yaffs_follow_link(struct dentry *dentry, struct nameidata *nd)
+{
+	int ret
+#endif
+	unsigned char *alias;
+	int ret_int = 0;
+	struct yaffs_dev *dev = yaffs_dentry_to_obj(dentry)->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	alias = yaffs_get_symlink_alias(yaffs_dentry_to_obj(dentry));
+	yaffs_gross_unlock(dev);
+
+	if (!alias) {
+		ret_int = -ENOMEM;
+		goto out;
+	}
+#if (YAFFS_NEW_FOLLOW_LINK == 1)
+	nd_set_link(nd, alias);
+	ret = alias;
+out:
+	if (ret_int)
+		ret = ERR_PTR(ret_int);
+	return ret;
+#else
+	ret = vfs_follow_link(nd, alias);
+	kfree(alias);
+out:
+	if (ret_int)
+		ret = ret_int;
+	return ret;
+#endif
+}
+#else
+static const char *yaffs_get_link(struct dentry *dentry, struct inode *inode, struct delayed_call *done)
+{
+	unsigned char *alias;
+	struct yaffs_dev *dev;
+
+	if (!dentry)
+		return ERR_PTR(-ECHILD);
+
+	dev = yaffs_dentry_to_obj(dentry)->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	alias = yaffs_get_symlink_alias(yaffs_dentry_to_obj(dentry));
+	yaffs_gross_unlock(dev);
+
+	if (!alias)
+		return ERR_PTR(-ENOMEM);
+	set_delayed_call(done, kfree_link, alias);
+	return alias;
+}
+#endif
+
+#ifdef YAFFS_HAS_PUT_INODE
+
+/* For now put inode is just for debugging
+ * Put inode is called when the inode **structure** is put.
+ */
+static void yaffs_put_inode(struct inode *inode)
+{
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_put_inode: ino %d, count %d"),
+		(int)inode->i_ino, atomic_read(&inode->i_count);
+
+}
+#endif
+
+#if (YAFFS_NEW_FOLLOW_LINK == 1)
+void yaffs_put_link(struct dentry *dentry, struct nameidata *nd, void *alias)
+{
+	kfree(alias);
+}
+#endif
+
+static const struct inode_operations yaffs_symlink_inode_operations = {
+	.readlink = yaffs_readlink,
+#if (YAFFS_NEW_GET_LINK == 1)
+	.get_link = yaffs_get_link,
+#else
+	.follow_link = yaffs_follow_link,
+#endif
+#if (YAFFS_NEW_FOLLOW_LINK == 1)
+	.put_link = yaffs_put_link,
+#endif
+	.setattr = yaffs_setattr,
+#ifdef YAFFS_USE_XATTR
+	.setxattr = yaffs_setxattr,
+	.getxattr = yaffs_getxattr,
+	.removexattr = yaffs_removexattr,
+#endif
+	.listxattr = yaffs_listxattr,
+};
+
+#ifdef YAFFS_USE_OWN_IGET
+
+static struct inode *yaffs_iget(struct super_block *sb, unsigned long ino)
+{
+	struct inode *inode;
+	struct yaffs_obj *obj;
+	struct yaffs_dev *dev = yaffs_super_to_dev(sb);
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_iget for %lu", ino);
+
+	inode = iget_locked(sb, ino);
+	if (!inode)
+		return ERR_PTR(-ENOMEM);
+	if (!(inode->i_state & I_NEW))
+		return inode;
+
+	/* NB This is called as a side effect of other functions, but
+	 * we had to release the lock to prevent deadlocks, so
+	 * need to lock again.
+	 */
+
+	yaffs_gross_lock(dev);
+
+	obj = yaffs_find_by_number(dev, inode->i_ino);
+
+	yaffs_fill_inode_from_obj(inode, obj);
+
+	yaffs_gross_unlock(dev);
+
+	unlock_new_inode(inode);
+	return inode;
+}
+
+#else
+
+static void yaffs_read_inode(struct inode *inode)
+{
+	/* NB This is called as a side effect of other functions, but
+	 * we had to release the lock to prevent deadlocks, so
+	 * need to lock again.
+	 */
+
+	struct yaffs_obj *obj;
+	struct yaffs_dev *dev = yaffs_super_to_dev(inode->i_sb);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_read_inode for %d", (int)inode->i_ino);
+
+	if (current != yaffs_dev_to_lc(dev)->readdir_process)
+		yaffs_gross_lock(dev);
+
+	obj = yaffs_find_by_number(dev, inode->i_ino);
+
+	yaffs_fill_inode_from_obj(inode, obj);
+
+	if (current != yaffs_dev_to_lc(dev)->readdir_process)
+		yaffs_gross_unlock(dev);
+}
+
+#endif
+
+
+
+struct inode *yaffs_get_inode(struct super_block *sb, int mode, int dev,
+			      struct yaffs_obj *obj)
+{
+	struct inode *inode;
+
+	if (!sb) {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_get_inode for NULL super_block!!");
+		return NULL;
+
+	}
+
+	if (!obj) {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_get_inode for NULL object!!");
+		return NULL;
+
+	}
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_get_inode for object %d", obj->obj_id);
+
+	inode = Y_IGET(sb, obj->obj_id);
+	if (IS_ERR(inode))
+		return NULL;
+
+	/* NB Side effect: iget calls back to yaffs_read_inode(). */
+	/* iget also increments the inode's i_count */
+	/* NB You can't be holding gross_lock or deadlock will happen! */
+
+	return inode;
+}
+
+
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 29)
+#define YCRED(x) x
+#else
+#define YCRED(x) (x->cred)
+#endif
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3,14,0)
+#define YPROC_uid(p) (YCRED(p)->fsuid)
+#define YPROC_gid(p) (YCRED(p)->fsgid)
+#define EXTRACT_gid(x) x
+#define EXTRACT_uid(x) x
+#define MAKE_gid(x) x
+#define MAKE_uid(x) x
+#else
+#define YPROC_uid(p) from_kuid(&init_user_ns, YCRED(p)->fsuid)
+#define YPROC_gid(p) from_kgid(&init_user_ns, YCRED(p)->fsgid)
+#define EXTRACT_gid(x) from_kgid(&init_user_ns, x)
+#define EXTRACT_uid(x) from_kuid(&init_user_ns, x)
+#define MAKE_gid(x) make_kgid(&init_user_ns, x)
+#define MAKE_uid(x) make_kuid(&init_user_ns, x)
+#endif
+
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 4, 0))
+static int yaffs_mknod(struct inode *dir, struct dentry *dentry, umode_t mode,
+		       dev_t rdev)
+#elif (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+static int yaffs_mknod(struct inode *dir, struct dentry *dentry, int mode,
+		       dev_t rdev)
+#else
+static int yaffs_mknod(struct inode *dir, struct dentry *dentry, int mode,
+		       int rdev)
+#endif
+{
+	struct inode *inode;
+
+	struct yaffs_obj *obj = NULL;
+	struct yaffs_dev *dev;
+
+	struct yaffs_obj *parent = yaffs_inode_to_obj(dir);
+
+	int error = -ENOSPC;
+	uid_t uid = YPROC_uid(current);
+	gid_t gid =
+	    (dir->i_mode & S_ISGID) ? EXTRACT_gid(dir->i_gid) : YPROC_gid(current);
+
+	if ((dir->i_mode & S_ISGID) && S_ISDIR(mode))
+		mode |= S_ISGID;
+
+	if (parent) {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_mknod: parent object %d type %d",
+			parent->obj_id, parent->variant_type);
+	} else {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_mknod: could not get parent object");
+		return -EPERM;
+	}
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_mknod: making oject for %s, mode %x dev %x",
+		dentry->d_name.name, mode, rdev);
+
+	dev = parent->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	switch (mode & S_IFMT) {
+	default:
+		/* Special (socket, fifo, device...) */
+		yaffs_trace(YAFFS_TRACE_OS, "yaffs_mknod: making special");
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+		obj =
+		    yaffs_create_special(parent, dentry->d_name.name, mode, uid,
+					 gid, old_encode_dev(rdev));
+#else
+		obj =
+		    yaffs_create_special(parent, dentry->d_name.name, mode, uid,
+					 gid, rdev);
+#endif
+		break;
+	case S_IFREG:		/* file          */
+		yaffs_trace(YAFFS_TRACE_OS, "yaffs_mknod: making file");
+		obj = yaffs_create_file(parent, dentry->d_name.name, mode, uid,
+					gid);
+		break;
+	case S_IFDIR:		/* directory */
+		yaffs_trace(YAFFS_TRACE_OS, "yaffs_mknod: making directory");
+		obj = yaffs_create_dir(parent, dentry->d_name.name, mode,
+				       uid, gid);
+		break;
+	case S_IFLNK:		/* symlink */
+		yaffs_trace(YAFFS_TRACE_OS, "yaffs_mknod: making symlink");
+		obj = NULL;	/* Do we ever get here? */
+		break;
+	}
+
+	/* Can not call yaffs_get_inode() with gross lock held */
+	yaffs_gross_unlock(dev);
+
+	if (obj) {
+		inode = yaffs_get_inode(dir->i_sb, mode, rdev, obj);
+		d_instantiate(dentry, inode);
+		update_dir_time(dir);
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_mknod created object %d count = %d",
+			obj->obj_id, atomic_read(&inode->i_count));
+		error = 0;
+		yaffs_fill_inode_from_obj(dir, parent);
+	} else {
+		yaffs_trace(YAFFS_TRACE_OS, "yaffs_mknod failed making object");
+		error = -ENOMEM;
+	}
+
+	return error;
+}
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 4, 0))
+static int yaffs_mkdir(struct inode *dir, struct dentry *dentry, umode_t mode)
+#else
+static int yaffs_mkdir(struct inode *dir, struct dentry *dentry, int mode)
+#endif
+{
+	int ret_val;
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_mkdir");
+	ret_val = yaffs_mknod(dir, dentry, mode | S_IFDIR, 0);
+	return ret_val;
+}
+
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 6, 0))
+static int yaffs_create(struct inode *dir, struct dentry *dentry, umode_t mode,
+			bool dummy)
+#elif (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 4, 0))
+static int yaffs_create(struct inode *dir, struct dentry *dentry, umode_t mode,
+			struct nameidata *n)
+#elif (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+static int yaffs_create(struct inode *dir, struct dentry *dentry, int mode,
+			struct nameidata *n)
+#else
+static int yaffs_create(struct inode *dir, struct dentry *dentry, int mode)
+#endif
+{
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_create");
+	return yaffs_mknod(dir, dentry, mode | S_IFREG, 0);
+}
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 6, 0))
+static struct dentry *yaffs_lookup(struct inode *dir, struct dentry *dentry,
+				   unsigned int dummy)
+#elif (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+static struct dentry *yaffs_lookup(struct inode *dir, struct dentry *dentry,
+				   struct nameidata *n)
+#else
+static struct dentry *yaffs_lookup(struct inode *dir, struct dentry *dentry)
+#endif
+{
+	struct yaffs_obj *obj;
+	struct inode *inode = NULL;	/* NCB 2.5/2.6 needs NULL here */
+
+	struct yaffs_dev *dev = yaffs_inode_to_obj(dir)->my_dev;
+
+	if (current != yaffs_dev_to_lc(dev)->readdir_process)
+		yaffs_gross_lock(dev);
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_lookup for %d:%s",
+		yaffs_inode_to_obj(dir)->obj_id, dentry->d_name.name);
+
+	obj = yaffs_find_by_name(yaffs_inode_to_obj(dir), dentry->d_name.name);
+
+	obj = yaffs_get_equivalent_obj(obj);	/* in case it was a hardlink */
+
+	/* Can't hold gross lock when calling yaffs_get_inode() */
+	if (current != yaffs_dev_to_lc(dev)->readdir_process)
+		yaffs_gross_unlock(dev);
+
+	if (obj) {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_lookup found %d", obj->obj_id);
+
+		inode = yaffs_get_inode(dir->i_sb, obj->yst_mode, 0, obj);
+	} else {
+		yaffs_trace(YAFFS_TRACE_OS, "yaffs_lookup not found");
+
+	}
+
+/* added NCB for 2.5/6 compatability - forces add even if inode is
+ * NULL which creates dentry hash */
+	d_add(dentry, inode);
+
+	return NULL;
+}
+
+/*
+ * Create a link...
+ */
+static int yaffs_link(struct dentry *old_dentry, struct inode *dir,
+		      struct dentry *dentry)
+{
+	struct inode *inode = old_dentry->d_inode;
+	struct yaffs_obj *obj = NULL;
+	struct yaffs_obj *link = NULL;
+	struct yaffs_dev *dev;
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_link");
+
+	obj = yaffs_inode_to_obj(inode);
+	dev = obj->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	if (!S_ISDIR(inode->i_mode))	/* Don't link directories */
+		link =
+		    yaffs_link_obj(yaffs_inode_to_obj(dir), dentry->d_name.name,
+				   obj);
+
+	if (link) {
+		set_nlink(old_dentry->d_inode, yaffs_get_obj_link_count(obj));
+		d_instantiate(dentry, old_dentry->d_inode);
+		atomic_inc(&old_dentry->d_inode->i_count);
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_link link count %d i_count %d",
+			old_dentry->d_inode->i_nlink,
+			atomic_read(&old_dentry->d_inode->i_count));
+	}
+
+	yaffs_gross_unlock(dev);
+
+	if (link) {
+		update_dir_time(dir);
+		return 0;
+	}
+
+	return -EPERM;
+}
+
+static int yaffs_symlink(struct inode *dir, struct dentry *dentry,
+			 const char *symname)
+{
+	struct yaffs_obj *obj;
+	struct yaffs_dev *dev;
+	uid_t uid = YPROC_uid(current);
+	gid_t gid =
+	    (dir->i_mode & S_ISGID) ? EXTRACT_gid(dir->i_gid) : YPROC_gid(current);
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_symlink");
+
+	if (strnlen(dentry->d_name.name, YAFFS_MAX_NAME_LENGTH + 1) >
+				YAFFS_MAX_NAME_LENGTH)
+		return -ENAMETOOLONG;
+
+	if (strnlen(symname, YAFFS_MAX_ALIAS_LENGTH + 1) >
+				YAFFS_MAX_ALIAS_LENGTH)
+		return -ENAMETOOLONG;
+
+	dev = yaffs_inode_to_obj(dir)->my_dev;
+	yaffs_gross_lock(dev);
+	obj = yaffs_create_symlink(yaffs_inode_to_obj(dir), dentry->d_name.name,
+				   S_IFLNK | S_IRWXUGO, uid, gid, symname);
+	yaffs_gross_unlock(dev);
+
+	if (obj) {
+		struct inode *inode;
+
+		inode = yaffs_get_inode(dir->i_sb, obj->yst_mode, 0, obj);
+		d_instantiate(dentry, inode);
+		update_dir_time(dir);
+		yaffs_trace(YAFFS_TRACE_OS, "symlink created OK");
+		return 0;
+	} else {
+		yaffs_trace(YAFFS_TRACE_OS, "symlink not created");
+	}
+
+	return -ENOMEM;
+}
+
+/*
+ * The VFS layer already does all the dentry stuff for rename.
+ *
+ * NB: POSIX says you can rename an object over an old object of the same name
+ */
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(4, 9, 0))
+static int yaffs_rename(struct inode *old_dir, struct dentry *old_dentry,
+			struct inode *new_dir, struct dentry *new_dentry, unsigned int unused)
+#else
+static int yaffs_rename(struct inode *old_dir, struct dentry *old_dentry,
+			struct inode *new_dir, struct dentry *new_dentry)
+#endif
+{
+	struct yaffs_dev *dev;
+	int ret_val = YAFFS_FAIL;
+	struct yaffs_obj *target;
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_rename");
+	dev = yaffs_inode_to_obj(old_dir)->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	/* Check if the target is an existing directory that is not empty. */
+	target = yaffs_find_by_name(yaffs_inode_to_obj(new_dir),
+				    new_dentry->d_name.name);
+
+	if (target && target->variant_type == YAFFS_OBJECT_TYPE_DIRECTORY &&
+	    !list_empty(&target->variant.dir_variant.children)) {
+
+		yaffs_trace(YAFFS_TRACE_OS, "target is non-empty dir");
+
+		ret_val = YAFFS_FAIL;
+	} else {
+		/* Now does unlinking internally using shadowing mechanism */
+		yaffs_trace(YAFFS_TRACE_OS, "calling yaffs_rename_obj");
+
+		ret_val = yaffs_rename_obj(yaffs_inode_to_obj(old_dir),
+					   old_dentry->d_name.name,
+					   yaffs_inode_to_obj(new_dir),
+					   new_dentry->d_name.name);
+	}
+	yaffs_gross_unlock(dev);
+
+	if (ret_val == YAFFS_OK) {
+		if (target)
+			inode_dec_link_count(new_dentry->d_inode);
+
+		update_dir_time(old_dir);
+		if (old_dir != new_dir)
+			update_dir_time(new_dir);
+		return 0;
+	} else {
+		return -ENOTEMPTY;
+	}
+}
+
+
+
+
+static int yaffs_unlink(struct inode *dir, struct dentry *dentry)
+{
+	int ret_val;
+
+	struct yaffs_dev *dev;
+	struct yaffs_obj *obj;
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_unlink %d:%s",
+		(int)(dir->i_ino), dentry->d_name.name);
+	obj = yaffs_inode_to_obj(dir);
+	dev = obj->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	ret_val = yaffs_unlinker(obj, dentry->d_name.name);
+
+	if (ret_val == YAFFS_OK) {
+		inode_dec_link_count(dentry->d_inode);
+		dir->i_version++;
+		yaffs_gross_unlock(dev);
+		update_dir_time(dir);
+		return 0;
+	}
+	yaffs_gross_unlock(dev);
+	return -ENOTEMPTY;
+}
+
+
+
+static const struct inode_operations yaffs_dir_inode_operations = {
+	.create = yaffs_create,
+	.lookup = yaffs_lookup,
+	.link = yaffs_link,
+	.unlink = yaffs_unlink,
+	.symlink = yaffs_symlink,
+	.mkdir = yaffs_mkdir,
+	.rmdir = yaffs_unlink,
+	.mknod = yaffs_mknod,
+	.rename = yaffs_rename,
+	.setattr = yaffs_setattr,
+	.listxattr = yaffs_listxattr,
+#ifdef YAFFS_USE_XATTR
+	.setxattr = yaffs_setxattr,
+	.getxattr = yaffs_getxattr,
+	.removexattr = yaffs_removexattr,
+#endif
+};
+
+/*-----------------------------------------------------------------*/
+/* Directory search context allows us to unlock access to yaffs during
+ * filldir without causing problems with the directory being modified.
+ * This is similar to the tried and tested mechanism used in yaffs direct.
+ *
+ * A search context iterates along a doubly linked list of siblings in the
+ * directory. If the iterating object is deleted then this would corrupt
+ * the list iteration, likely causing a crash. The search context avoids
+ * this by using the remove_obj_fn to move the search context to the
+ * next object before the object is deleted.
+ *
+ * Many readdirs (and thus seach conexts) may be alive simulateously so
+ * each struct yaffs_dev has a list of these.
+ *
+ * A seach context lives for the duration of a readdir.
+ *
+ * All these functions must be called while yaffs is locked.
+ */
+
+struct yaffs_search_context {
+	struct yaffs_dev *dev;
+	struct yaffs_obj *dir_obj;
+	struct yaffs_obj *next_return;
+	struct list_head others;
+};
+
+/*
+ * yaffs_new_search() creates a new search context, initialises it and
+ * adds it to the device's search context list.
+ *
+ * Called at start of readdir.
+ */
+static struct yaffs_search_context *yaffs_new_search(struct yaffs_obj *dir)
+{
+	struct yaffs_dev *dev = dir->my_dev;
+	struct yaffs_search_context *sc =
+	    kmalloc(sizeof(struct yaffs_search_context), GFP_NOFS);
+	if (sc) {
+		sc->dir_obj = dir;
+		sc->dev = dev;
+		if (list_empty(&sc->dir_obj->variant.dir_variant.children))
+			sc->next_return = NULL;
+		else
+			sc->next_return =
+			    list_entry(dir->variant.dir_variant.children.next,
+				       struct yaffs_obj, siblings);
+		INIT_LIST_HEAD(&sc->others);
+		list_add(&sc->others, &(yaffs_dev_to_lc(dev)->search_contexts));
+	}
+	return sc;
+}
+
+/*
+ * yaffs_search_end() disposes of a search context and cleans up.
+ */
+static void yaffs_search_end(struct yaffs_search_context *sc)
+{
+	if (sc) {
+		list_del(&sc->others);
+		kfree(sc);
+	}
+}
+
+/*
+ * yaffs_search_advance() moves a search context to the next object.
+ * Called when the search iterates or when an object removal causes
+ * the search context to be moved to the next object.
+ */
+static void yaffs_search_advance(struct yaffs_search_context *sc)
+{
+	if (!sc)
+		return;
+
+	if (sc->next_return == NULL ||
+	    list_empty(&sc->dir_obj->variant.dir_variant.children))
+		sc->next_return = NULL;
+	else {
+		struct list_head *next = sc->next_return->siblings.next;
+
+		if (next == &sc->dir_obj->variant.dir_variant.children)
+			sc->next_return = NULL;	/* end of list */
+		else
+			sc->next_return =
+			    list_entry(next, struct yaffs_obj, siblings);
+	}
+}
+
+/*
+ * yaffs_remove_obj_callback() is called when an object is unlinked.
+ * We check open search contexts and advance any which are currently
+ * on the object being iterated.
+ */
+static void yaffs_remove_obj_callback(struct yaffs_obj *obj)
+{
+
+	struct list_head *i;
+	struct yaffs_search_context *sc;
+	struct list_head *search_contexts =
+	    &(yaffs_dev_to_lc(obj->my_dev)->search_contexts);
+
+	/* Iterate through the directory search contexts.
+	 * If any are currently on the object being removed, then advance
+	 * the search context to the next object to prevent a hanging pointer.
+	 */
+	list_for_each(i, search_contexts) {
+		sc = list_entry(i, struct yaffs_search_context, others);
+		if (sc->next_return == obj)
+			yaffs_search_advance(sc);
+	}
+
+}
+
+
+/*-----------------------------------------------------------------*/
+
+#ifdef YAFFS_USE_DIR_ITERATE
+static int yaffs_iterate(struct file *f, struct dir_context *dc)
+{
+	struct yaffs_obj *obj;
+	struct yaffs_dev *dev;
+	struct yaffs_search_context *sc;
+	unsigned long curoffs;
+	struct yaffs_obj *l;
+	int ret_val = 0;
+
+	char name[YAFFS_MAX_NAME_LENGTH + 1];
+
+	obj = yaffs_dentry_to_obj(Y_GET_DENTRY(f));
+	dev = obj->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	yaffs_dev_to_lc(dev)->readdir_process = current;
+
+	sc = yaffs_new_search(obj);
+	if (!sc) {
+		ret_val = -ENOMEM;
+		goto out;
+	}
+
+	if (!dir_emit_dots(f, dc)) {
+		yaffs_gross_unlock(dev);
+		return 0;
+	}
+
+	curoffs = 1;
+
+	while (sc->next_return) {
+		curoffs++;
+		l = sc->next_return;
+		if (curoffs >= dc->pos) {
+			int this_inode = yaffs_get_obj_inode(l);
+			int this_type = yaffs_get_obj_type(l);
+
+			yaffs_get_obj_name(l, name, YAFFS_MAX_NAME_LENGTH + 1);
+			yaffs_trace(YAFFS_TRACE_OS,
+				"yaffs_readdir: %s inode %d",
+				name, yaffs_get_obj_inode(l));
+
+			yaffs_gross_unlock(dev);
+
+			if (!dir_emit(dc,
+				      name,
+				      strlen(name),
+				      this_inode,
+				      this_type)) {
+				yaffs_gross_lock(dev);
+				goto out;
+			}
+
+			yaffs_gross_lock(dev);
+
+			dc->pos++;
+			f->f_pos++;
+		}
+		yaffs_search_advance(sc);
+	}
+
+out:
+	yaffs_search_end(sc);
+	yaffs_dev_to_lc(dev)->readdir_process = NULL;
+	yaffs_gross_unlock(dev);
+
+	return ret_val;
+}
+
+#else
+
+static int yaffs_readdir(struct file *f, void *dirent, filldir_t filldir)
+{
+	struct yaffs_obj *obj;
+	struct yaffs_dev *dev;
+	struct yaffs_search_context *sc;
+	struct inode *inode = Y_GET_DENTRY(f)->d_inode;
+	unsigned long offset, curoffs;
+	struct yaffs_obj *l;
+	int ret_val = 0;
+
+	char name[YAFFS_MAX_NAME_LENGTH + 1];
+
+	obj = yaffs_dentry_to_obj(Y_GET_DENTRY(f));
+	dev = obj->my_dev;
+
+	yaffs_gross_lock(dev);
+
+	yaffs_dev_to_lc(dev)->readdir_process = current;
+
+	offset = f->f_pos;
+
+	sc = yaffs_new_search(obj);
+	if (!sc) {
+		ret_val = -ENOMEM;
+		goto out;
+	}
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_readdir: starting at %d", (int)offset);
+
+	if (offset == 0) {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_readdir: entry . ino %d",
+			(int)inode->i_ino);
+		yaffs_gross_unlock(dev);
+		if (filldir(dirent, ".", 1, offset, inode->i_ino, DT_DIR) < 0) {
+			yaffs_gross_lock(dev);
+			goto out;
+		}
+		yaffs_gross_lock(dev);
+		offset++;
+		f->f_pos++;
+	}
+	if (offset == 1) {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_readdir: entry .. ino %d",
+			(int)f->f_dentry->d_parent->d_inode->i_ino);
+		yaffs_gross_unlock(dev);
+		if (filldir(dirent, "..", 2, offset,
+			    f->f_dentry->d_parent->d_inode->i_ino,
+			    DT_DIR) < 0) {
+			yaffs_gross_lock(dev);
+			goto out;
+		}
+		yaffs_gross_lock(dev);
+		offset++;
+		f->f_pos++;
+	}
+
+	curoffs = 1;
+
+	/* If the directory has changed since the open or last call to
+	   readdir, rewind to after the 2 canned entries. */
+	if (f->f_version != inode->i_version) {
+		offset = 2;
+		f->f_pos = offset;
+		f->f_version = inode->i_version;
+	}
+
+	while (sc->next_return) {
+		curoffs++;
+		l = sc->next_return;
+		if (curoffs >= offset) {
+			int this_inode = yaffs_get_obj_inode(l);
+			int this_type = yaffs_get_obj_type(l);
+
+			yaffs_get_obj_name(l, name, YAFFS_MAX_NAME_LENGTH + 1);
+			yaffs_trace(YAFFS_TRACE_OS,
+				"yaffs_readdir: %s inode %d",
+				name, yaffs_get_obj_inode(l));
+
+			yaffs_gross_unlock(dev);
+
+			if (filldir(dirent,
+				    name,
+				    strlen(name),
+				    offset, this_inode, this_type) < 0) {
+				yaffs_gross_lock(dev);
+				goto out;
+			}
+
+			yaffs_gross_lock(dev);
+
+			offset++;
+			f->f_pos++;
+		}
+		yaffs_search_advance(sc);
+	}
+
+out:
+	yaffs_search_end(sc);
+	yaffs_dev_to_lc(dev)->readdir_process = NULL;
+	yaffs_gross_unlock(dev);
+
+	return ret_val;
+}
+
+#endif
+
+static const struct file_operations yaffs_dir_operations = {
+	.read = generic_read_dir,
+#ifdef YAFFS_USE_DIR_ITERATE
+	.iterate = yaffs_iterate,
+#else
+	.readdir = yaffs_readdir,
+#endif
+	.fsync = yaffs_sync_object,
+	.llseek = generic_file_llseek,
+};
+
+static void yaffs_fill_inode_from_obj(struct inode *inode,
+				      struct yaffs_obj *obj)
+{
+	if (inode && obj) {
+
+		/* Check mode against the variant type and attempt to repair if broken. */
+		u32 mode = obj->yst_mode;
+		switch (obj->variant_type) {
+		case YAFFS_OBJECT_TYPE_FILE:
+			if (!S_ISREG(mode)) {
+				obj->yst_mode &= ~S_IFMT;
+				obj->yst_mode |= S_IFREG;
+			}
+
+			break;
+		case YAFFS_OBJECT_TYPE_SYMLINK:
+			if (!S_ISLNK(mode)) {
+				obj->yst_mode &= ~S_IFMT;
+				obj->yst_mode |= S_IFLNK;
+			}
+
+			break;
+		case YAFFS_OBJECT_TYPE_DIRECTORY:
+			if (!S_ISDIR(mode)) {
+				obj->yst_mode &= ~S_IFMT;
+				obj->yst_mode |= S_IFDIR;
+			}
+
+			break;
+		case YAFFS_OBJECT_TYPE_UNKNOWN:
+		case YAFFS_OBJECT_TYPE_HARDLINK:
+		case YAFFS_OBJECT_TYPE_SPECIAL:
+		default:
+			/* TODO? */
+			break;
+		}
+
+		inode->i_flags |= S_NOATIME;
+
+		inode->i_ino = obj->obj_id;
+		inode->i_mode = obj->yst_mode;
+		inode->i_uid = MAKE_uid(obj->yst_uid);
+		inode->i_gid = MAKE_gid(obj->yst_gid);
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 19))
+		inode->i_blksize = inode->i_sb->s_blocksize;
+#endif
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+
+		inode->i_rdev = old_decode_dev(obj->yst_rdev);
+		inode->i_atime.tv_sec = (time_t) (obj->yst_atime);
+		inode->i_atime.tv_nsec = 0;
+		inode->i_mtime.tv_sec = (time_t) obj->yst_mtime;
+		inode->i_mtime.tv_nsec = 0;
+		inode->i_ctime.tv_sec = (time_t) obj->yst_ctime;
+		inode->i_ctime.tv_nsec = 0;
+#else
+		inode->i_rdev = obj->yst_rdev;
+		inode->i_atime = obj->yst_atime;
+		inode->i_mtime = obj->yst_mtime;
+		inode->i_ctime = obj->yst_ctime;
+#endif
+		inode->i_size = yaffs_get_obj_length(obj);
+		inode->i_blocks = (inode->i_size + 511) >> 9;
+
+		set_nlink(inode, yaffs_get_obj_link_count(obj));
+
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_fill_inode mode %x uid %d gid %d size %lld count %d",
+			inode->i_mode, obj->yst_uid, obj->yst_gid,
+			inode->i_size, atomic_read(&inode->i_count));
+
+		switch (obj->yst_mode & S_IFMT) {
+		default:	/* fifo, device or socket */
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+			init_special_inode(inode, obj->yst_mode,
+					   old_decode_dev(obj->yst_rdev));
+#else
+			init_special_inode(inode, obj->yst_mode,
+					   (dev_t) (obj->yst_rdev));
+#endif
+			break;
+		case S_IFREG:	/* file */
+			inode->i_op = &yaffs_file_inode_operations;
+			inode->i_fop = &yaffs_file_operations;
+			inode->i_mapping->a_ops =
+			    &yaffs_file_address_operations;
+			break;
+		case S_IFDIR:	/* directory */
+			inode->i_op = &yaffs_dir_inode_operations;
+			inode->i_fop = &yaffs_dir_operations;
+			break;
+		case S_IFLNK:	/* symlink */
+			inode->i_op = &yaffs_symlink_inode_operations;
+			break;
+		}
+
+		yaffs_inode_to_obj_lv(inode) = obj;
+
+		obj->my_inode = inode;
+
+	} else {
+		yaffs_trace(YAFFS_TRACE_OS,
+			"yaffs_fill_inode invalid parameters");
+	}
+
+}
+
+
+
+/*
+ * yaffs background thread functions .
+ * yaffs_bg_thread_fn() the thread function
+ * yaffs_bg_start() launches the background thread.
+ * yaffs_bg_stop() cleans up the background thread.
+ *
+ * NB:
+ * The thread should only run after the yaffs is initialised
+ * The thread should be stopped before yaffs is unmounted.
+ * The thread should not do any writing while the fs is in read only.
+ */
+
+static unsigned yaffs_bg_gc_urgency(struct yaffs_dev *dev)
+{
+	unsigned erased_chunks =
+	    dev->n_erased_blocks * dev->param.chunks_per_block;
+	struct yaffs_linux_context *context = yaffs_dev_to_lc(dev);
+	unsigned scattered = 0;	/* Free chunks not in an erased block */
+
+	if (erased_chunks < dev->n_free_chunks)
+		scattered = (dev->n_free_chunks - erased_chunks);
+
+	if (!context->bg_running)
+		return 0;
+	else if (scattered < (dev->param.chunks_per_block * 2))
+		return 0;
+	else if (erased_chunks > dev->n_free_chunks / 2)
+		return 0;
+	else if (erased_chunks > dev->n_free_chunks / 4)
+		return 1;
+	else
+		return 2;
+}
+
+#ifdef YAFFS_COMPILE_BACKGROUND
+
+void yaffs_background_waker(unsigned long data)
+{
+	wake_up_process((struct task_struct *)data);
+}
+
+static int yaffs_bg_thread_fn(void *data)
+{
+	struct yaffs_dev *dev = (struct yaffs_dev *)data;
+	struct yaffs_linux_context *context = yaffs_dev_to_lc(dev);
+	unsigned long now = jiffies;
+	unsigned long next_dir_update = now;
+	unsigned long next_gc = now;
+	unsigned long expires;
+	unsigned int urgency;
+
+	int gc_result;
+	struct timer_list timer;
+
+	yaffs_trace(YAFFS_TRACE_BACKGROUND,
+		"yaffs_background starting for dev %p", (void *)dev);
+
+#ifdef YAFFS_COMPILE_FREEZER
+	set_freezable();
+#endif
+	while (context->bg_running) {
+		yaffs_trace(YAFFS_TRACE_BACKGROUND, "yaffs_background");
+
+		if (kthread_should_stop())
+			break;
+
+#ifdef YAFFS_COMPILE_FREEZER
+		if (try_to_freeze())
+			continue;
+#endif
+		yaffs_gross_lock(dev);
+
+		now = jiffies;
+
+		if (time_after(now, next_dir_update) && yaffs_bg_enable) {
+			yaffs_update_dirty_dirs(dev);
+			next_dir_update = now + HZ;
+		}
+
+		if (time_after(now, next_gc) && yaffs_bg_enable) {
+			if (!dev->is_checkpointed) {
+				urgency = yaffs_bg_gc_urgency(dev);
+				gc_result = yaffs_bg_gc(dev, urgency);
+				if (urgency > 1)
+					next_gc = now + HZ / 20 + 1;
+				else if (urgency > 0)
+					next_gc = now + HZ / 10 + 1;
+				else
+					next_gc = now + HZ * 2;
+			} else	{
+			        /*
+				 * gc not running so set to next_dir_update
+				 * to cut down on wake ups
+				 */
+				next_gc = next_dir_update;
+                        }
+		}
+		yaffs_gross_unlock(dev);
+#if 1
+		expires = next_dir_update;
+		if (time_before(next_gc, expires))
+			expires = next_gc;
+		if (time_before(expires, now))
+			expires = now + HZ;
+
+		Y_INIT_TIMER(&timer);
+		timer.expires = expires + 1;
+		timer.data = (unsigned long)current;
+		timer.function = yaffs_background_waker;
+
+		set_current_state(TASK_INTERRUPTIBLE);
+		add_timer(&timer);
+		schedule();
+		del_timer_sync(&timer);
+#else
+		msleep(10);
+#endif
+	}
+
+	return 0;
+}
+
+static int yaffs_bg_start(struct yaffs_dev *dev)
+{
+	int retval = 0;
+	struct yaffs_linux_context *context = yaffs_dev_to_lc(dev);
+
+	if (dev->read_only)
+		return -1;
+
+	context->bg_running = 1;
+
+	context->bg_thread = kthread_run(yaffs_bg_thread_fn,
+					 (void *)dev, "yaffs-bg-%d",
+					 context->mount_id);
+
+	if (IS_ERR(context->bg_thread)) {
+		retval = PTR_ERR(context->bg_thread);
+		context->bg_thread = NULL;
+		context->bg_running = 0;
+	}
+	return retval;
+}
+
+static void yaffs_bg_stop(struct yaffs_dev *dev)
+{
+	struct yaffs_linux_context *ctxt = yaffs_dev_to_lc(dev);
+
+	ctxt->bg_running = 0;
+
+	if (ctxt->bg_thread) {
+		kthread_stop(ctxt->bg_thread);
+		ctxt->bg_thread = NULL;
+	}
+}
+#else
+static int yaffs_bg_thread_fn(void *data)
+{
+	return 0;
+}
+
+static int yaffs_bg_start(struct yaffs_dev *dev)
+{
+	return 0;
+}
+
+static void yaffs_bg_stop(struct yaffs_dev *dev)
+{
+}
+#endif
+
+
+static void yaffs_flush_inodes(struct super_block *sb)
+{
+	struct inode *iptr;
+	struct yaffs_obj *obj;
+
+	list_for_each_entry(iptr, &sb->s_inodes, i_sb_list) {
+		obj = yaffs_inode_to_obj(iptr);
+		if (obj) {
+			yaffs_trace(YAFFS_TRACE_OS,
+				"flushing obj %d",
+				obj->obj_id);
+			yaffs_flush_file(obj, 1, 0, 0);
+		}
+	}
+}
+
+static void yaffs_flush_super(struct super_block *sb, int do_checkpoint)
+{
+	struct yaffs_dev *dev = yaffs_super_to_dev(sb);
+	if (!dev)
+		return;
+
+	yaffs_flush_inodes(sb);
+	yaffs_update_dirty_dirs(dev);
+	yaffs_flush_whole_cache(dev, 1);
+	if (do_checkpoint)
+		yaffs_checkpoint_save(dev);
+}
+
+static LIST_HEAD(yaffs_context_list);
+struct mutex yaffs_context_lock;
+
+static void yaffs_put_super(struct super_block *sb)
+{
+	struct yaffs_dev *dev = yaffs_super_to_dev(sb);
+	struct mtd_info *mtd = yaffs_dev_to_mtd(dev);
+
+	yaffs_trace(YAFFS_TRACE_OS | YAFFS_TRACE_ALWAYS,
+			"yaffs_put_super");
+
+	yaffs_trace(YAFFS_TRACE_OS | YAFFS_TRACE_BACKGROUND,
+		"Shutting down yaffs background thread");
+	yaffs_bg_stop(dev);
+	yaffs_trace(YAFFS_TRACE_OS | YAFFS_TRACE_BACKGROUND,
+		"yaffs background thread shut down");
+
+	yaffs_gross_lock(dev);
+
+	yaffs_flush_super(sb, 1);
+
+	yaffs_deinitialise(dev);
+
+	yaffs_gross_unlock(dev);
+
+	mutex_lock(&yaffs_context_lock);
+	list_del_init(&(yaffs_dev_to_lc(dev)->context_list));
+	mutex_unlock(&yaffs_context_lock);
+
+	if (yaffs_dev_to_lc(dev)->spare_buffer) {
+		kfree(yaffs_dev_to_lc(dev)->spare_buffer);
+		yaffs_dev_to_lc(dev)->spare_buffer = NULL;
+	}
+
+	kfree(dev);
+
+	yaffs_put_mtd_device(mtd);
+
+	yaffs_trace(YAFFS_TRACE_OS | YAFFS_TRACE_ALWAYS,
+			"yaffs_put_super done");
+}
+
+
+static unsigned yaffs_gc_control_callback(struct yaffs_dev *dev)
+{
+	return yaffs_gc_control;
+}
+
+
+#ifdef YAFFS_COMPILE_EXPORTFS
+
+static struct inode *yaffs2_nfs_get_inode(struct super_block *sb, uint64_t ino,
+					  uint32_t generation)
+{
+	return Y_IGET(sb, ino);
+}
+
+static struct dentry *yaffs2_fh_to_dentry(struct super_block *sb,
+					  struct fid *fid, int fh_len,
+					  int fh_type)
+{
+	return generic_fh_to_dentry(sb, fid, fh_len, fh_type,
+				    yaffs2_nfs_get_inode);
+}
+
+static struct dentry *yaffs2_fh_to_parent(struct super_block *sb,
+					  struct fid *fid, int fh_len,
+					  int fh_type)
+{
+	return generic_fh_to_parent(sb, fid, fh_len, fh_type,
+				    yaffs2_nfs_get_inode);
+}
+
+struct dentry *yaffs2_get_parent(struct dentry *dentry)
+{
+
+	struct super_block *sb = dentry->d_inode->i_sb;
+	struct dentry *parent = ERR_PTR(-ENOENT);
+	struct inode *inode;
+	unsigned long parent_ino;
+	struct yaffs_obj *d_obj;
+	struct yaffs_obj *parent_obj;
+
+	d_obj = yaffs_inode_to_obj(dentry->d_inode);
+
+	if (d_obj) {
+		parent_obj = d_obj->parent;
+		if (parent_obj) {
+			parent_ino = yaffs_get_obj_inode(parent_obj);
+			inode = Y_IGET(sb, parent_ino);
+
+			if (IS_ERR(inode)) {
+				parent = ERR_CAST(inode);
+			} else {
+				parent = d_obtain_alias(inode);
+				if (!IS_ERR(parent)) {
+					parent = ERR_PTR(-ENOMEM);
+					iput(inode);
+				}
+			}
+		}
+	}
+
+	return parent;
+}
+
+/* Just declare a zero structure as a NULL value implies
+ * using the default functions of exportfs.
+ */
+
+static struct export_operations yaffs_export_ops = {
+	.fh_to_dentry = yaffs2_fh_to_dentry,
+	.fh_to_parent = yaffs2_fh_to_parent,
+	.get_parent = yaffs2_get_parent,
+};
+
+#endif
+
+static void yaffs_unstitch_obj(struct inode *inode, struct yaffs_obj *obj)
+{
+	/* Clear the association between the inode and
+	 * the struct yaffs_obj.
+	 */
+	obj->my_inode = NULL;
+	yaffs_inode_to_obj_lv(inode) = NULL;
+
+	/* If the object freeing was deferred, then the real
+	 * free happens now.
+	 * This should fix the inode inconsistency problem.
+	 */
+	yaffs_handle_defered_free(obj);
+}
+
+#ifdef YAFFS_HAS_EVICT_INODE
+/* yaffs_evict_inode combines into one operation what was previously done in
+ * yaffs_clear_inode() and yaffs_delete_inode()
+ *
+ */
+static void yaffs_evict_inode(struct inode *inode)
+{
+	struct yaffs_obj *obj;
+	struct yaffs_dev *dev;
+	int deleteme = 0;
+
+	obj = yaffs_inode_to_obj(inode);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_evict_inode: ino %d, count %d %s",
+		(int)inode->i_ino, atomic_read(&inode->i_count),
+		obj ? "object exists" : "null object");
+
+	if (!inode->i_nlink && !is_bad_inode(inode))
+		deleteme = 1;
+	truncate_inode_pages(&inode->i_data, 0);
+	Y_CLEAR_INODE(inode);
+
+	if (deleteme && obj) {
+		dev = obj->my_dev;
+		yaffs_gross_lock(dev);
+		yaffs_del_obj(obj);
+		yaffs_gross_unlock(dev);
+	}
+	if (obj) {
+		dev = obj->my_dev;
+		yaffs_gross_lock(dev);
+		yaffs_unstitch_obj(inode, obj);
+		yaffs_gross_unlock(dev);
+	}
+}
+#else
+
+/* clear is called to tell the fs to release any per-inode data it holds.
+ * The object might still exist on disk and is just being thrown out of the cache
+ * or else the object has actually been deleted and we're being called via
+ * the chain
+ *   yaffs_delete_inode() -> clear_inode()->yaffs_clear_inode()
+ */
+
+static void yaffs_clear_inode(struct inode *inode)
+{
+	struct yaffs_obj *obj;
+	struct yaffs_dev *dev;
+
+	obj = yaffs_inode_to_obj(inode);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_clear_inode: ino %d, count %d %s",
+		(int)inode->i_ino, atomic_read(&inode->i_count),
+		obj ? "object exists" : "null object");
+
+	if (obj) {
+		dev = obj->my_dev;
+		yaffs_gross_lock(dev);
+		yaffs_unstitch_obj(inode, obj);
+		yaffs_gross_unlock(dev);
+	}
+
+}
+
+/* delete is called when the link count is zero and the inode
+ * is put (ie. nobody wants to know about it anymore, time to
+ * delete the file).
+ * NB Must call clear_inode()
+ */
+static void yaffs_delete_inode(struct inode *inode)
+{
+	struct yaffs_obj *obj = yaffs_inode_to_obj(inode);
+	struct yaffs_dev *dev;
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_delete_inode: ino %d, count %d %s",
+		(int)inode->i_ino, atomic_read(&inode->i_count),
+		obj ? "object exists" : "null object");
+
+	if (obj) {
+		dev = obj->my_dev;
+		yaffs_gross_lock(dev);
+		yaffs_del_obj(obj);
+		yaffs_gross_unlock(dev);
+	}
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 13))
+	truncate_inode_pages(&inode->i_data, 0);
+#endif
+	clear_inode(inode);
+}
+#endif
+
+
+
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 17))
+static int yaffs_statfs(struct dentry *dentry, struct kstatfs *buf)
+{
+	struct yaffs_dev *dev = yaffs_dentry_to_obj(dentry)->my_dev;
+	struct super_block *sb = dentry->d_sb;
+#elif (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+static int yaffs_statfs(struct super_block *sb, struct kstatfs *buf)
+{
+	struct yaffs_dev *dev = yaffs_super_to_dev(sb);
+#else
+static int yaffs_statfs(struct super_block *sb, struct statfs *buf)
+{
+	struct yaffs_dev *dev = yaffs_super_to_dev(sb);
+#endif
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_statfs");
+
+	yaffs_gross_lock(dev);
+
+	buf->f_type = YAFFS_MAGIC;
+	buf->f_bsize = sb->s_blocksize;
+	buf->f_namelen = 255;
+
+	if (dev->data_bytes_per_chunk & (dev->data_bytes_per_chunk - 1)) {
+		/* Do this if chunk size is not a power of 2 */
+
+		uint64_t bytes_in_dev;
+		uint64_t bytes_free;
+
+		bytes_in_dev =
+		    ((uint64_t)
+		     ((dev->param.end_block - dev->param.start_block +
+		       1))) * ((uint64_t) (dev->param.chunks_per_block *
+					   dev->data_bytes_per_chunk));
+
+		do_div(bytes_in_dev, sb->s_blocksize);	/* bytes_in_dev becomes the number of blocks */
+		buf->f_blocks = bytes_in_dev;
+
+		bytes_free = ((uint64_t) (yaffs_get_n_free_chunks(dev))) *
+		    ((uint64_t) (dev->data_bytes_per_chunk));
+
+		do_div(bytes_free, sb->s_blocksize);
+
+		buf->f_bfree = bytes_free;
+
+	} else if (sb->s_blocksize > dev->data_bytes_per_chunk) {
+
+		buf->f_blocks =
+		    (dev->param.end_block - dev->param.start_block + 1) *
+		    dev->param.chunks_per_block /
+		    (sb->s_blocksize / dev->data_bytes_per_chunk);
+		buf->f_bfree =
+		    yaffs_get_n_free_chunks(dev) /
+		    (sb->s_blocksize / dev->data_bytes_per_chunk);
+	} else {
+		buf->f_blocks =
+		    (dev->param.end_block - dev->param.start_block + 1) *
+		    dev->param.chunks_per_block *
+		    (dev->data_bytes_per_chunk / sb->s_blocksize);
+
+		buf->f_bfree =
+		    yaffs_get_n_free_chunks(dev) *
+		    (dev->data_bytes_per_chunk / sb->s_blocksize);
+	}
+
+	buf->f_files = 0;
+	buf->f_ffree = 0;
+	buf->f_bavail = buf->f_bfree;
+
+	yaffs_gross_unlock(dev);
+	return 0;
+}
+
+
+
+static int yaffs_do_sync_fs(struct super_block *sb, int request_checkpoint)
+{
+
+	struct yaffs_dev *dev = yaffs_super_to_dev(sb);
+	unsigned int oneshot_checkpoint = (yaffs_auto_checkpoint & 4);
+	unsigned gc_urgent = yaffs_bg_gc_urgency(dev);
+	int do_checkpoint;
+	int dirty = yaffs_check_super_dirty(dev);
+
+	yaffs_trace(YAFFS_TRACE_OS | YAFFS_TRACE_SYNC | YAFFS_TRACE_BACKGROUND,
+		"yaffs_do_sync_fs: gc-urgency %d %s %s%s",
+		gc_urgent,
+		dirty ? "dirty" : "clean",
+		request_checkpoint ? "checkpoint requested" : "no checkpoint",
+		oneshot_checkpoint ? " one-shot" : "");
+
+	yaffs_gross_lock(dev);
+	do_checkpoint = ((request_checkpoint && !gc_urgent) ||
+			 oneshot_checkpoint) && !dev->is_checkpointed;
+
+	if (dirty || do_checkpoint) {
+		yaffs_flush_super(sb, !dev->is_checkpointed && do_checkpoint);
+		yaffs_clear_super_dirty(dev);
+		if (oneshot_checkpoint)
+			yaffs_auto_checkpoint &= ~4;
+	}
+	yaffs_gross_unlock(dev);
+
+	return 0;
+}
+
+
+#ifdef YAFFS_HAS_WRITE_SUPER
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 17))
+static void yaffs_write_super(struct super_block *sb)
+#else
+static int yaffs_write_super(struct super_block *sb)
+#endif
+{
+	unsigned request_checkpoint = (yaffs_auto_checkpoint >= 2);
+
+	yaffs_trace(YAFFS_TRACE_OS | YAFFS_TRACE_SYNC | YAFFS_TRACE_BACKGROUND,
+		"yaffs_write_super %s",
+		request_checkpoint ? " checkpt" : "");
+
+	yaffs_do_sync_fs(sb, request_checkpoint);
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 18))
+	return 0;
+#endif
+}
+#endif
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 17))
+static int yaffs_sync_fs(struct super_block *sb, int wait)
+#else
+static int yaffs_sync_fs(struct super_block *sb)
+#endif
+{
+	unsigned request_checkpoint = (yaffs_auto_checkpoint >= 1);
+
+	yaffs_trace(YAFFS_TRACE_OS | YAFFS_TRACE_SYNC,
+		"yaffs_sync_fs%s", request_checkpoint ? " checkpt" : "");
+
+	yaffs_do_sync_fs(sb, request_checkpoint);
+
+	return 0;
+}
+
+/* the function only is used to change dev->read_only when this file system
+ * is remounted.
+ */
+static int yaffs_remount_fs(struct super_block *sb, int *flags, char *data)
+{
+	int read_only = 0;
+	struct mtd_info *mtd;
+	struct yaffs_dev *dev = 0;
+
+	/* Get the device */
+	mtd = get_mtd_device(NULL, MINOR(sb->s_dev));
+	if (!mtd) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"MTD device #%u doesn't appear to exist",
+			MINOR(sb->s_dev));
+		return 1;
+	}
+
+	/* Check it's NAND */
+	if (mtd->type != MTD_NANDFLASH) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"MTD device is not NAND it's type %d",
+			mtd->type);
+		return 1;
+	}
+
+	read_only = ((*flags & MS_RDONLY) != 0);
+	if (!read_only && !(mtd->flags & MTD_WRITEABLE)) {
+		read_only = 1;
+		printk(KERN_INFO
+			"yaffs: mtd is read only, setting superblock read only");
+		*flags |= MS_RDONLY;
+	}
+
+	dev = sb->s_fs_info;
+	dev->read_only = read_only;
+
+	return 0;
+}
+
+static const struct super_operations yaffs_super_ops = {
+	.statfs = yaffs_statfs,
+
+#ifndef YAFFS_USE_OWN_IGET
+	.read_inode = yaffs_read_inode,
+#endif
+#ifdef YAFFS_HAS_PUT_INODE
+	.put_inode = yaffs_put_inode,
+#endif
+	.put_super = yaffs_put_super,
+#ifdef YAFFS_HAS_EVICT_INODE
+	.evict_inode = yaffs_evict_inode,
+#else
+	.delete_inode = yaffs_delete_inode,
+	.clear_inode = yaffs_clear_inode,
+#endif
+	.sync_fs = yaffs_sync_fs,
+#ifdef YAFFS_HAS_WRITE_SUPER
+	.write_super = yaffs_write_super,
+#endif
+	.remount_fs = yaffs_remount_fs,
+};
+
+struct yaffs_options {
+	int inband_tags;
+	int skip_checkpoint_read;
+	int skip_checkpoint_write;
+	int no_cache;
+	int tags_ecc_on;
+	int tags_ecc_overridden;
+	int lazy_loading_enabled;
+	int lazy_loading_overridden;
+	int empty_lost_and_found;
+	int empty_lost_and_found_overridden;
+	int disable_summary;
+};
+
+#define MAX_OPT_LEN 30
+static int yaffs_parse_options(struct yaffs_options *options,
+			       const char *options_str)
+{
+	char cur_opt[MAX_OPT_LEN + 1];
+	int p;
+	int error = 0;
+
+	/* Parse through the options which is a comma seperated list */
+
+	while (options_str && *options_str && !error) {
+		memset(cur_opt, 0, MAX_OPT_LEN + 1);
+		p = 0;
+
+		while (*options_str == ',')
+			options_str++;
+
+		while (*options_str && *options_str != ',') {
+			if (p < MAX_OPT_LEN) {
+				cur_opt[p] = *options_str;
+				p++;
+			}
+			options_str++;
+		}
+
+		if (!strcmp(cur_opt, "inband-tags")) {
+			options->inband_tags = 1;
+		} else if (!strcmp(cur_opt, "tags-ecc-off")) {
+			options->tags_ecc_on = 0;
+			options->tags_ecc_overridden = 1;
+		} else if (!strcmp(cur_opt, "tags-ecc-on")) {
+			options->tags_ecc_on = 1;
+			options->tags_ecc_overridden = 1;
+		} else if (!strcmp(cur_opt, "lazy-loading-off")) {
+			options->lazy_loading_enabled = 0;
+			options->lazy_loading_overridden = 1;
+		} else if (!strcmp(cur_opt, "lazy-loading-on")) {
+			options->lazy_loading_enabled = 1;
+			options->lazy_loading_overridden = 1;
+		} else if (!strcmp(cur_opt, "disable-summary")) {
+			options->disable_summary = 1;
+		} else if (!strcmp(cur_opt, "empty-lost-and-found-off")) {
+			options->empty_lost_and_found = 0;
+			options->empty_lost_and_found_overridden = 1;
+		} else if (!strcmp(cur_opt, "empty-lost-and-found-on")) {
+			options->empty_lost_and_found = 1;
+			options->empty_lost_and_found_overridden = 1;
+		} else if (!strcmp(cur_opt, "no-cache")) {
+			options->no_cache = 1;
+		} else if (!strcmp(cur_opt, "no-checkpoint-read")) {
+			options->skip_checkpoint_read = 1;
+		} else if (!strcmp(cur_opt, "no-checkpoint-write")) {
+			options->skip_checkpoint_write = 1;
+		} else if (!strcmp(cur_opt, "no-checkpoint")) {
+			options->skip_checkpoint_read = 1;
+			options->skip_checkpoint_write = 1;
+		} else {
+			printk(KERN_INFO "yaffs: Bad mount option \"%s\"\n",
+			       cur_opt);
+			error = 1;
+		}
+	}
+
+	return error;
+}
+
+
+static struct dentry *yaffs_make_root(struct inode *inode)
+{
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(3, 4, 0))
+	struct dentry *root = d_alloc_root(inode);
+
+	if (!root)
+		iput(inode);
+
+        return root;
+#else
+        return d_make_root(inode);
+#endif
+}
+
+
+
+
+static struct super_block *yaffs_internal_read_super(int yaffs_version,
+						     struct super_block *sb,
+						     void *data, int silent)
+{
+	int n_blocks;
+	struct inode *inode = NULL;
+	struct dentry *root;
+	struct yaffs_dev *dev = 0;
+	char devname_buf[BDEVNAME_SIZE + 1];
+	struct mtd_info *mtd;
+	int err;
+	char *data_str = (char *)data;
+	struct yaffs_linux_context *context = NULL;
+	struct yaffs_param *param;
+
+	int read_only = 0;
+	int inband_tags = 0;
+
+	struct yaffs_options options;
+
+	unsigned mount_id;
+	int found;
+	struct yaffs_linux_context *context_iterator;
+	struct list_head *l;
+
+	if (!sb) {
+		printk(KERN_INFO "yaffs: sb is NULL\n");
+		return NULL;
+        }
+
+	sb->s_magic = YAFFS_MAGIC;
+	sb->s_op = &yaffs_super_ops;
+	sb->s_flags |= MS_NOATIME;
+
+	read_only = ((sb->s_flags & MS_RDONLY) != 0);
+
+#ifdef YAFFS_COMPILE_EXPORTFS
+	sb->s_export_op = &yaffs_export_ops;
+#endif
+
+	if (!sb->s_dev)
+		printk(KERN_INFO "yaffs: sb->s_dev is NULL\n");
+	else if (!yaffs_devname(sb, devname_buf))
+		printk(KERN_INFO "yaffs: devname is NULL\n");
+	else
+		printk(KERN_INFO "yaffs: dev is %d name is \"%s\" %s\n",
+		       sb->s_dev,
+		       yaffs_devname(sb, devname_buf), read_only ? "ro" : "rw");
+
+	if (!data_str)
+		data_str = "";
+
+	printk(KERN_INFO "yaffs: passed flags \"%s\"\n", data_str);
+
+	memset(&options, 0, sizeof(options));
+
+	if (yaffs_parse_options(&options, data_str)) {
+		/* Option parsing failed */
+		return NULL;
+	}
+
+	sb->s_blocksize = PAGE_CACHE_SIZE;
+	sb->s_blocksize_bits = PAGE_CACHE_SHIFT;
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_read_super: Using yaffs%d", yaffs_version);
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_read_super: block size %d", (int)(sb->s_blocksize));
+
+	yaffs_trace(YAFFS_TRACE_ALWAYS,
+		"yaffs: Attempting MTD mount of %u.%u,\"%s\"",
+		MAJOR(sb->s_dev), MINOR(sb->s_dev),
+		yaffs_devname(sb, devname_buf));
+
+	/* Get the device */
+	mtd = get_mtd_device(NULL, MINOR(sb->s_dev));
+	if (IS_ERR(mtd)) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"yaffs: MTD device %u either not valid or unavailable",
+			MINOR(sb->s_dev));
+		return NULL;
+	}
+
+	if (yaffs_auto_select && yaffs_version == 1 && WRITE_SIZE(mtd) >= 2048) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS, "auto selecting yaffs2");
+		yaffs_version = 2;
+	}
+
+	/* Added NCB 26/5/2006 for completeness */
+	if (yaffs_version == 2 && !options.inband_tags
+	    && WRITE_SIZE(mtd) == 512) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS, "auto selecting yaffs1");
+		yaffs_version = 1;
+	}
+
+	if (mtd->oobavail < sizeof(struct yaffs_packed_tags2) ||
+	    options.inband_tags)
+		inband_tags = 1;
+
+	if(yaffs_verify_mtd(mtd, yaffs_version, inband_tags) < 0)
+		return NULL;
+
+	/* OK, so if we got here, we have an MTD that's NAND and looks
+	 * like it has the right capabilities
+	 * Set the struct yaffs_dev up for mtd
+	 */
+
+	if (!read_only && !(mtd->flags & MTD_WRITEABLE)) {
+		read_only = 1;
+		printk(KERN_INFO
+		       "yaffs: mtd is read only, setting superblock read only\n"
+		);
+		sb->s_flags |= MS_RDONLY;
+	}
+
+	dev = kmalloc(sizeof(struct yaffs_dev), GFP_KERNEL);
+	context = kmalloc(sizeof(struct yaffs_linux_context), GFP_KERNEL);
+
+	if (!dev || !context) {
+		kfree(dev);
+		kfree(context);
+		dev = NULL;
+		context = NULL;
+
+		/* Deep shit could not allocate device structure */
+		yaffs_trace(YAFFS_TRACE_ALWAYS,
+			"yaffs_read_super: Failed trying to allocate struct yaffs_dev."
+		);
+		return NULL;
+	}
+	memset(dev, 0, sizeof(struct yaffs_dev));
+	param = &(dev->param);
+
+	memset(context, 0, sizeof(struct yaffs_linux_context));
+	dev->os_context = context;
+	INIT_LIST_HEAD(&(context->context_list));
+	context->dev = dev;
+	context->super = sb;
+
+	dev->read_only = read_only;
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+	sb->s_fs_info = dev;
+#else
+	sb->u.generic_sbp = dev;
+#endif
+
+
+	dev->driver_context = mtd;
+	param->name = mtd->name;
+
+	/* Set up the memory size parameters.... */
+
+
+	param->n_reserved_blocks = 5;
+	param->n_caches = (options.no_cache) ? 0 : 10;
+	param->inband_tags = inband_tags;
+
+	param->enable_xattr = 1;
+	if (options.lazy_loading_overridden)
+		param->disable_lazy_load = !options.lazy_loading_enabled;
+
+	param->defered_dir_update = 1;
+
+	if (options.tags_ecc_overridden)
+		param->no_tags_ecc = !options.tags_ecc_on;
+
+	param->empty_lost_n_found = 1;
+	param->refresh_period = 500;
+	param->disable_summary = options.disable_summary;
+
+
+#ifdef CONFIG_YAFFS_DISABLE_BAD_BLOCK_MARKING
+	param->disable_bad_block_marking  = 1;
+#endif
+	if (options.empty_lost_and_found_overridden)
+		param->empty_lost_n_found = options.empty_lost_and_found;
+
+	/* ... and the functions. */
+	if (yaffs_version == 2) {
+		param->is_yaffs2 = 1;
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 17))
+		param->total_bytes_per_chunk = mtd->writesize;
+		param->chunks_per_block = mtd->erasesize / mtd->writesize;
+#else
+		param->total_bytes_per_chunk = mtd->oobblock;
+		param->chunks_per_block = mtd->erasesize / mtd->oobblock;
+#endif
+		n_blocks = YCALCBLOCKS(mtd->size, mtd->erasesize);
+
+		param->start_block = 0;
+		param->end_block = n_blocks - 1;
+	} else {
+		param->is_yaffs2 = 0;
+		n_blocks = YCALCBLOCKS(mtd->size,
+			     YAFFS_CHUNKS_PER_BLOCK * YAFFS_BYTES_PER_CHUNK);
+
+		param->chunks_per_block = YAFFS_CHUNKS_PER_BLOCK;
+		param->total_bytes_per_chunk = YAFFS_BYTES_PER_CHUNK;
+	}
+
+	param->start_block = 0;
+	param->end_block = n_blocks - 1;
+
+	yaffs_mtd_drv_install(dev);
+
+	param->sb_dirty_fn = yaffs_set_super_dirty;
+	param->gc_control_fn = yaffs_gc_control_callback;
+
+	yaffs_dev_to_lc(dev)->super = sb;
+
+	param->use_nand_ecc = 1;
+
+	param->skip_checkpt_rd = options.skip_checkpoint_read;
+	param->skip_checkpt_wr = options.skip_checkpoint_write;
+
+	mutex_lock(&yaffs_context_lock);
+	/* Get a mount id */
+	found = 0;
+	for (mount_id = 0; !found; mount_id++) {
+		found = 1;
+		list_for_each(l, &yaffs_context_list) {
+			context_iterator =
+			    list_entry(l, struct yaffs_linux_context,
+				       context_list);
+			if (context_iterator->mount_id == mount_id)
+				found = 0;
+		}
+	}
+	context->mount_id = mount_id;
+
+	list_add_tail(&(yaffs_dev_to_lc(dev)->context_list),
+		      &yaffs_context_list);
+	mutex_unlock(&yaffs_context_lock);
+
+	/* Directory search handling... */
+	INIT_LIST_HEAD(&(yaffs_dev_to_lc(dev)->search_contexts));
+	param->remove_obj_fn = yaffs_remove_obj_callback;
+
+	mutex_init(&(yaffs_dev_to_lc(dev)->gross_lock));
+
+	yaffs_gross_lock(dev);
+
+	err = yaffs_guts_initialise(dev);
+
+	yaffs_trace(YAFFS_TRACE_OS,
+		"yaffs_read_super: guts initialised %s",
+		(err == YAFFS_OK) ? "OK" : "FAILED");
+
+	if (err == YAFFS_OK)
+		yaffs_bg_start(dev);
+
+	if (!context->bg_thread)
+		param->defered_dir_update = 0;
+
+	sb->s_maxbytes = yaffs_max_file_size(dev);
+
+	/* Release lock before yaffs_get_inode() */
+	yaffs_gross_unlock(dev);
+
+	/* Create root inode */
+	if (err == YAFFS_OK)
+		inode = yaffs_get_inode(sb, S_IFDIR | 0755, 0, yaffs_root(dev));
+
+	if (!inode)
+		return NULL;
+
+	inode->i_op = &yaffs_dir_inode_operations;
+	inode->i_fop = &yaffs_dir_operations;
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_read_super: got root inode");
+
+	root = yaffs_make_root(inode);
+
+	if (!root)
+		return NULL;
+
+	sb->s_root = root;
+	if(!dev->is_checkpointed)
+		yaffs_set_super_dirty(dev);
+
+	yaffs_trace(YAFFS_TRACE_ALWAYS,
+		"yaffs_read_super: is_checkpointed %d",
+		dev->is_checkpointed);
+
+	yaffs_trace(YAFFS_TRACE_OS, "yaffs_read_super: done");
+	return sb;
+}
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+static int yaffs_internal_read_super_mtd(struct super_block *sb, void *data,
+					 int silent)
+{
+	return yaffs_internal_read_super(1, sb, data, silent) ? 0 : -EINVAL;
+}
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 39))
+static struct dentry *yaffs_mount(struct file_system_type *fs_type, int flags,
+        const char *dev_name, void *data)
+{
+    return mount_bdev(fs_type, flags, dev_name, data, yaffs_internal_read_super_mtd);
+}
+#elif (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 17))
+static int yaffs_read_super(struct file_system_type *fs,
+			    int flags, const char *dev_name,
+			    void *data, struct vfsmount *mnt)
+{
+
+	return get_sb_bdev(fs, flags, dev_name, data,
+			   yaffs_internal_read_super_mtd, mnt);
+}
+#else
+static struct super_block *yaffs_read_super(struct file_system_type *fs,
+					    int flags, const char *dev_name,
+					    void *data)
+{
+
+	return get_sb_bdev(fs, flags, dev_name, data,
+			   yaffs_internal_read_super_mtd);
+}
+#endif
+
+static struct file_system_type yaffs_fs_type = {
+	.owner = THIS_MODULE,
+	.name = "yaffs",
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 39))
+        .mount = yaffs_mount,
+#else
+        .get_sb = yaffs_read_super,
+#endif
+     	.kill_sb = kill_block_super,
+	.fs_flags = FS_REQUIRES_DEV,
+};
+#else
+static struct super_block *yaffs_read_super(struct super_block *sb, void *data,
+					    int silent)
+{
+	return yaffs_internal_read_super(1, sb, data, silent);
+}
+
+static DECLARE_FSTYPE(yaffs_fs_type, "yaffs", yaffs_read_super,
+		      FS_REQUIRES_DEV);
+#endif
+
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+static int yaffs2_internal_read_super_mtd(struct super_block *sb, void *data,
+					  int silent)
+{
+	return yaffs_internal_read_super(2, sb, data, silent) ? 0 : -EINVAL;
+}
+
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 39))
+static struct dentry *yaffs2_mount(struct file_system_type *fs_type, int flags,
+        const char *dev_name, void *data)
+{
+        return mount_bdev(fs_type, flags, dev_name, data, yaffs2_internal_read_super_mtd);
+}
+#elif (LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 17))
+static int yaffs2_read_super(struct file_system_type *fs,
+			     int flags, const char *dev_name, void *data,
+			     struct vfsmount *mnt)
+{
+	return get_sb_bdev(fs, flags, dev_name, data,
+			   yaffs2_internal_read_super_mtd, mnt);
+}
+#else
+static struct super_block *yaffs2_read_super(struct file_system_type *fs,
+					     int flags, const char *dev_name,
+					     void *data)
+{
+
+	return get_sb_bdev(fs, flags, dev_name, data,
+			   yaffs2_internal_read_super_mtd);
+}
+#endif
+
+static struct file_system_type yaffs2_fs_type = {
+	.owner = THIS_MODULE,
+	.name = "yaffs2",
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 39))
+        .mount = yaffs2_mount,
+#else
+        .get_sb = yaffs2_read_super,
+#endif
+     	.kill_sb = kill_block_super,
+	.fs_flags = FS_REQUIRES_DEV,
+};
+#else
+static struct super_block *yaffs2_read_super(struct super_block *sb,
+					     void *data, int silent)
+{
+	return yaffs_internal_read_super(2, sb, data, silent);
+}
+
+static DECLARE_FSTYPE(yaffs2_fs_type, "yaffs2", yaffs2_read_super,
+		      FS_REQUIRES_DEV);
+#endif
+
+
+static struct proc_dir_entry *my_proc_entry;
+
+static char *yaffs_dump_dev_part0(char *buf, struct yaffs_dev *dev)
+{
+	struct yaffs_param *param = &dev->param;
+	int bs[10];
+
+	yaffs_count_blocks_by_state(dev,bs);
+
+	buf += sprintf(buf, "start_block.......... %d\n", param->start_block);
+	buf += sprintf(buf, "end_block............ %d\n", param->end_block);
+	buf += sprintf(buf, "total_bytes_per_chunk %d\n",
+				param->total_bytes_per_chunk);
+	buf += sprintf(buf, "use_nand_ecc......... %d\n", param->use_nand_ecc);
+	buf += sprintf(buf, "no_tags_ecc.......... %d\n", param->no_tags_ecc);
+	buf += sprintf(buf, "is_yaffs2............ %d\n", param->is_yaffs2);
+	buf += sprintf(buf, "inband_tags.......... %d\n", param->inband_tags);
+	buf += sprintf(buf, "empty_lost_n_found... %d\n",
+				param->empty_lost_n_found);
+	buf += sprintf(buf, "disable_lazy_load.... %d\n",
+				param->disable_lazy_load);
+	buf += sprintf(buf, "disable_bad_block_mrk %d\n",
+				param->disable_bad_block_marking);
+	buf += sprintf(buf, "refresh_period....... %d\n",
+				param->refresh_period);
+	buf += sprintf(buf, "n_caches............. %d\n", param->n_caches);
+	buf += sprintf(buf, "n_reserved_blocks.... %d\n",
+				param->n_reserved_blocks);
+	buf += sprintf(buf, "always_check_erased.. %d\n",
+				param->always_check_erased);
+	buf += sprintf(buf, "\n");
+	buf += sprintf(buf, "block count by state\n");
+	buf += sprintf(buf, "0:%d 1:%d 2:%d 3:%d 4:%d\n",
+				bs[0], bs[1], bs[2], bs[3], bs[4]);
+	buf += sprintf(buf, "5:%d 6:%d 7:%d 8:%d 9:%d\n",
+				bs[5], bs[6], bs[7], bs[8], bs[9]);
+
+	return buf;
+}
+
+static char *yaffs_dump_dev_part1(char *buf, struct yaffs_dev *dev)
+{
+	buf += sprintf(buf, "max file size....... %lld\n",
+				(long long) yaffs_max_file_size(dev));
+	buf += sprintf(buf, "data_bytes_per_chunk. %d\n",
+				dev->data_bytes_per_chunk);
+	buf += sprintf(buf, "chunk_grp_bits....... %d\n", dev->chunk_grp_bits);
+	buf += sprintf(buf, "chunk_grp_size....... %d\n", dev->chunk_grp_size);
+	buf += sprintf(buf, "n_erased_blocks...... %d\n", dev->n_erased_blocks);
+	buf += sprintf(buf, "blocks_in_checkpt.... %d\n",
+				dev->blocks_in_checkpt);
+	buf += sprintf(buf, "\n");
+	buf += sprintf(buf, "n_tnodes............. %d\n", dev->n_tnodes);
+	buf += sprintf(buf, "n_obj................ %d\n", dev->n_obj);
+	buf += sprintf(buf, "n_free_chunks........ %d\n", dev->n_free_chunks);
+	buf += sprintf(buf, "\n");
+	buf += sprintf(buf, "n_page_writes........ %u\n", dev->n_page_writes);
+	buf += sprintf(buf, "n_page_reads......... %u\n", dev->n_page_reads);
+	buf += sprintf(buf, "n_erasures........... %u\n", dev->n_erasures);
+	buf += sprintf(buf, "n_gc_copies.......... %u\n", dev->n_gc_copies);
+	buf += sprintf(buf, "all_gcs.............. %u\n", dev->all_gcs);
+	buf += sprintf(buf, "passive_gc_count..... %u\n",
+				dev->passive_gc_count);
+	buf += sprintf(buf, "oldest_dirty_gc_count %u\n",
+				dev->oldest_dirty_gc_count);
+	buf += sprintf(buf, "n_gc_blocks.......... %u\n", dev->n_gc_blocks);
+	buf += sprintf(buf, "bg_gcs............... %u\n", dev->bg_gcs);
+	buf += sprintf(buf, "n_retried_writes..... %u\n",
+				dev->n_retried_writes);
+	buf += sprintf(buf, "n_retired_blocks..... %u\n",
+				dev->n_retired_blocks);
+	buf += sprintf(buf, "n_ecc_fixed.......... %u\n", dev->n_ecc_fixed);
+	buf += sprintf(buf, "n_ecc_unfixed........ %u\n", dev->n_ecc_unfixed);
+	buf += sprintf(buf, "n_tags_ecc_fixed..... %u\n",
+				dev->n_tags_ecc_fixed);
+	buf += sprintf(buf, "n_tags_ecc_unfixed... %u\n",
+				dev->n_tags_ecc_unfixed);
+	buf += sprintf(buf, "cache_hits........... %u\n", dev->cache_hits);
+	buf += sprintf(buf, "n_deleted_files...... %u\n", dev->n_deleted_files);
+	buf += sprintf(buf, "n_unlinked_files..... %u\n",
+				dev->n_unlinked_files);
+	buf += sprintf(buf, "refresh_count........ %u\n", dev->refresh_count);
+	buf += sprintf(buf, "n_bg_deletions....... %u\n", dev->n_bg_deletions);
+	buf += sprintf(buf, "tags_used............ %u\n", dev->tags_used);
+	buf += sprintf(buf, "summary_used......... %u\n", dev->summary_used);
+
+	return buf;
+}
+
+static int yaffs_proc_read(char *page,
+			   char **start,
+			   off_t offset, int count, int *eof, void *data)
+{
+	struct list_head *item;
+	char *buf = page;
+	int step = offset;
+	int n = 0;
+
+	/* Get proc_file_read() to step 'offset' by one on each sucessive call.
+	 * We use 'offset' (*ppos) to indicate where we are in dev_list.
+	 * This also assumes the user has posted a read buffer large
+	 * enough to hold the complete output; but that's life in /proc.
+	 */
+
+	*(int *)start = 1;
+
+	/* Print header first */
+	if (step == 0)
+		buf +=
+		    sprintf(buf, "Multi-version YAFFS\n");
+	else if (step == 1)
+		buf += sprintf(buf, "\n");
+	else {
+		step -= 2;
+
+		mutex_lock(&yaffs_context_lock);
+
+		/* Locate and print the Nth entry.  Order N-squared but N is small. */
+		list_for_each(item, &yaffs_context_list) {
+			struct yaffs_linux_context *dc =
+			    list_entry(item, struct yaffs_linux_context,
+				       context_list);
+			struct yaffs_dev *dev = dc->dev;
+
+			if (n < (step & ~1)) {
+				n += 2;
+				continue;
+			}
+			if ((step & 1) == 0) {
+				buf +=
+				    sprintf(buf, "\nDevice %d \"%s\"\n", n,
+					    dev->param.name);
+				buf = yaffs_dump_dev_part0(buf, dev);
+			} else {
+				buf = yaffs_dump_dev_part1(buf, dev);
+                        }
+
+			break;
+		}
+		mutex_unlock(&yaffs_context_lock);
+	}
+
+	return buf - page < count ? buf - page : count;
+}
+
+/**
+ * Set the verbosity of the warnings and error messages.
+ *
+ * Note that the names can only be a..z or _ with the current code.
+ */
+
+static struct {
+	char *mask_name;
+	unsigned mask_bitfield;
+} mask_flags[] = {
+	{"allocate", YAFFS_TRACE_ALLOCATE},
+	{"always", YAFFS_TRACE_ALWAYS},
+	{"background", YAFFS_TRACE_BACKGROUND},
+	{"bad_blocks", YAFFS_TRACE_BAD_BLOCKS},
+	{"buffers", YAFFS_TRACE_BUFFERS},
+	{"bug", YAFFS_TRACE_BUG},
+	{"checkpt", YAFFS_TRACE_CHECKPOINT},
+	{"deletion", YAFFS_TRACE_DELETION},
+	{"erase", YAFFS_TRACE_ERASE},
+	{"error", YAFFS_TRACE_ERROR},
+	{"gc_detail", YAFFS_TRACE_GC_DETAIL},
+	{"gc", YAFFS_TRACE_GC},
+	{"lock", YAFFS_TRACE_LOCK},
+	{"mtd", YAFFS_TRACE_MTD},
+	{"nandaccess", YAFFS_TRACE_NANDACCESS},
+	{"os", YAFFS_TRACE_OS},
+	{"scan_debug", YAFFS_TRACE_SCAN_DEBUG},
+	{"scan", YAFFS_TRACE_SCAN},
+	{"mount", YAFFS_TRACE_MOUNT},
+	{"tracing", YAFFS_TRACE_TRACING},
+	{"sync", YAFFS_TRACE_SYNC},
+	{"write", YAFFS_TRACE_WRITE},
+	{"verify", YAFFS_TRACE_VERIFY},
+	{"verify_nand", YAFFS_TRACE_VERIFY_NAND},
+	{"verify_full", YAFFS_TRACE_VERIFY_FULL},
+	{"verify_all", YAFFS_TRACE_VERIFY_ALL},
+	{"all", 0xffffffff},
+	{"none", 0},
+	{NULL, 0},
+};
+
+#define MAX_MASK_NAME_LENGTH 40
+static int yaffs_proc_write_trace_options(struct file *file, const char *buf,
+					  unsigned long count)
+{
+	unsigned rg = 0, mask_bitfield;
+	char *end;
+	char *mask_name;
+	const char *x;
+	char substring[MAX_MASK_NAME_LENGTH + 1];
+	int i;
+	int done = 0;
+	int add, len = 0;
+	int pos = 0;
+
+	rg = yaffs_trace_mask;
+
+	while (!done && (pos < count)) {
+		done = 1;
+		while ((pos < count) && isspace(buf[pos]))
+			pos++;
+
+		switch (buf[pos]) {
+		case '+':
+		case '-':
+		case '=':
+			add = buf[pos];
+			pos++;
+			break;
+
+		default:
+			add = ' ';
+			break;
+		}
+		mask_name = NULL;
+
+		mask_bitfield = simple_strtoul(buf + pos, &end, 0);
+
+		if (end > buf + pos) {
+			mask_name = "numeral";
+			len = end - (buf + pos);
+			pos += len;
+			done = 0;
+		} else {
+			for (x = buf + pos, i = 0;
+			     (*x == '_' || (*x >= 'a' && *x <= 'z')) &&
+			     i < MAX_MASK_NAME_LENGTH; x++, i++, pos++)
+				substring[i] = *x;
+			substring[i] = '\0';
+
+			for (i = 0; mask_flags[i].mask_name != NULL; i++) {
+				if (strcmp(substring, mask_flags[i].mask_name)
+				    == 0) {
+					mask_name = mask_flags[i].mask_name;
+					mask_bitfield =
+					    mask_flags[i].mask_bitfield;
+					done = 0;
+					break;
+				}
+			}
+		}
+
+		if (mask_name != NULL) {
+			done = 0;
+			switch (add) {
+			case '-':
+				rg &= ~mask_bitfield;
+				break;
+			case '+':
+				rg |= mask_bitfield;
+				break;
+			case '=':
+				rg = mask_bitfield;
+				break;
+			default:
+				rg |= mask_bitfield;
+				break;
+			}
+		}
+	}
+
+	yaffs_trace_mask = rg | YAFFS_TRACE_ALWAYS;
+
+	printk(KERN_DEBUG "new trace = 0x%08X\n", yaffs_trace_mask);
+
+	if (rg & YAFFS_TRACE_ALWAYS) {
+		for (i = 0; mask_flags[i].mask_name != NULL; i++) {
+			char flag;
+			flag = ((rg & mask_flags[i].mask_bitfield) ==
+				mask_flags[i].mask_bitfield) ? '+' : '-';
+			printk(KERN_DEBUG "%c%s\n", flag,
+			       mask_flags[i].mask_name);
+		}
+	}
+
+	return count;
+}
+
+/* Debug strings are of the form:
+ * .bnnn         print info on block n
+ * .cobjn,chunkn print nand chunk id for objn:chunkn
+ */
+
+static int yaffs_proc_debug_write(struct file *file, const char *buf,
+					  unsigned long count)
+{
+
+	char str[100];
+	char *p0;
+	char *p1;
+	long p1_val;
+	long p0_val;
+	char cmd;
+	struct list_head *item;
+
+	memset(str, 0, sizeof(str));
+	memcpy(str, buf, min((size_t)count, sizeof(str) -1));
+
+	cmd = str[1];
+
+	p0 = str + 2;
+
+	p1 = p0;
+
+	while (*p1 && *p1 != ',') {
+		p1++;
+	}
+	*p1 = '\0';
+	p1++;
+
+	p0_val = simple_strtol(p0, NULL, 0);
+	p1_val = simple_strtol(p1, NULL, 0);
+
+
+	mutex_lock(&yaffs_context_lock);
+
+	/* Locate and print the Nth entry.  Order N-squared but N is small. */
+	list_for_each(item, &yaffs_context_list) {
+		struct yaffs_linux_context *dc =
+		    list_entry(item, struct yaffs_linux_context,
+			       context_list);
+		struct yaffs_dev *dev = dc->dev;
+
+		if (cmd == 'b') {
+			struct yaffs_block_info *bi;
+
+			bi = yaffs_get_block_info(dev,p0_val);
+
+			if(bi) {
+				printk("Block %d: state %d, retire %d, use %d, seq %d\n",
+					(int)p0_val, bi->block_state,
+					bi->needs_retiring, bi->pages_in_use,
+					bi->seq_number);
+			}
+		} else if (cmd == 'c') {
+			struct yaffs_obj *obj;
+			int nand_chunk;
+
+			obj = yaffs_find_by_number(dev, p0_val);
+			if (!obj)
+				printk("No obj %d\n", (int)p0_val);
+			else {
+				if(p1_val == 0)
+					nand_chunk = obj->hdr_chunk;
+				else
+					nand_chunk =
+						yaffs_find_chunk_in_file(obj,
+							p1_val, NULL);
+				printk("Nand chunk for %d:%d is %d\n",
+					(int)p0_val, (int)p1_val, nand_chunk);
+			}
+		}
+	}
+
+	mutex_unlock(&yaffs_context_lock);
+
+	return count;
+}
+
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(3, 14, 0))
+static int yaffs_proc_write(struct file *file, const char *buf,
+			    unsigned long count, void *ppos)
+#else
+static ssize_t yaffs_proc_write(struct file *file, const char __user *buf,
+			    size_t count, loff_t *ppos)
+#endif
+{
+	if (buf[0] == '.')
+		return yaffs_proc_debug_write(file, buf, count);
+	return yaffs_proc_write_trace_options(file, buf, count);
+}
+
+/* Stuff to handle installation of file systems */
+struct file_system_to_install {
+	struct file_system_type *fst;
+	int installed;
+};
+
+static struct file_system_to_install fs_to_install[] = {
+	{&yaffs_fs_type, 0},
+	{&yaffs2_fs_type, 0},
+	{NULL, 0}
+};
+
+
+#ifdef YAFFS_NEW_PROCFS
+static int yaffs_proc_show(struct seq_file *m, void *v)
+{
+	/* FIXME: Unify in a better way? */
+	char buffer[512];
+	char *start;
+	int len;
+
+	len = yaffs_proc_read(buffer, &start, 0, sizeof(buffer), NULL, NULL);
+	seq_puts(m, buffer);
+	return 0;
+}
+
+static int yaffs_proc_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, yaffs_proc_show, NULL);
+}
+
+static struct file_operations procfs_ops = {
+	.owner = THIS_MODULE,
+	.open  = yaffs_proc_open,
+	.read  = seq_read,
+	.write = yaffs_proc_write,
+};
+
+static int yaffs_procfs_init(void)
+{
+	/* Install the proc_fs entries */
+	my_proc_entry = proc_create("yaffs",
+				    S_IRUGO | S_IFREG,
+				    YPROC_ROOT,
+				    &procfs_ops);
+
+	if (my_proc_entry) {
+		return 0;
+	} else {
+		return -ENOMEM;
+	}
+}
+
+#else
+
+
+static int yaffs_procfs_init(void)
+{
+	/* Install the proc_fs entries */
+	my_proc_entry = create_proc_entry("yaffs",
+					  S_IRUGO | S_IFREG, YPROC_ROOT);
+
+	if (my_proc_entry) {
+		my_proc_entry->write_proc = yaffs_proc_write;
+		my_proc_entry->read_proc = yaffs_proc_read;
+		my_proc_entry->data = NULL;
+		return 0;
+	} else {
+		return -ENOMEM;
+	}
+}
+
+#endif
+
+
+static int __init init_yaffs_fs(void)
+{
+	int error = 0;
+	struct file_system_to_install *fsinst;
+
+	yaffs_trace(YAFFS_TRACE_ALWAYS,
+		"yaffs Installing.");
+
+	mutex_init(&yaffs_context_lock);
+
+	error = yaffs_procfs_init();
+	if (error)
+		return error;
+
+	/* Now add the file system entries */
+
+	fsinst = fs_to_install;
+
+	while (fsinst->fst && !error) {
+		error = register_filesystem(fsinst->fst);
+		if (!error)
+			fsinst->installed = 1;
+		fsinst++;
+	}
+
+	/* Any errors? uninstall  */
+	if (error) {
+		fsinst = fs_to_install;
+
+		while (fsinst->fst) {
+			if (fsinst->installed) {
+				unregister_filesystem(fsinst->fst);
+				fsinst->installed = 0;
+			}
+			fsinst++;
+		}
+	}
+
+	return error;
+}
+
+static void __exit exit_yaffs_fs(void)
+{
+
+	struct file_system_to_install *fsinst;
+
+	yaffs_trace(YAFFS_TRACE_ALWAYS,
+		"yaffs removing.");
+
+	remove_proc_entry("yaffs", YPROC_ROOT);
+
+	fsinst = fs_to_install;
+
+	while (fsinst->fst) {
+		if (fsinst->installed) {
+			unregister_filesystem(fsinst->fst);
+			fsinst->installed = 0;
+		}
+		fsinst++;
+	}
+}
+
+module_init(init_yaffs_fs)
+    module_exit(exit_yaffs_fs)
+
+    MODULE_DESCRIPTION("YAFFS2 - a NAND specific flash file system");
+MODULE_AUTHOR("Charles Manning, Aleph One Ltd., 2002-2011");
+MODULE_LICENSE("GPL");
diff --git a/fs/yaffs2/yaffs_yaffs1.c b/fs/yaffs2/yaffs_yaffs1.c
new file mode 100644
index 00000000..1dd4db9
--- /dev/null
+++ b/fs/yaffs2/yaffs_yaffs1.c
@@ -0,0 +1,423 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yaffs_yaffs1.h"
+#include "yportenv.h"
+#include "yaffs_trace.h"
+#include "yaffs_bitmap.h"
+#include "yaffs_getblockinfo.h"
+#include "yaffs_nand.h"
+#include "yaffs_attribs.h"
+
+int yaffs1_scan(struct yaffs_dev *dev)
+{
+	struct yaffs_ext_tags tags;
+	u32 blk;
+	int result;
+	int chunk;
+	u32 c;
+	int deleted;
+	enum yaffs_block_state state;
+	LIST_HEAD(hard_list);
+	struct yaffs_block_info *bi;
+	u32 seq_number;
+	struct yaffs_obj_hdr *oh;
+	struct yaffs_obj *in;
+	struct yaffs_obj *parent;
+	int alloc_failed = 0;
+	struct yaffs_shadow_fixer *shadow_fixers = NULL;
+	u8 *chunk_data;
+
+	yaffs_trace(YAFFS_TRACE_SCAN,
+		"yaffs1_scan starts  intstartblk %d intendblk %d...",
+		dev->internal_start_block, dev->internal_end_block);
+
+	chunk_data = yaffs_get_temp_buffer(dev);
+
+	dev->seq_number = YAFFS_LOWEST_SEQUENCE_NUMBER;
+
+	/* Scan all the blocks to determine their state */
+	bi = dev->block_info;
+	for (blk = dev->internal_start_block; blk <= dev->internal_end_block;
+	     blk++) {
+		yaffs_clear_chunk_bits(dev, blk);
+		bi->pages_in_use = 0;
+		bi->soft_del_pages = 0;
+
+		yaffs_query_init_block_state(dev, blk, &state, &seq_number);
+
+		bi->block_state = state;
+		bi->seq_number = seq_number;
+
+		if (bi->seq_number == YAFFS_SEQUENCE_BAD_BLOCK)
+			bi->block_state = state = YAFFS_BLOCK_STATE_DEAD;
+
+		yaffs_trace(YAFFS_TRACE_SCAN_DEBUG,
+			"Block scanning block %d state %d seq %d",
+			blk, state, seq_number);
+
+		if (state == YAFFS_BLOCK_STATE_DEAD) {
+			yaffs_trace(YAFFS_TRACE_BAD_BLOCKS,
+				"block %d is bad", blk);
+		} else if (state == YAFFS_BLOCK_STATE_EMPTY) {
+			yaffs_trace(YAFFS_TRACE_SCAN_DEBUG, "Block empty ");
+			dev->n_erased_blocks++;
+			dev->n_free_chunks += dev->param.chunks_per_block;
+		}
+		bi++;
+	}
+
+	/* For each block.... */
+	for (blk = dev->internal_start_block;
+	     !alloc_failed && blk <= dev->internal_end_block; blk++) {
+
+		cond_resched();
+
+		bi = yaffs_get_block_info(dev, blk);
+		state = bi->block_state;
+
+		deleted = 0;
+
+		/* For each chunk in each block that needs scanning.... */
+		for (c = 0;
+			!alloc_failed && c < dev->param.chunks_per_block &&
+			state == YAFFS_BLOCK_STATE_NEEDS_SCAN; c++) {
+			/* Read the tags and decide what to do */
+			chunk = blk * dev->param.chunks_per_block + c;
+
+			result = yaffs_rd_chunk_tags_nand(dev, chunk, NULL,
+							  &tags);
+
+			if (result != YAFFS_OK)
+				continue;
+			/* Let's have a good look at this chunk... */
+
+			if (tags.ecc_result == YAFFS_ECC_RESULT_UNFIXED ||
+			    tags.is_deleted) {
+				/* YAFFS1 only...
+				 * A deleted chunk
+				 */
+				deleted++;
+				dev->n_free_chunks++;
+			} else if (!tags.chunk_used) {
+				/* An unassigned chunk in the block
+				 * This means that either the block is empty or
+				 * this is the one being allocated from
+				 */
+
+				if (c == 0) {
+					/* We're looking at the first chunk in
+					 *the block so the block is unused */
+					state = YAFFS_BLOCK_STATE_EMPTY;
+					dev->n_erased_blocks++;
+				} else {
+					/* this is the block being allocated */
+					yaffs_trace(YAFFS_TRACE_SCAN,
+						" Allocating from %d %d",
+						blk, c);
+					state = YAFFS_BLOCK_STATE_ALLOCATING;
+					dev->alloc_block = blk;
+					dev->alloc_page = c;
+					dev->alloc_block_finder = blk;
+
+				}
+
+				dev->n_free_chunks +=
+				    (dev->param.chunks_per_block - c);
+			} else if (tags.chunk_id > 0) {
+				/* chunk_id > 0 so it is a data chunk... */
+				unsigned int endpos;
+
+				yaffs_set_chunk_bit(dev, blk, c);
+				bi->pages_in_use++;
+
+				in = yaffs_find_or_create_by_number(dev,
+							tags.obj_id,
+							YAFFS_OBJECT_TYPE_FILE);
+				/* PutChunkIntoFile checks for a clash
+				 * (two data chunks with the same chunk_id).
+				 */
+
+				if (!in)
+					alloc_failed = 1;
+
+				if (in) {
+					if (!yaffs_put_chunk_in_file
+					    (in, tags.chunk_id, chunk, 1))
+						alloc_failed = 1;
+				}
+
+				endpos =
+				    (tags.chunk_id - 1) *
+				    dev->data_bytes_per_chunk +
+				    tags.n_bytes;
+				if (in &&
+				    in->variant_type ==
+				     YAFFS_OBJECT_TYPE_FILE &&
+				    in->variant.file_variant.stored_size <
+				      endpos) {
+					in->variant.file_variant.stored_size =
+					    endpos;
+					if (!dev->param.use_header_file_size) {
+						in->variant.
+						    file_variant.file_size =
+						    in->variant.
+						    file_variant.stored_size;
+					}
+
+				}
+			} else {
+				/* chunk_id == 0, so it is an ObjectHeader.
+				 * Make the object
+				 */
+				yaffs_set_chunk_bit(dev, blk, c);
+				bi->pages_in_use++;
+
+				result = yaffs_rd_chunk_tags_nand(dev, chunk,
+								  chunk_data,
+								  NULL);
+
+				oh = (struct yaffs_obj_hdr *)chunk_data;
+
+				in = yaffs_find_by_number(dev, tags.obj_id);
+				if (in && in->variant_type != oh->type) {
+					/* This should not happen, but somehow
+					 * Wev'e ended up with an obj_id that
+					 * has been reused but not yet deleted,
+					 * and worse still it has changed type.
+					 * Delete the old object.
+					 */
+
+					yaffs_del_obj(in);
+					in = NULL;
+				}
+
+				in = yaffs_find_or_create_by_number(dev,
+								tags.obj_id,
+								oh->type);
+
+				if (!in)
+					alloc_failed = 1;
+
+				if (in && oh->shadows_obj > 0) {
+
+					struct yaffs_shadow_fixer *fixer;
+					fixer =
+						kmalloc(sizeof
+						(struct yaffs_shadow_fixer),
+						GFP_NOFS);
+					if (fixer) {
+						fixer->next = shadow_fixers;
+						shadow_fixers = fixer;
+						fixer->obj_id = tags.obj_id;
+						fixer->shadowed_id =
+						    oh->shadows_obj;
+						yaffs_trace(YAFFS_TRACE_SCAN,
+							" Shadow fixer: %d shadows %d",
+							fixer->obj_id,
+							fixer->shadowed_id);
+
+					}
+
+				}
+
+				if (in && in->valid) {
+					/* We have already filled this one.
+					 * We have a duplicate and need to
+					 * resolve it. */
+
+					unsigned existing_serial = in->serial;
+					unsigned new_serial =
+					    tags.serial_number;
+
+					if (((existing_serial + 1) & 3) ==
+					    new_serial) {
+						/* Use new one - destroy the
+						 * exisiting one */
+						yaffs_chunk_del(dev,
+								in->hdr_chunk,
+								1, __LINE__);
+						in->valid = 0;
+					} else {
+						/* Use existing - destroy
+						 * this one. */
+						yaffs_chunk_del(dev, chunk, 1,
+								__LINE__);
+					}
+				}
+
+				if (in && !in->valid &&
+				    (tags.obj_id == YAFFS_OBJECTID_ROOT ||
+				     tags.obj_id ==
+				     YAFFS_OBJECTID_LOSTNFOUND)) {
+					/* We only load some info, don't fiddle
+					 * with directory structure */
+					in->valid = 1;
+					in->variant_type = oh->type;
+
+					in->yst_mode = oh->yst_mode;
+					yaffs_load_attribs(in, oh);
+					in->hdr_chunk = chunk;
+					in->serial = tags.serial_number;
+
+				} else if (in && !in->valid) {
+					/* we need to load this info */
+
+					in->valid = 1;
+					in->variant_type = oh->type;
+
+					in->yst_mode = oh->yst_mode;
+					yaffs_load_attribs(in, oh);
+					in->hdr_chunk = chunk;
+					in->serial = tags.serial_number;
+
+					yaffs_set_obj_name_from_oh(in, oh);
+					in->dirty = 0;
+
+					/* directory stuff...
+					 * hook up to parent
+					 */
+
+					parent =
+					    yaffs_find_or_create_by_number
+					    (dev, oh->parent_obj_id,
+					     YAFFS_OBJECT_TYPE_DIRECTORY);
+					if (!parent)
+						alloc_failed = 1;
+					if (parent && parent->variant_type ==
+					    YAFFS_OBJECT_TYPE_UNKNOWN) {
+						/* Set up as a directory */
+						parent->variant_type =
+						    YAFFS_OBJECT_TYPE_DIRECTORY;
+						INIT_LIST_HEAD(&parent->
+							variant.dir_variant.
+							children);
+					} else if (!parent ||
+						parent->variant_type !=
+						YAFFS_OBJECT_TYPE_DIRECTORY) {
+						/* Hoosterman, a problem....
+						 * We're trying to use a
+						 * non-directory as a directory
+						 */
+
+						yaffs_trace(YAFFS_TRACE_ERROR,
+							"yaffs tragedy: attempting to use non-directory as a directory in scan. Put in lost+found."
+							);
+						parent = dev->lost_n_found;
+					}
+
+					yaffs_add_obj_to_dir(parent, in);
+
+					switch (in->variant_type) {
+					case YAFFS_OBJECT_TYPE_UNKNOWN:
+						/* Todo got a problem */
+						break;
+					case YAFFS_OBJECT_TYPE_FILE:
+						if (dev->param.
+						    use_header_file_size)
+							in->variant.
+							file_variant.file_size
+							= yaffs_oh_to_size(dev, oh, 0);
+						break;
+					case YAFFS_OBJECT_TYPE_HARDLINK:
+						in->variant.
+						    hardlink_variant.equiv_id =
+						    oh->equiv_id;
+						list_add(&in->hard_links,
+								&hard_list);
+						break;
+					case YAFFS_OBJECT_TYPE_DIRECTORY:
+						/* Do nothing */
+						break;
+					case YAFFS_OBJECT_TYPE_SPECIAL:
+						/* Do nothing */
+						break;
+					case YAFFS_OBJECT_TYPE_SYMLINK:
+						in->variant.symlink_variant.
+						    alias =
+						    yaffs_clone_str(oh->alias);
+						if (!in->variant.
+						    symlink_variant.alias)
+							alloc_failed = 1;
+						break;
+					}
+				}
+			}
+		}
+
+		if (state == YAFFS_BLOCK_STATE_NEEDS_SCAN) {
+			/* If we got this far while scanning,
+			 * then the block is fully allocated. */
+			state = YAFFS_BLOCK_STATE_FULL;
+		}
+
+		if (state == YAFFS_BLOCK_STATE_ALLOCATING) {
+			/* If the block was partially allocated then
+			 * treat it as fully allocated. */
+			state = YAFFS_BLOCK_STATE_FULL;
+			dev->alloc_block = -1;
+		}
+
+		bi->block_state = state;
+
+		/* Now let's see if it was dirty */
+		if (bi->pages_in_use == 0 &&
+		    !bi->has_shrink_hdr &&
+		    bi->block_state == YAFFS_BLOCK_STATE_FULL)
+			yaffs_block_became_dirty(dev, blk);
+	}
+
+	/* Ok, we've done all the scanning.
+	 * Fix up the hard link chains.
+	 * We should now have scanned all the objects, now it's time to add
+	 * these hardlinks.
+	 */
+
+	yaffs_link_fixup(dev, &hard_list);
+
+	/*
+	 * Fix up any shadowed objects.
+	 * There should not be more than one of these.
+	 */
+	{
+		struct yaffs_shadow_fixer *fixer;
+		struct yaffs_obj *obj;
+
+		while (shadow_fixers) {
+			fixer = shadow_fixers;
+			shadow_fixers = fixer->next;
+			/* Complete the rename transaction by deleting the
+			 * shadowed object then setting the object header
+			 to unshadowed.
+			 */
+			obj = yaffs_find_by_number(dev, fixer->shadowed_id);
+			if (obj)
+				yaffs_del_obj(obj);
+
+			obj = yaffs_find_by_number(dev, fixer->obj_id);
+
+			if (obj)
+				yaffs_update_oh(obj, NULL, 1, 0, 0, NULL);
+
+			kfree(fixer);
+		}
+	}
+
+	yaffs_release_temp_buffer(dev, chunk_data);
+
+	if (alloc_failed)
+		return YAFFS_FAIL;
+
+	yaffs_trace(YAFFS_TRACE_SCAN, "yaffs1_scan ends");
+
+	return YAFFS_OK;
+}
diff --git a/fs/yaffs2/yaffs_yaffs1.h b/fs/yaffs2/yaffs_yaffs1.h
new file mode 100644
index 00000000..051e41c
--- /dev/null
+++ b/fs/yaffs2/yaffs_yaffs1.h
@@ -0,0 +1,21 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_YAFFS1_H__
+#define __YAFFS_YAFFS1_H__
+
+#include "yaffs_guts.h"
+int yaffs1_scan(struct yaffs_dev *dev);
+
+#endif
diff --git a/fs/yaffs2/yaffs_yaffs2.c b/fs/yaffs2/yaffs_yaffs2.c
new file mode 100644
index 00000000..9eb42f7
--- /dev/null
+++ b/fs/yaffs2/yaffs_yaffs2.c
@@ -0,0 +1,1711 @@
+/*
+ * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include "yaffs_guts.h"
+#include "yaffs_trace.h"
+#include "yaffs_yaffs2.h"
+#include "yaffs_checkptrw.h"
+#include "yaffs_bitmap.h"
+#include "yaffs_nand.h"
+#include "yaffs_getblockinfo.h"
+#include "yaffs_verify.h"
+#include "yaffs_attribs.h"
+#include "yaffs_summary.h"
+#include "yaffs_endian.h"
+
+/*
+ * Checkpoints are really no benefit on very small partitions.
+ *
+ * To save space on small partitions don't bother with checkpoints unless
+ * the partition is at least this big.
+ */
+#define YAFFS_CHECKPOINT_MIN_BLOCKS 60
+#define YAFFS_SMALL_HOLE_THRESHOLD 4
+
+/*
+ * Oldest Dirty Sequence Number handling.
+ */
+
+/* yaffs_calc_oldest_dirty_seq()
+ * yaffs2_find_oldest_dirty_seq()
+ * Calculate the oldest dirty sequence number if we don't know it.
+ */
+void yaffs_calc_oldest_dirty_seq(struct yaffs_dev *dev)
+{
+	u32 i;
+	unsigned seq;
+	unsigned block_no = 0;
+	struct yaffs_block_info *b;
+
+	if (!dev->param.is_yaffs2)
+		return;
+
+	/* Find the oldest dirty sequence number. */
+	seq = dev->seq_number + 1;
+	b = dev->block_info;
+	for (i = dev->internal_start_block; i <= dev->internal_end_block; i++) {
+		if (b->block_state == YAFFS_BLOCK_STATE_FULL &&
+		    (u32)(b->pages_in_use - b->soft_del_pages) <
+		    dev->param.chunks_per_block &&
+		    b->seq_number < seq) {
+			seq = b->seq_number;
+			block_no = i;
+		}
+		b++;
+	}
+
+	if (block_no) {
+		dev->oldest_dirty_seq = seq;
+		dev->oldest_dirty_block = block_no;
+	}
+}
+
+void yaffs2_find_oldest_dirty_seq(struct yaffs_dev *dev)
+{
+	if (!dev->param.is_yaffs2)
+		return;
+
+	if (!dev->oldest_dirty_seq)
+		yaffs_calc_oldest_dirty_seq(dev);
+}
+
+/*
+ * yaffs_clear_oldest_dirty_seq()
+ * Called when a block is erased or marked bad. (ie. when its seq_number
+ * becomes invalid). If the value matches the oldest then we clear
+ * dev->oldest_dirty_seq to force its recomputation.
+ */
+void yaffs2_clear_oldest_dirty_seq(struct yaffs_dev *dev,
+				   struct yaffs_block_info *bi)
+{
+
+	if (!dev->param.is_yaffs2)
+		return;
+
+	if (!bi || bi->seq_number == dev->oldest_dirty_seq) {
+		dev->oldest_dirty_seq = 0;
+		dev->oldest_dirty_block = 0;
+	}
+}
+
+/*
+ * yaffs2_update_oldest_dirty_seq()
+ * Update the oldest dirty sequence number whenever we dirty a block.
+ * Only do this if the oldest_dirty_seq is actually being tracked.
+ */
+void yaffs2_update_oldest_dirty_seq(struct yaffs_dev *dev, unsigned block_no,
+				    struct yaffs_block_info *bi)
+{
+	if (!dev->param.is_yaffs2)
+		return;
+
+	if (dev->oldest_dirty_seq) {
+		if (dev->oldest_dirty_seq > bi->seq_number) {
+			dev->oldest_dirty_seq = bi->seq_number;
+			dev->oldest_dirty_block = block_no;
+		}
+	}
+}
+
+int yaffs_block_ok_for_gc(struct yaffs_dev *dev, struct yaffs_block_info *bi)
+{
+
+	if (!dev->param.is_yaffs2)
+		return 1;	/* disqualification only applies to yaffs2. */
+
+	if (!bi->has_shrink_hdr)
+		return 1;	/* can gc */
+
+	yaffs2_find_oldest_dirty_seq(dev);
+
+	/* Can't do gc of this block if there are any blocks older than this
+	 * one that have discarded pages.
+	 */
+	return (bi->seq_number <= dev->oldest_dirty_seq);
+}
+
+/*
+ * yaffs2_find_refresh_block()
+ * periodically finds the oldest full block by sequence number for refreshing.
+ * Only for yaffs2.
+ */
+u32 yaffs2_find_refresh_block(struct yaffs_dev *dev)
+{
+	u32 b;
+	u32 oldest = 0;
+	u32 oldest_seq = 0;
+	struct yaffs_block_info *bi;
+
+	if (!dev->param.is_yaffs2)
+		return oldest;
+
+	/*
+	 * If refresh period < 10 then refreshing is disabled.
+	 */
+	if (dev->param.refresh_period < 10)
+		return oldest;
+
+	/*
+	 * Fix broken values.
+	 */
+	if (dev->refresh_skip > dev->param.refresh_period)
+		dev->refresh_skip = dev->param.refresh_period;
+
+	if (dev->refresh_skip > 0)
+		return oldest;
+
+	/*
+	 * Refresh skip is now zero.
+	 * We'll do a refresh this time around....
+	 * Update the refresh skip and find the oldest block.
+	 */
+	dev->refresh_skip = dev->param.refresh_period;
+	dev->refresh_count++;
+	bi = dev->block_info;
+	for (b = dev->internal_start_block; b <= dev->internal_end_block; b++) {
+
+		if (bi->block_state == YAFFS_BLOCK_STATE_FULL) {
+
+			if (oldest < 1 || bi->seq_number < oldest_seq) {
+				oldest = b;
+				oldest_seq = bi->seq_number;
+			}
+		}
+		bi++;
+	}
+
+	if (oldest > 0) {
+		yaffs_trace(YAFFS_TRACE_GC,
+			"GC refresh count %d selected block %d with seq_number %d",
+			dev->refresh_count, oldest, oldest_seq);
+	}
+
+	return oldest;
+}
+
+int yaffs2_checkpt_required(struct yaffs_dev *dev)
+{
+	int nblocks;
+
+	if (!dev->param.is_yaffs2)
+		return 0;
+
+	nblocks = dev->internal_end_block - dev->internal_start_block + 1;
+
+	return !dev->param.skip_checkpt_wr &&
+	    !dev->read_only && (nblocks >= YAFFS_CHECKPOINT_MIN_BLOCKS);
+}
+
+int yaffs_calc_checkpt_blocks_required(struct yaffs_dev *dev)
+{
+	int retval;
+	int n_bytes = 0;
+	int n_blocks;
+	int dev_blocks;
+
+	if (!dev->param.is_yaffs2)
+		return 0;
+
+	if (!dev->checkpoint_blocks_required && yaffs2_checkpt_required(dev)) {
+		/* Not a valid value so recalculate */
+		dev_blocks = dev->param.end_block - dev->param.start_block + 1;
+		n_bytes += sizeof(struct yaffs_checkpt_validity);
+		n_bytes += sizeof(struct yaffs_checkpt_dev);
+		n_bytes += dev_blocks * sizeof(struct yaffs_block_info);
+		n_bytes += dev_blocks * dev->chunk_bit_stride;
+		n_bytes +=
+		    (sizeof(struct yaffs_checkpt_obj) + sizeof(u32)) *
+		    dev->n_obj;
+		n_bytes += (dev->tnode_size + sizeof(u32)) * dev->n_tnodes;
+		n_bytes += sizeof(struct yaffs_checkpt_validity);
+		n_bytes += sizeof(u32);	/* checksum */
+
+		/* Round up and add 2 blocks to allow for some bad blocks,
+		 * so add 3 */
+
+		n_blocks =
+		    (n_bytes /
+		     (dev->data_bytes_per_chunk *
+		      dev->param.chunks_per_block)) + 3;
+
+		dev->checkpoint_blocks_required = n_blocks;
+	}
+
+	retval = dev->checkpoint_blocks_required - dev->blocks_in_checkpt;
+	if (retval < 0)
+		retval = 0;
+	return retval;
+}
+
+/*--------------------- Checkpointing --------------------*/
+
+static void yaffs2_do_endian_validity_marker(struct yaffs_dev *dev,
+					     struct yaffs_checkpt_validity *v)
+{
+
+	if (!dev->swap_endian)
+		return;
+	v->struct_type = swap_s32(v->struct_type);
+	v->magic = swap_u32(v->magic);
+	v->version = swap_u32(v->version);
+	v->head = swap_u32(v->head);
+}
+
+static int yaffs2_wr_checkpt_validity_marker(struct yaffs_dev *dev, int head)
+{
+	struct yaffs_checkpt_validity cp;
+
+	memset(&cp, 0, sizeof(cp));
+
+	cp.struct_type = sizeof(cp);
+	cp.magic = YAFFS_MAGIC;
+	cp.version = YAFFS_CHECKPOINT_VERSION;
+	cp.head = (head) ? 1 : 0;
+
+	yaffs2_do_endian_validity_marker(dev, &cp);
+
+	return (yaffs2_checkpt_wr(dev, &cp, sizeof(cp)) == sizeof(cp)) ? 1 : 0;
+}
+
+static int yaffs2_rd_checkpt_validity_marker(struct yaffs_dev *dev, int head)
+{
+	struct yaffs_checkpt_validity cp;
+	int ok;
+
+	ok = (yaffs2_checkpt_rd(dev, &cp, sizeof(cp)) == sizeof(cp));
+	yaffs2_do_endian_validity_marker(dev, &cp);
+
+	if (ok)
+		ok = (cp.struct_type == sizeof(cp)) &&
+		    (cp.magic == YAFFS_MAGIC) &&
+		    (cp.version == YAFFS_CHECKPOINT_VERSION) &&
+		    (cp.head == ((head) ? 1 : 0));
+	return ok ? 1 : 0;
+}
+
+static void yaffs2_dev_to_checkpt_dev(struct yaffs_checkpt_dev *cp,
+				      struct yaffs_dev *dev)
+{
+	cp->struct_type = sizeof(*cp);
+
+	cp->n_erased_blocks = dev->n_erased_blocks;
+	cp->alloc_block = dev->alloc_block;
+	cp->alloc_page = dev->alloc_page;
+	cp->n_free_chunks = dev->n_free_chunks;
+
+	cp->n_deleted_files = dev->n_deleted_files;
+	cp->n_unlinked_files = dev->n_unlinked_files;
+	cp->n_bg_deletions = dev->n_bg_deletions;
+	cp->seq_number = dev->seq_number;
+
+}
+
+static void yaffs_checkpt_dev_to_dev(struct yaffs_dev *dev,
+				     struct yaffs_checkpt_dev *cp)
+{
+	dev->n_erased_blocks = cp->n_erased_blocks;
+	dev->alloc_block = cp->alloc_block;
+	dev->alloc_page = cp->alloc_page;
+	dev->n_free_chunks = cp->n_free_chunks;
+
+	dev->n_deleted_files = cp->n_deleted_files;
+	dev->n_unlinked_files = cp->n_unlinked_files;
+	dev->n_bg_deletions = cp->n_bg_deletions;
+	dev->seq_number = cp->seq_number;
+}
+
+static void yaffs2_do_endian_checkpt_dev(struct yaffs_dev *dev,
+				     struct yaffs_checkpt_dev *cp)
+{
+	if (!dev->swap_endian)
+		return;
+	cp->struct_type = swap_s32(cp->struct_type);
+	cp->n_erased_blocks = swap_s32(cp->n_erased_blocks);
+	cp->alloc_block = swap_s32(cp->alloc_block);
+	cp->alloc_page = swap_u32(cp->alloc_page);
+	cp->n_free_chunks = swap_s32(cp->n_free_chunks);
+	cp->n_deleted_files = swap_s32(cp->n_deleted_files);
+	cp->n_unlinked_files = swap_s32(cp->n_unlinked_files);
+	cp->n_bg_deletions = swap_s32(cp->n_bg_deletions);
+}
+
+static int yaffs2_wr_checkpt_dev(struct yaffs_dev *dev)
+{
+	struct yaffs_checkpt_dev cp;
+	u32 n_bytes;
+	u32 n_blocks = dev->internal_end_block - dev->internal_start_block + 1;
+	int ok;
+	u32 i;
+	union yaffs_block_info_union bu;
+
+	/* Write device runtime values */
+	yaffs2_dev_to_checkpt_dev(&cp, dev);
+	yaffs2_do_endian_checkpt_dev(dev, &cp);
+
+	ok = (yaffs2_checkpt_wr(dev, &cp, sizeof(cp)) == sizeof(cp));
+	if (!ok)
+		return 0;
+
+	/* Write block info. */
+	if (!dev->swap_endian) {
+		n_bytes = n_blocks * sizeof(struct yaffs_block_info);
+		ok = (yaffs2_checkpt_wr(dev, dev->block_info, n_bytes) ==
+			(int)n_bytes);
+	} else {
+		/*
+		 * Need to swap the endianisms. We can't do this in place
+		 * since that would damage live data,
+		 * so write one block info at a time using a copy.
+		 */
+		for (i = 0; i < n_blocks && ok; i++) {
+			bu.bi = dev->block_info[i];
+			bu.as_u32[0] = swap_u32(bu.as_u32[0]);
+			bu.as_u32[1] = swap_u32(bu.as_u32[1]);
+			ok = (yaffs2_checkpt_wr(dev, &bu, sizeof(bu)) == sizeof(bu));
+		}
+	}
+
+	if (!ok)
+		return 0;
+
+	/*
+	 * Write chunk bits. Chunk bits are in bytes so
+	 * no endian conversion is needed.
+	 */
+	n_bytes = n_blocks * dev->chunk_bit_stride;
+	ok = (yaffs2_checkpt_wr(dev, dev->chunk_bits, n_bytes) ==
+		(int)n_bytes);
+
+	return ok ? 1 : 0;
+}
+
+static int yaffs2_rd_checkpt_dev(struct yaffs_dev *dev)
+{
+	struct yaffs_checkpt_dev cp;
+	u32 n_bytes;
+	u32 n_blocks =
+	    (dev->internal_end_block - dev->internal_start_block + 1);
+	int ok;
+
+	ok = (yaffs2_checkpt_rd(dev, &cp, sizeof(cp)) == sizeof(cp));
+	if (!ok)
+		return 0;
+	yaffs2_do_endian_checkpt_dev(dev, &cp);
+
+	if (cp.struct_type != sizeof(cp))
+		return 0;
+
+	yaffs_checkpt_dev_to_dev(dev, &cp);
+
+	n_bytes = n_blocks * sizeof(struct yaffs_block_info);
+
+	ok = (yaffs2_checkpt_rd(dev, dev->block_info, n_bytes) ==
+		(int)n_bytes);
+
+	if (!ok)
+		return 0;
+
+	if (dev->swap_endian) {
+		/* The block info can just be handled as a list of u32s. */
+		u32 *as_u32 = (u32 *) dev->block_info;
+		u32 n_u32s = n_bytes/sizeof(u32);
+		u32 i;
+
+		for (i=0; i < n_u32s; i++)
+			as_u32[i] = swap_u32(as_u32[i]);
+	}
+
+	n_bytes = n_blocks * dev->chunk_bit_stride;
+
+	ok = (yaffs2_checkpt_rd(dev, dev->chunk_bits, n_bytes) ==
+		(int)n_bytes);
+
+
+	return ok ? 1 : 0;
+}
+
+
+static void yaffs2_checkpt_obj_bit_assign(struct yaffs_checkpt_obj *cp,
+					  int bit_offset,
+					  int bit_width,
+					  u32 value)
+{
+	u32 and_mask;
+
+	and_mask = ((1<<bit_width)-1) << bit_offset;
+
+	cp->bit_field &= ~and_mask;
+	cp->bit_field |= ((value << bit_offset) & and_mask);
+}
+
+static u32 yaffs2_checkpt_obj_bit_get(struct yaffs_checkpt_obj *cp,
+				      int bit_offset,
+				      int bit_width)
+{
+	u32 and_mask;
+
+	and_mask = ((1<<bit_width)-1);
+
+	return (cp->bit_field >> bit_offset) & and_mask;
+}
+
+static void yaffs2_obj_checkpt_obj(struct yaffs_checkpt_obj *cp,
+				   struct yaffs_obj *obj)
+{
+	cp->obj_id = obj->obj_id;
+	cp->parent_id = (obj->parent) ? obj->parent->obj_id : 0;
+	cp->hdr_chunk = obj->hdr_chunk;
+
+	yaffs2_checkpt_obj_bit_assign(cp, CHECKPOINT_VARIANT_BITS, obj->variant_type);
+	yaffs2_checkpt_obj_bit_assign(cp, CHECKPOINT_DELETED_BITS, obj->deleted);
+	yaffs2_checkpt_obj_bit_assign(cp, CHECKPOINT_SOFT_DEL_BITS, obj->soft_del);
+	yaffs2_checkpt_obj_bit_assign(cp, CHECKPOINT_UNLINKED_BITS, obj->unlinked);
+	yaffs2_checkpt_obj_bit_assign(cp, CHECKPOINT_FAKE_BITS, obj->fake);
+	yaffs2_checkpt_obj_bit_assign(cp, CHECKPOINT_RENAME_ALLOWED_BITS, obj->rename_allowed);
+	yaffs2_checkpt_obj_bit_assign(cp, CHECKPOINT_UNLINK_ALLOWED_BITS, obj->unlink_allowed);
+	yaffs2_checkpt_obj_bit_assign(cp, CHECKPOINT_SERIAL_BITS, obj->serial);
+
+	cp->n_data_chunks = obj->n_data_chunks;
+
+	if (obj->variant_type == YAFFS_OBJECT_TYPE_FILE)
+		cp->size_or_equiv_obj = obj->variant.file_variant.file_size;
+	else if (obj->variant_type == YAFFS_OBJECT_TYPE_HARDLINK)
+		cp->size_or_equiv_obj = obj->variant.hardlink_variant.equiv_id;
+}
+
+static int yaffs2_checkpt_obj_to_obj(struct yaffs_obj *obj,
+				     struct yaffs_checkpt_obj *cp)
+{
+	struct yaffs_obj *parent;
+	u32 cp_variant_type = yaffs2_checkpt_obj_bit_get(cp, CHECKPOINT_VARIANT_BITS);
+
+	if (obj->variant_type != cp_variant_type) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"Checkpoint read object %d type %d chunk %d does not match existing object type %d",
+			cp->obj_id, cp_variant_type, cp->hdr_chunk,
+			obj->variant_type);
+		return 0;
+	}
+
+	obj->obj_id = cp->obj_id;
+
+	if (cp->parent_id)
+		parent = yaffs_find_or_create_by_number(obj->my_dev,
+						cp->parent_id,
+						YAFFS_OBJECT_TYPE_DIRECTORY);
+	else
+		parent = NULL;
+
+	if (parent) {
+		if (parent->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+			yaffs_trace(YAFFS_TRACE_ALWAYS,
+				"Checkpoint read object %d parent %d type %d chunk %d Parent type, %d, not directory",
+				cp->obj_id, cp->parent_id,
+				cp_variant_type, cp->hdr_chunk,
+				parent->variant_type);
+			return 0;
+		}
+		yaffs_add_obj_to_dir(parent, obj);
+	}
+
+	obj->hdr_chunk = cp->hdr_chunk;
+
+	obj->variant_type = yaffs2_checkpt_obj_bit_get(cp, CHECKPOINT_VARIANT_BITS);
+	obj->deleted = yaffs2_checkpt_obj_bit_get(cp, CHECKPOINT_DELETED_BITS);
+	obj->soft_del = yaffs2_checkpt_obj_bit_get(cp, CHECKPOINT_SOFT_DEL_BITS);
+	obj->unlinked = yaffs2_checkpt_obj_bit_get(cp, CHECKPOINT_UNLINKED_BITS);
+	obj->fake = yaffs2_checkpt_obj_bit_get(cp, CHECKPOINT_FAKE_BITS);
+	obj->rename_allowed = yaffs2_checkpt_obj_bit_get(cp, CHECKPOINT_RENAME_ALLOWED_BITS);
+	obj->unlink_allowed = yaffs2_checkpt_obj_bit_get(cp, CHECKPOINT_UNLINK_ALLOWED_BITS);
+	obj->serial = yaffs2_checkpt_obj_bit_get(cp, CHECKPOINT_SERIAL_BITS);
+
+	obj->n_data_chunks = cp->n_data_chunks;
+
+	if (obj->variant_type == YAFFS_OBJECT_TYPE_FILE) {
+		obj->variant.file_variant.file_size = cp->size_or_equiv_obj;
+		obj->variant.file_variant.stored_size = cp->size_or_equiv_obj;
+	} else if (obj->variant_type == YAFFS_OBJECT_TYPE_HARDLINK) {
+		obj->variant.hardlink_variant.equiv_id = cp->size_or_equiv_obj;
+	}
+	if (obj->hdr_chunk > 0)
+		obj->lazy_loaded = 1;
+	return 1;
+}
+
+static void yaffs2_do_endian_tnode(struct yaffs_dev *dev, struct yaffs_tnode *tn)
+{
+	int i;
+	u32 *as_u32 = (u32 *)tn;
+	int tnode_size_u32 = dev->tnode_size / sizeof(u32);
+
+	if (!dev->swap_endian)
+		return;
+	/* Swap all the tnode data as u32s to fix endianisms. */
+	for (i = 0; i<tnode_size_u32; i++)
+		as_u32[i] = swap_u32(as_u32[i]);
+}
+
+struct yaffs_tnode *yaffs2_do_endian_tnode_copy(struct yaffs_dev *dev,
+					       struct yaffs_tnode *tn)
+{
+	if (!dev->swap_endian)
+		return tn;
+
+	memcpy(dev->tn_swap_buffer, tn, dev->tnode_size);
+	tn = dev->tn_swap_buffer;
+
+	yaffs2_do_endian_tnode(dev, tn);
+
+	return tn;
+}
+
+static int yaffs2_checkpt_tnode_worker(struct yaffs_obj *in,
+				       struct yaffs_tnode *tn, u32 level,
+				       int chunk_offset)
+{
+	int i;
+	struct yaffs_dev *dev = in->my_dev;
+	int ok = 1;
+	u32 base_offset;
+
+	if (!tn)
+		return 1;
+
+	if (level > 0) {
+		for (i = 0; i < YAFFS_NTNODES_INTERNAL && ok; i++) {
+			if (!tn->internal[i])
+				continue;
+			ok = yaffs2_checkpt_tnode_worker(in,
+				 tn->internal[i],
+				 level - 1,
+				 (chunk_offset <<
+				  YAFFS_TNODES_INTERNAL_BITS) + i);
+		}
+		return ok;
+	}
+
+	/* Level 0 tnode */
+	base_offset = chunk_offset << YAFFS_TNODES_LEVEL0_BITS;
+	yaffs_do_endian_u32(dev, &base_offset);
+
+	ok = (yaffs2_checkpt_wr(dev, &base_offset, sizeof(base_offset)) ==
+			sizeof(base_offset));
+	if (ok) {
+		/*
+		 * NB Can't do an in-place endian swizzle since that would
+		 * damage current tnode data.
+		 * If a tnode endian conversion is required we do a copy.
+		 */
+		tn = yaffs2_do_endian_tnode_copy(dev, tn);
+		ok = (yaffs2_checkpt_wr(dev, tn, dev->tnode_size) ==
+			(int)dev->tnode_size);
+	}
+	return ok;
+}
+
+static int yaffs2_wr_checkpt_tnodes(struct yaffs_obj *obj)
+{
+	u32 end_marker = ~0;
+	int ok = 1;
+
+	if (obj->variant_type != YAFFS_OBJECT_TYPE_FILE)
+		return ok;
+
+	ok = yaffs2_checkpt_tnode_worker(obj,
+					 obj->variant.file_variant.top,
+					 obj->variant.file_variant.
+					 top_level, 0);
+	if (ok)
+		ok = (yaffs2_checkpt_wr(obj->my_dev, &end_marker,
+				sizeof(end_marker)) == sizeof(end_marker));
+
+	return ok ? 1 : 0;
+}
+
+static int yaffs2_rd_checkpt_tnodes(struct yaffs_obj *obj)
+{
+	u32 base_chunk;
+	int ok = 1;
+	struct yaffs_dev *dev = obj->my_dev;
+	struct yaffs_file_var *file_stuct_ptr = &obj->variant.file_variant;
+	struct yaffs_tnode *tn;
+	int nread = 0;
+
+	ok = (yaffs2_checkpt_rd(dev, &base_chunk, sizeof(base_chunk)) ==
+	      sizeof(base_chunk));
+
+	yaffs_do_endian_u32(dev, &base_chunk);
+
+	while (ok && (~base_chunk)) {
+		nread++;
+		/* Read level 0 tnode */
+
+		tn = yaffs_get_tnode(dev);
+		if (tn) {
+			ok = (yaffs2_checkpt_rd(dev, tn, dev->tnode_size) ==
+				(int)dev->tnode_size);
+			yaffs2_do_endian_tnode(dev, tn);
+		}
+		else
+			ok = 0;
+
+		if (tn && ok)
+			ok = yaffs_add_find_tnode_0(dev,
+						    file_stuct_ptr,
+						    base_chunk, tn) ? 1 : 0;
+
+		if (ok) {
+			ok = (yaffs2_checkpt_rd
+			      (dev, &base_chunk,
+			       sizeof(base_chunk)) == sizeof(base_chunk));
+			yaffs_do_endian_u32(dev, &base_chunk);
+		}
+
+	}
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+		"Checkpoint read tnodes %d records, last %d. ok %d",
+		nread, base_chunk, ok);
+
+	return ok ? 1 : 0;
+}
+
+
+static void yaffs2_do_endian_checkpt_obj(struct yaffs_dev *dev,
+					 struct yaffs_checkpt_obj *cp)
+{
+	if (!dev->swap_endian)
+		return;
+	cp->struct_type = swap_s32(cp->struct_type);
+	cp->obj_id = swap_u32(cp->obj_id);
+	cp->parent_id = swap_u32(cp->parent_id);
+	cp->hdr_chunk = swap_s32(cp->hdr_chunk);
+	cp->bit_field = swap_u32(cp->bit_field);
+	cp->n_data_chunks = swap_s32(cp->n_data_chunks);
+	cp->size_or_equiv_obj = swap_loff_t(cp->size_or_equiv_obj);
+}
+
+static int yaffs2_wr_checkpt_objs(struct yaffs_dev *dev)
+{
+	struct yaffs_obj *obj;
+	struct yaffs_checkpt_obj cp;
+	int i;
+	int ok = 1;
+	struct list_head *lh;
+	u32 cp_variant_type;
+
+	/* Iterate through the objects in each hash entry,
+	 * dumping them to the checkpointing stream.
+	 */
+
+	for (i = 0; ok && i < YAFFS_NOBJECT_BUCKETS; i++) {
+		list_for_each(lh, &dev->obj_bucket[i].list) {
+			obj = list_entry(lh, struct yaffs_obj, hash_link);
+			if (!obj->defered_free) {
+				yaffs2_obj_checkpt_obj(&cp, obj);
+				cp.struct_type = sizeof(cp);
+				cp_variant_type = yaffs2_checkpt_obj_bit_get(
+						&cp, CHECKPOINT_VARIANT_BITS);
+				yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+					"Checkpoint write object %d parent %d type %d chunk %d obj addr %p",
+					cp.obj_id, cp.parent_id,
+					cp_variant_type, cp.hdr_chunk, obj);
+
+				yaffs2_do_endian_checkpt_obj (dev, &cp);
+				ok = (yaffs2_checkpt_wr(dev, &cp,
+						sizeof(cp)) == sizeof(cp));
+
+				if (ok &&
+					obj->variant_type ==
+					YAFFS_OBJECT_TYPE_FILE)
+					ok = yaffs2_wr_checkpt_tnodes(obj);
+			}
+		}
+	}
+
+	/* Dump end of list */
+	memset(&cp, 0xff, sizeof(struct yaffs_checkpt_obj));
+	cp.struct_type = sizeof(cp);
+	yaffs2_do_endian_checkpt_obj (dev, &cp);
+
+	if (ok)
+		ok = (yaffs2_checkpt_wr(dev, &cp, sizeof(cp)) == sizeof(cp));
+
+	return ok ? 1 : 0;
+}
+
+static int yaffs2_rd_checkpt_objs(struct yaffs_dev *dev)
+{
+	struct yaffs_obj *obj;
+	struct yaffs_checkpt_obj cp;
+	int ok = 1;
+	int done = 0;
+	u32 cp_variant_type;
+	LIST_HEAD(hard_list);
+
+
+	while (ok && !done) {
+		ok = (yaffs2_checkpt_rd(dev, &cp, sizeof(cp)) == sizeof(cp));
+		yaffs2_do_endian_checkpt_obj (dev, &cp);
+
+		if (cp.struct_type != sizeof(cp)) {
+			yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+				"struct size %d instead of %d ok %d",
+				cp.struct_type, (int)sizeof(cp), ok);
+			ok = 0;
+		}
+
+		cp_variant_type = yaffs2_checkpt_obj_bit_get(
+						&cp, CHECKPOINT_VARIANT_BITS);
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"Checkpoint read object %d parent %d type %d chunk %d ",
+			cp.obj_id, cp.parent_id, cp_variant_type,
+			cp.hdr_chunk);
+
+		if (ok && cp.obj_id == (u32)(~0)) {
+			done = 1;
+		} else if (ok) {
+			obj =
+			    yaffs_find_or_create_by_number(dev, cp.obj_id,
+							   cp_variant_type);
+			if (obj) {
+				ok = yaffs2_checkpt_obj_to_obj(obj, &cp);
+				if (!ok)
+					break;
+				if (obj->variant_type ==
+					YAFFS_OBJECT_TYPE_FILE) {
+					ok = yaffs2_rd_checkpt_tnodes(obj);
+				} else if (obj->variant_type ==
+					YAFFS_OBJECT_TYPE_HARDLINK) {
+					list_add(&obj->hard_links, &hard_list);
+				}
+			} else {
+				ok = 0;
+			}
+		}
+	}
+
+	if (ok)
+		yaffs_link_fixup(dev, &hard_list);
+
+	return ok ? 1 : 0;
+}
+
+static int yaffs2_wr_checkpt_sum(struct yaffs_dev *dev)
+{
+	u32 checkpt_sum;
+	int ok;
+
+	yaffs2_get_checkpt_sum(dev, &checkpt_sum);
+
+	yaffs_do_endian_u32(dev, &checkpt_sum);
+
+	ok = (yaffs2_checkpt_wr(dev, &checkpt_sum, sizeof(checkpt_sum)) ==
+		sizeof(checkpt_sum));
+
+	if (!ok)
+		return 0;
+
+	return 1;
+}
+
+static int yaffs2_rd_checkpt_sum(struct yaffs_dev *dev)
+{
+	u32 checkpt_sum0;
+	u32 checkpt_sum1;
+	int ok;
+
+	yaffs2_get_checkpt_sum(dev, &checkpt_sum0);
+
+	ok = (yaffs2_checkpt_rd(dev, &checkpt_sum1, sizeof(checkpt_sum1)) ==
+		sizeof(checkpt_sum1));
+
+	if (!ok)
+		return 0;
+	yaffs_do_endian_u32(dev, &checkpt_sum1);
+
+	if (checkpt_sum0 != checkpt_sum1)
+		return 0;
+
+	return 1;
+}
+
+static int yaffs2_wr_checkpt_data(struct yaffs_dev *dev)
+{
+	int ok = 1;
+
+	if (!yaffs2_checkpt_required(dev)) {
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"skipping checkpoint write");
+		ok = 0;
+	}
+
+	if (ok)
+		ok = yaffs2_checkpt_open(dev, 1);
+
+	if (ok) {
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"write checkpoint validity");
+		ok = yaffs2_wr_checkpt_validity_marker(dev, 1);
+	}
+	if (ok) {
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"write checkpoint device");
+		ok = yaffs2_wr_checkpt_dev(dev);
+	}
+	if (ok) {
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"write checkpoint objects");
+		ok = yaffs2_wr_checkpt_objs(dev);
+	}
+	if (ok) {
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"write checkpoint validity");
+		ok = yaffs2_wr_checkpt_validity_marker(dev, 0);
+	}
+
+	if (ok)
+		ok = yaffs2_wr_checkpt_sum(dev);
+
+	if (!yaffs_checkpt_close(dev))
+		ok = 0;
+
+	if (ok)
+		dev->is_checkpointed = 1;
+	else
+		dev->is_checkpointed = 0;
+
+	return dev->is_checkpointed;
+}
+
+static int yaffs2_rd_checkpt_data(struct yaffs_dev *dev)
+{
+	int ok = 1;
+
+	if (!dev->param.is_yaffs2)
+		ok = 0;
+
+	if (ok && dev->param.skip_checkpt_rd) {
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"skipping checkpoint read");
+		ok = 0;
+	}
+
+	if (ok)
+		ok = yaffs2_checkpt_open(dev, 0); /* open for read */
+
+	if (ok) {
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"read checkpoint validity");
+		ok = yaffs2_rd_checkpt_validity_marker(dev, 1);
+	}
+	if (ok) {
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"read checkpoint device");
+		ok = yaffs2_rd_checkpt_dev(dev);
+	}
+	if (ok) {
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"read checkpoint objects");
+		ok = yaffs2_rd_checkpt_objs(dev);
+	}
+	if (ok) {
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"read checkpoint validity");
+		ok = yaffs2_rd_checkpt_validity_marker(dev, 0);
+	}
+
+	if (ok) {
+		ok = yaffs2_rd_checkpt_sum(dev);
+		yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+			"read checkpoint checksum %d", ok);
+	}
+
+	if (!yaffs_checkpt_close(dev))
+		ok = 0;
+
+	if (ok)
+		dev->is_checkpointed = 1;
+	else
+		dev->is_checkpointed = 0;
+
+	return ok ? 1 : 0;
+}
+
+void yaffs2_checkpt_invalidate(struct yaffs_dev *dev)
+{
+	if (dev->is_checkpointed || dev->blocks_in_checkpt > 0) {
+		dev->is_checkpointed = 0;
+		yaffs2_checkpt_invalidate_stream(dev);
+	}
+	if (dev->param.sb_dirty_fn)
+		dev->param.sb_dirty_fn(dev);
+}
+
+int yaffs_checkpoint_save(struct yaffs_dev *dev)
+{
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+		"save entry: is_checkpointed %d",
+		dev->is_checkpointed);
+
+	yaffs_verify_objects(dev);
+	yaffs_verify_blocks(dev);
+	yaffs_verify_free_chunks(dev);
+
+	if (!dev->is_checkpointed) {
+		yaffs2_checkpt_invalidate(dev);
+		yaffs2_wr_checkpt_data(dev);
+	}
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT | YAFFS_TRACE_MOUNT,
+		"save exit: is_checkpointed %d",
+		dev->is_checkpointed);
+
+	return dev->is_checkpointed;
+}
+
+int yaffs2_checkpt_restore(struct yaffs_dev *dev)
+{
+	int retval;
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+		"restore entry: is_checkpointed %d",
+		dev->is_checkpointed);
+
+	retval = yaffs2_rd_checkpt_data(dev);
+
+	if (dev->is_checkpointed) {
+		yaffs_verify_objects(dev);
+		yaffs_verify_blocks(dev);
+		yaffs_verify_free_chunks(dev);
+	}
+
+	yaffs_trace(YAFFS_TRACE_CHECKPOINT,
+		"restore exit: is_checkpointed %d",
+		dev->is_checkpointed);
+
+	return retval;
+}
+
+/* End of checkpointing */
+
+/* Hole handling logic for truncate past end of file */
+
+int yaffs2_handle_hole(struct yaffs_obj *obj, loff_t new_size)
+{
+	/* if new_size > old_file_size.
+	 * We're going to be writing a hole.
+	 * If the hole is small then write zeros otherwise write a start
+	 * of hole marker.
+	 */
+	loff_t old_file_size;
+	loff_t increase;
+	int small_hole;
+	int result = YAFFS_OK;
+	struct yaffs_dev *dev = NULL;
+	u8 *local_buffer = NULL;
+	int small_increase_ok = 0;
+
+	if (!obj)
+		return YAFFS_FAIL;
+
+	if (obj->variant_type != YAFFS_OBJECT_TYPE_FILE)
+		return YAFFS_FAIL;
+
+	dev = obj->my_dev;
+
+	/* Bail out if not yaffs2 mode */
+	if (!dev->param.is_yaffs2)
+		return YAFFS_OK;
+
+	old_file_size = obj->variant.file_variant.file_size;
+
+	if (new_size <= old_file_size)
+		return YAFFS_OK;
+
+	increase = new_size - old_file_size;
+
+	if (increase < YAFFS_SMALL_HOLE_THRESHOLD * dev->data_bytes_per_chunk &&
+	    yaffs_check_alloc_available(dev, YAFFS_SMALL_HOLE_THRESHOLD + 1))
+		small_hole = 1;
+	else
+		small_hole = 0;
+
+	if (small_hole)
+		local_buffer = yaffs_get_temp_buffer(dev);
+
+	if (local_buffer) {
+		/* fill hole with zero bytes */
+		loff_t pos = old_file_size;
+		int this_write;
+		int written;
+		memset(local_buffer, 0, dev->data_bytes_per_chunk);
+		small_increase_ok = 1;
+
+		while (increase > 0 && small_increase_ok) {
+			this_write = increase;
+			if (this_write > (int)dev->data_bytes_per_chunk)
+				this_write = dev->data_bytes_per_chunk;
+			written =
+			    yaffs_do_file_wr(obj, local_buffer, pos, this_write,
+					     0);
+			if (written == this_write) {
+				pos += this_write;
+				increase -= this_write;
+			} else {
+				small_increase_ok = 0;
+			}
+		}
+
+		yaffs_release_temp_buffer(dev, local_buffer);
+
+		/* If out of space then reverse any chunks we've added */
+		if (!small_increase_ok)
+			yaffs_resize_file_down(obj, old_file_size);
+	}
+
+	if (!small_increase_ok &&
+	    obj->parent &&
+	    obj->parent->obj_id != YAFFS_OBJECTID_UNLINKED &&
+	    obj->parent->obj_id != YAFFS_OBJECTID_DELETED) {
+		/* Write a hole start header with the old file size */
+		yaffs_update_oh(obj, NULL, 0, 1, 0, NULL);
+	}
+
+	return result;
+}
+
+/* Yaffs2 scanning */
+
+struct yaffs_block_index {
+	int seq;
+	int block;
+};
+
+static int yaffs2_ybicmp(const void *a, const void *b)
+{
+	int aseq = ((struct yaffs_block_index *)a)->seq;
+	int bseq = ((struct yaffs_block_index *)b)->seq;
+	int ablock = ((struct yaffs_block_index *)a)->block;
+	int bblock = ((struct yaffs_block_index *)b)->block;
+
+	if (aseq == bseq)
+		return ablock - bblock;
+
+	return aseq - bseq;
+}
+
+static inline int yaffs2_scan_chunk(struct yaffs_dev *dev,
+		struct yaffs_block_info *bi,
+		int blk, int chunk_in_block,
+		int *found_chunks,
+		u8 *chunk_data,
+		struct list_head *hard_list,
+		int summary_available)
+{
+	struct yaffs_obj_hdr *oh;
+	struct yaffs_obj *in;
+	struct yaffs_obj *parent;
+	int equiv_id;
+	loff_t file_size;
+	int is_shrink;
+	int is_unlinked;
+	struct yaffs_ext_tags tags;
+	int result;
+	int alloc_failed = 0;
+	int chunk = blk * dev->param.chunks_per_block + chunk_in_block;
+	struct yaffs_file_var *file_var;
+	struct yaffs_hardlink_var *hl_var;
+	struct yaffs_symlink_var *sl_var;
+
+	if (summary_available) {
+		result = yaffs_summary_fetch(dev, &tags, chunk_in_block);
+		tags.seq_number = bi->seq_number;
+	}
+
+	if (!summary_available || tags.obj_id == 0) {
+		result = yaffs_rd_chunk_tags_nand(dev, chunk, NULL, &tags);
+		dev->tags_used++;
+	} else {
+		dev->summary_used++;
+	}
+
+	if (result == YAFFS_FAIL)
+		yaffs_trace(YAFFS_TRACE_SCAN,
+				"Could not get tags for chunk %d\n", chunk);
+	/* Let's have a good look at this chunk... */
+
+	if (!tags.chunk_used) {
+		/* An unassigned chunk in the block.
+		 * If there are used chunks after this one, then
+		 * it is a chunk that was skipped due to failing
+		 * the erased check. Just skip it so that it can
+		 * be deleted.
+		 * But, more typically, We get here when this is
+		 * an unallocated chunk and his means that
+		 * either the block is empty or this is the one
+		 * being allocated from
+		 */
+
+		if (*found_chunks) {
+			/* This is a chunk that was skipped due
+			 * to failing the erased check */
+		} else if (chunk_in_block == 0) {
+			/* We're looking at the first chunk in
+			 * the block so the block is unused */
+			bi->block_state = YAFFS_BLOCK_STATE_EMPTY;
+			dev->n_erased_blocks++;
+		} else {
+			if (bi->block_state == YAFFS_BLOCK_STATE_NEEDS_SCAN ||
+			    bi->block_state == YAFFS_BLOCK_STATE_ALLOCATING) {
+				if (dev->seq_number == bi->seq_number) {
+					/* Allocating from this block*/
+					yaffs_trace(YAFFS_TRACE_SCAN,
+					    " Allocating from %d %d",
+					    blk, chunk_in_block);
+
+					bi->block_state =
+						YAFFS_BLOCK_STATE_ALLOCATING;
+					dev->alloc_block = blk;
+					dev->alloc_page = chunk_in_block;
+					dev->alloc_block_finder = blk;
+				} else {
+					/* This is a partially written block
+					 * that is not the current
+					 * allocation block.
+					 */
+					yaffs_trace(YAFFS_TRACE_SCAN,
+						"Partially written block %d detected. gc will fix this.",
+						blk);
+				}
+			}
+		}
+
+		dev->n_free_chunks++;
+
+	} else if (tags.ecc_result ==
+		YAFFS_ECC_RESULT_UNFIXED) {
+		yaffs_trace(YAFFS_TRACE_SCAN,
+			" Unfixed ECC in chunk(%d:%d), chunk ignored",
+			blk, chunk_in_block);
+			dev->n_free_chunks++;
+	} else if (tags.obj_id > YAFFS_MAX_OBJECT_ID ||
+		   tags.chunk_id > YAFFS_MAX_CHUNK_ID ||
+		   tags.obj_id == YAFFS_OBJECTID_SUMMARY ||
+		   (tags.chunk_id > 0 &&
+		     tags.n_bytes > dev->data_bytes_per_chunk) ||
+		   tags.seq_number != bi->seq_number) {
+		yaffs_trace(YAFFS_TRACE_SCAN,
+			"Chunk (%d:%d) with bad tags:obj = %d, chunk_id = %d, n_bytes = %d, ignored",
+			blk, chunk_in_block, tags.obj_id,
+			tags.chunk_id, tags.n_bytes);
+		dev->n_free_chunks++;
+	} else if (tags.chunk_id > 0) {
+		/* chunk_id > 0 so it is a data chunk... */
+		loff_t endpos;
+		loff_t chunk_base = (tags.chunk_id - 1) *
+					dev->data_bytes_per_chunk;
+
+		*found_chunks = 1;
+
+		yaffs_set_chunk_bit(dev, blk, chunk_in_block);
+		bi->pages_in_use++;
+
+		in = yaffs_find_or_create_by_number(dev,
+					tags.obj_id,
+					YAFFS_OBJECT_TYPE_FILE);
+		if (!in)
+			/* Out of memory */
+			alloc_failed = 1;
+
+		if (in &&
+		    in->variant_type == YAFFS_OBJECT_TYPE_FILE &&
+		    chunk_base < in->variant.file_variant.shrink_size) {
+			/* This has not been invalidated by
+			 * a resize */
+			if (!yaffs_put_chunk_in_file(in, tags.chunk_id,
+								chunk, -1))
+				alloc_failed = 1;
+
+			/* File size is calculated by looking at
+			 * the data chunks if we have not
+			 * seen an object header yet.
+			 * Stop this practice once we find an
+			 * object header.
+			 */
+			endpos = chunk_base + tags.n_bytes;
+
+			if (!in->valid &&
+			    in->variant.file_variant.stored_size < endpos) {
+				in->variant.file_variant.
+				    stored_size = endpos;
+				in->variant.file_variant.
+				    file_size = endpos;
+			}
+		} else if (in) {
+			/* This chunk has been invalidated by a
+			 * resize, or a past file deletion
+			 * so delete the chunk*/
+			yaffs_chunk_del(dev, chunk, 1, __LINE__);
+		}
+	} else {
+		/* chunk_id == 0, so it is an ObjectHeader.
+		 * Thus, we read in the object header and make
+		 * the object
+		 */
+		*found_chunks = 1;
+
+		yaffs_set_chunk_bit(dev, blk, chunk_in_block);
+		bi->pages_in_use++;
+
+		oh = NULL;
+		in = NULL;
+
+		if (tags.extra_available) {
+			in = yaffs_find_or_create_by_number(dev,
+					tags.obj_id,
+					tags.extra_obj_type);
+			if (!in)
+				alloc_failed = 1;
+		}
+
+		if (!in ||
+		    (!in->valid && dev->param.disable_lazy_load) ||
+		    tags.extra_shadows ||
+		    (!in->valid && (tags.obj_id == YAFFS_OBJECTID_ROOT ||
+				 tags.obj_id == YAFFS_OBJECTID_LOSTNFOUND))) {
+
+			/* If we don't have  valid info then we
+			 * need to read the chunk
+			 * TODO In future we can probably defer
+			 * reading the chunk and living with
+			 * invalid data until needed.
+			 */
+
+			result = yaffs_rd_chunk_tags_nand(dev,
+						  chunk,
+						  chunk_data,
+						  NULL);
+
+			oh = (struct yaffs_obj_hdr *)chunk_data;
+
+			yaffs_do_endian_oh(dev, oh);
+
+			if (dev->param.inband_tags) {
+				/* Fix up the header if they got
+				 * corrupted by inband tags */
+				oh->shadows_obj =
+				    oh->inband_shadowed_obj_id;
+				oh->is_shrink =
+				    oh->inband_is_shrink;
+			}
+
+			if (!in) {
+				in = yaffs_find_or_create_by_number(dev,
+							tags.obj_id, oh->type);
+				if (!in)
+					alloc_failed = 1;
+			}
+		}
+
+		if (!in) {
+			/* TODO Hoosterman we have a problem! */
+			yaffs_trace(YAFFS_TRACE_ERROR,
+				"yaffs tragedy: Could not make object for object  %d at chunk %d during scan",
+				tags.obj_id, chunk);
+			return YAFFS_FAIL;
+		}
+
+		if (in->valid) {
+			/* We have already filled this one.
+			 * We have a duplicate that will be
+			 * discarded, but we first have to suck
+			 * out resize info if it is a file.
+			 */
+			if ((in->variant_type == YAFFS_OBJECT_TYPE_FILE) &&
+				((oh && oh->type == YAFFS_OBJECT_TYPE_FILE) ||
+				 (tags.extra_available &&
+				  tags.extra_obj_type == YAFFS_OBJECT_TYPE_FILE)
+				)) {
+				loff_t this_size = (oh) ?
+					yaffs_oh_to_size(dev, oh, 0) :
+					tags.extra_file_size;
+				u32 parent_obj_id = (oh) ?
+					(u32)oh->parent_obj_id :
+					tags.extra_parent_id;
+
+				is_shrink = (oh) ?
+					oh->is_shrink :
+					tags.extra_is_shrink;
+
+				/* If it is deleted (unlinked
+				 * at start also means deleted)
+				 * we treat the file size as
+				 * being zeroed at this point.
+				 */
+				if (parent_obj_id == YAFFS_OBJECTID_DELETED ||
+				    parent_obj_id == YAFFS_OBJECTID_UNLINKED) {
+					this_size = 0;
+					is_shrink = 1;
+				}
+
+				if (is_shrink &&
+				    in->variant.file_variant.shrink_size >
+				    this_size)
+					in->variant.file_variant.shrink_size =
+					this_size;
+
+				if (is_shrink)
+					bi->has_shrink_hdr = 1;
+			}
+			/* Use existing - destroy this one. */
+			yaffs_chunk_del(dev, chunk, 1, __LINE__);
+		}
+
+		if (!in->valid && in->variant_type !=
+		    (oh ? oh->type : tags.extra_obj_type)) {
+			yaffs_trace(YAFFS_TRACE_ERROR,
+				"yaffs tragedy: Bad type, %d != %d, for object %d at chunk %d during scan",
+				oh ? oh->type : tags.extra_obj_type,
+				in->variant_type, tags.obj_id,
+				chunk);
+			in = yaffs_retype_obj(in, oh ? oh->type : tags.extra_obj_type);
+		}
+
+		if (!in->valid &&
+		    (tags.obj_id == YAFFS_OBJECTID_ROOT ||
+		     tags.obj_id == YAFFS_OBJECTID_LOSTNFOUND)) {
+			/* We only load some info, don't fiddle
+			 * with directory structure */
+			in->valid = 1;
+
+			if (oh) {
+				in->yst_mode = oh->yst_mode;
+				yaffs_load_attribs(in, oh);
+				in->lazy_loaded = 0;
+			} else {
+				in->lazy_loaded = 1;
+			}
+			in->hdr_chunk = chunk;
+
+		} else if (!in->valid) {
+			/* we need to load this info */
+			in->valid = 1;
+			in->hdr_chunk = chunk;
+			if (oh) {
+				in->variant_type = oh->type;
+				in->yst_mode = oh->yst_mode;
+				yaffs_load_attribs(in, oh);
+
+				if (oh->shadows_obj > 0)
+					yaffs_handle_shadowed_obj(dev,
+					     oh->shadows_obj, 1);
+
+				yaffs_set_obj_name_from_oh(in, oh);
+				parent = yaffs_find_or_create_by_number(dev,
+						oh->parent_obj_id,
+						YAFFS_OBJECT_TYPE_DIRECTORY);
+				file_size = yaffs_oh_to_size(dev, oh, 0);
+				is_shrink = oh->is_shrink;
+				equiv_id = oh->equiv_id;
+			} else {
+				in->variant_type = tags.extra_obj_type;
+				parent = yaffs_find_or_create_by_number(dev,
+						tags.extra_parent_id,
+						YAFFS_OBJECT_TYPE_DIRECTORY);
+				file_size = tags.extra_file_size;
+				is_shrink = tags.extra_is_shrink;
+				equiv_id = tags.extra_equiv_id;
+				in->lazy_loaded = 1;
+			}
+			in->dirty = 0;
+
+			if (!parent)
+				alloc_failed = 1;
+
+			/* directory stuff...
+			 * hook up to parent
+			 */
+
+			if (parent &&
+			    parent->variant_type == YAFFS_OBJECT_TYPE_UNKNOWN) {
+				/* Set up as a directory */
+				parent->variant_type =
+					YAFFS_OBJECT_TYPE_DIRECTORY;
+				INIT_LIST_HEAD(&parent->
+						variant.dir_variant.children);
+			} else if (!parent ||
+				   parent->variant_type !=
+					YAFFS_OBJECT_TYPE_DIRECTORY) {
+				/* Hoosterman, another problem....
+				 * Trying to use a non-directory as a directory
+				 */
+
+				yaffs_trace(YAFFS_TRACE_ERROR,
+					"yaffs tragedy: attempting to use non-directory as a directory in scan. Put in lost+found."
+					);
+				parent = dev->lost_n_found;
+			}
+			yaffs_add_obj_to_dir(parent, in);
+
+			is_unlinked = (parent == dev->del_dir) ||
+					(parent == dev->unlinked_dir);
+
+			if (is_shrink)
+				/* Mark the block */
+				bi->has_shrink_hdr = 1;
+
+			/* Note re hardlinks.
+			 * Since we might scan a hardlink before its equivalent
+			 * object is scanned we put them all in a list.
+			 * After scanning is complete, we should have all the
+			 * objects, so we run through this list and fix up all
+			 * the chains.
+			 */
+
+			switch (in->variant_type) {
+			case YAFFS_OBJECT_TYPE_UNKNOWN:
+				/* Todo got a problem */
+				break;
+			case YAFFS_OBJECT_TYPE_FILE:
+				file_var = &in->variant.file_variant;
+				if (file_var->stored_size < file_size) {
+					/* This covers the case where the file
+					 * size is greater than the data held.
+					 * This will happen if the file is
+					 * resized to be larger than its
+					 * current data extents.
+					 */
+					file_var->file_size = file_size;
+					file_var->stored_size = file_size;
+				}
+
+				if (file_var->shrink_size > file_size)
+					file_var->shrink_size = file_size;
+
+				break;
+			case YAFFS_OBJECT_TYPE_HARDLINK:
+				hl_var = &in->variant.hardlink_variant;
+				if (!is_unlinked) {
+					hl_var->equiv_id = equiv_id;
+					list_add(&in->hard_links, hard_list);
+				}
+				break;
+			case YAFFS_OBJECT_TYPE_DIRECTORY:
+				/* Do nothing */
+				break;
+			case YAFFS_OBJECT_TYPE_SPECIAL:
+				/* Do nothing */
+				break;
+			case YAFFS_OBJECT_TYPE_SYMLINK:
+				sl_var = &in->variant.symlink_variant;
+				if (oh) {
+					sl_var->alias =
+					    yaffs_clone_str(oh->alias);
+					if (!sl_var->alias)
+						alloc_failed = 1;
+				}
+				break;
+			}
+		}
+	}
+	return alloc_failed ? YAFFS_FAIL : YAFFS_OK;
+}
+
+int yaffs2_scan_backwards(struct yaffs_dev *dev)
+{
+	u32 blk;
+	int block_iter;
+	int start_iter;
+	int end_iter;
+	int n_to_scan = 0;
+	enum yaffs_block_state state;
+	int c;
+	LIST_HEAD(hard_list);
+	struct yaffs_block_info *bi;
+	u32 seq_number;
+	int n_blocks = dev->internal_end_block - dev->internal_start_block + 1;
+	u8 *chunk_data;
+	int found_chunks;
+	int alloc_failed = 0;
+	struct yaffs_block_index *block_index = NULL;
+	int alt_block_index = 0;
+	int summary_available;
+
+	yaffs_trace(YAFFS_TRACE_SCAN,
+		"yaffs2_scan_backwards starts  intstartblk %d intendblk %d...",
+		dev->internal_start_block, dev->internal_end_block);
+
+	dev->seq_number = YAFFS_LOWEST_SEQUENCE_NUMBER;
+
+	block_index =
+		kmalloc(n_blocks * sizeof(struct yaffs_block_index), GFP_NOFS);
+
+	if (!block_index) {
+		block_index =
+		    vmalloc(n_blocks * sizeof(struct yaffs_block_index));
+		alt_block_index = 1;
+	}
+
+	if (!block_index) {
+		yaffs_trace(YAFFS_TRACE_SCAN,
+			"yaffs2_scan_backwards() could not allocate block index!"
+			);
+		return YAFFS_FAIL;
+	}
+
+	dev->blocks_in_checkpt = 0;
+
+	chunk_data = yaffs_get_temp_buffer(dev);
+
+	/* Scan all the blocks to determine their state */
+	bi = dev->block_info;
+	for (blk = dev->internal_start_block; blk <= dev->internal_end_block;
+	     blk++) {
+		yaffs_clear_chunk_bits(dev, blk);
+		bi->pages_in_use = 0;
+		bi->soft_del_pages = 0;
+
+		yaffs_query_init_block_state(dev, blk, &state, &seq_number);
+
+		bi->block_state = state;
+		bi->seq_number = seq_number;
+
+		if (bi->seq_number == YAFFS_SEQUENCE_CHECKPOINT_DATA)
+			bi->block_state = YAFFS_BLOCK_STATE_CHECKPOINT;
+		if (bi->seq_number == YAFFS_SEQUENCE_BAD_BLOCK)
+			bi->block_state = YAFFS_BLOCK_STATE_DEAD;
+
+		yaffs_trace(YAFFS_TRACE_SCAN_DEBUG,
+			"Block scanning block %d state %d seq %d",
+			blk, bi->block_state, seq_number);
+
+		if (bi->block_state == YAFFS_BLOCK_STATE_CHECKPOINT) {
+			dev->blocks_in_checkpt++;
+
+		} else if (bi->block_state == YAFFS_BLOCK_STATE_DEAD) {
+			yaffs_trace(YAFFS_TRACE_BAD_BLOCKS,
+				"block %d is bad", blk);
+		} else if (bi->block_state == YAFFS_BLOCK_STATE_EMPTY) {
+			yaffs_trace(YAFFS_TRACE_SCAN_DEBUG, "Block empty ");
+			dev->n_erased_blocks++;
+			dev->n_free_chunks += dev->param.chunks_per_block;
+		} else if (bi->block_state ==
+				YAFFS_BLOCK_STATE_NEEDS_SCAN) {
+			/* Determine the highest sequence number */
+			if (seq_number >= YAFFS_LOWEST_SEQUENCE_NUMBER &&
+			    seq_number < YAFFS_HIGHEST_SEQUENCE_NUMBER) {
+				block_index[n_to_scan].seq = seq_number;
+				block_index[n_to_scan].block = blk;
+				n_to_scan++;
+				if (seq_number >= dev->seq_number)
+					dev->seq_number = seq_number;
+			} else {
+				/* TODO: Nasty sequence number! */
+				yaffs_trace(YAFFS_TRACE_SCAN,
+					"Block scanning block %d has bad sequence number %d",
+					blk, seq_number);
+			}
+		}
+		bi++;
+	}
+
+	yaffs_trace(YAFFS_TRACE_ALWAYS, "%d blocks to be sorted...", n_to_scan);
+
+	cond_resched();
+
+	/* Sort the blocks by sequence number */
+	sort(block_index, n_to_scan, sizeof(struct yaffs_block_index),
+		   yaffs2_ybicmp, NULL);
+
+	cond_resched();
+
+	yaffs_trace(YAFFS_TRACE_SCAN, "...done");
+
+	/* Now scan the blocks looking at the data. */
+	start_iter = 0;
+	end_iter = n_to_scan - 1;
+	yaffs_trace(YAFFS_TRACE_SCAN_DEBUG, "%d blocks to scan", n_to_scan);
+
+	/* For each block.... backwards */
+	for (block_iter = end_iter;
+	     !alloc_failed && block_iter >= start_iter;
+	     block_iter--) {
+		/* Cooperative multitasking! This loop can run for so
+		   long that watchdog timers expire. */
+		cond_resched();
+
+		/* get the block to scan in the correct order */
+		blk = block_index[block_iter].block;
+		bi = yaffs_get_block_info(dev, blk);
+
+		summary_available = yaffs_summary_read(dev, dev->sum_tags, blk);
+
+		/* For each chunk in each block that needs scanning.... */
+		found_chunks = 0;
+		if (summary_available)
+			c = dev->chunks_per_summary - 1;
+		else
+			c = dev->param.chunks_per_block - 1;
+
+		for (/* c is already initialised */;
+		     !alloc_failed && c >= 0 &&
+		     (bi->block_state == YAFFS_BLOCK_STATE_NEEDS_SCAN ||
+		      bi->block_state == YAFFS_BLOCK_STATE_ALLOCATING);
+		      c--) {
+			/* Scan backwards...
+			 * Read the tags and decide what to do
+			 */
+			if (yaffs2_scan_chunk(dev, bi, blk, c,
+					&found_chunks, chunk_data,
+					&hard_list, summary_available) ==
+					YAFFS_FAIL)
+				alloc_failed = 1;
+		}
+
+		if (bi->block_state == YAFFS_BLOCK_STATE_NEEDS_SCAN) {
+			/* If we got this far while scanning, then the block
+			 * is fully allocated. */
+			bi->block_state = YAFFS_BLOCK_STATE_FULL;
+		}
+
+		/* Now let's see if it was dirty */
+		if (bi->pages_in_use == 0 &&
+		    !bi->has_shrink_hdr &&
+		    bi->block_state == YAFFS_BLOCK_STATE_FULL) {
+			yaffs_block_became_dirty(dev, blk);
+		}
+	}
+
+	yaffs_skip_rest_of_block(dev);
+
+	if (alt_block_index)
+		vfree(block_index);
+	else
+		kfree(block_index);
+
+	/* Ok, we've done all the scanning.
+	 * Fix up the hard link chains.
+	 * We have scanned all the objects, now it's time to add these
+	 * hardlinks.
+	 */
+	yaffs_link_fixup(dev, &hard_list);
+
+	yaffs_release_temp_buffer(dev, chunk_data);
+
+	if (alloc_failed)
+		return YAFFS_FAIL;
+
+	yaffs_trace(YAFFS_TRACE_SCAN, "yaffs2_scan_backwards ends");
+
+	return YAFFS_OK;
+}
diff --git a/fs/yaffs2/yaffs_yaffs2.h b/fs/yaffs2/yaffs_yaffs2.h
new file mode 100644
index 00000000..4eaa722
--- /dev/null
+++ b/fs/yaffs2/yaffs_yaffs2.h
@@ -0,0 +1,38 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YAFFS_YAFFS2_H__
+#define __YAFFS_YAFFS2_H__
+
+#include "yaffs_guts.h"
+
+void yaffs_calc_oldest_dirty_seq(struct yaffs_dev *dev);
+void yaffs2_find_oldest_dirty_seq(struct yaffs_dev *dev);
+void yaffs2_clear_oldest_dirty_seq(struct yaffs_dev *dev,
+				   struct yaffs_block_info *bi);
+void yaffs2_update_oldest_dirty_seq(struct yaffs_dev *dev, unsigned block_no,
+				    struct yaffs_block_info *bi);
+int yaffs_block_ok_for_gc(struct yaffs_dev *dev, struct yaffs_block_info *bi);
+u32 yaffs2_find_refresh_block(struct yaffs_dev *dev);
+int yaffs2_checkpt_required(struct yaffs_dev *dev);
+int yaffs_calc_checkpt_blocks_required(struct yaffs_dev *dev);
+
+void yaffs2_checkpt_invalidate(struct yaffs_dev *dev);
+int yaffs2_checkpt_save(struct yaffs_dev *dev);
+int yaffs2_checkpt_restore(struct yaffs_dev *dev);
+
+int yaffs2_handle_hole(struct yaffs_obj *obj, loff_t new_size);
+int yaffs2_scan_backwards(struct yaffs_dev *dev);
+
+#endif
diff --git a/fs/yaffs2/yportenv.h b/fs/yaffs2/yportenv.h
new file mode 100644
index 00000000..3df7d56
--- /dev/null
+++ b/fs/yaffs2/yportenv.h
@@ -0,0 +1,84 @@
+/*
+ * YAFFS: Yet another Flash File System . A NAND-flash specific file system.
+ *
+ * Copyright (C) 2002-2018 Aleph One Ltd.
+ *
+ * Created by Charles Manning <charles@aleph1.co.uk>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License version 2.1 as
+ * published by the Free Software Foundation.
+ *
+ * Note: Only YAFFS headers are LGPL, YAFFS C code is covered by GPL.
+ */
+
+#ifndef __YPORTENV_H__
+#define __YPORTENV_H__
+
+/*
+ * Define the MTD version in terms of Linux Kernel versions
+ * This allows yaffs to be used independantly of the kernel
+ * as well as with it.
+ */
+
+#define MTD_VERSION(a, b, c) (((a) << 16) + ((b) << 8) + (c))
+
+#ifdef YAFFS_OUT_OF_TREE
+#include "moduleconfig.h"
+#endif
+
+#include <linux/version.h>
+#define MTD_VERSION_CODE LINUX_VERSION_CODE
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 19))
+#include <linux/config.h>
+#endif
+#include <linux/version.h>
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/sched.h>
+#include <linux/string.h>
+#include <linux/slab.h>
+#include <linux/vmalloc.h>
+#include <linux/xattr.h>
+#include <linux/list.h>
+#include <linux/types.h>
+#include <linux/fs.h>
+#include <linux/stat.h>
+#include <linux/sort.h>
+#include <linux/bitops.h>
+
+/*  These type wrappings are used to support Unicode names in WinCE. */
+#define YCHAR char
+#define YUCHAR unsigned char
+#define _Y(x)     x
+
+#define YAFFS_LOSTNFOUND_NAME		"lost+found"
+#define YAFFS_LOSTNFOUND_PREFIX		"obj"
+
+
+#define YAFFS_ROOT_MODE			0755
+#define YAFFS_LOSTNFOUND_MODE		0700
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0))
+#define Y_CURRENT_TIME CURRENT_TIME.tv_sec
+#define Y_TIME_CONVERT(x) (x).tv_sec
+#else
+#define Y_CURRENT_TIME CURRENT_TIME
+#define Y_TIME_CONVERT(x) (x)
+#endif
+
+#define compile_time_assertion(assertion) \
+	({ int x = __builtin_choose_expr(assertion, 0, (void)0); (void) x; })
+
+
+#define yaffs_printf(msk, fmt, ...) \
+	printk(KERN_DEBUG "yaffs: " fmt "\n", ##__VA_ARGS__)
+
+#define yaffs_trace(msk, fmt, ...) do { \
+	if (yaffs_trace_mask & (msk)) \
+		printk(KERN_DEBUG "yaffs: " fmt "\n", ##__VA_ARGS__); \
+} while (0)
+
+
+#endif
diff --git a/include/asm-generic/sections.h b/include/asm-generic/sections.h
index 4df64a1..e02a3d9 100644
--- a/include/asm-generic/sections.h
+++ b/include/asm-generic/sections.h
@@ -27,6 +27,8 @@
  *	__kprobes_text_start, __kprobes_text_end
  *	__entry_text_start, __entry_text_end
  *	__ctors_start, __ctors_end
+ *	__irqentry_text_start, __irqentry_text_end
+ *	__softirqentry_text_start, __softirqentry_text_end
  */
 extern char _text[], _stext[], _etext[];
 extern char _data[], _sdata[], _edata[];
@@ -39,6 +41,8 @@
 extern char __kprobes_text_start[], __kprobes_text_end[];
 extern char __entry_text_start[], __entry_text_end[];
 extern char __start_rodata[], __end_rodata[];
+extern char __irqentry_text_start[], __irqentry_text_end[];
+extern char __softirqentry_text_start[], __softirqentry_text_end[];
 
 /* Start and end of .ctors section - used for constructor calls. */
 extern char __ctors_start[], __ctors_end[];
diff --git a/include/asm-generic/vmlinux.lds.h b/include/asm-generic/vmlinux.lds.h
index 1462071..3c3519b 100644
--- a/include/asm-generic/vmlinux.lds.h
+++ b/include/asm-generic/vmlinux.lds.h
@@ -67,10 +67,12 @@
  */
 #ifdef CONFIG_LD_DEAD_CODE_DATA_ELIMINATION
 #define TEXT_MAIN .text .text.[0-9a-zA-Z_]*
+#define TEXT_CFI_MAIN .text.cfi .text.[0-9a-zA-Z_]*.cfi
 #define DATA_MAIN .data .data.[0-9a-zA-Z_]*
 #define BSS_MAIN .bss .bss.[0-9a-zA-Z_]*
 #else
 #define TEXT_MAIN .text
+#define TEXT_CFI_MAIN .text.cfi
 #define DATA_MAIN .data
 #define BSS_MAIN .bss
 #endif
@@ -105,7 +107,7 @@
 #ifdef CONFIG_FTRACE_MCOUNT_RECORD
 #define MCOUNT_REC()	. = ALIGN(8);				\
 			VMLINUX_SYMBOL(__start_mcount_loc) = .; \
-			*(__mcount_loc)				\
+			KEEP(*(__mcount_loc))			\
 			VMLINUX_SYMBOL(__stop_mcount_loc) = .;
 #else
 #define MCOUNT_REC()
@@ -139,10 +141,10 @@
 #ifdef CONFIG_EVENT_TRACING
 #define FTRACE_EVENTS()	. = ALIGN(8);					\
 			VMLINUX_SYMBOL(__start_ftrace_events) = .;	\
-			*(_ftrace_events)				\
+			KEEP(*(_ftrace_events))				\
 			VMLINUX_SYMBOL(__stop_ftrace_events) = .;	\
 			VMLINUX_SYMBOL(__start_ftrace_enum_maps) = .;	\
-			*(_ftrace_enum_map)				\
+			KEEP(*(_ftrace_enum_map))			\
 			VMLINUX_SYMBOL(__stop_ftrace_enum_maps) = .;
 #else
 #define FTRACE_EVENTS()
@@ -185,8 +187,8 @@
 #define _OF_TABLE_1(name)						\
 	. = ALIGN(8);							\
 	VMLINUX_SYMBOL(__##name##_of_table) = .;			\
-	*(__##name##_of_table)						\
-	*(__##name##_of_table_end)
+	KEEP(*(__##name##_of_table))					\
+	KEEP(*(__##name##_of_table_end))
 
 #define CLKSRC_OF_TABLES()	OF_TABLE(CONFIG_CLKSRC_OF, clksrc)
 #define IRQCHIP_OF_MATCH_TABLE() OF_TABLE(CONFIG_IRQCHIP, irqchip)
@@ -304,28 +306,28 @@
 	/* PCI quirks */						\
 	.pci_fixup        : AT(ADDR(.pci_fixup) - LOAD_OFFSET) {	\
 		VMLINUX_SYMBOL(__start_pci_fixups_early) = .;		\
-		*(.pci_fixup_early)					\
+		KEEP(*(.pci_fixup_early))				\
 		VMLINUX_SYMBOL(__end_pci_fixups_early) = .;		\
 		VMLINUX_SYMBOL(__start_pci_fixups_header) = .;		\
-		*(.pci_fixup_header)					\
+		KEEP(*(.pci_fixup_header))				\
 		VMLINUX_SYMBOL(__end_pci_fixups_header) = .;		\
 		VMLINUX_SYMBOL(__start_pci_fixups_final) = .;		\
-		*(.pci_fixup_final)					\
+		KEEP(*(.pci_fixup_final))				\
 		VMLINUX_SYMBOL(__end_pci_fixups_final) = .;		\
 		VMLINUX_SYMBOL(__start_pci_fixups_enable) = .;		\
-		*(.pci_fixup_enable)					\
+		KEEP(*(.pci_fixup_enable))				\
 		VMLINUX_SYMBOL(__end_pci_fixups_enable) = .;		\
 		VMLINUX_SYMBOL(__start_pci_fixups_resume) = .;		\
-		*(.pci_fixup_resume)					\
+		KEEP(*(.pci_fixup_resume))				\
 		VMLINUX_SYMBOL(__end_pci_fixups_resume) = .;		\
 		VMLINUX_SYMBOL(__start_pci_fixups_resume_early) = .;	\
-		*(.pci_fixup_resume_early)				\
+		KEEP(*(.pci_fixup_resume_early))			\
 		VMLINUX_SYMBOL(__end_pci_fixups_resume_early) = .;	\
 		VMLINUX_SYMBOL(__start_pci_fixups_suspend) = .;		\
-		*(.pci_fixup_suspend)					\
+		KEEP(*(.pci_fixup_suspend))				\
 		VMLINUX_SYMBOL(__end_pci_fixups_suspend) = .;		\
 		VMLINUX_SYMBOL(__start_pci_fixups_suspend_late) = .;	\
-		*(.pci_fixup_suspend_late)				\
+		KEEP(*(.pci_fixup_suspend_late))			\
 		VMLINUX_SYMBOL(__end_pci_fixups_suspend_late) = .;	\
 	}								\
 									\
@@ -423,7 +425,7 @@
 	/* Built-in module parameters. */				\
 	__param : AT(ADDR(__param) - LOAD_OFFSET) {			\
 		VMLINUX_SYMBOL(__start___param) = .;			\
-		*(__param)						\
+		KEEP(*(__param))					\
 		VMLINUX_SYMBOL(__stop___param) = .;			\
 	}								\
 									\
@@ -460,6 +462,8 @@
 #define TEXT_TEXT							\
 		ALIGN_FUNCTION();					\
 		*(.text.hot TEXT_MAIN .text.fixup .text.unlikely)	\
+		*(.text..ftrace)					\
+		*(TEXT_CFI_MAIN) 					\
 		*(.ref.text)						\
 	MEM_KEEP(init.text)						\
 	MEM_KEEP(exit.text)						\
@@ -499,28 +503,20 @@
 		*(.entry.text)						\
 		VMLINUX_SYMBOL(__entry_text_end) = .;
 
-#if defined(CONFIG_FUNCTION_GRAPH_TRACER) || defined(CONFIG_KASAN)
 #define IRQENTRY_TEXT							\
 		ALIGN_FUNCTION();					\
 		VMLINUX_SYMBOL(__irqentry_text_start) = .;		\
 		*(.irqentry.text)					\
 		VMLINUX_SYMBOL(__irqentry_text_end) = .;
-#else
-#define IRQENTRY_TEXT
-#endif
 
-#if defined(CONFIG_FUNCTION_GRAPH_TRACER) || defined(CONFIG_KASAN)
 #define SOFTIRQENTRY_TEXT						\
 		ALIGN_FUNCTION();					\
 		VMLINUX_SYMBOL(__softirqentry_text_start) = .;		\
 		*(.softirqentry.text)					\
 		VMLINUX_SYMBOL(__softirqentry_text_end) = .;
-#else
-#define SOFTIRQENTRY_TEXT
-#endif
 
 /* Section used for early init (in .S files) */
-#define HEAD_TEXT  *(.head.text)
+#define HEAD_TEXT  KEEP(*(.head.text))
 
 #define HEAD_TEXT_SECTION							\
 	.head.text : AT(ADDR(.head.text) - LOAD_OFFSET) {		\
@@ -534,7 +530,7 @@
 	. = ALIGN(align);						\
 	__ex_table : AT(ADDR(__ex_table) - LOAD_OFFSET) {		\
 		VMLINUX_SYMBOL(__start___ex_table) = .;			\
-		*(__ex_table)						\
+		KEEP(*(__ex_table))					\
 		VMLINUX_SYMBOL(__stop___ex_table) = .;			\
 	}
 
@@ -565,7 +561,7 @@
 	MEM_DISCARD(init.data)						\
 	KERNEL_CTORS()							\
 	MCOUNT_REC()							\
-	*(.init.rodata)							\
+	*(.init.rodata .init.rodata.*)					\
 	FTRACE_EVENTS()							\
 	TRACE_SYSCALLS()						\
 	KPROBE_BLACKLIST()						\
@@ -583,7 +579,7 @@
 	EARLYCON_TABLE()
 
 #define INIT_TEXT							\
-	*(.init.text)							\
+	*(.init.text .init.text.*)					\
 	*(.text.startup)						\
 	MEM_DISCARD(init.text)
 
@@ -600,7 +596,7 @@
 	MEM_DISCARD(exit.text)
 
 #define EXIT_CALL							\
-	*(.exitcall.exit)
+	KEEP(*(.exitcall.exit))
 
 /*
  * bss (Block Started by Symbol) - uninitialized data
@@ -676,7 +672,7 @@
 	. = ALIGN(8);							\
 	__bug_table : AT(ADDR(__bug_table) - LOAD_OFFSET) {		\
 		VMLINUX_SYMBOL(__start___bug_table) = .;		\
-		*(__bug_table)						\
+		KEEP(*(__bug_table))					\
 		VMLINUX_SYMBOL(__stop___bug_table) = .;			\
 	}
 #else
@@ -705,7 +701,7 @@
 #define INIT_SETUP(initsetup_align)					\
 		. = ALIGN(initsetup_align);				\
 		VMLINUX_SYMBOL(__setup_start) = .;			\
-		*(.init.setup)						\
+		KEEP(*(.init.setup))					\
 		VMLINUX_SYMBOL(__setup_end) = .;
 
 #define INIT_CALLS_LEVEL(level)						\
diff --git a/include/crypto/speck.h b/include/crypto/speck.h
new file mode 100644
index 00000000..73cfc95
--- /dev/null
+++ b/include/crypto/speck.h
@@ -0,0 +1,62 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Common values for the Speck algorithm
+ */
+
+#ifndef _CRYPTO_SPECK_H
+#define _CRYPTO_SPECK_H
+
+#include <linux/types.h>
+
+/* Speck128 */
+
+#define SPECK128_BLOCK_SIZE	16
+
+#define SPECK128_128_KEY_SIZE	16
+#define SPECK128_128_NROUNDS	32
+
+#define SPECK128_192_KEY_SIZE	24
+#define SPECK128_192_NROUNDS	33
+
+#define SPECK128_256_KEY_SIZE	32
+#define SPECK128_256_NROUNDS	34
+
+struct speck128_tfm_ctx {
+	u64 round_keys[SPECK128_256_NROUNDS];
+	int nrounds;
+};
+
+void crypto_speck128_encrypt(const struct speck128_tfm_ctx *ctx,
+			     u8 *out, const u8 *in);
+
+void crypto_speck128_decrypt(const struct speck128_tfm_ctx *ctx,
+			     u8 *out, const u8 *in);
+
+int crypto_speck128_setkey(struct speck128_tfm_ctx *ctx, const u8 *key,
+			   unsigned int keysize);
+
+/* Speck64 */
+
+#define SPECK64_BLOCK_SIZE	8
+
+#define SPECK64_96_KEY_SIZE	12
+#define SPECK64_96_NROUNDS	26
+
+#define SPECK64_128_KEY_SIZE	16
+#define SPECK64_128_NROUNDS	27
+
+struct speck64_tfm_ctx {
+	u32 round_keys[SPECK64_128_NROUNDS];
+	int nrounds;
+};
+
+void crypto_speck64_encrypt(const struct speck64_tfm_ctx *ctx,
+			    u8 *out, const u8 *in);
+
+void crypto_speck64_decrypt(const struct speck64_tfm_ctx *ctx,
+			    u8 *out, const u8 *in);
+
+int crypto_speck64_setkey(struct speck64_tfm_ctx *ctx, const u8 *key,
+			  unsigned int keysize);
+
+#endif /* _CRYPTO_SPECK_H */
diff --git a/include/drm/drm_atomic.h b/include/drm/drm_atomic.h
index 9701f2d..a5696c1 100644
--- a/include/drm/drm_atomic.h
+++ b/include/drm/drm_atomic.h
@@ -144,6 +144,7 @@ struct __drm_crtcs_state {
 	struct drm_crtc *ptr;
 	struct drm_crtc_state *state;
 	struct drm_crtc_commit *commit;
+	s32 __user *out_fence_ptr;
 };
 
 struct __drm_connnectors_state {
@@ -316,6 +317,8 @@ int drm_atomic_connector_set_property(struct drm_connector *connector,
 			      struct drm_crtc *crtc);
 void drm_atomic_set_fb_for_plane(struct drm_plane_state *plane_state,
 				 struct drm_framebuffer *fb);
+void drm_atomic_set_fence_for_plane(struct drm_plane_state *plane_state,
+				    struct fence *fence);
 int __must_check
 drm_atomic_set_crtc_for_connector(struct drm_connector_state *conn_state,
 				  struct drm_crtc *crtc);
diff --git a/include/drm/drm_crtc.h b/include/drm/drm_crtc.h
index 0aa2925..f3d58c7 100644
--- a/include/drm/drm_crtc.h
+++ b/include/drm/drm_crtc.h
@@ -680,6 +680,35 @@ struct drm_crtc {
 	 * context.
 	 */
 	struct drm_modeset_acquire_ctx *acquire_ctx;
+
+	/**
+	 * @fence_context:
+	 *
+	 * timeline context used for fence operations.
+	 */
+	unsigned int fence_context;
+
+	/**
+	 * @fence_lock:
+	 *
+	 * spinlock to protect the fences in the fence_context.
+	 */
+
+	spinlock_t fence_lock;
+	/**
+	 * @fence_seqno:
+	 *
+	 * Seqno variable used as monotonic counter for the fences
+	 * created on the CRTC's timeline.
+	 */
+	unsigned long fence_seqno;
+
+	/**
+	 * @timeline_name:
+	 *
+	 * The name of the CRTC's fence timeline.
+	 */
+	char timeline_name[32];
 };
 
 /**
@@ -1160,6 +1189,17 @@ struct drm_mode_config {
 	 */
 	struct drm_property *prop_fb_id;
 	/**
+	 * @prop_in_fence_fd: Sync File fd representing the incoming fences
+	 * for a Plane.
+	 */
+	struct drm_property *prop_in_fence_fd;
+	/**
+	 * @prop_out_fence_ptr: Sync File fd pointer representing the
+	 * outgoing fences for a CRTC. Userspace should provide a pointer to a
+	 * value of type s32, and then cast that pointer to u64.
+	 */
+	struct drm_property *prop_out_fence_ptr;
+	/**
 	 * @prop_crtc_id: Default atomic plane property to specify the
 	 * &drm_crtc.
 	 */
diff --git a/include/drm/drm_fb_cma_helper.h b/include/drm/drm_fb_cma_helper.h
index f313211..3b00f64 100644
--- a/include/drm/drm_fb_cma_helper.h
+++ b/include/drm/drm_fb_cma_helper.h
@@ -12,6 +12,8 @@
 struct drm_device;
 struct drm_file;
 struct drm_mode_fb_cmd2;
+struct drm_plane;
+struct drm_plane_state;
 
 struct drm_fbdev_cma *drm_fbdev_cma_init_with_funcs(struct drm_device *dev,
 	unsigned int preferred_bpp, unsigned int num_crtc,
@@ -41,6 +43,9 @@ struct drm_framebuffer *drm_fb_cma_create(struct drm_device *dev,
 struct drm_gem_cma_object *drm_fb_cma_get_gem_obj(struct drm_framebuffer *fb,
 	unsigned int plane);
 
+int drm_fb_cma_prepare_fb(struct drm_plane *plane,
+			  struct drm_plane_state *state);
+
 #ifdef CONFIG_DEBUG_FS
 struct seq_file;
 
diff --git a/include/drm/drm_plane.h b/include/drm/drm_plane.h
index 8b4dc62..952ef84 100644
--- a/include/drm/drm_plane.h
+++ b/include/drm/drm_plane.h
@@ -65,7 +65,7 @@ struct drm_plane_state {
 
 	struct drm_crtc *crtc;   /* do not write directly, use drm_atomic_set_crtc_for_plane() */
 	struct drm_framebuffer *fb;  /* do not write directly, use drm_atomic_set_fb_for_plane() */
-	struct fence *fence;
+	struct fence *fence; /* do not write directly, use drm_atomic_set_fence_for_plane() */
 
 	/* Signed dest location allows it to be partially off screen */
 	int32_t crtc_x, crtc_y;
diff --git a/include/dt-bindings/clock/rtk,clock-rtd119x.h b/include/dt-bindings/clock/rtk,clock-rtd119x.h
new file mode 100644
index 00000000..d53fdcb
--- /dev/null
+++ b/include/dt-bindings/clock/rtk,clock-rtd119x.h
@@ -0,0 +1,84 @@
+#ifndef __DT_BINDINGS_RTK_CLOCK_RTD119X_H
+#define __DT_BINDINGS_RTK_CLOCK_RTD119X_H
+
+/* 0x1800000c */
+#define CLK_EN_MISC             0
+#define CLK_EN_HDMIRX           1
+#define CLK_EN_GSPI             3
+#define CLK_EN_USB              4
+#define CLK_EN_PCR              5
+#define CLK_EN_ISO_MISC         6
+#define CLK_EN_HDMI             8
+#define CLK_EN_ETN              9
+#define CLK_EN_AIO             10
+#define CLK_EN_GPU             11
+#define CLK_EN_VE_H264         12
+#define CLK_EN_VE_JPEG         13
+#define CLK_EN_TVE             14
+#define CLK_EN_VO              15
+#define CLK_EN_LVDS            16
+#define CLK_EN_SE              17
+#define CLK_EN_DCU             18
+#define CLK_EN_CP              19
+#define CLK_EN_MD              20
+#define CLK_EN_TP              21
+#define CLK_EN_NF              23
+#define CLK_EN_EMMC            24
+#define CLK_EN_CR              25
+#define CLK_EN_SDIO_IP         26
+#define CLK_EN_MIPI            27
+#define CLK_EN_EMMC_IP         28
+#define CLK_EN_VE_H265         29
+#define CLK_EN_SDIO            30
+#define CLK_EN_SD_IP           31
+
+/* 0x18000010 */
+#define CLK_EN_MISC_I2C_5       1
+#define CLK_EN_SCPU             2
+#define CLK_EN_ACPU             4
+#define CLK_EN_VCPU             5
+#define CLK_EN_MISC_RTC        10
+#define CLK_EN_MISC_I2C_4      13
+#define CLK_EN_MISC_I2C_3      14
+#define CLK_EN_MISC_I2C_2      15
+#define CLK_EN_MISC_I2C_1      16
+#define CLK_EN_AIO_AU_CODEC    17
+#define CLK_EN_AIO_MOD         18
+#define CLK_EN_AIO_DA          19
+#define CLK_EN_AIO_HDMI        20
+#define CLK_EN_AIO_SPDIF       21
+#define CLK_EN_AIO_I2S         22
+#define CLK_EN_AIO_MCLK        23
+#define CLK_EN_UR1             28
+
+/* 0x1800708C */
+#define CLK_EN_MISC_MIX         0
+#define CLK_EN_MISC_VFD         1
+#define CLK_EN_MISC_CEC0        2
+#define CLK_EN_CBUSRX_SYS       3
+#define CLK_EN_CBUSTX_SYS       4
+#define CLK_EN_CBUS_SYS         5
+#define CLK_EN_CBUS_OSC         6
+#define CLK_EN_MISC_IR          7
+#define CLK_EN_MISC_UR0         8
+#define CLK_EN_I2C0             9
+#define CLK_EN_I2C6            10
+#define CLK_EN_ETN_250M        11
+#define CLK_EN_ETN_SYS         12
+
+/* CC */
+#define CC_PLL_SCPU             0
+#define CC_PLL_BUS              1
+#define CC_CLK_SYS              2
+#define CC_PLL_DCSB             3
+#define CC_CLK_SYSH             4
+#define CC_PLL_GPU              5
+#define CC_CLK_GPU              6
+#define CC_PLL_VCPU             7
+#define CC_CLK_VE               8
+#define CC_CLK_VE1              9
+#define CC_CLK_VE2             10
+#define CC_CLK_VE2_BPU         11
+#define CC_CLK_MAX             12
+
+#endif
diff --git a/include/dt-bindings/clock/rtk,clock-rtd129x.h b/include/dt-bindings/clock/rtk,clock-rtd129x.h
new file mode 100644
index 00000000..28e9531
--- /dev/null
+++ b/include/dt-bindings/clock/rtk,clock-rtd129x.h
@@ -0,0 +1,106 @@
+#ifndef __DT_BINDINGS_RTK_CLOCK_RTD129X_H
+#define __DT_BINDINGS_RTK_CLOCK_RTD129X_H
+
+/* 0x9800000C */
+#define CLK_EN_MISC             0
+#define CLK_EN_PCIE0            1
+#define CLK_EN_SATA_0           2
+#define CLK_EN_GSPI             3
+#define CLK_EN_USB              4
+#define CLK_EN_PCR              5
+#define CLK_EN_ISO_MISC         6
+#define CLK_EN_SATA_ALIVE_0     7
+#define CLK_EN_HDMI             8
+#define CLK_EN_ETN              9
+#define CLK_EN_AIO             10
+#define CLK_EN_GPU             11
+#define CLK_EN_VE1             12
+#define CLK_EN_VE2             13
+#define CLK_EN_TVE             14
+#define CLK_EN_VO              15
+#define CLK_EN_LVDS            16
+#define CLK_EN_SE              17
+#define CLK_EN_DCU             18
+#define CLK_EN_CP              19
+#define CLK_EN_MD              20
+#define CLK_EN_TP              21
+#define CLK_EN_RSA             22
+#define CLK_EN_NF              23
+#define CLK_EN_EMMC            24
+#define CLK_EN_CR              25
+#define CLK_EN_SDIO_IP         26
+#define CLK_EN_MIPI            27
+#define CLK_EN_EMMC_IP         28
+#define CLK_EN_VE3             29
+#define CLK_EN_SDIO            30
+#define CLK_EN_SD_IP           31
+
+/* 0x98000010 */
+#define CLK_EN_NAT              0
+#define CLK_EN_MISC_I2C_5       1
+#define CLK_EN_SCPU             2
+#define CLK_EN_JPEG             3
+#define CLK_EN_ACPU             4
+#define CLK_EN_PCIE1            5
+#define CLK_EN_MISC_SC          6
+#define CLK_EN_CBUS_TX          7
+#define CLK_EN_MISC_RTC        10
+#define CLK_EN_MISC_I2C_4      13
+#define CLK_EN_MISC_I2C_3      14
+#define CLK_EN_MISC_I2C_2      15
+#define CLK_EN_MISC_I2C_1      16
+#define CLK_EN_AIO_AU_CODEC    17
+#define CLK_EN_AIO_MOD         18
+#define CLK_EN_AIO_DA          19
+#define CLK_EN_AIO_HDMI        20
+#define CLK_EN_AIO_SPDIF       21
+#define CLK_EN_AIO_I2S         22
+#define CLK_EN_AIO_MCLK        23
+#define CLK_EN_HDMIRX          24
+#define CLK_EN_SATA_1          25
+#define CLK_EN_SATA_ALIVE_1    26
+#define CLK_EN_UR2             27
+#define CLK_EN_UR1             28
+#define CLK_EN_FAN             29
+#define CLK_EN_DCPHY_0         30
+#define CLK_EN_DCPHY_1         31
+
+/* 0x9800708C */
+#define CLK_EN_MISC_MIX         0
+#define CLK_EN_MISC_CEC0        2
+#define CLK_EN_CBUSRX_SYS       3
+#define CLK_EN_CBUSTX_SYS       4
+#define CLK_EN_CBUS_SYS         5
+#define CLK_EN_CBUS_OSC         6
+#define CLK_EN_MISC_IR          7
+#define CLK_EN_MISC_UR0         8
+#define CLK_EN_I2C0             9
+#define CLK_EN_I2C1            10
+#define CLK_EN_ETN_250M        11
+#define CLK_EN_ETN_SYS         12
+
+/* CC */
+#define CC_PLL_SCPU             0
+#define CC_CLK_SCPU             1
+#define CC_CLK_SCPU_SET         2
+#define CC_PLL_BUS              3
+#define CC_PLL_BUS_DIV2         4
+#define CC_CLK_SYS              5
+#define CC_CLK_SYS_SB2          6
+#define CC_PLL_BUS_H            7
+#define CC_CLK_SYSH             8
+#define CC_PLL_DDSA             9
+#define CC_PLL_DDSB            10
+#define CC_PLL_GPU             11
+#define CC_CLK_GPU             12
+#define CC_PLL_VE1             13
+#define CC_PLL_VE2             14
+#define CC_CLK_VE1             15
+#define CC_CLK_VE2             16
+#define CC_CLK_VE3             17
+#define CC_PLL_VODMA           18
+#define CC_PLL_ACPU            19
+#define CC_CLK_ACPU            20
+#define CC_CLK_MAX             21
+
+#endif
diff --git a/include/dt-bindings/clock/rtk,clock-rtd139x.h b/include/dt-bindings/clock/rtk,clock-rtd139x.h
new file mode 100644
index 00000000..57e0ebb
--- /dev/null
+++ b/include/dt-bindings/clock/rtk,clock-rtd139x.h
@@ -0,0 +1,92 @@
+#ifndef __DT_BINDINGS_RTK_CLOCK_RTD139X_H
+#define __DT_BINDINGS_RTK_CLOCK_RTD139X_H
+
+/* 0x9800000C */
+#define CLK_EN_MISC             0
+#define CLK_EN_PCIE0            1
+#define CLK_EN_DIP              2
+#define CLK_EN_GSPI             3
+#define CLK_EN_PCR              5
+#define CLK_EN_ISO_MISC         6
+#define CLK_EN_SDS              7
+#define CLK_EN_HDMI             8
+#define CLK_EN_AIO             10
+#define CLK_EN_GPU             11
+#define CLK_EN_VE1             12
+#define CLK_EN_VE2             13
+#define CLK_EN_TVE             14
+#define CLK_EN_VO              15
+#define CLK_EN_LSADC           16
+#define CLK_EN_SE              17
+#define CLK_EN_DCU             18
+#define CLK_EN_CP              19
+#define CLK_EN_MD              20
+#define CLK_EN_TP              21
+#define CLK_EN_RSA             22
+#define CLK_EN_NF              23
+#define CLK_EN_EMMC            24
+#define CLK_EN_CR              25
+#define CLK_EN_SDIO_IP         26
+#define CLK_EN_MIPI            27
+#define CLK_EN_EMMC_IP         28
+#define CLK_EN_SDIO            30
+#define CLK_EN_SD_IP           31
+
+/* 0x98000010 */
+#define CLK_EN_MISC_I2C_5       1
+#define CLK_EN_SCPU             2
+#define CLK_EN_JPEG             3
+#define CLK_EN_ACPU             4
+#define CLK_EN_AE               5
+#define CLK_EN_MISC_SC          6
+#define CLK_EN_AIO_AU_CODEC    17
+#define CLK_EN_AIO_MOD         18
+#define CLK_EN_AIO_DA          19
+#define CLK_EN_AIO_HDMI        20
+#define CLK_EN_AIO_SPDIF       21
+#define CLK_EN_AIO_I2S         22
+#define CLK_EN_AIO_MCLK        23
+#define CLK_EN_HSE             25
+#define CLK_EN_UR2             27
+#define CLK_EN_UR1             28
+#define CLK_EN_FAN             29
+#define CLK_EN_DCPHY_0         30
+#define CLK_EN_DCPHY_1         31
+
+/* 0x9800708C */
+#define CLK_EN_MISC_CEC0        2
+#define CLK_EN_CBUSRX_SYS       3
+#define CLK_EN_CBUSTX_SYS       4
+#define CLK_EN_CBUS_SYS         5
+#define CLK_EN_CBUS_OSC         6
+#define CLK_EN_MISC_IR          7
+#define CLK_EN_MISC_UR0         8
+#define CLK_EN_I2C0             9
+#define CLK_EN_I2C1            10
+#define CLK_EN_ETN_250M        11
+#define CLK_EN_ETN_SYS         12
+#define CLK_EN_USB_DRD         13
+#define CLK_EN_USB_HOST_0      14
+#define CLK_EN_USB_HOST_1      15
+#define CLK_EN_USB             16
+
+/* CC */
+#define CC_PLL_SCPU             0
+#define CC_PLL_BUS              3
+#define CC_PLL_BUS_DIV2         4
+#define CC_CLK_SYS              5
+#define CC_CLK_SYS_SB2          6
+#define CC_PLL_BUS_H            7
+#define CC_CLK_SYSH             8
+#define CC_PLL_DDSA             9
+#define CC_PLL_DDSB            10
+#define CC_PLL_GPU             11
+#define CC_CLK_GPU             12
+#define CC_PLL_VE1             13
+#define CC_PLL_VE2             14
+#define CC_CLK_VE1             15
+#define CC_CLK_VE2             16
+#define CC_CLK_VE2_BPU         17
+#define CC_CLK_MAX             21
+
+#endif
diff --git a/include/dt-bindings/clock/rtk,clock-rtd13xx.h b/include/dt-bindings/clock/rtk,clock-rtd13xx.h
new file mode 100644
index 00000000..3bc3d89
--- /dev/null
+++ b/include/dt-bindings/clock/rtk,clock-rtd13xx.h
@@ -0,0 +1,131 @@
+#ifndef __DT_BINDINGS_RTK_CLOCK_RTD13XX_H
+#define __DT_BINDINGS_RTK_CLOCK_RTD13XX_H
+
+/* 0x98000050 */
+#define CLK_EN_MISC             0
+#define CLK_EN_PCIE0            2
+#define CLK_EN_DIP              4
+#define CLK_EN_GSPI             6
+#define CLK_EN_PCR              8
+#define CLK_EN_ISO_MISC        10
+#define CLK_EN_SDS             12
+#define CLK_EN_HDMI            14
+#define CLK_EN_AIO             16
+#define CLK_EN_GPU             18
+#define CLK_EN_VE1             20
+#define CLK_EN_VE2             22
+#define CLK_EN_TVE             24
+#define CLK_EN_VO              26
+#define CLK_EN_LSADC           28
+#define CLK_EN_SE              30
+
+/* 0x98000054 */
+#define CLK_EN_DCU              0
+#define CLK_EN_CP               2
+#define CLK_EN_MD               4
+#define CLK_EN_TP               6
+#define CLK_EN_RSA              8
+#define CLK_EN_NF              10
+#define CLK_EN_EMMC            12
+#define CLK_EN_SD              14
+#define CLK_EN_SDIO_IP         16
+#define CLK_EN_MIPI            18
+#define CLK_EN_EMMC_IP         20
+#define CLK_EN_SDIO            22
+#define CLK_EN_SD_IP           24
+#define CLK_EN_CABLERX         26
+#define CLK_EN_TPB             28
+#define CLK_EN_MISC_SC1        30
+
+/* 0x98000058 */
+#define CLK_EN_MISC_I2C_3       0
+#define CLK_EN_SCPU             2
+#define CLK_EN_JPEG             4
+#define CLK_EN_ACPU             6
+#define CLK_EN_AE               8
+#define CLK_EN_MISC_SC0        10
+#define CLK_EN_AIO_AU_CODEC    12
+#define CLK_EN_AIO_MOD         14
+#define CLK_EN_AIO_DA          16
+#define CLK_EN_AIO_HDMI        18
+#define CLK_EN_AIO_SPDIF       20
+#define CLK_EN_AIO_I2S         22
+#define CLK_EN_AIO_MCLK        24
+#define CLK_EN_HDMIRX          26
+#define CLK_EN_HSE             28
+#define CLK_EN_UR2             30
+
+/* 0x9800005C */
+#define CLK_EN_UR1              0
+#define CLK_EN_FAN              2
+#define CLK_EN_DCPHY_0          4
+#define CLK_EN_DCPHY_1          6
+#define CLK_EN_SATA_WRAP_SYS    8
+#define CLK_EN_SATA_WRAP_SYSH  10
+#define CLK_EN_SATA_MAC_SYSH   12
+#define CLK_EN_R2RDSC          14
+#define CLK_EN_TPC             16
+#define CLK_EN_PCIE1           18
+#define CLK_EN_MISC_I2C_4      20
+#define CLK_EN_MISC_I2C_5      22
+#define CLK_EN_TSIO            24
+#define CLK_EN_VE3             26
+#define CLK_EN_EDP             28
+#define CLK_EN_TSIO_TRX        30
+
+/* 0x98000084 */
+#define CLK_EN_DSC              0
+#define CLK_EN_ND               2
+#define CLK_EN_AKL              4
+#define CLK_EN_SCE              6
+#define CLK_EN_KT               8
+
+/* 0x9800008C */
+#define CLK_EN_PCIE2            0
+#define CLK_EN_EARC             4
+
+/* 0x9800708C */
+#define CLK_EN_LSADC_ECOA2      0
+#define CLK_EN_MISC_CEC0        2
+#define CLK_EN_CBUSRX_SYS       3
+#define CLK_EN_CBUSTX_SYS       4
+#define CLK_EN_CBUS_SYS         5
+#define CLK_EN_CBUS_OSC         6
+#define CLK_EN_MISC_IR          7
+#define CLK_EN_MISC_UR0         8
+#define CLK_EN_I2C0             9
+#define CLK_EN_I2C1            10
+#define CLK_EN_ETN_250M        11
+#define CLK_EN_ETN_SYS         12
+#define CLK_EN_USB_DRD         13
+#define CLK_EN_USB_HOST        14
+#define CLK_EN_USB_U3_HOST     15
+#define CLK_EN_USB             16
+
+/* 0x98007064 */
+#define CLK_EN_ISO_GSPI         9
+
+/* CC */
+#define CC_PLL_SCPU             0
+#define CC_PLL_BUS              2
+#define CC_CLK_SYS              3
+#define CC_CLK_SYS_SB2          4
+#define CC_PLL_DCSB             5
+#define CC_CLK_SYSH             6
+#define CC_PLL_DDSA             7
+#define CC_PLL_DDSB             8
+#define CC_PLL_GPU              9
+#define CC_CLK_GPU             10
+#define CC_PLL_VE1             11
+#define CC_PLL_VE2             12
+#define CC_CLK_VE1             13
+#define CC_CLK_VE2             14
+#define CC_CLK_VE3             15
+#define CC_CLK_VE3_BPU         16
+#define CC_PLL_DIF             17
+#define CC_PLL_PSAUD1A         18
+#define CC_PLL_PSAUD2A         19
+#define CC_CLK_MAX             20
+
+
+#endif /* __DT_BINDINGS_RTK_CLOCK_RTD13XX_H */
diff --git a/include/dt-bindings/clock/rtk,clock-rtd16xx.h b/include/dt-bindings/clock/rtk,clock-rtd16xx.h
new file mode 100644
index 00000000..265798e
--- /dev/null
+++ b/include/dt-bindings/clock/rtk,clock-rtd16xx.h
@@ -0,0 +1,118 @@
+#ifndef __DT_BINDINGS_RTK_CLOCK_RTD16XX_H
+#define __DT_BINDINGS_RTK_CLOCK_RTD16XX_H
+
+/* 0x98000050 */
+#define CLK_EN_MISC             0
+#define CLK_EN_PCIE0            2
+#define CLK_EN_DIP              4
+#define CLK_EN_GSPI             6
+#define CLK_EN_PCR              8
+#define CLK_EN_ISO_MISC        10
+#define CLK_EN_SDS             12
+#define CLK_EN_HDMI            14
+#define CLK_EN_AIO             16
+#define CLK_EN_GPU             18
+#define CLK_EN_VE1             20
+#define CLK_EN_VE2             22
+#define CLK_EN_TVE             24
+#define CLK_EN_VO              26
+#define CLK_EN_LSADC           28
+#define CLK_EN_SE              30
+
+/* 0x98000054 */
+#define CLK_EN_DCU              0
+#define CLK_EN_CP               2
+#define CLK_EN_MD               4
+#define CLK_EN_TP               6
+#define CLK_EN_RSA              8
+#define CLK_EN_NF              10
+#define CLK_EN_EMMC            12
+#define CLK_EN_SD              14
+#define CLK_EN_SDIO_IP         16
+#define CLK_EN_MIPI            18
+#define CLK_EN_EMMC_IP         20
+#define CLK_EN_SDIO            22
+#define CLK_EN_SD_IP           24
+#define CLK_EN_CABLERX         26
+#define CLK_EN_TPB             28
+#define CLK_EN_MISC_SC1        30
+
+/* 0x98000058 */
+#define CLK_EN_MISC_I2C_3       0
+#define CLK_EN_SCPU             2
+#define CLK_EN_JPEG             4
+#define CLK_EN_ACPU             6
+#define CLK_EN_AE               8
+#define CLK_EN_MISC_SC0        10
+#define CLK_EN_AIO_AU_CODEC    12
+#define CLK_EN_AIO_MOD         14
+#define CLK_EN_AIO_DA          16
+#define CLK_EN_AIO_HDMI        18
+#define CLK_EN_AIO_SPDIF       20
+#define CLK_EN_AIO_I2S         22
+#define CLK_EN_AIO_MCLK        24
+#define CLK_EN_HDMIRX          26
+#define CLK_EN_HSE             28
+#define CLK_EN_UR2             30
+
+/* 0x9800005C */
+#define CLK_EN_UR1              0
+#define CLK_EN_FAN              2
+#define CLK_EN_DCPHY_0          4
+#define CLK_EN_DCPHY_1          6
+#define CLK_EN_SATA_WRAP_SYS    8
+#define CLK_EN_SATA_WRAP_SYSH  10
+#define CLK_EN_SATA_MAC_SYSH   12
+#define CLK_EN_R2RDSC          14
+#define CLK_EN_PCIE1           18
+#define CLK_EN_MISC_I2C_4      20
+#define CLK_EN_MISC_I2C_5      22
+#define CLK_EN_TSIO            24
+#define CLK_EN_VE3             26
+#define CLK_EN_EDP             28
+#define CLK_EN_TSIO_TRX        30
+
+/* 0x9800708C */
+#define CLK_EN_MISC_MIX         0
+#define CLK_EN_MISC_VFD         1
+#define CLK_EN_MISC_CEC0        2
+#define CLK_EN_CBUSRX_SYS       3
+#define CLK_EN_CBUSTX_SYS       4
+#define CLK_EN_CBUS_SYS         5
+#define CLK_EN_CBUS_OSC         6
+#define CLK_EN_MISC_IR          7
+#define CLK_EN_MISC_UR0         8
+#define CLK_EN_I2C0             9
+#define CLK_EN_I2C1            10
+#define CLK_EN_ETN_250M        11
+#define CLK_EN_ETN_SYS         12
+#define CLK_EN_USB_DRD         13
+#define CLK_EN_USB_HOST        14
+#define CLK_EN_USB_U3_HOST     15
+#define CLK_EN_USB             16
+
+/* CC */
+#define CC_PLL_SCPU             0
+#define CC_PLL_BUS              2
+#define CC_CLK_SYS              3
+#define CC_CLK_SYS_SB2          4
+#define CC_PLL_DCSB             5
+#define CC_CLK_SYSH             6
+#define CC_PLL_DDSA             7
+#define CC_PLL_DDSB             8
+#define CC_PLL_GPU              9
+#define CC_CLK_GPU             10
+#define CC_PLL_VE1             11
+#define CC_PLL_VE2             12
+#define CC_CLK_VE1             13
+#define CC_CLK_VE2             14
+#define CC_CLK_VE3             15
+#define CC_CLK_VE2_BPU         16
+#define CC_PLL_DIF             17
+#define CC_PLL_PSAUD1A         18
+#define CC_PLL_PSAUD2A         19
+#define CC_CLK_MAX             20
+
+#endif /* __DT_BINDINGS_RTK_CLOCK_RTD16XX_H */
+
+
diff --git a/include/dt-bindings/power/rtk,power-rtd129x.h b/include/dt-bindings/power/rtk,power-rtd129x.h
new file mode 100644
index 00000000..89c9ff9
--- /dev/null
+++ b/include/dt-bindings/power/rtk,power-rtd129x.h
@@ -0,0 +1,14 @@
+#ifndef __DT_BINDINGS_POWER_RTK_POWER_RTD129X_H
+#define __DT_BINDINGS_POWER_RTK_POWER_RTD129X_H
+
+#define PD_SRAM_VE1          0
+#define PD_SRAM_VE2          1
+#define PD_SRAM_GPU          2
+#define PD_SRAM_VE3          3
+#define PD_SRAM_NAT          4
+#define PD_SRAM_DISP_SE      5
+#define PD_SRAM_DISP_MIPI    6
+#define PD_SRAM_DISP_HDMIRX  7
+#define PD_MAX               8
+
+#endif
diff --git a/include/dt-bindings/power/rtk,power-rtd139x.h b/include/dt-bindings/power/rtk,power-rtd139x.h
new file mode 100644
index 00000000..cde22fd
--- /dev/null
+++ b/include/dt-bindings/power/rtk,power-rtd139x.h
@@ -0,0 +1,11 @@
+#ifndef __DT_BINDINGS_POWER_RTK_POWER_RTD139X_H
+#define __DT_BINDINGS_POWER_RTK_POWER_RTD139X_H
+
+#define RTD139X_PD_VE1   0
+#define RTD139X_PD_VE2   1
+#define RTD139X_PD_GPU   2
+#define RTD139X_PD_DISP  3
+#define RTD139X_PD_MAX   4
+
+
+#endif
diff --git a/include/dt-bindings/power/rtk,power-rtd13xx.h b/include/dt-bindings/power/rtk,power-rtd13xx.h
new file mode 100644
index 00000000..728787e
--- /dev/null
+++ b/include/dt-bindings/power/rtk,power-rtd13xx.h
@@ -0,0 +1,18 @@
+#ifndef __DT_BINDINGS_POWER_RTK_POWER_RTD13XX_H
+#define __DT_BINDINGS_POWER_RTK_POWER_RTD13XX_H
+
+#define PD_SRAM_VE1         0
+#define PD_SRAM_VE2         1
+#define PD_SRAM_GPU         2
+#define PD_SRAM_VE3         3
+#define PD_MAX              4
+
+/* undefined */
+#define PD_SRAM_DISP
+#define PD_SRAM_DCPHY0
+#define PD_SRAM_MAIN1
+#define PD_SRAM_SCPU
+#define PD_SRAM_MAIN2
+#define PD_SRAM_HDMI_TOP
+
+#endif
diff --git a/include/dt-bindings/power/rtk,power-rtd16xx.h b/include/dt-bindings/power/rtk,power-rtd16xx.h
new file mode 100644
index 00000000..8d6da06
--- /dev/null
+++ b/include/dt-bindings/power/rtk,power-rtd16xx.h
@@ -0,0 +1,19 @@
+#ifndef __DT_BINDINGS_POWER_RTK_POWER_RTD16XX_H
+#define __DT_BINDINGS_POWER_RTK_POWER_RTD16XX_H
+
+#define PD_SRAM_VE1         0
+#define PD_SRAM_VE2         1
+#define PD_SRAM_GPU         2
+#define PD_SRAM_VE3         3
+#define PD_SRAM_HDMIRX      4
+#define PD_MAX              5
+
+/* undefined */
+#define PD_SRAM_DISP
+#define PD_SRAM_DCPHY0
+#define PD_SRAM_MAIN1
+#define PD_SRAM_SCPU
+#define PD_SRAM_MAIN2
+#define PD_SRAM_HDMI_TOP
+
+#endif
diff --git a/include/dt-bindings/regulator/anpec,apw888x.h b/include/dt-bindings/regulator/anpec,apw888x.h
new file mode 100644
index 00000000..387340d
--- /dev/null
+++ b/include/dt-bindings/regulator/anpec,apw888x.h
@@ -0,0 +1,12 @@
+#ifndef __DT_BINDINGS_REGULATOR_ANPEC_APW888X_H
+#define __DT_BINDINGS_REGULATOR_ANPEC_APW888X_H
+
+#define APW8889_DC_MODE_AUTO              (0x0)
+#define APW8889_DC_MODE_FORCE_PWM         (0x1)
+#define APW8889_LDO_MODE_NORMAL           (APW8889_DC_MODE_AUTO)
+
+#define APW888X_DC_MODE_AUTO              (0x0)
+#define APW888X_DC_MODE_FORCE_PWM         (0x1)
+#define APW888X_LDO_MODE_NORMAL           (APW888X_DC_MODE_AUTO)
+
+#endif
diff --git a/include/dt-bindings/regulator/gmt,g22xx.h b/include/dt-bindings/regulator/gmt,g22xx.h
new file mode 100644
index 00000000..b3751d3
--- /dev/null
+++ b/include/dt-bindings/regulator/gmt,g22xx.h
@@ -0,0 +1,27 @@
+#ifndef __DT_BINDINGS_REGULATOR_G22XX_H
+#define __DT_BINDINGS_REGULATOR_G22XX_H
+
+#define G22XX_DC_MODE_AUTO              (0)
+#define G22XX_DC_MODE_FORCE_PWM         (1)
+#define G22XX_LDO_MODE_NORMAL           (G22XX_DC_MODE_AUTO)
+#define G22XX_LDO_MODE_ECO              (2)
+
+#define G22XX_LPOFF_TO_SHUTDOWN         (0)
+#define G22XX_LPOFF_TO_RESTART          (1)
+
+#define G22XX_TIME_IT_0128MS            (0)
+#define G22XX_TIME_IT_0500MS            (1)
+#define G22XX_TIME_IT_1000MS            (2)
+#define G22XX_TIME_IT_1500MS            (3)
+
+#define G22XX_TIME_LP_01S               (0)
+#define G22XX_TIME_LP_02S               (1)
+#define G22XX_TIME_LP_03S               (2)
+#define G22XX_TIME_LP_04S               (3)
+
+#define G22XX_TIME_LPOFF_06S            (0)
+#define G22XX_TIME_LPOFF_07S            (1)
+#define G22XX_TIME_LPOFF_08S            (2)
+#define G22XX_TIME_LPOFF_10S            (3)
+
+#endif
diff --git a/include/dt-bindings/reset/rtk,reset-rtd119x.h b/include/dt-bindings/reset/rtk,reset-rtd119x.h
new file mode 100644
index 00000000..507e48d
--- /dev/null
+++ b/include/dt-bindings/reset/rtk,reset-rtd119x.h
@@ -0,0 +1,65 @@
+#ifndef __DT_BINDINGS_RTK_RESET_RTD119X_H
+#define __DT_BINDINGS_RTK_RESET_RTD119X_H
+
+/* 0x18000000 */
+#define RSTN_MISC               0
+#define RSTN_RNG                1
+#define RSTN_USB3_POW           2
+#define RSTN_GSPI               3
+#define RSTN_USB3_P0_MDIO       4
+#define RSTN_VE_H265            5
+#define RSTN_USB                6
+#define RSTN_USB_PHY0           8
+#define RSTN_USB_PHY1           9
+#define RSTN_HDMIRX            11
+#define RSTN_HDMI              12
+#define RSTN_ETN               14
+#define RSTN_AIO               15
+#define RSTN_GPU               16
+#define RSTN_VE_H264           17
+#define RSTN_VE_JPEG           18
+#define RSTN_TVE               19
+#define RSTN_VO                20
+#define RSTN_LVDS              21
+#define RSTN_SE                22
+#define RSTN_DCU               23
+#define RSTN_DC_PHY            24
+#define RSTN_CP                25
+#define RSTN_MD                26
+#define RSTN_TP                27
+#define RSTN_AE                28
+#define RSTN_NF                29
+#define RSTN_MIPI              30
+
+/* 0x18000004 */
+#define RSTN_ACPU               0
+#define RSTN_VCPU               1
+#define RSTN_PCR_CNT            9
+#define RSTN_CR                10
+#define RSTN_EMMC              11
+#define RSTN_SDIO              12
+#define RSTN_I2C_5             18
+#define RSTN_RTC               20
+#define RSTN_I2C_4             23
+#define RSTN_I2C_3             24
+#define RSTN_I2C_2             25
+#define RSTN_I2C_1             26
+#define RSTN_UR1               28
+
+/* 0x18007088 */
+#define IRSTN_VFD               0
+#define IRSTN_IR                1
+#define IRSTN_CEC0              2
+#define IRSTN_CEC1              3
+#define IRSTN_DP                4
+#define IRSTN_CBUSTX            5
+#define IRSTN_CBUSRX            6
+#define IRSTN_EFUSE             7
+#define IRSTN_UR0               8
+#define IRSTN_GMAC              9
+#define IRSTN_GPHY             10
+#define IRSTN_I2C_0            11
+#define IRSTN_I2C_6            12
+#define IRSTN_CBUS             13
+
+#endif
diff --git a/include/dt-bindings/reset/rtk,reset-rtd129x.h b/include/dt-bindings/reset/rtk,reset-rtd129x.h
new file mode 100644
index 00000000..1bd49a5
--- /dev/null
+++ b/include/dt-bindings/reset/rtk,reset-rtd129x.h
@@ -0,0 +1,108 @@
+#ifndef __DT_BINDINGS_RTK_RESET_RTD129X_H
+#define __DT_BINDINGS_RTK_RESET_RTD129X_H
+
+/* 0x98000000 */
+#define RSTN_MISC               0
+#define RSTN_NAT                1
+#define RSTN_USB3_PHY0_POW      2
+#define RSTN_GSPI               3
+#define RSTN_USB3_P0_MDIO       4
+#define RSTN_SATA_0             5
+#define RSTN_USB                6
+#define RSTN_SATA_PHY_0         7
+#define RSTN_USB_PHY0           8
+#define RSTN_USB_PHY1           9
+#define RSTN_SATA_PHY_POW_0    10
+#define SATA_FUNC_EXIST_0      11
+#define RSTN_HDMI              12
+#define RSTN_VE1               13
+#define RSTN_VE2               14
+#define RSTN_VE3               15
+#define RSTN_ETN               16
+#define RSTN_AIO               17
+#define RSTN_GPU               18
+#define RSTN_TVE               19
+#define RSTN_VO                20
+#define RSTN_LVDS              21
+#define RSTN_SE                22
+#define RSTN_DCU               23
+#define RSTN_DC_PHY            24
+#define RSTN_CP                25
+#define RSTN_MD                26
+#define RSTN_TP                27
+#define RSTN_AE                28
+#define RSTN_NF                29
+#define RSTN_MIPI              30
+#define RSTN_RSA               31
+
+/* 0x98000004 */
+#define RSTN_ACPU               0
+#define RSTN_JPEG               1
+#define RSTN_USB_PHY3           2
+#define RSTN_USB_PHY2           3
+#define RSTN_USB3_PHY1_POW      4
+#define RSTN_USB3_P1_MDIO       5
+#define RSTN_PCIE0_STITCH       6
+#define RSTN_PCIE0_PHY          7
+#define RSTN_PCIE0              8
+#define RSTN_PCR_CNT            9
+#define RSTN_CR                10
+#define RSTN_EMMC              11
+#define RSTN_SDIO              12
+#define RSTN_PCIE0_CORE        13
+#define RSTN_PCIE0_POWER       14
+#define RSTN_PCIE0_NONSTITCH   15
+#define RSTN_PCIE1_PHY         16
+#define RSTN_PCIE1             17
+#define RSTN_I2C_5             18
+#define RSTN_PCIE1_STITCH      19
+#define RSTN_PCIE1_CORE        20
+#define RSTN_PCIE1_POWER       21
+#define RSTN_PCIE1_NONSTITCH   22
+#define RSTN_I2C_4             23
+#define RSTN_I2C_3             24
+#define RSTN_I2C_2             25
+#define RSTN_I2C_1             26
+#define RSTN_UR2               27
+#define RSTN_UR1               28
+#define RSTN_MISC_SC           29
+#define RSTN_CBUS_TX           30
+#define RSTN_SDS_PHY           31
+
+/* 0x98000008 */
+#define RSTN_SB2                0
+
+/* 0x98000050 */
+#define RSTN_DCPHY_CRT          0
+#define RSTN_DCPHY_ALERT_RX     1
+#define RSTN_DCPHY_PTR          2
+#define RSTN_DCPHY_LDO          3
+#define RSTN_DCPHY_SSC_DIG      4
+#define RSTN_HDMIRX             5
+#define RSTN_CBUSRX             6
+#define RSTN_SATA_PHY_POW_1     7
+#define SATA_FUNC_EXIST_1       8
+#define RSTN_SATA_PHY_1         9
+#define RSTN_SATA_1            10
+#define RSTN_FAN               11
+#define RSTN_HDMIRX_WRAP       12
+#define RSTN_PCIE0_PHY_MDIO    13
+#define RSTN_PCIE1_PHY_MDIO    14
+#define RSTN_DISP              15
+
+/* 0x98007084 */
+#define IRSTN_IR                1
+#define IRSTN_CEC0              2
+#define IRSTN_CEC1              3
+#define IRSTN_DP                4
+#define IRSTN_CBUSTX            5
+#define IRSTN_CBUSRX            6
+#define IRSTN_EFUSE             7
+#define IRSTN_UR0               8
+#define IRSTN_GMAC              9
+#define IRSTN_GPHY             10
+#define IRSTN_I2C_0            11
+#define IRSTN_I2C_1            12
+#define IRSTN_CBUS             13
+
+#endif
diff --git a/include/dt-bindings/reset/rtk,reset-rtd139x.h b/include/dt-bindings/reset/rtk,reset-rtd139x.h
new file mode 100644
index 00000000..569f6a7
--- /dev/null
+++ b/include/dt-bindings/reset/rtk,reset-rtd139x.h
@@ -0,0 +1,83 @@
+#ifndef __DT_BINDINGS_RTK_RESET_RTD139X_H
+#define __DT_BINDINGS_RTK_RESET_RTD139X_H
+
+/* 0x98000000 */
+#define RSTN_MISC               0
+#define RSTN_DIP                1
+#define RSTN_GSPI               2
+#define RSTN_SDS                3
+#define RSTN_SDS_REG            4
+#define RSTN_HDMI              12
+#define RSTN_VE1               13
+#define RSTN_VE2               14
+#define RSTN_VE1_WRAPPER       15
+#define RSTN_AIO               17
+#define RSTN_GPU               18
+#define RSTN_TVE               19
+#define RSTN_VO                20
+#define RSTN_LSADC             21
+#define RSTN_SE                22
+#define RSTN_HSE               23
+#define RSTN_DC_PHY            24
+#define RSTN_CP                25
+#define RSTN_MD                26
+#define RSTN_TP                27
+#define RSTN_AE                28
+#define RSTN_NF                29
+#define RSTN_MIPI              30
+#define RSTN_RSA               31
+
+/* 0x98000004 */
+#define RSTN_JPEG               1
+#define RSTN_PCIE0_STITCH       6
+#define RSTN_PCIE0_PHY          7
+#define RSTN_PCIE0              8
+#define RSTN_PCR_CNT            9
+#define RSTN_CR                10
+#define RSTN_EMMC              11
+#define RSTN_SDIO              12
+#define RSTN_PCIE0_CORE        13
+#define RSTN_PCIE0_POWER       14
+#define RSTN_PCIE0_NONSTITCH   15
+#define RSTN_I2C_5             16
+#define RSTN_I2C_1             26
+#define RSTN_UR2               27
+#define RSTN_UR1               28
+#define RSTN_MISC_SC           29
+#define RSTN_SDS_PHY           31
+
+/* 0x98000008 */
+#define RSTN_SB2                0
+
+/* 0x98000050 */
+#define RSTN_DCPHY_CRT          0
+#define RSTN_HDMIRX             5
+#define RSTN_FAN               11
+#define RSTN_HDMIRX_WRAP       12
+#define RSTN_PCIE0_PHY_MDIO    13
+#define RSTN_DISP              15
+#define RSTN_PCIE0_SGMII_MDIO  16
+
+/* 0x98000088 */
+#define IRSTN_IR                1
+#define IRSTN_CEC0              2
+#define IRSTN_CEC1              3
+#define IRSTN_DP                4
+#define IRSTN_CBUSTX            5
+#define IRSTN_CBUSRX            6
+#define IRSTN_EFUSE             7
+#define IRSTN_UR0               8
+#define IRSTN_GMAC              9
+#define IRSTN_GPHY             10
+#define IRSTN_I2C_0            11
+#define IRSTN_I2C_1            12
+#define IRSTN_CBUS             13
+#define IRSTN_USB_DRD          14
+#define IRSTN_USB_HOST         15
+#define IRSTN_USB_PHY_0        16
+#define IRSTN_USB_PHY_1        17
+#define IRSTN_USB_PHY_2        18
+#define IRSTN_USB              19
+#define IRSTN_TYPE_C           20
+
+#endif
diff --git a/include/dt-bindings/reset/rtk,reset-rtd13xx.h b/include/dt-bindings/reset/rtk,reset-rtd13xx.h
new file mode 100644
index 00000000..f4b0713
--- /dev/null
+++ b/include/dt-bindings/reset/rtk,reset-rtd13xx.h
@@ -0,0 +1,168 @@
+#ifndef __DT_BINDINGS_RTK_RESET_RTD13XX_H
+#define __DT_BINDINGS_RTK_RESET_RTD13XX_H
+
+/* 0x98000000 */
+#define RSTN_MISC             0x0100
+#define RSTN_DIP              0x0102
+#define RSTN_GSPI             0x0104
+#define RSTN_SDS              0x0106
+#define RSTN_SDS_REG          0x0108
+#define RSTN_SDS_PHY          0x010a
+#define RSTN_VE1_BIST         0x010c
+#define RSTN_VE2_BIST         0x010e
+#define RSTN_R2RDSC_BIST      0x0110
+#define RSTN_RSA              0x0112
+#define RSTN_GPU_BIST         0x0114
+#define RSTN_DC_PHY           0x0116
+#define RSTN_DCPHY_CRT        0x0118
+#define RSTN_LSADC            0x011a
+#define RSTN_SE               0x011c
+#define RSTN_HSE_BIST         0x011e
+
+/* 0x98000004 */
+#define RSTN_JPEG             0x0200
+#define RSTN_SD               0x0202
+#define RSTN_EMMC_BIST        0x0204
+#define RSTN_SDIO             0x0206
+#define RSTN_PCR_CNT          0x0208
+#define RSTN_PCIE0_STITCH     0x020a
+#define RSTN_PCIE0_PHY        0x020c
+#define RSTN_PCIE0            0x020e
+#define RSTN_PCIE0_CORE       0x0210
+#define RSTN_PCIE0_POWER      0x0212
+#define RSTN_PCIE0_NONSTITCH  0x0214
+#define RSTN_PCIE0_PHY_MDIO   0x0216
+#define RSTN_PCIE0_SGMII_MDIO 0x0218
+#define RSTN_UR2              0x021a
+#define RSTN_UR1              0x021c
+#define RSTN_MISC_SC0         0x021e
+
+/* 0x98000008 */
+#define RSTN_AE               0x0300
+#define RSTN_CABLERX          0x0302
+#define RSTN_MD               0x0304
+#define RSTN_TP_BIST          0x0306
+#define RSTN_NF_BIST          0x0308
+#define RSTN_MISC_SC1         0x030a
+#define RSTN_I2C_3            0x030c
+#define RSTN_FAN              0x030e
+#define RSTN_TVE              0x0310
+#define RSTN_AIO              0x0312
+#define RSTN_VO               0x0314
+#define RSTN_MIPI             0x0316
+#define RSTN_HDMIRX           0x0318
+#define RSTN_HDMIRX_WRAP      0x031a
+#define RSTN_HDMI             0x031c
+#define RSTN_DISP             0x031e
+
+/* 0x9800000C */
+#define RSTN_SATA_PHY_POW1    0x0400
+#define RSTN_SATA_PHY_POW0    0x0402
+#define RSTN_SATA_MDIO1       0x0404
+#define RSTN_SATA_MDIO0       0x0406
+#define RSTN_SATA_WRAP        0x0408
+#define RSTN_SATA_MAC_P1      0x040a
+#define RSTN_SATA_MAC_P0      0x040c
+#define RSTN_SATA_MAC_COM     0x040e
+#define RSTN_PCIE1_STITCH     0x0410
+#define RSTN_PCIE1_PHY        0x0412
+#define RSTN_PCIE1            0x0414
+#define RSTN_PCIE1_CORE       0x0416
+#define RSTN_PCIE1_POWER      0x0418
+#define RSTN_PCIE1_NONSTITCH  0x041a
+#define RSTN_PCIE1_PHY_MDIO   0x041c
+#define RSTN_HDMITOP          0x041e
+
+/* 0x98000010 */
+#define RSTN_SB2              0x0500
+
+/* 0x98000014 */
+#define RSTN_RNG              0x0600
+#define RSTN_DCU              0x0602
+#define RSTN_ACPU             0x0604
+#define RSTN_VE1              0x0606
+#define RSTN_VE3              0x060a
+#define RSTN_HSE              0x060e
+#define RSTN_CP               0x0610
+#define RSTN_R2RDSC           0x0616
+#define RSTN_TP               0x061a
+#define RSTN_TPB              0x061c
+#define RSTN_TPC              0x061e
+
+/* 0x98000068 */
+#define RSTN_TPB_BIST         0x0700
+#define RSTN_I2C_4            0x0702
+#define RSTN_I2C_5            0x0704
+#define RSTN_TSIO             0x0706
+#define RSTN_VE3_BIST         0x0708
+#define RSTN_EDP              0x070a
+#define RSTN_CP_BIST          0x070c
+#define RSTN_DCU_BIST         0x070e
+#define RSTN_KT_BIST          0x0710
+#define RSTN_AKL_BIST         0x0712
+#define RSTN_TPC_BIST         0x0714
+#define RSTN_ACPU_BIST        0x0718
+#define RSTN_SPI2EMMC         0x071a
+#define RSTN_EARC             0x071c
+
+/* 0x98000088 */
+#define RSTN_DSC              0x0800
+#define RSTN_ND               0x0802
+#define RSTN_AKL              0x0804
+#define RSTN_SCE              0x0806
+#define RSTN_KT               0x0808
+
+/* 0x98000090 */
+#define RSTN_PCIE2_STITCH     0x0900
+#define RSTN_PCIE2_PHY        0x0902
+#define RSTN_PCIE2            0x0904
+#define RSTN_PCIE2_CORE       0x0906
+#define RSTN_PCIE2_POWER      0x0908
+#define RSTN_PCIE2_NONSTITCH  0x090a
+#define RSTN_PCIE2_PHY_MDIO   0x090c
+#define RSTN_DCPHY_UMCTL2     0x090e
+
+/* 0x98000094 */
+#define RSTN_NF               0x0a00
+
+/* 0x98000454 */
+#define RSTN_EMMC             0x0b00
+
+/* 0x98000458 */
+#define RSTN_GPU              0x0c00
+
+/* 0x9800045c */
+
+/* 0x98000460 */
+
+/* 0x98000464 */
+#define RSTN_VE2              0x0f00
+
+/* 0x98007088 */
+#define RSTN_IR                 1
+#define RSTN_CEC0               2
+#define RSTN_CEC1               3
+#define RSTN_ISO_GSPI           4
+#define RSTN_CBUSTX             5
+#define RSTN_CBUSRX             6
+#define RSTN_LSADC_ECOA2        7
+#define RSTN_UR0                8
+#define RSTN_GMAC               9
+#define RSTN_GPHY              10
+#define RSTN_I2C_0             11
+#define RSTN_I2C_1             12
+#define RSTN_CBUS              13
+#define RSTN_USB_DRD           14
+#define RSTN_USB_HOST          15
+#define RSTN_USB_PHY_0         16
+#define RSTN_USB_PHY_1         17
+#define RSTN_USB_PHY_2         18
+#define RSTN_USB               19
+#define RSTN_TYPE_C            20
+#define RSTN_USB_U3_HOST       21
+#define RSTN_USB3_PHY0_POW     22
+#define RSTN_USB3_P0_MDIO      23
+#define RSTN_USB3_PHY1_POW     24
+#define RSTN_USB3_P1_MDIO      25
+
+#endif /* __DT_BINDINGS_RTK_RESET_RTD13XX_H */
diff --git a/include/dt-bindings/reset/rtk,reset-rtd16xx.h b/include/dt-bindings/reset/rtk,reset-rtd16xx.h
new file mode 100644
index 00000000..a7d4487
--- /dev/null
+++ b/include/dt-bindings/reset/rtk,reset-rtd16xx.h
@@ -0,0 +1,122 @@
+#ifndef __DT_BINDINGS_RTK_RESET_RTD16XX_H
+#define __DT_BINDINGS_RTK_RESET_RTD16XX_H
+
+/* 0x98000000 */
+#define RSTN_MISC             0x0100
+#define RSTN_DIP              0x0102
+#define RSTN_GSPI             0x0104
+#define RSTN_SDS              0x0106
+#define RSTN_SDS_REG          0x0108
+#define RSTN_SDS_PHY          0x010a
+#define RSTN_VE1              0x010c
+#define RSTN_VE2              0x010e
+#define RSTN_R2RDSC           0x0110
+#define RSTN_RSA              0x0112
+#define RSTN_GPU              0x0114
+#define RSTN_DC_PHY           0x0116
+#define RSTN_DCPHY_CRT        0x0118
+#define RSTN_LSADC            0x011a
+#define RSTN_SE               0x011c
+#define RSTN_HSE              0x011e
+
+/* 0x98000004 */
+#define RSTN_JPEG             0x0200
+#define RSTN_SD               0x0202
+#define RSTN_EMMC             0x0204
+#define RSTN_SDIO             0x0206
+#define RSTN_PCR_CNT          0x0208
+#define RSTN_PCIE0_STITCH     0x020a
+#define RSTN_PCIE0_PHY        0x020c
+#define RSTN_PCIE0            0x020e
+#define RSTN_PCIE0_CORE       0x0210
+#define RSTN_PCIE0_POWER      0x0212
+#define RSTN_PCIE0_NONSTITCH  0x0214
+#define RSTN_PCIE0_PHY_MDIO   0x0216
+#define RSTN_PCIE0_SGMII_MDIO 0x0218
+#define RSTN_UR2              0x021a
+#define RSTN_UR1              0x021c
+#define RSTN_MISC_SC0         0x021e
+
+/* 0x98000008 */
+#define RSTN_AE               0x0300
+#define RSTN_CABLERX          0x0302
+#define RSTN_MD               0x0304
+#define RSTN_TP               0x0306
+#define RSTN_NF               0x0308
+#define RSTN_MISC_SC1         0x030a
+#define RSTN_I2C_3            0x030c
+#define RSTN_FAN              0x030e
+#define RSTN_TVE              0x0310
+#define RSTN_AIO              0x0312
+#define RSTN_VO               0x0314
+#define RSTN_MIPI             0x0316
+#define RSTN_HDMIRX           0x0318
+#define RSTN_HDMIRX_WRAP      0x031a
+#define RSTN_HDMI             0x031c
+#define RSTN_DISP             0x031e
+
+/* 0x9800000C */
+#define RSTN_SATA_PHY_POW1    0x0400
+#define RSTN_SATA_PHY_POW0    0x0402
+#define RSTN_SATA_MDIO1       0x0404
+#define RSTN_SATA_MDIO0       0x0406
+#define RSTN_SATA_WRAP        0x0408
+#define RSTN_SATA_MAC_P1      0x040a
+#define RSTN_SATA_MAC_P0      0x040c
+#define RSTN_SATA_MAC_COM     0x040e
+#define RSTN_PCIE1_STITCH     0x0410
+#define RSTN_PCIE1_PHY        0x0412
+#define RSTN_PCIE1            0x0414
+#define RSTN_PCIE1_CORE       0x0416
+#define RSTN_PCIE1_POWER      0x0418
+#define RSTN_PCIE1_NONSTITCH  0x041a
+#define RSTN_PCIE1_PHY_MDIO   0x041c
+#define RSTN_HDMITOP          0x041e
+
+/* 0x98000014 */
+#define RSTN_HSE_2            0x0606
+#define RSTN_R2RDSC_2         0x0608
+#define RSTN_EMMC_2           0x060a
+#define RSTN_NF_2             0x060c
+#define RSTN_MD_2             0x060e
+#define RSTN_TPB_2            0x0618
+#define RSTN_TP_2             0x061a
+#define RSTN_MIPI_2           0x061c
+
+/* 0x98000068 */
+#define RSTN_TPB              0x0700
+#define RSTN_I2C_4            0x0702
+#define RSTN_I2C_5            0x0704
+#define RSTN_TSIO             0x0706
+#define RSTN_VE3              0x0708
+#define RSTN_EDP              0x070a
+
+/* 0x98007088 */
+#define RSTN_VFD                0
+#define RSTN_IR                 1
+#define RSTN_CEC0               2
+#define RSTN_CEC1               3
+#define RSTN_DP                 4
+#define RSTN_CBUSTX             5
+#define RSTN_CBUSRX             6
+#define RSTN_EFUSE              7
+#define RSTN_UR0                8
+#define RSTN_GMAC               9
+#define RSTN_GPHY              10
+#define RSTN_I2C_0             11
+#define RSTN_I2C_1             12
+#define RSTN_CBUS              13
+#define RSTN_USB_DRD           14
+#define RSTN_USB_HOST          15
+#define RSTN_USB_PHY_0         16
+#define RSTN_USB_PHY_1         17
+#define RSTN_USB_PHY_2         18
+#define RSTN_USB               19
+#define RSTN_TYPE_C            20
+#define RSTN_USB_U3_HOST       21
+#define RSTN_USB3_PHY0_POW     22
+#define RSTN_USB3_P0_MDIO      23
+#define RSTN_USB3_PHY1_POW     24
+#define RSTN_USB3_P1_MDIO      25
+
+#endif
diff --git a/include/dt-bindings/reset/rtk,reset.h b/include/dt-bindings/reset/rtk,reset.h
new file mode 100644
index 00000000..d547af7
--- /dev/null
+++ b/include/dt-bindings/reset/rtk,reset.h
@@ -0,0 +1,6 @@
+#ifndef __DT_BINDINGS_SOC_REALTEK_RESET_H
+#define __DT_BINDINGS_SOC_REALTEK_RESET_H
+
+#define RTK_RSTN_DO_SYNC  0x100
+
+#endif
diff --git a/include/dt-bindings/soc/rtd129x,memory.h b/include/dt-bindings/soc/rtd129x,memory.h
new file mode 100644
index 00000000..38e87d8
--- /dev/null
+++ b/include/dt-bindings/soc/rtd129x,memory.h
@@ -0,0 +1,13 @@
+/*
+ * rtd129x,memory.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#undef CONFIG_ARCH_RTD139x
+#include "../../soc/realtek/memory.h"
diff --git a/include/dt-bindings/soc/rtd139x,memory.h b/include/dt-bindings/soc/rtd139x,memory.h
new file mode 100644
index 00000000..efe12dd
--- /dev/null
+++ b/include/dt-bindings/soc/rtd139x,memory.h
@@ -0,0 +1,16 @@
+/*
+ * rtd139x,memory.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#include "../../generated/autoconf.h"
+#ifndef CONFIG_ARCH_RTD139x
+#define CONFIG_ARCH_RTD139x
+#endif
+#include "../../soc/realtek/memory.h"
diff --git a/include/dt-bindings/soc/rtd13xx,memory.h b/include/dt-bindings/soc/rtd13xx,memory.h
new file mode 100644
index 00000000..3534ee1
--- /dev/null
+++ b/include/dt-bindings/soc/rtd13xx,memory.h
@@ -0,0 +1,13 @@
+/*
+ * rtd13xx,memory.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#define CONFIG_ARCH_RTD13xx
+#include "../../soc/realtek/memory.h"
diff --git a/include/dt-bindings/soc/rtd16xx,memory.h b/include/dt-bindings/soc/rtd16xx,memory.h
new file mode 100644
index 00000000..ba5b4db
--- /dev/null
+++ b/include/dt-bindings/soc/rtd16xx,memory.h
@@ -0,0 +1,13 @@
+/*
+ * rtd16xx,memory.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#define CONFIG_ARCH_RTD16xx
+#include "../../soc/realtek/memory.h"
diff --git a/include/keys/user-type.h b/include/keys/user-type.h
index c56fef4..e098cbe 100644
--- a/include/keys/user-type.h
+++ b/include/keys/user-type.h
@@ -48,9 +48,14 @@ struct user_key_payload {
 extern long user_read(const struct key *key,
 		      char __user *buffer, size_t buflen);
 
-static inline const struct user_key_payload *user_key_payload(const struct key *key)
+static inline const struct user_key_payload *user_key_payload_rcu(const struct key *key)
 {
-	return (struct user_key_payload *)rcu_dereference_key(key);
+	return (struct user_key_payload *)dereference_key_rcu(key);
+}
+
+static inline struct user_key_payload *user_key_payload_locked(const struct key *key)
+{
+	return (struct user_key_payload *)dereference_key_locked((struct key *)key);
 }
 
 #endif /* CONFIG_KEYS */
diff --git a/include/kvm/arm_pmu.h b/include/kvm/arm_pmu.h
index 92e7e97..8e99275 100644
--- a/include/kvm/arm_pmu.h
+++ b/include/kvm/arm_pmu.h
@@ -19,7 +19,7 @@
 #define __ASM_ARM_KVM_PMU_H
 
 #include <linux/perf_event.h>
-#include <asm/perf_event.h>
+#include <linux/perf/arm_pmuv3.h>
 
 #define ARMV8_PMU_CYCLE_IDX		(ARMV8_PMU_MAX_COUNTERS - 1)
 
diff --git a/include/linux/Kbuild b/include/linux/Kbuild
new file mode 100644
index 00000000..a460889
--- /dev/null
+++ b/include/linux/Kbuild
@@ -0,0 +1,2 @@
+header-y += if_pppolac.h
+header-y += if_pppopns.h
diff --git a/include/linux/amba/mmci.h b/include/linux/amba/mmci.h
index 8c98113..eff56cb 100644
--- a/include/linux/amba/mmci.h
+++ b/include/linux/amba/mmci.h
@@ -5,6 +5,15 @@
 #define AMBA_MMCI_H
 
 #include <linux/mmc/host.h>
+#include <linux/mmc/card.h>
+#include <linux/mmc/sdio_func.h>
+
+struct embedded_sdio_data {
+        struct sdio_cis cis;
+        struct sdio_cccr cccr;
+        struct sdio_embedded_func *funcs;
+        int num_funcs;
+};
 
 /**
  * struct mmci_platform_data - platform configuration for the MMCI
@@ -31,6 +40,7 @@ struct mmci_platform_data {
 	int	gpio_wp;
 	int	gpio_cd;
 	bool	cd_invert;
+	struct embedded_sdio_data *embedded_sdio;
 };
 
 #endif
diff --git a/include/linux/android_aid.h b/include/linux/android_aid.h
new file mode 100644
index 00000000..6f1fa179
--- /dev/null
+++ b/include/linux/android_aid.h
@@ -0,0 +1,28 @@
+/* include/linux/android_aid.h
+ *
+ * Copyright (C) 2008 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_ANDROID_AID_H
+#define _LINUX_ANDROID_AID_H
+
+/* AIDs that the kernel treats differently */
+#define AID_OBSOLETE_000 KGIDT_INIT(3001)  /* was NET_BT_ADMIN */
+#define AID_OBSOLETE_001 KGIDT_INIT(3002)  /* was NET_BT */
+#define AID_INET         KGIDT_INIT(3003)
+#define AID_NET_RAW      KGIDT_INIT(3004)
+#define AID_NET_ADMIN    KGIDT_INIT(3005)
+#define AID_NET_BW_STATS KGIDT_INIT(3006)  /* read bandwidth statistics */
+#define AID_NET_BW_ACCT  KGIDT_INIT(3007)  /* change bandwidth statistics accounting */
+
+#endif
diff --git a/include/linux/arm-smccc.h b/include/linux/arm-smccc.h
index ca1d2cc..43072b1 100644
--- a/include/linux/arm-smccc.h
+++ b/include/linux/arm-smccc.h
@@ -160,6 +160,7 @@ asmlinkage void __arm_smccc_hvc(unsigned long a0, unsigned long a1,
 
 #define SMCCC_SMC_INST	"smc	#0"
 #define SMCCC_HVC_INST	"hvc	#0"
+#define SMCCC_REG(n)	asm("x" # n)
 
 #elif defined(CONFIG_ARM)
 #include <asm/opcodes-sec.h>
@@ -167,6 +168,7 @@ asmlinkage void __arm_smccc_hvc(unsigned long a0, unsigned long a1,
 
 #define SMCCC_SMC_INST	__SMC(0)
 #define SMCCC_HVC_INST	__HVC(0)
+#define SMCCC_REG(n)	asm("r" # n)
 
 #endif
 
@@ -199,47 +201,47 @@ asmlinkage void __arm_smccc_hvc(unsigned long a0, unsigned long a1,
 
 #define __declare_arg_0(a0, res)					\
 	struct arm_smccc_res   *___res = res;				\
-	register u32           r0 asm("r0") = a0;			\
-	register unsigned long r1 asm("r1");				\
-	register unsigned long r2 asm("r2");				\
-	register unsigned long r3 asm("r3")
+	register u32           r0 SMCCC_REG(0) = a0;			\
+	register unsigned long r1 SMCCC_REG(1);				\
+	register unsigned long r2 SMCCC_REG(2);				\
+	register unsigned long r3 SMCCC_REG(3)
 
 #define __declare_arg_1(a0, a1, res)					\
 	struct arm_smccc_res   *___res = res;				\
-	register u32           r0 asm("r0") = a0;			\
-	register typeof(a1)    r1 asm("r1") = a1;			\
-	register unsigned long r2 asm("r2");				\
-	register unsigned long r3 asm("r3")
+	register u32           r0 SMCCC_REG(0) = a0;			\
+	register typeof(a1)    r1 SMCCC_REG(1) = a1;			\
+	register unsigned long r2 SMCCC_REG(2);				\
+	register unsigned long r3 SMCCC_REG(3)
 
 #define __declare_arg_2(a0, a1, a2, res)				\
 	struct arm_smccc_res   *___res = res;				\
-	register u32           r0 asm("r0") = a0;			\
-	register typeof(a1)    r1 asm("r1") = a1;			\
-	register typeof(a2)    r2 asm("r2") = a2;			\
-	register unsigned long r3 asm("r3")
+	register u32           r0 SMCCC_REG(0) = a0;			\
+	register typeof(a1)    r1 SMCCC_REG(1) = a1;			\
+	register typeof(a2)    r2 SMCCC_REG(2) = a2;			\
+	register unsigned long r3 SMCCC_REG(3)
 
 #define __declare_arg_3(a0, a1, a2, a3, res)				\
 	struct arm_smccc_res   *___res = res;				\
-	register u32           r0 asm("r0") = a0;			\
-	register typeof(a1)    r1 asm("r1") = a1;			\
-	register typeof(a2)    r2 asm("r2") = a2;			\
-	register typeof(a3)    r3 asm("r3") = a3
+	register u32           r0 SMCCC_REG(0) = a0;			\
+	register typeof(a1)    r1 SMCCC_REG(1) = a1;			\
+	register typeof(a2)    r2 SMCCC_REG(2) = a2;			\
+	register typeof(a3)    r3 SMCCC_REG(3) = a3
 
 #define __declare_arg_4(a0, a1, a2, a3, a4, res)			\
 	__declare_arg_3(a0, a1, a2, a3, res);				\
-	register typeof(a4) r4 asm("r4") = a4
+	register typeof(a4) r4 SMCCC_REG(4) = a4
 
 #define __declare_arg_5(a0, a1, a2, a3, a4, a5, res)			\
 	__declare_arg_4(a0, a1, a2, a3, a4, res);			\
-	register typeof(a5) r5 asm("r5") = a5
+	register typeof(a5) r5 SMCCC_REG(5) = a5
 
 #define __declare_arg_6(a0, a1, a2, a3, a4, a5, a6, res)		\
 	__declare_arg_5(a0, a1, a2, a3, a4, a5, res);			\
-	register typeof(a6) r6 asm("r6") = a6
+	register typeof(a6) r6 SMCCC_REG(6) = a6
 
 #define __declare_arg_7(a0, a1, a2, a3, a4, a5, a6, a7, res)		\
 	__declare_arg_6(a0, a1, a2, a3, a4, a5, a6, res);		\
-	register typeof(a7) r7 asm("r7") = a7
+	register typeof(a7) r7 SMCCC_REG(7) = a7
 
 #define ___declare_args(count, ...) __declare_arg_ ## count(__VA_ARGS__)
 #define __declare_args(count, ...)  ___declare_args(count, __VA_ARGS__)
diff --git a/include/linux/blk_types.h b/include/linux/blk_types.h
index cd395ec..99ad610 100644
--- a/include/linux/blk_types.h
+++ b/include/linux/blk_types.h
@@ -25,6 +25,7 @@
 struct bio {
 	struct bio		*bi_next;	/* request queue link */
 	struct block_device	*bi_bdev;
+	unsigned short		bi_write_hint;
 	int			bi_error;
 	unsigned int		bi_opf;		/* bottom bits req flags,
 						 * top bits REQ_OP. Use
diff --git a/include/linux/blkdev.h b/include/linux/blkdev.h
index bd738aa..657689d 100644
--- a/include/linux/blkdev.h
+++ b/include/linux/blkdev.h
@@ -196,6 +196,9 @@ struct request {
 
 	/* for bidi */
 	struct request *next_rq;
+
+	ktime_t			lat_hist_io_start;
+	int			lat_hist_enabled;
 };
 
 #define REQ_OP_SHIFT (8 * sizeof(u64) - REQ_OP_BITS)
@@ -1700,6 +1703,62 @@ extern int bdev_write_page(struct block_device *, sector_t, struct page *,
 extern long bdev_direct_access(struct block_device *, struct blk_dax_ctl *);
 extern int bdev_dax_supported(struct super_block *, int);
 extern bool bdev_dax_capable(struct block_device *);
+
+/*
+ * X-axis for IO latency histogram support.
+ */
+static const u_int64_t latency_x_axis_us[] = {
+	100,
+	200,
+	300,
+	400,
+	500,
+	600,
+	700,
+	800,
+	900,
+	1000,
+	1200,
+	1400,
+	1600,
+	1800,
+	2000,
+	2500,
+	3000,
+	4000,
+	5000,
+	6000,
+	7000,
+	9000,
+	10000
+};
+
+#define BLK_IO_LAT_HIST_DISABLE         0
+#define BLK_IO_LAT_HIST_ENABLE          1
+#define BLK_IO_LAT_HIST_ZERO            2
+
+struct io_latency_state {
+	u_int64_t	latency_y_axis[ARRAY_SIZE(latency_x_axis_us) + 1];
+	u_int64_t	latency_elems;
+	u_int64_t	latency_sum;
+};
+
+static inline void
+blk_update_latency_hist(struct io_latency_state *s, u_int64_t delta_us)
+{
+	int i;
+
+	for (i = 0; i < ARRAY_SIZE(latency_x_axis_us); i++)
+		if (delta_us < (u_int64_t)latency_x_axis_us[i])
+			break;
+	s->latency_y_axis[i]++;
+	s->latency_elems++;
+	s->latency_sum += delta_us;
+}
+
+ssize_t blk_latency_hist_show(char* name, struct io_latency_state *s,
+		char *buf, int buf_size);
+
 #else /* CONFIG_BLOCK */
 
 struct block_device;
diff --git a/include/linux/bpf-cgroup.h b/include/linux/bpf-cgroup.h
new file mode 100644
index 00000000..ace92fc
--- /dev/null
+++ b/include/linux/bpf-cgroup.h
@@ -0,0 +1,77 @@
+#ifndef _BPF_CGROUP_H
+#define _BPF_CGROUP_H
+
+#include <linux/jump_label.h>
+#include <uapi/linux/bpf.h>
+
+struct sock;
+struct cgroup;
+struct sk_buff;
+
+#ifdef CONFIG_CGROUP_BPF
+
+extern struct static_key_false cgroup_bpf_enabled_key;
+#define cgroup_bpf_enabled static_branch_unlikely(&cgroup_bpf_enabled_key)
+
+struct cgroup_bpf {
+	/*
+	 * Store two sets of bpf_prog pointers, one for programs that are
+	 * pinned directly to this cgroup, and one for those that are effective
+	 * when this cgroup is accessed.
+	 */
+	struct bpf_prog *prog[MAX_BPF_ATTACH_TYPE];
+	struct bpf_prog *effective[MAX_BPF_ATTACH_TYPE];
+	bool disallow_override[MAX_BPF_ATTACH_TYPE];
+};
+
+void cgroup_bpf_put(struct cgroup *cgrp);
+void cgroup_bpf_inherit(struct cgroup *cgrp, struct cgroup *parent);
+
+int __cgroup_bpf_update(struct cgroup *cgrp, struct cgroup *parent,
+			struct bpf_prog *prog, enum bpf_attach_type type,
+			bool overridable);
+
+/* Wrapper for __cgroup_bpf_update() protected by cgroup_mutex */
+int cgroup_bpf_update(struct cgroup *cgrp, struct bpf_prog *prog,
+		      enum bpf_attach_type type, bool overridable);
+
+int __cgroup_bpf_run_filter(struct sock *sk,
+			    struct sk_buff *skb,
+			    enum bpf_attach_type type);
+
+/* Wrappers for __cgroup_bpf_run_filter() guarded by cgroup_bpf_enabled. */
+#define BPF_CGROUP_RUN_PROG_INET_INGRESS(sk,skb)			\
+({									\
+	int __ret = 0;							\
+	if (cgroup_bpf_enabled)						\
+		__ret = __cgroup_bpf_run_filter(sk, skb,		\
+						BPF_CGROUP_INET_INGRESS); \
+									\
+	__ret;								\
+})
+
+#define BPF_CGROUP_RUN_PROG_INET_EGRESS(sk,skb)				\
+({									\
+	int __ret = 0;							\
+	if (cgroup_bpf_enabled && sk && sk == skb->sk) {		\
+		typeof(sk) __sk = sk_to_full_sk(sk);			\
+		if (sk_fullsock(__sk))					\
+			__ret = __cgroup_bpf_run_filter(__sk, skb,	\
+						BPF_CGROUP_INET_EGRESS); \
+	}								\
+	__ret;								\
+})
+
+#else
+
+struct cgroup_bpf {};
+static inline void cgroup_bpf_put(struct cgroup *cgrp) {}
+static inline void cgroup_bpf_inherit(struct cgroup *cgrp,
+				      struct cgroup *parent) {}
+
+#define BPF_CGROUP_RUN_PROG_INET_INGRESS(sk,skb) ({ 0; })
+#define BPF_CGROUP_RUN_PROG_INET_EGRESS(sk,skb) ({ 0; })
+
+#endif /* CONFIG_CGROUP_BPF */
+
+#endif /* _BPF_CGROUP_H */
diff --git a/include/linux/bpf.h b/include/linux/bpf.h
index 7995940..cd6aaf0 100644
--- a/include/linux/bpf.h
+++ b/include/linux/bpf.h
@@ -56,6 +56,9 @@ struct bpf_map {
 	atomic_t refcnt;
 	atomic_t usercnt;
 	struct work_struct work;
+#ifdef CONFIG_SECURITY
+	void *security;
+#endif
 };
 
 struct bpf_map_type_list {
@@ -189,6 +192,9 @@ struct bpf_prog_aux {
 	struct bpf_map **used_maps;
 	struct bpf_prog *prog;
 	struct user_struct *user;
+#ifdef CONFIG_SECURITY
+	void *security;
+#endif
 	union {
 		struct work_struct work;
 		struct rcu_head	rcu;
@@ -241,6 +247,9 @@ u64 bpf_event_output(struct bpf_map *map, u64 flags, void *meta, u64 meta_size,
 void bpf_register_prog_type(struct bpf_prog_type_list *tl);
 void bpf_register_map_type(struct bpf_map_type_list *tl);
 
+extern const struct file_operations bpf_map_fops;
+extern const struct file_operations bpf_prog_fops;
+
 struct bpf_prog *bpf_prog_get(u32 ufd);
 struct bpf_prog *bpf_prog_get_type(u32 ufd, enum bpf_prog_type type);
 struct bpf_prog *bpf_prog_add(struct bpf_prog *prog, int i);
@@ -258,11 +267,11 @@ u64 bpf_event_output(struct bpf_map *map, u64 flags, void *meta, u64 meta_size,
 
 extern int sysctl_unprivileged_bpf_disabled;
 
-int bpf_map_new_fd(struct bpf_map *map);
+int bpf_map_new_fd(struct bpf_map *map, int flags);
 int bpf_prog_new_fd(struct bpf_prog *prog);
 
 int bpf_obj_pin_user(u32 ufd, const char __user *pathname);
-int bpf_obj_get_user(const char __user *pathname);
+int bpf_obj_get_user(const char __user *pathname, int flags);
 
 int bpf_percpu_hash_copy(struct bpf_map *map, void *key, void *value);
 int bpf_percpu_array_copy(struct bpf_map *map, void *key, void *value);
@@ -277,6 +286,8 @@ int bpf_fd_array_map_update_elem(struct bpf_map *map, struct file *map_file,
 				 void *key, void *value, u64 map_flags);
 void bpf_fd_array_map_clear(struct bpf_map *map);
 
+int bpf_get_file_flag(int flags);
+
 /* memcpy that is used with 8-byte aligned pointers, power-of-8 size and
  * forced to use 'long' read/writes to try to atomically copy long counters.
  * Best-effort only.  No barriers here, since it _will_ race with concurrent
@@ -295,6 +306,9 @@ static inline void bpf_long_memcpy(void *dst, const void *src, u32 size)
 
 /* verify correctness of eBPF program */
 int bpf_check(struct bpf_prog **fp, union bpf_attr *attr);
+
+struct bpf_prog *bpf_prog_get_type_path(const char *name, enum bpf_prog_type type);
+
 #else
 static inline void bpf_register_prog_type(struct bpf_prog_type_list *tl)
 {
@@ -322,6 +336,16 @@ static inline struct bpf_prog *bpf_prog_inc(struct bpf_prog *prog)
 {
 	return ERR_PTR(-EOPNOTSUPP);
 }
+static inline int bpf_obj_get_user(const char __user *pathname)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline struct bpf_prog *bpf_prog_get_type_path(const char *name,
+				enum bpf_prog_type type)
+{
+	return ERR_PTR(-EOPNOTSUPP);
+}
 #endif /* CONFIG_BPF_SYSCALL */
 
 /* verifier prototypes for helper functions called from eBPF programs */
diff --git a/include/linux/cfi.h b/include/linux/cfi.h
new file mode 100644
index 00000000..e27033d
--- /dev/null
+++ b/include/linux/cfi.h
@@ -0,0 +1,38 @@
+#ifndef _LINUX_CFI_H
+#define _LINUX_CFI_H
+
+#include <linux/stringify.h>
+
+#ifdef CONFIG_CFI_CLANG
+#ifdef CONFIG_MODULES
+
+typedef void (*cfi_check_fn)(uint64_t, void *, void *);
+
+/* Compiler-generated function in each module, and the kernel */
+#define CFI_CHECK_FN		__cfi_check
+#define CFI_CHECK_FN_NAME	__stringify(CFI_CHECK_FN)
+
+extern void CFI_CHECK_FN(uint64_t, void *, void *);
+
+#ifdef CONFIG_CFI_CLANG_SHADOW
+extern void cfi_module_add(struct module *mod, unsigned long min_addr,
+	unsigned long max_addr);
+
+extern void cfi_module_remove(struct module *mod, unsigned long min_addr,
+	unsigned long max_addr);
+#else
+static inline void cfi_module_add(struct module *mod, unsigned long min_addr,
+	unsigned long max_addr)
+{
+}
+
+static inline void cfi_module_remove(struct module *mod, unsigned long min_addr,
+	unsigned long max_addr)
+{
+}
+#endif /* CONFIG_CFI_CLANG_SHADOW */
+
+#endif /* CONFIG_MODULES */
+#endif /* CONFIG_CFI_CLANG */
+
+#endif /* _LINUX_CFI_H */
diff --git a/include/linux/cgroup-defs.h b/include/linux/cgroup-defs.h
index 1619a32..9c72b21 100644
--- a/include/linux/cgroup-defs.h
+++ b/include/linux/cgroup-defs.h
@@ -16,6 +16,7 @@
 #include <linux/percpu-refcount.h>
 #include <linux/percpu-rwsem.h>
 #include <linux/workqueue.h>
+#include <linux/bpf-cgroup.h>
 
 #ifdef CONFIG_CGROUPS
 
@@ -301,6 +302,9 @@ struct cgroup {
 	/* used to schedule release agent */
 	struct work_struct release_agent_work;
 
+	/* used to store eBPF programs */
+	struct cgroup_bpf bpf;
+
 	/* ids of the ancestors at each level including self */
 	int ancestor_ids[];
 };
diff --git a/include/linux/cgroup_subsys.h b/include/linux/cgroup_subsys.h
index 0df0336a..7f4a2a5 100644
--- a/include/linux/cgroup_subsys.h
+++ b/include/linux/cgroup_subsys.h
@@ -20,6 +20,10 @@
 SUBSYS(cpuacct)
 #endif
 
+#if IS_ENABLED(CONFIG_CGROUP_SCHEDTUNE)
+SUBSYS(schedtune)
+#endif
+
 #if IS_ENABLED(CONFIG_BLK_CGROUP)
 SUBSYS(io)
 #endif
diff --git a/include/linux/clocksource.h b/include/linux/clocksource.h
index 0839818..36dc520 100644
--- a/include/linux/clocksource.h
+++ b/include/linux/clocksource.h
@@ -117,7 +117,7 @@ struct clocksource {
 #define CLOCK_SOURCE_RESELECT			0x100
 
 /* simplify initialization of mask field */
-#define CLOCKSOURCE_MASK(bits) (cycle_t)((bits) < 64 ? ((1ULL<<(bits))-1) : -1)
+#define CLOCKSOURCE_MASK(bits) GENMASK_ULL((bits) - 1, 0)
 
 static inline u32 clocksource_freq2mult(u32 freq, u32 shift_constant, u64 from)
 {
diff --git a/include/linux/cma.h b/include/linux/cma.h
index 29f9e77..74840af 100644
--- a/include/linux/cma.h
+++ b/include/linux/cma.h
@@ -15,6 +15,25 @@
 
 struct cma;
 
+#if defined(CONFIG_CMA_AREAS)
+
+#define CMA_REGION_COLUMN 3
+
+typedef struct of_cma_region_s {
+	int flag;
+	phys_addr_t size;
+	phys_addr_t base;
+} of_cma_region_t;
+
+typedef struct of_cma_info_s {
+	int region_enable;
+	int region_cnt;
+	of_cma_region_t region[MAX_CMA_AREAS];
+} of_cma_info_t;
+
+#endif // defined(CONFIG_CMA_AREAS)
+
+extern unsigned cma_area_count;
 extern unsigned long totalcma_pages;
 extern phys_addr_t cma_get_base(const struct cma *cma);
 extern unsigned long cma_get_size(const struct cma *cma);
diff --git a/include/linux/compiler-clang.h b/include/linux/compiler-clang.h
index 01225b0..e4f142c 100644
--- a/include/linux/compiler-clang.h
+++ b/include/linux/compiler-clang.h
@@ -16,6 +16,23 @@
  */
 #define __UNIQUE_ID(prefix) __PASTE(__PASTE(__UNIQUE_ID_, prefix), __COUNTER__)
 
+#ifdef CONFIG_LTO_CLANG
+#ifdef CONFIG_FTRACE_MCOUNT_RECORD
+#define __norecordmcount \
+	__attribute__((__section__(".text..ftrace")))
+#endif
+
+#define __nocfi		__attribute__((no_sanitize("cfi")))
+#endif
+
+/* all clang versions usable with the kernel support KASAN ABI version 5 */
+#define KASAN_ABI_VERSION 5
+
+/* emulate gcc's __SANITIZE_ADDRESS__ flag */
+#if __has_feature(address_sanitizer)
+#define __SANITIZE_ADDRESS__
+#endif
+
 /* Clang doesn't have a way to turn it off per-function, yet. */
 #ifdef __noretpoline
 #undef __noretpoline
diff --git a/include/linux/compiler.h b/include/linux/compiler.h
index 4f3dfab..7385c7f 100644
--- a/include/linux/compiler.h
+++ b/include/linux/compiler.h
@@ -451,6 +451,14 @@ static __always_inline void __write_once_size(volatile void *p, void *res, int s
 #define __visible
 #endif
 
+#ifndef __norecordmcount
+#define __norecordmcount
+#endif
+
+#ifndef __nocfi
+#define __nocfi
+#endif
+
 /*
  * Assume alignment of return value.
  */
diff --git a/include/linux/cpu.h b/include/linux/cpu.h
index 917829b..c06e77c 100644
--- a/include/linux/cpu.h
+++ b/include/linux/cpu.h
@@ -255,4 +255,11 @@ static inline void enable_nonboot_cpus(void) {}
 static inline void cpuhp_report_idle_dead(void) { }
 #endif /* #ifdef CONFIG_HOTPLUG_CPU */
 
+#define IDLE_START 1
+#define IDLE_END 2
+
+void idle_notifier_register(struct notifier_block *n);
+void idle_notifier_unregister(struct notifier_block *n);
+void idle_notifier_call_chain(unsigned long val);
+
 #endif /* _LINUX_CPU_H_ */
diff --git a/include/linux/cpufreq.h b/include/linux/cpufreq.h
index 32dc0cbd..61f405d 100644
--- a/include/linux/cpufreq.h
+++ b/include/linux/cpufreq.h
@@ -120,6 +120,14 @@ struct cpufreq_policy {
 	bool			fast_switch_possible;
 	bool			fast_switch_enabled;
 
+	/*
+	 * Preferred average time interval between consecutive invocations of
+	 * the driver to set the frequency for this policy.  To be set by the
+	 * scaling driver (0, which is the default, means no preference).
+	 */
+	unsigned int		up_transition_delay_us;
+	unsigned int		down_transition_delay_us;
+
 	 /* Cached frequency lookup from cpufreq_driver_resolve_freq. */
 	unsigned int cached_target_freq;
 	int cached_resolved_idx;
@@ -177,6 +185,7 @@ static inline bool policy_is_shared(struct cpufreq_policy *policy)
 int cpufreq_get_policy(struct cpufreq_policy *policy, unsigned int cpu);
 int cpufreq_update_policy(unsigned int cpu);
 bool have_governor_per_policy(void);
+bool cpufreq_driver_is_slow(void);
 struct kobject *get_governor_parent_kobj(struct cpufreq_policy *policy);
 void cpufreq_enable_fast_switch(struct cpufreq_policy *policy);
 void cpufreq_disable_fast_switch(struct cpufreq_policy *policy);
@@ -359,6 +368,14 @@ struct cpufreq_driver {
  */
 #define CPUFREQ_NEED_INITIAL_FREQ_CHECK	(1 << 5)
 
+/*
+ * Indicates that it is safe to call cpufreq_driver_target from
+ * non-interruptable context in scheduler hot paths.  Drivers must
+ * opt-in to this flag, as the safe default is that they might sleep
+ * or be too slow for hot path use.
+ */
+#define CPUFREQ_DRIVER_FAST		(1 << 6)
+
 int cpufreq_register_driver(struct cpufreq_driver *driver_data);
 int cpufreq_unregister_driver(struct cpufreq_driver *driver_data);
 
@@ -553,6 +570,32 @@ struct governor_attr {
 	ssize_t (*store)(struct gov_attr_set *attr_set, const char *buf,
 			 size_t count);
 };
+/* CPUFREQ DEFAULT GOVERNOR */
+/*
+ * Performance governor is fallback governor if any other gov failed to auto
+ * load due latency restrictions
+ */
+#ifdef CONFIG_CPU_FREQ_GOV_PERFORMANCE
+extern struct cpufreq_governor cpufreq_gov_performance;
+#endif
+#ifdef CONFIG_CPU_FREQ_DEFAULT_GOV_PERFORMANCE
+#define CPUFREQ_DEFAULT_GOVERNOR	(&cpufreq_gov_performance)
+#elif defined(CONFIG_CPU_FREQ_DEFAULT_GOV_POWERSAVE)
+extern struct cpufreq_governor cpufreq_gov_powersave;
+#define CPUFREQ_DEFAULT_GOVERNOR	(&cpufreq_gov_powersave)
+#elif defined(CONFIG_CPU_FREQ_DEFAULT_GOV_USERSPACE)
+extern struct cpufreq_governor cpufreq_gov_userspace;
+#define CPUFREQ_DEFAULT_GOVERNOR	(&cpufreq_gov_userspace)
+#elif defined(CONFIG_CPU_FREQ_DEFAULT_GOV_ONDEMAND)
+extern struct cpufreq_governor cpufreq_gov_ondemand;
+#define CPUFREQ_DEFAULT_GOVERNOR	(&cpufreq_gov_ondemand)
+#elif defined(CONFIG_CPU_FREQ_DEFAULT_GOV_CONSERVATIVE)
+extern struct cpufreq_governor cpufreq_gov_conservative;
+#define CPUFREQ_DEFAULT_GOVERNOR	(&cpufreq_gov_conservative)
+#elif defined(CONFIG_CPU_FREQ_DEFAULT_GOV_SCHED)
+extern struct cpufreq_governor cpufreq_gov_sched;
+#define CPUFREQ_DEFAULT_GOVERNOR	(&cpufreq_gov_sched)
+#endif
 
 /*********************************************************************
  *                     FREQUENCY TABLE HELPERS                       *
@@ -886,4 +929,9 @@ int cpufreq_table_validate_and_show(struct cpufreq_policy *policy,
 int cpufreq_generic_init(struct cpufreq_policy *policy,
 		struct cpufreq_frequency_table *table,
 		unsigned int transition_latency);
+
+struct sched_domain;
+unsigned long cpufreq_scale_freq_capacity(struct sched_domain *sd, int cpu);
+unsigned long cpufreq_scale_max_freq_capacity(struct sched_domain *sd, int cpu);
+unsigned long cpufreq_scale_min_freq_capacity(struct sched_domain *sd, int cpu);
 #endif /* _LINUX_CPUFREQ_H */
diff --git a/include/linux/cpufreq_times.h b/include/linux/cpufreq_times.h
new file mode 100644
index 00000000..356a3fa
--- /dev/null
+++ b/include/linux/cpufreq_times.h
@@ -0,0 +1,46 @@
+/* drivers/cpufreq/cpufreq_times.c
+ *
+ * Copyright (C) 2018 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_CPUFREQ_TIMES_H
+#define _LINUX_CPUFREQ_TIMES_H
+
+#include <linux/cpufreq.h>
+#include <linux/cputime.h>
+#include <linux/pid.h>
+
+#ifdef CONFIG_CPU_FREQ_TIMES
+void cpufreq_task_times_init(struct task_struct *p);
+void cpufreq_task_times_alloc(struct task_struct *p);
+void cpufreq_task_times_exit(struct task_struct *p);
+int proc_time_in_state_show(struct seq_file *m, struct pid_namespace *ns,
+			    struct pid *pid, struct task_struct *p);
+void cpufreq_acct_update_power(struct task_struct *p, cputime_t cputime);
+void cpufreq_times_create_policy(struct cpufreq_policy *policy);
+void cpufreq_times_record_transition(struct cpufreq_freqs *freq);
+void cpufreq_task_times_remove_uids(uid_t uid_start, uid_t uid_end);
+int single_uid_time_in_state_open(struct inode *inode, struct file *file);
+#else
+static inline void cpufreq_task_times_init(struct task_struct *p) {}
+static inline void cpufreq_task_times_alloc(struct task_struct *p) {}
+static inline void cpufreq_task_times_exit(struct task_struct *p) {}
+static inline void cpufreq_acct_update_power(struct task_struct *p,
+					     u64 cputime) {}
+static inline void cpufreq_times_create_policy(struct cpufreq_policy *policy) {}
+static inline void cpufreq_times_record_transition(
+	struct cpufreq_freqs *freq) {}
+static inline void cpufreq_task_times_remove_uids(uid_t uid_start,
+						  uid_t uid_end) {}
+#endif /* CONFIG_CPU_FREQ_TIMES */
+#endif /* _LINUX_CPUFREQ_TIMES_H */
diff --git a/include/linux/cpuidle.h b/include/linux/cpuidle.h
index bb31373..9a8eec9 100644
--- a/include/linux/cpuidle.h
+++ b/include/linux/cpuidle.h
@@ -207,7 +207,7 @@ static inline int cpuidle_enter_freeze(struct cpuidle_driver *drv,
 #endif
 
 /* kernel/sched/idle.c */
-extern void sched_idle_set_state(struct cpuidle_state *idle_state);
+extern void sched_idle_set_state(struct cpuidle_state *idle_state, int index);
 extern void default_idle_call(void);
 
 #ifdef CONFIG_ARCH_NEEDS_CPU_IDLE_COUPLED
diff --git a/include/linux/crypto.h b/include/linux/crypto.h
index 8edb3ba..6666ea0 100644
--- a/include/linux/crypto.h
+++ b/include/linux/crypto.h
@@ -24,6 +24,7 @@
 #include <linux/slab.h>
 #include <linux/string.h>
 #include <linux/uaccess.h>
+#include <linux/completion.h>
 
 /*
  * Autoloaded crypto modules should only use a prefixed name to avoid allowing
@@ -473,6 +474,45 @@ struct crypto_alg {
 } CRYPTO_MINALIGN_ATTR;
 
 /*
+ * A helper struct for waiting for completion of async crypto ops
+ */
+struct crypto_wait {
+	struct completion completion;
+	int err;
+};
+
+/*
+ * Macro for declaring a crypto op async wait object on stack
+ */
+#define DECLARE_CRYPTO_WAIT(_wait) \
+	struct crypto_wait _wait = { \
+		COMPLETION_INITIALIZER_ONSTACK((_wait).completion), 0 }
+
+/*
+ * Async ops completion helper functioons
+ */
+void crypto_req_done(struct crypto_async_request *req, int err);
+
+static inline int crypto_wait_req(int err, struct crypto_wait *wait)
+{
+	switch (err) {
+	case -EINPROGRESS:
+	case -EBUSY:
+		wait_for_completion(&wait->completion);
+		reinit_completion(&wait->completion);
+		err = wait->err;
+		break;
+	};
+
+	return err;
+}
+
+static inline void crypto_init_wait(struct crypto_wait *wait)
+{
+	init_completion(&wait->completion);
+}
+
+/*
  * Algorithm registration interface.
  */
 int crypto_register_alg(struct crypto_alg *alg);
diff --git a/include/linux/dcache.h b/include/linux/dcache.h
index b757ee4..014d7f9 100644
--- a/include/linux/dcache.h
+++ b/include/linux/dcache.h
@@ -142,6 +142,7 @@ struct dentry_operations {
 	int (*d_manage)(struct dentry *, bool);
 	struct dentry *(*d_real)(struct dentry *, const struct inode *,
 				 unsigned int);
+	void (*d_canonical_path)(const struct path *, struct path *);
 } ____cacheline_aligned;
 
 /*
diff --git a/include/linux/device-mapper.h b/include/linux/device-mapper.h
index ef7962e..cf86f52 100644
--- a/include/linux/device-mapper.h
+++ b/include/linux/device-mapper.h
@@ -408,6 +408,12 @@ int dm_read_arg_group(struct dm_arg *arg, struct dm_arg_set *arg_set,
 void *dm_get_mdptr(struct mapped_device *md);
 
 /*
+ * Export the device via the ioctl interface (uses mdptr).
+ */
+int dm_ioctl_export(struct mapped_device *md, const char *name,
+		    const char *uuid);
+
+/*
  * A device can still be used while suspended, but I/O is deferred.
  */
 int dm_suspend(struct mapped_device *md, unsigned suspend_flags);
@@ -434,6 +440,13 @@ int dm_read_arg_group(struct dm_arg *arg, struct dm_arg_set *arg_set,
 
 struct queue_limits *dm_get_queue_limits(struct mapped_device *md);
 
+void dm_lock_md_type(struct mapped_device *md);
+void dm_unlock_md_type(struct mapped_device *md);
+void dm_set_md_type(struct mapped_device *md, unsigned type);
+unsigned dm_get_md_type(struct mapped_device *md);
+int dm_setup_md_queue(struct mapped_device *md, struct dm_table *t);
+unsigned dm_table_get_type(struct dm_table *t);
+
 /*
  * Geometry functions.
  */
diff --git a/include/linux/efi.h b/include/linux/efi.h
index 80b1b8f..2877ccb 100644
--- a/include/linux/efi.h
+++ b/include/linux/efi.h
@@ -1427,7 +1427,7 @@ efi_status_t handle_cmdline_files(efi_system_table_t *sys_table_arg,
 				  unsigned long *load_addr,
 				  unsigned long *load_size);
 
-efi_status_t efi_parse_options(char *cmdline);
+efi_status_t efi_parse_options(char const *cmdline);
 
 efi_status_t efi_setup_gop(efi_system_table_t *sys_table_arg,
 			   struct screen_info *si, efi_guid_t *proto,
diff --git a/include/linux/f2fs_fs.h b/include/linux/f2fs_fs.h
index e46e7d1..aa5db8b 100644
--- a/include/linux/f2fs_fs.h
+++ b/include/linux/f2fs_fs.h
@@ -21,6 +21,7 @@
 #define F2FS_BLKSIZE			4096	/* support only 4KB block */
 #define F2FS_BLKSIZE_BITS		12	/* bits for F2FS_BLKSIZE */
 #define F2FS_MAX_EXTENSION		64	/* # of extension entries */
+#define F2FS_EXTENSION_LEN		8	/* max size of extension */
 #define F2FS_BLK_ALIGN(x)	(((x) + F2FS_BLKSIZE - 1) >> F2FS_BLKSIZE_BITS)
 
 #define NULL_ADDR		((block_t)0)	/* used as block_t addresses */
@@ -32,13 +33,20 @@
 /* 0, 1(node nid), 2(meta nid) are reserved node id */
 #define F2FS_RESERVED_NODE_NUM		3
 
-#define F2FS_ROOT_INO(sbi)	(sbi->root_ino_num)
-#define F2FS_NODE_INO(sbi)	(sbi->node_ino_num)
-#define F2FS_META_INO(sbi)	(sbi->meta_ino_num)
+#define F2FS_ROOT_INO(sbi)	((sbi)->root_ino_num)
+#define F2FS_NODE_INO(sbi)	((sbi)->node_ino_num)
+#define F2FS_META_INO(sbi)	((sbi)->meta_ino_num)
+
+#define F2FS_MAX_QUOTAS		3
+
+#define F2FS_IO_SIZE(sbi)	(1 << F2FS_OPTION(sbi).write_io_size_bits) /* Blocks */
+#define F2FS_IO_SIZE_KB(sbi)	(1 << (F2FS_OPTION(sbi).write_io_size_bits + 2)) /* KB */
+#define F2FS_IO_SIZE_BYTES(sbi)	(1 << (F2FS_OPTION(sbi).write_io_size_bits + 12)) /* B */
+#define F2FS_IO_SIZE_BITS(sbi)	(F2FS_OPTION(sbi).write_io_size_bits) /* power of 2 */
+#define F2FS_IO_SIZE_MASK(sbi)	(F2FS_IO_SIZE(sbi) - 1)
 
 /* This flag is used by node and meta inodes, and by recovery */
 #define GFP_F2FS_ZERO		(GFP_NOFS | __GFP_ZERO)
-#define GFP_F2FS_HIGH_ZERO	(GFP_NOFS | __GFP_ZERO | __GFP_HIGHMEM)
 
 /*
  * For further optimization on multi-head logs, on-disk layout supports maximum
@@ -52,10 +60,17 @@
 
 #define VERSION_LEN	256
 #define MAX_VOLUME_NAME		512
+#define MAX_PATH_LEN		64
+#define MAX_DEVICES		8
 
 /*
  * For superblock
  */
+struct f2fs_device {
+	__u8 path[MAX_PATH_LEN];
+	__le32 total_segments;
+} __packed;
+
 struct f2fs_super_block {
 	__le32 magic;			/* Magic Number */
 	__le16 major_ver;		/* Major Version */
@@ -87,19 +102,26 @@ struct f2fs_super_block {
 	__u8 uuid[16];			/* 128-bit uuid for volume */
 	__le16 volume_name[MAX_VOLUME_NAME];	/* volume name */
 	__le32 extension_count;		/* # of extensions below */
-	__u8 extension_list[F2FS_MAX_EXTENSION][8];	/* extension array */
+	__u8 extension_list[F2FS_MAX_EXTENSION][F2FS_EXTENSION_LEN];/* extension array */
 	__le32 cp_payload;
 	__u8 version[VERSION_LEN];	/* the kernel version */
 	__u8 init_version[VERSION_LEN];	/* the initial kernel version */
 	__le32 feature;			/* defined features */
 	__u8 encryption_level;		/* versioning level for encryption */
 	__u8 encrypt_pw_salt[16];	/* Salt used for string2key algorithm */
-	__u8 reserved[871];		/* valid reserved region */
+	struct f2fs_device devs[MAX_DEVICES];	/* device list */
+	__le32 qf_ino[F2FS_MAX_QUOTAS];	/* quota inode numbers */
+	__u8 hot_ext_count;		/* # of hot file extension */
+	__u8 reserved[314];		/* valid reserved region */
 } __packed;
 
 /*
  * For checkpoint
  */
+#define CP_LARGE_NAT_BITMAP_FLAG	0x00000400
+#define CP_NOCRC_RECOVERY_FLAG	0x00000200
+#define CP_TRIMMED_FLAG		0x00000100
+#define CP_NAT_BITS_FLAG	0x00000080
 #define CP_CRC_RECOVERY_FLAG	0x00000040
 #define CP_FASTBOOT_FLAG	0x00000020
 #define CP_FSCK_FLAG		0x00000010
@@ -146,7 +168,7 @@ struct f2fs_checkpoint {
  */
 #define F2FS_ORPHANS_PER_BLOCK	1020
 
-#define GET_ORPHAN_BLOCKS(n)	((n + F2FS_ORPHANS_PER_BLOCK - 1) / \
+#define GET_ORPHAN_BLOCKS(n)	(((n) + F2FS_ORPHANS_PER_BLOCK - 1) / \
 					F2FS_ORPHANS_PER_BLOCK)
 
 struct f2fs_orphan_block {
@@ -168,8 +190,11 @@ struct f2fs_extent {
 } __packed;
 
 #define F2FS_NAME_LEN		255
-#define F2FS_INLINE_XATTR_ADDRS	50	/* 200 bytes for inline xattrs */
+/* 200 bytes for inline xattrs by default */
+#define DEFAULT_INLINE_XATTR_ADDRS	50
 #define DEF_ADDRS_PER_INODE	923	/* Address Pointers in an Inode */
+#define CUR_ADDRS_PER_INODE(inode)	(DEF_ADDRS_PER_INODE - \
+					get_extra_isize(inode))
 #define DEF_NIDS_PER_INODE	5	/* Node IDs in an Inode */
 #define ADDRS_PER_INODE(inode)	addrs_per_inode(inode)
 #define ADDRS_PER_BLOCK		1018	/* Address Pointers in a Direct Block */
@@ -189,9 +214,8 @@ struct f2fs_extent {
 #define F2FS_INLINE_DENTRY	0x04	/* file inline dentry flag */
 #define F2FS_DATA_EXIST		0x08	/* file inline data exist flag */
 #define F2FS_INLINE_DOTS	0x10	/* file having implicit dot dentries */
-
-#define MAX_INLINE_DATA		(sizeof(__le32) * (DEF_ADDRS_PER_INODE - \
-						F2FS_INLINE_XATTR_ADDRS - 1))
+#define F2FS_EXTRA_ATTR		0x20	/* file having extra attribute */
+#define F2FS_PIN_FILE		0x40	/* file should not be gced */
 
 struct f2fs_inode {
 	__le16 i_mode;			/* file mode */
@@ -209,7 +233,13 @@ struct f2fs_inode {
 	__le32 i_ctime_nsec;		/* change time in nano scale */
 	__le32 i_mtime_nsec;		/* modification time in nano scale */
 	__le32 i_generation;		/* file version (for NFS) */
-	__le32 i_current_depth;		/* only for directory depth */
+	union {
+		__le32 i_current_depth;	/* only for directory depth */
+		__le16 i_gc_failures;	/*
+					 * # of gc failures on pinned file.
+					 * only for regular files.
+					 */
+	};
 	__le32 i_xattr_nid;		/* nid to save xattr */
 	__le32 i_flags;			/* file attributes */
 	__le32 i_pino;			/* parent inode number */
@@ -219,8 +249,18 @@ struct f2fs_inode {
 
 	struct f2fs_extent i_ext;	/* caching a largest extent */
 
-	__le32 i_addr[DEF_ADDRS_PER_INODE];	/* Pointers to data blocks */
-
+	union {
+		struct {
+			__le16 i_extra_isize;	/* extra inode attribute size */
+			__le16 i_inline_xattr_size;	/* inline xattr size, unit: 4 bytes */
+			__le32 i_projid;	/* project id */
+			__le32 i_inode_checksum;/* inode meta checksum */
+			__le64 i_crtime;	/* creation time */
+			__le32 i_crtime_nsec;	/* creation time in nano scale */
+			__le32 i_extra_end[0];	/* for attribute size calculation */
+		} __packed;
+		__le32 i_addr[DEF_ADDRS_PER_INODE];	/* Pointers to data blocks */
+	};
 	__le32 i_nid[DEF_NIDS_PER_INODE];	/* direct(2), indirect(2),
 						double_indirect(1) node id */
 } __packed;
@@ -264,6 +304,11 @@ struct f2fs_node {
  * For NAT entries
  */
 #define NAT_ENTRY_PER_BLOCK (PAGE_SIZE / sizeof(struct f2fs_nat_entry))
+#define NAT_ENTRY_BITMAP_SIZE	((NAT_ENTRY_PER_BLOCK + 7) / 8)
+#define NAT_ENTRY_BITMAP_SIZE_ALIGNED				\
+	((NAT_ENTRY_BITMAP_SIZE + BITS_PER_LONG - 1) /		\
+	BITS_PER_LONG * BITS_PER_LONG)
+
 
 struct f2fs_nat_entry {
 	__u8 version;		/* latest version of cached nat entry */
@@ -439,7 +484,7 @@ struct f2fs_summary_block {
 #define F2FS_SLOT_LEN		8
 #define F2FS_SLOT_LEN_BITS	3
 
-#define GET_DENTRY_SLOTS(x)	((x + F2FS_SLOT_LEN - 1) >> F2FS_SLOT_LEN_BITS)
+#define GET_DENTRY_SLOTS(x) (((x) + F2FS_SLOT_LEN - 1) >> F2FS_SLOT_LEN_BITS)
 
 /* MAX level for dir lookup */
 #define MAX_DIR_HASH_DEPTH	63
@@ -448,7 +493,7 @@ struct f2fs_summary_block {
 #define MAX_DIR_BUCKETS		(1 << ((MAX_DIR_HASH_DEPTH / 2) - 1))
 
 /*
- * space utilization of regular dentry and inline dentry
+ * space utilization of regular dentry and inline dentry (w/o extra reservation)
  *		regular dentry			inline dentry
  * bitmap	1 * 27 = 27			1 * 23 = 23
  * reserved	1 * 3 = 3			1 * 7 = 7
@@ -484,24 +529,6 @@ struct f2fs_dentry_block {
 	__u8 filename[NR_DENTRY_IN_BLOCK][F2FS_SLOT_LEN];
 } __packed;
 
-/* for inline dir */
-#define NR_INLINE_DENTRY	(MAX_INLINE_DATA * BITS_PER_BYTE / \
-				((SIZE_OF_DIR_ENTRY + F2FS_SLOT_LEN) * \
-				BITS_PER_BYTE + 1))
-#define INLINE_DENTRY_BITMAP_SIZE	((NR_INLINE_DENTRY + \
-					BITS_PER_BYTE - 1) / BITS_PER_BYTE)
-#define INLINE_RESERVED_SIZE	(MAX_INLINE_DATA - \
-				((SIZE_OF_DIR_ENTRY + F2FS_SLOT_LEN) * \
-				NR_INLINE_DENTRY + INLINE_DENTRY_BITMAP_SIZE))
-
-/* inline directory entry structure */
-struct f2fs_inline_dentry {
-	__u8 dentry_bitmap[INLINE_DENTRY_BITMAP_SIZE];
-	__u8 reserved[INLINE_RESERVED_SIZE];
-	struct f2fs_dir_entry dentry[NR_INLINE_DENTRY];
-	__u8 filename[NR_INLINE_DENTRY][F2FS_SLOT_LEN];
-} __packed;
-
 /* file types used in inode_info->flags */
 enum {
 	F2FS_FT_UNKNOWN,
@@ -517,4 +544,6 @@ enum {
 
 #define S_SHIFT 12
 
+#define	F2FS_DEF_PROJID		0	/* default project ID */
+
 #endif  /* _LINUX_F2FS_FS_H */
diff --git a/include/linux/fence.h b/include/linux/fence.h
index 9bb2c0c..7c9b78c 100644
--- a/include/linux/fence.h
+++ b/include/linux/fence.h
@@ -108,6 +108,7 @@ struct fence_cb {
  * @get_driver_name: returns the driver name.
  * @get_timeline_name: return the name of the context this fence belongs to.
  * @enable_signaling: enable software signaling of fence.
+ * @disable_signaling: disable software signaling of fence (optional).
  * @signaled: [optional] peek whether the fence is signaled, can be null.
  * @wait: custom wait implementation, or fence_default_wait.
  * @release: [optional] called on destruction of fence, can be null
@@ -167,6 +168,7 @@ struct fence_ops {
 	const char * (*get_driver_name)(struct fence *fence);
 	const char * (*get_timeline_name)(struct fence *fence);
 	bool (*enable_signaling)(struct fence *fence);
+	void (*disable_signaling)(struct fence *fence);
 	bool (*signaled)(struct fence *fence);
 	signed long (*wait)(struct fence *fence, bool intr, signed long timeout);
 	void (*release)(struct fence *fence);
@@ -183,6 +185,16 @@ void fence_init(struct fence *fence, const struct fence_ops *ops,
 void fence_free(struct fence *fence);
 
 /**
+ * fence_put - decreases refcount of the fence
+ * @fence:	[in]	fence to reduce refcount of
+ */
+static inline void fence_put(struct fence *fence)
+{
+	if (fence)
+		kref_put(&fence->refcount, fence_release);
+}
+
+/**
  * fence_get - increases refcount of the fence
  * @fence:	[in]	fence to increase refcount of
  *
@@ -210,13 +222,49 @@ static inline struct fence *fence_get_rcu(struct fence *fence)
 }
 
 /**
- * fence_put - decreases refcount of the fence
- * @fence:	[in]	fence to reduce refcount of
+ * fence_get_rcu_safe  - acquire a reference to an RCU tracked fence
+ * @fence:	[in]	pointer to fence to increase refcount of
+ *
+ * Function returns NULL if no refcount could be obtained, or the fence.
+ * This function handles acquiring a reference to a fence that may be
+ * reallocated within the RCU grace period (such as with SLAB_DESTROY_BY_RCU),
+ * so long as the caller is using RCU on the pointer to the fence.
+ *
+ * An alternative mechanism is to employ a seqlock to protect a bunch of
+ * fences, such as used by struct reservation_object. When using a seqlock,
+ * the seqlock must be taken before and checked after a reference to the
+ * fence is acquired (as shown here).
+ *
+ * The caller is required to hold the RCU read lock.
  */
-static inline void fence_put(struct fence *fence)
+static inline struct fence *fence_get_rcu_safe(struct fence * __rcu *fencep)
 {
-	if (fence)
-		kref_put(&fence->refcount, fence_release);
+	do {
+		struct fence *fence;
+
+		fence = rcu_dereference(*fencep);
+		if (!fence || !fence_get_rcu(fence))
+			return NULL;
+
+		/* The atomic_inc_not_zero() inside fence_get_rcu()
+		 * provides a full memory barrier upon success (such as now).
+		 * This is paired with the write barrier from assigning
+		 * to the __rcu protected fence pointer so that if that
+		 * pointer still matches the current fence, we know we
+		 * have successfully acquire a reference to it. If it no
+		 * longer matches, we are holding a reference to some other
+		 * reallocated pointer. This is possible if the allocator
+		 * is using a freelist like SLAB_DESTROY_BY_RCU where the
+		 * fence remains valid for the RCU grace period, but it
+		 * may be reallocated. When using such allocators, we are
+		 * responsible for ensuring the reference we get is to
+		 * the right fence, as below.
+		 */
+		if (fence == rcu_access_pointer(*fencep))
+			return rcu_pointer_handoff(fence);
+
+		fence_put(fence);
+	} while (1);
 }
 
 int fence_signal(struct fence *fence);
diff --git a/include/linux/fs.h b/include/linux/fs.h
index e9867af..5c1c452 100644
--- a/include/linux/fs.h
+++ b/include/linux/fs.h
@@ -21,6 +21,7 @@
 #include <linux/mm_types.h>
 #include <linux/capability.h>
 #include <linux/semaphore.h>
+#include <linux/fcntl.h>
 #include <linux/fiemap.h>
 #include <linux/rculist_bl.h>
 #include <linux/atomic.h>
@@ -144,6 +145,9 @@ typedef int (dio_iodone_t)(struct kiocb *iocb, loff_t offset,
 /* File was opened by fanotify and shouldn't generate fanotify events */
 #define FMODE_NONOTIFY		((__force fmode_t)0x4000000)
 
+/* File is capable of returning -EAGAIN if I/O will block */
+#define FMODE_NOWAIT		((__force fmode_t)0x8000000)
+
 /*
  * Flag for rw_copy_check_uvector and compat_rw_copy_check_uvector
  * that indicates that they should check the contents of the iovec are
@@ -316,6 +320,18 @@ enum positive_aop_returns {
 struct address_space;
 struct writeback_control;
 
+/*
+ * Write life time hint values.
+ */
+enum rw_hint {
+	WRITE_LIFE_NOT_SET	= 0,
+	WRITE_LIFE_NONE		= RWH_WRITE_LIFE_NONE,
+	WRITE_LIFE_SHORT	= RWH_WRITE_LIFE_SHORT,
+	WRITE_LIFE_MEDIUM	= RWH_WRITE_LIFE_MEDIUM,
+	WRITE_LIFE_LONG		= RWH_WRITE_LIFE_LONG,
+	WRITE_LIFE_EXTREME	= RWH_WRITE_LIFE_EXTREME,
+};
+
 #define IOCB_EVENTFD		(1 << 0)
 #define IOCB_APPEND		(1 << 1)
 #define IOCB_DIRECT		(1 << 2)
@@ -323,6 +339,7 @@ enum positive_aop_returns {
 #define IOCB_DSYNC		(1 << 4)
 #define IOCB_SYNC		(1 << 5)
 #define IOCB_WRITE		(1 << 6)
+#define IOCB_NOWAIT		(1 << 7)
 
 struct kiocb {
 	struct file		*ki_filp;
@@ -330,6 +347,7 @@ struct kiocb {
 	void (*ki_complete)(struct kiocb *iocb, long ret, long ret2);
 	void			*private;
 	int			ki_flags;
+	enum rw_hint		ki_hint;
 };
 
 static inline bool is_sync_kiocb(struct kiocb *kiocb)
@@ -643,6 +661,7 @@ struct inode {
 	spinlock_t		i_lock;	/* i_blocks, i_bytes, maybe i_size */
 	unsigned short          i_bytes;
 	unsigned int		i_blkbits;
+	enum rw_hint		i_write_hint;
 	blkcnt_t		i_blocks;
 
 #ifdef __NEED_I_SIZE_ORDERED
@@ -1070,8 +1089,6 @@ struct file_lock_context {
 #define OFFT_OFFSET_MAX	INT_LIMIT(off_t)
 #endif
 
-#include <linux/fcntl.h>
-
 extern void send_sigio(struct fown_struct *fown, int fd, int band);
 
 /*
@@ -1610,13 +1627,21 @@ static inline void sb_start_intwrite(struct super_block *sb)
  * VFS helper functions..
  */
 extern int vfs_create(struct inode *, struct dentry *, umode_t, bool);
+extern int vfs_create2(struct vfsmount *, struct inode *, struct dentry *, umode_t, bool);
 extern int vfs_mkdir(struct inode *, struct dentry *, umode_t);
+extern int vfs_mkdir2(struct vfsmount *, struct inode *, struct dentry *, umode_t);
 extern int vfs_mknod(struct inode *, struct dentry *, umode_t, dev_t);
+extern int vfs_mknod2(struct vfsmount *, struct inode *, struct dentry *, umode_t, dev_t);
 extern int vfs_symlink(struct inode *, struct dentry *, const char *);
+extern int vfs_symlink2(struct vfsmount *, struct inode *, struct dentry *, const char *);
 extern int vfs_link(struct dentry *, struct inode *, struct dentry *, struct inode **);
+extern int vfs_link2(struct vfsmount *, struct dentry *, struct inode *, struct dentry *, struct inode **);
 extern int vfs_rmdir(struct inode *, struct dentry *);
+extern int vfs_rmdir2(struct vfsmount *, struct inode *, struct dentry *);
 extern int vfs_unlink(struct inode *, struct dentry *, struct inode **);
+extern int vfs_unlink2(struct vfsmount *, struct inode *, struct dentry *, struct inode **);
 extern int vfs_rename(struct inode *, struct dentry *, struct inode *, struct dentry *, struct inode **, unsigned int);
+extern int vfs_rename2(struct vfsmount *, struct inode *, struct dentry *, struct inode *, struct dentry *, struct inode **, unsigned int);
 extern int vfs_whiteout(struct inode *, struct dentry *);
 
 /*
@@ -1744,6 +1769,7 @@ struct inode_operations {
 	struct dentry * (*lookup) (struct inode *,struct dentry *, unsigned int);
 	const char * (*get_link) (struct dentry *, struct inode *, struct delayed_call *);
 	int (*permission) (struct inode *, int);
+	int (*permission2) (struct vfsmount *, struct inode *, int);
 	struct posix_acl * (*get_acl)(struct inode *, int);
 
 	int (*readlink) (struct dentry *, char __user *,int);
@@ -1758,6 +1784,7 @@ struct inode_operations {
 	int (*rename) (struct inode *, struct dentry *,
 			struct inode *, struct dentry *, unsigned int);
 	int (*setattr) (struct dentry *, struct iattr *);
+	int (*setattr2) (struct vfsmount *, struct dentry *, struct iattr *);
 	int (*getattr) (struct vfsmount *mnt, struct dentry *, struct kstat *);
 	ssize_t (*listxattr) (struct dentry *, char *, size_t);
 	int (*fiemap)(struct inode *, struct fiemap_extent_info *, u64 start,
@@ -1806,9 +1833,13 @@ struct super_operations {
 	int (*unfreeze_fs) (struct super_block *);
 	int (*statfs) (struct dentry *, struct kstatfs *);
 	int (*remount_fs) (struct super_block *, int *, char *);
+	int (*remount_fs2) (struct vfsmount *, struct super_block *, int *, char *);
+	void *(*clone_mnt_data) (void *);
+	void (*copy_mnt_data) (void *, void *);
 	void (*umount_begin) (struct super_block *);
 
 	int (*show_options)(struct seq_file *, struct dentry *);
+	int (*show_options2)(struct vfsmount *,struct seq_file *, struct dentry *);
 	int (*show_devname)(struct seq_file *, struct dentry *);
 	int (*show_path)(struct seq_file *, struct dentry *);
 	int (*show_stats)(struct seq_file *, struct dentry *);
@@ -1845,6 +1876,7 @@ struct super_operations {
 #else
 #define S_DAX		0	/* Make all the DAX code disappear */
 #endif
+#define S_ENCRYPTED	16384	/* Encrypted file (using fs/crypto/) */
 
 /*
  * Note that nosuid etc flags are inode-specific: setting some file-system
@@ -1883,6 +1915,7 @@ struct super_operations {
 #define IS_AUTOMOUNT(inode)	((inode)->i_flags & S_AUTOMOUNT)
 #define IS_NOSEC(inode)		((inode)->i_flags & S_NOSEC)
 #define IS_DAX(inode)		((inode)->i_flags & S_DAX)
+#define IS_ENCRYPTED(inode)	((inode)->i_flags & S_ENCRYPTED)
 
 #define IS_WHITEOUT(inode)	(S_ISCHR(inode->i_mode) && \
 				 (inode)->i_rdev == WHITEOUT_DEV)
@@ -2042,6 +2075,9 @@ struct file_system_type {
 #define FS_RENAME_DOES_D_MOVE	32768	/* FS will handle d_move() during rename() internally. */
 	struct dentry *(*mount) (struct file_system_type *, int,
 		       const char *, void *);
+	struct dentry *(*mount2) (struct vfsmount *, struct file_system_type *, int,
+			       const char *, void *);
+	void *(*alloc_mnt_data) (void);
 	void (*kill_sb) (struct super_block *);
 	struct module *owner;
 	struct file_system_type * next;
@@ -2340,6 +2376,8 @@ struct filename {
 extern long vfs_truncate(const struct path *, loff_t);
 extern int do_truncate(struct dentry *, loff_t start, unsigned int time_attrs,
 		       struct file *filp);
+extern int do_truncate2(struct vfsmount *, struct dentry *, loff_t start,
+			unsigned int time_attrs, struct file *filp);
 extern int vfs_fallocate(struct file *file, int mode, loff_t offset,
 			loff_t len);
 extern long do_sys_open(int dfd, const char __user *filename, int flags,
@@ -2393,6 +2431,7 @@ extern int finish_open(struct file *file, struct dentry *dentry,
 extern struct super_block *freeze_bdev(struct block_device *);
 extern void emergency_thaw_all(void);
 extern int thaw_bdev(struct block_device *bdev, struct super_block *sb);
+extern int thaw_bdev_force(struct block_device *bdev, struct super_block *sb);
 extern int fsync_bdev(struct block_device *);
 
 extern struct super_block *blockdev_superblock;
@@ -2417,6 +2456,11 @@ static inline int thaw_bdev(struct block_device *bdev, struct super_block *sb)
 	return 0;
 }
 
+static inline int thaw_bdev_force(struct block_device *bdev, struct super_block *sb)
+{
+	return 0;
+}
+
 static inline void iterate_bdevs(void (*f)(struct block_device *, void *), void *arg)
 {
 }
@@ -2582,8 +2626,11 @@ static inline ssize_t generic_write_sync(struct kiocb *iocb, ssize_t count)
 extern sector_t bmap(struct inode *, sector_t);
 #endif
 extern int notify_change(struct dentry *, struct iattr *, struct inode **);
+extern int notify_change2(struct vfsmount *, struct dentry *, struct iattr *, struct inode **);
 extern int inode_permission(struct inode *, int);
+extern int inode_permission2(struct vfsmount *, struct inode *, int);
 extern int __inode_permission(struct inode *, int);
+extern int __inode_permission2(struct vfsmount *, struct inode *, int);
 extern int generic_permission(struct inode *, int);
 extern int __check_sticky(struct inode *dir, struct inode *inode);
 
diff --git a/include/linux/fscrypt.h b/include/linux/fscrypt.h
new file mode 100644
index 00000000..9e535af
--- /dev/null
+++ b/include/linux/fscrypt.h
@@ -0,0 +1,250 @@
+/*
+ * fscrypt.h: declarations for per-file encryption
+ *
+ * Filesystems that implement per-file encryption include this header
+ * file with the __FS_HAS_ENCRYPTION set according to whether that filesystem
+ * is being built with encryption support or not.
+ *
+ * Copyright (C) 2015, Google, Inc.
+ *
+ * Written by Michael Halcrow, 2015.
+ * Modified by Jaegeuk Kim, 2015.
+ */
+#ifndef _LINUX_FSCRYPT_H
+#define _LINUX_FSCRYPT_H
+
+#include <linux/fs.h>
+
+#define FS_CRYPTO_BLOCK_SIZE		16
+
+struct fscrypt_ctx;
+struct fscrypt_info;
+
+struct fscrypt_str {
+	unsigned char *name;
+	u32 len;
+};
+
+struct fscrypt_name {
+	const struct qstr *usr_fname;
+	struct fscrypt_str disk_name;
+	u32 hash;
+	u32 minor_hash;
+	struct fscrypt_str crypto_buf;
+};
+
+#define FSTR_INIT(n, l)		{ .name = n, .len = l }
+#define FSTR_TO_QSTR(f)		QSTR_INIT((f)->name, (f)->len)
+#define fname_name(p)		((p)->disk_name.name)
+#define fname_len(p)		((p)->disk_name.len)
+
+#if __FS_HAS_ENCRYPTION
+#include <linux/fscrypt_supp.h>
+#else
+#include <linux/fscrypt_notsupp.h>
+#endif
+
+/**
+ * fscrypt_require_key - require an inode's encryption key
+ * @inode: the inode we need the key for
+ *
+ * If the inode is encrypted, set up its encryption key if not already done.
+ * Then require that the key be present and return -ENOKEY otherwise.
+ *
+ * No locks are needed, and the key will live as long as the struct inode --- so
+ * it won't go away from under you.
+ *
+ * Return: 0 on success, -ENOKEY if the key is missing, or another -errno code
+ * if a problem occurred while setting up the encryption key.
+ */
+static inline int fscrypt_require_key(struct inode *inode)
+{
+	if (IS_ENCRYPTED(inode)) {
+		int err = fscrypt_get_encryption_info(inode);
+
+		if (err)
+			return err;
+		if (!fscrypt_has_encryption_key(inode))
+			return -ENOKEY;
+	}
+	return 0;
+}
+
+/**
+ * fscrypt_prepare_link - prepare to link an inode into a possibly-encrypted directory
+ * @old_dentry: an existing dentry for the inode being linked
+ * @dir: the target directory
+ * @dentry: negative dentry for the target filename
+ *
+ * A new link can only be added to an encrypted directory if the directory's
+ * encryption key is available --- since otherwise we'd have no way to encrypt
+ * the filename.  Therefore, we first set up the directory's encryption key (if
+ * not already done) and return an error if it's unavailable.
+ *
+ * We also verify that the link will not violate the constraint that all files
+ * in an encrypted directory tree use the same encryption policy.
+ *
+ * Return: 0 on success, -ENOKEY if the directory's encryption key is missing,
+ * -EPERM if the link would result in an inconsistent encryption policy, or
+ * another -errno code.
+ */
+static inline int fscrypt_prepare_link(struct dentry *old_dentry,
+				       struct inode *dir,
+				       struct dentry *dentry)
+{
+	if (IS_ENCRYPTED(dir))
+		return __fscrypt_prepare_link(d_inode(old_dentry), dir);
+	return 0;
+}
+
+/**
+ * fscrypt_prepare_rename - prepare for a rename between possibly-encrypted directories
+ * @old_dir: source directory
+ * @old_dentry: dentry for source file
+ * @new_dir: target directory
+ * @new_dentry: dentry for target location (may be negative unless exchanging)
+ * @flags: rename flags (we care at least about %RENAME_EXCHANGE)
+ *
+ * Prepare for ->rename() where the source and/or target directories may be
+ * encrypted.  A new link can only be added to an encrypted directory if the
+ * directory's encryption key is available --- since otherwise we'd have no way
+ * to encrypt the filename.  A rename to an existing name, on the other hand,
+ * *is* cryptographically possible without the key.  However, we take the more
+ * conservative approach and just forbid all no-key renames.
+ *
+ * We also verify that the rename will not violate the constraint that all files
+ * in an encrypted directory tree use the same encryption policy.
+ *
+ * Return: 0 on success, -ENOKEY if an encryption key is missing, -EPERM if the
+ * rename would cause inconsistent encryption policies, or another -errno code.
+ */
+static inline int fscrypt_prepare_rename(struct inode *old_dir,
+					 struct dentry *old_dentry,
+					 struct inode *new_dir,
+					 struct dentry *new_dentry,
+					 unsigned int flags)
+{
+	if (IS_ENCRYPTED(old_dir) || IS_ENCRYPTED(new_dir))
+		return __fscrypt_prepare_rename(old_dir, old_dentry,
+						new_dir, new_dentry, flags);
+	return 0;
+}
+
+/**
+ * fscrypt_prepare_lookup - prepare to lookup a name in a possibly-encrypted directory
+ * @dir: directory being searched
+ * @dentry: filename being looked up
+ * @flags: lookup flags
+ *
+ * Prepare for ->lookup() in a directory which may be encrypted.  Lookups can be
+ * done with or without the directory's encryption key; without the key,
+ * filenames are presented in encrypted form.  Therefore, we'll try to set up
+ * the directory's encryption key, but even without it the lookup can continue.
+ *
+ * To allow invalidating stale dentries if the directory's encryption key is
+ * added later, we also install a custom ->d_revalidate() method and use the
+ * DCACHE_ENCRYPTED_WITH_KEY flag to indicate whether a given dentry is a
+ * plaintext name (flag set) or a ciphertext name (flag cleared).
+ *
+ * Return: 0 on success, -errno if a problem occurred while setting up the
+ * encryption key
+ */
+static inline int fscrypt_prepare_lookup(struct inode *dir,
+					 struct dentry *dentry,
+					 unsigned int flags)
+{
+	if (IS_ENCRYPTED(dir))
+		return __fscrypt_prepare_lookup(dir, dentry);
+	return 0;
+}
+
+/**
+ * fscrypt_prepare_setattr - prepare to change a possibly-encrypted inode's attributes
+ * @dentry: dentry through which the inode is being changed
+ * @attr: attributes to change
+ *
+ * Prepare for ->setattr() on a possibly-encrypted inode.  On an encrypted file,
+ * most attribute changes are allowed even without the encryption key.  However,
+ * without the encryption key we do have to forbid truncates.  This is needed
+ * because the size being truncated to may not be a multiple of the filesystem
+ * block size, and in that case we'd have to decrypt the final block, zero the
+ * portion past i_size, and re-encrypt it.  (We *could* allow truncating to a
+ * filesystem block boundary, but it's simpler to just forbid all truncates ---
+ * and we already forbid all other contents modifications without the key.)
+ *
+ * Return: 0 on success, -ENOKEY if the key is missing, or another -errno code
+ * if a problem occurred while setting up the encryption key.
+ */
+static inline int fscrypt_prepare_setattr(struct dentry *dentry,
+					  struct iattr *attr)
+{
+	if (attr->ia_valid & ATTR_SIZE)
+		return fscrypt_require_key(d_inode(dentry));
+	return 0;
+}
+
+/**
+ * fscrypt_prepare_symlink - prepare to create a possibly-encrypted symlink
+ * @dir: directory in which the symlink is being created
+ * @target: plaintext symlink target
+ * @len: length of @target excluding null terminator
+ * @max_len: space the filesystem has available to store the symlink target
+ * @disk_link: (out) the on-disk symlink target being prepared
+ *
+ * This function computes the size the symlink target will require on-disk,
+ * stores it in @disk_link->len, and validates it against @max_len.  An
+ * encrypted symlink may be longer than the original.
+ *
+ * Additionally, @disk_link->name is set to @target if the symlink will be
+ * unencrypted, but left NULL if the symlink will be encrypted.  For encrypted
+ * symlinks, the filesystem must call fscrypt_encrypt_symlink() to create the
+ * on-disk target later.  (The reason for the two-step process is that some
+ * filesystems need to know the size of the symlink target before creating the
+ * inode, e.g. to determine whether it will be a "fast" or "slow" symlink.)
+ *
+ * Return: 0 on success, -ENAMETOOLONG if the symlink target is too long,
+ * -ENOKEY if the encryption key is missing, or another -errno code if a problem
+ * occurred while setting up the encryption key.
+ */
+static inline int fscrypt_prepare_symlink(struct inode *dir,
+					  const char *target,
+					  unsigned int len,
+					  unsigned int max_len,
+					  struct fscrypt_str *disk_link)
+{
+	if (IS_ENCRYPTED(dir) || fscrypt_dummy_context_enabled(dir))
+		return __fscrypt_prepare_symlink(dir, len, max_len, disk_link);
+
+	disk_link->name = (unsigned char *)target;
+	disk_link->len = len + 1;
+	if (disk_link->len > max_len)
+		return -ENAMETOOLONG;
+	return 0;
+}
+
+/**
+ * fscrypt_encrypt_symlink - encrypt the symlink target if needed
+ * @inode: symlink inode
+ * @target: plaintext symlink target
+ * @len: length of @target excluding null terminator
+ * @disk_link: (in/out) the on-disk symlink target being prepared
+ *
+ * If the symlink target needs to be encrypted, then this function encrypts it
+ * into @disk_link->name.  fscrypt_prepare_symlink() must have been called
+ * previously to compute @disk_link->len.  If the filesystem did not allocate a
+ * buffer for @disk_link->name after calling fscrypt_prepare_link(), then one
+ * will be kmalloc()'ed and the filesystem will be responsible for freeing it.
+ *
+ * Return: 0 on success, -errno on failure
+ */
+static inline int fscrypt_encrypt_symlink(struct inode *inode,
+					  const char *target,
+					  unsigned int len,
+					  struct fscrypt_str *disk_link)
+{
+	if (IS_ENCRYPTED(inode))
+		return __fscrypt_encrypt_symlink(inode, target, len, disk_link);
+	return 0;
+}
+
+#endif	/* _LINUX_FSCRYPT_H */
diff --git a/include/linux/fscrypt_notsupp.h b/include/linux/fscrypt_notsupp.h
new file mode 100644
index 00000000..cbec086
--- /dev/null
+++ b/include/linux/fscrypt_notsupp.h
@@ -0,0 +1,230 @@
+/*
+ * fscrypt_notsupp.h
+ *
+ * This stubs out the fscrypt functions for filesystems configured without
+ * encryption support.
+ *
+ * Do not include this file directly. Use fscrypt.h instead!
+ */
+#ifndef _LINUX_FSCRYPT_H
+#error "Incorrect include of linux/fscrypt_notsupp.h!"
+#endif
+
+#ifndef _LINUX_FSCRYPT_NOTSUPP_H
+#define _LINUX_FSCRYPT_NOTSUPP_H
+
+static inline bool fscrypt_has_encryption_key(const struct inode *inode)
+{
+	return false;
+}
+
+static inline bool fscrypt_dummy_context_enabled(struct inode *inode)
+{
+	return false;
+}
+
+/* crypto.c */
+static inline void fscrypt_enqueue_decrypt_work(struct work_struct *work)
+{
+}
+
+static inline struct fscrypt_ctx *fscrypt_get_ctx(const struct inode *inode,
+						  gfp_t gfp_flags)
+{
+	return ERR_PTR(-EOPNOTSUPP);
+}
+
+static inline void fscrypt_release_ctx(struct fscrypt_ctx *ctx)
+{
+	return;
+}
+
+static inline struct page *fscrypt_encrypt_page(const struct inode *inode,
+						struct page *page,
+						unsigned int len,
+						unsigned int offs,
+						u64 lblk_num, gfp_t gfp_flags)
+{
+	return ERR_PTR(-EOPNOTSUPP);
+}
+
+static inline int fscrypt_decrypt_page(const struct inode *inode,
+				       struct page *page,
+				       unsigned int len, unsigned int offs,
+				       u64 lblk_num)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline struct page *fscrypt_control_page(struct page *page)
+{
+	WARN_ON_ONCE(1);
+	return ERR_PTR(-EINVAL);
+}
+
+static inline void fscrypt_restore_control_page(struct page *page)
+{
+	return;
+}
+
+/* policy.c */
+static inline int fscrypt_ioctl_set_policy(struct file *filp,
+					   const void __user *arg)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline int fscrypt_ioctl_get_policy(struct file *filp, void __user *arg)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline int fscrypt_has_permitted_context(struct inode *parent,
+						struct inode *child)
+{
+	return 0;
+}
+
+static inline int fscrypt_inherit_context(struct inode *parent,
+					  struct inode *child,
+					  void *fs_data, bool preload)
+{
+	return -EOPNOTSUPP;
+}
+
+/* keyinfo.c */
+static inline int fscrypt_get_encryption_info(struct inode *inode)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline void fscrypt_put_encryption_info(struct inode *inode)
+{
+	return;
+}
+
+ /* fname.c */
+static inline int fscrypt_setup_filename(struct inode *dir,
+					 const struct qstr *iname,
+					 int lookup, struct fscrypt_name *fname)
+{
+	if (IS_ENCRYPTED(dir))
+		return -EOPNOTSUPP;
+
+	memset(fname, 0, sizeof(struct fscrypt_name));
+	fname->usr_fname = iname;
+	fname->disk_name.name = (unsigned char *)iname->name;
+	fname->disk_name.len = iname->len;
+	return 0;
+}
+
+static inline void fscrypt_free_filename(struct fscrypt_name *fname)
+{
+	return;
+}
+
+static inline int fscrypt_fname_alloc_buffer(const struct inode *inode,
+					     u32 max_encrypted_len,
+					     struct fscrypt_str *crypto_str)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline void fscrypt_fname_free_buffer(struct fscrypt_str *crypto_str)
+{
+	return;
+}
+
+static inline int fscrypt_fname_disk_to_usr(struct inode *inode,
+					    u32 hash, u32 minor_hash,
+					    const struct fscrypt_str *iname,
+					    struct fscrypt_str *oname)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline bool fscrypt_match_name(const struct fscrypt_name *fname,
+				      const u8 *de_name, u32 de_name_len)
+{
+	/* Encryption support disabled; use standard comparison */
+	if (de_name_len != fname->disk_name.len)
+		return false;
+	return !memcmp(de_name, fname->disk_name.name, fname->disk_name.len);
+}
+
+/* bio.c */
+static inline void fscrypt_decrypt_bio(struct bio *bio)
+{
+}
+
+static inline void fscrypt_enqueue_decrypt_bio(struct fscrypt_ctx *ctx,
+					       struct bio *bio)
+{
+}
+
+static inline void fscrypt_pullback_bio_page(struct page **page, bool restore)
+{
+	return;
+}
+
+static inline int fscrypt_zeroout_range(const struct inode *inode, pgoff_t lblk,
+					sector_t pblk, unsigned int len)
+{
+	return -EOPNOTSUPP;
+}
+
+/* hooks.c */
+
+static inline int fscrypt_file_open(struct inode *inode, struct file *filp)
+{
+	if (IS_ENCRYPTED(inode))
+		return -EOPNOTSUPP;
+	return 0;
+}
+
+static inline int __fscrypt_prepare_link(struct inode *inode,
+					 struct inode *dir)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline int __fscrypt_prepare_rename(struct inode *old_dir,
+					   struct dentry *old_dentry,
+					   struct inode *new_dir,
+					   struct dentry *new_dentry,
+					   unsigned int flags)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline int __fscrypt_prepare_lookup(struct inode *dir,
+					   struct dentry *dentry)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline int __fscrypt_prepare_symlink(struct inode *dir,
+					    unsigned int len,
+					    unsigned int max_len,
+					    struct fscrypt_str *disk_link)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline int __fscrypt_encrypt_symlink(struct inode *inode,
+					    const char *target,
+					    unsigned int len,
+					    struct fscrypt_str *disk_link)
+{
+	return -EOPNOTSUPP;
+}
+
+static inline const char *fscrypt_get_symlink(struct inode *inode,
+					      const void *caddr,
+					      unsigned int max_size,
+					      struct delayed_call *done)
+{
+	return ERR_PTR(-EOPNOTSUPP);
+}
+
+#endif	/* _LINUX_FSCRYPT_NOTSUPP_H */
diff --git a/include/linux/fscrypt_supp.h b/include/linux/fscrypt_supp.h
new file mode 100644
index 00000000..99b6c52
--- /dev/null
+++ b/include/linux/fscrypt_supp.h
@@ -0,0 +1,203 @@
+/*
+ * fscrypt_supp.h
+ *
+ * Do not include this file directly. Use fscrypt.h instead!
+ */
+#ifndef _LINUX_FSCRYPT_H
+#error "Incorrect include of linux/fscrypt_supp.h!"
+#endif
+
+#ifndef _LINUX_FSCRYPT_SUPP_H
+#define _LINUX_FSCRYPT_SUPP_H
+
+#include <linux/mm.h>
+#include <linux/slab.h>
+
+/*
+ * fscrypt superblock flags
+ */
+#define FS_CFLG_OWN_PAGES (1U << 1)
+
+/*
+ * crypto operations for filesystems
+ */
+struct fscrypt_operations {
+	unsigned int flags;
+	const char *key_prefix;
+	int (*get_context)(struct inode *, void *, size_t);
+	int (*set_context)(struct inode *, const void *, size_t, void *);
+	bool (*dummy_context)(struct inode *);
+	bool (*empty_dir)(struct inode *);
+	unsigned int max_namelen;
+};
+
+struct fscrypt_ctx {
+	union {
+		struct {
+			struct page *bounce_page;	/* Ciphertext page */
+			struct page *control_page;	/* Original page  */
+		} w;
+		struct {
+			struct bio *bio;
+			struct work_struct work;
+		} r;
+		struct list_head free_list;	/* Free list */
+	};
+	u8 flags;				/* Flags */
+};
+
+static inline bool fscrypt_has_encryption_key(const struct inode *inode)
+{
+	return (inode->i_crypt_info != NULL);
+}
+
+static inline bool fscrypt_dummy_context_enabled(struct inode *inode)
+{
+	return inode->i_sb->s_cop->dummy_context &&
+		inode->i_sb->s_cop->dummy_context(inode);
+}
+
+/* crypto.c */
+extern void fscrypt_enqueue_decrypt_work(struct work_struct *);
+extern struct fscrypt_ctx *fscrypt_get_ctx(const struct inode *, gfp_t);
+extern void fscrypt_release_ctx(struct fscrypt_ctx *);
+extern struct page *fscrypt_encrypt_page(const struct inode *, struct page *,
+						unsigned int, unsigned int,
+						u64, gfp_t);
+extern int fscrypt_decrypt_page(const struct inode *, struct page *, unsigned int,
+				unsigned int, u64);
+
+static inline struct page *fscrypt_control_page(struct page *page)
+{
+	return ((struct fscrypt_ctx *)page_private(page))->w.control_page;
+}
+
+extern void fscrypt_restore_control_page(struct page *);
+
+/* policy.c */
+extern int fscrypt_ioctl_set_policy(struct file *, const void __user *);
+extern int fscrypt_ioctl_get_policy(struct file *, void __user *);
+extern int fscrypt_has_permitted_context(struct inode *, struct inode *);
+extern int fscrypt_inherit_context(struct inode *, struct inode *,
+					void *, bool);
+/* keyinfo.c */
+extern int fscrypt_get_encryption_info(struct inode *);
+extern void fscrypt_put_encryption_info(struct inode *);
+
+/* fname.c */
+extern int fscrypt_setup_filename(struct inode *, const struct qstr *,
+				int lookup, struct fscrypt_name *);
+
+static inline void fscrypt_free_filename(struct fscrypt_name *fname)
+{
+	kfree(fname->crypto_buf.name);
+}
+
+extern int fscrypt_fname_alloc_buffer(const struct inode *, u32,
+				struct fscrypt_str *);
+extern void fscrypt_fname_free_buffer(struct fscrypt_str *);
+extern int fscrypt_fname_disk_to_usr(struct inode *, u32, u32,
+			const struct fscrypt_str *, struct fscrypt_str *);
+
+#define FSCRYPT_FNAME_MAX_UNDIGESTED_SIZE	32
+
+/* Extracts the second-to-last ciphertext block; see explanation below */
+#define FSCRYPT_FNAME_DIGEST(name, len)	\
+	((name) + round_down((len) - FS_CRYPTO_BLOCK_SIZE - 1, \
+			     FS_CRYPTO_BLOCK_SIZE))
+
+#define FSCRYPT_FNAME_DIGEST_SIZE	FS_CRYPTO_BLOCK_SIZE
+
+/**
+ * fscrypt_digested_name - alternate identifier for an on-disk filename
+ *
+ * When userspace lists an encrypted directory without access to the key,
+ * filenames whose ciphertext is longer than FSCRYPT_FNAME_MAX_UNDIGESTED_SIZE
+ * bytes are shown in this abbreviated form (base64-encoded) rather than as the
+ * full ciphertext (base64-encoded).  This is necessary to allow supporting
+ * filenames up to NAME_MAX bytes, since base64 encoding expands the length.
+ *
+ * To make it possible for filesystems to still find the correct directory entry
+ * despite not knowing the full on-disk name, we encode any filesystem-specific
+ * 'hash' and/or 'minor_hash' which the filesystem may need for its lookups,
+ * followed by the second-to-last ciphertext block of the filename.  Due to the
+ * use of the CBC-CTS encryption mode, the second-to-last ciphertext block
+ * depends on the full plaintext.  (Note that ciphertext stealing causes the
+ * last two blocks to appear "flipped".)  This makes accidental collisions very
+ * unlikely: just a 1 in 2^128 chance for two filenames to collide even if they
+ * share the same filesystem-specific hashes.
+ *
+ * However, this scheme isn't immune to intentional collisions, which can be
+ * created by anyone able to create arbitrary plaintext filenames and view them
+ * without the key.  Making the "digest" be a real cryptographic hash like
+ * SHA-256 over the full ciphertext would prevent this, although it would be
+ * less efficient and harder to implement, especially since the filesystem would
+ * need to calculate it for each directory entry examined during a search.
+ */
+struct fscrypt_digested_name {
+	u32 hash;
+	u32 minor_hash;
+	u8 digest[FSCRYPT_FNAME_DIGEST_SIZE];
+};
+
+/**
+ * fscrypt_match_name() - test whether the given name matches a directory entry
+ * @fname: the name being searched for
+ * @de_name: the name from the directory entry
+ * @de_name_len: the length of @de_name in bytes
+ *
+ * Normally @fname->disk_name will be set, and in that case we simply compare
+ * that to the name stored in the directory entry.  The only exception is that
+ * if we don't have the key for an encrypted directory and a filename in it is
+ * very long, then we won't have the full disk_name and we'll instead need to
+ * match against the fscrypt_digested_name.
+ *
+ * Return: %true if the name matches, otherwise %false.
+ */
+static inline bool fscrypt_match_name(const struct fscrypt_name *fname,
+				      const u8 *de_name, u32 de_name_len)
+{
+	if (unlikely(!fname->disk_name.name)) {
+		const struct fscrypt_digested_name *n =
+			(const void *)fname->crypto_buf.name;
+		if (WARN_ON_ONCE(fname->usr_fname->name[0] != '_'))
+			return false;
+		if (de_name_len <= FSCRYPT_FNAME_MAX_UNDIGESTED_SIZE)
+			return false;
+		return !memcmp(FSCRYPT_FNAME_DIGEST(de_name, de_name_len),
+			       n->digest, FSCRYPT_FNAME_DIGEST_SIZE);
+	}
+
+	if (de_name_len != fname->disk_name.len)
+		return false;
+	return !memcmp(de_name, fname->disk_name.name, fname->disk_name.len);
+}
+
+/* bio.c */
+extern void fscrypt_decrypt_bio(struct bio *);
+extern void fscrypt_enqueue_decrypt_bio(struct fscrypt_ctx *ctx,
+					struct bio *bio);
+extern void fscrypt_pullback_bio_page(struct page **, bool);
+extern int fscrypt_zeroout_range(const struct inode *, pgoff_t, sector_t,
+				 unsigned int);
+
+/* hooks.c */
+extern int fscrypt_file_open(struct inode *inode, struct file *filp);
+extern int __fscrypt_prepare_link(struct inode *inode, struct inode *dir);
+extern int __fscrypt_prepare_rename(struct inode *old_dir,
+				    struct dentry *old_dentry,
+				    struct inode *new_dir,
+				    struct dentry *new_dentry,
+				    unsigned int flags);
+extern int __fscrypt_prepare_lookup(struct inode *dir, struct dentry *dentry);
+extern int __fscrypt_prepare_symlink(struct inode *dir, unsigned int len,
+				     unsigned int max_len,
+				     struct fscrypt_str *disk_link);
+extern int __fscrypt_encrypt_symlink(struct inode *inode, const char *target,
+				     unsigned int len,
+				     struct fscrypt_str *disk_link);
+extern const char *fscrypt_get_symlink(struct inode *inode, const void *caddr,
+				       unsigned int max_size,
+				       struct delayed_call *done);
+
+#endif	/* _LINUX_FSCRYPT_SUPP_H */
diff --git a/include/linux/fscrypto.h b/include/linux/fscrypto.h
deleted file mode 100644
index f6dfc29..00000000
--- a/include/linux/fscrypto.h
+++ /dev/null
@@ -1,409 +0,0 @@
-/*
- * General per-file encryption definition
- *
- * Copyright (C) 2015, Google, Inc.
- *
- * Written by Michael Halcrow, 2015.
- * Modified by Jaegeuk Kim, 2015.
- */
-
-#ifndef _LINUX_FSCRYPTO_H
-#define _LINUX_FSCRYPTO_H
-
-#include <linux/key.h>
-#include <linux/fs.h>
-#include <linux/mm.h>
-#include <linux/bio.h>
-#include <linux/dcache.h>
-#include <crypto/skcipher.h>
-#include <uapi/linux/fs.h>
-
-#define FS_KEY_DERIVATION_NONCE_SIZE		16
-#define FS_ENCRYPTION_CONTEXT_FORMAT_V1		1
-
-#define FS_POLICY_FLAGS_PAD_4		0x00
-#define FS_POLICY_FLAGS_PAD_8		0x01
-#define FS_POLICY_FLAGS_PAD_16		0x02
-#define FS_POLICY_FLAGS_PAD_32		0x03
-#define FS_POLICY_FLAGS_PAD_MASK	0x03
-#define FS_POLICY_FLAGS_VALID		0x03
-
-/* Encryption algorithms */
-#define FS_ENCRYPTION_MODE_INVALID		0
-#define FS_ENCRYPTION_MODE_AES_256_XTS		1
-#define FS_ENCRYPTION_MODE_AES_256_GCM		2
-#define FS_ENCRYPTION_MODE_AES_256_CBC		3
-#define FS_ENCRYPTION_MODE_AES_256_CTS		4
-
-/**
- * Encryption context for inode
- *
- * Protector format:
- *  1 byte: Protector format (1 = this version)
- *  1 byte: File contents encryption mode
- *  1 byte: File names encryption mode
- *  1 byte: Flags
- *  8 bytes: Master Key descriptor
- *  16 bytes: Encryption Key derivation nonce
- */
-struct fscrypt_context {
-	u8 format;
-	u8 contents_encryption_mode;
-	u8 filenames_encryption_mode;
-	u8 flags;
-	u8 master_key_descriptor[FS_KEY_DESCRIPTOR_SIZE];
-	u8 nonce[FS_KEY_DERIVATION_NONCE_SIZE];
-} __packed;
-
-/* Encryption parameters */
-#define FS_XTS_TWEAK_SIZE		16
-#define FS_AES_128_ECB_KEY_SIZE		16
-#define FS_AES_256_GCM_KEY_SIZE		32
-#define FS_AES_256_CBC_KEY_SIZE		32
-#define FS_AES_256_CTS_KEY_SIZE		32
-#define FS_AES_256_XTS_KEY_SIZE		64
-#define FS_MAX_KEY_SIZE			64
-
-#define FS_KEY_DESC_PREFIX		"fscrypt:"
-#define FS_KEY_DESC_PREFIX_SIZE		8
-
-/* This is passed in from userspace into the kernel keyring */
-struct fscrypt_key {
-	u32 mode;
-	u8 raw[FS_MAX_KEY_SIZE];
-	u32 size;
-} __packed;
-
-struct fscrypt_info {
-	u8 ci_data_mode;
-	u8 ci_filename_mode;
-	u8 ci_flags;
-	struct crypto_skcipher *ci_ctfm;
-	u8 ci_master_key[FS_KEY_DESCRIPTOR_SIZE];
-};
-
-#define FS_CTX_REQUIRES_FREE_ENCRYPT_FL		0x00000001
-#define FS_WRITE_PATH_FL			0x00000002
-
-struct fscrypt_ctx {
-	union {
-		struct {
-			struct page *bounce_page;	/* Ciphertext page */
-			struct page *control_page;	/* Original page  */
-		} w;
-		struct {
-			struct bio *bio;
-			struct work_struct work;
-		} r;
-		struct list_head free_list;	/* Free list */
-	};
-	u8 flags;				/* Flags */
-	u8 mode;				/* Encryption mode for tfm */
-};
-
-struct fscrypt_completion_result {
-	struct completion completion;
-	int res;
-};
-
-#define DECLARE_FS_COMPLETION_RESULT(ecr) \
-	struct fscrypt_completion_result ecr = { \
-		COMPLETION_INITIALIZER((ecr).completion), 0 }
-
-#define FS_FNAME_NUM_SCATTER_ENTRIES	4
-#define FS_CRYPTO_BLOCK_SIZE		16
-#define FS_FNAME_CRYPTO_DIGEST_SIZE	32
-
-/**
- * For encrypted symlinks, the ciphertext length is stored at the beginning
- * of the string in little-endian format.
- */
-struct fscrypt_symlink_data {
-	__le16 len;
-	char encrypted_path[1];
-} __packed;
-
-/**
- * This function is used to calculate the disk space required to
- * store a filename of length l in encrypted symlink format.
- */
-static inline u32 fscrypt_symlink_data_len(u32 l)
-{
-	if (l < FS_CRYPTO_BLOCK_SIZE)
-		l = FS_CRYPTO_BLOCK_SIZE;
-	return (l + sizeof(struct fscrypt_symlink_data) - 1);
-}
-
-struct fscrypt_str {
-	unsigned char *name;
-	u32 len;
-};
-
-struct fscrypt_name {
-	const struct qstr *usr_fname;
-	struct fscrypt_str disk_name;
-	u32 hash;
-	u32 minor_hash;
-	struct fscrypt_str crypto_buf;
-};
-
-#define FSTR_INIT(n, l)		{ .name = n, .len = l }
-#define FSTR_TO_QSTR(f)		QSTR_INIT((f)->name, (f)->len)
-#define fname_name(p)		((p)->disk_name.name)
-#define fname_len(p)		((p)->disk_name.len)
-
-/*
- * crypto opertions for filesystems
- */
-struct fscrypt_operations {
-	int (*get_context)(struct inode *, void *, size_t);
-	int (*key_prefix)(struct inode *, u8 **);
-	int (*prepare_context)(struct inode *);
-	int (*set_context)(struct inode *, const void *, size_t, void *);
-	int (*dummy_context)(struct inode *);
-	bool (*is_encrypted)(struct inode *);
-	bool (*empty_dir)(struct inode *);
-	unsigned (*max_namelen)(struct inode *);
-};
-
-static inline bool fscrypt_dummy_context_enabled(struct inode *inode)
-{
-	if (inode->i_sb->s_cop->dummy_context &&
-				inode->i_sb->s_cop->dummy_context(inode))
-		return true;
-	return false;
-}
-
-static inline bool fscrypt_valid_contents_enc_mode(u32 mode)
-{
-	return (mode == FS_ENCRYPTION_MODE_AES_256_XTS);
-}
-
-static inline bool fscrypt_valid_filenames_enc_mode(u32 mode)
-{
-	return (mode == FS_ENCRYPTION_MODE_AES_256_CTS);
-}
-
-static inline bool fscrypt_is_dot_dotdot(const struct qstr *str)
-{
-	if (str->len == 1 && str->name[0] == '.')
-		return true;
-
-	if (str->len == 2 && str->name[0] == '.' && str->name[1] == '.')
-		return true;
-
-	return false;
-}
-
-static inline struct page *fscrypt_control_page(struct page *page)
-{
-#if IS_ENABLED(CONFIG_FS_ENCRYPTION)
-	return ((struct fscrypt_ctx *)page_private(page))->w.control_page;
-#else
-	WARN_ON_ONCE(1);
-	return ERR_PTR(-EINVAL);
-#endif
-}
-
-static inline int fscrypt_has_encryption_key(struct inode *inode)
-{
-#if IS_ENABLED(CONFIG_FS_ENCRYPTION)
-	return (inode->i_crypt_info != NULL);
-#else
-	return 0;
-#endif
-}
-
-static inline void fscrypt_set_encrypted_dentry(struct dentry *dentry)
-{
-#if IS_ENABLED(CONFIG_FS_ENCRYPTION)
-	spin_lock(&dentry->d_lock);
-	dentry->d_flags |= DCACHE_ENCRYPTED_WITH_KEY;
-	spin_unlock(&dentry->d_lock);
-#endif
-}
-
-#if IS_ENABLED(CONFIG_FS_ENCRYPTION)
-extern const struct dentry_operations fscrypt_d_ops;
-#endif
-
-static inline void fscrypt_set_d_op(struct dentry *dentry)
-{
-#if IS_ENABLED(CONFIG_FS_ENCRYPTION)
-	d_set_d_op(dentry, &fscrypt_d_ops);
-#endif
-}
-
-#if IS_ENABLED(CONFIG_FS_ENCRYPTION)
-/* crypto.c */
-extern struct kmem_cache *fscrypt_info_cachep;
-int fscrypt_initialize(void);
-
-extern struct fscrypt_ctx *fscrypt_get_ctx(struct inode *, gfp_t);
-extern void fscrypt_release_ctx(struct fscrypt_ctx *);
-extern struct page *fscrypt_encrypt_page(struct inode *, struct page *, gfp_t);
-extern int fscrypt_decrypt_page(struct page *);
-extern void fscrypt_decrypt_bio_pages(struct fscrypt_ctx *, struct bio *);
-extern void fscrypt_pullback_bio_page(struct page **, bool);
-extern void fscrypt_restore_control_page(struct page *);
-extern int fscrypt_zeroout_range(struct inode *, pgoff_t, sector_t,
-						unsigned int);
-/* policy.c */
-extern int fscrypt_process_policy(struct file *, const struct fscrypt_policy *);
-extern int fscrypt_get_policy(struct inode *, struct fscrypt_policy *);
-extern int fscrypt_has_permitted_context(struct inode *, struct inode *);
-extern int fscrypt_inherit_context(struct inode *, struct inode *,
-					void *, bool);
-/* keyinfo.c */
-extern int fscrypt_get_encryption_info(struct inode *);
-extern void fscrypt_put_encryption_info(struct inode *, struct fscrypt_info *);
-
-/* fname.c */
-extern int fscrypt_setup_filename(struct inode *, const struct qstr *,
-				int lookup, struct fscrypt_name *);
-extern void fscrypt_free_filename(struct fscrypt_name *);
-extern u32 fscrypt_fname_encrypted_size(struct inode *, u32);
-extern int fscrypt_fname_alloc_buffer(struct inode *, u32,
-				struct fscrypt_str *);
-extern void fscrypt_fname_free_buffer(struct fscrypt_str *);
-extern int fscrypt_fname_disk_to_usr(struct inode *, u32, u32,
-			const struct fscrypt_str *, struct fscrypt_str *);
-extern int fscrypt_fname_usr_to_disk(struct inode *, const struct qstr *,
-			struct fscrypt_str *);
-#endif
-
-/* crypto.c */
-static inline struct fscrypt_ctx *fscrypt_notsupp_get_ctx(struct inode *i,
-							gfp_t f)
-{
-	return ERR_PTR(-EOPNOTSUPP);
-}
-
-static inline void fscrypt_notsupp_release_ctx(struct fscrypt_ctx *c)
-{
-	return;
-}
-
-static inline struct page *fscrypt_notsupp_encrypt_page(struct inode *i,
-						struct page *p, gfp_t f)
-{
-	return ERR_PTR(-EOPNOTSUPP);
-}
-
-static inline int fscrypt_notsupp_decrypt_page(struct page *p)
-{
-	return -EOPNOTSUPP;
-}
-
-static inline void fscrypt_notsupp_decrypt_bio_pages(struct fscrypt_ctx *c,
-						struct bio *b)
-{
-	return;
-}
-
-static inline void fscrypt_notsupp_pullback_bio_page(struct page **p, bool b)
-{
-	return;
-}
-
-static inline void fscrypt_notsupp_restore_control_page(struct page *p)
-{
-	return;
-}
-
-static inline int fscrypt_notsupp_zeroout_range(struct inode *i, pgoff_t p,
-					sector_t s, unsigned int f)
-{
-	return -EOPNOTSUPP;
-}
-
-/* policy.c */
-static inline int fscrypt_notsupp_process_policy(struct file *f,
-				const struct fscrypt_policy *p)
-{
-	return -EOPNOTSUPP;
-}
-
-static inline int fscrypt_notsupp_get_policy(struct inode *i,
-				struct fscrypt_policy *p)
-{
-	return -EOPNOTSUPP;
-}
-
-static inline int fscrypt_notsupp_has_permitted_context(struct inode *p,
-				struct inode *i)
-{
-	return 0;
-}
-
-static inline int fscrypt_notsupp_inherit_context(struct inode *p,
-				struct inode *i, void *v, bool b)
-{
-	return -EOPNOTSUPP;
-}
-
-/* keyinfo.c */
-static inline int fscrypt_notsupp_get_encryption_info(struct inode *i)
-{
-	return -EOPNOTSUPP;
-}
-
-static inline void fscrypt_notsupp_put_encryption_info(struct inode *i,
-					struct fscrypt_info *f)
-{
-	return;
-}
-
- /* fname.c */
-static inline int fscrypt_notsupp_setup_filename(struct inode *dir,
-			const struct qstr *iname,
-			int lookup, struct fscrypt_name *fname)
-{
-	if (dir->i_sb->s_cop->is_encrypted(dir))
-		return -EOPNOTSUPP;
-
-	memset(fname, 0, sizeof(struct fscrypt_name));
-	fname->usr_fname = iname;
-	fname->disk_name.name = (unsigned char *)iname->name;
-	fname->disk_name.len = iname->len;
-	return 0;
-}
-
-static inline void fscrypt_notsupp_free_filename(struct fscrypt_name *fname)
-{
-	return;
-}
-
-static inline u32 fscrypt_notsupp_fname_encrypted_size(struct inode *i, u32 s)
-{
-	/* never happens */
-	WARN_ON(1);
-	return 0;
-}
-
-static inline int fscrypt_notsupp_fname_alloc_buffer(struct inode *inode,
-				u32 ilen, struct fscrypt_str *crypto_str)
-{
-	return -EOPNOTSUPP;
-}
-
-static inline void fscrypt_notsupp_fname_free_buffer(struct fscrypt_str *c)
-{
-	return;
-}
-
-static inline int fscrypt_notsupp_fname_disk_to_usr(struct inode *inode,
-			u32 hash, u32 minor_hash,
-			const struct fscrypt_str *iname,
-			struct fscrypt_str *oname)
-{
-	return -EOPNOTSUPP;
-}
-
-static inline int fscrypt_notsupp_fname_usr_to_disk(struct inode *inode,
-			const struct qstr *iname,
-			struct fscrypt_str *oname)
-{
-	return -EOPNOTSUPP;
-}
-#endif	/* _LINUX_FSCRYPTO_H */
diff --git a/include/linux/fsnotify.h b/include/linux/fsnotify.h
index e5f03a4d..ff51592 100644
--- a/include/linux/fsnotify.h
+++ b/include/linux/fsnotify.h
@@ -213,12 +213,20 @@ static inline void fsnotify_modify(struct file *file)
 static inline void fsnotify_open(struct file *file)
 {
 	struct path *path = &file->f_path;
+	struct path lower_path;
 	struct inode *inode = path->dentry->d_inode;
+
 	__u32 mask = FS_OPEN;
 
 	if (S_ISDIR(inode->i_mode))
 		mask |= FS_ISDIR;
 
+	if (path->dentry->d_op && path->dentry->d_op->d_canonical_path) {
+		path->dentry->d_op->d_canonical_path(path, &lower_path);
+		fsnotify_parent(&lower_path, NULL, mask);
+		fsnotify(lower_path.dentry->d_inode, mask, &lower_path, FSNOTIFY_EVENT_PATH, NULL, 0);
+		path_put(&lower_path);
+	}
 	fsnotify_parent(path, NULL, mask);
 	fsnotify(inode, mask, path, FSNOTIFY_EVENT_PATH, NULL, 0);
 }
diff --git a/include/linux/ftrace.h b/include/linux/ftrace.h
index b3d34d3..ab7938a 100644
--- a/include/linux/ftrace.h
+++ b/include/linux/ftrace.h
@@ -244,8 +244,16 @@ static inline int ftrace_function_local_disabled(struct ftrace_ops *ops)
 	return *this_cpu_ptr(ops->disabled);
 }
 
+#ifdef CONFIG_CFI_CLANG
+/* Use a C stub with the correct type for CFI */
+static inline void ftrace_stub(unsigned long a0, unsigned long a1,
+			       struct ftrace_ops *op, struct pt_regs *regs)
+{
+}
+#else
 extern void ftrace_stub(unsigned long a0, unsigned long a1,
 			struct ftrace_ops *op, struct pt_regs *regs);
+#endif
 
 #else /* !CONFIG_FUNCTION_TRACER */
 /*
@@ -734,7 +742,8 @@ static inline unsigned long get_lock_parent_ip(void)
   static inline void time_hardirqs_off(unsigned long a0, unsigned long a1) { }
 #endif
 
-#ifdef CONFIG_PREEMPT_TRACER
+#if defined(CONFIG_PREEMPT_TRACER) || \
+	(defined(CONFIG_DEBUG_PREEMPT) && defined(CONFIG_PREEMPTIRQ_EVENTS))
   extern void trace_preempt_on(unsigned long a0, unsigned long a1);
   extern void trace_preempt_off(unsigned long a0, unsigned long a1);
 #else
diff --git a/include/linux/gfp.h b/include/linux/gfp.h
index f8041f9de..e47dbc1 100644
--- a/include/linux/gfp.h
+++ b/include/linux/gfp.h
@@ -516,7 +516,7 @@ extern void *__alloc_page_frag(struct page_frag_cache *nc,
 void page_alloc_init(void);
 void drain_zone_pages(struct zone *zone, struct per_cpu_pages *pcp);
 void drain_all_pages(struct zone *zone);
-void drain_local_pages(struct zone *zone);
+void drain_local_pages(void *zone);
 
 void page_alloc_init_late(void);
 
diff --git a/include/linux/gpio_event.h b/include/linux/gpio_event.h
new file mode 100644
index 00000000..2613fc5
--- /dev/null
+++ b/include/linux/gpio_event.h
@@ -0,0 +1,170 @@
+/* include/linux/gpio_event.h
+ *
+ * Copyright (C) 2007 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_GPIO_EVENT_H
+#define _LINUX_GPIO_EVENT_H
+
+#include <linux/input.h>
+
+struct gpio_event_input_devs {
+	int count;
+	struct input_dev *dev[];
+};
+enum {
+	GPIO_EVENT_FUNC_UNINIT  = 0x0,
+	GPIO_EVENT_FUNC_INIT    = 0x1,
+	GPIO_EVENT_FUNC_SUSPEND = 0x2,
+	GPIO_EVENT_FUNC_RESUME  = 0x3,
+};
+struct gpio_event_info {
+	int (*func)(struct gpio_event_input_devs *input_devs,
+		    struct gpio_event_info *info,
+		    void **data, int func);
+	int (*event)(struct gpio_event_input_devs *input_devs,
+		     struct gpio_event_info *info,
+		     void **data, unsigned int dev, unsigned int type,
+		     unsigned int code, int value); /* out events */
+	bool no_suspend;
+};
+
+struct gpio_event_platform_data {
+	const char *name;
+	struct gpio_event_info **info;
+	size_t info_count;
+	int (*power)(const struct gpio_event_platform_data *pdata, bool on);
+	const char *names[]; /* If name is NULL, names contain a NULL */
+			     /* terminated list of input devices to create */
+};
+
+#define GPIO_EVENT_DEV_NAME "gpio-event"
+
+/* Key matrix */
+
+enum gpio_event_matrix_flags {
+	/* unset: drive active output low, set: drive active output high */
+	GPIOKPF_ACTIVE_HIGH              = 1U << 0,
+	GPIOKPF_DEBOUNCE                 = 1U << 1,
+	GPIOKPF_REMOVE_SOME_PHANTOM_KEYS = 1U << 2,
+	GPIOKPF_REMOVE_PHANTOM_KEYS      = GPIOKPF_REMOVE_SOME_PHANTOM_KEYS |
+					   GPIOKPF_DEBOUNCE,
+	GPIOKPF_DRIVE_INACTIVE           = 1U << 3,
+	GPIOKPF_LEVEL_TRIGGERED_IRQ      = 1U << 4,
+	GPIOKPF_PRINT_UNMAPPED_KEYS      = 1U << 16,
+	GPIOKPF_PRINT_MAPPED_KEYS        = 1U << 17,
+	GPIOKPF_PRINT_PHANTOM_KEYS       = 1U << 18,
+};
+
+#define MATRIX_CODE_BITS (10)
+#define MATRIX_KEY_MASK ((1U << MATRIX_CODE_BITS) - 1)
+#define MATRIX_KEY(dev, code) \
+	(((dev) << MATRIX_CODE_BITS) | (code & MATRIX_KEY_MASK))
+
+extern int gpio_event_matrix_func(struct gpio_event_input_devs *input_devs,
+			struct gpio_event_info *info, void **data, int func);
+struct gpio_event_matrix_info {
+	/* initialize to gpio_event_matrix_func */
+	struct gpio_event_info info;
+	/* size must be ninputs * noutputs */
+	const unsigned short *keymap;
+	unsigned int *input_gpios;
+	unsigned int *output_gpios;
+	unsigned int ninputs;
+	unsigned int noutputs;
+	/* time to wait before reading inputs after driving each output */
+	ktime_t settle_time;
+	/* time to wait before scanning the keypad a second time */
+	ktime_t debounce_delay;
+	ktime_t poll_time;
+	unsigned flags;
+};
+
+/* Directly connected inputs and outputs */
+
+enum gpio_event_direct_flags {
+	GPIOEDF_ACTIVE_HIGH         = 1U << 0,
+/*	GPIOEDF_USE_DOWN_IRQ        = 1U << 1, */
+/*	GPIOEDF_USE_IRQ             = (1U << 2) | GPIOIDF_USE_DOWN_IRQ, */
+	GPIOEDF_PRINT_KEYS          = 1U << 8,
+	GPIOEDF_PRINT_KEY_DEBOUNCE  = 1U << 9,
+	GPIOEDF_PRINT_KEY_UNSTABLE  = 1U << 10,
+};
+
+struct gpio_event_direct_entry {
+	uint32_t gpio:16;
+	uint32_t code:10;
+	uint32_t dev:6;
+};
+
+/* inputs */
+extern int gpio_event_input_func(struct gpio_event_input_devs *input_devs,
+			struct gpio_event_info *info, void **data, int func);
+struct gpio_event_input_info {
+	/* initialize to gpio_event_input_func */
+	struct gpio_event_info info;
+	ktime_t debounce_time;
+	ktime_t poll_time;
+	uint16_t flags;
+	uint16_t type;
+	const struct gpio_event_direct_entry *keymap;
+	size_t keymap_size;
+};
+
+/* outputs */
+extern int gpio_event_output_func(struct gpio_event_input_devs *input_devs,
+			struct gpio_event_info *info, void **data, int func);
+extern int gpio_event_output_event(struct gpio_event_input_devs *input_devs,
+			struct gpio_event_info *info, void **data,
+			unsigned int dev, unsigned int type,
+			unsigned int code, int value);
+struct gpio_event_output_info {
+	/* initialize to gpio_event_output_func and gpio_event_output_event */
+	struct gpio_event_info info;
+	uint16_t flags;
+	uint16_t type;
+	const struct gpio_event_direct_entry *keymap;
+	size_t keymap_size;
+};
+
+
+/* axes */
+
+enum gpio_event_axis_flags {
+	GPIOEAF_PRINT_UNKNOWN_DIRECTION  = 1U << 16,
+	GPIOEAF_PRINT_RAW                = 1U << 17,
+	GPIOEAF_PRINT_EVENT              = 1U << 18,
+};
+
+extern int gpio_event_axis_func(struct gpio_event_input_devs *input_devs,
+			struct gpio_event_info *info, void **data, int func);
+struct gpio_event_axis_info {
+	/* initialize to gpio_event_axis_func */
+	struct gpio_event_info info;
+	uint8_t  count; /* number of gpios for this axis */
+	uint8_t  dev; /* device index when using multiple input devices */
+	uint8_t  type; /* EV_REL or EV_ABS */
+	uint16_t code;
+	uint16_t decoded_size;
+	uint16_t (*map)(struct gpio_event_axis_info *info, uint16_t in);
+	uint32_t *gpio;
+	uint32_t flags;
+};
+#define gpio_axis_2bit_gray_map gpio_axis_4bit_gray_map
+#define gpio_axis_3bit_gray_map gpio_axis_4bit_gray_map
+uint16_t gpio_axis_4bit_gray_map(
+			struct gpio_event_axis_info *info, uint16_t in);
+uint16_t gpio_axis_5bit_singletrack_map(
+			struct gpio_event_axis_info *info, uint16_t in);
+
+#endif
diff --git a/include/linux/if_pppolac.h b/include/linux/if_pppolac.h
new file mode 100644
index 00000000..e40aa10
--- /dev/null
+++ b/include/linux/if_pppolac.h
@@ -0,0 +1,23 @@
+/* include/linux/if_pppolac.h
+ *
+ * Header for PPP on L2TP Access Concentrator / PPPoLAC Socket (RFC 2661)
+ *
+ * Copyright (C) 2009 Google, Inc.
+ * Author: Chia-chi Yeh <chiachi@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef __LINUX_IF_PPPOLAC_H
+#define __LINUX_IF_PPPOLAC_H
+
+#include <uapi/linux/if_pppolac.h>
+
+#endif /* __LINUX_IF_PPPOLAC_H */
diff --git a/include/linux/if_pppopns.h b/include/linux/if_pppopns.h
new file mode 100644
index 00000000..4ac621a9
--- /dev/null
+++ b/include/linux/if_pppopns.h
@@ -0,0 +1,23 @@
+/* include/linux/if_pppopns.h
+ *
+ * Header for PPP on PPTP Network Server / PPPoPNS Socket (RFC 2637)
+ *
+ * Copyright (C) 2009 Google, Inc.
+ * Author: Chia-chi Yeh <chiachi@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef __LINUX_IF_PPPOPNS_H
+#define __LINUX_IF_PPPOPNS_H
+
+#include <uapi/linux/if_pppopns.h>
+
+#endif /* __LINUX_IF_PPPOPNS_H */
diff --git a/include/linux/if_pppox.h b/include/linux/if_pppox.h
index ba7a9b0..325727a 100644
--- a/include/linux/if_pppox.h
+++ b/include/linux/if_pppox.h
@@ -43,6 +43,25 @@ struct pptp_opt {
 	u32 seq_sent, seq_recv;
 	int ppp_flags;
 };
+
+struct pppolac_opt {
+	__u32		local;
+	__u32		remote;
+	__u32		recv_sequence;
+	__u32		xmit_sequence;
+	atomic_t	sequencing;
+	int		(*backlog_rcv)(struct sock *sk_udp, struct sk_buff *skb);
+};
+
+struct pppopns_opt {
+	__u16		local;
+	__u16		remote;
+	__u32		recv_sequence;
+	__u32		xmit_sequence;
+	void		(*data_ready)(struct sock *sk_raw);
+	int		(*backlog_rcv)(struct sock *sk_raw, struct sk_buff *skb);
+};
+
 #include <net/sock.h>
 
 struct pppox_sock {
@@ -53,6 +72,8 @@ struct pppox_sock {
 	union {
 		struct pppoe_opt pppoe;
 		struct pptp_opt  pptp;
+		struct pppolac_opt lac;
+		struct pppopns_opt pns;
 	} proto;
 	__be16			num;
 };
diff --git a/include/linux/init.h b/include/linux/init.h
index 0cca414..d4b13a4 100644
--- a/include/linux/init.h
+++ b/include/linux/init.h
@@ -46,7 +46,7 @@
 
 /* These are for everybody (although not all archs will actually
    discard it in modules) */
-#define __init		__section(.init.text) __cold notrace __latent_entropy __noinitretpoline
+#define __init		__section(.init.text) __cold notrace __latent_entropy __noinitretpoline __nocfi
 #define __initdata	__section(.init.data)
 #define __initconst	__section(.init.rodata)
 #define __exitdata	__section(.exit.data)
@@ -150,6 +150,15 @@
 
 #ifndef __ASSEMBLY__
 
+#ifdef CONFIG_LTO_CLANG
+  /* prepend the variable name with __COUNTER__ to ensure correct ordering */
+  #define ___initcall_name2(c, fn, id) 	__initcall_##c##_##fn##id
+  #define ___initcall_name1(c, fn, id)	___initcall_name2(c, fn, id)
+  #define __initcall_name(fn, id) 	___initcall_name1(__COUNTER__, fn, id)
+#else
+  #define __initcall_name(fn, id) 	__initcall_##fn##id
+#endif
+
 /*
  * initcalls are now grouped by functionality into separate
  * subsections. Ordering inside the subsections is determined
@@ -167,7 +176,7 @@
  */
 
 #define __define_initcall(fn, id) \
-	static initcall_t __initcall_##fn##id __used \
+	static initcall_t __initcall_name(fn, id) __used \
 	__attribute__((__section__(".initcall" #id ".init"))) = fn;
 
 /*
diff --git a/include/linux/initramfs.h b/include/linux/initramfs.h
new file mode 100644
index 00000000..fc7da63
--- /dev/null
+++ b/include/linux/initramfs.h
@@ -0,0 +1,32 @@
+/*
+ * include/linux/initramfs.h
+ *
+ * Copyright (C) 2015, Google
+ * Rom Lemarchand <romlem@android.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2 of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ */
+
+#ifndef _LINUX_INITRAMFS_H
+#define _LINUX_INITRAMFS_H
+
+#include <linux/kconfig.h>
+
+#if IS_BUILTIN(CONFIG_BLK_DEV_INITRD)
+
+int __init default_rootfs(void);
+
+#endif
+
+#endif /* _LINUX_INITRAMFS_H */
diff --git a/include/linux/interrupt.h b/include/linux/interrupt.h
index 72f0721..999b7c3 100644
--- a/include/linux/interrupt.h
+++ b/include/linux/interrupt.h
@@ -18,6 +18,7 @@
 #include <linux/atomic.h>
 #include <asm/ptrace.h>
 #include <asm/irq.h>
+#include <asm/sections.h>
 
 /*
  * These correspond to the IORESOURCE_IRQ_* defines in
@@ -699,7 +700,6 @@ static inline void init_irq_proc(void)
 extern int arch_probe_nr_irqs(void);
 extern int arch_early_irq_init(void);
 
-#if defined(CONFIG_FUNCTION_GRAPH_TRACER) || defined(CONFIG_KASAN)
 /*
  * We want to know which function is an entrypoint of a hardirq or a softirq.
  */
@@ -707,16 +707,4 @@ static inline void init_irq_proc(void)
 #define __softirq_entry  \
 	__attribute__((__section__(".softirqentry.text")))
 
-/* Limits of hardirq entrypoints */
-extern char __irqentry_text_start[];
-extern char __irqentry_text_end[];
-/* Limits of softirq entrypoints */
-extern char __softirqentry_text_start[];
-extern char __softirqentry_text_end[];
-
-#else
-#define __irq_entry
-#define __softirq_entry
-#endif
-
 #endif
diff --git a/include/linux/ipv6.h b/include/linux/ipv6.h
index b9dfca55..11ff751 100644
--- a/include/linux/ipv6.h
+++ b/include/linux/ipv6.h
@@ -37,9 +37,11 @@ struct ipv6_devconf {
 	__s32		accept_ra_rtr_pref;
 	__s32		rtr_probe_interval;
 #ifdef CONFIG_IPV6_ROUTE_INFO
+	__s32		accept_ra_rt_info_min_plen;
 	__s32		accept_ra_rt_info_max_plen;
 #endif
 #endif
+	__s32		accept_ra_rt_table;
 	__s32		proxy_ndp;
 	__s32		accept_source_route;
 	__s32		accept_ra_from_local;
diff --git a/include/linux/irqchip/arm-gic-v3.h b/include/linux/irqchip/arm-gic-v3.h
index b7e3431..5eea7f8 100644
--- a/include/linux/irqchip/arm-gic-v3.h
+++ b/include/linux/irqchip/arm-gic-v3.h
@@ -43,6 +43,7 @@
 #define GICD_IGRPMODR			0x0D00
 #define GICD_NSACR			0x0E00
 #define GICD_IROUTER			0x6000
+#define GICD_ICLAR			0xE000
 #define GICD_IDREGS			0xFFD0
 #define GICD_PIDR2			0xFFE8
 
@@ -92,6 +93,8 @@
 #define GICR_TYPER			0x0008
 #define GICR_STATUSR			GICD_STATUSR
 #define GICR_WAKER			0x0014
+#define GICR_FCTLR			0x0020
+#define GICR_CLASS			0x0028
 #define GICR_SETLPIR			0x0040
 #define GICR_CLRLPIR			0x0048
 #define GICR_SEIR			GICD_SEIR
diff --git a/include/linux/kasan.h b/include/linux/kasan.h
index 820c0ad..b37afd1 100644
--- a/include/linux/kasan.h
+++ b/include/linux/kasan.h
@@ -30,16 +30,10 @@ static inline void *kasan_mem_to_shadow(const void *addr)
 }
 
 /* Enable reporting bugs after kasan_disable_current() */
-static inline void kasan_enable_current(void)
-{
-	current->kasan_depth++;
-}
+extern void kasan_enable_current(void);
 
 /* Disable reporting bugs for current task */
-static inline void kasan_disable_current(void)
-{
-	current->kasan_depth--;
-}
+extern void kasan_disable_current(void);
 
 void kasan_unpoison_shadow(const void *address, size_t size);
 
@@ -52,7 +46,7 @@ static inline void kasan_disable_current(void)
 void kasan_cache_create(struct kmem_cache *cache, size_t *size,
 			unsigned long *flags);
 void kasan_cache_shrink(struct kmem_cache *cache);
-void kasan_cache_destroy(struct kmem_cache *cache);
+void kasan_cache_shutdown(struct kmem_cache *cache);
 
 void kasan_poison_slab(struct page *page);
 void kasan_unpoison_object_data(struct kmem_cache *cache, void *object);
@@ -81,6 +75,9 @@ struct kasan_cache {
 static inline void kasan_unpoison_slab(const void *ptr) { ksize(ptr); }
 size_t kasan_metadata_size(struct kmem_cache *cache);
 
+bool kasan_save_enable_multi_shot(void);
+void kasan_restore_multi_shot(bool enabled);
+
 #else /* CONFIG_KASAN */
 
 static inline void kasan_unpoison_shadow(const void *address, size_t size) {}
@@ -98,7 +95,7 @@ static inline void kasan_cache_create(struct kmem_cache *cache,
 				      size_t *size,
 				      unsigned long *flags) {}
 static inline void kasan_cache_shrink(struct kmem_cache *cache) {}
-static inline void kasan_cache_destroy(struct kmem_cache *cache) {}
+static inline void kasan_cache_shutdown(struct kmem_cache *cache) {}
 
 static inline void kasan_poison_slab(struct page *page) {}
 static inline void kasan_unpoison_object_data(struct kmem_cache *cache,
diff --git a/include/linux/kbuild.h b/include/linux/kbuild.h
index 22a7219..4e80f3a 100644
--- a/include/linux/kbuild.h
+++ b/include/linux/kbuild.h
@@ -2,14 +2,14 @@
 #define __LINUX_KBUILD_H
 
 #define DEFINE(sym, val) \
-        asm volatile("\n->" #sym " %0 " #val : : "i" (val))
+	asm volatile("\n.ascii \"->" #sym " %0 " #val "\"" : : "i" (val))
 
-#define BLANK() asm volatile("\n->" : : )
+#define BLANK() asm volatile("\n.ascii \"->\"" : : )
 
 #define OFFSET(sym, str, mem) \
 	DEFINE(sym, offsetof(struct str, mem))
 
 #define COMMENT(x) \
-	asm volatile("\n->#" x)
+	asm volatile("\n.ascii \"->#" x "\"")
 
 #endif
diff --git a/include/linux/kcov.h b/include/linux/kcov.h
index 2883ac9..87e2a44 100644
--- a/include/linux/kcov.h
+++ b/include/linux/kcov.h
@@ -7,19 +7,23 @@
 
 #ifdef CONFIG_KCOV
 
-void kcov_task_init(struct task_struct *t);
-void kcov_task_exit(struct task_struct *t);
-
 enum kcov_mode {
 	/* Coverage collection is not enabled yet. */
 	KCOV_MODE_DISABLED = 0,
+	/* KCOV was initialized, but tracing mode hasn't been chosen yet. */
+	KCOV_MODE_INIT = 1,
 	/*
 	 * Tracing coverage collection mode.
 	 * Covered PCs are collected in a per-task buffer.
 	 */
-	KCOV_MODE_TRACE = 1,
+	KCOV_MODE_TRACE_PC = 2,
+	/* Collecting comparison operands mode. */
+	KCOV_MODE_TRACE_CMP = 3,
 };
 
+void kcov_task_init(struct task_struct *t);
+void kcov_task_exit(struct task_struct *t);
+
 #else
 
 static inline void kcov_task_init(struct task_struct *t) {}
diff --git a/include/linux/key.h b/include/linux/key.h
index ed9b44f..7e2d143 100644
--- a/include/linux/key.h
+++ b/include/linux/key.h
@@ -369,7 +369,10 @@ static inline bool key_is_negative(const struct key *key)
 	return key_read_state(key) < 0;
 }
 
-#define rcu_dereference_key(KEY)					\
+#define dereference_key_rcu(KEY)					\
+	(rcu_dereference((KEY)->payload.rcu_data0))
+
+#define dereference_key_locked(KEY)					\
 	(rcu_dereference_protected((KEY)->payload.rcu_data0,		\
 				   rwsem_is_locked(&((struct key *)(KEY))->sem)))
 
diff --git a/include/linux/keychord.h b/include/linux/keychord.h
new file mode 100644
index 00000000..08cf540
--- /dev/null
+++ b/include/linux/keychord.h
@@ -0,0 +1,23 @@
+/*
+ *  Key chord input driver
+ *
+ * Copyright (C) 2008 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+*/
+
+#ifndef __LINUX_KEYCHORD_H_
+#define __LINUX_KEYCHORD_H_
+
+#include <uapi/linux/keychord.h>
+
+#endif	/* __LINUX_KEYCHORD_H_ */
diff --git a/include/linux/keycombo.h b/include/linux/keycombo.h
new file mode 100644
index 00000000..c6db262
--- /dev/null
+++ b/include/linux/keycombo.h
@@ -0,0 +1,36 @@
+/*
+ * include/linux/keycombo.h - platform data structure for keycombo driver
+ *
+ * Copyright (C) 2014 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_KEYCOMBO_H
+#define _LINUX_KEYCOMBO_H
+
+#define KEYCOMBO_NAME "keycombo"
+
+/*
+ * if key_down_fn and key_up_fn are both present, you are guaranteed that
+ * key_down_fn will return before key_up_fn is called, and that key_up_fn
+ * is called iff key_down_fn is called.
+ */
+struct keycombo_platform_data {
+	void (*key_down_fn)(void *);
+	void (*key_up_fn)(void *);
+	void *priv;
+	int key_down_delay; /* Time in ms */
+	int *keys_up;
+	int keys_down[]; /* 0 terminated */
+};
+
+#endif /* _LINUX_KEYCOMBO_H */
diff --git a/include/linux/keyreset.h b/include/linux/keyreset.h
new file mode 100644
index 00000000..2e34afa
--- /dev/null
+++ b/include/linux/keyreset.h
@@ -0,0 +1,29 @@
+/*
+ * include/linux/keyreset.h - platform data structure for resetkeys driver
+ *
+ * Copyright (C) 2014 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _LINUX_KEYRESET_H
+#define _LINUX_KEYRESET_H
+
+#define KEYRESET_NAME "keyreset"
+
+struct keyreset_platform_data {
+	int (*reset_fn)(void);
+	int key_down_delay;
+	int *keys_up;
+	int keys_down[]; /* 0 terminated */
+};
+
+#endif /* _LINUX_KEYRESET_H */
diff --git a/include/linux/kobject.h b/include/linux/kobject.h
index e628459..c1229fa 100644
--- a/include/linux/kobject.h
+++ b/include/linux/kobject.h
@@ -57,6 +57,11 @@ enum kobject_action {
 	KOBJ_MOVE,
 	KOBJ_ONLINE,
 	KOBJ_OFFLINE,
+#if IS_ENABLED(CONFIG_R8168) || IS_ENABLED(CONFIG_R8169SOC) || \
+	IS_ENABLED(CONFIG_RTD_1295_HWNAT)
+	KOBJ_LINKUP,
+	KOBJ_LINKDOWN,
+#endif
 	KOBJ_MAX
 };
 
diff --git a/include/linux/libata.h b/include/linux/libata.h
index df58b01..7f3a910 100644
--- a/include/linux/libata.h
+++ b/include/linux/libata.h
@@ -862,6 +862,11 @@ struct ata_port {
 
 	struct mutex		scsi_scan_mutex;
 	struct delayed_work	hotplug_task;
+
+#ifdef CONFIG_AHCI_RTK
+	unsigned int hotplug_flag;
+#endif
+
 	struct work_struct	scsi_rescan_task;
 
 	unsigned int		hsm_task_state;
diff --git a/include/linux/lsm_hooks.h b/include/linux/lsm_hooks.h
index 558adfa..121f2f2 100644
--- a/include/linux/lsm_hooks.h
+++ b/include/linux/lsm_hooks.h
@@ -1328,7 +1328,40 @@
  *	@inode we wish to get the security context of.
  *	@ctx is a pointer in which to place the allocated security context.
  *	@ctxlen points to the place to put the length of @ctx.
- * This is the main security structure.
+ *
+ * Security hooks for using the eBPF maps and programs functionalities through
+ * eBPF syscalls.
+ *
+ * @bpf:
+ *	Do a initial check for all bpf syscalls after the attribute is copied
+ *	into the kernel. The actual security module can implement their own
+ *	rules to check the specific cmd they need.
+ *
+ * @bpf_map:
+ *	Do a check when the kernel generate and return a file descriptor for
+ *	eBPF maps.
+ *
+ *	@map: bpf map that we want to access
+ *	@mask: the access flags
+ *
+ * @bpf_prog:
+ *	Do a check when the kernel generate and return a file descriptor for
+ *	eBPF programs.
+ *
+ *	@prog: bpf prog that userspace want to use.
+ *
+ * @bpf_map_alloc_security:
+ *	Initialize the security field inside bpf map.
+ *
+ * @bpf_map_free_security:
+ *	Clean up the security information stored inside bpf map.
+ *
+ * @bpf_prog_alloc_security:
+ *	Initialize the security field inside bpf program.
+ *
+ * @bpf_prog_free_security:
+ *	Clean up the security information stored inside bpf prog.
+ *
  */
 
 union security_list_options {
@@ -1652,6 +1685,17 @@
 				struct audit_context *actx);
 	void (*audit_rule_free)(void *lsmrule);
 #endif /* CONFIG_AUDIT */
+
+#ifdef CONFIG_BPF_SYSCALL
+	int (*bpf)(int cmd, union bpf_attr *attr,
+				 unsigned int size);
+	int (*bpf_map)(struct bpf_map *map, fmode_t fmode);
+	int (*bpf_prog)(struct bpf_prog *prog);
+	int (*bpf_map_alloc_security)(struct bpf_map *map);
+	void (*bpf_map_free_security)(struct bpf_map *map);
+	int (*bpf_prog_alloc_security)(struct bpf_prog_aux *aux);
+	void (*bpf_prog_free_security)(struct bpf_prog_aux *aux);
+#endif /* CONFIG_BPF_SYSCALL */
 };
 
 struct security_hook_heads {
@@ -1866,6 +1910,15 @@ struct security_hook_heads {
 	struct list_head audit_rule_match;
 	struct list_head audit_rule_free;
 #endif /* CONFIG_AUDIT */
+#ifdef CONFIG_BPF_SYSCALL
+	struct list_head bpf;
+	struct list_head bpf_map;
+	struct list_head bpf_prog;
+	struct list_head bpf_map_alloc_security;
+	struct list_head bpf_map_free_security;
+	struct list_head bpf_prog_alloc_security;
+	struct list_head bpf_prog_free_security;
+#endif /* CONFIG_BPF_SYSCALL */
 };
 
 /*
diff --git a/include/linux/memcontrol.h b/include/linux/memcontrol.h
index 8b35bdb..dc4de7e 100644
--- a/include/linux/memcontrol.h
+++ b/include/linux/memcontrol.h
@@ -490,10 +490,29 @@ static inline bool task_in_memcg_oom(struct task_struct *p)
 extern int do_swap_account;
 #endif
 
-void lock_page_memcg(struct page *page);
+struct mem_cgroup *lock_page_memcg(struct page *page);
+void __unlock_page_memcg(struct mem_cgroup *memcg);
 void unlock_page_memcg(struct page *page);
 
 /**
+ * mem_cgroup_update_stat - update state statistics
+ */
+static inline void mem_cgroup_update_stat(struct mem_cgroup *memcg,
+				 enum mem_cgroup_stat_index idx, int val)
+{
+	VM_BUG_ON(!(rcu_read_lock_held()));
+
+	if (memcg)
+		this_cpu_add(memcg->stat->count[idx], val);
+}
+
+static inline void mem_cgroup_dec_stat(struct mem_cgroup *memcg,
+					    enum mem_cgroup_stat_index idx)
+{
+	mem_cgroup_update_stat(memcg, idx, -1);
+}
+
+/**
  * mem_cgroup_update_page_stat - update page state statistics
  * @page: the page
  * @idx: page state item to account
@@ -709,7 +728,12 @@ static inline unsigned long mem_cgroup_get_limit(struct mem_cgroup *memcg)
 {
 }
 
-static inline void lock_page_memcg(struct page *page)
+static inline struct mem_cgroup *lock_page_memcg(struct page *page)
+{
+	return NULL;
+}
+
+static inline void __unlock_page_memcg(struct mem_cgroup *memcg)
 {
 }
 
diff --git a/include/linux/memory-state-time.h b/include/linux/memory-state-time.h
new file mode 100644
index 00000000..d2212b0
--- /dev/null
+++ b/include/linux/memory-state-time.h
@@ -0,0 +1,42 @@
+/* include/linux/memory-state-time.h
+ *
+ * Copyright (C) 2016 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/workqueue.h>
+
+#define UPDATE_MEMORY_STATE(BLOCK, VALUE) BLOCK->update_call(BLOCK, VALUE)
+
+struct memory_state_update_block;
+
+typedef void (*memory_state_update_fn_t)(struct memory_state_update_block *ub,
+		int value);
+
+/* This struct is populated when you pass it to a memory_state_register*
+ * function. The update_call function is used for an update and defined in the
+ * typedef memory_state_update_fn_t
+ */
+struct memory_state_update_block {
+	memory_state_update_fn_t update_call;
+	int id;
+};
+
+/* Register a frequency struct memory_state_update_block to provide updates to
+ * memory_state_time about frequency changes using its update_call function.
+ */
+struct memory_state_update_block *memory_state_register_frequency_source(void);
+
+/* Register a bandwidth struct memory_state_update_block to provide updates to
+ * memory_state_time about bandwidth changes using its update_call function.
+ */
+struct memory_state_update_block *memory_state_register_bandwidth_source(void);
diff --git a/include/linux/mfd/apw8886.h b/include/linux/mfd/apw8886.h
new file mode 100644
index 00000000..1b8477f
--- /dev/null
+++ b/include/linux/mfd/apw8886.h
@@ -0,0 +1,156 @@
+#ifndef __LINUX_MFD_APW8886_H
+#define __LINUX_MFD_APW8886_H
+
+/* button registers */
+#define APW8886_REG_INTR                (0x00)
+#define APW8886_REG_INTR_MASK           (0x01)
+#define APW8886_REG_PWRKEY              (0x02)
+#define APW8886_REG_SYS_CONTROL         (0x04)
+
+/* regulator control registers */
+#define APW8886_REG_FAULT_STATUS        (0x03)
+#define APW8886_REG_ONOFF               (0x05)
+#define APW8886_REG_DISCHG              (0x06)
+#define APW8886_REG_DC1DC2_MODE         (0x07)
+#define APW8886_REG_DC1_MODE            (APW8886_REG_DC1DC2_MODE)
+#define APW8886_REG_DC2_MODE            (APW8886_REG_DC1DC2_MODE)
+#define APW8886_REG_DC3_MODE            (0x08)
+#define APW8886_REG_DC4DC5_MODE         (0x09)
+#define APW8886_REG_DC4_MODE            (APW8886_REG_DC4DC5_MODE)
+#define APW8886_REG_DC5_MODE            (APW8886_REG_DC4DC5_MODE)
+#define APW8886_REG_LDO1_MODE           (0x0A)
+#define APW8886_REG_DC1_NRMVOLT         (0x0B)
+#define APW8886_REG_DC2_NRMVOLT         (0x0C)
+#define APW8886_REG_DC3_NRMVOLT         (0x0D)
+#define APW8886_REG_DC4_NRMVOLT         (0x0F)
+#define APW8886_REG_LDO1_NRMVOLT        (0x10)
+#define APW8886_REG_DC1_SLPVOLT         (0x11)
+#define APW8886_REG_DC2_SLPVOLT         (0x12)
+#define APW8886_REG_DC3_SLPVOLT         (0x13)
+#define APW8886_REG_DC4_SLPVOLT         (0x15)
+#define APW8886_REG_LDO1_SLPVOLT        (0x16)
+#define APW8886_REG_CLAMP               (0x17)
+
+/* misc registers */
+#define APW8886_REG_CHIP_ID             (0x1D)
+#define APW8886_REG_VERSION             (0x1E)
+
+/* register field: ONOFF */
+#define APW8886_DC1_ON_MASK             (0x80)
+#define APW8886_DC1_ON_SHIFT            (7)
+#define APW8886_DC1_ON_WIDTH            (1)
+#define APW8886_DC2_ON_MASK             (0x40)
+#define APW8886_DC2_ON_SHIFT            (6)
+#define APW8886_DC2_ON_WIDTH            (1)
+#define APW8886_DC3_ON_MASK             (0x20)
+#define APW8886_DC3_ON_SHIFT            (5)
+#define APW8886_DC3_ON_WIDTH            (1)
+#define APW8886_DC5_ON_MASK             (0x08)
+#define APW8886_DC5_ON_SHIFT            (3)
+#define APW8886_DC5_ON_WIDTH            (1)
+#define APW8886_DC4_ON_MASK             (0x04)
+#define APW8886_DC4_ON_SHIFT            (2)
+#define APW8886_DC4_ON_WIDTH            (1)
+#define APW8886_LDO1_ON_MASK            (0x01)
+#define APW8886_LDO1_ON_SHIFT           (0)
+#define APW8886_LDO1_ON_WIDTH           (1)
+
+/* register field: DISCHG */
+#define APW8886_DC1_DISCHG_MASK         (0x80)
+#define APW8886_DC1_DISCHG_SHIFT        (7)
+#define APW8886_DC1_DISCHG_WIDTH        (1)
+#define APW8886_DC2_DISCHG_MASK         (0x40)
+#define APW8886_DC2_DISCHG_SHIFT        (6)
+#define APW8886_DC2_DISCHG_WIDTH        (1)
+#define APW8886_DC3_DISCHG_MASK         (0x20)
+#define APW8886_DC3_DISCHG_SHIFT        (5)
+#define APW8886_DC3_DISCHG_WIDTH        (1)
+#define APW8886_DC5_DISCHG_MASK         (0x08)
+#define APW8886_DC5_DISCHG_SHIFT        (3)
+#define APW8886_DC5_DISCHG_WIDTH        (1)
+#define APW8886_DC4_DISCHG_MASK         (0x04)
+#define APW8886_DC4_DISCHG_SHIFT        (2)
+#define APW8886_DC4_DISCHG_WIDTH        (1)
+#define APW8886_LDO1_DISCHG_MASK        (0x01)
+#define APW8886_LDO1_DISCHG_SHIFT       (0)
+#define APW8886_LDO1_DISCHG_WIDTH       (1)
+
+/* register field: MODE */
+#define APW8886_DC1_NRMMODE_MASK        (0xC0)
+#define APW8886_DC1_NRMMODE_SHIFT       (6)
+#define APW8886_DC1_NRMMODE_WIDTH       (2)
+#define APW8886_DC1_SLPMODE_MASK        (0x30)
+#define APW8886_DC1_SLPMODE_SHIFT       (4)
+#define APW8886_DC1_SLPMODE_WIDTH       (2)
+#define APW8886_DC2_NRMMODE_MASK        (0x0C)
+#define APW8886_DC2_NRMMODE_SHIFT       (2)
+#define APW8886_DC2_NRMMODE_WIDTH       (2)
+#define APW8886_DC2_SLPMODE_MASK        (0x03)
+#define APW8886_DC2_SLPMODE_SHIFT       (0)
+#define APW8886_DC2_SLPMODE_WIDTH       (2)
+#define APW8886_DC3_NRMMODE_MASK        (0xC0)
+#define APW8886_DC3_NRMMODE_SHIFT       (6)
+#define APW8886_DC3_NRMMODE_WIDTH       (2)
+#define APW8886_DC3_SLPMODE_MASK        (0x30)
+#define APW8886_DC3_SLPMODE_SHIFT       (4)
+#define APW8886_DC3_SLPMODE_WIDTH       (2)
+#define APW8886_DC5_NRMMODE_MASK        (0xC0)
+#define APW8886_DC5_NRMMODE_SHIFT       (6)
+#define APW8886_DC5_NRMMODE_WIDTH       (2)
+#define APW8886_DC5_SLPMODE_MASK        (0x30)
+#define APW8886_DC5_SLPMODE_SHIFT       (4)
+#define APW8886_DC5_SLPMODE_WIDTH       (2)
+#define APW8886_DC4_NRMMODE_MASK        (0x0C)
+#define APW8886_DC4_NRMMODE_SHIFT       (2)
+#define APW8886_DC4_NRMMODE_WIDTH       (2)
+#define APW8886_DC4_SLPMODE_MASK        (0x03)
+#define APW8886_DC4_SLPMODE_SHIFT       (0)
+#define APW8886_DC4_SLPMODE_WIDTH       (2)
+#define APW8886_LDO1_NRMMODE_MASK       (0x30)
+#define APW8886_LDO1_NRMMODE_SHIFT      (4)
+#define APW8886_LDO1_NRMMODE_WIDTH      (2)
+#define APW8886_LDO1_SLPMODE_MASK       (0x30)
+#define APW8886_LDO1_SLPMODE_SHIFT      (4)
+#define APW8886_LDO1_SLPMODE_WIDTH      (2)
+
+/* register field: NRMVOLT / SLPVOLT */
+#define APW8886_DC1_NRMVOLT_MASK        (0x3F)
+#define APW8886_DC1_NRMVOLT_SHIFT       (0)
+#define APW8886_DC1_NRMVOLT_WIDTH       (6)
+#define APW8886_DC1_SLPVOLT_MASK        (0x3F)
+#define APW8886_DC1_SLPVOLT_SHIFT       (0)
+#define APW8886_DC1_SLPVOLT_WIDTH       (6)
+#define APW8886_DC2_NRMVOLT_MASK        (0x3F)
+#define APW8886_DC2_NRMVOLT_SHIFT       (0)
+#define APW8886_DC2_NRMVOLT_WIDTH       (6)
+#define APW8886_DC2_SLPVOLT_MASK        (0x3F)
+#define APW8886_DC2_SLPVOLT_SHIFT       (0)
+#define APW8886_DC2_SLPVOLT_WIDTH       (6)
+#define APW8886_DC3_NRMVOLT_MASK        (0x3F)
+#define APW8886_DC3_NRMVOLT_SHIFT       (0)
+#define APW8886_DC3_NRMVOLT_WIDTH       (6)
+#define APW8886_DC3_SLPVOLT_MASK        (0x3F)
+#define APW8886_DC3_SLPVOLT_SHIFT       (0)
+#define APW8886_DC3_SLPVOLT_WIDTH       (6)
+#define APW8886_DC4_NRMVOLT_MASK        (0x3F)
+#define APW8886_DC4_NRMVOLT_SHIFT       (0)
+#define APW8886_DC4_NRMVOLT_WIDTH       (6)
+#define APW8886_DC4_SLPVOLT_MASK        (0x3F)
+#define APW8886_DC4_SLPVOLT_SHIFT       (0)
+#define APW8886_DC4_SLPVOLT_WIDTH       (6)
+#define APW8886_LDO1_NRMVOLT_MASK       (0x1F)
+#define APW8886_LDO1_NRMVOLT_SHIFT      (0)
+#define APW8886_LDO1_NRMVOLT_WIDTH      (5)
+#define APW8886_LDO1_SLPVOLT_MASK       (0x1F)
+#define APW8886_LDO1_SLPVOLT_SHIFT      (0)
+#define APW8886_LDO1_SLPVOLT_WIDTH      (6)
+
+/* register field: CLAMP */
+#define APW8886_DC2_CLAMP_MASK          (0x2)
+#define APW8886_DC2_CLAMP_SHIFT         (1)
+#define APW8886_DC2_CLAMP_WIDTH         (1)
+#define APW8886_DC3_CLAMP_MASK          (0x1)
+#define APW8886_DC3_CLAMP_SHIFT         (0)
+#define APW8886_DC3_CLAMP_WIDTH         (1)
+
+#endif /* __LINUX_MFD_APW8886_H */
diff --git a/include/linux/mfd/apw8889.h b/include/linux/mfd/apw8889.h
new file mode 100644
index 00000000..8ef42b6
--- /dev/null
+++ b/include/linux/mfd/apw8889.h
@@ -0,0 +1,181 @@
+#ifndef __LINUX_MFD_APW8889_H
+#define __LINUX_MFD_APW8889_H
+
+/* button registers */
+#define APW8889_REG_INTR                (0x00)
+#define APW8889_REG_INTR_MASK           (0x01)
+#define APW8889_REG_PWRKEY              (0x02)
+#define APW8889_REG_SYS_CONTROL         (0x04)
+
+/* regulator control registers */
+#define APW8889_REG_FAULT_STATUS        (0x03)
+#define APW8889_REG_ONOFF               (0x05)
+#define APW8889_REG_DISCHG              (0x06)
+#define APW8889_REG_DC1DC2_MODE         (0x07)
+#define APW8889_REG_DC1_MODE            (APW8889_REG_DC1DC2_MODE)
+#define APW8889_REG_DC2_MODE            (APW8889_REG_DC1DC2_MODE)
+#define APW8889_REG_DC3DC4_MODE         (0x08)
+#define APW8889_REG_DC3_MODE            (APW8889_REG_DC3DC4_MODE)
+#define APW8889_REG_DC4_MODE            (APW8889_REG_DC3DC4_MODE)
+#define APW8889_REG_DC5DC6_MODE         (0x09)
+#define APW8889_REG_DC5_MODE            (APW8889_REG_DC5DC6_MODE)
+#define APW8889_REG_DC6_MODE            (APW8889_REG_DC5DC6_MODE)
+#define APW8889_REG_LDO1_MODE           (0x0A)
+#define APW8889_REG_DC1_NRMVOLT         (0x0B)
+#define APW8889_REG_DC2_NRMVOLT         (0x0C)
+#define APW8889_REG_DC3_NRMVOLT         (0x0D)
+#define APW8889_REG_DC4_NRMVOLT         (0x0E)
+#define APW8889_REG_DC6_NRMVOLT         (0x0F)
+#define APW8889_REG_LDO1_NRMVOLT        (0x10)
+#define APW8889_REG_DC1_SLPVOLT         (0x11)
+#define APW8889_REG_DC2_SLPVOLT         (0x12)
+#define APW8889_REG_DC3_SLPVOLT         (0x13)
+#define APW8889_REG_DC4_SLPVOLT         (0x14)
+#define APW8889_REG_DC6_SLPVOLT         (0x15)
+#define APW8889_REG_LDO1_SLPVOLT        (0x16)
+#define APW8889_REG_CLAMP               (0x17)
+
+/* misc registers */
+#define APW8889_REG_CHIP_ID             (0x1D)
+#define APW8889_REG_VERSION             (0x1E)
+
+/* register field: ONOFF */
+#define APW8889_DC1_ON_MASK             (0x80)
+#define APW8889_DC1_ON_SHIFT            (7)
+#define APW8889_DC1_ON_WIDTH            (1)
+#define APW8889_DC2_ON_MASK             (0x40)
+#define APW8889_DC2_ON_SHIFT            (6)
+#define APW8889_DC2_ON_WIDTH            (1)
+#define APW8889_DC3_ON_MASK             (0x20)
+#define APW8889_DC3_ON_SHIFT            (5)
+#define APW8889_DC3_ON_WIDTH            (1)
+#define APW8889_DC4_ON_MASK             (0x10)
+#define APW8889_DC4_ON_SHIFT            (4)
+#define APW8889_DC4_ON_WIDTH            (1)
+#define APW8889_DC5_ON_MASK             (0x08)
+#define APW8889_DC5_ON_SHIFT            (3)
+#define APW8889_DC5_ON_WIDTH            (1)
+#define APW8889_DC6_ON_MASK             (0x04)
+#define APW8889_DC6_ON_SHIFT            (2)
+#define APW8889_DC6_ON_WIDTH            (1)
+#define APW8889_LDO1_ON_MASK            (0x01)
+#define APW8889_LDO1_ON_SHIFT           (0)
+#define APW8889_LDO1_ON_WIDTH           (1)
+
+/* register field: DISCHG */
+#define APW8889_DC1_DISCHG_MASK         (0x80)
+#define APW8889_DC1_DISCHG_SHIFT        (7)
+#define APW8889_DC1_DISCHG_WIDTH        (1)
+#define APW8889_DC2_DISCHG_MASK         (0x40)
+#define APW8889_DC2_DISCHG_SHIFT        (6)
+#define APW8889_DC2_DISCHG_WIDTH        (1)
+#define APW8889_DC3_DISCHG_MASK         (0x20)
+#define APW8889_DC3_DISCHG_SHIFT        (5)
+#define APW8889_DC3_DISCHG_WIDTH        (1)
+#define APW8889_DC4_DISCHG_MASK         (0x10)
+#define APW8889_DC4_DISCHG_SHIFT        (4)
+#define APW8889_DC4_DISCHG_WIDTH        (1)
+#define APW8889_DC5_DISCHG_MASK         (0x08)
+#define APW8889_DC5_DISCHG_SHIFT        (3)
+#define APW8889_DC5_DISCHG_WIDTH        (1)
+#define APW8889_DC6_DISCHG_MASK         (0x04)
+#define APW8889_DC6_DISCHG_SHIFT        (2)
+#define APW8889_DC6_DISCHG_WIDTH        (1)
+#define APW8889_LDO1_DISCHG_MASK        (0x01)
+#define APW8889_LDO1_DISCHG_SHIFT       (0)
+#define APW8889_LDO1_DISCHG_WIDTH       (1)
+
+/* register field: MODE */
+#define APW8889_DC1_NRMMODE_MASK        (0xC0)
+#define APW8889_DC1_NRMMODE_SHIFT       (6)
+#define APW8889_DC1_NRMMODE_WIDTH       (2)
+#define APW8889_DC1_SLPMODE_MASK        (0x30)
+#define APW8889_DC1_SLPMODE_SHIFT       (4)
+#define APW8889_DC1_SLPMODE_WIDTH       (2)
+#define APW8889_DC2_NRMMODE_MASK        (0x0C)
+#define APW8889_DC2_NRMMODE_SHIFT       (2)
+#define APW8889_DC2_NRMMODE_WIDTH       (2)
+#define APW8889_DC2_SLPMODE_MASK        (0x03)
+#define APW8889_DC2_SLPMODE_SHIFT       (0)
+#define APW8889_DC2_SLPMODE_WIDTH       (2)
+#define APW8889_DC3_NRMMODE_MASK        (0xC0)
+#define APW8889_DC3_NRMMODE_SHIFT       (6)
+#define APW8889_DC3_NRMMODE_WIDTH       (2)
+#define APW8889_DC3_SLPMODE_MASK        (0x30)
+#define APW8889_DC3_SLPMODE_SHIFT       (4)
+#define APW8889_DC3_SLPMODE_WIDTH       (2)
+#define APW8889_DC4_NRMMODE_MASK        (0x0C)
+#define APW8889_DC4_NRMMODE_SHIFT       (2)
+#define APW8889_DC4_NRMMODE_WIDTH       (2)
+#define APW8889_DC4_SLPMODE_MASK        (0x03)
+#define APW8889_DC4_SLPMODE_SHIFT       (0)
+#define APW8889_DC4_SLPMODE_WIDTH       (2)
+#define APW8889_DC5_NRMMODE_MASK        (0xC0)
+#define APW8889_DC5_NRMMODE_SHIFT       (6)
+#define APW8889_DC5_NRMMODE_WIDTH       (2)
+#define APW8889_DC5_SLPMODE_MASK        (0x30)
+#define APW8889_DC5_SLPMODE_SHIFT       (4)
+#define APW8889_DC5_SLPMODE_WIDTH       (2)
+#define APW8889_DC6_NRMMODE_MASK        (0x0C)
+#define APW8889_DC6_NRMMODE_SHIFT       (2)
+#define APW8889_DC6_NRMMODE_WIDTH       (2)
+#define APW8889_DC6_SLPMODE_MASK        (0x03)
+#define APW8889_DC6_SLPMODE_SHIFT       (0)
+#define APW8889_DC6_SLPMODE_WIDTH       (2)
+#define APW8889_LDO1_NRMMODE_MASK       (0xC0)
+#define APW8889_LDO1_NRMMODE_SHIFT      (6)
+#define APW8889_LDO1_NRMMODE_WIDTH      (2)
+#define APW8889_LDO1_SLPMODE_MASK       (0x30)
+#define APW8889_LDO1_SLPMODE_SHIFT      (4)
+#define APW8889_LDO1_SLPMODE_WIDTH      (2)
+
+/* register field: NRMVOLT / SLPVOLT */
+#define APW8889_DC1_NRMVOLT_MASK        (0x3F)
+#define APW8889_DC1_NRMVOLT_SHIFT       (0)
+#define APW8889_DC1_NRMVOLT_WIDTH       (6)
+#define APW8889_DC1_SLPVOLT_MASK        (0x3F)
+#define APW8889_DC1_SLPVOLT_SHIFT       (0)
+#define APW8889_DC1_SLPVOLT_WIDTH       (6)
+#define APW8889_DC2_NRMVOLT_MASK        (0x3F)
+#define APW8889_DC2_NRMVOLT_SHIFT       (0)
+#define APW8889_DC2_NRMVOLT_WIDTH       (6)
+#define APW8889_DC2_SLPVOLT_MASK        (0x3F)
+#define APW8889_DC2_SLPVOLT_SHIFT       (0)
+#define APW8889_DC2_SLPVOLT_WIDTH       (6)
+#define APW8889_DC3_NRMVOLT_MASK        (0x3F)
+#define APW8889_DC3_NRMVOLT_SHIFT       (0)
+#define APW8889_DC3_NRMVOLT_WIDTH       (6)
+#define APW8889_DC3_SLPVOLT_MASK        (0x3F)
+#define APW8889_DC3_SLPVOLT_SHIFT       (0)
+#define APW8889_DC3_SLPVOLT_WIDTH       (6)
+#define APW8889_DC4_NRMVOLT_MASK        (0x3F)
+#define APW8889_DC4_NRMVOLT_SHIFT       (0)
+#define APW8889_DC4_NRMVOLT_WIDTH       (6)
+#define APW8889_DC4_SLPVOLT_MASK        (0x3F)
+#define APW8889_DC4_SLPVOLT_SHIFT       (0)
+#define APW8889_DC4_SLPVOLT_WIDTH       (6)
+#define APW8889_DC6_NRMVOLT_MASK        (0x3F)
+#define APW8889_DC6_NRMVOLT_SHIFT       (2)
+#define APW8889_DC6_NRMVOLT_WIDTH       (6)
+#define APW8889_DC6_SLPVOLT_MASK        (0x3F)
+#define APW8889_DC6_SLPVOLT_SHIFT       (0)
+#define APW8889_DC6_SLPVOLT_WIDTH       (6)
+#define APW8889_LDO1_NRMVOLT_MASK       (0x1F)
+#define APW8889_LDO1_NRMVOLT_SHIFT      (0)
+#define APW8889_LDO1_NRMVOLT_WIDTH      (5)
+#define APW8889_LDO1_SLPVOLT_MASK       (0x1F)
+#define APW8889_LDO1_SLPVOLT_SHIFT      (0)
+#define APW8889_LDO1_SLPVOLT_WIDTH      (5)
+
+/* register field: CLAMP */
+#define APW8889_DC2_CLAMP_MASK          (0x4)
+#define APW8889_DC2_CLAMP_SHIFT         (2)
+#define APW8889_DC2_CLAMP_WIDTH         (1)
+#define APW8889_DC3_CLAMP_MASK          (0x2)
+#define APW8889_DC3_CLAMP_SHIFT         (1)
+#define APW8889_DC3_CLAMP_WIDTH         (1)
+#define APW8889_DC4_CLAMP_MASK          (0x1)
+#define APW8889_DC4_CLAMP_SHIFT         (0)
+#define APW8889_DC4_CLAMP_WIDTH         (1)
+
+#endif /* __LINUX_MFD_APW8889_H */
diff --git a/include/linux/mfd/apw888x.h b/include/linux/mfd/apw888x.h
new file mode 100644
index 00000000..4f42729
--- /dev/null
+++ b/include/linux/mfd/apw888x.h
@@ -0,0 +1,41 @@
+/*
+ * Anpec APW888X series PMIC MFD
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __LINUX_MFD_APW888X_H
+#define __LINUX_MFD_APW888X_H
+
+#include <linux/regmap.h>
+
+struct apw888x_device {
+	u32 chip_id;
+	u32 chip_rev;
+	struct device *dev;
+	struct regmap *regmap;
+};
+
+int apw888x_device_init(struct apw888x_device *gdev);
+void apw888x_device_exit(struct apw888x_device *gdev);
+
+#define APW888X_DEVICE_ID_APW8889       (8889)
+#define APW888X_DEVICE_ID_APW8886       (8886)
+
+#endif /* __LINUX_MFD_APW888X_H */
diff --git a/include/linux/mfd/g2227.h b/include/linux/mfd/g2227.h
new file mode 100644
index 00000000..71d5485
--- /dev/null
+++ b/include/linux/mfd/g2227.h
@@ -0,0 +1,196 @@
+#ifndef __LINUX_MFD_G2227_H
+#define __LINUX_MFD_G2227_H
+
+#define G2227_REG_INTR                  (0x00)
+#define G2227_REG_INTR_MASK             (0x01)
+#define G2227_REG_PWRKEY                (0x02)
+#define G2227_REG_FAULT_STATUS          (0x03)
+#define G2227_REG_SYS_CONTROL           (0x04)
+#define G2227_REG_ONOFF                 (0x05)
+#define G2227_REG_DISCHG                (0x06)
+#define G2227_REG_DC1DC2_MODE           (0x07)
+#define G2227_REG_DC1_MODE              (G2227_REG_DC1DC2_MODE)
+#define G2227_REG_DC2_MODE              (G2227_REG_DC1DC2_MODE)
+#define G2227_REG_DC3DC4_MODE           (0x08)
+#define G2227_REG_DC3_MODE              (G2227_REG_DC3DC4_MODE)
+#define G2227_REG_DC4_MODE              (G2227_REG_DC3DC4_MODE)
+#define G2227_REG_DC5DC6_MODE           (0x09)
+#define G2227_REG_DC5_MODE              (G2227_REG_DC5DC6_MODE)
+#define G2227_REG_DC6_MODE              (G2227_REG_DC5DC6_MODE)
+#define G2227_REG_LDO2LDO3_MODE         (0x0A)
+#define G2227_REG_LDO2_MODE             (G2227_REG_LDO2LDO3_MODE)
+#define G2227_REG_LDO3_MODE             (G2227_REG_LDO2LDO3_MODE)
+#define G2227_REG_DC2_NRMVOLT           (0x10)
+#define G2227_REG_DC3_NRMVOLT           (0x11)
+#define G2227_REG_DC5_NRMVOLT           (0x12)
+#define G2227_REG_DC1DC6_NRMVOLT        (0x13)
+#define G2227_REG_DC1_NRMVOLT           (G2227_REG_DC1DC6_NRMVOLT)
+#define G2227_REG_DC6_NRMVOLT           (G2227_REG_DC1DC6_NRMVOLT)
+#define G2227_REG_LDO2LDO3_NRMVOLT      (0x14)
+#define G2227_REG_LDO2_NRMVOLT          (G2227_REG_LDO2LDO3_NRMVOLT)
+#define G2227_REG_LDO3_NRMVOLT          (G2227_REG_LDO2LDO3_NRMVOLT)
+#define G2227_REG_DC2_SLPVOLT           (0x15)
+#define G2227_REG_DC3_SLPVOLT           (0x16)
+#define G2227_REG_DC5_SLPVOLT           (0x17)
+#define G2227_REG_DC1DC6_SLPVOLT        (0x18)
+#define G2227_REG_DC1_SLPVOLT           (G2227_REG_DC1DC6_SLPVOLT)
+#define G2227_REG_DC6_SLPVOLT           (G2227_REG_DC1DC6_SLPVOLT)
+#define G2227_REG_LDO2LDO3_SLPVOLT      (0x19)
+#define G2227_REG_LDO3_SLPVOLT          (G2227_REG_LDO2LDO3_SLPVOLT)
+#define G2227_REG_LDO2_SLPVOLT          (G2227_REG_LDO2LDO3_SLPVOLT)
+#define G2227_REG_VERSION               (0x20)
+#define G2227_REG_GMT_TESTING           (0xF1)
+
+/* register field: REG_SYS_CONTROL */
+#define G2227_SOFTOFF_MASK              (0x80)
+#define G2227_SOFTOFF_SHIFT             (7)
+#define G2227_SOFTOFF_WIDTH             (1)
+
+/* register field: ONOFF */
+#define G2227_DC1_ON_MASK               (0x80)
+#define G2227_DC1_ON_SHIFT              (7)
+#define G2227_DC1_ON_WIDTH              (1)
+#define G2227_DC2_ON_MASK               (0x40)
+#define G2227_DC2_ON_SHIFT              (6)
+#define G2227_DC2_ON_WIDTH              (1)
+#define G2227_DC3_ON_MASK               (0x20)
+#define G2227_DC3_ON_SHIFT              (5)
+#define G2227_DC3_ON_WIDTH              (1)
+#define G2227_DC4_ON_MASK               (0x10)
+#define G2227_DC4_ON_SHIFT              (4)
+#define G2227_DC4_ON_WIDTH              (1)
+#define G2227_DC5_ON_MASK               (0x08)
+#define G2227_DC5_ON_SHIFT              (3)
+#define G2227_DC5_ON_WIDTH              (1)
+#define G2227_DC6_ON_MASK               (0x04)
+#define G2227_DC6_ON_SHIFT              (2)
+#define G2227_DC6_ON_WIDTH              (1)
+#define G2227_LDO2_ON_MASK              (0x02)
+#define G2227_LDO2_ON_SHIFT             (1)
+#define G2227_LDO2_ON_WIDTH             (1)
+#define G2227_LDO3_ON_MASK              (0x01)
+#define G2227_LDO3_ON_SHIFT             (0)
+#define G2227_LDO3_ON_WIDTH             (1)
+
+/* register field: DISCHG */
+#define G2227_DC1_DISCHG_MASK           (0x80)
+#define G2227_DC1_DISCHG_SHIFT          (7)
+#define G2227_DC1_DISCHG_WIDTH          (1)
+#define G2227_DC2_DISCHG_MASK           (0x40)
+#define G2227_DC2_DISCHG_SHIFT          (6)
+#define G2227_DC2_DISCHG_WIDTH          (1)
+#define G2227_DC3_DISCHG_MASK           (0x20)
+#define G2227_DC3_DISCHG_SHIFT          (5)
+#define G2227_DC3_DISCHG_WIDTH          (1)
+#define G2227_DC4_DISCHG_MASK           (0x10)
+#define G2227_DC4_DISCHG_SHIFT          (4)
+#define G2227_DC4_DISCHG_WIDTH          (1)
+#define G2227_DC5_DISCHG_MASK           (0x08)
+#define G2227_DC5_DISCHG_SHIFT          (3)
+#define G2227_DC5_DISCHG_WIDTH          (1)
+#define G2227_DC6_DISCHG_MASK           (0x04)
+#define G2227_DC6_DISCHG_SHIFT          (2)
+#define G2227_DC6_DISCHG_WIDTH          (1)
+#define G2227_LDO2_DISCHG_MASK          (0x02)
+#define G2227_LDO2_DISCHG_SHIFT         (1)
+#define G2227_LDO2_DISCHG_WIDTH         (1)
+#define G2227_LDO3_DISCHG_MASK          (0x01)
+#define G2227_LDO3_DISCHG_SHIFT         (0)
+#define G2227_LDO3_DISCHG_WIDTH         (1)
+
+/* register field: MODE */
+#define G2227_DC1_NRMMODE_MASK          (0xC0)
+#define G2227_DC1_NRMMODE_SHIFT         (6)
+#define G2227_DC1_NRMMODE_WIDTH         (2)
+#define G2227_DC1_SLPMODE_MASK          (0x30)
+#define G2227_DC1_SLPMODE_SHIFT         (4)
+#define G2227_DC1_SLPMODE_WIDTH         (2)
+#define G2227_DC2_NRMMODE_MASK          (0x0C)
+#define G2227_DC2_NRMMODE_SHIFT         (2)
+#define G2227_DC2_NRMMODE_WIDTH         (2)
+#define G2227_DC2_SLPMODE_MASK          (0x03)
+#define G2227_DC2_SLPMODE_SHIFT         (0)
+#define G2227_DC2_SLPMODE_WIDTH         (2)
+#define G2227_DC3_NRMMODE_MASK          (0xC0)
+#define G2227_DC3_NRMMODE_SHIFT         (6)
+#define G2227_DC3_NRMMODE_WIDTH         (2)
+#define G2227_DC3_SLPMODE_MASK          (0x30)
+#define G2227_DC3_SLPMODE_SHIFT         (4)
+#define G2227_DC3_SLPMODE_WIDTH         (2)
+#define G2227_DC4_NRMMODE_MASK          (0x0C)
+#define G2227_DC4_NRMMODE_SHIFT         (2)
+#define G2227_DC4_NRMMODE_WIDTH         (2)
+#define G2227_DC4_SLPMODE_MASK          (0x03)
+#define G2227_DC4_SLPMODE_SHIFT         (0)
+#define G2227_DC4_SLPMODE_WIDTH         (2)
+#define G2227_DC5_NRMMODE_MASK          (0xC0)
+#define G2227_DC5_NRMMODE_SHIFT         (6)
+#define G2227_DC5_NRMMODE_WIDTH         (2)
+#define G2227_DC5_SLPMODE_MASK          (0x30)
+#define G2227_DC5_SLPMODE_SHIFT         (4)
+#define G2227_DC5_SLPMODE_WIDTH         (2)
+#define G2227_DC6_NRMMODE_MASK          (0x0C)
+#define G2227_DC6_NRMMODE_SHIFT         (2)
+#define G2227_DC6_NRMMODE_WIDTH         (2)
+#define G2227_DC6_SLPMODE_MASK          (0x03)
+#define G2227_DC6_SLPMODE_SHIFT         (0)
+#define G2227_DC6_SLPMODE_WIDTH         (2)
+#define G2227_LDO2_NRMMODE_MASK         (0xC0)
+#define G2227_LDO2_NRMMODE_SHIFT        (6)
+#define G2227_LDO2_NRMMODE_WIDTH        (2)
+#define G2227_LDO2_SLPMODE_MASK         (0x30)
+#define G2227_LDO2_SLPMODE_SHIFT        (4)
+#define G2227_LDO2_SLPMODE_WIDTH        (2)
+#define G2227_LDO3_NRMMODE_MASK         (0x0C)
+#define G2227_LDO3_NRMMODE_SHIFT        (2)
+#define G2227_LDO3_NRMMODE_WIDTH        (2)
+#define G2227_LDO3_SLPMODE_MASK         (0x03)
+#define G2227_LDO3_SLPMODE_SHIFT        (0)
+#define G2227_LDO3_SLPMODE_WIDTH        (2)
+
+/* register field: NRMVOLT / SLPVOLT */
+#define G2227_DC1_NRMVOLT_MASK          (0xC0)
+#define G2227_DC1_NRMVOLT_SHIFT         (6)
+#define G2227_DC1_NRMVOLT_WIDTH         (2)
+#define G2227_DC1_SLPVOLT_MASK          (0xC0)
+#define G2227_DC1_SLPVOLT_SHIFT         (6)
+#define G2227_DC1_SLPVOLT_WIDTH         (2)
+#define G2227_DC2_NRMVOLT_MASK          (0x1F)
+#define G2227_DC2_NRMVOLT_SHIFT         (0)
+#define G2227_DC2_NRMVOLT_WIDTH         (5)
+#define G2227_DC2_SLPVOLT_MASK          (0x1F)
+#define G2227_DC2_SLPVOLT_SHIFT         (0)
+#define G2227_DC2_SLPVOLT_WIDTH         (5)
+#define G2227_DC3_NRMVOLT_MASK          (0x1F)
+#define G2227_DC3_NRMVOLT_SHIFT         (0)
+#define G2227_DC3_NRMVOLT_WIDTH         (5)
+#define G2227_DC3_SLPVOLT_MASK          (0x1F)
+#define G2227_DC3_SLPVOLT_SHIFT         (0)
+#define G2227_DC3_SLPVOLT_WIDTH         (5)
+#define G2227_DC5_NRMVOLT_MASK          (0x1F)
+#define G2227_DC5_NRMVOLT_SHIFT         (0)
+#define G2227_DC5_NRMVOLT_WIDTH         (5)
+#define G2227_DC5_SLPVOLT_MASK          (0x1F)
+#define G2227_DC5_SLPVOLT_SHIFT         (0)
+#define G2227_DC5_SLPVOLT_WIDTH         (5)
+#define G2227_DC6_NRMVOLT_MASK          (0x1F)
+#define G2227_DC6_NRMVOLT_SHIFT         (0)
+#define G2227_DC6_NRMVOLT_WIDTH         (0)
+#define G2227_DC6_SLPVOLT_MASK          (0x1F)
+#define G2227_DC6_SLPVOLT_SHIFT         (0)
+#define G2227_DC6_SLPVOLT_WIDTH         (5)
+#define G2227_LDO2_NRMVOLT_MASK         (0xF0)
+#define G2227_LDO2_NRMVOLT_SHIFT        (4)
+#define G2227_LDO2_NRMVOLT_WIDTH        (4)
+#define G2227_LDO2_SLPVOLT_MASK         (0xF0)
+#define G2227_LDO2_SLPVOLT_SHIFT        (4)
+#define G2227_LDO2_SLPVOLT_WIDTH        (4)
+#define G2227_LDO3_NRMVOLT_MASK         (0x0F)
+#define G2227_LDO3_NRMVOLT_SHIFT        (0)
+#define G2227_LDO3_NRMVOLT_WIDTH        (4)
+#define G2227_LDO3_SLPVOLT_MASK         (0x0F)
+#define G2227_LDO3_SLPVOLT_SHIFT        (0)
+#define G2227_LDO3_SLPVOLT_WIDTH        (4)
+
+
+#endif /* __LINUX_MFD_G2227_H */
diff --git a/include/linux/mfd/g2237.h b/include/linux/mfd/g2237.h
new file mode 100644
index 00000000..751cf16
--- /dev/null
+++ b/include/linux/mfd/g2237.h
@@ -0,0 +1,150 @@
+#ifndef __LINUX_MFD_G2237_H
+#define __LINUX_MFD_G2237_H
+
+#define G2237_REG_INTR                  (0x00)
+#define G2237_REG_INTR_MASK             (0x01)
+#define G2237_REG_PWRKEY                (0x02)
+#define G2237_REG_FAULT_STATUS          (0x03)
+#define G2237_REG_SYS_CONTROL           (0x04)
+#define G2237_REG_ONOFF                 (0x05)
+#define G2237_REG_DISCHG                (0x06)
+#define G2237_REG_DC1DC2_MODE           (0x07)
+#define G2237_REG_DC1_MODE              (G2237_REG_DC1DC2_MODE)
+#define G2237_REG_DC2_MODE              (G2237_REG_DC1DC2_MODE)
+#define G2237_REG_DC3DC4_MODE           (0x08)
+#define G2237_REG_DC3_MODE              (G2237_REG_DC3DC4_MODE)
+#define G2237_REG_DC4_MODE              (G2237_REG_DC3DC4_MODE)
+#define G2237_REG_DC5LDO1_MODE          (0x09)
+#define G2237_REG_DC5_MODE              (G2237_REG_DC5LDO1_MODE)
+#define G2237_REG_LDO1_MODE             (G2237_REG_DC5LDO1_MODE)
+#define G2237_REG_DC1_NRMVOLT           (0x0A)
+#define G2237_REG_DC2_NRMVOLT           (0x0B)
+#define G2237_REG_DC3_NRMVOLT           (0x0C)
+#define G2237_REG_DC5_NRMVOLT           (0x0D)
+#define G2237_REG_LDO1_NRMVOLT          (0x0E)
+#define G2237_REG_DC1_SLPVOLT           (0x0F)
+#define G2237_REG_DC2_SLPVOLT           (0x10)
+#define G2237_REG_DC3_SLPVOLT           (0x11)
+#define G2237_REG_DC5_SLPVOLT           (0x12)
+#define G2237_REG_LDO1_SLPVOLT          (0x13)
+#define G2237_REG_CHIP_ID               (0x14)
+#define G2237_REG_VERSION               (0x15)
+#define G2237_REG_GMT_TESTING           (0xF1)
+
+/* register field: REG_SYS_CONTROL */
+#define G2237_SOFTOFF_MASK              (0x80)
+#define G2237_SOFTOFF_SHIFT             (7)
+#define G2237_SOFTOFF_WIDTH             (1)
+
+/* register field: ONOFF */
+#define G2237_DC1_ON_MASK               (0x80)
+#define G2237_DC1_ON_SHIFT              (7)
+#define G2237_DC1_ON_WIDTH              (1)
+#define G2237_DC2_ON_MASK               (0x40)
+#define G2237_DC2_ON_SHIFT              (6)
+#define G2237_DC2_ON_WIDTH              (1)
+#define G2237_DC3_ON_MASK               (0x20)
+#define G2237_DC3_ON_SHIFT              (5)
+#define G2237_DC3_ON_WIDTH              (1)
+#define G2237_DC4_ON_MASK               (0x10)
+#define G2237_DC4_ON_SHIFT              (4)
+#define G2237_DC4_ON_WIDTH              (1)
+#define G2237_DC5_ON_MASK               (0x08)
+#define G2237_DC5_ON_SHIFT              (3)
+#define G2237_DC5_ON_WIDTH              (1)
+#define G2237_LDO1_ON_MASK              (0x01)
+#define G2237_LDO1_ON_SHIFT             (0)
+#define G2237_LDO1_ON_WIDTH             (1)
+
+/* register field: DISCHG */
+#define G2237_DC1_DISCHG_MASK           (0x80)
+#define G2237_DC1_DISCHG_SHIFT          (7)
+#define G2237_DC1_DISCHG_WIDTH          (1)
+#define G2237_DC2_DISCHG_MASK           (0x40)
+#define G2237_DC2_DISCHG_SHIFT          (6)
+#define G2237_DC2_DISCHG_WIDTH          (1)
+#define G2237_DC3_DISCHG_MASK           (0x20)
+#define G2237_DC3_DISCHG_SHIFT          (5)
+#define G2237_DC3_DISCHG_WIDTH          (1)
+#define G2237_DC4_DISCHG_MASK           (0x10)
+#define G2237_DC4_DISCHG_SHIFT          (4)
+#define G2237_DC4_DISCHG_WIDTH          (1)
+#define G2237_DC5_DISCHG_MASK           (0x08)
+#define G2237_DC5_DISCHG_SHIFT          (3)
+#define G2237_DC5_DISCHG_WIDTH          (1)
+#define G2237_LDO1_DISCHG_MASK          (0x01)
+#define G2237_LDO1_DISCHG_SHIFT         (0)
+#define G2237_LDO1_DISCHG_WIDTH         (1)
+
+/* register field: MODE */
+#define G2237_DC1_NRMMODE_MASK          (0xC0)
+#define G2237_DC1_NRMMODE_SHIFT         (6)
+#define G2237_DC1_NRMMODE_WIDTH         (2)
+#define G2237_DC1_SLPMODE_MASK          (0x30)
+#define G2237_DC1_SLPMODE_SHIFT         (4)
+#define G2237_DC1_SLPMODE_WIDTH         (2)
+#define G2237_DC2_NRMMODE_MASK          (0x0C)
+#define G2237_DC2_NRMMODE_SHIFT         (2)
+#define G2237_DC2_NRMMODE_WIDTH         (2)
+#define G2237_DC2_SLPMODE_MASK          (0x03)
+#define G2237_DC2_SLPMODE_SHIFT         (0)
+#define G2237_DC2_SLPMODE_WIDTH         (2)
+#define G2237_DC3_NRMMODE_MASK          (0xC0)
+#define G2237_DC3_NRMMODE_SHIFT         (6)
+#define G2237_DC3_NRMMODE_WIDTH         (2)
+#define G2237_DC3_SLPMODE_MASK          (0x30)
+#define G2237_DC3_SLPMODE_SHIFT         (4)
+#define G2237_DC3_SLPMODE_WIDTH         (2)
+#define G2237_DC4_NRMMODE_MASK          (0x0C)
+#define G2237_DC4_NRMMODE_SHIFT         (2)
+#define G2237_DC4_NRMMODE_WIDTH         (2)
+#define G2237_DC4_SLPMODE_MASK          (0x03)
+#define G2237_DC4_SLPMODE_SHIFT         (0)
+#define G2237_DC4_SLPMODE_WIDTH         (2)
+#define G2237_DC5_NRMMODE_MASK          (0xC0)
+#define G2237_DC5_NRMMODE_SHIFT         (6)
+#define G2237_DC5_NRMMODE_WIDTH         (2)
+#define G2237_DC5_SLPMODE_MASK          (0x30)
+#define G2237_DC5_SLPMODE_SHIFT         (4)
+#define G2237_DC5_SLPMODE_WIDTH         (2)
+#define G2237_LDO1_NRMMODE_MASK         (0x0C)
+#define G2237_LDO1_NRMMODE_SHIFT        (2)
+#define G2237_LDO1_NRMMODE_WIDTH        (2)
+#define G2237_LDO1_SLPMODE_MASK         (0x03)
+#define G2237_LDO1_SLPMODE_SHIFT        (0)
+#define G2237_LDO1_SLPMODE_WIDTH        (2)
+
+/* register field: NRMVOLT / SLPVOLT */
+#define G2237_DC1_NRMVOLT_MASK          (0x0F)
+#define G2237_DC1_NRMVOLT_SHIFT         (0)
+#define G2237_DC1_NRMVOLT_WIDTH         (4)
+#define G2237_DC1_SLPVOLT_MASK          (0x0F)
+#define G2237_DC1_SLPVOLT_SHIFT         (0)
+#define G2237_DC1_SLPVOLT_WIDTH         (4)
+#define G2237_DC2_NRMVOLT_MASK          (0x1F)
+#define G2237_DC2_NRMVOLT_SHIFT         (0)
+#define G2237_DC2_NRMVOLT_WIDTH         (5)
+#define G2237_DC2_SLPVOLT_MASK          (0x1F)
+#define G2237_DC2_SLPVOLT_SHIFT         (0)
+#define G2237_DC2_SLPVOLT_WIDTH         (5)
+#define G2237_DC3_NRMVOLT_MASK          (0x1F)
+#define G2237_DC3_NRMVOLT_SHIFT         (0)
+#define G2237_DC3_NRMVOLT_WIDTH         (5)
+#define G2237_DC3_SLPVOLT_MASK          (0x1F)
+#define G2237_DC3_SLPVOLT_SHIFT         (0)
+#define G2237_DC3_SLPVOLT_WIDTH         (5)
+#define G2237_DC5_NRMVOLT_MASK          (0x0F)
+#define G2237_DC5_NRMVOLT_SHIFT         (0)
+#define G2237_DC5_NRMVOLT_WIDTH         (4)
+#define G2237_DC5_SLPVOLT_MASK          (0x0F)
+#define G2237_DC5_SLPVOLT_SHIFT         (0)
+#define G2237_DC5_SLPVOLT_WIDTH         (4)
+#define G2237_LDO1_NRMVOLT_MASK         (0x0F)
+#define G2237_LDO1_NRMVOLT_SHIFT        (0)
+#define G2237_LDO1_NRMVOLT_WIDTH        (4)
+#define G2237_LDO1_SLPVOLT_MASK         (0x0F)
+#define G2237_LDO1_SLPVOLT_SHIFT        (0)
+#define G2237_LDO1_SLPVOLT_WIDTH        (4)
+
+
+#endif /* __LINUX_MFD_G2237_H */
diff --git a/include/linux/mfd/g22xx.h b/include/linux/mfd/g22xx.h
new file mode 100644
index 00000000..26fbbce
--- /dev/null
+++ b/include/linux/mfd/g22xx.h
@@ -0,0 +1,41 @@
+/*
+ * GMT-G22XX series PMIC MFD
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __LINUX_MFD_G22XX_H
+#define __LINUX_MFD_G22XX_H
+
+#include <linux/regmap.h>
+
+struct g22xx_device {
+	u32 chip_id;
+	u32 chip_rev;
+	struct device *dev;
+	struct regmap *regmap;
+};
+
+int g22xx_device_init(struct g22xx_device *gdev);
+void g22xx_device_exit(struct g22xx_device *gdev);
+
+#define G22XX_DEVICE_ID_G2227           (2227)
+#define G22XX_DEVICE_ID_G2237           (2237)
+
+#endif
diff --git a/include/linux/mm.h b/include/linux/mm.h
index 493d079..88b0c68 100644
--- a/include/linux/mm.h
+++ b/include/linux/mm.h
@@ -1143,6 +1143,7 @@ static inline void clear_page_pfmemalloc(struct page *page)
 extern void show_free_areas(unsigned int flags);
 extern bool skip_free_areas_node(unsigned int flags, int nid);
 
+void shmem_set_file(struct vm_area_struct *vma, struct file *file);
 int shmem_zero_setup(struct vm_area_struct *);
 #ifdef CONFIG_SHMEM
 bool shmem_mapping(struct address_space *mapping);
@@ -1966,7 +1967,7 @@ static inline int vma_adjust(struct vm_area_struct *vma, unsigned long start,
 extern struct vm_area_struct *vma_merge(struct mm_struct *,
 	struct vm_area_struct *prev, unsigned long addr, unsigned long end,
 	unsigned long vm_flags, struct anon_vma *, struct file *, pgoff_t,
-	struct mempolicy *, struct vm_userfaultfd_ctx);
+	struct mempolicy *, struct vm_userfaultfd_ctx, const char __user *);
 extern struct anon_vma *find_mergeable_anon_vma(struct vm_area_struct *);
 extern int split_vma(struct mm_struct *,
 	struct vm_area_struct *, unsigned long addr, int new_below);
diff --git a/include/linux/mm_types.h b/include/linux/mm_types.h
index e8471c2..de06ab8 100644
--- a/include/linux/mm_types.h
+++ b/include/linux/mm_types.h
@@ -326,11 +326,18 @@ struct vm_area_struct {
 	/*
 	 * For areas with an address space and backing store,
 	 * linkage into the address_space->i_mmap interval tree.
+	 *
+	 * For private anonymous mappings, a pointer to a null terminated string
+	 * in the user process containing the name given to the vma, or NULL
+	 * if unnamed.
 	 */
-	struct {
-		struct rb_node rb;
-		unsigned long rb_subtree_last;
-	} shared;
+	union {
+		struct {
+			struct rb_node rb;
+			unsigned long rb_subtree_last;
+		} shared;
+		const char __user *anon_name;
+	};
 
 	/*
 	 * A file's MAP_PRIVATE vma can be in both i_mmap tree and anon_vma
@@ -344,6 +351,9 @@ struct vm_area_struct {
 
 	/* Function pointers to deal with this struct. */
 	const struct vm_operations_struct *vm_ops;
+#ifdef CONFIG_RTK_PLATFORM
+	const struct vm_operations_struct *vm_rtk_ops;
+#endif /* CONFIG_RTK_PLATFORM */
 
 	/* Information about our backing store: */
 	unsigned long vm_pgoff;		/* Offset (within vm_file) in PAGE_SIZE
@@ -351,6 +361,10 @@ struct vm_area_struct {
 	struct file * vm_file;		/* File we map to (can be NULL). */
 	void * vm_private_data;		/* was vm_pte (shared mem) */
 
+#ifdef CONFIG_RTK_PLATFORM
+	void * vm_rtk_private_data;		/* was vm_pte (shared mem) */
+#endif /* CONFIG_RTK_PLATFORM */
+
 #ifndef CONFIG_MMU
 	struct vm_region *vm_region;	/* NOMMU mapping region */
 #endif
@@ -620,4 +634,13 @@ enum tlb_flush_reason {
 	unsigned long val;
 } swp_entry_t;
 
+/* Return the name for an anonymous mapping or NULL for a file-backed mapping */
+static inline const char __user *vma_get_anon_name(struct vm_area_struct *vma)
+{
+	if (vma->vm_file)
+		return NULL;
+
+	return vma->anon_name;
+}
+
 #endif /* _LINUX_MM_TYPES_H */
diff --git a/include/linux/mmc/card.h b/include/linux/mmc/card.h
index 73fad83..9c74a1f 100644
--- a/include/linux/mmc/card.h
+++ b/include/linux/mmc/card.h
@@ -14,6 +14,9 @@
 #include <linux/mmc/core.h>
 #include <linux/mod_devicetable.h>
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#define MMC_CARD_CMDQ_BLK_SIZE 512
+#endif
 struct mmc_cid {
 	unsigned int		manfid;
 	char			prod_name[8];
@@ -89,6 +92,14 @@ struct mmc_ext_csd {
 	unsigned int		boot_ro_lock;		/* ro lock support */
 	bool			boot_ro_lockable;
 	bool			ffu_capable;	/* Firmware upgrade support */
+
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)	
+	bool                    cmdq_en;        /* Command Queue enabled */
+	bool                    cmdq_support;   /* Command Queue supported */
+	unsigned int            cmdq_depth;     /* Command Queue depth */
+#endif
+
 #define MMC_FIRMWARE_LEN 8
 	u8			fwrev[MMC_FIRMWARE_LEN];  /* FW version */
 	u8			raw_exception_status;	/* 54 */
@@ -119,6 +130,9 @@ struct mmc_ext_csd {
 	u8			raw_pwr_cl_ddr_200_360;	/* 253 */
 	u8			raw_bkops_status;	/* 246 */
 	u8			raw_sectors[4];		/* 212 - 4 bytes */
+	u8			pre_eol_info;		/* 267 */
+	u8			device_life_time_est_typ_a;	/* 268 */
+	u8			device_life_time_est_typ_b;	/* 269 */
 
 	unsigned int            feature_support;
 #define MMC_DISCARD_FEATURE	BIT(0)                  /* CMD38 feature */
@@ -205,6 +219,11 @@ struct sdio_cis {
 struct sdio_func;
 struct sdio_func_tuple;
 
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+struct mmc_queue_req;
+#endif
+
 #define SDIO_MAX_FUNCS		7
 
 enum mmc_blk_status {
@@ -264,6 +283,9 @@ struct mmc_card {
 #define MMC_CARD_REMOVED	(1<<4)		/* card has been removed */
 #define MMC_STATE_DOING_BKOPS	(1<<5)		/* card is doing BKOPS */
 #define MMC_STATE_SUSPENDED	(1<<6)		/* card is suspended */
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#define MMC_STATE_CMDQ		(1<<12)         /* card is in cmd queue mode */
+#endif
 	unsigned int		quirks; 	/* card quirks */
 #define MMC_QUIRK_LENIENT_FN0	(1<<0)		/* allow SDIO FN0 writes outside of the VS CCCR range */
 #define MMC_QUIRK_BLKSZ_FOR_BYTE_MODE (1<<1)	/* use func->cur_blksize */
@@ -282,6 +304,10 @@ struct mmc_card {
 #define MMC_QUIRK_TRIM_BROKEN	(1<<12)		/* Skip trim */
 #define MMC_QUIRK_BROKEN_HPI	(1<<13)		/* Disable broken HPI support */
 
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	bool                    reenable_cmdq;  /* Re-enable Command Queue */
+#endif
 
 	unsigned int		erase_size;	/* erase size in sectors */
  	unsigned int		erase_shift;	/* if erase unit is power 2 */
@@ -316,6 +342,11 @@ struct mmc_card {
 	struct dentry		*debugfs_root;
 	struct mmc_part	part[MMC_NUM_PHY_PARTITION]; /* physical partitions */
 	unsigned int    nr_parts;
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	bool cmdq_init;
+	unsigned int            bouncesz;       /* Bounce buffer size */
+#endif
 };
 
 /*
@@ -454,6 +485,10 @@ static inline void __maybe_unused remove_quirk(struct mmc_card *card, int data)
 #define mmc_card_doing_bkops(c)	((c)->state & MMC_STATE_DOING_BKOPS)
 #define mmc_card_suspended(c)	((c)->state & MMC_STATE_SUSPENDED)
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#define mmc_card_cmdq(c)       ((c)->state & MMC_STATE_CMDQ)
+#endif
+
 #define mmc_card_set_present(c)	((c)->state |= MMC_STATE_PRESENT)
 #define mmc_card_set_readonly(c) ((c)->state |= MMC_STATE_READONLY)
 #define mmc_card_set_blockaddr(c) ((c)->state |= MMC_STATE_BLOCKADDR)
@@ -464,6 +499,10 @@ static inline void __maybe_unused remove_quirk(struct mmc_card *card, int data)
 #define mmc_card_set_suspended(c) ((c)->state |= MMC_STATE_SUSPENDED)
 #define mmc_card_clr_suspended(c) ((c)->state &= ~MMC_STATE_SUSPENDED)
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#define mmc_card_set_cmdq(c)           ((c)->state |= MMC_STATE_CMDQ)
+#define mmc_card_clr_cmdq(c)           ((c)->state &= ~MMC_STATE_CMDQ)
+#endif
 /*
  * Quirk add/remove for MMC products.
  */
@@ -559,4 +598,7 @@ struct mmc_driver {
 extern void mmc_fixup_device(struct mmc_card *card,
 			     const struct mmc_fixup *table);
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+extern void mmc_blk_cmdq_req_done(struct mmc_request *mrq);
+#endif
 #endif /* LINUX_MMC_CARD_H */
diff --git a/include/linux/mmc/core.h b/include/linux/mmc/core.h
index 2b953eb..37b79a4 100644
--- a/include/linux/mmc/core.h
+++ b/include/linux/mmc/core.h
@@ -111,12 +111,26 @@ struct mmc_data {
 	unsigned int		timeout_clks;	/* data timeout (in clocks) */
 	unsigned int		blksz;		/* data block size */
 	unsigned int		blocks;		/* number of blocks */
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	unsigned int            blk_addr;       /* block address */
+#endif
 	int			error;		/* data error */
 	unsigned int		flags;
 
 #define MMC_DATA_WRITE	(1 << 8)
 #define MMC_DATA_READ	(1 << 9)
 
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+/* Extra flags used by CQE */
+#define MMC_DATA_QBR           (1 << 10)         /* CQE queue barrier*/
+#define MMC_DATA_PRIO          (1 << 11)         /* CQE high priority */
+#define MMC_DATA_REL_WR        (1 << 12)         /* Reliable write */
+#define MMC_DATA_DAT_TAG       (1 << 13)         /* Tag request */
+#define MMC_DATA_FORCED_PRG    (1 << 14)         /* Forced programming */
+#endif
+
 	unsigned int		bytes_xfered;
 
 	struct mmc_command	*stop;		/* stop command */
@@ -138,15 +152,59 @@ struct mmc_request {
 	struct completion	completion;
 	struct completion	cmd_completion;
 	void			(*done)(struct mmc_request *);/* completion function */
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+       /*
+        * Notify uppers layers (e.g. mmc block driver) that recovery is needed
+        * due to an error associated with the mmc_request. Currently used only
+        * by CQE.
+        */
+       void                    (*recovery_notifier)(struct mmc_request *);
+#endif
 	struct mmc_host		*host;
-
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	struct mmc_cmdq_req	*cmdq_req;
+	struct request		*req;		/* associated block request */
+#endif
 	/* Allow other commands during this ongoing data transfer or busy wait */
 	bool			cap_cmd_during_tfr;
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	int                     tag;
+#endif
+	ktime_t			io_start;
+#ifdef CONFIG_BLOCK
+	int			lat_hist_enabled;
+#endif
+
+#ifdef CONFIG_ARCH_RTD119X
+#define MMC_ERR_NONE        0
+#define MMC_ERR_TIMEOUT     1
+#define MMC_ERR_BADCRC      2
+#define MMC_ERR_RMOVE       3
+#define MMC_ERR_FAILED      4
+#define MMC_ERR_INVALID     5
+#endif
 };
 
 struct mmc_card;
 struct mmc_async_req;
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+struct mmc_cmdq_req;
+
+extern int mmc_cmdq_halt(struct mmc_host *host, bool enable);
+extern void mmc_cmdq_post_req(struct mmc_host *host, int tag,
+			      int err);
+extern int mmc_cmdq_start_req(struct mmc_host *host,
+			      struct mmc_cmdq_req *cmdq_req);
+extern int mmc_cmdq_prepare_flush(struct mmc_command *cmd);
+extern int mmc_cmdq_wait_for_dcmd(struct mmc_host *host,
+			struct mmc_cmdq_req *cmdq_req);
+extern int mmc_cmdq_erase(struct mmc_cmdq_req *cmdq_req,
+	      struct mmc_card *card, unsigned int from, unsigned int nr,
+	      unsigned int arg);
+#endif
 extern int mmc_stop_bkops(struct mmc_card *);
 extern int mmc_read_bkops_status(struct mmc_card *);
 extern struct mmc_async_req *mmc_start_req(struct mmc_host *,
@@ -162,7 +220,16 @@ extern int mmc_wait_for_app_cmd(struct mmc_host *, struct mmc_card *,
 	struct mmc_command *, int);
 extern void mmc_start_bkops(struct mmc_card *card, bool from_exception);
 extern int mmc_switch(struct mmc_card *, u8, u8, u8, unsigned int);
+
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+extern int __mmc_switch_cmdq_mode(struct mmc_command *cmd, u8 set, u8 index,
+				  u8 value, unsigned int timeout_ms,
+				  bool use_busy_signal, bool ignore_timeout);
+#endif
 extern int mmc_send_tuning(struct mmc_host *host, u32 opcode, int *cmd_error);
+#ifdef CONFIG_MMC_SDHCI_RTK
+extern int mmc_send_tuning_tx(struct mmc_host *host, u32 opcode, int *cmd_error);
+#endif
 extern int mmc_get_ext_csd(struct mmc_card *card, u8 **new_ext_csd);
 
 #define MMC_ERASE_ARG		0x00000000
diff --git a/include/linux/mmc/host.h b/include/linux/mmc/host.h
index 0b24394..f2cf96e 100644
--- a/include/linux/mmc/host.h
+++ b/include/linux/mmc/host.h
@@ -16,6 +16,7 @@
 #include <linux/sched.h>
 #include <linux/device.h>
 #include <linux/fault-inject.h>
+#include <linux/blkdev.h>
 
 #include <linux/mmc/core.h>
 #include <linux/mmc/card.h>
@@ -82,6 +83,18 @@ struct mmc_ios {
 	bool enhanced_strobe;			/* hs400es selection */
 };
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+struct mmc_cmdq_host_ops {
+	int (*enable)(struct mmc_host *host);
+	void (*disable)(struct mmc_host *host, bool soft);
+	int (*request)(struct mmc_host *host, struct mmc_request *mrq);
+	void (*post_req)(struct mmc_host *host, int tag,
+			 int err);
+	int (*halt)(struct mmc_host *host, bool halt);
+	void (*getrsp)(struct mmc_host *host, struct mmc_request *mrq);
+};
+#endif
+
 struct mmc_host_ops {
 	/*
 	 * It is optional for the host to implement pre_req and post_req in
@@ -161,11 +174,79 @@ struct mmc_host_ops {
 	 */
 	int	(*multi_io_quirk)(struct mmc_card *card,
 				  unsigned int direction, int blk_size);
+	void    (*dqs_tuning)(struct mmc_host *host);
 };
 
 struct mmc_card;
 struct device;
 
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+struct mmc_cmdq_req {
+	unsigned int cmd_flags;
+	u32 blk_addr;
+	/* active mmc request */
+	struct mmc_request	mrq;
+	struct mmc_data		data;
+	struct mmc_command	cmd;
+#define DCMD		(1 << 0)
+#define QBR		(1 << 1)
+#define DIR		(1 << 2)
+#define PRIO		(1 << 3)
+#define REL_WR		(1 << 4)
+#define DAT_TAG	(1 << 5)
+#define FORCED_PRG	(1 << 6)
+	unsigned int		cmdq_req_flags;
+	int			tag; /* used for command queuing */
+	u8			ctx_id;
+};
+
+
+struct mmc_cqe_ops {
+        /* Allocate resources, and make the CQE operational */
+        int     (*cqe_enable)(struct mmc_host *host, struct mmc_card *card);
+        /* Free resources, and make the CQE non-operational */
+        void    (*cqe_disable)(struct mmc_host *host);
+        /*
+         * Issue a read, write or DCMD request to the CQE. Also deal with the
+         * effect of ->cqe_off().
+         */
+        int     (*cqe_request)(struct mmc_host *host, struct mmc_request *mrq);
+        /* Free resources (e.g. DMA mapping) associated with the request */
+        void    (*cqe_post_req)(struct mmc_host *host, struct mmc_request *mrq);
+        /*
+         * Prepare the CQE and host controller to accept non-CQ commands. There
+         * is no corresponding ->cqe_on(), instead ->cqe_request() is required
+         * to deal with that.
+         */
+        void    (*cqe_off)(struct mmc_host *host);
+        /*
+         * Wait for all CQE tasks to complete. Return an error if recovery
+         * becomes necessary.
+         */
+        int     (*cqe_wait_for_idle)(struct mmc_host *host);
+        /*
+         * Notify CQE that a request has timed out. Return false if the request
+         * completed or true if a timeout happened in which case indicate if
+         * recovery is needed.
+         */
+        bool    (*cqe_timeout)(struct mmc_host *host, struct mmc_request *mrq,
+                               bool *recovery_needed);
+        /*
+         * Stop all CQE activity and prepare the CQE and host controller to
+         * accept recovery commands.
+         */
+        void    (*cqe_recovery_start)(struct mmc_host *host);
+        /*
+         * Clear the queue and call mmc_cqe_request_done() on all requests.
+         * Requests that errored will have the error set on the mmc_request
+         * (data->error or cmd->error for DCMD).  Requests that did not error
+         * will have zero data bytes transferred.
+         */
+        void    (*cqe_recovery_finish)(struct mmc_host *host);
+};
+#endif
+
 struct mmc_async_req {
 	/* active mmc request */
 	struct mmc_request	*mrq;
@@ -192,6 +273,26 @@ struct mmc_slot {
 	void *handler_priv;
 };
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+/**
+ * mmc_cmdq_context_info - describes the contexts of cmdq
+ * @active_reqs		requests being processed
+ * @curr_state		state of cmdq engine
+ * @req_starved		completion should invoke the request_fn since
+ *			no tags were available
+ */
+struct mmc_cmdq_context_info {
+	unsigned long	active_reqs; /* in-flight requests */
+	unsigned long	curr_state;
+#define	CMDQ_STATE_ERR 0
+#define	CMDQ_STATE_DCMD_ACTIVE 1
+#define	CMDQ_STATE_HALT 2
+	/* no free tag available */
+	unsigned long	req_starved;
+	wait_queue_head_t	wait;
+};
+#endif
+
 /**
  * mmc_context_info - synchronization details for mmc context
  * @is_done_rcv		wake up reason was done request
@@ -221,6 +322,9 @@ struct mmc_host {
 	struct device		class_dev;
 	int			index;
 	const struct mmc_host_ops *ops;
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	const struct mmc_cmdq_host_ops *cmdq_ops;
+#endif
 	struct mmc_pwrseq	*pwrseq;
 	unsigned int		f_min;
 	unsigned int		f_max;
@@ -236,6 +340,10 @@ struct mmc_host {
 	u32			max_current_300;
 	u32			max_current_180;
 
+#ifdef CONFIG_RTK_PLATFORM
+	u32			mode; //for rtkemmc_execute_tuning usage
+#endif /* CONFIG_RTK_PLATFORM */
+
 #define MMC_VDD_165_195		0x00000080	/* VDD voltage 1.65 - 1.95 */
 #define MMC_VDD_20_21		0x00000100	/* VDD voltage 2.0 ~ 2.1 */
 #define MMC_VDD_21_22		0x00000200	/* VDD voltage 2.1 ~ 2.2 */
@@ -313,6 +421,12 @@ struct mmc_host {
 #define MMC_CAP2_NO_SD		(1 << 21)	/* Do not send SD commands during initialization */
 #define MMC_CAP2_NO_MMC		(1 << 22)	/* Do not send (e)MMC commands during initialization */
 
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#define MMC_CAP2_CQE		(1 << 23)	/* Has eMMC command queue engine */
+#define MMC_CAP2_CQE_DCMD	(1 << 24)	/* CQE can issue a direct command */
+#define MMC_CAP2_CMD_QUEUE	(1 << 25)	/* support eMMC command queue */
+#endif
 	mmc_pm_flag_t		pm_caps;	/* supported pm features */
 
 	/* host specific block data */
@@ -364,6 +478,12 @@ struct mmc_host {
 	const struct mmc_bus_ops *bus_ops;	/* current bus driver */
 	unsigned int		bus_refs;	/* reference counter */
 
+#ifdef CONFIG_RTK_PLATFORM
+	unsigned int		bus_resume_flags;
+	#define MMC_BUSRESUME_MANUAL_RESUME		(1 << 0)
+	#define MMC_BUSRESUME_NEEDS_RESUME		(1 << 1)
+#endif /* CONFIG_RTK_PLATFORM */
+
 	unsigned int		sdio_irqs;
 	struct task_struct	*sdio_irq_thread;
 	bool			sdio_irq_pending;
@@ -397,6 +517,45 @@ struct mmc_host {
 	int			dsr_req;	/* DSR value is valid */
 	u32			dsr;	/* optional driver stage (DSR) value */
 
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+	struct mmc_cmdq_context_info	cmdq_ctx;
+	/*
+	 * several cmdq supporting host controllers are extensions
+	 * of legacy controllers. This variable can be used to store
+	 * a reference to the cmdq extension of the existing host
+	 * controller.
+	 */
+	void *cmdq_private;
+	/* Command Queue Engine (CQE) support */
+	const struct mmc_cqe_ops *cqe_ops;
+	void			*cqe_private;
+	int			cqe_qdepth;
+	bool			cqe_enabled;
+	bool			cqe_on;
+#endif
+
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+	struct {
+		struct sdio_cis			*cis;
+		struct sdio_cccr		*cccr;
+		struct sdio_embedded_func	*funcs;
+		int				num_funcs;
+	} embedded_sdio_data;
+#endif
+
+#ifdef CONFIG_BLOCK
+	int			latency_hist_enabled;
+	struct io_latency_state io_lat_read;
+	struct io_latency_state io_lat_write;
+#endif
+
+#ifdef CONFIG_ARCH_RTD119X
+	unsigned int        card_type_pre;
+	#define CR_SD       0 //for card reader
+	#define CR_EM       2 //for eMMC
+#endif
+
 	unsigned long		private[0] ____cacheline_aligned;
 };
 
@@ -406,17 +565,39 @@ struct mmc_host {
 void mmc_free_host(struct mmc_host *);
 int mmc_of_parse(struct mmc_host *host);
 
+#ifdef CONFIG_MMC_EMBEDDED_SDIO
+extern void mmc_set_embedded_sdio_data(struct mmc_host *host,
+				       struct sdio_cis *cis,
+				       struct sdio_cccr *cccr,
+				       struct sdio_embedded_func *funcs,
+				       int num_funcs);
+#endif
+
 static inline void *mmc_priv(struct mmc_host *host)
 {
 	return (void *)host->private;
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+static inline void *mmc_cmdq_private(struct mmc_host *host)
+{
+	return host->cmdq_private;
+}
+#endif
+
 #define mmc_host_is_spi(host)	((host)->caps & MMC_CAP_SPI)
 
 #define mmc_dev(x)	((x)->parent)
 #define mmc_classdev(x)	(&(x)->class_dev)
 #define mmc_hostname(x)	(dev_name(&(x)->class_dev))
 
+#ifdef CONFIG_RTK_PLATFORM
+#define mmc_bus_needs_resume(host) ((host)->bus_resume_flags & MMC_BUSRESUME_NEEDS_RESUME)
+#define mmc_bus_manual_resume(host) ((host)->bus_resume_flags & MMC_BUSRESUME_MANUAL_RESUME)
+int mmc_suspend_host(struct mmc_host *);
+int mmc_resume_host(struct mmc_host *);
+#endif /* CONFIG_RTK_PLATFORM */
+
 int mmc_power_save_host(struct mmc_host *host);
 int mmc_power_restore_host(struct mmc_host *host);
 
@@ -500,6 +681,22 @@ static inline int mmc_host_packed_wr(struct mmc_host *host)
 	return host->caps2 & MMC_CAP2_PACKED_WR;
 }
 
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+static inline void mmc_host_set_halt(struct mmc_host *host)
+{
+	set_bit(CMDQ_STATE_HALT, &host->cmdq_ctx.curr_state);
+}
+
+static inline void mmc_host_clr_halt(struct mmc_host *host)
+{
+	clear_bit(CMDQ_STATE_HALT, &host->cmdq_ctx.curr_state);
+}
+
+static inline int mmc_host_halt(struct mmc_host *host)
+{
+	return test_bit(CMDQ_STATE_HALT, &host->cmdq_ctx.curr_state);
+}
+#endif
 static inline int mmc_card_hs(struct mmc_card *card)
 {
 	return card->host->ios.timing == MMC_TIMING_SD_HS ||
diff --git a/include/linux/mmc/mmc.h b/include/linux/mmc/mmc.h
index c376209..207cfbe 100644
--- a/include/linux/mmc/mmc.h
+++ b/include/linux/mmc/mmc.h
@@ -84,6 +84,16 @@
 #define MMC_APP_CMD              55   /* ac   [31:16] RCA        R1  */
 #define MMC_GEN_CMD              56   /* adtc [0] RD/WR          R1  */
 
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+  /* class 11 */
+#define MMC_QUE_TASK_PARAMS      44   /* ac   [20:16] task id    R1  */
+#define MMC_QUE_TASK_ADDR        45   /* ac   [31:0] data addr   R1  */
+#define MMC_EXECUTE_READ_TASK    46   /* adtc [20:16] task id    R1  */
+#define MMC_EXECUTE_WRITE_TASK   47   /* adtc [20:16] task id    R1  */
+#define MMC_CMDQ_TASK_MGMT       48   /* ac   [20:16] task id    R1b */
+#endif
+
 static inline bool mmc_op_multi(u32 opcode)
 {
 	return opcode == MMC_WRITE_MULTIPLE_BLOCK ||
@@ -272,6 +282,12 @@ struct _mmc_csd {
  * EXT_CSD fields
  */
 
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#define EXT_CSD_CMDQ_MODE_EN		15	/* R/W */
+#define EXT_CSD_CMDQ			15	/* R/W */
+#endif
+
 #define EXT_CSD_FLUSH_CACHE		32      /* W */
 #define EXT_CSD_CACHE_CTRL		33      /* R/W */
 #define EXT_CSD_POWER_OFF_NOTIFICATION	34	/* R/W */
@@ -331,6 +347,19 @@ struct _mmc_csd {
 #define EXT_CSD_CACHE_SIZE		249	/* RO, 4 bytes */
 #define EXT_CSD_PWR_CL_DDR_200_360	253	/* RO */
 #define EXT_CSD_FIRMWARE_VERSION	254	/* RO, 8 bytes */
+
+#ifdef CONFIG_MMC_RTK_EMMC
+#define EXT_CSD_PRE_EOL_INFO		267	/* RO */
+#define EXT_CSD_DEVICE_LIFE_TIME_EST_TYP_A	268	/* RO */
+#define EXT_CSD_DEVICE_LIFE_TIME_EST_TYP_B	269	/* RO */
+#endif
+
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+#define EXT_CSD_CMDQ_DEPTH		307	/* RO */
+#define EXT_CSD_CMDQ_SUPPORT		308	/* RO */
+#endif
+
 #define EXT_CSD_SUPPORTED_MODE		493	/* RO */
 #define EXT_CSD_TAG_UNIT_SIZE		498	/* RO */
 #define EXT_CSD_DATA_TAG_SUPPORT	499	/* RO */
@@ -345,6 +374,12 @@ struct _mmc_csd {
 
 #define EXT_CSD_WR_REL_PARAM_EN		(1<<2)
 
+#ifdef CONFIG_MMC_RTK_EMMC
+#define EXT_CSD_BOOT_WP_SEL            (0x80)
+#define EXT_CSD_BOOT_WP_PERM_SEL       (0x08)
+#define EXT_CSD_BOOT_WP_PWR_SEL        (0x02)
+#endif
+
 #define EXT_CSD_BOOT_WP_B_PWR_WP_DIS	(0x40)
 #define EXT_CSD_BOOT_WP_B_PERM_WP_DIS	(0x10)
 #define EXT_CSD_BOOT_WP_B_PERM_WP_EN	(0x04)
@@ -437,6 +472,16 @@ struct _mmc_csd {
  */
 #define EXT_CSD_MANUAL_BKOPS_MASK	0x01
 
+/*we port kernel 4.14-4.16 command queue function to kernel 4.9 for realtek eMMC 5.1 IP*/
+#if defined(CONFIG_ARCH_RTD13xx) && defined(CONFIG_MMC_RTK_EMMC) && defined(CONFIG_MMC_RTK_EMMC_CMDQ)
+/*
+ * Command Queue
+ */
+#define EXT_CSD_CMDQ_MODE_ENABLED	BIT(0)
+#define EXT_CSD_CMDQ_DEPTH_MASK		GENMASK(4, 0)
+#define EXT_CSD_CMDQ_SUPPORTED		BIT(0)
+#endif
+
 /*
  * MMC_SWITCH access modes
  */
diff --git a/include/linux/mmc/pm.h b/include/linux/mmc/pm.h
index 4a13920..6e2d6a1 100644
--- a/include/linux/mmc/pm.h
+++ b/include/linux/mmc/pm.h
@@ -26,5 +26,6 @@
 
 #define MMC_PM_KEEP_POWER	(1 << 0)	/* preserve card power during suspend */
 #define MMC_PM_WAKE_SDIO_IRQ	(1 << 1)	/* wake up host system on SDIO IRQ assertion */
+#define MMC_PM_IGNORE_PM_NOTIFY	(1 << 2)	/* ignore mmc pm notify */
 
 #endif /* LINUX_MMC_PM_H */
diff --git a/include/linux/mmc/sdio_func.h b/include/linux/mmc/sdio_func.h
index 97ca105..f563bcf 100644
--- a/include/linux/mmc/sdio_func.h
+++ b/include/linux/mmc/sdio_func.h
@@ -23,6 +23,14 @@
 typedef void (sdio_irq_handler_t)(struct sdio_func *);
 
 /*
+ * Structure used to hold embedded SDIO device data from platform layer
+ */
+struct sdio_embedded_func {
+	uint8_t f_class;
+	uint32_t f_maxblksize;
+};
+
+/*
  * SDIO function CIS tuple (unknown to the core)
  */
 struct sdio_func_tuple {
@@ -128,6 +136,8 @@ struct sdio_driver {
 extern unsigned int sdio_align_size(struct sdio_func *func, unsigned int sz);
 
 extern u8 sdio_readb(struct sdio_func *func, unsigned int addr, int *err_ret);
+extern u8 sdio_readb_ext(struct sdio_func *func, unsigned int addr, int *err_ret,
+	unsigned in);
 extern u16 sdio_readw(struct sdio_func *func, unsigned int addr, int *err_ret);
 extern u32 sdio_readl(struct sdio_func *func, unsigned int addr, int *err_ret);
 
diff --git a/include/linux/module.h b/include/linux/module.h
index d2224a0..9d6fd1d 100644
--- a/include/linux/module.h
+++ b/include/linux/module.h
@@ -20,6 +20,7 @@
 #include <linux/export.h>
 #include <linux/extable.h>	/* only as arch move module.h -> extable.h */
 #include <linux/rbtree_latch.h>
+#include <linux/cfi.h>
 
 #include <linux/percpu.h>
 #include <asm/module.h>
@@ -127,13 +128,13 @@ extern ssize_t __modver_version_show(struct module_attribute *,
 
 /* Each module must use one module_init(). */
 #define module_init(initfn)					\
-	static inline initcall_t __inittest(void)		\
+	static inline initcall_t __maybe_unused __inittest(void)		\
 	{ return initfn; }					\
 	int init_module(void) __attribute__((alias(#initfn)));
 
 /* This is only required if you want to be unloadable. */
 #define module_exit(exitfn)					\
-	static inline exitcall_t __exittest(void)		\
+	static inline exitcall_t __maybe_unused __exittest(void)		\
 	{ return exitfn; }					\
 	void cleanup_module(void) __attribute__((alias(#exitfn)));
 
@@ -349,6 +350,10 @@ struct module {
 	const unsigned long *crcs;
 	unsigned int num_syms;
 
+#ifdef CONFIG_CFI_CLANG
+	cfi_check_fn cfi_check;
+#endif
+
 	/* Kernel parameters. */
 #ifdef CONFIG_SYSFS
 	struct mutex param_lock;
diff --git a/include/linux/moduleparam.h b/include/linux/moduleparam.h
index 52666d9..060db5c 100644
--- a/include/linux/moduleparam.h
+++ b/include/linux/moduleparam.h
@@ -225,19 +225,11 @@ struct kparam_array
 	    VERIFY_OCTAL_PERMISSIONS(perm), level, flags, { arg } }
 
 /* Obsolete - use module_param_cb() */
-#define module_param_call(name, set, get, arg, perm)			\
-	static const struct kernel_param_ops __param_ops_##name =		\
-		{ .flags = 0, (void *)set, (void *)get };		\
+#define module_param_call(name, _set, _get, arg, perm)			\
+	static const struct kernel_param_ops __param_ops_##name =	\
+		{ .flags = 0, .set = _set, .get = _get };		\
 	__module_param_call(MODULE_PARAM_PREFIX,			\
-			    name, &__param_ops_##name, arg,		\
-			    (perm) + sizeof(__check_old_set_param(set))*0, -1, 0)
-
-/* We don't get oldget: it's often a new-style param_get_uint, etc. */
-static inline int
-__check_old_set_param(int (*oldset)(const char *, struct kernel_param *))
-{
-	return 0;
-}
+			    name, &__param_ops_##name, arg, perm, -1, 0)
 
 #ifdef CONFIG_SYSFS
 extern void kernel_param_lock(struct module *mod);
diff --git a/include/linux/mount.h b/include/linux/mount.h
index e0f3a82..5615a9e 100644
--- a/include/linux/mount.h
+++ b/include/linux/mount.h
@@ -67,6 +67,7 @@ struct vfsmount {
 	struct dentry *mnt_root;	/* root of the mounted tree */
 	struct super_block *mnt_sb;	/* pointer to superblock */
 	int mnt_flags;
+	void *data;
 };
 
 struct file; /* forward dec */
diff --git a/include/linux/mtd/rtk_nand.h b/include/linux/mtd/rtk_nand.h
new file mode 100644
index 00000000..3679ed6
--- /dev/null
+++ b/include/linux/mtd/rtk_nand.h
@@ -0,0 +1,366 @@
+/*
+ * rtk_nand.h - nand driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+#ifndef __RTK_NAND_H
+#define __RTK_NAND_H
+
+#include <linux/sched.h>
+#include <linux/mtd/mtd.h>
+
+#define DBG_SHOW_MSG_ENABLE	(0)	//define if show debug message;
+#define DBG_MODE_ENABLE		(0)   	//Enable debug mode or not;
+#define TEST_NF_DRIVER		(0)   	//Enable test procedure for NAND flash driver 
+#define RTK_NAND_TEST		(0) 	//+alexchang add 0702-2010
+#define RTK_ARD_ALGORITHM	(0)	//Enable Avoid Read Disturbance Algorithm or not
+#define RTK_CP_DISABLE		(0)	//Enable content protection for NAND driver or not
+
+/* 
+define mars read/write NAND HW registers
+use them because standard readb/writeb have warning msgs in our gcc 2.96
+ex: passing arg 2 of `writeb' makes pointer from integer without a cast
+*/
+#define GET_MAPPED_RBUS_ADDR(x)			(x)
+
+//#define REG_READ_U8(register)         	(*(volatile unsigned char *)GET_MAPPED_RBUS_ADDR(register))
+//#define REG_READ_U16(register)         	(*(volatile unsigned short *)GET_MAPPED_RBUS_ADDR(register))
+//#define REG_READ_U32(register)         	(*(volatile unsigned long *)GET_MAPPED_RBUS_ADDR(register))
+//#define REG_READ_U32(register)         	(readl(register))
+#define REG_READ_U32(x)				readl((volatile unsigned int*)(x))
+
+//#define REG_WRITE_U8(register, value)    	(*(volatile unsigned char *)GET_MAPPED_RBUS_ADDR(register) = value)
+//#define REG_WRITE_U16(register, value)    	(*(volatile unsigned short *)GET_MAPPED_RBUS_ADDR(register) = value)
+//#define REG_WRITE_U32(register, value)    	(*(volatile unsigned long *)GET_MAPPED_RBUS_ADDR(register) = value)
+//#define REG_WRITE_U32(register, value)    	(writel(value,register))
+#define REG_WRITE_U32(x,y)			writel(y,(volatile unsigned int*)(x))
+
+#define MTDSIZE	(sizeof (struct mtd_info) + sizeof (struct nand_chip))
+#define MAX_PARTITIONS	16
+#define BOOTCODE	16*1024*1024	//16MB
+
+
+#define NF_INIT_DEBUG		1
+//#define NF_DEBUG		1
+
+#ifdef NF_INIT_DEBUG
+#define NF_INIT_PRINT(fmt, args...)         printk(KERN_ERR "[NF] Init, " fmt, ## args)
+#else
+#define NF_INIT_PRINT(fmt, args...)
+#endif
+
+#ifdef NF_DEBUG
+#define NF_DEBUG_PRINT(fmt, args...)        printk(KERN_ERR "[NF] Debug, " fmt, ## args)
+#else
+#define NF_DEBUG_PRINT(fmt, args...)
+#endif
+
+#define NF_INFO_PRINT(fmt, args...)         printk(KERN_INFO "[NF] Info, " fmt, ## args)
+#define NF_ERR_PRINT(fmt, args...)          printk(KERN_ERR "[NF] Error, " fmt, ## args)
+
+//#define RTK_TEST 1
+#define RTK_VERIFY 1
+#define WAIT_TIMEOUT	99
+//#define RTK_NAND_SHIFTABLE
+
+/*
+ * Searches for a NAND device
+ */
+extern int rtk_nand_scan (struct mtd_info *mtd, int maxchips);
+
+
+//========================================================================
+
+/* Reserve Block Area usage */
+#define	BB_INIT		0xFFFE
+#define	RB_INIT		0xFFFD
+#define	BBT_TAG		0xBBBB
+#define SB_INIT		0xFFAA
+#define SBT_TAG		0xAAAA
+#define TAG_FACTORY_PARAM	(0x82)
+#define BB_DIE_INIT	0xEEEE
+#define RB_DIE_INIT	BB_DIE_INIT
+
+typedef struct  __attribute__ ((__packed__)){
+	u16 BB_die;
+	u16 bad_block;
+	u16 RB_die;
+	u16 remap_block;
+}BB_t;
+
+typedef struct {
+	u16 chipnum;
+	u16 block;
+	u16 shift;
+}SB_t;
+
+//for PCBmgr
+typedef enum {
+	PCB_PIN_TYPE_UNUSED = 0, 	
+	PCB_PIN_TYPE_LSADC, 
+	PCB_PIN_TYPE_EMCU_GPIO,
+	PCB_PIN_TYPE_GPIO,
+	PCB_PIN_TYPE_ISO_GPIO,
+	PCB_PIN_TYPE_UNIPWM,
+	PCB_PIN_TYPE_ISO_UNIPWM,
+	PCB_PIN_TYPE_PWM,
+	PCB_PIN_TYPE_ISO_PWM,
+	PCB_PIN_TYPE_AUDIO,	
+	PCB_PIN_TYPE_AUDIO_OUPUT,
+	PCB_PIN_TYPE_UNDEF,
+	PCB_PIN_TYPE_CEC,
+} PCB_PIN_TYPE_T;
+
+#define GET_PIN_TYPE(x)		((PCB_PIN_TYPE_T) (x & 0xFF))
+
+/* NAND Flash Command Sets */
+#define CMD_READ_ID		0x90
+#define CMD_READ_STATUS		0x70
+
+#define CMD_PG_READ_C1		0x00
+#define CMD_PG_READ_C2		0x30
+#define CMD_PG_READ_C3		CMD_READ_STATUS
+
+#define CMD_PG_WRITE_C1		0x80
+#define CMD_PG_WRITE_C2		0x10
+#define CMD_PG_WRITE_C3		CMD_READ_STATUS
+
+#define CMD_BLK_ERASE_C1	0x60	//Auto Block Erase Setup command
+#define CMD_BLK_ERASE_C2	0xd0	//CMD_ERASE_START
+#define CMD_BLK_ERASE_C3		CMD_READ_STATUS	//CMD_STATUS_READ
+
+#define CMD_RESET               0xff
+#define CMD_RANDOM_DATA_INPUT   0x85    /* RANDOM DATA write */ 
+
+#define CMD_RANDOM_DATA_OUTPUT_C1 0x05    /* RANDOM DATA read */
+#define CMD_RANDOM_DATA_OUTPUT_C2 0xe0 
+
+#define NAND_ISR_XFER_MODE_DONE	(1 << 2)
+#define NAND_ISR_AUTO_MODE_DONE	(1 << 3)
+#define NAND_ISR_DMA_DONE	(1 << 4)
+#define NAND_ISR_PFS_DONE	(1 << 7)	//polling flash status busy = 1
+
+#define MCP_NONE	0
+#define MCP_AES_ECB	1
+#define MCP_AES_CBC	2
+#define MCP_AES_CTR	3
+//========================================================================
+/* The maximum number of NAND chips in an array */
+#define NAND_MAX_CHIPS		8
+struct NAND_Info_st {
+	unsigned int U32NFDrvVer;//The version number of NF Driver
+	unsigned int U32ReadIDBytes;//Determine bytes for readID command need.
+	
+	unsigned int U32BlkCnt;// Number of blocks
+	unsigned int U32PageSize;//Page size
+	unsigned int U32PagePerBlk;//page count per block
+
+	unsigned int U32BlkCntShift;
+	unsigned int U32PageSizeShift;
+	unsigned int U32PagePerBlkShift;
+};
+
+
+/*
+	macro RTK_FLUSH_CACHE is to flush the cache at address "addr", 
+	the length is "len"
+*/
+#if 0
+#define RTK_FLUSH_CACHE(addr, len)		\
+do {								\
+	unsigned long dc_lsize = current_cpu_data.dcache.linesz;	\
+	unsigned long end, a;								\
+	a = (unsigned long ) addr & ~(dc_lsize - 1);		\
+	end = ((unsigned long )addr + len - 1) & ~(dc_lsize - 1);	\
+	while (1) {		\
+		flush_dcache_line(a);   /* Hit_Writeback_Inv_D */	\
+		if (a == end)	\
+			break;	\
+		a += dc_lsize;	\
+	}	\
+} while (0)
+#else
+#define RTK_FLUSH_CACHE(addr, len)
+#endif
+
+//===================================================================
+/*
+ * nand_state_t - chip states
+ * Enumeration for NAND flash chip state
+ */
+typedef enum {
+	FL_READY,
+	FL_READING,
+	FL_WRITING,
+	FL_ERASING,
+	FL_SYNCING,
+	FL_CACHEDPRG,
+} nand_state_t;
+//=============================================================================
+
+
+//=============================================================================
+
+/**
+ * struct nand_hw_control - Control structure for hardware controller (e.g ECC generator) shared among independend devices
+ * @lock:               protection lock  
+ * @active:		the mtd device which holds the controller currently
+ * @wq:			wait queue to sleep on if a NAND operation is in progress
+ *                      used instead of the per chip wait queue when a hw controller is available
+ */
+struct nand_hw_control {
+	spinlock_t	 lock;
+	struct nand_chip *active;
+	wait_queue_head_t wq;
+};
+//=============================================================================
+
+
+/**
+ * struct nand_chip - NAND Private Flash Chip Data
+ * @IO_ADDR_R:		[BOARDSPECIFIC] address to read the 8 I/O lines of the flash device 
+ * @IO_ADDR_W:		[BOARDSPECIFIC] address to write the 8 I/O lines of the flash device 
+ * @read_byte:		[REPLACEABLE] read one byte from the chip
+ * @write_byte:		[REPLACEABLE] write one byte to the chip
+ * @read_word:		[REPLACEABLE] read one word from the chip
+ * @write_word:		[REPLACEABLE] write one word to the chip
+ * @write_buf:		[REPLACEABLE] write data from the buffer to the chip
+ * @read_buf:		[REPLACEABLE] read data from the chip into the buffer
+ * @verify_buf:		[REPLACEABLE] verify buffer contents against the chip data
+ * @select_chip:	[REPLACEABLE] select chip nr
+ * @block_bad:		[REPLACEABLE] check, if the block is bad
+ * @block_markbad:	[REPLACEABLE] mark the block bad
+ * @hwcontrol:		[BOARDSPECIFIC] hardwarespecific function for accesing control-lines
+ * @dev_ready:		[BOARDSPECIFIC] hardwarespecific function for accesing device ready/busy line
+ *			If set to NULL no access to ready/busy is available and the ready/busy information
+ *			is read from the chip status register
+ * @cmdfunc:		[REPLACEABLE] hardwarespecific function for writing commands to the chip
+ * @waitfunc:		[REPLACEABLE] hardwarespecific function for wait on ready
+ * @calculate_ecc: 	[REPLACEABLE] function for ecc calculation or readback from ecc hardware
+ * @correct_data:	[REPLACEABLE] function for ecc correction, matching to ecc generator (sw/hw)
+ * @enable_hwecc:	[BOARDSPECIFIC] function to enable (reset) hardware ecc generator. Must only
+ *			be provided if a hardware ECC is available
+ * @erase_cmd:		[INTERN] erase command write function, selectable due to AND support
+ * @scan_bbt:		[REPLACEABLE] function to scan bad block table
+ * @eccmode:		[BOARDSPECIFIC] mode of ecc, see defines 
+ * @eccsize: 		[INTERN] databytes used per ecc-calculation
+ * @eccbytes: 		[INTERN] number of ecc bytes per ecc-calculation step
+ * @eccsteps:		[INTERN] number of ecc calculation steps per page
+ * @chip_delay:		[BOARDSPECIFIC] chip dependent delay for transfering data from array to read regs (tR)
+ * @chip_lock:		[INTERN] spinlock used to protect access to this structure and the chip
+ * @wq:			[INTERN] wait queue to sleep on if a NAND operation is in progress
+ * @state: 		[INTERN] the current state of the NAND device
+ * @page_shift:		[INTERN] number of address bits in a page (column address bits)
+ * @phys_erase_shift:	[INTERN] number of address bits in a physical eraseblock
+ * @bbt_erase_shift:	[INTERN] number of address bits in a bbt entry
+ * @chip_shift:		[INTERN] number of address bits in one chip
+ * @data_buf:		[INTERN] internal buffer for one page + oob 
+ * @oob_buf:		[INTERN] oob buffer for one eraseblock
+ * @oobdirty:		[INTERN] indicates that oob_buf must be reinitialized
+ * @data_poi:		[INTERN] pointer to a data buffer
+ * @options:		[BOARDSPECIFIC] various chip options. They can partly be set to inform nand_scan about
+ *			special functionality. See the defines for further explanation
+ * @badblockpos:	[INTERN] position of the bad block marker in the oob area
+ * @numchips:		[INTERN] number of physical chips
+ * @chipsize:		[INTERN] the size of one chip for multichip arrays
+ * @pagemask:		[INTERN] page number mask = number of (pages / chip) - 1
+ * @pagebuf:		[INTERN] holds the pagenumber which is currently in data_buf
+ * @autooob:		[REPLACEABLE] the default (auto)placement scheme
+ * @bbt:		[INTERN] bad block table pointer
+ * @bbt_td:		[REPLACEABLE] bad block table descriptor for flash lookup
+ * @bbt_md:		[REPLACEABLE] bad block table mirror descriptor
+ * @badblock_pattern:	[REPLACEABLE] bad block scan pattern used for initial bad block scan 
+ * @controller:		[OPTIONAL] a pointer to a hardware controller structure which is shared among multiple independend devices
+ * @priv:		[OPTIONAL] pointer to private chip date
+ * @errstat:		[OPTIONAL] hardware specific function to perform additional error status checks 
+ *			(determine if errors are correctable)
+ */
+ 
+struct nand_chip {
+	u_char oob_shift;
+	void (*read_id) (struct mtd_info *mtd, unsigned char id[5]);
+	int (*read_ecc_page) (struct mtd_info *mtd, u16 chipnr, unsigned int page, u_char *data, 
+									u_char *oob_buf, u16 cp_mode, dma_addr_t *data_phy);
+	int (*read_oob) (struct mtd_info *mtd, u16 chipnr, int page, int len, u_char *buf);
+	int (*write_ecc_page) (struct mtd_info *mtd, u16 chipnr, unsigned int page, const u_char *data, const u_char *oob_buf, const dma_addr_t *data_phy);										
+	int (*write_oob) (struct mtd_info *mtd, u16 chipnr, int page, int len, const u_char *buf);
+	int (*erase_block) (struct mtd_info *mtd, u16 chipnr, int page);
+	void (*sync) (struct mtd_info *mtd);
+
+	void (*suspend) (struct mtd_info *mtd);
+	void (*resume) (struct mtd_info *mtd);
+
+	void (*select_chip) (struct mtd_info *mtd, int chip);
+	void	(*read_buf)(struct mtd_info *mtd, u_char *buf, int len);
+	void 	(*cmdfunc)(struct mtd_info *mtd, unsigned command, int column, int page_addr);
+	int  (*dev_ready)(struct mtd_info *mtd);
+	int (*scan_bbt)(struct mtd_info *mtd, unsigned char *buf_phy);
+	int		eccmode;
+	int		eccsize;
+	int		eccbytes;
+	int		eccsteps;
+	int 		chip_delay;
+	spinlock_t	chip_lock;
+	wait_queue_head_t wq;
+	nand_state_t 	state;
+	uint64_t 		page_shift;
+	uint64_t		page_idx_mask;
+	int		phys_erase_shift;
+	int		bbt_erase_shift;
+	int		chip_shift;
+	u_char 		*g_databuf;
+	u_char		*g_oobbuf;
+	int		oobdirty;
+	u_char		*data_poi;
+	unsigned int	options;
+	int		badblockpos;
+	int		numchips;
+	uint64_t chipsize;
+
+	uint64_t device_size;
+	uint64_t		pagemask;
+	int		pagebuf;
+	struct nand_oobinfo	*autooob;
+
+	struct nand_bbt_descr	*bbt_td;
+	struct nand_bbt_descr	*bbt_md;
+	struct nand_bbt_descr	*badblock_pattern;	
+	struct nand_hw_control  *controller;
+	void		*priv;
+
+	unsigned char maker_code;	
+	unsigned char device_code; 
+	unsigned int ppb;	//page per block
+	unsigned int oob_size;	//spare area size
+	unsigned int block_num;
+	unsigned int page_num;
+	BB_t *bbt;
+	SB_t *sbt;
+	unsigned int RBA;
+	unsigned int RBA_PERCENT;
+	__u32 *erase_page_flag;
+	unsigned char active_chip;
+	unsigned int BBs;
+
+	unsigned int mcp;
+	unsigned short ecc_select;	//modify unsigned char to unsigned short by alexchang 0319-2010	
+};
+//=============================================================================
+
+
+extern int nand_scan_bbt (struct mtd_info *mtd, struct nand_bbt_descr *bd);
+extern int nand_update_bbt (struct mtd_info *mtd, loff_t offs);
+extern int nand_default_bbt (struct mtd_info *mtd);
+extern int nand_isbad_bbt (struct mtd_info *mtd, loff_t offs, int allowbbt);
+extern int nand_erase_nand (struct mtd_info *mtd, struct erase_info *instr, int allowbbt);
+extern int nand_do_read_ecc (struct mtd_info *mtd, loff_t from, size_t len,
+                             size_t * retlen, u_char * buf, u_char * oob_buf,
+                             struct nand_oobinfo *oobsel, int flags);
+//extern struct semaphore sem_NF_CARDREADER;                             
+#endif
+
diff --git a/include/linux/mtd/rtk_nand_list.h b/include/linux/mtd/rtk_nand_list.h
new file mode 100644
index 00000000..d3c5f35
--- /dev/null
+++ b/include/linux/mtd/rtk_nand_list.h
@@ -0,0 +1,238 @@
+/* Realtek supports nand chip types */
+/* Micorn */
+#define MT29F2G08AAD		0x2CDA8095	//SLC, 256 MB, 1 dies
+#define MT29F2G08ABAE		0x2CDA9095	//SLC, 256MB, 1 dies
+#define MT29F1G08ABADA		0x2CF18095	//SLC, 128MB, 1 dies
+#define MT29F4G08ABADA		0x2CDC9095	//SLC, 512MB, 1 dies
+#define MT29F32G08CBACA		0x2C68044A	//MLC, 4GB, 1 dies
+#define MT29F64G08CBAAA		0x2C88044B	//MLC, 8GB, 1dies
+#define MT29F8G08ABABA		0x2C380026	//Micron 1GB   (SLC single die)
+#define MT29F4G08ABAEA		0x2CDC90A6	//Micron 4Gb  (SLC single die)
+#define MT29F64G08CBABA		0x2C64444B	//Micron 64G	(MLC) 
+#define MT29F32G08CBADA		0x2C44444B	//Micron 32Gb (MLC)
+
+/* STMicorn */
+#define NAND01GW3B2B		0x20F1801D	//SLC, 128 MB, 1 dies
+#define NAND01GW3B2C		0x20F1001D	//SLC, 128 MB, 1 dies, son of NAND01GW3B2B
+#define NAND02GW3B2D		0x20DA1095	//SLC, 256 MB, 1 dies
+#define NAND04GW3B2B		0x20DC8095	//SLC, 512 MB, 1 dies
+#define NAND04GW3B2D		0x20DC1095	//SLC, 512 MB, 1 dies
+#define NAND04GW3C2B		0x20DC14A5	//MLC, 512 MB, 1 dies
+#define NAND08GW3C2B		0x20D314A5	//MLC, 1GB, 1 dies
+
+/* Hynix Nand */
+#define HY27UF081G2A		0xADF1801D	//SLC, 128 MB, 1 dies
+#define HY27UF081G2B		0xADF1801D	//SLC, 128 MB, 1 dies
+
+#define HY27UF082G2A		0xADDA801D	//SLC, 256 MB, 1 dies
+#define HY27UF082G2B		0xADDA1095	//SLC, 256 MB, 1 dies
+#define HY27UF084G2B		0xADDC1095	//SLC, 512 MB, 1 dies
+#define HY27UF084G2M		0xADDC8095	//SLC, 512 MB, 1 dies
+
+/* HY27UT084G2M speed is slower, we have to decrease T1, T2 and T3 */
+#define HY27UT084G2M		0xADDC8425	//MLC, 512 MB, 1 dies, BB check at last page, SLOW nand
+#define HY27UT084G2A		0xADDC14A5	//MLC, 512 MB, 1 dies
+#define H27U4G8T2B		0xADDC14A5	//MLC, 512 MB, 1 dies
+#define HY27UT088G2A		0xADD314A5	//MLC, 1GB, 1 dies, BB check at last page
+#define HY27UG088G5M		0xADDC8095	//SLC, 1GB, 2 dies
+#define HY27UG088G5B		0xADDC1095	//SLC, 1GB, 2 dies
+#define H27U8G8T2B		0xADD314B6	//MLC, 1GB, 1 dies, 4K page
+#define H27UAG8T2A		0xADD59425	//MLC, 2GB, 1 dies, 4K page
+#define H27UAG8T2B		0xADD5949A	//MLC, 2GB, 1 dies, 8K page
+#define H27U2G8F2C		0xADDA9095	//SLC, 256 MB, 1 dies, 2K page
+#define H27U4G8F2D		0xADDC9095	//SLC, 512MB, 1dies, 2K page
+#define H27U1G8F2B		0xADF1001D	//SLC, 128MB, 1dies, 2K page
+#define H27UBG8T2A		0xADD7949A	//MLC, 4GB, 1 dies, 8K page
+#define H27UBG8T2B		0xADD794DA	//MLC, 4GB, 1 dies, 8K page
+#define H27UBG8T2C		0xADD79491	//Hynix 32Gb	(MLC)
+#define H27UCG8T2B		0xADDE94EB	//Hynix 64Gb
+
+/* Samsung Nand */
+#define K9F1G08U0E		0xECF10095	//SLC, 128 MB, 1 dies
+#define K9F1G08U0D		0xECF10015	//SLC, 128 MB, 1 dies
+#define K9F2G08U0B		0xECDA1095	//SLC, 256 MB, 1 dies
+#define K9G4G08U0A		0xECDC1425	//MLC, 512 MB, 1 dies, BB check at last page
+#define K9G4G08U0B		0xECDC14A5	//MLC, 512 MB, 1 dies, BB check at last page
+#define K9F4G08U0B		0xECDC1095	//SLC, 512 MB, 1 dies
+#define K9G8G08U0A		0xECD314A5	//MLC, 1GB, 1 dies, BB check at last page
+#define K9G8G08U0M		0xECD31425	//MLC, 1GB, 1 dies, BB check at last page
+#define K9K8G08U0A		0xECD35195	//SLC, 1GB, 1 dies
+#define K9F8G08U0M		0xECD301A6	//SLC, 1GB, 1 dies, 4K page
+#define K9K8G08U0D		0xECD31195	//SLC, 1GB, 1 dies
+
+/* Toshiba */
+#define TC58NVG0S3C		0x98F19095	//128 MB, 1 dies
+#define TC58NVG0S3E		0x98D19015	//128 MB, 1 dies
+#define TC58NVG1S3C		0x98DA9095	//256 MB, 1 dies
+#define TC58NVG1S3E		0x98DA9015	//256 MB, 1 dies
+#define TC58NVG2S3E		0x98DC9015	//512 MB, 1 dies
+#define TC58NVG5D2F		0x98D79432	//MLC, 4GB, 1 dies, 8K page
+#define TC58NVG4D2E		0x98D59432	//MLC, 2GB, 1 dies, 8K page
+#define TC58NVG2S0HTA00		0x98DC9026	//SLC,512MB 1 dies,4K page
+#define TC58NVG2S0FTA00		0x98D39026	//Toshiba 4Gb  (SLC single die)
+#define TC58NVG5D2H		0x98D79432 
+#define TC58BVG0S3H		0x98F18015	//SLC, 1GB, 1 dies
+#define TC58BVG1S3H		0x98DA9015	//SLC, 2GB, 1 dies
+#define TC58NVG0S3H		0x98F18015	//SLC, 1GB, 1 dies
+#define TC58NVG1S3H		0x98DA9015	//SLC, 2GB, 1 dies
+#define TC58DVG02D5		0x98f10015	//SLC,128MB 1 dies 
+#define TC58TEG5DCJT		0x98D78493	//Toshiba 32Gb (MLC)
+#define TC58TEG6DCJT		0x98DE8493	//Toshiba 64Gb (MLC)
+#define TC58TEG6DDK		0x98DE9493
+#define TH58NVG3S0H		0x98D39126
+
+/* Macronix/MXIC */
+#define MX30LF4G18AC		0xC2DC9095	//512 MB, 1 dies
+#define MX30LF2G18AC		0xC2DA9095	//256 MB, 1 dies
+#define MX30LF1G18AC		0xC2F18095	//128 MB, 1 dies
+#define MX30LF1G08AM		0xC2F1801D	//128 MB, 1 dies
+#define MX30LF1208AA		0xC2F0801D	//64MB, 1 dies
+//#define MX30LF2G28AC		0xC2DA9095	//Macronix 2Gb
+//#define MX30LF4G28AC		0xC2DC9095	//Macronix 4Gb
+#define MX30LF2G28AC		0x9590DAC2	//Macronix 2Gb
+#define MX30LF4G28AC		0x9590DCC2	//Macronix 4Gb
+
+
+#define EN27LN4G08		0xC8DC9095
+
+/* ESMT */
+#define F59L1G81A		0x92F18095
+#define F59L2G81A		0xC8DA9095
+#define F59L4G81A		0xC8DC9095
+
+/*Winbond*/
+#define W29N01GV		0xEFF18095
+#define W29N02GV		0xEFDA9095
+#define W29N04GV		0xEFDC9095
+
+/*MIRA*/
+#define PSU2GA30BT		0xC8DA9095
+#define PSU4GA30AT		0xC8DC9095
+
+/*Spansion*/
+#define S34ML01G1	        0x01F1001D
+#define S34ML02G1	        0x01DA9095
+#define S34ML04G1	        0x01DC9095  
+#define S34ML01G2     		0x01F1801D
+#define S34ML02G2	        0x01DA9095 
+#define S34ML04G2	        0x01DC9095 
+
+/*Zentel*/
+#define A5U2GA31BTS	        0xC8DA9095
+
+/*Power Chip*/
+#define ASU1GA30HT		0x92F18095
+
+typedef struct __attribute__ ((__packed__)){
+        unsigned char   *name;
+        unsigned int    id;
+        uint64_t        size;   //nand total size
+        uint64_t        chipsize;       //die size
+        unsigned int    PageSize;
+        unsigned int    BlockSize;
+        unsigned short  OobSize;
+        unsigned char   num_chips;
+        unsigned char   isLastPage;     //page position of block to check BB
+        unsigned char   CycleID5th; //If CycleID5th do not exist, set it to 0xff
+        unsigned char   CycleID6th; //If CycleID6th do not exist, set it to 0xff
+        unsigned short  ecc_num;
+        unsigned char   T1;
+        unsigned char   T2;
+        unsigned char   T3;
+        unsigned short  eccSelect;//Ecc ability select:   add by alexchang 0319-2010
+} device_type_t;
+
+device_type_t nand_device[] = {
+	{"MT29F2G08AAD", MT29F2G08AAD, 0x10000000, 0x10000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"MT29F2G08ABAE", MT29F2G08ABAE, 0x10000000, 0x10000000, 2048, 64*2048, 64, 1, 0, 0x6, 0xff, 0xff,0x01, 0x01, 0x01, 0x00}, 	
+	{"MT29F1G08ABADA", MT29F1G08ABADA, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff,0x01, 0x01, 0x01, 0x00},	 
+	{"MT29F4G08ABADA", MT29F4G08ABADA, 0x20000000, 0x20000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff,0x01, 0x01, 0x01, 0x00},	  	
+	{"MT29F32G08CBACA", MT29F32G08CBACA, 0x100000000, 0x100000000, 4096, 256*4096, 224, 1, 0, 0xa9, 0xff, 0x18,0x01, 0x01, 0x01, 0x18},	
+	{"MT29F64G08CBAAA", MT29F64G08CBAAA, 0x200000000, 0x200000000, 8192, 256*8192, 448, 1, 0, 0xff, 0xff, 0x18,0x00, 0x00, 0x00, 0x18},	  	
+	{"MT29F8G08ABABA", MT29F8G08ABABA, 0x40000000, 0x40000000, 4096, 128*4096, 224, 1, 0, 0x85, 0xff, 0xff,0x01, 0x01, 0x01, 0x00}, 	 
+	{"MT29F4G08ABAEA", MT29F4G08ABAEA, 0x20000000, 0x20000000, 4096, 128*2048, 64, 1, 0, 0x54, 0xff, 0xff,0x01, 0x01, 0x01, 0x0c},	
+	{"MT29F64G08CBABA", MT29F64G08CBABA, 0x200000000, 0x200000000, 8192, 256*8192, 576, 1, 0, 0xa9, 0xff, 0x28,0x01, 0x01, 0x01, 0x28},
+	{"MT29F32G08CBADA", MT29F32G08CBADA, 0x100000000, 0x100000000, 8192, 256*8192, 744, 1, 0, 0xa9, 0xff, 0x28,0x00, 0x00, 0x00, 0x28},
+	{"NAND01GW3B2B", NAND01GW3B2B, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"NAND01GW3B2C", NAND01GW3B2C, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"NAND02GW3B2D", NAND02GW3B2D, 0x10000000, 0x10000000, 2048, 64*2048, 64, 1, 0, 0x44, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"NAND04GW3B2B", NAND04GW3B2B, 0x20000000, 0x20000000, 2048, 64*2048, 64, 1, 0, 0x20, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"NAND04GW3B2D", NAND04GW3B2D, 0x20000000, 0x20000000, 2048, 64*2048, 64, 1, 0, 0x54, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"NAND04GW3C2B", NAND04GW3C2B, 0x20000000, 0x20000000, 2048, 128*2048, 64, 1, 1, 0x24, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"NAND08GW3C2B", NAND08GW3C2B, 0x40000000, 0x40000000, 2048, 128*2048, 64, 1, 1, 0x34, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"HY27UF081G2A", HY27UF081G2A, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"HY27UF081G2B", HY27UF081G2B, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"HY27UF082G2A", HY27UF082G2A, 0x10000000, 0x10000000, 2048, 64*2048, 64, 1, 0, 0x00, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"HY27UF082G2B", HY27UF082G2B, 0x10000000, 0x10000000, 2048, 64*2048, 64, 1, 0, 0x44, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"HY27UF084G2B", HY27UF084G2B, 0x20000000, 0x20000000, 2048, 64*2048, 64, 1, 0, 0x54, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"HY27UT084G2A", HY27UT084G2A, 0x20000000, 0x20000000, 2048, 128*2048, 64, 1, 1, 0x24, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"H27U4G8T2B", H27U4G8T2B, 0x20000000, 0x20000000, 2048, 128*2048, 64, 1, 1, 0x24, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"HY27UT088G2A", HY27UT088G2A, 0x40000000, 0x40000000, 2048, 128*2048, 64, 1, 1, 0x34, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"HY27UF084G2M", HY27UF084G2M, 0x20000000, 0x20000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"HY27UT084G2M", HY27UT084G2M, 0x20000000, 0x20000000, 2048, 128*2048, 64, 1, 1, 0xff, 0xff, 0xff, 0x04, 0x04, 0x04, 0x00},
+	{"HY27UG088G5M", HY27UG088G5M, 0x40000000, 0x20000000, 2048, 64*2048, 64, 2, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"HY27UG088G5B", HY27UG088G5B, 0x40000000, 0x20000000, 2048, 64*2048, 64, 2, 0, 0x54, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"H27U8G8T2B", H27U8G8T2B, 0x40000000, 0x40000000, 4096, 128*4096, 128, 1, 1, 0x34, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"H27UAG8T2A", H27UAG8T2A, 0x80000000, 0x80000000, 4096, 128*4096, 224, 1, 1, 0x44, 0x41, 0x18, 0x01, 0x01, 0x01, 0x0c},
+	{"H27UAG8T2B", H27UAG8T2B, 0x80000000, 0x80000000, 8192, 256*8192, 448, 1, 1, 0x74, 0x42, 0x18, 0x01, 0x01, 0x01, 0x18},
+	{"H27U2G8F2C", H27U2G8F2C, 0x10000000, 0x10000000, 2048, 64*2048, 64, 1, 1, 0x44, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00}, 	 
+	{"H27U4G8F2D", H27U4G8F2D, 0x20000000, 0x20000000, 2048, 64*2048, 64, 1, 1, 0x54, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},  	
+	{"H27U1G8F2B", H27U1G8F2B, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},  	
+	{"H27UBG8T2A", H27UBG8T2A, 0x100000000, 0x100000000, 8192, 256*8192, 448, 1, 1, 0x74, 0x42, 0x18, 0x01, 0x01, 0x01, 0x18},
+	{"H27UBG8T2B", H27UBG8T2B, 0x100000000, 0x100000000, 8192, 256*8192, 448, 1, 1, 0x74, 0xc3, 0x18, 0x01, 0x01, 0x01, 0x18}, 	 
+	{"H27UBG8T2C", H27UBG8T2C, 0x100000000, 0x100000000, 8192, 256*8192, 640, 1, 0, 0x60, 0x44, 0x28, 0x01, 0x01, 0x01, 0x28},
+	{"H27UCG8T2B", H27UCG8T2B, 0x200000000, 0x200000000, 16384, 256*16384, 1280, 1, 0, 0x74, 0x44, 0x28, 0x01, 0x01, 0x01, 0x28},
+	{"K9F1G08U0E", K9F1G08U0E, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0x41, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"K9F1G08U0D", K9F1G08U0D, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0x40, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"K9F2G08U0B", K9F2G08U0B, 0x10000000, 0x10000000, 2048, 64*2048, 64, 1, 0, 0x44, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"K9G4G08U0A", K9G4G08U0A, 0x20000000, 0x20000000, 2048, 128*2048, 64, 1, 1, 0x54, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"K9G4G08U0B", K9G4G08U0B, 0x20000000, 0x20000000, 2048, 128*2048, 64, 1, 1, 0x54, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"K9F4G08U0B", K9F4G08U0B, 0x20000000, 0x20000000, 2048, 64*2048, 64, 1, 0, 0x54, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"K9G8G08U0A", K9G8G08U0A, 0x40000000, 0x40000000, 2048, 128*2048, 64, 1, 1, 0x64, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"K9G8G08U0M", K9G8G08U0M, 0x40000000, 0x40000000, 2048, 128*2048, 64, 1, 1, 0x64, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"K9K8G08U0A", K9K8G08U0A, 0x40000000, 0x40000000, 2048, 64*2048, 64, 1, 0, 0x58, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"K9F8G08U0M", K9F8G08U0M, 0x40000000, 0x40000000, 4096, 64*4096, 128, 1, 0, 0x64, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"K9K8G08U0D", K9K8G08U0D, 0x40000000, 0x40000000, 2048, 64*2048, 64, 1, 0, 0x58, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00}, 	
+	{"TC58NVG0S3C", TC58NVG0S3C, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"TC58NVG0S3E", TC58NVG0S3E, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0x76, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"TC58NVG1S3C", TC58NVG1S3C, 0x10000000, 0x10000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"TC58NVG2S3E", TC58NVG2S3E, 0x20000000, 0x20000000, 2048, 64*2048, 64, 1, 0, 0x76, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"TC58NVG5D2F", TC58NVG5D2F, 0x100000000, 0x100000000, 8192, 128*8192, 448, 1, 1, 0x76, 0x55, 0x18, 0x01, 0x01, 0x01, 0x18},
+	{"TC58NVG4D2E", TC58NVG4D2E, 0x80000000, 0x80000000, 8192, 128*8192, 448, 1, 1, 0x76, 0x55, 0x18, 0x01, 0x01, 0x01, 0x18},
+	{"TC58NVG2S0HTA00", TC58NVG2S0HTA00, 0x20000000, 0x20000000, 4096, 128*2048, 64, 1, 0, 0x76, 0xff, 0xff, 0x01, 0x01, 0x01, 0x0c},
+	{"TC58NVG2S0FTA00", TC58NVG2S0FTA00, 0x20000000, 0x20000000, 4096, 64*4096, 128, 1, 0, 0x76, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"TC58TEG5DCJT", TC58TEG5DCJT, 0x100000000, 0x100000000, 16384, 256*16384, 1280, 1, 0, 0x72, 0x57, 0x28, 0x01, 0x01, 0x01, 0x28},
+	{"TC58TEG6DCJT", TC58TEG6DCJT, 0x200000000, 0x200000000, 16384, 256*16384, 1280, 1, 0, 0x72, 0x57, 0x28, 0x01, 0x01, 0x01, 0x28},
+	{"TC58TEG6DDK", TC58TEG6DDK, 0x200000000, 0x200000000, 16384, 256*16384, 1280, 1, 0, 0x76, 0x50, 0x28, 0x01, 0x01, 0x01, 0x28},
+	{"TC58NVG5D2H", TC58NVG5D2H, 0x20000000, 0x20000000, 8192, 128*8192, 80, 1, 0, 0x76, 0x56, 0x18, 0x01, 0x01, 0x01, 0x18},
+	{"TC58BVG0S3H", TC58BVG0S3H, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0xF2, 0x16, 0xff, 0x01, 0x01, 0x01, 0x0c},
+	{"TC58BVG1S3H", TC58BVG1S3H, 0x10000000, 0x10000000, 2048, 128*1024,   64, 1, 0, 0xF6, 0x16, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"TH58NVG3S0H", TH58NVG3S0H, 0x40000000, 0x40000000, 4096, 256*1024, 1280, 1, 0, 0x76, 0xFF, 0xff, 0x01, 0x01, 0x01, 0x01},
+	{"TC58NVG0S3H", TC58NVG0S3H, 0x8000000, 0x8000000, 2048, 64*2048, 128, 1, 0, 0x72, 0x16, 0xff, 0x01, 0x01, 0x01, 0x0c},
+	{"TC58NVG1S3H", TC58NVG1S3H, 0x10000000, 0x10000000, 2048, 64*2048, 128, 1, 0, 0x76, 0x16, 0xff, 0x01, 0x01, 0x01, 0x0c},
+	{"TC58NVG1S3E", TC58NVG1S3E, 0x10000000, 0x10000000, 2048, 64*2048, 64, 1, 0, 0x76, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00}, 
+	{"TC58DVG02D5", TC58DVG02D5, 0x8000000, 0x8000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},	
+	{"W29N01GV", W29N01GV, 0x8000000, 0x8000000, 2048,  64*2048, 64, 1, 0, 0x0, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"W29N02GV", W29N02GV, 0x10000000, 0x10000000, 2048,  64*2048, 64, 1, 0, 0x4, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"W29N04GV", W29N04GV, 0x20000000, 0x20000000, 2048,  64*2048, 64, 1, 0, 0x54, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"MX30LF4G18AC", MX30LF4G18AC, 0x20000000, 0x20000000, 2048,  64*2048, 64, 1, 0, 0x57, 0x00, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"MX30LF2G18AC", MX30LF2G18AC, 0x10000000, 0x10000000, 2048,  64*2048, 64, 1, 0, 0x07, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"MX30LF1G18AC", MX30LF1G18AC, 0x8000000, 0x8000000, 2048,  64*2048, 64, 1, 0, 0x02, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"MX30LF1G08AM", MX30LF1G08AM, 0x8000000, 0x8000000, 2048,  64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"MX30LF1208AA", MX30LF1208AA, 0x4000000, 0x4000000, 2048,  64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},	
+	{"MX30LF2G28AC", MX30LF2G28AC, 0x10000000, 0x10000000, 2048,  64*2048, 64, 1, 0, 0x07, 0xff, 0xff, 0x01, 0x01, 0x01, 0x01},	
+	{"MX30LF4G28AC", MX30LF4G28AC, 0x20000000, 0x20000000, 2048,  64*2048, 64, 1, 0, 0x67, 0xff, 0xff, 0x01, 0x01, 0x01, 0x01},	
+	{"F59L1G81A", F59L1G81A, 0x8000000, 0x8000000, 2048,  64*2048, 64, 1, 0, 0x40, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},	   
+	{"F59L2G81A", F59L2G81A, 0x10000000, 0x10000000, 2048,  64*2048, 64, 1, 0, 0x44, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"EN27LN4G08", EN27LN4G08, 0x20000000, 0x20000000, 2048,  64*2048, 64, 1, 0, 0x54, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00}, 	
+	{"S34ML01G1",S34ML01G1, 0x8000000,  0x8000000,  2048,  64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"S34ML02G1",S34ML02G1, 0x10000000, 0x10000000, 2048,  64*2048, 64, 1, 0, 0x44, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},
+	{"S34ML04G1",S34ML04G1, 0x20000000, 0x20000000, 2048,  64*2048, 64, 1, 0, 0x54, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},                
+	{"S34ML01G2",S34ML01G2, 0x8000000,  0x8000000,  2048,  64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00},
+	{"S34ML02G2",S34ML02G2, 0x10000000, 0x10000000, 2048,  64*2048, 64, 1, 0, 0x46, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00},
+	{"S34ML04G2",S34ML04G2, 0x20000000, 0x20000000, 2048,  64*2048, 64, 1, 0, 0x56, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00},
+	{"A5U2GA31BTS", A5U2GA31BTS, 0x10000000, 0x10000000, 2048, 64*2048, 64, 1, 0, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00}, 
+	{"ASU1GA30HT", ASU1GA30HT, 0x4000000, 0x4000000, 2048,  64*2048, 64, 1, 0, 0x40, 0xff, 0xff, 0x01, 0x01, 0x01, 0x00},	 
+	{NULL, }
+};
+
diff --git a/include/linux/mtd/rtk_nand_reg.h b/include/linux/mtd/rtk_nand_reg.h
new file mode 100644
index 00000000..5589f85
--- /dev/null
+++ b/include/linux/mtd/rtk_nand_reg.h
@@ -0,0 +1,361 @@
+/*
+ * rtk_nand_reg.h - nand driver
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ */
+
+
+#ifndef __NAND_REG_H
+#define __NAND_REG_H
+//========================================================================
+
+//CRT registers for NAND driver
+#define REG_CLOCK_ENABLE1			(0xc)		// 23: Clock enable bit for NAND
+//#define REG_MUXPAD7				(0xb800036c)
+#define REG_NF_CKSEL				(0x38)
+
+//===================================================================
+//NAND flash register definition
+#define REG_DDR_BASE_ADDR			(0x80000000)
+//#define REG_NF_BASE_ADDR			(0x9801f000)
+#define REG_NF_BASE_ADDR			(0x0)
+#define REG_NF_SWC_BASE_ADDR			(0x9802f000)
+
+#define REG_ND_PA0				( REG_NF_BASE_ADDR + 0 ) 	//Page address 0 [7:0]
+#define	REG_ND_PA1				( REG_NF_BASE_ADDR + 0x4 )	//Page address 1 [15:8]
+#define	REG_ND_PA2				( REG_NF_BASE_ADDR + 0x8 )	//Page address 2 [20:16]
+#define	REG_ND_CA0				( REG_NF_BASE_ADDR + 0xc )	//Column address 0 [7:0]
+#define	REG_ND_CMD				( REG_NF_BASE_ADDR + 0x10 )	//Command [7:0]
+#define	REG_ND_DAT				( REG_NF_BASE_ADDR + 0x14 )	//NAND Data[7:0](Status_0)
+#define	REG_ND_CTL				( REG_NF_BASE_ADDR + 0x18 )	//NAND control register
+#define	REG_CMD3				( REG_NF_BASE_ADDR + 0x28 )	//CMD3 is the third command that would be transfer out by auto mode case 0/1/2
+#define	REG_ND_PA3				( REG_NF_BASE_ADDR + 0x2c )	//Page address 3 [23:21]
+#define REG_POLL_FSTS				( REG_NF_BASE_ADDR + 0x30 )	//Polling nand flash status
+#define REG_BLANK_CHK				( REG_NF_BASE_ADDR + 0x34 )	//Enable blank check function
+#define REG_ND_ECC				( REG_NF_BASE_ADDR + 0x38 )	//Indicate ECC status
+#define	REG_ND_CA1				( REG_NF_BASE_ADDR + 0x3c )	//Column address [15:8]
+#define	REG_DATA_TL0				( REG_NF_BASE_ADDR + 0x100 )	//Data transfer count [7:0]...
+#define	REG_DATA_TL1				( REG_NF_BASE_ADDR + 0x104 )	//Data transfer count [13:8]...
+#define REG_DMA1_CTL				( REG_NF_BASE_ADDR + 0x10c )	//DMA1 control register
+#define REG_PP_CTL0				( REG_NF_BASE_ADDR + 0x110 )	//Ping-Pong buffer control register
+#define REG_ECC_SEL				( REG_NF_BASE_ADDR + 0x128 )
+#define REG_PP_CTL1				( REG_NF_BASE_ADDR + 0x12c )	//PP starting address [7:0], this filedspecifies the starting address of the Ping-Pong buffer to put the data
+#define	REG_PD					( REG_NF_BASE_ADDR + 0x130 )	//PDx. Flash Chip Enable Output
+#define REG_NF_LOW_PWR				( REG_NF_BASE_ADDR + 0x13c )    //NF_LOW_PWR
+#define REG_NF_SWC_LOW_PWR			( REG_NF_SWC_BASE_ADDR + 0x13c )//SWC NF_LOW_PWR
+#define REG_DUMMY_NF1				( REG_NF_BASE_ADDR + 0x158 )	//NF clock dummy bit
+#define REG_DUMMY_NF2				( REG_NF_BASE_ADDR + 0x15c )	//NF clock dummy bit
+#define REG_DUMMY_NF3				( REG_NF_BASE_ADDR + 0x160 )	//NF clock dummy bit
+#define REG_DUMMY_NF4				( REG_NF_BASE_ADDR + 0x164 )	//NF clock dummy bit
+#define REG_AUTO_TRIG				( REG_NF_BASE_ADDR + 0x200 )	//Auto trigger register control
+#define REG_RSECC_NUM				( REG_NF_BASE_ADDR + 0x204 )	//ECC_NUM RS ECC error symbol count.
+#define REG_READ_BY_PP				( REG_NF_BASE_ADDR + 0x228 )	//Setting data read to DRAM from NAND through by PP or not
+#define REG_MAX_ECC_NUM				( REG_NF_BASE_ADDR + 0x22c )	//Auto mode(Mode 000) read status 
+#define REG_TIME_PARA3				( REG_NF_BASE_ADDR + 0x234 )	//NAND flash AC timming setting
+#define REG_TIME_PARA2				( REG_NF_BASE_ADDR + 0x238 )	//NAND flash AC timming setting
+#define REG_TIME_PARA1				( REG_NF_BASE_ADDR + 0x23c )	//NAND flash AC timming setting
+#define REG_PIN_MUX_STOP			( REG_NF_BASE_ADDR + 0x25c )	//Enable Pin_Mux_Stop function
+#define REG_DELAY_CTL				( REG_NF_BASE_ADDR + 0x260 )    //Flash timing delay clock number control
+#define	REG_ECC_STOP				( REG_NF_BASE_ADDR + 0x264 )	//Data read from NAND to SRAM don't stop transfer when ECC error occurs 
+#define	REG_ECC_PAGE				( REG_NF_BASE_ADDR + 0x268 )	//Used in data reading from NAND flash to TBRAM, and ECC_N_STOP was set.
+#define	REG_PAGE_CNT				( REG_NF_BASE_ADDR + 0x26c )	//Data page count that had been transferred.
+#define	REG_PAGE_LEN				( REG_NF_BASE_ADDR + 0x270 )	//Set the data length would be transferred by auto mode.
+#define	REG_CMD2				( REG_NF_BASE_ADDR + 0x274 )	//This is the secone command that would be transfer out by auto mode case 0/1/2.
+#define	REG_MULTI_CHNL_MODE			( REG_NF_BASE_ADDR + 0x27c )	//Multi-channel control register
+#define REG_SRAM_CTL				( REG_NF_BASE_ADDR + 0x300 )	//SRAM control register
+#define	REG_DMA_CTL1				( REG_NF_BASE_ADDR + 0x304 )	//DRAM start address for DMA transfer.
+#define	REG_DMA_CTL2				( REG_NF_BASE_ADDR + 0x308 )    //Transfer length for DMA transfer between DMA buffer and DDR.(512B Unit)
+#define	REG_DMA_CTL3				( REG_NF_BASE_ADDR + 0x30c )	//Set to control data transfer between DRAM and DMA buffer.
+#define	REG_NAND_ISR				( REG_NF_BASE_ADDR + 0x324 )	//NAND ISR status register
+#define	REG_NAND_ISREN				( REG_NF_BASE_ADDR + 0x328 )	//NAND ISR enable register
+#define	REG_DUMMY_SYS				( REG_NF_BASE_ADDR + 0x32c )	//Dummy
+#define	REG_DBG					( REG_NF_BASE_ADDR + 0x344 )	
+#define	REG_SPR_DDR_CTL				( REG_NF_BASE_ADDR + 0x348 )	
+#define	REG_CP_LEN				( REG_NF_BASE_ADDR + 0x34C )	
+
+#define	REG_RND_CMD1				(REG_NF_BASE_ADDR + 0x208)
+#define	REG_RND_CMD2				(REG_NF_BASE_ADDR + 0x20c)
+#define	REG_RND_DATA_STR_COL_H			(REG_NF_BASE_ADDR + 0x210)
+#define	REG_RND_SPR_STR_COL_H			(REG_NF_BASE_ADDR + 0x214)
+#define REG_RND_SPR_STR_COL_L			(REG_NF_BASE_ADDR + 0x218)
+#define	REG_RND_EN				(REG_NF_BASE_ADDR + 0x21c)
+
+#define REG_RMZ_CTRL				(REG_NF_BASE_ADDR + 0x240)
+#define REG_RMZ_SEED_L				(REG_NF_BASE_ADDR + 0x244)
+#define REG_RMZ_SEED_H				(REG_NF_BASE_ADDR + 0x248)
+
+
+/*
+ * Defines for the CP.
+ */
+#define REG_CP_BASE_ADDR			(0x18015000)
+#define REG_MCP_CTRL				(REG_CP_BASE_ADDR+0x100)
+#define REG_MCP_STATUS				(REG_CP_BASE_ADDR+0x104)
+#define REG_MCP_EN				(REG_CP_BASE_ADDR+0x108)
+#define REG_MCP_CTRL1				(REG_CP_BASE_ADDR+0x198)
+#define REG_MCP_BASE				(REG_CP_BASE_ADDR+0x10C)
+#define REG_MCP_LIMIT				(REG_CP_BASE_ADDR+0x110)
+#define REG_MCP_RDPTR				(REG_CP_BASE_ADDR+0x114)
+#define REG_MCP_WRPTR				(REG_CP_BASE_ADDR+0x118)
+#define REG_MCP_DES_COUNT			(REG_CP_BASE_ADDR+0x134)
+#define REG_MCP_DES_COMPARE			(REG_CP_BASE_ADDR+0x138)
+#define REG_MCP_DES_INI_KEY			(REG_CP_BASE_ADDR+0x11C)
+#define REG_MCP_AES_INI_KEY			(REG_CP_BASE_ADDR+0x124)
+#define REG_MCP_MULTI2_SYS_KEY			(REG_CP_BASE_ADDR+0x178)
+#define REG_OTP_LOAD				(REG_CP_BASE_ADDR+0x19C)
+#define REG_K_MCP_CTRL				(REG_CP_BASE_ADDR+0x900)
+#define REG_K_MCP_STATUS			(REG_CP_BASE_ADDR+0x904)
+#define REG_K_MCP_EN				(REG_CP_BASE_ADDR+0x908)
+#define REG_K_MCP_CTRL1				(REG_CP_BASE_ADDR+0x998)
+#define REG_K_MCP_BASE				(REG_CP_BASE_ADDR+0x90C)
+#define REG_K_MCP_LIMIT				(REG_CP_BASE_ADDR+0x910)
+#define REG_K_MCP_RDPTR				(REG_CP_BASE_ADDR+0x914)
+#define REG_K_MCP_WRPTR				(REG_CP_BASE_ADDR+0x918)
+#define REG_K_MCP_DES_COUNT			(REG_CP_BASE_ADDR+0x934)
+#define REG_K_MCP_DES_COMPARE			(REG_CP_BASE_ADDR+0x938)
+#define REG_K_MCP_DES_INI_KEY			(REG_CP_BASE_ADDR+0x91C)
+#define REG_K_MCP_AES_INI_KEY			(REG_CP_BASE_ADDR+0x924)
+#define REG_K_MCP_MULTI2_SYS_KEY		(REG_CP_BASE_ADDR+0x978)
+#define REG_CP_REG_KEY				(REG_CP_BASE_ADDR+0x034)
+#define REG_CP_REG_DATAIN			(REG_CP_BASE_ADDR+0x044)	
+#define REG_CP_REG_DATAOUT			(REG_CP_BASE_ADDR+0x054)
+#define REG_CP_REG_IV				(REG_CP_BASE_ADDR+0x064)
+#define REG_CP_REG_SET				(REG_CP_BASE_ADDR+0x074)
+#define REG_CP_REG_SET1				(REG_CP_BASE_ADDR+0x078)
+#define REG_CP_REG_SET2				(REG_CP_BASE_ADDR+0x07C)
+#define REG_TP_KEY_INFO				(0x18014058)
+#define REG_TP_KEY_CTRL				(0x18014060)
+#define REG_CP_SCTCH				(REG_CP_BASE_ADDR+0x080)
+#define REG_CP_NF_KEY				(REG_CP_BASE_ADDR+0x084)
+#define REG_CP_NF_INI_KEY			(REG_CP_BASE_ADDR+0x094)
+#define REG_CP_NF_SET				(REG_CP_BASE_ADDR+0x0A4)
+#define REG_CP_MD_KEY				(REG_CP_BASE_ADDR+0x0A8)
+#define REG_CP_MD_INI_KEY			(REG_CP_BASE_ADDR+0x0B8)
+#define REG_CP_MD_SET				(REG_CP_BASE_ADDR+0x0C8)
+#define REG_K_CP_REG_KEY			(REG_CP_BASE_ADDR+0x834)
+#define REG_K_CP_REG_DATAIN			(REG_CP_BASE_ADDR+0x844)
+#define REG_K_CP_REG_DATAOUT			(REG_CP_BASE_ADDR+0x854)
+#define REG_K_CP_REG_IV				(REG_CP_BASE_ADDR+0x864)
+#define REG_K_CP_REG_SET			(REG_CP_BASE_ADDR+0x874)
+#define REG_K_CP_REG_SET1			(REG_CP_BASE_ADDR+0x878)
+#define REG_K_CP_REG_SET2			(REG_CP_BASE_ADDR+0x87C)
+#define REG_CP_DBG				(REG_CP_BASE_ADDR+0x0CC)
+#define REG_MCP_ST				(REG_CP_BASE_ADDR+0x1A0)
+
+
+#define CP_NF_SET				(REG_NF_BASE_ADDR + 0x50a4)
+
+#define CP_NF_INI_KEY_0				(REG_NF_BASE_ADDR + 0x5094)
+#define CP_NF_INI_KEY_1				(REG_NF_BASE_ADDR + 0x5098)
+#define CP_NF_INI_KEY_2				(REG_NF_BASE_ADDR + 0x509c)
+#define CP_NF_INI_KEY_3				(REG_NF_BASE_ADDR + 0x50a0)
+
+#define CP_NF_KEY_0				(REG_NF_BASE_ADDR + 0x5084)
+#define CP_NF_KEY_1				(REG_NF_BASE_ADDR + 0x5088)
+#define CP_NF_KEY_2				(REG_NF_BASE_ADDR + 0x508c)
+#define CP_NF_KEY_3				(REG_NF_BASE_ADDR + 0x5090)
+
+#define CP_NF_NONE				0
+#define CP_NF_AES_ECB_128			1
+#define CP_NF_AES_CBC_128			2
+
+//===================================================================
+//#define REG_ND_PA0				( REG_NF_BASE_ADDR + 0 ) 	//Page address 0 [7:0]
+#define NF_ND_PA0_page_addr0(value)		(0x000000FF&((value)<<0))
+
+//#define REG_ND_PA1				( REG_NF_BASE_ADDR + 0x4 )	//Page address 1 [15:8]
+#define NF_ND_PA1_page_addr1(value)		(0x000000FF&((value)<<0))
+
+//#define REG_ND_PA2				( REG_NF_BASE_ADDR + 0x8 )	//Page address 2 [20:16]
+#define NF_ND_PA2_addr_mode(value)		(0x000000E0&((value)<<5))
+#define NF_ND_PA2_page_addr2(value)		(0x0000001F&((value)<<0))
+
+//#define REG_ND_CA0				( REG_NF_BASE_ADDR + 0xc )	//Column address 0 [7:0]
+#define NF_ND_CA0_col_addr0(value)		(0x000000FF&((value)<<0))
+
+//#define REG_ND_CMD				( REG_NF_BASE_ADDR + 0x10 )	//Command [7:0]
+#define NF_ND_CMD_cmd(value)			(0x000000FF&((value)<<0))
+
+//#define REG_ND_DAT				( REG_NF_BASE_ADDR + 0x14 )	//NAND Data[7:0](Status_0)
+#define NF_ND_DAT_dat(value)			(0x000000FF&((value)<<0))
+
+//#define REG_ND_CTL				( REG_NF_BASE_ADDR + 0x18 )	//NAND control register
+#define NF_ND_CTL_xfer(value)			(0x00000080&((value)<<7))
+#define NF_ND_CTL_ready_busy(value)		(0x00000040&((value)<<6))
+#define NF_ND_CTL_ecc_tran(value)		(0x00000020&((value)<<5))
+#define NF_ND_CTL_ecc_enable(value)		(0x00000008&((value)<<3))
+#define NF_ND_CTL_tran_mode(value)		(0x00000007&((value)<<0))
+
+//#define REG_CMD3				( REG_NF_BASE_ADDR + 0x28 )	//CMD3 is the third command that would be transfer out by auto mode case 0/1/2
+#define NF_CMD3_cmd3(value)			(0x000000FF&((value)<<0))
+
+//#define REG_ND_PA3				( REG_NF_BASE_ADDR + 0x2c )	//Page address 3 [23:21]
+#define NF_ND_PA3_page_addr3(value)		(0x000000E0&((value)<<5))
+
+//#define REG_POLL_FSTS				( REG_NF_BASE_ADDR + 0x30 )	//Polling nand flash status
+#define NF_POLL_FSTS_bit_sel(value)		(0x0000000E&((value)<<1))
+#define NF_POLL_FSTS_trig_poll(value)		(0x00000001&((value)<<0))
+
+//#define REG_BLANK_CHK				( REG_NF_BASE_ADDR + 0x34 )	//Enable blank check function
+#define NF_BLANK_CHK_read_ecc_xnor_ena(value)	(0x00000004&((value)<<2))
+#define NF_BLANK_CHK_blank_all_one(value)	(0x00000002&((value)<<1))
+#define NF_BLANK_CHK_blank_ena(value)		(0x00000001&((value)<<0))
+
+//#define REG_ND_ECC				( REG_NF_BASE_ADDR + 0x38 )	//Indicate ECC status
+#define NF_ND_ECC_ecc_not_clr(value)		(0x00000008&((value)<<3))
+#define NF_ND_ECC_ecc_err(value)		(0x00000004&((value)<<2))
+
+//#define REG_ND_CA1				( REG_NF_BASE_ADDR + 0x3c )	//Column address [15:8]
+#define NF_ND_CA1_col_addr1(value)		(0x000000FF&((value)<<0))
+
+//#define REG_DATA_TL0				( REG_NF_BASE_ADDR + 0x100 )	//Data transfer count [7:0]...
+#define NF_DATA_TL0_length0(value)		(0x000000FF&((value)<<0))
+
+//#define REG_DATA_TL1				( REG_NF_BASE_ADDR + 0x104 )	//Data transfer count [13:8]...
+#define NF_DATA_TL1_access_mode(value)		(0x00000080&((value)<<7))
+#define NF_DATA_TL1_sram_path(value)		(0x00000040&((value)<<6))
+#define NF_DATA_TL1_length1(value)		(0x0000003F&((value)<<0))
+
+//#define REG_DMA1_CTL				( REG_NF_BASE_ADDR + 0x10c )	//DMA1 control register
+#define NF_DMA1_CTL_eot_gen(value)		(0x00000008&((value)<<3))
+#define NF_DMA1_CTL_dma_max_pkt(value)		(0x00000004&((value)<<2))
+#define NF_DMA1_CTL_spec_pkt(value)		(0x00000002&((value)<<1))
+
+//#define REG_PP_CTL0				( REG_NF_BASE_ADDR + 0x110 )	//Ping-Pong buffer control register
+#define NF_PP_CTL0_pp_start_addr(value)		(0x00000030&((value)<<4))
+#define NF_PP_CTL0_pp_busy(value)		(0x00000004&((value)<<2))
+#define NF_PP_CTL0_pp_reset(value)		(0x00000002&((value)<<1))
+#define NF_PP_CTL0_pp_enable(value)		(0x00000001&((value)<<0))
+
+//#define REG_ECC_SEL				( REG_NF_BASE_ADDR + 0x128 )
+#define NF_ECC_SEL_ecc_bch_24b_ena(value)       (0x00000002&((value)<<1))
+#define NF_ECC_SEL_ecc_bch_12b_ena(value)       (0x00000001&((value)<<0))
+
+//#define REG_PP_CTL1				( REG_NF_BASE_ADDR + 0x12c )	//PP starting address [7:0], this filedspecifies the starting address of the Ping-Pong buffer to put the data
+#define NF_PP_CTL1_pp_start_addr(value)		(0x000000FF&((value)<<0))
+
+//#define REG_PD				( REG_NF_BASE_ADDR + 0x130 )	//PDx. Flash Chip Enable Output
+#define NF_PD_pd(value)				(0x0000001F&((value)<<0))
+
+//#define REG_DUMMY_NF1				( REG_NF_BASE_ADDR + 0x158 )	//NF clock dummy bit
+#define NF_DUMMY_NF1_Dmy1(value)		(0x000000FF&((value)<<0))
+
+//#define REG_DUMMY_NF2				( REG_NF_BASE_ADDR + 0x15c )	//NF clock dummy bit
+#define NF_DUMMY_NF2_Dmy2(value)		(0x000000FF&((value)<<0))
+
+//#define REG_DUMMY_NF3				( REG_NF_BASE_ADDR + 0x160 )	//NF clock dummy bit
+#define NF_DUMMY_NF3_Dmy3(value)		(0x000000FF&((value)<<0))
+
+//#define REG_DUMMY_NF4				( REG_NF_BASE_ADDR + 0x164 )	//NF clock dummy bit
+#define NF_DUMMY_NF4_Dmy4(value)		(0x000000FF&((value)<<0))
+
+//#define REG_AUTO_TRIG				( REG_NF_BASE_ADDR + 0x200 )	//Auto trigger register control
+#define NF_AUTO_TRIG_auto_trig(value)		(0x00000080&((value)<<7))
+#define NF_AUTO_TRIG_addr_fbd(value)		(0x00000040&((value)<<6))
+#define NF_AUTO_TRIG_pp_empty(value)		(0x00000020&((value)<<5))
+#define NF_AUTO_TRIG_spec_auto_case(value)	(0x00000018&((value)<<3))
+#define NF_AUTO_TRIG_auto_case(value)		(0x00000007&((value)<<0))
+
+//#define REG_RSECC_NUM				( REG_NF_BASE_ADDR + 0x204 )	//ECC_NUM RS ECC error symbol count.
+#define NF_RSECC_NUM_ecc_num(value)		(0x00000001F&((value)<<0))
+
+//#define REG_READ_BY_PP			( REG_NF_BASE_ADDR + 0x228 )	//Setting data read to DRAM from NAND through by PP or not
+#define NF_READ_BY_PP_read_by_pp(value)		(0x00000080&((value)<<7))
+
+//#define REG_MAX_ECC_NUM			( REG_NF_BASE_ADDR + 0x22c )	//Auto mode(Mode 000) read status 
+#define REG_MAX_ECC_NUM_max_ecc_num(value)	(0x00000001F&((value)<<0))
+
+//#define REG_TIME_PARA3			( REG_NF_BASE_ADDR + 0x234 )	//NAND flash AC timming setting
+#define NF_TIME_PARA3_T3(value)			(0x000000FF&((value)<<0))
+
+//#define REG_TIME_PARA2			( REG_NF_BASE_ADDR + 0x238 )	//NAND flash AC timming setting
+#define NF_TIME_PARA2_T2(value)			(0x000000FF&((value)<<0))
+
+//#define REG_TIME_PARA1			( REG_NF_BASE_ADDR + 0x23c )	//NAND flash AC timming setting
+#define NF_TIME_PARA1_T1(value)			(0x000000FF&((value)<<0))
+
+//#define REG_PIN_MUX_STOP			( REG_NF_BASE_ADDR + 0x25c )	//Enable Pin_Mux_Stop function
+#define NF_PIN_MUX_STOP_pin_stop(value)         (0x00000004&((value)<<2))
+#define NF_PIN_MUX_STOP_intlev_pin_ena(value)   (0x00000002&((value)<<1))
+#define NF_PIN_MUX_STOP_pin_mux_enae(value)     (0x00000001&((value)<<0))
+
+//#define REG_DELAY_CTL				( REG_NF_BASE_ADDR + 0x260 )    //Flash timing delay clock number control
+#define NF_DELAY_CTL_T_swait_busy(value)	(0x000000C0&((value)<<6))
+#define NF_DELAY_CTL_T_WHR_ADL(value)		(0x0000003F&((value)<<0))
+
+//#define REG_ECC_STOP				( REG_NF_BASE_ADDR + 0x264 )	//Data read from NAND to SRAM don't stop transfer when ECC error occurs 
+#define NF_ECC_STOP_ecc_n_stop(value)		(0x00000080&((value)<<7))
+
+//#define REG_ECC_PAGE				( REG_NF_BASE_ADDR + 0x268 )	//Used in data reading from NAND flash to TBRAM, and ECC_N_STOP was set.
+#define NF_ECC_PAGE_ecc_page(value)		(0x000000FF&((value)<<0))
+
+//#define REG_PAGE_CNT				( REG_NF_BASE_ADDR + 0x26c )	//Data page count that had been transferred.
+#define NF_PAGE_CNT_page_cnt(value)		(0x000000FF&((value)<<0))
+
+//#define REG_PAGE_LEN				( REG_NF_BASE_ADDR + 0x270 )	//Set the data length would be transferred by auto mode.
+#define NF_PAGE_LEN_page_len(value)		(0x000000FF&((value)<<0))
+
+//#define REG_CMD2				( REG_NF_BASE_ADDR + 0x274 )	//This is the secone command that would be transfer out by auto mode case 0/1/2.
+#define NF_CMD2_cmd2(value)			(0x000000FF&((value)<<0))
+
+//#define REG_MULTI_CHNL_MODE			( REG_NF_BASE_ADDR + 0x27c )	//Multi-channel control register
+#define NF_MULTI_CHNL_MODE_ecc_pass(value)      (0x00000080&((value)<<7))
+#define NF_MULTI_CHNL_MODE_ecc_no_check(value)  (0x00000040&((value)<<6))
+#define NF_MULTI_CHNL_MODE_edo(value)           (0x00000020&((value)<<5))
+#define NF_MULTI_CHNL_MODE_no_wait_busy(value)  (0x00000010&((value)<<4))
+#define NF_MULTI_CHNL_MODE_wait_ready(value)    (0x0000000C&((value)<<2))
+#define NF_MULTI_CHNL_MODE_multi_chnl_md(value) (0x00000003&((value)<<0))
+
+#define REG_SRAM_CTL				( REG_NF_BASE_ADDR + 0x300 )	//SRAM control register
+#define NF_SRAM_CTL_map_sel(value)		(0x00000020&((value)<<5))
+#define NF_SRAM_CTL_access_en(value)		(0x00000010&((value)<<4))
+#define NF_SRAM_CTL_mem_region(value)		(0x0000000F&((value)<<0))
+
+//#define REG_DMA_CTL1				( REG_NF_BASE_ADDR + 0x304 )	//DRAM start address for DMA transfer.
+#define NF_DMA_CTL1_dram_sa(value)		(0x0FFFFFFF&((value)<<0))
+
+//#define REG_DMA_CTL2				( REG_NF_BASE_ADDR + 0x308 )    //Transfer length for DMA transfer between DMA buffer and DDR.(512B Unit)
+#define NF_DMA_CTL2_dma_len(value)		(0x0000FFFF&((value)<<0))
+
+//#define REG_DMA_CTL3				( REG_NF_BASE_ADDR + 0x30c )	//Set to control data transfer between DRAM and DMA buffer.
+#define NF_DMA_CTL3_cp_first(value)		(0x00000008&((value)<<3))
+#define NF_DMA_CTL3_cp_enable(value)		(0x00000004&((value)<<2))	
+#define NF_DMA_CTL3_ddr_wr(value)		(0x00000002&((value)<<1))
+#define NF_DMA_CTL3_dma_xfer(value)		(0x00000001&((value)<<0))
+
+//#define REG_NAND_ISR				( REG_NF_BASE_ADDR + 0x324 )	//NAND ISR status register
+#define NF_NAND_ISR_Int5(value)			(0x00000020&((value)<<5))
+#define NF_NAND_ISR_Int4(value)			(0x00000010&((value)<<4))
+#define NF_NAND_ISR_Int3(value)			(0x00000008&((value)<<3))
+#define NF_NAND_ISR_Int2(value)			(0x00000004&((value)<<2))
+#define NF_NAND_ISR_Int1(value)			(0x00000002&((value)<<1))
+#define NF_NAND_ISR_write_data(value)		(0x00000001&((value)<<0))
+
+//#define REG_NAND_ISREN			( REG_NF_BASE_ADDR + 0x328 )	//NAND ISR enable register
+#define NF_NAND_ISREN_Int5En(value)		(0x00000020&((value)<<5))
+#define NF_NAND_ISREN_Int4En(value)		(0x00000010&((value)<<4))
+#define NF_NAND_ISREN_Int3En(value)		(0x00000008&((value)<<3))
+#define NF_NAND_ISREN_Int2En(value)		(0x00000004&((value)<<2))
+#define NF_NAND_ISREN_Int1En(value)		(0x00000002&((value)<<1))
+#define NF_NAND_ISREN_write_data(value)		(0x00000001&((value)<<0))
+
+//#define REG_DUMMY_SYS				( REG_NF_BASE_ADDR + 0x32c )	//Dummy
+#define NF_DUMMY_SYS_dmy(value)			(0xFFFFFFFF&((value)<<0))
+
+//#define REG_DBG				( REG_NF_BASE_ADDR + 0x344 )	
+
+//#define REG_SPR_DDR_CTL			( REG_NF_BASE_ADDR + 0x348 )	
+#define NF_SPR_DDR_CTL_cr_nf_hw_pinmux_ena(value)	(0x40000000&((value)<<30))
+#define NF_SPR_DDR_CTL_spare_ddr_ena(value)	(0x20000000&((value)<<29))
+#define NF_SPR_DDR_CTL_per_2k_spr_ena(value)	(0x10000000&((value)<<28))
+#define NF_SPR_DDR_CTL_spare_dram_sa(value)	(0x1FFFFFFF&((value)<<0))
+
+//#define REG_CP_LEN				( REG_NF_BASE_ADDR + 0x34C )	
+#define NF_CP_LEN_cp_length(value)		(0x01FFFE00&((value)<<9))
+
+
+#endif
diff --git a/include/linux/namei.h b/include/linux/namei.h
index f29abda3..cf437f5 100644
--- a/include/linux/namei.h
+++ b/include/linux/namei.h
@@ -78,8 +78,11 @@ static inline int user_path_dir(const char __user *name, struct path *path)
 extern void done_path_create(struct path *, struct dentry *);
 extern struct dentry *kern_path_locked(const char *, struct path *);
 extern int kern_path_mountpoint(int, const char *, struct path *, unsigned int);
+extern int vfs_path_lookup(struct dentry *, struct vfsmount *,
+		const char *, unsigned int, struct path *);
 
 extern struct dentry *lookup_one_len(const char *, struct dentry *, int);
+extern struct dentry *lookup_one_len2(const char *, struct vfsmount *mnt, struct dentry *, int);
 extern struct dentry *lookup_one_len_unlocked(const char *, struct dentry *, int);
 
 extern int follow_down_one(struct path *);
diff --git a/include/linux/netfilter/xt_qtaguid.h b/include/linux/netfilter/xt_qtaguid.h
new file mode 100644
index 00000000..1c67155
--- /dev/null
+++ b/include/linux/netfilter/xt_qtaguid.h
@@ -0,0 +1,14 @@
+#ifndef _XT_QTAGUID_MATCH_H
+#define _XT_QTAGUID_MATCH_H
+
+/* For now we just replace the xt_owner.
+ * FIXME: make iptables aware of qtaguid. */
+#include <linux/netfilter/xt_owner.h>
+
+#define XT_QTAGUID_UID    XT_OWNER_UID
+#define XT_QTAGUID_GID    XT_OWNER_GID
+#define XT_QTAGUID_SOCKET XT_OWNER_SOCKET
+#define xt_qtaguid_match_info xt_owner_match_info
+
+int qtaguid_untag(struct socket *sock, bool kernel);
+#endif /* _XT_QTAGUID_MATCH_H */
diff --git a/include/linux/netfilter/xt_quota2.h b/include/linux/netfilter/xt_quota2.h
new file mode 100644
index 00000000..eadc69033
--- /dev/null
+++ b/include/linux/netfilter/xt_quota2.h
@@ -0,0 +1,25 @@
+#ifndef _XT_QUOTA_H
+#define _XT_QUOTA_H
+
+enum xt_quota_flags {
+	XT_QUOTA_INVERT    = 1 << 0,
+	XT_QUOTA_GROW      = 1 << 1,
+	XT_QUOTA_PACKET    = 1 << 2,
+	XT_QUOTA_NO_CHANGE = 1 << 3,
+	XT_QUOTA_MASK      = 0x0F,
+};
+
+struct xt_quota_counter;
+
+struct xt_quota_mtinfo2 {
+	char name[15];
+	u_int8_t flags;
+
+	/* Comparison-invariant */
+	aligned_u64 quota;
+
+	/* Used internally by the kernel */
+	struct xt_quota_counter *master __attribute__((aligned(8)));
+};
+
+#endif /* _XT_QUOTA_H */
diff --git a/include/linux/netlink.h b/include/linux/netlink.h
index da14ab6..5bf0d03 100644
--- a/include/linux/netlink.h
+++ b/include/linux/netlink.h
@@ -80,6 +80,11 @@ extern int netlink_broadcast_filtered(struct sock *ssk, struct sk_buff *skb,
 extern int netlink_register_notifier(struct notifier_block *nb);
 extern int netlink_unregister_notifier(struct notifier_block *nb);
 
+#if defined(CONFIG_RTL_819X)
+extern int rtk_nlrecvmsg(struct sk_buff *_skb,int _len, void *_recv_data);
+extern int rtk_nlsendmsg (int _pid,struct sock *_nl_sk,int _len,void *_send_info);
+#endif
+
 /* finegrained unicast helpers: */
 struct sock *netlink_getsockbyfilp(struct file *filp);
 int netlink_attachskb(struct sock *sk, struct sk_buff *skb,
diff --git a/include/linux/of_fdt.h b/include/linux/of_fdt.h
index 4341f32..501d461 100644
--- a/include/linux/of_fdt.h
+++ b/include/linux/of_fdt.h
@@ -63,6 +63,27 @@ extern const void *of_get_flat_dt_prop(unsigned long node, const char *name,
 extern unsigned long of_get_flat_dt_root(void);
 extern int of_get_flat_dt_size(void);
 
+/*
+ * early_init_dt_scan_chosen - scan the device tree for ramdisk and bootargs
+ *
+ * The boot arguments will be placed into the memory pointed to by @data.
+ * That memory should be COMMAND_LINE_SIZE big and initialized to be a valid
+ * (possibly empty) string.  Logic for what will be in @data after this
+ * function finishes:
+ *
+ * - CONFIG_CMDLINE_FORCE=true
+ *     CONFIG_CMDLINE
+ * - CONFIG_CMDLINE_EXTEND=true, @data is non-empty string
+ *     @data + dt bootargs (even if dt bootargs are empty)
+ * - CONFIG_CMDLINE_EXTEND=true, @data is empty string
+ *     CONFIG_CMDLINE + dt bootargs (even if dt bootargs are empty)
+ * - CMDLINE_FROM_BOOTLOADER=true, dt bootargs=non-empty:
+ *     dt bootargs
+ * - CMDLINE_FROM_BOOTLOADER=true, dt bootargs=empty, @data is non-empty string
+ *     @data is left unchanged
+ * - CMDLINE_FROM_BOOTLOADER=true, dt bootargs=empty, @data is empty string
+ *     CONFIG_CMDLINE (or "" if that's not defined)
+ */
 extern int early_init_dt_scan_chosen(unsigned long node, const char *uname,
 				     int depth, void *data);
 extern int early_init_dt_scan_memory(unsigned long node, const char *uname,
diff --git a/include/linux/overflow.h b/include/linux/overflow.h
new file mode 100644
index 00000000..8712ff7
--- /dev/null
+++ b/include/linux/overflow.h
@@ -0,0 +1,278 @@
+/* SPDX-License-Identifier: GPL-2.0 OR MIT */
+#ifndef __LINUX_OVERFLOW_H
+#define __LINUX_OVERFLOW_H
+
+#include <linux/compiler.h>
+
+/*
+ * In the fallback code below, we need to compute the minimum and
+ * maximum values representable in a given type. These macros may also
+ * be useful elsewhere, so we provide them outside the
+ * COMPILER_HAS_GENERIC_BUILTIN_OVERFLOW block.
+ *
+ * It would seem more obvious to do something like
+ *
+ * #define type_min(T) (T)(is_signed_type(T) ? (T)1 << (8*sizeof(T)-1) : 0)
+ * #define type_max(T) (T)(is_signed_type(T) ? ((T)1 << (8*sizeof(T)-1)) - 1 : ~(T)0)
+ *
+ * Unfortunately, the middle expressions, strictly speaking, have
+ * undefined behaviour, and at least some versions of gcc warn about
+ * the type_max expression (but not if -fsanitize=undefined is in
+ * effect; in that case, the warning is deferred to runtime...).
+ *
+ * The slightly excessive casting in type_min is to make sure the
+ * macros also produce sensible values for the exotic type _Bool. [The
+ * overflow checkers only almost work for _Bool, but that's
+ * a-feature-not-a-bug, since people shouldn't be doing arithmetic on
+ * _Bools. Besides, the gcc builtins don't allow _Bool* as third
+ * argument.]
+ *
+ * Idea stolen from
+ * https://mail-index.netbsd.org/tech-misc/2007/02/05/0000.html -
+ * credit to Christian Biere.
+ */
+#define is_signed_type(type)       (((type)(-1)) < (type)1)
+#define __type_half_max(type) ((type)1 << (8*sizeof(type) - 1 - is_signed_type(type)))
+#define type_max(T) ((T)((__type_half_max(T) - 1) + __type_half_max(T)))
+#define type_min(T) ((T)((T)-type_max(T)-(T)1))
+
+
+#ifdef COMPILER_HAS_GENERIC_BUILTIN_OVERFLOW
+/*
+ * For simplicity and code hygiene, the fallback code below insists on
+ * a, b and *d having the same type (similar to the min() and max()
+ * macros), whereas gcc's type-generic overflow checkers accept
+ * different types. Hence we don't just make check_add_overflow an
+ * alias for __builtin_add_overflow, but add type checks similar to
+ * below.
+ */
+#define check_add_overflow(a, b, d) ({		\
+	typeof(a) __a = (a);			\
+	typeof(b) __b = (b);			\
+	typeof(d) __d = (d);			\
+	(void) (&__a == &__b);			\
+	(void) (&__a == __d);			\
+	__builtin_add_overflow(__a, __b, __d);	\
+})
+
+#define check_sub_overflow(a, b, d) ({		\
+	typeof(a) __a = (a);			\
+	typeof(b) __b = (b);			\
+	typeof(d) __d = (d);			\
+	(void) (&__a == &__b);			\
+	(void) (&__a == __d);			\
+	__builtin_sub_overflow(__a, __b, __d);	\
+})
+
+#define check_mul_overflow(a, b, d) ({		\
+	typeof(a) __a = (a);			\
+	typeof(b) __b = (b);			\
+	typeof(d) __d = (d);			\
+	(void) (&__a == &__b);			\
+	(void) (&__a == __d);			\
+	__builtin_mul_overflow(__a, __b, __d);	\
+})
+
+#else
+
+
+/* Checking for unsigned overflow is relatively easy without causing UB. */
+#define __unsigned_add_overflow(a, b, d) ({	\
+	typeof(a) __a = (a);			\
+	typeof(b) __b = (b);			\
+	typeof(d) __d = (d);			\
+	(void) (&__a == &__b);			\
+	(void) (&__a == __d);			\
+	*__d = __a + __b;			\
+	*__d < __a;				\
+})
+#define __unsigned_sub_overflow(a, b, d) ({	\
+	typeof(a) __a = (a);			\
+	typeof(b) __b = (b);			\
+	typeof(d) __d = (d);			\
+	(void) (&__a == &__b);			\
+	(void) (&__a == __d);			\
+	*__d = __a - __b;			\
+	__a < __b;				\
+})
+/*
+ * If one of a or b is a compile-time constant, this avoids a division.
+ */
+#define __unsigned_mul_overflow(a, b, d) ({		\
+	typeof(a) __a = (a);				\
+	typeof(b) __b = (b);				\
+	typeof(d) __d = (d);				\
+	(void) (&__a == &__b);				\
+	(void) (&__a == __d);				\
+	*__d = __a * __b;				\
+	__builtin_constant_p(__b) ?			\
+	  __b > 0 && __a > type_max(typeof(__a)) / __b : \
+	  __a > 0 && __b > type_max(typeof(__b)) / __a;	 \
+})
+
+/*
+ * For signed types, detecting overflow is much harder, especially if
+ * we want to avoid UB. But the interface of these macros is such that
+ * we must provide a result in *d, and in fact we must produce the
+ * result promised by gcc's builtins, which is simply the possibly
+ * wrapped-around value. Fortunately, we can just formally do the
+ * operations in the widest relevant unsigned type (u64) and then
+ * truncate the result - gcc is smart enough to generate the same code
+ * with and without the (u64) casts.
+ */
+
+/*
+ * Adding two signed integers can overflow only if they have the same
+ * sign, and overflow has happened iff the result has the opposite
+ * sign.
+ */
+#define __signed_add_overflow(a, b, d) ({	\
+	typeof(a) __a = (a);			\
+	typeof(b) __b = (b);			\
+	typeof(d) __d = (d);			\
+	(void) (&__a == &__b);			\
+	(void) (&__a == __d);			\
+	*__d = (u64)__a + (u64)__b;		\
+	(((~(__a ^ __b)) & (*__d ^ __a))	\
+		& type_min(typeof(__a))) != 0;	\
+})
+
+/*
+ * Subtraction is similar, except that overflow can now happen only
+ * when the signs are opposite. In this case, overflow has happened if
+ * the result has the opposite sign of a.
+ */
+#define __signed_sub_overflow(a, b, d) ({	\
+	typeof(a) __a = (a);			\
+	typeof(b) __b = (b);			\
+	typeof(d) __d = (d);			\
+	(void) (&__a == &__b);			\
+	(void) (&__a == __d);			\
+	*__d = (u64)__a - (u64)__b;		\
+	((((__a ^ __b)) & (*__d ^ __a))		\
+		& type_min(typeof(__a))) != 0;	\
+})
+
+/*
+ * Signed multiplication is rather hard. gcc always follows C99, so
+ * division is truncated towards 0. This means that we can write the
+ * overflow check like this:
+ *
+ * (a > 0 && (b > MAX/a || b < MIN/a)) ||
+ * (a < -1 && (b > MIN/a || b < MAX/a) ||
+ * (a == -1 && b == MIN)
+ *
+ * The redundant casts of -1 are to silence an annoying -Wtype-limits
+ * (included in -Wextra) warning: When the type is u8 or u16, the
+ * __b_c_e in check_mul_overflow obviously selects
+ * __unsigned_mul_overflow, but unfortunately gcc still parses this
+ * code and warns about the limited range of __b.
+ */
+
+#define __signed_mul_overflow(a, b, d) ({				\
+	typeof(a) __a = (a);						\
+	typeof(b) __b = (b);						\
+	typeof(d) __d = (d);						\
+	typeof(a) __tmax = type_max(typeof(a));				\
+	typeof(a) __tmin = type_min(typeof(a));				\
+	(void) (&__a == &__b);						\
+	(void) (&__a == __d);						\
+	*__d = (u64)__a * (u64)__b;					\
+	(__b > 0   && (__a > __tmax/__b || __a < __tmin/__b)) ||	\
+	(__b < (typeof(__b))-1  && (__a > __tmin/__b || __a < __tmax/__b)) || \
+	(__b == (typeof(__b))-1 && __a == __tmin);			\
+})
+
+
+#define check_add_overflow(a, b, d)					\
+	__builtin_choose_expr(is_signed_type(typeof(a)),		\
+			__signed_add_overflow(a, b, d),			\
+			__unsigned_add_overflow(a, b, d))
+
+#define check_sub_overflow(a, b, d)					\
+	__builtin_choose_expr(is_signed_type(typeof(a)),		\
+			__signed_sub_overflow(a, b, d),			\
+			__unsigned_sub_overflow(a, b, d))
+
+#define check_mul_overflow(a, b, d)					\
+	__builtin_choose_expr(is_signed_type(typeof(a)),		\
+			__signed_mul_overflow(a, b, d),			\
+			__unsigned_mul_overflow(a, b, d))
+
+
+#endif /* COMPILER_HAS_GENERIC_BUILTIN_OVERFLOW */
+
+/**
+ * array_size() - Calculate size of 2-dimensional array.
+ *
+ * @a: dimension one
+ * @b: dimension two
+ *
+ * Calculates size of 2-dimensional array: @a * @b.
+ *
+ * Returns: number of bytes needed to represent the array or SIZE_MAX on
+ * overflow.
+ */
+static inline __must_check size_t array_size(size_t a, size_t b)
+{
+	size_t bytes;
+
+	if (check_mul_overflow(a, b, &bytes))
+		return SIZE_MAX;
+
+	return bytes;
+}
+
+/**
+ * array3_size() - Calculate size of 3-dimensional array.
+ *
+ * @a: dimension one
+ * @b: dimension two
+ * @c: dimension three
+ *
+ * Calculates size of 3-dimensional array: @a * @b * @c.
+ *
+ * Returns: number of bytes needed to represent the array or SIZE_MAX on
+ * overflow.
+ */
+static inline __must_check size_t array3_size(size_t a, size_t b, size_t c)
+{
+	size_t bytes;
+
+	if (check_mul_overflow(a, b, &bytes))
+		return SIZE_MAX;
+	if (check_mul_overflow(bytes, c, &bytes))
+		return SIZE_MAX;
+
+	return bytes;
+}
+
+static inline __must_check size_t __ab_c_size(size_t n, size_t size, size_t c)
+{
+	size_t bytes;
+
+	if (check_mul_overflow(n, size, &bytes))
+		return SIZE_MAX;
+	if (check_add_overflow(bytes, c, &bytes))
+		return SIZE_MAX;
+
+	return bytes;
+}
+
+/**
+ * struct_size() - Calculate size of structure with trailing array.
+ * @p: Pointer to the structure.
+ * @member: Name of the array member.
+ * @n: Number of elements in the array.
+ *
+ * Calculates size of memory needed for structure @p followed by an
+ * array of @n @member elements.
+ *
+ * Return: number of bytes needed or SIZE_MAX on overflow.
+ */
+#define struct_size(p, member, n)					\
+	__ab_c_size(n,							\
+		    sizeof(*(p)->member) + __must_be_array((p)->member),\
+		    sizeof(*(p)))
+
+#endif /* __LINUX_OVERFLOW_H */
diff --git a/include/linux/pagemap.h b/include/linux/pagemap.h
index 35f4c4d..6e755d9 100644
--- a/include/linux/pagemap.h
+++ b/include/linux/pagemap.h
@@ -225,7 +225,7 @@ static inline gfp_t readahead_gfp_mask(struct address_space *x)
 				  __GFP_COLD | __GFP_NORETRY | __GFP_NOWARN;
 }
 
-typedef int filler_t(void *, struct page *);
+typedef int filler_t(struct file *, struct page *);
 
 pgoff_t page_cache_next_hole(struct address_space *mapping,
 			     pgoff_t index, unsigned long max_scan);
@@ -341,8 +341,16 @@ unsigned find_get_pages(struct address_space *mapping, pgoff_t start,
 			unsigned int nr_pages, struct page **pages);
 unsigned find_get_pages_contig(struct address_space *mapping, pgoff_t start,
 			       unsigned int nr_pages, struct page **pages);
-unsigned find_get_pages_tag(struct address_space *mapping, pgoff_t *index,
-			int tag, unsigned int nr_pages, struct page **pages);
+unsigned find_get_pages_range_tag(struct address_space *mapping, pgoff_t *index,
+			pgoff_t end, int tag, unsigned int nr_pages,
+			struct page **pages);
+static inline unsigned find_get_pages_tag(struct address_space *mapping,
+			pgoff_t *index, int tag, unsigned int nr_pages,
+			struct page **pages)
+{
+	return find_get_pages_range_tag(mapping, index, (pgoff_t)-1, tag,
+					nr_pages, pages);
+}
 unsigned find_get_entries_tag(struct address_space *mapping, pgoff_t start,
 			int tag, unsigned int nr_entries,
 			struct page **entries, pgoff_t *indices);
@@ -369,7 +377,7 @@ extern int read_cache_pages(struct address_space *mapping,
 static inline struct page *read_mapping_page(struct address_space *mapping,
 				pgoff_t index, void *data)
 {
-	filler_t *filler = (filler_t *)mapping->a_ops->readpage;
+	filler_t *filler = mapping->a_ops->readpage;
 	return read_cache_page(mapping, index, filler, data);
 }
 
diff --git a/include/linux/pagevec.h b/include/linux/pagevec.h
index b45d391..cead441 100644
--- a/include/linux/pagevec.h
+++ b/include/linux/pagevec.h
@@ -29,9 +29,17 @@ unsigned pagevec_lookup_entries(struct pagevec *pvec,
 void pagevec_remove_exceptionals(struct pagevec *pvec);
 unsigned pagevec_lookup(struct pagevec *pvec, struct address_space *mapping,
 		pgoff_t start, unsigned nr_pages);
-unsigned pagevec_lookup_tag(struct pagevec *pvec,
-		struct address_space *mapping, pgoff_t *index, int tag,
-		unsigned nr_pages);
+unsigned pagevec_lookup_range_tag(struct pagevec *pvec,
+		struct address_space *mapping, pgoff_t *index, pgoff_t end,
+		int tag);
+unsigned pagevec_lookup_range_nr_tag(struct pagevec *pvec,
+		struct address_space *mapping, pgoff_t *index, pgoff_t end,
+		int tag, unsigned max_pages);
+static inline unsigned pagevec_lookup_tag(struct pagevec *pvec,
+		struct address_space *mapping, pgoff_t *index, int tag)
+{
+	return pagevec_lookup_range_tag(pvec, mapping, index, (pgoff_t)-1, tag);
+}
 
 static inline void pagevec_init(struct pagevec *pvec, int cold)
 {
diff --git a/include/linux/perf/arm_pmuv3.h b/include/linux/perf/arm_pmuv3.h
new file mode 100644
index 00000000..909188b
--- /dev/null
+++ b/include/linux/perf/arm_pmuv3.h
@@ -0,0 +1,78 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (C) 2012 ARM Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __PERF_ARM_PMUV3_H
+#define __PERF_ARM_PMUV3_H
+
+#include <asm/arm_pmuv3.h>
+
+#define	ARMV8_PMU_MAX_COUNTERS	32
+#define	ARMV8_PMU_COUNTER_MASK	(ARMV8_PMU_MAX_COUNTERS - 1)
+
+/*
+ * Per-CPU PMCR: config reg
+ */
+#define ARMV8_PMU_PMCR_E	(1 << 0) /* Enable all counters */
+#define ARMV8_PMU_PMCR_P	(1 << 1) /* Reset all counters */
+#define ARMV8_PMU_PMCR_C	(1 << 2) /* Cycle counter reset */
+#define ARMV8_PMU_PMCR_D	(1 << 3) /* CCNT counts every 64th cpu cycle */
+#define ARMV8_PMU_PMCR_X	(1 << 4) /* Export to ETM */
+#define ARMV8_PMU_PMCR_DP	(1 << 5) /* Disable CCNT if non-invasive debug*/
+#define ARMV8_PMU_PMCR_LC	(1 << 6) /* Overflow on 64 bit cycle counter */
+#define	ARMV8_PMU_PMCR_N_SHIFT	11	 /* Number of counters supported */
+#define	ARMV8_PMU_PMCR_N_MASK	0x1f
+#define	ARMV8_PMU_PMCR_MASK	0x7f	 /* Mask for writable bits */
+
+/*
+ * PMOVSR: counters overflow flag status reg
+ */
+#define	ARMV8_PMU_OVSR_MASK		0xffffffff	/* Mask for writable bits */
+#define	ARMV8_PMU_OVERFLOWED_MASK	ARMV8_PMU_OVSR_MASK
+
+/*
+ * PMXEVTYPER: Event selection reg
+ */
+#define	ARMV8_PMU_EVTYPE_MASK	0xc800ffff	/* Mask for writable bits */
+#define	ARMV8_PMU_EVTYPE_EVENT	0xffff		/* Mask for EVENT bits */
+
+/*
+ * PMUv3 event types: required events
+ */
+#define ARMV8_PMUV3_PERFCTR_SW_INCR				0x00
+#define ARMV8_PMUV3_PERFCTR_L1D_CACHE_REFILL			0x03
+#define ARMV8_PMUV3_PERFCTR_L1D_CACHE				0x04
+#define ARMV8_PMUV3_PERFCTR_BR_MIS_PRED				0x10
+#define ARMV8_PMUV3_PERFCTR_CPU_CYCLES				0x11
+#define ARMV8_PMUV3_PERFCTR_BR_PRED				0x12
+
+/*
+ * Event filters for PMUv3
+ */
+#define	ARMV8_PMU_EXCLUDE_EL1	(1 << 31)
+#define	ARMV8_PMU_EXCLUDE_EL0	(1 << 30)
+#define	ARMV8_PMU_INCLUDE_EL2	(1 << 27)
+
+/*
+ * PMUSERENR: user enable reg
+ */
+#define ARMV8_PMU_USERENR_MASK	0xf		/* Mask for writable bits */
+#define ARMV8_PMU_USERENR_EN	(1 << 0) /* PMU regs can be accessed at EL0 */
+#define ARMV8_PMU_USERENR_SW	(1 << 1) /* PMSWINC can be written at EL0 */
+#define ARMV8_PMU_USERENR_CR	(1 << 2) /* Cycle counter can be read at EL0 */
+#define ARMV8_PMU_USERENR_ER	(1 << 3) /* Event counter can be read at EL0 */
+
+#endif
diff --git a/include/linux/perf_event.h b/include/linux/perf_event.h
index 78ed810..61ab566 100644
--- a/include/linux/perf_event.h
+++ b/include/linux/perf_event.h
@@ -1168,6 +1168,11 @@ extern int perf_cpu_time_max_percent_handler(struct ctl_table *table, int write,
 int perf_event_max_stack_handler(struct ctl_table *table, int write,
 				 void __user *buffer, size_t *lenp, loff_t *ppos);
 
+static inline bool perf_paranoid_any(void)
+{
+	return sysctl_perf_event_paranoid > 2;
+}
+
 static inline bool perf_paranoid_tracepoint_raw(void)
 {
 	return sysctl_perf_event_paranoid > -1;
diff --git a/include/linux/platform_data/ds2482.h b/include/linux/platform_data/ds2482.h
new file mode 100644
index 00000000..5a6879e2a
--- /dev/null
+++ b/include/linux/platform_data/ds2482.h
@@ -0,0 +1,21 @@
+/*
+ * Copyright (C) 2012 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef __PLATFORM_DATA_DS2482__
+#define __PLATFORM_DATA_DS2482__
+
+struct ds2482_platform_data {
+	int		slpz_gpio;
+};
+
+#endif /* __PLATFORM_DATA_DS2482__ */
diff --git a/include/linux/power-control.h b/include/linux/power-control.h
new file mode 100644
index 00000000..e1e4ebd
--- /dev/null
+++ b/include/linux/power-control.h
@@ -0,0 +1,2 @@
+#warning "Please include soc/realtek/power-control.h"
+#include <soc/realtek/power-control.h>
diff --git a/include/linux/power_supply.h b/include/linux/power_supply.h
index 3965503..ecfb4cac 100644
--- a/include/linux/power_supply.h
+++ b/include/linux/power_supply.h
@@ -18,6 +18,7 @@
 #include <linux/leds.h>
 #include <linux/spinlock.h>
 #include <linux/notifier.h>
+#include <linux/types.h>
 
 /*
  * All voltages, currents, charges, energies, time and temperatures in uV,
@@ -148,6 +149,12 @@ enum power_supply_property {
 	POWER_SUPPLY_PROP_SCOPE,
 	POWER_SUPPLY_PROP_CHARGE_TERM_CURRENT,
 	POWER_SUPPLY_PROP_CALIBRATE,
+	/* Local extensions */
+	POWER_SUPPLY_PROP_USB_HC,
+	POWER_SUPPLY_PROP_USB_OTG,
+	POWER_SUPPLY_PROP_CHARGE_ENABLED,
+	/* Local extensions of type int64_t */
+	POWER_SUPPLY_PROP_CHARGE_COUNTER_EXT,
 	/* Properties of type `const char *' */
 	POWER_SUPPLY_PROP_MODEL_NAME,
 	POWER_SUPPLY_PROP_MANUFACTURER,
@@ -175,6 +182,7 @@ enum power_supply_notifier_events {
 union power_supply_propval {
 	int intval;
 	const char *strval;
+	int64_t int64val;
 };
 
 struct device_node;
diff --git a/include/linux/proc_fs.h b/include/linux/proc_fs.h
index b97bf2e..b326d0a 100644
--- a/include/linux/proc_fs.h
+++ b/include/linux/proc_fs.h
@@ -74,6 +74,12 @@ static inline void proc_remove(struct proc_dir_entry *de) {}
 
 #endif /* CONFIG_PROC_FS */
 
+#ifdef CONFIG_PROC_UID
+extern void proc_register_uid(kuid_t uid);
+#else
+static inline void proc_register_uid(kuid_t uid) {}
+#endif
+
 struct net;
 
 static inline struct proc_dir_entry *proc_net_mkdir(
diff --git a/include/linux/pstore_ram.h b/include/linux/pstore_ram.h
index 4058bf9..cb5edd6 100644
--- a/include/linux/pstore_ram.h
+++ b/include/linux/pstore_ram.h
@@ -80,6 +80,8 @@ int persistent_ram_write_user(struct persistent_ram_zone *prz,
 ssize_t persistent_ram_ecc_string(struct persistent_ram_zone *prz,
 	char *str, size_t len);
 
+void ramoops_console_write_buf(const char *buf, size_t size);
+
 /*
  * Ramoops platform data
  * @mem_size	memory size for ramoops
diff --git a/include/linux/regulator/sy8827e.h b/include/linux/regulator/sy8827e.h
new file mode 100644
index 00000000..25f4fb61
--- /dev/null
+++ b/include/linux/regulator/sy8827e.h
@@ -0,0 +1,31 @@
+#ifndef __LINUX_REGULATOR_SY8827E_H
+#define __LINUX_REGULATOR_SY8827E_H
+
+#define SY8827E_REG_VSEL0               (0x00)
+#define SY8827E_REG_VSEL1               (0x01)
+#define SY8827E_REG_CONTROL             (0x02)
+#define SY8827E_REG_ID0                 (0x03)
+#define SY8827E_REG_ID1                 (0x04)
+#define SY8827E_REG_PGOOD               (0x05)
+
+/* register definition */
+#define SY8827E_BUCK_EN0_MASK           (0x80)
+#define SY8827E_BUCK_EN0_SHIFT          (7)
+#define SY8827E_BUCK_EN0_WIDTH          (1)
+#define SY8827E_MODE0_MASK              (0x40)
+#define SY8827E_MODE0_SHIFT             (6)
+#define SY8827E_MODE0_WIDTH             (1)
+#define SY8827E_NSEL0_MASK              (0x3F)
+#define SY8827E_NSEL0_SHIFT             (0)
+#define SY8827E_NSEL0_WIDTH             (6)
+#define SY8827E_BUCK_EN1_MASK           (0x80)
+#define SY8827E_BUCK_EN1_SHIFT          (7)
+#define SY8827E_BUCK_EN1_WIDTH          (1)
+#define SY8827E_MODE1_MASK              (0x40)
+#define SY8827E_MODE1_SHIFT             (6)
+#define SY8827E_MODE1_WIDTH             (1)
+#define SY8827E_NSEL1_MASK              (0x3F)
+#define SY8827E_NSEL1_SHIFT             (0)
+#define SY8827E_NSEL1_WIDTH             (6)
+
+#endif
diff --git a/include/linux/reservation.h b/include/linux/reservation.h
index b0f305e..bad7710 100644
--- a/include/linux/reservation.h
+++ b/include/linux/reservation.h
@@ -177,17 +177,14 @@ struct reservation_object {
 reservation_object_get_excl_rcu(struct reservation_object *obj)
 {
 	struct fence *fence;
-	unsigned seq;
-retry:
-	seq = read_seqcount_begin(&obj->seq);
+
+	if (!rcu_access_pointer(obj->fence_excl))
+		return NULL;
+
 	rcu_read_lock();
-	fence = rcu_dereference(obj->fence_excl);
-	if (read_seqcount_retry(&obj->seq, seq)) {
-		rcu_read_unlock();
-		goto retry;
-	}
-	fence = fence_get(fence);
+	fence = fence_get_rcu_safe(&obj->fence_excl);
 	rcu_read_unlock();
+
 	return fence;
 }
 
diff --git a/include/linux/restart_block.h b/include/linux/restart_block.h
new file mode 100644
index 00000000..0d905d8
--- /dev/null
+++ b/include/linux/restart_block.h
@@ -0,0 +1,51 @@
+/*
+ * Common syscall restarting data
+ */
+#ifndef __LINUX_RESTART_BLOCK_H
+#define __LINUX_RESTART_BLOCK_H
+
+#include <linux/compiler.h>
+#include <linux/types.h>
+
+struct timespec;
+struct compat_timespec;
+struct pollfd;
+
+/*
+ * System call restart block.
+ */
+struct restart_block {
+	long (*fn)(struct restart_block *);
+	union {
+		/* For futex_wait and futex_wait_requeue_pi */
+		struct {
+			u32 __user *uaddr;
+			u32 val;
+			u32 flags;
+			u32 bitset;
+			u64 time;
+			u32 __user *uaddr2;
+		} futex;
+		/* For nanosleep */
+		struct {
+			clockid_t clockid;
+			struct timespec __user *rmtp;
+#ifdef CONFIG_COMPAT
+			struct compat_timespec __user *compat_rmtp;
+#endif
+			u64 expires;
+		} nanosleep;
+		/* For poll */
+		struct {
+			struct pollfd __user *ufds;
+			int nfds;
+			int has_timeout;
+			unsigned long tv_sec;
+			unsigned long tv_nsec;
+		} poll;
+	};
+};
+
+extern long do_no_restart_syscall(struct restart_block *parm);
+
+#endif /* __LINUX_RESTART_BLOCK_H */
diff --git a/include/linux/rtk_trace.h b/include/linux/rtk_trace.h
new file mode 100644
index 00000000..73a2ac4
--- /dev/null
+++ b/include/linux/rtk_trace.h
@@ -0,0 +1,98 @@
+/*
+ * Copyright (c) 2012-2014, The Linux Foundation. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+#ifndef __RTK_TRACE_H__
+#define __RTK_TRACE_H__
+
+/*
+ * These numbers are used from the kernel command line and sysfs
+ * to control filtering. Remove items from here with extreme caution.
+ */
+enum logk_event_type {
+	LOGK_NONE = 0,
+	LOGK_READL = 1,
+	LOGK_WRITEL = 2,
+	LOGK_LOGBUF = 3,
+	LOGK_HOTPLUG = 4,
+	LOGK_CTXID = 5,
+	LOGK_TIMESTAMP = 6,
+	LOGK_L2CPREAD = 7,
+	LOGK_L2CPWRITE = 8,
+	LOGK_IRQ = 9,
+	LOGK_DIE = 10,
+	LOGK_INITCALL = 11,
+	LOGK_SOFTIRQ = 12,
+	LOGK_HVC = 13,
+};
+
+#define LOGTYPE_NOPC 0x80
+
+struct rtk_trace_platform_data {
+	unsigned int size;
+};
+
+#if defined(CONFIG_RTK_TRACER)
+int remove_vmap_info(void *va, int check_init);
+int inject_vmap_info(void *va, unsigned long size , phys_addr_t pa, int check_init);
+
+void rtk_trace_disable(void);
+
+/*
+ * returns 1 if data was logged, 0 otherwise
+ */
+int uncached_logk_pc(enum logk_event_type log_type, void *caller,
+				void *data);
+
+/*
+ * returns 1 if data was logged, 0 otherwise
+ */
+int uncached_logk(enum logk_event_type log_type, void *data);
+
+#define ETB_WAYPOINT  do { \
+				BRANCH_TO_NEXT_ISTR; \
+				nop(); \
+				BRANCH_TO_NEXT_ISTR; \
+				nop(); \
+			} while (0)
+
+#define BRANCH_TO_NEXT_ISTR  asm volatile("b .+4\n" : : : "memory")
+/*
+ * both the mb and the isb are needed to ensure enough waypoints for
+ * etb tracing
+ */
+#define LOG_BARRIER	do { \
+				mb(); \
+				isb();\
+			 } while (0)
+#else /* !CONFIG_RTK_TRACER */
+static inline int remove_vmap_info(void *va, int check_init) { return 0; }
+static inline int inject_vmap_info(void *va, unsigned long size , phys_addr_t pa, int check_init) { return 0; }
+
+static inline void rtk_trace_disable(void) { return; }
+
+static inline int uncached_logk_pc(enum logk_event_type log_type,
+					void *caller,
+					void *data) { return 0; }
+
+static inline int uncached_logk(enum logk_event_type log_type,
+					void *data) { return 0; }
+
+#define ETB_WAYPOINT
+#define BRANCH_TO_NEXT_ISTR
+/*
+ * Due to a GCC bug, we need to have a nop here in order to prevent an extra
+ * read from being generated after the write.
+ */
+#define LOG_BARRIER		nop()
+#endif /* CONFIG_RTK_TRACER */
+
+#endif /* __RTK_TRACE_H__ */
diff --git a/include/linux/sched.h b/include/linux/sched.h
index 1cc5723..fe74de4 100644
--- a/include/linux/sched.h
+++ b/include/linux/sched.h
@@ -173,6 +173,9 @@ struct sched_attr {
 extern unsigned long nr_iowait(void);
 extern unsigned long nr_iowait_cpu(int cpu);
 extern void get_iowait_load(unsigned long *nr_waiters, unsigned long *load);
+#ifdef CONFIG_CPU_QUIET
+extern u64 nr_running_integral(unsigned int cpu);
+#endif
 
 extern void calc_global_load(unsigned long ticks);
 
@@ -315,6 +318,15 @@ static inline void cpu_load_update_nohz_stop(void) { }
 /* Task command name length */
 #define TASK_COMM_LEN 16
 
+enum task_event {
+	PUT_PREV_TASK   = 0,
+	PICK_NEXT_TASK  = 1,
+	TASK_WAKE       = 2,
+	TASK_MIGRATE    = 3,
+	TASK_UPDATE     = 4,
+	IRQ_UPDATE	= 5,
+};
+
 #include <linux/spinlock.h>
 
 /*
@@ -982,6 +994,14 @@ enum cpu_idle_type {
 #define SCHED_CAPACITY_SHIFT	SCHED_FIXEDPOINT_SHIFT
 #define SCHED_CAPACITY_SCALE	(1L << SCHED_CAPACITY_SHIFT)
 
+struct sched_capacity_reqs {
+	unsigned long cfs;
+	unsigned long rt;
+	unsigned long dl;
+
+	unsigned long total;
+};
+
 /*
  * Wake-queues are lists of tasks with a pending wakeup, whose
  * callers have already marked the task as woken internally,
@@ -1045,6 +1065,7 @@ extern void wake_q_add(struct wake_q_head *head,
 #define SD_PREFER_SIBLING	0x1000	/* Prefer to place tasks in a sibling domain */
 #define SD_OVERLAP		0x2000	/* sched_domains of this level overlap */
 #define SD_NUMA			0x4000	/* cross-node balancing */
+#define SD_SHARE_CAP_STATES	0x8000  /* Domain members share capacity state */
 
 #ifdef CONFIG_SCHED_SMT
 static inline int cpu_smt_flags(void)
@@ -1077,8 +1098,57 @@ struct sched_domain_attr {
 
 extern int sched_domain_level_max;
 
+struct capacity_state {
+	unsigned long cap;	/* compute capacity */
+	unsigned long power;	/* power consumption at this compute capacity */
+};
+
+struct idle_state {
+	unsigned long power;	 /* power consumption in this idle state */
+};
+
+struct sched_group_energy {
+	unsigned int nr_idle_states;	/* number of idle states */
+	struct idle_state *idle_states;	/* ptr to idle state array */
+	unsigned int nr_cap_states;	/* number of capacity states */
+	struct capacity_state *cap_states; /* ptr to capacity state array */
+};
+
+unsigned long capacity_curr_of(int cpu);
+
 struct sched_group;
 
+struct eas_stats {
+	/* select_idle_sibling() stats */
+	u64 sis_attempts;
+	u64 sis_idle;
+	u64 sis_cache_affine;
+	u64 sis_suff_cap;
+	u64 sis_idle_cpu;
+	u64 sis_count;
+
+	/* select_energy_cpu_brute() stats */
+	u64 secb_attempts;
+	u64 secb_sync;
+	u64 secb_idle_bt;
+	u64 secb_insuff_cap;
+	u64 secb_no_nrg_sav;
+	u64 secb_nrg_sav;
+	u64 secb_count;
+
+	/* find_best_target() stats */
+	u64 fbt_attempts;
+	u64 fbt_no_cpu;
+	u64 fbt_no_sd;
+	u64 fbt_pref_idle;
+	u64 fbt_count;
+
+	/* cas */
+	/* select_task_rq_fair() stats */
+	u64 cas_attempts;
+	u64 cas_count;
+};
+
 struct sched_domain_shared {
 	atomic_t	ref;
 	atomic_t	nr_busy_cpus;
@@ -1147,6 +1217,8 @@ struct sched_domain {
 	unsigned int ttwu_wake_remote;
 	unsigned int ttwu_move_affine;
 	unsigned int ttwu_move_balance;
+
+	struct eas_stats eas_stats;
 #endif
 #ifdef CONFIG_SCHED_DEBUG
 	char *name;
@@ -1184,6 +1256,8 @@ extern void partition_sched_domains(int ndoms_new, cpumask_var_t doms_new[],
 
 typedef const struct cpumask *(*sched_domain_mask_f)(int cpu);
 typedef int (*sched_domain_flags_f)(void);
+typedef
+const struct sched_group_energy * const(*sched_domain_energy_f)(int cpu);
 
 #define SDTL_OVERLAP	0x01
 
@@ -1197,6 +1271,7 @@ struct sd_data {
 struct sched_domain_topology_level {
 	sched_domain_mask_f mask;
 	sched_domain_flags_f sd_flags;
+	sched_domain_energy_f energy;
 	int		    flags;
 	int		    numa_level;
 	struct sd_data      data;
@@ -1342,6 +1417,70 @@ struct sched_statistics {
 	u64			nr_wakeups_affine_attempts;
 	u64			nr_wakeups_passive;
 	u64			nr_wakeups_idle;
+
+	/* select_idle_sibling() */
+	u64			nr_wakeups_sis_attempts;
+	u64			nr_wakeups_sis_idle;
+	u64			nr_wakeups_sis_cache_affine;
+	u64			nr_wakeups_sis_suff_cap;
+	u64			nr_wakeups_sis_idle_cpu;
+	u64			nr_wakeups_sis_count;
+
+	/* energy_aware_wake_cpu() */
+	u64			nr_wakeups_secb_attempts;
+	u64			nr_wakeups_secb_sync;
+	u64			nr_wakeups_secb_idle_bt;
+	u64			nr_wakeups_secb_insuff_cap;
+	u64			nr_wakeups_secb_no_nrg_sav;
+	u64			nr_wakeups_secb_nrg_sav;
+	u64			nr_wakeups_secb_count;
+
+	/* find_best_target() */
+	u64			nr_wakeups_fbt_attempts;
+	u64			nr_wakeups_fbt_no_cpu;
+	u64			nr_wakeups_fbt_no_sd;
+	u64			nr_wakeups_fbt_pref_idle;
+	u64			nr_wakeups_fbt_count;
+
+	/* cas */
+	/* select_task_rq_fair() */
+	u64			nr_wakeups_cas_attempts;
+	u64			nr_wakeups_cas_count;
+};
+#endif
+
+#ifdef CONFIG_SCHED_WALT
+#define RAVG_HIST_SIZE_MAX  5
+
+/* ravg represents frequency scaled cpu-demand of tasks */
+struct ravg {
+	/*
+	 * 'mark_start' marks the beginning of an event (task waking up, task
+	 * starting to execute, task being preempted) within a window
+	 *
+	 * 'sum' represents how runnable a task has been within current
+	 * window. It incorporates both running time and wait time and is
+	 * frequency scaled.
+	 *
+	 * 'sum_history' keeps track of history of 'sum' seen over previous
+	 * RAVG_HIST_SIZE windows. Windows where task was entirely sleeping are
+	 * ignored.
+	 *
+	 * 'demand' represents maximum sum seen over previous
+	 * sysctl_sched_ravg_hist_size windows. 'demand' could drive frequency
+	 * demand for tasks.
+	 *
+	 * 'curr_window' represents task's contribution to cpu busy time
+	 * statistics (rq->curr_runnable_sum) in current window
+	 *
+	 * 'prev_window' represents task's contribution to cpu busy time
+	 * statistics (rq->prev_runnable_sum) in previous window
+	 */
+	u64 mark_start;
+	u32 sum, demand;
+	u32 sum_history[RAVG_HIST_SIZE_MAX];
+	u32 curr_window, prev_window;
+	u16 active_windows;
 };
 #endif
 
@@ -1516,6 +1655,16 @@ struct task_struct {
 	const struct sched_class *sched_class;
 	struct sched_entity se;
 	struct sched_rt_entity rt;
+#ifdef CONFIG_SCHED_WALT
+	struct ravg ravg;
+	/*
+	 * 'init_load_pct' represents the initial task load assigned to children
+	 * of this task
+	 */
+	u32 init_load_pct;
+	u64 last_sleep_ts;
+#endif
+
 #ifdef CONFIG_CGROUP_SCHED
 	struct task_group *sched_task_group;
 #endif
@@ -1644,6 +1793,10 @@ struct task_struct {
 
 	cputime_t utime, stime, utimescaled, stimescaled;
 	cputime_t gtime;
+#ifdef CONFIG_CPU_FREQ_TIMES
+	u64 *time_in_state;
+	unsigned int max_state;
+#endif
 	struct prev_cputime prev_cputime;
 #ifdef CONFIG_VIRT_CPU_ACCOUNTING_GEN
 	seqcount_t vtime_seqcount;
@@ -3571,6 +3724,11 @@ static inline void inc_syscw(struct task_struct *tsk)
 {
 	tsk->ioac.syscw++;
 }
+
+static inline void inc_syscfs(struct task_struct *tsk)
+{
+	tsk->ioac.syscfs++;
+}
 #else
 static inline void add_rchar(struct task_struct *tsk, ssize_t amt)
 {
@@ -3587,6 +3745,9 @@ static inline void inc_syscr(struct task_struct *tsk)
 static inline void inc_syscw(struct task_struct *tsk)
 {
 }
+static inline void inc_syscfs(struct task_struct *tsk)
+{
+}
 #endif
 
 #ifndef TASK_SIZE_OF
diff --git a/include/linux/sched/sysctl.h b/include/linux/sched/sysctl.h
index 22db1e6..da3a02d 100644
--- a/include/linux/sched/sysctl.h
+++ b/include/linux/sched/sysctl.h
@@ -18,6 +18,14 @@ extern int proc_dohung_task_timeout_secs(struct ctl_table *table, int write,
 extern unsigned int sysctl_sched_min_granularity;
 extern unsigned int sysctl_sched_wakeup_granularity;
 extern unsigned int sysctl_sched_child_runs_first;
+extern unsigned int sysctl_sched_sync_hint_enable;
+extern unsigned int sysctl_sched_cstate_aware;
+#ifdef CONFIG_SCHED_WALT
+extern unsigned int sysctl_sched_use_walt_cpu_util;
+extern unsigned int sysctl_sched_use_walt_task_util;
+extern unsigned int sysctl_sched_walt_init_task_load_pct;
+extern unsigned int sysctl_sched_walt_cpu_high_irqload;
+#endif
 
 enum sched_tunable_scaling {
 	SCHED_TUNABLESCALING_NONE,
@@ -56,6 +64,22 @@ int sched_proc_update_handler(struct ctl_table *table, int write,
 extern unsigned int sysctl_sched_cfs_bandwidth_slice;
 #endif
 
+#ifdef CONFIG_SCHED_TUNE
+extern unsigned int sysctl_sched_cfs_boost;
+int sysctl_sched_cfs_boost_handler(struct ctl_table *table, int write,
+				   void __user *buffer, size_t *length,
+				   loff_t *ppos);
+static inline unsigned int get_sysctl_sched_cfs_boost(void)
+{
+	return sysctl_sched_cfs_boost;
+}
+#else
+static inline unsigned int get_sysctl_sched_cfs_boost(void)
+{
+	return 0;
+}
+#endif
+
 #ifdef CONFIG_SCHED_AUTOGROUP
 extern unsigned int sysctl_sched_autogroup_enabled;
 #endif
diff --git a/include/linux/sched_energy.h b/include/linux/sched_energy.h
new file mode 100644
index 00000000..1daf3e1
--- /dev/null
+++ b/include/linux/sched_energy.h
@@ -0,0 +1,44 @@
+#ifndef _LINUX_SCHED_ENERGY_H
+#define _LINUX_SCHED_ENERGY_H
+
+#include <linux/sched.h>
+#include <linux/slab.h>
+
+/*
+ * There doesn't seem to be an NR_CPUS style max number of sched domain
+ * levels so here's an arbitrary constant one for the moment.
+ *
+ * The levels alluded to here correspond to entries in struct
+ * sched_domain_topology_level that are meant to be populated by arch
+ * specific code (topology.c).
+ */
+#define NR_SD_LEVELS 8
+
+#define SD_LEVEL0   0
+#define SD_LEVEL1   1
+#define SD_LEVEL2   2
+#define SD_LEVEL3   3
+#define SD_LEVEL4   4
+#define SD_LEVEL5   5
+#define SD_LEVEL6   6
+#define SD_LEVEL7   7
+
+/*
+ * Convenience macro for iterating through said sd levels.
+ */
+#define for_each_possible_sd_level(level)		    \
+	for (level = 0; level < NR_SD_LEVELS; level++)
+
+#ifdef CONFIG_SMP
+
+extern struct sched_group_energy *sge_array[NR_CPUS][NR_SD_LEVELS];
+
+void init_sched_energy_costs(void);
+
+#else
+
+#define init_sched_energy_costs() do { } while (0)
+
+#endif /* CONFIG_SMP */
+
+#endif
diff --git a/include/linux/security.h b/include/linux/security.h
index c2125e90..3632428 100644
--- a/include/linux/security.h
+++ b/include/linux/security.h
@@ -1662,6 +1662,54 @@ static inline void securityfs_remove(struct dentry *dentry)
 
 #endif
 
+#ifdef CONFIG_BPF_SYSCALL
+union bpf_attr;
+struct bpf_map;
+struct bpf_prog;
+struct bpf_prog_aux;
+#ifdef CONFIG_SECURITY
+extern int security_bpf(int cmd, union bpf_attr *attr, unsigned int size);
+extern int security_bpf_map(struct bpf_map *map, fmode_t fmode);
+extern int security_bpf_prog(struct bpf_prog *prog);
+extern int security_bpf_map_alloc(struct bpf_map *map);
+extern void security_bpf_map_free(struct bpf_map *map);
+extern int security_bpf_prog_alloc(struct bpf_prog_aux *aux);
+extern void security_bpf_prog_free(struct bpf_prog_aux *aux);
+#else
+static inline int security_bpf(int cmd, union bpf_attr *attr,
+					     unsigned int size)
+{
+	return 0;
+}
+
+static inline int security_bpf_map(struct bpf_map *map, fmode_t fmode)
+{
+	return 0;
+}
+
+static inline int security_bpf_prog(struct bpf_prog *prog)
+{
+	return 0;
+}
+
+static inline int security_bpf_map_alloc(struct bpf_map *map)
+{
+	return 0;
+}
+
+static inline void security_bpf_map_free(struct bpf_map *map)
+{ }
+
+static inline int security_bpf_prog_alloc(struct bpf_prog_aux *aux)
+{
+	return 0;
+}
+
+static inline void security_bpf_prog_free(struct bpf_prog_aux *aux)
+{ }
+#endif /* CONFIG_SECURITY */
+#endif /* CONFIG_BPF_SYSCALL */
+
 #ifdef CONFIG_SECURITY
 
 static inline char *alloc_secdata(void)
diff --git a/include/linux/serial_core.h b/include/linux/serial_core.h
index eb4f645..c7dff69 100644
--- a/include/linux/serial_core.h
+++ b/include/linux/serial_core.h
@@ -66,6 +66,7 @@ struct uart_ops {
 	void		(*set_ldisc)(struct uart_port *, struct ktermios *);
 	void		(*pm)(struct uart_port *, unsigned int state,
 			      unsigned int oldstate);
+	void		(*wake_peer)(struct uart_port *);
 
 	/*
 	 * Return a string describing the type of the port
diff --git a/include/linux/sock_diag.h b/include/linux/sock_diag.h
index a0596ca0..a2f8109 100644
--- a/include/linux/sock_diag.h
+++ b/include/linux/sock_diag.h
@@ -24,6 +24,7 @@ struct sock_diag_handler {
 void sock_diag_register_inet_compat(int (*fn)(struct sk_buff *skb, struct nlmsghdr *nlh));
 void sock_diag_unregister_inet_compat(int (*fn)(struct sk_buff *skb, struct nlmsghdr *nlh));
 
+u64 sock_gen_cookie(struct sock *sk);
 int sock_diag_check_cookie(struct sock *sk, const __u32 *cookie);
 void sock_diag_save_cookie(struct sock *sk, __u32 *cookie);
 
diff --git a/include/linux/string.h b/include/linux/string.h
index 60042e5..5da7f44 100644
--- a/include/linux/string.h
+++ b/include/linux/string.h
@@ -76,6 +76,7 @@ static inline __must_check char *strstrip(char *str)
 #endif
 #ifndef __HAVE_ARCH_STRNSTR
 extern char * strnstr(const char *, const char *, size_t);
+extern void * memmem(const void *, size_t, const void *, size_t);
 #endif
 #ifndef __HAVE_ARCH_STRLEN
 extern __kernel_size_t strlen(const char *);
diff --git a/include/linux/suspend.h b/include/linux/suspend.h
index 249dafc..219d032 100644
--- a/include/linux/suspend.h
+++ b/include/linux/suspend.h
@@ -39,6 +39,10 @@ static inline void pm_restore_console(void)
 #define PM_SUSPEND_MIN		PM_SUSPEND_FREEZE
 #define PM_SUSPEND_MAX		((__force suspend_state_t) 4)
 
+#ifdef CONFIG_RTK_PLATFORM
+extern int RTK_PM_STATE;
+#endif /* CONFIG_RTK_PLATFORM */
+
 enum suspend_stat_step {
 	SUSPEND_FREEZE = 1,
 	SUSPEND_PREPARE,
@@ -436,6 +440,7 @@ static inline void hibernation_set_ops(const struct platform_hibernation_ops *op
 extern bool pm_save_wakeup_count(unsigned int count);
 extern void pm_wakep_autosleep_enabled(bool set);
 extern void pm_print_active_wakeup_sources(void);
+extern void pm_get_active_wakeup_sources(char *pending_sources, size_t max);
 
 static inline void lock_system_sleep(void)
 {
diff --git a/include/linux/switch.h b/include/linux/switch.h
new file mode 100644
index 00000000..3e4c748
--- /dev/null
+++ b/include/linux/switch.h
@@ -0,0 +1,53 @@
+/*
+ *  Switch class driver
+ *
+ * Copyright (C) 2008 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+*/
+
+#ifndef __LINUX_SWITCH_H__
+#define __LINUX_SWITCH_H__
+
+struct switch_dev {
+	const char	*name;
+	struct device	*dev;
+	int		index;
+	int		state;
+
+	ssize_t	(*print_name)(struct switch_dev *sdev, char *buf);
+	ssize_t	(*print_state)(struct switch_dev *sdev, char *buf);
+};
+
+struct gpio_switch_platform_data {
+	const char *name;
+	unsigned 	gpio;
+
+	/* if NULL, switch_dev.name will be printed */
+	const char *name_on;
+	const char *name_off;
+	/* if NULL, "0" or "1" will be printed */
+	const char *state_on;
+	const char *state_off;
+};
+
+extern int switch_dev_register(struct switch_dev *sdev);
+extern void switch_dev_unregister(struct switch_dev *sdev);
+
+static inline int switch_get_state(struct switch_dev *sdev)
+{
+	return sdev->state;
+}
+
+extern void switch_set_state(struct switch_dev *sdev, int state);
+
+#endif /* __LINUX_SWITCH_H__ */
diff --git a/include/linux/sync_file.h b/include/linux/sync_file.h
index aa17ccf..2f99f87 100644
--- a/include/linux/sync_file.h
+++ b/include/linux/sync_file.h
@@ -40,14 +40,18 @@ struct sync_file {
 #endif
 
 	wait_queue_head_t	wq;
+	unsigned long		flags;
 
 	struct fence		*fence;
 	struct fence_cb cb;
 };
 
-#define POLL_ENABLED FENCE_FLAG_USER_BITS
+#define POLL_ENABLED 0
 
+#ifdef CONFIG_RTK_PLATFORM
 struct sync_file *sync_file_create(struct fence *fence);
 struct fence *sync_file_get_fence(int fd);
+struct sync_file *sync_file_fdget(int fd);
+#endif /* CONFIG_RTK_PLATFORM */
 
 #endif /* _LINUX_SYNC_H */
diff --git a/include/linux/sysfs.h b/include/linux/sysfs.h
index 00a1f33..9c452f6 100644
--- a/include/linux/sysfs.h
+++ b/include/linux/sysfs.h
@@ -518,7 +518,7 @@ static inline void sysfs_notify_dirent(struct kernfs_node *kn)
 }
 
 static inline struct kernfs_node *sysfs_get_dirent(struct kernfs_node *parent,
-						   const unsigned char *name)
+						   const char *name)
 {
 	return kernfs_find_and_get(parent, name);
 }
diff --git a/include/linux/task_io_accounting.h b/include/linux/task_io_accounting.h
index bdf855c..2dd338f 100644
--- a/include/linux/task_io_accounting.h
+++ b/include/linux/task_io_accounting.h
@@ -18,6 +18,8 @@ struct task_io_accounting {
 	u64 syscr;
 	/* # of write syscalls */
 	u64 syscw;
+	/* # of fsync syscalls */
+	u64 syscfs;
 #endif /* CONFIG_TASK_XACCT */
 
 #ifdef CONFIG_TASK_IO_ACCOUNTING
diff --git a/include/linux/task_io_accounting_ops.h b/include/linux/task_io_accounting_ops.h
index 4d090f9..1b505c8 100644
--- a/include/linux/task_io_accounting_ops.h
+++ b/include/linux/task_io_accounting_ops.h
@@ -96,6 +96,7 @@ static inline void task_chr_io_accounting_add(struct task_io_accounting *dst,
 	dst->wchar += src->wchar;
 	dst->syscr += src->syscr;
 	dst->syscw += src->syscw;
+	dst->syscfs += src->syscfs;
 }
 #else
 static inline void task_chr_io_accounting_add(struct task_io_accounting *dst,
diff --git a/include/linux/tcp.h b/include/linux/tcp.h
index d0c3615..b8ea15a 100644
--- a/include/linux/tcp.h
+++ b/include/linux/tcp.h
@@ -219,8 +219,9 @@ struct tcp_sock {
 	} rack;
 	u16	advmss;		/* Advertised MSS			*/
 	u8	rate_app_limited:1,  /* rate_{delivered,interval_us} limited? */
+		fastopen_connect:1, /* FASTOPEN_CONNECT sockopt */
 		is_sack_reneg:1,    /* in recovery from loss with SACK reneg? */
-		unused:6;
+		unused:5;
 	u8	nonagle     : 4,/* Disable Nagle algorithm?             */
 		thin_lto    : 1,/* Use linear timeouts for thin streams */
 		thin_dupack : 1,/* Fast retransmit on first dupack      */
diff --git a/include/linux/tee_drv.h b/include/linux/tee_drv.h
new file mode 100644
index 00000000..18d966b
--- /dev/null
+++ b/include/linux/tee_drv.h
@@ -0,0 +1,497 @@
+/*
+ * Copyright (c) 2015-2016, Linaro Limited
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef __TEE_DRV_H
+#define __TEE_DRV_H
+
+#include <linux/types.h>
+#include <linux/idr.h>
+#include <linux/kref.h>
+#include <linux/list.h>
+#include <linux/tee.h>
+
+/*
+ * The file describes the API provided by the generic TEE driver to the
+ * specific TEE driver.
+ */
+
+#define TEE_SHM_MAPPED		BIT(0)	/* Memory mapped by the kernel */
+#define TEE_SHM_DMA_BUF		BIT(1)	/* Memory with dma-buf handle */
+#define TEE_SHM_EXT_DMA_BUF	BIT(2)	/* Memory with dma-buf handle */
+#define TEE_SHM_REGISTER	BIT(3)  /* Memory registered in secure world */
+#define TEE_SHM_USER_MAPPED	BIT(4)  /* Memory mapped in user space */
+#define TEE_SHM_POOL		BIT(5)  /* Memory allocated from pool */
+
+struct device;
+struct tee_device;
+struct tee_shm;
+struct tee_shm_pool;
+
+/**
+ * struct tee_context - driver specific context on file pointer data
+ * @teedev:	pointer to this drivers struct tee_device
+ * @list_shm:	List of shared memory object owned by this context
+ * @data:	driver specific context data, managed by the driver
+ * @refcount:	reference counter for this structure
+ * @releasing:  flag that indicates if context is being released right now.
+ *		It is needed to break circular dependency on context during
+ *              shared memory release.
+ */
+struct tee_context {
+	struct tee_device *teedev;
+	struct list_head list_shm;
+	void *data;
+	struct kref refcount;
+	bool releasing;
+};
+
+struct tee_param_memref {
+	size_t shm_offs;
+	size_t size;
+	struct tee_shm *shm;
+};
+
+struct tee_param_value {
+	u64 a;
+	u64 b;
+	u64 c;
+};
+
+struct tee_param {
+	u64 attr;
+	union {
+		struct tee_param_memref memref;
+		struct tee_param_value value;
+	} u;
+};
+
+/**
+ * struct tee_driver_ops - driver operations vtable
+ * @get_version:	returns version of driver
+ * @open:		called when the device file is opened
+ * @release:		release this open file
+ * @open_session:	open a new session
+ * @close_session:	close a session
+ * @invoke_func:	invoke a trusted function
+ * @cancel_req:		request cancel of an ongoing invoke or open
+ * @supp_revc:		called for supplicant to get a command
+ * @supp_send:		called for supplicant to send a response
+ * @shm_register:	register shared memory buffer in TEE
+ * @shm_unregister:	unregister shared memory buffer in TEE
+ */
+struct tee_driver_ops {
+	void (*get_version)(struct tee_device *teedev,
+			    struct tee_ioctl_version_data *vers);
+	int (*open)(struct tee_context *ctx);
+	void (*release)(struct tee_context *ctx);
+	int (*open_session)(struct tee_context *ctx,
+			    struct tee_ioctl_open_session_arg *arg,
+			    struct tee_param *param);
+	int (*close_session)(struct tee_context *ctx, u32 session);
+	int (*invoke_func)(struct tee_context *ctx,
+			   struct tee_ioctl_invoke_arg *arg,
+			   struct tee_param *param);
+	int (*cancel_req)(struct tee_context *ctx, u32 cancel_id, u32 session);
+	int (*supp_recv)(struct tee_context *ctx, u32 *func, u32 *num_params,
+			 struct tee_param *param);
+	int (*supp_send)(struct tee_context *ctx, u32 ret, u32 num_params,
+			 struct tee_param *param);
+	int (*shm_register)(struct tee_context *ctx, struct tee_shm *shm,
+			    struct page **pages, size_t num_pages,
+			    unsigned long start);
+	int (*shm_unregister)(struct tee_context *ctx, struct tee_shm *shm);
+};
+
+/**
+ * struct tee_desc - Describes the TEE driver to the subsystem
+ * @name:	name of driver
+ * @ops:	driver operations vtable
+ * @owner:	module providing the driver
+ * @flags:	Extra properties of driver, defined by TEE_DESC_* below
+ */
+#define TEE_DESC_PRIVILEGED	0x1
+struct tee_desc {
+	const char *name;
+	const struct tee_driver_ops *ops;
+	struct module *owner;
+	u32 flags;
+};
+
+/**
+ * tee_device_alloc() - Allocate a new struct tee_device instance
+ * @teedesc:	Descriptor for this driver
+ * @dev:	Parent device for this device
+ * @pool:	Shared memory pool, NULL if not used
+ * @driver_data: Private driver data for this device
+ *
+ * Allocates a new struct tee_device instance. The device is
+ * removed by tee_device_unregister().
+ *
+ * @returns a pointer to a 'struct tee_device' or an ERR_PTR on failure
+ */
+struct tee_device *tee_device_alloc(const struct tee_desc *teedesc,
+				    struct device *dev,
+				    struct tee_shm_pool *pool,
+				    void *driver_data);
+
+/**
+ * tee_device_register() - Registers a TEE device
+ * @teedev:	Device to register
+ *
+ * tee_device_unregister() need to be called to remove the @teedev if
+ * this function fails.
+ *
+ * @returns < 0 on failure
+ */
+int tee_device_register(struct tee_device *teedev);
+
+/**
+ * tee_device_unregister() - Removes a TEE device
+ * @teedev:	Device to unregister
+ *
+ * This function should be called to remove the @teedev even if
+ * tee_device_register() hasn't been called yet. Does nothing if
+ * @teedev is NULL.
+ */
+void tee_device_unregister(struct tee_device *teedev);
+
+/**
+ * struct tee_shm - shared memory object
+ * @teedev:	device used to allocate the object
+ * @ctx:	context using the object, if NULL the context is gone
+ * @link	link element
+ * @paddr:	physical address of the shared memory
+ * @kaddr:	virtual address of the shared memory
+ * @size:	size of shared memory
+ * @offset:	offset of buffer in user space
+ * @pages:	locked pages from userspace
+ * @num_pages:	number of locked pages
+ * @dmabuf:	dmabuf used to for exporting to user space
+ * @flags:	defined by TEE_SHM_* in tee_drv.h
+ * @id:		unique id of a shared memory object on this device
+ *
+ * This pool is only supposed to be accessed directly from the TEE
+ * subsystem and from drivers that implements their own shm pool manager.
+ */
+struct tee_shm {
+	struct tee_device *teedev;
+	struct tee_context *ctx;
+	struct list_head link;
+	phys_addr_t paddr;
+	void *kaddr;
+	size_t size;
+	unsigned int offset;
+	struct page **pages;
+	size_t num_pages;
+	struct dma_buf *dmabuf;
+	u32 flags;
+	int id;
+};
+
+/**
+ * struct tee_shm_pool_mgr - shared memory manager
+ * @ops:		operations
+ * @private_data:	private data for the shared memory manager
+ */
+struct tee_shm_pool_mgr {
+	const struct tee_shm_pool_mgr_ops *ops;
+	void *private_data;
+};
+
+/**
+ * struct tee_shm_pool_mgr_ops - shared memory pool manager operations
+ * @alloc:		called when allocating shared memory
+ * @free:		called when freeing shared memory
+ * @destroy_poolmgr:	called when destroying the pool manager
+ */
+struct tee_shm_pool_mgr_ops {
+	int (*alloc)(struct tee_shm_pool_mgr *poolmgr, struct tee_shm *shm,
+		     size_t size);
+	void (*free)(struct tee_shm_pool_mgr *poolmgr, struct tee_shm *shm);
+	void (*destroy_poolmgr)(struct tee_shm_pool_mgr *poolmgr);
+};
+
+/**
+ * tee_shm_pool_alloc() - Create a shared memory pool from shm managers
+ * @priv_mgr:	manager for driver private shared memory allocations
+ * @dmabuf_mgr:	manager for dma-buf shared memory allocations
+ *
+ * Allocation with the flag TEE_SHM_DMA_BUF set will use the range supplied
+ * in @dmabuf, others will use the range provided by @priv.
+ *
+ * @returns pointer to a 'struct tee_shm_pool' or an ERR_PTR on failure.
+ */
+struct tee_shm_pool *tee_shm_pool_alloc(struct tee_shm_pool_mgr *priv_mgr,
+					struct tee_shm_pool_mgr *dmabuf_mgr);
+
+/*
+ * tee_shm_pool_mgr_alloc_res_mem() - Create a shm manager for reserved
+ * memory
+ * @vaddr:	Virtual address of start of pool
+ * @paddr:	Physical address of start of pool
+ * @size:	Size in bytes of the pool
+ *
+ * @returns pointer to a 'struct tee_shm_pool_mgr' or an ERR_PTR on failure.
+ */
+struct tee_shm_pool_mgr *tee_shm_pool_mgr_alloc_res_mem(unsigned long vaddr,
+							phys_addr_t paddr,
+							size_t size,
+							int min_alloc_order);
+
+/**
+ * tee_shm_pool_mgr_destroy() - Free a shared memory manager
+ */
+static inline void tee_shm_pool_mgr_destroy(struct tee_shm_pool_mgr *poolm)
+{
+	poolm->ops->destroy_poolmgr(poolm);
+}
+
+/**
+ * struct tee_shm_pool_mem_info - holds information needed to create a shared
+ * memory pool
+ * @vaddr:	Virtual address of start of pool
+ * @paddr:	Physical address of start of pool
+ * @size:	Size in bytes of the pool
+ */
+struct tee_shm_pool_mem_info {
+	unsigned long vaddr;
+	phys_addr_t paddr;
+	size_t size;
+};
+
+/**
+ * tee_shm_pool_alloc_res_mem() - Create a shared memory pool from reserved
+ * memory range
+ * @priv_info:	 Information for driver private shared memory pool
+ * @dmabuf_info: Information for dma-buf shared memory pool
+ *
+ * Start and end of pools will must be page aligned.
+ *
+ * Allocation with the flag TEE_SHM_DMA_BUF set will use the range supplied
+ * in @dmabuf, others will use the range provided by @priv.
+ *
+ * @returns pointer to a 'struct tee_shm_pool' or an ERR_PTR on failure.
+ */
+struct tee_shm_pool *
+tee_shm_pool_alloc_res_mem(struct tee_shm_pool_mem_info *priv_info,
+			   struct tee_shm_pool_mem_info *dmabuf_info);
+
+/**
+ * tee_shm_pool_free() - Free a shared memory pool
+ * @pool:	The shared memory pool to free
+ *
+ * The must be no remaining shared memory allocated from this pool when
+ * this function is called.
+ */
+void tee_shm_pool_free(struct tee_shm_pool *pool);
+
+/**
+ * tee_get_drvdata() - Return driver_data pointer
+ * @returns the driver_data pointer supplied to tee_register().
+ */
+void *tee_get_drvdata(struct tee_device *teedev);
+
+/**
+ * tee_shm_alloc() - Allocate shared memory
+ * @ctx:	Context that allocates the shared memory
+ * @size:	Requested size of shared memory
+ * @flags:	Flags setting properties for the requested shared memory.
+ *
+ * Memory allocated as global shared memory is automatically freed when the
+ * TEE file pointer is closed. The @flags field uses the bits defined by
+ * TEE_SHM_* above. TEE_SHM_MAPPED must currently always be set. If
+ * TEE_SHM_DMA_BUF global shared memory will be allocated and associated
+ * with a dma-buf handle, else driver private memory.
+ *
+ * @returns a pointer to 'struct tee_shm'
+ */
+struct tee_shm *tee_shm_alloc(struct tee_context *ctx, size_t size, u32 flags);
+
+/**
+ * tee_shm_priv_alloc() - Allocate shared memory privately
+ * @dev:	Device that allocates the shared memory
+ * @size:	Requested size of shared memory
+ *
+ * Allocates shared memory buffer that is not associated with any client
+ * context. Such buffers are owned by TEE driver and used for internal calls.
+ *
+ * @returns a pointer to 'struct tee_shm'
+ */
+struct tee_shm *tee_shm_priv_alloc(struct tee_device *teedev, size_t size);
+
+/**
+ * tee_shm_register() - Register shared memory buffer
+ * @ctx:	Context that registers the shared memory
+ * @addr:	Address is userspace of the shared buffer
+ * @length:	Length of the shared buffer
+ * @flags:	Flags setting properties for the requested shared memory.
+ *
+ * @returns a pointer to 'struct tee_shm'
+ */
+struct tee_shm *tee_shm_register(struct tee_context *ctx, unsigned long addr,
+				 size_t length, u32 flags);
+
+/**
+ * tee_shm_is_registered() - Check if shared memory object in registered in TEE
+ * @shm:	Shared memory handle
+ * @returns true if object is registered in TEE
+ */
+static inline bool tee_shm_is_registered(struct tee_shm *shm)
+{
+	return shm && (shm->flags & TEE_SHM_REGISTER);
+}
+
+/**
+ * tee_shm_register_fd() - Register shared memory from file descriptor
+ *
+ * @ctx:	Context that allocates the shared memory
+ * @fd:		shared memory file descriptor reference.
+ *
+ * @returns a pointer to 'struct tee_shm'
+ */
+struct tee_shm *tee_shm_register_fd(struct tee_context *ctx, int fd);
+
+/**
+ * tee_shm_free() - Free shared memory
+ * @shm:	Handle to shared memory to free
+ */
+void tee_shm_free(struct tee_shm *shm);
+
+/**
+ * tee_shm_put() - Decrease reference count on a shared memory handle
+ * @shm:	Shared memory handle
+ */
+void tee_shm_put(struct tee_shm *shm);
+
+/**
+ * tee_shm_va2pa() - Get physical address of a virtual address
+ * @shm:	Shared memory handle
+ * @va:		Virtual address to tranlsate
+ * @pa:		Returned physical address
+ * @returns 0 on success and < 0 on failure
+ */
+int tee_shm_va2pa(struct tee_shm *shm, void *va, phys_addr_t *pa);
+
+/**
+ * tee_shm_pa2va() - Get virtual address of a physical address
+ * @shm:	Shared memory handle
+ * @pa:		Physical address to tranlsate
+ * @va:		Returned virtual address
+ * @returns 0 on success and < 0 on failure
+ */
+int tee_shm_pa2va(struct tee_shm *shm, phys_addr_t pa, void **va);
+
+/**
+ * tee_shm_get_va() - Get virtual address of a shared memory plus an offset
+ * @shm:	Shared memory handle
+ * @offs:	Offset from start of this shared memory
+ * @returns virtual address of the shared memory + offs if offs is within
+ *	the bounds of this shared memory, else an ERR_PTR
+ */
+void *tee_shm_get_va(struct tee_shm *shm, size_t offs);
+
+/**
+ * tee_shm_get_pa() - Get physical address of a shared memory plus an offset
+ * @shm:	Shared memory handle
+ * @offs:	Offset from start of this shared memory
+ * @pa:		Physical address to return
+ * @returns 0 if offs is within the bounds of this shared memory, else an
+ *	error code.
+ */
+int tee_shm_get_pa(struct tee_shm *shm, size_t offs, phys_addr_t *pa);
+
+/**
+ * tee_shm_get_size() - Get size of shared memory buffer
+ * @shm:	Shared memory handle
+ * @returns size of shared memory
+ */
+static inline size_t tee_shm_get_size(struct tee_shm *shm)
+{
+	return shm->size;
+}
+
+/**
+ * tee_shm_get_pages() - Get list of pages that hold shared buffer
+ * @shm:	Shared memory handle
+ * @num_pages:	Number of pages will be stored there
+ * @returns pointer to pages array
+ */
+static inline struct page **tee_shm_get_pages(struct tee_shm *shm,
+					      size_t *num_pages)
+{
+	*num_pages = shm->num_pages;
+	return shm->pages;
+}
+
+/**
+ * tee_shm_get_page_offset() - Get shared buffer offset from page start
+ * @shm:	Shared memory handle
+ * @returns page offset of shared buffer
+ */
+static inline size_t tee_shm_get_page_offset(struct tee_shm *shm)
+{
+	return shm->offset;
+}
+
+/**
+ * tee_shm_get_id() - Get id of a shared memory object
+ * @shm:	Shared memory handle
+ * @returns id
+ */
+static inline int tee_shm_get_id(struct tee_shm *shm)
+{
+	return shm->id;
+}
+
+/**
+ * tee_shm_get_from_id() - Find shared memory object and increase reference
+ * count
+ * @ctx:	Context owning the shared memory
+ * @id:		Id of shared memory object
+ * @returns a pointer to 'struct tee_shm' on success or an ERR_PTR on failure
+ */
+struct tee_shm *tee_shm_get_from_id(struct tee_context *ctx, int id);
+
+struct tee_context *tee_client_open_context(struct tee_context *start,
+			int (*match)(struct tee_ioctl_version_data *,
+				const void *),
+			const void *data, struct tee_ioctl_version_data *vers);
+
+void tee_client_close_context(struct tee_context *ctx);
+
+void tee_client_get_version(struct tee_context *ctx,
+			struct tee_ioctl_version_data *vers);
+
+int tee_client_open_session(struct tee_context *ctx,
+			struct tee_ioctl_open_session_arg *arg,
+			struct tee_param *param);
+
+int tee_client_close_session(struct tee_context *ctx, u32 session);
+
+int tee_client_invoke_func(struct tee_context *ctx,
+			struct tee_ioctl_invoke_arg *arg,
+			struct tee_param *param);
+static inline bool tee_param_is_memref(struct tee_param *param)
+{
+	switch (param->attr & TEE_IOCTL_PARAM_ATTR_TYPE_MASK) {
+	case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT:
+	case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_OUTPUT:
+	case TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT:
+		return true;
+	default:
+		return false;
+	}
+}
+
+#endif /*__TEE_DRV_H*/
diff --git a/include/linux/thread_info.h b/include/linux/thread_info.h
index 5e64367..ce98a8e 100644
--- a/include/linux/thread_info.h
+++ b/include/linux/thread_info.h
@@ -9,50 +9,17 @@
 
 #include <linux/types.h>
 #include <linux/bug.h>
-
-struct timespec;
-struct compat_timespec;
+#include <linux/restart_block.h>
 
 #ifdef CONFIG_THREAD_INFO_IN_TASK
-#define current_thread_info() ((struct thread_info *)current)
-#endif
-
 /*
- * System call restart block.
+ * For CONFIG_THREAD_INFO_IN_TASK kernels we need <asm/current.h> for the
+ * definition of current, but for !CONFIG_THREAD_INFO_IN_TASK kernels,
+ * including <asm/current.h> can cause a circular dependency on some platforms.
  */
-struct restart_block {
-	long (*fn)(struct restart_block *);
-	union {
-		/* For futex_wait and futex_wait_requeue_pi */
-		struct {
-			u32 __user *uaddr;
-			u32 val;
-			u32 flags;
-			u32 bitset;
-			u64 time;
-			u32 __user *uaddr2;
-		} futex;
-		/* For nanosleep */
-		struct {
-			clockid_t clockid;
-			struct timespec __user *rmtp;
-#ifdef CONFIG_COMPAT
-			struct compat_timespec __user *compat_rmtp;
+#include <asm/current.h>
+#define current_thread_info() ((struct thread_info *)current)
 #endif
-			u64 expires;
-		} nanosleep;
-		/* For poll */
-		struct {
-			struct pollfd __user *ufds;
-			int nfds;
-			int has_timeout;
-			unsigned long tv_sec;
-			unsigned long tv_nsec;
-		} poll;
-	};
-};
-
-extern long do_no_restart_syscall(struct restart_block *parm);
 
 #include <linux/bitops.h>
 #include <asm/thread_info.h>
diff --git a/include/linux/tick.h b/include/linux/tick.h
index 62be0786..78ec2eb 100644
--- a/include/linux/tick.h
+++ b/include/linux/tick.h
@@ -117,6 +117,7 @@ enum tick_dep_bits {
 extern void tick_nohz_idle_exit(void);
 extern void tick_nohz_irq_exit(void);
 extern ktime_t tick_nohz_get_sleep_length(void);
+extern unsigned long tick_nohz_get_idle_calls(void);
 extern u64 get_cpu_idle_time_us(int cpu, u64 *last_update_time);
 extern u64 get_cpu_iowait_time_us(int cpu, u64 *last_update_time);
 #else /* !CONFIG_NO_HZ_COMMON */
diff --git a/include/linux/timekeeper_internal.h b/include/linux/timekeeper_internal.h
index 2c225d4..dfc80b7 100644
--- a/include/linux/timekeeper_internal.h
+++ b/include/linux/timekeeper_internal.h
@@ -51,7 +51,7 @@ struct tk_read_base {
  * @clock_was_set_seq:	The sequence number of clock was set events
  * @cs_was_changed_seq:	The sequence number of clocksource change events
  * @next_leap_ktime:	CLOCK_MONOTONIC time value of a pending leap-second
- * @raw_time:		Monotonic raw base time in timespec64 format
+ * @raw_sec:		CLOCK_MONOTONIC_RAW  time in seconds
  * @cycle_interval:	Number of clock cycles in one NTP interval
  * @xtime_interval:	Number of clock shifted nano seconds in one NTP
  *			interval.
@@ -93,7 +93,7 @@ struct timekeeper {
 	unsigned int		clock_was_set_seq;
 	u8			cs_was_changed_seq;
 	ktime_t			next_leap_ktime;
-	struct timespec64	raw_time;
+	u64			raw_sec;
 
 	/* The following members are for timekeeping internal use */
 	cycle_t			cycle_interval;
diff --git a/include/linux/timekeeping.h b/include/linux/timekeeping.h
index 09168c5..361f8bf 100644
--- a/include/linux/timekeeping.h
+++ b/include/linux/timekeeping.h
@@ -249,6 +249,7 @@ static inline u64 ktime_get_raw_ns(void)
 
 extern u64 ktime_get_mono_fast_ns(void);
 extern u64 ktime_get_raw_fast_ns(void);
+extern u64 ktime_get_boot_fast_ns(void);
 
 /*
  * Timespec interfaces utilizing the ktime based ones
diff --git a/include/linux/uio_driver.h b/include/linux/uio_driver.h
index 32c0e83..d4a0428 100644
--- a/include/linux/uio_driver.h
+++ b/include/linux/uio_driver.h
@@ -100,6 +100,9 @@ struct uio_info {
 	long			irq;
 	unsigned long		irq_flags;
 	void			*priv;
+#ifdef CONFIG_UIO_ASSIGN_MINOR
+	int	minor;
+#endif
 	irqreturn_t (*handler)(int irq, struct uio_info *dev_info);
 	int (*mmap)(struct uio_info *info, struct vm_area_struct *vma);
 	int (*open)(struct uio_info *info, struct inode *inode);
diff --git a/include/linux/ump-common.h b/include/linux/ump-common.h
new file mode 100644
index 00000000..0015bda
--- /dev/null
+++ b/include/linux/ump-common.h
@@ -0,0 +1,252 @@
+/*
+ *
+ * (C) COPYRIGHT 2010-2013 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+
+
+/**
+ * @file ump-common.h
+ *
+ * This file contains some common enum values used both in both the user and kernel space side of UMP.
+ */
+
+#ifndef _UMP_COMMON_H_
+#define _UMP_COMMON_H_
+
+#ifdef __cplusplus
+extern "C"
+{
+#endif
+
+#ifdef __KERNEL__
+#include <linux/types.h>
+#else
+#include <stdint.h>
+#endif
+
+#define UMP_UINT32_MAX (4294967295U)
+#define UMP_UINT64_MAX (18446744073709551615ULL)
+
+#ifdef __GNUC__
+	#define CHECK_RESULT        __attribute__((__warn_unused_result__))
+	#define INLINE	__inline__
+#else
+	#define CHECK_RESULT
+	#define INLINE __inline
+#endif
+
+#ifndef STATIC
+	#define STATIC static
+#endif
+
+/**
+ * Values to identify major and minor version of UMP
+ */
+#define UMP_VERSION_MAJOR 2
+#define UMP_VERSION_MINOR 0
+
+/**
+ * Typedef for a secure ID, a system wide identifier for UMP memory buffers.
+ */
+typedef int32_t ump_secure_id;
+
+/**
+ * Value to indicate an invalid secure Id.
+ */
+#define UMP_INVALID_SECURE_ID  ((ump_secure_id)0)
+
+/**
+ * UMP error codes.
+ */
+typedef enum
+{
+	UMP_OK    = 0, /**< indicates success */
+	UMP_ERROR = 1  /**< indicates failure */
+} ump_result;
+
+/**
+ * Allocation flag bits.
+ *
+ * ump_allocate accepts zero or more flags to specify the type of memory to allocate and how to expose it to devices.
+ *
+ * For each supported device there are 4 flags to control access permissions and give usage characteristic hints to optimize the allocation/mapping.
+ * They are;
+ * @li @a UMP_PROT_<device>_RD   read permission
+ * @li @a UMP_PROT_<device>_WR   write permission
+ * @li @a UMP_HINT_<device>_RD   read often
+ * @li @a UMP_HINT_<device>_WR   written often
+ *
+ * 5 devices are currently supported, with a device being the CPU itself.
+ * The other 4 devices will be mapped to real devices per SoC design.
+ * They are just named W,X,Y,Z by UMP as it has no knowledge of their real names/identifiers.
+ * As an example device W could be a camera device while device Z could be an ARM GPU device, leaving X and Y unused.
+ *
+ * 2 additional flags control the allocation;
+ * @li @a UMP_CONSTRAINT_PHYSICALLY_LINEAR   the allocation must be physical linear. Typical for devices without an MMU and no IOMMU to help it.
+ * @li @a UMP_PROT_SHAREABLE                 the allocation can be shared with other processes on the system. Without this flag the returned allocation won't be resolvable in other processes.
+ *
+ * All UMP allocation are growable unless they're @a UMP_PROT_SHAREABLE.
+ * The hint bits should be used to indicate the access pattern so the driver can select the most optimal memory type and cache settings based on the what the system supports.
+ */
+typedef enum
+{
+	/* Generic helpers */
+	UMP_PROT_DEVICE_RD = (1u << 0),
+	UMP_PROT_DEVICE_WR = (1u << 1),
+	UMP_HINT_DEVICE_RD = (1u << 2),
+	UMP_HINT_DEVICE_WR = (1u << 3),
+	UMP_DEVICE_MASK = 0xF,
+	UMP_DEVICE_CPU_SHIFT = 0,
+	UMP_DEVICE_W_SHIFT = 4,
+	UMP_DEVICE_X_SHIFT = 8,
+	UMP_DEVICE_Y_SHIFT = 12,
+	UMP_DEVICE_Z_SHIFT = 16,
+
+	/* CPU protection and hints. */
+	UMP_PROT_CPU_RD = (1u <<  0),
+	UMP_PROT_CPU_WR = (1u <<  1),
+	UMP_HINT_CPU_RD = (1u <<  2),
+	UMP_HINT_CPU_WR = (1u <<  3),
+
+	/* device W */
+	UMP_PROT_W_RD = (1u <<  4),
+	UMP_PROT_W_WR = (1u <<  5),
+	UMP_HINT_W_RD = (1u <<  6),
+	UMP_HINT_W_WR = (1u <<  7),
+
+	/* device X */
+	UMP_PROT_X_RD = (1u <<  8),
+	UMP_PROT_X_WR = (1u <<  9),
+	UMP_HINT_X_RD = (1u << 10),
+	UMP_HINT_X_WR = (1u << 11),
+	
+	/* device Y */
+	UMP_PROT_Y_RD = (1u << 12),
+	UMP_PROT_Y_WR = (1u << 13),
+	UMP_HINT_Y_RD = (1u << 14),
+	UMP_HINT_Y_WR = (1u << 15),
+
+	/* device Z */
+	UMP_PROT_Z_RD = (1u << 16),
+	UMP_PROT_Z_WR = (1u << 17),
+	UMP_HINT_Z_RD = (1u << 18),
+	UMP_HINT_Z_WR = (1u << 19),
+
+	/* 20-26 reserved for future use */
+	UMPP_ALLOCBITS_UNUSED = (0x7Fu << 20),
+	/** Allocations marked as @ UMP_CONSTRAINT_UNCACHED won't be mapped as cached by the cpu  */
+	UMP_CONSTRAINT_UNCACHED = (1u << 27),
+	/** Require 32-bit physically addressable memory */
+	UMP_CONSTRAINT_32BIT_ADDRESSABLE = (1u << 28),
+	/** For devices without an MMU and with no IOMMU assistance. */
+	UMP_CONSTRAINT_PHYSICALLY_LINEAR = (1u << 29),
+	/** Shareable must be set to allow the allocation to be used by other processes, the default is non-shared */
+	UMP_PROT_SHAREABLE = (1u << 30)
+	/* (1u << 31) should not be used to ensure compiler portability */
+} ump_allocation_bits;
+
+/**
+ * ump_allocation_bits combination argument type.
+ *
+ * Type used to pass zero or more bits from the @ref ump_allocation_bits enum
+ */
+typedef uint32_t ump_alloc_flags;
+
+
+/**
+ *  Default allocation flags for UMP v1 compatible allocations.
+ */
+#define UMP_V1_API_DEFAULT_ALLOCATION_FLAGS		UMP_PROT_CPU_RD | UMP_PROT_CPU_WR | \
+												UMP_PROT_W_RD | UMP_PROT_W_WR |	\
+												UMP_PROT_X_RD | UMP_PROT_X_WR |	\
+												UMP_PROT_Y_RD | UMP_PROT_Y_WR |	\
+												UMP_PROT_Z_RD | UMP_PROT_Z_WR |	\
+												UMP_PROT_SHAREABLE |	\
+												UMP_CONSTRAINT_32BIT_ADDRESSABLE
+
+/**
+ * CPU cache sync operations.
+ *
+ * Cache synchronization operations to pass to @ref ump_cpu_msync_now
+ */
+enum
+{
+	/**
+	 * Cleans any dirty cache lines to main memory, but the data will still be available in the cache.
+	 * After a clean the contents of memory is considered to be "owned" by the device.
+	 * */
+	UMP_MSYNC_CLEAN = 1,
+
+	/** Cleans any dirty cache lines to main memory and Ejects all lines from the cache.
+	 * After an clean&invalidate the contents of memory is considered to be "owned" by the CPU.
+	 * Any subsequent access will fetch data from main memory.
+	 *
+	 * @note Due to CPUs doing speculative prefetching a UMP_MSYNC_CLEAN_AND_INVALIDATE must be done before and after interacting with hardware.
+	 * */
+	UMP_MSYNC_CLEAN_AND_INVALIDATE
+
+};
+
+typedef uint32_t ump_cpu_msync_op;
+
+/**
+ * Memory import types supported.
+ * If new import types are added they will appear here.
+ * They must be added before UMPP_EXTERNAL_MEM_COUNT and
+ * must be assigned an explicit sequantial number.
+ *
+ * @li UMP_EXTERNAL_MEM_TYPE_ION - Import an ION allocation
+ *                                 Takes a int* (pointer to a file descriptor)
+ *                                 Another ION reference is taken which is released on the final ump_release
+ */
+enum ump_external_memory_type
+{
+	UMPP_EXTERNAL_MEM_TYPE_UNUSED = 0, /* reserve type 0 */
+	UMP_EXTERNAL_MEM_TYPE_ION = 1,
+	UMPP_EXTERNAL_MEM_COUNT
+};
+
+/** @name UMP v1 API
+ *
+ *@{
+ */
+
+/**
+ * Allocation constraints.
+ *
+ * Allocation flags to pass @ref ump_ref_drv_allocate
+ *
+ * UMP v1 API only.
+ */
+typedef enum
+{
+	/** the allocation is mapped as noncached. */
+	UMP_REF_DRV_CONSTRAINT_NONE = 0,
+	/** not supported. */
+	UMP_REF_DRV_CONSTRAINT_PHYSICALLY_LINEAR = 1,
+	/** the allocation is mapped as cached by the cpu. */
+	UMP_REF_DRV_CONSTRAINT_USE_CACHE = 4
+} ump_alloc_constraints;
+
+/* @} */
+
+
+#ifdef __cplusplus
+}
+#endif
+
+
+#endif /* _UMP_COMMON_H_ */
diff --git a/include/linux/ump-import.h b/include/linux/ump-import.h
new file mode 100644
index 00000000..89ce727
--- /dev/null
+++ b/include/linux/ump-import.h
@@ -0,0 +1,99 @@
+/*
+ *
+ * (C) COPYRIGHT 2011-2013 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+
+
+#ifndef _UMP_IMPORT_H_
+#define _UMP_IMPORT_H_
+
+#include <linux/ump.h>
+#include <linux/module.h>
+
+/**
+ * UMP import module info.
+ * Contains information about the Linux module providing the import module,
+ * used to block unloading of the Linux module while imported memory exists.
+ * Lists the functions implementing the UMP import functions.
+ */
+struct ump_import_handler
+{
+	/**
+	 * Linux module of the import handler
+	 */
+	struct module * linux_module;
+
+	/**
+	 * UMP session usage begin.
+	 *
+	 * Called when a UMP session first is bound to the handler.
+	 * Typically used to set up any import module specific per-session data.
+	 * The function returns a pointer to this data in the output pointer custom_session_data
+	 * which will be passed to \a session_end and \a import.
+	 *
+	 * Note: custom_session_data must be set to non-NULL if successful.
+	 * If no pointer is needed set it a magic value to validate instead.
+	 *
+	 * @param[out] custom_session_data Pointer to a generic pointer where any data can be stored
+	 * @return 0 on success, error code if the session could not be initiated.
+	 */
+	int (*session_begin)(void ** custom_session_data);
+
+	/**
+	 * UMP session usage end.
+	 *
+	 * Called when a UMP session is no longer using the handler.
+	 * Only called if @a session_begin returned OK.
+	 *
+	 * @param[in] custom_session_data The value set by the session_begin handler
+	 */
+	void (*session_end)(void * custom_session_data);
+
+	/**
+	 * Import request.
+	 *
+	 * Called when a client has asked to import a resource of the type the import module was installed for.
+	 * Only called if @a session_begin returned OK.
+	 *
+	 * The requested flags must be verified to be valid to apply to the imported memory.
+	 * If not valid return UMP_DD_INVALID_MEMORY_HANDLE.
+	 * If the flags are found to be valid call \a ump_dd_create_from_phys_blocks_64 to create a handle.
+	 *
+	 * @param[in] custom_session_data The value set by the session_begin handler
+	 * @param[in] phandle Pointer to the handle to import
+	 * @param     flags The requested UMPv2 flags to assign to the imported handle
+	 * @return UMP_DD_INVALID_MEMORY_HANDLE if the import failed, a valid ump handle on success
+	 */
+	ump_dd_handle (*import)(void * custom_session_data, void * phandle, ump_alloc_flags flags);
+};
+
+/**
+ * Import module registration.
+ * Registers a ump_import_handler structure for a memory type.
+ * @param     type    Type of the memory to register a handler for
+ * @param[in] handler Handler strcture to install
+ * @return 0 on success, a Linux error code on failure
+ */
+int ump_import_module_register(enum ump_external_memory_type type, struct ump_import_handler * handler);
+
+/**
+ * Import module deregistration.
+ * Uninstalls the handler for the given memory type.
+ * @param type Type of the memory to unregister the handler for
+ */
+void ump_import_module_unregister(enum ump_external_memory_type type);
+
+#endif /* _UMP_IMPORT_H_ */
diff --git a/include/linux/ump-ioctl.h b/include/linux/ump-ioctl.h
new file mode 100644
index 00000000..451403e
--- /dev/null
+++ b/include/linux/ump-ioctl.h
@@ -0,0 +1,152 @@
+/*
+ *
+ * (C) COPYRIGHT 2008-2013 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+
+
+#ifndef _UMP_IOCTL_H_
+#define _UMP_IOCTL_H
+
+#include <linux/ump-common.h>
+
+/*
+ * The order and size of the members of these have been chosen so the structures look the same in 32-bit and 64-bit builds.
+ * If any changes are done build the ump_struct_size_checker test for 32-bit and 64-bit targets. Both must compile successfully to commit.
+ */
+
+/** 32/64-bit neutral way to represent pointers */
+typedef union ump_pointer
+{
+	void * value; /**< client should store their pointers here */
+	uint32_t compat_value; /**< 64-bit kernels should fetch value here when handling 32-bit clients */
+	uint64_t sizer; /**< Force 64-bit storage for all clients regardless */
+} ump_pointer;
+
+/**
+ * UMP allocation request.
+ * Used when performing ump_allocate
+ */
+typedef struct ump_k_allocate
+{
+	uint64_t size; /**< [in] Size in bytes to allocate */
+	ump_secure_id secure_id; /**< [out] Secure ID of allocation on success */
+	ump_alloc_flags alloc_flags; /**< [in] Flags to use when allocating */
+} ump_k_allocate;
+
+/**
+ * UMP size query request.
+ * Used when performing ump_size_get
+ */
+typedef struct ump_k_sizequery
+{
+	uint64_t size; /**< [out] Size of allocation */
+	ump_secure_id secure_id; /**< [in] ID of allocation to query the size of */
+	uint32_t padding; /* don't remove */
+} ump_k_sizequery;
+
+/**
+ * UMP cache synchronization request.
+ * Used when performing ump_cpu_msync_now
+ */
+typedef struct ump_k_msync
+{
+	ump_pointer mapped_ptr; /**< [in] CPU VA to perform cache operation on */
+	ump_secure_id secure_id; /**< [in] ID of allocation to perform cache operation on */
+	ump_cpu_msync_op cache_operation; /**< [in] Cache operation to perform */
+	uint64_t size; /**< [in] Size in bytes of the range to synchronize */
+} ump_k_msync;
+
+/**
+ * UMP memory retain request.
+ * Used when performing ump_retain
+ */
+typedef struct ump_k_retain
+{
+	ump_secure_id secure_id; /**< [in] ID of allocation to retain a reference to */
+	uint32_t padding; /* don't remove */
+} ump_k_retain;
+
+/**
+ * UMP memory release request.
+ * Used when performing ump_release
+ */
+typedef struct ump_k_release
+{
+	ump_secure_id secure_id; /**< [in] ID of allocation to release a reference to */
+	uint32_t padding; /* don't remove */
+} ump_k_release;
+
+typedef struct ump_k_import
+{
+	ump_pointer phandle;                /**< [in]  Pointer to handle to import */
+	uint32_t type;                           /**< [in]  Type of handle to import */
+	ump_alloc_flags alloc_flags;        /**< [in]  Flags to assign to the imported memory */
+	ump_secure_id secure_id;            /**< [out] UMP ID representing the imported memory */
+	uint32_t padding;                        /* don't remove */
+} ump_k_import;
+
+/**
+ * UMP allocation flags request.
+ * Used when performing umpp_get_allocation_flags
+ *
+ * used only by v1 API
+ */
+typedef struct ump_k_allocation_flags
+{
+	ump_secure_id secure_id; /**< [in] Secure ID of allocation on success */
+	ump_alloc_flags alloc_flags; /**< [out] Flags to use when allocating */
+} ump_k_allocation_flags;
+
+#define UMP_CALL_MAX_SIZE 512
+/*
+ * Ioctl definitions
+ */
+
+/* Use '~' as magic number */
+
+#define UMP_IOC_MAGIC  '~'
+
+#define UMP_FUNC_ALLOCATE _IOWR(UMP_IOC_MAGIC,  1, ump_k_allocate)
+#define UMP_FUNC_SIZEQUERY _IOWR(UMP_IOC_MAGIC,  2, ump_k_sizequery)
+#define UMP_FUNC_MSYNC _IOWR(UMP_IOC_MAGIC,  3, ump_k_msync)
+#define UMP_FUNC_RETAIN _IOW(UMP_IOC_MAGIC,  4, ump_k_retain)
+#define UMP_FUNC_RELEASE _IOW(UMP_IOC_MAGIC,  5, ump_k_release)
+#define UMP_FUNC_ALLOCATION_FLAGS_GET _IOWR(UMP_IOC_MAGIC,  6, ump_k_allocation_flags)
+#define UMP_FUNC_IMPORT _IOWR(UMP_IOC_MAGIC, 7, ump_k_import)
+
+/*max ioctl sequential number*/
+#define UMP_IOC_MAXNR 7
+
+/* 15 bits for the UMP ID (allowing 32768 IDs) */
+#define UMP_LINUX_ID_BITS 15
+#define UMP_LINUX_ID_MASK ((1ULL << UMP_LINUX_ID_BITS) - 1ULL)
+
+/* 64-bit (really 52 bits) encoding: 15 bits for the ID, 37 bits for the offset */
+#define UMP_LINUX_OFFSET_BITS_64 37
+#define UMP_LINUX_OFFSET_MASK_64 ((1ULL << UMP_LINUX_OFFSET_BITS_64)-1)
+/* 32-bit encoding: 15 bits for the ID, 17 bits for the offset */
+#define UMP_LINUX_OFFSET_BITS_32 17
+#define UMP_LINUX_OFFSET_MASK_32 ((1ULL << UMP_LINUX_OFFSET_BITS_32)-1)
+
+#if __SIZEOF_LONG__ == 8
+#define UMP_LINUX_OFFSET_BITS UMP_LINUX_OFFSET_BITS_64
+#define UMP_LINUX_OFFSET_MASK UMP_LINUX_OFFSET_MASK_64
+#else
+#define UMP_LINUX_OFFSET_BITS UMP_LINUX_OFFSET_BITS_32
+#define UMP_LINUX_OFFSET_MASK UMP_LINUX_OFFSET_MASK_32
+#endif
+
+#endif /* _UMP_IOCTL_H_ */
diff --git a/include/linux/ump.h b/include/linux/ump.h
new file mode 100644
index 00000000..16f9c39
--- /dev/null
+++ b/include/linux/ump.h
@@ -0,0 +1,481 @@
+/*
+ *
+ * (C) COPYRIGHT 2008-2013, 2015 ARM Limited. All rights reserved.
+ *
+ * This program is free software and is provided to you under the terms of the
+ * GNU General Public License version 2 as published by the Free Software
+ * Foundation, and any use by you of this program is subject to the terms
+ * of such GNU licence.
+ *
+ * A copy of the licence is included with the program, and can also be obtained
+ * from Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA  02110-1301, USA.
+ *
+ */
+
+
+
+
+
+/**
+ * @file
+ *
+ * This file contains the kernel space part of the UMP API.
+ *
+ */
+
+#ifndef _UMP_KERNEL_INTERFACE_H_
+#define _UMP_KERNEL_INTERFACE_H_
+
+/**
+ * @addtogroup ump_api
+ * @{
+ */
+
+/** @defgroup ump_kernel_space_api UMP Kernel Space API
+ * @{ */
+
+/**
+ * External representation of a UMP handle in kernel space.
+ */
+typedef void * ump_dd_handle;
+
+#ifdef CONFIG_KDS
+#include <linux/kds.h>
+#endif
+
+#include <linux/ump-common.h>
+
+#define UMP_KERNEL_API_EXPORT
+
+#if defined(__KERNEL__)
+#include <linux/ump-import.h>
+#else
+#include <ump/src/library/common/ump_user.h>
+#endif
+
+#ifdef __cplusplus
+extern "C"
+{
+#endif
+
+/**
+ * Value to indicate an invalid UMP memory handle.
+ */
+#define UMP_DD_INVALID_MEMORY_HANDLE ((ump_dd_handle)0)
+
+/**
+ * Struct used to describe a physical block used by UMP memory
+ */
+typedef struct ump_dd_physical_block_64
+{
+	uint64_t addr; /**< The physical address of the block */
+	uint64_t size; /**< The length of the block, in bytes, typically page aligned */
+} ump_dd_physical_block_64;
+
+/**
+ * Security filter hook.
+ *
+ * Each allocation can have a security filter attached to it.@n
+ * The hook receives
+ * @li the secure ID
+ * @li a handle to the allocation
+ * @li  the callback_data argument provided to @ref ump_dd_allocate_64 or @ref ump_dd_create_from_phys_blocks_64
+ *
+ * The hook must return @a true to indicate that access to the handle is allowed or @n
+ * @a false to state that no access is permitted.@n
+ * This hook is guaranteed to be called in the context of the requesting process/address space.
+ *
+ * The arguments provided to the hook are;
+ * @li the secure ID
+ * @li handle to the allocation
+ * @li the callback_data set when registering the hook
+ *
+ * Return value;
+ * @li @a true to permit access
+ * @li @a false to deny access
+ */
+typedef bool (*ump_dd_security_filter)(ump_secure_id, ump_dd_handle, void *);
+
+/**
+ * Final release notify hook.
+ *
+ * Allocations can have a hook attached to them which is called when the last reference to the allocation is released.
+ * No reference count manipulation is allowed on the provided handle, just property querying (ID get, size get, phys block get).
+ * This is similar to finalizers in OO languages.
+ *
+ * The arguments provided to the hook are;
+ * * handle to the allocation
+ * * the callback_data set when registering the hook
+ */
+typedef void (*ump_dd_final_release_callback)(const ump_dd_handle, void *);
+
+/**
+ * Allocate a buffer.
+ * The lifetime of the allocation is controlled by a reference count.
+ * The reference count of the returned buffer is set to 1.
+ * The memory will be freed once the reference count reaches 0.
+ * Use @ref ump_dd_retain and @ref ump_dd_release to control the reference count.
+ * @param size Number of bytes to allocate. Will be padded up to a multiple of the page size.
+ * @param flags Bit-wise OR of zero or more of the allocation flag bits.
+ * @param[in] filter_func Pointer to a function which will be called when an allocation is required from a
+ * secure id before the allocation itself is returned to user-space.
+ * NULL permitted if no need for a callback.
+ * @param[in] final_release_func Pointer to a function which will be called when the last reference is removed,
+ * just before the allocation is freed. NULL permitted if no need for a callback.
+ * @param[in] callback_data An opaque pointer which will be provided to @a filter_func and @a final_release_func
+ * @return Handle to the new allocation, or @a UMP_DD_INVALID_MEMORY_HANDLE on allocation failure.
+ */
+UMP_KERNEL_API_EXPORT ump_dd_handle ump_dd_allocate_64(uint64_t size, ump_alloc_flags flags, ump_dd_security_filter filter_func, ump_dd_final_release_callback final_release_func, void* callback_data);
+
+
+/**
+ * Allocation bits getter.
+ * Retrieves the allocation flags used when instantiating the given handle.
+ * Just a copy of the flag given to @ref ump_dd_allocate_64 and @ref ump_dd_create_from_phys_blocks_64
+ * @param mem The handle retrieve the bits for
+ * @return The allocation bits used to instantiate the allocation
+ */
+UMP_KERNEL_API_EXPORT ump_alloc_flags ump_dd_allocation_flags_get(const ump_dd_handle mem);
+
+
+/**
+ * Retrieves the secure ID for the specified UMP memory.
+ *
+ * This identifier is unique across the entire system, and uniquely identifies
+ * the specified UMP memory allocation. This identifier can later be used through the
+ * @ref ump_dd_from_secure_id or
+ * @ref ump_from_secure_id
+ * functions in order to access this UMP memory, for instance from another process (if shared of course).
+ * Unless the allocation was marked as shared the returned ID will only be resolvable in the same process as did the allocation.
+ *
+ * Calling on an @a UMP_DD_INVALID_MEMORY_HANDLE will result in undefined behavior.
+ * Debug builds will assert on this.
+ *
+ * @note There is a user space equivalent function called @ref ump_secure_id_get
+ *
+ * @see ump_dd_from_secure_id
+ * @see ump_from_secure_id
+ * @see ump_secure_id_get
+ *
+ * @param mem Handle to UMP memory.
+ *
+ * @return Returns the secure ID for the specified UMP memory.
+ */
+UMP_KERNEL_API_EXPORT ump_secure_id ump_dd_secure_id_get(const ump_dd_handle mem);
+
+#ifdef CONFIG_KDS
+/**
+ * Retrieve the KDS resource for the specified UMP memory.
+ *
+ * The KDS resource should be used to synchronize access to the UMP allocation.
+ * See the KDS API for how to do that.
+ *
+ * @param mem Handle to the UMP memory to query.
+ * @return Pointer to the KDS resource controlling access to the UMP memory.
+ */
+UMP_KERNEL_API_EXPORT struct kds_resource * ump_dd_kds_resource_get(const ump_dd_handle mem);
+#endif
+
+/**
+ * Retrieves a handle to allocated UMP memory.
+ *
+ * The usage of UMP memory is reference counted, so this will increment the reference
+ * count by one for the specified UMP memory.
+ * Use @ref ump_dd_release when there is no longer any
+ * use for the retrieved handle.
+ *
+ * If called on an non-shared allocation and this is a different process @a UMP_DD_INVALID_MEMORY_HANDLE will be returned.
+ *
+ * Calling on an @a UMP_INVALID_SECURE_ID will return @a UMP_DD_INVALID_MEMORY_HANDLE
+ *
+ * @note There is a user space equivalent function called @ref ump_from_secure_id
+ *
+ * @see ump_dd_release
+ * @see ump_from_secure_id
+ *
+ * @param secure_id The secure ID of the UMP memory to open, that can be retrieved using the @ref ump_secure_id_get function.
+ *
+ * @return @a UMP_DD_INVALID_MEMORY_HANDLE indicates failure, otherwise a valid handle is returned.
+ */
+UMP_KERNEL_API_EXPORT ump_dd_handle ump_dd_from_secure_id(ump_secure_id secure_id);
+
+
+/**
+ * Retrieves all physical memory block information for specified UMP memory.
+ *
+ * This function can be used by other device drivers in order to create MMU tables.
+ * This function will return a pointer to an array of @ref ump_dd_physical_block_64 in @a pArray and the number of array elements in @a pCount
+ *
+ * Calling on an @a UMP_DD_INVALID_MEMORY_HANDLE results in undefined behavior.
+ * Debug builds will assert on this.
+ *
+ * @param mem Handle to UMP memory.
+ * @param[out] pCount Pointer to where to store the number of items in the returned array
+ * @param[out] pArray Pointer to where to store a pointer to the physical blocks array
+ */
+UMP_KERNEL_API_EXPORT void ump_dd_phys_blocks_get_64(const ump_dd_handle mem, uint64_t * const pCount, const ump_dd_physical_block_64 ** const pArray);
+
+/**
+ * Retrieves the actual size of the specified UMP memory.
+ *
+ * The size is reported in bytes, and is typically page aligned.
+ *
+ * Calling on an @a UMP_DD_INVALID_MEMORY_HANDLE results in undefined behavior.
+ * Debug builds will assert on this.
+ *
+ * @note There is a user space equivalent function called @ref ump_size_get
+ *
+ * @see ump_size_get
+ *
+ * @param mem Handle to UMP memory.
+ *
+ * @return Returns the allocated size of the specified UMP memory, in bytes.
+ */
+UMP_KERNEL_API_EXPORT uint64_t ump_dd_size_get_64(const ump_dd_handle mem);
+
+
+/**
+ * Adds an extra reference to the specified UMP memory allocation.
+ *
+ * The function @ref ump_dd_release must then be used
+ * to release each copy of the UMP memory handle.
+ *
+ * Calling on an @a UMP_DD_INVALID_MEMORY_HANDLE results in undefined behavior.
+ * Debug builds will assert on this.
+ *
+ * @note You are not required to call @ref ump_dd_retain
+ * for UMP handles returned from
+ * @ref ump_dd_from_secure_id,
+ * because these handles are already reference counted by this function.
+ *
+ * @note There is a user space equivalent function called @ref ump_retain
+ *
+ * @see ump_retain
+ *
+ * @param mem Handle to UMP memory.
+ * @return 0 indicates success, any other value indicates failure.
+ */
+UMP_KERNEL_API_EXPORT int ump_dd_retain(ump_dd_handle mem);
+
+
+/**
+ * Releases a reference from the specified UMP memory.
+ *
+ * This function must be called once for every reference to the UMP memory handle.
+ * When the last reference is released, all resources associated with this UMP memory
+ * handle are freed.
+ *
+ * One can only call ump_release when matched with a successful ump_dd_retain, ump_dd_allocate_64 or ump_dd_from_secure_id
+ * If called on an @a UMP_DD_INVALID_MEMORY_HANDLE the function will early out.
+ *
+ * @note There is a user space equivalent function called @ref ump_release
+ *
+ * @see ump_release
+ *
+ * @param mem Handle to UMP memory.
+ */
+UMP_KERNEL_API_EXPORT void ump_dd_release(ump_dd_handle mem);
+
+/**
+ * Create an ump allocation handle based on externally managed memory.
+ * Used to wrap an existing allocation as an UMP memory handle.
+ * Once wrapped the memory acts just like a normal allocation coming from @ref ump_dd_allocate_64.
+ * The only exception is that the freed physical memory is not put into the pool of free memory, but instead considered returned to the caller once @a final_release_func returns.
+ * The blocks array will be copied, so no need to hold on to it after this function returns.
+ * @param[in] blocks Array of @ref ump_dd_physical_block_64
+ * @param num_blocks Number of elements in the array pointed to by @a blocks
+ * @param flags Allocation flags to mark the handle with
+ * @param[in] filter_func Pointer to a function which will be called when an allocation is required from a secure id before the allocation itself is returned to user-space.
+ * NULL permitted if no need for a callback.
+ * @param[in] final_release_func Pointer to a function which will be called when the last reference is removed, just before the allocation is freed. NULL permitted if no need for a callback.
+ * @param[in] callback_data An opaque pointer which will be provided to @a filter_func and @a final_release_func
+ * @return Handle to the UMP allocation handle created, or @a UMP_DD_INVALID_MEMORY_HANDLE if no such handle could be created.
+ */
+UMP_KERNEL_API_EXPORT ump_dd_handle ump_dd_create_from_phys_blocks_64(const ump_dd_physical_block_64 * blocks, uint64_t num_blocks, ump_alloc_flags flags, ump_dd_security_filter filter_func, ump_dd_final_release_callback final_release_func, void* callback_data);
+
+
+/** @name UMP v1 API
+ * Functions provided to support compatibility with UMP v1 API
+ *
+ *@{
+ */
+
+/**
+ * Value to indicate an invalid UMP memory handle.
+ */
+#define UMP_DD_HANDLE_INVALID UMP_DD_INVALID_MEMORY_HANDLE
+
+/**
+ * UMP error codes for kernel space.
+ */
+typedef enum
+{
+	UMP_DD_SUCCESS, /**< indicates success */
+	UMP_DD_INVALID /**< indicates failure */
+} ump_dd_status_code;
+
+
+/**
+ * Struct used to describe a physical block used by UMP memory
+ */
+typedef struct ump_dd_physical_block
+{
+	unsigned long addr; /**< The physical address of the block */
+	unsigned long size; /**< The length of the block, typically page aligned */
+} ump_dd_physical_block;
+
+
+/**
+ * Retrieves a handle to allocated UMP memory.
+ *
+ * The usage of UMP memory is reference counted, so this will increment the reference
+ * count by one for the specified UMP memory.
+ * Use @ref ump_dd_reference_release "ump_dd_reference_release" when there is no longer any
+ * use for the retrieved handle.
+ *
+ * @note There is a user space equivalent function called @ref ump_handle_create_from_secure_id "ump_handle_create_from_secure_id"
+ *
+ * @see ump_dd_reference_release
+ * @see ump_handle_create_from_secure_id
+ *
+ * @param secure_id The secure ID of the UMP memory to open, that can be retrieved using the @ref ump_secure_id_get "ump_secure_id_get " function.
+ *
+ * @return UMP_INVALID_MEMORY_HANDLE indicates failure, otherwise a valid handle is returned.
+ */
+UMP_KERNEL_API_EXPORT ump_dd_handle ump_dd_handle_create_from_secure_id(ump_secure_id secure_id);
+
+
+
+/**
+ * Create an ump allocation handle based on externally managed memory.
+ * Used to wrap an existing allocation as an UMP memory handle.
+ *
+ * @param[in] blocks Array of @ref ump_dd_physical_block
+ * @param num_blocks Number of elements in the array pointed to by @a blocks
+ *
+ * @return Handle to the UMP allocation handle created, or @a UMP_DD_INVALID_MEMORY_HANDLE if no such handle could be created.
+ */
+UMP_KERNEL_API_EXPORT ump_dd_handle ump_dd_handle_create_from_phys_blocks(ump_dd_physical_block * blocks, unsigned long num_blocks);
+
+
+/**
+ * Retrieves the number of physical blocks used by the specified UMP memory.
+ *
+ * This function retrieves the number of @ref ump_dd_physical_block "ump_dd_physical_block" structs needed
+ * to describe the physical memory layout of the given UMP memory. This can later be used when calling
+ * the functions @ref ump_dd_phys_blocks_get "ump_dd_phys_blocks_get" and
+ * @ref ump_dd_phys_block_get "ump_dd_phys_block_get".
+ *
+ * @see ump_dd_phys_blocks_get
+ * @see ump_dd_phys_block_get
+ *
+ * @param mem Handle to UMP memory.
+ *
+ * @return The number of ump_dd_physical_block structs required to describe the physical memory layout of the specified UMP memory.
+ */
+UMP_KERNEL_API_EXPORT unsigned long ump_dd_phys_block_count_get(ump_dd_handle mem);
+
+
+/**
+ * Retrieves all physical memory block information for specified UMP memory.
+ *
+ * This function can be used by other device drivers in order to create MMU tables.
+ *
+ * @note This function will fail if the num_blocks parameter is either to large or to small.
+ *
+ * @see ump_dd_phys_block_get
+ *
+ * @param mem Handle to UMP memory.
+ * @param blocks An array of @ref ump_dd_physical_block "ump_dd_physical_block" structs that will receive the physical description.
+ * @param num_blocks The number of blocks to return in the blocks array. Use the function
+ *                   @ref ump_dd_phys_block_count_get "ump_dd_phys_block_count_get" first to determine the number of blocks required.
+ *
+ * @return UMP_DD_SUCCESS indicates success, UMP_DD_INVALID indicates failure.
+ */
+UMP_KERNEL_API_EXPORT ump_dd_status_code ump_dd_phys_blocks_get(ump_dd_handle mem, ump_dd_physical_block * const blocks, unsigned long num_blocks);
+
+
+/**
+ * Retrieves the physical memory block information for specified block for the specified UMP memory.
+ *
+ * This function can be used by other device drivers in order to create MMU tables.
+ *
+ * @note This function will return UMP_DD_INVALID if the specified index is out of range.
+ *
+ * @see ump_dd_phys_blocks_get
+ *
+ * @param mem Handle to UMP memory.
+ * @param index Which physical info block to retrieve.
+ * @param block Pointer to a @ref ump_dd_physical_block "ump_dd_physical_block" struct which will receive the requested information.
+ *
+ * @return UMP_DD_SUCCESS indicates success, UMP_DD_INVALID indicates failure.
+ */
+UMP_KERNEL_API_EXPORT ump_dd_status_code ump_dd_phys_block_get(ump_dd_handle mem, unsigned long index, ump_dd_physical_block * const block);
+
+
+/**
+ * Retrieves the actual size of the specified UMP memory.
+ *
+ * The size is reported in bytes, and is typically page aligned.
+ *
+ * @note There is a user space equivalent function called @ref ump_size_get "ump_size_get"
+ *
+ * @see ump_size_get
+ *
+ * @param mem Handle to UMP memory.
+ *
+ * @return Returns the allocated size of the specified UMP memory, in bytes.
+ */
+UMP_KERNEL_API_EXPORT unsigned long ump_dd_size_get(ump_dd_handle mem);
+
+
+/**
+ * Adds an extra reference to the specified UMP memory.
+ *
+ * This function adds an extra reference to the specified UMP memory. This function should
+ * be used every time a UMP memory handle is duplicated, that is, assigned to another ump_dd_handle
+ * variable. The function @ref ump_dd_reference_release "ump_dd_reference_release" must then be used
+ * to release each copy of the UMP memory handle.
+ *
+ * @note You are not required to call @ref ump_dd_reference_add "ump_dd_reference_add"
+ * for UMP handles returned from
+ * @ref ump_dd_handle_create_from_secure_id "ump_dd_handle_create_from_secure_id",
+ * because these handles are already reference counted by this function.
+ *
+ * @note There is a user space equivalent function called @ref ump_reference_add "ump_reference_add"
+ *
+ * @see ump_reference_add
+ *
+ * @param mem Handle to UMP memory.
+ */
+UMP_KERNEL_API_EXPORT void ump_dd_reference_add(ump_dd_handle mem);
+
+
+/**
+ * Releases a reference from the specified UMP memory.
+ *
+ * This function should be called once for every reference to the UMP memory handle.
+ * When the last reference is released, all resources associated with this UMP memory
+ * handle are freed.
+ *
+ * @note There is a user space equivalent function called @ref ump_reference_release "ump_reference_release"
+ *
+ * @see ump_reference_release
+ *
+ * @param mem Handle to UMP memory.
+ */
+UMP_KERNEL_API_EXPORT void ump_dd_reference_release(ump_dd_handle mem);
+
+/* @} */
+
+#ifdef __cplusplus
+}
+#endif
+
+
+/** @} */ /* end group ump_kernel_space_api */
+
+/** @} */ /* end group ump_api */
+
+#endif /* _UMP_KERNEL_INTERFACE_H_ */
diff --git a/include/linux/ump_fb.h b/include/linux/ump_fb.h
new file mode 100644
index 00000000..6c9e3b6
--- /dev/null
+++ b/include/linux/ump_fb.h
@@ -0,0 +1,26 @@
+#ifndef _UMP_FB_INTERFACE_H_
+#define _UMP_FB_INTERFACE_H_
+
+#include "linux/ump.h"
+
+#ifdef __cplusplus
+extern "C"
+{
+#endif
+
+struct ump_operations {                                                
+    ump_dd_handle (*create_from_phys_blocks_64) (const ump_dd_physical_block_64 * blocks, uint64_t num_blocks, ump_alloc_flags flags, ump_dd_security_filter filter_func, ump_dd_final_release_callback final_release_func, void* callback_data);
+    ump_dd_handle (*create_from_phys_blocks) (ump_dd_physical_block * blocks, unsigned long num_blocks);
+
+    ump_secure_id (*secure_id_get) (const ump_dd_handle mem);
+};
+
+//int ump_ops_register(struct ump_operations * cb);
+
+//EXPORT_SYMBOL(ump_ops);                                                
+//EXPORT_SYMBOL(ump_ops_register);
+
+#ifdef __cplusplus
+}
+#endif
+#endif /* _UMP_FB_INTERFACE_H_ */
diff --git a/include/linux/usb/class-dual-role.h b/include/linux/usb/class-dual-role.h
new file mode 100644
index 00000000..c6df223
--- /dev/null
+++ b/include/linux/usb/class-dual-role.h
@@ -0,0 +1,129 @@
+#ifndef __LINUX_CLASS_DUAL_ROLE_H__
+#define __LINUX_CLASS_DUAL_ROLE_H__
+
+#include <linux/workqueue.h>
+#include <linux/errno.h>
+#include <linux/types.h>
+
+struct device;
+
+enum dual_role_supported_modes {
+	DUAL_ROLE_SUPPORTED_MODES_DFP_AND_UFP = 0,
+	DUAL_ROLE_SUPPORTED_MODES_DFP,
+	DUAL_ROLE_SUPPORTED_MODES_UFP,
+/*The following should be the last element*/
+	DUAL_ROLE_PROP_SUPPORTED_MODES_TOTAL,
+};
+
+enum {
+	DUAL_ROLE_PROP_MODE_UFP = 0,
+	DUAL_ROLE_PROP_MODE_DFP,
+	DUAL_ROLE_PROP_MODE_NONE,
+/*The following should be the last element*/
+	DUAL_ROLE_PROP_MODE_TOTAL,
+};
+
+enum {
+	DUAL_ROLE_PROP_PR_SRC = 0,
+	DUAL_ROLE_PROP_PR_SNK,
+	DUAL_ROLE_PROP_PR_NONE,
+/*The following should be the last element*/
+	DUAL_ROLE_PROP_PR_TOTAL,
+
+};
+
+enum {
+	DUAL_ROLE_PROP_DR_HOST = 0,
+	DUAL_ROLE_PROP_DR_DEVICE,
+	DUAL_ROLE_PROP_DR_NONE,
+/*The following should be the last element*/
+	DUAL_ROLE_PROP_DR_TOTAL,
+};
+
+enum {
+	DUAL_ROLE_PROP_VCONN_SUPPLY_NO = 0,
+	DUAL_ROLE_PROP_VCONN_SUPPLY_YES,
+/*The following should be the last element*/
+	DUAL_ROLE_PROP_VCONN_SUPPLY_TOTAL,
+};
+
+enum dual_role_property {
+	DUAL_ROLE_PROP_SUPPORTED_MODES = 0,
+	DUAL_ROLE_PROP_MODE,
+	DUAL_ROLE_PROP_PR,
+	DUAL_ROLE_PROP_DR,
+	DUAL_ROLE_PROP_VCONN_SUPPLY,
+};
+
+struct dual_role_phy_instance;
+
+/* Description of typec port */
+struct dual_role_phy_desc {
+	/* /sys/class/dual_role_usb/<name>/ */
+	const char *name;
+	enum dual_role_supported_modes supported_modes;
+	enum dual_role_property *properties;
+	size_t num_properties;
+
+	/* Callback for "cat /sys/class/dual_role_usb/<name>/<property>" */
+	int (*get_property)(struct dual_role_phy_instance *dual_role,
+			     enum dual_role_property prop,
+			     unsigned int *val);
+	/* Callback for "echo <value> >
+	 *                      /sys/class/dual_role_usb/<name>/<property>" */
+	int (*set_property)(struct dual_role_phy_instance *dual_role,
+			     enum dual_role_property prop,
+			     const unsigned int *val);
+	/* Decides whether userspace can change a specific property */
+	int (*property_is_writeable)(struct dual_role_phy_instance *dual_role,
+				      enum dual_role_property prop);
+};
+
+struct dual_role_phy_instance {
+	const struct dual_role_phy_desc *desc;
+
+	/* Driver private data */
+	void *drv_data;
+
+	struct device dev;
+	struct work_struct changed_work;
+};
+
+#if IS_ENABLED(CONFIG_DUAL_ROLE_USB_INTF)
+extern void dual_role_instance_changed(struct dual_role_phy_instance
+				       *dual_role);
+extern struct dual_role_phy_instance *__must_check
+devm_dual_role_instance_register(struct device *parent,
+				 const struct dual_role_phy_desc *desc);
+extern void devm_dual_role_instance_unregister(struct device *dev,
+					       struct dual_role_phy_instance
+					       *dual_role);
+extern int dual_role_get_property(struct dual_role_phy_instance *dual_role,
+				  enum dual_role_property prop,
+				  unsigned int *val);
+extern int dual_role_set_property(struct dual_role_phy_instance *dual_role,
+				  enum dual_role_property prop,
+				  const unsigned int *val);
+extern int dual_role_property_is_writeable(struct dual_role_phy_instance
+					   *dual_role,
+					   enum dual_role_property prop);
+extern void *dual_role_get_drvdata(struct dual_role_phy_instance *dual_role);
+#else /* CONFIG_DUAL_ROLE_USB_INTF */
+static inline void dual_role_instance_changed(struct dual_role_phy_instance
+				       *dual_role){}
+static inline struct dual_role_phy_instance *__must_check
+devm_dual_role_instance_register(struct device *parent,
+				 const struct dual_role_phy_desc *desc)
+{
+	return ERR_PTR(-ENOSYS);
+}
+static inline void devm_dual_role_instance_unregister(struct device *dev,
+					       struct dual_role_phy_instance
+					       *dual_role){}
+static inline void *dual_role_get_drvdata(struct dual_role_phy_instance
+		*dual_role)
+{
+	return ERR_PTR(-ENOSYS);
+}
+#endif /* CONFIG_DUAL_ROLE_USB_INTF */
+#endif /* __LINUX_CLASS_DUAL_ROLE_H__ */
diff --git a/include/linux/usb/composite.h b/include/linux/usb/composite.h
index 667d204..93b8627 100644
--- a/include/linux/usb/composite.h
+++ b/include/linux/usb/composite.h
@@ -584,6 +584,7 @@ struct usb_function_instance {
 	struct config_group group;
 	struct list_head cfs_list;
 	struct usb_function_driver *fd;
+	struct usb_function *f;
 	int (*set_inst_name)(struct usb_function_instance *inst,
 			      const char *name);
 	void (*free_func_inst)(struct usb_function_instance *inst);
@@ -626,14 +627,14 @@ int usb_add_config_only(struct usb_composite_dev *cdev,
 
 /* messaging utils */
 #define DBG(d, fmt, args...) \
-	dev_dbg(&(d)->gadget->dev , fmt , ## args)
+	dev_dbg(((d)&&(d)->gadget)?&(d)->gadget->dev:NULL , fmt , ## args)
 #define VDBG(d, fmt, args...) \
-	dev_vdbg(&(d)->gadget->dev , fmt , ## args)
+	dev_vdbg(((d)&&(d)->gadget)?&(d)->gadget->dev:NULL , fmt , ## args)
 #define ERROR(d, fmt, args...) \
-	dev_err(&(d)->gadget->dev , fmt , ## args)
+	dev_err(((d)&&(d)->gadget)?&(d)->gadget->dev:NULL , fmt , ## args)
 #define WARNING(d, fmt, args...) \
-	dev_warn(&(d)->gadget->dev , fmt , ## args)
+	dev_warn(((d)&&(d)->gadget)?&(d)->gadget->dev:NULL , fmt , ## args)
 #define INFO(d, fmt, args...) \
-	dev_info(&(d)->gadget->dev , fmt , ## args)
+	dev_info(((d)&&(d)->gadget)?&(d)->gadget->dev:NULL , fmt , ## args)
 
 #endif	/* __LINUX_USB_COMPOSITE_H */
diff --git a/include/linux/usb/f_accessory.h b/include/linux/usb/f_accessory.h
new file mode 100644
index 00000000..ebe3c4d
--- /dev/null
+++ b/include/linux/usb/f_accessory.h
@@ -0,0 +1,23 @@
+/*
+ * Gadget Function Driver for Android USB accessories
+ *
+ * Copyright (C) 2011 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef __LINUX_USB_F_ACCESSORY_H
+#define __LINUX_USB_F_ACCESSORY_H
+
+#include <uapi/linux/usb/f_accessory.h>
+
+#endif /* __LINUX_USB_F_ACCESSORY_H */
diff --git a/include/linux/usb/f_mtp.h b/include/linux/usb/f_mtp.h
new file mode 100644
index 00000000..4e84177
--- /dev/null
+++ b/include/linux/usb/f_mtp.h
@@ -0,0 +1,23 @@
+/*
+ * Gadget Function Driver for MTP
+ *
+ * Copyright (C) 2010 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef __LINUX_USB_F_MTP_H
+#define __LINUX_USB_F_MTP_H
+
+#include <uapi/linux/usb/f_mtp.h>
+
+#endif /* __LINUX_USB_F_MTP_H */
diff --git a/include/linux/verification.h b/include/linux/verification.h
index a10549a..5a088da 100644
--- a/include/linux/verification.h
+++ b/include/linux/verification.h
@@ -26,9 +26,13 @@ enum key_being_used_for {
 };
 extern const char *const key_being_used_for[NR__KEY_BEING_USED_FOR];
 
-#ifdef CONFIG_SYSTEM_DATA_VERIFICATION
-
 struct key;
+struct public_key_signature;
+
+extern int verify_signature_one(const struct public_key_signature *sig,
+			   struct key *trusted_keys, const char *keyid);
+
+#ifdef CONFIG_SYSTEM_DATA_VERIFICATION
 
 extern int verify_pkcs7_signature(const void *data, size_t len,
 				  const void *raw_pkcs7, size_t pkcs7_len,
diff --git a/include/linux/wakeup_reason.h b/include/linux/wakeup_reason.h
new file mode 100644
index 00000000..d84d8c3
--- /dev/null
+++ b/include/linux/wakeup_reason.h
@@ -0,0 +1,32 @@
+/*
+ * include/linux/wakeup_reason.h
+ *
+ * Logs the reason which caused the kernel to resume
+ * from the suspend mode.
+ *
+ * Copyright (C) 2014 Google, Inc.
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef _LINUX_WAKEUP_REASON_H
+#define _LINUX_WAKEUP_REASON_H
+
+#define MAX_SUSPEND_ABORT_LEN 256
+
+void log_wakeup_reason(int irq);
+int check_wakeup_reason(int irq);
+
+#ifdef CONFIG_SUSPEND
+void log_suspend_abort_reason(const char *fmt, ...);
+#else
+static inline void log_suspend_abort_reason(const char *fmt, ...) { }
+#endif
+
+#endif /* _LINUX_WAKEUP_REASON_H */
diff --git a/include/linux/wlan_plat.h b/include/linux/wlan_plat.h
new file mode 100644
index 00000000..8e8b06f
--- /dev/null
+++ b/include/linux/wlan_plat.h
@@ -0,0 +1,30 @@
+/* include/linux/wlan_plat.h
+ *
+ * Copyright (C) 2010 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+#ifndef _LINUX_WLAN_PLAT_H_
+#define _LINUX_WLAN_PLAT_H_
+
+#define WLAN_PLAT_NODFS_FLAG	0x01
+
+struct wifi_platform_data {
+	int (*set_power)(int val);
+	int (*set_reset)(int val);
+	int (*set_carddetect)(int val);
+	void *(*mem_prealloc)(int section, unsigned long size);
+	int (*get_mac_addr)(unsigned char *buf);
+	int (*get_wake_irq)(void);
+	void *(*get_country_code)(char *ccode, u32 flags);
+};
+
+#endif
diff --git a/include/net/addrconf.h b/include/net/addrconf.h
index b8ee8a1..858f308 100644
--- a/include/net/addrconf.h
+++ b/include/net/addrconf.h
@@ -244,6 +244,8 @@ static inline bool ipv6_is_mld(struct sk_buff *skb, int nexthdr, int offset)
 void addrconf_prefix_rcv(struct net_device *dev,
 			 u8 *opt, int len, bool sllao);
 
+u32 addrconf_rt_table(const struct net_device *dev, u32 default_table);
+
 /*
  *	anycast prototypes (anycast.c)
  */
diff --git a/include/net/fib_rules.h b/include/net/fib_rules.h
index 456e4a6..8dbfdf7 100644
--- a/include/net/fib_rules.h
+++ b/include/net/fib_rules.h
@@ -8,6 +8,11 @@
 #include <net/flow.h>
 #include <net/rtnetlink.h>
 
+struct fib_kuid_range {
+	kuid_t start;
+	kuid_t end;
+};
+
 struct fib_rule {
 	struct list_head	list;
 	int			iifindex;
@@ -30,6 +35,7 @@ struct fib_rule {
 	int			suppress_prefixlen;
 	char			iifname[IFNAMSIZ];
 	char			oifname[IFNAMSIZ];
+	struct fib_kuid_range	uid_range;
 	struct rcu_head		rcu;
 };
 
@@ -92,7 +98,8 @@ struct fib_rules_ops {
 	[FRA_SUPPRESS_PREFIXLEN] = { .type = NLA_U32 }, \
 	[FRA_SUPPRESS_IFGROUP] = { .type = NLA_U32 }, \
 	[FRA_GOTO]	= { .type = NLA_U32 }, \
-	[FRA_L3MDEV]	= { .type = NLA_U8 }
+	[FRA_L3MDEV]	= { .type = NLA_U8 }, \
+	[FRA_UID_RANGE]	= { .len = sizeof(struct fib_rule_uid_range) }
 
 static inline void fib_rule_get(struct fib_rule *rule)
 {
diff --git a/include/net/flow.h b/include/net/flow.h
index 035aa77..6bbbca8 100644
--- a/include/net/flow.h
+++ b/include/net/flow.h
@@ -11,6 +11,7 @@
 #include <linux/in6.h>
 #include <linux/atomic.h>
 #include <net/flow_dissector.h>
+#include <linux/uidgid.h>
 
 /*
  * ifindex generation is per-net namespace, and loopback is
@@ -37,6 +38,7 @@ struct flowi_common {
 #define FLOWI_FLAG_SKIP_NH_OIF		0x04
 	__u32	flowic_secid;
 	struct flowi_tunnel flowic_tun_key;
+	kuid_t  flowic_uid;
 };
 
 union flowi_uli {
@@ -74,6 +76,7 @@ struct flowi4 {
 #define flowi4_flags		__fl_common.flowic_flags
 #define flowi4_secid		__fl_common.flowic_secid
 #define flowi4_tun_key		__fl_common.flowic_tun_key
+#define flowi4_uid		__fl_common.flowic_uid
 
 	/* (saddr,daddr) must be grouped, same order as in IP header */
 	__be32			saddr;
@@ -93,7 +96,8 @@ static inline void flowi4_init_output(struct flowi4 *fl4, int oif,
 				      __u32 mark, __u8 tos, __u8 scope,
 				      __u8 proto, __u8 flags,
 				      __be32 daddr, __be32 saddr,
-				      __be16 dport, __be16 sport)
+				      __be16 dport, __be16 sport,
+				      kuid_t uid)
 {
 	fl4->flowi4_oif = oif;
 	fl4->flowi4_iif = LOOPBACK_IFINDEX;
@@ -104,6 +108,7 @@ static inline void flowi4_init_output(struct flowi4 *fl4, int oif,
 	fl4->flowi4_flags = flags;
 	fl4->flowi4_secid = 0;
 	fl4->flowi4_tun_key.tun_id = 0;
+	fl4->flowi4_uid = uid;
 	fl4->daddr = daddr;
 	fl4->saddr = saddr;
 	fl4->fl4_dport = dport;
@@ -131,6 +136,7 @@ struct flowi6 {
 #define flowi6_flags		__fl_common.flowic_flags
 #define flowi6_secid		__fl_common.flowic_secid
 #define flowi6_tun_key		__fl_common.flowic_tun_key
+#define flowi6_uid		__fl_common.flowic_uid
 	struct in6_addr		daddr;
 	struct in6_addr		saddr;
 	/* Note: flowi6_tos is encoded in flowlabel, too. */
@@ -176,6 +182,7 @@ struct flowi {
 #define flowi_flags	u.__fl_common.flowic_flags
 #define flowi_secid	u.__fl_common.flowic_secid
 #define flowi_tun_key	u.__fl_common.flowic_tun_key
+#define flowi_uid	u.__fl_common.flowic_uid
 } __attribute__((__aligned__(BITS_PER_LONG/8)));
 
 static inline struct flowi *flowi4_to_flowi(struct flowi4 *fl4)
diff --git a/include/net/inet_sock.h b/include/net/inet_sock.h
index 0464b20..a2f3a49 100644
--- a/include/net/inet_sock.h
+++ b/include/net/inet_sock.h
@@ -212,7 +212,11 @@ struct inet_sock {
 				transparent:1,
 				mc_all:1,
 				nodefrag:1;
-	__u8			bind_address_no_port:1;
+	__u8			bind_address_no_port:1,
+				defer_connect:1; /* Indicates that fastopen_connect is set
+						  * and cookie exists so we defer connect
+						  * until first data frame is written
+						  */
 	__u8			rcv_tos;
 	__u8			convert_csum;
 	int			uc_index;
diff --git a/include/net/ip.h b/include/net/ip.h
index bc9b4de..f203977 100644
--- a/include/net/ip.h
+++ b/include/net/ip.h
@@ -180,6 +180,7 @@ struct ip_reply_arg {
 				/* -1 if not needed */ 
 	int	    bound_dev_if;
 	u8  	    tos;
+	kuid_t	    uid;
 }; 
 
 #define IP_REPLY_ARG_NOSRCCHECK 1
diff --git a/include/net/ip6_route.h b/include/net/ip6_route.h
index 2c43993..4341731 100644
--- a/include/net/ip6_route.h
+++ b/include/net/ip6_route.h
@@ -142,9 +142,10 @@ int rt6_route_rcv(struct net_device *dev, u8 *opt, int len,
 		  const struct in6_addr *gwaddr);
 
 void ip6_update_pmtu(struct sk_buff *skb, struct net *net, __be32 mtu, int oif,
-		     u32 mark);
+		     u32 mark, kuid_t uid);
 void ip6_sk_update_pmtu(struct sk_buff *skb, struct sock *sk, __be32 mtu);
-void ip6_redirect(struct sk_buff *skb, struct net *net, int oif, u32 mark);
+void ip6_redirect(struct sk_buff *skb, struct net *net, int oif, u32 mark,
+		  kuid_t uid);
 void ip6_redirect_no_header(struct sk_buff *skb, struct net *net, int oif,
 			    u32 mark);
 void ip6_sk_redirect(struct sk_buff *skb, struct sock *sk);
diff --git a/include/net/netfilter/nf_conntrack.h b/include/net/netfilter/nf_conntrack.h
index 9ae819e..29f0d47 100644
--- a/include/net/netfilter/nf_conntrack.h
+++ b/include/net/netfilter/nf_conntrack.h
@@ -306,7 +306,7 @@ static inline bool nf_ct_should_gc(const struct nf_conn *ct)
 
 struct kernel_param;
 
-int nf_conntrack_set_hashsize(const char *val, struct kernel_param *kp);
+int nf_conntrack_set_hashsize(const char *val, const struct kernel_param *kp);
 int nf_conntrack_hash_resize(unsigned int hashsize);
 
 extern struct hlist_nulls_head *nf_conntrack_hash;
diff --git a/include/net/route.h b/include/net/route.h
index b8488ef..2702b7a 100644
--- a/include/net/route.h
+++ b/include/net/route.h
@@ -154,7 +154,7 @@ static inline struct rtable *ip_route_output_ports(struct net *net, struct flowi
 	flowi4_init_output(fl4, oif, sk ? sk->sk_mark : 0, tos,
 			   RT_SCOPE_UNIVERSE, proto,
 			   sk ? inet_sk_flowi_flags(sk) : 0,
-			   daddr, saddr, dport, sport);
+			   daddr, saddr, dport, sport, sock_net_uid(net, sk));
 	if (sk)
 		security_sk_classify_flow(sk, flowi4_to_flowi(fl4));
 	return ip_route_output_flow(net, fl4, sk);
@@ -270,7 +270,8 @@ static inline void ip_route_connect_init(struct flowi4 *fl4, __be32 dst, __be32
 		flow_flags |= FLOWI_FLAG_ANYSRC;
 
 	flowi4_init_output(fl4, oif, sk->sk_mark, tos, RT_SCOPE_UNIVERSE,
-			   protocol, flow_flags, dst, src, dport, sport);
+			   protocol, flow_flags, dst, src, dport, sport,
+			   sk->sk_uid);
 }
 
 static inline struct rtable *ip_route_connect(struct flowi4 *fl4,
diff --git a/include/net/rtl/fastpath/fastpath_core.h b/include/net/rtl/fastpath/fastpath_core.h
new file mode 100644
index 00000000..02eaee7
--- /dev/null
+++ b/include/net/rtl/fastpath/fastpath_core.h
@@ -0,0 +1,1296 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef	__FASTPATH_CORE_H__
+#define	__FASTPATH_CORE_H__
+
+#include <linux/module.h>
+#include <linux/proc_fs.h>
+#include <linux/in.h>
+#include <linux/ip.h>
+#include <linux/udp.h>
+#include <linux/tcp.h>
+#include <linux/netdevice.h>
+#include <linux/netfilter.h>
+#include <linux/netfilter_ipv4.h>
+#include <net/dst.h>
+#include <net/rtl/rtl_queue.h>
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+#include <net/rtl/rtl865x_nat.h>
+#endif
+
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+#include <linux/seq_file.h>
+extern struct proc_dir_entry proc_root;
+#endif
+#if defined(CONFIG_OPENWRT_SDK)
+#include <uapi/linux/netfilter/nf_conntrack_tuple_common.h>
+#endif
+
+//#include <net/netfilter/nf_conntrack.h>
+//#include <net/route.h>
+
+/*
+	Virtual Rome Driver API & System (Light Rome Driver Simulator)
+*/
+
+#if defined (__IRAM_GEN)
+#undef	__IRAM_GEN
+#define	__IRAM_GEN
+#endif
+
+//#define       ipaddr_t        __u32
+//#define       uint8           __u8
+//#define       uint16          __u16
+//#define       uint32          __u32
+//typedef unsigned long long    __uint64;
+
+#if 0
+#define DEBUGP_API printk
+#else
+#define DEBUGP_API(format, args...)
+#endif
+
+#if 0
+#define DEBUGP_PKT printk
+#else
+#define DEBUGP_PKT(format, args...)
+#endif
+
+#if 0
+#define DEBUGP_SYS printk
+#else
+#define DEBUGP_SYS(format, args...)
+#endif
+
+#define	DEBUG_PROCFILE		/* Create ProcFile for debug */
+
+//define this macro to improve qos
+#define IMPROVE_QOS		1
+
+//#define       RTL_FP_CHECK_SPI_ENABLED        1
+#if !defined(RTL_FP_CHECK_SPI_ENABLED)
+#define CONFIG_UDP_FRAG_CACHE 1	//enable fragmentation cache ,mark_add
+#endif
+
+#if defined(CONFIG_UDP_FRAG_CACHE)
+#define MAX_UDP_FRAG_ENTRY 64	//kernel => 64 frag queue!!
+#endif
+
+#if 1
+/***********************************cary:refine filter.c**********************************/
+#define FASTPATH_FILTER	1
+/***********************************************************************************/
+#define CUSTOM_RSP_PACKET
+#define DOS_FILTER
+#define URL_FILTER
+
+//#define URL_CONTENT_AUTHENTICATION
+
+#define ACTION_ALLOW 1
+#define ACTION_DENY 0
+#define WEEK_ALL_DAY 1<<7
+#define TIME_ALL_TIME 1<<0
+#define FAST_PPTP
+#define FAST_L2TP
+#endif
+//#define DEL_NAPT_TBL
+#define DEL_ROUTE_TBL		//sync from rtl865x --2010.02.09
+#define NO_ARP_USED		// 2008.01.09, Forrest Lin. Use kernel route cache already.
+#define INVALID_PATH_BY_FIN
+
+#if defined(CONFIG_RTL_FAST_PPPOE)
+#define MAX_PPPOE_ENTRY 16
+struct pppoe_info {
+	char		wan_dev[IFNAMSIZ];          /* Local device to use */
+	char		ppp_dev[IFNAMSIZ];          /* Local device to use */
+	unsigned char	our_mac[6];
+	unsigned char	peer_mac[6];
+	unsigned int	our_ip;
+	unsigned int	peer_ip;
+	unsigned short	sid;
+	unsigned short	valid;
+	unsigned long	last_rx;
+	unsigned long	last_tx;
+	unsigned char	txHdrCache[22];
+#if defined (CONFIG_RTL_FAST_PPPOE_DEBUG)
+	unsigned int	total_rx;
+	unsigned int	total_tx;
+#endif
+};
+
+int __init fast_pppoe_init(void);
+int __exit fast_pppoe_exit(void);
+
+int clear_pppoe_info(char *ppp_dev, char *wan_dev, unsigned short sid,
+		     unsigned int our_ip, unsigned int peer_ip,
+		     unsigned char *our_mac, unsigned char *peer_mac);
+
+int set_pppoe_info(char *ppp_dev, char *wan_dev, unsigned short sid,
+		   unsigned int our_ip, unsigned int peer_ip,
+		   unsigned char *our_mac, unsigned char *peer_mac);
+
+unsigned long get_pppoe_last_rx_tx(char *ppp_dev, char *wan_dev, unsigned short sid,
+				   unsigned int our_ip, unsigned int peer_ip,
+				   unsigned char *our_mac, unsigned char *peer_mac,
+				   unsigned long *last_rx, unsigned long *last_tx);
+
+
+int check_and_pull_pppoe_hdr(struct sk_buff *skb);
+
+void check_and_restore_pppoe_hdr(struct sk_buff *skb);
+
+int fast_pppoe_xmit(struct sk_buff *skb);
+
+#endif
+
+#if defined(CONFIG_OPENWRT_SDK)
+#if defined(CONFIG_RTL_IPTABLES_FAST_PATH)
+#define NET_RX_CN_LOW		2	/* storm alert, just in case */
+#define NET_RX_CN_MOD		3	/* Storm on its way! */
+#define NET_RX_CN_HIGH		4	/* The storm is here */
+#define NET_RX_BAD		5	/* packet dropped due to kernel error */
+#define NET_RX_PASSBY		6	/* packet pass by for next process */
+#endif
+
+#if defined(CONFIG_RTL_819X)
+static inline struct dst_entry *rtl_skb_dst(const struct sk_buff *skb)
+{
+	return (struct dst_entry *)(skb->_skb_refdst);
+}
+#endif
+
+#if defined 	(CONFIG_RTL865X_LANPORT_RESTRICTION)
+#define NET_RX_AUTH_BLOCK	6
+#endif
+#endif /* CONFIG_OPENWRT_SDK */
+
+#ifdef CONFIG_RTL_FAST_IPV6
+#define CONFIG_V6_UDP_FRAG_CACHE 1
+struct V6_Tuple {
+	/* hash 5 tuple */
+	struct in6_addr saddr;
+	struct in6_addr daddr;
+	uint32 protocol;
+	uint32 sport;
+	uint32 dport;
+};
+int ipv6_fast_enter(struct sk_buff *pskb);
+int rtk_addV6Connection(struct V6_Tuple *PathEntry, struct sk_buff *pskb,
+	void *ct);
+int rtk_delV6Connection(struct V6_Tuple *PathEntry);
+int rtl_V6_Cache_Timer_update(void *ct);
+
+#endif
+#ifdef URL_CONTENT_AUTHENTICATION
+#define RTL_UNAUTH_BUFFER_SIZE 8
+#define RTL_URL_CONTENT_READED 0x1
+
+typedef struct _unAuth_skb_s {
+	struct list_head list;
+	int id;			/*skb->iphdr.id */
+	uint32 saddr;
+	uint32 daddr;
+	uint32 flag;		/*whether the url content is readed by application.... */
+	struct sk_buff *skb;
+} unAuth_skb_t;
+
+int rtl_urlContent_auth(struct sk_buff *skb);
+#endif
+
+#if defined(FAST_L2TP)
+#if 0
+#define DEBUGP	printk
+#else
+#define DEBUGP(fmt, args...) {}
+#endif
+
+#define control_message 0x8000
+#define connect_control 0xc
+#define stop_control 0x4
+#define call_reply 0xb
+
+struct l2tp_info {
+	void *wan_dev;
+	void *ppp0_dev;
+	unsigned long last_xmit;
+	__u32 daddr;
+	__u32 saddr;
+	__u16 tid;		/* Tunnel ID */
+	__u16 cid;		/* Caller ID */
+	unsigned char mac_header[ETH_HLEN];
+	__u16 valid;
+
+};
+
+struct l2tp_ext_hdr {
+	__u16 source;
+	__u16 dest;
+	__u16 len;
+	__u16 checksum;
+	__u16 type;
+	__u16 tid;
+	__u16 cid;
+	__u16 addr_control;
+	__u16 protocol;
+};
+
+struct Rus_l2tp_ext_hdr {
+	//udp header
+	__u16 source;
+	__u16 dest;
+	__u16 len;
+	__u16 checksum;
+
+	//l2tp header
+	__u16 type;
+	__u16 tid;
+	__u16 cid;
+
+	//ppp header
+	__u16 addr_control;
+	__u16 protocol;
+
+	// Lcp reply header
+	unsigned char code;
+	unsigned char id;
+	__u16 lcp_length;
+	unsigned int imagicNumber;
+	unsigned int message;
+};
+
+struct avp_info {
+	__u16 length;
+	__u16 vendorid;
+	__u16 attr;
+	__u16 mss_type;
+};
+
+struct l2tp_header {
+	__u16 ver;		/* Version and friends */
+	__u16 length;		/* Optional Length */
+	__u16 tid;		/* Tunnel ID */
+	__u16 cid;		/* Caller ID */
+	__u16 Ns;		/* Optional next sent */
+	__u16 Nr;		/* Optional next received */
+};
+extern void (*l2tp_tx_id_hook) (void *skb);
+
+#endif
+
+#if defined(FAST_PPTP)
+
+#if 0
+#define FAST_PPTP_PRINT	printk
+#else
+#define FAST_PPTP_PRINT(fmt, args...) {}
+#endif
+
+/*
+struct pptp_info {
+	struct net_device *wan_dev;
+	unsigned int tx_seqno;
+	unsigned int rx_seqno;
+	__u32 saddr;
+	__u32 daddr;
+	__u16 callID;
+	__u16 peer_callID;
+	__u16 tx_ipID;
+	__u16 ipID;
+	struct net_device *ppp0_dev;
+	struct net_device *lan_dev;
+	unsigned char mac_header[ETH_HLEN];
+	unsigned int tx_seqno_daemon;
+	unsigned int rx_seqno_daemon;
+	int ppp_hdr_len;
+	unsigned char ppp_hdr[4];
+};
+*/
+
+struct pptp_acc_info {
+	unsigned long fast_pptp_lastxmit;
+	int valid;
+	void *wanDev;
+	unsigned char ourMac[ETHER_ADDR_LEN];
+	__u16 ourCallID;
+	__u32 ourIp;
+	unsigned char peerMac[ETHER_ADDR_LEN];
+	__u16 peerCallID;
+	__u32 peerIp;
+	unsigned int tx_seqno;
+	unsigned int rx_seqno;
+	__u16 tx_ipID;
+	__u16 ipID;
+	unsigned int tx_seqno_daemon;
+	unsigned int rx_seqno_daemon;
+	void *pppDev;
+	struct ppp_channel *pppChan;
+};
+
+extern int fast_pptp_fw;
+
+/* following define are imported from kerenl */
+#define SC_COMP_RUN     0x00001000	/* compressor has been inited */
+enum NPmode {
+	NPMODE_PASS,		/* pass the packet through */
+	NPMODE_DROP,		/* silently drop the packet */
+	NPMODE_ERROR,		/* return an error */
+	NPMODE_QUEUE		/* save it up for later. */
+};
+
+#define NUM_NP	6		/* Number of NPs. */
+struct ppp_file {
+	enum {
+		INTERFACE = 1, CHANNEL
+	} kind;
+	struct sk_buff_head xq;	/* pppd transmit queue */
+	struct sk_buff_head rq;	/* receive queue for pppd */
+	wait_queue_head_t rwait;	/* for poll on reading /dev/ppp */
+	atomic_t refcnt;	/* # refs (incl /dev/ppp attached) */
+	int hdrlen;		/* space to leave for headers */
+	int index;		/* interface unit / channel number */
+	int dead;		/* unit/channel has been shut down */
+};
+
+//To sync with drivers/net/ppp_generic.c
+struct ppp {
+	struct ppp_file	file;		/* stuff for read/write/poll 0 */
+	struct file	*owner;		/* file that owns this unit 48 */
+	struct list_head channels;	/* list of attached channels 4c */
+	int		n_channels;	/* how many channels are attached 54 */
+	spinlock_t	rlock;		/* lock for receive side 58 */
+	spinlock_t	wlock;		/* lock for transmit side 5c */
+	int		mru;		/* max receive unit 60 */
+#if defined(CONFIG_PPP_MPPE_MPPC)
+	int		mru_alloc;	/* MAX(1500,MRU) for dev_alloc_skb() */
+#endif
+	unsigned int	flags;		/* control bits 64 */
+	unsigned int	xstate;		/* transmit state bits 68 */
+	unsigned int	rstate;		/* receive state bits 6c */
+	int		debug;		/* debug flags 70 */
+	struct slcompress *vj;		/* state for VJ header compression */
+	enum NPmode	npmode[NUM_NP];	/* what to do with each net proto 78 */
+	struct sk_buff	*xmit_pending;	/* a packet ready to go out 88 */
+	struct compressor *xcomp;	/* transmit packet compressor 8c */
+	void		*xc_state;	/* its internal state 90 */
+	struct compressor *rcomp;	/* receive decompressor 94 */
+	void		*rc_state;	/* its internal state 98 */
+	unsigned long	last_xmit;	/* jiffies when last pkt sent 9c */
+	unsigned long	last_recv;	/* jiffies when last pkt rcvd a0 */
+	struct net_device *dev;		/* network interface device a4 */
+	int		closing;	/* is device closing down? a8 */
+#ifdef CONFIG_PPP_MULTILINK
+	int		nxchan;		/* next channel to send something on */
+	u32		nxseq;		/* next sequence number to send */
+	int		mrru;		/* MP: max reconst. receive unit */
+	u32		nextseq;	/* MP: seq no of next packet */
+	u32		minseq;		/* MP: min of most recent seqnos */
+	struct sk_buff_head mrq;	/* MP: receive reconstruction queue */
+#endif /* CONFIG_PPP_MULTILINK */
+	struct net_device_stats stats;	/* statistics */
+#ifdef CONFIG_PPP_FILTER
+	struct sock_filter *pass_filter;	/* filter for packets to pass */
+	struct sock_filter *active_filter;	/* filter for pkts to reset idle */
+	unsigned pass_len, active_len;
+#endif /* CONFIG_PPP_FILTER */
+	struct net *ppp_net;	/* the net we belong to */
+};
+
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+/*
+ * Private data structure for each channel.
+ * This includes the data structure used for multilink.
+ */
+struct channel {
+	struct ppp_file	file;		/* stuff for read/write/poll */
+	struct list_head list;		/* link in all/new_channels list */
+	struct ppp_channel *chan;	/* public channel data structure */
+	struct rw_semaphore chan_sem;	/* protects `chan' during chan ioctl */
+	spinlock_t	downl;		/* protects `chan', file.xq dequeue */
+	struct ppp	*ppp;		/* ppp unit we're connected to */
+	struct net	*chan_net;	/* the net channel belongs to */
+	struct list_head clist;		/* link in list of channels per unit */
+	rwlock_t	upl;		/* protects `ppp' */
+#ifdef CONFIG_PPP_MULTILINK
+	u8		avail;		/* flag used in multilink stuff */
+	u8		had_frag;	/* >= 1 fragments have been sent */
+	u32		lastseq;	/* MP: last sequence # received */
+	int		speed;		/* speed of the corresponding ppp channel*/
+#endif /* CONFIG_PPP_MULTILINK */
+#if defined(CONFIG_RTL_PPPOE_HWACC) || defined (CONFIG_RTL_FAST_PPPOE)
+	u8		pppoe;
+	u8		rsv1;
+	u16		rsv2;
+#endif
+};
+#endif
+
+extern void (*sync_tx_pptp_gre_seqno_hook) (void *skb);
+#endif
+#if defined(CUSTOM_RSP_PACKET)
+void register_customRspHook(int *_cusRsp401_func, int *_cusRspTCPFinAck_func,
+	int *_cusRspTCPEndAck_func);
+void unregister_customRspHook(void);
+void register_customRspStr(char *_str);
+void unregister_customRspStr(void);
+int GenerateHTTP401(void *skb);
+#endif
+#ifdef DOS_FILTER
+extern int filter_enter(void *skb);
+extern int __init filter_init(void);
+extern void __exit filter_exit(void);
+extern void filter_addconnect(ipaddr_t ipaddr);
+extern void filter_delconnect(ipaddr_t ipaddr);
+extern int filter_checkConnect(__u32 ipaddr);
+#endif
+
+#ifdef FAST_PPTP
+extern void fast_pptp_filter(void *skb);
+extern void fast_pptp_sync_rx_seq(void *skb);
+extern int __init fast_pptp_init(void);
+extern void __exit fast_pptp_exit(void);
+extern int fast_pptp_to_lan(void **pskb);
+extern int Check_GRE_rx_net_device(void *skb);
+extern int pptp_tcp_finished;
+#endif
+
+#ifdef FAST_L2TP
+extern int __init fast_l2tp_init(void);
+extern void __exit fast_l2tp_exit(void);
+
+#if !defined(CONFIG_OPENWRT_SDK)
+extern int fast_l2tp_to_wan(void *skb);
+#endif
+extern int fast_l2tp_rx(void *skb);
+extern void l2tp_tx_id(void *skb);
+extern int fast_l2tp_fw;
+#endif
+
+#ifdef CONFIG_RTL_FAST_IPV6
+extern int __init ipv6_fast_forward_init(void);
+extern void __exit ipv6_fast_forward_exit(void);
+extern int init_V6_table_path(int v6_path_tbl_list_max,
+	int v6_path_tbl_entry_max);
+extern int V6_udp_fragCache_init(int V6_udp_frag_entry_max);
+extern int fast_ipv6_fw;
+#endif
+
+/* ---------------------------------------------------------------------------------------------------- */
+
+#define	IFNAME_LEN_MAX			16
+#define	MAC_ADDR_LEN_MAX		18
+#if !defined(NO_ARP_USED)
+#define	ARP_TABLE_LIST_MAX		32
+#define	ARP_TABLE_ENTRY_MAX		128
+#endif
+
+#define	ROUTE_TABLE_LIST_MAX	16
+#define	ROUTE_TABLE_ENTRY_MAX	64
+
+#if defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_92D_SUPPORT) ||defined(CONFIG_RTL_819XD) ||(defined(CONFIG_RTL_8196E)&&defined(CONFIG_RTL_SDRAM_GE_32M)) || defined(CONFIG_RTL_8198C) || (defined(CONFIG_RTL_8197F) && !defined(CONFIG_RTL_SHRINK_MEMORY_SIZE))
+#if defined(CONFIG_OPENWRT_SDK)
+#define NAPT_TABLE_LIST_MAX	8192
+#define NAPT_TABLE_ENTRY_MAX	8192
+#define PATH_TABLE_LIST_MAX	8192
+#else
+#define NAPT_TABLE_LIST_MAX	4096
+#define NAPT_TABLE_ENTRY_MAX	4096
+#define PATH_TABLE_LIST_MAX	4096
+#endif
+#else
+#define NAPT_TABLE_LIST_MAX	768
+#define NAPT_TABLE_ENTRY_MAX	768
+#define PATH_TABLE_LIST_MAX	768
+#endif
+
+#define PATH_TABLE_ENTRY_MAX	(NAPT_TABLE_ENTRY_MAX << 1)
+
+#if	defined(CONFIG_RTL_FAST_FILTER)
+#define NF_DROP		0
+#define NF_FASTPATH	1
+#define NF_LINUX	2
+#define NF_MARK		3
+#define NF_REPEAT	4
+#define NF_OMIT		5
+#endif
+
+#if 0
+#define	ETHER_ADDR_LEN		6
+typedef struct ether_addr_s {
+	uint8 octet[ETHER_ADDR_LEN];
+} ether_addr_t;
+#endif
+
+/* ########### API #################################################################################### */
+enum LR_RESULT {
+	/* Common error code */
+	LR_SUCCESS = 0,		/* Function Success */
+	LR_FAILED = -1,		/* General Failure, not recommended to use */
+	LR_ERROR_PARAMETER = -2,	/* The given parameter error */
+	LR_EXIST = -3,		/* The entry you want to add has been existed, add failed */
+	LR_NONEXIST = -4,	/* The specified entry is not found */
+
+	LR_NOBUFFER = -1000,	/* Out of Entry Space */
+	LR_INVAPARAM = -1001,	/* Invalid parameters */
+	LR_NOTFOUND = -1002,	/* Entry not found */
+	LR_DUPENTRY = -1003,	/* Duplicate entry found */
+};
+
+#if 0
+enum IF_FLAGS {
+	IF_NONE,
+	IF_INTERNAL = (0 << 1),	/* This is an internal interface. */
+	IF_EXTERNAL = (1 << 1),	/* This is an external interface. */
+};
+
+enum FDB_FLAGS {
+	FDB_NONE = 0,
+};
+#endif
+
+enum ARP_FLAGS {
+	ARP_NONE = 0,
+};
+
+enum RT_FLAGS {
+	RT_NONE = 0,
+};
+
+enum SE_TYPE {
+	SE_PPPOE = 1,
+	SE_PPTP = 2,
+	SE_L2TP = 3,
+};
+enum SE_FLAGS {
+	SE_NONE = 0,
+};
+
+enum NP_PROTOCOL {
+	NP_UDP = 1,
+	NP_TCP = 2,
+#if defined(CONFIG_RTL_FAST_GRE)
+	NP_GRE = 3,
+#endif
+};
+enum NP_FLAGS {
+	NP_NONE = 0,
+};
+
+typedef struct _rtl_fp_napt_entry {
+	enum NP_PROTOCOL protocol;
+	ipaddr_t intIp;
+	uint32 intPort;
+	ipaddr_t extIp;
+	uint32 extPort;
+	ipaddr_t remIp;
+	uint32 remPort;
+} rtl_fp_napt_entry;
+
+/* ---------------------------------------------------------------------------------------------------- */
+#if 0
+enum LR_RESULT rtk_addInterface(uint8 *ifname, ipaddr_t ipAddr,
+	ether_addr_t *gmac, uint32 mtu, enum IF_FLAGS flags);
+enum LR_RESULT rtk_configInterface(uint8 *ifname, uint32 vlanId, uint32 fid,
+	uint32 mbr, uint32 untag, enum IF_FLAGS flags);
+enum LR_RESULT rtk_delInterface(uint8 *ifname);
+enum LR_RESULT rtk_addFdbEntry(uint32 vid, uint32 fid, ether_addr_t *mac,
+	uint32 portmask, enum FDB_FLAGS flags);
+enum LR_RESULT rtk_delFdbEntry(uint32 vid, uint32 fid, ether_addr_t *mac);
+#endif
+enum LR_RESULT rtk_addArp(ipaddr_t ip, ether_addr_t *mac, enum ARP_FLAGS flags);
+enum LR_RESULT rtk_modifyArp(ipaddr_t ip, ether_addr_t *mac,
+	enum ARP_FLAGS flags);
+enum LR_RESULT rtk_delArp(ipaddr_t ip);
+enum LR_RESULT rtk_addRoute(ipaddr_t ip, ipaddr_t mask, ipaddr_t gateway,
+	uint8 *ifname, enum RT_FLAGS flags);
+enum LR_RESULT rtk_modifyRoute(ipaddr_t ip, ipaddr_t mask, ipaddr_t gateway,
+	uint8 *ifname, enum RT_FLAGS flags);
+enum LR_RESULT rtk_delRoute(ipaddr_t ip, ipaddr_t mask);
+enum LR_RESULT rtk_addSession(uint8 *ifname, enum SE_TYPE seType,
+	uint32 sessionId, enum SE_FLAGS flags);
+enum LR_RESULT rtk_delSession(uint8 *ifname);
+
+enum LR_RESULT rtk_addNaptConnection(rtl_fp_napt_entry * fpNaptEntry,
+#if defined(IMPROVE_QOS)
+	void *pskb, void *ct,
+#endif
+	enum NP_FLAGS flags);
+enum LR_RESULT rtk_delNaptConnection(rtl_fp_napt_entry * fpNaptEntry);
+
+#if defined(IMPROVE_QOS)
+enum LR_RESULT rtk_idleNaptConnection(rtl_fp_napt_entry * fpNaptEntry,
+	uint32 interval);
+#else
+enum LR_RESULT rtk_idleNaptConnection(rtl_fp_napt_entry * fpNaptEntry,
+	uint32 interval, unsigned long *lastUsed);
+#endif
+#if defined(CONFIG_BRIDGE)
+int32 rtl_br_fdb_time_update(void *br, void *fdb, const unsigned char *addr);
+#endif
+int32 rtl_fp_dev_queue_xmit_check(struct sk_buff *skb, struct net_device *dev);
+int32 rtl_fp_dev_hard_start_xmit_check(struct sk_buff *skb,
+	struct net_device *dev, struct netdev_queue *txq);
+
+#if defined(IMPROVE_QOS) || defined(CONFIG_RTL_HW_QOS_SUPPORT)
+//To query hardware address based on IP through arp table of dev
+int arp_req_get_ha(__be32 queryIP, struct net_device *dev,
+	unsigned char *resHwAddr);
+#endif
+
+#if	defined(CONFIG_RTL_HW_QOS_SUPPORT)
+int32 rtl_qosGetSkbMarkByNaptEntry(rtl865x_napt_entry * naptEntry,
+	rtl865x_qos_mark * qosMark, struct sk_buff *pskb);
+#endif
+int fast_path_before_nat_check(struct sk_buff *skb, struct iphdr *iph,
+	uint32 iphProtocol);
+
+#if defined(CONFIG_PROC_FS)
+int fastpath_dump_napt_entry_num(char *page, int len);
+#endif
+
+/* [MARCO FUNCTION] ========================================================================= */
+#define	MAC2STR(addr) \
+	((unsigned char *)&addr)[0], \
+	((unsigned char *)&addr)[1], \
+	((unsigned char *)&addr)[2], \
+	((unsigned char *)&addr)[3], \
+	((unsigned char *)&addr)[4], \
+	((unsigned char *)&addr)[5]
+
+#define	FASTPATH_MAC2STR(mac, hbuffer) \
+	do { \
+		int j,k; \
+		const char hexbuf[] =  "0123456789ABCDEF"; \
+		for (k=0,j=0;k<MAC_ADDR_LEN_MAX && j<6;j++) { \
+			hbuffer[k++]=hexbuf[(mac->octet[j]>>4)&15 ]; \
+			hbuffer[k++]=hexbuf[mac->octet[j]&15     ]; \
+			hbuffer[k++]=':'; \
+		} \
+		hbuffer[--k]=0; \
+	} while(0)		/* Mac Address to String */
+#if 0
+#define FASTPATH_ADJUST_CHKSUM_NAT(ip_mod, ip_org, chksum) \
+	do { \
+		s32 accumulate = 0; \
+		if (((ip_mod) != 0) && ((ip_org) != 0)){ \
+			accumulate = ((ip_org) & 0xffff); \
+			accumulate += (( (ip_org) >> 16 ) & 0xffff); \
+			accumulate -= ((ip_mod) & 0xffff); \
+			accumulate -= (( (ip_mod) >> 16 ) & 0xffff); \
+		} \
+		accumulate += ntohs(chksum); \
+		if (accumulate < 0) { \
+			accumulate = -accumulate; \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) ~accumulate); \
+		} else { \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) accumulate); \
+		} \
+	}while(0)		/* Checksum adjustment */
+
+#define FASTPATH_ADJUST_CHKSUM_NPT(port_mod, port_org, chksum) \
+	do { \
+		s32 accumulate = 0; \
+		if (((port_mod) != 0) && ((port_org) != 0)){ \
+			accumulate += (port_org); \
+			accumulate -= (port_mod); \
+		} \
+		accumulate += ntohs(chksum); \
+		if (accumulate < 0) { \
+			accumulate = -accumulate; \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) ~accumulate); \
+		} else { \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) accumulate); \
+		} \
+	}while(0)		/* Checksum adjustment */
+
+#define FASTPATH_ADJUST_CHKSUM_NAPT(ip_mod, ip_org, port_mod, port_org, chksum) \
+	do { \
+		s32 accumulate = 0; \
+		if (((ip_mod) != 0) && ((ip_org) != 0)){ \
+			accumulate = ((ip_org) & 0xffff); \
+			accumulate += (( (ip_org) >> 16 ) & 0xffff); \
+			accumulate -= ((ip_mod) & 0xffff); \
+			accumulate -= (( (ip_mod) >> 16 ) & 0xffff); \
+		} \
+		if (((port_mod) != 0) && ((port_org) != 0)){ \
+			accumulate += (port_org); \
+			accumulate -= (port_mod); \
+		} \
+		accumulate += ntohs(chksum); \
+		if (accumulate < 0) { \
+			accumulate = -accumulate; \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) ~accumulate); \
+		} else { \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) accumulate); \
+		} \
+	}while(0)		/* Checksum adjustment */
+#else
+
+#define FASTPATH_ADJUST_CHKSUM_NAT(ip_mod, ip_org, chksum) \
+	do { \
+		s32 accumulate = 0; \
+		accumulate = ((ip_org) & 0xffff); \
+		accumulate += (( (ip_org) >> 16 ) & 0xffff); \
+		accumulate -= ((ip_mod) & 0xffff); \
+		accumulate -= (( (ip_mod) >> 16 ) & 0xffff); \
+		accumulate += ntohs(chksum); \
+		if (accumulate < 0) { \
+			accumulate = -accumulate; \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) ~accumulate); \
+		} else { \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) accumulate); \
+		} \
+	}while(0)		/* Checksum adjustment */
+
+#define FASTPATH_ADJUST_CHKSUM_NPT(port_mod, port_org, chksum) \
+	do { \
+		s32 accumulate = 0; \
+		accumulate += (port_org); \
+		accumulate -= (port_mod); \
+		accumulate += ntohs(chksum); \
+		if (accumulate < 0) { \
+			accumulate = -accumulate; \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) ~accumulate); \
+		} else { \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) accumulate); \
+		} \
+	}while(0)		/* Checksum adjustment */
+
+#define FASTPATH_ADJUST_CHKSUM_NAPT(ip_mod, ip_org, port_mod, port_org, chksum) \
+	do { \
+		s32 accumulate = 0; \
+		accumulate = ((ip_org) & 0xffff); \
+		accumulate += (( (ip_org) >> 16 ) & 0xffff); \
+		accumulate -= ((ip_mod) & 0xffff); \
+		accumulate -= (( (ip_mod) >> 16 ) & 0xffff); \
+		accumulate += (port_org); \
+		accumulate -= (port_mod); \
+		accumulate += ntohs(chksum); \
+		if (accumulate < 0) { \
+			accumulate = -accumulate; \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) ~accumulate); \
+		} else { \
+			accumulate = (accumulate >> 16) + (accumulate & 0xffff); \
+			accumulate += accumulate >> 16; \
+			chksum = htons((uint16) accumulate); \
+		} \
+	}while(0)		/* Checksum adjustment */
+
+#endif
+/* ---------------------------------------------------------------------------------------------------- */
+#ifdef	DEBUG_PROCFILE
+void init_fastpath_debug_proc(void);
+void remove_fastpath_debug_proc(void);
+#endif
+#ifndef NO_ARP_USED
+int init_table_arp(int arp_tbl_list_max, int arp_tbl_entry_max);
+#endif
+#ifndef DEL_ROUTE_TBL
+int init_table_route(int route_tbl_list_max, int route_tbl_entry_max);
+#endif
+#ifndef DEL_NAPT_TBL
+int init_table_napt(int napt_tbl_list_max, int napt_tbl_entry_max);
+#endif
+
+#ifdef CONFIG_RTL_FAST_IPV6
+u_int8_t rtl_get_ct_protonum_ipv6(void *ct_ptr, enum ip_conntrack_dir dir);
+#endif
+
+int init_table_path(int path_tbl_list_max, int path_tbl_entry_max);
+int udp_fragCache_init(int udp_frag_entry_max);
+int negative_fragCache_init(void);
+void fastpath_set_qos_mark(struct sk_buff *skb, unsigned int preRouteMark,
+	unsigned int postRouteMark);
+int fast_path_pre_process_check(struct iphdr *iph, struct tcphdr *tcphupuh,
+	struct sk_buff *skb);
+int fast_path_post_process_xmit_check(struct iphdr *iph,
+	struct tcphdr *tcphupuh, struct sk_buff *skb);
+int fast_path_post_process_return_check(struct iphdr *iph,
+	struct tcphdr *tcphupuh, struct sk_buff *skb);
+int ip_finish_output3(struct sk_buff *skb);
+
+#if defined (CONFIG_RTL_FAST_PPPOE)
+int ip_finish_output4(struct sk_buff *skb);
+#endif
+__IRAM_GEN int enter_fast_path(void *skb);
+uint8 *FastPath_Route(ipaddr_t dIp);
+int FastPath_Enter(struct sk_buff **skb);
+extern int Get_fast_pptp_fw(void);
+
+#ifdef CONFIG_FAST_PATH_MODULE
+extern int (*fast_path_hook) (struct sk_buff **pskb);
+extern enum LR_RESULT (*FastPath_hook1) (ipaddr_t ip, ipaddr_t mask);
+extern enum LR_RESULT (*FastPath_hook2) (ipaddr_t ip, ipaddr_t mask,
+	ipaddr_t gateway, uint8 *ifname, enum RT_FLAGS flags);
+extern int (*fast_path_hook) (struct sk_buff **pskb);
+extern enum LR_RESULT (*FastPath_hook3) (ipaddr_t ip, ipaddr_t mask,
+	ipaddr_t gateway, uint8 *ifname, enum RT_FLAGS flags);
+extern enum LR_RESULT (*FastPath_hook4) (rtl_fp_napt_entry *fpNaptEntry);
+extern enum LR_RESULT (*FastPath_hook5) (ipaddr_t ip, ether_addr_t *mac,
+	enum ARP_FLAGS flags);
+#if defined(CONFIG_OPENWRT_SDK)
+extern enum LR_RESULT (*FastPath_hook6) (rtl_fp_napt_entry *fpNaptEntry,
+#if defined(IMPROVE_QOS)
+	void *pskb, void *ct,
+#endif
+	enum NP_FLAGS flags);
+#else
+enum LR_RESULT (*FastPath_hook6) (rtl_fp_napt_entry *fpNaptEntry,
+#if defined(IMPROVE_QOS)
+	struct sk_buff *pskb, struct nf_conn *ct,
+#endif
+	enum NP_FLAGS flags);
+#endif
+extern enum LR_RESULT (*FastPath_hook7) (ipaddr_t ip);
+extern enum LR_RESULT (*FastPath_hook8) (ipaddr_t ip, ether_addr_t *mac,
+	enum ARP_FLAGS flags);
+extern int (*FastPath_hook9) (void);
+
+#if defined(CONFIG_OPENWRT_SDK)
+extern int (*FastPath_hook10) (void *skb);
+#else
+extern int (*FastPath_hook10) (struct sk_buff * skb);
+#endif
+extern enum LR_RESULT (*FastPath_hook11) (rtl_fp_napt_entry *fpNaptEntry,
+	uint32 interval);
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_OPENWRT_SDK)
+extern int (*qosGetSkbMarkByNaptEntryHook) (rtl865x_napt_entry *naptEntry,
+	rtl865x_qos_mark *qosMark, struct sk_buff *pskb);
+#endif
+extern int fast_pptp_to_wan(void *skb);
+#endif
+
+/* ---------------------------------------------------------------------------------------------------- */
+#if defined(FASTPATH_FILTER)
+#define RTL_FILTER_CONTENT_MAXNUM 40
+#define RTL_TABLE_FILTER_ENTRY_COUNT 10
+#define IP_RANGE_TABLE 	1
+#define MAC_TABLE		2
+#define URL_KEY_TABLE	3
+#define SCHEDULT_TABLE	4
+#define CONTENT_FILTER	5
+
+typedef struct _rlt_filter_table_head {
+	struct list_head filter_table;
+	struct list_head filter_items;
+	uint32 flag;
+} rlt_filter_table_head;
+
+//ip range table
+#define RTL_IP_RANGE_FILTER_ENTRY_COUNT 20
+typedef struct _filter_ipRange_fastpath {
+	struct list_head list;
+	uint32 addr_start;	/*ipaddr start */
+	uint32 addr_end;	/*address end */
+	uint32 flag;		/*0 bit: default action[0:block,1:forward];1 bit: src ip or dest ip[0:src, 1:dest];2 bit: refer both direction */
+	/*bit 9: valid 1; invalid 0 */
+} rtl_ipRange_fastpath;
+
+//url and keyword
+#define RTL_URL_FILTER_CONTENT_MAXNUM_FASTPATH 40
+typedef struct _url_table_head_entry_fastpath {
+	struct list_head list;
+	uint32 flag;
+	int (*func) (struct sk_buff * skb);
+} url_table_head_entry_fastpath;
+
+typedef struct _url_table_unit_entry_fastpath {
+	struct list_head list;
+	char url_content[RTL_URL_FILTER_CONTENT_MAXNUM_FASTPATH];
+} url_table_unit_entry_fastpath;
+
+typedef struct _url_entry_fastpath {
+	struct list_head list;
+	char url_content[RTL_URL_FILTER_CONTENT_MAXNUM_FASTPATH];
+	uint32 flag;
+} rtl_url_entry_fastpath;
+
+typedef struct _rtl_mac_entry_fastpath {
+	struct list_head list;
+	char mac[ETHER_ADDR_LEN];
+	uint8 flag;
+} rtl_mac_entry_fastpath;
+
+typedef struct _rtl_sch_entry_fastpath {
+	struct list_head list;
+	uint32 weekMask;	/*bit0: sunday, bit 1: monday, .... bit 6 saturday, bit7: (1: all days, monday~sunday) */
+	uint32 startTime;	/*minutes, ex. 5:21 = 5*60+21 minutes */
+	uint32 endTime;		/*minutes */
+	uint8 allTimeFlag;	/*if alltime(00:00~23:59:59), please set this flag... */
+	uint8 flag;		/* bit0( 0: deny, 1: allow), bit1( 1:block all http packet), bit2(0:default deny; 1: default allow) */
+} rtl_sch_entry_fastpath;
+
+typedef struct _filter_table_info {
+	uint32 type;		//type
+	int (*func) (struct sk_buff *skb, void *data);
+} filter_table_info;
+
+typedef struct _filter_table_list {
+	struct list_head table_list;
+	struct list_head item_list;
+	uint32 type;		//type
+	uint32 flag;
+	uint32 num;
+	int (*func) (struct sk_buff * skb, void *data);
+} filter_table_list;
+
+typedef struct _filter_item_entry {
+	struct list_head item_list;
+	struct list_head rule_list;
+	uint32 relation_flag;	//bit0: is the first condition? 1;0
+				//bit1: have next condition? 1:0 [next table condition]
+				//bit2: have "and" logic condition?1:0
+				//bit3: default action: 1 block;0 forward
+				//bit4~7: the index of "and" logic rule
+				//bit8: all match flag 1: all, 0: not all
+				//bit9: NULL flag, 1:NULL, 0: not NULL
+	uint32 index;
+	uint32 flag;
+#ifdef CONFIG_URL_FILTER_USER_MODE_SUPPORT
+	char userMode;
+	char macAddr[2 * ETHER_ADDR_LEN + 1];
+	uint32 ipAddr;
+#endif
+	char data[RTL_FILTER_CONTENT_MAXNUM];
+} filter_item_entry;
+
+typedef struct _rtl_mac_info {
+	char mac[ETHER_ADDR_LEN];
+} rtl_mac_info;
+
+#if !defined(CONFIG_OPENWRT_SDK)
+/* --- PATH Table Structures --- */
+struct Path_List_Entry {
+	uint8			vaild;
+	uint8			type;
+	uint8			course;			/* 1:Out-Bonud 2:In-Bound */
+
+	/*diff with sd2 port1 start*/
+	enum NP_PROTOCOL	protocol;
+	//uint32		protocol;
+	uint16			in_dPort;
+	uint16			in_sPort;
+	ipaddr_t		in_sIp;
+	ipaddr_t		in_dIp;
+	ipaddr_t		out_sIp;
+	uint16			out_sPort;
+	ipaddr_t		out_dIp;
+	uint16			out_dPort;
+	/*diff with sd2 port1 end*/
+	uint32			last_used;
+	uint8			*out_ifname;
+#ifndef NO_ARP_USED
+	struct Arp_List_Entry	*arp_entry;		/* for Out-dMac */
+#endif
+
+#if defined(IMPROVE_QOS)
+#if defined(CONFIG_NET_SCHED)
+	uint32			PreMark;		//nfmark of uplink
+	uint32			PostMark;		//nfmark of downlink
+#endif
+	void			*ct;
+	unsigned long		timeout;
+#endif
+#if 1//defined(CONFIG_RTL_IP_POLICY_ROUTING_SUPPORT)
+	uint32			policy_route_mark;
+#endif
+
+//	struct dst_entry 	*dst;
+	unsigned int		packet_bypassed;
+	unsigned int		packet_bypass_checked;
+
+#if 1				//defined(CONFIG_RTL_DSCP_IPTABLE_CHECK) && defined(IMPROVE_QOS)
+	uint8			dscp_in;	//inbound dscp shoud changed to
+	uint8			dscp_out;	//outbound dscp shoud changed to
+#endif
+
+#if 1				//defined(CONFIG_RTL_VLANID_IPTABLE_CHECK) && defined(IMPROVE_QOS)
+	uint16			vlanid_in;	//inbound vlanid shoud changed to
+	uint16			vlanid_out;	//outbound vlanid shoud changed to
+#endif
+
+#if 1				//defined(CONFIG_RTL_VLANPRI_IPTABLE_CHECK) && defined(IMPROVE_QOS)
+	uint16			vlanpri_out;
+#endif
+
+	CTAILQ_ENTRY(Path_List_Entry) path_link;
+	CTAILQ_ENTRY(Path_List_Entry) tqe_link;
+};
+#endif
+//============================================================================
+
+extern filter_table_list table_list_head;
+
+#define	RTL_FP_FLT_TBL_INIT_VALUE	1
+#define	RTL_FP_FLT_TBL_EMPTY	(table_list_head.num==RTL_FP_FLT_TBL_INIT_VALUE)
+#define	RTL_FP_FLT_TBL_NOT_INIT	(table_list_head.num<RTL_FP_FLT_TBL_INIT_VALUE)
+#endif
+
+#define RTL_FASTPATH_PPP0_DEV_NAME	"ppp0"
+
+#if 1				//defined(CONFIG_RTL_NF_CONNTRACK_GARBAGE_NEW)
+void rtl_fp_mark_invalid(void *ct);
+#endif
+#if !defined(CONFIG_OPENWRT_SDK)
+void mark_path_invalid(uint32 sIp, uint16 sPort, uint32 dIp, uint16 dPort,
+	uint16 iphProtocol);
+#endif
+
+#define FASTPTH_INDEPENDENCE_KERNEL 1
+#if defined(FASTPTH_INDEPENDENCE_KERNEL)
+extern struct dst_entry *dst_tmp;
+extern int ppp_start_xmit(struct sk_buff *skb, struct net_device *dev);
+extern struct sk_buff *ppp_receive_nonmp_frame(struct ppp *ppp,
+	struct sk_buff *skb, int is_fast_fw);
+
+__be16 rtl_get_skb_protocol(struct sk_buff *skb);
+void rtl_set_skb_protocol(struct sk_buff *skb, __be16 protocol);
+
+unsigned char rtl_get_skb_type(struct sk_buff *skb);
+
+__wsum rtl_get_skb_csum(struct sk_buff *skb);
+
+#if !defined(CONFIG_OPENWRT_SDK)
+void rtl_dev_put(struct net_device *dev);
+#endif
+unsigned int rtl_get_skb_len(struct sk_buff *skb);
+
+unsigned char *rtl_get_skb_data(struct sk_buff *skb);
+void rtl_set_skb_data(struct sk_buff *skb, int offset, int action);
+
+unsigned char *rtl_skb_mac_header(struct sk_buff *skb);
+void rtl_skb_set_mac_header(struct sk_buff *skb, int offset);
+int rtl_skb_mac_header_was_set(struct sk_buff *skb);
+
+void rtl_set_skb_dmac(struct sk_buff *skb, void *device);
+void rtl_set_skb_smac(struct sk_buff *skb, void *device);
+
+unsigned char *rtl_skb_network_header(struct sk_buff *skb);
+void rtl_skb_set_network_header(struct sk_buff *skb, const int offset);
+void rtl_skb_reset_network_header(struct sk_buff *skb);
+void rtl_set_skb_network_header(struct sk_buff *skb,
+	unsigned char *network_header);
+
+unsigned char *rtl_skb_transport_header(struct sk_buff *skb);
+void rtl_skb_set_transport_header(struct sk_buff *skb, const int offset);
+void rtl_skb_reset_transport_header(struct sk_buff *skb);
+void rtl_set_skb_transport_header(struct sk_buff *skb,
+	unsigned char *transport_header);
+
+unsigned int rtl_get_skb_pppoe_flag(struct sk_buff *skb);
+void rtl_set_skb_pppoe_flag(struct sk_buff *skb, unsigned int pppoe_flag);
+
+unsigned char *rtl_skb_pull(struct sk_buff *skb, unsigned int len);
+unsigned char *rtl_skb_push(struct sk_buff *skb, unsigned int len);
+
+int rtl_ppp_proto_check(struct sk_buff *skb, unsigned char *ppp_proto);
+unsigned int rtl_ipt_do_table(struct sk_buff *skb, unsigned int hook, void *in,
+	void *out);
+#if defined(CONFIG_OPENWRT_SDK)
+int rtl_ip_route_input(struct sk_buff *skb, __be32 daddr, __be32 saddr, u8 tos);
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 10, 0)
+int rtl_skb_dst_check(struct sk_buff *skb, unsigned long dip, void *ct,
+	uint8 type);
+#else
+int rtl_skb_dst_check(struct sk_buff *skb);
+#endif
+#else
+int rtl_ip_route_input(struct sk_buff *skb, __be32 daddr, void *ct);
+unsigned int rtl_nf_rtcache_in(struct sk_buff *skb, const void *entry_ct);
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 10, 0)
+int rtl_skb_dst_check(struct sk_buff *skb, unsigned long dip,
+	struct iphdr *iph);
+#else
+int rtl_skb_dst_check(struct sk_buff *skb, struct iphdr *iph);
+#endif
+void rtl_dst_release_ipv4(struct sk_buff *skb);
+#endif
+void rtl_set_skb_ip_summed(struct sk_buff *skb, int value);
+void rtl_dst_release(struct sk_buff *skb);
+
+__u32 rtl_get_skb_mark(struct sk_buff *skb);
+void rtl_set_skb_mark(struct sk_buff *skb, unsigned int value);
+void rtl_store_skb_dst(struct sk_buff *skb);
+void rtl_set_skb_dst(struct sk_buff *skb);
+int rtl_tcp_get_timeouts(void *ptr);
+int rtl_arp_req_get_ha(__be32 queryIP, void *device, unsigned char *resHwAddr);
+
+u_int8_t rtl_get_ct_protonum(void *ct_ptr, enum ip_conntrack_dir dir);
+unsigned long rtl_get_ct_udp_status(void *ct_ptr);
+u_int8_t rtl_get_ct_tcp_state(void *ct_ptr);
+__be32 rtl_get_ct_ip_by_dir(void *ct_ptr, enum ip_conntrack_dir dir, int flag);
+__be16 rtl_get_ct_port_by_dir(void *ct_ptr, enum ip_conntrack_dir dir,
+	int flag);
+#if defined(CONFIG_RTD_1295_HWNAT) && LINUX_VERSION_CODE >= KERNEL_VERSION(4,9,0)
+void rtl_set_ct_timeout_expires(void *ct_ptr, unsigned int value);
+#else
+void rtl_set_ct_timeout_expires(void *ct_ptr, unsigned long value);
+#endif /* CONFIG_RTD_1295_HWNAT & version >= 4.9.0 */
+unsigned long rtl_hold_time(void *br_ptr);
+void rtl_set_fdb_aging(void *fdb_ptr, unsigned long value);
+unsigned long rtl_get_fdb_aging(void *fdb_ptr);
+
+struct ethhdr *rtl_eth_hdr(struct sk_buff *skb);
+struct iphdr *rtl_ip_hdr(struct sk_buff *skb);
+
+struct net_device *rtl_get_dev_by_name(char *name);
+
+struct net_device *rtl_get_skb_dev(struct sk_buff *skb);
+void rtl_set_skb_dev(struct sk_buff *skb, struct net_device *dev);
+
+char *rtl_get_skb_dev_name(struct sk_buff *skb);
+
+void rtl_set_skb_inDev(struct sk_buff *skb);
+
+#if !defined(CONFIG_OPENWRT_SDK)
+void rtl_skb_policy_route_mark_set(struct sk_buff *skb,
+	unsigned int policy_route_mark, unsigned int *mark_bak);
+void rtl_recheck_fp_policy_route_mark(struct sk_buff *skb,
+	uint32 *fp_policy_route_mark);
+#endif
+struct net_device *rtl_get_skb_rx_dev(struct sk_buff *skb);
+void rtl_set_skb_rx_dev(struct sk_buff *skb, struct net_device *dev);
+
+char *rtl_get_ppp_dev_name(struct net_device *ppp_dev);
+void *rtl_get_ppp_dev_priv(struct net_device *ppp_dev);
+
+int rtl_call_skb_ndo_start_xmit(struct sk_buff *skb);
+
+void rtl_inc_ppp_stats(struct ppp *ppp, int act, int len);
+
+void rtl_set_skb_tail(struct sk_buff *skb, int offset, int action);
+struct sk_buff *rtl_ppp_receive_nonmp_frame(struct ppp *ppp,
+	struct sk_buff *skb, int is_fast_fw);
+int rtl_ppp_start_xmit(struct sk_buff *skb, struct net_device *dev);
+void rtl_set_skb_cb(struct sk_buff *skb, char *value, int len);
+int rtl_ppp_vj_check(struct ppp *ppp);
+void *rtl_get_ppp_xmit_pending(struct ppp *ppp);
+void rtl_set_ppp_xmit_pending(struct ppp *ppp, struct sk_buff *skb);
+void rtl_set_skb_nfct(struct sk_buff *skb, void *value);
+struct neighbour *rtl_neigh_lookup(const void *pkey, struct net_device *dev);
+struct hh_cache *rtl_get_hh_from_neigh(struct neighbour *neigh);
+seqlock_t rtl_get_lock_from_hh(struct hh_cache *hh);
+unsigned short rtl_get_len_from_hh(struct hh_cache *hh);
+unsigned long *rtl_get_data_from_hh(struct hh_cache *hh);
+unsigned int rtl_skb_headroom(struct sk_buff *skb);
+int rtl_skb_cloned(struct sk_buff *skb);
+int rtl_skb_shared(const struct sk_buff *skb);
+
+#if 1				//defined(CONFIG_RTL_DSCP_IPTABLE_CHECK) && defined(IMPROVE_QOS)
+#if defined(CONFIG_OPENWRT_SDK)
+#if defined(CONFIG_RTL_DSCP_IPTABLE_CHECK) && defined(IMPROVE_QOS)
+__u8 rtl_get_skb_orig_dscp(struct sk_buff *skb);
+#endif
+#else
+__u8 rtl_get_skb_orig_dscp(struct sk_buff *skb);
+void rtl_set_iph_dscp(struct Path_List_Entry *entry_path, struct iphdr *iph);
+void rtl_set_entry_dscp_out(struct Path_List_Entry *entry_path,
+	struct sk_buff *pskb);
+void rtl_set_entry_dscp_in(struct Path_List_Entry *entry_path,
+	struct sk_buff *pskb);
+#endif /* CONFIG_OPENWRT_SDK */
+#endif
+
+#if !defined(CONFIG_OPENWRT_SDK)
+#if 1				//defined(CONFIG_RTL_VLANPRI_IPTABLE_CHECK) && defined(IMPROVE_QOS)
+__u16 rtl_get_skb_orig_vlanpri(struct sk_buff *skb);
+uint16 rtl_get_skb_remark_vlanpri(struct sk_buff *skb);
+uint16 rtl_restore_skb_vlanpri(struct sk_buff *skb, uint16 pri);
+void rtl_set_skb_remark_vlanpri(struct Path_List_Entry *entry_path,
+	struct sk_buff *skb);
+void rtl_set_entry_vlanpri(struct Path_List_Entry *entry_path,
+	struct sk_buff *pskb);
+void rtl_set_skb_ori_vlanpri(struct sk_buff *skb);
+#endif
+
+#if 1				//defined(CONFIG_RTL_VLANID_IPTABLE_CHECK) && defined(IMPROVE_QOS)
+uint16 rtl_get_skb_vlanId(struct sk_buff *skb);
+void rtl_set_skb_vlanId(struct sk_buff *skb, uint16 vlanId);
+void rtl_set_entry_vlanid_in(struct Path_List_Entry *entry_path,
+	struct sk_buff *skb);
+void rtl_set_entry_vlanid_out(struct Path_List_Entry *entry_path,
+	struct sk_buff *skb);
+#endif
+
+__u8 rtl_get_skb_phy_port(struct sk_buff *skb);
+void rtl_set_skb_phy_port(struct sk_buff *skb, uint8 phy_port);
+void rtl_set_skb_src_phy_port(struct sk_buff *skb, unsigned char *resMac,
+	int is_wan);
+#endif /* !CONFIG_OPENWRT_SDK */
+
+void rtl_conntrack_drop_check_hook(struct nf_conn *ct_tmp, uint16 ipprotocol,
+	struct nf_conn *ct);
+int rtl_Add_Pattern_ACL_For_ContentFilter(void);
+
+#ifdef CONFIG_RTL_FAST_IPV6
+struct ipv6hdr *rtl_ipv6_hdr(const struct sk_buff *skb);
+void rtl_store_skb_ipv6_dst(struct sk_buff *skb);
+void rtl_set_skb_ipv6_dst(struct sk_buff *skb);
+struct dst_entry *rtl_get_skb_ipv6_dst(struct sk_buff *skb);
+struct net_device *rtl_get_skb_ipv6_dst_dev(struct sk_buff *skb);
+void rtl_get_ct_v6_ip_by_dir(void *ct_ptr, enum ip_conntrack_dir dir, int flag,
+	struct in6_addr *addr);
+
+int rtl_skb_ipv6_dst_check(struct sk_buff *skb);
+int rtl_skb_is_gso(struct sk_buff *skb);
+int rtl_skb_to_dut(struct sk_buff *skb);
+u32 rtl_dst_allfrag(struct sk_buff *skb);
+struct hh_cache *rtl_get_hh_from_skb(struct sk_buff *skb);
+struct neighbour *rtl_get_neigh_from_skb(struct sk_buff *skb);
+int rtl_check_skb_dst_output_exist(struct sk_buff *skb);
+int rtl_neigh_hh_output(struct sk_buff *skb);
+int rtl_neigh_output(struct sk_buff *skb);
+int rtl_dst_output(struct sk_buff *skb);
+int rtl_ip6_route_input(struct sk_buff *skb);
+int rtl_ipt6_do_table(struct sk_buff *skb, unsigned int hook, void *in,
+	void *out);
+int rtl_check_dst_input(struct sk_buff *skb);
+void rtl_skb_dst_set(struct sk_buff *skb, struct dst_entry *dst);
+#endif
+#endif
+
+#define RTL_FSTPATH_TTL_ADJUST 1
+void get_fastpath_module_info(unsigned char *buf);
+
+//#define RTL_FASTPATH_FRAGMENT_SUPPORT 1
+#if defined(RTL_FASTPATH_FRAGMENT_SUPPORT)
+int fast_pppoe_xmit_check(struct sk_buff *skb);
+int fast_pppoe_xmit2(struct sk_buff *skb);
+int fast_l2tp_to_wan_check(void *skb);
+int fast_l2tp_to_wan2(void *skb);
+#endif
+
+#endif /* __FASTPATH_CORE_H__ */
diff --git a/include/net/rtl/features/fast_bridge.h b/include/net/rtl/features/fast_bridge.h
new file mode 100644
index 00000000..71c5cd7
--- /dev/null
+++ b/include/net/rtl/features/fast_bridge.h
@@ -0,0 +1,90 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#if !defined(FAST_BRIDGE_H)
+#define FAST_BRIDGE_H
+
+#define	CONFIG_RTL_FASTBRIDGE		1
+
+#define	RTL_FB_ENTRY_NUM				16
+#define	RTL_FB_HASH_SIZE				16	/* must be 2s order */
+
+#if !defined(__KERNEL__)
+struct hlist_node {
+	struct hlist_node *next, **pprev;
+};
+struct hlist_head {
+	struct hlist_node *first;
+};
+#endif
+
+typedef struct _rtl_fb_para
+{
+	uint32	enable_fb_filter:1;
+	uint32	enable_fb_fwd:1;
+	uint32	entry_num;
+} rtl_fb_para;
+
+typedef struct _rtl_fb_head
+{
+	struct hlist_head	in_used_list[RTL_FB_HASH_SIZE];
+	struct hlist_head	free_list;
+	uint32			used_cnt;
+} rtl_fb_head;
+
+typedef struct _rtl_fb_entry
+{
+	/* hlist MUST be the first filed */
+	struct hlist_node	hlist;	/* belongs to the same hash entry */
+	void*			dev_matchKey;
+	int32			(*ndo_start_xmit) (struct sk_buff *skb,
+						   struct net_device *dev);
+	unsigned long		last_used;
+	uint8			mac_addr[ETHER_ADDR_LEN];
+} rtl_fb_entry;
+
+int32	rtl_fb_process_in_nic(struct sk_buff *pskb, struct net_device *dev);
+void		rtl_fb_del_entry(const uint8 *mac);
+void		rtl_fb_flush(void);
+void		rtl_fb_flush_by_dev(void* key);
+unsigned long rtl_fb_get_entry_lastused(const uint8 *mac);
+
+#define	RTL_FB_RETURN_SUCCESS	0
+#define	RTL_FB_RETURN_FAILED		-1
+
+/*****************************************************/
+/*		netlink										*/
+#define	FB_CMD_NO_CMD			-1
+#define	FB_CMD_SET_FWD			0
+#define	FB_CMD_SET_FILTER			1
+#define	FB_CMD_SET_ENTRY_NUM	2
+#define	FB_CMD_GET_STATUS		3
+#define	FB_CMD_GET_USED_NUM		4
+#define	FB_CMD_DUMP_ENTRYS		5
+
+typedef struct _rtl_fb_nl_entry {
+	uint8			name[IFNAMSIZ];
+	uint8			mac_addr[ETHER_ADDR_LEN];
+	unsigned long		last_used;
+} rtl_fb_nl_entry;
+
+typedef struct fb_data_info {
+	rtl_fb_para		data;		/* status/flags/counter/etc */
+	rtl_fb_nl_entry	*entry;		/* for get entry list */
+	uint32			in_used;		/* inused count */
+} fb_data_info_s, *fb_data_info_p;
+
+typedef struct fb_cmd_info {
+	int 				action;		/*	set/get items	*/
+	fb_data_info_s	info;
+}fb_cmd_info_s, *fb_cmd_info_p;
+
+/*****************************************************/
+
+#endif
diff --git a/include/net/rtl/features/lan_restrict.h b/include/net/rtl/features/lan_restrict.h
new file mode 100644
index 00000000..969da8f
--- /dev/null
+++ b/include/net/rtl/features/lan_restrict.h
@@ -0,0 +1,19 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+//#include <common/rtl865x_common.h>
+#include <net/rtl/rtl_types.h>
+#include <net/rtl/rtl_queue.h>
+#include <net/rtl/rtl_nic.h>
+#include <net/rtl/rtl865x_fdb_api.h>
+
+int32 lan_restrict_getBlockAddr(int32 port , const unsigned char *swap_addr);
+extern int __init lan_restrict_init(void);
+extern int	 lan_restrict_rcv(struct sk_buff *skb, struct net_device *dev);
+extern int32 lan_restrict_CheckStatusByport(int32 port);
diff --git a/include/net/rtl/features/rtl_features.h b/include/net/rtl/features/rtl_features.h
new file mode 100644
index 00000000..b13eda6
--- /dev/null
+++ b/include/net/rtl/features/rtl_features.h
@@ -0,0 +1,290 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef	RTL_FEATURES_H
+#define	RTL_FEATURES_H		1
+
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+#include <linux/seq_file.h>
+#include <linux/inetdevice.h>
+extern struct proc_dir_entry proc_root;
+#endif
+
+extern char __conntrack_drop_check(void* tmp);
+extern int	rtl_nf_conntrack_threshold;
+extern int	drop_priority_max_idx;
+
+//#if defined(CONFIG_RTL_IPTABLES_FAST_PATH) || defined(CONFIG_RTL_HARDWARE_NAT) || defined(CONFIG_RTL_NF_CONNTRACK_GARBAGE_NEW)
+#define IS_CLASSD_ADDR(__ipv4addr__)				((((uint32)(__ipv4addr__)) & 0xf0000000) == 0xe0000000)
+#define IS_ALLZERO_ADDR(__ipv4addr__)				((((uint32)(__ipv4addr__)) & 0xffffffff) == 0)
+#define IS_BROADCAST_ADDR(__ipv4addr__)			((((uint32)(__ipv4addr__)) & 0xffffffff) == 0xffffffff)
+//#endif
+
+#if defined(CONFIG_RTL_NF_CONNTRACK_GARBAGE_NEW)
+struct tcp_state_hash_head
+{
+	enum tcp_conntrack state;
+
+	struct list_head* state_hash;
+};
+struct udp_state_hash_head
+{
+	uint8_t state;
+	struct list_head* state_hash;
+};
+
+#define UDP_UNREPLY (TCP_CONNTRACK_MAX+1)
+#define UDP_ASSURED (TCP_CONNTRACK_MAX+2)
+
+struct DROP_PRORITY{
+	u_int8_t state;
+	u_int16_t  threshold;
+};
+
+extern struct tcp_state_hash_head Tcp_State_Hash_Head[];
+extern struct udp_state_hash_head Udp_State_Hash_Head[];
+extern struct DROP_PRORITY drop_priority[];
+
+enum {
+	PROT_ICMP,
+	PROT_TCP,
+	PROT_UDP,
+	PROT_MAX
+};
+#endif
+
+#if defined(CONFIG_RTL_NF_CONNTRACK_GARBAGE_NEW)
+#if defined(CONFIG_PROC_FS)
+extern unsigned long rtl_gc_overflow_timout;
+void gc_overflow_timout_proc_init(void);
+#endif
+void clean_from_lists(void *ct, void *net);
+void rtl_death_action(void *ct);
+int drop_one_conntrack(const struct nf_conntrack_tuple *orig,const struct nf_conntrack_tuple *repl);
+int isReservedConntrack(const struct nf_conntrack_tuple * orig, const struct nf_conntrack_tuple * repl);
+int32 rtl_nf_conn_GC_init(void);
+int32 rtl_connGC_addList(void *skb, void *ct);
+#endif
+
+#if defined(CONFIG_RTL_IPTABLES_FAST_PATH)
+int rtl_fpTimer_update(void *ct);
+#endif
+
+void rtl_fpAddConnCache(struct nf_conn *ct, struct sk_buff *skb);
+#ifdef CONFIG_RTL_FAST_IPV6
+int rtl_AddV6ConnCache(struct nf_conn *ct, struct sk_buff *skb);
+int rtl_DelV6ConnCache(struct nf_conn *ct);
+int rtl_V6_connCache_timer_update(struct nf_conn *ct);
+#endif
+
+#if defined(CONFIG_RTL_LOCAL_PUBLIC) || defined(CONFIG_RTL_MULTIPLE_WAN)  ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN) || (defined(CONFIG_NET_SCHED)&&defined(CONFIG_RTL_IPTABLES_FAST_PATH)) || defined(CONFIG_RTL_HW_QOS_SUPPORT)
+extern struct net_device *rtl865x_getWanDev(void );
+extern struct net_device *rtl865x_getLanDev(void );
+#endif
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC) || defined(CONFIG_RTL_HW_QOS_SUPPORT)
+extern int rtl865x_attainDevType(unsigned char *devName, unsigned int *isLanDev, unsigned int *isWanDev);
+#endif
+
+#if defined(CONFIG_RTL_IPTABLES_FAST_PATH) || defined(CONFIG_RTL_HARDWARE_NAT)
+/*2007-12-19*/
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,10,0)
+extern int	tcp_get_timeouts_by_state(u_int8_t state,void *ct_or_cp,int is_ct);
+#else
+extern int 	tcp_get_timeouts_by_state(u_int8_t state);
+#endif
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 10, 0)
+extern unsigned int	udp_get_timeouts_by_state(enum udp_conntrack state,void *ct_or_cp,int is_ct);
+#else
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+extern unsigned int	udp_get_timeouts_by_state(enum udp_conntrack state);
+#else
+extern unsigned int nf_ct_udp_timeout;
+extern unsigned int nf_ct_udp_timeout_stream;
+#endif
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT) && LINUX_VERSION_CODE >= KERNEL_VERSION(4,9,0)
+void rtl_check_for_acc(struct nf_conn *ct, unsigned int expires);
+#else
+void rtl_check_for_acc(struct nf_conn *ct, unsigned long expires);
+#endif /* CONFIG_RTD_1295_HWNAT & version >= 4.9.0 */
+void rtl_delConnCache(struct nf_conn *ct);
+int32 rtl_connCache_timer_update(struct nf_conn *ct);
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+int32 rtl865x_handle_nat(struct nf_conn *ct, int act, struct sk_buff *skb);
+int rtl_hwnat_timer_update(struct nf_conn *ct);
+#ifndef CONFIG_RTL_EXT_PORT_SUPPORT
+#define CONFIG_RTL_AVOID_ADDING_WLAN_PKT_TO_HW_NAT 1
+#endif
+#endif
+
+#if (defined(IMPROVE_QOS) && defined(CONFIG_RTL_IPTABLES_FAST_PATH)) || defined(CONFIG_RTL_HARDWARE_NAT)
+void rtl_addConnCache(struct nf_conn *ct, struct sk_buff *skb);
+#endif
+
+#if defined(CONFIG_RTL_819X)
+int32 rtl_nat_init(void);
+#endif
+
+#if defined(CONFIG_NET_SCHED)
+extern int gQosEnabled;
+int32 rtl_qos_init(void);
+int32 rtl_qos_cleanup(void);
+#endif
+
+#if defined(CONFIG_RTL_FAST_BRIDGE)
+int32 rtl_fb_add_br_entry(skb)
+#endif
+
+//#define CONFIG_HARDWARE_NAT_DEBUG
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+#define RTL_MULTIPLE_WAN_NUM		16
+#else
+#define RTL_MULTIPLE_WAN_NUM		2
+#endif
+
+typedef struct _rtl_masq_if_struct
+{
+	unsigned int valid;
+	unsigned int ipAddr;
+	//struct ipt_entry *masq_entry;
+	char ifName[IFNAMSIZ];
+}rtl_masq_if;
+
+rtl_masq_if *rtl_get_masq_info_by_devName(const char* name);
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_NAT) ||defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+int32 syn_asic_arp(struct neighbour *n, int add);
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+#if defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+int32 rtl_get_ps_arp_mapping(u32 ip,void *arp_entry);
+#endif
+#endif
+
+#if defined(FAST_PATH_SPI_ENABLED)
+extern struct nf_conntrack_l4proto **nf_ct_protos[PF_MAX];
+extern unsigned int
+	rtl_nf_conntrack_in(struct net *net, unsigned int dataoff, unsigned int hooknum, struct sk_buff *skb);
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+#if defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+extern int32 rtl_del_extIp_not_exist_in_ps(void);
+extern void rtl_sync_extIp_to_masq_info(const char *name,
+		unsigned int valid_hooks, struct xt_table_info *newinfo,
+		void *entry0, unsigned int size, unsigned int number,
+		const unsigned int *hook_entries, const unsigned int *underflows);
+#endif
+int rtl_flush_extern_ip(void);
+int rtl_init_masq_info(void);
+int rtl_check_for_extern_ip(const char *name,
+		unsigned int valid_hooks, struct xt_table_info *newinfo,
+		void *entry0, unsigned int size,
+		unsigned int number, const unsigned int *hook_entries,
+		const unsigned int *underflows);
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+int32 rtl865x_handle_nat(struct nf_conn *ct, int act, struct sk_buff *skb);
+int32 rtl_update_ip_tables(char *name,  unsigned long event, struct in_ifaddr *ina);
+int32 rtl_fn_insert(struct fib_table *tb, struct fib_config *cfg, struct fib_info *fi);
+int32 rtl_fn_delete(struct fib_table *tb, struct fib_config *cfg);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+int32 rtl_fib_flush(u32 tb_id, u32 fn_key, u32 ip_mask);
+#endif
+int32 rtl_fn_flush(int	 fz_order, int idx, u32 tb_id, u32 fn_key);
+int32 rtl_ip_vs_conn_expire_check(struct ip_vs_conn *cp);
+int32 rtl_ip_vs_conn_expire_check_delete(struct ip_vs_conn *cp);
+void rtl_tcp_state_transition_check(struct ip_vs_conn *cp, int direction, const struct sk_buff *skb, struct ip_vs_protocol *pp);
+void rtl_udp_state_transition_check(struct ip_vs_conn *cp, int direction, const struct sk_buff *skb, struct ip_vs_protocol *pp);
+#endif
+
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+int32 rtl8198c_ipv6_router_add(struct rt6_info *rt);
+int32 rtl8198c_ipv6_router_del(struct rt6_info *rt);
+#endif
+
+#if defined(CONFIG_RTL_NF_CONNTRACK_GARBAGE_NEW)
+extern int	rtl_newGC_session_status_flags;
+extern unsigned long rtl_newGC_session_status_time;
+
+#if (HZ==100)
+#define	RTL_FP_SESSION_LEVEL3_INTERVAL		(1)
+#define	RTL_FP_SESSION_LEVEL1_INTERVAL		(200)	/* 2 second */
+#elif (HZ==1000)
+#define	RTL_FP_SESSION_LEVEL3_INTERVAL		(10)
+#define	RTL_FP_SESSION_LEVEL1_INTERVAL		(2000)	/* 2 second */
+#else
+#error "Please adjust the parameter according to the HZ"
+#endif
+
+#if defined(CONFIG_RTL_8198)
+#define	RTL_FP_SESSION_LEVEL3_ALLOW_COUNT	(40)
+#else
+#define	RTL_FP_SESSION_LEVEL3_ALLOW_COUNT	(16)
+#endif
+#define	RTL_FP_SESSION_LEVEL1_RX_WEIGHT		(8)
+
+#define	RTL_FP_SESSION_LEVEL_IDLE				0
+#define	RTL_FP_SESSION_LEVEL1					1
+#define	RTL_FP_SESSION_LEVEL2					2
+#define	RTL_FP_SESSION_LEVEL3					3
+//void rtl_fp_mark_invalid(struct nf_conn *ct);
+//enum LR_RESULT rtk_refreshOSConnectionTimer(void);
+
+#if 1 //defined(CONFIG_RTL_GC_INDEPENDENCE_ON_KERNEL)
+int rtl_gc_threshold_check(struct net* net);
+void rtl_list_del(struct nf_conn* ct);
+void rtl_hlist_nulls_del_rcu(struct nf_conn* ct, enum ip_conntrack_dir dir);
+void rtl_list_add_tail(struct nf_conn* ct, int proto, int flag);
+int rtl_test_bit(struct nf_conn* ct, int num);
+int rtl_del_ct_timer(struct nf_conn *ct);
+void rtl_add_ct_timer(struct nf_conn *ct);
+void rtl_list_move_tail(struct nf_conn *ct, int proto, int state);
+#if defined(CONFIG_RTD_1295_HWNAT) && LINUX_VERSION_CODE >= KERNEL_VERSION(4,9,0)
+unsigned int rtl_get_ct_timer_expires(struct nf_conn* ct);
+#else
+unsigned long rtl_get_ct_timer_expires(struct nf_conn* ct);
+#endif /* CONFIG_RTD_1295_HWNAT & version >= 4.9.0 */
+void rtl_nf_ct_stat_inc(struct net* net);
+int rtl_skb_network_offset(struct sk_buff *skb);
+u_int8_t rtl_new_gc_get_ct_protonum(void *ct_ptr, enum ip_conntrack_dir dir);
+struct iphdr *rtl_new_gc_ip_hdr(struct sk_buff *skb);
+__be16 rtl_new_gc_get_skb_protocol(struct sk_buff *skb);
+unsigned long rtl_new_gc_get_ct_udp_status(void *ct_ptr);
+u_int8_t rtl_new_gc_get_ct_tcp_state(void *ct_ptr);
+#if defined(CONFIG_RTD_1295_HWNAT) && LINUX_VERSION_CODE >= KERNEL_VERSION(4,9,0)
+void rtl_new_gc_set_ct_timeout_expires(void *ct_ptr, unsigned int value);
+#else
+void rtl_new_gc_set_ct_timeout_expires(void *ct_ptr, unsigned long value);
+#endif /* CONFIG_RTD_1295_HWNAT & version >= 4.9.0 */
+__be32 rtl_new_gc_get_ct_ip_by_dir(void *ct_ptr, enum ip_conntrack_dir dir, int flag);
+__be16 rtl_new_gc_get_ct_port_by_dir(void *ct_ptr, enum ip_conntrack_dir dir, int flag);
+#endif
+
+#endif
+
+#define CONFIG_RTL_URL_PATCH 1
+#if defined(CONFIG_RTL_URL_PATCH)
+#define URL_PROTO_PORT 80
+#endif
+
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+extern int router_support_hw_nat;
+#endif
+#endif	/*	RTL_FEATURES_H	*/
diff --git a/include/net/rtl/features/rtl_ps_hooks.h b/include/net/rtl/features/rtl_ps_hooks.h
new file mode 100644
index 00000000..a3f3466
--- /dev/null
+++ b/include/net/rtl/features/rtl_ps_hooks.h
@@ -0,0 +1,227 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef	RTL_PS_HOOKS_H
+#define	RTL_PS_HOOKS_H		1
+
+#include <linux/netfilter_ipv4.h>
+#include <linux/netfilter/nf_conntrack_common.h>
+
+#include <linux/netfilter/nf_conntrack_tcp.h>
+
+#include <net/rtl/rtl_types.h>
+#include <net/ip_fib.h>
+#include <net/ip_vs.h>
+
+#if defined(CONFIG_RTL_AP_PACKAGE) && !defined(CONFIG_NETFILTER)
+#else
+#include <net/netfilter/nf_conntrack.h>
+#include <net/netfilter/nf_conntrack_core.h>
+#include <net/netfilter/nf_conntrack_helper.h>
+#endif
+
+#include <net/rtl/features/rtl_features.h>
+#if defined(CONFIG_RTL_FASTBRIDGE)
+#include <net/rtl/features/fast_bridge.h>
+#endif
+#include "../../../net/bridge/br_private.h"
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_OPENWRT_SDK)
+#include <net/rtl/rtl865x_netif.h>
+#include <net/rtl/rtl865x_outputQueue.h>
+#endif
+
+#define	RTL_PS_HOOKS_CONTINUE	0		/*	keep the process flow	*/
+#define	RTL_PS_HOOKS_BREAK		1		/*	should break from caller's loops	*/
+#define	RTL_PS_HOOKS_RETURN		2		/*	should immediately return from the caller function	*/
+#define	RTL_PS_HOOKS_DROP		3
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+extern int extPortEnabled;
+#ifndef PKTHDR_EXTPORT_P3
+#define 	PKTHDR_EXTPORT_P3 8
+#endif
+#endif
+
+typedef struct rtl_nf_conntrack_info {
+	struct net				*net;
+	struct nf_conn				*ct;
+	struct sk_buff 			*skb;
+	struct nf_conntrack_l3proto *l3proto;
+	struct nf_conntrack_l4proto *l4proto;
+	u_int8_t 					protonum;
+	u_int8_t 					pf;
+	unsigned int 				hooknum;
+	enum ip_conntrack_info		ctinfo;
+	enum tcp_conntrack 		new_state;
+	enum tcp_conntrack 		old_state;
+	#if defined(CONFIG_RTD_1295_HWNAT)
+	u_int32_t			hash;
+	u_int32_t			reply_hash;
+	void (*double_unlock)(struct rtl_nf_conntrack_info *conn_info);
+	void (*double_lock)(struct rtl_nf_conntrack_info *conn_info);
+	#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+}	rtl_nf_conntrack_inso_s;
+
+int32 rtl_nf_conntrack_in_hooks(rtl_nf_conntrack_inso_s *info);
+int32 rtl_nf_conntrack_death_by_timeout_hooks(rtl_nf_conntrack_inso_s *info);
+int32 rtl_nf_conntrack_destroy_hooks(rtl_nf_conntrack_inso_s *info);
+int32 rtl_nf_conntrack_confirm_hooks(rtl_nf_conntrack_inso_s *info);
+int32 rtl_nf_init_conntrack_hooks(rtl_nf_conntrack_inso_s *info);
+int32 rtl_nf_conntrack_init_hooks(void);
+int32 rtl_tcp_packet_hooks(rtl_nf_conntrack_inso_s *info);
+int32 rtl_nf_nat_packet_hooks(rtl_nf_conntrack_inso_s *info);
+int32 rtl_nat_init_hooks(void);
+int32 rtl_nat_cleanup_hooks(void);
+
+int32 rtl_fn_hash_insert_hooks(struct fib_table *tb, struct fib_config *cfg, struct fib_info *fi);
+int32 rtl_fn_hash_delete_hooks(struct fib_table *tb, struct fib_config *cfg);
+int32 rtl_fn_flush_list_hooks(int	 fz_order, int idx, u32 tb_id, u32 fn_key);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+int32 rtl_fib_flush_list_hooks(u32 tb_id, u32 fn_key, u32 ip_mask);
+#endif
+int32 rtl_fn_hash_replace_hooks(struct fib_table *tb, struct fib_config *cfg, struct fib_info *fi);
+
+#if defined(CONFIG_OPENWRT_SDK)
+#if defined(CONFIG_IPV6) && defined(CONFIG_RTL_8198C)
+int32 rtl8198c_fib6_add_hooks(struct rt6_info *rt);
+int32 rtl8198c_fib6_del_hooks(struct rt6_info *rt);
+#endif
+#else
+int32 rtl8198c_fib6_add_hooks(void *rt);
+int32 rtl8198c_fib6_del_hooks(void *rt);
+#endif
+
+int32 rtl_dev_queue_xmit_hooks(struct sk_buff *skb, struct net_device *dev);
+int32 rtl_dev_hard_start_xmit_hooks(struct sk_buff *skb, struct net_device *dev, struct netdev_queue *txq);
+int32 rtl_netif_receive_skb_hooks(struct sk_buff **pskb);
+
+int32 rtl_br_dev_queue_push_xmit_before_xmit_hooks(struct sk_buff *skb);
+
+#ifdef CONFIG_NET_SCHED
+
+extern int gQosEnabled;
+#endif
+
+int32 rtl_neigh_forced_gc_hooks(struct neigh_table *tbl, struct neighbour *n);
+int32 rtl_neigh_flush_dev_hooks(struct neigh_table *tbl, struct net_device *dev, struct neighbour *n);
+int32 rtl_neigh_destroy_hooks(struct neighbour *n);
+int32 rtl_neigh_connect_hooks(struct neighbour *neigh);
+int32 rtl_neigh_timer_handler_pre_update_hooks(struct neighbour *neigh, unsigned state);
+int32 rtl_neigh_timer_handler_during_update_hooks(struct neighbour *neigh, unsigned state);
+int32 rtl_neigh_timer_handler_post_update_hooks(struct neighbour *neigh, unsigned state);
+int32 rtl___neigh_event_send_pre_hooks(struct neighbour *neigh, struct sk_buff *skb);
+int32 rtl___neigh_event_send_post_hooks(struct neighbour *neigh, struct sk_buff *skb);
+int32 rtl_neigh_update_hooks(struct neighbour *n, const u8 *lladdr, uint8 old);
+int32 rtl_neigh_update_post_hooks(struct neighbour *n, const u8 *lladdr, uint8 old);
+int32 rtl_neigh_periodic_timer_hooks(struct neighbour *n,  unsigned int  refresh);
+int32 rtl_neigh_init_hooks(void);
+void rtl_update_ps_neigh_confirm(struct neighbour *neigh);
+
+#if defined(CONFIG_BRIDGE)
+int32 rtl___br_fdb_get_timeout_hooks(struct net_bridge *br, struct net_bridge_fdb_entry *fdb, const unsigned char *addr);
+#endif
+int32 rtl_translate_table_hooks(const char *name,
+
+		unsigned int valid_hooks,
+		struct xt_table_info *newinfo,
+		void *entry0,
+		unsigned int size,
+		unsigned int number,
+		const unsigned int *hook_entries,
+		const unsigned int *underflows);
+
+int32 rtl_ip_tables_init_hooks(void);
+
+int32 rtl_masq_device_event_hooks(struct notifier_block *this, struct net_device *dev,  unsigned long event);
+int32 rtl_masq_inet_event_hooks(struct notifier_block *this, unsigned long event, void *ptr);
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if IS_ENABLED(CONFIG_IP_VS)
+int32 rtl_ip_vs_conn_expire_hooks1(struct ip_vs_conn *cp);
+int32 rtl_ip_vs_conn_expire_hooks2(struct ip_vs_conn *cp);
+#endif
+
+#if IS_ENABLED(CONFIG_IP_VS_PROTO_TCP)
+int32 rtl_tcp_state_transition_hooks(struct ip_vs_conn *cp, int direction, const struct sk_buff *skb, struct ip_vs_protocol *pp);
+#endif
+
+#if IS_ENABLED(CONFIG_IP_VS_PROTO_UDP)
+int32 rtl_udp_state_transition_hooks(struct ip_vs_conn *cp, int direction, const struct sk_buff *skb, struct ip_vs_protocol *pp);
+#endif
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_IP_VS)
+int32 rtl_ip_vs_conn_expire_hooks1(struct ip_vs_conn *cp);
+int32 rtl_ip_vs_conn_expire_hooks2(struct ip_vs_conn *cp);
+#endif
+
+#if defined(CONFIG_IP_VS_PROTO_TCP)
+int32 rtl_tcp_state_transition_hooks(struct ip_vs_conn *cp, int direction, const struct sk_buff *skb, struct ip_vs_protocol *pp);
+#endif
+
+#if defined(CONFIG_IP_VS_PROTO_UDP)
+int32 rtl_udp_state_transition_hooks(struct ip_vs_conn *cp, int direction, const struct sk_buff *skb, struct ip_vs_protocol *pp);
+#endif
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#ifdef CONFIG_PROC_FS
+int rtl_ct_seq_show_hooks(struct seq_file *s, struct nf_conn *ct);
+#endif
+#if 0
+int rtl_get_unique_tuple_hooks(struct nf_conntrack_tuple *tuple,
+		 const struct nf_conntrack_tuple *orig_tuple,
+		 const struct nf_nat_range *range,
+		 struct nf_conn *ct,
+		 enum nf_nat_manip_type maniptype,
+		 struct nf_nat_protocol *proto);
+
+#endif
+
+int32 rtl_dst_alloc_gc_pre_check_hooks(struct dst_ops * ops);
+int32 rtl_dst_alloc_gc_post_check1_hooks(struct dst_ops * ops);
+int32 rtl_dst_alloc_gc_post_check2_hooks(struct dst_ops * ops, struct dst_entry * dst);
+
+#if defined(CONFIG_RTL_NF_CONNTRACK_GARBAGE_NEW)
+int32 clean_from_lists_hooks(struct nf_conn *ct, struct net *net);
+int32 __nf_ct_refresh_acct_proto_hooks(struct nf_conn *ct,
+					enum ip_conntrack_info ctinfo,
+					const struct sk_buff *skb,
+					int do_acct,
+					int *event);
+int32 __drop_one_conntrack_process_hooks1(struct nf_conn* ct, int dropPrioIdx, int factor, int checkFlags, int tcpUdpState);
+int32 __drop_one_conntrack_process_hooks2(struct nf_conn* ct, int dropPrioIdx, int factor, int checkFlags, int tcpUdpState);
+int32 rtl_nf_conn_GC_init_hooks(void);
+#endif
+
+
+#if defined(CONFIG_BRIDGE)
+int32 rtl_fdb_create_hooks(struct net_bridge_fdb_entry *fdb,const unsigned char *addr);
+int32 rtl865x_addAuthFDBEntry_hooks(const unsigned char *addr);
+int32 rtl_fdb_delete_hooks(struct net_bridge_fdb_entry *f);
+int32 rtl_br_fdb_cleanup_hooks(struct net_bridge *br, struct net_bridge_fdb_entry *f, unsigned long delay);
+
+#endif
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_OPENWRT_SDK)
+int rtl_hwQosSyncTcHook(struct net_device *dev, struct Qdisc  *q,unsigned int parent);
+
+#endif
+#if defined(CONFIG_RTL_QOS_SYNC_SUPPORT)
+
+
+int rtl_QosSyncTcHook(struct net_device *dev, struct Qdisc  *q,unsigned int parent, int process);
+
+#define RTL_QOS_QUEUE_HOOK 	0x1
+#define RTL_QOS_CLASS_HOOK 	0x2
+#define RTL_QOS_FILTER_HOOK 	0x4
+#define RTL_QOS_ADD_PROCESS	0x10
+#define RTL_QOS_DEL_PROCESS	0x20
+
+#endif
+#endif
+
+
+
diff --git a/include/net/rtl/features/rtl_ps_log.h b/include/net/rtl/features/rtl_ps_log.h
new file mode 100644
index 00000000..62879dc
--- /dev/null
+++ b/include/net/rtl/features/rtl_ps_log.h
@@ -0,0 +1,53 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef	RTL_PS_LOG_H
+#define	RTL_PS_LOG_H
+
+#if defined(CONFIG_RTL_LOG_DEBUG)
+
+	#if defined(LOG_ERROR)
+	#undef LOG_ERROR
+	#define LOG_ERROR(fmt, args...) do{ \
+		if(RTL_LogTypeMask.ERROR&&RTL_LogModuleMask.PROSTACK&&LOG_LIMIT)scrlog_printk("PS-ERROR:"fmt, ## args); \
+			}while(0)
+	#endif
+
+	#if defined(LOG_MEM_ERROR)
+	#undef LOG_MEM_ERROR
+	#define LOG_MEM_ERROR(fmt, args...) do{ \
+		if(RTL_LogTypeMask.ERROR&&RTL_LogErrorMask.MEM&&RTL_LogModuleMask.PROSTACK&&LOG_LIMIT)scrlog_printk("PS-MEM-ERROR:"fmt, ## args); \
+			}while(0)
+	#endif
+
+	#if defined(LOG_SKB_ERROR)
+	#undef LOG_SKB_ERROR
+	#define LOG_SKB_ERROR(fmt, args...) do{ \
+		if(RTL_LogTypeMask.ERROR&&RTL_LogErrorMask.SKB&&RTL_LogModuleMask.PROSTACK&&LOG_LIMIT)scrlog_printk("PS-SKB-ERROR:"fmt, ## args); \
+			}while(0)
+	#endif
+
+	#if defined(LOG_WARN)
+	#undef LOG_WARN
+	#define LOG_WARN(fmt, args...) do{ \
+		if(RTL_LogTypeMask.WARN&&RTL_LogModuleMask.PROSTACK&&LOG_LIMIT)scrlog_printk("PS-WARN:"fmt, ## args); \
+			}while(0)
+	#endif
+
+	#if defined(LOG_INFO)
+	#undef LOG_INFO
+	#define LOG_INFO(fmt, args...) do{ \
+		if(RTL_LogTypeMask.INFO&&RTL_LogModuleMask.PROSTACK&&LOG_LIMIT)scrlog_printk("PS-INFO:"fmt, ## args); \
+			}while(0)
+	#endif
+
+#endif
+
+#endif
+
diff --git a/include/net/rtl/rtk_stp.h b/include/net/rtl/rtk_stp.h
new file mode 100644
index 00000000..5afa86b
--- /dev/null
+++ b/include/net/rtl/rtk_stp.h
@@ -0,0 +1,48 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+/*
+ *      Headler file of Realtek STP
+ *
+ *      $Id: rtk_stp.h,v 1.3 2009/06/01 07:00:27 davidhsu Exp $
+ */
+
+#ifndef _RTK_STP_H
+#define _RTK_STP_H
+#include "rtl_types.h"
+
+#ifdef CONFIG_RTK_MESH
+#define MAX_RE865X_STP_PORT	7
+#define WLAN_MESH_PSEUDO_IF_INDEX	6
+#define WLAN_MESH_IF_NAME		"wlan0-msh0"
+#else
+#define MAX_RE865X_STP_PORT	6
+#endif
+
+#define MAX_RE865X_ETH_STP_PORT	5
+#define WLAN_PSEUDO_IF_INDEX	5
+#define WLAN_IF_NAME			"wlan0"
+
+#define NO_MAPPING				-1
+
+#define MAX_RTL_STP_PORT_WH	5
+
+#define RTL8651_PORTSTA_DISABLED		0x00
+#define RTL8651_PORTSTA_BLOCKING		0x01
+#define RTL8651_PORTSTA_LISTENING		0x02
+#define RTL8651_PORTSTA_LEARNING		0x03
+#define RTL8651_PORTSTA_FORWARDING	0x04
+
+extern int8 STP_PortDev_Mapping[MAX_RE865X_STP_PORT];
+
+int32 rtl865x_setSpanningEnable(int8 spanningTreeEnabled);
+int32 rtl865x_setMulticastSpanningTreePortState(uint32 port, uint32 portState);
+int32 rtl865x_setSpanningTreePortState(uint32 port, uint32 portState);
+
+#endif // _RTK_STP_H
diff --git a/include/net/rtl/rtk_vlan.h b/include/net/rtl/rtk_vlan.h
new file mode 100644
index 00000000..733ee4b
--- /dev/null
+++ b/include/net/rtl/rtk_vlan.h
@@ -0,0 +1,88 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+/*
+ *      Headler file of Realtek VLAN
+ *
+ *      $Id: rtk_vlan.h,v 1.3 2009/06/01 07:00:27 davidhsu Exp $
+ */
+
+#ifndef _RTK_VLAN_H
+#define _RTK_VLAN_H
+
+// to_be_checked !!!
+#if !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F)
+#include "rtl_types.h"
+#endif
+//#define CONFIG_PPPOE_VLANTAG 1
+
+#if	defined (CONFIG_PPPOE_VLANTAG)
+#define COPY_TAG(tag, info) { \
+	tag.f.tpid =  htons(ETH_P_8021Q); \
+	tag.f.pci = (unsigned short) (((((unsigned char)info->pri)&0x7) << 13) | \
+					((((unsigned char)info->cfi)&0x1) << 12) |((unsigned short)info->id&0xfff)); \
+	tag.f.pci =  htons(tag.f.pci);	\
+}
+
+
+#define STRIP_TAG(skb) { \
+	memmove(skb->data+VLAN_HLEN, skb->data, ETH_ALEN*2); \
+	skb_pull(skb, VLAN_HLEN); \
+}
+#endif
+
+struct vlan_info {
+	int global_vlan;		// 0/1 - global vlan disable/enable
+	int is_lan;				// 1: eth-lan/wlan port, 0: wan port
+	int vlan;				// 0/1: disable/enable vlan
+	int tag;				// 0/1: disable/enable tagging
+	int id;					// 1~4090: vlan id
+	int pri;				// 0~7: priority;
+	int cfi;				// 0/1: cfi
+//#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT) //mark_hwv
+	int forwarding_rule;	// 0:disabled/1: bridge/2:NAT
+	int index;
+//#endif
+};
+
+struct _vlan_tag {
+	unsigned short tpid;	// protocol id
+	unsigned short pci;		// priority:3, cfi:1, id:12
+};
+
+struct vlan_tag {
+	union
+	{
+		unsigned long v;
+		struct _vlan_tag f;
+	};
+};
+
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+extern struct vlan_info management_vlan;
+extern unsigned char lan_macaddr[6];
+struct vlan_info_item {
+	struct vlan_info info;
+	struct net_device *dev;
+};
+struct net_device *rtl_get_wan_from_vlan_info(void);
+int rtl_add_vlan_info(struct vlan_info *info, struct net_device *dev);
+struct vlan_info_item *rtl_get_vlan_info_item_by_dev(struct net_device *dev);
+
+#endif
+
+#ifdef CONFIG_RTL_HW_VLAN_SUPPORT
+#define CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+#endif
+
+#if defined(CONFIG_RTL_HW_STP)
+unsigned int rtl865x_getVlanPortMask(unsigned int vid);
+#endif
+
+#endif // _RTK_VLAN_H
diff --git a/include/net/rtl/rtl8198c_arp_ipv6_api.h b/include/net/rtl/rtl8198c_arp_ipv6_api.h
new file mode 100644
index 00000000..513b4f9
--- /dev/null
+++ b/include/net/rtl/rtl8198c_arp_ipv6_api.h
@@ -0,0 +1,40 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL865X_ARP_IPV6_API_H
+#define RTL865X_ARP_IPV6_API_H
+
+#define RTL8198C_IPV6_ARPTBL_SIZE 256
+
+typedef struct rtl8198c_ipv6_arpMapping_entry_s
+{
+	 uint32 valid;
+        inv6_addr_t ip;
+        ether_addr_t mac;
+	 uint32 subnetIdx;
+}rtl8198c_ipv6_arpMapping_entry_t;
+
+struct rtl8198c_ipv6_arp_table {
+        rtl8198c_ipv6_arpMapping_entry_t      mappings[RTL8198C_IPV6_ARPTBL_SIZE];
+};
+
+/*for linux protocol stack sync*/
+int32 rtl8198c_addIpv6Arp(inv6_addr_t ip, ether_addr_t * mac);
+int32 rtl8198c_delIpv6Arp(inv6_addr_t ip);
+int32 rtl8198c_delIpv6ArpBySubnetIdx(uint32 subnetIdx);
+uint32 rtl8198c_ipv6ArpSync(inv6_addr_t ip, uint32 refresh);
+int32 rtl8198c_getIpv6ArpMapping(inv6_addr_t ip, rtl8198c_ipv6_arpMapping_entry_t * arp_mapping);
+int32 rtl8198c_changeIpv6ArpSubnetIdx(uint32 old_subnetIdx, uint32 new_subnetIdx);
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#if defined(CONFIG_RTL_HW_DSLITE_SUPPORT)
+int32 rtl8198c_dslite_Ipv6ArpMapping(inv6_addr_t ip, rtl8198c_ipv6_arpMapping_entry_t * arp_mapping);
+#endif
+#endif
+#endif
+
diff --git a/include/net/rtl/rtl8198c_route_ipv6_api.h b/include/net/rtl/rtl8198c_route_ipv6_api.h
new file mode 100644
index 00000000..f2079d7
--- /dev/null
+++ b/include/net/rtl/rtl8198c_route_ipv6_api.h
@@ -0,0 +1,24 @@
+/*
+ * * Copyright c                  Realtek Semiconductor Corporation, 2013
+ * * All rights reserved.
+ * *
+ * * Program : route table driver
+ * * Abstract :
+ * * Author : Jia Wenjian (wenjain_jai@realsil.com.cn)
+ * *
+ * * This program is free software; you can redistribute it and/or modify
+ * * it under the terms of the GNU General Public License as published by
+ * * the Free Software Foundation; either version 2 of the License, or
+ * * (at your option) any later version.
+ * */
+#ifndef RTL8198C_ROUTE_IPV6_API_H
+#define RTL8198C_ROUTE_IPV6_API_H
+
+#define IPV6_RT_ASIC_ENTRY_NUM 	8
+#define IPV6_RT_DRV_ENTRY_NUM        8
+
+int32 rtl8198c_addIpv6Route(inv6_addr_t ipAddr, int fc_dst_len, inv6_addr_t nextHop, int8 * ifName);
+int32 rtl8198c_delIpv6Route(inv6_addr_t ipAddr, int fc_dst_len);
+
+#endif
+
diff --git a/include/net/rtl/rtl865x_arp_api.h b/include/net/rtl/rtl865x_arp_api.h
new file mode 100644
index 00000000..c371708
--- /dev/null
+++ b/include/net/rtl/rtl865x_arp_api.h
@@ -0,0 +1,43 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL865X_ARP_API_H
+#define RTL865X_ARP_API_H
+
+#define RTL865X_ARPTBL_SIZE 512
+
+typedef struct rtl865x_arpMapping_entry_s {
+	ipaddr_t ip;
+	ether_addr_t mac;
+#if defined(CONFIG_RTL_HW_NAPT_REFINE_KERNEL_HOOKS)
+	uint16 exist_in_ps;
+	uint16 valid;
+#endif
+} rtl865x_arpMapping_entry_t;
+
+struct rtl865x_arp_table {
+	uint8 allocBitmap[64];
+	rtl865x_arpMapping_entry_t mappings[512];
+};
+
+/*for linux protocol stack sync*/
+int32 rtl865x_addArp(ipaddr_t ip, ether_addr_t *mac);
+int32 rtl865x_delArp(ipaddr_t ip);
+uint32 rtl865x_arpSync(ipaddr_t ip, uint32 refresh);
+int32 rtl865x_getArpMapping(ipaddr_t ip,
+	rtl865x_arpMapping_entry_t *arp_mapping);
+#if defined(CONFIG_RTL_MULTIPLE_WAN) || defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+int32 rtl_set_callback_for_ps_arp(int (*call_back_fn) (u32 ip,
+		rtl865x_arpMapping_entry_t *entry));
+#endif
+
+#if 1				/* #if defined(CONFIG_RTL_AVOID_ADDING_WLAN_PKT_TO_HW_NAT) */
+int32 rtl865x_isEthArp(ipaddr_t ip);
+#endif
+#endif
diff --git a/include/net/rtl/rtl865x_fdb_api.h b/include/net/rtl/rtl865x_fdb_api.h
new file mode 100644
index 00000000..1a07027
--- /dev/null
+++ b/include/net/rtl/rtl865x_fdb_api.h
@@ -0,0 +1,120 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+
+#ifndef RTL865X_FDB_API_H
+#define RTL865X_FDB_API_H
+
+#define RTL_LAN_FID			0
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define RTL_WAN_FID			1
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTL_IVL_SUPPORT)
+#define RTL_WAN_FID			1
+#else
+#define RTL_WAN_FID			0
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#define FDB_STATIC			0x01	/* flag for FDB: process static entry only */
+#define FDB_DYNAMIC			0x02	/* flag for FDB: process dynamic entry only */
+
+#define RTL865x_FDB_NUMBER		4
+#define RTL865x_L2_TYPEI		0x0001	/* Referenced by ARP/PPPoE */
+#define RTL865x_L2_TYPEII		0x0002	/* Referenced by Protocol */
+#define RTL865x_L2_TYPEIII		0x0004	/* Referenced by PCI/Extension Port */
+#define CONFIG_RTL865X_SYNC_L2		1
+#define RTL865X_FDBENTRY_TIMEOUT	0x1001	/*fdb entry time out */
+#define RTL865X_FDBENTRY_450SEC		0x1002	/*fdb entry 450s timing */
+#define RTL865X_FDBENTRY_300SEC		0x1004	/*fdb entry 300s timing */
+#define RTL865X_FDBENTRY_150SEC		0x1008	/*fdb entry 150s timing */
+
+/*#define ETHER_ADDR_LEN				6
+typedef struct ether_addr_s {
+	uint8 octet[ETHER_ADDR_LEN];
+} ether_addr_t;*/
+/*
+typedef struct rtl865x_tblAsicDrv_l2Param_s {
+	ether_addr_t	macAddr;
+	uint32 		memberPortMask; //extension ports [rtl8651_totalExtPortNum-1:0] are located at bits [RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum-1:RTL8651_PORT_NUMBER]
+	uint32 		ageSec;
+	uint32	 	cpu:1,
+				srcBlk:1,
+				isStatic:1,
+				nhFlag:1,
+				fid:2,
+				auth:1;
+
+} rtl865x_tblAsicDrv_l2Param_t;*/
+
+/* extern typedef struct rtl865x_tblAsicDrv_l2Param_s    rtl865x_tblAsicDrv_l2Param_t; */
+
+void update_hw_l2table(const char *srcName, const unsigned char *addr);
+int32 rtl_get_hw_fdb_age(uint32 fid, ether_addr_t *mac, uint32 flags);
+int32 rtl865x_addAuthFDBEntry(const unsigned char *addr, int32 auth, int32 port,
+	int32 srcblk);
+int32 rtl865x_setRestrictPortNum(int32 port, uint8 isEnable, int32 number);
+int32 rtl865x_check_authfdbentry_Byport(int32 port_num,
+	const unsigned char *macAddr);
+int32 rtl865x_enableLanPortNumRestrict(uint8 isEnable);
+int32 rtl865x_delAuthLanFDBEntry(uint16 l2Type, const unsigned char *addr);
+int32 rtl865x_delLanFDBEntry(uint16 l2Type, const unsigned char *addr);
+
+int32 rtl865x_arrangeFdbEntry(const unsigned char *timeout_addr, int32 *port);
+
+/* extern int32 rtl865x_Lookup_fdb_entry(uint32 fid, ether_addr_t *mac, uint32 flags, uint32 *col_num, rtl865x_tblAsicDrv_l2Param_t *L2buff); */
+
+int32 rtl865x_getPortNum(const unsigned char *addr);
+int32 rtl865x_ConvertPortMasktoPortNum(int32 portmask);
+int32 rtl865x_addFDBEntry(const unsigned char *addr);
+int32 rtl865x_isEthMac(void *mac);
+
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+int32 rtl865x_addExtFDBEntry(const unsigned char *addr, int extPort);
+int32 rtl865x_delExtFDBEntry(void);
+
+#endif
+
+#if defined(CONFIG_RTL865X_LANPORT_RESTRICTION)
+#define	LAN_RESTRICT_PORT_NUMBER		9
+#define RTL_LAN_RESTRICT_STAT2	2
+#define RTL_LAN_RESTRICT_STAT1	1
+#define RTL_LAN_RESTRICT_STAT0	0
+
+typedef struct _lan_restrict_info {
+	int16 port_num;
+	int16 enable;
+	int32 max_num;
+	int32 curr_num;
+} lan_restrict_info;
+
+extern lan_restrict_info lan_restrict_tbl[LAN_RESTRICT_PORT_NUMBER];
+
+/* int32 rtl865x_addAuthFDBEntry_hooks(struct net_bridge_fdb_entry *fdb,const unsigned char *addr); */
+
+int32 lan_restrict_getBlockAddr(int32 port, const unsigned char *swap_addr);
+int32 lan_restrict_CheckStatusByport(int32 port);
+
+int32 rtl_check_fdb_entry_check_exist(uint32 fid, ether_addr_t *mac,
+	uint32 flags);
+int32 rtl_check_fdb_entry_check_srcBlock(uint32 fid, ether_addr_t *mac,
+	int32 *SrcBlk);
+int32 lanrestrict_callbackFn_for_add_fdb(void *param);
+int32 lanrestrict_callbackFn_for_del_fdb(void *param);
+int32 lanrestrict_unRegister_event(void);
+int32 lanrestrict_register_event(void);
+#endif /*      defined(CONFIG_RTL865X_LANPORT_RESTRICTION)     */
+
+#if defined(CONFIG_RTL_HARDWARE_NAT)	/* && defined(REINIT_SWITCH_CORE) */
+void rtl819x_init_l2_bakup_entry(void);
+int32 rtl819x_save_inused_l2_entry(ipaddr_t ip, ether_addr_t *mac, uint32 fid);
+int rtl819x_restore_hw_l2_table(void);
+#endif
+
+#endif
diff --git a/include/net/rtl/rtl865x_igmpsnooping.h b/include/net/rtl/rtl865x_igmpsnooping.h
new file mode 100644
index 00000000..69939be
--- /dev/null
+++ b/include/net/rtl/rtl865x_igmpsnooping.h
@@ -0,0 +1,191 @@
+/*
+* Copyright c                  Realsil Semiconductor Corporation, 2006
+* All rights reserved.
+*
+* Program :  igmp snooping function
+* Abstract :
+* Author :qinjunjie
+* Email:qinjunjie1980@hotmail.com
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+*/
+
+#ifndef RTL865X_IGMP_SNOOPING_H
+#define RTL865X_IGMP_SNOOPING_H
+
+/* multicast configuration*/
+struct rtl_mCastSnoopingGlobalConfig {
+	uint32 maxGroupNum;
+	uint32 maxClientNum;
+	uint32 maxSourceNum;
+	uint32 hashTableSize;
+
+	uint32 groupMemberAgingTime;
+	uint32 lastMemberAgingTime;
+	uint32 querierPresentInterval;
+
+	uint32 dvmrpRouterAgingTime;
+	uint32 mospfRouterAgingTime;
+	uint32 pimRouterAgingTime;
+};
+
+struct rtl_mCastSnoopingLocalConfig {
+	uint8 enableSourceList;
+	uint8 enableFastLeave;
+	uint8 gatewayMac[6];
+	uint32 gatewayIpv4Addr;
+	uint32 gatewayIpv6Addr[4];
+	/* uint32 unknownMcastFloodMap; */
+	uint32 ipv4UnknownMcastFloodMap;
+	uint32 ipv6UnknownMcastFloodMap;
+	uint32 staticRouterPortMask;
+};
+
+struct rtl_mCastTimerParameters {
+	uint32 disableExpire;
+	uint32 groupMemberAgingTime;
+	uint32 lastMemberAgingTime;
+	uint32 querierPresentInterval;
+
+	uint32 dvmrpRouterAgingTime;	/*DVMRP multicast router aging time */
+	uint32 mospfRouterAgingTime;	/*MOSPF multicast router aging time */
+	uint32 pimRouterAgingTime;	/*PIM-DM multicast router aging time */
+
+};
+
+#define IP_VERSION4 4
+#define IP_VERSION6 6
+
+struct rtl_multicastDataInfo {
+	uint32 ipVersion;
+	uint32 sourceIp[4];
+	uint32 groupAddr[4];
+
+};
+
+struct rtl_multicastFwdInfo {
+	uint8 unknownMCast;
+	uint8 reservedMCast;
+	uint16 cpuFlag;
+	uint32 fwdPortMask;
+
+};
+
+struct rtl_groupInfo {
+	uint32 ownerMask;
+};
+
+typedef struct rtl_multicastDeviceInfo_s {
+	char devName[32];
+	uint32 vlanId;
+	uint32 portMask;
+	uint32 swPortMask;
+} rtl_multicastDeviceInfo_t;
+
+typedef struct rtl_multicastEventContext_s {
+	char devName[16];
+	uint32 moduleIndex;
+	uint32 ipVersion;
+	uint32 groupAddr[4];
+	uint32 sourceAddr[4];
+	uint32 portMask;
+} rtl_multicastEventContext_t;
+
+typedef struct rtl_igmpPortInfo_s {
+	uint32 linkPortMask;
+} rtl_igmpPortInfo_t;
+
+#define DEL_RESERVED_MULTICAST_FLAG	0
+#define ADD_RESERVED_MULTICAST_FLAG	1
+#define MAX_RESERVED_MULTICAST_NUM	16
+#if defined(CONFIG_RT_MULTIPLE_BR_SUPPORT)
+#define RTL_IMGP_MAX_BRMODULE		8
+#endif
+struct rtl865x_ReservedMCastRecord {
+	unsigned int groupAddr;
+	unsigned int valid;
+};
+
+int rtl_add_ReservedMCastAddr(uint32 groupAddr, int flag);
+int rtl_check_ReservedMCastAddr(uint32 groupAddr);
+
+/******************************************************
+	Function called in the system initialization
+******************************************************/
+
+int32 rtl_initMulticastSnooping(struct rtl_mCastSnoopingGlobalConfig
+	mCastSnoopingGlobalConfig);
+int32 rtl_exitMulticastSnooping(void);
+void rtl_setMulticastParameters(struct rtl_mCastTimerParameters
+	mCastTimerParameters);
+
+int32 rtl_registerIgmpSnoopingModule(uint32 *moduleIndex);
+
+int32 rtl_setIgmpSnoopingModuleDevInfo(uint32 moduleIndex,
+	rtl_multicastDeviceInfo_t *devInfo);
+int32 rtl_getIgmpSnoopingModuleDevInfo(uint32 moduleIndex,
+	rtl_multicastDeviceInfo_t *devInfo);
+
+int32 rtl_getDeviceIgmpSnoopingModuleIndex(rtl_multicastDeviceInfo_t *devInfo,
+	uint32 *moduleIndex);
+
+int32 rtl_unregisterIgmpSnoopingModule(uint32 moduleIndex);
+
+int32 rtl_configIgmpSnoopingModule(uint32 moduleIndex,
+	struct rtl_mCastSnoopingLocalConfig *multicastSnoopingConfig);
+
+int32 rtl_igmpMldProcess(uint32 moduleIndex, uint8 *macFrame, uint32 portNum,
+	uint32 *fwdPortMask);
+
+int32 rtl_getMulticastDataFwdInfo(uint32 moduleIndex,
+	struct rtl_multicastDataInfo *multicastDataInfo,
+	struct rtl_multicastFwdInfo *multicastFwdInfo);
+
+int32 rtl_maintainMulticastSnoopingTimerList(uint32 currentSystemTime);
+int32 rtl_getGroupNum(uint32 ipVersion);
+
+#ifdef CONFIG_PROC_FS
+int igmp_show(struct seq_file *s, void *v);
+ssize_t igmp_write(struct file *file, const char __user *buffer, size_t count,
+	loff_t *data);
+#endif
+
+int32 rtl_getGroupInfo(uint32 groupAddr, struct rtl_groupInfo *groupInfo);
+
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+int32 rtl_getGroupInfov6(uint32 *groupAddr, struct rtl_groupInfo *groupInfo);
+#endif
+int32 rtl_flushAllIgmpRecord(uint8 flush_flag);
+int32 rtl_delIgmpRecordByMacAddr(uint8 *macAddr);
+
+int32 rtl_addSpecialMCast(uint32 moduleIndex, uint32 ipVersion,
+	uint32 *groupAddr, uint32 fwdPortMask);
+int32 rtl_delSpecialMCast(uint32 moduleIndex, uint32 ipVersion,
+	uint32 *groupAddr);
+
+int32 rtl_setIpv4UnknownMCastFloodMap(uint32 moduleIndex,
+	uint32 unknownMCastFloodMap);
+int32 rtl_getIpv4UnknownMCastFloodMap(uint32 moduleIndex,
+	uint32 *unknownMCastFloodMap);
+int32 rtl_setIpv6UnknownMCastFloodMap(uint32 moduleIndex,
+	uint32 unknownMCastFloodMap);
+int32 rtl_getIpv6UnknownMCastFloodMap(uint32 moduleIndex,
+	uint32 *unknownMCastFloodMap);
+#define	Any_0_hop_protocl		114
+#ifndef M2U_DELETE_CHECK
+#define M2U_DELETE_CHECK
+#endif
+
+#define FLUSH_IGMP_RECORD 0x01
+#ifdef CONFIG_RTL_MLD_SNOOPING
+#define FLUSH_MLD_RECORD  0x10
+#endif
+
+#if 0				/* !defined(IMPROVE_MCAST_PERFORMANCE_WITH_RTL8367) && defined(CONFIG_RTL_IGMP_SNOOPING) && defined(CONFIG_RTL_8367R_SUPPORT) */
+#define IMPROVE_MCAST_PERFORMANCE_WITH_RTL8367
+#endif
+#endif
diff --git a/include/net/rtl/rtl865x_igmpsnooping_glue.h b/include/net/rtl/rtl865x_igmpsnooping_glue.h
new file mode 100644
index 00000000..e316246
--- /dev/null
+++ b/include/net/rtl/rtl865x_igmpsnooping_glue.h
@@ -0,0 +1,160 @@
+/*
+* Copyright c                  Realsil Semiconductor Corporation, 2006
+* All rights reserved.
+*
+* Program :  IGMP glue file
+* Abstract :
+* Author :qinjunjie
+* Email:qinjunjie1980@hotmail.com
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+*/
+
+#ifndef NULL
+#define NULL 0
+#endif
+
+#ifndef TRUE
+#define TRUE 1
+#endif
+
+#ifndef FALSE
+#define FALSE 0
+#endif
+
+#ifndef SUCCESS
+#define SUCCESS 	0
+#endif
+
+#ifndef FAILED
+#define FAILED -1
+#endif
+
+#if 0
+#ifndef _RTL_TYPES_H
+typedef unsigned int uint32;
+typedef int int32;
+typedef unsigned short uint16;
+typedef short int16;
+typedef unsigned char uint8;
+typedef char int8;
+#endif
+#else
+#include "rtl_types.h"
+#endif
+
+#ifndef RTL_MULTICAST_SNOOPING_GLUE
+#define RTL_MULTICAST_SNOOPING_GLUE
+
+#define swapl32(x)\
+	((((x) & 0xff000000U) >> 24) | \
+	(((x) & 0x00ff0000U) >>  8) | \
+	(((x) & 0x0000ff00U) <<  8) | \
+	(((x) & 0x000000ffU) << 24))
+#define swaps16(x)        \
+	((((x) & 0xff00) >> 8) | \
+	(((x) & 0x00ff) << 8))
+
+#ifdef _LITTLE_ENDIAN
+
+#ifndef ntohs
+#define ntohs(x)   (swaps16(x))
+#endif
+
+#ifndef ntohl
+#define ntohl(x)   (swapl32(x))
+#endif
+
+#ifndef htons
+#define htons(x)   (swaps16(x))
+#endif
+
+#ifndef htonl
+#define htonl(x)   (swapl32(x))
+#endif
+
+#else
+
+#ifndef ntohs
+#define ntohs(x)	(x)
+#endif
+
+#ifndef ntohl
+#define ntohl(x)	(x)
+#endif
+
+#ifndef htons
+#define htons(x)	(x)
+#endif
+
+#ifndef htonl
+#define htonl(x)	(x)
+#endif
+
+#endif
+
+#ifdef __KERNEL__
+#define rtl_gluePrintf printk
+#else
+#define rtl_gluePrintf printf
+#endif
+
+void *rtl_glueMalloc(uint32 NBYTES);
+void rtl_glueFree(void *memblock);
+
+void rtl_glueMutexLock(void);
+void rtl_glueMutexUnlock(void);
+
+
+#ifdef CONFIG_SMP
+#include <linux/spinlock.h>
+extern int lock_owner_igmp;
+extern spinlock_t lock_igmp;
+extern int lock_owner_igmp_concurrent;
+extern spinlock_t lock_igmp_concurrent;
+
+#ifdef CONFIG_PREEMPT
+#define SMP_LOCK_IGMP(__x__)    \
+	do { \
+		get_cpu(); \
+		if (lock_owner_igmp != smp_processor_id()) { \
+			lock_owner_igmp = smp_processor_id(); \
+			put_cpu(); \
+			spin_lock_irqsave(&lock_igmp, (__x__)); \
+		} else {\
+			lock_owner_igmp = smp_processor_id();\
+			put_cpu(); \
+			rtlglue_printf("[%s %s %d] recursion detection in IGMP\n", __FILE__, __FUNCTION__, __LINE__); \
+		} \
+	} while (0)
+#else
+#define SMP_LOCK_IGMP(__x__)	\
+	do { \
+		if (lock_owner_igmp != smp_processor_id()) \
+			spin_lock_irqsave(&lock_igmp, (__x__)); \
+		else \
+			rtlglue_printf("[%s %s %d] recursion detection in IGMP\n", __FILE__, __FUNCTION__, __LINE__); \
+		lock_owner_igmp = smp_processor_id();\
+	} while (0)
+#endif
+
+#define SMP_UNLOCK_IGMP(__x__) \
+	do { \
+		lock_owner_igmp = -1; \
+		spin_unlock_irqrestore(&lock_igmp, (__x__)); \
+	} while (0)
+
+#define SMP_LOCK_IGMP_CONCURRENT(__x__)			spin_lock_irqsave(&lock_igmp_concurrent, (__x__))
+#define SMP_UNLOCK_IGMP_CONCURRENT(__x__) 		spin_unlock_irqrestore(&lock_igmp_concurrent, (__x__))
+
+#else
+#define SMP_LOCK_IGMP(__x__)
+#define SMP_UNLOCK_IGMP(__x__)
+#endif
+
+#endif
+
diff --git a/include/net/rtl/rtl865x_ip_api.h b/include/net/rtl/rtl865x_ip_api.h
new file mode 100644
index 00000000..018a1f5
--- /dev/null
+++ b/include/net/rtl/rtl865x_ip_api.h
@@ -0,0 +1,20 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL865X_IP_API_H
+#define RTL865X_IP_API_H
+
+#define IP_TYPE_NAPT            0x00
+#define IP_TYPE_NAT             0x01
+#define IP_TYPE_LOCALSERVER     0x02
+#define IP_TYPE_RESERVED        0x03
+
+int32 rtl865x_addIp(ipaddr_t intIp, ipaddr_t extIp, uint32 ip_type);
+int32 rtl865x_delIp(ipaddr_t extIp);
+#endif
diff --git a/include/net/rtl/rtl865x_localPublic.h b/include/net/rtl/rtl865x_localPublic.h
new file mode 100644
index 00000000..87a21ec
--- /dev/null
+++ b/include/net/rtl/rtl865x_localPublic.h
@@ -0,0 +1,126 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL865X_LOCAL_PUBLIC_H
+#define RTL865X_LOCAL_PUBLIC_H
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+#include <common/rtl865x_netif.h>
+#endif
+
+#define FROM_LOCAL_PUBLIC	1
+#define TO_LOCAL_PUBLIC		2
+#define RX_LAN_PACKET	1
+#define RX_WAN_PACKET	2
+#define TX_LAN_PACKET	3
+#define TX_WAN_PACKET	4
+
+#define MAX_HW_LOCAL_PUBLIC_NUM 2
+#define DEF_LOCAL_PUBLIC_NUM	32
+#define MAX_LOCAL_PUBLIC_NUM	32
+
+#define LOCAL_PUBLIC_VLAN_START 	3198
+#define LOCAL_PUBLIC_VLAN_END		4094
+#define MCAST_NETIF_VLAN_ID		3197
+
+struct rtl865x_localPublic
+{
+	unsigned int ipAddr;
+	unsigned int netMask;
+	unsigned int defGateway;
+	unsigned int hw;
+	unsigned int inAsic;
+
+	unsigned char port;
+	unsigned char mac[6];
+	unsigned char dev[16];
+
+	unsigned char lpNetif[16];
+	unsigned int lpVid;
+	unsigned char defGwMac[6];
+
+	//must at the tail...
+	struct
+	{
+		struct rtl865x_localPublic *tqe_next;
+		struct rtl865x_localPublic**tqe_prev;
+	}next;
+
+};
+
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+struct rtl865x_public_ssid_entry
+{
+	struct list_head list;
+	unsigned int public_addr;
+	unsigned int flags;
+};
+#endif
+
+struct rtl865x_pktInfo
+{
+	/*input parameter*/
+	unsigned char *data;
+	unsigned char port;
+	unsigned char action;
+	unsigned char dev[16];
+
+	/*output parameter*/
+	unsigned char *arpHdr;
+	unsigned char *ipHdr;
+	unsigned char fromLocalPublic;
+	unsigned char toLocalPublic;
+	unsigned int srcIp;
+	unsigned int dstIp;
+};
+
+struct rtl865x_localPublicPara
+{
+	unsigned int maxEntryNum;
+};
+
+struct rtl865x_interface_info
+{
+	unsigned char 			ifname[16];
+	unsigned char 			isWan;
+	unsigned short			if_type;
+	unsigned short			vid;
+	unsigned short			fid;
+	unsigned int				memPort;
+	unsigned int				untagSet;
+	unsigned int				mtu;
+};
+
+int rtl865x_initLocalPublic(struct rtl865x_localPublicPara* para);
+
+int rtl865x_reInitLocalPublic(void);
+
+int rtl865x_addLocalPublic(struct rtl865x_localPublic* newEntry);
+
+int rtl865x_delLocalPublic(struct rtl865x_localPublic* delEntry);
+
+int rtl865x_checkLocalPublic(struct rtl865x_pktInfo *pktInfo);
+
+int rtl865x_isLocalPublicIp(unsigned int ipAddr);
+
+int rtl865x_getLocalPublicInfo(unsigned int ipAddr, struct rtl865x_localPublic  *localPublicInfo);
+
+int rtl865x_localPublicEnabled(void);
+int rtl865x_getLocalPublicMac(unsigned int ip, unsigned char mac[]);
+int rtl865x_getAllLocalPublic(struct rtl865x_localPublic localPublicArray[], int arraySize);
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)
+int rtl_checkLocalPublicNetifIngressRule(rtl865x_AclRule_t *rule);
+#endif
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+int rtl865x_is_public_ssid_entry(unsigned int ipAddr);
+int rtl865x_from_public_ssid_device(unsigned char *name);
+#endif
+
+int rtl865x_setMCastSrcMac(unsigned char *srcMac);
+#endif
diff --git a/include/net/rtl/rtl865x_multicast.h b/include/net/rtl/rtl865x_multicast.h
new file mode 100644
index 00000000..582a76d
--- /dev/null
+++ b/include/net/rtl/rtl865x_multicast.h
@@ -0,0 +1,497 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef RTL865X_MULTICAST_H
+#define RTL865X_MULTICAST_H
+
+#define RTL865X_NETWORK_INTERFACE_DATA_STRUCTURE
+
+#define RTL865X_MULTICAST_TABLE_AGE				35
+#define RTL865X_MULTICAST_TABLE_ASIC_FULL_AGE	35
+#define RTL865X_MULTICAST_TABLE_ASIC_AGE			10	/* we would always write this value into ASIC */
+#define RTL865X_MULTICAST_SWAP_THRESHOLD		400
+#define SINGLE_BITMASK_ISSET(x) ((x & (x - 1)) == 0)	/* chenyl: only 1 bit is set in vlanMask */
+
+#define RTL865X_HW_MCAST_SWAP_GAP  300
+
+/*================================================
+  * Multicast Data Structure
+  *================================================*/
+#define TBLDRV_MULTICAST_DATA_STRUCTURE
+
+/* mcast entry flag */
+#define 	RTL865X_MULTICAST_PPPOEPATCH_CPUBIT		0x01
+#define 	RTL865X_MULTICAST_EXTIP_SET				0x02
+#define 	RTL865X_MULTICAST_UPLOADONLY				0x04
+
+//#define 	MAX_MCAST_FWD_DESCRIPTOR_CNT			256
+#define 	MAX_MCAST_FWD_DESCRIPTOR_CNT			(RTL8651_MULTICASTTBL_SIZE<<2)
+//#define	    MAX_MCAST_TABLE_ENTRY_CNT				128
+#define	    MAX_MCAST_TABLE_ENTRY_CNT			(RTL8651_MULTICASTTBL_SIZE<<1)
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+//#define 	MAX_MCASTV6_FWD_DESCRIPTOR_CNT			256
+//#define     MAX_MCASTV6_TABLE_ENTRY_CNT				256
+#define 	MAX_MCASTV6_FWD_DESCRIPTOR_CNT			(RTL8651_MULTICASTTBL_SIZE<<2)
+#define     MAX_MCASTV6_TABLE_ENTRY_CNT				(RTL8651_MULTICASTTBL_SIZE<<1)
+#endif
+
+/*
+ * List definitions.
+ */
+#define MC_LIST_HEAD(name, type)						\
+struct name {								\
+	struct type *lh_first;	/* first element */			\
+}
+
+#define MC_LIST_HEAD_INITIALIZER(head)					\
+	{ NULL }
+
+#define MC_LIST_ENTRY(type)						\
+struct {								\
+	struct type *le_next;	/* next element */			\
+	struct type **le_prev;	/* address of previous next element */	\
+}
+
+/*
+ * List functions.
+ */
+
+#define MC_LIST_EMPTY(head) ((head)->lh_first == NULL)
+
+#define MC_LIST_FIRST(head)	((head)->lh_first)
+
+#define MC_LIST_FOREACH(var, head, field)					\
+	for((var) = (head)->lh_first; (var); (var) = (var)->field.le_next)
+
+#define MC_LIST_INIT(head) do {						\
+	(head)->lh_first = NULL;					\
+} while (0)
+
+#define MC_LIST_INSERT_AFTER(listelm, elm, field) do {			\
+	if (((elm)->field.le_next = (listelm)->field.le_next) != NULL)	\
+		(listelm)->field.le_next->field.le_prev =		\
+		    &(elm)->field.le_next;				\
+	(listelm)->field.le_next = (elm);				\
+	(elm)->field.le_prev = &(listelm)->field.le_next;		\
+} while (0)
+
+#define MC_LIST_INSERT_BEFORE(listelm, elm, field) do {			\
+	(elm)->field.le_prev = (listelm)->field.le_prev;		\
+	(elm)->field.le_next = (listelm);				\
+	*(listelm)->field.le_prev = (elm);				\
+	(listelm)->field.le_prev = &(elm)->field.le_next;		\
+} while (0)
+
+#define MC_LIST_INSERT_HEAD(head, elm, field) do {				\
+	if (((elm)->field.le_next = (head)->lh_first) != NULL)		\
+		(head)->lh_first->field.le_prev = &(elm)->field.le_next;\
+	(head)->lh_first = (elm);					\
+	(elm)->field.le_prev = &(head)->lh_first;			\
+} while (0)
+
+#define MC_LIST_NEXT(elm, field)	((elm)->field.le_next)
+
+#define MC_LIST_REMOVE(elm, field) do {					\
+	if ((elm)->field.le_next != NULL)				\
+		(elm)->field.le_next->field.le_prev = 			\
+		    (elm)->field.le_prev;				\
+	if ((elm)->field.le_prev != NULL)	\
+		*(elm)->field.le_prev = (elm)->field.le_next;			\
+} while (0)
+
+
+
+
+/*
+ * Counting Tail queue definitions.
+ */
+#define CTAILQ_HEAD(name, type)						\
+struct name {\
+	struct type *tqh_first;	/* first element */			\
+	struct type **tqh_last;	/* addr of last next element */		\
+	int tqh_count;\
+}
+
+#define CTAILQ_HEAD_INITIALIZER(head)					\
+	{ 0, NULL, &(head).tqh_first }
+
+#define CTAILQ_ENTRY(type)						\
+struct {								\
+	struct type *tqe_next;	/* next element */			\
+	struct type **tqe_prev;	/* address of previous next element */	\
+}
+
+/*
+ * Counting Tail queue functions.
+ */
+#define	CTAILQ_EMPTY(head) ((head)->tqh_first == NULL)
+
+#define CTAILQ_FOREACH(var, head, field)					\
+	for (var = TAILQ_FIRST(head); var; var = TAILQ_NEXT(var, field))
+
+#define CTAILQ_FOREACH_REVERSE(var, head, headname, field)		\
+	for ((var) = TAILQ_LAST((head), headname);			\
+	     (var);							\
+	     (var) = TAILQ_PREV((var), headname, field))
+
+#define	CTAILQ_FIRST(head) ((head)->tqh_first)
+#define	CTAILQ_TOTAL(head) ((head)->tqh_count)
+#define	CTAILQ_LAST(head, headname) \
+	(*(((struct headname *)((head)->tqh_last))->tqh_last))
+
+#define	CTAILQ_NEXT(elm, field) ((elm)->field.tqe_next)
+
+#define CTAILQ_PREV(elm, headname, field) \
+	(*(((struct headname *)((elm)->field.tqe_prev))->tqh_last))
+
+#define	CTAILQ_INIT(head) do {						\
+	(head)->tqh_count=0;\
+	(head)->tqh_first = NULL;					\
+	(head)->tqh_last = &(head)->tqh_first;				\
+} while (0)
+
+#define CTAILQ_INSERT_HEAD(head, elm, field) do {			\
+	if (((elm)->field.tqe_next = (head)->tqh_first) != NULL)	\
+		(head)->tqh_first->field.tqe_prev =			\
+		    &(elm)->field.tqe_next;				\
+	else								\
+		(head)->tqh_last = &(elm)->field.tqe_next;		\
+	(head)->tqh_first = (elm);					\
+	(elm)->field.tqe_prev = &(head)->tqh_first;			\
+	(head)->tqh_count++;\
+} while (0)
+
+#define CTAILQ_INSERT_TAIL(head, elm, field) do {			\
+	(elm)->field.tqe_next = NULL;					\
+	(elm)->field.tqe_prev = (head)->tqh_last;			\
+	*(head)->tqh_last = (elm);					\
+	(head)->tqh_last = &(elm)->field.tqe_next;			\
+	(head)->tqh_count++;\
+} while (0)
+
+#define CTAILQ_INSERT_AFTER(head, listelm, elm, field) do {		\
+	if (((elm)->field.tqe_next = (listelm)->field.tqe_next) != NULL)\
+		(elm)->field.tqe_next->field.tqe_prev = 		\
+		    &(elm)->field.tqe_next;				\
+	else								\
+		(head)->tqh_last = &(elm)->field.tqe_next;		\
+	(listelm)->field.tqe_next = (elm);				\
+	(elm)->field.tqe_prev = &(listelm)->field.tqe_next;		\
+	(head)->tqh_count++;	\
+} while (0)
+
+#define CTAILQ_INSERT_BEFORE(head, listelm, elm, field) do {			\
+	(elm)->field.tqe_prev = (listelm)->field.tqe_prev;		\
+	(elm)->field.tqe_next = (listelm);				\
+	*(listelm)->field.tqe_prev = (elm);				\
+	(listelm)->field.tqe_prev = &(elm)->field.tqe_next;		\
+	(head)->tqh_count++;\
+} while (0)
+
+#define CTAILQ_REMOVE(head, elm, field) do {				\
+	if (((elm)->field.tqe_next) != NULL)				\
+		(elm)->field.tqe_next->field.tqe_prev = 		\
+		    (elm)->field.tqe_prev;				\
+	else								\
+		(head)->tqh_last = (elm)->field.tqe_prev;		\
+	*(elm)->field.tqe_prev = (elm)->field.tqe_next;			\
+	(head)->tqh_count--;\
+} while (0)
+
+#define ETHERNET_DEVICE_TYPE 0
+#define WIRELESS_DEVICE_TYPE 1
+#define VIRTUAL_DEVICE_TYPE  2
+typedef struct rtl865x_mcast_fwd_descriptor_s{
+	char netifName[16];
+	unsigned int descPortMask;
+	char toCpu;
+	unsigned int vid;
+	unsigned int fwdPortMask;
+#if defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+	unsigned int dip;
+#endif
+	MC_LIST_ENTRY(rtl865x_mcast_fwd_descriptor_s)	next;
+
+}rtl865x_mcast_fwd_descriptor_t;
+
+typedef MC_LIST_HEAD(mcast_fwd_descriptor_head_s, rtl865x_mcast_fwd_descriptor_s)  mcast_fwd_descriptor_head_t;
+
+/*
+ * Tail queue definitions.
+ */
+#define TAILQ_HEAD(name, type)						\
+struct name {								\
+	struct type *tqh_first;	/* first element */			\
+	struct type **tqh_last;	/* addr of last next element */		\
+}
+
+#define TAILQ_HEAD_INITIALIZER(head)					\
+	{ NULL, &(head).tqh_first }
+
+#define TAILQ_ENTRY(type)						\
+struct {								\
+	struct type *tqe_next;	/* next element */			\
+	struct type **tqe_prev;	/* address of previous next element */	\
+}
+
+/*
+ * Tail queue functions.
+ */
+#define	TAILQ_EMPTY(head) ((head)->tqh_first == NULL)
+
+#define TAILQ_FOREACH(var, head, field)					\
+	for (var = TAILQ_FIRST(head); var; var = TAILQ_NEXT(var, field))
+
+#define TAILQ_FOREACH_REVERSE(var, head, headname, field)		\
+	for ((var) = TAILQ_LAST((head), headname);			\
+	     (var);							\
+	     (var) = TAILQ_PREV((var), headname, field))
+
+#define	TAILQ_FIRST(head) ((head)->tqh_first)
+
+#define	TAILQ_LAST(head, headname) \
+	(*(((struct headname *)((head)->tqh_last))->tqh_last))
+
+#define	TAILQ_NEXT(elm, field) ((elm)->field.tqe_next)
+
+#define TAILQ_PREV(elm, headname, field) \
+	(*(((struct headname *)((elm)->field.tqe_prev))->tqh_last))
+
+#define	TAILQ_INIT(head) do {						\
+	(head)->tqh_first = NULL;					\
+	(head)->tqh_last = &(head)->tqh_first;				\
+} while (0)
+
+#define TAILQ_INSERT_HEAD(head, elm, field) do {			\
+	if (((elm)->field.tqe_next = (head)->tqh_first) != NULL)	\
+		(head)->tqh_first->field.tqe_prev =			\
+		    &(elm)->field.tqe_next;				\
+	else								\
+		(head)->tqh_last = &(elm)->field.tqe_next;		\
+	(head)->tqh_first = (elm);					\
+	(elm)->field.tqe_prev = &(head)->tqh_first;			\
+} while (0)
+
+#define TAILQ_INSERT_TAIL(head, elm, field) do {			\
+	(elm)->field.tqe_next = NULL;					\
+	(elm)->field.tqe_prev = (head)->tqh_last;			\
+	*(head)->tqh_last = (elm);					\
+	(head)->tqh_last = &(elm)->field.tqe_next;			\
+} while (0)
+
+#define TAILQ_INSERT_AFTER(head, listelm, elm, field) do {		\
+	if (((elm)->field.tqe_next = (listelm)->field.tqe_next) != NULL)\
+		(elm)->field.tqe_next->field.tqe_prev = 		\
+		    &(elm)->field.tqe_next;				\
+	else								\
+		(head)->tqh_last = &(elm)->field.tqe_next;		\
+	(listelm)->field.tqe_next = (elm);				\
+	(elm)->field.tqe_prev = &(listelm)->field.tqe_next;		\
+} while (0)
+
+#define TAILQ_INSERT_BEFORE(listelm, elm, field) do {			\
+	(elm)->field.tqe_prev = (listelm)->field.tqe_prev;		\
+	(elm)->field.tqe_next = (listelm);				\
+	*(listelm)->field.tqe_prev = (elm);				\
+	(listelm)->field.tqe_prev = &(elm)->field.tqe_next;		\
+} while (0)
+
+#define TAILQ_REMOVE(head, elm, field) do {				\
+	if (((elm)->field.tqe_next) != NULL)				\
+		(elm)->field.tqe_next->field.tqe_prev = 		\
+		    (elm)->field.tqe_prev;				\
+	else								\
+		(head)->tqh_last = (elm)->field.tqe_prev;		\
+	*(elm)->field.tqe_prev = (elm)->field.tqe_next;			\
+} while (0)
+#ifdef CONFIG_RTL_IGMP_PROXY_MULTIWAN
+#define ALL_LAN_PORT 0xFFFFFFFF
+#endif
+typedef struct rtl865x_tblDrv_mCast_s {
+	unsigned int	sip;
+	unsigned int	dip;
+	unsigned short	svid;
+	unsigned short 	port;
+	unsigned int	mbr;
+	unsigned short	age;
+	unsigned short	cpu;
+	unsigned int extIp;
+	/*above field is for asic table usage*/
+	mcast_fwd_descriptor_head_t fwdDescChain;
+	unsigned int	count;
+	//unsigned int	maxPPS;
+	unsigned char	cpuHold;
+	unsigned char	flag;
+	unsigned char	inAsic;
+	unsigned char	unKnownMCast;
+#if  defined(CONFIG_RTL8196C_REVISION_B) || defined (CONFIG_RTL8198_REVISION_B) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	unsigned short liveTime;
+#endif
+//#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	unsigned int hashIndex;
+//#endif
+#if defined(CONFIG_RTL_MULTICAST_PORT_MAPPING)
+	unsigned int mapPortMbr;
+#endif
+	TAILQ_ENTRY(rtl865x_tblDrv_mCast_s) nextMCast;
+
+} rtl865x_tblDrv_mCast_t;
+TAILQ_HEAD(MCast_hash_head, rtl865x_tblDrv_mCast_s);
+struct rtl865x_multicastTable{
+
+	struct freeList_s {
+
+		TAILQ_HEAD( _FreeMultiCastEntry, rtl865x_tblDrv_mCast_s) freeMultiCast;
+	} freeList;
+
+	struct inuseList_s {
+		TAILQ_HEAD( _InuseMCast, rtl865x_tblDrv_mCast_s) *mCastTbl;
+	}inuseList;
+
+};
+
+typedef struct rtl865x_mCastConfig_s{
+	unsigned int externalPortMask;
+
+}rtl865x_mCastConfig_t;
+
+int rtl865x_initMulticast(rtl865x_mCastConfig_t * mCastConfig);
+int rtl865x_reinitMulticast(void);
+
+int rtl865x_addMulticastExternalPort(unsigned int extPort);
+int rtl865x_delMulticastExternalPort(unsigned int extPort);
+
+int rtl865x_setMulticastExternalPortMask(unsigned int extPortMask);
+int rtl865x_getMulticastExternalPortMask(void);
+
+int rtl865x_addMulticastExternalPortMask(unsigned int extPortMask);
+int rtl865x_delMulticastExternalPortMask(unsigned int extPortMask);
+
+rtl865x_tblDrv_mCast_t *rtl865x_findMCastEntry(unsigned int mAddr, unsigned int sip, unsigned short svid, unsigned short sport);
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+int rtl865x_addMulticastEntry(unsigned int mAddr, unsigned int sip, unsigned short svid, unsigned short sport,
+									rtl865x_mcast_fwd_descriptor_t * newFwdDescChain,
+									int flushOldChain, unsigned int extIp, char cpuHold, unsigned char flag, unsigned int mapPortMask);
+#else
+int rtl865x_addMulticastEntry(unsigned int mAddr, unsigned int sip, unsigned short svid, unsigned short sport,
+									rtl865x_mcast_fwd_descriptor_t * newFwdDescChain,
+									int flushOldChain, unsigned int extIp, char cpuHold, unsigned char flag);
+#endif
+int rtl865x_delMulticastEntry(unsigned int mcast_addr);
+
+int rtl865x_genVirtualMCastFwdDescriptor(unsigned int forceToCpu, unsigned int  fwdPortMask, rtl865x_mcast_fwd_descriptor_t *fwdDescriptor);
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+int rtl865x_blockMulticastFlow(unsigned int srcVlanId, unsigned int srcPort,unsigned int srcIpAddr, unsigned int destIpAddr, unsigned int mapPortMask);
+#else
+int rtl865x_blockMulticastFlow(unsigned int srcVlanId, unsigned int srcPort,unsigned int srcIpAddr, unsigned int destIpAddr);
+#endif
+int32 rtl865x_flushHWMulticastEntry(void);
+int rtl865x_getMCastHashMethod(unsigned int *hashMethod);
+int rtl865x_setMCastHashMethod(unsigned int hashMethod);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+typedef MC_LIST_HEAD(mcast_fwd_descriptor_head6_s, rtl8198c_mcast_fwd_descriptor6_s)  mcast_fwd_descriptor_head6_t;
+typedef struct rtl8198c_mcast_fwd_descriptor6_s{
+	char netifName[16];
+	unsigned int descPortMask;
+	char toCpu;
+	unsigned int vid;
+	unsigned int fwdPortMask;
+#if defined(CONFIG_BRIDGE_IGMP_SNOOPING)
+	unsigned int swPortMask;
+	unsigned int dip;
+#endif
+	MC_LIST_ENTRY(rtl8198c_mcast_fwd_descriptor6_s)	next;
+
+}rtl8198c_mcast_fwd_descriptor6_t;
+typedef struct rtl8198c_tblDrv_mCastv6_s {
+	inv6_addr_t sip;
+	inv6_addr_t dip;
+	uint16 	port;
+	uint32	mbr;
+	uint16  age;
+	uint16  cpu;
+	uint16	six_rd_eg;
+	uint16	six_rd_idx;
+	/*above field is for asic table usage*/
+	unsigned short	svid;
+	mcast_fwd_descriptor_head6_t fwdDescChain;
+	unsigned int	count;
+	unsigned char	cpuHold;
+	unsigned char	flag;
+	unsigned char	inAsic;
+	unsigned char	unKnownMCast;
+#if  defined(CONFIG_RTL8196C_REVISION_B) || defined (CONFIG_RTL8198_REVISION_B) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	unsigned short liveTime;
+#endif
+
+//#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+	unsigned int hashIndex;
+//#endif
+
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+	unsigned int mapPortMbr;
+#endif
+
+	TAILQ_ENTRY(rtl8198c_tblDrv_mCastv6_s) nextMCast;
+} rtl8198c_tblDrv_mCastv6_t;
+TAILQ_HEAD( MCast6_hash_head, rtl8198c_tblDrv_mCastv6_s);
+struct rtl8198c_multicastv6Table{
+	struct freeList6_s {
+
+		TAILQ_HEAD( _FreeMultiCastEntry6, rtl8198c_tblDrv_mCastv6_s) freeMultiCast;
+	} freeList;
+
+	struct inuseList6_s {
+		TAILQ_HEAD( _InuseMCast6, rtl8198c_tblDrv_mCastv6_s) *mCastTbl;
+	}inuseList;
+};
+
+typedef struct rtl8198c_mCastv6Config_s{
+	unsigned int externalPortMask;
+}rtl8198c_mCastv6Config_t;
+
+int rtl8198C_initMulticastv6(void);//rtl8198c_mCastv6Config_t * mCastConfig6);
+int rtl8198C_reinitMulticastv6(void);
+int rtl8198C_addMulticastv6ExternalPort(unsigned int extPort);
+int rtl8198C_delMulticastv6ExternalPort(unsigned int extPort);
+int rtl8198C_setMulticastv6ExternalPortMask(unsigned int extPortMask);
+int rtl8198C_getMulticastv6ExternalPortMask(void);
+int rtl8198C_addMulticastv6ExternalPortMask(unsigned int extPortMask);
+int rtl8198C_delMulticastv6ExternalPortMask(unsigned int extPortMask);
+rtl8198c_tblDrv_mCastv6_t *rtl8198C_findMCastv6Entry(inv6_addr_t dip,inv6_addr_t sip, unsigned short svid, unsigned short sport);
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+int rtl8198C_addMulticastv6Entry(inv6_addr_t dip,inv6_addr_t sip, unsigned short svid, unsigned short sport,
+									rtl8198c_mcast_fwd_descriptor6_t * newFwdDescChain,
+									int flushOldChain, unsigned int extIp, char cpuHold, unsigned char flag, unsigned int mapPortMask);
+#else
+int rtl8198C_addMulticastv6Entry(inv6_addr_t dip,inv6_addr_t sip, unsigned short svid, unsigned short sport,
+									rtl8198c_mcast_fwd_descriptor6_t * newFwdDescChain,
+									int flushOldChain, unsigned int extIp, char cpuHold, unsigned char flag);
+#endif
+int rtl8198C_delMulticastv6Entry(inv6_addr_t groupAddr);
+int rtl8198C_genVirtualMCastv6FwdDescriptor(unsigned int forceToCpu, unsigned int  fwdPortMask, rtl8198c_mcast_fwd_descriptor6_t *fwdDescriptor);
+#if defined CONFIG_RTL_MULTICAST_PORT_MAPPING
+int rtl8198C_blockMulticastv6Flow(unsigned int srcVlanId, unsigned int srcPort,inv6_addr_t srcIpAddr,inv6_addr_t destIpAddr, unsigned int mapPortMask);
+#else
+int rtl8198C_blockMulticastv6Flow(unsigned int srcVlanId, unsigned int srcPort,inv6_addr_t srcIpAddr,inv6_addr_t destIpAddr);
+#endif
+int32 rtl8198C_flushHWMulticastv6Entry(void);
+int rtl8198C_getMCastv6HashMethod(unsigned int *hashMethod);
+int rtl8198C_setMCastv6HashMethod(unsigned int hashMethod);
+#endif
+#if defined (CONFIG_RTL_HW_MCAST_PATCH_FOR_MAC)
+#define MACCLONE_MODE_HW_REPLACE 1
+#define	MACCLONE_MODE_SW_REPLACE 2
+#define MACCLONE_MODE_HW_DISBLE 3
+#define	MACCLONE_MODE_ORI 0
+#endif
+
+#endif
+
diff --git a/include/net/rtl/rtl865x_multipleWan_api.h b/include/net/rtl/rtl865x_multipleWan_api.h
new file mode 100644
index 00000000..be4689a
--- /dev/null
+++ b/include/net/rtl/rtl865x_multipleWan_api.h
@@ -0,0 +1,276 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2010
+* All rights reserved.
+*
+* Program : multiple wan device driver header file
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865X_MULTIPLEWAN_API_H
+#define RTL865X_MULTIPLEWAN_API_H
+#include "rtl_types.h"
+
+#define RTL_ADVRT_MAC						0x00
+#define RTL_ADVRT_DSTFILTER_IPRANGE		0x01
+#define RTL_ADVRT_IP					0x02
+#define RTL_ADVRT_ICMP				0x04
+#define RTL_ADVRT_IGMP				0x05
+#define RTL_ADVRT_TCP					0x06
+#define RTL_ADVRT_UDP					0x07
+#define RTL_ADVRT_SRCFILTER			0x08
+#define RTL_ADVRT_DSTFILTER			0x09
+#define RTL_ADVRT_IP_RANGE			0x0A
+#define RTL_ADVRT_SRCFILTER_IPRANGE 	0x0B
+#define RTL_ADVRT_ICMP_IPRANGE		0x0C
+#define RTL_ADVRT_IGMP_IPRANGE 		0x0D
+#define RTL_ADVRT_TCP_IPRANGE		0x0E
+#define RTL_ADVRT_UDP_IPRANGE		0x0F
+
+
+typedef struct _rtl_advRoute_entry
+{
+	union
+	{
+		/* MAC rule */
+		struct {
+			ether_addr_t _dstMac, _dstMacMask;
+			ether_addr_t _srcMac, _srcMacMask;
+			uint16 _typeLen, _typeLenMask;
+		} MAC;
+
+		/* IP Group rule */
+		struct
+		{
+			ipaddr_t _srcIpAddr, _srcIpAddrMask;
+			ipaddr_t _dstIpAddr, _dstIpAddrMask;
+			uint8 _tos, _tosMask;
+			union
+			{
+				/* IP rle */
+				struct
+				{
+					uint8 _proto, _protoMask, _flagMask;// flag & flagMask only last 3-bit is meaning ful
+					uint32 _FOP:1, _FOM:1, _httpFilter:1, _httpFilterM:1, _identSrcDstIp:1, _identSrcDstIpM:1;
+					union
+					{
+						uint8 _flag;
+						struct
+						{
+							uint8 pend1:5,
+								 pend2:1,
+								 _DF:1,	//don't fragment flag
+								 _MF:1;	//more fragments flag
+						} s;
+					} un;
+				} ip;
+
+				/* ICMP rule */
+				struct
+				{
+					uint8 _type, _typeMask, _code, _codeMask;
+				} icmp;
+
+				/* IGMP rule */
+				struct
+				{
+					uint8 _type, _typeMask;
+				} igmp;
+
+				/* TCP rule */
+				struct
+				{
+					uint8 _flagMask;
+					uint16 _srcPortUpperBound, _srcPortLowerBound;
+					uint16 _dstPortUpperBound, _dstPortLowerBound;
+					union
+					{
+						uint8 _flag;
+						struct
+						{
+							uint8 _pend:2,
+								  _urg:1, //urgent bit
+								  _ack:1, //ack bit
+								  _psh:1, //push bit
+								  _rst:1, //reset bit
+								  _syn:1, //sync bit
+								  _fin:1; //fin bit
+						}s;
+					}un;
+				}tcp;
+
+				/* UDP rule */
+				struct
+				{
+					uint16 _srcPortUpperBound, _srcPortLowerBound;
+					uint16 _dstPortUpperBound, _dstPortLowerBound;
+				}udp;
+			}is;
+		}L3L4;
+#if defined(CONFIG_RTL_8198C)
+		struct
+		{
+			inv6_addr_t _srcIpV6Addr, _srcIpV6AddrMask;
+			inv6_addr_t _dstIpV6Addr, _dstIpV6AddrMask;
+			uint32 _INV:1,_ETY:1, _comb:1,_ip_tunnel:1 ,_httpFilter:1, _httpFilterM:1, _identSrcDstIp:1, _identSrcDstIpM:1;
+			uint32 _flowLabel, _flowLabelMask;
+			uint8 _trafficClass, _trafficClassMask;
+			uint8 _nextheader, _nextheaderMask;
+		}L3V6;
+ #endif
+
+		/* Source filter rule */
+		struct
+		{
+			ether_addr_t _srcMac, _srcMacMask;
+			uint16 _srcPort, _srcPortMask;
+			uint16 _srcVlanIdx, _srcVlanIdxMask;
+			ipaddr_t _srcIpAddr, _srcIpAddrMask;
+			uint16 _srcPortUpperBound, _srcPortLowerBound;
+			uint32 _ignoreL4:1, //L2 rule
+				  	 _ignoreL3L4:1; //L3 rule
+		} SRCFILTER;
+
+		/* Destination filter rule */
+		struct
+		{
+			ether_addr_t _dstMac, _dstMacMask;
+			uint16 _vlanIdx, _vlanIdxMask;
+			ipaddr_t _dstIpAddr, _dstIpAddrMask;
+			uint16 _dstPortUpperBound, _dstPortLowerBound;
+			uint32 _ignoreL4:1, //L3 rule
+				   _ignoreL3L4:1; //L2 rule
+		} DSTFILTER;
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT) ||defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+		struct {
+			uint8	vlanTagPri;
+		} VLANTAG;
+#endif
+	}un_ty;
+
+
+	uint32	valid_:1,
+			ruleType_:5,
+			pktOpApp_:3;
+
+	ipaddr_t	extIp; /*which ip address is used when napt*/
+	ipaddr_t	nexthop; /* next hop IP address */
+	char outIfName[16]; /*out interface name, it should the netif name in driver*/
+}rtl_advRoute_entry_t;
+
+/* MAC ACL rule Definition */
+#define advrt_dstMac_				un_ty.MAC._dstMac
+#define advrt_dstMacMask_			un_ty.MAC._dstMacMask
+#define advrt_srcMac_				un_ty.MAC._srcMac
+#define advrt_srcMacMask_			un_ty.MAC._srcMacMask
+#define advrt_typeLen_				un_ty.MAC._typeLen
+#define advrt_typeLenMask_			un_ty.MAC._typeLenMask
+
+/* Common IP ACL Rule Definition */
+#define advrt_srcIpAddr_				un_ty.L3L4._srcIpAddr
+#define advrt_srcIpAddrMask_			un_ty.L3L4._srcIpAddrMask
+#define advrt_srcIpAddrUB_				un_ty.L3L4._srcIpAddr
+#define advrt_srcIpAddrLB_				un_ty.L3L4._srcIpAddrMask
+#define advrt_dstIpAddr_				un_ty.L3L4._dstIpAddr
+#define advrt_dstIpAddrMask_			un_ty.L3L4._dstIpAddrMask
+#define advrt_dstIpAddrUB_				un_ty.L3L4._dstIpAddr
+#define advrt_dstIpAddrLB_				un_ty.L3L4._dstIpAddrMask
+#define advrt_tos_					un_ty.L3L4._tos
+#define advrt_tosMask_				un_ty.L3L4._tosMask
+/* IP Rrange */
+/*Hyking:Asic use Addr to srore Upper address
+	and use Mask to store Lower address
+*/
+#define advrt_srcIpAddrStart_			un_ty.L3L4._srcIpAddrMask
+#define advrt_srcIpAddrEnd_			un_ty.L3L4._srcIpAddr
+#define advrt_dstIpAddrStart_			un_ty.L3L4._dstIpAddrMask
+#define advrt_dstIpAddrEnd_			un_ty.L3L4._dstIpAddr
+
+/* IP ACL Rule Definition */
+#define advrt_ipProto_				un_ty.L3L4.is.ip._proto
+#define advrt_ipProtoMask_			un_ty.L3L4.is.ip._protoMask
+#define advrt_ipFlagMask_			un_ty.L3L4.is.ip._flagMask
+#define advrt_ipFOP_      				un_ty.L3L4.is.ip._FOP
+#define advrt_ipFOM_      				un_ty.L3L4.is.ip._FOM
+#define advrt_ipHttpFilter_      			un_ty.L3L4.is.ip._httpFilter
+#define advrt_ipHttpFilterM_			un_ty.L3L4.is.ip._httpFilterM
+#define advrt_ipIdentSrcDstIp_   		un_ty.L3L4.is.ip._identSrcDstIp
+#define advrt_ipIdentSrcDstIpM_		un_ty.L3L4.is.ip._identSrcDstIpM
+#define advrt_ipFlag_					un_ty.L3L4.is.ip.un._flag
+#define advrt_ipDF_					un_ty.L3L4.is.ip.un.s._DF
+#define advrt_ipMF_					un_ty.L3L4.is.ip.un.s._MF
+
+/* ICMP ACL Rule Definition */
+#define advrt_icmpType_				un_ty.L3L4.is.icmp._type
+#define advrt_icmpTypeMask_			un_ty.L3L4.is.icmp._typeMask
+#define advrt_icmpCode_				un_ty.L3L4.is.icmp._code
+#define advrt_icmpCodeMask_			un_ty.L3L4.is.icmp._codeMask
+
+/* IGMP ACL Rule Definition */
+#define advrt_igmpType_				un_ty.L3L4.is.igmp._type
+#define advrt_igmpTypeMask_			un_ty.L3L4.is.igmp._typeMask
+
+/* TCP ACL Rule Definition */
+#define advrt_tcpSrcPortUB_			un_ty.L3L4.is.tcp._srcPortUpperBound
+#define advrt_tcpSrcPortLB_			un_ty.L3L4.is.tcp._srcPortLowerBound
+#define advrt_tcpDstPortUB_			un_ty.L3L4.is.tcp._dstPortUpperBound
+#define advrt_tcpDstPortLB_			un_ty.L3L4.is.tcp._dstPortLowerBound
+#define advrt_tcpFlagMask_			un_ty.L3L4.is.tcp._flagMask
+#define advrt_tcpFlag_				un_ty.L3L4.is.tcp.un._flag
+#define advrt_tcpURG_				un_ty.L3L4.is.tcp.un.s._urg
+#define advrt_tcpACK_				un_ty.L3L4.is.tcp.un.s._ack
+#define advrt_tcpPSH_				un_ty.L3L4.is.tcp.un.s._psh
+#define advrt_tcpRST_				un_ty.L3L4.is.tcp.un.s._rst
+#define advrt_tcpSYN_				un_ty.L3L4.is.tcp.un.s._syn
+#define advrt_tcpFIN_				un_ty.L3L4.is.tcp.un.s._fin
+
+/* UDP ACL Rule Definition */
+#define advrt_udpSrcPortUB_			un_ty.L3L4.is.udp._srcPortUpperBound
+#define advrt_udpSrcPortLB_			un_ty.L3L4.is.udp._srcPortLowerBound
+#define advrt_udpDstPortUB_			un_ty.L3L4.is.udp._dstPortUpperBound
+#define advrt_udpDstPortLB_			un_ty.L3L4.is.udp._dstPortLowerBound
+
+/* Source Filter ACL Rule Definition */
+#define advrt_srcFilterMac_				un_ty.SRCFILTER._srcMac
+#define advrt_srcFilterMacMask_		un_ty.SRCFILTER._srcMacMask
+#define advrt_srcFilterPort_				un_ty.SRCFILTER._srcPort
+#define advrt_srcFilterPortMask_		un_ty.SRCFILTER._srcPortMask
+#define advrt_srcFilterVlanIdx_			un_ty.SRCFILTER._srcVlanIdx
+#define advrt_srcFilterVlanId_			un_ty.SRCFILTER._srcVlanIdx
+#define advrt_srcFilterVlanIdxMask_		un_ty.SRCFILTER._srcVlanIdxMask
+#define advrt_srcFilterVlanIdMask_		un_ty.SRCFILTER._srcVlanIdxMask
+#define advrt_srcFilterIpAddr_			un_ty.SRCFILTER._srcIpAddr
+#define advrt_srcFilterIpAddrMask_		un_ty.SRCFILTER._srcIpAddrMask
+#define advrt_srcFilterIpAddrUB_		un_ty.SRCFILTER._srcIpAddr
+#define advrt_srcFilterIpAddrLB_		un_ty.SRCFILTER._srcIpAddrMask
+#define advrt_srcFilterPortUpperBound_	un_ty.SRCFILTER._srcPortUpperBound
+#define advrt_srcFilterPortLowerBound_	un_ty.SRCFILTER._srcPortLowerBound
+#define advrt_srcFilterIgnoreL3L4_		un_ty.SRCFILTER._ignoreL3L4
+#define advrt_srcFilterIgnoreL4_		un_ty.SRCFILTER._ignoreL4
+
+/* Destination Filter ACL Rule Definition */
+#define advrt_dstFilterMac_				un_ty.DSTFILTER._dstMac
+#define advrt_dstFilterMacMask_		un_ty.DSTFILTER._dstMacMask
+#define advrt_dstFilterVlanIdx_			un_ty.DSTFILTER._vlanIdx
+#define advrt_dstFilterVlanIdxMask_		un_ty.DSTFILTER._vlanIdxMask
+#define advrt_dstFilterVlanId_			un_ty.DSTFILTER._vlanIdx
+#define advrt_dstFilterVlanIdMask_		un_ty.DSTFILTER._vlanIdxMask
+#define advrt_dstFilterIpAddr_			un_ty.DSTFILTER._dstIpAddr
+#define advrt_dstFilterIpAddrMask_		un_ty.DSTFILTER._dstIpAddrMask
+#define advrt_dstFilterPortUpperBound_	un_ty.DSTFILTER._dstPortUpperBound
+#define advrt_dstFilterIpAddrUB_		un_ty.DSTFILTER._dstIpAddr
+#define advrt_dstFilterIpAddrLB_		un_ty.DSTFILTER._dstIpAddrMask
+#define advrt_dstFilterPortLowerBound_	un_ty.DSTFILTER._dstPortLowerBound
+#define advrt_dstFilterIgnoreL3L4_		un_ty.DSTFILTER._ignoreL3L4
+#define advrt_dstFilterIgnoreL4_		un_ty.DSTFILTER._ignoreL4
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+#define advrt_vlanTagPri_			un_ty.VLANTAG.vlanTagPri
+#endif
+
+
+#endif
diff --git a/include/net/rtl/rtl865x_nat.h b/include/net/rtl/rtl865x_nat.h
new file mode 100644
index 00000000..505c680
--- /dev/null
+++ b/include/net/rtl/rtl865x_nat.h
@@ -0,0 +1,143 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef	RTL865X_NAT_H
+#define	RTL865X_NAT_H
+#define CONFIG_RTL865X_NAT_ADD_FAIL_CHECK	1
+#define FLAG_QOS_ENABLE 1
+
+/* NAT timeout value */
+#define TCP_TIMEOUT					120	 	/* 120 secs */
+#define UDP_TIMEOUT					90		/* 90 secs */
+#define TCP_OVERRIDE_ELASPED_THRESHOLD	60	 	/* 60 secs */
+#define UDP_OVERRIDE_ELASPED_THRESHOLD	30		/* 30 secs */
+
+#define TCP_CLOSED_FLOW				8
+
+#define RTL865X_PROTOCOL_UDP		0
+#define RTL865X_PROTOCOL_TCP		1
+
+#define NAT_INBOUND					0x00000001
+#define NAT_OUTBOUND				0x00000002
+#define NAT_PRI_PROCESSED			0x00000004
+#define NAT_PRI_HALF_PROCESSED		0x00000008
+
+#define NAT_PRE_RESERVED		0x00000100
+#define RESERVE_EXPIRE_TIME	3	/*uinit:seconds*/
+
+#define NAT_INUSE(_n_)				( ((_n_)->flags&(NAT_INBOUND|NAT_OUTBOUND)) )
+#define SET_NAT_FLAGS(_n_, _v_)		((_n_)->flags |= (_v_))
+#define CLR_NAT_FLAGS(_n_, _v_)		((_n_)->flags &= (~(_v_)))
+#define	NAT_INVALID(_n_)			( ((_n_)->flags=0) )
+
+#define MAX_EXTPORT_TRY_CNT 8
+
+#define	RTL_NAPT_ACCELERATION_FAIL			-1
+#define	RTL_NAPT_FULL_ACCELERATION			0
+#define	RTL_NAPT_OUTBOUND_ACCELERATION 	1
+#define 	RTL_NAPT_INBOUND_ACCELERATION		2
+
+#define CONFIG_RTL_INBOUND_COLLISION_AVOIDANCE
+#define CONFIG_RTL_HALF_NAPT_ACCELERATION
+
+#define RTL_REFRESH_HW_L2_ENTRY_DECIDE_BY_HW_NAT	1
+
+typedef struct _rtl865x_napt_entry
+{
+	uint32 protocol;	//RTL865X_PROTOCOL_UDP or RTL865X_PROTOCOL_TCP
+	ipaddr_t intIp;
+	uint32 intPort;
+	ipaddr_t extIp;
+	uint32 extPort;
+	ipaddr_t remIp;
+	uint32 remPort;
+#if defined (CONFIG_RTL_EXT_PORT_SUPPORT)
+	uint32 isExtNaptEntry;
+#endif
+}rtl865x_napt_entry;
+
+typedef struct _rtl865x_priority
+{
+	int32 uplinkPrio;
+	int32 downlinkPrio;
+}rtl865x_priority;
+
+typedef struct _rtl865x_qos_mark
+{
+	int32 uplinkMark;
+	int32 downlinkMark;
+}rtl865x_qos_mark;
+
+int32 rtl865x_nat_init(void);
+int32 rtl865x_nat_reinit(void);
+/*
+@func enum RTL_RESULT | rtl865x_addNaptConnection | Add a NAPT Flow
+@parm enum RTL_NP_PROTOCOL | protocol | The protocol to add
+@parm ipaddr_t | intIp | Internal IP address
+@parm uint32 | intPort | Internal Port
+@parm ipaddr_t | extIp | External IP address
+@parm uint32 | extPort | External Port
+@parm ipaddr_t | remIp | Remote IP address
+@parm uint32 | remPort | Remote Port
+@parm enum RTL_NP_FLAGS | flags | reserved for future used
+@rvalue RTL_SUCCESS | Add success (can be ASIC-accelerated)
+@rvalue RTL_SUCCESS | Add success (cannot be ASIC-accelerated)
+@rvalue RTL_ERROR_PARAMETER | Error parameter is given
+@rvalue RTL_EXIST | Add an existed flow
+@rvalue RTL_FAILED | General failure
+@comm
+	Add a NAPT Flow Entry to L4 TCP/UDP NAPT Table(1024-Entry)
+@devnote
+	Insert into ip_nat_setup_info() function in file net/ipv4/netfilter/ip_nat_core.c
+*/
+int32 rtl865x_addNaptConnection(rtl865x_napt_entry *naptEntry, rtl865x_priority *prio);
+/*
+@func enum RTL_RESULT | rtl865x_delNaptConnection | Delete a NAPT Flow
+@parm enum RTL_NP_PROTOCOL | protocol | The protocol to delete
+@parm ipaddr_t | intIp | Internal IP address
+@parm uint32 | intPort | Internal Port
+@parm ipaddr_t | extIp | External IP address
+@parm uint32 | extPort | External Port
+@parm ipaddr_t | remIp | Remote IP address
+@parm uint32 | remPort | Remote Port
+@rvalue RTL_SUCCESS | Delete success
+@rvalue RTL_NONEXIST | Delete a non-existed flow
+@rvalue RTL_FAILED | General failure
+@comm
+	Delete a NAPT Flow Entry of L4 TCP/UDP NAPT Table(1024-Entry)
+@devnote
+	Insert into ip_nat_cleanup_conntrack() function in file net/ipv4/netfilter/ip_nat_core.c
+*/
+int32 rtl865x_delNaptConnection(rtl865x_napt_entry *naptEntry);
+
+int32 rtl865x_naptSync(rtl865x_napt_entry *naptEntry, uint32 refresh);
+
+#if defined (CONFIG_RTL_INBOUND_COLLISION_AVOIDANCE)
+int rtl865x_optimizeExtPort(unsigned short origDelta, unsigned int rangeSize, unsigned short *newDelta);
+
+int rtl865x_getAsicNaptHashScore(rtl865x_napt_entry *naptEntry,
+					                        uint32 *naptHashScore);
+
+int32 rtl865x_preReserveConn(rtl865x_napt_entry *naptEntry);
+
+#endif
+#if defined(CONFIG_RTL_HARDWARE_NAT)
+int32 rtl_nat_expire_interval_update(int proto, int32 interval);
+int32 rtl865x_nat_reinit(void);
+#endif
+
+#if defined(RTL_REFRESH_HW_L2_ENTRY_DECIDE_BY_HW_NAT)
+int rtl865x_check_hw_nat_by_ip(ipaddr_t ip);
+#endif
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+int32 rtl865x_flush_ext_port_entry(void);
+
+#endif
+#endif
+
diff --git a/include/net/rtl/rtl865x_netif.h b/include/net/rtl/rtl865x_netif.h
new file mode 100644
index 00000000..fa181e3
--- /dev/null
+++ b/include/net/rtl/rtl865x_netif.h
@@ -0,0 +1,1007 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : network interface driver header file
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+
+#ifndef RTL865X_NETIF_H
+#define RTL865X_NETIF_H
+#include "rtl_types.h"
+#include <linux/seq_file.h>
+
+
+#define IF_NONE 0
+#define	IF_ETHER 1
+#define	IF_PPPOE 2
+#define	IF_PPTP 3
+#define	IF_L2TP 4
+#define IF_6RD	5
+#define IF_DSLT	6
+
+#define RTL865X_ACL_IGMP_USED		-30003
+#if defined(CONFIG_RTL_INBAND_CTL_ACL)
+#define RTL865X_ACL_TEST_USED		-30002
+#endif
+#if defined(CONFIG_RTL_DNS_TRAP)
+#define RTL865X_ACL_DNSTRAP_USED	-30001
+#endif
+#define RTL865X_ACL_IPV6_USED		-30000
+#define RTL865X_ACL_QOS_USED2		-20002		/* dummy queue for iptable 2 acl translate */
+#define RTL865X_ACL_QOS_USED1		-20000		/* for default queue */
+#define RTL865X_ACL_QOS_USED0		-20001		/* for user add queue */
+#if defined(CONFIG_RTL_HTTP_REDIRECT_LOCAL)
+#define RTL865X_ACL_HTTP_REDIRECT_USED	-14000	/*for http redirect local*/
+#endif
+#define RTL865X_ACL_MULTIWAN_USED	-15000	/*for multiwan*/
+#define RTL865X_ACL_USER_USED		0
+
+#if 1 //def CONFIG_RTL_LAYERED_DRIVER_ACL
+typedef struct _rtl865x_AclRule_s
+{
+	union
+	{
+		/* MAC ACL rule */
+		struct {
+			ether_addr_t _dstMac, _dstMacMask;
+			ether_addr_t _srcMac, _srcMacMask;
+			uint16 _typeLen, _typeLenMask;
+		} MAC;
+
+		/* IP Group ACL rule */
+		struct
+		{
+			ipaddr_t _srcIpAddr, _srcIpAddrMask;
+			ipaddr_t _dstIpAddr, _dstIpAddrMask;
+			uint8 _tos, _tosMask;
+			union
+			{
+				/* IP ACL rle */
+				struct
+				{
+					uint8 _proto, _protoMask, _flagMask;// flag & flagMask only last 3-bit is meaning ful
+					uint32 _FOP:1, _FOM:1, _httpFilter:1, _httpFilterM:1, _identSrcDstIp:1, _identSrcDstIpM:1;
+					union
+					{
+						uint8 _flag;
+						struct
+						{
+							uint8 pend1:5,
+								 pend2:1,
+								 _DF:1,	//don't fragment flag
+								 _MF:1;	//more fragments flag
+						} s;
+					} un;
+				} ip;
+
+				/* ICMP ACL rule */
+				struct
+				{
+					uint8 _type, _typeMask, _code, _codeMask;
+				} icmp;
+
+				/* IGMP ACL rule */
+				struct
+				{
+					uint8 _type, _typeMask;
+				} igmp;
+
+				/* TCP ACL rule */
+				struct
+				{
+					uint8 _flagMask;
+					uint16 _srcPortUpperBound, _srcPortLowerBound;
+					uint16 _dstPortUpperBound, _dstPortLowerBound;
+					union
+					{
+						uint8 _flag;
+						struct
+						{
+							uint8 _pend:2,
+								  _urg:1, //urgent bit
+								  _ack:1, //ack bit
+								  _psh:1, //push bit
+								  _rst:1, //reset bit
+								  _syn:1, //sync bit
+								  _fin:1; //fin bit
+						}s;
+					}un;
+				}tcp;
+
+				/* UDP ACL rule */
+				struct
+				{
+					uint16 _srcPortUpperBound, _srcPortLowerBound;
+					uint16 _dstPortUpperBound, _dstPortLowerBound;
+				}udp;
+			}is;
+		}L3L4;
+
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+		struct
+		{
+			inv6_addr_t _srcIpV6Addr, _srcIpV6AddrMask;
+			inv6_addr_t _dstIpV6Addr, _dstIpV6AddrMask;
+			uint32 _INV:1,_ETY:1, _comb:1,_ip_tunnel:1 ,_httpFilter:1, _httpFilterM:1, _identSrcDstIp:1, _identSrcDstIpM:1;
+			uint32 _flowLabel, _flowLabelMask;
+			uint8 _trafficClass, _trafficClassMask;
+			uint8 _nextheader, _nextheaderMask;
+		}L3V6;
+ #endif
+		/* Source filter ACL rule */
+		struct
+		{
+			ether_addr_t _srcMac, _srcMacMask;
+			uint16 _srcPort, _srcPortMask;
+			uint16 _srcVlanIdx, _srcVlanIdxMask;
+			ipaddr_t _srcIpAddr, _srcIpAddrMask;
+			uint16 _srcPortUpperBound, _srcPortLowerBound;
+			uint32 _ignoreL4:1, //L2 rule
+				   _ignoreL3L4:1; //L3 rule
+		} SRCFILTER;
+
+		/* Destination filter ACL rule */
+		struct
+		{
+			ether_addr_t _dstMac, _dstMacMask;
+			uint16 _vlanIdx, _vlanIdxMask;
+			ipaddr_t _dstIpAddr, _dstIpAddrMask;
+			uint16 _dstPortUpperBound, _dstPortLowerBound;
+			uint32 _ignoreL4:1, //L3 rule
+				   _ignoreL3L4:1; //L2 rule
+		} DSTFILTER;
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT) ||defined(CONFIG_RTL_MULTIPLE_WAN)  ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+		struct {
+			uint8	vlanTagPri;
+		} VLANTAG;
+#endif
+
+#if defined(CONFIG_RTL_8197F)
+		/* Pattern Match ACL rule */
+		struct {
+			uint16 _spub, _splb ,_dpub, _dplb ;
+			uint16 _protocol, _specialop ,_spa, _spam ;
+			uint16 _pppctl , _pppctlm, _pppctlor ;
+			uint16 _offset0, _pattern0 ,_pm0, _or0 ;
+			uint16 _offset1, _pattern1 ,_pm1, _or1 ;
+			uint16 _offset2, _pattern2 ,_pm2, _or2 ;
+			uint16 _offset3, _pattern3 ,_pm3, _or3 ;
+			uint16 _offset4, _pattern4 ,_pm4, _or4 ;
+			uint16 _offset5, _pattern5 ,_pm5, _or5 ;
+			uint16 _offset6, _pattern6 ,_pm6, _or6 ;
+			uint16 _offset7, _pattern7 ,_pm7, _or7 ;
+		} PM;
+#endif
+
+	}un_ty;
+
+	uint32	ruleType_:5,
+			actionType_:4,
+			pktOpApp_:3,
+			priority_:3,
+			direction_:2,
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) ||defined(CONFIG_RTL_MULTIPLE_WAN)  ||defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+			upDown_:1,//0: uplink acl rule for hw qos; 1: downlink acl rule for hw qos
+#endif
+#if defined(CONFIG_RTL_8197F)
+			_INV:1,_ETY:1, _comb:1,_ip_tunnel:1,
+#endif
+			nexthopIdx_:5, /* Index of nexthop table (NOT L2 table) */	/* used as network interface index for 865xC qos system */
+			ratelimtIdx_:4; /* Index of rate limit table */	/* used as outputQueue index for 865xC qos system */
+
+	uint32	netifIdx_:3, /*for redirect*/
+			pppoeIdx_:3, /*for redirect*/
+			L2Idx_:10, /* Index of L2 table */
+			inv_flag:8, /*mainly for iptables-->acl rule, when iptables rule has invert netif flag, this acl rule is added to other netifs*/
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+			aclIdx:8;	/* aisc entry idx */
+#else
+			aclIdx:7;	/* aisc entry idx */
+#endif
+
+#if defined(CONFIG_RTL_8197F)
+	uint32	aclvid_:12, /* vid if ActionType =1111 */
+			aclfid_:2, /*  fid if ActionType =1111 */
+			ipfrag_apply_:1;
+#elif defined(CONFIG_RTL_8198C)
+	uint32 aclvid_:12; /* vid if ActionType =1111 */
+#endif
+	struct _rtl865x_AclRule_s *pre,*next;
+
+}rtl865x_AclRule_t;
+
+
+/* MAC ACL rule Definition */
+#define dstMac_						un_ty.MAC._dstMac
+#define dstMacMask_					un_ty.MAC._dstMacMask
+#define srcMac_						un_ty.MAC._srcMac
+#define srcMacMask_					un_ty.MAC._srcMacMask
+#define typeLen_					un_ty.MAC._typeLen
+#define typeLenMask_				un_ty.MAC._typeLenMask
+
+/* Common IP ACL Rule Definition */
+#define srcIpAddr_					un_ty.L3L4._srcIpAddr
+#define srcIpAddrMask_				un_ty.L3L4._srcIpAddrMask
+#define srcIpAddrUB_				un_ty.L3L4._srcIpAddr
+#define srcIpAddrLB_				un_ty.L3L4._srcIpAddrMask
+#define dstIpAddr_					un_ty.L3L4._dstIpAddr
+#define dstIpAddrMask_				un_ty.L3L4._dstIpAddrMask
+#define dstIpAddrUB_				un_ty.L3L4._dstIpAddr
+#define dstIpAddrLB_				un_ty.L3L4._dstIpAddrMask
+#define tos_						un_ty.L3L4._tos
+#define tosMask_					un_ty.L3L4._tosMask
+/* IP Rrange */
+/*Hyking:Asic use Addr to srore Upper address
+	and use Mask to store Lower address
+*/
+#define srcIpAddrStart_				un_ty.L3L4._srcIpAddrMask
+#define srcIpAddrEnd_				un_ty.L3L4._srcIpAddr
+#define dstIpAddrStart_				un_ty.L3L4._dstIpAddrMask
+#define dstIpAddrEnd_				un_ty.L3L4._dstIpAddr
+
+/* IP ACL Rule Definition */
+#define ipProto_					un_ty.L3L4.is.ip._proto
+#define ipProtoMask_				un_ty.L3L4.is.ip._protoMask
+#define ipFlagMask_					un_ty.L3L4.is.ip._flagMask
+#define ipFOP_						un_ty.L3L4.is.ip._FOP
+#define ipFOM_						un_ty.L3L4.is.ip._FOM
+#define ipHttpFilter_				un_ty.L3L4.is.ip._httpFilter
+#define ipHttpFilterM_				un_ty.L3L4.is.ip._httpFilterM
+#define ipIdentSrcDstIp_			un_ty.L3L4.is.ip._identSrcDstIp
+#define ipIdentSrcDstIpM_			un_ty.L3L4.is.ip._identSrcDstIpM
+#define ipFlag_						un_ty.L3L4.is.ip.un._flag
+#define ipDF_						un_ty.L3L4.is.ip.un.s._DF
+#define ipMF_						un_ty.L3L4.is.ip.un.s._MF
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+/* IPv6 ACL Rule Definition */
+#define srcIpV6Addr_				un_ty.L3V6._srcIpV6Addr
+#define srcIpV6AddrMask_			un_ty.L3V6._srcIpV6AddrMask
+#define srcIpV6AddrUB_				un_ty.L3V6._srcIpV6Addr
+#define srcIpV6AddrLB_				un_ty.L3V6._srcIpV6AddrMask
+#define dstIpV6Addr_				un_ty.L3V6._dstIpV6Addr
+#define dstIpV6AddrMask_			un_ty.L3V6._dstIpV6AddrMask
+#define dstIpV6AddrUB_				un_ty.L3V6._dstIpV6Addr
+#define dstIpV6AddrLB_				un_ty.L3V6._dstIpV6AddrMask
+#define ipv6HttpFilter_				un_ty.L3V6._httpFilter
+#define ipv6HttpFilterM_			un_ty.L3V6._httpFilterM
+#define ipv6IdentSrcDstIp_			un_ty.L3V6._identSrcDstIp
+#define ipv6IdentSrcDstIpM_			un_ty.L3V6._identSrcDstIpM
+#define ipv6FlowLabel_				un_ty.L3V6._flowLabel
+#define ipv6FlowLabelM_				un_ty.L3V6._flowLabelMask
+#define ipv6TrafficClass_			un_ty.L3V6._trafficClass
+#define ipv6TrafficClassM_			un_ty.L3V6._trafficClassMask
+#define ipv6NextHeader_				un_ty.L3V6._nextheader
+#define ipv6NextHeaderM_			un_ty.L3V6._nextheaderMask
+#endif
+
+#if defined(CONFIG_RTL_8198C)
+#define ipv6Invert_					un_ty.L3V6._INV
+#define ipv6EntryType_				un_ty.L3V6._ETY
+#define ipv6Combine_				un_ty.L3V6._comb
+#define ipv6IPtunnel_				un_ty.L3V6._ip_tunnel
+#elif defined(CONFIG_RTL_8197F)
+#define ipv6Invert_					_INV
+#define ipv6EntryType_				_ETY
+#define ipv6Combine_				_comb
+#define ipv6IPtunnel_				_ip_tunnel
+#endif
+
+/* ICMP ACL Rule Definition */
+#define icmpType_					un_ty.L3L4.is.icmp._type
+#define icmpTypeMask_				un_ty.L3L4.is.icmp._typeMask
+#define icmpCode_					un_ty.L3L4.is.icmp._code
+#define icmpCodeMask_				un_ty.L3L4.is.icmp._codeMask
+
+/* IGMP ACL Rule Definition */
+#define igmpType_					un_ty.L3L4.is.igmp._type
+#define igmpTypeMask_				un_ty.L3L4.is.igmp._typeMask
+
+/* TCP ACL Rule Definition */
+#define tcpSrcPortUB_				un_ty.L3L4.is.tcp._srcPortUpperBound
+#define tcpSrcPortLB_				un_ty.L3L4.is.tcp._srcPortLowerBound
+#define tcpDstPortUB_				un_ty.L3L4.is.tcp._dstPortUpperBound
+#define tcpDstPortLB_				un_ty.L3L4.is.tcp._dstPortLowerBound
+#define tcpFlagMask_				un_ty.L3L4.is.tcp._flagMask
+#define tcpFlag_					un_ty.L3L4.is.tcp.un._flag
+#define tcpURG_						un_ty.L3L4.is.tcp.un.s._urg
+#define tcpACK_						un_ty.L3L4.is.tcp.un.s._ack
+#define tcpPSH_						un_ty.L3L4.is.tcp.un.s._psh
+#define tcpRST_						un_ty.L3L4.is.tcp.un.s._rst
+#define tcpSYN_						un_ty.L3L4.is.tcp.un.s._syn
+#define tcpFIN_						un_ty.L3L4.is.tcp.un.s._fin
+
+/* UDP ACL Rule Definition */
+#define udpSrcPortUB_				un_ty.L3L4.is.udp._srcPortUpperBound
+#define udpSrcPortLB_				un_ty.L3L4.is.udp._srcPortLowerBound
+#define udpDstPortUB_				un_ty.L3L4.is.udp._dstPortUpperBound
+#define udpDstPortLB_				un_ty.L3L4.is.udp._dstPortLowerBound
+
+/* Source Filter ACL Rule Definition */
+#define srcFilterMac_				un_ty.SRCFILTER._srcMac
+#define srcFilterMacMask_			un_ty.SRCFILTER._srcMacMask
+#define srcFilterPort_				un_ty.SRCFILTER._srcPort
+#define srcFilterPortMask_			un_ty.SRCFILTER._srcPortMask
+#define srcFilterVlanIdx_			un_ty.SRCFILTER._srcVlanIdx
+#define srcFilterVlanId_			un_ty.SRCFILTER._srcVlanIdx
+#define srcFilterVlanIdxMask_		un_ty.SRCFILTER._srcVlanIdxMask
+#define srcFilterVlanIdMask_		un_ty.SRCFILTER._srcVlanIdxMask
+#define srcFilterIpAddr_			un_ty.SRCFILTER._srcIpAddr
+#define srcFilterIpAddrMask_		un_ty.SRCFILTER._srcIpAddrMask
+#define srcFilterIpAddrUB_			un_ty.SRCFILTER._srcIpAddr
+#define srcFilterIpAddrLB_			un_ty.SRCFILTER._srcIpAddrMask
+#define srcFilterPortUpperBound_	un_ty.SRCFILTER._srcPortUpperBound
+#define srcFilterPortLowerBound_	un_ty.SRCFILTER._srcPortLowerBound
+#define srcFilterIgnoreL3L4_		un_ty.SRCFILTER._ignoreL3L4
+#define srcFilterIgnoreL4_			un_ty.SRCFILTER._ignoreL4
+
+/* Destination Filter ACL Rule Definition */
+#define dstFilterMac_				un_ty.DSTFILTER._dstMac
+#define dstFilterMacMask_			un_ty.DSTFILTER._dstMacMask
+#define dstFilterVlanIdx_			un_ty.DSTFILTER._vlanIdx
+#define dstFilterVlanIdxMask_		un_ty.DSTFILTER._vlanIdxMask
+#define dstFilterVlanId_			un_ty.DSTFILTER._vlanIdx
+#define dstFilterVlanIdMask_		un_ty.DSTFILTER._vlanIdxMask
+#define dstFilterIpAddr_			un_ty.DSTFILTER._dstIpAddr
+#define dstFilterIpAddrMask_		un_ty.DSTFILTER._dstIpAddrMask
+#define dstFilterPortUpperBound_	un_ty.DSTFILTER._dstPortUpperBound
+#define dstFilterIpAddrUB_			un_ty.DSTFILTER._dstIpAddr
+#define dstFilterIpAddrLB_			un_ty.DSTFILTER._dstIpAddrMask
+#define dstFilterPortLowerBound_	un_ty.DSTFILTER._dstPortLowerBound
+#define dstFilterIgnoreL3L4_		un_ty.DSTFILTER._ignoreL3L4
+#define dstFilterIgnoreL4_			un_ty.DSTFILTER._ignoreL4
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+#define vlanTagPri_					un_ty.VLANTAG.vlanTagPri
+#endif
+
+#if defined(CONFIG_RTL_8197F)
+#define pmSPUB_						un_ty.PM._spub
+#define pmSPLB_						un_ty.PM._splb
+#define pmDPUB_						un_ty.PM._dpub
+#define pmDPLB_						un_ty.PM._dplb
+#define pmProtocol_					un_ty.PM._protocol
+#define pmSpecialop_				un_ty.PM._specialop
+#define pmSPA_						un_ty.PM._spa
+#define pmSPAM_						un_ty.PM._spam
+#define pmPPPCTL_					un_ty.PM._pppctl
+#define pmPPPCTLM_					un_ty.PM._pppctlm
+#define pmPPPCTLOR_					un_ty.PM._pppctlor
+#define pmOffset0_					un_ty.PM._offset0
+#define pmPattern0_					un_ty.PM._pattern0
+#define pmPatternMask0_				un_ty.PM._pm0
+#define pmOR0_						un_ty.PM._or0
+#define pmOffset1_					un_ty.PM._offset1
+#define pmPattern1_					un_ty.PM._pattern1
+#define pmPatternMask1_				un_ty.PM._pm1
+#define pmOR1_						un_ty.PM._or1
+#define pmOffset2_					un_ty.PM._offset2
+#define pmPattern2_					un_ty.PM._pattern2
+#define pmPatternMask2_				un_ty.PM._pm2
+#define pmOR2_						un_ty.PM._or2
+#define pmOffset3_					un_ty.PM._offset3
+#define pmPattern3_					un_ty.PM._pattern3
+#define pmPatternMask3_				un_ty.PM._pm3
+#define pmOR3_						un_ty.PM._or3
+#define pmOffset4_					un_ty.PM._offset4
+#define pmPattern4_					un_ty.PM._pattern4
+#define pmPatternMask4_				un_ty.PM._pm4
+#define pmOR4_						un_ty.PM._or4
+#define pmOffset5_					un_ty.PM._offset5
+#define pmPattern5_					un_ty.PM._pattern5
+#define pmPatternMask5_				un_ty.PM._pm5
+#define pmOR5_						un_ty.PM._or5
+#define pmOffset6_					un_ty.PM._offset6
+#define pmPattern6_					un_ty.PM._pattern6
+#define pmPatternMask6_				un_ty.PM._pm6
+#define pmOR6_						un_ty.PM._or6
+#define pmOffset7_					un_ty.PM._offset7
+#define pmPattern7_					un_ty.PM._pattern7
+#define pmPatternMask7_				un_ty.PM._pm7
+#define pmOR7_						un_ty.PM._or7
+#endif
+
+#endif //CONFIG_RTL_LAYERED_DRIVER_ACL
+
+/* ACL Rule Action type Definition */
+#define RTL865X_ACL_PERMIT					0x00
+#define RTL865X_ACL_REDIRECT_ETHER			0x01
+#define RTL865X_ACL_DROP					0x02
+#define RTL865X_ACL_TOCPU					0x03
+#define RTL865X_ACL_LEGACY_DROP				0x04
+#define RTL865X_ACL_DROPCPU_LOG				0x05
+#define RTL865X_ACL_MIRROR					0x06
+#define RTL865X_ACL_REDIRECT_PPPOE			0x07
+#define RTL865X_ACL_DEFAULT_REDIRECT		0x08
+#define RTL865X_ACL_MIRROR_KEEP_MATCH		0x09
+#define RTL865X_ACL_DROP_RATE_EXCEED_PPS	0x0a
+#define RTL865X_ACL_LOG_RATE_EXCEED_PPS		0x0b
+#define RTL865X_ACL_DROP_RATE_EXCEED_BPS	0x0c
+#define RTL865X_ACL_LOG_RATE_EXCEED_BPS		0x0d
+#define RTL865X_ACL_PRIORITY				0x0e
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define RTL865X_ACL_VID						0x0f
+#endif
+
+/* ACL Rule type Definition */
+#define RTL865X_ACL_MAC						0x00
+#define RTL865X_ACL_DSTFILTER_IPRANGE		0x01
+#define RTL865X_ACL_IP						0x02
+#define RTL865X_ACL_ICMP					0x04
+#define RTL865X_ACL_IGMP					0x05
+#define RTL865X_ACL_TCP						0x06
+#define RTL865X_ACL_UDP						0x07
+#define RTL865X_ACL_SRCFILTER				0x08
+#define RTL865X_ACL_DSTFILTER				0x09
+#define RTL865X_ACL_IP_RANGE				0x0A
+#define RTL865X_ACL_SRCFILTER_IPRANGE		0x0B
+#define RTL865X_ACL_ICMP_IPRANGE			0x0C
+#define RTL865X_ACL_IGMP_IPRANGE			0x0D
+#define RTL865X_ACL_TCP_IPRANGE				0x0E
+#define RTL865X_ACL_UDP_IPRANGE				0x0F
+
+#if defined(CONFIG_RTL_8197F)
+#define RTL865X_ACL_PM						0x10 /* pattern match*/
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define RTL865X_ACL_IPV6					0x12 /* ipv6 mask */
+#define RTL865X_ACL_IPV6_RANGE				0x1A
+#endif
+
+#if	defined(CONFIG_RTL_QOS_8021P_SUPPORT)
+/*	dummy acl type for qos	*/
+#define RTL865X_ACL_802D1P					0x1f
+#endif
+
+/* For PktOpApp */
+#define RTL865X_ACL_ONLY_L2				1 /* Only for L2 switch */
+#define RTL865X_ACL_ONLY_L3				2 /* Only for L3 routing (including IP multicast) */
+#define RTL865X_ACL_L2_AND_L3			3 /* Only for L2 switch and L3 routing (including IP multicast) */
+#define RTL865X_ACL_ONLY_L4				4 /* Only for L4 translation packets */
+#define RTL865X_ACL_L3_AND_L4			6 /* Only for L3 routing and L4 translation packets (including IP multicast) */
+#define RTL865X_ACL_ALL_LAYER			7 /* No operation. Don't apply this rule. */
+
+#if defined (CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F) //8198C has 256 acl rules
+#define RTL865X_ACL_MAX_NUMBER		252
+#else
+#define RTL865X_ACL_MAX_NUMBER		124
+#endif
+
+//#define RTL865X_ACL_MAX_NUMBER		64
+#define RTL865X_ACL_RESERVED_NUMBER	4
+
+#if defined (CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define RTL865X_ACLTBL_ALL_TO_CPU	255		// This rule is always "To CPU"
+#define RTL865X_ACLTBL_DROP_ALL		254		//This rule is always "Drop"
+#define RTL865X_ACLTBL_PERMIT_ALL	253		// This rule is always "Permit"
+#define RTL865X_ACLTBL_IPV6_TO_CPU	252
+#else
+#define RTL865X_ACLTBL_ALL_TO_CPU	127		// This rule is always "To CPU"
+#define RTL865X_ACLTBL_DROP_ALL		126		//This rule is always "Drop"
+#define RTL865X_ACLTBL_PERMIT_ALL	125		// This rule is always "Permit"
+#define RTL865X_ACLTBL_IPV6_TO_CPU	124
+#endif
+
+#define MAX_IFNAMESIZE 16
+#define NETIF_NUMBER 8
+
+/*invert flag*/
+#define RTL865X_INVERT_IN_NETIF		0x01
+#define RTL865X_INVERT_OUT_NETIF	0x02
+
+/*ingress or egress flag*/
+#define RTL865X_ACL_INGRESS		0 /*ingress acl*/
+#define RTL865X_ACL_EGRESS		1 /*egress acl*/
+
+#define RTL_DEV_NAME_NUM(name,num)	name#num
+
+#define RTL_BR_NAME "br0"
+#define RTL_WLAN_NAME "wlan"
+//flowing name in driver DO NOT duplicate
+#if defined(CONFIG_BRIDGE)
+#define RTL_DRV_LAN_NETIF_NAME "br0"
+#else
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define RTL_DRV_LAN_NETIF_NAME "eth1"
+#else
+#define RTL_DRV_LAN_NETIF_NAME "eth0"
+#endif
+#endif
+
+#ifdef CONFIG_RTK_VLAN_WAN_TAG_SUPPORT
+#define RTL_BR1_NAME		"br1"
+#define RTL_PS_BR1_DEV_NAME	RTL_BR1_NAME
+#define RTL_PS_ETH_NAME_ETH2	"eth2"
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define RTL_WAN_IDX			0
+#if defined(CONFIG_RTL_WAN_MAC5)
+#define RTL_LAN_IDX			0
+#else /* CONFIG_RTL_WAN_MAC5 */
+#define RTL_LAN_IDX			1
+#endif /* CONFIG_RTL_WAN_MAC5 */
+#define RTL_DRV_WAN0_NETIF_NAME	 "eth0"
+#else
+#define RTL_WAN_IDX			1
+#define RTL_LAN_IDX			0
+#define RTL_DRV_WAN0_NETIF_NAME "eth1"
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+#define RTL_DRV_WAN1_NETIF_NAME "eth6"
+#endif
+#define RTL_DRV_PPP_NETIF_NAME "ppp0"
+#define RTL_DRV_DSLT_NETIF_NAME "dslt"
+#define RTL_DRV_6RD_NETIF_NAME "6rd"
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+#if defined(CONFIG_RTL_CPU_TAG)
+#define RTL_DRV_LAN_P0_NETIF_NAME "eth4"
+#define RTL_DRV_LAN_P1_NETIF_NAME RTL_DRV_LAN_NETIF_NAME
+#define RTL_DRV_LAN_P2_NETIF_NAME "eth2"
+#define RTL_DRV_LAN_P3_NETIF_NAME "eth3"
+#define RTL_DRV_LAN_P5_NETIF_NAME RTL_DRV_WAN0_NETIF_NAME
+#else /* CONFIG_RTL_CPU_TAG */
+#define RTL_DRV_LAN_P0_NETIF_NAME "eth2"
+#define RTL_DRV_LAN_P1_NETIF_NAME "eth_none2"
+#define RTL_DRV_LAN_P2_NETIF_NAME "eth_none3"
+#define RTL_DRV_LAN_P3_NETIF_NAME "eth_none4"
+
+#define RTL_DRV_LAN_P4_NETIF_NAME RTL_DRV_WAN0_NETIF_NAME
+#if defined(CONFIG_RTL_WAN_MAC5)
+#define RTL_DRV_LAN_P5_NETIF_NAME RTL_DRV_WAN0_NETIF_NAME
+#else /* CONFIG_RTL_WAN_MAC5 */
+#define RTL_DRV_LAN_P5_NETIF_NAME RTL_DRV_LAN_NETIF_NAME
+#endif /* CONFIG_RTL_WAN_MAC5 */
+#endif /* CONFIG_RTL_CPU_TAG */
+
+#else /* CONFIG_RTL_MULTI_LAN_DEV */
+
+#if defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)
+#define RTL_DRV_LAN_P5_NETIF_NAME RTL_DRV_WAN0_NETIF_NAME
+#else /* CONFIG_RTL_2_RGMII_PORTS_ONLY */
+#define RTL_DRV_LAN_P4_NETIF_NAME RTL_DRV_WAN0_NETIF_NAME
+#endif /* CONFIG_RTL_2_RGMII_PORTS_ONLY */
+/* Ohter LAN ports use RTL_DRV_LAN_NETIF_NAME */
+
+#endif /* CONFIG_RTL_MULTI_LAN_DEV */
+
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#define RTL_DRV_LAN_P0_NETIF_NAME RTL_DRV_LAN_NETIF_NAME
+#define RTL_DRV_LAN_P1_NETIF_NAME "eth2"
+#define RTL_DRV_LAN_P2_NETIF_NAME "eth3"
+#define RTL_DRV_LAN_P3_NETIF_NAME "eth4"
+#define RTL_DRV_LAN_P4_NETIF_NAME RTL_DRV_WAN0_NETIF_NAME
+#define RTL_DRV_LAN_P5_NETIF_NAME "eth5"
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+#define RTL_DRV_LAN_P7_NETIF_NAME "eth7"
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+#define NETIF_SW_NUMBER		16
+#define RTL_BRIDGE_WANVLANID	7 /* WAN vid (bridged, default no vlan tag)*/
+#define LAN_DEV_NUM_MAX	14	//lan(4) + wlan0(5) + wlan1(5)
+
+#define ALIASNAME_PPP					"ppp"
+#define ALIASNAME_ETH_LAN				"eth0."
+#define ALIASNAME_ETH_WAN				"eth1."
+#define ALIASNAME_WLAN0_VA				"wlan0-va"
+#define ALIASNAME_WLAN1_VA				"wlan1-va"
+#define RTL_DRV_ETHLAN_P0_NETIF_NAME	"eth0"
+#define RTL_DRV_WLAN0_DEV_NAME			"wlan0"
+#define RTL_DRV_WLAN1_DEV_NAME			"wlan1"
+
+#define RTL_ETH_LAN0_BIND_MASK		(0x1<<0)
+#define RTL_ETH_LAN1_BIND_MASK		(0x1<<1)
+#define RTL_ETH_LAN2_BIND_MASK		(0x1<<2)
+#define RTL_ETH_LAN3_BIND_MASK		(0x1<<3)
+#define RTL_WLAN0_BIND_MASK			(0x1<<4)
+#define RTL_WLAN0_VA0_BIND_MASK		(0x1<<5)
+#define RTL_WLAN0_VA1_BIND_MASK		(0x1<<6)
+#define RTL_WLAN0_VA2_BIND_MASK		(0x1<<7)
+#define RTL_WLAN0_VA3_BIND_MASK		(0x1<<8)
+#define RTL_WLAN1_BIND_MASK			(0x1<<9)
+#define RTL_WLAN1_VA0_BIND_MASK		(0x1<<10)
+#define RTL_WLAN1_VA1_BIND_MASK		(0x1<<11)
+#define RTL_WLAN1_VA2_BIND_MASK		(0x1<<12)
+#define RTL_WLAN1_VA3_BIND_MASK		(0x1<<13)
+
+#define RTL_DRV_WLAN0_VA0_DEV_NAME	RTL_DEV_NAME_NUM(ALIASNAME_WLAN0_VA, 0)
+#define RTL_DRV_WLAN0_VA1_DEV_NAME	RTL_DEV_NAME_NUM(ALIASNAME_WLAN0_VA, 1)
+#define RTL_DRV_WLAN0_VA2_DEV_NAME	RTL_DEV_NAME_NUM(ALIASNAME_WLAN0_VA, 2)
+#define RTL_DRV_WLAN0_VA3_DEV_NAME	RTL_DEV_NAME_NUM(ALIASNAME_WLAN0_VA, 3)
+#define RTL_DRV_WLAN1_VA0_DEV_NAME	RTL_DEV_NAME_NUM(ALIASNAME_WLAN1_VA, 0)
+#define RTL_DRV_WLAN1_VA1_DEV_NAME	RTL_DEV_NAME_NUM(ALIASNAME_WLAN1_VA, 1)
+#define RTL_DRV_WLAN1_VA2_DEV_NAME	RTL_DEV_NAME_NUM(ALIASNAME_WLAN1_VA, 2)
+#define RTL_DRV_WLAN1_VA3_DEV_NAME	RTL_DEV_NAME_NUM(ALIASNAME_WLAN1_VA, 3)
+
+#define RTL_DRV_ETHLAN1_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_LAN,1)//"eth0.1"
+#define RTL_DRV_ETHLAN2_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_LAN,2)//"eth0.2"
+#define RTL_DRV_ETHLAN3_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_LAN,3)//"eth0.3"
+#define RTL_DRV_ETHLAN4_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_LAN,4)//"eth0.4"
+
+#define RTL_DRV_ETHWAN1_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_WAN,1)//"eth1.1"
+#define RTL_DRV_ETHWAN2_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_WAN,2)//"eth1.2"
+#define RTL_DRV_ETHWAN3_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_WAN,3)//"eth1.3"
+#define RTL_DRV_ETHWAN4_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_WAN,4)//"eth1.4"
+#define RTL_DRV_ETHWAN5_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_WAN,5)//"eth1.5"
+#define RTL_DRV_ETHWAN6_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_WAN,6)//"eth1.6"
+#define RTL_DRV_ETHWAN7_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_WAN,7)//"eth1.7"
+#define RTL_DRV_ETHWAN8_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_ETH_WAN,8)//"eth1.8"
+
+#define RTL_DRV_ETHWAN1_NETIF_NAME_EXTEND RTL_DEV_NAME_NUM(RTL_DRV_ETHWAN1_NETIF_NAME,B)//"eth1.1B"
+#define RTL_DRV_ETHWAN2_NETIF_NAME_EXTEND RTL_DEV_NAME_NUM(RTL_DRV_ETHWAN2_NETIF_NAME,B)//"eth1.2B"
+#define RTL_DRV_ETHWAN3_NETIF_NAME_EXTEND RTL_DEV_NAME_NUM(RTL_DRV_ETHWAN3_NETIF_NAME,B)//"eth1.3B"
+#define RTL_DRV_ETHWAN4_NETIF_NAME_EXTEND RTL_DEV_NAME_NUM(RTL_DRV_ETHWAN4_NETIF_NAME,B)//"eth1.4B"
+#define RTL_DRV_ETHWAN5_NETIF_NAME_EXTEND RTL_DEV_NAME_NUM(RTL_DRV_ETHWAN5_NETIF_NAME,B)//"eth1.5B"
+#define RTL_DRV_ETHWAN6_NETIF_NAME_EXTEND RTL_DEV_NAME_NUM(RTL_DRV_ETHWAN6_NETIF_NAME,B)//"eth1.6B"
+#define RTL_DRV_ETHWAN7_NETIF_NAME_EXTEND RTL_DEV_NAME_NUM(RTL_DRV_ETHWAN7_NETIF_NAME,B)//"eth1.7B"
+#define RTL_DRV_ETHWAN8_NETIF_NAME_EXTEND RTL_DEV_NAME_NUM(RTL_DRV_ETHWAN8_NETIF_NAME,B)//"eth1.8B"
+
+#define RTL_DRV_PPP0_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_PPP,0)//"ppp0"
+#define RTL_DRV_PPP1_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_PPP,1)//"ppp1"
+#define RTL_DRV_PPP2_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_PPP,2)//"ppp2"
+#define RTL_DRV_PPP3_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_PPP,3)//"ppp3"
+#define RTL_DRV_PPP4_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_PPP,4)//"ppp4"
+#define RTL_DRV_PPP5_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_PPP,5)//"ppp5"
+#define RTL_DRV_PPP6_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_PPP,6)//"ppp6"
+#define RTL_DRV_PPP7_NETIF_NAME RTL_DEV_NAME_NUM(ALIASNAME_PPP,7)//"ppp7"
+
+//#define CONFIG_RTL_MAC_BASED_NETIF	1
+
+#ifndef CONFIG_RTL_MAC_BASED_NETIF
+#define CONFIG_RTL_VLAN_BASED_NETIF 1
+#endif
+
+#if defined(CONFIG_RTL_MAC_BASED_NETIF)
+#define IF_FEATURE_IS_BRIDGE	0x00000001
+#endif
+
+#define RTL_CPU_PORT		8
+
+int rtl_get_bind_port_mask_by_dev_name(char *name);
+void rtl865x_get_master_netif_by_vid(int vid, char* netif_name);
+int32 rtl865x_netif_exist(char *ifName);
+int32 rtl865x_netif_is_wan(char *ifName);
+int32 rtl865x_netif_is_master(char *ifName);
+#endif
+
+
+/************************************
+*	const variable defination
+*************************************/
+#define	RTL_WANVLANID			8
+#define	RTL_LANVLANID			9
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+#define	RTL_WAN_1_VLANID		369
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+#if defined(CONFIG_RTL_CPU_TAG)
+//#define RTL_LANPORT_MASK_0		0x01	//port 0
+#define RTL_LANPORT_MASK_1		0x02	//port 1
+#define RTL_LANPORT_MASK_2		0x04	//port 2
+//#define RTL_LANPORT_MASK_3		0x08	//port 3
+
+#define RTL_WANPORT_MASK		0x20	//port 5
+#define RTL_DEF_LANPORT_MASK		0x106
+
+#else /* CONFIG_RTL_CPU_TAG */
+#define RTL_LANPORT_MASK_1		0x01	//port 0
+#define RTL_LANPORT_MASK_5		0x20	//port 5
+
+#define	RTL_WANPORT_MASK		0x10
+#if defined(CONFIG_RTL_WAN_MAC5)
+#define	RTL_DEF_LANPORT_MASK		0x120
+#else /* CONFIG_RTL_WAN_MAC5 */
+#define	RTL_DEF_LANPORT_MASK		0x121
+#endif /* CONFIG_RTL_WAN_MAC5 */
+#endif /* CONFIG_RTL_CPU_TAG */
+
+#else /* CONFIG_RTL_MULTI_LAN_DEV */
+#if defined(CONFIG_RTL_2_RGMII_PORTS_ONLY)
+#define RTL_WANPORT_MASK		0x20	//port 5
+#define RTL_DEF_LANPORT_MASK		0x101
+#else /* CONFIG_RTL_2_RGMII_PORTS_ONLY */
+#define RTL_WANPORT_MASK		0x10
+#define RTL_DEF_LANPORT_MASK		0x121
+#endif /* CONFIG_RTL_2_RGMII_PORTS_ONLY */
+#endif /* CONFIG_RTL_MULTI_LAN_DEV */
+
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL8196_RTL8366)
+	#define	RTL_WANPORT_MASK		0x1C1
+	#define	RTL_LANPORT_MASK		0x1C1
+	#define	RTL8366RB_GMIIPORT		0x20
+	#define	RTL8366RB_LANPORT		0xCf
+	#define	RTL8366RB_WANPORT		0x10
+#elif defined(CONFIG_RTL_819X) && (defined(CONFIG_RTK_VLAN_SUPPORT) || defined (CONFIG_RTL_MULTI_LAN_DEV) || defined(CONFIG_RTL_EXCHANGE_PORTMASK) || defined(CONFIG_AUTO_DHCP_CHECK) || defined(CONFIG_RTK_WLAN_EVENT_INDICATE) || defined(CONFIG_RTL_LINK_AGGREGATION))
+	#if defined(CONFIG_POCKET_ROUTER_SUPPORT)
+		#define	RTL_WANPORT_MASK		0x10
+		#define	RTL_LANPORT_MASK		0x10
+	#elif defined(CONFIG_RTL_PUBLIC_SSID)
+		#define RTL_WANPORT_MASK		0x110     //port 4/port 8
+		#define	RTL_LANPORT_MASK		0x10f
+	#elif defined(CONFIG_8198_PORT5_RGMII)
+		#define	RTL_WANPORT_MASK		0x10
+		#define	RTL_LANPORT_MASK		0x12f
+	#else
+		#if defined(CONFIG_RTL_8196C_iNIC)
+			#define	RTL_WANPORT_MASK		0x01
+			#define	RTL_LANPORT_MASK		0x110 //mark_inic , only port4 connect to MII
+		#elif defined (CONFIG_RTK_INBAND_HOST_HACK)
+			#if defined(CONFIG_8198_PORT5_GMII)
+			#define RTL_WANPORT_MASK		0x120  //port5 ,hack port,eth1
+			#define RTL_LANPORT_MASK		0x11f // 0~4 port eth0
+			#else
+			#define RTL_WANPORT_MASK		0x110  //port4(port0 in some board) is eth1
+			#define RTL_LANPORT_MASK		0x12f // 0 1 2 3 5  port are eth0
+			#endif
+		#elif defined(CONFIG_8198_PORT5_GMII)
+			#define RTL_WANPORT_MASK		0x10  //port0
+			#define RTL_LANPORT_MASK		0x12f //all port eth0
+		#elif defined (CONFIG_RTL_89xxD)
+			#define RTL_WANPORT_MASK		0x01  //port0
+			#define RTL_LANPORT_MASK		0x11e //all port eth0
+		#elif defined(CONFIG_RTL_AP_PACKAGE)
+			#define	RTL_WANPORT_MASK		0x00
+			#define	RTL_LANPORT_MASK		0x11f
+		#elif defined(CONFIG_RTL_EXCHANGE_PORTMASK)
+			//change wan port to port0
+			#define RTL_WANPORT_MASK		0x01 //port0
+			#define RTL_LANPORT_MASK		0x11e
+		#else
+			#if defined(CONFIG_RTL_LINK_AGGREGATION)
+			#define RTL_WANPORT_MASK		0x18 //port3 and port4 for wan, testcode
+			#define RTL_LANPORT_MASK		0x107 //port0/port1/port2 for lan, testcode
+			#else
+			#define	RTL_WANPORT_MASK		0x10
+			#ifdef CONFIG_8198C_8211FS
+				#define	RTL_LANPORT_MASK	0x12f
+			#else
+				#define	RTL_LANPORT_MASK	0x10f
+			#endif
+			#endif
+		#endif
+	#endif
+
+	#if defined(CONFIG_RTL_89xxD)
+		#define		RTL_LANPORT_MASK_1		0x2	//port 1
+		#define		RTL_LANPORT_MASK_2		0x4	//port 2
+		#define		RTL_LANPORT_MASK_3		0x8	//port 3
+		#define		RTL_LANPORT_MASK_4		0x10	//port 4
+	#else
+		#if defined(CONFIG_RTL_AP_PACKAGE)
+			#define		RTL_LANPORT_MASK_0		0x10	//port 4
+		#endif
+
+		#if defined(CONFIG_RTL_EXCHANGE_PORTMASK)
+			#define		RTL_LANPORT_MASK_1		0x10	//port 4
+			#define		RTL_LANPORT_MASK_2		0x8	//port 3
+			#define		RTL_LANPORT_MASK_3		0x4	//port 2
+			#define		RTL_LANPORT_MASK_4		0x2	//port 1
+		#else
+			#if defined(CONFIG_RTL_LINK_AGGREGATION)
+			#define		RTL_LANPORT_MASK_1		0x0 	//none
+			#define		RTL_LANPORT_MASK_2		0x4 	//port 2
+			#define		RTL_LANPORT_MASK_3		0x2 	//port 1
+			#define		RTL_LANPORT_MASK_4		0x1 	//port 0
+			#else
+			#define		RTL_LANPORT_MASK_1		0x8	//port 0
+			#define		RTL_LANPORT_MASK_2		0x4	//port 1
+			#define		RTL_LANPORT_MASK_3		0x2	//port 2
+			#ifdef CONFIG_8198C_8211FS
+			#define		RTL_LANPORT_MASK_4		0x21	//port 0 / port5
+			#else
+			#define		RTL_LANPORT_MASK_4		0x1	//port 3
+			#endif
+			#endif
+		#endif
+	#endif
+	#ifdef CONFIG_8198_PORT5_GMII
+	#define	RTL_LANPORT_MASK_5		0x20	//port 5
+	#endif
+#elif defined(CONFIG_RTL_8198_NFBI_BOARD)
+	#define	RTL_WANPORT_MASK		0x1e0	//port 5, port 6,port 7,port 8
+	#define	RTL_LANPORT_MASK		0x1df	//port 0~4 , port 6~8	 , need port4 ??
+#elif defined(CONFIG_8198_PORT5_GMII)
+	#define	RTL_WANPORT_MASK		0x110
+	#define	RTL_LANPORT_MASK		0x1ef
+#elif defined (CONFIG_POCKET_ROUTER_SUPPORT)
+	#define	RTL_WANPORT_MASK		0x10
+	#define	RTL_LANPORT_MASK		0x10
+#elif defined(CONFIG_RTL_PUBLIC_SSID)
+	#define RTL_WANPORT_MASK		0x110	//port 4/port 8
+
+#elif defined(CONFIG_RTL_819X)
+	#ifdef CONFIG_RTL_8196C_iNIC
+	#define RTL_WANPORT_MASK		0x01
+	#define RTL_LANPORT_MASK		0x110 //mark_inic , only port4 connect to MII
+	#elif defined(CONFIG_RTL_AP_PACKAGE)
+	#define	RTL_WANPORT_MASK		0x00
+	#define	RTL_LANPORT_MASK		0x11f
+	#elif defined(CONFIG_RTL_8198C_8367RB) || defined(CONFIG_RTL_8198C_8211F)
+	#define	RTL_WANPORT_MASK		0x01		/* port 0 as wan port */
+	#define	RTL_LANPORT_MASK		0x13e		/* port 1/2/3/4/5/cpu port(port 8) */
+	#else
+	#define	RTL_WANPORT_MASK		0x10
+		#ifdef CONFIG_8198C_8211FS
+		#define	RTL_LANPORT_MASK			0x12f
+		#else
+	#define	RTL_LANPORT_MASK		0x10f
+		#endif
+	#endif
+#else // should not happen
+	#define	RTL_WANPORT_MASK		0x01
+	#define	RTL_LANPORT_MASK		0x11e		/* port1/2/3/4/cpu port(port 8) */
+	#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined (CONFIG_RTL_MULTI_LAN_DEV)
+	#define	RTL_LANPORT_MASK_1		0x2		//port 1
+	#define	RTL_LANPORT_MASK_2		0x4		//port 2
+	#define	RTL_LANPORT_MASK_3		0x8		//port 3
+	#define	RTL_LANPORT_MASK_4		0x10	//port 4
+	#endif
+#endif
+
+#if defined(CONFIG_RTL_8881A) && defined(CONFIG_RTL_8211F_SUPPORT)
+#undef RTL_WANPORT_MASK
+#undef RTL_LANPORT_MASK
+#define	RTL_WANPORT_MASK		0x1
+#define	RTL_LANPORT_MASK		0x110
+#endif
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_MULTI_LAN_DEV)
+#if defined(CONFIG_RTL_CPU_TAG)
+#define ETH_INTF_NUM	6
+#else /* CONFIG_RTL_CPU_TAG */
+#if defined(CONFIG_RTL_WAN_MAC5)
+#define ETH_INTF_NUM	4
+#else /* CONFIG_RTL_WAN_MAC5 */
+#define ETH_INTF_NUM	6
+#endif /* CONFIG_RTL_WAN_MAC5 */
+#endif /* CONFIG_RTL_CPU_TAG */
+#else /* CONFIG_RTL_MULTI_LAN_DEV */
+#define ETH_INTF_NUM	5
+#endif /* CONFIG_RTL_MULTI_LAN_DEV */
+
+#else //defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined (CONFIG_RTL_MULTI_LAN_DEV)
+#if defined(CONFIG_8198_PORT5_GMII)
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+	#define ETH_INTF_NUM	7
+#else
+	#define ETH_INTF_NUM	6
+#endif
+#else
+#if defined(CONFIG_RTK_BRIDGE_VLAN_SUPPORT)
+	#define ETH_INTF_NUM	6
+#else
+	#define ETH_INTF_NUM	5
+#endif
+#endif
+#else
+#define ETH_INTF_NUM	2
+#endif
+#endif //defined(CONFIG_RTD_1295_HWNAT)
+
+typedef struct rtl865x_netif_s
+{
+	uint16	vid; /*netif->vid*/
+	uint16	mtu; /*netif's MTU*/
+	uint32	if_type:5; /*interface type, 0:ether,1:pppoe....*/
+	ether_addr_t macAddr;
+	uint32	is_wan:1, /*wan interface?*/
+			dmz:1,	/*DMZ/routing lan*/
+			is_slave:1; /*is slave interface?*/
+	uint8	name[MAX_IFNAMESIZE];
+	uint16	enableRoute;
+#if defined (CONFIG_RTL_LOCAL_PUBLIC) ||defined(CONFIG_RTL_MULTIPLE_WAN) ||defined(CONFIG_RTL_MAC_BASED_NETIF)
+	uint16	forMacBasedMCast;
+#endif
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	uint16	enableRouteV6;
+	uint16	mtuV6; /*netif's ipv6 MTU*/
+#endif
+}rtl865x_netif_t;
+/*internal...*/
+int32 _rtl865x_getAclFromAsic(int32 index, rtl865x_AclRule_t *rule);
+
+int32 rtl865x_init_acl(void);
+int32 rtl865x_reinit_acl(void);
+int32 rtl865x_add_acl(rtl865x_AclRule_t *rule, char *netifName, int32 chainNo);
+int32 rtl865x_del_acl(rtl865x_AclRule_t *rule, char *netifName, int32 chainNo);
+int32 rtl865x_regist_aclChain(char *netifName, int32 priority, uint32 flag);
+int32 rtl865x_unRegist_aclChain(char *netifName, int32 priority, uint32 flag);
+int32 rtl865x_flush_allAcl_fromChain(char *netifName, int32 priority, uint32 flag);
+int32 rtl865x_show_allAclChains(struct seq_file *s);
+rtl865x_AclRule_t* rtl865x_matched_layer4_aclChain(char *netifName,int32 priority, uint32 flag, rtl865x_AclRule_t *match);
+rtl865x_AclRule_t* rtl865x_matched_layer2_aclChain(char *netifName,int32 priority, uint32 flag, rtl865x_AclRule_t *match);
+//int32 rtl865x_add_def_permit_acl(void);
+//int32 rtl865x_del_def_permit_acl(void);
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+int32 rtl865x_enable_acl(uint32 enable);
+#endif
+int rtl865x_add_pattern_acl_for_contentFilter(rtl865x_AclRule_t *rule,char *netifName);
+int rtl865x_del_pattern_acl_for_contentFilter(rtl865x_AclRule_t *rule,char *netifName);
+
+
+#ifdef RTL_LAYERED_DRIVER_DEBUG
+int32 rtl865x_acl_test(int32 testNo);
+#endif
+
+#if defined(CONFIG_RTL_REDIRECT_ACL_SUPPORT_FOR_ISP_MULTI_WAN)
+#define CONFIG_RTL_AVOID_ADDING_WAN_SUBNET_PKT_TO_HW_NAT	1
+#endif
+
+//#define CONFIG_RTL_IPTABLES2ACL_PATCH 1
+#if defined(CONFIG_RTL_IPTABLES2ACL_PATCH)
+int32 rtl865x_add_sw_acl(rtl865x_AclRule_t *rule, char *netifName,int32 priority);
+int32 _rtl865x_synAclwithAsicTbl(void);
+int32 rtl865x_flush_allAcl_sw_fromChain(char *netifName, int32 priority, uint32 flag);
+#endif
+
+
+int32 rtl865x_deReferNetif(char *ifName);
+int32 rtl865x_referNetif(char *ifName);
+int32 rtl865x_setNetifMtu(rtl865x_netif_t *netif);
+int32 rtl865x_setNetifMac(rtl865x_netif_t *netif);
+int32 rtl865x_setNetifVid(char *name, uint16 vid);
+int32 rtl865x_setNetifType(char *name, uint32 ifType);
+int32 rtl865x_addNetif(rtl865x_netif_t *netif);
+int32 rtl865x_delNetif(char *ifName);
+int32 rtl865x_initNetifTable(void);
+int32 rtl865x_reinitNetifTable(void);
+int32 rtl865x_attachMasterNetif(char *slave, char *master);
+int32 rtl865x_detachMasterNetif(char *slave);
+
+int32 rtl865x_setPortToNetif(char *name,uint32 port);
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+int32 rtl865x_setNetifMtuV6(rtl865x_netif_t *netif);
+#endif
+
+#if defined(CONFIG_SWCONFIG) && defined(CONFIG_RTL_HARDWARE_NAT) && defined(CONFIG_OPENWRT_SDK)
+#define CONFIG_SWCONFIG_SUPPORT_HW_NAT 1
+#if defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+#define RTL_SWCONFIG_DRV_PPP_NETIF_NAME "pppoe-wan"
+extern int swconfig_vlan_enable;
+extern char hw_nat_wan_dev_name[MAX_IFNAMESIZE];
+extern uint8* rtl_get_netif_gmac(char *name);
+extern int rtl_check_default_router_valid(void);
+#endif
+#endif
+#if defined(CONFIG_RTL_HARDWARE_MULTICAST) || defined(CONFIG_SWCONFIG_SUPPORT_HW_NAT)
+int32 rtl865x_getNetifVid(char *name, uint32 *vid);
+int32 rtl865x_getNetifType(char *name,uint32 *type);
+uint32 rtl865x_getExternalPortMask(void);
+#endif
+
+#if defined (CONFIG_RTL_LOCAL_PUBLIC)
+//int32 rtl865x_getNetifFid(char *name, uint16 *fid);
+int32 rtl865x_addVirtualNetif(rtl865x_netif_t *netif);
+int32 rtl865x_delVirtualNetif(char *ifName);
+#endif
+
+int32 rtl865x_setDefACLForAllNetif(uint8 start_ingressAclIdx, uint8 end_ingressAclIdx,uint8 start_egressAclIdx,uint8 end_egressAclIdx);
+int32 rtl865x_reConfigDefaultAcl(char *ifName);
+int32 rtl865x_config_callback_for_get_drv_netifName(int (*fun)(const char *psName,char *netifName));
+#if defined(CONFIG_RTL_HARDWARE_IPV6_SUPPORT)
+void rtl_set_netif_v6_route(int enable);
+#endif
+#endif
+
diff --git a/include/net/rtl/rtl865x_outputQueue.h b/include/net/rtl/rtl865x_outputQueue.h
new file mode 100644
index 00000000..d71f84e
--- /dev/null
+++ b/include/net/rtl/rtl865x_outputQueue.h
@@ -0,0 +1,258 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef	RTL865X_OUTPUTQUEUE_H
+#define	RTL865X_OUTPUTQUEUE_H
+#include <linux/if.h>
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_OPENWRT_SDK)
+#include <linux/netdevice.h>
+#endif
+
+#if !defined(CONFIG_RTL_LAYERED_ASIC_DRIVER)
+#define	RTL865XC_MNQUEUE_OUTPUTQUEUE	1
+#define	RTL865XC_QOS_OUTPUTQUEUE	1
+
+typedef struct rtl865xC_outputQueuePara_s {
+
+	uint32 ifg;		/* default: Bandwidth Control Include/exclude Preamble & IFG */
+	uint32 gap;		/* default: Per Queue Physical Length Gap = 20 */
+	uint32 drop;		/* default: Descriptor Run Out Threshold = 500 */
+
+	uint32 systemSBFCOFF;	/*System shared buffer flow control turn off threshold */
+	uint32 systemSBFCON;	/*System shared buffer flow control turn on threshold */
+
+	uint32 systemFCOFF;	/* system flow control turn off threshold */
+	uint32 systemFCON;	/* system flow control turn on threshold */
+
+	uint32 portFCOFF;	/* port base flow control turn off threshold */
+	uint32 portFCON;	/* port base flow control turn on threshold */
+
+	uint32 queueDescFCOFF;	/* Queue-Descriptor=Based Flow Control turn off Threshold  */
+	uint32 queueDescFCON;	/* Queue-Descriptor=Based Flow Control turn on Threshold  */
+
+	uint32 queuePktFCOFF;	/* Queue-Packet=Based Flow Control turn off Threshold  */
+	uint32 queuePktFCON;	/* Queue-Packet=Based Flow Control turn on Threshold  */
+} rtl865xC_outputQueuePara_t;
+#endif
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && !defined(CONFIG_OPENWRT_SDK)
+#define CONFIG_RTL_HW_QOS_SP_PRIO	1
+#endif
+
+#define	MAX_QOS_RULE_NUM		10
+#if defined(CONFIG_OPENWRT_SDK)
+#define	MAX_MARK_NUM_PER_DEV		10
+#else
+/* #define	MAX_MARK_NUM_PER_DEV	5 */	/* Note: not include the default mark(0) and should be <= (hw queue number - 1(for default)) */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define	MAX_MARK_NUM_PER_DEV		8
+#else
+#define	MAX_MARK_NUM_PER_DEV		6
+#endif
+#endif
+#define	IPPROTO_ANY			256
+#define	IPPROTO_BOTH			257
+
+#define	QOS_DEF_QUEUE			0x4
+#define	QOS_VALID_MASK			0x2
+#define	QOS_TYPE_MASK			0x1
+#define	QOS_TYPE_STR			0x0	/*0x0|QOS_VALID_MASK */
+#define	QOS_TYPE_WFQ			0x1	/*0x1|QOS_VALID_MASK */
+
+#if defined CONFIG_RTL_8367_QOS_SUPPORT
+#define	EGRESS_BANDWIDTH_GRANULARITY		0xC00	/*      8*1024   */
+#define	EGRESS_BANDWIDTH_GRANULARITY_API	0x400
+#else
+#if defined(CONFIG_RTL_8197F)
+#define	EGRESS_BANDWIDTH_GRANULARITY		0x400	/*      1*1024   */
+#define	EGRESS_BANDWIDTH_GRANULARITY_BITMASK	0x3ff
+#else
+#define	EGRESS_BANDWIDTH_GRANULARITY		0x10000	/*      64*1024  */
+#define	EGRESS_BANDWIDTH_GRANULARITY_BITMASK	0xffff
+#endif
+#endif
+
+#if defined CONFIG_RTL_8367_QOS_SUPPORT
+#define	EGRESS_BANDWIDTH_GRANULARITY_BITLEN	13
+#define	EGRESS_BANDWIDTH_GRANULARITY_BYTELEN	(EGRESS_BANDWIDTH_GRANULARITY_BITLEN - 3)
+#define	INGRESS_BANDWIDTH_GRANULARITY_BITLEN	13
+#define	INGRESS_BANDWIDTH_GRANULARITY_BYTELEN	(INGRESS_BANDWIDTH_GRANULARITY_BITLEN - 3)
+#else
+#if defined(CONFIG_RTL_8197F)
+#define	EGRESS_BANDWIDTH_GRANULARITY_BITLEN	10
+#define	EGRESS_BANDWIDTH_GRANULARITY_BYTELEN	(EGRESS_BANDWIDTH_GRANULARITY_BITLEN - 3)
+#define	INGRESS_BANDWIDTH_GRANULARITY_BITLEN	10
+#define	INGRESS_BANDWIDTH_GRANULARITY_BYTELEN	(INGRESS_BANDWIDTH_GRANULARITY_BITLEN - 3)
+#else
+#define	EGRESS_BANDWIDTH_GRANULARITY_BITLEN	16
+#define	EGRESS_BANDWIDTH_GRANULARITY_BYTELEN	(EGRESS_BANDWIDTH_GRANULARITY_BITLEN - 3)
+#define	INGRESS_BANDWIDTH_GRANULARITY_BITLEN	14
+#define	INGRESS_BANDWIDTH_GRANULARITY_BYTELEN	(INGRESS_BANDWIDTH_GRANULARITY_BITLEN - 3)
+#endif
+#endif
+
+#define	EGRESS_WFQ_MAX_RATIO			0x80
+
+#if 0
+#define QOS_DEBUGP				printk
+#else
+#define QOS_DEBUGP(format, args...)
+#endif
+
+#if 0
+#define QOS_RULE_DEBUGP				printk
+#else
+#define QOS_RULE_DEBUGP(format, args...)
+#endif
+
+/* priority decision array index */
+enum PriDecIdx {
+	PORT_BASE = 0,
+	D1P_BASE,
+	DSCP_BASE,
+	ACL_BASE,
+	NAT_BASE,
+#if defined(CONFIG_RTL_8197F)
+	VID_BASE,
+#endif
+	PRI_TYPE_NUM,
+};
+
+typedef unsigned int bwu;
+
+typedef struct {
+	/*      classify        */
+	unsigned int protocol;
+	ipaddr_t local_ip_start;
+	ipaddr_t local_ip_end;
+	ipaddr_t remote_ip_start;
+	ipaddr_t remote_ip_end;
+	unsigned short lo_port_start;
+	unsigned short lo_port_end;
+	unsigned short re_port_start;
+	unsigned short re_port_end;
+
+	/*      tc      */
+	uint32 mark;
+	unsigned char prio;
+	unsigned char rate;
+} rtl865x_qos_entry_t, *rtl865x_qos_entry_p;
+
+typedef struct {
+	uint8 dscpRemark;
+	uint8 vlanPriRemark;
+	uint16 flags;
+
+	char ifname[IFNAMSIZ];
+	uint32 queueId;		/*      identify outputQueue    */
+	uint32 handle;
+
+	bwu ceil;
+	bwu burst;
+	bwu bandwidth;		/* average bandwidth, unit kbps */
+#if defined(CONFIG_RTL_HW_QOS_SP_PRIO) || defined(CONFIG_OPENWRT_SDK)
+	bwu prio;
+#endif
+} rtl865x_qos_t, *rtl865x_qos_p;
+
+typedef rtl865x_qos_entry_t QOS_T;
+typedef rtl865x_qos_entry_p QOS_Tp;
+
+typedef struct _rtl865x_qos_rule_t {
+	char inIfname[IFNAMSIZ];
+	char outIfname[IFNAMSIZ];
+	rtl865x_AclRule_t *rule;
+	uint32 mark;
+	uint32 handle;
+	struct _rtl865x_qos_rule_t *next;
+} rtl865x_qos_rule_t, *rtl865x_qos_rule_p;
+
+typedef struct {
+	uint32 mark;		/*      mark==0 means entry not used    */
+#if defined(CONFIG_OPENWRT_SDK)
+	uint32 mask;
+#endif
+	uint32 priority;
+	uint8 dscpRemark;
+	uint8 vlanpriRemark;
+} rtl_qos_mark_info_t, *rtl_qos_mark_info_p;
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_OPENWRT_SDK)
+
+typedef struct {
+	uint32 mark;		/*      mark==0 means entry not used    */
+	uint32 handle;
+} rtl_qos_mark2handl_info_t, *rtl_qos_mark2handle_info_p;
+
+#define RTL_MARK2HANDL_ADD_FLAG 	0x1
+#define RTL_MARK2HANDL_DEL_FLAG 	0x2
+#define RTL_MARK2HANDL_FLUSH_FLAG	0x4
+
+#define RTL_MARK2PRIO_FLUSH_FLAG 	0x4
+
+#endif
+
+int32 rtl865x_qosSetBandwidth(uint8 *netIfName, uint32 bps);
+int32 rtl865x_qosFlushBandwidth(uint8 *netIfName);
+int32 rtl865x_qosGetPriorityByHandle(uint8 *priority, uint32 handle);
+int32 rtl865x_qosProcessQueue(uint8 *netIfName, rtl865x_qos_t *qosInfo);
+int32 rtl865x_setRule2HandleMapping(uint32 ifIdx, uint32 idx, uint32 handle);
+int32 rtl865x_qosAddMarkRule(rtl865x_qos_rule_t *rule);
+int32 rtl865x_qosFlushMarkRule(void);
+int32 rtl865x_qosCheckNaptPriority(rtl865x_AclRule_t *qosRule);
+int32 rtl865x_closeQos(uint8 *netIfName);
+int32 rtl865x_registerQosCompFunc(int8 (*p_cmpFunc)(rtl865x_qos_t *entry1,
+	rtl865x_qos_t *entry2));
+int __init rtl865x_initOutputQueue(uint8 **netIfName);
+void __exit rtl865x_exitOutputQueue(void);
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_OPENWRT_SDK)
+void rtl865x_HwQosProcess(struct net_device *dev, int flag);
+#endif
+int32 rtl865x_qosArrangeRuleByNetif(void);
+
+#if defined(CONFIG_RTL_PROC_DEBUG)
+int32 rtl865x_show_allQosAcl(struct seq_file *s);
+#endif
+extern int32 rtl865x_qosArrangeRuleByNetif(void);
+int32 rtl_qosGetPriorityByMark(uint8 *netIfName, int32 mark);
+
+int32 rtl_qosGetPriorityByVid(int32 vid, int32 mark);
+
+#if defined(CONFIG_OPENWRT_SDK)
+int32 rtl_qosSetPriorityByMark(uint8 *netIfName, int32 mark, int32 handler,
+	int32 mask, int32 enable);
+#else
+int32 rtl_qosSetPriorityByMark(uint8 *netIfName, int32 mark, int32 handler,
+	int32 enable);
+
+#endif
+extern u8 netIfNameArray[NETIF_NUMBER][IFNAMSIZ];
+extern rtl865x_qos_rule_t *rtl865x_qosRuleHead;
+
+#if defined(CONFIG_RTK_QOS_FOR_CABLE_MODEM)
+void rtl_initQosForCableModem(void);
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT) && defined(CONFIG_RTL_QOS_PATCH)
+#define	DEF_QUEUE_NUM					1
+#define	MAX_QOS_PATCH_QUEUE_NUM	2
+void rtl865x_reinitOutputQueuePatchForQoS(uint32 qosEnabled);
+#endif
+
+#if defined(CONFIG_RTL_HW_QOS_SUPPORT)	/* sync from voip customer for multiple ppp */
+int32 rtl865x_qosFlushMarkRuleByDev(uint8 *netIfName);
+int32 rtl865x_qosRearrangeRule(void);
+#endif
+
+#if defined(CONFIG_OPENWRT_SDK)
+#define DEFAULT_PRIORITY_PATCH 1
+#endif
+
+#endif
diff --git a/include/net/rtl/rtl865x_ppp.h b/include/net/rtl/rtl865x_ppp.h
new file mode 100644
index 00000000..e8667d5
--- /dev/null
+++ b/include/net/rtl/rtl865x_ppp.h
@@ -0,0 +1,45 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2008
+* All rights reserved.
+*
+* Program : ppoe table driver
+* Abstract :
+* Author : hyking (hyking_liu@realsil.com.cn)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*/
+#ifndef	RTL865X_PPP_H
+#define	RTL865X_PPP_H
+
+#if 0				//!defined(REDUCE_MEMORY_SIZE_FOR_16M)
+#define REDUCE_MEMORY_SIZE_FOR_16M
+#endif
+
+#if defined(REDUCE_MEMORY_SIZE_FOR_16M)
+#define PPP_NUMBER	2
+#else
+#define PPP_NUMBER	8
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+#undef PPP_NUMBER
+#if defined(CONFIG_RTL_8198C)
+#define PPP_NUMBER	32
+#else
+#define PPP_NUMBER	8
+#endif
+#endif
+
+#define SESSION_TYPE_PPPOE			0x00
+#define SESSION_TYPE_PPTP			0x01
+#define SESSION_TYPE_L2TP			0x02
+
+int32 rtl865x_delPpp(uint32 sessionId);
+int32 rtl865x_delPppbyIfName(char *name);
+int32 rtl865x_addPpp(uint8 *ifname, ether_addr_t *mac, uint32 sessionId,
+	int32 type);
+
+#endif
diff --git a/include/net/rtl/rtl865x_route_api.h b/include/net/rtl/rtl865x_route_api.h
new file mode 100644
index 00000000..2c25cfe
--- /dev/null
+++ b/include/net/rtl/rtl865x_route_api.h
@@ -0,0 +1,29 @@
+
+/*
+ * * Copyright c                  Realtek Semiconductor Corporation, 2008
+ * * All rights reserved.
+ * *
+ * * Program : route table driver
+ * * Abstract :
+ * * Author : hyking (hyking_liu@realsil.com.cn)
+ * *
+ * * This program is free software; you can redistribute it and/or modify
+ * * it under the terms of the GNU General Public License as published by
+ * * the Free Software Foundation; either version 2 of the License, or
+ * * (at your option) any later version.
+ * */
+#ifndef RTL865X_ROUTE_API_H
+#define RTL865X_ROUTE_API_H
+
+#define RT_ASIC_ENTRY_NUM 8
+#define RT_DRV_ENTRY_NUM        8
+
+#define RT_MAX_ARP_SIZE 256
+
+int32 rtl865x_addRoute(ipaddr_t ipAddr, ipaddr_t ipMask, ipaddr_t nextHop, int8 * ifName,ipaddr_t srcIp);
+int32 rtl865x_delRoute(ipaddr_t ipAddr, ipaddr_t ipMask);
+#if defined(CONFIG_RTL_EXT_PORT_SUPPORT)
+int rtl865x_checkL3L2Valid(ipaddr_t ipAddr );
+#endif
+
+#endif
diff --git a/include/net/rtl/rtl_dnstrap.h b/include/net/rtl/rtl_dnstrap.h
new file mode 100644
index 00000000..df07446
--- /dev/null
+++ b/include/net/rtl/rtl_dnstrap.h
@@ -0,0 +1,40 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _RTL_DNS_TRAP_H
+#define _RTL_DNS_TRAP_H
+
+//#define DBG_DNS_TRAP
+
+#if defined(DBG_DNS_TRAP)
+	#define DBGP_DNS_TRAP(format, arg...) 	  \
+		do {printk(format , ## arg);}while(0)
+#else
+	#define DBGP_DNS_TRAP(format, arg...)
+#endif
+
+typedef struct _header {
+	unsigned short int	id;
+	unsigned short		u;
+
+	short int	qdcount;
+	short int	ancount;
+	short int	nscount;
+	short int	arcount;
+} dnsheader_t;
+
+extern int br_dns_filter_enter(struct sk_buff *skb);
+extern int is_dns_packet(struct sk_buff *skb);
+extern int dns_filter_enable;
+
+extern int br_dns_filter_init(void);
+extern void br_dns_filter_exit(void);
+
+
+#endif	/* _RTL_DNS_TRAP_H */
diff --git a/include/net/rtl/rtl_dot1x.h b/include/net/rtl/rtl_dot1x.h
new file mode 100644
index 00000000..2583ddb
--- /dev/null
+++ b/include/net/rtl/rtl_dot1x.h
@@ -0,0 +1,170 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef	RTL_DOT1X_H
+#define	RTL_DOT1X_H
+
+//#include "rtl865x_netif.h"
+//#define DOT1X_DEBUG
+
+#define DOT1X_AUTH_TYPE_PORT_BASED      1
+#define DOT1X_AUTH_TYPE_MAC_BASED       2
+
+#define DOT1X_AUTH_MODE_SNOOPING        1
+#define DOT1X_AUTH_MODE_PROXY       	2
+#define DOT1X_AUTH_MODE_CLIENT       	3
+
+#define DOT1X_EAPOL_TYPE_EAP_PACKET         0x00
+#define DOT1X_EAPOL_TYPE_START              0x01
+#define DOT1X_EAPOL_TYPE_LOGOFF             0x02
+#define DOT1X_EAPOL_TYPE_EAP_REQUEST        0x03
+#define DOT1X_EAPOL_TYPE_EAP_RESPONSE       0x04
+#define DOT1X_EAPOL_TYPE_EAP_SUCCESS        0x05
+#define DOT1X_EAPOL_TYPE_EAP_FAILURE        0x06
+
+#define DOT1X_EAPOL_PACKET_CODE_REQUEST      0x1
+#define DOT1X_EAPOL_PACKET_CODE_RESPONSE     0x2
+#define DOT1X_EAPOL_PACKET_CODE_SUCCESS      0x3
+#define DOT1X_EAPOL_PACKET_CODE_FAILURE      0x4
+
+#define DOT1X_EAPOL_PACKET_TYPE_OFFSET		 3
+#define DOT1X_EAPOL_PACKET_CODE_OFFSET		 6
+#define DOT1X_EAPOL_PACKET_ID_OFFSET		 7
+
+#define DOT1X_AUTH_STATE_UNAUTH              0x00
+#define DOT1X_AUTH_STATE_START               0x01
+#define DOT1X_AUTH_STATE_PROCESSING          0x02
+#define DOT1X_AUTH_STATE_SUCCESS             0x03
+
+#define DOT1X_AUTH_TIME_OUT                  (5*60)
+
+#define DOT1X_CONSUME_PKT                    1
+#define DOT1X_DROP_PKT                       2
+
+#define	DOT1X_TABLE_LIST_MAX	256
+#define	DOT1X_TABLE_ENTRY_MAX	256
+
+#define	DOT1X_TABLE_ENTRY_VALID	  0xff
+#define	DOT1X_TABLE_ENTRY_INVALID 0x00
+
+#define DOT1X_EVENT_EAP_PACKET	  0x01
+#define DOT1X_EVENT_PORT_DOWN	  0x02
+#define DOT1X_EVENT_PORT_UP	  0x03
+
+#define DOT1X_MAX_QUEUE_SIZE	8
+#define DOT1X_MAX_DATA_LEN		1560
+#define DOT1X_MAX_EAP_PACKET_LEN 1550
+#define DOT1X_ERROR_2LARGE	-1
+#define DOT1X_ERROR_QFULL	-2
+#define DOT1X_ERROR_QEMPTY	-3
+#define DOT1X_ERROR_ERROR	-4
+
+#define DOT1X_SPECIAL_IDENTITY 0xaabb
+
+
+typedef struct __rtl802Dot1xPortMode
+{
+		uint8           port_enable;
+		/* auth_dir:
+		0= BOTH direction. (control for the packets that
+		"incoming from" or "expect outgoing from" this port .)
+		1= IN direction. (control for the packets that "incoming from" this port .)
+		*/
+		uint8 			auth_dir;
+		uint8		    auth_mode;
+}rtl802Dot1xPortMode;
+
+typedef	struct __rtl802Dot1xConfig
+{
+	int8		server_port;
+	uint8		enable;
+	uint8		type; /* 1:port based/2:mac based */
+	/* only valid in proxy mode  or snooping mode???
+	  * 0:authenticator response EAP packet's destination MAC address as multicast
+	  * 1:authenticator response EAP packet's destination MAC address as unicast
+	  */
+	uint8       enable_unicastresp;
+    /*mode
+    	  *1:snooping mode-->transparent forward eapol packets
+    	  *2:repeater mode -->normal 1x auth flow client<->DUT(auth deamon) <->server
+    	  *3:client mode-->act as supplicant
+    	  */
+	rtl802Dot1xPortMode	mode[RTL8651_PORT_NUMBER];
+}rtl802Dot1xConfig;
+#if 0
+typedef struct __rtl802Dot1xPortBasedInfo
+{
+    uint8 portAuthEnable;
+    int8  portNum;
+    uint8 authState;
+    uint8 authOpdir;
+    uint8 macaddr[ETH_ALEN];
+    struct timer_list expire_timer;
+}rtl802Dot1xPortBasedInfo;
+#endif
+
+/* ---start---used for snooping mode ---start---*/
+typedef struct __rtl802Dot1xCacheEntry
+{
+	uint32 id;
+	uint8  rx_port_num;
+    uint8 auth_state;
+    uint8 mac_addr[ETH_ALEN];
+	uint8 valid;
+	CTAILQ_ENTRY(__rtl802Dot1xCacheEntry) cache_link;
+	CTAILQ_ENTRY(__rtl802Dot1xCacheEntry) tqe_link;
+}rtl802Dot1xCacheEntry;
+typedef struct __rtl802Dot1xCacheTable
+{
+	CTAILQ_HEAD(__rtl802Dot1xCacheListEntryHead, __rtl802Dot1xCacheEntry) *list;
+}rtl802Dot1xCacheTable;
+
+/* ---end---used for snooping mode ---end---*/
+
+/* ---start---used for repeater mode/client mode ---start---*/
+typedef struct __rtl802Dot1xPortStateInfo
+{
+		uint8	event_id;
+		int8	flag; /* more packets flag */
+		uint32	port_mask;/* Bit0 = port0, Bit0=1 means down and so on */
+}rtl802Dot1xPortStateInfo;
+
+typedef struct __rtl802Dot1xEapPkt
+{
+		uint8   event_id;
+		int8	flag; /* more packets flag */
+		uint8	rx_port_num;
+        int16	item_size;
+        uint8	item[DOT1X_MAX_EAP_PACKET_LEN];
+}rtl802Dot1xEapPkt;
+
+typedef struct __rtl802Dot1xQueueNode
+{
+        int16	item_size;
+        uint8	item[DOT1X_MAX_DATA_LEN];
+}rtl802Dot1xQueueNode;
+
+typedef struct __rtl802Dot1xQueue
+{
+        int32     head;
+        int32     tail;
+        int32     item_num;
+        int32     max_item;
+    	rtl802Dot1xQueueNode item_array[DOT1X_MAX_QUEUE_SIZE];
+}rtl802Dot1xQueue;
+
+typedef struct __rtl802Dot1xAuthResult
+{
+		uint8     type; /* 1:port base result/2:mac base result */
+        uint8     port_num;
+        int8      auth_state;
+		uint8     mac_addr[ETH_ALEN];
+}rtl802Dot1xAuthResult;
+/* ---end---used for repeater mode/client mode ---end---*/
+#endif
diff --git a/include/net/rtl/rtl_glue.h b/include/net/rtl/rtl_glue.h
new file mode 100644
index 00000000..752bb45
--- /dev/null
+++ b/include/net/rtl/rtl_glue.h
@@ -0,0 +1,258 @@
+/*
+* --------------------------------------------------------------------
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* Program : rtl_glue.h
+* Abstract :Header of porting layer
+* Author	: Edward Jin-Ru Chen
+*
+* $Id: rtl_glue.h,v 1.3 2008/04/11 10:12:38 bo_zhao Exp $
+* $Log: rtl_glue.h,v $
+* Revision 1.3  2008/04/11 10:12:38  bo_zhao
+* *: swap nic drive to 8186 style
+*
+* Revision 1.2  2008/01/18 02:50:16  alva_zhang
+* *: refine function define to pass the gcc-3.4 compiling
+*
+* Revision 1.1  2007/12/21 10:29:52  davidhsu
+* +: support nic driver
+*
+* Revision 1.35  2007/07/03 05:53:51  qy_wang
+* *:add rtl8316s model core
+*
+* Revision 1.34  2007/06/07 05:35:30  chenyl
+* +: add new function "rtlglue_clearDCache" to clear D-cache without
+*    writing back to external memory. ( Only for Processor with this function )
+*
+* Revision 1.33  2007/06/01 09:20:52  michaelhuang
+* -: removed the rtl867x compiler flag.
+*
+* Revision 1.32  2007/04/09 14:14:01  michaelhuang
+* +: added rtlglue_read() function
+*
+* Revision 1.31  2007/03/02 13:31:59  chenyl
+* *: enable range based D-cache flush function.
+*
+* Revision 1.30  2007/01/09 02:36:08  michaelhuang
+* *: Prepare implement test module for RTL8672
+*
+* Revision 1.29  2006/12/21 06:57:00  yjlou
+* -: remove the following usages:
+*    printk
+*    printfByPolling
+*
+* Revision 1.28  2006/11/28 02:15:14  hyking_liu
+* *: Mofify function related with usrDefineTunnel
+*
+* Revision 1.27  2006/11/21 12:28:35  chenyl
+* *: rearrange some code
+* *: bug fix - Src VLAN decision
+* *: bug fix - D-cache invalidation for FAST extension device forwarding
+* *: bug fix - m_unused1 and ph_reserved are needed for FAST extension device forwarding
+*
+* Revision 1.26  2006/10/26 02:15:32  qy_wang
+* *:remove the inculed file net_device.h in rtl8651_layer2fwd.c
+*
+* Revision 1.25  2006/10/25 07:10:15  qy_wang
+* +:add a function to block extension device when link up
+*
+* Revision 1.24  2006/08/31 15:44:48  chenyl
+* *: add some declarations of external APIs
+*
+* Revision 1.23  2006/07/13 15:55:49  chenyl
+* *: modify code for RTL865XC driver compilation.
+* *: dos2unix process
+*
+* Revision 1.22  2006/06/20 05:53:22  brian_bin
+* +: brian_bin move open, write, close declaration into __RTL_GLUE__ define brace
+*
+* Revision 1.21  2006/01/12 08:32:37  brian_bin
+* +: brian_bin add kernel system call of file operations
+*
+* Revision 1.20  2006/01/02 02:52:14  chenyl
+* +: VLAN-tag support extension port forwarding and software Rome Driver forwarding.
+*
+* Revision 1.19  2005/09/16 11:34:48  tony
+* *: bug fixed: support kernel space swNic model code for RTL865XC.
+*
+* Revision 1.18  2005/09/06 02:36:38  yjlou
+* +: add random and time glue functions.
+*
+* Revision 1.17  2005/07/20 15:29:38  yjlou
+* +: porting Model Code to Linux Kernel: check RTL865X_MODEL_KERNEL.
+*
+* Revision 1.16  2005/07/01 09:34:41  yjlou
+* *: porting swNic2.c into model code.
+*
+* Revision 1.15  2005/06/19 05:41:19  yjlou
+* *: merge ASIC driver into model code.
+*
+* Revision 1.14  2005/06/07 15:00:57  chenyl
+* *: modify mutex Lock / Unlock code to check the balance of Lock/Unlock function call
+*
+* Revision 1.13  2004/11/29 07:35:44  chenyl
+* *: fix bug : multiple-PPPoE MTU setting bug
+* *: fix bug : Never add second session's ip into ASIC in multiple-PPPoE WAN type.
+* *: fix bug : Tunekey abnormal behavior when multiple-PPPoE Dial-on-demand Dynamically turn ON/OFF
+* *: in forwarding engine Init function, the parameter == 0xffffffff means user want to set as default value
+* *: add Mutex-Lock/Unlock checking in testing code
+*
+* Revision 1.12  2004/11/05 09:54:08  yjlou
+* +: support more precise timeUpdate() function.
+*   +: add EVENT_TRIGGER_TIMEUPDATE==2
+*   *: modify #ifdef EVENT_TRIGGER_TIMEUPDATE
+*
+* Revision 1.11  2004/07/27 10:47:08  cfliu
+* -: Remove RTL865x external loopback port related code for PPTP/L2TP/WLAN
+*
+* Revision 1.10  2004/06/23 08:11:55  yjlou
+* *: change the declaration of rtlglue_getmstime()
+*
+* Revision 1.9  2004/05/03 14:56:18  cfliu
+* Add 8650B extension port support.
+* Revise all WLAN/extport related code.
+*
+* Revision 1.8  2004/05/03 02:53:03  chenyl
+* *: swNic_getRingSize -> rtlglue_getRingSize and move it from swNic2.c to rtl_glue.c
+* *: set default upstream ip to 0 if we config interface to dhcp
+*
+* Revision 1.7  2004/04/30 08:58:08  chenyl
+* +: ip multicast/igmp proxy
+*
+* Revision 1.6  2004/04/08 12:11:20  cfliu
+* Change extension port API.....define rtlglue_extDeviceSend()
+*
+* Revision 1.5  2004/03/31 09:37:01  cfliu
+* Add WDS support
+*
+* Revision 1.4  2004/03/19 13:13:35  cfliu
+* Reorganize ROME driver local header files. Put all private data structures into different .h file corrsponding to its layering
+* Rename printf, printk, malloc, free with rtlglue_XXX prefix
+*
+* Revision 1.1  2004/03/10 11:42:36  cfliu
+* Move rtl_glue.* from rtl865x/
+*
+* Revision 1.2  2004/03/03 10:40:38  yjlou
+* *: commit for mergence the difference in rtl86xx_tbl/ since 2004/02/26.
+*
+* Revision 1.1  2004/02/25 14:26:33  chhuang
+* *** empty log message ***
+*
+* Revision 1.2  2004/02/25 14:24:52  chhuang
+* *** empty log message ***
+*
+* Revision 1.7  2004/02/24 04:15:43  cfliu
+* add API for WLAN acceleration
+*
+* Revision 1.6  2004/02/18 13:54:37  chhuang
+* *** empty log message ***
+*
+* Revision 1.5  2003/12/26 09:27:50  orlando
+* add rtl_glue.h
+*
+* Revision 1.3  2003/09/30 06:07:50  orlando
+* check in RTL8651BLDRV_V20_20030930
+*
+* Revision 1.4  2003/06/10 05:33:30  cfliu
+* Remove rtl8651_tblDrvFwdSend registration.
+* Add rtlglue_drvSend to replace rtl8651_tblDrvFwdSend function pointer
+*
+* Revision 1.3  2003/06/09 04:48:43  cfliu
+* add 3 OS dependent glue functions to support mbuf external cluster allocation.
+* Rewrite all help messages using Autoduck's syntax so documentation could generated automatically.
+*
+* Revision 1.2  2003/05/23 07:47:06  cfliu
+* Extract porting function and fix compile warning.
+*
+* Revision 1.1  2003/05/23 04:55:25  jzchen
+* Add rtl glue to solve porting issue
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+*/
+
+#ifndef RTL_GLUE_H
+#define RTL_GLUE_H
+
+/*	@doc RTLGLUE_API
+
+	@module rtl_glue.h - Glue interface for Realtek 8651 Home gateway controller driver	|
+	This guide documents the glue interface for porting 8651 driver to targeted operating system
+	@normal Chun-Feng Liu (cfliu@realtek.com.tw) <date>
+
+	Copyright <cp>2003 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.
+
+ 	@head3 List of Symbols |
+ 	Here is the list of all functions and variables in this module.
+
+ 	@index | RTLGLUE_API
+*/
+#include <linux/semaphore.h>
+#include <linux/spinlock.h>
+#include <linux/slab.h>
+
+#define RTL_DECLARE_MUTEX(name) 		DECLARE_MUTEX(name)
+
+//int rtl_down_interruptible(struct semaphore * sem);
+//void rtl_up(struct semaphore * sem);
+//
+#ifndef RTL865X_DEBUG
+#define assert(expr) do {} while (0)
+#else
+#define assert(expr) \
+        if(!(expr)) {                                   \
+        printk( "\033[33;41m%s:%d: assert(%s)\033[m\n", \
+        __FILE__,__LINE__,#expr);               \
+        }
+#endif
+
+#define RTL_BUG(cause) \
+        do { printk(" [= !! BUG !! =] at %s line %d\n\t=> Cause: \
+        %s\n\t=>-- system Halt\n", __FUNCTION__, __LINE__, cause); while(1);} while (0)
+
+#define TBL_MEM_ALLOC(tbl, type, size)   \
+        { \
+        (tbl) = (type *)kmalloc((size) * sizeof(type),GFP_ATOMIC); \
+                if(!(tbl)){\
+                        printk("MEM alloc failed at line %d\n", __LINE__);\
+                        while(1);\
+                        return FAILED;\
+                }\
+        }
+
+#ifndef bzero
+	#define bzero( p, s ) memset( p, 0, s )
+#endif
+
+#define	RTL_NIC_LOCK_INIT(__rtl_lock__)		spin_lock_init(&__rtl_lock__)
+#define	RTL_NIC_LOCK(__rtl_lock__)			spin_lock(&__rtl_lock__)
+#define	RTL_NIC_UNLOCK(__rtl_lock__)		spin_unlock(&__rtl_lock__)
+
+static inline int rtl_down_interruptible(struct semaphore * sem)
+{
+        return down_interruptible(sem);
+}
+
+static inline void rtl_up(struct semaphore * sem)
+{
+        up(sem);
+}
+
+static inline void *rtl_malloc(size_t NBYTES)
+{
+	if(NBYTES==0) return NULL;
+		return (void *)kmalloc(NBYTES,GFP_ATOMIC);
+}
+
+static inline void rtl_free(void *APTR)
+{
+	kfree(APTR);
+}
+
+void memDump (void *start, uint32 size, int8 * strHeader);
+
+#endif
diff --git a/include/net/rtl/rtl_multi_wan.h b/include/net/rtl/rtl_multi_wan.h
new file mode 100644
index 00000000..646339c
--- /dev/null
+++ b/include/net/rtl/rtl_multi_wan.h
@@ -0,0 +1,123 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _RTL_MULTI_WAN_H_
+#define _RTL_MULTI_WAN_H_
+
+#include <linux/netdevice.h>
+#include <linux/skbuff.h>
+#include <linux/version.h>
+
+/* found in socket.c */
+extern void smux_ioctl_set(int (*hook)(void __user *));
+extern int rtl_get_vid_of_smux_dev(char *name);
+extern int rtl_smux_upstream_port_mapping_check(struct sk_buff *skb);
+extern int rtl_smux_downstream_port_mapping_check(struct sk_buff *skb);
+extern struct net_device * rtl_get_smux_dev(struct sk_buff *skb);
+extern unsigned int rtl_get_member_of_smux_dev_by_vid(unsigned int vid);
+
+
+#ifndef VLAN_VID_MASK
+#define VLAN_VID_MASK	0xfff
+#endif
+#define VLAN_1P_MASK 	0xe000
+
+
+/* smux device info in net_device. */
+struct smux_dev_info {
+	struct smux_group *smux_grp;
+	struct net_device *vdev;
+	struct net_device_stats stats;
+	int    proto;
+	int    vid;		/* -1 means vlan disable */
+	int    napt;
+	int    brpppoe;
+	unsigned int    m_1p;
+	unsigned int    member;	/* for port mapping */
+	struct list_head  list;
+
+#ifdef CONFIG_PORT_MIRROR
+	int port_mirror;
+	struct net_device* mirror_dev;
+
+#define OUT_MIR_MASK			0x1
+#define IN_MIR_MASK			0x2
+#define OUT_NEED_MIR(val) ((val)  & (OUT_MIR_MASK))
+#define IN_NEED_MIR(val)  ((val)  & (IN_MIR_MASK))
+
+#endif
+#ifdef CONFIG_RTL_IGMP_PROXY_MULTIWAN
+	int igmpproxy_enable;
+	int on_phy;
+#endif
+};
+
+/* represents a group of smux devices */
+struct smux_group {
+	struct net_device	*real_dev;
+	struct list_head	smux_grp_devs;
+	struct list_head	virtual_devs;
+};
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,4,0)
+#define SMUX_DEV_INFO(x) ((struct smux_dev_info *)(netdev_priv(x)))
+#else
+#define SMUX_DEV_INFO(x) ((struct smux_dev_info *)(x->priv))
+#endif
+
+/* inline functions */
+
+static inline struct net_device_stats *smux_dev_get_stats(struct net_device *dev)
+{
+	return &(SMUX_DEV_INFO(dev)->stats);
+}
+
+/* SMUX IOCTLs are found in sockios.h */
+
+/* Passed in smux_ioctl_args structure to determine behaviour. Should be same as busybox/networking/smuxctl.c  */
+enum smux_ioctl_cmds {
+	ADD_SMUX_CMD,
+	REM_SMUX_CMD,
+};
+
+enum smux_proto_types {
+	SMUX_PROTO_PPPOE,
+	SMUX_PROTO_IPOE,
+	SMUX_PROTO_BRIDGE
+};
+
+/*
+ * for vlan device, smux dev name is nas0.VID, others' name is nas0_No
+ */
+struct smux_ioctl_args {
+	int cmd; /* Should be one of the smux_ioctl_cmds enum above. */
+	int proto;
+	int vid; /* vid==-1 means vlan disabled on this dev. */
+	int napt;
+	int brpppoe;
+	char ifname[IFNAMSIZ];
+	union {
+		char ifname[IFNAMSIZ]; /* smux device info */
+	} u;
+#ifdef CONFIG_RTL_IGMP_PROXY_MULTIWAN
+	int igmpproxy_enable;
+	int on_phy;
+#endif
+};
+#define rsmux_ifname	ifname
+#define osmux_ifname	u.ifname
+
+static inline void TOKEN_NUM(char *inputStr, int *outInt)
+{
+	*outInt = inputStr[strlen(inputStr)-1]-'0';
+	// printk("port :%d\n",*outInt);
+}
+
+#endif /* _RTL_MULTI_WAN_H_ */
+
diff --git a/include/net/rtl/rtl_nic.h b/include/net/rtl/rtl_nic.h
new file mode 100644
index 00000000..35cb54a
--- /dev/null
+++ b/include/net/rtl/rtl_nic.h
@@ -0,0 +1,435 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef	RTL_NIC_H
+#define	RTL_NIC_H
+
+#ifdef CONFIG_RTL_STP
+#include <net/rtl/rtk_stp.h>
+#endif
+
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+#include <linux/interrupt.h>
+#endif
+#include "rtl865x_netif.h"
+/************************************
+*	feature enable/disable
+*************************************/
+#define RX_TASKLET	1
+#define TX_TASKLET	1
+#define LINK_TASKLET 1
+#define RTL819X_PRIV_IOCTL_ENABLE 1	/* mark_add */
+#define CONFIG_RTL_PHY_PATCH		1
+#define RTK_QUE			1
+#if defined(CONFIG_NET_WIRELESS_AGN) || defined(CONFIG_RTL8192SE) ||\
+	defined(CONFIG_RTL8192CD) || defined(CONFIG_RTL8192CD_MODULE) ||\
+	(defined(CONFIG_RTD_1295_HWNAT) && defined(CONFIG_RTL_BR_SHORTCUT))
+
+#if !defined(CONFIG_RTL_NO_BR_SHORTCUT)
+#if !defined(CONFIG_RTL_FASTBRIDGE)	/* &&!defined(CONFIG_RPS) */
+#define BR_SHORTCUT         1
+#endif
+#endif
+
+#endif
+#if defined(CONFIG_RTD_1295_HWNAT) && defined(CONFIG_RTL_BR_SHORTCUT)
+#define CONFIG_WIRELESS_LAN_MODULE
+#endif /* CONFIG_RTD_1295_HWNAT && CONFIG_RTL_BR_SHORTCUT */
+
+/*
+*#define	CONFIG_RTL_MULTI_LAN_DEV	1
+*/
+
+#if defined(CONFIG_RTL_TSO)
+#define CONFIG_RTL_ETH_NAPI_SUPPORT 1
+#endif /* CONFIG_RTL_TSO */
+
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+#define CONFIG_RTL_ETH_NAPI_GRO_SUPPORT 1
+#endif
+
+#if defined(CONFIG_POCKET_AP_SUPPORT)
+#define	CONFIG_POCKET_ROUTER_SUPPORT
+#endif
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+#if defined(CONFIG_RTL_819X)
+#define MAX_ETH_SKB_NUM	(\
+			NUM_RX_PKTHDR_DESC \
+			+ NUM_RX_PKTHDR_DESC1 \
+			+ NUM_RX_PKTHDR_DESC2 \
+			+ NUM_RX_PKTHDR_DESC3 \
+			+ NUM_RX_PKTHDR_DESC4 \
+			+ NUM_RX_PKTHDR_DESC5 \
+			+ MAX_PRE_ALLOC_RX_SKB + 128)
+#else
+#define MAX_ETH_SKB_NUM	(\
+			NUM_RX_PKTHDR_DESC \
+			+ NUM_RX_PKTHDR_DESC1 \
+			+ NUM_RX_PKTHDR_DESC2 \
+			+ NUM_RX_PKTHDR_DESC3 \
+			+ NUM_RX_PKTHDR_DESC4 \
+			+ NUM_RX_PKTHDR_DESC5 \
+			+ MAX_PRE_ALLOC_RX_SKB + 256)
+#endif
+
+#include <linux/version.h>
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 36)
+#define ETH_SKB_BUF_SIZE	(SKB_DATA_ALIGN(CROSS_LAN_MBUF_LEN+sizeof(struct skb_shared_info)+160+RTL_NET_SKB_PAD))
+#else
+#define ETH_SKB_BUF_SIZE	(SKB_DATA_ALIGN(CROSS_LAN_MBUF_LEN+sizeof(struct skb_shared_info)+160+NET_SKB_PAD))
+#endif
+#define ETH_MAGIC_CODE		"819X"
+#define ETH_MAGIC_LEN		4
+#endif
+
+struct re865x_priv {
+	u16 ready;
+	u16 addIF;
+	u16 devnum;
+	u32 sec_count;
+	u32 sec;
+#if defined(CONFIG_RTD_1295_HWNAT)
+	struct net_device *dev[ETH_INTF_NUM];
+	struct platform_device *plat_dev;
+#else				/* CONFIG_RTD_1295_HWNAT */
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_MULTI_LAN_DEV)
+	struct net_device *dev[ETH_INTF_NUM];
+#else
+	struct net_device *dev[ETH_INTF_NUM];
+#endif
+#endif				/* defined(CONFIG_RTD_1295_HWNAT) */
+#if 0				/* def CONFIG_RTL_STP */
+	struct net_device *stp_port[MAX_RE865X_STP_PORT];
+#endif
+#if defined(CONFIG_RTL_CUSTOM_PASSTHRU)
+	struct net_device *pdev;
+#endif
+	/* spinlock_t            lock; */
+	void *regs;
+	struct tasklet_struct rx_tasklet;
+	struct timer_list timer;	/* Media monitoring timer. */
+	unsigned long linkchg;
+};
+
+struct dev_priv {
+	u32 id;			/* VLAN id, not vlan index */
+	u32 portmask;		/* member port mask */
+	u32 portnum;		/* number of member ports */
+	u32 netinit;
+	struct net_device *dev;
+	struct net_device *dev_prev;
+	struct net_device *dev_next;
+#if defined(CONFIG_RTD_1295_HWNAT)
+	struct platform_device *plat_dev;
+	struct work_struct link_event_work;
+	u32 link_event;
+#endif				/* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(RX_TASKLET) || defined(CONFIG_RTL_ETH_NAPI_GRO_SUPPORT)
+	struct tasklet_struct rx_dsr_tasklet;
+#endif
+#if defined(CONFIG_RTL_ETH_NAPI_SUPPORT)
+	struct napi_struct napi;
+#endif
+
+#ifdef TX_TASKLET
+	struct tasklet_struct tx_dsr_tasklet;
+#endif
+
+	struct tasklet_struct link_dsr_tasklet;
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT)
+	struct vlan_info vlan_setting;
+#endif
+
+#ifdef CP_VLAN_TAG_USED
+	struct vlan_group *vlgrp;
+#endif
+	spinlock_t lock;
+	u32 msg_enable;
+	u32 opened;
+	u32 irq_owner;		/* record which dev request IRQ */
+	struct net_device_stats net_stats;
+#if defined(DYNAMIC_ADJUST_TASKLET) || defined(BR_SHORTCUT) || defined(CONFIG_RTL8196C_REVISION_B) || defined(CONFIG_RTL_8198) || defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E) || defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+	struct timer_list expire_timer;
+#endif
+
+#ifdef CONFIG_RTL8196C_GREEN_ETHERNET
+	struct timer_list expire_timer2;
+#endif
+
+#ifdef CONFIG_RTL_ETH_NAPI_SUPPORT
+	struct sk_buff_head rx_napi_skb_queue;
+#endif
+};
+
+typedef struct __rtlInterruptRxData {
+#if defined(CONFIG_RTK_VOIP_QOS) && !defined(CONFIG_RTK_VOIP_ETHERNET_DSP_IS_HOST)
+	unsigned long voip_rx_start_time;
+	int voip_rx_cnt;
+#endif
+} rtlInterruptRxData;
+
+/*	define return value		*/
+#define	RTL_RX_PROCESS_RETURN_SUCCESS		0
+#define	RTL_RX_PROCESS_RETURN_CONTINUE		-1
+#define	RTL_RX_PROCESS_RETURN_BREAK		-2
+
+#if defined(CONFIG_RTL_UNKOWN_UNICAST_CONTROL)
+#define	RTL_MAC_RECORD_NUM		16	/* Must be 2's orders */
+#define	RTL_MAC_THRESHOLD		200	/* threshold for block unkown unicast */
+#define	RTL_MAC_TIMEOUT			10*HZ	/* unkown unicast restriction time */
+#define	RTL_MAC_REFILL_TOKEN		10	/* per second refill token number */
+typedef struct __rtlMacRecord {
+	uint8 enable;
+	uint8 cnt;
+	uint8 mac[ETHER_ADDR_LEN];
+	struct timer_list timer;
+	uint8 acl_config;
+} rtlMacRecord;
+#endif
+
+#if defined(RTL819X_PRIV_IOCTL_ENABLE)
+#define RTL819X_IOCTL_READ_PORT_STATUS			(SIOCDEVPRIVATE + 0x01)
+#define RTL819X_IOCTL_READ_PORT_STATS	              (SIOCDEVPRIVATE + 0x02)
+
+struct lan_port_status {
+	unsigned char link;
+	unsigned char speed;
+	unsigned char duplex;
+	unsigned char nway;
+};
+
+struct port_statistics {
+	unsigned int rx_bytes;
+	unsigned int rx_unipkts;
+	unsigned int rx_mulpkts;
+	unsigned int rx_bropkts;
+	unsigned int rx_discard;
+	unsigned int rx_error;
+	unsigned int tx_bytes;
+	unsigned int tx_unipkts;
+	unsigned int tx_mulpkts;
+	unsigned int tx_bropkts;
+	unsigned int tx_discard;
+	unsigned int tx_error;
+};
+#endif
+
+#if defined(CONFIG_RTL_INBAND_CTL_API)
+struct port_stats {
+	unsigned long rx_bytes_last;
+	unsigned long tx_bytes_last;
+	unsigned long rx_bytes_current;
+	unsigned long tx_bytes_current;
+	unsigned long rx_rate;
+	unsigned long tx_rate;
+};
+#endif
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+struct ifvlan {
+	int cmd;
+	char enable;
+	short vlanIdx;
+	short vid;
+	char disable_priority;
+	int member;
+	int port;
+	char txtag;
+};
+struct lan_dev_bind_mask_drv {
+	char ifname[IFNAMSIZ];
+	int bind_mask;
+};
+#endif
+#if defined(CONFIG_RTK_VLAN_SUPPORT) || defined(CONFIG_RTL_MULTI_LAN_DEV)
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+#define	RTL_LANVLANID_1		RTL_LANVLANID
+#define	RTL_LANVLANID_2		RTL_LANVLANID
+#define	RTL_LANVLANID_3		RTL_LANVLANID
+#define	RTL_LANVLANID_4		RTL_LANVLANID
+#define 	RTL_LANVLANID_5		RTL_LANVLANID
+#else
+#if defined(CONFIG_RTD_1295_HWNAT)
+#if defined(CONFIG_RTL_CPU_TAG)
+#define	RTL_LANVLANID_0		14
+#endif /* CONFIG_RTL_CPU_TAG */
+#endif /* CONFIG_RTD_1295_HWNAT */
+#define	RTL_LANVLANID_1		9
+#define	RTL_LANVLANID_2		10
+#define	RTL_LANVLANID_3		11
+#define	RTL_LANVLANID_4		12
+#define RTL_LANVLANID_5		13
+#endif
+#endif
+#define	RTL_PPTPL2TP_VLANID	999
+
+/* flowing name in protocol stack DO NOT duplicate */
+#define RTL_PS_BR0_DEV_NAME RTL_BR_NAME
+#define RTL_PS_ETH_NAME	"eth"
+#define RTL_PS_WLAN_NAME	RTL_WLAN_NAME
+#define RTL_PS_PPP_NAME	"ppp"
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define RTL_PS_LAN_P0_DEV_NAME RTL_DEV_NAME_NUM(RTL_PS_ETH_NAME, 1)
+#define RTL_PS_WAN0_DEV_NAME RTL_DEV_NAME_NUM(RTL_PS_ETH_NAME, 0)
+#else /* CONFIG_RTD_1295_HWNAT */
+#define RTL_PS_LAN_P0_DEV_NAME RTL_DEV_NAME_NUM(RTL_PS_ETH_NAME, 0)
+#define RTL_PS_WAN0_DEV_NAME RTL_DEV_NAME_NUM(RTL_PS_ETH_NAME, 1)
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+#define RTL_PS_PPP0_DEV_NAME RTL_DEV_NAME_NUM(RTL_PS_PPP_NAME, 0)
+#define RTL_PS_PPP1_DEV_NAME RTL_DEV_NAME_NUM(RTL_PS_PPP_NAME, 1)
+#define RTL_PS_WLAN0_DEV_NAME RTL_DEV_NAME_NUM(RTL_PS_WLAN_NAME, 0)
+#define RTL_PS_WLAN1_DEV_NAME RTL_DEV_NAME_NUM(RTL_PS_WLAN_NAME, 1)
+#define RTL_PS_MESH_DEV_NAME "wlan-msh"
+
+#if defined(CONFIG_RTL_MULTIPLE_WAN)
+#define RTL_MULTIWAN_ADD 1
+#define RTL_MULTIWAN_DEL 2
+/* #define RTL_PS_WAN1_DEV_NAME RTL_DEV_NAME_NUM(RTL_PS_ETH_NAME,2) */
+#endif
+
+#if defined(CONFIG_RTL_PUBLIC_SSID)
+#define RTL_LAN_DEVICE_NAME "br0"
+#define RTL_GW_WAN_DEVICE_NAME "br1"
+#define RTL_WISP_WAN_DEVICE_NAME "wlan0"
+#define RTL_BR_WAN_DEVICE_NAME "br0"
+#endif
+
+/* Used by fastpath mac-based qos under IMPROVE_QOS */
+#define QOS_LAN_DEV_NAME RTL_PS_BR0_DEV_NAME
+
+#ifdef CONFIG_RTL_LAYERED_DRIVER
+struct rtl865x_vlanConfig {
+	uint8 ifname[IFNAMSIZ];
+	uint8 isWan;
+	uint16 if_type;
+	uint16 vid;
+	uint16 fid;
+
+	/*
+	 * When CONFIG_RTL_ISP_MULTI_WAN_SUPPORT defined:
+	 * For WAN port (isWan=1):      "memPort" is NOT the vlan's mbr , it means the port-binding members of this WAN
+	 * For LAN port (isWan=0):      "memPort" means the switch phyport mapping
+	 */
+	uint32 memPort;
+	uint32 untagSet;
+	uint32 mtu;
+	ether_addr_t mac;
+	uint8 is_slave;
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+	uint8 protocol;		/* 0: pppoe, 1: ipoe, 2: bridge */
+#endif
+};
+
+#if defined(CONFIG_RTL_ISP_MULTI_WAN_SUPPORT)
+#define RTL865X_CONFIG_END					{ "", 0, 0, 0, 0, 0, 0, 0, {{0}}, 0, 0 }
+#else
+#define RTL865X_CONFIG_END					{ "", 0, 0, 0, 0, 0, 0, 0, {{0}}, 0 }
+#endif
+#define GATEWAY_MODE					0
+#define BRIDGE_MODE					1
+#define WISP_MODE					2
+/* #define MULTIPLE_VLAN_BRIDGE_MODE 3 */
+/* #define MULTIPLE_VLAN_WISP_MODE 4 */
+#define CONFIG_CHECK(expr) do { \
+	if (((int32)expr) != SUCCESS) { \
+		rtlglue_printf("Error >>> %s:%d failed !\n", __FUNCTION__, __LINE__);\
+			return FAILED;\
+	} \
+} while (0)
+
+#define INIT_CHECK(expr) do { \
+	if (((int32)expr) != SUCCESS) { \
+		rtlglue_printf("Error >>> %s:%d failed !\n", __FUNCTION__, __LINE__);\
+			return FAILED;\
+	} \
+} while (0)
+#endif
+
+#ifdef CONFIG_RTL8686_GMAC
+#define GATEWAY_MODE				0
+#define BRIDGE_MODE					1
+#define WISP_MODE					2
+#endif
+
+typedef struct _ps_drv_netif_mapping_s {
+	uint32 valid:1,		/* entry enable? */
+	 flags;			/* reserverd */
+	struct net_device *ps_netif;	/* linux ps network interface */
+	char drvName[MAX_IFNAMESIZE];	/* netif name in driver */
+
+} ps_drv_netif_mapping_t;
+
+int32 rtl865x_changeOpMode(int mode);
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+__MIPS16 __IRAM_FWD int is_rtl865x_eth_priv_buf(unsigned char *head);
+void free_rtl865x_eth_priv_buf(unsigned char *head);
+#endif
+
+ps_drv_netif_mapping_t *rtl_get_ps_drv_netif_mapping_by_psdev(struct net_device
+	*dev);
+int rtl_add_ps_drv_netif_mapping(struct net_device *dev, const char *name);
+int rtl_del_ps_drv_netif_mapping(struct net_device *dev);
+
+#if defined(CONFIG_RTK_VLAN_SUPPORT) && defined(CONFIG_RTK_VLAN_FOR_CABLE_MODEM)
+extern struct net_device *get_dev_by_vid(int vid);
+#endif
+extern __MIPS16 struct net_device *get_shortcut_dev(unsigned char *da);
+
+#define CONFIG_RTL_NIC_HWSTATS
+
+int32 rtl865x_changeOpMode(int mode);
+int rtl865x_reChangeOpMode(void);
+extern int update_vlanconfig(uint32 vid, uint32 portMask, uint32 untagPortMask);
+extern void htonl_array(u32 *org_buf, u32 *dst_buf, unsigned int words);
+extern void ntohl_array(u32 *org_buf, u32 *dst_buf, unsigned int words);
+
+#if defined(CONFIG_RTL_HW_VLAN_SUPPORT)
+extern int rtl_hw_vlan_ignore_tagged_mc;
+
+#define CONFIG_RTL_HW_VLAN_SUPPORT_HW_NAT
+#endif
+#ifndef CONFIG_RTL_CUSTOM_PASSTHRU
+#ifndef CONFIG_OPENWRT_SDK
+#define CONFIG_RTL_CUSTOM_PASSTHRU
+#endif
+/* #define CONFIG_RTL_CUSTOM_PASSTHRU_PPPOE */
+#ifdef CONFIG_RTL_CUSTOM_PASSTHRU
+#define PASSTHRU_VLAN_ID 100
+
+#define IP6_PASSTHRU_RULEID 5
+#define PPPOE_PASSTHRU_RULEID1 3
+#define PPPOE_PASSTHRU_RULEID2 4
+#define IP6_PASSTHRU_MASK 0x1
+#define PPPOE_PASSTHRU_MASK 0x1<<1
+#endif
+#endif
+
+#define RTL_DROP_OUT_OF_BR_SUBNET_FRAME 1
+
+#if defined(CONFIG_RTL_PROCESS_PPPOE_IGMP_FOR_BRIDGE_FORWARD)
+struct iphdr * rtl_get_pppoe_ipv4_hdr(unsigned char *data, int check_from_mac, unsigned short protocol);
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+struct ipv6hdr * rtl_get_pppoe_ipv6_hdr(unsigned char *data, int check_from_mac, unsigned short protocol);
+#endif
+int rtl_is_pppoe_igmp_bridge_frame(struct sk_buff *skb, int check_from_mac, unsigned char *dest);
+#define PPPOE_IGMP  1
+#define PPPOE_UDP   2
+#define PPPOE_TCP   3
+#if defined(CONFIG_RTL_MLD_SNOOPING)
+#define PPPOE_ICMPV6  4
+#define PPPOE_UDPV6  5
+#define PPPOE_TCPV6  6
+#endif
+#endif
+#endif
diff --git a/include/net/rtl/rtl_queue.h b/include/net/rtl/rtl_queue.h
new file mode 100644
index 00000000..ba4c7f7
--- /dev/null
+++ b/include/net/rtl/rtl_queue.h
@@ -0,0 +1,940 @@
+
+/*
+ * Copyright (c) 1991, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)queue.h	8.5 (Berkeley) 8/20/94
+ * $FreeBSD: src/sys/sys/queue.h,v 1.32.2.4 2001/03/31 03:33:39 hsu Exp $
+ */
+
+#ifndef _RTL_QUEUE_H_
+#define	_RTL_QUEUE_H_
+
+////#include <machine/ansi.h>   /* for __offsetof */
+
+/*
+ * This file defines five types of data structures: singly-linked lists,
+ * singly-linked tail queues, lists, tail queues, and circular queues.
+ *
+ * A singly-linked list is headed by a single forward pointer. The elements
+ * are singly linked for minimum space and pointer manipulation overhead at
+ * the expense of O(n) removal for arbitrary elements. New elements can be
+ * added to the list after an existing element or at the head of the list.
+ * Elements being removed from the head of the list should use the explicit
+ * macro for this purpose for optimum efficiency. A singly-linked list may
+ * only be traversed in the forward direction.  Singly-linked lists are ideal
+ * for applications with large datasets and few or no removals or for
+ * implementing a LIFO queue.
+ *
+ * A singly-linked tail queue is headed by a pair of pointers, one to the
+ * head of the list and the other to the tail of the list. The elements are
+ * singly linked for minimum space and pointer manipulation overhead at the
+ * expense of O(n) removal for arbitrary elements. New elements can be added
+ * to the list after an existing element, at the head of the list, or at the
+ * end of the list. Elements being removed from the head of the tail queue
+ * should use the explicit macro for this purpose for optimum efficiency.
+ * A singly-linked tail queue may only be traversed in the forward direction.
+ * Singly-linked tail queues are ideal for applications with large datasets
+ * and few or no removals or for implementing a FIFO queue.
+ *
+ * A list is headed by a single forward pointer (or an array of forward
+ * pointers for a hash table header). The elements are doubly linked
+ * so that an arbitrary element can be removed without a need to
+ * traverse the list. New elements can be added to the list before
+ * or after an existing element or at the head of the list. A list
+ * may only be traversed in the forward direction.
+ *
+ * A tail queue is headed by a pair of pointers, one to the head of the
+ * list and the other to the tail of the list. The elements are doubly
+ * linked so that an arbitrary element can be removed without a need to
+ * traverse the list. New elements can be added to the list before or
+ * after an existing element, at the head of the list, or at the end of
+ * the list. A tail queue may be traversed in either direction.
+ *
+ * A circle queue is headed by a pair of pointers, one to the head of the
+ * list and the other to the tail of the list. The elements are doubly
+ * linked so that an arbitrary element can be removed without a need to
+ * traverse the list. New elements can be added to the list before or after
+ * an existing element, at the head of the list, or at the end of the list.
+ * A circle queue may be traversed in either direction, but has a more
+ * complex end of list detection.
+ *
+ * For details on the use of these macros, see the queue(3) manual page.
+ *
+ *
+ *			SLIST	LIST	STAILQ	TAILQ	CIRCLEQ
+ * _HEAD		+	+	+	+	+
+ * _ENTRY		+	+	+	+	+
+ * _INIT		+	+	+	+	+
+ * _EMPTY		+	+	+	+	+
+ * _FIRST		+	+	+	+	+
+ * _NEXT		+	+	+	+	+
+ * _PREV		-	-	-	+	+
+ * _LAST		-	-	+	+	+
+ * _FOREACH		+	+	+	+	+
+ * _FOREACH_REVERSE	-	-	-	+	+
+ * _INSERT_HEAD		+	+	+	+	+
+ * _INSERT_BEFORE	-	+	-	+	+
+ * _INSERT_AFTER	+	+	+	+	+
+ * _INSERT_TAIL		-	-	+	+	+
+ * _REMOVE_HEAD		+	-	+	-	-
+ * _REMOVE		+	+	+	+	+
+ *
+ */
+
+#ifndef __offsetof
+#define __offsetof(type, field) ((unsigned long)(&((type *)0)->field))
+#endif
+
+/*
+ * Singly-linked List definitions.
+ */
+#define SLIST_HEAD(name, type)						\
+struct name {								\
+	struct type *slh_first;	/* first element */			\
+}
+
+#define SLIST_HEAD_INITIALIZER(head)					\
+	{ NULL }
+
+#define SLIST_ENTRY(type)						\
+struct {								\
+	struct type *sle_next;	/* next element */			\
+}
+
+/*
+ * Singly-linked List functions.
+ */
+#define	SLIST_EMPTY(head)	((head)->slh_first == NULL)
+
+#define	SLIST_FIRST(head)	((head)->slh_first)
+
+#define SLIST_FOREACH(var, head, field)					\
+	for((var) = (head)->slh_first; (var); (var) = (var)->field.sle_next)
+
+#define SLIST_INIT(head) {						\
+	(head)->slh_first = NULL;					\
+}
+
+#define SLIST_INSERT_AFTER(slistelm, elm, field) do {			\
+	(elm)->field.sle_next = (slistelm)->field.sle_next;		\
+	(slistelm)->field.sle_next = (elm);				\
+} while (0)
+
+#define SLIST_INSERT_HEAD(head, elm, field) do {			\
+	(elm)->field.sle_next = (head)->slh_first;			\
+	(head)->slh_first = (elm);					\
+} while (0)
+
+#define SLIST_NEXT(elm, field)	((elm)->field.sle_next)
+
+#define SLIST_REMOVE_HEAD(head, field) do {				\
+	(head)->slh_first = (head)->slh_first->field.sle_next;		\
+} while (0)
+
+#define SLIST_REMOVE(head, elm, type, field) do {			\
+	if ((head)->slh_first == (elm)) {				\
+		SLIST_REMOVE_HEAD((head), field);			\
+	}								\
+	else {								\
+		struct type *curelm = (head)->slh_first;		\
+		while( curelm->field.sle_next != (elm) )		\
+			curelm = curelm->field.sle_next;		\
+		curelm->field.sle_next =				\
+		    curelm->field.sle_next->field.sle_next;		\
+	}								\
+} while (0)
+
+/*
+ * Counting Singly-linked List definitions.
+ */
+#define CSLIST_HEAD(name, type)						\
+struct name {								\
+	struct type *slh_first;	/* first element */			\
+	int slh_count;\
+}
+
+#define CSLIST_HEAD_INITIALIZER(head)					\
+	{0,  NULL }
+
+#define CSLIST_ENTRY(type)						\
+struct {								\
+	struct type *sle_next;	/* next element */			\
+}
+
+/*
+ * Singly-linked List functions.
+ */
+#define	CSLIST_EMPTY(head)	((head)->slh_first == NULL)
+#define	CSLIST_FIRST(head)	((head)->slh_first)
+#define	CSLIST_TOTAL(head)	((head)->slh_count)
+#define CSLIST_FOREACH(var, head, field)					\
+	for((var) = (head)->slh_first; (var); (var) = (var)->field.sle_next)
+
+#define CSLIST_INIT(head) {						\
+	(head)->slh_count=0;\
+	(head)->slh_first = NULL;					\
+}
+
+#define CSLIST_INSERT_AFTER(head, slistelm, elm, field) do {			\
+	(elm)->field.sle_next = (slistelm)->field.sle_next;		\
+	(slistelm)->field.sle_next = (elm);				\
+	(head)->slh_count++;\
+} while (0)
+
+#define CSLIST_INSERT_HEAD(head, elm, field) do {			\
+	(elm)->field.sle_next = (head)->slh_first;			\
+	(head)->slh_first = (elm);					\
+	(head)->slh_count++;\
+} while (0)
+
+#define CSLIST_NEXT(elm, field)	((elm)->field.sle_next)
+
+#define CSLIST_REMOVE_HEAD(head, field) do {				\
+	(head)->slh_first = (head)->slh_first->field.sle_next;		\
+	(head)->slh_count--;\
+} while (0)
+
+#define CSLIST_REMOVE(head, elm, type, field) do {			\
+	if ((head)->slh_first == (elm)) {				\
+		CSLIST_REMOVE_HEAD((head), field);			\
+	}								\
+	else {								\
+		struct type *curelm = (head)->slh_first;		\
+		while( curelm->field.sle_next != (elm) )		\
+			curelm = curelm->field.sle_next;		\
+		curelm->field.sle_next = curelm->field.sle_next->field.sle_next;\
+		(head)->slh_count--;\
+	}\
+} while (0)
+
+/*
+ * Singly-linked Tail queue definitions.
+ */
+#define STAILQ_HEAD(name, type)						\
+struct name {								\
+	struct type *stqh_first;/* first element */			\
+	struct type **stqh_last;/* addr of last next element */		\
+}
+
+#define STAILQ_HEAD_INITIALIZER(head)					\
+	{ NULL, &(head).stqh_first }
+
+#define STAILQ_ENTRY(type)						\
+struct {								\
+	struct type *stqe_next;	/* next element */			\
+}
+
+/*
+ * Singly-linked Tail queue functions.
+ */
+#define STAILQ_EMPTY(head) ((head)->stqh_first == NULL)
+
+#define	STAILQ_INIT(head) do {						\
+	(head)->stqh_first = NULL;					\
+	(head)->stqh_last = &(head)->stqh_first;			\
+} while (0)
+
+#define STAILQ_FIRST(head)	((head)->stqh_first)
+
+#define	STAILQ_LAST(head, type, field)					\
+	(STAILQ_EMPTY(head) ?						\
+		NULL :							\
+	        ((struct type *)					\
+		((int8 *)((head)->stqh_last) - __offsetof(struct type, field))))
+
+#define STAILQ_FOREACH(var, head, field)				\
+	for((var) = (head)->stqh_first; (var); (var) = (var)->field.stqe_next)
+
+#define STAILQ_INSERT_HEAD(head, elm, field) do {			\
+	if (((elm)->field.stqe_next = (head)->stqh_first) == NULL)	\
+		(head)->stqh_last = &(elm)->field.stqe_next;		\
+	(head)->stqh_first = (elm);					\
+} while (0)
+
+/*if the header->stqh_first == NULL,we should modify it*/
+#define STAILQ_INSERT_TAIL(head, elm, field) do {			\
+	if((head)->stqh_first == NULL)		\
+		STAILQ_INSERT_HEAD(head, elm, field);	\
+	else	{							\
+		(elm)->field.stqe_next = NULL;					\
+		*(head)->stqh_last = (elm);					\
+		(head)->stqh_last = &(elm)->field.stqe_next;			\
+	}							\
+} while (0)
+
+#define STAILQ_INSERT_AFTER(head, tqelm, elm, field) do {		\
+	if (((elm)->field.stqe_next = (tqelm)->field.stqe_next) == NULL)\
+		(head)->stqh_last = &(elm)->field.stqe_next;		\
+	(tqelm)->field.stqe_next = (elm);				\
+} while (0)
+
+#define STAILQ_NEXT(elm, field)	((elm)->field.stqe_next)
+
+#define STAILQ_REMOVE_HEAD(head, field) do {				\
+	if (((head)->stqh_first =					\
+	     (head)->stqh_first->field.stqe_next) == NULL)		\
+		(head)->stqh_last = &(head)->stqh_first;		\
+} while (0)
+
+#define STAILQ_REMOVE_HEAD_UNTIL(head, elm, field) do {			\
+	if (((head)->stqh_first = (elm)->field.stqe_next) == NULL)	\
+		(head)->stqh_last = &(head)->stqh_first;		\
+} while (0)
+
+#define STAILQ_REMOVE(head, elm, type, field) do {			\
+	if ((head)->stqh_first == (elm)) {				\
+		STAILQ_REMOVE_HEAD(head, field);			\
+	}								\
+	else {								\
+		struct type *curelm = (head)->stqh_first;		\
+		while( curelm->field.stqe_next != (elm) )		\
+			curelm = curelm->field.stqe_next;		\
+		if((curelm->field.stqe_next =				\
+		    curelm->field.stqe_next->field.stqe_next) == NULL)	\
+			(head)->stqh_last = &(curelm)->field.stqe_next;	\
+	}								\
+} while (0)
+
+
+/*
+ * Counting Singly-linked Tail queue definitions.
+ */
+#define CSTAILQ_HEAD(name, type)						\
+struct name {								\
+	struct type *stqh_first;/* first element */			\
+	struct type **stqh_last;/* addr of last next element */		\
+	int stqh_count;\
+}
+
+#define CSTAILQ_HEAD_INITIALIZER(head)					\
+	{ 0, NULL, &(head).stqh_first }
+
+#define CSTAILQ_ENTRY(type)						\
+struct {								\
+	struct type *stqe_next;	/* next element */			\
+}
+
+/*
+ * Counting Singly-linked Tail queue functions.
+ */
+#define CSTAILQ_EMPTY(head) ((head)->stqh_first == NULL)
+
+#define	CSTAILQ_INIT(head) do {						\
+	(head)->stqh_count=0;\
+	(head)->stqh_first = NULL;					\
+	(head)->stqh_last = &(head)->stqh_first;			\
+} while (0)
+
+#define CSTAILQ_FIRST(head)	((head)->stqh_first)
+#define CSTAILQ_TOTAL(head)	((head)->stqh_count)
+#define	CSTAILQ_LAST(head, type, field)					\
+	(CSTAILQ_EMPTY(head) ?						\
+		NULL :							\
+	        ((struct type *)					\
+		((int8 *)((head)->stqh_last) - __offsetof(struct type, field))))
+
+#define CSTAILQ_FOREACH(var, head, field)				\
+	for((var) = (head)->stqh_first; (var); (var) = (var)->field.stqe_next)
+
+#define CSTAILQ_INSERT_HEAD(head, elm, field) do {			\
+	if (((elm)->field.stqe_next = (head)->stqh_first) == NULL)	\
+		(head)->stqh_last = &(elm)->field.stqe_next;		\
+	(head)->stqh_first = (elm);					\
+	(head)->stqh_count++;\
+} while (0)
+
+#define CSTAILQ_INSERT_TAIL(head, elm, field) do {			\
+	(elm)->field.stqe_next = NULL;					\
+	*(head)->stqh_last = (elm);					\
+	(head)->stqh_last = &(elm)->field.stqe_next;			\
+	(head)->stqh_count++;\
+} while (0)
+
+#define CSTAILQ_INSERT_AFTER(head, tqelm, elm, field) do {		\
+	if (((elm)->field.stqe_next = (tqelm)->field.stqe_next) == NULL)\
+		(head)->stqh_last = &(elm)->field.stqe_next;		\
+	(tqelm)->field.stqe_next = (elm);				\
+	(head)->stqh_count++;\
+} while (0)
+
+#define CSTAILQ_NEXT(elm, field)	((elm)->field.stqe_next)
+
+#define CSTAILQ_REMOVE_HEAD(head, field) do {				\
+	if (((head)->stqh_first =					\
+	     (head)->stqh_first->field.stqe_next) == NULL)		\
+		(head)->stqh_last = &(head)->stqh_first;		\
+	(head)->stqh_count--;\
+} while (0)
+
+#define CSTAILQ_REMOVE_HEAD_UNTIL(head, elm, field) do {			\
+	if (((head)->stqh_first = (elm)->field.stqe_next) == NULL)	\
+		(head)->stqh_last = &(head)->stqh_first;		\
+	(head)->stqh_count--;\
+} while (0)
+
+#define CSTAILQ_REMOVE(head, elm, type, field) do {			\
+	if ((head)->stqh_first == (elm)) {				\
+		CSTAILQ_REMOVE_HEAD(head, field);			\
+	}								\
+	else {								\
+		struct type *curelm = (head)->stqh_first;		\
+		while( curelm->field.stqe_next != (elm) )		\
+			curelm = curelm->field.stqe_next;		\
+		if((curelm->field.stqe_next =				\
+		    curelm->field.stqe_next->field.stqe_next) == NULL)	\
+			(head)->stqh_last = &(curelm)->field.stqe_next;	\
+		(head)->stqh_count--;\
+	}								\
+} while (0)
+
+#if	!(defined(__linux__) || defined(LIST_HEAD))
+
+/*
+ * List definitions.
+ */
+#define LIST_HEAD(name, type)						\
+struct name {								\
+	struct type *lh_first;	/* first element */			\
+}
+
+#define LIST_HEAD_INITIALIZER(head)					\
+	{ NULL }
+
+#define LIST_ENTRY(type)						\
+struct {								\
+	struct type *le_next;	/* next element */			\
+	struct type **le_prev;	/* address of previous next element */	\
+}
+
+/*
+ * List functions.
+ */
+
+#define	LIST_EMPTY(head) ((head)->lh_first == NULL)
+
+#define LIST_FIRST(head)	((head)->lh_first)
+
+#define LIST_FOREACH(var, head, field)					\
+	for((var) = (head)->lh_first; (var); (var) = (var)->field.le_next)
+
+#define	LIST_INIT(head) do {						\
+	(head)->lh_first = NULL;					\
+} while (0)
+
+#define LIST_INSERT_AFTER(listelm, elm, field) do {			\
+	if (((elm)->field.le_next = (listelm)->field.le_next) != NULL)	\
+		(listelm)->field.le_next->field.le_prev =		\
+		    &(elm)->field.le_next;				\
+	(listelm)->field.le_next = (elm);				\
+	(elm)->field.le_prev = &(listelm)->field.le_next;		\
+} while (0)
+
+#define LIST_INSERT_BEFORE(listelm, elm, field) do {			\
+	(elm)->field.le_prev = (listelm)->field.le_prev;		\
+	(elm)->field.le_next = (listelm);				\
+	*(listelm)->field.le_prev = (elm);				\
+	(listelm)->field.le_prev = &(elm)->field.le_next;		\
+} while (0)
+
+#define LIST_INSERT_HEAD(head, elm, field) do {				\
+	if (((elm)->field.le_next = (head)->lh_first) != NULL)		\
+		(head)->lh_first->field.le_prev = &(elm)->field.le_next;\
+	(head)->lh_first = (elm);					\
+	(elm)->field.le_prev = &(head)->lh_first;			\
+} while (0)
+
+#define LIST_NEXT(elm, field)	((elm)->field.le_next)
+
+#define LIST_REMOVE(elm, field) do {					\
+	if ((elm)->field.le_next != NULL)				\
+		(elm)->field.le_next->field.le_prev = 			\
+		    (elm)->field.le_prev;				\
+	*(elm)->field.le_prev = (elm)->field.le_next;			\
+} while (0)
+
+#endif /* __linux__ */
+
+/*
+ * Counting List definitions.
+ */
+#define CLIST_HEAD(name, type)						\
+struct name { \
+	struct type *lh_first;	/* first element */			\
+	int lh_count;\
+}
+
+#define CLIST_HEAD_INITIALIZER(head)					\
+	{ 0, NULL }
+
+#define CLIST_ENTRY(type)						\
+struct {								\
+	struct type *le_next;	/* next element */			\
+	struct type **le_prev;	/* address of previous next element */	\
+}
+
+/*
+ * Counting List functions.
+ */
+
+#define	CLIST_EMPTY(head) ((head)->lh_first == NULL)
+#define   CLIST_TOTAL(head) ((head)->lh_count)
+#define CLIST_FIRST(head)	((head)->lh_first)
+
+#define CLIST_FOREACH(var, head, field)					\
+	for((var) = (head)->lh_first; (var); (var) = (var)->field.le_next)
+
+#define	CLIST_INIT(head) do {						\
+	(head)->lh_count=0;\
+	(head)->lh_first = NULL;					\
+} while (0)
+
+#define CLIST_INSERT_AFTER(head, listelm, elm, field) do {			\
+	if (((elm)->field.le_next = (listelm)->field.le_next) != NULL)	\
+		(listelm)->field.le_next->field.le_prev =		\
+		    &(elm)->field.le_next;				\
+	(listelm)->field.le_next = (elm);				\
+	(elm)->field.le_prev = &(listelm)->field.le_next;		\
+	(head)->lh_count++;\
+} while (0)
+
+#define CLIST_INSERT_BEFORE(head, listelm, elm, field) do {			\
+	(elm)->field.le_prev = (listelm)->field.le_prev;		\
+	(elm)->field.le_next = (listelm);				\
+	*(listelm)->field.le_prev = (elm);				\
+	(listelm)->field.le_prev = &(elm)->field.le_next;		\
+	(head)->lh_count++;\
+} while (0)
+
+#define CLIST_INSERT_HEAD(head, elm, field) do {				\
+	if (((elm)->field.le_next = (head)->lh_first) != NULL)		\
+		(head)->lh_first->field.le_prev = &(elm)->field.le_next;\
+	(head)->lh_first = (elm);					\
+	(elm)->field.le_prev = &(head)->lh_first;			\
+	(head)->lh_count++;\
+} while (0)
+
+#define CLIST_NEXT(elm, field)	((elm)->field.le_next)
+
+#define CLIST_REMOVE(head, elm, field) do {					\
+	if ((elm)->field.le_next != NULL)				\
+		(elm)->field.le_next->field.le_prev = 			\
+		    (elm)->field.le_prev;				\
+	*(elm)->field.le_prev = (elm)->field.le_next;			\
+	(head)->lh_count--;\
+} while (0)
+
+
+/*
+ * Tail queue definitions.
+ */
+#define TAILQ_HEAD(name, type)						\
+struct name {								\
+	struct type *tqh_first;	/* first element */			\
+	struct type **tqh_last;	/* addr of last next element */		\
+}
+
+#define TAILQ_HEAD_INITIALIZER(head)					\
+	{ NULL, &(head).tqh_first }
+
+#define TAILQ_ENTRY(type)						\
+struct {								\
+	struct type *tqe_next;	/* next element */			\
+	struct type **tqe_prev;	/* address of previous next element */	\
+}
+
+/*
+ * Tail queue functions.
+ */
+#define	TAILQ_EMPTY(head) ((head)->tqh_first == NULL)
+
+#define TAILQ_FOREACH(var, head, field)					\
+	for (var = TAILQ_FIRST(head); var; var = TAILQ_NEXT(var, field))
+
+#define TAILQ_FOREACH_REVERSE(var, head, headname, field)		\
+	for ((var) = TAILQ_LAST((head), headname);			\
+	     (var);							\
+	     (var) = TAILQ_PREV((var), headname, field))
+
+#define	TAILQ_FIRST(head) ((head)->tqh_first)
+
+#define	TAILQ_LAST(head, headname) \
+	(*(((struct headname *)((head)->tqh_last))->tqh_last))
+
+#define	TAILQ_NEXT(elm, field) ((elm)->field.tqe_next)
+
+#define TAILQ_PREV(elm, headname, field) \
+	(*(((struct headname *)((elm)->field.tqe_prev))->tqh_last))
+
+#define	TAILQ_INIT(head) do {						\
+	(head)->tqh_first = NULL;					\
+	(head)->tqh_last = &(head)->tqh_first;				\
+} while (0)
+
+#define TAILQ_INSERT_HEAD(head, elm, field) do {			\
+	if (((elm)->field.tqe_next = (head)->tqh_first) != NULL)	\
+		(head)->tqh_first->field.tqe_prev =			\
+		    &(elm)->field.tqe_next;				\
+	else								\
+		(head)->tqh_last = &(elm)->field.tqe_next;		\
+	(head)->tqh_first = (elm);					\
+	(elm)->field.tqe_prev = &(head)->tqh_first;			\
+} while (0)
+
+#define TAILQ_INSERT_TAIL(head, elm, field) do {			\
+	(elm)->field.tqe_next = NULL;					\
+	(elm)->field.tqe_prev = (head)->tqh_last;			\
+	*(head)->tqh_last = (elm);					\
+	(head)->tqh_last = &(elm)->field.tqe_next;			\
+} while (0)
+
+#define TAILQ_INSERT_AFTER(head, listelm, elm, field) do {		\
+	if (((elm)->field.tqe_next = (listelm)->field.tqe_next) != NULL)\
+		(elm)->field.tqe_next->field.tqe_prev = 		\
+		    &(elm)->field.tqe_next;				\
+	else								\
+		(head)->tqh_last = &(elm)->field.tqe_next;		\
+	(listelm)->field.tqe_next = (elm);				\
+	(elm)->field.tqe_prev = &(listelm)->field.tqe_next;		\
+} while (0)
+
+#define TAILQ_INSERT_BEFORE(listelm, elm, field) do {			\
+	(elm)->field.tqe_prev = (listelm)->field.tqe_prev;		\
+	(elm)->field.tqe_next = (listelm);				\
+	*(listelm)->field.tqe_prev = (elm);				\
+	(listelm)->field.tqe_prev = &(elm)->field.tqe_next;		\
+} while (0)
+
+#define TAILQ_REMOVE(head, elm, field) do {				\
+	if (((elm)->field.tqe_next) != NULL)				\
+		(elm)->field.tqe_next->field.tqe_prev = 		\
+		    (elm)->field.tqe_prev;				\
+	else								\
+		(head)->tqh_last = (elm)->field.tqe_prev;		\
+	*(elm)->field.tqe_prev = (elm)->field.tqe_next;			\
+} while (0)
+
+/*
+ * Counting Tail queue definitions.
+ */
+#define CTAILQ_HEAD(name, type)						\
+struct name {\
+	struct type *tqh_first;	/* first element */			\
+	struct type **tqh_last;	/* addr of last next element */		\
+	int tqh_count;\
+}
+
+#define CTAILQ_HEAD_INITIALIZER(head)					\
+	{ 0, NULL, &(head).tqh_first }
+
+#define CTAILQ_ENTRY(type)						\
+struct {								\
+	struct type *tqe_next;	/* next element */			\
+	struct type **tqe_prev;	/* address of previous next element */	\
+}
+
+/*
+ * Counting Tail queue functions.
+ */
+#define	CTAILQ_EMPTY(head) ((head)->tqh_first == NULL)
+
+#define CTAILQ_FOREACH(var, head, field)					\
+	for (var = TAILQ_FIRST(head); var; var = TAILQ_NEXT(var, field))
+
+#define CTAILQ_FOREACH_REVERSE(var, head, headname, field)		\
+	for ((var) = TAILQ_LAST((head), headname);			\
+	     (var);							\
+	     (var) = TAILQ_PREV((var), headname, field))
+
+#define	CTAILQ_FIRST(head) ((head)->tqh_first)
+#define	CTAILQ_TOTAL(head) ((head)->tqh_count)
+#define	CTAILQ_LAST(head, headname) \
+	(*(((struct headname *)((head)->tqh_last))->tqh_last))
+
+#define	CTAILQ_NEXT(elm, field) ((elm)->field.tqe_next)
+
+#define CTAILQ_PREV(elm, headname, field) \
+	(*(((struct headname *)((elm)->field.tqe_prev))->tqh_last))
+
+#define	CTAILQ_INIT(head) do {						\
+	(head)->tqh_count=0;\
+	(head)->tqh_first = NULL;					\
+	(head)->tqh_last = &(head)->tqh_first;				\
+} while (0)
+
+#define CTAILQ_INSERT_HEAD(head, elm, field) do {			\
+	if (((elm)->field.tqe_next = (head)->tqh_first) != NULL)	\
+		(head)->tqh_first->field.tqe_prev =			\
+		    &(elm)->field.tqe_next;				\
+	else								\
+		(head)->tqh_last = &(elm)->field.tqe_next;		\
+	(head)->tqh_first = (elm);					\
+	(elm)->field.tqe_prev = &(head)->tqh_first;			\
+	(head)->tqh_count++;\
+} while (0)
+
+#define CTAILQ_INSERT_TAIL(head, elm, field) do {			\
+	(elm)->field.tqe_next = NULL;					\
+	(elm)->field.tqe_prev = (head)->tqh_last;			\
+	*(head)->tqh_last = (elm);					\
+	(head)->tqh_last = &(elm)->field.tqe_next;			\
+	(head)->tqh_count++;\
+} while (0)
+
+#define CTAILQ_INSERT_AFTER(head, listelm, elm, field) do {		\
+	if (((elm)->field.tqe_next = (listelm)->field.tqe_next) != NULL)\
+		(elm)->field.tqe_next->field.tqe_prev = 		\
+		    &(elm)->field.tqe_next;				\
+	else								\
+		(head)->tqh_last = &(elm)->field.tqe_next;		\
+	(listelm)->field.tqe_next = (elm);				\
+	(elm)->field.tqe_prev = &(listelm)->field.tqe_next;		\
+	(head)->tqh_count++;	\
+} while (0)
+
+#define CTAILQ_INSERT_BEFORE(head, listelm, elm, field) do {			\
+	(elm)->field.tqe_prev = (listelm)->field.tqe_prev;		\
+	(elm)->field.tqe_next = (listelm);				\
+	*(listelm)->field.tqe_prev = (elm);				\
+	(listelm)->field.tqe_prev = &(elm)->field.tqe_next;		\
+	(head)->tqh_count++;\
+} while (0)
+
+#define CTAILQ_REMOVE(head, elm, field) do {				\
+	if (((elm)->field.tqe_next) != NULL)				\
+		(elm)->field.tqe_next->field.tqe_prev = 		\
+		    (elm)->field.tqe_prev;				\
+	else								\
+		(head)->tqh_last = (elm)->field.tqe_prev;		\
+	*(elm)->field.tqe_prev = (elm)->field.tqe_next;			\
+	(head)->tqh_count--;\
+} while (0)
+
+
+
+/*
+ * Circular queue definitions.
+ */
+#define CIRCLEQ_HEAD(name, type)					\
+struct name {								\
+	struct type *cqh_first;		/* first element */		\
+	struct type *cqh_last;		/* last element */		\
+}
+
+#define CIRCLEQ_ENTRY(type)						\
+struct {								\
+	struct type *cqe_next;		/* next element */		\
+	struct type *cqe_prev;		/* previous element */		\
+}
+
+/*
+ * Circular queue functions.
+ */
+#define CIRCLEQ_EMPTY(head) ((head)->cqh_first == (void *)(head))
+
+#define CIRCLEQ_FIRST(head) ((head)->cqh_first)
+
+#define CIRCLEQ_FOREACH(var, head, field)				\
+	for((var) = (head)->cqh_first;					\
+	    (var) != (void *)(head);					\
+	    (var) = (var)->field.cqe_next)
+
+#define CIRCLEQ_FOREACH_REVERSE(var, head, field)			\
+	for((var) = (head)->cqh_last;					\
+	    (var) != (void *)(head);					\
+	    (var) = (var)->field.cqe_prev)
+
+#define	CIRCLEQ_INIT(head) do {						\
+	(head)->cqh_first = (void *)(head);				\
+	(head)->cqh_last = (void *)(head);				\
+} while (0)
+
+#define CIRCLEQ_INSERT_AFTER(head, listelm, elm, field) do {		\
+	(elm)->field.cqe_next = (listelm)->field.cqe_next;		\
+	(elm)->field.cqe_prev = (listelm);				\
+	if ((listelm)->field.cqe_next == (void *)(head))		\
+		(head)->cqh_last = (elm);				\
+	else								\
+		(listelm)->field.cqe_next->field.cqe_prev = (elm);	\
+	(listelm)->field.cqe_next = (elm);				\
+} while (0)
+
+#define CIRCLEQ_INSERT_BEFORE(head, listelm, elm, field) do {		\
+	(elm)->field.cqe_next = (listelm);				\
+	(elm)->field.cqe_prev = (listelm)->field.cqe_prev;		\
+	if ((listelm)->field.cqe_prev == (void *)(head))		\
+		(head)->cqh_first = (elm);				\
+	else								\
+		(listelm)->field.cqe_prev->field.cqe_next = (elm);	\
+	(listelm)->field.cqe_prev = (elm);				\
+} while (0)
+
+#define CIRCLEQ_INSERT_HEAD(head, elm, field) do {			\
+	(elm)->field.cqe_next = (head)->cqh_first;			\
+	(elm)->field.cqe_prev = (void *)(head);				\
+	if ((head)->cqh_last == (void *)(head))				\
+		(head)->cqh_last = (elm);				\
+	else								\
+		(head)->cqh_first->field.cqe_prev = (elm);		\
+	(head)->cqh_first = (elm);					\
+} while (0)
+
+#define CIRCLEQ_INSERT_TAIL(head, elm, field) do {			\
+	(elm)->field.cqe_next = (void *)(head);				\
+	(elm)->field.cqe_prev = (head)->cqh_last;			\
+	if ((head)->cqh_first == (void *)(head))			\
+		(head)->cqh_first = (elm);				\
+	else								\
+		(head)->cqh_last->field.cqe_next = (elm);		\
+	(head)->cqh_last = (elm);					\
+} while (0)
+
+#define CIRCLEQ_LAST(head) ((head)->cqh_last)
+
+#define CIRCLEQ_NEXT(elm,field) ((elm)->field.cqe_next)
+
+#define CIRCLEQ_PREV(elm,field) ((elm)->field.cqe_prev)
+
+#define	CIRCLEQ_REMOVE(head, elm, field) do {				\
+	if ((elm)->field.cqe_next == (void *)(head))			\
+		(head)->cqh_last = (elm)->field.cqe_prev;		\
+	else								\
+		(elm)->field.cqe_next->field.cqe_prev =			\
+		    (elm)->field.cqe_prev;				\
+	if ((elm)->field.cqe_prev == (void *)(head))			\
+		(head)->cqh_first = (elm)->field.cqe_next;		\
+	else								\
+		(elm)->field.cqe_prev->field.cqe_next =			\
+		    (elm)->field.cqe_next;				\
+} while (0)
+
+/*
+ * Counting Circular queue definitions.
+ */
+#define CCIRCLEQ_HEAD(name, type)					\
+struct name {								\
+	struct type *cqh_first;		/* first element */		\
+	struct type *cqh_last;		/* last element */		\
+}
+
+#define CCIRCLEQ_ENTRY(type)						\
+struct {								\
+	int cqe_count;\
+	struct type *cqe_next;		/* next element */		\
+	struct type *cqe_prev;		/* previous element */		\
+}
+
+/*
+ * Counting Circular queue functions.
+ */
+#define CCIRCLEQ_EMPTY(head) ((head)->cqh_first == (void *)(head))
+#define CCIRCLEQ_FIRST(head) ((head)->cqh_first)
+#define CCIRCLEQ_TOTAL(head) ((head))->cqh_count)
+#define CCIRCLEQ_FOREACH(var, head, field)				\
+	for((var) = (head)->cqh_first;					\
+	    (var) != (void *)(head);					\
+	    (var) = (var)->field.cqe_next)
+
+#define CCIRCLEQ_FOREACH_REVERSE(var, head, field)			\
+	for((var) = (head)->cqh_last;					\
+	    (var) != (void *)(head);					\
+	    (var) = (var)->field.cqe_prev)
+
+#define	CCIRCLEQ_INIT(head) do {						\
+	(head)->cqh_count=0;\
+	(head)->cqh_first = (void *)(head);				\
+	(head)->cqh_last = (void *)(head);				\
+} while (0)
+
+#define CCIRCLEQ_INSERT_AFTER(head, listelm, elm, field) do {		\
+	(elm)->field.cqe_next = (listelm)->field.cqe_next;		\
+	(elm)->field.cqe_prev = (listelm);				\
+	if ((listelm)->field.cqe_next == (void *)(head))		\
+		(head)->cqh_last = (elm);				\
+	else								\
+		(listelm)->field.cqe_next->field.cqe_prev = (elm);	\
+	(listelm)->field.cqe_next = (elm);				\
+	(head)->cqh_count++;\
+} while (0)
+
+#define CCIRCLEQ_INSERT_BEFORE(head, listelm, elm, field) do {		\
+	(elm)->field.cqe_next = (listelm);				\
+	(elm)->field.cqe_prev = (listelm)->field.cqe_prev;		\
+	if ((listelm)->field.cqe_prev == (void *)(head))		\
+		(head)->cqh_first = (elm);				\
+	else								\
+		(listelm)->field.cqe_prev->field.cqe_next = (elm);	\
+	(listelm)->field.cqe_prev = (elm);				\
+	(head)->cqh_count++;\
+} while (0)
+
+#define CCIRCLEQ_INSERT_HEAD(head, elm, field) do {			\
+	(elm)->field.cqe_next = (head)->cqh_first;			\
+	(elm)->field.cqe_prev = (void *)(head);				\
+	if ((head)->cqh_last == (void *)(head))				\
+		(head)->cqh_last = (elm);				\
+	else								\
+		(head)->cqh_first->field.cqe_prev = (elm);		\
+	(head)->cqh_first = (elm);					\
+	(head)->cqh_count++;\
+} while (0)
+
+#define CCIRCLEQ_INSERT_TAIL(head, elm, field) do {			\
+	(elm)->field.cqe_next = (void *)(head);				\
+	(elm)->field.cqe_prev = (head)->cqh_last;			\
+	if ((head)->cqh_first == (void *)(head))			\
+		(head)->cqh_first = (elm);				\
+	else								\
+		(head)->cqh_last->field.cqe_next = (elm);		\
+	(head)->cqh_last = (elm);					\
+	(head)->cqh_count++;\
+} while (0)
+
+#define CCIRCLEQ_LAST(head) ((head)->cqh_last)
+
+#define CCIRCLEQ_NEXT(elm,field) ((elm)->field.cqe_next)
+
+#define CCIRCLEQ_PREV(elm,field) ((elm)->field.cqe_prev)
+
+#define	CCIRCLEQ_REMOVE(head, elm, field) do {				\
+	if ((elm)->field.cqe_next == (void *)(head))			\
+		(head)->cqh_last = (elm)->field.cqe_prev;		\
+	else								\
+		(elm)->field.cqe_next->field.cqe_prev =			\
+		    (elm)->field.cqe_prev;				\
+	if ((elm)->field.cqe_prev == (void *)(head))			\
+		(head)->cqh_first = (elm)->field.cqe_next;		\
+	else								\
+		(elm)->field.cqe_prev->field.cqe_next =			\
+		    (elm)->field.cqe_next;				\
+	(head)->cqh_count--;\
+} while (0)
+#endif			   /* !_RTL_QUEUE_H_ */
diff --git a/include/net/rtl/rtl_types.h b/include/net/rtl/rtl_types.h
new file mode 100644
index 00000000..f1b34dd
--- /dev/null
+++ b/include/net/rtl/rtl_types.h
@@ -0,0 +1,986 @@
+/*
+* Copyright c                  Realtek Semiconductor Corporation, 2002
+* All rights reserved.
+*
+* Program : The header file of realtek type definition
+* Abstract :
+* Author :
+* $Id: rtl_types.h,v 1.2 2008-01-18 07:53:11 hyking_liu Exp $
+* $Log: not supported by cvs2svn $
+* Revision 1.1  2007/12/21 10:29:52  davidhsu
+* +: support nic driver
+*
+* Revision 1.27  2007/07/27 09:31:23  chenyl
+* +: Add macro for MIPS16-enabled function declaration.
+*
+* Revision 1.26  2007/07/24 08:37:02  chenyl
+* *: For MIPS16 related macros
+*
+* Revision 1.25  2007/06/25 13:08:43  alva_zhang
+* -: remove suitable header file rtl_config.h
+*
+* Revision 1.24  2007/06/25 05:42:30  alva_zhang
+* *: reopen including rtl_config.h
+*
+* Revision 1.23  2007/06/25 02:29:27  alva_zhang
+* -: diable include rtl_config.h temporarily
+*
+* Revision 1.22  2007/06/23 09:11:00  alva_zhang
+* +: add rtl_config.h which includes the MAcro indicate the usage of SDK
+*
+* Revision 1.21  2007/05/15 03:36:56  michaelhuang
+* *: fixed compatibility for Linux Kernel 2.6
+*
+* Revision 1.20  2007/04/04 15:48:54  chenyl
+* +: cleshell commend for asic register configuration : mmtu ( multicast mtu )
+*
+* Revision 1.19  2006/08/29 13:00:00  chenyl
+* *: New SWNIC driver for RTL865xC
+* *: some rearrange in re_core.c for Bootstrap sequence being more readable.
+*
+* Revision 1.18  2006/02/27 07:47:06  ympan
+* +: No change by ympan
+*
+* Revision 1.17  2005/09/27 05:59:44  chenyl
+* *: modify IRAM / DRAM layout:
+* 	IRAM/DRAM-FWD		: external used, swNic ... blahblah
+* 	IRAM/DRAM-L2-FWD	: fwdengine internal used, L2 and below (ex. preprocess, postprocess)
+* 	IRAM/DRAM-L34-FWD	: fwdengine internal used, L3/L4 process only (ex. Routing, decision table...etc).
+*
+* 	=> If L34 is used, we strongly suggest L2 must be used, too.
+*
+* Revision 1.16  2005/08/23 14:38:26  chenyl
+* +: apply prioirty IRAM/DRAM usage
+*
+* Revision 1.15  2005/08/22 07:33:55  chenyl
+* *: don't set DRAM/IRAM for other OSs yet.
+*
+* Revision 1.14  2005/08/18 09:14:08  chenyl
+* *: add code to porting to other OSs
+*
+* Revision 1.13  2005/08/18 06:29:29  chenyl
+* +: always define the rtlglue_printf in rtl_types.h
+*
+* Revision 1.12  2005/07/01 09:34:41  yjlou
+* *: porting swNic2.c into model code.
+*
+* Revision 1.11  2005/06/19 05:29:37  yjlou
+* *: use 'unsigned int' to replace 'size_t'
+* *: define spinlock_t when RTL865X_MODEL_USER defined.
+*
+* Revision 1.10  2005/06/10 05:32:22  yjlou
+* +: Porting CLE Shell to Linux user space for model test.
+*    See RTL865X_MODEL_USER compile flags.
+*
+* Revision 1.9  2005/01/10 03:21:43  yjlou
+* *: always define __IRAM and __DRAM
+*
+* Revision 1.8  2004/07/23 13:42:45  tony
+* *: remove all warning messages
+*
+* Revision 1.7  2004/07/05 08:25:32  chenyl
+* +: define __IRAM, __DRAM for module test
+*
+* Revision 1.6  2004/07/04 15:04:55  cfliu
+* +: add IRAM and DRAM
+*
+* Revision 1.5  2004/04/20 03:44:03  tony
+* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
+*
+* Revision 1.4  2004/03/19 13:13:35  cfliu
+* Reorganize ROME driver local header files. Put all private data structures into different .h file corrsponding to its layering
+* Rename printf, printk, malloc, free with rtlglue_XXX prefix
+*
+* Revision 1.3  2004/03/05 07:44:27  cfliu
+* fix header file problem for ctype.h
+*
+* Revision 1.2  2004/03/03 10:40:38  yjlou
+* *: commit for mergence the difference in rtl86xx_tbl/ since 2004/02/26.
+*
+* Revision 1.1  2004/02/25 14:26:33  chhuang
+* *** empty log message ***
+*
+* Revision 1.3  2004/02/25 14:24:52  chhuang
+* *** empty log message ***
+*
+* Revision 1.8  2003/12/10 06:30:12  tony
+* add linux/config.h, disable define CONFIG_RTL865X_NICDRV2 in mbuf.c by default
+*
+* Revision 1.7  2003/12/03 14:25:43  cfliu
+* change SIZE_T to _SIZE_T. Linux kernel seems to recognize _SIZE_T
+*
+* Revision 1.6  2003/10/01 12:29:02  tony
+* #define DEBUG_P(args...) while(0);
+*
+* Revision 1.5  2003/10/01 10:31:47  tony
+* solve all the compiler warnning messages in the board.c
+*
+* Revision 1.4  2003/09/30 06:07:50  orlando
+* check in RTL8651BLDRV_V20_20030930
+*
+* Revision 1.30  2003/07/21 06:27:49  cfliu
+* no message
+*
+* Revision 1.29  2003/04/30 15:32:30  cfliu
+* move macros to types.h
+*
+* Revision 1.28  2003/03/13 10:29:22  cfliu
+* Remove unused symbols
+*
+* Revision 1.27  2003/03/06 05:00:04  cfliu
+* Move '#pragma ghs inlineprologue' to rtl_depend.h since it is compiler dependent
+*
+* Revision 1.26  2003/03/06 03:41:46  danwu
+* Prevent compiler from generating internal sub-routine call code at the
+*  function prologue and epilogue automatically
+*
+* Revision 1.25  2003/03/03 09:16:35  hiwu
+* remove ip4a
+*
+* Revision 1.24  2003/02/18 10:04:06  jzchen
+* Add ether_addr_t to compatable with protocol stack's ether_addr
+*
+* Revision 1.23  2003/01/21 05:59:51  cfliu
+* add min, max, SETBITS, CLEARBITS, etc.
+*
+* Revision 1.22  2002/11/25 07:31:30  cfliu
+* Remove _POSIX_SOURCE since it is cygwin specific
+*
+* Revision 1.21  2002/09/30 11:51:49  jzchen
+* Add ASSERT_ISR for not print inside ISR
+*
+* Revision 1.20  2002/09/18 01:43:24  jzchen
+* Add type limit definition
+*
+* Revision 1.19  2002/09/16 00:14:34  elvis
+* remove struct posix_handle_t (change the handle type from
+*  structure to uint32)
+*
+* Revision 1.18  2002/08/20 01:40:40  danwu
+* Add definitions of ipaddr_t & macaddr_t.
+*
+* Revision 1.17  2002/07/30 04:36:30  danwu
+* Add ASSERT_CSP.
+*
+* Revision 1.16  2002/07/19 06:47:30  cfliu
+* Add _POSIX_SOURCE symbol
+*
+* Revision 1.15  2002/07/05 02:10:39  elvis
+* Add new types for OSK
+*
+* Revision 1.14  2002/07/03 12:36:21  orlando
+* <rtl_depend.h> will use type definitions. Has to be moved to
+* be after the type declaration lines.
+*
+* Revision 1.13  2002/07/03 09:19:00  cfliu
+* Removed all standard header files from source code. They would be included by <core/types.h>-><rtl_depend.h>
+*
+* Revision 1.12  2002/07/03 09:16:48  cfliu
+* Removed all standard header files from source code. They would be included by <core/types.h>-><rtl_depend.h>
+*
+* Revision 1.11  2002/07/03 07:14:47  orlando
+* Add "struct posix_handle_t_", used by POSIX module.
+*
+* Revision 1.9  2002/06/21 03:15:36  cfliu
+* Add time.h for struct timeval
+*
+* Revision 1.8  2002/06/14 01:58:03  cfliu
+* Move sa_family_t to socket
+*
+* Revision 1.7  2002/06/13 09:37:42  cfliu
+* Move byte order conversion routines to socket
+*
+* Revision 1.6  2002/05/23 04:24:37  hiwu
+* change memaddr_t to calladdr_t
+*
+* Revision 1.5  2002/05/13 10:15:16  hiwu
+* add new type definition
+*
+* Revision 1.4  2002/05/09 05:21:51  cfliu
+* Add parenthesis around swaps16, swapl32
+*
+* Revision 1.3  2002/04/30 03:07:34  orlando
+* Remove UIxx_T definitions to conform with new
+* naming conventions.
+*
+* Revision 1.2  2002/04/29 10:10:32  hiwu
+* add NTOHS macro
+*
+* Revision 1.1.1.1  2002/04/26 08:53:53  orlando
+* Initial source tree creation.
+*
+* Revision 1.9  2002/04/25 03:59:05  cfliu
+* no message
+*
+* Revision 1.8  2002/04/08 08:08:04  hiwu
+* initial version
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+*/
+
+#ifndef _RTL_TYPES_H
+#define _RTL_TYPES_H
+
+#define RTL_LAYERED_DRIVER_DEBUG 0
+
+#if 0
+#ifndef RTL865X_OVER_KERNEL
+#undef __KERNEL__
+#endif
+
+#ifndef RTL865X_OVER_LINUX
+#undef __linux__
+#endif
+#endif
+
+/*
+ * Internal names for basic integral types.  Omit the typedef if
+ * not possible for a machine/compiler combination.
+ */
+#ifdef __linux__
+#ifdef __KERNEL__
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+#include <linux/kconfig.h>
+#elif (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 0))
+#include <linux/config.h>
+#endif
+/* #include <linux/ctype.h> */
+#include <linux/module.h>
+/* #include <linux/string.h> */
+
+#endif /*__KERNEL__*/
+#endif /*__linux__*/
+
+/* ===============================================================================
+		IRAM / DRAM definition
+    =============================================================================== */
+#undef __DRAM_GEN
+#undef __DRAM_FWD
+#undef __DRAM_L2_FWD
+#undef __DRAM_L34_FWD
+#undef __DRAM_EXTDEV
+#undef __DRAM_AIRGO
+#undef __DRAM_RTKWLAN
+#undef __DRAM_CRYPTO
+#undef __DRAM_VOIP
+#undef __DRAM_TX
+#undef __DRAM
+
+#undef __IRAM_GEN
+#undef __IRAM_FWD
+#undef __IRAM_L2_FWD
+#undef __IRAM_L34_FWD
+#undef __IRAM_EXTDEV
+#undef __IRAM_AIRGO
+#undef __IRAM_RTKWLAN
+#undef __IRAM_CRYPTO
+#undef __IRAM_VOIP
+#undef __IRAM_TX
+#undef __IRAM
+
+#if defined(__linux__) && defined(__KERNEL__) && defined(CONFIG_RTL_819X) && !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F)
+#define __DRAM_GEN			__attribute__  ((section(".dram-gen")))
+#define __DRAM_FWD			__attribute__  ((section(".dram-fwd")))
+#define __DRAM_L2_FWD			__attribute__  ((section(".dram-l2-fwd")))
+#define __DRAM_L34_FWD			__attribute__  ((section(".dram-l34-fwd")))
+#define __DRAM_EXTDEV			__attribute__  ((section(".dram-extdev")))
+#define __DRAM_AIRGO			__attribute__  ((section(".dram-airgo")))
+#define __DRAM_RTKWLAN			__attribute__  ((section(".dram-rtkwlan")))
+#define __DRAM_CRYPTO			__attribute__  ((section(".dram-crypto")))
+#define __DRAM_VOIP			__attribute__  ((section(".dram-voip")))
+#define __DRAM_TX			__attribute__  ((section(".dram-tx")))
+#define __DRAM				__attribute__  ((section(".dram")))
+
+#define __IRAM_GEN			__attribute__  ((section(".iram-gen")))
+#define __IRAM_FWD			__attribute__  ((section(".iram-fwd")))
+#define __IRAM_L2_FWD			__attribute__  ((section(".iram-l2-fwd")))
+#define __IRAM_L34_FWD			__attribute__  ((section(".iram-l34-fwd")))
+#define __IRAM_EXTDEV			__attribute__  ((section(".iram-extdev")))
+#define __IRAM_AIRGO			__attribute__  ((section(".iram-airgo")))
+#define __IRAM_RTKWLAN			__attribute__  ((section(".iram-rtkwlan")))
+#define __IRAM_CRYPTO			__attribute__  ((section(".iram-crypto")))
+#define __IRAM_VOIP			__attribute__  ((section(".iram-voip")))
+#define __IRAM_TX			__attribute__  ((section(".iram-tx")))
+#define __IRAM				__attribute__  ((section(".iram")))
+#else
+#define __DRAM_GEN
+#define __DRAM_FWD
+#define __DRAM_L2_FWD
+#define __DRAM_L34_FWD
+#define __DRAM_EXTDEV
+#define __DRAM_AIRGO
+#define __DRAM_RTKWLAN
+#define __DRAM_CRYPTO
+#define __DRAM_VOIP
+#define __DRAM_TX
+#define __DRAM
+
+#define __IRAM_GEN
+#define __IRAM_FWD
+#define __IRAM_L2_FWD
+#define __IRAM_L34_FWD
+#define __IRAM_EXTDEV
+#define __IRAM_AIRGO
+#define __IRAM_RTKWLAN
+#define __IRAM_CRYPTO
+#define __IRAM_VOIP
+#define __IRAM_TX
+#define __IRAM
+#endif
+
+#if defined(CONFIG_RTL_DYNAMIC_IRAM_MAPPING_FOR_WAPI)
+#define __IRAM_GEN_WAPI			__attribute__  ((section(".iram-gen-wapi")))
+#define __IRAM_FWD_WAPI			__attribute__  ((section(".iram-fwd-wapi")))
+#define __IRAM_L2_FWD_WAPI		__attribute__  ((section(".iram-l2-fwd-wapi")))
+#define __IRAM_L34_FWD_WAPI		__attribute__  ((section(".iram-l34-fwd-wapi")))
+#define __IRAM_RTKWLAN_WAPI		__attribute__  ((section(".iram-rtkwlan-wapi")))
+#define __IRAM_TX_WAPI			__attribute__  ((section(".iram-tx-wapi")))
+
+#define FUNCTION_CHECK(x)	do \
+							{ \
+								if ((x) == NULL) \
+									printk("---%s %s(%d) function is NULL!!\n", __FILE__, __FUNCTION__, __LINE__); \
+							} while (0)
+#endif
+
+/* ===============================================================================
+		Additional GCC attribute
+    =============================================================================== */
+
+#undef __NOMIPS16
+#undef __MIPS16
+
+#if defined(__linux__) && defined(__KERNEL__) && defined(CONFIG_RTL_819X) && !defined(CONFIG_RTL_8196C) && !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F) && !defined(CONFIG_RTL_DISABLE_ETH_MIPS16)
+#define __NOMIPS16			__attribute__((nomips16))	/* Inidcate to prevent from MIPS16 */
+#define __MIPS16			__attribute__((mips16))	/* Inidcate to use MIPS16 */
+#else
+#define __NOMIPS16
+#define __MIPS16
+#endif
+
+/* ===============================================================================
+		print macro
+    =============================================================================== */
+#if	defined(__linux__) && defined(__KERNEL__)
+
+/* to_be_checked !!!, since kernel does not has panic_printk */
+/* #ifdef CONFIG_RTL_8198C // modified by lynn_pu, 2014-10-21 */
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F) || (defined(CONFIG_RLX) && (LINUX_VERSION_CODE >= KERNEL_VERSION(3, 10, 0))) || defined(CONFIG_OPENWRT_SDK)
+#define  rtlglue_printf		printk
+#define  panic_printk		printk
+#else
+#define rtlglue_printf	panic_printk
+#endif
+
+#else /* defined(__linux__) && defined(__KERNEL__) */
+
+#ifdef	RTL865X_TEST
+#include <ctype.h>
+#endif /* RTL865X_TEST */
+
+#define rtlglue_printf	printf
+
+#endif /* defined(__linux__) && defined(__KERNEL__) */
+
+/* ===============================================================================
+		Type definition
+    =============================================================================== */
+#if 1
+typedef unsigned long long uint64;
+typedef long long int64;
+typedef unsigned int uint32;
+
+#ifndef int32
+/* #undef int32 */
+#if defined(CONFIG_OPENWRT_SDK) || defined(CONFIG_RTD_1295_HWNAT)
+#ifndef _SLHC_H
+typedef int int32;
+#endif
+#else /* defined(CONFIG_OPENWRT_SDK) || defined(CONFIG_RTD_1295_HWNAT) */
+typedef int int32;
+#endif /* defined(CONFIG_OPENWRT_SDK) || defined(CONFIG_RTD_1295_HWNAT) */
+#endif
+
+typedef unsigned short uint16;
+typedef short int16;
+typedef unsigned char uint8;
+typedef char int8;
+
+#else
+typedef __u64 uint64;
+typedef __s64 int64;
+typedef __u32 uint32;
+
+#ifndef int32
+typedef __s32 int32;
+#endif
+typedef __u16 uint16;
+typedef __s16 int16;
+typedef __u8 uint8;
+typedef __s8 int8;
+#endif
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+typedef uintptr_t memaddr;
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+typedef uint32 memaddr;
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+typedef uint32 ipaddr_t;
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+/*copy from in6.h*/
+typedef struct inv6_addr_s {
+	union {
+		__u8 u6_addr8[16];
+		uint16 u6_addr16[8];
+		uint32 u6_addr32[4];
+	} inv6_u;
+#define v6_addr			inv6_u.u6_addr8
+#define v6_addr16		inv6_u.u6_addr16
+#define v6_addr32		inv6_u.u6_addr32
+} inv6_addr_t;
+#endif
+
+typedef struct {
+	uint16 mac47_32;
+	uint16 mac31_16;
+	uint16 mac15_0;
+} macaddr_t;
+
+#define ETHER_ADDR_LEN				6
+typedef struct ether_addr_s {
+	uint8 octet[ETHER_ADDR_LEN];
+} ether_addr_t;
+
+#if defined(CONFIG_RTD_1295_HWNAT)
+#define RX_OFFSET       2
+#else /* defined(CONFIG_RTD_1295_HWNAT) */
+#if defined(CONFIG_RTL_ULINKER_BRSC)
+#define RX_OFFSET	4
+#else
+#define RX_OFFSET	2
+#endif
+#endif /* defined(CONFIG_RTD_1295_HWNAT) */
+
+#if 1
+#if defined(CONFIG_RTL_JUMBO_FRAME)
+#if defined(CONFIG_RTD_1295_HWNAT) && !defined(CONFIG_RTL_836X_SUPPORT)
+#define MBUF_LEN	9220
+#else /* CONFIG_RTD_1295_HWNAT && !CONFIG_RTL_836X_SUPPORT */
+#define MBUF_LEN	2100
+#endif /* CONFIG_RTD_1295_HWNAT && !CONFIG_RTL_836X_SUPPORT */
+#else
+#define MBUF_LEN	1540 //8: double vlan tag, 4: L2 CRC //1536
+#endif /* CONFIG_RTL_JUMBO_FRAME */
+#define CROSS_LAN_MBUF_LEN		(MBUF_LEN+RX_OFFSET+16) // 16: WAPI MIC or 8+4: tkip MIC/ICV
+#else
+#define MBUF_LEN	1700
+#define CROSS_LAN_MBUF_LEN		(MBUF_LEN+RX_OFFSET+10)
+#endif
+
+#if defined(CONFIG_RTL_819X)
+#if defined(CONFIG_RTL_ETH_PRIV_SKB) && !defined(CONFIG_RTL_8198C) && !defined(CONFIG_RTL_8197F)
+#define DELAY_REFILL_ETH_RX_BUF	1
+#endif
+
+#if defined(CONFIG_RTL_ETH_PRIV_SKB)
+#define PRIV_BUF_CAN_USE_KERNEL_BUF		1
+#define INIT_RX_RING_ERR_HANDLE			1
+	/* #define ALLOW_RX_RING_PARTIAL_EMPTY           1 */
+#endif
+#endif
+
+#ifndef NULL
+#define NULL 0
+#endif
+#ifndef TRUE
+#define TRUE 1
+#endif
+#ifndef FALSE
+#define FALSE 0
+#endif
+
+#ifndef SUCCESS
+#define SUCCESS 	0
+#endif
+#ifndef FAILED
+#define FAILED -1
+#endif
+
+#define DEBUG_P(args...) while (0);
+#ifndef OK
+#define OK		0
+#endif
+#ifndef NOT_OK
+#define NOT_OK  1
+#endif
+
+#ifndef CLEARBITS
+#define CLEARBITS(a, b)	((a) &= ~(b))
+#endif
+
+#ifndef SETBITS
+#define SETBITS(a, b)		((a) |= (b))
+#endif
+
+#ifndef ISSET
+#define ISSET(a, b)		(((a) & (b)) != 0)
+#endif
+
+#ifndef ISCLEARED
+#define ISCLEARED(a, b)	(((a) & (b)) == 0)
+#endif
+
+#ifndef max
+#define max(a, b)  (((a) > (b)) ? (a) : (b))
+#endif /* max */
+
+#ifndef min
+#define min(a, b)  (((a) < (b)) ? (a) : (b))
+#endif /* min */
+
+/* round down x to multiple of y.  Ex: ROUNDDOWN(20, 7)=14 */
+#ifndef ROUNDDOWN
+#define	ROUNDDOWN(x, y)	(((x)/(y))*(y))
+#endif
+
+/* round up x to multiple of y. Ex: ROUNDUP(11, 7) = 14 */
+#ifndef ROUNDUP
+#define	ROUNDUP(x, y)	((((x)+((y)-1))/(y))*(y))	/* to any y */
+#endif
+
+#ifndef ROUNDUP2
+#define	ROUNDUP2(x, y)	(((x)+((y)-1))&(~((y)-1)))	/* if y is powers of two */
+#endif
+
+#ifndef ROUNDUP4
+#define	ROUNDUP4(x)		((1+(((x)-1)>>2))<<2)
+#endif
+
+#ifndef IS4BYTEALIGNED
+#define IS4BYTEALIGNED(x)	 ((((x) & 0x3) == 0) ? 1 : 0)
+#endif
+
+#ifndef __offsetof
+#define __offsetof(type, field) ((unsigned long)(&((type *)0)->field))
+#endif
+
+#ifndef offsetof
+#define offsetof(type, field) __offsetof(type, field)
+#endif
+
+#ifndef RTL_PROC_CHECK
+#define RTL_PROC_CHECK(expr, success) \
+	do {\
+			int __retval; \
+			if ((__retval = (expr)) != (success))\
+			{\
+				rtlglue_printf("ERROR >>> [%s]:[%d] failed -- return value: %d\n", __FUNCTION__, __LINE__, __retval);\
+				return __retval; \
+			} \
+		} while (0)
+#endif
+
+#ifndef RTL_STREAM_SAME
+#define RTL_STREAM_SAME(s1, s2) \
+	((strlen(s1) == strlen(s2)) && (strcmp(s1, s2) == 0))
+#endif
+
+#define ASSERT_ISR(x) if (!(x)) {while (1); }
+#define RTL_STATIC_INLINE   static inline
+
+#define ASSERT_CSP(x) if (!(x)) {rtlglue_printf("\nAssert Fail: %s %d", __FILE__, __LINE__); while (1); }
+
+#if defined(RTL865X_TEST) || defined(RTL865X_MODEL_USER)
+#define UNCACHE_MASK		0
+#define UNCACHE(addr)		(addr)
+#define CACHED(addr)		((uint32)(addr))
+#else
+#define UNCACHE_MASK		0x20000000
+#define UNCACHE(addr)		((UNCACHE_MASK)|(uint32)(addr))
+#define CACHED(addr)		((uint32)(addr) & ~(UNCACHE_MASK))
+#endif
+
+/*	asic configuration	*/
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define RTL8651_OUTPUTQUEUE_SIZE		8
+#else
+#define RTL8651_OUTPUTQUEUE_SIZE		6
+#endif
+#define TOTAL_VLAN_PRIORITY_NUM			8
+#define RTL8651_RATELIMITTBL_SIZE		32
+
+#define VLAN_ETH_ALEN	6	/* Octets in one ethernet addr   */
+
+#define NIPQUAD(addr) \
+	((unsigned char *)&addr)[0], \
+	((unsigned char *)&addr)[1], \
+	((unsigned char *)&addr)[2], \
+	((unsigned char *)&addr)[3]
+
+#if defined(CONFIG_RTL_8196C)
+#define CONFIG_RTL8196C_ETH_IOT         1
+#ifdef CONFIG_MP_PSD_SUPPORT
+#undef CONFIG_RTL8196C_GREEN_ETHERNET
+#else
+/* #define CONFIG_RTL_8196C_ESD            1 */
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8198) && !defined(CONFIG_RTL_819XD)
+#define CONFIG_RTL_8198_ESD        1
+#endif
+
+#if defined(CONFIG_RTL_8198)
+#define RTL8198_EEE_MAC 	1
+#endif
+
+#if defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8196E)
+#define CONFIG_RTL_8197D_DYN_THR		1
+#endif
+
+#define DYN_THR_LINK_UP_PORTS			3
+
+#ifdef CONFIG_RTL_8881A
+/* IC default value */
+#define DYN_THR_DEF_fcON			0x1ac
+#define DYN_THR_DEF_fcOFF			0x1a0
+#define DYN_THR_DEF_sharedON			0x162
+#define DYN_THR_DEF_sharedOFF			0x14a
+
+/* aggressive value */
+#define DYN_THR_AGG_fcON			0x1d2
+#define DYN_THR_AGG_fcOFF			0x1ba
+#define DYN_THR_AGG_sharedON			0x190
+#define DYN_THR_AGG_sharedOFF			0x178
+#else
+/* IC default value */
+#define DYN_THR_DEF_fcON			0xac
+#define DYN_THR_DEF_fcOFF			0xa0
+#define DYN_THR_DEF_sharedON			0x62
+#define DYN_THR_DEF_sharedOFF			0x4a
+
+/* aggressive value */
+#define DYN_THR_AGG_fcON			0xd0
+#define DYN_THR_AGG_fcOFF			0xa0	/* 0xc0 */
+#if defined(CONFIG_RTL_819XDT)
+#define DYN_THR_AGG_sharedON			0xa0
+#define DYN_THR_AGG_sharedOFF			0x88
+#else
+#define DYN_THR_AGG_sharedON			0x88	/* 0xc0 */
+#define DYN_THR_AGG_sharedOFF			0x70	/* 0xa8 */
+#endif
+#endif
+#if defined(CONFIG_RTL_LOG_DEBUG)
+extern int scrlog_printk(const char *fmt, ...);
+
+extern struct RTL_LOG_PRINT_MASK {
+	uint32 ERROR:1;
+	uint32 WARN:1;
+	uint32 INFO:1;
+} RTL_LogTypeMask;
+
+extern struct RTL_LOG_ERROR_MASK {
+	uint32 MEM:1;
+	uint32 SKB:1;
+} RTL_LogErrorMask;
+extern uint32 RTL_LogRatelimit;
+
+extern struct RTL_LOG_MODULE_MASK {
+	uint8 NIC:1;
+	uint8 WIRELESS:1;
+	uint8 PROSTACK:1;
+} RTL_LogModuleMask;
+
+#define LOG_LIMIT (!RTL_LogRatelimit || net_ratelimit())
+
+#define LOG_ERROR(fmt, args...) do { \
+	if (RTL_LogTypeMask.ERROR && LOG_LIMIT)scrlog_printk("ERROR:"fmt, ## args); \
+		} while (0)
+
+#define LOG_MEM_ERROR(fmt, args...) do { \
+	if (RTL_LogTypeMask.ERROR && RTL_LogErrorMask.MEM && LOG_LIMIT)scrlog_printk("ERROR:"fmt, ## args); \
+		} while (0)
+
+#define LOG_SKB_ERROR(fmt, args...) do { \
+		if (RTL_LogTypeMask.ERROR && RTL_LogErrorMask.SKB && LOG_LIMIT)scrlog_printk("ERROR:"fmt, ## args); \
+			} while (0)
+
+#define LOG_WARN(fmt, args...) do { \
+		if (RTL_LogTypeMask.WARN && LOG_LIMIT)scrlog_printk("WARN:"fmt, ## args); \
+			} while (0)
+
+#define LOG_INFO(fmt, args...) do { \
+		if (RTL_LogTypeMask.INFO && LOG_LIMIT)scrlog_printk("INFO:"fmt, ## args); \
+			} while (0)
+
+#else
+
+#define LOG_ERROR(fmt, args...)
+#define LOG_MEM_ERROR(fmt, args...)
+#define LOG_SKB_ERROR(fmt, args...)
+#define LOG_WARN(fmt, args...)
+#define LOG_INFO(fmt, args...)
+
+#endif
+
+#ifdef CONFIG_SMP
+#include <linux/spinlock.h>
+
+extern int lock_owner;
+extern int lock_owner_rx;
+extern int lock_owner_tx;
+extern int lock_owner_buf;
+extern int lock_owner_hw;
+extern int lock_owner_event;
+extern spinlock_t lock_eth_other;
+extern spinlock_t lock_eth_rx;
+extern spinlock_t lock_eth_tx;
+extern spinlock_t lock_eth_buf;
+extern spinlock_t lock_eth_hw;
+extern spinlock_t lock_eth_event;
+
+#if 1
+/* ============ release version ============ */
+#define SMP_LOCK_ETH(__x__)			spin_lock_irqsave(&lock_eth_other, (__x__))
+#define SMP_UNLOCK_ETH(__x__) 			spin_unlock_irqrestore(&lock_eth_other, (__x__))
+
+#define SMP_LOCK_ETH_XMIT(__x__)		spin_lock_irqsave(&lock_eth_tx, (__x__))
+#define SMP_UNLOCK_ETH_XMIT(__x__) 		spin_unlock_irqrestore(&lock_eth_tx, (__x__))
+
+#define SMP_LOCK_ETH_RECV(__x__)		spin_lock_irqsave(&lock_eth_rx, (__x__))
+#define SMP_UNLOCK_ETH_RECV(__x__) 		spin_unlock_irqrestore(&lock_eth_rx, (__x__))
+
+#define SMP_LOCK_ETH_BUF(__x__)			spin_lock_irqsave(&lock_eth_buf, (__x__))
+#define SMP_UNLOCK_ETH_BUF(__x__) 		spin_unlock_irqrestore(&lock_eth_buf, (__x__))
+
+#define SMP_LOCK_ETH_HW(__x__)			spin_lock_irqsave(&lock_eth_hw, (__x__))
+#define SMP_UNLOCK_ETH_HW(__x__) 		spin_unlock_irqrestore(&lock_eth_hw, (__x__))
+
+#define SMP_LOCK_ETH_EVENT(__x__)		spin_lock_irqsave(&lock_eth_event, (__x__))
+#define SMP_UNLOCK_ETH_EVENT(__x__) 		spin_unlock_irqrestore(&lock_eth_event, (__x__))
+#else
+
+/* ============ debug version ============ */
+#define SMP_LOCK_ETH(__x__)	\
+	do { \
+		if (lock_owner != smp_processor_id()) \
+			spin_lock_irqsave(&lock_eth_other, (__x__)); \
+		else \
+			rtlglue_printf("[%s %s %d] recursion detection in ETH\n", __FILE__, __FUNCTION__, __LINE__); \
+		lock_owner = smp_processor_id();\
+	} while (0)
+
+#define SMP_UNLOCK_ETH(__x__) \
+	do { \
+		lock_owner = -1; \
+		spin_unlock_irqrestore(&lock_eth_other, (__x__)); \
+	} while (0)
+
+#define SMP_LOCK_ETH_XMIT(__x__)	\
+	do { \
+		if (lock_owner_tx != smp_processor_id()) \
+			spin_lock_irqsave(&lock_eth_tx, (__x__)); \
+		else \
+			rtlglue_printf("[%s %d] recursion detection in XMIT\n", __FUNCTION__, __LINE__); \
+		lock_owner_tx = smp_processor_id();\
+	} while (0)
+
+#define SMP_UNLOCK_ETH_XMIT(__x__) \
+	do { \
+		lock_owner_tx = -1; \
+		spin_unlock_irqrestore(&lock_eth_tx, (__x__)); \
+	} while (0)
+
+#define SMP_LOCK_ETH_RECV(__x__)	\
+	do { \
+		if (lock_owner_rx != smp_processor_id()) \
+			spin_lock_irqsave(&lock_eth_rx, (__x__)); \
+		else \
+			rtlglue_printf("[%s %d] recursion detection in RECV\n", __FUNCTION__, __LINE__); \
+		lock_owner_rx = smp_processor_id();\
+	} while (0)
+
+#define SMP_UNLOCK_ETH_RECV(__x__) \
+	do { \
+		lock_owner_rx = -1; \
+		spin_unlock_irqrestore(&lock_eth_rx, (__x__)); \
+	} while (0)
+
+#define SMP_LOCK_ETH_BUF(__x__)	\
+	do { \
+		if (lock_owner_buf != smp_processor_id()) {\
+			spin_lock_irqsave(&lock_eth_buf, (__x__)); \
+		} else \
+			rtlglue_printf("[%s %d] recursion detection in BUF\n", __FUNCTION__, __LINE__); \
+		lock_owner_buf = smp_processor_id();\
+	} while (0)
+
+#define SMP_UNLOCK_ETH_BUF(__x__) \
+	do { \
+		lock_owner_buf = -1; \
+		spin_unlock_irqrestore(&lock_eth_buf, (__x__)); \
+	} while (0)
+
+#define SMP_LOCK_ETH_HW(__x__)	\
+	do { \
+		if (lock_owner_hw != smp_processor_id()) \
+			spin_lock_irqsave(&lock_eth_hw, (__x__)); \
+		else \
+			rtlglue_printf("[%s %d] recursion detection in HW\n", __FUNCTION__, __LINE__); \
+		lock_owner_hw = smp_processor_id();\
+	} while (0)
+
+#define SMP_UNLOCK_ETH_HW(__x__) \
+	do { \
+		lock_owner_hw = -1; \
+		spin_unlock_irqrestore(&lock_eth_hw, (__x__)); \
+	} while (0)
+#endif
+
+#if defined(CONFIG_RTL819X_SPI_FLASH)
+extern spinlock_t lock_spi;
+
+#define SMP_LOCK_ETH_CACHE(__x__)		(__x__++)	/* spin_lock_irqsave(&lock_spi, (__x__)) */
+#define SMP_UNLOCK_ETH_CACHE(__x__) 		(__x__++)	/* spin_unlock_irqrestore(&lock_spi, (__x__)) */
+#else
+#define SMP_LOCK_ETH_CACHE(x)			(x++)
+#define SMP_UNLOCK_ETH_CACHE(x) 		(x++)
+#endif
+
+#define SMP_LOCK_ETH2(x)			(x++)
+#define SMP_UNLOCK_ETH2(x)			(x++)
+
+#else
+#define SMP_LOCK_ETH(x)				local_irq_save(x)
+#define SMP_UNLOCK_ETH(x)			local_irq_restore(x)
+
+#define SMP_LOCK_ETH_XMIT(x)			local_irq_save(x)
+#define SMP_UNLOCK_ETH_XMIT(x)			local_irq_restore(x)
+
+#define SMP_LOCK_ETH_RECV(x)			local_irq_save(x)
+#define SMP_UNLOCK_ETH_RECV(x)			local_irq_restore(x)
+
+#define SMP_LOCK_ETH_BUF(x)			local_irq_save(x)
+#define SMP_UNLOCK_ETH_BUF(x)			local_irq_restore(x)
+
+#define SMP_LOCK_ETH_HW(x)			local_irq_save(x)
+#define SMP_UNLOCK_ETH_HW(x)			local_irq_restore(x)
+
+#define SMP_LOCK_ETH2(x)			local_irq_save(x)
+#define SMP_UNLOCK_ETH2(x)			local_irq_restore(x)
+
+#endif
+
+#ifdef __KERNEL__
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0)
+#define CONFIG_RTL_PROC_NEW		1
+#endif
+#endif
+
+#ifdef CONFIG_CPU_LITTLE_ENDIAN
+#define _LITTLE_ENDIAN			1
+#endif
+
+#ifdef CONFIG_RTL_8197F
+#define CONFIG_RTL_SWITCH_NEW_DESCRIPTOR	1
+#endif
+/* move this two definitions from linux_menuconfig to here due to they are too obviously. */
+#if !defined(CONFIG_RTL_AP_PACKAGE) && !defined(CONFIG_OPENWRT_SDK)
+#define REINIT_SWITCH_CORE	1
+/* #define CONFIG_RTL_CHECK_SWITCH_TX_HANGUP     1 */
+
+#endif
+
+#ifdef CONFIG_RTL_SWITCH_NEW_DESCRIPTOR
+#define RTL_swNic_init(a, b, c, d)		New_swNic_init(a, c, d)
+#define RTL_swNic_send(a, b, c, d)		New_swNic_send(a, b, c, d)
+#define RTL_swNic_receive(a, b)			New_swNic_receive(a, b)
+#define RTL_swNic_txDone(a)			New_swNic_txDone(a)
+#define RTL_swNic_freeRxBuf()			New_swNic_freeRxBuf()
+#define RTL_dumpRxRing(a)			New_dumpRxRing(a)
+#define RTL_dumpTxRing(a)			New_dumpTxRing(a)
+#define RTL_dumpMbufRing(a)
+#define RTL_swNic_reInit()			New_swNic_reInit()
+#define RTL_check_tx_own(a)			New_check_tx_done_desc_swCore_own(a)
+#else
+#define RTL_swNic_init(a, b, c, d)		swNic_init(a, b, c, d)
+#define RTL_swNic_send(a, b, c, d)		swNic_send(a, b, c, d)
+#define RTL_swNic_receive(a, b)			swNic_receive(a, b)
+#define RTL_swNic_txDone(a)			swNic_txDone(a)
+#define RTL_swNic_freeRxBuf()			swNic_freeRxBuf()
+#define RTL_dumpRxRing(a)			rtl_dumpRxRing(a)
+#define RTL_dumpTxRing(a)			rtl_dumpTxRing(a)
+#define RTL_dumpMbufRing(a)			rtl_dumpMbufRing(a)
+#define RTL_swNic_reInit()			swNic_reInit()
+#define RTL_check_tx_own(a)			rtl_check_tx_done_desc_swCore_own(a)
+#endif
+
+#if defined(CONFIG_RTL_8198C) || defined(CONFIG_RTL_8197F)
+#define RTL_CACHE_WBACK(x, y)		_dma_cache_wback(x, y)
+#else
+#define RTL_CACHE_WBACK(x, y)		_dma_cache_wback_inv(x, y)
+#endif
+
+#if defined(__linux__) && defined(__KERNEL__)
+
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3, 0, 0)
+#undef CONFIG_RTL_GSO
+#endif
+
+#endif
+
+#if defined(CONFIG_RTL_GSO)
+
+		/* these features are needed for GSO */
+#if defined(CONFIG_RTL_SWITCH_NEW_DESCRIPTOR)
+#define CONFIG_RTL_97F_HW_TX_CSUM            1
+#else
+#if (defined(CONFIG_RTL_819XD) || defined(CONFIG_RTL_8881A)) && defined(CONFIG_IPV6)
+			/* for 97D/8881A and older IC, they do not support HW L4 csum offload for IPv6+TCP/UDP packet. */
+#else
+#define CONFIG_RTL_HW_TX_CSUM 		1
+#endif
+#define CONFIG_RTL_ETH_TX_SG 		1
+#endif
+#else
+#if defined(CONFIG_RTL_SWITCH_NEW_DESCRIPTOR)
+#define CONFIG_RTL_97F_HW_TX_CSUM            1
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_TSO) && !defined(CONFIG_RTL_8367R_SUPPORT)
+	/* #define CONFIG_RTL_ADAPTABLE_TSO */
+#endif
+
+#if defined(CONFIG_RTL_WTDOG)
+#define WATCHDOG_NUM_OF_TIMES 8
+void rtl_periodic_watchdog_kick(unsigned int count, unsigned int times);
+#endif
+
+#if !defined(__KERNEL__)
+#define GET_BR_PORT(netdev)	(netdev)->br_port
+#else
+#if LINUX_VERSION_CODE <= KERNEL_VERSION(2, 6, 35)
+#define GET_BR_PORT(netdev)	(netdev)->br_port
+#else
+#define GET_BR_PORT(netdev)	br_port_get_rcu(netdev)
+#endif
+#endif
+
+#if defined(CONFIG_RTL_8197F) && defined(CONFIG_RTL_8211F_SUPPORT)
+extern int gpio_simulate_mdc_mdio;
+#endif
+
+/*
+ * Hardware multicast debug option
+ */
+#define CONFIG_HW_MCAST_DEBUG 1
+
+#endif
diff --git a/include/net/sock.h b/include/net/sock.h
index 6d42ed8..badd144 100644
--- a/include/net/sock.h
+++ b/include/net/sock.h
@@ -419,6 +419,7 @@ struct sock {
 	u32			sk_max_ack_backlog;
 	__u32			sk_priority;
 	__u32			sk_mark;
+	kuid_t			sk_uid;
 	struct pid		*sk_peer_pid;
 	const struct cred	*sk_peer_cred;
 	long			sk_rcvtimeo;
@@ -1647,6 +1648,7 @@ static inline void sock_graft(struct sock *sk, struct socket *parent)
 	sk->sk_wq = parent->wq;
 	parent->sk = sk;
 	sk_set_socket(sk, parent);
+	sk->sk_uid = SOCK_INODE(parent)->i_uid;
 	security_sock_graft(sk, parent);
 	write_unlock_bh(&sk->sk_callback_lock);
 }
@@ -1654,6 +1656,11 @@ static inline void sock_graft(struct sock *sk, struct socket *parent)
 kuid_t sock_i_uid(struct sock *sk);
 unsigned long sock_i_ino(struct sock *sk);
 
+static inline kuid_t sock_net_uid(const struct net *net, const struct sock *sk)
+{
+	return sk ? sk->sk_uid : make_kuid(net->user_ns, 0);
+}
+
 static inline u32 net_tx_rndhash(void)
 {
 	u32 v = prandom_u32();
diff --git a/include/net/tcp.h b/include/net/tcp.h
index 97d2105..8d4ad17 100644
--- a/include/net/tcp.h
+++ b/include/net/tcp.h
@@ -271,6 +271,7 @@
 extern int sysctl_tcp_invalid_ratelimit;
 extern int sysctl_tcp_pacing_ss_ratio;
 extern int sysctl_tcp_pacing_ca_ratio;
+extern int sysctl_tcp_default_init_rwnd;
 
 extern atomic_long_t tcp_memory_allocated;
 extern struct percpu_counter tcp_sockets_allocated;
@@ -1510,6 +1511,9 @@ struct sock *tcp_try_fastopen(struct sock *sk, struct sk_buff *skb,
 			      struct tcp_fastopen_cookie *foc,
 			      struct dst_entry *dst);
 void tcp_fastopen_init_key_once(bool publish);
+bool tcp_fastopen_cookie_check(struct sock *sk, u16 *mss,
+			     struct tcp_fastopen_cookie *cookie);
+bool tcp_fastopen_defer_connect(struct sock *sk, int *err);
 #define TCP_FASTOPEN_KEY_LENGTH 16
 
 /* Fastopen key context */
diff --git a/include/net/xfrm.h b/include/net/xfrm.h
index 835c30e..9b6e6a4 100644
--- a/include/net/xfrm.h
+++ b/include/net/xfrm.h
@@ -155,6 +155,7 @@ struct xfrm_state {
 		int		header_len;
 		int		trailer_len;
 		u32		extra_flags;
+		u32		output_mark;
 	} props;
 
 	struct xfrm_lifetime_cfg lft;
@@ -284,10 +285,12 @@ struct xfrm_policy_afinfo {
 	struct dst_entry	*(*dst_lookup)(struct net *net,
 					       int tos, int oif,
 					       const xfrm_address_t *saddr,
-					       const xfrm_address_t *daddr);
+					       const xfrm_address_t *daddr,
+					       u32 mark);
 	int			(*get_saddr)(struct net *net, int oif,
 					     xfrm_address_t *saddr,
-					     xfrm_address_t *daddr);
+					     xfrm_address_t *daddr,
+					     u32 mark);
 	void			(*decode_session)(struct sk_buff *skb,
 						  struct flowi *fl,
 						  int reverse);
diff --git a/include/soc/realtek/avcpu.h b/include/soc/realtek/avcpu.h
new file mode 100644
index 00000000..69b2b9a
--- /dev/null
+++ b/include/soc/realtek/avcpu.h
@@ -0,0 +1,279 @@
+/*
+ * Realtek Audio & Video cpu driver
+ *
+ * Copyright (c) 2011 EJ Hsu <ejhsu@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License.
+ *
+ * History:
+ *
+ * 2011-12-02:  EJ Hsu: first version
+ * 2013-05-02:  EJ Hsu: port to arm platform
+ */
+
+#ifndef _LINUX_AVCPU_H
+#define _LINUX_AVCPU_H
+
+#include <generated/autoconf.h>
+#include <linux/module.h>
+#include <linux/kernel.h>
+
+#define AUDIO_CPU               1
+#define VIDEO_CPU_1             2
+#define VIDEO_CPU_2             3
+
+#define AUDIO_ENTRY_ADDR        (PAGE_OFFSET+0xe0)
+#define VIDEO_ENTRY_ADDR_1      (PAGE_OFFSET+0xe4)
+#define VIDEO_ENTRY_ADDR_2      (PAGE_OFFSET+0xdc)
+
+#define AVCPU_MAJOR             241
+
+#define AVCPU_SUSPEND           100
+#define AVCPU_RESUME            101
+#define AVCPU_RESET_PREPARE     102
+#define AVCPU_RESET_DONE        103
+
+#define AVSTAT_NORMAL   0
+#define AVSTAT_SUSPEND  1
+#define AVSTAT_RESUME   2
+#define AVSTAT_RESETAV  3
+
+
+#ifdef CONFIG_RTK_ACPU_RELOAD
+
+#define FW_DESC_TABLE_V1_T_VERSION_1            0x1
+#define FW_DESC_TABLE_V1_T_VERSION_11           0x11
+#define FW_DESC_TABLE_V1_T_VERSION_21           0x21
+
+#define FW_DESC_TABLE_V2_T_VERSION_2            0x2
+#define FW_DESC_TABLE_V2_T_VERSION_12           0x12
+#define FW_DESC_TABLE_V2_T_VERSION_22           0x22
+
+#define FW_DESC_BASE_VERSION(v)                 ((v) & 0xf)
+#define FW_DESC_EXT_VERSION(v)                  ((v) >> 4)
+
+int register_avcpu_notifier(struct notifier_block *nb);
+int unregister_avcpu_notifier(struct notifier_block *nb);
+
+int resetav_lock(int is_suspend);
+int resetav_unlock(int is_suspend);
+
+int load_av_image(char *, unsigned int, char *, unsigned int, char *, unsigned int);
+
+typedef enum {
+    FW_TYPE_RESERVED = 0,
+    FW_TYPE_BOOTCODE,
+    FW_TYPE_KERNEL,
+    FW_TYPE_RESCUE_DT,
+    FW_TYPE_KERNEL_DT,
+    FW_TYPE_RESCUE_ROOTFS,
+    FW_TYPE_KERNEL_ROOTFS,
+    FW_TYPE_AUDIO,
+    FW_TYPE_AUDIO_FILE,
+    FW_TYPE_VIDEO_FILE,
+    FW_TYPE_EXT4,
+    FW_TYPE_UBIFS,
+    FW_TYPE_SQUASH,
+    FW_TYPE_EXT3,
+    FW_TYPE_ODD,
+    FW_TYPE_YAFFS2,
+    FW_TYPE_ISO,
+    FW_TYPE_SWAP,
+    FW_TYPE_NTFS,
+    FW_TYPE_JFFS2,
+    FW_TYPE_IMAGE_FILE,
+    FW_TYPE_VIDEO,
+    FW_TYPE_VIDEO2,
+    FW_TYPE_ECPU,
+    FW_TYPE_UNKNOWN
+} fw_type_code_t;
+
+typedef enum {
+    RTK_PLAT_ERR_OK = 0,
+    RTK_PLAT_ERR_PARSE_FW_DESC,
+    RTK_PLAT_ERR_READ_FW_IMG,
+    RTK_PLAT_ERR_READ_KERNEL_IMG,
+    RTK_PLAT_ERR_READ_RESCUE_IMG,
+    RTK_PLAT_ERR_BOOT,
+} rtk_plat_err_t;
+
+typedef enum {
+    FS_TYPE_JFFS2 = 0,
+    FS_TYPE_YAFFS2,
+    FS_TYPE_SQUASH,
+    FS_TYPE_RAWFILE,
+    FS_TYPE_EXT4,
+    FS_TYPE_UBIFS,
+    FS_TYPE_NONE,
+    FS_TYPE_UNKOWN
+} rtk_part_fw_type_t;
+
+typedef struct {
+    char            *audio_image;
+    unsigned int        audio_start;
+    char            *video_image_1;
+    unsigned int        video_start_1;
+    char            *video_image_2;
+    unsigned int        video_start_2;
+} resetav_struct;
+
+typedef struct {
+    unsigned int    timeout; //in ms
+    int             status;
+} status_struct;
+
+typedef struct {
+    wait_queue_head_t   status_wq;
+    int                 status;
+} avcpu_info;
+
+typedef struct {
+    u8          signature[8];
+    u32         checksum;
+    u8          version;    //0x00
+    u8          reserved[15];
+    u32         length;
+} __attribute__((packed)) fw_desc_table_t;
+
+typedef struct {
+    u8          signature[8];
+    u32         checksum;
+    u8          version;    //0x01
+    u8          reserved[7];
+    u32         paddings;
+    u32         part_list_len;
+    u32         fw_list_len;
+} __attribute__((packed)) fw_desc_table_v1_t;
+
+typedef struct {
+    u8          type;
+    u8          reserved:7,
+                ro:1;
+    u64         length;
+    u8          fw_count;
+    u8          fw_type;
+    //#ifdef CONFIG_SYS_RTK_EMMC_FLASH
+#if 1
+    u8   emmc_partIdx;
+    u8   reserved_1[3];
+#else
+    u8   reserved_1[4];
+#endif
+    u8          mount_point[32];
+} __attribute__((packed)) part_desc_entry_v1_t;
+
+typedef struct {
+    u8          type;
+    u8          reserved:6,
+                lzma:1,
+                ro:1;
+    u32         version;
+    u32         target_addr;
+    u32         offset;
+    u32         length;
+    u32         paddings;
+    u32         checksum;
+    u8          reserved_1[6];
+} __attribute__((packed)) fw_desc_entry_v1_t;
+
+typedef struct {
+    fw_desc_entry_v1_t  v1;
+    u32         act_size;
+    u8          hash[32];
+    u8          part_num;
+    u8          reserved[27];
+} __attribute__((packed)) fw_desc_entry_v11_t;
+
+typedef struct {
+    fw_desc_entry_v1_t v1;
+    u32         act_size;
+    u8          part_num;
+    u8          RSA_sign[256];
+    u8          reserved[27];
+} __attribute__((packed)) fw_desc_entry_v21_t;
+
+// Version 2, offset->u64 / checksum->sha256
+typedef struct {
+	u8   type;
+#ifdef LITTLE_ENDIAN
+	u8   reserved:6,
+		lzma:1,
+		ro:1;
+#else
+	u8   ro:1,
+		lzma:1,
+		reserved:6;
+#endif
+	u32    version;
+	u32    target_addr;
+	u64     offset;
+	u32    length;
+	u32    paddings;
+	u8   sha_hash[32];;
+	u8   reserved_1[6];
+} __attribute__((packed)) fw_desc_entry_v2_t;
+
+// for fw_desc_table_v1_t.version = FW_DESC_TABLE_V1_T_VERSION_11
+typedef struct {
+	fw_desc_entry_v2_t v2;
+	u32    act_size;
+	u8   hash[32];
+	u8   part_num;
+	u8   reserved[27];
+} __attribute__((packed)) fw_desc_entry_v12_t;
+
+// for fw_desc_table_v1_t.version = FW_DESC_TABLE_V1_T_VERSION_21
+typedef struct {
+	fw_desc_entry_v2_t v2;
+	u32    act_size;
+	u8   part_num;
+	u8   RSA_sign[256];
+	u8   reserved[27];
+} __attribute__((packed)) fw_desc_entry_v22_t;
+
+#define FW_ENTRY_MEMBER_SET(val, fw_entry, member, version) \
+{ \
+	fw_desc_entry_v1_t* entry_v1 = (fw_desc_entry_v1_t*)fw_entry; \
+	fw_desc_entry_v2_t* entry_v2 = (fw_desc_entry_v2_t*)fw_entry; \
+	if (FW_DESC_BASE_VERSION(version) == FW_DESC_TABLE_V1_T_VERSION_1) \
+		entry_v1->member = val; \
+	else if (FW_DESC_BASE_VERSION(version) == FW_DESC_TABLE_V2_T_VERSION_2) \
+		entry_v2->member = val; \
+} \
+
+#define FW_ENTRY_MEMBER_GET(data, fw_entry, member, version) \
+{ \
+        fw_desc_entry_v1_t* entry_v1 = (fw_desc_entry_v1_t*)fw_entry; \
+        fw_desc_entry_v2_t* entry_v2 = (fw_desc_entry_v2_t*)fw_entry; \
+        if (FW_DESC_BASE_VERSION(version) == FW_DESC_TABLE_V1_T_VERSION_1) \
+		data = entry_v1->member; \
+        else if (FW_DESC_BASE_VERSION(version) == FW_DESC_TABLE_V2_T_VERSION_2) \
+		data = entry_v2->member; \
+} \
+
+/*
+ * Ioctl definitions
+ */
+
+/* Use 'c' as magic number */
+#define AVCPU_IOC_MAGIC  'c'
+
+/*
+ * S means "Set"                : through a ptr,
+ * T means "Tell"               : directly with the argument value
+ * G means "Get"                : reply by setting through a pointer
+ * Q means "Query"              : response is on the return value
+ * X means "eXchange"           : G and S atomically
+ * H means "sHift"              : T and Q atomically
+ */
+#define AVCPU_IOCTRESET     _IOW(AVCPU_IOC_MAGIC, 1, resetav_struct)
+#define AVCPU_IOCTSTOP      _IO(AVCPU_IOC_MAGIC, 2)
+#define AVCPU_IOCTSTART     _IO(AVCPU_IOC_MAGIC, 3)
+#define AVCPU_IOCGSTATUS    _IOR(AVCPU_IOC_MAGIC, 4, status_struct)
+#define AVCPU_IOCGALIVE     _IO(AVCPU_IOC_MAGIC, 5)
+
+#endif /* CONFIG_RTK_ACPU_RELOAD */
+
+#endif
+
diff --git a/include/soc/realtek/barrier.h b/include/soc/realtek/barrier.h
new file mode 100644
index 00000000..76a89d2
--- /dev/null
+++ b/include/soc/realtek/barrier.h
@@ -0,0 +1,17 @@
+/*
+ * barrier.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef INCLUDE_SOC_REALTEK_BARRIER_H_
+#define INCLUDE_SOC_REALTEK_BARRIER_H_
+
+void __iomem *rbus_addr;
+
+#endif /* INCLUDE_SOC_REALTEK_BARRIER_H_ */
diff --git a/include/soc/realtek/dcsys.h b/include/soc/realtek/dcsys.h
new file mode 100644
index 00000000..9d79783
--- /dev/null
+++ b/include/soc/realtek/dcsys.h
@@ -0,0 +1,140 @@
+/*
+ * Copyright (c) 2019 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __SOC_REALTEK_DCSYS_H_INCLUDED
+#define __SOC_REALTEK_DCSYS_H_INCLUDED
+
+enum {
+	DCSYS_PERFCNT_ID_TOTAL_0,
+	DCSYS_PERFCNT_ID_TOTAL_1,
+	DCSYS_PERFCNT_ID_SYSH_0,
+	DCSYS_PERFCNT_ID_SYSH_1,
+	DCSYS_PERFCNT_ID_SYSH_2,
+	DCSYS_PERFCNT_ID_SYSH_3,
+	DCSYS_PERFCNT_ID_SYSH_4,
+	DCSYS_PERFCNT_ID_SYSH_5,
+	DCSYS_PERFCNT_ID_SYSH_6,
+	DCSYS_PERFCNT_ID_SYSH_7,
+	DCSYS_PERFCNT_ID_SYS_0,
+	DCSYS_PERFCNT_ID_SYS_1,
+	DCSYS_PERFCNT_ID_SYS_2,
+};
+
+#define DCSYS_PROG_DCSEL_MASK           (0x80)
+#define DCSYS_PROG_DCSEL_DC0            (0x00)
+#define DCSYS_PROG_DCSEL_DC1            (0x80)
+#define DCSYS_PROG_BRIDGE_ID_MASK       (0x78)
+
+/* platform prog_sel definitions */
+#define KYLIN_PROG_SEL_VO               (0x00)
+#define KYLIN_PROG_SEL_AIO              (0x0a)
+#define KYLIN_PROG_SEL_CP               (0x11)
+#define KYLIN_PROG_SEL_MD               (0x13)
+#define KYLIN_PROG_SEL_NAT2             (0x14)
+#define KYLIN_PROG_SEL_JPEG             (0x15)
+#define KYLIN_PROG_SEL_TP               (0x17)
+#define KYLIN_PROG_SEL_NAT              (0x12)
+#define KYLIN_PROG_SEL_GPU              (0x19)
+#define KYLIN_PROG_SEL_SCPU             (0x20)
+#define KYLIN_PROG_SEL_KCPU             (0x21)
+#define KYLIN_PROG_SEL_ACPU             (0x23)
+#define KYLIN_PROG_SEL_AEE              (0x28)
+#define KYLIN_PROG_SEL_ADE              (0x29)
+#define KYLIN_PROG_SEL_USB              (0x2a)
+#define KYLIN_PROG_SEL_ETN              (0x2e)
+#define KYLIN_PROG_SEL_VE1              (0x30)
+#define KYLIN_PROG_SEL_VE2              (0x31)
+#define KYLIN_PROG_SEL_VE3              (0x32)
+#define KYLIN_PROG_SEL_SE               (0x38)
+#define KYLIN_PROG_SEL_MIPI             (0x40)
+#define KYLIN_PROG_SEL_SATA             (0x48)
+#define KYLIN_PROG_SEL_CR               (0x50)
+#define KYLIN_PROG_SEL_NF               (0x53)
+#define KYLIN_PROG_SEL_PCIE0            (0x54)
+#define KYLIN_PROG_SEL_PCIE1            (0x56)
+
+#define HERCULES_PROG_SEL_VO            (0x00)
+#define HERCULES_PROG_SEL_AIO           (0x0a)
+#define HERCULES_PROG_SEL_CP            (0x11)
+#define HERCULES_PROG_SEL_MD            (0x13)
+#define HERCULES_PROG_SEL_JPEG          (0x15)
+#define HERCULES_PROG_SEL_GPU           (0x19)
+#define HERCULES_PROG_SEL_TP            (0x17)
+#define HERCULES_PROG_SEL_SCPU          (0x20)
+#define HERCULES_PROG_SEL_HIF           (0x22)
+#define HERCULES_PROG_SEL_ACPU          (0x23)
+#define HERCULES_PROG_SEL_SCPU_SWC      (0x25)
+#define HERCULES_PROG_SEL_AEE           (0x28)
+#define HERCULES_PROG_SEL_ADE           (0x29)
+#define HERCULES_PROG_SEL_USB           (0x2a)
+#define HERCULES_PROG_SEL_SD            (0x2b)
+#define HERCULES_PROG_SEL_PCIE          (0x2c)
+#define HERCULES_PROG_SEL_SDIO          (0x2d)
+#define HERCULES_PROG_SEL_ETN           (0x2e)
+#define HERCULES_PROG_SEL_VE1           (0x30)
+#define HERCULES_PROG_SEL_VE2           (0x31)
+#define HERCULES_PROG_SEL_SE            (0x38)
+#define HERCULES_PROG_SEL_MIPI          (0x40)
+#define HERCULES_PROG_SEL_EMMC          (0x50)
+#define HERCULES_PROG_SEL_NF            (0x53)
+#define HERCULES_PROG_SEL_DIP           (0x58)
+#define HERCULES_PROG_SEL_HSE_REE       (0x60)
+#define HERCULES_PROG_SEL_HSE_TEE       (0x65)
+
+#define THOR_PROG_SEL_VO                (0x00)
+#define THOR_PROG_SEL_AIO               (0x0A)
+#define THOR_PROG_SEL_R2RDSC            (0x10)
+#define THOR_PROG_SEL_CP                (0x11)
+#define THOR_PROG_SEL_AEE               (0x12)
+#define THOR_PROG_SEL_MD                (0x13)
+#define THOR_PROG_SEL_ADE               (0x14)
+#define THOR_PROG_SEL_JPEG              (0x15)
+#define THOR_PROG_SEL_TPB               (0x16)
+#define THOR_PROG_SEL_TP                (0x17)
+#define THOR_PROG_SEL_GPU               (0x19)
+#define THOR_PROG_SEL_SCPU              (0x20)
+#define THOR_PROG_SEL_SCPU_NWC          (0x25)
+#define THOR_PROG_SEL_ACPU              (0x23)
+#define THOR_PROG_SEL_HIF               (0x22)
+#define THOR_PROG_SEL_USB               (0x2A)
+#define THOR_PROG_SEL_PCIE              (0x2C)
+#define THOR_PROG_SEL_SDIO              (0x2D)
+#define THOR_PROG_SEL_EMMC              (0x50)
+#define THOR_PROG_SEL_VE1               (0x30)
+#define THOR_PROG_SEL_VE2               (0x31)
+#define THOR_PROG_SEL_VE3               (0x32)
+#define THOR_PROG_SEL_SE                (0x38)
+#define THOR_PROG_SEL_MIPI              (0x40)
+#define THOR_PROG_SEL_SATA              (0x48)
+#define THOR_PROG_SEL_ETN               (0x2E)
+#define THOR_PROG_SEL_SD                (0x51)
+#define THOR_PROG_SEL_PCIE_2_SATA       (0x52)
+#define THOR_PROG_SEL_NF                (0x53)
+#define THOR_PROG_SEL_TSIO              (0x54)
+#define THOR_PROG_SEL_DIP               (0x58)
+#define THOR_PROG_SEL_HSE_REE           (0x60)
+#define THOR_PROG_SEL_HSE_TEE           (0x65)
+
+
+#define DCSYS_CA_DC_SEL_MASK            (0x8)
+#define DCSYS_CA_DC_SEL_DC0             (0x0)
+#define DCSYS_CA_DC_SEL_DC1             (0x8)
+#define DCSYS_CA_SEL_MASK               (0x7)
+
+#define DCSYS_CA_SEL_NONE               (0x0)
+#define DCSYS_CA_SEL_VE1                (0x1)
+#define DCSYS_CA_SEL_SE                 (0x2)
+#define DCSYS_CA_SEL_GPU                (0x3)
+#define DCSYS_CA_SEL_SATA               (0x4)
+#define DCSYS_CA_SEL_VE2                (0x5)
+#define DCSYS_CA_SEL_DIP                (0x6)
+#define DCSYS_CA_SEL_HSE                (0x7)
+
+
+#endif
diff --git a/include/soc/realtek/devfreq_gov_data.h b/include/soc/realtek/devfreq_gov_data.h
new file mode 100644
index 00000000..e977751
--- /dev/null
+++ b/include/soc/realtek/devfreq_gov_data.h
@@ -0,0 +1,27 @@
+/*
+ * Copyright (c) 2019 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __SOC_REALTEK_DEVFREQ_GOVERNOR_DATA_H_INCLUDED
+#define __SOC_REALTEK_DEVFREQ_GOVERNOR_DATA_H_INCLUDED
+
+struct devfreq_ltl_data {
+	int th_cap;
+	int th_cap_short;
+	int th_cap_long;
+
+	/* private data */
+	int prev_cap;
+	int weighted_cap_long;
+	int weighted_cap_short;
+	struct notifier_block nb;
+};
+
+
+
+#endif
diff --git a/include/soc/realtek/dmc.h b/include/soc/realtek/dmc.h
new file mode 100644
index 00000000..37b992f
--- /dev/null
+++ b/include/soc/realtek/dmc.h
@@ -0,0 +1,18 @@
+/*
+ * Copyright (c) 2019 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __SOC_REALTEK_DMC_H_INCLUDED
+#define __SOC_REALTEK_DMC_H_INCLUDED
+
+enum {
+	DMC_PERFCNT_ID_CPU,
+	DMC_PERFCNT_ID_GPU,
+};
+
+#endif
diff --git a/include/soc/realtek/hypercall.h b/include/soc/realtek/hypercall.h
new file mode 100644
index 00000000..b411e95
--- /dev/null
+++ b/include/soc/realtek/hypercall.h
@@ -0,0 +1,20 @@
+/*
+ * Copyright (C) 2018 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __SOC_RTK_HYPERCALL_H__
+#define __SOC_RTK_HYPERCALL_H__
+
+#include <xen/interface/rtk-hypercall.h>
+
+#ifdef CONFIG_RTK_XEN_HYPERCALL
+unsigned int rtk_xen_domain_lock(unsigned long timeout, RTK_DOMAIN_LOCK lock_type);
+int rtk_xen_domain_unlock(unsigned int ticket, RTK_DOMAIN_LOCK lock_type);
+#endif// CONFIG_RTK_XEN_HYPERCALL
+
+#endif //__SOC_RTK_HYPERCALL_H__
diff --git a/include/soc/realtek/kernel-rpc.h b/include/soc/realtek/kernel-rpc.h
new file mode 100644
index 00000000..970f042
--- /dev/null
+++ b/include/soc/realtek/kernel-rpc.h
@@ -0,0 +1,32 @@
+/*
+ * kernel-rpc.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef _KERNEL_RPC_H_
+#define _KERNEL_RPC_H_
+
+#define RPC_AUDIO   0x0
+#define RPC_VIDEO   0x1
+#define RPC_VIDEO2  0x2 //add by Angus
+#define RPC_KCPU    0x3
+
+// The param1, param2 must be multiple of 4(bytes)
+int send_rpc_command(int opt, uint32_t command, uint32_t param1, uint32_t param2, uint32_t *retvalue);
+
+static inline uint32_t get_rpc_alignment_offset(uint32_t offset)
+{
+	if((offset%4) == 0)
+		return offset;
+	else
+		return (offset+(4-(offset%4)));
+}
+
+#endif //_KERNEL_RPC_H_
+
diff --git a/include/soc/realtek/memory.h b/include/soc/realtek/memory.h
new file mode 100755
index 00000000..042f4b0
--- /dev/null
+++ b/include/soc/realtek/memory.h
@@ -0,0 +1,244 @@
+/*
+ * memory.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __ASM_ARCH_MEMORY_H
+#define __ASM_ARCH_MEMORY_H
+
+#define RTK_FLAG_NONCACHED (1U << 0)
+#define RTK_FLAG_SCPUACC (1U << 1)
+#define RTK_FLAG_ACPUACC (1U << 2)
+#define RTK_FLAG_HWIPACC (1U << 3)
+#define RTK_FLAG_VE_SPEC (1U << 4)
+#define RTK_FLAG_SECURE_AUDIO (1U << 5)
+#define RTK_FLAG_SECURE_TPACC (1U << 6)
+#define RTK_FLAG_VCPU_FWACC (1U << 7) /* Less than 512MB */
+#define RTK_FLAG_CMA (1U << 8)
+#define RTK_FLAG_DEAULT	 \
+	(RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | RTK_FLAG_HWIPACC)
+
+#if !defined(CONFIG_CPU_V7)
+#define PLAT_PHYS_OFFSET (0x00000000)
+#define PLAT_MEM_SIZE (512*1024*1024)
+#endif
+
+/* 0x00000000 ~ 0x0001efff */ // (X) ALL
+#if !defined(CONFIG_CPU_V7)
+#define SYS_BOOTCODE_MEMBASE (PLAT_PHYS_OFFSET)
+#else
+#define SYS_BOOTCODE_MEMBASE 0
+#endif
+
+#if 0
+#define SYS_BOOTCODE_MEMSIZE (0x00030000)
+#else
+/* https://jira.realtek.com/browse/DHCHERC-1007      */
+/* if not reseve [0x00030000,0x00100000), there are  */
+/* un-expected errors.                               */
+/* Please fix me ASAP in order to free 832KB space.  */
+#define SYS_BOOTCODE_MEMSIZE (0x00100000)
+#endif
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+/* 0x0002f000 ~ 0x0001ffff */
+#define RPC_COMM_PHYS (0x0002F000)
+
+#elif defined(CONFIG_ARCH_RTD13xx)
+
+#define RPC_COMM_PHYS (0x0003F000)
+#else
+/* 0x0001f000 ~ 0x0001ffff */
+#define RPC_COMM_PHYS (0x0001F000)
+#endif
+#define RPC_COMM_SIZE (0x00001000)
+/* 0x00030000 ~ 0x000fffff */
+#define RESERVED_832KB_PHYS (0x00030000)
+#define RESERVED_832KB_SIZE (0x000D0000)
+/* 0x01ffe000 ~ 0x02001fff */
+#define RPC_RINGBUF_PHYS (0x01ffe000)
+#define RPC_RINGBUF_SIZE (0x00004000)
+
+/* 0x02200000 ~ 0x025fffff */
+#if defined(CONFIG_RTK_VMX_ULTRA_RAMFS_VENDOR)
+#define ROOTFS_NORMAL_START (0x20000000)
+#define ROOTFS_NORMAL_SIZE  (0x5A00000) //90MB
+#elif defined(CONFIG_RTK_VMX_ULTRA)
+#define ROOTFS_NORMAL_START (0x4BB00000)
+#define ROOTFS_NORMAL_SIZE  (0x3200000) //50MB
+#else
+#define ROOTFS_NORMAL_START (0x02200000)
+#define ROOTFS_NORMAL_SIZE (0x00400000) //4MB
+#endif
+
+#define ROOTFS_NORMAL_END \
+	(ROOTFS_NORMAL_START + ROOTFS_NORMAL_SIZE)
+/* 0x02200000 ~ 0x02dfffff */
+#define ROOTFS_RESCUE_START (0x02200000)
+#define ROOTFS_RESCUE_SIZE (0x00C00000) //12MB
+#define ROOTFS_RESCUE_END (ROOTFS_RESCUE_START + ROOTFS_RESCUE_SIZE)
+/* 0x02600000 ~ 0x02bfffff */
+#define MEM_SLOT_PHYS_1 (0x02600000)
+#define MEM_SLOT_SIZE_1	 (0x00c00000) // Max : 12M
+#define MEM_SLOT_FLAG_1 (RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | \
+        RTK_FLAG_VCPU_FWACC | \
+		RTK_FLAG_HWIPACC)
+/* 0x03200000 ~ 0x0f8fffff */
+#define MEM_SLOT_PHYS_0 (0x03200000)
+#ifdef CONFIG_ARCH_RTD13xx
+#define MEM_SLOT_SIZE_0	 (0x0c200000) // Max : 194M //reduce for video fw
+#else
+#define MEM_SLOT_SIZE_0	 (0x0c700000) // Max : 199M
+#endif
+#define MEM_SLOT_FLAG_0 (RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | \
+        RTK_FLAG_VCPU_FWACC | \
+		RTK_FLAG_HWIPACC)
+/* 0x0f900000 ~ 0x0fdfffff */
+#define ACPU_FIREWARE_PHYS (0x0f900000)
+#define ACPU_FIREWARE_SIZE (0x00500000)
+/* 0x10000000 ~ 0x10013fff */ // (X) ALL
+#define ACPU_IDMEM_PHYS (0x10000000)
+#define ACPU_IDMEM_SIZE (0x00014000)
+/* 0x10100000 ~ 0x141fffff */ // (X) ALL
+/* Kernel will resrved memory for TEE OS if kernel config is for DRM */
+#define TEE_OS_PHYS     (0x10100000)
+#define TEE_OS_SIZE     (0x04100000)
+/* Kernel will resrved memory for TEE OS if kernel config is for 1GB ATV w/ DRM */
+#define TEE_OS_30MB_PHYS   (0x10100000)
+#define TEE_OS_30MB_SIZE   (0x01E00000)
+/* Kernel will resrved memory for TEE OS if kernel config is for Non DRM*/
+#define TEE_OS_SLIM_PHYS     (0x10100000)
+#if 1 /* non-drm enviromnet config */
+#define TEE_OS_SLIM_SIZE     (0x00f00000)
+#else /* tempary workaround */
+#define TEE_OS_SLIM_SIZE     (TEE_OS_SIZE)
+#endif
+/* For memtester tool */
+#define MEMTESTER_RSV_PHYS (0x22000000)
+#define MEMTESTER_RSV_SIZE (0x04000000)
+
+/* For HIF emmc memory reserve */
+#define HIF_EMMC_RSV_PHYS (0x08000000)
+#define HIF_EMMC_RSV_SIZE (0x01000000)
+
+#if defined(CONFIG_ARCH_RTD139x) || defined(CONFIG_ARCH_RTD16xx)
+/* 0x14200000 ~ 0x1effffff */
+#define MEM_SLOT_PHYS_2 (0x14200000)
+#define MEM_SLOT_SIZE_2	(0x0ae00000) // Max : 174M
+#define MEM_SLOT_FLAG_2 (RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | \
+        RTK_FLAG_VCPU_FWACC | \
+		RTK_FLAG_HWIPACC)
+#else /* else of CONFIG_ARCH_RTD139x or CONFIG_ARCH_RTD16xx */
+/* 0x14200000 ~ 0x1e7fffff */
+#define MEM_SLOT_PHYS_2 (0x14200000)
+#define MEM_SLOT_SIZE_2	(0x0a600000) // Max : 166M
+#define MEM_SLOT_FLAG_2 (RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | \
+        RTK_FLAG_VCPU_FWACC | \
+		RTK_FLAG_HWIPACC)
+/* 0x1e800000 ~ 0x1effffff */
+#define MEM_SLOT_PHYS_3 (0x1e800000)
+#define MEM_SLOT_SIZE_3	 (0x00800000) // Max : 8M
+#define MEM_SLOT_FLAG_3 (RTK_FLAG_SCPUACC | RTK_FLAG_ACPUACC | \
+        RTK_FLAG_VCPU_FWACC | \
+		RTK_FLAG_HWIPACC)
+/* 0x45700000 ~ 0x48700000 */
+#define MEM_SLOT_PHYS_5 (MEM_SLOT_PHYS_4 + MEM_SLOT_SIZE_4)
+#define MEM_SLOT_SIZE_5 (0x03000000) // Max : 48MB
+#define MEM_SLOT_FLAG_5 (RTK_FLAG_SCPUACC | RTK_FLAG_HWIPACC)
+#endif /* end of CONFIG_ARCH_RTD139x or CONFIG_ARCH_RTD16xx */
+
+/* 0x1fc00000 ~ 0x1fc00fff */ // (X) ALL
+#define ACPU_BOOTCODE_PHYS (0x1FC00000)
+#define ACPU_BOOTCODE_SIZE (0x00001000)
+/* 0x32800000 ~ 0x3effffff */
+#ifdef CONFIG_RTK_VMX_DRM
+#define MEM_SLOT_PHYS_4 (0x32b00000)
+#define MEM_SLOT_SIZE_4 (0x15400000)
+#else
+#define MEM_SLOT_PHYS_4 (0x32b00000)
+#define MEM_SLOT_SIZE_4 (0x12c00000)
+#endif
+#define MEM_SLOT_FLAG_4 (RTK_FLAG_SCPUACC | RTK_FLAG_HWIPACC)
+/* 0x80000000 ~ 0x80007fff */
+#define PLAT_SECURE_PHYS (0x80000000)
+#define PLAT_SECURE_SIZE (0x00008000)
+/* 0x88100000 ~ 0x88107fff */
+#define PLAT_NOR_PHYS (0x88100000)
+#define PLAT_NOR_SIZE (0x00008000)
+/* 0x98000000 ~ 0x981fffff */
+#define RBUS_BASE_PHYS (0x98000000)
+#define RBUS_BASE_SIZE (0x00200000)
+
+#define RBUS_BASE_VIRT (0xFE000000)
+
+#define ROOTFS_BIST_START (0x30000000)
+#define ROOTFS_BIST_SIZE (0x00C00000) //12MB
+#define ROOTFS_BIST_END (ROOTFS_BIST_START + ROOTFS_BIST_SIZE)
+
+#define HW_LIMITATION_PHYS (0x3FFFF000)
+#define HW_LIMITATION_SIZE (0x00001000) //4KB
+#define HW_LIMITATION_START (HW_LIMITATION_PHYS)
+#define HW_LIMITATION_END (HW_LIMITATION_START + HW_LIMITATION_SIZE)
+
+#define HW_LIMITATION_3GB_PHYS (0x7FFFF000)
+#define HW_LIMITATION_3GB_SIZE (0x00001000) //4KB
+#define HW_LIMITATION_3GB_START (HW_LIMITATION_3GB_PHYS)
+#define HW_LIMITATION_3GB_END (HW_LIMITATION_3GB_START + HW_LIMITATION_3GB_SIZE)
+
+#define HW_SECURE_RAM_PHYS PLAT_SECURE_PHYS
+#define HW_SECURE_RAM_SIZE PLAT_SECURE_SIZE
+#define HW_SECURE_RAM_START (HW_SECURE_RAM_PHYS)
+#define HW_SECURE_RAM_END (HW_SECURE_RAM_START + HW_SECURE_RAM_SIZE)
+
+#define HW_NOR_REMAP_PHYS (0x88100000)
+#define HW_NOR_REMAP_SIZE (0x02000000) //32MB
+#define HW_NOR_REMAP_START (HW_NOR_REMAP_PHYS)
+#define HW_NOR_REMAP_END (HW_NOR_REMAP_START + HW_NOR_REMAP_SIZE)
+
+#define MEM_SLOT_PHYS_BY(_nr, req_size) (MEM_SLOT_PHYS_##_nr##)
+#define MEM_SLOT_SIZE_BY(_nr, req_size) ( \
+		(req_size  > MEM_SLOT_SIZE_##_nr##) ? MEM_SLOT_SIZE_##_nr## : \
+		req_size)
+#define MEM_SLOT_FLAG_BY(_nr, req_size) (MEM_SLOT_FLAG_##_nr##)
+#define MEM_SLOT(_nr, _type, req_size) \
+	MEM_SLOT_##_type##_BY(_nr, req_size)
+
+
+/* legacy : 184 M */
+#define ION_MEDIA_HEAP_PHYS1 (MEM_SLOT(0, PHYS, 0x0b800000))
+#define ION_MEDIA_HEAP_SIZE1 (MEM_SLOT(0, SIZE, 0x0b800000))
+#define ION_MEDIA_HEAP_FLAG1 (MEM_SLOT(0, FLAG, 0x0b800000))
+
+/* legacy : 12 M */
+#define ION_AUDIO_HEAP_PHYS (MEM_SLOT(1, PHYS, 0x00c00000))
+#define ION_AUDIO_HEAP_SIZE (MEM_SLOT(1, SIZE, 0x00c00000))
+#define ION_AUDIO_HEAP_FLAG	 (MEM_SLOT(1, FLAG, 0x00c00000))
+
+/* legacy : 146 M */
+#define ION_MEDIA_HEAP_PHYS2 (MEM_SLOT(2, PHYS, 0x09200000))
+#define ION_MEDIA_HEAP_SIZE2 (MEM_SLOT(2, SIZE, 0x09200000))
+#define ION_MEDIA_HEAP_FLAG2 (MEM_SLOT(2, FLAG, 0x09200000))
+
+#ifdef CONFIG_ARCH_RTD129x
+/* legacy : 8 M */
+#define ION_MEDIA_HEAP_PHYS3 (MEM_SLOT(3, PHYS, 0x00800000))
+#define ION_MEDIA_HEAP_SIZE3 (MEM_SLOT(3, SIZE, 0x00800000))
+#define ION_MEDIA_HEAP_FLAG3 (MEM_SLOT(3, FLAG, 0x00800000) | RTK_FLAG_VE_SPEC)
+#endif /* end of CONFIG_ARCH_RTD129x */
+
+/* legacy : 200 M */
+#define ION_SECURE_HEAP_PHYS (MEM_SLOT(4, PHYS, 0x12c00000))
+#define ION_SECURE_HEAP_SIZE (MEM_SLOT(4, SIZE, 0x12c00000))
+#define ION_SECURE_HEAP_FLAG (RTK_FLAG_HWIPACC)
+
+#else	//phoenix rtd119x memory.h include file path
+
+#include "../../../arch/arm/mach-rtd119x/include/mach/memory.h"
+
+#endif
+
diff --git a/include/soc/realtek/perfcnt.h b/include/soc/realtek/perfcnt.h
new file mode 100644
index 00000000..8e8419d
--- /dev/null
+++ b/include/soc/realtek/perfcnt.h
@@ -0,0 +1,77 @@
+#ifndef __SOC_REALTEK_PERFCNT_H_INCLUDED
+#define __SOC_REALTEK_PERFCNT_H_INCLUDED
+
+struct device_node;
+struct perfcnt_device;
+
+#define PERFCNT_MAX_DATA                (5)
+
+struct perfcnt_data {
+	u32 data[PERFCNT_MAX_DATA];
+};
+
+struct perfcnt {
+	struct device *dev;
+	struct perfcnt_device *pcdev;
+	struct list_head list;
+	struct list_head suspend;
+};
+
+/* consumer api */
+struct perfcnt *perfcnt_get(struct device *dev, const char *id);
+void perfcnt_put(struct perfcnt *pc);
+int perfcnt_set_conf(struct perfcnt *pc, u32 id, u32 conf);
+int perfcnt_get_data(struct perfcnt *pc, u32 id, struct perfcnt_data *data);
+int perfcnt_start(struct perfcnt *pc);
+int perfcnt_stop(struct perfcnt *pc);
+int perfcnt_reset(struct perfcnt *pc);
+int perfcnt_last_duration(struct perfcnt *pc, u32 *period_ms);
+
+int perfcnt_request(struct perfcnt *new_pc);
+int perfcnt_release(struct perfcnt *old_pc);
+
+int perfcnt_register_notifier(struct perfcnt *pc, struct notifier_block *nb);
+int perfcnt_unregister_notifier(struct perfcnt *pc, struct notifier_block *nb);
+
+#define PERFCNT_EVENT_PRE_CHANGE         0x1
+#define PERFCNT_EVENT_POST_CHANGE        0x2
+
+struct perfcnt_change_data {
+	struct perfcnt *old_pc;
+	struct perfcnt *new_pc;
+};
+
+struct perfcnt_ops;
+struct perfcnt_data;
+
+struct perfcnt_device {
+	struct list_head   list;
+	struct device      *dev;
+	struct device_node *np;
+	int                num_cnt;
+	const struct perfcnt_ops *ops;
+	u64                time_begin;
+	u64                time_end;
+	u32                is_start;
+	struct blocking_notifier_head notifier;
+	struct perfcnt     *cur_pc;
+	struct list_head   list_idle;
+	struct list_head   list_suspend;
+};
+
+struct perfcnt_ops {
+	int (*start)(struct perfcnt_device *pcdev);
+	int (*stop)(struct perfcnt_device *pcdev);
+	int (*reset)(struct perfcnt_device *pcdev);
+	int (*set_conf)(struct perfcnt_device *pcdev, u32 id, u32 conf);
+	int (*get_data)(struct perfcnt_device *pcdev, u32 id, struct perfcnt_data *data);
+};
+
+/* provider api */
+int perfcnt_register(struct perfcnt_device *pcdev);
+void perfcnt_unregister(struct perfcnt_device *pcdev);
+
+int perfcnt_suspend(struct perfcnt_device *pcdev);
+int perfcnt_resume(struct perfcnt_device *pcdev);
+
+#endif /* __SOC_REALTEK_PERFCNT_H_INCLUDED */
diff --git a/include/soc/realtek/power-control.h b/include/soc/realtek/power-control.h
new file mode 100644
index 00000000..8d390d6
--- /dev/null
+++ b/include/soc/realtek/power-control.h
@@ -0,0 +1,117 @@
+/*
+ * Copyright (C) 2016 Realtek Semiconductor Corporation
+ * Copyright (C) 2016 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __SOC_REALTEK_POWER_CONTROL_H_INCLUDED
+#define __SOC_REALTEK_POWER_CONTROL_H_INCLUDED
+
+struct device_node;
+struct power_control;
+
+#include <linux/types.h>
+
+/* power-control notifier actions */
+#define POWER_CONTROL_ACTION_PRE_POWER_ON         (0x01)
+#define POWER_CONTROL_ACTION_POST_POWER_ON        (0x02)
+#define POWER_CONTROL_ACTION_POWER_ON_ABORT       (0x03)
+#define POWER_CONTROL_ACTION_POWER_ON_IGNORE      (0x04)
+#define POWER_CONTROL_ACTION_PRE_POWER_OFF        (0x11)
+#define POWER_CONTROL_ACTION_POST_POWER_OFF       (0x12)
+
+#ifdef CONFIG_POWER_CONTROL
+int power_control_init(struct power_control *pwrctrl);
+int power_control_power_on(struct power_control *pwrctrl);
+int power_control_power_off(struct power_control *pwrctrl);
+int power_control_is_powered_on(struct power_control *pwrctrl);
+
+struct power_control *power_control_get(const char *name);
+struct power_control *of_power_control_get_by_index(struct device_node *node,
+						    int index);
+struct power_control *of_power_control_get(struct device_node *node,
+					   const char *id);
+void power_control_put(struct power_control *pwrctrl);
+
+int power_control_register(struct power_control *pwrctrl);
+void power_control_unregister(struct power_control *pwrctrl);
+
+int power_control_register_notifier(struct power_control *pwrctrl,
+				    struct notifier_block *nb);
+void power_control_unregister_notifier(struct power_control *pwrctrl,
+				       struct notifier_block *nb);
+
+#else
+
+static inline int power_control_power_on(struct power_control *pwrctrl)
+{
+	return -EINVAL;
+}
+
+static inline int power_control_power_off(struct power_control *pwrctrl)
+{
+	return -EINVAL;
+}
+
+static inline int power_control_is_powered_on(struct power_control *pwrctrl)
+{
+	return -EINVAL;
+}
+
+static inline struct power_control *power_control_get(const char *name)
+{
+	return ERR_PTR(-EINVAL);
+}
+
+static inline struct power_control *of_power_control_get_by_index(struct device_node *node,
+								  int index)
+{
+	return ERR_PTR(-EINVAL);
+}
+
+static inline struct power_control *of_power_control_get(struct device_node *node,
+							 const char *id)
+{
+	return ERR_PTR(-EINVAL);
+}
+
+static inline void power_control_put(struct power_control *pwrctrl)
+{
+}
+
+static inline int power_control_register(struct power_control *pwrctrl)
+{
+	return -EINVAL;
+}
+
+static inline void power_control_unregister(struct power_control *pwrctrl)
+{
+}
+
+static inline int power_control_register_notifier(struct power_control *pwrctrl,
+						  struct notifier_block *nb)
+{
+	return -EINVAL;
+}
+
+static inline void power_control_unregister_notifier(struct power_control *pwrctrl,
+						     struct notifier_block *nb)
+{
+}
+
+#endif
+
+static inline int power_control_enable_hw_pm(struct power_control *pwrctrl)
+{
+	return power_control_power_off(pwrctrl);
+}
+
+static inline int power_control_disable_hw_pm(struct power_control *pwrctrl)
+{
+	return power_control_power_on(pwrctrl);
+}
+
+#endif
diff --git a/include/soc/realtek/rtd129x_efuse.h b/include/soc/realtek/rtd129x_efuse.h
new file mode 100644
index 00000000..f9cfbd6
--- /dev/null
+++ b/include/soc/realtek/rtd129x_efuse.h
@@ -0,0 +1,54 @@
+/*
+ * rtd129x_efuse.h - Realtek eFuse Header
+ *
+ * Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * Author: Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+#ifndef _RTD129x_EFUSE_H_
+#define _RTD129x_EFUSE_H_ 
+
+#define EFUSE_MEM_SIZE         0x00000800
+#define EFUSE_OTP_SIZE         0x00000400
+#define EFUSE_MAX_ENTRY_SIZE   128
+
+/* eFuse Pattern ID */
+#define EFUSE_UUID                    0
+#define EFUSE_ETN_PHY                 1
+#define EFUSE_ETN_PHY_RC              2
+#define EFUSE_ETN_PHY_R               3
+#define EFUSE_ETN_PHY_AMP             4
+#define EFUSE_ETN_PHY_ADC             5
+#define EFUSE_PWR_ID                  6
+#define EFUSE_PACKAGE_ID              7
+#define EFUSE_USB_CC_EN               8
+#define EFUSE_USB_CC1_4_7_K_CAL       9
+#define EFUSE_USB_CC1_12_K_CAL       10
+#define EFUSE_USB_CC2_4_7_K_CAL      11
+#define EFUSE_USB_CC2_12_K_CAL       12
+#define EFUSE_TOP_IDDQ               13
+#define EFUSE_CPU_IDDQ               14
+#define EFUSE_USB_DP_DM              15
+#define EFUSE_CC_CAL                 16
+#define EFUSE_CHIP_ID                17
+#define EFUSE_PROG_RVD               18
+
+u8  efuse_readb(unsigned long addr);
+u16 efuse_readw(unsigned long addr);
+u32 efuse_readl(unsigned long addr);
+u64 efuse_readq(unsigned long addr);
+int efuse_read_pattern(int id, unsigned char *buf, int *size);
+
+#endif /* _RTD129x_EFUSE_H_ */
diff --git a/include/soc/realtek/rtd129x_lockapi.h b/include/soc/realtek/rtd129x_lockapi.h
new file mode 100644
index 00000000..39b054a
--- /dev/null
+++ b/include/soc/realtek/rtd129x_lockapi.h
@@ -0,0 +1,113 @@
+/*
+ * rtd129x_lockapi.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef _RTD129x_LOCKAPI_H_
+#define _RTD129x_LOCKAPI_H_
+
+//#define EN_SPINLOCK
+#define EN_SPINLOCK_IRQ
+//#define EN_SEMAPHORE
+//#define EN_MUTEX
+
+#define LINE2STR_DETAIL(x) #x
+#define LINE2STR(x) LINE2STR_DETAIL(x)
+#define _AT_(X) __FILE__ " " LINE2STR(X)
+#define _at_(X) X " " LINE2STR(__LINE__)
+
+#if defined(EN_SPINLOCK) || defined(EN_SPINLOCK_IRQ) || defined(EN_SEMAPHORE) || defined(EN_MUTEX)
+#ifdef CONFIG_ARCH_RTD129x
+    #define LOCKAPI_EN
+    #define rtk_lockapi_trylock(X,Y)         _rtk_lockapi_trylock(&X,Y)
+    #define rtk_lockapi_lock(X,Y)            _rtk_lockapi_lock(&X,Y)
+    #define rtk_lockapi_unlock(X,Y)          _rtk_lockapi_unlock(X,Y)
+
+    #define rtk_lockapi_trylock2(X,Y)        _rtk_lockapi_trylock2(&X,Y)
+    #define rtk_lockapi_lock2(X,Y)           _rtk_lockapi_lock2(&X,Y)
+    #define rtk_lockapi_unlock2(X,Y)         _rtk_lockapi_unlock2(X,Y)
+
+    #define rtk_lockapi_trylock3(X,Y,Z)        _rtk_lockapi_trylock3(&X,Y,Z)
+    #define rtk_lockapi_lock3(X,Y,Z)         _rtk_lockapi_lock3(&X,Y,Z)
+    #define rtk_lockapi_unlock3(X,Y,Z)       _rtk_lockapi_unlock3(X,Y,Z)
+#else
+    #define rtk_lockapi_trylock(X,Y)
+    #define rtk_lockapi_lock(X,Y)
+    #define rtk_lockapi_unlock(X,Y)
+
+    #define rtk_lockapi_trylock2(X,Y)
+    #define rtk_lockapi_lock2(X,Y)
+    #define rtk_lockapi_unlock2(X,Y)
+
+    #define rtk_lockapi_trylock3(X,Y,Z)
+    #define rtk_lockapi_lock3(X,Y,Z)
+    #define rtk_lockapi_unlock3(X,Y,Z)
+#endif /* CONFIG_ARCH_RTD129x */
+#else
+    #define rtk_lockapi_trylock(X,Y)
+    #define rtk_lockapi_lock(X,Y)
+    #define rtk_lockapi_unlock(X,Y)
+
+    #define rtk_lockapi_trylock2(X,Y)
+    #define rtk_lockapi_lock2(X,Y)
+    #define rtk_lockapi_unlock2(X,Y)
+
+    #define rtk_lockapi_trylock3(X,Y,Z)
+    #define rtk_lockapi_lock3(X,Y,Z)
+    #define rtk_lockapi_unlock3(X,Y,Z)
+#endif
+
+#define LOCKAPI_MAGICNUM (0xdeadbeef)
+#define LOCKAPI_BY_PASS (0xbeefdead)
+#define MAX_LOG_MSG_LEN  (64)
+
+#define LOCK_NOP_DELAY_CNT (30)
+#define UNLOCK_NOP_DELAY_CNT (30)
+
+#define LOCK_NOP_DELAY \
+{ \
+	nop_loop = LOCK_NOP_DELAY_CNT; \
+	while(nop_loop--){ \
+		asm volatile("nop" : : : ); \
+	} \
+}
+
+#define UNLOCK_NOP_DELAY \
+{ \
+	nop_loop = UNLOCK_NOP_DELAY_CNT; \
+	while(nop_loop--){ \
+		asm volatile("nop" : : : ); \
+	} \
+}
+
+enum lockapi_errortype {
+	LOCKAPI_NO_ERR = 0,
+	LOCKAPI_ERR_BUSY = 1,
+	LOCKAPI_ERR_TIMEOUT = 2,
+	LOCKAPI_ERR_RELOCK = 3,
+	LOCKAPI_ERR_REUNLOCK = 4,
+	LOCKAPI_ERR_DRV_NOT_READY = 99,
+	LOCKAPI_ERR_UNKNOW = 100,
+};
+
+void lockapi_show_status( void );
+
+int _rtk_lockapi_trylock( unsigned long * pflags, char * log_msg );
+int _rtk_lockapi_lock( unsigned long * pflags, char * log_msg );
+int _rtk_lockapi_unlock( unsigned long flags, char * log_msg );
+
+int _rtk_lockapi_trylock2( unsigned long * pflags, char * log_msg );
+int _rtk_lockapi_lock2( unsigned long * pflags, char * log_msg );
+int _rtk_lockapi_unlock2( unsigned long flags, char * log_msg );
+
+int _rtk_lockapi_trylock3( unsigned long * pflags, char * log_msg, int log_line );
+int _rtk_lockapi_lock3( unsigned long * pflags, char * log_msg, int log_line );
+int _rtk_lockapi_unlock3( unsigned long flags, char * log_msg, int log_line );
+
+#endif //_RTD129x_LOCKAPI_H_
diff --git a/include/soc/realtek/rtd139x_efuse.h b/include/soc/realtek/rtd139x_efuse.h
new file mode 100644
index 00000000..f9cfbd6
--- /dev/null
+++ b/include/soc/realtek/rtd139x_efuse.h
@@ -0,0 +1,54 @@
+/*
+ * rtd129x_efuse.h - Realtek eFuse Header
+ *
+ * Copyright (C) 2016 Realtek Semiconductor Corporation
+ *
+ * Author: Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+#ifndef _RTD129x_EFUSE_H_
+#define _RTD129x_EFUSE_H_ 
+
+#define EFUSE_MEM_SIZE         0x00000800
+#define EFUSE_OTP_SIZE         0x00000400
+#define EFUSE_MAX_ENTRY_SIZE   128
+
+/* eFuse Pattern ID */
+#define EFUSE_UUID                    0
+#define EFUSE_ETN_PHY                 1
+#define EFUSE_ETN_PHY_RC              2
+#define EFUSE_ETN_PHY_R               3
+#define EFUSE_ETN_PHY_AMP             4
+#define EFUSE_ETN_PHY_ADC             5
+#define EFUSE_PWR_ID                  6
+#define EFUSE_PACKAGE_ID              7
+#define EFUSE_USB_CC_EN               8
+#define EFUSE_USB_CC1_4_7_K_CAL       9
+#define EFUSE_USB_CC1_12_K_CAL       10
+#define EFUSE_USB_CC2_4_7_K_CAL      11
+#define EFUSE_USB_CC2_12_K_CAL       12
+#define EFUSE_TOP_IDDQ               13
+#define EFUSE_CPU_IDDQ               14
+#define EFUSE_USB_DP_DM              15
+#define EFUSE_CC_CAL                 16
+#define EFUSE_CHIP_ID                17
+#define EFUSE_PROG_RVD               18
+
+u8  efuse_readb(unsigned long addr);
+u16 efuse_readw(unsigned long addr);
+u32 efuse_readl(unsigned long addr);
+u64 efuse_readq(unsigned long addr);
+int efuse_read_pattern(int id, unsigned char *buf, int *size);
+
+#endif /* _RTD129x_EFUSE_H_ */
diff --git a/include/soc/realtek/rtk_chip.h b/include/soc/realtek/rtk_chip.h
new file mode 100644
index 00000000..c6ae67e
--- /dev/null
+++ b/include/soc/realtek/rtk_chip.h
@@ -0,0 +1,42 @@
+/*
+ * rtk_chip.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef _RTK_CHIP_H_INCLUDED_
+#define _RTK_CHIP_H_INCLUDED_
+
+enum rtd_chip_id {
+	CHIP_ID_RTD1195 = 0x1195,
+	CHIP_ID_RTD129X = 0x1290,
+	CHIP_ID_RTD1294 = 0x1294,
+	CHIP_ID_RTD1295 = 0x1295,
+	CHIP_ID_RTD1296 = 0x1296,
+	CHIP_ID_RTD139X = 0x1390,
+	CHIP_ID_RTD1392 = 0x1392,
+	CHIP_ID_RTD1395 = 0x1395,
+	CHIP_ID_RTD1619 = 0x1619,
+	CHIP_ID_RTD1315 = 0x1315,
+	CHIP_ID_RTD1317 = 0x1317,
+	CHIP_ID_RTD1319 = 0x1319,
+};
+
+int get_rtd_chip_id(void);
+
+enum rtd_chip_revision {
+	RTD_CHIP_A00 = 0xA00,
+	RTD_CHIP_A01 = 0xA01,
+	RTD_CHIP_A02 = 0xA02,
+	RTD_CHIP_B00 = 0xB00,
+	RTD_CHIP_B01 = 0xB01,
+};
+
+int get_rtd_chip_revision(void);
+
+#endif //_RTK_CHIP_H_INCLUDED_
diff --git a/include/soc/realtek/rtk_event.h b/include/soc/realtek/rtk_event.h
new file mode 100644
index 00000000..2ca4a5f1
--- /dev/null
+++ b/include/soc/realtek/rtk_event.h
@@ -0,0 +1,33 @@
+/*
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __RTK_EVENT_H
+#define __RTK_EVENT_H
+
+struct notifier_block;
+
+void rtk_clk_notify(struct clk *clk, unsigned int long event);
+#define CLK_EVENT_REGISTERED            1
+
+int rtk_clk_notifier_register(struct notifier_block *nb);
+int rtk_clk_notifier_unregister(struct notifier_block *nb);
+
+
+#endif /* __RTK_EVENT_H */
diff --git a/include/soc/realtek/rtk_ipc_shm.h b/include/soc/realtek/rtk_ipc_shm.h
new file mode 100644
index 00000000..2d90a8c
--- /dev/null
+++ b/include/soc/realtek/rtk_ipc_shm.h
@@ -0,0 +1,100 @@
+/*
+ * rtk_ipc_shm.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __ASM_ARCH_RTK_IPC_SHM_H
+#define __ASM_ARCH_RTK_IPC_SHM_H
+
+extern volatile void __iomem *rpc_common_base;
+#define IPC_SHM_VIRT (rpc_common_base + 0x000000C4)
+
+struct rtk_ipc_shm {
+	volatile uint32_t sys_assign_serial;
+	volatile uint32_t pov_boot_vd_std_ptr;
+	volatile uint32_t pov_boot_av_info;
+	volatile uint32_t audio_rpc_flag;
+	volatile uint32_t suspend_mask;
+	volatile uint32_t suspend_flag;
+	volatile uint32_t vo_vsync_flag;
+	volatile uint32_t audio_fw_entry_pt;
+	volatile uint32_t power_saving_ptr;
+	volatile unsigned char printk_buffer[24];
+	volatile uint32_t ir_extended_tbl_pt;
+	volatile uint32_t vo_int_sync;
+	volatile uint32_t bt_wakeup_flag;
+	volatile uint32_t ir_scancode_mask;
+	volatile uint32_t ir_wakeup_scancode;
+	volatile uint32_t suspend_wakeup_flag;
+	volatile uint32_t acpu_resume_state;
+	volatile uint32_t gpio_wakeup_enable;
+	volatile uint32_t gpio_wakeup_activity;
+	volatile uint32_t gpio_output_change_enable;
+	volatile uint32_t gpio_output_change_activity;
+	volatile uint32_t audio_reciprocal_timer_sec;
+	volatile uint32_t u_boot_version_magic;
+	volatile uint32_t u_boot_version_info;
+	volatile uint32_t suspend_watchdog;
+	volatile uint32_t xen_domu_boot_st;
+	volatile uint32_t gpio_wakeup_enable2;
+	volatile uint32_t gpio_wakeup_activity2;
+	volatile uint32_t gpio_output_change_enable2;
+	volatile uint32_t gpio_output_change_activity2;
+	volatile uint32_t gpio_wakeup_enable3;
+	volatile uint32_t gpio_wakeup_activity3;
+	volatile uint32_t video_rpc_flag;
+	volatile uint32_t video_int_sync;
+};
+
+struct avcpu_syslog_struct{
+	volatile uint32_t log_buf_addr;
+	volatile uint32_t log_buf_len;
+	volatile uint32_t logged_chars;
+	volatile uint32_t log_start;
+	volatile uint32_t con_start;
+	volatile uint32_t log_end;
+};
+
+#if defined(CONFIG_RTK_XEN_SUPPORT) && defined(CONFIG_RTK_RPC)
+#define SETMASK(bits, pos)		(((-1U) >> (32-bits))  << (pos))
+#define CLRMASK(bits, pos)		(~(SETMASK(bits, pos)))
+#define SET_VAL(val,bits,pos)		((val << pos) & SETMASK(bits, pos))
+#define GET_VAL(reg,bits,pos)		((reg & SETMASK(bits, pos)) >> pos)
+
+#define XEN_DOMU_BOOT_ST_MAGIC_KEY			(0xEA)
+#define XEN_DOMU_BOOT_ST_MAGIC_KEY_MASK			(XEN_DOMU_BOOT_ST_MAGIC_KEY << 24)
+
+#define XEN_DOMU_BOOT_ST_VERSION_SET(reg)		SET_VAL(reg, 4,20)
+#define XEN_DOMU_BOOT_ST_VERSION_GET(reg)		GET_VAL(reg, 4,20)
+#define XEN_DOMU_BOOT_ST_VERSION			(1)
+
+#define XEN_DOMU_BOOT_ST_AUTHOR_SET(reg)		SET_VAL(reg, 4,16)
+#define XEN_DOMU_BOOT_ST_AUTHOR_GET(reg)		GET_VAL(reg, 4,16)
+#define XEN_DOMU_BOOT_ST_AUTHOR_ACPU			(1)
+#define XEN_DOMU_BOOT_ST_AUTHOR_SCPU			(2)
+
+#define XEN_DOMU_BOOT_ST_STATE_SET(reg)			SET_VAL(reg, 8, 8)
+#define XEN_DOMU_BOOT_ST_STATE_GET(reg)			GET_VAL(reg, 8, 8)
+#define XEN_DOMU_BOOT_ST_STATE_SCPU_BOOT		(1)
+#define XEN_DOMU_BOOT_ST_STATE_SCPU_RESTART		(2)
+#define XEN_DOMU_BOOT_ST_STATE_SCPU_POWOFF		(3)
+#define XEN_DOMU_BOOT_ST_STATE_ACPU_LOCK		(4)
+#define XEN_DOMU_BOOT_ST_STATE_ACPU_UNLOCK		(5)
+#define XEN_DOMU_BOOT_ST_STATE_SCPU_WAIT_DONE		(6)
+#define XEN_DOMU_BOOT_ST_STATE_ACPU_ENTER_IDLE		(7)
+#define XEN_DOMU_BOOT_ST_STATE_SCPU_SUSPEND		(8)
+#define XEN_DOMU_BOOT_ST_STATE_SCPU_RESUME		(9)
+#define XEN_DOMU_BOOT_ST_STATE_ACPU_ACK			(10)
+
+
+#define XEN_DOMU_BOOT_ST_EXT_SET(reg)			SET_VAL(reg, 8, 0)
+#define XEN_DOMU_BOOT_ST_EXT_GET(reg)			GET_VAL(reg, 8, 0)
+#endif /* defined(CONFIG_RTK_XEN_SUPPORT) && defined(CONFIG_RTK_RPC) */
+
+#endif /* End of  __ASM_ARCH_RTK_IPC_SHM_H */
diff --git a/include/soc/realtek/rtk_ir.h b/include/soc/realtek/rtk_ir.h
new file mode 100644
index 00000000..7b049aa
--- /dev/null
+++ b/include/soc/realtek/rtk_ir.h
@@ -0,0 +1,28 @@
+/*
+ * rtk_ir.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+#ifndef __RTK_IR__H__
+#define __RTK_IR__H__
+
+struct irda_wake_up_key {
+	unsigned int protocol;
+	unsigned int scancode_mask;
+	unsigned int wakeup_scancode;
+	unsigned int cus_mask;
+	unsigned int cus_code;
+};
+
+struct ipc_shm_irda {
+	unsigned int ipc_shm_ir_magic;
+	unsigned int dev_count;
+	struct irda_wake_up_key key_tbl[5];
+};
+
+#endif
\ No newline at end of file
diff --git a/include/soc/realtek/rtk_mmio.h b/include/soc/realtek/rtk_mmio.h
new file mode 100644
index 00000000..a525a26
--- /dev/null
+++ b/include/soc/realtek/rtk_mmio.h
@@ -0,0 +1,75 @@
+/*
+ * rtk_mmio.h -  Realtek Regmap-MMIO API.
+ *
+ * Copyright (C) 2017,2019 Realtek Semiconductor Corporation
+ *
+ * Author:
+ *      Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#ifndef __SOC_REALTEK_MMIO_H
+#define __SOC_REALTEK_MMIO_H
+
+struct regmap;
+struct device_node;
+struct rtk_regmap_config;
+
+#ifdef CONFIG_RTK_MMIO
+struct regmap *rtk_mmio_node_to_regmap(struct device_node *np);
+#else
+static inline struct regmap *rtk_mmio_node_to_regmap(struct device_node *np)
+{
+	return ERR_PTR(-ENOENT);
+}
+#endif /* CONFIG_RTK_MMIO */
+
+static inline struct regmap *of_get_rtk_mmio_regmap_with_offset(
+	const struct device_node *np, int index, int *offset)
+{
+	struct of_phandle_args args;
+	int ret;
+
+	ret = of_parse_phandle_with_fixed_args(np, "realtek,mmio", 1,
+		index, &args);
+	if (ret)
+		return ERR_PTR(ret);
+
+	if (offset)
+		*offset = args.args[0];
+
+	return rtk_mmio_node_to_regmap(args.np);
+}
+
+static inline struct regmap *of_get_rtk_mmio_regmap(
+	const struct device_node *np, int index)
+{
+	return of_get_rtk_mmio_regmap_with_offset(np, index, NULL);
+}
+
+
+#ifdef CONFIG_RTK_MMIO_SECURE
+struct rtk_regmap_config *rtk_mmio_match_config_by_addr(unsigned long addr);
+#else
+static inline
+struct rtk_regmap_config *rtk_mmio_match_config_by_addr(unsigned long addr)
+{
+	return NULL;
+}
+#endif /* CONFIG_RTK_MMIO_SECURE */
+
+#endif /* __SOC_REALTEK_MMIO_H */
+
diff --git a/include/soc/realtek/rtk_pcie.h b/include/soc/realtek/rtk_pcie.h
new file mode 100644
index 00000000..d1ae6be
--- /dev/null
+++ b/include/soc/realtek/rtk_pcie.h
@@ -0,0 +1,21 @@
+/*
+ * rtk_pcie.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+void rtk_pcie1_write(u32 addr, u8 size, u32 wval);
+u32 rtk_pcie1_read(u32 addr, u8 size);
+void rtk_pcie2_write(u32 addr, u8 size, u32 wval);
+u32 rtk_pcie2_read(u32 addr, u8 size);
+u32 rtk_pcie_mmio_start(void);
+u32 rtk_pcie_mmio_end(void);
+u32 rtk_pcie_mmio_len(void);
+u32 rtk_pcie2_mmio_start(void);
+u32 rtk_pcie2_mmio_end(void);
+u32 rtk_pcie2_mmio_len(void);
diff --git a/include/soc/realtek/rtk_pm.h b/include/soc/realtek/rtk_pm.h
new file mode 100644
index 00000000..fe01f7d
--- /dev/null
+++ b/include/soc/realtek/rtk_pm.h
@@ -0,0 +1,13 @@
+/*
+ * rtk_pm.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#define SUSPEND_ISO_GPIO_BASE 0
+#define SUSPEND_ISO_GPIO_SIZE 86
diff --git a/include/soc/realtek/rtk_regmap.h b/include/soc/realtek/rtk_regmap.h
new file mode 100644
index 00000000..1ca3ce1
--- /dev/null
+++ b/include/soc/realtek/rtk_regmap.h
@@ -0,0 +1,100 @@
+/*
+ * rtk_regmap.h - Realtek Regmap API
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ * Copyright (C) 2017 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifndef __SOC_REALTEK_REGMAP_H
+#define __SOC_REALTEK_REGMAP_H
+
+#include <linux/regmap.h>
+struct i2c_client;
+
+/* i2c api */
+struct regmap *__rtk_regmap_init_i2c(struct i2c_client *client,
+				     const struct regmap_config *config,
+				     struct lock_class_key *lock_key,
+				     const char *lock_name);
+struct regmap *__devm_rtk_regmap_init_i2c(struct i2c_client *client,
+					  const struct regmap_config *config,
+					  struct lock_class_key *lock_key,
+					  const char *lock_name);
+
+#define rtk_regmap_init_i2c(client, config)                             \
+	__regmap_lockdep_wrapper(__rtk_regmap_init_i2c, #config,        \
+		client, config)
+#define devm_rtk_regmap_init_i2c(client, config)                        \
+	__regmap_lockdep_wrapper(__devm_rtk_regmap_init_i2c, #config,	\
+		client, config)
+
+/* mmio api */
+struct regmap *__rtk_regmap_init_mmio(struct device *dev,
+				      void __iomem *regs,
+				      const struct regmap_config *config,
+				      struct lock_class_key *lock_key,
+				      const char *lock_name);
+struct regmap *__devm_rtk_regmap_init_mmio(struct device *dev,
+					   void __iomem *regs,
+					   const struct regmap_config *config,
+					   struct lock_class_key *lock_key,
+					   const char *lock_name);
+
+#define rtk_regmap_init_mmio(dev, regs, config)                         \
+	__regmap_lockdep_wrapper(__rtk_regmap_init_mmio, #config,       \
+		dev, regs, config)
+#define devm_rtk_regmap_init_mmio(dev, regs, config)                    \
+	__regmap_lockdep_wrapper(__devm_rtk_regmap_init_mmio, #config,	\
+		dev, regs, config)
+
+/* secure mmio api */
+enum {
+	SMCCC_FMT_CMD,
+	SMCCC_FMT_CMD_PHYS,
+};
+
+struct secure_register_desc {
+	u32 offset;
+	u32 wcmd;
+	u32 rcmd;
+	u32 fmt;
+};
+
+#define REG_DESC_OFFSET_INVALID  0xffffffff
+#define DEFINE_REG_SMCCC(_off, _w, _r) \
+	{ .offset = _off, .wcmd = _w, .rcmd = _r, .fmt = SMCCC_FMT_CMD, }
+#define DEFINE_REG_SMCCC_PHYS(_off, _w, _r) \
+	{ .offset = _off, .wcmd = _w, .rcmd = _r, .fmt = SMCCC_FMT_CMD_PHYS, }
+#define DEFINE_REG_INVALID \
+	{ .offset = REG_DESC_OFFSET_INVALID, }
+
+struct rtk_regmap_config {
+	struct regmap_config config;
+	const struct secure_register_desc *descs;
+	u32 num_descs;
+	u32 addr;
+};
+
+struct regmap *__rtk_regmap_init_secure_mmio(struct device *dev,
+					     void __iomem *regs,
+					     const struct rtk_regmap_config *config,
+					     struct lock_class_key *lock_key,
+					     const char *lock_name);
+struct regmap *__devm_rtk_regmap_init_secure_mmio(struct device *dev,
+						  void __iomem *regs,
+						  const struct rtk_regmap_config *config,
+						  struct lock_class_key *lock_key,
+						  const char *lock_name);
+
+#define rtk_regmap_init_secure_mmio(dev, regs, config)                        \
+	__regmap_lockdep_wrapper(__rtk_regmap_init_secure_mmio, #config,      \
+		dev, regs, config)
+#define devm_rtk_regmap_init_secure_mmio(dev, regs, config)                   \
+	__regmap_lockdep_wrapper(__devm_rtk_regmap_init_secure_mmio, #config, \
+		dev, regs, config)
+
+
+#endif
diff --git a/include/soc/realtek/rtk_rstctl.h b/include/soc/realtek/rtk_rstctl.h
new file mode 100644
index 00000000..fb25bf0
--- /dev/null
+++ b/include/soc/realtek/rtk_rstctl.h
@@ -0,0 +1,25 @@
+/*
+ * rtk_rstctl.h
+ *
+ * Copyright (c) 2018 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+#ifndef __RTK_RSTCTL_H__
+#define __RTK_RSTCTL_H__
+
+#define RESET_MAGIC 0xAABBCC00
+
+typedef enum {
+	RESET_ACTION_NO_ACTION = 0,
+	RESET_ACTION_FASTBOOT,
+	RESET_ACTION_RECOVERY,
+	RESET_ACTION_GOLDEN,
+	RESET_ACTION_RESCUE,
+	RESET_ACTION_ABNORMAL = 0xff,
+}RESET_ACTION;
+
+#endif /* __RTK_RSTCTL_H__ */
diff --git a/include/soc/realtek/rtk_sb2_dbg.h b/include/soc/realtek/rtk_sb2_dbg.h
new file mode 100644
index 00000000..0d6054b
--- /dev/null
+++ b/include/soc/realtek/rtk_sb2_dbg.h
@@ -0,0 +1,75 @@
+/*
+ * rtk_sb2_dbg.h - Realtek SB2 Debug API
+ *
+ * Copyright (C) 2019 Realtek Semiconductor Corporation
+ * Copyright (C) 2019 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __SOC_REALTEK_SB2_DGB_H
+#define __SOC_REALTEK_SB2_DGB_H
+
+#include <linux/ktime.h>
+
+enum {
+	SB2_DBG_SOURCE_SCPU,
+	SB2_DBG_SOURCE_ACPU,
+	SB2_DBG_SOURCE_PCPU,
+};
+
+enum {
+	SB2_DBG_ACCESS_WRITE,
+	SB2_DBG_ACCESS_READ,
+	SB2_DBG_ACCESS_DATA,
+	SB2_DBG_ACCESS_INSTRUCTION,
+};
+
+struct sb2_dbg_event_data {
+	u32 raw_ints;
+	u32 cpu;
+	u32 rw;
+	u32 di;
+	u32 addr;
+	ktime_t cur_time;
+};
+
+enum {
+	SB2_INV_SCPU_SWC,
+	SB2_INV_SCPU,
+	SB2_INV_ACPU,
+	SB2_INV_PCPU,
+};
+
+struct sb2_inv_event_data {
+	u32 raw_ints;
+	u32 addr;
+	u32 inv_cpu;
+	u32 timeout_th;
+	ktime_t cur_time;
+};
+
+int sb2_dbg_register_dbg_notifier(struct notifier_block *nb);
+int sb2_dbg_unregister_dbg_notifier(struct notifier_block *nb);
+int sb2_dbg_register_inv_notifier(struct notifier_block *nb);
+int sb2_dbg_unregister_inv_notifier(struct notifier_block *nb);
+
+void sb2_dbg_disable_default_handlers(void);
+void sb2_dbg_enable_default_handlers(void);
+static inline void sb2_dbg_add_default_handlers(void)
+{
+	sb2_dbg_enable_default_handlers();
+}
+static inline void sb2_dbg_remove_default_handlers(void)
+{
+	sb2_dbg_disable_default_handlers();
+}
+
+int sb2_dbg_ready(void);
+int sb2_dbg_disable_mem_monitor(int i);
+int sb2_dbg_scpu_monitor(int which, u32 start, u32 end, u32 d_i, u32 r_w);
+int sb2_dbg_acpu_monitor(int which, u32 start, u32 end, u32 d_i, u32 r_w);
+
+#endif
diff --git a/include/soc/realtek/rtk_sb2_sem.h b/include/soc/realtek/rtk_sb2_sem.h
new file mode 100644
index 00000000..690b12e
--- /dev/null
+++ b/include/soc/realtek/rtk_sb2_sem.h
@@ -0,0 +1,39 @@
+/*
+ * rtk_sb2_sem.h - Realtek SB2 HW semaphore API
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ * Copyright (C) 2017 Cheng-Yu Lee <cylee12@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __SOC_REALTEK_SB2_SEM_H
+#define __SOC_REALTEK_SB2_SEM_H
+
+struct sb2_sem;
+struct sb2_sem *sb2_sem_get(unsigned int index);
+int sb2_sem_try_lock(struct sb2_sem *sem, unsigned int flags);
+void sb2_sem_lock(struct sb2_sem *sem, unsigned int flags);
+void sb2_sem_unlock(struct sb2_sem *sem);
+struct sb2_sem *sb2_sem_node_to_lock(struct device_node *np);
+
+#define SB2_SEM_NO_WARNING         0x2
+#define SB2_SEM_TIMEOUT_INFINITY   0x4
+
+static inline struct sb2_sem *of_sb2_sem_get(const struct device_node *np,
+	 int index)
+{
+	struct of_phandle_args args;
+	int ret;
+
+	ret = of_parse_phandle_with_fixed_args(np, "realtek,sb2-lock", 0,
+		index, &args);
+	if (ret)
+		return ERR_PTR(ret);
+
+	return sb2_sem_node_to_lock(args.np);
+}
+
+#endif
diff --git a/include/soc/realtek/rtk_sha1.h b/include/soc/realtek/rtk_sha1.h
new file mode 100644
index 00000000..210b47d
--- /dev/null
+++ b/include/soc/realtek/rtk_sha1.h
@@ -0,0 +1,40 @@
+/*
+ * rtk_sha1.h - sha1 API
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+/********************************************************************************
+ SHA-1 Hashing
+ ********************************************************************************/
+#ifndef __RTK_SHA1_H__
+#define __RTK_SHA1_H__
+
+#define uint8_t unsigned char
+#define uint32_t unsigned int
+
+typedef struct {
+    unsigned int   state[5];
+    unsigned int   count[2];
+    unsigned char  buffer[64];
+} SHA1_CTX;
+
+#define SHA1_FILE_HASHING_BUFFER_SIZE        FILE_HASHING_BUFFER_SIZE
+#define SHA1_DIGEST_SIZE                     20
+#define SHA1_BLOCK_SIZE                      64
+#define SHA1_ALIGNMENT_CHECK                 0x3F
+
+int MCP_SHA1_Get_Hash( unsigned char * source, unsigned int source_len, unsigned char * hash );
+void MCP_SHA1_dump_hex( unsigned char * pbuf, unsigned int len );
+
+void SHA1_Transform(unsigned int state[5], const unsigned char buffer[64]);
+void SHA1_Init(SHA1_CTX * context);
+void SHA1_Update(SHA1_CTX * context, const unsigned char * data, const size_t len);
+void SHA1_Final(SHA1_CTX * context, unsigned char digest[SHA1_DIGEST_SIZE]);
+
+#endif // __RTK_SHA1_H__
diff --git a/include/soc/realtek/rtk_usb.h b/include/soc/realtek/rtk_usb.h
new file mode 100644
index 00000000..df9da15
--- /dev/null
+++ b/include/soc/realtek/rtk_usb.h
@@ -0,0 +1,45 @@
+/*
+ * rtk_usb.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __RTK_USB_H_INCLUDED_
+#define __RTK_USB_H_INCLUDED_
+
+struct device_node;
+struct rtk_usb;
+
+enum usb_port_num {
+	USB_PORT_0 = 0,
+	USB_PORT_1 = 1,
+	USB_PORT_2 = 2,
+	USB_PORT_3 = 3,
+};
+
+struct rtk_usb *rtk_usb_soc_init(struct device_node *node);
+
+int rtk_usb_soc_free(struct rtk_usb **rtk_usb);
+
+int rtk_usb_port_suspend_resume(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool is_suspend);
+
+int rtk_usb_set_hw_l4icg_on_off(struct rtk_usb *rtk_usb,
+	    enum usb_port_num port_num, bool on);
+
+int rtk_usb_iso_power_ctrl(struct rtk_usb *rtk_usb,
+	    bool power_on);
+
+void rtk_usb_set_charger_power(struct rtk_usb *rtk_usb, unsigned int val);
+
+/* For Type c */
+int rtk_type_c_init(struct rtk_usb *rtk_usb);
+
+int rtk_type_c_plug_config(struct rtk_usb *rtk_usb, int dr_mode, int cc);
+
+#endif // __RTK_USB_H_INCLUDED_
diff --git a/include/soc/realtek/rtk_wdt.h b/include/soc/realtek/rtk_wdt.h
new file mode 100644
index 00000000..be0d0be
--- /dev/null
+++ b/include/soc/realtek/rtk_wdt.h
@@ -0,0 +1,45 @@
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+#ifndef __SOC_REALTEK_WDT_H
+#define __SOC_REALTEK_WDT_H
+
+struct notifier_block;
+#define RTK_WATCHDOG_NMI_PRI_SYSRQ    (20)
+#define RTK_WATCHDOG_NMI_PRI_ISO_RESET (-20)
+
+#ifdef CONFIG_RTK_WATCHDOG
+
+int rtk_wdt_register_notifier(struct notifier_block *nb);
+int rtk_wdt_unregister_notifier(struct notifier_block *nb);
+
+int set_wdt_oe(void);
+#else
+
+static inline
+int rtk_wdt_register_notifier(struct notifier_block *nb)
+{
+	return 0;
+}
+
+static inline
+int rtk_wdt_unregister_notifier(struct notifier_block *nb)
+{
+	return 0;
+}
+
+static inline set_wdt_oe(void) { return; }
+#endif /* CONFIG_RTK_WATCHDOG */
+
+#endif /* __SOC_REALTEK_WDT_H */
diff --git a/include/soc/realtek/venus_gpio.h b/include/soc/realtek/venus_gpio.h
new file mode 100644
index 00000000..73f8028
--- /dev/null
+++ b/include/soc/realtek/venus_gpio.h
@@ -0,0 +1,116 @@
+/*
+ * venus_gpio.h
+ *
+ * Copyright (c) 2017 Realtek Semiconductor Corp.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ */
+
+#ifndef __VENUS_GPIO_H__
+#define __VENUS_GPIO_H__
+
+#define VENUS_GPIO_ID               unsigned int
+
+#define venus_gpio_id(group, idx)   (((group & 0x3) << 8) | (idx & 0xFF))
+#define gpio_group(id)              ((id >> 8) & 0x3)
+#define gpio_idx(id)                (id & 0xFF)
+#define gpio_type(group)           ((group==ISO_GPIO) ? "ISO" : "MISC")
+
+typedef struct 
+{
+    char   name[32];    
+    void*  dev_id;
+    void (*handler) (VENUS_GPIO_ID id, unsigned char assert, void* data);   // assert call back
+}VENUS_GPIO_IRQ;
+
+
+typedef enum {
+    MIS_GPIO = 0,
+    ISO_GPIO,
+}VENUS_GPIO_GROUP;
+
+typedef enum {
+    VENUS_GPIO_DEBOUNCE_37ns = 0,
+    VENUS_GPIO_DEBOUNCE_1us,
+    VENUS_GPIO_DEBOUNCE_10us,
+    VENUS_GPIO_DEBOUNCE_100us,
+    VENUS_GPIO_DEBOUNCE_1ms,
+    VENUS_GPIO_DEBOUNCE_10ms,
+    VENUS_GPIO_DEBOUNCE_20ms,
+    VENUS_GPIO_DEBOUNCE_30ms,
+}VENUS_GPIO_DEBOUNCE;
+
+////////////////// APIs ////////////////////
+
+static __maybe_unused int venus_gpio_set_dir          (VENUS_GPIO_ID          gid,  unsigned char     out){return 0;}
+static __maybe_unused int venus_gpio_set_debounce     (VENUS_GPIO_ID          gid, unsigned char     val){return 0;}                                
+static __maybe_unused  int venus_gpio_input            (VENUS_GPIO_ID          gid){return 0;}                                 
+static __maybe_unused  int venus_gpio_output           (VENUS_GPIO_ID          gid, unsigned char    val){return 0;}                                
+static __maybe_unused  int venus_gpio_set_irq_polarity (VENUS_GPIO_ID          gid, unsigned char     positive){return 0;}
+static __maybe_unused  int venus_gpio_set_irq_enable   (VENUS_GPIO_ID          gid,  unsigned char     on){return 0;}
+static __maybe_unused  int venus_gpio_request_irq      (VENUS_GPIO_ID          gid, 
+                                 void (*handler) (VENUS_GPIO_ID gid, unsigned char assert, void* dev_id), 
+                                 char*                  name,
+                                 void*                  dev_id){return 0;}
+
+
+static __maybe_unused  void venus_gpio_free_irq        (VENUS_GPIO_ID          gid,  void*     dev_id){return ;}                                    
+static  __maybe_unused int venus_gpio_clear_isr        (VENUS_GPIO_ID          gid){return 0;}
+static __maybe_unused  int venus_gpio_chk_irq_enable   (VENUS_GPIO_ID          gid){return 0;}                                                         
+
+
+
+
+
+
+
+
+/*
+
+int venus_gpio_set_dir          (VENUS_GPIO_ID          gid, 
+                                 unsigned char          out);
+
+int venus_gpio_set_debounce     (VENUS_GPIO_ID          gid, 
+                                 unsigned char          val);
+                                 
+int venus_gpio_input            (VENUS_GPIO_ID          gid);
+                                 
+int venus_gpio_output           (VENUS_GPIO_ID          gid,
+                                 unsigned char          val);
+                                 
+int venus_gpio_set_irq_polarity (VENUS_GPIO_ID          gid, 
+                                 unsigned char          positive);
+
+int venus_gpio_set_irq_enable   (VENUS_GPIO_ID          gid, 
+                                 unsigned char          on);
+
+int venus_gpio_request_irq      (VENUS_GPIO_ID          gid, 
+                                 void (*handler) (VENUS_GPIO_ID gid, unsigned char assert, void* dev_id), 
+                                 char*                  name,
+                                 void*                  dev_id);
+
+void venus_gpio_free_irq        (VENUS_GPIO_ID          gid,
+                                 void*                  dev_id);     
+                                 
+int venus_gpio_clear_isr        (VENUS_GPIO_ID          gid);
+
+int venus_gpio_chk_irq_enable   (VENUS_GPIO_ID          gid);         
+*/
+////////////////// Debug messages ////////////////////
+
+
+#ifdef CONFIG_VENUS_GPIO_DBG_EN
+#define VENUS_GPIO_DBG(fmt, args...)          printk("[GPIO] Dbg, " fmt, ## args)
+#define VENUS_GPIO_INFO(fmt, args...)         printk("[GPIO] Info, " fmt, ## args)
+#else
+#define VENUS_GPIO_DBG(fmt, args...) 
+#define VENUS_GPIO_INFO(fmt, args...)         
+#endif
+
+#define VENUS_GPIO_WARNING(fmt, args...)      printk("[GPIO] Warning, " fmt, ## args)
+    
+    
+#endif //__VENUS_GPIO_H__
diff --git a/include/sound/memalloc.h b/include/sound/memalloc.h
index 782d1df..33749b5 100644
--- a/include/sound/memalloc.h
+++ b/include/sound/memalloc.h
@@ -58,6 +58,11 @@ struct snd_dma_device {
 #define SNDRV_DMA_TYPE_DEV_IRAM	SNDRV_DMA_TYPE_DEV
 #endif
 
+#ifdef CONFIG_RTK_PLATFORM
+#define SNDRV_DMA_TYPE_ION_PLAYBACK 5
+#define SNDRV_DMA_TYPE_ION_CAPTURE 6
+#endif /* CONFIG_RTK_PLATFORM */
+
 /*
  * info for buffer allocation
  */
diff --git a/include/trace/events/android_fs.h b/include/trace/events/android_fs.h
new file mode 100644
index 00000000..4950953
--- /dev/null
+++ b/include/trace/events/android_fs.h
@@ -0,0 +1,65 @@
+#undef TRACE_SYSTEM
+#define TRACE_SYSTEM android_fs
+
+#if !defined(_TRACE_ANDROID_FS_H) || defined(TRACE_HEADER_MULTI_READ)
+#define _TRACE_ANDROID_FS_H
+
+#include <linux/tracepoint.h>
+#include <trace/events/android_fs_template.h>
+
+DEFINE_EVENT(android_fs_data_start_template, android_fs_dataread_start,
+	TP_PROTO(struct inode *inode, loff_t offset, int bytes,
+		 pid_t pid, char *pathname, char *command),
+	TP_ARGS(inode, offset, bytes, pid, pathname, command));
+
+DEFINE_EVENT(android_fs_data_end_template, android_fs_dataread_end,
+	TP_PROTO(struct inode *inode, loff_t offset, int bytes),
+	TP_ARGS(inode, offset, bytes));
+
+DEFINE_EVENT(android_fs_data_start_template, android_fs_datawrite_start,
+	TP_PROTO(struct inode *inode, loff_t offset, int bytes,
+		 pid_t pid, char *pathname, char *command),
+	TP_ARGS(inode, offset, bytes, pid, pathname, command));
+
+DEFINE_EVENT(android_fs_data_end_template, android_fs_datawrite_end,
+	TP_PROTO(struct inode *inode, loff_t offset, int bytes),
+	     TP_ARGS(inode, offset, bytes));
+
+#endif /* _TRACE_ANDROID_FS_H */
+
+/* This part must be outside protection */
+#include <trace/define_trace.h>
+
+#ifndef ANDROID_FSTRACE_GET_PATHNAME
+#define ANDROID_FSTRACE_GET_PATHNAME
+
+/* Sizes an on-stack array, so careful if sizing this up ! */
+#define MAX_TRACE_PATHBUF_LEN	256
+
+static inline char *
+android_fstrace_get_pathname(char *buf, int buflen, struct inode *inode)
+{
+	char *path;
+	struct dentry *d;
+
+	/*
+	 * d_obtain_alias() will either iput() if it locates an existing
+	 * dentry or transfer the reference to the new dentry created.
+	 * So get an extra reference here.
+	 */
+	ihold(inode);
+	d = d_obtain_alias(inode);
+	if (likely(!IS_ERR(d))) {
+		path = dentry_path_raw(d, buf, buflen);
+		if (unlikely(IS_ERR(path))) {
+			strcpy(buf, "ERROR");
+			path = buf;
+		}
+		dput(d);
+	} else {
+		strcpy(buf, "ERROR");
+		path = buf;
+	}
+	return path;
+}
+#endif
diff --git a/include/trace/events/android_fs_template.h b/include/trace/events/android_fs_template.h
new file mode 100644
index 00000000..b23d17b
--- /dev/null
+++ b/include/trace/events/android_fs_template.h
@@ -0,0 +1,64 @@
+#if !defined(_TRACE_ANDROID_FS_TEMPLATE_H) || defined(TRACE_HEADER_MULTI_READ)
+#define _TRACE_ANDROID_FS_TEMPLATE_H
+
+#include <linux/tracepoint.h>
+
+DECLARE_EVENT_CLASS(android_fs_data_start_template,
+	TP_PROTO(struct inode *inode, loff_t offset, int bytes,
+		 pid_t pid, char *pathname, char *command),
+	TP_ARGS(inode, offset, bytes, pid, pathname, command),
+	TP_STRUCT__entry(
+		__string(pathbuf, pathname);
+		__field(loff_t,	offset);
+		__field(int,	bytes);
+		__field(loff_t,	i_size);
+		__string(cmdline, command);
+		__field(pid_t,	pid);
+		__field(ino_t,	ino);
+	),
+	TP_fast_assign(
+		{
+			/*
+			 * Replace the spaces in filenames and cmdlines
+			 * because this screws up the tooling that parses
+			 * the traces.
+			 */
+			__assign_str(pathbuf, pathname);
+			(void)strreplace(__get_str(pathbuf), ' ', '_');
+			__entry->offset		= offset;
+			__entry->bytes		= bytes;
+			__entry->i_size		= i_size_read(inode);
+			__assign_str(cmdline, command);
+			(void)strreplace(__get_str(cmdline), ' ', '_');
+			__entry->pid		= pid;
+			__entry->ino		= inode->i_ino;
+		}
+	),
+	TP_printk("entry_name %s, offset %llu, bytes %d, cmdline %s,"
+		  " pid %d, i_size %llu, ino %lu",
+		  __get_str(pathbuf), __entry->offset, __entry->bytes,
+		  __get_str(cmdline), __entry->pid, __entry->i_size,
+		  (unsigned long) __entry->ino)
+);
+
+DECLARE_EVENT_CLASS(android_fs_data_end_template,
+	TP_PROTO(struct inode *inode, loff_t offset, int bytes),
+	TP_ARGS(inode, offset, bytes),
+	TP_STRUCT__entry(
+		__field(ino_t,	ino);
+		__field(loff_t,	offset);
+		__field(int,	bytes);
+	),
+	TP_fast_assign(
+		{
+			__entry->ino		= inode->i_ino;
+			__entry->offset		= offset;
+			__entry->bytes		= bytes;
+		}
+	),
+	TP_printk("ino %lu, offset %llu, bytes %d",
+		  (unsigned long) __entry->ino,
+		  __entry->offset, __entry->bytes)
+);
+
+#endif /* _TRACE_ANDROID_FS_TEMPLATE_H */
diff --git a/include/trace/events/cpufreq_interactive.h b/include/trace/events/cpufreq_interactive.h
new file mode 100644
index 00000000..faecc0b
--- /dev/null
+++ b/include/trace/events/cpufreq_interactive.h
@@ -0,0 +1,112 @@
+#undef TRACE_SYSTEM
+#define TRACE_SYSTEM cpufreq_interactive
+
+#if !defined(_TRACE_CPUFREQ_INTERACTIVE_H) || defined(TRACE_HEADER_MULTI_READ)
+#define _TRACE_CPUFREQ_INTERACTIVE_H
+
+#include <linux/tracepoint.h>
+
+DECLARE_EVENT_CLASS(set,
+	TP_PROTO(u32 cpu_id, unsigned long targfreq,
+		 unsigned long actualfreq),
+	TP_ARGS(cpu_id, targfreq, actualfreq),
+
+	TP_STRUCT__entry(
+		__field(u32, cpu_id)
+		__field(unsigned long, targfreq)
+		__field(unsigned long, actualfreq)
+	),
+
+	TP_fast_assign(
+		__entry->cpu_id = (u32)cpu_id;
+		__entry->targfreq = targfreq;
+		__entry->actualfreq = actualfreq;
+	),
+
+	TP_printk("cpu=%u targ=%lu actual=%lu",
+		__entry->cpu_id, __entry->targfreq,
+		__entry->actualfreq)
+);
+
+DEFINE_EVENT(set, cpufreq_interactive_setspeed,
+	TP_PROTO(u32 cpu_id, unsigned long targfreq,
+		 unsigned long actualfreq),
+	TP_ARGS(cpu_id, targfreq, actualfreq)
+);
+
+DECLARE_EVENT_CLASS(loadeval,
+	TP_PROTO(unsigned long cpu_id, unsigned long load,
+		 unsigned long curtarg, unsigned long curactual,
+		 unsigned long newtarg),
+	TP_ARGS(cpu_id, load, curtarg, curactual, newtarg),
+
+	TP_STRUCT__entry(
+		__field(unsigned long, cpu_id)
+		__field(unsigned long, load)
+		__field(unsigned long, curtarg)
+		__field(unsigned long, curactual)
+		__field(unsigned long, newtarg)
+	),
+
+	TP_fast_assign(
+		__entry->cpu_id = cpu_id;
+		__entry->load = load;
+		__entry->curtarg = curtarg;
+		__entry->curactual = curactual;
+		__entry->newtarg = newtarg;
+	),
+
+	TP_printk("cpu=%lu load=%lu cur=%lu actual=%lu targ=%lu",
+		  __entry->cpu_id, __entry->load, __entry->curtarg,
+		  __entry->curactual, __entry->newtarg)
+);
+
+DEFINE_EVENT(loadeval, cpufreq_interactive_target,
+	TP_PROTO(unsigned long cpu_id, unsigned long load,
+		 unsigned long curtarg, unsigned long curactual,
+		 unsigned long newtarg),
+	TP_ARGS(cpu_id, load, curtarg, curactual, newtarg)
+);
+
+DEFINE_EVENT(loadeval, cpufreq_interactive_already,
+	TP_PROTO(unsigned long cpu_id, unsigned long load,
+		 unsigned long curtarg, unsigned long curactual,
+		 unsigned long newtarg),
+	TP_ARGS(cpu_id, load, curtarg, curactual, newtarg)
+);
+
+DEFINE_EVENT(loadeval, cpufreq_interactive_notyet,
+	TP_PROTO(unsigned long cpu_id, unsigned long load,
+		 unsigned long curtarg, unsigned long curactual,
+		 unsigned long newtarg),
+	TP_ARGS(cpu_id, load, curtarg, curactual, newtarg)
+);
+
+TRACE_EVENT(cpufreq_interactive_boost,
+	TP_PROTO(const char *s),
+	TP_ARGS(s),
+	TP_STRUCT__entry(
+		__string(s, s)
+	),
+	TP_fast_assign(
+		__assign_str(s, s);
+	),
+	TP_printk("%s", __get_str(s))
+);
+
+TRACE_EVENT(cpufreq_interactive_unboost,
+	TP_PROTO(const char *s),
+	TP_ARGS(s),
+	TP_STRUCT__entry(
+		__string(s, s)
+	),
+	TP_fast_assign(
+		__assign_str(s, s);
+	),
+	TP_printk("%s", __get_str(s))
+);
+
+#endif /* _TRACE_CPUFREQ_INTERACTIVE_H */
+
+/* This part must be outside protection */
+#include <trace/define_trace.h>
diff --git a/include/trace/events/cpufreq_sched.h b/include/trace/events/cpufreq_sched.h
new file mode 100644
index 00000000..a46cd08
--- /dev/null
+++ b/include/trace/events/cpufreq_sched.h
@@ -0,0 +1,87 @@
+/*
+ *  Copyright (C)  2015 Steve Muckle <smuckle@linaro.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#undef TRACE_SYSTEM
+#define TRACE_SYSTEM cpufreq_sched
+
+#if !defined(_TRACE_CPUFREQ_SCHED_H) || defined(TRACE_HEADER_MULTI_READ)
+#define _TRACE_CPUFREQ_SCHED_H
+
+#include <linux/sched.h>
+#include <linux/tracepoint.h>
+
+TRACE_EVENT(cpufreq_sched_throttled,
+	    TP_PROTO(unsigned int rem),
+	    TP_ARGS(rem),
+	    TP_STRUCT__entry(
+		    __field(	unsigned int,	rem)
+	    ),
+	    TP_fast_assign(
+		    __entry->rem = rem;
+	    ),
+	    TP_printk("throttled - %d usec remaining", __entry->rem)
+);
+
+TRACE_EVENT(cpufreq_sched_request_opp,
+	    TP_PROTO(int cpu,
+		     unsigned long capacity,
+		     unsigned int freq_new,
+		     unsigned int requested_freq),
+	    TP_ARGS(cpu, capacity, freq_new, requested_freq),
+	    TP_STRUCT__entry(
+		    __field(	int,		cpu)
+		    __field(	unsigned long,	capacity)
+		    __field(	unsigned int,	freq_new)
+		    __field(	unsigned int,	requested_freq)
+		    ),
+	    TP_fast_assign(
+		    __entry->cpu = cpu;
+		    __entry->capacity = capacity;
+		    __entry->freq_new = freq_new;
+		    __entry->requested_freq = requested_freq;
+		    ),
+	    TP_printk("cpu %d cap change, cluster cap request %ld => OPP %d "
+		      "(cur %d)",
+		      __entry->cpu, __entry->capacity, __entry->freq_new,
+		      __entry->requested_freq)
+);
+
+TRACE_EVENT(cpufreq_sched_update_capacity,
+	    TP_PROTO(int cpu,
+		     bool request,
+		     struct sched_capacity_reqs *scr,
+		     unsigned long new_capacity),
+	    TP_ARGS(cpu, request, scr, new_capacity),
+	    TP_STRUCT__entry(
+		    __field(	int,		cpu)
+		    __field(	bool,		request)
+		    __field(	unsigned long,	cfs)
+		    __field(	unsigned long,	rt)
+		    __field(	unsigned long,	dl)
+		    __field(	unsigned long,	total)
+		    __field(	unsigned long,	new_total)
+	    ),
+	    TP_fast_assign(
+		    __entry->cpu = cpu;
+		    __entry->request = request;
+		    __entry->cfs = scr->cfs;
+		    __entry->rt = scr->rt;
+		    __entry->dl = scr->dl;
+		    __entry->total = scr->total;
+		    __entry->new_total = new_capacity;
+	    ),
+	    TP_printk("cpu=%d set_cap=%d cfs=%ld rt=%ld dl=%ld old_tot=%ld "
+		      "new_tot=%ld",
+		      __entry->cpu, __entry->request, __entry->cfs, __entry->rt,
+		      __entry->dl, __entry->total, __entry->new_total)
+);
+
+#endif /* _TRACE_CPUFREQ_SCHED_H */
+
+/* This part must be outside protection */
+#include <trace/define_trace.h>
diff --git a/include/trace/events/f2fs.h b/include/trace/events/f2fs.h
index 903a091..e88465a 100644
--- a/include/trace/events/f2fs.h
+++ b/include/trace/events/f2fs.h
@@ -6,8 +6,8 @@
 
 #include <linux/tracepoint.h>
 
-#define show_dev(entry)		MAJOR(entry->dev), MINOR(entry->dev)
-#define show_dev_ino(entry)	show_dev(entry), (unsigned long)entry->ino
+#define show_dev(dev)		MAJOR(dev), MINOR(dev)
+#define show_dev_ino(entry)	show_dev(entry->dev), (unsigned long)entry->ino
 
 TRACE_DEFINE_ENUM(NODE);
 TRACE_DEFINE_ENUM(DATA);
@@ -15,6 +15,8 @@
 TRACE_DEFINE_ENUM(META_FLUSH);
 TRACE_DEFINE_ENUM(INMEM);
 TRACE_DEFINE_ENUM(INMEM_DROP);
+TRACE_DEFINE_ENUM(INMEM_INVALIDATE);
+TRACE_DEFINE_ENUM(INMEM_REVOKE);
 TRACE_DEFINE_ENUM(IPU);
 TRACE_DEFINE_ENUM(OPU);
 TRACE_DEFINE_ENUM(CURSEG_HOT_DATA);
@@ -42,6 +44,7 @@
 TRACE_DEFINE_ENUM(CP_SYNC);
 TRACE_DEFINE_ENUM(CP_RECOVERY);
 TRACE_DEFINE_ENUM(CP_DISCARD);
+TRACE_DEFINE_ENUM(CP_TRIMMED);
 
 #define show_block_type(type)						\
 	__print_symbolic(type,						\
@@ -51,32 +54,40 @@
 		{ META_FLUSH,	"META_FLUSH" },				\
 		{ INMEM,	"INMEM" },				\
 		{ INMEM_DROP,	"INMEM_DROP" },				\
+		{ INMEM_INVALIDATE,	"INMEM_INVALIDATE" },		\
 		{ INMEM_REVOKE,	"INMEM_REVOKE" },			\
 		{ IPU,		"IN-PLACE" },				\
 		{ OPU,		"OUT-OF-PLACE" })
 
-#define F2FS_BIO_FLAG_MASK(t)	(t & (REQ_RAHEAD | WRITE_FLUSH_FUA))
-#define F2FS_BIO_EXTRA_MASK(t)	(t & (REQ_META | REQ_PRIO))
+#define F2FS_OP_FLAGS (REQ_RAHEAD | REQ_SYNC | REQ_META | REQ_PRIO |	\
+			REQ_PREFLUSH | REQ_FUA)
+#define F2FS_BIO_FLAG_MASK(t)	(t & F2FS_OP_FLAGS)
 
-#define show_bio_type(op_flags)	show_bio_op_flags(op_flags), 		\
-						show_bio_extra(op_flags)
+#define show_bio_type(op,op_flags)	show_bio_op(op),		\
+						show_bio_op_flags(op_flags)
+
+#define show_bio_op(op)							\
+	__print_symbolic(op,						\
+		{ REQ_OP_READ,			"READ" },		\
+		{ REQ_OP_WRITE,			"WRITE" },		\
+		{ REQ_OP_DISCARD,		"DISCARD" },		\
+		{ REQ_OP_SECURE_ERASE,		"SECURE_ERASE" },	\
+		{ REQ_OP_WRITE_SAME,		"WRITE_SAME" })
 
 #define show_bio_op_flags(flags)					\
-	__print_symbolic(F2FS_BIO_FLAG_MASK(flags),			\
-		{ 0,			"WRITE" },			\
-		{ REQ_RAHEAD, 		"READAHEAD" },			\
-		{ READ_SYNC, 		"READ_SYNC" },			\
-		{ WRITE_SYNC, 		"WRITE_SYNC" },			\
-		{ WRITE_FLUSH,		"WRITE_FLUSH" },		\
-		{ WRITE_FUA, 		"WRITE_FUA" },			\
-		{ WRITE_FLUSH_FUA,	"WRITE_FLUSH_FUA" })
-
-#define show_bio_extra(type)						\
-	__print_symbolic(F2FS_BIO_EXTRA_MASK(type),			\
-		{ REQ_META, 		"(M)" },			\
-		{ REQ_PRIO, 		"(P)" },			\
-		{ REQ_META | REQ_PRIO,	"(MP)" },			\
-		{ 0, " \b" })
+	__print_flags(F2FS_BIO_FLAG_MASK(flags), "|",			\
+		{ REQ_RAHEAD,		"R" },				\
+		{ REQ_SYNC,		"S" },				\
+		{ REQ_META,		"M" },				\
+		{ REQ_PRIO,		"P" },				\
+		{ REQ_PREFLUSH,		"PF" },				\
+		{ REQ_FUA,		"FUA" })
+
+#define show_block_temp(temp)						\
+	__print_symbolic(temp,						\
+		{ HOT,		"HOT" },				\
+		{ WARM,		"WARM" },				\
+		{ COLD,		"COLD" })
 
 #define show_data_type(type)						\
 	__print_symbolic(type,						\
@@ -109,12 +120,27 @@
 		{ GC_CB,	"Cost-Benefit" })
 
 #define show_cpreason(type)						\
-	__print_symbolic(type,						\
+	__print_flags(type, "|",					\
 		{ CP_UMOUNT,	"Umount" },				\
 		{ CP_FASTBOOT,	"Fastboot" },				\
 		{ CP_SYNC,	"Sync" },				\
 		{ CP_RECOVERY,	"Recovery" },				\
-		{ CP_DISCARD,	"Discard" })
+		{ CP_DISCARD,	"Discard" },				\
+		{ CP_UMOUNT,	"Umount" },				\
+		{ CP_TRIMMED,	"Trimmed" })
+
+#define show_fsync_cpreason(type)					\
+	__print_symbolic(type,						\
+		{ CP_NO_NEEDED,		"no needed" },			\
+		{ CP_NON_REGULAR,	"non regular" },		\
+		{ CP_HARDLINK,		"hardlink" },			\
+		{ CP_SB_NEED_CP,	"sb needs cp" },		\
+		{ CP_WRONG_PINO,	"wrong pino" },			\
+		{ CP_NO_SPC_ROLL,	"no space roll forward" },	\
+		{ CP_NODE_NEED_CP,	"node needs cp" },		\
+		{ CP_FASTBOOT_MODE,	"fastboot mode" },		\
+		{ CP_SPEC_LOG_NUM,	"log type is 2" },		\
+		{ CP_RECOVER_DIR,	"dir needs recovery" })
 
 struct victim_sel_policy;
 struct f2fs_map_blocks;
@@ -190,14 +216,14 @@
 
 TRACE_EVENT(f2fs_sync_file_exit,
 
-	TP_PROTO(struct inode *inode, int need_cp, int datasync, int ret),
+	TP_PROTO(struct inode *inode, int cp_reason, int datasync, int ret),
 
-	TP_ARGS(inode, need_cp, datasync, ret),
+	TP_ARGS(inode, cp_reason, datasync, ret),
 
 	TP_STRUCT__entry(
 		__field(dev_t,	dev)
 		__field(ino_t,	ino)
-		__field(int,	need_cp)
+		__field(int,	cp_reason)
 		__field(int,	datasync)
 		__field(int,	ret)
 	),
@@ -205,15 +231,15 @@
 	TP_fast_assign(
 		__entry->dev		= inode->i_sb->s_dev;
 		__entry->ino		= inode->i_ino;
-		__entry->need_cp	= need_cp;
+		__entry->cp_reason	= cp_reason;
 		__entry->datasync	= datasync;
 		__entry->ret		= ret;
 	),
 
-	TP_printk("dev = (%d,%d), ino = %lu, checkpoint is %s, "
+	TP_printk("dev = (%d,%d), ino = %lu, cp_reason: %s, "
 		"datasync = %d, ret = %d",
 		show_dev_ino(__entry),
-		__entry->need_cp ? "needed" : "not needed",
+		show_fsync_cpreason(__entry->cp_reason),
 		__entry->datasync,
 		__entry->ret)
 );
@@ -237,7 +263,7 @@
 	),
 
 	TP_printk("dev = (%d,%d), superblock is %s, wait = %d",
-		show_dev(__entry),
+		show_dev(__entry->dev),
 		__entry->dirty ? "dirty" : "not dirty",
 		__entry->wait)
 );
@@ -307,6 +333,13 @@
 	TP_ARGS(inode, ret)
 );
 
+DEFINE_EVENT(f2fs__inode_exit, f2fs_drop_inode,
+
+	TP_PROTO(struct inode *inode, int ret),
+
+	TP_ARGS(inode, ret)
+);
+
 DEFINE_EVENT(f2fs__inode, f2fs_truncate,
 
 	TP_PROTO(struct inode *inode),
@@ -516,14 +549,14 @@
 
 TRACE_EVENT(f2fs_background_gc,
 
-	TP_PROTO(struct super_block *sb, long wait_ms,
+	TP_PROTO(struct super_block *sb, unsigned int wait_ms,
 			unsigned int prefree, unsigned int free),
 
 	TP_ARGS(sb, wait_ms, prefree, free),
 
 	TP_STRUCT__entry(
 		__field(dev_t,	dev)
-		__field(long,	wait_ms)
+		__field(unsigned int,	wait_ms)
 		__field(unsigned int,	prefree)
 		__field(unsigned int,	free)
 	),
@@ -535,13 +568,120 @@
 		__entry->free		= free;
 	),
 
-	TP_printk("dev = (%d,%d), wait_ms = %ld, prefree = %u, free = %u",
-		show_dev(__entry),
+	TP_printk("dev = (%d,%d), wait_ms = %u, prefree = %u, free = %u",
+		show_dev(__entry->dev),
 		__entry->wait_ms,
 		__entry->prefree,
 		__entry->free)
 );
 
+TRACE_EVENT(f2fs_gc_begin,
+
+	TP_PROTO(struct super_block *sb, bool sync, bool background,
+			long long dirty_nodes, long long dirty_dents,
+			long long dirty_imeta, unsigned int free_sec,
+			unsigned int free_seg, int reserved_seg,
+			unsigned int prefree_seg),
+
+	TP_ARGS(sb, sync, background, dirty_nodes, dirty_dents, dirty_imeta,
+		free_sec, free_seg, reserved_seg, prefree_seg),
+
+	TP_STRUCT__entry(
+		__field(dev_t,		dev)
+		__field(bool,		sync)
+		__field(bool,		background)
+		__field(long long,	dirty_nodes)
+		__field(long long,	dirty_dents)
+		__field(long long,	dirty_imeta)
+		__field(unsigned int,	free_sec)
+		__field(unsigned int,	free_seg)
+		__field(int,		reserved_seg)
+		__field(unsigned int,	prefree_seg)
+	),
+
+	TP_fast_assign(
+		__entry->dev		= sb->s_dev;
+		__entry->sync		= sync;
+		__entry->background	= background;
+		__entry->dirty_nodes	= dirty_nodes;
+		__entry->dirty_dents	= dirty_dents;
+		__entry->dirty_imeta	= dirty_imeta;
+		__entry->free_sec	= free_sec;
+		__entry->free_seg	= free_seg;
+		__entry->reserved_seg	= reserved_seg;
+		__entry->prefree_seg	= prefree_seg;
+	),
+
+	TP_printk("dev = (%d,%d), sync = %d, background = %d, nodes = %lld, "
+		"dents = %lld, imeta = %lld, free_sec:%u, free_seg:%u, "
+		"rsv_seg:%d, prefree_seg:%u",
+		show_dev(__entry->dev),
+		__entry->sync,
+		__entry->background,
+		__entry->dirty_nodes,
+		__entry->dirty_dents,
+		__entry->dirty_imeta,
+		__entry->free_sec,
+		__entry->free_seg,
+		__entry->reserved_seg,
+		__entry->prefree_seg)
+);
+
+TRACE_EVENT(f2fs_gc_end,
+
+	TP_PROTO(struct super_block *sb, int ret, int seg_freed,
+			int sec_freed, long long dirty_nodes,
+			long long dirty_dents, long long dirty_imeta,
+			unsigned int free_sec, unsigned int free_seg,
+			int reserved_seg, unsigned int prefree_seg),
+
+	TP_ARGS(sb, ret, seg_freed, sec_freed, dirty_nodes, dirty_dents,
+		dirty_imeta, free_sec, free_seg, reserved_seg, prefree_seg),
+
+	TP_STRUCT__entry(
+		__field(dev_t,		dev)
+		__field(int,		ret)
+		__field(int,		seg_freed)
+		__field(int,		sec_freed)
+		__field(long long,	dirty_nodes)
+		__field(long long,	dirty_dents)
+		__field(long long,	dirty_imeta)
+		__field(unsigned int,	free_sec)
+		__field(unsigned int,	free_seg)
+		__field(int,		reserved_seg)
+		__field(unsigned int,	prefree_seg)
+	),
+
+	TP_fast_assign(
+		__entry->dev		= sb->s_dev;
+		__entry->ret		= ret;
+		__entry->seg_freed	= seg_freed;
+		__entry->sec_freed	= sec_freed;
+		__entry->dirty_nodes	= dirty_nodes;
+		__entry->dirty_dents	= dirty_dents;
+		__entry->dirty_imeta	= dirty_imeta;
+		__entry->free_sec	= free_sec;
+		__entry->free_seg	= free_seg;
+		__entry->reserved_seg	= reserved_seg;
+		__entry->prefree_seg	= prefree_seg;
+	),
+
+	TP_printk("dev = (%d,%d), ret = %d, seg_freed = %d, sec_freed = %d, "
+		"nodes = %lld, dents = %lld, imeta = %lld, free_sec:%u, "
+		"free_seg:%u, rsv_seg:%d, prefree_seg:%u",
+		show_dev(__entry->dev),
+		__entry->ret,
+		__entry->seg_freed,
+		__entry->sec_freed,
+		__entry->dirty_nodes,
+		__entry->dirty_dents,
+		__entry->dirty_imeta,
+		__entry->free_sec,
+		__entry->free_seg,
+		__entry->reserved_seg,
+		__entry->prefree_seg)
+);
+
 TRACE_EVENT(f2fs_get_victim,
 
 	TP_PROTO(struct super_block *sb, int type, int gc_type,
@@ -557,6 +697,7 @@
 		__field(int,	alloc_mode)
 		__field(int,	gc_mode)
 		__field(unsigned int,	victim)
+		__field(unsigned int,	cost)
 		__field(unsigned int,	ofs_unit)
 		__field(unsigned int,	pre_victim)
 		__field(unsigned int,	prefree)
@@ -570,26 +711,114 @@
 		__entry->alloc_mode	= p->alloc_mode;
 		__entry->gc_mode	= p->gc_mode;
 		__entry->victim		= p->min_segno;
+		__entry->cost		= p->min_cost;
 		__entry->ofs_unit	= p->ofs_unit;
 		__entry->pre_victim	= pre_victim;
 		__entry->prefree	= prefree;
 		__entry->free		= free;
 	),
 
-	TP_printk("dev = (%d,%d), type = %s, policy = (%s, %s, %s), victim = %u "
-		"ofs_unit = %u, pre_victim_secno = %d, prefree = %u, free = %u",
-		show_dev(__entry),
+	TP_printk("dev = (%d,%d), type = %s, policy = (%s, %s, %s), "
+		"victim = %u, cost = %u, ofs_unit = %u, "
+		"pre_victim_secno = %d, prefree = %u, free = %u",
+		show_dev(__entry->dev),
 		show_data_type(__entry->type),
 		show_gc_type(__entry->gc_type),
 		show_alloc_mode(__entry->alloc_mode),
 		show_victim_policy(__entry->gc_mode),
 		__entry->victim,
+		__entry->cost,
 		__entry->ofs_unit,
 		(int)__entry->pre_victim,
 		__entry->prefree,
 		__entry->free)
 );
 
+TRACE_EVENT(f2fs_lookup_start,
+
+	TP_PROTO(struct inode *dir, struct dentry *dentry, unsigned int flags),
+
+	TP_ARGS(dir, dentry, flags),
+
+	TP_STRUCT__entry(
+		__field(dev_t,	dev)
+		__field(ino_t,	ino)
+		__field(const char *,	name)
+		__field(unsigned int, flags)
+	),
+
+	TP_fast_assign(
+		__entry->dev	= dir->i_sb->s_dev;
+		__entry->ino	= dir->i_ino;
+		__entry->name	= dentry->d_name.name;
+		__entry->flags	= flags;
+	),
+
+	TP_printk("dev = (%d,%d), pino = %lu, name:%s, flags:%u",
+		show_dev_ino(__entry),
+		__entry->name,
+		__entry->flags)
+);
+
+TRACE_EVENT(f2fs_lookup_end,
+
+	TP_PROTO(struct inode *dir, struct dentry *dentry, nid_t ino,
+		int err),
+
+	TP_ARGS(dir, dentry, ino, err),
+
+	TP_STRUCT__entry(
+		__field(dev_t,	dev)
+		__field(ino_t,	ino)
+		__field(const char *,	name)
+		__field(nid_t,	cino)
+		__field(int,	err)
+	),
+
+	TP_fast_assign(
+		__entry->dev	= dir->i_sb->s_dev;
+		__entry->ino	= dir->i_ino;
+		__entry->name	= dentry->d_name.name;
+		__entry->cino	= ino;
+		__entry->err	= err;
+	),
+
+	TP_printk("dev = (%d,%d), pino = %lu, name:%s, ino:%u, err:%d",
+		show_dev_ino(__entry),
+		__entry->name,
+		__entry->cino,
+		__entry->err)
+);
+
+TRACE_EVENT(f2fs_readdir,
+
+	TP_PROTO(struct inode *dir, loff_t start_pos, loff_t end_pos, int err),
+
+	TP_ARGS(dir, start_pos, end_pos, err),
+
+	TP_STRUCT__entry(
+		__field(dev_t,	dev)
+		__field(ino_t,	ino)
+		__field(loff_t,	start)
+		__field(loff_t,	end)
+		__field(int,	err)
+	),
+
+	TP_fast_assign(
+		__entry->dev	= dir->i_sb->s_dev;
+		__entry->ino	= dir->i_ino;
+		__entry->start	= start_pos;
+		__entry->end	= end_pos;
+		__entry->err	= err;
+	),
+
+	TP_printk("dev = (%d,%d), ino = %lu, start_pos:%llu, end_pos:%llu, err:%d",
+		show_dev_ino(__entry),
+		__entry->start,
+		__entry->end,
+		__entry->err)
+);
+
 TRACE_EVENT(f2fs_fallocate,
 
 	TP_PROTO(struct inode *inode, int mode,
@@ -715,7 +944,7 @@
 	),
 
 	TP_printk("dev = (%d,%d), nid = %u, ofs_in_node = %u, count = %llu",
-		show_dev(__entry),
+		show_dev(__entry->dev),
 		(unsigned int)__entry->nid,
 		__entry->ofs_in_node,
 		(unsigned long long)__entry->count)
@@ -735,6 +964,7 @@
 		__field(block_t, new_blkaddr)
 		__field(int, op)
 		__field(int, op_flags)
+		__field(int, temp)
 		__field(int, type)
 	),
 
@@ -746,16 +976,18 @@
 		__entry->new_blkaddr	= fio->new_blkaddr;
 		__entry->op		= fio->op;
 		__entry->op_flags	= fio->op_flags;
+		__entry->temp		= fio->temp;
 		__entry->type		= fio->type;
 	),
 
 	TP_printk("dev = (%d,%d), ino = %lu, page_index = 0x%lx, "
-		"oldaddr = 0x%llx, newaddr = 0x%llx, rw = %s%s, type = %s",
+		"oldaddr = 0x%llx, newaddr = 0x%llx, rw = %s(%s), type = %s_%s",
 		show_dev_ino(__entry),
 		(unsigned long)__entry->index,
 		(unsigned long long)__entry->old_blkaddr,
 		(unsigned long long)__entry->new_blkaddr,
-		show_bio_type(__entry->op_flags),
+		show_bio_type(__entry->op, __entry->op_flags),
+		show_block_temp(__entry->temp),
 		show_block_type(__entry->type))
 );
 
@@ -768,7 +1000,7 @@
 	TP_CONDITION(page->mapping)
 );
 
-DEFINE_EVENT_CONDITION(f2fs__submit_page_bio, f2fs_submit_page_mbio,
+DEFINE_EVENT_CONDITION(f2fs__submit_page_bio, f2fs_submit_page_write,
 
 	TP_PROTO(struct page *page, struct f2fs_io_info *fio),
 
@@ -777,15 +1009,15 @@
 	TP_CONDITION(page->mapping)
 );
 
-DECLARE_EVENT_CLASS(f2fs__submit_bio,
+DECLARE_EVENT_CLASS(f2fs__bio,
 
-	TP_PROTO(struct super_block *sb, struct f2fs_io_info *fio,
-						struct bio *bio),
+	TP_PROTO(struct super_block *sb, int type, struct bio *bio),
 
-	TP_ARGS(sb, fio, bio),
+	TP_ARGS(sb, type, bio),
 
 	TP_STRUCT__entry(
 		__field(dev_t,	dev)
+		__field(dev_t,	target)
 		__field(int,	op)
 		__field(int,	op_flags)
 		__field(int,	type)
@@ -795,37 +1027,55 @@
 
 	TP_fast_assign(
 		__entry->dev		= sb->s_dev;
-		__entry->op		= fio->op;
-		__entry->op_flags	= fio->op_flags;
-		__entry->type		= fio->type;
+		__entry->target		= bio->bi_bdev->bd_dev;
+		__entry->op		= bio_op(bio);
+		__entry->op_flags	= bio->bi_opf;
+		__entry->type		= type;
 		__entry->sector		= bio->bi_iter.bi_sector;
 		__entry->size		= bio->bi_iter.bi_size;
 	),
 
-	TP_printk("dev = (%d,%d), rw = %s%s, %s, sector = %lld, size = %u",
-		show_dev(__entry),
-		show_bio_type(__entry->op_flags),
+	TP_printk("dev = (%d,%d)/(%d,%d), rw = %s(%s), %s, sector = %lld, size = %u",
+		show_dev(__entry->target),
+		show_dev(__entry->dev),
+		show_bio_type(__entry->op, __entry->op_flags),
 		show_block_type(__entry->type),
 		(unsigned long long)__entry->sector,
 		__entry->size)
 );
 
-DEFINE_EVENT_CONDITION(f2fs__submit_bio, f2fs_submit_write_bio,
+DEFINE_EVENT_CONDITION(f2fs__bio, f2fs_prepare_write_bio,
+
+	TP_PROTO(struct super_block *sb, int type, struct bio *bio),
+
+	TP_ARGS(sb, type, bio),
+
+	TP_CONDITION(bio)
+);
+
+DEFINE_EVENT_CONDITION(f2fs__bio, f2fs_prepare_read_bio,
 
-	TP_PROTO(struct super_block *sb, struct f2fs_io_info *fio,
-							struct bio *bio),
+	TP_PROTO(struct super_block *sb, int type, struct bio *bio),
 
-	TP_ARGS(sb, fio, bio),
+	TP_ARGS(sb, type, bio),
 
 	TP_CONDITION(bio)
 );
 
-DEFINE_EVENT_CONDITION(f2fs__submit_bio, f2fs_submit_read_bio,
+DEFINE_EVENT_CONDITION(f2fs__bio, f2fs_submit_read_bio,
 
-	TP_PROTO(struct super_block *sb, struct f2fs_io_info *fio,
-							struct bio *bio),
+	TP_PROTO(struct super_block *sb, int type, struct bio *bio),
 
-	TP_ARGS(sb, fio, bio),
+	TP_ARGS(sb, type, bio),
+
+	TP_CONDITION(bio)
+);
+
+DEFINE_EVENT_CONDITION(f2fs__bio, f2fs_submit_write_bio,
+
+	TP_PROTO(struct super_block *sb, int type, struct bio *bio),
+
+	TP_ARGS(sb, type, bio),
 
 	TP_CONDITION(bio)
 );
@@ -1084,16 +1334,16 @@
 	),
 
 	TP_printk("dev = (%d,%d), checkpoint for %s, state = %s",
-		show_dev(__entry),
+		show_dev(__entry->dev),
 		show_cpreason(__entry->reason),
 		__entry->msg)
 );
 
-TRACE_EVENT(f2fs_issue_discard,
+DECLARE_EVENT_CLASS(f2fs_discard,
 
-	TP_PROTO(struct super_block *sb, block_t blkstart, block_t blklen),
+	TP_PROTO(struct block_device *dev, block_t blkstart, block_t blklen),
 
-	TP_ARGS(sb, blkstart, blklen),
+	TP_ARGS(dev, blkstart, blklen),
 
 	TP_STRUCT__entry(
 		__field(dev_t,	dev)
@@ -1102,40 +1352,85 @@
 	),
 
 	TP_fast_assign(
-		__entry->dev	= sb->s_dev;
+		__entry->dev	= dev->bd_dev;
 		__entry->blkstart = blkstart;
 		__entry->blklen = blklen;
 	),
 
 	TP_printk("dev = (%d,%d), blkstart = 0x%llx, blklen = 0x%llx",
-		show_dev(__entry),
+		show_dev(__entry->dev),
 		(unsigned long long)__entry->blkstart,
 		(unsigned long long)__entry->blklen)
 );
 
+DEFINE_EVENT(f2fs_discard, f2fs_queue_discard,
+
+	TP_PROTO(struct block_device *dev, block_t blkstart, block_t blklen),
+
+	TP_ARGS(dev, blkstart, blklen)
+);
+
+DEFINE_EVENT(f2fs_discard, f2fs_issue_discard,
+
+	TP_PROTO(struct block_device *dev, block_t blkstart, block_t blklen),
+
+	TP_ARGS(dev, blkstart, blklen)
+);
+
+DEFINE_EVENT(f2fs_discard, f2fs_remove_discard,
+
+	TP_PROTO(struct block_device *dev, block_t blkstart, block_t blklen),
+
+	TP_ARGS(dev, blkstart, blklen)
+);
+
+TRACE_EVENT(f2fs_issue_reset_zone,
+
+	TP_PROTO(struct block_device *dev, block_t blkstart),
+
+	TP_ARGS(dev, blkstart),
+
+	TP_STRUCT__entry(
+		__field(dev_t,	dev)
+		__field(block_t, blkstart)
+	),
+
+	TP_fast_assign(
+		__entry->dev	= dev->bd_dev;
+		__entry->blkstart = blkstart;
+	),
+
+	TP_printk("dev = (%d,%d), reset zone at block = 0x%llx",
+		show_dev(__entry->dev),
+		(unsigned long long)__entry->blkstart)
+);
+
 TRACE_EVENT(f2fs_issue_flush,
 
-	TP_PROTO(struct super_block *sb, unsigned int nobarrier,
-					unsigned int flush_merge),
+	TP_PROTO(struct block_device *dev, unsigned int nobarrier,
+				unsigned int flush_merge, int ret),
 
-	TP_ARGS(sb, nobarrier, flush_merge),
+	TP_ARGS(dev, nobarrier, flush_merge, ret),
 
 	TP_STRUCT__entry(
 		__field(dev_t,	dev)
 		__field(unsigned int, nobarrier)
 		__field(unsigned int, flush_merge)
+		__field(int,  ret)
 	),
 
 	TP_fast_assign(
-		__entry->dev	= sb->s_dev;
+		__entry->dev	= dev->bd_dev;
 		__entry->nobarrier = nobarrier;
 		__entry->flush_merge = flush_merge;
+		__entry->ret = ret;
 	),
 
-	TP_printk("dev = (%d,%d), %s %s",
-		show_dev(__entry),
+	TP_printk("dev = (%d,%d), %s %s, ret = %d",
+		show_dev(__entry->dev),
 		__entry->nobarrier ? "skip (nobarrier)" : "issue",
-		__entry->flush_merge ? " with flush_merge" : "")
+		__entry->flush_merge ? " with flush_merge" : "",
+		__entry->ret)
 );
 
 TRACE_EVENT(f2fs_lookup_extent_tree_start,
@@ -1248,7 +1543,7 @@
 	),
 
 	TP_printk("dev = (%d,%d), shrunk: node_cnt = %u, tree_cnt = %u",
-		show_dev(__entry),
+		show_dev(__entry->dev),
 		__entry->node_cnt,
 		__entry->tree_cnt)
 );
@@ -1295,7 +1590,7 @@
 	),
 
 	TP_printk("dev = (%d,%d), %s, dirty count = %lld",
-		show_dev(__entry),
+		show_dev(__entry->dev),
 		show_file_type(__entry->type),
 		__entry->count)
 );
diff --git a/include/trace/events/gpu.h b/include/trace/events/gpu.h
new file mode 100644
index 00000000..7e15cdf
--- /dev/null
+++ b/include/trace/events/gpu.h
@@ -0,0 +1,143 @@
+#undef TRACE_SYSTEM
+#define TRACE_SYSTEM gpu
+
+#if !defined(_TRACE_GPU_H) || defined(TRACE_HEADER_MULTI_READ)
+#define _TRACE_GPU_H
+
+#include <linux/tracepoint.h>
+#include <linux/time.h>
+
+#define show_secs_from_ns(ns) \
+	({ \
+		u64 t = ns + (NSEC_PER_USEC / 2); \
+		do_div(t, NSEC_PER_SEC); \
+		t; \
+	})
+
+#define show_usecs_from_ns(ns) \
+	({ \
+		u64 t = ns + (NSEC_PER_USEC / 2) ; \
+		u32 rem; \
+		do_div(t, NSEC_PER_USEC); \
+		rem = do_div(t, USEC_PER_SEC); \
+	})
+
+/*
+ * The gpu_sched_switch event indicates that a switch from one GPU context to
+ * another occurred on one of the GPU hardware blocks.
+ *
+ * The gpu_name argument identifies the GPU hardware block.  Each independently
+ * scheduled GPU hardware block should have a different name.  This may be used
+ * in different ways for different GPUs.  For example, if a GPU includes
+ * multiple processing cores it may use names "GPU 0", "GPU 1", etc.  If a GPU
+ * includes a separately scheduled 2D and 3D hardware block, it might use the
+ * names "2D" and "3D".
+ *
+ * The timestamp argument is the timestamp at which the switch occurred on the
+ * GPU. These timestamps are in units of nanoseconds and must use
+ * approximately the same time as sched_clock, though they need not come from
+ * any CPU clock. The timestamps for a single hardware block must be
+ * monotonically nondecreasing.  This means that if a variable compensation
+ * offset is used to translate from some other clock to the sched_clock, then
+ * care must be taken when increasing that offset, and doing so may result in
+ * multiple events with the same timestamp.
+ *
+ * The next_ctx_id argument identifies the next context that was running on
+ * the GPU hardware block.  A value of 0 indicates that the hardware block
+ * will be idle.
+ *
+ * The next_prio argument indicates the priority of the next context at the
+ * time of the event.  The exact numeric values may mean different things for
+ * different GPUs, but they should follow the rule that lower values indicate a
+ * higher priority.
+ *
+ * The next_job_id argument identifies the batch of work that the GPU will be
+ * working on.  This should correspond to a job_id that was previously traced
+ * as a gpu_job_enqueue event when the batch of work was created.
+ */
+TRACE_EVENT(gpu_sched_switch,
+
+	TP_PROTO(const char *gpu_name, u64 timestamp,
+		u32 next_ctx_id, s32 next_prio, u32 next_job_id),
+
+	TP_ARGS(gpu_name, timestamp, next_ctx_id, next_prio, next_job_id),
+
+	TP_STRUCT__entry(
+		__string(       gpu_name,       gpu_name        )
+		__field(        u64,            timestamp       )
+		__field(        u32,            next_ctx_id     )
+		__field(        s32,            next_prio       )
+		__field(        u32,            next_job_id     )
+	),
+
+	TP_fast_assign(
+		__assign_str(gpu_name, gpu_name);
+		__entry->timestamp = timestamp;
+		__entry->next_ctx_id = next_ctx_id;
+		__entry->next_prio = next_prio;
+		__entry->next_job_id = next_job_id;
+	),
+
+	TP_printk("gpu_name=%s ts=%llu.%06lu next_ctx_id=%lu next_prio=%ld "
+		"next_job_id=%lu",
+		__get_str(gpu_name),
+		(unsigned long long)show_secs_from_ns(__entry->timestamp),
+		(unsigned long)show_usecs_from_ns(__entry->timestamp),
+		(unsigned long)__entry->next_ctx_id,
+		(long)__entry->next_prio,
+		(unsigned long)__entry->next_job_id)
+);
+
+/*
+ * The gpu_job_enqueue event indicates that a batch of work has been queued up
+ * to be processed by the GPU.  This event is not intended to indicate that
+ * the batch of work has been submitted to the GPU hardware, but rather that
+ * it has been submitted to the GPU kernel driver.
+ *
+ * This event should be traced on the thread that initiated the work being
+ * queued.  For example, if a batch of work is submitted to the kernel by a
+ * userland thread, the event should be traced on that thread.
+ *
+ * The ctx_id field identifies the GPU context in which the batch of work
+ * being queued is to be run.
+ *
+ * The job_id field identifies the batch of work being queued within the given
+ * GPU context.  The first batch of work submitted for a given GPU context
+ * should have a job_id of 0, and each subsequent batch of work should
+ * increment the job_id by 1.
+ *
+ * The type field identifies the type of the job being enqueued.  The job
+ * types may be different for different GPU hardware.  For example, a GPU may
+ * differentiate between "2D", "3D", and "compute" jobs.
+ */
+TRACE_EVENT(gpu_job_enqueue,
+
+	TP_PROTO(u32 ctx_id, u32 job_id, const char *type),
+
+	TP_ARGS(ctx_id, job_id, type),
+
+	TP_STRUCT__entry(
+		__field(        u32,            ctx_id          )
+		__field(        u32,            job_id          )
+		__string(       type,           type            )
+	),
+
+	TP_fast_assign(
+		__entry->ctx_id = ctx_id;
+		__entry->job_id = job_id;
+		__assign_str(type, type);
+	),
+
+	TP_printk("ctx_id=%lu job_id=%lu type=%s",
+		(unsigned long)__entry->ctx_id,
+		(unsigned long)__entry->job_id,
+		__get_str(type))
+);
+
+#undef show_secs_from_ns
+#undef show_usecs_from_ns
+
+#endif /* _TRACE_GPU_H */
+
+/* This part must be outside protection */
+#include <trace/define_trace.h>
diff --git a/include/trace/events/net.h b/include/trace/events/net.h
index 49cc7c3..89d009e 100644
--- a/include/trace/events/net.h
+++ b/include/trace/events/net.h
@@ -57,7 +57,7 @@
 		__entry->gso_type = skb_shinfo(skb)->gso_type;
 	),
 
-	TP_printk("dev=%s queue_mapping=%u skbaddr=%p vlan_tagged=%d vlan_proto=0x%04x vlan_tci=0x%04x protocol=0x%04x ip_summed=%d len=%u data_len=%u network_offset=%d transport_offset_valid=%d transport_offset=%d tx_flags=%d gso_size=%d gso_segs=%d gso_type=%#x",
+	TP_printk("dev=%s queue_mapping=%u skbaddr=%pK vlan_tagged=%d vlan_proto=0x%04x vlan_tci=0x%04x protocol=0x%04x ip_summed=%d len=%u data_len=%u network_offset=%d transport_offset_valid=%d transport_offset=%d tx_flags=%d gso_size=%d gso_segs=%d gso_type=%#x",
 		  __get_str(name), __entry->queue_mapping, __entry->skbaddr,
 		  __entry->vlan_tagged, __entry->vlan_proto, __entry->vlan_tci,
 		  __entry->protocol, __entry->ip_summed, __entry->len,
@@ -90,7 +90,7 @@
 		__assign_str(name, dev->name);
 	),
 
-	TP_printk("dev=%s skbaddr=%p len=%u rc=%d",
+	TP_printk("dev=%s skbaddr=%pK len=%u rc=%d",
 		__get_str(name), __entry->skbaddr, __entry->len, __entry->rc)
 );
 
@@ -112,7 +112,7 @@
 		__assign_str(name, skb->dev->name);
 	),
 
-	TP_printk("dev=%s skbaddr=%p len=%u",
+	TP_printk("dev=%s skbaddr=%pK len=%u",
 		__get_str(name), __entry->skbaddr, __entry->len)
 )
 
@@ -191,7 +191,7 @@
 		__entry->gso_type = skb_shinfo(skb)->gso_type;
 	),
 
-	TP_printk("dev=%s napi_id=%#x queue_mapping=%u skbaddr=%p vlan_tagged=%d vlan_proto=0x%04x vlan_tci=0x%04x protocol=0x%04x ip_summed=%d hash=0x%08x l4_hash=%d len=%u data_len=%u truesize=%u mac_header_valid=%d mac_header=%d nr_frags=%d gso_size=%d gso_type=%#x",
+	TP_printk("dev=%s napi_id=%#x queue_mapping=%u skbaddr=%pK vlan_tagged=%d vlan_proto=0x%04x vlan_tci=0x%04x protocol=0x%04x ip_summed=%d hash=0x%08x l4_hash=%d len=%u data_len=%u truesize=%u mac_header_valid=%d mac_header=%d nr_frags=%d gso_size=%d gso_type=%#x",
 		  __get_str(name), __entry->napi_id, __entry->queue_mapping,
 		  __entry->skbaddr, __entry->vlan_tagged, __entry->vlan_proto,
 		  __entry->vlan_tci, __entry->protocol, __entry->ip_summed,
diff --git a/include/trace/events/power.h b/include/trace/events/power.h
index 54e3aad..ec6f815 100644
--- a/include/trace/events/power.h
+++ b/include/trace/events/power.h
@@ -147,6 +147,38 @@
 	TP_ARGS(frequency, cpu_id)
 );
 
+TRACE_EVENT(cpu_frequency_limits,
+
+	TP_PROTO(unsigned int max_freq, unsigned int min_freq,
+		unsigned int cpu_id),
+
+	TP_ARGS(max_freq, min_freq, cpu_id),
+
+	TP_STRUCT__entry(
+		__field(	u32,		min_freq	)
+		__field(	u32,		max_freq	)
+		__field(	u32,		cpu_id		)
+	),
+
+	TP_fast_assign(
+		__entry->min_freq = min_freq;
+		__entry->max_freq = max_freq;
+		__entry->cpu_id = cpu_id;
+	),
+
+	TP_printk("min=%lu max=%lu cpu_id=%lu",
+		  (unsigned long)__entry->min_freq,
+		  (unsigned long)__entry->max_freq,
+		  (unsigned long)__entry->cpu_id)
+);
+
+DEFINE_EVENT(cpu, cpu_capacity,
+
+	TP_PROTO(unsigned int capacity, unsigned int cpu_id),
+
+	TP_ARGS(capacity, cpu_id)
+);
+
 TRACE_EVENT(device_pm_callback_start,
 
 	TP_PROTO(struct device *dev, const char *pm_ops, int event),
@@ -300,6 +332,25 @@
 	TP_ARGS(name, state, cpu_id)
 );
 
+TRACE_EVENT(clock_set_parent,
+
+	TP_PROTO(const char *name, const char *parent_name),
+
+	TP_ARGS(name, parent_name),
+
+	TP_STRUCT__entry(
+		__string(       name,           name            )
+		__string(       parent_name,    parent_name     )
+	),
+
+	TP_fast_assign(
+		__assign_str(name, name);
+		__assign_str(parent_name, parent_name);
+	),
+
+	TP_printk("%s parent=%s", __get_str(name), __get_str(parent_name))
+);
+
 /*
  * The power domain events are used for power domains transitions
  */
diff --git a/include/trace/events/preemptirq.h b/include/trace/events/preemptirq.h
new file mode 100644
index 00000000..9c4eb33
--- /dev/null
+++ b/include/trace/events/preemptirq.h
@@ -0,0 +1,73 @@
+#ifdef CONFIG_PREEMPTIRQ_EVENTS
+
+#undef TRACE_SYSTEM
+#define TRACE_SYSTEM preemptirq
+
+#if !defined(_TRACE_PREEMPTIRQ_H) || defined(TRACE_HEADER_MULTI_READ)
+#define _TRACE_PREEMPTIRQ_H
+
+#include <linux/ktime.h>
+#include <linux/tracepoint.h>
+#include <linux/string.h>
+#include <asm/sections.h>
+
+DECLARE_EVENT_CLASS(preemptirq_template,
+
+	TP_PROTO(unsigned long ip, unsigned long parent_ip),
+
+	TP_ARGS(ip, parent_ip),
+
+	TP_STRUCT__entry(
+		__field(u32, caller_offs)
+		__field(u32, parent_offs)
+	),
+
+	TP_fast_assign(
+		__entry->caller_offs = (u32)(ip - (unsigned long)_stext);
+		__entry->parent_offs = (u32)(parent_ip - (unsigned long)_stext);
+	),
+
+	TP_printk("caller=%pF parent=%pF",
+		  (void *)((unsigned long)(_stext) + __entry->caller_offs),
+		  (void *)((unsigned long)(_stext) + __entry->parent_offs))
+);
+
+#ifndef CONFIG_PROVE_LOCKING
+DEFINE_EVENT(preemptirq_template, irq_disable,
+	     TP_PROTO(unsigned long ip, unsigned long parent_ip),
+	     TP_ARGS(ip, parent_ip));
+
+DEFINE_EVENT(preemptirq_template, irq_enable,
+	     TP_PROTO(unsigned long ip, unsigned long parent_ip),
+	     TP_ARGS(ip, parent_ip));
+#endif
+
+#ifdef CONFIG_DEBUG_PREEMPT
+DEFINE_EVENT(preemptirq_template, preempt_disable,
+	     TP_PROTO(unsigned long ip, unsigned long parent_ip),
+	     TP_ARGS(ip, parent_ip));
+
+DEFINE_EVENT(preemptirq_template, preempt_enable,
+	     TP_PROTO(unsigned long ip, unsigned long parent_ip),
+	     TP_ARGS(ip, parent_ip));
+#endif
+
+#endif /* _TRACE_PREEMPTIRQ_H */
+
+#include <trace/define_trace.h>
+
+#endif /* !CONFIG_PREEMPTIRQ_EVENTS */
+
+#if !defined(CONFIG_PREEMPTIRQ_EVENTS) || defined(CONFIG_PROVE_LOCKING)
+#define trace_irq_enable(...)
+#define trace_irq_disable(...)
+#define trace_irq_enable_rcuidle(...)
+#define trace_irq_disable_rcuidle(...)
+#endif
+
+#if !defined(CONFIG_PREEMPTIRQ_EVENTS) || !defined(CONFIG_DEBUG_PREEMPT)
+#define trace_preempt_enable(...)
+#define trace_preempt_disable(...)
+#define trace_preempt_enable_rcuidle(...)
+#define trace_preempt_disable_rcuidle(...)
+#endif
diff --git a/include/trace/events/sched.h b/include/trace/events/sched.h
index 9b90c57..f578047 100644
--- a/include/trace/events/sched.h
+++ b/include/trace/events/sched.h
@@ -219,7 +219,7 @@ static inline long __trace_sched_switch_state(bool preempt, struct task_struct *
 DEFINE_EVENT(sched_process_template, sched_process_free,
 	     TP_PROTO(struct task_struct *p),
 	     TP_ARGS(p));
-	     
+
 
 /*
  * Tracepoint for a task exiting:
@@ -374,6 +374,30 @@ static inline long __trace_sched_switch_state(bool preempt, struct task_struct *
 	     TP_ARGS(tsk, delay));
 
 /*
+ * Tracepoint for recording the cause of uninterruptible sleep.
+ */
+TRACE_EVENT(sched_blocked_reason,
+
+	TP_PROTO(struct task_struct *tsk),
+
+	TP_ARGS(tsk),
+
+	TP_STRUCT__entry(
+		__field( pid_t,	pid	)
+		__field( void*, caller	)
+		__field( bool, io_wait	)
+	),
+
+	TP_fast_assign(
+		__entry->pid	= tsk->pid;
+		__entry->caller = (void*)get_wchan(tsk);
+		__entry->io_wait = tsk->in_iowait;
+	),
+
+	TP_printk("pid=%d iowait=%d caller=%pS", __entry->pid, __entry->io_wait, __entry->caller)
+);
+
+/*
  * Tracepoint for accounting runtime (time the task is executing
  * on a CPU).
  */
@@ -562,6 +586,520 @@ static inline long __trace_sched_switch_state(bool preempt, struct task_struct *
 
 	TP_printk("cpu=%d", __entry->cpu)
 );
+
+TRACE_EVENT(sched_contrib_scale_f,
+
+	TP_PROTO(int cpu, unsigned long freq_scale_factor,
+		 unsigned long cpu_scale_factor),
+
+	TP_ARGS(cpu, freq_scale_factor, cpu_scale_factor),
+
+	TP_STRUCT__entry(
+		__field(int, cpu)
+		__field(unsigned long, freq_scale_factor)
+		__field(unsigned long, cpu_scale_factor)
+	),
+
+	TP_fast_assign(
+		__entry->cpu = cpu;
+		__entry->freq_scale_factor = freq_scale_factor;
+		__entry->cpu_scale_factor = cpu_scale_factor;
+	),
+
+	TP_printk("cpu=%d freq_scale_factor=%lu cpu_scale_factor=%lu",
+		  __entry->cpu, __entry->freq_scale_factor,
+		  __entry->cpu_scale_factor)
+);
+
+#ifdef CONFIG_SMP
+
+#ifdef CONFIG_SCHED_WALT
+extern unsigned int sysctl_sched_use_walt_cpu_util;
+extern unsigned int sysctl_sched_use_walt_task_util;
+extern unsigned int walt_ravg_window;
+extern bool walt_disabled;
+#endif
+
+/*
+ * Tracepoint for accounting sched averages for tasks.
+ */
+TRACE_EVENT(sched_load_avg_task,
+
+	TP_PROTO(struct task_struct *tsk, struct sched_avg *avg, void *_ravg),
+
+	TP_ARGS(tsk, avg, _ravg),
+
+	TP_STRUCT__entry(
+		__array( char,	comm,	TASK_COMM_LEN		)
+		__field( pid_t,	pid				)
+		__field( int,	cpu				)
+		__field( unsigned long,	load_avg		)
+		__field( unsigned long,	util_avg		)
+		__field( unsigned long,	util_avg_pelt		)
+		__field( u32,		util_avg_walt		)
+		__field( u64,		load_sum		)
+		__field( u32,		util_sum		)
+		__field( u32,		period_contrib		)
+	),
+
+	TP_fast_assign(
+		memcpy(__entry->comm, tsk->comm, TASK_COMM_LEN);
+		__entry->pid			= tsk->pid;
+		__entry->cpu			= task_cpu(tsk);
+		__entry->load_avg		= avg->load_avg;
+		__entry->util_avg		= avg->util_avg;
+		__entry->load_sum		= avg->load_sum;
+		__entry->util_sum		= avg->util_sum;
+		__entry->period_contrib		= avg->period_contrib;
+		__entry->util_avg_pelt  = avg->util_avg;
+		__entry->util_avg_walt  = 0;
+#ifdef CONFIG_SCHED_WALT
+		__entry->util_avg_walt = ((struct ravg*)_ravg)->demand /
+					 (walt_ravg_window >> SCHED_CAPACITY_SHIFT);
+		if (!walt_disabled && sysctl_sched_use_walt_task_util)
+			__entry->util_avg = __entry->util_avg_walt;
+#endif
+	),
+	TP_printk("comm=%s pid=%d cpu=%d load_avg=%lu util_avg=%lu "
+			"util_avg_pelt=%lu util_avg_walt=%u load_sum=%llu"
+		  " util_sum=%u period_contrib=%u",
+		  __entry->comm,
+		  __entry->pid,
+		  __entry->cpu,
+		  __entry->load_avg,
+		  __entry->util_avg,
+		  __entry->util_avg_pelt,
+		  __entry->util_avg_walt,
+		  (u64)__entry->load_sum,
+		  (u32)__entry->util_sum,
+		  (u32)__entry->period_contrib)
+);
+
+/*
+ * Tracepoint for accounting sched averages for cpus.
+ */
+TRACE_EVENT(sched_load_avg_cpu,
+
+	TP_PROTO(int cpu, struct cfs_rq *cfs_rq),
+
+	TP_ARGS(cpu, cfs_rq),
+
+	TP_STRUCT__entry(
+		__field( int,	cpu				)
+		__field( unsigned long,	load_avg		)
+		__field( unsigned long,	util_avg		)
+		__field( unsigned long,	util_avg_pelt		)
+		__field( u32,		util_avg_walt		)
+	),
+
+	TP_fast_assign(
+		__entry->cpu			= cpu;
+		__entry->load_avg		= cfs_rq->avg.load_avg;
+		__entry->util_avg		= cfs_rq->avg.util_avg;
+		__entry->util_avg_pelt	= cfs_rq->avg.util_avg;
+		__entry->util_avg_walt	= 0;
+#ifdef CONFIG_SCHED_WALT
+		__entry->util_avg_walt = div64_ul(cpu_rq(cpu)->prev_runnable_sum,
+					 walt_ravg_window >> SCHED_CAPACITY_SHIFT);
+		if (!walt_disabled && sysctl_sched_use_walt_cpu_util)
+			__entry->util_avg		= __entry->util_avg_walt;
+#endif
+	),
+
+	TP_printk("cpu=%d load_avg=%lu util_avg=%lu "
+			  "util_avg_pelt=%lu util_avg_walt=%u",
+		  __entry->cpu, __entry->load_avg, __entry->util_avg,
+		  __entry->util_avg_pelt, __entry->util_avg_walt)
+);
+
+/*
+ * Tracepoint for sched_tune_config settings
+ */
+TRACE_EVENT(sched_tune_config,
+
+	TP_PROTO(int boost),
+
+	TP_ARGS(boost),
+
+	TP_STRUCT__entry(
+		__field( int,	boost		)
+	),
+
+	TP_fast_assign(
+		__entry->boost 	= boost;
+	),
+
+	TP_printk("boost=%d ", __entry->boost)
+);
+
+/*
+ * Tracepoint for accounting CPU  boosted utilization
+ */
+TRACE_EVENT(sched_boost_cpu,
+
+	TP_PROTO(int cpu, unsigned long util, long margin),
+
+	TP_ARGS(cpu, util, margin),
+
+	TP_STRUCT__entry(
+		__field( int,		cpu			)
+		__field( unsigned long,	util			)
+		__field(long,		margin			)
+	),
+
+	TP_fast_assign(
+		__entry->cpu	= cpu;
+		__entry->util	= util;
+		__entry->margin	= margin;
+	),
+
+	TP_printk("cpu=%d util=%lu margin=%ld",
+		  __entry->cpu,
+		  __entry->util,
+		  __entry->margin)
+);
+
+/*
+ * Tracepoint for schedtune_tasks_update
+ */
+TRACE_EVENT(sched_tune_tasks_update,
+
+	TP_PROTO(struct task_struct *tsk, int cpu, int tasks, int idx,
+		int boost, int max_boost),
+
+	TP_ARGS(tsk, cpu, tasks, idx, boost, max_boost),
+
+	TP_STRUCT__entry(
+		__array( char,	comm,	TASK_COMM_LEN	)
+		__field( pid_t,		pid		)
+		__field( int,		cpu		)
+		__field( int,		tasks		)
+		__field( int,		idx		)
+		__field( int,		boost		)
+		__field( int,		max_boost	)
+	),
+
+	TP_fast_assign(
+		memcpy(__entry->comm, tsk->comm, TASK_COMM_LEN);
+		__entry->pid		= tsk->pid;
+		__entry->cpu 		= cpu;
+		__entry->tasks		= tasks;
+		__entry->idx 		= idx;
+		__entry->boost		= boost;
+		__entry->max_boost	= max_boost;
+	),
+
+	TP_printk("pid=%d comm=%s "
+			"cpu=%d tasks=%d idx=%d boost=%d max_boost=%d",
+		__entry->pid, __entry->comm,
+		__entry->cpu, __entry->tasks, __entry->idx,
+		__entry->boost, __entry->max_boost)
+);
+
+/*
+ * Tracepoint for schedtune_boostgroup_update
+ */
+TRACE_EVENT(sched_tune_boostgroup_update,
+
+	TP_PROTO(int cpu, int variation, int max_boost),
+
+	TP_ARGS(cpu, variation, max_boost),
+
+	TP_STRUCT__entry(
+		__field( int,	cpu		)
+		__field( int,	variation	)
+		__field( int,	max_boost	)
+	),
+
+	TP_fast_assign(
+		__entry->cpu		= cpu;
+		__entry->variation	= variation;
+		__entry->max_boost	= max_boost;
+	),
+
+	TP_printk("cpu=%d variation=%d max_boost=%d",
+		__entry->cpu, __entry->variation, __entry->max_boost)
+);
+
+/*
+ * Tracepoint for accounting task boosted utilization
+ */
+TRACE_EVENT(sched_boost_task,
+
+	TP_PROTO(struct task_struct *tsk, unsigned long util, long margin),
+
+	TP_ARGS(tsk, util, margin),
+
+	TP_STRUCT__entry(
+		__array( char,	comm,	TASK_COMM_LEN		)
+		__field( pid_t,		pid			)
+		__field( unsigned long,	util			)
+		__field( long,		margin			)
+
+	),
+
+	TP_fast_assign(
+		memcpy(__entry->comm, tsk->comm, TASK_COMM_LEN);
+		__entry->pid	= tsk->pid;
+		__entry->util	= util;
+		__entry->margin	= margin;
+	),
+
+	TP_printk("comm=%s pid=%d util=%lu margin=%ld",
+		  __entry->comm, __entry->pid,
+		  __entry->util,
+		  __entry->margin)
+);
+
+/*
+ * Tracepoint for find_best_target
+ */
+TRACE_EVENT(sched_find_best_target,
+
+	TP_PROTO(struct task_struct *tsk, bool prefer_idle,
+		unsigned long min_util, int start_cpu,
+		int best_idle, int best_active, int target),
+
+	TP_ARGS(tsk, prefer_idle, min_util, start_cpu,
+		best_idle, best_active, target),
+
+	TP_STRUCT__entry(
+		__array( char,	comm,	TASK_COMM_LEN	)
+		__field( pid_t,	pid			)
+		__field( unsigned long,	min_util	)
+		__field( bool,	prefer_idle		)
+		__field( int,	start_cpu		)
+		__field( int,	best_idle		)
+		__field( int,	best_active		)
+		__field( int,	target			)
+	),
+
+	TP_fast_assign(
+		memcpy(__entry->comm, tsk->comm, TASK_COMM_LEN);
+		__entry->pid		= tsk->pid;
+		__entry->min_util	= min_util;
+		__entry->prefer_idle	= prefer_idle;
+		__entry->start_cpu 	= start_cpu;
+		__entry->best_idle	= best_idle;
+		__entry->best_active	= best_active;
+		__entry->target		= target;
+	),
+
+	TP_printk("pid=%d comm=%s prefer_idle=%d start_cpu=%d "
+		  "best_idle=%d best_active=%d target=%d",
+		__entry->pid, __entry->comm,
+		__entry->prefer_idle, __entry->start_cpu,
+		__entry->best_idle, __entry->best_active,
+		__entry->target)
+);
+
+/*
+ * Tracepoint for schedtune_tasks_update
+ */
+TRACE_EVENT(sched_tune_filter,
+
+	TP_PROTO(int nrg_delta, int cap_delta,
+		 int nrg_gain,  int cap_gain,
+		 int payoff, int region),
+
+	TP_ARGS(nrg_delta, cap_delta, nrg_gain, cap_gain, payoff, region),
+
+	TP_STRUCT__entry(
+		__field( int,	nrg_delta	)
+		__field( int,	cap_delta	)
+		__field( int,	nrg_gain	)
+		__field( int,	cap_gain	)
+		__field( int,	payoff		)
+		__field( int,	region		)
+	),
+
+	TP_fast_assign(
+		__entry->nrg_delta	= nrg_delta;
+		__entry->cap_delta	= cap_delta;
+		__entry->nrg_gain	= nrg_gain;
+		__entry->cap_gain	= cap_gain;
+		__entry->payoff		= payoff;
+		__entry->region		= region;
+	),
+
+	TP_printk("nrg_delta=%d cap_delta=%d nrg_gain=%d cap_gain=%d payoff=%d region=%d",
+		__entry->nrg_delta, __entry->cap_delta,
+		__entry->nrg_gain, __entry->cap_gain,
+		__entry->payoff, __entry->region)
+);
+
+/*
+ * Tracepoint for system overutilized flag
+ */
+TRACE_EVENT(sched_overutilized,
+
+	TP_PROTO(bool overutilized),
+
+	TP_ARGS(overutilized),
+
+	TP_STRUCT__entry(
+		__field( bool,	overutilized	)
+	),
+
+	TP_fast_assign(
+		__entry->overutilized	= overutilized;
+	),
+
+	TP_printk("overutilized=%d",
+		__entry->overutilized ? 1 : 0)
+);
+#ifdef CONFIG_SCHED_WALT
+struct rq;
+
+TRACE_EVENT(walt_update_task_ravg,
+
+	TP_PROTO(struct task_struct *p, struct rq *rq, int evt,
+						u64 wallclock, u64 irqtime),
+
+	TP_ARGS(p, rq, evt, wallclock, irqtime),
+
+	TP_STRUCT__entry(
+		__array(	char,	comm,   TASK_COMM_LEN	)
+		__field(	pid_t,	pid			)
+		__field(	pid_t,	cur_pid			)
+		__field(	u64,	wallclock		)
+		__field(	u64,	mark_start		)
+		__field(	u64,	delta_m			)
+		__field(	u64,	win_start		)
+		__field(	u64,	delta			)
+		__field(	u64,	irqtime			)
+		__field(        int,    evt			)
+		__field(unsigned int,	demand			)
+		__field(unsigned int,	sum			)
+		__field(	 int,	cpu			)
+		__field(	u64,	cs			)
+		__field(	u64,	ps			)
+		__field(unsigned long,	util			)
+		__field(	u32,	curr_window		)
+		__field(	u32,	prev_window		)
+		__field(	u64,	nt_cs			)
+		__field(	u64,	nt_ps			)
+		__field(	u32,	active_windows		)
+	),
+
+	TP_fast_assign(
+		__entry->wallclock      = wallclock;
+		__entry->win_start      = rq->window_start;
+		__entry->delta          = (wallclock - rq->window_start);
+		__entry->evt            = evt;
+		__entry->cpu            = rq->cpu;
+		__entry->cur_pid        = rq->curr->pid;
+		memcpy(__entry->comm, p->comm, TASK_COMM_LEN);
+		__entry->pid            = p->pid;
+		__entry->mark_start     = p->ravg.mark_start;
+		__entry->delta_m        = (wallclock - p->ravg.mark_start);
+		__entry->demand         = p->ravg.demand;
+		__entry->sum            = p->ravg.sum;
+		__entry->irqtime        = irqtime;
+		__entry->cs             = rq->curr_runnable_sum;
+		__entry->ps             = rq->prev_runnable_sum;
+		__entry->util           = rq->prev_runnable_sum << SCHED_CAPACITY_SHIFT;
+		do_div(__entry->util, walt_ravg_window);
+		__entry->curr_window	= p->ravg.curr_window;
+		__entry->prev_window	= p->ravg.prev_window;
+		__entry->nt_cs		= rq->nt_curr_runnable_sum;
+		__entry->nt_ps		= rq->nt_prev_runnable_sum;
+		__entry->active_windows	= p->ravg.active_windows;
+	),
+
+	TP_printk("wc %llu ws %llu delta %llu event %d cpu %d cur_pid %d task %d (%s) ms %llu delta %llu demand %u sum %u irqtime %llu"
+		" cs %llu ps %llu util %lu cur_window %u prev_window %u active_wins %u"
+		, __entry->wallclock, __entry->win_start, __entry->delta,
+		__entry->evt, __entry->cpu, __entry->cur_pid,
+		__entry->pid, __entry->comm, __entry->mark_start,
+		__entry->delta_m, __entry->demand,
+		__entry->sum, __entry->irqtime,
+		__entry->cs, __entry->ps, __entry->util,
+		__entry->curr_window, __entry->prev_window,
+		  __entry->active_windows
+		)
+);
+
+TRACE_EVENT(walt_update_history,
+
+	TP_PROTO(struct rq *rq, struct task_struct *p, u32 runtime, int samples,
+			int evt),
+
+	TP_ARGS(rq, p, runtime, samples, evt),
+
+	TP_STRUCT__entry(
+		__array(	char,	comm,   TASK_COMM_LEN	)
+		__field(	pid_t,	pid			)
+		__field(unsigned int,	runtime			)
+		__field(	 int,	samples			)
+		__field(	 int,	evt			)
+		__field(	 u64,	demand			)
+		__field(	 u64,	walt_avg		)
+		__field(unsigned int,	pelt_avg		)
+		__array(	 u32,	hist, RAVG_HIST_SIZE_MAX)
+		__field(	 int,	cpu			)
+	),
+
+	TP_fast_assign(
+		memcpy(__entry->comm, p->comm, TASK_COMM_LEN);
+		__entry->pid            = p->pid;
+		__entry->runtime        = runtime;
+		__entry->samples        = samples;
+		__entry->evt            = evt;
+		__entry->demand         = p->ravg.demand;
+		__entry->walt_avg	= (__entry->demand << SCHED_CAPACITY_SHIFT);
+		__entry->walt_avg	= div_u64(__entry->walt_avg,
+						  walt_ravg_window);
+		__entry->pelt_avg	= p->se.avg.util_avg;
+		memcpy(__entry->hist, p->ravg.sum_history,
+					RAVG_HIST_SIZE_MAX * sizeof(u32));
+		__entry->cpu            = rq->cpu;
+	),
+
+	TP_printk("%d (%s): runtime %u samples %d event %d demand %llu"
+		" walt %llu pelt %u (hist: %u %u %u %u %u) cpu %d",
+		__entry->pid, __entry->comm,
+		__entry->runtime, __entry->samples, __entry->evt,
+		__entry->demand,
+		__entry->walt_avg,
+		__entry->pelt_avg,
+		__entry->hist[0], __entry->hist[1],
+		__entry->hist[2], __entry->hist[3],
+		__entry->hist[4], __entry->cpu)
+);
+
+TRACE_EVENT(walt_migration_update_sum,
+
+	TP_PROTO(struct rq *rq, struct task_struct *p),
+
+	TP_ARGS(rq, p),
+
+	TP_STRUCT__entry(
+		__field(int,		cpu			)
+		__field(int,		pid			)
+		__field(	u64,	cs			)
+		__field(	u64,	ps			)
+		__field(	s64,	nt_cs			)
+		__field(	s64,	nt_ps			)
+	),
+
+	TP_fast_assign(
+		__entry->cpu		= cpu_of(rq);
+		__entry->cs		= rq->curr_runnable_sum;
+		__entry->ps		= rq->prev_runnable_sum;
+		__entry->nt_cs		= (s64)rq->nt_curr_runnable_sum;
+		__entry->nt_ps		= (s64)rq->nt_prev_runnable_sum;
+		__entry->pid		= p->pid;
+	),
+
+	TP_printk("cpu %d: cs %llu ps %llu nt_cs %lld nt_ps %lld pid %d",
+		  __entry->cpu, __entry->cs, __entry->ps,
+		  __entry->nt_cs, __entry->nt_ps, __entry->pid)
+);
+#endif /* CONFIG_SCHED_WALT */
+
+#endif /* CONFIG_SMP */
+
 #endif /* _TRACE_SCHED_H */
 
 /* This part must be outside protection */
diff --git a/include/uapi/asm-generic/socket.h b/include/uapi/asm-generic/socket.h
index 67d632f..2d078c20 100644
--- a/include/uapi/asm-generic/socket.h
+++ b/include/uapi/asm-generic/socket.h
@@ -92,4 +92,6 @@
 
 #define SO_CNX_ADVICE		53
 
+#define SO_COOKIE		57
+
 #endif /* __ASM_GENERIC_SOCKET_H */
diff --git a/include/uapi/linux/android/binder.h b/include/uapi/linux/android/binder.h
index 41420e3..5539933 100644
--- a/include/uapi/linux/android/binder.h
+++ b/include/uapi/linux/android/binder.h
@@ -33,11 +33,60 @@ enum {
 	BINDER_TYPE_HANDLE	= B_PACK_CHARS('s', 'h', '*', B_TYPE_LARGE),
 	BINDER_TYPE_WEAK_HANDLE	= B_PACK_CHARS('w', 'h', '*', B_TYPE_LARGE),
 	BINDER_TYPE_FD		= B_PACK_CHARS('f', 'd', '*', B_TYPE_LARGE),
+	BINDER_TYPE_FDA		= B_PACK_CHARS('f', 'd', 'a', B_TYPE_LARGE),
+	BINDER_TYPE_PTR		= B_PACK_CHARS('p', 't', '*', B_TYPE_LARGE),
 };
 
-enum {
+/**
+ * enum flat_binder_object_shifts: shift values for flat_binder_object_flags
+ * @FLAT_BINDER_FLAG_SCHED_POLICY_SHIFT: shift for getting scheduler policy.
+ *
+ */
+enum flat_binder_object_shifts {
+	FLAT_BINDER_FLAG_SCHED_POLICY_SHIFT = 9,
+};
+
+/**
+ * enum flat_binder_object_flags - flags for use in flat_binder_object.flags
+ */
+enum flat_binder_object_flags {
+	/**
+	 * @FLAT_BINDER_FLAG_PRIORITY_MASK: bit-mask for min scheduler priority
+	 *
+	 * These bits can be used to set the minimum scheduler priority
+	 * at which transactions into this node should run. Valid values
+	 * in these bits depend on the scheduler policy encoded in
+	 * @FLAT_BINDER_FLAG_SCHED_POLICY_MASK.
+	 *
+	 * For SCHED_NORMAL/SCHED_BATCH, the valid range is between [-20..19]
+	 * For SCHED_FIFO/SCHED_RR, the value can run between [1..99]
+	 */
 	FLAT_BINDER_FLAG_PRIORITY_MASK = 0xff,
+	/**
+	 * @FLAT_BINDER_FLAG_ACCEPTS_FDS: whether the node accepts fds.
+	 */
 	FLAT_BINDER_FLAG_ACCEPTS_FDS = 0x100,
+	/**
+	 * @FLAT_BINDER_FLAG_SCHED_POLICY_MASK: bit-mask for scheduling policy
+	 *
+	 * These two bits can be used to set the min scheduling policy at which
+	 * transactions on this node should run. These match the UAPI
+	 * scheduler policy values, eg:
+	 * 00b: SCHED_NORMAL
+	 * 01b: SCHED_FIFO
+	 * 10b: SCHED_RR
+	 * 11b: SCHED_BATCH
+	 */
+	FLAT_BINDER_FLAG_SCHED_POLICY_MASK =
+		3U << FLAT_BINDER_FLAG_SCHED_POLICY_SHIFT,
+
+	/**
+	 * @FLAT_BINDER_FLAG_INHERIT_RT: whether the node inherits RT policy
+	 *
+	 * Only when set, calls into this node will inherit a real-time
+	 * scheduling policy from the caller (for synchronous transactions).
+	 */
+	FLAT_BINDER_FLAG_INHERIT_RT = 0x800,
 };
 
 #ifdef BINDER_IPC_32BIT
@@ -48,6 +97,14 @@ enum {
 typedef __u64 binder_uintptr_t;
 #endif
 
+/**
+ * struct binder_object_header - header shared by all binder metadata objects.
+ * @type:	type of the object
+ */
+struct binder_object_header {
+	__u32        type;
+};
+
 /*
  * This is the flattened representation of a Binder object for transfer
  * between processes.  The 'offsets' supplied as part of a binder transaction
@@ -56,9 +113,8 @@ enum {
  * between processes.
  */
 struct flat_binder_object {
-	/* 8 bytes for large_flat_header. */
-	__u32		type;
-	__u32		flags;
+	struct binder_object_header	hdr;
+	__u32				flags;
 
 	/* 8 bytes of data. */
 	union {
@@ -70,6 +126,86 @@ struct flat_binder_object {
 	binder_uintptr_t	cookie;
 };
 
+/**
+ * struct binder_fd_object - describes a filedescriptor to be fixed up.
+ * @hdr:	common header structure
+ * @pad_flags:	padding to remain compatible with old userspace code
+ * @pad_binder:	padding to remain compatible with old userspace code
+ * @fd:		file descriptor
+ * @cookie:	opaque data, used by user-space
+ */
+struct binder_fd_object {
+	struct binder_object_header	hdr;
+	__u32				pad_flags;
+	union {
+		binder_uintptr_t	pad_binder;
+		__u32			fd;
+	};
+
+	binder_uintptr_t		cookie;
+};
+
+/* struct binder_buffer_object - object describing a userspace buffer
+ * @hdr:		common header structure
+ * @flags:		one or more BINDER_BUFFER_* flags
+ * @buffer:		address of the buffer
+ * @length:		length of the buffer
+ * @parent:		index in offset array pointing to parent buffer
+ * @parent_offset:	offset in @parent pointing to this buffer
+ *
+ * A binder_buffer object represents an object that the
+ * binder kernel driver can copy verbatim to the target
+ * address space. A buffer itself may be pointed to from
+ * within another buffer, meaning that the pointer inside
+ * that other buffer needs to be fixed up as well. This
+ * can be done by setting the BINDER_BUFFER_FLAG_HAS_PARENT
+ * flag in @flags, by setting @parent buffer to the index
+ * in the offset array pointing to the parent binder_buffer_object,
+ * and by setting @parent_offset to the offset in the parent buffer
+ * at which the pointer to this buffer is located.
+ */
+struct binder_buffer_object {
+	struct binder_object_header	hdr;
+	__u32				flags;
+	binder_uintptr_t		buffer;
+	binder_size_t			length;
+	binder_size_t			parent;
+	binder_size_t			parent_offset;
+};
+
+enum {
+	BINDER_BUFFER_FLAG_HAS_PARENT = 0x01,
+};
+
+/* struct binder_fd_array_object - object describing an array of fds in a buffer
+ * @hdr:		common header structure
+ * @pad:		padding to ensure correct alignment
+ * @num_fds:		number of file descriptors in the buffer
+ * @parent:		index in offset array to buffer holding the fd array
+ * @parent_offset:	start offset of fd array in the buffer
+ *
+ * A binder_fd_array object represents an array of file
+ * descriptors embedded in a binder_buffer_object. It is
+ * different from a regular binder_buffer_object because it
+ * describes a list of file descriptors to fix up, not an opaque
+ * blob of memory, and hence the kernel needs to treat it differently.
+ *
+ * An example of how this would be used is with Android's
+ * native_handle_t object, which is a struct with a list of integers
+ * and a list of file descriptors. The native_handle_t struct itself
+ * will be represented by a struct binder_buffer_objct, whereas the
+ * embedded list of file descriptors is represented by a
+ * struct binder_fd_array_object with that binder_buffer_object as
+ * a parent.
+ */
+struct binder_fd_array_object {
+	struct binder_object_header	hdr;
+	__u32				pad;
+	binder_size_t			num_fds;
+	binder_size_t			parent;
+	binder_size_t			parent_offset;
+};
+
 /*
  * On 64-bit platforms where user code may run in 32-bits the driver must
  * translate the buffer (and local binder) addresses appropriately.
@@ -97,6 +233,19 @@ struct binder_version {
 #define BINDER_CURRENT_PROTOCOL_VERSION 8
 #endif
 
+/*
+ * Use with BINDER_GET_NODE_DEBUG_INFO, driver reads ptr, writes to all fields.
+ * Set ptr to NULL for the first call to get the info for the first node, and
+ * then repeat the call passing the previously returned value to get the next
+ * nodes.  ptr will be 0 when there are no more nodes.
+ */
+struct binder_node_debug_info {
+	binder_uintptr_t ptr;
+	binder_uintptr_t cookie;
+	__u32            has_strong_ref;
+	__u32            has_weak_ref;
+};
+
 #define BINDER_WRITE_READ		_IOWR('b', 1, struct binder_write_read)
 #define BINDER_SET_IDLE_TIMEOUT		_IOW('b', 3, __s64)
 #define BINDER_SET_MAX_THREADS		_IOW('b', 5, __u32)
@@ -104,6 +253,7 @@ struct binder_version {
 #define BINDER_SET_CONTEXT_MGR		_IOW('b', 7, __s32)
 #define BINDER_THREAD_EXIT		_IOW('b', 8, __s32)
 #define BINDER_VERSION			_IOWR('b', 9, struct binder_version)
+#define BINDER_GET_NODE_DEBUG_INFO	_IOWR('b', 11, struct binder_node_debug_info)
 
 /*
  * NOTE: Two special error codes you should check for when calling
@@ -162,6 +312,11 @@ struct binder_transaction_data {
 	} data;
 };
 
+struct binder_transaction_data_sg {
+	struct binder_transaction_data transaction_data;
+	binder_size_t buffers_size;
+};
+
 struct binder_ptr_cookie {
 	binder_uintptr_t ptr;
 	binder_uintptr_t cookie;
@@ -346,6 +501,12 @@ enum binder_driver_command_protocol {
 	/*
 	 * void *: cookie
 	 */
+
+	BC_TRANSACTION_SG = _IOW('c', 17, struct binder_transaction_data_sg),
+	BC_REPLY_SG = _IOW('c', 18, struct binder_transaction_data_sg),
+	/*
+	 * binder_transaction_data_sg: the sent command.
+	 */
 };
 
 #endif /* _UAPI_LINUX_BINDER_H */
diff --git a/include/uapi/linux/bpf.h b/include/uapi/linux/bpf.h
index f09c70b..a339bea 100644
--- a/include/uapi/linux/bpf.h
+++ b/include/uapi/linux/bpf.h
@@ -73,6 +73,8 @@ enum bpf_cmd {
 	BPF_PROG_LOAD,
 	BPF_OBJ_PIN,
 	BPF_OBJ_GET,
+	BPF_PROG_ATTACH,
+	BPF_PROG_DETACH,
 };
 
 enum bpf_map_type {
@@ -96,8 +98,23 @@ enum bpf_prog_type {
 	BPF_PROG_TYPE_TRACEPOINT,
 	BPF_PROG_TYPE_XDP,
 	BPF_PROG_TYPE_PERF_EVENT,
+	BPF_PROG_TYPE_CGROUP_SKB,
 };
 
+enum bpf_attach_type {
+	BPF_CGROUP_INET_INGRESS,
+	BPF_CGROUP_INET_EGRESS,
+	__MAX_BPF_ATTACH_TYPE
+};
+
+#define MAX_BPF_ATTACH_TYPE __MAX_BPF_ATTACH_TYPE
+
+/* If BPF_F_ALLOW_OVERRIDE flag is used in BPF_PROG_ATTACH command
+ * to the given target_fd cgroup the descendent cgroup will be able to
+ * override effective bpf program that was inherited from this cgroup
+ */
+#define BPF_F_ALLOW_OVERRIDE	(1U << 0)
+
 #define BPF_PSEUDO_MAP_FD	1
 
 /* flags for BPF_MAP_UPDATE_ELEM command */
@@ -107,6 +124,10 @@ enum bpf_prog_type {
 
 #define BPF_F_NO_PREALLOC	(1U << 0)
 
+/* Flags for accessing BPF object */
+#define BPF_F_RDONLY		(1U << 3)
+#define BPF_F_WRONLY		(1U << 4)
+
 union bpf_attr {
 	struct { /* anonymous struct used by BPF_MAP_CREATE command */
 		__u32	map_type;	/* one of enum bpf_map_type */
@@ -140,6 +161,14 @@ enum bpf_prog_type {
 	struct { /* anonymous struct used by BPF_OBJ_* commands */
 		__aligned_u64	pathname;
 		__u32		bpf_fd;
+		__u32		file_flags;
+	};
+
+	struct { /* anonymous struct used by BPF_PROG_ATTACH/DETACH commands */
+		__u32		target_fd;	/* container object to attach to */
+		__u32		attach_bpf_fd;	/* eBPF program to attach */
+		__u32		attach_type;
+		__u32		attach_flags;
 	};
 } __attribute__((aligned(8)));
 
@@ -426,6 +455,67 @@ enum bpf_func_id {
 	 */
 	BPF_FUNC_set_hash_invalid,
 
+	/**
+	 * int bpf_get_numa_node_id()
+	 *     Return: Id of current NUMA node.
+	 */
+	BPF_FUNC_get_numa_node_id,
+
+	/**
+	 * int bpf_skb_change_head()
+	 *     Grows headroom of skb and adjusts MAC header offset accordingly.
+	 *     Will extends/reallocae as required automatically.
+	 *     May change skb data pointer and will thus invalidate any check
+	 *     performed for direct packet access.
+	 *     @skb: pointer to skb
+	 *     @len: length of header to be pushed in front
+	 *     @flags: Flags (unused for now)
+	 *     Return: 0 on success or negative error
+	 */
+	BPF_FUNC_skb_change_head,
+
+	/**
+	 * int bpf_xdp_adjust_head(xdp_md, delta)
+	 *     Adjust the xdp_md.data by delta
+	 *     @xdp_md: pointer to xdp_md
+	 *     @delta: An positive/negative integer to be added to xdp_md.data
+	 *     Return: 0 on success or negative on error
+	 */
+	BPF_FUNC_xdp_adjust_head,
+
+	/**
+	 * int bpf_probe_read_str(void *dst, int size, const void *unsafe_ptr)
+	 *     Copy a NUL terminated string from unsafe address. In case the string
+	 *     length is smaller than size, the target is not padded with further NUL
+	 *     bytes. In case the string length is larger than size, just count-1
+	 *     bytes are copied and the last byte is set to NUL.
+	 *     @dst: destination address
+	 *     @size: maximum number of bytes to copy, including the trailing NUL
+	 *     @unsafe_ptr: unsafe address
+	 *     Return:
+	 *       > 0 length of the string including the trailing NUL on success
+	 *       < 0 error
+	 */
+	BPF_FUNC_probe_read_str,
+
+	/**
+	 * u64 bpf_bpf_get_socket_cookie(skb)
+	 *     Get the cookie for the socket stored inside sk_buff.
+	 *     @skb: pointer to skb
+	 *     Return: 8 Bytes non-decreasing number on success or 0 if the socket
+	 *     field is missing inside sk_buff
+	 */
+	BPF_FUNC_get_socket_cookie,
+
+	/**
+	 * u32 bpf_get_socket_uid(skb)
+	 *     Get the owner uid of the socket stored inside sk_buff.
+	 *     @skb: pointer to skb
+	 *     Return: uid of the socket owner on success or 0 if the socket pointer
+	 *     inside sk_buff is NULL
+	 */
+	BPF_FUNC_get_socket_uid,
+
 	__BPF_FUNC_MAX_ID,
 };
 
diff --git a/include/uapi/linux/dm-ioctl.h b/include/uapi/linux/dm-ioctl.h
index 4bf9f1e..28e1a39 100644
--- a/include/uapi/linux/dm-ioctl.h
+++ b/include/uapi/linux/dm-ioctl.h
@@ -240,7 +240,10 @@ enum {
 	/* Added later */
 	DM_LIST_VERSIONS_CMD,
 	DM_TARGET_MSG_CMD,
-	DM_DEV_SET_GEOMETRY_CMD
+	DM_DEV_SET_GEOMETRY_CMD,
+
+	/* Verify signature */
+	DM_VERIFY_SIGNATURE_CMD
 };
 
 #define DM_IOCTL 0xfd
@@ -266,6 +269,8 @@ enum {
 #define DM_TARGET_MSG	 _IOWR(DM_IOCTL, DM_TARGET_MSG_CMD, struct dm_ioctl)
 #define DM_DEV_SET_GEOMETRY	_IOWR(DM_IOCTL, DM_DEV_SET_GEOMETRY_CMD, struct dm_ioctl)
 
+#define DM_VERIFY_SIGNATURE     _IOWR(DM_IOCTL, DM_VERIFY_SIGNATURE_CMD, struct dm_ioctl)
+
 #define DM_VERSION_MAJOR	4
 #define DM_VERSION_MINOR	35
 #define DM_VERSION_PATCHLEVEL	0
diff --git a/include/uapi/linux/fcntl.h b/include/uapi/linux/fcntl.h
index beed138..f85ed3a 100644
--- a/include/uapi/linux/fcntl.h
+++ b/include/uapi/linux/fcntl.h
@@ -43,6 +43,27 @@
 /* (1U << 31) is reserved for signed error codes */
 
 /*
+ * Set/Get write life time hints. {GET,SET}_RW_HINT operate on the
+ * underlying inode, while {GET,SET}_FILE_RW_HINT operate only on
+ * the specific file.
+ */
+#define F_GET_RW_HINT		(F_LINUX_SPECIFIC_BASE + 11)
+#define F_SET_RW_HINT		(F_LINUX_SPECIFIC_BASE + 12)
+#define F_GET_FILE_RW_HINT	(F_LINUX_SPECIFIC_BASE + 13)
+#define F_SET_FILE_RW_HINT	(F_LINUX_SPECIFIC_BASE + 14)
+
+/*
+ * Valid hint values for F_{GET,SET}_RW_HINT. 0 is "not set", or can be
+ * used to clear any hints previously set.
+ */
+#define RWF_WRITE_LIFE_NOT_SET	0
+#define RWH_WRITE_LIFE_NONE	1
+#define RWH_WRITE_LIFE_SHORT	2
+#define RWH_WRITE_LIFE_MEDIUM	3
+#define RWH_WRITE_LIFE_LONG	4
+#define RWH_WRITE_LIFE_EXTREME	5
+
+/*
  * Types of directory notifications that may be requested.
  */
 #define DN_ACCESS	0x00000001	/* File accessed */
diff --git a/include/uapi/linux/fib_rules.h b/include/uapi/linux/fib_rules.h
index 14404b3..bbf02a6 100644
--- a/include/uapi/linux/fib_rules.h
+++ b/include/uapi/linux/fib_rules.h
@@ -29,6 +29,11 @@ struct fib_rule_hdr {
 	__u32		flags;
 };
 
+struct fib_rule_uid_range {
+	__u32		start;
+	__u32		end;
+};
+
 enum {
 	FRA_UNSPEC,
 	FRA_DST,	/* destination address */
@@ -51,6 +56,7 @@ enum {
 	FRA_OIFNAME,
 	FRA_PAD,
 	FRA_L3MDEV,	/* iif or oif is l3mdev goto its table */
+	FRA_UID_RANGE,	/* UID range */
 	__FRA_MAX
 };
 
diff --git a/include/uapi/linux/fs.h b/include/uapi/linux/fs.h
index 4749955..5ebe952 100644
--- a/include/uapi/linux/fs.h
+++ b/include/uapi/linux/fs.h
@@ -237,6 +237,8 @@ struct fsxattr {
 #define FICLONERANGE	_IOW(0x94, 13, struct file_clone_range)
 #define FIDEDUPERANGE	_IOWR(0x94, 54, struct file_dedupe_range)
 
+#define FIDTRIM	_IOWR('f', 128, struct fstrim_range)	/* Deep discard trim */
+
 #define	FS_IOC_GETFLAGS			_IOR('f', 1, long)
 #define	FS_IOC_SETFLAGS			_IOW('f', 2, long)
 #define	FS_IOC_GETVERSION		_IOR('v', 1, long)
@@ -255,18 +257,49 @@ struct fsxattr {
 /* Policy provided via an ioctl on the topmost directory */
 #define FS_KEY_DESCRIPTOR_SIZE	8
 
+#define FS_POLICY_FLAGS_PAD_4		0x00
+#define FS_POLICY_FLAGS_PAD_8		0x01
+#define FS_POLICY_FLAGS_PAD_16		0x02
+#define FS_POLICY_FLAGS_PAD_32		0x03
+#define FS_POLICY_FLAGS_PAD_MASK	0x03
+#define FS_POLICY_FLAGS_VALID		0x03
+
+/* Encryption algorithms */
+#define FS_ENCRYPTION_MODE_INVALID		0
+#define FS_ENCRYPTION_MODE_AES_256_XTS		1
+#define FS_ENCRYPTION_MODE_AES_256_GCM		2
+#define FS_ENCRYPTION_MODE_AES_256_CBC		3
+#define FS_ENCRYPTION_MODE_AES_256_CTS		4
+#define FS_ENCRYPTION_MODE_AES_128_CBC		5
+#define FS_ENCRYPTION_MODE_AES_128_CTS		6
+#define FS_ENCRYPTION_MODE_SPECK128_256_XTS	7
+#define FS_ENCRYPTION_MODE_SPECK128_256_CTS	8
+
 struct fscrypt_policy {
 	__u8 version;
 	__u8 contents_encryption_mode;
 	__u8 filenames_encryption_mode;
 	__u8 flags;
 	__u8 master_key_descriptor[FS_KEY_DESCRIPTOR_SIZE];
-} __packed;
+};
 
 #define FS_IOC_SET_ENCRYPTION_POLICY	_IOR('f', 19, struct fscrypt_policy)
 #define FS_IOC_GET_ENCRYPTION_PWSALT	_IOW('f', 20, __u8[16])
 #define FS_IOC_GET_ENCRYPTION_POLICY	_IOW('f', 21, struct fscrypt_policy)
 
+/* Parameters for passing an encryption key into the kernel keyring */
+#define FS_KEY_DESC_PREFIX		"fscrypt:"
+#define FS_KEY_DESC_PREFIX_SIZE		8
+
+/* Structure that userspace passes to the kernel keyring */
+#define FS_MAX_KEY_SIZE			64
+
+struct fscrypt_key {
+	__u32 mode;
+	__u8 raw[FS_MAX_KEY_SIZE];
+	__u32 size;
+};
+
 /*
  * Inode flags (FS_IOC_GETFLAGS / FS_IOC_SETFLAGS)
  *
diff --git a/include/uapi/linux/fuse.h b/include/uapi/linux/fuse.h
index 42fa977..0932378 100644
--- a/include/uapi/linux/fuse.h
+++ b/include/uapi/linux/fuse.h
@@ -375,6 +375,7 @@ enum fuse_opcode {
 	FUSE_READDIRPLUS   = 44,
 	FUSE_RENAME2       = 45,
 	FUSE_LSEEK         = 46,
+	FUSE_CANONICAL_PATH= 2016,
 
 	/* CUSE specific operations */
 	CUSE_INIT          = 4096,
diff --git a/include/uapi/linux/hw_breakpoint.h b/include/uapi/linux/hw_breakpoint.h
index b04000a..2b65efd 100644
--- a/include/uapi/linux/hw_breakpoint.h
+++ b/include/uapi/linux/hw_breakpoint.h
@@ -4,7 +4,11 @@
 enum {
 	HW_BREAKPOINT_LEN_1 = 1,
 	HW_BREAKPOINT_LEN_2 = 2,
+	HW_BREAKPOINT_LEN_3 = 3,
 	HW_BREAKPOINT_LEN_4 = 4,
+	HW_BREAKPOINT_LEN_5 = 5,
+	HW_BREAKPOINT_LEN_6 = 6,
+	HW_BREAKPOINT_LEN_7 = 7,
 	HW_BREAKPOINT_LEN_8 = 8,
 };
 
diff --git a/include/uapi/linux/i2c.h b/include/uapi/linux/i2c.h
index 009e27b..6c08d6b 100644
--- a/include/uapi/linux/i2c.h
+++ b/include/uapi/linux/i2c.h
@@ -68,6 +68,11 @@
 struct i2c_msg {
 	__u16 addr;	/* slave address			*/
 	__u16 flags;
+#define I2C_M_TEN		0x0010	/* this is a ten bit chip address */
+#ifdef CONFIG_I2C_RTK
+#define I2C_M_NO_GUARD_TIME   	0x0020  /* 20121120 - Kevin Wang add for disable guard time*/
+#define I2C_GPIO_RW				0x0080  /* 20100510 - Kevin Wang add for Venus I2C */
+#endif
 #define I2C_M_RD		0x0001	/* read data, from slave to master */
 					/* I2C_M_RD is guaranteed to be 0x0001! */
 #define I2C_M_TEN		0x0010	/* this is a ten bit chip address */
@@ -77,6 +82,17 @@ struct i2c_msg {
 #define I2C_M_REV_DIR_ADDR	0x2000	/* if I2C_FUNC_PROTOCOL_MANGLING */
 #define I2C_M_NOSTART		0x4000	/* if I2C_FUNC_NOSTART */
 #define I2C_M_STOP		0x8000	/* if I2C_FUNC_PROTOCOL_MANGLING */
+#ifdef CONFIG_I2C_RTK
+#define I2C_M_NORMAL_SPEED  	0x0000  /* 20120716 - Kevin Wang add for Standard Speed Transmission : 100Kbps */
+#define I2C_M_FAST_SPEED    	0x0002  /* 20120716 - Kevin Wang add for Fast Speed Transmission : 400Kbps */
+#define I2C_M_HIGH_SPEED    	0x0004  /* 20120716 - Kevin Wang add for High Speed Transmission : > 400Kbps to max 3.4 Mbps */
+#define I2C_M_LOW_SPEED       	0x0006  /* 20120716 - Kevin Wang add for Low  Speed Transmission : 50Kbps */
+#define I2C_M_LOW_SPEED_80     	0x0008  /* 20140910 - Victor hsu add for Low  Speed Transmission : 80Kbps */
+#define I2C_M_LOW_SPEED_66     	0x000a  /* 20120716 - Kevin Wang add for Low  Speed Transmission : 66Kbps */
+#define I2C_M_LOW_SPEED_33     	0x000c  /* 20140910 - Victor hsu add for Low  Speed Transmission : 33Kbps */
+#define I2C_M_LOW_SPEED_10     	0x000e  /* 20140910 - Victor hsu add for Low  Speed Transmission : 10Kbps */
+#define I2C_M_SPEED_MASK      	0x000e  /* 20120716 - Kevin Wang add for speed control*/
+#endif
 	__u16 len;		/* msg length				*/
 	__u8 *buf;		/* pointer to msg data			*/
 };
diff --git a/include/uapi/linux/if_pppolac.h b/include/uapi/linux/if_pppolac.h
new file mode 100644
index 00000000..b7eb8153
--- /dev/null
+++ b/include/uapi/linux/if_pppolac.h
@@ -0,0 +1,33 @@
+/* include/uapi/linux/if_pppolac.h
+ *
+ * Header for PPP on L2TP Access Concentrator / PPPoLAC Socket (RFC 2661)
+ *
+ * Copyright (C) 2009 Google, Inc.
+ * Author: Chia-chi Yeh <chiachi@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef _UAPI_LINUX_IF_PPPOLAC_H
+#define _UAPI_LINUX_IF_PPPOLAC_H
+
+#include <linux/socket.h>
+#include <linux/types.h>
+
+struct sockaddr_pppolac {
+	sa_family_t	sa_family;	/* AF_PPPOX */
+	unsigned int	sa_protocol;	/* PX_PROTO_OLAC */
+	int		udp_socket;
+	struct __attribute__((packed)) {
+		__u16	tunnel, session;
+	} local, remote;
+} __attribute__((packed));
+
+#endif /* _UAPI_LINUX_IF_PPPOLAC_H */
diff --git a/include/uapi/linux/if_pppopns.h b/include/uapi/linux/if_pppopns.h
new file mode 100644
index 00000000..a392b52
--- /dev/null
+++ b/include/uapi/linux/if_pppopns.h
@@ -0,0 +1,32 @@
+/* include/uapi/linux/if_pppopns.h
+ *
+ * Header for PPP on PPTP Network Server / PPPoPNS Socket (RFC 2637)
+ *
+ * Copyright (C) 2009 Google, Inc.
+ * Author: Chia-chi Yeh <chiachi@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef _UAPI_LINUX_IF_PPPOPNS_H
+#define _UAPI_LINUX_IF_PPPOPNS_H
+
+#include <linux/socket.h>
+#include <linux/types.h>
+
+struct sockaddr_pppopns {
+	sa_family_t	sa_family;	/* AF_PPPOX */
+	unsigned int	sa_protocol;	/* PX_PROTO_OPNS */
+	int		tcp_socket;
+	__u16		local;
+	__u16		remote;
+} __attribute__((packed));
+
+#endif /* _UAPI_LINUX_IF_PPPOPNS_H */
diff --git a/include/uapi/linux/if_pppox.h b/include/uapi/linux/if_pppox.h
index d37bbb1..6aad18a 100644
--- a/include/uapi/linux/if_pppox.h
+++ b/include/uapi/linux/if_pppox.h
@@ -24,6 +24,8 @@
 #include <linux/if.h>
 #include <linux/if_ether.h>
 #include <linux/if_pppol2tp.h>
+#include <linux/if_pppolac.h>
+#include <linux/if_pppopns.h>
 #include <linux/in.h>
 #include <linux/in6.h>
 
@@ -59,7 +61,9 @@ struct pptp_addr {
 #define PX_PROTO_OE    0 /* Currently just PPPoE */
 #define PX_PROTO_OL2TP 1 /* Now L2TP also */
 #define PX_PROTO_PPTP  2
-#define PX_MAX_PROTO   3
+#define PX_PROTO_OLAC  3
+#define PX_PROTO_OPNS  4
+#define PX_MAX_PROTO   5
 
 struct sockaddr_pppox {
 	__kernel_sa_family_t sa_family;       /* address family, AF_PPPOX */
diff --git a/include/uapi/linux/ipv6.h b/include/uapi/linux/ipv6.h
index 8c27723..c462f1d 100644
--- a/include/uapi/linux/ipv6.h
+++ b/include/uapi/linux/ipv6.h
@@ -164,6 +164,7 @@ enum {
 	DEVCONF_ACCEPT_DAD,
 	DEVCONF_FORCE_TLLAO,
 	DEVCONF_NDISC_NOTIFY,
+	DEVCONF_ACCEPT_RA_RT_TABLE,
 	DEVCONF_MLDV1_UNSOLICITED_REPORT_INTERVAL,
 	DEVCONF_MLDV2_UNSOLICITED_REPORT_INTERVAL,
 	DEVCONF_SUPPRESS_FRAG_NDISC,
@@ -178,6 +179,12 @@ enum {
 	DEVCONF_DROP_UNSOLICITED_NA,
 	DEVCONF_KEEP_ADDR_ON_DOWN,
 	DEVCONF_RTR_SOLICIT_MAX_INTERVAL,
+	DEVCONF_SEG6_ENABLED,
+	DEVCONF_SEG6_REQUIRE_HMAC,
+	DEVCONF_ENHANCED_DAD,
+	DEVCONF_ADDR_GEN_MODE,
+	DEVCONF_DISABLE_POLICY,
+	DEVCONF_ACCEPT_RA_RT_INFO_MIN_PLEN,
 	DEVCONF_MAX
 };
 
diff --git a/include/uapi/linux/kcov.h b/include/uapi/linux/kcov.h
index 574e22e..33b826b 100644
--- a/include/uapi/linux/kcov.h
+++ b/include/uapi/linux/kcov.h
@@ -7,4 +7,28 @@
 #define KCOV_ENABLE			_IO('c', 100)
 #define KCOV_DISABLE			_IO('c', 101)
 
+enum {
+	/*
+	 * Tracing coverage collection mode.
+	 * Covered PCs are collected in a per-task buffer.
+	 * In new KCOV version the mode is chosen by calling
+	 * ioctl(fd, KCOV_ENABLE, mode). In older versions the mode argument
+	 * was supposed to be 0 in such a call. So, for reasons of backward
+	 * compatibility, we have chosen the value KCOV_TRACE_PC to be 0.
+	 */
+	KCOV_TRACE_PC = 0,
+	/* Collecting comparison operands mode. */
+	KCOV_TRACE_CMP = 1,
+};
+
+/*
+ * The format for the types of collected comparisons.
+ *
+ * Bit 0 shows whether one of the arguments is a compile-time constant.
+ * Bits 1 & 2 contain log2 of the argument size, up to 8 bytes.
+ */
+#define KCOV_CMP_CONST          (1 << 0)
+#define KCOV_CMP_SIZE(n)        ((n) << 1)
+#define KCOV_CMP_MASK           KCOV_CMP_SIZE(3)
+
 #endif /* _LINUX_KCOV_IOCTLS_H */
diff --git a/include/uapi/linux/keychord.h b/include/uapi/linux/keychord.h
new file mode 100644
index 00000000..ea7cf4d
--- /dev/null
+++ b/include/uapi/linux/keychord.h
@@ -0,0 +1,52 @@
+/*
+ *  Key chord input driver
+ *
+ * Copyright (C) 2008 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+*/
+
+#ifndef _UAPI_LINUX_KEYCHORD_H_
+#define _UAPI_LINUX_KEYCHORD_H_
+
+#include <linux/input.h>
+
+#define KEYCHORD_VERSION		1
+
+/*
+ * One or more input_keychord structs are written to /dev/keychord
+ * at once to specify the list of keychords to monitor.
+ * Reading /dev/keychord returns the id of a keychord when the
+ * keychord combination is pressed.  A keychord is signalled when
+ * all of the keys in the keycode list are in the pressed state.
+ * The order in which the keys are pressed does not matter.
+ * The keychord will not be signalled if keys not in the keycode
+ * list are pressed.
+ * Keychords will not be signalled on key release events.
+ */
+struct input_keychord {
+	/* should be KEYCHORD_VERSION */
+	__u16 version;
+	/*
+	 * client specified ID, returned from read()
+	 * when this keychord is pressed.
+	 */
+	__u16 id;
+
+	/* number of keycodes in this keychord */
+	__u16 count;
+
+	/* variable length array of keycodes */
+	__u16 keycodes[];
+};
+
+#endif	/* _UAPI_LINUX_KEYCHORD_H_ */
diff --git a/include/uapi/linux/magic.h b/include/uapi/linux/magic.h
index 9bd5594..bd01769 100644
--- a/include/uapi/linux/magic.h
+++ b/include/uapi/linux/magic.h
@@ -53,6 +53,8 @@
 #define REISER2FS_SUPER_MAGIC_STRING	"ReIsEr2Fs"
 #define REISER2FS_JR_SUPER_MAGIC_STRING	"ReIsEr3Fs"
 
+#define SDCARDFS_SUPER_MAGIC	0x5dca2df5
+
 #define SMB_SUPER_MAGIC		0x517B
 #define CGROUP_SUPER_MAGIC	0x27e0eb
 #define CGROUP2_SUPER_MAGIC	0x63677270
diff --git a/include/uapi/linux/major.h b/include/uapi/linux/major.h
index 620252e..b126115 100644
--- a/include/uapi/linux/major.h
+++ b/include/uapi/linux/major.h
@@ -147,6 +147,8 @@
 #define UNIX98_PTY_MAJOR_COUNT	8
 #define UNIX98_PTY_SLAVE_MAJOR	(UNIX98_PTY_MASTER_MAJOR+UNIX98_PTY_MAJOR_COUNT)
 
+#define TSIO_MAJOR		137
+
 #define DRBD_MAJOR		147
 #define RTF_MAJOR		150
 #define RAW_MAJOR		162
diff --git a/include/uapi/linux/netfilter/xt_IDLETIMER.h b/include/uapi/linux/netfilter/xt_IDLETIMER.h
index 208ae93..faaa28b 100644
--- a/include/uapi/linux/netfilter/xt_IDLETIMER.h
+++ b/include/uapi/linux/netfilter/xt_IDLETIMER.h
@@ -4,6 +4,7 @@
  * Header file for Xtables timer target module.
  *
  * Copyright (C) 2004, 2010 Nokia Corporation
+ *
  * Written by Timo Teras <ext-timo.teras@nokia.com>
  *
  * Converted to x_tables and forward-ported to 2.6.34
@@ -32,12 +33,19 @@
 #include <linux/types.h>
 
 #define MAX_IDLETIMER_LABEL_SIZE 28
+#define NLMSG_MAX_SIZE 64
+
+#define NL_EVENT_TYPE_INACTIVE 0
+#define NL_EVENT_TYPE_ACTIVE 1
 
 struct idletimer_tg_info {
 	__u32 timeout;
 
 	char label[MAX_IDLETIMER_LABEL_SIZE];
 
+	/* Use netlink messages for notification in addition to sysfs */
+	__u8 send_nl_msg;
+
 	/* for kernel module internal use only */
 	struct idletimer_tg *timer __attribute__((aligned(8)));
 };
diff --git a/include/uapi/linux/netfilter/xt_bpf.h b/include/uapi/linux/netfilter/xt_bpf.h
index 1fad2c2..da161b5 100644
--- a/include/uapi/linux/netfilter/xt_bpf.h
+++ b/include/uapi/linux/netfilter/xt_bpf.h
@@ -2,9 +2,11 @@
 #define _XT_BPF_H
 
 #include <linux/filter.h>
+#include <linux/limits.h>
 #include <linux/types.h>
 
 #define XT_BPF_MAX_NUM_INSTR	64
+#define XT_BPF_PATH_MAX		(XT_BPF_MAX_NUM_INSTR * sizeof(struct sock_filter))
 
 struct bpf_prog;
 
@@ -16,4 +18,24 @@ struct xt_bpf_info {
 	struct bpf_prog *filter __attribute__((aligned(8)));
 };
 
+enum xt_bpf_modes {
+	XT_BPF_MODE_BYTECODE,
+	XT_BPF_MODE_FD_PINNED,
+	XT_BPF_MODE_FD_ELF,
+};
+#define XT_BPF_MODE_PATH_PINNED XT_BPF_MODE_FD_PINNED
+
+struct xt_bpf_info_v1 {
+	__u16 mode;
+	__u16 bpf_program_num_elem;
+	__s32 fd;
+	union {
+		struct sock_filter bpf_program[XT_BPF_MAX_NUM_INSTR];
+		char path[XT_BPF_PATH_MAX];
+	};
+
+	/* only used in the kernel */
+	struct bpf_prog *filter __attribute__((aligned(8)));
+};
+
 #endif /*_XT_BPF_H */
diff --git a/include/uapi/linux/netfilter/xt_socket.h b/include/uapi/linux/netfilter/xt_socket.h
index 87644f8..7f00df6 100644
--- a/include/uapi/linux/netfilter/xt_socket.h
+++ b/include/uapi/linux/netfilter/xt_socket.h
@@ -26,4 +26,11 @@ struct xt_socket_mtinfo3 {
 			   | XT_SOCKET_NOWILDCARD \
 			   | XT_SOCKET_RESTORESKMARK)
 
+struct sock *xt_socket_lookup_slow_v4(struct net *net,
+				      const struct sk_buff *skb,
+				      const struct net_device *indev);
+struct sock *xt_socket_lookup_slow_v6(struct net *net,
+				      const struct sk_buff *skb,
+				      const struct net_device *indev);
+
 #endif /* _XT_SOCKET_H */
diff --git a/include/uapi/linux/netlink.h b/include/uapi/linux/netlink.h
index 0dba4e4..6f67e85 100644
--- a/include/uapi/linux/netlink.h
+++ b/include/uapi/linux/netlink.h
@@ -30,6 +30,14 @@
 
 #define NETLINK_INET_DIAG	NETLINK_SOCK_DIAG
 
+#if defined(CONFIG_RTL_819X)
+#define NETLINK_RTK_FILTER		22
+#define NETLINK_MULTICAST_DELETE	23
+#define NETLINK_RTK_FB			24
+#define NETLINK_RTK_HW_QOS		25
+#define NETLINK_RTK_DEBUG		26
+#endif
+
 #define MAX_LINKS 32		
 
 struct sockaddr_nl {
diff --git a/include/uapi/linux/prctl.h b/include/uapi/linux/prctl.h
index 64776b7..8b8a5e9 100644
--- a/include/uapi/linux/prctl.h
+++ b/include/uapi/linux/prctl.h
@@ -209,4 +209,7 @@ struct prctl_mm_map {
 # define PR_SPEC_DISABLE		(1UL << 2)
 # define PR_SPEC_FORCE_DISABLE		(1UL << 3)
 
+#define PR_SET_VMA		0x53564d41
+# define PR_SET_VMA_ANON_NAME		0
+
 #endif /* _LINUX_PRCTL_H */
diff --git a/include/uapi/linux/rtnetlink.h b/include/uapi/linux/rtnetlink.h
index 5a78be5..e14377f 100644
--- a/include/uapi/linux/rtnetlink.h
+++ b/include/uapi/linux/rtnetlink.h
@@ -318,6 +318,7 @@ enum rtattr_type_t {
 	RTA_ENCAP,
 	RTA_EXPIRES,
 	RTA_PAD,
+	RTA_UID,
 	__RTA_MAX
 };
 
diff --git a/include/uapi/linux/sysctl.h b/include/uapi/linux/sysctl.h
index d2b1215..e13d480 100644
--- a/include/uapi/linux/sysctl.h
+++ b/include/uapi/linux/sysctl.h
@@ -568,6 +568,7 @@ enum {
 	NET_IPV6_PROXY_NDP=23,
 	NET_IPV6_ACCEPT_SOURCE_ROUTE=25,
 	NET_IPV6_ACCEPT_RA_FROM_LOCAL=26,
+	NET_IPV6_ACCEPT_RA_RT_INFO_MIN_PLEN=27,
 	__NET_IPV6_MAX
 };
 
diff --git a/include/uapi/linux/tcp.h b/include/uapi/linux/tcp.h
index 73ac0db..84a3eb2 100644
--- a/include/uapi/linux/tcp.h
+++ b/include/uapi/linux/tcp.h
@@ -116,6 +116,7 @@ enum {
 #define TCP_SAVE_SYN		27	/* Record SYN headers for new connections */
 #define TCP_SAVED_SYN		28	/* Get SYN headers recorded for connection */
 #define TCP_REPAIR_WINDOW	29	/* Get/set window parameters */
+#define TCP_FASTOPEN_CONNECT	30	/* Attempt FastOpen with connect */
 
 struct tcp_repair_opt {
 	__u32	opt_code;
diff --git a/include/uapi/linux/tee.h b/include/uapi/linux/tee.h
new file mode 100644
index 00000000..08fb98f5f
--- /dev/null
+++ b/include/uapi/linux/tee.h
@@ -0,0 +1,413 @@
+/*
+ * Copyright (c) 2015-2016, Linaro Limited
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright notice,
+ * this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef __TEE_H
+#define __TEE_H
+
+#include <linux/ioctl.h>
+#include <linux/types.h>
+
+/*
+ * This file describes the API provided by a TEE driver to user space.
+ *
+ * Each TEE driver defines a TEE specific protocol which is used for the
+ * data passed back and forth using TEE_IOC_CMD.
+ */
+
+/* Helpers to make the ioctl defines */
+#define TEE_IOC_MAGIC	0xa4
+#define TEE_IOC_BASE	0
+
+/* Flags relating to shared memory */
+#define TEE_IOCTL_SHM_MAPPED	0x1	/* memory mapped in normal world */
+#define TEE_IOCTL_SHM_DMA_BUF	0x2	/* dma-buf handle on shared memory */
+
+#define TEE_MAX_ARG_SIZE	1024
+
+#define TEE_GEN_CAP_GP		(1 << 0)/* GlobalPlatform compliant TEE */
+#define TEE_GEN_CAP_PRIVILEGED	(1 << 1)/* Privileged device (for supplicant) */
+#define TEE_GEN_CAP_REG_MEM	(1 << 2)/* Supports registering shared memory */
+
+/*
+ * TEE Implementation ID
+ */
+#define TEE_IMPL_ID_OPTEE	1
+
+/*
+ * OP-TEE specific capabilities
+ */
+#define TEE_OPTEE_CAP_TZ	(1 << 0)
+
+/**
+ * struct tee_ioctl_version_data - TEE version
+ * @impl_id:	[out] TEE implementation id
+ * @impl_caps:	[out] Implementation specific capabilities
+ * @gen_caps:	[out] Generic capabilities, defined by TEE_GEN_CAPS_* above
+ *
+ * Identifies the TEE implementation, @impl_id is one of TEE_IMPL_ID_* above.
+ * @impl_caps is implementation specific, for example TEE_OPTEE_CAP_*
+ * is valid when @impl_id == TEE_IMPL_ID_OPTEE.
+ */
+struct tee_ioctl_version_data {
+	__u32 impl_id;
+	__u32 impl_caps;
+	__u32 gen_caps;
+};
+
+/**
+ * TEE_IOC_VERSION - query version of TEE
+ *
+ * Takes a tee_ioctl_version_data struct and returns with the TEE version
+ * data filled in.
+ */
+#define TEE_IOC_VERSION		_IOR(TEE_IOC_MAGIC, TEE_IOC_BASE + 0, \
+				     struct tee_ioctl_version_data)
+
+/**
+ * struct tee_ioctl_shm_alloc_data - Shared memory allocate argument
+ * @size:	[in/out] Size of shared memory to allocate
+ * @flags:	[in/out] Flags to/from allocation.
+ * @id:		[out] Identifier of the shared memory
+ *
+ * The flags field should currently be zero as input. Updated by the call
+ * with actual flags as defined by TEE_IOCTL_SHM_* above.
+ * This structure is used as argument for TEE_IOC_SHM_ALLOC below.
+ */
+struct tee_ioctl_shm_alloc_data {
+	__u64 size;
+	__u32 flags;
+	__s32 id;
+};
+
+/**
+ * TEE_IOC_SHM_ALLOC - allocate shared memory
+ *
+ * Allocates shared memory between the user space process and secure OS.
+ *
+ * Returns a file descriptor on success or < 0 on failure
+ *
+ * The returned file descriptor is used to map the shared memory into user
+ * space. The shared memory is freed when the descriptor is closed and the
+ * memory is unmapped.
+ */
+#define TEE_IOC_SHM_ALLOC	_IOWR(TEE_IOC_MAGIC, TEE_IOC_BASE + 1, \
+				     struct tee_ioctl_shm_alloc_data)
+
+/**
+ * struct tee_ioctl_shm_register_fd_data - Shared memory registering argument
+ * @fd:		[in] file descriptor identifying the shared memory
+ * @size:	[out] Size of shared memory to allocate
+ * @flags:	[in] Flags to/from allocation.
+ * @id:		[out] Identifier of the shared memory
+ *
+ * The flags field should currently be zero as input. Updated by the call
+ * with actual flags as defined by TEE_IOCTL_SHM_* above.
+ * This structure is used as argument for TEE_IOC_SHM_ALLOC below.
+ */
+struct tee_ioctl_shm_register_fd_data {
+	__s64 fd;
+	__u64 size;
+	__u32 flags;
+	__s32 id;
+} __aligned(8);
+
+/**
+ * TEE_IOC_SHM_REGISTER_FD - register a shared memory from a file descriptor
+ *
+ * Returns a file descriptor on success or < 0 on failure
+ *
+ * The returned file descriptor refers to the shared memory object in kernel
+ * land. The shared memory is freed when the descriptor is closed.
+ */
+#define TEE_IOC_SHM_REGISTER_FD	_IOWR(TEE_IOC_MAGIC, TEE_IOC_BASE + 8, \
+				     struct tee_ioctl_shm_register_fd_data)
+
+/**
+ * struct tee_ioctl_buf_data - Variable sized buffer
+ * @buf_ptr:	[in] A __user pointer to a buffer
+ * @buf_len:	[in] Length of the buffer above
+ *
+ * Used as argument for TEE_IOC_OPEN_SESSION, TEE_IOC_INVOKE,
+ * TEE_IOC_SUPPL_RECV, and TEE_IOC_SUPPL_SEND below.
+ */
+struct tee_ioctl_buf_data {
+	__u64 buf_ptr;
+	__u64 buf_len;
+};
+
+/*
+ * Attributes for struct tee_ioctl_param, selects field in the union
+ */
+#define TEE_IOCTL_PARAM_ATTR_TYPE_NONE		0	/* parameter not used */
+
+/*
+ * These defines value parameters (struct tee_ioctl_param_value)
+ */
+#define TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INPUT	1
+#define TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_OUTPUT	2
+#define TEE_IOCTL_PARAM_ATTR_TYPE_VALUE_INOUT	3	/* input and output */
+
+/*
+ * These defines shared memory reference parameters (struct
+ * tee_ioctl_param_memref)
+ */
+#define TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INPUT	5
+#define TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_OUTPUT	6
+#define TEE_IOCTL_PARAM_ATTR_TYPE_MEMREF_INOUT	7	/* input and output */
+
+/*
+ * Mask for the type part of the attribute, leaves room for more types
+ */
+#define TEE_IOCTL_PARAM_ATTR_TYPE_MASK		0xff
+
+/* Meta parameter carrying extra information about the message. */
+#define TEE_IOCTL_PARAM_ATTR_META		0x100
+
+/* Mask of all known attr bits */
+#define TEE_IOCTL_PARAM_ATTR_MASK \
+	(TEE_IOCTL_PARAM_ATTR_TYPE_MASK | TEE_IOCTL_PARAM_ATTR_META)
+
+/*
+ * Matches TEEC_LOGIN_* in GP TEE Client API
+ * Are only defined for GP compliant TEEs
+ */
+#define TEE_IOCTL_LOGIN_PUBLIC			0
+#define TEE_IOCTL_LOGIN_USER			1
+#define TEE_IOCTL_LOGIN_GROUP			2
+#define TEE_IOCTL_LOGIN_APPLICATION		4
+#define TEE_IOCTL_LOGIN_USER_APPLICATION	5
+#define TEE_IOCTL_LOGIN_GROUP_APPLICATION	6
+
+/**
+ * struct tee_ioctl_param - parameter
+ * @attr: attributes
+ * @a: if a memref, offset into the shared memory object, else a value parameter
+ * @b: if a memref, size of the buffer, else a value parameter
+ * @c: if a memref, shared memory identifier, else a value parameter
+ *
+ * @attr & TEE_PARAM_ATTR_TYPE_MASK indicates if memref or value is used in
+ * the union. TEE_PARAM_ATTR_TYPE_VALUE_* indicates value and
+ * TEE_PARAM_ATTR_TYPE_MEMREF_* indicates memref. TEE_PARAM_ATTR_TYPE_NONE
+ * indicates that none of the members are used.
+ *
+ * Shared memory is allocated with TEE_IOC_SHM_ALLOC which returns an
+ * identifier representing the shared memory object. A memref can reference
+ * a part of a shared memory by specifying an offset (@a) and size (@b) of
+ * the object. To supply the entire shared memory object set the offset
+ * (@a) to 0 and size (@b) to the previously returned size of the object.
+ */
+struct tee_ioctl_param {
+	__u64 attr;
+	__u64 a;
+	__u64 b;
+	__u64 c;
+};
+
+#define TEE_IOCTL_UUID_LEN		16
+
+/**
+ * struct tee_ioctl_open_session_arg - Open session argument
+ * @uuid:	[in] UUID of the Trusted Application
+ * @clnt_uuid:	[in] UUID of client
+ * @clnt_login:	[in] Login class of client, TEE_IOCTL_LOGIN_* above
+ * @cancel_id:	[in] Cancellation id, a unique value to identify this request
+ * @session:	[out] Session id
+ * @ret:	[out] return value
+ * @ret_origin	[out] origin of the return value
+ * @num_params	[in] number of parameters following this struct
+ */
+struct tee_ioctl_open_session_arg {
+	__u8 uuid[TEE_IOCTL_UUID_LEN];
+	__u8 clnt_uuid[TEE_IOCTL_UUID_LEN];
+	__u32 clnt_login;
+	__u32 cancel_id;
+	__u32 session;
+	__u32 ret;
+	__u32 ret_origin;
+	__u32 num_params;
+	/* num_params tells the actual number of element in params */
+	struct tee_ioctl_param params[];
+};
+
+/**
+ * TEE_IOC_OPEN_SESSION - opens a session to a Trusted Application
+ *
+ * Takes a struct tee_ioctl_buf_data which contains a struct
+ * tee_ioctl_open_session_arg followed by any array of struct
+ * tee_ioctl_param
+ */
+#define TEE_IOC_OPEN_SESSION	_IOR(TEE_IOC_MAGIC, TEE_IOC_BASE + 2, \
+				     struct tee_ioctl_buf_data)
+
+/**
+ * struct tee_ioctl_invoke_func_arg - Invokes a function in a Trusted
+ * Application
+ * @func:	[in] Trusted Application function, specific to the TA
+ * @session:	[in] Session id
+ * @cancel_id:	[in] Cancellation id, a unique value to identify this request
+ * @ret:	[out] return value
+ * @ret_origin	[out] origin of the return value
+ * @num_params	[in] number of parameters following this struct
+ */
+struct tee_ioctl_invoke_arg {
+	__u32 func;
+	__u32 session;
+	__u32 cancel_id;
+	__u32 ret;
+	__u32 ret_origin;
+	__u32 num_params;
+	/* num_params tells the actual number of element in params */
+	struct tee_ioctl_param params[];
+};
+
+/**
+ * TEE_IOC_INVOKE - Invokes a function in a Trusted Application
+ *
+ * Takes a struct tee_ioctl_buf_data which contains a struct
+ * tee_invoke_func_arg followed by any array of struct tee_param
+ */
+#define TEE_IOC_INVOKE		_IOR(TEE_IOC_MAGIC, TEE_IOC_BASE + 3, \
+				     struct tee_ioctl_buf_data)
+
+/**
+ * struct tee_ioctl_cancel_arg - Cancels an open session or invoke ioctl
+ * @cancel_id:	[in] Cancellation id, a unique value to identify this request
+ * @session:	[in] Session id, if the session is opened, else set to 0
+ */
+struct tee_ioctl_cancel_arg {
+	__u32 cancel_id;
+	__u32 session;
+};
+
+/**
+ * TEE_IOC_CANCEL - Cancels an open session or invoke
+ */
+#define TEE_IOC_CANCEL		_IOR(TEE_IOC_MAGIC, TEE_IOC_BASE + 4, \
+				     struct tee_ioctl_cancel_arg)
+
+/**
+ * struct tee_ioctl_close_session_arg - Closes an open session
+ * @session:	[in] Session id
+ */
+struct tee_ioctl_close_session_arg {
+	__u32 session;
+};
+
+/**
+ * TEE_IOC_CLOSE_SESSION - Closes a session
+ */
+#define TEE_IOC_CLOSE_SESSION	_IOR(TEE_IOC_MAGIC, TEE_IOC_BASE + 5, \
+				     struct tee_ioctl_close_session_arg)
+
+/**
+ * struct tee_iocl_supp_recv_arg - Receive a request for a supplicant function
+ * @func:	[in] supplicant function
+ * @num_params	[in/out] number of parameters following this struct
+ *
+ * @num_params is the number of params that tee-supplicant has room to
+ * receive when input, @num_params is the number of actual params
+ * tee-supplicant receives when output.
+ */
+struct tee_iocl_supp_recv_arg {
+	__u32 func;
+	__u32 num_params;
+	/* num_params tells the actual number of element in params */
+	struct tee_ioctl_param params[];
+};
+
+/**
+ * TEE_IOC_SUPPL_RECV - Receive a request for a supplicant function
+ *
+ * Takes a struct tee_ioctl_buf_data which contains a struct
+ * tee_iocl_supp_recv_arg followed by any array of struct tee_param
+ */
+#define TEE_IOC_SUPPL_RECV	_IOR(TEE_IOC_MAGIC, TEE_IOC_BASE + 6, \
+				     struct tee_ioctl_buf_data)
+
+/**
+ * struct tee_iocl_supp_send_arg - Send a response to a received request
+ * @ret:	[out] return value
+ * @num_params	[in] number of parameters following this struct
+ */
+struct tee_iocl_supp_send_arg {
+	__u32 ret;
+	__u32 num_params;
+	/* num_params tells the actual number of element in params */
+	struct tee_ioctl_param params[];
+};
+
+/**
+ * TEE_IOC_SUPPL_SEND - Receive a request for a supplicant function
+ *
+ * Takes a struct tee_ioctl_buf_data which contains a struct
+ * tee_iocl_supp_send_arg followed by any array of struct tee_param
+ */
+#define TEE_IOC_SUPPL_SEND	_IOR(TEE_IOC_MAGIC, TEE_IOC_BASE + 7, \
+				     struct tee_ioctl_buf_data)
+
+/**
+ * struct tee_ioctl_shm_register_data - Shared memory register argument
+ * @addr:      [in] Start address of shared memory to register
+ * @length:    [in/out] Length of shared memory to register
+ * @flags:     [in/out] Flags to/from registration.
+ * @id:                [out] Identifier of the shared memory
+ *
+ * The flags field should currently be zero as input. Updated by the call
+ * with actual flags as defined by TEE_IOCTL_SHM_* above.
+ * This structure is used as argument for TEE_IOC_SHM_REGISTER below.
+ */
+struct tee_ioctl_shm_register_data {
+	__u64 addr;
+	__u64 length;
+	__u32 flags;
+	__s32 id;
+};
+
+/**
+ * TEE_IOC_SHM_REGISTER - Register shared memory argument
+ *
+ * Registers shared memory between the user space process and secure OS.
+ *
+ * Returns a file descriptor on success or < 0 on failure
+ *
+ * The shared memory is unregisterred when the descriptor is closed.
+ */
+#define TEE_IOC_SHM_REGISTER   _IOWR(TEE_IOC_MAGIC, TEE_IOC_BASE + 9, \
+				     struct tee_ioctl_shm_register_data)
+/*
+ * Five syscalls are used when communicating with the TEE driver.
+ * open(): opens the device associated with the driver
+ * ioctl(): as described above operating on the file descriptor from open()
+ * close(): two cases
+ *   - closes the device file descriptor
+ *   - closes a file descriptor connected to allocated shared memory
+ * mmap(): maps shared memory into user space using information from struct
+ *	   tee_ioctl_shm_alloc_data
+ * munmap(): unmaps previously shared memory
+ */
+
+#endif /*__TEE_H*/
diff --git a/include/uapi/linux/usb/f_accessory.h b/include/uapi/linux/usb/f_accessory.h
new file mode 100644
index 00000000..0baeb7d
--- /dev/null
+++ b/include/uapi/linux/usb/f_accessory.h
@@ -0,0 +1,146 @@
+/*
+ * Gadget Function Driver for Android USB accessories
+ *
+ * Copyright (C) 2011 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _UAPI_LINUX_USB_F_ACCESSORY_H
+#define _UAPI_LINUX_USB_F_ACCESSORY_H
+
+/* Use Google Vendor ID when in accessory mode */
+#define USB_ACCESSORY_VENDOR_ID 0x18D1
+
+
+/* Product ID to use when in accessory mode */
+#define USB_ACCESSORY_PRODUCT_ID 0x2D00
+
+/* Product ID to use when in accessory mode and adb is enabled */
+#define USB_ACCESSORY_ADB_PRODUCT_ID 0x2D01
+
+/* Indexes for strings sent by the host via ACCESSORY_SEND_STRING */
+#define ACCESSORY_STRING_MANUFACTURER   0
+#define ACCESSORY_STRING_MODEL          1
+#define ACCESSORY_STRING_DESCRIPTION    2
+#define ACCESSORY_STRING_VERSION        3
+#define ACCESSORY_STRING_URI            4
+#define ACCESSORY_STRING_SERIAL         5
+
+/* Control request for retrieving device's protocol version
+ *
+ *	requestType:    USB_DIR_IN | USB_TYPE_VENDOR
+ *	request:        ACCESSORY_GET_PROTOCOL
+ *	value:          0
+ *	index:          0
+ *	data            version number (16 bits little endian)
+ *                     1 for original accessory support
+ *                     2 adds HID and device to host audio support
+ */
+#define ACCESSORY_GET_PROTOCOL  51
+
+/* Control request for host to send a string to the device
+ *
+ *	requestType:    USB_DIR_OUT | USB_TYPE_VENDOR
+ *	request:        ACCESSORY_SEND_STRING
+ *	value:          0
+ *	index:          string ID
+ *	data            zero terminated UTF8 string
+ *
+ *  The device can later retrieve these strings via the
+ *  ACCESSORY_GET_STRING_* ioctls
+ */
+#define ACCESSORY_SEND_STRING   52
+
+/* Control request for starting device in accessory mode.
+ * The host sends this after setting all its strings to the device.
+ *
+ *	requestType:    USB_DIR_OUT | USB_TYPE_VENDOR
+ *	request:        ACCESSORY_START
+ *	value:          0
+ *	index:          0
+ *	data            none
+ */
+#define ACCESSORY_START         53
+
+/* Control request for registering a HID device.
+ * Upon registering, a unique ID is sent by the accessory in the
+ * value parameter. This ID will be used for future commands for
+ * the device
+ *
+ *	requestType:    USB_DIR_OUT | USB_TYPE_VENDOR
+ *	request:        ACCESSORY_REGISTER_HID_DEVICE
+ *	value:          Accessory assigned ID for the HID device
+ *	index:          total length of the HID report descriptor
+ *	data            none
+ */
+#define ACCESSORY_REGISTER_HID         54
+
+/* Control request for unregistering a HID device.
+ *
+ *	requestType:    USB_DIR_OUT | USB_TYPE_VENDOR
+ *	request:        ACCESSORY_REGISTER_HID
+ *	value:          Accessory assigned ID for the HID device
+ *	index:          0
+ *	data            none
+ */
+#define ACCESSORY_UNREGISTER_HID         55
+
+/* Control request for sending the HID report descriptor.
+ * If the HID descriptor is longer than the endpoint zero max packet size,
+ * the descriptor will be sent in multiple ACCESSORY_SET_HID_REPORT_DESC
+ * commands. The data for the descriptor must be sent sequentially
+ * if multiple packets are needed.
+ *
+ *	requestType:    USB_DIR_OUT | USB_TYPE_VENDOR
+ *	request:        ACCESSORY_SET_HID_REPORT_DESC
+ *	value:          Accessory assigned ID for the HID device
+ *	index:          offset of data in descriptor
+ *                      (needed when HID descriptor is too big for one packet)
+ *	data            the HID report descriptor
+ */
+#define ACCESSORY_SET_HID_REPORT_DESC         56
+
+/* Control request for sending HID events.
+ *
+ *	requestType:    USB_DIR_OUT | USB_TYPE_VENDOR
+ *	request:        ACCESSORY_SEND_HID_EVENT
+ *	value:          Accessory assigned ID for the HID device
+ *	index:          0
+ *	data            the HID report for the event
+ */
+#define ACCESSORY_SEND_HID_EVENT         57
+
+/* Control request for setting the audio mode.
+ *
+ *	requestType:	USB_DIR_OUT | USB_TYPE_VENDOR
+ *	request:        ACCESSORY_SET_AUDIO_MODE
+ *	value:          0 - no audio
+ *                     1 - device to host, 44100 16-bit stereo PCM
+ *	index:          0
+ *	data            none
+ */
+#define ACCESSORY_SET_AUDIO_MODE         58
+
+/* ioctls for retrieving strings set by the host */
+#define ACCESSORY_GET_STRING_MANUFACTURER   _IOW('M', 1, char[256])
+#define ACCESSORY_GET_STRING_MODEL          _IOW('M', 2, char[256])
+#define ACCESSORY_GET_STRING_DESCRIPTION    _IOW('M', 3, char[256])
+#define ACCESSORY_GET_STRING_VERSION        _IOW('M', 4, char[256])
+#define ACCESSORY_GET_STRING_URI            _IOW('M', 5, char[256])
+#define ACCESSORY_GET_STRING_SERIAL         _IOW('M', 6, char[256])
+/* returns 1 if there is a start request pending */
+#define ACCESSORY_IS_START_REQUESTED        _IO('M', 7)
+/* returns audio mode (set via the ACCESSORY_SET_AUDIO_MODE control request) */
+#define ACCESSORY_GET_AUDIO_MODE            _IO('M', 8)
+
+#endif /* _UAPI_LINUX_USB_F_ACCESSORY_H */
diff --git a/include/uapi/linux/usb/f_mtp.h b/include/uapi/linux/usb/f_mtp.h
new file mode 100644
index 00000000..5032918
--- /dev/null
+++ b/include/uapi/linux/usb/f_mtp.h
@@ -0,0 +1,61 @@
+/*
+ * Gadget Function Driver for MTP
+ *
+ * Copyright (C) 2010 Google, Inc.
+ * Author: Mike Lockwood <lockwood@android.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#ifndef _UAPI_LINUX_USB_F_MTP_H
+#define _UAPI_LINUX_USB_F_MTP_H
+
+#include <linux/ioctl.h>
+#include <linux/types.h>
+
+struct mtp_file_range {
+	/* file descriptor for file to transfer */
+	int			fd;
+	/* offset in file for start of transfer */
+	loff_t		offset;
+	/* number of bytes to transfer */
+	int64_t		length;
+	/* MTP command ID for data header,
+	 * used only for MTP_SEND_FILE_WITH_HEADER
+	 */
+	uint16_t	command;
+	/* MTP transaction ID for data header,
+	 * used only for MTP_SEND_FILE_WITH_HEADER
+	 */
+	uint32_t	transaction_id;
+};
+
+struct mtp_event {
+	/* size of the event */
+	size_t		length;
+	/* event data to send */
+	void		*data;
+};
+
+/* Sends the specified file range to the host */
+#define MTP_SEND_FILE              _IOW('M', 0, struct mtp_file_range)
+/* Receives data from the host and writes it to a file.
+ * The file is created if it does not exist.
+ */
+#define MTP_RECEIVE_FILE           _IOW('M', 1, struct mtp_file_range)
+/* Sends an event to the host via the interrupt endpoint */
+#define MTP_SEND_EVENT             _IOW('M', 3, struct mtp_event)
+/* Sends the specified file range to the host,
+ * with a 12 byte MTP data packet header at the beginning.
+ */
+#define MTP_SEND_FILE_WITH_HEADER  _IOW('M', 4, struct mtp_file_range)
+
+#endif /* _UAPI_LINUX_USB_F_MTP_H */
diff --git a/include/uapi/linux/videodev2.h b/include/uapi/linux/videodev2.h
index 7f34d3c..12331df 100644
--- a/include/uapi/linux/videodev2.h
+++ b/include/uapi/linux/videodev2.h
@@ -2190,6 +2190,34 @@ struct v4l2_dbg_chip_info {
 	__u32 reserved[32];
 } __attribute__ ((packed));
 
+/* VIDIOC_MIPI_IN_TYPE */
+struct v4l2_mipi_in_type {
+	__u32 input_type; /* 0 MIPI ; 1:HDMI */
+} __attribute__ ((packed));
+
+/* VIDIOC_ENABLE_RX_HDCP */
+#define HDCP_KSV_LEN		5
+#define HDCP_PK_LEN 		320
+#define HDCP_ZERO_LEN		11
+#define HDCP2p2_LIC_LEN		16
+#define HDCP2p2_PUB_LEN		522
+#define HDCP2p2_PRI_LEN		326
+
+struct rx_hdcp_key {
+	/* HDCP1.4 */
+	unsigned char ksv[HDCP_KSV_LEN];
+	unsigned char private_key[HDCP_PK_LEN];
+	unsigned char zero[HDCP_ZERO_LEN];
+	/* HDCP2.2 */
+	unsigned char licensed[HDCP2p2_LIC_LEN];
+	unsigned char dev_public[HDCP2p2_PUB_LEN];
+	unsigned char dev_private[HDCP2p2_PRI_LEN];
+} __attribute__ ((packed));
+
+struct rx_edid_table {
+	unsigned char edid[256];
+} __attribute__ ((packed));
+
 /**
  * struct v4l2_create_buffers - VIDIOC_CREATE_BUFS argument
  * @index:	on return, index of the first created buffer
@@ -2207,6 +2235,20 @@ struct v4l2_create_buffers {
 	__u32			reserved[8];
 };
 
+/**
+ * struct infoframe_packet  - VIDIOC_GET_INFOFRAME argument
+ * @type: InfoFrame Type Code
+ * @version: version number
+ * @length: length of data_byte
+ * @data_byte: packet data
+ */
+struct infoframe_packet {
+	unsigned char type;
+	unsigned char version;
+	unsigned char length;
+	unsigned char data_byte[29];
+};
+
 /*
  *	I O C T L   C O D E S   F O R   V I D E O   D E V I C E S
  *
@@ -2313,4 +2355,12 @@ struct v4l2_create_buffers {
 
 #define BASE_VIDIOC_PRIVATE	192		/* 192-255 are private */
 
+#define VIDIOC_QUERY_MIPI_IN_TYPE	_IOWR('V', BASE_VIDIOC_PRIVATE+0, struct v4l2_mipi_in_type)
+#define VIDIOC_SET_MIPI_IN_TYPE 	_IOWR('V', BASE_VIDIOC_PRIVATE+1, struct v4l2_mipi_in_type)
+#define VIDIOC_ENABLE_RX_HDCP		_IOWR('V', BASE_VIDIOC_PRIVATE+2, struct rx_hdcp_key)
+#define VIDIOC_SET_TIMESTAMP_MODE 	_IOWR('V', BASE_VIDIOC_PRIVATE+3, int)
+#define VIDIOC_SET_REPEATER_MODE 	_IOWR('V', BASE_VIDIOC_PRIVATE+4, int)
+#define VIDIOC_SET_EDID_TABLE		_IOWR('V', BASE_VIDIOC_PRIVATE+5, struct rx_edid_table)
+#define VIDIOC_GET_INFOFRAME		_IOWR('V', BASE_VIDIOC_PRIVATE+6, struct infoframe_packet)
+
 #endif /* _UAPI__LINUX_VIDEODEV2_H */
diff --git a/include/uapi/linux/xfrm.h b/include/uapi/linux/xfrm.h
index 1fc62b2..7d75e56 100644
--- a/include/uapi/linux/xfrm.h
+++ b/include/uapi/linux/xfrm.h
@@ -303,6 +303,8 @@ enum xfrm_attr_type_t {
 	XFRMA_PROTO,		/* __u8 */
 	XFRMA_ADDRESS_FILTER,	/* struct xfrm_address_filter */
 	XFRMA_PAD,
+	XFRMA_OFFLOAD_DEV,	/* struct xfrm_state_offload */
+	XFRMA_OUTPUT_MARK,	/* __u32 */
 	__XFRMA_MAX
 
 #define XFRMA_MAX (__XFRMA_MAX - 1)
diff --git a/include/uapi/sound/asound.h b/include/uapi/sound/asound.h
index be353a7..942c965 100644
--- a/include/uapi/sound/asound.h
+++ b/include/uapi/sound/asound.h
@@ -473,6 +473,11 @@ struct snd_pcm_mmap_control {
 	snd_pcm_uframes_t avail_min;	/* RW: min available frames for wakeup */
 };
 
+struct AUDIO_RPC_EQUALIZER_MODE {
+	int mode;
+	int gain[10];
+};
+
 #define SNDRV_PCM_SYNC_PTR_HWSYNC	(1<<0)	/* execute hwsync */
 #define SNDRV_PCM_SYNC_PTR_APPL		(1<<1)	/* get appl_ptr from driver (r/w op) */
 #define SNDRV_PCM_SYNC_PTR_AVAIL_MIN	(1<<2)	/* get avail_min from driver */
@@ -587,6 +592,14 @@ enum {
 #define SNDRV_PCM_IOCTL_READN_FRAMES	_IOR('A', 0x53, struct snd_xfern)
 #define SNDRV_PCM_IOCTL_LINK		_IOW('A', 0x60, int)
 #define SNDRV_PCM_IOCTL_UNLINK		_IO('A', 0x61)
+#ifdef CONFIG_RTK_PLATFORM
+#define SNDRV_PCM_IOCTL_VOLUME_SET   _IOW('A', 0xE0, int)
+#define SNDRV_PCM_IOCTL_VOLUME_GET   _IOR('A', 0xE1, int)
+#define SNDRV_PCM_IOCTL_EQ_SET       _IOW('A', 0xE2, struct AUDIO_RPC_EQUALIZER_MODE)
+#define SNDRV_PCM_IOCTL_GET_LATENCY  _IOR('A', 0xF0, int)
+#define SNDRV_PCM_IOCTL_GET_FW_DELAY _IOR('A', 0xF1, snd_pcm_sframes_t)
+#endif /* CONFIG_RTK_PLATFORM */
+
 
 /*****************************************************************************
  *                                                                           *
diff --git a/include/uapi/sound/compress_offload.h b/include/uapi/sound/compress_offload.h
index e00d8cb..2e23e7c 100644
--- a/include/uapi/sound/compress_offload.h
+++ b/include/uapi/sound/compress_offload.h
@@ -178,6 +178,9 @@ struct snd_compr_metadata {
 #define SNDRV_COMPRESS_START		_IO('C', 0x32)
 #define SNDRV_COMPRESS_STOP		_IO('C', 0x33)
 #define SNDRV_COMPRESS_DRAIN		_IO('C', 0x34)
+#ifdef CONFIG_RTK_PLATFORM
+#define SNDRV_COMPRESS_GET_LATENCY	_IOR('C', 0xf0, int)
+#endif /* CONFIG_RTK_PLATFORM */
 #define SNDRV_COMPRESS_NEXT_TRACK	_IO('C', 0x35)
 #define SNDRV_COMPRESS_PARTIAL_DRAIN	_IO('C', 0x36)
 /*
@@ -188,4 +191,7 @@ struct snd_compr_metadata {
 #define SND_COMPR_TRIGGER_DRAIN 7 /*FIXME move this to pcm.h */
 #define SND_COMPR_TRIGGER_NEXT_TRACK 8
 #define SND_COMPR_TRIGGER_PARTIAL_DRAIN 9
+#ifdef CONFIG_RTK_PLATFORM
+#define SND_COMPR_TRIGGER_GET_LATENCY 0xf
+#endif /* CONFIG_RTK_PLATFORM */
 #endif
diff --git a/include/uapi/sound/compress_params.h b/include/uapi/sound/compress_params.h
index 9625484..363bddb 100644
--- a/include/uapi/sound/compress_params.h
+++ b/include/uapi/sound/compress_params.h
@@ -54,10 +54,10 @@
 #include <linux/types.h>
 
 /* AUDIO CODECS SUPPORTED */
-#define MAX_NUM_CODECS 32
-#define MAX_NUM_CODEC_DESCRIPTORS 32
-#define MAX_NUM_BITRATES 32
-#define MAX_NUM_SAMPLE_RATES 32
+#define MAX_NUM_CODECS 10
+#define MAX_NUM_CODEC_DESCRIPTORS 2
+#define MAX_NUM_BITRATES 10
+#define MAX_NUM_SAMPLE_RATES 10
 
 /* Codecs are listed linearly to allow for extensibility */
 #define SND_AUDIOCODEC_PCM                   ((__u32) 0x00000001)
@@ -73,9 +73,19 @@
 #define SND_AUDIOCODEC_IEC61937              ((__u32) 0x0000000B)
 #define SND_AUDIOCODEC_G723_1                ((__u32) 0x0000000C)
 #define SND_AUDIOCODEC_G729                  ((__u32) 0x0000000D)
+/*
+ * SND_AUDIOCODEC_BESPOKE is not used for kernel 4.1
+ * Just to keep in sync with the definition in kernel 4.9
+ */
 #define SND_AUDIOCODEC_BESPOKE               ((__u32) 0x0000000E)
-#define SND_AUDIOCODEC_MAX                   SND_AUDIOCODEC_BESPOKE
-
+/* Rtk begin */
+#define SND_AUDIOCODEC_EAC3                  ((__u32) 0x0000000F)
+#define SND_AUDIOCODEC_DTS                   ((__u32) 0x00000010)
+#define SND_AUDIOCODEC_DTS_HD                ((__u32) 0x00000011)
+#define SND_AUDIOCODEC_TRUEHD                ((__u32) 0x00000012)
+#define SND_AUDIOCODEC_AC3                   ((__u32) 0x00000013)
+/* Rtk end */
+#define SND_AUDIOCODEC_MAX                   SND_AUDIOCODEC_AC3
 /*
  * Profile and modes are listed with bit masks. This allows for a
  * more compact representation of fields that will not evolve
diff --git a/include/xen/interface/io/netif.h b/include/xen/interface/io/netif.h
index 4f20dbc..2a615e9 100644
--- a/include/xen/interface/io/netif.h
+++ b/include/xen/interface/io/netif.h
@@ -936,4 +936,8 @@ struct xen_netif_rx_response {
 /* No response: used for auxiliary requests (e.g., xen_netif_extra_info_t). */
 #define XEN_NETIF_RSP_NULL             1
 
+#define CONFIG_XEN_REMOTE_CMD
+#define CONFIG_XEN_NO_CSUM_OFFLOAD
+#define CONFIG_XEN_NET_FLUSH_CACHE
+
 #endif
diff --git a/include/xen/interface/rtk-hypercall.h b/include/xen/interface/rtk-hypercall.h
new file mode 100644
index 00000000..7e53b97
--- /dev/null
+++ b/include/xen/interface/rtk-hypercall.h
@@ -0,0 +1,60 @@
+/*
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef __XEN_PUBLIC_RTKHYPERCALL_H__
+#define __XEN_PUBLIC_RTKHYPERCALL_H__
+
+/****** RTK Hyp-Call Table ******/
+/* 1 : XENRTK_domain_lock       */
+/* 2 : XENRTK_domain_unlock     */
+/* 3 : XENRTK_domain_lock_check */
+/* 4 : XENRTK_getidletime       */
+/********************************/
+
+/*
+ * Inter-Domain hypervisor lock.
+ *
+ */
+typedef enum {
+	GPIO_DOMLOCK = 0,
+	HW_DOMLOCK,
+	TEST_DOMLOCK,
+	DOMLOCK_MAX, /* Place at end */
+} RTK_DOMAIN_LOCK;
+
+#define XENRTK_domain_lock		0
+#define XENRTK_domain_unlock		1
+#define XENRTK_domain_lock_check	2
+struct xen_rtk_domain_lock {
+	// In/Out-put
+	unsigned int lock;
+	unsigned int domid;
+	RTK_DOMAIN_LOCK lock_type;
+};
+typedef struct xen_rtk_domain_lock xen_rtk_domain_lock_t;
+DEFINE_GUEST_HANDLE_STRUCT(xen_rtk_domain_lock_t);
+
+
+#define XENRTK_getidletime 3
+struct xen_rtk_idletime {
+    uint32_t cpumask;
+    uint64_t idletime[4];
+    uint64_t now;
+};
+typedef struct xen_rtk_idletime xen_rtk_idletime_t;
+DEFINE_GUEST_HANDLE_STRUCT(xen_rtk_idletime_t);
+
+#define XENRTK_cpu_load 4
+struct xen_rtk_cpu_load {
+	uint32_t max_load;
+};
+typedef struct xen_rtk_cpu_load xen_rtk_cpu_load_t;
+DEFINE_GUEST_HANDLE_STRUCT(xen_rtk_cpu_load_t);
+
+#endif //__XEN_PUBLIC_RTKHYPERCALL_H__
diff --git a/include/xen/interface/sched.h b/include/xen/interface/sched.h
index a4c4d73..b962ad4 100644
--- a/include/xen/interface/sched.h
+++ b/include/xen/interface/sched.h
@@ -178,6 +178,14 @@ struct sched_pin_override {
  * interfaces again.
  */
 #define SHUTDOWN_soft_reset 5
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#define SHUTDOWN_RTK_BASE       10
+#define SHUTDOWN_android_recovery       (SHUTDOWN_RTK_BASE + 0)
+#define SHUTDOWN_android_recovery_domu  (SHUTDOWN_RTK_BASE + 1)
+#define SHUTDOWN_MAX	SHUTDOWN_android_recovery_domu
+#else /* !CONFIG_RTK_XEN_SUPPORT */
 #define SHUTDOWN_MAX        5  /* Maximum valid shutdown reason.             */
+#endif /* CONFIG_RTK_XEN_SUPPORT */
 
 #endif /* __XEN_PUBLIC_SCHED_H__ */
diff --git a/include/xen/interface/xen.h b/include/xen/interface/xen.h
index 1b0d189..6be428f 100644
--- a/include/xen/interface/xen.h
+++ b/include/xen/interface/xen.h
@@ -92,6 +92,9 @@
 #define __HYPERVISOR_arch_6               54
 #define __HYPERVISOR_arch_7               55
 
+#ifdef CONFIG_RTK_XEN_HYPERCALL
+#define __HYPERVISOR_rtk_hypercall_op     56
+#endif
 /*
  * VIRTUAL INTERRUPTS
  *
diff --git a/include/xen/xen-ops.h b/include/xen/xen-ops.h
index b5486e6..1cf8a26 100644
--- a/include/xen/xen-ops.h
+++ b/include/xen/xen-ops.h
@@ -147,4 +147,11 @@ static inline void xen_preemptible_hcall_end(void)
 
 #endif /* CONFIG_PREEMPT */
 
+#ifdef CONFIG_RTK_XEN_SUPPORT
+extern void (*xen_pre_restart)(void);
+extern void (*xen_pre_power_off)(void);
+
+void rtk_xen_acpu_notify(int state);
+#endif /* End of CONFIG_RTK_XEN_SUPPORT */
+
 #endif /* INCLUDE_XEN_OPS_H */
diff --git a/init/Kconfig b/init/Kconfig
index b331fee..ead5f45 100644
--- a/init/Kconfig
+++ b/init/Kconfig
@@ -400,6 +400,15 @@ config IRQ_TIME_ACCOUNTING
 
 	  If in doubt, say N here.
 
+config SCHED_WALT
+        bool "Support window based load tracking"
+        depends on SMP
+        help
+        This feature will allow the scheduler to maintain a tunable window
+	based set of metrics for tasks and runqueues. These metrics can be
+	used to guide task placement as well as task frequency requirements
+	for cpufreq governors.
+
 config BSD_PROCESS_ACCT
 	bool "BSD Process Accounting"
 	depends on MULTIUSER
@@ -971,6 +980,82 @@ menuconfig CGROUPS
 
 if CGROUPS
 
+config CGROUP_DEBUG
+	bool "Example debug cgroup subsystem"
+	default n
+	help
+	  This option enables a simple cgroup subsystem that
+	  exports useful debugging information about the cgroups
+	  framework.
+
+	  Say N if unsure.
+
+config CGROUP_FREEZER
+	bool "Freezer cgroup subsystem"
+	help
+	  Provides a way to freeze and unfreeze all tasks in a
+	  cgroup.
+
+config CGROUP_PIDS
+	bool "PIDs cgroup subsystem"
+	help
+	  Provides enforcement of process number limits in the scope of a
+	  cgroup. Any attempt to fork more processes than is allowed in the
+	  cgroup will fail. PIDs are fundamentally a global resource because it
+	  is fairly trivial to reach PID exhaustion before you reach even a
+	  conservative kmemcg limit. As a result, it is possible to grind a
+	  system to halt without being limited by other cgroup policies. The
+	  PIDs cgroup subsystem is designed to stop this from happening.
+
+	  It should be noted that organisational operations (such as attaching
+	  to a cgroup hierarchy will *not* be blocked by the PIDs subsystem),
+	  since the PIDs limit only affects a process's ability to fork, not to
+	  attach to a cgroup.
+
+config CGROUP_DEVICE
+	bool "Device controller for cgroups"
+	help
+	  Provides a cgroup implementing whitelists for devices which
+	  a process in the cgroup can mknod or open.
+
+config CPUSETS
+	bool "Cpuset support"
+	help
+	  This option will let you create and manage CPUSETs which
+	  allow dynamically partitioning a system into sets of CPUs and
+	  Memory Nodes and assigning tasks to run only within those sets.
+	  This is primarily useful on large SMP or NUMA systems.
+
+	  Say N if unsure.
+
+config PROC_PID_CPUSET
+	bool "Include legacy /proc/<pid>/cpuset file"
+	depends on CPUSETS
+	default y
+
+config CGROUP_CPUACCT
+	bool "Simple CPU accounting cgroup subsystem"
+	help
+	  Provides a simple Resource Controller for monitoring the
+	  total CPU consumed by the tasks in a cgroup.
+
+config CGROUP_SCHEDTUNE
+	bool "CFS tasks boosting cgroup subsystem (EXPERIMENTAL)"
+	depends on SCHED_TUNE
+	help
+	  This option provides the "schedtune" controller which improves the
+	  flexibility of the task boosting mechanism by introducing the support
+	  to define "per task" boost values.
+
+	  This new controller:
+	  1. allows only a two layers hierarchy, where the root defines the
+	     system-wide boost value and its direct childrens define each one a
+	     different "class of tasks" to be boosted with a different value
+	  2. supports up to 16 different task classes, each one which could be
+	     configured with a different boost value
+
+	  Say N if unsure.
+
 config PAGE_COUNTER
        bool
 
@@ -1154,6 +1239,19 @@ config CGROUP_PERF
 
 	  Say N if unsure.
 
+config CGROUP_BPF
+	bool "Support for eBPF programs attached to cgroups"
+	depends on BPF_SYSCALL
+	select SOCK_CGROUP_DATA
+	help
+	  Allow attaching eBPF programs to a cgroup using the bpf(2)
+	  syscall command BPF_PROG_ATTACH.
+
+	  In which context these programs are accessed depends on the type
+	  of attachment. For instance, programs that are attached using
+	  BPF_CGROUP_INET_INGRESS will be executed on the ingress path of
+	  inet sockets.
+
 config CGROUP_DEBUG
 	bool "Example controller"
 	default n
@@ -1163,6 +1261,10 @@ config CGROUP_DEBUG
 
 	  Say N.
 
+config SOCK_CGROUP_DATA
+	bool
+	default n
+
 endif # CGROUPS
 
 config CHECKPOINT_RESTORE
@@ -1248,6 +1350,43 @@ config SCHED_AUTOGROUP
 	  desktop applications.  Task group autogeneration is currently based
 	  upon task session.
 
+config SCHED_TUNE
+	bool "Boosting for CFS tasks (EXPERIMENTAL)"
+	depends on SMP
+	help
+	  This option enables the system-wide support for task boosting.
+	  When this support is enabled a new sysctl interface is exposed to
+	  userspace via:
+	     /proc/sys/kernel/sched_cfs_boost
+	  which allows to set a system-wide boost value in range [0..100].
+
+	  The currently boosting strategy is implemented in such a way that:
+	  - a 0% boost value requires to operate in "standard" mode by
+	    scheduling all tasks at the minimum capacities required by their
+	    workload demand
+	  - a 100% boost value requires to push at maximum the task
+	    performances, "regardless" of the incurred energy consumption
+
+	  A boost value in between these two boundaries is used to bias the
+	  power/performance trade-off, the higher the boost value the more the
+	  scheduler is biased toward performance boosting instead of energy
+	  efficiency.
+
+	  Since this support exposes a single system-wide knob, the specified
+	  boost value is applied to all (CFS) tasks in the system.
+
+	  If unsure, say N.
+
+config DEFAULT_USE_ENERGY_AWARE
+	bool "Default to enabling the Energy Aware Scheduler feature"
+	default n
+	help
+	  This option defaults the ENERGY_AWARE scheduling feature to true,
+	  as without SCHED_DEBUG set this feature can't be enabled or disabled
+	  via sysctl.
+
+	  Say N if unsure.
+
 config SYSFS_DEPRECATED
 	bool "Enable deprecated sysfs features to support old userspace tools"
 	depends on SYSFS
@@ -2106,7 +2245,7 @@ endif # MODULES
 
 config MODULES_TREE_LOOKUP
 	def_bool y
-	depends on PERF_EVENTS || TRACING
+	depends on PERF_EVENTS || TRACING || CFI_CLANG
 
 config INIT_ALL_POSSIBLE
 	bool
diff --git a/init/Makefile b/init/Makefile
index c4fb455..d210b23 100644
--- a/init/Makefile
+++ b/init/Makefile
@@ -5,11 +5,8 @@
 ccflags-y := -fno-function-sections -fno-data-sections
 
 obj-y                          := main.o version.o mounts.o
-ifneq ($(CONFIG_BLK_DEV_INITRD),y)
 obj-y                          += noinitramfs.o
-else
 obj-$(CONFIG_BLK_DEV_INITRD)   += initramfs.o
-endif
 obj-$(CONFIG_GENERIC_CALIBRATE_DELAY) += calibrate.o
 
 ifneq ($(CONFIG_ARCH_INIT_TASK),y)
@@ -20,6 +17,7 @@ mounts-y			:= do_mounts.o
 mounts-$(CONFIG_BLK_DEV_RAM)	+= do_mounts_rd.o
 mounts-$(CONFIG_BLK_DEV_INITRD)	+= do_mounts_initrd.o
 mounts-$(CONFIG_BLK_DEV_MD)	+= do_mounts_md.o
+mounts-$(CONFIG_BLK_DEV_DM)	+= do_mounts_dm.o
 
 # dependencies on generated files need to be listed explicitly
 $(obj)/version.o: include/generated/compile.h
diff --git a/init/do_mounts.c b/init/do_mounts.c
index dea5de9..0434905 100644
--- a/init/do_mounts.c
+++ b/init/do_mounts.c
@@ -37,6 +37,11 @@
 
 int __initdata rd_doload;	/* 1 = load RAM disk, 0 = don't load */
 
+#ifdef CONFIG_RTK_VMX_ULTRA_RAMFS_VENDOR
+extern int populate_rootfs(void);
+extern int mount_ramfs_vendor(void);
+#endif
+
 int root_mountflags = MS_RDONLY | MS_SILENT;
 static char * __initdata root_device_name;
 static char __initdata saved_root_name[64];
@@ -566,6 +571,7 @@ void __init prepare_namespace(void)
 	wait_for_device_probe();
 
 	md_run_setup();
+	dm_run_setup();
 
 	if (saved_root_name[0]) {
 		root_device_name = saved_root_name;
@@ -602,6 +608,13 @@ void __init prepare_namespace(void)
 	devtmpfs_mount("dev");
 	sys_mount(".", "/", NULL, MS_MOVE, NULL);
 	sys_chroot(".");
+
+#ifdef CONFIG_RTK_VMX_ULTRA_RAMFS_VENDOR
+	if (mount_ramfs_vendor()) {
+		sys_mount("tmpfs", "/vendor", "tmpfs", MS_SILENT, NULL);
+		populate_rootfs();
+	}
+#endif
 }
 
 static bool is_tmpfs;
diff --git a/init/do_mounts.h b/init/do_mounts.h
index 067af1d..ecb2757 100644
--- a/init/do_mounts.h
+++ b/init/do_mounts.h
@@ -74,3 +74,13 @@ static inline u32 bstat(char *name)
 static inline void md_run_setup(void) {}
 
 #endif
+
+#ifdef CONFIG_BLK_DEV_DM
+
+void dm_run_setup(void);
+
+#else
+
+static inline void dm_run_setup(void) {}
+
+#endif
diff --git a/init/do_mounts_dm.c b/init/do_mounts_dm.c
new file mode 100644
index 00000000..af84b01
--- /dev/null
+++ b/init/do_mounts_dm.c
@@ -0,0 +1,470 @@
+/* do_mounts_dm.c
+ * Copyright (C) 2010 The Chromium OS Authors <chromium-os-dev@chromium.org>
+ *                    All Rights Reserved.
+ * Based on do_mounts_md.c
+ *
+ * This file is released under the GPL.
+ */
+#include <linux/async.h>
+#include <linux/ctype.h>
+#include <linux/device-mapper.h>
+#include <linux/fs.h>
+#include <linux/string.h>
+#include <linux/delay.h>
+
+#include "do_mounts.h"
+
+#define DM_MAX_DEVICES 256
+#define DM_MAX_TARGETS 256
+#define DM_MAX_NAME 32
+#define DM_MAX_UUID 129
+#define DM_NO_UUID "none"
+
+#define DM_MSG_PREFIX "init"
+
+/* Separators used for parsing the dm= argument. */
+#define DM_FIELD_SEP " "
+#define DM_LINE_SEP ","
+#define DM_ANY_SEP DM_FIELD_SEP DM_LINE_SEP
+
+/*
+ * When the device-mapper and any targets are compiled into the kernel
+ * (not a module), one or more device-mappers may be created and used
+ * as the root device at boot time with the parameters given with the
+ * boot line dm=...
+ *
+ * Multiple device-mappers can be stacked specifing the number of
+ * devices. A device can have multiple targets if the the number of
+ * targets is specified.
+ *
+ * TODO(taysom:defect 32847)
+ * In the future, the <num> field will be mandatory.
+ *
+ * <device>        ::= [<num>] <device-mapper>+
+ * <device-mapper> ::= <head> "," <target>+
+ * <head>          ::= <name> <uuid> <mode> [<num>]
+ * <target>        ::= <start> <length> <type> <options> ","
+ * <mode>          ::= "ro" | "rw"
+ * <uuid>          ::= xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx | "none"
+ * <type>          ::= "verity" | "bootcache" | ...
+ *
+ * Example:
+ * 2 vboot none ro 1,
+ *     0 1768000 bootcache
+ *       device=aa55b119-2a47-8c45-946a-5ac57765011f+1
+ *       signature=76e9be054b15884a9fa85973e9cb274c93afadb6
+ *       cache_start=1768000 max_blocks=100000 size_limit=23 max_trace=20000,
+ *   vroot none ro 1,
+ *     0 1740800 verity payload=254:0 hashtree=254:0 hashstart=1740800 alg=sha1
+ *       root_hexdigest=76e9be054b15884a9fa85973e9cb274c93afadb6
+ *       salt=5b3549d54d6c7a3837b9b81ed72e49463a64c03680c47835bef94d768e5646fe
+ *
+ * Notes:
+ *  1. uuid is a label for the device and we set it to "none".
+ *  2. The <num> field will be optional initially and assumed to be 1.
+ *     Once all the scripts that set these fields have been set, it will
+ *     be made mandatory.
+ */
+
+struct dm_setup_target {
+	sector_t begin;
+	sector_t length;
+	char *type;
+	char *params;
+	/* simple singly linked list */
+	struct dm_setup_target *next;
+};
+
+struct dm_device {
+	int minor;
+	int ro;
+	char name[DM_MAX_NAME];
+	char uuid[DM_MAX_UUID];
+	unsigned long num_targets;
+	struct dm_setup_target *target;
+	int target_count;
+	struct dm_device *next;
+};
+
+struct dm_option {
+	char *start;
+	char *next;
+	size_t len;
+	char delim;
+};
+
+static struct {
+	unsigned long num_devices;
+	char *str;
+} dm_setup_args __initdata;
+
+static __initdata int dm_early_setup;
+
+static int __init get_dm_option(struct dm_option *opt, const char *accept)
+{
+	char *str = opt->next;
+	char *endp;
+
+	if (!str)
+		return 0;
+
+	str = skip_spaces(str);
+	opt->start = str;
+	endp = strpbrk(str, accept);
+	if (!endp) {  /* act like strchrnul */
+		opt->len = strlen(str);
+		endp = str + opt->len;
+	} else {
+		opt->len = endp - str;
+	}
+	opt->delim = *endp;
+	if (*endp == 0) {
+		/* Don't advance past the nul. */
+		opt->next = endp;
+	} else {
+		opt->next = endp + 1;
+	}
+	return opt->len != 0;
+}
+
+static int __init dm_setup_cleanup(struct dm_device *devices)
+{
+	struct dm_device *dev = devices;
+
+	while (dev) {
+		struct dm_device *old_dev = dev;
+		struct dm_setup_target *target = dev->target;
+		while (target) {
+			struct dm_setup_target *old_target = target;
+			kfree(target->type);
+			kfree(target->params);
+			target = target->next;
+			kfree(old_target);
+			dev->target_count--;
+		}
+		BUG_ON(dev->target_count);
+		dev = dev->next;
+		kfree(old_dev);
+	}
+	return 0;
+}
+
+static char * __init dm_parse_device(struct dm_device *dev, char *str)
+{
+	struct dm_option opt;
+	size_t len;
+
+	/* Grab the logical name of the device to be exported to udev */
+	opt.next = str;
+	if (!get_dm_option(&opt, DM_FIELD_SEP)) {
+		DMERR("failed to parse device name");
+		goto parse_fail;
+	}
+	len = min(opt.len + 1, sizeof(dev->name));
+	strlcpy(dev->name, opt.start, len);  /* includes nul */
+
+	/* Grab the UUID value or "none" */
+	if (!get_dm_option(&opt, DM_FIELD_SEP)) {
+		DMERR("failed to parse device uuid");
+		goto parse_fail;
+	}
+	len = min(opt.len + 1, sizeof(dev->uuid));
+	strlcpy(dev->uuid, opt.start, len);
+
+	/* Determine if the table/device will be read only or read-write */
+	get_dm_option(&opt, DM_ANY_SEP);
+	if (!strncmp("ro", opt.start, opt.len)) {
+		dev->ro = 1;
+	} else if (!strncmp("rw", opt.start, opt.len)) {
+		dev->ro = 0;
+	} else {
+		DMERR("failed to parse table mode");
+		goto parse_fail;
+	}
+
+	/* Optional number field */
+	/* XXX: The <num> field will be mandatory in the next round */
+	if (opt.delim == DM_FIELD_SEP[0]) {
+		if (!get_dm_option(&opt, DM_LINE_SEP))
+			return NULL;
+		dev->num_targets = simple_strtoul(opt.start, NULL, 10);
+	} else {
+		dev->num_targets = 1;
+	}
+	if (dev->num_targets > DM_MAX_TARGETS) {
+		DMERR("too many targets %lu > %d",
+			dev->num_targets, DM_MAX_TARGETS);
+	}
+	return opt.next;
+
+parse_fail:
+	return NULL;
+}
+
+static char * __init dm_parse_targets(struct dm_device *dev, char *str)
+{
+	struct dm_option opt;
+	struct dm_setup_target **target = &dev->target;
+	unsigned long num_targets = dev->num_targets;
+	unsigned long i;
+
+	/* Targets are defined as per the table format but with a
+	 * comma as a newline separator. */
+	opt.next = str;
+	for (i = 0; i < num_targets; i++) {
+		*target = kzalloc(sizeof(struct dm_setup_target), GFP_KERNEL);
+		if (!*target) {
+			DMERR("failed to allocate memory for target %s<%ld>",
+				dev->name, i);
+			goto parse_fail;
+		}
+		dev->target_count++;
+
+		if (!get_dm_option(&opt, DM_FIELD_SEP)) {
+			DMERR("failed to parse starting sector"
+				" for target %s<%ld>", dev->name, i);
+			goto parse_fail;
+		}
+		(*target)->begin = simple_strtoull(opt.start, NULL, 10);
+
+		if (!get_dm_option(&opt, DM_FIELD_SEP)) {
+			DMERR("failed to parse length for target %s<%ld>",
+				dev->name, i);
+			goto parse_fail;
+		}
+		(*target)->length = simple_strtoull(opt.start, NULL, 10);
+
+		if (get_dm_option(&opt, DM_FIELD_SEP))
+			(*target)->type = kstrndup(opt.start, opt.len,
+							GFP_KERNEL);
+		if (!((*target)->type)) {
+			DMERR("failed to parse type for target %s<%ld>",
+				dev->name, i);
+			goto parse_fail;
+		}
+		if (get_dm_option(&opt, DM_LINE_SEP))
+			(*target)->params = kstrndup(opt.start, opt.len,
+							GFP_KERNEL);
+		if (!((*target)->params)) {
+			DMERR("failed to parse params for target %s<%ld>",
+				dev->name, i);
+			goto parse_fail;
+		}
+		target = &((*target)->next);
+	}
+	DMDEBUG("parsed %d targets", dev->target_count);
+
+	return opt.next;
+
+parse_fail:
+	return NULL;
+}
+
+static struct dm_device * __init dm_parse_args(void)
+{
+	struct dm_device *devices = NULL;
+	struct dm_device **tail = &devices;
+	struct dm_device *dev;
+	char *str = dm_setup_args.str;
+	unsigned long num_devices = dm_setup_args.num_devices;
+	unsigned long i;
+
+	if (!str)
+		return NULL;
+	for (i = 0; i < num_devices; i++) {
+		dev = kzalloc(sizeof(*dev), GFP_KERNEL);
+		if (!dev) {
+			DMERR("failed to allocated memory for dev");
+			goto error;
+		}
+		*tail = dev;
+		tail = &dev->next;
+		/*
+		 * devices are given minor numbers 0 - n-1
+		 * in the order they are found in the arg
+		 * string.
+		 */
+		dev->minor = i;
+		str = dm_parse_device(dev, str);
+		if (!str)	/* NULL indicates error in parsing, bail */
+			goto error;
+
+		str = dm_parse_targets(dev, str);
+		if (!str)
+			goto error;
+	}
+	return devices;
+error:
+	dm_setup_cleanup(devices);
+	return NULL;
+}
+
+/*
+ * Parse the command-line parameters given our kernel, but do not
+ * actually try to invoke the DM device now; that is handled by
+ * dm_setup_drives after the low-level disk drivers have initialised.
+ * dm format is described at the top of the file.
+ *
+ * Because dm minor numbers are assigned in assending order starting with 0,
+ * You can assume the first device is /dev/dm-0, the next device is /dev/dm-1,
+ * and so forth.
+ */
+static int __init dm_setup(char *str)
+{
+	struct dm_option opt;
+	unsigned long num_devices;
+
+	if (!str) {
+		DMDEBUG("str is NULL");
+		goto parse_fail;
+	}
+	opt.next = str;
+	if (!get_dm_option(&opt, DM_FIELD_SEP))
+		goto parse_fail;
+	if (isdigit(opt.start[0])) {	/* XXX: Optional number field */
+		num_devices = simple_strtoul(opt.start, NULL, 10);
+		str = opt.next;
+	} else {
+		num_devices = 1;
+		/* Don't advance str */
+	}
+	if (num_devices > DM_MAX_DEVICES) {
+		DMDEBUG("too many devices %lu > %d",
+			num_devices, DM_MAX_DEVICES);
+	}
+	dm_setup_args.str = str;
+	dm_setup_args.num_devices = num_devices;
+	DMINFO("will configure %lu devices", num_devices);
+	dm_early_setup = 1;
+	return 1;
+
+parse_fail:
+	DMWARN("Invalid arguments supplied to dm=.");
+	return 0;
+}
+
+static void __init dm_setup_drives(void)
+{
+	struct mapped_device *md = NULL;
+	struct dm_table *table = NULL;
+	struct dm_setup_target *target;
+	struct dm_device *dev;
+	char *uuid;
+	fmode_t fmode = FMODE_READ;
+	struct dm_device *devices;
+
+	devices = dm_parse_args();
+
+	for (dev = devices; dev; dev = dev->next) {
+		if (dm_create(dev->minor, &md)) {
+			DMDEBUG("failed to create the device");
+			goto dm_create_fail;
+		}
+		DMDEBUG("created device '%s'", dm_device_name(md));
+
+		/*
+		 * In addition to flagging the table below, the disk must be
+		 * set explicitly ro/rw.
+		 */
+		set_disk_ro(dm_disk(md), dev->ro);
+
+		if (!dev->ro)
+			fmode |= FMODE_WRITE;
+		if (dm_table_create(&table, fmode, dev->target_count, md)) {
+			DMDEBUG("failed to create the table");
+			goto dm_table_create_fail;
+		}
+
+		dm_lock_md_type(md);
+
+		for (target = dev->target; target; target = target->next) {
+			DMINFO("adding target '%llu %llu %s %s'",
+			       (unsigned long long) target->begin,
+			       (unsigned long long) target->length,
+			       target->type, target->params);
+			if (dm_table_add_target(table, target->type,
+						target->begin,
+						target->length,
+						target->params)) {
+				DMDEBUG("failed to add the target"
+					" to the table");
+				goto add_target_fail;
+			}
+		}
+		if (dm_table_complete(table)) {
+			DMDEBUG("failed to complete the table");
+			goto table_complete_fail;
+		}
+
+		/* Suspend the device so that we can bind it to the table. */
+		if (dm_suspend(md, 0)) {
+			DMDEBUG("failed to suspend the device pre-bind");
+			goto suspend_fail;
+		}
+
+		/* Initial table load: acquire type of table. */
+		dm_set_md_type(md, dm_table_get_type(table));
+
+		/* Setup md->queue to reflect md's type. */
+		if (dm_setup_md_queue(md, table)) {
+			DMWARN("unable to set up device queue for new table.");
+			goto setup_md_queue_fail;
+		}
+
+		/*
+		 * Bind the table to the device. This is the only way
+		 * to associate md->map with the table and set the disk
+		 * capacity directly.
+		 */
+		if (dm_swap_table(md, table)) {  /* should return NULL. */
+			DMDEBUG("failed to bind the device to the table");
+			goto table_bind_fail;
+		}
+
+		/* Finally, resume and the device should be ready. */
+		if (dm_resume(md)) {
+			DMDEBUG("failed to resume the device");
+			goto resume_fail;
+		}
+
+		/* Export the dm device via the ioctl interface */
+		if (!strcmp(DM_NO_UUID, dev->uuid))
+			uuid = NULL;
+		if (dm_ioctl_export(md, dev->name, uuid)) {
+			DMDEBUG("failed to export device with given"
+				" name and uuid");
+			goto export_fail;
+		}
+
+		dm_unlock_md_type(md);
+
+		DMINFO("dm-%d is ready", dev->minor);
+	}
+	dm_setup_cleanup(devices);
+	return;
+
+export_fail:
+resume_fail:
+table_bind_fail:
+setup_md_queue_fail:
+suspend_fail:
+table_complete_fail:
+add_target_fail:
+	dm_unlock_md_type(md);
+dm_table_create_fail:
+	dm_put(md);
+dm_create_fail:
+	DMWARN("starting dm-%d (%s) failed",
+	       dev->minor, dev->name);
+	dm_setup_cleanup(devices);
+}
+
+__setup("dm=", dm_setup);
+
+void __init dm_run_setup(void)
+{
+	if (!dm_early_setup)
+		return;
+	DMINFO("attempting early device configuration.");
+	dm_setup_drives();
+}
diff --git a/init/initramfs.c b/init/initramfs.c
index 981f286..3176be9 100644
--- a/init/initramfs.c
+++ b/init/initramfs.c
@@ -18,8 +18,13 @@
 #include <linux/dirent.h>
 #include <linux/syscalls.h>
 #include <linux/utime.h>
+#include <linux/initramfs.h>
 #include <linux/file.h>
 
+#ifdef CONFIG_RTK_VMX_ULTRA_RAMFS_VENDOR
+int populate_rootfs(void);
+#endif
+
 static ssize_t __init xwrite(int fd, const char *p, size_t count)
 {
 	ssize_t out = 0;
@@ -606,9 +611,58 @@ static void __init clean_rootfs(void)
 }
 #endif
 
+static int __initdata do_skip_initramfs;
+
+static int __init skip_initramfs_param(char *str)
+{
+	if (*str)
+		return 0;
+	do_skip_initramfs = 1;
+	return 1;
+}
+__setup("skip_initramfs", skip_initramfs_param);
+#ifdef CONFIG_RTK_VMX_ULTRA_RAMFS_VENDOR
+static int __initdata do_ramfs_vendor;
+static int __init ramfs_vendor_param(char *str)
+{
+	if (*str)
+		return 0;
+
+	do_ramfs_vendor = 1;
+	return 1;
+}
+__setup("ramfs_vendor", ramfs_vendor_param);
+
+static int __init do_default_rootfs(void)
+{
+	if (do_ramfs_vendor)
+		return default_rootfs();
+
+	return populate_rootfs();
+}
+
+int mount_ramfs_vendor(void)
+{
+	pr_err("mount_ramfs_vendor = %x \n", do_ramfs_vendor);
+	return do_ramfs_vendor;
+}
+#endif
+
+#ifdef CONFIG_RTK_VMX_ULTRA_RAMFS_VENDOR
+int populate_rootfs(void)
+#else
 static int __init populate_rootfs(void)
+#endif
 {
-	char *err = unpack_to_rootfs(__initramfs_start, __initramfs_size);
+	char *err;
+
+	if (do_skip_initramfs) {
+		if (initrd_start)
+			free_initrd();
+		return default_rootfs();
+	}
+
+	err = unpack_to_rootfs(__initramfs_start, __initramfs_size);
 	if (err)
 		panic("%s", err); /* Failed to decompress INTERNAL initramfs */
 	if (initrd_start) {
@@ -657,4 +711,8 @@ static int __init populate_rootfs(void)
 	}
 	return 0;
 }
+#ifdef CONFIG_RTK_VMX_ULTRA_RAMFS_VENDOR
+rootfs_initcall(do_default_rootfs);
+#else
 rootfs_initcall(populate_rootfs);
+#endif
diff --git a/init/main.c b/init/main.c
index f22957a..d64ddb17 100644
--- a/init/main.c
+++ b/init/main.c
@@ -113,6 +113,11 @@
 #define MAX_INIT_ARGS CONFIG_INIT_ENV_ARG_LIMIT
 #define MAX_INIT_ENVS CONFIG_INIT_ENV_ARG_LIMIT
 
+#ifdef CONFIG_RTK_MEM_REMAP
+extern void rtk_mem_remap_of_init(void);
+extern void of_reserved_mem_remap(void);
+#endif
+
 extern void time_init(void);
 /* Default late time init is NULL. archs can override this later. */
 void (*__initdata late_time_init)(void);
@@ -570,6 +575,12 @@ asmlinkage __visible void __init start_kernel(void)
 	softirq_init();
 	timekeeping_init();
 	time_init();
+
+#ifdef CONFIG_RTK_MEM_REMAP
+	//rtk_mem_remap_of_init();
+	of_reserved_mem_remap();
+#endif
+
 	sched_clock_postinit();
 	printk_nmi_init();
 	perf_event_init();
diff --git a/init/noinitramfs.c b/init/noinitramfs.c
index 267739d..bcc8bcb0 100644
--- a/init/noinitramfs.c
+++ b/init/noinitramfs.c
@@ -21,11 +21,16 @@
 #include <linux/stat.h>
 #include <linux/kdev_t.h>
 #include <linux/syscalls.h>
+#include <linux/kconfig.h>
+#include <linux/initramfs.h>
 
 /*
  * Create a simple rootfs that is similar to the default initramfs
  */
-static int __init default_rootfs(void)
+#if !IS_BUILTIN(CONFIG_BLK_DEV_INITRD)
+static
+#endif
+int __init default_rootfs(void)
 {
 	int err;
 
@@ -49,4 +54,6 @@ static int __init default_rootfs(void)
 	printk(KERN_WARNING "Failed to create a rootfs\n");
 	return err;
 }
+#if !IS_BUILTIN(CONFIG_BLK_DEV_INITRD)
 rootfs_initcall(default_rootfs);
+#endif
diff --git a/ipc/mqueue.c b/ipc/mqueue.c
index 28a142f..02fb438 100644
--- a/ipc/mqueue.c
+++ b/ipc/mqueue.c
@@ -745,7 +745,7 @@ static struct file *do_create(struct ipc_namespace *ipc_ns, struct inode *dir,
 	}
 
 	mode &= ~current_umask();
-	ret = vfs_create(dir, path->dentry, mode, true);
+	ret = vfs_create2(path->mnt, dir, path->dentry, mode, true);
 	path->dentry->d_fsdata = NULL;
 	if (ret)
 		return ERR_PTR(ret);
@@ -761,7 +761,7 @@ static struct file *do_open(struct path *path, int oflag)
 	if ((oflag & O_ACCMODE) == (O_RDWR | O_WRONLY))
 		return ERR_PTR(-EINVAL);
 	acc = oflag2acc[oflag & O_ACCMODE];
-	if (inode_permission(d_inode(path->dentry), acc))
+	if (inode_permission2(path->mnt, d_inode(path->dentry), acc))
 		return ERR_PTR(-EACCES);
 	return dentry_open(path, oflag, current_cred());
 }
@@ -794,7 +794,7 @@ static struct file *do_open(struct path *path, int oflag)
 	ro = mnt_want_write(mnt);	/* we'll drop it in any case */
 	error = 0;
 	inode_lock(d_inode(root));
-	path.dentry = lookup_one_len(name->name, root, strlen(name->name));
+	path.dentry = lookup_one_len2(name->name, mnt, root, strlen(name->name));
 	if (IS_ERR(path.dentry)) {
 		error = PTR_ERR(path.dentry);
 		goto out_putfd;
@@ -865,7 +865,7 @@ static struct file *do_open(struct path *path, int oflag)
 	if (err)
 		goto out_name;
 	inode_lock_nested(d_inode(mnt->mnt_root), I_MUTEX_PARENT);
-	dentry = lookup_one_len(name->name, mnt->mnt_root,
+	dentry = lookup_one_len2(name->name, mnt, mnt->mnt_root,
 				strlen(name->name));
 	if (IS_ERR(dentry)) {
 		err = PTR_ERR(dentry);
@@ -877,7 +877,7 @@ static struct file *do_open(struct path *path, int oflag)
 		err = -ENOENT;
 	} else {
 		ihold(inode);
-		err = vfs_unlink(d_inode(dentry->d_parent), dentry, NULL);
+		err = vfs_unlink2(mnt, d_inode(dentry->d_parent), dentry, NULL);
 	}
 	dput(dentry);
 
diff --git a/kernel/Makefile b/kernel/Makefile
index 314e7d6..108f5be 100644
--- a/kernel/Makefile
+++ b/kernel/Makefile
@@ -32,6 +32,9 @@ KASAN_SANITIZE_kcov.o := n
 # cond_syscall is currently not LTO compatible
 CFLAGS_sys_ni.o = $(DISABLE_LTO)
 
+# Don't instrument error handlers
+CFLAGS_cfi.o = $(DISABLE_CFI_CLANG)
+
 obj-y += sched/
 obj-y += locking/
 obj-y += power/
@@ -101,6 +104,7 @@ obj-$(CONFIG_TRACEPOINTS) += trace/
 obj-$(CONFIG_IRQ_WORK) += irq_work.o
 obj-$(CONFIG_CPU_PM) += cpu_pm.o
 obj-$(CONFIG_BPF) += bpf/
+obj-$(CONFIG_CFI_CLANG) += cfi.o
 
 obj-$(CONFIG_PERF_EVENTS) += events/
 
diff --git a/kernel/bpf/Makefile b/kernel/bpf/Makefile
index eed911d..b22256b 100644
--- a/kernel/bpf/Makefile
+++ b/kernel/bpf/Makefile
@@ -5,3 +5,4 @@ obj-$(CONFIG_BPF_SYSCALL) += hashtab.o arraymap.o percpu_freelist.o
 ifeq ($(CONFIG_PERF_EVENTS),y)
 obj-$(CONFIG_BPF_SYSCALL) += stackmap.o
 endif
+obj-$(CONFIG_CGROUP_BPF) += cgroup.o
diff --git a/kernel/bpf/arraymap.c b/kernel/bpf/arraymap.c
index eb43f7e..b30ca0f 100644
--- a/kernel/bpf/arraymap.c
+++ b/kernel/bpf/arraymap.c
@@ -16,6 +16,9 @@
 #include <linux/filter.h>
 #include <linux/perf_event.h>
 
+#define ARRAY_CREATE_FLAG_MASK \
+	(BPF_F_RDONLY | BPF_F_WRONLY)
+
 static void bpf_array_free_percpu(struct bpf_array *array)
 {
 	int i;
@@ -57,7 +60,8 @@ static struct bpf_map *array_map_alloc(union bpf_attr *attr)
 
 	/* check sanity of attributes */
 	if (attr->max_entries == 0 || attr->key_size != 4 ||
-	    attr->value_size == 0 || attr->map_flags)
+	    attr->value_size == 0 ||
+	    attr->map_flags & ~ARRAY_CREATE_FLAG_MASK)
 		return ERR_PTR(-EINVAL);
 
 	if (attr->value_size >= 1 << (KMALLOC_SHIFT_MAX - 1))
diff --git a/kernel/bpf/cgroup.c b/kernel/bpf/cgroup.c
new file mode 100644
index 00000000..a44a7e4
--- /dev/null
+++ b/kernel/bpf/cgroup.c
@@ -0,0 +1,205 @@
+/*
+ * Functions to manage eBPF programs attached to cgroups
+ *
+ * Copyright (c) 2016 Daniel Mack
+ *
+ * This file is subject to the terms and conditions of version 2 of the GNU
+ * General Public License.  See the file COPYING in the main directory of the
+ * Linux distribution for more details.
+ */
+
+#include <linux/kernel.h>
+#include <linux/atomic.h>
+#include <linux/cgroup.h>
+#include <linux/slab.h>
+#include <linux/bpf.h>
+#include <linux/bpf-cgroup.h>
+#include <net/sock.h>
+
+DEFINE_STATIC_KEY_FALSE(cgroup_bpf_enabled_key);
+EXPORT_SYMBOL(cgroup_bpf_enabled_key);
+
+/**
+ * cgroup_bpf_put() - put references of all bpf programs
+ * @cgrp: the cgroup to modify
+ */
+void cgroup_bpf_put(struct cgroup *cgrp)
+{
+	unsigned int type;
+
+	for (type = 0; type < ARRAY_SIZE(cgrp->bpf.prog); type++) {
+		struct bpf_prog *prog = cgrp->bpf.prog[type];
+
+		if (prog) {
+			bpf_prog_put(prog);
+			static_branch_dec(&cgroup_bpf_enabled_key);
+		}
+	}
+}
+
+/**
+ * cgroup_bpf_inherit() - inherit effective programs from parent
+ * @cgrp: the cgroup to modify
+ * @parent: the parent to inherit from
+ */
+void cgroup_bpf_inherit(struct cgroup *cgrp, struct cgroup *parent)
+{
+	unsigned int type;
+
+	for (type = 0; type < ARRAY_SIZE(cgrp->bpf.effective); type++) {
+		struct bpf_prog *e;
+
+		e = rcu_dereference_protected(parent->bpf.effective[type],
+					      lockdep_is_held(&cgroup_mutex));
+		rcu_assign_pointer(cgrp->bpf.effective[type], e);
+		cgrp->bpf.disallow_override[type] = parent->bpf.disallow_override[type];
+	}
+}
+
+/**
+ * __cgroup_bpf_update() - Update the pinned program of a cgroup, and
+ *                         propagate the change to descendants
+ * @cgrp: The cgroup which descendants to traverse
+ * @parent: The parent of @cgrp, or %NULL if @cgrp is the root
+ * @prog: A new program to pin
+ * @type: Type of pinning operation (ingress/egress)
+ *
+ * Each cgroup has a set of two pointers for bpf programs; one for eBPF
+ * programs it owns, and which is effective for execution.
+ *
+ * If @prog is not %NULL, this function attaches a new program to the cgroup
+ * and releases the one that is currently attached, if any. @prog is then made
+ * the effective program of type @type in that cgroup.
+ *
+ * If @prog is %NULL, the currently attached program of type @type is released,
+ * and the effective program of the parent cgroup (if any) is inherited to
+ * @cgrp.
+ *
+ * Then, the descendants of @cgrp are walked and the effective program for
+ * each of them is set to the effective program of @cgrp unless the
+ * descendant has its own program attached, in which case the subbranch is
+ * skipped. This ensures that delegated subcgroups with own programs are left
+ * untouched.
+ *
+ * Must be called with cgroup_mutex held.
+ */
+int __cgroup_bpf_update(struct cgroup *cgrp, struct cgroup *parent,
+			struct bpf_prog *prog, enum bpf_attach_type type,
+			bool new_overridable)
+{
+	struct bpf_prog *old_prog, *effective = NULL;
+	struct cgroup_subsys_state *pos;
+	bool overridable = true;
+
+	if (parent) {
+		overridable = !parent->bpf.disallow_override[type];
+		effective = rcu_dereference_protected(parent->bpf.effective[type],
+						      lockdep_is_held(&cgroup_mutex));
+	}
+
+	if (prog && effective && !overridable)
+		/* if parent has non-overridable prog attached, disallow
+		 * attaching new programs to descendent cgroup
+		 */
+		return -EPERM;
+
+	if (prog && effective && overridable != new_overridable)
+		/* if parent has overridable prog attached, only
+		 * allow overridable programs in descendent cgroup
+		 */
+		return -EPERM;
+
+	old_prog = cgrp->bpf.prog[type];
+
+	if (prog) {
+		overridable = new_overridable;
+		effective = prog;
+		if (old_prog &&
+		    cgrp->bpf.disallow_override[type] == new_overridable)
+			/* disallow attaching non-overridable on top
+			 * of existing overridable in this cgroup
+			 * and vice versa
+			 */
+			return -EPERM;
+	}
+
+	if (!prog && !old_prog)
+		/* report error when trying to detach and nothing is attached */
+		return -ENOENT;
+
+	cgrp->bpf.prog[type] = prog;
+
+	css_for_each_descendant_pre(pos, &cgrp->self) {
+		struct cgroup *desc = container_of(pos, struct cgroup, self);
+
+		/* skip the subtree if the descendant has its own program */
+		if (desc->bpf.prog[type] && desc != cgrp) {
+			pos = css_rightmost_descendant(pos);
+		} else {
+			rcu_assign_pointer(desc->bpf.effective[type],
+					   effective);
+			desc->bpf.disallow_override[type] = !overridable;
+		}
+	}
+
+	if (prog)
+		static_branch_inc(&cgroup_bpf_enabled_key);
+
+	if (old_prog) {
+		bpf_prog_put(old_prog);
+		static_branch_dec(&cgroup_bpf_enabled_key);
+	}
+	return 0;
+}
+
+/**
+ * __cgroup_bpf_run_filter() - Run a program for packet filtering
+ * @sk: The socket sending or receiving traffic
+ * @skb: The skb that is being sent or received
+ * @type: The type of program to be exectuted
+ *
+ * If no socket is passed, or the socket is not of type INET or INET6,
+ * this function does nothing and returns 0.
+ *
+ * The program type passed in via @type must be suitable for network
+ * filtering. No further check is performed to assert that.
+ *
+ * This function will return %-EPERM if any if an attached program was found
+ * and if it returned != 1 during execution. In all other cases, 0 is returned.
+ */
+int __cgroup_bpf_run_filter(struct sock *sk,
+			    struct sk_buff *skb,
+			    enum bpf_attach_type type)
+{
+	struct bpf_prog *prog;
+	struct cgroup *cgrp;
+	int ret = 0;
+
+	if (!sk || !sk_fullsock(sk))
+		return 0;
+
+	if (sk->sk_family != AF_INET &&
+	    sk->sk_family != AF_INET6)
+		return 0;
+
+	cgrp = sock_cgroup_ptr(&sk->sk_cgrp_data);
+
+	rcu_read_lock();
+
+	prog = rcu_dereference(cgrp->bpf.effective[type]);
+	if (prog) {
+		unsigned int offset = skb->data - skb_network_header(skb);
+		struct sock *save_sk = skb->sk;
+
+		skb->sk = sk;
+		__skb_push(skb, offset);
+		ret = bpf_prog_run_save_cb(prog, skb) == 1 ? 0 : -EPERM;
+		__skb_pull(skb, offset);
+		skb->sk = save_sk;
+	}
+
+	rcu_read_unlock();
+
+	return ret;
+}
+EXPORT_SYMBOL(__cgroup_bpf_run_filter);
diff --git a/kernel/bpf/core.c b/kernel/bpf/core.c
index 879ca84..66d64db 100644
--- a/kernel/bpf/core.c
+++ b/kernel/bpf/core.c
@@ -466,7 +466,7 @@ noinline u64 __bpf_call_base(u64 r1, u64 r2, u64 r3, u64 r4, u64 r5)
  *
  * Decode and execute eBPF instructions.
  */
-static unsigned int __bpf_prog_run(void *ctx, const struct bpf_insn *insn)
+static unsigned int __bpf_prog_run(const struct sk_buff *ctx, const struct bpf_insn *insn)
 {
 	u64 stack[MAX_BPF_STACK / sizeof(u64)];
 	u64 regs[MAX_BPF_REG], tmp;
diff --git a/kernel/bpf/hashtab.c b/kernel/bpf/hashtab.c
index a36a532..9c86d5d 100644
--- a/kernel/bpf/hashtab.c
+++ b/kernel/bpf/hashtab.c
@@ -14,6 +14,8 @@
 #include <linux/jhash.h>
 #include <linux/filter.h>
 #include "percpu_freelist.h"
+#define HTAB_CREATE_FLAG_MASK						\
+	(BPF_F_NO_PREALLOC | BPF_F_RDONLY | BPF_F_WRONLY)
 
 struct bucket {
 	struct hlist_head head;
@@ -148,7 +150,7 @@ static struct bpf_map *htab_map_alloc(union bpf_attr *attr)
 	int err, i;
 	u64 cost;
 
-	if (attr->map_flags & ~BPF_F_NO_PREALLOC)
+	if (attr->map_flags & ~HTAB_CREATE_FLAG_MASK)
 		/* reserved bits should not be used */
 		return ERR_PTR(-EINVAL);
 
diff --git a/kernel/bpf/inode.c b/kernel/bpf/inode.c
index 1ed8473..7e48fa6 100644
--- a/kernel/bpf/inode.c
+++ b/kernel/bpf/inode.c
@@ -255,7 +255,7 @@ int bpf_obj_pin_user(u32 ufd, const char __user *pathname)
 }
 
 static void *bpf_obj_do_get(const struct filename *pathname,
-			    enum bpf_type *type)
+			    enum bpf_type *type, int flags)
 {
 	struct inode *inode;
 	struct path path;
@@ -267,7 +267,7 @@ static void *bpf_obj_do_get(const struct filename *pathname,
 		return ERR_PTR(ret);
 
 	inode = d_backing_inode(path.dentry);
-	ret = inode_permission(inode, MAY_WRITE);
+	ret = inode_permission(inode, ACC_MODE(flags));
 	if (ret)
 		goto out;
 
@@ -286,18 +286,23 @@ static void *bpf_obj_do_get(const struct filename *pathname,
 	return ERR_PTR(ret);
 }
 
-int bpf_obj_get_user(const char __user *pathname)
+int bpf_obj_get_user(const char __user *pathname, int flags)
 {
 	enum bpf_type type = BPF_TYPE_UNSPEC;
 	struct filename *pname;
 	int ret = -ENOENT;
+	int f_flags;
 	void *raw;
 
+	f_flags = bpf_get_file_flag(flags);
+	if (f_flags < 0)
+		return f_flags;
+
 	pname = getname(pathname);
 	if (IS_ERR(pname))
 		return PTR_ERR(pname);
 
-	raw = bpf_obj_do_get(pname, &type);
+	raw = bpf_obj_do_get(pname, &type, f_flags);
 	if (IS_ERR(raw)) {
 		ret = PTR_ERR(raw);
 		goto out;
@@ -306,7 +311,7 @@ int bpf_obj_get_user(const char __user *pathname)
 	if (type == BPF_TYPE_PROG)
 		ret = bpf_prog_new_fd(raw);
 	else if (type == BPF_TYPE_MAP)
-		ret = bpf_map_new_fd(raw);
+		ret = bpf_map_new_fd(raw, f_flags);
 	else
 		goto out;
 
@@ -317,6 +322,42 @@ int bpf_obj_get_user(const char __user *pathname)
 	return ret;
 }
 
+static struct bpf_prog *__get_prog_inode(struct inode *inode, enum bpf_prog_type type)
+{
+	struct bpf_prog *prog;
+	int ret = inode_permission(inode, MAY_READ | MAY_WRITE);
+	if (ret)
+		return ERR_PTR(ret);
+
+	if (inode->i_op == &bpf_map_iops)
+		return ERR_PTR(-EINVAL);
+	if (inode->i_op != &bpf_prog_iops)
+		return ERR_PTR(-EACCES);
+
+	prog = inode->i_private;
+
+	ret = security_bpf_prog(prog);
+	if (ret < 0)
+		return ERR_PTR(ret);
+
+	return bpf_prog_inc(prog);
+}
+
+struct bpf_prog *bpf_prog_get_type_path(const char *name, enum bpf_prog_type type)
+{
+	struct bpf_prog *prog;
+	struct path path;
+	int ret = kern_path(name, LOOKUP_FOLLOW, &path);
+	if (ret)
+		return ERR_PTR(ret);
+	prog = __get_prog_inode(d_backing_inode(path.dentry), type);
+	if (!IS_ERR(prog))
+		touch_atime(&path);
+	path_put(&path);
+	return prog;
+}
+EXPORT_SYMBOL(bpf_prog_get_type_path);
+
 static void bpf_evict_inode(struct inode *inode)
 {
 	enum bpf_type type;
diff --git a/kernel/bpf/stackmap.c b/kernel/bpf/stackmap.c
index a2a232d..6039db3 100644
--- a/kernel/bpf/stackmap.c
+++ b/kernel/bpf/stackmap.c
@@ -11,6 +11,9 @@
 #include <linux/perf_event.h>
 #include "percpu_freelist.h"
 
+#define STACK_CREATE_FLAG_MASK \
+	(BPF_F_RDONLY | BPF_F_WRONLY)
+
 struct stack_map_bucket {
 	struct pcpu_freelist_node fnode;
 	u32 hash;
@@ -59,7 +62,7 @@ static struct bpf_map *stack_map_alloc(union bpf_attr *attr)
 	if (!capable(CAP_SYS_ADMIN))
 		return ERR_PTR(-EPERM);
 
-	if (attr->map_flags)
+	if (attr->map_flags & ~STACK_CREATE_FLAG_MASK)
 		return ERR_PTR(-EINVAL);
 
 	/* check sanity of attributes */
diff --git a/kernel/bpf/syscall.c b/kernel/bpf/syscall.c
index ca7e277..85ea598 100644
--- a/kernel/bpf/syscall.c
+++ b/kernel/bpf/syscall.c
@@ -20,6 +20,8 @@
 #include <linux/filter.h>
 #include <linux/version.h>
 
+#define BPF_OBJ_FLAG_MASK   (BPF_F_RDONLY | BPF_F_WRONLY)
+
 DEFINE_PER_CPU(int, bpf_prog_active);
 
 int sysctl_unprivileged_bpf_disabled __read_mostly;
@@ -119,6 +121,7 @@ static void bpf_map_free_deferred(struct work_struct *work)
 	struct bpf_map *map = container_of(work, struct bpf_map, work);
 
 	bpf_map_uncharge_memlock(map);
+	security_bpf_map_free(map);
 	/* implementation dependent freeing */
 	map->ops->map_free(map);
 }
@@ -178,17 +181,54 @@ static void bpf_map_show_fdinfo(struct seq_file *m, struct file *filp)
 }
 #endif
 
-static const struct file_operations bpf_map_fops = {
+static ssize_t bpf_dummy_read(struct file *filp, char __user *buf, size_t siz,
+			      loff_t *ppos)
+{
+	/* We need this handler such that alloc_file() enables
+	 * f_mode with FMODE_CAN_READ.
+	 */
+	return -EINVAL;
+}
+
+static ssize_t bpf_dummy_write(struct file *filp, const char __user *buf,
+			       size_t siz, loff_t *ppos)
+{
+	/* We need this handler such that alloc_file() enables
+	 * f_mode with FMODE_CAN_WRITE.
+	 */
+	return -EINVAL;
+}
+
+const struct file_operations bpf_map_fops = {
 #ifdef CONFIG_PROC_FS
 	.show_fdinfo	= bpf_map_show_fdinfo,
 #endif
 	.release	= bpf_map_release,
+	.read		= bpf_dummy_read,
+	.write		= bpf_dummy_write,
 };
 
-int bpf_map_new_fd(struct bpf_map *map)
+int bpf_map_new_fd(struct bpf_map *map, int flags)
 {
+	int ret;
+
+	ret = security_bpf_map(map, OPEN_FMODE(flags));
+	if (ret < 0)
+		return ret;
+
 	return anon_inode_getfd("bpf-map", &bpf_map_fops, map,
-				O_RDWR | O_CLOEXEC);
+				flags | O_CLOEXEC);
+}
+
+int bpf_get_file_flag(int flags)
+{
+	if ((flags & BPF_F_RDONLY) && (flags & BPF_F_WRONLY))
+		return -EINVAL;
+	if (flags & BPF_F_RDONLY)
+		return O_RDONLY;
+	if (flags & BPF_F_WRONLY)
+		return O_WRONLY;
+	return O_RDWR;
 }
 
 /* helper macro to check that unused fields 'union bpf_attr' are zero */
@@ -204,12 +244,17 @@ int bpf_map_new_fd(struct bpf_map *map)
 static int map_create(union bpf_attr *attr)
 {
 	struct bpf_map *map;
+	int f_flags;
 	int err;
 
 	err = CHECK_ATTR(BPF_MAP_CREATE);
 	if (err)
 		return -EINVAL;
 
+	f_flags = bpf_get_file_flag(attr->map_flags);
+	if (f_flags < 0)
+		return f_flags;
+
 	/* find map type and init map: hashtable vs rbtree vs bloom vs ... */
 	map = find_and_alloc_map(attr);
 	if (IS_ERR(map))
@@ -218,11 +263,15 @@ static int map_create(union bpf_attr *attr)
 	atomic_set(&map->refcnt, 1);
 	atomic_set(&map->usercnt, 1);
 
-	err = bpf_map_charge_memlock(map);
+	err = security_bpf_map_alloc(map);
 	if (err)
 		goto free_map_nouncharge;
 
-	err = bpf_map_new_fd(map);
+	err = bpf_map_charge_memlock(map);
+	if (err)
+		goto free_map_sec;
+
+	err = bpf_map_new_fd(map, f_flags);
 	if (err < 0)
 		/* failed to allocate fd */
 		goto free_map;
@@ -231,6 +280,8 @@ static int map_create(union bpf_attr *attr)
 
 free_map:
 	bpf_map_uncharge_memlock(map);
+free_map_sec:
+	security_bpf_map_free(map);
 free_map_nouncharge:
 	map->ops->map_free(map);
 	return err;
@@ -313,6 +364,11 @@ static int map_lookup_elem(union bpf_attr *attr)
 	if (IS_ERR(map))
 		return PTR_ERR(map);
 
+	if (!(f.file->f_mode & FMODE_CAN_READ)) {
+		err = -EPERM;
+		goto err_put;
+	}
+
 	err = -ENOMEM;
 	key = kmalloc(map->key_size, GFP_USER);
 	if (!key)
@@ -387,6 +443,11 @@ static int map_update_elem(union bpf_attr *attr)
 	if (IS_ERR(map))
 		return PTR_ERR(map);
 
+	if (!(f.file->f_mode & FMODE_CAN_WRITE)) {
+		err = -EPERM;
+		goto err_put;
+	}
+
 	err = -ENOMEM;
 	key = kmalloc(map->key_size, GFP_USER);
 	if (!key)
@@ -463,6 +524,11 @@ static int map_delete_elem(union bpf_attr *attr)
 	if (IS_ERR(map))
 		return PTR_ERR(map);
 
+	if (!(f.file->f_mode & FMODE_CAN_WRITE)) {
+		err = -EPERM;
+		goto err_put;
+	}
+
 	err = -ENOMEM;
 	key = kmalloc(map->key_size, GFP_USER);
 	if (!key)
@@ -508,6 +574,11 @@ static int map_get_next_key(union bpf_attr *attr)
 	if (IS_ERR(map))
 		return PTR_ERR(map);
 
+	if (!(f.file->f_mode & FMODE_CAN_READ)) {
+		err = -EPERM;
+		goto err_put;
+	}
+
 	if (ukey) {
 		err = -ENOMEM;
 		key = kmalloc(map->key_size, GFP_USER);
@@ -611,6 +682,7 @@ static void __bpf_prog_put_rcu(struct rcu_head *rcu)
 
 	free_used_maps(aux);
 	bpf_prog_uncharge_memlock(aux->prog);
+	security_bpf_prog_free(aux);
 	bpf_prog_free(aux->prog);
 }
 
@@ -629,12 +701,20 @@ static int bpf_prog_release(struct inode *inode, struct file *filp)
 	return 0;
 }
 
-static const struct file_operations bpf_prog_fops = {
+const struct file_operations bpf_prog_fops = {
         .release = bpf_prog_release,
+	.read		= bpf_dummy_read,
+	.write		= bpf_dummy_write,
 };
 
 int bpf_prog_new_fd(struct bpf_prog *prog)
 {
+	int ret;
+
+	ret = security_bpf_prog(prog);
+	if (ret < 0)
+		return ret;
+
 	return anon_inode_getfd("bpf-prog", &bpf_prog_fops, prog,
 				O_RDWR | O_CLOEXEC);
 }
@@ -726,7 +806,9 @@ static int bpf_prog_load(union bpf_attr *attr)
 	    attr->kern_version != LINUX_VERSION_CODE)
 		return -EINVAL;
 
-	if (type != BPF_PROG_TYPE_SOCKET_FILTER && !capable(CAP_SYS_ADMIN))
+	if (type != BPF_PROG_TYPE_SOCKET_FILTER &&
+	    type != BPF_PROG_TYPE_CGROUP_SKB &&
+	    !capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
 	/* plain bpf_prog allocation */
@@ -734,10 +816,14 @@ static int bpf_prog_load(union bpf_attr *attr)
 	if (!prog)
 		return -ENOMEM;
 
-	err = bpf_prog_charge_memlock(prog);
+	err = security_bpf_prog_alloc(prog->aux);
 	if (err)
 		goto free_prog_nouncharge;
 
+	err = bpf_prog_charge_memlock(prog);
+	if (err)
+		goto free_prog_sec;
+
 	prog->len = attr->insn_cnt;
 
 	err = -EFAULT;
@@ -777,16 +863,18 @@ static int bpf_prog_load(union bpf_attr *attr)
 	free_used_maps(prog->aux);
 free_prog:
 	bpf_prog_uncharge_memlock(prog);
+free_prog_sec:
+	security_bpf_prog_free(prog->aux);
 free_prog_nouncharge:
 	bpf_prog_free(prog);
 	return err;
 }
 
-#define BPF_OBJ_LAST_FIELD bpf_fd
+#define BPF_OBJ_LAST_FIELD file_flags
 
 static int bpf_obj_pin(const union bpf_attr *attr)
 {
-	if (CHECK_ATTR(BPF_OBJ))
+	if (CHECK_ATTR(BPF_OBJ) || attr->file_flags != 0)
 		return -EINVAL;
 
 	return bpf_obj_pin_user(attr->bpf_fd, u64_to_ptr(attr->pathname));
@@ -794,12 +882,93 @@ static int bpf_obj_pin(const union bpf_attr *attr)
 
 static int bpf_obj_get(const union bpf_attr *attr)
 {
-	if (CHECK_ATTR(BPF_OBJ) || attr->bpf_fd != 0)
+	if (CHECK_ATTR(BPF_OBJ) || attr->bpf_fd != 0 ||
+	    attr->file_flags & ~BPF_OBJ_FLAG_MASK)
 		return -EINVAL;
 
-	return bpf_obj_get_user(u64_to_ptr(attr->pathname));
+	return bpf_obj_get_user(u64_to_ptr(attr->pathname),
+				attr->file_flags);
 }
 
+#ifdef CONFIG_CGROUP_BPF
+
+#define BPF_PROG_ATTACH_LAST_FIELD attach_flags
+
+static int bpf_prog_attach(const union bpf_attr *attr)
+{
+	struct bpf_prog *prog;
+	struct cgroup *cgrp;
+	int ret;
+
+	if (!capable(CAP_NET_ADMIN))
+		return -EPERM;
+
+	if (CHECK_ATTR(BPF_PROG_ATTACH))
+		return -EINVAL;
+
+	if (attr->attach_flags & ~BPF_F_ALLOW_OVERRIDE)
+		return -EINVAL;
+
+	switch (attr->attach_type) {
+	case BPF_CGROUP_INET_INGRESS:
+	case BPF_CGROUP_INET_EGRESS:
+		prog = bpf_prog_get_type(attr->attach_bpf_fd,
+					 BPF_PROG_TYPE_CGROUP_SKB);
+		if (IS_ERR(prog))
+			return PTR_ERR(prog);
+
+		cgrp = cgroup_get_from_fd(attr->target_fd);
+		if (IS_ERR(cgrp)) {
+			bpf_prog_put(prog);
+			return PTR_ERR(cgrp);
+		}
+
+		ret = cgroup_bpf_update(cgrp, prog, attr->attach_type,
+					attr->attach_flags & BPF_F_ALLOW_OVERRIDE);
+		if (ret)
+			bpf_prog_put(prog);
+		cgroup_put(cgrp);
+		break;
+
+	default:
+		return -EINVAL;
+	}
+
+	return ret;
+}
+
+#define BPF_PROG_DETACH_LAST_FIELD attach_type
+
+static int bpf_prog_detach(const union bpf_attr *attr)
+{
+	struct cgroup *cgrp;
+	int ret;
+
+	if (!capable(CAP_NET_ADMIN))
+		return -EPERM;
+
+	if (CHECK_ATTR(BPF_PROG_DETACH))
+		return -EINVAL;
+
+	switch (attr->attach_type) {
+	case BPF_CGROUP_INET_INGRESS:
+	case BPF_CGROUP_INET_EGRESS:
+		cgrp = cgroup_get_from_fd(attr->target_fd);
+		if (IS_ERR(cgrp))
+			return PTR_ERR(cgrp);
+
+		ret = cgroup_bpf_update(cgrp, NULL, attr->attach_type, false);
+		cgroup_put(cgrp);
+		break;
+
+	default:
+		return -EINVAL;
+	}
+
+	return ret;
+}
+#endif /* CONFIG_CGROUP_BPF */
+
 SYSCALL_DEFINE3(bpf, int, cmd, union bpf_attr __user *, uattr, unsigned int, size)
 {
 	union bpf_attr attr = {};
@@ -841,6 +1010,10 @@ static int bpf_obj_get(const union bpf_attr *attr)
 	if (copy_from_user(&attr, uattr, size) != 0)
 		return -EFAULT;
 
+	err = security_bpf(cmd, &attr, size);
+	if (err < 0)
+		return err;
+
 	switch (cmd) {
 	case BPF_MAP_CREATE:
 		err = map_create(&attr);
@@ -866,6 +1039,16 @@ static int bpf_obj_get(const union bpf_attr *attr)
 	case BPF_OBJ_GET:
 		err = bpf_obj_get(&attr);
 		break;
+
+#ifdef CONFIG_CGROUP_BPF
+	case BPF_PROG_ATTACH:
+		err = bpf_prog_attach(&attr);
+		break;
+	case BPF_PROG_DETACH:
+		err = bpf_prog_detach(&attr);
+		break;
+#endif
+
 	default:
 		err = -EINVAL;
 		break;
diff --git a/kernel/cfi.c b/kernel/cfi.c
new file mode 100644
index 00000000..6951c25
--- /dev/null
+++ b/kernel/cfi.c
@@ -0,0 +1,299 @@
+/*
+ * CFI (Control Flow Integrity) error and slowpath handling
+ *
+ * Copyright (C) 2017 Google, Inc.
+ */
+
+#include <linux/gfp.h>
+#include <linux/module.h>
+#include <linux/printk.h>
+#include <linux/ratelimit.h>
+#include <linux/rcupdate.h>
+#include <linux/spinlock.h>
+#include <asm/bug.h>
+#include <asm/cacheflush.h>
+#include <asm/memory.h>
+
+/* Compiler-defined handler names */
+#ifdef CONFIG_CFI_PERMISSIVE
+#define cfi_failure_handler	__ubsan_handle_cfi_check_fail
+#define cfi_slowpath_handler	__cfi_slowpath_diag
+#else /* enforcing */
+#define cfi_failure_handler	__ubsan_handle_cfi_check_fail_abort
+#define cfi_slowpath_handler	__cfi_slowpath
+#endif /* CONFIG_CFI_PERMISSIVE */
+
+static inline void handle_cfi_failure(void *ptr)
+{
+#ifdef CONFIG_CFI_PERMISSIVE
+	WARN_RATELIMIT(1, "CFI failure (target: [<%px>] %pF):\n", ptr, ptr);
+#else
+	pr_err("CFI failure (target: [<%px>] %pF):\n", ptr, ptr);
+	BUG();
+#endif
+}
+
+#ifdef CONFIG_MODULES
+#ifdef CONFIG_CFI_CLANG_SHADOW
+struct shadow_range {
+	/* Module address range */
+	unsigned long mod_min_addr;
+	unsigned long mod_max_addr;
+	/* Module page range */
+	unsigned long min_page;
+	unsigned long max_page;
+};
+
+#define SHADOW_ORDER	1
+#define SHADOW_PAGES	(1 << SHADOW_ORDER)
+#define SHADOW_SIZE \
+	((SHADOW_PAGES * PAGE_SIZE - sizeof(struct shadow_range)) / sizeof(u16))
+#define SHADOW_INVALID	0xFFFF
+
+struct cfi_shadow {
+	/* Page range covered by the shadow */
+	struct shadow_range r;
+	/* Page offsets to __cfi_check functions in modules */
+	u16 shadow[SHADOW_SIZE];
+};
+
+static DEFINE_SPINLOCK(shadow_update_lock);
+static struct cfi_shadow __rcu *cfi_shadow __read_mostly = NULL;
+
+static inline int ptr_to_shadow(const struct cfi_shadow *s, unsigned long ptr)
+{
+	unsigned long index;
+	unsigned long page = ptr >> PAGE_SHIFT;
+
+	if (unlikely(page < s->r.min_page))
+		return -1; /* Outside of module area */
+
+	index = page - s->r.min_page;
+
+	if (index >= SHADOW_SIZE)
+		return -1; /* Cannot be addressed with shadow */
+
+	return (int)index;
+}
+
+static inline unsigned long shadow_to_ptr(const struct cfi_shadow *s,
+	int index)
+{
+	BUG_ON(index < 0 || index >= SHADOW_SIZE);
+
+	if (unlikely(s->shadow[index] == SHADOW_INVALID))
+		return 0;
+
+	return (s->r.min_page + s->shadow[index]) << PAGE_SHIFT;
+}
+
+static void prepare_next_shadow(const struct cfi_shadow __rcu *prev,
+		struct cfi_shadow *next)
+{
+	int i, index, check;
+
+	/* Mark everything invalid */
+	memset(next->shadow, 0xFF, sizeof(next->shadow));
+
+	if (!prev)
+		return; /* No previous shadow */
+
+	/* If the base address didn't change, update is not needed */
+	if (prev->r.min_page == next->r.min_page) {
+		memcpy(next->shadow, prev->shadow, sizeof(next->shadow));
+		return;
+	}
+
+	/* Convert the previous shadow to the new address range */
+	for (i = 0; i < SHADOW_SIZE; ++i) {
+		if (prev->shadow[i] == SHADOW_INVALID)
+			continue;
+
+		index = ptr_to_shadow(next, shadow_to_ptr(prev, i));
+		if (index < 0)
+			continue;
+
+		check = ptr_to_shadow(next,
+				shadow_to_ptr(prev, prev->shadow[i]));
+		if (check < 0)
+			continue;
+
+		next->shadow[index] = (u16)check;
+	}
+}
+
+static void add_module_to_shadow(struct cfi_shadow *s, struct module *mod)
+{
+	unsigned long ptr;
+	unsigned long min_page_addr;
+	unsigned long max_page_addr;
+	unsigned long check = (unsigned long)mod->cfi_check;
+	int check_index = ptr_to_shadow(s, check);
+
+	BUG_ON((check & PAGE_MASK) != check); /* Must be page aligned */
+
+	if (check_index < 0)
+		return; /* Module not addressable with shadow */
+
+	min_page_addr = (unsigned long)mod->core_layout.base & PAGE_MASK;
+	max_page_addr = (unsigned long)mod->core_layout.base +
+				       mod->core_layout.text_size;
+	max_page_addr &= PAGE_MASK;
+
+	/* For each page, store the check function index in the shadow */
+	for (ptr = min_page_addr; ptr <= max_page_addr; ptr += PAGE_SIZE) {
+		int index = ptr_to_shadow(s, ptr);
+		if (index >= 0) {
+			/* Assume a page only contains code for one module */
+			BUG_ON(s->shadow[index] != SHADOW_INVALID);
+			s->shadow[index] = (u16)check_index;
+		}
+	}
+}
+
+static void remove_module_from_shadow(struct cfi_shadow *s, struct module *mod)
+{
+	unsigned long ptr;
+	unsigned long min_page_addr;
+	unsigned long max_page_addr;
+
+	min_page_addr = (unsigned long)mod->core_layout.base & PAGE_MASK;
+	max_page_addr = (unsigned long)mod->core_layout.base +
+				       mod->core_layout.text_size;
+	max_page_addr &= PAGE_MASK;
+
+	for (ptr = min_page_addr; ptr <= max_page_addr; ptr += PAGE_SIZE) {
+		int index = ptr_to_shadow(s, ptr);
+		if (index >= 0)
+			s->shadow[index] = SHADOW_INVALID;
+	}
+}
+
+typedef void (*update_shadow_fn)(struct cfi_shadow *, struct module *);
+
+static void update_shadow(struct module *mod, unsigned long min_addr,
+	unsigned long max_addr, update_shadow_fn fn)
+{
+	struct cfi_shadow *prev;
+	struct cfi_shadow *next = (struct cfi_shadow *)
+		__get_free_pages(GFP_KERNEL, SHADOW_ORDER);
+
+	BUG_ON(!next);
+
+	next->r.mod_min_addr = min_addr;
+	next->r.mod_max_addr = max_addr;
+	next->r.min_page = min_addr >> PAGE_SHIFT;
+	next->r.max_page = max_addr >> PAGE_SHIFT;
+
+	spin_lock(&shadow_update_lock);
+	prev = rcu_dereference_protected(cfi_shadow, 1);
+	prepare_next_shadow(prev, next);
+
+	fn(next, mod);
+	set_memory_ro((unsigned long)next, SHADOW_PAGES);
+	rcu_assign_pointer(cfi_shadow, next);
+
+	spin_unlock(&shadow_update_lock);
+	synchronize_rcu();
+
+	if (prev) {
+		set_memory_rw((unsigned long)prev, SHADOW_PAGES);
+		free_pages((unsigned long)prev, SHADOW_ORDER);
+	}
+}
+
+void cfi_module_add(struct module *mod, unsigned long min_addr,
+	unsigned long max_addr)
+{
+	update_shadow(mod, min_addr, max_addr, add_module_to_shadow);
+}
+EXPORT_SYMBOL(cfi_module_add);
+
+void cfi_module_remove(struct module *mod, unsigned long min_addr,
+	unsigned long max_addr)
+{
+	update_shadow(mod, min_addr, max_addr, remove_module_from_shadow);
+}
+EXPORT_SYMBOL(cfi_module_remove);
+
+static inline cfi_check_fn ptr_to_check_fn(const struct cfi_shadow __rcu *s,
+	unsigned long ptr)
+{
+	int index;
+	unsigned long check;
+
+	if (unlikely(!s))
+		return NULL; /* No shadow available */
+
+	if (ptr < s->r.mod_min_addr || ptr > s->r.mod_max_addr)
+		return NULL; /* Not in a mapped module */
+
+	index = ptr_to_shadow(s, ptr);
+	if (index < 0)
+		return NULL; /* Cannot be addressed with shadow */
+
+	return (cfi_check_fn)shadow_to_ptr(s, index);
+}
+#endif /* CONFIG_CFI_CLANG_SHADOW */
+
+static inline cfi_check_fn find_module_cfi_check(void *ptr)
+{
+	struct module *mod;
+
+	preempt_disable();
+	mod = __module_address((unsigned long)ptr);
+	preempt_enable();
+
+	if (mod)
+		return mod->cfi_check;
+
+	return CFI_CHECK_FN;
+}
+
+static inline cfi_check_fn find_cfi_check(void *ptr)
+{
+#ifdef CONFIG_CFI_CLANG_SHADOW
+	cfi_check_fn f;
+
+	if (!rcu_access_pointer(cfi_shadow))
+		return CFI_CHECK_FN; /* No loaded modules */
+
+	/* Look up the __cfi_check function to use */
+	rcu_read_lock();
+	f = ptr_to_check_fn(rcu_dereference(cfi_shadow), (unsigned long)ptr);
+	rcu_read_unlock();
+
+	if (f)
+		return f;
+
+	/*
+	 * Fall back to find_module_cfi_check, which works also for a larger
+	 * module address space, but is slower.
+	 */
+#endif /* CONFIG_CFI_CLANG_SHADOW */
+
+	return find_module_cfi_check(ptr);
+}
+
+void cfi_slowpath_handler(uint64_t id, void *ptr, void *diag)
+{
+	cfi_check_fn check = find_cfi_check(ptr);
+
+	if (likely(check))
+		check(id, ptr, diag);
+	else /* Don't allow unchecked modules */
+		handle_cfi_failure(ptr);
+}
+EXPORT_SYMBOL(cfi_slowpath_handler);
+#endif /* CONFIG_MODULES */
+
+void cfi_failure_handler(void *data, void *ptr, void *vtable)
+{
+	handle_cfi_failure(ptr);
+}
+EXPORT_SYMBOL(cfi_failure_handler);
+
+void __cfi_check_fail(void *data, void *ptr)
+{
+	handle_cfi_failure(ptr);
+}
diff --git a/kernel/cgroup.c b/kernel/cgroup.c
index 4c23343..2c05146 100644
--- a/kernel/cgroup.c
+++ b/kernel/cgroup.c
@@ -2856,7 +2856,8 @@ static int cgroup_procs_write_permission(struct task_struct *task,
 	 */
 	if (!uid_eq(cred->euid, GLOBAL_ROOT_UID) &&
 	    !uid_eq(cred->euid, tcred->uid) &&
-	    !uid_eq(cred->euid, tcred->suid))
+	    !uid_eq(cred->euid, tcred->suid) &&
+	    !ns_capable(tcred->user_ns, CAP_SYS_NICE))
 		ret = -EACCES;
 
 	if (!ret && cgroup_on_dfl(dst_cgrp)) {
@@ -5075,6 +5076,8 @@ static void css_release_work_fn(struct work_struct *work)
 		if (cgrp->kn)
 			RCU_INIT_POINTER(*(void __rcu __force **)&cgrp->kn->priv,
 					 NULL);
+
+		cgroup_bpf_put(cgrp);
 	}
 
 	mutex_unlock(&cgroup_mutex);
@@ -5287,6 +5290,9 @@ static struct cgroup *cgroup_create(struct cgroup *parent)
 	if (!cgroup_on_dfl(cgrp))
 		cgrp->subtree_control = cgroup_control(cgrp);
 
+	if (parent)
+		cgroup_bpf_inherit(cgrp, parent);
+
 	cgroup_propagate_control(cgrp);
 
 	return cgrp;
@@ -6502,6 +6508,20 @@ static __init int cgroup_namespaces_init(void)
 }
 subsys_initcall(cgroup_namespaces_init);
 
+#ifdef CONFIG_CGROUP_BPF
+int cgroup_bpf_update(struct cgroup *cgrp, struct bpf_prog *prog,
+		      enum bpf_attach_type type, bool overridable)
+{
+	struct cgroup *parent = cgroup_parent(cgrp);
+	int ret;
+
+	mutex_lock(&cgroup_mutex);
+	ret = __cgroup_bpf_update(cgrp, parent, prog, type, overridable);
+	mutex_unlock(&cgroup_mutex);
+	return ret;
+}
+#endif /* CONFIG_CGROUP_BPF */
+
 #ifdef CONFIG_CGROUP_DEBUG
 static struct cgroup_subsys_state *
 debug_css_alloc(struct cgroup_subsys_state *parent_css)
@@ -6580,7 +6600,7 @@ static int cgroup_css_links_read(struct seq_file *seq, void *v)
 		struct task_struct *task;
 		int count = 0;
 
-		seq_printf(seq, "css_set %p\n", cset);
+		seq_printf(seq, "css_set %pK\n", cset);
 
 		list_for_each_entry(task, &cset->tasks, cg_list) {
 			if (count++ > MAX_TASKS_SHOWN_PER_CSS)
diff --git a/kernel/configs/android-base.config b/kernel/configs/android-base.config
deleted file mode 100644
index 1a8f34f..00000000
--- a/kernel/configs/android-base.config
+++ /dev/null
@@ -1,149 +0,0 @@
-#  KEEP ALPHABETICALLY SORTED
-# CONFIG_DEVKMEM is not set
-# CONFIG_DEVMEM is not set
-# CONFIG_INET_LRO is not set
-# CONFIG_MODULES is not set
-# CONFIG_OABI_COMPAT is not set
-# CONFIG_SYSVIPC is not set
-CONFIG_ANDROID=y
-CONFIG_ANDROID_BINDER_IPC=y
-CONFIG_ANDROID_LOW_MEMORY_KILLER=y
-CONFIG_ARMV8_DEPRECATED=y
-CONFIG_ASHMEM=y
-CONFIG_AUDIT=y
-CONFIG_BLK_DEV_INITRD=y
-CONFIG_CGROUPS=y
-CONFIG_CGROUP_CPUACCT=y
-CONFIG_CGROUP_DEBUG=y
-CONFIG_CGROUP_FREEZER=y
-CONFIG_CGROUP_SCHED=y
-CONFIG_CP15_BARRIER_EMULATION=y
-CONFIG_DEFAULT_SECURITY_SELINUX=y
-CONFIG_EMBEDDED=y
-CONFIG_FB=y
-CONFIG_HIGH_RES_TIMERS=y
-CONFIG_INET6_AH=y
-CONFIG_INET6_ESP=y
-CONFIG_INET6_IPCOMP=y
-CONFIG_INET=y
-CONFIG_INET_DIAG_DESTROY=y
-CONFIG_INET_ESP=y
-CONFIG_INET_XFRM_MODE_TUNNEL=y
-CONFIG_IP6_NF_FILTER=y
-CONFIG_IP6_NF_IPTABLES=y
-CONFIG_IP6_NF_MANGLE=y
-CONFIG_IP6_NF_RAW=y
-CONFIG_IP6_NF_TARGET_REJECT=y
-CONFIG_IPV6=y
-CONFIG_IPV6_MIP6=y
-CONFIG_IPV6_MULTIPLE_TABLES=y
-CONFIG_IPV6_OPTIMISTIC_DAD=y
-CONFIG_IPV6_ROUTER_PREF=y
-CONFIG_IPV6_ROUTE_INFO=y
-CONFIG_IP_ADVANCED_ROUTER=y
-CONFIG_IP_MULTICAST=y
-CONFIG_IP_MULTIPLE_TABLES=y
-CONFIG_IP_NF_ARPFILTER=y
-CONFIG_IP_NF_ARPTABLES=y
-CONFIG_IP_NF_ARP_MANGLE=y
-CONFIG_IP_NF_FILTER=y
-CONFIG_IP_NF_IPTABLES=y
-CONFIG_IP_NF_MANGLE=y
-CONFIG_IP_NF_MATCH_AH=y
-CONFIG_IP_NF_MATCH_ECN=y
-CONFIG_IP_NF_MATCH_TTL=y
-CONFIG_IP_NF_NAT=y
-CONFIG_IP_NF_RAW=y
-CONFIG_IP_NF_SECURITY=y
-CONFIG_IP_NF_TARGET_MASQUERADE=y
-CONFIG_IP_NF_TARGET_NETMAP=y
-CONFIG_IP_NF_TARGET_REDIRECT=y
-CONFIG_IP_NF_TARGET_REJECT=y
-CONFIG_NET=y
-CONFIG_NETDEVICES=y
-CONFIG_NETFILTER=y
-CONFIG_NETFILTER_TPROXY=y
-CONFIG_NETFILTER_XT_MATCH_COMMENT=y
-CONFIG_NETFILTER_XT_MATCH_CONNLIMIT=y
-CONFIG_NETFILTER_XT_MATCH_CONNMARK=y
-CONFIG_NETFILTER_XT_MATCH_CONNTRACK=y
-CONFIG_NETFILTER_XT_MATCH_HASHLIMIT=y
-CONFIG_NETFILTER_XT_MATCH_HELPER=y
-CONFIG_NETFILTER_XT_MATCH_IPRANGE=y
-CONFIG_NETFILTER_XT_MATCH_LENGTH=y
-CONFIG_NETFILTER_XT_MATCH_LIMIT=y
-CONFIG_NETFILTER_XT_MATCH_MAC=y
-CONFIG_NETFILTER_XT_MATCH_MARK=y
-CONFIG_NETFILTER_XT_MATCH_PKTTYPE=y
-CONFIG_NETFILTER_XT_MATCH_POLICY=y
-CONFIG_NETFILTER_XT_MATCH_QUOTA=y
-CONFIG_NETFILTER_XT_MATCH_SOCKET=y
-CONFIG_NETFILTER_XT_MATCH_STATE=y
-CONFIG_NETFILTER_XT_MATCH_STATISTIC=y
-CONFIG_NETFILTER_XT_MATCH_STRING=y
-CONFIG_NETFILTER_XT_MATCH_TIME=y
-CONFIG_NETFILTER_XT_MATCH_U32=y
-CONFIG_NETFILTER_XT_TARGET_CLASSIFY=y
-CONFIG_NETFILTER_XT_TARGET_CONNMARK=y
-CONFIG_NETFILTER_XT_TARGET_CONNSECMARK=y
-CONFIG_NETFILTER_XT_TARGET_IDLETIMER=y
-CONFIG_NETFILTER_XT_TARGET_MARK=y
-CONFIG_NETFILTER_XT_TARGET_NFLOG=y
-CONFIG_NETFILTER_XT_TARGET_NFQUEUE=y
-CONFIG_NETFILTER_XT_TARGET_SECMARK=y
-CONFIG_NETFILTER_XT_TARGET_TCPMSS=y
-CONFIG_NETFILTER_XT_TARGET_TPROXY=y
-CONFIG_NETFILTER_XT_TARGET_TRACE=y
-CONFIG_NET_CLS_ACT=y
-CONFIG_NET_CLS_U32=y
-CONFIG_NET_EMATCH=y
-CONFIG_NET_EMATCH_U32=y
-CONFIG_NET_KEY=y
-CONFIG_NET_SCHED=y
-CONFIG_NET_SCH_HTB=y
-CONFIG_NF_CONNTRACK=y
-CONFIG_NF_CONNTRACK_AMANDA=y
-CONFIG_NF_CONNTRACK_EVENTS=y
-CONFIG_NF_CONNTRACK_FTP=y
-CONFIG_NF_CONNTRACK_H323=y
-CONFIG_NF_CONNTRACK_IPV4=y
-CONFIG_NF_CONNTRACK_IPV6=y
-CONFIG_NF_CONNTRACK_IRC=y
-CONFIG_NF_CONNTRACK_NETBIOS_NS=y
-CONFIG_NF_CONNTRACK_PPTP=y
-CONFIG_NF_CONNTRACK_SANE=y
-CONFIG_NF_CONNTRACK_SECMARK=y
-CONFIG_NF_CONNTRACK_TFTP=y
-CONFIG_NF_CT_NETLINK=y
-CONFIG_NF_CT_PROTO_DCCP=y
-CONFIG_NF_CT_PROTO_SCTP=y
-CONFIG_NF_CT_PROTO_UDPLITE=y
-CONFIG_NF_NAT=y
-CONFIG_NO_HZ=y
-CONFIG_PACKET=y
-CONFIG_PM_AUTOSLEEP=y
-CONFIG_PM_WAKELOCKS=y
-CONFIG_PPP=y
-CONFIG_PPP_BSDCOMP=y
-CONFIG_PPP_DEFLATE=y
-CONFIG_PPP_MPPE=y
-CONFIG_PREEMPT=y
-CONFIG_QUOTA=y
-CONFIG_RTC_CLASS=y
-CONFIG_RT_GROUP_SCHED=y
-CONFIG_SECCOMP=y
-CONFIG_SECURITY=y
-CONFIG_SECURITY_NETWORK=y
-CONFIG_SECURITY_SELINUX=y
-CONFIG_SETEND_EMULATION=y
-CONFIG_STAGING=y
-CONFIG_SWP_EMULATION=y
-CONFIG_SYNC=y
-CONFIG_TUN=y
-CONFIG_UNIX=y
-CONFIG_USB_GADGET=y
-CONFIG_USB_CONFIGFS=y
-CONFIG_USB_CONFIGFS_F_FS=y
-CONFIG_USB_CONFIGFS_F_MIDI=y
-CONFIG_USB_OTG_WAKELOCK=y
-CONFIG_XFRM_USER=y
diff --git a/kernel/configs/android-fetch-configs.sh b/kernel/configs/android-fetch-configs.sh
new file mode 100755
index 00000000..a5b56d4
--- /dev/null
+++ b/kernel/configs/android-fetch-configs.sh
@@ -0,0 +1,4 @@
+#!/bin/sh
+
+curl https://android.googlesource.com/kernel/configs/+archive/master/android-4.9.tar.gz | tar xzv
+
diff --git a/kernel/configs/android-recommended.config b/kernel/configs/android-recommended.config
deleted file mode 100644
index 297756b..00000000
--- a/kernel/configs/android-recommended.config
+++ /dev/null
@@ -1,125 +0,0 @@
-#  KEEP ALPHABETICALLY SORTED
-# CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS is not set
-# CONFIG_INPUT_MOUSE is not set
-# CONFIG_LEGACY_PTYS is not set
-# CONFIG_NF_CONNTRACK_SIP is not set
-# CONFIG_PM_WAKELOCKS_GC is not set
-# CONFIG_VT is not set
-CONFIG_BACKLIGHT_LCD_SUPPORT=y
-CONFIG_BLK_DEV_DM=y
-CONFIG_BLK_DEV_LOOP=y
-CONFIG_BLK_DEV_RAM=y
-CONFIG_BLK_DEV_RAM_SIZE=8192
-CONFIG_COMPACTION=y
-CONFIG_DEBUG_RODATA=y
-CONFIG_DM_CRYPT=y
-CONFIG_DM_UEVENT=y
-CONFIG_DM_VERITY=y
-CONFIG_DM_VERITY_FEC=y
-CONFIG_DRAGONRISE_FF=y
-CONFIG_ENABLE_DEFAULT_TRACERS=y
-CONFIG_EXT4_FS=y
-CONFIG_EXT4_FS_SECURITY=y
-CONFIG_FUSE_FS=y
-CONFIG_GREENASIA_FF=y
-CONFIG_HIDRAW=y
-CONFIG_HID_A4TECH=y
-CONFIG_HID_ACRUX=y
-CONFIG_HID_ACRUX_FF=y
-CONFIG_HID_APPLE=y
-CONFIG_HID_BELKIN=y
-CONFIG_HID_CHERRY=y
-CONFIG_HID_CHICONY=y
-CONFIG_HID_CYPRESS=y
-CONFIG_HID_DRAGONRISE=y
-CONFIG_HID_ELECOM=y
-CONFIG_HID_EMS_FF=y
-CONFIG_HID_EZKEY=y
-CONFIG_HID_GREENASIA=y
-CONFIG_HID_GYRATION=y
-CONFIG_HID_HOLTEK=y
-CONFIG_HID_KENSINGTON=y
-CONFIG_HID_KEYTOUCH=y
-CONFIG_HID_KYE=y
-CONFIG_HID_LCPOWER=y
-CONFIG_HID_LOGITECH=y
-CONFIG_HID_LOGITECH_DJ=y
-CONFIG_HID_MAGICMOUSE=y
-CONFIG_HID_MICROSOFT=y
-CONFIG_HID_MONTEREY=y
-CONFIG_HID_MULTITOUCH=y
-CONFIG_HID_NTRIG=y
-CONFIG_HID_ORTEK=y
-CONFIG_HID_PANTHERLORD=y
-CONFIG_HID_PETALYNX=y
-CONFIG_HID_PICOLCD=y
-CONFIG_HID_PRIMAX=y
-CONFIG_HID_PRODIKEYS=y
-CONFIG_HID_ROCCAT=y
-CONFIG_HID_SAITEK=y
-CONFIG_HID_SAMSUNG=y
-CONFIG_HID_SMARTJOYPLUS=y
-CONFIG_HID_SONY=y
-CONFIG_HID_SPEEDLINK=y
-CONFIG_HID_SUNPLUS=y
-CONFIG_HID_THRUSTMASTER=y
-CONFIG_HID_TIVO=y
-CONFIG_HID_TOPSEED=y
-CONFIG_HID_TWINHAN=y
-CONFIG_HID_UCLOGIC=y
-CONFIG_HID_WACOM=y
-CONFIG_HID_WALTOP=y
-CONFIG_HID_WIIMOTE=y
-CONFIG_HID_ZEROPLUS=y
-CONFIG_HID_ZYDACRON=y
-CONFIG_INPUT_EVDEV=y
-CONFIG_INPUT_GPIO=y
-CONFIG_INPUT_JOYSTICK=y
-CONFIG_INPUT_MISC=y
-CONFIG_INPUT_TABLET=y
-CONFIG_INPUT_UINPUT=y
-CONFIG_ION=y
-CONFIG_JOYSTICK_XPAD=y
-CONFIG_JOYSTICK_XPAD_FF=y
-CONFIG_JOYSTICK_XPAD_LEDS=y
-CONFIG_KALLSYMS_ALL=y
-CONFIG_KSM=y
-CONFIG_LOGIG940_FF=y
-CONFIG_LOGIRUMBLEPAD2_FF=y
-CONFIG_LOGITECH_FF=y
-CONFIG_MD=y
-CONFIG_MEDIA_SUPPORT=y
-CONFIG_MSDOS_FS=y
-CONFIG_PANIC_TIMEOUT=5
-CONFIG_PANTHERLORD_FF=y
-CONFIG_PERF_EVENTS=y
-CONFIG_PM_DEBUG=y
-CONFIG_PM_RUNTIME=y
-CONFIG_PM_WAKELOCKS_LIMIT=0
-CONFIG_POWER_SUPPLY=y
-CONFIG_PSTORE=y
-CONFIG_PSTORE_CONSOLE=y
-CONFIG_PSTORE_RAM=y
-CONFIG_SCHEDSTATS=y
-CONFIG_SMARTJOYPLUS_FF=y
-CONFIG_SND=y
-CONFIG_SOUND=y
-CONFIG_SUSPEND_TIME=y
-CONFIG_TABLET_USB_ACECAD=y
-CONFIG_TABLET_USB_AIPTEK=y
-CONFIG_TABLET_USB_GTCO=y
-CONFIG_TABLET_USB_HANWANG=y
-CONFIG_TABLET_USB_KBTAB=y
-CONFIG_TASKSTATS=y
-CONFIG_TASK_DELAY_ACCT=y
-CONFIG_TASK_IO_ACCOUNTING=y
-CONFIG_TASK_XACCT=y
-CONFIG_TIMER_STATS=y
-CONFIG_TMPFS=y
-CONFIG_TMPFS_POSIX_ACL=y
-CONFIG_UHID=y
-CONFIG_USB_ANNOUNCE_NEW_DEVICES=y
-CONFIG_USB_EHCI_HCD=y
-CONFIG_USB_HIDDEV=y
-CONFIG_USB_USBNET=y
-CONFIG_VFAT_FS=y
diff --git a/kernel/cpu.c b/kernel/cpu.c
index 967163f..3800880 100644
--- a/kernel/cpu.c
+++ b/kernel/cpu.c
@@ -1133,6 +1133,7 @@ int freeze_secondary_cpus(int primary)
 			continue;
 		trace_suspend_resume(TPS("CPU_OFF"), cpu, true);
 		error = _cpu_down(cpu, 1, CPUHP_OFFLINE);
+
 		trace_suspend_resume(TPS("CPU_OFF"), cpu, false);
 		if (!error)
 			cpumask_set_cpu(cpu, frozen_cpus);
@@ -1169,6 +1170,7 @@ void __weak arch_enable_nonboot_cpus_end(void)
 void enable_nonboot_cpus(void)
 {
 	int cpu, error;
+	struct device *cpu_device;
 
 	/* Allow everyone to use the CPU hotplug again */
 	cpu_maps_update_begin();
@@ -1186,6 +1188,12 @@ void enable_nonboot_cpus(void)
 		trace_suspend_resume(TPS("CPU_ON"), cpu, false);
 		if (!error) {
 			pr_info("CPU%d is up\n", cpu);
+			cpu_device = get_cpu_device(cpu);
+			if (!cpu_device)
+				pr_err("%s: failed to get cpu%d device\n",
+				       __func__, cpu);
+			else
+				kobject_uevent(&cpu_device->kobj, KOBJ_ONLINE);
 			continue;
 		}
 		pr_warn("Error taking CPU%d up: %d\n", cpu, error);
@@ -1948,3 +1956,23 @@ void __init boot_cpu_state_init(void)
 {
 	per_cpu_ptr(&cpuhp_state, smp_processor_id())->state = CPUHP_ONLINE;
 }
+
+static ATOMIC_NOTIFIER_HEAD(idle_notifier);
+
+void idle_notifier_register(struct notifier_block *n)
+{
+	atomic_notifier_chain_register(&idle_notifier, n);
+}
+EXPORT_SYMBOL_GPL(idle_notifier_register);
+
+void idle_notifier_unregister(struct notifier_block *n)
+{
+	atomic_notifier_chain_unregister(&idle_notifier, n);
+}
+EXPORT_SYMBOL_GPL(idle_notifier_unregister);
+
+void idle_notifier_call_chain(unsigned long val)
+{
+	atomic_notifier_call_chain(&idle_notifier, val, NULL);
+}
+EXPORT_SYMBOL_GPL(idle_notifier_call_chain);
diff --git a/kernel/cpuset.c b/kernel/cpuset.c
index 511b1dd..194e2f2 100644
--- a/kernel/cpuset.c
+++ b/kernel/cpuset.c
@@ -100,6 +100,7 @@ struct cpuset {
 
 	/* user-configured CPUs and Memory Nodes allow to tasks */
 	cpumask_var_t cpus_allowed;
+	cpumask_var_t cpus_requested;
 	nodemask_t mems_allowed;
 
 	/* effective CPUs and Memory Nodes allow to tasks */
@@ -399,7 +400,7 @@ static void cpuset_update_task_spread_flag(struct cpuset *cs,
 
 static int is_cpuset_subset(const struct cpuset *p, const struct cpuset *q)
 {
-	return	cpumask_subset(p->cpus_allowed, q->cpus_allowed) &&
+	return	cpumask_subset(p->cpus_requested, q->cpus_requested) &&
 		nodes_subset(p->mems_allowed, q->mems_allowed) &&
 		is_cpu_exclusive(p) <= is_cpu_exclusive(q) &&
 		is_mem_exclusive(p) <= is_mem_exclusive(q);
@@ -499,7 +500,7 @@ static int validate_change(struct cpuset *cur, struct cpuset *trial)
 	cpuset_for_each_child(c, css, par) {
 		if ((is_cpu_exclusive(trial) || is_cpu_exclusive(c)) &&
 		    c != cur &&
-		    cpumask_intersects(trial->cpus_allowed, c->cpus_allowed))
+		    cpumask_intersects(trial->cpus_requested, c->cpus_requested))
 			goto out;
 		if ((is_mem_exclusive(trial) || is_mem_exclusive(c)) &&
 		    c != cur &&
@@ -958,17 +959,18 @@ static int update_cpumask(struct cpuset *cs, struct cpuset *trialcs,
 	if (!*buf) {
 		cpumask_clear(trialcs->cpus_allowed);
 	} else {
-		retval = cpulist_parse(buf, trialcs->cpus_allowed);
+		retval = cpulist_parse(buf, trialcs->cpus_requested);
 		if (retval < 0)
 			return retval;
 
-		if (!cpumask_subset(trialcs->cpus_allowed,
-				    top_cpuset.cpus_allowed))
+		if (!cpumask_subset(trialcs->cpus_requested, cpu_present_mask))
 			return -EINVAL;
+
+		cpumask_and(trialcs->cpus_allowed, trialcs->cpus_requested, cpu_active_mask);
 	}
 
 	/* Nothing to do if the cpus didn't change */
-	if (cpumask_equal(cs->cpus_allowed, trialcs->cpus_allowed))
+	if (cpumask_equal(cs->cpus_requested, trialcs->cpus_requested))
 		return 0;
 
 	retval = validate_change(cs, trialcs);
@@ -977,6 +979,7 @@ static int update_cpumask(struct cpuset *cs, struct cpuset *trialcs,
 
 	spin_lock_irq(&callback_lock);
 	cpumask_copy(cs->cpus_allowed, trialcs->cpus_allowed);
+	cpumask_copy(cs->cpus_requested, trialcs->cpus_requested);
 	spin_unlock_irq(&callback_lock);
 
 	/* use trialcs->cpus_allowed as a temp variable */
@@ -1761,7 +1764,7 @@ static int cpuset_common_seq_show(struct seq_file *sf, void *v)
 
 	switch (type) {
 	case FILE_CPULIST:
-		seq_printf(sf, "%*pbl\n", cpumask_pr_args(cs->cpus_allowed));
+		seq_printf(sf, "%*pbl\n", cpumask_pr_args(cs->cpus_requested));
 		break;
 	case FILE_MEMLIST:
 		seq_printf(sf, "%*pbl\n", nodemask_pr_args(&cs->mems_allowed));
@@ -1951,11 +1954,14 @@ static s64 cpuset_read_s64(struct cgroup_subsys_state *css, struct cftype *cft)
 		return ERR_PTR(-ENOMEM);
 	if (!alloc_cpumask_var(&cs->cpus_allowed, GFP_KERNEL))
 		goto free_cs;
+	if (!alloc_cpumask_var(&cs->cpus_requested, GFP_KERNEL))
+		goto free_allowed;
 	if (!alloc_cpumask_var(&cs->effective_cpus, GFP_KERNEL))
-		goto free_cpus;
+		goto free_requested;
 
 	set_bit(CS_SCHED_LOAD_BALANCE, &cs->flags);
 	cpumask_clear(cs->cpus_allowed);
+	cpumask_clear(cs->cpus_requested);
 	nodes_clear(cs->mems_allowed);
 	cpumask_clear(cs->effective_cpus);
 	nodes_clear(cs->effective_mems);
@@ -1964,7 +1970,9 @@ static s64 cpuset_read_s64(struct cgroup_subsys_state *css, struct cftype *cft)
 
 	return &cs->css;
 
-free_cpus:
+free_requested:
+	free_cpumask_var(cs->cpus_requested);
+free_allowed:
 	free_cpumask_var(cs->cpus_allowed);
 free_cs:
 	kfree(cs);
@@ -2027,6 +2035,7 @@ static int cpuset_css_online(struct cgroup_subsys_state *css)
 	cs->mems_allowed = parent->mems_allowed;
 	cs->effective_mems = parent->mems_allowed;
 	cpumask_copy(cs->cpus_allowed, parent->cpus_allowed);
+	cpumask_copy(cs->cpus_requested, parent->cpus_requested);
 	cpumask_copy(cs->effective_cpus, parent->cpus_allowed);
 	spin_unlock_irq(&callback_lock);
 out_unlock:
@@ -2061,6 +2070,7 @@ static void cpuset_css_free(struct cgroup_subsys_state *css)
 
 	free_cpumask_var(cs->effective_cpus);
 	free_cpumask_var(cs->cpus_allowed);
+	free_cpumask_var(cs->cpus_requested);
 	kfree(cs);
 }
 
@@ -2125,8 +2135,11 @@ int __init cpuset_init(void)
 		BUG();
 	if (!alloc_cpumask_var(&top_cpuset.effective_cpus, GFP_KERNEL))
 		BUG();
+	if (!alloc_cpumask_var(&top_cpuset.cpus_requested, GFP_KERNEL))
+		BUG();
 
 	cpumask_setall(top_cpuset.cpus_allowed);
+	cpumask_setall(top_cpuset.cpus_requested);
 	nodes_setall(top_cpuset.mems_allowed);
 	cpumask_setall(top_cpuset.effective_cpus);
 	nodes_setall(top_cpuset.effective_mems);
@@ -2260,7 +2273,7 @@ static void cpuset_hotplug_update_tasks(struct cpuset *cs)
 		goto retry;
 	}
 
-	cpumask_and(&new_cpus, cs->cpus_allowed, parent_cs(cs)->effective_cpus);
+	cpumask_and(&new_cpus, cs->cpus_requested, parent_cs(cs)->effective_cpus);
 	nodes_and(new_mems, cs->mems_allowed, parent_cs(cs)->effective_mems);
 
 	cpus_updated = !cpumask_equal(&new_cpus, cs->effective_cpus);
diff --git a/kernel/debug/kdb/kdb_io.c b/kernel/debug/kdb/kdb_io.c
index 77777d9..3990c1f 100644
--- a/kernel/debug/kdb/kdb_io.c
+++ b/kernel/debug/kdb/kdb_io.c
@@ -216,7 +216,7 @@ static char *kdb_read(char *buffer, size_t bufsize)
 	int i;
 	int diag, dtab_count;
 	int key;
-
+	static int last_crlf;
 
 	diag = kdbgetintenv("DTABCOUNT", &dtab_count);
 	if (diag)
@@ -237,6 +237,9 @@ static char *kdb_read(char *buffer, size_t bufsize)
 		return buffer;
 	if (key != 9)
 		tab = 0;
+	if (key != 10 && key != 13)
+		last_crlf = 0;
+
 	switch (key) {
 	case 8: /* backspace */
 		if (cp > buffer) {
@@ -254,7 +257,12 @@ static char *kdb_read(char *buffer, size_t bufsize)
 			*cp = tmp;
 		}
 		break;
-	case 13: /* enter */
+	case 10: /* new line */
+	case 13: /* carriage return */
+		/* handle \n after \r */
+		if (last_crlf && last_crlf != key)
+			break;
+		last_crlf = key;
 		*lastchar++ = '\n';
 		*lastchar++ = '\0';
 		if (!KDB_STATE(KGDB_TRANS)) {
diff --git a/kernel/events/core.c b/kernel/events/core.c
index 6e6ec22..da172d3 100644
--- a/kernel/events/core.c
+++ b/kernel/events/core.c
@@ -389,8 +389,13 @@ enum event_type_t {
  *   0 - disallow raw tracepoint access for unpriv
  *   1 - disallow cpu events for unpriv
  *   2 - disallow kernel profiling for unpriv
+ *   3 - disallow all unpriv perf event use
  */
+#ifdef CONFIG_SECURITY_PERF_EVENTS_RESTRICT
+int sysctl_perf_event_paranoid __read_mostly = 3;
+#else
 int sysctl_perf_event_paranoid __read_mostly = 2;
+#endif
 
 /* Minimum for 512 kiB + 1 user control page */
 int sysctl_perf_event_mlock __read_mostly = 512 + (PAGE_SIZE / 1024); /* 'free' kiB per user */
@@ -9659,6 +9664,9 @@ static int perf_event_set_clock(struct perf_event *event, clockid_t clk_id)
 	if (flags & ~PERF_FLAG_ALL)
 		return -EINVAL;
 
+	if (perf_paranoid_any() && !capable(CAP_SYS_ADMIN))
+		return -EACCES;
+
 	err = perf_copy_attr(attr_uptr, &attr);
 	if (err)
 		return err;
diff --git a/kernel/exit.c b/kernel/exit.c
index 6dd7ff4..61921bc 100644
--- a/kernel/exit.c
+++ b/kernel/exit.c
@@ -55,6 +55,8 @@
 #include <linux/shm.h>
 #include <linux/kcov.h>
 
+#include "sched/tune.h"
+
 #include <asm/uaccess.h>
 #include <asm/unistd.h>
 #include <asm/pgtable.h>
@@ -775,6 +777,9 @@ void __noreturn do_exit(long code)
 	}
 
 	exit_signals(tsk);  /* sets PF_EXITING */
+
+	schedtune_exit_task(tsk);
+
 	/*
 	 * Ensure that all new tsk->pi_lock acquisitions must observe
 	 * PF_EXITING. Serializes against futex.c:attach_to_pi_owner().
diff --git a/kernel/fork.c b/kernel/fork.c
index 2c98b98..16efa64 100644
--- a/kernel/fork.c
+++ b/kernel/fork.c
@@ -77,6 +77,7 @@
 #include <linux/compiler.h>
 #include <linux/sysctl.h>
 #include <linux/kcov.h>
+#include <linux/cpufreq_times.h>
 
 #include <asm/pgtable.h>
 #include <asm/pgalloc.h>
@@ -111,6 +112,7 @@
 DEFINE_PER_CPU(unsigned long, process_counts) = 0;
 
 __cacheline_aligned DEFINE_RWLOCK(tasklist_lock);  /* outer */
+EXPORT_SYMBOL(tasklist_lock);
 
 #ifdef CONFIG_PROVE_RCU
 int lockdep_tasklist_lock_is_held(void)
@@ -342,6 +344,8 @@ void put_task_stack(struct task_struct *tsk)
 
 void free_task(struct task_struct *tsk)
 {
+	cpufreq_task_times_exit(tsk);
+
 #ifndef CONFIG_THREAD_INFO_IN_TASK
 	/*
 	 * The task is finally done with both the stack and thread_info,
@@ -1530,6 +1534,8 @@ static __latent_entropy struct task_struct *copy_process(
 	if (!p)
 		goto fork_out;
 
+	cpufreq_task_times_init(p);
+
 	ftrace_graph_init_task(p);
 
 	rt_mutex_init_task(p);
@@ -1966,6 +1972,8 @@ long _do_fork(unsigned long clone_flags,
 		struct completion vfork;
 		struct pid *pid;
 
+		cpufreq_task_times_alloc(p);
+
 		trace_sched_process_fork(current, p);
 
 		pid = get_task_pid(p, PIDTYPE_PID);
diff --git a/kernel/kallsyms.c b/kernel/kallsyms.c
index fafd1a3..a0c3365 100644
--- a/kernel/kallsyms.c
+++ b/kernel/kallsyms.c
@@ -306,6 +306,24 @@ int kallsyms_lookup_size_offset(unsigned long addr, unsigned long *symbolsize,
 	return !!module_address_lookup(addr, symbolsize, offset, NULL, namebuf);
 }
 
+#ifdef CONFIG_CFI_CLANG
+/*
+ * LLVM appends .cfi to function names when CONFIG_CFI_CLANG is enabled,
+ * which causes confusion and potentially breaks user space tools, so we
+ * will strip the postfix from expanded symbol names.
+ */
+static inline void cleanup_symbol_name(char *s)
+{
+	char *res;
+
+	res = strrchr(s, '.');
+	if (res && !strcmp(res, ".cfi"))
+		*res = '\0';
+}
+#else
+static inline void cleanup_symbol_name(char *s) {}
+#endif
+
 /*
  * Lookup an address
  * - modname is set to NULL if it's in the kernel.
@@ -330,16 +348,23 @@ const char *kallsyms_lookup(unsigned long addr,
 				       namebuf, KSYM_NAME_LEN);
 		if (modname)
 			*modname = NULL;
-		return namebuf;
+		goto found;
 	}
 
 	/* See if it's in a module. */
-	return module_address_lookup(addr, symbolsize, offset, modname,
-				     namebuf);
+	if (!module_address_lookup(addr, symbolsize, offset, modname,
+				     namebuf))
+		return NULL;
+
+found:
+	cleanup_symbol_name(namebuf);
+	return namebuf;
 }
 
 int lookup_symbol_name(unsigned long addr, char *symname)
 {
+	int res;
+
 	symname[0] = '\0';
 	symname[KSYM_NAME_LEN - 1] = '\0';
 
@@ -350,15 +375,23 @@ int lookup_symbol_name(unsigned long addr, char *symname)
 		/* Grab name */
 		kallsyms_expand_symbol(get_symbol_offset(pos),
 				       symname, KSYM_NAME_LEN);
-		return 0;
+		goto found;
 	}
 	/* See if it's in a module. */
-	return lookup_module_symbol_name(addr, symname);
+	res = lookup_module_symbol_name(addr, symname);
+	if (res)
+		return res;
+
+found:
+	cleanup_symbol_name(symname);
+	return 0;
 }
 
 int lookup_symbol_attrs(unsigned long addr, unsigned long *size,
 			unsigned long *offset, char *modname, char *name)
 {
+	int res;
+
 	name[0] = '\0';
 	name[KSYM_NAME_LEN - 1] = '\0';
 
@@ -370,10 +403,16 @@ int lookup_symbol_attrs(unsigned long addr, unsigned long *size,
 		kallsyms_expand_symbol(get_symbol_offset(pos),
 				       name, KSYM_NAME_LEN);
 		modname[0] = '\0';
-		return 0;
+		goto found;
 	}
 	/* See if it's in a module. */
-	return lookup_module_symbol_attrs(addr, size, offset, modname, name);
+	res = lookup_module_symbol_attrs(addr, size, offset, modname, name);
+	if (res)
+		return res;
+
+found:
+	cleanup_symbol_name(name);
+	return 0;
 }
 
 /* Look up a kernel symbol and return it in a text buffer. */
diff --git a/kernel/kcov.c b/kernel/kcov.c
index b0ec314..fad5144 100644
--- a/kernel/kcov.c
+++ b/kernel/kcov.c
@@ -1,11 +1,16 @@
 #define pr_fmt(fmt) "kcov: " fmt
 
 #define DISABLE_BRANCH_PROFILING
+#include <linux/atomic.h>
 #include <linux/compiler.h>
+#include <linux/errno.h>
+#include <linux/export.h>
 #include <linux/types.h>
 #include <linux/file.h>
 #include <linux/fs.h>
+#include <linux/init.h>
 #include <linux/mm.h>
+#include <linux/preempt.h>
 #include <linux/printk.h>
 #include <linux/sched.h>
 #include <linux/slab.h>
@@ -14,6 +19,10 @@
 #include <linux/debugfs.h>
 #include <linux/uaccess.h>
 #include <linux/kcov.h>
+#include <asm/setup.h>
+
+/* Number of 64-bit words written per one comparison: */
+#define KCOV_WORDS_PER_CMP 4
 
 /*
  * kcov descriptor (one per opened debugfs file).
@@ -21,7 +30,12 @@
  *  - initial state after open()
  *  - then there must be a single ioctl(KCOV_INIT_TRACE) call
  *  - then, mmap() call (several calls are allowed but not useful)
- *  - then, repeated enable/disable for a task (only one task a time allowed)
+ *  - then, ioctl(KCOV_ENABLE, arg), where arg is
+ *	KCOV_TRACE_PC - to trace only the PCs
+ *	or
+ *	KCOV_TRACE_CMP - to trace only the comparison operands
+ *  - then, ioctl(KCOV_DISABLE) to disable the task.
+ * Enabling/disabling ioctls can be repeated (only one task a time allowed).
  */
 struct kcov {
 	/*
@@ -41,6 +55,36 @@ struct kcov {
 	struct task_struct	*t;
 };
 
+static bool check_kcov_mode(enum kcov_mode needed_mode, struct task_struct *t)
+{
+	enum kcov_mode mode;
+
+	/*
+	 * We are interested in code coverage as a function of a syscall inputs,
+	 * so we ignore code executed in interrupts.
+	 */
+	if (!in_task())
+		return false;
+	mode = READ_ONCE(t->kcov_mode);
+	/*
+	 * There is some code that runs in interrupts but for which
+	 * in_interrupt() returns false (e.g. preempt_schedule_irq()).
+	 * READ_ONCE()/barrier() effectively provides load-acquire wrt
+	 * interrupts, there are paired barrier()/WRITE_ONCE() in
+	 * kcov_ioctl_locked().
+	 */
+	barrier();
+	return mode == needed_mode;
+}
+
+static unsigned long canonicalize_ip(unsigned long ip)
+{
+#ifdef CONFIG_RANDOMIZE_BASE
+	ip -= kaslr_offset();
+#endif
+	return ip;
+}
+
 /*
  * Entry point from instrumented code.
  * This is called once per basic-block/edge.
@@ -48,46 +92,139 @@ struct kcov {
 void notrace __sanitizer_cov_trace_pc(void)
 {
 	struct task_struct *t;
-	enum kcov_mode mode;
+	unsigned long *area;
+	unsigned long ip = canonicalize_ip(_RET_IP_);
+	unsigned long pos;
 
 	t = current;
-	/*
-	 * We are interested in code coverage as a function of a syscall inputs,
-	 * so we ignore code executed in interrupts.
-	 * The checks for whether we are in an interrupt are open-coded, because
-	 * 1. We can't use in_interrupt() here, since it also returns true
-	 *    when we are inside local_bh_disable() section.
-	 * 2. We don't want to use (in_irq() | in_serving_softirq() | in_nmi()),
-	 *    since that leads to slower generated code (three separate tests,
-	 *    one for each of the flags).
-	 */
-	if (!t || (preempt_count() & (HARDIRQ_MASK | SOFTIRQ_OFFSET
-							| NMI_MASK)))
+	if (!check_kcov_mode(KCOV_MODE_TRACE_PC, t))
 		return;
-	mode = READ_ONCE(t->kcov_mode);
-	if (mode == KCOV_MODE_TRACE) {
-		unsigned long *area;
-		unsigned long pos;
 
-		/*
-		 * There is some code that runs in interrupts but for which
-		 * in_interrupt() returns false (e.g. preempt_schedule_irq()).
-		 * READ_ONCE()/barrier() effectively provides load-acquire wrt
-		 * interrupts, there are paired barrier()/WRITE_ONCE() in
-		 * kcov_ioctl_locked().
-		 */
-		barrier();
-		area = t->kcov_area;
-		/* The first word is number of subsequent PCs. */
-		pos = READ_ONCE(area[0]) + 1;
-		if (likely(pos < t->kcov_size)) {
-			area[pos] = _RET_IP_;
-			WRITE_ONCE(area[0], pos);
-		}
+	area = t->kcov_area;
+	/* The first 64-bit word is the number of subsequent PCs. */
+	pos = READ_ONCE(area[0]) + 1;
+	if (likely(pos < t->kcov_size)) {
+		area[pos] = ip;
+		WRITE_ONCE(area[0], pos);
 	}
 }
 EXPORT_SYMBOL(__sanitizer_cov_trace_pc);
 
+#ifdef CONFIG_KCOV_ENABLE_COMPARISONS
+static void write_comp_data(u64 type, u64 arg1, u64 arg2, u64 ip)
+{
+	struct task_struct *t;
+	u64 *area;
+	u64 count, start_index, end_pos, max_pos;
+
+	t = current;
+	if (!check_kcov_mode(KCOV_MODE_TRACE_CMP, t))
+		return;
+
+	ip = canonicalize_ip(ip);
+
+	/*
+	 * We write all comparison arguments and types as u64.
+	 * The buffer was allocated for t->kcov_size unsigned longs.
+	 */
+	area = (u64 *)t->kcov_area;
+	max_pos = t->kcov_size * sizeof(unsigned long);
+
+	count = READ_ONCE(area[0]);
+
+	/* Every record is KCOV_WORDS_PER_CMP 64-bit words. */
+	start_index = 1 + count * KCOV_WORDS_PER_CMP;
+	end_pos = (start_index + KCOV_WORDS_PER_CMP) * sizeof(u64);
+	if (likely(end_pos <= max_pos)) {
+		area[start_index] = type;
+		area[start_index + 1] = arg1;
+		area[start_index + 2] = arg2;
+		area[start_index + 3] = ip;
+		WRITE_ONCE(area[0], count + 1);
+	}
+}
+
+void notrace __sanitizer_cov_trace_cmp1(u8 arg1, u8 arg2)
+{
+	write_comp_data(KCOV_CMP_SIZE(0), arg1, arg2, _RET_IP_);
+}
+EXPORT_SYMBOL(__sanitizer_cov_trace_cmp1);
+
+void notrace __sanitizer_cov_trace_cmp2(u16 arg1, u16 arg2)
+{
+	write_comp_data(KCOV_CMP_SIZE(1), arg1, arg2, _RET_IP_);
+}
+EXPORT_SYMBOL(__sanitizer_cov_trace_cmp2);
+
+void notrace __sanitizer_cov_trace_cmp4(u32 arg1, u32 arg2)
+{
+	write_comp_data(KCOV_CMP_SIZE(2), arg1, arg2, _RET_IP_);
+}
+EXPORT_SYMBOL(__sanitizer_cov_trace_cmp4);
+
+void notrace __sanitizer_cov_trace_cmp8(u64 arg1, u64 arg2)
+{
+	write_comp_data(KCOV_CMP_SIZE(3), arg1, arg2, _RET_IP_);
+}
+EXPORT_SYMBOL(__sanitizer_cov_trace_cmp8);
+
+void notrace __sanitizer_cov_trace_const_cmp1(u8 arg1, u8 arg2)
+{
+	write_comp_data(KCOV_CMP_SIZE(0) | KCOV_CMP_CONST, arg1, arg2,
+			_RET_IP_);
+}
+EXPORT_SYMBOL(__sanitizer_cov_trace_const_cmp1);
+
+void notrace __sanitizer_cov_trace_const_cmp2(u16 arg1, u16 arg2)
+{
+	write_comp_data(KCOV_CMP_SIZE(1) | KCOV_CMP_CONST, arg1, arg2,
+			_RET_IP_);
+}
+EXPORT_SYMBOL(__sanitizer_cov_trace_const_cmp2);
+
+void notrace __sanitizer_cov_trace_const_cmp4(u32 arg1, u32 arg2)
+{
+	write_comp_data(KCOV_CMP_SIZE(2) | KCOV_CMP_CONST, arg1, arg2,
+			_RET_IP_);
+}
+EXPORT_SYMBOL(__sanitizer_cov_trace_const_cmp4);
+
+void notrace __sanitizer_cov_trace_const_cmp8(u64 arg1, u64 arg2)
+{
+	write_comp_data(KCOV_CMP_SIZE(3) | KCOV_CMP_CONST, arg1, arg2,
+			_RET_IP_);
+}
+EXPORT_SYMBOL(__sanitizer_cov_trace_const_cmp8);
+
+void notrace __sanitizer_cov_trace_switch(u64 val, u64 *cases)
+{
+	u64 i;
+	u64 count = cases[0];
+	u64 size = cases[1];
+	u64 type = KCOV_CMP_CONST;
+
+	switch (size) {
+	case 8:
+		type |= KCOV_CMP_SIZE(0);
+		break;
+	case 16:
+		type |= KCOV_CMP_SIZE(1);
+		break;
+	case 32:
+		type |= KCOV_CMP_SIZE(2);
+		break;
+	case 64:
+		type |= KCOV_CMP_SIZE(3);
+		break;
+	default:
+		return;
+	}
+	for (i = 0; i < count; i++)
+		write_comp_data(type, cases[i + 2], val, _RET_IP_);
+}
+EXPORT_SYMBOL(__sanitizer_cov_trace_switch);
+#endif /* ifdef CONFIG_KCOV_ENABLE_COMPARISONS */
+
 static void kcov_get(struct kcov *kcov)
 {
 	atomic_inc(&kcov->refcount);
@@ -125,6 +262,7 @@ void kcov_task_exit(struct task_struct *t)
 	/* Just to not leave dangling references behind. */
 	kcov_task_init(t);
 	kcov->t = NULL;
+	kcov->mode = KCOV_MODE_INIT;
 	spin_unlock(&kcov->lock);
 	kcov_put(kcov);
 }
@@ -143,7 +281,7 @@ static int kcov_mmap(struct file *filep, struct vm_area_struct *vma)
 
 	spin_lock(&kcov->lock);
 	size = kcov->size * sizeof(unsigned long);
-	if (kcov->mode == KCOV_MODE_DISABLED || vma->vm_pgoff != 0 ||
+	if (kcov->mode != KCOV_MODE_INIT || vma->vm_pgoff != 0 ||
 	    vma->vm_end - vma->vm_start != size) {
 		res = -EINVAL;
 		goto exit;
@@ -172,6 +310,7 @@ static int kcov_open(struct inode *inode, struct file *filep)
 	kcov = kzalloc(sizeof(*kcov), GFP_KERNEL);
 	if (!kcov)
 		return -ENOMEM;
+	kcov->mode = KCOV_MODE_DISABLED;
 	atomic_set(&kcov->refcount, 1);
 	spin_lock_init(&kcov->lock);
 	filep->private_data = kcov;
@@ -207,7 +346,7 @@ static int kcov_ioctl_locked(struct kcov *kcov, unsigned int cmd,
 		if (size < 2 || size > INT_MAX / sizeof(unsigned long))
 			return -EINVAL;
 		kcov->size = size;
-		kcov->mode = KCOV_MODE_TRACE;
+		kcov->mode = KCOV_MODE_INIT;
 		return 0;
 	case KCOV_ENABLE:
 		/*
@@ -217,9 +356,19 @@ static int kcov_ioctl_locked(struct kcov *kcov, unsigned int cmd,
 		 * at task exit or voluntary by KCOV_DISABLE. After that it can
 		 * be enabled for another task.
 		 */
-		unused = arg;
-		if (unused != 0 || kcov->mode == KCOV_MODE_DISABLED ||
-		    kcov->area == NULL)
+		if (kcov->mode != KCOV_MODE_INIT || !kcov->area)
+			return -EINVAL;
+		if (kcov->t != NULL)
+			return -EBUSY;
+		if (arg == KCOV_TRACE_PC)
+			kcov->mode = KCOV_MODE_TRACE_PC;
+		else if (arg == KCOV_TRACE_CMP)
+#ifdef CONFIG_KCOV_ENABLE_COMPARISONS
+			kcov->mode = KCOV_MODE_TRACE_CMP;
+#else
+		return -ENOTSUPP;
+#endif
+		else
 			return -EINVAL;
 		t = current;
 		if (kcov->t != NULL || t->kcov != NULL)
@@ -227,7 +376,7 @@ static int kcov_ioctl_locked(struct kcov *kcov, unsigned int cmd,
 		/* Cache in task struct for performance. */
 		t->kcov_size = kcov->size;
 		t->kcov_area = kcov->area;
-		/* See comment in __sanitizer_cov_trace_pc(). */
+		/* See comment in check_kcov_mode(). */
 		barrier();
 		WRITE_ONCE(t->kcov_mode, kcov->mode);
 		t->kcov = kcov;
@@ -245,6 +394,7 @@ static int kcov_ioctl_locked(struct kcov *kcov, unsigned int cmd,
 			return -EINVAL;
 		kcov_task_init(t);
 		kcov->t = NULL;
+		kcov->mode = KCOV_MODE_INIT;
 		kcov_put(kcov);
 		return 0;
 	default:
@@ -267,6 +417,7 @@ static long kcov_ioctl(struct file *filep, unsigned int cmd, unsigned long arg)
 static const struct file_operations kcov_fops = {
 	.open		= kcov_open,
 	.unlocked_ioctl	= kcov_ioctl,
+	.compat_ioctl	= kcov_ioctl,
 	.mmap		= kcov_mmap,
 	.release        = kcov_close,
 };
diff --git a/kernel/module.c b/kernel/module.c
index 0651f2d..13ad2f8 100644
--- a/kernel/module.c
+++ b/kernel/module.c
@@ -2099,6 +2099,8 @@ void __weak module_arch_freeing_init(struct module *mod)
 {
 }
 
+static void cfi_cleanup(struct module *mod);
+
 /* Free a module, remove from lists, etc. */
 static void free_module(struct module *mod)
 {
@@ -2140,6 +2142,10 @@ static void free_module(struct module *mod)
 
 	/* This may be empty, but that's OK */
 	disable_ro_nx(&mod->init_layout);
+
+	/* Clean up CFI for the module. */
+	cfi_cleanup(mod);
+
 	module_arch_freeing_init(mod);
 	module_memfree(mod->init_layout.base);
 	kfree(mod->args);
@@ -3321,6 +3327,8 @@ int __weak module_finalize(const Elf_Ehdr *hdr,
 	return 0;
 }
 
+static void cfi_init(struct module *mod);
+
 static int post_relocation(struct module *mod, const struct load_info *info)
 {
 	/* Sort exception table now relocations are done. */
@@ -3333,6 +3341,9 @@ static int post_relocation(struct module *mod, const struct load_info *info)
 	/* Setup kallsyms-specific fields. */
 	add_kallsyms(mod, info);
 
+	/* Setup CFI for the module. */
+	cfi_init(mod);
+
 	/* Arch-specific module finalizing. */
 	return module_finalize(info->hdr, info->sechdrs, mod);
 }
@@ -4067,6 +4078,22 @@ int module_kallsyms_on_each_symbol(int (*fn)(void *, const char *,
 }
 #endif /* CONFIG_KALLSYMS */
 
+static void cfi_init(struct module *mod)
+{
+#ifdef CONFIG_CFI_CLANG
+	mod->cfi_check =
+		(cfi_check_fn)mod_find_symname(mod, CFI_CHECK_FN_NAME);
+	cfi_module_add(mod, module_addr_min, module_addr_max);
+#endif
+}
+
+static void cfi_cleanup(struct module *mod)
+{
+#ifdef CONFIG_CFI_CLANG
+	cfi_module_remove(mod, module_addr_min, module_addr_max);
+#endif
+}
+
 static char *module_flags(struct module *mod, char *buf)
 {
 	int bx = 0;
diff --git a/kernel/pid.c b/kernel/pid.c
index fa704f8..61bbcb6 100644
--- a/kernel/pid.c
+++ b/kernel/pid.c
@@ -462,6 +462,7 @@ struct task_struct *find_task_by_vpid(pid_t vnr)
 {
 	return find_task_by_pid_ns(vnr, task_active_pid_ns(current));
 }
+EXPORT_SYMBOL(find_task_by_vpid);
 
 struct pid *get_task_pid(struct task_struct *task, enum pid_type type)
 {
diff --git a/kernel/power/Kconfig b/kernel/power/Kconfig
index e8517b6..0b127b7 100644
--- a/kernel/power/Kconfig
+++ b/kernel/power/Kconfig
@@ -1,6 +1,7 @@
 config SUSPEND
 	bool "Suspend to RAM and standby"
 	depends on ARCH_SUSPEND_POSSIBLE
+	select RTC_LIB
 	default y
 	---help---
 	  Allow the system to enter sleep states in which main memory is
@@ -311,3 +312,11 @@ config PM_GENERIC_DOMAINS_OF
 
 config CPU_PM
 	bool
+
+config GLINUX_CURRENT
+	bool "User space suspend interface"
+	depends on SUSPEND
+	default n
+	---help---
+	  RTK Generic linux um interface for stop playback related component
+	  before SUSPEND.
diff --git a/kernel/power/Makefile b/kernel/power/Makefile
index eb4f717..80578f2 100644
--- a/kernel/power/Makefile
+++ b/kernel/power/Makefile
@@ -14,3 +14,5 @@ obj-$(CONFIG_PM_AUTOSLEEP)	+= autosleep.o
 obj-$(CONFIG_PM_WAKELOCKS)	+= wakelock.o
 
 obj-$(CONFIG_MAGIC_SYSRQ)	+= poweroff.o
+
+obj-$(CONFIG_SUSPEND)	+= wakeup_reason.o
diff --git a/kernel/power/main.c b/kernel/power/main.c
old mode 100644
new mode 100755
index 281a697..3083766
--- a/kernel/power/main.c
+++ b/kernel/power/main.c
@@ -15,11 +15,40 @@
 #include <linux/workqueue.h>
 #include <linux/debugfs.h>
 #include <linux/seq_file.h>
+#include <linux/delay.h>
 
 #include "power.h"
 
 DEFINE_MUTEX(pm_mutex);
 
+#ifdef CONFIG_GLINUX_CURRENT
+#include <linux/delay.h>
+static char current_power[32]="none";//none->mem->ok->none
+
+static ssize_t mycurrent_show(struct kobject *kobj,
+                                      struct kobj_attribute *attr, char *buf)
+{
+    return sprintf(buf, "%s\n", current_power);
+}
+
+/* set ok to quit suspend waiting*/
+static ssize_t mycurrent_store(struct kobject *kobj,
+                                       struct kobj_attribute *attr,
+                                       const char *buf, size_t n)
+{
+    if (n < 32) {
+        snprintf(current_power,n, "%s\n", buf);
+        return n;
+    }
+    else {
+        return -EINVAL;
+    }
+}
+
+power_attr(mycurrent);
+
+#endif  /* CONFIG_GLINUX_CURRENT */
+
 #ifdef CONFIG_PM_SLEEP
 
 /* Routines for PM-transition notifications */
@@ -367,6 +396,23 @@ static ssize_t state_store(struct kobject *kobj, struct kobj_attribute *attr,
 		goto out;
 	}
 
+#ifdef CONFIG_GLINUX_CURRENT
+    {
+        int wait_count = 0;
+        if (n < 32) {
+            strcpy(current_power, buf);
+            for (wait_count = 0; wait_count < 5000; wait_count++) {
+                if (!strncmp("ok", current_power, 2)) {
+                    break;
+                }
+                else {
+                    udelay(1000);
+                }
+            }
+            strcpy(current_power, "none");
+        }
+    }
+#endif
 	state = decode_state(buf, n);
 	if (state < PM_SUSPEND_MAX)
 		error = pm_suspend(state);
@@ -411,12 +457,34 @@ static ssize_t state_store(struct kobject *kobj, struct kobj_attribute *attr,
  * are any wakeup events detected after 'wakeup_count' was written to.
  */
 
+#ifdef CONFIG_RTK_PLATFORM
+extern unsigned int pm_wakelock_mode;
+extern unsigned int pm_block_wakelock;
+#endif /* CONFIG_RTK_PLATFORM */
+
 static ssize_t wakeup_count_show(struct kobject *kobj,
 				struct kobj_attribute *attr,
 				char *buf)
 {
 	unsigned int val;
 
+#ifdef CONFIG_RTK_PLATFORM
+
+#if 0
+    if(pm_wakelock_mode == 1) {
+        int count = 0;
+        while(pm_block_wakelock == 1) {
+            msleep(1); //udelay(1);
+            count++;
+        }
+        pr_err("[%s] count %d\n",__func__,count);
+        val = 0;
+        return sprintf(buf,"%u\n",val);
+    }
+#endif
+
+#endif /* CONFIG_RTK_PLATFORM */
+
 	return pm_get_wakeup_count(&val, true) ?
 		sprintf(buf, "%u\n", val) : -EINTR;
 }
@@ -428,6 +496,16 @@ static ssize_t wakeup_count_store(struct kobject *kobj,
 	unsigned int val;
 	int error;
 
+#ifdef CONFIG_RTK_PLATFORM
+
+#if 0
+	if(pm_wakelock_mode == 1) {
+		return n;
+	}
+#endif
+
+#endif /* CONFIG_RTK_PLATFORM */
+
 	error = pm_autosleep_lock();
 	if (error)
 		return error;
@@ -504,6 +582,7 @@ static ssize_t wake_lock_store(struct kobject *kobj,
 			       struct kobj_attribute *attr,
 			       const char *buf, size_t n)
 {
+    //pr_info("wake_lock:%s\n", buf);
 	int error = pm_wake_lock(buf);
 	return error ? error : n;
 }
@@ -521,6 +600,7 @@ static ssize_t wake_unlock_store(struct kobject *kobj,
 				 struct kobj_attribute *attr,
 				 const char *buf, size_t n)
 {
+    //pr_info("wake_unlock:%s\n", buf);
 	int error = pm_wake_unlock(buf);
 	return error ? error : n;
 }
@@ -620,6 +700,9 @@ static ssize_t pm_freeze_timeout_store(struct kobject *kobj,
 #ifdef CONFIG_FREEZER
 	&pm_freeze_timeout_attr.attr,
 #endif
+#ifdef CONFIG_GLINUX_CURRENT
+	&mycurrent_attr.attr,
+#endif
 	NULL,
 };
 
@@ -652,6 +735,9 @@ static int __init pm_init(void)
 	if (error)
 		return error;
 	pm_print_times_init();
+#ifdef CONFIG_RTK_PLATFORM //FIXME: acquire wakelock to prevent system from entering suspend state
+    pm_wake_lock("rtk_awake");
+#endif
 	return pm_autosleep_init();
 }
 
diff --git a/kernel/power/process.c b/kernel/power/process.c
index 8ea24de..9a12c83 100644
--- a/kernel/power/process.c
+++ b/kernel/power/process.c
@@ -18,6 +18,7 @@
 #include <linux/workqueue.h>
 #include <linux/kmod.h>
 #include <trace/events/power.h>
+#include <linux/wakeup_reason.h>
 #include <linux/cpuset.h>
 
 /*
@@ -35,6 +36,9 @@ static int try_to_freeze_tasks(bool user_only)
 	unsigned int elapsed_msecs;
 	bool wakeup = false;
 	int sleep_usecs = USEC_PER_MSEC;
+#ifdef CONFIG_PM_SLEEP
+	char suspend_abort[MAX_SUSPEND_ABORT_LEN];
+#endif
 
 	start = ktime_get_boottime();
 
@@ -64,6 +68,11 @@ static int try_to_freeze_tasks(bool user_only)
 			break;
 
 		if (pm_wakeup_pending()) {
+#ifdef CONFIG_PM_SLEEP
+			pm_get_active_wakeup_sources(suspend_abort,
+				MAX_SUSPEND_ABORT_LEN);
+			log_suspend_abort_reason(suspend_abort);
+#endif
 			wakeup = true;
 			break;
 		}
@@ -82,26 +91,27 @@ static int try_to_freeze_tasks(bool user_only)
 	elapsed = ktime_sub(end, start);
 	elapsed_msecs = ktime_to_ms(elapsed);
 
-	if (todo) {
+	if (wakeup) {
 		pr_cont("\n");
-		pr_err("Freezing of tasks %s after %d.%03d seconds "
-		       "(%d tasks refusing to freeze, wq_busy=%d):\n",
-		       wakeup ? "aborted" : "failed",
+		pr_err("Freezing of tasks aborted after %d.%03d seconds",
+		       elapsed_msecs / 1000, elapsed_msecs % 1000);
+	} else if (todo) {
+		pr_cont("\n");
+		pr_err("Freezing of tasks failed after %d.%03d seconds"
+		       " (%d tasks refusing to freeze, wq_busy=%d):\n",
 		       elapsed_msecs / 1000, elapsed_msecs % 1000,
 		       todo - wq_busy, wq_busy);
 
 		if (wq_busy)
 			show_workqueue_state();
 
-		if (!wakeup) {
-			read_lock(&tasklist_lock);
-			for_each_process_thread(g, p) {
-				if (p != current && !freezer_should_skip(p)
-				    && freezing(p) && !frozen(p))
-					sched_show_task(p);
-			}
-			read_unlock(&tasklist_lock);
+		read_lock(&tasklist_lock);
+		for_each_process_thread(g, p) {
+			if (p != current && !freezer_should_skip(p)
+			    && freezing(p) && !frozen(p))
+				sched_show_task(p);
 		}
+		read_unlock(&tasklist_lock);
 	} else {
 		pr_cont("(elapsed %d.%03d seconds) ", elapsed_msecs / 1000,
 			elapsed_msecs % 1000);
diff --git a/kernel/power/suspend.c b/kernel/power/suspend.c
old mode 100644
new mode 100755
index 6ccb08f..9d5262c
--- a/kernel/power/suspend.c
+++ b/kernel/power/suspend.c
@@ -26,12 +26,30 @@
 #include <linux/suspend.h>
 #include <linux/syscore_ops.h>
 #include <linux/ftrace.h>
+#include <linux/rtc.h>
 #include <trace/events/power.h>
 #include <linux/compiler.h>
 #include <linux/moduleparam.h>
+#include <linux/wakeup_reason.h>
 
 #include "power.h"
 
+#ifdef CONFIG_RTK_PLATFORM
+int RTK_PM_STATE;
+EXPORT_SYMBOL(RTK_PM_STATE);
+#endif/* CONFIG_RTK_PLATFORM */
+
+#ifdef CONFIG_AHCI_RTK
+extern struct task_struct *rtk_sata_dev_task;
+#endif
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+extern int xen_suspend_to_ram(void);
+#else
+/* should never reach here */
+static inline int xen_suspend_to_ram(void) { BUG(); };
+#endif
+
 const char *pm_labels[] = { "mem", "standby", "freeze", NULL };
 const char *pm_states[PM_SUSPEND_MAX];
 
@@ -322,7 +340,8 @@ void __weak arch_suspend_enable_irqs(void)
  */
 static int suspend_enter(suspend_state_t state, bool *wakeup)
 {
-	int error;
+	char suspend_abort[MAX_SUSPEND_ABORT_LEN];
+	int error, last_dev;
 
 	error = platform_suspend_prepare(state);
 	if (error)
@@ -330,7 +349,11 @@ static int suspend_enter(suspend_state_t state, bool *wakeup)
 
 	error = dpm_suspend_late(PMSG_SUSPEND);
 	if (error) {
+		last_dev = suspend_stats.last_failed_dev + REC_FAILED_NUM - 1;
+		last_dev %= REC_FAILED_NUM;
 		pr_err("PM: late suspend of devices failed\n");
+		log_suspend_abort_reason("%s device failed to power down",
+			suspend_stats.failed_devs[last_dev]);
 		goto Platform_finish;
 	}
 	error = platform_suspend_prepare_late(state);
@@ -339,7 +362,11 @@ static int suspend_enter(suspend_state_t state, bool *wakeup)
 
 	error = dpm_suspend_noirq(PMSG_SUSPEND);
 	if (error) {
+		last_dev = suspend_stats.last_failed_dev + REC_FAILED_NUM - 1;
+		last_dev %= REC_FAILED_NUM;
 		pr_err("PM: noirq suspend of devices failed\n");
+		log_suspend_abort_reason("noirq suspend of %s device failed",
+			suspend_stats.failed_devs[last_dev]);
 		goto Platform_early_resume;
 	}
 	error = platform_suspend_prepare_noirq(state);
@@ -363,8 +390,10 @@ static int suspend_enter(suspend_state_t state, bool *wakeup)
 	}
 
 	error = disable_nonboot_cpus();
-	if (error || suspend_test(TEST_CPUS))
+	if (error || suspend_test(TEST_CPUS)) {
+		log_suspend_abort_reason("Disabling non-boot cpus failed");
 		goto Enable_cpus;
+	}
 
 	arch_suspend_disable_irqs();
 	BUG_ON(!irqs_disabled());
@@ -380,6 +409,9 @@ static int suspend_enter(suspend_state_t state, bool *wakeup)
 				state, false);
 			events_check_enabled = false;
 		} else if (*wakeup) {
+			pm_get_active_wakeup_sources(suspend_abort,
+				MAX_SUSPEND_ABORT_LEN);
+			log_suspend_abort_reason(suspend_abort);
 			error = -EBUSY;
 		}
 		syscore_resume();
@@ -424,9 +456,13 @@ int suspend_devices_and_enter(suspend_state_t state)
 
 	suspend_console();
 	suspend_test_start();
+#ifdef CONFIG_RTK_PLATFORM
+	RTK_PM_STATE = state;
+#endif /* CONFIG_RTK_PLATFORM */
 	error = dpm_suspend_start(PMSG_SUSPEND);
 	if (error) {
 		pr_err("PM: Some devices failed to suspend, or early wake event detected\n");
+		log_suspend_abort_reason("Some devices failed to suspend, or early wake event detected");
 		goto Recover_platform;
 	}
 	suspend_test_finish("suspend devices");
@@ -467,6 +503,12 @@ static void suspend_finish(void)
 	pm_restore_console();
 }
 
+#ifdef CONFIG_RTK_PLATFORM
+extern unsigned int pm_wakelock_mode;
+extern struct device *rtk_pm_dev;
+extern unsigned int pm_state;
+#endif /* CONFIG_RTK_PLATFORM */
+
 /**
  * enter_state - Do common work needed to enter system sleep state.
  * @state: System sleep state to enter.
@@ -478,8 +520,49 @@ static void suspend_finish(void)
 static int enter_state(suspend_state_t state)
 {
 	int error;
+#ifdef CONFIG_RTK_PLATFORM
+	int count = 0;
+#endif /* CONFIG_RTK_PLATFORM */
 
+#ifdef CONFIG_AHCI_RTK
+	unsigned long timeout;
+#endif
 	trace_suspend_resume(TPS("suspend_enter"), state, true);
+	
+#ifdef CONFIG_RTK_PLATFORM
+
+	kobject_uevent(&rtk_pm_dev->kobj, KOBJ_CHANGE);
+
+	if(pm_wakelock_mode == 1) {
+		while (!(pm_state == 1)) {
+			if (count == 1000){
+				pr_err("[RTD16xx PM] Android suspend pre handle timeout!\n");
+				break;
+			}
+            msleep(1);
+			//udelay(1);
+			count++;
+            if((count%100) == 0) {
+                pr_err("[RTD16xx PM] enter_state loop %d\n",count);
+            }
+		}
+	}
+
+	if (state == PM_SUSPEND_STANDBY) {
+	}
+
+	if (state == PM_SUSPEND_MEM){
+		sys_sync();
+#ifdef CONFIG_AHCI_RTK
+		if (rtk_sata_dev_task != NULL) {
+			wake_up_process(rtk_sata_dev_task);
+			timeout = jiffies + msecs_to_jiffies(1000);
+			while(time_before(jiffies, timeout));
+		}
+#endif
+	}
+#endif /* CONFIG_RTK_PLATFORM */
+	
 	if (state == PM_SUSPEND_FREEZE) {
 #ifdef CONFIG_PM_DEBUG
 		if (pm_test_level != TEST_NONE && pm_test_level <= TEST_CPUS) {
@@ -527,6 +610,18 @@ static int enter_state(suspend_state_t state)
 	return error;
 }
 
+static void pm_suspend_marker(char *annotation)
+{
+	struct timespec ts;
+	struct rtc_time tm;
+
+	getnstimeofday(&ts);
+	rtc_time_to_tm(ts.tv_sec, &tm);
+	pr_info("PM: suspend %s %d-%02d-%02d %02d:%02d:%02d.%09lu UTC\n",
+		annotation, tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
+		tm.tm_hour, tm.tm_min, tm.tm_sec, ts.tv_nsec);
+}
+
 /**
  * pm_suspend - Externally visible function for suspending the system.
  * @state: System sleep state to enter.
@@ -541,13 +636,20 @@ int pm_suspend(suspend_state_t state)
 	if (state <= PM_SUSPEND_ON || state >= PM_SUSPEND_MAX)
 		return -EINVAL;
 
-	error = enter_state(state);
+	pm_suspend_marker("entry");
+	if (xen_domain() && !xen_initial_domain()) {
+		pr_info("Enter xen suspend\n");
+		error = xen_suspend_to_ram();
+	} else {
+		error = enter_state(state);
+	}
 	if (error) {
 		suspend_stats.fail++;
 		dpm_save_failed_errno(error);
 	} else {
 		suspend_stats.success++;
 	}
+	pm_suspend_marker("exit");
 	return error;
 }
 EXPORT_SYMBOL(pm_suspend);
diff --git a/kernel/power/wakeup_reason.c b/kernel/power/wakeup_reason.c
new file mode 100644
index 00000000..252611f
--- /dev/null
+++ b/kernel/power/wakeup_reason.c
@@ -0,0 +1,225 @@
+/*
+ * kernel/power/wakeup_reason.c
+ *
+ * Logs the reasons which caused the kernel to resume from
+ * the suspend mode.
+ *
+ * Copyright (C) 2014 Google, Inc.
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include <linux/wakeup_reason.h>
+#include <linux/kernel.h>
+#include <linux/irq.h>
+#include <linux/interrupt.h>
+#include <linux/io.h>
+#include <linux/kobject.h>
+#include <linux/sysfs.h>
+#include <linux/init.h>
+#include <linux/spinlock.h>
+#include <linux/notifier.h>
+#include <linux/suspend.h>
+
+
+#define MAX_WAKEUP_REASON_IRQS 32
+static int irq_list[MAX_WAKEUP_REASON_IRQS];
+static int irqcount;
+static bool suspend_abort;
+static char abort_reason[MAX_SUSPEND_ABORT_LEN];
+static struct kobject *wakeup_reason;
+static DEFINE_SPINLOCK(resume_reason_lock);
+
+static ktime_t last_monotime; /* monotonic time before last suspend */
+static ktime_t curr_monotime; /* monotonic time after last suspend */
+static ktime_t last_stime; /* monotonic boottime offset before last suspend */
+static ktime_t curr_stime; /* monotonic boottime offset after last suspend */
+
+static ssize_t last_resume_reason_show(struct kobject *kobj, struct kobj_attribute *attr,
+		char *buf)
+{
+	int irq_no, buf_offset = 0;
+	struct irq_desc *desc;
+	spin_lock(&resume_reason_lock);
+	if (suspend_abort) {
+		buf_offset = sprintf(buf, "Abort: %s", abort_reason);
+	} else {
+		for (irq_no = 0; irq_no < irqcount; irq_no++) {
+			desc = irq_to_desc(irq_list[irq_no]);
+			if (desc && desc->action && desc->action->name)
+				buf_offset += sprintf(buf + buf_offset, "%d %s\n",
+						irq_list[irq_no], desc->action->name);
+			else
+				buf_offset += sprintf(buf + buf_offset, "%d\n",
+						irq_list[irq_no]);
+		}
+	}
+	spin_unlock(&resume_reason_lock);
+	return buf_offset;
+}
+
+static ssize_t last_suspend_time_show(struct kobject *kobj,
+			struct kobj_attribute *attr, char *buf)
+{
+	struct timespec sleep_time;
+	struct timespec total_time;
+	struct timespec suspend_resume_time;
+
+	/*
+	 * total_time is calculated from monotonic bootoffsets because
+	 * unlike CLOCK_MONOTONIC it include the time spent in suspend state.
+	 */
+	total_time = ktime_to_timespec(ktime_sub(curr_stime, last_stime));
+
+	/*
+	 * suspend_resume_time is calculated as monotonic (CLOCK_MONOTONIC)
+	 * time interval before entering suspend and post suspend.
+	 */
+	suspend_resume_time = ktime_to_timespec(ktime_sub(curr_monotime, last_monotime));
+
+	/* sleep_time = total_time - suspend_resume_time */
+	sleep_time = timespec_sub(total_time, suspend_resume_time);
+
+	/* Export suspend_resume_time and sleep_time in pair here. */
+	return sprintf(buf, "%lu.%09lu %lu.%09lu\n",
+				suspend_resume_time.tv_sec, suspend_resume_time.tv_nsec,
+				sleep_time.tv_sec, sleep_time.tv_nsec);
+}
+
+static struct kobj_attribute resume_reason = __ATTR_RO(last_resume_reason);
+static struct kobj_attribute suspend_time = __ATTR_RO(last_suspend_time);
+
+static struct attribute *attrs[] = {
+	&resume_reason.attr,
+	&suspend_time.attr,
+	NULL,
+};
+static struct attribute_group attr_group = {
+	.attrs = attrs,
+};
+
+/*
+ * logs all the wake up reasons to the kernel
+ * stores the irqs to expose them to the userspace via sysfs
+ */
+void log_wakeup_reason(int irq)
+{
+	struct irq_desc *desc;
+	desc = irq_to_desc(irq);
+	if (desc && desc->action && desc->action->name)
+		printk(KERN_INFO "Resume caused by IRQ %d, %s\n", irq,
+				desc->action->name);
+	else
+		printk(KERN_INFO "Resume caused by IRQ %d\n", irq);
+
+	spin_lock(&resume_reason_lock);
+	if (irqcount == MAX_WAKEUP_REASON_IRQS) {
+		spin_unlock(&resume_reason_lock);
+		printk(KERN_WARNING "Resume caused by more than %d IRQs\n",
+				MAX_WAKEUP_REASON_IRQS);
+		return;
+	}
+
+	irq_list[irqcount++] = irq;
+	spin_unlock(&resume_reason_lock);
+}
+
+int check_wakeup_reason(int irq)
+{
+	int irq_no;
+	int ret = false;
+
+	spin_lock(&resume_reason_lock);
+	for (irq_no = 0; irq_no < irqcount; irq_no++)
+		if (irq_list[irq_no] == irq) {
+			ret = true;
+			break;
+	}
+	spin_unlock(&resume_reason_lock);
+	return ret;
+}
+
+void log_suspend_abort_reason(const char *fmt, ...)
+{
+	va_list args;
+
+	spin_lock(&resume_reason_lock);
+
+	//Suspend abort reason has already been logged.
+	if (suspend_abort) {
+		spin_unlock(&resume_reason_lock);
+		return;
+	}
+
+	suspend_abort = true;
+	va_start(args, fmt);
+	vsnprintf(abort_reason, MAX_SUSPEND_ABORT_LEN, fmt, args);
+	va_end(args);
+	spin_unlock(&resume_reason_lock);
+}
+
+/* Detects a suspend and clears all the previous wake up reasons*/
+static int wakeup_reason_pm_event(struct notifier_block *notifier,
+		unsigned long pm_event, void *unused)
+{
+	switch (pm_event) {
+	case PM_SUSPEND_PREPARE:
+		spin_lock(&resume_reason_lock);
+		irqcount = 0;
+		suspend_abort = false;
+		spin_unlock(&resume_reason_lock);
+		/* monotonic time since boot */
+		last_monotime = ktime_get();
+		/* monotonic time since boot including the time spent in suspend */
+		last_stime = ktime_get_boottime();
+		break;
+	case PM_POST_SUSPEND:
+		/* monotonic time since boot */
+		curr_monotime = ktime_get();
+		/* monotonic time since boot including the time spent in suspend */
+		curr_stime = ktime_get_boottime();
+		break;
+	default:
+		break;
+	}
+	return NOTIFY_DONE;
+}
+
+static struct notifier_block wakeup_reason_pm_notifier_block = {
+	.notifier_call = wakeup_reason_pm_event,
+};
+
+/* Initializes the sysfs parameter
+ * registers the pm_event notifier
+ */
+int __init wakeup_reason_init(void)
+{
+	int retval;
+
+	retval = register_pm_notifier(&wakeup_reason_pm_notifier_block);
+	if (retval)
+		printk(KERN_WARNING "[%s] failed to register PM notifier %d\n",
+				__func__, retval);
+
+	wakeup_reason = kobject_create_and_add("wakeup_reasons", kernel_kobj);
+	if (!wakeup_reason) {
+		printk(KERN_WARNING "[%s] failed to create a sysfs kobject\n",
+				__func__);
+		return 1;
+	}
+	retval = sysfs_create_group(wakeup_reason, &attr_group);
+	if (retval) {
+		kobject_put(wakeup_reason);
+		printk(KERN_WARNING "[%s] failed to create a sysfs group %d\n",
+				__func__, retval);
+	}
+	return 0;
+}
+
+late_initcall(wakeup_reason_init);
diff --git a/kernel/printk/printk.c b/kernel/printk/printk.c
index ab6855a..3012f95 100644
--- a/kernel/printk/printk.c
+++ b/kernel/printk/printk.c
@@ -56,6 +56,10 @@
 #include "braille.h"
 #include "internal.h"
 
+#ifdef CONFIG_EARLY_PRINTK_DIRECT
+extern void printascii(char *);
+#endif
+
 int console_printk[4] = {
 	CONSOLE_LOGLEVEL_DEFAULT,	/* console_loglevel */
 	MESSAGE_LOGLEVEL_DEFAULT,	/* default_message_loglevel */
@@ -1870,6 +1874,10 @@ asmlinkage int vprintk_emit(int facility, int level,
 		}
 	}
 
+#ifdef CONFIG_EARLY_PRINTK_DIRECT
+	printascii(text);
+#endif
+
 	if (level == LOGLEVEL_DEFAULT)
 		level = default_message_loglevel;
 
diff --git a/kernel/reboot.c b/kernel/reboot.c
index bd30a97..210dac7 100644
--- a/kernel/reboot.c
+++ b/kernel/reboot.c
@@ -211,6 +211,7 @@ void migrate_to_reboot_cpu(void)
  *	Shutdown everything and perform a clean reboot.
  *	This is not safe to call in interrupt context.
  */
+
 void kernel_restart(char *cmd)
 {
 	kernel_restart_prepare(cmd);
@@ -220,6 +221,7 @@ void kernel_restart(char *cmd)
 		pr_emerg("Restarting system\n");
 	else
 		pr_emerg("Restarting system with command '%s'\n", cmd);
+
 	kmsg_dump(KMSG_DUMP_RESTART);
 	machine_restart(cmd);
 }
@@ -386,8 +388,13 @@ void ctrl_alt_del(void)
 		kill_cad_pid(SIGINT, 1);
 }
 
+#if defined(CONFIG_RTK_XEN_SUPPORT) && defined(CONFIG_ANDROID)
+char poweroff_cmd[POWEROFF_CMD_PATH_LEN] = "/system/bin/reboot -p";
+static const char reboot_cmd[] = "/system/bin/reboot";
+#else
 char poweroff_cmd[POWEROFF_CMD_PATH_LEN] = "/sbin/poweroff";
 static const char reboot_cmd[] = "/sbin/reboot";
+#endif
 
 static int run_cmd(const char *cmd)
 {
diff --git a/kernel/sched/Makefile b/kernel/sched/Makefile
index 5e59b83..c9dbe93 100644
--- a/kernel/sched/Makefile
+++ b/kernel/sched/Makefile
@@ -18,10 +18,12 @@ endif
 obj-y += core.o loadavg.o clock.o cputime.o
 obj-y += idle_task.o fair.o rt.o deadline.o stop_task.o
 obj-y += wait.o swait.o completion.o idle.o
-obj-$(CONFIG_SMP) += cpupri.o cpudeadline.o
+obj-$(CONFIG_SMP) += cpupri.o cpudeadline.o energy.o
+obj-$(CONFIG_SCHED_WALT) += walt.o
 obj-$(CONFIG_SCHED_AUTOGROUP) += auto_group.o
 obj-$(CONFIG_SCHEDSTATS) += stats.o
 obj-$(CONFIG_SCHED_DEBUG) += debug.o
+obj-$(CONFIG_SCHED_TUNE) += tune.o
 obj-$(CONFIG_CGROUP_CPUACCT) += cpuacct.o
 obj-$(CONFIG_CPU_FREQ) += cpufreq.o
 obj-$(CONFIG_CPU_FREQ_GOV_SCHEDUTIL) += cpufreq_schedutil.o
diff --git a/kernel/sched/core.c b/kernel/sched/core.c
index 917be22..d3b4d62 100644
--- a/kernel/sched/core.c
+++ b/kernel/sched/core.c
@@ -75,6 +75,7 @@
 #include <linux/compiler.h>
 #include <linux/frame.h>
 #include <linux/prefetch.h>
+#include <linux/cpufreq_times.h>
 
 #include <asm/switch_to.h>
 #include <asm/tlb.h>
@@ -90,6 +91,7 @@
 
 #define CREATE_TRACE_POINTS
 #include <trace/events/sched.h>
+#include "walt.h"
 
 DEFINE_MUTEX(sched_domains_mutex);
 DEFINE_PER_CPU_SHARED_ALIGNED(struct rq, runqueues);
@@ -156,6 +158,18 @@ void update_rq_clock(struct rq *rq)
 /* cpus with isolated domains */
 cpumask_var_t cpu_isolated_map;
 
+struct rq *
+lock_rq_of(struct task_struct *p, struct rq_flags *flags)
+{
+	return task_rq_lock(p, flags);
+}
+
+void
+unlock_rq_of(struct rq *rq, struct task_struct *p, struct rq_flags *flags)
+{
+	task_rq_unlock(rq, p, flags);
+}
+
 /*
  * this_rq_lock - lock this runqueue and disable interrupts.
  */
@@ -998,7 +1012,9 @@ static struct rq *move_queued_task(struct rq *rq, struct task_struct *p, int new
 
 	p->on_rq = TASK_ON_RQ_MIGRATING;
 	dequeue_task(rq, p, 0);
+	double_lock_balance(rq, cpu_rq(new_cpu));
 	set_task_cpu(p, new_cpu);
+	double_unlock_balance(rq, cpu_rq(new_cpu));
 	raw_spin_unlock(&rq->lock);
 
 	rq = cpu_rq(new_cpu);
@@ -1254,6 +1270,8 @@ void set_task_cpu(struct task_struct *p, unsigned int new_cpu)
 			p->sched_class->migrate_task_rq(p);
 		p->se.nr_migrations++;
 		perf_event_task_migrate(p);
+
+		walt_fixup_busy_time(p, new_cpu);
 	}
 
 	__set_task_cpu(p, new_cpu);
@@ -1269,7 +1287,9 @@ static void __migrate_swap_task(struct task_struct *p, int cpu)
 
 		p->on_rq = TASK_ON_RQ_MIGRATING;
 		deactivate_task(src_rq, p, 0);
+		p->on_rq = TASK_ON_RQ_MIGRATING;
 		set_task_cpu(p, cpu);
+		p->on_rq = TASK_ON_RQ_QUEUED;
 		activate_task(dst_rq, p, 0);
 		p->on_rq = TASK_ON_RQ_QUEUED;
 		check_preempt_curr(dst_rq, p, 0);
@@ -2010,6 +2030,10 @@ static void ttwu_queue(struct task_struct *p, int cpu, int wake_flags)
 {
 	unsigned long flags;
 	int cpu, success = 0;
+#ifdef CONFIG_SMP
+	struct rq *rq;
+	u64 wallclock;
+#endif
 
 	/*
 	 * If we are going to wake up a thread waiting for CONDITION we
@@ -2083,14 +2107,24 @@ static void ttwu_queue(struct task_struct *p, int cpu, int wake_flags)
 	 */
 	smp_cond_load_acquire(&p->on_cpu, !VAL);
 
+	rq = cpu_rq(task_cpu(p));
+
+	raw_spin_lock(&rq->lock);
+	wallclock = walt_ktime_clock();
+	walt_update_task_ravg(rq->curr, rq, TASK_UPDATE, wallclock, 0);
+	walt_update_task_ravg(p, rq, TASK_WAKE, wallclock, 0);
+	raw_spin_unlock(&rq->lock);
+
 	p->sched_contributes_to_load = !!task_contributes_to_load(p);
 	p->state = TASK_WAKING;
 
 	cpu = select_task_rq(p, p->wake_cpu, SD_BALANCE_WAKE, wake_flags);
+
 	if (task_cpu(p) != cpu) {
 		wake_flags |= WF_MIGRATED;
 		set_task_cpu(p, cpu);
 	}
+
 #endif /* CONFIG_SMP */
 
 	ttwu_queue(p, cpu, wake_flags);
@@ -2140,8 +2174,13 @@ static void try_to_wake_up_local(struct task_struct *p, struct pin_cookie cookie
 
 	trace_sched_waking(p);
 
-	if (!task_on_rq_queued(p))
+	if (!task_on_rq_queued(p)) {
+		u64 wallclock = walt_ktime_clock();
+
+		walt_update_task_ravg(rq->curr, rq, TASK_UPDATE, wallclock, 0);
+		walt_update_task_ravg(p, rq, TASK_WAKE, wallclock, 0);
 		ttwu_activate(rq, p, ENQUEUE_WAKEUP);
+	}
 
 	ttwu_do_wakeup(rq, p, 0, cookie);
 	ttwu_stat(p, smp_processor_id(), 0);
@@ -2206,7 +2245,12 @@ static void __sched_fork(unsigned long clone_flags, struct task_struct *p)
 	p->se.prev_sum_exec_runtime	= 0;
 	p->se.nr_migrations		= 0;
 	p->se.vruntime			= 0;
+#ifdef CONFIG_SCHED_WALT
+	p->last_sleep_ts		= 0;
+#endif
+
 	INIT_LIST_HEAD(&p->se.group_node);
+	walt_init_new_task_load(p);
 
 #ifdef CONFIG_FAIR_GROUP_SCHED
 	p->se.cfs_rq			= NULL;
@@ -2566,6 +2610,9 @@ void wake_up_new_task(struct task_struct *p)
 	struct rq *rq;
 
 	raw_spin_lock_irqsave(&p->pi_lock, rf.flags);
+
+	walt_init_new_task_load(p);
+
 	p->state = TASK_RUNNING;
 #ifdef CONFIG_SMP
 	/*
@@ -2579,9 +2626,12 @@ void wake_up_new_task(struct task_struct *p)
 	__set_task_cpu(p, select_task_rq(p, task_cpu(p), SD_BALANCE_FORK, 0));
 #endif
 	rq = __task_rq_lock(p, &rf);
+	update_rq_clock(rq);
 	post_init_entity_util_avg(&p->se);
 
-	activate_task(rq, p, 0);
+	walt_mark_task_starting(p);
+
+	activate_task(rq, p, ENQUEUE_WAKEUP_NEW);
 	p->on_rq = TASK_ON_RQ_QUEUED;
 	trace_sched_wakeup_new(p);
 	check_preempt_curr(rq, p, WF_FORK);
@@ -2966,6 +3016,36 @@ unsigned long nr_iowait_cpu(int cpu)
 	return atomic_read(&this->nr_iowait);
 }
 
+#ifdef CONFIG_CPU_QUIET
+u64 nr_running_integral(unsigned int cpu)
+{
+	unsigned int seqcnt;
+	u64 integral;
+	struct rq *q;
+
+	if (cpu >= nr_cpu_ids)
+		return 0;
+
+	q = cpu_rq(cpu);
+
+	/*
+	 * Update average to avoid reading stalled value if there were
+	 * no run-queue changes for a long time. On the other hand if
+	 * the changes are happening right now, just read current value
+	 * directly.
+	 */
+
+	seqcnt = read_seqcount_begin(&q->ave_seqcnt);
+	integral = do_nr_running_integral(q);
+	if (read_seqcount_retry(&q->ave_seqcnt, seqcnt)) {
+		read_seqcount_begin(&q->ave_seqcnt);
+		integral = q->nr_running_integral;
+	}
+
+	return integral;
+}
+#endif
+
 void get_iowait_load(unsigned long *nr_waiters, unsigned long *load)
 {
 	struct rq *rq = this_rq();
@@ -3083,6 +3163,9 @@ void scheduler_tick(void)
 	sched_clock_tick();
 
 	raw_spin_lock(&rq->lock);
+	walt_set_window_start(rq);
+	walt_update_task_ravg(rq->curr, rq, TASK_UPDATE,
+			walt_ktime_clock(), 0);
 	update_rq_clock(rq);
 	curr->sched_class->task_tick(rq, curr, 0);
 	cpu_load_update_active(rq);
@@ -3096,6 +3179,9 @@ void scheduler_tick(void)
 	trigger_load_balance(rq);
 #endif
 	rq_last_tick_reset(rq);
+
+	if (curr->sched_class == &fair_sched_class)
+		check_for_migration(rq, curr);
 }
 
 #ifdef CONFIG_NO_HZ_FULL
@@ -3339,6 +3425,7 @@ static void __sched notrace __schedule(bool preempt)
 	struct pin_cookie cookie;
 	struct rq *rq;
 	int cpu;
+	u64 wallclock;
 
 	cpu = smp_processor_id();
 	rq = cpu_rq(cpu);
@@ -3391,11 +3478,18 @@ static void __sched notrace __schedule(bool preempt)
 		update_rq_clock(rq);
 
 	next = pick_next_task(rq, prev, cookie);
+	wallclock = walt_ktime_clock();
+	walt_update_task_ravg(prev, rq, PUT_PREV_TASK, wallclock, 0);
+	walt_update_task_ravg(next, rq, PICK_NEXT_TASK, wallclock, 0);
 	clear_tsk_need_resched(prev);
 	clear_preempt_need_resched();
 	rq->clock_skip_update = 0;
 
 	if (likely(prev != next)) {
+#ifdef CONFIG_SCHED_WALT
+		if (!prev->on_rq)
+			prev->last_sleep_ts = wallclock;
+#endif
 		rq->nr_switches++;
 		rq->curr = next;
 		++*switch_count;
@@ -3652,6 +3746,7 @@ void rt_mutex_setprio(struct task_struct *p, int prio)
 	BUG_ON(prio > MAX_PRIO);
 
 	rq = __task_rq_lock(p, &rf);
+	update_rq_clock(rq);
 
 	/*
 	 * Idle task boosting is a nono in general. There is one
@@ -3748,6 +3843,8 @@ void set_user_nice(struct task_struct *p, long nice)
 	 * the task might be in the middle of scheduling on another CPU.
 	 */
 	rq = task_rq_lock(p, &rf);
+	update_rq_clock(rq);
+
 	/*
 	 * The RT priorities are set via sched_setscheduler(), but we still
 	 * allow the 'normal' nice value to be set - but as expected
@@ -4181,6 +4278,7 @@ static int __sched_setscheduler(struct task_struct *p,
 	 * runqueue lock must be held.
 	 */
 	rq = task_rq_lock(p, &rf);
+	update_rq_clock(rq);
 
 	/*
 	 * Changing the policy of the stop threads its a very bad idea
@@ -5666,9 +5764,6 @@ static int sched_domain_debug_one(struct sched_domain *sd, int cpu, int level,
 
 	if (!(sd->flags & SD_LOAD_BALANCE)) {
 		printk("does not load-balance\n");
-		if (sd->parent)
-			printk(KERN_ERR "ERROR: !SD_LOAD_BALANCE domain"
-					" has parent");
 		return -1;
 	}
 
@@ -5710,7 +5805,7 @@ static int sched_domain_debug_one(struct sched_domain *sd, int cpu, int level,
 		printk(KERN_CONT " %*pbl",
 		       cpumask_pr_args(sched_group_cpus(group)));
 		if (group->sgc->capacity != SCHED_CAPACITY_SCALE) {
-			printk(KERN_CONT " (cpu_capacity = %d)",
+			printk(KERN_CONT " (cpu_capacity = %lu)",
 				group->sgc->capacity);
 		}
 
@@ -5763,8 +5858,12 @@ static inline bool sched_debug(void)
 
 static int sd_degenerate(struct sched_domain *sd)
 {
-	if (cpumask_weight(sched_domain_span(sd)) == 1)
-		return 1;
+	if (cpumask_weight(sched_domain_span(sd)) == 1) {
+		if (sd->groups->sge)
+			sd->flags &= ~SD_LOAD_BALANCE;
+		else
+			return 1;
+	}
 
 	/* Following flags need at least 2 groups */
 	if (sd->flags & (SD_LOAD_BALANCE |
@@ -5774,7 +5873,8 @@ static int sd_degenerate(struct sched_domain *sd)
 			 SD_SHARE_CPUCAPACITY |
 			 SD_ASYM_CPUCAPACITY |
 			 SD_SHARE_PKG_RESOURCES |
-			 SD_SHARE_POWERDOMAIN)) {
+			 SD_SHARE_POWERDOMAIN |
+			 SD_SHARE_CAP_STATES)) {
 		if (sd->groups != sd->groups->next)
 			return 0;
 	}
@@ -5807,7 +5907,12 @@ static int sd_degenerate(struct sched_domain *sd)
 				SD_SHARE_CPUCAPACITY |
 				SD_SHARE_PKG_RESOURCES |
 				SD_PREFER_SIBLING |
-				SD_SHARE_POWERDOMAIN);
+				SD_SHARE_POWERDOMAIN |
+				SD_SHARE_CAP_STATES);
+		if (parent->groups->sge) {
+			parent->flags &= ~SD_LOAD_BALANCE;
+			return 0;
+		}
 		if (nr_node_ids == 1)
 			pflags &= ~SD_SERIALIZE;
 	}
@@ -5905,6 +6010,11 @@ static int init_rootdomain(struct root_domain *rd)
 
 	if (cpupri_init(&rd->cpupri) != 0)
 		goto free_rto_mask;
+
+	init_max_cpu_capacity(&rd->max_cpu_capacity);
+
+	rd->max_cap_orig_cpu = rd->min_cap_orig_cpu = -1;
+
 	return 0;
 
 free_rto_mask:
@@ -6016,11 +6126,14 @@ static void destroy_sched_domains(struct sched_domain *sd)
 DEFINE_PER_CPU(struct sched_domain_shared *, sd_llc_shared);
 DEFINE_PER_CPU(struct sched_domain *, sd_numa);
 DEFINE_PER_CPU(struct sched_domain *, sd_asym);
+DEFINE_PER_CPU(struct sched_domain *, sd_ea);
+DEFINE_PER_CPU(struct sched_domain *, sd_scs);
 
 static void update_top_cache_domain(int cpu)
 {
 	struct sched_domain_shared *sds = NULL;
 	struct sched_domain *sd;
+	struct sched_domain *ea_sd = NULL;
 	int id = cpu;
 	int size = 1;
 
@@ -6041,6 +6154,17 @@ static void update_top_cache_domain(int cpu)
 
 	sd = highest_flag_domain(cpu, SD_ASYM_PACKING);
 	rcu_assign_pointer(per_cpu(sd_asym, cpu), sd);
+
+	for_each_domain(cpu, sd) {
+		if (sd->groups->sge)
+			ea_sd = sd;
+		else
+			break;
+	}
+	rcu_assign_pointer(per_cpu(sd_ea, cpu), ea_sd);
+
+	sd = highest_flag_domain(cpu, SD_SHARE_CAP_STATES);
+	rcu_assign_pointer(per_cpu(sd_scs, cpu), sd);
 }
 
 /*
@@ -6222,6 +6346,8 @@ int group_balance_cpu(struct sched_group *sg)
 		 * die on a /0 trap.
 		 */
 		sg->sgc->capacity = SCHED_CAPACITY_SCALE * cpumask_weight(sg_span);
+		sg->sgc->max_capacity = SCHED_CAPACITY_SCALE;
+		sg->sgc->min_capacity = SCHED_CAPACITY_SCALE;
 
 		/*
 		 * Make sure the first group of this domain contains the
@@ -6350,6 +6476,66 @@ static void init_sched_groups_capacity(int cpu, struct sched_domain *sd)
 }
 
 /*
+ * Check that the per-cpu provided sd energy data is consistent for all cpus
+ * within the mask.
+ */
+static inline void check_sched_energy_data(int cpu, sched_domain_energy_f fn,
+					   const struct cpumask *cpumask)
+{
+	const struct sched_group_energy * const sge = fn(cpu);
+	struct cpumask mask;
+	int i;
+
+	if (cpumask_weight(cpumask) <= 1)
+		return;
+
+	cpumask_xor(&mask, cpumask, get_cpu_mask(cpu));
+
+	for_each_cpu(i, &mask) {
+		const struct sched_group_energy * const e = fn(i);
+		int y;
+
+		BUG_ON(e->nr_idle_states != sge->nr_idle_states);
+
+		for (y = 0; y < (e->nr_idle_states); y++) {
+			BUG_ON(e->idle_states[y].power !=
+					sge->idle_states[y].power);
+		}
+
+		BUG_ON(e->nr_cap_states != sge->nr_cap_states);
+
+		for (y = 0; y < (e->nr_cap_states); y++) {
+			BUG_ON(e->cap_states[y].cap != sge->cap_states[y].cap);
+			BUG_ON(e->cap_states[y].power !=
+					sge->cap_states[y].power);
+		}
+	}
+}
+
+static void init_sched_energy(int cpu, struct sched_domain *sd,
+			      sched_domain_energy_f fn)
+{
+	if (!(fn && fn(cpu)))
+		return;
+
+	if (cpu != group_balance_cpu(sd->groups))
+		return;
+
+	if (sd->child && !sd->child->groups->sge) {
+		pr_err("BUG: EAS setup broken for CPU%d\n", cpu);
+#ifdef CONFIG_SCHED_DEBUG
+		pr_err("     energy data on %s but not on %s domain\n",
+			sd->name, sd->child->name);
+#endif
+		return;
+	}
+
+	check_sched_energy_data(cpu, fn, sched_group_cpus(sd->groups));
+
+	sd->groups->sge = fn(cpu);
+}
+
+/*
  * Initializers for schedule domains
  * Non-inlined to reduce accumulated stack pressure in build_sched_domains()
  */
@@ -6465,6 +6651,7 @@ static void claim_allocations(int cpu, struct sched_domain *sd)
  *   SD_NUMA                - describes NUMA topologies
  *   SD_SHARE_POWERDOMAIN   - describes shared power domain
  *   SD_ASYM_CPUCAPACITY    - describes mixed capacity topologies
+ *   SD_SHARE_CAP_STATES    - describes shared capacity states
  *
  * Odd one out, which beside describing the topology has a quirk also
  * prescribes the desired behaviour that goes along with it:
@@ -6477,7 +6664,8 @@ static void claim_allocations(int cpu, struct sched_domain *sd)
 	 SD_NUMA |			\
 	 SD_ASYM_PACKING |		\
 	 SD_ASYM_CPUCAPACITY |		\
-	 SD_SHARE_POWERDOMAIN)
+	 SD_SHARE_POWERDOMAIN |		\
+	 SD_SHARE_CAP_STATES)
 
 static struct sched_domain *
 sd_init(struct sched_domain_topology_level *tl,
@@ -7035,7 +7223,6 @@ static int build_sched_domains(const struct cpumask *cpu_map,
 	enum s_alloc alloc_state;
 	struct sched_domain *sd;
 	struct s_data d;
-	struct rq *rq = NULL;
 	int i, ret = -ENOMEM;
 
 	alloc_state = __visit_domain_allocation_hell(&d, cpu_map);
@@ -7053,8 +7240,6 @@ static int build_sched_domains(const struct cpumask *cpu_map,
 				*per_cpu_ptr(d.sd, i) = sd;
 			if (tl->flags & SDTL_OVERLAP || sched_feat(FORCE_SD_OVERLAP))
 				sd->flags |= SD_OVERLAP;
-			if (cpumask_equal(cpu_map, sched_domain_span(sd)))
-				break;
 		}
 	}
 
@@ -7074,10 +7259,13 @@ static int build_sched_domains(const struct cpumask *cpu_map,
 
 	/* Calculate CPU capacity for physical packages and nodes */
 	for (i = nr_cpumask_bits-1; i >= 0; i--) {
+		struct sched_domain_topology_level *tl = sched_domain_topology;
+
 		if (!cpumask_test_cpu(i, cpu_map))
 			continue;
 
-		for (sd = *per_cpu_ptr(d.sd, i); sd; sd = sd->parent) {
+		for (sd = *per_cpu_ptr(d.sd, i); sd; sd = sd->parent, tl++) {
+			init_sched_energy(i, sd, tl->energy);
 			claim_allocations(i, sd);
 			init_sched_groups_capacity(i, sd);
 		}
@@ -7086,22 +7274,23 @@ static int build_sched_domains(const struct cpumask *cpu_map,
 	/* Attach the domains */
 	rcu_read_lock();
 	for_each_cpu(i, cpu_map) {
-		rq = cpu_rq(i);
-		sd = *per_cpu_ptr(d.sd, i);
+		int max_cpu = READ_ONCE(d.rd->max_cap_orig_cpu);
+		int min_cpu = READ_ONCE(d.rd->min_cap_orig_cpu);
+
+		if ((max_cpu < 0) || (cpu_rq(i)->cpu_capacity_orig >
+		    cpu_rq(max_cpu)->cpu_capacity_orig))
+			WRITE_ONCE(d.rd->max_cap_orig_cpu, i);
 
-		/* Use READ_ONCE()/WRITE_ONCE() to avoid load/store tearing: */
-		if (rq->cpu_capacity_orig > READ_ONCE(d.rd->max_cpu_capacity))
-			WRITE_ONCE(d.rd->max_cpu_capacity, rq->cpu_capacity_orig);
+		if ((min_cpu < 0) || (cpu_rq(i)->cpu_capacity_orig <
+		    cpu_rq(min_cpu)->cpu_capacity_orig))
+			WRITE_ONCE(d.rd->min_cap_orig_cpu, i);
+
+		sd = *per_cpu_ptr(d.sd, i);
 
 		cpu_attach_domain(sd, d.rd, i);
 	}
 	rcu_read_unlock();
 
-	if (rq && sched_debug_enabled) {
-		pr_info("span: %*pbl (max cpu_capacity = %lu)\n",
-			cpumask_pr_args(cpu_map), rq->rd->max_cpu_capacity);
-	}
-
 	ret = 0;
 error:
 	__free_domain_allocs(&d, alloc_state, cpu_map);
@@ -7444,6 +7633,9 @@ int sched_cpu_dying(unsigned int cpu)
 	/* Handle pending wakeups and then migrate everything off */
 	sched_ttwu_pending();
 	raw_spin_lock_irqsave(&rq->lock, flags);
+
+	walt_migrate_sync_cpu(cpu);
+
 	if (rq->rd) {
 		BUG_ON(!cpumask_test_cpu(cpu, rq->rd->span));
 		set_rq_offline(rq);
@@ -7620,6 +7812,7 @@ void __init sched_init(void)
 #ifdef CONFIG_FAIR_GROUP_SCHED
 		root_task_group.shares = ROOT_TASK_GROUP_LOAD;
 		INIT_LIST_HEAD(&rq->leaf_cfs_rq_list);
+		rq->tmp_alone_branch = &rq->leaf_cfs_rq_list;
 		/*
 		 * How much cpu bandwidth does root_task_group get?
 		 *
@@ -7659,11 +7852,17 @@ void __init sched_init(void)
 		rq->active_balance = 0;
 		rq->next_balance = jiffies;
 		rq->push_cpu = 0;
+		rq->push_task = NULL;
 		rq->cpu = i;
 		rq->online = 0;
 		rq->idle_stamp = 0;
 		rq->avg_idle = 2*sysctl_sched_migration_cost;
 		rq->max_idle_balance_cost = sysctl_sched_migration_cost;
+#ifdef CONFIG_SCHED_WALT
+		rq->cur_irqload = 0;
+		rq->avg_irqload = 0;
+		rq->irqload_ts = 0;
+#endif
 
 		INIT_LIST_HEAD(&rq->cfs_tasks);
 
@@ -7721,6 +7920,14 @@ static inline int preempt_count_equals(int preempt_offset)
 	return (nested == preempt_offset);
 }
 
+static int __might_sleep_init_called;
+int __init __might_sleep_init(void)
+{
+	__might_sleep_init_called = 1;
+	return 0;
+}
+early_initcall(__might_sleep_init);
+
 void __might_sleep(const char *file, int line, int preempt_offset)
 {
 	/*
@@ -7746,8 +7953,10 @@ void ___might_sleep(const char *file, int line, int preempt_offset)
 
 	rcu_sleep_check(); /* WARN_ON_ONCE() by default, no rate limit reqd. */
 	if ((preempt_count_equals(preempt_offset) && !irqs_disabled() &&
-	     !is_idle_task(current)) ||
-	    system_state != SYSTEM_RUNNING || oops_in_progress)
+	     !is_idle_task(current)) || oops_in_progress)
+		return;
+	if (system_state != SYSTEM_RUNNING &&
+	    (!__might_sleep_init_called || system_state != SYSTEM_BOOTING))
 		return;
 	if (time_before(jiffies, prev_jiffy + HZ) && prev_jiffy)
 		return;
@@ -8440,6 +8649,7 @@ static void cpu_cgroup_fork(struct task_struct *task)
 
 	rq = task_rq_lock(task, &rf);
 
+	update_rq_clock(rq);
 	sched_change_group(task, TASK_SET_GROUP);
 
 	task_rq_unlock(rq, task, &rf);
diff --git a/kernel/sched/cpufreq_schedutil.c b/kernel/sched/cpufreq_schedutil.c
index cb771c7..0526dc0 100644
--- a/kernel/sched/cpufreq_schedutil.c
+++ b/kernel/sched/cpufreq_schedutil.c
@@ -12,14 +12,27 @@
 #define pr_fmt(fmt) KBUILD_MODNAME ": " fmt
 
 #include <linux/cpufreq.h>
+#include <linux/kthread.h>
 #include <linux/slab.h>
 #include <trace/events/power.h>
 
 #include "sched.h"
+#include "tune.h"
+
+unsigned long boosted_cpu_util(int cpu);
+
+/* Stub out fast switch routines present on mainline to reduce the backport
+ * overhead. */
+#define cpufreq_driver_fast_switch(x, y) 0
+#define cpufreq_enable_fast_switch(x)
+#define cpufreq_disable_fast_switch(x)
+#define LATENCY_MULTIPLIER			(1000)
+#define SUGOV_KTHREAD_PRIORITY	50
 
 struct sugov_tunables {
 	struct gov_attr_set attr_set;
-	unsigned int rate_limit_us;
+	unsigned int up_rate_limit_us;
+	unsigned int down_rate_limit_us;
 };
 
 struct sugov_policy {
@@ -30,14 +43,18 @@ struct sugov_policy {
 
 	raw_spinlock_t update_lock;  /* For shared policies */
 	u64 last_freq_update_time;
-	s64 freq_update_delay_ns;
+	s64 min_rate_limit_ns;
+	s64 up_rate_delay_ns;
+	s64 down_rate_delay_ns;
 	unsigned int next_freq;
 	unsigned int cached_raw_freq;
 
 	/* The next fields are only needed if fast switch cannot be used. */
 	struct irq_work irq_work;
-	struct work_struct work;
+	struct kthread_work work;
 	struct mutex work_lock;
+	struct kthread_worker worker;
+	struct task_struct *thread;
 	bool work_in_progress;
 
 	bool need_freq_update;
@@ -55,6 +72,11 @@ struct sugov_cpu {
 	unsigned long util;
 	unsigned long max;
 	unsigned int flags;
+
+	/* The field below is for single-CPU policies only. */
+#ifdef CONFIG_NO_HZ_COMMON
+	unsigned long saved_idle_calls;
+#endif
 };
 
 static DEFINE_PER_CPU(struct sugov_cpu, sugov_cpu);
@@ -79,7 +101,27 @@ static bool sugov_should_update_freq(struct sugov_policy *sg_policy, u64 time)
 	}
 
 	delta_ns = time - sg_policy->last_freq_update_time;
-	return delta_ns >= sg_policy->freq_update_delay_ns;
+
+	/* No need to recalculate next freq for min_rate_limit_us at least */
+	return delta_ns >= sg_policy->min_rate_limit_ns;
+}
+
+static bool sugov_up_down_rate_limit(struct sugov_policy *sg_policy, u64 time,
+				     unsigned int next_freq)
+{
+	s64 delta_ns;
+
+	delta_ns = time - sg_policy->last_freq_update_time;
+
+	if (next_freq > sg_policy->next_freq &&
+	    delta_ns < sg_policy->up_rate_delay_ns)
+			return true;
+
+	if (next_freq < sg_policy->next_freq &&
+	    delta_ns < sg_policy->down_rate_delay_ns)
+			return true;
+
+	return false;
 }
 
 static void sugov_update_commit(struct sugov_policy *sg_policy, u64 time,
@@ -87,22 +129,26 @@ static void sugov_update_commit(struct sugov_policy *sg_policy, u64 time,
 {
 	struct cpufreq_policy *policy = sg_policy->policy;
 
+	if (sugov_up_down_rate_limit(sg_policy, time, next_freq)) {
+		/* Reset cached freq as next_freq isn't changed */
+		sg_policy->cached_raw_freq = 0;
+		return;
+	}
+
+	if (sg_policy->next_freq == next_freq)
+		return;
+
+	sg_policy->next_freq = next_freq;
 	sg_policy->last_freq_update_time = time;
 
 	if (policy->fast_switch_enabled) {
-		if (sg_policy->next_freq == next_freq) {
-			trace_cpu_frequency(policy->cur, smp_processor_id());
-			return;
-		}
-		sg_policy->next_freq = next_freq;
 		next_freq = cpufreq_driver_fast_switch(policy, next_freq);
 		if (next_freq == CPUFREQ_ENTRY_INVALID)
 			return;
 
 		policy->cur = next_freq;
 		trace_cpu_frequency(next_freq, smp_processor_id());
-	} else if (sg_policy->next_freq != next_freq) {
-		sg_policy->next_freq = next_freq;
+	} else {
 		sg_policy->work_in_progress = true;
 		irq_work_queue(&sg_policy->irq_work);
 	}
@@ -110,7 +156,7 @@ static void sugov_update_commit(struct sugov_policy *sg_policy, u64 time,
 
 /**
  * get_next_freq - Compute a new frequency for a given cpufreq policy.
- * @sg_cpu: schedutil cpu object to compute the new frequency for.
+ * @sg_policy: schedutil policy object to compute the new frequency for.
  * @util: Current CPU utilization.
  * @max: CPU capacity.
  *
@@ -130,10 +176,9 @@ static void sugov_update_commit(struct sugov_policy *sg_policy, u64 time,
  * next_freq (as calculated above) is returned, subject to policy min/max and
  * cpufreq driver limitations.
  */
-static unsigned int get_next_freq(struct sugov_cpu *sg_cpu, unsigned long util,
-				  unsigned long max)
+static unsigned int get_next_freq(struct sugov_policy *sg_policy,
+				  unsigned long util, unsigned long max)
 {
-	struct sugov_policy *sg_policy = sg_cpu->sg_policy;
 	struct cpufreq_policy *policy = sg_policy->policy;
 	unsigned int freq = arch_scale_freq_invariant() ?
 				policy->cpuinfo.max_freq : policy->cur;
@@ -146,15 +191,36 @@ static unsigned int get_next_freq(struct sugov_cpu *sg_cpu, unsigned long util,
 	return cpufreq_driver_resolve_freq(policy, freq);
 }
 
-static void sugov_get_util(unsigned long *util, unsigned long *max)
+static inline bool use_pelt(void)
 {
-	struct rq *rq = this_rq();
-	unsigned long cfs_max;
+#ifdef CONFIG_SCHED_WALT
+	return (!sysctl_sched_use_walt_cpu_util || walt_disabled);
+#else
+	return true;
+#endif
+}
+
+static void sugov_get_util(unsigned long *util, unsigned long *max, u64 time)
+{
+	int cpu = smp_processor_id();
+	struct rq *rq = cpu_rq(cpu);
+	unsigned long max_cap, rt;
+	s64 delta;
+
+	max_cap = arch_scale_cpu_capacity(NULL, cpu);
 
-	cfs_max = arch_scale_cpu_capacity(NULL, smp_processor_id());
+	sched_avg_update(rq);
+	delta = time - rq->age_stamp;
+	if (unlikely(delta < 0))
+		delta = 0;
+	rt = div64_u64(rq->rt_avg, sched_avg_period() + delta);
+	rt = (rt * max_cap) >> SCHED_CAPACITY_SHIFT;
 
-	*util = min(rq->cfs.avg.util_avg, cfs_max);
-	*max = cfs_max;
+	*util = boosted_cpu_util(cpu);
+	if (likely(use_pelt()))
+		*util = min((*util + rt), max_cap);
+
+	*max = max_cap;
 }
 
 static void sugov_set_iowait_boost(struct sugov_cpu *sg_cpu, u64 time,
@@ -187,6 +253,19 @@ static void sugov_iowait_boost(struct sugov_cpu *sg_cpu, unsigned long *util,
 	sg_cpu->iowait_boost >>= 1;
 }
 
+#ifdef CONFIG_NO_HZ_COMMON
+static bool sugov_cpu_is_busy(struct sugov_cpu *sg_cpu)
+{
+	unsigned long idle_calls = tick_nohz_get_idle_calls();
+	bool ret = idle_calls == sg_cpu->saved_idle_calls;
+
+	sg_cpu->saved_idle_calls = idle_calls;
+	return ret;
+}
+#else
+static inline bool sugov_cpu_is_busy(struct sugov_cpu *sg_cpu) { return false; }
+#endif /* CONFIG_NO_HZ_COMMON */
+
 static void sugov_update_single(struct update_util_data *hook, u64 time,
 				unsigned int flags)
 {
@@ -195,6 +274,7 @@ static void sugov_update_single(struct update_util_data *hook, u64 time,
 	struct cpufreq_policy *policy = sg_policy->policy;
 	unsigned long util, max;
 	unsigned int next_f;
+	bool busy;
 
 	sugov_set_iowait_boost(sg_cpu, time, flags);
 	sg_cpu->last_update = time;
@@ -202,40 +282,40 @@ static void sugov_update_single(struct update_util_data *hook, u64 time,
 	if (!sugov_should_update_freq(sg_policy, time))
 		return;
 
-	if (flags & SCHED_CPUFREQ_RT_DL) {
+	busy = sugov_cpu_is_busy(sg_cpu);
+
+	if (flags & SCHED_CPUFREQ_DL) {
 		next_f = policy->cpuinfo.max_freq;
 	} else {
-		sugov_get_util(&util, &max);
+		sugov_get_util(&util, &max, time);
 		sugov_iowait_boost(sg_cpu, &util, &max);
-		next_f = get_next_freq(sg_cpu, util, max);
+		next_f = get_next_freq(sg_policy, util, max);
+		/*
+		 * Do not reduce the frequency if the CPU has not been idle
+		 * recently, as the reduction is likely to be premature then.
+		 */
+		if (busy && next_f < sg_policy->next_freq) {
+			next_f = sg_policy->next_freq;
+
+			/* Reset cached freq as next_freq has changed */
+			sg_policy->cached_raw_freq = 0;
+		}
 	}
 	sugov_update_commit(sg_policy, time, next_f);
 }
 
-static unsigned int sugov_next_freq_shared(struct sugov_cpu *sg_cpu,
-					   unsigned long util, unsigned long max,
-					   unsigned int flags)
+static unsigned int sugov_next_freq_shared(struct sugov_cpu *sg_cpu, u64 time)
 {
 	struct sugov_policy *sg_policy = sg_cpu->sg_policy;
 	struct cpufreq_policy *policy = sg_policy->policy;
-	unsigned int max_f = policy->cpuinfo.max_freq;
-	u64 last_freq_update_time = sg_policy->last_freq_update_time;
+	unsigned long util = 0, max = 1;
 	unsigned int j;
 
-	if (flags & SCHED_CPUFREQ_RT_DL)
-		return max_f;
-
-	sugov_iowait_boost(sg_cpu, &util, &max);
-
 	for_each_cpu(j, policy->cpus) {
-		struct sugov_cpu *j_sg_cpu;
+		struct sugov_cpu *j_sg_cpu = &per_cpu(sugov_cpu, j);
 		unsigned long j_util, j_max;
 		s64 delta_ns;
 
-		if (j == smp_processor_id())
-			continue;
-
-		j_sg_cpu = &per_cpu(sugov_cpu, j);
 		/*
 		 * If the CPU utilization was last updated before the previous
 		 * frequency update and the time elapsed between the last update
@@ -243,13 +323,13 @@ static unsigned int sugov_next_freq_shared(struct sugov_cpu *sg_cpu,
 		 * enough, don't take the CPU into account as it probably is
 		 * idle now (and clear iowait_boost for it).
 		 */
-		delta_ns = last_freq_update_time - j_sg_cpu->last_update;
+		delta_ns = time - j_sg_cpu->last_update;
 		if (delta_ns > TICK_NSEC) {
 			j_sg_cpu->iowait_boost = 0;
 			continue;
 		}
-		if (j_sg_cpu->flags & SCHED_CPUFREQ_RT_DL)
-			return max_f;
+		if (j_sg_cpu->flags & SCHED_CPUFREQ_DL)
+			return policy->cpuinfo.max_freq;
 
 		j_util = j_sg_cpu->util;
 		j_max = j_sg_cpu->max;
@@ -261,7 +341,7 @@ static unsigned int sugov_next_freq_shared(struct sugov_cpu *sg_cpu,
 		sugov_iowait_boost(j_sg_cpu, &util, &max);
 	}
 
-	return get_next_freq(sg_cpu, util, max);
+	return get_next_freq(sg_policy, util, max);
 }
 
 static void sugov_update_shared(struct update_util_data *hook, u64 time,
@@ -272,7 +352,7 @@ static void sugov_update_shared(struct update_util_data *hook, u64 time,
 	unsigned long util, max;
 	unsigned int next_f;
 
-	sugov_get_util(&util, &max);
+	sugov_get_util(&util, &max, time);
 
 	raw_spin_lock(&sg_policy->update_lock);
 
@@ -284,14 +364,18 @@ static void sugov_update_shared(struct update_util_data *hook, u64 time,
 	sg_cpu->last_update = time;
 
 	if (sugov_should_update_freq(sg_policy, time)) {
-		next_f = sugov_next_freq_shared(sg_cpu, util, max, flags);
+		if (flags & SCHED_CPUFREQ_DL)
+			next_f = sg_policy->policy->cpuinfo.max_freq;
+		else
+			next_f = sugov_next_freq_shared(sg_cpu, time);
+
 		sugov_update_commit(sg_policy, time, next_f);
 	}
 
 	raw_spin_unlock(&sg_policy->update_lock);
 }
 
-static void sugov_work(struct work_struct *work)
+static void sugov_work(struct kthread_work *work)
 {
 	struct sugov_policy *sg_policy = container_of(work, struct sugov_policy, work);
 
@@ -308,7 +392,21 @@ static void sugov_irq_work(struct irq_work *irq_work)
 	struct sugov_policy *sg_policy;
 
 	sg_policy = container_of(irq_work, struct sugov_policy, irq_work);
-	schedule_work_on(smp_processor_id(), &sg_policy->work);
+
+	/*
+	 * For RT and deadline tasks, the schedutil governor shoots the
+	 * frequency to maximum. Special care must be taken to ensure that this
+	 * kthread doesn't result in the same behavior.
+	 *
+	 * This is (mostly) guaranteed by the work_in_progress flag. The flag is
+	 * updated only at the end of the sugov_work() function and before that
+	 * the schedutil governor rejects all other frequency scaling requests.
+	 *
+	 * There is a very rare case though, where the RT thread yields right
+	 * after the work_in_progress flag is cleared. The effects of that are
+	 * neglected for now.
+	 */
+	kthread_queue_work(&sg_policy->worker, &sg_policy->work);
 }
 
 /************************** sysfs interface ************************/
@@ -321,15 +419,32 @@ static inline struct sugov_tunables *to_sugov_tunables(struct gov_attr_set *attr
 	return container_of(attr_set, struct sugov_tunables, attr_set);
 }
 
-static ssize_t rate_limit_us_show(struct gov_attr_set *attr_set, char *buf)
+static DEFINE_MUTEX(min_rate_lock);
+
+static void update_min_rate_limit_us(struct sugov_policy *sg_policy)
+{
+	mutex_lock(&min_rate_lock);
+	sg_policy->min_rate_limit_ns = min(sg_policy->up_rate_delay_ns,
+					   sg_policy->down_rate_delay_ns);
+	mutex_unlock(&min_rate_lock);
+}
+
+static ssize_t up_rate_limit_us_show(struct gov_attr_set *attr_set, char *buf)
+{
+	struct sugov_tunables *tunables = to_sugov_tunables(attr_set);
+
+	return sprintf(buf, "%u\n", tunables->up_rate_limit_us);
+}
+
+static ssize_t down_rate_limit_us_show(struct gov_attr_set *attr_set, char *buf)
 {
 	struct sugov_tunables *tunables = to_sugov_tunables(attr_set);
 
-	return sprintf(buf, "%u\n", tunables->rate_limit_us);
+	return sprintf(buf, "%u\n", tunables->down_rate_limit_us);
 }
 
-static ssize_t rate_limit_us_store(struct gov_attr_set *attr_set, const char *buf,
-				   size_t count)
+static ssize_t up_rate_limit_us_store(struct gov_attr_set *attr_set,
+				      const char *buf, size_t count)
 {
 	struct sugov_tunables *tunables = to_sugov_tunables(attr_set);
 	struct sugov_policy *sg_policy;
@@ -338,18 +453,42 @@ static ssize_t rate_limit_us_store(struct gov_attr_set *attr_set, const char *bu
 	if (kstrtouint(buf, 10, &rate_limit_us))
 		return -EINVAL;
 
-	tunables->rate_limit_us = rate_limit_us;
+	tunables->up_rate_limit_us = rate_limit_us;
 
-	list_for_each_entry(sg_policy, &attr_set->policy_list, tunables_hook)
-		sg_policy->freq_update_delay_ns = rate_limit_us * NSEC_PER_USEC;
+	list_for_each_entry(sg_policy, &attr_set->policy_list, tunables_hook) {
+		sg_policy->up_rate_delay_ns = rate_limit_us * NSEC_PER_USEC;
+		update_min_rate_limit_us(sg_policy);
+	}
 
 	return count;
 }
 
-static struct governor_attr rate_limit_us = __ATTR_RW(rate_limit_us);
+static ssize_t down_rate_limit_us_store(struct gov_attr_set *attr_set,
+					const char *buf, size_t count)
+{
+	struct sugov_tunables *tunables = to_sugov_tunables(attr_set);
+	struct sugov_policy *sg_policy;
+	unsigned int rate_limit_us;
+
+	if (kstrtouint(buf, 10, &rate_limit_us))
+		return -EINVAL;
+
+	tunables->down_rate_limit_us = rate_limit_us;
+
+	list_for_each_entry(sg_policy, &attr_set->policy_list, tunables_hook) {
+		sg_policy->down_rate_delay_ns = rate_limit_us * NSEC_PER_USEC;
+		update_min_rate_limit_us(sg_policy);
+	}
+
+	return count;
+}
+
+static struct governor_attr up_rate_limit_us = __ATTR_RW(up_rate_limit_us);
+static struct governor_attr down_rate_limit_us = __ATTR_RW(down_rate_limit_us);
 
 static struct attribute *sugov_attributes[] = {
-	&rate_limit_us.attr,
+	&up_rate_limit_us.attr,
+	&down_rate_limit_us.attr,
 	NULL
 };
 
@@ -371,19 +510,64 @@ static struct sugov_policy *sugov_policy_alloc(struct cpufreq_policy *policy)
 		return NULL;
 
 	sg_policy->policy = policy;
-	init_irq_work(&sg_policy->irq_work, sugov_irq_work);
-	INIT_WORK(&sg_policy->work, sugov_work);
-	mutex_init(&sg_policy->work_lock);
 	raw_spin_lock_init(&sg_policy->update_lock);
 	return sg_policy;
 }
 
 static void sugov_policy_free(struct sugov_policy *sg_policy)
 {
-	mutex_destroy(&sg_policy->work_lock);
 	kfree(sg_policy);
 }
 
+static int sugov_kthread_create(struct sugov_policy *sg_policy)
+{
+	struct task_struct *thread;
+	struct sched_param param = { .sched_priority = MAX_USER_RT_PRIO / 2 };
+	struct cpufreq_policy *policy = sg_policy->policy;
+	int ret;
+
+	/* kthread only required for slow path */
+	if (policy->fast_switch_enabled)
+		return 0;
+
+	kthread_init_work(&sg_policy->work, sugov_work);
+	kthread_init_worker(&sg_policy->worker);
+	thread = kthread_create(kthread_worker_fn, &sg_policy->worker,
+				"sugov:%d",
+				cpumask_first(policy->related_cpus));
+	if (IS_ERR(thread)) {
+		pr_err("failed to create sugov thread: %ld\n", PTR_ERR(thread));
+		return PTR_ERR(thread);
+	}
+
+	ret = sched_setscheduler_nocheck(thread, SCHED_FIFO, &param);
+	if (ret) {
+		kthread_stop(thread);
+		pr_warn("%s: failed to set SCHED_FIFO\n", __func__);
+		return ret;
+	}
+
+	sg_policy->thread = thread;
+	kthread_bind_mask(thread, policy->related_cpus);
+	init_irq_work(&sg_policy->irq_work, sugov_irq_work);
+	mutex_init(&sg_policy->work_lock);
+
+	wake_up_process(thread);
+
+	return 0;
+}
+
+static void sugov_kthread_stop(struct sugov_policy *sg_policy)
+{
+	/* kthread only required for slow path */
+	if (sg_policy->policy->fast_switch_enabled)
+		return;
+
+	kthread_flush_worker(&sg_policy->worker);
+	kthread_stop(sg_policy->thread);
+	mutex_destroy(&sg_policy->work_lock);
+}
+
 static struct sugov_tunables *sugov_tunables_alloc(struct sugov_policy *sg_policy)
 {
 	struct sugov_tunables *tunables;
@@ -409,23 +593,30 @@ static int sugov_init(struct cpufreq_policy *policy)
 {
 	struct sugov_policy *sg_policy;
 	struct sugov_tunables *tunables;
-	unsigned int lat;
 	int ret = 0;
 
 	/* State should be equivalent to EXIT */
 	if (policy->governor_data)
 		return -EBUSY;
 
+	cpufreq_enable_fast_switch(policy);
+
 	sg_policy = sugov_policy_alloc(policy);
-	if (!sg_policy)
-		return -ENOMEM;
+	if (!sg_policy) {
+		ret = -ENOMEM;
+		goto disable_fast_switch;
+	}
+
+	ret = sugov_kthread_create(sg_policy);
+	if (ret)
+		goto free_sg_policy;
 
 	mutex_lock(&global_tunables_lock);
 
 	if (global_tunables) {
 		if (WARN_ON(have_governor_per_policy())) {
 			ret = -EINVAL;
-			goto free_sg_policy;
+			goto stop_kthread;
 		}
 		policy->governor_data = sg_policy;
 		sg_policy->tunables = global_tunables;
@@ -437,13 +628,23 @@ static int sugov_init(struct cpufreq_policy *policy)
 	tunables = sugov_tunables_alloc(sg_policy);
 	if (!tunables) {
 		ret = -ENOMEM;
-		goto free_sg_policy;
+		goto stop_kthread;
 	}
 
-	tunables->rate_limit_us = LATENCY_MULTIPLIER;
-	lat = policy->cpuinfo.transition_latency / NSEC_PER_USEC;
-	if (lat)
-		tunables->rate_limit_us *= lat;
+	if (policy->up_transition_delay_us && policy->down_transition_delay_us) {
+		tunables->up_rate_limit_us = policy->up_transition_delay_us;
+		tunables->down_rate_limit_us = policy->down_transition_delay_us;
+	} else {
+		unsigned int lat;
+
+                tunables->up_rate_limit_us = LATENCY_MULTIPLIER;
+                tunables->down_rate_limit_us = LATENCY_MULTIPLIER;
+		lat = policy->cpuinfo.transition_latency / NSEC_PER_USEC;
+		if (lat) {
+                        tunables->up_rate_limit_us *= lat;
+                        tunables->down_rate_limit_us *= lat;
+                }
+	}
 
 	policy->governor_data = sg_policy;
 	sg_policy->tunables = tunables;
@@ -454,20 +655,25 @@ static int sugov_init(struct cpufreq_policy *policy)
 	if (ret)
 		goto fail;
 
- out:
+out:
 	mutex_unlock(&global_tunables_lock);
-
-	cpufreq_enable_fast_switch(policy);
 	return 0;
 
- fail:
+fail:
 	policy->governor_data = NULL;
 	sugov_tunables_free(tunables);
 
+ stop_kthread:
+	sugov_kthread_stop(sg_policy);
+
  free_sg_policy:
 	mutex_unlock(&global_tunables_lock);
 
 	sugov_policy_free(sg_policy);
+
+disable_fast_switch:
+	cpufreq_disable_fast_switch(policy);
+
 	pr_err("initialization failed (error %d)\n", ret);
 	return ret;
 }
@@ -478,8 +684,6 @@ static void sugov_exit(struct cpufreq_policy *policy)
 	struct sugov_tunables *tunables = sg_policy->tunables;
 	unsigned int count;
 
-	cpufreq_disable_fast_switch(policy);
-
 	mutex_lock(&global_tunables_lock);
 
 	count = gov_attr_set_put(&tunables->attr_set, &sg_policy->tunables_hook);
@@ -489,7 +693,10 @@ static void sugov_exit(struct cpufreq_policy *policy)
 
 	mutex_unlock(&global_tunables_lock);
 
+	sugov_kthread_stop(sg_policy);
 	sugov_policy_free(sg_policy);
+
+	cpufreq_disable_fast_switch(policy);
 }
 
 static int sugov_start(struct cpufreq_policy *policy)
@@ -497,7 +704,11 @@ static int sugov_start(struct cpufreq_policy *policy)
 	struct sugov_policy *sg_policy = policy->governor_data;
 	unsigned int cpu;
 
-	sg_policy->freq_update_delay_ns = sg_policy->tunables->rate_limit_us * NSEC_PER_USEC;
+	sg_policy->up_rate_delay_ns =
+		sg_policy->tunables->up_rate_limit_us * NSEC_PER_USEC;
+	sg_policy->down_rate_delay_ns =
+		sg_policy->tunables->down_rate_limit_us * NSEC_PER_USEC;
+	update_min_rate_limit_us(sg_policy);
 	sg_policy->last_freq_update_time = 0;
 	sg_policy->next_freq = UINT_MAX;
 	sg_policy->work_in_progress = false;
@@ -509,7 +720,7 @@ static int sugov_start(struct cpufreq_policy *policy)
 
 		memset(sg_cpu, 0, sizeof(*sg_cpu));
 		sg_cpu->sg_policy = sg_policy;
-		sg_cpu->flags = SCHED_CPUFREQ_RT;
+		sg_cpu->flags = SCHED_CPUFREQ_DL;
 		sg_cpu->iowait_boost_max = policy->cpuinfo.max_freq;
 		cpufreq_add_update_util_hook(cpu, &sg_cpu->update_util,
 					     policy_is_shared(policy) ?
@@ -529,8 +740,10 @@ static void sugov_stop(struct cpufreq_policy *policy)
 
 	synchronize_sched();
 
-	irq_work_sync(&sg_policy->irq_work);
-	cancel_work_sync(&sg_policy->work);
+	if (!policy->fast_switch_enabled) {
+		irq_work_sync(&sg_policy->irq_work);
+		kthread_cancel_work_sync(&sg_policy->work);
+	}
 }
 
 static void sugov_limits(struct cpufreq_policy *policy)
diff --git a/kernel/sched/cputime.c b/kernel/sched/cputime.c
index 5ebee31..9fc85ba 100644
--- a/kernel/sched/cputime.c
+++ b/kernel/sched/cputime.c
@@ -4,11 +4,12 @@
 #include <linux/kernel_stat.h>
 #include <linux/static_key.h>
 #include <linux/context_tracking.h>
+#include <linux/cpufreq_times.h>
 #include "sched.h"
 #ifdef CONFIG_PARAVIRT
 #include <asm/paravirt.h>
 #endif
-
+#include "walt.h"
 
 #ifdef CONFIG_IRQ_TIME_ACCOUNTING
 
@@ -46,11 +47,18 @@ void irqtime_account_irq(struct task_struct *curr)
 	struct irqtime *irqtime = this_cpu_ptr(&cpu_irqtime);
 	s64 delta;
 	int cpu;
+#ifdef CONFIG_SCHED_WALT
+	u64 wallclock;
+	bool account = true;
+#endif
 
 	if (!sched_clock_irqtime)
 		return;
 
 	cpu = smp_processor_id();
+#ifdef CONFIG_SCHED_WALT
+	wallclock = sched_clock_cpu(cpu);
+#endif
 	delta = sched_clock_cpu(cpu) - irqtime->irq_start_time;
 	irqtime->irq_start_time += delta;
 
@@ -65,8 +73,16 @@ void irqtime_account_irq(struct task_struct *curr)
 		irqtime->hardirq_time += delta;
 	else if (in_serving_softirq() && curr != this_cpu_ksoftirqd())
 		irqtime->softirq_time += delta;
+#ifdef CONFIG_SCHED_WALT
+	else
+		account = false;
+#endif
 
 	u64_stats_update_end(&irqtime->sync);
+#ifdef CONFIG_SCHED_WALT
+	if (account)
+		walt_account_irqtime(cpu, curr, delta, wallclock);
+#endif
 }
 EXPORT_SYMBOL_GPL(irqtime_account_irq);
 
@@ -147,6 +163,9 @@ void account_user_time(struct task_struct *p, cputime_t cputime,
 
 	/* Account for user time used */
 	acct_account_cputime(p);
+
+	/* Account power usage for user time */
+	cpufreq_acct_update_power(p, cputime);
 }
 
 /*
@@ -197,6 +216,9 @@ void __account_system_time(struct task_struct *p, cputime_t cputime,
 
 	/* Account for system time used */
 	acct_account_cputime(p);
+
+	/* Account power usage for system time */
+	cpufreq_acct_update_power(p, cputime);
 }
 
 /*
diff --git a/kernel/sched/deadline.c b/kernel/sched/deadline.c
index 3042927..d464490 100644
--- a/kernel/sched/deadline.c
+++ b/kernel/sched/deadline.c
@@ -18,6 +18,8 @@
 
 #include <linux/slab.h>
 
+#include "walt.h"
+
 struct dl_bandwidth def_dl_bandwidth;
 
 static inline struct task_struct *dl_task_of(struct sched_dl_entity *dl_se)
@@ -947,6 +949,7 @@ void inc_dl_tasks(struct sched_dl_entity *dl_se, struct dl_rq *dl_rq)
 	WARN_ON(!dl_prio(prio));
 	dl_rq->dl_nr_running++;
 	add_nr_running(rq_of_dl_rq(dl_rq), 1);
+	walt_inc_cumulative_runnable_avg(rq_of_dl_rq(dl_rq), dl_task_of(dl_se));
 
 	inc_dl_deadline(dl_rq, deadline);
 	inc_dl_migration(dl_se, dl_rq);
@@ -961,6 +964,7 @@ void dec_dl_tasks(struct sched_dl_entity *dl_se, struct dl_rq *dl_rq)
 	WARN_ON(!dl_rq->dl_nr_running);
 	dl_rq->dl_nr_running--;
 	sub_nr_running(rq_of_dl_rq(dl_rq), 1);
+	walt_dec_cumulative_runnable_avg(rq_of_dl_rq(dl_rq), dl_task_of(dl_se));
 
 	dec_dl_deadline(dl_rq, dl_se->deadline);
 	dec_dl_migration(dl_se, dl_rq);
@@ -1628,7 +1632,9 @@ static int push_dl_task(struct rq *rq)
 	}
 
 	deactivate_task(rq, next_task, 0);
+	next_task->on_rq = TASK_ON_RQ_MIGRATING;
 	set_task_cpu(next_task, later_rq->cpu);
+	next_task->on_rq = TASK_ON_RQ_QUEUED;
 	activate_task(later_rq, next_task, 0);
 	ret = 1;
 
@@ -1716,7 +1722,9 @@ static void pull_dl_task(struct rq *this_rq)
 			resched = true;
 
 			deactivate_task(src_rq, p, 0);
+			p->on_rq = TASK_ON_RQ_MIGRATING;
 			set_task_cpu(p, this_cpu);
+			p->on_rq = TASK_ON_RQ_QUEUED;
 			activate_task(this_rq, p, 0);
 			dmin = p->dl.deadline;
 
diff --git a/kernel/sched/debug.c b/kernel/sched/debug.c
index fa178b6..00d2aff 100644
--- a/kernel/sched/debug.c
+++ b/kernel/sched/debug.c
@@ -31,7 +31,7 @@
 	if (m)					\
 		seq_printf(m, x);		\
 	else					\
-		printk(x);			\
+		pr_cont(x);			\
  } while (0)
 
 /*
@@ -261,9 +261,60 @@ static void sd_free_ctl_entry(struct ctl_table **tablep)
 }
 
 static struct ctl_table *
+sd_alloc_ctl_energy_table(struct sched_group_energy *sge)
+{
+	struct ctl_table *table = sd_alloc_ctl_entry(5);
+
+	if (table == NULL)
+		return NULL;
+
+	set_table_entry(&table[0], "nr_idle_states", &sge->nr_idle_states,
+			sizeof(int), 0644, proc_dointvec_minmax, false);
+	set_table_entry(&table[1], "idle_states", &sge->idle_states[0].power,
+			sge->nr_idle_states*sizeof(struct idle_state), 0644,
+			proc_doulongvec_minmax, false);
+	set_table_entry(&table[2], "nr_cap_states", &sge->nr_cap_states,
+			sizeof(int), 0644, proc_dointvec_minmax, false);
+	set_table_entry(&table[3], "cap_states", &sge->cap_states[0].cap,
+			sge->nr_cap_states*sizeof(struct capacity_state), 0644,
+			proc_doulongvec_minmax, false);
+
+	return table;
+}
+
+static struct ctl_table *
+sd_alloc_ctl_group_table(struct sched_group *sg)
+{
+	struct ctl_table *table = sd_alloc_ctl_entry(2);
+
+	if (table == NULL)
+		return NULL;
+
+	table->procname = kstrdup("energy", GFP_KERNEL);
+	table->mode = 0555;
+	table->child = sd_alloc_ctl_energy_table((struct sched_group_energy *)sg->sge);
+
+	return table;
+}
+
+static struct ctl_table *
 sd_alloc_ctl_domain_table(struct sched_domain *sd)
 {
-	struct ctl_table *table = sd_alloc_ctl_entry(14);
+	struct ctl_table *table;
+	unsigned int nr_entries = 14;
+
+	int i = 0;
+	struct sched_group *sg = sd->groups;
+
+	if (sg->sge) {
+		int nr_sgs = 0;
+
+		do {} while (nr_sgs++, sg = sg->next, sg != sd->groups);
+
+		nr_entries += nr_sgs;
+	}
+
+	table = sd_alloc_ctl_entry(nr_entries);
 
 	if (table == NULL)
 		return NULL;
@@ -296,7 +347,19 @@ static void sd_free_ctl_entry(struct ctl_table **tablep)
 		sizeof(long), 0644, proc_doulongvec_minmax, false);
 	set_table_entry(&table[12], "name", sd->name,
 		CORENAME_MAX_SIZE, 0444, proc_dostring, false);
-	/* &table[13] is terminator */
+	sg = sd->groups;
+	if (sg->sge) {
+		char buf[32];
+		struct ctl_table *entry = &table[13];
+
+		do {
+			snprintf(buf, 32, "group%d", i);
+			entry->procname = kstrdup(buf, GFP_KERNEL);
+			entry->mode = 0555;
+			entry->child = sd_alloc_ctl_group_table(sg);
+		} while (entry++, i++, sg = sg->next, sg != sd->groups);
+	}
+	/* &table[nr_entries-1] is terminator */
 
 	return table;
 }
@@ -918,7 +981,33 @@ void proc_sched_show_task(struct task_struct *p, struct seq_file *m)
 		P_SCHEDSTAT(se.statistics.nr_wakeups_affine_attempts);
 		P_SCHEDSTAT(se.statistics.nr_wakeups_passive);
 		P_SCHEDSTAT(se.statistics.nr_wakeups_idle);
-
+		/* eas */
+		/* select_idle_sibling() */
+		P_SCHEDSTAT(se.statistics.nr_wakeups_sis_attempts);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_sis_idle);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_sis_cache_affine);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_sis_suff_cap);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_sis_idle_cpu);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_sis_count);
+		/* select_energy_cpu_brute() */
+		P_SCHEDSTAT(se.statistics.nr_wakeups_secb_attempts);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_secb_sync);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_secb_idle_bt);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_secb_insuff_cap);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_secb_no_nrg_sav);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_secb_nrg_sav);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_secb_count);
+		/* find_best_target() */
+		P_SCHEDSTAT(se.statistics.nr_wakeups_fbt_attempts);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_fbt_no_cpu);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_fbt_no_sd);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_fbt_pref_idle);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_fbt_count);
+		/* cas */
+		/* select_task_rq_fair() */
+		P_SCHEDSTAT(se.statistics.nr_wakeups_cas_attempts);
+		P_SCHEDSTAT(se.statistics.nr_wakeups_cas_count);
+ 
 		avg_atom = p->se.sum_exec_runtime;
 		if (nr_switches)
 			avg_atom = div64_ul(avg_atom, nr_switches);
diff --git a/kernel/sched/energy.c b/kernel/sched/energy.c
new file mode 100644
index 00000000..b0656b7
--- /dev/null
+++ b/kernel/sched/energy.c
@@ -0,0 +1,124 @@
+/*
+ * Obtain energy cost data from DT and populate relevant scheduler data
+ * structures.
+ *
+ * Copyright (C) 2015 ARM Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+#define pr_fmt(fmt) "sched-energy: " fmt
+
+#define DEBUG
+
+#include <linux/gfp.h>
+#include <linux/of.h>
+#include <linux/printk.h>
+#include <linux/sched.h>
+#include <linux/sched_energy.h>
+#include <linux/stddef.h>
+
+struct sched_group_energy *sge_array[NR_CPUS][NR_SD_LEVELS];
+
+static void free_resources(void)
+{
+	int cpu, sd_level;
+	struct sched_group_energy *sge;
+
+	for_each_possible_cpu(cpu) {
+		for_each_possible_sd_level(sd_level) {
+			sge = sge_array[cpu][sd_level];
+			if (sge) {
+				kfree(sge->cap_states);
+				kfree(sge->idle_states);
+				kfree(sge);
+			}
+		}
+	}
+}
+
+void init_sched_energy_costs(void)
+{
+	struct device_node *cn, *cp;
+	struct capacity_state *cap_states;
+	struct idle_state *idle_states;
+	struct sched_group_energy *sge;
+	const struct property *prop;
+	int sd_level, i, nstates, cpu;
+	const __be32 *val;
+
+	for_each_possible_cpu(cpu) {
+		cn = of_get_cpu_node(cpu, NULL);
+		if (!cn) {
+			pr_warn("CPU device node missing for CPU %d\n", cpu);
+			return;
+		}
+
+		if (!of_find_property(cn, "sched-energy-costs", NULL)) {
+			pr_warn("CPU device node has no sched-energy-costs\n");
+			return;
+		}
+
+		for_each_possible_sd_level(sd_level) {
+			cp = of_parse_phandle(cn, "sched-energy-costs", sd_level);
+			if (!cp)
+				break;
+
+			prop = of_find_property(cp, "busy-cost-data", NULL);
+			if (!prop || !prop->value) {
+				pr_warn("No busy-cost data, skipping sched_energy init\n");
+				goto out;
+			}
+
+			sge = kcalloc(1, sizeof(struct sched_group_energy),
+				      GFP_NOWAIT);
+
+			nstates = (prop->length / sizeof(u32)) / 2;
+			cap_states = kcalloc(nstates,
+					     sizeof(struct capacity_state),
+					     GFP_NOWAIT);
+
+			for (i = 0, val = prop->value; i < nstates; i++) {
+				cap_states[i].cap = be32_to_cpup(val++);
+				cap_states[i].power = be32_to_cpup(val++);
+			}
+
+			sge->nr_cap_states = nstates;
+			sge->cap_states = cap_states;
+
+			prop = of_find_property(cp, "idle-cost-data", NULL);
+			if (!prop || !prop->value) {
+				pr_warn("No idle-cost data, skipping sched_energy init\n");
+				goto out;
+			}
+
+			nstates = (prop->length / sizeof(u32));
+			idle_states = kcalloc(nstates,
+					      sizeof(struct idle_state),
+					      GFP_NOWAIT);
+
+			for (i = 0, val = prop->value; i < nstates; i++)
+				idle_states[i].power = be32_to_cpup(val++);
+
+			sge->nr_idle_states = nstates;
+			sge->idle_states = idle_states;
+
+			sge_array[cpu][sd_level] = sge;
+		}
+	}
+
+	pr_info("Sched-energy-costs installed from DT\n");
+	return;
+
+out:
+	free_resources();
+}
diff --git a/kernel/sched/fair.c b/kernel/sched/fair.c
index f6e8727..dd4f623 100644
--- a/kernel/sched/fair.c
+++ b/kernel/sched/fair.c
@@ -30,10 +30,13 @@
 #include <linux/mempolicy.h>
 #include <linux/migrate.h>
 #include <linux/task_work.h>
+#include <linux/module.h>
 
 #include <trace/events/sched.h>
 
 #include "sched.h"
+#include "tune.h"
+#include "walt.h"
 
 /*
  * Targeted preemption latency for CPU-bound tasks:
@@ -50,6 +53,15 @@
 unsigned int sysctl_sched_latency = 6000000ULL;
 unsigned int normalized_sysctl_sched_latency = 6000000ULL;
 
+unsigned int sysctl_sched_sync_hint_enable = 1;
+unsigned int sysctl_sched_cstate_aware = 1;
+
+#ifdef CONFIG_SCHED_WALT
+unsigned int sysctl_sched_use_walt_cpu_util = 1;
+unsigned int sysctl_sched_use_walt_task_util = 1;
+__read_mostly unsigned int sysctl_sched_walt_cpu_high_irqload =
+    (10 * NSEC_PER_MSEC);
+#endif
 /*
  * The initial- and re-scaling of tunables is configurable
  * (default SCHED_TUNABLESCALING_LOG = *(1+ilog(ncpus))
@@ -116,7 +128,7 @@ enum sched_tunable_scaling sysctl_sched_tunable_scaling
 
 /*
  * The margin used when comparing utilization with CPU capacity:
- * util * 1024 < capacity * margin
+ * util * margin < capacity * 1024
  */
 unsigned int capacity_margin = 1280; /* ~20% */
 
@@ -290,19 +302,59 @@ static inline struct cfs_rq *group_cfs_rq(struct sched_entity *grp)
 static inline void list_add_leaf_cfs_rq(struct cfs_rq *cfs_rq)
 {
 	if (!cfs_rq->on_list) {
+		struct rq *rq = rq_of(cfs_rq);
+		int cpu = cpu_of(rq);
 		/*
 		 * Ensure we either appear before our parent (if already
 		 * enqueued) or force our parent to appear after us when it is
-		 * enqueued.  The fact that we always enqueue bottom-up
-		 * reduces this to two cases.
+		 * enqueued. The fact that we always enqueue bottom-up
+		 * reduces this to two cases and a special case for the root
+		 * cfs_rq. Furthermore, it also means that we will always reset
+		 * tmp_alone_branch either when the branch is connected
+		 * to a tree or when we reach the beg of the tree
 		 */
 		if (cfs_rq->tg->parent &&
-		    cfs_rq->tg->parent->cfs_rq[cpu_of(rq_of(cfs_rq))]->on_list) {
-			list_add_rcu(&cfs_rq->leaf_cfs_rq_list,
-				&rq_of(cfs_rq)->leaf_cfs_rq_list);
-		} else {
+		    cfs_rq->tg->parent->cfs_rq[cpu]->on_list) {
+			/*
+			 * If parent is already on the list, we add the child
+			 * just before. Thanks to circular linked property of
+			 * the list, this means to put the child at the tail
+			 * of the list that starts by parent.
+			 */
+			list_add_tail_rcu(&cfs_rq->leaf_cfs_rq_list,
+				&(cfs_rq->tg->parent->cfs_rq[cpu]->leaf_cfs_rq_list));
+			/*
+			 * The branch is now connected to its tree so we can
+			 * reset tmp_alone_branch to the beginning of the
+			 * list.
+			 */
+			rq->tmp_alone_branch = &rq->leaf_cfs_rq_list;
+		} else if (!cfs_rq->tg->parent) {
+			/*
+			 * cfs rq without parent should be put
+			 * at the tail of the list.
+			 */
 			list_add_tail_rcu(&cfs_rq->leaf_cfs_rq_list,
-				&rq_of(cfs_rq)->leaf_cfs_rq_list);
+				&rq->leaf_cfs_rq_list);
+			/*
+			 * We have reach the beg of a tree so we can reset
+			 * tmp_alone_branch to the beginning of the list.
+			 */
+			rq->tmp_alone_branch = &rq->leaf_cfs_rq_list;
+		} else {
+			/*
+			 * The parent has not already been added so we want to
+			 * make sure that it will be put after us.
+			 * tmp_alone_branch points to the beg of the branch
+			 * where we will add parent.
+			 */
+			list_add_rcu(&cfs_rq->leaf_cfs_rq_list,
+				rq->tmp_alone_branch);
+			/*
+			 * update tmp_alone_branch to points to the new beg
+			 * of the branch
+			 */
+			rq->tmp_alone_branch = &cfs_rq->leaf_cfs_rq_list;
 		}
 
 		cfs_rq->on_list = 1;
@@ -699,6 +751,7 @@ void init_entity_runnable_average(struct sched_entity *se)
 	if (entity_is_task(se))
 		sa->load_avg = scale_load_down(se->load.weight);
 	sa->load_sum = sa->load_avg * LOAD_AVG_MAX;
+
 	/*
 	 * At this point, util_avg won't be used in select_task_rq_fair anyway
 	 */
@@ -708,9 +761,7 @@ void init_entity_runnable_average(struct sched_entity *se)
 }
 
 static inline u64 cfs_rq_clock_task(struct cfs_rq *cfs_rq);
-static int update_cfs_rq_load_avg(u64 now, struct cfs_rq *cfs_rq, bool update_freq);
-static void update_tg_load_avg(struct cfs_rq *cfs_rq, int force);
-static void attach_entity_load_avg(struct cfs_rq *cfs_rq, struct sched_entity *se);
+static void attach_entity_cfs_rq(struct sched_entity *se);
 
 /*
  * With new tasks being created, their initial util_avgs are extrapolated
@@ -742,7 +793,6 @@ void post_init_entity_util_avg(struct sched_entity *se)
 	struct cfs_rq *cfs_rq = cfs_rq_of(se);
 	struct sched_avg *sa = &se->avg;
 	long cap = (long)(SCHED_CAPACITY_SCALE - cfs_rq->avg.util_avg) / 2;
-	u64 now = cfs_rq_clock_task(cfs_rq);
 
 	if (cap > 0) {
 		if (cfs_rq->avg.util_avg != 0) {
@@ -770,14 +820,12 @@ void post_init_entity_util_avg(struct sched_entity *se)
 			 * such that the next switched_to_fair() has the
 			 * expected state.
 			 */
-			se->avg.last_update_time = now;
+			se->avg.last_update_time = cfs_rq_clock_task(cfs_rq);
 			return;
 		}
 	}
 
-	update_cfs_rq_load_avg(now, cfs_rq, false);
-	attach_entity_load_avg(cfs_rq, se);
-	update_tg_load_avg(cfs_rq, false);
+	attach_entity_cfs_rq(se);
 }
 
 #else /* !CONFIG_SMP */
@@ -937,6 +985,7 @@ static void update_curr_fair(struct rq *rq)
 			}
 
 			trace_sched_stat_blocked(tsk, delta);
+			trace_sched_blocked_reason(tsk);
 
 			/*
 			 * Blocking time is in units of nanosecs, so shift by
@@ -2646,16 +2695,20 @@ static void reweight_entity(struct cfs_rq *cfs_rq, struct sched_entity *se,
 
 static inline int throttled_hierarchy(struct cfs_rq *cfs_rq);
 
-static void update_cfs_shares(struct cfs_rq *cfs_rq)
+static void update_cfs_shares(struct sched_entity *se)
 {
+	struct cfs_rq *cfs_rq = group_cfs_rq(se);
 	struct task_group *tg;
-	struct sched_entity *se;
 	long shares;
 
-	tg = cfs_rq->tg;
-	se = tg->se[cpu_of(rq_of(cfs_rq))];
-	if (!se || throttled_hierarchy(cfs_rq))
+	if (!cfs_rq)
+		return;
+
+	if (throttled_hierarchy(cfs_rq))
 		return;
+
+	tg = cfs_rq->tg;
+
 #ifndef CONFIG_SMP
 	if (likely(se->load.weight == tg->shares))
 		return;
@@ -2664,8 +2717,9 @@ static void update_cfs_shares(struct cfs_rq *cfs_rq)
 
 	reweight_entity(cfs_rq_of(se), se, shares);
 }
+
 #else /* CONFIG_FAIR_GROUP_SCHED */
-static inline void update_cfs_shares(struct cfs_rq *cfs_rq)
+static inline void update_cfs_shares(struct sched_entity *se)
 {
 }
 #endif /* CONFIG_FAIR_GROUP_SCHED */
@@ -2816,6 +2870,7 @@ static u32 __compute_runnable_contrib(u64 n)
 
 	scale_freq = arch_scale_freq_capacity(NULL, cpu);
 	scale_cpu = arch_scale_cpu_capacity(NULL, cpu);
+	trace_sched_contrib_scale_f(cpu, scale_freq, scale_cpu);
 
 	/* delta_w is the amount already accumulated against our next period */
 	delta_w = sa->period_contrib;
@@ -2891,6 +2946,26 @@ static u32 __compute_runnable_contrib(u64 n)
 	return decayed;
 }
 
+/*
+ * Signed add and clamp on underflow.
+ *
+ * Explicitly do a load-store to ensure the intermediate value never hits
+ * memory. This allows lockless observations without ever seeing the negative
+ * values.
+ */
+#define add_positive(_ptr, _val) do {                           \
+	typeof(_ptr) ptr = (_ptr);                              \
+	typeof(_val) val = (_val);                              \
+	typeof(*ptr) res, var = READ_ONCE(*ptr);                \
+								\
+	res = var + val;                                        \
+								\
+	if (val < 0 && res > var)                               \
+		res = 0;                                        \
+								\
+	WRITE_ONCE(*ptr, res);                                  \
+} while (0)
+
 #ifdef CONFIG_FAIR_GROUP_SCHED
 /**
  * update_tg_load_avg - update the tg's load avg
@@ -2970,8 +3045,168 @@ void set_task_rq_fair(struct sched_entity *se,
 		se->avg.last_update_time = n_last_update_time;
 	}
 }
+
+/* Take into account change of utilization of a child task group */
+static inline void
+update_tg_cfs_util(struct cfs_rq *cfs_rq, struct sched_entity *se)
+{
+	struct cfs_rq *gcfs_rq = group_cfs_rq(se);
+	long delta = gcfs_rq->avg.util_avg - se->avg.util_avg;
+
+	/* Nothing to update */
+	if (!delta)
+		return;
+
+	/* Set new sched_entity's utilization */
+	se->avg.util_avg = gcfs_rq->avg.util_avg;
+	se->avg.util_sum = se->avg.util_avg * LOAD_AVG_MAX;
+
+	/* Update parent cfs_rq utilization */
+	add_positive(&cfs_rq->avg.util_avg, delta);
+	cfs_rq->avg.util_sum = cfs_rq->avg.util_avg * LOAD_AVG_MAX;
+}
+
+/* Take into account change of load of a child task group */
+static inline void
+update_tg_cfs_load(struct cfs_rq *cfs_rq, struct sched_entity *se)
+{
+	struct cfs_rq *gcfs_rq = group_cfs_rq(se);
+	long delta, load = gcfs_rq->avg.load_avg;
+
+	/*
+	 * If the load of group cfs_rq is null, the load of the
+	 * sched_entity will also be null so we can skip the formula
+	 */
+	if (load) {
+		long tg_load;
+
+		/* Get tg's load and ensure tg_load > 0 */
+		tg_load = atomic_long_read(&gcfs_rq->tg->load_avg) + 1;
+
+		/* Ensure tg_load >= load and updated with current load*/
+		tg_load -= gcfs_rq->tg_load_avg_contrib;
+		tg_load += load;
+
+		/*
+		 * We need to compute a correction term in the case that the
+		 * task group is consuming more CPU than a task of equal
+		 * weight. A task with a weight equals to tg->shares will have
+		 * a load less or equal to scale_load_down(tg->shares).
+		 * Similarly, the sched_entities that represent the task group
+		 * at parent level, can't have a load higher than
+		 * scale_load_down(tg->shares). And the Sum of sched_entities'
+		 * load must be <= scale_load_down(tg->shares).
+		 */
+		if (tg_load > scale_load_down(gcfs_rq->tg->shares)) {
+			/* scale gcfs_rq's load into tg's shares*/
+			load *= scale_load_down(gcfs_rq->tg->shares);
+			load /= tg_load;
+		}
+	}
+
+	delta = load - se->avg.load_avg;
+
+	/* Nothing to update */
+	if (!delta)
+		return;
+
+	/* Set new sched_entity's load */
+	se->avg.load_avg = load;
+	se->avg.load_sum = se->avg.load_avg * LOAD_AVG_MAX;
+
+	/* Update parent cfs_rq load */
+	add_positive(&cfs_rq->avg.load_avg, delta);
+	cfs_rq->avg.load_sum = cfs_rq->avg.load_avg * LOAD_AVG_MAX;
+
+	/*
+	 * If the sched_entity is already enqueued, we also have to update the
+	 * runnable load avg.
+	 */
+	if (se->on_rq) {
+		/* Update parent cfs_rq runnable_load_avg */
+		add_positive(&cfs_rq->runnable_load_avg, delta);
+		cfs_rq->runnable_load_sum = cfs_rq->runnable_load_avg * LOAD_AVG_MAX;
+	}
+}
+
+static inline void set_tg_cfs_propagate(struct cfs_rq *cfs_rq)
+{
+	cfs_rq->propagate_avg = 1;
+}
+
+static inline int test_and_clear_tg_cfs_propagate(struct sched_entity *se)
+{
+	struct cfs_rq *cfs_rq = group_cfs_rq(se);
+
+	if (!cfs_rq->propagate_avg)
+		return 0;
+
+	cfs_rq->propagate_avg = 0;
+	return 1;
+}
+
+/* Update task and its cfs_rq load average */
+static inline int propagate_entity_load_avg(struct sched_entity *se)
+{
+	struct cfs_rq *cfs_rq;
+
+	if (entity_is_task(se))
+		return 0;
+
+	if (!test_and_clear_tg_cfs_propagate(se))
+		return 0;
+
+	cfs_rq = cfs_rq_of(se);
+
+	set_tg_cfs_propagate(cfs_rq);
+
+	update_tg_cfs_util(cfs_rq, se);
+	update_tg_cfs_load(cfs_rq, se);
+
+	return 1;
+}
+
+/*
+ * Check if we need to update the load and the utilization of a blocked
+ * group_entity:
+ */
+static inline bool skip_blocked_update(struct sched_entity *se)
+{
+	struct cfs_rq *gcfs_rq = group_cfs_rq(se);
+
+	/*
+	 * If sched_entity still have not zero load or utilization, we have to
+	 * decay it:
+	 */
+	if (se->avg.load_avg || se->avg.util_avg)
+		return false;
+
+	/*
+	 * If there is a pending propagation, we have to update the load and
+	 * the utilization of the sched_entity:
+	 */
+	if (gcfs_rq->propagate_avg)
+		return false;
+
+	/*
+	 * Otherwise, the load and the utilization of the sched_entity is
+	 * already zero and there is no pending propagation, so it will be a
+	 * waste of time to try to decay it:
+	 */
+	return true;
+}
+
 #else /* CONFIG_FAIR_GROUP_SCHED */
+
 static inline void update_tg_load_avg(struct cfs_rq *cfs_rq, int force) {}
+
+static inline int propagate_entity_load_avg(struct sched_entity *se)
+{
+	return 0;
+}
+
+static inline void set_tg_cfs_propagate(struct cfs_rq *cfs_rq) {}
+
 #endif /* CONFIG_FAIR_GROUP_SCHED */
 
 static inline void cfs_rq_util_change(struct cfs_rq *cfs_rq)
@@ -3042,6 +3277,7 @@ static inline void cfs_rq_util_change(struct cfs_rq *cfs_rq)
 		sub_positive(&sa->load_avg, r);
 		sub_positive(&sa->load_sum, r * LOAD_AVG_MAX);
 		removed_load = 1;
+		set_tg_cfs_propagate(cfs_rq);
 	}
 
 	if (atomic_long_read(&cfs_rq->removed_util_avg)) {
@@ -3049,6 +3285,7 @@ static inline void cfs_rq_util_change(struct cfs_rq *cfs_rq)
 		sub_positive(&sa->util_avg, r);
 		sub_positive(&sa->util_sum, r * LOAD_AVG_MAX);
 		removed_util = 1;
+		set_tg_cfs_propagate(cfs_rq);
 	}
 
 	decayed = __update_load_avg(now, cpu_of(rq_of(cfs_rq)), sa,
@@ -3062,27 +3299,51 @@ static inline void cfs_rq_util_change(struct cfs_rq *cfs_rq)
 	if (update_freq && (decayed || removed_util))
 		cfs_rq_util_change(cfs_rq);
 
+	/* Trace CPU load, unless cfs_rq belongs to a non-root task_group */
+	if (cfs_rq == &rq_of(cfs_rq)->cfs)
+		trace_sched_load_avg_cpu(cpu_of(rq_of(cfs_rq)), cfs_rq);
+
 	return decayed || removed_load;
 }
 
+/*
+ * Optional action to be done while updating the load average
+ */
+#define UPDATE_TG	0x1
+#define SKIP_AGE_LOAD	0x2
+
 /* Update task and its cfs_rq load average */
-static inline void update_load_avg(struct sched_entity *se, int update_tg)
+static inline void update_load_avg(struct sched_entity *se, int flags)
 {
 	struct cfs_rq *cfs_rq = cfs_rq_of(se);
 	u64 now = cfs_rq_clock_task(cfs_rq);
 	struct rq *rq = rq_of(cfs_rq);
 	int cpu = cpu_of(rq);
+	int decayed;
+	void *ptr = NULL;
 
 	/*
 	 * Track task load average for carrying it to new CPU after migrated, and
 	 * track group sched_entity load average for task_h_load calc in migration
 	 */
-	__update_load_avg(now, cpu, &se->avg,
+	if (se->avg.last_update_time && !(flags & SKIP_AGE_LOAD)) {
+		__update_load_avg(now, cpu, &se->avg,
 			  se->on_rq * scale_load_down(se->load.weight),
 			  cfs_rq->curr == se, NULL);
+	}
+
+	decayed  = update_cfs_rq_load_avg(now, cfs_rq, true);
+	decayed |= propagate_entity_load_avg(se);
 
-	if (update_cfs_rq_load_avg(now, cfs_rq, true) && update_tg)
+	if (decayed && (flags & UPDATE_TG))
 		update_tg_load_avg(cfs_rq, 0);
+
+	if (entity_is_task(se)) {
+#ifdef CONFIG_SCHED_WALT
+		ptr = (void *)&(task_of(se)->ravg);
+#endif
+		trace_sched_load_avg_task(task_of(se), &se->avg, ptr);
+	}
 }
 
 /**
@@ -3095,31 +3356,12 @@ static inline void update_load_avg(struct sched_entity *se, int update_tg)
  */
 static void attach_entity_load_avg(struct cfs_rq *cfs_rq, struct sched_entity *se)
 {
-	if (!sched_feat(ATTACH_AGE_LOAD))
-		goto skip_aging;
-
-	/*
-	 * If we got migrated (either between CPUs or between cgroups) we'll
-	 * have aged the average right before clearing @last_update_time.
-	 *
-	 * Or we're fresh through post_init_entity_util_avg().
-	 */
-	if (se->avg.last_update_time) {
-		__update_load_avg(cfs_rq->avg.last_update_time, cpu_of(rq_of(cfs_rq)),
-				  &se->avg, 0, 0, NULL);
-
-		/*
-		 * XXX: we could have just aged the entire load away if we've been
-		 * absent from the fair class for too long.
-		 */
-	}
-
-skip_aging:
 	se->avg.last_update_time = cfs_rq->avg.last_update_time;
 	cfs_rq->avg.load_avg += se->avg.load_avg;
 	cfs_rq->avg.load_sum += se->avg.load_sum;
 	cfs_rq->avg.util_avg += se->avg.util_avg;
 	cfs_rq->avg.util_sum += se->avg.util_sum;
+	set_tg_cfs_propagate(cfs_rq);
 
 	cfs_rq_util_change(cfs_rq);
 }
@@ -3134,14 +3376,12 @@ static void attach_entity_load_avg(struct cfs_rq *cfs_rq, struct sched_entity *s
  */
 static void detach_entity_load_avg(struct cfs_rq *cfs_rq, struct sched_entity *se)
 {
-	__update_load_avg(cfs_rq->avg.last_update_time, cpu_of(rq_of(cfs_rq)),
-			  &se->avg, se->on_rq * scale_load_down(se->load.weight),
-			  cfs_rq->curr == se, NULL);
 
 	sub_positive(&cfs_rq->avg.load_avg, se->avg.load_avg);
 	sub_positive(&cfs_rq->avg.load_sum, se->avg.load_sum);
 	sub_positive(&cfs_rq->avg.util_avg, se->avg.util_avg);
 	sub_positive(&cfs_rq->avg.util_sum, se->avg.util_sum);
+	set_tg_cfs_propagate(cfs_rq);
 
 	cfs_rq_util_change(cfs_rq);
 }
@@ -3151,34 +3391,20 @@ static void detach_entity_load_avg(struct cfs_rq *cfs_rq, struct sched_entity *s
 enqueue_entity_load_avg(struct cfs_rq *cfs_rq, struct sched_entity *se)
 {
 	struct sched_avg *sa = &se->avg;
-	u64 now = cfs_rq_clock_task(cfs_rq);
-	int migrated, decayed;
-
-	migrated = !sa->last_update_time;
-	if (!migrated) {
-		__update_load_avg(now, cpu_of(rq_of(cfs_rq)), sa,
-			se->on_rq * scale_load_down(se->load.weight),
-			cfs_rq->curr == se, NULL);
-	}
-
-	decayed = update_cfs_rq_load_avg(now, cfs_rq, !migrated);
 
 	cfs_rq->runnable_load_avg += sa->load_avg;
 	cfs_rq->runnable_load_sum += sa->load_sum;
 
-	if (migrated)
+	if (!sa->last_update_time) {
 		attach_entity_load_avg(cfs_rq, se);
-
-	if (decayed || migrated)
 		update_tg_load_avg(cfs_rq, 0);
+	}
 }
 
 /* Remove the runnable load generated by se from cfs_rq's runnable load average */
 static inline void
 dequeue_entity_load_avg(struct cfs_rq *cfs_rq, struct sched_entity *se)
 {
-	update_load_avg(se, 1);
-
 	cfs_rq->runnable_load_avg =
 		max_t(long, cfs_rq->runnable_load_avg - se->avg.load_avg, 0);
 	cfs_rq->runnable_load_sum =
@@ -3207,13 +3433,25 @@ static inline u64 cfs_rq_last_update_time(struct cfs_rq *cfs_rq)
 #endif
 
 /*
+ * Synchronize entity load avg of dequeued entity without locking
+ * the previous rq.
+ */
+void sync_entity_load_avg(struct sched_entity *se)
+{
+	struct cfs_rq *cfs_rq = cfs_rq_of(se);
+	u64 last_update_time;
+
+	last_update_time = cfs_rq_last_update_time(cfs_rq);
+	__update_load_avg(last_update_time, cpu_of(rq_of(cfs_rq)), &se->avg, 0, 0, NULL);
+}
+
+/*
  * Task first catches up with cfs_rq, and then subtract
  * itself from the cfs_rq (task must be off the queue now).
  */
 void remove_entity_load_avg(struct sched_entity *se)
 {
 	struct cfs_rq *cfs_rq = cfs_rq_of(se);
-	u64 last_update_time;
 
 	/*
 	 * tasks cannot exit without having gone through wake_up_new_task() ->
@@ -3225,9 +3463,7 @@ void remove_entity_load_avg(struct sched_entity *se)
 	 * calls this.
 	 */
 
-	last_update_time = cfs_rq_last_update_time(cfs_rq);
-
-	__update_load_avg(last_update_time, cpu_of(rq_of(cfs_rq)), &se->avg, 0, 0, NULL);
+	sync_entity_load_avg(se);
 	atomic_long_add(se->avg.load_avg, &cfs_rq->removed_load_avg);
 	atomic_long_add(se->avg.util_avg, &cfs_rq->removed_util_avg);
 }
@@ -3252,7 +3488,10 @@ static inline unsigned long cfs_rq_load_avg(struct cfs_rq *cfs_rq)
 	return 0;
 }
 
-static inline void update_load_avg(struct sched_entity *se, int not_used)
+#define UPDATE_TG	0x0
+#define SKIP_AGE_LOAD	0x0
+
+static inline void update_load_avg(struct sched_entity *se, int not_used1)
 {
 	cpufreq_update_util(rq_of(cfs_rq_of(se)), 0);
 }
@@ -3397,9 +3636,18 @@ static inline void check_schedstat_required(void)
 	if (renorm && !curr)
 		se->vruntime += cfs_rq->min_vruntime;
 
+	/*
+	 * When enqueuing a sched_entity, we must:
+	 *   - Update loads to have both entity and cfs_rq synced with now.
+	 *   - Add its load to cfs_rq->runnable_avg
+	 *   - For group_entity, update its weight to reflect the new share of
+	 *     its group cfs_rq
+	 *   - Add its new weight to cfs_rq->load.weight
+	 */
+	update_load_avg(se, UPDATE_TG);
 	enqueue_entity_load_avg(cfs_rq, se);
+	update_cfs_shares(se);
 	account_entity_enqueue(cfs_rq, se);
-	update_cfs_shares(cfs_rq);
 
 	if (flags & ENQUEUE_WAKEUP)
 		place_entity(cfs_rq, se, 0);
@@ -3471,6 +3719,16 @@ static void clear_buddies(struct cfs_rq *cfs_rq, struct sched_entity *se)
 	 * Update run-time statistics of the 'current'.
 	 */
 	update_curr(cfs_rq);
+
+	/*
+	 * When dequeuing a sched_entity, we must:
+	 *   - Update loads to have both entity and cfs_rq synced with now.
+	 *   - Substract its load from the cfs_rq->runnable_avg.
+	 *   - Substract its previous weight from cfs_rq->load.weight.
+	 *   - For group entity, update its weight to reflect the new share
+	 *     of its group cfs_rq.
+	 */
+	update_load_avg(se, UPDATE_TG);
 	dequeue_entity_load_avg(cfs_rq, se);
 
 	update_stats_dequeue(cfs_rq, se, flags);
@@ -3494,7 +3752,7 @@ static void clear_buddies(struct cfs_rq *cfs_rq, struct sched_entity *se)
 	/* return excess runtime on last dequeue */
 	return_cfs_rq_runtime(cfs_rq);
 
-	update_cfs_shares(cfs_rq);
+	update_cfs_shares(se);
 
 	/*
 	 * Now advance min_vruntime if @se was the entity holding it back,
@@ -3558,7 +3816,7 @@ static void clear_buddies(struct cfs_rq *cfs_rq, struct sched_entity *se)
 		 */
 		update_stats_wait_end(cfs_rq, se);
 		__dequeue_entity(cfs_rq, se);
-		update_load_avg(se, 1);
+		update_load_avg(se, UPDATE_TG);
 	}
 
 	update_stats_curr_start(cfs_rq, se);
@@ -3676,8 +3934,8 @@ static void put_prev_entity(struct cfs_rq *cfs_rq, struct sched_entity *prev)
 	/*
 	 * Ensure that runnable average is periodically updated.
 	 */
-	update_load_avg(curr, 1);
-	update_cfs_shares(cfs_rq);
+	update_load_avg(curr, UPDATE_TG);
+	update_cfs_shares(curr);
 
 #ifdef CONFIG_SCHED_HRTICK
 	/*
@@ -4528,6 +4786,14 @@ static inline void hrtick_update(struct rq *rq)
 }
 #endif
 
+#ifdef CONFIG_SMP
+static bool __cpu_overutilized(int cpu, int delta);
+static bool cpu_overutilized(int cpu);
+unsigned long boosted_cpu_util(int cpu);
+#else
+#define boosted_cpu_util(cpu) cpu_util_freq(cpu)
+#endif
+
 /*
  * The enqueue_task method is called before nr_running is
  * increased. Here we update the fair scheduling stats and
@@ -4538,6 +4804,9 @@ static inline void hrtick_update(struct rq *rq)
 {
 	struct cfs_rq *cfs_rq;
 	struct sched_entity *se = &p->se;
+#ifdef CONFIG_SMP
+	int task_new = flags & ENQUEUE_WAKEUP_NEW;
+#endif
 
 	/*
 	 * If in_iowait is set, the code below may not trigger any cpufreq
@@ -4562,6 +4831,7 @@ static inline void hrtick_update(struct rq *rq)
 		if (cfs_rq_throttled(cfs_rq))
 			break;
 		cfs_rq->h_nr_running++;
+		walt_inc_cfs_cumulative_runnable_avg(cfs_rq, p);
 
 		flags = ENQUEUE_WAKEUP;
 	}
@@ -4569,17 +4839,49 @@ static inline void hrtick_update(struct rq *rq)
 	for_each_sched_entity(se) {
 		cfs_rq = cfs_rq_of(se);
 		cfs_rq->h_nr_running++;
+		walt_inc_cfs_cumulative_runnable_avg(cfs_rq, p);
 
 		if (cfs_rq_throttled(cfs_rq))
 			break;
 
-		update_load_avg(se, 1);
-		update_cfs_shares(cfs_rq);
+		update_load_avg(se, UPDATE_TG);
+		update_cfs_shares(se);
 	}
 
 	if (!se)
 		add_nr_running(rq, 1);
 
+#ifdef CONFIG_SMP
+
+	/*
+	 * Update SchedTune accounting.
+	 *
+	 * We do it before updating the CPU capacity to ensure the
+	 * boost value of the current task is accounted for in the
+	 * selection of the OPP.
+	 *
+	 * We do it also in the case where we enqueue a throttled task;
+	 * we could argue that a throttled task should not boost a CPU,
+	 * however:
+	 * a) properly implementing CPU boosting considering throttled
+	 *    tasks will increase a lot the complexity of the solution
+	 * b) it's not easy to quantify the benefits introduced by
+	 *    such a more complex solution.
+	 * Thus, for the time being we go for the simple solution and boost
+	 * also for throttled RQs.
+	 */
+	schedtune_enqueue_task(p, cpu_of(rq));
+
+	if (!se) {
+		walt_inc_cumulative_runnable_avg(rq, p);
+		if (!task_new && !rq->rd->overutilized &&
+		    cpu_overutilized(rq->cpu)) {
+			rq->rd->overutilized = true;
+			trace_sched_overutilized(true);
+		}
+	}
+
+#endif /* CONFIG_SMP */
 	hrtick_update(rq);
 }
 
@@ -4609,6 +4911,7 @@ static void dequeue_task_fair(struct rq *rq, struct task_struct *p, int flags)
 		if (cfs_rq_throttled(cfs_rq))
 			break;
 		cfs_rq->h_nr_running--;
+		walt_dec_cfs_cumulative_runnable_avg(cfs_rq, p);
 
 		/* Don't dequeue parent if it has other entities besides us */
 		if (cfs_rq->load.weight) {
@@ -4628,17 +4931,33 @@ static void dequeue_task_fair(struct rq *rq, struct task_struct *p, int flags)
 	for_each_sched_entity(se) {
 		cfs_rq = cfs_rq_of(se);
 		cfs_rq->h_nr_running--;
+		walt_dec_cfs_cumulative_runnable_avg(cfs_rq, p);
 
 		if (cfs_rq_throttled(cfs_rq))
 			break;
 
-		update_load_avg(se, 1);
-		update_cfs_shares(cfs_rq);
+		update_load_avg(se, UPDATE_TG);
+		update_cfs_shares(se);
 	}
 
 	if (!se)
 		sub_nr_running(rq, 1);
 
+#ifdef CONFIG_SMP
+
+	/*
+	 * Update SchedTune accounting
+	 *
+	 * We do it before updating the CPU capacity to ensure the
+	 * boost value of the current task is accounted for in the
+	 * selection of the OPP.
+	 */
+	schedtune_dequeue_task(p, cpu_of(rq));
+
+	if (!se)
+		walt_dec_cumulative_runnable_avg(rq, p);
+#endif /* CONFIG_SMP */
+
 	hrtick_update(rq);
 }
 
@@ -4945,15 +5264,6 @@ static unsigned long target_load(int cpu, int type)
 	return max(rq->cpu_load[type-1], total);
 }
 
-static unsigned long capacity_of(int cpu)
-{
-	return cpu_rq(cpu)->cpu_capacity;
-}
-
-static unsigned long capacity_orig_of(int cpu)
-{
-	return cpu_rq(cpu)->cpu_capacity_orig;
-}
 
 static unsigned long cpu_avg_load_per_task(int cpu)
 {
@@ -5105,57 +5415,583 @@ static void record_wakee(struct task_struct *p)
 }
 
 /*
- * Detect M:N waker/wakee relationships via a switching-frequency heuristic.
- *
- * A waker of many should wake a different task than the one last awakened
- * at a frequency roughly N times higher than one of its wakees.
- *
- * In order to determine whether we should let the load spread vs consolidating
- * to shared cache, we look for a minimum 'flip' frequency of llc_size in one
- * partner, and a factor of lls_size higher frequency in the other.
- *
- * With both conditions met, we can be relatively sure that the relationship is
- * non-monogamous, with partner count exceeding socket size.
- *
- * Waker/wakee being client/server, worker/dispatcher, interrupt source or
- * whatever is irrelevant, spread criteria is apparent partner count exceeds
- * socket size.
+ * Returns the current capacity of cpu after applying both
+ * cpu and freq scaling.
  */
-static int wake_wide(struct task_struct *p)
+unsigned long capacity_curr_of(int cpu)
 {
-	unsigned int master = current->wakee_flips;
-	unsigned int slave = p->wakee_flips;
-	int factor = this_cpu_read(sd_llc_size);
+	return cpu_rq(cpu)->cpu_capacity_orig *
+	       arch_scale_freq_capacity(NULL, cpu)
+	       >> SCHED_CAPACITY_SHIFT;
+}
 
-	if (master < slave)
-		swap(master, slave);
-	if (slave < factor || master < slave * factor)
+/*
+ * Returns the current capacity of cpu after applying both
+ * cpu and min freq scaling.
+ */
+unsigned long capacity_min_of(int cpu)
+{
+	if (!sched_feat(MIN_CAPACITY_CAPPING))
 		return 0;
-	return 1;
+	return arch_scale_cpu_capacity(NULL, cpu) *
+	       arch_scale_min_freq_capacity(NULL, cpu)
+	       >> SCHED_CAPACITY_SHIFT;
 }
 
-static int wake_affine(struct sched_domain *sd, struct task_struct *p,
-		       int prev_cpu, int sync)
+
+static inline bool energy_aware(void)
 {
-	s64 this_load, load;
-	s64 this_eff_load, prev_eff_load;
-	int idx, this_cpu;
-	struct task_group *tg;
-	unsigned long weight;
-	int balanced;
+	return sched_feat(ENERGY_AWARE);
+}
 
-	idx	  = sd->wake_idx;
-	this_cpu  = smp_processor_id();
-	load	  = source_load(prev_cpu, idx);
-	this_load = target_load(this_cpu, idx);
+/*
+ * CPU candidates.
+ *
+ * These are labels to reference CPU candidates for an energy_diff.
+ * Currently we support only two possible candidates: the task's previous CPU
+ * and another candiate CPU.
+ * More advanced/aggressive EAS selection policies can consider more
+ * candidates.
+ */
+#define EAS_CPU_PRV	0
+#define EAS_CPU_NXT	1
+#define EAS_CPU_BKP	2
+#define EAS_CPU_CNT	3
 
-	/*
-	 * If sync wakeup then subtract the (maximum possible)
-	 * effect of the currently running task from the load
-	 * of the current CPU:
-	 */
-	if (sync) {
-		tg = task_group(current);
+/*
+ * energy_diff - supports the computation of the estimated energy impact in
+ * moving a "task"'s "util_delta" between different CPU candidates.
+ */
+struct energy_env {
+	/* Utilization to move */
+	struct task_struct	*p;
+	int			util_delta;
+
+	/* Mask of CPUs candidates to evaluate */
+	cpumask_t		cpus_mask;
+
+	/* CPU candidates to evaluate */
+	struct {
+
+		/* CPU ID, must be in cpus_mask */
+		int	cpu_id;
+
+		/*
+		 * Index (into sched_group_energy::cap_states) of the OPP the
+		 * CPU needs to run at if the task is placed on it.
+		 * This includes the both active and blocked load, due to
+		 * other tasks on this CPU,  as well as the task's own
+		 * utilization.
+		 */
+		int	cap_idx;
+		int	cap;
+
+		/* Estimated system energy */
+		unsigned int energy;
+
+		/* Estimated energy variation wrt EAS_CPU_PRV */
+		int	nrg_delta;
+
+	} cpu[EAS_CPU_CNT];
+
+	/*
+	 * Index (into energy_env::cpu) of the morst energy efficient CPU for
+	 * the specified energy_env::task
+	 */
+	int			next_idx;
+
+	/* Support data */
+	struct sched_group	*sg_top;
+	struct sched_group	*sg_cap;
+	struct sched_group	*sg;
+};
+
+static int cpu_util_wake(int cpu, struct task_struct *p);
+
+/*
+ * __cpu_norm_util() returns the cpu util relative to a specific capacity,
+ * i.e. it's busy ratio, in the range [0..SCHED_LOAD_SCALE], which is useful for
+ * energy calculations.
+ *
+ * Since util is a scale-invariant utilization defined as:
+ *
+ *   util ~ (curr_freq/max_freq)*1024 * capacity_orig/1024 * running_time/time
+ *
+ * the normalized util can be found using the specific capacity.
+ *
+ *   capacity = capacity_orig * curr_freq/max_freq
+ *
+ *   norm_util = running_time/time ~ util/capacity
+ */
+static unsigned long __cpu_norm_util(unsigned long util, unsigned long capacity)
+{
+	if (util >= capacity)
+		return SCHED_CAPACITY_SCALE;
+
+	return (util << SCHED_CAPACITY_SHIFT)/capacity;
+}
+
+static unsigned long group_max_util(struct energy_env *eenv, int cpu_idx)
+{
+	unsigned long max_util = 0;
+	unsigned long util;
+	int cpu;
+
+	for_each_cpu(cpu, sched_group_cpus(eenv->sg_cap)) {
+		util = cpu_util_wake(cpu, eenv->p);
+
+		/*
+		 * If we are looking at the target CPU specified by the eenv,
+		 * then we should add the (estimated) utilization of the task
+		 * assuming we will wake it up on that CPU.
+		 */
+		if (unlikely(cpu == eenv->cpu[cpu_idx].cpu_id))
+			util += eenv->util_delta;
+
+		max_util = max(max_util, util);
+
+		/*
+		 * Take into account any minimum frequency imposed
+		 * elsewhere which limits the energy states available
+		 * If the MIN_CAPACITY_CAPPING feature is not enabled
+		 * capacity_min_of will return 0 (not capped).
+		 */
+		max_util = max(max_util, capacity_min_of(cpu));
+
+	}
+
+	return max_util;
+}
+
+/*
+ * group_norm_util() returns the approximated group util relative to it's
+ * current capacity (busy ratio), in the range [0..SCHED_LOAD_SCALE], for use
+ * in energy calculations.
+ *
+ * Since task executions may or may not overlap in time in the group the true
+ * normalized util is between MAX(cpu_norm_util(i)) and SUM(cpu_norm_util(i))
+ * when iterating over all CPUs in the group.
+ * The latter estimate is used as it leads to a more pessimistic energy
+ * estimate (more busy).
+ */
+static unsigned
+long group_norm_util(struct energy_env *eenv, int cpu_idx)
+{
+	unsigned long capacity = eenv->cpu[cpu_idx].cap;
+	unsigned long util, util_sum = 0;
+	int cpu;
+
+	for_each_cpu(cpu, sched_group_cpus(eenv->sg)) {
+		util = cpu_util_wake(cpu, eenv->p);
+
+		/*
+		 * If we are looking at the target CPU specified by the eenv,
+		 * then we should add the (estimated) utilization of the task
+		 * assuming we will wake it up on that CPU.
+		 */
+		if (unlikely(cpu == eenv->cpu[cpu_idx].cpu_id))
+			util += eenv->util_delta;
+
+		util_sum += __cpu_norm_util(util, capacity);
+	}
+
+	return min_t(unsigned long, util_sum, SCHED_CAPACITY_SCALE);
+}
+
+static int find_new_capacity(struct energy_env *eenv, int cpu_idx)
+{
+	const struct sched_group_energy *sge = eenv->sg->sge;
+	int idx, max_idx = sge->nr_cap_states - 1;
+	unsigned long util = group_max_util(eenv, cpu_idx);
+
+	/* default is max_cap if we don't find a match */
+	eenv->cpu[cpu_idx].cap_idx = max_idx;
+	eenv->cpu[cpu_idx].cap = sge->cap_states[max_idx].cap;
+
+	for (idx = 0; idx < sge->nr_cap_states; idx++) {
+		if (sge->cap_states[idx].cap >= util) {
+			/* Keep track of SG's capacity */
+			eenv->cpu[cpu_idx].cap_idx = idx;
+			eenv->cpu[cpu_idx].cap = sge->cap_states[idx].cap;
+			break;
+		}
+	}
+
+	return eenv->cpu[cpu_idx].cap_idx;
+}
+
+static int group_idle_state(struct energy_env *eenv, int cpu_idx)
+{
+	struct sched_group *sg = eenv->sg;
+	int i, state = INT_MAX;
+	int src_in_grp, dst_in_grp;
+	long grp_util = 0;
+
+	/* Find the shallowest idle state in the sched group. */
+	for_each_cpu(i, sched_group_cpus(sg))
+		state = min(state, idle_get_state_idx(cpu_rq(i)));
+
+	/* Take non-cpuidle idling into account (active idle/arch_cpu_idle()) */
+	state++;
+
+	src_in_grp = cpumask_test_cpu(eenv->cpu[EAS_CPU_PRV].cpu_id,
+				      sched_group_cpus(sg));
+	dst_in_grp = cpumask_test_cpu(eenv->cpu[cpu_idx].cpu_id,
+				      sched_group_cpus(sg));
+	if (src_in_grp == dst_in_grp) {
+		/* both CPUs under consideration are in the same group or not in
+		 * either group, migration should leave idle state the same.
+		 */
+		goto end;
+	}
+
+	/*
+	 * Try to estimate if a deeper idle state is
+	 * achievable when we move the task.
+	 */
+	for_each_cpu(i, sched_group_cpus(sg)) {
+		grp_util += cpu_util_wake(i, eenv->p);
+		if (unlikely(i == eenv->cpu[cpu_idx].cpu_id))
+			grp_util += eenv->util_delta;
+	}
+
+	if (grp_util <=
+		((long)sg->sgc->max_capacity * (int)sg->group_weight)) {
+		/* after moving, this group is at most partly
+		 * occupied, so it should have some idle time.
+		 */
+		int max_idle_state_idx = sg->sge->nr_idle_states - 2;
+		int new_state = grp_util * max_idle_state_idx;
+		if (grp_util <= 0)
+			/* group will have no util, use lowest state */
+			new_state = max_idle_state_idx + 1;
+		else {
+			/* for partially idle, linearly map util to idle
+			 * states, excluding the lowest one. This does not
+			 * correspond to the state we expect to enter in
+			 * reality, but an indication of what might happen.
+			 */
+			new_state = min(max_idle_state_idx, (int)
+					(new_state / sg->sgc->max_capacity));
+			new_state = max_idle_state_idx - new_state;
+		}
+		state = new_state;
+	} else {
+		/* After moving, the group will be fully occupied
+		 * so assume it will not be idle at all.
+		 */
+		state = 0;
+	}
+end:
+	return state;
+}
+
+/*
+ * calc_sg_energy: compute energy for the eenv's SG (i.e. eenv->sg).
+ *
+ * This works in iterations to compute the SG's energy for each CPU
+ * candidate defined by the energy_env's cpu array.
+ *
+ * NOTE: in the following computations for busy_energy and idle_energy we do
+ * not shift by SCHED_CAPACITY_SHIFT in order to reduce rounding errors.
+ * The required scaling will be performed just one time, by the calling
+ * functions, once we accumulated the contributons for all the SGs.
+ */
+static void calc_sg_energy(struct energy_env *eenv)
+{
+	struct sched_group *sg = eenv->sg;
+	int busy_energy, idle_energy;
+	unsigned int busy_power;
+	unsigned int idle_power;
+	unsigned long sg_util;
+	int cap_idx, idle_idx;
+	int total_energy = 0;
+	int cpu_idx;
+
+	for (cpu_idx = EAS_CPU_PRV; cpu_idx < EAS_CPU_CNT; ++cpu_idx) {
+
+
+		if (eenv->cpu[cpu_idx].cpu_id == -1)
+			continue;
+		/* Compute ACTIVE energy */
+		cap_idx = find_new_capacity(eenv, cpu_idx);
+		busy_power = sg->sge->cap_states[cap_idx].power;
+		/*
+		 * in order to calculate cpu_norm_util, we need to know which
+		 * capacity level the group will be at, so calculate that first
+		 */
+		sg_util = group_norm_util(eenv, cpu_idx);
+
+		busy_energy   = sg_util * busy_power;
+
+		/* Compute IDLE energy */
+		idle_idx = group_idle_state(eenv, cpu_idx);
+		idle_power = sg->sge->idle_states[idle_idx].power;
+
+		idle_energy   = SCHED_CAPACITY_SCALE - sg_util;
+		idle_energy  *= idle_power;
+
+		total_energy = busy_energy + idle_energy;
+		eenv->cpu[cpu_idx].energy += total_energy;
+	}
+}
+
+/*
+ * compute_energy() computes the absolute variation in energy consumption by
+ * moving eenv.util_delta from EAS_CPU_PRV to EAS_CPU_NXT.
+ *
+ * NOTE: compute_energy() may fail when racing with sched_domain updates, in
+ *       which case we abort by returning -EINVAL.
+ */
+static int compute_energy(struct energy_env *eenv)
+{
+	struct cpumask visit_cpus;
+	int cpu_count;
+
+	WARN_ON(!eenv->sg_top->sge);
+
+	cpumask_copy(&visit_cpus, sched_group_cpus(eenv->sg_top));
+	/* If a cpu is hotplugged in while we are in this function,
+	 * it does not appear in the existing visit_cpus mask
+	 * which came from the sched_group pointer of the
+	 * sched_domain pointed at by sd_ea for either the prev
+	 * or next cpu and was dereferenced in __energy_diff.
+	 * Since we will dereference sd_scs later as we iterate
+	 * through the CPUs we expect to visit, new CPUs can
+	 * be present which are not in the visit_cpus mask.
+	 * Guard this with cpu_count.
+	 */
+	cpu_count = cpumask_weight(&visit_cpus);
+
+	while (!cpumask_empty(&visit_cpus)) {
+		struct sched_group *sg_shared_cap = NULL;
+		int cpu = cpumask_first(&visit_cpus);
+		struct sched_domain *sd;
+
+		/*
+		 * Is the group utilization affected by cpus outside this
+		 * sched_group?
+		 * This sd may have groups with cpus which were not present
+		 * when we took visit_cpus.
+		 */
+		sd = rcu_dereference(per_cpu(sd_scs, cpu));
+		if (sd && sd->parent)
+			sg_shared_cap = sd->parent->groups;
+
+		for_each_domain(cpu, sd) {
+			struct sched_group *sg = sd->groups;
+
+			/* Has this sched_domain already been visited? */
+			if (sd->child && group_first_cpu(sg) != cpu)
+				break;
+
+			do {
+				eenv->sg_cap = sg;
+				if (sg_shared_cap && sg_shared_cap->group_weight >= sg->group_weight)
+					eenv->sg_cap = sg_shared_cap;
+
+				/*
+				 * Compute the energy for all the candidate
+				 * CPUs in the current visited SG.
+				 */
+				eenv->sg = sg;
+				calc_sg_energy(eenv);
+
+				if (!sd->child) {
+					/*
+					 * cpu_count here is the number of
+					 * cpus we expect to visit in this
+					 * calculation. If we race against
+					 * hotplug, we can have extra cpus
+					 * added to the groups we are
+					 * iterating which do not appear in
+					 * the visit_cpus mask. In that case
+					 * we are not able to calculate energy
+					 * without restarting so we will bail
+					 * out and use prev_cpu this time.
+					 */
+					if (!cpu_count)
+						return -EINVAL;
+					cpumask_xor(&visit_cpus, &visit_cpus, sched_group_cpus(sg));
+					cpu_count--;
+				}
+
+				if (cpumask_equal(sched_group_cpus(sg), sched_group_cpus(eenv->sg_top)))
+					goto next_cpu;
+
+			} while (sg = sg->next, sg != sd->groups);
+		}
+
+		/*
+		 * If we raced with hotplug and got an sd NULL-pointer;
+		 * returning a wrong energy estimation is better than
+		 * entering an infinite loop.
+		 * Specifically: If a cpu is unplugged after we took
+		 * the visit_cpus mask, it no longer has an sd_scs
+		 * pointer, so when we dereference it, we get NULL.
+		 */
+		if (cpumask_test_cpu(cpu, &visit_cpus))
+			return -EINVAL;
+next_cpu:
+		cpumask_clear_cpu(cpu, &visit_cpus);
+		continue;
+	}
+
+	return 0;
+}
+
+static inline bool cpu_in_sg(struct sched_group *sg, int cpu)
+{
+	return cpu != -1 && cpumask_test_cpu(cpu, sched_group_cpus(sg));
+}
+
+/*
+ * select_energy_cpu_idx(): estimate the energy impact of changing the
+ * utilization distribution.
+ *
+ * The eenv parameter specifies the changes: utilisation amount and a pair of
+ * possible CPU candidates (the previous CPU and a different target CPU).
+ *
+ * This function returns the index of a CPU candidate specified by the
+ * energy_env which corresponds to the first CPU saving energy.
+ * Thus, 0 (EAS_CPU_PRV) means that non of the CPU candidate is more energy
+ * efficient than running on prev_cpu. This is also the value returned in case
+ * of abort due to error conditions during the computations.
+ * A value greater than zero means that the first energy-efficient CPU is the
+ * one represented by eenv->cpu[eenv->next_idx].cpu_id.
+ */
+static inline int select_energy_cpu_idx(struct energy_env *eenv)
+{
+	struct sched_domain *sd;
+	struct sched_group *sg;
+	int sd_cpu = -1;
+	int cpu_idx;
+	int margin;
+
+	sd_cpu = eenv->cpu[EAS_CPU_PRV].cpu_id;
+	sd = rcu_dereference(per_cpu(sd_ea, sd_cpu));
+	if (!sd)
+		return EAS_CPU_PRV;
+
+	cpumask_clear(&eenv->cpus_mask);
+	for (cpu_idx = EAS_CPU_PRV; cpu_idx < EAS_CPU_CNT; ++cpu_idx) {
+		int cpu = eenv->cpu[cpu_idx].cpu_id;
+
+		if (cpu < 0)
+			continue;
+		cpumask_set_cpu(cpu, &eenv->cpus_mask);
+	}
+
+	sg = sd->groups;
+	do {
+		/* Skip SGs which do not contains a candidate CPU */
+		if (!cpumask_intersects(&eenv->cpus_mask, sched_group_cpus(sg)))
+			continue;
+
+		eenv->sg_top = sg;
+		/* energy is unscaled to reduce rounding errors */
+		if (compute_energy(eenv) == -EINVAL)
+			return EAS_CPU_PRV;
+
+	} while (sg = sg->next, sg != sd->groups);
+
+	/* Scale energy before comparisons */
+	for (cpu_idx = EAS_CPU_PRV; cpu_idx < EAS_CPU_CNT; ++cpu_idx)
+		eenv->cpu[cpu_idx].energy >>= SCHED_CAPACITY_SHIFT;
+
+	/*
+	 * Compute the dead-zone margin used to prevent too many task
+	 * migrations with negligible energy savings.
+	 * An energy saving is considered meaningful if it reduces the energy
+	 * consumption of EAS_CPU_PRV CPU candidate by at least ~1.56%
+	 */
+	margin = eenv->cpu[EAS_CPU_PRV].energy >> 6;
+
+	/*
+	 * By default the EAS_CPU_PRV CPU is considered the most energy
+	 * efficient, with a 0 energy variation.
+	 */
+	eenv->next_idx = EAS_CPU_PRV;
+
+	/*
+	 * Compare the other CPU candidates to find a CPU which can be
+	 * more energy efficient then EAS_CPU_PRV
+	 */
+	for (cpu_idx = EAS_CPU_NXT; cpu_idx < EAS_CPU_CNT; ++cpu_idx) {
+		/* Skip not valid scheduled candidates */
+		if (eenv->cpu[cpu_idx].cpu_id < 0)
+			continue;
+		/* Compute energy delta wrt EAS_CPU_PRV */
+		eenv->cpu[cpu_idx].nrg_delta =
+			eenv->cpu[cpu_idx].energy -
+			eenv->cpu[EAS_CPU_PRV].energy;
+		/* filter energy variations within the dead-zone margin */
+		if (abs(eenv->cpu[cpu_idx].nrg_delta) < margin)
+			eenv->cpu[cpu_idx].nrg_delta = 0;
+		/* update the schedule candidate with min(nrg_delta) */
+		if (eenv->cpu[cpu_idx].nrg_delta <
+		    eenv->cpu[eenv->next_idx].nrg_delta) {
+			eenv->next_idx = cpu_idx;
+			if (sched_feat(FBT_STRICT_ORDER))
+				break;
+		}
+	}
+
+	return eenv->next_idx;
+}
+
+/*
+ * Detect M:N waker/wakee relationships via a switching-frequency heuristic.
+ *
+ * A waker of many should wake a different task than the one last awakened
+ * at a frequency roughly N times higher than one of its wakees.
+ *
+ * In order to determine whether we should let the load spread vs consolidating
+ * to shared cache, we look for a minimum 'flip' frequency of llc_size in one
+ * partner, and a factor of lls_size higher frequency in the other.
+ *
+ * With both conditions met, we can be relatively sure that the relationship is
+ * non-monogamous, with partner count exceeding socket size.
+ *
+ * Waker/wakee being client/server, worker/dispatcher, interrupt source or
+ * whatever is irrelevant, spread criteria is apparent partner count exceeds
+ * socket size.
+ */
+static int wake_wide(struct task_struct *p)
+{
+	unsigned int master = current->wakee_flips;
+	unsigned int slave = p->wakee_flips;
+	int factor = this_cpu_read(sd_llc_size);
+
+	if (master < slave)
+		swap(master, slave);
+	if (slave < factor || master < slave * factor)
+		return 0;
+	return 1;
+}
+
+static int wake_affine(struct sched_domain *sd, struct task_struct *p,
+		       int prev_cpu, int sync)
+{
+	s64 this_load, load;
+	s64 this_eff_load, prev_eff_load;
+	int idx, this_cpu;
+	struct task_group *tg;
+	unsigned long weight;
+	int balanced;
+
+	idx	  = sd->wake_idx;
+	this_cpu  = smp_processor_id();
+	load	  = source_load(prev_cpu, idx);
+	this_load = target_load(this_cpu, idx);
+
+	/*
+	 * If sync wakeup then subtract the (maximum possible)
+	 * effect of the currently running task from the load
+	 * of the current CPU:
+	 */
+	if (sync) {
+		tg = task_group(current);
 		weight = current->se.avg.load_avg;
 
 		this_load += effective_load(tg, this_cpu, -weight, -weight);
@@ -5177,47 +6013,203 @@ static int wake_affine(struct sched_domain *sd, struct task_struct *p,
 	this_eff_load = 100;
 	this_eff_load *= capacity_of(prev_cpu);
 
-	prev_eff_load = 100 + (sd->imbalance_pct - 100) / 2;
-	prev_eff_load *= capacity_of(this_cpu);
+	prev_eff_load = 100 + (sd->imbalance_pct - 100) / 2;
+	prev_eff_load *= capacity_of(this_cpu);
+
+	if (this_load > 0) {
+		this_eff_load *= this_load +
+			effective_load(tg, this_cpu, weight, weight);
+
+		prev_eff_load *= load + effective_load(tg, prev_cpu, 0, weight);
+	}
+
+	balanced = this_eff_load <= prev_eff_load;
+
+	schedstat_inc(p->se.statistics.nr_wakeups_affine_attempts);
+
+	if (!balanced)
+		return 0;
+
+	schedstat_inc(sd->ttwu_move_affine);
+	schedstat_inc(p->se.statistics.nr_wakeups_affine);
+
+	return 1;
+}
+
+static inline unsigned long task_util(struct task_struct *p)
+{
+#ifdef CONFIG_SCHED_WALT
+	if (!walt_disabled && sysctl_sched_use_walt_task_util) {
+		unsigned long demand = p->ravg.demand;
+		return (demand << SCHED_CAPACITY_SHIFT) / walt_ravg_window;
+	}
+#endif
+	return p->se.avg.util_avg;
+}
+
+static inline unsigned long boosted_task_util(struct task_struct *p);
+
+static inline bool __task_fits(struct task_struct *p, int cpu, int util)
+{
+	unsigned long capacity = capacity_of(cpu);
+
+	util += boosted_task_util(p);
+
+	return (capacity * 1024) > (util * capacity_margin);
+}
+
+static inline bool task_fits_max(struct task_struct *p, int cpu)
+{
+	unsigned long capacity = capacity_of(cpu);
+	unsigned long max_capacity = cpu_rq(cpu)->rd->max_cpu_capacity.val;
+
+	if (capacity == max_capacity)
+		return true;
+
+	if (capacity * capacity_margin > max_capacity * 1024)
+		return true;
+
+	return __task_fits(p, cpu, 0);
+}
+
+static bool __cpu_overutilized(int cpu, int delta)
+{
+	return (capacity_of(cpu) * 1024) < ((cpu_util(cpu) + delta) * capacity_margin);
+}
+
+static bool cpu_overutilized(int cpu)
+{
+	return __cpu_overutilized(cpu, 0);
+}
+
+#ifdef CONFIG_SCHED_TUNE
+
+struct reciprocal_value schedtune_spc_rdiv;
+
+static long
+schedtune_margin(unsigned long signal, long boost)
+{
+	long long margin = 0;
+
+	/*
+	 * Signal proportional compensation (SPC)
+	 *
+	 * The Boost (B) value is used to compute a Margin (M) which is
+	 * proportional to the complement of the original Signal (S):
+	 *   M = B * (SCHED_CAPACITY_SCALE - S)
+	 * The obtained M could be used by the caller to "boost" S.
+	 */
+	if (boost >= 0) {
+		margin  = SCHED_CAPACITY_SCALE - signal;
+		margin *= boost;
+	} else {
+		margin = -signal * boost;
+	}
+
+	margin  = reciprocal_divide(margin, schedtune_spc_rdiv);
+	if (boost < 0)
+		margin *= -1;
+
+	return margin;
+}
+
+static inline int
+schedtune_cpu_margin(unsigned long util, int cpu)
+{
+	int boost = schedtune_cpu_boost(cpu);
+
+	if (boost == 0)
+		return 0;
+
+	return schedtune_margin(util, boost);
+}
+
+static inline long
+schedtune_task_margin(struct task_struct *p)
+{
+	int boost = schedtune_task_boost(p);
+	unsigned long util;
+	long margin;
+
+	if (boost == 0)
+		return 0;
+
+	util = task_util(p);
+	margin = schedtune_margin(util, boost);
+
+	return margin;
+}
+
+#else /* CONFIG_SCHED_TUNE */
 
-	if (this_load > 0) {
-		this_eff_load *= this_load +
-			effective_load(tg, this_cpu, weight, weight);
+static inline int
+schedtune_cpu_margin(unsigned long util, int cpu)
+{
+	return 0;
+}
 
-		prev_eff_load *= load + effective_load(tg, prev_cpu, 0, weight);
-	}
+static inline int
+schedtune_task_margin(struct task_struct *p)
+{
+	return 0;
+}
 
-	balanced = this_eff_load <= prev_eff_load;
+#endif /* CONFIG_SCHED_TUNE */
 
-	schedstat_inc(p->se.statistics.nr_wakeups_affine_attempts);
+unsigned long
+boosted_cpu_util(int cpu)
+{
+	unsigned long util = cpu_util_freq(cpu);
+	long margin = schedtune_cpu_margin(util, cpu);
 
-	if (!balanced)
-		return 0;
+	trace_sched_boost_cpu(cpu, util, margin);
 
-	schedstat_inc(sd->ttwu_move_affine);
-	schedstat_inc(p->se.statistics.nr_wakeups_affine);
+	return util + margin;
+}
 
-	return 1;
+static inline unsigned long
+boosted_task_util(struct task_struct *p)
+{
+	unsigned long util = task_util(p);
+	long margin = schedtune_task_margin(p);
+
+	trace_sched_boost_task(p, util, margin);
+
+	return util + margin;
+}
+
+static unsigned long capacity_spare_wake(int cpu, struct task_struct *p)
+{
+	return max_t(long, capacity_of(cpu) - cpu_util_wake(cpu, p), 0);
 }
 
 /*
  * find_idlest_group finds and returns the least busy CPU group within the
  * domain.
+ *
+ * Assumes p is allowed on at least one CPU in sd.
  */
 static struct sched_group *
 find_idlest_group(struct sched_domain *sd, struct task_struct *p,
 		  int this_cpu, int sd_flag)
 {
 	struct sched_group *idlest = NULL, *group = sd->groups;
-	unsigned long min_load = ULONG_MAX, this_load = 0;
+	struct sched_group *most_spare_sg = NULL;
+	unsigned long min_runnable_load = ULONG_MAX;
+	unsigned long this_runnable_load = ULONG_MAX;
+	unsigned long min_avg_load = ULONG_MAX, this_avg_load = ULONG_MAX;
+	unsigned long most_spare = 0, this_spare = 0;
 	int load_idx = sd->forkexec_idx;
-	int imbalance = 100 + (sd->imbalance_pct-100)/2;
+	int imbalance_scale = 100 + (sd->imbalance_pct-100)/2;
+	unsigned long imbalance = scale_load_down(NICE_0_LOAD) *
+				(sd->imbalance_pct-100) / 100;
 
 	if (sd_flag & SD_BALANCE_WAKE)
 		load_idx = sd->wake_idx;
 
 	do {
-		unsigned long load, avg_load;
+		unsigned long load, avg_load, runnable_load;
+		unsigned long spare_cap, max_spare_cap;
 		int local_group;
 		int i;
 
@@ -5229,8 +6221,13 @@ static int wake_affine(struct sched_domain *sd, struct task_struct *p,
 		local_group = cpumask_test_cpu(this_cpu,
 					       sched_group_cpus(group));
 
-		/* Tally up the load of all CPUs in the group */
+		/*
+		 * Tally up the load of all CPUs in the group and find
+		 * the group containing the CPU with most spare capacity.
+		 */
 		avg_load = 0;
+		runnable_load = 0;
+		max_spare_cap = 0;
 
 		for_each_cpu(i, sched_group_cpus(group)) {
 			/* Bias balancing toward cpus of our domain */
@@ -5239,30 +6236,85 @@ static int wake_affine(struct sched_domain *sd, struct task_struct *p,
 			else
 				load = target_load(i, load_idx);
 
-			avg_load += load;
+			runnable_load += load;
+
+			avg_load += cfs_rq_load_avg(&cpu_rq(i)->cfs);
+
+			spare_cap = capacity_spare_wake(i, p);
+
+			if (spare_cap > max_spare_cap)
+				max_spare_cap = spare_cap;
 		}
 
 		/* Adjust by relative CPU capacity of the group */
-		avg_load = (avg_load * SCHED_CAPACITY_SCALE) / group->sgc->capacity;
+		avg_load = (avg_load * SCHED_CAPACITY_SCALE) /
+					group->sgc->capacity;
+		runnable_load = (runnable_load * SCHED_CAPACITY_SCALE) /
+					group->sgc->capacity;
 
 		if (local_group) {
-			this_load = avg_load;
-		} else if (avg_load < min_load) {
-			min_load = avg_load;
-			idlest = group;
+			this_runnable_load = runnable_load;
+			this_avg_load = avg_load;
+			this_spare = max_spare_cap;
+		} else {
+			if (min_runnable_load > (runnable_load + imbalance)) {
+				/*
+				 * The runnable load is significantly smaller
+				 *  so we can pick this new cpu
+				 */
+				min_runnable_load = runnable_load;
+				min_avg_load = avg_load;
+				idlest = group;
+			} else if ((runnable_load < (min_runnable_load + imbalance)) &&
+					(100*min_avg_load > imbalance_scale*avg_load)) {
+				/*
+				 * The runnable loads are close so we take
+				 * into account blocked load through avg_load
+				 *  which is blocked + runnable load
+				 */
+				min_avg_load = avg_load;
+				idlest = group;
+			}
+
+			if (most_spare < max_spare_cap) {
+				most_spare = max_spare_cap;
+				most_spare_sg = group;
+			}
 		}
 	} while (group = group->next, group != sd->groups);
 
-	if (!idlest || 100*this_load < imbalance*min_load)
+	/*
+	 * The cross-over point between using spare capacity or least load
+	 * is too conservative for high utilization tasks on partially
+	 * utilized systems if we require spare_capacity > task_util(p),
+	 * so we allow for some task stuffing by using
+	 * spare_capacity > task_util(p)/2.
+	 * spare capacity can't be used for fork because the utilization has
+	 * not been set yet as it need to get a rq to init the utilization
+	 */
+	if (sd_flag & SD_BALANCE_FORK)
+		goto skip_spare;
+
+	if (this_spare > task_util(p) / 2 &&
+	    imbalance_scale*this_spare > 100*most_spare)
+		return NULL;
+	else if (most_spare > task_util(p) / 2)
+		return most_spare_sg;
+
+skip_spare:
+	if (!idlest ||
+	    (min_runnable_load > (this_runnable_load + imbalance)) ||
+	    ((this_runnable_load < (min_runnable_load + imbalance)) &&
+			(100*this_avg_load < imbalance_scale*min_avg_load)))
 		return NULL;
 	return idlest;
 }
 
 /*
- * find_idlest_cpu - find the idlest cpu among the cpus in group.
+ * find_idlest_group_cpu - find the idlest cpu among the cpus in group.
  */
 static int
-find_idlest_cpu(struct sched_group *group, struct task_struct *p, int this_cpu)
+find_idlest_group_cpu(struct sched_group *group, struct task_struct *p, int this_cpu)
 {
 	unsigned long load, min_load = ULONG_MAX;
 	unsigned int min_exit_latency = UINT_MAX;
@@ -5311,6 +6363,68 @@ static int wake_affine(struct sched_domain *sd, struct task_struct *p,
 	return shallowest_idle_cpu != -1 ? shallowest_idle_cpu : least_loaded_cpu;
 }
 
+static inline int find_idlest_cpu(struct sched_domain *sd, struct task_struct *p,
+				  int cpu, int prev_cpu, int sd_flag)
+{
+	int wu = sd_flag & SD_BALANCE_WAKE;
+	int cas_cpu = -1;
+	int new_cpu = cpu;
+
+	if (wu) {
+		schedstat_inc(p->se.statistics.nr_wakeups_cas_attempts);
+		schedstat_inc(this_rq()->eas_stats.cas_attempts);
+	}
+
+	if (!cpumask_intersects(sched_domain_span(sd), &p->cpus_allowed))
+		return prev_cpu;
+
+	while (sd) {
+		struct sched_group *group;
+		struct sched_domain *tmp;
+		int weight;
+
+		if (wu)
+			schedstat_inc(sd->eas_stats.cas_attempts);
+
+		if (!(sd->flags & sd_flag)) {
+			sd = sd->child;
+			continue;
+		}
+
+		group = find_idlest_group(sd, p, cpu, sd_flag);
+		if (!group) {
+			sd = sd->child;
+			continue;
+		}
+
+		new_cpu = find_idlest_group_cpu(group, p, cpu);
+		if (new_cpu == cpu) {
+			/* Now try balancing at a lower domain level of cpu */
+			sd = sd->child;
+			continue;
+		}
+
+		/* Now try balancing at a lower domain level of new_cpu */
+		cpu = cas_cpu = new_cpu;
+		weight = sd->span_weight;
+		sd = NULL;
+		for_each_domain(cpu, tmp) {
+			if (weight <= tmp->span_weight)
+				break;
+			if (tmp->flags & sd_flag)
+				sd = tmp;
+		}
+		/* while loop will break here if sd == NULL */
+	}
+
+	if (wu && (cas_cpu >= 0)) {
+		schedstat_inc(p->se.statistics.nr_wakeups_cas_count);
+		schedstat_inc(this_rq()->eas_stats.cas_count);
+	}
+
+	return new_cpu;
+}
+
 #ifdef CONFIG_SCHED_SMT
 
 static inline void set_idle_cores(int cpu, int val)
@@ -5478,94 +6592,581 @@ static int select_idle_cpu(struct task_struct *p, struct sched_domain *sd, int t
 static int select_idle_sibling(struct task_struct *p, int prev, int target)
 {
 	struct sched_domain *sd;
-	int i;
+	struct sched_group *sg;
+	int i = task_cpu(p);
+	int best_idle_cpu = -1;
+	int best_idle_cstate = INT_MAX;
+	unsigned long best_idle_capacity = ULONG_MAX;
+
+	schedstat_inc(p->se.statistics.nr_wakeups_sis_attempts);
+	schedstat_inc(this_rq()->eas_stats.sis_attempts);
+
+	if (!sysctl_sched_cstate_aware) {
+		if (idle_cpu(target)) {
+			schedstat_inc(p->se.statistics.nr_wakeups_sis_idle);
+			schedstat_inc(this_rq()->eas_stats.sis_idle);
+			return target;
+		}
+
+		/*
+		 * If the prevous cpu is cache affine and idle, don't be stupid.
+		 */
+		if (i != target && cpus_share_cache(i, target) && idle_cpu(i)) {
+			schedstat_inc(p->se.statistics.nr_wakeups_sis_cache_affine);
+			schedstat_inc(this_rq()->eas_stats.sis_cache_affine);
+			return i;
+		}
+
+		sd = rcu_dereference(per_cpu(sd_llc, target));
+		if (!sd)
+			return target;
+
+		i = select_idle_core(p, sd, target);
+		if ((unsigned)i < nr_cpumask_bits)
+			return i;
+
+		i = select_idle_cpu(p, sd, target);
+		if ((unsigned)i < nr_cpumask_bits)
+			return i;
 
-	if (idle_cpu(target))
-		return target;
+		i = select_idle_smt(p, sd, target);
+		if ((unsigned)i < nr_cpumask_bits)
+			return i;
+	}
 
 	/*
-	 * If the previous cpu is cache affine and idle, don't be stupid.
+	 * Otherwise, iterate the domains and find an elegible idle cpu.
 	 */
-	if (prev != target && cpus_share_cache(prev, target) && idle_cpu(prev))
-		return prev;
-
 	sd = rcu_dereference(per_cpu(sd_llc, target));
-	if (!sd)
-		return target;
+	for_each_lower_domain(sd) {
+		sg = sd->groups;
+		do {
+			if (!cpumask_intersects(sched_group_cpus(sg),
+                                        tsk_cpus_allowed(p)))
+				goto next;
+
+
+			if (sysctl_sched_cstate_aware) {
+				for_each_cpu_and(i, tsk_cpus_allowed(p), sched_group_cpus(sg)) {
+					int idle_idx = idle_get_state_idx(cpu_rq(i));
+					unsigned long new_usage = boosted_task_util(p);
+					unsigned long capacity_orig = capacity_orig_of(i);
+
+					if (new_usage > capacity_orig || !idle_cpu(i))
+						goto next;
+
+					if (i == target && new_usage <= capacity_curr_of(target)) {
+						schedstat_inc(p->se.statistics.nr_wakeups_sis_suff_cap);
+						schedstat_inc(this_rq()->eas_stats.sis_suff_cap);
+						schedstat_inc(sd->eas_stats.sis_suff_cap);
+						return target;
+					}
+
+					if (idle_idx < best_idle_cstate &&
+					    capacity_orig <= best_idle_capacity) {
+						best_idle_cpu = i;
+						best_idle_cstate = idle_idx;
+						best_idle_capacity = capacity_orig;
+					}
+				}
+			} else {
+				for_each_cpu(i, sched_group_cpus(sg)) {
+					if (i == target || !idle_cpu(i))
+						goto next;
+				}
 
-	i = select_idle_core(p, sd, target);
-	if ((unsigned)i < nr_cpumask_bits)
-		return i;
+				target = cpumask_first_and(sched_group_cpus(sg),
+					tsk_cpus_allowed(p));
+				schedstat_inc(p->se.statistics.nr_wakeups_sis_idle_cpu);
+				schedstat_inc(this_rq()->eas_stats.sis_idle_cpu);
+				schedstat_inc(sd->eas_stats.sis_idle_cpu);
+				goto done;
+			}
+next:
+			sg = sg->next;
+		} while (sg != sd->groups);
+	}
 
-	i = select_idle_cpu(p, sd, target);
-	if ((unsigned)i < nr_cpumask_bits)
-		return i;
+	if (best_idle_cpu >= 0)
+		target = best_idle_cpu;
 
-	i = select_idle_smt(p, sd, target);
-	if ((unsigned)i < nr_cpumask_bits)
-		return i;
+done:
+	schedstat_inc(p->se.statistics.nr_wakeups_sis_count);
+	schedstat_inc(this_rq()->eas_stats.sis_count);
 
 	return target;
 }
-
+ 
 /*
- * cpu_util returns the amount of capacity of a CPU that is used by CFS
- * tasks. The unit of the return value must be the one of capacity so we can
- * compare the utilization with the capacity of the CPU that is available for
- * CFS task (ie cpu_capacity).
- *
- * cfs_rq.avg.util_avg is the sum of running time of runnable tasks plus the
- * recent utilization of currently non-runnable tasks on a CPU. It represents
- * the amount of utilization of a CPU in the range [0..capacity_orig] where
- * capacity_orig is the cpu_capacity available at the highest frequency
- * (arch_scale_freq_capacity()).
- * The utilization of a CPU converges towards a sum equal to or less than the
- * current capacity (capacity_curr <= capacity_orig) of the CPU because it is
- * the running time on this CPU scaled by capacity_curr.
- *
- * Nevertheless, cfs_rq.avg.util_avg can be higher than capacity_curr or even
- * higher than capacity_orig because of unfortunate rounding in
- * cfs.avg.util_avg or just after migrating tasks and new task wakeups until
- * the average stabilizes with the new running time. We need to check that the
- * utilization stays within the range of [0..capacity_orig] and cap it if
- * necessary. Without utilization capping, a group could be seen as overloaded
- * (CPU0 utilization at 121% + CPU1 utilization at 80%) whereas CPU1 has 20% of
- * available capacity. We allow utilization to overshoot capacity_curr (but not
- * capacity_orig) as it useful for predicting the capacity required after task
- * migrations (scheduler-driven DVFS).
+ * cpu_util_wake: Compute cpu utilization with any contributions from
+ * the waking task p removed.  check_for_migration() looks for a better CPU of
+ * rq->curr. For that case we should return cpu util with contributions from
+ * currently running task p removed.
  */
-static int cpu_util(int cpu)
+static int cpu_util_wake(int cpu, struct task_struct *p)
 {
-	unsigned long util = cpu_rq(cpu)->cfs.avg.util_avg;
-	unsigned long capacity = capacity_orig_of(cpu);
+	unsigned long util, capacity;
+
+#ifdef CONFIG_SCHED_WALT
+	/*
+	 * WALT does not decay idle tasks in the same manner
+	 * as PELT, so it makes little sense to subtract task
+	 * utilization from cpu utilization. Instead just use
+	 * cpu_util for this case.
+	 */
+	if (!walt_disabled && sysctl_sched_use_walt_cpu_util &&
+	    p->state == TASK_WAKING)
+		return cpu_util(cpu);
+#endif
+	/* Task has no contribution or is new */
+	if (cpu != task_cpu(p) || !p->se.avg.last_update_time)
+		return cpu_util(cpu);
+
+	capacity = capacity_orig_of(cpu);
+	util = max_t(long, cpu_util(cpu) - task_util(p), 0);
 
 	return (util >= capacity) ? capacity : util;
 }
 
-static inline int task_util(struct task_struct *p)
+static int start_cpu(bool boosted)
 {
-	return p->se.avg.util_avg;
+	struct root_domain *rd = cpu_rq(smp_processor_id())->rd;
+
+	return boosted ? rd->max_cap_orig_cpu : rd->min_cap_orig_cpu;
+}
+
+static inline int find_best_target(struct task_struct *p, int *backup_cpu,
+				   bool boosted, bool prefer_idle)
+{
+	unsigned long best_idle_min_cap_orig = ULONG_MAX;
+	unsigned long min_util = boosted_task_util(p);
+	unsigned long target_capacity = ULONG_MAX;
+	unsigned long min_wake_util = ULONG_MAX;
+	unsigned long target_max_spare_cap = 0;
+	unsigned long target_util = ULONG_MAX;
+	unsigned long best_active_util = ULONG_MAX;
+	unsigned long target_idle_max_spare_cap = 0;
+	int best_idle_cstate = INT_MAX;
+	struct sched_domain *sd;
+	struct sched_group *sg;
+	int best_active_cpu = -1;
+	int best_idle_cpu = -1;
+	int target_cpu = -1;
+	int cpu, i;
+
+	*backup_cpu = -1;
+
+	schedstat_inc(p->se.statistics.nr_wakeups_fbt_attempts);
+	schedstat_inc(this_rq()->eas_stats.fbt_attempts);
+
+	/* Find start CPU based on boost value */
+	cpu = start_cpu(boosted);
+	if (cpu < 0) {
+		schedstat_inc(p->se.statistics.nr_wakeups_fbt_no_cpu);
+		schedstat_inc(this_rq()->eas_stats.fbt_no_cpu);
+		return -1;
+	}
+
+	/* Find SD for the start CPU */
+	sd = rcu_dereference(per_cpu(sd_ea, cpu));
+	if (!sd) {
+		schedstat_inc(p->se.statistics.nr_wakeups_fbt_no_sd);
+		schedstat_inc(this_rq()->eas_stats.fbt_no_sd);
+		return -1;
+	}
+
+	/* Scan CPUs in all SDs */
+	sg = sd->groups;
+	do {
+		for_each_cpu_and(i, tsk_cpus_allowed(p), sched_group_cpus(sg)) {
+			unsigned long capacity_curr = capacity_curr_of(i);
+			unsigned long capacity_orig = capacity_orig_of(i);
+			unsigned long wake_util, new_util, min_capped_util;
+
+			if (!cpu_online(i))
+				continue;
+
+			if (walt_cpu_high_irqload(i))
+				continue;
+
+			/*
+			 * p's blocked utilization is still accounted for on prev_cpu
+			 * so prev_cpu will receive a negative bias due to the double
+			 * accounting. However, the blocked utilization may be zero.
+			 */
+			wake_util = cpu_util_wake(i, p);
+			new_util = wake_util + task_util(p);
+
+			/*
+			 * Ensure minimum capacity to grant the required boost.
+			 * The target CPU can be already at a capacity level higher
+			 * than the one required to boost the task.
+			 */
+			new_util = max(min_util, new_util);
+
+			/*
+			 * Include minimum capacity constraint:
+			 * new_util contains the required utilization including
+			 * boost. min_capped_util also takes into account a
+			 * minimum capacity cap imposed on the CPU by external
+			 * actors.
+			 */
+			min_capped_util = max(new_util, capacity_min_of(i));
+
+			if (new_util > capacity_orig)
+				continue;
+
+			/*
+			 * Case A) Latency sensitive tasks
+			 *
+			 * Unconditionally favoring tasks that prefer idle CPU to
+			 * improve latency.
+			 *
+			 * Looking for:
+			 * - an idle CPU, whatever its idle_state is, since
+			 *   the first CPUs we explore are more likely to be
+			 *   reserved for latency sensitive tasks.
+			 * - a non idle CPU where the task fits in its current
+			 *   capacity and has the maximum spare capacity.
+			 * - a non idle CPU with lower contention from other
+			 *   tasks and running at the lowest possible OPP.
+			 *
+			 * The last two goals tries to favor a non idle CPU
+			 * where the task can run as if it is "almost alone".
+			 * A maximum spare capacity CPU is favoured since
+			 * the task already fits into that CPU's capacity
+			 * without waiting for an OPP chance.
+			 *
+			 * The following code path is the only one in the CPUs
+			 * exploration loop which is always used by
+			 * prefer_idle tasks. It exits the loop with wither a
+			 * best_active_cpu or a target_cpu which should
+			 * represent an optimal choice for latency sensitive
+			 * tasks.
+			 */
+			if (prefer_idle) {
+
+				/*
+				 * Case A.1: IDLE CPU
+				 * Return the first IDLE CPU we find.
+				 */
+				if (idle_cpu(i)) {
+					schedstat_inc(p->se.statistics.nr_wakeups_fbt_pref_idle);
+					schedstat_inc(this_rq()->eas_stats.fbt_pref_idle);
+
+					trace_sched_find_best_target(p,
+							prefer_idle, min_util,
+							cpu, best_idle_cpu,
+							best_active_cpu, i);
+
+					return i;
+				}
+
+				/*
+				 * Case A.2: Target ACTIVE CPU
+				 * Favor CPUs with max spare capacity.
+				 */
+				if ((capacity_curr > new_util) &&
+					(capacity_orig - new_util > target_max_spare_cap)) {
+					target_max_spare_cap = capacity_orig - new_util;
+					target_cpu = i;
+					continue;
+				}
+				if (target_cpu != -1)
+					continue;
+
+
+				/*
+				 * Case A.3: Backup ACTIVE CPU
+				 * Favor CPUs with:
+				 * - lower utilization due to other tasks
+				 * - lower utilization with the task in
+				 */
+				if (wake_util > min_wake_util)
+					continue;
+				if (new_util > best_active_util)
+					continue;
+				min_wake_util = wake_util;
+				best_active_util = new_util;
+				best_active_cpu = i;
+				continue;
+			}
+
+			/*
+			 * Enforce EAS mode
+			 *
+			 * For non latency sensitive tasks, skip CPUs that
+			 * will be overutilized by moving the task there.
+			 *
+			 * The goal here is to remain in EAS mode as long as
+			 * possible at least for !prefer_idle tasks.
+			 */
+			if ((new_util * capacity_margin) >
+			    (capacity_orig * SCHED_CAPACITY_SCALE))
+				continue;
+
+			/*
+			 * Case B) Non latency sensitive tasks on IDLE CPUs.
+			 *
+			 * Find an optimal backup IDLE CPU for non latency
+			 * sensitive tasks.
+			 *
+			 * Looking for:
+			 * - minimizing the capacity_orig,
+			 *   i.e. preferring LITTLE CPUs
+			 * - favoring shallowest idle states
+			 *   i.e. avoid to wakeup deep-idle CPUs
+			 *
+			 * The following code path is used by non latency
+			 * sensitive tasks if IDLE CPUs are available. If at
+			 * least one of such CPUs are available it sets the
+			 * best_idle_cpu to the most suitable idle CPU to be
+			 * selected.
+			 *
+			 * If idle CPUs are available, favour these CPUs to
+			 * improve performances by spreading tasks.
+			 * Indeed, the energy_diff() computed by the caller
+			 * will take care to ensure the minimization of energy
+			 * consumptions without affecting performance.
+			 */
+			if (idle_cpu(i)) {
+				int idle_idx = idle_get_state_idx(cpu_rq(i));
+
+				/* Select idle CPU with lower cap_orig */
+				if (capacity_orig > best_idle_min_cap_orig)
+					continue;
+				/* Favor CPUs that won't end up running at a
+				 * high OPP.
+				 */
+				if ((capacity_orig - min_capped_util) <
+					target_idle_max_spare_cap)
+					continue;
+
+				/*
+				 * Skip CPUs in deeper idle state, but only
+				 * if they are also less energy efficient.
+				 * IOW, prefer a deep IDLE LITTLE CPU vs a
+				 * shallow idle big CPU.
+				 */
+				if (sysctl_sched_cstate_aware &&
+				    best_idle_cstate <= idle_idx)
+					continue;
+
+				/* Keep track of best idle CPU */
+				best_idle_min_cap_orig = capacity_orig;
+				target_idle_max_spare_cap = capacity_orig -
+							    min_capped_util;
+				best_idle_cstate = idle_idx;
+				best_idle_cpu = i;
+				continue;
+			}
+
+			/*
+			 * Case C) Non latency sensitive tasks on ACTIVE CPUs.
+			 *
+			 * Pack tasks in the most energy efficient capacities.
+			 *
+			 * This task packing strategy prefers more energy
+			 * efficient CPUs (i.e. pack on smaller maximum
+			 * capacity CPUs) while also trying to spread tasks to
+			 * run them all at the lower OPP.
+			 *
+			 * This assumes for example that it's more energy
+			 * efficient to run two tasks on two CPUs at a lower
+			 * OPP than packing both on a single CPU but running
+			 * that CPU at an higher OPP.
+			 *
+			 * Thus, this case keep track of the CPU with the
+			 * smallest maximum capacity and highest spare maximum
+			 * capacity.
+			 */
+
+			/* Favor CPUs with smaller capacity */
+			if (capacity_orig > target_capacity)
+				continue;
+
+			/* Favor CPUs with maximum spare capacity */
+			if ((capacity_orig - min_capped_util) <
+				target_max_spare_cap)
+				continue;
+
+			target_max_spare_cap = capacity_orig - min_capped_util;
+			target_capacity = capacity_orig;
+			target_util = new_util;
+			target_cpu = i;
+		}
+
+	} while (sg = sg->next, sg != sd->groups);
+
+	/*
+	 * For non latency sensitive tasks, cases B and C in the previous loop,
+	 * we pick the best IDLE CPU only if we was not able to find a target
+	 * ACTIVE CPU.
+	 *
+	 * Policies priorities:
+	 *
+	 * - prefer_idle tasks:
+	 *
+	 *   a) IDLE CPU available, we return immediately
+	 *   b) ACTIVE CPU where task fits and has the bigger maximum spare
+	 *      capacity (i.e. target_cpu)
+	 *   c) ACTIVE CPU with less contention due to other tasks
+	 *      (i.e. best_active_cpu)
+	 *
+	 * - NON prefer_idle tasks:
+	 *
+	 *   a) ACTIVE CPU: target_cpu
+	 *   b) IDLE CPU: best_idle_cpu
+	 */
+	if (target_cpu == -1)
+		target_cpu = prefer_idle
+			? best_active_cpu
+			: best_idle_cpu;
+	else
+		*backup_cpu = prefer_idle
+		? best_active_cpu
+		: best_idle_cpu;
+
+	trace_sched_find_best_target(p, prefer_idle, min_util, cpu,
+				     best_idle_cpu, best_active_cpu,
+				     target_cpu);
+
+	schedstat_inc(p->se.statistics.nr_wakeups_fbt_count);
+	schedstat_inc(this_rq()->eas_stats.fbt_count);
+
+	return target_cpu;
 }
 
 /*
  * Disable WAKE_AFFINE in the case where task @p doesn't fit in the
  * capacity of either the waking CPU @cpu or the previous CPU @prev_cpu.
- *
+ * 
  * In that case WAKE_AFFINE doesn't make sense and we'll let
  * BALANCE_WAKE sort things out.
  */
 static int wake_cap(struct task_struct *p, int cpu, int prev_cpu)
 {
 	long min_cap, max_cap;
+	min_cap = min(capacity_orig_of(prev_cpu), capacity_orig_of(cpu));
+	max_cap = cpu_rq(cpu)->rd->max_cpu_capacity.val;
+	/* Minimum capacity is close to max, no need to abort wake_affine */
+	if (max_cap - min_cap < max_cap >> 3)
+		return 0;
+
+	/* Bring task utilization in sync with prev_cpu */
+	sync_entity_load_avg(&p->se);
+
+	return min_cap * 1024 < task_util(p) * capacity_margin;
+}
+
+static int select_energy_cpu_brute(struct task_struct *p, int prev_cpu, int sync)
+{
+	bool boosted, prefer_idle;
+	struct sched_domain *sd;
+	int target_cpu;
+	int backup_cpu;
+	int next_cpu;
+
+	schedstat_inc(p->se.statistics.nr_wakeups_secb_attempts);
+	schedstat_inc(this_rq()->eas_stats.secb_attempts);
+
+	if (sysctl_sched_sync_hint_enable && sync) {
+		int cpu = smp_processor_id();
+
+		if (cpumask_test_cpu(cpu, tsk_cpus_allowed(p))) {
+			schedstat_inc(p->se.statistics.nr_wakeups_secb_sync);
+			schedstat_inc(this_rq()->eas_stats.secb_sync);
+			return cpu;
+		}
+	}
+
+#ifdef CONFIG_CGROUP_SCHEDTUNE
+	boosted = schedtune_task_boost(p) > 0;
+	prefer_idle = schedtune_prefer_idle(p) > 0;
+#else
+	boosted = get_sysctl_sched_cfs_boost() > 0;
+	prefer_idle = 0;
+#endif
+
+	rcu_read_lock();
+
+	sd = rcu_dereference(per_cpu(sd_ea, prev_cpu));
+	if (!sd) {
+		target_cpu = prev_cpu;
+		goto unlock;
+	}
+
+	sync_entity_load_avg(&p->se);
+
+	/* Find a cpu with sufficient capacity */
+	next_cpu = find_best_target(p, &backup_cpu, boosted, prefer_idle);
+	if (next_cpu == -1) {
+		target_cpu = prev_cpu;
+		goto unlock;
+	}
+
+	/* Unconditionally prefer IDLE CPUs for boosted/prefer_idle tasks */
+	if ((boosted || prefer_idle) && idle_cpu(next_cpu)) {
+		schedstat_inc(p->se.statistics.nr_wakeups_secb_idle_bt);
+		schedstat_inc(this_rq()->eas_stats.secb_idle_bt);
+		target_cpu = next_cpu;
+		goto unlock;
+	}
+
+	target_cpu = prev_cpu;
+	if (next_cpu != prev_cpu) {
+		int delta = 0;
+		struct energy_env eenv = {
+			.p              = p,
+			.util_delta     = task_util(p),
+			/* Task's previous CPU candidate */
+			.cpu[EAS_CPU_PRV] = {
+				.cpu_id = prev_cpu,
+			},
+			/* Main alternative CPU candidate */
+			.cpu[EAS_CPU_NXT] = {
+				.cpu_id = next_cpu,
+			},
+			/* Backup alternative CPU candidate */
+			.cpu[EAS_CPU_BKP] = {
+				.cpu_id = backup_cpu,
+			},
+		};
+
+
+#ifdef CONFIG_SCHED_WALT
+		if (!walt_disabled && sysctl_sched_use_walt_cpu_util &&
+			p->state == TASK_WAKING)
+			delta = task_util(p);
+#endif
+		/* Not enough spare capacity on previous cpu */
+		if (__cpu_overutilized(prev_cpu, delta)) {
+			schedstat_inc(p->se.statistics.nr_wakeups_secb_insuff_cap);
+			schedstat_inc(this_rq()->eas_stats.secb_insuff_cap);
+			target_cpu = next_cpu;
+			goto unlock;
+		}
 
-	min_cap = min(capacity_orig_of(prev_cpu), capacity_orig_of(cpu));
-	max_cap = cpu_rq(cpu)->rd->max_cpu_capacity;
+		/* Check if EAS_CPU_NXT is a more energy efficient CPU */
+		if (select_energy_cpu_idx(&eenv) != EAS_CPU_PRV) {
+			schedstat_inc(p->se.statistics.nr_wakeups_secb_nrg_sav);
+			schedstat_inc(this_rq()->eas_stats.secb_nrg_sav);
+			target_cpu = eenv.cpu[eenv.next_idx].cpu_id;
+			goto unlock;
+		}
 
-	/* Minimum capacity is close to max, no need to abort wake_affine */
-	if (max_cap - min_cap < max_cap >> 3)
-		return 0;
+		schedstat_inc(p->se.statistics.nr_wakeups_secb_no_nrg_sav);
+		schedstat_inc(this_rq()->eas_stats.secb_no_nrg_sav);
+		target_cpu = prev_cpu;
+		goto unlock;
+	}
 
-	return min_cap * 1024 < task_util(p) * capacity_margin;
+	schedstat_inc(p->se.statistics.nr_wakeups_secb_count);
+	schedstat_inc(this_rq()->eas_stats.secb_count);
+
+unlock:
+	rcu_read_unlock();
+	return target_cpu;
 }
 
 /*
@@ -5591,10 +7192,13 @@ static int wake_cap(struct task_struct *p, int cpu, int prev_cpu)
 
 	if (sd_flag & SD_BALANCE_WAKE) {
 		record_wakee(p);
-		want_affine = !wake_wide(p) && !wake_cap(p, cpu, prev_cpu)
-			      && cpumask_test_cpu(cpu, tsk_cpus_allowed(p));
+		want_affine = (!wake_wide(p) && !wake_cap(p, cpu, prev_cpu) &&
+			cpumask_test_cpu(cpu, tsk_cpus_allowed(p)));
 	}
 
+	if (energy_aware() && !(cpu_rq(prev_cpu)->rd->overutilized))
+		return select_energy_cpu_brute(p, prev_cpu, sync);
+
 	rcu_read_lock();
 	for_each_domain(cpu, tmp) {
 		if (!(tmp->flags & SD_LOAD_BALANCE))
@@ -5622,43 +7226,21 @@ static int wake_cap(struct task_struct *p, int cpu, int prev_cpu)
 			new_cpu = cpu;
 	}
 
+	if (sd && !(sd_flag & SD_BALANCE_FORK)) {
+		/*
+		 * We're going to need the task's util for capacity_spare_wake
+		 * in find_idlest_group. Sync it up to prev_cpu's
+		 * last_update_time.
+		 */
+		sync_entity_load_avg(&p->se);
+	}
+
 	if (!sd) {
 		if (sd_flag & SD_BALANCE_WAKE) /* XXX always ? */
 			new_cpu = select_idle_sibling(p, prev_cpu, new_cpu);
 
-	} else while (sd) {
-		struct sched_group *group;
-		int weight;
-
-		if (!(sd->flags & sd_flag)) {
-			sd = sd->child;
-			continue;
-		}
-
-		group = find_idlest_group(sd, p, cpu, sd_flag);
-		if (!group) {
-			sd = sd->child;
-			continue;
-		}
-
-		new_cpu = find_idlest_cpu(group, p, cpu);
-		if (new_cpu == -1 || new_cpu == cpu) {
-			/* Now try balancing at a lower domain level of cpu */
-			sd = sd->child;
-			continue;
-		}
-
-		/* Now try balancing at a lower domain level of new_cpu */
-		cpu = new_cpu;
-		weight = sd->span_weight;
-		sd = NULL;
-		for_each_domain(cpu, tmp) {
-			if (weight <= tmp->span_weight)
-				break;
-			if (tmp->flags & sd_flag)
-				sd = tmp;
-		}
-		/* while loop will break here if sd == NULL */
+	} else {
+		new_cpu = find_idlest_cpu(sd, p, cpu, prev_cpu, sd_flag);
 	}
 	rcu_read_unlock();
 
@@ -5718,6 +7300,8 @@ static void task_dead_fair(struct task_struct *p)
 {
 	remove_entity_load_avg(&p->se);
 }
+#else
+#define task_fits_max(p, cpu) true
 #endif /* CONFIG_SMP */
 
 static unsigned long
@@ -5964,6 +7548,8 @@ static void check_preempt_wakeup(struct rq *rq, struct task_struct *p, int wake_
 	if (hrtick_enabled(rq))
 		hrtick_start_fair(rq, p);
 
+	rq->misfit_task = !task_fits_max(p, rq->cpu);
+
 	return p;
 simple:
 	cfs_rq = &rq->cfs;
@@ -5985,9 +7571,12 @@ static void check_preempt_wakeup(struct rq *rq, struct task_struct *p, int wake_
 	if (hrtick_enabled(rq))
 		hrtick_start_fair(rq, p);
 
+	rq->misfit_task = !task_fits_max(p, rq->cpu);
+
 	return p;
 
 idle:
+	rq->misfit_task = 0;
 	/*
 	 * This is OK, because current is on_cpu, which avoids it being picked
 	 * for load-balance and preemption/IRQs are still disabled avoiding
@@ -6200,6 +7789,13 @@ static bool yield_to_task_fair(struct rq *rq, struct task_struct *p, bool preemp
 
 enum fbq_type { regular, remote, all };
 
+enum group_type {
+	group_other = 0,
+	group_misfit_task,
+	group_imbalanced,
+	group_overloaded,
+};
+
 #define LBF_ALL_PINNED	0x01
 #define LBF_NEED_BREAK	0x02
 #define LBF_DST_PINNED  0x04
@@ -6218,6 +7814,7 @@ struct lb_env {
 	int			new_dst_cpu;
 	enum cpu_idle_type	idle;
 	long			imbalance;
+	unsigned int		src_grp_nr_running;
 	/* The set of CPUs under consideration for load-balancing */
 	struct cpumask		*cpus;
 
@@ -6228,6 +7825,7 @@ struct lb_env {
 	unsigned int		loop_max;
 
 	enum fbq_type		fbq_type;
+	enum group_type		busiest_group_type;
 	struct list_head	tasks;
 };
 
@@ -6409,7 +8007,9 @@ static void detach_task(struct task_struct *p, struct lb_env *env)
 
 	p->on_rq = TASK_ON_RQ_MIGRATING;
 	deactivate_task(env->src_rq, p, 0);
+	double_lock_balance(env->src_rq, env->dst_rq);
 	set_task_cpu(p, env->dst_cpu);
+	double_unlock_balance(env->src_rq, env->dst_rq);
 }
 
 /*
@@ -6593,12 +8193,19 @@ static void update_blocked_averages(int cpu)
 	 * list_add_leaf_cfs_rq() for details.
 	 */
 	for_each_leaf_cfs_rq(rq, cfs_rq) {
+		struct sched_entity *se;
+
 		/* throttled entities do not contribute to load */
 		if (throttled_hierarchy(cfs_rq))
 			continue;
 
 		if (update_cfs_rq_load_avg(cfs_rq_clock_task(cfs_rq), cfs_rq, true))
 			update_tg_load_avg(cfs_rq, 0);
+
+		/* Propagate pending load changes to the parent, if any: */
+		se = cfs_rq->tg->se[cpu];
+		if (se && !skip_blocked_update(se))
+			update_load_avg(se, 0);
 	}
 	raw_spin_unlock_irqrestore(&rq->lock, flags);
 }
@@ -6670,12 +8277,6 @@ static unsigned long task_h_load(struct task_struct *p)
 
 /********** Helpers for find_busiest_group ************************/
 
-enum group_type {
-	group_other = 0,
-	group_imbalanced,
-	group_overloaded,
-};
-
 /*
  * sg_lb_stats - stats of a sched_group required for load_balancing
  */
@@ -6691,6 +8292,7 @@ struct sg_lb_stats {
 	unsigned int group_weight;
 	enum group_type group_type;
 	int group_no_capacity;
+	int group_misfit_task; /* A cpu has a task too big for its capacity */
 #ifdef CONFIG_NUMA_BALANCING
 	unsigned int nr_numa_running;
 	unsigned int nr_preferred_running;
@@ -6788,13 +8390,46 @@ static unsigned long scale_rt_capacity(int cpu)
 	return 1;
 }
 
+void init_max_cpu_capacity(struct max_cpu_capacity *mcc)
+{
+	raw_spin_lock_init(&mcc->lock);
+	mcc->val = 0;
+	mcc->cpu = -1;
+}
+
 static void update_cpu_capacity(struct sched_domain *sd, int cpu)
 {
 	unsigned long capacity = arch_scale_cpu_capacity(sd, cpu);
 	struct sched_group *sdg = sd->groups;
+	struct max_cpu_capacity *mcc;
+	unsigned long max_capacity;
+	int max_cap_cpu;
+	unsigned long flags;
 
 	cpu_rq(cpu)->cpu_capacity_orig = capacity;
 
+	capacity *= arch_scale_max_freq_capacity(sd, cpu);
+	capacity >>= SCHED_CAPACITY_SHIFT;
+
+	mcc = &cpu_rq(cpu)->rd->max_cpu_capacity;
+
+	raw_spin_lock_irqsave(&mcc->lock, flags);
+	max_capacity = mcc->val;
+	max_cap_cpu = mcc->cpu;
+
+	if ((max_capacity > capacity && max_cap_cpu == cpu) ||
+	    (max_capacity < capacity)) {
+		mcc->val = capacity;
+		mcc->cpu = cpu;
+#ifdef CONFIG_SCHED_DEBUG
+		raw_spin_unlock_irqrestore(&mcc->lock, flags);
+		pr_info("CPU%d: update max cpu_capacity %lu\n", cpu, capacity);
+		goto skip_unlock;
+#endif
+	}
+	raw_spin_unlock_irqrestore(&mcc->lock, flags);
+
+skip_unlock: __attribute__ ((unused));
 	capacity *= scale_rt_capacity(cpu);
 	capacity >>= SCHED_CAPACITY_SHIFT;
 
@@ -6803,13 +8438,15 @@ static void update_cpu_capacity(struct sched_domain *sd, int cpu)
 
 	cpu_rq(cpu)->cpu_capacity = capacity;
 	sdg->sgc->capacity = capacity;
+	sdg->sgc->max_capacity = capacity;
+	sdg->sgc->min_capacity = capacity;
 }
 
 void update_group_capacity(struct sched_domain *sd, int cpu)
 {
 	struct sched_domain *child = sd->child;
 	struct sched_group *group, *sdg = sd->groups;
-	unsigned long capacity;
+	unsigned long capacity, max_capacity, min_capacity;
 	unsigned long interval;
 
 	interval = msecs_to_jiffies(sd->balance_interval);
@@ -6822,6 +8459,8 @@ void update_group_capacity(struct sched_domain *sd, int cpu)
 	}
 
 	capacity = 0;
+	max_capacity = 0;
+	min_capacity = ULONG_MAX;
 
 	if (child->flags & SD_OVERLAP) {
 		/*
@@ -6846,11 +8485,13 @@ void update_group_capacity(struct sched_domain *sd, int cpu)
 			 */
 			if (unlikely(!rq->sd)) {
 				capacity += capacity_of(cpu);
-				continue;
+			} else {
+				sgc = rq->sd->groups->sgc;
+				capacity += sgc->capacity;
 			}
 
-			sgc = rq->sd->groups->sgc;
-			capacity += sgc->capacity;
+			max_capacity = max(capacity, max_capacity);
+			min_capacity = min(capacity, min_capacity);
 		}
 	} else  {
 		/*
@@ -6860,12 +8501,18 @@ void update_group_capacity(struct sched_domain *sd, int cpu)
 
 		group = child->groups;
 		do {
-			capacity += group->sgc->capacity;
+			struct sched_group_capacity *sgc = group->sgc;
+
+			capacity += sgc->capacity;
+			max_capacity = max(sgc->max_capacity, max_capacity);
+			min_capacity = min(sgc->min_capacity, min_capacity);
 			group = group->next;
 		} while (group != child->groups);
 	}
 
 	sdg->sgc->capacity = capacity;
+	sdg->sgc->max_capacity = max_capacity;
+	sdg->sgc->min_capacity = min_capacity;
 }
 
 /*
@@ -6960,6 +8607,17 @@ static inline int sg_imbalanced(struct sched_group *group)
 	return false;
 }
 
+/*
+ * group_smaller_cpu_capacity: Returns true if sched_group sg has smaller
+ * per-cpu capacity than sched_group ref.
+ */
+static inline bool
+group_smaller_cpu_capacity(struct sched_group *sg, struct sched_group *ref)
+{
+	return sg->sgc->max_capacity + capacity_margin - SCHED_CAPACITY_SCALE <
+							ref->sgc->max_capacity;
+}
+
 static inline enum
 group_type group_classify(struct sched_group *group,
 			  struct sg_lb_stats *sgs)
@@ -6970,9 +8628,44 @@ group_type group_classify(struct sched_group *group,
 	if (sg_imbalanced(group))
 		return group_imbalanced;
 
+	if (sgs->group_misfit_task)
+		return group_misfit_task;
+
 	return group_other;
 }
 
+#ifdef CONFIG_NO_HZ_COMMON
+/*
+ * idle load balancing data
+ *  - used by the nohz balance, but we want it available here
+ *    so that we can see which CPUs have no tick.
+ */
+static struct {
+	cpumask_var_t idle_cpus_mask;
+	atomic_t nr_cpus;
+	unsigned long next_balance;     /* in jiffy units */
+} nohz ____cacheline_aligned;
+
+static inline void update_cpu_stats_if_tickless(struct rq *rq)
+{
+	/* only called from update_sg_lb_stats when irqs are disabled */
+	if (cpumask_test_cpu(rq->cpu, nohz.idle_cpus_mask)) {
+		/* rate limit updates to once-per-jiffie at most */
+		if (READ_ONCE(jiffies) <= rq->last_load_update_tick)
+			return;
+
+		raw_spin_lock(&rq->lock);
+		update_rq_clock(rq);
+		cpu_load_update_idle(rq);
+		update_cfs_rq_load_avg(rq->clock_task, &rq->cfs, false);
+		raw_spin_unlock(&rq->lock);
+	}
+}
+
+#else
+static inline void update_cpu_stats_if_tickless(struct rq *rq) { }
+#endif
+
 /**
  * update_sg_lb_stats - Update sched_group's statistics for load balancing.
  * @env: The load balancing environment.
@@ -6981,11 +8674,12 @@ group_type group_classify(struct sched_group *group,
  * @local_group: Does group contain this_cpu.
  * @sgs: variable to hold the statistics for this group.
  * @overload: Indicate more than one runnable task for any CPU.
+ * @overutilized: Indicate overutilization for any CPU.
  */
 static inline void update_sg_lb_stats(struct lb_env *env,
 			struct sched_group *group, int load_idx,
 			int local_group, struct sg_lb_stats *sgs,
-			bool *overload)
+			bool *overload, bool *overutilized)
 {
 	unsigned long load;
 	int i, nr_running;
@@ -6995,6 +8689,12 @@ static inline void update_sg_lb_stats(struct lb_env *env,
 	for_each_cpu_and(i, sched_group_cpus(group), env->cpus) {
 		struct rq *rq = cpu_rq(i);
 
+		/* if we are entering idle and there are CPUs with
+		 * their tick stopped, do an update for them
+		 */
+		if (env->idle == CPU_NEWLY_IDLE)
+			update_cpu_stats_if_tickless(rq);
+
 		/* Bias balancing toward cpus of our domain */
 		if (local_group)
 			load = target_load(i, load_idx);
@@ -7019,6 +8719,12 @@ static inline void update_sg_lb_stats(struct lb_env *env,
 		 */
 		if (!nr_running && idle_cpu(i))
 			sgs->idle_cpus++;
+
+		if (cpu_overutilized(i)) {
+			*overutilized = true;
+			if (!sgs->group_misfit_task && rq->misfit_task)
+				sgs->group_misfit_task = capacity_of(i);
+		}
 	}
 
 	/* Adjust by relative CPU capacity of the group */
@@ -7060,9 +8766,31 @@ static bool update_sd_pick_busiest(struct lb_env *env,
 	if (sgs->group_type < busiest->group_type)
 		return false;
 
+	/*
+	 * Candidate sg doesn't face any serious load-balance problems
+	 * so don't pick it if the local sg is already filled up.
+	 */
+	if (sgs->group_type == group_other &&
+	    !group_has_capacity(env, &sds->local_stat))
+		return false;
+
 	if (sgs->avg_load <= busiest->avg_load)
 		return false;
 
+	if (!(env->sd->flags & SD_ASYM_CPUCAPACITY))
+		goto asym_packing;
+
+	/*
+	 * Candidate sg has no more than one task per CPU and
+	 * has higher per-CPU capacity. Migrating tasks to less
+	 * capable CPUs may harm throughput. Maximize throughput,
+	 * power/energy consequences are not considered.
+	 */
+	if (sgs->sum_nr_running <= sgs->group_weight &&
+	    group_smaller_cpu_capacity(sds->local, sg))
+		return false;
+
+asym_packing:
 	/* This is the busiest node in its class. */
 	if (!(env->sd->flags & SD_ASYM_PACKING))
 		return true;
@@ -7117,6 +8845,9 @@ static inline enum fbq_type fbq_classify_rq(struct rq *rq)
 }
 #endif /* CONFIG_NUMA_BALANCING */
 
+#define lb_sd_parent(sd) \
+	(sd->parent && sd->parent->groups != sd->parent->groups->next)
+
 /**
  * update_sd_lb_stats - Update sched_domain's statistics for load balancing.
  * @env: The load balancing environment.
@@ -7128,7 +8859,7 @@ static inline void update_sd_lb_stats(struct lb_env *env, struct sd_lb_stats *sd
 	struct sched_group *sg = env->sd->groups;
 	struct sg_lb_stats tmp_sgs;
 	int load_idx, prefer_sibling = 0;
-	bool overload = false;
+	bool overload = false, overutilized = false;
 
 	if (child && child->flags & SD_PREFER_SIBLING)
 		prefer_sibling = 1;
@@ -7150,7 +8881,7 @@ static inline void update_sd_lb_stats(struct lb_env *env, struct sd_lb_stats *sd
 		}
 
 		update_sg_lb_stats(env, sg, load_idx, local_group, sgs,
-						&overload);
+						&overload, &overutilized);
 
 		if (local_group)
 			goto next_group;
@@ -7172,6 +8903,15 @@ static inline void update_sd_lb_stats(struct lb_env *env, struct sd_lb_stats *sd
 			sgs->group_type = group_classify(sg, sgs);
 		}
 
+		/*
+		 * Ignore task groups with misfit tasks if local group has no
+		 * capacity or if per-cpu capacity isn't higher.
+		 */
+		if (sgs->group_type == group_misfit_task &&
+		    (!group_has_capacity(env, &sds->local_stat) ||
+		     !group_smaller_cpu_capacity(sg, sds->local)))
+			sgs->group_type = group_other;
+
 		if (update_sd_pick_busiest(env, sds, sg, sgs)) {
 			sds->busiest = sg;
 			sds->busiest_stat = *sgs;
@@ -7188,10 +8928,23 @@ static inline void update_sd_lb_stats(struct lb_env *env, struct sd_lb_stats *sd
 	if (env->sd->flags & SD_NUMA)
 		env->fbq_type = fbq_classify_group(&sds->busiest_stat);
 
-	if (!env->sd->parent) {
+	env->src_grp_nr_running = sds->busiest_stat.sum_nr_running;
+
+	if (!lb_sd_parent(env->sd)) {
 		/* update overload indicator if we are at root domain */
 		if (env->dst_rq->rd->overload != overload)
 			env->dst_rq->rd->overload = overload;
+
+		/* Update over-utilization (tipping point, U >= 0) indicator */
+		if (env->dst_rq->rd->overutilized != overutilized) {
+			env->dst_rq->rd->overutilized = overutilized;
+			trace_sched_overutilized(overutilized);
+		}
+	} else {
+		if (!env->dst_rq->rd->overutilized && overutilized) {
+			env->dst_rq->rd->overutilized = true;
+			trace_sched_overutilized(true);
+		}
 	}
 
 }
@@ -7344,6 +9097,22 @@ static inline void calculate_imbalance(struct lb_env *env, struct sd_lb_stats *s
 	 */
 	if (busiest->avg_load <= sds->avg_load ||
 	    local->avg_load >= sds->avg_load) {
+		/* Misfitting tasks should be migrated in any case */
+		if (busiest->group_type == group_misfit_task) {
+			env->imbalance = busiest->group_misfit_task;
+			return;
+		}
+
+		/*
+		 * Busiest group is overloaded, local is not, use the spare
+		 * cycles to maximize throughput
+		 */
+		if (busiest->group_type == group_overloaded &&
+		    local->group_type <= group_misfit_task) {
+			env->imbalance = busiest->load_per_task;
+			return;
+		}
+
 		env->imbalance = 0;
 		return fix_small_imbalance(env, sds);
 	}
@@ -7377,6 +9146,11 @@ static inline void calculate_imbalance(struct lb_env *env, struct sd_lb_stats *s
 		(sds->avg_load - local->avg_load) * local->group_capacity
 	) / SCHED_CAPACITY_SCALE;
 
+	/* Boost imbalance to allow misfit task to be balanced. */
+	if (busiest->group_type == group_misfit_task)
+		env->imbalance = max_t(long, env->imbalance,
+				     busiest->group_misfit_task);
+
 	/*
 	 * if *imbalance is less than the average load per runnable task
 	 * there is no guarantee that any tasks will be moved so we'll have
@@ -7412,6 +9186,10 @@ static struct sched_group *find_busiest_group(struct lb_env *env)
 	 * this level.
 	 */
 	update_sd_lb_stats(env, &sds);
+
+	if (energy_aware() && !env->dst_rq->rd->overutilized)
+		goto out_balanced;
+
 	local = &sds.local_stat;
 	busiest = &sds.busiest_stat;
 
@@ -7434,11 +9212,19 @@ static struct sched_group *find_busiest_group(struct lb_env *env)
 	if (busiest->group_type == group_imbalanced)
 		goto force_balance;
 
-	/* SD_BALANCE_NEWIDLE trumps SMP nice when underutilized */
-	if (env->idle == CPU_NEWLY_IDLE && group_has_capacity(env, local) &&
+	/*
+	 * When dst_cpu is idle, prevent SMP nice and/or asymmetric group
+	 * capacities from resulting in underutilization due to avg_load.
+	 */
+	if (env->idle != CPU_NOT_IDLE && group_has_capacity(env, local) &&
 	    busiest->group_no_capacity)
 		goto force_balance;
 
+	/* Misfitting tasks should be dealt with regardless of the avg load */
+	if (busiest->group_type == group_misfit_task) {
+		goto force_balance;
+	}
+
 	/*
 	 * If the local group is busier than the selected busiest group
 	 * don't try and pull any tasks.
@@ -7462,7 +9248,8 @@ static struct sched_group *find_busiest_group(struct lb_env *env)
 		 * might end up to just move the imbalance on another group
 		 */
 		if ((busiest->group_type != group_overloaded) &&
-				(local->idle_cpus <= (busiest->idle_cpus + 1)))
+		    (local->idle_cpus <= (busiest->idle_cpus + 1)) &&
+		    !group_smaller_cpu_capacity(sds.busiest, sds.local))
 			goto out_balanced;
 	} else {
 		/*
@@ -7475,6 +9262,7 @@ static struct sched_group *find_busiest_group(struct lb_env *env)
 	}
 
 force_balance:
+	env->busiest_group_type = busiest->group_type;
 	/* Looks like there is an imbalance. Compute it */
 	calculate_imbalance(env, &sds);
 	return sds.busiest;
@@ -7533,7 +9321,8 @@ static struct rq *find_busiest_queue(struct lb_env *env,
 		 */
 
 		if (rq->nr_running == 1 && wl > env->imbalance &&
-		    !check_cpu_capacity(rq, env->sd))
+		    !check_cpu_capacity(rq, env->sd) &&
+		    env->busiest_group_type != group_misfit_task)
 			continue;
 
 		/*
@@ -7591,6 +9380,14 @@ static int need_active_balance(struct lb_env *env)
 			return 1;
 	}
 
+	if ((capacity_of(env->src_cpu) < capacity_of(env->dst_cpu)) &&
+	    ((capacity_orig_of(env->src_cpu) < capacity_orig_of(env->dst_cpu))) &&
+				env->src_rq->cfs.h_nr_running == 1 &&
+				cpu_overutilized(env->src_cpu) &&
+				!cpu_overutilized(env->dst_cpu)) {
+			return 1;
+	}
+
 	return unlikely(sd->nr_balance_failed > sd->cache_nice_tries+2);
 }
 
@@ -7639,7 +9436,7 @@ static int load_balance(int this_cpu, struct rq *this_rq,
 			int *continue_balancing)
 {
 	int ld_moved, cur_ld_moved, active_balance = 0;
-	struct sched_domain *sd_parent = sd->parent;
+	struct sched_domain *sd_parent = lb_sd_parent(sd) ? sd->parent : NULL;
 	struct sched_group *group;
 	struct rq *busiest;
 	unsigned long flags;
@@ -7706,6 +9503,7 @@ static int load_balance(int this_cpu, struct rq *this_rq,
 
 more_balance:
 		raw_spin_lock_irqsave(&busiest->lock, flags);
+		update_rq_clock(busiest);
 
 		/*
 		 * cur_ld_moved - load moved in current iteration
@@ -7803,7 +9601,8 @@ static int load_balance(int this_cpu, struct rq *this_rq,
 		 * excessive cache_hot migrations and active balances.
 		 */
 		if (idle != CPU_NEWLY_IDLE)
-			sd->nr_balance_failed++;
+			if (env.src_grp_nr_running > 1)
+				sd->nr_balance_failed++;
 
 		if (need_active_balance(&env)) {
 			raw_spin_lock_irqsave(&busiest->lock, flags);
@@ -7940,8 +9739,9 @@ static int idle_balance(struct rq *this_rq)
 	 */
 	this_rq->idle_stamp = rq_clock(this_rq);
 
-	if (this_rq->avg_idle < sysctl_sched_migration_cost ||
-	    !this_rq->rd->overload) {
+	if (!energy_aware() &&
+	    (this_rq->avg_idle < sysctl_sched_migration_cost ||
+	     !this_rq->rd->overload)) {
 		rcu_read_lock();
 		sd = rcu_dereference_check_sched_domain(this_rq->sd);
 		if (sd)
@@ -8032,8 +9832,18 @@ static int active_load_balance_cpu_stop(void *data)
 	int busiest_cpu = cpu_of(busiest_rq);
 	int target_cpu = busiest_rq->push_cpu;
 	struct rq *target_rq = cpu_rq(target_cpu);
-	struct sched_domain *sd;
+	struct sched_domain *sd = NULL;
 	struct task_struct *p = NULL;
+	struct task_struct *push_task = NULL;
+	int push_task_detached = 0;
+	struct lb_env env = {
+		.sd		= sd,
+		.dst_cpu	= target_cpu,
+		.dst_rq		= target_rq,
+		.src_cpu	= busiest_rq->cpu,
+		.src_rq		= busiest_rq,
+		.idle		= CPU_IDLE,
+	};
 
 	raw_spin_lock_irq(&busiest_rq->lock);
 
@@ -8053,6 +9863,17 @@ static int active_load_balance_cpu_stop(void *data)
 	 */
 	BUG_ON(busiest_rq == target_rq);
 
+	push_task = busiest_rq->push_task;
+	if (push_task) {
+		if (task_on_rq_queued(push_task) &&
+			task_cpu(push_task) == busiest_cpu &&
+					cpu_online(target_cpu)) {
+			detach_task(push_task, &env);
+			push_task_detached = 1;
+		}
+		goto out_unlock;
+	}
+
 	/* Search for an sd spanning us and the target CPU. */
 	rcu_read_lock();
 	for_each_domain(target_cpu, sd) {
@@ -8062,16 +9883,9 @@ static int active_load_balance_cpu_stop(void *data)
 	}
 
 	if (likely(sd)) {
-		struct lb_env env = {
-			.sd		= sd,
-			.dst_cpu	= target_cpu,
-			.dst_rq		= target_rq,
-			.src_cpu	= busiest_rq->cpu,
-			.src_rq		= busiest_rq,
-			.idle		= CPU_IDLE,
-		};
-
+		env.sd = sd;
 		schedstat_inc(sd->alb_count);
+		update_rq_clock(busiest_rq);
 
 		p = detach_one_task(&env);
 		if (p) {
@@ -8085,8 +9899,18 @@ static int active_load_balance_cpu_stop(void *data)
 	rcu_read_unlock();
 out_unlock:
 	busiest_rq->active_balance = 0;
+
+	if (push_task)
+		busiest_rq->push_task = NULL;
+
 	raw_spin_unlock(&busiest_rq->lock);
 
+	if (push_task) {
+		if (push_task_detached)
+			attach_one_task(target_rq, push_task);
+		put_task_struct(push_task);
+	}
+
 	if (p)
 		attach_one_task(target_rq, p);
 
@@ -8107,12 +9931,6 @@ static inline int on_null_domain(struct rq *rq)
  *   needed, they will kick the idle load balancer, which then does idle
  *   load balancing for all the idle CPUs.
  */
-static struct {
-	cpumask_var_t idle_cpus_mask;
-	atomic_t nr_cpus;
-	unsigned long next_balance;     /* in jiffy units */
-} nohz ____cacheline_aligned;
-
 static inline int find_new_ilb(void)
 {
 	int ilb = cpumask_first(nohz.idle_cpus_mask);
@@ -8446,9 +10264,14 @@ static inline bool nohz_kick_needed(struct rq *rq)
 	if (time_before(now, nohz.next_balance))
 		return false;
 
-	if (rq->nr_running >= 2)
+	if (rq->nr_running >= 2 &&
+	    (!energy_aware() || cpu_overutilized(cpu)))
 		return true;
 
+	/* Do idle load balance if there have misfit task */
+	if (energy_aware())
+		return rq->misfit_task;
+
 	rcu_read_lock();
 	sds = rcu_dereference(per_cpu(sd_llc_shared, cpu));
 	if (sds) {
@@ -8542,6 +10365,47 @@ static void rq_offline_fair(struct rq *rq)
 	unthrottle_offline_cfs_rqs(rq);
 }
 
+static inline int
+kick_active_balance(struct rq *rq, struct task_struct *p, int new_cpu)
+{
+	int rc = 0;
+
+	/* Invoke active balance to force migrate currently running task */
+	raw_spin_lock(&rq->lock);
+	if (!rq->active_balance) {
+		rq->active_balance = 1;
+		rq->push_cpu = new_cpu;
+		get_task_struct(p);
+		rq->push_task = p;
+		rc = 1;
+	}
+	raw_spin_unlock(&rq->lock);
+
+	return rc;
+}
+
+void check_for_migration(struct rq *rq, struct task_struct *p)
+{
+	int new_cpu;
+	int active_balance;
+	int cpu = task_cpu(p);
+
+	if (energy_aware() && rq->misfit_task) {
+		if (rq->curr->state != TASK_RUNNING ||
+		    rq->curr->nr_cpus_allowed == 1)
+			return;
+
+		new_cpu = select_energy_cpu_brute(p, cpu, 0);
+		if (capacity_orig_of(new_cpu) > capacity_orig_of(cpu)) {
+			active_balance = kick_active_balance(rq, p, new_cpu);
+			if (active_balance)
+				stop_one_cpu_nowait(cpu,
+						active_load_balance_cpu_stop,
+						rq, &rq->active_balance_work);
+		}
+	}
+}
+
 #endif /* CONFIG_SMP */
 
 /*
@@ -8559,6 +10423,16 @@ static void task_tick_fair(struct rq *rq, struct task_struct *curr, int queued)
 
 	if (static_branch_unlikely(&sched_numa_balancing))
 		task_tick_numa(rq, curr);
+
+#ifdef CONFIG_SMP
+	if (!rq->rd->overutilized && cpu_overutilized(task_cpu(curr))) {
+		rq->rd->overutilized = true;
+		trace_sched_overutilized(true);
+	}
+
+	rq->misfit_task = !task_fits_max(curr, rq->cpu);
+#endif
+
 }
 
 /*
@@ -8645,32 +10519,45 @@ static inline bool vruntime_normalized(struct task_struct *p)
 	return false;
 }
 
-static void detach_task_cfs_rq(struct task_struct *p)
+#ifdef CONFIG_FAIR_GROUP_SCHED
+/*
+ * Propagate the changes of the sched_entity across the tg tree to make it
+ * visible to the root
+ */
+static void propagate_entity_cfs_rq(struct sched_entity *se)
 {
-	struct sched_entity *se = &p->se;
-	struct cfs_rq *cfs_rq = cfs_rq_of(se);
-	u64 now = cfs_rq_clock_task(cfs_rq);
+	struct cfs_rq *cfs_rq;
 
-	if (!vruntime_normalized(p)) {
-		/*
-		 * Fix up our vruntime so that the current sleep doesn't
-		 * cause 'unlimited' sleep bonus.
-		 */
-		place_entity(cfs_rq, se, 0);
-		se->vruntime -= cfs_rq->min_vruntime;
+	/* Start to propagate at parent */
+	se = se->parent;
+
+	for_each_sched_entity(se) {
+		cfs_rq = cfs_rq_of(se);
+
+		if (cfs_rq_throttled(cfs_rq))
+			break;
+
+		update_load_avg(se, UPDATE_TG);
 	}
+}
+#else
+static void propagate_entity_cfs_rq(struct sched_entity *se) { }
+#endif
+
+static void detach_entity_cfs_rq(struct sched_entity *se)
+{
+	struct cfs_rq *cfs_rq = cfs_rq_of(se);
 
 	/* Catch up with the cfs_rq and remove our load when we leave */
-	update_cfs_rq_load_avg(now, cfs_rq, false);
+	update_load_avg(se, 0);
 	detach_entity_load_avg(cfs_rq, se);
 	update_tg_load_avg(cfs_rq, false);
+	propagate_entity_cfs_rq(se);
 }
 
-static void attach_task_cfs_rq(struct task_struct *p)
+static void attach_entity_cfs_rq(struct sched_entity *se)
 {
-	struct sched_entity *se = &p->se;
 	struct cfs_rq *cfs_rq = cfs_rq_of(se);
-	u64 now = cfs_rq_clock_task(cfs_rq);
 
 #ifdef CONFIG_FAIR_GROUP_SCHED
 	/*
@@ -8680,10 +10567,36 @@ static void attach_task_cfs_rq(struct task_struct *p)
 	se->depth = se->parent ? se->parent->depth + 1 : 0;
 #endif
 
-	/* Synchronize task with its cfs_rq */
-	update_cfs_rq_load_avg(now, cfs_rq, false);
+	/* Synchronize entity with its cfs_rq */
+	update_load_avg(se, sched_feat(ATTACH_AGE_LOAD) ? 0 : SKIP_AGE_LOAD);
 	attach_entity_load_avg(cfs_rq, se);
 	update_tg_load_avg(cfs_rq, false);
+	propagate_entity_cfs_rq(se);
+}
+
+static void detach_task_cfs_rq(struct task_struct *p)
+{
+	struct sched_entity *se = &p->se;
+	struct cfs_rq *cfs_rq = cfs_rq_of(se);
+
+	if (!vruntime_normalized(p)) {
+		/*
+		 * Fix up our vruntime so that the current sleep doesn't
+		 * cause 'unlimited' sleep bonus.
+		 */
+		place_entity(cfs_rq, se, 0);
+		se->vruntime -= cfs_rq->min_vruntime;
+	}
+
+	detach_entity_cfs_rq(se);
+}
+
+static void attach_task_cfs_rq(struct task_struct *p)
+{
+	struct sched_entity *se = &p->se;
+	struct cfs_rq *cfs_rq = cfs_rq_of(se);
+
+	attach_entity_cfs_rq(se);
 
 	if (!vruntime_normalized(p))
 		se->vruntime += cfs_rq->min_vruntime;
@@ -8737,6 +10650,9 @@ void init_cfs_rq(struct cfs_rq *cfs_rq)
 	cfs_rq->min_vruntime_copy = cfs_rq->min_vruntime;
 #endif
 #ifdef CONFIG_SMP
+#ifdef CONFIG_FAIR_GROUP_SCHED
+	cfs_rq->propagate_avg = 0;
+#endif
 	atomic_long_set(&cfs_rq->removed_load_avg, 0);
 	atomic_long_set(&cfs_rq->removed_util_avg, 0);
 #endif
@@ -8845,7 +10761,8 @@ void online_fair_sched_group(struct task_group *tg)
 		se = tg->se[i];
 
 		raw_spin_lock_irq(&rq->lock);
-		post_init_entity_util_avg(se);
+		update_rq_clock(rq);
+		attach_entity_cfs_rq(se);
 		sync_throttle(tg, i);
 		raw_spin_unlock_irq(&rq->lock);
 	}
@@ -8937,8 +10854,10 @@ int sched_group_set_shares(struct task_group *tg, unsigned long shares)
 
 		/* Possible calls to update_curr() need rq clock */
 		update_rq_clock(rq);
-		for_each_sched_entity(se)
-			update_cfs_shares(group_cfs_rq(se));
+		for_each_sched_entity(se) {
+			update_load_avg(se, UPDATE_TG);
+			update_cfs_shares(se);
+		}
 		raw_spin_unlock_irqrestore(&rq->lock, flags);
 	}
 
diff --git a/kernel/sched/features.h b/kernel/sched/features.h
index 1b3c818..c7f1bdd 100644
--- a/kernel/sched/features.h
+++ b/kernel/sched/features.h
@@ -74,3 +74,27 @@
 SCHED_FEAT(LB_MIN, false)
 SCHED_FEAT(ATTACH_AGE_LOAD, true)
 
+/*
+ * Energy aware scheduling. Use platform energy model to guide scheduling
+ * decisions optimizing for energy efficiency.
+ */
+#ifdef CONFIG_DEFAULT_USE_ENERGY_AWARE
+SCHED_FEAT(ENERGY_AWARE, true)
+#else
+SCHED_FEAT(ENERGY_AWARE, false)
+#endif
+
+/*
+ * Minimum capacity capping. Keep track of minimum capacity factor when
+ * minimum frequency available to a policy is modified.
+ * If enabled, this can be used to inform the scheduler about capacity
+ * restrictions.
+ */
+SCHED_FEAT(MIN_CAPACITY_CAPPING, false)
+
+/*
+ * Enforce the priority of candidates selected by find_best_target()
+ * ON: If the target CPU saves any energy, use that.
+ * OFF: Use whichever of target or backup saves most.
+ */
+SCHED_FEAT(FBT_STRICT_ORDER, true)
diff --git a/kernel/sched/idle.c b/kernel/sched/idle.c
index 1d8718d..cf75f00f7 100644
--- a/kernel/sched/idle.c
+++ b/kernel/sched/idle.c
@@ -23,9 +23,10 @@
  * sched_idle_set_state - Record idle state for the current CPU.
  * @idle_state: State to record.
  */
-void sched_idle_set_state(struct cpuidle_state *idle_state)
+void sched_idle_set_state(struct cpuidle_state *idle_state, int index)
 {
 	idle_set_state(this_rq(), idle_state);
+	idle_set_state_idx(this_rq(), index);
 }
 
 static int __read_mostly cpu_idle_force_poll;
diff --git a/kernel/sched/rt.c b/kernel/sched/rt.c
index 9ab4d73..5b4c9b4 100644
--- a/kernel/sched/rt.c
+++ b/kernel/sched/rt.c
@@ -8,6 +8,8 @@
 #include <linux/slab.h>
 #include <linux/irq_work.h>
 
+#include "walt.h"
+
 int sched_rr_timeslice = RR_TIMESLICE;
 
 static int do_sched_rt_period_timer(struct rt_bandwidth *rt_b, int overrun);
@@ -888,6 +890,51 @@ static inline int rt_se_prio(struct sched_rt_entity *rt_se)
 	return rt_task_of(rt_se)->prio;
 }
 
+static void dump_throttled_rt_tasks(struct rt_rq *rt_rq)
+{
+	struct rt_prio_array *array = &rt_rq->active;
+	struct sched_rt_entity *rt_se;
+	char buf[500];
+	char *pos = buf;
+	char *end = buf + sizeof(buf);
+	int idx;
+
+	pos += snprintf(pos, sizeof(buf),
+		"sched: RT throttling activated for rt_rq %p (cpu %d)\n",
+		rt_rq, cpu_of(rq_of_rt_rq(rt_rq)));
+
+	if (bitmap_empty(array->bitmap, MAX_RT_PRIO))
+		goto out;
+
+	pos += snprintf(pos, end - pos, "potential CPU hogs:\n");
+	idx = sched_find_first_bit(array->bitmap);
+	while (idx < MAX_RT_PRIO) {
+		list_for_each_entry(rt_se, array->queue + idx, run_list) {
+			struct task_struct *p;
+
+			if (!rt_entity_is_task(rt_se))
+				continue;
+
+			p = rt_task_of(rt_se);
+			if (pos < end)
+				pos += snprintf(pos, end - pos, "\t%s (%d)\n",
+					p->comm, p->pid);
+		}
+		idx = find_next_bit(array->bitmap, MAX_RT_PRIO, idx + 1);
+	}
+out:
+#ifdef CONFIG_PANIC_ON_RT_THROTTLING
+	/*
+	 * Use pr_err() in the BUG() case since printk_sched() will
+	 * not get flushed and deadlock is not a concern.
+	 */
+	pr_err("%s", buf);
+	BUG();
+#else
+	printk_deferred("%s", buf);
+#endif
+}
+
 static int sched_rt_runtime_exceeded(struct rt_rq *rt_rq)
 {
 	u64 runtime = sched_rt_runtime(rt_rq);
@@ -911,8 +958,14 @@ static int sched_rt_runtime_exceeded(struct rt_rq *rt_rq)
 		 * but accrue some time due to boosting.
 		 */
 		if (likely(rt_b->rt_runtime)) {
+			static bool once = false;
+
 			rt_rq->rt_throttled = 1;
-			printk_deferred_once("sched: RT throttling activated\n");
+
+			if (!once) {
+				once = true;
+				dump_throttled_rt_tasks(rt_rq);
+			}
 		} else {
 			/*
 			 * In case we did anyway, make it go away,
@@ -1313,6 +1366,7 @@ static void dequeue_rt_entity(struct sched_rt_entity *rt_se, unsigned int flags)
 		rt_se->timeout = 0;
 
 	enqueue_rt_entity(rt_se, flags);
+	walt_inc_cumulative_runnable_avg(rq, p);
 
 	if (!task_current(rq, p) && tsk_nr_cpus_allowed(p) > 1)
 		enqueue_pushable_task(rq, p);
@@ -1324,6 +1378,7 @@ static void dequeue_task_rt(struct rq *rq, struct task_struct *p, int flags)
 
 	update_curr_rt(rq);
 	dequeue_rt_entity(rt_se, flags);
+	walt_dec_cumulative_runnable_avg(rq, p);
 
 	dequeue_pushable_task(rq, p);
 }
@@ -1833,7 +1888,9 @@ static int push_rt_task(struct rq *rq)
 	}
 
 	deactivate_task(rq, next_task, 0);
+	next_task->on_rq = TASK_ON_RQ_MIGRATING;
 	set_task_cpu(next_task, lowest_rq->cpu);
+	next_task->on_rq = TASK_ON_RQ_QUEUED;
 	activate_task(lowest_rq, next_task, 0);
 	ret = 1;
 
@@ -2105,7 +2162,9 @@ static void pull_rt_task(struct rq *this_rq)
 			resched = true;
 
 			deactivate_task(src_rq, p, 0);
+			p->on_rq = TASK_ON_RQ_MIGRATING;
 			set_task_cpu(p, this_cpu);
+			p->on_rq = TASK_ON_RQ_QUEUED;
 			activate_task(this_rq, p, 0);
 			/*
 			 * We continue with the search, just in
diff --git a/kernel/sched/sched.h b/kernel/sched/sched.h
index f564a1d2..09d1219 100644
--- a/kernel/sched/sched.h
+++ b/kernel/sched/sched.h
@@ -39,8 +39,10 @@
 
 #ifdef CONFIG_SMP
 extern void cpu_load_update_active(struct rq *this_rq);
+extern void check_for_migration(struct rq *rq, struct task_struct *p);
 #else
 static inline void cpu_load_update_active(struct rq *this_rq) { }
+static inline void check_for_migration(struct rq *rq, struct task_struct *p) { }
 #endif
 
 #ifdef CONFIG_SCHED_SMT
@@ -410,6 +412,7 @@ struct cfs_rq {
 	unsigned long runnable_load_avg;
 #ifdef CONFIG_FAIR_GROUP_SCHED
 	unsigned long tg_load_avg_contrib;
+	unsigned long propagate_avg;
 #endif
 	atomic_long_t removed_load_avg, removed_util_avg;
 #ifndef CONFIG_64BIT
@@ -453,6 +456,9 @@ struct cfs_rq {
 	u64 throttled_clock_task_time;
 	int throttled, throttle_count;
 	struct list_head throttled_list;
+#ifdef CONFIG_SCHED_WALT
+	u64 cumulative_runnable_avg;
+#endif /* CONFIG_SCHED_WALT */
 #endif /* CONFIG_CFS_BANDWIDTH */
 #endif /* CONFIG_FAIR_GROUP_SCHED */
 };
@@ -539,6 +545,12 @@ struct dl_rq {
 
 #ifdef CONFIG_SMP
 
+struct max_cpu_capacity {
+	raw_spinlock_t lock;
+	unsigned long val;
+	int cpu;
+};
+
 /*
  * We add the notion of a root-domain which will be used to define per-domain
  * variables. Each exclusive cpuset essentially defines an island domain by
@@ -557,6 +569,9 @@ struct root_domain {
 	/* Indicate more than one runnable task for any CPU */
 	bool overload;
 
+	/* Indicate one or more cpus over-utilized (tipping point) */
+	bool overutilized;
+
 	/*
 	 * The bit corresponding to a CPU gets set here if such CPU has more
 	 * than one runnable -deadline task (as it is below for RT tasks).
@@ -586,7 +601,11 @@ struct root_domain {
 	cpumask_var_t rto_mask;
 	struct cpupri cpupri;
 
-	unsigned long max_cpu_capacity;
+	/* Maximum cpu capacity in the system. */
+	struct max_cpu_capacity max_cpu_capacity;
+
+	/* First cpu with maximum and minimum original capacity */
+	int max_cap_orig_cpu, min_cap_orig_cpu;
 };
 
 extern struct root_domain def_root_domain;
@@ -620,6 +639,7 @@ struct rq {
 #endif
 	#define CPU_LOAD_IDX_MAX 5
 	unsigned long cpu_load[CPU_LOAD_IDX_MAX];
+	unsigned int misfit_task;
 #ifdef CONFIG_NO_HZ_COMMON
 #ifdef CONFIG_SMP
 	unsigned long last_load_update_tick;
@@ -629,6 +649,14 @@ struct rq {
 #ifdef CONFIG_NO_HZ_FULL
 	unsigned long last_sched_tick;
 #endif
+
+#ifdef CONFIG_CPU_QUIET
+	/* time-based average load */
+	u64 nr_last_stamp;
+	u64 nr_running_integral;
+	seqcount_t ave_seqcnt;
+#endif
+
 	/* capture load from *all* tasks on this cpu: */
 	struct load_weight load;
 	unsigned long nr_load_updates;
@@ -641,6 +669,7 @@ struct rq {
 #ifdef CONFIG_FAIR_GROUP_SCHED
 	/* list of leaf cfs_rq on this cpu: */
 	struct list_head leaf_cfs_rq_list;
+	struct list_head *tmp_alone_branch;
 #endif /* CONFIG_FAIR_GROUP_SCHED */
 
 	/*
@@ -674,6 +703,7 @@ struct rq {
 	/* For active balancing */
 	int active_balance;
 	int push_cpu;
+	struct task_struct *push_task;
 	struct cpu_stop_work active_balance_work;
 	/* cpu of this runqueue: */
 	int cpu;
@@ -690,6 +720,20 @@ struct rq {
 	u64 max_idle_balance_cost;
 #endif
 
+#ifdef CONFIG_SCHED_WALT
+	u64 cumulative_runnable_avg;
+	u64 window_start;
+	u64 curr_runnable_sum;
+	u64 prev_runnable_sum;
+	u64 nt_curr_runnable_sum;
+	u64 nt_prev_runnable_sum;
+	u64 cur_irqload;
+	u64 avg_irqload;
+	u64 irqload_ts;
+	u64 cum_window_demand;
+#endif /* CONFIG_SCHED_WALT */
+
+
 #ifdef CONFIG_IRQ_TIME_ACCOUNTING
 	u64 prev_irq_time;
 #endif
@@ -728,6 +772,9 @@ struct rq {
 	/* try_to_wake_up() stats */
 	unsigned int ttwu_count;
 	unsigned int ttwu_local;
+#ifdef CONFIG_SMP
+	struct eas_stats eas_stats;
+#endif
 #endif
 
 #ifdef CONFIG_SMP
@@ -737,6 +784,7 @@ struct rq {
 #ifdef CONFIG_CPU_IDLE
 	/* Must be inspected within a rcu lock section */
 	struct cpuidle_state *idle_state;
+	int idle_state_idx;
 #endif
 };
 
@@ -886,6 +934,8 @@ static inline struct sched_domain *lowest_flag_domain(int cpu, int flag)
 DECLARE_PER_CPU(struct sched_domain_shared *, sd_llc_shared);
 DECLARE_PER_CPU(struct sched_domain *, sd_numa);
 DECLARE_PER_CPU(struct sched_domain *, sd_asym);
+DECLARE_PER_CPU(struct sched_domain *, sd_ea);
+DECLARE_PER_CPU(struct sched_domain *, sd_scs);
 
 struct sched_group_capacity {
 	atomic_t ref;
@@ -893,7 +943,9 @@ struct sched_group_capacity {
 	 * CPU capacity of this group, SCHED_CAPACITY_SCALE being max capacity
 	 * for a single CPU.
 	 */
-	unsigned int capacity;
+	unsigned long capacity;
+	unsigned long max_capacity; /* Max per-cpu capacity in group */
+	unsigned long min_capacity; /* Min per-CPU capacity in group */
 	unsigned long next_update;
 	int imbalance; /* XXX unrelated to capacity but shared group state */
 
@@ -906,6 +958,7 @@ struct sched_group {
 
 	unsigned int group_weight;
 	struct sched_group_capacity *sgc;
+	const struct sched_group_energy *sge;
 
 	/*
 	 * The CPUs this group covers.
@@ -1214,6 +1267,7 @@ static inline void finish_lock_switch(struct rq *rq, struct task_struct *prev)
 #else
 #define ENQUEUE_MIGRATED	0x00
 #endif
+#define ENQUEUE_WAKEUP_NEW	0x40
 
 #define RETRY_TASK		((void *)-1UL)
 
@@ -1304,6 +1358,7 @@ static inline void set_curr_task(struct rq *rq, struct task_struct *curr)
 
 #ifdef CONFIG_SMP
 
+extern void init_max_cpu_capacity(struct max_cpu_capacity *mcc);
 extern void update_group_capacity(struct sched_domain *sd, int cpu);
 
 extern void trigger_load_balance(struct rq *rq);
@@ -1324,6 +1379,17 @@ static inline struct cpuidle_state *idle_get_state(struct rq *rq)
 	SCHED_WARN_ON(!rcu_read_lock_held());
 	return rq->idle_state;
 }
+
+static inline void idle_set_state_idx(struct rq *rq, int idle_state_idx)
+{
+	rq->idle_state_idx = idle_state_idx;
+}
+
+static inline int idle_get_state_idx(struct rq *rq)
+{
+	WARN_ON(!rcu_read_lock_held());
+	return rq->idle_state_idx;
+}
 #else
 static inline void idle_set_state(struct rq *rq,
 				  struct cpuidle_state *idle_state)
@@ -1334,6 +1400,15 @@ static inline struct cpuidle_state *idle_get_state(struct rq *rq)
 {
 	return NULL;
 }
+
+static inline void idle_set_state_idx(struct rq *rq, int idle_state_idx)
+{
+}
+
+static inline int idle_get_state_idx(struct rq *rq)
+{
+	return -1;
+}
 #endif
 
 extern void sysrq_sched_debug_show(void);
@@ -1388,7 +1463,7 @@ static inline void sched_update_tick_dependency(struct rq *rq)
 static inline void sched_update_tick_dependency(struct rq *rq) { }
 #endif
 
-static inline void add_nr_running(struct rq *rq, unsigned count)
+static inline void __add_nr_running(struct rq *rq, unsigned count)
 {
 	unsigned prev_nr = rq->nr_running;
 
@@ -1404,13 +1479,50 @@ static inline void add_nr_running(struct rq *rq, unsigned count)
 	sched_update_tick_dependency(rq);
 }
 
-static inline void sub_nr_running(struct rq *rq, unsigned count)
+static inline void __sub_nr_running(struct rq *rq, unsigned count)
 {
 	rq->nr_running -= count;
 	/* Check if we still need preemption */
 	sched_update_tick_dependency(rq);
 }
 
+#ifdef CONFIG_CPU_QUIET
+#define NR_AVE_SCALE(x)		((x) << FSHIFT)
+static inline u64 do_nr_running_integral(struct rq *rq)
+{
+	s64 nr, deltax;
+	u64 nr_running_integral = rq->nr_running_integral;
+
+	deltax = rq->clock_task - rq->nr_last_stamp;
+	nr = NR_AVE_SCALE(rq->nr_running);
+
+	nr_running_integral += nr * deltax;
+
+	return nr_running_integral;
+}
+
+static inline void add_nr_running(struct rq *rq, unsigned count)
+{
+	write_seqcount_begin(&rq->ave_seqcnt);
+	rq->nr_running_integral = do_nr_running_integral(rq);
+	rq->nr_last_stamp = rq->clock_task;
+	__add_nr_running(rq, count);
+	write_seqcount_end(&rq->ave_seqcnt);
+}
+
+static inline void sub_nr_running(struct rq *rq, unsigned count)
+{
+	write_seqcount_begin(&rq->ave_seqcnt);
+	rq->nr_running_integral = do_nr_running_integral(rq);
+	rq->nr_last_stamp = rq->clock_task;
+	__sub_nr_running(rq, count);
+	write_seqcount_end(&rq->ave_seqcnt);
+}
+#else
+#define add_nr_running __add_nr_running
+#define sub_nr_running __sub_nr_running
+#endif
+
 static inline void rq_last_tick_reset(struct rq *rq)
 {
 #ifdef CONFIG_NO_HZ_FULL
@@ -1472,6 +1584,26 @@ unsigned long arch_scale_freq_capacity(struct sched_domain *sd, int cpu)
 }
 #endif
 
+#ifndef arch_scale_max_freq_capacity
+static __always_inline
+unsigned long arch_scale_max_freq_capacity(struct sched_domain *sd, int cpu)
+{
+	return SCHED_CAPACITY_SCALE;
+}
+#endif
+
+#ifndef arch_scale_min_freq_capacity
+static __always_inline
+unsigned long arch_scale_min_freq_capacity(struct sched_domain *sd, int cpu)
+{
+	/*
+	 * Multiplied with any capacity value, this scale factor will return
+	 * 0, which represents an un-capped state
+	 */
+	return 0;
+}
+#endif
+
 #ifndef arch_scale_cpu_capacity
 static __always_inline
 unsigned long arch_scale_cpu_capacity(struct sched_domain *sd, int cpu)
@@ -1483,10 +1615,87 @@ unsigned long arch_scale_cpu_capacity(struct sched_domain *sd, int cpu)
 }
 #endif
 
+#ifdef CONFIG_SMP
+static inline unsigned long capacity_of(int cpu)
+{
+	return cpu_rq(cpu)->cpu_capacity;
+}
+
+static inline unsigned long capacity_orig_of(int cpu)
+{
+	return cpu_rq(cpu)->cpu_capacity_orig;
+}
+
+extern unsigned int sysctl_sched_use_walt_cpu_util;
+extern unsigned int walt_ravg_window;
+extern bool walt_disabled;
+
+/*
+ * cpu_util returns the amount of capacity of a CPU that is used by CFS
+ * tasks. The unit of the return value must be the one of capacity so we can
+ * compare the utilization with the capacity of the CPU that is available for
+ * CFS task (ie cpu_capacity).
+ *
+ * cfs_rq.avg.util_avg is the sum of running time of runnable tasks plus the
+ * recent utilization of currently non-runnable tasks on a CPU. It represents
+ * the amount of utilization of a CPU in the range [0..capacity_orig] where
+ * capacity_orig is the cpu_capacity available at the highest frequency
+ * (arch_scale_freq_capacity()).
+ * The utilization of a CPU converges towards a sum equal to or less than the
+ * current capacity (capacity_curr <= capacity_orig) of the CPU because it is
+ * the running time on this CPU scaled by capacity_curr.
+ *
+ * Nevertheless, cfs_rq.avg.util_avg can be higher than capacity_curr or even
+ * higher than capacity_orig because of unfortunate rounding in
+ * cfs.avg.util_avg or just after migrating tasks and new task wakeups until
+ * the average stabilizes with the new running time. We need to check that the
+ * utilization stays within the range of [0..capacity_orig] and cap it if
+ * necessary. Without utilization capping, a group could be seen as overloaded
+ * (CPU0 utilization at 121% + CPU1 utilization at 80%) whereas CPU1 has 20% of
+ * available capacity. We allow utilization to overshoot capacity_curr (but not
+ * capacity_orig) as it useful for predicting the capacity required after task
+ * migrations (scheduler-driven DVFS).
+ */
+static inline unsigned long __cpu_util(int cpu, int delta)
+{
+	unsigned long util = cpu_rq(cpu)->cfs.avg.util_avg;
+	unsigned long capacity = capacity_orig_of(cpu);
+
+#ifdef CONFIG_SCHED_WALT
+	if (!walt_disabled && sysctl_sched_use_walt_cpu_util) 
+		util = div64_u64(cpu_rq(cpu)->cumulative_runnable_avg,
+			       walt_ravg_window >> SCHED_CAPACITY_SHIFT);
+#endif
+	delta += util;
+	if (delta < 0)
+		return 0;
+
+	return (delta >= capacity) ? capacity : delta;
+}
+
+static inline unsigned long cpu_util(int cpu)
+{
+	return __cpu_util(cpu, 0);
+}
+
+static inline unsigned long cpu_util_freq(int cpu)
+{
+	unsigned long util = cpu_rq(cpu)->cfs.avg.util_avg;
+	unsigned long capacity = capacity_orig_of(cpu);
+
+#ifdef CONFIG_SCHED_WALT
+	if (!walt_disabled && sysctl_sched_use_walt_cpu_util)
+		util = div64_u64(cpu_rq(cpu)->prev_runnable_sum,
+				 walt_ravg_window >> SCHED_CAPACITY_SHIFT);
+#endif
+	return (util >= capacity) ? capacity : util;
+}
+
+#endif
+
 static inline void sched_rt_avg_update(struct rq *rq, u64 rt_delta)
 {
 	rq->rt_avg += rt_delta * arch_scale_freq_capacity(NULL, cpu_of(rq));
-	sched_avg_update(rq);
 }
 #else
 static inline void sched_rt_avg_update(struct rq *rq, u64 rt_delta) { }
@@ -1521,6 +1730,9 @@ static inline void __task_rq_unlock(struct rq *rq, struct rq_flags *rf)
 	raw_spin_unlock_irqrestore(&p->pi_lock, rf->flags);
 }
 
+extern struct rq *lock_rq_of(struct task_struct *p, struct rq_flags *flags);
+extern void unlock_rq_of(struct rq *rq, struct task_struct *p, struct rq_flags *flags);
+
 #ifdef CONFIG_SMP
 #ifdef CONFIG_PREEMPT
 
@@ -1593,7 +1805,8 @@ static inline int double_lock_balance(struct rq *this_rq, struct rq *busiest)
 static inline void double_unlock_balance(struct rq *this_rq, struct rq *busiest)
 	__releases(busiest->lock)
 {
-	raw_spin_unlock(&busiest->lock);
+	if (this_rq != busiest)
+		raw_spin_unlock(&busiest->lock);
 	lock_set_subclass(&this_rq->lock.dep_map, 0, _RET_IP_);
 }
 
@@ -1809,6 +2022,17 @@ static inline void cpufreq_update_util(struct rq *rq, unsigned int flags) {}
 static inline void cpufreq_update_this_cpu(struct rq *rq, unsigned int flags) {}
 #endif /* CONFIG_CPU_FREQ */
 
+#ifdef CONFIG_SCHED_WALT
+
+static inline bool
+walt_task_in_cum_window_demand(struct rq *rq, struct task_struct *p)
+{
+	return cpu_of(rq) == task_cpu(p) &&
+	       (p->on_rq || p->last_sleep_ts >= rq->window_start);
+}
+
+#endif /* CONFIG_SCHED_WALT */
+
 #ifdef arch_scale_freq_capacity
 #ifndef arch_scale_freq_invariant
 #define arch_scale_freq_invariant()	(true)
diff --git a/kernel/sched/stats.c b/kernel/sched/stats.c
index 87e2c9f..6d74a7c 100644
--- a/kernel/sched/stats.c
+++ b/kernel/sched/stats.c
@@ -12,6 +12,28 @@
  */
 #define SCHEDSTAT_VERSION 15
 
+#ifdef CONFIG_SMP
+static inline void show_easstat(struct seq_file *seq, struct eas_stats *stats)
+{
+	/* eas-specific runqueue stats */
+	seq_printf(seq, "eas %llu %llu %llu %llu %llu %llu ",
+	    stats->sis_attempts, stats->sis_idle, stats->sis_cache_affine,
+	    stats->sis_suff_cap, stats->sis_idle_cpu, stats->sis_count);
+
+	seq_printf(seq, "%llu %llu %llu %llu %llu %llu %llu ",
+	    stats->secb_attempts, stats->secb_sync, stats->secb_idle_bt,
+	    stats->secb_insuff_cap, stats->secb_no_nrg_sav,
+	    stats->secb_nrg_sav, stats->secb_count);
+
+	seq_printf(seq, "%llu %llu %llu %llu %llu ",
+	    stats->fbt_attempts, stats->fbt_no_cpu, stats->fbt_no_sd,
+	    stats->fbt_pref_idle, stats->fbt_count);
+
+	seq_printf(seq, "%llu %llu\n",
+	    stats->cas_attempts, stats->cas_count);
+}
+#endif
+
 static int show_schedstat(struct seq_file *seq, void *v)
 {
 	int cpu;
@@ -40,6 +62,8 @@ static int show_schedstat(struct seq_file *seq, void *v)
 		seq_printf(seq, "\n");
 
 #ifdef CONFIG_SMP
+		show_easstat(seq, &rq->eas_stats);
+
 		/* domain-specific stats */
 		rcu_read_lock();
 		for_each_domain(cpu, sd) {
@@ -66,6 +90,8 @@ static int show_schedstat(struct seq_file *seq, void *v)
 			    sd->sbf_count, sd->sbf_balanced, sd->sbf_pushed,
 			    sd->ttwu_wake_remote, sd->ttwu_move_affine,
 			    sd->ttwu_move_balance);
+
+			show_easstat(seq, &sd->eas_stats);
 		}
 		rcu_read_unlock();
 #endif
diff --git a/kernel/sched/stop_task.c b/kernel/sched/stop_task.c
index 604297a..836a389 100644
--- a/kernel/sched/stop_task.c
+++ b/kernel/sched/stop_task.c
@@ -1,4 +1,5 @@
 #include "sched.h"
+#include "walt.h"
 
 /*
  * stop-task scheduling class.
@@ -42,12 +43,14 @@
 enqueue_task_stop(struct rq *rq, struct task_struct *p, int flags)
 {
 	add_nr_running(rq, 1);
+	walt_inc_cumulative_runnable_avg(rq, p);
 }
 
 static void
 dequeue_task_stop(struct rq *rq, struct task_struct *p, int flags)
 {
 	sub_nr_running(rq, 1);
+	walt_dec_cumulative_runnable_avg(rq, p);
 }
 
 static void yield_task_stop(struct rq *rq)
diff --git a/kernel/sched/tune.c b/kernel/sched/tune.c
new file mode 100644
index 00000000..fbdd00a
--- /dev/null
+++ b/kernel/sched/tune.c
@@ -0,0 +1,1027 @@
+#include <linux/cgroup.h>
+#include <linux/err.h>
+#include <linux/kernel.h>
+#include <linux/percpu.h>
+#include <linux/printk.h>
+#include <linux/rcupdate.h>
+#include <linux/slab.h>
+
+#include <trace/events/sched.h>
+
+#include "sched.h"
+#include "tune.h"
+
+#ifdef CONFIG_CGROUP_SCHEDTUNE
+bool schedtune_initialized = false;
+#endif
+
+unsigned int sysctl_sched_cfs_boost __read_mostly;
+
+extern struct reciprocal_value schedtune_spc_rdiv;
+struct target_nrg schedtune_target_nrg;
+
+/* Performance Boost region (B) threshold params */
+static int perf_boost_idx;
+
+/* Performance Constraint region (C) threshold params */
+static int perf_constrain_idx;
+
+/**
+ * Performance-Energy (P-E) Space thresholds constants
+ */
+struct threshold_params {
+	int nrg_gain;
+	int cap_gain;
+};
+
+/*
+ * System specific P-E space thresholds constants
+ */
+static struct threshold_params
+threshold_gains[] = {
+	{ 0, 5 }, /*   < 10% */
+	{ 1, 5 }, /*   < 20% */
+	{ 2, 5 }, /*   < 30% */
+	{ 3, 5 }, /*   < 40% */
+	{ 4, 5 }, /*   < 50% */
+	{ 5, 4 }, /*   < 60% */
+	{ 5, 3 }, /*   < 70% */
+	{ 5, 2 }, /*   < 80% */
+	{ 5, 1 }, /*   < 90% */
+	{ 5, 0 }  /* <= 100% */
+};
+
+static int
+__schedtune_accept_deltas(int nrg_delta, int cap_delta,
+			  int perf_boost_idx, int perf_constrain_idx)
+{
+	int payoff = -INT_MAX;
+	int gain_idx = -1;
+
+	/* Performance Boost (B) region */
+	if (nrg_delta >= 0 && cap_delta > 0)
+		gain_idx = perf_boost_idx;
+	/* Performance Constraint (C) region */
+	else if (nrg_delta < 0 && cap_delta <= 0)
+		gain_idx = perf_constrain_idx;
+
+	/* Default: reject schedule candidate */
+	if (gain_idx == -1)
+		return payoff;
+
+	/*
+	 * Evaluate "Performance Boost" vs "Energy Increase"
+	 *
+	 * - Performance Boost (B) region
+	 *
+	 *   Condition: nrg_delta > 0 && cap_delta > 0
+	 *   Payoff criteria:
+	 *     cap_gain / nrg_gain  < cap_delta / nrg_delta =
+	 *     cap_gain * nrg_delta < cap_delta * nrg_gain
+	 *   Note that since both nrg_gain and nrg_delta are positive, the
+	 *   inequality does not change. Thus:
+	 *
+	 *     payoff = (cap_delta * nrg_gain) - (cap_gain * nrg_delta)
+	 *
+	 * - Performance Constraint (C) region
+	 *
+	 *   Condition: nrg_delta < 0 && cap_delta < 0
+	 *   payoff criteria:
+	 *     cap_gain / nrg_gain  > cap_delta / nrg_delta =
+	 *     cap_gain * nrg_delta < cap_delta * nrg_gain
+	 *   Note that since nrg_gain > 0 while nrg_delta < 0, the
+	 *   inequality change. Thus:
+	 *
+	 *     payoff = (cap_delta * nrg_gain) - (cap_gain * nrg_delta)
+	 *
+	 * This means that, in case of same positive defined {cap,nrg}_gain
+	 * for both the B and C regions, we can use the same payoff formula
+	 * where a positive value represents the accept condition.
+	 */
+	payoff  = cap_delta * threshold_gains[gain_idx].nrg_gain;
+	payoff -= nrg_delta * threshold_gains[gain_idx].cap_gain;
+
+	return payoff;
+}
+
+#ifdef CONFIG_CGROUP_SCHEDTUNE
+
+/*
+ * EAS scheduler tunables for task groups.
+ *
+ * When CGroup support is enabled, we have to synchronize two different
+ * paths:
+ *  - slow path: where CGroups are created/updated/removed
+ *  - fast path: where tasks in a CGroups are accounted
+ *
+ * The slow path tracks (a limited number of) CGroups and maps each on a
+ * "boost_group" index. The fastpath accounts tasks currently RUNNABLE on each
+ * "boost_group".
+ *
+ * Once a new CGroup is created, a boost group idx is assigned and the
+ * corresponding "boost_group" marked as valid on each CPU.
+ * Once a CGroup is release, the corresponding "boost_group" is marked as
+ * invalid on each CPU. The CPU boost value (boost_max) is aggregated by
+ * considering only valid boost_groups with a non null tasks counter.
+ *
+ * .:: Locking strategy
+ *
+ * The fast path uses a spin lock for each CPU boost_group which protects the
+ * tasks counter.
+ *
+ * The "valid" and "boost" values of each CPU boost_group is instead
+ * protected by the RCU lock provided by the CGroups callbacks. Thus, only the
+ * slow path can access and modify the boost_group attribtues of each CPU.
+ * The fast path will catch up the most updated values at the next scheduling
+ * event (i.e. enqueue/dequeue).
+ *
+ *                                                        |
+ *                                             SLOW PATH  |   FAST PATH
+ *                              CGroup add/update/remove  |   Scheduler enqueue/dequeue events
+ *                                                        |
+ *                                                        |
+ *                                                        |     DEFINE_PER_CPU(struct boost_groups)
+ *                                                        |     +--------------+----+---+----+----+
+ *                                                        |     |  idle        |    |   |    |    |
+ *                                                        |     |  boost_max   |    |   |    |    |
+ *                                                        |  +---->lock        |    |   |    |    |
+ *  struct schedtune                  allocated_groups    |  |  |  group[    ] |    |   |    |    |
+ *  +------------------------------+         +-------+    |  |  +--+---------+-+----+---+----+----+
+ *  | idx                          |         |       |    |  |     |  valid  |
+ *  | boots / prefer_idle          |         |       |    |  |     |  boost  |
+ *  | perf_{boost/constraints}_idx | <---------+(*)  |    |  |     |  tasks  | <------------+
+ *  | css                          |         +-------+    |  |     +---------+              |
+ *  +-+----------------------------+         |       |    |  |     |         |              |
+ *    ^                                      |       |    |  |     |         |              |
+ *    |                                      +-------+    |  |     +---------+              |
+ *    |                                      |       |    |  |     |         |              |
+ *    |                                      |       |    |  |     |         |              |
+ *    |                                      +-------+    |  |     +---------+              |
+ *    | zmalloc                              |       |    |  |     |         |              |
+ *    |                                      |       |    |  |     |         |              |
+ *    |                                      +-------+    |  |     +---------+              |
+ *    +                              BOOSTGROUPS_COUNT    |  |     BOOSTGROUPS_COUNT        |
+ *  schedtune_boostgroup_init()                           |  +                              |
+ *                                                        |  schedtune_{en,de}queue_task()  |
+ *                                                        |                                 +
+ *                                                        |          schedtune_tasks_update()
+ *                                                        |
+ */
+
+/* SchdTune tunables for a group of tasks */
+struct schedtune {
+	/* SchedTune CGroup subsystem */
+	struct cgroup_subsys_state css;
+
+	/* Boost group allocated ID */
+	int idx;
+
+	/* Boost value for tasks on that SchedTune CGroup */
+	int boost;
+
+	/* Performance Boost (B) region threshold params */
+	int perf_boost_idx;
+
+	/* Performance Constraint (C) region threshold params */
+	int perf_constrain_idx;
+
+	/* Hint to bias scheduling of tasks on that SchedTune CGroup
+	 * towards idle CPUs */
+	int prefer_idle;
+};
+
+static inline struct schedtune *css_st(struct cgroup_subsys_state *css)
+{
+	return css ? container_of(css, struct schedtune, css) : NULL;
+}
+
+static inline struct schedtune *task_schedtune(struct task_struct *tsk)
+{
+	return css_st(task_css(tsk, schedtune_cgrp_id));
+}
+
+static inline struct schedtune *parent_st(struct schedtune *st)
+{
+	return css_st(st->css.parent);
+}
+
+/*
+ * SchedTune root control group
+ * The root control group is used to defined a system-wide boosting tuning,
+ * which is applied to all tasks in the system.
+ * Task specific boost tuning could be specified by creating and
+ * configuring a child control group under the root one.
+ * By default, system-wide boosting is disabled, i.e. no boosting is applied
+ * to tasks which are not into a child control group.
+ */
+static struct schedtune
+root_schedtune = {
+	.boost	= 0,
+	.perf_boost_idx = 0,
+	.perf_constrain_idx = 0,
+	.prefer_idle = 0,
+};
+
+int
+schedtune_accept_deltas(int nrg_delta, int cap_delta,
+			struct task_struct *task)
+{
+	struct schedtune *ct;
+	int perf_boost_idx;
+	int perf_constrain_idx;
+
+	/* Optimal (O) region */
+	if (nrg_delta < 0 && cap_delta > 0) {
+		trace_sched_tune_filter(nrg_delta, cap_delta, 0, 0, 1, 0);
+		return INT_MAX;
+	}
+
+	/* Suboptimal (S) region */
+	if (nrg_delta > 0 && cap_delta < 0) {
+		trace_sched_tune_filter(nrg_delta, cap_delta, 0, 0, -1, 5);
+		return -INT_MAX;
+	}
+
+	/* Get task specific perf Boost/Constraints indexes */
+	rcu_read_lock();
+	ct = task_schedtune(task);
+	perf_boost_idx = ct->perf_boost_idx;
+	perf_constrain_idx = ct->perf_constrain_idx;
+	rcu_read_unlock();
+
+	return __schedtune_accept_deltas(nrg_delta, cap_delta,
+			perf_boost_idx, perf_constrain_idx);
+}
+
+/*
+ * Maximum number of boost groups to support
+ * When per-task boosting is used we still allow only limited number of
+ * boost groups for two main reasons:
+ * 1. on a real system we usually have only few classes of workloads which
+ *    make sense to boost with different values (e.g. background vs foreground
+ *    tasks, interactive vs low-priority tasks)
+ * 2. a limited number allows for a simpler and more memory/time efficient
+ *    implementation especially for the computation of the per-CPU boost
+ *    value
+ */
+#define BOOSTGROUPS_COUNT 5
+
+/* Array of configured boostgroups */
+static struct schedtune *allocated_group[BOOSTGROUPS_COUNT] = {
+	&root_schedtune,
+	NULL,
+};
+
+/* SchedTune boost groups
+ * Keep track of all the boost groups which impact on CPU, for example when a
+ * CPU has two RUNNABLE tasks belonging to two different boost groups and thus
+ * likely with different boost values.
+ * Since on each system we expect only a limited number of boost groups, here
+ * we use a simple array to keep track of the metrics required to compute the
+ * maximum per-CPU boosting value.
+ */
+struct boost_groups {
+	/* Maximum boost value for all RUNNABLE tasks on a CPU */
+	int boost_max;
+	struct {
+		/* True when this boost group maps an actual cgroup */
+		bool valid;
+		/* The boost for tasks on that boost group */
+		int boost;
+		/* Count of RUNNABLE tasks on that boost group */
+		unsigned tasks;
+	} group[BOOSTGROUPS_COUNT];
+	/* CPU's boost group locking */
+	raw_spinlock_t lock;
+};
+
+/* Boost groups affecting each CPU in the system */
+DEFINE_PER_CPU(struct boost_groups, cpu_boost_groups);
+
+static void
+schedtune_cpu_update(int cpu)
+{
+	struct boost_groups *bg;
+	int boost_max;
+	int idx;
+
+	bg = &per_cpu(cpu_boost_groups, cpu);
+
+	/* The root boost group is always active */
+	boost_max = bg->group[0].boost;
+	for (idx = 1; idx < BOOSTGROUPS_COUNT; ++idx) {
+
+		/* Ignore non boostgroups not mapping a cgroup */
+		if (!bg->group[idx].valid)
+			continue;
+
+		/*
+		 * A boost group affects a CPU only if it has
+		 * RUNNABLE tasks on that CPU
+		 */
+		if (bg->group[idx].tasks == 0)
+			continue;
+
+		boost_max = max(boost_max, bg->group[idx].boost);
+	}
+
+	/* Ensures boost_max is non-negative when all cgroup boost values
+	 * are neagtive. Avoids under-accounting of cpu capacity which may cause
+	 * task stacking and frequency spikes.*/
+	boost_max = max(boost_max, 0);
+	bg->boost_max = boost_max;
+}
+
+static int
+schedtune_boostgroup_update(int idx, int boost)
+{
+	struct boost_groups *bg;
+	int cur_boost_max;
+	int old_boost;
+	int cpu;
+
+	/* Update per CPU boost groups */
+	for_each_possible_cpu(cpu) {
+		bg = &per_cpu(cpu_boost_groups, cpu);
+
+		/* CGroups are never associated to non active cgroups */
+		BUG_ON(!bg->group[idx].valid);
+
+		/*
+		 * Keep track of current boost values to compute the per CPU
+		 * maximum only when it has been affected by the new value of
+		 * the updated boost group
+		 */
+		cur_boost_max = bg->boost_max;
+		old_boost = bg->group[idx].boost;
+
+		/* Update the boost value of this boost group */
+		bg->group[idx].boost = boost;
+
+		/* Check if this update increase current max */
+		if (boost > cur_boost_max && bg->group[idx].tasks) {
+			bg->boost_max = boost;
+			trace_sched_tune_boostgroup_update(cpu, 1, bg->boost_max);
+			continue;
+		}
+
+		/* Check if this update has decreased current max */
+		if (cur_boost_max == old_boost && old_boost > boost) {
+			schedtune_cpu_update(cpu);
+			trace_sched_tune_boostgroup_update(cpu, -1, bg->boost_max);
+			continue;
+		}
+
+		trace_sched_tune_boostgroup_update(cpu, 0, bg->boost_max);
+	}
+
+	return 0;
+}
+
+#define ENQUEUE_TASK  1
+#define DEQUEUE_TASK -1
+
+static inline void
+schedtune_tasks_update(struct task_struct *p, int cpu, int idx, int task_count)
+{
+	struct boost_groups *bg = &per_cpu(cpu_boost_groups, cpu);
+	int tasks = bg->group[idx].tasks + task_count;
+
+	/* Update boosted tasks count while avoiding to make it negative */
+	bg->group[idx].tasks = max(0, tasks);
+
+	trace_sched_tune_tasks_update(p, cpu, tasks, idx,
+			bg->group[idx].boost, bg->boost_max);
+
+	/* Boost group activation or deactivation on that RQ */
+	if (tasks == 1 || tasks == 0)
+		schedtune_cpu_update(cpu);
+}
+
+/*
+ * NOTE: This function must be called while holding the lock on the CPU RQ
+ */
+void schedtune_enqueue_task(struct task_struct *p, int cpu)
+{
+	struct boost_groups *bg = &per_cpu(cpu_boost_groups, cpu);
+	unsigned long irq_flags;
+	struct schedtune *st;
+	int idx;
+
+	if (!unlikely(schedtune_initialized))
+		return;
+
+	/*
+	 * When a task is marked PF_EXITING by do_exit() it's going to be
+	 * dequeued and enqueued multiple times in the exit path.
+	 * Thus we avoid any further update, since we do not want to change
+	 * CPU boosting while the task is exiting.
+	 */
+	if (p->flags & PF_EXITING)
+		return;
+
+	/*
+	 * Boost group accouting is protected by a per-cpu lock and requires
+	 * interrupt to be disabled to avoid race conditions for example on
+	 * do_exit()::cgroup_exit() and task migration.
+	 */
+	raw_spin_lock_irqsave(&bg->lock, irq_flags);
+	rcu_read_lock();
+
+	st = task_schedtune(p);
+	idx = st->idx;
+
+	schedtune_tasks_update(p, cpu, idx, ENQUEUE_TASK);
+
+	rcu_read_unlock();
+	raw_spin_unlock_irqrestore(&bg->lock, irq_flags);
+}
+
+int schedtune_can_attach(struct cgroup_taskset *tset)
+{
+	struct task_struct *task;
+	struct cgroup_subsys_state *css;
+	struct boost_groups *bg;
+	struct rq_flags irq_flags;
+	unsigned int cpu;
+	struct rq *rq;
+	int src_bg; /* Source boost group index */
+	int dst_bg; /* Destination boost group index */
+	int tasks;
+
+	if (!unlikely(schedtune_initialized))
+		return 0;
+
+
+	cgroup_taskset_for_each(task, css, tset) {
+
+		/*
+		 * Lock the CPU's RQ the task is enqueued to avoid race
+		 * conditions with migration code while the task is being
+		 * accounted
+		 */
+		rq = lock_rq_of(task, &irq_flags);
+
+		if (!task->on_rq) {
+			unlock_rq_of(rq, task, &irq_flags);
+			continue;
+		}
+
+		/*
+		 * Boost group accouting is protected by a per-cpu lock and requires
+		 * interrupt to be disabled to avoid race conditions on...
+		 */
+		cpu = cpu_of(rq);
+		bg = &per_cpu(cpu_boost_groups, cpu);
+		raw_spin_lock(&bg->lock);
+
+		dst_bg = css_st(css)->idx;
+		src_bg = task_schedtune(task)->idx;
+
+		/*
+		 * Current task is not changing boostgroup, which can
+		 * happen when the new hierarchy is in use.
+		 */
+		if (unlikely(dst_bg == src_bg)) {
+			raw_spin_unlock(&bg->lock);
+			unlock_rq_of(rq, task, &irq_flags);
+			continue;
+		}
+
+		/*
+		 * This is the case of a RUNNABLE task which is switching its
+		 * current boost group.
+		 */
+
+		/* Move task from src to dst boost group */
+		tasks = bg->group[src_bg].tasks - 1;
+		bg->group[src_bg].tasks = max(0, tasks);
+		bg->group[dst_bg].tasks += 1;
+
+		raw_spin_unlock(&bg->lock);
+		unlock_rq_of(rq, task, &irq_flags);
+
+		/* Update CPU boost group */
+		if (bg->group[src_bg].tasks == 0 || bg->group[dst_bg].tasks == 1)
+			schedtune_cpu_update(task_cpu(task));
+
+	}
+
+	return 0;
+}
+
+void schedtune_cancel_attach(struct cgroup_taskset *tset)
+{
+	/* This can happen only if SchedTune controller is mounted with
+	 * other hierarchies ane one of them fails. Since usually SchedTune is
+	 * mouted on its own hierarcy, for the time being we do not implement
+	 * a proper rollback mechanism */
+	WARN(1, "SchedTune cancel attach not implemented");
+}
+
+/*
+ * NOTE: This function must be called while holding the lock on the CPU RQ
+ */
+void schedtune_dequeue_task(struct task_struct *p, int cpu)
+{
+	struct boost_groups *bg = &per_cpu(cpu_boost_groups, cpu);
+	unsigned long irq_flags;
+	struct schedtune *st;
+	int idx;
+
+	if (!unlikely(schedtune_initialized))
+		return;
+
+	/*
+	 * When a task is marked PF_EXITING by do_exit() it's going to be
+	 * dequeued and enqueued multiple times in the exit path.
+	 * Thus we avoid any further update, since we do not want to change
+	 * CPU boosting while the task is exiting.
+	 * The last dequeue is already enforce by the do_exit() code path
+	 * via schedtune_exit_task().
+	 */
+	if (p->flags & PF_EXITING)
+		return;
+
+	/*
+	 * Boost group accouting is protected by a per-cpu lock and requires
+	 * interrupt to be disabled to avoid race conditions on...
+	 */
+	raw_spin_lock_irqsave(&bg->lock, irq_flags);
+	rcu_read_lock();
+
+	st = task_schedtune(p);
+	idx = st->idx;
+
+	schedtune_tasks_update(p, cpu, idx, DEQUEUE_TASK);
+
+	rcu_read_unlock();
+	raw_spin_unlock_irqrestore(&bg->lock, irq_flags);
+}
+
+void schedtune_exit_task(struct task_struct *tsk)
+{
+	struct schedtune *st;
+	struct rq_flags irq_flags;
+	unsigned int cpu;
+	struct rq *rq;
+	int idx;
+
+	if (!unlikely(schedtune_initialized))
+		return;
+
+	rq = lock_rq_of(tsk, &irq_flags);
+	rcu_read_lock();
+
+	cpu = cpu_of(rq);
+	st = task_schedtune(tsk);
+	idx = st->idx;
+	schedtune_tasks_update(tsk, cpu, idx, DEQUEUE_TASK);
+
+	rcu_read_unlock();
+	unlock_rq_of(rq, tsk, &irq_flags);
+}
+
+int schedtune_cpu_boost(int cpu)
+{
+	struct boost_groups *bg;
+
+	bg = &per_cpu(cpu_boost_groups, cpu);
+	return bg->boost_max;
+}
+
+int schedtune_task_boost(struct task_struct *p)
+{
+	struct schedtune *st;
+	int task_boost;
+
+	if (!unlikely(schedtune_initialized))
+		return 0;
+
+	/* Get task boost value */
+	rcu_read_lock();
+	st = task_schedtune(p);
+	task_boost = st->boost;
+	rcu_read_unlock();
+
+	return task_boost;
+}
+
+int schedtune_prefer_idle(struct task_struct *p)
+{
+	struct schedtune *st;
+	int prefer_idle;
+
+	if (!unlikely(schedtune_initialized))
+		return 0;
+
+	/* Get prefer_idle value */
+	rcu_read_lock();
+	st = task_schedtune(p);
+	prefer_idle = st->prefer_idle;
+	rcu_read_unlock();
+
+	return prefer_idle;
+}
+
+static u64
+prefer_idle_read(struct cgroup_subsys_state *css, struct cftype *cft)
+{
+	struct schedtune *st = css_st(css);
+
+	return st->prefer_idle;
+}
+
+static int
+prefer_idle_write(struct cgroup_subsys_state *css, struct cftype *cft,
+	    u64 prefer_idle)
+{
+	struct schedtune *st = css_st(css);
+	st->prefer_idle = prefer_idle;
+
+	return 0;
+}
+
+static s64
+boost_read(struct cgroup_subsys_state *css, struct cftype *cft)
+{
+	struct schedtune *st = css_st(css);
+
+	return st->boost;
+}
+
+static int
+boost_write(struct cgroup_subsys_state *css, struct cftype *cft,
+	    s64 boost)
+{
+	struct schedtune *st = css_st(css);
+	unsigned threshold_idx;
+	int boost_pct;
+
+	if (boost < -100 || boost > 100)
+		return -EINVAL;
+	boost_pct = boost;
+
+	/*
+	 * Update threshold params for Performance Boost (B)
+	 * and Performance Constraint (C) regions.
+	 * The current implementatio uses the same cuts for both
+	 * B and C regions.
+	 */
+	threshold_idx = clamp(boost_pct, 0, 99) / 10;
+	st->perf_boost_idx = threshold_idx;
+	st->perf_constrain_idx = threshold_idx;
+
+	st->boost = boost;
+	if (css == &root_schedtune.css) {
+		sysctl_sched_cfs_boost = boost;
+		perf_boost_idx  = threshold_idx;
+		perf_constrain_idx  = threshold_idx;
+	}
+
+	/* Update CPU boost */
+	schedtune_boostgroup_update(st->idx, st->boost);
+
+	trace_sched_tune_config(st->boost);
+
+	return 0;
+}
+
+static struct cftype files[] = {
+	{
+		.name = "boost",
+		.read_s64 = boost_read,
+		.write_s64 = boost_write,
+	},
+	{
+		.name = "prefer_idle",
+		.read_u64 = prefer_idle_read,
+		.write_u64 = prefer_idle_write,
+	},
+	{ }	/* terminate */
+};
+
+static void
+schedtune_boostgroup_init(struct schedtune *st, int idx)
+{
+	struct boost_groups *bg;
+	int cpu;
+
+	/* Initialize per CPUs boost group support */
+	for_each_possible_cpu(cpu) {
+		bg = &per_cpu(cpu_boost_groups, cpu);
+		bg->group[idx].boost = 0;
+		bg->group[idx].valid = true;
+	}
+
+	/* Keep track of allocated boost groups */
+	allocated_group[idx] = st;
+	st->idx = idx;
+}
+
+static struct cgroup_subsys_state *
+schedtune_css_alloc(struct cgroup_subsys_state *parent_css)
+{
+	struct schedtune *st;
+	int idx;
+
+	if (!parent_css)
+		return &root_schedtune.css;
+
+	/* Allow only single level hierachies */
+	if (parent_css != &root_schedtune.css) {
+		pr_err("Nested SchedTune boosting groups not allowed\n");
+		return ERR_PTR(-ENOMEM);
+	}
+
+	/* Allow only a limited number of boosting groups */
+	for (idx = 1; idx < BOOSTGROUPS_COUNT; ++idx)
+		if (!allocated_group[idx])
+			break;
+	if (idx == BOOSTGROUPS_COUNT) {
+		pr_err("Trying to create more than %d SchedTune boosting groups\n",
+		       BOOSTGROUPS_COUNT);
+		return ERR_PTR(-ENOSPC);
+	}
+
+	st = kzalloc(sizeof(*st), GFP_KERNEL);
+	if (!st)
+		goto out;
+
+	/* Initialize per CPUs boost group support */
+	schedtune_boostgroup_init(st, idx);
+
+	return &st->css;
+
+out:
+	return ERR_PTR(-ENOMEM);
+}
+
+static void
+schedtune_boostgroup_release(struct schedtune *st)
+{
+	struct boost_groups *bg;
+	int cpu;
+
+	/* Reset per CPUs boost group support */
+	for_each_possible_cpu(cpu) {
+		bg = &per_cpu(cpu_boost_groups, cpu);
+		bg->group[st->idx].valid = false;
+		bg->group[st->idx].boost = 0;
+	}
+
+	/* Keep track of allocated boost groups */
+	allocated_group[st->idx] = NULL;
+}
+
+static void
+schedtune_css_free(struct cgroup_subsys_state *css)
+{
+	struct schedtune *st = css_st(css);
+
+	/* Release per CPUs boost group support */
+	schedtune_boostgroup_release(st);
+	kfree(st);
+}
+
+struct cgroup_subsys schedtune_cgrp_subsys = {
+	.css_alloc	= schedtune_css_alloc,
+	.css_free	= schedtune_css_free,
+	.can_attach     = schedtune_can_attach,
+	.cancel_attach  = schedtune_cancel_attach,
+	.legacy_cftypes	= files,
+	.early_init	= 1,
+};
+
+static inline void
+schedtune_init_cgroups(void)
+{
+	struct boost_groups *bg;
+	int cpu;
+
+	/* Initialize the per CPU boost groups */
+	for_each_possible_cpu(cpu) {
+		bg = &per_cpu(cpu_boost_groups, cpu);
+		memset(bg, 0, sizeof(struct boost_groups));
+		bg->group[0].valid = true;
+		raw_spin_lock_init(&bg->lock);
+	}
+
+	pr_info("schedtune: configured to support %d boost groups\n",
+		BOOSTGROUPS_COUNT);
+
+	schedtune_initialized = true;
+}
+
+#else /* CONFIG_CGROUP_SCHEDTUNE */
+
+int
+schedtune_accept_deltas(int nrg_delta, int cap_delta,
+			struct task_struct *task)
+{
+	/* Optimal (O) region */
+	if (nrg_delta < 0 && cap_delta > 0) {
+		trace_sched_tune_filter(nrg_delta, cap_delta, 0, 0, 1, 0);
+		return INT_MAX;
+	}
+
+	/* Suboptimal (S) region */
+	if (nrg_delta > 0 && cap_delta < 0) {
+		trace_sched_tune_filter(nrg_delta, cap_delta, 0, 0, -1, 5);
+		return -INT_MAX;
+	}
+
+	return __schedtune_accept_deltas(nrg_delta, cap_delta,
+			perf_boost_idx, perf_constrain_idx);
+}
+
+#endif /* CONFIG_CGROUP_SCHEDTUNE */
+
+int
+sysctl_sched_cfs_boost_handler(struct ctl_table *table, int write,
+			       void __user *buffer, size_t *lenp,
+			       loff_t *ppos)
+{
+	int ret = proc_dointvec_minmax(table, write, buffer, lenp, ppos);
+	unsigned threshold_idx;
+	int boost_pct;
+
+	if (ret || !write)
+		return ret;
+
+	if (sysctl_sched_cfs_boost < -100 || sysctl_sched_cfs_boost > 100)
+		return -EINVAL;
+	boost_pct = sysctl_sched_cfs_boost;
+
+	/*
+	 * Update threshold params for Performance Boost (B)
+	 * and Performance Constraint (C) regions.
+	 * The current implementatio uses the same cuts for both
+	 * B and C regions.
+	 */
+	threshold_idx = clamp(boost_pct, 0, 99) / 10;
+	perf_boost_idx = threshold_idx;
+	perf_constrain_idx = threshold_idx;
+
+	return 0;
+}
+
+#ifdef CONFIG_SCHED_DEBUG
+static void
+schedtune_test_nrg(unsigned long delta_pwr)
+{
+	unsigned long test_delta_pwr;
+	unsigned long test_norm_pwr;
+	int idx;
+
+	/*
+	 * Check normalization constants using some constant system
+	 * energy values
+	 */
+	pr_info("schedtune: verify normalization constants...\n");
+	for (idx = 0; idx < 6; ++idx) {
+		test_delta_pwr = delta_pwr >> idx;
+
+		/* Normalize on max energy for target platform */
+		test_norm_pwr = reciprocal_divide(
+					test_delta_pwr << SCHED_CAPACITY_SHIFT,
+					schedtune_target_nrg.rdiv);
+
+		pr_info("schedtune: max_pwr/2^%d: %4lu => norm_pwr: %5lu\n",
+			idx, test_delta_pwr, test_norm_pwr);
+	}
+}
+#else
+#define schedtune_test_nrg(delta_pwr)
+#endif
+
+/*
+ * Compute the min/max power consumption of a cluster and all its CPUs
+ */
+static void
+schedtune_add_cluster_nrg(
+		struct sched_domain *sd,
+		struct sched_group *sg,
+		struct target_nrg *ste)
+{
+	struct sched_domain *sd2;
+	struct sched_group *sg2;
+
+	struct cpumask *cluster_cpus;
+	char str[32];
+
+	unsigned long min_pwr;
+	unsigned long max_pwr;
+	int cpu;
+
+	/* Get Cluster energy using EM data for the first CPU */
+	cluster_cpus = sched_group_cpus(sg);
+	snprintf(str, 32, "CLUSTER[%*pbl]",
+		 cpumask_pr_args(cluster_cpus));
+
+	min_pwr = sg->sge->idle_states[sg->sge->nr_idle_states - 1].power;
+	max_pwr = sg->sge->cap_states[sg->sge->nr_cap_states - 1].power;
+	pr_info("schedtune: %-17s min_pwr: %5lu max_pwr: %5lu\n",
+		str, min_pwr, max_pwr);
+
+	/*
+	 * Keep track of this cluster's energy in the computation of the
+	 * overall system energy
+	 */
+	ste->min_power += min_pwr;
+	ste->max_power += max_pwr;
+
+	/* Get CPU energy using EM data for each CPU in the group */
+	for_each_cpu(cpu, cluster_cpus) {
+		/* Get a SD view for the specific CPU */
+		for_each_domain(cpu, sd2) {
+			/* Get the CPU group */
+			sg2 = sd2->groups;
+			min_pwr = sg2->sge->idle_states[sg2->sge->nr_idle_states - 1].power;
+			max_pwr = sg2->sge->cap_states[sg2->sge->nr_cap_states - 1].power;
+
+			ste->min_power += min_pwr;
+			ste->max_power += max_pwr;
+
+			snprintf(str, 32, "CPU[%d]", cpu);
+			pr_info("schedtune: %-17s min_pwr: %5lu max_pwr: %5lu\n",
+				str, min_pwr, max_pwr);
+
+			/*
+			 * Assume we have EM data only at the CPU and
+			 * the upper CLUSTER level
+			 */
+			BUG_ON(!cpumask_equal(
+				sched_group_cpus(sg),
+				sched_group_cpus(sd2->parent->groups)
+				));
+			break;
+		}
+	}
+}
+
+/*
+ * Initialize the constants required to compute normalized energy.
+ * The values of these constants depends on the EM data for the specific
+ * target system and topology.
+ * Thus, this function is expected to be called by the code
+ * that bind the EM to the topology information.
+ */
+static int
+schedtune_init(void)
+{
+	struct target_nrg *ste = &schedtune_target_nrg;
+	unsigned long delta_pwr = 0;
+	struct sched_domain *sd;
+	struct sched_group *sg;
+
+	pr_info("schedtune: init normalization constants...\n");
+	ste->max_power = 0;
+	ste->min_power = 0;
+
+	rcu_read_lock();
+
+	/*
+	 * When EAS is in use, we always have a pointer to the highest SD
+	 * which provides EM data.
+	 */
+	sd = rcu_dereference(per_cpu(sd_ea, cpumask_first(cpu_online_mask)));
+	if (!sd) {
+		pr_info("schedtune: no energy model data\n");
+		goto nodata;
+	}
+
+	sg = sd->groups;
+	do {
+		schedtune_add_cluster_nrg(sd, sg, ste);
+	} while (sg = sg->next, sg != sd->groups);
+
+	rcu_read_unlock();
+
+	pr_info("schedtune: %-17s min_pwr: %5lu max_pwr: %5lu\n",
+		"SYSTEM", ste->min_power, ste->max_power);
+
+	/* Compute normalization constants */
+	delta_pwr = ste->max_power - ste->min_power;
+	ste->rdiv = reciprocal_value(delta_pwr);
+	pr_info("schedtune: using normalization constants mul: %u sh1: %u sh2: %u\n",
+		ste->rdiv.m, ste->rdiv.sh1, ste->rdiv.sh2);
+
+	schedtune_test_nrg(delta_pwr);
+
+#ifdef CONFIG_CGROUP_SCHEDTUNE
+	schedtune_init_cgroups();
+#else
+	pr_info("schedtune: configured to support global boosting only\n");
+#endif
+
+	schedtune_spc_rdiv = reciprocal_value(100);
+
+	return 0;
+
+nodata:
+	pr_warning("schedtune: disabled!\n");
+	rcu_read_unlock();
+	return -EINVAL;
+}
+postcore_initcall(schedtune_init);
diff --git a/kernel/sched/tune.h b/kernel/sched/tune.h
new file mode 100644
index 00000000..4f64417
--- /dev/null
+++ b/kernel/sched/tune.h
@@ -0,0 +1,55 @@
+
+#ifdef CONFIG_SCHED_TUNE
+
+#include <linux/reciprocal_div.h>
+
+/*
+ * System energy normalization constants
+ */
+struct target_nrg {
+	unsigned long min_power;
+	unsigned long max_power;
+	struct reciprocal_value rdiv;
+};
+
+#ifdef CONFIG_CGROUP_SCHEDTUNE
+
+int schedtune_cpu_boost(int cpu);
+int schedtune_task_boost(struct task_struct *tsk);
+
+int schedtune_prefer_idle(struct task_struct *tsk);
+
+void schedtune_exit_task(struct task_struct *tsk);
+
+void schedtune_enqueue_task(struct task_struct *p, int cpu);
+void schedtune_dequeue_task(struct task_struct *p, int cpu);
+
+#else /* CONFIG_CGROUP_SCHEDTUNE */
+
+#define schedtune_cpu_boost(cpu)  get_sysctl_sched_cfs_boost()
+#define schedtune_task_boost(tsk) get_sysctl_sched_cfs_boost()
+
+#define schedtune_exit_task(task) do { } while (0)
+
+#define schedtune_enqueue_task(task, cpu) do { } while (0)
+#define schedtune_dequeue_task(task, cpu) do { } while (0)
+
+#endif /* CONFIG_CGROUP_SCHEDTUNE */
+
+int schedtune_normalize_energy(int energy);
+int schedtune_accept_deltas(int nrg_delta, int cap_delta,
+			    struct task_struct *task);
+
+#else /* CONFIG_SCHED_TUNE */
+
+#define schedtune_cpu_boost(cpu)  0
+#define schedtune_task_boost(tsk) 0
+
+#define schedtune_exit_task(task) do { } while (0)
+
+#define schedtune_enqueue_task(task, cpu) do { } while (0)
+#define schedtune_dequeue_task(task, cpu) do { } while (0)
+
+#define schedtune_accept_deltas(nrg_delta, cap_delta, task) nrg_delta
+
+#endif /* CONFIG_SCHED_TUNE */
diff --git a/kernel/sched/walt.c b/kernel/sched/walt.c
new file mode 100644
index 00000000..0162dde
--- /dev/null
+++ b/kernel/sched/walt.c
@@ -0,0 +1,903 @@
+/*
+ * Copyright (c) 2016, The Linux Foundation. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ *
+ * Window Assisted Load Tracking (WALT) implementation credits:
+ * Srivatsa Vaddagiri, Steve Muckle, Syed Rameez Mustafa, Joonwoo Park,
+ * Pavan Kumar Kondeti, Olav Haugan
+ *
+ * 2016-03-06: Integration with EAS/refactoring by Vikram Mulukutla
+ *             and Todd Kjos
+ */
+
+#include <linux/acpi.h>
+#include <linux/syscore_ops.h>
+#include <trace/events/sched.h>
+#include "sched.h"
+#include "walt.h"
+
+#define WINDOW_STATS_RECENT		0
+#define WINDOW_STATS_MAX		1
+#define WINDOW_STATS_MAX_RECENT_AVG	2
+#define WINDOW_STATS_AVG		3
+#define WINDOW_STATS_INVALID_POLICY	4
+
+#define EXITING_TASK_MARKER	0xdeaddead
+
+static __read_mostly unsigned int walt_ravg_hist_size = 5;
+static __read_mostly unsigned int walt_window_stats_policy =
+	WINDOW_STATS_MAX_RECENT_AVG;
+static __read_mostly unsigned int walt_account_wait_time = 1;
+static __read_mostly unsigned int walt_freq_account_wait_time = 0;
+static __read_mostly unsigned int walt_io_is_busy = 0;
+
+unsigned int sysctl_sched_walt_init_task_load_pct = 15;
+
+/* true -> use PELT based load stats, false -> use window-based load stats */
+bool __read_mostly walt_disabled = false;
+
+/*
+ * Window size (in ns). Adjust for the tick size so that the window
+ * rollover occurs just before the tick boundary.
+ */
+__read_mostly unsigned int walt_ravg_window =
+					    (20000000 / TICK_NSEC) * TICK_NSEC;
+#define MIN_SCHED_RAVG_WINDOW ((10000000 / TICK_NSEC) * TICK_NSEC)
+#define MAX_SCHED_RAVG_WINDOW ((1000000000 / TICK_NSEC) * TICK_NSEC)
+
+static unsigned int sync_cpu;
+static ktime_t ktime_last;
+static __read_mostly bool walt_ktime_suspended;
+
+static unsigned int task_load(struct task_struct *p)
+{
+	return p->ravg.demand;
+}
+
+static inline void fixup_cum_window_demand(struct rq *rq, s64 delta)
+{
+	rq->cum_window_demand += delta;
+	if (unlikely((s64)rq->cum_window_demand < 0))
+		rq->cum_window_demand = 0;
+}
+
+void
+walt_inc_cumulative_runnable_avg(struct rq *rq,
+				 struct task_struct *p)
+{
+	rq->cumulative_runnable_avg += p->ravg.demand;
+
+	/*
+	 * Add a task's contribution to the cumulative window demand when
+	 *
+	 * (1) task is enqueued with on_rq = 1 i.e migration,
+	 *     prio/cgroup/class change.
+	 * (2) task is waking for the first time in this window.
+	 */
+	if (p->on_rq || (p->last_sleep_ts < rq->window_start))
+		fixup_cum_window_demand(rq, p->ravg.demand);
+}
+
+void
+walt_dec_cumulative_runnable_avg(struct rq *rq,
+				 struct task_struct *p)
+{
+	rq->cumulative_runnable_avg -= p->ravg.demand;
+	BUG_ON((s64)rq->cumulative_runnable_avg < 0);
+
+	/*
+	 * on_rq will be 1 for sleeping tasks. So check if the task
+	 * is migrating or dequeuing in RUNNING state to change the
+	 * prio/cgroup/class.
+	 */
+	if (task_on_rq_migrating(p) || p->state == TASK_RUNNING)
+		fixup_cum_window_demand(rq, -(s64)p->ravg.demand);
+}
+
+static void
+fixup_cumulative_runnable_avg(struct rq *rq,
+			      struct task_struct *p, u64 new_task_load)
+{
+	s64 task_load_delta = (s64)new_task_load - task_load(p);
+
+	rq->cumulative_runnable_avg += task_load_delta;
+	if ((s64)rq->cumulative_runnable_avg < 0)
+		panic("cra less than zero: tld: %lld, task_load(p) = %u\n",
+			task_load_delta, task_load(p));
+
+	fixup_cum_window_demand(rq, task_load_delta);
+}
+
+u64 walt_ktime_clock(void)
+{
+	if (unlikely(walt_ktime_suspended))
+		return ktime_to_ns(ktime_last);
+	return ktime_get_ns();
+}
+
+static void walt_resume(void)
+{
+	walt_ktime_suspended = false;
+}
+
+static int walt_suspend(void)
+{
+	ktime_last = ktime_get();
+	walt_ktime_suspended = true;
+	return 0;
+}
+
+static struct syscore_ops walt_syscore_ops = {
+	.resume	= walt_resume,
+	.suspend = walt_suspend
+};
+
+static int __init walt_init_ops(void)
+{
+	register_syscore_ops(&walt_syscore_ops);
+	return 0;
+}
+late_initcall(walt_init_ops);
+
+#ifdef CONFIG_CFS_BANDWIDTH
+void walt_inc_cfs_cumulative_runnable_avg(struct cfs_rq *cfs_rq,
+		struct task_struct *p)
+{
+	cfs_rq->cumulative_runnable_avg += p->ravg.demand;
+}
+
+void walt_dec_cfs_cumulative_runnable_avg(struct cfs_rq *cfs_rq,
+		struct task_struct *p)
+{
+	cfs_rq->cumulative_runnable_avg -= p->ravg.demand;
+}
+#endif
+
+static int exiting_task(struct task_struct *p)
+{
+	if (p->flags & PF_EXITING) {
+		if (p->ravg.sum_history[0] != EXITING_TASK_MARKER) {
+			p->ravg.sum_history[0] = EXITING_TASK_MARKER;
+		}
+		return 1;
+	}
+	return 0;
+}
+
+static int __init set_walt_ravg_window(char *str)
+{
+	unsigned int adj_window;
+	bool no_walt = walt_disabled;
+
+	get_option(&str, &walt_ravg_window);
+
+	/* Adjust for CONFIG_HZ */
+	adj_window = (walt_ravg_window / TICK_NSEC) * TICK_NSEC;
+
+	/* Warn if we're a bit too far away from the expected window size */
+	WARN(adj_window < walt_ravg_window - NSEC_PER_MSEC,
+	     "tick-adjusted window size %u, original was %u\n", adj_window,
+	     walt_ravg_window);
+
+	walt_ravg_window = adj_window;
+
+	walt_disabled = walt_disabled ||
+			(walt_ravg_window < MIN_SCHED_RAVG_WINDOW ||
+			 walt_ravg_window > MAX_SCHED_RAVG_WINDOW);
+
+	WARN(!no_walt && walt_disabled,
+	     "invalid window size, disabling WALT\n");
+
+	return 0;
+}
+
+early_param("walt_ravg_window", set_walt_ravg_window);
+
+static void
+update_window_start(struct rq *rq, u64 wallclock)
+{
+	s64 delta;
+	int nr_windows;
+
+	delta = wallclock - rq->window_start;
+	/* If the MPM global timer is cleared, set delta as 0 to avoid kernel BUG happening */
+	if (delta < 0) {
+		delta = 0;
+		WARN_ONCE(1, "WALT wallclock appears to have gone backwards or reset\n");
+	}
+
+	if (delta < walt_ravg_window)
+		return;
+
+	nr_windows = div64_u64(delta, walt_ravg_window);
+	rq->window_start += (u64)nr_windows * (u64)walt_ravg_window;
+
+	rq->cum_window_demand = rq->cumulative_runnable_avg;
+}
+
+/*
+ * Translate absolute delta time accounted on a CPU
+ * to a scale where 1024 is the capacity of the most
+ * capable CPU running at FMAX
+ */
+static u64 scale_exec_time(u64 delta, struct rq *rq)
+{
+	unsigned long capcurr = capacity_curr_of(cpu_of(rq));
+
+	return (delta * capcurr) >> SCHED_CAPACITY_SHIFT;
+}
+
+static int cpu_is_waiting_on_io(struct rq *rq)
+{
+	if (!walt_io_is_busy)
+		return 0;
+
+	return atomic_read(&rq->nr_iowait);
+}
+
+void walt_account_irqtime(int cpu, struct task_struct *curr,
+				 u64 delta, u64 wallclock)
+{
+	struct rq *rq = cpu_rq(cpu);
+	unsigned long flags, nr_windows;
+	u64 cur_jiffies_ts;
+
+	raw_spin_lock_irqsave(&rq->lock, flags);
+
+	/*
+	 * cputime (wallclock) uses sched_clock so use the same here for
+	 * consistency.
+	 */
+	delta += sched_clock() - wallclock;
+	cur_jiffies_ts = get_jiffies_64();
+
+	if (is_idle_task(curr))
+		walt_update_task_ravg(curr, rq, IRQ_UPDATE, walt_ktime_clock(),
+				 delta);
+
+	nr_windows = cur_jiffies_ts - rq->irqload_ts;
+
+	if (nr_windows) {
+		if (nr_windows < 10) {
+			/* Decay CPU's irqload by 3/4 for each window. */
+			rq->avg_irqload *= (3 * nr_windows);
+			rq->avg_irqload = div64_u64(rq->avg_irqload,
+						    4 * nr_windows);
+		} else {
+			rq->avg_irqload = 0;
+		}
+		rq->avg_irqload += rq->cur_irqload;
+		rq->cur_irqload = 0;
+	}
+
+	rq->cur_irqload += delta;
+	rq->irqload_ts = cur_jiffies_ts;
+	raw_spin_unlock_irqrestore(&rq->lock, flags);
+}
+
+
+#define WALT_HIGH_IRQ_TIMEOUT 3
+
+u64 walt_irqload(int cpu) {
+	struct rq *rq = cpu_rq(cpu);
+	s64 delta;
+	delta = get_jiffies_64() - rq->irqload_ts;
+
+        /*
+	 * Current context can be preempted by irq and rq->irqload_ts can be
+	 * updated by irq context so that delta can be negative.
+	 * But this is okay and we can safely return as this means there
+	 * was recent irq occurrence.
+	 */
+
+        if (delta < WALT_HIGH_IRQ_TIMEOUT)
+		return rq->avg_irqload;
+        else
+		return 0;
+}
+
+int walt_cpu_high_irqload(int cpu) {
+	return walt_irqload(cpu) >= sysctl_sched_walt_cpu_high_irqload;
+}
+
+static int account_busy_for_cpu_time(struct rq *rq, struct task_struct *p,
+				     u64 irqtime, int event)
+{
+	if (is_idle_task(p)) {
+		/* TASK_WAKE && TASK_MIGRATE is not possible on idle task! */
+		if (event == PICK_NEXT_TASK)
+			return 0;
+
+		/* PUT_PREV_TASK, TASK_UPDATE && IRQ_UPDATE are left */
+		return irqtime || cpu_is_waiting_on_io(rq);
+	}
+
+	if (event == TASK_WAKE)
+		return 0;
+
+	if (event == PUT_PREV_TASK || event == IRQ_UPDATE ||
+					 event == TASK_UPDATE)
+		return 1;
+
+	/* Only TASK_MIGRATE && PICK_NEXT_TASK left */
+	return walt_freq_account_wait_time;
+}
+
+/*
+ * Account cpu activity in its busy time counters (rq->curr/prev_runnable_sum)
+ */
+static void update_cpu_busy_time(struct task_struct *p, struct rq *rq,
+	     int event, u64 wallclock, u64 irqtime)
+{
+	int new_window, nr_full_windows = 0;
+	int p_is_curr_task = (p == rq->curr);
+	u64 mark_start = p->ravg.mark_start;
+	u64 window_start = rq->window_start;
+	u32 window_size = walt_ravg_window;
+	u64 delta;
+
+	new_window = mark_start < window_start;
+	if (new_window) {
+		nr_full_windows = div64_u64((window_start - mark_start),
+						window_size);
+		if (p->ravg.active_windows < USHRT_MAX)
+			p->ravg.active_windows++;
+	}
+
+	/* Handle per-task window rollover. We don't care about the idle
+	 * task or exiting tasks. */
+	if (new_window && !is_idle_task(p) && !exiting_task(p)) {
+		u32 curr_window = 0;
+
+		if (!nr_full_windows)
+			curr_window = p->ravg.curr_window;
+
+		p->ravg.prev_window = curr_window;
+		p->ravg.curr_window = 0;
+	}
+
+	if (!account_busy_for_cpu_time(rq, p, irqtime, event)) {
+		/* account_busy_for_cpu_time() = 0, so no update to the
+		 * task's current window needs to be made. This could be
+		 * for example
+		 *
+		 *   - a wakeup event on a task within the current
+		 *     window (!new_window below, no action required),
+		 *   - switching to a new task from idle (PICK_NEXT_TASK)
+		 *     in a new window where irqtime is 0 and we aren't
+		 *     waiting on IO */
+
+		if (!new_window)
+			return;
+
+		/* A new window has started. The RQ demand must be rolled
+		 * over if p is the current task. */
+		if (p_is_curr_task) {
+			u64 prev_sum = 0;
+
+			/* p is either idle task or an exiting task */
+			if (!nr_full_windows) {
+				prev_sum = rq->curr_runnable_sum;
+			}
+
+			rq->prev_runnable_sum = prev_sum;
+			rq->curr_runnable_sum = 0;
+		}
+
+		return;
+	}
+
+	if (!new_window) {
+		/* account_busy_for_cpu_time() = 1 so busy time needs
+		 * to be accounted to the current window. No rollover
+		 * since we didn't start a new window. An example of this is
+		 * when a task starts execution and then sleeps within the
+		 * same window. */
+
+		if (!irqtime || !is_idle_task(p) || cpu_is_waiting_on_io(rq))
+			delta = wallclock - mark_start;
+		else
+			delta = irqtime;
+		delta = scale_exec_time(delta, rq);
+		rq->curr_runnable_sum += delta;
+		if (!is_idle_task(p) && !exiting_task(p))
+			p->ravg.curr_window += delta;
+
+		return;
+	}
+
+	if (!p_is_curr_task) {
+		/* account_busy_for_cpu_time() = 1 so busy time needs
+		 * to be accounted to the current window. A new window
+		 * has also started, but p is not the current task, so the
+		 * window is not rolled over - just split up and account
+		 * as necessary into curr and prev. The window is only
+		 * rolled over when a new window is processed for the current
+		 * task.
+		 *
+		 * Irqtime can't be accounted by a task that isn't the
+		 * currently running task. */
+
+		if (!nr_full_windows) {
+			/* A full window hasn't elapsed, account partial
+			 * contribution to previous completed window. */
+			delta = scale_exec_time(window_start - mark_start, rq);
+			if (!exiting_task(p))
+				p->ravg.prev_window += delta;
+		} else {
+			/* Since at least one full window has elapsed,
+			 * the contribution to the previous window is the
+			 * full window (window_size). */
+			delta = scale_exec_time(window_size, rq);
+			if (!exiting_task(p))
+				p->ravg.prev_window = delta;
+		}
+		rq->prev_runnable_sum += delta;
+
+		/* Account piece of busy time in the current window. */
+		delta = scale_exec_time(wallclock - window_start, rq);
+		rq->curr_runnable_sum += delta;
+		if (!exiting_task(p))
+			p->ravg.curr_window = delta;
+
+		return;
+	}
+
+	if (!irqtime || !is_idle_task(p) || cpu_is_waiting_on_io(rq)) {
+		/* account_busy_for_cpu_time() = 1 so busy time needs
+		 * to be accounted to the current window. A new window
+		 * has started and p is the current task so rollover is
+		 * needed. If any of these three above conditions are true
+		 * then this busy time can't be accounted as irqtime.
+		 *
+		 * Busy time for the idle task or exiting tasks need not
+		 * be accounted.
+		 *
+		 * An example of this would be a task that starts execution
+		 * and then sleeps once a new window has begun. */
+
+		if (!nr_full_windows) {
+			/* A full window hasn't elapsed, account partial
+			 * contribution to previous completed window. */
+			delta = scale_exec_time(window_start - mark_start, rq);
+			if (!is_idle_task(p) && !exiting_task(p))
+				p->ravg.prev_window += delta;
+
+			delta += rq->curr_runnable_sum;
+		} else {
+			/* Since at least one full window has elapsed,
+			 * the contribution to the previous window is the
+			 * full window (window_size). */
+			delta = scale_exec_time(window_size, rq);
+			if (!is_idle_task(p) && !exiting_task(p))
+				p->ravg.prev_window = delta;
+
+		}
+		/*
+		 * Rollover for normal runnable sum is done here by overwriting
+		 * the values in prev_runnable_sum and curr_runnable_sum.
+		 * Rollover for new task runnable sum has completed by previous
+		 * if-else statement.
+		 */
+		rq->prev_runnable_sum = delta;
+
+		/* Account piece of busy time in the current window. */
+		delta = scale_exec_time(wallclock - window_start, rq);
+		rq->curr_runnable_sum = delta;
+		if (!is_idle_task(p) && !exiting_task(p))
+			p->ravg.curr_window = delta;
+
+		return;
+	}
+
+	if (irqtime) {
+		/* account_busy_for_cpu_time() = 1 so busy time needs
+		 * to be accounted to the current window. A new window
+		 * has started and p is the current task so rollover is
+		 * needed. The current task must be the idle task because
+		 * irqtime is not accounted for any other task.
+		 *
+		 * Irqtime will be accounted each time we process IRQ activity
+		 * after a period of idleness, so we know the IRQ busy time
+		 * started at wallclock - irqtime. */
+
+		BUG_ON(!is_idle_task(p));
+		mark_start = wallclock - irqtime;
+
+		/* Roll window over. If IRQ busy time was just in the current
+		 * window then that is all that need be accounted. */
+		rq->prev_runnable_sum = rq->curr_runnable_sum;
+		if (mark_start > window_start) {
+			rq->curr_runnable_sum = scale_exec_time(irqtime, rq);
+			return;
+		}
+
+		/* The IRQ busy time spanned multiple windows. Process the
+		 * busy time preceding the current window start first. */
+		delta = window_start - mark_start;
+		if (delta > window_size)
+			delta = window_size;
+		delta = scale_exec_time(delta, rq);
+		rq->prev_runnable_sum += delta;
+
+		/* Process the remaining IRQ busy time in the current window. */
+		delta = wallclock - window_start;
+		rq->curr_runnable_sum = scale_exec_time(delta, rq);
+
+		return;
+	}
+
+	BUG();
+}
+
+static int account_busy_for_task_demand(struct task_struct *p, int event)
+{
+	/* No need to bother updating task demand for exiting tasks
+	 * or the idle task. */
+	if (exiting_task(p) || is_idle_task(p))
+		return 0;
+
+	/* When a task is waking up it is completing a segment of non-busy
+	 * time. Likewise, if wait time is not treated as busy time, then
+	 * when a task begins to run or is migrated, it is not running and
+	 * is completing a segment of non-busy time. */
+	if (event == TASK_WAKE || (!walt_account_wait_time &&
+			 (event == PICK_NEXT_TASK || event == TASK_MIGRATE)))
+		return 0;
+
+	return 1;
+}
+
+/*
+ * Called when new window is starting for a task, to record cpu usage over
+ * recently concluded window(s). Normally 'samples' should be 1. It can be > 1
+ * when, say, a real-time task runs without preemption for several windows at a
+ * stretch.
+ */
+static void update_history(struct rq *rq, struct task_struct *p,
+			 u32 runtime, int samples, int event)
+{
+	u32 *hist = &p->ravg.sum_history[0];
+	int ridx, widx;
+	u32 max = 0, avg, demand;
+	u64 sum = 0;
+
+	/* Ignore windows where task had no activity */
+	if (!runtime || is_idle_task(p) || exiting_task(p) || !samples)
+			goto done;
+
+	/* Push new 'runtime' value onto stack */
+	widx = walt_ravg_hist_size - 1;
+	ridx = widx - samples;
+	for (; ridx >= 0; --widx, --ridx) {
+		hist[widx] = hist[ridx];
+		sum += hist[widx];
+		if (hist[widx] > max)
+			max = hist[widx];
+	}
+
+	for (widx = 0; widx < samples && widx < walt_ravg_hist_size; widx++) {
+		hist[widx] = runtime;
+		sum += hist[widx];
+		if (hist[widx] > max)
+			max = hist[widx];
+	}
+
+	p->ravg.sum = 0;
+
+	if (walt_window_stats_policy == WINDOW_STATS_RECENT) {
+		demand = runtime;
+	} else if (walt_window_stats_policy == WINDOW_STATS_MAX) {
+		demand = max;
+	} else {
+		avg = div64_u64(sum, walt_ravg_hist_size);
+		if (walt_window_stats_policy == WINDOW_STATS_AVG)
+			demand = avg;
+		else
+			demand = max(avg, runtime);
+	}
+
+	/*
+	 * A throttled deadline sched class task gets dequeued without
+	 * changing p->on_rq. Since the dequeue decrements hmp stats
+	 * avoid decrementing it here again.
+	 *
+	 * When window is rolled over, the cumulative window demand
+	 * is reset to the cumulative runnable average (contribution from
+	 * the tasks on the runqueue). If the current task is dequeued
+	 * already, it's demand is not included in the cumulative runnable
+	 * average. So add the task demand separately to cumulative window
+	 * demand.
+	 */
+	if (!task_has_dl_policy(p) || !p->dl.dl_throttled) {
+		if (task_on_rq_queued(p))
+			fixup_cumulative_runnable_avg(rq, p, demand);
+		else if (rq->curr == p)
+			fixup_cum_window_demand(rq, demand);
+	}
+
+	p->ravg.demand = demand;
+
+done:
+	trace_walt_update_history(rq, p, runtime, samples, event);
+	return;
+}
+
+static void add_to_task_demand(struct rq *rq, struct task_struct *p,
+				u64 delta)
+{
+	delta = scale_exec_time(delta, rq);
+	p->ravg.sum += delta;
+	if (unlikely(p->ravg.sum > walt_ravg_window))
+		p->ravg.sum = walt_ravg_window;
+}
+
+/*
+ * Account cpu demand of task and/or update task's cpu demand history
+ *
+ * ms = p->ravg.mark_start;
+ * wc = wallclock
+ * ws = rq->window_start
+ *
+ * Three possibilities:
+ *
+ *	a) Task event is contained within one window.
+ *		window_start < mark_start < wallclock
+ *
+ *		ws   ms  wc
+ *		|    |   |
+ *		V    V   V
+ *		|---------------|
+ *
+ *	In this case, p->ravg.sum is updated *iff* event is appropriate
+ *	(ex: event == PUT_PREV_TASK)
+ *
+ *	b) Task event spans two windows.
+ *		mark_start < window_start < wallclock
+ *
+ *		ms   ws   wc
+ *		|    |    |
+ *		V    V    V
+ *		-----|-------------------
+ *
+ *	In this case, p->ravg.sum is updated with (ws - ms) *iff* event
+ *	is appropriate, then a new window sample is recorded followed
+ *	by p->ravg.sum being set to (wc - ws) *iff* event is appropriate.
+ *
+ *	c) Task event spans more than two windows.
+ *
+ *		ms ws_tmp			   ws  wc
+ *		|  |				   |   |
+ *		V  V				   V   V
+ *		---|-------|-------|-------|-------|------
+ *		   |				   |
+ *		   |<------ nr_full_windows ------>|
+ *
+ *	In this case, p->ravg.sum is updated with (ws_tmp - ms) first *iff*
+ *	event is appropriate, window sample of p->ravg.sum is recorded,
+ *	'nr_full_window' samples of window_size is also recorded *iff*
+ *	event is appropriate and finally p->ravg.sum is set to (wc - ws)
+ *	*iff* event is appropriate.
+ *
+ * IMPORTANT : Leave p->ravg.mark_start unchanged, as update_cpu_busy_time()
+ * depends on it!
+ */
+static void update_task_demand(struct task_struct *p, struct rq *rq,
+	     int event, u64 wallclock)
+{
+	u64 mark_start = p->ravg.mark_start;
+	u64 delta, window_start = rq->window_start;
+	int new_window, nr_full_windows;
+	u32 window_size = walt_ravg_window;
+
+	new_window = mark_start < window_start;
+	if (!account_busy_for_task_demand(p, event)) {
+		if (new_window)
+			/* If the time accounted isn't being accounted as
+			 * busy time, and a new window started, only the
+			 * previous window need be closed out with the
+			 * pre-existing demand. Multiple windows may have
+			 * elapsed, but since empty windows are dropped,
+			 * it is not necessary to account those. */
+			update_history(rq, p, p->ravg.sum, 1, event);
+		return;
+	}
+
+	if (!new_window) {
+		/* The simple case - busy time contained within the existing
+		 * window. */
+		add_to_task_demand(rq, p, wallclock - mark_start);
+		return;
+	}
+
+	/* Busy time spans at least two windows. Temporarily rewind
+	 * window_start to first window boundary after mark_start. */
+	delta = window_start - mark_start;
+	nr_full_windows = div64_u64(delta, window_size);
+	window_start -= (u64)nr_full_windows * (u64)window_size;
+
+	/* Process (window_start - mark_start) first */
+	add_to_task_demand(rq, p, window_start - mark_start);
+
+	/* Push new sample(s) into task's demand history */
+	update_history(rq, p, p->ravg.sum, 1, event);
+	if (nr_full_windows)
+		update_history(rq, p, scale_exec_time(window_size, rq),
+			       nr_full_windows, event);
+
+	/* Roll window_start back to current to process any remainder
+	 * in current window. */
+	window_start += (u64)nr_full_windows * (u64)window_size;
+
+	/* Process (wallclock - window_start) next */
+	mark_start = window_start;
+	add_to_task_demand(rq, p, wallclock - mark_start);
+}
+
+/* Reflect task activity on its demand and cpu's busy time statistics */
+void walt_update_task_ravg(struct task_struct *p, struct rq *rq,
+	     int event, u64 wallclock, u64 irqtime)
+{
+	if (walt_disabled || !rq->window_start)
+		return;
+
+	lockdep_assert_held(&rq->lock);
+
+	update_window_start(rq, wallclock);
+
+	if (!p->ravg.mark_start)
+		goto done;
+
+	update_task_demand(p, rq, event, wallclock);
+	update_cpu_busy_time(p, rq, event, wallclock, irqtime);
+
+done:
+	trace_walt_update_task_ravg(p, rq, event, wallclock, irqtime);
+
+	p->ravg.mark_start = wallclock;
+}
+
+static void reset_task_stats(struct task_struct *p)
+{
+	u32 sum = 0;
+
+	if (exiting_task(p))
+		sum = EXITING_TASK_MARKER;
+
+	memset(&p->ravg, 0, sizeof(struct ravg));
+	/* Retain EXITING_TASK marker */
+	p->ravg.sum_history[0] = sum;
+}
+
+void walt_mark_task_starting(struct task_struct *p)
+{
+	u64 wallclock;
+	struct rq *rq = task_rq(p);
+
+	if (!rq->window_start) {
+		reset_task_stats(p);
+		return;
+	}
+
+	wallclock = walt_ktime_clock();
+	p->ravg.mark_start = wallclock;
+}
+
+void walt_set_window_start(struct rq *rq)
+{
+	int cpu = cpu_of(rq);
+	struct rq *sync_rq = cpu_rq(sync_cpu);
+
+	if (likely(rq->window_start))
+		return;
+
+	if (cpu == sync_cpu) {
+		rq->window_start = 1;
+	} else {
+		raw_spin_unlock(&rq->lock);
+		double_rq_lock(rq, sync_rq);
+		rq->window_start = cpu_rq(sync_cpu)->window_start;
+		rq->curr_runnable_sum = rq->prev_runnable_sum = 0;
+		raw_spin_unlock(&sync_rq->lock);
+	}
+
+	rq->curr->ravg.mark_start = rq->window_start;
+}
+
+void walt_migrate_sync_cpu(int cpu)
+{
+	if (cpu == sync_cpu)
+		sync_cpu = smp_processor_id();
+}
+
+void walt_fixup_busy_time(struct task_struct *p, int new_cpu)
+{
+	struct rq *src_rq = task_rq(p);
+	struct rq *dest_rq = cpu_rq(new_cpu);
+	u64 wallclock;
+
+	if (!p->on_rq && p->state != TASK_WAKING)
+		return;
+
+	if (exiting_task(p)) {
+		return;
+	}
+
+	if (p->state == TASK_WAKING)
+		double_rq_lock(src_rq, dest_rq);
+
+	wallclock = walt_ktime_clock();
+
+	walt_update_task_ravg(task_rq(p)->curr, task_rq(p),
+			TASK_UPDATE, wallclock, 0);
+	walt_update_task_ravg(dest_rq->curr, dest_rq,
+			TASK_UPDATE, wallclock, 0);
+
+	walt_update_task_ravg(p, task_rq(p), TASK_MIGRATE, wallclock, 0);
+
+	/*
+	 * When a task is migrating during the wakeup, adjust
+	 * the task's contribution towards cumulative window
+	 * demand.
+	 */
+	if (p->state == TASK_WAKING &&
+	    p->last_sleep_ts >= src_rq->window_start) {
+		fixup_cum_window_demand(src_rq, -(s64)p->ravg.demand);
+		fixup_cum_window_demand(dest_rq, p->ravg.demand);
+	}
+
+	if (p->ravg.curr_window) {
+		src_rq->curr_runnable_sum -= p->ravg.curr_window;
+		dest_rq->curr_runnable_sum += p->ravg.curr_window;
+	}
+
+	if (p->ravg.prev_window) {
+		src_rq->prev_runnable_sum -= p->ravg.prev_window;
+		dest_rq->prev_runnable_sum += p->ravg.prev_window;
+	}
+
+	if ((s64)src_rq->prev_runnable_sum < 0) {
+		src_rq->prev_runnable_sum = 0;
+		WARN_ON(1);
+	}
+	if ((s64)src_rq->curr_runnable_sum < 0) {
+		src_rq->curr_runnable_sum = 0;
+		WARN_ON(1);
+	}
+
+	trace_walt_migration_update_sum(src_rq, p);
+	trace_walt_migration_update_sum(dest_rq, p);
+
+	if (p->state == TASK_WAKING)
+		double_rq_unlock(src_rq, dest_rq);
+}
+
+void walt_init_new_task_load(struct task_struct *p)
+{
+	int i;
+	u32 init_load_windows =
+			div64_u64((u64)sysctl_sched_walt_init_task_load_pct *
+                          (u64)walt_ravg_window, 100);
+	u32 init_load_pct = current->init_load_pct;
+
+	p->init_load_pct = 0;
+	memset(&p->ravg, 0, sizeof(struct ravg));
+
+	if (init_load_pct) {
+		init_load_windows = div64_u64((u64)init_load_pct *
+			  (u64)walt_ravg_window, 100);
+	}
+
+	p->ravg.demand = init_load_windows;
+	for (i = 0; i < RAVG_HIST_SIZE_MAX; ++i)
+		p->ravg.sum_history[i] = init_load_windows;
+}
diff --git a/kernel/sched/walt.h b/kernel/sched/walt.h
new file mode 100644
index 00000000..bd20ed8
--- /dev/null
+++ b/kernel/sched/walt.h
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2016, The Linux Foundation. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef __WALT_H
+#define __WALT_H
+
+#ifdef CONFIG_SCHED_WALT
+
+void walt_update_task_ravg(struct task_struct *p, struct rq *rq, int event,
+		u64 wallclock, u64 irqtime);
+void walt_inc_cumulative_runnable_avg(struct rq *rq, struct task_struct *p);
+void walt_dec_cumulative_runnable_avg(struct rq *rq, struct task_struct *p);
+
+void walt_fixup_busy_time(struct task_struct *p, int new_cpu);
+void walt_init_new_task_load(struct task_struct *p);
+void walt_mark_task_starting(struct task_struct *p);
+void walt_set_window_start(struct rq *rq);
+void walt_migrate_sync_cpu(int cpu);
+void walt_init_cpu_efficiency(void);
+u64 walt_ktime_clock(void);
+void walt_account_irqtime(int cpu, struct task_struct *curr, u64 delta,
+                                  u64 wallclock);
+
+u64 walt_irqload(int cpu);
+int walt_cpu_high_irqload(int cpu);
+
+#else /* CONFIG_SCHED_WALT */
+
+static inline void walt_update_task_ravg(struct task_struct *p, struct rq *rq,
+		int event, u64 wallclock, u64 irqtime) { }
+static inline void walt_inc_cumulative_runnable_avg(struct rq *rq, struct task_struct *p) { }
+static inline void walt_dec_cumulative_runnable_avg(struct rq *rq, struct task_struct *p) { }
+static inline void walt_fixup_busy_time(struct task_struct *p, int new_cpu) { }
+static inline void walt_init_new_task_load(struct task_struct *p) { }
+static inline void walt_mark_task_starting(struct task_struct *p) { }
+static inline void walt_set_window_start(struct rq *rq) { }
+static inline void walt_migrate_sync_cpu(int cpu) { }
+static inline void walt_init_cpu_efficiency(void) { }
+static inline u64 walt_ktime_clock(void) { return 0; }
+
+#define walt_cpu_high_irqload(cpu) false
+
+#endif /* CONFIG_SCHED_WALT */
+
+#if defined(CONFIG_CFS_BANDWIDTH) && defined(CONFIG_SCHED_WALT)
+void walt_inc_cfs_cumulative_runnable_avg(struct cfs_rq *rq,
+		struct task_struct *p);
+void walt_dec_cfs_cumulative_runnable_avg(struct cfs_rq *rq,
+		struct task_struct *p);
+#else
+static inline void walt_inc_cfs_cumulative_runnable_avg(struct cfs_rq *rq,
+		struct task_struct *p) { }
+static inline void walt_dec_cfs_cumulative_runnable_avg(struct cfs_rq *rq,
+		struct task_struct *p) { }
+#endif
+
+extern bool walt_disabled;
+
+#endif
diff --git a/kernel/softirq.c b/kernel/softirq.c
index 744fa61..e3c965c 100644
--- a/kernel/softirq.c
+++ b/kernel/softirq.c
@@ -26,6 +26,7 @@
 #include <linux/smpboot.h>
 #include <linux/tick.h>
 #include <linux/irq.h>
+#include <linux/rtk_trace.h>
 
 #define CREATE_TRACE_POINTS
 #include <trace/events/irq.h>
@@ -281,6 +282,7 @@ asmlinkage __visible void __softirq_entry __do_softirq(void)
 		kstat_incr_softirqs_this_cpu(vec_nr);
 
 		trace_softirq_entry(vec_nr);
+		uncached_logk(LOGK_SOFTIRQ, (void *)(h->action));
 		h->action(h);
 		trace_softirq_exit(vec_nr);
 		if (unlikely(prev_count != preempt_count())) {
diff --git a/kernel/sys.c b/kernel/sys.c
index b13b530..671b800 100644
--- a/kernel/sys.c
+++ b/kernel/sys.c
@@ -41,6 +41,8 @@
 #include <linux/syscore_ops.h>
 #include <linux/version.h>
 #include <linux/ctype.h>
+#include <linux/mm.h>
+#include <linux/mempolicy.h>
 
 #include <linux/compat.h>
 #include <linux/syscalls.h>
@@ -2075,6 +2077,153 @@ static int prctl_get_tid_address(struct task_struct *me, int __user **tid_addr)
 }
 #endif
 
+#ifdef CONFIG_MMU
+static int prctl_update_vma_anon_name(struct vm_area_struct *vma,
+		struct vm_area_struct **prev,
+		unsigned long start, unsigned long end,
+		const char __user *name_addr)
+{
+	struct mm_struct *mm = vma->vm_mm;
+	int error = 0;
+	pgoff_t pgoff;
+
+	if (name_addr == vma_get_anon_name(vma)) {
+		*prev = vma;
+		goto out;
+	}
+
+	pgoff = vma->vm_pgoff + ((start - vma->vm_start) >> PAGE_SHIFT);
+	*prev = vma_merge(mm, *prev, start, end, vma->vm_flags, vma->anon_vma,
+				vma->vm_file, pgoff, vma_policy(vma),
+				vma->vm_userfaultfd_ctx, name_addr);
+	if (*prev) {
+		vma = *prev;
+		goto success;
+	}
+
+	*prev = vma;
+
+	if (start != vma->vm_start) {
+		error = split_vma(mm, vma, start, 1);
+		if (error)
+			goto out;
+	}
+
+	if (end != vma->vm_end) {
+		error = split_vma(mm, vma, end, 0);
+		if (error)
+			goto out;
+	}
+
+success:
+	if (!vma->vm_file)
+		vma->anon_name = name_addr;
+
+out:
+	if (error == -ENOMEM)
+		error = -EAGAIN;
+	return error;
+}
+
+static int prctl_set_vma_anon_name(unsigned long start, unsigned long end,
+			unsigned long arg)
+{
+	unsigned long tmp;
+	struct vm_area_struct *vma, *prev;
+	int unmapped_error = 0;
+	int error = -EINVAL;
+
+	/*
+	 * If the interval [start,end) covers some unmapped address
+	 * ranges, just ignore them, but return -ENOMEM at the end.
+	 * - this matches the handling in madvise.
+	 */
+	vma = find_vma_prev(current->mm, start, &prev);
+	if (vma && start > vma->vm_start)
+		prev = vma;
+
+	for (;;) {
+		/* Still start < end. */
+		error = -ENOMEM;
+		if (!vma)
+			return error;
+
+		/* Here start < (end|vma->vm_end). */
+		if (start < vma->vm_start) {
+			unmapped_error = -ENOMEM;
+			start = vma->vm_start;
+			if (start >= end)
+				return error;
+		}
+
+		/* Here vma->vm_start <= start < (end|vma->vm_end) */
+		tmp = vma->vm_end;
+		if (end < tmp)
+			tmp = end;
+
+		/* Here vma->vm_start <= start < tmp <= (end|vma->vm_end). */
+		error = prctl_update_vma_anon_name(vma, &prev, start, tmp,
+				(const char __user *)arg);
+		if (error)
+			return error;
+		start = tmp;
+		if (prev && start < prev->vm_end)
+			start = prev->vm_end;
+		error = unmapped_error;
+		if (start >= end)
+			return error;
+		if (prev)
+			vma = prev->vm_next;
+		else	/* madvise_remove dropped mmap_sem */
+			vma = find_vma(current->mm, start);
+	}
+}
+
+static int prctl_set_vma(unsigned long opt, unsigned long start,
+		unsigned long len_in, unsigned long arg)
+{
+	struct mm_struct *mm = current->mm;
+	int error;
+	unsigned long len;
+	unsigned long end;
+
+	if (start & ~PAGE_MASK)
+		return -EINVAL;
+	len = (len_in + ~PAGE_MASK) & PAGE_MASK;
+
+	/* Check to see whether len was rounded up from small -ve to zero */
+	if (len_in && !len)
+		return -EINVAL;
+
+	end = start + len;
+	if (end < start)
+		return -EINVAL;
+
+	if (end == start)
+		return 0;
+
+	down_write(&mm->mmap_sem);
+
+	switch (opt) {
+	case PR_SET_VMA_ANON_NAME:
+		error = prctl_set_vma_anon_name(start, end, arg);
+		break;
+	default:
+		error = -EINVAL;
+	}
+
+	up_write(&mm->mmap_sem);
+
+	return error;
+}
+#else /* CONFIG_MMU */
+static int prctl_set_vma(unsigned long opt, unsigned long start,
+		unsigned long len_in, unsigned long arg)
+{
+	return -EINVAL;
+}
+#endif
+
 int __weak arch_prctl_spec_ctrl_get(struct task_struct *t, unsigned long which)
 {
 	return -EINVAL;
@@ -2294,6 +2443,9 @@ int __weak arch_prctl_spec_ctrl_set(struct task_struct *t, unsigned long which,
 			return -EINVAL;
 		error = arch_prctl_spec_ctrl_set(me, arg2, arg3);
 		break;
+	case PR_SET_VMA:
+		error = prctl_set_vma(arg2, arg3, arg4, arg5);
+		break;
 	default:
 		error = -EINVAL;
 		break;
diff --git a/kernel/sysctl.c b/kernel/sysctl.c
index 24d603d..c0f63fa 100644
--- a/kernel/sysctl.c
+++ b/kernel/sysctl.c
@@ -105,6 +105,7 @@
 extern unsigned int core_pipe_limit;
 #endif
 extern int pid_max;
+extern int extra_free_kbytes;
 extern int pid_max_min, pid_max_max;
 extern int percpu_pagelist_fraction;
 extern int latencytop_enabled;
@@ -308,6 +309,50 @@ static int sysrq_sysctl_handler(struct ctl_table *table, int write,
 		.extra2		= &max_sched_granularity_ns,
 	},
 	{
+		.procname	= "sched_sync_hint_enable",
+		.data		= &sysctl_sched_sync_hint_enable,
+		.maxlen		= sizeof(unsigned int),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec,
+	},
+#ifdef CONFIG_SCHED_WALT
+	{
+		.procname	= "sched_use_walt_cpu_util",
+		.data		= &sysctl_sched_use_walt_cpu_util,
+		.maxlen		= sizeof(unsigned int),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec,
+	},
+	{
+		.procname	= "sched_use_walt_task_util",
+		.data		= &sysctl_sched_use_walt_task_util,
+		.maxlen		= sizeof(unsigned int),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec,
+	},
+	{
+		.procname	= "sched_walt_init_task_load_pct",
+		.data		= &sysctl_sched_walt_init_task_load_pct,
+		.maxlen		= sizeof(unsigned int),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec,
+	},
+	{
+		.procname	= "sched_walt_cpu_high_irqload",
+		.data		= &sysctl_sched_walt_cpu_high_irqload,
+		.maxlen		= sizeof(unsigned int),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec,
+	},
+#endif
+	{
+		.procname	= "sched_cstate_aware",
+		.data		= &sysctl_sched_cstate_aware,
+		.maxlen		= sizeof(unsigned int),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec,
+	},
+	{
 		.procname	= "sched_wakeup_granularity_ns",
 		.data		= &sysctl_sched_wakeup_granularity,
 		.maxlen		= sizeof(unsigned int),
@@ -449,6 +494,21 @@ static int sysrq_sysctl_handler(struct ctl_table *table, int write,
 		.extra1		= &one,
 	},
 #endif
+#ifdef CONFIG_SCHED_TUNE
+	{
+		.procname	= "sched_cfs_boost",
+		.data		= &sysctl_sched_cfs_boost,
+		.maxlen		= sizeof(sysctl_sched_cfs_boost),
+#ifdef CONFIG_CGROUP_SCHEDTUNE
+		.mode		= 0444,
+#else
+		.mode		= 0644,
+#endif
+		.proc_handler	= &sysctl_sched_cfs_boost_handler,
+		.extra1		= &zero,
+		.extra2		= &one_hundred,
+	},
+#endif
 #ifdef CONFIG_PROVE_LOCKING
 	{
 		.procname	= "prove_locking",
@@ -1446,6 +1506,14 @@ static int sysrq_sysctl_handler(struct ctl_table *table, int write,
 		.extra2		= &one_thousand,
 	},
 	{
+		.procname	= "extra_free_kbytes",
+		.data		= &extra_free_kbytes,
+		.maxlen		= sizeof(extra_free_kbytes),
+		.mode		= 0644,
+		.proc_handler	= min_free_kbytes_sysctl_handler,
+		.extra1		= &zero,
+	},
+	{
 		.procname	= "percpu_pagelist_fraction",
 		.data		= &percpu_pagelist_fraction,
 		.maxlen		= sizeof(percpu_pagelist_fraction),
diff --git a/kernel/time/alarmtimer.c b/kernel/time/alarmtimer.c
index d67ef56c..f0b1435 100644
--- a/kernel/time/alarmtimer.c
+++ b/kernel/time/alarmtimer.c
@@ -253,6 +253,9 @@ static int alarmtimer_suspend(struct device *dev)
 	if (min.tv64 == 0)
 		return 0;
 
+	if (IS_ENABLED(CONFIG_RTK_PLATFORM))
+		return 0;
+
 	if (ktime_to_ns(min) < 2 * NSEC_PER_SEC) {
 		__pm_wakeup_event(ws, 2 * MSEC_PER_SEC);
 		return -EBUSY;
diff --git a/kernel/time/tick-sched.c b/kernel/time/tick-sched.c
index b6bebe2..65aafad 100644
--- a/kernel/time/tick-sched.c
+++ b/kernel/time/tick-sched.c
@@ -1009,6 +1009,18 @@ ktime_t tick_nohz_get_sleep_length(void)
 	return ts->sleep_length;
 }
 
+/**
+ * tick_nohz_get_idle_calls - return the current idle calls counter value
+ *
+ * Called from the schedutil frequency scaling governor in scheduler context.
+ */
+unsigned long tick_nohz_get_idle_calls(void)
+{
+	struct tick_sched *ts = this_cpu_ptr(&tick_cpu_sched);
+
+	return ts->idle_calls;
+}
+
 static void tick_nohz_account_idle_ticks(struct tick_sched *ts)
 {
 #ifndef CONFIG_VIRT_CPU_ACCOUNTING_NATIVE
diff --git a/kernel/time/timekeeping.c b/kernel/time/timekeeping.c
index d831827..427e33d 100644
--- a/kernel/time/timekeeping.c
+++ b/kernel/time/timekeeping.c
@@ -70,6 +70,10 @@ static inline void tk_normalize_xtime(struct timekeeper *tk)
 		tk->tkr_mono.xtime_nsec -= (u64)NSEC_PER_SEC << tk->tkr_mono.shift;
 		tk->xtime_sec++;
 	}
+	while (tk->tkr_raw.xtime_nsec >= ((u64)NSEC_PER_SEC << tk->tkr_raw.shift)) {
+		tk->tkr_raw.xtime_nsec -= (u64)NSEC_PER_SEC << tk->tkr_raw.shift;
+		tk->raw_sec++;
+	}
 }
 
 static inline struct timespec64 tk_xtime(struct timekeeper *tk)
@@ -283,12 +287,14 @@ static void tk_setup_internals(struct timekeeper *tk, struct clocksource *clock)
 	 /* if changing clocks, convert xtime_nsec shift units */
 	if (old_clock) {
 		int shift_change = clock->shift - old_clock->shift;
-		if (shift_change < 0)
+		if (shift_change < 0) {
 			tk->tkr_mono.xtime_nsec >>= -shift_change;
-		else
+			tk->tkr_raw.xtime_nsec >>= -shift_change;
+		} else {
 			tk->tkr_mono.xtime_nsec <<= shift_change;
+			tk->tkr_raw.xtime_nsec <<= shift_change;
+		}
 	}
-	tk->tkr_raw.xtime_nsec = 0;
 
 	tk->tkr_mono.shift = clock->shift;
 	tk->tkr_raw.shift = clock->shift;
@@ -442,6 +448,35 @@ u64 ktime_get_raw_fast_ns(void)
 }
 EXPORT_SYMBOL_GPL(ktime_get_raw_fast_ns);
 
+/**
+ * ktime_get_boot_fast_ns - NMI safe and fast access to boot clock.
+ *
+ * To keep it NMI safe since we're accessing from tracing, we're not using a
+ * separate timekeeper with updates to monotonic clock and boot offset
+ * protected with seqlocks. This has the following minor side effects:
+ *
+ * (1) Its possible that a timestamp be taken after the boot offset is updated
+ * but before the timekeeper is updated. If this happens, the new boot offset
+ * is added to the old timekeeping making the clock appear to update slightly
+ * earlier:
+ *    CPU 0                                        CPU 1
+ *    timekeeping_inject_sleeptime64()
+ *    __timekeeping_inject_sleeptime(tk, delta);
+ *                                                 timestamp();
+ *    timekeeping_update(tk, TK_CLEAR_NTP...);
+ *
+ * (2) On 32-bit systems, the 64-bit boot offset (tk->offs_boot) may be
+ * partially updated.  Since the tk->offs_boot update is a rare event, this
+ * should be a rare occurrence which postprocessing should be able to handle.
+ */
+u64 notrace ktime_get_boot_fast_ns(void)
+{
+	struct timekeeper *tk = &tk_core.timekeeper;
+
+	return (ktime_get_mono_fast_ns() + ktime_to_ns(tk->offs_boot));
+}
+EXPORT_SYMBOL_GPL(ktime_get_boot_fast_ns);
+
 /* Suspend-time cycles value for halted fast timekeeper. */
 static cycle_t cycles_at_suspend;
 
@@ -590,9 +625,6 @@ static inline void tk_update_ktime_data(struct timekeeper *tk)
 	nsec = (u32) tk->wall_to_monotonic.tv_nsec;
 	tk->tkr_mono.base = ns_to_ktime(seconds * NSEC_PER_SEC + nsec);
 
-	/* Update the monotonic raw base */
-	tk->tkr_raw.base = timespec64_to_ktime(tk->raw_time);
-
 	/*
 	 * The sum of the nanoseconds portions of xtime and
 	 * wall_to_monotonic can be greater/equal one second. Take
@@ -602,6 +634,9 @@ static inline void tk_update_ktime_data(struct timekeeper *tk)
 	if (nsec >= NSEC_PER_SEC)
 		seconds++;
 	tk->ktime_sec = seconds;
+
+	/* Update the monotonic raw base */
+	tk->tkr_raw.base = ns_to_ktime(tk->raw_sec * NSEC_PER_SEC);
 }
 
 /* must hold timekeeper_lock */
@@ -643,7 +678,6 @@ static void timekeeping_update(struct timekeeper *tk, unsigned int action)
 static void timekeeping_forward_now(struct timekeeper *tk)
 {
 	cycle_t cycle_now, delta;
-	s64 nsec;
 
 	cycle_now = tk_clock_read(&tk->tkr_mono);
 	delta = clocksource_delta(cycle_now, tk->tkr_mono.cycle_last, tk->tkr_mono.mask);
@@ -655,10 +689,13 @@ static void timekeeping_forward_now(struct timekeeper *tk)
 	/* If arch requires, add in get_arch_timeoffset() */
 	tk->tkr_mono.xtime_nsec += (u64)arch_gettimeoffset() << tk->tkr_mono.shift;
 
-	tk_normalize_xtime(tk);
 
-	nsec = clocksource_cyc2ns(delta, tk->tkr_raw.mult, tk->tkr_raw.shift);
-	timespec64_add_ns(&tk->raw_time, nsec);
+	tk->tkr_raw.xtime_nsec += delta * tk->tkr_raw.mult;
+
+	/* If arch requires, add in get_arch_timeoffset() */
+	tk->tkr_raw.xtime_nsec += (u64)arch_gettimeoffset() << tk->tkr_raw.shift;
+
+	tk_normalize_xtime(tk);
 }
 
 /**
@@ -1382,19 +1419,18 @@ int timekeeping_notify(struct clocksource *clock)
 void getrawmonotonic64(struct timespec64 *ts)
 {
 	struct timekeeper *tk = &tk_core.timekeeper;
-	struct timespec64 ts64;
 	unsigned long seq;
 	s64 nsecs;
 
 	do {
 		seq = read_seqcount_begin(&tk_core.seq);
+		ts->tv_sec = tk->raw_sec;
 		nsecs = timekeeping_get_ns(&tk->tkr_raw);
-		ts64 = tk->raw_time;
 
 	} while (read_seqcount_retry(&tk_core.seq, seq));
 
-	timespec64_add_ns(&ts64, nsecs);
-	*ts = ts64;
+	ts->tv_nsec = 0;
+	timespec64_add_ns(ts, nsecs);
 }
 EXPORT_SYMBOL(getrawmonotonic64);
 
@@ -1518,8 +1554,7 @@ void __init timekeeping_init(void)
 	tk_setup_internals(tk, clock);
 
 	tk_set_xtime(tk, &now);
-	tk->raw_time.tv_sec = 0;
-	tk->raw_time.tv_nsec = 0;
+	tk->raw_sec = 0;
 	if (boot.tv_sec == 0 && boot.tv_nsec == 0)
 		boot = tk_xtime(tk);
 
@@ -2037,15 +2072,12 @@ static cycle_t logarithmic_accumulation(struct timekeeper *tk, cycle_t offset,
 	*clock_set |= accumulate_nsecs_to_secs(tk);
 
 	/* Accumulate raw time */
-	tk->tkr_raw.xtime_nsec += (u64)tk->raw_time.tv_nsec << tk->tkr_raw.shift;
 	tk->tkr_raw.xtime_nsec += tk->raw_interval << shift;
 	snsec_per_sec = (u64)NSEC_PER_SEC << tk->tkr_raw.shift;
 	while (tk->tkr_raw.xtime_nsec >= snsec_per_sec) {
 		tk->tkr_raw.xtime_nsec -= snsec_per_sec;
-		tk->raw_time.tv_sec++;
+		tk->raw_sec++;
 	}
-	tk->raw_time.tv_nsec = tk->tkr_raw.xtime_nsec >> tk->tkr_raw.shift;
-	tk->tkr_raw.xtime_nsec -= (u64)tk->raw_time.tv_nsec << tk->tkr_raw.shift;
 
 	/* Accumulate error between NTP and clock interval */
 	tk->ntp_error += tk->ntp_tick << shift;
diff --git a/kernel/time/timer_list.c b/kernel/time/timer_list.c
index ef4f16e..ab4fc54 100644
--- a/kernel/time/timer_list.c
+++ b/kernel/time/timer_list.c
@@ -34,20 +34,13 @@ struct timer_list_iter {
  * This allows printing both to /proc/timer_list and
  * to the console (on SysRq-Q):
  */
-__printf(2, 3)
-static void SEQ_printf(struct seq_file *m, const char *fmt, ...)
-{
-	va_list args;
-
-	va_start(args, fmt);
-
-	if (m)
-		seq_vprintf(m, fmt, args);
-	else
-		vprintk(fmt, args);
-
-	va_end(args);
-}
+#define SEQ_printf(m, x...)			\
+ do {						\
+	if (m)					\
+		seq_printf(m, x);		\
+	else					\
+		pr_cont(x);			\
+ } while (0)
 
 static void print_name_offset(struct seq_file *m, void *sym)
 {
diff --git a/kernel/trace/Kconfig b/kernel/trace/Kconfig
index 2a96b06..55f3566 100644
--- a/kernel/trace/Kconfig
+++ b/kernel/trace/Kconfig
@@ -72,6 +72,9 @@ config EVENT_TRACING
 	select CONTEXT_SWITCH_TRACER
 	bool
 
+config GPU_TRACEPOINTS
+	bool
+
 config CONTEXT_SWITCH_TRACER
 	bool
 
@@ -81,6 +84,12 @@ config RING_BUFFER_ALLOW_SWAP
 	 Allow the use of ring_buffer_swap_cpu.
 	 Adds a very slight overhead to tracing when enabled.
 
+config RTK_TRACER
+	bool "RTK tracer"
+	default y if DEBUG_KERNEL
+	help
+	  RTK event tracer.
+
 # All tracer options should select GENERIC_TRACER. For those options that are
 # enabled by all tracers (context switch and event tracer) they select TRACING.
 # This allows those options to appear when no other tracer is selected. But the
@@ -157,6 +166,17 @@ config FUNCTION_GRAPH_TRACER
 	  address on the current task structure into a stack of calls.
 
 
+config PREEMPTIRQ_EVENTS
+	bool "Enable trace events for preempt and irq disable/enable"
+	select TRACE_IRQFLAGS
+	depends on DEBUG_PREEMPT || !PROVE_LOCKING
+	default n
+	help
+	  Enable tracing of disable and enable events for preemption and irqs.
+	  For tracing preempt disable/enable events, DEBUG_PREEMPT must be
+	  enabled. For tracing irq disable/enable events, PROVE_LOCKING must
+	  be disabled.
+
 config IRQSOFF_TRACER
 	bool "Interrupts-off Latency Tracer"
 	default n
diff --git a/kernel/trace/Makefile b/kernel/trace/Makefile
index e579808..2c08722 100644
--- a/kernel/trace/Makefile
+++ b/kernel/trace/Makefile
@@ -34,6 +34,7 @@ obj-$(CONFIG_TRACING) += trace_printk.o
 obj-$(CONFIG_TRACING_MAP) += tracing_map.o
 obj-$(CONFIG_CONTEXT_SWITCH_TRACER) += trace_sched_switch.o
 obj-$(CONFIG_FUNCTION_TRACER) += trace_functions.o
+obj-$(CONFIG_PREEMPTIRQ_EVENTS) += trace_irqsoff.o
 obj-$(CONFIG_IRQSOFF_TRACER) += trace_irqsoff.o
 obj-$(CONFIG_PREEMPT_TRACER) += trace_irqsoff.o
 obj-$(CONFIG_SCHED_TRACER) += trace_sched_wakeup.o
@@ -67,7 +68,10 @@ obj-$(CONFIG_KGDB_KDB) += trace_kdb.o
 endif
 obj-$(CONFIG_PROBE_EVENTS) += trace_probe.o
 obj-$(CONFIG_UPROBE_EVENT) += trace_uprobe.o
+obj-$(CONFIG_GPU_TRACEPOINTS) += gpu-traces.o
 
 obj-$(CONFIG_TRACEPOINT_BENCHMARK) += trace_benchmark.o
 
+obj-$(CONFIG_RTK_TRACER) += rtk_trace.o
+
 libftrace-y := ftrace.o
diff --git a/kernel/trace/ftrace.c b/kernel/trace/ftrace.c
index 2884fe0..5534be1 100644
--- a/kernel/trace/ftrace.c
+++ b/kernel/trace/ftrace.c
@@ -120,8 +120,9 @@ static void ftrace_ops_list_func(unsigned long ip, unsigned long parent_ip,
 				 struct ftrace_ops *op, struct pt_regs *regs);
 #else
 /* See comment below, where ftrace_ops_list_func is defined */
-static void ftrace_ops_no_ops(unsigned long ip, unsigned long parent_ip);
-#define ftrace_ops_list_func ((ftrace_func_t)ftrace_ops_no_ops)
+static void ftrace_ops_no_ops(unsigned long ip, unsigned long parent_ip,
+			      struct ftrace_ops *op, struct pt_regs *regs);
+#define ftrace_ops_list_func ftrace_ops_no_ops
 #endif
 
 /*
@@ -4874,9 +4875,9 @@ static int ftrace_cmp_ips(const void *a, const void *b)
 	return 0;
 }
 
-static int ftrace_process_locs(struct module *mod,
-			       unsigned long *start,
-			       unsigned long *end)
+static int __norecordmcount ftrace_process_locs(struct module *mod,
+						unsigned long *start,
+						unsigned long *end)
 {
 	struct ftrace_page *start_pg;
 	struct ftrace_page *pg;
@@ -5309,7 +5310,8 @@ static void ftrace_ops_list_func(unsigned long ip, unsigned long parent_ip,
 	__ftrace_ops_list_func(ip, parent_ip, NULL, regs);
 }
 #else
-static void ftrace_ops_no_ops(unsigned long ip, unsigned long parent_ip)
+static void ftrace_ops_no_ops(unsigned long ip, unsigned long parent_ip,
+			      struct ftrace_ops *op, struct pt_regs *regs)
 {
 	__ftrace_ops_list_func(ip, parent_ip, NULL, NULL);
 }
@@ -5735,14 +5737,17 @@ void ftrace_graph_graph_time_control(bool enable)
 	fgraph_graph_time = enable;
 }
 
+void ftrace_graph_return_stub(struct ftrace_graph_ret *trace)
+{
+}
+
 int ftrace_graph_entry_stub(struct ftrace_graph_ent *trace)
 {
 	return 0;
 }
 
 /* The callbacks that hook a function */
-trace_func_graph_ret_t ftrace_graph_return =
-			(trace_func_graph_ret_t)ftrace_stub;
+trace_func_graph_ret_t ftrace_graph_return = ftrace_graph_return_stub;
 trace_func_graph_ent_t ftrace_graph_entry = ftrace_graph_entry_stub;
 static trace_func_graph_ent_t __ftrace_graph_entry = ftrace_graph_entry_stub;
 
@@ -5970,7 +5975,7 @@ void unregister_ftrace_graph(void)
 		goto out;
 
 	ftrace_graph_active--;
-	ftrace_graph_return = (trace_func_graph_ret_t)ftrace_stub;
+	ftrace_graph_return = ftrace_graph_return_stub;
 	ftrace_graph_entry = ftrace_graph_entry_stub;
 	__ftrace_graph_entry = ftrace_graph_entry_stub;
 	ftrace_shutdown(&graph_ops, FTRACE_STOP_FUNC_RET);
diff --git a/kernel/trace/gpu-traces.c b/kernel/trace/gpu-traces.c
new file mode 100644
index 00000000..a4b3f00
--- /dev/null
+++ b/kernel/trace/gpu-traces.c
@@ -0,0 +1,23 @@
+/*
+ * GPU tracepoints
+ *
+ * Copyright (C) 2013 Google, Inc.
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ */
+
+#include <linux/module.h>
+
+#define CREATE_TRACE_POINTS
+#include <trace/events/gpu.h>
+
+EXPORT_TRACEPOINT_SYMBOL(gpu_sched_switch);
+EXPORT_TRACEPOINT_SYMBOL(gpu_job_enqueue);
diff --git a/kernel/trace/rtk_trace.c b/kernel/trace/rtk_trace.c
new file mode 100644
index 00000000..6e4b501
--- /dev/null
+++ b/kernel/trace/rtk_trace.c
@@ -0,0 +1,585 @@
+/*
+ * Copyright (c) 2013-2015, The Linux Foundation. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 and
+ * only version 2 as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+#define pr_fmt(fmt) "rtktrace: " fmt
+
+#include <linux/atomic.h>
+#include <linux/export.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/dma-mapping.h>
+#include <linux/mod_devicetable.h>
+#include <linux/platform_device.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/string.h>
+#include <linux/atomic.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/io.h>
+#include <asm-generic/sizes.h>
+#include <linux/rtk_trace.h>
+#include <linux/miscdevice.h>
+#include <linux/fs.h>
+#include <linux/uaccess.h>
+
+#define MODULE_NAME	"rtktrace"
+
+
+#define SENTINEL_BYTE_1 0xFF
+#define SENTINEL_BYTE_2 0xAA
+#define SENTINEL_BYTE_3 0xFF
+
+#define VMAP_MAGIC	0x11223344
+
+extern void external_vmap_area_lock(void);
+extern void external_vmap_area_unlock(void);
+
+/* Write
+ * 1) 3 bytes sentinel
+ * 2) 1 bytes of log type
+ * 3) 8 bytes of where the caller came from
+ * 4) 4 bytes index
+ * 4) 8 bytes extra data from the caller
+ * 5) 8 bytes of timestamp
+ *
+ * Total = 32 bytes.
+ */
+struct rtk_trace_layout {
+	unsigned char sentinel[3];
+	unsigned char log_type;
+	uint32_t idx;
+	uint64_t caller;
+	uint64_t data;
+	uint64_t timestamp;
+} __attribute__ ((__packed__));
+
+
+struct rtk_trace_state {
+	struct rtk_trace_layout *t_buf;
+	phys_addr_t phys;
+	int nentries;
+	int size;
+	int enabled;
+	int initialized;
+	uint32_t filter;
+	int step_size;
+};
+
+struct rtk_trace_dump_device {
+	char name[32];
+	struct miscdevice device;
+	int size;
+	char *last_buf;
+};
+
+/* structure & variables used for vmap info */
+struct rtk_trace_vmap_info {
+	uint64_t va;
+	uint64_t size;
+	uint64_t pa;
+	uint32_t magic;
+	uint32_t dummy;
+} __attribute__ ((__packed__));
+
+struct vmap_info_stat_t {
+	spinlock_t lock;
+	void *vmap_p;
+	int vmap_size;
+	int count;
+};
+
+DEFINE_PER_CPU(atomic_t, rtk_trace_idx_cpu);
+
+static struct vmap_info_stat_t vmap_info_stat;
+static atomic_t vmap_initialized __read_mostly = ATOMIC_INIT(0);
+
+static struct rtk_trace_state rtk_trace = {
+	/* remove rtk_trace.filter from cmdline to control the filter here */
+	.filter = (1 << LOGK_READL)|(1 << LOGK_WRITEL)|(1 << LOGK_LOGBUF)|(1 << LOGK_HOTPLUG)|(1 << LOGK_CTXID)|(1 << LOGK_IRQ)|(1 << LOGK_DIE)|(1 << LOGK_INITCALL)|(1 << LOGK_SOFTIRQ)|(1 << LOGK_HVC),
+	.enabled = 1,
+};
+
+module_param_named(filter, rtk_trace.filter, uint, 0644);
+module_param_named(enable, rtk_trace.enabled, int, 0644);
+
+void rtk_trace_disable(void)
+{
+	rtk_trace.enabled = 0;
+	return;
+}
+EXPORT_SYMBOL(rtk_trace_disable);
+
+static int rtk_trace_panic_notifier(struct notifier_block *this,
+					unsigned long event, void *ptr)
+{
+	rtk_trace.enabled = 0;
+	pr_info("stop due to panic\n");
+	return NOTIFY_DONE;
+}
+
+static struct notifier_block rtk_trace_panic_blk = {
+	.notifier_call  = rtk_trace_panic_notifier,
+};
+
+int notrace rtk_trace_event_should_log(enum logk_event_type log_type)
+{
+	return rtk_trace.initialized && rtk_trace.enabled &&
+		((1 << (log_type & ~LOGTYPE_NOPC)) & rtk_trace.filter);
+}
+EXPORT_SYMBOL(rtk_trace_event_should_log);
+
+static void rtk_trace_emit_sentinel(struct rtk_trace_layout *start)
+{
+	start->sentinel[0] = SENTINEL_BYTE_1;
+	start->sentinel[1] = SENTINEL_BYTE_2;
+	start->sentinel[2] = SENTINEL_BYTE_3;
+}
+
+static void rtk_trace_write_type(enum logk_event_type log_type,
+			struct rtk_trace_layout *start)
+{
+	start->log_type = (char)log_type;
+}
+
+static void rtk_trace_write_caller(uint64_t caller, struct rtk_trace_layout *start)
+{
+	start->caller = caller;
+}
+
+static void rtk_trace_write_idx(uint32_t idx,
+				struct rtk_trace_layout *start)
+{
+	start->idx = idx;
+}
+
+static void rtk_trace_write_data(uint64_t data, struct rtk_trace_layout *start)
+{
+	start->data = data;
+}
+
+static void rtk_trace_write_timestamp(struct rtk_trace_layout *start)
+{
+	start->timestamp = sched_clock();
+}
+
+static void uncached_logk_pc_idx(enum logk_event_type log_type, uint64_t caller,
+				 uint64_t data, int idx)
+{
+	struct rtk_trace_layout *start;
+
+	start = &rtk_trace.t_buf[idx & (rtk_trace.nentries - 1)];
+
+	rtk_trace_emit_sentinel(start);
+	rtk_trace_write_type(log_type, start);
+	rtk_trace_write_caller(caller, start);
+	rtk_trace_write_idx(idx, start);
+	rtk_trace_write_data(data, start);
+	rtk_trace_write_timestamp(start);
+	mb();
+
+	return;
+}
+
+static void uncached_logk_timestamp(int idx)
+{
+	unsigned long long timestamp;
+
+	timestamp = sched_clock();
+	uncached_logk_pc_idx(LOGK_TIMESTAMP|LOGTYPE_NOPC,
+			(uint64_t)lower_32_bits(timestamp),
+			(uint64_t)upper_32_bits(timestamp), idx);
+}
+
+/*
+ * Since it is not necessarily true that nentries % step_size == 0,
+ * must make appropriate adjustments to the index when a "wraparound"
+ * occurs to ensure that rtk_trace.t_buf[x] always belongs to the same cpu.
+ * It is desired to give all cpus the same number of entries; this leaves
+ * (nentries % step_size) dead space at the end of the buffer.
+ */
+static int rtk_trace_get_idx(void)
+{
+	int cpu, i, offset;
+	atomic_t *index;
+	unsigned long flags;
+	u32 unused_buffer_size = rtk_trace.nentries % rtk_trace.step_size;
+	int adjusted_size;
+
+	/*
+	 * ideally we would use get_cpu but this is a close enough
+	 * approximation for our purposes.
+	 */
+	cpu = raw_smp_processor_id();
+
+	index = &per_cpu(rtk_trace_idx_cpu, cpu);
+
+	local_irq_save(flags);
+	i = atomic_add_return(rtk_trace.step_size, index);
+	i -= rtk_trace.step_size;
+
+	/*
+	 * Check if index has wrapped around or is in the unused region at the
+	 * end of the buffer
+	 */
+	adjusted_size = atomic_read(index) + unused_buffer_size;
+	offset = (adjusted_size & (rtk_trace.nentries - 1)) -
+		 ((adjusted_size - rtk_trace.step_size) & (rtk_trace.nentries - 1));
+	if (offset < 0) {
+		uncached_logk_timestamp(i);
+		i = atomic_add_return(rtk_trace.step_size + unused_buffer_size,
+									index);
+		i -= rtk_trace.step_size;
+	}
+	local_irq_restore(flags);
+
+	return i;
+}
+
+int notrace uncached_logk_pc(enum logk_event_type log_type, void *caller,
+				void *data)
+{
+	int i;
+
+	if (!rtk_trace_event_should_log(log_type))
+		return 0;
+
+	i = rtk_trace_get_idx();
+	uncached_logk_pc_idx(log_type, (uint64_t)((unsigned long) caller),
+				(uint64_t)((unsigned long) data), i);
+
+	return 1;
+}
+EXPORT_SYMBOL(uncached_logk_pc);
+
+noinline int notrace uncached_logk(enum logk_event_type log_type, void *data)
+{
+	return uncached_logk_pc(log_type, __builtin_return_address(0), data);
+}
+EXPORT_SYMBOL(uncached_logk);
+
+static int rtk_trace_open(struct inode *inode, struct file *filep)
+{
+	struct rtk_trace_dump_device *td_dev = container_of(filep->private_data, struct rtk_trace_dump_device, device);
+	pr_info("%s opened by %s(%d)\n", td_dev->name, current->comm, current->pid);
+        return 0;
+}
+
+static int rtk_trace_release(struct inode *inode, struct file *filep)
+{
+	struct rtk_trace_dump_device *td_dev = container_of(filep->private_data, struct rtk_trace_dump_device, device);
+	pr_info("%s closed by %s(%d)\n", td_dev->name, current->comm, current->pid);
+        return 0;
+}
+
+static ssize_t rtk_trace_read(struct file *filep, char __user *buf, size_t count, loff_t *pos)
+{
+	struct rtk_trace_dump_device *td_dev = container_of(filep->private_data, struct rtk_trace_dump_device, device);
+	size_t copy_size = 0;
+	int ret = 0;
+
+	if (*pos < td_dev->size) {
+		copy_size = td_dev->size - *pos;
+		copy_size = min(copy_size, count);
+
+		if (copy_to_user(buf, td_dev->last_buf + *pos, copy_size)) {
+			ret = -EFAULT;
+			goto dump_done;
+		}
+
+		*pos += copy_size;
+		count -= copy_size;
+		buf += copy_size;
+		if (count == 0)
+			return copy_size;
+	}
+
+dump_done:
+	*pos = 0;
+	return ret;
+}
+
+static const struct file_operations rtk_trace_file_ops = {
+	.open = rtk_trace_open,
+	.release = rtk_trace_release,
+	.read = rtk_trace_read,
+};
+
+int remove_vmap_info(void *va, int check_init)
+{
+	struct vmap_info_stat_t *info_stat = &vmap_info_stat;
+	struct rtk_trace_vmap_info *iter_info;
+	int i;
+
+	if (check_init && !atomic_read(&vmap_initialized))
+		return 0;
+
+	spin_lock(&info_stat->lock);
+	/* we start from the back since it's easier to found the match item*/
+	for (i = info_stat->count - 1 ; i >= 0 ; i--) {
+		iter_info = (struct rtk_trace_vmap_info *)info_stat->vmap_p + i;
+
+		if ((u64)va >= iter_info->va && (u64)va < (iter_info->va + iter_info->size))
+			break;
+	}
+
+	if (i < 0) {
+		WARN("Couldn't find record for va:%p\n", va);
+		spin_unlock(&info_stat->lock);
+		return -EINVAL;
+	} else if (i == info_stat->count - 1) {
+		/* record is at tail, simply clear the record */
+		memset_io(iter_info, 0, sizeof(struct rtk_trace_vmap_info));
+	} else {
+		memcpy_toio(iter_info, iter_info + 1, (info_stat->count - i - 1) * sizeof(struct rtk_trace_vmap_info));
+		iter_info = (struct rtk_trace_vmap_info *)info_stat->vmap_p + info_stat->count - 1;
+		memset_io(iter_info, 0, sizeof(struct rtk_trace_vmap_info));
+	}
+
+	info_stat->count--;
+	spin_unlock(&info_stat->lock);
+
+	return 0;
+}
+
+int inject_vmap_info(void *va, unsigned long size , phys_addr_t pa, int check_init)
+{
+	struct vmap_info_stat_t *info_stat = &vmap_info_stat;
+	struct rtk_trace_vmap_info *iter_info = info_stat->vmap_p;
+
+	if (check_init && !atomic_read(&vmap_initialized))
+		return 0;
+
+	if ((void*)(iter_info + info_stat->count) >= (info_stat->vmap_p + info_stat->vmap_size)) {
+		pr_err("%p exceed reserve buffer %p\n",
+			iter_info + info_stat->count, info_stat->vmap_p + info_stat->vmap_size);
+		BUG();
+	}
+
+	spin_lock(&info_stat->lock);
+	iter_info = iter_info + info_stat->count;
+	iter_info->va = (uint64_t)va;
+	iter_info->size = size;
+	iter_info->pa = pa;
+	iter_info->magic = VMAP_MAGIC;
+	info_stat->count++;
+	spin_unlock(&info_stat->lock);
+
+	return 0;
+}
+
+#define VM_VM_AREA      0x04 /* flag sync with mm/vmalloc.c */
+static int vmap_info_initial(void)
+{
+	struct vmap_area *va;
+	struct vm_struct *vm;
+
+	/* Copy current vmap info first */
+	external_vmap_area_lock();
+	list_for_each_entry(va, &vmap_area_list, list) {
+		/* vmap_area not-ready/invalid, vmalloc didn't use zalloc for vmap_area */
+		if (!(va->flags & VM_VM_AREA))
+			continue;
+
+		vm = va->vm;
+
+		/* There should be vm_strcut for each vmap_area right? */
+		if(!vm)
+			continue;
+
+		/* We're not intrested non-ioremapped region */
+		if (!(vm->flags & VM_IOREMAP))
+			continue;
+
+		/* vmap_area already been invalid?? */
+		if ((unsigned long)vm->addr < VMALLOC_START || (unsigned long)vm->addr > VMALLOC_END)
+			continue;
+
+		pr_debug("va:%p, size:%lu, pa:%p\n", vm->addr, vm->size, (void*)vm->phys_addr);
+		inject_vmap_info(vm->addr, vm->size, vm->phys_addr, 0);
+	}
+
+	/* OK, now all the vmap info should be recorded, turn flag on so
+	   all the vmap info would be recorded through ioremap */
+	atomic_set(&vmap_initialized, 1);
+	external_vmap_area_unlock();
+
+	return 0;
+}
+
+static int rtk_trace_probe(struct platform_device *pdev)
+{
+	struct resource *res = NULL, *res_vmap = NULL;
+	unsigned int cpu;
+	struct rtk_trace_dump_device *dump_device = NULL, *dump_device_vmap = NULL;
+	int release_vmap_res = 0;
+	int ret = 0;
+
+	if (WARN_ON(!(pdev->dev.of_node))) {
+		pr_err("%s, couldn't find node!\n", __func__);
+		return -ENODEV;
+	}
+
+	res = platform_get_resource_byname(pdev, IORESOURCE_MEM, "rtk_trace_res");
+
+	if (!res) {
+		pr_err("%s, resource not defined\n", __func__);
+		return -EINVAL;
+	}
+
+	rtk_trace.phys = res->start;
+	rtk_trace.size = resource_size(res);
+	rtk_trace.t_buf = ioremap(rtk_trace.phys, rtk_trace.size);
+
+	if (!rtk_trace.t_buf)
+		return -ENOMEM;
+
+	pr_info("phys:0x%llx, size:0x%x, t_buf:%p\n", rtk_trace.phys, rtk_trace.size, rtk_trace.t_buf);
+
+	rtk_trace.nentries = rtk_trace.size / sizeof(struct rtk_trace_layout);
+
+	/* Round this down to a power of 2 */
+	rtk_trace.nentries = __rounddown_pow_of_two(rtk_trace.nentries);
+
+	/* Back up old trace buffer */
+	dump_device = kzalloc(sizeof(struct rtk_trace_dump_device), GFP_KERNEL);
+
+	if (dump_device) {
+		strncpy(dump_device->name, MODULE_NAME, 32);
+		dump_device->last_buf = vmalloc(rtk_trace.size);
+		dump_device->size = rtk_trace.size;
+
+		if (dump_device->last_buf) {
+
+			dump_device->device.minor = MISC_DYNAMIC_MINOR;
+			dump_device->device.name = dump_device->name;
+			dump_device->device.fops = &rtk_trace_file_ops;
+			if (!(ret = misc_register(&dump_device->device))) {
+				memcpy_fromio(dump_device->last_buf, rtk_trace.t_buf, rtk_trace.size);
+			} else {
+				pr_err("misc device register fail!\n");
+				vfree(dump_device->last_buf);
+				kfree(dump_device);
+			}
+		} else {
+			pr_err("couldn't allocate last_buf\n");
+			kfree(dump_device);
+		}
+	} else {
+		pr_err("couldn't allocate dump_device\n");
+	}
+
+	/* Now, start vmap info region */
+	res_vmap = platform_get_resource_byname(pdev, IORESOURCE_MEM, "rtk_trace_vmap");
+
+	vmap_info_stat.vmap_p = NULL;
+	vmap_info_stat.vmap_size = 0;
+	vmap_info_stat.count = 0;
+	spin_lock_init(&vmap_info_stat.lock);
+
+	if (res_vmap) {
+
+		vmap_info_stat.vmap_p = ioremap(res_vmap->start, resource_size(res_vmap));
+		vmap_info_stat.vmap_size = resource_size(res_vmap);
+
+		if (!vmap_info_stat.vmap_p) {
+			pr_err("can't map region %p/%d\n", (void*)res_vmap->start, (int)resource_size(res_vmap));
+			release_vmap_res = 1;
+			goto skip_vmap;
+		}
+
+		dump_device_vmap = kzalloc(sizeof(struct rtk_trace_dump_device), GFP_KERNEL);
+
+		if (!dump_device_vmap) {
+			pr_err("can't allocate memory for dump_device_vmap\n");
+			release_vmap_res = 1;
+			goto skip_vmap;
+		}
+
+		dump_device_vmap->last_buf = vmalloc(vmap_info_stat.vmap_size);
+		dump_device_vmap->size = vmap_info_stat.vmap_size;
+
+		if (!dump_device_vmap->last_buf) {
+			pr_err("can't allocate memory for dump_device_vmap\n");
+			release_vmap_res = 1;
+			goto skip_vmap;
+		}
+
+		strncpy(dump_device_vmap->name, MODULE_NAME"_vmap", 32);
+		dump_device_vmap->device.minor = MISC_DYNAMIC_MINOR;
+		dump_device_vmap->device.name = dump_device_vmap->name;
+		dump_device_vmap->device.fops = &rtk_trace_file_ops;
+
+		if (!(ret = misc_register(&dump_device_vmap->device))) {
+			memcpy_fromio(dump_device_vmap->last_buf, vmap_info_stat.vmap_p, vmap_info_stat.vmap_size);
+		} else {
+			pr_err("misc-vmap register fail\n");
+			release_vmap_res = 1;
+			goto skip_vmap;
+		}
+		/* now the backup is done, start record current vmap info */
+		memset_io(vmap_info_stat.vmap_p, 0, vmap_info_stat.vmap_size);
+		vmap_info_initial();
+	}
+skip_vmap:
+	/* Now clean up trace buff content */
+	memset_io(rtk_trace.t_buf, 0, rtk_trace.size);
+
+	for_each_possible_cpu(cpu) {
+		atomic_t *a = &per_cpu(rtk_trace_idx_cpu, cpu);
+		atomic_set(a, cpu);
+	}
+	rtk_trace.step_size = num_possible_cpus();
+
+	atomic_notifier_chain_register(&panic_notifier_list,
+						&rtk_trace_panic_blk);
+	rtk_trace.initialized = 1;
+
+	if (release_vmap_res) {
+
+		if (vmap_info_stat.vmap_p)
+			iounmap(vmap_info_stat.vmap_p);
+
+		if (dump_device_vmap) {
+			if (dump_device_vmap->last_buf)
+				vfree(dump_device_vmap->last_buf);
+			kfree(dump_device_vmap);
+		}
+	}
+
+	return 0;
+}
+
+static struct of_device_id rtktrace_match_table[] = {
+	{.compatible = "Realtek,trace"},
+	{},
+};
+
+static struct platform_driver rtk_trace_driver = {
+	.driver         = {
+		.name = MODULE_NAME,
+		.owner = THIS_MODULE,
+		.of_match_table = rtktrace_match_table
+	},
+};
+
+static int __init rtk_trace_init(void)
+{
+	return platform_driver_probe(&rtk_trace_driver, rtk_trace_probe);
+}
+
+static void __exit rtk_trace_exit(void)
+{
+	platform_driver_unregister(&rtk_trace_driver);
+}
+module_init(rtk_trace_init)
+module_exit(rtk_trace_exit)
diff --git a/kernel/trace/trace.c b/kernel/trace/trace.c
index 901c7f1..f4c8a97 100644
--- a/kernel/trace/trace.c
+++ b/kernel/trace/trace.c
@@ -1125,6 +1125,7 @@ unsigned long nsecs_to_usecs(unsigned long nsecs)
 	{ trace_clock,			"perf",		1 },
 	{ ktime_get_mono_fast_ns,	"mono",		1 },
 	{ ktime_get_raw_fast_ns,	"mono_raw",	1 },
+	{ ktime_get_boot_fast_ns,	"boot",		1 },
 	ARCH_TRACE_CLOCKS
 };
 
@@ -1603,6 +1604,7 @@ void tracing_reset_all_online_cpus(void)
 
 #define SAVED_CMDLINES_DEFAULT 128
 #define NO_CMDLINE_MAP UINT_MAX
+static unsigned saved_tgids[SAVED_CMDLINES_DEFAULT];
 static arch_spinlock_t trace_cmdline_lock = __ARCH_SPIN_LOCK_UNLOCKED;
 struct saved_cmdlines_buffer {
 	unsigned map_pid_to_cmdline[PID_MAX_DEFAULT+1];
@@ -1841,7 +1843,7 @@ static int trace_save_cmdline(struct task_struct *tsk)
 	}
 
 	set_cmdline(idx, tsk->comm);
-
+	saved_tgids[idx] = tsk->tgid;
 	arch_spin_unlock(&trace_cmdline_lock);
 
 	return 1;
@@ -1884,6 +1886,25 @@ void trace_find_cmdline(int pid, char comm[])
 	preempt_enable();
 }
 
+int trace_find_tgid(int pid)
+{
+	unsigned map;
+	int tgid;
+
+	preempt_disable();
+	arch_spin_lock(&trace_cmdline_lock);
+	map = savedcmd->map_pid_to_cmdline[pid];
+	if (map != NO_CMDLINE_MAP)
+		tgid = saved_tgids[map];
+	else
+		tgid = -1;
+
+	arch_spin_unlock(&trace_cmdline_lock);
+	preempt_enable();
+
+	return tgid;
+}
+
 void tracing_record_cmdline(struct task_struct *tsk)
 {
 	if (atomic_read(&trace_record_cmdline_disabled) || !tracing_is_on())
@@ -2932,6 +2953,13 @@ static void print_func_help_header(struct trace_buffer *buf, struct seq_file *m)
 		    "#              | |       |          |         |\n");
 }
 
+static void print_func_help_header_tgid(struct trace_buffer *buf, struct seq_file *m)
+{
+	print_event_info(buf, m);
+	seq_puts(m, "#           TASK-PID    TGID   CPU#      TIMESTAMP  FUNCTION\n");
+	seq_puts(m, "#              | |        |      |          |         |\n");
+}
+
 static void print_func_help_header_irq(struct trace_buffer *buf, struct seq_file *m)
 {
 	print_event_info(buf, m);
@@ -2944,6 +2972,18 @@ static void print_func_help_header_irq(struct trace_buffer *buf, struct seq_file
 		    "#              | |       |   ||||       |         |\n");
 }
 
+static void print_func_help_header_irq_tgid(struct trace_buffer *buf, struct seq_file *m)
+{
+	print_event_info(buf, m);
+	seq_puts(m, "#                                      _-----=> irqs-off\n");
+	seq_puts(m, "#                                     / _----=> need-resched\n");
+	seq_puts(m, "#                                    | / _---=> hardirq/softirq\n");
+	seq_puts(m, "#                                    || / _--=> preempt-depth\n");
+	seq_puts(m, "#                                    ||| /     delay\n");
+	seq_puts(m, "#           TASK-PID    TGID   CPU#  ||||    TIMESTAMP  FUNCTION\n");
+	seq_puts(m, "#              | |        |      |   ||||       |         |\n");
+}
+
 void
 print_trace_header(struct seq_file *m, struct trace_iterator *iter)
 {
@@ -3017,13 +3057,14 @@ static void test_cpu_buff_start(struct trace_iterator *iter)
 	if (!(iter->iter_flags & TRACE_FILE_ANNOTATE))
 		return;
 
-	if (iter->started && cpumask_test_cpu(iter->cpu, iter->started))
+	if (cpumask_available(iter->started) &&
+	    cpumask_test_cpu(iter->cpu, iter->started))
 		return;
 
 	if (per_cpu_ptr(iter->trace_buffer->data, iter->cpu)->skipped_entries)
 		return;
 
-	if (iter->started)
+	if (cpumask_available(iter->started))
 		cpumask_set_cpu(iter->cpu, iter->started);
 
 	/* Don't print started cpu buffer for the first entry of the trace */
@@ -3256,9 +3297,15 @@ void trace_default_header(struct seq_file *m)
 	} else {
 		if (!(trace_flags & TRACE_ITER_VERBOSE)) {
 			if (trace_flags & TRACE_ITER_IRQ_INFO)
-				print_func_help_header_irq(iter->trace_buffer, m);
+				if (trace_flags & TRACE_ITER_TGID)
+					print_func_help_header_irq_tgid(iter->trace_buffer, m);
+				else
+					print_func_help_header_irq(iter->trace_buffer, m);
 			else
-				print_func_help_header(iter->trace_buffer, m);
+				if (trace_flags & TRACE_ITER_TGID)
+					print_func_help_header_tgid(iter->trace_buffer, m);
+				else
+					print_func_help_header(iter->trace_buffer, m);
 		}
 	}
 }
@@ -4589,6 +4636,50 @@ static void trace_insert_enum_map(struct module *mod,
 }
 
 static ssize_t
+tracing_saved_tgids_read(struct file *file, char __user *ubuf,
+				size_t cnt, loff_t *ppos)
+{
+	char *file_buf;
+	char *buf;
+	int len = 0;
+	int pid;
+	int i;
+
+	file_buf = kmalloc(SAVED_CMDLINES_DEFAULT*(16+1+16), GFP_KERNEL);
+	if (!file_buf)
+		return -ENOMEM;
+
+	buf = file_buf;
+
+	for (i = 0; i < SAVED_CMDLINES_DEFAULT; i++) {
+		int tgid;
+		int r;
+
+		pid = savedcmd->map_cmdline_to_pid[i];
+		if (pid == -1 || pid == NO_CMDLINE_MAP)
+			continue;
+
+		tgid = trace_find_tgid(pid);
+		r = sprintf(buf, "%d %d\n", pid, tgid);
+		buf += r;
+		len += r;
+	}
+
+	len = simple_read_from_buffer(ubuf, cnt, ppos,
+				      file_buf, len);
+
+	kfree(file_buf);
+
+	return len;
+}
+
+static const struct file_operations tracing_saved_tgids_fops = {
+	.open	= tracing_open_generic,
+	.read	= tracing_saved_tgids_read,
+	.llseek	= generic_file_llseek,
+};
+
+static ssize_t
 tracing_set_trace_read(struct file *filp, char __user *ubuf,
 		       size_t cnt, loff_t *ppos)
 {
@@ -7220,6 +7311,9 @@ static __init void create_trace_instances(struct dentry *d_tracer)
 	trace_create_file("trace_marker", 0220, d_tracer,
 			  tr, &tracing_mark_fops);
 
+	trace_create_file("saved_tgids", 0444, d_tracer,
+			  tr, &tracing_saved_tgids_fops);
+
 	trace_create_file("trace_clock", 0644, d_tracer, tr,
 			  &trace_clock_fops);
 
diff --git a/kernel/trace/trace.h b/kernel/trace/trace.h
index b0d8576..d4c6633 100644
--- a/kernel/trace/trace.h
+++ b/kernel/trace/trace.h
@@ -690,6 +690,7 @@ static inline void __trace_stack(struct trace_array *tr, unsigned long flags,
 
 extern void trace_find_cmdline(int pid, char comm[]);
 extern void trace_event_follow_fork(struct trace_array *tr, bool enable);
+extern int trace_find_tgid(int pid);
 
 #ifdef CONFIG_DYNAMIC_FTRACE
 extern unsigned long ftrace_update_tot_cnt;
@@ -1009,7 +1010,8 @@ extern int trace_get_user(struct trace_parser *parser, const char __user *ubuf,
 		FUNCTION_FLAGS					\
 		FGRAPH_FLAGS					\
 		STACK_FLAGS					\
-		BRANCH_FLAGS
+		BRANCH_FLAGS					\
+		C(TGID,			"print-tgid"),
 
 /*
  * By defining C, we can make TRACE_FLAGS a list of bit names
diff --git a/kernel/trace/trace_functions_graph.c b/kernel/trace/trace_functions_graph.c
index 01e7181..7461d51 100644
--- a/kernel/trace/trace_functions_graph.c
+++ b/kernel/trace/trace_functions_graph.c
@@ -65,6 +65,9 @@ struct fgraph_data {
 
 #define TRACE_GRAPH_INDENT	2
 
+/* Flag options */
+#define TRACE_GRAPH_PRINT_FLAT		0x80
+
 static unsigned int max_depth;
 
 static struct tracer_opt trace_opts[] = {
@@ -88,6 +91,8 @@ struct fgraph_data {
 	{ TRACER_OPT(sleep-time, TRACE_GRAPH_SLEEP_TIME) },
 	/* Include time within nested functions */
 	{ TRACER_OPT(graph-time, TRACE_GRAPH_GRAPH_TIME) },
+	/* Use standard trace formatting rather than hierarchical */
+	{ TRACER_OPT(funcgraph-flat, TRACE_GRAPH_PRINT_FLAT) },
 	{ } /* Empty entry */
 };
 
@@ -1246,6 +1251,9 @@ enum print_line_t
 	int cpu = iter->cpu;
 	int ret;
 
+	if (flags & TRACE_GRAPH_PRINT_FLAT)
+		return TRACE_TYPE_UNHANDLED;
+
 	if (data && per_cpu_ptr(data->cpu_data, cpu)->ignore) {
 		per_cpu_ptr(data->cpu_data, cpu)->ignore = 0;
 		return TRACE_TYPE_HANDLED;
@@ -1303,13 +1311,6 @@ enum print_line_t
 	return print_graph_function_flags(iter, tracer_flags.val);
 }
 
-static enum print_line_t
-print_graph_function_event(struct trace_iterator *iter, int flags,
-			   struct trace_event *event)
-{
-	return print_graph_function(iter);
-}
-
 static void print_lat_header(struct seq_file *s, u32 flags)
 {
 	static const char spaces[] = "                "	/* 16 spaces */
@@ -1378,6 +1379,11 @@ void print_graph_headers_flags(struct seq_file *s, u32 flags)
 	struct trace_iterator *iter = s->private;
 	struct trace_array *tr = iter->tr;
 
+	if (flags & TRACE_GRAPH_PRINT_FLAT) {
+		trace_default_header(s);
+		return;
+	}
+
 	if (!(tr->trace_flags & TRACE_ITER_CONTEXT_INFO))
 		return;
 
@@ -1459,19 +1465,6 @@ void graph_trace_close(struct trace_iterator *iter)
 	return 0;
 }
 
-static struct trace_event_functions graph_functions = {
-	.trace		= print_graph_function_event,
-};
-
-static struct trace_event graph_trace_entry_event = {
-	.type		= TRACE_GRAPH_ENT,
-	.funcs		= &graph_functions,
-};
-
-static struct trace_event graph_trace_ret_event = {
-	.type		= TRACE_GRAPH_RET,
-	.funcs		= &graph_functions
-};
 
 static struct tracer graph_trace __tracer_data = {
 	.name		= "function_graph",
@@ -1548,16 +1541,6 @@ static __init int init_graph_trace(void)
 {
 	max_bytes_for_cpu = snprintf(NULL, 0, "%d", nr_cpu_ids - 1);
 
-	if (!register_trace_event(&graph_trace_entry_event)) {
-		pr_warn("Warning: could not register graph trace events\n");
-		return 1;
-	}
-
-	if (!register_trace_event(&graph_trace_ret_event)) {
-		pr_warn("Warning: could not register graph trace events\n");
-		return 1;
-	}
-
 	return register_tracer(&graph_trace);
 }
 
diff --git a/kernel/trace/trace_irqsoff.c b/kernel/trace/trace_irqsoff.c
index 03cdff8..c180fe5 100644
--- a/kernel/trace/trace_irqsoff.c
+++ b/kernel/trace/trace_irqsoff.c
@@ -16,6 +16,10 @@
 
 #include "trace.h"
 
+#define CREATE_TRACE_POINTS
+#include <trace/events/preemptirq.h>
+
+#if defined(CONFIG_IRQSOFF_TRACER) || defined(CONFIG_PREEMPT_TRACER)
 static struct trace_array		*irqsoff_trace __read_mostly;
 static int				tracer_enabled __read_mostly;
 
@@ -451,63 +455,43 @@ void time_hardirqs_off(unsigned long a0, unsigned long a1)
 #else /* !CONFIG_PROVE_LOCKING */
 
 /*
- * Stubs:
- */
-
-void trace_softirqs_on(unsigned long ip)
-{
-}
-
-void trace_softirqs_off(unsigned long ip)
-{
-}
-
-inline void print_irqtrace_events(struct task_struct *curr)
-{
-}
-
-/*
  * We are only interested in hardirq on/off events:
  */
-void trace_hardirqs_on(void)
+static inline void tracer_hardirqs_on(void)
 {
 	if (!preempt_trace() && irq_trace())
 		stop_critical_timing(CALLER_ADDR0, CALLER_ADDR1);
 }
-EXPORT_SYMBOL(trace_hardirqs_on);
 
-void trace_hardirqs_off(void)
+static inline void tracer_hardirqs_off(void)
 {
 	if (!preempt_trace() && irq_trace())
 		start_critical_timing(CALLER_ADDR0, CALLER_ADDR1);
 }
-EXPORT_SYMBOL(trace_hardirqs_off);
 
-__visible void trace_hardirqs_on_caller(unsigned long caller_addr)
+static inline void tracer_hardirqs_on_caller(unsigned long caller_addr)
 {
 	if (!preempt_trace() && irq_trace())
 		stop_critical_timing(CALLER_ADDR0, caller_addr);
 }
-EXPORT_SYMBOL(trace_hardirqs_on_caller);
 
-__visible void trace_hardirqs_off_caller(unsigned long caller_addr)
+static inline void tracer_hardirqs_off_caller(unsigned long caller_addr)
 {
 	if (!preempt_trace() && irq_trace())
 		start_critical_timing(CALLER_ADDR0, caller_addr);
 }
-EXPORT_SYMBOL(trace_hardirqs_off_caller);
 
 #endif /* CONFIG_PROVE_LOCKING */
 #endif /*  CONFIG_IRQSOFF_TRACER */
 
 #ifdef CONFIG_PREEMPT_TRACER
-void trace_preempt_on(unsigned long a0, unsigned long a1)
+static inline void tracer_preempt_on(unsigned long a0, unsigned long a1)
 {
 	if (preempt_trace() && !irq_trace())
 		stop_critical_timing(a0, a1);
 }
 
-void trace_preempt_off(unsigned long a0, unsigned long a1)
+static inline void tracer_preempt_off(unsigned long a0, unsigned long a1)
 {
 	if (preempt_trace() && !irq_trace())
 		start_critical_timing(a0, a1);
@@ -769,3 +753,100 @@ __init static int init_irqsoff_tracer(void)
 	return 0;
 }
 core_initcall(init_irqsoff_tracer);
+#endif /* IRQSOFF_TRACER || PREEMPTOFF_TRACER */
+
+#ifndef CONFIG_IRQSOFF_TRACER
+static inline void tracer_hardirqs_on(void) { }
+static inline void tracer_hardirqs_off(void) { }
+static inline void tracer_hardirqs_on_caller(unsigned long caller_addr) { }
+static inline void tracer_hardirqs_off_caller(unsigned long caller_addr) { }
+#endif
+
+#ifndef CONFIG_PREEMPT_TRACER
+static inline void tracer_preempt_on(unsigned long a0, unsigned long a1) { }
+static inline void tracer_preempt_off(unsigned long a0, unsigned long a1) { }
+#endif
+
+/* Per-cpu variable to prevent redundant calls when IRQs already off */
+static DEFINE_PER_CPU(int, tracing_irq_cpu);
+
+#if defined(CONFIG_TRACE_IRQFLAGS) && !defined(CONFIG_PROVE_LOCKING)
+void trace_hardirqs_on(void)
+{
+	if (!this_cpu_read(tracing_irq_cpu))
+		return;
+
+	trace_irq_enable_rcuidle(CALLER_ADDR0, CALLER_ADDR1);
+	tracer_hardirqs_on();
+
+	this_cpu_write(tracing_irq_cpu, 0);
+}
+EXPORT_SYMBOL(trace_hardirqs_on);
+
+void trace_hardirqs_off(void)
+{
+	if (this_cpu_read(tracing_irq_cpu))
+		return;
+
+	this_cpu_write(tracing_irq_cpu, 1);
+
+	trace_irq_disable_rcuidle(CALLER_ADDR0, CALLER_ADDR1);
+	tracer_hardirqs_off();
+}
+EXPORT_SYMBOL(trace_hardirqs_off);
+
+__visible void trace_hardirqs_on_caller(unsigned long caller_addr)
+{
+	if (!this_cpu_read(tracing_irq_cpu))
+		return;
+
+	trace_irq_enable_rcuidle(CALLER_ADDR0, caller_addr);
+	tracer_hardirqs_on_caller(caller_addr);
+
+	this_cpu_write(tracing_irq_cpu, 0);
+}
+EXPORT_SYMBOL(trace_hardirqs_on_caller);
+
+__visible void trace_hardirqs_off_caller(unsigned long caller_addr)
+{
+	if (this_cpu_read(tracing_irq_cpu))
+		return;
+
+	this_cpu_write(tracing_irq_cpu, 1);
+
+	trace_irq_disable_rcuidle(CALLER_ADDR0, caller_addr);
+	tracer_hardirqs_off_caller(caller_addr);
+}
+EXPORT_SYMBOL(trace_hardirqs_off_caller);
+
+/*
+ * Stubs:
+ */
+
+void trace_softirqs_on(unsigned long ip)
+{
+}
+
+void trace_softirqs_off(unsigned long ip)
+{
+}
+
+inline void print_irqtrace_events(struct task_struct *curr)
+{
+}
+#endif
+
+#if defined(CONFIG_PREEMPT_TRACER) || \
+	(defined(CONFIG_DEBUG_PREEMPT) && defined(CONFIG_PREEMPTIRQ_EVENTS))
+void trace_preempt_on(unsigned long a0, unsigned long a1)
+{
+	trace_preempt_enable_rcuidle(a0, a1);
+	tracer_preempt_on(a0, a1);
+}
+
+void trace_preempt_off(unsigned long a0, unsigned long a1)
+{
+	trace_preempt_disable_rcuidle(a0, a1);
+	tracer_preempt_off(a0, a1);
+}
+#endif
diff --git a/kernel/trace/trace_output.c b/kernel/trace/trace_output.c
index 3fc2042..0346759 100644
--- a/kernel/trace/trace_output.c
+++ b/kernel/trace/trace_output.c
@@ -530,11 +530,21 @@ int trace_print_context(struct trace_iterator *iter)
 	unsigned long long t;
 	unsigned long secs, usec_rem;
 	char comm[TASK_COMM_LEN];
+	int tgid;
 
 	trace_find_cmdline(entry->pid, comm);
 
-	trace_seq_printf(s, "%16s-%-5d [%03d] ",
-			       comm, entry->pid, iter->cpu);
+	trace_seq_printf(s, "%16s-%-5d ", comm, entry->pid);
+
+	if (tr->trace_flags & TRACE_ITER_TGID) {
+		tgid = trace_find_tgid(entry->pid);
+		if (tgid < 0)
+			trace_seq_puts(s, "(-----) ");
+		else
+			trace_seq_printf(s, "(%5d) ", tgid);
+	}
+
+	trace_seq_printf(s, "[%03d] ", iter->cpu);
 
 	if (tr->trace_flags & TRACE_ITER_IRQ_INFO)
 		trace_print_lat_fmt(s, entry);
@@ -849,6 +859,174 @@ static enum print_line_t trace_fn_bin(struct trace_iterator *iter, int flags,
 	.funcs		= &trace_fn_funcs,
 };
 
+/* TRACE_GRAPH_ENT */
+static enum print_line_t trace_graph_ent_trace(struct trace_iterator *iter, int flags,
+					struct trace_event *event)
+{
+	struct trace_seq *s = &iter->seq;
+	struct ftrace_graph_ent_entry *field;
+
+	trace_assign_type(field, iter->ent);
+
+	trace_seq_puts(s, "graph_ent: func=");
+	if (trace_seq_has_overflowed(s))
+		return TRACE_TYPE_PARTIAL_LINE;
+
+	if (!seq_print_ip_sym(s, field->graph_ent.func, flags))
+		return TRACE_TYPE_PARTIAL_LINE;
+
+	trace_seq_puts(s, "\n");
+	if (trace_seq_has_overflowed(s))
+		return TRACE_TYPE_PARTIAL_LINE;
+
+	return TRACE_TYPE_HANDLED;
+}
+
+static enum print_line_t trace_graph_ent_raw(struct trace_iterator *iter, int flags,
+				      struct trace_event *event)
+{
+	struct ftrace_graph_ent_entry *field;
+
+	trace_assign_type(field, iter->ent);
+
+	trace_seq_printf(&iter->seq, "%lx %d\n",
+			      field->graph_ent.func,
+			      field->graph_ent.depth);
+	if (trace_seq_has_overflowed(&iter->seq))
+		return TRACE_TYPE_PARTIAL_LINE;
+
+	return TRACE_TYPE_HANDLED;
+}
+
+static enum print_line_t trace_graph_ent_hex(struct trace_iterator *iter, int flags,
+				      struct trace_event *event)
+{
+	struct ftrace_graph_ent_entry *field;
+	struct trace_seq *s = &iter->seq;
+
+	trace_assign_type(field, iter->ent);
+
+	SEQ_PUT_HEX_FIELD(s, field->graph_ent.func);
+	SEQ_PUT_HEX_FIELD(s, field->graph_ent.depth);
+
+	return TRACE_TYPE_HANDLED;
+}
+
+static enum print_line_t trace_graph_ent_bin(struct trace_iterator *iter, int flags,
+				      struct trace_event *event)
+{
+	struct ftrace_graph_ent_entry *field;
+	struct trace_seq *s = &iter->seq;
+
+	trace_assign_type(field, iter->ent);
+
+	SEQ_PUT_FIELD(s, field->graph_ent.func);
+	SEQ_PUT_FIELD(s, field->graph_ent.depth);
+
+	return TRACE_TYPE_HANDLED;
+}
+
+static struct trace_event_functions trace_graph_ent_funcs = {
+	.trace		= trace_graph_ent_trace,
+	.raw		= trace_graph_ent_raw,
+	.hex		= trace_graph_ent_hex,
+	.binary		= trace_graph_ent_bin,
+};
+
+static struct trace_event trace_graph_ent_event = {
+	.type		= TRACE_GRAPH_ENT,
+	.funcs		= &trace_graph_ent_funcs,
+};
+
+/* TRACE_GRAPH_RET */
+static enum print_line_t trace_graph_ret_trace(struct trace_iterator *iter, int flags,
+					struct trace_event *event)
+{
+	struct trace_seq *s = &iter->seq;
+	struct trace_entry *entry = iter->ent;
+	struct ftrace_graph_ret_entry *field;
+
+	trace_assign_type(field, entry);
+
+	trace_seq_puts(s, "graph_ret: func=");
+	if (trace_seq_has_overflowed(s))
+		return TRACE_TYPE_PARTIAL_LINE;
+
+	if (!seq_print_ip_sym(s, field->ret.func, flags))
+		return TRACE_TYPE_PARTIAL_LINE;
+
+	trace_seq_puts(s, "\n");
+	if (trace_seq_has_overflowed(s))
+		return TRACE_TYPE_PARTIAL_LINE;
+
+	return TRACE_TYPE_HANDLED;
+}
+
+static enum print_line_t trace_graph_ret_raw(struct trace_iterator *iter, int flags,
+				      struct trace_event *event)
+{
+	struct ftrace_graph_ret_entry *field;
+
+	trace_assign_type(field, iter->ent);
+
+	trace_seq_printf(&iter->seq, "%lx %lld %lld %ld %d\n",
+			      field->ret.func,
+			      field->ret.calltime,
+			      field->ret.rettime,
+			      field->ret.overrun,
+			      field->ret.depth);
+	if (trace_seq_has_overflowed(&iter->seq))
+		return TRACE_TYPE_PARTIAL_LINE;
+
+	return TRACE_TYPE_HANDLED;
+}
+
+static enum print_line_t trace_graph_ret_hex(struct trace_iterator *iter, int flags,
+				      struct trace_event *event)
+{
+	struct ftrace_graph_ret_entry *field;
+	struct trace_seq *s = &iter->seq;
+
+	trace_assign_type(field, iter->ent);
+
+	SEQ_PUT_HEX_FIELD(s, field->ret.func);
+	SEQ_PUT_HEX_FIELD(s, field->ret.calltime);
+	SEQ_PUT_HEX_FIELD(s, field->ret.rettime);
+	SEQ_PUT_HEX_FIELD(s, field->ret.overrun);
+	SEQ_PUT_HEX_FIELD(s, field->ret.depth);
+
+	return TRACE_TYPE_HANDLED;
+}
+
+static enum print_line_t trace_graph_ret_bin(struct trace_iterator *iter, int flags,
+				      struct trace_event *event)
+{
+	struct ftrace_graph_ret_entry *field;
+	struct trace_seq *s = &iter->seq;
+
+	trace_assign_type(field, iter->ent);
+
+	SEQ_PUT_FIELD(s, field->ret.func);
+	SEQ_PUT_FIELD(s, field->ret.calltime);
+	SEQ_PUT_FIELD(s, field->ret.rettime);
+	SEQ_PUT_FIELD(s, field->ret.overrun);
+	SEQ_PUT_FIELD(s, field->ret.depth);
+
+	return TRACE_TYPE_HANDLED;
+}
+
+static struct trace_event_functions trace_graph_ret_funcs = {
+	.trace		= trace_graph_ret_trace,
+	.raw		= trace_graph_ret_raw,
+	.hex		= trace_graph_ret_hex,
+	.binary		= trace_graph_ret_bin,
+};
+
+static struct trace_event trace_graph_ret_event = {
+	.type		= TRACE_GRAPH_RET,
+	.funcs		= &trace_graph_ret_funcs,
+};
+
 /* TRACE_CTX an TRACE_WAKE */
 static enum print_line_t trace_ctxwake_print(struct trace_iterator *iter,
 					     char *delim)
@@ -1291,6 +1469,8 @@ static enum print_line_t trace_print_raw(struct trace_iterator *iter, int flags,
 
 static struct trace_event *events[] __initdata = {
 	&trace_fn_event,
+	&trace_graph_ent_event,
+	&trace_graph_ret_event,
 	&trace_ctx_event,
 	&trace_wake_event,
 	&trace_stack_event,
diff --git a/kernel/trace/trace_printk.c b/kernel/trace/trace_printk.c
index ad1d616..e82cff5 100644
--- a/kernel/trace/trace_printk.c
+++ b/kernel/trace/trace_printk.c
@@ -304,7 +304,7 @@ static int t_show(struct seq_file *m, void *v)
 	if (!*fmt)
 		return 0;
 
-	seq_printf(m, "0x%lx : \"", *(unsigned long *)fmt);
+	seq_printf(m, "0x%lx : \"", 0L);
 
 	/*
 	 * Tabs and new lines need to be converted.
diff --git a/kernel/user.c b/kernel/user.c
index b069ccb..41e94e4 100644
--- a/kernel/user.c
+++ b/kernel/user.c
@@ -16,6 +16,7 @@
 #include <linux/interrupt.h>
 #include <linux/export.h>
 #include <linux/user_namespace.h>
+#include <linux/proc_fs.h>
 #include <linux/proc_ns.h>
 
 /*
@@ -201,6 +202,7 @@ struct user_struct *alloc_uid(kuid_t uid)
 		}
 		spin_unlock_irq(&uidhash_lock);
 	}
+	proc_register_uid(uid);
 
 	return up;
 
@@ -222,6 +224,7 @@ static int __init uid_cache_init(void)
 	spin_lock_irq(&uidhash_lock);
 	uid_hash_insert(&root_user, uidhashentry(GLOBAL_ROOT_UID));
 	spin_unlock_irq(&uidhash_lock);
+	proc_register_uid(GLOBAL_ROOT_UID);
 
 	return 0;
 }
diff --git a/kernel/workqueue.c b/kernel/workqueue.c
index 1961dd4..279a1b9 100644
--- a/kernel/workqueue.c
+++ b/kernel/workqueue.c
@@ -4824,6 +4824,9 @@ bool freeze_workqueues_busy(void)
 		for_each_pwq(pwq, wq) {
 			WARN_ON_ONCE(pwq->nr_active < 0);
 			if (pwq->nr_active) {
+				#ifdef CONFIG_ARCH_RTD129x
+				printk(KERN_ERR "[PM DEBUG] busy wq = %s\n", wq->name);
+				#endif /*CONFIG_ARCH_RTD129x*/
 				busy = true;
 				rcu_read_unlock_sched();
 				goto out_unlock;
diff --git a/lib/Kconfig.debug b/lib/Kconfig.debug
index 58a22ca..ba7670c 100644
--- a/lib/Kconfig.debug
+++ b/lib/Kconfig.debug
@@ -922,6 +922,15 @@ config SCHED_INFO
 	bool
 	default n
 
+config PANIC_ON_RT_THROTTLING
+	bool "Panic on RT throttling"
+	help
+	  Say Y here to enable the kernel to panic when a realtime
+	  runqueue is throttled. This may be useful for detecting
+	  and debugging RT throttling issues.
+
+	  Say N if unsure.
+
 config SCHEDSTATS
 	bool "Collect scheduler statistics"
 	depends on DEBUG_KERNEL && PROC_FS
diff --git a/lib/debugobjects.c b/lib/debugobjects.c
index 056052dc..19572a4 100644
--- a/lib/debugobjects.c
+++ b/lib/debugobjects.c
@@ -293,10 +293,13 @@ static void debug_object_is_on_stack(void *addr, int onstack)
 		return;
 
 	limit++;
-	if (is_on_stack)
-		pr_warn("object is on stack, but not annotated\n");
-	else
-		pr_warn("object is not on stack, but annotated\n");
+	if (is_on_stack) {
+		pr_warn("object %p is on stack %p, but NOT annotated\n", addr,
+				task_stack_page(current));
+	} else {
+		pr_warn("object %p is NOT on stack %p, but annotated\n", addr,
+				task_stack_page(current));
+	}
 	WARN_ON(1);
 }
 
diff --git a/lib/digsig.c b/lib/digsig.c
index a876156..6ba6fcd 100644
--- a/lib/digsig.c
+++ b/lib/digsig.c
@@ -85,7 +85,7 @@ static int digsig_verify_rsa(struct key *key,
 	struct pubkey_hdr *pkh;
 
 	down_read(&key->sem);
-	ukp = user_key_payload(key);
+	ukp = user_key_payload_locked(key);
 
 	if (!ukp) {
 		/* key was revoked before we acquired its semaphore */
diff --git a/lib/iomap.c b/lib/iomap.c
index fc3dcb4..866a4fb 100644
--- a/lib/iomap.c
+++ b/lib/iomap.c
@@ -7,6 +7,7 @@
 #include <linux/io.h>
 
 #include <linux/export.h>
+#include <linux/rtk_trace.h>
 
 /*
  * Read/write from/to an (offsettable) iomem cookie. It might be a PIO
@@ -70,26 +71,31 @@ static void bad_io_access(unsigned long port, const char *access)
 
 unsigned int ioread8(void __iomem *addr)
 {
-	IO_COND(addr, return inb(port), return readb(addr));
+	uncached_logk_pc(LOGK_READL, __builtin_return_address(0), addr);
+	IO_COND(addr, return inb(port), return readb_no_log(addr));
 	return 0xff;
 }
 unsigned int ioread16(void __iomem *addr)
 {
-	IO_COND(addr, return inw(port), return readw(addr));
+	uncached_logk_pc(LOGK_READL, __builtin_return_address(0), addr);
+	IO_COND(addr, return inw(port), return readw_no_log(addr));
 	return 0xffff;
 }
 unsigned int ioread16be(void __iomem *addr)
 {
+	uncached_logk_pc(LOGK_READL, __builtin_return_address(0), addr);
 	IO_COND(addr, return pio_read16be(port), return mmio_read16be(addr));
 	return 0xffff;
 }
 unsigned int ioread32(void __iomem *addr)
 {
-	IO_COND(addr, return inl(port), return readl(addr));
+	uncached_logk_pc(LOGK_READL, __builtin_return_address(0), addr);
+	IO_COND(addr, return inl(port), return readl_no_log(addr));
 	return 0xffffffff;
 }
 unsigned int ioread32be(void __iomem *addr)
 {
+	uncached_logk_pc(LOGK_READL, __builtin_return_address(0), addr);
 	IO_COND(addr, return pio_read32be(port), return mmio_read32be(addr));
 	return 0xffffffff;
 }
@@ -111,22 +117,27 @@ unsigned int ioread32be(void __iomem *addr)
 
 void iowrite8(u8 val, void __iomem *addr)
 {
-	IO_COND(addr, outb(val,port), writeb(val, addr));
+	uncached_logk_pc(LOGK_WRITEL, __builtin_return_address(0), addr);
+	IO_COND(addr, outb(val,port), writeb_no_log(val, addr));
 }
 void iowrite16(u16 val, void __iomem *addr)
 {
-	IO_COND(addr, outw(val,port), writew(val, addr));
+	uncached_logk_pc(LOGK_WRITEL, __builtin_return_address(0), addr);
+	IO_COND(addr, outw(val,port), writew_no_log(val, addr));
 }
 void iowrite16be(u16 val, void __iomem *addr)
 {
+	uncached_logk_pc(LOGK_WRITEL, __builtin_return_address(0), addr);
 	IO_COND(addr, pio_write16be(val,port), mmio_write16be(val, addr));
 }
 void iowrite32(u32 val, void __iomem *addr)
 {
-	IO_COND(addr, outl(val,port), writel(val, addr));
+	uncached_logk_pc(LOGK_WRITEL, __builtin_return_address(0), addr);
+	IO_COND(addr, outl(val,port), writel_no_log(val, addr));
 }
 void iowrite32be(u32 val, void __iomem *addr)
 {
+	uncached_logk_pc(LOGK_WRITEL, __builtin_return_address(0), addr);
 	IO_COND(addr, pio_write32be(val,port), mmio_write32be(val, addr));
 }
 EXPORT_SYMBOL(iowrite8);
diff --git a/lib/kobject_uevent.c b/lib/kobject_uevent.c
index f6c2c1e..cddca8c 100644
--- a/lib/kobject_uevent.c
+++ b/lib/kobject_uevent.c
@@ -50,6 +50,11 @@ struct uevent_sock {
 	[KOBJ_MOVE] =		"move",
 	[KOBJ_ONLINE] =		"online",
 	[KOBJ_OFFLINE] =	"offline",
+#if IS_ENABLED(CONFIG_R8168) || IS_ENABLED(CONFIG_R8169SOC) || \
+	IS_ENABLED(CONFIG_RTD_1295_HWNAT)
+	[KOBJ_LINKUP] =		"linkup",
+	[KOBJ_LINKDOWN] =	"linkdown",
+#endif
 };
 
 /**
diff --git a/lib/scatterlist.c b/lib/scatterlist.c
index 004fc70..a854cc3 100644
--- a/lib/scatterlist.c
+++ b/lib/scatterlist.c
@@ -496,17 +496,18 @@ static bool sg_miter_get_next_page(struct sg_mapping_iter *miter)
 {
 	if (!miter->__remaining) {
 		struct scatterlist *sg;
-		unsigned long pgoffset;
 
 		if (!__sg_page_iter_next(&miter->piter))
 			return false;
 
 		sg = miter->piter.sg;
-		pgoffset = miter->piter.sg_pgoffset;
 
-		miter->__offset = pgoffset ? 0 : sg->offset;
+		miter->__offset = miter->piter.sg_pgoffset ? 0 : sg->offset;
+		miter->piter.sg_pgoffset += miter->__offset >> PAGE_SHIFT;
+		miter->__offset &= PAGE_SIZE - 1;
 		miter->__remaining = sg->offset + sg->length -
-				(pgoffset << PAGE_SHIFT) - miter->__offset;
+				     (miter->piter.sg_pgoffset << PAGE_SHIFT) -
+				     miter->__offset;
 		miter->__remaining = min_t(unsigned long, miter->__remaining,
 					   PAGE_SIZE - miter->__offset);
 	}
diff --git a/lib/string.c b/lib/string.c
index ed83562..6d1504c 100644
--- a/lib/string.c
+++ b/lib/string.c
@@ -845,6 +845,27 @@ char *strnstr(const char *s1, const char *s2, size_t len)
 	return NULL;
 }
 EXPORT_SYMBOL(strnstr);
+
+/**
+ * memmem - Find the first length-limited substring in a length-limited string
+ * @s1: The string to be searched
+ * @len1: the maximum number of characters to search
+ * @s2: The string to search for
+ * @len2: the length of the string being searched
+ */
+void *memmem(const void *s1, size_t len1, const void *s2, size_t len2)
+{
+    if (!len2)
+        return (void *)s1;
+    while (len1 >= len2) {
+        len1--;
+        if (!memcmp(s1, s2, len2))
+            return (void *)s1;
+        s1++;
+    }
+    return NULL;
+}
+EXPORT_SYMBOL(memmem);
 #endif
 
 #ifndef __HAVE_ARCH_MEMCHR
diff --git a/lib/swiotlb.c b/lib/swiotlb.c
index b7812df..e8abdb2 100644
--- a/lib/swiotlb.c
+++ b/lib/swiotlb.c
@@ -38,6 +38,9 @@
 #include <linux/bootmem.h>
 #include <linux/iommu-helper.h>
 
+#include <linux/of.h>
+#include <linux/of_address.h>
+
 #define CREATE_TRACE_POINTS
 #include <trace/events/swiotlb.h>
 
@@ -99,6 +102,11 @@
 static int __init
 setup_io_tlb_npages(char *str)
 {
+	if (io_tlb_nslabs) {
+		/* might be initalized in early_init_dt_check_for_swiotlb() */
+		return 0;
+	}
+	swiotlb_force = SWIOTLB_NORMAL;
 	if (isdigit(*str)) {
 		io_tlb_nslabs = simple_strtoul(str, &str, 0);
 		/* avoid tail segment of size < IO_TLB_SEGSIZE */
@@ -124,6 +132,15 @@ unsigned long swiotlb_nr_tbl(void)
 }
 EXPORT_SYMBOL_GPL(swiotlb_nr_tbl);
 
+void swiotlb_init_variable(unsigned long of_io_tlb_nslabs, enum swiotlb_force of_swiotlb_force)
+{
+	io_tlb_nslabs = of_io_tlb_nslabs;
+	swiotlb_force = of_swiotlb_force;
+	/* avoid tail segment of size < IO_TLB_SEGSIZE */
+	io_tlb_nslabs = ALIGN(io_tlb_nslabs, IO_TLB_SEGSIZE);
+}
+EXPORT_SYMBOL_GPL(swiotlb_init_variable);
+
 /* default to 64MB */
 #define IO_TLB_DEFAULT_SIZE (64UL<<20)
 unsigned long swiotlb_size_or_default(void)
diff --git a/lib/test_kasan.c b/lib/test_kasan.c
index fbdf879..8fcad61 100644
--- a/lib/test_kasan.c
+++ b/lib/test_kasan.c
@@ -19,6 +19,7 @@
 #include <linux/string.h>
 #include <linux/uaccess.h>
 #include <linux/module.h>
+#include <linux/kasan.h>
 
 /*
  * Note: test functions are marked noinline so that their names appear in
@@ -439,8 +440,34 @@ static noinline void __init use_after_scope_test(void)
 	p[1023] = 1;
 }
 
+static noinline void __init kasan_alloca_oob_left(void)
+{
+	volatile int i = 10;
+	char alloca_array[i];
+	char *p = alloca_array - 1;
+
+	pr_info("out-of-bounds to left on alloca\n");
+	*(volatile char *)p;
+}
+
+static noinline void __init kasan_alloca_oob_right(void)
+{
+	volatile int i = 10;
+	char alloca_array[i];
+	char *p = alloca_array + i;
+
+	pr_info("out-of-bounds to right on alloca\n");
+	*(volatile char *)p;
+}
+
 static int __init kmalloc_tests_init(void)
 {
+	/*
+	 * Temporarily enable multi-shot mode. Otherwise, we'd only get a
+	 * report for the first case.
+	 */
+	bool multishot = kasan_save_enable_multi_shot();
+
 	kmalloc_oob_right();
 	kmalloc_oob_left();
 	kmalloc_node_oob_right();
@@ -462,9 +489,14 @@ static int __init kmalloc_tests_init(void)
 	kmem_cache_oob();
 	kasan_stack_oob();
 	kasan_global_oob();
+	kasan_alloca_oob_left();
+	kasan_alloca_oob_right();
 	ksize_unpoisons_memory();
 	copy_user_test();
 	use_after_scope_test();
+
+	kasan_restore_multi_shot(multishot);
+
 	return -EAGAIN;
 }
 
diff --git a/mm/cma.c b/mm/cma.c
index 397687f..1c0b819 100644
--- a/mm/cma.c
+++ b/mm/cma.c
@@ -297,6 +297,7 @@ int __init cma_declare_contiguous(phys_addr_t base,
 		limit = memblock_end;
 
 	/* Reserve memory */
+	pr_info("size %pa, base %pa, fixed(%d)\n", &size, &base, fixed);
 	if (fixed) {
 		if (memblock_is_region_reserved(base, size) ||
 		    memblock_reserve(base, size) < 0) {
diff --git a/mm/filemap.c b/mm/filemap.c
index 6d2f561..8f36d9c 100644
--- a/mm/filemap.c
+++ b/mm/filemap.c
@@ -437,19 +437,17 @@ static int __filemap_fdatawait_range(struct address_space *mapping,
 		goto out;
 
 	pagevec_init(&pvec, 0);
-	while ((index <= end) &&
-			(nr_pages = pagevec_lookup_tag(&pvec, mapping, &index,
-			PAGECACHE_TAG_WRITEBACK,
-			min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1)) != 0) {
+	while (index <= end) {
 		unsigned i;
 
+		nr_pages = pagevec_lookup_range_tag(&pvec, mapping, &index,
+				end, PAGECACHE_TAG_WRITEBACK);
+		if (!nr_pages)
+			break;
+
 		for (i = 0; i < nr_pages; i++) {
 			struct page *page = pvec.pages[i];
 
-			/* until radix tree lookup accepts end_index */
-			if (page->index > end)
-				continue;
-
 			wait_on_page_writeback(page);
 			if (TestClearPageError(page))
 				ret = -EIO;
@@ -1491,9 +1489,10 @@ unsigned find_get_pages_contig(struct address_space *mapping, pgoff_t index,
 EXPORT_SYMBOL(find_get_pages_contig);
 
 /**
- * find_get_pages_tag - find and return pages that match @tag
+ * find_get_pages_range_tag - find and return pages in given range matching @tag
  * @mapping:	the address_space to search
  * @index:	the starting page index
+ * @end:	The final page index (inclusive)
  * @tag:	the tag index
  * @nr_pages:	the maximum number of pages
  * @pages:	where the resulting pages are placed
@@ -1501,8 +1500,9 @@ unsigned find_get_pages_contig(struct address_space *mapping, pgoff_t index,
  * Like find_get_pages, except we only return pages which are tagged with
  * @tag.   We update @index to index the next page for the traversal.
  */
-unsigned find_get_pages_tag(struct address_space *mapping, pgoff_t *index,
-			int tag, unsigned int nr_pages, struct page **pages)
+unsigned find_get_pages_range_tag(struct address_space *mapping, pgoff_t *index,
+			pgoff_t end, int tag, unsigned int nr_pages,
+			struct page **pages)
 {
 	struct radix_tree_iter iter;
 	void **slot;
@@ -1515,6 +1515,9 @@ unsigned find_get_pages_tag(struct address_space *mapping, pgoff_t *index,
 	radix_tree_for_each_tagged(slot, &mapping->page_tree,
 				   &iter, *index, tag) {
 		struct page *head, *page;
+
+		if (iter.index > end)
+			break;
 repeat:
 		page = radix_tree_deref_slot(slot);
 		if (unlikely(!page))
@@ -1556,18 +1559,28 @@ unsigned find_get_pages_tag(struct address_space *mapping, pgoff_t *index,
 		}
 
 		pages[ret] = page;
-		if (++ret == nr_pages)
-			break;
+		if (++ret == nr_pages) {
+			*index = pages[ret - 1]->index + 1;
+			goto out;
+		}
 	}
 
+	/*
+	 * We come here when we got at @end. We take care to not overflow the
+	 * index @index as it confuses some of the callers. This breaks the
+	 * iteration when there is page at index -1 but that is already broken
+	 * anyway.
+	 */
+	if (end == (pgoff_t)-1)
+		*index = (pgoff_t)-1;
+	else
+		*index = end + 1;
+out:
 	rcu_read_unlock();
 
-	if (ret)
-		*index = pages[ret - 1]->index + 1;
-
 	return ret;
 }
-EXPORT_SYMBOL(find_get_pages_tag);
+EXPORT_SYMBOL(find_get_pages_range_tag);
 
 /**
  * find_get_entries_tag - find and return entries that match @tag
@@ -2387,7 +2400,7 @@ static struct page *wait_on_page_read(struct page *page)
 
 static struct page *do_read_cache_page(struct address_space *mapping,
 				pgoff_t index,
-				int (*filler)(void *, struct page *),
+				int (*filler)(struct file *, struct page *),
 				void *data,
 				gfp_t gfp)
 {
@@ -2494,7 +2507,7 @@ static struct page *do_read_cache_page(struct address_space *mapping,
  */
 struct page *read_cache_page(struct address_space *mapping,
 				pgoff_t index,
-				int (*filler)(void *, struct page *),
+				int (*filler)(struct file *, struct page *),
 				void *data)
 {
 	return do_read_cache_page(mapping, index, filler, data, mapping_gfp_mask(mapping));
@@ -2516,7 +2529,7 @@ struct page *read_cache_page_gfp(struct address_space *mapping,
 				pgoff_t index,
 				gfp_t gfp)
 {
-	filler_t *filler = (filler_t *)mapping->a_ops->readpage;
+	filler_t *filler = mapping->a_ops->readpage;
 
 	return do_read_cache_page(mapping, index, filler, NULL, gfp);
 }
diff --git a/mm/kasan/kasan.c b/mm/kasan/kasan.c
index 73c2581..7d78b5f 100644
--- a/mm/kasan/kasan.c
+++ b/mm/kasan/kasan.c
@@ -39,6 +39,16 @@
 #include "kasan.h"
 #include "../slab.h"
 
+void kasan_enable_current(void)
+{
+	current->kasan_depth++;
+}
+
+void kasan_disable_current(void)
+{
+	current->kasan_depth--;
+}
+
 /*
  * Poisons the shadow memory for 'size' bytes starting from 'addr'.
  * Memory addresses should be aligned to KASAN_SHADOW_SCALE_SIZE.
@@ -428,7 +438,7 @@ void kasan_cache_shrink(struct kmem_cache *cache)
 	quarantine_remove_cache(cache);
 }
 
-void kasan_cache_destroy(struct kmem_cache *cache)
+void kasan_cache_shutdown(struct kmem_cache *cache)
 {
 	quarantine_remove_cache(cache);
 }
@@ -559,7 +569,8 @@ bool kasan_slab_free(struct kmem_cache *cache, void *object)
 
 	shadow_byte = READ_ONCE(*(s8 *)kasan_mem_to_shadow(object));
 	if (shadow_byte < 0 || shadow_byte >= KASAN_SHADOW_SCALE_SIZE) {
-		kasan_report_double_free(cache, object, shadow_byte);
+		kasan_report_double_free(cache, object,
+				__builtin_return_address(1));
 		return true;
 	}
 
@@ -783,6 +794,55 @@ void __asan_unpoison_stack_memory(const void *addr, size_t size)
 }
 EXPORT_SYMBOL(__asan_unpoison_stack_memory);
 
+/* Emitted by compiler to poison alloca()ed objects. */
+void __asan_alloca_poison(unsigned long addr, size_t size)
+{
+	size_t rounded_up_size = round_up(size, KASAN_SHADOW_SCALE_SIZE);
+	size_t padding_size = round_up(size, KASAN_ALLOCA_REDZONE_SIZE) -
+			rounded_up_size;
+	size_t rounded_down_size = round_down(size, KASAN_SHADOW_SCALE_SIZE);
+
+	const void *left_redzone = (const void *)(addr -
+			KASAN_ALLOCA_REDZONE_SIZE);
+	const void *right_redzone = (const void *)(addr + rounded_up_size);
+
+	WARN_ON(!IS_ALIGNED(addr, KASAN_ALLOCA_REDZONE_SIZE));
+
+	kasan_unpoison_shadow((const void *)(addr + rounded_down_size),
+			      size - rounded_down_size);
+	kasan_poison_shadow(left_redzone, KASAN_ALLOCA_REDZONE_SIZE,
+			KASAN_ALLOCA_LEFT);
+	kasan_poison_shadow(right_redzone,
+			padding_size + KASAN_ALLOCA_REDZONE_SIZE,
+			KASAN_ALLOCA_RIGHT);
+}
+EXPORT_SYMBOL(__asan_alloca_poison);
+
+/* Emitted by compiler to unpoison alloca()ed areas when the stack unwinds. */
+void __asan_allocas_unpoison(const void *stack_top, const void *stack_bottom)
+{
+	if (unlikely(!stack_top || stack_top > stack_bottom))
+		return;
+
+	kasan_unpoison_shadow(stack_top, stack_bottom - stack_top);
+}
+EXPORT_SYMBOL(__asan_allocas_unpoison);
+
+/* Emitted by the compiler to [un]poison local variables. */
+#define DEFINE_ASAN_SET_SHADOW(byte) \
+	void __asan_set_shadow_##byte(const void *addr, size_t size)	\
+	{								\
+		__memset((void *)addr, 0x##byte, size);			\
+	}								\
+	EXPORT_SYMBOL(__asan_set_shadow_##byte)
+
+DEFINE_ASAN_SET_SHADOW(00);
+DEFINE_ASAN_SET_SHADOW(f1);
+DEFINE_ASAN_SET_SHADOW(f2);
+DEFINE_ASAN_SET_SHADOW(f3);
+DEFINE_ASAN_SET_SHADOW(f5);
+DEFINE_ASAN_SET_SHADOW(f8);
+
 #ifdef CONFIG_MEMORY_HOTPLUG
 static int kasan_mem_notifier(struct notifier_block *nb,
 			unsigned long action, void *data)
diff --git a/mm/kasan/kasan.h b/mm/kasan/kasan.h
index 1c260e6..d9cf9e2 100644
--- a/mm/kasan/kasan.h
+++ b/mm/kasan/kasan.h
@@ -23,6 +23,14 @@
 #define KASAN_STACK_PARTIAL     0xF4
 #define KASAN_USE_AFTER_SCOPE   0xF8
 
+/*
+ * alloca redzone shadow values
+ */
+#define KASAN_ALLOCA_LEFT	0xCA
+#define KASAN_ALLOCA_RIGHT	0xCB
+
+#define KASAN_ALLOCA_REDZONE_SIZE	32
+
 /* Don't break randconfig/all*config builds */
 #ifndef KASAN_ABI_VERSION
 #define KASAN_ABI_VERSION 1
@@ -96,15 +104,10 @@ static inline const void *kasan_shadow_to_mem(const void *shadow_addr)
 		<< KASAN_SHADOW_SCALE_SHIFT);
 }
 
-static inline bool kasan_report_enabled(void)
-{
-	return !current->kasan_depth;
-}
-
 void kasan_report(unsigned long addr, size_t size,
 		bool is_write, unsigned long ip);
 void kasan_report_double_free(struct kmem_cache *cache, void *object,
-			s8 shadow);
+					void *ip);
 
 #if defined(CONFIG_SLAB) || defined(CONFIG_SLUB)
 void quarantine_put(struct kasan_free_meta *info, struct kmem_cache *cache);
@@ -117,4 +120,48 @@ static inline void quarantine_reduce(void) { }
 static inline void quarantine_remove_cache(struct kmem_cache *cache) { }
 #endif
 
+/*
+ * Exported functions for interfaces called from assembly or from generated
+ * code. Declarations here to avoid warning about missing declarations.
+ */
+asmlinkage void kasan_unpoison_task_stack_below(const void *watermark);
+void __asan_register_globals(struct kasan_global *globals, size_t size);
+void __asan_unregister_globals(struct kasan_global *globals, size_t size);
+void __asan_loadN(unsigned long addr, size_t size);
+void __asan_storeN(unsigned long addr, size_t size);
+void __asan_handle_no_return(void);
+void __asan_poison_stack_memory(const void *addr, size_t size);
+void __asan_unpoison_stack_memory(const void *addr, size_t size);
+void __asan_alloca_poison(unsigned long addr, size_t size);
+void __asan_allocas_unpoison(const void *stack_top, const void *stack_bottom);
+
+void __asan_load1(unsigned long addr);
+void __asan_store1(unsigned long addr);
+void __asan_load2(unsigned long addr);
+void __asan_store2(unsigned long addr);
+void __asan_load4(unsigned long addr);
+void __asan_store4(unsigned long addr);
+void __asan_load8(unsigned long addr);
+void __asan_store8(unsigned long addr);
+void __asan_load16(unsigned long addr);
+void __asan_store16(unsigned long addr);
+
+void __asan_load1_noabort(unsigned long addr);
+void __asan_store1_noabort(unsigned long addr);
+void __asan_load2_noabort(unsigned long addr);
+void __asan_store2_noabort(unsigned long addr);
+void __asan_load4_noabort(unsigned long addr);
+void __asan_store4_noabort(unsigned long addr);
+void __asan_load8_noabort(unsigned long addr);
+void __asan_store8_noabort(unsigned long addr);
+void __asan_load16_noabort(unsigned long addr);
+void __asan_store16_noabort(unsigned long addr);
+
+void __asan_set_shadow_00(const void *addr, size_t size);
+void __asan_set_shadow_f1(const void *addr, size_t size);
+void __asan_set_shadow_f2(const void *addr, size_t size);
+void __asan_set_shadow_f3(const void *addr, size_t size);
+void __asan_set_shadow_f5(const void *addr, size_t size);
+void __asan_set_shadow_f8(const void *addr, size_t size);
+
 #endif
diff --git a/mm/kasan/quarantine.c b/mm/kasan/quarantine.c
index baabaad..3a8ddf8 100644
--- a/mm/kasan/quarantine.c
+++ b/mm/kasan/quarantine.c
@@ -25,6 +25,7 @@
 #include <linux/printk.h>
 #include <linux/shrinker.h>
 #include <linux/slab.h>
+#include <linux/srcu.h>
 #include <linux/string.h>
 #include <linux/types.h>
 
@@ -86,24 +87,9 @@ static void qlist_move_all(struct qlist_head *from, struct qlist_head *to)
 	qlist_init(from);
 }
 
-static void qlist_move(struct qlist_head *from, struct qlist_node *last,
-		struct qlist_head *to, size_t size)
-{
-	if (unlikely(last == from->tail)) {
-		qlist_move_all(from, to);
-		return;
-	}
-	if (qlist_empty(to))
-		to->head = from->head;
-	else
-		to->tail->next = from->head;
-	to->tail = last;
-	from->head = last->next;
-	last->next = NULL;
-	from->bytes -= size;
-	to->bytes += size;
-}
-
+#define QUARANTINE_PERCPU_SIZE (1 << 20)
+#define QUARANTINE_BATCHES \
+	(1024 > 4 * CONFIG_NR_CPUS ? 1024 : 4 * CONFIG_NR_CPUS)
 
 /*
  * The object quarantine consists of per-cpu queues and a global queue,
@@ -111,11 +97,23 @@ static void qlist_move(struct qlist_head *from, struct qlist_node *last,
  */
 static DEFINE_PER_CPU(struct qlist_head, cpu_quarantine);
 
-static struct qlist_head global_quarantine;
+/* Round-robin FIFO array of batches. */
+static struct qlist_head global_quarantine[QUARANTINE_BATCHES];
+static int quarantine_head;
+static int quarantine_tail;
+/* Total size of all objects in global_quarantine across all batches. */
+static unsigned long quarantine_size;
 static DEFINE_SPINLOCK(quarantine_lock);
+DEFINE_STATIC_SRCU(remove_cache_srcu);
 
 /* Maximum size of the global queue. */
-static unsigned long quarantine_size;
+static unsigned long quarantine_max_size;
+
+/*
+ * Target size of a batch in global_quarantine.
+ * Usually equal to QUARANTINE_PERCPU_SIZE unless we have too much RAM.
+ */
+static unsigned long quarantine_batch_size;
 
 /*
  * The fraction of physical memory the quarantine is allowed to occupy.
@@ -124,9 +122,6 @@ static void qlist_move(struct qlist_head *from, struct qlist_node *last,
  */
 #define QUARANTINE_FRACTION 32
 
-#define QUARANTINE_LOW_SIZE (READ_ONCE(quarantine_size) * 3 / 4)
-#define QUARANTINE_PERCPU_SIZE (1 << 20)
-
 static struct kmem_cache *qlink_to_cache(struct qlist_node *qlink)
 {
 	return virt_to_head_page(qlink)->slab_cache;
@@ -180,62 +175,89 @@ void quarantine_put(struct kasan_free_meta *info, struct kmem_cache *cache)
 	struct qlist_head *q;
 	struct qlist_head temp = QLIST_INIT;
 
+	/*
+	 * Note: irq must be disabled until after we move the batch to the
+	 * global quarantine. Otherwise quarantine_remove_cache() can miss
+	 * some objects belonging to the cache if they are in our local temp
+	 * list. quarantine_remove_cache() executes on_each_cpu() at the
+	 * beginning which ensures that it either sees the objects in per-cpu
+	 * lists or in the global quarantine.
+	 */
 	local_irq_save(flags);
 
 	q = this_cpu_ptr(&cpu_quarantine);
 	qlist_put(q, &info->quarantine_link, cache->size);
-	if (unlikely(q->bytes > QUARANTINE_PERCPU_SIZE))
+	if (unlikely(q->bytes > QUARANTINE_PERCPU_SIZE)) {
 		qlist_move_all(q, &temp);
 
-	local_irq_restore(flags);
-
-	if (unlikely(!qlist_empty(&temp))) {
-		spin_lock_irqsave(&quarantine_lock, flags);
-		qlist_move_all(&temp, &global_quarantine);
-		spin_unlock_irqrestore(&quarantine_lock, flags);
+		spin_lock(&quarantine_lock);
+		WRITE_ONCE(quarantine_size, quarantine_size + temp.bytes);
+		qlist_move_all(&temp, &global_quarantine[quarantine_tail]);
+		if (global_quarantine[quarantine_tail].bytes >=
+				READ_ONCE(quarantine_batch_size)) {
+			int new_tail;
+
+			new_tail = quarantine_tail + 1;
+			if (new_tail == QUARANTINE_BATCHES)
+				new_tail = 0;
+			if (new_tail != quarantine_head)
+				quarantine_tail = new_tail;
+		}
+		spin_unlock(&quarantine_lock);
 	}
+
+	local_irq_restore(flags);
 }
 
 void quarantine_reduce(void)
 {
-	size_t new_quarantine_size, percpu_quarantines;
+	size_t total_size, new_quarantine_size, percpu_quarantines;
 	unsigned long flags;
+	int srcu_idx;
 	struct qlist_head to_free = QLIST_INIT;
-	size_t size_to_free = 0;
-	struct qlist_node *last;
 
-	if (likely(READ_ONCE(global_quarantine.bytes) <=
-		   READ_ONCE(quarantine_size)))
+	if (likely(READ_ONCE(quarantine_size) <=
+		   READ_ONCE(quarantine_max_size)))
 		return;
 
+	/*
+	 * srcu critical section ensures that quarantine_remove_cache()
+	 * will not miss objects belonging to the cache while they are in our
+	 * local to_free list. srcu is chosen because (1) it gives us private
+	 * grace period domain that does not interfere with anything else,
+	 * and (2) it allows synchronize_srcu() to return without waiting
+	 * if there are no pending read critical sections (which is the
+	 * expected case).
+	 */
+	srcu_idx = srcu_read_lock(&remove_cache_srcu);
 	spin_lock_irqsave(&quarantine_lock, flags);
 
 	/*
 	 * Update quarantine size in case of hotplug. Allocate a fraction of
 	 * the installed memory to quarantine minus per-cpu queue limits.
 	 */
-	new_quarantine_size = (READ_ONCE(totalram_pages) << PAGE_SHIFT) /
+	total_size = (READ_ONCE(totalram_pages) << PAGE_SHIFT) /
 		QUARANTINE_FRACTION;
 	percpu_quarantines = QUARANTINE_PERCPU_SIZE * num_online_cpus();
-	new_quarantine_size = (new_quarantine_size < percpu_quarantines) ?
-		0 : new_quarantine_size - percpu_quarantines;
-	WRITE_ONCE(quarantine_size, new_quarantine_size);
-
-	last = global_quarantine.head;
-	while (last) {
-		struct kmem_cache *cache = qlink_to_cache(last);
-
-		size_to_free += cache->size;
-		if (!last->next || size_to_free >
-		    global_quarantine.bytes - QUARANTINE_LOW_SIZE)
-			break;
-		last = last->next;
+	new_quarantine_size = (total_size < percpu_quarantines) ?
+		0 : total_size - percpu_quarantines;
+	WRITE_ONCE(quarantine_max_size, new_quarantine_size);
+	/* Aim at consuming at most 1/2 of slots in quarantine. */
+	WRITE_ONCE(quarantine_batch_size, max((size_t)QUARANTINE_PERCPU_SIZE,
+		2 * total_size / QUARANTINE_BATCHES));
+
+	if (likely(quarantine_size > quarantine_max_size)) {
+		qlist_move_all(&global_quarantine[quarantine_head], &to_free);
+		WRITE_ONCE(quarantine_size, quarantine_size - to_free.bytes);
+		quarantine_head++;
+		if (quarantine_head == QUARANTINE_BATCHES)
+			quarantine_head = 0;
 	}
-	qlist_move(&global_quarantine, last, &to_free, size_to_free);
 
 	spin_unlock_irqrestore(&quarantine_lock, flags);
 
 	qlist_free_all(&to_free, NULL);
+	srcu_read_unlock(&remove_cache_srcu, srcu_idx);
 }
 
 static void qlist_move_cache(struct qlist_head *from,
@@ -273,16 +295,34 @@ static void per_cpu_remove_cache(void *arg)
 	qlist_free_all(&to_free, cache);
 }
 
+/* Free all quarantined objects belonging to cache. */
 void quarantine_remove_cache(struct kmem_cache *cache)
 {
-	unsigned long flags;
+	unsigned long flags, i;
 	struct qlist_head to_free = QLIST_INIT;
 
+	/*
+	 * Must be careful to not miss any objects that are being moved from
+	 * per-cpu list to the global quarantine in quarantine_put(),
+	 * nor objects being freed in quarantine_reduce(). on_each_cpu()
+	 * achieves the first goal, while synchronize_srcu() achieves the
+	 * second.
+	 */
 	on_each_cpu(per_cpu_remove_cache, cache, 1);
 
 	spin_lock_irqsave(&quarantine_lock, flags);
-	qlist_move_cache(&global_quarantine, &to_free, cache);
+	for (i = 0; i < QUARANTINE_BATCHES; i++) {
+		if (qlist_empty(&global_quarantine[i]))
+			continue;
+		qlist_move_cache(&global_quarantine[i], &to_free, cache);
+		/* Scanning whole quarantine can take a while. */
+		spin_unlock_irqrestore(&quarantine_lock, flags);
+		cond_resched();
+		spin_lock_irqsave(&quarantine_lock, flags);
+	}
 	spin_unlock_irqrestore(&quarantine_lock, flags);
 
 	qlist_free_all(&to_free, cache);
+
+	synchronize_srcu(&remove_cache_srcu);
 }
diff --git a/mm/kasan/report.c b/mm/kasan/report.c
index 8ca412a..a324797 100644
--- a/mm/kasan/report.c
+++ b/mm/kasan/report.c
@@ -13,7 +13,9 @@
  *
  */
 
+#include <linux/bitops.h>
 #include <linux/ftrace.h>
+#include <linux/init.h>
 #include <linux/kernel.h>
 #include <linux/mm.h>
 #include <linux/printk.h>
@@ -49,7 +51,13 @@ static const void *find_first_bad_addr(const void *addr, size_t size)
 	return first_bad_addr;
 }
 
-static void print_error_description(struct kasan_access_info *info)
+static bool addr_has_shadow(struct kasan_access_info *info)
+{
+	return (info->access_addr >=
+		kasan_shadow_to_mem((void *)KASAN_SHADOW_START));
+}
+
+static const char *get_shadow_bug_type(struct kasan_access_info *info)
 {
 	const char *bug_type = "unknown-crash";
 	u8 *shadow_addr;
@@ -94,14 +102,45 @@ static void print_error_description(struct kasan_access_info *info)
 	case KASAN_USE_AFTER_SCOPE:
 		bug_type = "use-after-scope";
 		break;
+	case KASAN_ALLOCA_LEFT:
+	case KASAN_ALLOCA_RIGHT:
+		bug_type = "alloca-out-of-bounds";
+		break;
 	}
 
-	pr_err("BUG: KASAN: %s in %pS at addr %p\n",
-		bug_type, (void *)info->ip,
-		info->access_addr);
-	pr_err("%s of size %zu by task %s/%d\n",
-		info->is_write ? "Write" : "Read",
-		info->access_size, current->comm, task_pid_nr(current));
+	return bug_type;
+}
+
+static const char *get_wild_bug_type(struct kasan_access_info *info)
+{
+	const char *bug_type = "unknown-crash";
+
+	if ((unsigned long)info->access_addr < PAGE_SIZE)
+		bug_type = "null-ptr-deref";
+	else if ((unsigned long)info->access_addr < TASK_SIZE)
+		bug_type = "user-memory-access";
+	else
+		bug_type = "wild-memory-access";
+
+	return bug_type;
+}
+
+static const char *get_bug_type(struct kasan_access_info *info)
+{
+	if (addr_has_shadow(info))
+		return get_shadow_bug_type(info);
+	return get_wild_bug_type(info);
+}
+
+static void print_error_description(struct kasan_access_info *info)
+{
+	const char *bug_type = get_bug_type(info);
+
+	pr_err("BUG: KASAN: %s in %pS\n",
+		bug_type, (void *)info->ip);
+	pr_err("%s of size %zu at addr %p by task %s/%d\n",
+		info->is_write ? "Write" : "Read", info->access_size,
+		info->access_addr, current->comm, task_pid_nr(current));
 }
 
 static inline bool kernel_or_module_addr(const void *addr)
@@ -137,12 +176,14 @@ static void kasan_end_report(unsigned long *flags)
 	pr_err("==================================================================\n");
 	add_taint(TAINT_BAD_PAGE, LOCKDEP_NOW_UNRELIABLE);
 	spin_unlock_irqrestore(&report_lock, *flags);
+	if (panic_on_warn)
+		panic("panic_on_warn set ...\n");
 	kasan_enable_current();
 }
 
-static void print_track(struct kasan_track *track)
+static void print_track(struct kasan_track *track, const char *prefix)
 {
-	pr_err("PID = %u\n", track->pid);
+	pr_err("%s by task %u:\n", prefix, track->pid);
 	if (track->stack) {
 		struct stack_trace trace;
 
@@ -153,59 +194,84 @@ static void print_track(struct kasan_track *track)
 	}
 }
 
-static void kasan_object_err(struct kmem_cache *cache, void *object)
+static struct page *addr_to_page(const void *addr)
 {
-	struct kasan_alloc_meta *alloc_info = get_alloc_info(cache, object);
+	if ((addr >= (void *)PAGE_OFFSET) &&
+			(addr < high_memory))
+		return virt_to_head_page(addr);
+	return NULL;
+}
 
-	dump_stack();
-	pr_err("Object at %p, in cache %s size: %d\n", object, cache->name,
-		cache->object_size);
+static void describe_object_addr(struct kmem_cache *cache, void *object,
+				const void *addr)
+{
+	unsigned long access_addr = (unsigned long)addr;
+	unsigned long object_addr = (unsigned long)object;
+	const char *rel_type;
+	int rel_bytes;
 
-	if (!(cache->flags & SLAB_KASAN))
+	pr_err("The buggy address belongs to the object at %p\n"
+	       " which belongs to the cache %s of size %d\n",
+		object, cache->name, cache->object_size);
+
+	if (!addr)
 		return;
 
-	pr_err("Allocated:\n");
-	print_track(&alloc_info->alloc_track);
-	pr_err("Freed:\n");
-	print_track(&alloc_info->free_track);
+	if (access_addr < object_addr) {
+		rel_type = "to the left";
+		rel_bytes = object_addr - access_addr;
+	} else if (access_addr >= object_addr + cache->object_size) {
+		rel_type = "to the right";
+		rel_bytes = access_addr - (object_addr + cache->object_size);
+	} else {
+		rel_type = "inside";
+		rel_bytes = access_addr - object_addr;
+	}
+
+	pr_err("The buggy address is located %d bytes %s of\n"
+	       " %d-byte region [%p, %p)\n",
+		rel_bytes, rel_type, cache->object_size, (void *)object_addr,
+		(void *)(object_addr + cache->object_size));
 }
 
-void kasan_report_double_free(struct kmem_cache *cache, void *object,
-			s8 shadow)
+static void describe_object(struct kmem_cache *cache, void *object,
+				const void *addr)
 {
-	unsigned long flags;
+	struct kasan_alloc_meta *alloc_info = get_alloc_info(cache, object);
 
-	kasan_start_report(&flags);
-	pr_err("BUG: Double free or freeing an invalid pointer\n");
-	pr_err("Unexpected shadow byte: 0x%hhX\n", shadow);
-	kasan_object_err(cache, object);
-	kasan_end_report(&flags);
+	if (cache->flags & SLAB_KASAN) {
+		print_track(&alloc_info->alloc_track, "Allocated");
+		pr_err("\n");
+		print_track(&alloc_info->free_track, "Freed");
+		pr_err("\n");
+	}
+
+	describe_object_addr(cache, object, addr);
 }
 
-static void print_address_description(struct kasan_access_info *info)
+static void print_address_description(void *addr)
 {
-	const void *addr = info->access_addr;
+	struct page *page = addr_to_page(addr);
 
-	if ((addr >= (void *)PAGE_OFFSET) &&
-		(addr < high_memory)) {
-		struct page *page = virt_to_head_page(addr);
-
-		if (PageSlab(page)) {
-			void *object;
-			struct kmem_cache *cache = page->slab_cache;
-			object = nearest_obj(cache, page,
-						(void *)info->access_addr);
-			kasan_object_err(cache, object);
-			return;
-		}
-		dump_page(page, "kasan: bad access detected");
+	dump_stack();
+	pr_err("\n");
+
+	if (page && PageSlab(page)) {
+		struct kmem_cache *cache = page->slab_cache;
+		void *object = nearest_obj(cache, page,	addr);
+
+		describe_object(cache, object, addr);
 	}
 
-	if (kernel_or_module_addr(addr)) {
-		if (!init_task_stack_addr(addr))
-			pr_err("Address belongs to variable %pS\n", addr);
+	if (kernel_or_module_addr(addr) && !init_task_stack_addr(addr)) {
+		pr_err("The buggy address belongs to the variable:\n");
+		pr_err(" %pS\n", addr);
+	}
+
+	if (page) {
+		pr_err("The buggy address belongs to the page:\n");
+		dump_page(page, "kasan: bad access detected");
 	}
-	dump_stack();
 }
 
 static bool row_is_guilty(const void *row, const void *guilty)
@@ -260,37 +326,74 @@ static void print_shadow_for_address(const void *addr)
 	}
 }
 
+void kasan_report_double_free(struct kmem_cache *cache, void *object,
+				void *ip)
+{
+	unsigned long flags;
+
+	kasan_start_report(&flags);
+	pr_err("BUG: KASAN: double-free or invalid-free in %pS\n", ip);
+	pr_err("\n");
+	print_address_description(object);
+	pr_err("\n");
+	print_shadow_for_address(object);
+	kasan_end_report(&flags);
+}
+
 static void kasan_report_error(struct kasan_access_info *info)
 {
 	unsigned long flags;
-	const char *bug_type;
 
 	kasan_start_report(&flags);
 
-	if (info->access_addr <
-			kasan_shadow_to_mem((void *)KASAN_SHADOW_START)) {
-		if ((unsigned long)info->access_addr < PAGE_SIZE)
-			bug_type = "null-ptr-deref";
-		else if ((unsigned long)info->access_addr < TASK_SIZE)
-			bug_type = "user-memory-access";
-		else
-			bug_type = "wild-memory-access";
-		pr_err("BUG: KASAN: %s on address %p\n",
-			bug_type, info->access_addr);
-		pr_err("%s of size %zu by task %s/%d\n",
-			info->is_write ? "Write" : "Read",
-			info->access_size, current->comm,
-			task_pid_nr(current));
+	print_error_description(info);
+	pr_err("\n");
+
+	if (!addr_has_shadow(info)) {
 		dump_stack();
 	} else {
-		print_error_description(info);
-		print_address_description(info);
+		print_address_description((void *)info->access_addr);
+		pr_err("\n");
 		print_shadow_for_address(info->first_bad_addr);
 	}
 
 	kasan_end_report(&flags);
 }
 
+static unsigned long kasan_flags;
+
+#define KASAN_BIT_REPORTED	0
+#define KASAN_BIT_MULTI_SHOT	1
+
+bool kasan_save_enable_multi_shot(void)
+{
+	return test_and_set_bit(KASAN_BIT_MULTI_SHOT, &kasan_flags);
+}
+EXPORT_SYMBOL_GPL(kasan_save_enable_multi_shot);
+
+void kasan_restore_multi_shot(bool enabled)
+{
+	if (!enabled)
+		clear_bit(KASAN_BIT_MULTI_SHOT, &kasan_flags);
+}
+EXPORT_SYMBOL_GPL(kasan_restore_multi_shot);
+
+static int __init kasan_set_multi_shot(char *str)
+{
+	set_bit(KASAN_BIT_MULTI_SHOT, &kasan_flags);
+	return 1;
+}
+__setup("kasan_multi_shot", kasan_set_multi_shot);
+
+static inline bool kasan_report_enabled(void)
+{
+	if (current->kasan_depth)
+		return false;
+	if (test_bit(KASAN_BIT_MULTI_SHOT, &kasan_flags))
+		return true;
+	return !test_and_set_bit(KASAN_BIT_REPORTED, &kasan_flags);
+}
+
 void kasan_report(unsigned long addr, size_t size,
 		bool is_write, unsigned long ip)
 {
diff --git a/mm/madvise.c b/mm/madvise.c
index a49afe0..bb58a44 100644
--- a/mm/madvise.c
+++ b/mm/madvise.c
@@ -109,7 +109,7 @@ static long madvise_behavior(struct vm_area_struct *vma,
 	pgoff = vma->vm_pgoff + ((start - vma->vm_start) >> PAGE_SHIFT);
 	*prev = vma_merge(mm, *prev, start, end, new_flags, vma->anon_vma,
 			  vma->vm_file, pgoff, vma_policy(vma),
-			  vma->vm_userfaultfd_ctx);
+			  vma->vm_userfaultfd_ctx, vma_get_anon_name(vma));
 	if (*prev) {
 		vma = *prev;
 		goto success;
diff --git a/mm/memblock.c b/mm/memblock.c
old mode 100644
new mode 100755
index 42b98af..70e8005
--- a/mm/memblock.c
+++ b/mm/memblock.c
@@ -19,12 +19,22 @@
 #include <linux/debugfs.h>
 #include <linux/seq_file.h>
 #include <linux/memblock.h>
+#include <linux/delay.h>
+#include <linux/kthread.h>
+#include <linux/sched.h>
 
 #include <asm/sections.h>
 #include <linux/io.h>
 
 #include "internal.h"
 
+static DEFINE_MUTEX(free_logo_mutex);
+extern unsigned long logo_start_addr;
+extern unsigned long logo_size;
+extern unsigned long logo_start_addr_bak;
+extern unsigned long logo_size_bak;
+extern int free_logo_reserved_region;
+
 static struct memblock_region memblock_memory_init_regions[INIT_MEMBLOCK_REGIONS] __initdata_memblock;
 static struct memblock_region memblock_reserved_init_regions[INIT_MEMBLOCK_REGIONS] __initdata_memblock;
 #ifdef CONFIG_HAVE_MEMBLOCK_PHYS_MAP
@@ -1741,6 +1751,74 @@ static int __init early_memblock(char *p)
 
 #if defined(CONFIG_DEBUG_FS) && !defined(CONFIG_ARCH_DISCARD_MEMBLOCK)
 
+static struct task_struct *free_logo_task;
+
+#ifdef CONFIG_HIGHMEM /* copy form arch/arm/mm/init.c */
+static inline void free_area_high(unsigned long pfn, unsigned long end)
+{
+	for (; pfn < end; pfn++)
+		free_highmem_page(pfn_to_page(pfn));
+}
+#else
+static inline void free_area_high(unsigned long pfn, unsigned long end)
+{
+}
+#endif
+
+static void free_logo_memory(void *data)
+{
+	mutex_lock(&free_logo_mutex);
+	if( logo_start_addr && logo_size ) {
+#if defined(CONFIG_ARM64) && defined(CONFIG_64BIT)
+		free_reserved_area(__va(logo_start_addr),
+			__va(logo_start_addr+logo_size), 0,
+			"free logo area");
+#else /* logo_start_addr might out of lowmem range in 32-bit environment */
+		if(__va(logo_start_addr+logo_size) >=
+			(unsigned long)high_memory) {
+			memblock_free(logo_start_addr,
+				logo_size);
+			free_area_high((logo_start_addr>>PAGE_SHIFT),
+				(logo_start_addr+logo_size)>>PAGE_SHIFT);
+		}
+		else {
+			free_reserved_area(__va(logo_start_addr),
+				__va(logo_start_addr+logo_size), 0,
+				"free logo area");
+		}
+#endif
+		logo_start_addr = logo_size = 0;
+	}
+	mutex_unlock(&free_logo_mutex);
+}
+
+static int do_free_logo(void *data)
+{
+	int time_out = 120;;
+	struct sched_param param = {.sched_priority = MAX_RT_PRIO-2};
+
+	sched_setscheduler(current, SCHED_FIFO, &param);
+	while (!kthread_should_stop() && time_out--) {
+		msleep(1000);
+		if( !logo_start_addr || !logo_size ) {
+			return 0;
+		}
+	}
+	free_logo_memory(data);
+	return 0;
+}
+
+static void memblock_init_free_logo_kthread(void)
+{
+	free_logo_task = kthread_create(do_free_logo, NULL, "free_logo");
+	if (IS_ERR(free_logo_task)) {
+		printk(KERN_ERR "create free logo kthread failed\n");
+		return 0;
+	}
+	kthread_bind(free_logo_task, 0);
+	wake_up_process(free_logo_task);
+}
+
 static int memblock_debug_show(struct seq_file *m, void *private)
 {
 	struct memblock_type *type = m->private;
@@ -1768,11 +1846,49 @@ static int memblock_debug_open(struct inode *inode, struct file *file)
 	return single_open(file, memblock_debug_show, inode->i_private);
 }
 
+static ssize_t memblock_debug_write(struct file *file, const char __user *buf,
+			    size_t count, loff_t *ppos)
+{
+	struct memblock_type *rsv_mem = &memblock.reserved;
+	struct memblock_type *type = file->f_inode->i_private;
+	char buffer[16];
+	size_t buffer_valid_size;
+	if(rsv_mem == type) {
+		if(count >= 8 ) {
+			if(copy_from_user(buffer, buf, 8)==0) {
+				buffer_valid_size = 8; /* OK */
+			}
+			else {
+				buffer_valid_size = 0;
+			}
+		}
+		if(buffer_valid_size >= 8 && !strncmp(buffer, "freelogo", 8)) {
+			free_logo_memory(NULL);
+		}
+		if(buffer_valid_size >= 8 && !strncmp(buffer, "logoinfo", 8)) {
+			if( sizeof(logo_size) == 8 ) {
+				printk(KERN_ERR "cur start: 0x%llx, size: 0x%llx\n",
+					logo_start_addr, logo_size);
+				printk(KERN_ERR "bak start: 0x%llx, size: 0x%llx\n",
+					logo_start_addr_bak, logo_size_bak);
+			}
+			else {
+				printk(KERN_ERR "cur start: 0x%lx, size: 0x%lx\n",
+					logo_start_addr, logo_size);
+				printk(KERN_ERR "bak start: 0x%lx, size: 0x%lx\n",
+					logo_start_addr_bak, logo_size_bak);
+			}
+		}
+	}
+	return count;
+}
+
 static const struct file_operations memblock_debug_fops = {
 	.open = memblock_debug_open,
 	.read = seq_read,
 	.llseek = seq_lseek,
 	.release = single_release,
+	.write = memblock_debug_write,
 };
 
 static int __init memblock_init_debugfs(void)
@@ -1785,7 +1901,14 @@ static int __init memblock_init_debugfs(void)
 #ifdef CONFIG_HAVE_MEMBLOCK_PHYS_MAP
 	debugfs_create_file("physmem", S_IRUGO, root, &memblock.physmem, &memblock_debug_fops);
 #endif
-
+#if 1 /* might create new of attribute to enable or disable this function */
+	if( free_logo_reserved_region && logo_start_addr && logo_size ) {
+		if (memblock_is_memory(logo_start_addr))
+			memblock_init_free_logo_kthread();
+		else
+			pr_info("logo:0x%llx not in memory region\n", logo_start_addr);
+	}
+#endif
 	return 0;
 }
 __initcall(memblock_init_debugfs);
diff --git a/mm/memcontrol.c b/mm/memcontrol.c
index 349f4a8..b319a7d 100644
--- a/mm/memcontrol.c
+++ b/mm/memcontrol.c
@@ -1619,9 +1619,13 @@ bool mem_cgroup_oom_synchronize(bool handle)
  * @page: the page
  *
  * This function protects unlocked LRU pages from being moved to
- * another cgroup and stabilizes their page->mem_cgroup binding.
+ * another cgroup.
+ *
+ * It ensures lifetime of the returned memcg. Caller is responsible
+ * for the lifetime of the page; __unlock_page_memcg() is available
+ * when @page might get freed inside the locked section.
  */
-void lock_page_memcg(struct page *page)
+struct mem_cgroup *lock_page_memcg(struct page *page)
 {
 	struct mem_cgroup *memcg;
 	unsigned long flags;
@@ -1630,18 +1634,24 @@ void lock_page_memcg(struct page *page)
 	 * The RCU lock is held throughout the transaction.  The fast
 	 * path can get away without acquiring the memcg->move_lock
 	 * because page moving starts with an RCU grace period.
-	 */
+	 *
+	 * The RCU lock also protects the memcg from being freed when
+	 * the page state that is going to change is the only thing
+	 * preventing the page itself from being freed. E.g. writeback
+	 * doesn't hold a page reference and relies on PG_writeback to
+	 * keep off truncation, migration and so forth.
+         */
 	rcu_read_lock();
 
 	if (mem_cgroup_disabled())
-		return;
+		return NULL;
 again:
 	memcg = page->mem_cgroup;
 	if (unlikely(!memcg))
-		return;
+		return NULL;
 
 	if (atomic_read(&memcg->moving_account) <= 0)
-		return;
+		return memcg;
 
 	spin_lock_irqsave(&memcg->move_lock, flags);
 	if (memcg != page->mem_cgroup) {
@@ -1657,18 +1667,18 @@ void lock_page_memcg(struct page *page)
 	memcg->move_lock_task = current;
 	memcg->move_lock_flags = flags;
 
-	return;
+	return memcg;
 }
 EXPORT_SYMBOL(lock_page_memcg);
 
 /**
- * unlock_page_memcg - unlock a page->mem_cgroup binding
- * @page: the page
+ * __unlock_page_memcg - unlock and unpin a memcg
+ * @memcg: the memcg
+ *
+ * Unlock and unpin a memcg returned by lock_page_memcg().
  */
-void unlock_page_memcg(struct page *page)
+void __unlock_page_memcg(struct mem_cgroup *memcg)
 {
-	struct mem_cgroup *memcg = page->mem_cgroup;
-
 	if (memcg && memcg->move_lock_task == current) {
 		unsigned long flags = memcg->move_lock_flags;
 
@@ -1680,6 +1690,11 @@ void unlock_page_memcg(struct page *page)
 
 	rcu_read_unlock();
 }
+
+void unlock_page_memcg(struct page *page)
+{
+	__unlock_page_memcg(page->mem_cgroup);
+}
 EXPORT_SYMBOL(unlock_page_memcg);
 
 /*
diff --git a/mm/mempolicy.c b/mm/mempolicy.c
index 69c4a0c..d0adeef 100644
--- a/mm/mempolicy.c
+++ b/mm/mempolicy.c
@@ -752,7 +752,8 @@ static int mbind_range(struct mm_struct *mm, unsigned long start,
 			((vmstart - vma->vm_start) >> PAGE_SHIFT);
 		prev = vma_merge(mm, prev, vmstart, vmend, vma->vm_flags,
 				 vma->anon_vma, vma->vm_file, pgoff,
-				 new_pol, vma->vm_userfaultfd_ctx);
+				 new_pol, vma->vm_userfaultfd_ctx,
+				 vma_get_anon_name(vma));
 		if (prev) {
 			vma = prev;
 			next = vma->vm_next;
diff --git a/mm/mlock.c b/mm/mlock.c
index f050569..9cdd063 100644
--- a/mm/mlock.c
+++ b/mm/mlock.c
@@ -529,7 +529,7 @@ static int mlock_fixup(struct vm_area_struct *vma, struct vm_area_struct **prev,
 	pgoff = vma->vm_pgoff + ((start - vma->vm_start) >> PAGE_SHIFT);
 	*prev = vma_merge(mm, *prev, start, end, newflags, vma->anon_vma,
 			  vma->vm_file, pgoff, vma_policy(vma),
-			  vma->vm_userfaultfd_ctx);
+			  vma->vm_userfaultfd_ctx, vma_get_anon_name(vma));
 	if (*prev) {
 		vma = *prev;
 		goto success;
diff --git a/mm/mmap.c b/mm/mmap.c
index aa97074..400c31b 100644
--- a/mm/mmap.c
+++ b/mm/mmap.c
@@ -970,7 +970,8 @@ int __vma_adjust(struct vm_area_struct *vma, unsigned long start,
  */
 static inline int is_mergeable_vma(struct vm_area_struct *vma,
 				struct file *file, unsigned long vm_flags,
-				struct vm_userfaultfd_ctx vm_userfaultfd_ctx)
+				struct vm_userfaultfd_ctx vm_userfaultfd_ctx,
+				const char __user *anon_name)
 {
 	/*
 	 * VM_SOFTDIRTY should not prevent from VMA merging, if we
@@ -988,6 +989,8 @@ static inline int is_mergeable_vma(struct vm_area_struct *vma,
 		return 0;
 	if (!is_mergeable_vm_userfaultfd_ctx(vma, vm_userfaultfd_ctx))
 		return 0;
+	if (vma_get_anon_name(vma) != anon_name)
+		return 0;
 	return 1;
 }
 
@@ -1020,9 +1023,10 @@ static inline int is_mergeable_anon_vma(struct anon_vma *anon_vma1,
 can_vma_merge_before(struct vm_area_struct *vma, unsigned long vm_flags,
 		     struct anon_vma *anon_vma, struct file *file,
 		     pgoff_t vm_pgoff,
-		     struct vm_userfaultfd_ctx vm_userfaultfd_ctx)
+		     struct vm_userfaultfd_ctx vm_userfaultfd_ctx,
+		     const char __user *anon_name)
 {
-	if (is_mergeable_vma(vma, file, vm_flags, vm_userfaultfd_ctx) &&
+	if (is_mergeable_vma(vma, file, vm_flags, vm_userfaultfd_ctx, anon_name) &&
 	    is_mergeable_anon_vma(anon_vma, vma->anon_vma, vma)) {
 		if (vma->vm_pgoff == vm_pgoff)
 			return 1;
@@ -1041,9 +1045,10 @@ static inline int is_mergeable_anon_vma(struct anon_vma *anon_vma1,
 can_vma_merge_after(struct vm_area_struct *vma, unsigned long vm_flags,
 		    struct anon_vma *anon_vma, struct file *file,
 		    pgoff_t vm_pgoff,
-		    struct vm_userfaultfd_ctx vm_userfaultfd_ctx)
+		    struct vm_userfaultfd_ctx vm_userfaultfd_ctx,
+		    const char __user *anon_name)
 {
-	if (is_mergeable_vma(vma, file, vm_flags, vm_userfaultfd_ctx) &&
+	if (is_mergeable_vma(vma, file, vm_flags, vm_userfaultfd_ctx, anon_name) &&
 	    is_mergeable_anon_vma(anon_vma, vma->anon_vma, vma)) {
 		pgoff_t vm_pglen;
 		vm_pglen = vma_pages(vma);
@@ -1054,9 +1059,9 @@ static inline int is_mergeable_anon_vma(struct anon_vma *anon_vma1,
 }
 
 /*
- * Given a mapping request (addr,end,vm_flags,file,pgoff), figure out
- * whether that can be merged with its predecessor or its successor.
- * Or both (it neatly fills a hole).
+ * Given a mapping request (addr,end,vm_flags,file,pgoff,anon_name),
+ * figure out whether that can be merged with its predecessor or its
+ * successor.  Or both (it neatly fills a hole).
  *
  * In most cases - when called for mmap, brk or mremap - [addr,end) is
  * certain not to be mapped by the time vma_merge is called; but when
@@ -1098,7 +1103,8 @@ struct vm_area_struct *vma_merge(struct mm_struct *mm,
 			unsigned long end, unsigned long vm_flags,
 			struct anon_vma *anon_vma, struct file *file,
 			pgoff_t pgoff, struct mempolicy *policy,
-			struct vm_userfaultfd_ctx vm_userfaultfd_ctx)
+			struct vm_userfaultfd_ctx vm_userfaultfd_ctx,
+			const char __user *anon_name)
 {
 	pgoff_t pglen = (end - addr) >> PAGE_SHIFT;
 	struct vm_area_struct *area, *next;
@@ -1131,7 +1137,8 @@ struct vm_area_struct *vma_merge(struct mm_struct *mm,
 			mpol_equal(vma_policy(prev), policy) &&
 			can_vma_merge_after(prev, vm_flags,
 					    anon_vma, file, pgoff,
-					    vm_userfaultfd_ctx)) {
+					    vm_userfaultfd_ctx,
+					    anon_name)) {
 		/*
 		 * OK, it can.  Can we now merge in the successor as well?
 		 */
@@ -1140,7 +1147,8 @@ struct vm_area_struct *vma_merge(struct mm_struct *mm,
 				can_vma_merge_before(next, vm_flags,
 						     anon_vma, file,
 						     pgoff+pglen,
-						     vm_userfaultfd_ctx) &&
+						     vm_userfaultfd_ctx,
+						     anon_name) &&
 				is_mergeable_anon_vma(prev->anon_vma,
 						      next->anon_vma, NULL)) {
 							/* cases 1, 6 */
@@ -1163,7 +1171,8 @@ struct vm_area_struct *vma_merge(struct mm_struct *mm,
 			mpol_equal(policy, vma_policy(next)) &&
 			can_vma_merge_before(next, vm_flags,
 					     anon_vma, file, pgoff+pglen,
-					     vm_userfaultfd_ctx)) {
+					     vm_userfaultfd_ctx,
+					     anon_name)) {
 		if (prev && addr < prev->vm_end)	/* case 4 */
 			err = __vma_adjust(prev, prev->vm_start,
 					 addr, prev->vm_pgoff, NULL, next);
@@ -1673,7 +1682,7 @@ unsigned long mmap_region(struct file *file, unsigned long addr,
 	 * Can we just expand an old mapping?
 	 */
 	vma = vma_merge(mm, prev, addr, addr + len, vm_flags,
-			NULL, file, pgoff, NULL, NULL_VM_UFFD_CTX);
+			NULL, file, pgoff, NULL, NULL_VM_UFFD_CTX, NULL);
 	if (vma)
 		goto out;
 
@@ -2733,6 +2742,7 @@ int do_munmap(struct mm_struct *mm, unsigned long start, size_t len)
 
 	return 0;
 }
+EXPORT_SYMBOL(do_munmap);
 
 int vm_munmap(unsigned long start, size_t len)
 {
@@ -2928,7 +2938,7 @@ static int do_brk(unsigned long addr, unsigned long request)
 
 	/* Can we just expand an old private anonymous mapping? */
 	vma = vma_merge(mm, prev, addr, addr + len, flags,
-			NULL, NULL, pgoff, NULL, NULL_VM_UFFD_CTX);
+			NULL, NULL, pgoff, NULL, NULL_VM_UFFD_CTX, NULL);
 	if (vma)
 		goto out;
 
@@ -3089,7 +3099,7 @@ struct vm_area_struct *copy_vma(struct vm_area_struct **vmap,
 		return NULL;	/* should never get here */
 	new_vma = vma_merge(mm, prev, addr, addr + len, vma->vm_flags,
 			    vma->anon_vma, vma->vm_file, pgoff, vma_policy(vma),
-			    vma->vm_userfaultfd_ctx);
+			    vma->vm_userfaultfd_ctx, vma_get_anon_name(vma));
 	if (new_vma) {
 		/*
 		 * Source vma may have been merged into new_vma
diff --git a/mm/mprotect.c b/mm/mprotect.c
index ae740c9..1f2c969 100644
--- a/mm/mprotect.c
+++ b/mm/mprotect.c
@@ -303,7 +303,7 @@ unsigned long change_protection(struct vm_area_struct *vma, unsigned long start,
 	pgoff = vma->vm_pgoff + ((start - vma->vm_start) >> PAGE_SHIFT);
 	*pprev = vma_merge(mm, *pprev, start, end, newflags,
 			   vma->anon_vma, vma->vm_file, pgoff, vma_policy(vma),
-			   vma->vm_userfaultfd_ctx);
+			   vma->vm_userfaultfd_ctx, vma_get_anon_name(vma));
 	if (*pprev) {
 		vma = *pprev;
 		VM_WARN_ON((vma->vm_flags ^ newflags) & ~VM_SOFTDIRTY);
diff --git a/mm/page-writeback.c b/mm/page-writeback.c
index 807236a..404ad76 100644
--- a/mm/page-writeback.c
+++ b/mm/page-writeback.c
@@ -2185,30 +2185,14 @@ int write_cache_pages(struct address_space *mapping,
 	while (!done && (index <= end)) {
 		int i;
 
-		nr_pages = pagevec_lookup_tag(&pvec, mapping, &index, tag,
-			      min(end - index, (pgoff_t)PAGEVEC_SIZE-1) + 1);
+		nr_pages = pagevec_lookup_range_tag(&pvec, mapping, &index, end,
+				tag);
 		if (nr_pages == 0)
 			break;
 
 		for (i = 0; i < nr_pages; i++) {
 			struct page *page = pvec.pages[i];
 
-			/*
-			 * At this point, the page may be truncated or
-			 * invalidated (changing page->mapping to NULL), or
-			 * even swizzled back from swapper_space to tmpfs file
-			 * mapping. However, page->index will not change
-			 * because we have a reference on the page.
-			 */
-			if (page->index > end) {
-				/*
-				 * can't be range_cyclic (1st pass) because
-				 * end == -1 in that case.
-				 */
-				done = 1;
-				break;
-			}
-
 			done_index = page->index;
 
 			lock_page(page);
@@ -2713,9 +2697,12 @@ int clear_page_dirty_for_io(struct page *page)
 int test_clear_page_writeback(struct page *page)
 {
 	struct address_space *mapping = page_mapping(page);
+	struct mem_cgroup *memcg;
+	struct lruvec *lruvec;
 	int ret;
 
-	lock_page_memcg(page);
+	memcg = lock_page_memcg(page);
+	lruvec = mem_cgroup_page_lruvec(page, page_pgdat(page));
 	if (mapping && mapping_use_writeback_tags(mapping)) {
 		struct inode *inode = mapping->host;
 		struct backing_dev_info *bdi = inode_to_bdi(inode);
@@ -2743,13 +2730,36 @@ int test_clear_page_writeback(struct page *page)
 	} else {
 		ret = TestClearPageWriteback(page);
 	}
+	/*
+	 * NOTE: Page might be free now! Writeback doesn't hold a page
+	 * reference on its own, it relies on truncation to wait for
+	 * the clearing of PG_writeback. The below can only access
+	 * page state that is static across allocation cycles.
+	 */
 	if (ret) {
+#if 1		/* Reference by kernel 4.14 function
+		   dec_lruvec_state(lruvec, NR_WRITEBACK); */
+		unsigned long flags;
+
+		local_irq_save(flags);
+		__dec_node_state(lruvec_pgdat(lruvec), NR_WRITEBACK);
+		local_irq_restore(flags);
+#ifdef CONFIG_MEMCG
+		if (!mem_cgroup_disabled()) {
+			struct mem_cgroup_per_node *pn;
+
+			pn = container_of(lruvec, struct mem_cgroup_per_node, lruvec);
+			mem_cgroup_dec_stat(pn->memcg, MEM_CGROUP_STAT_WRITEBACK);
+		}
+#endif /* CONFIG_MEMCG */
+#else
 		mem_cgroup_dec_page_stat(page, MEM_CGROUP_STAT_WRITEBACK);
 		dec_node_page_state(page, NR_WRITEBACK);
+#endif
 		dec_zone_page_state(page, NR_ZONE_WRITE_PENDING);
 		inc_node_page_state(page, NR_WRITTEN);
 	}
-	unlock_page_memcg(page);
+	__unlock_page_memcg(memcg);
 	return ret;
 }
 
diff --git a/mm/page_alloc.c b/mm/page_alloc.c
index 28240ce..82ae4c2 100644
--- a/mm/page_alloc.c
+++ b/mm/page_alloc.c
@@ -253,9 +253,21 @@ bool pm_suspended_storage(void)
 #endif
 };
 
+/*
+ * Try to keep at least this much lowmem free.  Do not allow normal
+ * allocations below this point, only high priority ones. Automatically
+ * tuned according to the amount of memory in the system.
+ */
 int min_free_kbytes = 1024;
 int user_min_free_kbytes = -1;
-int watermark_scale_factor = 10;
+int watermark_scale_factor = 500;
+
+/*
+ * Extra memory for the system to try freeing. Used to temporarily
+ * free memory, to make space for new workloads. Anyone can allocate
+ * down to the min watermarks controlled by min_free_kbytes above.
+ */
+int extra_free_kbytes = 0;
 
 static unsigned long __meminitdata nr_kernel_pages;
 static unsigned long __meminitdata nr_all_pages;
@@ -2341,8 +2353,9 @@ static void drain_pages(unsigned int cpu)
  * The CPU has to be pinned. When zone parameter is non-NULL, spill just
  * the single zone's pages.
  */
-void drain_local_pages(struct zone *zone)
+void drain_local_pages(void *z)
 {
+	struct zone *zone = (struct zone *)z;
 	int cpu = smp_processor_id();
 
 	if (zone)
@@ -2402,8 +2415,7 @@ void drain_all_pages(struct zone *zone)
 		else
 			cpumask_clear_cpu(cpu, &cpus_with_pcps);
 	}
-	on_each_cpu_mask(&cpus_with_pcps, (smp_call_func_t) drain_local_pages,
-								zone, 1);
+	on_each_cpu_mask(&cpus_with_pcps, drain_local_pages, zone, 1);
 }
 
 #ifdef CONFIG_HIBERNATION
@@ -6663,6 +6675,7 @@ static void setup_per_zone_lowmem_reserve(void)
 static void __setup_per_zone_wmarks(void)
 {
 	unsigned long pages_min = min_free_kbytes >> (PAGE_SHIFT - 10);
+	unsigned long pages_low = extra_free_kbytes >> (PAGE_SHIFT - 10);
 	unsigned long lowmem_pages = 0;
 	struct zone *zone;
 	unsigned long flags;
@@ -6674,11 +6687,14 @@ static void __setup_per_zone_wmarks(void)
 	}
 
 	for_each_zone(zone) {
-		u64 tmp;
+		u64 min, low;
 
 		spin_lock_irqsave(&zone->lock, flags);
-		tmp = (u64)pages_min * zone->managed_pages;
-		do_div(tmp, lowmem_pages);
+		min = (u64)pages_min * zone->managed_pages;
+		do_div(min, lowmem_pages);
+		low = (u64)pages_low * zone->managed_pages;
+		do_div(low, vm_total_pages);
+
 		if (is_highmem(zone)) {
 			/*
 			 * __GFP_HIGH and PF_MEMALLOC allocations usually don't
@@ -6699,7 +6715,7 @@ static void __setup_per_zone_wmarks(void)
 			 * If it's a lowmem zone, reserve a number of pages
 			 * proportionate to the zone's size.
 			 */
-			zone->watermark[WMARK_MIN] = tmp;
+			zone->watermark[WMARK_MIN] = min;
 		}
 
 		/*
@@ -6707,12 +6723,14 @@ static void __setup_per_zone_wmarks(void)
 		 * scale factor in proportion to available memory, but
 		 * ensure a minimum size on small systems.
 		 */
-		tmp = max_t(u64, tmp >> 2,
+		min = max_t(u64, min >> 2,
 			    mult_frac(zone->managed_pages,
 				      watermark_scale_factor, 10000));
 
-		zone->watermark[WMARK_LOW]  = min_wmark_pages(zone) + tmp;
-		zone->watermark[WMARK_HIGH] = min_wmark_pages(zone) + tmp * 2;
+		zone->watermark[WMARK_LOW]  = min_wmark_pages(zone) +
+					low + min;
+		zone->watermark[WMARK_HIGH] = min_wmark_pages(zone) +
+					low + min * 2;
 
 		spin_unlock_irqrestore(&zone->lock, flags);
 	}
@@ -6793,7 +6811,7 @@ int __meminit init_per_zone_wmark_min(void)
 /*
  * min_free_kbytes_sysctl_handler - just a wrapper around proc_dointvec() so
  *	that we can call two helper functions whenever min_free_kbytes
- *	changes.
+ *	or extra_free_kbytes changes.
  */
 int min_free_kbytes_sysctl_handler(struct ctl_table *table, int write,
 	void __user *buffer, size_t *length, loff_t *ppos)
diff --git a/mm/readahead.c b/mm/readahead.c
index c8a955b..3c1d2a4 100644
--- a/mm/readahead.c
+++ b/mm/readahead.c
@@ -81,7 +81,7 @@ static void read_cache_pages_invalidate_pages(struct address_space *mapping,
  * Hides the details of the LRU cache etc from the filesystems.
  */
 int read_cache_pages(struct address_space *mapping, struct list_head *pages,
-			int (*filler)(void *, struct page *), void *data)
+			int (*filler)(struct file *, struct page *), void *data)
 {
 	struct page *page;
 	int ret = 0;
diff --git a/mm/shmem.c b/mm/shmem.c
index 42ca5df..61a39aa 100644
--- a/mm/shmem.c
+++ b/mm/shmem.c
@@ -4076,6 +4076,14 @@ struct file *shmem_file_setup(const char *name, loff_t size, unsigned long flags
 }
 EXPORT_SYMBOL_GPL(shmem_file_setup);
 
+void shmem_set_file(struct vm_area_struct *vma, struct file *file)
+{
+	if (vma->vm_file)
+		fput(vma->vm_file);
+	vma->vm_file = file;
+	vma->vm_ops = &shmem_vm_ops;
+}
+
 /**
  * shmem_zero_setup - setup a shared anonymous mapping
  * @vma: the vma to be mmapped is prepared by do_mmap_pgoff
@@ -4095,10 +4103,7 @@ int shmem_zero_setup(struct vm_area_struct *vma)
 	if (IS_ERR(file))
 		return PTR_ERR(file);
 
-	if (vma->vm_file)
-		fput(vma->vm_file);
-	vma->vm_file = file;
-	vma->vm_ops = &shmem_vm_ops;
+	shmem_set_file(vma, file);
 
 	if (IS_ENABLED(CONFIG_TRANSPARENT_HUGE_PAGECACHE) &&
 			((vma->vm_start + ~HPAGE_PMD_MASK) & HPAGE_PMD_MASK) <
diff --git a/mm/slab_common.c b/mm/slab_common.c
index 622f6b6..0dc614d 100644
--- a/mm/slab_common.c
+++ b/mm/slab_common.c
@@ -458,6 +458,9 @@ struct kmem_cache *
 static int shutdown_cache(struct kmem_cache *s,
 		struct list_head *release, bool *need_rcu_barrier)
 {
+	/* free asan quarantined objects */
+	kasan_cache_shutdown(s);
+
 	if (__kmem_cache_shutdown(s) != 0)
 		return -EBUSY;
 
@@ -741,7 +744,6 @@ void kmem_cache_destroy(struct kmem_cache *s)
 	get_online_cpus();
 	get_online_mems();
 
-	kasan_cache_destroy(s);
 	mutex_lock(&slab_mutex);
 
 	s->refcount--;
diff --git a/mm/sparse-vmemmap.c b/mm/sparse-vmemmap.c
index 574c67b..4a01293 100644
--- a/mm/sparse-vmemmap.c
+++ b/mm/sparse-vmemmap.c
@@ -26,10 +26,14 @@
 #include <linux/spinlock.h>
 #include <linux/vmalloc.h>
 #include <linux/sched.h>
+#include <linux/memblock.h>
 #include <asm/dma.h>
 #include <asm/pgalloc.h>
 #include <asm/pgtable.h>
 
+extern int saving_section_page_table_xen_low;
+extern int saving_section_page_table;
+
 /*
  * Allocate a block of memory to be used to back the virtual memory map
  * or to back the page tables that are used to create the mapping.
@@ -258,6 +262,143 @@ struct page * __meminit sparse_mem_map_populate(unsigned long pnum, int nid)
 	start = (unsigned long)map;
 	end = (unsigned long)(map + PAGES_PER_SECTION);
 
+#if 0
+	DDDD("map %p, pnum %lld, PAGES_PER_SECTION 0x%08x, nid %d",
+		map, pnum, PAGES_PER_SECTION, nid);
+	DDDD("start 0x%llx", start);
+	DDDD("end   0x%llx", end);
+	DDDD("memblock.memory.cnt %d", memblock.memory.cnt);
+	DDDD("saving_section_page_table %d", saving_section_page_table);
+#endif
+
+#ifndef CONFIG_ARM64_64K_PAGES
+	/* workaroud for memory saving */
+	/* only for memory size less than 1-GB system */
+	/* suppose using continuous memory block */
+	/*                                     */
+	/*             pnum 0 +---------+                   */
+	/*           /        +  PMD 0  |                   */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 1  |                   */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 2  |                   */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 3  |                   */
+	/*  1GB     <         +---------+                   */
+	/* (section0)|        +  PMD 4  |                   */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 5  |                   */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 6  |                   */
+	/*           |        +---------+                   */
+	/*           \        +  PMD 7  |                   */
+	/*             pnum 1 +---------+                   */
+	/*           /        +  PMD 8  | PMD_lower         */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 9  |         PMD_start */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 10 |                   */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 11 |                   */
+	/*  1GB     <         +---------+                   */
+	/* (section1)|        +  PMD 12 |         PMD_end   */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 13 |                   */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 14 |                   */
+	/*           |        +---------+                   */
+	/*           \        +  PMD 15 |                   */
+	/*             pnum 2 +---------+                   */
+	/*           /        +  PMD 16 | PMD_upper         */
+	/*           |        +---------+                   */
+	/*           |        +  PMD 17 |                   */
+	/*           |        +---------+                   */
+	/*                                                  */
+	if( saving_section_page_table &&
+		(memblock.memory.cnt == 1) )
+	{
+		#define PMD_MEM_SIZE (((PAGES_PER_SECTION>>3)<<PAGE_SHIFT))
+		unsigned long PMD_lower;
+		unsigned long PMD_uppder;
+		unsigned long PMD_start;
+		unsigned long PMD_count;
+		unsigned long PMD_end;
+		unsigned long start_phy;
+		unsigned long end_phy;
+
+		PMD_lower = pnum<<3;
+		PMD_uppder = PMD_lower+8;
+		PMD_start = memblock.memory.regions[0].base / PMD_MEM_SIZE;
+		PMD_count = (memblock.memory.regions[0].size+PMD_MEM_SIZE-1)
+			/ PMD_MEM_SIZE;
+		PMD_end = PMD_start + PMD_count;
+
+		//DDDD("PMD_start 0x%llx", PMD_start);
+		//DDDD("PMD_count 0x%llx", PMD_count);
+		//DDDD("PMD_end   0x%llx", PMD_end);
+
+		if(PMD_start > PMD_lower) { /* not fall in valid range */
+			start = (unsigned long)(map +
+				((PMD_start-PMD_lower)*(PAGES_PER_SECTION>>3)));
+		}
+
+		if(PMD_end < PMD_uppder) { /* not fall in valid range */
+			end = (unsigned long)(map +
+				((PMD_end-PMD_lower)*(PAGES_PER_SECTION>>3)));
+		}
+
+		start_phy = (pnum * PAGES_PER_SECTION) << PAGE_SHIFT;
+		end_phy = ((pnum+1) * PAGES_PER_SECTION) << PAGE_SHIFT;
+
+		//DDDD("updated: start 0x%llx", start);
+		//DDDD("updated: end   0x%llx", end);
+	}
+
+	if( saving_section_page_table_xen_low )
+	{
+		/* for low memory dom0 system, its memory layout maybe present in */
+		/* non-continuous block. For example:                             */
+		/* root@OpenWrt:/# cat /sys/kernel/debug/memblock/memory          */
+		/* 0: 0x0000000033800000..0x000000003bffffff                      */
+		/* 1: 0x000000003e000000..0x000000003f7fffff                      */
+		#define PMD_MEM_SIZE (((PAGES_PER_SECTION>>3)<<PAGE_SHIFT))
+		unsigned long PMD_lower;
+		unsigned long PMD_uppder;
+		unsigned long PMD_start;
+		unsigned long PMD_end;
+		unsigned long start_phy;
+		unsigned long end_phy;
+
+		printk("old: start 0x%llx", start);
+		printk("old: end   0x%llx", end);
+
+		PMD_lower = pnum<<3;
+		PMD_uppder = PMD_lower+8;
+		PMD_start = memblock.memory.regions[0].base / PMD_MEM_SIZE;
+		PMD_end = (memblock.memory.regions[memblock.memory.cnt-1].base +
+			memblock.memory.regions[memblock.memory.cnt-1].size +
+			PMD_MEM_SIZE-1) / PMD_MEM_SIZE;
+
+		printk("\033[1;33m" "PMD_start %d" "\033[m\n", PMD_start);
+		printk("\033[1;33m" "PMD_end %d" "\033[m\n", PMD_end);
+
+		if(PMD_start > PMD_lower) { /* not fall in valid range */
+			start = (unsigned long)(map +
+				((PMD_start-PMD_lower)*(PAGES_PER_SECTION>>3)));
+		}
+
+		if(PMD_end < PMD_uppder) { /* not fall in valid range */
+			end = (unsigned long)(map +
+				((PMD_end-PMD_lower)*(PAGES_PER_SECTION>>3)));
+		}
+
+		start_phy = (pnum * PAGES_PER_SECTION) << PAGE_SHIFT;
+		end_phy = ((pnum+1) * PAGES_PER_SECTION) << PAGE_SHIFT;
+
+		printk("updated: start 0x%llx", start);
+		printk("updated: end   0x%llx", end);
+	}
+#endif
 	if (vmemmap_populate(start, end, nid))
 		return NULL;
 
diff --git a/mm/swap.c b/mm/swap.c
index 4dcf852..e75bb40 100644
--- a/mm/swap.c
+++ b/mm/swap.c
@@ -954,15 +954,25 @@ unsigned pagevec_lookup(struct pagevec *pvec, struct address_space *mapping,
 }
 EXPORT_SYMBOL(pagevec_lookup);
 
-unsigned pagevec_lookup_tag(struct pagevec *pvec, struct address_space *mapping,
-		pgoff_t *index, int tag, unsigned nr_pages)
+unsigned pagevec_lookup_range_tag(struct pagevec *pvec,
+		struct address_space *mapping, pgoff_t *index, pgoff_t end,
+		int tag)
 {
-	pvec->nr = find_get_pages_tag(mapping, index, tag,
-					nr_pages, pvec->pages);
+	pvec->nr = find_get_pages_range_tag(mapping, index, end, tag,
+					PAGEVEC_SIZE, pvec->pages);
 	return pagevec_count(pvec);
 }
-EXPORT_SYMBOL(pagevec_lookup_tag);
+EXPORT_SYMBOL(pagevec_lookup_range_tag);
 
+unsigned pagevec_lookup_range_nr_tag(struct pagevec *pvec,
+		struct address_space *mapping, pgoff_t *index, pgoff_t end,
+		int tag, unsigned max_pages)
+{
+	pvec->nr = find_get_pages_range_tag(mapping, index, end, tag,
+		min_t(unsigned int, max_pages, PAGEVEC_SIZE), pvec->pages);
+	return pagevec_count(pvec);
+}
+EXPORT_SYMBOL(pagevec_lookup_range_nr_tag);
 /*
  * Perform any setup for the swap system
  */
diff --git a/mm/swapfile.c b/mm/swapfile.c
index 79c03ec..169b790 100644
--- a/mm/swapfile.c
+++ b/mm/swapfile.c
@@ -2617,6 +2617,7 @@ void si_swapinfo(struct sysinfo *val)
 	val->totalswap = total_swap_pages + nr_to_be_unused;
 	spin_unlock(&swap_lock);
 }
+EXPORT_SYMBOL_GPL(si_swapinfo);
 
 /*
  * Verify that a swap entry is valid and increment its swap map count.
diff --git a/mm/vmalloc.c b/mm/vmalloc.c
index fa59816..eea0f09 100644
--- a/mm/vmalloc.c
+++ b/mm/vmalloc.c
@@ -2721,3 +2721,14 @@ static int __init proc_vmalloc_init(void)
 
 #endif
 
+#ifdef CONFIG_RTK_TRACER
+void external_vmap_area_lock(void)
+{
+	spin_lock(&vmap_area_lock);
+}
+
+void external_vmap_area_unlock(void)
+{
+	spin_unlock(&vmap_area_lock);
+}
+#endif /* CONFIG_RTK_TRACE */
diff --git a/net/Kconfig b/net/Kconfig
index 7b6cd34..3775760 100644
--- a/net/Kconfig
+++ b/net/Kconfig
@@ -89,6 +89,12 @@ source "net/netlabel/Kconfig"
 
 endif # if INET
 
+config ANDROID_PARANOID_NETWORK
+	bool "Only allow certain groups to create sockets"
+	default y
+	help
+		none
+
 config NETWORK_SECMARK
 	bool "Security Marking"
 	help
@@ -258,10 +264,6 @@ config XPS
 config HWBM
        bool
 
-config SOCK_CGROUP_DATA
-	bool
-	default n
-
 config CGROUP_NET_PRIO
 	bool "Network priority cgroup"
 	depends on CGROUPS
@@ -292,6 +294,7 @@ config BPF_JIT
 	bool "enable BPF Just In Time compiler"
 	depends on HAVE_CBPF_JIT || HAVE_EBPF_JIT
 	depends on MODULES
+	depends on !CFI
 	---help---
 	  Berkeley Packet Filter filtering capabilities are normally handled
 	  by an interpreter. This option allows kernel to generate a native
diff --git a/net/bluetooth/af_bluetooth.c b/net/bluetooth/af_bluetooth.c
index 5d36981..ec313c9 100644
--- a/net/bluetooth/af_bluetooth.c
+++ b/net/bluetooth/af_bluetooth.c
@@ -106,11 +106,40 @@ void bt_sock_unregister(int proto)
 }
 EXPORT_SYMBOL(bt_sock_unregister);
 
+#ifdef CONFIG_PARANOID_NETWORK
+static inline int current_has_bt_admin(void)
+{
+	return !current_euid();
+}
+
+static inline int current_has_bt(void)
+{
+	return current_has_bt_admin();
+}
+# else
+static inline int current_has_bt_admin(void)
+{
+	return 1;
+}
+
+static inline int current_has_bt(void)
+{
+	return 1;
+}
+#endif
+
 static int bt_sock_create(struct net *net, struct socket *sock, int proto,
 			  int kern)
 {
 	int err;
 
+	if (proto == BTPROTO_RFCOMM || proto == BTPROTO_SCO ||
+			proto == BTPROTO_L2CAP) {
+		if (!current_has_bt())
+			return -EPERM;
+	} else if (!current_has_bt_admin())
+		return -EPERM;
+
 	if (net != &init_net)
 		return -EAFNOSUPPORT;
 
diff --git a/net/bridge/br_device.c b/net/bridge/br_device.c
index 5f5e28f..04eea2f 100644
--- a/net/bridge/br_device.c
+++ b/net/bridge/br_device.c
@@ -48,11 +48,6 @@ netdev_tx_t br_dev_xmit(struct sk_buff *skb, struct net_device *dev)
 		return NETDEV_TX_OK;
 	}
 
-	u64_stats_update_begin(&brstats->syncp);
-	brstats->tx_packets++;
-	brstats->tx_bytes += skb->len;
-	u64_stats_update_end(&brstats->syncp);
-
 #ifdef CONFIG_NET_SWITCHDEV
 	skb->offload_fwd_mark = 0;
 #endif
@@ -61,6 +56,12 @@ netdev_tx_t br_dev_xmit(struct sk_buff *skb, struct net_device *dev)
 	skb_reset_mac_header(skb);
 	skb_pull(skb, ETH_HLEN);
 
+	u64_stats_update_begin(&brstats->syncp);
+	brstats->tx_packets++;
+	/* Exclude ETH_HLEN from byte stats for consistency with Rx chain */
+	brstats->tx_bytes += skb->len;
+	u64_stats_update_end(&brstats->syncp);
+
 	if (!br_allowed_ingress(br, br_vlan_group_rcu(br), skb, &vid))
 		goto out;
 
diff --git a/net/core/dev.c b/net/core/dev.c
index 5407d5f..a658030 100644
--- a/net/core/dev.c
+++ b/net/core/dev.c
@@ -1222,6 +1222,7 @@ int dev_change_name(struct net_device *dev, const char *newname)
 
 	return err;
 }
+EXPORT_SYMBOL(dev_change_name);
 
 /**
  *	dev_set_alias - change ifalias of a device
diff --git a/net/core/fib_rules.c b/net/core/fib_rules.c
index be4629c..31c4041 100644
--- a/net/core/fib_rules.c
+++ b/net/core/fib_rules.c
@@ -18,6 +18,11 @@
 #include <net/fib_rules.h>
 #include <net/ip_tunnels.h>
 
+static const struct fib_kuid_range fib_kuid_range_unset = {
+	KUIDT_INIT(0),
+	KUIDT_INIT(~0),
+};
+
 int fib_default_rule_add(struct fib_rules_ops *ops,
 			 u32 pref, u32 table, u32 flags)
 {
@@ -33,6 +38,7 @@ int fib_default_rule_add(struct fib_rules_ops *ops,
 	r->table = table;
 	r->flags = flags;
 	r->fr_net = ops->fro_net;
+	r->uid_range = fib_kuid_range_unset;
 
 	r->suppress_prefixlen = -1;
 	r->suppress_ifgroup = -1;
@@ -172,6 +178,34 @@ void fib_rules_unregister(struct fib_rules_ops *ops)
 }
 EXPORT_SYMBOL_GPL(fib_rules_unregister);
 
+static int uid_range_set(struct fib_kuid_range *range)
+{
+	return uid_valid(range->start) && uid_valid(range->end);
+}
+
+static struct fib_kuid_range nla_get_kuid_range(struct nlattr **tb)
+{
+	struct fib_rule_uid_range *in;
+	struct fib_kuid_range out;
+
+	in = (struct fib_rule_uid_range *)nla_data(tb[FRA_UID_RANGE]);
+
+	out.start = make_kuid(current_user_ns(), in->start);
+	out.end = make_kuid(current_user_ns(), in->end);
+
+	return out;
+}
+
+static int nla_put_uid_range(struct sk_buff *skb, struct fib_kuid_range *range)
+{
+	struct fib_rule_uid_range out = {
+		from_kuid_munged(current_user_ns(), range->start),
+		from_kuid_munged(current_user_ns(), range->end)
+	};
+
+	return nla_put(skb, FRA_UID_RANGE, sizeof(out), &out);
+}
+
 static int fib_rule_match(struct fib_rule *rule, struct fib_rules_ops *ops,
 			  struct flowi *fl, int flags,
 			  struct fib_lookup_arg *arg)
@@ -193,6 +227,10 @@ static int fib_rule_match(struct fib_rule *rule, struct fib_rules_ops *ops,
 	if (rule->l3mdev && !l3mdev_fib_rule_match(rule->fr_net, fl, arg))
 		goto out;
 
+	if (uid_lt(fl->flowi_uid, rule->uid_range.start) ||
+	    uid_gt(fl->flowi_uid, rule->uid_range.end))
+		goto out;
+
 	ret = ops->match(rule, fl, flags);
 out:
 	return (rule->flags & FIB_RULE_INVERT) ? !ret : ret;
@@ -305,6 +343,10 @@ static int rule_exists(struct fib_rules_ops *ops, struct fib_rule_hdr *frh,
 		if (r->l3mdev != rule->l3mdev)
 			continue;
 
+		if (!uid_eq(r->uid_range.start, rule->uid_range.start) ||
+		    !uid_eq(r->uid_range.end, rule->uid_range.end))
+			continue;
+
 		if (!ops->compare(r, frh, tb))
 			continue;
 		return 1;
@@ -383,6 +425,7 @@ int fib_nl_newrule(struct sk_buff *skb, struct nlmsghdr *nlh)
 	if (tb[FRA_TUN_ID])
 		rule->tun_id = nla_get_be64(tb[FRA_TUN_ID]);
 
+	err = -EINVAL;
 	if (tb[FRA_L3MDEV]) {
 #ifdef CONFIG_NET_L3_MASTER_DEV
 		rule->l3mdev = nla_get_u8(tb[FRA_L3MDEV]);
@@ -404,7 +447,6 @@ int fib_nl_newrule(struct sk_buff *skb, struct nlmsghdr *nlh)
 	else
 		rule->suppress_ifgroup = -1;
 
-	err = -EINVAL;
 	if (tb[FRA_GOTO]) {
 		if (rule->action != FR_ACT_GOTO)
 			goto errout_free;
@@ -429,6 +471,21 @@ int fib_nl_newrule(struct sk_buff *skb, struct nlmsghdr *nlh)
 	if (rule->l3mdev && rule->table)
 		goto errout_free;
 
+	if (tb[FRA_UID_RANGE]) {
+		if (current_user_ns() != net->user_ns) {
+			err = -EPERM;
+			goto errout_free;
+		}
+
+		rule->uid_range = nla_get_kuid_range(tb);
+
+		if (!uid_range_set(&rule->uid_range) ||
+		    !uid_lte(rule->uid_range.start, rule->uid_range.end))
+			goto errout_free;
+	} else {
+		rule->uid_range = fib_kuid_range_unset;
+	}
+
 	if ((nlh->nlmsg_flags & NLM_F_EXCL) &&
 	    rule_exists(ops, frh, tb, rule)) {
 		err = -EEXIST;
@@ -497,6 +554,7 @@ int fib_nl_delrule(struct sk_buff *skb, struct nlmsghdr *nlh)
 	struct fib_rules_ops *ops = NULL;
 	struct fib_rule *rule, *tmp;
 	struct nlattr *tb[FRA_MAX+1];
+	struct fib_kuid_range range;
 	int err = -EINVAL;
 
 	if (nlh->nlmsg_len < nlmsg_msg_size(sizeof(*frh)))
@@ -516,6 +574,16 @@ int fib_nl_delrule(struct sk_buff *skb, struct nlmsghdr *nlh)
 	if (err < 0)
 		goto errout;
 
+	if (tb[FRA_UID_RANGE]) {
+		range = nla_get_kuid_range(tb);
+		if (!uid_range_set(&range)) {
+			err = -EINVAL;
+			goto errout;
+		}
+	} else {
+		range = fib_kuid_range_unset;
+	}
+
 	list_for_each_entry(rule, &ops->rules_list, list) {
 		if (frh->action && (frh->action != rule->action))
 			continue;
@@ -552,6 +620,11 @@ int fib_nl_delrule(struct sk_buff *skb, struct nlmsghdr *nlh)
 		    (rule->l3mdev != nla_get_u8(tb[FRA_L3MDEV])))
 			continue;
 
+		if (uid_range_set(&range) &&
+		    (!uid_eq(rule->uid_range.start, range.start) ||
+		     !uid_eq(rule->uid_range.end, range.end)))
+			continue;
+
 		if (!ops->compare(rule, frh, tb))
 			continue;
 
@@ -619,7 +692,8 @@ static inline size_t fib_rule_nlmsg_size(struct fib_rules_ops *ops,
 			 + nla_total_size(4) /* FRA_SUPPRESS_IFGROUP */
 			 + nla_total_size(4) /* FRA_FWMARK */
 			 + nla_total_size(4) /* FRA_FWMASK */
-			 + nla_total_size_64bit(8); /* FRA_TUN_ID */
+			 + nla_total_size_64bit(8) /* FRA_TUN_ID */
+			 + nla_total_size(sizeof(struct fib_kuid_range));
 
 	if (ops->nlmsg_payload)
 		payload += ops->nlmsg_payload(rule);
@@ -679,7 +753,9 @@ static int fib_nl_fill_rule(struct sk_buff *skb, struct fib_rule *rule,
 	    (rule->tun_id &&
 	     nla_put_be64(skb, FRA_TUN_ID, rule->tun_id, FRA_PAD)) ||
 	    (rule->l3mdev &&
-	     nla_put_u8(skb, FRA_L3MDEV, rule->l3mdev)))
+	     nla_put_u8(skb, FRA_L3MDEV, rule->l3mdev)) ||
+	    (uid_range_set(&rule->uid_range) &&
+	     nla_put_uid_range(skb, &rule->uid_range)))
 		goto nla_put_failure;
 
 	if (rule->suppress_ifgroup != -1) {
diff --git a/net/core/filter.c b/net/core/filter.c
index e8c89d2..c385c55 100644
--- a/net/core/filter.c
+++ b/net/core/filter.c
@@ -26,6 +26,7 @@
 #include <linux/mm.h>
 #include <linux/fcntl.h>
 #include <linux/socket.h>
+#include <linux/sock_diag.h>
 #include <linux/in.h>
 #include <linux/inet.h>
 #include <linux/netdevice.h>
@@ -78,6 +79,10 @@ int sk_filter_trim_cap(struct sock *sk, struct sk_buff *skb, unsigned int cap)
 	if (skb_pfmemalloc(skb) && !sock_flag(sk, SOCK_MEMALLOC))
 		return -ENOMEM;
 
+	err = BPF_CGROUP_RUN_PROG_INET_INGRESS(sk, skb);
+	if (err)
+		return err;
+
 	err = security_sock_rcv_skb(sk, skb);
 	if (err)
 		return err;
@@ -85,7 +90,12 @@ int sk_filter_trim_cap(struct sock *sk, struct sk_buff *skb, unsigned int cap)
 	rcu_read_lock();
 	filter = rcu_dereference(sk->sk_filter);
 	if (filter) {
-		unsigned int pkt_len = bpf_prog_run_save_cb(filter->prog, skb);
+		struct sock *save_sk = skb->sk;
+		unsigned int pkt_len;
+
+		skb->sk = sk;
+		pkt_len = bpf_prog_run_save_cb(filter->prog, skb);
+		skb->sk = save_sk;
 		err = pkt_len ? pskb_trim(skb, max(cap, pkt_len)) : -EPERM;
 	}
 	rcu_read_unlock();
@@ -2533,6 +2543,36 @@ static unsigned long bpf_xdp_copy(void *dst_buff, const void *src_buff,
 	.arg5_type	= ARG_CONST_STACK_SIZE,
 };
 
+BPF_CALL_1(bpf_get_socket_cookie, struct sk_buff *, skb)
+{
+	return skb->sk ? sock_gen_cookie(skb->sk) : 0;
+}
+
+static const struct bpf_func_proto bpf_get_socket_cookie_proto = {
+	.func           = bpf_get_socket_cookie,
+	.gpl_only       = false,
+	.ret_type       = RET_INTEGER,
+	.arg1_type      = ARG_PTR_TO_CTX,
+};
+
+BPF_CALL_1(bpf_get_socket_uid, struct sk_buff *, skb)
+{
+	struct sock *sk = sk_to_full_sk(skb->sk);
+	kuid_t kuid;
+
+	if (!sk || !sk_fullsock(sk))
+		return overflowuid;
+	kuid = sock_net_uid(sock_net(sk), sk);
+	return from_kuid_munged(sock_net(sk)->user_ns, kuid);
+}
+
+static const struct bpf_func_proto bpf_get_socket_uid_proto = {
+	.func           = bpf_get_socket_uid,
+	.gpl_only       = false,
+	.ret_type       = RET_INTEGER,
+	.arg1_type      = ARG_PTR_TO_CTX,
+};
+
 static const struct bpf_func_proto *
 sk_filter_func_proto(enum bpf_func_id func_id)
 {
@@ -2554,6 +2594,10 @@ static unsigned long bpf_xdp_copy(void *dst_buff, const void *src_buff,
 	case BPF_FUNC_trace_printk:
 		if (capable(CAP_SYS_ADMIN))
 			return bpf_get_trace_printk_proto();
+	case BPF_FUNC_get_socket_cookie:
+		return &bpf_get_socket_cookie_proto;
+	case BPF_FUNC_get_socket_uid:
+		return &bpf_get_socket_uid_proto;
 	default:
 		return NULL;
 	}
@@ -2631,6 +2675,17 @@ static unsigned long bpf_xdp_copy(void *dst_buff, const void *src_buff,
 	}
 }
 
+static const struct bpf_func_proto *
+cg_skb_func_proto(enum bpf_func_id func_id)
+{
+	switch (func_id) {
+	case BPF_FUNC_skb_load_bytes:
+		return &bpf_skb_load_bytes_proto;
+	default:
+		return sk_filter_func_proto(func_id);
+	}
+}
+
 static bool __is_valid_access(int off, int size, enum bpf_access_type type)
 {
 	if (off < 0 || off >= sizeof(struct __sk_buff))
@@ -2993,6 +3048,12 @@ static u32 xdp_convert_ctx_access(enum bpf_access_type type, int dst_reg,
 	.convert_ctx_access	= xdp_convert_ctx_access,
 };
 
+static const struct bpf_verifier_ops cg_skb_ops = {
+	.get_func_proto		= cg_skb_func_proto,
+	.is_valid_access	= sk_filter_is_valid_access,
+	.convert_ctx_access	= sk_filter_convert_ctx_access,
+};
+
 static struct bpf_prog_type_list sk_filter_type __read_mostly = {
 	.ops	= &sk_filter_ops,
 	.type	= BPF_PROG_TYPE_SOCKET_FILTER,
@@ -3013,12 +3074,18 @@ static u32 xdp_convert_ctx_access(enum bpf_access_type type, int dst_reg,
 	.type	= BPF_PROG_TYPE_XDP,
 };
 
+static struct bpf_prog_type_list cg_skb_type __read_mostly = {
+	.ops	= &cg_skb_ops,
+	.type	= BPF_PROG_TYPE_CGROUP_SKB,
+};
+
 static int __init register_sk_filter_ops(void)
 {
 	bpf_register_prog_type(&sk_filter_type);
 	bpf_register_prog_type(&sched_cls_type);
 	bpf_register_prog_type(&sched_act_type);
 	bpf_register_prog_type(&xdp_type);
+	bpf_register_prog_type(&cg_skb_type);
 
 	return 0;
 }
diff --git a/net/core/netpoll.c b/net/core/netpoll.c
index 457f882..9b2d6112 100644
--- a/net/core/netpoll.c
+++ b/net/core/netpoll.c
@@ -666,7 +666,7 @@ int netpoll_setup(struct netpoll *np)
 	int err;
 
 	rtnl_lock();
-	if (np->dev_name) {
+	if (np->dev_name[0]) {
 		struct net *net = current->nsproxy->net_ns;
 		ndev = __dev_get_by_name(net, np->dev_name);
 	}
diff --git a/net/core/sock.c b/net/core/sock.c
index 1c4c434..0e82197 100644
--- a/net/core/sock.c
+++ b/net/core/sock.c
@@ -1031,6 +1031,7 @@ int sock_getsockopt(struct socket *sock, int level, int optname,
 
 	union {
 		int val;
+		u64 val64;
 		struct linger ling;
 		struct timeval tm;
 	} v;
@@ -1261,6 +1262,13 @@ int sock_getsockopt(struct socket *sock, int level, int optname,
 		v.val = sk->sk_incoming_cpu;
 		break;
 
+
+	case SO_COOKIE:
+		lv = sizeof(u64);
+		if (len < lv)
+			return -EINVAL;
+		v.val64 = sock_gen_cookie(sk);
+		break;
 	default:
 		/* We implement the SO_SNDLOWAT etc to not be settable
 		 * (1003.1g 7).
@@ -2441,8 +2449,11 @@ void sock_init_data(struct socket *sock, struct sock *sk)
 		sk->sk_type	=	sock->type;
 		sk->sk_wq	=	sock->wq;
 		sock->sk	=	sk;
-	} else
+		sk->sk_uid	=	SOCK_INODE(sock)->i_uid;
+	} else {
 		sk->sk_wq	=	NULL;
+		sk->sk_uid	=	make_kuid(sock_net(sk)->user_ns, 0);
+	}
 
 	rwlock_init(&sk->sk_callback_lock);
 	lockdep_set_class_and_name(&sk->sk_callback_lock,
diff --git a/net/core/sock_diag.c b/net/core/sock_diag.c
index d1d9faf..fb467db 100644
--- a/net/core/sock_diag.c
+++ b/net/core/sock_diag.c
@@ -19,7 +19,7 @@
 static DEFINE_MUTEX(sock_diag_table_mutex);
 static struct workqueue_struct *broadcast_wq;
 
-static u64 sock_gen_cookie(struct sock *sk)
+u64 sock_gen_cookie(struct sock *sk)
 {
 	while (1) {
 		u64 res = atomic64_read(&sk->sk_cookie);
diff --git a/net/dns_resolver/dns_query.c b/net/dns_resolver/dns_query.c
index ecc28cf..d502c94 100644
--- a/net/dns_resolver/dns_query.c
+++ b/net/dns_resolver/dns_query.c
@@ -70,7 +70,7 @@ int dns_query(const char *type, const char *name, size_t namelen,
 	      const char *options, char **_result, time64_t *_expiry)
 {
 	struct key *rkey;
-	const struct user_key_payload *upayload;
+	struct user_key_payload *upayload;
 	const struct cred *saved_cred;
 	size_t typelen, desclen;
 	char *desc, *cp;
@@ -141,7 +141,7 @@ int dns_query(const char *type, const char *name, size_t namelen,
 	if (ret)
 		goto put;
 
-	upayload = user_key_payload(rkey);
+	upayload = user_key_payload_locked(rkey);
 	len = upayload->datalen;
 
 	ret = -ENOMEM;
diff --git a/net/ipv4/Makefile b/net/ipv4/Makefile
index bc6a6c8..a8b934a 100644
--- a/net/ipv4/Makefile
+++ b/net/ipv4/Makefile
@@ -16,6 +16,7 @@ obj-y     := route.o inetpeer.o protocol.o \
 
 obj-$(CONFIG_NET_IP_TUNNEL) += ip_tunnel.o
 obj-$(CONFIG_SYSCTL) += sysctl_net_ipv4.o
+obj-$(CONFIG_SYSFS) += sysfs_net_ipv4.o
 obj-$(CONFIG_PROC_FS) += proc.o
 obj-$(CONFIG_IP_MULTIPLE_TABLES) += fib_rules.o
 obj-$(CONFIG_IP_MROUTE) += ipmr.o
diff --git a/net/ipv4/af_inet.c b/net/ipv4/af_inet.c
index b5116ec..01cda5b 100644
--- a/net/ipv4/af_inet.c
+++ b/net/ipv4/af_inet.c
@@ -89,6 +89,7 @@
 #include <linux/netfilter_ipv4.h>
 #include <linux/random.h>
 #include <linux/slab.h>
+#include <linux/netfilter/xt_qtaguid.h>
 
 #include <asm/uaccess.h>
 
@@ -121,6 +122,19 @@
 #endif
 #include <net/l3mdev.h>
 
+#ifdef CONFIG_ANDROID_PARANOID_NETWORK
+#include <linux/android_aid.h>
+
+static inline int current_has_network(void)
+{
+	return in_egroup_p(AID_INET) || capable(CAP_NET_RAW);
+}
+#else
+static inline int current_has_network(void)
+{
+	return 1;
+}
+#endif
 
 /* The inetsw table contains everything that inet_create needs to
  * build a new socket.
@@ -255,6 +269,9 @@ static int inet_create(struct net *net, struct socket *sock, int protocol,
 	if (protocol < 0 || protocol >= IPPROTO_MAX)
 		return -EINVAL;
 
+	if (!current_has_network())
+		return -EACCES;
+
 	sock->state = SS_UNCONNECTED;
 
 	/* Look for the requested type/protocol pair. */
@@ -303,8 +320,7 @@ static int inet_create(struct net *net, struct socket *sock, int protocol,
 	}
 
 	err = -EPERM;
-	if (sock->type == SOCK_RAW && !kern &&
-	    !ns_capable(net->user_ns, CAP_NET_RAW))
+	if (sock->type == SOCK_RAW && !kern && !capable(CAP_NET_RAW))
 		goto out_rcu_unlock;
 
 	sock->ops = answer->ops;
@@ -397,6 +413,9 @@ int inet_release(struct socket *sock)
 	if (sk) {
 		long timeout;
 
+#ifdef CONFIG_NETFILTER_XT_MATCH_QTAGUID
+		qtaguid_untag(sock, true);
+#endif
 		/* Applications forget to leave groups before exiting */
 		ip_mc_drop_socket(sk);
 
@@ -566,13 +585,24 @@ int __inet_stream_connect(struct socket *sock, struct sockaddr *uaddr,
 	int err;
 	long timeo;
 
-	if (addr_len < sizeof(uaddr->sa_family))
-		return -EINVAL;
+	/*
+	 * uaddr can be NULL and addr_len can be 0 if:
+	 * sk is a TCP fastopen active socket and
+	 * TCP_FASTOPEN_CONNECT sockopt is set and
+	 * we already have a valid cookie for this socket.
+	 * In this case, user can call write() after connect().
+	 * write() will invoke tcp_sendmsg_fastopen() which calls
+	 * __inet_stream_connect().
+	 */
+	if (uaddr) {
+		if (addr_len < sizeof(uaddr->sa_family))
+			return -EINVAL;
 
-	if (uaddr->sa_family == AF_UNSPEC) {
-		err = sk->sk_prot->disconnect(sk, flags);
-		sock->state = err ? SS_DISCONNECTING : SS_UNCONNECTED;
-		goto out;
+		if (uaddr->sa_family == AF_UNSPEC) {
+			err = sk->sk_prot->disconnect(sk, flags);
+			sock->state = err ? SS_DISCONNECTING : SS_UNCONNECTED;
+			goto out;
+		}
 	}
 
 	switch (sock->state) {
@@ -583,7 +613,10 @@ int __inet_stream_connect(struct socket *sock, struct sockaddr *uaddr,
 		err = -EISCONN;
 		goto out;
 	case SS_CONNECTING:
-		err = -EALREADY;
+		if (inet_sk(sk)->defer_connect)
+			err = -EINPROGRESS;
+		else
+			err = -EALREADY;
 		/* Fall out of switch with err, set for this state */
 		break;
 	case SS_UNCONNECTED:
@@ -597,6 +630,9 @@ int __inet_stream_connect(struct socket *sock, struct sockaddr *uaddr,
 
 		sock->state = SS_CONNECTING;
 
+		if (!err && inet_sk(sk)->defer_connect)
+			goto out;
+
 		/* Just entered SS_CONNECTING state; the only
 		 * difference is that return value in non-blocking
 		 * case is EINPROGRESS, rather than EALREADY.
diff --git a/net/ipv4/fib_frontend.c b/net/ipv4/fib_frontend.c
index 6a2ef16..78ee2fc 100644
--- a/net/ipv4/fib_frontend.c
+++ b/net/ipv4/fib_frontend.c
@@ -320,7 +320,7 @@ static int __fib_validate_source(struct sk_buff *skb, __be32 src, __be32 dst,
 	int ret, no_addr;
 	struct fib_result res;
 	struct flowi4 fl4;
-	struct net *net;
+	struct net *net = dev_net(dev);
 	bool dev_match;
 
 	fl4.flowi4_oif = 0;
@@ -333,6 +333,7 @@ static int __fib_validate_source(struct sk_buff *skb, __be32 src, __be32 dst,
 	fl4.flowi4_scope = RT_SCOPE_UNIVERSE;
 	fl4.flowi4_tun_key.tun_id = 0;
 	fl4.flowi4_flags = 0;
+	fl4.flowi4_uid = sock_net_uid(net, NULL);
 
 	no_addr = idev->ifa_list == NULL;
 
@@ -340,13 +341,12 @@ static int __fib_validate_source(struct sk_buff *skb, __be32 src, __be32 dst,
 
 	trace_fib_validate_source(dev, &fl4);
 
-	net = dev_net(dev);
 	if (fib_lookup(net, &fl4, &res, 0))
 		goto last_resort;
 	if (res.type != RTN_UNICAST &&
 	    (res.type != RTN_LOCAL || !IN_DEV_ACCEPT_LOCAL(idev)))
 		goto e_inval;
-	if (!rpf && !fib_num_tclassid_users(dev_net(dev)) &&
+	if (!rpf && !fib_num_tclassid_users(net) &&
 	    (dev->ifindex != oif || !IN_DEV_TX_REDIRECTS(idev)))
 		goto last_resort;
 	fib_combine_itag(itag, &res);
@@ -622,6 +622,7 @@ int ip_rt_ioctl(struct net *net, unsigned int cmd, void __user *arg)
 	[RTA_FLOW]		= { .type = NLA_U32 },
 	[RTA_ENCAP_TYPE]	= { .type = NLA_U16 },
 	[RTA_ENCAP]		= { .type = NLA_NESTED },
+	[RTA_UID]		= { .type = NLA_U32 },
 };
 
 static int rtm_to_fib_config(struct net *net, struct sk_buff *skb,
diff --git a/net/ipv4/icmp.c b/net/ipv4/icmp.c
index 31f17f0..42a19fb 100644
--- a/net/ipv4/icmp.c
+++ b/net/ipv4/icmp.c
@@ -425,6 +425,7 @@ static void icmp_reply(struct icmp_bxm *icmp_param, struct sk_buff *skb)
 	fl4.daddr = daddr;
 	fl4.saddr = saddr;
 	fl4.flowi4_mark = mark;
+	fl4.flowi4_uid = sock_net_uid(net, NULL);
 	fl4.flowi4_tos = RT_TOS(ip_hdr(skb)->tos);
 	fl4.flowi4_proto = IPPROTO_ICMP;
 	fl4.flowi4_oif = l3mdev_master_ifindex(skb->dev);
@@ -473,6 +474,7 @@ static struct rtable *icmp_route_lookup(struct net *net,
 		      param->replyopts.opt.opt.faddr : iph->saddr);
 	fl4->saddr = saddr;
 	fl4->flowi4_mark = mark;
+	fl4->flowi4_uid = sock_net_uid(net, NULL);
 	fl4->flowi4_tos = RT_TOS(tos);
 	fl4->flowi4_proto = IPPROTO_ICMP;
 	fl4->fl4_icmp_type = type;
diff --git a/net/ipv4/inet_connection_sock.c b/net/ipv4/inet_connection_sock.c
index d1cab49..2621838 100644
--- a/net/ipv4/inet_connection_sock.c
+++ b/net/ipv4/inet_connection_sock.c
@@ -417,7 +417,7 @@ struct dst_entry *inet_csk_route_req(const struct sock *sk,
 			   sk->sk_protocol, inet_sk_flowi_flags(sk),
 			   (opt && opt->opt.srr) ? opt->opt.faddr : ireq->ir_rmt_addr,
 			   ireq->ir_loc_addr, ireq->ir_rmt_port,
-			   htons(ireq->ir_num));
+			   htons(ireq->ir_num), sk->sk_uid);
 	security_req_classify_flow(req, flowi4_to_flowi(fl4));
 	rt = ip_route_output_flow(net, fl4, sk);
 	if (IS_ERR(rt))
@@ -453,7 +453,7 @@ struct dst_entry *inet_csk_route_child_sock(const struct sock *sk,
 			   sk->sk_protocol, inet_sk_flowi_flags(sk),
 			   (opt && opt->opt.srr) ? opt->opt.faddr : ireq->ir_rmt_addr,
 			   ireq->ir_loc_addr, ireq->ir_rmt_port,
-			   htons(ireq->ir_num));
+			   htons(ireq->ir_num), sk->sk_uid);
 	security_req_classify_flow(req, flowi4_to_flowi(fl4));
 	rt = ip_route_output_flow(net, fl4, sk);
 	if (IS_ERR(rt))
diff --git a/net/ipv4/ip_output.c b/net/ipv4/ip_output.c
index 100c86f..5fcafc8 100644
--- a/net/ipv4/ip_output.c
+++ b/net/ipv4/ip_output.c
@@ -74,6 +74,7 @@
 #include <net/checksum.h>
 #include <net/inetpeer.h>
 #include <net/lwtunnel.h>
+#include <linux/bpf-cgroup.h>
 #include <linux/igmp.h>
 #include <linux/netfilter_ipv4.h>
 #include <linux/netfilter_bridge.h>
@@ -287,6 +288,13 @@ static int ip_finish_output_gso(struct net *net, struct sock *sk,
 static int ip_finish_output(struct net *net, struct sock *sk, struct sk_buff *skb)
 {
 	unsigned int mtu;
+	int ret;
+
+	ret = BPF_CGROUP_RUN_PROG_INET_EGRESS(sk, skb);
+	if (ret) {
+		kfree_skb(skb);
+		return ret;
+	}
 
 #if defined(CONFIG_NETFILTER) && defined(CONFIG_XFRM)
 	/* Policy lookup after SNAT yielded a new policy */
@@ -305,6 +313,20 @@ static int ip_finish_output(struct net *net, struct sock *sk, struct sk_buff *sk
 	return ip_finish_output2(net, sk, skb);
 }
 
+static int ip_mc_finish_output(struct net *net, struct sock *sk,
+			       struct sk_buff *skb)
+{
+	int ret;
+
+	ret = BPF_CGROUP_RUN_PROG_INET_EGRESS(sk, skb);
+	if (ret) {
+		kfree_skb(skb);
+		return ret;
+	}
+
+	return dev_loopback_xmit(net, sk, skb);
+}
+
 int ip_mc_output(struct net *net, struct sock *sk, struct sk_buff *skb)
 {
 	struct rtable *rt = skb_rtable(skb);
@@ -342,7 +364,7 @@ int ip_mc_output(struct net *net, struct sock *sk, struct sk_buff *skb)
 			if (newskb)
 				NF_HOOK(NFPROTO_IPV4, NF_INET_POST_ROUTING,
 					net, sk, newskb, NULL, newskb->dev,
-					dev_loopback_xmit);
+					ip_mc_finish_output);
 		}
 
 		/* Multicasts with ttl 0 must not go beyond the host */
@@ -358,7 +380,7 @@ int ip_mc_output(struct net *net, struct sock *sk, struct sk_buff *skb)
 		if (newskb)
 			NF_HOOK(NFPROTO_IPV4, NF_INET_POST_ROUTING,
 				net, sk, newskb, NULL, newskb->dev,
-				dev_loopback_xmit);
+				ip_mc_finish_output);
 	}
 
 	return NF_HOOK_COND(NFPROTO_IPV4, NF_INET_POST_ROUTING,
@@ -1600,7 +1622,8 @@ void ip_send_unicast_reply(struct sock *sk, struct sk_buff *skb,
 			   RT_SCOPE_UNIVERSE, ip_hdr(skb)->protocol,
 			   ip_reply_arg_flowi_flags(arg),
 			   daddr, saddr,
-			   tcp_hdr(skb)->source, tcp_hdr(skb)->dest);
+			   tcp_hdr(skb)->source, tcp_hdr(skb)->dest,
+			   arg->uid);
 	security_skb_classify_flow(skb, flowi4_to_flowi(&fl4));
 	rt = ip_route_output_key(net, &fl4);
 	if (IS_ERR(rt))
diff --git a/net/ipv4/ping.c b/net/ipv4/ping.c
index 9adcd4b..8fa153c 100644
--- a/net/ipv4/ping.c
+++ b/net/ipv4/ping.c
@@ -798,7 +798,8 @@ static int ping_v4_sendmsg(struct sock *sk, struct msghdr *msg, size_t len)
 
 	flowi4_init_output(&fl4, ipc.oif, sk->sk_mark, tos,
 			   RT_SCOPE_UNIVERSE, sk->sk_protocol,
-			   inet_sk_flowi_flags(sk), faddr, saddr, 0, 0);
+			   inet_sk_flowi_flags(sk), faddr, saddr, 0, 0,
+			   sk->sk_uid);
 
 	security_sk_classify_flow(sk, flowi4_to_flowi(&fl4));
 	rt = ip_route_output_flow(net, &fl4, sk);
diff --git a/net/ipv4/raw.c b/net/ipv4/raw.c
index 59d8770..a860df2 100644
--- a/net/ipv4/raw.c
+++ b/net/ipv4/raw.c
@@ -612,7 +612,7 @@ static int raw_sendmsg(struct sock *sk, struct msghdr *msg, size_t len)
 			   hdrincl ? IPPROTO_RAW : sk->sk_protocol,
 			   inet_sk_flowi_flags(sk) |
 			    (hdrincl ? FLOWI_FLAG_KNOWN_NH : 0),
-			   daddr, saddr, 0, 0);
+			   daddr, saddr, 0, 0, sk->sk_uid);
 
 	if (!hdrincl) {
 		rfv.msg = msg;
diff --git a/net/ipv4/route.c b/net/ipv4/route.c
index 890141d..cec5e9e 100644
--- a/net/ipv4/route.c
+++ b/net/ipv4/route.c
@@ -510,7 +510,8 @@ void __ip_select_ident(struct net *net, struct iphdr *iph, int segs)
 }
 EXPORT_SYMBOL(__ip_select_ident);
 
-static void __build_flow_key(struct flowi4 *fl4, const struct sock *sk,
+static void __build_flow_key(const struct net *net, struct flowi4 *fl4,
+			     const struct sock *sk,
 			     const struct iphdr *iph,
 			     int oif, u8 tos,
 			     u8 prot, u32 mark, int flow_flags)
@@ -526,19 +527,21 @@ static void __build_flow_key(struct flowi4 *fl4, const struct sock *sk,
 	flowi4_init_output(fl4, oif, mark, tos,
 			   RT_SCOPE_UNIVERSE, prot,
 			   flow_flags,
-			   iph->daddr, iph->saddr, 0, 0);
+			   iph->daddr, iph->saddr, 0, 0,
+			   sock_net_uid(net, sk));
 }
 
 static void build_skb_flow_key(struct flowi4 *fl4, const struct sk_buff *skb,
 			       const struct sock *sk)
 {
+	const struct net *net = dev_net(skb->dev);
 	const struct iphdr *iph = ip_hdr(skb);
 	int oif = skb->dev->ifindex;
 	u8 tos = RT_TOS(iph->tos);
 	u8 prot = iph->protocol;
 	u32 mark = skb->mark;
 
-	__build_flow_key(fl4, sk, iph, oif, tos, prot, mark, 0);
+	__build_flow_key(net, fl4, sk, iph, oif, tos, prot, mark, 0);
 }
 
 static void build_sk_flow_key(struct flowi4 *fl4, const struct sock *sk)
@@ -555,7 +558,7 @@ static void build_sk_flow_key(struct flowi4 *fl4, const struct sock *sk)
 			   RT_CONN_FLAGS(sk), RT_SCOPE_UNIVERSE,
 			   inet->hdrincl ? IPPROTO_RAW : sk->sk_protocol,
 			   inet_sk_flowi_flags(sk),
-			   daddr, inet->inet_saddr, 0, 0);
+			   daddr, inet->inet_saddr, 0, 0, sk->sk_uid);
 	rcu_read_unlock();
 }
 
@@ -807,6 +810,7 @@ static void ip_do_redirect(struct dst_entry *dst, struct sock *sk, struct sk_buf
 	struct rtable *rt;
 	struct flowi4 fl4;
 	const struct iphdr *iph = (const struct iphdr *) skb->data;
+	struct net *net = dev_net(skb->dev);
 	int oif = skb->dev->ifindex;
 	u8 tos = RT_TOS(iph->tos);
 	u8 prot = iph->protocol;
@@ -814,7 +818,7 @@ static void ip_do_redirect(struct dst_entry *dst, struct sock *sk, struct sk_buf
 
 	rt = (struct rtable *) dst;
 
-	__build_flow_key(&fl4, sk, iph, oif, tos, prot, mark, 0);
+	__build_flow_key(net, &fl4, sk, iph, oif, tos, prot, mark, 0);
 	__ip_do_redirect(rt, skb, &fl4, true);
 }
 
@@ -1035,7 +1039,7 @@ void ipv4_update_pmtu(struct sk_buff *skb, struct net *net, u32 mtu,
 	if (!mark)
 		mark = IP4_REPLY_MARK(net, skb->mark);
 
-	__build_flow_key(&fl4, NULL, iph, oif,
+	__build_flow_key(net, &fl4, NULL, iph, oif,
 			 RT_TOS(iph->tos), protocol, mark, flow_flags);
 	rt = __ip_route_output_key(net, &fl4);
 	if (!IS_ERR(rt)) {
@@ -1051,7 +1055,7 @@ static void __ipv4_sk_update_pmtu(struct sk_buff *skb, struct sock *sk, u32 mtu)
 	struct flowi4 fl4;
 	struct rtable *rt;
 
-	__build_flow_key(&fl4, sk, iph, 0, 0, 0, 0, 0);
+	__build_flow_key(sock_net(sk), &fl4, sk, iph, 0, 0, 0, 0, 0);
 
 	if (!fl4.flowi4_mark)
 		fl4.flowi4_mark = IP4_REPLY_MARK(sock_net(sk), skb->mark);
@@ -1070,6 +1074,7 @@ void ipv4_sk_update_pmtu(struct sk_buff *skb, struct sock *sk, u32 mtu)
 	struct rtable *rt;
 	struct dst_entry *odst = NULL;
 	bool new = false;
+	struct net *net = sock_net(sk);
 
 	bh_lock_sock(sk);
 
@@ -1083,7 +1088,7 @@ void ipv4_sk_update_pmtu(struct sk_buff *skb, struct sock *sk, u32 mtu)
 		goto out;
 	}
 
-	__build_flow_key(&fl4, sk, iph, 0, 0, 0, 0, 0);
+	__build_flow_key(net, &fl4, sk, iph, 0, 0, 0, 0, 0);
 
 	rt = (struct rtable *)odst;
 	if (odst->obsolete && !odst->ops->check(odst, 0)) {
@@ -1123,7 +1128,7 @@ void ipv4_redirect(struct sk_buff *skb, struct net *net,
 	struct flowi4 fl4;
 	struct rtable *rt;
 
-	__build_flow_key(&fl4, NULL, iph, oif,
+	__build_flow_key(net, &fl4, NULL, iph, oif,
 			 RT_TOS(iph->tos), protocol, mark, flow_flags);
 	rt = __ip_route_output_key(net, &fl4);
 	if (!IS_ERR(rt)) {
@@ -1138,9 +1143,10 @@ void ipv4_sk_redirect(struct sk_buff *skb, struct sock *sk)
 	const struct iphdr *iph = (const struct iphdr *) skb->data;
 	struct flowi4 fl4;
 	struct rtable *rt;
+	struct net *net = sock_net(sk);
 
-	__build_flow_key(&fl4, sk, iph, 0, 0, 0, 0, 0);
-	rt = __ip_route_output_key(sock_net(sk), &fl4);
+	__build_flow_key(net, &fl4, sk, iph, 0, 0, 0, 0, 0);
+	rt = __ip_route_output_key(net, &fl4);
 	if (!IS_ERR(rt)) {
 		__ip_do_redirect(rt, skb, &fl4, false);
 		ip_rt_put(rt);
@@ -1870,6 +1876,7 @@ static int ip_route_input_slow(struct sk_buff *skb, __be32 daddr, __be32 saddr,
 	fl4.flowi4_flags = 0;
 	fl4.daddr = daddr;
 	fl4.saddr = saddr;
+	fl4.flowi4_uid = sock_net_uid(net, NULL);
 	err = fib_lookup(net, &fl4, &res, 0);
 	if (err != 0) {
 		if (!IN_DEV_FORWARD(in_dev))
@@ -2524,6 +2531,11 @@ static int rt_fill_info(struct net *net,  __be32 dst, __be32 src, u32 table_id,
 	    nla_put_u32(skb, RTA_MARK, fl4->flowi4_mark))
 		goto nla_put_failure;
 
+	if (!uid_eq(fl4->flowi4_uid, INVALID_UID) &&
+	    nla_put_u32(skb, RTA_UID,
+			from_kuid_munged(current_user_ns(), fl4->flowi4_uid)))
+		goto nla_put_failure;
+
 	error = rt->dst.error;
 
 	if (rt_is_input_route(rt)) {
@@ -2576,6 +2588,7 @@ static int inet_rtm_getroute(struct sk_buff *in_skb, struct nlmsghdr *nlh)
 	int mark;
 	struct sk_buff *skb;
 	u32 table_id = RT_TABLE_MAIN;
+	kuid_t uid;
 
 	err = nlmsg_parse(nlh, sizeof(*rtm), tb, RTA_MAX, rtm_ipv4_policy);
 	if (err < 0)
@@ -2603,6 +2616,10 @@ static int inet_rtm_getroute(struct sk_buff *in_skb, struct nlmsghdr *nlh)
 	dst = tb[RTA_DST] ? nla_get_in_addr(tb[RTA_DST]) : 0;
 	iif = tb[RTA_IIF] ? nla_get_u32(tb[RTA_IIF]) : 0;
 	mark = tb[RTA_MARK] ? nla_get_u32(tb[RTA_MARK]) : 0;
+	if (tb[RTA_UID])
+		uid = make_kuid(current_user_ns(), nla_get_u32(tb[RTA_UID]));
+	else
+		uid = (iif ? INVALID_UID : current_uid());
 
 	memset(&fl4, 0, sizeof(fl4));
 	fl4.daddr = dst;
@@ -2610,6 +2627,7 @@ static int inet_rtm_getroute(struct sk_buff *in_skb, struct nlmsghdr *nlh)
 	fl4.flowi4_tos = rtm->rtm_tos;
 	fl4.flowi4_oif = tb[RTA_OIF] ? nla_get_u32(tb[RTA_OIF]) : 0;
 	fl4.flowi4_mark = mark;
+	fl4.flowi4_uid = uid;
 
 	if (iif) {
 		struct net_device *dev;
diff --git a/net/ipv4/syncookies.c b/net/ipv4/syncookies.c
index 0597ad7..4487c71 100644
--- a/net/ipv4/syncookies.c
+++ b/net/ipv4/syncookies.c
@@ -373,7 +373,7 @@ struct sock *cookie_v4_check(struct sock *sk, struct sk_buff *skb)
 			   RT_CONN_FLAGS(sk), RT_SCOPE_UNIVERSE, IPPROTO_TCP,
 			   inet_sk_flowi_flags(sk),
 			   opt->srr ? opt->faddr : ireq->ir_rmt_addr,
-			   ireq->ir_loc_addr, th->source, th->dest);
+			   ireq->ir_loc_addr, th->source, th->dest, sk->sk_uid);
 	security_req_classify_flow(req, flowi4_to_flowi(&fl4));
 	rt = ip_route_output_key(sock_net(sk), &fl4);
 	if (IS_ERR(rt)) {
diff --git a/net/ipv4/sysctl_net_ipv4.c b/net/ipv4/sysctl_net_ipv4.c
index 024ab83..ce43dc7 100644
--- a/net/ipv4/sysctl_net_ipv4.c
+++ b/net/ipv4/sysctl_net_ipv4.c
@@ -152,6 +152,21 @@ static int ipv4_ping_group_range(struct ctl_table *table, int write,
 	return ret;
 }
 
+/* Validate changes from /proc interface. */
+static int proc_tcp_default_init_rwnd(struct ctl_table *ctl, int write,
+				      void __user *buffer,
+				      size_t *lenp, loff_t *ppos)
+{
+	int old_value = *(int *)ctl->data;
+	int ret = proc_dointvec(ctl, write, buffer, lenp, ppos);
+	int new_value = *(int *)ctl->data;
+
+	if (write && ret == 0 && (new_value < 3 || new_value > 100))
+		*(int *)ctl->data = old_value;
+
+	return ret;
+}
+
 static int proc_tcp_congestion_control(struct ctl_table *ctl, int write,
 				       void __user *buffer, size_t *lenp, loff_t *ppos)
 {
@@ -633,6 +648,13 @@ static int proc_tcp_fastopen_key(struct ctl_table *ctl, int write,
 		.proc_handler	= proc_dointvec_ms_jiffies,
 	},
 	{
+		.procname       = "tcp_default_init_rwnd",
+		.data           = &sysctl_tcp_default_init_rwnd,
+		.maxlen         = sizeof(int),
+		.mode           = 0644,
+		.proc_handler   = proc_tcp_default_init_rwnd
+	},
+	{
 		.procname	= "icmp_msgs_per_sec",
 		.data		= &sysctl_icmp_msgs_per_sec,
 		.maxlen		= sizeof(int),
diff --git a/net/ipv4/sysfs_net_ipv4.c b/net/ipv4/sysfs_net_ipv4.c
new file mode 100644
index 00000000..0cbbf10
--- /dev/null
+++ b/net/ipv4/sysfs_net_ipv4.c
@@ -0,0 +1,88 @@
+/*
+ * net/ipv4/sysfs_net_ipv4.c
+ *
+ * sysfs-based networking knobs (so we can, unlike with sysctl, control perms)
+ *
+ * Copyright (C) 2008 Google, Inc.
+ *
+ * Robert Love <rlove@google.com>
+ *
+ * This software is licensed under the terms of the GNU General Public
+ * License version 2, as published by the Free Software Foundation, and
+ * may be copied, distributed, and modified under those terms.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include <linux/kobject.h>
+#include <linux/string.h>
+#include <linux/sysfs.h>
+#include <linux/init.h>
+#include <net/tcp.h>
+
+#define CREATE_IPV4_FILE(_name, _var) \
+static ssize_t _name##_show(struct kobject *kobj, \
+			    struct kobj_attribute *attr, char *buf) \
+{ \
+	return sprintf(buf, "%d\n", _var); \
+} \
+static ssize_t _name##_store(struct kobject *kobj, \
+			     struct kobj_attribute *attr, \
+			     const char *buf, size_t count) \
+{ \
+	int val, ret; \
+	ret = sscanf(buf, "%d", &val); \
+	if (ret != 1) \
+		return -EINVAL; \
+	if (val < 0) \
+		return -EINVAL; \
+	_var = val; \
+	return count; \
+} \
+static struct kobj_attribute _name##_attr = \
+	__ATTR(_name, 0644, _name##_show, _name##_store)
+
+CREATE_IPV4_FILE(tcp_wmem_min, sysctl_tcp_wmem[0]);
+CREATE_IPV4_FILE(tcp_wmem_def, sysctl_tcp_wmem[1]);
+CREATE_IPV4_FILE(tcp_wmem_max, sysctl_tcp_wmem[2]);
+
+CREATE_IPV4_FILE(tcp_rmem_min, sysctl_tcp_rmem[0]);
+CREATE_IPV4_FILE(tcp_rmem_def, sysctl_tcp_rmem[1]);
+CREATE_IPV4_FILE(tcp_rmem_max, sysctl_tcp_rmem[2]);
+
+static struct attribute *ipv4_attrs[] = {
+	&tcp_wmem_min_attr.attr,
+	&tcp_wmem_def_attr.attr,
+	&tcp_wmem_max_attr.attr,
+	&tcp_rmem_min_attr.attr,
+	&tcp_rmem_def_attr.attr,
+	&tcp_rmem_max_attr.attr,
+	NULL
+};
+
+static struct attribute_group ipv4_attr_group = {
+	.attrs = ipv4_attrs,
+};
+
+static __init int sysfs_ipv4_init(void)
+{
+	struct kobject *ipv4_kobject;
+	int ret;
+
+	ipv4_kobject = kobject_create_and_add("ipv4", kernel_kobj);
+	if (!ipv4_kobject)
+		return -ENOMEM;
+
+	ret = sysfs_create_group(ipv4_kobject, &ipv4_attr_group);
+	if (ret) {
+		kobject_put(ipv4_kobject);
+		return ret;
+	}
+
+	return 0;
+}
+
+subsys_initcall(sysfs_ipv4_init);
diff --git a/net/ipv4/tcp.c b/net/ipv4/tcp.c
index 8f15eae..be018ea 100644
--- a/net/ipv4/tcp.c
+++ b/net/ipv4/tcp.c
@@ -538,6 +538,12 @@ unsigned int tcp_poll(struct file *file, struct socket *sock, poll_table *wait)
 
 		if (tp->urg_data & TCP_URG_VALID)
 			mask |= POLLPRI;
+	} else if (state == TCP_SYN_SENT && inet_sk(sk)->defer_connect) {
+		/* Active TCP fastopen socket with defer_connect
+		 * Return POLLOUT so application can call write()
+		 * in order for kernel to generate SYN+data
+		 */
+		mask |= POLLOUT | POLLWRNORM;
 	}
 	/* This barrier is coupled with smp_wmb() in tcp_reset() */
 	smp_rmb();
@@ -1079,6 +1085,7 @@ static int tcp_sendmsg_fastopen(struct sock *sk, struct msghdr *msg,
 				int *copied, size_t size)
 {
 	struct tcp_sock *tp = tcp_sk(sk);
+	struct inet_sock *inet = inet_sk(sk);
 	struct sockaddr *uaddr = msg->msg_name;
 	int err, flags;
 
@@ -1096,11 +1103,26 @@ static int tcp_sendmsg_fastopen(struct sock *sk, struct msghdr *msg,
 	tp->fastopen_req->data = msg;
 	tp->fastopen_req->size = size;
 
+	if (inet->defer_connect) {
+		err = tcp_connect(sk);
+		/* Same failure procedure as in tcp_v4/6_connect */
+		if (err) {
+			tcp_set_state(sk, TCP_CLOSE);
+			inet->inet_dport = 0;
+			sk->sk_route_caps = 0;
+		}
+	}
 	flags = (msg->msg_flags & MSG_DONTWAIT) ? O_NONBLOCK : 0;
 	err = __inet_stream_connect(sk->sk_socket, uaddr,
 				    msg->msg_namelen, flags);
-	*copied = tp->fastopen_req->copied;
-	tcp_free_fastopen_req(tp);
+	/* fastopen_req could already be freed in __inet_stream_connect
+	 * if the connection times out or gets rst
+	 */
+	if (tp->fastopen_req) {
+		*copied = tp->fastopen_req->copied;
+		tcp_free_fastopen_req(tp);
+		inet->defer_connect = 0;
+	}
 	return err;
 }
 
@@ -1118,7 +1140,8 @@ int tcp_sendmsg(struct sock *sk, struct msghdr *msg, size_t size)
 	lock_sock(sk);
 
 	flags = msg->msg_flags;
-	if ((flags & MSG_FASTOPEN) && !tp->repair) {
+	if (unlikely(flags & MSG_FASTOPEN || inet_sk(sk)->defer_connect) &&
+	    !tp->repair) {
 		err = tcp_sendmsg_fastopen(sk, msg, &copied_syn, size);
 		if (err == -EINPROGRESS && copied_syn > 0)
 			goto out;
@@ -2314,6 +2337,10 @@ int tcp_disconnect(struct sock *sk, int flags)
 	sk->sk_rx_dst = NULL;
 	tcp_saved_syn_free(tp);
 
+	/* Clean up fastopen related fields */
+	tcp_free_fastopen_req(tp);
+	inet->defer_connect = 0;
+
 	WARN_ON(inet->inet_num && !icsk->icsk_bind_hash);
 
 	if (sk->sk_frag.page) {
@@ -2688,6 +2715,18 @@ static int do_tcp_setsockopt(struct sock *sk, int level,
 			err = -EINVAL;
 		}
 		break;
+	case TCP_FASTOPEN_CONNECT:
+		if (val > 1 || val < 0) {
+			err = -EINVAL;
+		} else if (sysctl_tcp_fastopen & TFO_CLIENT_ENABLE) {
+			if (sk->sk_state == TCP_CLOSE)
+				tp->fastopen_connect = val;
+			else
+				err = -EINVAL;
+		} else {
+			err = -EOPNOTSUPP;
+		}
+		break;
 	case TCP_TIMESTAMP:
 		if (!tp->repair)
 			err = -EPERM;
@@ -3001,6 +3040,10 @@ static int do_tcp_getsockopt(struct sock *sk, int level,
 		val = icsk->icsk_accept_queue.fastopenq.max_qlen;
 		break;
 
+	case TCP_FASTOPEN_CONNECT:
+		val = tp->fastopen_connect;
+		break;
+
 	case TCP_TIMESTAMP:
 		val = tcp_time_stamp + tp->tsoffset;
 		break;
diff --git a/net/ipv4/tcp_fastopen.c b/net/ipv4/tcp_fastopen.c
index dd2560c..8ea4e97 100644
--- a/net/ipv4/tcp_fastopen.c
+++ b/net/ipv4/tcp_fastopen.c
@@ -326,3 +326,57 @@ struct sock *tcp_try_fastopen(struct sock *sk, struct sk_buff *skb,
 	*foc = valid_foc;
 	return NULL;
 }
+
+bool tcp_fastopen_cookie_check(struct sock *sk, u16 *mss,
+			       struct tcp_fastopen_cookie *cookie)
+{
+	unsigned long last_syn_loss = 0;
+	int syn_loss = 0;
+
+	tcp_fastopen_cache_get(sk, mss, cookie, &syn_loss, &last_syn_loss);
+
+	/* Recurring FO SYN losses: no cookie or data in SYN */
+	if (syn_loss > 1 &&
+	    time_before(jiffies, last_syn_loss + (60*HZ << syn_loss))) {
+		cookie->len = -1;
+		return false;
+	}
+	if (sysctl_tcp_fastopen & TFO_CLIENT_NO_COOKIE) {
+		cookie->len = -1;
+		return true;
+	}
+	return cookie->len > 0;
+}
+
+/* This function checks if we want to defer sending SYN until the first
+ * write().  We defer under the following conditions:
+ * 1. fastopen_connect sockopt is set
+ * 2. we have a valid cookie
+ * Return value: return true if we want to defer until application writes data
+ *               return false if we want to send out SYN immediately
+ */
+bool tcp_fastopen_defer_connect(struct sock *sk, int *err)
+{
+	struct tcp_fastopen_cookie cookie = { .len = 0 };
+	struct tcp_sock *tp = tcp_sk(sk);
+	u16 mss;
+
+	if (tp->fastopen_connect && !tp->fastopen_req) {
+		if (tcp_fastopen_cookie_check(sk, &mss, &cookie)) {
+			inet_sk(sk)->defer_connect = 1;
+			return true;
+		}
+
+		/* Alloc fastopen_req in order for FO option to be included
+		 * in SYN
+		 */
+		tp->fastopen_req = kzalloc(sizeof(*tp->fastopen_req),
+					   sk->sk_allocation);
+		if (tp->fastopen_req)
+			tp->fastopen_req->cookie = cookie;
+		else
+			*err = -ENOBUFS;
+	}
+	return false;
+}
+EXPORT_SYMBOL(tcp_fastopen_defer_connect);
diff --git a/net/ipv4/tcp_input.c b/net/ipv4/tcp_input.c
index 9d0b73a..1fdb411 100644
--- a/net/ipv4/tcp_input.c
+++ b/net/ipv4/tcp_input.c
@@ -100,6 +100,7 @@
 int sysctl_tcp_moderate_rcvbuf __read_mostly = 1;
 int sysctl_tcp_early_retrans __read_mostly = 3;
 int sysctl_tcp_invalid_ratelimit __read_mostly = HZ/2;
+int sysctl_tcp_default_init_rwnd __read_mostly = TCP_INIT_CWND * 2;
 
 #define FLAG_DATA		0x01 /* Incoming frame contained data.		*/
 #define FLAG_WIN_UPDATE		0x02 /* Incoming ACK was a window update.	*/
diff --git a/net/ipv4/tcp_ipv4.c b/net/ipv4/tcp_ipv4.c
index 504cdae..aea0a96 100644
--- a/net/ipv4/tcp_ipv4.c
+++ b/net/ipv4/tcp_ipv4.c
@@ -232,6 +232,7 @@ int tcp_v4_connect(struct sock *sk, struct sockaddr *uaddr, int addr_len)
 	/* OK, now commit destination to socket.  */
 	sk->sk_gso_type = SKB_GSO_TCPV4;
 	sk_setup_caps(sk, &rt->dst);
+	rt = NULL;
 
 	if (!tp->write_seq && likely(!tp->repair))
 		tp->write_seq = secure_tcp_sequence_number(inet->inet_saddr,
@@ -241,9 +242,13 @@ int tcp_v4_connect(struct sock *sk, struct sockaddr *uaddr, int addr_len)
 
 	inet->inet_id = tp->write_seq ^ jiffies;
 
+	if (tcp_fastopen_defer_connect(sk, &err))
+		return err;
+	if (err)
+		goto failure;
+
 	err = tcp_connect(sk);
 
-	rt = NULL;
 	if (err)
 		goto failure;
 
@@ -695,6 +700,7 @@ static void tcp_v4_send_reset(const struct sock *sk, struct sk_buff *skb)
 		     offsetof(struct inet_timewait_sock, tw_bound_dev_if));
 
 	arg.tos = ip_hdr(skb)->tos;
+	arg.uid = sock_net_uid(net, sk && sk_fullsock(sk) ? sk : NULL);
 	local_bh_disable();
 	ip_send_unicast_reply(*this_cpu_ptr(net->ipv4.tcp_sk),
 			      skb, &TCP_SKB_CB(skb)->header.h4.opt,
@@ -715,7 +721,7 @@ static void tcp_v4_send_reset(const struct sock *sk, struct sk_buff *skb)
    outside socket context is ugly, certainly. What can I do?
  */
 
-static void tcp_v4_send_ack(struct net *net,
+static void tcp_v4_send_ack(const struct sock *sk,
 			    struct sk_buff *skb, u32 seq, u32 ack,
 			    u32 win, u32 tsval, u32 tsecr, int oif,
 			    struct tcp_md5sig_key *key,
@@ -730,6 +736,7 @@ static void tcp_v4_send_ack(struct net *net,
 #endif
 			];
 	} rep;
+	struct net *net = sock_net(sk);
 	struct ip_reply_arg arg;
 
 	memset(&rep.th, 0, sizeof(struct tcphdr));
@@ -779,6 +786,7 @@ static void tcp_v4_send_ack(struct net *net,
 	if (oif)
 		arg.bound_dev_if = oif;
 	arg.tos = tos;
+	arg.uid = sock_net_uid(net, sk_fullsock(sk) ? sk : NULL);
 	local_bh_disable();
 	ip_send_unicast_reply(*this_cpu_ptr(net->ipv4.tcp_sk),
 			      skb, &TCP_SKB_CB(skb)->header.h4.opt,
@@ -794,7 +802,7 @@ static void tcp_v4_timewait_ack(struct sock *sk, struct sk_buff *skb)
 	struct inet_timewait_sock *tw = inet_twsk(sk);
 	struct tcp_timewait_sock *tcptw = tcp_twsk(sk);
 
-	tcp_v4_send_ack(sock_net(sk), skb,
+	tcp_v4_send_ack(sk, skb,
 			tcptw->tw_snd_nxt, tcptw->tw_rcv_nxt,
 			tcptw->tw_rcv_wnd >> tw->tw_rcv_wscale,
 			tcp_time_stamp + tcptw->tw_ts_offset,
@@ -822,7 +830,7 @@ static void tcp_v4_reqsk_send_ack(const struct sock *sk, struct sk_buff *skb,
 	 * exception of <SYN> segments, MUST be right-shifted by
 	 * Rcv.Wind.Shift bits:
 	 */
-	tcp_v4_send_ack(sock_net(sk), skb, seq,
+	tcp_v4_send_ack(sk, skb, seq,
 			tcp_rsk(req)->rcv_nxt,
 			req->rsk_rcv_wnd >> inet_rsk(req)->rcv_wscale,
 			tcp_time_stamp,
@@ -1674,7 +1682,9 @@ int tcp_v4_rcv(struct sk_buff *skb)
 		 */
 		sock_hold(sk);
 		refcounted = true;
-		nsk = tcp_check_req(sk, skb, req, false);
+		nsk = NULL;
+		if (!tcp_filter(sk, skb))
+			nsk = tcp_check_req(sk, skb, req, false);
 		if (!nsk) {
 			reqsk_put(req);
 			goto discard_and_relse;
diff --git a/net/ipv4/tcp_output.c b/net/ipv4/tcp_output.c
index 5f91695..0afd75a 100644
--- a/net/ipv4/tcp_output.c
+++ b/net/ipv4/tcp_output.c
@@ -193,7 +193,7 @@ u32 tcp_default_init_rwnd(u32 mss)
 	 * (RFC 3517, Section 4, NextSeg() rule (2)). Further place a
 	 * limit when mss is larger than 1460.
 	 */
-	u32 init_rwnd = TCP_INIT_CWND * 2;
+	u32 init_rwnd = sysctl_tcp_default_init_rwnd;
 
 	if (mss > 1460)
 		init_rwnd = max((1460 * init_rwnd) / mss, 2U);
@@ -3293,23 +3293,11 @@ static int tcp_send_syn_data(struct sock *sk, struct sk_buff *syn)
 {
 	struct tcp_sock *tp = tcp_sk(sk);
 	struct tcp_fastopen_request *fo = tp->fastopen_req;
-	int syn_loss = 0, space, err = 0;
-	unsigned long last_syn_loss = 0;
+	int space, err = 0;
 	struct sk_buff *syn_data;
 
 	tp->rx_opt.mss_clamp = tp->advmss;  /* If MSS is not cached */
-	tcp_fastopen_cache_get(sk, &tp->rx_opt.mss_clamp, &fo->cookie,
-			       &syn_loss, &last_syn_loss);
-	/* Recurring FO SYN losses: revert to regular handshake temporarily */
-	if (syn_loss > 1 &&
-	    time_before(jiffies, last_syn_loss + (60*HZ << syn_loss))) {
-		fo->cookie.len = -1;
-		goto fallback;
-	}
-
-	if (sysctl_tcp_fastopen & TFO_CLIENT_NO_COOKIE)
-		fo->cookie.len = -1;
-	else if (fo->cookie.len <= 0)
+	if (!tcp_fastopen_cookie_check(sk, &tp->rx_opt.mss_clamp, &fo->cookie))
 		goto fallback;
 
 	/* MSS for SYN-data is based on cached MSS and bounded by PMTU and
diff --git a/net/ipv4/udp.c b/net/ipv4/udp.c
index aa2a20e..bb295c6 100644
--- a/net/ipv4/udp.c
+++ b/net/ipv4/udp.c
@@ -1018,7 +1018,8 @@ int udp_sendmsg(struct sock *sk, struct msghdr *msg, size_t len)
 		flowi4_init_output(fl4, ipc.oif, sk->sk_mark, tos,
 				   RT_SCOPE_UNIVERSE, sk->sk_protocol,
 				   flow_flags,
-				   faddr, saddr, dport, inet->inet_sport);
+				   faddr, saddr, dport, inet->inet_sport,
+				   sk->sk_uid);
 
 		security_sk_classify_flow(sk, flowi4_to_flowi(fl4));
 		rt = ip_route_output_flow(net, fl4, sk);
diff --git a/net/ipv4/xfrm4_policy.c b/net/ipv4/xfrm4_policy.c
index 622e158..e62d76c9 100644
--- a/net/ipv4/xfrm4_policy.c
+++ b/net/ipv4/xfrm4_policy.c
@@ -22,7 +22,8 @@
 static struct dst_entry *__xfrm4_dst_lookup(struct net *net, struct flowi4 *fl4,
 					    int tos, int oif,
 					    const xfrm_address_t *saddr,
-					    const xfrm_address_t *daddr)
+					    const xfrm_address_t *daddr,
+					    u32 mark)
 {
 	struct rtable *rt;
 
@@ -30,6 +31,7 @@ static struct dst_entry *__xfrm4_dst_lookup(struct net *net, struct flowi4 *fl4,
 	fl4->daddr = daddr->a4;
 	fl4->flowi4_tos = tos;
 	fl4->flowi4_oif = l3mdev_master_ifindex_by_index(net, oif);
+	fl4->flowi4_mark = mark;
 	if (saddr)
 		fl4->saddr = saddr->a4;
 
@@ -44,20 +46,22 @@ static struct dst_entry *__xfrm4_dst_lookup(struct net *net, struct flowi4 *fl4,
 
 static struct dst_entry *xfrm4_dst_lookup(struct net *net, int tos, int oif,
 					  const xfrm_address_t *saddr,
-					  const xfrm_address_t *daddr)
+					  const xfrm_address_t *daddr,
+					  u32 mark)
 {
 	struct flowi4 fl4;
 
-	return __xfrm4_dst_lookup(net, &fl4, tos, oif, saddr, daddr);
+	return __xfrm4_dst_lookup(net, &fl4, tos, oif, saddr, daddr, mark);
 }
 
 static int xfrm4_get_saddr(struct net *net, int oif,
-			   xfrm_address_t *saddr, xfrm_address_t *daddr)
+			   xfrm_address_t *saddr, xfrm_address_t *daddr,
+			   u32 mark)
 {
 	struct dst_entry *dst;
 	struct flowi4 fl4;
 
-	dst = __xfrm4_dst_lookup(net, &fl4, 0, oif, NULL, daddr);
+	dst = __xfrm4_dst_lookup(net, &fl4, 0, oif, NULL, daddr, mark);
 	if (IS_ERR(dst))
 		return -EHOSTUNREACH;
 
diff --git a/net/ipv6/addrconf.c b/net/ipv6/addrconf.c
index 3a27cf7..dd438eb 100644
--- a/net/ipv6/addrconf.c
+++ b/net/ipv6/addrconf.c
@@ -223,9 +223,11 @@ static bool ipv6_chk_same_addr(struct net *net, const struct in6_addr *addr,
 	.accept_ra_rtr_pref	= 1,
 	.rtr_probe_interval	= 60 * HZ,
 #ifdef CONFIG_IPV6_ROUTE_INFO
+	.accept_ra_rt_info_min_plen = 0,
 	.accept_ra_rt_info_max_plen = 0,
 #endif
 #endif
+	.accept_ra_rt_table	= 0,
 	.proxy_ndp		= 0,
 	.accept_source_route	= 0,	/* we do not accept RH0 by default. */
 	.disable_ipv6		= 0,
@@ -269,9 +271,11 @@ static bool ipv6_chk_same_addr(struct net *net, const struct in6_addr *addr,
 	.accept_ra_rtr_pref	= 1,
 	.rtr_probe_interval	= 60 * HZ,
 #ifdef CONFIG_IPV6_ROUTE_INFO
+	.accept_ra_rt_info_min_plen = 0,
 	.accept_ra_rt_info_max_plen = 0,
 #endif
 #endif
+	.accept_ra_rt_table	= 0,
 	.proxy_ndp		= 0,
 	.accept_source_route	= 0,	/* we do not accept RH0 by default. */
 	.disable_ipv6		= 0,
@@ -2203,6 +2207,31 @@ static void  ipv6_try_regen_rndid(struct inet6_dev *idev, struct in6_addr *tmpad
 		ipv6_regen_rndid(idev);
 }
 
+u32 addrconf_rt_table(const struct net_device *dev, u32 default_table) {
+	/* Determines into what table to put autoconf PIO/RIO/default routes
+	 * learned on this device.
+	 *
+	 * - If 0, use the same table for every device. This puts routes into
+	 *   one of RT_TABLE_{PREFIX,INFO,DFLT} depending on the type of route
+	 *   (but note that these three are currently all equal to
+	 *   RT6_TABLE_MAIN).
+	 * - If > 0, use the specified table.
+	 * - If < 0, put routes into table dev->ifindex + (-rt_table).
+	 */
+	struct inet6_dev *idev = in6_dev_get(dev);
+	u32 table;
+	int sysctl = idev->cnf.accept_ra_rt_table;
+	if (sysctl == 0) {
+		table = default_table;
+	} else if (sysctl > 0) {
+		table = (u32) sysctl;
+	} else {
+		table = (unsigned) dev->ifindex + (-sysctl);
+	}
+	in6_dev_put(idev);
+	return table;
+}
+
 /*
  *	Add prefix route.
  */
@@ -2212,7 +2241,7 @@ static void  ipv6_try_regen_rndid(struct inet6_dev *idev, struct in6_addr *tmpad
 		      unsigned long expires, u32 flags)
 {
 	struct fib6_config cfg = {
-		.fc_table = l3mdev_fib_table(dev) ? : RT6_TABLE_PREFIX,
+		.fc_table = l3mdev_fib_table(dev) ? : addrconf_rt_table(dev, RT6_TABLE_PREFIX),
 		.fc_metric = IP6_RT_PRIO_ADDRCONF,
 		.fc_ifindex = dev->ifindex,
 		.fc_expires = expires,
@@ -2245,7 +2274,7 @@ static struct rt6_info *addrconf_get_prefix_route(const struct in6_addr *pfx,
 	struct fib6_node *fn;
 	struct rt6_info *rt = NULL;
 	struct fib6_table *table;
-	u32 tb_id = l3mdev_fib_table(dev) ? : RT6_TABLE_PREFIX;
+	u32 tb_id = l3mdev_fib_table(dev) ? : addrconf_rt_table(dev, RT6_TABLE_PREFIX);
 
 	table = fib6_get_table(dev_net(dev), tb_id);
 	if (!table)
@@ -4957,9 +4986,11 @@ static inline void ipv6_store_devconf(struct ipv6_devconf *cnf,
 	array[DEVCONF_RTR_PROBE_INTERVAL] =
 		jiffies_to_msecs(cnf->rtr_probe_interval);
 #ifdef CONFIG_IPV6_ROUTE_INFO
+	array[DEVCONF_ACCEPT_RA_RT_INFO_MIN_PLEN] = cnf->accept_ra_rt_info_min_plen;
 	array[DEVCONF_ACCEPT_RA_RT_INFO_MAX_PLEN] = cnf->accept_ra_rt_info_max_plen;
 #endif
 #endif
+	array[DEVCONF_ACCEPT_RA_RT_TABLE] = cnf->accept_ra_rt_table;
 	array[DEVCONF_PROXY_NDP] = cnf->proxy_ndp;
 	array[DEVCONF_ACCEPT_SOURCE_ROUTE] = cnf->accept_source_route;
 #ifdef CONFIG_IPV6_OPTIMISTIC_DAD
@@ -5932,6 +5963,13 @@ int addrconf_sysctl_ignore_routes_with_linkdown(struct ctl_table *ctl,
 	},
 #ifdef CONFIG_IPV6_ROUTE_INFO
 	{
+		.procname	= "accept_ra_rt_info_min_plen",
+		.data		= &ipv6_devconf.accept_ra_rt_info_min_plen,
+		.maxlen		= sizeof(int),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec,
+	},
+	{
 		.procname	= "accept_ra_rt_info_max_plen",
 		.data		= &ipv6_devconf.accept_ra_rt_info_max_plen,
 		.maxlen		= sizeof(int),
@@ -5941,6 +5979,13 @@ int addrconf_sysctl_ignore_routes_with_linkdown(struct ctl_table *ctl,
 #endif
 #endif
 	{
+		.procname	= "accept_ra_rt_table",
+		.data		= &ipv6_devconf.accept_ra_rt_table,
+		.maxlen		= sizeof(int),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec,
+	},
+	{
 		.procname	= "proxy_ndp",
 		.data		= &ipv6_devconf.proxy_ndp,
 		.maxlen		= sizeof(int),
diff --git a/net/ipv6/af_inet6.c b/net/ipv6/af_inet6.c
index 4213790..1111684 100644
--- a/net/ipv6/af_inet6.c
+++ b/net/ipv6/af_inet6.c
@@ -65,6 +65,20 @@
 #include <asm/uaccess.h>
 #include <linux/mroute6.h>
 
+#ifdef CONFIG_ANDROID_PARANOID_NETWORK
+#include <linux/android_aid.h>
+
+static inline int current_has_network(void)
+{
+	return in_egroup_p(AID_INET) || capable(CAP_NET_RAW);
+}
+#else
+static inline int current_has_network(void)
+{
+	return 1;
+}
+#endif
+
 #include "ip6_offload.h"
 
 MODULE_AUTHOR("Cast of dozens");
@@ -121,6 +135,9 @@ static int inet6_create(struct net *net, struct socket *sock, int protocol,
 	if (protocol < 0 || protocol >= IPPROTO_MAX)
 		return -EINVAL;
 
+	if (!current_has_network())
+		return -EACCES;
+
 	/* Look for the requested type/protocol pair. */
 lookup_protocol:
 	err = -ESOCKTNOSUPPORT;
@@ -167,8 +184,7 @@ static int inet6_create(struct net *net, struct socket *sock, int protocol,
 	}
 
 	err = -EPERM;
-	if (sock->type == SOCK_RAW && !kern &&
-	    !ns_capable(net->user_ns, CAP_NET_RAW))
+	if (sock->type == SOCK_RAW && !kern && !capable(CAP_NET_RAW))
 		goto out_rcu_unlock;
 
 	sock->ops = answer->ops;
@@ -680,6 +696,7 @@ int inet6_sk_rebuild_header(struct sock *sk)
 		fl6.flowi6_mark = sk->sk_mark;
 		fl6.fl6_dport = inet->inet_dport;
 		fl6.fl6_sport = inet->inet_sport;
+		fl6.flowi6_uid = sk->sk_uid;
 		security_sk_classify_flow(sk, flowi6_to_flowi(&fl6));
 
 		rcu_read_lock();
diff --git a/net/ipv6/ah6.c b/net/ipv6/ah6.c
index 0edc44c..e742c4d 100644
--- a/net/ipv6/ah6.c
+++ b/net/ipv6/ah6.c
@@ -666,9 +666,10 @@ static int ah6_err(struct sk_buff *skb, struct inet6_skb_parm *opt,
 		return 0;
 
 	if (type == NDISC_REDIRECT)
-		ip6_redirect(skb, net, skb->dev->ifindex, 0);
+		ip6_redirect(skb, net, skb->dev->ifindex, 0,
+			     sock_net_uid(net, NULL));
 	else
-		ip6_update_pmtu(skb, net, info, 0, 0);
+		ip6_update_pmtu(skb, net, info, 0, 0, sock_net_uid(net, NULL));
 	xfrm_state_put(x);
 
 	return 0;
diff --git a/net/ipv6/datagram.c b/net/ipv6/datagram.c
index 2d3c8fe..988b1c8 100644
--- a/net/ipv6/datagram.c
+++ b/net/ipv6/datagram.c
@@ -54,6 +54,7 @@ static void ip6_datagram_flow_key_init(struct flowi6 *fl6, struct sock *sk)
 	fl6->fl6_dport = inet->inet_dport;
 	fl6->fl6_sport = inet->inet_sport;
 	fl6->flowlabel = np->flow_label;
+	fl6->flowi6_uid = sk->sk_uid;
 
 	if (!fl6->flowi6_oif)
 		fl6->flowi6_oif = np->sticky_pktinfo.ipi6_ifindex;
diff --git a/net/ipv6/esp6.c b/net/ipv6/esp6.c
index 6a924be..44a2010 100644
--- a/net/ipv6/esp6.c
+++ b/net/ipv6/esp6.c
@@ -478,9 +478,10 @@ static int esp6_err(struct sk_buff *skb, struct inet6_skb_parm *opt,
 		return 0;
 
 	if (type == NDISC_REDIRECT)
-		ip6_redirect(skb, net, skb->dev->ifindex, 0);
+		ip6_redirect(skb, net, skb->dev->ifindex, 0,
+			     sock_net_uid(net, NULL));
 	else
-		ip6_update_pmtu(skb, net, info, 0, 0);
+		ip6_update_pmtu(skb, net, info, 0, 0, sock_net_uid(net, NULL));
 	xfrm_state_put(x);
 
 	return 0;
diff --git a/net/ipv6/exthdrs_core.c b/net/ipv6/exthdrs_core.c
index 305e2ed..477692f 100644
--- a/net/ipv6/exthdrs_core.c
+++ b/net/ipv6/exthdrs_core.c
@@ -166,15 +166,15 @@ int ipv6_find_tlv(const struct sk_buff *skb, int offset, int type)
  * to explore inner IPv6 header, eg. ICMPv6 error messages.
  *
  * If target header is found, its offset is set in *offset and return protocol
- * number. Otherwise, return -1.
+ * number. Otherwise, return -ENOENT or -EBADMSG.
  *
  * If the first fragment doesn't contain the final protocol header or
  * NEXTHDR_NONE it is considered invalid.
  *
  * Note that non-1st fragment is special case that "the protocol number
  * of last header" is "next header" field in Fragment header. In this case,
- * *offset is meaningless and fragment offset is stored in *fragoff if fragoff
- * isn't NULL.
+ * *offset is meaningless. If fragoff is not NULL, the fragment offset is
+ * stored in *fragoff; if it is NULL, return -EINVAL.
  *
  * if flags is not NULL and it's a fragment, then the frag flag
  * IP6_FH_F_FRAG will be set. If it's an AH header, the
@@ -253,9 +253,12 @@ int ipv6_find_hdr(const struct sk_buff *skb, unsigned int *offset,
 				if (target < 0 &&
 				    ((!ipv6_ext_hdr(hp->nexthdr)) ||
 				     hp->nexthdr == NEXTHDR_NONE)) {
-					if (fragoff)
+					if (fragoff) {
 						*fragoff = _frag_off;
-					return hp->nexthdr;
+						return hp->nexthdr;
+					} else {
+						return -EINVAL;
+					}
 				}
 				if (!found)
 					return -ENOENT;
diff --git a/net/ipv6/icmp.c b/net/ipv6/icmp.c
index 2772004..17fa28f 100644
--- a/net/ipv6/icmp.c
+++ b/net/ipv6/icmp.c
@@ -92,9 +92,10 @@ static void icmpv6_err(struct sk_buff *skb, struct inet6_skb_parm *opt,
 	struct net *net = dev_net(skb->dev);
 
 	if (type == ICMPV6_PKT_TOOBIG)
-		ip6_update_pmtu(skb, net, info, 0, 0);
+		ip6_update_pmtu(skb, net, info, 0, 0, sock_net_uid(net, NULL));
 	else if (type == NDISC_REDIRECT)
-		ip6_redirect(skb, net, skb->dev->ifindex, 0);
+		ip6_redirect(skb, net, skb->dev->ifindex, 0,
+			     sock_net_uid(net, NULL));
 
 	if (!(type & ICMPV6_INFOMSG_MASK))
 		if (icmp6->icmp6_type == ICMPV6_ECHO_REQUEST)
@@ -486,6 +487,7 @@ static void icmp6_send(struct sk_buff *skb, u8 type, u8 code, __u32 info,
 	fl6.flowi6_oif = iif;
 	fl6.fl6_icmp_type = type;
 	fl6.fl6_icmp_code = code;
+	fl6.flowi6_uid = sock_net_uid(net, NULL);
 	security_skb_classify_flow(skb, flowi6_to_flowi(&fl6));
 
 	sk = icmpv6_xmit_lock(net);
@@ -660,6 +662,7 @@ static void icmpv6_echo_reply(struct sk_buff *skb)
 	fl6.flowi6_oif = skb->dev->ifindex;
 	fl6.fl6_icmp_type = ICMPV6_ECHO_REPLY;
 	fl6.flowi6_mark = mark;
+	fl6.flowi6_uid = sock_net_uid(net, NULL);
 	security_skb_classify_flow(skb, flowi6_to_flowi(&fl6));
 
 	sk = icmpv6_xmit_lock(net);
diff --git a/net/ipv6/inet6_connection_sock.c b/net/ipv6/inet6_connection_sock.c
index 798a095..10d1deb 100644
--- a/net/ipv6/inet6_connection_sock.c
+++ b/net/ipv6/inet6_connection_sock.c
@@ -88,6 +88,7 @@ struct dst_entry *inet6_csk_route_req(const struct sock *sk,
 	fl6->flowi6_mark = ireq->ir_mark;
 	fl6->fl6_dport = ireq->ir_rmt_port;
 	fl6->fl6_sport = htons(ireq->ir_num);
+	fl6->flowi6_uid = sk->sk_uid;
 	security_req_classify_flow(req, flowi6_to_flowi(fl6));
 
 	dst = ip6_dst_lookup_flow(sk, fl6, final_p);
@@ -136,6 +137,7 @@ static struct dst_entry *inet6_csk_route_socket(struct sock *sk,
 	fl6->flowi6_mark = sk->sk_mark;
 	fl6->fl6_sport = inet->inet_sport;
 	fl6->fl6_dport = inet->inet_dport;
+	fl6->flowi6_uid = sk->sk_uid;
 	security_sk_classify_flow(sk, flowi6_to_flowi(fl6));
 
 	rcu_read_lock();
diff --git a/net/ipv6/ip6_fib.c b/net/ipv6/ip6_fib.c
index 5da8649..7ba9a6e 100644
--- a/net/ipv6/ip6_fib.c
+++ b/net/ipv6/ip6_fib.c
@@ -914,6 +914,7 @@ static int fib6_add_rt2node(struct fib6_node *fn, struct rt6_info *rt,
 			fn->fn_flags |= RTN_RTINFO;
 		}
 		nsiblings = iter->rt6i_nsiblings;
+		iter->rt6i_node = NULL;
 		fib6_purge_rt(iter, fn, info->nl_net);
 		if (fn->rr_ptr == iter)
 			fn->rr_ptr = NULL;
@@ -928,6 +929,7 @@ static int fib6_add_rt2node(struct fib6_node *fn, struct rt6_info *rt,
 					break;
 				if (rt6_qualify_for_ecmp(iter)) {
 					*ins = iter->dst.rt6_next;
+					iter->rt6i_node = NULL;
 					fib6_purge_rt(iter, fn, info->nl_net);
 					if (fn->rr_ptr == iter)
 						fn->rr_ptr = NULL;
diff --git a/net/ipv6/ip6_gre.c b/net/ipv6/ip6_gre.c
index caee553..a88aff0 100644
--- a/net/ipv6/ip6_gre.c
+++ b/net/ipv6/ip6_gre.c
@@ -562,6 +562,8 @@ static inline int ip6gre_xmit_ipv4(struct sk_buff *skb, struct net_device *dev)
 	if (t->parms.flags & IP6_TNL_F_USE_ORIG_FWMARK)
 		fl6.flowi6_mark = skb->mark;
 
+	fl6.flowi6_uid = sock_net_uid(dev_net(dev), NULL);
+
 	err = gre_handle_offloads(skb, !!(t->parms.o_flags & TUNNEL_CSUM));
 	if (err)
 		return -1;
@@ -621,6 +623,8 @@ static inline int ip6gre_xmit_ipv6(struct sk_buff *skb, struct net_device *dev)
 	if (t->parms.flags & IP6_TNL_F_USE_ORIG_FWMARK)
 		fl6.flowi6_mark = skb->mark;
 
+	fl6.flowi6_uid = sock_net_uid(dev_net(dev), NULL);
+
 	if (gre_handle_offloads(skb, !!(t->parms.o_flags & TUNNEL_CSUM)))
 		return -1;
 
diff --git a/net/ipv6/ip6_output.c b/net/ipv6/ip6_output.c
index ea14466..c502ae6 100644
--- a/net/ipv6/ip6_output.c
+++ b/net/ipv6/ip6_output.c
@@ -39,6 +39,7 @@
 #include <linux/module.h>
 #include <linux/slab.h>
 
+#include <linux/bpf-cgroup.h>
 #include <linux/netfilter.h>
 #include <linux/netfilter_ipv6.h>
 
@@ -66,9 +67,6 @@ static int ip6_finish_output2(struct net *net, struct sock *sk, struct sk_buff *
 	struct in6_addr *nexthop;
 	int ret;
 
-	skb->protocol = htons(ETH_P_IPV6);
-	skb->dev = dev;
-
 	if (ipv6_addr_is_multicast(&ipv6_hdr(skb)->daddr)) {
 		struct inet6_dev *idev = ip6_dst_idev(skb_dst(skb));
 
@@ -131,6 +129,14 @@ static int ip6_finish_output2(struct net *net, struct sock *sk, struct sk_buff *
 
 static int ip6_finish_output(struct net *net, struct sock *sk, struct sk_buff *skb)
 {
+	int ret;
+
+	ret = BPF_CGROUP_RUN_PROG_INET_EGRESS(sk, skb);
+	if (ret) {
+		kfree_skb(skb);
+		return ret;
+	}
+
 	if ((skb->len > ip6_skb_dst_mtu(skb) && !skb_is_gso(skb)) ||
 	    dst_allfrag(skb_dst(skb)) ||
 	    (IP6CB(skb)->frag_max_size && skb->len > IP6CB(skb)->frag_max_size))
@@ -144,6 +150,9 @@ int ip6_output(struct net *net, struct sock *sk, struct sk_buff *skb)
 	struct net_device *dev = skb_dst(skb)->dev;
 	struct inet6_dev *idev = ip6_dst_idev(skb_dst(skb));
 
+	skb->protocol = htons(ETH_P_IPV6);
+	skb->dev = dev;
+
 	if (unlikely(idev->cnf.disable_ipv6)) {
 		IP6_INC_STATS(net, idev, IPSTATS_MIB_OUTDISCARDS);
 		kfree_skb(skb);
@@ -868,7 +877,6 @@ int ip6_fragment(struct net *net, struct sock *sk, struct sk_buff *skb,
 	if (skb->sk && dst_allfrag(skb_dst(skb)))
 		sk_nocaps_add(skb->sk, NETIF_F_GSO_MASK);
 
-	skb->dev = skb_dst(skb)->dev;
 	icmpv6_send(skb, ICMPV6_PKT_TOOBIG, 0, mtu);
 	err = -EMSGSIZE;
 
diff --git a/net/ipv6/ip6_tunnel.c b/net/ipv6/ip6_tunnel.c
index c7b202c..5603410 100644
--- a/net/ipv6/ip6_tunnel.c
+++ b/net/ipv6/ip6_tunnel.c
@@ -1273,6 +1273,8 @@ int ip6_tnl_xmit(struct sk_buff *skb, struct net_device *dev, __u8 dsfield,
 			fl6.flowi6_mark = skb->mark;
 	}
 
+	fl6.flowi6_uid = sock_net_uid(dev_net(dev), NULL);
+
 	if (iptunnel_handle_offloads(skb, SKB_GSO_IPXIP6))
 		return -1;
 
@@ -1356,6 +1358,8 @@ int ip6_tnl_xmit(struct sk_buff *skb, struct net_device *dev, __u8 dsfield,
 			fl6.flowi6_mark = skb->mark;
 	}
 
+	fl6.flowi6_uid = sock_net_uid(dev_net(dev), NULL);
+
 	if (iptunnel_handle_offloads(skb, SKB_GSO_IPXIP6))
 		return -1;
 
diff --git a/net/ipv6/ip6_vti.c b/net/ipv6/ip6_vti.c
index beae93f..5ae1681 100644
--- a/net/ipv6/ip6_vti.c
+++ b/net/ipv6/ip6_vti.c
@@ -616,9 +616,10 @@ static int vti6_err(struct sk_buff *skb, struct inet6_skb_parm *opt,
 		return 0;
 
 	if (type == NDISC_REDIRECT)
-		ip6_redirect(skb, net, skb->dev->ifindex, 0);
+		ip6_redirect(skb, net, skb->dev->ifindex, 0,
+			     sock_net_uid(net, NULL));
 	else
-		ip6_update_pmtu(skb, net, info, 0, 0);
+		ip6_update_pmtu(skb, net, info, 0, 0, sock_net_uid(net, NULL));
 	xfrm_state_put(x);
 
 	return 0;
diff --git a/net/ipv6/ipcomp6.c b/net/ipv6/ipcomp6.c
index 1b9316e..54d165b 100644
--- a/net/ipv6/ipcomp6.c
+++ b/net/ipv6/ipcomp6.c
@@ -74,9 +74,10 @@ static int ipcomp6_err(struct sk_buff *skb, struct inet6_skb_parm *opt,
 		return 0;
 
 	if (type == NDISC_REDIRECT)
-		ip6_redirect(skb, net, skb->dev->ifindex, 0);
+		ip6_redirect(skb, net, skb->dev->ifindex, 0,
+			     sock_net_uid(net, NULL));
 	else
-		ip6_update_pmtu(skb, net, info, 0, 0);
+		ip6_update_pmtu(skb, net, info, 0, 0, sock_net_uid(net, NULL));
 	xfrm_state_put(x);
 
 	return 0;
diff --git a/net/ipv6/ndisc.c b/net/ipv6/ndisc.c
index 21f3bf2..984d48b 100644
--- a/net/ipv6/ndisc.c
+++ b/net/ipv6/ndisc.c
@@ -1395,6 +1395,8 @@ static void ndisc_router_discovery(struct sk_buff *skb)
 			if (ri->prefix_len == 0 &&
 			    !in6_dev->cnf.accept_ra_defrtr)
 				continue;
+			if (ri->prefix_len < in6_dev->cnf.accept_ra_rt_info_min_plen)
+				continue;
 			if (ri->prefix_len > in6_dev->cnf.accept_ra_rt_info_max_plen)
 				continue;
 			rt6_route_rcv(skb->dev, (u8 *)p, (p->nd_opt_len) << 3,
diff --git a/net/ipv6/netfilter.c b/net/ipv6/netfilter.c
index d11c468..39970e2 100644
--- a/net/ipv6/netfilter.c
+++ b/net/ipv6/netfilter.c
@@ -26,6 +26,7 @@ int ip6_route_me_harder(struct net *net, struct sk_buff *skb)
 	struct flowi6 fl6 = {
 		.flowi6_oif = skb->sk ? skb->sk->sk_bound_dev_if : 0,
 		.flowi6_mark = skb->mark,
+		.flowi6_uid = sock_net_uid(net, skb->sk),
 		.daddr = iph->daddr,
 		.saddr = iph->saddr,
 	};
diff --git a/net/ipv6/ping.c b/net/ipv6/ping.c
index 9828681..2a965d4 100644
--- a/net/ipv6/ping.c
+++ b/net/ipv6/ping.c
@@ -113,6 +113,7 @@ static int ping_v6_sendmsg(struct sock *sk, struct msghdr *msg, size_t len)
 	fl6.daddr = *daddr;
 	fl6.flowi6_oif = oif;
 	fl6.flowi6_mark = sk->sk_mark;
+	fl6.flowi6_uid = sk->sk_uid;
 	fl6.fl6_icmp_type = user_icmph.icmp6_type;
 	fl6.fl6_icmp_code = user_icmph.icmp6_code;
 	security_sk_classify_flow(sk, flowi6_to_flowi(&fl6));
diff --git a/net/ipv6/raw.c b/net/ipv6/raw.c
index 71ffa526..ff701ce 100644
--- a/net/ipv6/raw.c
+++ b/net/ipv6/raw.c
@@ -780,6 +780,7 @@ static int rawv6_sendmsg(struct sock *sk, struct msghdr *msg, size_t len)
 	memset(&fl6, 0, sizeof(fl6));
 
 	fl6.flowi6_mark = sk->sk_mark;
+	fl6.flowi6_uid = sk->sk_uid;
 
 	ipc6.hlimit = -1;
 	ipc6.tclass = -1;
diff --git a/net/ipv6/route.c b/net/ipv6/route.c
index 70fa31e..f606c76 100644
--- a/net/ipv6/route.c
+++ b/net/ipv6/route.c
@@ -1417,7 +1417,7 @@ static void ip6_rt_update_pmtu(struct dst_entry *dst, struct sock *sk,
 }
 
 void ip6_update_pmtu(struct sk_buff *skb, struct net *net, __be32 mtu,
-		     int oif, u32 mark)
+		     int oif, u32 mark, kuid_t uid)
 {
 	const struct ipv6hdr *iph = (struct ipv6hdr *) skb->data;
 	struct dst_entry *dst;
@@ -1429,6 +1429,7 @@ void ip6_update_pmtu(struct sk_buff *skb, struct net *net, __be32 mtu,
 	fl6.daddr = iph->daddr;
 	fl6.saddr = iph->saddr;
 	fl6.flowlabel = ip6_flowinfo(iph);
+	fl6.flowi6_uid = uid;
 
 	dst = ip6_route_output(net, NULL, &fl6);
 	if (!dst->error)
@@ -1442,7 +1443,7 @@ void ip6_sk_update_pmtu(struct sk_buff *skb, struct sock *sk, __be32 mtu)
 	struct dst_entry *dst;
 
 	ip6_update_pmtu(skb, sock_net(sk), mtu,
-			sk->sk_bound_dev_if, sk->sk_mark);
+			sk->sk_bound_dev_if, sk->sk_mark, sk->sk_uid);
 
 	dst = __sk_dst_get(sk);
 	if (!dst || !dst->obsolete ||
@@ -1534,7 +1535,8 @@ static struct dst_entry *ip6_route_redirect(struct net *net,
 				flags, __ip6_route_redirect);
 }
 
-void ip6_redirect(struct sk_buff *skb, struct net *net, int oif, u32 mark)
+void ip6_redirect(struct sk_buff *skb, struct net *net, int oif, u32 mark,
+		  kuid_t uid)
 {
 	const struct ipv6hdr *iph = (struct ipv6hdr *) skb->data;
 	struct dst_entry *dst;
@@ -1547,6 +1549,7 @@ void ip6_redirect(struct sk_buff *skb, struct net *net, int oif, u32 mark)
 	fl6.daddr = iph->daddr;
 	fl6.saddr = iph->saddr;
 	fl6.flowlabel = ip6_flowinfo(iph);
+	fl6.flowi6_uid = uid;
 
 	dst = ip6_route_redirect(net, &fl6, &ipv6_hdr(skb)->saddr);
 	rt6_do_redirect(dst, NULL, skb);
@@ -1568,6 +1571,7 @@ void ip6_redirect_no_header(struct sk_buff *skb, struct net *net, int oif,
 	fl6.flowi6_mark = mark;
 	fl6.daddr = msg->dest;
 	fl6.saddr = iph->daddr;
+	fl6.flowi6_uid = sock_net_uid(net, NULL);
 
 	dst = ip6_route_redirect(net, &fl6, &iph->saddr);
 	rt6_do_redirect(dst, NULL, skb);
@@ -1576,7 +1580,8 @@ void ip6_redirect_no_header(struct sk_buff *skb, struct net *net, int oif,
 
 void ip6_sk_redirect(struct sk_buff *skb, struct sock *sk)
 {
-	ip6_redirect(skb, sock_net(sk), sk->sk_bound_dev_if, sk->sk_mark);
+	ip6_redirect(skb, sock_net(sk), sk->sk_bound_dev_if, sk->sk_mark,
+		     sk->sk_uid);
 }
 EXPORT_SYMBOL_GPL(ip6_sk_redirect);
 
@@ -2351,8 +2356,7 @@ static struct rt6_info *rt6_get_route_info(struct net *net,
 					   const struct in6_addr *gwaddr,
 					   struct net_device *dev)
 {
-	u32 tb_id = l3mdev_fib_table(dev) ? : RT6_TABLE_INFO;
-	int ifindex = dev->ifindex;
+	u32 tb_id = l3mdev_fib_table(dev) ? : addrconf_rt_table(dev, RT6_TABLE_INFO);
 	struct fib6_node *fn;
 	struct rt6_info *rt = NULL;
 	struct fib6_table *table;
@@ -2367,7 +2371,7 @@ static struct rt6_info *rt6_get_route_info(struct net *net,
 		goto out;
 
 	for (rt = fn->leaf; rt; rt = rt->dst.rt6_next) {
-		if (rt->dst.dev->ifindex != ifindex)
+		if (rt->dst.dev->ifindex != dev->ifindex)
 			continue;
 		if ((rt->rt6i_flags & (RTF_ROUTEINFO|RTF_GATEWAY)) != (RTF_ROUTEINFO|RTF_GATEWAY))
 			continue;
@@ -2398,7 +2402,7 @@ static struct rt6_info *rt6_add_route_info(struct net *net,
 		.fc_nlinfo.nl_net = net,
 	};
 
-	cfg.fc_table = l3mdev_fib_table(dev) ? : RT6_TABLE_INFO,
+	cfg.fc_table = l3mdev_fib_table(dev) ? : addrconf_rt_table(dev, RT6_TABLE_INFO),
 	cfg.fc_dst = *prefix;
 	cfg.fc_gateway = *gwaddr;
 
@@ -2414,7 +2418,7 @@ static struct rt6_info *rt6_add_route_info(struct net *net,
 
 struct rt6_info *rt6_get_dflt_router(const struct in6_addr *addr, struct net_device *dev)
 {
-	u32 tb_id = l3mdev_fib_table(dev) ? : RT6_TABLE_DFLT;
+	u32 tb_id = l3mdev_fib_table(dev) ? : addrconf_rt_table(dev, RT6_TABLE_MAIN);
 	struct rt6_info *rt;
 	struct fib6_table *table;
 
@@ -2440,7 +2444,7 @@ struct rt6_info *rt6_add_dflt_router(const struct in6_addr *gwaddr,
 				     unsigned int pref)
 {
 	struct fib6_config cfg = {
-		.fc_table	= l3mdev_fib_table(dev) ? : RT6_TABLE_DFLT,
+		.fc_table	= l3mdev_fib_table(dev) ? : addrconf_rt_table(dev, RT6_TABLE_DFLT),
 		.fc_metric	= IP6_RT_PRIO_USER,
 		.fc_ifindex	= dev->ifindex,
 		.fc_flags	= RTF_GATEWAY | RTF_ADDRCONF | RTF_DEFAULT |
@@ -2463,43 +2467,16 @@ struct rt6_info *rt6_add_dflt_router(const struct in6_addr *gwaddr,
 	return rt6_get_dflt_router(gwaddr, dev);
 }
 
-static void __rt6_purge_dflt_routers(struct fib6_table *table)
-{
-	struct rt6_info *rt;
-
-restart:
-	read_lock_bh(&table->tb6_lock);
-	for (rt = table->tb6_root.leaf; rt; rt = rt->dst.rt6_next) {
-		if (rt->rt6i_flags & (RTF_DEFAULT | RTF_ADDRCONF) &&
-		    (!rt->rt6i_idev || rt->rt6i_idev->cnf.accept_ra != 2)) {
-			dst_hold(&rt->dst);
-			read_unlock_bh(&table->tb6_lock);
-			ip6_del_rt(rt);
-			goto restart;
-		}
-	}
-	read_unlock_bh(&table->tb6_lock);
-
-	table->flags &= ~RT6_TABLE_HAS_DFLT_ROUTER;
+int rt6_addrconf_purge(struct rt6_info *rt, void *arg) {
+	if (rt->rt6i_flags & (RTF_DEFAULT | RTF_ADDRCONF) &&
+	    (!rt->rt6i_idev || rt->rt6i_idev->cnf.accept_ra != 2))
+		return -1;
+	return 0;
 }
 
 void rt6_purge_dflt_routers(struct net *net)
 {
-	struct fib6_table *table;
-	struct hlist_head *head;
-	unsigned int h;
-
-	rcu_read_lock();
-
-	for (h = 0; h < FIB6_TABLE_HASHSZ; h++) {
-		head = &net->ipv6.fib_table_hash[h];
-		hlist_for_each_entry_rcu(table, head, tb6_hlist) {
-			if (table->flags & RT6_TABLE_HAS_DFLT_ROUTER)
-				__rt6_purge_dflt_routers(table);
-		}
-	}
-
-	rcu_read_unlock();
+	fib6_clean_all(net, rt6_addrconf_purge, NULL);
 }
 
 static void rtmsg_to_fib6_config(struct net *net,
@@ -2818,6 +2795,7 @@ void rt6_mtu_change(struct net_device *dev, unsigned int mtu)
 	[RTA_ENCAP_TYPE]	= { .type = NLA_U16 },
 	[RTA_ENCAP]		= { .type = NLA_NESTED },
 	[RTA_EXPIRES]		= { .type = NLA_U32 },
+	[RTA_UID]		= { .type = NLA_U32 },
 	[RTA_TABLE]		= { .type = NLA_U32 },
 };
 
@@ -3398,6 +3376,12 @@ static int inet6_rtm_getroute(struct sk_buff *in_skb, struct nlmsghdr *nlh)
 	if (tb[RTA_MARK])
 		fl6.flowi6_mark = nla_get_u32(tb[RTA_MARK]);
 
+	if (tb[RTA_UID])
+		fl6.flowi6_uid = make_kuid(current_user_ns(),
+					   nla_get_u32(tb[RTA_UID]));
+	else
+		fl6.flowi6_uid = iif ? INVALID_UID : current_uid();
+
 	if (iif) {
 		struct net_device *dev;
 		int flags = 0;
diff --git a/net/ipv6/syncookies.c b/net/ipv6/syncookies.c
index 7a86433d..a67174e 100644
--- a/net/ipv6/syncookies.c
+++ b/net/ipv6/syncookies.c
@@ -228,6 +228,7 @@ struct sock *cookie_v6_check(struct sock *sk, struct sk_buff *skb)
 		fl6.flowi6_mark = ireq->ir_mark;
 		fl6.fl6_dport = ireq->ir_rmt_port;
 		fl6.fl6_sport = inet_sk(sk)->inet_sport;
+		fl6.flowi6_uid = sk->sk_uid;
 		security_req_classify_flow(req, flowi6_to_flowi(&fl6));
 
 		dst = ip6_dst_lookup_flow(sk, &fl6, final_p);
diff --git a/net/ipv6/tcp_ipv6.c b/net/ipv6/tcp_ipv6.c
index 0a69d39..cb0813c 100644
--- a/net/ipv6/tcp_ipv6.c
+++ b/net/ipv6/tcp_ipv6.c
@@ -238,6 +238,7 @@ static int tcp_v6_connect(struct sock *sk, struct sockaddr *uaddr,
 	fl6.flowi6_mark = sk->sk_mark;
 	fl6.fl6_dport = usin->sin6_port;
 	fl6.fl6_sport = inet->inet_sport;
+	fl6.flowi6_uid = sk->sk_uid;
 
 	opt = rcu_dereference_protected(np->opt, lockdep_sock_is_held(sk));
 	final_p = fl6_update_dst(&fl6, opt, &final);
@@ -289,6 +290,11 @@ static int tcp_v6_connect(struct sock *sk, struct sockaddr *uaddr,
 							     inet->inet_sport,
 							     inet->inet_dport);
 
+	if (tcp_fastopen_defer_connect(sk, &err))
+		return err;
+	if (err)
+		goto late_failure;
+
 	err = tcp_connect(sk);
 	if (err)
 		goto late_failure;
@@ -297,7 +303,6 @@ static int tcp_v6_connect(struct sock *sk, struct sockaddr *uaddr,
 
 late_failure:
 	tcp_set_state(sk, TCP_CLOSE);
-	__sk_dst_reset(sk);
 failure:
 	inet->inet_dport = 0;
 	sk->sk_route_caps = 0;
@@ -835,6 +840,7 @@ static void tcp_v6_send_response(const struct sock *sk, struct sk_buff *skb, u32
 	fl6.flowi6_mark = IP6_REPLY_MARK(net, skb->mark);
 	fl6.fl6_dport = t1->dest;
 	fl6.fl6_sport = t1->source;
+	fl6.flowi6_uid = sock_net_uid(net, sk && sk_fullsock(sk) ? sk : NULL);
 	security_skb_classify_flow(skb, flowi6_to_flowi(&fl6));
 
 	/* Pass a socket to ip6_dst_lookup either it is for RST
@@ -1240,9 +1246,6 @@ static int tcp_v6_do_rcv(struct sock *sk, struct sk_buff *skb)
 	if (skb->protocol == htons(ETH_P_IP))
 		return tcp_v4_do_rcv(sk, skb);
 
-	if (tcp_filter(sk, skb))
-		goto discard;
-
 	/*
 	 *	socket locking is here for SMP purposes as backlog rcv
 	 *	is currently called with bh processing disabled.
@@ -1443,7 +1446,9 @@ static int tcp_v6_rcv(struct sk_buff *skb)
 		}
 		sock_hold(sk);
 		refcounted = true;
-		nsk = tcp_check_req(sk, skb, req, false);
+		nsk = NULL;
+		if (!tcp_filter(sk, skb))
+			nsk = tcp_check_req(sk, skb, req, false);
 		if (!nsk) {
 			reqsk_put(req);
 			goto discard_and_relse;
diff --git a/net/ipv6/udp.c b/net/ipv6/udp.c
index 4db5f54..c43ef0c 100644
--- a/net/ipv6/udp.c
+++ b/net/ipv6/udp.c
@@ -1162,6 +1162,7 @@ int udpv6_sendmsg(struct sock *sk, struct msghdr *msg, size_t len)
 		fl6.flowi6_oif = np->sticky_pktinfo.ipi6_ifindex;
 
 	fl6.flowi6_mark = sk->sk_mark;
+	fl6.flowi6_uid = sk->sk_uid;
 
 	if (msg->msg_controllen) {
 		opt = &opt_space;
diff --git a/net/ipv6/xfrm6_policy.c b/net/ipv6/xfrm6_policy.c
index 0c7f27a..d82f427 100644
--- a/net/ipv6/xfrm6_policy.c
+++ b/net/ipv6/xfrm6_policy.c
@@ -29,7 +29,8 @@
 
 static struct dst_entry *xfrm6_dst_lookup(struct net *net, int tos, int oif,
 					  const xfrm_address_t *saddr,
-					  const xfrm_address_t *daddr)
+					  const xfrm_address_t *daddr,
+					  u32 mark)
 {
 	struct flowi6 fl6;
 	struct dst_entry *dst;
@@ -38,6 +39,7 @@ static struct dst_entry *xfrm6_dst_lookup(struct net *net, int tos, int oif,
 	memset(&fl6, 0, sizeof(fl6));
 	fl6.flowi6_oif = l3mdev_master_ifindex_by_index(net, oif);
 	fl6.flowi6_flags = FLOWI_FLAG_SKIP_NH_OIF;
+	fl6.flowi6_mark = mark;
 	memcpy(&fl6.daddr, daddr, sizeof(fl6.daddr));
 	if (saddr)
 		memcpy(&fl6.saddr, saddr, sizeof(fl6.saddr));
@@ -54,12 +56,13 @@ static struct dst_entry *xfrm6_dst_lookup(struct net *net, int tos, int oif,
 }
 
 static int xfrm6_get_saddr(struct net *net, int oif,
-			   xfrm_address_t *saddr, xfrm_address_t *daddr)
+			   xfrm_address_t *saddr, xfrm_address_t *daddr,
+			   u32 mark)
 {
 	struct dst_entry *dst;
 	struct net_device *dev;
 
-	dst = xfrm6_dst_lookup(net, 0, oif, NULL, daddr);
+	dst = xfrm6_dst_lookup(net, 0, oif, NULL, daddr, mark);
 	if (IS_ERR(dst))
 		return -EHOSTUNREACH;
 
diff --git a/net/l2tp/l2tp_ip6.c b/net/l2tp/l2tp_ip6.c
index 2470972..86ad51a 100644
--- a/net/l2tp/l2tp_ip6.c
+++ b/net/l2tp/l2tp_ip6.c
@@ -526,6 +526,7 @@ static int l2tp_ip6_sendmsg(struct sock *sk, struct msghdr *msg, size_t len)
 	memset(&fl6, 0, sizeof(fl6));
 
 	fl6.flowi6_mark = sk->sk_mark;
+	fl6.flowi6_uid = sk->sk_uid;
 
 	ipc6.hlimit = -1;
 	ipc6.tclass = -1;
diff --git a/net/netfilter/Kconfig b/net/netfilter/Kconfig
index e8d56d9..177d3ae 100644
--- a/net/netfilter/Kconfig
+++ b/net/netfilter/Kconfig
@@ -1316,6 +1316,8 @@ config NETFILTER_XT_MATCH_OWNER
 	based on who created the socket: the user or group. It is also
 	possible to check whether a socket actually exists.
 
+	Conflicts with '"quota, tag, uid" match'
+
 config NETFILTER_XT_MATCH_POLICY
 	tristate 'IPsec "policy" match support'
 	depends on XFRM
@@ -1349,6 +1351,22 @@ config NETFILTER_XT_MATCH_PKTTYPE
 
 	  To compile it as a module, choose M here.  If unsure, say N.
 
+config NETFILTER_XT_MATCH_QTAGUID
+	bool '"quota, tag, owner" match and stats support'
+        depends on NETFILTER_XT_MATCH_SOCKET
+	depends on NETFILTER_XT_MATCH_OWNER=n
+	help
+	  This option replaces the `owner' match. In addition to matching
+	  on uid, it keeps stats based on a tag assigned to a socket.
+	  The full tag is comprised of a UID and an accounting tag.
+	  The tags are assignable to sockets from user space (e.g. a download
+	  manager can assign the socket to another UID for accounting).
+	  Stats and control are done via /proc/net/xt_qtaguid/.
+	  It replaces owner as it takes the same arguments, but should
+	  really be recognized by the iptables tool.
+
+	  If unsure, say `N'.
+
 config NETFILTER_XT_MATCH_QUOTA
 	tristate '"quota" match support'
 	depends on NETFILTER_ADVANCED
@@ -1359,6 +1377,29 @@ config NETFILTER_XT_MATCH_QUOTA
 	  If you want to compile it as a module, say M here and read
 	  <file:Documentation/kbuild/modules.txt>.  If unsure, say `N'.
 
+config NETFILTER_XT_MATCH_QUOTA2
+	tristate '"quota2" match support'
+	depends on NETFILTER_ADVANCED
+	help
+	  This option adds a `quota2' match, which allows to match on a
+	  byte counter correctly and not per CPU.
+	  It allows naming the quotas.
+	  This is based on http://xtables-addons.git.sourceforge.net
+
+	  If you want to compile it as a module, say M here and read
+	  <file:Documentation/kbuild/modules.txt>.  If unsure, say `N'.
+
+config NETFILTER_XT_MATCH_QUOTA2_LOG
+	bool '"quota2" Netfilter LOG support'
+	depends on NETFILTER_XT_MATCH_QUOTA2
+	default n
+	help
+	  This option allows `quota2' to log ONCE when a quota limit
+	  is passed. It logs via NETLINK using the NETLINK_NFLOG family.
+	  It logs similarly to how ipt_ULOG would without data.
+
+	  If unsure, say `N'.
+
 config NETFILTER_XT_MATCH_RATEEST
 	tristate '"rateest" match support'
 	depends on NETFILTER_ADVANCED
diff --git a/net/netfilter/Makefile b/net/netfilter/Makefile
index c23c3c8..54ba5aa 100644
--- a/net/netfilter/Makefile
+++ b/net/netfilter/Makefile
@@ -167,7 +167,9 @@ obj-$(CONFIG_NETFILTER_XT_MATCH_CGROUP) += xt_cgroup.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_PHYSDEV) += xt_physdev.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_PKTTYPE) += xt_pkttype.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_POLICY) += xt_policy.o
+obj-$(CONFIG_NETFILTER_XT_MATCH_QTAGUID) += xt_qtaguid_print.o xt_qtaguid.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_QUOTA) += xt_quota.o
+obj-$(CONFIG_NETFILTER_XT_MATCH_QUOTA2) += xt_quota2.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_RATEEST) += xt_rateest.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_REALM) += xt_realm.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_RECENT) += xt_recent.o
diff --git a/net/netfilter/nf_conntrack_core.c b/net/netfilter/nf_conntrack_core.c
index 2039fd7..b0f11e5 100644
--- a/net/netfilter/nf_conntrack_core.c
+++ b/net/netfilter/nf_conntrack_core.c
@@ -1023,7 +1023,7 @@ static void gc_worker(struct work_struct *work)
 
 	next_run = gc_work->next_gc_run;
 	gc_work->last_bucket = i;
-	queue_delayed_work(system_long_wq, &gc_work->dwork, next_run);
+	queue_delayed_work(system_power_efficient_wq, &gc_work->dwork, next_run);
 }
 
 static void conntrack_gc_work_init(struct conntrack_gc_work *gc_work)
@@ -1813,7 +1813,7 @@ int nf_conntrack_hash_resize(unsigned int hashsize)
 	return 0;
 }
 
-int nf_conntrack_set_hashsize(const char *val, struct kernel_param *kp)
+int nf_conntrack_set_hashsize(const char *val, const struct kernel_param *kp)
 {
 	unsigned int hashsize;
 	int rc;
@@ -1941,7 +1941,7 @@ int nf_conntrack_init_start(void)
 	nf_ct_untracked_status_or(IPS_CONFIRMED | IPS_UNTRACKED);
 
 	conntrack_gc_work_init(&conntrack_gc_work);
-	queue_delayed_work(system_long_wq, &conntrack_gc_work.dwork, HZ);
+	queue_delayed_work(system_power_efficient_wq, &conntrack_gc_work.dwork, HZ);
 
 	return 0;
 
diff --git a/net/netfilter/nf_nat_ftp.c b/net/netfilter/nf_nat_ftp.c
index e84a578..d76afaf 100644
--- a/net/netfilter/nf_nat_ftp.c
+++ b/net/netfilter/nf_nat_ftp.c
@@ -134,7 +134,7 @@ static int __init nf_nat_ftp_init(void)
 }
 
 /* Prior to 2.6.11, we had a ports param.  No longer, but don't break users. */
-static int warn_set(const char *val, struct kernel_param *kp)
+static int warn_set(const char *val, const struct kernel_param *kp)
 {
 	printk(KERN_INFO KBUILD_MODNAME
 	       ": kernel >= 2.6.10 only uses 'ports' for conntrack modules\n");
diff --git a/net/netfilter/nf_nat_irc.c b/net/netfilter/nf_nat_irc.c
index 1fb2258..8039bcd 100644
--- a/net/netfilter/nf_nat_irc.c
+++ b/net/netfilter/nf_nat_irc.c
@@ -107,7 +107,7 @@ static int __init nf_nat_irc_init(void)
 }
 
 /* Prior to 2.6.11, we had a ports param.  No longer, but don't break users. */
-static int warn_set(const char *val, struct kernel_param *kp)
+static int warn_set(const char *val, const struct kernel_param *kp)
 {
 	printk(KERN_INFO KBUILD_MODNAME
 	       ": kernel >= 2.6.10 only uses 'ports' for conntrack modules\n");
diff --git a/net/netfilter/xt_IDLETIMER.c b/net/netfilter/xt_IDLETIMER.c
index bb5d6a0..12d33ea 100644
--- a/net/netfilter/xt_IDLETIMER.c
+++ b/net/netfilter/xt_IDLETIMER.c
@@ -5,6 +5,7 @@
  * After timer expires a kevent will be sent.
  *
  * Copyright (C) 2004, 2010 Nokia Corporation
+ *
  * Written by Timo Teras <ext-timo.teras@nokia.com>
  *
  * Converted to x_tables and reworked for upstream inclusion
@@ -38,8 +39,17 @@
 #include <linux/netfilter/xt_IDLETIMER.h>
 #include <linux/kdev_t.h>
 #include <linux/kobject.h>
+#include <linux/skbuff.h>
 #include <linux/workqueue.h>
 #include <linux/sysfs.h>
+#include <linux/rtc.h>
+#include <linux/time.h>
+#include <linux/math64.h>
+#include <linux/suspend.h>
+#include <linux/notifier.h>
+#include <net/net_namespace.h>
+#include <net/sock.h>
+#include <net/inet_sock.h>
 
 struct idletimer_tg_attr {
 	struct attribute attr;
@@ -55,14 +65,110 @@ struct idletimer_tg {
 	struct kobject *kobj;
 	struct idletimer_tg_attr attr;
 
+	struct timespec delayed_timer_trigger;
+	struct timespec last_modified_timer;
+	struct timespec last_suspend_time;
+	struct notifier_block pm_nb;
+
+	int timeout;
 	unsigned int refcnt;
+	bool work_pending;
+	bool send_nl_msg;
+	bool active;
+	uid_t uid;
 };
 
 static LIST_HEAD(idletimer_tg_list);
 static DEFINE_MUTEX(list_mutex);
+static DEFINE_SPINLOCK(timestamp_lock);
 
 static struct kobject *idletimer_tg_kobj;
 
+static bool check_for_delayed_trigger(struct idletimer_tg *timer,
+		struct timespec *ts)
+{
+	bool state;
+	struct timespec temp;
+	spin_lock_bh(&timestamp_lock);
+	timer->work_pending = false;
+	if ((ts->tv_sec - timer->last_modified_timer.tv_sec) > timer->timeout ||
+			timer->delayed_timer_trigger.tv_sec != 0) {
+		state = false;
+		temp.tv_sec = timer->timeout;
+		temp.tv_nsec = 0;
+		if (timer->delayed_timer_trigger.tv_sec != 0) {
+			temp = timespec_add(timer->delayed_timer_trigger, temp);
+			ts->tv_sec = temp.tv_sec;
+			ts->tv_nsec = temp.tv_nsec;
+			timer->delayed_timer_trigger.tv_sec = 0;
+			timer->work_pending = true;
+			schedule_work(&timer->work);
+		} else {
+			temp = timespec_add(timer->last_modified_timer, temp);
+			ts->tv_sec = temp.tv_sec;
+			ts->tv_nsec = temp.tv_nsec;
+		}
+	} else {
+		state = timer->active;
+	}
+	spin_unlock_bh(&timestamp_lock);
+	return state;
+}
+
+static void notify_netlink_uevent(const char *iface, struct idletimer_tg *timer)
+{
+	char iface_msg[NLMSG_MAX_SIZE];
+	char state_msg[NLMSG_MAX_SIZE];
+	char timestamp_msg[NLMSG_MAX_SIZE];
+	char uid_msg[NLMSG_MAX_SIZE];
+	char *envp[] = { iface_msg, state_msg, timestamp_msg, uid_msg, NULL };
+	int res;
+	struct timespec ts;
+	uint64_t time_ns;
+	bool state;
+
+	res = snprintf(iface_msg, NLMSG_MAX_SIZE, "INTERFACE=%s",
+		       iface);
+	if (NLMSG_MAX_SIZE <= res) {
+		pr_err("message too long (%d)", res);
+		return;
+	}
+
+	get_monotonic_boottime(&ts);
+	state = check_for_delayed_trigger(timer, &ts);
+	res = snprintf(state_msg, NLMSG_MAX_SIZE, "STATE=%s",
+			state ? "active" : "inactive");
+
+	if (NLMSG_MAX_SIZE <= res) {
+		pr_err("message too long (%d)", res);
+		return;
+	}
+
+	if (state) {
+		res = snprintf(uid_msg, NLMSG_MAX_SIZE, "UID=%u", timer->uid);
+		if (NLMSG_MAX_SIZE <= res)
+			pr_err("message too long (%d)", res);
+	} else {
+		res = snprintf(uid_msg, NLMSG_MAX_SIZE, "UID=");
+		if (NLMSG_MAX_SIZE <= res)
+			pr_err("message too long (%d)", res);
+	}
+
+	time_ns = timespec_to_ns(&ts);
+	res = snprintf(timestamp_msg, NLMSG_MAX_SIZE, "TIME_NS=%llu", time_ns);
+	if (NLMSG_MAX_SIZE <= res) {
+		timestamp_msg[0] = '\0';
+		pr_err("message too long (%d)", res);
+	}
+
+	pr_debug("putting nlmsg: <%s> <%s> <%s> <%s>\n", iface_msg, state_msg,
+		 timestamp_msg, uid_msg);
+	kobject_uevent_env(idletimer_tg_kobj, KOBJ_CHANGE, envp);
+	return;
+
+
+}
+
 static
 struct idletimer_tg *__idletimer_tg_find_by_label(const char *label)
 {
@@ -83,6 +189,7 @@ static ssize_t idletimer_tg_show(struct kobject *kobj, struct attribute *attr,
 {
 	struct idletimer_tg *timer;
 	unsigned long expires = 0;
+	unsigned long now = jiffies;
 
 	mutex_lock(&list_mutex);
 
@@ -92,11 +199,15 @@ static ssize_t idletimer_tg_show(struct kobject *kobj, struct attribute *attr,
 
 	mutex_unlock(&list_mutex);
 
-	if (time_after(expires, jiffies))
+	if (time_after(expires, now))
 		return sprintf(buf, "%u\n",
-			       jiffies_to_msecs(expires - jiffies) / 1000);
+			       jiffies_to_msecs(expires - now) / 1000);
 
-	return sprintf(buf, "0\n");
+	if (timer->send_nl_msg)
+		return sprintf(buf, "0 %d\n",
+			jiffies_to_msecs(now - expires) / 1000);
+	else
+		return sprintf(buf, "0\n");
 }
 
 static void idletimer_tg_work(struct work_struct *work)
@@ -105,6 +216,9 @@ static void idletimer_tg_work(struct work_struct *work)
 						  work);
 
 	sysfs_notify(idletimer_tg_kobj, NULL, timer->attr.attr.name);
+
+	if (timer->send_nl_msg)
+		notify_netlink_uevent(timer->attr.attr.name, timer);
 }
 
 static void idletimer_tg_expired(unsigned long data)
@@ -112,8 +226,55 @@ static void idletimer_tg_expired(unsigned long data)
 	struct idletimer_tg *timer = (struct idletimer_tg *) data;
 
 	pr_debug("timer %s expired\n", timer->attr.attr.name);
-
+	spin_lock_bh(&timestamp_lock);
+	timer->active = false;
+	timer->work_pending = true;
 	schedule_work(&timer->work);
+	spin_unlock_bh(&timestamp_lock);
+}
+
+static int idletimer_resume(struct notifier_block *notifier,
+		unsigned long pm_event, void *unused)
+{
+	struct timespec ts;
+	unsigned long time_diff, now = jiffies;
+	struct idletimer_tg *timer = container_of(notifier,
+			struct idletimer_tg, pm_nb);
+	if (!timer)
+		return NOTIFY_DONE;
+	switch (pm_event) {
+	case PM_SUSPEND_PREPARE:
+		get_monotonic_boottime(&timer->last_suspend_time);
+		break;
+	case PM_POST_SUSPEND:
+		spin_lock_bh(&timestamp_lock);
+		if (!timer->active) {
+			spin_unlock_bh(&timestamp_lock);
+			break;
+		}
+		/* since jiffies are not updated when suspended now represents
+		 * the time it would have suspended */
+		if (time_after(timer->timer.expires, now)) {
+			get_monotonic_boottime(&ts);
+			ts = timespec_sub(ts, timer->last_suspend_time);
+			time_diff = timespec_to_jiffies(&ts);
+			if (timer->timer.expires > (time_diff + now)) {
+				mod_timer_pending(&timer->timer,
+						(timer->timer.expires - time_diff));
+			} else {
+				del_timer(&timer->timer);
+				timer->timer.expires = 0;
+				timer->active = false;
+				timer->work_pending = true;
+				schedule_work(&timer->work);
+			}
+		}
+		spin_unlock_bh(&timestamp_lock);
+		break;
+	default:
+		break;
+	}
+	return NOTIFY_DONE;
 }
 
 static int idletimer_tg_create(struct idletimer_tg_info *info)
@@ -146,6 +307,21 @@ static int idletimer_tg_create(struct idletimer_tg_info *info)
 	setup_timer(&info->timer->timer, idletimer_tg_expired,
 		    (unsigned long) info->timer);
 	info->timer->refcnt = 1;
+	info->timer->send_nl_msg = (info->send_nl_msg == 0) ? false : true;
+	info->timer->active = true;
+	info->timer->timeout = info->timeout;
+
+	info->timer->delayed_timer_trigger.tv_sec = 0;
+	info->timer->delayed_timer_trigger.tv_nsec = 0;
+	info->timer->work_pending = false;
+	info->timer->uid = 0;
+	get_monotonic_boottime(&info->timer->last_modified_timer);
+
+	info->timer->pm_nb.notifier_call = idletimer_resume;
+	ret = register_pm_notifier(&info->timer->pm_nb);
+	if (ret)
+		printk(KERN_WARNING "[%s] Failed to register pm notifier %d\n",
+				__func__, ret);
 
 	INIT_WORK(&info->timer->work, idletimer_tg_work);
 
@@ -162,6 +338,42 @@ static int idletimer_tg_create(struct idletimer_tg_info *info)
 	return ret;
 }
 
+static void reset_timer(const struct idletimer_tg_info *info,
+			struct sk_buff *skb)
+{
+	unsigned long now = jiffies;
+	struct idletimer_tg *timer = info->timer;
+	bool timer_prev;
+
+	spin_lock_bh(&timestamp_lock);
+	timer_prev = timer->active;
+	timer->active = true;
+	/* timer_prev is used to guard overflow problem in time_before*/
+	if (!timer_prev || time_before(timer->timer.expires, now)) {
+		pr_debug("Starting Checkentry timer (Expired, Jiffies): %lu, %lu\n",
+				timer->timer.expires, now);
+
+		/* Stores the uid resposible for waking up the radio */
+		if (skb && (skb->sk)) {
+			timer->uid = from_kuid_munged(current_user_ns(),
+					sock_i_uid(skb_to_full_sk(skb)));
+		}
+
+		/* checks if there is a pending inactive notification*/
+		if (timer->work_pending)
+			timer->delayed_timer_trigger = timer->last_modified_timer;
+		else {
+			timer->work_pending = true;
+			schedule_work(&timer->work);
+		}
+	}
+
+	get_monotonic_boottime(&timer->last_modified_timer);
+	mod_timer(&timer->timer,
+			msecs_to_jiffies(info->timeout * 1000) + now);
+	spin_unlock_bh(&timestamp_lock);
+}
+
 /*
  * The actual xt_tables plugin.
  */
@@ -169,15 +381,23 @@ static unsigned int idletimer_tg_target(struct sk_buff *skb,
 					 const struct xt_action_param *par)
 {
 	const struct idletimer_tg_info *info = par->targinfo;
+	unsigned long now = jiffies;
 
 	pr_debug("resetting timer %s, timeout period %u\n",
 		 info->label, info->timeout);
 
 	BUG_ON(!info->timer);
 
-	mod_timer(&info->timer->timer,
-		  msecs_to_jiffies(info->timeout * 1000) + jiffies);
+	info->timer->active = true;
+
+	if (time_before(info->timer->timer.expires, now)) {
+		schedule_work(&info->timer->work);
+		pr_debug("Starting timer %s (Expired, Jiffies): %lu, %lu\n",
+			 info->label, info->timer->timer.expires, now);
+	}
 
+	/* TODO: Avoid modifying timers on each packet */
+	reset_timer(info, skb);
 	return XT_CONTINUE;
 }
 
@@ -186,7 +406,7 @@ static int idletimer_tg_checkentry(const struct xt_tgchk_param *par)
 	struct idletimer_tg_info *info = par->targinfo;
 	int ret;
 
-	pr_debug("checkentry targinfo%s\n", info->label);
+	pr_debug("checkentry targinfo %s\n", info->label);
 
 	if (info->timeout == 0) {
 		pr_debug("timeout value is zero\n");
@@ -208,9 +428,7 @@ static int idletimer_tg_checkentry(const struct xt_tgchk_param *par)
 	info->timer = __idletimer_tg_find_by_label(info->label);
 	if (info->timer) {
 		info->timer->refcnt++;
-		mod_timer(&info->timer->timer,
-			  msecs_to_jiffies(info->timeout * 1000) + jiffies);
-
+		reset_timer(info, NULL);
 		pr_debug("increased refcnt of timer %s to %u\n",
 			 info->label, info->timer->refcnt);
 	} else {
@@ -223,6 +441,7 @@ static int idletimer_tg_checkentry(const struct xt_tgchk_param *par)
 	}
 
 	mutex_unlock(&list_mutex);
+
 	return 0;
 }
 
@@ -239,13 +458,14 @@ static void idletimer_tg_destroy(const struct xt_tgdtor_param *par)
 
 		list_del(&info->timer->entry);
 		del_timer_sync(&info->timer->timer);
-		cancel_work_sync(&info->timer->work);
 		sysfs_remove_file(idletimer_tg_kobj, &info->timer->attr.attr);
+		unregister_pm_notifier(&info->timer->pm_nb);
+		cancel_work_sync(&info->timer->work);
 		kfree(info->timer->attr.attr.name);
 		kfree(info->timer);
 	} else {
 		pr_debug("decreased refcnt of timer %s to %u\n",
-			 info->label, info->timer->refcnt);
+		info->label, info->timer->refcnt);
 	}
 
 	mutex_unlock(&list_mutex);
@@ -253,6 +473,7 @@ static void idletimer_tg_destroy(const struct xt_tgdtor_param *par)
 
 static struct xt_target idletimer_tg __read_mostly = {
 	.name		= "IDLETIMER",
+	.revision	= 1,
 	.family		= NFPROTO_UNSPEC,
 	.target		= idletimer_tg_target,
 	.targetsize     = sizeof(struct idletimer_tg_info),
@@ -318,3 +539,4 @@ static void __exit idletimer_tg_exit(void)
 MODULE_LICENSE("GPL v2");
 MODULE_ALIAS("ipt_IDLETIMER");
 MODULE_ALIAS("ip6t_IDLETIMER");
+MODULE_ALIAS("arpt_IDLETIMER");
diff --git a/net/netfilter/xt_bpf.c b/net/netfilter/xt_bpf.c
index dffee9d47..a8df0a9 100644
--- a/net/netfilter/xt_bpf.c
+++ b/net/netfilter/xt_bpf.c
@@ -8,8 +8,10 @@
  */
 
 #include <linux/module.h>
+#include <linux/syscalls.h>
 #include <linux/skbuff.h>
 #include <linux/filter.h>
+#include <linux/bpf.h>
 
 #include <linux/netfilter/xt_bpf.h>
 #include <linux/netfilter/x_tables.h>
@@ -20,15 +22,18 @@
 MODULE_ALIAS("ipt_bpf");
 MODULE_ALIAS("ip6t_bpf");
 
-static int bpf_mt_check(const struct xt_mtchk_param *par)
+static int __bpf_mt_check_bytecode(struct sock_filter *insns, __u16 len,
+				   struct bpf_prog **ret)
 {
-	struct xt_bpf_info *info = par->matchinfo;
 	struct sock_fprog_kern program;
 
-	program.len = info->bpf_program_num_elem;
-	program.filter = info->bpf_program;
+	if (len > XT_BPF_MAX_NUM_INSTR)
+		return -EINVAL;
 
-	if (bpf_prog_create(&info->filter, &program)) {
+	program.len = len;
+	program.filter = insns;
+
+	if (bpf_prog_create(ret, &program)) {
 		pr_info("bpf: check failed: parse error\n");
 		return -EINVAL;
 	}
@@ -36,6 +41,53 @@ static int bpf_mt_check(const struct xt_mtchk_param *par)
 	return 0;
 }
 
+static int __bpf_mt_check_fd(int fd, struct bpf_prog **ret)
+{
+	struct bpf_prog *prog;
+
+	prog = bpf_prog_get_type(fd, BPF_PROG_TYPE_SOCKET_FILTER);
+	if (IS_ERR(prog))
+		return PTR_ERR(prog);
+
+	*ret = prog;
+	return 0;
+}
+
+static int __bpf_mt_check_path(const char *path, struct bpf_prog **ret)
+{
+	if (strnlen(path, XT_BPF_PATH_MAX) == XT_BPF_PATH_MAX)
+		return -EINVAL;
+
+	*ret = bpf_prog_get_type_path(path, BPF_PROG_TYPE_SOCKET_FILTER);
+	return PTR_ERR_OR_ZERO(*ret);
+
+}
+
+static int bpf_mt_check(const struct xt_mtchk_param *par)
+{
+	struct xt_bpf_info *info = par->matchinfo;
+
+	return __bpf_mt_check_bytecode(info->bpf_program,
+				       info->bpf_program_num_elem,
+				       &info->filter);
+}
+
+static int bpf_mt_check_v1(const struct xt_mtchk_param *par)
+{
+	struct xt_bpf_info_v1 *info = par->matchinfo;
+
+	if (info->mode == XT_BPF_MODE_BYTECODE)
+		return __bpf_mt_check_bytecode(info->bpf_program,
+					       info->bpf_program_num_elem,
+					       &info->filter);
+	else if (info->mode == XT_BPF_MODE_FD_ELF)
+		return __bpf_mt_check_fd(info->fd, &info->filter);
+	else if (info->mode == XT_BPF_MODE_PATH_PINNED)
+		return __bpf_mt_check_path(info->path, &info->filter);
+	else
+		return -EINVAL;
+}
+
 static bool bpf_mt(const struct sk_buff *skb, struct xt_action_param *par)
 {
 	const struct xt_bpf_info *info = par->matchinfo;
@@ -43,31 +95,58 @@ static bool bpf_mt(const struct sk_buff *skb, struct xt_action_param *par)
 	return BPF_PROG_RUN(info->filter, skb);
 }
 
+static bool bpf_mt_v1(const struct sk_buff *skb, struct xt_action_param *par)
+{
+	const struct xt_bpf_info_v1 *info = par->matchinfo;
+
+	return !!bpf_prog_run_save_cb(info->filter, (struct sk_buff *) skb);
+}
+
 static void bpf_mt_destroy(const struct xt_mtdtor_param *par)
 {
 	const struct xt_bpf_info *info = par->matchinfo;
+
+	bpf_prog_destroy(info->filter);
+}
+
+static void bpf_mt_destroy_v1(const struct xt_mtdtor_param *par)
+{
+	const struct xt_bpf_info_v1 *info = par->matchinfo;
+
 	bpf_prog_destroy(info->filter);
 }
 
-static struct xt_match bpf_mt_reg __read_mostly = {
-	.name		= "bpf",
-	.revision	= 0,
-	.family		= NFPROTO_UNSPEC,
-	.checkentry	= bpf_mt_check,
-	.match		= bpf_mt,
-	.destroy	= bpf_mt_destroy,
-	.matchsize	= sizeof(struct xt_bpf_info),
-	.me		= THIS_MODULE,
+static struct xt_match bpf_mt_reg[] __read_mostly = {
+	{
+		.name		= "bpf",
+		.revision	= 0,
+		.family		= NFPROTO_UNSPEC,
+		.checkentry	= bpf_mt_check,
+		.match		= bpf_mt,
+		.destroy	= bpf_mt_destroy,
+		.matchsize	= sizeof(struct xt_bpf_info),
+		.me		= THIS_MODULE,
+	},
+	{
+		.name		= "bpf",
+		.revision	= 1,
+		.family		= NFPROTO_UNSPEC,
+		.checkentry	= bpf_mt_check_v1,
+		.match		= bpf_mt_v1,
+		.destroy	= bpf_mt_destroy_v1,
+		.matchsize	= sizeof(struct xt_bpf_info_v1),
+		.me		= THIS_MODULE,
+	},
 };
 
 static int __init bpf_mt_init(void)
 {
-	return xt_register_match(&bpf_mt_reg);
+	return xt_register_matches(bpf_mt_reg, ARRAY_SIZE(bpf_mt_reg));
 }
 
 static void __exit bpf_mt_exit(void)
 {
-	xt_unregister_match(&bpf_mt_reg);
+	xt_unregister_matches(bpf_mt_reg, ARRAY_SIZE(bpf_mt_reg));
 }
 
 module_init(bpf_mt_init);
diff --git a/net/netfilter/xt_qtaguid.c b/net/netfilter/xt_qtaguid.c
new file mode 100644
index 00000000..d677909
--- /dev/null
+++ b/net/netfilter/xt_qtaguid.c
@@ -0,0 +1,3021 @@
+/*
+ * Kernel iptables module to track stats for packets based on user tags.
+ *
+ * (C) 2011 Google, Inc
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+/*
+ * There are run-time debug flags enabled via the debug_mask module param, or
+ * via the DEFAULT_DEBUG_MASK. See xt_qtaguid_internal.h.
+ */
+#define DEBUG
+
+#include <linux/file.h>
+#include <linux/inetdevice.h>
+#include <linux/module.h>
+#include <linux/miscdevice.h>
+#include <linux/netfilter/x_tables.h>
+#include <linux/netfilter/xt_qtaguid.h>
+#include <linux/ratelimit.h>
+#include <linux/seq_file.h>
+#include <linux/skbuff.h>
+#include <linux/workqueue.h>
+#include <net/addrconf.h>
+#include <net/sock.h>
+#include <net/tcp.h>
+#include <net/udp.h>
+
+#if defined(CONFIG_IP6_NF_IPTABLES) || defined(CONFIG_IP6_NF_IPTABLES_MODULE)
+#include <linux/netfilter_ipv6/ip6_tables.h>
+#endif
+
+#include <linux/netfilter/xt_socket.h>
+#include "xt_qtaguid_internal.h"
+#include "xt_qtaguid_print.h"
+#include "../../fs/proc/internal.h"
+
+/*
+ * We only use the xt_socket funcs within a similar context to avoid unexpected
+ * return values.
+ */
+#define XT_SOCKET_SUPPORTED_HOOKS \
+	((1 << NF_INET_PRE_ROUTING) | (1 << NF_INET_LOCAL_IN))
+
+
+static const char *module_procdirname = "xt_qtaguid";
+static struct proc_dir_entry *xt_qtaguid_procdir;
+
+static unsigned int proc_iface_perms = S_IRUGO;
+module_param_named(iface_perms, proc_iface_perms, uint, S_IRUGO | S_IWUSR);
+
+static struct proc_dir_entry *xt_qtaguid_stats_file;
+static unsigned int proc_stats_perms = S_IRUGO;
+module_param_named(stats_perms, proc_stats_perms, uint, S_IRUGO | S_IWUSR);
+
+static struct proc_dir_entry *xt_qtaguid_ctrl_file;
+
+/* Everybody can write. But proc_ctrl_write_limited is true by default which
+ * limits what can be controlled. See the can_*() functions.
+ */
+static unsigned int proc_ctrl_perms = S_IRUGO | S_IWUGO;
+module_param_named(ctrl_perms, proc_ctrl_perms, uint, S_IRUGO | S_IWUSR);
+
+/* Limited by default, so the gid of the ctrl and stats proc entries
+ * will limit what can be done. See the can_*() functions.
+ */
+static bool proc_stats_readall_limited = true;
+static bool proc_ctrl_write_limited = true;
+
+module_param_named(stats_readall_limited, proc_stats_readall_limited, bool,
+		   S_IRUGO | S_IWUSR);
+module_param_named(ctrl_write_limited, proc_ctrl_write_limited, bool,
+		   S_IRUGO | S_IWUSR);
+
+/*
+ * Limit the number of active tags (via socket tags) for a given UID.
+ * Multiple processes could share the UID.
+ */
+static int max_sock_tags = DEFAULT_MAX_SOCK_TAGS;
+module_param(max_sock_tags, int, S_IRUGO | S_IWUSR);
+
+/*
+ * After the kernel has initiallized this module, it is still possible
+ * to make it passive.
+ * Setting passive to Y:
+ *  - the iface stats handling will not act on notifications.
+ *  - iptables matches will never match.
+ *  - ctrl commands silently succeed.
+ *  - stats are always empty.
+ * This is mostly usefull when a bug is suspected.
+ */
+static bool module_passive;
+module_param_named(passive, module_passive, bool, S_IRUGO | S_IWUSR);
+
+/*
+ * Control how qtaguid data is tracked per proc/uid.
+ * Setting tag_tracking_passive to Y:
+ *  - don't create proc specific structs to track tags
+ *  - don't check that active tag stats exceed some limits.
+ *  - don't clean up socket tags on process exits.
+ * This is mostly usefull when a bug is suspected.
+ */
+static bool qtu_proc_handling_passive;
+module_param_named(tag_tracking_passive, qtu_proc_handling_passive, bool,
+		   S_IRUGO | S_IWUSR);
+
+#define QTU_DEV_NAME "xt_qtaguid"
+
+uint qtaguid_debug_mask = DEFAULT_DEBUG_MASK;
+module_param_named(debug_mask, qtaguid_debug_mask, uint, S_IRUGO | S_IWUSR);
+
+/*---------------------------------------------------------------------------*/
+static const char *iface_stat_procdirname = "iface_stat";
+static struct proc_dir_entry *iface_stat_procdir;
+/*
+ * The iface_stat_all* will go away once userspace gets use to the new fields
+ * that have a format line.
+ */
+static const char *iface_stat_all_procfilename = "iface_stat_all";
+static struct proc_dir_entry *iface_stat_all_procfile;
+static const char *iface_stat_fmt_procfilename = "iface_stat_fmt";
+static struct proc_dir_entry *iface_stat_fmt_procfile;
+
+
+static LIST_HEAD(iface_stat_list);
+static DEFINE_SPINLOCK(iface_stat_list_lock);
+
+static struct rb_root sock_tag_tree = RB_ROOT;
+static DEFINE_SPINLOCK(sock_tag_list_lock);
+
+static struct rb_root tag_counter_set_tree = RB_ROOT;
+static DEFINE_SPINLOCK(tag_counter_set_list_lock);
+
+static struct rb_root uid_tag_data_tree = RB_ROOT;
+static DEFINE_SPINLOCK(uid_tag_data_tree_lock);
+
+static struct rb_root proc_qtu_data_tree = RB_ROOT;
+/* No proc_qtu_data_tree_lock; use uid_tag_data_tree_lock */
+
+static struct qtaguid_event_counts qtu_events;
+/*----------------------------------------------*/
+static bool can_manipulate_uids(void)
+{
+	/* root pwnd */
+	return in_egroup_p(xt_qtaguid_ctrl_file->gid)
+		|| unlikely(!from_kuid(&init_user_ns, current_fsuid())) || unlikely(!proc_ctrl_write_limited)
+		|| unlikely(uid_eq(current_fsuid(), xt_qtaguid_ctrl_file->uid));
+}
+
+static bool can_impersonate_uid(kuid_t uid)
+{
+	return uid_eq(uid, current_fsuid()) || can_manipulate_uids();
+}
+
+static bool can_read_other_uid_stats(kuid_t uid)
+{
+	/* root pwnd */
+	return in_egroup_p(xt_qtaguid_stats_file->gid)
+		|| unlikely(!from_kuid(&init_user_ns, current_fsuid())) || uid_eq(uid, current_fsuid())
+		|| unlikely(!proc_stats_readall_limited)
+		|| unlikely(uid_eq(current_fsuid(), xt_qtaguid_ctrl_file->uid));
+}
+
+static inline void dc_add_byte_packets(struct data_counters *counters, int set,
+				  enum ifs_tx_rx direction,
+				  enum ifs_proto ifs_proto,
+				  int bytes,
+				  int packets)
+{
+	counters->bpc[set][direction][ifs_proto].bytes += bytes;
+	counters->bpc[set][direction][ifs_proto].packets += packets;
+}
+
+static struct tag_node *tag_node_tree_search(struct rb_root *root, tag_t tag)
+{
+	struct rb_node *node = root->rb_node;
+
+	while (node) {
+		struct tag_node *data = rb_entry(node, struct tag_node, node);
+		int result;
+		RB_DEBUG("qtaguid: tag_node_tree_search(0x%llx): "
+			 " node=%p data=%p\n", tag, node, data);
+		result = tag_compare(tag, data->tag);
+		RB_DEBUG("qtaguid: tag_node_tree_search(0x%llx): "
+			 " data.tag=0x%llx (uid=%u) res=%d\n",
+			 tag, data->tag, get_uid_from_tag(data->tag), result);
+		if (result < 0)
+			node = node->rb_left;
+		else if (result > 0)
+			node = node->rb_right;
+		else
+			return data;
+	}
+	return NULL;
+}
+
+static void tag_node_tree_insert(struct tag_node *data, struct rb_root *root)
+{
+	struct rb_node **new = &(root->rb_node), *parent = NULL;
+
+	/* Figure out where to put new node */
+	while (*new) {
+		struct tag_node *this = rb_entry(*new, struct tag_node,
+						 node);
+		int result = tag_compare(data->tag, this->tag);
+		RB_DEBUG("qtaguid: %s(): tag=0x%llx"
+			 " (uid=%u)\n", __func__,
+			 this->tag,
+			 get_uid_from_tag(this->tag));
+		parent = *new;
+		if (result < 0)
+			new = &((*new)->rb_left);
+		else if (result > 0)
+			new = &((*new)->rb_right);
+		else
+			BUG();
+	}
+
+	/* Add new node and rebalance tree. */
+	rb_link_node(&data->node, parent, new);
+	rb_insert_color(&data->node, root);
+}
+
+static void tag_stat_tree_insert(struct tag_stat *data, struct rb_root *root)
+{
+	tag_node_tree_insert(&data->tn, root);
+}
+
+static struct tag_stat *tag_stat_tree_search(struct rb_root *root, tag_t tag)
+{
+	struct tag_node *node = tag_node_tree_search(root, tag);
+	if (!node)
+		return NULL;
+	return rb_entry(&node->node, struct tag_stat, tn.node);
+}
+
+static void tag_counter_set_tree_insert(struct tag_counter_set *data,
+					struct rb_root *root)
+{
+	tag_node_tree_insert(&data->tn, root);
+}
+
+static struct tag_counter_set *tag_counter_set_tree_search(struct rb_root *root,
+							   tag_t tag)
+{
+	struct tag_node *node = tag_node_tree_search(root, tag);
+	if (!node)
+		return NULL;
+	return rb_entry(&node->node, struct tag_counter_set, tn.node);
+
+}
+
+static void tag_ref_tree_insert(struct tag_ref *data, struct rb_root *root)
+{
+	tag_node_tree_insert(&data->tn, root);
+}
+
+static struct tag_ref *tag_ref_tree_search(struct rb_root *root, tag_t tag)
+{
+	struct tag_node *node = tag_node_tree_search(root, tag);
+	if (!node)
+		return NULL;
+	return rb_entry(&node->node, struct tag_ref, tn.node);
+}
+
+static struct sock_tag *sock_tag_tree_search(struct rb_root *root,
+					     const struct sock *sk)
+{
+	struct rb_node *node = root->rb_node;
+
+	while (node) {
+		struct sock_tag *data = rb_entry(node, struct sock_tag,
+						 sock_node);
+		if (sk < data->sk)
+			node = node->rb_left;
+		else if (sk > data->sk)
+			node = node->rb_right;
+		else
+			return data;
+	}
+	return NULL;
+}
+
+static void sock_tag_tree_insert(struct sock_tag *data, struct rb_root *root)
+{
+	struct rb_node **new = &(root->rb_node), *parent = NULL;
+
+	/* Figure out where to put new node */
+	while (*new) {
+		struct sock_tag *this = rb_entry(*new, struct sock_tag,
+						 sock_node);
+		parent = *new;
+		if (data->sk < this->sk)
+			new = &((*new)->rb_left);
+		else if (data->sk > this->sk)
+			new = &((*new)->rb_right);
+		else
+			BUG();
+	}
+
+	/* Add new node and rebalance tree. */
+	rb_link_node(&data->sock_node, parent, new);
+	rb_insert_color(&data->sock_node, root);
+}
+
+static void sock_tag_tree_erase(struct rb_root *st_to_free_tree)
+{
+	struct rb_node *node;
+	struct sock_tag *st_entry;
+
+	node = rb_first(st_to_free_tree);
+	while (node) {
+		st_entry = rb_entry(node, struct sock_tag, sock_node);
+		node = rb_next(node);
+		CT_DEBUG("qtaguid: %s(): "
+			 "erase st: sk=%p tag=0x%llx (uid=%u)\n", __func__,
+			 st_entry->sk,
+			 st_entry->tag,
+			 get_uid_from_tag(st_entry->tag));
+		rb_erase(&st_entry->sock_node, st_to_free_tree);
+		sock_put(st_entry->sk);
+		kfree(st_entry);
+	}
+}
+
+static struct proc_qtu_data *proc_qtu_data_tree_search(struct rb_root *root,
+						       const pid_t pid)
+{
+	struct rb_node *node = root->rb_node;
+
+	while (node) {
+		struct proc_qtu_data *data = rb_entry(node,
+						      struct proc_qtu_data,
+						      node);
+		if (pid < data->pid)
+			node = node->rb_left;
+		else if (pid > data->pid)
+			node = node->rb_right;
+		else
+			return data;
+	}
+	return NULL;
+}
+
+static void proc_qtu_data_tree_insert(struct proc_qtu_data *data,
+				      struct rb_root *root)
+{
+	struct rb_node **new = &(root->rb_node), *parent = NULL;
+
+	/* Figure out where to put new node */
+	while (*new) {
+		struct proc_qtu_data *this = rb_entry(*new,
+						      struct proc_qtu_data,
+						      node);
+		parent = *new;
+		if (data->pid < this->pid)
+			new = &((*new)->rb_left);
+		else if (data->pid > this->pid)
+			new = &((*new)->rb_right);
+		else
+			BUG();
+	}
+
+	/* Add new node and rebalance tree. */
+	rb_link_node(&data->node, parent, new);
+	rb_insert_color(&data->node, root);
+}
+
+static void uid_tag_data_tree_insert(struct uid_tag_data *data,
+				     struct rb_root *root)
+{
+	struct rb_node **new = &(root->rb_node), *parent = NULL;
+
+	/* Figure out where to put new node */
+	while (*new) {
+		struct uid_tag_data *this = rb_entry(*new,
+						     struct uid_tag_data,
+						     node);
+		parent = *new;
+		if (data->uid < this->uid)
+			new = &((*new)->rb_left);
+		else if (data->uid > this->uid)
+			new = &((*new)->rb_right);
+		else
+			BUG();
+	}
+
+	/* Add new node and rebalance tree. */
+	rb_link_node(&data->node, parent, new);
+	rb_insert_color(&data->node, root);
+}
+
+static struct uid_tag_data *uid_tag_data_tree_search(struct rb_root *root,
+						     uid_t uid)
+{
+	struct rb_node *node = root->rb_node;
+
+	while (node) {
+		struct uid_tag_data *data = rb_entry(node,
+						     struct uid_tag_data,
+						     node);
+		if (uid < data->uid)
+			node = node->rb_left;
+		else if (uid > data->uid)
+			node = node->rb_right;
+		else
+			return data;
+	}
+	return NULL;
+}
+
+/*
+ * Allocates a new uid_tag_data struct if needed.
+ * Returns a pointer to the found or allocated uid_tag_data.
+ * Returns a PTR_ERR on failures, and lock is not held.
+ * If found is not NULL:
+ *   sets *found to true if not allocated.
+ *   sets *found to false if allocated.
+ */
+struct uid_tag_data *get_uid_data(uid_t uid, bool *found_res)
+{
+	struct uid_tag_data *utd_entry;
+
+	/* Look for top level uid_tag_data for the UID */
+	utd_entry = uid_tag_data_tree_search(&uid_tag_data_tree, uid);
+	DR_DEBUG("qtaguid: get_uid_data(%u) utd=%p\n", uid, utd_entry);
+
+	if (found_res)
+		*found_res = utd_entry;
+	if (utd_entry)
+		return utd_entry;
+
+	utd_entry = kzalloc(sizeof(*utd_entry), GFP_ATOMIC);
+	if (!utd_entry) {
+		pr_err("qtaguid: get_uid_data(%u): "
+		       "tag data alloc failed\n", uid);
+		return ERR_PTR(-ENOMEM);
+	}
+
+	utd_entry->uid = uid;
+	utd_entry->tag_ref_tree = RB_ROOT;
+	uid_tag_data_tree_insert(utd_entry, &uid_tag_data_tree);
+	DR_DEBUG("qtaguid: get_uid_data(%u) new utd=%p\n", uid, utd_entry);
+	return utd_entry;
+}
+
+/* Never returns NULL. Either PTR_ERR or a valid ptr. */
+static struct tag_ref *new_tag_ref(tag_t new_tag,
+				   struct uid_tag_data *utd_entry)
+{
+	struct tag_ref *tr_entry;
+	int res;
+
+	if (utd_entry->num_active_tags + 1 > max_sock_tags) {
+		pr_info("qtaguid: new_tag_ref(0x%llx): "
+			"tag ref alloc quota exceeded. max=%d\n",
+			new_tag, max_sock_tags);
+		res = -EMFILE;
+		goto err_res;
+
+	}
+
+	tr_entry = kzalloc(sizeof(*tr_entry), GFP_ATOMIC);
+	if (!tr_entry) {
+		pr_err("qtaguid: new_tag_ref(0x%llx): "
+		       "tag ref alloc failed\n",
+		       new_tag);
+		res = -ENOMEM;
+		goto err_res;
+	}
+	tr_entry->tn.tag = new_tag;
+	/* tr_entry->num_sock_tags  handled by caller */
+	utd_entry->num_active_tags++;
+	tag_ref_tree_insert(tr_entry, &utd_entry->tag_ref_tree);
+	DR_DEBUG("qtaguid: new_tag_ref(0x%llx): "
+		 " inserted new tag ref %p\n",
+		 new_tag, tr_entry);
+	return tr_entry;
+
+err_res:
+	return ERR_PTR(res);
+}
+
+static struct tag_ref *lookup_tag_ref(tag_t full_tag,
+				      struct uid_tag_data **utd_res)
+{
+	struct uid_tag_data *utd_entry;
+	struct tag_ref *tr_entry;
+	bool found_utd;
+	uid_t uid = get_uid_from_tag(full_tag);
+
+	DR_DEBUG("qtaguid: lookup_tag_ref(tag=0x%llx (uid=%u))\n",
+		 full_tag, uid);
+
+	utd_entry = get_uid_data(uid, &found_utd);
+	if (IS_ERR_OR_NULL(utd_entry)) {
+		if (utd_res)
+			*utd_res = utd_entry;
+		return NULL;
+	}
+
+	tr_entry = tag_ref_tree_search(&utd_entry->tag_ref_tree, full_tag);
+	if (utd_res)
+		*utd_res = utd_entry;
+	DR_DEBUG("qtaguid: lookup_tag_ref(0x%llx) utd_entry=%p tr_entry=%p\n",
+		 full_tag, utd_entry, tr_entry);
+	return tr_entry;
+}
+
+/* Never returns NULL. Either PTR_ERR or a valid ptr. */
+static struct tag_ref *get_tag_ref(tag_t full_tag,
+				   struct uid_tag_data **utd_res)
+{
+	struct uid_tag_data *utd_entry;
+	struct tag_ref *tr_entry;
+
+	DR_DEBUG("qtaguid: get_tag_ref(0x%llx)\n",
+		 full_tag);
+	tr_entry = lookup_tag_ref(full_tag, &utd_entry);
+	BUG_ON(IS_ERR_OR_NULL(utd_entry));
+	if (!tr_entry)
+		tr_entry = new_tag_ref(full_tag, utd_entry);
+
+	if (utd_res)
+		*utd_res = utd_entry;
+	DR_DEBUG("qtaguid: get_tag_ref(0x%llx) utd=%p tr=%p\n",
+		 full_tag, utd_entry, tr_entry);
+	return tr_entry;
+}
+
+/* Checks and maybe frees the UID Tag Data entry */
+static void put_utd_entry(struct uid_tag_data *utd_entry)
+{
+	/* Are we done with the UID tag data entry? */
+	if (RB_EMPTY_ROOT(&utd_entry->tag_ref_tree) &&
+		!utd_entry->num_pqd) {
+		DR_DEBUG("qtaguid: %s(): "
+			 "erase utd_entry=%p uid=%u "
+			 "by pid=%u tgid=%u uid=%u\n", __func__,
+			 utd_entry, utd_entry->uid,
+			 current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()));
+		BUG_ON(utd_entry->num_active_tags);
+		rb_erase(&utd_entry->node, &uid_tag_data_tree);
+		kfree(utd_entry);
+	} else {
+		DR_DEBUG("qtaguid: %s(): "
+			 "utd_entry=%p still has %d tags %d proc_qtu_data\n",
+			 __func__, utd_entry, utd_entry->num_active_tags,
+			 utd_entry->num_pqd);
+		BUG_ON(!(utd_entry->num_active_tags ||
+			 utd_entry->num_pqd));
+	}
+}
+
+/*
+ * If no sock_tags are using this tag_ref,
+ * decrements refcount of utd_entry, removes tr_entry
+ * from utd_entry->tag_ref_tree and frees.
+ */
+static void free_tag_ref_from_utd_entry(struct tag_ref *tr_entry,
+					struct uid_tag_data *utd_entry)
+{
+	DR_DEBUG("qtaguid: %s(): %p tag=0x%llx (uid=%u)\n", __func__,
+		 tr_entry, tr_entry->tn.tag,
+		 get_uid_from_tag(tr_entry->tn.tag));
+	if (!tr_entry->num_sock_tags) {
+		BUG_ON(!utd_entry->num_active_tags);
+		utd_entry->num_active_tags--;
+		rb_erase(&tr_entry->tn.node, &utd_entry->tag_ref_tree);
+		DR_DEBUG("qtaguid: %s(): erased %p\n", __func__, tr_entry);
+		kfree(tr_entry);
+	}
+}
+
+static void put_tag_ref_tree(tag_t full_tag, struct uid_tag_data *utd_entry)
+{
+	struct rb_node *node;
+	struct tag_ref *tr_entry;
+	tag_t acct_tag;
+
+	DR_DEBUG("qtaguid: %s(tag=0x%llx (uid=%u))\n", __func__,
+		 full_tag, get_uid_from_tag(full_tag));
+	acct_tag = get_atag_from_tag(full_tag);
+	node = rb_first(&utd_entry->tag_ref_tree);
+	while (node) {
+		tr_entry = rb_entry(node, struct tag_ref, tn.node);
+		node = rb_next(node);
+		if (!acct_tag || tr_entry->tn.tag == full_tag)
+			free_tag_ref_from_utd_entry(tr_entry, utd_entry);
+	}
+}
+
+static ssize_t read_proc_u64(struct file *file, char __user *buf,
+			 size_t size, loff_t *ppos)
+{
+	uint64_t *valuep = PDE_DATA(file_inode(file));
+	char tmp[24];
+	size_t tmp_size;
+
+	tmp_size = scnprintf(tmp, sizeof(tmp), "%llu\n", *valuep);
+	return simple_read_from_buffer(buf, size, ppos, tmp, tmp_size);
+}
+
+static ssize_t read_proc_bool(struct file *file, char __user *buf,
+			  size_t size, loff_t *ppos)
+{
+	bool *valuep = PDE_DATA(file_inode(file));
+	char tmp[24];
+	size_t tmp_size;
+
+	tmp_size = scnprintf(tmp, sizeof(tmp), "%u\n", *valuep);
+	return simple_read_from_buffer(buf, size, ppos, tmp, tmp_size);
+}
+
+static int get_active_counter_set(tag_t tag)
+{
+	int active_set = 0;
+	struct tag_counter_set *tcs;
+
+	MT_DEBUG("qtaguid: get_active_counter_set(tag=0x%llx)"
+		 " (uid=%u)\n",
+		 tag, get_uid_from_tag(tag));
+	/* For now we only handle UID tags for active sets */
+	tag = get_utag_from_tag(tag);
+	spin_lock_bh(&tag_counter_set_list_lock);
+	tcs = tag_counter_set_tree_search(&tag_counter_set_tree, tag);
+	if (tcs)
+		active_set = tcs->active_set;
+	spin_unlock_bh(&tag_counter_set_list_lock);
+	return active_set;
+}
+
+/*
+ * Find the entry for tracking the specified interface.
+ * Caller must hold iface_stat_list_lock
+ */
+static struct iface_stat *get_iface_entry(const char *ifname)
+{
+	struct iface_stat *iface_entry;
+
+	/* Find the entry for tracking the specified tag within the interface */
+	if (ifname == NULL) {
+		pr_info("qtaguid: iface_stat: get() NULL device name\n");
+		return NULL;
+	}
+
+	/* Iterate over interfaces */
+	list_for_each_entry(iface_entry, &iface_stat_list, list) {
+		if (!strcmp(ifname, iface_entry->ifname))
+			goto done;
+	}
+	iface_entry = NULL;
+done:
+	return iface_entry;
+}
+
+/* This is for fmt2 only */
+static void pp_iface_stat_header(struct seq_file *m)
+{
+	seq_puts(m,
+		 "ifname "
+		 "total_skb_rx_bytes total_skb_rx_packets "
+		 "total_skb_tx_bytes total_skb_tx_packets "
+		 "rx_tcp_bytes rx_tcp_packets "
+		 "rx_udp_bytes rx_udp_packets "
+		 "rx_other_bytes rx_other_packets "
+		 "tx_tcp_bytes tx_tcp_packets "
+		 "tx_udp_bytes tx_udp_packets "
+		 "tx_other_bytes tx_other_packets\n"
+	);
+}
+
+static void pp_iface_stat_line(struct seq_file *m,
+			       struct iface_stat *iface_entry)
+{
+	struct data_counters *cnts;
+	int cnt_set = 0;   /* We only use one set for the device */
+	cnts = &iface_entry->totals_via_skb;
+	seq_printf(m, "%s %llu %llu %llu %llu %llu %llu %llu %llu "
+		   "%llu %llu %llu %llu %llu %llu %llu %llu\n",
+		   iface_entry->ifname,
+		   dc_sum_bytes(cnts, cnt_set, IFS_RX),
+		   dc_sum_packets(cnts, cnt_set, IFS_RX),
+		   dc_sum_bytes(cnts, cnt_set, IFS_TX),
+		   dc_sum_packets(cnts, cnt_set, IFS_TX),
+		   cnts->bpc[cnt_set][IFS_RX][IFS_TCP].bytes,
+		   cnts->bpc[cnt_set][IFS_RX][IFS_TCP].packets,
+		   cnts->bpc[cnt_set][IFS_RX][IFS_UDP].bytes,
+		   cnts->bpc[cnt_set][IFS_RX][IFS_UDP].packets,
+		   cnts->bpc[cnt_set][IFS_RX][IFS_PROTO_OTHER].bytes,
+		   cnts->bpc[cnt_set][IFS_RX][IFS_PROTO_OTHER].packets,
+		   cnts->bpc[cnt_set][IFS_TX][IFS_TCP].bytes,
+		   cnts->bpc[cnt_set][IFS_TX][IFS_TCP].packets,
+		   cnts->bpc[cnt_set][IFS_TX][IFS_UDP].bytes,
+		   cnts->bpc[cnt_set][IFS_TX][IFS_UDP].packets,
+		   cnts->bpc[cnt_set][IFS_TX][IFS_PROTO_OTHER].bytes,
+		   cnts->bpc[cnt_set][IFS_TX][IFS_PROTO_OTHER].packets);
+}
+
+struct proc_iface_stat_fmt_info {
+	int fmt;
+};
+
+static void *iface_stat_fmt_proc_start(struct seq_file *m, loff_t *pos)
+{
+	struct proc_iface_stat_fmt_info *p = m->private;
+	loff_t n = *pos;
+
+	/*
+	 * This lock will prevent iface_stat_update() from changing active,
+	 * and in turn prevent an interface from unregistering itself.
+	 */
+	spin_lock_bh(&iface_stat_list_lock);
+
+	if (unlikely(module_passive))
+		return NULL;
+
+	if (!n && p->fmt == 2)
+		pp_iface_stat_header(m);
+
+	return seq_list_start(&iface_stat_list, n);
+}
+
+static void *iface_stat_fmt_proc_next(struct seq_file *m, void *p, loff_t *pos)
+{
+	return seq_list_next(p, &iface_stat_list, pos);
+}
+
+static void iface_stat_fmt_proc_stop(struct seq_file *m, void *p)
+{
+	spin_unlock_bh(&iface_stat_list_lock);
+}
+
+static int iface_stat_fmt_proc_show(struct seq_file *m, void *v)
+{
+	struct proc_iface_stat_fmt_info *p = m->private;
+	struct iface_stat *iface_entry;
+	struct rtnl_link_stats64 dev_stats, *stats;
+	struct rtnl_link_stats64 no_dev_stats = {0};
+
+
+	CT_DEBUG("qtaguid:proc iface_stat_fmt pid=%u tgid=%u uid=%u\n",
+		 current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()));
+
+	iface_entry = list_entry(v, struct iface_stat, list);
+
+	if (iface_entry->active) {
+		stats = dev_get_stats(iface_entry->net_dev,
+				      &dev_stats);
+	} else {
+		stats = &no_dev_stats;
+	}
+	/*
+	 * If the meaning of the data changes, then update the fmtX
+	 * string.
+	 */
+	if (p->fmt == 1) {
+		seq_printf(m, "%s %d %llu %llu %llu %llu %llu %llu %llu %llu\n",
+			   iface_entry->ifname,
+			   iface_entry->active,
+			   iface_entry->totals_via_dev[IFS_RX].bytes,
+			   iface_entry->totals_via_dev[IFS_RX].packets,
+			   iface_entry->totals_via_dev[IFS_TX].bytes,
+			   iface_entry->totals_via_dev[IFS_TX].packets,
+			   stats->rx_bytes, stats->rx_packets,
+			   stats->tx_bytes, stats->tx_packets
+			   );
+	} else {
+		pp_iface_stat_line(m, iface_entry);
+	}
+	return 0;
+}
+
+static const struct file_operations read_u64_fops = {
+	.read		= read_proc_u64,
+	.llseek		= default_llseek,
+};
+
+static const struct file_operations read_bool_fops = {
+	.read		= read_proc_bool,
+	.llseek		= default_llseek,
+};
+
+static void iface_create_proc_worker(struct work_struct *work)
+{
+	struct proc_dir_entry *proc_entry;
+	struct iface_stat_work *isw = container_of(work, struct iface_stat_work,
+						   iface_work);
+	struct iface_stat *new_iface  = isw->iface_entry;
+
+	/* iface_entries are not deleted, so safe to manipulate. */
+	proc_entry = proc_mkdir(new_iface->ifname, iface_stat_procdir);
+	if (IS_ERR_OR_NULL(proc_entry)) {
+		pr_err("qtaguid: iface_stat: create_proc(): alloc failed.\n");
+		kfree(isw);
+		return;
+	}
+
+	new_iface->proc_ptr = proc_entry;
+
+	proc_create_data("tx_bytes", proc_iface_perms, proc_entry,
+			 &read_u64_fops,
+			 &new_iface->totals_via_dev[IFS_TX].bytes);
+	proc_create_data("rx_bytes", proc_iface_perms, proc_entry,
+			 &read_u64_fops,
+			 &new_iface->totals_via_dev[IFS_RX].bytes);
+	proc_create_data("tx_packets", proc_iface_perms, proc_entry,
+			 &read_u64_fops,
+			 &new_iface->totals_via_dev[IFS_TX].packets);
+	proc_create_data("rx_packets", proc_iface_perms, proc_entry,
+			 &read_u64_fops,
+			 &new_iface->totals_via_dev[IFS_RX].packets);
+	proc_create_data("active", proc_iface_perms, proc_entry,
+			 &read_bool_fops, &new_iface->active);
+
+	IF_DEBUG("qtaguid: iface_stat: create_proc(): done "
+		 "entry=%p dev=%s\n", new_iface, new_iface->ifname);
+	kfree(isw);
+}
+
+/*
+ * Will set the entry's active state, and
+ * update the net_dev accordingly also.
+ */
+static void _iface_stat_set_active(struct iface_stat *entry,
+				   struct net_device *net_dev,
+				   bool activate)
+{
+	if (activate) {
+		entry->net_dev = net_dev;
+		entry->active = true;
+		IF_DEBUG("qtaguid: %s(%s): "
+			 "enable tracking. rfcnt=%d\n", __func__,
+			 entry->ifname,
+			 __this_cpu_read(*net_dev->pcpu_refcnt));
+	} else {
+		entry->active = false;
+		entry->net_dev = NULL;
+		IF_DEBUG("qtaguid: %s(%s): "
+			 "disable tracking. rfcnt=%d\n", __func__,
+			 entry->ifname,
+			 __this_cpu_read(*net_dev->pcpu_refcnt));
+
+	}
+}
+
+/* Caller must hold iface_stat_list_lock */
+static struct iface_stat *iface_alloc(struct net_device *net_dev)
+{
+	struct iface_stat *new_iface;
+	struct iface_stat_work *isw;
+
+	new_iface = kzalloc(sizeof(*new_iface), GFP_ATOMIC);
+	if (new_iface == NULL) {
+		pr_err("qtaguid: iface_stat: create(%s): "
+		       "iface_stat alloc failed\n", net_dev->name);
+		return NULL;
+	}
+	new_iface->ifname = kstrdup(net_dev->name, GFP_ATOMIC);
+	if (new_iface->ifname == NULL) {
+		pr_err("qtaguid: iface_stat: create(%s): "
+		       "ifname alloc failed\n", net_dev->name);
+		kfree(new_iface);
+		return NULL;
+	}
+	spin_lock_init(&new_iface->tag_stat_list_lock);
+	new_iface->tag_stat_tree = RB_ROOT;
+	_iface_stat_set_active(new_iface, net_dev, true);
+
+	/*
+	 * ipv6 notifier chains are atomic :(
+	 * No create_proc_read_entry() for you!
+	 */
+	isw = kmalloc(sizeof(*isw), GFP_ATOMIC);
+	if (!isw) {
+		pr_err("qtaguid: iface_stat: create(%s): "
+		       "work alloc failed\n", new_iface->ifname);
+		_iface_stat_set_active(new_iface, net_dev, false);
+		kfree(new_iface->ifname);
+		kfree(new_iface);
+		return NULL;
+	}
+	isw->iface_entry = new_iface;
+	INIT_WORK(&isw->iface_work, iface_create_proc_worker);
+	schedule_work(&isw->iface_work);
+	list_add(&new_iface->list, &iface_stat_list);
+	return new_iface;
+}
+
+static void iface_check_stats_reset_and_adjust(struct net_device *net_dev,
+					       struct iface_stat *iface)
+{
+	struct rtnl_link_stats64 dev_stats, *stats;
+	bool stats_rewound;
+
+	stats = dev_get_stats(net_dev, &dev_stats);
+	/* No empty packets */
+	stats_rewound =
+		(stats->rx_bytes < iface->last_known[IFS_RX].bytes)
+		|| (stats->tx_bytes < iface->last_known[IFS_TX].bytes);
+
+	IF_DEBUG("qtaguid: %s(%s): iface=%p netdev=%p "
+		 "bytes rx/tx=%llu/%llu "
+		 "active=%d last_known=%d "
+		 "stats_rewound=%d\n", __func__,
+		 net_dev ? net_dev->name : "?",
+		 iface, net_dev,
+		 stats->rx_bytes, stats->tx_bytes,
+		 iface->active, iface->last_known_valid, stats_rewound);
+
+	if (iface->active && iface->last_known_valid && stats_rewound) {
+		pr_warn_once("qtaguid: iface_stat: %s(%s): "
+			     "iface reset its stats unexpectedly\n", __func__,
+			     net_dev->name);
+
+		iface->totals_via_dev[IFS_TX].bytes +=
+			iface->last_known[IFS_TX].bytes;
+		iface->totals_via_dev[IFS_TX].packets +=
+			iface->last_known[IFS_TX].packets;
+		iface->totals_via_dev[IFS_RX].bytes +=
+			iface->last_known[IFS_RX].bytes;
+		iface->totals_via_dev[IFS_RX].packets +=
+			iface->last_known[IFS_RX].packets;
+		iface->last_known_valid = false;
+		IF_DEBUG("qtaguid: %s(%s): iface=%p "
+			 "used last known bytes rx/tx=%llu/%llu\n", __func__,
+			 iface->ifname, iface, iface->last_known[IFS_RX].bytes,
+			 iface->last_known[IFS_TX].bytes);
+	}
+}
+
+/*
+ * Create a new entry for tracking the specified interface.
+ * Do nothing if the entry already exists.
+ * Called when an interface is configured with a valid IP address.
+ */
+static void iface_stat_create(struct net_device *net_dev,
+			      struct in_ifaddr *ifa)
+{
+	struct in_device *in_dev = NULL;
+	const char *ifname;
+	struct iface_stat *entry;
+	__be32 ipaddr = 0;
+	struct iface_stat *new_iface;
+
+	IF_DEBUG("qtaguid: iface_stat: create(%s): ifa=%p netdev=%p\n",
+		 net_dev ? net_dev->name : "?",
+		 ifa, net_dev);
+	if (!net_dev) {
+		pr_err("qtaguid: iface_stat: create(): no net dev\n");
+		return;
+	}
+
+	ifname = net_dev->name;
+	if (!ifa) {
+		in_dev = in_dev_get(net_dev);
+		if (!in_dev) {
+			pr_err("qtaguid: iface_stat: create(%s): no inet dev\n",
+			       ifname);
+			return;
+		}
+		IF_DEBUG("qtaguid: iface_stat: create(%s): in_dev=%p\n",
+			 ifname, in_dev);
+		for (ifa = in_dev->ifa_list; ifa; ifa = ifa->ifa_next) {
+			IF_DEBUG("qtaguid: iface_stat: create(%s): "
+				 "ifa=%p ifa_label=%s\n",
+				 ifname, ifa, ifa->ifa_label);
+			if (!strcmp(ifname, ifa->ifa_label))
+				break;
+		}
+	}
+
+	if (!ifa) {
+		IF_DEBUG("qtaguid: iface_stat: create(%s): no matching IP\n",
+			 ifname);
+		goto done_put;
+	}
+	ipaddr = ifa->ifa_local;
+
+	spin_lock_bh(&iface_stat_list_lock);
+	entry = get_iface_entry(ifname);
+	if (entry != NULL) {
+		IF_DEBUG("qtaguid: iface_stat: create(%s): entry=%p\n",
+			 ifname, entry);
+		iface_check_stats_reset_and_adjust(net_dev, entry);
+		_iface_stat_set_active(entry, net_dev, true);
+		IF_DEBUG("qtaguid: %s(%s): "
+			 "tracking now %d on ip=%pI4\n", __func__,
+			 entry->ifname, true, &ipaddr);
+		goto done_unlock_put;
+	}
+
+	new_iface = iface_alloc(net_dev);
+	IF_DEBUG("qtaguid: iface_stat: create(%s): done "
+		 "entry=%p ip=%pI4\n", ifname, new_iface, &ipaddr);
+done_unlock_put:
+	spin_unlock_bh(&iface_stat_list_lock);
+done_put:
+	if (in_dev)
+		in_dev_put(in_dev);
+}
+
+static void iface_stat_create_ipv6(struct net_device *net_dev,
+				   struct inet6_ifaddr *ifa)
+{
+	struct in_device *in_dev;
+	const char *ifname;
+	struct iface_stat *entry;
+	struct iface_stat *new_iface;
+	int addr_type;
+
+	IF_DEBUG("qtaguid: iface_stat: create6(): ifa=%p netdev=%p->name=%s\n",
+		 ifa, net_dev, net_dev ? net_dev->name : "");
+	if (!net_dev) {
+		pr_err("qtaguid: iface_stat: create6(): no net dev!\n");
+		return;
+	}
+	ifname = net_dev->name;
+
+	in_dev = in_dev_get(net_dev);
+	if (!in_dev) {
+		pr_err("qtaguid: iface_stat: create6(%s): no inet dev\n",
+		       ifname);
+		return;
+	}
+
+	IF_DEBUG("qtaguid: iface_stat: create6(%s): in_dev=%p\n",
+		 ifname, in_dev);
+
+	if (!ifa) {
+		IF_DEBUG("qtaguid: iface_stat: create6(%s): no matching IP\n",
+			 ifname);
+		goto done_put;
+	}
+	addr_type = ipv6_addr_type(&ifa->addr);
+
+	spin_lock_bh(&iface_stat_list_lock);
+	entry = get_iface_entry(ifname);
+	if (entry != NULL) {
+		IF_DEBUG("qtaguid: %s(%s): entry=%p\n", __func__,
+			 ifname, entry);
+		iface_check_stats_reset_and_adjust(net_dev, entry);
+		_iface_stat_set_active(entry, net_dev, true);
+		IF_DEBUG("qtaguid: %s(%s): "
+			 "tracking now %d on ip=%pI6c\n", __func__,
+			 entry->ifname, true, &ifa->addr);
+		goto done_unlock_put;
+	}
+
+	new_iface = iface_alloc(net_dev);
+	IF_DEBUG("qtaguid: iface_stat: create6(%s): done "
+		 "entry=%p ip=%pI6c\n", ifname, new_iface, &ifa->addr);
+
+done_unlock_put:
+	spin_unlock_bh(&iface_stat_list_lock);
+done_put:
+	in_dev_put(in_dev);
+}
+
+static struct sock_tag *get_sock_stat_nl(const struct sock *sk)
+{
+	MT_DEBUG("qtaguid: get_sock_stat_nl(sk=%p)\n", sk);
+	return sock_tag_tree_search(&sock_tag_tree, sk);
+}
+
+static struct sock_tag *get_sock_stat(const struct sock *sk)
+{
+	struct sock_tag *sock_tag_entry;
+	MT_DEBUG("qtaguid: get_sock_stat(sk=%p)\n", sk);
+	if (!sk)
+		return NULL;
+	spin_lock_bh(&sock_tag_list_lock);
+	sock_tag_entry = get_sock_stat_nl(sk);
+	spin_unlock_bh(&sock_tag_list_lock);
+	return sock_tag_entry;
+}
+
+static int ipx_proto(const struct sk_buff *skb,
+		     struct xt_action_param *par)
+{
+	int thoff = 0, tproto;
+
+	switch (par->family) {
+	case NFPROTO_IPV6:
+		tproto = ipv6_find_hdr(skb, &thoff, -1, NULL, NULL);
+		if (tproto < 0)
+			MT_DEBUG("%s(): transport header not found in ipv6"
+				 " skb=%p\n", __func__, skb);
+		break;
+	case NFPROTO_IPV4:
+		tproto = ip_hdr(skb)->protocol;
+		break;
+	default:
+		tproto = IPPROTO_RAW;
+	}
+	return tproto;
+}
+
+static void
+data_counters_update(struct data_counters *dc, int set,
+		     enum ifs_tx_rx direction, int proto, int bytes)
+{
+	switch (proto) {
+	case IPPROTO_TCP:
+		dc_add_byte_packets(dc, set, direction, IFS_TCP, bytes, 1);
+		break;
+	case IPPROTO_UDP:
+		dc_add_byte_packets(dc, set, direction, IFS_UDP, bytes, 1);
+		break;
+	case IPPROTO_IP:
+	default:
+		dc_add_byte_packets(dc, set, direction, IFS_PROTO_OTHER, bytes,
+				    1);
+		break;
+	}
+}
+
+/*
+ * Update stats for the specified interface. Do nothing if the entry
+ * does not exist (when a device was never configured with an IP address).
+ * Called when an device is being unregistered.
+ */
+static void iface_stat_update(struct net_device *net_dev, bool stash_only)
+{
+	struct rtnl_link_stats64 dev_stats, *stats;
+	struct iface_stat *entry;
+
+	stats = dev_get_stats(net_dev, &dev_stats);
+	spin_lock_bh(&iface_stat_list_lock);
+	entry = get_iface_entry(net_dev->name);
+	if (entry == NULL) {
+		IF_DEBUG("qtaguid: iface_stat: update(%s): not tracked\n",
+			 net_dev->name);
+		spin_unlock_bh(&iface_stat_list_lock);
+		return;
+	}
+
+	IF_DEBUG("qtaguid: %s(%s): entry=%p\n", __func__,
+		 net_dev->name, entry);
+	if (!entry->active) {
+		IF_DEBUG("qtaguid: %s(%s): already disabled\n", __func__,
+			 net_dev->name);
+		spin_unlock_bh(&iface_stat_list_lock);
+		return;
+	}
+
+	if (stash_only) {
+		entry->last_known[IFS_TX].bytes = stats->tx_bytes;
+		entry->last_known[IFS_TX].packets = stats->tx_packets;
+		entry->last_known[IFS_RX].bytes = stats->rx_bytes;
+		entry->last_known[IFS_RX].packets = stats->rx_packets;
+		entry->last_known_valid = true;
+		IF_DEBUG("qtaguid: %s(%s): "
+			 "dev stats stashed rx/tx=%llu/%llu\n", __func__,
+			 net_dev->name, stats->rx_bytes, stats->tx_bytes);
+		spin_unlock_bh(&iface_stat_list_lock);
+		return;
+	}
+	entry->totals_via_dev[IFS_TX].bytes += stats->tx_bytes;
+	entry->totals_via_dev[IFS_TX].packets += stats->tx_packets;
+	entry->totals_via_dev[IFS_RX].bytes += stats->rx_bytes;
+	entry->totals_via_dev[IFS_RX].packets += stats->rx_packets;
+	/* We don't need the last_known[] anymore */
+	entry->last_known_valid = false;
+	_iface_stat_set_active(entry, net_dev, false);
+	IF_DEBUG("qtaguid: %s(%s): "
+		 "disable tracking. rx/tx=%llu/%llu\n", __func__,
+		 net_dev->name, stats->rx_bytes, stats->tx_bytes);
+	spin_unlock_bh(&iface_stat_list_lock);
+}
+
+/* Guarantied to return a net_device that has a name */
+static void get_dev_and_dir(const struct sk_buff *skb,
+			    struct xt_action_param *par,
+			    enum ifs_tx_rx *direction,
+			    const struct net_device **el_dev)
+{
+	BUG_ON(!direction || !el_dev);
+
+	if (par->in) {
+		*el_dev = par->in;
+		*direction = IFS_RX;
+	} else if (par->out) {
+		*el_dev = par->out;
+		*direction = IFS_TX;
+	} else {
+		pr_err("qtaguid[%d]: %s(): no par->in/out?!!\n",
+		       par->hooknum, __func__);
+		BUG();
+	}
+	if (skb->dev && *el_dev != skb->dev) {
+		MT_DEBUG("qtaguid[%d]: skb->dev=%p %s vs par->%s=%p %s\n",
+			 par->hooknum, skb->dev, skb->dev->name,
+			 *direction == IFS_RX ? "in" : "out",  *el_dev,
+			 (*el_dev)->name);
+	}
+}
+
+/*
+ * Update stats for the specified interface from the skb.
+ * Do nothing if the entry
+ * does not exist (when a device was never configured with an IP address).
+ * Called on each sk.
+ */
+static void iface_stat_update_from_skb(const struct sk_buff *skb,
+				       struct xt_action_param *par)
+{
+	struct iface_stat *entry;
+	const struct net_device *el_dev;
+	enum ifs_tx_rx direction;
+	int bytes = skb->len;
+	int proto;
+
+	get_dev_and_dir(skb, par, &direction, &el_dev);
+	proto = ipx_proto(skb, par);
+	MT_DEBUG("qtaguid[%d]: iface_stat: %s(%s): "
+		 "type=%d fam=%d proto=%d dir=%d\n",
+		 par->hooknum, __func__, el_dev->name, el_dev->type,
+		 par->family, proto, direction);
+
+	spin_lock_bh(&iface_stat_list_lock);
+	entry = get_iface_entry(el_dev->name);
+	if (entry == NULL) {
+		IF_DEBUG("qtaguid[%d]: iface_stat: %s(%s): not tracked\n",
+			 par->hooknum, __func__, el_dev->name);
+		spin_unlock_bh(&iface_stat_list_lock);
+		return;
+	}
+
+	IF_DEBUG("qtaguid[%d]: %s(%s): entry=%p\n", par->hooknum,  __func__,
+		 el_dev->name, entry);
+
+	data_counters_update(&entry->totals_via_skb, 0, direction, proto,
+			     bytes);
+	spin_unlock_bh(&iface_stat_list_lock);
+}
+
+static void tag_stat_update(struct tag_stat *tag_entry,
+			enum ifs_tx_rx direction, int proto, int bytes)
+{
+	int active_set;
+	active_set = get_active_counter_set(tag_entry->tn.tag);
+	MT_DEBUG("qtaguid: tag_stat_update(tag=0x%llx (uid=%u) set=%d "
+		 "dir=%d proto=%d bytes=%d)\n",
+		 tag_entry->tn.tag, get_uid_from_tag(tag_entry->tn.tag),
+		 active_set, direction, proto, bytes);
+	data_counters_update(&tag_entry->counters, active_set, direction,
+			     proto, bytes);
+	if (tag_entry->parent_counters)
+		data_counters_update(tag_entry->parent_counters, active_set,
+				     direction, proto, bytes);
+}
+
+/*
+ * Create a new entry for tracking the specified {acct_tag,uid_tag} within
+ * the interface.
+ * iface_entry->tag_stat_list_lock should be held.
+ */
+static struct tag_stat *create_if_tag_stat(struct iface_stat *iface_entry,
+					   tag_t tag)
+{
+	struct tag_stat *new_tag_stat_entry = NULL;
+	IF_DEBUG("qtaguid: iface_stat: %s(): ife=%p tag=0x%llx"
+		 " (uid=%u)\n", __func__,
+		 iface_entry, tag, get_uid_from_tag(tag));
+	new_tag_stat_entry = kzalloc(sizeof(*new_tag_stat_entry), GFP_ATOMIC);
+	if (!new_tag_stat_entry) {
+		pr_err("qtaguid: iface_stat: tag stat alloc failed\n");
+		goto done;
+	}
+	new_tag_stat_entry->tn.tag = tag;
+	tag_stat_tree_insert(new_tag_stat_entry, &iface_entry->tag_stat_tree);
+done:
+	return new_tag_stat_entry;
+}
+
+static void if_tag_stat_update(const char *ifname, uid_t uid,
+			       const struct sock *sk, enum ifs_tx_rx direction,
+			       int proto, int bytes)
+{
+	struct tag_stat *tag_stat_entry;
+	tag_t tag, acct_tag;
+	tag_t uid_tag;
+	struct data_counters *uid_tag_counters;
+	struct sock_tag *sock_tag_entry;
+	struct iface_stat *iface_entry;
+	struct tag_stat *new_tag_stat = NULL;
+	MT_DEBUG("qtaguid: if_tag_stat_update(ifname=%s "
+		"uid=%u sk=%p dir=%d proto=%d bytes=%d)\n",
+		 ifname, uid, sk, direction, proto, bytes);
+
+	spin_lock_bh(&iface_stat_list_lock);
+	iface_entry = get_iface_entry(ifname);
+	if (!iface_entry) {
+		pr_err_ratelimited("qtaguid: tag_stat: stat_update() "
+				   "%s not found\n", ifname);
+		spin_unlock_bh(&iface_stat_list_lock);
+		return;
+	}
+	/* It is ok to process data when an iface_entry is inactive */
+
+	MT_DEBUG("qtaguid: tag_stat: stat_update() dev=%s entry=%p\n",
+		 ifname, iface_entry);
+
+	/*
+	 * Look for a tagged sock.
+	 * It will have an acct_uid.
+	 */
+	sock_tag_entry = get_sock_stat(sk);
+	if (sock_tag_entry) {
+		tag = sock_tag_entry->tag;
+		acct_tag = get_atag_from_tag(tag);
+		uid_tag = get_utag_from_tag(tag);
+	} else {
+		acct_tag = make_atag_from_value(0);
+		tag = combine_atag_with_uid(acct_tag, uid);
+		uid_tag = make_tag_from_uid(uid);
+	}
+	MT_DEBUG("qtaguid: tag_stat: stat_update(): "
+		 " looking for tag=0x%llx (uid=%u) in ife=%p\n",
+		 tag, get_uid_from_tag(tag), iface_entry);
+	/* Loop over tag list under this interface for {acct_tag,uid_tag} */
+	spin_lock_bh(&iface_entry->tag_stat_list_lock);
+
+	tag_stat_entry = tag_stat_tree_search(&iface_entry->tag_stat_tree,
+					      tag);
+	if (tag_stat_entry) {
+		/*
+		 * Updating the {acct_tag, uid_tag} entry handles both stats:
+		 * {0, uid_tag} will also get updated.
+		 */
+		tag_stat_update(tag_stat_entry, direction, proto, bytes);
+		goto unlock;
+	}
+
+	/* Loop over tag list under this interface for {0,uid_tag} */
+	tag_stat_entry = tag_stat_tree_search(&iface_entry->tag_stat_tree,
+					      uid_tag);
+	if (!tag_stat_entry) {
+		/* Here: the base uid_tag did not exist */
+		/*
+		 * No parent counters. So
+		 *  - No {0, uid_tag} stats and no {acc_tag, uid_tag} stats.
+		 */
+		new_tag_stat = create_if_tag_stat(iface_entry, uid_tag);
+		if (!new_tag_stat)
+			goto unlock;
+		uid_tag_counters = &new_tag_stat->counters;
+	} else {
+		uid_tag_counters = &tag_stat_entry->counters;
+	}
+
+	if (acct_tag) {
+		/* Create the child {acct_tag, uid_tag} and hook up parent. */
+		new_tag_stat = create_if_tag_stat(iface_entry, tag);
+		if (!new_tag_stat)
+			goto unlock;
+		new_tag_stat->parent_counters = uid_tag_counters;
+	} else {
+		/*
+		 * For new_tag_stat to be still NULL here would require:
+		 *  {0, uid_tag} exists
+		 *  and {acct_tag, uid_tag} doesn't exist
+		 *  AND acct_tag == 0.
+		 * Impossible. This reassures us that new_tag_stat
+		 * below will always be assigned.
+		 */
+		BUG_ON(!new_tag_stat);
+	}
+	tag_stat_update(new_tag_stat, direction, proto, bytes);
+unlock:
+	spin_unlock_bh(&iface_entry->tag_stat_list_lock);
+	spin_unlock_bh(&iface_stat_list_lock);
+}
+
+static int iface_netdev_event_handler(struct notifier_block *nb,
+				      unsigned long event, void *ptr) {
+	struct net_device *dev = netdev_notifier_info_to_dev(ptr);
+
+	if (unlikely(module_passive))
+		return NOTIFY_DONE;
+
+	IF_DEBUG("qtaguid: iface_stat: netdev_event(): "
+		 "ev=0x%lx/%s netdev=%p->name=%s\n",
+		 event, netdev_evt_str(event), dev, dev ? dev->name : "");
+
+	switch (event) {
+	case NETDEV_UP:
+		iface_stat_create(dev, NULL);
+		atomic64_inc(&qtu_events.iface_events);
+		break;
+	case NETDEV_DOWN:
+	case NETDEV_UNREGISTER:
+		iface_stat_update(dev, event == NETDEV_DOWN);
+		atomic64_inc(&qtu_events.iface_events);
+		break;
+	}
+	return NOTIFY_DONE;
+}
+
+static int iface_inet6addr_event_handler(struct notifier_block *nb,
+					 unsigned long event, void *ptr)
+{
+	struct inet6_ifaddr *ifa = ptr;
+	struct net_device *dev;
+
+	if (unlikely(module_passive))
+		return NOTIFY_DONE;
+
+	IF_DEBUG("qtaguid: iface_stat: inet6addr_event(): "
+		 "ev=0x%lx/%s ifa=%p\n",
+		 event, netdev_evt_str(event), ifa);
+
+	switch (event) {
+	case NETDEV_UP:
+		BUG_ON(!ifa || !ifa->idev);
+		dev = (struct net_device *)ifa->idev->dev;
+		iface_stat_create_ipv6(dev, ifa);
+		atomic64_inc(&qtu_events.iface_events);
+		break;
+	case NETDEV_DOWN:
+	case NETDEV_UNREGISTER:
+		BUG_ON(!ifa || !ifa->idev);
+		dev = (struct net_device *)ifa->idev->dev;
+		iface_stat_update(dev, event == NETDEV_DOWN);
+		atomic64_inc(&qtu_events.iface_events);
+		break;
+	}
+	return NOTIFY_DONE;
+}
+
+static int iface_inetaddr_event_handler(struct notifier_block *nb,
+					unsigned long event, void *ptr)
+{
+	struct in_ifaddr *ifa = ptr;
+	struct net_device *dev;
+
+	if (unlikely(module_passive))
+		return NOTIFY_DONE;
+
+	IF_DEBUG("qtaguid: iface_stat: inetaddr_event(): "
+		 "ev=0x%lx/%s ifa=%p\n",
+		 event, netdev_evt_str(event), ifa);
+
+	switch (event) {
+	case NETDEV_UP:
+		BUG_ON(!ifa || !ifa->ifa_dev);
+		dev = ifa->ifa_dev->dev;
+		iface_stat_create(dev, ifa);
+		atomic64_inc(&qtu_events.iface_events);
+		break;
+	case NETDEV_DOWN:
+	case NETDEV_UNREGISTER:
+		BUG_ON(!ifa || !ifa->ifa_dev);
+		dev = ifa->ifa_dev->dev;
+		iface_stat_update(dev, event == NETDEV_DOWN);
+		atomic64_inc(&qtu_events.iface_events);
+		break;
+	}
+	return NOTIFY_DONE;
+}
+
+static struct notifier_block iface_netdev_notifier_blk = {
+	.notifier_call = iface_netdev_event_handler,
+};
+
+static struct notifier_block iface_inetaddr_notifier_blk = {
+	.notifier_call = iface_inetaddr_event_handler,
+};
+
+static struct notifier_block iface_inet6addr_notifier_blk = {
+	.notifier_call = iface_inet6addr_event_handler,
+};
+
+static const struct seq_operations iface_stat_fmt_proc_seq_ops = {
+	.start	= iface_stat_fmt_proc_start,
+	.next	= iface_stat_fmt_proc_next,
+	.stop	= iface_stat_fmt_proc_stop,
+	.show	= iface_stat_fmt_proc_show,
+};
+
+static int proc_iface_stat_fmt_open(struct inode *inode, struct file *file)
+{
+	struct proc_iface_stat_fmt_info *s;
+
+	s = __seq_open_private(file, &iface_stat_fmt_proc_seq_ops,
+			sizeof(struct proc_iface_stat_fmt_info));
+	if (!s)
+		return -ENOMEM;
+
+	s->fmt = (uintptr_t)PDE_DATA(inode);
+	return 0;
+}
+
+static const struct file_operations proc_iface_stat_fmt_fops = {
+	.open		= proc_iface_stat_fmt_open,
+	.read		= seq_read,
+	.llseek		= seq_lseek,
+	.release	= seq_release_private,
+};
+
+static int __init iface_stat_init(struct proc_dir_entry *parent_procdir)
+{
+	int err;
+
+	iface_stat_procdir = proc_mkdir(iface_stat_procdirname, parent_procdir);
+	if (!iface_stat_procdir) {
+		pr_err("qtaguid: iface_stat: init failed to create proc entry\n");
+		err = -1;
+		goto err;
+	}
+
+	iface_stat_all_procfile = proc_create_data(iface_stat_all_procfilename,
+						   proc_iface_perms,
+						   parent_procdir,
+						   &proc_iface_stat_fmt_fops,
+						   (void *)1 /* fmt1 */);
+	if (!iface_stat_all_procfile) {
+		pr_err("qtaguid: iface_stat: init "
+		       " failed to create stat_old proc entry\n");
+		err = -1;
+		goto err_zap_entry;
+	}
+
+	iface_stat_fmt_procfile = proc_create_data(iface_stat_fmt_procfilename,
+						   proc_iface_perms,
+						   parent_procdir,
+						   &proc_iface_stat_fmt_fops,
+						   (void *)2 /* fmt2 */);
+	if (!iface_stat_fmt_procfile) {
+		pr_err("qtaguid: iface_stat: init "
+		       " failed to create stat_all proc entry\n");
+		err = -1;
+		goto err_zap_all_stats_entry;
+	}
+
+
+	err = register_netdevice_notifier(&iface_netdev_notifier_blk);
+	if (err) {
+		pr_err("qtaguid: iface_stat: init "
+		       "failed to register dev event handler\n");
+		goto err_zap_all_stats_entries;
+	}
+	err = register_inetaddr_notifier(&iface_inetaddr_notifier_blk);
+	if (err) {
+		pr_err("qtaguid: iface_stat: init "
+		       "failed to register ipv4 dev event handler\n");
+		goto err_unreg_nd;
+	}
+
+	err = register_inet6addr_notifier(&iface_inet6addr_notifier_blk);
+	if (err) {
+		pr_err("qtaguid: iface_stat: init "
+		       "failed to register ipv6 dev event handler\n");
+		goto err_unreg_ip4_addr;
+	}
+	return 0;
+
+err_unreg_ip4_addr:
+	unregister_inetaddr_notifier(&iface_inetaddr_notifier_blk);
+err_unreg_nd:
+	unregister_netdevice_notifier(&iface_netdev_notifier_blk);
+err_zap_all_stats_entries:
+	remove_proc_entry(iface_stat_fmt_procfilename, parent_procdir);
+err_zap_all_stats_entry:
+	remove_proc_entry(iface_stat_all_procfilename, parent_procdir);
+err_zap_entry:
+	remove_proc_entry(iface_stat_procdirname, parent_procdir);
+err:
+	return err;
+}
+
+static struct sock *qtaguid_find_sk(const struct sk_buff *skb,
+				    struct xt_action_param *par)
+{
+	struct sock *sk;
+	unsigned int hook_mask = (1 << par->hooknum);
+
+	MT_DEBUG("qtaguid[%d]: find_sk(skb=%p) family=%d\n",
+		 par->hooknum, skb, par->family);
+
+	/*
+	 * Let's not abuse the the xt_socket_get*_sk(), or else it will
+	 * return garbage SKs.
+	 */
+	if (!(hook_mask & XT_SOCKET_SUPPORTED_HOOKS))
+		return NULL;
+
+	switch (par->family) {
+	case NFPROTO_IPV6:
+		sk = xt_socket_lookup_slow_v6(dev_net(skb->dev), skb, par->in);
+		break;
+	case NFPROTO_IPV4:
+		sk = xt_socket_lookup_slow_v4(dev_net(skb->dev), skb, par->in);
+		break;
+	default:
+		return NULL;
+	}
+
+	if (sk) {
+		MT_DEBUG("qtaguid[%d]: %p->sk_proto=%u->sk_state=%d\n",
+			 par->hooknum, sk, sk->sk_protocol, sk->sk_state);
+	}
+	return sk;
+}
+
+static void account_for_uid(const struct sk_buff *skb,
+			    const struct sock *alternate_sk, uid_t uid,
+			    struct xt_action_param *par)
+{
+	const struct net_device *el_dev;
+	enum ifs_tx_rx direction;
+	int proto;
+
+	get_dev_and_dir(skb, par, &direction, &el_dev);
+	proto = ipx_proto(skb, par);
+	MT_DEBUG("qtaguid[%d]: dev name=%s type=%d fam=%d proto=%d dir=%d\n",
+		 par->hooknum, el_dev->name, el_dev->type,
+		 par->family, proto, direction);
+
+	if_tag_stat_update(el_dev->name, uid,
+			   skb->sk ? skb->sk : alternate_sk,
+			   direction,
+			   proto, skb->len);
+}
+
+static bool qtaguid_mt(const struct sk_buff *skb, struct xt_action_param *par)
+{
+	const struct xt_qtaguid_match_info *info = par->matchinfo;
+	const struct file *filp;
+	bool got_sock = false;
+	struct sock *sk;
+	kuid_t sock_uid;
+	bool res;
+	bool set_sk_callback_lock = false;
+	/*
+	 * TODO: unhack how to force just accounting.
+	 * For now we only do tag stats when the uid-owner is not requested
+	 */
+	bool do_tag_stat = !(info->match & XT_QTAGUID_UID);
+
+	if (unlikely(module_passive))
+		return (info->match ^ info->invert) == 0;
+
+	MT_DEBUG("qtaguid[%d]: entered skb=%p par->in=%p/out=%p fam=%d\n",
+		 par->hooknum, skb, par->in, par->out, par->family);
+
+	atomic64_inc(&qtu_events.match_calls);
+	if (skb == NULL) {
+		res = (info->match ^ info->invert) == 0;
+		goto ret_res;
+	}
+
+	switch (par->hooknum) {
+	case NF_INET_PRE_ROUTING:
+	case NF_INET_POST_ROUTING:
+		atomic64_inc(&qtu_events.match_calls_prepost);
+		iface_stat_update_from_skb(skb, par);
+		/*
+		 * We are done in pre/post. The skb will get processed
+		 * further alter.
+		 */
+		res = (info->match ^ info->invert);
+		goto ret_res;
+		break;
+	/* default: Fall through and do UID releated work */
+	}
+
+	sk = skb_to_full_sk(skb);
+	/*
+	 * When in TCP_TIME_WAIT the sk is not a "struct sock" but
+	 * "struct inet_timewait_sock" which is missing fields.
+	 * So we ignore it.
+	 */
+	if (sk && sk->sk_state == TCP_TIME_WAIT)
+		sk = NULL;
+	if (sk == NULL) {
+		/*
+		 * A missing sk->sk_socket happens when packets are in-flight
+		 * and the matching socket is already closed and gone.
+		 */
+		sk = qtaguid_find_sk(skb, par);
+		/*
+		 * TCP_NEW_SYN_RECV are not "struct sock" but "struct request_sock"
+		 * where we can get a pointer to a full socket to retrieve uid/gid.
+		 * When in TCP_TIME_WAIT, sk is a struct inet_timewait_sock
+		 * which is missing fields and does not contain any reference
+		 * to a full socket, so just ignore the socket.
+		 */
+		if (sk && sk->sk_state == TCP_NEW_SYN_RECV) {
+			sock_gen_put(sk);
+			sk = sk_to_full_sk(sk);
+		} else if (sk && (!sk_fullsock(sk) || sk->sk_state == TCP_TIME_WAIT)) {
+			sock_gen_put(sk);
+			sk = NULL;
+		} else {
+			/*
+			 * If we got the socket from the find_sk(), we will need to put
+			 * it back, as nf_tproxy_get_sock_v4() got it.
+			 */
+			got_sock = sk;
+		}
+		if (sk)
+			atomic64_inc(&qtu_events.match_found_sk_in_ct);
+		else
+			atomic64_inc(&qtu_events.match_found_no_sk_in_ct);
+	} else {
+		atomic64_inc(&qtu_events.match_found_sk);
+	}
+	MT_DEBUG("qtaguid[%d]: sk=%p got_sock=%d fam=%d proto=%d\n",
+		 par->hooknum, sk, got_sock, par->family, ipx_proto(skb, par));
+
+	if (!sk) {
+		/*
+		 * Here, the qtaguid_find_sk() using connection tracking
+		 * couldn't find the owner, so for now we just count them
+		 * against the system.
+		 */
+		if (do_tag_stat)
+			account_for_uid(skb, sk, 0, par);
+		MT_DEBUG("qtaguid[%d]: leaving (sk=NULL)\n", par->hooknum);
+		res = (info->match ^ info->invert) == 0;
+		atomic64_inc(&qtu_events.match_no_sk);
+		goto put_sock_ret_res;
+	} else if (info->match & info->invert & XT_QTAGUID_SOCKET) {
+		res = false;
+		goto put_sock_ret_res;
+	}
+	sock_uid = sk->sk_uid;
+	if (do_tag_stat)
+		account_for_uid(skb, sk, from_kuid(&init_user_ns, sock_uid),
+				par);
+
+	/*
+	 * The following two tests fail the match when:
+	 *    id not in range AND no inverted condition requested
+	 * or id     in range AND    inverted condition requested
+	 * Thus (!a && b) || (a && !b) == a ^ b
+	 */
+	if (info->match & XT_QTAGUID_UID) {
+		kuid_t uid_min = make_kuid(&init_user_ns, info->uid_min);
+		kuid_t uid_max = make_kuid(&init_user_ns, info->uid_max);
+
+		if ((uid_gte(sock_uid, uid_min) &&
+		     uid_lte(sock_uid, uid_max)) ^
+		    !(info->invert & XT_QTAGUID_UID)) {
+			MT_DEBUG("qtaguid[%d]: leaving uid not matching\n",
+				 par->hooknum);
+			res = false;
+			goto put_sock_ret_res;
+		}
+	}
+	if (info->match & XT_QTAGUID_GID) {
+		kgid_t gid_min = make_kgid(&init_user_ns, info->gid_min);
+		kgid_t gid_max = make_kgid(&init_user_ns, info->gid_max);
+		set_sk_callback_lock = true;
+		read_lock_bh(&sk->sk_callback_lock);
+		MT_DEBUG("qtaguid[%d]: sk=%p->sk_socket=%p->file=%p\n",
+			 par->hooknum, sk, sk->sk_socket,
+			 sk->sk_socket ? sk->sk_socket->file : (void *)-1LL);
+		filp = sk->sk_socket ? sk->sk_socket->file : NULL;
+		if (!filp) {
+			res = ((info->match ^ info->invert) &
+			       XT_QTAGUID_GID) == 0;
+			atomic64_inc(&qtu_events.match_no_sk_gid);
+			goto put_sock_ret_res;
+		}
+		MT_DEBUG("qtaguid[%d]: filp...uid=%u\n",
+			 par->hooknum, filp ?
+			 from_kuid(&init_user_ns, filp->f_cred->fsuid) : -1);
+		if ((gid_gte(filp->f_cred->fsgid, gid_min) &&
+				gid_lte(filp->f_cred->fsgid, gid_max)) ^
+			!(info->invert & XT_QTAGUID_GID)) {
+			MT_DEBUG("qtaguid[%d]: leaving gid not matching\n",
+				par->hooknum);
+			res = false;
+			goto put_sock_ret_res;
+		}
+	}
+	MT_DEBUG("qtaguid[%d]: leaving matched\n", par->hooknum);
+	res = true;
+
+put_sock_ret_res:
+	if (got_sock)
+		sock_gen_put(sk);
+	if (set_sk_callback_lock)
+		read_unlock_bh(&sk->sk_callback_lock);
+ret_res:
+	MT_DEBUG("qtaguid[%d]: left %d\n", par->hooknum, res);
+	return res;
+}
+
+#ifdef DDEBUG
+/*
+ * This function is not in xt_qtaguid_print.c because of locks visibility.
+ * The lock of sock_tag_list must be aquired before calling this function
+ */
+static void prdebug_full_state_locked(int indent_level, const char *fmt, ...)
+{
+	va_list args;
+	char *fmt_buff;
+	char *buff;
+
+	if (!unlikely(qtaguid_debug_mask & DDEBUG_MASK))
+		return;
+
+	fmt_buff = kasprintf(GFP_ATOMIC,
+			     "qtaguid: %s(): %s {\n", __func__, fmt);
+	BUG_ON(!fmt_buff);
+	va_start(args, fmt);
+	buff = kvasprintf(GFP_ATOMIC,
+			  fmt_buff, args);
+	BUG_ON(!buff);
+	pr_debug("%s", buff);
+	kfree(fmt_buff);
+	kfree(buff);
+	va_end(args);
+
+	prdebug_sock_tag_tree(indent_level, &sock_tag_tree);
+
+	spin_lock_bh(&uid_tag_data_tree_lock);
+	prdebug_uid_tag_data_tree(indent_level, &uid_tag_data_tree);
+	prdebug_proc_qtu_data_tree(indent_level, &proc_qtu_data_tree);
+	spin_unlock_bh(&uid_tag_data_tree_lock);
+
+	spin_lock_bh(&iface_stat_list_lock);
+	prdebug_iface_stat_list(indent_level, &iface_stat_list);
+	spin_unlock_bh(&iface_stat_list_lock);
+
+	pr_debug("qtaguid: %s(): }\n", __func__);
+}
+#else
+static void prdebug_full_state_locked(int indent_level, const char *fmt, ...) {}
+#endif
+
+struct proc_ctrl_print_info {
+	struct sock *sk; /* socket found by reading to sk_pos */
+	loff_t sk_pos;
+};
+
+static void *qtaguid_ctrl_proc_next(struct seq_file *m, void *v, loff_t *pos)
+{
+	struct proc_ctrl_print_info *pcpi = m->private;
+	struct sock_tag *sock_tag_entry = v;
+	struct rb_node *node;
+
+	(*pos)++;
+
+	if (!v || v  == SEQ_START_TOKEN)
+		return NULL;
+
+	node = rb_next(&sock_tag_entry->sock_node);
+	if (!node) {
+		pcpi->sk = NULL;
+		sock_tag_entry = SEQ_START_TOKEN;
+	} else {
+		sock_tag_entry = rb_entry(node, struct sock_tag, sock_node);
+		pcpi->sk = sock_tag_entry->sk;
+	}
+	pcpi->sk_pos = *pos;
+	return sock_tag_entry;
+}
+
+static void *qtaguid_ctrl_proc_start(struct seq_file *m, loff_t *pos)
+{
+	struct proc_ctrl_print_info *pcpi = m->private;
+	struct sock_tag *sock_tag_entry;
+	struct rb_node *node;
+
+	spin_lock_bh(&sock_tag_list_lock);
+
+	if (unlikely(module_passive))
+		return NULL;
+
+	if (*pos == 0) {
+		pcpi->sk_pos = 0;
+		node = rb_first(&sock_tag_tree);
+		if (!node) {
+			pcpi->sk = NULL;
+			return SEQ_START_TOKEN;
+		}
+		sock_tag_entry = rb_entry(node, struct sock_tag, sock_node);
+		pcpi->sk = sock_tag_entry->sk;
+	} else {
+		sock_tag_entry = (pcpi->sk ? get_sock_stat_nl(pcpi->sk) :
+						NULL) ?: SEQ_START_TOKEN;
+		if (*pos != pcpi->sk_pos) {
+			/* seq_read skipped a next call */
+			*pos = pcpi->sk_pos;
+			return qtaguid_ctrl_proc_next(m, sock_tag_entry, pos);
+		}
+	}
+	return sock_tag_entry;
+}
+
+static void qtaguid_ctrl_proc_stop(struct seq_file *m, void *v)
+{
+	spin_unlock_bh(&sock_tag_list_lock);
+}
+
+/*
+ * Procfs reader to get all active socket tags using style "1)" as described in
+ * fs/proc/generic.c
+ */
+static int qtaguid_ctrl_proc_show(struct seq_file *m, void *v)
+{
+	struct sock_tag *sock_tag_entry = v;
+	uid_t uid;
+
+	CT_DEBUG("qtaguid: proc ctrl pid=%u tgid=%u uid=%u\n",
+		 current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()));
+
+	if (sock_tag_entry != SEQ_START_TOKEN) {
+		int sk_ref_count;
+		uid = get_uid_from_tag(sock_tag_entry->tag);
+		CT_DEBUG("qtaguid: proc_read(): sk=%p tag=0x%llx (uid=%u) "
+			 "pid=%u\n",
+			 sock_tag_entry->sk,
+			 sock_tag_entry->tag,
+			 uid,
+			 sock_tag_entry->pid
+			);
+		sk_ref_count = atomic_read(
+			&sock_tag_entry->sk->sk_refcnt);
+		seq_printf(m, "sock=%pK tag=0x%llx (uid=%u) pid=%u "
+			   "f_count=%d\n",
+			   sock_tag_entry->sk,
+			   sock_tag_entry->tag, uid,
+			   sock_tag_entry->pid, sk_ref_count);
+	} else {
+		seq_printf(m, "events: sockets_tagged=%llu "
+			   "sockets_untagged=%llu "
+			   "counter_set_changes=%llu "
+			   "delete_cmds=%llu "
+			   "iface_events=%llu "
+			   "match_calls=%llu "
+			   "match_calls_prepost=%llu "
+			   "match_found_sk=%llu "
+			   "match_found_sk_in_ct=%llu "
+			   "match_found_no_sk_in_ct=%llu "
+			   "match_no_sk=%llu "
+			   "match_no_sk_gid=%llu\n",
+			   (u64)atomic64_read(&qtu_events.sockets_tagged),
+			   (u64)atomic64_read(&qtu_events.sockets_untagged),
+			   (u64)atomic64_read(&qtu_events.counter_set_changes),
+			   (u64)atomic64_read(&qtu_events.delete_cmds),
+			   (u64)atomic64_read(&qtu_events.iface_events),
+			   (u64)atomic64_read(&qtu_events.match_calls),
+			   (u64)atomic64_read(&qtu_events.match_calls_prepost),
+			   (u64)atomic64_read(&qtu_events.match_found_sk),
+			   (u64)atomic64_read(&qtu_events.match_found_sk_in_ct),
+			   (u64)atomic64_read(&qtu_events.match_found_no_sk_in_ct),
+			   (u64)atomic64_read(&qtu_events.match_no_sk),
+			   (u64)atomic64_read(&qtu_events.match_no_sk_gid));
+
+		/* Count the following as part of the last item_index. No need
+		 * to lock the sock_tag_list here since it is already locked when
+		 * starting the seq_file operation
+		 */
+		prdebug_full_state_locked(0, "proc ctrl");
+	}
+
+	return 0;
+}
+
+/*
+ * Delete socket tags, and stat tags associated with a given
+ * accouting tag and uid.
+ */
+static int ctrl_cmd_delete(const char *input)
+{
+	char cmd;
+	int uid_int;
+	kuid_t uid;
+	uid_t entry_uid;
+	tag_t acct_tag;
+	tag_t tag;
+	int res, argc;
+	struct iface_stat *iface_entry;
+	struct rb_node *node;
+	struct sock_tag *st_entry;
+	struct rb_root st_to_free_tree = RB_ROOT;
+	struct tag_stat *ts_entry;
+	struct tag_counter_set *tcs_entry;
+	struct tag_ref *tr_entry;
+	struct uid_tag_data *utd_entry;
+
+	argc = sscanf(input, "%c %llu %u", &cmd, &acct_tag, &uid_int);
+	uid = make_kuid(&init_user_ns, uid_int);
+	CT_DEBUG("qtaguid: ctrl_delete(%s): argc=%d cmd=%c "
+		 "user_tag=0x%llx uid=%u\n", input, argc, cmd,
+		 acct_tag, uid_int);
+	if (argc < 2) {
+		res = -EINVAL;
+		goto err;
+	}
+	if (!valid_atag(acct_tag)) {
+		pr_info("qtaguid: ctrl_delete(%s): invalid tag\n", input);
+		res = -EINVAL;
+		goto err;
+	}
+	if (argc < 3) {
+		uid = current_fsuid();
+		uid_int = from_kuid(&init_user_ns, uid);
+	} else if (!can_impersonate_uid(uid)) {
+		pr_info("qtaguid: ctrl_delete(%s): "
+			"insufficient priv from pid=%u tgid=%u uid=%u\n",
+			input, current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()));
+		res = -EPERM;
+		goto err;
+	}
+
+	tag = combine_atag_with_uid(acct_tag, uid_int);
+	CT_DEBUG("qtaguid: ctrl_delete(%s): "
+		 "looking for tag=0x%llx (uid=%u)\n",
+		 input, tag, uid_int);
+
+	/* Delete socket tags */
+	spin_lock_bh(&sock_tag_list_lock);
+	spin_lock_bh(&uid_tag_data_tree_lock);
+	node = rb_first(&sock_tag_tree);
+	while (node) {
+		st_entry = rb_entry(node, struct sock_tag, sock_node);
+		entry_uid = get_uid_from_tag(st_entry->tag);
+		node = rb_next(node);
+		if (entry_uid != uid_int)
+			continue;
+
+		CT_DEBUG("qtaguid: ctrl_delete(%s): st tag=0x%llx (uid=%u)\n",
+			 input, st_entry->tag, entry_uid);
+
+		if (!acct_tag || st_entry->tag == tag) {
+			rb_erase(&st_entry->sock_node, &sock_tag_tree);
+			/* Can't sockfd_put() within spinlock, do it later. */
+			sock_tag_tree_insert(st_entry, &st_to_free_tree);
+			tr_entry = lookup_tag_ref(st_entry->tag, NULL);
+			BUG_ON(tr_entry->num_sock_tags <= 0);
+			tr_entry->num_sock_tags--;
+			/*
+			 * TODO: remove if, and start failing.
+			 * This is a hack to work around the fact that in some
+			 * places we have "if (IS_ERR_OR_NULL(pqd_entry))"
+			 * and are trying to work around apps
+			 * that didn't open the /dev/xt_qtaguid.
+			 */
+			if (st_entry->list.next && st_entry->list.prev)
+				list_del(&st_entry->list);
+		}
+	}
+	spin_unlock_bh(&uid_tag_data_tree_lock);
+	spin_unlock_bh(&sock_tag_list_lock);
+
+	sock_tag_tree_erase(&st_to_free_tree);
+
+	/* Delete tag counter-sets */
+	spin_lock_bh(&tag_counter_set_list_lock);
+	/* Counter sets are only on the uid tag, not full tag */
+	tcs_entry = tag_counter_set_tree_search(&tag_counter_set_tree, tag);
+	if (tcs_entry) {
+		CT_DEBUG("qtaguid: ctrl_delete(%s): "
+			 "erase tcs: tag=0x%llx (uid=%u) set=%d\n",
+			 input,
+			 tcs_entry->tn.tag,
+			 get_uid_from_tag(tcs_entry->tn.tag),
+			 tcs_entry->active_set);
+		rb_erase(&tcs_entry->tn.node, &tag_counter_set_tree);
+		kfree(tcs_entry);
+	}
+	spin_unlock_bh(&tag_counter_set_list_lock);
+
+	/*
+	 * If acct_tag is 0, then all entries belonging to uid are
+	 * erased.
+	 */
+	spin_lock_bh(&iface_stat_list_lock);
+	list_for_each_entry(iface_entry, &iface_stat_list, list) {
+		spin_lock_bh(&iface_entry->tag_stat_list_lock);
+		node = rb_first(&iface_entry->tag_stat_tree);
+		while (node) {
+			ts_entry = rb_entry(node, struct tag_stat, tn.node);
+			entry_uid = get_uid_from_tag(ts_entry->tn.tag);
+			node = rb_next(node);
+
+			CT_DEBUG("qtaguid: ctrl_delete(%s): "
+				 "ts tag=0x%llx (uid=%u)\n",
+				 input, ts_entry->tn.tag, entry_uid);
+
+			if (entry_uid != uid_int)
+				continue;
+			if (!acct_tag || ts_entry->tn.tag == tag) {
+				CT_DEBUG("qtaguid: ctrl_delete(%s): "
+					 "erase ts: %s 0x%llx %u\n",
+					 input, iface_entry->ifname,
+					 get_atag_from_tag(ts_entry->tn.tag),
+					 entry_uid);
+				rb_erase(&ts_entry->tn.node,
+					 &iface_entry->tag_stat_tree);
+				kfree(ts_entry);
+			}
+		}
+		spin_unlock_bh(&iface_entry->tag_stat_list_lock);
+	}
+	spin_unlock_bh(&iface_stat_list_lock);
+
+	/* Cleanup the uid_tag_data */
+	spin_lock_bh(&uid_tag_data_tree_lock);
+	node = rb_first(&uid_tag_data_tree);
+	while (node) {
+		utd_entry = rb_entry(node, struct uid_tag_data, node);
+		entry_uid = utd_entry->uid;
+		node = rb_next(node);
+
+		CT_DEBUG("qtaguid: ctrl_delete(%s): "
+			 "utd uid=%u\n",
+			 input, entry_uid);
+
+		if (entry_uid != uid_int)
+			continue;
+		/*
+		 * Go over the tag_refs, and those that don't have
+		 * sock_tags using them are freed.
+		 */
+		put_tag_ref_tree(tag, utd_entry);
+		put_utd_entry(utd_entry);
+	}
+	spin_unlock_bh(&uid_tag_data_tree_lock);
+
+	atomic64_inc(&qtu_events.delete_cmds);
+	res = 0;
+
+err:
+	return res;
+}
+
+static int ctrl_cmd_counter_set(const char *input)
+{
+	char cmd;
+	uid_t uid = 0;
+	tag_t tag;
+	int res, argc;
+	struct tag_counter_set *tcs;
+	int counter_set;
+
+	argc = sscanf(input, "%c %d %u", &cmd, &counter_set, &uid);
+	CT_DEBUG("qtaguid: ctrl_counterset(%s): argc=%d cmd=%c "
+		 "set=%d uid=%u\n", input, argc, cmd,
+		 counter_set, uid);
+	if (argc != 3) {
+		res = -EINVAL;
+		goto err;
+	}
+	if (counter_set < 0 || counter_set >= IFS_MAX_COUNTER_SETS) {
+		pr_info("qtaguid: ctrl_counterset(%s): invalid counter_set range\n",
+			input);
+		res = -EINVAL;
+		goto err;
+	}
+	if (!can_manipulate_uids()) {
+		pr_info("qtaguid: ctrl_counterset(%s): "
+			"insufficient priv from pid=%u tgid=%u uid=%u\n",
+			input, current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()));
+		res = -EPERM;
+		goto err;
+	}
+
+	tag = make_tag_from_uid(uid);
+	spin_lock_bh(&tag_counter_set_list_lock);
+	tcs = tag_counter_set_tree_search(&tag_counter_set_tree, tag);
+	if (!tcs) {
+		tcs = kzalloc(sizeof(*tcs), GFP_ATOMIC);
+		if (!tcs) {
+			spin_unlock_bh(&tag_counter_set_list_lock);
+			pr_err("qtaguid: ctrl_counterset(%s): "
+			       "failed to alloc counter set\n",
+			       input);
+			res = -ENOMEM;
+			goto err;
+		}
+		tcs->tn.tag = tag;
+		tag_counter_set_tree_insert(tcs, &tag_counter_set_tree);
+		CT_DEBUG("qtaguid: ctrl_counterset(%s): added tcs tag=0x%llx "
+			 "(uid=%u) set=%d\n",
+			 input, tag, get_uid_from_tag(tag), counter_set);
+	}
+	tcs->active_set = counter_set;
+	spin_unlock_bh(&tag_counter_set_list_lock);
+	atomic64_inc(&qtu_events.counter_set_changes);
+	res = 0;
+
+err:
+	return res;
+}
+
+static int ctrl_cmd_tag(const char *input)
+{
+	char cmd;
+	int sock_fd = 0;
+	kuid_t uid;
+	unsigned int uid_int = 0;
+	tag_t acct_tag = make_atag_from_value(0);
+	tag_t full_tag;
+	struct socket *el_socket;
+	int res, argc;
+	struct sock_tag *sock_tag_entry;
+	struct tag_ref *tag_ref_entry;
+	struct uid_tag_data *uid_tag_data_entry;
+	struct proc_qtu_data *pqd_entry;
+
+	/* Unassigned args will get defaulted later. */
+	argc = sscanf(input, "%c %d %llu %u", &cmd, &sock_fd, &acct_tag, &uid_int);
+	uid = make_kuid(&init_user_ns, uid_int);
+	CT_DEBUG("qtaguid: ctrl_tag(%s): argc=%d cmd=%c sock_fd=%d "
+		 "acct_tag=0x%llx uid=%u\n", input, argc, cmd, sock_fd,
+		 acct_tag, uid_int);
+	if (argc < 2) {
+		res = -EINVAL;
+		goto err;
+	}
+	el_socket = sockfd_lookup(sock_fd, &res);  /* This locks the file */
+	if (!el_socket) {
+		pr_info("qtaguid: ctrl_tag(%s): failed to lookup"
+			" sock_fd=%d err=%d pid=%u tgid=%u uid=%u\n",
+			input, sock_fd, res, current->pid, current->tgid,
+			from_kuid(&init_user_ns, current_fsuid()));
+		goto err;
+	}
+	CT_DEBUG("qtaguid: ctrl_tag(%s): socket->...->sk_refcnt=%d ->sk=%p\n",
+		 input, atomic_read(&el_socket->sk->sk_refcnt),
+		 el_socket->sk);
+	if (argc < 3) {
+		acct_tag = make_atag_from_value(0);
+	} else if (!valid_atag(acct_tag)) {
+		pr_info("qtaguid: ctrl_tag(%s): invalid tag\n", input);
+		res = -EINVAL;
+		goto err_put;
+	}
+	CT_DEBUG("qtaguid: ctrl_tag(%s): "
+		 "pid=%u tgid=%u uid=%u euid=%u fsuid=%u "
+		 "ctrl.gid=%u in_group()=%d in_egroup()=%d\n",
+		 input, current->pid, current->tgid,
+		 from_kuid(&init_user_ns, current_uid()),
+		 from_kuid(&init_user_ns, current_euid()),
+		 from_kuid(&init_user_ns, current_fsuid()),
+		 from_kgid(&init_user_ns, xt_qtaguid_ctrl_file->gid),
+		 in_group_p(xt_qtaguid_ctrl_file->gid),
+		 in_egroup_p(xt_qtaguid_ctrl_file->gid));
+	if (argc < 4) {
+		uid = current_fsuid();
+		uid_int = from_kuid(&init_user_ns, uid);
+	} else if (!can_impersonate_uid(uid)) {
+		pr_info("qtaguid: ctrl_tag(%s): "
+			"insufficient priv from pid=%u tgid=%u uid=%u\n",
+			input, current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()));
+		res = -EPERM;
+		goto err_put;
+	}
+	full_tag = combine_atag_with_uid(acct_tag, uid_int);
+
+	spin_lock_bh(&sock_tag_list_lock);
+	spin_lock_bh(&uid_tag_data_tree_lock);
+	sock_tag_entry = get_sock_stat_nl(el_socket->sk);
+	tag_ref_entry = get_tag_ref(full_tag, &uid_tag_data_entry);
+	if (IS_ERR(tag_ref_entry)) {
+		res = PTR_ERR(tag_ref_entry);
+		spin_unlock_bh(&uid_tag_data_tree_lock);
+		spin_unlock_bh(&sock_tag_list_lock);
+		goto err_put;
+	}
+	tag_ref_entry->num_sock_tags++;
+	if (sock_tag_entry) {
+		struct tag_ref *prev_tag_ref_entry;
+
+		CT_DEBUG("qtaguid: ctrl_tag(%s): retag for sk=%p "
+			 "st@%p ...->sk_refcnt=%d\n",
+			 input, el_socket->sk, sock_tag_entry,
+			 atomic_read(&el_socket->sk->sk_refcnt));
+		prev_tag_ref_entry = lookup_tag_ref(sock_tag_entry->tag,
+						    &uid_tag_data_entry);
+		BUG_ON(IS_ERR_OR_NULL(prev_tag_ref_entry));
+		BUG_ON(prev_tag_ref_entry->num_sock_tags <= 0);
+		prev_tag_ref_entry->num_sock_tags--;
+		sock_tag_entry->tag = full_tag;
+	} else {
+		CT_DEBUG("qtaguid: ctrl_tag(%s): newtag for sk=%p\n",
+			 input, el_socket->sk);
+		sock_tag_entry = kzalloc(sizeof(*sock_tag_entry),
+					 GFP_ATOMIC);
+		if (!sock_tag_entry) {
+			pr_err("qtaguid: ctrl_tag(%s): "
+			       "socket tag alloc failed\n",
+			       input);
+			BUG_ON(tag_ref_entry->num_sock_tags <= 0);
+			tag_ref_entry->num_sock_tags--;
+			free_tag_ref_from_utd_entry(tag_ref_entry,
+						    uid_tag_data_entry);
+			spin_unlock_bh(&uid_tag_data_tree_lock);
+			spin_unlock_bh(&sock_tag_list_lock);
+			res = -ENOMEM;
+			goto err_put;
+		}
+		/*
+		 * Hold the sk refcount here to make sure the sk pointer cannot
+		 * be freed and reused
+		 */
+		sock_hold(el_socket->sk);
+		sock_tag_entry->sk = el_socket->sk;
+		sock_tag_entry->pid = current->tgid;
+		sock_tag_entry->tag = combine_atag_with_uid(acct_tag, uid_int);
+		pqd_entry = proc_qtu_data_tree_search(
+			&proc_qtu_data_tree, current->tgid);
+		/*
+		 * TODO: remove if, and start failing.
+		 * At first, we want to catch user-space code that is not
+		 * opening the /dev/xt_qtaguid.
+		 */
+		if (IS_ERR_OR_NULL(pqd_entry))
+			pr_warn_once(
+				"qtaguid: %s(): "
+				"User space forgot to open /dev/xt_qtaguid? "
+				"pid=%u tgid=%u uid=%u\n", __func__,
+				current->pid, current->tgid,
+				from_kuid(&init_user_ns, current_fsuid()));
+		else
+			list_add(&sock_tag_entry->list,
+				 &pqd_entry->sock_tag_list);
+
+		sock_tag_tree_insert(sock_tag_entry, &sock_tag_tree);
+		atomic64_inc(&qtu_events.sockets_tagged);
+	}
+	spin_unlock_bh(&uid_tag_data_tree_lock);
+	spin_unlock_bh(&sock_tag_list_lock);
+	/* We keep the ref to the sk until it is untagged */
+	CT_DEBUG("qtaguid: ctrl_tag(%s): done st@%p ...->sk_refcnt=%d\n",
+		 input, sock_tag_entry,
+		 atomic_read(&el_socket->sk->sk_refcnt));
+	sockfd_put(el_socket);
+	return 0;
+
+err_put:
+	CT_DEBUG("qtaguid: ctrl_tag(%s): done. ...->sk_refcnt=%d\n",
+		 input, atomic_read(&el_socket->sk->sk_refcnt) - 1);
+	/* Release the sock_fd that was grabbed by sockfd_lookup(). */
+	sockfd_put(el_socket);
+	return res;
+
+err:
+	CT_DEBUG("qtaguid: ctrl_tag(%s): done.\n", input);
+	return res;
+}
+
+static int ctrl_cmd_untag(const char *input)
+{
+	char cmd;
+	int sock_fd = 0;
+	struct socket *el_socket;
+	int res, argc;
+
+	argc = sscanf(input, "%c %d", &cmd, &sock_fd);
+	CT_DEBUG("qtaguid: ctrl_untag(%s): argc=%d cmd=%c sock_fd=%d\n",
+		 input, argc, cmd, sock_fd);
+	if (argc < 2) {
+		res = -EINVAL;
+		return res;
+	}
+	el_socket = sockfd_lookup(sock_fd, &res);  /* This locks the file */
+	if (!el_socket) {
+		pr_info("qtaguid: ctrl_untag(%s): failed to lookup"
+			" sock_fd=%d err=%d pid=%u tgid=%u uid=%u\n",
+			input, sock_fd, res, current->pid, current->tgid,
+			from_kuid(&init_user_ns, current_fsuid()));
+		return res;
+	}
+	CT_DEBUG("qtaguid: ctrl_untag(%s): socket->...->f_count=%ld ->sk=%p\n",
+		 input, atomic_long_read(&el_socket->file->f_count),
+		 el_socket->sk);
+	res = qtaguid_untag(el_socket, false);
+	sockfd_put(el_socket);
+	return res;
+}
+
+int qtaguid_untag(struct socket *el_socket, bool kernel)
+{
+	int res;
+	pid_t pid;
+	struct sock_tag *sock_tag_entry;
+	struct tag_ref *tag_ref_entry;
+	struct uid_tag_data *utd_entry;
+	struct proc_qtu_data *pqd_entry;
+
+	spin_lock_bh(&sock_tag_list_lock);
+	sock_tag_entry = get_sock_stat_nl(el_socket->sk);
+	if (!sock_tag_entry) {
+		spin_unlock_bh(&sock_tag_list_lock);
+		res = -EINVAL;
+		return res;
+	}
+	/*
+	 * The socket already belongs to the current process
+	 * so it can do whatever it wants to it.
+	 */
+	rb_erase(&sock_tag_entry->sock_node, &sock_tag_tree);
+
+	tag_ref_entry = lookup_tag_ref(sock_tag_entry->tag, &utd_entry);
+	BUG_ON(!tag_ref_entry);
+	BUG_ON(tag_ref_entry->num_sock_tags <= 0);
+	spin_lock_bh(&uid_tag_data_tree_lock);
+	if (kernel)
+		pid = sock_tag_entry->pid;
+	else
+		pid = current->tgid;
+	pqd_entry = proc_qtu_data_tree_search(
+		&proc_qtu_data_tree, pid);
+	/*
+	 * TODO: remove if, and start failing.
+	 * At first, we want to catch user-space code that is not
+	 * opening the /dev/xt_qtaguid.
+	 */
+	if (IS_ERR_OR_NULL(pqd_entry) || !sock_tag_entry->list.next) {
+		pr_warn_once("qtaguid: %s(): "
+			     "User space forgot to open /dev/xt_qtaguid? "
+			     "pid=%u tgid=%u sk_pid=%u, uid=%u\n", __func__,
+			     current->pid, current->tgid, sock_tag_entry->pid,
+			     from_kuid(&init_user_ns, current_fsuid()));
+	} else {
+		list_del(&sock_tag_entry->list);
+	}
+	spin_unlock_bh(&uid_tag_data_tree_lock);
+	/*
+	 * We don't free tag_ref from the utd_entry here,
+	 * only during a cmd_delete().
+	 */
+	tag_ref_entry->num_sock_tags--;
+	spin_unlock_bh(&sock_tag_list_lock);
+	/*
+	 * Release the sock_fd that was grabbed at tag time.
+	 */
+	sock_put(sock_tag_entry->sk);
+	CT_DEBUG("qtaguid: done. st@%p ...->sk_refcnt=%d\n",
+		 sock_tag_entry,
+		 atomic_read(&el_socket->sk->sk_refcnt));
+
+	kfree(sock_tag_entry);
+	atomic64_inc(&qtu_events.sockets_untagged);
+
+	return 0;
+}
+
+static ssize_t qtaguid_ctrl_parse(const char *input, size_t count)
+{
+	char cmd;
+	ssize_t res;
+
+	CT_DEBUG("qtaguid: ctrl(%s): pid=%u tgid=%u uid=%u\n",
+		 input, current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()));
+
+	cmd = input[0];
+	/* Collect params for commands */
+	switch (cmd) {
+	case 'd':
+		res = ctrl_cmd_delete(input);
+		break;
+
+	case 's':
+		res = ctrl_cmd_counter_set(input);
+		break;
+
+	case 't':
+		res = ctrl_cmd_tag(input);
+		break;
+
+	case 'u':
+		res = ctrl_cmd_untag(input);
+		break;
+
+	default:
+		res = -EINVAL;
+		goto err;
+	}
+	if (!res)
+		res = count;
+err:
+	CT_DEBUG("qtaguid: ctrl(%s): res=%zd\n", input, res);
+	return res;
+}
+
+#define MAX_QTAGUID_CTRL_INPUT_LEN 255
+static ssize_t qtaguid_ctrl_proc_write(struct file *file, const char __user *buffer,
+				   size_t count, loff_t *offp)
+{
+	char input_buf[MAX_QTAGUID_CTRL_INPUT_LEN];
+
+	if (unlikely(module_passive))
+		return count;
+
+	if (count >= MAX_QTAGUID_CTRL_INPUT_LEN)
+		return -EINVAL;
+
+	if (copy_from_user(input_buf, buffer, count))
+		return -EFAULT;
+
+	input_buf[count] = '\0';
+	return qtaguid_ctrl_parse(input_buf, count);
+}
+
+struct proc_print_info {
+	struct iface_stat *iface_entry;
+	int item_index;
+	tag_t tag; /* tag found by reading to tag_pos */
+	off_t tag_pos;
+	int tag_item_index;
+};
+
+static void pp_stats_header(struct seq_file *m)
+{
+	seq_puts(m,
+		 "idx iface acct_tag_hex uid_tag_int cnt_set "
+		 "rx_bytes rx_packets "
+		 "tx_bytes tx_packets "
+		 "rx_tcp_bytes rx_tcp_packets "
+		 "rx_udp_bytes rx_udp_packets "
+		 "rx_other_bytes rx_other_packets "
+		 "tx_tcp_bytes tx_tcp_packets "
+		 "tx_udp_bytes tx_udp_packets "
+		 "tx_other_bytes tx_other_packets\n");
+}
+
+static int pp_stats_line(struct seq_file *m, struct tag_stat *ts_entry,
+			 int cnt_set)
+{
+	struct data_counters *cnts;
+	tag_t tag = ts_entry->tn.tag;
+	uid_t stat_uid = get_uid_from_tag(tag);
+	struct proc_print_info *ppi = m->private;
+	/* Detailed tags are not available to everybody */
+	if (!can_read_other_uid_stats(make_kuid(&init_user_ns,stat_uid))) {
+		CT_DEBUG("qtaguid: stats line: "
+			 "%s 0x%llx %u: insufficient priv "
+			 "from pid=%u tgid=%u uid=%u stats.gid=%u\n",
+			 ppi->iface_entry->ifname,
+			 get_atag_from_tag(tag), stat_uid,
+			 current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()),
+			 from_kgid(&init_user_ns,xt_qtaguid_stats_file->gid));
+		return 0;
+	}
+	ppi->item_index++;
+	cnts = &ts_entry->counters;
+	seq_printf(m, "%d %s 0x%llx %u %u "
+		"%llu %llu "
+		"%llu %llu "
+		"%llu %llu "
+		"%llu %llu "
+		"%llu %llu "
+		"%llu %llu "
+		"%llu %llu "
+		"%llu %llu\n",
+		ppi->item_index,
+		ppi->iface_entry->ifname,
+		get_atag_from_tag(tag),
+		stat_uid,
+		cnt_set,
+		dc_sum_bytes(cnts, cnt_set, IFS_RX),
+		dc_sum_packets(cnts, cnt_set, IFS_RX),
+		dc_sum_bytes(cnts, cnt_set, IFS_TX),
+		dc_sum_packets(cnts, cnt_set, IFS_TX),
+		cnts->bpc[cnt_set][IFS_RX][IFS_TCP].bytes,
+		cnts->bpc[cnt_set][IFS_RX][IFS_TCP].packets,
+		cnts->bpc[cnt_set][IFS_RX][IFS_UDP].bytes,
+		cnts->bpc[cnt_set][IFS_RX][IFS_UDP].packets,
+		cnts->bpc[cnt_set][IFS_RX][IFS_PROTO_OTHER].bytes,
+		cnts->bpc[cnt_set][IFS_RX][IFS_PROTO_OTHER].packets,
+		cnts->bpc[cnt_set][IFS_TX][IFS_TCP].bytes,
+		cnts->bpc[cnt_set][IFS_TX][IFS_TCP].packets,
+		cnts->bpc[cnt_set][IFS_TX][IFS_UDP].bytes,
+		cnts->bpc[cnt_set][IFS_TX][IFS_UDP].packets,
+		cnts->bpc[cnt_set][IFS_TX][IFS_PROTO_OTHER].bytes,
+		cnts->bpc[cnt_set][IFS_TX][IFS_PROTO_OTHER].packets);
+	return seq_has_overflowed(m) ? -ENOSPC : 1;
+}
+
+static bool pp_sets(struct seq_file *m, struct tag_stat *ts_entry)
+{
+	int ret;
+	int counter_set;
+	for (counter_set = 0; counter_set < IFS_MAX_COUNTER_SETS;
+	     counter_set++) {
+		ret = pp_stats_line(m, ts_entry, counter_set);
+		if (ret < 0)
+			return false;
+	}
+	return true;
+}
+
+static int qtaguid_stats_proc_iface_stat_ptr_valid(struct iface_stat *ptr)
+{
+	struct iface_stat *iface_entry;
+
+	if (!ptr)
+		return false;
+
+	list_for_each_entry(iface_entry, &iface_stat_list, list)
+		if (iface_entry == ptr)
+			return true;
+	return false;
+}
+
+static void qtaguid_stats_proc_next_iface_entry(struct proc_print_info *ppi)
+{
+	spin_unlock_bh(&ppi->iface_entry->tag_stat_list_lock);
+	list_for_each_entry_continue(ppi->iface_entry, &iface_stat_list, list) {
+		spin_lock_bh(&ppi->iface_entry->tag_stat_list_lock);
+		return;
+	}
+	ppi->iface_entry = NULL;
+}
+
+static void *qtaguid_stats_proc_next(struct seq_file *m, void *v, loff_t *pos)
+{
+	struct proc_print_info *ppi = m->private;
+	struct tag_stat *ts_entry;
+	struct rb_node *node;
+
+	if (!v) {
+		pr_err("qtaguid: %s(): unexpected v: NULL\n", __func__);
+		return NULL;
+	}
+
+	(*pos)++;
+
+	if (!ppi->iface_entry || unlikely(module_passive))
+		return NULL;
+
+	if (v == SEQ_START_TOKEN)
+		node = rb_first(&ppi->iface_entry->tag_stat_tree);
+	else
+		node = rb_next(&((struct tag_stat *)v)->tn.node);
+
+	while (!node) {
+		qtaguid_stats_proc_next_iface_entry(ppi);
+		if (!ppi->iface_entry)
+			return NULL;
+		node = rb_first(&ppi->iface_entry->tag_stat_tree);
+	}
+
+	ts_entry = rb_entry(node, struct tag_stat, tn.node);
+	ppi->tag = ts_entry->tn.tag;
+	ppi->tag_pos = *pos;
+	ppi->tag_item_index = ppi->item_index;
+	return ts_entry;
+}
+
+static void *qtaguid_stats_proc_start(struct seq_file *m, loff_t *pos)
+{
+	struct proc_print_info *ppi = m->private;
+	struct tag_stat *ts_entry = NULL;
+
+	spin_lock_bh(&iface_stat_list_lock);
+
+	if (*pos == 0) {
+		ppi->item_index = 1;
+		ppi->tag_pos = 0;
+		if (list_empty(&iface_stat_list)) {
+			ppi->iface_entry = NULL;
+		} else {
+			ppi->iface_entry = list_first_entry(&iface_stat_list,
+							    struct iface_stat,
+							    list);
+			spin_lock_bh(&ppi->iface_entry->tag_stat_list_lock);
+		}
+		return SEQ_START_TOKEN;
+	}
+	if (!qtaguid_stats_proc_iface_stat_ptr_valid(ppi->iface_entry)) {
+		if (ppi->iface_entry) {
+			pr_err("qtaguid: %s(): iface_entry %p not found\n",
+			       __func__, ppi->iface_entry);
+			ppi->iface_entry = NULL;
+		}
+		return NULL;
+	}
+
+	spin_lock_bh(&ppi->iface_entry->tag_stat_list_lock);
+
+	if (!ppi->tag_pos) {
+		/* seq_read skipped first next call */
+		ts_entry = SEQ_START_TOKEN;
+	} else {
+		ts_entry = tag_stat_tree_search(
+				&ppi->iface_entry->tag_stat_tree, ppi->tag);
+		if (!ts_entry) {
+			pr_info("qtaguid: %s(): tag_stat.tag 0x%llx not found. Abort.\n",
+				__func__, ppi->tag);
+			return NULL;
+		}
+	}
+
+	if (*pos == ppi->tag_pos) { /* normal resume */
+		ppi->item_index = ppi->tag_item_index;
+	} else {
+		/* seq_read skipped a next call */
+		*pos = ppi->tag_pos;
+		ts_entry = qtaguid_stats_proc_next(m, ts_entry, pos);
+	}
+
+	return ts_entry;
+}
+
+static void qtaguid_stats_proc_stop(struct seq_file *m, void *v)
+{
+	struct proc_print_info *ppi = m->private;
+	if (ppi->iface_entry)
+		spin_unlock_bh(&ppi->iface_entry->tag_stat_list_lock);
+	spin_unlock_bh(&iface_stat_list_lock);
+}
+
+/*
+ * Procfs reader to get all tag stats using style "1)" as described in
+ * fs/proc/generic.c
+ * Groups all protocols tx/rx bytes.
+ */
+static int qtaguid_stats_proc_show(struct seq_file *m, void *v)
+{
+	struct tag_stat *ts_entry = v;
+
+	if (v == SEQ_START_TOKEN)
+		pp_stats_header(m);
+	else
+		pp_sets(m, ts_entry);
+
+	return 0;
+}
+
+/*------------------------------------------*/
+static int qtudev_open(struct inode *inode, struct file *file)
+{
+	struct uid_tag_data *utd_entry;
+	struct proc_qtu_data  *pqd_entry;
+	struct proc_qtu_data  *new_pqd_entry;
+	int res;
+	bool utd_entry_found;
+
+	if (unlikely(qtu_proc_handling_passive))
+		return 0;
+
+	DR_DEBUG("qtaguid: qtudev_open(): pid=%u tgid=%u uid=%u\n",
+		 current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()));
+
+	spin_lock_bh(&uid_tag_data_tree_lock);
+
+	/* Look for existing uid data, or alloc one. */
+	utd_entry = get_uid_data(from_kuid(&init_user_ns, current_fsuid()), &utd_entry_found);
+	if (IS_ERR_OR_NULL(utd_entry)) {
+		res = PTR_ERR(utd_entry);
+		goto err_unlock;
+	}
+
+	/* Look for existing PID based proc_data */
+	pqd_entry = proc_qtu_data_tree_search(&proc_qtu_data_tree,
+					      current->tgid);
+	if (pqd_entry) {
+		pr_err("qtaguid: qtudev_open(): %u/%u %u "
+		       "%s already opened\n",
+		       current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()),
+		       QTU_DEV_NAME);
+		res = -EBUSY;
+		goto err_unlock_free_utd;
+	}
+
+	new_pqd_entry = kzalloc(sizeof(*new_pqd_entry), GFP_ATOMIC);
+	if (!new_pqd_entry) {
+		pr_err("qtaguid: qtudev_open(): %u/%u %u: "
+		       "proc data alloc failed\n",
+		       current->pid, current->tgid, from_kuid(&init_user_ns, current_fsuid()));
+		res = -ENOMEM;
+		goto err_unlock_free_utd;
+	}
+	new_pqd_entry->pid = current->tgid;
+	INIT_LIST_HEAD(&new_pqd_entry->sock_tag_list);
+	new_pqd_entry->parent_tag_data = utd_entry;
+	utd_entry->num_pqd++;
+
+	proc_qtu_data_tree_insert(new_pqd_entry,
+				  &proc_qtu_data_tree);
+
+	spin_unlock_bh(&uid_tag_data_tree_lock);
+	DR_DEBUG("qtaguid: tracking data for uid=%u in pqd=%p\n",
+		 from_kuid(&init_user_ns, current_fsuid()), new_pqd_entry);
+	file->private_data = new_pqd_entry;
+	return 0;
+
+err_unlock_free_utd:
+	if (!utd_entry_found) {
+		rb_erase(&utd_entry->node, &uid_tag_data_tree);
+		kfree(utd_entry);
+	}
+err_unlock:
+	spin_unlock_bh(&uid_tag_data_tree_lock);
+	return res;
+}
+
+static int qtudev_release(struct inode *inode, struct file *file)
+{
+	struct proc_qtu_data  *pqd_entry = file->private_data;
+	struct uid_tag_data  *utd_entry = pqd_entry->parent_tag_data;
+	struct sock_tag *st_entry;
+	struct rb_root st_to_free_tree = RB_ROOT;
+	struct list_head *entry, *next;
+	struct tag_ref *tr;
+
+	if (unlikely(qtu_proc_handling_passive))
+		return 0;
+
+	/*
+	 * Do not trust the current->pid, it might just be a kworker cleaning
+	 * up after a dead proc.
+	 */
+	DR_DEBUG("qtaguid: qtudev_release(): "
+		 "pid=%u tgid=%u uid=%u "
+		 "pqd_entry=%p->pid=%u utd_entry=%p->active_tags=%d\n",
+		 current->pid, current->tgid, pqd_entry->parent_tag_data->uid,
+		 pqd_entry, pqd_entry->pid, utd_entry,
+		 utd_entry->num_active_tags);
+
+	spin_lock_bh(&sock_tag_list_lock);
+	spin_lock_bh(&uid_tag_data_tree_lock);
+
+	list_for_each_safe(entry, next, &pqd_entry->sock_tag_list) {
+		st_entry = list_entry(entry, struct sock_tag, list);
+		DR_DEBUG("qtaguid: %s(): "
+			 "erase sock_tag=%p->sk=%p pid=%u tgid=%u uid=%u\n",
+			 __func__,
+			 st_entry, st_entry->sk,
+			 current->pid, current->tgid,
+			 pqd_entry->parent_tag_data->uid);
+
+		utd_entry = uid_tag_data_tree_search(
+			&uid_tag_data_tree,
+			get_uid_from_tag(st_entry->tag));
+		BUG_ON(IS_ERR_OR_NULL(utd_entry));
+		DR_DEBUG("qtaguid: %s(): "
+			 "looking for tag=0x%llx in utd_entry=%p\n", __func__,
+			 st_entry->tag, utd_entry);
+		tr = tag_ref_tree_search(&utd_entry->tag_ref_tree,
+					 st_entry->tag);
+		BUG_ON(!tr);
+		BUG_ON(tr->num_sock_tags <= 0);
+		tr->num_sock_tags--;
+		free_tag_ref_from_utd_entry(tr, utd_entry);
+
+		rb_erase(&st_entry->sock_node, &sock_tag_tree);
+		list_del(&st_entry->list);
+		/* Can't sockfd_put() within spinlock, do it later. */
+		sock_tag_tree_insert(st_entry, &st_to_free_tree);
+
+		/*
+		 * Try to free the utd_entry if no other proc_qtu_data is
+		 * using it (num_pqd is 0) and it doesn't have active tags
+		 * (num_active_tags is 0).
+		 */
+		put_utd_entry(utd_entry);
+	}
+
+	rb_erase(&pqd_entry->node, &proc_qtu_data_tree);
+	BUG_ON(pqd_entry->parent_tag_data->num_pqd < 1);
+	pqd_entry->parent_tag_data->num_pqd--;
+	put_utd_entry(pqd_entry->parent_tag_data);
+	kfree(pqd_entry);
+	file->private_data = NULL;
+
+	spin_unlock_bh(&uid_tag_data_tree_lock);
+	spin_unlock_bh(&sock_tag_list_lock);
+
+
+	sock_tag_tree_erase(&st_to_free_tree);
+
+	spin_lock_bh(&sock_tag_list_lock);
+	prdebug_full_state_locked(0, "%s(): pid=%u tgid=%u", __func__,
+			   current->pid, current->tgid);
+	spin_unlock_bh(&sock_tag_list_lock);
+	return 0;
+}
+
+/*------------------------------------------*/
+static const struct file_operations qtudev_fops = {
+	.owner = THIS_MODULE,
+	.open = qtudev_open,
+	.release = qtudev_release,
+};
+
+static struct miscdevice qtu_device = {
+	.minor = MISC_DYNAMIC_MINOR,
+	.name = QTU_DEV_NAME,
+	.fops = &qtudev_fops,
+	/* How sad it doesn't allow for defaults: .mode = S_IRUGO | S_IWUSR */
+};
+
+static const struct seq_operations proc_qtaguid_ctrl_seqops = {
+	.start = qtaguid_ctrl_proc_start,
+	.next = qtaguid_ctrl_proc_next,
+	.stop = qtaguid_ctrl_proc_stop,
+	.show = qtaguid_ctrl_proc_show,
+};
+
+static int proc_qtaguid_ctrl_open(struct inode *inode, struct file *file)
+{
+	return seq_open_private(file, &proc_qtaguid_ctrl_seqops,
+				sizeof(struct proc_ctrl_print_info));
+}
+
+static const struct file_operations proc_qtaguid_ctrl_fops = {
+	.open		= proc_qtaguid_ctrl_open,
+	.read		= seq_read,
+	.write		= qtaguid_ctrl_proc_write,
+	.llseek		= seq_lseek,
+	.release	= seq_release_private,
+};
+
+static const struct seq_operations proc_qtaguid_stats_seqops = {
+	.start = qtaguid_stats_proc_start,
+	.next = qtaguid_stats_proc_next,
+	.stop = qtaguid_stats_proc_stop,
+	.show = qtaguid_stats_proc_show,
+};
+
+static int proc_qtaguid_stats_open(struct inode *inode, struct file *file)
+{
+	return seq_open_private(file, &proc_qtaguid_stats_seqops,
+				sizeof(struct proc_print_info));
+}
+
+static const struct file_operations proc_qtaguid_stats_fops = {
+	.open		= proc_qtaguid_stats_open,
+	.read		= seq_read,
+	.llseek		= seq_lseek,
+	.release	= seq_release_private,
+};
+
+/*------------------------------------------*/
+static int __init qtaguid_proc_register(struct proc_dir_entry **res_procdir)
+{
+	int ret;
+	*res_procdir = proc_mkdir(module_procdirname, init_net.proc_net);
+	if (!*res_procdir) {
+		pr_err("qtaguid: failed to create proc/.../xt_qtaguid\n");
+		ret = -ENOMEM;
+		goto no_dir;
+	}
+
+	xt_qtaguid_ctrl_file = proc_create_data("ctrl", proc_ctrl_perms,
+						*res_procdir,
+						&proc_qtaguid_ctrl_fops,
+						NULL);
+	if (!xt_qtaguid_ctrl_file) {
+		pr_err("qtaguid: failed to create xt_qtaguid/ctrl "
+			" file\n");
+		ret = -ENOMEM;
+		goto no_ctrl_entry;
+	}
+
+	xt_qtaguid_stats_file = proc_create_data("stats", proc_stats_perms,
+						 *res_procdir,
+						 &proc_qtaguid_stats_fops,
+						 NULL);
+	if (!xt_qtaguid_stats_file) {
+		pr_err("qtaguid: failed to create xt_qtaguid/stats "
+			"file\n");
+		ret = -ENOMEM;
+		goto no_stats_entry;
+	}
+	/*
+	 * TODO: add support counter hacking
+	 * xt_qtaguid_stats_file->write_proc = qtaguid_stats_proc_write;
+	 */
+	return 0;
+
+no_stats_entry:
+	remove_proc_entry("ctrl", *res_procdir);
+no_ctrl_entry:
+	remove_proc_entry("xt_qtaguid", NULL);
+no_dir:
+	return ret;
+}
+
+static struct xt_match qtaguid_mt_reg __read_mostly = {
+	/*
+	 * This module masquerades as the "owner" module so that iptables
+	 * tools can deal with it.
+	 */
+	.name       = "owner",
+	.revision   = 1,
+	.family     = NFPROTO_UNSPEC,
+	.match      = qtaguid_mt,
+	.matchsize  = sizeof(struct xt_qtaguid_match_info),
+	.me         = THIS_MODULE,
+};
+
+static int __init qtaguid_mt_init(void)
+{
+	if (qtaguid_proc_register(&xt_qtaguid_procdir)
+	    || iface_stat_init(xt_qtaguid_procdir)
+	    || xt_register_match(&qtaguid_mt_reg)
+	    || misc_register(&qtu_device))
+		return -1;
+	return 0;
+}
+
+/*
+ * TODO: allow unloading of the module.
+ * For now stats are permanent.
+ * Kconfig forces'y/n' and never an 'm'.
+ */
+
+module_init(qtaguid_mt_init);
+MODULE_AUTHOR("jpa <jpa@google.com>");
+MODULE_DESCRIPTION("Xtables: socket owner+tag matching and associated stats");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("ipt_owner");
+MODULE_ALIAS("ip6t_owner");
+MODULE_ALIAS("ipt_qtaguid");
+MODULE_ALIAS("ip6t_qtaguid");
diff --git a/net/netfilter/xt_qtaguid_internal.h b/net/netfilter/xt_qtaguid_internal.h
new file mode 100644
index 00000000..c705270
--- /dev/null
+++ b/net/netfilter/xt_qtaguid_internal.h
@@ -0,0 +1,350 @@
+/*
+ * Kernel iptables module to track stats for packets based on user tags.
+ *
+ * (C) 2011 Google, Inc
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifndef __XT_QTAGUID_INTERNAL_H__
+#define __XT_QTAGUID_INTERNAL_H__
+
+#include <linux/types.h>
+#include <linux/rbtree.h>
+#include <linux/spinlock_types.h>
+#include <linux/workqueue.h>
+
+/* Iface handling */
+#define IDEBUG_MASK (1<<0)
+/* Iptable Matching. Per packet. */
+#define MDEBUG_MASK (1<<1)
+/* Red-black tree handling. Per packet. */
+#define RDEBUG_MASK (1<<2)
+/* procfs ctrl/stats handling */
+#define CDEBUG_MASK (1<<3)
+/* dev and resource tracking */
+#define DDEBUG_MASK (1<<4)
+
+/* E.g (IDEBUG_MASK | CDEBUG_MASK | DDEBUG_MASK) */
+#define DEFAULT_DEBUG_MASK 0
+
+/*
+ * (Un)Define these *DEBUG to compile out/in the pr_debug calls.
+ * All undef: text size ~ 0x3030; all def: ~ 0x4404.
+ */
+#define IDEBUG
+#define MDEBUG
+#define RDEBUG
+#define CDEBUG
+#define DDEBUG
+
+#define MSK_DEBUG(mask, ...) do {                           \
+		if (unlikely(qtaguid_debug_mask & (mask)))  \
+			pr_debug(__VA_ARGS__);              \
+	} while (0)
+#ifdef IDEBUG
+#define IF_DEBUG(...) MSK_DEBUG(IDEBUG_MASK, __VA_ARGS__)
+#else
+#define IF_DEBUG(...) no_printk(__VA_ARGS__)
+#endif
+#ifdef MDEBUG
+#define MT_DEBUG(...) MSK_DEBUG(MDEBUG_MASK, __VA_ARGS__)
+#else
+#define MT_DEBUG(...) no_printk(__VA_ARGS__)
+#endif
+#ifdef RDEBUG
+#define RB_DEBUG(...) MSK_DEBUG(RDEBUG_MASK, __VA_ARGS__)
+#else
+#define RB_DEBUG(...) no_printk(__VA_ARGS__)
+#endif
+#ifdef CDEBUG
+#define CT_DEBUG(...) MSK_DEBUG(CDEBUG_MASK, __VA_ARGS__)
+#else
+#define CT_DEBUG(...) no_printk(__VA_ARGS__)
+#endif
+#ifdef DDEBUG
+#define DR_DEBUG(...) MSK_DEBUG(DDEBUG_MASK, __VA_ARGS__)
+#else
+#define DR_DEBUG(...) no_printk(__VA_ARGS__)
+#endif
+
+extern uint qtaguid_debug_mask;
+
+/*---------------------------------------------------------------------------*/
+/*
+ * Tags:
+ *
+ * They represent what the data usage counters will be tracked against.
+ * By default a tag is just based on the UID.
+ * The UID is used as the base for policing, and can not be ignored.
+ * So a tag will always at least represent a UID (uid_tag).
+ *
+ * A tag can be augmented with an "accounting tag" which is associated
+ * with a UID.
+ * User space can set the acct_tag portion of the tag which is then used
+ * with sockets: all data belonging to that socket will be counted against the
+ * tag. The policing is then based on the tag's uid_tag portion,
+ * and stats are collected for the acct_tag portion separately.
+ *
+ * There could be
+ * a:  {acct_tag=1, uid_tag=10003}
+ * b:  {acct_tag=2, uid_tag=10003}
+ * c:  {acct_tag=3, uid_tag=10003}
+ * d:  {acct_tag=0, uid_tag=10003}
+ * a, b, and c represent tags associated with specific sockets.
+ * d is for the totals for that uid, including all untagged traffic.
+ * Typically d is used with policing/quota rules.
+ *
+ * We want tag_t big enough to distinguish uid_t and acct_tag.
+ * It might become a struct if needed.
+ * Nothing should be using it as an int.
+ */
+typedef uint64_t tag_t;  /* Only used via accessors */
+
+#define TAG_UID_MASK 0xFFFFFFFFULL
+#define TAG_ACCT_MASK (~0xFFFFFFFFULL)
+
+static inline int tag_compare(tag_t t1, tag_t t2)
+{
+	return t1 < t2 ? -1 : t1 == t2 ? 0 : 1;
+}
+
+static inline tag_t combine_atag_with_uid(tag_t acct_tag, uid_t uid)
+{
+	return acct_tag | uid;
+}
+static inline tag_t make_tag_from_uid(uid_t uid)
+{
+	return uid;
+}
+static inline uid_t get_uid_from_tag(tag_t tag)
+{
+	return tag & TAG_UID_MASK;
+}
+static inline tag_t get_utag_from_tag(tag_t tag)
+{
+	return tag & TAG_UID_MASK;
+}
+static inline tag_t get_atag_from_tag(tag_t tag)
+{
+	return tag & TAG_ACCT_MASK;
+}
+
+static inline bool valid_atag(tag_t tag)
+{
+	return !(tag & TAG_UID_MASK);
+}
+static inline tag_t make_atag_from_value(uint32_t value)
+{
+	return (uint64_t)value << 32;
+}
+/*---------------------------------------------------------------------------*/
+
+/*
+ * Maximum number of socket tags that a UID is allowed to have active.
+ * Multiple processes belonging to the same UID contribute towards this limit.
+ * Special UIDs that can impersonate a UID also contribute (e.g. download
+ * manager, ...)
+ */
+#define DEFAULT_MAX_SOCK_TAGS 1024
+
+/*
+ * For now we only track 2 sets of counters.
+ * The default set is 0.
+ * Userspace can activate another set for a given uid being tracked.
+ */
+#define IFS_MAX_COUNTER_SETS 2
+
+enum ifs_tx_rx {
+	IFS_TX,
+	IFS_RX,
+	IFS_MAX_DIRECTIONS
+};
+
+/* For now, TCP, UDP, the rest */
+enum ifs_proto {
+	IFS_TCP,
+	IFS_UDP,
+	IFS_PROTO_OTHER,
+	IFS_MAX_PROTOS
+};
+
+struct byte_packet_counters {
+	uint64_t bytes;
+	uint64_t packets;
+};
+
+struct data_counters {
+	struct byte_packet_counters bpc[IFS_MAX_COUNTER_SETS][IFS_MAX_DIRECTIONS][IFS_MAX_PROTOS];
+};
+
+static inline uint64_t dc_sum_bytes(struct data_counters *counters,
+				    int set,
+				    enum ifs_tx_rx direction)
+{
+	return counters->bpc[set][direction][IFS_TCP].bytes
+		+ counters->bpc[set][direction][IFS_UDP].bytes
+		+ counters->bpc[set][direction][IFS_PROTO_OTHER].bytes;
+}
+
+static inline uint64_t dc_sum_packets(struct data_counters *counters,
+				      int set,
+				      enum ifs_tx_rx direction)
+{
+	return counters->bpc[set][direction][IFS_TCP].packets
+		+ counters->bpc[set][direction][IFS_UDP].packets
+		+ counters->bpc[set][direction][IFS_PROTO_OTHER].packets;
+}
+
+
+/* Generic X based nodes used as a base for rb_tree ops */
+struct tag_node {
+	struct rb_node node;
+	tag_t tag;
+};
+
+struct tag_stat {
+	struct tag_node tn;
+	struct data_counters counters;
+	/*
+	 * If this tag is acct_tag based, we need to count against the
+	 * matching parent uid_tag.
+	 */
+	struct data_counters *parent_counters;
+};
+
+struct iface_stat {
+	struct list_head list;  /* in iface_stat_list */
+	char *ifname;
+	bool active;
+	/* net_dev is only valid for active iface_stat */
+	struct net_device *net_dev;
+
+	struct byte_packet_counters totals_via_dev[IFS_MAX_DIRECTIONS];
+	struct data_counters totals_via_skb;
+	/*
+	 * We keep the last_known, because some devices reset their counters
+	 * just before NETDEV_UP, while some will reset just before
+	 * NETDEV_REGISTER (which is more normal).
+	 * So now, if the device didn't do a NETDEV_UNREGISTER and we see
+	 * its current dev stats smaller that what was previously known, we
+	 * assume an UNREGISTER and just use the last_known.
+	 */
+	struct byte_packet_counters last_known[IFS_MAX_DIRECTIONS];
+	/* last_known is usable when last_known_valid is true */
+	bool last_known_valid;
+
+	struct proc_dir_entry *proc_ptr;
+
+	struct rb_root tag_stat_tree;
+	spinlock_t tag_stat_list_lock;
+};
+
+/* This is needed to create proc_dir_entries from atomic context. */
+struct iface_stat_work {
+	struct work_struct iface_work;
+	struct iface_stat *iface_entry;
+};
+
+/*
+ * Track tag that this socket is transferring data for, and not necessarily
+ * the uid that owns the socket.
+ * This is the tag against which tag_stat.counters will be billed.
+ * These structs need to be looked up by sock and pid.
+ */
+struct sock_tag {
+	struct rb_node sock_node;
+	struct sock *sk;  /* Only used as a number, never dereferenced */
+	/* Used to associate with a given pid */
+	struct list_head list;   /* in proc_qtu_data.sock_tag_list */
+	pid_t pid;
+
+	tag_t tag;
+};
+
+struct qtaguid_event_counts {
+	/* Various successful events */
+	atomic64_t sockets_tagged;
+	atomic64_t sockets_untagged;
+	atomic64_t counter_set_changes;
+	atomic64_t delete_cmds;
+	atomic64_t iface_events;  /* Number of NETDEV_* events handled */
+
+	atomic64_t match_calls;   /* Number of times iptables called mt */
+	/* Number of times iptables called mt from pre or post routing hooks */
+	atomic64_t match_calls_prepost;
+	/*
+	 * match_found_sk_*: numbers related to the netfilter matching
+	 * function finding a sock for the sk_buff.
+	 * Total skbs processed is sum(match_found*).
+	 */
+	atomic64_t match_found_sk;   /* An sk was already in the sk_buff. */
+	/* The connection tracker had or didn't have the sk. */
+	atomic64_t match_found_sk_in_ct;
+	atomic64_t match_found_no_sk_in_ct;
+	/*
+	 * No sk could be found. No apparent owner. Could happen with
+	 * unsolicited traffic.
+	 */
+	atomic64_t match_no_sk;
+	/*
+	 * The file ptr in the sk_socket wasn't there and we couldn't get GID.
+	 * This might happen for traffic while the socket is being closed.
+	 */
+	atomic64_t match_no_sk_gid;
+};
+
+/* Track the set active_set for the given tag. */
+struct tag_counter_set {
+	struct tag_node tn;
+	int active_set;
+};
+
+/*----------------------------------------------*/
+/*
+ * The qtu uid data is used to track resources that are created directly or
+ * indirectly by processes (uid tracked).
+ * It is shared by the processes with the same uid.
+ * Some of the resource will be counted to prevent further rogue allocations,
+ * some will need freeing once the owner process (uid) exits.
+ */
+struct uid_tag_data {
+	struct rb_node node;
+	uid_t uid;
+
+	/*
+	 * For the uid, how many accounting tags have been set.
+	 */
+	int num_active_tags;
+	/* Track the number of proc_qtu_data that reference it */
+	int num_pqd;
+	struct rb_root tag_ref_tree;
+	/* No tag_node_tree_lock; use uid_tag_data_tree_lock */
+};
+
+struct tag_ref {
+	struct tag_node tn;
+
+	/*
+	 * This tracks the number of active sockets that have a tag on them
+	 * which matches this tag_ref.tn.tag.
+	 * A tag ref can live on after the sockets are untagged.
+	 * A tag ref can only be removed during a tag delete command.
+	 */
+	int num_sock_tags;
+};
+
+struct proc_qtu_data {
+	struct rb_node node;
+	pid_t pid;
+
+	struct uid_tag_data *parent_tag_data;
+
+	/* Tracks the sock_tags that need freeing upon this proc's death */
+	struct list_head sock_tag_list;
+	/* No spinlock_t sock_tag_list_lock; use the global one. */
+};
+
+/*----------------------------------------------*/
+#endif  /* ifndef __XT_QTAGUID_INTERNAL_H__ */
diff --git a/net/netfilter/xt_qtaguid_print.c b/net/netfilter/xt_qtaguid_print.c
new file mode 100644
index 00000000..2a7190d
--- /dev/null
+++ b/net/netfilter/xt_qtaguid_print.c
@@ -0,0 +1,566 @@
+/*
+ * Pretty printing Support for iptables xt_qtaguid module.
+ *
+ * (C) 2011 Google, Inc
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+/*
+ * Most of the functions in this file just waste time if DEBUG is not defined.
+ * The matching xt_qtaguid_print.h will static inline empty funcs if the needed
+ * debug flags ore not defined.
+ * Those funcs that fail to allocate memory will panic as there is no need to
+ * hobble allong just pretending to do the requested work.
+ */
+
+#define DEBUG
+
+#include <linux/fs.h>
+#include <linux/gfp.h>
+#include <linux/net.h>
+#include <linux/rbtree.h>
+#include <linux/slab.h>
+#include <linux/spinlock_types.h>
+#include <net/sock.h>
+
+#include "xt_qtaguid_internal.h"
+#include "xt_qtaguid_print.h"
+
+#ifdef DDEBUG
+
+static void _bug_on_err_or_null(void *ptr)
+{
+	if (IS_ERR_OR_NULL(ptr)) {
+		pr_err("qtaguid: kmalloc failed\n");
+		BUG();
+	}
+}
+
+char *pp_tag_t(tag_t *tag)
+{
+	char *res;
+
+	if (!tag)
+		res = kasprintf(GFP_ATOMIC, "tag_t@null{}");
+	else
+		res = kasprintf(GFP_ATOMIC,
+				"tag_t@%p{tag=0x%llx, uid=%u}",
+				tag, *tag, get_uid_from_tag(*tag));
+	_bug_on_err_or_null(res);
+	return res;
+}
+
+char *pp_data_counters(struct data_counters *dc, bool showValues)
+{
+	char *res;
+
+	if (!dc)
+		res = kasprintf(GFP_ATOMIC, "data_counters@null{}");
+	else if (showValues)
+		res = kasprintf(
+			GFP_ATOMIC, "data_counters@%p{"
+			"set0{"
+			"rx{"
+			"tcp{b=%llu, p=%llu}, "
+			"udp{b=%llu, p=%llu},"
+			"other{b=%llu, p=%llu}}, "
+			"tx{"
+			"tcp{b=%llu, p=%llu}, "
+			"udp{b=%llu, p=%llu},"
+			"other{b=%llu, p=%llu}}}, "
+			"set1{"
+			"rx{"
+			"tcp{b=%llu, p=%llu}, "
+			"udp{b=%llu, p=%llu},"
+			"other{b=%llu, p=%llu}}, "
+			"tx{"
+			"tcp{b=%llu, p=%llu}, "
+			"udp{b=%llu, p=%llu},"
+			"other{b=%llu, p=%llu}}}}",
+			dc,
+			dc->bpc[0][IFS_RX][IFS_TCP].bytes,
+			dc->bpc[0][IFS_RX][IFS_TCP].packets,
+			dc->bpc[0][IFS_RX][IFS_UDP].bytes,
+			dc->bpc[0][IFS_RX][IFS_UDP].packets,
+			dc->bpc[0][IFS_RX][IFS_PROTO_OTHER].bytes,
+			dc->bpc[0][IFS_RX][IFS_PROTO_OTHER].packets,
+			dc->bpc[0][IFS_TX][IFS_TCP].bytes,
+			dc->bpc[0][IFS_TX][IFS_TCP].packets,
+			dc->bpc[0][IFS_TX][IFS_UDP].bytes,
+			dc->bpc[0][IFS_TX][IFS_UDP].packets,
+			dc->bpc[0][IFS_TX][IFS_PROTO_OTHER].bytes,
+			dc->bpc[0][IFS_TX][IFS_PROTO_OTHER].packets,
+			dc->bpc[1][IFS_RX][IFS_TCP].bytes,
+			dc->bpc[1][IFS_RX][IFS_TCP].packets,
+			dc->bpc[1][IFS_RX][IFS_UDP].bytes,
+			dc->bpc[1][IFS_RX][IFS_UDP].packets,
+			dc->bpc[1][IFS_RX][IFS_PROTO_OTHER].bytes,
+			dc->bpc[1][IFS_RX][IFS_PROTO_OTHER].packets,
+			dc->bpc[1][IFS_TX][IFS_TCP].bytes,
+			dc->bpc[1][IFS_TX][IFS_TCP].packets,
+			dc->bpc[1][IFS_TX][IFS_UDP].bytes,
+			dc->bpc[1][IFS_TX][IFS_UDP].packets,
+			dc->bpc[1][IFS_TX][IFS_PROTO_OTHER].bytes,
+			dc->bpc[1][IFS_TX][IFS_PROTO_OTHER].packets);
+	else
+		res = kasprintf(GFP_ATOMIC, "data_counters@%p{...}", dc);
+	_bug_on_err_or_null(res);
+	return res;
+}
+
+char *pp_tag_node(struct tag_node *tn)
+{
+	char *tag_str;
+	char *res;
+
+	if (!tn) {
+		res = kasprintf(GFP_ATOMIC, "tag_node@null{}");
+		_bug_on_err_or_null(res);
+		return res;
+	}
+	tag_str = pp_tag_t(&tn->tag);
+	res = kasprintf(GFP_ATOMIC,
+			"tag_node@%p{tag=%s}",
+			tn, tag_str);
+	_bug_on_err_or_null(res);
+	kfree(tag_str);
+	return res;
+}
+
+char *pp_tag_ref(struct tag_ref *tr)
+{
+	char *tn_str;
+	char *res;
+
+	if (!tr) {
+		res = kasprintf(GFP_ATOMIC, "tag_ref@null{}");
+		_bug_on_err_or_null(res);
+		return res;
+	}
+	tn_str = pp_tag_node(&tr->tn);
+	res = kasprintf(GFP_ATOMIC,
+			"tag_ref@%p{%s, num_sock_tags=%d}",
+			tr, tn_str, tr->num_sock_tags);
+	_bug_on_err_or_null(res);
+	kfree(tn_str);
+	return res;
+}
+
+char *pp_tag_stat(struct tag_stat *ts)
+{
+	char *tn_str;
+	char *counters_str;
+	char *parent_counters_str;
+	char *res;
+
+	if (!ts) {
+		res = kasprintf(GFP_ATOMIC, "tag_stat@null{}");
+		_bug_on_err_or_null(res);
+		return res;
+	}
+	tn_str = pp_tag_node(&ts->tn);
+	counters_str = pp_data_counters(&ts->counters, true);
+	parent_counters_str = pp_data_counters(ts->parent_counters, false);
+	res = kasprintf(GFP_ATOMIC,
+			"tag_stat@%p{%s, counters=%s, parent_counters=%s}",
+			ts, tn_str, counters_str, parent_counters_str);
+	_bug_on_err_or_null(res);
+	kfree(tn_str);
+	kfree(counters_str);
+	kfree(parent_counters_str);
+	return res;
+}
+
+char *pp_iface_stat(struct iface_stat *is)
+{
+	char *res;
+	if (!is) {
+		res = kasprintf(GFP_ATOMIC, "iface_stat@null{}");
+	} else {
+		struct data_counters *cnts = &is->totals_via_skb;
+		res = kasprintf(GFP_ATOMIC, "iface_stat@%p{"
+				"list=list_head{...}, "
+				"ifname=%s, "
+				"total_dev={rx={bytes=%llu, "
+				"packets=%llu}, "
+				"tx={bytes=%llu, "
+				"packets=%llu}}, "
+				"total_skb={rx={bytes=%llu, "
+				"packets=%llu}, "
+				"tx={bytes=%llu, "
+				"packets=%llu}}, "
+				"last_known_valid=%d, "
+				"last_known={rx={bytes=%llu, "
+				"packets=%llu}, "
+				"tx={bytes=%llu, "
+				"packets=%llu}}, "
+				"active=%d, "
+				"net_dev=%p, "
+				"proc_ptr=%p, "
+				"tag_stat_tree=rb_root{...}}",
+				is,
+				is->ifname,
+				is->totals_via_dev[IFS_RX].bytes,
+				is->totals_via_dev[IFS_RX].packets,
+				is->totals_via_dev[IFS_TX].bytes,
+				is->totals_via_dev[IFS_TX].packets,
+				dc_sum_bytes(cnts, 0, IFS_RX),
+				dc_sum_packets(cnts, 0, IFS_RX),
+				dc_sum_bytes(cnts, 0, IFS_TX),
+				dc_sum_packets(cnts, 0, IFS_TX),
+				is->last_known_valid,
+				is->last_known[IFS_RX].bytes,
+				is->last_known[IFS_RX].packets,
+				is->last_known[IFS_TX].bytes,
+				is->last_known[IFS_TX].packets,
+				is->active,
+				is->net_dev,
+				is->proc_ptr);
+	}
+	_bug_on_err_or_null(res);
+	return res;
+}
+
+char *pp_sock_tag(struct sock_tag *st)
+{
+	char *tag_str;
+	char *res;
+
+	if (!st) {
+		res = kasprintf(GFP_ATOMIC, "sock_tag@null{}");
+		_bug_on_err_or_null(res);
+		return res;
+	}
+	tag_str = pp_tag_t(&st->tag);
+	res = kasprintf(GFP_ATOMIC, "sock_tag@%p{"
+			"sock_node=rb_node{...}, "
+			"sk=%p (f_count=%d), list=list_head{...}, "
+			"pid=%u, tag=%s}",
+			st, st->sk, atomic_read(
+				&st->sk->sk_refcnt),
+			st->pid, tag_str);
+	_bug_on_err_or_null(res);
+	kfree(tag_str);
+	return res;
+}
+
+char *pp_uid_tag_data(struct uid_tag_data *utd)
+{
+	char *res;
+
+	if (!utd)
+		res = kasprintf(GFP_ATOMIC, "uid_tag_data@null{}");
+	else
+		res = kasprintf(GFP_ATOMIC, "uid_tag_data@%p{"
+				"uid=%u, num_active_acct_tags=%d, "
+				"num_pqd=%d, "
+				"tag_node_tree=rb_root{...}, "
+				"proc_qtu_data_tree=rb_root{...}}",
+				utd, utd->uid,
+				utd->num_active_tags, utd->num_pqd);
+	_bug_on_err_or_null(res);
+	return res;
+}
+
+char *pp_proc_qtu_data(struct proc_qtu_data *pqd)
+{
+	char *parent_tag_data_str;
+	char *res;
+
+	if (!pqd) {
+		res = kasprintf(GFP_ATOMIC, "proc_qtu_data@null{}");
+		_bug_on_err_or_null(res);
+		return res;
+	}
+	parent_tag_data_str = pp_uid_tag_data(pqd->parent_tag_data);
+	res = kasprintf(GFP_ATOMIC, "proc_qtu_data@%p{"
+			"node=rb_node{...}, pid=%u, "
+			"parent_tag_data=%s, "
+			"sock_tag_list=list_head{...}}",
+			pqd, pqd->pid, parent_tag_data_str
+		);
+	_bug_on_err_or_null(res);
+	kfree(parent_tag_data_str);
+	return res;
+}
+
+/*------------------------------------------*/
+void prdebug_sock_tag_tree(int indent_level,
+			   struct rb_root *sock_tag_tree)
+{
+	struct rb_node *node;
+	struct sock_tag *sock_tag_entry;
+	char *str;
+
+	if (!unlikely(qtaguid_debug_mask & DDEBUG_MASK))
+		return;
+
+	if (RB_EMPTY_ROOT(sock_tag_tree)) {
+		str = "sock_tag_tree=rb_root{}";
+		pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+		return;
+	}
+
+	str = "sock_tag_tree=rb_root{";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+	indent_level++;
+	for (node = rb_first(sock_tag_tree);
+	     node;
+	     node = rb_next(node)) {
+		sock_tag_entry = rb_entry(node, struct sock_tag, sock_node);
+		str = pp_sock_tag(sock_tag_entry);
+		pr_debug("%*d: %s,\n", indent_level*2, indent_level, str);
+		kfree(str);
+	}
+	indent_level--;
+	str = "}";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+}
+
+void prdebug_sock_tag_list(int indent_level,
+			   struct list_head *sock_tag_list)
+{
+	struct sock_tag *sock_tag_entry;
+	char *str;
+
+	if (!unlikely(qtaguid_debug_mask & DDEBUG_MASK))
+		return;
+
+	if (list_empty(sock_tag_list)) {
+		str = "sock_tag_list=list_head{}";
+		pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+		return;
+	}
+
+	str = "sock_tag_list=list_head{";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+	indent_level++;
+	list_for_each_entry(sock_tag_entry, sock_tag_list, list) {
+		str = pp_sock_tag(sock_tag_entry);
+		pr_debug("%*d: %s,\n", indent_level*2, indent_level, str);
+		kfree(str);
+	}
+	indent_level--;
+	str = "}";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+}
+
+void prdebug_proc_qtu_data_tree(int indent_level,
+				struct rb_root *proc_qtu_data_tree)
+{
+	char *str;
+	struct rb_node *node;
+	struct proc_qtu_data *proc_qtu_data_entry;
+
+	if (!unlikely(qtaguid_debug_mask & DDEBUG_MASK))
+		return;
+
+	if (RB_EMPTY_ROOT(proc_qtu_data_tree)) {
+		str = "proc_qtu_data_tree=rb_root{}";
+		pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+		return;
+	}
+
+	str = "proc_qtu_data_tree=rb_root{";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+	indent_level++;
+	for (node = rb_first(proc_qtu_data_tree);
+	     node;
+	     node = rb_next(node)) {
+		proc_qtu_data_entry = rb_entry(node,
+					       struct proc_qtu_data,
+					       node);
+		str = pp_proc_qtu_data(proc_qtu_data_entry);
+		pr_debug("%*d: %s,\n", indent_level*2, indent_level,
+			 str);
+		kfree(str);
+		indent_level++;
+		prdebug_sock_tag_list(indent_level,
+				      &proc_qtu_data_entry->sock_tag_list);
+		indent_level--;
+
+	}
+	indent_level--;
+	str = "}";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+}
+
+void prdebug_tag_ref_tree(int indent_level, struct rb_root *tag_ref_tree)
+{
+	char *str;
+	struct rb_node *node;
+	struct tag_ref *tag_ref_entry;
+
+	if (!unlikely(qtaguid_debug_mask & DDEBUG_MASK))
+		return;
+
+	if (RB_EMPTY_ROOT(tag_ref_tree)) {
+		str = "tag_ref_tree{}";
+		pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+		return;
+	}
+
+	str = "tag_ref_tree{";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+	indent_level++;
+	for (node = rb_first(tag_ref_tree);
+	     node;
+	     node = rb_next(node)) {
+		tag_ref_entry = rb_entry(node,
+					 struct tag_ref,
+					 tn.node);
+		str = pp_tag_ref(tag_ref_entry);
+		pr_debug("%*d: %s,\n", indent_level*2, indent_level,
+			 str);
+		kfree(str);
+	}
+	indent_level--;
+	str = "}";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+}
+
+void prdebug_uid_tag_data_tree(int indent_level,
+			       struct rb_root *uid_tag_data_tree)
+{
+	char *str;
+	struct rb_node *node;
+	struct uid_tag_data *uid_tag_data_entry;
+
+	if (!unlikely(qtaguid_debug_mask & DDEBUG_MASK))
+		return;
+
+	if (RB_EMPTY_ROOT(uid_tag_data_tree)) {
+		str = "uid_tag_data_tree=rb_root{}";
+		pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+		return;
+	}
+
+	str = "uid_tag_data_tree=rb_root{";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+	indent_level++;
+	for (node = rb_first(uid_tag_data_tree);
+	     node;
+	     node = rb_next(node)) {
+		uid_tag_data_entry = rb_entry(node, struct uid_tag_data,
+					      node);
+		str = pp_uid_tag_data(uid_tag_data_entry);
+		pr_debug("%*d: %s,\n", indent_level*2, indent_level, str);
+		kfree(str);
+		if (!RB_EMPTY_ROOT(&uid_tag_data_entry->tag_ref_tree)) {
+			indent_level++;
+			prdebug_tag_ref_tree(indent_level,
+					     &uid_tag_data_entry->tag_ref_tree);
+			indent_level--;
+		}
+	}
+	indent_level--;
+	str = "}";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+}
+
+void prdebug_tag_stat_tree(int indent_level,
+				  struct rb_root *tag_stat_tree)
+{
+	char *str;
+	struct rb_node *node;
+	struct tag_stat *ts_entry;
+
+	if (!unlikely(qtaguid_debug_mask & DDEBUG_MASK))
+		return;
+
+	if (RB_EMPTY_ROOT(tag_stat_tree)) {
+		str = "tag_stat_tree{}";
+		pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+		return;
+	}
+
+	str = "tag_stat_tree{";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+	indent_level++;
+	for (node = rb_first(tag_stat_tree);
+	     node;
+	     node = rb_next(node)) {
+		ts_entry = rb_entry(node, struct tag_stat, tn.node);
+		str = pp_tag_stat(ts_entry);
+		pr_debug("%*d: %s\n", indent_level*2, indent_level,
+			 str);
+		kfree(str);
+	}
+	indent_level--;
+	str = "}";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+}
+
+void prdebug_iface_stat_list(int indent_level,
+			     struct list_head *iface_stat_list)
+{
+	char *str;
+	struct iface_stat *iface_entry;
+
+	if (!unlikely(qtaguid_debug_mask & DDEBUG_MASK))
+		return;
+
+	if (list_empty(iface_stat_list)) {
+		str = "iface_stat_list=list_head{}";
+		pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+		return;
+	}
+
+	str = "iface_stat_list=list_head{";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+	indent_level++;
+	list_for_each_entry(iface_entry, iface_stat_list, list) {
+		str = pp_iface_stat(iface_entry);
+		pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+		kfree(str);
+
+		spin_lock_bh(&iface_entry->tag_stat_list_lock);
+		if (!RB_EMPTY_ROOT(&iface_entry->tag_stat_tree)) {
+			indent_level++;
+			prdebug_tag_stat_tree(indent_level,
+					      &iface_entry->tag_stat_tree);
+			indent_level--;
+		}
+		spin_unlock_bh(&iface_entry->tag_stat_list_lock);
+	}
+	indent_level--;
+	str = "}";
+	pr_debug("%*d: %s\n", indent_level*2, indent_level, str);
+}
+
+#endif  /* ifdef DDEBUG */
+/*------------------------------------------*/
+static const char * const netdev_event_strings[] = {
+	"netdev_unknown",
+	"NETDEV_UP",
+	"NETDEV_DOWN",
+	"NETDEV_REBOOT",
+	"NETDEV_CHANGE",
+	"NETDEV_REGISTER",
+	"NETDEV_UNREGISTER",
+	"NETDEV_CHANGEMTU",
+	"NETDEV_CHANGEADDR",
+	"NETDEV_GOING_DOWN",
+	"NETDEV_CHANGENAME",
+	"NETDEV_FEAT_CHANGE",
+	"NETDEV_BONDING_FAILOVER",
+	"NETDEV_PRE_UP",
+	"NETDEV_PRE_TYPE_CHANGE",
+	"NETDEV_POST_TYPE_CHANGE",
+	"NETDEV_POST_INIT",
+	"NETDEV_UNREGISTER_BATCH",
+	"NETDEV_RELEASE",
+	"NETDEV_NOTIFY_PEERS",
+	"NETDEV_JOIN",
+};
+
+const char *netdev_evt_str(int netdev_event)
+{
+	if (netdev_event < 0
+	    || netdev_event >= ARRAY_SIZE(netdev_event_strings))
+		return "bad event num";
+	return netdev_event_strings[netdev_event];
+}
diff --git a/net/netfilter/xt_qtaguid_print.h b/net/netfilter/xt_qtaguid_print.h
new file mode 100644
index 00000000..b63871a
--- /dev/null
+++ b/net/netfilter/xt_qtaguid_print.h
@@ -0,0 +1,120 @@
+/*
+ * Pretty printing Support for iptables xt_qtaguid module.
+ *
+ * (C) 2011 Google, Inc
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#ifndef __XT_QTAGUID_PRINT_H__
+#define __XT_QTAGUID_PRINT_H__
+
+#include "xt_qtaguid_internal.h"
+
+#ifdef DDEBUG
+
+char *pp_tag_t(tag_t *tag);
+char *pp_data_counters(struct data_counters *dc, bool showValues);
+char *pp_tag_node(struct tag_node *tn);
+char *pp_tag_ref(struct tag_ref *tr);
+char *pp_tag_stat(struct tag_stat *ts);
+char *pp_iface_stat(struct iface_stat *is);
+char *pp_sock_tag(struct sock_tag *st);
+char *pp_uid_tag_data(struct uid_tag_data *qtd);
+char *pp_proc_qtu_data(struct proc_qtu_data *pqd);
+
+/*------------------------------------------*/
+void prdebug_sock_tag_list(int indent_level,
+			   struct list_head *sock_tag_list);
+void prdebug_sock_tag_tree(int indent_level,
+			   struct rb_root *sock_tag_tree);
+void prdebug_proc_qtu_data_tree(int indent_level,
+				struct rb_root *proc_qtu_data_tree);
+void prdebug_tag_ref_tree(int indent_level, struct rb_root *tag_ref_tree);
+void prdebug_uid_tag_data_tree(int indent_level,
+			       struct rb_root *uid_tag_data_tree);
+void prdebug_tag_stat_tree(int indent_level,
+			   struct rb_root *tag_stat_tree);
+void prdebug_iface_stat_list(int indent_level,
+			     struct list_head *iface_stat_list);
+
+#else
+
+/*------------------------------------------*/
+static inline char *pp_tag_t(tag_t *tag)
+{
+	return NULL;
+}
+static inline char *pp_data_counters(struct data_counters *dc, bool showValues)
+{
+	return NULL;
+}
+static inline char *pp_tag_node(struct tag_node *tn)
+{
+	return NULL;
+}
+static inline char *pp_tag_ref(struct tag_ref *tr)
+{
+	return NULL;
+}
+static inline char *pp_tag_stat(struct tag_stat *ts)
+{
+	return NULL;
+}
+static inline char *pp_iface_stat(struct iface_stat *is)
+{
+	return NULL;
+}
+static inline char *pp_sock_tag(struct sock_tag *st)
+{
+	return NULL;
+}
+static inline char *pp_uid_tag_data(struct uid_tag_data *qtd)
+{
+	return NULL;
+}
+static inline char *pp_proc_qtu_data(struct proc_qtu_data *pqd)
+{
+	return NULL;
+}
+
+/*------------------------------------------*/
+static inline
+void prdebug_sock_tag_list(int indent_level,
+			   struct list_head *sock_tag_list)
+{
+}
+static inline
+void prdebug_sock_tag_tree(int indent_level,
+			   struct rb_root *sock_tag_tree)
+{
+}
+static inline
+void prdebug_proc_qtu_data_tree(int indent_level,
+				struct rb_root *proc_qtu_data_tree)
+{
+}
+static inline
+void prdebug_tag_ref_tree(int indent_level, struct rb_root *tag_ref_tree)
+{
+}
+static inline
+void prdebug_uid_tag_data_tree(int indent_level,
+			       struct rb_root *uid_tag_data_tree)
+{
+}
+static inline
+void prdebug_tag_stat_tree(int indent_level,
+			   struct rb_root *tag_stat_tree)
+{
+}
+static inline
+void prdebug_iface_stat_list(int indent_level,
+			     struct list_head *iface_stat_list)
+{
+}
+#endif
+/*------------------------------------------*/
+const char *netdev_evt_str(int netdev_event);
+#endif  /* ifndef __XT_QTAGUID_PRINT_H__ */
diff --git a/net/netfilter/xt_quota2.c b/net/netfilter/xt_quota2.c
new file mode 100644
index 00000000..834594a
--- /dev/null
+++ b/net/netfilter/xt_quota2.c
@@ -0,0 +1,401 @@
+/*
+ * xt_quota2 - enhanced xt_quota that can count upwards and in packets
+ * as a minimal accounting match.
+ * by Jan Engelhardt <jengelh@medozas.de>, 2008
+ *
+ * Originally based on xt_quota.c:
+ * 	netfilter module to enforce network quotas
+ * 	Sam Johnston <samj@samj.net>
+ *
+ *	This program is free software; you can redistribute it and/or modify
+ *	it under the terms of the GNU General Public License; either
+ *	version 2 of the License, as published by the Free Software Foundation.
+ */
+#include <linux/list.h>
+#include <linux/module.h>
+#include <linux/proc_fs.h>
+#include <linux/skbuff.h>
+#include <linux/spinlock.h>
+#include <asm/atomic.h>
+#include <net/netlink.h>
+
+#include <linux/netfilter/x_tables.h>
+#include <linux/netfilter/xt_quota2.h>
+
+#ifdef CONFIG_NETFILTER_XT_MATCH_QUOTA2_LOG
+/* For compatibility, these definitions are copied from the
+ * deprecated header file <linux/netfilter_ipv4/ipt_ULOG.h> */
+#define ULOG_MAC_LEN	80
+#define ULOG_PREFIX_LEN	32
+
+/* Format of the ULOG packets passed through netlink */
+typedef struct ulog_packet_msg {
+	unsigned long mark;
+	long timestamp_sec;
+	long timestamp_usec;
+	unsigned int hook;
+	char indev_name[IFNAMSIZ];
+	char outdev_name[IFNAMSIZ];
+	size_t data_len;
+	char prefix[ULOG_PREFIX_LEN];
+	unsigned char mac_len;
+	unsigned char mac[ULOG_MAC_LEN];
+	unsigned char payload[0];
+} ulog_packet_msg_t;
+#endif
+
+/**
+ * @lock:	lock to protect quota writers from each other
+ */
+struct xt_quota_counter {
+	u_int64_t quota;
+	spinlock_t lock;
+	struct list_head list;
+	atomic_t ref;
+	char name[sizeof(((struct xt_quota_mtinfo2 *)NULL)->name)];
+	struct proc_dir_entry *procfs_entry;
+};
+
+#ifdef CONFIG_NETFILTER_XT_MATCH_QUOTA2_LOG
+/* Harald's favorite number +1 :D From ipt_ULOG.C */
+static int qlog_nl_event = 112;
+module_param_named(event_num, qlog_nl_event, uint, S_IRUGO | S_IWUSR);
+MODULE_PARM_DESC(event_num,
+		 "Event number for NETLINK_NFLOG message. 0 disables log."
+		 "111 is what ipt_ULOG uses.");
+static struct sock *nflognl;
+#endif
+
+static LIST_HEAD(counter_list);
+static DEFINE_SPINLOCK(counter_list_lock);
+
+static struct proc_dir_entry *proc_xt_quota;
+static unsigned int quota_list_perms = S_IRUGO | S_IWUSR;
+static kuid_t quota_list_uid = KUIDT_INIT(0);
+static kgid_t quota_list_gid = KGIDT_INIT(0);
+module_param_named(perms, quota_list_perms, uint, S_IRUGO | S_IWUSR);
+
+#ifdef CONFIG_NETFILTER_XT_MATCH_QUOTA2_LOG
+static void quota2_log(unsigned int hooknum,
+		       const struct sk_buff *skb,
+		       const struct net_device *in,
+		       const struct net_device *out,
+		       const char *prefix)
+{
+	ulog_packet_msg_t *pm;
+	struct sk_buff *log_skb;
+	size_t size;
+	struct nlmsghdr *nlh;
+
+	if (!qlog_nl_event)
+		return;
+
+	size = NLMSG_SPACE(sizeof(*pm));
+	size = max(size, (size_t)NLMSG_GOODSIZE);
+	log_skb = alloc_skb(size, GFP_ATOMIC);
+	if (!log_skb) {
+		pr_err("xt_quota2: cannot alloc skb for logging\n");
+		return;
+	}
+
+	nlh = nlmsg_put(log_skb, /*pid*/0, /*seq*/0, qlog_nl_event,
+			sizeof(*pm), 0);
+	if (!nlh) {
+		pr_err("xt_quota2: nlmsg_put failed\n");
+		kfree_skb(log_skb);
+		return;
+	}
+	pm = nlmsg_data(nlh);
+	if (skb->tstamp.tv64 == 0)
+		__net_timestamp((struct sk_buff *)skb);
+	pm->data_len = 0;
+	pm->hook = hooknum;
+	if (prefix != NULL)
+		strlcpy(pm->prefix, prefix, sizeof(pm->prefix));
+	else
+		*(pm->prefix) = '\0';
+	if (in)
+		strlcpy(pm->indev_name, in->name, sizeof(pm->indev_name));
+	else
+		pm->indev_name[0] = '\0';
+
+	if (out)
+		strlcpy(pm->outdev_name, out->name, sizeof(pm->outdev_name));
+	else
+		pm->outdev_name[0] = '\0';
+
+	NETLINK_CB(log_skb).dst_group = 1;
+	pr_debug("throwing 1 packets to netlink group 1\n");
+	netlink_broadcast(nflognl, log_skb, 0, 1, GFP_ATOMIC);
+}
+#else
+static void quota2_log(unsigned int hooknum,
+		       const struct sk_buff *skb,
+		       const struct net_device *in,
+		       const struct net_device *out,
+		       const char *prefix)
+{
+}
+#endif  /* if+else CONFIG_NETFILTER_XT_MATCH_QUOTA2_LOG */
+
+static ssize_t quota_proc_read(struct file *file, char __user *buf,
+			   size_t size, loff_t *ppos)
+{
+	struct xt_quota_counter *e = PDE_DATA(file_inode(file));
+	char tmp[24];
+	size_t tmp_size;
+
+	spin_lock_bh(&e->lock);
+	tmp_size = scnprintf(tmp, sizeof(tmp), "%llu\n", e->quota);
+	spin_unlock_bh(&e->lock);
+	return simple_read_from_buffer(buf, size, ppos, tmp, tmp_size);
+}
+
+static ssize_t quota_proc_write(struct file *file, const char __user *input,
+                            size_t size, loff_t *ppos)
+{
+	struct xt_quota_counter *e = PDE_DATA(file_inode(file));
+	char buf[sizeof("18446744073709551616")];
+
+	if (size > sizeof(buf))
+		size = sizeof(buf);
+	if (copy_from_user(buf, input, size) != 0)
+		return -EFAULT;
+	buf[sizeof(buf)-1] = '\0';
+
+	spin_lock_bh(&e->lock);
+	e->quota = simple_strtoull(buf, NULL, 0);
+	spin_unlock_bh(&e->lock);
+	return size;
+}
+
+static const struct file_operations q2_counter_fops = {
+	.read		= quota_proc_read,
+	.write		= quota_proc_write,
+	.llseek		= default_llseek,
+};
+
+static struct xt_quota_counter *
+q2_new_counter(const struct xt_quota_mtinfo2 *q, bool anon)
+{
+	struct xt_quota_counter *e;
+	unsigned int size;
+
+	/* Do not need all the procfs things for anonymous counters. */
+	size = anon ? offsetof(typeof(*e), list) : sizeof(*e);
+	e = kmalloc(size, GFP_KERNEL);
+	if (e == NULL)
+		return NULL;
+
+	e->quota = q->quota;
+	spin_lock_init(&e->lock);
+	if (!anon) {
+		INIT_LIST_HEAD(&e->list);
+		atomic_set(&e->ref, 1);
+		strlcpy(e->name, q->name, sizeof(e->name));
+	}
+	return e;
+}
+
+/**
+ * q2_get_counter - get ref to counter or create new
+ * @name:	name of counter
+ */
+static struct xt_quota_counter *
+q2_get_counter(const struct xt_quota_mtinfo2 *q)
+{
+	struct proc_dir_entry *p;
+	struct xt_quota_counter *e = NULL;
+	struct xt_quota_counter *new_e;
+
+	if (*q->name == '\0')
+		return q2_new_counter(q, true);
+
+	/* No need to hold a lock while getting a new counter */
+	new_e = q2_new_counter(q, false);
+	if (new_e == NULL)
+		goto out;
+
+	spin_lock_bh(&counter_list_lock);
+	list_for_each_entry(e, &counter_list, list)
+		if (strcmp(e->name, q->name) == 0) {
+			atomic_inc(&e->ref);
+			spin_unlock_bh(&counter_list_lock);
+			kfree(new_e);
+			pr_debug("xt_quota2: old counter name=%s", e->name);
+			return e;
+		}
+	e = new_e;
+	pr_debug("xt_quota2: new_counter name=%s", e->name);
+	list_add_tail(&e->list, &counter_list);
+	/* The entry having a refcount of 1 is not directly destructible.
+	 * This func has not yet returned the new entry, thus iptables
+	 * has not references for destroying this entry.
+	 * For another rule to try to destroy it, it would 1st need for this
+	 * func* to be re-invoked, acquire a new ref for the same named quota.
+	 * Nobody will access the e->procfs_entry either.
+	 * So release the lock. */
+	spin_unlock_bh(&counter_list_lock);
+
+	/* create_proc_entry() is not spin_lock happy */
+	p = e->procfs_entry = proc_create_data(e->name, quota_list_perms,
+	                      proc_xt_quota, &q2_counter_fops, e);
+
+	if (IS_ERR_OR_NULL(p)) {
+		spin_lock_bh(&counter_list_lock);
+		list_del(&e->list);
+		spin_unlock_bh(&counter_list_lock);
+		goto out;
+	}
+	proc_set_user(p, quota_list_uid, quota_list_gid);
+	return e;
+
+ out:
+	kfree(e);
+	return NULL;
+}
+
+static int quota_mt2_check(const struct xt_mtchk_param *par)
+{
+	struct xt_quota_mtinfo2 *q = par->matchinfo;
+
+	pr_debug("xt_quota2: check() flags=0x%04x", q->flags);
+
+	if (q->flags & ~XT_QUOTA_MASK)
+		return -EINVAL;
+
+	q->name[sizeof(q->name)-1] = '\0';
+	if (*q->name == '.' || strchr(q->name, '/') != NULL) {
+		printk(KERN_ERR "xt_quota.3: illegal name\n");
+		return -EINVAL;
+	}
+
+	q->master = q2_get_counter(q);
+	if (q->master == NULL) {
+		printk(KERN_ERR "xt_quota.3: memory alloc failure\n");
+		return -ENOMEM;
+	}
+
+	return 0;
+}
+
+static void quota_mt2_destroy(const struct xt_mtdtor_param *par)
+{
+	struct xt_quota_mtinfo2 *q = par->matchinfo;
+	struct xt_quota_counter *e = q->master;
+
+	if (*q->name == '\0') {
+		kfree(e);
+		return;
+	}
+
+	spin_lock_bh(&counter_list_lock);
+	if (!atomic_dec_and_test(&e->ref)) {
+		spin_unlock_bh(&counter_list_lock);
+		return;
+	}
+
+	list_del(&e->list);
+	remove_proc_entry(e->name, proc_xt_quota);
+	spin_unlock_bh(&counter_list_lock);
+	kfree(e);
+}
+
+static bool
+quota_mt2(const struct sk_buff *skb, struct xt_action_param *par)
+{
+	struct xt_quota_mtinfo2 *q = (void *)par->matchinfo;
+	struct xt_quota_counter *e = q->master;
+	bool ret = q->flags & XT_QUOTA_INVERT;
+
+	spin_lock_bh(&e->lock);
+	if (q->flags & XT_QUOTA_GROW) {
+		/*
+		 * While no_change is pointless in "grow" mode, we will
+		 * implement it here simply to have a consistent behavior.
+		 */
+		if (!(q->flags & XT_QUOTA_NO_CHANGE)) {
+			e->quota += (q->flags & XT_QUOTA_PACKET) ? 1 : skb->len;
+		}
+		ret = true;
+	} else {
+		if (e->quota >= skb->len) {
+			if (!(q->flags & XT_QUOTA_NO_CHANGE))
+				e->quota -= (q->flags & XT_QUOTA_PACKET) ? 1 : skb->len;
+			ret = !ret;
+		} else {
+			/* We are transitioning, log that fact. */
+			if (e->quota) {
+				quota2_log(par->hooknum,
+					   skb,
+					   par->in,
+					   par->out,
+					   q->name);
+			}
+			/* we do not allow even small packets from now on */
+			e->quota = 0;
+		}
+	}
+	spin_unlock_bh(&e->lock);
+	return ret;
+}
+
+static struct xt_match quota_mt2_reg[] __read_mostly = {
+	{
+		.name       = "quota2",
+		.revision   = 3,
+		.family     = NFPROTO_IPV4,
+		.checkentry = quota_mt2_check,
+		.match      = quota_mt2,
+		.destroy    = quota_mt2_destroy,
+		.matchsize  = sizeof(struct xt_quota_mtinfo2),
+		.me         = THIS_MODULE,
+	},
+	{
+		.name       = "quota2",
+		.revision   = 3,
+		.family     = NFPROTO_IPV6,
+		.checkentry = quota_mt2_check,
+		.match      = quota_mt2,
+		.destroy    = quota_mt2_destroy,
+		.matchsize  = sizeof(struct xt_quota_mtinfo2),
+		.me         = THIS_MODULE,
+	},
+};
+
+static int __init quota_mt2_init(void)
+{
+	int ret;
+	pr_debug("xt_quota2: init()");
+
+#ifdef CONFIG_NETFILTER_XT_MATCH_QUOTA2_LOG
+	nflognl = netlink_kernel_create(&init_net, NETLINK_NFLOG, NULL);
+	if (!nflognl)
+		return -ENOMEM;
+#endif
+
+	proc_xt_quota = proc_mkdir("xt_quota", init_net.proc_net);
+	if (proc_xt_quota == NULL)
+		return -EACCES;
+
+	ret = xt_register_matches(quota_mt2_reg, ARRAY_SIZE(quota_mt2_reg));
+	if (ret < 0)
+		remove_proc_entry("xt_quota", init_net.proc_net);
+	pr_debug("xt_quota2: init() %d", ret);
+	return ret;
+}
+
+static void __exit quota_mt2_exit(void)
+{
+	xt_unregister_matches(quota_mt2_reg, ARRAY_SIZE(quota_mt2_reg));
+	remove_proc_entry("xt_quota", init_net.proc_net);
+}
+
+module_init(quota_mt2_init);
+module_exit(quota_mt2_exit);
+MODULE_DESCRIPTION("Xtables: countdown quota match; up counter");
+MODULE_AUTHOR("Sam Johnston <samj@samj.net>");
+MODULE_AUTHOR("Jan Engelhardt <jengelh@medozas.de>");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("ipt_quota2");
+MODULE_ALIAS("ip6t_quota2");
diff --git a/net/netfilter/xt_socket.c b/net/netfilter/xt_socket.c
index b10ade2..a52fbaf5 100644
--- a/net/netfilter/xt_socket.c
+++ b/net/netfilter/xt_socket.c
@@ -144,13 +144,14 @@ static bool xt_socket_sk_is_transparent(struct sock *sk)
 	}
 }
 
-static struct sock *xt_socket_lookup_slow_v4(struct net *net,
+struct sock *xt_socket_lookup_slow_v4(struct net *net,
 					     const struct sk_buff *skb,
 					     const struct net_device *indev)
 {
 	const struct iphdr *iph = ip_hdr(skb);
 	struct sk_buff *data_skb = NULL;
 	int doff = 0;
+	struct sock *sk = skb->sk;
 	__be32 uninitialized_var(daddr), uninitialized_var(saddr);
 	__be16 uninitialized_var(dport), uninitialized_var(sport);
 	u8 uninitialized_var(protocol);
@@ -205,9 +206,16 @@ static struct sock *xt_socket_lookup_slow_v4(struct net *net,
 	}
 #endif
 
-	return xt_socket_get_sock_v4(net, data_skb, doff, protocol, saddr,
-				     daddr, sport, dport, indev);
+	if (sk)
+		atomic_inc(&sk->sk_refcnt);
+	else
+		sk = xt_socket_get_sock_v4(dev_net(skb->dev), data_skb, doff,
+					   protocol, saddr, daddr, sport,
+					   dport, indev);
+
+	return sk;
 }
+EXPORT_SYMBOL(xt_socket_lookup_slow_v4);
 
 static bool
 socket_match(const struct sk_buff *skb, struct xt_action_param *par,
@@ -239,8 +247,7 @@ static struct sock *xt_socket_lookup_slow_v4(struct net *net,
 		    transparent)
 			pskb->mark = sk->sk_mark;
 
-		if (sk != skb->sk)
-			sock_gen_put(sk);
+		sock_gen_put(sk);
 
 		if (wildcard || !transparent)
 			sk = NULL;
@@ -344,10 +351,11 @@ static struct sock *xt_socket_lookup_slow_v4(struct net *net,
 	return NULL;
 }
 
-static struct sock *xt_socket_lookup_slow_v6(struct net *net,
+struct sock *xt_socket_lookup_slow_v6(struct net *net,
 					     const struct sk_buff *skb,
 					     const struct net_device *indev)
 {
+	struct sock *sk = skb->sk;
 	__be16 uninitialized_var(dport), uninitialized_var(sport);
 	const struct in6_addr *daddr = NULL, *saddr = NULL;
 	struct ipv6hdr *iph = ipv6_hdr(skb);
@@ -387,9 +395,16 @@ static struct sock *xt_socket_lookup_slow_v6(struct net *net,
 		return NULL;
 	}
 
-	return xt_socket_get_sock_v6(net, data_skb, doff, tproto, saddr, daddr,
-				     sport, dport, indev);
+	if (sk)
+		atomic_inc(&sk->sk_refcnt);
+	else
+		sk = xt_socket_get_sock_v6(dev_net(skb->dev), data_skb, doff,
+					   tproto, saddr, daddr, sport, dport,
+					   indev);
+
+	return sk;
 }
+EXPORT_SYMBOL(xt_socket_lookup_slow_v6);
 
 static bool
 socket_mt6_v1_v2_v3(const struct sk_buff *skb, struct xt_action_param *par)
diff --git a/net/netlink/af_netlink.c b/net/netlink/af_netlink.c
index 0254874..46dfea7 100644
--- a/net/netlink/af_netlink.c
+++ b/net/netlink/af_netlink.c
@@ -2705,3 +2705,53 @@ static int __init netlink_proto_init(void)
 }
 
 core_initcall(netlink_proto_init);
+
+#if defined(CONFIG_RTL_819X)
+int rtk_nlrecvmsg(struct sk_buff *skb,int _len, void *_recv_data)
+{
+	int pid;
+	struct nlmsghdr *nlh;
+
+	pid = 0;
+
+	if (skb->len >= NLMSG_SPACE(0)) {
+		nlh = nlmsg_hdr(skb);
+		memcpy(_recv_data, NLMSG_DATA(nlh), _len);
+		pid = nlh->nlmsg_pid; /*pid of sending process */
+		return pid;
+	}
+	else
+	{
+		return -1;
+	}
+}
+EXPORT_SYMBOL(rtk_nlrecvmsg);
+
+int rtk_nlsendmsg(int _pid,struct sock *_nl_sk,int _len,void *_send_info)
+{
+	struct nlmsghdr *nlh;
+	struct sk_buff *skb;
+	int rc;
+	int len;
+
+	len = NLMSG_SPACE(_len + sizeof(struct nlmsghdr) + 32);
+
+	skb = alloc_skb(len, GFP_ATOMIC);
+	if (!skb){
+		printk(KERN_ERR "net_link: allocate failed.\n");
+		return -1;
+	}
+	nlh = nlmsg_put(skb, 0, 0, 0, len, 0);
+	NETLINK_CB(skb).portid = 0; /* from kernel */
+
+	memcpy(NLMSG_DATA(nlh), _send_info, _len);
+	rc = netlink_unicast(_nl_sk, skb, _pid, MSG_DONTWAIT);
+	if (rc < 0) {
+		printk(KERN_ERR "net_link: can not unicast skb (%d)\n", rc);
+	}
+	return 0;
+}
+EXPORT_SYMBOL(rtk_nlsendmsg);
+#endif /* CONFIG_RTL_819X */
+
+
diff --git a/net/nfc/hci/core.c b/net/nfc/hci/core.c
index 2b0f0ac..5a58f9f 100644
--- a/net/nfc/hci/core.c
+++ b/net/nfc/hci/core.c
@@ -209,6 +209,11 @@ void nfc_hci_cmd_received(struct nfc_hci_dev *hdev, u8 pipe, u8 cmd,
 		}
 		create_info = (struct hci_create_pipe_resp *)skb->data;
 
+		if (create_info->pipe >= NFC_HCI_MAX_PIPES) {
+			status = NFC_HCI_ANY_E_NOK;
+			goto exit;
+		}
+
 		/* Save the new created pipe and bind with local gate,
 		 * the description for skb->data[3] is destination gate id
 		 * but since we received this cmd from host controller, we
@@ -232,6 +237,11 @@ void nfc_hci_cmd_received(struct nfc_hci_dev *hdev, u8 pipe, u8 cmd,
 		}
 		delete_info = (struct hci_delete_pipe_noti *)skb->data;
 
+		if (delete_info->pipe >= NFC_HCI_MAX_PIPES) {
+			status = NFC_HCI_ANY_E_NOK;
+			goto exit;
+		}
+
 		hdev->pipes[delete_info->pipe].gate = NFC_HCI_INVALID_GATE;
 		hdev->pipes[delete_info->pipe].dest_host = NFC_HCI_INVALID_HOST;
 		break;
diff --git a/net/rfkill/Kconfig b/net/rfkill/Kconfig
index 868f1ad..8463a6d 100644
--- a/net/rfkill/Kconfig
+++ b/net/rfkill/Kconfig
@@ -10,6 +10,11 @@ menuconfig RFKILL
 	  To compile this driver as a module, choose M here: the
 	  module will be called rfkill.
 
+config RFKILL_PM
+	bool "Power off on suspend"
+	depends on RFKILL && PM
+	default y
+
 # LED trigger support
 config RFKILL_LEDS
 	bool
diff --git a/net/rfkill/core.c b/net/rfkill/core.c
index 884027f..a9a7128 100644
--- a/net/rfkill/core.c
+++ b/net/rfkill/core.c
@@ -796,8 +796,7 @@ void rfkill_resume_polling(struct rfkill *rfkill)
 }
 EXPORT_SYMBOL(rfkill_resume_polling);
 
-#ifdef CONFIG_PM_SLEEP
-static int rfkill_suspend(struct device *dev)
+static __maybe_unused int rfkill_suspend(struct device *dev)
 {
 	struct rfkill *rfkill = to_rfkill(dev);
 
@@ -807,7 +806,7 @@ static int rfkill_suspend(struct device *dev)
 	return 0;
 }
 
-static int rfkill_resume(struct device *dev)
+static __maybe_unused int rfkill_resume(struct device *dev)
 {
 	struct rfkill *rfkill = to_rfkill(dev);
 	bool cur;
@@ -827,17 +826,13 @@ static int rfkill_resume(struct device *dev)
 }
 
 static SIMPLE_DEV_PM_OPS(rfkill_pm_ops, rfkill_suspend, rfkill_resume);
-#define RFKILL_PM_OPS (&rfkill_pm_ops)
-#else
-#define RFKILL_PM_OPS NULL
-#endif
 
 static struct class rfkill_class = {
 	.name		= "rfkill",
 	.dev_release	= rfkill_release,
 	.dev_groups	= rfkill_dev_groups,
 	.dev_uevent	= rfkill_dev_uevent,
-	.pm		= RFKILL_PM_OPS,
+	.pm		= IS_ENABLED(CONFIG_RFKILL_PM) ? &rfkill_pm_ops : NULL,
 };
 
 bool rfkill_blocked(struct rfkill *rfkill)
diff --git a/net/socket.c b/net/socket.c
index 35fa349b..ded4402 100644
--- a/net/socket.c
+++ b/net/socket.c
@@ -534,8 +534,22 @@ static ssize_t sockfs_listxattr(struct dentry *dentry, char *buffer,
 	return used;
 }
 
+static int sockfs_setattr(struct dentry *dentry, struct iattr *iattr)
+{
+	int err = simple_setattr(dentry, iattr);
+
+	if (!err && (iattr->ia_valid & ATTR_UID)) {
+		struct socket *sock = SOCKET_I(d_inode(dentry));
+
+		sock->sk->sk_uid = iattr->ia_uid;
+	}
+
+	return err;
+}
+
 static const struct inode_operations sockfs_inode_ops = {
 	.listxattr = sockfs_listxattr,
+	.setattr = sockfs_setattr,
 };
 
 /**
diff --git a/net/sunrpc/svc.c b/net/sunrpc/svc.c
index 272c345..b43818c 100644
--- a/net/sunrpc/svc.c
+++ b/net/sunrpc/svc.c
@@ -50,7 +50,7 @@ struct svc_pool_map svc_pool_map = {
 static DEFINE_MUTEX(svc_pool_map_mutex);/* protects svc_pool_map.count only */
 
 static int
-param_set_pool_mode(const char *val, struct kernel_param *kp)
+param_set_pool_mode(const char *val, const struct kernel_param *kp)
 {
 	int *ip = (int *)kp->arg;
 	struct svc_pool_map *m = &svc_pool_map;
@@ -80,7 +80,7 @@ struct svc_pool_map svc_pool_map = {
 }
 
 static int
-param_get_pool_mode(char *buf, struct kernel_param *kp)
+param_get_pool_mode(char *buf, const struct kernel_param *kp)
 {
 	int *ip = (int *)kp->arg;
 
diff --git a/net/wireless/scan.c b/net/wireless/scan.c
index 35ad69f..e318878 100644
--- a/net/wireless/scan.c
+++ b/net/wireless/scan.c
@@ -70,7 +70,7 @@
 MODULE_PARM_DESC(bss_entries_limit,
                  "limit to number of scan BSS entries (per wiphy, default 1000)");
 
-#define IEEE80211_SCAN_RESULT_EXPIRE	(30 * HZ)
+#define IEEE80211_SCAN_RESULT_EXPIRE	(7 * HZ)
 
 static void bss_free(struct cfg80211_internal_bss *bss)
 {
diff --git a/net/xfrm/xfrm_algo.c b/net/xfrm/xfrm_algo.c
index 44ac85f..d0ca0db 100644
--- a/net/xfrm/xfrm_algo.c
+++ b/net/xfrm/xfrm_algo.c
@@ -241,7 +241,7 @@
 
 	.uinfo = {
 		.auth = {
-			.icv_truncbits = 96,
+			.icv_truncbits = 128,
 			.icv_fullbits = 256,
 		}
 	},
diff --git a/net/xfrm/xfrm_output.c b/net/xfrm/xfrm_output.c
index 637387b..d864a6d 100644
--- a/net/xfrm/xfrm_output.c
+++ b/net/xfrm/xfrm_output.c
@@ -66,6 +66,9 @@ static int xfrm_output_one(struct sk_buff *skb, int err)
 			goto error_nolock;
 		}
 
+		if (x->props.output_mark)
+			skb->mark = x->props.output_mark;
+
 		err = x->outer_mode->output(x, skb);
 		if (err) {
 			XFRM_INC_STATS(net, LINUX_MIB_XFRMOUTSTATEMODEERROR);
diff --git a/net/xfrm/xfrm_policy.c b/net/xfrm/xfrm_policy.c
index 5b8fa68..791ad6e 100644
--- a/net/xfrm/xfrm_policy.c
+++ b/net/xfrm/xfrm_policy.c
@@ -125,7 +125,7 @@ static inline struct dst_entry *__xfrm_dst_lookup(struct net *net,
 						  int tos, int oif,
 						  const xfrm_address_t *saddr,
 						  const xfrm_address_t *daddr,
-						  int family)
+						  int family, u32 mark)
 {
 	struct xfrm_policy_afinfo *afinfo;
 	struct dst_entry *dst;
@@ -134,7 +134,7 @@ static inline struct dst_entry *__xfrm_dst_lookup(struct net *net,
 	if (unlikely(afinfo == NULL))
 		return ERR_PTR(-EAFNOSUPPORT);
 
-	dst = afinfo->dst_lookup(net, tos, oif, saddr, daddr);
+	dst = afinfo->dst_lookup(net, tos, oif, saddr, daddr, mark);
 
 	xfrm_policy_put_afinfo(afinfo);
 
@@ -145,7 +145,7 @@ static inline struct dst_entry *xfrm_dst_lookup(struct xfrm_state *x,
 						int tos, int oif,
 						xfrm_address_t *prev_saddr,
 						xfrm_address_t *prev_daddr,
-						int family)
+						int family, u32 mark)
 {
 	struct net *net = xs_net(x);
 	xfrm_address_t *saddr = &x->props.saddr;
@@ -161,7 +161,7 @@ static inline struct dst_entry *xfrm_dst_lookup(struct xfrm_state *x,
 		daddr = x->coaddr;
 	}
 
-	dst = __xfrm_dst_lookup(net, tos, oif, saddr, daddr, family);
+	dst = __xfrm_dst_lookup(net, tos, oif, saddr, daddr, family, mark);
 
 	if (!IS_ERR(dst)) {
 		if (prev_saddr != saddr)
@@ -1435,14 +1435,14 @@ int __xfrm_sk_clone_policy(struct sock *sk, const struct sock *osk)
 
 static int
 xfrm_get_saddr(struct net *net, int oif, xfrm_address_t *local,
-	       xfrm_address_t *remote, unsigned short family)
+	       xfrm_address_t *remote, unsigned short family, u32 mark)
 {
 	int err;
 	struct xfrm_policy_afinfo *afinfo = xfrm_policy_get_afinfo(family);
 
 	if (unlikely(afinfo == NULL))
 		return -EINVAL;
-	err = afinfo->get_saddr(net, oif, local, remote);
+	err = afinfo->get_saddr(net, oif, local, remote, mark);
 	xfrm_policy_put_afinfo(afinfo);
 	return err;
 }
@@ -1473,7 +1473,7 @@ int __xfrm_sk_clone_policy(struct sock *sk, const struct sock *osk)
 			if (xfrm_addr_any(local, tmpl->encap_family)) {
 				error = xfrm_get_saddr(net, fl->flowi_oif,
 						       &tmp, remote,
-						       tmpl->encap_family);
+						       tmpl->encap_family, 0);
 				if (error)
 					goto fail;
 				local = &tmp;
@@ -1752,7 +1752,8 @@ static struct dst_entry *xfrm_bundle_create(struct xfrm_policy *policy,
 		if (xfrm[i]->props.mode != XFRM_MODE_TRANSPORT) {
 			family = xfrm[i]->props.family;
 			dst = xfrm_dst_lookup(xfrm[i], tos, fl->flowi_oif,
-					      &saddr, &daddr, family);
+					      &saddr, &daddr, family,
+					      xfrm[i]->props.output_mark);
 			err = PTR_ERR(dst);
 			if (IS_ERR(dst))
 				goto put_states;
diff --git a/net/xfrm/xfrm_state.c b/net/xfrm/xfrm_state.c
index 71a94e5..3fbe584 100644
--- a/net/xfrm/xfrm_state.c
+++ b/net/xfrm/xfrm_state.c
@@ -1922,6 +1922,7 @@ int xfrm_user_policy(struct sock *sk, int optname, u8 __user *optval, int optlen
 	if (err >= 0) {
 		xfrm_sk_policy_insert(sk, err, pol);
 		xfrm_pol_put(pol);
+		__sk_dst_reset(sk);
 		err = 0;
 	}
 
diff --git a/net/xfrm/xfrm_user.c b/net/xfrm/xfrm_user.c
index 6a02935..a054e1a 100644
--- a/net/xfrm/xfrm_user.c
+++ b/net/xfrm/xfrm_user.c
@@ -579,6 +579,9 @@ static struct xfrm_state *xfrm_state_construct(struct net *net,
 
 	xfrm_mark_get(attrs, &x->mark);
 
+	if (attrs[XFRMA_OUTPUT_MARK])
+		x->props.output_mark = nla_get_u32(attrs[XFRMA_OUTPUT_MARK]);
+
 	err = __xfrm_init_state(x, false);
 	if (err)
 		goto error;
@@ -864,6 +867,11 @@ static int copy_to_user_state_extra(struct xfrm_state *x,
 			      &x->replay);
 	if (ret)
 		goto out;
+	if (x->props.output_mark) {
+		ret = nla_put_u32(skb, XFRMA_OUTPUT_MARK, x->props.output_mark);
+		if (ret)
+			goto out;
+	}
 	if (x->security)
 		ret = copy_sec_ctx(x->security, skb);
 out:
@@ -2427,6 +2435,7 @@ static int xfrm_send_migrate(const struct xfrm_selector *sel, u8 dir, u8 type,
 	[XFRMA_SA_EXTRA_FLAGS]	= { .type = NLA_U32 },
 	[XFRMA_PROTO]		= { .type = NLA_U8 },
 	[XFRMA_ADDRESS_FILTER]	= { .len = sizeof(struct xfrm_address_filter) },
+	[XFRMA_OUTPUT_MARK]	= { .len = NLA_U32 },
 };
 
 static const struct nla_policy xfrma_spd_policy[XFRMA_SPD_MAX+1] = {
@@ -2646,6 +2655,8 @@ static inline size_t xfrm_sa_len(struct xfrm_state *x)
 		l += nla_total_size(sizeof(*x->coaddr));
 	if (x->props.extra_flags)
 		l += nla_total_size(sizeof(x->props.extra_flags));
+	if (x->props.output_mark)
+		l += nla_total_size(sizeof(x->props.output_mark));
 
 	/* Must count x->lastused as it may become non-zero behind our back. */
 	l += nla_total_size_64bit(sizeof(u64));
diff --git a/samples/bpf/Makefile b/samples/bpf/Makefile
index 72c5867..b2cdced 100644
--- a/samples/bpf/Makefile
+++ b/samples/bpf/Makefile
@@ -22,6 +22,7 @@ hostprogs-y += spintest
 hostprogs-y += map_perf_test
 hostprogs-y += test_overhead
 hostprogs-y += test_cgrp2_array_pin
+hostprogs-y += test_cgrp2_attach
 hostprogs-y += xdp1
 hostprogs-y += xdp2
 hostprogs-y += test_current_task_under_cgroup
@@ -50,6 +51,7 @@ spintest-objs := bpf_load.o libbpf.o spintest_user.o
 map_perf_test-objs := bpf_load.o libbpf.o map_perf_test_user.o
 test_overhead-objs := bpf_load.o libbpf.o test_overhead_user.o
 test_cgrp2_array_pin-objs := libbpf.o test_cgrp2_array_pin.o
+test_cgrp2_attach-objs := libbpf.o test_cgrp2_attach.o
 xdp1-objs := bpf_load.o libbpf.o xdp1_user.o
 # reuse xdp1 source intentionally
 xdp2-objs := bpf_load.o libbpf.o xdp1_user.o
diff --git a/samples/bpf/libbpf.c b/samples/bpf/libbpf.c
index 9969e35..9cbc786 100644
--- a/samples/bpf/libbpf.c
+++ b/samples/bpf/libbpf.c
@@ -104,6 +104,29 @@ int bpf_prog_load(enum bpf_prog_type prog_type,
 	return syscall(__NR_bpf, BPF_PROG_LOAD, &attr, sizeof(attr));
 }
 
+int bpf_prog_attach(int prog_fd, int target_fd, enum bpf_attach_type type,
+		    unsigned int flags)
+{
+	union bpf_attr attr = {
+		.target_fd = target_fd,
+		.attach_bpf_fd = prog_fd,
+		.attach_type = type,
+		.attach_flags  = flags;
+	};
+
+	return syscall(__NR_bpf, BPF_PROG_ATTACH, &attr, sizeof(attr));
+}
+
+int bpf_prog_detach(int target_fd, enum bpf_attach_type type)
+{
+	union bpf_attr attr = {
+		.target_fd = target_fd,
+		.attach_type = type,
+	};
+
+	return syscall(__NR_bpf, BPF_PROG_DETACH, &attr, sizeof(attr));
+}
+
 int bpf_obj_pin(int fd, const char *pathname)
 {
 	union bpf_attr attr = {
diff --git a/samples/bpf/libbpf.h b/samples/bpf/libbpf.h
index ac6edb6..b06cf5a 100644
--- a/samples/bpf/libbpf.h
+++ b/samples/bpf/libbpf.h
@@ -15,6 +15,10 @@ int bpf_prog_load(enum bpf_prog_type prog_type,
 		  const struct bpf_insn *insns, int insn_len,
 		  const char *license, int kern_version);
 
+int bpf_prog_attach(int prog_fd, int attachable_fd, enum bpf_attach_type type,
+		    unsigned int flags);
+int bpf_prog_detach(int attachable_fd, enum bpf_attach_type type);
+
 int bpf_obj_pin(int fd, const char *pathname);
 int bpf_obj_get(const char *pathname);
 
diff --git a/samples/bpf/test_cgrp2_attach.c b/samples/bpf/test_cgrp2_attach.c
new file mode 100644
index 00000000..9de4896
--- /dev/null
+++ b/samples/bpf/test_cgrp2_attach.c
@@ -0,0 +1,147 @@
+/* eBPF example program:
+ *
+ * - Creates arraymap in kernel with 4 bytes keys and 8 byte values
+ *
+ * - Loads eBPF program
+ *
+ *   The eBPF program accesses the map passed in to store two pieces of
+ *   information. The number of invocations of the program, which maps
+ *   to the number of packets received, is stored to key 0. Key 1 is
+ *   incremented on each iteration by the number of bytes stored in
+ *   the skb.
+ *
+ * - Detaches any eBPF program previously attached to the cgroup
+ *
+ * - Attaches the new program to a cgroup using BPF_PROG_ATTACH
+ *
+ * - Every second, reads map[0] and map[1] to see how many bytes and
+ *   packets were seen on any socket of tasks in the given cgroup.
+ */
+
+#define _GNU_SOURCE
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <stddef.h>
+#include <string.h>
+#include <unistd.h>
+#include <assert.h>
+#include <errno.h>
+#include <fcntl.h>
+
+#include <linux/bpf.h>
+
+#include "libbpf.h"
+
+enum {
+	MAP_KEY_PACKETS,
+	MAP_KEY_BYTES,
+};
+
+static int prog_load(int map_fd, int verdict)
+{
+	struct bpf_insn prog[] = {
+		BPF_MOV64_REG(BPF_REG_6, BPF_REG_1), /* save r6 so it's not clobbered by BPF_CALL */
+
+		/* Count packets */
+		BPF_MOV64_IMM(BPF_REG_0, MAP_KEY_PACKETS), /* r0 = 0 */
+		BPF_STX_MEM(BPF_W, BPF_REG_10, BPF_REG_0, -4), /* *(u32 *)(fp - 4) = r0 */
+		BPF_MOV64_REG(BPF_REG_2, BPF_REG_10),
+		BPF_ALU64_IMM(BPF_ADD, BPF_REG_2, -4), /* r2 = fp - 4 */
+		BPF_LD_MAP_FD(BPF_REG_1, map_fd), /* load map fd to r1 */
+		BPF_RAW_INSN(BPF_JMP | BPF_CALL, 0, 0, 0, BPF_FUNC_map_lookup_elem),
+		BPF_JMP_IMM(BPF_JEQ, BPF_REG_0, 0, 2),
+		BPF_MOV64_IMM(BPF_REG_1, 1), /* r1 = 1 */
+		BPF_RAW_INSN(BPF_STX | BPF_XADD | BPF_DW, BPF_REG_0, BPF_REG_1, 0, 0), /* xadd r0 += r1 */
+
+		/* Count bytes */
+		BPF_MOV64_IMM(BPF_REG_0, MAP_KEY_BYTES), /* r0 = 1 */
+		BPF_STX_MEM(BPF_W, BPF_REG_10, BPF_REG_0, -4), /* *(u32 *)(fp - 4) = r0 */
+		BPF_MOV64_REG(BPF_REG_2, BPF_REG_10),
+		BPF_ALU64_IMM(BPF_ADD, BPF_REG_2, -4), /* r2 = fp - 4 */
+		BPF_LD_MAP_FD(BPF_REG_1, map_fd),
+		BPF_RAW_INSN(BPF_JMP | BPF_CALL, 0, 0, 0, BPF_FUNC_map_lookup_elem),
+		BPF_JMP_IMM(BPF_JEQ, BPF_REG_0, 0, 2),
+		BPF_LDX_MEM(BPF_W, BPF_REG_1, BPF_REG_6, offsetof(struct __sk_buff, len)), /* r1 = skb->len */
+		BPF_RAW_INSN(BPF_STX | BPF_XADD | BPF_DW, BPF_REG_0, BPF_REG_1, 0, 0), /* xadd r0 += r1 */
+
+		BPF_MOV64_IMM(BPF_REG_0, verdict), /* r0 = verdict */
+		BPF_EXIT_INSN(),
+	};
+
+	return bpf_prog_load(BPF_PROG_TYPE_CGROUP_SKB,
+			     prog, sizeof(prog), "GPL", 0);
+}
+
+static int usage(const char *argv0)
+{
+	printf("Usage: %s <cg-path> <egress|ingress> [drop]\n", argv0);
+	return EXIT_FAILURE;
+}
+
+int main(int argc, char **argv)
+{
+	int cg_fd, map_fd, prog_fd, key, ret;
+	long long pkt_cnt, byte_cnt;
+	enum bpf_attach_type type;
+	int verdict = 1;
+
+	if (argc < 3)
+		return usage(argv[0]);
+
+	if (strcmp(argv[2], "ingress") == 0)
+		type = BPF_CGROUP_INET_INGRESS;
+	else if (strcmp(argv[2], "egress") == 0)
+		type = BPF_CGROUP_INET_EGRESS;
+	else
+		return usage(argv[0]);
+
+	if (argc > 3 && strcmp(argv[3], "drop") == 0)
+		verdict = 0;
+
+	cg_fd = open(argv[1], O_DIRECTORY | O_RDONLY);
+	if (cg_fd < 0) {
+		printf("Failed to open cgroup path: '%s'\n", strerror(errno));
+		return EXIT_FAILURE;
+	}
+
+	map_fd = bpf_create_map(BPF_MAP_TYPE_ARRAY,
+				sizeof(key), sizeof(byte_cnt),
+				256, 0);
+	if (map_fd < 0) {
+		printf("Failed to create map: '%s'\n", strerror(errno));
+		return EXIT_FAILURE;
+	}
+
+	prog_fd = prog_load(map_fd, verdict);
+	printf("Output from kernel verifier:\n%s\n-------\n", bpf_log_buf);
+
+	if (prog_fd < 0) {
+		printf("Failed to load prog: '%s'\n", strerror(errno));
+		return EXIT_FAILURE;
+	}
+
+	ret = bpf_prog_detach(cg_fd, type);
+	printf("bpf_prog_detach() returned '%s' (%d)\n", strerror(errno), errno);
+
+	ret = bpf_prog_attach(prog_fd, cg_fd, type, 0);
+	if (ret < 0) {
+		printf("Failed to attach prog to cgroup: '%s'\n",
+		       strerror(errno));
+		return EXIT_FAILURE;
+	}
+
+	while (1) {
+		key = MAP_KEY_PACKETS;
+		assert(bpf_lookup_elem(map_fd, &key, &pkt_cnt) == 0);
+
+		key = MAP_KEY_BYTES;
+		assert(bpf_lookup_elem(map_fd, &key, &byte_cnt) == 0);
+
+		printf("cgroup received %lld packets, %lld bytes\n",
+		       pkt_cnt, byte_cnt);
+		sleep(1);
+	}
+
+	return EXIT_SUCCESS;
+}
diff --git a/scripts/Kbuild.include b/scripts/Kbuild.include
index 6377430..b1cdd50 100644
--- a/scripts/Kbuild.include
+++ b/scripts/Kbuild.include
@@ -109,6 +109,11 @@ as-option = $(call try-run,\
 as-instr = $(call try-run,\
 	printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
 
+# __cc-option
+# Usage: MY_CFLAGS += $(call __cc-option,$(CC),$(MY_CFLAGS),-march=winchip-c6,-march=i586)
+__cc-option = $(call try-run,\
+	$(1) -Werror $(2) $(3) -c -x c /dev/null -o "$$TMP",$(3),$(4))
+
 # Do not attempt to build with gcc plugins during cc-option tests.
 # (And this uses delayed resolution so the flags will be up to date.)
 CC_OPTION_CFLAGS = $(filter-out $(GCC_PLUGINS_CFLAGS),$(KBUILD_CFLAGS))
@@ -116,13 +121,18 @@ CC_OPTION_CFLAGS = $(filter-out $(GCC_PLUGINS_CFLAGS),$(KBUILD_CFLAGS))
 # cc-option
 # Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
 
-cc-option = $(call try-run,\
-	$(CC) $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",$(1),$(2))
+cc-option = $(call __cc-option, $(CC),\
+	$(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS),$(1),$(2))
+
+# hostcc-option
+# Usage: cflags-y += $(call hostcc-option,-march=winchip-c6,-march=i586)
+hostcc-option = $(call __cc-option, $(HOSTCC),\
+	$(HOSTCFLAGS) $(HOST_EXTRACFLAGS),$(1),$(2))
 
 # cc-option-yn
 # Usage: flag := $(call cc-option-yn,-march=winchip-c6)
 cc-option-yn = $(call try-run,\
-	$(CC) $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
+	$(CC) -Werror $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
 
 # cc-option-align
 # Prefix align with either -falign or -malign
@@ -132,12 +142,43 @@ cc-option-align = $(subst -functions=0,,\
 # cc-disable-warning
 # Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
 cc-disable-warning = $(call try-run,\
-	$(CC) $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
+	$(CC) -Werror $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
 
 # cc-name
 # Expands to either gcc or clang
 cc-name = $(shell $(CC) -v 2>&1 | grep -q "clang version" && echo clang || echo gcc)
 
+# __cc-version
+# Returns compiler version
+__cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/$(cc-name)-version.sh $(CC))
+
+# __cc-fullversion
+# Returns full compiler version
+__cc-fullversion = $(shell $(CONFIG_SHELL) \
+	$(srctree)/scripts/$(cc-name)-version.sh -p $(CC))
+
+# __cc-ifversion
+# Matches compiler name and version
+# Usage:  EXTRA_CFLAGS += $(call cc-if-name-version, gcc, -lt, 0402, -O1)
+__cc-ifversion = $(shell [ $(cc-name) = $(1) ] && [ $(__cc-version) $(2) $(3) ] && echo $(4) || echo $(5))
+
+# __cc-if-fullversion
+# Matches compiler name and full version
+# Usage:  EXTRA_CFLAGS += $(call cc-if-name-fullversion, gcc, -lt, 040502, -O1)
+__cc-if-fullversion = $(shell [ $(cc-name) = $(1) ] && [ $(__cc-fullversion) $(2) $(3) ] && echo $(4) || echo $(5))
+
+# gcc-ifversion
+gcc-ifversion = $(call __cc-ifversion, gcc, $(1), $(2), $(3), $(4))
+
+# gcc-if-fullversion
+gcc-if-fullversion = (call __cc-if-fullversion, gcc, $(1), $(2), $(3), $(4))
+
+# clang-ifversion
+clang-ifversion =  $(call __cc-ifversion, clang, $(1), $(2), $(3), $(4))
+
+# clang-if-fullversion
+clang-if-fullversion = (call __cc-if-fullversion, clang, $(1), $(2), $(3), $(4))
+
 # cc-version
 cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh $(CC))
 
@@ -145,9 +186,9 @@ cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh $(CC))
 cc-fullversion = $(shell $(CONFIG_SHELL) \
 	$(srctree)/scripts/gcc-version.sh -p $(CC))
 
-# cc-ifversion
-# Usage:  EXTRA_CFLAGS += $(call cc-ifversion, -lt, 0402, -O1)
-cc-ifversion = $(shell [ $(cc-version) $(1) $(2) ] && echo $(3) || echo $(4))
+# backward compatibility
+cc-ifversion = $(gcc-ifversion)
+cc-if-fullversion = $(gcc-if-fullversion)
 
 # cc-ldoption
 # Usage: ldflags += $(call cc-ldoption, -Wl$(comma)--hash-style=both)
@@ -164,6 +205,10 @@ ld-option = $(call try-run,\
 # Important: no spaces around options
 ar-option = $(call try-run, $(AR) rc$(1) "$$TMP",$(1),$(2))
 
+# ld-name
+# Expands to either bfd or gold
+ld-name = $(shell $(LD) -v 2>&1 | grep -q "GNU gold" && echo gold || echo bfd)
+
 # ld-version
 # Note this is mainly for HJ Lu's 3 number binutil versions
 ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
@@ -172,6 +217,18 @@ ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
 # Usage:  $(call ld-ifversion, -ge, 22252, y)
 ld-ifversion = $(shell [ $(ld-version) $(1) $(2) ] && echo $(3) || echo $(4))
 
+# __ld-ifversion
+# Usage:  $(call __ld-ifversion, gold, -ge, 112000000, y)
+__ld-ifversion = $(shell [ $(ld-name) = $(1) ] && [ $(ld-version) $(2) $(3) ] && echo $(4) || echo $(5))
+
+# bfd-ifversion
+# Usage:  $(call bfd-ifversion, -ge, 227000000, y)
+bfd-ifversion = $(call __ld-ifversion, bfd, $(1), $(2), $(3), $(4))
+
+# gold-ifversion
+# Usage:  $(call gold-ifversion, -ge, 112000000, y)
+gold-ifversion = $(call __ld-ifversion, gold, $(1), $(2), $(3), $(4))
+
 ######
 
 ###
diff --git a/scripts/Makefile.build b/scripts/Makefile.build
index abfd4f4..d41c72a5 100644
--- a/scripts/Makefile.build
+++ b/scripts/Makefile.build
@@ -176,6 +176,14 @@ cmd_cc_symtypes_c =                                                         \
 $(obj)/%.symtypes : $(src)/%.c FORCE
 	$(call cmd,cc_symtypes_c)
 
+# LLVM assembly
+# Generate .ll files from .c
+quiet_cmd_cc_ll_c = CC $(quiet_modtag)  $@
+      cmd_cc_ll_c = $(CC) $(c_flags) -emit-llvm -S -o $@ $<
+
+$(obj)/%.ll: $(src)/%.c FORCE
+	$(call if_changed_dep,cc_ll_c)
+
 # C (.c) files
 # The C file is compiled and updated dependency information is generated.
 # (See cmd_cc_o_c + relevant part of rule_cc_o_c)
@@ -200,6 +208,23 @@ else
 
 cmd_cc_o_c = $(CC) $(c_flags) -c -o $(@D)/.tmp_$(@F) $<
 
+ifdef CONFIG_LTO_CLANG
+# Generate .o.symversions files for each .o with exported symbols, and link these
+# to the kernel and/or modules at the end.
+cmd_modversions_c =								\
+	if $(OBJDUMP) -h $(@D)/.tmp_$(@F) >/dev/null 2>/dev/null; then		\
+		if $(OBJDUMP) -h $(@D)/.tmp_$(@F) | grep -q __ksymtab; then	\
+			$(call cmd_gensymtypes_c,$(KBUILD_SYMTYPES),$(@:.o=.symtypes)) \
+			    > $(@D)/$(@F).symversions;				\
+		fi;								\
+	else									\
+		if $(LLVM_DIS) -o=- $(@D)/.tmp_$(@F) | grep -q __ksymtab; then	\
+			$(call cmd_gensymtypes_c,$(KBUILD_SYMTYPES),$(@:.o=.symtypes)) \
+			    > $(@D)/$(@F).symversions;				\
+		fi;								\
+	fi;									\
+	mv -f $(@D)/.tmp_$(@F) $@;
+else
 cmd_modversions_c =								\
 	if $(OBJDUMP) -h $(@D)/.tmp_$(@F) | grep -q __ksymtab; then		\
 		$(call cmd_gensymtypes_c,$(KBUILD_SYMTYPES),$(@:.o=.symtypes))	\
@@ -212,12 +237,19 @@ cmd_modversions_c =								\
 		mv -f $(@D)/.tmp_$(@F) $@;					\
 	fi;
 endif
+endif
 
 ifdef CONFIG_FTRACE_MCOUNT_RECORD
 ifdef BUILD_C_RECORDMCOUNT
 ifeq ("$(origin RECORDMCOUNT_WARN)", "command line")
   RECORDMCOUNT_FLAGS = -w
 endif
+
+ifdef CONFIG_LTO_CLANG
+# With LTO, we postpone running recordmcount until after the LTO link step, so
+# let's export the parameters for the link script.
+export RECORDMCOUNT_FLAGS
+else
 # Due to recursion, we must skip empty.o.
 # The empty.o file is created in the make process in order to determine
 #  the target endianness and word size. It is made before all other C
@@ -226,23 +258,29 @@ sub_cmd_record_mcount =					\
 	if [ $(@) != "scripts/mod/empty.o" ]; then	\
 		$(objtree)/scripts/recordmcount $(RECORDMCOUNT_FLAGS) "$(@)";	\
 	fi;
+endif
+
 recordmcount_source := $(srctree)/scripts/recordmcount.c \
 		    $(srctree)/scripts/recordmcount.h
-else
+else # !BUILD_C_RECORDMCOUNT
 sub_cmd_record_mcount = set -e ; perl $(srctree)/scripts/recordmcount.pl "$(ARCH)" \
 	"$(if $(CONFIG_CPU_BIG_ENDIAN),big,little)" \
 	"$(if $(CONFIG_64BIT),64,32)" \
 	"$(OBJDUMP)" "$(OBJCOPY)" "$(CC) $(KBUILD_CFLAGS)" \
 	"$(LD)" "$(NM)" "$(RM)" "$(MV)" \
 	"$(if $(part-of-module),1,0)" "$(@)";
+
 recordmcount_source := $(srctree)/scripts/recordmcount.pl
-endif
+endif # BUILD_C_RECORDMCOUNT
+
+ifndef CONFIG_LTO_CLANG
 cmd_record_mcount =						\
 	if [ "$(findstring $(CC_FLAGS_FTRACE),$(_c_flags))" =	\
 	     "$(CC_FLAGS_FTRACE)" ]; then			\
 		$(sub_cmd_record_mcount)			\
 	fi;
 endif
+endif # CONFIG_FTRACE_MCOUNT_RECORD
 
 ifdef CONFIG_STACK_VALIDATION
 ifneq ($(SKIP_STACK_VALIDATION),1)
@@ -429,9 +467,30 @@ $(sort $(subdir-obj-y)): $(subdir-ym) ;
 #
 ifdef builtin-target
 
+ifdef CONFIG_LTO_CLANG
+  ifdef CONFIG_MODVERSIONS
+    # combine symversions for later processing
+    update_lto_symversions =				\
+	rm -f $@.symversions; 				\
+	for i in $(filter-out FORCE,$^); do		\
+		if [ -f $$i.symversions ]; then		\
+			cat $$i.symversions 		\
+				>> $@.symversions;	\
+		fi;					\
+	done;
+  endif
+  # rebuild the symbol table with llvm-ar to include IR files
+  update_lto_symtable = ;				\
+	mv -f $@ $@.tmp;				\
+	$(LLVM_AR) rcsT$(KBUILD_ARFLAGS) $@ 		\
+		$$($(AR) t $@.tmp); 			\
+	rm -f $@.tmp
+endif
+
 ifdef CONFIG_THIN_ARCHIVES
-  cmd_make_builtin = rm -f $@; $(AR) rcST$(KBUILD_ARFLAGS)
-  cmd_make_empty_builtin = rm -f $@; $(AR) rcST$(KBUILD_ARFLAGS)
+  cmd_make_builtin = $(update_lto_symversions)	\
+	rm -f $@; $(AR) rcSTP$(KBUILD_ARFLAGS)
+  cmd_make_empty_builtin = rm -f $@; $(AR) rcSTP$(KBUILD_ARFLAGS)
   quiet_cmd_link_o_target = AR      $@
 else
   cmd_make_builtin = $(LD) $(ld_flags) -r -o
@@ -471,7 +530,11 @@ ifdef lib-target
 quiet_cmd_link_l_target = AR      $@
 
 ifdef CONFIG_THIN_ARCHIVES
-  cmd_link_l_target = rm -f $@; $(AR) rcsT$(KBUILD_ARFLAGS) $@ $(lib-y)
+  cmd_link_l_target = 					\
+	$(update_lto_symversions)			\
+	rm -f $@; 					\
+	$(AR) rcsTP$(KBUILD_ARFLAGS) $@ $(lib-y)	\
+	$(update_lto_symtable)
 else
   cmd_link_l_target = rm -f $@; $(AR) rcs$(KBUILD_ARFLAGS) $@ $(lib-y)
 endif
@@ -489,14 +552,36 @@ else
 ref_prefix = EXTERN(
 endif
 
-quiet_cmd_export_list = EXPORTS $@
-cmd_export_list = $(OBJDUMP) -h $< | \
-	sed -ne '/___ksymtab/{s/.*+/$(ref_prefix)/;s/ .*/)/;p}' >$(ksyms-lds);\
-	rm -f $(dummy-object);\
-	$(AR) rcs$(KBUILD_ARFLAGS) $(dummy-object);\
+filter_export_list = sed -ne '/___ksymtab/s/.*+\([^ "]*\).*/$(ref_prefix)\1)/p'
+link_export_list = rm -f $(dummy-object);\
+	echo | $(CC) $(a_flags) -c -o $(dummy-object) -x assembler -;\
 	$(LD) $(ld_flags) -r -o $@ -T $(ksyms-lds) $(dummy-object);\
 	rm $(dummy-object) $(ksyms-lds)
 
+quiet_cmd_export_list = EXPORTS $@
+
+ifdef CONFIG_LTO_CLANG
+# objdump doesn't understand IR files and llvm-dis doesn't support archives,
+# so we'll walk through each file in the archive separately
+cmd_export_list = 					\
+	rm -f $(ksyms-lds);				\
+	for o in $$($(AR) t $<); do			\
+		if $(OBJDUMP) -h $$o >/dev/null 2>/dev/null; then \
+			$(OBJDUMP) -h $$o | 		\
+				$(filter_export_list) 	\
+				>>$(ksyms-lds);		\
+		else					\
+			$(LLVM_DIS) -o=- $$o |		\
+				$(filter_export_list) 	\
+				>>$(ksyms-lds);		\
+		fi; 					\
+	done;						\
+	$(link_export_list)
+else
+cmd_export_list = $(OBJDUMP) -h $< | $(filter_export_list) >$(ksyms-lds); \
+	$(link_export_list)
+endif
+
 $(obj)/lib-ksyms.o: $(lib-target) FORCE
 	$(call if_changed,export_list)
 
@@ -520,20 +605,36 @@ $($(subst $(obj)/,,$(@:.o=-objs)))    \
 $($(subst $(obj)/,,$(@:.o=-y)))       \
 $($(subst $(obj)/,,$(@:.o=-m)))), $^)
 
-quiet_cmd_link_multi-y = LD      $@
-cmd_link_multi-y = $(LD) $(ld_flags) -r -o $@ $(link_multi_deps) $(cmd_secanalysis)
+cmd_link_multi-link = $(LD) $(ld_flags) -r -o $@ $(link_multi_deps) $(cmd_secanalysis)
+
+ifdef CONFIG_THIN_ARCHIVES
+  quiet_cmd_link_multi-y = AR      $@
+  cmd_link_multi-y = $(update_lto_symversions) \
+	rm -f $@; $(AR) rcSTP$(KBUILD_ARFLAGS) $@ $(link_multi_deps) \
+	$(update_lto_symtable)
+else
+  quiet_cmd_link_multi-y = LD      $@
+  cmd_link_multi-y = $(cmd_link_multi-link)
+endif
 
 quiet_cmd_link_multi-m = LD [M]  $@
-cmd_link_multi-m = $(cmd_link_multi-y)
+
+ifdef CONFIG_LTO_CLANG
+  # don't compile IR until needed
+  cmd_link_multi-m = $(cmd_link_multi-y)
+else
+  cmd_link_multi-m = $(cmd_link_multi-link)
+endif
 
 $(multi-used-y): FORCE
 	$(call if_changed,link_multi-y)
-$(call multi_depend, $(multi-used-y), .o, -objs -y)
 
 $(multi-used-m): FORCE
 	$(call if_changed,link_multi-m)
 	@{ echo $(@:.o=.ko); echo $(link_multi_deps); \
 	   $(cmd_undef_syms); } > $(MODVERDIR)/$(@F:.o=.mod)
+
+$(call multi_depend, $(multi-used-y), .o, -objs -y)
 $(call multi_depend, $(multi-used-m), .o, -objs -y -m)
 
 targets += $(multi-used-y) $(multi-used-m)
diff --git a/scripts/Makefile.clean b/scripts/Makefile.clean
index 50616ea..2e70c6f 100644
--- a/scripts/Makefile.clean
+++ b/scripts/Makefile.clean
@@ -11,7 +11,7 @@ include scripts/Kbuild.include
 
 # The filename Kbuild has precedence over Makefile
 kbuild-dir := $(if $(filter /%,$(src)),$(src),$(srctree)/$(src))
-include $(if $(wildcard $(kbuild-dir)/Kbuild), $(kbuild-dir)/Kbuild, $(kbuild-dir)/Makefile)
+-include $(if $(wildcard $(kbuild-dir)/Kbuild), $(kbuild-dir)/Kbuild, $(kbuild-dir)/Makefile)
 
 # Figure out what we need to build from the various variables
 # ==========================================================================
diff --git a/scripts/Makefile.extrawarn b/scripts/Makefile.extrawarn
index 7c321a6..fb3522f 100644
--- a/scripts/Makefile.extrawarn
+++ b/scripts/Makefile.extrawarn
@@ -64,7 +64,6 @@ ifeq ($(cc-name),clang)
 KBUILD_CFLAGS += $(call cc-disable-warning, initializer-overrides)
 KBUILD_CFLAGS += $(call cc-disable-warning, unused-value)
 KBUILD_CFLAGS += $(call cc-disable-warning, format)
-KBUILD_CFLAGS += $(call cc-disable-warning, unknown-warning-option)
 KBUILD_CFLAGS += $(call cc-disable-warning, sign-compare)
 KBUILD_CFLAGS += $(call cc-disable-warning, format-zero-length)
 KBUILD_CFLAGS += $(call cc-disable-warning, uninitialized)
diff --git a/scripts/Makefile.host b/scripts/Makefile.host
index 45b5b1a..9cfd5c8 100644
--- a/scripts/Makefile.host
+++ b/scripts/Makefile.host
@@ -20,12 +20,6 @@
 # Will compile qconf as a C++ program, and menu as a C program.
 # They are linked as C++ code to the executable qconf
 
-# hostcc-option
-# Usage: cflags-y += $(call hostcc-option,-march=winchip-c6,-march=i586)
-
-hostcc-option = $(call try-run,\
-	$(HOSTCC) $(HOSTCFLAGS) $(HOST_EXTRACFLAGS) $(1) -c -x c /dev/null -o "$$TMP",$(1),$(2))
-
 __hostprogs := $(sort $(hostprogs-y) $(hostprogs-m))
 host-cshlib := $(sort $(hostlibs-y) $(hostlibs-m))
 host-cxxshlib := $(sort $(hostcxxlibs-y) $(hostcxxlibs-m))
diff --git a/scripts/Makefile.kasan b/scripts/Makefile.kasan
index 37323b0..8c69cd1 100644
--- a/scripts/Makefile.kasan
+++ b/scripts/Makefile.kasan
@@ -9,10 +9,7 @@ KASAN_SHADOW_OFFSET ?= $(CONFIG_KASAN_SHADOW_OFFSET)
 
 CFLAGS_KASAN_MINIMAL := -fsanitize=kernel-address
 
-CFLAGS_KASAN := $(call cc-option, -fsanitize=kernel-address \
-		-fasan-shadow-offset=$(KASAN_SHADOW_OFFSET) \
-		--param asan-stack=1 --param asan-globals=1 \
-		--param asan-instrumentation-with-call-threshold=$(call_threshold))
+cc-param = $(call cc-option, -mllvm -$(1), $(call cc-option, --param $(1)))
 
 ifeq ($(call cc-option, $(CFLAGS_KASAN_MINIMAL) -Werror),)
    ifneq ($(CONFIG_COMPILE_TEST),y)
@@ -20,12 +17,23 @@ ifeq ($(call cc-option, $(CFLAGS_KASAN_MINIMAL) -Werror),)
             -fsanitize=kernel-address is not supported by compiler)
    endif
 else
-    ifeq ($(CFLAGS_KASAN),)
-        ifneq ($(CONFIG_COMPILE_TEST),y)
-            $(warning CONFIG_KASAN: compiler does not support all options.\
-                Trying minimal configuration)
-        endif
-        CFLAGS_KASAN := $(CFLAGS_KASAN_MINIMAL)
-    endif
+   # -fasan-shadow-offset fails without -fsanitize
+   CFLAGS_KASAN_SHADOW := $(call cc-option, -fsanitize=kernel-address \
+			-fasan-shadow-offset=$(KASAN_SHADOW_OFFSET), \
+			$(call cc-option, -fsanitize=kernel-address \
+			-mllvm -asan-mapping-offset=$(KASAN_SHADOW_OFFSET)))
+
+   ifeq ($(strip $(CFLAGS_KASAN_SHADOW)),)
+      CFLAGS_KASAN := $(CFLAGS_KASAN_MINIMAL)
+   else
+      # Now add all the compiler specific options that are valid standalone
+      CFLAGS_KASAN := $(CFLAGS_KASAN_SHADOW) \
+	$(call cc-param,asan-globals=1) \
+	$(call cc-param,asan-instrumentation-with-call-threshold=$(call_threshold)) \
+	$(call cc-param,asan-stack=1) \
+	$(call cc-param,asan-use-after-scope=1) \
+	$(call cc-param,asan-instrument-allocas=1)
+   endif
+
 endif
 endif
diff --git a/scripts/Makefile.lib b/scripts/Makefile.lib
index ae0f9ab..d295f2a 100644
--- a/scripts/Makefile.lib
+++ b/scripts/Makefile.lib
@@ -314,6 +314,12 @@ $(obj)/%.dtb: $(src)/%.dts FORCE
 
 dtc-tmp = $(subst $(comma),_,$(dot-target).dts.tmp)
 
+# cat
+# ---------------------------------------------------------------------------
+# Concatentate multiple files together
+quiet_cmd_cat = CAT     $@
+cmd_cat = (cat $(filter-out FORCE,$^) > $@) || (rm -f $@; false)
+
 # Bzip2
 # ---------------------------------------------------------------------------
 
@@ -408,3 +414,34 @@ quiet_cmd_xzmisc = XZMISC  $@
 cmd_xzmisc = (cat $(filter-out FORCE,$^) | \
 	xz --check=crc32 --lzma2=dict=1MiB) > $@ || \
 	(rm -f $@ ; false)
+
+# ASM offsets
+# ---------------------------------------------------------------------------
+
+# Default sed regexp - multiline due to syntax constraints
+#
+# Use [:space:] because LLVM's integrated assembler inserts <tab> around
+# the .ascii directive whereas GCC keeps the <space> as-is.
+define sed-offsets
+	's:^[[:space:]]*\.ascii[[:space:]]*"\(.*\)".*:\1:; \
+	/^->/{s:->#\(.*\):/* \1 */:; \
+	s:^->\([^ ]*\) [\$$#]*\([^ ]*\) \(.*\):#define \1 \2 /* \3 */:; \
+	s:->::; p;}'
+endef
+
+# Use filechk to avoid rebuilds when a header changes, but the resulting file
+# does not
+define filechk_offsets
+	(set -e; \
+	 echo "#ifndef $2"; \
+	 echo "#define $2"; \
+	 echo "/*"; \
+	 echo " * DO NOT MODIFY."; \
+	 echo " *"; \
+	 echo " * This file was generated by Kbuild"; \
+	 echo " */"; \
+	 echo ""; \
+	 sed -ne $(sed-offsets); \
+	 echo ""; \
+	 echo "#endif" )
+endef
diff --git a/scripts/Makefile.modinst b/scripts/Makefile.modinst
index 07650ee..6f4c3f5 100644
--- a/scripts/Makefile.modinst
+++ b/scripts/Makefile.modinst
@@ -29,7 +29,7 @@ quiet_cmd_modules_install = INSTALL $@
 INSTALL_MOD_DIR ?= extra
 ext-mod-dir = $(INSTALL_MOD_DIR)$(subst $(patsubst %/,%,$(KBUILD_EXTMOD)),,$(@D))
 
-modinst_dir = $(if $(KBUILD_EXTMOD),$(ext-mod-dir),kernel/$(@D))
+modinst_dir ?= $(if $(KBUILD_EXTMOD),$(ext-mod-dir),kernel/$(@D))
 
 $(modules):
 	$(call cmd,modules_install,$(MODLIB)/$(modinst_dir))
diff --git a/scripts/Makefile.modpost b/scripts/Makefile.modpost
index 16923ba..b7c50cb 100644
--- a/scripts/Makefile.modpost
+++ b/scripts/Makefile.modpost
@@ -82,12 +82,28 @@ modpost = scripts/mod/modpost                    \
 
 MODPOST_OPT=$(subst -i,-n,$(filter -i,$(MAKEFLAGS)))
 
+# If CONFIG_LTO_CLANG is enabled, .o files are either LLVM IR, or empty, so we
+# need to link them into actual objects before passing them to modpost
+modpost-ext = $(if $(CONFIG_LTO_CLANG),.lto,)
+
+ifdef CONFIG_LTO_CLANG
+quiet_cmd_cc_lto_link_modules = LD [M]  $@
+cmd_cc_lto_link_modules =						\
+	$(LD) $(ld_flags) -r -o $(@)					\
+		$(shell [ -s $(@:$(modpost-ext).o=.o.symversions) ] &&	\
+			echo -T $(@:$(modpost-ext).o=.o.symversions))	\
+		--whole-archive $(filter-out FORCE,$^)
+
+$(modules:.ko=$(modpost-ext).o): %$(modpost-ext).o: %.o FORCE
+	$(call if_changed,cc_lto_link_modules)
+endif
+
 # We can go over command line length here, so be careful.
 quiet_cmd_modpost = MODPOST $(words $(filter-out vmlinux FORCE, $^)) modules
-      cmd_modpost = $(MODLISTCMD) | sed 's/\.ko$$/.o/' | $(modpost) $(MODPOST_OPT) -s -T -
+      cmd_modpost = $(MODLISTCMD) | sed 's/\.ko$$/$(modpost-ext)\.o/' | $(modpost) $(MODPOST_OPT) -s -T -
 
 PHONY += __modpost
-__modpost: $(modules:.ko=.o) FORCE
+__modpost: $(modules:.ko=$(modpost-ext).o) FORCE
 	$(call cmd,modpost) $(wildcard vmlinux)
 
 quiet_cmd_kernel-mod = MODPOST $@
@@ -98,8 +114,7 @@ vmlinux.o: FORCE
 
 # Declare generated files as targets for modpost
 $(symverfile):         __modpost ;
-$(modules:.ko=.mod.c): __modpost ;
-
+$(modules:.ko=$(modpost-ext).mod.c): __modpost ;
 
 # Step 5), compile all *.mod.c files
 
@@ -110,22 +125,37 @@ quiet_cmd_cc_o_c = CC      $@
       cmd_cc_o_c = $(CC) $(c_flags) $(KBUILD_CFLAGS_MODULE) $(CFLAGS_MODULE) \
 		   -c -o $@ $<
 
-$(modules:.ko=.mod.o): %.mod.o: %.mod.c FORCE
+$(modules:.ko=.mod.o): %.mod.o: %$(modpost-ext).mod.c FORCE
 	$(call if_changed_dep,cc_o_c)
 
-targets += $(modules:.ko=.mod.o)
+targets += $(modules:.ko=$(modpost-ext).mod.o)
 
 ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(SRCARCH)/Makefile.postlink)
 
 # Step 6), final link of the modules with optional arch pass after final link
 quiet_cmd_ld_ko_o = LD [M]  $@
+
+ifdef CONFIG_LTO_CLANG
+      cmd_ld_ko_o = 							\
+	$(LD) -r $(LDFLAGS)                                 		\
+		 $(KBUILD_LDFLAGS_MODULE) $(LDFLAGS_MODULE) 		\
+		 $(shell [ -s $(@:.ko=.o.symversions) ] &&		\
+			echo -T $(@:.ko=.o.symversions))  		\
+		 -o $@ --whole-archive					\
+		 $(filter-out FORCE,$(^:$(modpost-ext).o=.o))
+
+  ifdef CONFIG_FTRACE_MCOUNT_RECORD
+      cmd_ld_ko_o += ; $(objtree)/scripts/recordmcount $(RECORDMCOUNT_FLAGS) $@
+  endif
+else
       cmd_ld_ko_o =                                                     \
 	$(LD) -r $(LDFLAGS)                                             \
                  $(KBUILD_LDFLAGS_MODULE) $(LDFLAGS_MODULE)             \
                  -o $@ $(filter-out FORCE,$^) ;                         \
 	$(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
+endif
 
-$(modules): %.ko :%.o %.mod.o FORCE
+$(modules): %.ko: %$(modpost-ext).o %.mod.o FORCE
 	+$(call if_changed,ld_ko_o)
 
 targets += $(modules)
diff --git a/scripts/checkpatch.pl b/scripts/checkpatch.pl
index 5517164..77bc368 100755
--- a/scripts/checkpatch.pl
+++ b/scripts/checkpatch.pl
@@ -2529,6 +2529,7 @@ sub process {
 # Check for git id commit length and improperly formed commit descriptions
 		if ($in_commit_log && !$commit_log_possible_stack_dump &&
 		    $line !~ /^\s*(?:Link|Patchwork|http|https|BugLink):/i &&
+		    $line !~ /^This reverts commit [0-9a-f]{7,40}/ &&
 		    ($line =~ /\bcommit\s+[0-9a-f]{5,}\b/i ||
 		     ($line =~ /(?:\s|^)[0-9a-f]{12,40}(?:[\s"'\(\[]|$)/i &&
 		      $line !~ /[\<\[][0-9a-f]{12,40}[\>\]]/i &&
diff --git a/scripts/clang-version.sh b/scripts/clang-version.sh
new file mode 100755
index 00000000..9780efa
--- /dev/null
+++ b/scripts/clang-version.sh
@@ -0,0 +1,33 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+#
+# clang-version [-p] clang-command
+#
+# Prints the compiler version of `clang-command' in a canonical 4-digit form
+# such as `0500' for clang-5.0 etc.
+#
+# With the -p option, prints the patchlevel as well, for example `050001' for
+# clang-5.0.1 etc.
+#
+
+if [ "$1" = "-p" ] ; then
+	with_patchlevel=1;
+	shift;
+fi
+
+compiler="$*"
+
+if [ ${#compiler} -eq 0 ]; then
+	echo "Error: No compiler specified."
+	printf "Usage:\n\t$0 <clang-command>\n"
+	exit 1
+fi
+
+MAJOR=$(echo __clang_major__ | $compiler -E -x c - | tail -n 1)
+MINOR=$(echo __clang_minor__ | $compiler -E -x c - | tail -n 1)
+if [ "x$with_patchlevel" != "x" ] ; then
+	PATCHLEVEL=$(echo __clang_patchlevel__ | $compiler -E -x c - | tail -n 1)
+	printf "%02d%02d%02d\\n" $MAJOR $MINOR $PATCHLEVEL
+else
+	printf "%02d%02d\\n" $MAJOR $MINOR
+fi
diff --git a/scripts/link-vmlinux.sh b/scripts/link-vmlinux.sh
index f742c65..8b4329c 100755
--- a/scripts/link-vmlinux.sh
+++ b/scripts/link-vmlinux.sh
@@ -53,7 +53,38 @@ archive_builtin()
 		${AR} rcsT${KBUILD_ARFLAGS} built-in.o			\
 					${KBUILD_VMLINUX_INIT}		\
 					${KBUILD_VMLINUX_MAIN}
+
+		if [ -n "${CONFIG_LTO_CLANG}" ]; then
+			mv -f built-in.o built-in.o.tmp
+			${LLVM_AR} rcsT${KBUILD_ARFLAGS} built-in.o $(${AR} t built-in.o.tmp)
+			rm -f built-in.o.tmp
+		fi
+	fi
+}
+
+# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
+# .tmp_symversions
+modversions()
+{
+	if [ -z "${CONFIG_LTO_CLANG}" ]; then
+		return
 	fi
+
+	if [ -z "${CONFIG_MODVERSIONS}" ]; then
+		return
+	fi
+
+	rm -f .tmp_symversions
+
+	for a in built-in.o ${KBUILD_VMLINUX_LIBS}; do
+		for o in $(${AR} t $a); do
+			if [ -f ${o}.symversions ]; then
+				cat ${o}.symversions >> .tmp_symversions
+			fi
+		done
+	done
+
+	echo "-T .tmp_symversions"
 }
 
 # Link of vmlinux.o used for section mismatch analysis
@@ -70,7 +101,29 @@ modpost_link()
 			${KBUILD_VMLINUX_MAIN}				\
 			--end-group"
 	fi
-	${LD} ${LDFLAGS} -r -o ${1} ${objects}
+
+	if [ -n "${CONFIG_LTO_CLANG}" ]; then
+		# This might take a while, so indicate that we're doing
+		# an LTO link
+		info LTO vmlinux.o
+	else
+		info LD vmlinux.o
+	fi
+
+	${LD} ${LDFLAGS} -r -o ${1} $(modversions) ${objects}
+}
+
+# If CONFIG_LTO_CLANG is selected, we postpone running recordmcount until
+# we have compiled LLVM IR to an object file.
+recordmcount()
+{
+	if [ -z "${CONFIG_LTO_CLANG}" ]; then
+		return
+	fi
+
+	if [ -n "${CONFIG_FTRACE_MCOUNT_RECORD}" ]; then
+		scripts/recordmcount ${RECORDMCOUNT_FLAGS} $*
+	fi
 }
 
 # Link of vmlinux
@@ -82,7 +135,15 @@ vmlinux_link()
 	local objects
 
 	if [ "${SRCARCH}" != "um" ]; then
-		if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
+		local ld=${LD}
+		local ldflags="${LDFLAGS} ${LDFLAGS_vmlinux}"
+
+		if [ -n "${LDFINAL_vmlinux}" ]; then
+			ld=${LDFINAL_vmlinux}
+			ldflags="${LDFLAGS_FINAL_vmlinux} ${LDFLAGS_vmlinux}"
+		fi
+
+		if [[ -n "${CONFIG_THIN_ARCHIVES}" && -z "${CONFIG_LTO_CLANG}" ]]; then
 			objects="--whole-archive built-in.o ${1}"
 		else
 			objects="${KBUILD_VMLINUX_INIT}			\
@@ -92,8 +153,7 @@ vmlinux_link()
 				${1}"
 		fi
 
-		${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}		\
-			-T ${lds} ${objects}
+		${ld} ${ldflags} -o ${2} -T ${lds} ${objects}
 	else
 		if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
 			objects="-Wl,--whole-archive built-in.o ${1}"
@@ -113,7 +173,6 @@ vmlinux_link()
 	fi
 }
 
-
 # Create ${2} .o file with all symbols from the ${1} object file
 kallsyms()
 {
@@ -164,6 +223,7 @@ cleanup()
 	rm -f .tmp_System.map
 	rm -f .tmp_kallsyms*
 	rm -f .tmp_version
+	rm -f .tmp_symversions
 	rm -f .tmp_vmlinux*
 	rm -f built-in.o
 	rm -f System.map
@@ -209,15 +269,6 @@ case "${KCONFIG_CONFIG}" in
 	. "./${KCONFIG_CONFIG}"
 esac
 
-archive_builtin
-
-#link vmlinux.o
-info LD vmlinux.o
-modpost_link vmlinux.o
-
-# modpost vmlinux.o to check for section mismatches
-${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
-
 # Update version
 info GEN .version
 if [ ! -r .version ]; then
@@ -228,9 +279,27 @@ else
 	expr 0$(cat .old_version) + 1 >.version;
 fi;
 
+archive_builtin
+
+#link vmlinux.o
+modpost_link vmlinux.o
+
+# modpost vmlinux.o to check for section mismatches
+${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
+
 # final build of init/
 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}"
 
+if [ -n "${CONFIG_LTO_CLANG}" ]; then
+	# Re-use vmlinux.o, so we can avoid the slow LTO link step in
+	# vmlinux_link
+	KBUILD_VMLINUX_INIT=
+	KBUILD_VMLINUX_MAIN=vmlinux.o
+
+	# Call recordmcount if needed
+	recordmcount vmlinux.o
+fi
+
 kallsymso=""
 kallsyms_vmlinux=""
 if [ -n "${CONFIG_KALLSYMS}" ]; then
diff --git a/scripts/mod/Makefile b/scripts/mod/Makefile
index 19d9bca..247cf1f 100644
--- a/scripts/mod/Makefile
+++ b/scripts/mod/Makefile
@@ -1,4 +1,5 @@
 OBJECT_FILES_NON_STANDARD := y
+CFLAGS_empty.o += $(DISABLE_LTO)
 
 hostprogs-y	:= modpost mk_elfconfig
 always		:= $(hostprogs-y) empty.o
@@ -7,32 +8,8 @@ modpost-objs	:= modpost.o file2alias.o sumversion.o
 
 devicetable-offsets-file := devicetable-offsets.h
 
-define sed-y
-	"/^->/{s:->#\(.*\):/* \1 */:; \
-	s:^->\([^ ]*\) [\$$#]*\([-0-9]*\) \(.*\):#define \1 \2 /* \3 */:; \
-	s:^->\([^ ]*\) [\$$#]*\([^ ]*\) \(.*\):#define \1 \2 /* \3 */:; \
-	s:->::; p;}"
-endef
-
-quiet_cmd_offsets = GEN     $@
-define cmd_offsets
-	(set -e; \
-	 echo "#ifndef __DEVICETABLE_OFFSETS_H__"; \
-	 echo "#define __DEVICETABLE_OFFSETS_H__"; \
-	 echo "/*"; \
-	 echo " * DO NOT MODIFY."; \
-	 echo " *"; \
-	 echo " * This file was generated by Kbuild"; \
-	 echo " *"; \
-	 echo " */"; \
-	 echo ""; \
-	 sed -ne $(sed-y) $<; \
-	 echo ""; \
-	 echo "#endif" ) > $@
-endef
-
-$(obj)/$(devicetable-offsets-file): $(obj)/devicetable-offsets.s
-	$(call if_changed,offsets)
+$(obj)/$(devicetable-offsets-file): $(obj)/devicetable-offsets.s FORCE
+	$(call filechk,offsets,__DEVICETABLE_OFFSETS_H__)
 
 targets += $(devicetable-offsets-file) devicetable-offsets.s
 
diff --git a/scripts/recordmcount.c b/scripts/recordmcount.c
index 5423a58..e0c5082 100644
--- a/scripts/recordmcount.c
+++ b/scripts/recordmcount.c
@@ -366,7 +366,8 @@ static uint32_t w2nat(uint16_t const x)
 		strcmp(".softirqentry.text", txtname) == 0 ||
 		strcmp(".kprobes.text", txtname) == 0 ||
 		strcmp(".cpuidle.text", txtname) == 0 ||
-		strcmp(".text.unlikely", txtname) == 0;
+		(strncmp(".text.",       txtname, 6) == 0 &&
+		 strcmp(".text..ftrace", txtname) != 0);
 }
 
 /* 32 bit and 64 bit are very similar */
diff --git a/security/Kconfig b/security/Kconfig
index 32f36b4..80a2934 100644
--- a/security/Kconfig
+++ b/security/Kconfig
@@ -18,6 +18,15 @@ config SECURITY_DMESG_RESTRICT
 
 	  If you are unsure how to answer this question, answer N.
 
+config SECURITY_PERF_EVENTS_RESTRICT
+	bool "Restrict unprivileged use of performance events"
+	depends on PERF_EVENTS
+	help
+	  If you say Y here, the kernel.perf_event_paranoid sysctl
+	  will be set to 3 by default, and no unprivileged use of the
+	  perf_event_open syscall will be permitted unless it is
+	  changed.
+
 config SECURITY
 	bool "Enable different security models"
 	depends on SYSFS
diff --git a/security/apparmor/lsm.c b/security/apparmor/lsm.c
index 02cc952..1d3b8ab 100644
--- a/security/apparmor/lsm.c
+++ b/security/apparmor/lsm.c
@@ -656,11 +656,11 @@ static int apparmor_task_setrlimit(struct task_struct *task,
 	.get = param_get_aalockpolicy
 };
 
-static int param_set_audit(const char *val, struct kernel_param *kp);
-static int param_get_audit(char *buffer, struct kernel_param *kp);
+static int param_set_audit(const char *val, const struct kernel_param *kp);
+static int param_get_audit(char *buffer, const struct kernel_param *kp);
 
-static int param_set_mode(const char *val, struct kernel_param *kp);
-static int param_get_mode(char *buffer, struct kernel_param *kp);
+static int param_set_mode(const char *val, const struct kernel_param *kp);
+static int param_get_mode(char *buffer, const struct kernel_param *kp);
 
 /* Flag values, also controllable via /sys/module/apparmor/parameters
  * We define special types as we want to do additional mediation.
@@ -774,7 +774,7 @@ static int param_get_aauint(char *buffer, const struct kernel_param *kp)
 	return param_get_uint(buffer, kp);
 }
 
-static int param_get_audit(char *buffer, struct kernel_param *kp)
+static int param_get_audit(char *buffer, const struct kernel_param *kp)
 {
 	if (!policy_view_capable())
 		return -EPERM;
@@ -785,7 +785,7 @@ static int param_get_audit(char *buffer, struct kernel_param *kp)
 	return sprintf(buffer, "%s", audit_mode_names[aa_g_audit]);
 }
 
-static int param_set_audit(const char *val, struct kernel_param *kp)
+static int param_set_audit(const char *val, const struct kernel_param *kp)
 {
 	int i;
 	if (!policy_admin_capable())
@@ -807,7 +807,7 @@ static int param_set_audit(const char *val, struct kernel_param *kp)
 	return -EINVAL;
 }
 
-static int param_get_mode(char *buffer, struct kernel_param *kp)
+static int param_get_mode(char *buffer, const struct kernel_param *kp)
 {
 	if (!policy_admin_capable())
 		return -EPERM;
@@ -818,7 +818,7 @@ static int param_get_mode(char *buffer, struct kernel_param *kp)
 	return sprintf(buffer, "%s", aa_profile_mode_names[aa_g_profile_mode]);
 }
 
-static int param_set_mode(const char *val, struct kernel_param *kp)
+static int param_set_mode(const char *val, const struct kernel_param *kp)
 {
 	int i;
 	if (!policy_admin_capable())
diff --git a/security/commoncap.c b/security/commoncap.c
index 8df676f..1076608 100644
--- a/security/commoncap.c
+++ b/security/commoncap.c
@@ -31,6 +31,10 @@
 #include <linux/binfmts.h>
 #include <linux/personality.h>
 
+#ifdef CONFIG_ANDROID_PARANOID_NETWORK
+#include <linux/android_aid.h>
+#endif
+
 /*
  * If a non-root user executes a setuid-root binary in
  * !secure(SECURE_NOROOT) mode, then we raise capabilities.
@@ -54,7 +58,7 @@ static void warn_setuid_and_fcaps_mixed(const char *fname)
 }
 
 /**
- * cap_capable - Determine whether a task has a particular effective capability
+ * __cap_capable - Determine whether a task has a particular effective capability
  * @cred: The credentials to use
  * @ns:  The user namespace in which we need the capability
  * @cap: The capability to check for
@@ -68,7 +72,7 @@ static void warn_setuid_and_fcaps_mixed(const char *fname)
  * cap_has_capability() returns 0 when a task has a capability, but the
  * kernel's capable() and has_capability() returns 1 for this case.
  */
-int cap_capable(const struct cred *cred, struct user_namespace *targ_ns,
+int __cap_capable(const struct cred *cred, struct user_namespace *targ_ns,
 		int cap, int audit)
 {
 	struct user_namespace *ns = targ_ns;
@@ -103,6 +107,27 @@ int cap_capable(const struct cred *cred, struct user_namespace *targ_ns,
 	/* We never get here */
 }
 
+int cap_capable(const struct cred *cred, struct user_namespace *targ_ns,
+		int cap, int audit)
+{
+	int ret = __cap_capable(cred, targ_ns, cap, audit);
+
+#ifdef CONFIG_ANDROID_PARANOID_NETWORK
+	if (ret != 0 && cap == CAP_NET_RAW && in_egroup_p(AID_NET_RAW)) {
+		printk("Process %s granted CAP_NET_RAW from Android group net_raw.\n", current->comm);
+		printk("  Please update the .rc file to explictly set 'capabilities NET_RAW'\n");
+		printk("  Implicit grants are deprecated and will be removed in the future.\n");
+		return 0;
+	}
+	if (ret != 0 && cap == CAP_NET_ADMIN && in_egroup_p(AID_NET_ADMIN)) {
+		printk("Process %s granted CAP_NET_ADMIN from Android group net_admin.\n", current->comm);
+		printk("  Please update the .rc file to explictly set 'capabilities NET_ADMIN'\n");
+		printk("  Implicit grants are deprecated and will be removed in the future.\n");
+		return 0;
+	}
+#endif
+	return ret;
+}
 /**
  * cap_settime - Determine whether the current process may set the system clock
  * @ts: The time to set
diff --git a/security/inode.c b/security/inode.c
index c83db05..b4531f2 100644
--- a/security/inode.c
+++ b/security/inode.c
@@ -100,7 +100,7 @@ struct dentry *securityfs_create_file(const char *name, umode_t mode,
 	dir = d_inode(parent);
 
 	inode_lock(dir);
-	dentry = lookup_one_len(name, parent, strlen(name));
+	dentry = lookup_one_len2(name, mount, parent, strlen(name));
 	if (IS_ERR(dentry))
 		goto out;
 
diff --git a/security/keys/dh.c b/security/keys/dh.c
index 531ed2e..893af4c 100644
--- a/security/keys/dh.c
+++ b/security/keys/dh.c
@@ -55,7 +55,7 @@ static ssize_t mpi_from_key(key_serial_t keyid, size_t maxlen, MPI *mpi)
 		if (status == 0) {
 			const struct user_key_payload *payload;
 
-			payload = user_key_payload(key);
+			payload = user_key_payload_locked(key);
 
 			if (maxlen == 0) {
 				*mpi = NULL;
diff --git a/security/keys/encrypted-keys/encrypted.c b/security/keys/encrypted-keys/encrypted.c
index ead2fd6..1f3d600 100644
--- a/security/keys/encrypted-keys/encrypted.c
+++ b/security/keys/encrypted-keys/encrypted.c
@@ -313,7 +313,7 @@ static struct key *request_user_key(const char *master_desc, const u8 **master_k
 		goto error;
 
 	down_read(&ukey->sem);
-	upayload = user_key_payload(ukey);
+	upayload = user_key_payload_locked(ukey);
 	if (!upayload) {
 		/* key was revoked before we acquired its semaphore */
 		up_read(&ukey->sem);
@@ -933,7 +933,7 @@ static long encrypted_read(const struct key *key, char __user *buffer,
 	size_t asciiblob_len;
 	int ret;
 
-	epayload = rcu_dereference_key(key);
+	epayload = dereference_key_locked(key);
 
 	/* returns the hex encoded iv, encrypted-data, and hmac as ascii */
 	asciiblob_len = epayload->datablob_len + ivsize + 1
diff --git a/security/keys/trusted.c b/security/keys/trusted.c
index 4ba2f6b..e0fcb17 100644
--- a/security/keys/trusted.c
+++ b/security/keys/trusted.c
@@ -1139,12 +1139,12 @@ static int trusted_update(struct key *key, struct key_preparsed_payload *prep)
 static long trusted_read(const struct key *key, char __user *buffer,
 			 size_t buflen)
 {
-	struct trusted_key_payload *p;
+	const struct trusted_key_payload *p;
 	char *ascii_buf;
 	char *bufp;
 	int i;
 
-	p = rcu_dereference_key(key);
+	p = dereference_key_locked(key);
 	if (!p)
 		return -EINVAL;
 
diff --git a/security/keys/user_defined.c b/security/keys/user_defined.c
index 3dc2607..b4c170a 100644
--- a/security/keys/user_defined.c
+++ b/security/keys/user_defined.c
@@ -107,7 +107,7 @@ int user_update(struct key *key, struct key_preparsed_payload *prep)
 	/* attach the new data, displacing the old */
 	key->expiry = prep->expiry;
 	if (key_is_positive(key))
-		zap = rcu_dereference_key(key);
+		zap = dereference_key_locked(key);
 	rcu_assign_keypointer(key, prep->payload.data[0]);
 	prep->payload.data[0] = NULL;
 
@@ -123,7 +123,7 @@ int user_update(struct key *key, struct key_preparsed_payload *prep)
  */
 void user_revoke(struct key *key)
 {
-	struct user_key_payload *upayload = key->payload.data[0];
+	struct user_key_payload *upayload = user_key_payload_locked(key);
 
 	/* clear the quota */
 	key_payload_reserve(key, 0);
@@ -169,7 +169,7 @@ long user_read(const struct key *key, char __user *buffer, size_t buflen)
 	const struct user_key_payload *upayload;
 	long ret;
 
-	upayload = user_key_payload(key);
+	upayload = user_key_payload_locked(key);
 	ret = upayload->datalen;
 
 	/* we can return the data as is */
diff --git a/security/security.c b/security/security.c
index f825304..99890aa 100644
--- a/security/security.c
+++ b/security/security.c
@@ -11,6 +11,7 @@
  *	(at your option) any later version.
  */
 
+#include <linux/bpf.h>
 #include <linux/capability.h>
 #include <linux/dcache.h>
 #include <linux/module.h>
@@ -508,6 +509,7 @@ int security_path_chown(const struct path *path, kuid_t uid, kgid_t gid)
 		return 0;
 	return call_int_hook(path_chown, 0, path, uid, gid);
 }
+EXPORT_SYMBOL(security_path_chown);
 
 int security_path_chroot(const struct path *path)
 {
@@ -1589,6 +1591,37 @@ int security_audit_rule_match(u32 secid, u32 field, u32 op, void *lsmrule,
 }
 #endif /* CONFIG_AUDIT */
 
+#ifdef CONFIG_BPF_SYSCALL
+int security_bpf(int cmd, union bpf_attr *attr, unsigned int size)
+{
+	return call_int_hook(bpf, 0, cmd, attr, size);
+}
+int security_bpf_map(struct bpf_map *map, fmode_t fmode)
+{
+	return call_int_hook(bpf_map, 0, map, fmode);
+}
+int security_bpf_prog(struct bpf_prog *prog)
+{
+	return call_int_hook(bpf_prog, 0, prog);
+}
+int security_bpf_map_alloc(struct bpf_map *map)
+{
+	return call_int_hook(bpf_map_alloc_security, 0, map);
+}
+int security_bpf_prog_alloc(struct bpf_prog_aux *aux)
+{
+	return call_int_hook(bpf_prog_alloc_security, 0, aux);
+}
+void security_bpf_map_free(struct bpf_map *map)
+{
+	call_void_hook(bpf_map_free_security, map);
+}
+void security_bpf_prog_free(struct bpf_prog_aux *aux)
+{
+	call_void_hook(bpf_prog_free_security, aux);
+}
+#endif /* CONFIG_BPF_SYSCALL */
+
 struct security_hook_heads security_hook_heads = {
 	.binder_set_context_mgr =
 		LIST_HEAD_INIT(security_hook_heads.binder_set_context_mgr),
@@ -1940,4 +1973,20 @@ struct security_hook_heads security_hook_heads = {
 	.audit_rule_free =
 		LIST_HEAD_INIT(security_hook_heads.audit_rule_free),
 #endif /* CONFIG_AUDIT */
+#ifdef CONFIG_BPF_SYSCALL
+	.bpf =
+		LIST_HEAD_INIT(security_hook_heads.bpf),
+	.bpf_map =
+		LIST_HEAD_INIT(security_hook_heads.bpf_map),
+	.bpf_prog =
+		LIST_HEAD_INIT(security_hook_heads.bpf_prog),
+	.bpf_map_alloc_security =
+		LIST_HEAD_INIT(security_hook_heads.bpf_map_alloc_security),
+	.bpf_map_free_security =
+		LIST_HEAD_INIT(security_hook_heads.bpf_map_free_security),
+	.bpf_prog_alloc_security =
+		LIST_HEAD_INIT(security_hook_heads.bpf_prog_alloc_security),
+	.bpf_prog_free_security =
+		LIST_HEAD_INIT(security_hook_heads.bpf_prog_free_security),
+#endif /* CONFIG_BPF_SYSCALL */
 };
diff --git a/security/selinux/hooks.c b/security/selinux/hooks.c
index 8ded808..70b8ac1 100644
--- a/security/selinux/hooks.c
+++ b/security/selinux/hooks.c
@@ -83,6 +83,7 @@
 #include <linux/export.h>
 #include <linux/msg.h>
 #include <linux/shm.h>
+#include <linux/bpf.h>
 
 #include "avc.h"
 #include "objsec.h"
@@ -479,6 +480,7 @@ static int selinux_is_sblabel_mnt(struct super_block *sb)
 		!strcmp(sb->s_type->name, "sysfs") ||
 		!strcmp(sb->s_type->name, "pstore") ||
 		!strcmp(sb->s_type->name, "debugfs") ||
+		!strcmp(sb->s_type->name, "tracefs") ||
 		!strcmp(sb->s_type->name, "rootfs");
 }
 
@@ -797,6 +799,7 @@ static int selinux_set_mnt_opts(struct super_block *sb,
 		sbsec->flags |= SE_SBPROC | SE_SBGENFS;
 
 	if (!strcmp(sb->s_type->name, "debugfs") ||
+	    !strcmp(sb->s_type->name, "tracefs") ||
 	    !strcmp(sb->s_type->name, "sysfs") ||
 	    !strcmp(sb->s_type->name, "pstore"))
 		sbsec->flags |= SE_SBGENFS;
@@ -1745,6 +1748,10 @@ static inline int file_path_has_perm(const struct cred *cred,
 	return inode_has_perm(cred, file_inode(file), av, &ad);
 }
 
+#ifdef CONFIG_BPF_SYSCALL
+static int bpf_fd_pass(struct file *file, u32 sid);
+#endif
+
 /* Check whether a task can use an open file descriptor to
    access an inode in a given way.  Check access to the
    descriptor itself, and then use dentry_has_perm to
@@ -1775,6 +1782,12 @@ static int file_has_perm(const struct cred *cred,
 			goto out;
 	}
 
+#ifdef CONFIG_BPF_SYSCALL
+	rc = bpf_fd_pass(file, cred_sid(cred));
+	if (rc)
+		return rc;
+#endif
+
 	/* av is zero if only checking access to the descriptor. */
 	rc = 0;
 	if (av)
@@ -2104,6 +2117,12 @@ static int selinux_binder_transfer_file(struct task_struct *from,
 			return rc;
 	}
 
+#ifdef CONFIG_BPF_SYSCALL
+	rc = bpf_fd_pass(file, sid);
+	if (rc)
+		return rc;
+#endif
+
 	if (unlikely(IS_PRIVATE(d_backing_inode(dentry))))
 		return 0;
 
@@ -6073,6 +6092,139 @@ static int selinux_key_getsecurity(struct key *key, char **_buffer)
 
 #endif
 
+#ifdef CONFIG_BPF_SYSCALL
+static int selinux_bpf(int cmd, union bpf_attr *attr,
+				     unsigned int size)
+{
+	u32 sid = current_sid();
+	int ret;
+
+	switch (cmd) {
+	case BPF_MAP_CREATE:
+		ret = avc_has_perm(sid, sid, SECCLASS_BPF, BPF__MAP_CREATE,
+				   NULL);
+		break;
+	case BPF_PROG_LOAD:
+		ret = avc_has_perm(sid, sid, SECCLASS_BPF, BPF__PROG_LOAD,
+				   NULL);
+		break;
+	default:
+		ret = 0;
+		break;
+	}
+
+	return ret;
+}
+
+static u32 bpf_map_fmode_to_av(fmode_t fmode)
+{
+	u32 av = 0;
+
+	if (fmode & FMODE_READ)
+		av |= BPF__MAP_READ;
+	if (fmode & FMODE_WRITE)
+		av |= BPF__MAP_WRITE;
+	return av;
+}
+
+/* This function will check the file pass through unix socket or binder to see
+ * if it is a bpf related object. And apply correspinding checks on the bpf
+ * object based on the type. The bpf maps and programs, not like other files and
+ * socket, are using a shared anonymous inode inside the kernel as their inode.
+ * So checking that inode cannot identify if the process have privilege to
+ * access the bpf object and that's why we have to add this additional check in
+ * selinux_file_receive and selinux_binder_transfer_files.
+ */
+static int bpf_fd_pass(struct file *file, u32 sid)
+{
+	struct bpf_security_struct *bpfsec;
+	struct bpf_prog *prog;
+	struct bpf_map *map;
+	int ret;
+
+	if (file->f_op == &bpf_map_fops) {
+		map = file->private_data;
+		bpfsec = map->security;
+		ret = avc_has_perm(sid, bpfsec->sid, SECCLASS_BPF,
+				   bpf_map_fmode_to_av(file->f_mode), NULL);
+		if (ret)
+			return ret;
+	} else if (file->f_op == &bpf_prog_fops) {
+		prog = file->private_data;
+		bpfsec = prog->aux->security;
+		ret = avc_has_perm(sid, bpfsec->sid, SECCLASS_BPF,
+				   BPF__PROG_RUN, NULL);
+		if (ret)
+			return ret;
+	}
+	return 0;
+}
+
+static int selinux_bpf_map(struct bpf_map *map, fmode_t fmode)
+{
+	u32 sid = current_sid();
+	struct bpf_security_struct *bpfsec;
+
+	bpfsec = map->security;
+	return avc_has_perm(sid, bpfsec->sid, SECCLASS_BPF,
+			    bpf_map_fmode_to_av(fmode), NULL);
+}
+
+static int selinux_bpf_prog(struct bpf_prog *prog)
+{
+	u32 sid = current_sid();
+	struct bpf_security_struct *bpfsec;
+
+	bpfsec = prog->aux->security;
+	return avc_has_perm(sid, bpfsec->sid, SECCLASS_BPF,
+			    BPF__PROG_RUN, NULL);
+}
+
+static int selinux_bpf_map_alloc(struct bpf_map *map)
+{
+	struct bpf_security_struct *bpfsec;
+
+	bpfsec = kzalloc(sizeof(*bpfsec), GFP_KERNEL);
+	if (!bpfsec)
+		return -ENOMEM;
+
+	bpfsec->sid = current_sid();
+	map->security = bpfsec;
+
+	return 0;
+}
+
+static void selinux_bpf_map_free(struct bpf_map *map)
+{
+	struct bpf_security_struct *bpfsec = map->security;
+
+	map->security = NULL;
+	kfree(bpfsec);
+}
+
+static int selinux_bpf_prog_alloc(struct bpf_prog_aux *aux)
+{
+	struct bpf_security_struct *bpfsec;
+
+	bpfsec = kzalloc(sizeof(*bpfsec), GFP_KERNEL);
+	if (!bpfsec)
+		return -ENOMEM;
+
+	bpfsec->sid = current_sid();
+	aux->security = bpfsec;
+
+	return 0;
+}
+
+static void selinux_bpf_prog_free(struct bpf_prog_aux *aux)
+{
+	struct bpf_security_struct *bpfsec = aux->security;
+
+	aux->security = NULL;
+	kfree(bpfsec);
+}
+#endif
+
 static struct security_hook_list selinux_hooks[] = {
 	LSM_HOOK_INIT(binder_set_context_mgr, selinux_binder_set_context_mgr),
 	LSM_HOOK_INIT(binder_transaction, selinux_binder_transaction),
@@ -6287,6 +6439,16 @@ static int selinux_key_getsecurity(struct key *key, char **_buffer)
 	LSM_HOOK_INIT(audit_rule_match, selinux_audit_rule_match),
 	LSM_HOOK_INIT(audit_rule_free, selinux_audit_rule_free),
 #endif
+
+#ifdef CONFIG_BPF_SYSCALL
+	LSM_HOOK_INIT(bpf, selinux_bpf),
+	LSM_HOOK_INIT(bpf_map, selinux_bpf_map),
+	LSM_HOOK_INIT(bpf_prog, selinux_bpf_prog),
+	LSM_HOOK_INIT(bpf_map_alloc_security, selinux_bpf_map_alloc),
+	LSM_HOOK_INIT(bpf_prog_alloc_security, selinux_bpf_prog_alloc),
+	LSM_HOOK_INIT(bpf_map_free_security, selinux_bpf_map_free),
+	LSM_HOOK_INIT(bpf_prog_free_security, selinux_bpf_prog_free),
+#endif
 };
 
 static __init int selinux_init(void)
diff --git a/security/selinux/include/classmap.h b/security/selinux/include/classmap.h
index 1f1f4b2..963ff80 100644
--- a/security/selinux/include/classmap.h
+++ b/security/selinux/include/classmap.h
@@ -165,5 +165,7 @@ struct security_class_mapping secclass_map[] = {
 	  { COMMON_CAP_PERMS, NULL } },
 	{ "cap2_userns",
 	  { COMMON_CAP2_PERMS, NULL } },
+	{ "bpf",
+	  {"map_create", "map_read", "map_write", "prog_load", "prog_run"} },
 	{ NULL }
   };
diff --git a/security/selinux/include/objsec.h b/security/selinux/include/objsec.h
index c21e135..43535cd 100644
--- a/security/selinux/include/objsec.h
+++ b/security/selinux/include/objsec.h
@@ -128,6 +128,10 @@ struct key_security_struct {
 	u32 sid;	/* SID of key */
 };
 
+struct bpf_security_struct {
+	u32 sid;  /*SID of bpf obj creater*/
+};
+
 extern unsigned int selinux_checkreqprot;
 
 #endif /* _SELINUX_OBJSEC_H_ */
diff --git a/security/selinux/ss/avtab.c b/security/selinux/ss/avtab.c
index 3628d3a..3134537 100644
--- a/security/selinux/ss/avtab.c
+++ b/security/selinux/ss/avtab.c
@@ -374,6 +374,32 @@ void avtab_hash_eval(struct avtab *h, char *tag)
 	       chain2_len_sum);
 }
 
+/*
+ * extended permissions compatibility. Make ToT Android kernels compatible
+ * with Android M releases
+ */
+#define AVTAB_OPTYPE_ALLOWED	0x1000
+#define AVTAB_OPTYPE_AUDITALLOW	0x2000
+#define AVTAB_OPTYPE_DONTAUDIT	0x4000
+#define AVTAB_OPTYPE		(AVTAB_OPTYPE_ALLOWED | \
+				AVTAB_OPTYPE_AUDITALLOW | \
+				AVTAB_OPTYPE_DONTAUDIT)
+#define AVTAB_XPERMS_OPTYPE	4
+
+#define avtab_xperms_to_optype(x) (x << AVTAB_XPERMS_OPTYPE)
+#define avtab_optype_to_xperms(x) (x >> AVTAB_XPERMS_OPTYPE)
+
+static unsigned int avtab_android_m_compat;
+
+static void avtab_android_m_compat_set(void)
+{
+	if (!avtab_android_m_compat) {
+		pr_info("SELinux:  Android master kernel running Android"
+				" M policy in compatibility mode.\n");
+		avtab_android_m_compat = 1;
+	}
+}
+
 static uint16_t spec_order[] = {
 	AVTAB_ALLOWED,
 	AVTAB_AUDITDENY,
@@ -398,6 +424,7 @@ int avtab_read_item(struct avtab *a, void *fp, struct policydb *pol,
 	struct avtab_datum datum;
 	struct avtab_extended_perms xperms;
 	__le32 buf32[ARRAY_SIZE(xperms.perms.p)];
+	unsigned int android_m_compat_optype = 0;
 	int i, rc;
 	unsigned set;
 
@@ -488,6 +515,13 @@ int avtab_read_item(struct avtab *a, void *fp, struct policydb *pol,
 	key.target_class = le16_to_cpu(buf16[items++]);
 	key.specified = le16_to_cpu(buf16[items++]);
 
+	if ((key.specified & AVTAB_OPTYPE) &&
+			(vers == POLICYDB_VERSION_XPERMS_IOCTL)) {
+		key.specified = avtab_optype_to_xperms(key.specified);
+		android_m_compat_optype = 1;
+		avtab_android_m_compat_set();
+	}
+
 	if (!policydb_type_isvalid(pol, key.source_type) ||
 	    !policydb_type_isvalid(pol, key.target_type) ||
 	    !policydb_class_isvalid(pol, key.target_class)) {
@@ -518,10 +552,22 @@ int avtab_read_item(struct avtab *a, void *fp, struct policydb *pol,
 			printk(KERN_ERR "SELinux: avtab: truncated entry\n");
 			return rc;
 		}
-		rc = next_entry(&xperms.driver, fp, sizeof(u8));
-		if (rc) {
-			printk(KERN_ERR "SELinux: avtab: truncated entry\n");
-			return rc;
+		if (avtab_android_m_compat ||
+			    ((xperms.specified != AVTAB_XPERMS_IOCTLFUNCTION) &&
+			    (xperms.specified != AVTAB_XPERMS_IOCTLDRIVER) &&
+			    (vers == POLICYDB_VERSION_XPERMS_IOCTL))) {
+			xperms.driver = xperms.specified;
+			if (android_m_compat_optype)
+				xperms.specified = AVTAB_XPERMS_IOCTLDRIVER;
+			else
+				xperms.specified = AVTAB_XPERMS_IOCTLFUNCTION;
+			avtab_android_m_compat_set();
+		} else {
+			rc = next_entry(&xperms.driver, fp, sizeof(u8));
+			if (rc) {
+				printk(KERN_ERR "SELinux: avtab: truncated entry\n");
+				return rc;
+			}
 		}
 		rc = next_entry(buf32, fp, sizeof(u32)*ARRAY_SIZE(xperms.perms.p));
 		if (rc) {
@@ -607,15 +653,22 @@ int avtab_write_item(struct policydb *p, struct avtab_node *cur, void *fp)
 	buf16[0] = cpu_to_le16(cur->key.source_type);
 	buf16[1] = cpu_to_le16(cur->key.target_type);
 	buf16[2] = cpu_to_le16(cur->key.target_class);
-	buf16[3] = cpu_to_le16(cur->key.specified);
+	if (avtab_android_m_compat && (cur->key.specified & AVTAB_XPERMS) &&
+		    (cur->datum.u.xperms->specified == AVTAB_XPERMS_IOCTLDRIVER))
+		buf16[3] = cpu_to_le16(avtab_xperms_to_optype(cur->key.specified));
+	else
+		buf16[3] = cpu_to_le16(cur->key.specified);
 	rc = put_entry(buf16, sizeof(u16), 4, fp);
 	if (rc)
 		return rc;
 
 	if (cur->key.specified & AVTAB_XPERMS) {
-		rc = put_entry(&cur->datum.u.xperms->specified, sizeof(u8), 1, fp);
-		if (rc)
-			return rc;
+		if (avtab_android_m_compat == 0) {
+			rc = put_entry(&cur->datum.u.xperms->specified,
+					sizeof(u8), 1, fp);
+			if (rc)
+				return rc;
+		}
 		rc = put_entry(&cur->datum.u.xperms->driver, sizeof(u8), 1, fp);
 		if (rc)
 			return rc;
diff --git a/sound/arm/Kconfig b/sound/arm/Kconfig
index 65171f6..cbf3b29 100644
--- a/sound/arm/Kconfig
+++ b/sound/arm/Kconfig
@@ -2,7 +2,7 @@
 
 menuconfig SND_ARM
 	bool "ARM sound devices"
-	depends on ARM
+	depends on ARM || ARM64
 	default y
 	help
 	  Support for sound devices specific to ARM architectures.
@@ -32,6 +32,20 @@ config SND_PXA2XX_AC97
 	  Say Y or M if you want to support any AC97 codec attached to
 	  the PXA2xx AC97 interface.
 
+config SND_REALTEK
+	tristate "REALTEK ALSA Driver"
+	select SND_PCM
+	select SND_SOC_COMPRESS
+	default y
+	
+config SND_REALTEK_AARCH32
+	tristate "REALTEK AARCH32 ALSA Driver"
+	default n
+
+config REALTEK_FL3236
+	tristate "REALTEK Feature for fl3236 light driver"
+	default n
+
 endif	# SND_ARM
 
 config SND_PXA2XX_LIB
@@ -40,4 +54,4 @@ config SND_PXA2XX_LIB
 	select SND_DMAENGINE_PCM
 
 config SND_PXA2XX_LIB_AC97
-	bool
+	bool
\ No newline at end of file
diff --git a/sound/arm/Makefile b/sound/arm/Makefile
index 8c0c851..d60080e 100644
--- a/sound/arm/Makefile
+++ b/sound/arm/Makefile
@@ -2,6 +2,9 @@
 # Makefile for ALSA
 #
 
+ccflags-y += -I$(srctree)/drivers/soc/realtek/common/rpc
+ccflags-y += -Werror
+
 obj-$(CONFIG_SND_ARMAACI)	+= snd-aaci.o
 snd-aaci-objs			:= aaci.o
 
@@ -14,3 +17,8 @@ snd-pxa2xx-lib-$(CONFIG_SND_PXA2XX_LIB_AC97)	+= pxa2xx-ac97-lib.o
 
 obj-$(CONFIG_SND_PXA2XX_AC97)	+= snd-pxa2xx-ac97.o
 snd-pxa2xx-ac97-objs		:= pxa2xx-ac97.o
+
+obj-$(CONFIG_SND_REALTEK)	+= snd-realtek-driver.o
+snd-realtek-driver-objs	:= snd-realtek.o snd-realtek-compress.o snd-realtek_RPC.o snd-realtek-notify.o
+
+obj-$(CONFIG_REALTEK_FL3236)	+= fl3236.o
\ No newline at end of file
diff --git a/sound/arm/fl3236.c b/sound/arm/fl3236.c
new file mode 100644
index 00000000..4d30135
--- /dev/null
+++ b/sound/arm/fl3236.c
@@ -0,0 +1,271 @@
+/*
+ * fl3236.c  --  FL3236 SPI driver
+ *
+ * Copyright 2018 Realtek Semiconductor Corp.
+ * Author: YH HSIEH <yh_hsieh@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/input.h>
+#include <linux/spi/spi.h>
+#include <linux/device.h>
+#include <linux/init.h>
+#include <linux/delay.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/slab.h>
+#include <linux/gpio.h>
+#include <linux/sched.h>
+#include <linux/kthread.h>
+#include <linux/uaccess.h>
+#include <linux/miscdevice.h>
+#include <linux/pm_qos.h>
+#include <linux/sysfs.h>
+#include <linux/clk.h>
+#include <sound/core.h>
+#include <sound/pcm.h>
+#include <sound/pcm_params.h>
+#include <sound/soc.h>
+#include <sound/soc-dapm.h>
+#include <sound/initval.h>
+#include <linux/i2c.h>
+#include <linux/of_gpio.h>
+#include <soc/realtek/rtk_regmap.h>
+
+int voice_direction_from_user = 0;
+int fl3236_check_flag = 0;
+
+static ssize_t fl3236_light_store(struct device *dev,
+						struct device_attribute *attr,
+						const char *buf,
+						size_t count)
+{
+	unsigned long long direction;
+	if(!kstrtoull(buf, 10, &direction))
+		voice_direction_from_user = (int)direction;
+	printk("%s before write %d\n", __func__, voice_direction_from_user);
+	voice_direction_from_user = voice_direction_from_user - 180; //shift degree
+	printk("%s after write %d\n", __func__, voice_direction_from_user);
+	return count;
+}
+
+static ssize_t fl3236_light_show(struct device *dev,
+					       struct device_attribute *attr,
+					       char *buf)
+{
+	return 0;
+}
+
+static DEVICE_ATTR(light, 0644,
+		   fl3236_light_show,
+		   fl3236_light_store);
+
+static struct attribute *fl3236_light_dev_attrs[] = {
+	&dev_attr_light.attr,
+	NULL
+};
+
+static const struct attribute_group fl3236_dev_group = {
+	.name = "fl3236_light",
+	.attrs = fl3236_light_dev_attrs,
+};
+
+static int fl3236_add_sysfs(struct device *dev)
+{
+	return sysfs_create_group(&dev->kobj, &fl3236_dev_group);
+}
+
+/*****************************************************************************
+******* below fl3236 led i2c driver                                  *********
+******************************************************************************
+*/
+static uint8_t voice_led_position_01 = 9;
+static uint8_t voice_led_position_02 = 8;
+
+static void convert_mic_position_to_led_position(int voice_direction) {
+
+	if ( voice_direction > 0 && voice_direction <= 30 ) {
+		voice_led_position_01 =  6;
+		voice_led_position_02 =  5;
+	} else if ( voice_direction > 30 && voice_direction <= 60 ) {
+		voice_led_position_01 =  5;
+		voice_led_position_02 =  4;
+	} else if ( voice_direction > 60 && voice_direction <= 90 ) {
+		voice_led_position_01 =  4;
+		voice_led_position_02 =  3;
+	} else if ( voice_direction > 90 && voice_direction <= 120 ) {
+		voice_led_position_01 =  3;
+		voice_led_position_02 =  2;
+	} else if ( voice_direction > 120 && voice_direction <= 150 ) {
+		voice_led_position_01 =  2;
+		voice_led_position_02 =  1;
+	} else if ( voice_direction > 150 && voice_direction <= 180 ) {
+		voice_led_position_01 =  1;
+		voice_led_position_02 =  12;
+	} else if ( voice_direction >= -180 && voice_direction <= -150 ) {
+		voice_led_position_01 =  12;
+		voice_led_position_02 =  11;
+	} else if ( voice_direction >= -150 && voice_direction <= -120 ) {
+		voice_led_position_01 =  11;
+		voice_led_position_02 =  10;
+	} else if ( voice_direction >= -120 && voice_direction <= -90 ) {
+		voice_led_position_01 =  10;
+		voice_led_position_02 =  9;
+	} else if ( voice_direction >= -90 && voice_direction <= -60 ) {
+		voice_led_position_01 = 9;
+		voice_led_position_02 = 8;
+	} else if ( voice_direction >= -60 && voice_direction <= -30 ) {
+		voice_led_position_01 = 8;
+		voice_led_position_02 = 7;
+	} else if ( voice_direction >= -30 && voice_direction <= -0 ) {
+		voice_led_position_01 = 7;
+		voice_led_position_02 = 6;
+	} else {
+		printk("unknown voice position:%d\r\n", voice_direction);
+		voice_led_position_01 =  0xFF;
+		voice_led_position_02 =  0xFF;
+	}
+}
+
+struct fl3236_priv {
+
+	struct regmap *regmap;
+};
+
+struct fl3236_priv *fl3236;
+
+static void fl3236_set_led(uint8_t led_position_01, uint8_t  led_position_02, int on_off)
+{
+	/* pwm luminous intensity */
+	regmap_write(fl3236->regmap, 0x01+(led_position_01-1)*3, 0x80);
+	regmap_write(fl3236->regmap, 0x01+(led_position_02-1)*3, 0x80);
+	regmap_write(fl3236->regmap, 0x01+(led_position_01-1)*3 + 1, 0x80);
+	regmap_write(fl3236->regmap, 0x01+(led_position_02-1)*3 + 1, 0x80);
+	regmap_write(fl3236->regmap, 0x01+(led_position_01-1)*3 + 2, 0x80);
+	regmap_write(fl3236->regmap, 0x01+(led_position_02-1)*3 + 2, 0x80);
+
+	/* LED Control */
+	regmap_write(fl3236->regmap, 0x26+(led_position_01-1)*3, on_off);
+	regmap_write(fl3236->regmap, 0x26+(led_position_02-1)*3, on_off);
+	regmap_write(fl3236->regmap, 0x26+(led_position_01-1)*3 + 1, on_off);
+	regmap_write(fl3236->regmap, 0x26+(led_position_02-1)*3 + 1, on_off);
+	regmap_write(fl3236->regmap, 0x26+(led_position_01-1)*3 + 2, on_off);
+	regmap_write(fl3236->regmap, 0x26+(led_position_02-1)*3 + 2, on_off);
+
+	/* pwm Update */
+	regmap_write(fl3236->regmap, 0x25, 0);
+}
+
+void fl3236_enable_light(void)
+{
+	int i;
+
+	if(!fl3236_check_flag)
+		return;
+
+	/* all LED off */
+	for (i = 1; i < 12 ; i++)
+		fl3236_set_led(i, i+1, 0);
+
+	/* Get the voice direction and show the light*/
+	convert_mic_position_to_led_position(voice_direction_from_user);
+	fl3236_set_led(voice_led_position_01, voice_led_position_02, 1);
+}
+
+void fl3236_disable_light(void)
+{
+	int i;
+
+	if(!fl3236_check_flag)
+		return;
+
+	/* all LED off */
+	for (i = 1; i < 12 ; i++)
+		fl3236_set_led(i, i+1, 0);
+}
+
+static const struct regmap_config fl3236_regmap = {
+	.reg_bits = 8,
+	.val_bits = 8,
+	.max_register = 0xffff,
+};
+
+static int fl3236_i2c_probe(struct i2c_client *i2c,
+                             const struct i2c_device_id *id)
+{
+	int i;
+	void __iomem	*pad_mux;
+
+	pr_err("%s id->name =%s i2c->name=%s i2c->addr=0x%x \n", __func__, id->name, i2c->name, i2c->addr);
+	fl3236 = devm_kzalloc(&i2c->dev, sizeof(struct fl3236_priv),
+						GFP_KERNEL);
+	if (fl3236 == NULL)
+		return -ENOMEM;
+
+	fl3236->regmap = devm_rtk_regmap_init_i2c(i2c, &fl3236_regmap);
+
+	fl3236_add_sysfs(&i2c->dev);
+
+	/* Set the hif_clf for sda 4 */
+	pad_mux = ioremap(0x9804F000, 0x120);
+	writel(0x75555554, pad_mux);
+
+	/* Set the pad_mux for i2c sda 4 */
+	pad_mux = ioremap(0x9804F004, 0x120);
+	writel(0x2492924B, pad_mux);
+
+	if (IS_ERR(fl3236->regmap))
+		return PTR_ERR(fl3236->regmap);
+
+	/* Reset */
+	regmap_write(fl3236->regmap, 0x4f, 0);
+
+	/* Normal operation */
+	regmap_write(fl3236->regmap, 0x00, 1);
+
+	/* all LED on */
+	for (i = 1; i < 12 ; i++)
+		fl3236_set_led(i, i+1, 1);
+
+	mdelay(1000);
+
+	for (i = 1; i < 12 ; i++)
+		fl3236_set_led(i, i+1, 0);
+
+	/* check fl3236 enable success */
+	fl3236_check_flag = 1;
+
+	return 0;
+}
+
+static const struct i2c_device_id fl3236_i2c_id[] = {
+	{ "fl3236", 0 },
+	{ }
+};
+MODULE_DEVICE_TABLE(i2c, fl3236_i2c_id);
+
+static const struct of_device_id fl3236_of_id[] = {
+	{ .compatible = "fl3236", },
+	{ /* senitel */ }
+};
+MODULE_DEVICE_TABLE(of, fl3236_of_id);
+
+static struct i2c_driver fl3236_i2c_driver = {
+	.driver = {
+		.name = "rtk,fl3236",
+		.owner = THIS_MODULE,
+	},
+	.probe =    fl3236_i2c_probe,
+//	.remove =   fl3236_i2c_remove,
+	.id_table = fl3236_i2c_id,
+};
+
+module_i2c_driver(fl3236_i2c_driver);
+
+MODULE_AUTHOR("YH HSIEH");
+MODULE_DESCRIPTION("FL3236 Kernel Driver");
+MODULE_LICENSE("GPL");
diff --git a/sound/arm/snd-realtek-compress.c b/sound/arm/snd-realtek-compress.c
new file mode 100644
index 00000000..65b769e
--- /dev/null
+++ b/sound/arm/snd-realtek-compress.c
@@ -0,0 +1,2184 @@
+/**
+ * snd-realtek-compress.c - Realtek alsa driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/init.h>
+#include <linux/jiffies.h>
+#include <linux/slab.h>
+#include <linux/time.h>
+#include <linux/wait.h>
+#include <linux/moduleparam.h>
+#include <linux/delay.h>
+#include <sound/core.h>
+#include <sound/control.h>
+#include <sound/pcm.h>
+#include <sound/rawmidi.h>
+#include <sound/initval.h>
+#include <linux/mutex.h>
+#include <linux/ioctl.h> /* needed for the _IOW etc stuff used later */
+#include <linux/syscalls.h> /* needed for the _IOW etc stuff used later */
+#include <linux/mpage.h>
+#include <linux/dcache.h>
+#include <linux/timer.h>
+#include <linux/workqueue.h>
+#include <linux/dma-mapping.h>
+#include <linux/math64.h>
+#include <sound/asound.h>
+#include <sound/compress_driver.h>
+#include <asm/cacheflush.h>
+#include "snd-realtek.h"
+#include "snd-realtek-compress.h"
+
+extern struct ion_client *alsa_client;
+static struct ion_handle *rtk_compress_handle;
+static struct ion_handle *compr_inRing_handle;
+static struct ion_handle *compr_inband_handle;
+static struct ion_handle *compr_dwnstrm_handle;
+static struct ion_handle *compr_outRing_handle[8];
+static struct ion_handle *refclock_handle;
+
+static struct ion_handle *rawdelay_handle = NULL;
+static struct ion_handle *rawdelay_handle2 = NULL;
+static int mtotal_latency = 0;
+static int *rawdelay_mem = NULL;
+static ALSA_RAW_LATENCY *rawdelay_mem2 = NULL;
+static ion_phys_addr_t phy_rawdelay = 0;
+static ion_phys_addr_t phy_rawdelay2 = 0;
+static int hw_avsync_header_offset = 0;
+
+/*	DHCHERC-219:
+	There has some noise when multi-video playing specific video.
+ */
+static char *header_handle_buf1 = NULL;
+static char *header_handle_buf2 = NULL;
+static int header_handle_flag = 0;
+static int header_handle_len = 0;
+static int delim_check_format = 1;
+static int delim_format = 0;
+static int delim_header_size = 0;
+static bool compress_first_pts = false;
+
+//#define DEC_IN_BUFFER_SIZE       (128 * 1024)
+#define DEC_OUT_BUFFER_SIZE      (36 * 1024)
+#define DEC_OUT_BUFFER_SIZE_LOW  (8 * 1024)
+#define DEC_INBAND_BUFFER_SIZE   (16 * 1024)
+#define DEC_DWNSTRM_BUFFER_SIZE  (32 * 1024)
+
+#define AUDIO_DEC_OUTPIN         8
+
+#define NUM_CODEC                7
+#define MIN_FRAGMENT             2 
+#define MAX_FRAGMENT             16
+#define MIN_FRAGMENT_SIZE        (1024) //(50 * 1024)
+#define MAX_FRAGMENT_SIZE        (8192*64) //(1024 * 1024)
+
+#define ENDIAN_CHANGE(x) ((((x)&0xff000000)>>24)|(((x)&0x00ff0000)>>8)|(((x)&0x0000ff00)<<8)|(((x)&0x000000ff)<<24))
+#define RAWDELAY_MEM_SIZE        8
+#define AUTOMASTER_NOT_MASTER    0
+#define SHARE_MEM_SIZE_RAW_LATENCY sizeof(ALSA_RAW_LATENCY)
+
+typedef struct rtk_runtime_stream {
+    //RTK_snd_card_t *card;
+    //struct snd_compr_stream* cstream;
+    int audioDecId;
+    int audioPPId;
+    int audioOutId;
+    int audioDecPinId;
+    int audioAppPinId;
+
+    unsigned int codecId;
+    unsigned int audioChannel;
+    unsigned int audioSamplingRate;
+    long lastInRingRP;
+    bool isGetInfo;
+    bool isLowWater;
+    bool isRPCsetOutputMode;
+
+    int status;
+    size_t bytes_written; 
+    size_t copied_total;
+    size_t comsume_total;
+    unsigned long outFrames;
+//    unsigned long preOutFrames;
+
+    // ringbuffer header
+    RINGBUFFER_HEADER decInRingHeader;
+    RINGBUFFER_HEADER decInbandRingHeader;
+    RINGBUFFER_HEADER dwnstrmRingHeader;
+    RINGBUFFER_HEADER decOutRingHeader[8];
+
+    //virtual address of ringbuffer
+    unsigned char* virDecInRing;
+    unsigned char* virInbandRing;
+    unsigned char* virDwnRing;
+    unsigned char* virDecOutRing[8];
+
+    unsigned char* virDwnRingLower;
+    unsigned char* virDwnRingUpper;
+
+    unsigned char* virDecOutRingLower[8];
+    unsigned char* virDecOutRingUpper[8];
+
+    //physical address of ringbuffer
+    ion_phys_addr_t phyDecInRing;
+    ion_phys_addr_t phyDecInbandRing;
+    ion_phys_addr_t phyDecDwnstrmRing;
+    ion_phys_addr_t phyDecOutRing[8];
+
+    REFCLOCK* refclock;
+    ion_phys_addr_t phyRefclock;
+
+    ion_phys_addr_t phy_addr;
+} rtk_runtime_stream_t;
+
+typedef enum {
+    BS,
+    COMMAND
+} DELIVER_WHAT;
+
+unsigned long reverseInteger(unsigned long value) {
+    unsigned long b0 = value & 0x000000ff;
+    unsigned long b1 = (value & 0x0000ff00) >> 8;
+    unsigned long b2 = (value & 0x00ff0000) >> 16;
+    unsigned long b3 = (value & 0xff000000) >> 24;
+    return (b0 << 24) | (b1 << 16) | (b2 << 8) | b3;
+}
+
+void pli_IPCCopyMemory(unsigned char* src, unsigned char* des, unsigned long len) {
+#if 0
+    unsigned long i;
+    unsigned long *psrc, *pdes;
+
+    if ((((unsigned long)src & 0x3) != 0) || (((unsigned long)des & 0x3) != 0) || ((len & 0x3) != 0))
+        TRACE_CODE("error in pli_IPCCopyMemory()...\n");
+
+    for (i = 0; i < len; i+=4) {
+        psrc = (unsigned long *)&src[i];
+        pdes = (unsigned long *)&des[i];
+        *pdes = reverseInteger(*psrc);
+        //TRACE_CODE("%x, %x...\n", src[i], des[i]);
+    }
+#else
+    volatile unsigned char * pdes = (volatile unsigned char *) des;
+    volatile unsigned char * psrc = (volatile unsigned char *) src;
+    int i;
+    //printk("[%s] des:%p src:%p size:%lu\n", __func__, des, src, len);
+    for (i = 0; i < len; i+=4)
+        writel(__cpu_to_be32(readl(&psrc[i])), &pdes[i]);
+#endif
+}
+
+void MyMemcpy(DELIVER_WHAT type, unsigned char *pSrc, unsigned char *pDes, long size) {
+    if (type == COMMAND) {
+        pli_IPCCopyMemory(pSrc, pDes, size);
+    }
+    else {
+        memcpy(pDes, pSrc, size);
+    }
+}
+
+unsigned long GetBufferFromRing(unsigned char* upper, unsigned char* lower, unsigned char* rptr, unsigned char* dest, unsigned long size) {
+    unsigned long space = 0;
+    if (rptr + size < upper) {
+        MyMemcpy(COMMAND, rptr, dest, size);
+    } else {
+        space = upper - rptr;
+        //ALOGD("wrap around space %u\n", space);
+        MyMemcpy(COMMAND, rptr, dest, space);
+        if(size > space)
+            MyMemcpy(COMMAND, lower, dest + space, size - space);
+    }
+    return space;
+}
+
+void UpdateRingPtr(unsigned char* upper, unsigned char* lower, unsigned char* rptr,
+    rtk_runtime_stream_t *stream, unsigned long size, unsigned long space) {
+    //TRACE_CODE("%s %d rptr %x size %d upper %x\n", __FUNCTION__, __LINE__, rptr, size, upper);
+    if ((rptr + size) < upper) {
+        stream->dwnstrmRingHeader.readPtr[0] = ntohl(ntohl(stream->dwnstrmRingHeader.readPtr[0]) + size);
+        //TRACE_CODE("%s %d rp %x\n", __FUNCTION__, __LINE__, stream->virDwnRing + (ntohl(stream->dwnstrmRingHeader.readPtr[0]) - ntohl(stream->dwnstrmRingHeader.beginAddr)));
+    } else {
+        stream->dwnstrmRingHeader.readPtr[0] = ntohl(ntohl(stream->dwnstrmRingHeader.beginAddr) + size - space);
+        //TRACE_CODE("%s %d rp %x\n", __FUNCTION__, __LINE__, stream->virDwnRing + (ntohl(stream->dwnstrmRingHeader.readPtr[0]) - ntohl(stream->dwnstrmRingHeader.beginAddr)));
+    }
+}
+
+static long ringValidData(long ring_base, long ring_limit, long ring_rp, long ring_wp) {
+    if (ring_wp >= ring_rp) {
+        return (ring_wp - ring_rp);
+    } else {
+        return (ring_limit - ring_base) - (ring_rp - ring_wp);
+    }
+}
+
+static long validFreeSize(long base, long limit, long rp, long wp) {
+    return (limit - base) - ringValidData(base, limit, rp, wp) - 1;
+}
+
+long GetGeneralInstanceID(long instanceID, long pinID) {
+    return ((instanceID & 0xFFFFF000) | (pinID & 0xFFF));
+}
+
+void resetPointer (rtk_runtime_stream_t *stream)
+{
+    stream->copied_total = 0;
+    stream->comsume_total = 0;
+    stream->bytes_written = 0;
+    stream->outFrames = 0;
+    stream->isGetInfo = false;
+    stream->dwnstrmRingHeader.readPtr[0] = stream->dwnstrmRingHeader.writePtr;
+    stream->lastInRingRP = (long)ntohl(stream->decInRingHeader.writePtr);
+    mtotal_latency = 0;
+}
+
+void dumptr(rtk_runtime_stream_t *stream , int i)
+{
+    long inwp, inrp, banwp, bandrp, outwp, outrp, outbanwp, outbanrp;
+    inwp = (long)ENDIAN_CHANGE(stream->decInRingHeader.writePtr);
+    inrp = (long)ENDIAN_CHANGE(stream->decInRingHeader.readPtr[0]);
+    bandrp = (long)ENDIAN_CHANGE(stream->decInbandRingHeader.readPtr[0]);
+    banwp = (long)ENDIAN_CHANGE(stream->decInbandRingHeader.writePtr);
+    outrp = (long)ENDIAN_CHANGE(stream->decOutRingHeader[0].readPtr[0]);
+    outwp = (long)ENDIAN_CHANGE(stream->decOutRingHeader[0].writePtr);
+    outbanrp = (long)ENDIAN_CHANGE(stream->dwnstrmRingHeader.readPtr[0]);
+    outbanwp = (long)ENDIAN_CHANGE(stream->dwnstrmRingHeader.writePtr);
+    printk("i %d point Iwp %lx Irp %lx IBwp %lx IBrp %lx Owp %lx Orp %lx OBwp %lx OBrp %lx\n",i , inwp, inrp, banwp, bandrp, outwp, outrp, outbanwp, outbanrp);
+
+
+}
+
+int triggerAudio(rtk_runtime_stream_t *stream, int cmd) {
+    //TRACE_CODE("%s %d", __FUNCTION__, __LINE__);
+    switch (cmd) {
+        case SNDRV_PCM_TRIGGER_START:
+        case SNDRV_PCM_TRIGGER_PAUSE_RELEASE:
+            if (stream->status != SNDRV_PCM_TRIGGER_START) {
+                RPC_TOAGENT_RUN_SVC(stream->audioOutId);
+                RPC_TOAGENT_RUN_SVC(GetGeneralInstanceID(stream->audioPPId, stream->audioAppPinId));
+                RPC_TOAGENT_RUN_SVC(stream->audioDecId);
+            }
+            stream->status = SNDRV_PCM_TRIGGER_START;
+			compress_first_pts = true;
+            break;
+        case SNDRV_PCM_TRIGGER_STOP:
+            if (stream->status != SNDRV_PCM_TRIGGER_STOP) {
+                AUDIO_RPC_SENDIO sendio;
+                // decoder flush
+                sendio.instanceID = stream->audioDecId;
+                sendio.pinID = stream->audioDecPinId;
+                if (RPC_TOAGENT_FLUSH_SVC(&sendio)) {
+                    ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+                    return -1;
+                }
+                //dumptr(stream, 1);
+                resetPointer(stream);
+                RPC_TOAGENT_STOP_SVC(stream->audioOutId);
+                RPC_TOAGENT_STOP_SVC(GetGeneralInstanceID(stream->audioPPId, stream->audioAppPinId));
+                RPC_TOAGENT_STOP_SVC(stream->audioDecId);
+            }
+            stream->status = SNDRV_PCM_TRIGGER_STOP;
+            break;
+        case SNDRV_PCM_TRIGGER_PAUSE_PUSH:
+            if (stream->status != SNDRV_PCM_TRIGGER_PAUSE_PUSH) {
+                RPC_TOAGENT_PAUSE_SVC(stream->audioOutId);
+                RPC_TOAGENT_PAUSE_SVC(GetGeneralInstanceID(stream->audioPPId, stream->audioAppPinId));
+                RPC_TOAGENT_PAUSE_SVC(stream->audioDecId);
+            }
+            stream->refclock->RCD = -1;
+			stream->refclock->mastership.audioMode = AVSYNC_FORCED_MASTER;
+            stream->refclock->mastership.videoMode = AVSYNC_FORCED_SLAVE;
+            stream->status = SNDRV_PCM_TRIGGER_PAUSE_PUSH;
+            break;
+        default:
+            break;
+    }
+
+    return 0;
+}
+
+void destroyAudioComponent(rtk_runtime_stream_t *stream) {
+    TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+
+    triggerAudio(stream, SNDRV_PCM_TRIGGER_STOP);
+
+    RPC_TOAGENT_PP_INIT_PIN_SVC(GetGeneralInstanceID(stream->audioPPId, stream->audioAppPinId));
+    RPC_TOAGENT_DESTROY_SVC(GetGeneralInstanceID(stream->audioPPId, stream->audioAppPinId));
+    RPC_TOAGENT_DESTROY_SVC(stream->audioDecId);
+
+    stream->audioDecId = 0;
+    stream->audioPPId = 0;
+    stream->audioOutId = 0;
+    stream->audioDecPinId = 0;
+    stream->audioAppPinId = 0;
+}
+
+int createAudioComponent(rtk_runtime_stream_t *stream) {
+    TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+
+    // create decoder agent
+    if (RPC_TOAGENT_CREATE_DECODER_AGENT(&stream->audioDecId, &stream->audioDecPinId)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -ENOMEM;
+    }
+
+    // create pp agent and get global pp pin
+    if (RPC_TOAGENT_CREATE_PP_AGENT(&stream->audioPPId, &stream->audioAppPinId)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -ENOMEM;
+    }
+
+    // create ao agent
+    if (RPC_TOAGENT_CREATE_AO_AGENT(&stream->audioOutId, AUDIO_OUT)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -ENOMEM;
+    }
+    stream->audioOutId = GetGeneralInstanceID(stream->audioOutId, stream->audioAppPinId);
+    ////////////////////////////////////////////////////////////
+    /// SEND RPC tell 5280 audio fw OMX AUDIO VERSION
+    ////////////////////////////////////////////////////////////
+    //yllin: add this to handle incompatible issue casued by OMX use new AUDIO_INFO_CHANNEL_INDEX and audio fw enable PP_SUPPORT_INBAND_QUEUE.
+    //ENUM_OMX_AUDIO_VERSION_0 : supports only old AUDIO_INFO_CHANNEL_INDEX type(contains 'char' type)
+    //ENUM_OMX_AUDIO_VERSION_1 : supports both new(contains only 'long' type) & old AUDIO_INFO_CHANNEL_INDEX type.
+
+    if (RPC_TOAGENT_SEND_AUDIO_VERSION(ENUM_OMX_AUDIO_VERSION_1)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -ENOMEM;
+    }
+
+    TRACE_CODE("[create audio dec %d pin id %d]\n", stream->audioDecId, stream->audioDecPinId);
+    TRACE_CODE("[create audio pp  %d pin id %d]\n", stream->audioPPId, stream->audioAppPinId);
+    TRACE_CODE("[create audio out %d]\n", stream->audioOutId);
+    return 0;
+}
+
+int configOutput(rtk_runtime_stream_t *stream) {
+    //config i2s
+    AUDIO_CONFIG_DAC_I2S dac_i2s_config;
+    AUDIO_CONFIG_DAC_SPDIF dac_spdif_config;
+    AUDIO_RPC_FOCUS focus;
+
+    TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+
+    dac_i2s_config.instanceID = stream->audioOutId;
+    dac_i2s_config.dacConfig.audioGeneralConfig.interface_en = 1;
+    dac_i2s_config.dacConfig.audioGeneralConfig.channel_out = LEFT_CENTER_FRONT_CHANNEL_EN|RIGHT_CENTER_FRONT_CHANNEL_EN;
+    dac_i2s_config.dacConfig.audioGeneralConfig.count_down_play_en = 0;
+    dac_i2s_config.dacConfig.audioGeneralConfig.count_down_play_cyc = 0;
+    dac_i2s_config.dacConfig.sampleInfo.sampling_rate = 48000;
+    dac_i2s_config.dacConfig.sampleInfo.PCM_bitnum = 24;
+    if (RPC_TOAGENT_DAC_I2S_CONFIG(&dac_i2s_config)) {
+        ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    //config spdif
+    dac_spdif_config.instanceID = stream->audioOutId;
+    dac_spdif_config.spdifConfig.audioGeneralConfig.interface_en = 1;
+    dac_spdif_config.spdifConfig.audioGeneralConfig.channel_out = SPDIF_LEFT_CHANNEL_EN|SPDIF_RIGHT_CHANNEL_EN;
+    dac_spdif_config.spdifConfig.audioGeneralConfig.count_down_play_en = 0;
+    dac_spdif_config.spdifConfig.audioGeneralConfig.count_down_play_cyc = 0;
+    dac_spdif_config.spdifConfig.sampleInfo.sampling_rate = 48000;
+    dac_spdif_config.spdifConfig.sampleInfo.PCM_bitnum = 24;
+    dac_spdif_config.spdifConfig.out_cs_info.non_pcm_valid = 0;
+    dac_spdif_config.spdifConfig.out_cs_info.non_pcm_format = 0;
+    dac_spdif_config.spdifConfig.out_cs_info.audio_format = 0;
+    dac_spdif_config.spdifConfig.out_cs_info.spdif_consumer_use = 0;
+    dac_spdif_config.spdifConfig.out_cs_info.copy_right = 0;
+    dac_spdif_config.spdifConfig.out_cs_info.pre_emphasis = 0;
+    dac_spdif_config.spdifConfig.out_cs_info.stereo_channel = 0;
+    if (RPC_TOAGENT_DAC_SPDIF_CONFIG(&dac_spdif_config)) {
+        ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    //set focus
+    focus.instanceID = stream->audioOutId;
+    focus.focusID = 0;
+    if (RPC_TOAGENT_SWITCH_FOCUS(&focus)) {
+        ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+    focus.instanceID = stream->audioPPId;
+    focus.focusID = stream->audioAppPinId;
+    if (RPC_TOAGENT_SWITCH_FOCUS(&focus)) {
+        ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+    return 0;
+}
+
+void destroyRingBuf(rtk_runtime_stream_t *stream) {
+    //TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+    if (stream->codecId == SND_AUDIOCODEC_TRUEHD) {
+        RPC_TOAGENT_SET_TRUEHD_ERR_SELF_RESET(false);
+    }
+
+    if (stream->isLowWater) {
+        RPC_TOAGENT_SET_LOW_WATER_LEVEL(false);
+    }
+
+    if (alsa_client != NULL) {
+        int ch;
+
+        if (refclock_handle != NULL) {
+            //TRACE_CODE("%s %d free refclock_handle\n", __FUNCTION__, __LINE__);
+            ion_unmap_kernel(alsa_client, refclock_handle);
+            ion_free(alsa_client, refclock_handle);
+            refclock_handle = NULL;
+        }
+
+        if (compr_inRing_handle != NULL) {
+            //TRACE_CODE("%s %d free compr_inRing_handle\n", __FUNCTION__, __LINE__);
+            ion_unmap_kernel(alsa_client, compr_inRing_handle);
+            ion_free(alsa_client, compr_inRing_handle);
+            compr_inRing_handle = NULL;
+        }
+
+        if (compr_inband_handle != NULL) {
+            //TRACE_CODE("%s %d free compr_inband_handle\n", __FUNCTION__, __LINE__);
+            ion_unmap_kernel(alsa_client, compr_inband_handle);
+            ion_free(alsa_client, compr_inband_handle);
+            compr_inband_handle = NULL;
+        }
+
+        if (compr_dwnstrm_handle != NULL) {
+            //TRACE_CODE("%s %d free compr_dwnstrm_handle\n", __FUNCTION__, __LINE__);
+            ion_unmap_kernel(alsa_client, compr_dwnstrm_handle);
+            ion_free(alsa_client, compr_dwnstrm_handle);
+            compr_dwnstrm_handle = NULL;
+        }
+
+        if (compr_outRing_handle[0] != NULL) {
+            //TRACE_CODE("%s %d free compr_outRing_handle\n", __FUNCTION__, __LINE__);
+            for (ch = 0; ch < AUDIO_DEC_OUTPIN; ch++) {
+                ion_unmap_kernel(alsa_client, compr_outRing_handle[ch]);
+                ion_free(alsa_client, compr_outRing_handle[ch]);
+                compr_outRing_handle[ch] = NULL;
+            }
+        }
+    }
+}
+
+int createRingBuf(rtk_runtime_stream_t *stream, unsigned int buffer_size) {
+
+    int ch, i;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned int decOutSize = 0;
+    AUDIO_RPC_RINGBUFFER_HEADER ringBufferHeader;
+    AUDIO_RPC_CONNECTION connection;
+
+    TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+
+    /* Set low water mode for according to format & sample rate */
+    if (stream->isLowWater) {
+        decOutSize = DEC_OUT_BUFFER_SIZE_LOW;
+        RPC_TOAGENT_SET_LOW_WATER_LEVEL(true);
+    } else {
+        decOutSize = DEC_OUT_BUFFER_SIZE;
+        RPC_TOAGENT_SET_LOW_WATER_LEVEL(false);
+    }
+
+    //create RINGBUFFER_HEADER decInRing
+    compr_inRing_handle = ion_alloc(alsa_client, buffer_size, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+    if (IS_ERR(compr_inRing_handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+    if (ion_phys(alsa_client, compr_inRing_handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+    stream->virDecInRing = ion_map_kernel(alsa_client, compr_inRing_handle);
+    stream->phyDecInRing = dat;
+
+    //TRACE_CODE("decInring phy %x limit %x\n\n", stream->phyDecInRing, stream->phyDecInRing + len);
+
+    TRACE_CODE("%s %d inRing_size %u\n", __FUNCTION__, __LINE__,buffer_size);
+    stream->decInRingHeader.beginAddr = htonl((unsigned long)stream->phyDecInRing);
+    stream->decInRingHeader.size = htonl(buffer_size);
+    stream->decInRingHeader.writePtr = stream->decInRingHeader.beginAddr;
+    stream->decInRingHeader.numOfReadPtr = htonl(1);
+    stream->decInRingHeader.readPtr[0] = stream->decInRingHeader.beginAddr;
+    stream->lastInRingRP = (long)ntohl(stream->decInRingHeader.readPtr[0]);
+
+    ringBufferHeader.instanceID = stream->audioDecId;
+    ringBufferHeader.pinID = BASE_BS_IN; //stream->audioDecPinId;
+    ringBufferHeader.readIdx = 0;
+    ringBufferHeader.listSize = 1;
+    ringBufferHeader.pRingBufferHeaderList[0] = (unsigned long)&stream->decInRingHeader - (unsigned long)stream + stream->phy_addr;
+
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&ringBufferHeader, ringBufferHeader.listSize) < 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto fail; 
+    };
+    //TRACE_CODE("decInRing wp %x rp %x\n\n", htonl(stream->decInRingHeader.writePtr), htonl(stream->decInRingHeader.readPtr[0]));
+
+    //create RINGBUFFER_HEADER decInbandRing;
+    compr_inband_handle = ion_alloc(alsa_client, DEC_INBAND_BUFFER_SIZE, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+    if (IS_ERR(compr_inband_handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+    if (ion_phys(alsa_client, compr_inband_handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+    stream->virInbandRing = ion_map_kernel(alsa_client, compr_inband_handle);
+    stream->phyDecInbandRing = dat;
+
+    stream->decInbandRingHeader.beginAddr = htonl((unsigned long)stream->phyDecInbandRing);
+    stream->decInbandRingHeader.size = htonl(DEC_INBAND_BUFFER_SIZE);
+    stream->decInbandRingHeader.writePtr = stream->decInbandRingHeader.beginAddr;
+    stream->decInbandRingHeader.numOfReadPtr = htonl(1);
+    stream->decInbandRingHeader.readPtr[0] = stream->decInbandRingHeader.beginAddr;
+
+    ringBufferHeader.instanceID = stream->audioDecId;
+    ringBufferHeader.pinID = INBAND_QUEUE;
+    ringBufferHeader.readIdx = 0;
+    ringBufferHeader.listSize = 1;
+    ringBufferHeader.pRingBufferHeaderList[0] = (unsigned long)&stream->decInbandRingHeader - (unsigned long)stream + stream->phy_addr; 
+
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&ringBufferHeader, ringBufferHeader.listSize) < 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto fail; 
+    };
+
+    //create RINGBUFFER_HEADER dwnstrmRing;
+    compr_dwnstrm_handle = ion_alloc(alsa_client, DEC_DWNSTRM_BUFFER_SIZE, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+    if (IS_ERR(compr_dwnstrm_handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+    if (ion_phys(alsa_client, compr_dwnstrm_handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+    stream->virDwnRing = ion_map_kernel(alsa_client, compr_dwnstrm_handle);
+    stream->phyDecDwnstrmRing = dat;
+
+    stream->virDwnRingLower = stream->virDwnRing;
+    stream->virDwnRingUpper = stream->virDwnRing + DEC_DWNSTRM_BUFFER_SIZE;
+
+    stream->dwnstrmRingHeader.beginAddr = htonl((unsigned long)stream->phyDecDwnstrmRing);
+    stream->dwnstrmRingHeader.size = htonl(DEC_DWNSTRM_BUFFER_SIZE);
+    stream->dwnstrmRingHeader.writePtr = stream->dwnstrmRingHeader.beginAddr;
+    stream->dwnstrmRingHeader.numOfReadPtr = htonl(1);
+    stream->dwnstrmRingHeader.readPtr[0] = stream->dwnstrmRingHeader.beginAddr;
+
+    ringBufferHeader.instanceID = stream->audioDecId;
+    ringBufferHeader.pinID = DWNSTRM_INBAND_QUEUE;
+    ringBufferHeader.readIdx = -1;
+    ringBufferHeader.listSize = 1;
+    ringBufferHeader.pRingBufferHeaderList[0] = (unsigned long)&stream->dwnstrmRingHeader - (unsigned long)stream + stream->phy_addr; 
+
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&ringBufferHeader, ringBufferHeader.listSize) < 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto fail;
+    };
+
+    //create RINGBUFFER_HEADER decOutRing[8];
+    for (ch = 0; ch < AUDIO_DEC_OUTPIN; ch++) {
+        compr_outRing_handle[ch] = ion_alloc(alsa_client, decOutSize, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+        if (IS_ERR(compr_outRing_handle[ch])) {
+            ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+            goto fail;
+        }
+        if (ion_phys(alsa_client, compr_outRing_handle[ch], &dat, &len) != 0) {
+            ALSA_WARNING("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+            goto fail;
+        }
+        stream->virDecOutRing[ch] = ion_map_kernel(alsa_client, compr_outRing_handle[ch]);
+        stream->phyDecOutRing[ch] = dat;
+
+        stream->virDecOutRingLower[ch] = stream->virDecOutRing[ch];
+        stream->virDecOutRingUpper[ch] = stream->virDecOutRing[ch] + decOutSize;
+
+        stream->decOutRingHeader[ch].beginAddr = htonl((unsigned long)stream->phyDecOutRing[ch]);
+        stream->decOutRingHeader[ch].size = htonl(decOutSize);
+        stream->decOutRingHeader[ch].writePtr = stream->decOutRingHeader[ch].beginAddr;
+        stream->decOutRingHeader[ch].numOfReadPtr = htonl(1);
+        for (i = 0; i < 4; i++)
+            stream->decOutRingHeader[ch].readPtr[i] = stream->decOutRingHeader[ch].beginAddr;
+    }
+
+    ringBufferHeader.instanceID = stream->audioDecId;
+    ringBufferHeader.pinID = PCM_OUT;
+    ringBufferHeader.readIdx = -1; //todo maybe be to set 1 in there for getting frame pts
+//    ringBufferHeader.readIdx = 1; //todo maybe be to set 1 in there for getting frame pts
+    ringBufferHeader.listSize = AUDIO_DEC_OUTPIN;
+    for (ch = 0; ch < AUDIO_DEC_OUTPIN; ++ch)
+        ringBufferHeader.pRingBufferHeaderList[ch] = (unsigned long)&stream->decOutRingHeader[ch] - (unsigned long)stream + stream->phy_addr; 
+
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&ringBufferHeader, ringBufferHeader.listSize) < 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto fail;
+    };
+
+    ringBufferHeader.instanceID = stream->audioPPId;
+    ringBufferHeader.pinID = stream->audioAppPinId;
+    ringBufferHeader.readIdx = 0;
+    ringBufferHeader.listSize = AUDIO_DEC_OUTPIN;
+    for (ch = 0; ch < AUDIO_DEC_OUTPIN; ++ch) 
+        ringBufferHeader.pRingBufferHeaderList[ch] = (unsigned long)&stream->decOutRingHeader[ch] - (unsigned long)stream + stream->phy_addr; 
+
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&ringBufferHeader, ringBufferHeader.listSize) < 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto fail;
+    };
+ 
+    //connection
+    connection.desInstanceID = stream->audioPPId;
+    connection.srcInstanceID = stream->audioDecId;
+    connection.srcPinID = PCM_OUT;
+    connection.desPinID = stream->audioAppPinId;
+
+    if (RPC_TOAGENT_CONNECT_SVC(&connection)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto fail;
+    };
+
+    if (configOutput(stream)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+
+    return 0;
+
+fail:
+    destroyRingBuf(stream);
+    return -1;
+}
+
+int getAudioInfo(rtk_runtime_stream_t *stream, unsigned int *channel, unsigned int *rate) {
+    int ret = 0;
+    /*
+    unsigned char* ptswp = stream->virDwnRing +
+        (ntohl(stream->dwnstrmRingHeader.writePtr) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+    */
+    unsigned char* ptsrp = stream->virDwnRing +
+        (ntohl(stream->dwnstrmRingHeader.readPtr[0]) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+    unsigned char* ptsrp_tmp = ptsrp;
+
+    bool new_chIdx_type = false;
+    int audio_start_thld = 0;
+    unsigned long space = 0;
+    long up_space = 0;
+    AUDIO_INFO_PCM_FORMAT pcmFormat;
+    AUDIO_INBAND_PRIVATE_INFO inbandInfo;
+
+    ///////////////////////////////////////////////////////////////////////////////
+    /// privateinfo   (16)
+    /// pcm_format    (32)
+    /// privateinfo   (16)
+    /// channel_index (20)
+    ///////////////////////////////////////////////////////////////////////////////
+    memset(&inbandInfo, 0, INBAND_INFO_SIZE);
+    space = GetBufferFromRing(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp_tmp, (unsigned char*)&inbandInfo, INBAND_INFO_SIZE);
+    //TRACE_CODE("inbanInfo headerType %lu\n", inbandInfo.header.type);
+    //TRACE_CODE("inbanInfo headerSize %lu\n", inbandInfo.header.size);
+    //TRACE_CODE("inbanInfo infoType   %lu\n", inbandInfo.infoType);
+    //TRACE_CODE("inbanInfo size       %lu\n", inbandInfo.infoSize);
+
+    if (inbandInfo.infoType != AUDIO_INBAND_CMD_PRIVATE_PCM_FMT) {
+        return ret;
+    }
+    if (space > 0)
+        ptsrp_tmp = stream->virDwnRing + INBAND_INFO_SIZE - space;
+    else
+        ptsrp_tmp = ptsrp_tmp + INBAND_INFO_SIZE;
+
+    memset(&pcmFormat, 0, INBAND_PCM_SIZE);
+    space = GetBufferFromRing(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp_tmp, (unsigned char*)&pcmFormat, INBAND_PCM_SIZE);
+
+    //TRACE_CODE("pcmFormat chnum %d\n", pcmFormat.pcmFormat.chnum);
+    TRACE_CODE("pcmFormat rate  %d\n", pcmFormat.pcmFormat.samplerate);
+
+    if (space > 0)
+        ptsrp_tmp = stream->virDwnRing + INBAND_PCM_SIZE - space;
+    else
+        ptsrp_tmp = ptsrp_tmp + INBAND_PCM_SIZE;
+
+    memset(&inbandInfo, 0, INBAND_INFO_SIZE);
+    space = GetBufferFromRing(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp_tmp, (unsigned char*)&inbandInfo, INBAND_INFO_SIZE);
+
+    //TRACE_CODE("cmd header type %lu\n", inbandInfo.header.type);
+    //TRACE_CODE("cmd header size %lu\n", inbandInfo.header.size);
+    //TRACE_CODE("cmd infoType    %lu\n", inbandInfo.infoType);
+    //TRACE_CODE("cmd infoSize    %lu\n", inbandInfo.infoSize);
+
+    if (inbandInfo.infoType != AUDIO_INBAND_CMD_PRIVATE_CH_IDX) {
+        TRACE_CODE("Info.infoType != AUDIO_INBAND");
+        return ret;
+    }
+
+    if (space > 0)
+        ptsrp_tmp = stream->virDwnRing + INBAND_INFO_SIZE - space;
+    else
+        ptsrp_tmp = ptsrp_tmp + INBAND_INFO_SIZE;
+
+    //get pcm information and channel index
+    *rate = pcmFormat.pcmFormat.samplerate;
+
+    if(inbandInfo.infoSize > OLD_CHANNEL_INDEX_INFO_SIZE) {
+        new_chIdx_type = true;
+        printk("use NEW CHANNEL_INDEX_INFO\n");
+    } else {
+        printk("use OLD CHANNEL_INDEX_INFO\n");
+    }
+
+    if (new_chIdx_type == true) {
+        int count;
+        AUDIO_INFO_CHANNEL_INDEX_NEW infoChIndex;
+        memset(&infoChIndex, 0, sizeof(infoChIndex));
+        space = GetBufferFromRing(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp_tmp, (unsigned char*)&infoChIndex, sizeof(infoChIndex));
+
+        for (count = 0; count < AUDIO_DEC_OUTPIN; count++) {
+            //TRACE_CODE("infoChIndex index %d\n", infoChIndex.channel_index[count]);
+            if(infoChIndex.channel_index[count])
+                (*channel)++;
+        }
+    } else{
+        int count;
+        AUDIO_INFO_CHANNEL_INDEX_OLD infoChIndex;
+        memset(&infoChIndex, 0, sizeof(infoChIndex));
+        space = GetBufferFromRing(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp_tmp, (unsigned char*)&infoChIndex, sizeof(infoChIndex));
+
+        for (count = 0; count < AUDIO_DEC_OUTPIN; count++) {
+            //TRACE_CODE("infoChIndex index %d\n", infoChIndex.channel_index[count]);
+            if(infoChIndex.channel_index[count])
+                (*channel)++;
+        }
+    }
+    up_space = ringValidData((long)stream->virDwnRingLower, (long)stream->virDwnRingUpper, (long)ptsrp, (long)stream->virDwnRingUpper);
+    audio_start_thld = INBAND_PCM_SIZE + (2 * INBAND_INFO_SIZE) + inbandInfo.infoSize;
+    UpdateRingPtr(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, stream, audio_start_thld, up_space);
+    ret = 1;
+    return ret;
+}
+
+int checkAudioInfo(rtk_runtime_stream_t *stream) {
+    int ret = 0;
+
+    unsigned char* ptswp = stream->virDwnRing +
+        (ntohl(stream->dwnstrmRingHeader.writePtr) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+    unsigned char* ptsrp = stream->virDwnRing +
+        (ntohl(stream->dwnstrmRingHeader.readPtr[0]) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+    long canReadsize = ringValidData((long)stream->virDwnRingLower, (long)stream->virDwnRingUpper, (long)ptsrp, (long)ptswp);
+
+    if (canReadsize >= AUDIO_START_THRES) {
+        unsigned int numChannel = 0;
+        unsigned int numRate = 0;
+        ret = getAudioInfo(stream, &numChannel, &numRate);
+
+        if (numChannel > 0) {
+            TRACE_CODE("[RTK Codec] nChannels      %u\n", numChannel);
+            TRACE_CODE("[RTK Codec] nSamplesPerSec %u\n", numRate);
+            stream->isGetInfo = true;
+            printk("snd_compress got stream.info isGetInfo set to true\n");
+            if( numChannel != stream->audioChannel || numRate != stream->audioSamplingRate) {
+                TRACE_CODE("[RTK] INFO CHANGE\n");
+                stream->audioChannel = numChannel;
+                stream->audioSamplingRate = numRate;
+            }
+            ret = 1;
+        }
+    }
+    return ret;
+}
+
+int GetSampleIndex(unsigned int sampleRate) {
+    unsigned int index;
+    static const unsigned int aac_samplerate_tab[12] = {
+        96000, 88200, 64000, 48000, 44100, 32000, 24000, 22050, 16000, 12000, 11025, 8000};
+
+    for (index = 0; index < sizeof(aac_samplerate_tab) / sizeof(aac_samplerate_tab[0]); index++) {
+        if (sampleRate == aac_samplerate_tab[index]) {
+            return index;
+        }
+    }
+    return -1;
+}
+
+int snd_monitor_raw_data_queue_new(rtk_runtime_stream_t *stream) {
+
+    int rawOutDelay = 0;
+    if (rawdelay_mem2) {
+        uint64_t pcmPTS;
+        uint64_t curPTS;
+        uint64_t diffPTS;
+        unsigned int sum = 0;
+        unsigned int latency = 0;
+        unsigned int ptsL = 0;
+        unsigned int ptsH = 0;
+        unsigned int in_wp = 0;
+        unsigned int decfrm = 0;
+
+        int retry = 0;
+
+        //to get ALSA_LATENCY_INFO frmo fw
+        if (rawdelay_mem2) {
+            latency = ENDIAN_CHANGE(rawdelay_mem2->latency);
+            ptsL = ENDIAN_CHANGE(rawdelay_mem2->ptsL);
+            ptsH = ENDIAN_CHANGE(rawdelay_mem2->ptsH);
+            sum = ENDIAN_CHANGE(rawdelay_mem2->sum);
+            in_wp = ENDIAN_CHANGE(rawdelay_mem2->decin_wp) & 0x0fffffff;
+            decfrm = ENDIAN_CHANGE(rawdelay_mem2->decfrm_smpl);
+
+            while (sum != (latency + ptsL)) {
+                if (retry > 100) {
+                    if (ptsL < sum) {
+                        latency = sum - ptsL;
+                    }
+                    break;
+                }
+                latency = ENDIAN_CHANGE(rawdelay_mem2->latency);
+                ptsL = ENDIAN_CHANGE(rawdelay_mem2->ptsL);
+                ptsH = ENDIAN_CHANGE(rawdelay_mem2->ptsH);
+                sum = ENDIAN_CHANGE(rawdelay_mem2->sum);
+                in_wp = ENDIAN_CHANGE(rawdelay_mem2->decin_wp) & 0x0fffffff;
+                decfrm = ENDIAN_CHANGE(rawdelay_mem2->decfrm_smpl);
+
+                retry++;
+            }
+        }
+        pcmPTS = (((uint64_t)ptsH << 32) | ((uint64_t)ptsL));
+        curPTS = snd_card_get_90k_pts();
+        diffPTS = curPTS - pcmPTS;
+        // no ptsL means the audio fw is old.
+        if (in_wp == 0 && ptsL == 0) {
+            if (rawdelay_mem) {
+                rawOutDelay = *rawdelay_mem;
+                //rawOutDelay = ENDIAN_CHANGE(rawOutDelay);
+                rawOutDelay = htonl(rawOutDelay);
+            }
+        } else {
+            rawOutDelay = latency - div64_ul(diffPTS * 1000, 90);
+            rawOutDelay = rawOutDelay / 1000;
+            if (rawOutDelay < 0) {
+                rawOutDelay = 0;
+            }
+        }
+
+        //printk("alsa raw retry %d latency %u , ptsL %u, ptsH %u, sum %u, in_wp %u decfrm %u fr %lu curPTS %lu pcmPTS %lu\n",
+        //   retry, latency, ptsL, ptsH, sum, in_wp, decfrm, stream->outFrames,curPTS, pcmPTS);
+    } else if (rawdelay_mem) {
+        rawOutDelay = *rawdelay_mem;
+        rawOutDelay = htonl(rawOutDelay);
+    } else {
+        ALSA_WARNING("NO exist share memory %s %d!!\n", __FUNCTION__, __LINE__);
+    }
+
+    mtotal_latency = rawOutDelay;
+    return rawOutDelay;
+}
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+static int snd_card_compr_open(struct snd_compr_stream *cstream) {
+    struct snd_compr_runtime *runtime = cstream->runtime;
+    rtk_runtime_stream_t *stream = NULL;
+
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+    rtk_compress_handle = ion_alloc(alsa_client, sizeof(rtk_runtime_stream_t), 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(rtk_compress_handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+
+    if (ion_phys(alsa_client, rtk_compress_handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+
+    stream = ion_map_kernel(alsa_client, rtk_compress_handle);
+    memset(stream, 0, len);
+    stream->phy_addr = dat;
+
+    //TRACE_CODE("stream phy %p virtual %p\n", stream->phy_addr, stream);
+
+    if (createAudioComponent(stream)) { 
+        ALSA_WARNING("[%s %d] create Audio Component failed\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+
+/*  move to snd_card_compr_set_params
+    if (createRingBuf(stream)) {
+        ALSA_WARNING("[%s %d] create Audio Component failed\n", __FUNCTION__, __LINE__);
+        goto fail;
+    }
+*/
+    stream->status = SNDRV_PCM_TRIGGER_STOP;
+
+    runtime->private_data = stream;
+
+    if (rawdelay_mem == NULL) {
+        //printk("%s create rawdelay_handle\n", __FUNCTION__);
+        rawdelay_handle = ion_alloc(alsa_client, RAWDELAY_MEM_SIZE, 32, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+        if (IS_ERR(rawdelay_handle)) {
+            ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+            goto fail;
+        }
+
+        if (ion_phys(alsa_client, rawdelay_handle, &phy_rawdelay, &len) != 0) {
+            printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+            goto fail;
+        }
+
+        rawdelay_mem = ion_map_kernel(alsa_client, rawdelay_handle);
+        memset(rawdelay_mem, 0, RAWDELAY_MEM_SIZE);
+
+        //RPC_TOAGENT_PUT_SHARE_MEMORY((void *)phy_rawdelay, ENUM_PRIVATEINFO_AUDIO_PROVIDE_RAWOUT_LATENCY);
+    }
+
+    if (rawdelay_mem2 == NULL) {
+        rawdelay_handle2 = ion_alloc(alsa_client, SHARE_MEM_SIZE_RAW_LATENCY, 32, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+        if (IS_ERR(rawdelay_handle2)) {
+            ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+            goto fail;
+        }
+
+        if (ion_phys(alsa_client, rawdelay_handle2, &phy_rawdelay2, &len) != 0) {
+            printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+            goto fail;
+        }
+
+        rawdelay_mem2 = ion_map_kernel(alsa_client, rawdelay_handle2);
+        memset(rawdelay_mem2, 0, SHARE_MEM_SIZE_RAW_LATENCY);
+
+        RPC_TOAGENT_PUT_SHARE_MEMORY_LATENCY((void *)phy_rawdelay, (void *)phy_rawdelay2, stream->audioDecId, ENUM_PRIVATEINFO_AUDIO_PROVIDE_RAWOUT_LATENCY);
+    }
+
+	delim_check_format = 1;
+	header_handle_buf1 = kmalloc(sizeof(char *)*16, GFP_KERNEL);
+	header_handle_buf2 = kmalloc(sizeof(char *)*64, GFP_KERNEL);
+
+    return 0;
+
+fail:
+    if (alsa_client != NULL) {
+        if (rawdelay_handle != NULL) {
+            ion_unmap_kernel(alsa_client, rawdelay_handle);
+            ion_free(alsa_client, rawdelay_handle);
+            rawdelay_handle = NULL;
+        }
+        if (rawdelay_handle2 != NULL) {
+            ion_unmap_kernel(alsa_client, rawdelay_handle2);
+            ion_free(alsa_client, rawdelay_handle2);
+            rawdelay_handle2 = NULL;
+        }
+        if (rawdelay_mem)
+            rawdelay_mem = NULL;
+
+        if (rawdelay_mem2)
+            rawdelay_mem2 = NULL;
+
+        if (rtk_compress_handle != NULL) {
+            //printk("%s free rtk_compress_handle\n", __FUNCTION__);
+            ion_unmap_kernel(alsa_client, rtk_compress_handle);
+            ion_free(alsa_client, rtk_compress_handle);
+            rtk_compress_handle = NULL;
+            stream = NULL;
+        }
+    }
+    return -1;
+}
+
+static int snd_card_compr_free(struct snd_compr_stream *cstream) {
+    int ret_val;
+    rtk_runtime_stream_t *stream = cstream->runtime->private_data;
+
+    TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+
+    if (rawdelay_mem) {
+        //RPC_TOAGENT_PUT_SHARE_MEMORY(NULL, ENUM_PRIVATEINFO_AUDIO_PROVIDE_RAWOUT_LATENCY);
+
+        if (alsa_client != NULL && rawdelay_handle != NULL) {
+            //printk("%s destory rawdelay_handle\n", __FUNCTION__);
+            ion_unmap_kernel(alsa_client, rawdelay_handle);
+            ion_free(alsa_client, rawdelay_handle);
+            rawdelay_handle = NULL;
+        }
+        rawdelay_mem = NULL;
+    }
+
+    if (rawdelay_mem2) {
+        RPC_TOAGENT_PUT_SHARE_MEMORY_LATENCY(NULL, NULL, 0, ENUM_PRIVATEINFO_AUDIO_PROVIDE_RAWOUT_LATENCY);
+
+        if (alsa_client != NULL && rawdelay_handle2 != NULL) {
+            //printk("%s destory rawdelay_handle\n", __FUNCTION__);
+            ion_unmap_kernel(alsa_client, rawdelay_handle2);
+            ion_free(alsa_client, rawdelay_handle2);
+            rawdelay_handle2 = NULL;
+        }
+        rawdelay_mem2 = NULL;
+    }
+
+    if (stream->audioDecId != 0) {
+        destroyAudioComponent(stream);
+    }
+
+    destroyRingBuf(stream);
+
+    /* For NAS LEDE */
+    if (stream->isRPCsetOutputMode) {
+        // reset AO to default mode
+        RPC_TOAGENT_SET_HDMI_OUTPUT_MODE(AUDIO_DIGITAL_LPCM_DUAL_CH);
+        RPC_TOAGENT_SET_SPDIF_OUTPUT_MODE(AUDIO_DIGITAL_LPCM_DUAL_CH);
+
+        stream->isRPCsetOutputMode = false;
+    }
+ 
+    if (alsa_client != NULL && rtk_compress_handle != NULL) {
+        TRACE_CODE("%s %d free rtk_compress_handle\n", __FUNCTION__, __LINE__);
+        ion_unmap_kernel(alsa_client, rtk_compress_handle);
+        ion_free(alsa_client, rtk_compress_handle);
+        rtk_compress_handle = NULL;
+        stream = NULL;
+    }
+
+	delim_check_format = 1;
+	kfree(header_handle_buf1);
+	kfree(header_handle_buf2);
+
+    ret_val = 0;
+    return ret_val;
+}
+
+static unsigned long buf_memcpy2_ring(unsigned long base, unsigned long limit, unsigned long ptr, char* buf, unsigned long size)
+{
+	if (ptr + size <= limit)
+	{
+		if(copy_from_user((char*)ptr,buf,size))
+			printk("%s %d there are remaining some data need to write\n",__func__, __LINE__);
+	}
+	else
+	{
+		int i = limit-ptr;
+		if(copy_from_user((char*)ptr,(char*)buf,i))
+			printk("%s %d there are remaining some data need to write\n",__func__, __LINE__);
+		if(copy_from_user((char*)base,(char*)(buf+i),size-i))
+			printk("%s %d there are remaining some data need to write\n",__func__, __LINE__);
+	}
+
+	ptr += size;
+	if (ptr >= limit)
+	{
+		ptr = base + (ptr-limit);
+	}
+	return ptr;
+}
+
+static unsigned long buf_memcpy3_ring(unsigned long base, unsigned long limit, unsigned long ptr, char* buf, unsigned long size)
+{
+	if (ptr + size <= limit)
+	{
+		memcpy((char*)ptr,buf,size);
+	}
+	else
+	{
+		int i = limit-ptr;
+		memcpy((char*)ptr,(char*)buf,i);
+		memcpy((char*)base,(char*)(buf+i),size-i);
+	}
+
+	ptr += size;
+	if (ptr >= limit)
+	{
+		ptr = base + (ptr-limit);
+	}
+	return ptr;
+}
+
+static int writeData(rtk_runtime_stream_t *stream, void *data, int len)
+{
+    unsigned long base, limit, wp;
+    base = (unsigned long)stream->virDecInRing;
+    limit = base + ntohl(stream->decInRingHeader.size);// sizeof(stream->phyDecInbandRing);
+    wp = base + (unsigned long)(ntohl(stream->decInRingHeader.writePtr) - ntohl(stream->decInRingHeader.beginAddr));
+
+    ALSA_VitalPrint("base %x limit %x wp %x\n", (long)base, (long)limit, (long)wp);
+    wp = buf_memcpy2_ring(base, limit, wp, (char *)data, (unsigned long)len);
+    stream->decInRingHeader.writePtr = ntohl((int)(wp - base) + ntohl(stream->decInRingHeader.beginAddr));
+    //TRACE_CODE("[INBAND RING] writeAddr %x\n", stream->decInRingHeader.writePtr);
+    return len;
+}
+
+static int writeInbandCmd2(rtk_runtime_stream_t *stream, void *data, int len)
+{
+    unsigned long base, limit, wp;
+    base = (unsigned long)stream->virInbandRing;
+    limit = base + ntohl(stream->decInbandRingHeader.size);// sizeof(stream->phyDecInbandRing);
+    wp = base + (unsigned long)(ntohl(stream->decInbandRingHeader.writePtr) - ntohl(stream->decInbandRingHeader.beginAddr));
+
+    ALSA_VitalPrint("base %x limit %x wp %x\n", (long)base, (long)limit, (long)wp);
+    wp = buf_memcpy3_ring(base, limit, wp, (char *)data, (unsigned long)len);
+    stream->decInbandRingHeader.writePtr = ntohl((int)(wp - base) + ntohl(stream->decInbandRingHeader.beginAddr));
+    //TRACE_CODE("[INBAND RING] writeAddr %x\n", stream->decInbandRingHeader.writePtr);
+    return len;
+}
+
+/*
+ * For Netflix diretOutput Used
+ * Need write PTS Inband Command and Data
+ */
+static int directWriteData(rtk_runtime_stream_t *stream, void *data, int len)
+{
+	char *cBuf = (char *)data;
+	char *header_buf;
+	char delim[4] = {0x55, 0x55, 0x00, 0x01};
+	char delim_2[4] = {0x55, 0x55, 0x00, 0x02};
+	char delim_3[4] = {0x55, 0x55, 0x00, 0x03};
+	char *bufHeader = NULL;
+	int remainingLen = len;
+	int sizeInByte = 0;
+	uint64_t timestamp = 0;
+	long long timestampref = 0;
+	AUDIO_DEC_PTS_INFO cmd;
+	int writeLen = 0;
+	int retLen = 0;
+	int header_offset = 0;
+
+	header_buf = kmalloc(sizeof(int) * len, GFP_KERNEL);
+	if(copy_from_user(header_buf, cBuf, len))
+		printk("%s %d copy data fail\n",__func__, __LINE__);
+
+	if (delim_format == 1)
+		bufHeader = (char *)memmem(header_buf, remainingLen, delim_2, 4);
+	else if (delim_format == 0)
+		bufHeader = (char *)memmem(header_buf, remainingLen, delim, 4);
+	else
+		bufHeader = (char *)memmem(header_buf, remainingLen, delim_3, 4);
+
+	/*
+	 * Reset the hw_avsync_header_offset, if the data contains header.
+	 */
+	if (bufHeader != NULL && hw_avsync_header_offset != 0)
+		hw_avsync_header_offset = 0;
+
+    if(hw_avsync_header_offset != -1) { /* With hw av sync header */
+        if(hw_avsync_header_offset > 0) {
+            if(hw_avsync_header_offset <= remainingLen)
+                writeLen = hw_avsync_header_offset;
+            else
+                writeLen = remainingLen;
+
+            writeData(stream, cBuf, writeLen);
+            retLen = retLen + writeLen;
+            remainingLen = remainingLen - writeLen;
+            hw_avsync_header_offset = hw_avsync_header_offset - writeLen;
+            cBuf = cBuf + writeLen;
+        }
+
+		/*	DHCHERC-486:
+			1. Google has the new format for more than 2 channels.
+			2. If this data is the new format 0x55550002, it needs to record header length.
+			3. The header length will not the same in each video.
+		 */
+		if (delim_check_format)
+		{
+			bufHeader = (char *)memmem(header_buf, remainingLen, delim_3, 4);
+			if (bufHeader != NULL)
+			{
+				delim_format = 2;
+				delim_header_size = ((bufHeader[19] | ((0xff & bufHeader[18]) << 8) | ((0xff & bufHeader[17]) << 16) | ((0xff & bufHeader[16]) << 24)) & 0xffffffff);
+				delim_check_format = 0;
+				printk("%s %d delim_format %d = 0x55550003 delim_header_size %d\n",__func__, __LINE__, delim_format, delim_header_size);
+			}
+			bufHeader = (char *)memmem(header_buf, remainingLen, delim_2, 4);
+			if (bufHeader != NULL)
+			{
+				delim_format = 1;
+				delim_header_size = (int)bufHeader[19];
+				delim_check_format = 0;
+				printk("%s %d delim_format %d = 0x55550002 delim_header_size %d\n",__func__, __LINE__, delim_format, delim_header_size);
+			}
+			bufHeader = (char *)memmem(header_buf, remainingLen, delim, 4);
+			if (bufHeader != NULL)
+			{
+				delim_format = 0;
+				delim_check_format = 0;
+				printk("%s %d delim_format %d = 0x55550001\n",__func__, __LINE__, delim_format);
+			}
+		}
+
+        while(remainingLen > 0) {
+
+			/* Copy the data for more than 1 header */
+			kfree(header_buf);
+			header_buf = kmalloc(sizeof(int) * remainingLen, GFP_KERNEL);
+			if(copy_from_user(header_buf, cBuf, remainingLen))
+				printk("%s %d copy data fail\n",__func__, __LINE__);
+
+			if (delim_format == 1)
+			{
+				if (header_handle_flag)
+				{
+					memcpy(header_handle_buf2 + header_handle_len, header_buf, sizeof(char *)*(delim_header_size - header_handle_len));
+					bufHeader = (char *)memmem(header_handle_buf2, delim_header_size, delim_2, 4);
+				}
+				else
+				{
+					bufHeader = (char *)memmem(header_buf, remainingLen, delim_2, 4);
+				}
+			}
+			else if (delim_format == 0)
+			{
+				if (header_handle_flag)
+				{
+					memcpy(header_handle_buf1 + header_handle_len, header_buf, sizeof(char *)*(16 - header_handle_len));
+					bufHeader = (char *)memmem(header_handle_buf1, 16, delim, 4);
+				}
+				else
+				{
+					bufHeader = (char *)memmem(header_buf, remainingLen, delim, 4);
+				}
+			}
+			else
+			{
+				bufHeader = (char *)memmem(header_buf, remainingLen, delim_3, 4);
+			}
+
+            if(bufHeader != NULL) {
+
+				/*	DHCHERC-219:
+					1. There has some noise when multi-video playing specific video.
+					2. The header is 16 bytes, so add the handler when remainingLen is less than 16.
+					3. Saving the parts of header and merge to next loop.
+				*/
+				if (delim_format == 1)
+				{
+					if (remainingLen > 0 && remainingLen < delim_header_size)
+					{
+						memcpy(header_handle_buf2, header_buf, remainingLen);
+						header_handle_len = remainingLen;
+						header_handle_flag = 1;
+						return retLen;
+					}
+				}
+				else if (delim_format == 0)
+				{
+					if (remainingLen > 0 && remainingLen < 16)
+					{
+						memcpy(header_handle_buf1, header_buf, remainingLen);
+						header_handle_len = remainingLen;
+						header_handle_flag = 1;
+						return retLen;
+					}
+				}
+
+                /* Write header */
+                memset(&cmd, 0, sizeof(cmd));
+                sizeInByte = ((int)bufHeader[7] | ((int)bufHeader[6] << 8) | ((int)bufHeader[5] << 16)| ((int)bufHeader[4] << 24));
+                cmd.header.type = htonl(AUDIO_DEC_INBAND_CMD_TYPE_PTS);
+                cmd.header.size = htonl(sizeof(AUDIO_DEC_PTS_INFO));
+                cmd.PTSH = ((bufHeader[11] | ((0xff & bufHeader[10]) << 8) | ((0xff & bufHeader[9]) << 16) | ((0xff & bufHeader[8]) << 24)) & 0xffffffff);
+                cmd.PTSL = ((bufHeader[15] | ((0xff & bufHeader[14]) << 8) | ((0xff & bufHeader[13]) << 16) | ((0xff & bufHeader[12]) << 24)) & 0xffffffff);
+                cmd.wPtr = htonl(stream->phyDecInRing);
+                timestamp = (((int64_t)cmd.PTSH << 32) | ((int64_t)cmd.PTSL & 0xffffffff)) * 9;
+				timestamp = div64_ul(timestamp, 100000);
+                cmd.PTSH = htonl((int32_t)(timestamp >> 32)& 0xffffffff);
+                cmd.PTSL = htonl((int32_t)(timestamp & 0xffffffffLL));
+				if (compress_first_pts) {
+					timestampref = __cpu_to_be64(stream->refclock->audioSystemPTS);
+					if ((long long)timestamp < timestampref) {
+						stream->refclock->mastership.audioMode = AVSYNC_AUTO_MASTER;
+						stream->refclock->mastership.videoMode = AVSYNC_AUTO_SLAVE;
+						printk("[seek forward] Change to auto master mode\n");
+					}
+					compress_first_pts = false;
+				}
+
+                writeInbandCmd2(stream, &cmd, sizeof(cmd));
+
+				/*	DHCHERC-486:
+					1. The position of header file may not at the first of data in some video.
+					2. The data before header file need to be send to buffer.
+					3. The offset of header file need to consider more about this case.
+				 */
+				header_offset = (int)(uintptr_t)(bufHeader - header_buf);
+				if (header_offset > 0 && !header_handle_flag)
+					writeData(stream, cBuf, header_offset);
+
+				if (delim_format == 1)
+				{
+					if (header_handle_flag)
+					{
+						remainingLen = remainingLen - (delim_header_size - header_handle_len);
+						cBuf = cBuf + (delim_header_size - header_handle_len);
+						header_handle_flag = 0;
+						header_handle_len = 0;
+					}
+					else
+					{
+						remainingLen = remainingLen - delim_header_size - header_offset;
+						cBuf = cBuf + delim_header_size + header_offset;
+					}
+				}
+				else if (delim_format == 0)
+				{
+					if (header_handle_flag)
+					{
+						remainingLen = remainingLen - (16 - header_handle_len);
+						cBuf = cBuf + (16 - header_handle_len);
+						header_handle_flag = 0;
+						header_handle_len = 0;
+					}
+					else
+					{
+						remainingLen = remainingLen - 16 - header_offset;
+						cBuf = cBuf + 16 + header_offset;
+					}
+				}
+				else
+				{
+					cBuf = cBuf + delim_header_size;
+					return 0;
+				}
+
+                /* Write data */
+                if (remainingLen > sizeInByte)
+                    writeLen = sizeInByte;
+                else
+                    writeLen = remainingLen;
+
+                writeData(stream, cBuf, writeLen);
+                retLen = retLen + writeLen;
+                remainingLen = remainingLen - writeLen;
+                hw_avsync_header_offset = hw_avsync_header_offset + (sizeInByte - writeLen);
+                cBuf = cBuf + writeLen;
+            } else {
+                if(remainingLen > 0)
+                    writeLen = remainingLen;
+                else
+                    writeLen = 0;
+
+                writeData(stream, cBuf, writeLen);
+                retLen = retLen + writeLen;
+                remainingLen = remainingLen - writeLen;
+                cBuf = cBuf + writeLen;
+            }
+        }
+    } else { /* without hw av sync header */
+        if(remainingLen > 0)
+            writeLen = remainingLen;
+        else
+            writeLen = 0;
+
+        writeData(stream, cBuf, writeLen);
+        retLen = retLen + writeLen;
+        remainingLen = remainingLen - writeLen;
+        cBuf = cBuf + writeLen;
+    }
+
+    kfree(header_buf);
+    return retLen;
+}
+
+/* The setting for different channel mapping. 
+ *  This will send rpc for AFW.
+ */
+static unsigned int snd_choose_channel_mapping(int num_channels)
+{
+	unsigned int channel_mapping_info;
+	switch (num_channels)
+	{
+		case 1:
+			channel_mapping_info = (0x1) << 6;
+			break;
+		case 2:
+			channel_mapping_info = (0x3) << 6;
+			break;
+		case 4:
+			channel_mapping_info = (0x33) << 6;
+			break;
+		case 6:
+			channel_mapping_info = (0x3F) << 6;
+			break;
+		case 8:
+			channel_mapping_info = (0x63F) << 6;
+			break;
+		default:
+			channel_mapping_info = (0x3) << 6;
+			break;
+	}
+	
+	return channel_mapping_info;
+}
+
+static int snd_card_compr_set_params(struct snd_compr_stream *cstream, struct snd_compr_params *params) {
+
+    rtk_runtime_stream_t *stream = cstream->runtime->private_data;
+    AUDIO_RPC_SENDIO sendio;
+    AUDIO_DEC_NEW_FORMAT cmd;
+    unsigned int buffer_size;
+
+    // add 16 byte because audio fw can NOT set wp = rp. max buffer can write is (buffer size - 1)
+    buffer_size = params->buffer.fragment_size * params->buffer.fragments + 16;
+
+	stream->isLowWater = false;
+	if (params->codec.reserved[1] & 0x1) {
+		/*
+		* bit 0 is for low waterlevel mode
+		* must be set before creating ring buffer
+		*/
+		stream->isLowWater = true;
+	}
+
+    if (createRingBuf(stream, buffer_size)) {
+        ALSA_WARNING("[%s %d] create Audio Component failed\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    /* For NAS LEDE */
+    if (params->codec.reserved[1] & 0x2) {
+        // set AO raw out
+        if (RPC_TOAGENT_SET_HDMI_OUTPUT_MODE(AUDIO_DIGITAL_RAW) < 0) {
+            ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+            return -1;
+        }
+
+        if (RPC_TOAGENT_SET_SPDIF_OUTPUT_MODE(AUDIO_DIGITAL_RAW) < 0) {
+            ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+            return -1;
+        }
+
+        stream->isRPCsetOutputMode = true;
+    }
+
+    /*
+     * For Netflix
+     * Previous refclock_handle should free by audio hal
+     */
+    if (params->codec.reserved[0] > 0) { /* with hw av sync */
+        size_t len = 0;
+        AUDIO_RPC_REFCLOCK audioRefClock;
+        refclock_handle = ion_import_dma_buf_fd(alsa_client, params->codec.reserved[0]);
+        if (IS_ERR(refclock_handle)) {
+            ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+            return -1;
+        } else {
+            pr_emerg("\033[0;32m handle:%p \033[m\n", refclock_handle);
+        }
+
+        if (ion_phys(alsa_client, refclock_handle, &stream->phyRefclock, &len) != 0) {
+            ALSA_WARNING("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+            return -1;
+        }
+        pr_emerg("\033[0;32m len:%d phy:%lx \033[m\n", (int)len, stream->phyRefclock);
+
+        stream->refclock = (REFCLOCK*)ion_map_kernel(alsa_client, refclock_handle);
+        memset(stream->refclock, 0, sizeof(REFCLOCK));
+#if 0
+        stream->refclock->mastership.systemMode = AVSYNC_FORCED_SLAVE;
+        stream->refclock->mastership.audioMode = AVSYNC_FORCED_MASTER;
+        stream->refclock->mastership.videoMode = AVSYNC_FORCED_SLAVE;
+        stream->refclock->mastership.masterState = AVSYNC_FORCED_SLAVE;
+#else
+        stream->refclock->mastership.systemMode = AVSYNC_FORCED_SLAVE;
+        //stream->refclock->mastership.audioMode = AVSYNC_AUTO_MASTER;
+        //stream->refclock->mastership.videoMode = AVSYNC_AUTO_SLAVE;
+		stream->refclock->mastership.audioMode = AVSYNC_FORCED_MASTER;
+        stream->refclock->mastership.videoMode = AVSYNC_FORCED_SLAVE;
+        stream->refclock->mastership.masterState = AUTOMASTER_NOT_MASTER;
+#endif
+        stream->refclock->videoFreeRunThreshold = htonl(0x7FFFFFFF);
+        stream->refclock->audioFreeRunThreshold = htonl(0x7FFFFFFF);
+
+        audioRefClock.instanceID = stream->audioOutId;
+        audioRefClock.pRefClockID = stream->audioAppPinId;
+        audioRefClock.pRefClock = (long)stream->phyRefclock;
+
+        if (RPC_TOAGENT_SETREFCLOCK(&audioRefClock)) {
+            ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+            return -1;
+        }
+        hw_avsync_header_offset = 0;
+        pr_emerg("\033[0;32m done \033[m\n");
+    } else { /* without hw av sync */
+        //set refclock
+        size_t len = 0;
+        AUDIO_RPC_REFCLOCK audioRefClock;
+        refclock_handle = ion_alloc(alsa_client, sizeof(stream->refclock), 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+        if (IS_ERR(refclock_handle)) {
+            ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+            return -1;
+        }
+        if (ion_phys(alsa_client, refclock_handle, &stream->phyRefclock, &len) != 0) {
+            ALSA_WARNING("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+            return -1;
+        }
+        stream->refclock = (REFCLOCK*)ion_map_kernel(alsa_client, refclock_handle);
+        memset(stream->refclock, 0, sizeof(REFCLOCK));
+
+        stream->refclock->mastership.systemMode = AVSYNC_FORCED_SLAVE;
+        stream->refclock->mastership.audioMode = AVSYNC_FORCED_MASTER;
+        stream->refclock->mastership.videoMode = AVSYNC_FORCED_SLAVE;
+        stream->refclock->mastership.masterState = AVSYNC_FORCED_SLAVE;
+        stream->refclock->videoFreeRunThreshold = htonl(0x7FFFFFFF);
+        stream->refclock->audioFreeRunThreshold = htonl(0x7FFFFFFF);
+
+        audioRefClock.instanceID = stream->audioOutId;
+        audioRefClock.pRefClockID = stream->audioAppPinId;
+        audioRefClock.pRefClock = (long)stream->phyRefclock;
+
+        if (RPC_TOAGENT_SETREFCLOCK(&audioRefClock)) {
+            ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+            return -1;
+        }
+
+        hw_avsync_header_offset = -1;
+        //ALSA_WARNING("\033[0;32m shareFd:%d do nothing\033[m\n", params->codec.reserved[0]);
+    }
+
+    TRACE_CODE("[+] %s %d\n", __FUNCTION__, __LINE__);
+    TRACE_CODE("codec id   %x\n", params->codec.id);
+    TRACE_CODE("codec ch   %d\n", params->codec.ch_in);
+    TRACE_CODE("codec rate %d\n", params->codec.sample_rate);
+
+    stream->codecId = params->codec.id;
+    stream->audioChannel = params->codec.ch_in;
+    stream->audioSamplingRate = params->codec.sample_rate;
+
+    // decoder flush
+    sendio.instanceID = stream->audioDecId;
+    sendio.pinID = stream->audioDecPinId;
+    if (RPC_TOAGENT_FLUSH_SVC(&sendio)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    //run audio component
+    triggerAudio(stream, SNDRV_PCM_TRIGGER_START);
+
+    //send audio format to inband cmd
+    memset(&cmd, 0, sizeof(cmd));
+
+    switch (params->codec.id) {
+        case SND_AUDIOCODEC_PCM:
+            printk("SND_AUDIOCODEC_PCM\n");
+            cmd.audioType = htonl(AUDIO_LPCM_DECODER_TYPE);
+            cmd.privateInfo[0] = htonl(params->codec.ch_in);
+            cmd.privateInfo[1] = htonl(16);
+            cmd.privateInfo[2] = htonl(params->codec.sample_rate);
+            cmd.privateInfo[3] = htonl(0);
+            cmd.privateInfo[4] = htonl(snd_choose_channel_mapping(params->codec.ch_in));  // privateInfo[4]&0x3FFFC0)>>6; // bit[6:21] for wave channel mask
+            cmd.privateInfo[5] = htonl(0);
+            cmd.privateInfo[6] = htonl(0);
+            cmd.privateInfo[7] = htonl(AUDIO_LITTLE_ENDIAN);
+            break;
+        case SND_AUDIOCODEC_MP3:
+            TRACE_CODE("SND_AUDIO_MP3\n");
+            cmd.audioType = htonl(AUDIO_MPEG_DECODER_TYPE);
+            break;
+        case SND_AUDIOCODEC_AAC:
+            TRACE_CODE("SND_AUDIO_AAC\n");
+#if 0
+            cmd.audioType = htonl(AUDIO_AAC_DECODER_TYPE);
+#else
+            cmd.audioType = htonl(AUDIO_RAW_AAC_DECODER_TYPE);
+            cmd.privateInfo[0] = htonl(params->codec.ch_in);
+            cmd.privateInfo[1] = htonl(GetSampleIndex(params->codec.sample_rate));
+            cmd.privateInfo[2] = htonl(OBJT_TYPE_LC);
+            cmd.privateInfo[3] = htonl(0);
+#endif
+            break;
+        case SND_AUDIOCODEC_AC3:
+            printk("SND_AUDIO_AC3\n");
+            cmd.audioType = htonl(AUDIO_AC3_DECODER_TYPE);
+            break;
+        case SND_AUDIOCODEC_EAC3:
+            printk("SND_AUDIO_EAC3\n");
+            cmd.audioType = htonl(AUDIO_DDP_DECODER_TYPE);
+            break;
+        case SND_AUDIOCODEC_DTS:
+            printk("SND_AUDIO_DTS\n");
+            cmd.audioType = htonl(AUDIO_DTS_DECODER_TYPE);
+            break;
+        case SND_AUDIOCODEC_DTS_HD:
+            printk("SND_AUDIO_DTS_HD\n");
+            cmd.audioType = htonl(AUDIO_DTS_HD_DECODER_TYPE);
+            break;
+        case SND_AUDIOCODEC_TRUEHD:
+            printk("SND_AUDIO_TRUEHD\n");
+            cmd.audioType = htonl(AUDIO_MLP_DECODER_TYPE);
+            RPC_TOAGENT_SET_TRUEHD_ERR_SELF_RESET(true);
+            break;
+        case SND_AUDIOCODEC_IEC61937:
+            printk("SND_AUDIOCODEC_IEC61937\n");
+            cmd.audioType = htonl(AUDIO_LPCM_DECODER_TYPE);
+            cmd.privateInfo[0] = htonl(params->codec.ch_in);
+            cmd.privateInfo[1] = htonl(16);
+            cmd.privateInfo[2] = htonl(params->codec.sample_rate);
+            cmd.privateInfo[3] = htonl(0);
+            cmd.privateInfo[4] = htonl(0x1<<26);  // IEC61937 set bit26 to 1.
+            cmd.privateInfo[5] = htonl(0);
+            cmd.privateInfo[6] = htonl(0);  // (a_format->privateData[0]&0x1)<<4 : float or not
+            cmd.privateInfo[7] = htonl(AUDIO_LITTLE_ENDIAN);
+            break;
+        default:
+            ALSA_WARNING("[%s %d] audio format not support\n", __FUNCTION__, __LINE__);
+            break;
+    }
+
+    cmd.header.type = htonl(AUDIO_DEC_INBAMD_CMD_TYPE_NEW_FORMAT);
+    cmd.header.size = htonl(sizeof(AUDIO_DEC_NEW_FORMAT));
+    cmd.wPtr = htonl(stream->phyDecInRing);
+#ifdef CONFIG_64BIT
+    writeInbandCmd2(stream, &cmd, sizeof(AUDIO_DEC_NEW_FORMAT));
+#else
+    snd_realtek_hw_ring_write(&stream->decInbandRingHeader, &cmd, sizeof(AUDIO_DEC_NEW_FORMAT),
+        (unsigned long)stream->virInbandRing - (unsigned long)stream->phyDecInbandRing);
+#endif
+
+#if 0 //deliver pts to inband cmd
+    AUDIO_DEC_PTS_INFO ptsCmd;
+    ptsCmd.header.type = AUDIO_DEC_INBAND_CMD_TYPE_PTS;
+    ptsCmd.header.size = sizeof (AUDIO_DEC_PTS_INFO);
+    ptsCmd.PTSH = 0 >> 32;
+    ptsCmd.PTSL = 0;
+    snd_realtek_hw_ring_write(&stream->decInbandRingHeader, &ptsCmd, sizeof(AUDIO_DEC_PTS_INFO),
+        (unsigned long)stream->virInbandRing - (unsigned long)stream->phyDecInbandRing);
+#endif
+
+    TRACE_CODE("[-] %s %d\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+static int snd_card_compr_set_metadata(struct snd_compr_stream *cstream, struct snd_compr_metadata *metadata) {
+    TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+/*
+static int snd_card_compr_get_params(struct snd_compr_stream *cstream, struct snd_codec *params) {
+    TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+static int snd_card_compr_get_metadata(struct snd_compr_stream *cstream, struct snd_compr_metadata *metadata) {
+    TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+*/
+static int snd_card_compr_trigger(struct snd_compr_stream *cstream, int cmd) {
+    //TRACE_CODE("%s %d cmd %d\n", __FUNCTION__, __LINE__, cmd);
+
+    int rawDelay;
+    rtk_runtime_stream_t *stream = cstream->runtime->private_data;
+
+    switch (cmd) {
+        case SNDRV_PCM_TRIGGER_START:
+        case SNDRV_PCM_TRIGGER_STOP:
+        case SNDRV_PCM_TRIGGER_PAUSE_PUSH:
+        case SNDRV_PCM_TRIGGER_PAUSE_RELEASE:
+            if (triggerAudio(stream, cmd)) {
+                ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+            }
+            break;
+        case SND_COMPR_TRIGGER_DRAIN:
+        case SND_COMPR_TRIGGER_PARTIAL_DRAIN:
+            {
+                TRACE_CODE("TRIGGER_DRAIN/TRIGGER_PARTIAL_DRAIN\n");
+#if 0
+                AUDIO_DEC_EOS cmd;
+                cmd.header.type = htonl(AUDIO_DEC_INBAND_CMD_TYPE_EOS);
+                cmd.header.size = htonl(sizeof(AUDIO_DEC_EOS));
+                cmd.EOSID = htonl(0);
+                cmd.wPtr = stream->decInRingHeader.writePtr;
+                snd_realtek_hw_ring_write(&stream->decInbandRingHeader, &cmd, sizeof(AUDIO_DEC_INBAND_CMD_TYPE_EOS),
+                    (unsigned long)stream->virInbandRing - (unsigned long)stream->phyDecInbandRing);
+#endif
+            } break;
+        case SND_COMPR_TRIGGER_NEXT_TRACK:
+            TRACE_CODE("TRIGGER_NEXT_TRACK\n");
+            break;
+        case SND_COMPR_TRIGGER_GET_LATENCY:
+            //rawDelay = snd_monitor_raw_data_queue();
+            rawDelay = snd_monitor_raw_data_queue_new(stream);
+            return rawDelay;
+        default:
+            return -EINVAL;
+    }
+
+    return 0;
+}
+
+static int snd_card_compr_pointer(struct snd_compr_stream *cstream, struct snd_compr_tstamp *tstamp) {
+    //TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+
+    rtk_runtime_stream_t *stream = cstream->runtime->private_data;
+
+    unsigned char* ptswp = stream->virDwnRing +
+        (ntohl(stream->dwnstrmRingHeader.writePtr) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+    unsigned char* ptsrp = stream->virDwnRing +
+        (ntohl(stream->dwnstrmRingHeader.readPtr[0]) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+    unsigned long space = 0;
+    //TRACE_CODE("dwnstrm inband wp %x rp %x\n", ptswp, ptsrp);
+    unsigned long frameSize = 0;
+    unsigned int decfrm = 0;
+    long cosume_Size = 0;
+    long now_rp;
+
+    //unsigned long queueFrames;
+    if (!stream->isGetInfo) {
+        if (!checkAudioInfo(stream)) {
+            stream->isGetInfo = false;
+            //TRACE_CODE("dsp need more data\n");
+            //return 0;
+        } else {
+            ptswp = stream->virDwnRing +
+                (ntohl(stream->dwnstrmRingHeader.writePtr) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+            ptsrp = stream->virDwnRing +
+                (ntohl(stream->dwnstrmRingHeader.readPtr[0]) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+            //TRACE_CODE("dwnstrm inband wp %x rp %x\n", ptswp, ptsrp);
+        }
+    }
+
+    if (ptswp != ptsrp) {
+        do {
+            AUDIO_INBAND_CMD_TYPE infoType;
+            memset(&infoType, 0, sizeof(AUDIO_INBAND_CMD_TYPE));
+            GetBufferFromRing(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, (unsigned char*)&infoType, sizeof(AUDIO_INBAND_CMD_TYPE));
+
+            if (infoType == AUDIO_DEC_INBAND_CMD_TYPE_PRIVATE_INFO) {
+                //skip private info
+                AUDIO_INBAND_PRIVATE_INFO inbandInfo;
+                memset(&inbandInfo, 0, INBAND_INFO_SIZE);
+                space = GetBufferFromRing(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, (unsigned char*)&inbandInfo, INBAND_INFO_SIZE);
+                UpdateRingPtr(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, stream, INBAND_INFO_SIZE, space);
+                //skip pcminfo or channel index info
+                if (inbandInfo.infoType == AUDIO_INBAND_CMD_PRIVATE_PCM_FMT) {
+                    ptsrp = stream->virDwnRing + (ntohl(stream->dwnstrmRingHeader.readPtr[0]) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+                    space = stream->virDwnRingUpper - ptsrp;
+                    UpdateRingPtr(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, stream, INBAND_PCM_SIZE, space);
+                    TRACE_CODE("skip INBAND CMD PRIVATE PCM FMT\n");
+                } else if (inbandInfo.infoType == AUDIO_INBAND_CMD_PRIVATE_CH_IDX) {
+                    ptsrp = stream->virDwnRing + (ntohl(stream->dwnstrmRingHeader.readPtr[0]) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+                    space = stream->virDwnRingUpper - ptsrp;
+                    UpdateRingPtr(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, stream, INBAND_INDEX_SIZE, space);
+                    TRACE_CODE("skip INBAND CMD PRIVATE CH IDX\n");
+                } else {
+                    TRACE_CODE("should not be there %d\n", __LINE__);
+                    break;
+                }
+            } else if (infoType == AUDIO_DEC_INBAND_CMD_TYPE_PTS) {
+                //get ptsinfo
+                AUDIO_DEC_PTS_INFO pPTSInfo;
+                memset(&pPTSInfo, 0, INBAND_PTS_INFO_SIZE);
+                space = GetBufferFromRing(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, (unsigned char*)&pPTSInfo, INBAND_PTS_INFO_SIZE);
+                //TRACE_CODE("Get pts form ACPU PTSH %d PTSL %d\n", pPTSInfo.PTSH, pPTSInfo.PTSL);
+                //            frame->nTimeStamp = (OMX_S64)(((OMX_U64)pPTSInfo.PTSH << 32) | pPTSInfo.PTSL);
+                //            frame->nTimeStamp = (OMX_S64)(((float)frame->nTimeStamp / 90000.0)*1E6);
+
+                //wPtr is used to indicate the audio frame length
+                //            TRACE_CODE("get frameSize from audio fw %d ptswp %p ptsrp %p\n", pPTSInfo.wPtr, ptswp, ptsrp);
+                if (pPTSInfo.wPtr != 0) {
+                    frameSize += pPTSInfo.wPtr;
+                    UpdateRingPtr(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, stream, INBAND_PTS_INFO_SIZE, space);
+                } else {
+                    TRACE_CODE("should not be there %d\n", __LINE__);
+                    break;
+                }
+            } else if (infoType == AUDIO_DEC_INBAND_CMD_TYPE_EOS) {
+                AUDIO_DEC_EOS pEOSInfo;
+
+                TRACE_CODE("RECEIVE AUDIO_DEC_INBAND_CMD_TYPE_EOS\n");
+                memset(&pEOSInfo, 0, INBAND_EOS_SIZE);
+                space = GetBufferFromRing(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, (unsigned char*)&pEOSInfo, INBAND_EOS_SIZE);
+                UpdateRingPtr(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, stream, INBAND_EOS_SIZE, space);
+                if (pEOSInfo.header.size == INBAND_EOS_SIZE && pEOSInfo.EOSID == 0) {
+                    printk(KERN_ALERT "get audio eos\n");
+                } else if (pEOSInfo.header.size == INBAND_EOS_SIZE && pEOSInfo.EOSID == -1) {
+                    TRACE_CODE("should not be there %d\n", __LINE__);
+                    break;
+                }
+            } else {
+                TRACE_CODE("should not be there %d\n", __LINE__);
+                break;
+            }
+            ptswp = stream->virDwnRing +
+                (ntohl(stream->dwnstrmRingHeader.writePtr) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+            ptsrp = stream->virDwnRing +
+                (ntohl(stream->dwnstrmRingHeader.readPtr[0]) - ntohl(stream->dwnstrmRingHeader.beginAddr));
+
+        } while (ptswp != ptsrp);
+    } else {
+        TRACE_CODE("need more data %d\n", __LINE__);
+        //usleep_range(500,1000);
+    }
+
+    //to calculate to total read into decoder.
+    now_rp = (long)ntohl(stream->decInRingHeader.readPtr[0]);
+    if (now_rp != stream->lastInRingRP) {
+        long rp = stream->lastInRingRP;
+        long lower = (long)ntohl(stream->decInRingHeader.beginAddr);
+        long upper = lower + (long)ntohl(stream->decInRingHeader.size);
+        cosume_Size = ringValidData(lower, upper, rp, now_rp);
+        stream->lastInRingRP = now_rp;
+    }
+
+    stream->comsume_total += cosume_Size;
+    tstamp->copied_total = stream->comsume_total;
+    tstamp->byte_offset = tstamp->copied_total % (u32)cstream->runtime->buffer_size;
+
+    //tstamp->pcm_frames = 0;
+    if (frameSize) {
+        //UpdateRingPtr(stream->virDwnRingUpper, stream->virDwnRingLower, ptsrp, stream, INBAND_PTS_INFO_SIZE, space);
+        stream->outFrames += (frameSize >> 2);
+        //TRACE_CODE("stream out frames %d\n", stream->outFrames);
+        TRACE_CODE("stream out frames %ld wp %p rp %p\n", frameSize, ptswp, ptsrp);
+    }
+
+    //for IOCTL TSTAMP to get render position in user space
+#if 1
+    decfrm = ENDIAN_CHANGE(rawdelay_mem2->decfrm_smpl);
+    if (decfrm == 0)
+        tstamp->pcm_io_frames = stream->outFrames;
+    else
+        tstamp->pcm_io_frames = ENDIAN_CHANGE(rawdelay_mem2->decfrm_smpl);
+
+    //if (stream->isGetInfo)
+        tstamp->sampling_rate = stream->audioSamplingRate;
+#else
+    if (stream->isGetInfo) {
+        tstamp->sampling_rate = stream->audioSamplingRate;
+        queueFrames = snd_monitor_raw_data_queue() * stream->audioSamplingRate / 1000;
+
+        if (queueFrames > stream->outFrames) {
+            printk(KERN_ALERT "queueFrames %lu outFrames %lu", queueFrames, stream->outFrames);
+            tstamp->pcm_io_frames = 0;
+        } else {
+            if (frameSize && ((stream->outFrames - queueFrames) > stream->preOutFrames))
+                tstamp->pcm_io_frames = stream->outFrames - queueFrames;
+            else
+                tstamp->pcm_io_frames = stream->preOutFrames;
+        }
+        stream->preOutFrames = tstamp->pcm_io_frames;
+        //printk(KERN_ALERT "renderedFrames %u samplerate %d\n", tstamp->pcm_io_frames, stream->audioSamplingRate);
+    }
+#endif
+    //TRACE_CODE("calc bytes offset/copied bytes as %d runtime->buffer_size %d\n", tstamp->byte_offset, cstream->runtime->buffer_size);
+
+    return 0;
+}
+
+static int snd_card_compr_copy(struct snd_compr_stream *cstream, char __user *buf, size_t count) {
+    //TRACE_CODE("%s %d buf %p size %d\n", __FUNCTION__, __LINE__, buf, count);
+
+    rtk_runtime_stream_t *stream = cstream->runtime->private_data;
+
+    //copy data to input ringbuffer
+    long wp = (long)ntohl(stream->decInRingHeader.writePtr);
+    long rp = (long)ntohl(stream->decInRingHeader.readPtr[0]);
+    long lower = (long)ntohl(stream->decInRingHeader.beginAddr);
+    long upper = lower + (long)ntohl(stream->decInRingHeader.size);
+    long writableSize = 0;
+    int bufFullCount = 0;
+    int write_frame = 0;
+
+    //TRACE_CODE("decInring wp %lx rp %lx\n", wp, rp);
+
+    writableSize = validFreeSize(lower, upper, rp, wp);
+    while(count > writableSize) {
+        if(bufFullCount++ > 5) {
+            //printk(KERN_ALERT "writableSize %ld count %zu bufFullCount %d return\n", writableSize ,count ,bufFullCount);
+            return 0;
+        }
+        usleep_range(500,1000);
+        rp = (long) ntohl(stream->decInRingHeader.readPtr[0]);
+        writableSize = validFreeSize(lower, upper, rp, wp);
+    }
+#if 1
+    /*
+     * With hw av sync header       : Write header & data into different buffer
+     * Without hw av sync header    : Write data only
+     */
+    write_frame = directWriteData(stream, (char *)buf, count);
+#else
+    snd_realtek_hw_ring_write(&stream->decInRingHeader, (char *)buf, count,
+        (unsigned long)stream->virDecInRing - (unsigned long)stream->phyDecInRing);
+#endif
+    stream->copied_total += count;
+    /*
+     * With hw av sync header       : count = write_frame + header
+     * Without hw av sync header    : count = write_frame
+     */
+    stream->comsume_total += (count - write_frame);
+    //TRACE_CODE("copy %zu bufFullCount %d return\n", count ,bufFullCount);
+    return count;
+}
+
+#if 0
+static int snd_card_compr_ack(struct snd_compr_stream *cstream, size_t bytes) {
+    TRACE_CODE("%s %d bytes %d\n", __FUNCTION__, __LINE__, bytes);
+
+    rtk_runtime_stream_t *stream = cstream->runtime->private_data;
+    stream->bytes_written += bytes;
+    return 0;
+}
+#endif
+
+static int snd_card_compr_get_caps(struct snd_compr_stream *cstream, struct snd_compr_caps *caps) {
+    TRACE_CODE("%s %d\n", __FUNCTION__, __LINE__);
+
+    caps->num_codecs = NUM_CODEC;
+    caps->direction = SND_COMPRESS_PLAYBACK;
+    caps->min_fragment_size = MIN_FRAGMENT_SIZE;
+    caps->max_fragment_size = MAX_FRAGMENT_SIZE;
+    caps->min_fragments = MIN_FRAGMENT;
+    caps->max_fragments = MAX_FRAGMENT;
+    caps->codecs[0] = SND_AUDIOCODEC_MP3;
+    caps->codecs[1] = SND_AUDIOCODEC_AAC;
+    caps->codecs[2] = SND_AUDIOCODEC_AC3;
+    caps->codecs[3] = SND_AUDIOCODEC_DTS;
+    caps->codecs[4] = SND_AUDIOCODEC_DTS_HD;
+    caps->codecs[5] = SND_AUDIOCODEC_EAC3;
+    caps->codecs[6] = SND_AUDIOCODEC_TRUEHD;
+    return 0;
+}
+
+static struct snd_compr_codec_caps caps_mp3 = {
+    .num_descriptors = 1,
+    .descriptor[0].max_ch = 2,
+    .descriptor[0].sample_rates[0] = 48000,
+    .descriptor[0].sample_rates[1] = 44100,
+    .descriptor[0].sample_rates[2] = 32000,
+    .descriptor[0].sample_rates[3] = 16000,
+    .descriptor[0].sample_rates[4] = 8000,
+    .descriptor[0].num_sample_rates = 5,
+    .descriptor[0].bit_rate[0] = 320,
+    .descriptor[0].bit_rate[1] = 192,
+    .descriptor[0].num_bitrates = 2,
+    .descriptor[0].profiles = 0,
+    .descriptor[0].modes = SND_AUDIOCHANMODE_MP3_STEREO,
+    .descriptor[0].formats = 0,
+};
+
+static struct snd_compr_codec_caps caps_aac = {
+    .num_descriptors = 1,
+    .descriptor[0].max_ch = 8,
+    .descriptor[0].sample_rates[0] = 48000,
+    .descriptor[0].sample_rates[1] = 44100,
+    .descriptor[0].sample_rates[2] = 32000,
+    .descriptor[0].sample_rates[3] = 16000,
+    .descriptor[0].sample_rates[4] = 8000,
+    .descriptor[0].num_sample_rates = 5,
+    .descriptor[0].bit_rate[0] = 320,
+    .descriptor[0].bit_rate[1] = 192,
+    .descriptor[0].num_bitrates = 2,
+    .descriptor[0].profiles = 0,
+    .descriptor[0].modes = 0,
+    .descriptor[0].formats = 0, //(SND_AUDIOSTREAMFORMAT_MP2ADTS | SND_AUDIOSTREAMFORMAT_MP4ADTS),
+};
+
+static struct snd_compr_codec_caps caps_ac3 = {
+    .num_descriptors = 1,
+    .descriptor[0].max_ch = 8,
+    .descriptor[0].sample_rates[0] = 48000,
+    .descriptor[0].sample_rates[1] = 44100,
+    .descriptor[0].sample_rates[2] = 32000,
+    .descriptor[0].sample_rates[3] = 16000,
+    .descriptor[0].sample_rates[4] = 8000,
+    .descriptor[0].num_sample_rates = 5,
+    .descriptor[0].bit_rate[0] = 320,
+    .descriptor[0].bit_rate[1] = 192,
+    .descriptor[0].num_bitrates = 2,
+    .descriptor[0].profiles = 0,
+    .descriptor[0].modes = 0,
+    .descriptor[0].min_buffer = 8192,
+    .descriptor[0].formats = 0,
+};
+
+static struct snd_compr_codec_caps caps_eac3 = {
+    .num_descriptors = 1,
+    .descriptor[0].max_ch = 8,
+    .descriptor[0].sample_rates[0] = 48000,
+    .descriptor[0].sample_rates[1] = 44100,
+    .descriptor[0].sample_rates[2] = 32000,
+    .descriptor[0].sample_rates[3] = 16000,
+    .descriptor[0].sample_rates[4] = 8000,
+    .descriptor[0].num_sample_rates = 5,
+    .descriptor[0].bit_rate[0] = 320,
+    .descriptor[0].bit_rate[1] = 192,
+    .descriptor[0].num_bitrates = 2,
+    .descriptor[0].profiles = 0,
+    .descriptor[0].modes = 0,
+    .descriptor[0].min_buffer = 8192,
+    .descriptor[0].formats = 0,
+};
+
+static struct snd_compr_codec_caps caps_dts = {
+    .num_descriptors = 1,
+    .descriptor[0].max_ch = 8,
+    .descriptor[0].sample_rates[0] = 48000,
+    .descriptor[0].sample_rates[1] = 44100,
+    .descriptor[0].sample_rates[2] = 32000,
+    .descriptor[0].sample_rates[3] = 16000,
+    .descriptor[0].sample_rates[4] = 8000,
+    .descriptor[0].num_sample_rates = 5,
+    .descriptor[0].bit_rate[0] = 320,
+    .descriptor[0].bit_rate[1] = 192,
+    .descriptor[0].num_bitrates = 2,
+    .descriptor[0].profiles = 0,
+    .descriptor[0].modes = 0,
+    .descriptor[0].min_buffer = 8192,
+    .descriptor[0].formats = 0,
+};
+
+
+static struct snd_compr_codec_caps caps_dtsHD = {
+    .num_descriptors = 1,
+    .descriptor[0].max_ch = 8,
+    .descriptor[0].sample_rates[0] = 48000,
+    .descriptor[0].sample_rates[1] = 44100,
+    .descriptor[0].sample_rates[2] = 32000,
+    .descriptor[0].sample_rates[3] = 16000,
+    .descriptor[0].sample_rates[4] = 8000,
+    .descriptor[0].num_sample_rates = 5,
+    .descriptor[0].bit_rate[0] = 320,
+    .descriptor[0].bit_rate[1] = 192,
+    .descriptor[0].num_bitrates = 2,
+    .descriptor[0].profiles = 0,
+    .descriptor[0].modes = 0,
+    .descriptor[0].min_buffer = 8192,
+    .descriptor[0].formats = 0,
+};
+
+static struct snd_compr_codec_caps caps_trueHD = {
+    .num_descriptors = 1,
+    .descriptor[0].max_ch = 8,
+    .descriptor[0].sample_rates[0] = 48000,
+    .descriptor[0].sample_rates[1] = 44100,
+    .descriptor[0].sample_rates[2] = 32000,
+    .descriptor[0].sample_rates[3] = 16000,
+    .descriptor[0].sample_rates[4] = 8000,
+    .descriptor[0].num_sample_rates = 5,
+    .descriptor[0].bit_rate[0] = 320,
+    .descriptor[0].bit_rate[1] = 192,
+    .descriptor[0].num_bitrates = 2,
+    .descriptor[0].profiles = 0,
+    .descriptor[0].modes = 0,
+    .descriptor[0].min_buffer = 8192,
+    .descriptor[0].formats = 0,
+};
+
+static int snd_card_compr_get_codec_caps(struct snd_compr_stream *cstream, struct snd_compr_codec_caps *codec) {
+    TRACE_CODE("%s %d codec %x\n", __FUNCTION__, __LINE__, codec->codec);
+
+    switch (codec->codec) {
+        case SND_AUDIOCODEC_MP3:
+            *codec = caps_mp3;
+            break;
+        case SND_AUDIOCODEC_AAC:
+            *codec = caps_aac;
+            break;
+        case SND_AUDIOCODEC_AC3:
+            *codec = caps_ac3;
+            break;
+        case SND_AUDIOCODEC_EAC3:
+            *codec = caps_eac3;
+            break;
+        case SND_AUDIOCODEC_DTS:
+            *codec = caps_dts;
+            break;
+        case SND_AUDIOCODEC_DTS_HD:
+            *codec = caps_dtsHD;
+            break;
+        case SND_AUDIOCODEC_TRUEHD:
+            *codec = caps_trueHD;
+            break;
+        default:
+            return -EINVAL;
+    }
+    return 0;
+}
+
+int snd_monitor_raw_data_queue(void) {
+    int rawOutDelay = 0;
+    /*
+    if (rawdelay_mem) {
+        rawOutDelay = *rawdelay_mem;
+        //rawOutDelay = ENDIAN_CHANGE(rawOutDelay);
+        rawOutDelay = htonl(rawOutDelay);
+    }
+    */
+    if (rawdelay_mem2) {
+        rawOutDelay = ENDIAN_CHANGE(rawdelay_mem2->latency) / 1000;
+    } else if (rawdelay_mem ){
+        rawOutDelay = *rawdelay_mem;
+        //rawOutDelay = ENDIAN_CHANGE(rawOutDelay);
+        rawOutDelay = htonl(rawOutDelay);
+    } else {
+        rawOutDelay = mtotal_latency;
+    }
+    return rawOutDelay;
+}
+
+static struct snd_compr_ops snd_card_rtk_compr_ops = {
+    .open           = snd_card_compr_open,
+    .free           = snd_card_compr_free,
+    .set_params     = snd_card_compr_set_params,
+    .get_params     = NULL, //snd_card_compr_get_params,
+    .set_metadata   = snd_card_compr_set_metadata,
+    .get_metadata   = NULL, //snd_card_compr_get_metadata,
+    .trigger        = snd_card_compr_trigger,
+    .pointer        = snd_card_compr_pointer,
+    .copy           = snd_card_compr_copy,
+    .ack            = NULL, //snd_card_compr_ack,
+    .get_caps       = snd_card_compr_get_caps,
+    .get_codec_caps = snd_card_compr_get_codec_caps
+};
+
+int snd_card_create_compress_instance(RTK_snd_card_t *pSnd, int instance_idx) {
+    struct snd_compr *compr = NULL;
+    int ret = 0;
+    int direction = SND_COMPRESS_PLAYBACK;
+
+    compr = kzalloc(sizeof(*compr), GFP_KERNEL);
+    if (compr == NULL) {
+        snd_printk(KERN_ERR "Cannot allocate compr\n");
+        return -ENOMEM;
+    }
+
+    compr->ops = kzalloc(sizeof(snd_card_rtk_compr_ops), GFP_KERNEL);
+    if (compr->ops == NULL) {
+        snd_printk(KERN_ERR "Cannot allocate compressed ops\n");
+        ret = -ENOMEM;
+        goto compr_err;
+    }
+    memcpy(compr->ops, &snd_card_rtk_compr_ops, sizeof(snd_card_rtk_compr_ops));
+
+    mutex_init(&compr->lock);
+    ret = snd_compress_new(pSnd->card, instance_idx, direction, "rtk_snd",compr);
+    if (ret < 0) {
+        pr_err("snd_card_create_compress_instance failed");
+        goto compr_err;
+    }
+
+    pSnd->compr = compr;
+    compr->private_data = pSnd;
+
+    TRACE_CODE("[%s %d] snd_card_create_compress_instance success\n", __FUNCTION__, __LINE__);
+
+    return 0;
+
+compr_err:
+    if (compr->ops != NULL)
+        kfree(compr->ops);
+    if (compr != NULL)
+        kfree(compr);
+    return ret;
+}
diff --git a/sound/arm/snd-realtek-compress.h b/sound/arm/snd-realtek-compress.h
new file mode 100644
index 00000000..20e58df
--- /dev/null
+++ b/sound/arm/snd-realtek-compress.h
@@ -0,0 +1,190 @@
+/**
+ * snd-realtek-compress.h - Realtek alsa driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef SND_COMPRESS_RTK
+#define SND_COMPRESS_RTK
+
+#include <sound/compress_params.h>
+#include <sound/compress_offload.h>
+#include <sound/compress_driver.h>
+
+enum
+{
+    OBJT_TYPE_NULL = 0,
+    OBJT_TYPE_MAIN = 1,
+    OBJT_TYPE_LC   = 2,
+    OBJT_TYPE_SSR  = 3,
+    OBJT_TYPE_SBR  = 5
+};
+
+struct AUDIO_PCM_FORMAT {
+    int chnum;
+    int samplebit;
+    int samplerate;
+    u_int dynamicRange;
+    u_char emphasis;
+    u_char mute;
+};
+typedef struct AUDIO_PCM_FORMAT AUDIO_PCM_FORMAT;
+
+typedef enum
+{
+    ENUM_AUDIO_PCM_FORMAT,                              //0
+    ENUM_AUDIO_FRAME_SIZE,
+    ENUM_AUDIO_FRAME_BOUNDARY,
+    ENUM_AUDIO_DEC_EXT_BS,
+    ENUM_AUDIO_DEC_CFG,
+    ENUM_AUDIO_CS_DATA,
+    ENUM_AUDIO_AI_STATE,
+    ENUM_AUDIO_SPDIF_BS_INFO,
+    ENUM_AUDIO_DEMUX_BUFFER_INIT,
+    ENUM_AUDIO_CHANNEL_INDEX,                           //9
+    ENUM_AUDIO_ECHO_INFO,
+    // add by ny /////////////////////////////////
+    ENUM_AUDIO_ENC_CFG,
+    // add end ///////////////////////////////////
+    ENUM_AUDIO_REFRESH_RBUFPTR,
+    ENUM_AUDIO_SWITCH_FOCUS,                            //d
+    ENUM_AIN_SWITCH_FOCUS,
+    ENUM_AUDIO_CHANNEL_SOURCE,      //obsolete
+    ENUM_AUDIO_SPDIF_NONPCM_CFG,
+    ENUM_AOUT_MUTE_INFO,
+    ENUM_AOUT_VOLUME_LEVEL,
+    ENUM_AOUT_SPDIF_SOURCE_SELECT,
+    ENUM_AOUT_KARAOKE_CONTROL,
+    ENUM_AOUT_SPDIF_DIFF,
+    ENUM_AUDIO_CHANGE_PP_OUT_SAMPLERATE,
+    ENUM_APP_NIGHT_MODE_CFG,  // old version
+    ENUM_APP_REINIT_PIN,
+    ENUM_AUDIO_BS_ERR,
+    ENUM_AUDIO_PTS_TEST,
+    ENUM_AOUT_DROP_PTS,
+    ENUM_APP_NIGHT_MODE_INFO, // for night mode global var
+    ENUM_AUDIO_MPEG_TYPE,
+    ENUM_AUDIO_NOISE_INFO,
+    ENUM_AUDIO_SOUND_EVENT,
+    ENUM_AUDIO_PRIVATE_CGMS_INFO,                       //21
+    // add by taro for inband /////////////////////////////////
+    ENUM_AUDIO_INBAND_EOS_INFO,
+    ENUM_AUDIO_INBAND_PTS_INFO,
+    //    ENUM_AUDIO_INBAND_PRIVATE_INFO,
+    ENUM_AUDIO_INBAND_NEWFORMAT_INFO,
+    // end add by taro for inband /////////////////////////////////
+    ENUM_AUDIO_DEC_GET_FORMAT,
+    // for trans-encoder, add by isometry
+    ENUM_AUDIO_TRANSENC_BS_INFO,
+    ENUM_AUDIO_TRANSENC_BUFFER_INIT,
+    ENUM_AUDIO_TRANSENC_NONPCM_CFG,
+    ENUM_AUDIO_SRC_CHANGE,
+    // end for trans-encoder
+    // send aac raw out info
+    ENUM_AUDIO_AAC_RAW_OUT_INFO,
+    ENUM_AUDIO_FLASH_AO,
+    ENUM_AUDIO_IN_DATA_MEASURE,
+    ENUM_AUDIO_DECODER_NEWFORMAT,
+    ENUM_AUDIO_PASSTHROUGH_MODE,
+    ENUM_AUDIO_DTS_DOWNMIX,
+    ENUM_AUDIO_AAC_DOWNMIX,
+    ENUM_AUDIO_KARAOKE_INFO, // for Karaoke mixer, add by Chris
+#ifdef AUDIO_RAW_OUT_MORE_BYTES
+    ENUM_AUDIO_DECODER_EOS,      // for raw out, decoder inform AO to raw out more 64 bytes.
+#endif
+    ENUM_AUDIO_GET_FLASH_PINID,
+    ENUM_AUDIO_RELEASE_FLASH_PINID,
+    ENUM_AUDIO_CONTROL_FLASH_VOLUME,
+    ENUM_AUDIO_DEC_SUPPORT_RATE,
+#ifdef AUDIO_TV_PLATFORM
+    ENUM_AUDIO_SPDIF_OUT_CS_INFO,
+    ENUM_AUDIO_DEC_DELAY_RP,
+    ENUM_AUDIO_ANALOG_INPUT_CLOCK_INFO,
+    ENUM_AIN_ATV_SET_CLOCK,
+    ENUM_AIN_INOUT_CH_SELECT,
+    ENUM_AIN_SET_FS_CLOCKSRC,
+    ENUM_AIN_SET_PATH_DATA_OUT,
+    ENUM_AIN_SET_INTERLEAVE_OUT,
+#ifdef SUPPORT_GLOBAL_AI
+    ENUM_AIN_SET_OUT_FMT,
+#endif // SUPPORT_GLOBAL_AI
+#endif // AUDIO_TV_PLATFORM
+    ENUM_APP_AGC_MODE_CONFIG,
+    ENUM_AO_LOW_DELAY_PARAMETERS,
+    ENUM_AIN_CONNECT_ALSA
+} ENUM_AUDIO_INFO_TYPE;
+
+typedef struct
+{
+    ENUM_AUDIO_INFO_TYPE    infoType;
+    AUDIO_PCM_FORMAT        pcmFormat;
+    unsigned int            start_addr;
+    //long                    start_addr;
+    int                     max_bit_rate;
+} AUDIO_INFO_PCM_FORMAT;
+
+typedef struct
+{
+    ENUM_AUDIO_INFO_TYPE    infoType;
+    char channel_index[8];
+    unsigned int start_addr;
+    char dual_mono_flag;
+} AUDIO_INFO_CHANNEL_INDEX_OLD;
+
+typedef struct
+{
+    ENUM_AUDIO_INFO_TYPE    infoType;
+    unsigned int channel_index[8];
+    unsigned int start_addr;
+    //long start_addr;
+    unsigned int dual_mono_flag;
+} AUDIO_INFO_CHANNEL_INDEX_NEW;
+
+// for use dwnstrmInBandQ to deliver info
+typedef enum
+{
+    AUDIO_INBAND_CMD_PRIVATE_INVALID    = 0,
+    AUDIO_INBAND_CMD_PRIVATE_PCM_FMT    = 1,
+    AUDIO_INBAND_CMD_PRIVATE_CH_IDX     = 2
+} ENUM_AUDIO_INBAND_PRIVATE_INFO;
+
+//following this packet, has private_size number of bytes is the privateinfo to deliver out
+typedef struct
+{
+    AUDIO_INBAND_CMD_PKT_HEADER header;
+    ENUM_AUDIO_INBAND_PRIVATE_INFO infoType;
+    unsigned int infoSize;
+} AUDIO_INBAND_PRIVATE_INFO ;
+
+typedef struct
+{
+    unsigned int latency;
+    unsigned int ptsL;
+    unsigned int ptsH;
+    unsigned int sum; // latency+PTSL
+    unsigned int decin_wp;
+    unsigned int decin_rp;
+    unsigned int decfrm_smpl;
+} ALSA_RAW_LATENCY;
+
+#define INBAND_PTS_INFO_SIZE sizeof(AUDIO_DEC_PTS_INFO)
+#define INBAND_PCM_SIZE      sizeof(AUDIO_INFO_PCM_FORMAT)
+#define INBAND_EOS_SIZE      sizeof(AUDIO_DEC_EOS)
+#define INBAND_INDEX_SIZE    sizeof(AUDIO_INFO_CHANNEL_INDEX_NEW)
+#define INBAND_INFO_SIZE     sizeof(AUDIO_INBAND_PRIVATE_INFO)
+#define AUDIO_START_THRES    (INBAND_PCM_SIZE + INBAND_INDEX_SIZE + (2 * INBAND_INFO_SIZE))
+
+#define NEW_CHANNEL_INDEX_INFO_SIZE  sizeof(AUDIO_INFO_CHANNEL_INDEX_NEW)
+#define OLD_CHANNEL_INDEX_INFO_SIZE  sizeof(AUDIO_INFO_CHANNEL_INDEX_OLD)
+
+//////////////////////////////////////////////////////////////////////////////////////////
+
+int snd_card_create_compress_instance(RTK_snd_card_t *pSnd, int instance_idx);
+int snd_monitor_raw_data_queue(void);
+//int snd_monitor_raw_data_queue_new(rtk_runtime_stream_t *stream);
+#endif
diff --git a/sound/arm/snd-realtek-notify.c b/sound/arm/snd-realtek-notify.c
new file mode 100644
index 00000000..d15714d
--- /dev/null
+++ b/sound/arm/snd-realtek-notify.c
@@ -0,0 +1,426 @@
+/**
+ * snd-realtek-notify.c - Realtek alsa driver
+ *
+ * Copyright (C) 2017-2018 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/gpio.h>
+#include <linux/io.h>
+#include <linux/of.h>
+#include <linux/of_address.h>
+#include <linux/of_gpio.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/clk.h>
+#include <soc/realtek/kernel-rpc.h>
+#include <sound/asound.h>
+#include <rtk_rpc.h>
+#include "snd-realtek.h"
+
+extern struct ion_client *alsa_client;
+
+static inline struct ion_client *__get_ion_client(void)
+{
+	return alsa_client;
+}
+
+enum {
+	ENUM_DT_AI_EN = 0, /* this is used by acpu */
+	ENUM_DT_AI_AIN, /* always set this bit if using AI */
+	ENUM_DT_AI_ADC,
+	ENUM_DT_AI_ANALOG_IN,
+	ENUM_DT_AI_ADC_AMIC,
+};
+
+static const char *ai_names[] = {
+	"", "",
+	"adc", "analog-in", "adc-amic",
+};
+
+enum {
+	ENUM_AI_I2S_STATUS = 0,
+	ENUM_AI_I2S_PIN_SHARE_BIT, /* pin-share:1, pin-dependent:0 */
+	ENUM_AI_I2S_AI_MASTER_BIT, /* AI-master:1, AI-slave:0 */
+};
+
+enum {
+	ENUM_DT_AO_DAC    = 0,
+	ENUM_DT_AO_I2S    = 1,
+	ENUM_DT_AO_SPDIF  = 2,
+	ENUM_DT_AO_HDMI   = 3,
+	ENUM_DT_AO_GLOBAL = 4,
+};
+
+#define AN_MAX_DATA_SIZE 16
+
+struct audio_notifier_data {
+	AUDIO_ENUM_AIO_PRIVAETINFO info;
+	u32 data[AN_MAX_DATA_SIZE];
+	u32 size;
+};
+
+/* privateInfo for AI */
+#define AN_AI_DEVICE_ON         0
+#define AN_AI_DEVICE_I2S_CONF   1
+
+/* privateInfo for AO */
+#define AN_AO_SET_DEVICE_OFF            0
+#define AN_AO_SET_I2S_CHANNEL           1
+#define AN_AO_SET_I2S_MODE              2
+
+/* selection of AN_AO_SET_I2S_CHANNEL */
+enum {
+	AN_AO_SET_I2S_2_CHANNEL       = 0,
+	AN_AO_SET_I2S_8_CHANNEL       = 1,
+};
+
+/* selection of AN_AO_SET_I2S_MODE */
+enum {
+	AN_AO_SET_I2S_MODE_MASTER     = 0,
+	AN_AO_SET_I2S_MODE_SLAVE      = 1,
+};
+
+
+static int __send_rpc(struct ion_client *client,
+	AUDIO_ENUM_AIO_PRIVAETINFO info, unsigned int *data, int size)
+{
+	struct ion_handle *handle;
+	ion_phys_addr_t phys;
+	size_t len;
+	AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS *arg;
+	HRESULT RPC_ret;
+	int off;
+	int ret = -EINVAL;
+	int i;
+
+	if (!client)
+		return -EINVAL;
+
+	handle = ion_alloc(client, 4096, 1024,
+		RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+	if (IS_ERR(handle)) {
+		ret = PTR_ERR(handle);
+		goto exit;
+	}
+
+	ret = ion_phys(client, handle, &phys, &len);
+	if (ret)
+		goto exit;
+
+	arg = ion_map_kernel(client, handle);
+	memset(arg, 0, sizeof(*arg));
+
+	arg->type = htonl(info);
+	for (i = 0; i < size; i++)
+		arg->argateInfo[i] = htonl(data[i]);
+	off = get_rpc_alignment_offset(sizeof(*arg));
+
+	if (send_rpc_command(RPC_AUDIO,
+		ENUM_KERNEL_RPC_AIO_PRIVATEINFO,
+		CONVERT_FOR_AVCPU(phys),
+		CONVERT_FOR_AVCPU(phys + off),
+		&RPC_ret)) {
+		ret = -EINVAL;
+		goto exit;
+	}
+
+	ret = RPC_ret != S_OK ? -EINVAL : 0;
+
+exit:
+	if (handle) {
+		ion_unmap_kernel(client, handle);
+		ion_free(client, handle);
+	}
+	return ret;
+}
+
+static bool audio_notifier_data_is_empty(struct audio_notifier_data *andata)
+{
+	int i;
+
+	for (i = 0; i < andata->size; i++)
+		if (andata->data[i] != 0)
+			return false;
+	return true;
+}
+
+
+static int audio_notifier_notify(struct device *dev, struct audio_notifier_data *andata)
+{
+	int ret;
+	struct ion_client *client = __get_ion_client();
+
+	if (andata->size > AN_MAX_DATA_SIZE)
+		return -E2BIG;
+
+	if (audio_notifier_data_is_empty(andata)) {
+		dev_dbg(dev, "no data to send\n");
+		return 0;
+	}
+
+	ret = __send_rpc(client, andata->info, andata->data, andata->size);
+	if (ret) {
+		dev_err(dev, "failed to notify ACPU: %d\n", ret);
+		return ret;
+	}
+
+	return 0;
+}
+
+/* second compatible of ai devices */
+static const struct of_device_id rtk_ai_matches[] = {
+	{.compatible = "alc5279",   .data = (void *)ENUM_DT_AI_ADC},
+	{.compatible = "wm8782",    .data = (void *)ENUM_DT_AI_ADC},
+	{.compatible = "adc",       .data = (void *)ENUM_DT_AI_ADC},
+	{.compatible = "analog-in", .data = (void *)ENUM_DT_AI_ANALOG_IN},
+	{.compatible = "adc-amic",  .data = (void *)ENUM_DT_AI_ADC_AMIC},
+	{}
+};
+
+static int rtk_audio_notifier_ai_init(struct device *dev)
+{
+	struct device_node *np = dev->of_node;
+	unsigned int val;
+	const struct of_device_id *match;
+	struct audio_notifier_data *andata;
+
+	andata = devm_kzalloc(dev, sizeof(*andata), GFP_KERNEL);
+	if (!andata)
+		return -ENOMEM;
+
+	andata->info = ENUM_PRIVATEINFO_AIO_AI_INTERFACE_SWITCH_CONTROL;
+	andata->data[AN_AI_DEVICE_ON] = BIT(ENUM_DT_AI_AIN);
+	andata->size = 2;
+
+	match = of_match_node(rtk_ai_matches, np);
+	if (!match)
+		return -EINVAL;
+	val = (unsigned long)(match->data);
+
+	dev_info(dev, "device_type=%s(%d)\n", ai_names[val], val);
+	andata->data[AN_AI_DEVICE_ON] |= BIT(val);
+
+	if (of_property_match_string(np, "ai,type", "i2s") >= 0) {
+		u32 conf = BIT(ENUM_AI_I2S_STATUS);
+
+		if (of_find_property(np, "ai,i2s-pin-shared", NULL))
+			conf |=	BIT(ENUM_AI_I2S_PIN_SHARE_BIT);
+		if (of_find_property(np, "ai,i2s-master", NULL))
+			conf |=	BIT(ENUM_AI_I2S_AI_MASTER_BIT);
+
+		dev_info(dev, "i2s mode=%s, pin=%s\n",
+			(conf & BIT(ENUM_AI_I2S_AI_MASTER_BIT)) ? "master" : "slave",
+			(conf & BIT(ENUM_AI_I2S_PIN_SHARE_BIT)) ? "shared" : "independent");
+		andata->data[AN_AI_DEVICE_I2S_CONF] = conf;
+	}
+
+	return audio_notifier_notify(dev, andata);
+}
+
+/* compatible of ao sub nodes */
+static const struct of_device_id rtk_ao_matches[] = {
+	{.compatible = "dac",    .data = (void *)ENUM_DT_AO_DAC},
+	{.compatible = "i2s",    .data = (void *)ENUM_DT_AO_I2S},
+	{.compatible = "spdif",  .data = (void *)ENUM_DT_AO_SPDIF},
+	{.compatible = "hdmi",   .data = (void *)ENUM_DT_AO_HDMI},
+	{.compatible = "global", .data = (void *)ENUM_DT_AO_GLOBAL},
+	{}
+};
+
+static int rtk_audio_notifier_ao_init(struct device *dev)
+{
+	struct device_node *np = dev->of_node;
+	struct device_node *child;
+	unsigned int mask = BIT(ENUM_DT_AO_DAC) |
+		BIT(ENUM_DT_AO_SPDIF) |
+		BIT(ENUM_DT_AO_I2S) |
+		BIT(ENUM_DT_AO_HDMI) |
+		BIT(ENUM_DT_AO_GLOBAL);
+	struct audio_notifier_data *andata;
+
+	andata = devm_kzalloc(dev, sizeof(*andata), GFP_KERNEL);
+	if (!andata)
+		return -ENOMEM;
+
+	andata->info = ENUM_PRIVATEINFO_AIO_AO_INTERFACE_SWITCH_CONTROL;
+	andata->size = 3;
+
+	for_each_child_of_node(np, child) {
+		const struct of_device_id *match;
+		u32 val;
+
+		match = of_match_node(rtk_ao_matches, child);
+		if (!match)
+			continue;
+
+		if (!of_device_is_available(child))
+			continue;
+
+		/* parse config for ao-i2s */
+		if (!strcmp(match->compatible, "i2s")) {
+			int val = 0;
+			int ch = AN_AO_SET_I2S_2_CHANNEL;
+			int mo = AN_AO_SET_I2S_MODE_MASTER;
+
+			/* i2s channgel */
+			if (of_property_read_u32(child, "channel", &val))
+				val = 0;
+			if (val == 8)
+				ch = AN_AO_SET_I2S_8_CHANNEL;
+
+			/* i2s mode */
+			if (of_find_property(child, "slave-mode", NULL))
+				mo = AN_AO_SET_I2S_MODE_SLAVE;
+
+			dev_info(dev, "i2s: mode=%s, channel=%d\n",
+				mo ? "slave" : "master", ch ? 8 : 2);
+			andata->data[AN_AO_SET_I2S_CHANNEL] = ch;
+			andata->data[AN_AO_SET_I2S_MODE]    = mo;
+		}
+
+		val = (u64)(uintptr_t)(match->data);
+		mask &= ~BIT(val);
+		dev_dbg(dev, "update mask to 0x%08x from dt node %s\n", mask,
+			child->name);
+	}
+
+	andata->data[AN_AO_SET_DEVICE_OFF] = mask;
+	if (mask & BIT(ENUM_DT_AO_DAC))
+		dev_info(dev, "disabling adc\n");
+	if (mask & BIT(ENUM_DT_AO_SPDIF))
+		dev_info(dev, "disabling spdif\n");
+	if (mask & BIT(ENUM_DT_AO_I2S))
+		dev_info(dev, "disabling i2s\n");
+	if (mask & BIT(ENUM_DT_AO_HDMI))
+		dev_info(dev, "disabling hdmi\n");
+	if (mask & BIT(ENUM_DT_AO_GLOBAL))
+		dev_info(dev, "disabling global\n");
+	return audio_notifier_notify(dev, andata);
+}
+
+static int rtk_audio_simple_init(struct device *dev)
+{
+	return 0;
+}
+
+static const struct of_device_id rtk_audio_dev_ids[] = {
+	{
+		.compatible = "realtek,audio-in",
+		.data = rtk_audio_notifier_ai_init,
+	},
+	{
+		.compatible = "realtek,audio-out",
+		.data = rtk_audio_notifier_ao_init,
+	},
+	{
+		.compatible = "realtek,audio",
+		.data = rtk_audio_simple_init,
+	},
+	{}
+};
+
+static void rtk_audio_notifier_of_get_gpios(struct device *dev)
+{
+	struct device_node *np = dev->of_node;
+	int num;
+	int i;
+
+	num = of_gpio_count(np);
+	for (i = 0; i < num; i++) {
+		int gpio = of_get_gpio(np, i);
+
+		if (gpio < 0) {
+			dev_err(dev, "failed to get gpio[%d]\n", i);
+			continue;
+		}
+
+		if (!gpio_is_valid(gpio)) {
+			dev_err(dev, "invalid gpio num %d\n", gpio);
+			continue;
+		}
+
+		if (gpio_request(gpio, dev_name(dev))) {
+			dev_err(dev, "failed to request gpio %d\n", gpio);
+			continue;
+		}
+
+		dev_info(dev, "request gpio%d\n", gpio);
+	}
+}
+
+static int rtk_audio_notifier_setup_pll(struct device *dev)
+{
+	struct device_node *np = dev->of_node;
+	struct clk *ddsa;
+	struct clk *psaud1a;
+	struct clk *psaud2a;
+	int ret;
+
+	if (!of_find_property(np, "clocks", NULL))
+		return 0;
+
+	ddsa = clk_get(dev, "ddsa");
+	if (IS_ERR(ddsa)) {
+		ret = PTR_ERR(ddsa);
+		dev_warn(dev, "failed to get clk ddsa, %d\n", ret);
+		ddsa = NULL;
+	}
+	psaud1a = clk_get(dev, "psaud1a");
+	if (IS_ERR(psaud1a)) {
+		ret = PTR_ERR(psaud1a);
+		dev_warn(dev, "failed to get clk psaud1a, %d\n", ret);
+		psaud1a = NULL;
+	}
+	psaud2a = clk_get(dev, "psaud2a");
+	if (IS_ERR(psaud2a)) {
+		ret = PTR_ERR(psaud2a);
+		dev_warn(dev, "failed to get clk psaud2a, %d\n", ret);
+		psaud2a = NULL;
+	}
+
+	clk_prepare_enable(ddsa);
+	clk_set_rate(ddsa, 432000000);
+	clk_prepare_enable(psaud1a);
+	clk_set_rate(psaud1a, 49152000);
+	clk_prepare_enable(psaud2a);
+	clk_set_rate(psaud1a, 45158400);
+	return 0;
+}
+
+static int rtk_audio_notifier_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	const struct of_device_id *match;
+	int (*init_func)(struct device *dev);
+
+	dev_info(&pdev->dev, "%s\n", __func__);
+
+	match = of_match_node(rtk_audio_dev_ids, dev->of_node);
+	if (!match)
+		return -EFAULT;
+
+	rtk_audio_notifier_setup_pll(dev);
+	rtk_audio_notifier_of_get_gpios(dev);
+
+	init_func = match->data;
+	return init_func ? init_func(dev) : -EINVAL;
+}
+
+static struct platform_driver rtk_audio_notifier_drv = {
+	.driver = {
+		.name   = "audio-notifier",
+		.of_match_table = rtk_audio_dev_ids,
+	},
+	.probe = rtk_audio_notifier_probe,
+};
+
+static int __init rtk_audio_notifier_init(void)
+{
+	return platform_driver_register(&rtk_audio_notifier_drv);
+}
+late_initcall(rtk_audio_notifier_init);
diff --git a/sound/arm/snd-realtek.c b/sound/arm/snd-realtek.c
new file mode 100644
index 00000000..573bd2e
--- /dev/null
+++ b/sound/arm/snd-realtek.c
@@ -0,0 +1,4803 @@
+/**
+ * snd-realtek.c - Realtek alsa driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/jiffies.h>
+#include <linux/slab.h>
+#include <linux/time.h>
+#include <linux/wait.h>
+#include <linux/moduleparam.h>
+#include <linux/delay.h>
+#include <linux/platform_device.h>
+#include <linux/hrtimer.h>
+#include <linux/mutex.h>
+#include <linux/ioctl.h> /* needed for the _IOW etc stuff used later */
+#include <linux/syscalls.h> /* needed for the _IOW etc stuff used later */
+#include <linux/mpage.h>
+#include <linux/dcache.h>
+#include <linux/timer.h>
+#include <linux/workqueue.h>
+#include <linux/math64.h>
+#include <linux/dma-mapping.h>
+#include <linux/suspend.h>
+#include <sound/asound.h>
+#include <sound/core.h>
+#include <sound/control.h>
+#include <sound/pcm.h>
+#include <sound/rawmidi.h>
+#include <sound/initval.h>
+#include <asm/cacheflush.h>
+#include "snd-realtek.h"
+#include <rtk_rpc.h>
+#include "snd-realtek-compress.h"
+
+#ifdef CONFIG_RTK_XEN_SUPPORT
+#include <xen/xen.h>
+#endif
+
+#ifdef RTK_TRACE_ALSA_EN
+#define RTK_TRACE_ALSA(format, ...) printk(KERN_ALERT format, ##__VA_ARGS__);
+#else
+#define RTK_TRACE_ALSA(format, ...)
+#endif
+
+#define MIS_CLK90K_TM_LO_reg            0x9801B540
+#define MIS_CLK90K_TM_HI_reg            0x9801B544
+#define SYS_CLOCK_ENABLE2               0x98000010
+
+#define ENDIAN_CHANGE(x) ((((x)&0xff000000)>>24)|(((x)&0x00ff0000)>>8)|(((x)&0x0000ff00)<<8)|(((x)&0x000000ff)<<24))
+#define SHARE_MEM_SIZE 8
+#define SHARE_MEM_SIZE_LATENCY sizeof(ALSA_LATENCY_INFO)
+#define LPCM_2CH_16BITS (4)
+
+#define SND_REALTEK_DRIVER "snd_alsa_rtk"
+#define SND_REALTEK_DRIVER_I2S_IN "snd_alsa_rtk_i2s_in"
+#define SND_REALTEK_DRIVER_NONPCM_IN "snd_alsa_rtk_nonpcm_in"
+#define SND_REALTEK_DRIVER_AUDIO_IN "snd_alsa_rtk_audio_in"
+#define SND_REALTEK_DRIVER_AUDIO_V2_IN "snd_alsa_rtk_audio_v2_in"
+#define SND_REALTEK_DRIVER_AUDIO_V3_IN "snd_alsa_rtk_audio_v3_in"
+#define SND_REALTEK_DRIVER_AUDIO_V4_IN "snd_alsa_rtk_audio_v4_in"
+
+#ifndef MIN
+#define MIN(a, b) ((a) <= (b) ? (a) : (b))
+#endif
+
+static int snd_card_playback_open(snd_pcm_substream_t * substream);
+static int snd_card_playback_close(snd_pcm_substream_t * substream);
+static int snd_card_playback_ioctl(struct snd_pcm_substream *substream,  unsigned int cmd, void *arg);
+static int snd_card_hw_params(snd_pcm_substream_t * substream, snd_pcm_hw_params_t * hw_params);
+static int snd_card_hw_free(snd_pcm_substream_t * substream);
+static int snd_card_playback_prepare(snd_pcm_substream_t * substream);
+static int snd_card_playback_trigger(snd_pcm_substream_t * substream, int cmd);
+static snd_pcm_uframes_t snd_card_playback_pointer(snd_pcm_substream_t * substream);
+
+static int snd_card_capture_open(snd_pcm_substream_t * substream);
+static int snd_card_capture_i2s_open(snd_pcm_substream_t * substream);
+static int snd_card_capture_nonpcm_open(snd_pcm_substream_t * substream);
+static int snd_card_capture_audio_open(snd_pcm_substream_t * substream);
+static int snd_card_capture_audio_v2_open(snd_pcm_substream_t * substream);
+static int snd_card_capture_audio_v3_open(snd_pcm_substream_t * substream);
+static int snd_card_capture_audio_v4_open(snd_pcm_substream_t * substream);
+static int snd_card_capture_close(snd_pcm_substream_t * substream);
+static int snd_card_capture_close_audio(snd_pcm_substream_t * substream);
+static int snd_card_capture_ioctl(struct snd_pcm_substream *substream,  unsigned int cmd, void *arg);
+static int snd_card_capture_prepare(snd_pcm_substream_t * substream);
+static int snd_card_capture_trigger(snd_pcm_substream_t * substream, int cmd);
+static int snd_card_capture_hw_free(snd_pcm_substream_t * substream);
+static snd_pcm_uframes_t snd_card_capture_pointer(snd_pcm_substream_t * substream);
+static unsigned int snd_capture_monitor_delay(struct snd_pcm_substream *substream);
+int snd_card_capture_get_time_info(struct snd_pcm_substream *substream,
+			struct timespec *system_ts, struct timespec *audio_ts,
+			struct snd_pcm_audio_tstamp_config *audio_tstamp_config,
+			struct snd_pcm_audio_tstamp_report *audio_tstamp_report);
+static int snd_realtek_hw_capture_malloc_pts_ring(snd_pcm_runtime_t *runtime);
+static int snd_realtek_hw_capture_init_PTS_ringheader_of_AI(snd_pcm_runtime_t *runtime);
+static void snd_card_capture_setup_pts(snd_pcm_runtime_t *runtime, AUDIO_DEC_PTS_INFO *pPkt);
+int snd_realtek_capture_check_hdmirx_enable(void);
+char *snd_realtek_capture_get_stream_name(void);
+static void snd_card_capture_handle_HDMI_plug_out(snd_pcm_substream_t * substream);
+
+
+static enum hrtimer_restart snd_card_timer_function(struct hrtimer *timer);
+static enum hrtimer_restart snd_card_capture_lpcm_timer_function(struct hrtimer *timer);
+static void snd_card_capture_timer_function(unsigned long data);
+static void snd_card_capture_calculate_pts(snd_pcm_runtime_t *runtime, long nPeriodCount);
+
+static unsigned long valid_free_size(unsigned long base, unsigned long limit, unsigned long rp, unsigned long wp);
+static unsigned long ring_add(unsigned long ring_base, unsigned long ring_limit, unsigned long ptr, unsigned int bytes);
+static unsigned long ring_valid_data(unsigned long ring_base, unsigned long ring_limit, unsigned long ring_rp, unsigned long ring_wp);
+static unsigned long buf_memcpy2_ring(unsigned long base, unsigned long limit, unsigned long ptr, char* buf, unsigned long size);
+static int ring_check_ptr_valid_32(unsigned int ring_rp, unsigned int ring_wp, unsigned int ptr);
+static long ring_memcpy2_buf(char* buf,unsigned long base, unsigned long limit, unsigned long ptr, unsigned int size);
+static unsigned long ring_minus(unsigned long ring_base, unsigned long ring_limit, unsigned long ptr, int bytes);
+
+static int snd_realtek_hw_free_ring (snd_pcm_runtime_t *runtime);
+static int snd_RTK_volume_info(snd_kcontrol_t * kcontrol, snd_ctl_elem_info_t * uinfo);
+static int snd_RTK_volume_get(snd_kcontrol_t * kcontrol, snd_ctl_elem_value_t * ucontrol);
+static int snd_RTK_volume_put(snd_kcontrol_t * kcontrol, snd_ctl_elem_value_t * ucontrol);
+static int snd_RTK_capsrc_info(snd_kcontrol_t * kcontrol, snd_ctl_elem_info_t * uinfo);
+static int snd_RTK_capsrc_get(snd_kcontrol_t * kcontrol, snd_ctl_elem_value_t * ucontrol);
+static int snd_RTK_capsrc_put(snd_kcontrol_t * kcontrol, snd_ctl_elem_value_t * ucontrol);
+
+static int snd_realtek_hw_capture_free_ring(snd_pcm_runtime_t *runtime);
+static long snd_card_get_ring_data(RINGBUFFER_HEADER *pRing_BE, RINGBUFFER_HEADER *pRing_LE);
+static void ring1_to_ring2_general_64(AUDIO_RINGBUF_PTR_64* ring1, AUDIO_RINGBUF_PTR_64* ring2, long size, char* dmem_buf);
+
+/************************************************************************/
+/* GLOBAL                                                                     */
+/************************************************************************/
+static struct platform_device *devices[SNDRV_CARDS] = {NULL};
+static bool snd_card_enable[SNDRV_CARDS] = {1, [1 ... (SNDRV_CARDS - 1)] = 0};    // only one sound card
+static int pcm_substreams[SNDRV_CARDS] = {[0 ... (SNDRV_CARDS - 1)] = 2};
+static int pcm_capture_substreams[SNDRV_CARDS] = {[0 ... (SNDRV_CARDS - 1)] = 1};
+static snd_card_t *snd_RTK_cards[SNDRV_CARDS] = SNDRV_DEFAULT_PTR;
+static int snd_open_count = 0;
+static int snd_open_ai_count = 0;
+static char *snd_pcm_id[] = {SND_REALTEK_DRIVER, SND_REALTEK_DRIVER_I2S_IN, SND_REALTEK_DRIVER_NONPCM_IN,
+								SND_REALTEK_DRIVER_AUDIO_IN, SND_REALTEK_DRIVER_AUDIO_V2_IN,
+								SND_REALTEK_DRIVER_AUDIO_V3_IN, SND_REALTEK_DRIVER_AUDIO_V4_IN}; // multiple PCM instances in 1 sound card
+static unsigned int rtk_dec_ao_buffer = RTK_DEC_AO_BUFFER_SIZE;
+static void __iomem *clk90k_vaddr_hi = NULL;
+static void __iomem *clk90k_vaddr_lo = NULL;
+static void __iomem *sys_clk_en2_virt = NULL;
+
+static spinlock_t playback_lock;
+static spinlock_t capture_lock;
+static int dec_out_msec = 0;
+static int mtotal_latency = 0;
+static int *g_ShareMemPtr = NULL;
+static ALSA_LATENCY_INFO *g_ShareMemPtr2 = NULL;
+static ALSA_LATENCY_INFO *g_ShareMemPtr3 = NULL;
+
+static bool is_suspend = false;
+
+#ifdef USE_ION_AUDIO_HEAP
+struct ion_client *alsa_client;
+static struct ion_handle *alsa_playback_handle = NULL;
+static struct ion_handle *dec_out_handle[8] = {NULL};
+static struct ion_handle *sharemem_handle = NULL;
+static struct ion_handle *sharemem_handle2 = NULL;
+static struct ion_handle *sharemem_handle3 = NULL;
+static struct ion_handle *alsa_capture_handle = NULL;
+static struct ion_handle *enc_in_handle[2] = {NULL};
+static struct ion_handle *enc_lpcm_handle = NULL;
+static struct ion_handle *enc_pts_handle = NULL;
+static char gRtkDriverName[] = SND_REALTEK_DRIVER;
+
+static ion_phys_addr_t g_ShareMemPtr_dat = 0;
+static ion_phys_addr_t g_ShareMemPtr_dat2 = 0;
+static ion_phys_addr_t g_ShareMemPtr_dat3 = 0;
+#else
+static dma_addr_t g_ShareMemPtr_dat;
+static dma_addr_t g_ShareMemPtr_dat2;
+static dma_addr_t g_ShareMemPtr_dat3;
+#endif
+
+static snd_kcontrol_new_t snd_mars_controls[] = {
+MARS_VOLUME("Master Volume", 0, MIXER_ADDR_MASTER),
+MARS_CAPSRC("Master Capture Switch", 0, MIXER_ADDR_MASTER),
+MARS_VOLUME("Synth Volume", 0, MIXER_ADDR_SYNTH),
+//MARS_CAPSRC("Synth Capture Switch", 0, MIXER_ADDR_MASTER),
+//MARS_VOLUME("Line Volume", 0, MIXER_ADDR_LINE),
+//MARS_CAPSRC("Line Capture Switch", 0, MIXER_ADDR_MASTER),
+//MARS_VOLUME("Mic Volume", 0, MIXER_ADDR_MIC),
+//MARS_CAPSRC("Mic Capture Switch", 0, MIXER_ADDR_MASTER),
+//MARS_VOLUME("CD Volume", 0, MIXER_ADDR_CD),
+//MARS_CAPSRC("CD Capture Switch", 0, MIXER_ADDR_MASTER)
+};
+
+static snd_pcm_ops_t snd_card_rtk_playback_ops = {
+	.open =         snd_card_playback_open,
+	.close =        snd_card_playback_close,
+	.ioctl =        snd_card_playback_ioctl,
+	.hw_params =    snd_card_hw_params,
+	.hw_free =      snd_card_hw_free,
+	.prepare =      snd_card_playback_prepare,
+	.trigger =      snd_card_playback_trigger,
+	.pointer =      snd_card_playback_pointer,
+	.copy =         NULL,
+	.silence =      NULL,
+};
+
+// for HDMI-RX in
+static snd_pcm_ops_t snd_card_rtk_capture_ops = {
+	.open =         snd_card_capture_open,
+	.close =        snd_card_capture_close,
+	.ioctl =        snd_card_capture_ioctl,
+	.hw_params =    snd_card_hw_params,
+	.hw_free =      snd_card_capture_hw_free,
+	.prepare =      snd_card_capture_prepare,
+	.trigger =      snd_card_capture_trigger,
+	.pointer =      snd_card_capture_pointer,
+	.copy =         NULL,
+	.silence =      NULL,
+	.get_time_info = snd_card_capture_get_time_info
+};
+
+// for I2S in
+static snd_pcm_ops_t snd_card_rtk_capture_i2s_ops = {
+	.open =         snd_card_capture_i2s_open,
+	.close =        snd_card_capture_close,
+	.ioctl =        snd_card_capture_ioctl,
+	.hw_params =    snd_card_hw_params,
+	.hw_free =      snd_card_capture_hw_free,
+	.prepare =      snd_card_capture_prepare,
+	.trigger =      snd_card_capture_trigger,
+	.pointer =      snd_card_capture_pointer,
+	.copy =         NULL,
+	.silence =      NULL,
+	.get_time_info = snd_card_capture_get_time_info
+};
+
+// for non-pcm-in flow in
+static snd_pcm_ops_t snd_card_rtk_capture_nonpcm_ops = {
+	.open =         snd_card_capture_nonpcm_open,
+	.close =        snd_card_capture_close,
+	.ioctl =        snd_card_capture_ioctl,
+	.hw_params =    snd_card_hw_params,
+	.hw_free =      snd_card_capture_hw_free,
+	.prepare =      snd_card_capture_prepare,
+	.trigger =      snd_card_capture_trigger,
+	.pointer =      snd_card_capture_pointer,
+	.copy =         NULL,
+	.silence =      NULL,
+	.get_time_info = snd_card_capture_get_time_info
+};
+
+// for audio processing CS demo
+static snd_pcm_ops_t snd_card_rtk_capture_audio_ops = {
+	.open =         snd_card_capture_audio_open,
+	.close =        snd_card_capture_close_audio,
+	.ioctl =        snd_card_capture_ioctl,
+	.hw_params =    snd_card_hw_params,
+	.hw_free =      snd_card_capture_hw_free,
+	.prepare =      snd_card_capture_prepare,
+	.trigger =      snd_card_capture_trigger,
+	.pointer =      snd_card_capture_pointer,
+	.copy =         NULL,
+	.silence =      NULL,
+	.get_time_info = snd_card_capture_get_time_info
+};
+
+// for audio processing v2 DMIC LOOPBACK
+static snd_pcm_ops_t snd_card_rtk_capture_audio_v2_ops = {
+	.open =         snd_card_capture_audio_v2_open,
+	.close =        snd_card_capture_close,
+	.ioctl =        snd_card_capture_ioctl,
+	.hw_params =    snd_card_hw_params,
+	.hw_free =      snd_card_capture_hw_free,
+	.prepare =      snd_card_capture_prepare,
+	.trigger =      snd_card_capture_trigger,
+	.pointer =      snd_card_capture_pointer,
+	.copy =         NULL,
+	.silence =      NULL,
+	.get_time_info = snd_card_capture_get_time_info
+};
+
+// for audio processing v3 SPEECH RECOGNITION FROM DMIC
+static snd_pcm_ops_t snd_card_rtk_capture_audio_v3_ops = {
+	.open =         snd_card_capture_audio_v3_open,
+	.close =        snd_card_capture_close,
+	.ioctl =        snd_card_capture_ioctl,
+	.hw_params =    snd_card_hw_params,
+	.hw_free =      snd_card_capture_hw_free,
+	.prepare =      snd_card_capture_prepare,
+	.trigger =      snd_card_capture_trigger,
+	.pointer =      snd_card_capture_pointer,
+	.copy =         NULL,
+	.silence =      NULL,
+	.get_time_info = snd_card_capture_get_time_info
+};
+
+// for audio processing v4 SPEECH RECOGNITION FROM I2S
+static snd_pcm_ops_t snd_card_rtk_capture_audio_v4_ops = {
+	.open =         snd_card_capture_audio_v4_open,
+	.close =        snd_card_capture_close,
+	.ioctl =        snd_card_capture_ioctl,
+	.hw_params =    snd_card_hw_params,
+	.hw_free =      snd_card_capture_hw_free,
+	.prepare =      snd_card_capture_prepare,
+	.trigger =      snd_card_capture_trigger,
+	.pointer =      snd_card_capture_pointer,
+	.copy =         NULL,
+	.silence =      NULL,
+	.get_time_info = snd_card_capture_get_time_info
+};
+
+static snd_pcm_hardware_t snd_card_playback =
+{
+	.info               = RTK_DMP_PLAYBACK_INFO,
+	.formats            = RTK_DMP_PLAYBACK_FORMATS,
+	.rates              = RTK_DMP_PLYABACK_RATES,
+	.rate_min           = RTK_DMP_PLAYBACK_RATE_MIN,
+	.rate_max           = RTK_DMP_PLAYBACK_RATE_MAX,
+	.channels_min       = RTK_DMP_PLAYBACK_CHANNELS_MIN,
+	.channels_max       = RTK_DMP_PLAYBACK_CHANNELS_MAX,
+	.buffer_bytes_max   = RTK_DMP_PLAYBACK_MAX_BUFFER_SIZE,
+	.period_bytes_min   = RTK_DMP_PLAYBACK_MIN_PERIOD_SIZE,
+	.period_bytes_max   = RTK_DMP_PLAYBACK_MAX_PERIOD_SIZE,
+	.periods_min        = RTK_DMP_PLAYBACK_PERIODS_MIN,
+	.periods_max        = RTK_DMP_PLAYBACK_PERIODS_MAX,
+	.fifo_size          = RTK_DMP_PLAYBACK_FIFO_SIZE,
+};
+
+static snd_pcm_hardware_t snd_card_mars_capture =
+{
+	.info               = RTK_DMP_CAPTURE_INFO,
+	.formats            = RTK_DMP_CAPTURE_FORMATS,
+	.rates              = RTK_DMP_CAPTURE_RATES,
+	.rate_min           = RTK_DMP_CAPTURE_RATE_MIN,
+	.rate_max           = RTK_DMP_CAPTURE_RATE_MAX,
+	.channels_min       = RTK_DMP_CAPTURE_CHANNELS_MIN,
+	.channels_max       = RTK_DMP_CAPTURE_CHANNELS_MAX,
+	.buffer_bytes_max   = RTK_DMP_CAPTURE_MAX_BUFFER_SIZE,
+	.period_bytes_min   = RTK_DMP_CAPTURE_MIN_PERIOD_SIZE,
+	.period_bytes_max   = RTK_DMP_CAPTURE_MAX_PERIOD_SIZE,
+	.periods_min        = RTK_DMP_CAPTURE_PERIODS_MIN,
+	.periods_max        = RTK_DMP_CAPTURE_PERIODS_MAX,
+	.fifo_size          = RTK_DMP_CAPTURE_FIFO_SIZE,
+};
+
+static snd_pcm_hardware_t snd_card_mars_capture_audio =
+{
+	.info                   = SNDRV_PCM_INFO_MMAP |
+							SNDRV_PCM_INFO_MMAP_VALID |
+							SNDRV_PCM_INFO_INTERLEAVED,
+	.formats                = SNDRV_PCM_FMTBIT_S16_LE,
+	.rates					= SNDRV_PCM_RATE_16000,
+	.rate_min				= 16000,
+	.rate_max 				= 16000,
+	.period_bytes_min       = 64,
+	.period_bytes_max       = 4096,
+	.periods_min            = 4,
+	.periods_max            = 1024,
+	.channels_min           = 1,
+	.channels_max           = 1,
+	.buffer_bytes_max       = 32*1024,
+};
+
+/************************************************************************/
+/* MODULE                                                               */
+/************************************************************************/
+module_param_array(snd_card_enable, bool, NULL, 0444);
+MODULE_PARM_DESC(snd_card_enable, "Enable this mars soundcard.");
+module_param_array(pcm_substreams, int, NULL, 0444);
+MODULE_PARM_DESC(pcm_substreams, "PCM substreams # (1-16) for mars driver.");
+
+/************************************************************************/
+/* FUNCTION                                                             */
+/************************************************************************/
+int snd_monitor_audio_data_queue(void)
+{
+    /*
+    int audioLatency = 0;
+    if (g_ShareMemPtr)
+    {
+        audioLatency = *g_ShareMemPtr;
+        audioLatency = ENDIAN_CHANGE(audioLatency);
+    }
+    else
+    {
+        //ALSA_WARNING("NO exist share memory !!\n");
+    }
+
+    //ALSA_VitalPrint("audiofw total latency %d (dec_out_msec %d ao_out_msec %d)\n", ret + dec_out_msec, dec_out_msec, ret);
+    audioLatency += dec_out_msec;
+    return audioLatency;
+    */
+    return mtotal_latency;
+}
+
+int snd_monitor_audio_data_queue_new(struct snd_pcm_substream *substream)
+{
+    int audioLatency = 0;
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+    if (g_ShareMemPtr2) {
+
+        uint64_t pcmPTS;
+        uint64_t curPTS;
+        uint64_t diffPTS;
+        unsigned int sum = 0;
+        unsigned int latency = 0;
+        unsigned int ptsL = 0;
+        unsigned int ptsH = 0;
+        unsigned int in_wp = 0;
+        //unsigned int in_rp = 0;
+
+        int retry = 0;
+        uint64_t inHWRingWp;
+        uint64_t outHWRingWp;
+        unsigned int wp_buffer;
+        unsigned int wp_frame;
+
+        //to get ALSA_LATENCY_INFO frmo fw
+        if (g_ShareMemPtr3) {
+            memcpy(g_ShareMemPtr3, g_ShareMemPtr2, SHARE_MEM_SIZE_LATENCY);
+
+            latency = ENDIAN_CHANGE(g_ShareMemPtr3->latency);
+            ptsL = ENDIAN_CHANGE(g_ShareMemPtr3->ptsL);
+            ptsH = ENDIAN_CHANGE(g_ShareMemPtr3->ptsH);
+            sum = ENDIAN_CHANGE(g_ShareMemPtr3->sum);
+            in_wp = ENDIAN_CHANGE(g_ShareMemPtr3->decin_wp) & 0x0fffffff;
+            //in_rp = ENDIAN_CHANGE(g_ShareMemPtr3->decin_rp) & 0x0fffffff;
+
+            // make sure all of ALSA_LATENCY_INFO are updated.
+            while (sum != (latency + ptsL)) {
+                if (retry > 100) {
+                    if (ptsL < sum) {
+                        latency = sum - ptsL;
+                    }
+                    break;
+                }
+                memcpy(g_ShareMemPtr3, g_ShareMemPtr2, SHARE_MEM_SIZE_LATENCY);
+                latency = ENDIAN_CHANGE(g_ShareMemPtr3->latency);
+                ptsL = ENDIAN_CHANGE(g_ShareMemPtr3->ptsL);
+                ptsH = ENDIAN_CHANGE(g_ShareMemPtr3->ptsH);
+                sum = ENDIAN_CHANGE(g_ShareMemPtr3->sum);
+                in_wp = ENDIAN_CHANGE(g_ShareMemPtr3->decin_wp) & 0x0fffffff;
+                //in_rp = ENDIAN_CHANGE(g_ShareMemPtr3->decin_rp) & 0x0fffffff;
+                retry++;
+            }
+        }
+        //printk("alsa pcm latency %u, ptsL %u, ptsH %u, sum %u, in_wp %u \n", latency, ptsL, ptsH, sum, in_wp);
+        inHWRingWp = (unsigned int)(ntohl(dpcm->decInRing[0].writePtr));//physical address
+        outHWRingWp = (unsigned int)(ntohl(dpcm->decOutRing[0].writePtr));//physical address
+
+        pcmPTS = (((uint64_t)ptsH<< 32) | ((uint64_t)ptsL));
+        curPTS = snd_card_get_90k_pts();
+        diffPTS = curPTS - pcmPTS;
+
+        wp_frame = 0;
+        if (in_wp != inHWRingWp) {
+            wp_buffer = ring_valid_data(dpcm->decInRing_LE[0].beginAddr
+                            ,dpcm->decInRing_LE[0].beginAddr + dpcm->decInRing_LE[0].size
+                            ,(in_wp & 0x0fffffff)
+                            ,inHWRingWp);
+            wp_frame = bytes_to_frames(runtime, wp_buffer);
+        }
+        // old audio fw only has latency without ptsL and wp
+        if (in_wp == 0 && ptsL == 0) {
+            if (g_ShareMemPtr) {
+                audioLatency = *g_ShareMemPtr;
+                audioLatency = ENDIAN_CHANGE(audioLatency);
+                audioLatency += dec_out_msec;
+            }
+        } else {
+            unsigned long queuebuffer = (wp_frame + (runtime->control->appl_ptr - dpcm->nTotalWrite))*1000000 / runtime->rate; 
+            audioLatency = latency + queuebuffer - div64_ul(diffPTS * 1000,90);
+            audioLatency = audioLatency / 1000;
+        }
+
+        if (audioLatency < 0) {
+            audioLatency = 0;
+        }
+    } else if (g_ShareMemPtr) {
+        audioLatency = *g_ShareMemPtr;
+        audioLatency = ENDIAN_CHANGE(audioLatency);
+        audioLatency += dec_out_msec;
+    } else {
+        ALSA_WARNING("NO exist share memory !!\n");
+    }
+
+    mtotal_latency = audioLatency;
+
+    return audioLatency;
+}
+
+int snd_realtek_capture_check_hdmirx_enable(void)
+{
+#define HDMI_RX_CLK_BIT 24
+    int ret = 0;
+    if(sys_clk_en2_virt)
+    {
+        ret = (int)readl(sys_clk_en2_virt);
+        ret = (ret>> HDMI_RX_CLK_BIT) & 0x1;
+    }
+    return ret;
+}
+
+char *snd_realtek_capture_get_stream_name(void)
+{
+    return gRtkDriverName;
+}
+
+static int snd_realtek_hw_check_audio_ready(void) 
+{
+    wait_queue_head_t     waitQueue;        /* for blocking read */
+    int ret = 0;
+
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    // Initialize wait queue...
+    init_waitqueue_head(&waitQueue);
+
+    ret = wait_event_interruptible_timeout(waitQueue, RPC_TOAGENT_CHECK_AUDIO_READY() == 0, HZ);
+
+    if ( ret <= 0 )
+        return 1;   // fail
+    else 
+        return 0;   // success
+}
+
+static int snd_realtek_hw_capture_init_ringheader_of_AI(snd_pcm_runtime_t *runtime)
+{
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    RINGBUFFER_HEADER *pAIRingHeader = dpcm->nAIRing;
+    RINGBUFFER_HEADER *pAIRingHeader_LE = dpcm->nAIRing_LE;
+    AUDIO_RPC_RINGBUFFER_HEADER nRingHeader;
+    int ch;
+
+    // init ring header
+    for(ch = 0; ch < runtime->channels; ++ch)
+    {
+        //pAIRingHeader_LE[ch].beginAddr = (unsigned long)dpcm->pAIRingData[ch];
+        pAIRingHeader_LE[ch].beginAddr = (unsigned long)dpcm->phy_pAIRingData[ch];
+        pAIRingHeader_LE[ch].size = dpcm->nRingSize;
+        pAIRingHeader_LE[ch].readPtr[0] = pAIRingHeader_LE[ch].beginAddr;
+        pAIRingHeader_LE[ch].writePtr = pAIRingHeader_LE[ch].beginAddr;
+        pAIRingHeader_LE[ch].numOfReadPtr = 1;
+
+        pAIRingHeader[ch].beginAddr = htonl((unsigned long)pAIRingHeader_LE[ch].beginAddr);
+        pAIRingHeader[ch].size = htonl(pAIRingHeader_LE[ch].size);
+        pAIRingHeader[ch].readPtr[0] = htonl(pAIRingHeader_LE[ch].readPtr[0]);
+        pAIRingHeader[ch].writePtr = htonl(pAIRingHeader_LE[ch].writePtr);
+        pAIRingHeader[ch].numOfReadPtr = htonl(pAIRingHeader_LE[ch].numOfReadPtr);
+
+        //nRingHeader.pRingBufferHeaderList[ch] = (unsigned int) (pAIRingHeader + ch);
+        nRingHeader.pRingBufferHeaderList[ch] = (unsigned long) (pAIRingHeader + ch) - (unsigned long)dpcm + dpcm->phy_addr;
+
+        //ALSA_VitalPrint("[ALSA ringHeader %x %x]\n", ch, nRingHeader.pRingBufferHeaderList[ch]);
+        ALSA_DbgPrint("[ALSA %d ring %x %x %x %x]\n", ch, (unsigned int)pAIRingHeader_LE[ch].beginAddr
+            , (unsigned int)pAIRingHeader_LE[ch].size, (unsigned int)pAIRingHeader_LE[ch].readPtr[0]
+            , (unsigned int)pAIRingHeader_LE[ch].writePtr);
+    }
+
+    // init AI ring header
+    nRingHeader.instanceID = dpcm->AIAgentID;
+    nRingHeader.pinID = PCM_OUT;
+    nRingHeader.readIdx = -1;
+    nRingHeader.listSize =  runtime->channels;
+
+    // RPC set AI ring header
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&nRingHeader, nRingHeader.listSize) < 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    };
+
+    return 0;
+}
+
+static int snd_realtek_hw_capture_destroy_LPCM_ringheader_of_Audio(snd_pcm_runtime_t *runtime)
+{
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+	RINGBUFFER_HEADER *pAIRingHeader = &dpcm->nLPCMRing;
+	RINGBUFFER_HEADER *pAIRingHeader_LE = &dpcm->nLPCMRing_LE;
+	AUDIO_RPC_RINGBUFFER_HEADER nRingHeader;
+
+	// init ring header
+	pAIRingHeader_LE->beginAddr = (unsigned int)dpcm->phy_pLPCMData;
+	pAIRingHeader_LE->size = dpcm->nLPCMRingSize;
+	pAIRingHeader_LE->readPtr[0] = pAIRingHeader_LE->beginAddr;
+	pAIRingHeader_LE->writePtr = pAIRingHeader_LE->beginAddr;
+	pAIRingHeader_LE->numOfReadPtr = 1;
+
+	pAIRingHeader->beginAddr = htonl((unsigned int)pAIRingHeader_LE->beginAddr);
+	pAIRingHeader->size = htonl(pAIRingHeader_LE->size);
+	pAIRingHeader->readPtr[0] = htonl(pAIRingHeader_LE->readPtr[0]);
+	pAIRingHeader->writePtr = htonl(pAIRingHeader_LE->writePtr);
+	pAIRingHeader->numOfReadPtr = htonl(pAIRingHeader_LE->numOfReadPtr);
+
+	nRingHeader.pRingBufferHeaderList[0] = (int)((unsigned long) pAIRingHeader - (unsigned long)dpcm + dpcm->phy_addr);
+
+	// init AI ring header
+	nRingHeader.instanceID = dpcm->AIAgentID;
+	nRingHeader.readIdx = -1;
+	nRingHeader.listSize = 0;
+
+	if(dpcm->source_in == ENUM_AIN_AUDIO)
+		nRingHeader.pinID = APP_LPCM_OUT;
+	else
+		nRingHeader.pinID = BASE_BS_OUT;
+
+	// RPC set AI ring header
+	if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&nRingHeader, nRingHeader.listSize) < 0) {
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -1;
+	};
+
+	return 0;
+}
+
+static int snd_realtek_hw_capture_init_LPCM_ringheader_of_AI(snd_pcm_runtime_t *runtime)
+{
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+	RINGBUFFER_HEADER *pAIRingHeader = &dpcm->nLPCMRing;
+	RINGBUFFER_HEADER *pAIRingHeader_LE = &dpcm->nLPCMRing_LE;
+	AUDIO_RPC_RINGBUFFER_HEADER nRingHeader;
+
+	// init ring header
+	pAIRingHeader_LE->beginAddr = (unsigned int)dpcm->phy_pLPCMData;
+	pAIRingHeader_LE->size = dpcm->nLPCMRingSize;
+	pAIRingHeader_LE->readPtr[0] = pAIRingHeader_LE->beginAddr;
+	pAIRingHeader_LE->writePtr = pAIRingHeader_LE->beginAddr;
+	pAIRingHeader_LE->numOfReadPtr = 1;
+
+	pAIRingHeader->beginAddr = htonl((unsigned int)pAIRingHeader_LE->beginAddr);
+	pAIRingHeader->size = htonl(pAIRingHeader_LE->size);
+	pAIRingHeader->readPtr[0] = htonl(pAIRingHeader_LE->readPtr[0]);
+	pAIRingHeader->writePtr = htonl(pAIRingHeader_LE->writePtr);
+	pAIRingHeader->numOfReadPtr = htonl(pAIRingHeader_LE->numOfReadPtr);
+
+	nRingHeader.pRingBufferHeaderList[0] = (int)((unsigned long) pAIRingHeader - (unsigned long)dpcm + dpcm->phy_addr);
+
+	// init AI ring header
+	nRingHeader.instanceID = dpcm->AIAgentID;
+	nRingHeader.readIdx = -1;
+	nRingHeader.listSize = 1;
+
+	if(dpcm->source_in == ENUM_AIN_AUDIO)
+		nRingHeader.pinID = APP_LPCM_OUT;
+	else
+		nRingHeader.pinID = BASE_BS_OUT;
+
+	// RPC set AI ring header
+	if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&nRingHeader, nRingHeader.listSize) < 0) {
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -1;
+	};
+
+	return 0;
+}
+
+static int snd_realtek_hw_capture_init_PTS_ringheader_of_AI(snd_pcm_runtime_t *runtime)
+{
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    RINGBUFFER_HEADER *pAIRingHeader = &dpcm->nPTSRingHdr;
+    RINGBUFFER_HEADER *pAIRingHeader_LE, nAIRingHeader_LE;
+    AUDIO_RPC_RINGBUFFER_HEADER nRingHeader;
+    pAIRingHeader_LE = &nAIRingHeader_LE;
+
+    dpcm->nPTSRing.base = (unsigned long)dpcm->nPTSMem.pVirt;
+    dpcm->nPTSRing.wp = dpcm->nPTSRing.rp = dpcm->nPTSRing.base;
+    dpcm->nPTSRing.limit = dpcm->nPTSRing.base + dpcm->nPTSMem.size;
+
+    // init ring header
+    pAIRingHeader_LE->beginAddr = (unsigned int)dpcm->nPTSMem.pPhy;
+    pAIRingHeader_LE->size = dpcm->nPTSMem.size;
+    pAIRingHeader_LE->readPtr[0] = pAIRingHeader_LE->beginAddr;
+    pAIRingHeader_LE->writePtr = pAIRingHeader_LE->beginAddr;
+    pAIRingHeader_LE->numOfReadPtr = 1;
+
+    pAIRingHeader->beginAddr = htonl((unsigned int)pAIRingHeader_LE->beginAddr);
+    pAIRingHeader->size = htonl(pAIRingHeader_LE->size);
+    pAIRingHeader->readPtr[0] = htonl(pAIRingHeader_LE->readPtr[0]);
+    pAIRingHeader->writePtr = htonl(pAIRingHeader_LE->writePtr);
+    pAIRingHeader->numOfReadPtr = htonl(pAIRingHeader_LE->numOfReadPtr);
+
+    nRingHeader.pRingBufferHeaderList[0] = (int)((unsigned long) pAIRingHeader - (unsigned long)dpcm + dpcm->phy_addr);
+
+    // init AI ring header
+    nRingHeader.instanceID = dpcm->AIAgentID;
+    nRingHeader.pinID = MESSAGE_QUEUE;
+    nRingHeader.readIdx = -1;
+    nRingHeader.listSize = 1;
+    
+    // RPC set AI ring header
+    //if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&nRingHeader, runtime->channels) < 0) {
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&nRingHeader, nRingHeader.listSize) < 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    };
+
+    return 0;
+}
+
+
+// init ringheader of decoder_outring and AO_inring
+static int snd_realtek_hw_init_ringheader_of_DEC_AO(snd_pcm_runtime_t *runtime)
+{
+    //ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+    RINGBUFFER_HEADER *pAORingHeader = dpcm->decOutRing;
+    AUDIO_RPC_RINGBUFFER_HEADER nRingHeader;
+    int ch, j;
+
+    // init ring header
+    //for(ch = 0 ; ch < 8 ; ++ch)
+    for (ch = 0 ; ch < runtime->channels ; ++ch) {
+        //pAORingHeader[ch].beginAddr = htonl((unsigned long)dpcm->decOutData[ch]);
+        pAORingHeader[ch].beginAddr = (unsigned int)htonl(dpcm->phy_decOutData[ch]);
+        pAORingHeader[ch].size = htonl(dpcm->nRingSize);
+        for (j = 0 ; j < 4 ; ++j)
+            pAORingHeader[ch].readPtr[j] = pAORingHeader[ch].beginAddr;
+        pAORingHeader[ch].writePtr = pAORingHeader[ch].beginAddr;
+        pAORingHeader[ch].numOfReadPtr = htonl(1);
+    }
+
+    // init DEC outring header
+    nRingHeader.instanceID = dpcm->DECAgentID;
+    nRingHeader.pinID = PCM_OUT;
+    //nRingHeader.pRingBufferHeaderList[0] = (unsigned int) &dpcm->decOutRing[0];
+    //nRingHeader.pRingBufferHeaderList[1] = (unsigned int) &dpcm->decOutRing[1];
+    for (ch = 0 ; ch < runtime->channels ; ++ch)
+        nRingHeader.pRingBufferHeaderList[ch] = (unsigned long)&dpcm->decOutRing[ch] - (unsigned long)dpcm + dpcm->phy_addr;
+    nRingHeader.readIdx = -1;
+    nRingHeader.listSize = runtime->channels;
+
+    // RPC set DEC outring header
+    //if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&nRingHeader, runtime->channels) < 0) {
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&nRingHeader, nRingHeader.listSize) < 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    };
+
+    // init AO inring header
+    nRingHeader.instanceID = dpcm->AOAgentID;
+    nRingHeader.pinID = dpcm->AOpinID;
+    //nRingHeader.pRingBufferHeaderList[0] = (unsigned int) &dpcm->decOutRing[0];
+    //nRingHeader.pRingBufferHeaderList[1] = (unsigned int) &dpcm->decOutRing[1];
+    for (ch = 0 ; ch < runtime->channels ; ++ch)
+        nRingHeader.pRingBufferHeaderList[ch] = (unsigned long)&dpcm->decOutRing[ch] - (unsigned long)dpcm + dpcm->phy_addr;
+    nRingHeader.readIdx = 0;
+    nRingHeader.listSize = runtime->channels;
+
+    // RPC set AO inring header
+    //if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&nRingHeader, runtime->channels) < 0) {
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&nRingHeader, nRingHeader.listSize) < 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    };
+
+    return 0;
+}
+
+// connet decoder and AO by RPC
+static int snd_realtek_hw_init_connect_decoder_ao(snd_card_RTK_pcm_t *dpcm)
+{   
+    AUDIO_RPC_CONNECTION nConnection;
+
+    nConnection.desInstanceID = dpcm->AOAgentID;            
+    nConnection.srcInstanceID = dpcm->DECAgentID;
+    nConnection.srcPinID = PCM_OUT;
+    nConnection.desPinID = dpcm->AOpinID;
+
+    if (RPC_TOAGENT_CONNECT_SVC(&nConnection)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    };
+    return 0;
+}
+
+// 1. init decoder in_ring
+// 2. init decoder inband ring
+static int snd_realtek_hw_init_decoder_ring(snd_pcm_runtime_t *runtime) {
+    //ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+    AUDIO_RPC_RINGBUFFER_HEADER ringbuf_header;
+    
+    // init HW inring header
+    //printk("dma buffer virAddr %lx\n", (unsigned long) runtime->dma_area);
+    //printk("dma buffer phyAddr %lx\n", (unsigned long) runtime->dma_addr);
+    //printk("dma buffer size         %d\n", (unsigned long) runtime->dma_bytes);
+    dpcm->decInRing[0].beginAddr = htonl((unsigned int)runtime->dma_addr);
+    dpcm->decInRing[0].bufferID = htonl(RINGBUFFER_STREAM);
+    dpcm->decInRing[0].size = htonl(frames_to_bytes(runtime, runtime->buffer_size));
+    dpcm->decInRing[0].writePtr = dpcm->decInRing[0].beginAddr; 
+    dpcm->decInRing[0].readPtr[0] = dpcm->decInRing[0].beginAddr;
+    dpcm->decInRing[0].readPtr[1] = dpcm->decInRing[0].beginAddr;
+    dpcm->decInRing[0].readPtr[2] = dpcm->decInRing[0].beginAddr;
+    dpcm->decInRing[0].readPtr[3] = dpcm->decInRing[0].beginAddr;
+    dpcm->decInRing[0].numOfReadPtr = htonl(1);
+
+    //printk("[INRING] writeAddr %x\n", htonl(dpcm->decInRing[0].writePtr));
+    // init HW inring (little endian)
+    dpcm->decInRing_LE[0].beginAddr = ((unsigned int)runtime->dma_addr);
+    dpcm->decInRing_LE[0].size = frames_to_bytes(runtime, runtime->buffer_size);
+    dpcm->decInRing_LE[0].writePtr = dpcm->decInRing_LE[0].beginAddr;
+    dpcm->decInRing_LE[0].readPtr[0] = dpcm->decInRing_LE[0].beginAddr;
+    dpcm->decInRing_LE[0].readPtr[1] = dpcm->decInRing_LE[0].beginAddr;
+    dpcm->decInRing_LE[0].readPtr[2] = dpcm->decInRing_LE[0].beginAddr;
+    dpcm->decInRing_LE[0].readPtr[3] = dpcm->decInRing_LE[0].beginAddr;
+
+    //printk("[INRING LE] writeAddr %x\n", dpcm->decInRing_LE[0].writePtr);
+    // init RPC ring header
+    ringbuf_header.instanceID = dpcm->DECAgentID;
+    ringbuf_header.pinID = BASE_BS_IN;
+    ringbuf_header.pRingBufferHeaderList[0] = (unsigned long)dpcm->decInRing - (unsigned long)dpcm + dpcm->phy_addr;
+    ringbuf_header.readIdx = 0;
+    ringbuf_header.listSize = 1;
+
+    // RPC set decoder in_ring
+    //if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&ringbuf_header, runtime->channels)) 
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&ringbuf_header, ringbuf_header.listSize)) {
+        ALSA_WARNING("[fail %s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    };
+
+    // init inband ring header
+    dpcm->decInbandRing.beginAddr = htonl((int)((unsigned long)dpcm->decInbandData - (unsigned long)dpcm + dpcm->phy_addr));
+    //TRACE_CODE("[INBAND RING] beginAddr %x\n", dpcm->decInbandRing.beginAddr);
+    dpcm->decInbandRing.size = htonl(sizeof(dpcm->decInbandData));
+    dpcm->decInbandRing.readPtr[0] = dpcm->decInbandRing.beginAddr;
+    dpcm->decInbandRing.writePtr = dpcm->decInbandRing.beginAddr;
+    dpcm->decInbandRing.numOfReadPtr = htonl(1);
+
+    // init RPC ring header
+    ringbuf_header.instanceID = dpcm->DECAgentID;
+    ringbuf_header.pinID = INBAND_QUEUE;
+    ringbuf_header.pRingBufferHeaderList[0] = (unsigned long)&dpcm->decInbandRing - (unsigned long)dpcm + dpcm->phy_addr; //physical
+    ringbuf_header.readIdx = 0;
+    ringbuf_header.listSize = 1;
+
+    //if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&ringbuf_header, runtime->channels)) 
+    if (RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&ringbuf_header, ringbuf_header.listSize)) {
+        ALSA_WARNING("[fail %s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    };
+    return 0;
+}
+
+static int snd_realtek_hw_capture_run(snd_card_RTK_capture_pcm_t *dpcm) 
+{
+    // AI pause
+    if (RPC_TOAGENT_PAUSE_SVC(dpcm->AIAgentID)) 
+    {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1; 
+    }
+
+    // AI run
+    if(RPC_TOAGENT_RUN_SVC(dpcm->AIAgentID))
+    {
+        ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    return 0;
+}
+
+static int snd_realtek_hw_resume(snd_card_RTK_pcm_t *dpcm) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    // decoder run & AO run
+    if (RPC_TOAGENT_RUN_SVC(dpcm->DECAgentID)) {
+        ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+    if (RPC_TOAGENT_RUN_SVC((dpcm->AOAgentID | dpcm->AOpinID))) {
+        ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+    return 0;
+}
+
+int writeInbandCmd(snd_card_RTK_pcm_t *dpcm, void *data, int len)
+{
+    //snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+    unsigned long base, limit, wp;
+    base = (unsigned long)dpcm->decInbandData;
+    limit = base + sizeof(dpcm->decInbandData);
+    wp = base + (unsigned long)(ntohl(dpcm->decInbandRing.writePtr) - ntohl(dpcm->decInbandRing.beginAddr));
+
+    //ALSA_VitalPrint("base %x limit %x wp %x\n", (long)base, (long)limit, (long)wp);
+    wp = buf_memcpy2_ring(base, limit, wp, (char *)data, (unsigned long)len);
+    dpcm->decInbandRing.writePtr = ntohl((int)(wp - base) + ntohl(dpcm->decInbandRing.beginAddr));
+    //TRACE_CODE("[INBAND RING] writeAddr %x\n", dpcm->decInbandRing.writePtr);
+    return len;
+}
+
+// ring is big-endian
+int snd_realtek_hw_ring_write(RINGBUFFER_HEADER* ring, void *data, int len, unsigned int offset)
+{
+    unsigned long base, limit, wp;
+
+    //Convert to virtual address
+    base = (unsigned long)(ntohl(ring->beginAddr)) + offset;
+    limit = base + ntohl(ring->size);
+    wp = (unsigned long)(ntohl(ring->writePtr)) + offset;
+    ALSA_VitalPrint("base %x limit %x wp %x \n", (unsigned int)base, (unsigned int)limit, (unsigned int)wp);
+    //TRACE_CODE("base %x limit %x wp %x \n", (long)base, (long)limit, (long)wp);
+    wp = buf_memcpy2_ring((long)base, (long)limit, (long)wp, (char *)data, (long)len);
+    ring->writePtr = htonl(wp - offset); // record physical address
+    return len;
+}
+
+/* The setting for different channel mapping. 
+   This will send rpc for AFW.
+ */
+static unsigned int snd_choose_channel_mapping(int num_channels)
+{
+	unsigned int channel_mapping_info;
+	switch (num_channels)
+	{
+		case 1:
+			channel_mapping_info = (0x1) << 6;
+			break;
+		case 2:
+			channel_mapping_info = (0x3) << 6;
+			break;
+		case 4:
+			channel_mapping_info = (0x33) << 6;
+			break;
+		case 6:
+			channel_mapping_info = (0x3F) << 6;
+			break;
+		case 8:
+			channel_mapping_info = (0x63F) << 6;
+			break;
+		default:
+			channel_mapping_info = (0x3) << 6;
+			break;
+	}
+	
+	return channel_mapping_info;
+}
+
+// AO pause
+// decoder pause
+// decoder run
+// decoder flush
+// write decoder info into inband of decoder
+static int snd_realtek_hw_init_decoder_info(snd_pcm_runtime_t *runtime) 
+{
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+    AUDIO_DEC_NEW_FORMAT cmd;
+    AUDIO_RPC_SENDIO sendio;
+
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    // AO pause
+    if (RPC_TOAGENT_PAUSE_SVC(dpcm->AOAgentID | dpcm->AOpinID)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1; 
+    }
+
+    // decoder pause
+    //if (RPC_TOAGENT_PAUSE_SVC(dpcm->DECAgentID))
+    if (RPC_TOAGENT_STOP_SVC(dpcm->DECAgentID)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    // decoder flush
+    sendio.instanceID = dpcm->DECAgentID;
+    sendio.pinID = dpcm->DECpinID;
+    if (RPC_TOAGENT_FLUSH_SVC(&sendio)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    // decoder run
+    if (RPC_TOAGENT_RUN_SVC(dpcm->DECAgentID)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    cmd.audioType = htonl(AUDIO_LPCM_DECODER_TYPE); 
+    cmd.header.type = htonl(AUDIO_DEC_INBAMD_CMD_TYPE_NEW_FORMAT);
+    cmd.header.size = htonl(sizeof(AUDIO_DEC_NEW_FORMAT));
+    cmd.privateInfo[0] = htonl(runtime->channels);
+    cmd.privateInfo[1] = htonl(runtime->sample_bits);
+    cmd.privateInfo[2] = htonl(runtime->rate);
+    cmd.privateInfo[3] = htonl(0);
+    cmd.privateInfo[4] = htonl(snd_choose_channel_mapping(runtime->channels));  // privateInfo[4]&0x3FFFC0)>>6; // bit[6:21] for wave channel mask
+    cmd.privateInfo[5] = htonl(0);
+    cmd.privateInfo[6] = htonl(0);  // (a_format->privateData[0]&0x1)<<4 : float or not
+    cmd.privateInfo[7] = htonl(0);
+
+    switch (runtime->format)
+    {
+        case SNDRV_PCM_FORMAT_S16_BE:
+        case SNDRV_PCM_FORMAT_U16_BE:
+        case SNDRV_PCM_FORMAT_S24_BE:
+        case SNDRV_PCM_FORMAT_U24_BE:
+        case SNDRV_PCM_FORMAT_S32_BE:
+        case SNDRV_PCM_FORMAT_U32_BE:
+        case SNDRV_PCM_FORMAT_S24_3BE:
+        case SNDRV_PCM_FORMAT_U24_3BE:
+        case SNDRV_PCM_FORMAT_S20_3BE:      
+        case SNDRV_PCM_FORMAT_U20_3BE:
+        case SNDRV_PCM_FORMAT_S18_3BE:
+        case SNDRV_PCM_FORMAT_U18_3BE:
+        case SNDRV_PCM_FORMAT_FLOAT_BE:
+        case SNDRV_PCM_FORMAT_FLOAT64_BE:
+        case SNDRV_PCM_FORMAT_IEC958_SUBFRAME_BE:
+            cmd.privateInfo[7]  = htonl(AUDIO_BIG_ENDIAN);
+            break;
+
+        case SNDRV_PCM_FORMAT_S8:
+        case SNDRV_PCM_FORMAT_U8:
+        case SNDRV_PCM_FORMAT_S16_LE:
+        case SNDRV_PCM_FORMAT_U16_LE:
+        case SNDRV_PCM_FORMAT_S24_LE:
+        case SNDRV_PCM_FORMAT_U24_LE:
+        case SNDRV_PCM_FORMAT_S32_LE:
+        case SNDRV_PCM_FORMAT_U32_LE:
+        case SNDRV_PCM_FORMAT_S24_3LE:
+        case SNDRV_PCM_FORMAT_U24_3LE:
+        case SNDRV_PCM_FORMAT_S20_3LE:
+        case SNDRV_PCM_FORMAT_U20_3LE:
+        case SNDRV_PCM_FORMAT_S18_3LE:
+        case SNDRV_PCM_FORMAT_U18_3LE:
+        case SNDRV_PCM_FORMAT_FLOAT_LE:
+        case SNDRV_PCM_FORMAT_FLOAT64_LE:
+        case SNDRV_PCM_FORMAT_IEC958_SUBFRAME_LE:
+        case SNDRV_PCM_FORMAT_MU_LAW:
+        case SNDRV_PCM_FORMAT_A_LAW:
+        case SNDRV_PCM_FORMAT_IMA_ADPCM:
+        case SNDRV_PCM_FORMAT_MPEG:
+        case SNDRV_PCM_FORMAT_GSM:
+        case SNDRV_PCM_FORMAT_SPECIAL:
+        default:
+            cmd.privateInfo[7]  = htonl(AUDIO_LITTLE_ENDIAN);
+            break;
+    }
+
+    cmd.wPtr = dpcm->decInRing[0].writePtr;
+    //printk("[test] dpcm->decInRing[0].beginAddr %lx\n" , cmd.wPtr); //decoder buffer ring physical address
+
+#ifdef CONFIG_64BIT
+    writeInbandCmd(dpcm, &cmd, sizeof(AUDIO_DEC_NEW_FORMAT));
+#else
+    //snd_realtek_hw_ring_write(((unsigned long)dpcm->decInbandRing - (unsigned long)dpcm + dpcm->phy_addr), &cmd, sizeof(AUDIO_DEC_NEW_FORMAT)); 
+    snd_realtek_hw_ring_write(&dpcm->decInbandRing, &cmd, sizeof(AUDIO_DEC_NEW_FORMAT), (unsigned long)dpcm - (unsigned long)dpcm->phy_addr); 
+#endif
+    //ALSA_VitalPrint("[ALSA LPCM ch %d sample_bit %d sample rate %d]\n", runtime->channels, runtime->sample_bits, runtime->rate);
+    return 0;
+}
+
+// decoder stop
+// AO pause
+// AO stop
+// decoder flush
+// destroy decoder
+static int snd_realtek_reprepare(snd_pcm_runtime_t *runtime) 
+{
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+    AUDIO_RPC_SENDIO sendio;
+	
+	// DHCKYLIN-2822 disable get_latency before destroy decoder instance
+    if (dpcm->DECAgentID) {
+        RPC_TOAGENT_PUT_SHARE_MEMORY(NULL, ENUM_PRIVATEINFO_AUDIO_GET_SHARE_MEMORY_FROM_ALSA);
+        RPC_TOAGENT_PUT_SHARE_MEMORY_LATENCY(NULL, NULL, 0, ENUM_PRIVATEINFO_AUDIO_GET_SHARE_MEMORY_FROM_ALSA);
+    }
+	
+	// decoder stop
+    if (RPC_TOAGENT_STOP_SVC(dpcm->DECAgentID)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    // AO pause
+    if (RPC_TOAGENT_PAUSE_SVC(dpcm->AOAgentID | dpcm->AOpinID)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1; 
+    }
+	
+	// AO stop
+    if (RPC_TOAGENT_STOP_SVC(dpcm->AOAgentID | dpcm->AOpinID)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1; 
+    }
+
+    // decoder flush
+    sendio.instanceID = dpcm->DECAgentID;
+    sendio.pinID = dpcm->DECpinID;
+    if (RPC_TOAGENT_FLUSH_SVC(&sendio)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+	// destroy decoder
+    if (RPC_TOAGENT_DESTROY_SVC(dpcm->DECAgentID)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+	
+	// free decoder InBand ring
+	memset(dpcm->decInbandData, 0, sizeof(unsigned int)*64);
+
+	// free ao in_ring
+	// decoder out_ring = ao in_ring
+	snd_realtek_hw_free_ring(runtime);
+
+	return 0;
+}
+
+// malloc ring buffer for AI.
+static int snd_realtek_hw_capture_malloc_ring(snd_pcm_runtime_t *runtime)
+{
+    //ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    int ch , bMallocSuccess = 1;
+#ifdef USE_ION_AUDIO_HEAP
+    ion_phys_addr_t dat;
+    size_t len;
+#endif
+    for(ch = 0 ; ch < runtime->channels ; ++ch)
+    {
+        if(dpcm->pAIRingData[ch])
+        {
+            ALSA_WARNING("[re-malloc error !!! %s %d]\n", __FUNCTION__, __LINE__);
+#ifdef USE_ION_AUDIO_HEAP
+            if(alsa_client != NULL && enc_in_handle[ch] != NULL)
+            {
+                ion_unmap_kernel(alsa_client, enc_in_handle[ch]);
+                ion_free(alsa_client, enc_in_handle[ch]);
+                enc_in_handle[ch] = NULL;
+            }
+#else
+            dma_free_coherent(NULL, RTK_ENC_AI_BUFFER_SIZE, dpcm->pAIRingData[ch], dpcm->phy_pAIRingData[ch]);
+#endif
+            dpcm->pAIRingData[ch] = NULL;
+        }
+
+#ifdef USE_ION_AUDIO_HEAP
+        //printk("%s create enc_in_handle[%d]\n", __FUNCTION__, ch);
+        enc_in_handle[ch] = ion_alloc(alsa_client, RTK_ENC_AI_BUFFER_SIZE, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+        if (IS_ERR(enc_in_handle[ch])) {
+             ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+             return bMallocSuccess;
+        }
+
+        if(ion_phys(alsa_client, enc_in_handle[ch], &dat, &len) != 0)
+        {
+            snd_realtek_hw_capture_free_ring(runtime);
+            ALSA_WARNING("[malloc ch %d fail and terminate %s %d]\n", ch, __FUNCTION__, __LINE__);
+            return bMallocSuccess;
+        }
+
+        dpcm->phy_pAIRingData[ch] = dat;
+        dpcm->pAIRingData[ch] = ion_map_kernel(alsa_client, enc_in_handle[ch]);
+        ALSA_VitalPrint("[ALSA ch %d phy %x vir %p]\n", ch, (unsigned int)dpcm->phy_pAIRingData[ch], dpcm->pAIRingData[ch]);
+#else
+        void *addr = 0;
+        addr = dma_alloc_coherent(NULL, RTK_ENC_AI_BUFFER_SIZE, &dpcm->phy_pAIRingData[ch], GFP_KERNEL);
+        if(!addr)
+        {
+            snd_realtek_hw_capture_free_ring(runtime);
+            printk("[malloc ch %d fail and terminate %s %d]\n", ch, __FUNCTION__, __LINE__);
+            return bMallocSuccess;
+        }
+        dpcm->pAIRingData[ch] = addr;
+#endif   
+        dpcm->nRingSize = RTK_ENC_AI_BUFFER_SIZE;
+    }
+
+    bMallocSuccess = 0; //Success
+    return bMallocSuccess;
+}
+
+static int snd_realtek_hw_capture_malloc_lpcm_ring(snd_pcm_runtime_t *runtime)
+{
+    //ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+
+    int bMallocSuccess = 1;
+
+#ifdef USE_ION_AUDIO_HEAP
+    ion_phys_addr_t dat;
+    size_t len;
+
+    //printk("%s create enc_lpcm_handle\n", __FUNCTION__);
+    enc_lpcm_handle = ion_alloc(alsa_client, RTK_ENC_LPCM_BUFFER_SIZE, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(enc_lpcm_handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        return bMallocSuccess;
+    }
+
+    if(ion_phys(alsa_client, enc_lpcm_handle, &dat, &len) != 0)
+    {
+        printk("[malloc fail and terminate %s %d]\n", __FUNCTION__, __LINE__);
+        return bMallocSuccess;
+    }
+
+    dpcm->phy_pLPCMData= dat;
+    dpcm->pLPCMData = ion_map_kernel(alsa_client, enc_lpcm_handle);
+    ALSA_VitalPrint("[ALSA LPCM phy %x vir %p]\n", (unsigned int)dpcm->phy_pLPCMData, dpcm->pLPCMData);
+#else
+    void *addr = 0;
+    addr = dma_alloc_coherent(NULL, RTK_ENC_LPCM_BUFFER_SIZE, &dpcm->phy_pLPCMData,  GFP_KERNEL);
+    if(!addr)
+    {
+        printk("[malloc fail and terminate %s %d]\n", __FUNCTION__, __LINE__);
+        return bMallocSuccess;
+    }
+    dpcm->pLPCMData = addr;
+#endif
+    dpcm->nLPCMRingSize = RTK_ENC_LPCM_BUFFER_SIZE;
+
+    bMallocSuccess = 0; //Success
+    return bMallocSuccess;
+}
+
+static int snd_realtek_hw_capture_malloc_pts_ring(snd_pcm_runtime_t *runtime)
+{
+    //ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+
+    int bMallocSuccess = -1;
+
+    ion_phys_addr_t dat;
+    size_t len;
+
+    //printk("%s create enc_lpcm_handle\n", __FUNCTION__);
+    dpcm->nPTSMem.size = RTK_ENC_PTS_BUFFER_SIZE;
+    enc_pts_handle = ion_alloc(alsa_client, RTK_ENC_PTS_BUFFER_SIZE, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(enc_pts_handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        return bMallocSuccess;
+    }
+
+    if(ion_phys(alsa_client, enc_pts_handle, &dat, &len) != 0)
+    {
+        printk("[malloc fail and terminate %s %d]\n", __FUNCTION__, __LINE__);
+        return bMallocSuccess;
+    }
+
+    dpcm->nPTSMem.pPhy = dat;
+    dpcm->nPTSMem.pVirt = ion_map_kernel(alsa_client, enc_pts_handle);
+    ALSA_VitalPrint("[ALSA PTS phy %x vir %p]\n"
+        , (unsigned int)dpcm->nPTSMem.pPhy, dpcm->nPTSMem.pVirt);
+
+    bMallocSuccess = 0; //Success
+    return bMallocSuccess;
+}
+
+
+// in decoder-AO path, malloc AO in_ring
+static int snd_realtek_hw_malloc_ring(snd_pcm_runtime_t *runtime)
+{
+    //ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+    int ch, bMallocSuccess = 1;
+#ifdef USE_ION_AUDIO_HEAP
+    ion_phys_addr_t dat;
+    size_t len;
+#endif
+
+    for (ch = 0 ; ch < runtime->channels ; ++ch) {
+        if (dpcm->decOutData[ch]) {
+            printk("[re-malloc error !!! %s %d]\n", __FUNCTION__, __LINE__);
+#ifdef USE_ION_AUDIO_HEAP
+            if (alsa_client != NULL && dec_out_handle[ch] != NULL) {
+                ion_unmap_kernel(alsa_client, dec_out_handle[ch]);
+                ion_free(alsa_client, dec_out_handle[ch]);
+                dec_out_handle[ch] = NULL;
+            }
+#else
+            dma_free_coherent(NULL, rtk_dec_ao_buffer, dpcm->decOutData[ch], dpcm->phy_decOutData[ch]);
+#endif
+            dpcm->decOutData[ch] = NULL;
+        }
+
+#ifdef USE_ION_AUDIO_HEAP
+        //printk("%s create dec_out_handle[%d]\n", __FUNCTION__, ch);
+        dec_out_handle[ch] = ion_alloc(alsa_client, rtk_dec_ao_buffer, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+        if (IS_ERR(dec_out_handle[ch])) {
+            ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+            return bMallocSuccess;
+        }
+
+        if (ion_phys(alsa_client, dec_out_handle[ch], &dat, &len) != 0) {
+            snd_realtek_hw_free_ring(runtime);
+            printk("[malloc ch %d fail and terminate %s %d]\n", ch, __FUNCTION__, __LINE__);
+            return bMallocSuccess;
+        }
+
+        dpcm->phy_decOutData[ch] = dat;
+        dpcm->decOutData[ch] = ion_map_kernel(alsa_client, dec_out_handle[ch]);
+#else
+        void *addr = 0;
+
+        addr = dma_alloc_coherent(NULL, rtk_dec_ao_buffer, &dpcm->phy_decOutData[ch], GFP_KERNEL);
+        if(!addr)
+        {
+            snd_realtek_hw_free_ring(runtime);
+            printk("[malloc ch %d fail and terminate %s %d]\n", ch, __FUNCTION__, __LINE__);
+            return bMallocSuccess;
+        }
+
+        dpcm->decOutData[ch] = addr;
+#endif
+
+        dpcm->nRingSize = rtk_dec_ao_buffer;
+        //printk("[test]AO Inring buffer ch %d (vir)address %x (phy)address %x\n", ch, dpcm->decOutData[ch], dpcm->phy_decOutData[ch]);
+    }
+
+    bMallocSuccess = 0; //Success
+    return bMallocSuccess;
+}
+
+static int snd_realtek_hw_create_AI(snd_pcm_substream_t *substream)
+{
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+
+    if (snd_open_ai_count >= MAX_AI_DEVICES) 
+    {
+        ALSA_WARNING("[too more AI %s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    if(RPC_TOAGENT_CREATE_AI_AGENT(dpcm))
+    {
+        ALSA_WARNING("[err %s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    snd_open_ai_count ++;
+    return 0;
+}
+
+static int snd_realtek_hw_get_AI(snd_pcm_substream_t *substream)
+{
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+
+    if (snd_open_ai_count >= MAX_AI_DEVICES)
+    {
+        ALSA_WARNING("[too more AI %s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    if(RPC_TOAGENT_GET_AI_AGENT(dpcm))
+    {
+        ALSA_WARNING("[err %s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    snd_open_ai_count ++;
+    return 0;
+}
+
+// get AO flash pin ID
+static int snd_realtek_hw_open(snd_pcm_substream_t *substream)
+{
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    if (snd_open_count >= MAX_PCM_SUBSTREAMS) {
+        ALSA_WARNING("[opened audio stream count excess %d]\n", MAX_PCM_SUBSTREAMS);
+        return -1;
+    }
+
+    // get ao flash pin ID
+    if ((dpcm->AOpinID = RPC_TOAGENT_GET_AO_FLASH_PIN(dpcm)) < 0) {
+        ALSA_WARNING("[can't get flash pin %s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+
+    // init volume
+    dpcm->volume = 31;
+    
+    snd_open_count ++;
+    ALSA_VitalPrint("[ALSA Open AO AgentID = %d pinID = %d]\n", dpcm->AOAgentID, dpcm->AOpinID);
+    return 0;
+}
+
+// check if AO exists
+// return 0(success), 1(fail)
+static int snd_realtek_hw_init(snd_card_RTK_pcm_t *dpcm) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    if (dpcm->bHWinit != 0) 
+        return 0;
+
+    if (snd_realtek_hw_check_audio_ready()) 
+    {
+        return -1;
+    }
+
+    if (RPC_TOAGENT_CREATE_AO_AGENT(&dpcm->AOAgentID, AUDIO_ALSA_OUT))
+    {
+        ALSA_WARNING("[No AO agent %s %d]\n", __FUNCTION__, __LINE__);
+        return -1;
+    }
+    dpcm->bHWinit = 1;
+
+    return 0;
+}
+
+static int snd_realtek_hw_close(snd_card_RTK_pcm_t *dpcm)
+{
+	AUDIO_RPC_RINGBUFFER_HEADER RBuf;
+	int ret = 0;
+	int i;
+	int channel_max = 8;
+
+	/* re-initialize ring buffer with null ring */
+	RBuf.instanceID = dpcm->AOAgentID;
+	RBuf.pinID = dpcm->AOpinID;
+	RBuf.readIdx = 0;
+	RBuf.listSize = 0;
+	for ( i = 0; i < channel_max; i++)
+		RBuf.pRingBufferHeaderList[i] = 0;
+
+	/* stop AO */
+	ret = RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(&RBuf, channel_max);
+
+	dec_out_msec = 0;
+	return ret;
+}
+
+static int snd_realtek_hw_capture_free_ring(snd_pcm_runtime_t *runtime)
+{
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    int ch;
+
+    printk("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+	switch(dpcm->source_in)
+	{
+		case ENUM_AIN_AUDIO_V2:
+		case ENUM_AIN_AUDIO_V3:
+		case ENUM_AIN_AUDIO_V4:
+			break;
+		default:
+			// free AI in_ring
+			for (ch = 0; ch < runtime->channels; ch++)
+			{
+				if(dpcm->pAIRingData[ch] != NULL)
+				{
+#ifdef USE_ION_AUDIO_HEAP
+					if(alsa_client != NULL && enc_in_handle[ch] != NULL)
+					{
+						ion_unmap_kernel(alsa_client, enc_in_handle[ch]);
+						ion_free(alsa_client, enc_in_handle[ch]);
+						enc_in_handle[ch] = NULL;
+					}
+#else
+					dma_free_coherent(NULL, RTK_ENC_AI_BUFFER_SIZE, dpcm->pAIRingData[ch], dpcm->phy_pAIRingData[ch]);
+#endif
+					dpcm->pAIRingData[ch] = NULL;
+				}
+			}
+			break;
+	}
+
+	// free AI lpcm ring
+	if(dpcm->nAIFormat == AUDIO_ALSA_FORMAT_16BITS_LE_LPCM ||
+	dpcm->nAIFormat == AUDIO_ALSA_FORMAT_24BITS_LE_LPCM)
+	{
+#ifdef USE_ION_AUDIO_HEAP
+		if(alsa_client != NULL && enc_lpcm_handle != NULL)
+		{
+			ion_unmap_kernel(alsa_client, enc_lpcm_handle);
+			ion_free(alsa_client, enc_lpcm_handle);
+			enc_lpcm_handle = NULL;
+		}
+#else
+		dma_free_coherent(NULL, RTK_ENC_LPCM_BUFFER_SIZE, dpcm->pLPCMData, dpcm->phy_pLPCMData);
+#endif
+	}
+
+#ifdef CAPTURE_USE_PTS_RING
+	// free AI pts ring
+	if(alsa_client != NULL && enc_pts_handle != NULL)
+	{
+		ion_unmap_kernel(alsa_client, enc_pts_handle);
+		ion_free(alsa_client, enc_pts_handle);
+		enc_pts_handle = NULL;
+	}
+#endif
+
+	return 0;
+}
+
+static int snd_realtek_hw_free_ring (snd_pcm_runtime_t *runtime)
+{
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+    int ch;
+
+    //ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+    for (ch = 0; ch < dpcm->last_channel; ch++)
+    {
+        if(dpcm->decOutData[ch] != NULL)
+        {
+#ifdef USE_ION_AUDIO_HEAP
+            if(alsa_client != NULL && dec_out_handle[ch] != NULL)
+            {
+                ion_unmap_kernel(alsa_client, dec_out_handle[ch]);
+                ion_free(alsa_client, dec_out_handle[ch]);
+                dec_out_handle[ch] = NULL;
+            }
+#else
+            dma_free_coherent(NULL, rtk_dec_ao_buffer, dpcm->decOutData[ch], dpcm->phy_decOutData[ch]);
+#endif
+            dpcm->decOutData[ch] = NULL;
+        }
+    }
+    //TRACE_CODE("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+static void snd_card_runtime_free(snd_pcm_runtime_t *runtime)
+{
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+	struct ion_handle *alsa_playback_handle_free = NULL;
+	alsa_playback_handle_free = dpcm->inRingHandle;
+    ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+    
+    //snd_realtek_hw_free_ring(runtime);
+#ifdef USE_ION_AUDIO_HEAP
+    if (alsa_client != NULL && alsa_playback_handle_free != NULL)
+    {
+        //printk("%s free handle %p \n", __FUNCTION__, alsa_playback_handle_free);
+        ion_unmap_kernel(alsa_client, alsa_playback_handle_free);
+        ion_free(alsa_client, alsa_playback_handle_free);
+        alsa_playback_handle_free = NULL;
+    }
+#else
+    dma_free_coherent(NULL, 4096, dpcm, dpcm->phy_addr);
+#endif
+    runtime->private_data = NULL;
+}
+
+static void snd_card_capture_runtime_free(snd_pcm_runtime_t *runtime)
+{
+    ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+#ifndef USE_ION_AUDIO_HEAP
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+#endif
+
+#ifdef USE_ION_AUDIO_HEAP
+    if(alsa_client != NULL && alsa_capture_handle != NULL)
+    {
+        printk("%s free alsa_capture_handle\n", __FUNCTION__);
+        ion_unmap_kernel(alsa_client, alsa_capture_handle);
+        ion_free(alsa_client, alsa_capture_handle);
+        alsa_capture_handle = NULL;
+    }
+#else
+    dma_free_coherent(NULL, 4096, dpcm, dpcm->phy_addr);
+#endif
+    runtime->private_data = NULL;
+}
+
+static int snd_card_playback_open(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_pcm_t *dpcm = NULL;
+	int ret = ENOMEM;
+#ifdef USE_ION_AUDIO_HEAP
+	ion_phys_addr_t dat;
+	size_t len;
+#endif
+
+	printk("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+#if 0
+	if(is_suspend)
+	{
+		ALSA_VitalPrint("[ALSA %s %d] suspend\n", __FUNCTION__, __LINE__);
+		return ret;
+	}
+#endif
+
+#ifdef USE_ION_AUDIO_HEAP
+	alsa_playback_handle = ion_alloc(alsa_client, sizeof(snd_card_RTK_pcm_t), 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+	printk("%s create alsa_playback_handle %p\n", __FUNCTION__, alsa_playback_handle);
+
+	if (IS_ERR(alsa_playback_handle)) {
+		ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	if (ion_phys(alsa_client, alsa_playback_handle, &dat, &len) != 0) {
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = ion_map_kernel(alsa_client, alsa_playback_handle);
+	memset(dpcm, 0, len);
+	dpcm->phy_addr = dat;
+	dpcm->inRingHandle = alsa_playback_handle;
+#else
+	dma_addr_t dat;
+	void *p;
+
+	p = dma_alloc_coherent(NULL, sizeof(snd_card_RTK_pcm_t), &dat, GFP_KERNEL);
+	if(!p)
+	{
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = p;
+	dpcm->phy_addr = dat;
+#endif
+
+	// private data
+	runtime->private_data = dpcm;
+	runtime->private_free = snd_card_runtime_free;
+
+	// check if AO exists
+	if (snd_realtek_hw_init(dpcm))
+	{
+		ALSA_WARNING("[error %s %d]\n", __FUNCTION__, __LINE__);
+		ret = -ENOMEDIUM;
+		goto fail;
+	}
+
+	memcpy(&runtime->hw, &snd_card_playback, sizeof(struct snd_pcm_hardware));
+	dpcm->substream = substream;
+	dpcm->nEOSState = SND_REALTEK_EOS_STATE_NONE;
+	if (snd_realtek_hw_open(substream) < 0)
+	{
+		ALSA_WARNING("[error %s %d]\n", __FUNCTION__, __LINE__);
+		ret = -ENOMEM;
+		goto fail;
+	}
+
+	dpcm->card = (RTK_snd_card_t *) (substream->pcm->card->private_data);
+
+	// init dec_out_msec
+	dec_out_msec = 0;
+
+	// init hr timer
+	hrtimer_init(&dpcm->hr_timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+	dpcm->hr_timer.function = &snd_card_timer_function;
+
+#ifdef DEBUG_RECORD
+	dpcm->ai_count = snd_open_count;
+	if (dpcm->ai_count > 1){
+		/* Create the file needs to after initalizing the sysem. */
+		dpcm->fp = filp_open("/data/debug_record.wav", O_RDWR | O_CREAT, 0644);
+		if (IS_ERR(dpcm->fp)){
+			ALSA_WARNING("[create file error %s %d]\n", __FUNCTION__, __LINE__);
+		}
+		dpcm->pos =0;
+	}
+#endif
+
+	spin_lock_init(&playback_lock);
+
+	dpcm->card->mixer_volume[MIXER_ADDR_MASTER][0] = dpcm->card->mixer_volume[MIXER_ADDR_MASTER][1] = RPC_TOAGENT_GET_VOLUME(dpcm);
+
+	ret = 0;
+
+	if (g_ShareMemPtr == NULL)
+	{
+#ifdef USE_ION_AUDIO_HEAP
+		//printk("%s create sharemem_handle\n", __FUNCTION__);
+		sharemem_handle = ion_alloc(alsa_client, SHARE_MEM_SIZE, 32, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+		if (IS_ERR(sharemem_handle)) {
+			ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+			goto fail;
+		}
+
+		if (ion_phys(alsa_client, sharemem_handle, &g_ShareMemPtr_dat, &len) != 0)
+		{
+			printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+			goto fail;
+		}
+
+		g_ShareMemPtr = ion_map_kernel(alsa_client, sharemem_handle);
+		//printk("phy %p vir %p\n", g_ShareMemPtr_dat, g_ShareMemPtr);
+#else
+		g_ShareMemPtr = dma_alloc_coherent(NULL, SHARE_MEM_SIZE, &g_ShareMemPtr_dat, GFP_KERNEL);
+		if(!g_ShareMemPtr)
+		{
+			printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+			goto fail;
+		}
+		//printk("g_ShareMemPtr %p\n", g_ShareMemPtr);
+#endif
+		memset(g_ShareMemPtr, 0, SHARE_MEM_SIZE);
+		//RPC_TOAGENT_PUT_SHARE_MEMORY((void *)g_ShareMemPtr_dat, ENUM_PRIVATEINFO_AUDIO_GET_SHARE_MEMORY_FROM_ALSA);
+    }
+
+	if (g_ShareMemPtr2 == NULL)
+	{
+#ifdef USE_ION_AUDIO_HEAP
+		//printk("%s create sharemem_handle\n", __FUNCTION__);
+		sharemem_handle2 = ion_alloc(alsa_client, SHARE_MEM_SIZE_LATENCY, 32, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+		if (IS_ERR(sharemem_handle2)) {
+			ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+			goto fail;
+		}
+
+		if (ion_phys(alsa_client, sharemem_handle2, &g_ShareMemPtr_dat2, &len) != 0)
+		{
+			printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+			goto fail;
+		}
+
+		g_ShareMemPtr2 = ion_map_kernel(alsa_client, sharemem_handle2);
+		//printk("phy %p vir %p\n", g_ShareMemPtr_dat, g_ShareMemPtr);
+#else
+		g_ShareMemPtr2 = dma_alloc_coherent(NULL, SHARE_MEM_SIZE_LATENCY, &g_ShareMemPtr_dat2, GFP_KERNEL);
+		if(!g_ShareMemPtr2)
+		{
+			printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+			goto fail;
+		}
+		//printk("g_ShareMemPtr %p\n", g_ShareMemPtr);
+#endif
+		memset(g_ShareMemPtr2, 0, SHARE_MEM_SIZE_LATENCY);
+		//move to snd_card_playback_prepare to set RPC_TOAGENT_PUT_SHARE_MEMORY_LATENCY
+		//RPC_TOAGENT_PUT_SHARE_MEMORY_LATENCY((void *)g_ShareMemPtr_dat, (void *)g_ShareMemPtr_dat2, ENUM_PRIVATEINFO_AUDIO_GET_SHARE_MEMORY_FROM_ALSA);
+	}
+
+	if (g_ShareMemPtr3 == NULL)
+	{
+#ifdef USE_ION_AUDIO_HEAP
+		//printk("%s create sharemem_handle\n", __FUNCTION__);
+		sharemem_handle3 = ion_alloc(alsa_client, SHARE_MEM_SIZE_LATENCY, 32, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+		if (IS_ERR(sharemem_handle3)) {
+			ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+			goto fail;
+		}
+
+		if (ion_phys(alsa_client, sharemem_handle3, &g_ShareMemPtr_dat3, &len) != 0)
+		{
+			printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+			goto fail;
+		}
+
+		g_ShareMemPtr3 = ion_map_kernel(alsa_client, sharemem_handle3);
+		//printk("phy %p vir %p\n", g_ShareMemPtr_dat, g_ShareMemPtr);
+#else
+		g_ShareMemPtr3 = dma_alloc_coherent(NULL, SHARE_MEM_SIZE_LATENCY, &g_ShareMemPtr_dat3, GFP_KERNEL);
+		if(!g_ShareMemPtr3)
+		{
+			printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+			goto fail;
+		}
+		//printk("g_ShareMemPtr %p\n", g_ShareMemPtr);
+#endif
+		memset(g_ShareMemPtr3, 0, SHARE_MEM_SIZE_LATENCY);
+	}
+
+	return ret;
+fail:
+
+#ifdef USE_ION_AUDIO_HEAP
+	if (alsa_client != NULL && alsa_playback_handle != NULL) {
+		printk("%s free alsa_playback_handle\n", __FUNCTION__);
+		ion_unmap_kernel(alsa_client, alsa_playback_handle);
+		ion_free(alsa_client, alsa_playback_handle);
+		alsa_playback_handle = NULL;
+		dpcm = NULL;
+	}
+#else
+	if(p)
+	{
+		dma_free_coherent(NULL, sizeof(snd_card_RTK_pcm_t), p, dat);
+		dpcm = NULL;
+	}
+#endif
+
+	return ret;
+}
+
+// it's for HDMI-RX
+static int snd_card_capture_open(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = NULL;
+	int ret = ENOMEM;
+
+#ifdef USE_ION_AUDIO_HEAP
+	ion_phys_addr_t dat;
+	size_t len;
+
+	if(alsa_capture_handle)
+	{
+		ALSA_WARNING("ERR more than 1 capture instance!!!\n");
+	}
+
+	alsa_capture_handle = ion_alloc(alsa_client, sizeof(snd_card_RTK_capture_pcm_t), 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+	if (IS_ERR(alsa_capture_handle)) {
+		ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	if(ion_phys(alsa_client, alsa_capture_handle, &dat, &len) != 0) {
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = ion_map_kernel(alsa_client, alsa_capture_handle);
+	memset(dpcm, 0, len);
+	dpcm->phy_addr = dat;
+#else
+	dma_addr_t dat;
+	void *p;
+
+	p = dma_alloc_coherent(NULL, sizeof(snd_card_RTK_pcm_t), &dat, GFP_KERNEL);
+	if (!p)
+	{
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = p;
+	dpcm->phy_addr = dat;
+#endif
+	printk("[ALSA %s %s %d]\n",substream->pcm->name, __FUNCTION__, __LINE__);
+
+	// private data
+	runtime->private_data = dpcm;
+	runtime->private_free = snd_card_capture_runtime_free;
+
+	memcpy(&runtime->hw, &snd_card_mars_capture, sizeof(struct snd_pcm_hardware));
+	dpcm->substream = substream;
+	dpcm->source_in = ENUM_AIN_HDMIRX;
+
+	// create AI
+	if (snd_realtek_hw_create_AI(substream) < 0)
+	{
+		ALSA_WARNING("[error %s %d]\n", __FUNCTION__, __LINE__);
+		ret = -ENOMEM;
+		goto fail;
+	}
+
+	dpcm->card = (RTK_snd_card_t *)(substream->pcm->card->private_data);
+
+	// init hr timer
+	hrtimer_init(&dpcm->hr_timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+
+	//spin_lock_init(&dpcm->nLock);
+	spin_lock_init(&capture_lock);
+
+	ALSA_VitalPrint("[ALSA %s END]\n", __FUNCTION__);
+
+	ret = 0;
+
+	return ret;
+fail:
+
+#ifdef USE_ION_AUDIO_HEAP
+	if(alsa_client != NULL && alsa_capture_handle != NULL)
+	{
+		printk("%s free alsa_capture_handle\n", __FUNCTION__);
+		ion_unmap_kernel(alsa_client, alsa_capture_handle);
+		ion_free(alsa_client, alsa_capture_handle);
+		alsa_capture_handle = NULL;
+		dpcm = NULL;
+	}
+#else
+	if(p)
+	{
+		dma_free_coherent(NULL, sizeof(snd_card_RTK_capture_pcm_t), p, dat);
+		dpcm = NULL;
+	}
+#endif
+
+	return ret;
+}
+
+// it's for HDMI-RX nonpcm in
+static int snd_card_capture_nonpcm_open(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = NULL;
+	int ret = ENOMEM;
+
+#ifdef USE_ION_AUDIO_HEAP
+	ion_phys_addr_t dat;
+	size_t len;
+
+	if(alsa_capture_handle)
+	{
+		ALSA_WARNING("ERR more than 1 capture instance!!!\n");
+	}
+
+	alsa_capture_handle = ion_alloc(alsa_client, sizeof(snd_card_RTK_capture_pcm_t), 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+	if (IS_ERR(alsa_capture_handle)) {
+		ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	if(ion_phys(alsa_client, alsa_capture_handle, &dat, &len) != 0) {
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = ion_map_kernel(alsa_client, alsa_capture_handle);
+	memset(dpcm, 0, len);
+	dpcm->phy_addr = dat;
+#else
+	dma_addr_t dat;
+	void *p;
+
+	p = dma_alloc_coherent(NULL, sizeof(snd_card_RTK_pcm_t), &dat, GFP_KERNEL);
+	if (!p)
+	{
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = p;
+	dpcm->phy_addr = dat;
+#endif
+	printk("[ALSA %s %s %d]\n",substream->pcm->name, __FUNCTION__, __LINE__);
+
+	// private data
+	runtime->private_data = dpcm;
+	runtime->private_free = snd_card_capture_runtime_free;
+
+	memcpy(&runtime->hw, &snd_card_mars_capture, sizeof(struct snd_pcm_hardware));
+	dpcm->substream = substream;
+
+	// create AI
+	if (snd_realtek_hw_create_AI(substream) < 0)
+	{
+		ALSA_WARNING("[error %s %d]\n", __FUNCTION__, __LINE__);
+		ret = -ENOMEM;
+		goto fail;
+	}
+
+	dpcm->card = (RTK_snd_card_t *)(substream->pcm->card->private_data);
+
+	// init hr timer
+	hrtimer_init(&dpcm->hr_timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+
+	//spin_lock_init(&dpcm->nLock);
+	spin_lock_init(&capture_lock);
+
+	ALSA_VitalPrint("[ALSA %s END]\n", __FUNCTION__);
+
+	ret = 0;
+
+	return ret;
+fail:
+
+#ifdef USE_ION_AUDIO_HEAP
+	if(alsa_client != NULL && alsa_capture_handle != NULL)
+	{
+		printk("%s free alsa_capture_handle\n", __FUNCTION__);
+		ion_unmap_kernel(alsa_client, alsa_capture_handle);
+		ion_free(alsa_client, alsa_capture_handle);
+		alsa_capture_handle = NULL;
+		dpcm = NULL;
+	}
+#else
+	if(p)
+	{
+		dma_free_coherent(NULL, sizeof(snd_card_RTK_capture_pcm_t), p, dat);
+		dpcm = NULL;
+	}
+#endif
+
+	return ret;
+}
+
+// it's for I2S
+static int snd_card_capture_i2s_open(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = NULL;
+	int ret = ENOMEM;
+
+#ifdef USE_ION_AUDIO_HEAP
+	ion_phys_addr_t dat;
+	size_t len;
+
+	if(alsa_capture_handle)
+	{
+		ALSA_WARNING("ERR more than 1 capture instance!!!\n");
+	}
+
+	alsa_capture_handle = ion_alloc(alsa_client, sizeof(snd_card_RTK_capture_pcm_t), 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+	if (IS_ERR(alsa_capture_handle)) {
+		ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	if(ion_phys(alsa_client, alsa_capture_handle, &dat, &len) != 0) {
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = ion_map_kernel(alsa_client, alsa_capture_handle);
+	memset(dpcm, 0, len);
+	dpcm->phy_addr = dat;
+#else
+	dma_addr_t dat;
+	void *p;
+
+	p = dma_alloc_coherent(NULL, sizeof(snd_card_RTK_pcm_t), &dat, GFP_KERNEL);
+	if (!p)
+	{
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = p;
+	dpcm->phy_addr = dat;
+#endif
+	printk("[ALSA %s %s %d]\n",substream->pcm->name, __FUNCTION__, __LINE__);
+
+	// private data
+	runtime->private_data = dpcm;
+	runtime->private_free = snd_card_capture_runtime_free;
+
+	memcpy(&runtime->hw, &snd_card_mars_capture, sizeof(struct snd_pcm_hardware));
+	dpcm->substream = substream;
+	dpcm->source_in = ENUM_AIN_I2S;
+
+	// create AI
+	if (snd_realtek_hw_create_AI(substream) < 0)
+	{
+		ALSA_WARNING("[error %s %d]\n", __FUNCTION__, __LINE__);
+		ret = -ENOMEM;
+		goto fail;
+	}
+
+	dpcm->card = (RTK_snd_card_t *)(substream->pcm->card->private_data);
+
+	// init hr timer
+	hrtimer_init(&dpcm->hr_timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+
+	//spin_lock_init(&dpcm->nLock);
+	spin_lock_init(&capture_lock);
+
+	ALSA_VitalPrint("[ALSA %s END]\n", __FUNCTION__);
+
+	ret = 0;
+
+	return ret;
+fail:
+
+#ifdef USE_ION_AUDIO_HEAP
+	if(alsa_client != NULL && alsa_capture_handle != NULL)
+	{
+		printk("%s free alsa_capture_handle\n", __FUNCTION__);
+		ion_unmap_kernel(alsa_client, alsa_capture_handle);
+		ion_free(alsa_client, alsa_capture_handle);
+		alsa_capture_handle = NULL;
+		dpcm = NULL;
+	}
+#else
+	if(p)
+	{
+		dma_free_coherent(NULL, sizeof(snd_card_RTK_capture_pcm_t), p, dat);
+		dpcm = NULL;
+	}
+#endif
+
+	return ret;
+}
+
+// it's for audio in
+#ifdef CONFIG_REALTEK_FL3236
+extern void fl3236_enable_light(void);
+#endif
+static int snd_card_capture_audio_open(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = NULL;
+	int ret = ENOMEM;
+
+#ifdef USE_ION_AUDIO_HEAP
+	ion_phys_addr_t dat;
+	size_t len;
+
+	if(alsa_capture_handle)
+	{
+		ALSA_WARNING("ERR more than 1 capture instance!!!\n");
+	}
+
+	alsa_capture_handle = ion_alloc(alsa_client, sizeof(snd_card_RTK_capture_pcm_t), 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+	if (IS_ERR(alsa_capture_handle)) {
+		ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	if(ion_phys(alsa_client, alsa_capture_handle, &dat, &len) != 0) {
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = ion_map_kernel(alsa_client, alsa_capture_handle);
+	memset(dpcm, 0, len);
+	dpcm->phy_addr = dat;
+#else
+	dma_addr_t dat;
+	void *p;
+
+	p = dma_alloc_coherent(NULL, sizeof(snd_card_RTK_pcm_t), &dat, GFP_KERNEL);
+	if (!p)
+	{
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = p;
+	dpcm->phy_addr = dat;
+#endif
+	// private data
+	runtime->private_data = dpcm;
+	runtime->private_free = snd_card_capture_runtime_free;
+
+	memcpy(&runtime->hw, &snd_card_mars_capture_audio, sizeof(struct snd_pcm_hardware));
+	dpcm->substream = substream;
+	dpcm->source_in = ENUM_AIN_AUDIO;
+
+	// get AI, AI is already
+	if (snd_realtek_hw_get_AI(substream) < 0)
+	{
+		ALSA_WARNING("[error %s %d]\n", __FUNCTION__, __LINE__);
+		ret = -ENOMEM;
+		goto fail;
+	}
+
+	dpcm->card = (RTK_snd_card_t *)(substream->pcm->card->private_data);
+
+#ifdef CONFIG_REALTEK_FL3236
+	fl3236_enable_light();
+#endif
+
+	// init hr timer
+	hrtimer_init(&dpcm->hr_timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+
+	spin_lock_init(&capture_lock);
+
+	ALSA_VitalPrint("[ALSA %s END]\n", __FUNCTION__);
+
+	ret = 0;
+
+	return ret;
+fail:
+
+#ifdef USE_ION_AUDIO_HEAP
+	if(alsa_client != NULL && alsa_capture_handle != NULL)
+	{
+		ion_unmap_kernel(alsa_client, alsa_capture_handle);
+		ion_free(alsa_client, alsa_capture_handle);
+		alsa_capture_handle = NULL;
+		dpcm = NULL;
+	}
+#else
+	if(p)
+	{
+		dma_free_coherent(NULL, sizeof(snd_card_RTK_capture_pcm_t), p, dat);
+		dpcm = NULL;
+	}
+#endif
+
+	return ret;
+}
+
+static int snd_card_capture_audio_v2_open(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = NULL;
+	int ret = ENOMEM;
+
+#ifdef USE_ION_AUDIO_HEAP
+	ion_phys_addr_t dat;
+	size_t len;
+
+	if(alsa_capture_handle)
+	{
+		ALSA_WARNING("ERR more than 1 capture instance!!!\n");
+	}
+
+	alsa_capture_handle = ion_alloc(alsa_client, sizeof(snd_card_RTK_capture_pcm_t), 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+	if (IS_ERR(alsa_capture_handle)) {
+		ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	if(ion_phys(alsa_client, alsa_capture_handle, &dat, &len) != 0) {
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = ion_map_kernel(alsa_client, alsa_capture_handle);
+	memset(dpcm, 0, len);
+	dpcm->phy_addr = dat;
+#else
+	dma_addr_t dat;
+	void *p;
+
+	p = dma_alloc_coherent(NULL, sizeof(snd_card_RTK_pcm_t), &dat, GFP_KERNEL);
+	if (!p)
+	{
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = p;
+	dpcm->phy_addr = dat;
+#endif
+	// private data
+	runtime->private_data = dpcm;
+	runtime->private_free = snd_card_capture_runtime_free;
+
+	memcpy(&runtime->hw, &snd_card_mars_capture_audio, sizeof(struct snd_pcm_hardware));
+	dpcm->substream = substream;
+	dpcm->source_in = ENUM_AIN_AUDIO_V2;
+
+	// create AI
+	if (snd_realtek_hw_create_AI(substream) < 0)
+	{
+		ALSA_WARNING("[error %s %d]\n", __FUNCTION__, __LINE__);
+		ret = -ENOMEM;
+		goto fail;
+	}
+
+	dpcm->card = (RTK_snd_card_t *)(substream->pcm->card->private_data);
+
+	// init hr timer
+	hrtimer_init(&dpcm->hr_timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+
+	spin_lock_init(&capture_lock);
+
+	ALSA_VitalPrint("[ALSA %s END]\n", __FUNCTION__);
+
+	ret = 0;
+
+	return ret;
+fail:
+
+#ifdef USE_ION_AUDIO_HEAP
+	if(alsa_client != NULL && alsa_capture_handle != NULL)
+	{
+		ion_unmap_kernel(alsa_client, alsa_capture_handle);
+		ion_free(alsa_client, alsa_capture_handle);
+		alsa_capture_handle = NULL;
+		dpcm = NULL;
+	}
+#else
+	if(p)
+	{
+		dma_free_coherent(NULL, sizeof(snd_card_RTK_capture_pcm_t), p, dat);
+		dpcm = NULL;
+	}
+#endif
+
+	return ret;
+}
+
+static int snd_card_capture_audio_v3_open(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = NULL;
+	int ret = ENOMEM;
+
+#ifdef USE_ION_AUDIO_HEAP
+	ion_phys_addr_t dat;
+	size_t len;
+
+	if(alsa_capture_handle)
+	{
+		ALSA_WARNING("ERR more than 1 capture instance!!!\n");
+	}
+
+	alsa_capture_handle = ion_alloc(alsa_client, sizeof(snd_card_RTK_capture_pcm_t), 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+	if (IS_ERR(alsa_capture_handle)) {
+		ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	if(ion_phys(alsa_client, alsa_capture_handle, &dat, &len) != 0) {
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = ion_map_kernel(alsa_client, alsa_capture_handle);
+	memset(dpcm, 0, len);
+	dpcm->phy_addr = dat;
+#else
+	dma_addr_t dat;
+	void *p;
+
+	p = dma_alloc_coherent(NULL, sizeof(snd_card_RTK_pcm_t), &dat, GFP_KERNEL);
+	if (!p)
+	{
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = p;
+	dpcm->phy_addr = dat;
+#endif
+	// private data
+	runtime->private_data = dpcm;
+	runtime->private_free = snd_card_capture_runtime_free;
+
+	memcpy(&runtime->hw, &snd_card_mars_capture_audio, sizeof(struct snd_pcm_hardware));
+	dpcm->substream = substream;
+	dpcm->source_in = ENUM_AIN_AUDIO_V3;
+
+	// create AI
+	if (snd_realtek_hw_create_AI(substream) < 0)
+	{
+		ALSA_WARNING("[error %s %d]\n", __FUNCTION__, __LINE__);
+		ret = -ENOMEM;
+		goto fail;
+	}
+
+	dpcm->card = (RTK_snd_card_t *)(substream->pcm->card->private_data);
+
+	// init hr timer
+	hrtimer_init(&dpcm->hr_timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+
+	spin_lock_init(&capture_lock);
+
+	ALSA_VitalPrint("[ALSA %s END]\n", __FUNCTION__);
+
+	ret = 0;
+
+	return ret;
+fail:
+
+#ifdef USE_ION_AUDIO_HEAP
+	if(alsa_client != NULL && alsa_capture_handle != NULL)
+	{
+		ion_unmap_kernel(alsa_client, alsa_capture_handle);
+		ion_free(alsa_client, alsa_capture_handle);
+		alsa_capture_handle = NULL;
+		dpcm = NULL;
+	}
+#else
+	if(p)
+	{
+		dma_free_coherent(NULL, sizeof(snd_card_RTK_capture_pcm_t), p, dat);
+		dpcm = NULL;
+	}
+#endif
+
+	return ret;
+}
+
+static int snd_card_capture_audio_v4_open(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = NULL;
+	int ret = ENOMEM;
+
+#ifdef USE_ION_AUDIO_HEAP
+	ion_phys_addr_t dat;
+	size_t len;
+
+	if(alsa_capture_handle)
+	{
+		ALSA_WARNING("ERR more than 1 capture instance!!!\n");
+	}
+
+	alsa_capture_handle = ion_alloc(alsa_client, sizeof(snd_card_RTK_capture_pcm_t), 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+	if (IS_ERR(alsa_capture_handle)) {
+		ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	if(ion_phys(alsa_client, alsa_capture_handle, &dat, &len) != 0) {
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = ion_map_kernel(alsa_client, alsa_capture_handle);
+	memset(dpcm, 0, len);
+	dpcm->phy_addr = dat;
+#else
+	dma_addr_t dat;
+	void *p;
+
+	p = dma_alloc_coherent(NULL, sizeof(snd_card_RTK_pcm_t), &dat, GFP_KERNEL);
+	if (!p)
+	{
+		printk("[%s %d] alloc memory faild\n", __FUNCTION__, __LINE__);
+		goto fail;
+	}
+
+	dpcm = p;
+	dpcm->phy_addr = dat;
+#endif
+	// private data
+	runtime->private_data = dpcm;
+	runtime->private_free = snd_card_capture_runtime_free;
+
+	memcpy(&runtime->hw, &snd_card_mars_capture_audio, sizeof(struct snd_pcm_hardware));
+	dpcm->substream = substream;
+	dpcm->source_in = ENUM_AIN_AUDIO_V4;
+
+	// create AI
+	if (snd_realtek_hw_create_AI(substream) < 0)
+	{
+		ALSA_WARNING("[error %s %d]\n", __FUNCTION__, __LINE__);
+		ret = -ENOMEM;
+		goto fail;
+	}
+
+	dpcm->card = (RTK_snd_card_t *)(substream->pcm->card->private_data);
+
+	// init hr timer
+	hrtimer_init(&dpcm->hr_timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
+
+	spin_lock_init(&capture_lock);
+
+	ALSA_VitalPrint("[ALSA %s END]\n", __FUNCTION__);
+
+	ret = 0;
+
+	return ret;
+fail:
+
+#ifdef USE_ION_AUDIO_HEAP
+	if(alsa_client != NULL && alsa_capture_handle != NULL)
+	{
+		ion_unmap_kernel(alsa_client, alsa_capture_handle);
+		ion_free(alsa_client, alsa_capture_handle);
+		alsa_capture_handle = NULL;
+		dpcm = NULL;
+	}
+#else
+	if(p)
+	{
+		dma_free_coherent(NULL, sizeof(snd_card_RTK_capture_pcm_t), p, dat);
+		dpcm = NULL;
+	}
+#endif
+
+	return ret;
+}
+
+#ifdef CONFIG_REALTEK_FL3236
+extern void fl3236_disable_light(void);
+#endif
+static int snd_card_capture_close_audio(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+	ktime_t remaining;
+	int ret = -1;
+
+	if(snd_open_ai_count)
+	{
+		if (RPC_TOAGENT_AI_DISCONNECT_ALSA_AUDIO(runtime))
+		{
+			ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+			goto exit;
+		}
+	}
+
+	snd_realtek_hw_capture_destroy_LPCM_ringheader_of_Audio(runtime);
+#ifdef CONFIG_REALTEK_FL3236
+	fl3236_disable_light();
+#endif
+
+	/* destroy the hr timer */
+	remaining = hrtimer_get_remaining(&dpcm->hr_timer);
+	if(ktime_to_ns(remaining) > 0)
+		ndelay(ktime_to_ns(remaining));
+	ret = hrtimer_cancel(&dpcm->hr_timer);
+	if (ret){
+		ALSA_WARNING("The timer still alive...\n");
+		goto exit;
+	}
+
+	ret = 0;
+exit:
+
+	snd_realtek_hw_capture_free_ring(runtime);
+
+	if(snd_open_ai_count > 0)
+		snd_open_ai_count--;
+	return ret;
+}
+
+static int snd_card_capture_close(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+	ktime_t remaining;
+	int ret = -1;
+
+	printk("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+	if(snd_open_ai_count)
+	{
+		if (RPC_TOAGENT_DESTROY_AI_FLOW_SVC(dpcm->AIAgentID))
+		{
+			ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+			goto exit;
+		}
+	}
+
+	/* destroy the hr timer */
+	remaining = hrtimer_get_remaining(&dpcm->hr_timer);
+	if(ktime_to_ns(remaining) > 0)
+		ndelay(ktime_to_ns(remaining));
+	ret = hrtimer_cancel(&dpcm->hr_timer);
+	if (ret){
+		ALSA_WARNING("The timer still alive...\n");
+		goto exit;
+	}
+
+	ret = 0;
+exit:
+
+	snd_realtek_hw_capture_free_ring(runtime);
+
+	if(snd_open_ai_count > 0)
+		snd_open_ai_count--;
+	return ret;
+}
+
+static int snd_card_playback_close(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+	AUDIO_RPC_SENDIO sendio;
+	ktime_t remaining;
+	int ret = 0;
+
+	printk("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+	// DHCKYLIN-2822 disable get_latency before destroy decoder instance
+	if (dpcm->DECAgentID) {
+		RPC_TOAGENT_PUT_SHARE_MEMORY(NULL, ENUM_PRIVATEINFO_AUDIO_GET_SHARE_MEMORY_FROM_ALSA);
+		RPC_TOAGENT_PUT_SHARE_MEMORY_LATENCY(NULL, NULL, 0, ENUM_PRIVATEINFO_AUDIO_GET_SHARE_MEMORY_FROM_ALSA);
+	}
+
+	if (dpcm->AOpinID) {
+		/* stop decoder */
+		if(dpcm->DECAgentID)
+			RPC_TOAGENT_STOP_SVC(dpcm->DECAgentID);
+
+		// AO pause
+		if (RPC_TOAGENT_PAUSE_SVC(dpcm->AOAgentID | dpcm->AOpinID)) {
+			ret = -1;
+			goto exit;
+		}
+
+		if (dpcm->bInitRing != 0) {
+			// decoder flush
+			sendio.instanceID = dpcm->DECAgentID;
+			sendio.pinID = dpcm->DECpinID;
+
+			if (RPC_TOAGENT_FLUSH_SVC(&sendio)) {
+				ret = -1;
+				goto exit;
+			}
+			snd_realtek_hw_close(dpcm);
+		}
+
+		/* destroy decoder instance if exist */
+		if (dpcm->DECAgentID)
+			RPC_TOAGENT_DESTROY_SVC(dpcm->DECAgentID);
+	}
+	else {
+		return -1;
+	}
+
+#ifdef DEBUG_RECORD
+	/* Close the record file */
+	if (dpcm->ai_count > 1)
+		filp_close(dpcm->fp,NULL);
+#endif
+
+	/* destroy the hr timer */
+	remaining = hrtimer_get_remaining(&dpcm->hr_timer);
+	if(ktime_to_ns(remaining) > 0)
+		ndelay(ktime_to_ns(remaining));
+	ret = hrtimer_cancel(&dpcm->hr_timer);
+	if (ret){
+		ALSA_WARNING("The timer still alive...\n");
+		goto exit;
+	}
+
+exit:
+	RPC_TOAGENT_RELEASE_AO_FLASH_PIN(dpcm);
+	snd_open_count--;
+
+	snd_realtek_hw_free_ring(runtime);
+
+	if ((g_ShareMemPtr || g_ShareMemPtr2 || g_ShareMemPtr3) && snd_open_count == 0) {
+#ifdef USE_ION_AUDIO_HEAP
+		if (alsa_client != NULL && sharemem_handle != NULL) {
+			//printk("%s destory sharemem_handle\n", __FUNCTION__);
+			ion_unmap_kernel(alsa_client, sharemem_handle);
+			ion_free(alsa_client, sharemem_handle);
+			sharemem_handle = NULL;
+		}
+
+		if (alsa_client != NULL && sharemem_handle2 != NULL) {
+			ion_unmap_kernel(alsa_client, sharemem_handle2);
+			ion_free(alsa_client, sharemem_handle2);
+			sharemem_handle2 = NULL;
+		}
+
+		if (alsa_client != NULL && sharemem_handle3 != NULL) {
+			ion_unmap_kernel(alsa_client, sharemem_handle3);
+			ion_free(alsa_client, sharemem_handle3);
+			sharemem_handle3 = NULL;
+		}
+#else
+		dma_free_coherent(NULL, 4096, g_ShareMemPtr, g_ShareMemPtr_dat);
+		dma_free_coherent(NULL, 4096, g_ShareMemPtr2, g_ShareMemPtr_dat2);
+		dma_free_coherent(NULL, 4096, g_ShareMemPtr3, g_ShareMemPtr_dat3);
+#endif
+		g_ShareMemPtr = NULL;
+		g_ShareMemPtr2 = NULL;
+		g_ShareMemPtr3 = NULL;
+    }
+
+	return ret;
+}
+
+static unsigned int snd_capture_monitor_delay(struct snd_pcm_substream *substream)
+{
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    unsigned int sample_rate = runtime->rate;
+    unsigned int ret = 0;
+    unsigned long base, limit, rp, wp;
+    unsigned int pcm_size;  // unit: sample
+    unsigned int pcm_latency;   // unit ms
+    unsigned int lpcm_size; // unit: sample
+    unsigned int lpcm_latency;  // unit:ms
+
+    // calculate the size of PCM (input of AI)
+    base = (unsigned long)(dpcm->nAIRing_LE[0].beginAddr);
+    limit = (unsigned long)(dpcm->nAIRing_LE[0].beginAddr + dpcm->nAIRing_LE[0].size);
+    wp = (unsigned long)(ntohl(dpcm->nAIRing[0].writePtr));
+    rp = (unsigned long)(ntohl(dpcm->nAIRing[0].readPtr[0]));
+    pcm_size = ring_valid_data(base, limit, rp, wp) >> 2;
+    //printk(KERN_ALERT "AI pcm %x %x %x %x\n", (int)base, (int)limit, (int)wp, (int)rp);
+
+    // calculate the size of LPCM (output of AI)
+    base = (unsigned long)(dpcm->nLPCMRing_LE.beginAddr);
+    limit = (unsigned long)(dpcm->nLPCMRing_LE.beginAddr + dpcm->nLPCMRing_LE.size);
+    wp = (unsigned long)(ntohl(dpcm->nLPCMRing.writePtr));
+    rp = (unsigned long)(ntohl(dpcm->nLPCMRing.readPtr[0]));
+    lpcm_size = ring_valid_data(base, limit, rp, wp);
+    switch(dpcm->nAIFormat)
+    {
+        case AUDIO_ALSA_FORMAT_16BITS_LE_LPCM:
+            lpcm_size >>= 2;    // 2ch, 2bytes per sample
+            break;
+        case AUDIO_ALSA_FORMAT_24BITS_LE_LPCM:
+            lpcm_size /= 6; // 2ch, 3bytes per sample
+            break;
+        default:
+            ALSA_WARNING("capture err, %d @ %s %d\n", dpcm->nAIFormat, __FUNCTION__, __LINE__);
+    }
+    //printk(KERN_ALERT "AI lpcm %x %x %x %x\n", (int)base, (int)limit, (int)wp, (int)rp);
+
+    // calculate leatency
+    pcm_latency = (pcm_size * 1000) / sample_rate;
+    lpcm_latency = (lpcm_size * 1000) / sample_rate;
+    ret = pcm_latency + lpcm_latency;
+    //printk(KERN_ALERT "AI latency %x + %x = %x\n", pcm_latency, lpcm_latency, ret);
+
+    return ret;
+}
+
+static int snd_card_capture_ioctl(struct snd_pcm_substream *substream,  unsigned int cmd, void *arg)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+	int delay_ms;
+	unsigned int *volume = NULL;
+
+    TRACE_CODE("[%s %s %d cmd %d]\n", __FILE__, __FUNCTION__, __LINE__, cmd);
+    ALSA_VitalPrint("[%s %d cmd %d]\n",__FUNCTION__, __LINE__, cmd);
+
+    switch (cmd) 
+    {
+        case SNDRV_PCM_IOCTL_VOLUME_SET:
+			volume = (unsigned int *)arg;
+			return RPC_TOAGENT_SET_SOFTWARE_AI_FLASH_VOLUME(dpcm, *volume);
+            break;
+        case SNDRV_PCM_IOCTL_VOLUME_GET:
+            break;
+        case SNDRV_PCM_IOCTL_GET_FW_DELAY:
+            delay_ms = snd_capture_monitor_delay(substream);
+            put_user(delay_ms, (unsigned int*) arg);
+            break;
+        default:
+            return snd_pcm_lib_ioctl(substream, cmd, arg);
+            break;
+    }
+    return 0;
+}
+
+static int snd_card_playback_ioctl(struct snd_pcm_substream *substream,  unsigned int cmd, void *arg)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+	struct AUDIO_RPC_EQUALIZER_MODE *equalizer_mode;
+
+	//printk("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+	switch (cmd)
+	{
+		case SNDRV_PCM_IOCTL_VOLUME_SET:
+		{
+			printk("[ALSA SET VOLUME]\n");
+			get_user(dpcm->volume, (int *) arg);
+			if (dpcm->volume < 0)
+				dpcm->volume = 0;
+			if (dpcm->volume > 31)
+				dpcm->volume = 31;
+			RPC_TOAGENT_SET_AO_FLASH_VOLUME(substream);
+			break;
+		}
+		case SNDRV_PCM_IOCTL_VOLUME_GET:
+		{
+			put_user(dpcm->volume, (int *) arg);
+			break;
+		}
+		case SNDRV_PCM_IOCTL_GET_LATENCY:
+		{
+			int mLatency = 0;
+
+			mLatency = snd_monitor_audio_data_queue_new(substream);
+
+			put_user(mLatency, (int *) arg);
+			break;
+		}
+		case SNDRV_PCM_IOCTL_GET_FW_DELAY:
+		{
+			int mLatency = 0;
+			snd_pcm_sframes_t n = 0;
+
+			mLatency = snd_monitor_audio_data_queue_new(substream);
+
+			n = (mLatency * runtime->rate) / 1000;
+			put_user(n, (snd_pcm_sframes_t *) arg);
+			break;
+		}
+		case SNDRV_PCM_IOCTL_EQ_SET:
+		{
+			equalizer_mode = kmalloc(sizeof(struct AUDIO_RPC_EQUALIZER_MODE), GFP_KERNEL);
+			if(copy_from_user((void *)equalizer_mode, (void *)arg, sizeof(struct AUDIO_RPC_EQUALIZER_MODE)))
+				printk("%s %d copy data fail\n",__func__, __LINE__);
+			RPC_TOAGENT_SET_EQ(dpcm, equalizer_mode);
+			break;
+		}
+		default:
+			return snd_pcm_lib_ioctl(substream, cmd, arg);
+			break;
+	}
+	return 0;
+}
+
+static snd_pcm_uframes_t snd_card_capture_pointer(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+	snd_pcm_uframes_t ret = 0;
+
+	// update hw_ptr
+	ret = dpcm->nTotalWrite % runtime->buffer_size;
+	return ret;
+}
+
+static snd_pcm_uframes_t snd_card_playback_pointer(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+	snd_pcm_uframes_t ret = 0;
+
+	// update runtime->status->hw_ptr
+	ret = dpcm->nTotalRead % runtime->buffer_size;
+	return ret;
+}
+
+static int snd_card_capture_prepare_32bits_BE(snd_pcm_substream_t * substream)
+{
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+
+    TRACE_CODE("[ @ %s %d]\n", __FUNCTION__, __LINE__);
+    // malloc AI ring buf
+    if(snd_realtek_hw_capture_malloc_ring(runtime))
+    {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -ENOMEM;
+    }
+
+    // init AI ring header
+    if(snd_realtek_hw_capture_init_ringheader_of_AI(runtime))
+    {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -ENOMEM;
+    }
+
+	// config for different protocol
+	if (dpcm->source_in == ENUM_AIN_HDMIRX)
+		RPC_TOAGENT_AI_CONFIG_HDMI_RX_IN(dpcm); // config HDMI-RX
+	else if (dpcm->source_in == ENUM_AIN_I2S)
+		RPC_TOAGENT_AI_CONFIG_I2S_IN(dpcm); // config I2S
+
+    // private info
+    if(RPC_TOAGENT_AI_CONNECT_ALSA(runtime))
+    {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -ENOMEM;
+    }
+
+    // configure
+#if 0
+    if(RPC_TOAGENT_CONFIGURE_AI_HW(runtime))
+    {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -ENOMEM;
+    }
+#endif
+
+    // run
+    if(snd_realtek_hw_capture_run(dpcm))
+    {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        return -ENOMEM;
+    }
+
+    dpcm->nStartTimer.function = (void (*) (unsigned long))snd_card_capture_timer_function;
+
+    return 0;
+}
+
+static int snd_card_capture_prepare_LPCM_audio(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+
+	printk("[ @ %s %d]\n", __FUNCTION__, __LINE__);
+	// malloc AI ring buf
+	if(snd_realtek_hw_capture_malloc_ring(runtime))
+	{
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	// malloc LPCM ring buf
+	if(snd_realtek_hw_capture_malloc_lpcm_ring(runtime))
+	{
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	// init LPCM ring header of AI
+	if(snd_realtek_hw_capture_init_LPCM_ringheader_of_AI(runtime))
+	{
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	// private info
+	if(RPC_TOAGENT_AI_CONNECT_ALSA(runtime))
+	{
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	dpcm->hr_timer.function = &snd_card_capture_lpcm_timer_function;
+
+	return 0;
+}
+
+static int snd_card_capture_prepare_LPCM(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+
+	printk("[ @ %s %d]\n", __FUNCTION__, __LINE__);
+
+	switch(dpcm->source_in)
+	{
+		case ENUM_AIN_AUDIO_V2:
+		case ENUM_AIN_AUDIO_V3:
+		case ENUM_AIN_AUDIO_V4:
+			break;
+		default:
+			// malloc AI ring buf
+			if(snd_realtek_hw_capture_malloc_ring(runtime))
+			{
+				ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+				return -ENOMEM;
+			}
+
+			// init ring header of AI
+			if(snd_realtek_hw_capture_init_ringheader_of_AI(runtime))
+			{
+				ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+				return -ENOMEM;
+			}
+
+#ifdef CAPTURE_USE_PTS_RING
+			// malloc PTS ring buf
+			if(snd_realtek_hw_capture_malloc_pts_ring(runtime))
+			{
+				ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+				return -ENOMEM;
+			}
+
+			// init PTS ring header of AI
+			if(snd_realtek_hw_capture_init_PTS_ringheader_of_AI(runtime))
+			{
+				ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+				return -ENOMEM;
+			}
+#endif
+			break;
+	}
+
+	// malloc LPCM ring buf
+	if(snd_realtek_hw_capture_malloc_lpcm_ring(runtime))
+	{
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	// init LPCM ring header of AI
+	if(snd_realtek_hw_capture_init_LPCM_ringheader_of_AI(runtime))
+	{
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	// config for different protocol
+	switch(dpcm->source_in)
+	{
+		case ENUM_AIN_AUDIO_V2:
+		case ENUM_AIN_AUDIO_V3:
+		case ENUM_AIN_AUDIO_V4:
+			// For audio processing flow, doing connect alsa before config audio v2 or v3
+			if(RPC_TOAGENT_AI_CONNECT_ALSA(runtime))
+			{
+				ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+				return -ENOMEM;
+			}
+			RPC_TOAGENT_AI_CONFIG_AUDIO_IN(dpcm); // config audio v2 or v3
+			break;
+		case ENUM_AIN_HDMIRX:
+			RPC_TOAGENT_AI_CONFIG_HDMI_RX_IN(dpcm); // config HDMI-RX
+			break;
+		case ENUM_AIN_I2S:
+			RPC_TOAGENT_AI_CONFIG_I2S_IN(dpcm); // config I2S
+			break;
+		default:
+			break;
+	}
+
+	// private info
+	switch(dpcm->source_in)
+	{
+		case ENUM_AIN_AUDIO_V2:
+		case ENUM_AIN_AUDIO_V3:
+		case ENUM_AIN_AUDIO_V4:
+			break;
+		default:
+			if(RPC_TOAGENT_AI_CONNECT_ALSA(runtime))
+			{
+				ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+				return -ENOMEM;
+			}
+			break;
+	}
+
+	// run
+	switch(dpcm->source_in)
+	{
+		case ENUM_AIN_AUDIO_V2:
+		case ENUM_AIN_AUDIO_V3:
+		case ENUM_AIN_AUDIO_V4:
+			break;
+		default:
+			if(snd_realtek_hw_capture_run(dpcm))
+			{
+				ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+				return -ENOMEM;
+			}
+			break;
+	}
+
+	dpcm->hr_timer.function = &snd_card_capture_lpcm_timer_function;
+
+	return 0;
+}
+
+static int snd_card_capture_prepare(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+
+	ALSA_WARNING("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+	if(runtime->status->state == SNDRV_PCM_STATE_XRUN)
+	{
+		ALSA_WARNING("[SNDRV_PCM_STATE_XRUN appl_ptr %d hw_ptr %d]\n", (int)runtime->control->appl_ptr, (int)runtime->status->hw_ptr);
+	}
+
+	/* Setup the hr timer using ktime */
+	dpcm->ktime = ktime_set(0 ,(runtime->period_size * 1000) / runtime->rate * 1000 * 1000); //ms to ns
+
+	printk("\n\n\n");
+	printk("[capture : rate %d channels %d format %x\n", runtime->rate, runtime->channels, runtime->format);
+	printk("   period_size %d periods %d\n", (int)runtime->period_size, (int)runtime->periods);
+	printk("   buffer_size %d period_jiffies %d\n", (int)runtime->buffer_size, (int)dpcm->nPeriodJiffies);
+	printk("   start_threshold %d stop_threshold %d]\n", (int)runtime->start_threshold, (int)runtime->stop_threshold);
+	printk("\n\n\n");
+
+	switch (runtime->access)
+	{
+		case SNDRV_PCM_ACCESS_MMAP_INTERLEAVED:
+		case SNDRV_PCM_ACCESS_RW_INTERLEAVED:
+			switch(runtime->format)
+			{
+				case SNDRV_PCM_FORMAT_S16_LE:
+					TRACE_CODE("[SNDRV_PCM_FORMAT_S16_LE]\n");
+					dpcm->nAIFormat = AUDIO_ALSA_FORMAT_16BITS_LE_LPCM;
+					break;
+				case SNDRV_PCM_FORMAT_S24_LE:
+					TRACE_CODE("[SNDRV_PCM_FORMAT_S24_LE]\n");
+					ALSA_WARNING("[ALSA write .wav header err]\n");
+					printk("[ALSA byte #32 of .wav should be 8=>6 manually]\n");
+					dpcm->nAIFormat = AUDIO_ALSA_FORMAT_24BITS_LE_LPCM;
+					break;
+				default:
+					ALSA_WARNING("[unsupport format %d %s %d]\n", runtime->format
+						, __FUNCTION__, __LINE__);
+					return -1;
+			}
+			break;
+		case SNDRV_PCM_ACCESS_MMAP_NONINTERLEAVED:
+		case SNDRV_PCM_ACCESS_RW_NONINTERLEAVED:
+		default:
+			ALSA_WARNING("[unsupport access @ %s %d]\n", __FUNCTION__, __LINE__);
+			return -1;
+	}
+
+	if(dpcm->bInitRing)
+	{
+		dpcm->nTotalWrite = 0;
+		ALSA_WARNING("[Re-Prepare %d %d %s %d]\n", (int)runtime->control->appl_ptr, (int)runtime->status->hw_ptr, __FUNCTION__, __LINE__);
+		return 0;
+	}
+
+	dpcm->nPeriodBytes = frames_to_bytes(runtime, runtime->period_size);
+	dpcm->nFrameBytes = frames_to_bytes(runtime, 1);
+
+	switch(dpcm->nAIFormat)
+	{
+		case AUDIO_ALSA_FORMAT_32BITS_BE_PCM:
+			ALSA_WARNING("ALSA: unsupport @ %s %d\n", __FUNCTION__, __LINE__);
+			if(snd_card_capture_prepare_32bits_BE(substream))
+			{
+				ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+				return -ENOMEM;
+			}
+			break;
+		case AUDIO_ALSA_FORMAT_16BITS_LE_LPCM:
+		case AUDIO_ALSA_FORMAT_24BITS_LE_LPCM:
+			if(dpcm->source_in == ENUM_AIN_AUDIO){
+				if(snd_card_capture_prepare_LPCM_audio(substream))
+				{
+					ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+					return -ENOMEM;
+				}
+			}else{
+				if(snd_card_capture_prepare_LPCM(substream))
+				{
+					ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+					return -ENOMEM;
+				}
+			}
+			break;
+		default:
+			ALSA_WARNING("[ALSA err %s %d]\n", __FUNCTION__, __LINE__);
+			break;
+	}
+
+	dpcm->bInitRing = 1;
+
+	return 0;
+}
+
+static int snd_card_playback_prepare(snd_pcm_substream_t * substream)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+	printk("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+	if (is_suspend) {
+		ALSA_WARNING("[ALSA %s %d] suspend\n", __FUNCTION__, __LINE__);
+		return 0;
+	}
+
+	if (runtime->status->state == SNDRV_PCM_STATE_XRUN) {
+		ALSA_WARNING("[SNDRV_PCM_STATE_XRUN appl_ptr %d hw_ptr %d]\n", (int)runtime->control->appl_ptr, (int)runtime->status->hw_ptr);
+	}
+
+	/* Setup the hr timer using ktime .
+	 * For more precise compute the ktime in us.
+	 */
+	dpcm->ktime = ktime_set(0 ,(runtime->period_size * 1000) * 1000 / runtime->rate * 1000); //ms to ns
+
+	if (dpcm->bInitRing) {
+		/* Reset the information about playback.
+		 * nPreHWPtr will influence the next information update in timer function.
+		 */
+		dpcm->nHWReadSize = 0;
+		dpcm->nTotalRead = 0;
+		dpcm->nTotalWrite = 0;
+		dpcm->nPreHWPtr = 0;
+		dpcm->nPre_appl_ptr = 0;
+		/*	DHCKYLIN-2193:
+			1.  pasue and stop AO and decoder, then destory the decoder for re-sending NewFormat.
+			2.  re-send NewFormat cmd to audio f/w when alsa is reconfigured.
+		 */
+		snd_realtek_reprepare(runtime);
+		printk("[Re-Prepare %d %d %s %d]\n", (int)runtime->control->appl_ptr, (int)runtime->status->hw_ptr, __FUNCTION__, __LINE__);
+	}
+
+	printk("[======START======]\n");
+	printk("[playback : rate %d channels %d]\n", runtime->rate, runtime->channels);
+	printk("[period_size %d periods %d]\n", (int)runtime->period_size, (int)runtime->periods);
+	printk("[buffer_size %d ktime %d]\n", (int)runtime->buffer_size, (int)ktime_to_ns(dpcm->ktime));
+	printk("[start_threshold %d stop_threshold %d]\n", (int)runtime->start_threshold, (int)runtime->stop_threshold);
+	printk("[runtime->access %d]\n", runtime->access);
+	printk("[runtime->format %d]\n", runtime->format);
+	printk("[runtime->frame_bits %d]\n", runtime->frame_bits);
+	printk("[runtime->sample_bits %d]\n", runtime->sample_bits);
+	printk("[runtime->silence_threshold %d]\n", (int)runtime->silence_threshold);
+	printk("[runtime->silence_size %d]\n", (int)runtime->silence_size);
+	printk("[runtime->boundary %d]\n", (int)runtime->boundary);
+	printk("[runtime->min_align %d]\n", (int)runtime->min_align);
+	printk("[runtime->hw_ptr_base %x]\n", (unsigned int)runtime->hw_ptr_base);
+	printk("[runtime->dma_area %x]\n", (unsigned int)(uintptr_t)runtime->dma_area);
+	printk("[======END======]\n");
+
+	dpcm->nPeriodBytes = frames_to_bytes(runtime, runtime->period_size);
+
+	// create decoder agent
+	if (RPC_TOAGENT_CREATE_DECODER_AGENT(&dpcm->DECAgentID, &dpcm->DECpinID)) {
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	if (g_ShareMemPtr != NULL && g_ShareMemPtr2 != NULL) {
+		printk("to set latency of DECAgentID %d  \n", dpcm->DECAgentID);
+		RPC_TOAGENT_PUT_SHARE_MEMORY_LATENCY((void *)g_ShareMemPtr_dat, (void *)g_ShareMemPtr_dat2, dpcm->DECAgentID, ENUM_PRIVATEINFO_AUDIO_GET_SHARE_MEMORY_FROM_ALSA);
+	}
+
+	// malloc ao_inring
+	if (snd_realtek_hw_malloc_ring(runtime)) {
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	// init ringheader of decoder_outring and AO_inring
+	if (snd_realtek_hw_init_ringheader_of_DEC_AO(runtime)) {
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	// connet decoder and AO by RPC
+	if (snd_realtek_hw_init_connect_decoder_ao(dpcm)) {
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	// 1. init decoder in_ring
+	// 2. init decoder inband ring
+	if (snd_realtek_hw_init_decoder_ring(runtime)) {
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	// AO pause
+	// decoder pause
+	// decoder run
+	// decoder flush
+	// write decoder info into inband of decoder
+	if (snd_realtek_hw_init_decoder_info(runtime)) {
+		ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	if (snd_realtek_hw_resume(dpcm)) {
+		ALSA_WARNING("[%s %d]\n", __FUNCTION__, __LINE__);
+		return -ENOMEM;
+	}
+
+	dpcm->last_channel = runtime->channels;
+	dpcm->bInitRing = 1;
+
+	return 0;
+}
+
+static long snd_card_get_ring_data(RINGBUFFER_HEADER *pRing_BE, RINGBUFFER_HEADER *pRing_LE)
+{
+    unsigned long base, limit, rp, wp, data_size;
+
+    base = (unsigned long)pRing_LE->beginAddr;
+    limit= (unsigned long)(pRing_LE->beginAddr + pRing_LE->size);
+    //wp = (long)SND_UNCACHE_ADDRESS(ntohl(pRing_BE->writePtr));
+    //rp = (long)SND_UNCACHE_ADDRESS(ntohl(pRing_BE->readPtr[0]));
+    wp = (unsigned long)(ntohl(pRing_BE->writePtr));
+    rp = (unsigned long)(ntohl(pRing_BE->readPtr[0]));
+    //printk("[�� b %x l %x r %x w %x]\n", base, limit, rp, wp);
+    data_size = ring_valid_data(base, limit, rp, wp);
+    return data_size;
+}
+
+// copy data from ring(AI) to dma_buf
+#define COPY_FUNC(nFrameSize, p, pRingRp) \
+{\
+    int i,temp;\
+    for(i=0 ; i<nFrameSize ; ++i)\
+    {\
+        temp = (int)(*pRingRp[0]);\
+        temp = ENDIAN_CHANGE(temp);\
+        *p = (short)(temp >> 9);\
+        p++;\
+        temp = (int)(*pRingRp[1]);\
+        temp = ENDIAN_CHANGE(temp);\
+        *p = (short)(temp >> 9);\
+        p++;\
+        pRingRp[0]++;\
+        pRingRp[1]++;\
+    }\
+}
+
+// copy data from AI_ring to dma_buf
+static void snd_card_capture_copy(snd_pcm_runtime_t *runtime, long nPeriodCount)
+{
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    snd_pcm_uframes_t nFrameSize = nPeriodCount * runtime->period_size;
+    snd_pcm_uframes_t dma_wp = dpcm->nTotalWrite % runtime->buffer_size;
+    snd_pcm_uframes_t wrap_size = runtime->buffer_size - dma_wp;
+    int *pRingRp[2];    // kernel virtual address
+    unsigned long nRingLimit[2];    // kernel virtual address
+    unsigned long temp;
+    int i, loop0, loop1;
+    short *p = NULL;
+
+    for(i=0 ; i<2 ; ++i)
+    {
+        temp = (unsigned long)dpcm->pAIRingData[i];
+        temp += (dpcm->nAIRing_LE[i].readPtr[0] - dpcm->nAIRing_LE[i].beginAddr);
+        pRingRp[i] = (int *)temp;        
+        nRingLimit[i] = (unsigned long)(dpcm->pAIRingData[i]) + (unsigned long)dpcm->nAIRing_LE[i].size;
+    }
+    
+    if(nFrameSize > wrap_size)
+    {
+        p = (short *)(runtime->dma_area + LPCM_2CH_16BITS * dma_wp);
+        if((unsigned long)(pRingRp[0] + wrap_size) > nRingLimit[0])
+        {
+            loop0 = (nRingLimit[0] - (unsigned long)pRingRp[0]) >> 2;
+            loop1 = wrap_size - loop0;
+            COPY_FUNC(loop0, p, pRingRp);
+            pRingRp[0] = (int *)dpcm->pAIRingData[0];
+            pRingRp[1] = (int *)dpcm->pAIRingData[1];
+            COPY_FUNC(loop1, p, pRingRp);
+        }
+        else
+        {
+            COPY_FUNC(wrap_size, p, pRingRp);
+        }
+
+        p = (short *)(runtime->dma_area);
+        nFrameSize -= wrap_size;
+        if((unsigned long)(pRingRp[0] + nFrameSize) > nRingLimit[0])
+        {
+            loop0 = (nRingLimit[0] - (unsigned long)pRingRp[0]) >> 2;
+            loop1 = nFrameSize - loop0;
+            COPY_FUNC(loop0, p, pRingRp);
+            pRingRp[0] = (int *)dpcm->pAIRingData[0];
+            pRingRp[1] = (int *)dpcm->pAIRingData[1];
+            COPY_FUNC(loop1, p, pRingRp);
+        }
+        else
+        {
+            COPY_FUNC(nFrameSize, p, pRingRp);
+        }
+    }
+    else
+    {
+        p = (short *)(runtime->dma_area + LPCM_2CH_16BITS * dma_wp);
+        if((unsigned long)(pRingRp[0] + nFrameSize) > nRingLimit[0])
+        {
+            loop0 = (nRingLimit[0] - (unsigned long)pRingRp[0]) >> 2;
+            loop1 = nFrameSize - loop0;
+            COPY_FUNC(loop0, p, pRingRp);
+            pRingRp[0] = (int *)dpcm->pAIRingData[0];
+            pRingRp[1] = (int *)dpcm->pAIRingData[1];
+            COPY_FUNC(loop1, p, pRingRp);
+        }
+        else
+        {
+            COPY_FUNC(nFrameSize, p, pRingRp);
+        }
+    }
+}
+
+static long ring_memcpy2_buf(char* buf,unsigned long base, unsigned long limit, unsigned long ptr, unsigned int size)
+{
+	if (ptr + size <= limit)
+	{					
+		memcpy(buf,(char*)ptr,size);			
+	}
+	else
+	{
+		int i = limit-ptr;
+		memcpy((char*)buf,(char*)ptr,i);
+		memcpy((char*)(buf+i),(char*)base,size-i);
+	}
+	
+	ptr += size;
+	if (ptr >= limit)
+	{
+		ptr = base + (ptr-limit);
+	}	
+	return ptr;
+}
+
+uint64_t snd_card_get_90k_pts(void)
+{
+    uint64_t ret = 0;
+
+    if(clk90k_vaddr_hi && clk90k_vaddr_lo)
+    {
+        ret = (uint64_t)readl(clk90k_vaddr_lo);
+        ret |= (((uint64_t)readl(clk90k_vaddr_hi)) << 32);
+    }
+    else
+    {
+        ALSA_WARNING("%p %p @ %s\n", clk90k_vaddr_hi, clk90k_vaddr_lo, __func__);
+    }
+
+    return ret;
+}
+
+static void snd_card_capture_setup_pts(snd_pcm_runtime_t *runtime, AUDIO_DEC_PTS_INFO *pPkt)
+{
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+	uint64_t curPTS;
+	unsigned int pcm_pts_hi, pcm_pts_lo;
+	uint64_t pcmPTS = 0;
+	uint64_t diffPTS;
+
+	curPTS = snd_card_get_90k_pts();
+	pcm_pts_hi = ntohl(pPkt->PTSH);
+	pcm_pts_lo = ntohl(pPkt->PTSL);
+
+	pcmPTS = (((uint64_t)pcm_pts_hi) << 32) | ((uint64_t)pcm_pts_lo);
+
+	diffPTS = curPTS - pcmPTS;
+
+	//ALSA_VitalPrint("pcm pts %x %x\n", pcm_pts_hi, pcm_pts_lo);
+	//ALSA_VitalPrint("cur pts %x %x\n", (unsigned int)(curPTS >> 32), (unsigned int)curPTS);
+	//ALSA_VitalPrint("pcm dely %d ms\n", (int)((diffPTS * 1000) / 90000));
+
+	ktime_get_ts(&dpcm->ts);
+	dpcm->ts.tv_sec -= (div64_ul(diffPTS, 90000));
+	dpcm->ts.tv_nsec -= (div64_ul(diffPTS * 100000, 9));
+	//ALSA_VitalPrint("cap ts %x\n\n", (unsigned int)dpcm->ts.tv_sec);
+}
+
+static void snd_card_capture_calculate_pts(snd_pcm_runtime_t *runtime, long nPeriodCount)
+{
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    //snd_pcm_uframes_t nFrameSize = nPeriodCount * runtime->period_size;
+    AUDIO_DEC_PTS_INFO nPkt[2];
+    AUDIO_RINGBUF_PTR_64 *pRing = &dpcm->nPTSRing;
+    unsigned long temp_rp;
+    unsigned int lpcm_rp = dpcm->nLPCMRing_LE.readPtr[0];
+    unsigned int nPkt_ptr[2] = {0};
+    unsigned int wp_offset, rp_offset, loop_count=0;
+    //unsigned long old_rp = pRing->rp;
+
+    // refresh wp of pts_ring
+    wp_offset = ntohl(dpcm->nPTSRingHdr.writePtr) - (unsigned int)dpcm->nPTSMem.pPhy;
+    pRing->wp = pRing->base + (unsigned long)wp_offset;
+
+    //ALSA_VitalPrint("#pkt %d\n", (int)(ring_valid_data(pRing->base, pRing->limit, pRing->rp, pRing->wp) / sizeof(AUDIO_DEC_PTS_INFO)));
+
+    ////////////////////////////
+    // find corresponding pts //
+    ////////////////////////////
+    // get the first PTS
+    if(ring_valid_data(pRing->base, pRing->limit, pRing->rp, pRing->wp) >= sizeof(AUDIO_DEC_PTS_INFO))
+    {
+        temp_rp = ring_memcpy2_buf((char *)&nPkt[0], pRing->base, pRing->limit, pRing->rp, sizeof(AUDIO_DEC_PTS_INFO));
+    }
+    else
+    {
+        ALSA_WARNING("Err @ %s %d\n", __func__, __LINE__);
+        goto exit;
+    }
+    do
+    {
+        if(ring_valid_data(pRing->base, pRing->limit, temp_rp, pRing->wp) >= sizeof(AUDIO_DEC_PTS_INFO))
+        {
+            ring_memcpy2_buf((char *)&nPkt[1], pRing->base, pRing->limit, temp_rp, sizeof(AUDIO_DEC_PTS_INFO));
+        }
+        else
+        {
+            if(loop_count == 0)
+            {
+                snd_card_capture_setup_pts(runtime, &nPkt[0]);
+                goto exit;
+            }
+            else
+            {
+                // get the last packet as PTS needed
+                snd_card_capture_setup_pts(runtime, &nPkt[0]);
+                pRing->rp = ring_minus(pRing->base, pRing->limit, temp_rp, sizeof(AUDIO_DEC_PTS_INFO));
+                break;
+            }
+        }
+
+        nPkt_ptr[0] = ntohl(nPkt[0].wPtr);
+        nPkt_ptr[1] = ntohl(nPkt[1].wPtr);
+        //ALSA_VitalPrint("lpcm %x pkt %x %x\n", lpcm_rp, nPkt_ptr[0], nPkt_ptr[1]);
+        if(ring_check_ptr_valid_32(nPkt_ptr[0], nPkt_ptr[1], lpcm_rp))
+        {
+            // get PTS
+            snd_card_capture_setup_pts(runtime, &nPkt[0]);
+
+            pRing->rp = ring_minus(pRing->base, pRing->limit, temp_rp, sizeof(AUDIO_DEC_PTS_INFO));
+            break;
+        }
+        else
+        {
+            temp_rp = ring_add(pRing->base, pRing->limit, temp_rp, sizeof(AUDIO_DEC_PTS_INFO));
+            nPkt[0] = nPkt[1];
+        }
+
+        loop_count++;
+    }while(1);
+
+    // update rp
+    //ALSA_VitalPrint("pts rp %lx => %lx\n", old_rp, pRing->rp);
+    rp_offset = pRing->rp - pRing->base;
+    dpcm->nPTSRingHdr.readPtr[0] = htonl((unsigned int)dpcm->nPTSMem.pPhy + rp_offset);
+
+exit:
+/*  ALSA_VitalPrint("lpcm_rp %x time %x\n", lpcm_rp, (unsigned int)dpcm->ts.tv_sec);
+    ALSA_VitalPrint("pts b %x l %x w %x r %x\n"
+        , (unsigned int)ntohl(dpcm->nPTSRingHdr.beginAddr)
+        , (unsigned int)(ntohl(dpcm->nPTSRingHdr.beginAddr) + dpcm->nPTSMem.size)
+        , (unsigned int)ntohl(dpcm->nPTSRingHdr.writePtr), (unsigned int)ntohl(dpcm->nPTSRingHdr.readPtr[0])); */
+    return;
+}
+
+static void snd_card_capture_LPCM_copy(snd_pcm_runtime_t *runtime, long nPeriodCount)
+{
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    snd_pcm_uframes_t nFrameSize = nPeriodCount * runtime->period_size;
+    snd_pcm_uframes_t dma_wp = dpcm->nTotalWrite % runtime->buffer_size;
+    AUDIO_RINGBUF_PTR_64 src_ring, dst_ring;
+
+    src_ring.base = (unsigned long)dpcm->pLPCMData;
+    src_ring.limit = (unsigned long)(src_ring.base + dpcm->nLPCMRing_LE.size);
+    src_ring.rp = src_ring.base 
+        + (unsigned long)(dpcm->nLPCMRing_LE.readPtr[0] - dpcm->nLPCMRing_LE.beginAddr);
+
+    dst_ring.base = (unsigned long)runtime->dma_area;
+    dst_ring.limit = (unsigned long)(runtime->dma_area + runtime->buffer_size * dpcm->nFrameBytes);
+    dst_ring.wp = (unsigned long)(runtime->dma_area + dma_wp * dpcm->nFrameBytes);
+
+    ring1_to_ring2_general_64(&src_ring, &dst_ring, nFrameSize * dpcm->nFrameBytes, NULL);
+}
+
+#if _DBG_CHECK_AI_HW_RING_DATA_EN
+static void snd_card_capture_lpcm_check_ringBuf(unsigned int data)
+{
+    snd_pcm_substream_t * substream = (snd_pcm_substream_t *)data;
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    long nDataOfAIInring = 0;
+    long nDataOfAILpcmRing = 0;
+    nDataOfAIInring = snd_card_get_ring_data(dpcm->nAIRing, dpcm->nAIRing_LE) >> 2;
+    nDataOfAILpcmRing = snd_card_get_ring_data(&dpcm->nLPCMRing, &dpcm->nLPCMRing_LE) / dpcm->nFrameBytes;
+#if 0
+    {
+        long wp, rp, base, limit;        
+        base = (long)dpcm->nAIRing_LE[0].beginAddr;
+        limit= (long)(dpcm->nAIRing_LE[0].beginAddr + dpcm->nAIRing_LE[0].size);
+        wp = (long)(ntohl(dpcm->nAIRing[0].writePtr));
+        rp = (long)(ntohl(dpcm->nAIRing[0].readPtr[0]));
+        ALSA_VitalPrint("[ALSA AI HW_ring b %x l %x w %x r %x]\n", base, limit, wp, rp);
+    }
+#endif
+    ALSA_VitalPrint("[ALSA AI size %x data %x LPCM size %x data %x]\n"
+        , dpcm->nAIRing_LE[0].size >> 2, nDataOfAIInring, dpcm->nLPCMRing_LE.size / dpcm->nFrameBytes, nDataOfAILpcmRing / dpcm->nFrameBytes);
+}
+#endif
+
+int snd_card_capture_get_time_info(struct snd_pcm_substream *substream,
+			struct timespec *system_ts, struct timespec *audio_ts,
+			struct snd_pcm_audio_tstamp_config *audio_tstamp_config,
+			struct snd_pcm_audio_tstamp_report *audio_tstamp_report)
+{
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    //ALSA_VitalPrint("%s\n", __func__);
+    *system_ts = dpcm->ts;
+    return 0;
+}
+
+static void snd_card_capture_handle_HDMI_plug_out(snd_pcm_substream_t * substream)
+{
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    unsigned int nPeriodCount = 1;
+    snd_pcm_uframes_t nFrameSize = nPeriodCount * runtime->period_size;
+    snd_pcm_uframes_t dma_wp = dpcm->nTotalWrite % runtime->buffer_size;
+    AUDIO_RINGBUF_PTR_64 dst_ring;
+    char *pBuf = kmalloc(nFrameSize * dpcm->nFrameBytes, GFP_KERNEL);
+    unsigned long free_size;
+
+    if(pBuf == NULL)
+    {
+        ALSA_SEC_PRINT(1, "malloc FAILED @ %s %d\n", __func__, __LINE__);
+        return;
+    }
+
+    free_size = snd_pcm_capture_hw_avail(runtime);
+    if(free_size <= runtime->period_size)
+    {
+        ALSA_SEC_PRINT(1, "over flow %d %d @ %s %d\n", (int)free_size, (int)runtime->period_size, __func__, __LINE__);
+        return;
+    }
+
+    ALSA_SEC_PRINT(2, " @ %s\n", __func__);
+    // copy MUTE to DMA buffer
+    memset(pBuf, 0, nFrameSize * dpcm->nFrameBytes);
+    dst_ring.base = (unsigned long)runtime->dma_area;
+    dst_ring.limit = (unsigned long)(runtime->dma_area + runtime->buffer_size * dpcm->nFrameBytes);
+    dst_ring.wp = (unsigned long)(runtime->dma_area + dma_wp * dpcm->nFrameBytes);
+    buf_memcpy2_ring(dst_ring.base, dst_ring.limit, dst_ring.wp, pBuf, nFrameSize * dpcm->nFrameBytes);
+    kfree(pBuf);
+
+    // paste time stamp
+   	ktime_get_ts(&dpcm->ts);
+
+    dpcm->nTotalWrite += nPeriodCount * runtime->period_size;
+    snd_pcm_period_elapsed(substream);
+}
+
+static enum hrtimer_restart snd_card_capture_lpcm_timer_function(struct hrtimer *timer)
+{
+	snd_card_RTK_capture_pcm_t *dpcm =
+		container_of(timer, snd_card_RTK_capture_pcm_t, hr_timer);
+	snd_pcm_substream_t *substream = dpcm->substream;
+	snd_pcm_runtime_t *runtime = substream->runtime;
+
+	snd_pcm_uframes_t nRingDataFrame, free_size;
+	long nRingDataSize; // bytes
+	unsigned int nPeriodCount = 0, free_period;
+
+	if(dpcm->enHRTimer == HRTIMER_RESTART)
+	{
+
+		if(ring_valid_data(0
+			, (unsigned long)runtime->boundary
+			, (unsigned long)runtime->control->appl_ptr
+			, (unsigned long)runtime->status->hw_ptr) > runtime->buffer_size)
+		{
+			ALSA_WARNING("[hw_ptr %d appl_ptr %d %d @ %s %d]\n"
+				, (int)runtime->status->hw_ptr
+				, (int)runtime->control->appl_ptr
+				, (int)runtime->buffer_size, __FUNCTION__, __LINE__);
+		}
+
+		_DBG_CHECK_AI_HW_RING_DATA(data);
+
+		// check if HDMI-RX plug out
+		if(dpcm->source_in == ENUM_AIN_HDMIRX)
+		{
+			if(snd_realtek_capture_check_hdmirx_enable() == 0)
+			{
+				snd_card_capture_handle_HDMI_plug_out(substream);
+				goto SET_TIMER;
+			}
+		}
+
+		nRingDataSize = snd_card_get_ring_data(&dpcm->nLPCMRing, &dpcm->nLPCMRing_LE);
+		nRingDataFrame = nRingDataSize / dpcm->nFrameBytes;
+		if(nRingDataFrame >= runtime->period_size)
+		{
+			nPeriodCount = nRingDataFrame / runtime->period_size;
+
+			if(nPeriodCount == runtime->periods)
+				nPeriodCount--;
+
+			// check overflow
+			{
+				free_size = runtime->buffer_size - ring_valid_data(0
+					, (unsigned long)runtime->boundary
+					, (unsigned long)runtime->control->appl_ptr
+					, (unsigned long)runtime->status->hw_ptr);
+				free_period = free_size / runtime->period_size;
+				nPeriodCount = MIN(nPeriodCount, free_period);
+				if(nPeriodCount == 0)
+					goto SET_TIMER;
+			}
+
+			// copy data from LPCM_ring to dma_buf
+			snd_card_capture_LPCM_copy(runtime, nPeriodCount);
+
+#ifdef CAPTURE_USE_PTS_RING
+			// calculate PTS
+			switch(dpcm->source_in)
+			{
+				case ENUM_AIN_AUDIO:
+				case ENUM_AIN_AUDIO_V2:
+				case ENUM_AIN_AUDIO_V3:
+				case ENUM_AIN_AUDIO_V4:
+					break;
+				default:
+					snd_card_capture_calculate_pts(runtime, nPeriodCount);
+					break;
+			}
+#endif
+
+			// update LPCM_ring rp.
+			dpcm->nLPCMRing_LE.readPtr[0] = (unsigned int)ring_add(
+				(unsigned long)dpcm->nLPCMRing_LE.beginAddr
+				, (unsigned long)(dpcm->nLPCMRing_LE.beginAddr + dpcm->nLPCMRing_LE.size)
+				, (unsigned long)(dpcm->nLPCMRing_LE.readPtr[0])
+				, nPeriodCount * runtime->period_size * dpcm->nFrameBytes);
+			dpcm->nLPCMRing.readPtr[0] = htonl(dpcm->nLPCMRing_LE.readPtr[0]);
+
+			dpcm->nTotalWrite += nPeriodCount * runtime->period_size;
+
+			// update runtime->status->hw_ptr
+			snd_pcm_period_elapsed(substream);
+		}
+
+SET_TIMER:
+		/* Set up the next time */
+		hrtimer_forward_now(timer, dpcm->ktime);
+
+		return HRTIMER_RESTART;
+	}
+	else
+	{
+		return HRTIMER_NORESTART;
+	}
+}
+
+static void snd_card_capture_timer_function(unsigned long data)
+{
+    snd_pcm_substream_t * substream = (snd_pcm_substream_t *)data;
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    snd_pcm_uframes_t nRingDataFrame;  
+    unsigned long flags;
+    long nRingDataSize;
+    unsigned int nPeriodCount = 0;
+    int ch;
+
+    if(ring_valid_data(0, runtime->boundary, runtime->control->appl_ptr, runtime->status->hw_ptr) > runtime->buffer_size)
+    {
+        ALSA_WARNING("[hw_ptr %d appl_ptr %d %s %d]\n", (int)runtime->status->hw_ptr, (int)runtime->control->appl_ptr, __FUNCTION__, __LINE__);
+    }
+
+#if 0   // DEBUG: check wp/rp
+    ALSA_SEC_PRINT(2, "[���� state %d appl_ptr %d hw_ptr %d]\n", (int)runtime->status->state, (int)runtime->control->appl_ptr, (int)runtime->status->hw_ptr);
+#endif
+
+    // fresh wp
+    for(ch=0 ; ch<2 ; ++ch)
+        dpcm->nAIRing_LE[ch].writePtr = ntohl(dpcm->nAIRing[ch].writePtr);
+
+    nRingDataSize = snd_card_get_ring_data(dpcm->nAIRing, dpcm->nAIRing_LE);
+    nRingDataFrame = nRingDataSize >> 2;    // 1 PCM = 32 bits.
+    if(nRingDataFrame >= runtime->period_size)
+    {
+        nPeriodCount = nRingDataFrame / runtime->period_size;
+        if(nPeriodCount == runtime->periods)
+            nPeriodCount--;
+
+        // dma wirte too faster ?? (NOT sure)
+
+        // copy data from AI_ring to dma_buf
+        snd_card_capture_copy(runtime, nPeriodCount);
+
+        // update AI_ring rp.
+        for(ch=0 ; ch<2 ; ++ch)
+        {
+            dpcm->nAIRing_LE[ch].readPtr[0] = ring_add((unsigned long)dpcm->nAIRing_LE[ch].beginAddr
+                , (unsigned long)(dpcm->nAIRing_LE[ch].beginAddr + dpcm->nAIRing_LE[ch].size)
+                , (unsigned long)dpcm->nAIRing_LE[ch].readPtr[0]
+                , nPeriodCount * runtime->period_size * 4 /* 1 PCM = 32 bits */);
+            dpcm->nAIRing[ch].readPtr[0] = (unsigned int)htonl(dpcm->nAIRing_LE[ch].readPtr[0]);
+        }
+
+        dpcm->nTotalWrite += nPeriodCount * runtime->period_size;
+        snd_pcm_period_elapsed(substream);
+    }
+
+    // set timer
+    dpcm->nStartTimer.expires = dpcm->nPeriodJiffies + jiffies;
+    //spin_lock_irqsave(&dpcm->nLock, flags);
+    spin_lock_irqsave(&capture_lock, flags);
+    if(dpcm->bStop)
+        dpcm->bStop = 0;
+    else
+        add_timer(&dpcm->nStartTimer);
+    //spin_unlock_irqrestore(&dpcm->nLock, flags);
+    spin_unlock_irqrestore(&capture_lock, flags);
+}
+
+static enum hrtimer_restart snd_card_timer_function(struct hrtimer *timer)
+{
+	snd_card_RTK_pcm_t *dpcm =
+			container_of(timer, snd_card_RTK_pcm_t, hr_timer);
+	snd_pcm_substream_t *substream = dpcm->substream;
+	snd_pcm_runtime_t *runtime = substream->runtime;
+
+	snd_pcm_uframes_t nReadAddSize = 0;
+	unsigned int nPeriodCount = 0;
+	unsigned int HWRingRp;
+	unsigned int HWRingFreeSize;
+	unsigned int HWRingFreeFrame;
+	static unsigned long dbg_count = 0;
+	int dec_out_valid_size = 0;
+
+	if(dpcm->enHRTimer == HRTIMER_RESTART)
+	{
+		//calculate AOInring msec
+		dec_out_valid_size = ring_valid_data(
+			(unsigned int)ntohl(dpcm->decOutRing[0].beginAddr),
+			(unsigned int)ntohl(dpcm->decOutRing[0].beginAddr) + rtk_dec_ao_buffer,
+			(unsigned int)ntohl(dpcm->decOutRing[0].readPtr[0]),
+			(unsigned int)ntohl(dpcm->decOutRing[0].writePtr));
+		//printk("dec_out_valid_size %d\n", dec_out_valid_size);
+		if (dec_out_valid_size > 0 && dec_out_valid_size <= dpcm->nRingSize)
+			dec_out_msec = ((dec_out_valid_size >> 2) * 1000) / runtime->rate;
+		else
+			dec_out_msec = 0;
+		//printk("dec_out_msec %d\n", dec_out_msec);
+
+		if (runtime->control->appl_ptr == runtime->status->hw_ptr)
+		{
+			ALSA_WARNING("[appl_ptr %d = hw_ptr %s %d]\n", (int)runtime->control->appl_ptr, __FUNCTION__, __LINE__);
+			ALSA_WARNING("Need to check why data didn't send to alsa\n");
+		}
+
+		// update HW rp (the pointer of AFW read)
+		HWRingRp = (unsigned int)(ntohl(dpcm->decInRing[0].readPtr[0]));//physical address
+		dpcm->decInRing_LE[0].readPtr[0] = HWRingRp;
+		dpcm->nHWPtr = bytes_to_frames(runtime, (unsigned long)HWRingRp - (unsigned long)dpcm->decInRing_LE[0].beginAddr);
+
+#ifdef DEBUG_RECORD
+		if (dpcm->ai_count > 1){
+			dpcm->fs = get_fs();
+			set_fs(KERNEL_DS);
+			if (dpcm->nHWPtr >= dpcm->nPreHWPtr)
+			{
+				// 4 = 2 channel * 2 (16 bits = 2 bytes), using frames to btyes
+				vfs_write(dpcm->fp, runtime->dma_area + frames_to_bytes(runtime, dpcm->nPreHWPtr), frames_to_bytes(runtime,dpcm->nHWPtr - dpcm->nPreHWPtr), &dpcm->pos);
+			}
+			else{
+				nReadAddSize = ring_valid_data(0, runtime->buffer_size, dpcm->nPreHWPtr, dpcm->nHWPtr);
+
+				vfs_write(dpcm->fp, runtime->dma_area + frames_to_bytes(runtime, dpcm->nPreHWPtr), frames_to_bytes(runtime, runtime->buffer_size - dpcm->nPreHWPtr), &dpcm->pos);
+				vfs_write(dpcm->fp, runtime->dma_area, frames_to_bytes(runtime, nReadAddSize - (runtime->buffer_size - dpcm->nPreHWPtr)), &dpcm->pos);
+			}
+			set_fs(dpcm->fs);
+		}
+#endif
+
+		// update HW read size
+		if (dpcm->nHWPtr != dpcm->nPreHWPtr)
+		{
+			nReadAddSize = ring_valid_data(0, runtime->buffer_size, dpcm->nPreHWPtr, dpcm->nHWPtr);
+
+			/* Control the rp for application.
+			 * 1. If data more than half buffer means the ability is enough,
+			 *    we can update length of the half buffer to rp.
+			 * 2. If data less than half buffer means the ability is not enough,
+			 *    we just update one period size length to rp avoiding SW-3490 problem.
+			 */
+			if (nReadAddSize > (runtime->buffer_size >> 1))
+			{
+				nReadAddSize = runtime->buffer_size >> 1;
+				dpcm->nHWPtr = ring_add(0, runtime->buffer_size, dpcm->nPreHWPtr, nReadAddSize);
+				//ALSA_WARNING("[ALSA maybe hang because Jitter %d, runtime->buffer size %d]\n", (int)nReadAddSize, (int)runtime->buffer_size);
+			}
+			else if (nReadAddSize <= (runtime->buffer_size >> 1) && nReadAddSize >= runtime->period_size)
+			{
+				nReadAddSize = runtime->period_size;
+				dpcm->nHWPtr = ring_add(0, runtime->buffer_size, dpcm->nPreHWPtr, nReadAddSize);
+				//ALSA_WARNING("[ALSA maybe hang because Jitter %d, runtime->buffer size %d]\n", (int)nReadAddSize, (int)runtime->buffer_size);
+			}
+
+			dpcm->nHWReadSize += nReadAddSize;
+			dpcm->nTotalRead = ring_add(0,
+				runtime->boundary,
+				dpcm->nTotalRead,
+				nReadAddSize);
+		}
+
+		// update wp (the pointer application send data to alsa)
+		nPeriodCount = ring_valid_data(0, runtime->boundary, dpcm->nTotalWrite, runtime->control->appl_ptr) / runtime->period_size;
+
+		if (nPeriodCount == runtime->periods)
+			nPeriodCount--;
+
+		//printk("\033[0;33;33m [INRING LE %d] base %x limit %x\033[m\n",
+		//    __LINE__, dpcm->decInRing_LE[0].beginAddr, dpcm->decInRing_LE[0].beginAddr + dpcm->decInRing_LE[0].size);
+		//printk("\033[0;33;33m [INRING LE %d] wp %x rp %x HWRingRp %x\033[m\n",
+		//    __LINE__, dpcm->decInRing_LE[0].writePtr, dpcm->decInRing_LE[0].readPtr[0], HWRingRp);
+
+		// Check the buffer available size between alsa and AFW
+		HWRingFreeSize = valid_free_size(dpcm->decInRing_LE[0].beginAddr,
+			dpcm->decInRing_LE[0].beginAddr + dpcm->decInRing_LE[0].size,
+			HWRingRp,
+			dpcm->decInRing_LE[0].writePtr);
+
+		HWRingFreeFrame = bytes_to_frames(runtime, HWRingFreeSize);
+
+		if ((runtime->period_size * nPeriodCount) > HWRingFreeFrame)
+			nPeriodCount = HWRingFreeFrame / runtime->period_size;
+
+		if (HWRingFreeSize <= dpcm->nPeriodBytes)
+			nPeriodCount = 0;
+
+		if (nPeriodCount)
+		{
+			//printk("[INRING LE] wp %x update 0x%x bytes\n", dpcm->decInRing_LE[0].writePtr, frames_to_bytes(runtime, runtime->period_size * nPeriodCount));
+			dpcm->decInRing_LE[0].writePtr = ring_add(dpcm->decInRing_LE[0].beginAddr
+				, dpcm->decInRing_LE[0].beginAddr + dpcm->decInRing_LE[0].size
+				, dpcm->decInRing_LE[0].writePtr
+				, frames_to_bytes(runtime, runtime->period_size * nPeriodCount));
+
+			dpcm->nTotalWrite = ring_add(0,
+				runtime->boundary,
+				dpcm->nTotalWrite,
+				runtime->period_size * nPeriodCount);
+
+			// update wp (tell AFW the write pointer from application is update)
+			dpcm->decInRing[0].writePtr = htonl(dpcm->decInRing_LE[0].writePtr);//record physical address
+			//printk("\033[0;33;33m [INRING LE %d update] wp %x rp %x\033[m\n", __LINE__, dpcm->decInRing_LE[0].writePtr, dpcm->decInRing_LE[0].readPtr[0]);
+		}
+
+		//printk("[nReadAddSize %d pre %d cur %d %d]\n", nReadAddSize, dpcm->nPreHWPtr, dpcm->nHWPtr, dpcm->nHWReadSize);
+		//printk("[nTotalWrite %d nTotalRead %d nPeriodCount %d]\n", dpcm->nTotalWrite, dpcm->nTotalRead, nPeriodCount);
+
+		if (runtime->status->state == SNDRV_PCM_STATE_DRAINING) {
+			switch (dpcm->nEOSState) {
+				case SND_REALTEK_EOS_STATE_NONE:
+					if (RPC_TOAGENT_INBAND_EOS_SVC(dpcm) < 0)
+					{
+						ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+					}
+					dpcm->nEOSState = SND_REALTEK_EOS_STATE_FINISH;
+					break;
+				case SND_REALTEK_EOS_STATE_FINISH:
+					if (dpcm->nTotalWrite == dpcm->nTotalRead)
+					{
+						DEBUG_CODE("[snd_pcm_period_elapsed]\n");
+						dpcm->nHWReadSize = 0;
+						snd_pcm_period_elapsed(substream);
+					}
+					break;
+				default:
+					break;
+			}
+		} else {
+			if (dpcm->nHWReadSize >= runtime->period_size) {
+				dpcm->nHWReadSize %= runtime->period_size;
+				DEBUG_CODE("[snd_pcm_period_elapsed]\n");
+				snd_pcm_period_elapsed(substream);
+			}
+		}
+
+		// check if wp and rp of android and AFW both stop
+		if (dpcm->nHWPtr == dpcm->nPreHWPtr && runtime->control->appl_ptr == dpcm->nPre_appl_ptr)
+			dbg_count++;
+		else
+			dbg_count = 0;
+
+		if (dbg_count >= (HZ << 1))
+		{
+			ALSA_WARNING("[state %d]\n", (int)runtime->status->state);
+			ALSA_WARNING("[runtime->control->appl_ptr %d runtime->status->hw_ptr %d]\n", (int)runtime->control->appl_ptr, (int)runtime->status->hw_ptr);
+			ALSA_WARNING("[dpcm->nTotalWrite %d dpcm->nTotalRead %d dpcm->nHWPtr %d]\n", (int)dpcm->nTotalWrite, (int)dpcm->nTotalRead, (int)dpcm->nHWPtr);
+			ALSA_WARNING("[b %x l %x w %x r %x]\n",
+				(unsigned int)(ntohl(dpcm->decInRing[0].beginAddr)),
+				(unsigned int)((ntohl(dpcm->decInRing[0].beginAddr)) + dpcm->decInRing_LE[0].size),
+				(unsigned int)(ntohl(dpcm->decInRing[0].writePtr)),
+				(unsigned int)(ntohl(dpcm->decInRing[0].readPtr[0])));
+			ALSA_WARNING("[HWRingRp %x nPeriodCount %d runtime->periods %d]\n", HWRingRp, nPeriodCount, runtime->periods);
+			ALSA_WARNING("[snd_pcm_playback_avail %d runtime->control->avail_min %d]\n", (int)snd_pcm_playback_avail(runtime), (int)runtime->control->avail_min);
+			dbg_count = 0;
+		}
+
+		dpcm->nPreHWPtr = dpcm->nHWPtr;
+		dpcm->nPre_appl_ptr = runtime->control->appl_ptr;
+
+		/* Set up the next time */
+		hrtimer_forward_now(timer, dpcm->ktime);
+
+		return HRTIMER_RESTART;
+	}
+	else
+	{
+		return HRTIMER_NORESTART;
+	}
+}
+
+static int snd_card_capture_trigger(snd_pcm_substream_t * substream, int cmd)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+	int ret = 0;
+	unsigned long flags;
+
+	// error checking
+	if(snd_pcm_capture_avail(runtime) > runtime->buffer_size
+		|| snd_pcm_capture_hw_avail(runtime) > runtime->buffer_size)
+	{
+		ALSA_WARNING("[WARNING %d %s %s %d]\n", cmd, __FILE__, __FUNCTION__, __LINE__);
+		ALSA_WARNING("[state %d appl_ptr %d hw_ptr %d %d]\n", runtime->status->state, (int)runtime->control->appl_ptr, (int)runtime->status->hw_ptr, (int)runtime->buffer_size);
+	}
+
+	switch(cmd)
+	{
+		case SNDRV_PCM_TRIGGER_START:
+			printk("[ALSA trigger start appl_ptr %d hw_ptr %d]\n", (int)runtime->control->appl_ptr, (int)runtime->status->hw_ptr);
+			dpcm->enHRTimer = HRTIMER_RESTART;
+			hrtimer_start(&dpcm->hr_timer, dpcm->ktime, HRTIMER_MODE_REL);
+			break;
+		case SNDRV_PCM_TRIGGER_STOP:
+			printk("[ALSA trigger stop appl_ptr %d hw_ptr %d]\n", (int)runtime->control->appl_ptr, (int)runtime->status->hw_ptr);
+			spin_lock_irqsave(&capture_lock, flags);
+			dpcm->enHRTimer = HRTIMER_NORESTART;
+			spin_unlock_irqrestore(&capture_lock, flags);
+			hrtimer_try_to_cancel(&dpcm->hr_timer);
+			break;
+		default:
+			ret = -EINVAL;
+	}
+
+	return ret;
+}
+
+static int snd_card_playback_trigger(snd_pcm_substream_t * substream, int cmd)
+{
+	snd_pcm_runtime_t *runtime = substream->runtime;
+	snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+	int ret = 0;
+	unsigned long flags;
+
+	if (cmd != SNDRV_PCM_TRIGGER_SUSPEND && is_suspend) {
+		ALSA_VitalPrint("[ALSA %s %d] suspend\n", __FUNCTION__, __LINE__);
+		return 0;
+	}
+
+	// error checking
+	if (snd_pcm_playback_avail(runtime) > runtime->buffer_size
+		|| snd_pcm_playback_hw_avail(runtime) > runtime->buffer_size)
+	{
+		ALSA_WARNING("[WARNING %s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+		ALSA_WARNING("[state %d appl_ptr %d hw_ptr %d]\n", runtime->status->state, (int)runtime->control->appl_ptr, (int)runtime->status->hw_ptr);
+		ALSA_WARNING("[dpcm->nTotalWrite %d dpcm->nTotalRead %d]\n", (int)dpcm->nTotalWrite, (int)dpcm->nTotalRead);
+	}
+
+	switch(cmd)
+	{
+		case SNDRV_PCM_TRIGGER_STOP:
+			spin_lock_irqsave(&playback_lock, flags);
+			dpcm->enHRTimer = HRTIMER_NORESTART;
+			spin_unlock_irqrestore(&playback_lock, flags);
+			hrtimer_try_to_cancel(&dpcm->hr_timer);
+			break;
+
+		case SNDRV_PCM_TRIGGER_START:
+			dpcm->enHRTimer = HRTIMER_RESTART;
+			hrtimer_start(&dpcm->hr_timer, dpcm->ktime, HRTIMER_MODE_REL);
+			break;
+
+		case SNDRV_PCM_TRIGGER_PAUSE_PUSH:
+			spin_lock_irqsave(&playback_lock, flags);
+			dpcm->enHRTimer = HRTIMER_NORESTART;
+			spin_unlock_irqrestore(&playback_lock, flags);
+			break;
+
+		case SNDRV_PCM_TRIGGER_PAUSE_RELEASE:
+			dpcm->enHRTimer = HRTIMER_RESTART;
+			hrtimer_start(&dpcm->hr_timer, dpcm->ktime, HRTIMER_MODE_REL);
+			break;
+
+		case SNDRV_PCM_TRIGGER_SUSPEND:
+			spin_lock_irqsave(&playback_lock, flags);
+			ALSA_WARNING("[+]SNDRV_PCM_TRIGGER_SUSPEND\n");
+			dpcm->enHRTimer = HRTIMER_NORESTART;
+			ALSA_WARNING("[-]SNDRV_PCM_TRIGGER_SUSPEND\n");
+			spin_unlock_irqrestore(&playback_lock, flags);
+			break;
+
+		case SNDRV_PCM_TRIGGER_RESUME:
+			ALSA_WARNING("[+]SNDRV_PCM_TRIGGER_RESUME\n");
+			dpcm->enHRTimer = HRTIMER_RESTART;
+			hrtimer_start(&dpcm->hr_timer, dpcm->ktime, HRTIMER_MODE_REL);
+			ALSA_WARNING("[-]SNDRV_PCM_TRIGGER_RESUME\n");
+			break;
+
+		default:
+			ALSA_WARNING("[err %d %s %d]\n", cmd, __FUNCTION__, __LINE__);
+			ret = -EINVAL;
+	}
+
+	return ret;
+}
+
+static int snd_card_hw_params(snd_pcm_substream_t * substream, snd_pcm_hw_params_t * hw_params)
+{
+    //ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+    int err;
+    //ALSA_VitalPrint("[ALSA %s demand %d Bytes]\n", __FUNCTION__, params_buffer_bytes(hw_params));
+    TRACE_CODE("[ALSA %s demand %d Bytes]\n", __FUNCTION__, params_buffer_bytes(hw_params));
+    err = snd_pcm_lib_malloc_pages(substream, params_buffer_bytes(hw_params));
+    if (err != 0 && err != 1) {
+        ALSA_WARNING("[fail %s %d]\n", __FUNCTION__, __LINE__);
+    }
+    return err;
+}
+
+static int snd_card_capture_hw_free(snd_pcm_substream_t * substream)
+{
+    DEBUG_CODE("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+    return snd_pcm_lib_free_pages(substream);
+}
+
+static int snd_card_hw_free(snd_pcm_substream_t * substream)
+{
+    TRACE_CODE("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+    return snd_pcm_lib_free_pages(substream);
+}
+
+static unsigned long ring_valid_data(unsigned long ring_base, unsigned long ring_limit, unsigned long ring_rp, unsigned long ring_wp)
+{
+	if (ring_wp >= ring_rp)
+	{
+		return (ring_wp-ring_rp);
+	}
+	else
+	{
+		return (ring_limit-ring_base)-(ring_rp-ring_wp);
+	}
+}
+
+static unsigned long ring_add(unsigned long ring_base, unsigned long ring_limit, unsigned long ptr, unsigned int bytes)
+{
+	ptr += bytes;
+	if (ptr >= ring_limit)
+	{
+		ptr = ring_base + (ptr-ring_limit);
+	}
+	return ptr;
+}
+
+static unsigned long ring_minus(unsigned long ring_base, unsigned long ring_limit, unsigned long ptr, int bytes)
+{
+	ptr -= bytes;
+
+	if (ptr < ring_base)
+		ptr = ring_limit-(ring_base-ptr);
+
+	return ptr;
+}
+
+static unsigned long valid_free_size(unsigned long base, unsigned long limit, unsigned long rp, unsigned long wp)
+{
+	return (limit-base)-ring_valid_data(base,limit,rp,wp)-1;
+}
+
+static int ring_check_ptr_valid_32(unsigned int ring_rp, unsigned int ring_wp, unsigned int ptr)
+{
+	if (ring_wp >= ring_rp)
+	{
+		return (ptr < ring_wp && ptr >= ring_rp);
+	}
+	else
+	{
+		return (ptr >= ring_rp || ptr < ring_wp);
+	}
+}
+
+static unsigned long buf_memcpy2_ring(unsigned long base, unsigned long limit, unsigned long ptr, char* buf, unsigned long size)
+{
+	if (ptr + size <= limit)
+	{
+		memcpy((char*)ptr,buf,size);
+	}
+	else
+	{
+		int i = limit-ptr;
+		memcpy((char*)ptr,(char*)buf,i);
+		memcpy((char*)base,(char*)(buf+i),size-i);
+	}
+
+	ptr += size;
+	if (ptr >= limit)
+	{
+		ptr = base + (ptr-limit);
+	}
+	return ptr;
+}
+
+// create PCM instance
+static int __init snd_card_create_PCM_instance(
+RTK_snd_card_t *pSnd,
+int instance_idx,
+int playback_substreams,
+int capture_substreams)
+{
+	snd_pcm_t *pcm = NULL;
+	struct snd_pcm_substream *p = NULL;
+	int err;
+	int i;
+
+	printk("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+	RTK_TRACE_ALSA("%d %d @ %s %d\n", playback_substreams, capture_substreams, __func__, __LINE__);
+
+	// create PCM instance
+	if ((err = snd_pcm_new(pSnd->card
+		, snd_pcm_id[instance_idx] /* id string */
+		, instance_idx
+		, playback_substreams
+		, capture_substreams
+		, &pcm)) < 0)    // for Jupiter Capture Count = 0 (ie. there is no ain)
+	{
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		return err;
+	}
+
+	// set OPs
+	switch(instance_idx)
+	{
+		case 0:
+			snd_pcm_set_ops(pcm, SNDRV_PCM_STREAM_PLAYBACK, &snd_card_rtk_playback_ops);
+			snd_pcm_set_ops(pcm, SNDRV_PCM_STREAM_CAPTURE, &snd_card_rtk_capture_ops);
+			sprintf(pcm->name, SND_REALTEK_DRIVER);
+			break;
+		case 1:
+			snd_pcm_set_ops(pcm, SNDRV_PCM_STREAM_CAPTURE, &snd_card_rtk_capture_i2s_ops);
+			sprintf(pcm->name, SND_REALTEK_DRIVER_I2S_IN);
+			break;
+		case 2:
+			snd_pcm_set_ops(pcm, SNDRV_PCM_STREAM_CAPTURE, &snd_card_rtk_capture_nonpcm_ops);
+			sprintf(pcm->name, SND_REALTEK_DRIVER_NONPCM_IN);
+			break;
+		case 3:
+			snd_pcm_set_ops(pcm, SNDRV_PCM_STREAM_CAPTURE, &snd_card_rtk_capture_audio_ops);
+			sprintf(pcm->name, SND_REALTEK_DRIVER_AUDIO_IN);
+			break;
+		case 4:
+			snd_pcm_set_ops(pcm, SNDRV_PCM_STREAM_CAPTURE, &snd_card_rtk_capture_audio_v2_ops);
+			sprintf(pcm->name, SND_REALTEK_DRIVER_AUDIO_V2_IN);
+			break;
+		case 5:
+			snd_pcm_set_ops(pcm, SNDRV_PCM_STREAM_CAPTURE, &snd_card_rtk_capture_audio_v3_ops);
+			sprintf(pcm->name, SND_REALTEK_DRIVER_AUDIO_V3_IN);
+			break;
+		case 6:
+			snd_pcm_set_ops(pcm, SNDRV_PCM_STREAM_CAPTURE, &snd_card_rtk_capture_audio_v4_ops);
+			sprintf(pcm->name, SND_REALTEK_DRIVER_AUDIO_V4_IN);
+			break;
+		default:
+			ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+			break;
+	}
+
+	pcm->private_data = pSnd;
+	pcm->info_flags = 0;
+
+	p = pcm->streams[SNDRV_PCM_STREAM_PLAYBACK].substream;
+	for (i = 0; i < playback_substreams; i++)
+	{
+		p->dma_buffer.dev.dev = snd_dma_continuous_data(GFP_KERNEL);
+#ifdef USE_ION_AUDIO_HEAP
+		p->dma_buffer.dev.type = SNDRV_DMA_TYPE_ION_PLAYBACK;
+#else
+		p->dma_buffer.dev.type = SNDRV_DMA_TYPE_CONTINUOUS;
+#endif
+		p = p->next;
+	}
+
+	p = pcm->streams[SNDRV_PCM_STREAM_CAPTURE].substream;
+	for (i = 0; i < capture_substreams; i++)
+	{
+		p->dma_buffer.dev.dev = snd_dma_continuous_data(GFP_KERNEL);
+#ifdef USE_ION_AUDIO_HEAP
+		p->dma_buffer.dev.type = SNDRV_DMA_TYPE_ION_CAPTURE;
+#else
+		p->dma_buffer.dev.type = SNDRV_DMA_TYPE_CONTINUOUS;
+#endif
+		p = p->next;
+	}
+
+	snd_pcm_add_chmap_ctls(pcm, SNDRV_PCM_STREAM_PLAYBACK,snd_pcm_alt_chmaps, 8, 0, NULL);
+	pSnd->pcm = pcm;
+
+#if 0
+	/* NOTE: this may fail */
+	if (err = snd_pcm_lib_preallocate_pages_for_all(pcm,
+			SNDRV_DMA_TYPE_CONTINUOUS,
+			snd_dma_continuous_data(GFP_KERNEL),
+			32*1024,
+			32*1024))
+	{
+		printk("snd_pcm_lib_preallocate_pages failed\n");
+	}
+#endif
+
+	return 0;
+}
+
+void snd_realtek_hw_playback_volume_work(struct work_struct *work) {
+	RTK_snd_card_t *mars = container_of(work, RTK_snd_card_t, work_volume);
+	printk("[%s %d]\n", __FUNCTION__, __LINE__);
+	RPC_TOAGENT_SET_VOLUME(mars->mixer_volume[MIXER_ADDR_MASTER][0]);
+}
+
+static int __init snd_card_mars_new_mixer(RTK_snd_card_t * pRTK_card)
+{
+    snd_card_t *card = pRTK_card->card;
+    unsigned int idx;
+    int err;
+
+    spin_lock_init(&pRTK_card->mixer_lock);
+    INIT_WORK(&pRTK_card->work_volume, snd_realtek_hw_playback_volume_work);
+    
+    strcpy(card->mixername, "RTK_Mixer");
+
+    // add snc_control
+    for (idx = 0; idx < ARRAY_SIZE(snd_mars_controls); idx++) {
+        if ((err = snd_ctl_add(card, snd_ctl_new1(&snd_mars_controls[idx], pRTK_card))) < 0)
+        {
+            ALSA_WARNING("[snd_ctl_add faile %s %d]\n", __FUNCTION__, __LINE__);
+            return err;
+        }
+    }
+    return 0;
+}
+
+static int snd_RTK_volume_info(snd_kcontrol_t * kcontrol, snd_ctl_elem_info_t * uinfo)
+{
+    //printk("[ALSA %s %d\n", __FUNCTION__, __LINE__);
+    uinfo->type = SNDRV_CTL_ELEM_TYPE_INTEGER;
+    // Jupiter only Master Volume can control
+    uinfo->count = 2;
+    uinfo->value.integer.min = 0;
+    uinfo->value.integer.max = 31;
+    return 0;
+}
+
+static int snd_RTK_volume_get(snd_kcontrol_t * kcontrol, snd_ctl_elem_value_t * ucontrol)
+{
+    RTK_snd_card_t *mars = snd_kcontrol_chip(kcontrol);
+    unsigned long flags;
+    int addr = kcontrol->private_value;
+
+    //printk("[ALSA %s %d\n", __FUNCTION__, __LINE__);
+
+    spin_lock_irqsave(&mars->mixer_lock, flags);
+    switch(addr) {
+        case MIXER_ADDR_MASTER:
+            mars->mixer_volume[addr][1] = mars->mixer_volume[addr][0] ;
+            break;
+        default:
+            break;
+    }
+    ucontrol->value.integer.value[0] = mars->mixer_volume[addr][0];
+    ucontrol->value.integer.value[1] = mars->mixer_volume[addr][1];
+    spin_unlock_irqrestore(&mars->mixer_lock, flags);
+    return 0;
+}
+
+#define cpy_func(dst, src, size, dmem_buf) memcpy(dst, src, size)
+
+static void ring1_to_ring2_general_64(AUDIO_RINGBUF_PTR_64* ring1, AUDIO_RINGBUF_PTR_64* ring2, long size, char* dmem_buf)
+{
+    if (ring1->rp + size <= ring1->limit)
+    {
+        if (ring2->wp + size <= ring2->limit)
+        {
+                        
+            cpy_func((char*)ring2->wp,(char*)ring1->rp,size,dmem_buf);          
+        }
+        else
+        {
+            int i = ring2->limit-ring2->wp;
+            cpy_func((char*)ring2->wp,(char*)ring1->rp,i,dmem_buf);
+            cpy_func((char*)ring2->base,(char*)(ring1->rp+i),size-i,dmem_buf);
+
+        }
+    }
+    else
+    {
+        if (ring2->wp + size <= ring2->limit)
+        {
+            int i = ring1->limit-ring1->rp;
+            cpy_func((char*)ring2->wp,(char*)ring1->rp,i,dmem_buf);
+            cpy_func((char*)(ring2->wp+i),(char*)(ring1->base),size-i,dmem_buf);
+        }
+        else
+        {
+            int i,j;
+            i = ring1->limit-ring1->rp;
+            j = ring2->limit-ring2->wp;
+            if (j <= i)
+            {
+                cpy_func((char*)ring2->wp,(char*)ring1->rp,j,dmem_buf);
+                cpy_func((char*)ring2->base,(char*)(ring1->rp+j),i-j,dmem_buf);
+                cpy_func((char*)(ring2->base+i-j),(char*)(ring1->base),size-i,dmem_buf);
+            }
+            else
+            {
+                cpy_func((char*)ring2->wp,(char*)ring1->rp,i,dmem_buf);
+                cpy_func((char*)(ring2->wp+i),(char*)ring1->base,j-i,dmem_buf);
+                cpy_func((char*)ring2->base,(char*)(ring1->base+j-i),size-j,dmem_buf);
+            }
+        }       
+    }
+    
+    ring1->rp += size;
+    if (ring1->rp >= ring1->limit)
+    {
+        ring1->rp = ring1->base + (ring1->rp-ring1->limit);
+    }
+
+    ring2->wp += size;
+    if (ring2->wp >= ring2->limit)
+    {
+        ring2->wp = ring2->base + (ring2->wp-ring2->limit);
+    }   
+}
+
+
+static int snd_RTK_volume_put(snd_kcontrol_t * kcontrol, snd_ctl_elem_value_t * ucontrol)
+{
+    RTK_snd_card_t *mars = snd_kcontrol_chip(kcontrol);
+    unsigned long flags;
+    int change, addr = kcontrol->private_value;
+    int master;
+
+    //printk("[ALSA %s %d\n", __FUNCTION__, __LINE__);
+
+    master = ucontrol->value.integer.value[0];
+    if (master < 0) {
+        master = 0;
+    } 
+    if (master > 31) {
+        master = 31; 
+    }
+    
+    spin_lock_irqsave(&mars->mixer_lock, flags);
+    change = mars->mixer_volume[addr][0] != master;
+    mars->mixer_volume[addr][0] = master;
+    mars->mixer_volume[addr][1] = master;
+    spin_unlock_irqrestore(&mars->mixer_lock, flags);
+    if (addr ==MIXER_ADDR_MASTER) { 
+        schedule_work(&mars->work_volume);
+    }
+        
+    return change;
+}
+
+static int snd_RTK_capsrc_info(snd_kcontrol_t * kcontrol, snd_ctl_elem_info_t * uinfo)
+{
+    //printk("[ALSA %s %d\n", __FUNCTION__, __LINE__);
+    uinfo->type = SNDRV_CTL_ELEM_TYPE_BOOLEAN;
+    uinfo->count = 2;
+    uinfo->value.integer.min = 0;
+    uinfo->value.integer.max = 1;
+    return 0;
+}
+ 
+static int snd_RTK_capsrc_get(snd_kcontrol_t * kcontrol, snd_ctl_elem_value_t * ucontrol)
+{
+    RTK_snd_card_t *mars = snd_kcontrol_chip(kcontrol);
+    unsigned long flags;
+    int addr = kcontrol->private_value;
+
+    //printk("[ALSA %s %d\n", __FUNCTION__, __LINE__);
+    spin_lock_irqsave(&mars->mixer_lock, flags);
+    ucontrol->value.integer.value[0] = mars->capture_source[addr][0];
+    ucontrol->value.integer.value[1] = mars->capture_source[addr][1];
+    spin_unlock_irqrestore(&mars->mixer_lock, flags);
+    return 0;
+}
+
+static int snd_RTK_capsrc_put(snd_kcontrol_t * kcontrol, snd_ctl_elem_value_t * ucontrol)
+{
+    RTK_snd_card_t *mars = snd_kcontrol_chip(kcontrol);
+    unsigned long flags;
+    int change, addr = kcontrol->private_value;
+    int left, right;
+    //printk("[ALSA %s %d\n", __FUNCTION__, __LINE__);
+
+    left = ucontrol->value.integer.value[0] & 1;
+    right = ucontrol->value.integer.value[1] & 1;
+    spin_lock_irqsave(&mars->mixer_lock, flags);
+    change = mars->capture_source[addr][0] != left &&
+             mars->capture_source[addr][1] != right;
+    mars->capture_source[addr][0] = left;
+    mars->capture_source[addr][1] = right;
+    spin_unlock_irqrestore(&mars->mixer_lock, flags);
+    return change;
+}
+
+#ifdef CONFIG_SYSFS
+
+static ssize_t alsa_latency_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    int mLatency = 0;
+    mLatency = snd_monitor_audio_data_queue();
+
+    return sprintf(buf, "%u\n", mLatency);
+}
+
+static ssize_t alsa_raw_delay_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    int mRawDelay = 0;
+    mRawDelay = snd_monitor_raw_data_queue();
+
+    return sprintf(buf, "%u\n", mRawDelay);
+}
+
+static ssize_t alsa_active_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    return sprintf(buf, "%u\n", rtk_dec_ao_buffer);
+}
+
+static ssize_t alsa_active_store(struct kobject *kobj, struct kobj_attribute *attr, const char *buf, size_t count)
+{
+    unsigned long val;
+
+    if (kstrtoul(buf, 10, &val) < 0)
+        return -EINVAL;
+
+    //ALSA_VitalPrint("rtk_dec_ao value %d\n", val);
+    if (val >= 4096 && val <= (12*1024))
+        rtk_dec_ao_buffer = val;
+    else
+        ALSA_WARNING("set dec_ao_buffer failed! (size must be from 4k to 12k)\n");
+
+    return count;
+}
+
+static struct kobj_attribute alsa_active_attr =
+    __ATTR(dec_ao_buffer_size, 0644, alsa_active_show, alsa_active_store);
+
+static struct kobj_attribute alsa_latency_attr =
+    __ATTR(latency, 0444, alsa_latency_show, NULL);
+
+static struct kobj_attribute alsa_raw_delay_attr =
+    __ATTR(rawdelay, 0444, alsa_raw_delay_show, NULL);
+
+static struct attribute *alsa_attrs[] = {
+    &alsa_active_attr.attr,
+    &alsa_latency_attr.attr,
+    &alsa_raw_delay_attr.attr,
+    NULL,
+};
+
+static struct attribute_group rtk_alsa_attr_group = {
+    .attrs = alsa_attrs,
+};
+
+static struct kobject *alsa_kobj;
+
+static int __init alsa_sysfs_init(void)
+{
+    int ret;
+
+    alsa_kobj = kobject_create_and_add("rtk_alsa", kernel_kobj);
+    if (!alsa_kobj)
+        return -ENOMEM;
+    ret = sysfs_create_group(alsa_kobj, &rtk_alsa_attr_group);
+    if (ret)
+        kobject_put(alsa_kobj);
+    return ret;
+}
+#endif
+
+static int snd_card_probe(struct platform_device *devptr)
+{
+    snd_card_t *card;
+    RTK_snd_card_t *pRTKSnd;
+    int dev = devptr->id;
+    int idx, err;
+
+    TRACE_CODE("[%s %s %d] dev %d\n", __FILE__, __FUNCTION__, __LINE__, dev);
+    RTK_TRACE_ALSA("[+] @ %s\n", __func__);
+
+    // create sound card
+    RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+    err = snd_card_new(
+        &devptr->dev,
+        -1, /* -1 ; idx == -1 == 0xffff means: take any free slot*/
+        SND_REALTEK_DRIVER, /* describe ID string of sound card */
+        THIS_MODULE,
+        sizeof(RTK_snd_card_t), // size of private_data
+        &card);
+    RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+    if (err < 0)
+        return err;
+
+    // private data
+    pRTKSnd = (RTK_snd_card_t *)card->private_data;
+    pRTKSnd->card = card;
+
+    for (idx = 0; idx < MAX_PCM_DEVICES ; idx++)
+    {
+        // create PCM instance
+        RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+        if ((err = snd_card_create_PCM_instance(pRTKSnd, idx
+            , pcm_substreams[dev], pcm_capture_substreams[dev])) < 0)
+        {
+            ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+            goto __nodev;
+        }
+        RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+
+        // create Compress instance
+        if ((err = snd_card_create_compress_instance(pRTKSnd, idx)) < 0) {
+            ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+            goto __nodev;
+        }
+    }
+
+	// create another instance ONLY for capture AI I2S in
+	snd_card_create_PCM_instance(pRTKSnd, 1, 0, 1);
+
+	// create instance ONLY for capture AI nonpcm in
+	snd_card_create_PCM_instance(pRTKSnd, 2, 0, 1);
+
+	// create instance ONLY for capture AI audio in
+	snd_card_create_PCM_instance(pRTKSnd, 3, 0, 1);
+
+	// create instance ONLY for capture AI audio v2 in
+	snd_card_create_PCM_instance(pRTKSnd, 4, 0, 1);
+
+	// create instance ONLY for capture AI audio v3 in
+	snd_card_create_PCM_instance(pRTKSnd, 5, 0, 1);
+
+    RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+    if ((err = snd_card_mars_new_mixer(pRTKSnd)) < 0)
+        goto __nodev;
+    RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+
+    strcpy(card->driver, SND_REALTEK_DRIVER);
+    strcpy(card->shortname, SND_REALTEK_DRIVER);
+    sprintf(card->longname, SND_REALTEK_DRIVER);
+
+    RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+    if ((err = snd_card_register(card)) == 0) {
+        snd_RTK_cards[dev] = card;
+        platform_set_drvdata(devptr, card);
+        RTK_TRACE_ALSA("[-] @ %s %d\n", __func__, __LINE__);
+        return 0;
+    }
+
+    // error handling
+__nodev:
+    ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+    snd_card_free(card);
+    return err;
+}
+
+static int snd_card_remove(struct platform_device *devptr)
+{
+    struct snd_card *card = platform_get_drvdata(devptr);
+
+    RTK_TRACE_ALSA("[+] @ %s\n", __func__);
+    if (card) {
+        RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+        snd_card_free(card);
+        RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+        platform_set_drvdata(devptr, NULL);
+        RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+    }
+
+    RTK_TRACE_ALSA("[-] @ %s\n", __func__);
+    return 0;
+}
+
+#ifdef CONFIG_PM
+static int rtk_alsa_suspend(struct device *pdev)
+{
+    struct snd_card *card = dev_get_drvdata(pdev);
+
+    //snd_card_t *card = snd_RTK_cards[0];
+    struct RTK_snd_card *pRTKSnd = card->private_data;
+
+    ALSA_VitalPrint("[+]%s %d\n", __FUNCTION__, __LINE__);
+    snd_power_change_state(card, SNDRV_CTL_POWER_D3hot);
+
+    is_suspend = true;
+    snd_pcm_suspend_all(pRTKSnd->pcm);
+
+    ALSA_VitalPrint("[-]%s %d\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+static int rtk_alsa_resume(struct device *pdev)
+{
+    struct snd_card *card = dev_get_drvdata(pdev);
+
+    ALSA_VitalPrint("[+]%s %d\n", __FUNCTION__, __LINE__);
+    snd_power_change_state(card, SNDRV_CTL_POWER_D0);
+    is_suspend = false;
+
+    ALSA_VitalPrint("[-]%s %d\n", __FUNCTION__, __LINE__);
+    return 0;
+}
+
+static SIMPLE_DEV_PM_OPS(rtk_alsa_pm, rtk_alsa_suspend, rtk_alsa_resume);
+#define RTK_ALSA_PM_OPS &rtk_alsa_pm
+#else
+#define RTK_ALSA_PM_OPS NULL
+#endif
+
+static struct platform_driver rtk_alsa_driver = {
+    .probe      = snd_card_probe,
+    .remove     = snd_card_remove,
+    .driver     = {
+        .name   = SND_REALTEK_DRIVER,
+        .owner  = THIS_MODULE,
+        .pm     = RTK_ALSA_PM_OPS,
+    },
+};
+
+static void rtk_alsa_unregister_all(void)
+{
+    int i;
+
+    ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+
+    for(i = 0; i < ARRAY_SIZE(devices); ++i)
+        platform_device_unregister(devices[i]);
+    platform_driver_unregister(&rtk_alsa_driver);
+}
+
+static int __init RTK_alsa_card_init(void)
+{
+    int i, cards, ret, err;
+#ifdef CONFIG_RTK_XEN_SUPPORT
+    if (xen_domain() && xen_initial_domain()) {
+        RTK_TRACE_ALSA("%s: skip on dom0\n", __func__);
+        return 0;
+    }
+#endif
+    RTK_TRACE_ALSA("[+] @ %s\n", __func__);
+    //ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+    err = platform_driver_register(&rtk_alsa_driver);
+    RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+    if (err < 0)
+        goto RETURN_ERR;
+
+#ifdef USE_ION_AUDIO_HEAP
+	if (IS_ERR_OR_NULL(rtk_phoenix_ion_device))
+		goto RETURN_ERR;
+    alsa_client = ion_client_create(rtk_phoenix_ion_device, "ALSADriver");
+#endif
+
+#ifdef CONFIG_SYSFS
+    ret = alsa_sysfs_init();
+    if (ret)
+        ALSA_VitalPrint("%s: unable to create sysfs entry\n", __FUNCTION__);
+#endif
+
+    cards = 0;
+    for (i = 0; i < SNDRV_CARDS && snd_card_enable[i]; i++)
+    {
+        struct platform_device *device;
+        RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+        device = platform_device_register_simple(SND_REALTEK_DRIVER, i, NULL, 0);
+        RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+
+        if (IS_ERR(device))
+        {
+            continue;
+        }
+
+        RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+        if (!platform_get_drvdata(device)) {
+            platform_device_unregister(device);
+            continue;
+        }
+        RTK_TRACE_ALSA(" @ %s %d\n", __func__, __LINE__);
+
+        devices[i] = device;
+        cards++;
+    }
+
+    if (!cards)
+    {
+        ALSA_VitalPrint("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        rtk_alsa_unregister_all();
+        err = -ENODEV;
+        goto RETURN_ERR;
+    }
+
+    clk90k_vaddr_hi = ioremap(MIS_CLK90K_TM_HI_reg, 4);
+    clk90k_vaddr_lo = ioremap(MIS_CLK90K_TM_LO_reg, 4);
+    sys_clk_en2_virt = ioremap(SYS_CLOCK_ENABLE2, 4);
+
+    RTK_TRACE_ALSA("[-] @ %s %d\n", __func__, __LINE__);
+    return 0;
+
+RETURN_ERR:
+    RTK_TRACE_ALSA("[-] @ %s %d\n", __func__, __LINE__);
+    return err;
+}
+
+static void __exit RTK_alsa_card_exit(void)
+{
+#ifdef CONFIG_RTK_XEN_SUPPORT
+    if (xen_domain() && xen_initial_domain()) {
+        RTK_TRACE_ALSA("%s: skip on dom0\n", __func__);
+        return;
+    }
+#endif
+    //ALSA_VitalPrint("[ALSA %s %d]\n", __FUNCTION__, __LINE__);
+    RTK_TRACE_ALSA("[+] @ %s\n", __func__);
+
+    iounmap(clk90k_vaddr_hi);
+    clk90k_vaddr_hi = NULL;
+    iounmap(clk90k_vaddr_lo);
+    clk90k_vaddr_lo = NULL;
+    iounmap(sys_clk_en2_virt);
+    sys_clk_en2_virt  = NULL;
+
+#ifdef USE_ION_AUDIO_HEAP
+    if (alsa_client != NULL)
+    {
+        printk("%s ion_client_destroy\n", __FUNCTION__);
+        ion_client_destroy(alsa_client);
+    }
+#endif
+
+    rtk_alsa_unregister_all();
+    RTK_TRACE_ALSA("[-] @ %s\n", __func__);
+}
+
+module_init(RTK_alsa_card_init);
+module_exit(RTK_alsa_card_exit);
+
+EXPORT_SYMBOL(snd_realtek_capture_check_hdmirx_enable);
+EXPORT_SYMBOL(snd_realtek_capture_get_stream_name);
diff --git a/sound/arm/snd-realtek.h b/sound/arm/snd-realtek.h
new file mode 100644
index 00000000..79e3d10
--- /dev/null
+++ b/sound/arm/snd-realtek.h
@@ -0,0 +1,1344 @@
+/**
+ * snd-realtek.h - Realtek alsa driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef SND_REALTEK_H
+#define SND_REALTEK_H
+
+#include "snd-realtek_common.h"
+
+//////////////////
+// Main Control //
+//////////////////
+#define USE_ION_AUDIO_HEAP
+#define CAPTURE_USE_PTS_RING
+
+///////////////////
+// Debug Control //
+///////////////////
+//#define _TRACE_CODE
+//#define _DEBUG_CODE
+//#define _SHOW_CONFIG_INFO
+#define _DBG_CHECK_AI_HW_RING_DATA_EN 0
+//#define _TRACE_RPC
+
+///////////
+// Macro //
+///////////
+#ifdef USE_ION_AUDIO_HEAP
+#include "../../drivers/staging/android/ion/ion.h"
+#include "../../drivers/staging/android/uapi/ion_rtk.h"
+extern struct ion_device *rtk_phoenix_ion_device;
+#endif
+
+#define ALSA_CAPTURE_TODO(format, ...) printk(KERN_ALERT "[ALSA CAPTURE NOT IMPLEMENT !!]\n");
+
+#define ALSA_WARNING(format, ...)    \
+{\
+    printk(KERN_ALERT "[ALSA WARNING] ");\
+    printk(KERN_ALERT format, ##__VA_ARGS__);\
+}
+
+#define ALSA_VitalPrint(format, ...) //printk(KERN_ALERT format, ##__VA_ARGS__);
+#define ALSA_DbgPrint(format, ...) printk(KERN_ALERT format, ##__VA_ARGS__);
+
+// debug
+#ifdef _TRACE_CODE
+#define TRACE_CODE(format, ...)    \
+{\
+    printk(KERN_ALERT format, ##__VA_ARGS__);\
+}
+#else
+#define TRACE_CODE(format, ...)
+#endif
+
+#ifdef _TRACE_RPC
+#define TRACE_RPC() printk(KERN_ALERT "�� alsa %s\n", __FUNCTION__);
+#else
+#define TRACE_RPC() 
+#endif
+
+#ifdef _DEBUG_CODE
+#define DEBUG_CODE(format, ...)    \
+{\
+    printk(KERN_ALERT format, ##__VA_ARGS__);\
+}
+#else
+#define DEBUG_CODE(format, ...)
+#endif
+
+#ifdef _SHOW_CONFIG_INFO
+#define SHOW_CONFIG_INFO(format, ...)    \
+{\
+    printk(KERN_ALERT format, ##__VA_ARGS__);\
+}
+#else
+#define SHOW_CONFIG_INFO(format, ...)
+#endif
+
+#define ALSA_PRINT() printk(KERN_ALERT "[���� %s %d]\n", __FUNCTION__, __LINE__);
+
+#define ALSA_SEC_PRINT(sec, format, ...)    \
+{\
+    static long count = 0;\
+    if((jiffies - count) > HZ * sec)\
+    {\
+        count = jiffies;\
+        printk(KERN_ALERT format, ##__VA_ARGS__);\
+    }\
+}
+
+#if _DBG_CHECK_AI_HW_RING_DATA_EN
+#define _DBG_CHECK_AI_HW_RING_DATA_SEC 1
+#define _DBG_CHECK_AI_HW_RING_DATA(data) {\
+    static long count = 0;\
+    if((jiffies - count) > (HZ * _DBG_CHECK_AI_HW_RING_DATA_SEC))\
+    {\
+        snd_card_capture_lpcm_check_ringBuf(data);\
+        count = jiffies;\
+    }\
+}    
+#else
+#define _DBG_CHECK_AI_HW_RING_DATA(data) 
+#endif
+
+#define S_OK        0x10000000
+
+#if defined(CONFIG_ARCH_RTD129x) || defined(CONFIG_ARCH_RTD119X)
+#define CONVERT_FOR_AVCPU(x)        ((unsigned int)(x) | 0xA0000000)
+#else
+#define CONVERT_FOR_AVCPU(x)        (x)
+#endif
+#define AUDIO_ION_FLAG              (ION_FLAG_NONCACHED |ION_FLAG_SCPUACC | ION_FLAG_ACPUACC)
+
+//////////////
+// playback //
+//////////////
+#define RTK_DMP_PLAYBACK_INFO    (SNDRV_PCM_INFO_INTERLEAVED | \
+                         SNDRV_PCM_INFO_NONINTERLEAVED | \
+                         SNDRV_PCM_INFO_RESUME | \
+                         SNDRV_PCM_INFO_PAUSE)
+#define RTK_DMP_PLAYBACK_FORMATS (SNDRV_PCM_FMTBIT_S8 | SNDRV_PCM_FMTBIT_S16_LE | SNDRV_PCM_FMTBIT_S24_LE | SNDRV_PCM_FMTBIT_S24_3LE)
+#define RTK_DMP_PLYABACK_RATES (SNDRV_PCM_RATE_16000 | SNDRV_PCM_RATE_32000 | SNDRV_PCM_RATE_44100 \
+                     | SNDRV_PCM_RATE_48000 | SNDRV_PCM_RATE_88200 | SNDRV_PCM_RATE_96000 \
+                     | SNDRV_PCM_RATE_176400 | SNDRV_PCM_RATE_192000)
+#define RTK_DMP_PLAYBACK_RATE_MIN       16000
+#define RTK_DMP_PLAYBACK_RATE_MAX       192000
+#define RTK_DMP_PLAYBACK_CHANNELS_MIN   1
+#define RTK_DMP_PLAYBACK_CHANNELS_MAX   8
+#define RTK_DMP_PLAYBACK_MAX_BUFFER_SIZE         (32*1024)//(16*1024)
+#define RTK_DMP_PLAYBACK_MIN_PERIOD_SIZE         64
+#define RTK_DMP_PLAYBACK_MAX_PERIOD_SIZE         (8*1024)
+#define RTK_DMP_PLAYBACK_PERIODS_MIN             4
+#define RTK_DMP_PLAYBACK_PERIODS_MAX             1024
+#define RTK_DMP_PLAYBACK_FIFO_SIZE               32
+
+/////////////
+// capture //
+/////////////
+#define RTK_DMP_CAPTURE_INFO RTK_DMP_PLAYBACK_INFO
+#define RTK_DMP_CAPTURE_FORMATS (SNDRV_PCM_FMTBIT_S16_LE | SNDRV_PCM_FMTBIT_S24_LE)
+#define RTK_DMP_CAPTURE_RATES (SNDRV_PCM_RATE_44100 | SNDRV_PCM_RATE_48000)
+#define RTK_DMP_CAPTURE_RATE_MIN 44100
+#define RTK_DMP_CAPTURE_RATE_MAX 48000
+#define RTK_DMP_CAPTURE_CHANNELS_MIN 2
+#define RTK_DMP_CAPTURE_CHANNELS_MAX 2
+#define RTK_DMP_CAPTURE_MAX_BUFFER_SIZE         RTK_DMP_PLAYBACK_MAX_BUFFER_SIZE
+#define RTK_DMP_CAPTURE_MIN_PERIOD_SIZE         RTK_DMP_PLAYBACK_MIN_PERIOD_SIZE
+#define RTK_DMP_CAPTURE_MAX_PERIOD_SIZE         4096
+#define RTK_DMP_CAPTURE_PERIODS_MIN             RTK_DMP_PLAYBACK_PERIODS_MIN
+#define RTK_DMP_CAPTURE_PERIODS_MAX             RTK_DMP_PLAYBACK_PERIODS_MAX
+#define RTK_DMP_CAPTURE_FIFO_SIZE               RTK_DMP_PLAYBACK_FIFO_SIZE
+
+#define RTK_DEC_AO_BUFFER_SIZE          (7*1024)//(10*1024)
+#define RTK_ENC_AI_BUFFER_SIZE          (32*1024)//(64*1024)
+#define RTK_ENC_LPCM_BUFFER_SIZE        (32*1024)
+#define RTK_ENC_PTS_BUFFER_SIZE         (8*1024)
+
+enum{
+	ENUM_AIN_HDMIRX = 0,
+	ENUM_AIN_I2S,  // from ADC outside of IC
+	ENUM_AIN_AUDIO,
+	ENUM_AIN_AUDIO_V2,
+	ENUM_AIN_AUDIO_V3,
+	ENUM_AIN_AUDIO_V4
+};
+
+////////////////////////////////////////////
+////////////////////////////////////////////
+
+#define MAX_PCM_DEVICES     1 //2 todo
+#define MAX_PCM_SUBSTREAMS  2
+#define MAX_AI_DEVICES      1
+
+#define MIXER_ADDR_MASTER   0
+#define MIXER_ADDR_LINE     1
+#define MIXER_ADDR_MIC      2
+#define MIXER_ADDR_SYNTH    3
+#define MIXER_ADDR_CD       4
+#define MIXER_ADDR_LAST     4
+
+#define MARS_VOLUME(xname, xindex, addr)    \
+{ .iface = SNDRV_CTL_ELEM_IFACE_MIXER, .name = xname, .index = xindex, \
+  .info = snd_RTK_volume_info, \
+  .get = snd_RTK_volume_get, .put = snd_RTK_volume_put, \
+  .private_value = addr }
+
+#define MARS_CAPSRC(xname, xindex, addr)    \
+{ .iface = SNDRV_CTL_ELEM_IFACE_MIXER, .name = xname, .index = xindex, \
+  .info = snd_RTK_capsrc_info, \
+  .get = snd_RTK_capsrc_get, .put = snd_RTK_capsrc_put, \
+  .private_value = addr }
+
+#define RING32_2_RING64(pRing64, pRing32) \
+{\
+    pRing64->base = (unsigned long)pRing32->base; \
+    pRing64->limit = (unsigned long)pRing32->limit; \
+    pRing64->wp = (unsigned long)pRing32->wp; \
+    pRing64->rp = (unsigned long)pRing32->rp; \
+    pRing64->cp = (unsigned long)pRing32->cp; \
+}
+
+
+/************************************************************************/
+/* ENUM                                                                     */
+/************************************************************************/
+typedef enum _tagAVSyncMode{
+    AVSYNC_FORCED_SLAVE,
+    AVSYNC_FORCED_MASTER,
+    AVSYNC_AUTO_SLAVE,
+    AVSYNC_AUTO_MASTER,
+    AVSYNC_AUTO_MASTER_NO_SKIP,
+    AVSYNC_AUTO_MASTER_CONSTANT_DELAY   /* after getback mastership, it become force master */
+} AVSYNC_MODE;
+
+struct _tagMastership {
+    unsigned char systemMode;  /* enum AVSYNC_MODE */
+    unsigned char videoMode;   /* enum AVSYNC_MODE */
+    unsigned char audioMode;   /* enum AVSYNC_MODE */
+    unsigned char masterState; /* enum AUTOMASTER_STATE */
+};
+typedef struct _tagMastership MASTERSHIP;
+
+/* change this structure, make sure to change the CReferenceClock definition*/
+struct _tagRefClock {
+    long long      RCD;
+    unsigned int  RCD_ext;
+    long long      GPTSTimeout;
+    long long      videoSystemPTS;
+    long long      audioSystemPTS;
+    long long      videoRPTS;
+    long long      audioRPTS;
+    unsigned int  videoContext;
+    unsigned int  audioContext;
+
+    MASTERSHIP     mastership;
+    unsigned int  videoFreeRunThreshold;
+    unsigned int  audioFreeRunThreshold;
+    long long      masterGPTS;   // this is the value of GPTS (hardware PTS) when master set the reference clock
+    int           audioFullness;   // This flag will be turned on when AE's output buffer is almost full.
+    // VE which is monitoring this flag will issue auto-pause then.
+    // (0: still have enough output space for encoding.   1: AE request pause)
+    int           audioPauseFlag;  // This flag will be turned on when VE decides to auto-pause.
+    // AE which is monitoring this flag will auto-pause itself then.
+    // (0: ignore.  1: AE have to pauseEncode immediately)
+
+    int           VO_Underflow; // (0: VO is working properly; otherwise, VO underflow)
+    int           AO_Underflow; // (0: AO is working properly; otherwise, AO underflow)
+    int           videoEndOfSegment; // set to the flow EOS.eventID by VO after presenting the EOS sample
+    int           audioEndOfSegment; // set to the flow EOS.eventID by AO after presenting the EOS sample
+    unsigned char  reserved[16];
+};
+typedef struct _tagRefClock  REFCLOCK;
+
+typedef enum {
+    AUDIO_PATH_NO_DEFINE = 0,
+    AUDIO_PATH_DECODER_AO,
+    AUDIO_PATH_AO_BYPASS
+} AUDIO_PATH_T;
+
+typedef enum {
+    SND_REALTEK_EOS_STATE_NONE = 0,
+    SND_REALTEK_EOS_STATE_PROCESSING,
+    SND_REALTEK_EOS_STATE_FINISH
+} SND_REALTEK_EOS_STATE_T;
+
+typedef enum _tagRingBufferType{
+    RINGBUFFER_STREAM,
+    RINGBUFFER_COMMAND,
+    RINGBUFFER_MESSAGE,
+    RINGBUFFER_VBI,
+    RINGBUFFER_PTS,
+    RINGBUFFER_DTVCC
+} RINGBUFFER_TYPE;
+
+typedef enum {
+    ENUM_OMX_AUDIO_VERSION_0 = 0,
+    ENUM_OMX_AUDIO_VERSION_1 = 1,
+} OMX_AUDIO_VERSION;
+
+enum AUDIO_CONFIG_CMD_MSG {
+    AUDIO_CONFIG_CMD_SPEAKER = 0,
+    AUDIO_CONFIG_CMD_AGC = 1,
+    AUDIO_CONFIG_CMD_SPDIF = 2,
+    AUDIO_CONFIG_CMD_VOLUME = 3,
+    AUDIO_CONFIG_CMD_MUTE = 4,
+    AUDIO_CONFIG_CMD_AO_MIC = 5,
+    AUDIO_CONFIG_CMD_AO_AUX = 6,
+    AUDIO_CONFIG_CMD_AO_ECHO_REVERB = 7,
+    AUDIO_CONFIG_CMD_AO_MIC1_VOLUME = 8,
+    AUDIO_CONFIG_CMD_AO_MIC2_VOLUME = 9,
+    AUDIO_CONFIG_CMD_AO_DEC_VOLUME = 10,
+    AUDIO_CONFIG_CMD_AO_AUX_VOLUME = 11,
+    AUDIO_CONFIG_CMD_DAC_SWITCH = 12,
+    AUDIO_CONFIG_CMD_DD_DUALMONO = 13,
+    AUDIO_CONFIG_CMD_DD_SCALE = 14,
+    AUDIO_CONFIG_CMD_DD_DOWNMIXMODE = 15,
+    AUDIO_CONFIG_CMD_DD_COMP = 16,
+    AUDIO_CONFIG_CMD_DD_LFE = 17,
+    AUDIO_CONFIG_CMD_DD_STEREOMIX = 18,
+    AUDIO_CONFIG_CMD_DIGITAL_OUT = 19,
+    AUDIO_CONFIG_CMD_EXCLUSIVE = 20,
+    AUDIO_CONFIG_CMD_AC3_SPDIF_RAW = 21,
+    AUDIO_CONFIG_CMD_AC3_HDMI_RAW = 22,
+    AUDIO_CONFIG_CMD_DTS_SPDIF_RAW = 23,
+    AUDIO_CONFIG_CMD_DTS_HDMI_RAW = 24,
+    AUDIO_CONFIG_CMD_MPG_SPDIF_RAW = 25,
+    AUDIO_CONFIG_CMD_MPG_HDMI_RAW = 26,
+    AUDIO_CONFIG_CMD_AAC_SPDIF_RAW = 27,
+    AUDIO_CONFIG_CMD_AAC_HDMI_RAW = 28,
+    AUDIO_CONFIG_CMD_MLP_HDMI_RAW = 29,
+    AUDIO_CONFIG_CMD_DDP_HDMI_RAW = 30,
+    AUDIO_CONFIG_CMD_HDMI_CHANNEL_OUT = 31,
+    AUDIO_CONFIG_CMD_FORCE_CHANNEL_CODEC = 32,
+    AUDIO_CONFIG_CMD_MLP_SPDIF_RAW = 33,
+    AUDIO_CONFIG_CMD_DDP_SPDIF_RAW = 34,
+    AUDIO_CONFIG_CMD_MAX_OUTPUT_SAMPLERATE = 35,
+    AUDIO_CONFIG_CMD_USB_DEVICE_SUPPORT_SAMPLERATE = 36,
+    AUDIO_CONFIG_CMD_KARAOKE_MODE = 37,
+    AUDIO_CONFIG_CMD_BRAZIL_LATM_AAC = 38,
+    AUDIO_CONFIG_CMD_DRC_PERCENT = 39,
+    AUDIO_CONFIG_CMD_LICENSE_MODE = 40,
+    AUDIO_CONFIG_CMD_AUDIO_TYPE_PRIORITY = 41,
+    AUDIO_CONFIG_CMD_SPDIF_OUTPUT_SWITCH = 42,
+    AUDIO_CONFIG_CMD_CUSTOMIZE_REQUEST = 43,
+    AUDIO_CONFIG_CMD_DEC_PLAYBACK_RATE = 44,
+    AUDIO_CONFIG_CMD_SAMPLERATE_TOLERANCE = 45,
+    AUDIO_CONFIG_CMD_KARAOKE_GENDER_CHANGE = 46,
+    AUDIO_CONFIG_CMD_DAC_OUTPUT_SWITCH = 47,
+    AUDIO_CONFIG_CMD_SET_DEC_DELAY_RP = 48,
+    AUDIO_CONFIG_CMD_MPEG2_AAC_LOW_SR_SPDIF_RAW = 49,
+    AUDIO_CONFIG_CMD_MPEG2_AAC_LOW_SR_HDMI_RAW = 50,
+    AUDIO_CONFIG_CMD_MPEG4_AAC_SPDIF_RAW = 51,
+    AUDIO_CONFIG_CMD_MPEG4_AAC_HDMI_RAW = 52,
+    AUDIO_CONFIG_CMD_HDMI_OUTPUT_SWITCH = 53,
+    AUDIO_CONFIG_CMD_SPDIF_SCMS = 54,
+    AUDIO_CONFIG_CMD_DAC_ANALOG_GAIN = 55,
+    AUDIO_CONFIG_CMD_POWER_SAVING_SETUP = 56,
+    AUDIO_CONFIG_TRUEHD_ERR_SELF_RESET_ENABLED = 57,
+};
+typedef enum AUDIO_CONFIG_CMD_MSG AUDIO_CONFIG_CMD_MSG;
+
+enum ENUM_AUDIO_HDMI_EDID_ENABLE {
+    ENUM_AUDIO_EDID_DISABLE = 0,
+    ENUM_AUDIO_EDID_ENABLE = 1,
+    ENUM_AUDIO_EDID_START = 2,
+    ENUM_AUDIO_EDID_END = 3,
+};
+typedef enum ENUM_AUDIO_HDMI_EDID_ENABLE ENUM_AUDIO_HDMI_EDID_ENABLE;
+
+//  downmix could be placed on in-band queue
+//  set media type or private information to in-band queue
+typedef enum
+{
+    /* Audio Decoder In-band Command */
+    AUDIO_DEC_INBAND_CMD_TYPE_PTS = 0,
+    AUDIO_DEC_INBAND_CMD_TYPE_NEW_SEG = 1,      /* let begin_AGC_gain = 1 */
+    AUDIO_DEC_INBAMD_CMD_TYPE_NEW_FORMAT = 2,
+    AUDIO_DEC_INBAND_CMD_TYPE_EOS = 3,          /* Can not be passed, sent back to system */    
+    AUDIO_DEC_INBAND_CMD_TYPE_CONTEXT = 4,      /* write debug information, need a RPC_ToSystem command *//* Can not be passed, sent back to system */
+    AUDIO_DEC_INBAND_CMD_TYPE_DECODE = 5,       /* Information for each decoder is inclueded */
+    AUDIO_DEC_INABND_CMD_TYPE_PTS_SKIP = 6,
+    AUDIO_DEC_INBAND_CMD_TYPE_PRIVATE_INFO = 7,
+    AUDIO_DEC_INBAND_CMD_TYPE_VORBIS_PACKETINFO = 8,    /* Information about vorbis packets */
+
+    AUDIO_DEC_INBAND_CMD_TYPE_BS_DISCONTINUITY = 9,
+    AUDIO_DEC_INBAND_CMD_TYPE_RESYNC = 10,      
+    AUDIO_DEC_INBAND_CMD_TYPE_CGMS_INFO = 11,       
+    AUDIO_DEC_INBAND_CMD_TYPE_RALSD_INFO = 12,
+    AUDIO_DEC_INBAND_CMD_TYPE_WMAPRO_DRC = 13,      
+    AUDIO_DEC_INBAND_CMD_TYPE_WMAPRO_DWNMIX_MTRX = 14,  
+
+    AUDIO_DEC_INBAND_CMD_TYPE_EMPHASIS = 15,        // for lpcm emphasis info   
+
+    /* Audio AO Mixer In-band Command */
+    AUDIO_AO_MIXER_INBAND_CMD_TYPE_SET_MIXER_RPTS = 64,
+    AUDIO_AO_MIXER_INBAND_CMD_TYPE_SET_BLEND,
+
+    /* Audio DV Mixer In-band Command */
+    AUDIO_DV_MIXER_INBAND_CMD_TYPE_SET_BLEND
+} AUDIO_INBAND_CMD_TYPE ;
+
+enum AUDIO_DEC_TYPE {
+    AUDIO_UNKNOWN_TYPE = 0,
+    AUDIO_MPEG_DECODER_TYPE = 1,
+    AUDIO_AC3_DECODER_TYPE = 2,
+    AUDIO_LPCM_DECODER_TYPE = 3,
+    AUDIO_DTS_DECODER_TYPE = 4,
+    AUDIO_WMA_DECODER_TYPE = 5,
+    AUDIO_AAC_DECODER_TYPE = 6,
+    AUDIO_VORBIS_DECODER_TYPE = 7,
+    AUDIO_DV_DECODER_TYPE = 8,
+    AUDIO_MLP_DECODER_TYPE = 9,
+    AUDIO_DDP_DECODER_TYPE = 10,
+    AUDIO_DTS_HD_DECODER_TYPE = 11,
+    AUDIO_WMA_PRO_DECODER_TYPE = 12,
+    AUDIO_MP4AAC_DECODER_TYPE = 13,
+    AUDIO_MP3_PRO_DECODER_TYPE = 14,
+    AUDIO_MP4HEAAC_DECODER_TYPE = 15,
+    AUDIO_RAW_AAC_DECODER_TYPE = 16,
+    AUDIO_RA1_DECODER_TYPE = 17,
+    AUDIO_RA2_DECODER_TYPE = 18,
+    AUDIO_ATRAC3_DECODER_TYPE = 19,
+    AUDIO_COOK_DECODER_TYPE = 20,
+    AUDIO_LSD_DECODER_TYPE = 21,
+    AUDIO_ADPCM_DECODER_TYPE = 22,
+    AUDIO_FLAC_DECODER_TYPE = 23,
+    AUDIO_ULAW_DECODER_TYPE = 24,
+    AUDIO_ALAW_DECODER_TYPE = 25,
+    AUDIO_ALAC_DECODER_TYPE = 26,
+    AUDIO_DTS_HIGH_RESOLUTION_DECODER_TYPE = 27,
+    AUDIO_DTS_LBR_DECODER_TYPE = 28,
+    AUDIO_DTS_MASTER_AUDIO_DECODER_TYPE = 29,
+    AUDIO_AMR_DECODER_TYPE = 30,
+    AUDIO_MIDI_DECODER_TYPE = 31,
+    AUDIO_APE_DECODER_TYPE = 32,
+    AUDIO_AVS_DECODER_TYPE = 33,
+    AUDIO_NELLYMOSER_DECODER_TYPE = 34,
+    AUDIO_WMA_LOSSLESS_DECODER_TYPE = 35,
+    AUDIO_UNCERTAIN_DECODER_TYPE = 36,
+    AUDIO_UNCERTAIN_HDMV_DECODER_TYPE = 37,
+    AUDIO_ILBC_DECODER_TYPE = 38,
+};
+typedef enum AUDIO_DEC_TYPE AUDIO_DEC_TYPE;
+
+enum AUDIO_MODULE_TYPE {
+    AUDIO_OUT = 7,
+    AUDIO_IN = 8,
+    AUDIO_ENCODER = 9,
+    AUDIO_MPEG_ENCODER = 10,
+    AUDIO_ALSA_OUT = 12,
+    AUDIO_PSEUDO_OUT = 14,
+    AUDIO_PP_OUT = 15,
+    AUDIO_DECODER = 16,
+    AUDIO_UNKNOWN = 17,
+    AUDIO_LPCM_ENCODER = 19,
+    AUDIO_AAC_ENCODER = 21,
+    AUDIO_MP3_ENCODER = 22,
+    AUDIO_RV_PARSER = 23,
+    AUDIO_AC3_ENCODER = 24,
+    AUDIO_VIENNA_OUT = 25,
+    AUDIO_DTS_ENCODER = 26, 
+};
+typedef enum AUDIO_MODULE_TYPE AUDIO_MODULE_TYPE;
+
+enum AUDIO_ENUM_PRIVAETINFO {
+    ENUM_PRIVATEINFO_AUDIO_FORMAT_PARSER_CAPABILITY = 0,
+    ENUM_PRIVATEINFO_AUDIO_DECODER_CAPABILITY = 1,
+    ENUM_PRIVATEINFO_AUDIO_CONFIG_CMD_BS_INFO = 2,
+    ENUM_PRIVATEINFO_AUDIO_CHECK_LPCM_ENDIANESS = 3,
+    ENUM_PRIVATEINFO_AUDIO_CONFIG_CMD_AO_DELAY_INFO = 4,
+    ENUM_PRIVATEINFO_AUDIO_AO_CHANNEL_VOLUME_LEVEL = 5,
+    ENUM_PRIVATEINFO_AUDIO_GET_FLASH_PIN = 6,
+    ENUM_PRIVATEINFO_AUDIO_RELEASE_FLASH_PIN = 7,
+    ENUM_PRIVATEINFO_AUDIO_GET_MUTE_N_VOLUME = 8,
+    ENUM_PRIVATEINFO_AUDIO_AO_MONITOR_FULLNESS = 9,
+    ENUM_PRIVATEINFO_AUDIO_CONTROL_FLASH_VOLUME = 10,
+    ENUM_PRIVATEINFO_AUDIO_CONTROL_DAC_SWITCH = 11,
+    ENUM_PRIVATEINFO_AUDIO_PREPROCESS_CONFIG = 12,
+    ENUM_PRIVATEINFO_AUDIO_CHECK_SECURITY_ID = 13,
+    ENUM_PRIVATEINFO_AUDIO_LOW_DELAY_PARAMETERS = 14,
+    ENUM_PRIVATEINFO_AUDIO_SET_NETWORK_JITTER = 15,
+    ENUM_PRIVATEINFO_AUDIO_GET_QUEUE_DATA_SIZE = 16,
+    ENUM_PRIVATEINFO_AUDIO_GET_SHARE_MEMORY_FROM_ALSA = 17,
+    ENUM_PRIVATEINFO_AUDIO_AI_CONNECT_ALSA = 18,
+    ENUM_PRIVATEINFO_AUDIO_SET_PCM_FORMAT = 19,
+    ENUM_PRIVATEINFO_AUDIO_DO_SELF_DESTROY_FLOW = 20,
+    ENUM_PRIVATEINFO_AUDIO_GET_SAMPLING_RATE = 21,
+    ENUM_PRIVATEINFO_AUDIO_SLAVE_TIMEOUT_THRESHOLD = 22,
+    ENUM_PRIVATEINFO_AUDIO_GET_GLOBAL_AO_INSTANCEID = 23,
+    ENUM_PRIVATEINFO_AUDIO_SET_CEC_PARAMETERS = 24,
+    ENUM_PRIVATEINFO_AUDIO_INIT_DBG_DUMP_MEM = 25,
+    ENUM_PRIVATEINFO_AUDIO_AI_GET_AO_FLASH_PIN = 26,
+    ENUM_PRIVATEINFO_AUDIO_AI_SET_AO_FLASH_PIN = 27,
+    ENUM_PRIVATEINFO_AUDIO_GET_PP_FREE_PINID = 28,
+    ENUM_PRIVATEINFO_AUDIO_HDMI_RX_CONNECT_TO_BT = 29,
+    ENUM_PRIVATEINFO_AUDIO_GET_BS_ERR_RATE = 30,
+    ENUM_PRIVATEINFO_AUDIO_SET_RESUME_IR_KEYS = 31,
+    ENUM_PRIVATEINFO_SET_GSTREAMER_PTS_ACC_MODE = 32,
+    ENUM_PRIVATEINFO_AUDIO_GET_BONDING_TYPE = 33,
+    ENUM_PRIVATEINFO_AUDIO_SHARE_MEMORY_FOR_PORTING_FIRMWARE = 34,
+    ENUM_PRIVATEINFO_AUDIO_SET_DVDPLAYER_AO_VERSION = 35,
+    ENUM_PRIVATEINFO_AUDIO_MS_PP_CERT = 36,
+    ENUM_PRIVATEINFO_AUDIO_TRIGGER_EVENT = 37,
+    ENUM_PRIVATEINFO_AUDIO_AI_NON_PCM_IN = 38,
+    ENUM_PRIVATEINFO_OMX_AUDIO_VERSION = 39,
+    ENUM_PRIVATEINFO_AUDIO_AI_PAD_IN = 40,
+    ENUM_PRIVATEINFO_AUDIO_MS_MAJOR_DECODER_PIN = 41,
+    ENUM_PRIVATEINFO_AUDIO_PROVIDE_RAWOUT_LATENCY = 42,
+    ENUM_PRIVATEINFO_AUDIO_MS_MIXER_IGNORE_PIN = 43,
+    ENUM_PRIVATEINFO_AUDIO_MS_CERTIFICATION_PLATFORM = 44,
+    ENUM_PRIVATEINFO_AUDIO_MS_MIXER_PIN_NEW_SEG = 45,
+    ENUM_PRIVATEINFO_AUDIO_MS_DEC_DROP_BY_PTS = 46,
+    ENUM_PRIVATEINFO_AUDIO_MS_DEC_INIT_PTS_OFFSET = 47,
+    ENUM_PRIVATEINFO_AUDIO_MS_PP_OUTPUT_TYPE = 48,
+    ENUM_PRIVATEINFO_AUDIO_DTS_ENCODER_CONFIG = 49,
+    ENUM_PRIVATEINFO_AUDIO_GET_FW_VERSION = 50,
+    ENUM_PRIVATEINFO_AUDIO_DTS_M8_IN_CONFIG = 51,
+    ENUM_PRIVATEINFO_AUDIO_DTS_M8_LA_NUM = 52,
+    ENUM_PRIVATEINFO_AUDIO_DTS_M8_SET_OUTPUT_FORMAT = 53,
+    ENUM_PRIVATEINFO_AUDIO_SET_DRC_CFG = 54,
+    ENUM_PRIVATEINFO_AUDIO_DTS_M8_LA_ERROR_MSG = 55,
+    ENUM_PRIVATEINFO_GET_B_VALUE = 56,
+    ENUM_PRIVATEINFO_AUDIO_ENTER_SUSPEND = 57,
+    ENUM_PRIVATEINFO_AUDIO_MPEGH_IN_CONFIG = 58,
+    ENUM_PRIVATEINFO_AUDIO_SET_LOW_WATERLEVEL = 59,
+};
+typedef enum AUDIO_ENUM_PRIVAETINFO AUDIO_ENUM_PRIVAETINFO;
+
+enum AUDIO_CHANNEL_OUT_INDEX {
+    AUDIO_NULL_CHANNEL_INDEX = 0,
+    AUDIO_LEFT_FRONT_INDEX = 1,
+    AUDIO_RIGHT_FRONT_INDEX = 2,
+    AUDIO_CENTER_FRONT_INDEX = 5,
+    AUDIO_LFE_INDEX = 6,
+    AUDIO_LEFT_SURROUND_REAR_INDEX = 3,
+    AUDIO_RIGHT_SURROUND_REAR_INDEX = 4,
+    AUDIO_LEFT_OUTSIDE_FRONT_INDEX = 7,
+    AUDIO_RIGHT_OUTSIDE_FRONT_INDEX = 8,
+    AUDIO_SPDIF_LEFT_CHANNEL_INDEX = 9,
+    AUDIO_SPDIF_RIGHT_CHANNEL_INDEX = 10,
+    AUDIO_SURROUND_INDEX = 11,
+    AUDIO_CENTER_SURROUND_REAR_INDEX = 12,
+    AUDIO_OverHead_INDEX = 13,
+    AUDIO_LEFT_SURROUND_INDEX = 14,
+    AUDIO_RIGHT_SURROUND_INDEX = 15,
+    AUDIO_LEFT_FRONT_HIGH_INDEX = 16,
+    AUDIO_RIGHT_FRONT_HIGH_INDEX = 17,
+    AUDIO_LEFT_INNER_FRONT_INDEX = 18,
+    AUDIO_RIGHT_INNER_FRONT_INDEX = 19,
+    AUDIO_LEFT_REAR_INDEX = 20,
+    AUDIO_RIGHT_REAR_INDEX = 21,
+    AUDIO_LEFT_SURROUND_DIRECT_INDEX = 22,
+    AUDIO_RIGHT_SURROUND_DIRECT_INDEX = 23,
+    AUDIO_CENTER_FRONT_HIGH_INDEX = 24,
+    AUDIO_LFE2_INDEX = 25,
+    AUDIO_SPDIF_NON_PCM_TYPE = 256,
+    AUDIO_ENABLE_DOWNMIX = 257,
+};
+typedef enum AUDIO_CHANNEL_OUT_INDEX AUDIO_CHANNEL_OUT_INDEX;
+
+enum AUDIO_FORMAT_OF_AI_SEND_TO_ALSA {
+	AUDIO_ALSA_FORMAT_32BITS_BE_PCM = 0,
+	AUDIO_ALSA_FORMAT_16BITS_LE_LPCM = 1,
+	AUDIO_ALSA_FORMAT_24BITS_LE_LPCM = 2,
+	AUDIO_ALSA_FORMAT_NONE = 3,
+	AUDIO_ALSA_FORMAT_TOTAL_NUM = 3 + 1,
+};
+typedef enum AUDIO_FORMAT_OF_AI_SEND_TO_ALSA AUDIO_FORMAT_OF_AI_SEND_TO_ALSA;
+
+typedef enum 
+{
+    AUDIO_BIG_ENDIAN        = 0,       // CD,DVD type
+    AUDIO_LITTLE_ENDIAN     = 1,       
+    AUDIO_LPCM_DHMV_TYPE    = 2,       // HDMV type
+} AUDIO_ENDIANTYPE;
+
+typedef enum {
+    AUDIO_SAMPLERATE_32000 = 0x1,
+    AUDIO_SAMPLERATE_44100 = 0x2,
+    AUDIO_SAMPLERATE_48000 = 0x4,
+    AUDIO_SAMPLERATE_88200 = 0x8,
+    AUDIO_SAMPLERATE_96000 = 0x10,
+    AUDIO_SAMPLERATE_176400 = 0x20,
+    AUDIO_SAMPLERATE_192000 = 0x40,
+    AUDIO_SAMPLERATE_22050 = 0x80,
+    AUDIO_SAMPLERATE_24000 = 0x100,
+    AUDIO_SAMPLERATE_64000 = 0x200,
+    AUDIO_SAMPLERATE_16000 = 0x400,
+    AUDIO_SAMPLERATE_8000 = 0x800,
+    AUDIO_SAMPLERATE_11025 = 0x1000,
+} AUDIO_SAMPLERATE;
+
+typedef enum{
+    ENUM_USB_AUDIO_IN_CMD_DISCONNECT = 0,
+    ENUM_USB_AUDIO_IN_CMD_CONNECT = 1,
+    ENUM_USB_AUDIO_IN_CMD_STOP = 2,
+    ENUM_USB_AUDIO_IN_CMD_START = 3,
+    ENUM_USB_AUDIO_IN_CMD_GETINFO = 4,
+    ENUM_USB_AUDIO_IN_CMD_SETINFO = 5,
+} USB_AUDIO_IN_CMD;
+
+typedef enum{
+    ENUM_START_STATE = 1,
+    ENUM_SLEEP_STATE,
+    ENUM_IN_COPY_LOOP_STATE,
+    ENUM_IN_WAIT_LOOP_STATE,
+    ENUM_END_STATE
+} ALSA_WRITE_STATE;
+
+typedef enum{
+    ENUM_USB_AUDIO_IN_FORMAT_SIGNED_8BITS = 0x1,
+    ENUM_USB_AUDIO_IN_FORMAT_SIGNED_16BITS = 0x2,
+    ENUM_USB_AUDIO_IN_FORMAT_SIGNED_24BITS = 0x4,
+    ENUM_USB_AUDIO_IN_FORMAT_SIGNED_32BITS = 0x8,
+    ENUM_USB_AUDIO_IN_FORMAT_UNSIGNED_8BITS = 0x10,
+    ENUM_USB_AUDIO_IN_FORMAT_UNSIGNED_16BITS = 0x20,
+    ENUM_USB_AUDIO_IN_FORMAT_UNSIGNED_24BITS = 0x40,
+    ENUM_USB_AUDIO_IN_FORMAT_UNSIGNED_32BITS = 0x80,
+} USB_AUDIO_IN_FORMAT;
+
+typedef enum
+{
+    ENUM_AO_FLASH_32BIT_BE = 0,
+    ENUM_AO_FLASH_24BIT_BE,
+    ENUM_AO_FLASH_16BIT_BE,
+    ENUM_AO_FLASH_24BIT_LE,
+    ENUM_AO_FLASH_16BIT_LE,
+    ENUM_AO_FLASH_8BIT
+} AO_FLASH_PCM_FORMAT;
+
+typedef enum
+{
+    ENUM_AUDIO_NULL_CHANNEL_INDEX = 0,
+
+    ENUM_AUDIO_LEFT_FRONT_INDEX = 1,            // L
+    ENUM_AUDIO_RIGHT_FRONT_INDEX = 2,           // R
+    ENUM_AUDIO_CENTER_FRONT_INDEX = 5,          // C
+    ENUM_AUDIO_LFE_INDEX = 6,                   // LFE
+    ENUM_AUDIO_LEFT_SURROUND_REAR_INDEX = 3,    // Ls or Lsr
+    ENUM_AUDIO_RIGHT_SURROUND_REAR_INDEX = 4,   // Rs or Rsr
+    ENUM_AUDIO_LEFT_OUTSIDE_FRONT_INDEX = 7,    // ENUM_AUDIO_LEFT_SURROUND_SIDE_INDEX,  Lss
+    ENUM_AUDIO_RIGHT_OUTSIDE_FRONT_INDEX = 8,   // ENUM_AUDIO_RIGHT_SURROUND_SIDE_INDEX, Rss
+    ENUM_AUDIO_SPDIF_LEFT_CHANNEL_INDEX = 9,
+    ENUM_AUDIO_SPDIF_RIGHT_CHANNEL_INDEX = 10,
+
+    ENUM_AUDIO_SURROUND_INDEX = 11,
+    ENUM_AUDIO_CENTER_SURROUND_REAR_INDEX = 12,
+    ENUM_AUDIO_OverHead_INDEX = 13,
+
+    ENUM_AUDIO_LEFT_SURROUND_INDEX = 14,
+    ENUM_AUDIO_RIGHT_SURROUND_INDEX = 15,
+    ENUM_AUDIO_LEFT_FRONT_HIGH_INDEX = 16,
+    ENUM_AUDIO_RIGHT_FRONT_HIGH_INDEX = 17,
+    ENUM_AUDIO_LEFT_INNER_FRONT_INDEX = 18,
+    ENUM_AUDIO_RIGHT_INNER_FRONT_INDEX = 19,
+    ENUM_AUDIO_LEFT_REAR_INDEX = 20,
+    ENUM_AUDIO_RIGHT_REAR_INDEX = 21,
+    ENUM_AUDIO_LEFT_SURROUND_DIRECT_INDEX = 22,
+    ENUM_AUDIO_RIGHT_SURROUND_DIRECT_INDEX = 23,
+    ENUM_AUDIO_CENTER_FRONT_HIGH_INDEX = 24,
+    ENUM_AUDIO_LFE2_INDEX = 25,
+
+    ENUM_AUDIO_SPDIF_NON_PCM_TYPE = 256,
+    ENUM_AUDIO_ENABLE_DOWNMIX = 257
+} ENUM_AUDIO_CHANNEL_OUT_INDEX;
+
+enum ENUM_AUDIO_CHANNEL_IN {
+    IN_NULL_CHANNEL = 0,
+    ADC0_LEFT_CHANNEL_EN = 1,
+    ADC0_RIGHT_CHANNEL_EN = 2,
+    ADC1_LEFT_CHANNEL_EN = 4,
+    ADC1_Right_CHANNEL_EN = 8,
+    SPDIF_LEFT_CHANNEL_EN = 16,
+    SPDIF_RIGHT_CHANNEL_EN = 32,
+    ADC2_LEFT_CHANNEL_EN = 64,
+    ADC2_RIGHT_CHANNEL_EN = 128,
+};
+typedef enum ENUM_AUDIO_CHANNEL_IN ENUM_AUDIO_CHANNEL_IN;
+
+enum ENUM_AUDIO_CHANNEL_OUT {
+    OUT_NULL_CHANNEL = 0,
+    LEFT_CENTER_FRONT_CHANNEL_EN = 1,
+    RIGHT_CENTER_FRONT_CHANNEL_EN = 2,
+    CENTER_FRONT_CHANNEL_EN = 4,
+    LFE_CHANNEL_EN = 8,
+    LEFT_SURROUND_CHANNEL_EN = 16,
+    RIGHT_SURROUND_CHANNEL_EN = 32,
+    LEFT_OUTSIDE_FRONT_CHANNEL_EN = 64,
+    RIGHT_OUTSIDE_FRONT_CHANNEL_EN = 128,
+    NON_PCM_OUT_EN = 256,
+    ENABLE_DOWNMIX = 257,
+};
+typedef enum ENUM_AUDIO_CHANNEL_OUT ENUM_AUDIO_CHANNEL_OUT;
+
+enum AUDIO_ENUM_AIO_PRIVAETINFO {
+	ENUM_PRIVATEINFO_AIO_AO_INTERFACE_SWITCH_CONTROL = 0,
+	ENUM_PRIVATEINFO_AIO_AI_INTERFACE_SWITCH_CONTROL = 1,
+	ENUM_PRIVATEINFO_AIO_ALSA_DESTROY_AI_FLOW = 2,
+	ENUM_PRIVATEINFO_AIO_AI_NONPCM_WRITE_BACK_BS = 3,
+	ENUM_PRIVATEINFO_AIO_HDMIRX_LATENCY_MEM = 4,
+	ENUM_PRIVATEINFO_AIO_AI_LOOPBACK_AO = 5,
+	ENUM_PRIVATEINFO_AIO_AI_LOOPBACK_HDMITX = 6,
+	ENUM_PRIVATEINFO_AIO_AI_LOOPBACK_DAC = 7,
+	ENUM_PRIVATEINFO_AIO_AI_ADC_ANALOG = 8,
+	ENUM_PRIVATEINFO_AIO_AI_MULTIPLE_ADC = 9,
+	ENUM_PRIVATEINFO_AIO_AI_ADC_AMIC = 9 + 1,
+	ENUM_PRIVATEINFO_AIO_KERNEL_RPC = 9 + 2,
+	ENUM_PRIVATEINFO_AIO_SET_SE_CLK = 9 + 3,
+	ENUM_PRIVATEINFO_AIO_AI_PRIVATEINFO = 9 + 4,
+	ENUM_PRIVATEINFO_AIO_DELIVER_SCPU_FW_PID = 9 + 5,
+	ENUM_PRIVATEINFO_AIO_GET_D_VISION_CAPABILITY = 9 + 6,
+	ENUM_PRIVATEINFO_AIO_GET_AUDIO_PROCESSING_AI = 9 + 7,
+	ENUM_PRIVATEINFO_AIO_TOTAL_NUM = 9 + 8,
+};
+typedef enum AUDIO_ENUM_AIO_PRIVAETINFO AUDIO_ENUM_AIO_PRIVAETINFO;
+
+typedef enum
+{
+    ENUM_AI_PRIVATE_MUTE = 0,
+    ENUM_AI_PRIVATE_WRITE_BACK_SYSTEM,
+    ENUM_AI_PRIVATE_HDMI_RX_TO_SET_AO_FLASH,
+    ENUM_AI_PRIVATE_HDMI_RX_TO_GET_AO_FLASH,
+    ENUM_AI_PRIVATE_HDMI_RX_CONNECT_TO_BT_INFO,
+    ENUM_AI_PRIVATE_NON_PCM_IN,
+    ENUM_AI_PRIVATE_SET_PAD_SOURCE,
+    ENUM_AI_PRIVATE_NONPCM_WRITE_BACK_BS,
+    ENUM_AI_PRIVATE_LOOPBACK_AO,
+    ENUM_AI_PRIVATE_ADC_ANALOG,
+    ENUM_AI_PRIVATE_MULTIPLE_ADC,
+    ENUM_AI_PRIVATE_ADC_AMIC,     // 11
+    ENUM_AI_PRIVATE_ADC_SWAP,
+    ENUM_AI_PRIVATE_ADC_SET_VOLUME,
+	ENUM_AI_PRIVATE_AUDIO_PROCESSING,
+	ENUM_AI_PRIVATE_VOLUME_CTRL,
+	ENUM_AI_PRIVATE_WRITE_BACK_SYSTEM_EXT,
+	ENUM_AI_PRIVATE_HDMIRX_AUDIO_INFO_FRAME,
+	ENUM_AI_PRIVATE_HACK_1KHZ_WITHOUT_HW = 12 + 6,
+	ENUM_AI_PRIVATE_SPDIF_OPTICAL = 12 + 7,
+	ENUM_AI_PRIVATE_HDMI_RX = 12 + 8,
+	ENUM_AI_PRIVATE_SPDIF_COAXIAL = 12 + 9,
+	ENUM_AI_PRIVATE_SPDIF_ARC = 12 + 10,
+	ENUM_AI_PRIVATE_ADC_DMIC = 12 + 11,
+	ENUM_AI_PRIVATE_TDM = 12 + 12,
+	ENUM_AI_PRIVATE_ADC_DMIC_PACK = 12 + 13,
+	ENUM_AI_PRIVATE_SELF_FLUSH = 12 + 14,
+	ENUM_AI_PRIVATE_CONFIG_PIN_MUX = 12 + 15,
+	ENUM_AI_PRIVATE_DUMP_NONPCM = 12 + 16,
+	ENUM_AI_PRIVATE_DUAL_DMIC_AND_LOOPBACK = 12 + 17,
+	ENUM_AI_PRIVATE_DUAL_DMIC_AND_LOOPBACK_FW = 12 + 18,
+	ENUM_AI_PRIVATE_SPEECH_RECOGNITION_FROM_DMIC = 12 + 19,
+	ENUM_AI_PRIVATE_TOTAL_NUM = 12 + 20,
+}ENUM_AI_PRIVATE_TYPE;
+
+enum AUDIO_VOLUME_CTRL {
+	ENUM_AUDIO_VOLUME_CTRL_0_DB = 0,
+	ENUM_AUDIO_VOLUME_CTRL_N1_DB = 0 + 1,
+	ENUM_AUDIO_VOLUME_CTRL_N2_DB = 0 + 2,
+	ENUM_AUDIO_VOLUME_CTRL_N3_DB = 0 + 3,
+	ENUM_AUDIO_VOLUME_CTRL_N4_DB = 0 + 4,
+	ENUM_AUDIO_VOLUME_CTRL_N5_DB = 0 + 5,
+	ENUM_AUDIO_VOLUME_CTRL_N6_DB = 0 + 6,
+	ENUM_AUDIO_VOLUME_CTRL_N7_DB = 0 + 7,
+	ENUM_AUDIO_VOLUME_CTRL_N8_DB = 0 + 8,
+	ENUM_AUDIO_VOLUME_CTRL_N9_DB = 0 + 9,
+	ENUM_AUDIO_VOLUME_CTRL_N10_DB = 0 + 10,
+	ENUM_AUDIO_VOLUME_CTRL_N11_DB = 0 + 11,
+	ENUM_AUDIO_VOLUME_CTRL_N12_DB = 0 + 12,
+	ENUM_AUDIO_VOLUME_CTRL_N13_DB = 0 + 13,
+	ENUM_AUDIO_VOLUME_CTRL_N14_DB = 0 + 14,
+	ENUM_AUDIO_VOLUME_CTRL_N15_DB = 0 + 15,
+	ENUM_AUDIO_VOLUME_CTRL_N16_DB = 0 + 16,
+	ENUM_AUDIO_VOLUME_CTRL_P1_DB = 256,  //17
+	ENUM_AUDIO_VOLUME_CTRL_P2_DB = 256 + 1,
+	ENUM_AUDIO_VOLUME_CTRL_P3_DB = 256 + 2,
+	ENUM_AUDIO_VOLUME_CTRL_P4_DB = 256 + 3,
+	ENUM_AUDIO_VOLUME_CTRL_P5_DB = 256 + 4,
+	ENUM_AUDIO_VOLUME_CTRL_P6_DB = 256 + 5,
+	ENUM_AUDIO_VOLUME_CTRL_P7_DB = 256 + 6,
+	ENUM_AUDIO_VOLUME_CTRL_P8_DB = 256 + 7,
+	ENUM_AUDIO_VOLUME_CTRL_P9_DB = 256 + 8,
+	ENUM_AUDIO_VOLUME_CTRL_P10_DB = 256 + 9,
+	ENUM_AUDIO_VOLUME_CTRL_P11_DB = 256 + 10,
+	ENUM_AUDIO_VOLUME_CTRL_P12_DB = 256 + 11,
+	ENUM_AUDIO_VOLUME_CTRL_P13_DB = 256 + 12,
+	ENUM_AUDIO_VOLUME_CTRL_P14_DB = 256 + 13,
+	ENUM_AUDIO_VOLUME_CTRL_P15_DB = 256 + 14,
+	ENUM_AUDIO_VOLUME_CTRL_P16_DB = 256 + 15,  //32
+};
+typedef enum AUDIO_VOLUME_CTRL AUDIO_VOLUME_CTRL;
+
+typedef enum _audio_digital_output_mode {
+	AUDIO_DIGITAL_RAW,
+	AUDIO_DIGITAL_LPCM_DUAL_CH,
+	AUDIO_DIGITAL_LPCM_MULTI_CH,
+	AUDIO_DIGITAL_AUTO,
+	AUDIO_DIGITAL_MAX
+} ENUM_AUDIO_DIGITAL_OUTPUT_MODE;
+
+enum ENUM_GBL_VAR_EQUALIZER_ID {
+	ENUM_EQUALIZER_PP = 0,
+	ENUM_EQUALIZER_MIC = 1,
+	ENUM_EQUALIZER_AUX = 2,
+	ENUM_EQUALIZER_AO = 3,
+};
+typedef enum ENUM_GBL_VAR_EQUALIZER_ID ENUM_GBL_VAR_EQUALIZER_ID;
+
+enum AIN_AUDIO_PROCESSING {
+	ENUM_AIN_AUDIO_PROCESSING_NONE = 0,
+	ENUM_AIN_AUDIO_PROCESSING_NO_INTERNAL_RING_BUF = 0 + 1,
+	ENUM_AIN_AUDIO_PROCESSING = 0 + 2,
+	ENUM_AIN_AUDIO_PROCESSING_DMIC_AND_LOOPBACK = 0 + 3,
+	ENUM_AIN_AUDIO_PROCESSING_DMIC = 0 + 4,
+	ENUM_AIN_AUDIO_PROCESSING_I2S = 0 + 5,
+};
+typedef enum AIN_AUDIO_PROCESSING AIN_AUDIO_PROCESSING;
+
+/************************************************************************/
+/* typedef                                                                     */
+/************************************************************************/
+typedef struct snd_pcm_substream snd_pcm_substream_t;
+typedef struct snd_pcm_runtime snd_pcm_runtime_t;
+typedef struct snd_pcm_hw_params snd_pcm_hw_params_t;
+typedef struct snd_pcm snd_pcm_t;
+typedef struct snd_pcm_ops snd_pcm_ops_t;
+typedef struct snd_pcm_hardware snd_pcm_hardware_t;
+typedef struct snd_kcontrol snd_kcontrol_t;
+typedef struct snd_ctl_elem_value snd_ctl_elem_value_t;
+typedef struct snd_ctl_elem_info snd_ctl_elem_info_t;
+typedef struct snd_kcontrol_new snd_kcontrol_new_t;
+typedef struct snd_card snd_card_t;
+typedef uint32_t HRESULT;
+
+typedef struct AUDIO_CONFIG_COMMAND {
+    AUDIO_CONFIG_CMD_MSG msgID;
+    unsigned int value[6];
+}AUDIO_CONFIG_COMMAND;
+
+typedef struct RPCRES_LONG {
+    HRESULT result;
+    int data;
+}RPCRES_LONG;
+
+typedef struct { 
+    unsigned int  info;
+    RPCRES_LONG retval;
+    HRESULT ret;
+} RPC_DEFAULT_INPUT_T;
+
+typedef struct {
+    int instanceID;
+    enum AUDIO_ENUM_PRIVAETINFO type;
+    int privateInfo[16];
+}AUDIO_RPC_PRIVATEINFO_PARAMETERS;
+
+typedef struct {
+    int instanceID;
+    int privateInfo[16];
+}AUDIO_RPC_PRIVATEINFO_RETURNVAL;
+
+typedef struct AUDIO_EQUALIZER_CONFIG {
+	int instanceID;
+	int gbl_var_eq_ID;
+	unsigned char ena;
+	struct AUDIO_RPC_EQUALIZER_MODE app_eq_config;
+}AUDIO_EQUALIZER_CONFIG;
+
+typedef struct AUDIO_RPC_INSTANCE {
+    int instanceID;
+    int type;
+}AUDIO_RPC_INSTANCE;
+
+typedef struct {
+    AUDIO_RPC_INSTANCE info;
+    RPCRES_LONG retval;
+    HRESULT ret;
+} RPC_CREATE_AO_AGENT_T;
+
+typedef struct { 
+    AUDIO_RPC_INSTANCE instance;
+    RPCRES_LONG res;
+    HRESULT ret;
+} RPC_CREATE_PCM_DECODER_CTRL_T;
+
+typedef struct {
+    int instanceID;
+    int pinID;
+    int pRingBufferHeaderList[8];
+    int readIdx;
+    int listSize;
+}AUDIO_RPC_RINGBUFFER_HEADER;
+
+// Ring Buffer header is the shared memory structure
+typedef struct _tagRingBufferHeader {
+    unsigned int magic;   //Magic number
+    unsigned int beginAddr;
+    unsigned int size;
+    unsigned int bufferID;  // RINGBUFFER_TYPE, choose a type from RINGBUFFER_TYPE
+
+    unsigned int  writePtr;
+    unsigned int  numOfReadPtr;
+    unsigned int  reserve2;  //Reserve for Red Zone
+    unsigned int  reserve3;  //Reserve for Red Zone
+
+    unsigned int readPtr[4];
+
+    int          fileOffset ;
+    int          requestedFileOffset ;
+    int          fileSize ;
+
+    int          bSeekable ;  /* Can't be sought if data is streamed by HTTP */
+    /*
+FileOffset:
+the offset to the streaming file from the beginning of the file.
+It is set by system to tell FW that the current streaming is starting from ��FileOffset�� bytes.
+For example, the TIFF file display will set fileOffset to 0 at beginning.
+
+RequestedFileOffset:
+the offset to be set by video firmware, to request system to seek to other place.
+The initial is -1.When it is not equal to -1, that means FW side is requesting a new seek.
+
+FileSize:
+file size. At current implementation, only TIFF decode needs the fileSize,
+other decoding does not pay attention to this field
+
+the behavior for TIFF seek:
+At the initial value, FileOffset = 0, or at any initial offset (for example, resume from bookmark), RequestedFileOffset=-1. FileSize= file size.
+1. If FW needs to perform seek operation, FW set RequestedFileOffset to the value it need to seek.
+2. Once system see RequestedOffset is not -1, system reset the ring buffer (FW need to make sure it will not use ring buffer after request the seek), set FileOffset to the new location (the value of RequestedFileOffset), then set RequestedOffset  to -1. From now on, system will stream data from byte FileOffset of the file.
+3. FW needs to wait until RequestedOffset== -1, then check the value inside FileOffset. If FileOffset is -1, that means read out of bound.
+If system already finish the streaming before FW issue a seek, system will still continue polling.
+*/
+
+} RINGBUFFER_HEADER;
+
+typedef struct {        
+    RPCRES_LONG ret;
+    HRESULT         res;
+    AUDIO_RPC_RINGBUFFER_HEADER header;
+} RPC_INITRINGBUFFER_HEADER_T;
+
+typedef struct AUDIO_RPC_CONNECTION {
+    int srcInstanceID;
+    int srcPinID;
+    int desInstanceID;
+    int desPinID;
+    int mediaType;
+}AUDIO_RPC_CONNECTION;
+
+typedef struct {        
+    AUDIO_RPC_CONNECTION out;
+    RPCRES_LONG ret;
+    HRESULT res;
+} RPC_CONNECTION_T;
+
+typedef struct {
+    int inst_id;
+    RPCRES_LONG retval;
+    HRESULT res;
+} RPC_TOAGENT_T;
+
+typedef struct {
+    int inst_id;
+    HRESULT retval;
+    HRESULT res;
+} RPC_TOAGENT_PAUSE_T;
+
+typedef struct AUDIO_RPC_SENDIO {
+    int instanceID;
+    int pinID;
+}AUDIO_RPC_SENDIO;
+
+typedef struct {
+    RPCRES_LONG retval;
+    HRESULT res;
+    AUDIO_RPC_SENDIO sendio;
+} RPC_TOAGENT_FLASH_T;
+
+typedef struct
+{
+    AUDIO_INBAND_CMD_TYPE   type ;
+    int                    size ;
+} AUDIO_INBAND_CMD_PKT_HEADER;
+
+typedef struct
+{
+    AUDIO_INBAND_CMD_PKT_HEADER header;
+    unsigned int               wPtr;
+    int                        EOSID;  /* ID associated with command */
+} AUDIO_DEC_EOS;
+
+typedef struct
+{
+    AUDIO_INBAND_CMD_PKT_HEADER header;
+    unsigned int               wPtr;
+    AUDIO_DEC_TYPE              audioType;
+    int                        privateInfo[8];  // note: privateinfo[6] is used for choosing decoder sync pts method
+}   AUDIO_DEC_NEW_FORMAT ;
+
+typedef struct
+{
+    AUDIO_INBAND_CMD_PKT_HEADER header;
+    unsigned int               wPtr ;
+    unsigned int               PTSH;
+    unsigned int               PTSL;
+} AUDIO_DEC_PTS_INFO ;
+
+typedef struct {        
+    RPCRES_LONG retval;
+    HRESULT         res;
+    int        instanceID;
+} RPC_TOAGENT_STOP_T;
+
+typedef struct {        
+    RPCRES_LONG retval;
+    HRESULT         res;
+    int        instanceID;
+} RPC_TOAGENT_DESTROY_T;
+
+typedef struct { 
+    RPCRES_LONG res;
+    HRESULT ret;
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS  param;
+} RPC_GET_VOLUME_T;
+
+struct AUDIO_GENERAL_CONFIG {
+    char interface_en;
+    char channel_in;
+    char count_down_rec_en;
+    int count_down_rec_cyc;
+};
+typedef struct AUDIO_GENERAL_CONFIG AUDIO_GENERAL_CONFIG;
+
+struct AUDIO_SAMPLE_INFO {
+    int sampling_rate;
+    int PCM_bitnum;
+};
+typedef struct AUDIO_SAMPLE_INFO AUDIO_SAMPLE_INFO;
+
+struct AUDIO_ADC_CONFIG {
+    AUDIO_GENERAL_CONFIG audioGeneralConfig;
+    AUDIO_SAMPLE_INFO sampleInfo;
+};
+typedef struct AUDIO_ADC_CONFIG AUDIO_ADC_CONFIG;
+
+struct AUDIO_CONFIG_ADC {
+    int instanceID;
+    AUDIO_ADC_CONFIG adcConfig;
+};
+typedef struct AUDIO_CONFIG_ADC AUDIO_CONFIG_ADC;
+
+typedef struct {
+    int instanceID;
+    int pRefClockID;
+    int pRefClock;
+} AUDIO_RPC_REFCLOCK;
+
+typedef struct {
+    int instanceID;
+    int pRefClockID;
+    int pRefClock;
+    RPCRES_LONG ret;
+    HRESULT res;
+} AUDIO_RPC_REFCLOCK_T;
+
+typedef struct {
+    int instanceID;
+    int focusID;
+} AUDIO_RPC_FOCUS;
+
+typedef struct {
+    int instanceID;
+    int focusID;
+    RPCRES_LONG ret;
+    HRESULT res;
+} AUDIO_RPC_FOCUS_T;
+
+struct AUDIO_OUT_GENERAL_CONFIG {
+    char interface_en;
+    char channel_out;
+    char count_down_play_en;
+    int count_down_play_cyc;
+};
+typedef struct AUDIO_OUT_GENERAL_CONFIG AUDIO_OUT_GENERAL_CONFIG;
+
+struct AUDIO_OUT_CS_INFO {
+    char non_pcm_valid;
+    char non_pcm_format;
+    int audio_format;
+    char spdif_consumer_use;
+    char copy_right;
+    char pre_emphasis;
+    char stereo_channel;
+};
+typedef struct AUDIO_OUT_CS_INFO AUDIO_OUT_CS_INFO;
+
+struct AUDIO_DAC_CONFIG {
+    AUDIO_OUT_GENERAL_CONFIG audioGeneralConfig;
+    AUDIO_SAMPLE_INFO sampleInfo;
+};
+typedef struct AUDIO_DAC_CONFIG AUDIO_DAC_CONFIG;
+
+struct AUDIO_OUT_SPDIF_CONFIG {
+    AUDIO_OUT_GENERAL_CONFIG audioGeneralConfig;
+    AUDIO_SAMPLE_INFO sampleInfo;
+    AUDIO_OUT_CS_INFO out_cs_info;
+};
+typedef struct AUDIO_OUT_SPDIF_CONFIG AUDIO_OUT_SPDIF_CONFIG;
+
+struct AUDIO_CONFIG_DAC_I2S {
+    int instanceID;
+    AUDIO_DAC_CONFIG dacConfig;
+};
+typedef struct AUDIO_CONFIG_DAC_I2S AUDIO_CONFIG_DAC_I2S;
+
+typedef struct {
+    int instanceID;
+    AUDIO_DAC_CONFIG dacConfig;
+    HRESULT res;
+} AUDIO_CONFIG_DAC_I2S_T;
+
+struct AUDIO_CONFIG_DAC_SPDIF {
+    int instanceID;
+    AUDIO_OUT_SPDIF_CONFIG spdifConfig;
+};
+typedef struct AUDIO_CONFIG_DAC_SPDIF AUDIO_CONFIG_DAC_SPDIF;
+
+typedef struct {
+    int instanceID;
+    AUDIO_OUT_SPDIF_CONFIG spdifConfig;
+    HRESULT res;
+} AUDIO_CONFIG_DAC_SPDIF_T;
+
+
+typedef struct 
+{
+    int base;
+    int limit;
+    int cp;
+    int rp;
+    int wp;
+} AUDIO_RINGBUF_PTR;
+
+typedef struct 
+{
+    unsigned long base;
+    unsigned long limit;
+    unsigned long cp;
+    unsigned long rp;
+    unsigned long wp;
+} AUDIO_RINGBUF_PTR_64;
+
+typedef struct
+{
+    ion_phys_addr_t pPhy;
+    unsigned int *pVirt;
+    unsigned int size;
+} ALSA_MEM_INFO;
+
+typedef struct
+{
+    unsigned int latency;
+    unsigned int ptsL;
+    unsigned int ptsH;
+    unsigned int sum;     // latency + ptsL
+    unsigned int decin_wp;
+    unsigned int decin_rp;
+} ALSA_LATENCY_INFO;
+
+struct AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS {
+    int instanceID;
+    enum AUDIO_ENUM_AIO_PRIVAETINFO type;
+    int argateInfo[16];
+};
+typedef struct AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS;
+
+//////////////////////////////////////////////////////////////////////////
+
+// RTK sound card
+typedef struct RTK_snd_card {
+    snd_card_t *card;
+    spinlock_t mixer_lock;
+    int mixer_volume[MIXER_ADDR_LAST+1][2];
+    int mixer_change;
+    int capture_source[MIXER_ADDR_LAST+1][2];
+    int capture_change; 
+    struct work_struct work_volume;
+    struct mutex rpc_lock;
+
+    struct snd_pcm *pcm;
+    struct snd_compr *compr;
+} RTK_snd_card_t;
+
+// RTK PCM instance
+typedef struct snd_card_RTK_pcm {
+	/******************************************************************************************************************
+	** CAN'T change the order of the following variables, bcz AO(on SCPU) will refer RINGBUFFER_HEADER decOutRing[8] **
+	******************************************************************************************************************/
+	RINGBUFFER_HEADER decOutRing[8];    /* big endian, in DEC-AO path, share with DEC and AO */
+	RTK_snd_card_t *card;
+	snd_pcm_substream_t *substream;
+	RINGBUFFER_HEADER decInbandRing;    /* big endian, in DEC-AO path, inband ring of DEC */
+
+	RINGBUFFER_HEADER decInRing[1];     /* big endian, uncache, in DEC-AO path, inring of DEC */
+	RINGBUFFER_HEADER decInRing_LE[1];  /* little endian, uncache, duplication of nHWInring */
+
+	snd_pcm_uframes_t nHWPtr;           /* in DEC-AO path, rp of in_ring of DEC, (0,1, ..., ,runntime->buffer_size-1) */
+	snd_pcm_uframes_t nPreHWPtr;
+	snd_pcm_uframes_t nPre_appl_ptr;
+	snd_pcm_uframes_t nHWReadSize;      /* less than runntime->period_size */
+	snd_pcm_uframes_t nTotalRead;
+	snd_pcm_uframes_t nTotalWrite;
+
+#ifdef DEBUG_RECORD
+	struct file *fp;
+	loff_t pos;                         /* The param for record data send to alsa */
+	mm_segment_t fs;
+	int ai_count;
+#endif
+
+	struct ion_handle *inRingHandle;
+
+	struct hrtimer hr_timer;           /* Hr timer for playback */
+	enum hrtimer_restart enHRTimer;    /* Hr timer state */
+	ktime_t ktime;                     /* Ktime for hr timer */
+	struct timer_list nStartTimer;
+	spinlock_t pcm_nLock;
+	//    AUDIO_PATH_T AudioPath;
+	SND_REALTEK_EOS_STATE_T nEOSState;
+	int DECAgentID;
+	int DECpinID;
+	int AOAgentID;
+	int AOpinID;
+	int volume;
+	int bInitRing;
+	int bHWinit;
+	int bStop;
+	int last_channel;
+	unsigned int decInbandData[64];     //inband ring
+	unsigned int *decOutData[8];        //decoder Output data
+	unsigned int nPeriodJiffies;
+	unsigned int nPeriodBytes;
+	unsigned int nRingSize;            // bytes
+#ifdef USE_ION_AUDIO_HEAP
+	ion_phys_addr_t phy_decOutData[8];  //physical address of Output data
+	ion_phys_addr_t phy_addr;           //physical addresss of snd_card_RTK_pcm_t;
+#else
+	dma_addr_t phy_decOutData[8];       //physical address of Output data
+	dma_addr_t phy_addr;                //physical addresss of snd_card_RTK_pcm_t;
+#endif
+	RINGBUFFER_HEADER decOutRing_LE[8];    /* little endian, in DEC-AO path, share with DEC and AO */
+} snd_card_RTK_pcm_t;
+
+typedef struct snd_card_RTK_capture_pcm {
+    RTK_snd_card_t *card;
+    snd_pcm_substream_t *substream;
+    RINGBUFFER_HEADER nAIRing[8];       /* big endian */
+    RINGBUFFER_HEADER nAIRing_LE[8];    /* little endian */
+    RINGBUFFER_HEADER nLPCMRing;        /* big endian */
+    RINGBUFFER_HEADER nLPCMRing_LE;     /* little endian */
+    RINGBUFFER_HEADER nPTSRingHdr;        /* big endian */
+    snd_pcm_uframes_t nAIRingWp;
+    snd_pcm_uframes_t nAIRingPreWp;
+    snd_pcm_uframes_t nTotalWrite;
+    AUDIO_FORMAT_OF_AI_SEND_TO_ALSA nAIFormat;
+
+	struct hrtimer hr_timer;           /* Hr timer for playback */
+	enum hrtimer_restart enHRTimer;    /* Hr timer state */
+	ktime_t ktime;                     /* Ktime for hr timer */
+    struct timer_list nStartTimer;
+    spinlock_t nLock;
+    //    SND_REALTEK_EOS_STATE_T nEOSState;
+    int AIAgentID;
+    int bInitRing;
+    int bStop;
+    int *pAIRingData[8];   // kernel virtual address
+    unsigned int *pLPCMData;
+    unsigned int nPeriodJiffies;
+    unsigned int nPeriodBytes;
+    unsigned int nFrameBytes;
+    unsigned int nRingSize; // bytes
+    unsigned int nLPCMRingSize;
+    int source_in;
+#ifdef USE_ION_AUDIO_HEAP
+    ion_phys_addr_t phy_pAIRingData[8]; //physical address of ai data
+    ion_phys_addr_t phy_pLPCMData;      //physical address of lpcm data
+    ion_phys_addr_t phy_addr;           //physical addresss of snd_card_RTK_capture_pcm_t;
+#else
+    dma_addr_t phy_pAIRingData[8];      //physical address of ai data
+    dma_addr_t phy_pLPCMData;           //physical address of lpcm data
+    dma_addr_t phy_addr;                //physical addresss of snd_card_RTK_capture_pcm_t;
+#endif
+    ALSA_MEM_INFO nPTSMem;
+    AUDIO_RINGBUF_PTR_64 nPTSRing;
+    struct timespec ts;
+} snd_card_RTK_capture_pcm_t;
+
+#define IF_ALSA_CAPTURE_LPCM(dpcm) ((dpcm)->nAIFormat == AUDIO_ALSA_FORMAT_16BITS_LE_LPCM || (dpcm)->nAIFormat == AUDIO_ALSA_FORMAT_24BITS_LE_LPCM )
+
+/************************************************************************/
+/* PROTOTYPE                                                            */
+/************************************************************************/
+int snd_realtek_hw_ring_write(RINGBUFFER_HEADER* ring, void *data, int len, unsigned int offset) ;
+int writeInbandCmd(snd_card_RTK_pcm_t *dpcm, void *data, int len);
+uint64_t snd_card_get_90k_pts(void);
+#if _DBG_CHECK_AI_HW_RING_DATA_EN
+static void snd_card_capture_lpcm_check_ringBuf(unsigned int data);
+#endif
+// RPC function
+int RPC_TOAGENT_CHECK_AUDIO_READY(void);
+int RPC_TOAGENT_SEND_AUDIO_VERSION(OMX_AUDIO_VERSION version);
+int RPC_TOAGENT_CONNECT_SVC(AUDIO_RPC_CONNECTION *pconnection);
+int RPC_TOAGENT_DESTROY_SVC(int instanceID);
+int RPC_TOAGENT_EOS_SVC(snd_pcm_substream_t * substream);
+int RPC_TOAGENT_FLUSH_SVC(AUDIO_RPC_SENDIO  *sendio);
+int RPC_TOAGENT_INBAND_EOS_SVC(snd_card_RTK_pcm_t * dpcm);
+int RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(AUDIO_RPC_RINGBUFFER_HEADER *header, int channel);
+int RPC_TOAGENT_PAUSE_SVC(int instance_id);
+int RPC_TOAGENT_RUN_SVC(int instance_id);
+int RPC_TOAGENT_STOP_SVC(int instanceID);
+int RPC_TOAGENT_PP_INIT_PIN_SVC(int instanceID);
+int RPC_TOAGENT_CREATE_AO_AGENT(int* aoId, int pinId);
+int RPC_TOAGENT_CREATE_PP_AGENT(int* ppId, int* pinId);
+int RPC_TOAGENT_GET_AO_FLASH_PIN(snd_card_RTK_pcm_t *);
+int RPC_TOAGENT_GET_GLOBAL_PP_PIN(int* pinId);
+int RPC_TOAGENT_CREATE_DECODER_AGENT(int* decId, int* pinId);
+int RPC_TOAGENT_SET_AO_FLASH_VOLUME(snd_pcm_substream_t * substream);
+int RPC_TOAGENT_AO_PRIVATE_INFO(snd_pcm_substream_t *substream);
+int RPC_TOAGENT_RELEASE_AO_FLASH_PIN(snd_card_RTK_pcm_t *);
+int RPC_TOAGENT_RELEASE_INIT_AO_RING(snd_pcm_substream_t * substream);
+int RPC_TOAGENT_PAUSE(snd_pcm_substream_t * substream);
+int RPC_TOAGENT_SET_TRUEHD_ERR_SELF_RESET(bool isON);
+int RPC_TOAGENT_SET_VOLUME(int volume);
+int RPC_TOAGENT_GET_VOLUME(snd_card_RTK_pcm_t *mars);
+int RPC_TOAGENT_SET_HDMI_OUTPUT_MODE(int mode);
+int RPC_TOAGENT_SET_SPDIF_OUTPUT_MODE(int mode);
+int RPC_TOAGENT_PUT_SHARE_MEMORY(void *p, int type);
+int RPC_TOAGENT_PUT_SHARE_MEMORY_LATENCY(void *p, void *p2, int decID, int type);
+int RPC_TOAGENT_CREATE_AI_AGENT(snd_card_RTK_capture_pcm_t *dpcm);
+int RPC_TOAGENT_AI_CONNECT_ALSA(snd_pcm_runtime_t *runtime);
+int RPC_TOAGENT_AI_DISCONNECT_ALSA_AUDIO(snd_pcm_runtime_t *runtime);
+int RPC_TOAGENT_CONFIGURE_AI_HW(snd_pcm_runtime_t *runtime);
+int RPC_TOAGENT_SWITCH_FOCUS(AUDIO_RPC_FOCUS *focus);
+int RPC_TOAGENT_DAC_I2S_CONFIG(AUDIO_CONFIG_DAC_I2S *config);
+int RPC_TOAGENT_DAC_SPDIF_CONFIG(AUDIO_CONFIG_DAC_SPDIF *config);
+int RPC_TOAGENT_SETREFCLOCK(AUDIO_RPC_REFCLOCK *pClock);
+int RPC_TOAGENT_AI_CONFIG_HDMI_RX_IN(snd_card_RTK_capture_pcm_t *dpcm);
+int RPC_TOAGENT_AI_CONFIG_I2S_IN(snd_card_RTK_capture_pcm_t *dpcm);
+int RPC_TOAGENT_AI_CONFIG_AUDIO_IN(snd_card_RTK_capture_pcm_t *dpcm);
+int RPC_TOAGENT_DESTROY_AI_FLOW_SVC(int instance_id);
+int RPC_TOAGENT_AI_CONFIG_NONPCM_IN(snd_card_RTK_capture_pcm_t *dpcm);
+int RPC_TOAGENT_SET_AI_FLASH_VOLUME(snd_card_RTK_capture_pcm_t *dpcm, unsigned int volume);
+int RPC_TOAGENT_SET_SOFTWARE_AI_FLASH_VOLUME(snd_card_RTK_capture_pcm_t *dpcm, unsigned int volume);
+int RPC_TOAGENT_SET_LOW_WATER_LEVEL(bool isLowWater);
+int RPC_TOAGENT_GET_AI_AGENT(snd_card_RTK_capture_pcm_t *dpcm);
+int RPC_TOAGENT_SET_EQ(snd_card_RTK_pcm_t *dpcm, struct AUDIO_RPC_EQUALIZER_MODE *equalizer_mode);
+
+#endif //SND_REALTEK_H
diff --git a/sound/arm/snd-realtek_RPC.c b/sound/arm/snd-realtek_RPC.c
new file mode 100644
index 00000000..53d6600
--- /dev/null
+++ b/sound/arm/snd-realtek_RPC.c
@@ -0,0 +1,3626 @@
+/**
+ * snd-realtek_RPC.c - Realtek alsa driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <linux/init.h>
+#include <linux/jiffies.h>
+#include <linux/slab.h>
+#include <linux/time.h>
+#include <linux/wait.h>
+#include <linux/moduleparam.h>
+#include <linux/delay.h>
+#include <sound/core.h>
+#include <sound/control.h>
+#include <sound/pcm.h>
+#include <sound/rawmidi.h>
+#include <sound/initval.h>
+#include <linux/mutex.h>
+#include <linux/ioctl.h> /* needed for the _IOW etc stuff used later */
+#include <linux/syscalls.h> /* needed for the _IOW etc stuff used later */
+#include <linux/mpage.h>
+#include <linux/dcache.h>
+//#include <linux/pageremap.h>
+#include <linux/timer.h>
+#include <linux/workqueue.h>
+#include <linux/dma-mapping.h>
+#include <sound/asound.h>
+#include <asm/cacheflush.h>
+#include "snd-realtek.h"
+#include <rtk_rpc.h>
+#include <soc/realtek/kernel-rpc.h>
+
+#ifdef USE_ION_AUDIO_HEAP
+
+#ifdef CONFIG_64BIT
+#define PRIVATE_INFO_MASK 0xFFFFFFFFFFFFFFFC
+#else
+#define PRIVATE_INFO_MASK 0xFFFFFFFC
+#endif
+
+extern struct ion_client *alsa_client;
+
+int RPC_TOAGENT_CHECK_AUDIO_READY() 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    RPC_DEFAULT_INPUT_T *rpc = NULL;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_CHECK_READY,
+        CONVERT_FOR_AVCPU(dat), //rpc->info address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->info))), //rpc->retval address
+        &rpc->ret)) {
+        ALSA_WARNING("[ALSA %s RPC fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    if (rpc->ret != S_OK ) {
+        ALSA_WARNING("[ALSA %s RPC fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    if (rpc->info == 0) {
+        ALSA_WARNING("[ALSA Audio is not ready]\n");
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d ] success\n", __FILE__, __FUNCTION__, __LINE__);
+    // successful
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_SEND_AUDIO_VERSION(OMX_AUDIO_VERSION version)
+{
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    HRESULT RPC_ret;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+       goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = ion_map_kernel(alsa_client, handle);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+
+    memset(cmd, 0, sizeof(*cmd));
+    cmd->type = htonl(ENUM_PRIVATEINFO_OMX_AUDIO_VERSION);
+    cmd->privateInfo[0] = htonl(version);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat), //cmd address
+        CONVERT_FOR_AVCPU(dat + offset), //res address
+        &RPC_ret)) {
+            ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+            goto exit;
+        }
+
+    if (RPC_ret != S_OK) {
+            ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+            goto exit;
+        }
+
+    ret = 0;
+
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_CREATE_PP_AGENT(int* ppId, int* pinId)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    RPC_CREATE_AO_AGENT_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->info.instanceID = htonl(0);
+    rpc->info.type = htonl(AUDIO_PP_OUT);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_CREATE_AGENT,
+        CONVERT_FOR_AVCPU(dat), //rpc->info address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->info))),//rpc->retval address
+        &rpc->ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ntohl(rpc->retval.result) != S_OK || rpc->ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    *ppId = ntohl(rpc->retval.data);
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = RPC_TOAGENT_GET_GLOBAL_PP_PIN(pinId);
+
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_CREATE_AO_AGENT(int* aoId, int pinId)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    RPC_CREATE_AO_AGENT_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->info.instanceID = htonl(0);
+    rpc->info.type = htonl(pinId);
+   
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_CREATE_AGENT,
+        CONVERT_FOR_AVCPU(dat), //rpc->info address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->info))),//rpc->retval address
+        &rpc->ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ntohl(rpc->retval.result) != S_OK || rpc->ret != S_OK) {
+        ALSA_WARNING("[ALSA %x %x %s %d RPC fail]\n", rpc->retval.result, rpc->ret, __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    *aoId = ntohl(rpc->retval.data);
+    //TRACE_CODE("[%s %s %d] aoid %d success\n", __FILE__, __FUNCTION__, __LINE__, *aoId);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_PUT_SHARE_MEMORY_LATENCY(void *p, void *p2, int decID, int type)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    int ret = 0;
+    int magic_num = 2379;
+    HRESULT RPC_ret;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = ion_map_kernel(alsa_client, handle);
+    //res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)(((unsigned long)cmd + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS) + 8) & PRIVATE_INFO_MASK);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+    //offset = (unsigned long)res - (unsigned long)cmd;
+    printk("[%s %d ion_alloc p1 %x p2 %x decID %d type %d\n", __FUNCTION__, __LINE__, (uint32_t)((long)p), (uint32_t)((long)p2), decID, type);
+    memset(cmd, 0, sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    cmd->type = htonl(type);
+    cmd->privateInfo[0] = (uint32_t)htonl((uint32_t)((long)p));
+    cmd->privateInfo[1] = htonl(magic_num);
+    cmd->privateInfo[2] = (uint32_t)htonl((uint32_t)((long)p2));
+    cmd->privateInfo[3] = (uint32_t)htonl((uint32_t)(decID));
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &RPC_ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (RPC_ret != S_OK ) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_PUT_SHARE_MEMORY(void *p, int type)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;  
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    int ret = 0;
+    HRESULT RPC_ret;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = ion_map_kernel(alsa_client, handle);
+    //res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)(((unsigned long)cmd + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS) + 8) & PRIVATE_INFO_MASK);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+    //offset = (unsigned long)res - (unsigned long)cmd;
+
+    memset(cmd, 0, sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    cmd->type = htonl(type);
+    cmd->privateInfo[0] = (uint32_t)htonl((uint32_t)((long)p));
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &RPC_ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (RPC_ret != S_OK ) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_GET_AO_FLASH_PIN(snd_card_RTK_pcm_t *dpcm) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;  
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    HRESULT RPC_ret;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = ion_map_kernel(alsa_client, handle);
+    //res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)(((unsigned long)cmd + sizeof(*cmd) + 8) & PRIVATE_INFO_MASK);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+    //offset = (unsigned long)res - (unsigned long)cmd;
+    memset(cmd, 0, sizeof(*cmd));
+    memset(res, 0, sizeof(*res));
+    cmd->instanceID = htonl(dpcm->AOAgentID);   
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_GET_FLASH_PIN);
+    cmd->privateInfo[0] = 0xFF; 
+    cmd->privateInfo[1] = 0xFF;
+    cmd->privateInfo[2] = 0xFF; 
+    cmd->privateInfo[3] = 0xFF;     
+    cmd->privateInfo[4] = 0xFF;     
+    cmd->privateInfo[5] = 0xFF; 
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat), //cmd address
+        CONVERT_FOR_AVCPU(dat + offset),//res address
+        &RPC_ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (RPC_ret != S_OK ) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+    
+    ret = ntohl(res->privateInfo[0]);
+    
+    if (ret < FLASH_AUDIO_PIN_1 || ret > FLASH_AUDIO_PIN_3) {
+        ALSA_WARNING("[ALSA %s %d RPC %d fail]\n", __FUNCTION__, __LINE__, ret);
+        ret = -1;
+    }
+    //ALSA_WARNING("GET_AO_FLASH_PIN ret %d\n", ret);
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_GET_GLOBAL_PP_PIN(int* pinId)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    HRESULT RPC_ret;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = ion_map_kernel(alsa_client, handle);
+    //res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)(cmd + sizeof(*cmd)+8) & PRIVATE_INFO_MASK);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+    //offset = (unsigned long)res - (unsigned long)cmd;
+
+    memset(cmd, 0, sizeof(*cmd));
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_GET_PP_FREE_PINID);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat), //cmd address
+        CONVERT_FOR_AVCPU(dat + offset), //res address
+        &RPC_ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (RPC_ret != S_OK ) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (res != NULL && res->privateInfo[0] == 0x44495050) {
+        //int first = res->privateInfo[1];
+        //TRACE_CODE("##### get PP Pin = %ld first %d\n", ntohl(res->privateInfo[2]), ntohl(first));
+        *pinId = ntohl(res->privateInfo[2]);
+        ret = 0;
+    } else {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+    }
+    //ALSA_WARNING("GET_GLOBAL_PIN ret %d\n", ret);
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_SET_AO_FLASH_VOLUME(snd_pcm_substream_t * substream) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;
+    HRESULT rpc_ret;
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    //cmd = (AUDIO_RPC_PRIVATEINFO_PARAMETERS *) ((unsigned int)page_address(page));
+    //res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *) ((((unsigned int) page_address(page) + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS)+8) & 0xFFFFFFFC));
+    cmd = ion_map_kernel(alsa_client, handle);
+    //res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)(((unsigned long)cmd + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS) + 8) & PRIVATE_INFO_MASK);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+    //offset = (unsigned long)res - (unsigned long)cmd;
+
+    memset(cmd, 0, sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    cmd->instanceID = htonl(dpcm->AOAgentID);
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_CONTROL_FLASH_VOLUME);
+    cmd->privateInfo[0] = htonl(dpcm->AOpinID);
+    cmd->privateInfo[1] = htonl((31-dpcm->volume));
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &rpc_ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc_ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    ALSA_VitalPrint("[ALSA set AO_pin %d volume %d]\n", dpcm->AOpinID, dpcm->volume);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_CREATE_DECODER_AGENT(int* decID, int* pinID)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_CREATE_PCM_DECODER_CTRL_T* rpc = NULL;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->instance.type = htonl(AUDIO_DECODER);
+    rpc->instance.instanceID = htonl(-1);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_CREATE_AGENT,
+        CONVERT_FOR_AVCPU(dat), //rpc->instance address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->instance))), //rpc->res address
+        &rpc->ret)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->ret != S_OK) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    *decID = ntohl(rpc->res.data);
+    *pinID = BASE_BS_IN;
+
+    //printk("[ALSA Create Decoder instance %d]\n", *decID/*dpcm->DECAgentID*/);
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+// data of AUDIO_RPC_RINGBUFFER_HEADER is "hose side"
+int RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(AUDIO_RPC_RINGBUFFER_HEADER *header, int buffer_count) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_INITRINGBUFFER_HEADER_T *rpc;
+    int ch;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->header.instanceID = htonl(header->instanceID);
+    rpc->header.pinID = htonl(header->pinID);
+    rpc->header.readIdx = htonl(header->readIdx); 
+    rpc->header.listSize = htonl(header->listSize);
+
+    //printk(" header instance ID %d\n", header->instanceID);
+    //printk(" header pinID       %d\n", header->pinID);
+    //printk(" header readIdx     %d\n", header->readIdx);
+    //printk(" header listSize    %d\n", header->listSize);
+
+    for ( ch = 0; ch < buffer_count; ch++) {
+        //rpc_initringbuffer->header.pRingBufferHeaderList[i] = htonl(0xa0000000|(((unsigned int) header->pRingBufferHeaderList[i])&0x1FFFFFFF));
+        //printk("[test]header.pRingBufferHeaderList[%d] = %lx\n", ch, header->pRingBufferHeaderList[ch]); 
+        rpc->header.pRingBufferHeaderList[ch] = htonl((unsigned int) header->pRingBufferHeaderList[ch]);
+        //rpc->header.pRingBufferHeaderList[ch] = htonl(0xa0000000|(((unsigned int) header->pRingBufferHeaderList[ch])&0x1FFFFFFF));
+    }
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_INIT_RINGBUF,
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->ret) + sizeof(rpc->res))), //rpc->header address
+        CONVERT_FOR_AVCPU(dat), //rpc->ret address
+        &rpc->res)) {
+        ALSA_WARNING("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->ret.result) != S_OK) {
+        ALSA_WARNING("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_CONNECT_SVC(AUDIO_RPC_CONNECTION *pconnection) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_CONNECTION_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->out.srcInstanceID = htonl(pconnection->srcInstanceID);
+    rpc->out.srcPinID = htonl(pconnection->srcPinID);
+    rpc->out.desInstanceID = htonl(pconnection->desInstanceID);
+    rpc->out.desPinID= htonl(pconnection->desPinID);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_CONNECT,
+        CONVERT_FOR_AVCPU(dat), //rpc->out address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->out))), //rpc->ret
+        &rpc->res)) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->ret.result) != S_OK) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_SWITCH_FOCUS(AUDIO_RPC_FOCUS *focus)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    AUDIO_RPC_FOCUS_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->instanceID = htonl(focus->instanceID);
+    rpc->focusID = htonl(focus->focusID);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_SWITCH_FOCUS,
+        CONVERT_FOR_AVCPU(dat), //rpc->out address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->instanceID) + sizeof(rpc->focusID))), //rpc->ret
+        &rpc->res)) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->ret.result) != S_OK) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_DAC_I2S_CONFIG(AUDIO_CONFIG_DAC_I2S *config)
+{
+    AUDIO_CONFIG_DAC_I2S_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    HRESULT *result;
+    unsigned long offset;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_CONFIG_DAC_I2S_T));
+    result = (HRESULT *)((unsigned long)rpc + offset);
+    rpc->instanceID = htonl(config->instanceID);
+    rpc->dacConfig.audioGeneralConfig.interface_en = htonl(config->dacConfig.audioGeneralConfig.interface_en);
+    rpc->dacConfig.audioGeneralConfig.channel_out = htonl(config->dacConfig.audioGeneralConfig.channel_out);
+    rpc->dacConfig.audioGeneralConfig.count_down_play_en = htonl(config->dacConfig.audioGeneralConfig.count_down_play_en);
+    rpc->dacConfig.audioGeneralConfig.count_down_play_cyc = htonl(config->dacConfig.audioGeneralConfig.count_down_play_cyc);
+    rpc->dacConfig.sampleInfo.sampling_rate = htonl(config->dacConfig.sampleInfo.sampling_rate);
+    rpc->dacConfig.sampleInfo.PCM_bitnum = htonl(config->dacConfig.sampleInfo.PCM_bitnum);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_DAC_I2S_CONFIG,
+        CONVERT_FOR_AVCPU(dat), //rpc->out address
+        CONVERT_FOR_AVCPU(dat + offset), //rpc->ret
+        &rpc->res)) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ntohl(*result) != S_OK) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_DAC_SPDIF_CONFIG(AUDIO_CONFIG_DAC_SPDIF *config)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    AUDIO_CONFIG_DAC_SPDIF_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    HRESULT *result;
+    unsigned long offset;
+
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_CONFIG_DAC_SPDIF_T));
+    result = (HRESULT *)((unsigned long)rpc + offset);
+    rpc->instanceID = htonl(config->instanceID);
+    rpc->spdifConfig.audioGeneralConfig.interface_en = htonl(config->spdifConfig.audioGeneralConfig.interface_en);
+    rpc->spdifConfig.audioGeneralConfig.channel_out = htonl(config->spdifConfig.audioGeneralConfig.channel_out);
+    rpc->spdifConfig.audioGeneralConfig.count_down_play_en = htonl(config->spdifConfig.audioGeneralConfig.count_down_play_en);
+    rpc->spdifConfig.audioGeneralConfig.count_down_play_cyc = htonl(config->spdifConfig.audioGeneralConfig.count_down_play_cyc);
+    rpc->spdifConfig.sampleInfo.sampling_rate = htonl(config->spdifConfig.sampleInfo.sampling_rate);
+    rpc->spdifConfig.sampleInfo.PCM_bitnum = htonl(config->spdifConfig.sampleInfo.PCM_bitnum);
+    rpc->spdifConfig.out_cs_info.non_pcm_valid = htonl(config->spdifConfig.out_cs_info.non_pcm_valid);
+    rpc->spdifConfig.out_cs_info.non_pcm_format = htonl(config->spdifConfig.out_cs_info.non_pcm_format);
+    rpc->spdifConfig.out_cs_info.audio_format = htonl(config->spdifConfig.out_cs_info.audio_format);
+    rpc->spdifConfig.out_cs_info.spdif_consumer_use = htonl(config->spdifConfig.out_cs_info.spdif_consumer_use);
+    rpc->spdifConfig.out_cs_info.copy_right = htonl(config->spdifConfig.out_cs_info.copy_right);
+    rpc->spdifConfig.out_cs_info.pre_emphasis = htonl(config->spdifConfig.out_cs_info.pre_emphasis);
+    rpc->spdifConfig.out_cs_info.stereo_channel = htonl(config->spdifConfig.out_cs_info.stereo_channel);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_DAC_SPDIF_CONFIG,
+        CONVERT_FOR_AVCPU(dat), //rpc->out address
+        CONVERT_FOR_AVCPU(dat + offset), //rpc->ret
+        &rpc->res)) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ntohl(*result) != S_OK) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_SETREFCLOCK(AUDIO_RPC_REFCLOCK *pClock)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    AUDIO_RPC_REFCLOCK_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->instanceID = htonl(pClock->instanceID);
+    rpc->pRefClockID = htonl(pClock->pRefClockID);
+    rpc->pRefClock = htonl(pClock->pRefClock);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_SETREFCLOCK,
+        CONVERT_FOR_AVCPU(dat), //rpc->out address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->instanceID) + sizeof(rpc->pRefClockID) + sizeof(rpc->pRefClock))), //rpc->ret
+        &rpc->res)) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->ret.result) != S_OK) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_PAUSE_SVC(int instance_id) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    RPC_TOAGENT_PAUSE_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->inst_id = htonl(instance_id);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PAUSE,
+        CONVERT_FOR_AVCPU(dat), //rpc->inst_id address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->inst_id))),//rpc->retval address
+        &rpc->res)) {
+        ALSA_WARNING("[%s %d RPC fail\n]", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK) {
+        ALSA_WARNING("[%s %d RPC fail\n]", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_DESTROY_AI_FLOW_SVC(int instance_id) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS *rpc = NULL;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    HRESULT res;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->type = htonl(ENUM_PRIVATEINFO_AIO_ALSA_DESTROY_AI_FLOW);
+    rpc->instanceID = htonl(instance_id);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_AIO_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat), //rpc->inst_id address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(*rpc))),//rpc->retval address
+        &res)) {
+        ALSA_WARNING("[%s %d RPC fail\n]", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_RUN_SVC(int instance_id) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    RPC_TOAGENT_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->inst_id = htonl(instance_id);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_RUN,
+        CONVERT_FOR_AVCPU(dat), //rpc->inst_id address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->inst_id))), //rpc->retval address
+        &rpc->res)) {
+        ALSA_WARNING("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->retval.result) != S_OK) {
+        ALSA_WARNING("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}  
+
+int RPC_TOAGENT_FLUSH_SVC(AUDIO_RPC_SENDIO  *sendio) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_TOAGENT_FLASH_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA %s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->sendio.instanceID = htonl(sendio->instanceID);
+    rpc->sendio.pinID = htonl(sendio->pinID);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_FLUSH,
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->retval) + sizeof(rpc->res))), //rpc->sendio address
+        CONVERT_FOR_AVCPU(dat), //rpc->retval address
+        &rpc->res)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->retval.result) != S_OK) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_RELEASE_AO_FLASH_PIN(snd_card_RTK_pcm_t *dpcm) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    HRESULT rpc_ret = 0;
+    int ret = -1;
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    TRACE_RPC();
+    if (dpcm->AOpinID < FLASH_AUDIO_PIN_1 || dpcm->AOpinID > FLASH_AUDIO_PIN_3) {
+       ALSA_WARNING("[%d @ %s %d]\n", dpcm->AOpinID, __FUNCTION__, __LINE__);
+       goto exit;
+    }
+
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = ion_map_kernel(alsa_client, handle);
+    //res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)(((unsigned long)cmd + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS) + 8) & PRIVATE_INFO_MASK);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+    //offset = (unsigned long)res - (unsigned long)cmd;
+
+    memset(cmd, 0, sizeof(*cmd));
+    cmd->instanceID = htonl(dpcm->AOAgentID);
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_RELEASE_FLASH_PIN);
+    cmd->privateInfo[0] = htonl(dpcm->AOpinID);
+    cmd->privateInfo[1] = 0xFF;
+    cmd->privateInfo[2] = 0xFF;
+    cmd->privateInfo[3] = 0xFF;
+    cmd->privateInfo[4] = 0xFF;
+    cmd->privateInfo[5] = 0xFF;
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat), //cmd address
+        CONVERT_FOR_AVCPU(dat + offset), //res address
+        &rpc_ret)) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+
+    if (rpc_ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_STOP_SVC(int instanceID) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_TOAGENT_STOP_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA %s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+ 
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->instanceID = htonl(instanceID);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_STOP,
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->retval) + sizeof(rpc->res))), //rpc->instanceID address
+        CONVERT_FOR_AVCPU(dat),//rpc->retval address
+        &rpc->res)) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->retval.result) != S_OK) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_PP_INIT_PIN_SVC(int instanceID)
+{
+    RPC_TOAGENT_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->inst_id = htonl(instanceID);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_VIDEO_KERNEL_RPC_PP_INIT_PIN,
+        CONVERT_FOR_AVCPU(dat), //rpc->inst_id address
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->inst_id))), //rpc->retval address
+        &rpc->res)) {
+        ALSA_WARNING("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->retval.result) != S_OK) {
+        ALSA_WARNING("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_DESTROY_SVC(int instanceID) 
+{
+    RPC_TOAGENT_DESTROY_T *rpc;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+   handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA %s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->instanceID = htonl(instanceID);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_DESTROY,
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->retval) + sizeof(rpc->res))), //rpc->instanceID address
+        CONVERT_FOR_AVCPU(dat), //rpc->retval address
+        &rpc->res)) {
+        ALSA_WARNING("%s %d RPC fail\n", __FILE__, __LINE__);
+        goto exit;
+    }
+
+    if (rpc->res != S_OK || ntohl(rpc->retval.result) != S_OK) {
+        ALSA_WARNING("%s %d RPC fail\n", __FILE__, __LINE__);
+        goto exit;
+    }
+
+//    printk(KERN_ALERT "[ALSA] @ %s\n", __FUNCTION__);
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_INBAND_EOS_SVC(snd_card_RTK_pcm_t * dpcm) 
+{
+    AUDIO_DEC_EOS cmd ;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    cmd.header.type = htonl(AUDIO_DEC_INBAND_CMD_TYPE_EOS);
+    cmd.header.size = htonl(sizeof(AUDIO_DEC_EOS));
+    cmd.EOSID = 0;
+    cmd.wPtr = htonl(dpcm->decInRing_LE[0].writePtr);
+#ifdef CONFIG_64BIT
+    writeInbandCmd(dpcm, &cmd, sizeof(AUDIO_DEC_EOS));
+#else
+    //snd_realtek_hw_ring_write(((unsigned int)dpcm->decInbandRing - (unsigned int)dpcm + dpcm->phy_addr), &cmd, sizeof(AUDIO_DEC_EOS));
+    snd_realtek_hw_ring_write(&dpcm->decInbandRing, &cmd, sizeof(AUDIO_DEC_EOS), (unsigned int)dpcm - (unsigned int)dpcm->phy_addr);
+#endif
+    return 0;
+}
+
+// set TRUEHD_ERR_SELF_RESET_ENABLED
+int RPC_TOAGENT_SET_TRUEHD_ERR_SELF_RESET(bool isON)
+{
+    AUDIO_CONFIG_COMMAND *config;
+    unsigned int *res;
+    HRESULT ret;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+    TRACE_RPC();
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    //config = (AUDIO_CONFIG_COMMAND  *) (unsigned int)page_address(page);
+    config = ion_map_kernel(alsa_client, handle);
+    config->msgID = htonl(AUDIO_CONFIG_TRUEHD_ERR_SELF_RESET_ENABLED);
+    config->value[0] = htonl(isON);
+
+    //res = (unsigned int*) (((unsigned long)config + sizeof(AUDIO_CONFIG_COMMAND) + 8) & PRIVATE_INFO_MASK);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_CONFIG_COMMAND));
+    res = (unsigned int*)((unsigned long)config + offset);
+    //offset = (unsigned long)res - (unsigned long)config;
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_AUDIO_CONFIG,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &ret)) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+
+    if (ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+// set AO volume
+int RPC_TOAGENT_SET_VOLUME(int volume) 
+{
+    AUDIO_CONFIG_COMMAND *config;
+    unsigned int *res;
+    HRESULT ret;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    TRACE_RPC();
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    //config = (AUDIO_CONFIG_COMMAND  *) (unsigned int)page_address(page);
+    config = ion_map_kernel(alsa_client, handle);
+    config->msgID = htonl(AUDIO_CONFIG_CMD_VOLUME);
+    config->value[0] = htonl(31 - volume);
+
+    //res = (unsigned int*) (((unsigned long)config + sizeof(AUDIO_CONFIG_COMMAND) + 8) & PRIVATE_INFO_MASK);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_CONFIG_COMMAND));
+    res = (unsigned int*)((unsigned long)config + offset);
+    //offset = (unsigned long)res - (unsigned long)config;
+
+    // set gpAudio->ao_volume_level(from Audio FW)
+    //if (send_rpc_command(RPC_AUDIO, ENUM_KERNEL_RPC_VOLUME_CONTROL, (unsigned int) config,(unsigned int) res, &ret)) {
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_VOLUME_CONTROL,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &ret)) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+
+    if (ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+// get AI ID
+int RPC_TOAGENT_GET_AI_AGENT(snd_card_RTK_capture_pcm_t *dpcm)
+{
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *in;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *out;
+    int offset;
+    HRESULT ret;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    in = ion_map_kernel(alsa_client, handle);
+    out = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)in + offset);
+    in->type = htonl(ENUM_PRIVATEINFO_AIO_GET_AUDIO_PROCESSING_AI);
+
+	if (send_rpc_command(RPC_AUDIO,
+		ENUM_KERNEL_RPC_AIO_PRIVATEINFO,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + offset),
+		&ret)) {
+		ALSA_WARNING("[fail %s %d]\n", __FUNCTION__, __LINE__);
+		goto exit;
+	}
+
+    dpcm->AIAgentID = ntohl(out->privateInfo[0]);
+	ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+// get AO volume
+int RPC_TOAGENT_GET_VOLUME(snd_card_RTK_pcm_t *mars) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    int volume = 0;
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *pArg;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *pRet;
+    int offset;
+    HRESULT rc;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    pArg = ion_map_kernel(alsa_client, handle);
+    pRet = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)pArg + offset);
+    pArg->type = htonl(ENUM_PRIVATEINFO_AUDIO_GET_MUTE_N_VOLUME);
+//    flush_dcache_page(page);
+
+    //if (send_rpc_command(RPC_AUDIO, ENUM_KERNEL_RPC_GET_MUTE_N_VOLUME , (unsigned int) &(config->param),(unsigned int) &(config->res), &(config->ret))) {
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_GET_MUTE_N_VOLUME,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &rc)) {
+        ALSA_WARNING("[fail %s %d]\n", __FUNCTION__, __LINE__);
+        volume = -1;
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    // get gpAudio->ao_volume_level (from audio FW)
+    volume = ntohl(pRet->privateInfo[1]);
+
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return volume;
+}
+
+// set HDMI output mode
+int RPC_TOAGENT_SET_HDMI_OUTPUT_MODE(int mode)
+{
+    AUDIO_CONFIG_COMMAND *config;
+    unsigned int *res;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    TRACE_RPC();
+    TRACE_CODE("[%s %s %d] mode=%d\n", __FILE__, __FUNCTION__, __LINE__, mode);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    config = ion_map_kernel(alsa_client, handle);
+
+    // first RPC: AUDIO_CONFIG_CMD_SPDIF
+    config->msgID = htonl(AUDIO_CONFIG_CMD_SPDIF);
+    switch (mode)
+    {
+        case AUDIO_DIGITAL_RAW:
+            config->value[0] = config->value[1] = htonl(ENUM_AUDIO_SPDIF_NON_PCM_TYPE);
+            config->value[2] = htonl(1);
+            break;
+        case AUDIO_DIGITAL_AUTO:
+            config->value[0] = config->value[1] = htonl(ENUM_AUDIO_SPDIF_NON_PCM_TYPE);
+            config->value[2] = htonl(1);
+            break;
+        case AUDIO_DIGITAL_LPCM_MULTI_CH:
+            config->value[0] = config->value[1] = htonl(ENUM_AUDIO_ENABLE_DOWNMIX);
+            config->value[2] = htonl(1);
+            break;
+        case AUDIO_DIGITAL_LPCM_DUAL_CH:
+        default:
+            config->value[0] = config->value[1] = htonl(ENUM_AUDIO_ENABLE_DOWNMIX);
+            config->value[2] = htonl(1);
+            break;
+    }
+
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_CONFIG_COMMAND));
+    res = (unsigned int*)((unsigned long)config + offset);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_VOLUME_CONTROL,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &ret)) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+
+    if (ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+
+    // second RPC: AUDIO_CONFIG_CMD_HDMI_CHANNEL_OUT
+    config->msgID = htonl(AUDIO_CONFIG_CMD_HDMI_CHANNEL_OUT);
+    switch (mode)
+    {
+        case AUDIO_DIGITAL_RAW:
+            config->value[0] = htonl(1);
+            break;
+        case AUDIO_DIGITAL_AUTO:
+            config->value[0] = htonl(0);
+            break;
+        case AUDIO_DIGITAL_LPCM_MULTI_CH:
+            config->value[0] = htonl(1);
+            break;
+        case AUDIO_DIGITAL_LPCM_DUAL_CH:
+        default:
+            config->value[0] = htonl(0);
+            break;
+    }
+
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_CONFIG_COMMAND));
+    res = (unsigned int*)((unsigned long)config + offset);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_VOLUME_CONTROL,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &ret)) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+
+    if (ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+// set SPDIF output mode
+int RPC_TOAGENT_SET_SPDIF_OUTPUT_MODE(int mode)
+{
+    AUDIO_CONFIG_COMMAND *config;
+    unsigned int *res;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    TRACE_RPC();
+    TRACE_CODE("[%s %s %d] mode=%d\n", __FILE__, __FUNCTION__, __LINE__, mode);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    config = ion_map_kernel(alsa_client, handle);
+
+    // RPC: AUDIO_CONFIG_CMD_SPDIF
+    config->msgID = htonl(AUDIO_CONFIG_CMD_SPDIF);
+    switch (mode)
+    {
+        case AUDIO_DIGITAL_RAW:
+            config->value[0] = config->value[1] = htonl(ENUM_AUDIO_SPDIF_NON_PCM_TYPE);
+            config->value[2] = htonl(0);
+            break;
+        case AUDIO_DIGITAL_LPCM_DUAL_CH:
+        default:
+            config->value[0] = config->value[1] = htonl(ENUM_AUDIO_ENABLE_DOWNMIX);
+            config->value[2] = htonl(0);
+            break;
+    }
+
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_CONFIG_COMMAND));
+    res = (unsigned int*)((unsigned long)config + offset);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_VOLUME_CONTROL,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &ret)) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+
+    if (ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_AI_CONFIG_HDMI_RX_IN(snd_card_RTK_capture_pcm_t *dpcm)
+{
+    AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS *rpc = NULL;
+    HRESULT RPC_ret;
+    unsigned int offset;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(alsa_client, handle, &dat, &len) != 0)
+    {
+        ALSA_WARNING("[ALSA %s %d fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS));
+    rpc->instanceID = htonl(dpcm->AIAgentID);
+    rpc->type = htonl(ENUM_PRIVATEINFO_AIO_AI_PRIVATEINFO);
+	rpc->argateInfo[0] = htonl(ENUM_AI_PRIVATE_HDMI_RX);
+
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_AIO_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &RPC_ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(RPC_ret != S_OK )
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_AI_CONFIG_I2S_IN(snd_card_RTK_capture_pcm_t *dpcm)
+{
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *rpc = NULL;
+    HRESULT RPC_ret;
+    unsigned int offset;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(alsa_client, handle, &dat, &len) != 0)
+    {
+        ALSA_WARNING("[ALSA %s %d fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    rpc->instanceID = htonl(dpcm->AIAgentID);
+    rpc->type = htonl(ENUM_PRIVATEINFO_AUDIO_AI_PAD_IN);
+	rpc->privateInfo[0] = htonl(48000);
+
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &RPC_ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(RPC_ret != S_OK )
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_AI_CONFIG_AUDIO_IN(snd_card_RTK_capture_pcm_t *dpcm)
+{
+    AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS *rpc = NULL;
+    HRESULT RPC_ret;
+    unsigned int offset;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(alsa_client, handle, &dat, &len) != 0)
+    {
+        ALSA_WARNING("[ALSA %s %d fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+	rpc = ion_map_kernel(alsa_client, handle);
+	offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS));
+
+	memset(rpc, 0, sizeof(AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS));
+	rpc->instanceID = htonl(dpcm->AIAgentID);
+	rpc->type = htonl(ENUM_PRIVATEINFO_AIO_AI_PRIVATEINFO);
+
+	if(dpcm->source_in == ENUM_AIN_AUDIO_V2)
+		rpc->argateInfo[0] = htonl(ENUM_AI_PRIVATE_DUAL_DMIC_AND_LOOPBACK);
+	else if(dpcm->source_in == ENUM_AIN_AUDIO_V3)
+	{
+		rpc->argateInfo[0] = htonl(ENUM_AI_PRIVATE_SPEECH_RECOGNITION_FROM_DMIC);
+		rpc->argateInfo[1] = htonl(ENUM_AIN_AUDIO_PROCESSING_DMIC);
+	}
+	else if(dpcm->source_in == ENUM_AIN_AUDIO_V4)
+	{
+		rpc->argateInfo[0] = htonl(ENUM_AI_PRIVATE_SPEECH_RECOGNITION_FROM_DMIC);
+		rpc->argateInfo[1] = htonl(ENUM_AIN_AUDIO_PROCESSING_I2S);
+	}
+
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_AIO_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &RPC_ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(RPC_ret != S_OK )
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_SET_AI_FLASH_VOLUME(snd_card_RTK_capture_pcm_t *dpcm, unsigned int volume)
+{
+	//TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+	AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS *rpc = NULL;
+	AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+	struct ion_handle *handle = NULL;
+	HRESULT rpc_ret;
+	unsigned int offset;
+	int ret = -1;
+	ion_phys_addr_t dat;
+	size_t len;
+
+	TRACE_RPC();
+	handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+	if (IS_ERR(handle)) {
+		ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+		goto exit;
+	}
+
+	if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		goto exit;
+	}
+
+	rpc = ion_map_kernel(alsa_client, handle);
+	offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+	res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)rpc + offset);
+	rpc->instanceID = htonl(dpcm->AIAgentID);    
+	rpc->type = htonl(ENUM_PRIVATEINFO_AIO_AI_PRIVATEINFO);
+	rpc->argateInfo[0] = htonl(ENUM_AI_PRIVATE_ADC_SET_VOLUME);
+	rpc->argateInfo[1] = htonl(volume); // ADC left channel digital volume in 0.5 dB step, -33.5dB~30dB
+	rpc->argateInfo[2] = htonl(volume); // ADC right channel digital volume in 0.5 dB step, -33.5dB~30dB
+
+	if(send_rpc_command(RPC_AUDIO,
+		ENUM_KERNEL_RPC_AIO_PRIVATEINFO,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + offset),
+		&rpc_ret)) {
+		ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+		goto exit;
+	}
+
+	if(rpc_ret != S_OK) {
+		ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+		goto exit;
+	}
+
+	TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+	ret = 0;
+
+exit:
+	if(handle != NULL) {
+		ion_unmap_kernel(alsa_client, handle);
+		ion_free(alsa_client, handle);
+	}
+	return ret;
+}
+
+int RPC_TOAGENT_SET_SOFTWARE_AI_FLASH_VOLUME(snd_card_RTK_capture_pcm_t *dpcm, unsigned int volume)
+{
+	//TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    
+	AUDIO_RPC_AIO_PRIVATEINFO_PARAMETERS *rpc = NULL;
+	AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+	struct ion_handle *handle = NULL;
+	HRESULT rpc_ret;
+	unsigned int offset;
+    int ret = -1, rpc_volume;
+	ion_phys_addr_t dat;
+	size_t len;
+	
+	/* The range of software control volume index is from 0 to 32. */
+	if (volume >= 0 && volume < 17)
+		rpc_volume = ENUM_AUDIO_VOLUME_CTRL_0_DB + volume;
+	else if (volume >= 17 && volume < 33)
+		rpc_volume = ENUM_AUDIO_VOLUME_CTRL_P1_DB + volume%17;
+	else
+		goto exit;
+	
+	TRACE_RPC();
+	handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+	
+	if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+	
+	if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+	
+	rpc = ion_map_kernel(alsa_client, handle);
+	offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+	res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)rpc + offset);
+	rpc->instanceID = htonl(dpcm->AIAgentID);    
+	rpc->type = htonl(ENUM_PRIVATEINFO_AIO_AI_PRIVATEINFO);
+	rpc->argateInfo[0] = htonl(ENUM_AI_PRIVATE_VOLUME_CTRL);
+	rpc->argateInfo[1] = htonl(rpc_volume); // one of AUDIO_VOLUME_CTRL
+	
+	if(send_rpc_command(RPC_AUDIO,
+		ENUM_KERNEL_RPC_AIO_PRIVATEINFO,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + offset),
+		&rpc_ret)) {
+		ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+	}
+	
+	if(rpc_ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+	
+	TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+
+exit:
+	if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_SET_EQ(snd_card_RTK_pcm_t *dpcm, struct AUDIO_RPC_EQUALIZER_MODE *equalizer_mode)
+{
+	AUDIO_EQUALIZER_CONFIG *rpc = NULL;
+	AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+	struct ion_handle *handle = NULL;
+	HRESULT rpc_ret;
+	unsigned int offset;
+	int i, ret = -1;
+	ion_phys_addr_t dat;
+	size_t len;
+
+	TRACE_RPC();
+	handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+	if (IS_ERR(handle)) {
+		ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+		goto exit;
+	}
+
+	if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+		ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+		goto exit;
+	}
+
+	rpc = ion_map_kernel(alsa_client, handle);
+	offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+	res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)rpc + offset);
+	rpc->instanceID = htonl(dpcm->AOAgentID);
+	rpc->gbl_var_eq_ID = htonl(ENUM_EQUALIZER_AO);
+	rpc->ena = 0x1;
+
+	/* Set up EQ data */
+	rpc->app_eq_config.mode = htonl(equalizer_mode->mode);
+	for(i=0; i<10; i++)
+		rpc->app_eq_config.gain[i] = htonl(equalizer_mode->gain[i]);
+
+	if(send_rpc_command(RPC_AUDIO,
+		ENUM_KERNEL_RPC_EQ_CONFIG,
+		CONVERT_FOR_AVCPU(dat),
+		CONVERT_FOR_AVCPU(dat + offset),
+		&rpc_ret)) {
+		ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+		goto exit;
+	}
+
+	if(rpc_ret != S_OK) {
+		ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+		goto exit;
+	}
+
+	TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+	ret = 0;
+
+exit:
+	if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_AI_CONFIG_NONPCM_IN(snd_card_RTK_capture_pcm_t *dpcm)
+{
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *rpc = NULL;
+    HRESULT RPC_ret;
+    unsigned int offset;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(alsa_client, handle, &dat, &len) != 0)
+    {
+        ALSA_WARNING("[ALSA %s %d fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    rpc->instanceID = htonl(dpcm->AIAgentID);
+    rpc->type = htonl(ENUM_PRIVATEINFO_AUDIO_AI_NON_PCM_IN);
+
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &RPC_ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(RPC_ret != S_OK )
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+
+int RPC_TOAGENT_CREATE_AI_AGENT(snd_card_RTK_capture_pcm_t *dpcm)
+{
+    RPC_CREATE_AO_AGENT_T *rpc = NULL;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(alsa_client, handle, &dat, &len) != 0)
+    {
+        ALSA_WARNING("[ALSA %s %d fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = ion_map_kernel(alsa_client, handle);
+    rpc->info.instanceID = htonl(-1);
+    rpc->info.type = htonl(AUDIO_IN);
+
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_CREATE_AGENT,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + get_rpc_alignment_offset(sizeof(rpc->info))),
+        &rpc->ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ntohl(rpc->retval.result) != S_OK || rpc->ret != S_OK)
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    dpcm->AIAgentID = ntohl(rpc->retval.data);
+//    printk(KERN_ALERT "[ALSA Create AI instance %d]\n", dpcm->AIAgentID);
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    // success
+    ret = 0;
+exit:
+    if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_CONFIGURE_AI_HW(snd_pcm_runtime_t *runtime) 
+{
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    AUDIO_CONFIG_ADC *rpc = NULL;
+    AUDIO_ADC_CONFIG *pConfig = NULL;
+    HRESULT *rpc_arg;
+    int ret = -1;
+    HRESULT RPC_ret;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned int offset;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(alsa_client, handle, &dat, &len) != 0)
+    {
+        ALSA_WARNING("[ALSA %s %d fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+    rpc = ion_map_kernel(alsa_client, handle);
+    //rpc_arg = (HRESULT *)((unsigned int)(rpc + sizeof(AUDIO_CONFIG_ADC) + 8) & 0xFFFFFFFC);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_CONFIG_ADC));
+    rpc_arg = (HRESULT *)((unsigned long)rpc + offset);
+
+    //offset = (unsigned int)rpc_arg - (unsigned int)rpc;
+
+    pConfig = &rpc->adcConfig;
+    rpc->instanceID = htonl(dpcm->AIAgentID);
+    pConfig->audioGeneralConfig.interface_en = 1;
+    pConfig->audioGeneralConfig.channel_in = 0x3;
+    pConfig->sampleInfo.sampling_rate = htonl(runtime->rate);
+    pConfig->sampleInfo.PCM_bitnum = htonl(24);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_ADC0_CONFIG,
+        CONVERT_FOR_AVCPU(dat),//rpc address
+        CONVERT_FOR_AVCPU(dat + offset), //rpc_arg address
+        &RPC_ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_AI_DISCONNECT_ALSA_AUDIO(snd_pcm_runtime_t *runtime)
+{
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL*res;
+    HRESULT RPC_ret;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned int offset;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(alsa_client, handle, &dat, &len) != 0)
+    {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = ion_map_kernel(alsa_client, handle);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+
+    memset(cmd, 0, sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    cmd->instanceID = htonl(dpcm->AIAgentID);
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_AI_CONNECT_ALSA);
+    cmd->privateInfo[0] = htonl(AUDIO_ALSA_FORMAT_NONE);
+    cmd->privateInfo[1] = htonl(runtime->rate);
+
+	if(dpcm->source_in == ENUM_AIN_AUDIO)
+		cmd->privateInfo[2] = htonl(1);
+	else
+		cmd->privateInfo[2] = htonl(0);
+
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &RPC_ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(RPC_ret != S_OK )
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_AI_CONNECT_ALSA(snd_pcm_runtime_t *runtime)
+{
+	snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL*res;
+    HRESULT RPC_ret;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned int offset;
+
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(ion_phys(alsa_client, handle, &dat, &len) != 0)
+    {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = ion_map_kernel(alsa_client, handle);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+
+    memset(cmd, 0, sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    cmd->instanceID = htonl(dpcm->AIAgentID);
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_AI_CONNECT_ALSA);
+    cmd->privateInfo[0] = htonl(dpcm->nAIFormat);
+    cmd->privateInfo[1] = htonl(runtime->rate);
+
+	switch(dpcm->source_in)
+	{
+		case ENUM_AIN_AUDIO:
+			cmd->privateInfo[2] = htonl(1);
+			break;
+		default:
+			cmd->privateInfo[2] = htonl(0);
+			break;
+	}
+
+	switch(dpcm->source_in)
+	{
+		case ENUM_AIN_AUDIO_V2:
+		case ENUM_AIN_AUDIO_V3:
+		case ENUM_AIN_AUDIO_V4:
+			cmd->privateInfo[3] = htonl(1); //1 channel
+			break;
+		default:
+			cmd->privateInfo[3] = htonl(0); //channels
+			break;
+	}
+
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &RPC_ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(RPC_ret != S_OK )
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    ret = 0;
+exit:
+    if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_DESTROY_AUDIO_FLOW(int pid)
+{
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd = NULL;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    HRESULT RPC_ret;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned int offset;
+    //ALSA_WARNING("[%s] PID = %d\n",__func__,pid);
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    //cmd = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    cmd = ion_map_kernel(alsa_client, handle);
+    //res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned int)((unsigned int)cmd + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS)+8) & PRIVATE_INFO_MASK);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+    //offset = (unsigned long)res - (unsigned long)cmd;
+    memset(cmd, 0, sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    cmd->instanceID = htonl(-1);
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_DO_SELF_DESTROY_FLOW);
+    cmd->privateInfo[0] = htonl(pid);
+
+    if (send_rpc_command(RPC_AUDIO,
+                ENUM_KERNEL_RPC_PRIVATEINFO,
+                CONVERT_FOR_AVCPU(dat),
+                CONVERT_FOR_AVCPU(dat + offset),
+                &RPC_ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+    }
+
+    if (RPC_ret != S_OK ) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+exit:
+    if(handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+int RPC_TOAGENT_SET_LOW_WATER_LEVEL(bool isLowWater)
+{
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    HRESULT RPC_ret;
+    int ret = -1;
+    struct ion_handle *handle = NULL;
+    ion_phys_addr_t dat;
+    size_t len;
+    unsigned long offset;
+
+    TRACE_RPC();
+    handle = ion_alloc(alsa_client, 4096, 1024, RTK_PHOENIX_ION_HEAP_AUDIO_MASK, AUDIO_ION_FLAG);
+
+    if (IS_ERR(handle)) {
+        ALSA_WARNING("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (ion_phys(alsa_client, handle, &dat, &len) != 0) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = ion_map_kernel(alsa_client, handle);
+    offset = get_rpc_alignment_offset(sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned long)cmd + offset);
+    memset(cmd, 0, sizeof(*cmd));
+    memset(res, 0, sizeof(*res));
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_SET_LOW_WATERLEVEL);
+    if (isLowWater) {
+        cmd->privateInfo[0] = htonl(0x1);
+        printk("Enable pp ao low waterlevel mode\n");
+    } else {
+        cmd->privateInfo[0] = 0;
+        printk("Disable pp ao low waterlevel mode\n");
+    }
+    cmd->privateInfo[1] = 0;
+    cmd->privateInfo[2] = 0;
+    cmd->privateInfo[3] = 0;
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat), //cmd address
+        CONVERT_FOR_AVCPU(dat + offset),//res address
+        &RPC_ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (RPC_ret != S_OK ) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    // successful
+    ret = 0;
+exit:
+    if (handle != NULL) {
+        ion_unmap_kernel(alsa_client, handle);
+        ion_free(alsa_client, handle);
+    }
+    return ret;
+}
+
+#else // use dma
+
+int RPC_TOAGENT_CHECK_AUDIO_READY() 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_DEFAULT_INPUT_T *rpc = NULL;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if(!addr) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = addr;
+
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_CHECK_READY,
+        CONVERT_FOR_AVCPU(dat), //rpc->info address
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->info)), //rpc->retval address
+        &rpc->ret)) {
+        ALSA_WARNING("[ALSA %s RPC fail]\n", __FUNCTION__);
+        goto exit;
+    }
+    
+    if(rpc->ret != S_OK ) {
+        ALSA_WARNING("[ALSA %s RPC fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    if(rpc->info == 0) {
+        ALSA_WARNING("[ALSA Audio is not ready]\n");
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d ] success\n", __FILE__, __FUNCTION__, __LINE__);
+
+    // successful
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+
+int RPC_TOAGENT_CREATE_AO_AGENT(snd_card_RTK_pcm_t *dpcm) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    
+    RPC_CREATE_AO_AGENT_T *rpc;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if(!addr) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = addr;
+    rpc->info.instanceID = htonl(0);
+    rpc->info.type = htonl(AUDIO_OUT);//AUDIO_ALSA_OUT
+
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_CREATE_AGENT,
+        CONVERT_FOR_AVCPU(dat), //rpc->info address
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->info)),//rpc->retval address
+        &rpc->ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+    
+    if(ntohl(rpc->retval.result) != S_OK || rpc->ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    dpcm->AOAgentID = ntohl(rpc->retval.data);
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+    // success
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+ 
+
+
+int RPC_TOAGENT_PUT_SHARE_MEMORY(void *p)
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;  
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL*res;
+    int ret = 0;
+    HRESULT RPC_ret;
+    dma_addr_t dat;
+    void *addr = 0;
+    unsigned int offset;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+
+    if(!addr)
+    {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = addr;
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned int)(cmd + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS)+8) & 0xFFFFFFFC);
+
+    offset = (unsigned int)res - (unsigned int)cmd;
+
+    memset(cmd, 0, sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_GET_SHARE_MEMORY_FROM_ALSA);           
+    cmd->privateInfo[0] = htonl((int)p);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat+offset),
+        &RPC_ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (RPC_ret != S_OK )  
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    
+    return ret;
+}
+
+int RPC_TOAGENT_GET_AO_FLASH_PIN(snd_card_RTK_pcm_t *dpcm) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;  
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    HRESULT RPC_ret;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+    unsigned int offset;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+
+    if(!addr) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = addr;
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned int)(cmd + sizeof(cmd)+8) & 0xFFFFFFFC);
+    offset = (unsigned int)res - (unsigned int)cmd;
+
+    memset(cmd, 0, sizeof(cmd));
+    cmd->instanceID = htonl(dpcm->AOAgentID);   
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_GET_FLASH_PIN);
+    cmd->privateInfo[0] = 0xFF; 
+    cmd->privateInfo[1] = 0xFF;
+    cmd->privateInfo[2] = 0xFF; 
+    cmd->privateInfo[3] = 0xFF;     
+    cmd->privateInfo[4] = 0xFF;     
+    cmd->privateInfo[5] = 0xFF; 
+
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_PRIVATEINFO, 
+        CONVERT_FOR_AVCPU(dat), //cmd address
+        CONVERT_FOR_AVCPU(dat + offset),//res address
+        &RPC_ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(RPC_ret != S_OK ) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+    
+    ret = ntohl(res->privateInfo[0]);
+    
+    if(ret < FLASH_AUDIO_PIN_1 || ret > FLASH_AUDIO_PIN_3) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+    }
+
+    //ALSA_WARNING("GET_AO_FLASH_PIN ret %d\n", ret);
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+
+    return ret;
+}
+
+
+
+int RPC_TOAGENT_SET_AO_FLASH_VOLUME(snd_pcm_substream_t * substream) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+        
+    snd_pcm_runtime_t *runtime = substream->runtime;
+    snd_card_RTK_pcm_t *dpcm = runtime->private_data;   
+    HRESULT RPC_ret;
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;  
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+    unsigned int offset;
+    
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    
+    if(!addr) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+  
+    //cmd = (AUDIO_RPC_PRIVATEINFO_PARAMETERS *) ((unsigned int)page_address(page));
+    //res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *) ((((unsigned int) page_address(page) + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS)+8) & 0xFFFFFFFC));   
+    cmd = addr;
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned int)(cmd + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS)+8) & 0xFFFFFFFC);
+    offset = (unsigned int)res - (unsigned int)cmd;
+    
+    memset(cmd, 0, sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    cmd->instanceID = htonl(dpcm->AOAgentID);   
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_CONTROL_FLASH_VOLUME);         
+    cmd->privateInfo[0] = htonl(dpcm->AOpinID); 
+    cmd->privateInfo[1] = htonl((31-dpcm->volume));
+
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_PRIVATEINFO, 
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &rpc_ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(rpc_ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    // success
+    ret = 0;
+    //ALSA_VitalPrint("[ALSA set AO_pin %d volume %d]\n", dpcm->AOpinID, dpcm->volume);
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+
+int RPC_TOAGENT_CREATE_DECODER_AGENT(snd_card_RTK_pcm_t * dpcm) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    
+    RPC_CREATE_PCM_DECODER_CTRL_T* rpc = NULL;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if(!addr) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = addr;
+    rpc->instance.type = htonl(AUDIO_DECODER);
+    rpc->instance.instanceID = htonl(-1);   
+
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_CREATE_AGENT, 
+        CONVERT_FOR_AVCPU(dat), //rpc->instance address
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->instance)), //rpc->res address
+        &rpc->ret)) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(rpc->ret != S_OK) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    dpcm->DECAgentID = ntohl(rpc->res.data);
+    dpcm->DECpinID = BASE_BS_IN ;
+
+    ret = 0;
+    printk("[ALSA Create Decoder instance %d]\n", dpcm->DECAgentID);
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+
+    return ret;
+}
+
+// data of AUDIO_RPC_RINGBUFFER_HEADER is "hose side"
+int RPC_TOAGENT_INITRINGBUFFER_HEADER_SVC(AUDIO_RPC_RINGBUFFER_HEADER *header, int buffer_count) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_INITRINGBUFFER_HEADER_T *rpc;
+    int ch;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if(!addr) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = addr;
+    rpc->header.instanceID = htonl(header->instanceID);
+    rpc->header.pinID = htonl(header->pinID);
+    rpc->header.readIdx = htonl(header->readIdx); 
+    rpc->header.listSize = htonl(header->listSize);
+
+    //printk(" header instance ID %d\n", header->instanceID);
+    //printk(" header pinID       %d\n", header->pinID);
+    //printk(" header readIdx     %d\n", header->readIdx);
+    //printk(" header listSize    %d\n", header->listSize);
+
+    for( ch = 0; ch < buffer_count; ch++) {
+        //rpc_initringbuffer->header.pRingBufferHeaderList[i] = htonl(0xa0000000|(((unsigned int) header->pRingBufferHeaderList[i])&0x1FFFFFFF));
+        //printk("[test]header.pRingBufferHeaderList[%d] = %lx\n", ch, header->pRingBufferHeaderList[ch]); 
+        rpc->header.pRingBufferHeaderList[ch] = htonl((unsigned int) header->pRingBufferHeaderList[ch]);
+        //rpc->header.pRingBufferHeaderList[ch] = htonl(0xa0000000|(((unsigned int) header->pRingBufferHeaderList[ch])&0x1FFFFFFF));
+        
+    }
+    
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_INIT_RINGBUF,
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->ret) + sizeof(rpc->res)), //rpc->header address
+        CONVERT_FOR_AVCPU(dat), //rpc->ret address
+        &rpc->res)) {
+        ALSA_WARNING("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(rpc->res != S_OK || ntohl(rpc->ret.result) != S_OK) {
+        ALSA_WARNING("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+
+    // success
+    ret = 0;
+
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+
+int RPC_TOAGENT_CONNECT_SVC(AUDIO_RPC_CONNECTION *pconnection) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_CONNECTION_T *rpc;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if(!addr) {
+        ALSA_WARNING("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+    
+    rpc = addr; 
+    rpc->out.srcInstanceID = htonl(pconnection->srcInstanceID); 
+    rpc->out.srcPinID = htonl(pconnection->srcPinID);   
+    rpc->out.desInstanceID = htonl(pconnection->desInstanceID); 
+    rpc->out.desPinID= htonl(pconnection->desPinID);        
+    
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_CONNECT, 
+        CONVERT_FOR_AVCPU(dat), //rpc->out address
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->out)), //rpc->ret
+        &rpc->res)) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(rpc->res != S_OK || ntohl(rpc->ret.result) != S_OK) {
+        ALSA_WARNING("[%s RPC fail %d]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+
+    // success
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+
+int RPC_TOAGENT_PAUSE_SVC(int instance_id) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_TOAGENT_PAUSE_T *rpc;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if(!addr) {
+        ALSA_WARNING("[%s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+    
+    rpc = addr;
+    rpc->inst_id = htonl(instance_id);
+    
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_PAUSE, 
+        CONVERT_FOR_AVCPU(dat), //rpc->inst_id address
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->inst_id)),//rpc->retval address
+        &rpc->res)) {
+        ALSA_WARNING("[%s %d RPC fail\n]", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(rpc->res != S_OK) {
+        ALSA_WARNING("[%s %d RPC fail\n]", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+
+    // success
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+
+int RPC_TOAGENT_RUN_SVC(int instance_id) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_TOAGENT_T *rpc;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if(!addr) {
+        ALSA_WARNING("[%s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+   
+    rpc = addr;    
+    rpc->inst_id = htonl(instance_id);
+    
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_RUN, 
+        CONVERT_FOR_AVCPU(dat), //rpc->inst_id address
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->inst_id)), //rpc->retval address
+        &rpc->res)) {
+        ALSA_WARNING("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(rpc->res != S_OK || ntohl(rpc->retval.result) != S_OK) {
+        ALSA_WARNING("[%s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+
+    // success
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}  
+
+int RPC_TOAGENT_FLUSH_SVC(AUDIO_RPC_SENDIO  *sendio) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_TOAGENT_FLASH_T *rpc;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+    
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if(!addr) {
+        ALSA_WARNING("[ALSA %s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+    
+    rpc = addr;
+    rpc->sendio.instanceID = htonl(sendio->instanceID);
+    rpc->sendio.pinID = htonl(sendio->pinID);
+
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_FLUSH,
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->retval) + sizeof(rpc->res)), //rpc->sendio address
+        CONVERT_FOR_AVCPU(dat), //rpc->retval address
+        &rpc->res)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if(rpc->res != S_OK || ntohl(rpc->retval.result) != S_OK) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+
+    // success
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);  
+    return ret;
+}
+
+int RPC_TOAGENT_RELEASE_AO_FLASH_PIN(snd_card_RTK_pcm_t *dpcm) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    HRESULT rpc_ret = 0;
+    int ret = -1;
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;  
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    dma_addr_t dat;
+    void *addr = 0;
+    unsigned int offset;
+
+    if(dpcm->AOpinID < FLASH_AUDIO_PIN_1 || dpcm->AOpinID > FLASH_AUDIO_PIN_3) {
+       ALSA_WARNING("[%d @ %s %d]\n", dpcm->AOpinID, __FUNCTION__, __LINE__);
+       goto exit;
+    }
+    
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    
+    if(!addr) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = addr;
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned int)(cmd + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS)+8) & 0xFFFFFFFC);
+    offset = (unsigned int)res - (unsigned int)cmd;
+    
+    memset(cmd, 0, sizeof(cmd));
+    cmd->instanceID = htonl(dpcm->AOAgentID);   
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_RELEASE_FLASH_PIN);            
+    cmd->privateInfo[0] = htonl(dpcm->AOpinID); 
+    cmd->privateInfo[1] = 0xFF;
+    cmd->privateInfo[2] = 0xFF; 
+    cmd->privateInfo[3] = 0xFF;     
+    cmd->privateInfo[4] = 0xFF;     
+    cmd->privateInfo[5] = 0xFF; 
+    
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_PRIVATEINFO, 
+        CONVERT_FOR_AVCPU(dat), //cmd address
+        CONVERT_FOR_AVCPU(dat + offset), //res address
+        &rpc_ret)) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+
+    if(rpc_ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+
+    ret = 0;
+
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+
+    return ret;
+}
+
+int RPC_TOAGENT_STOP_SVC(int instanceID) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_TOAGENT_STOP_T *rpc;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+    
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+
+    if(!addr) {
+        ALSA_WARNING("[ALSA %s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+    
+    rpc = addr;
+    rpc->instanceID = htonl(instanceID);
+    
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_STOP,
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->retval) + sizeof(rpc->res)), //rpc->instanceID address
+        CONVERT_FOR_AVCPU(dat),//rpc->retval address
+        &rpc->res))
+    {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+
+    if(rpc->res != S_OK || ntohl(rpc->retval.result) != S_OK)
+    {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+
+int RPC_TOAGENT_DESTROY_SVC(int instanceID) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_TOAGENT_DESTROY_T *rpc;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if(!addr) 
+    {
+        ALSA_WARNING("[ALSA %s malloc fail]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    rpc = addr;
+    rpc->instanceID = htonl(instanceID);
+
+    if(send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_DESTROY,
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->retval) + sizeof(rpc->res)), //rpc->instanceID address
+        CONVERT_FOR_AVCPU(dat), //rpc->retval address
+        &rpc->res)) {
+        ALSA_WARNING("%s %d RPC fail\n", __FILE__, __LINE__);
+        goto exit;
+    }
+
+    if(rpc->res != S_OK || ntohl(rpc->retval.result) != S_OK) {
+        ALSA_WARNING("%s %d RPC fail\n", __FILE__, __LINE__);
+        goto exit;
+    }
+
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+
+int RPC_TOAGENT_INBAND_EOS_SVC(snd_card_RTK_pcm_t * dpcm) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    AUDIO_DEC_EOS cmd ;
+    
+    cmd.header.type = htonl(AUDIO_DEC_INBAND_CMD_TYPE_EOS);
+    cmd.header.size = htonl(sizeof(AUDIO_DEC_EOS));
+    cmd.EOSID = 0;
+
+    cmd.wPtr = htonl(dpcm->decInRing_LE[0].writePtr);
+    //TRACE_CODE("[test]write cmd type %d\n", AUDIO_DEC_INBAND_CMD_TYPE_EOS);
+    //snd_realtek_hw_ring_write(((unsigned int)dpcm->decInbandRing - (unsigned int)dpcm + dpcm->phy_addr), &cmd, sizeof(AUDIO_DEC_EOS));
+    snd_realtek_hw_ring_write((unsigned int)&dpcm->decInbandRing, &cmd, sizeof(AUDIO_DEC_EOS), (unsigned int)dpcm - (unsigned int)dpcm->phy_addr);
+    return 0;
+}
+
+// set AO volume
+int RPC_TOAGENT_SET_VOLUME(int volume) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+    
+    AUDIO_CONFIG_COMMAND *config;
+    unsigned int *res;
+    HRESULT ret;
+    dma_addr_t dat;
+    void *addr = 0;
+    unsigned int offset;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+
+    if(!addr) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    //config = (AUDIO_CONFIG_COMMAND  *) (unsigned int)page_address(page);
+    config = addr;
+    config->msgID = htonl(AUDIO_CONFIG_CMD_VOLUME);
+    config->value[0] = htonl(31- volume);
+
+    res = (unsigned int *) ((unsigned int) (config + sizeof(AUDIO_CONFIG_COMMAND)+8) & 0xFFFFFFFC); 
+    offset = (unsigned int)res - (unsigned int)config;
+
+    // set gpAudio->ao_volume_level(from Audio FW)
+    //if (send_rpc_command(RPC_AUDIO, ENUM_KERNEL_RPC_VOLUME_CONTROL, (unsigned int) config,(unsigned int) res, &ret)) {
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_VOLUME_CONTROL, 
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset), 
+        &ret)) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+    
+    if (ret != S_OK) {
+        ALSA_WARNING("[ALSA %s %d fail]\n", __FUNCTION__, __LINE__);
+        ret = -1;
+        goto exit;
+    }
+
+    ret = 0;
+
+    //TRACE_CODE("[%s %s %d] success\n", __FILE__, __FUNCTION__, __LINE__);
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    
+    return ret;
+}
+
+// get AO volume
+int RPC_TOAGENT_GET_VOLUME(snd_card_RTK_pcm_t *mars) 
+{
+    //TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    int volume;
+    RPC_GET_VOLUME_T *config;
+    dma_addr_t dat;
+    void *addr = 0;
+    
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if(!addr) {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+    
+    //config = (RPC_GET_VOLUME_T  *) (unsigned int)page_address(page);
+    config = addr;
+    config->param.instanceID = htonl(mars->AOAgentID);
+    config->param.type = htonl(ENUM_PRIVATEINFO_AUDIO_GET_MUTE_N_VOLUME);
+
+//    flush_dcache_page(page);
+
+    //if (send_rpc_command(RPC_AUDIO, ENUM_KERNEL_RPC_GET_MUTE_N_VOLUME , (unsigned int) &(config->param),(unsigned int) &(config->res), &(config->ret))) {
+    if(send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_GET_MUTE_N_VOLUME ,
+        CONVERT_FOR_AVCPU(dat + sizeof(config->res) + sizeof(config->ret)),
+        CONVERT_FOR_AVCPU(dat),
+        &(config->ret))) {
+        ALSA_WARNING("[fail %s %d]\n", __FUNCTION__, __LINE__);
+        volume = -1;
+        goto exit;
+    }
+
+    if(config->ret != S_OK) {
+        ALSA_WARNING("[fail %s %d]\n", __FUNCTION__, __LINE__);
+        volume = -1;
+        goto exit;
+    }
+
+    // get gpAudio->ao_volume_level (from audio FW)
+    volume = config->param.privateInfo[1];
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    
+    return volume;
+}
+
+int RPC_TOAGENT_CREATE_AI_AGENT(snd_card_RTK_capture_pcm_t *dpcm) 
+{
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    RPC_CREATE_AO_AGENT_T *rpc = NULL;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    if (!addr) 
+    {
+        ALSA_WARNING("[ALSA %s %d fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    rpc = addr;
+    rpc->info.instanceID = htonl(-1);
+    rpc->info.type = htonl(AUDIO_IN);
+
+    if (send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_CREATE_AGENT, 
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + sizeof(rpc->info)),
+        &rpc->ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+    
+    if (ntohl(rpc->retval.result) != S_OK || rpc->ret != S_OK)  
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    dpcm->AIAgentID = ntohl(rpc->retval.data);
+    // success
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+
+int RPC_TOAGENT_CONFIGURE_AI_HW(snd_pcm_runtime_t *runtime)
+{
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    snd_card_RTK_capture_pcm_t *dpcm = runtime->private_data;
+    AUDIO_CONFIG_ADC *rpc = NULL;
+    AUDIO_ADC_CONFIG *pConfig = NULL;
+    HRESULT *rpc_arg;
+    int ret = -1;
+    HRESULT RPC_ret;
+    dma_addr_t dat;
+    void *addr = 0;
+    unsigned int offset;
+    
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+
+    if(!addr)
+    {
+        ALSA_WARNING("[ALSA %s %d fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+    rpc = addr;
+    rpc_arg = (HRESULT *)((unsigned int)(rpc + sizeof(AUDIO_CONFIG_ADC) + 8) & 0xFFFFFFFC);
+
+    offset = (unsigned int)rpc_arg - (unsigned int)rpc;
+
+    pConfig = &rpc->adcConfig;
+    rpc->instanceID = htonl(dpcm->AIAgentID);
+    pConfig->audioGeneralConfig.interface_en = 1;
+    pConfig->audioGeneralConfig.channel_in = 0x3;
+    pConfig->sampleInfo.sampling_rate = htonl(runtime->rate);
+    pConfig->sampleInfo.PCM_bitnum = htonl(24);
+
+    if (send_rpc_command(RPC_AUDIO, 
+        ENUM_KERNEL_RPC_ADC0_CONFIG,
+        CONVERT_FOR_AVCPU(dat),//rpc address
+        CONVERT_FOR_AVCPU(dat + offset), //rpc_arg address
+        &RPC_ret)) 
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n",__FUNCTION__, __LINE__);
+        goto exit;
+    }
+    
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+
+int RPC_TOAGENT_AI_CONNECT_ALSA(snd_card_RTK_capture_pcm_t *dpcm)
+{
+    TRACE_CODE("[%s %s %d]\n", __FILE__, __FUNCTION__, __LINE__);
+
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL*res;
+    HRESULT RPC_ret;
+    int ret = -1;
+    dma_addr_t dat;
+    void *addr = 0;
+    unsigned int offset;
+
+    addr = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+
+    if(!addr)
+    {
+        ALSA_WARNING("[ALSA malloc fail %s]\n", __FUNCTION__);
+        goto exit;
+    }
+
+    cmd = addr;
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned int)(cmd + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS)+8) & 0xFFFFFFFC);
+    offset = (unsigned int)res - (unsigned int)cmd;
+
+    memset(cmd, 0, sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    cmd->instanceID = htonl(dpcm->AIAgentID);
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_AI_CONNECT_ALSA);
+    cmd->privateInfo[0] = htonl(dpcm->nAIFormat);
+
+    if (send_rpc_command(RPC_AUDIO,
+        ENUM_KERNEL_RPC_PRIVATEINFO,
+        CONVERT_FOR_AVCPU(dat),
+        CONVERT_FOR_AVCPU(dat + offset),
+        &RPC_ret))
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+
+    if (RPC_ret != S_OK)
+    {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit; 
+    }
+
+    ret = 0;
+exit:
+    if(addr)
+        dma_free_coherent(NULL, 4096, addr, dat);
+    return ret;
+}
+
+int RPC_DESTROY_AUDIO_FLOW(int pid)
+{
+    AUDIO_RPC_PRIVATEINFO_PARAMETERS *cmd = NULL;
+    AUDIO_RPC_PRIVATEINFO_RETURNVAL *res;
+    HRESULT RPC_ret;
+    int ret = -1;
+    dma_addr_t dat;
+    unsigned int offset;
+    //ALSA_WARNING("[%s] PID = %d\n",__func__,pid);
+    cmd = dma_alloc_coherent(NULL, 4096, &dat, GFP_KERNEL);
+    res = (AUDIO_RPC_PRIVATEINFO_RETURNVAL *)((unsigned int)(cmd + sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS)+8) & 0xFFFFFFFC);
+    offset = (unsigned int)res - (unsigned int)cmd;
+    memset(cmd, 0, sizeof(AUDIO_RPC_PRIVATEINFO_PARAMETERS));
+    cmd->instanceID = htonl(-1);
+    cmd->type = htonl(ENUM_PRIVATEINFO_AUDIO_DO_SELF_DESTROY_FLOW);
+    cmd->privateInfo[0] = htonl(pid);
+    if(send_rpc_command(RPC_AUDIO,
+                ENUM_KERNEL_RPC_PRIVATEINFO,
+                CONVERT_FOR_AVCPU(dat),
+                CONVERT_FOR_AVCPU(dat + offset),
+                &RPC_ret)) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+    }
+
+    if(RPC_ret != S_OK ) {
+        ALSA_WARNING("[ALSA %s %d RPC fail]\n", __FUNCTION__, __LINE__);
+        goto exit;
+    }
+exit:
+    if (NULL != cmd)
+        dma_free_coherent(NULL, 4096, cmd, dat);
+    return ret;
+}
+
+#endif //USE_ION_AUDIO_HEAP
diff --git a/sound/arm/snd-realtek_common.h b/sound/arm/snd-realtek_common.h
new file mode 100644
index 00000000..c5ba3be
--- /dev/null
+++ b/sound/arm/snd-realtek_common.h
@@ -0,0 +1,128 @@
+/**
+ * snd-realtek_common.h - Realtek alsa driver
+ *
+ * Copyright (C) 2017 Realtek Semiconductor Corporation
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef SND_RTK_COMMON_H
+#define SND_RTK_COMMON_H
+
+typedef enum
+{
+	ENUM_KERNEL_RPC_CREATE_AGENT,   // 0
+	ENUM_KERNEL_RPC_INIT_RINGBUF,
+	ENUM_KERNEL_RPC_PRIVATEINFO,
+	ENUM_KERNEL_RPC_RUN,
+	ENUM_KERNEL_RPC_PAUSE,
+	ENUM_KERNEL_RPC_SWITCH_FOCUS,   // 5
+	ENUM_KERNEL_RPC_MALLOC_ADDR,
+	ENUM_KERNEL_RPC_VOLUME_CONTROL,      // AUDIO_CONFIG_COMMAND
+	ENUM_KERNEL_RPC_FLUSH,               // AUDIO_RPC_SENDIO
+	ENUM_KERNEL_RPC_CONNECT,             // AUDIO_RPC_CONNECTION
+	ENUM_KERNEL_RPC_SETREFCLOCK,    // 10     // AUDIO_RPC_REFCLOCK
+	ENUM_KERNEL_RPC_DAC_I2S_CONFIG,      // AUDIO_CONFIG_DAC_I2S
+	ENUM_KERNEL_RPC_DAC_SPDIF_CONFIG,    // AUDIO_CONFIG_DAC_SPDIF
+	ENUM_KERNEL_RPC_HDMI_OUT_EDID,       // AUDIO_HDMI_OUT_EDID_DATA
+	ENUM_KERNEL_RPC_HDMI_OUT_EDID2,      // AUDIO_HDMI_OUT_EDID_DATA2
+	ENUM_KERNEL_RPC_HDMI_SET,       // 15     // AUDIO_HDMI_SET
+	ENUM_KERNEL_RPC_HDMI_MUTE,           //AUDIO_HDMI_MUTE_INFO
+	ENUM_KERNEL_RPC_ASK_DBG_MEM_ADDR,
+	ENUM_KERNEL_RPC_DESTROY,
+	ENUM_KERNEL_RPC_STOP,
+	ENUM_KERNEL_RPC_CHECK_READY,     // 20    // check if Audio get memory pool from AP
+	ENUM_KERNEL_RPC_GET_MUTE_N_VOLUME,   // get mute and volume level
+	ENUM_KERNEL_RPC_EOS,
+	ENUM_KERNEL_RPC_ADC0_CONFIG,
+	ENUM_KERNEL_RPC_ADC1_CONFIG,
+	ENUM_KERNEL_RPC_ADC2_CONFIG,    // 25
+#if defined(AUDIO_TV_PLATFORM)
+	ENUM_KERNEL_RPC_BBADC_CONFIG,
+	ENUM_KERNEL_RPC_I2SI_CONFIG,
+	ENUM_KERNEL_RPC_SPDIFI_CONFIG,
+#endif // AUDIO_TV_PLATFORM
+	ENUM_KERNEL_RPC_HDMI_OUT_VSDB,
+	ENUM_VIDEO_KERNEL_RPC_CONFIG_TV_SYSTEM,
+	ENUM_VIDEO_KERNEL_RPC_CONFIG_HDMI_INFO_FRAME,
+	ENUM_VIDEO_KERNEL_RPC_QUERY_DISPLAY_WIN,
+	ENUM_VIDEO_KERNEL_RPC_PP_INIT_PIN,
+	ENUM_KERNEL_RPC_INIT_RINGBUF_AO, //need check this enum
+	ENUM_VIDEO_KERNEL_RPC_VOUT_EDID_DATA,
+	ENUM_KERNEL_RPC_AUDIO_POWER_SET,
+	ENUM_VIDEO_KERNEL_RPC_VOUT_VDAC_SET,
+	ENUM_VIDEO_KERNEL_RPC_QUERY_CONFIG_TV_SYSTEM,
+	ENUM_KERNEL_RPC_AUDIO_CONFIG,
+	ENUM_KERNEL_RPC_AIO_PRIVATEINFO,
+	ENUM_KERNEL_RPC_QUERY_FW_DEBUG_INFO,
+	ENUM_KERNEL_RPC_HDMI_RX_LATENCY_MEM,
+	ENUM_KERNEL_RPC_EQ_CONFIG,
+} ENUM_AUDIO_KERNEL_RPC_CMD;
+
+enum AUDIO_IO_PIN {
+	BASE_BS_IN = 0,
+	EXT_BS_IN = 1,
+	PCM_IN = 2,
+	BASE_BS_OUT = 3,
+	EXT_BS_OUT = 4,
+	PCM_OUT = 5,
+	SPDIF_IN = 6,
+	SPDIF_OUT = 7,
+	NON_PCM_OUT = 8,
+	INBAND_QUEUE = 9,
+	MESSAGE_QUEUE = 10,
+	MIC_IN = 11,
+	SOUND_EVENT_IN = 12,
+	PCM_OUT1 = 13,
+	PCM_OUT2 = 14,
+	FLASH_AUDIO_PIN_1 = 15,
+	FLASH_AUDIO_PIN_2 = 16,
+	FLASH_AUDIO_PIN_3 = 17,
+	FLASH_AUDIO_PIN_4 = 18,
+	FLASH_AUDIO_PIN_5 = 19,
+	FLASH_AUDIO_PIN_6 = 20,
+	FLASH_AUDIO_PIN_7 = 21,
+	FLASH_AUDIO_PIN_8 = 22,
+	FLASH_AUDIO_PIN_9 = 23,
+	FLASH_AUDIO_PIN_10 = 24,
+	FLASH_AUDIO_PIN_11 = 25,
+	FLASH_AUDIO_PIN_12 = 26,
+	FLASH_AUDIO_PIN_13 = 27,
+	FLASH_AUDIO_PIN_14 = 28,
+	FLASH_AUDIO_PIN_15 = 29,
+	FLASH_AUDIO_PIN_16 = 30,
+	ASSOCIATED_PCM_IN = 31,
+	EXTERNAL_PCM_IN = 32,
+	SYSTEM_PCM_IN = 33,
+	APP_PCM_IN = 34,
+	DOWNMIX_PCM_OUT = 35,
+	RAW_PCM_OUT = 36,
+	EXT_PCM_OUT = 37,
+	EXT_INBAND_QUEUE = 38,
+	NON_PCM_IN = 39,
+	DTS_LA_IN0 = 40,
+	DTS_LA_IN1 = 41,
+	DTS_LA_IN2 = 42,
+	DTS_LA_IN3 = 43,
+	DTS_LA_IN4 = 44,
+	DTS_LA_IN5 = 45,
+	DTS_LA_IN6 = 46,
+	DTS_LA_IN7 = 47,
+	TDM_IN = 48,
+	PCM_PACKED_IN = 49,
+	APP_PCM_OUT = 50,
+	APP_LPCM_OUT = 51,
+	DWNSTRM_INBAND_QUEUE = 200,
+	EXT_DWNSTRM_INBAND_QUEUE = 201,
+	RAWOUT_INFOOUT_QUEUE = 202,
+	RAWOUT_INFOIN_QUEUE = 203,
+};
+typedef enum AUDIO_IO_PIN AUDIO_IO_PIN;
+
+
+#endif
+
+
diff --git a/sound/core/compress_offload.c b/sound/core/compress_offload.c
index 4490a69..ce1134b 100644
--- a/sound/core/compress_offload.c
+++ b/sound/core/compress_offload.c
@@ -809,6 +809,20 @@ static int snd_compr_drain(struct snd_compr_stream *stream)
 	return snd_compress_wait_for_drain(stream);
 }
 
+#ifdef CONFIG_RTK_PLATFORM
+static int snd_compr_get_latency(struct snd_compr_stream *stream, unsigned long arg)
+{
+	int retval;
+
+	retval = stream->ops->trigger(stream, SND_COMPR_TRIGGER_GET_LATENCY);
+
+	if (retval > 0)
+		retval = copy_to_user((int *)arg, &retval, sizeof(retval)) ? -EFAULT : 0;
+
+	return retval;
+}
+#endif /* CONFIG_RTK_PLATFORM */
+
 static int snd_compr_next_track(struct snd_compr_stream *stream)
 {
 	int retval;
@@ -916,7 +930,11 @@ static long snd_compr_ioctl(struct file *f, unsigned int cmd, unsigned long arg)
 	case _IOC_NR(SNDRV_COMPRESS_NEXT_TRACK):
 		retval = snd_compr_next_track(stream);
 		break;
-
+#ifdef CONFIG_RTK_PLATFORM
+	case _IOC_NR(SNDRV_COMPRESS_GET_LATENCY):
+		retval = snd_compr_get_latency(stream, arg);
+		break;
+#endif /* CONFIG_RTK_PLATFORM */
 	}
 	mutex_unlock(&stream->device->lock);
 	return retval;
diff --git a/sound/core/memalloc.c b/sound/core/memalloc.c
index f05cb6a..0eae1309 100644
--- a/sound/core/memalloc.c
+++ b/sound/core/memalloc.c
@@ -27,6 +27,18 @@
 #include <linux/genalloc.h>
 #include <sound/memalloc.h>
 
+
+#ifdef CONFIG_SND_REALTEK
+
+#include "../../drivers/staging/android/ion/ion.h"
+#include "../../drivers/staging/android/uapi/ion_rtk.h"
+
+extern struct ion_device *rtk_phoenix_ion_device;
+static struct ion_client *rtk_ion_playback_client;
+static struct ion_handle *rtk_ion_playback_handle;
+static struct ion_client *rtk_ion_capture_client;
+static struct ion_handle *rtk_ion_capture_handle;
+#endif /* CONFIG_SND_REALTEK */
 /*
  *
  *  Generic memory allocators
@@ -172,6 +184,10 @@ static void snd_free_dev_iram(struct snd_dma_buffer *dmab)
 int snd_dma_alloc_pages(int type, struct device *device, size_t size,
 			struct snd_dma_buffer *dmab)
 {
+#ifdef CONFIG_SND_REALTEK
+	size_t len;
+#endif /* CONFIG_SND_REALTEK */
+
 	if (WARN_ON(!size))
 		return -ENXIO;
 	if (WARN_ON(!dmab))
@@ -206,6 +222,49 @@ int snd_dma_alloc_pages(int type, struct device *device, size_t size,
 		snd_malloc_sgbuf_pages(device, size, dmab, NULL);
 		break;
 #endif
+#ifdef CONFIG_SND_REALTEK
+	case SNDRV_DMA_TYPE_ION_PLAYBACK:
+		//pr_info("[+]snd_dma_alloc_pages SNDRV_DMA_TYPE_ION_PLAYBACK size %d\n", size);
+		rtk_ion_playback_client = ion_client_create(rtk_phoenix_ion_device, "ALSA");
+		rtk_ion_playback_handle = ion_alloc(rtk_ion_playback_client,
+			size,
+			1024,
+			RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+			ION_FLAG_NONCACHED |ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+
+		if (IS_ERR(rtk_ion_playback_handle)) {
+			pr_err("[%s %d ion_alloc fail]\n", __func__, __LINE__);
+			return -ENXIO;
+		}
+
+		if (ion_phys(rtk_ion_playback_client, rtk_ion_playback_handle, (ion_phys_addr_t *)&dmab->addr, &len) != 0) {
+			pr_err("snd_dma_alloc_pages allocate ion audio heap buffer failed\n");
+			return -ENXIO;
+		}
+		dmab->area = ion_map_kernel(rtk_ion_playback_client, rtk_ion_playback_handle);
+		//pr_info("[-]snd_dma_alloc_pages phy %p vir %p size %d\n", dmab->addr, dmab->area, len);
+		break;
+	case SNDRV_DMA_TYPE_ION_CAPTURE:
+		//pr_info("[+]snd_dma_alloc_pages SNDRV_DMA_TYPE_ION_CAPTURE size %d\n", size);
+		rtk_ion_capture_client = ion_client_create(rtk_phoenix_ion_device, "ALSA");
+		rtk_ion_capture_handle = ion_alloc(rtk_ion_capture_client,
+			size,
+			1024,
+			RTK_PHOENIX_ION_HEAP_AUDIO_MASK,
+			ION_FLAG_NONCACHED |ION_FLAG_SCPUACC | ION_FLAG_ACPUACC);
+		if (IS_ERR(rtk_ion_capture_handle)) {
+			pr_err("[%s %d ion_alloc fail]\n", __FUNCTION__, __LINE__);
+			return -ENXIO;
+		}
+
+		if (ion_phys(rtk_ion_capture_client, rtk_ion_capture_handle, (ion_phys_addr_t *)&dmab->addr, &len) != 0) {
+			pr_err("snd_dma_alloc_pages allocate ion audio heap buffer failed\n");
+			return -ENXIO;
+		}
+		dmab->area = ion_map_kernel(rtk_ion_capture_client, rtk_ion_capture_handle);
+		//pr_info("[-]snd_dma_alloc_pages phy %p vir %p size %d\n", dmab->addr, dmab->area, len);
+		break;
+#endif /* CONFIG_SND_REALTEK */
 	default:
 		pr_err("snd-malloc: invalid device type %d\n", type);
 		dmab->area = NULL;
@@ -283,6 +342,26 @@ void snd_dma_free_pages(struct snd_dma_buffer *dmab)
 		snd_free_sgbuf_pages(dmab);
 		break;
 #endif
+#ifdef CONFIG_SND_REALTEK
+	case SNDRV_DMA_TYPE_ION_PLAYBACK:
+		//pr_info("snd_dma_free_pages SNDRV_DMA_TYPE_ION_PLAYBACK\n");
+		if (rtk_ion_playback_handle != NULL) {
+			ion_unmap_kernel(rtk_ion_playback_client, rtk_ion_playback_handle);
+			ion_free(rtk_ion_playback_client, rtk_ion_playback_handle);
+			ion_client_destroy(rtk_ion_playback_client);
+			rtk_ion_playback_handle = NULL;
+		}
+		break;
+	case SNDRV_DMA_TYPE_ION_CAPTURE:
+		//printk("snd_dma_free_pages SNDRV_DMA_TYPE_CAPTURE\n");
+		if (rtk_ion_capture_handle != NULL) {
+			ion_unmap_kernel(rtk_ion_capture_client, rtk_ion_capture_handle);
+			ion_free(rtk_ion_capture_client, rtk_ion_capture_handle);
+			ion_client_destroy(rtk_ion_capture_client);
+			rtk_ion_capture_client = NULL;
+		}
+		break;
+#endif /* CONFIG_SND_REALTEK */
 	default:
 		pr_err("snd-malloc: invalid device type %d\n", dmab->dev.type);
 	}
diff --git a/sound/core/pcm_compat.c b/sound/core/pcm_compat.c
index 7ae080b..791a480 100644
--- a/sound/core/pcm_compat.c
+++ b/sound/core/pcm_compat.c
@@ -74,6 +74,32 @@ static int snd_pcm_ioctl_forward_compat(struct snd_pcm_substream *substream,
 	return err < 0 ? err : 0;
 }
 
+#ifdef CONFIG_RTK_PLATFORM
+static int snd_pcm_ioctl_get_fw_delay_compat(struct snd_pcm_substream *substream,
+	s32 __user *src)
+{
+	snd_pcm_sframes_t fw_delay;
+	mm_segment_t fs;
+	int err = -ENOTTY;
+
+	fs = snd_enter_user();
+	if ((strcmp(substream->pcm->card->driver, "RTK") == 0)) {
+		err = substream->ops->ioctl(substream, SNDRV_PCM_IOCTL_GET_FW_DELAY, &fw_delay);
+	} else {
+		/* for other sound card, it has no additional delay */
+		fw_delay = 0;
+		err = 0;
+	}
+
+	snd_leave_user(fs);
+	if (err < 0)
+		return err;
+	if (put_user(fw_delay, src))
+		return -EFAULT;
+	return err;
+}
+#endif /* CONFIG_RTK_PLATFORM */
+
 struct snd_pcm_hw_params32 {
 	u32 flags;
 	struct snd_mask masks[SNDRV_PCM_HW_PARAM_LAST_MASK - SNDRV_PCM_HW_PARAM_FIRST_MASK + 1]; /* this must be identical */
@@ -649,6 +675,9 @@ enum {
 	SNDRV_PCM_IOCTL_WRITEN_FRAMES32 = _IOW('A', 0x52, struct snd_xfern32),
 	SNDRV_PCM_IOCTL_READN_FRAMES32 = _IOR('A', 0x53, struct snd_xfern32),
 	SNDRV_PCM_IOCTL_SYNC_PTR32 = _IOWR('A', 0x23, struct snd_pcm_sync_ptr32),
+#ifdef CONFIG_RTK_PLATFORM
+	SNDRV_PCM_IOCTL_GET_FW_DELAY32 = _IOR('A', 0xF1, s32),
+#endif /* CONFIG_RTK_PLATFORM */
 #ifdef CONFIG_X86_X32
 	SNDRV_PCM_IOCTL_CHANNEL_INFO_X32 = _IOR('A', 0x32, struct snd_pcm_channel_info),
 	SNDRV_PCM_IOCTL_STATUS_X32 = _IOR('A', 0x20, struct snd_pcm_status_x32),
@@ -694,6 +723,12 @@ static long snd_pcm_ioctl_compat(struct file *file, unsigned int cmd, unsigned l
 	case SNDRV_PCM_IOCTL_XRUN:
 	case SNDRV_PCM_IOCTL_LINK:
 	case SNDRV_PCM_IOCTL_UNLINK:
+#ifdef CONFIG_RTK_PLATFORM
+	case SNDRV_PCM_IOCTL_VOLUME_SET:
+	case SNDRV_PCM_IOCTL_VOLUME_GET:
+	case SNDRV_PCM_IOCTL_EQ_SET:
+	case SNDRV_PCM_IOCTL_GET_LATENCY:
+#endif /* CONFIG_RTK_PLATFORM */
 		if (substream->stream == SNDRV_PCM_STREAM_PLAYBACK)
 			return snd_pcm_playback_ioctl1(file, substream, cmd, argp);
 		else
@@ -726,6 +761,10 @@ static long snd_pcm_ioctl_compat(struct file *file, unsigned int cmd, unsigned l
 		return snd_pcm_ioctl_rewind_compat(substream, argp);
 	case SNDRV_PCM_IOCTL_FORWARD32:
 		return snd_pcm_ioctl_forward_compat(substream, argp);
+#ifdef CONFIG_RTK_PLATFORM
+	case SNDRV_PCM_IOCTL_GET_FW_DELAY32:
+		return snd_pcm_ioctl_get_fw_delay_compat(substream, argp);
+#endif /* CONFIG_RTK_PLATFORM */
 #ifdef CONFIG_X86_X32
 	case SNDRV_PCM_IOCTL_STATUS_X32:
 		return snd_pcm_status_user_x32(substream, argp, false);
diff --git a/sound/core/pcm_lib.c b/sound/core/pcm_lib.c
index 9306604..d236970 100644
--- a/sound/core/pcm_lib.c
+++ b/sound/core/pcm_lib.c
@@ -1943,6 +1943,7 @@ static int wait_for_avail(struct snd_pcm_substream *substream,
 			avail = snd_pcm_capture_avail(runtime);
 		if (avail >= runtime->twake)
 			break;
+
 		snd_pcm_stream_unlock_irq(substream);
 
 		tout = schedule_timeout(wait_time);
diff --git a/sound/core/pcm_native.c b/sound/core/pcm_native.c
index 7901869..4ae2d6c 100644
--- a/sound/core/pcm_native.c
+++ b/sound/core/pcm_native.c
@@ -2814,6 +2814,20 @@ static int snd_pcm_common_ioctl1(struct file *file,
 		snd_pcm_stream_unlock_irq(substream);
 		return res;
 	}
+#ifdef CONFIG_RTK_PLATFORM
+	case SNDRV_PCM_IOCTL_VOLUME_SET:
+	case SNDRV_PCM_IOCTL_VOLUME_GET:
+	case SNDRV_PCM_IOCTL_EQ_SET:
+	case SNDRV_PCM_IOCTL_GET_LATENCY:
+	case SNDRV_PCM_IOCTL_GET_FW_DELAY:
+		snd_printd("############## %s %d\n", __func__, __LINE__);
+		snd_printd("substream->name = %s\n", substream->pcm->card->driver);
+		/* realtek sound card driver name */
+		if((strcmp(substream->pcm->card->driver, "snd_alsa_rtk") == 0))
+			substream->ops->ioctl(substream, cmd, arg);
+
+		return 0;
+#endif /* CONFIG_RTK_PLATFORM */
 	}
 	pcm_dbg(substream->pcm, "unknown ioctl = 0x%x\n", cmd);
 	return -ENOTTY;
diff --git a/sound/core/sound.c b/sound/core/sound.c
index 175f9e4..11decf0 100644
--- a/sound/core/sound.c
+++ b/sound/core/sound.c
@@ -351,7 +351,11 @@ static const char *snd_device_type_name(int type)
 		return "sequencer";
 	case SNDRV_DEVICE_TYPE_TIMER:
 		return "timer";
-	default:
+#ifdef CONFIG_RTK_PLATFORM
+	case SNDRV_DEVICE_TYPE_COMPRESS:
+		return "compress audio";
+#endif /* CONFIG_RTK_PLATFORM */
+	 default:
 		return "?";
 	}
 }
diff --git a/sound/spi/Kconfig b/sound/spi/Kconfig
index e6485be..76aef28 100644
--- a/sound/spi/Kconfig
+++ b/sound/spi/Kconfig
@@ -9,6 +9,12 @@ menuconfig SND_SPI
 
 if SND_SPI
 
+config SND_ALC5680
+	tristate "Realtek ALC5680 ADC driver"
+	select SND_PCM
+	help
+	  Say Y here if you want to use the Realtek ALC5680 external ADC.
+
 config SND_AT73C213
 	tristate "Atmel AT73C213 DAC driver"
 	depends on ATMEL_SSC
diff --git a/sound/spi/Makefile b/sound/spi/Makefile
index 026fb73..e49e0f2 100644
--- a/sound/spi/Makefile
+++ b/sound/spi/Makefile
@@ -3,3 +3,4 @@
 snd-at73c213-objs		:= at73c213.o
 
 obj-$(CONFIG_SND_AT73C213)	+= snd-at73c213.o
+obj-$(CONFIG_SND_ALC5680)	+= alc5680.o
diff --git a/sound/spi/alc5680.c b/sound/spi/alc5680.c
new file mode 100644
index 00000000..cbeb0e7
--- /dev/null
+++ b/sound/spi/alc5680.c
@@ -0,0 +1,1255 @@
+/*
+ * alc5680.c  --  ALC5680 SPI driver
+ *
+ * Copyright 2018 Realtek Semiconductor Corp.
+ * Author: Oder Chiou <oder_chiou@realtek.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/input.h>
+#include <linux/spi/spi.h>
+#include <linux/device.h>
+#include <linux/init.h>
+#include <linux/delay.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/slab.h>
+#include <linux/gpio.h>
+#include <linux/sched.h>
+#include <linux/kthread.h>
+#include <linux/uaccess.h>
+#include <linux/miscdevice.h>
+#include <linux/pm_qos.h>
+#include <linux/sysfs.h>
+#include <linux/clk.h>
+#include <sound/core.h>
+#include <sound/pcm.h>
+#include <sound/pcm_params.h>
+#include <sound/soc.h>
+#include <sound/soc-dapm.h>
+#include <sound/initval.h>
+#include <linux/i2c.h>
+#include <linux/of_gpio.h>
+#include <soc/realtek/rtk_regmap.h>
+
+#define HELLO_BLUE_GENIE	0X03
+#define ALEXA 			0X04
+#define SESAMEE 		0X05
+#define BAIDU 			0X76
+
+#define ALC5680_SPI_REG_DRIVER_CTRL0    0x18009060
+#define ALC5680_SPI_REG_DRIVER_CTRL1    0x18009064
+#define REG_KEY_WORD_START              0x18009080
+
+#define SILENCE_MODE_OUTRING_BASE       0x600008f8
+#define SILENCE_MODE_OUTRING_LIMIT      0x600008fc
+#define SILENCE_MODE_OUTRING_WP         0x60000908
+
+#define ALC5680_SPI_DEVICE_ID           0x18008004
+#define MUSIC_MODE_OUTRING_BASE         0x18006900
+#define MUSIC_MODE_OUTRING_LIMIT        0x18006904
+#define MUSIC_MODE_OUTRING_WP           0x1800690c
+
+#define ALC5680_SPI_WOV_MUSIC_MODE   (0)
+#define ALC5680_SPI_WOV_SILENCE_MODE (1)
+
+#define REG_DSP_MUTE_STATE              0x1800C192
+#define REG_DSP_VOICE_DIRECTION         0x180000C8
+
+
+static unsigned char gpio_cs_pin;
+static unsigned char gpio_reset_pin;
+static unsigned short spi_bus_num = 0;
+static struct spi_device *spi_device;
+
+static unsigned int outring_base  = 0;
+static unsigned int outring_limit = 0;
+static unsigned int outring_wp    = 0;
+static unsigned int outring_rp    = 0;
+
+static unsigned int alc5680_spi_reg_dsp_connect = 0;
+static unsigned int alc5680_spi_reg_vol_up = 0;
+static unsigned int alc5680_spi_reg_vol_down = 0;
+static unsigned int alc5680_spi_reg_dsp_mute = 0;
+
+static uint8_t voice_led_position_01 = 0xFF;
+static uint8_t voice_led_position_02 = 0xFF;
+
+static void fl3236_set_led(uint8_t led_position_01, uint8_t  led_position_02, int on_ff);
+
+
+static void convert_mic_position_to_led_position(int voice_direction) {
+
+	if ( voice_direction > 0 && voice_direction <= 30 ) {
+		voice_led_position_01 =  9;
+		voice_led_position_02 =  8;
+	} else if ( voice_direction > 30 && voice_direction <= 60 ) {
+		voice_led_position_01 =  8;
+		voice_led_position_02 =  7;
+	} else if ( voice_direction > 60 && voice_direction <= 90 ) {
+		voice_led_position_01 =  7;
+		voice_led_position_02 =  6;
+	} else if ( voice_direction > 90 && voice_direction <= 120 ) {
+		voice_led_position_01 =  6;
+		voice_led_position_02 =  5;
+	} else if ( voice_direction > 120 && voice_direction <= 150 ) {
+		voice_led_position_01 =  5;
+		voice_led_position_02 =  4;
+	} else if ( voice_direction > 150 && voice_direction <= 180 ) {
+		voice_led_position_01 =  4;
+		voice_led_position_02 =  3;
+	} else if ( voice_direction >= -180 && voice_direction <= -150 ) {
+		voice_led_position_01 =  3;
+		voice_led_position_02 =  2;
+	} else if ( voice_direction >= -150 && voice_direction <= -120 ) {
+		voice_led_position_01 =  2;
+		voice_led_position_02 =  1;
+	} else if ( voice_direction >= -120 && voice_direction <= -90 ) {
+		voice_led_position_01 =  1;
+		voice_led_position_02 = 12;
+	} else if ( voice_direction >= -90 && voice_direction <= -60 ) {
+		voice_led_position_01 = 12;
+		voice_led_position_02 = 11;
+	} else if ( voice_direction >= -60 && voice_direction <= -30 ) {
+		voice_led_position_01 = 11;
+		voice_led_position_02 = 10;
+	} else if ( voice_direction >= -30 && voice_direction <= -0 ) {
+		voice_led_position_01 = 10;
+		voice_led_position_02 =  9;
+	} else {
+		printk("unknown voice position:%d\r\n", voice_direction);
+		voice_led_position_01 =  0xFF;
+		voice_led_position_02 =  0xFF;
+	}
+}
+
+/*****************************************************************************
+ ****** below spi driver                                             *********           
+ *****************************************************************************
+ */
+
+
+static unsigned int alc5680_spi_read32(struct spi_device *spi, unsigned int addr, 
+					unsigned char cs_pin)
+{
+	struct spi_message	msg;
+	struct spi_transfer	xfer[2];	 
+	unsigned char 		tx_buf[9] = {0};
+	unsigned char 		rx_buf[4];
+	int			val;
+	int			error = 0;
+
+	spi_message_init(&msg);
+	memset(xfer, 0, sizeof(xfer));
+	
+	xfer[0].tx_buf = tx_buf;
+	xfer[0].rx_buf = NULL; 
+	xfer[0].len = 9;
+	spi_message_add_tail(&xfer[0], &msg);
+
+	xfer[1].tx_buf = NULL; 
+	xfer[1].rx_buf = rx_buf;
+	xfer[1].len = 4;
+	spi_message_add_tail(&xfer[1], &msg);
+
+	tx_buf[0] = 0x02;
+	tx_buf[1] = (addr >> 24) & 0xff;
+	tx_buf[2] = (addr >> 16) & 0xff;
+	tx_buf[3] = (addr >> 8) & 0xff;
+	tx_buf[4] = addr & 0xff;
+
+	gpio_set_value(cs_pin, 0);
+	error = spi_sync(spi, &msg);
+	gpio_set_value(cs_pin, 1);
+
+	if (error) {
+		pr_err("%s : spi_sync error !!!\n", __func__);
+		return error;
+	}
+
+	val =  ((unsigned int)(rx_buf[0]) << 24) | ((unsigned int)(rx_buf[1]) << 16) |
+		((unsigned int)(rx_buf[2]) << 8) | ((unsigned int)(rx_buf[3]) << 0) ;
+
+	//pr_err("%s : spi_sync ok val=0x%x !!!\n", __func__, val);
+
+	return val;
+}
+
+static int alc5680_spi_write32(struct spi_device *spi, unsigned int addr, 
+					unsigned int val, unsigned char cs_pin)
+{
+	struct spi_message	msg;
+	struct spi_transfer	xfer[1];	 
+	unsigned char		tx_buf[10] = {0};
+	int			error = 0;
+
+	spi_message_init(&msg);
+	memset(xfer, 0, sizeof(xfer));
+	
+	xfer[0].tx_buf = tx_buf;
+	xfer[0].rx_buf = NULL; 
+	xfer[0].len = 9;
+	spi_message_add_tail(&xfer[0], &msg);
+
+	tx_buf[0] = 0x03;
+	tx_buf[1] = (addr >> 24) & 0xff;
+	tx_buf[2] = (addr >> 16) & 0xff;
+	tx_buf[3] = (addr >> 8) & 0xff;
+	tx_buf[4] = addr & 0xff;
+	tx_buf[5] = (val >> 24) & 0xff;
+	tx_buf[6] = (val >> 16) & 0xff;
+	tx_buf[7] = (val >> 8) & 0xff;
+	tx_buf[8] = val & 0xff;	
+
+	gpio_set_value(cs_pin, 0);
+	error = spi_sync(spi, &msg);
+	gpio_set_value(cs_pin, 1);
+
+	if (error) {
+		pr_err("%s : spi_sync error !!!\n", __func__);
+	}
+
+	return error;
+}
+
+static int alc5680_spi_burst_read(struct spi_device *spi, unsigned int addr, unsigned char *rx_buf,
+					unsigned int len, unsigned char cs_pin)
+{
+	struct spi_message	msg;
+	struct spi_transfer	xfer[2];	 
+	unsigned char 		tx_buf[9] = {0};
+	unsigned char 		tmp_buf[4];
+	unsigned int 		len8 = len & 0xfffffff8;
+	int 			i, error = 0;
+
+	if (len8 == 0) { 
+		return 0;
+	}
+
+	spi_message_init(&msg);
+	memset(xfer, 0, sizeof(xfer));
+	
+	xfer[0].tx_buf = tx_buf;
+	xfer[0].rx_buf = NULL; 
+	xfer[0].len = 9;
+	spi_message_add_tail(&xfer[0], &msg);
+
+	xfer[1].tx_buf = NULL; 
+	xfer[1].rx_buf = rx_buf;
+	xfer[1].len = len8;
+	spi_message_add_tail(&xfer[1], &msg);
+
+	tx_buf[0] = 0x04;
+	tx_buf[1] = (addr >> 24) & 0xff;
+	tx_buf[2] = (addr >> 16) & 0xff;
+	tx_buf[3] = (addr >> 8) & 0xff;
+	tx_buf[4] = addr & 0xff;
+
+	gpio_set_value(cs_pin, 0);
+	error = spi_sync(spi, &msg);
+	gpio_set_value(cs_pin, 1);
+
+	if (error) {
+		pr_err("%s : spi_sync error !!!\n", __func__);
+		return error;
+	}
+
+	/* MSB ---> LSB */
+	for (i = 0; i < len8; i += 8) {
+		tmp_buf[0] = rx_buf[i + 0];
+		tmp_buf[1] = rx_buf[i + 1];
+		tmp_buf[2] = rx_buf[i + 2];
+		tmp_buf[3] = rx_buf[i + 3];
+		rx_buf[i + 0] = rx_buf[i + 7];
+		rx_buf[i + 1] = rx_buf[i + 6];
+		rx_buf[i + 2] = rx_buf[i + 5];
+		rx_buf[i + 3] = rx_buf[i + 4];
+		rx_buf[i + 4] = tmp_buf[3];
+		rx_buf[i + 5] = tmp_buf[2];
+		rx_buf[i + 6] = tmp_buf[1];
+		rx_buf[i + 7] = tmp_buf[0];
+
+	}  
+	
+	return len8;
+}
+
+static unsigned char alc5680_spi_get_wov_mode(struct spi_device *spi_device,  unsigned char cs_pin)
+{
+	unsigned int value;
+	
+	value = alc5680_spi_read32(spi_device, ALC5680_SPI_REG_DRIVER_CTRL1, cs_pin);
+	
+	return (value & 0x01) ? 1 : 0;
+}
+
+static void alc5680_spi_set_wov_mode(struct spi_device *spi_device, unsigned char wov_mode, unsigned char cs_pin)
+{
+
+	unsigned int value;
+	value = alc5680_spi_read32(spi_device, ALC5680_SPI_REG_DRIVER_CTRL1, cs_pin);
+
+	if (wov_mode == ALC5680_SPI_WOV_SILENCE_MODE) {
+	
+		alc5680_spi_write32(spi_device, ALC5680_SPI_REG_DRIVER_CTRL1, value |  0x00000001, cs_pin);
+		outring_base  = alc5680_spi_read32(spi_device, SILENCE_MODE_OUTRING_BASE, cs_pin);
+		outring_limit = alc5680_spi_read32(spi_device, SILENCE_MODE_OUTRING_LIMIT, cs_pin);
+		outring_wp    = alc5680_spi_read32(spi_device, SILENCE_MODE_OUTRING_WP, cs_pin);
+
+	} else if (wov_mode == ALC5680_SPI_WOV_MUSIC_MODE) {
+
+		alc5680_spi_write32(spi_device, ALC5680_SPI_REG_DRIVER_CTRL1, value & ~0x00000001, cs_pin);
+		outring_base  = alc5680_spi_read32(spi_device, MUSIC_MODE_OUTRING_BASE, cs_pin);
+		outring_limit = alc5680_spi_read32(spi_device, MUSIC_MODE_OUTRING_LIMIT, cs_pin);
+		outring_wp    = alc5680_spi_read32(spi_device, MUSIC_MODE_OUTRING_WP, cs_pin);
+
+    }
+	
+	outring_limit = ((outring_limit >> 2) + 1) << 2;
+
+	pr_info("outring: %08X ~ %08X\r\n", outring_base, outring_limit);
+
+	outring_rp = outring_wp;
+		
+}
+
+static void alc5680_spi_clear_button_states(struct spi_device *spi_device, unsigned char cs_pin)
+{
+	alc5680_spi_write32(spi_device, alc5680_spi_reg_dsp_connect, 0, cs_pin);
+	alc5680_spi_write32(spi_device, alc5680_spi_reg_vol_up, 0, cs_pin);
+    alc5680_spi_write32(spi_device, alc5680_spi_reg_vol_down, 0, cs_pin);
+    alc5680_spi_write32(spi_device, alc5680_spi_reg_dsp_mute, 0, cs_pin);
+
+}
+
+static unsigned char alc5680_spi_get_mute_state(struct spi_device *spi_device, unsigned char cs_pin)
+{
+	unsigned char value;
+
+	value = alc5680_spi_read32(spi_device, REG_DSP_MUTE_STATE, cs_pin);
+	if (value & 0x00000200) {
+		return 1;
+	}else {
+		return 0;
+	}
+}
+
+static unsigned int alc5680_spi_get_outring_size(void)
+{
+	if (outring_limit > outring_base + 4) {
+		return outring_limit - outring_base;
+	}else {
+		return 0;
+	}
+}
+
+static unsigned int alc5680_spi_fetch_data_dma(struct spi_device *spi_device, unsigned char *buf, unsigned int bufsize, unsigned char cs_pin)
+{
+	unsigned int idx = 0;
+	unsigned int value;
+	unsigned int desire_len;
+	unsigned int read_len = 0, read_len2 = 0;
+	unsigned int target_wp;
+
+	do {
+		if (bufsize < 4) 
+			break;
+	
+		outring_wp = alc5680_spi_read32(spi_device, MUSIC_MODE_OUTRING_WP, cs_pin);
+		target_wp = outring_wp;
+	
+		if (outring_rp == target_wp)
+			break;
+	
+		// Burst read need 8 byte alignment, so we make rp 8 byte alignment
+		if (outring_rp & 0x00000004 != 0) {
+			value = alc5680_spi_read32(spi_device, outring_rp, cs_pin);
+	
+			// NOTICE: PCM data is LSB, not MSB
+			buf[idx]   = (value & 0x000000FF) >>  0;
+			buf[idx+1] = (value & 0x0000FF00) >>  8;
+			buf[idx+2] = (value & 0x00FF0000) >> 16;
+			buf[idx+3] = (value & 0xFF000000) >> 24;
+	
+			idx += 4;
+			outring_rp += 4;
+			if (outring_rp >= outring_limit) 
+				outring_rp = outring_base;
+			bufsize -= 4;
+		}
+	
+		if (outring_rp == target_wp) 
+			break;
+		
+		if (bufsize < 8) 
+			break;
+	
+		if (outring_rp < target_wp) {
+			desire_len = (bufsize > (target_wp - outring_rp)) ? (target_wp - outring_rp) : bufsize;
+			read_len = alc5680_spi_burst_read(spi_device, outring_rp, buf + idx, desire_len, cs_pin);
+			idx += read_len;
+			outring_rp += read_len;
+			if (outring_rp >= outring_limit) {
+				outring_rp = outring_base;
+			}	
+		} else {
+			desire_len = (bufsize > (outring_limit - outring_rp)) ? (outring_limit - outring_rp) : bufsize;
+			read_len = alc5680_spi_burst_read(spi_device, outring_rp, buf + idx, desire_len, cs_pin);
+			idx += read_len;
+			bufsize -= read_len;
+			outring_rp = outring_base;
+		
+			if (bufsize > 0) {
+				desire_len = (bufsize > (target_wp - outring_rp)) ? (target_wp - outring_rp) : bufsize;
+				read_len = alc5680_spi_burst_read(spi_device, outring_rp, buf + idx, desire_len, cs_pin);
+				idx += read_len;
+				outring_rp += read_len;
+				if (outring_rp >= outring_limit) {
+					outring_rp = outring_base;
+				}
+			}
+		}
+	} while (0);
+	
+	return idx;
+}			
+
+static int alc5680_spi_get_voice_direction(struct spi_device *spi_device, unsigned char cs_pin)
+{
+	int direction_sign, direction_exponent, direction_transformed;
+	int direction_mantisse1, direction_mantisse2;
+	unsigned int value = alc5680_spi_read32(spi_device, REG_DSP_VOICE_DIRECTION, cs_pin);
+	
+	/*
+	 * The value of direction is hexadecimal floating point.
+	 * We need to transform it to decimal.
+	 */
+	
+	/* Check the sign bit */
+	if ((value >> 31) == 0)
+		direction_sign = 1;
+	else
+		direction_sign = -1;
+	
+	/* Extract the exponent value */
+	value = value & 0x7FFFFFFF;
+	direction_exponent = (value >> 23);
+	
+	/* Extract the mantisse value */
+	value = value & 0x7FFFFF;
+	direction_mantisse1 = (value >> 19);
+	
+	value = value & 0x7FFFF;
+	direction_mantisse2 = (value >> 15);
+	
+	/*
+	 * We didn't support floating point computation.
+	 * The approximate value of direction can be computed by
+	 * multiplying all value before divisor.
+	 */	
+	direction_transformed = direction_sign * ((256 + direction_mantisse1*16 + direction_mantisse2) * (1<<(direction_exponent-127))) / 256;
+
+	return direction_transformed;
+}
+
+static void alc5680_spi_init_btn_reg(struct spi_device *spi_device, unsigned char cs_pin) 
+{
+	unsigned int addr;
+	
+	addr = alc5680_spi_read32(spi_device, 0x180000D8, cs_pin);
+	alc5680_spi_reg_vol_up = addr;
+	alc5680_spi_reg_vol_down = addr + 0x04;
+	alc5680_spi_reg_dsp_connect = addr + 0x08;
+	alc5680_spi_reg_dsp_mute = addr + 0x0C;
+}
+/*****************************************************************************
+ ****** below alsa driver                                            *********           
+ *****************************************************************************
+ */
+struct alc5680_dsp {
+	struct device *dev;
+	struct spi_device *spi_dev;
+	struct delayed_work copy_work;
+	struct mutex dma_lock;
+	struct snd_pcm_substream *substream;
+	unsigned int buf_base, buf_limit, buf_rp;
+	size_t buf_size;
+	size_t dma_offset;
+	//size_t dsp_offset;
+};
+
+static const struct snd_pcm_hardware alc5680_spi_pcm_hardware = {
+	.info                   = SNDRV_PCM_INFO_MMAP |
+							SNDRV_PCM_INFO_MMAP_VALID |
+							SNDRV_PCM_INFO_INTERLEAVED,
+	.formats                = SNDRV_PCM_FMTBIT_S16_LE,
+	.rates					= SNDRV_PCM_RATE_16000,
+	.rate_min				= 16000,
+	.rate_max 				= 16000,
+	.period_bytes_min       = 64,
+	.period_bytes_max       = 1024*256,
+	.periods_min            = 32,
+	.periods_max            = 1024,
+	.channels_min           = 1,
+	.channels_max           = 1,
+	.buffer_bytes_max       = 1024*256,
+};
+
+static void alc5680_spi_copy_work(struct work_struct *work)
+{
+	struct alc5680_dsp *alc5680_dsp =
+			container_of(work, struct alc5680_dsp, copy_work.work);
+	struct snd_pcm_runtime *runtime;
+	size_t period_bytes, truncated_bytes = 0;
+	
+	mutex_lock(&alc5680_dsp->dma_lock);
+	if (!alc5680_dsp->substream) {
+		dev_err(alc5680_dsp->dev, "No pcm substream\n");
+		goto done;
+	}
+	
+	runtime = alc5680_dsp->substream->runtime;
+	
+	period_bytes = snd_pcm_lib_period_bytes(alc5680_dsp->substream);
+	if ((alc5680_dsp->dma_offset + period_bytes) >= runtime->dma_bytes)
+		alc5680_dsp->dma_offset = 0;
+	
+	outring_wp   = alc5680_spi_read32(spi_device, MUSIC_MODE_OUTRING_WP, gpio_cs_pin);
+	
+	if (alc5680_dsp->buf_rp + period_bytes <= alc5680_dsp->buf_limit) {
+		
+		if ((alc5680_dsp->buf_rp + period_bytes > outring_wp) && (alc5680_dsp->buf_rp < outring_wp))
+			period_bytes = outring_wp - alc5680_dsp->buf_rp;
+	
+		alc5680_spi_burst_read(alc5680_dsp->spi_dev, alc5680_dsp->buf_rp,
+				runtime->dma_area + alc5680_dsp->dma_offset,
+				period_bytes, gpio_cs_pin);
+
+		if (alc5680_dsp->buf_rp + period_bytes == alc5680_dsp->buf_limit)
+				alc5680_dsp->buf_rp = alc5680_dsp->buf_base;
+		else
+				alc5680_dsp->buf_rp += period_bytes;
+	} else {		
+		 if ((alc5680_dsp->buf_rp < outring_wp) && (alc5680_dsp->buf_limit > outring_wp)) {
+			period_bytes = outring_wp -  alc5680_dsp->buf_rp;
+
+			alc5680_spi_burst_read(alc5680_dsp->spi_dev, alc5680_dsp->buf_rp,
+				runtime->dma_area + alc5680_dsp->dma_offset,
+				period_bytes, gpio_cs_pin);
+				
+			alc5680_dsp->buf_rp += period_bytes;
+		}
+		else {			
+			truncated_bytes = alc5680_dsp->buf_limit - alc5680_dsp->buf_rp;
+			
+			if (outring_wp < (alc5680_dsp->buf_base + period_bytes - truncated_bytes))
+				period_bytes = outring_wp - alc5680_dsp->buf_base + truncated_bytes;
+			
+			alc5680_spi_burst_read(alc5680_dsp->spi_dev, alc5680_dsp->buf_rp,
+					runtime->dma_area + alc5680_dsp->dma_offset,
+					truncated_bytes, gpio_cs_pin);
+					
+			alc5680_spi_burst_read(alc5680_dsp->spi_dev, alc5680_dsp->buf_base,
+					runtime->dma_area + alc5680_dsp->dma_offset +
+					truncated_bytes, period_bytes - truncated_bytes, gpio_cs_pin);
+	
+			alc5680_dsp->buf_rp = alc5680_dsp->buf_base +
+					period_bytes - truncated_bytes;
+		}
+	}
+	
+	alc5680_dsp->dma_offset += period_bytes;
+	
+	//alc5680_dsp->dsp_offset += period_bytes;
+	
+	snd_pcm_period_elapsed(alc5680_dsp->substream);
+	
+	//if (alc5680_dsp->dsp_offset < alc5680_dsp->buf_size)
+	schedule_delayed_work(&alc5680_dsp->copy_work, 4);
+
+done:
+	mutex_unlock(&alc5680_dsp->dma_lock);
+
+}
+
+static int alc5680_spi_pcm_open(struct snd_pcm_substream *substream)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+
+	//runtime->hw = alc5680_spi_pcm_hardware; 
+	memcpy(&runtime->hw, &alc5680_spi_pcm_hardware, sizeof(struct snd_pcm_hardware));
+
+	return 0;
+}
+
+static int alc5680_spi_pcm_close(struct snd_pcm_substream *substream)
+{
+
+	return 0;
+}
+
+static int alc5680_spi_hw_params(struct snd_pcm_substream *substream,
+                               struct snd_pcm_hw_params *hw_params)
+{
+	struct alc5680_dsp *alc5680_dsp = snd_pcm_substream_chip(substream);
+	int ret;
+
+	mutex_lock(&alc5680_dsp->dma_lock);
+	ret = snd_pcm_lib_alloc_vmalloc_buffer(substream,
+					params_buffer_bytes(hw_params));
+	alc5680_dsp->substream = substream;
+	mutex_unlock(&alc5680_dsp->dma_lock);
+	
+	return ret;
+}
+
+static int alc5680_spi_hw_free(struct snd_pcm_substream *substream)
+{
+	struct alc5680_dsp *alc5680_dsp = snd_pcm_substream_chip(substream);
+	int i;
+	
+	cancel_delayed_work_sync(&alc5680_dsp->copy_work);
+
+	mutex_lock(&alc5680_dsp->dma_lock);
+	alc5680_dsp->substream = NULL;
+	mutex_unlock(&alc5680_dsp->dma_lock);
+	
+	/* all LED off */
+	for (i = 1; i < 12 ; i++)
+		fl3236_set_led(i, i+1, 0);
+	
+	return snd_pcm_lib_free_vmalloc_buffer(substream);
+}
+
+static int alc5680_spi_prepare(struct snd_pcm_substream *substream)
+{
+	struct alc5680_dsp *alc5680_dsp = snd_pcm_substream_chip(substream);
+
+	alc5680_dsp->dma_offset = 0;
+	//alc5680_dsp->dsp_offset = 0;
+	
+	/**
+	* The address area x1800XXXX is the register address, and it cannot
+	* support spi burst read perfectly. So we use the spi burst read
+	* individually to make sure the data correctly.
+	*/
+
+	alc5680_dsp->buf_base	= alc5680_spi_read32(spi_device, MUSIC_MODE_OUTRING_BASE, gpio_cs_pin);
+	alc5680_dsp->buf_limit	= alc5680_spi_read32(spi_device, MUSIC_MODE_OUTRING_LIMIT, gpio_cs_pin) + 0x2;
+	alc5680_dsp->buf_rp	= alc5680_spi_read32(spi_device, MUSIC_MODE_OUTRING_WP, gpio_cs_pin);
+
+	return 0;
+}
+
+
+static int alc5680_spi_trigger(struct snd_pcm_substream *substream, int cmd)
+{
+	struct alc5680_dsp *alc5680_dsp = snd_pcm_substream_chip(substream);
+	int i;
+	
+	if (cmd == SNDRV_PCM_TRIGGER_START) {
+		if (alc5680_dsp->buf_base && alc5680_dsp->buf_limit &&
+			alc5680_dsp->buf_rp){
+
+			/* all LED off */
+			for (i = 1; i < 12 ; i++)
+				fl3236_set_led(i, i+1, 0);
+
+			/* Get the voice direction and show the light*/
+			convert_mic_position_to_led_position(alc5680_spi_get_voice_direction(alc5680_dsp->spi_dev, gpio_cs_pin));
+			fl3236_set_led(voice_led_position_01, voice_led_position_02, 1);
+
+			schedule_delayed_work(&alc5680_dsp->copy_work, 0);
+		}
+	}
+	
+	return 0;
+}
+
+static snd_pcm_uframes_t alc5680_spi_pcm_pointer(
+                struct snd_pcm_substream *substream)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+	struct alc5680_dsp *alc5680_dsp = snd_pcm_substream_chip(substream);
+
+	return bytes_to_frames(runtime, alc5680_dsp->dma_offset);
+}
+
+static int alc5680_spi_pcm_ioctl(struct snd_pcm_substream *substream,  unsigned int cmd, void *arg)
+{
+	printk("%s %d cmd %x\n",__func__, __LINE__, cmd);
+
+	switch (cmd) 
+    {
+		case SNDRV_PCM_IOCTL_HW_REFINE:
+			printk("%s %d cmd %x\n",__func__, __LINE__, cmd);
+			return 0;
+		case SNDRV_PCM_IOCTL_HW_PARAMS:
+			printk("%s %d cmd %x\n",__func__, __LINE__, cmd);
+			return 0;
+        default:
+			printk("%s %d cmd %x\n",__func__, __LINE__, cmd);
+            return snd_pcm_lib_ioctl(substream, cmd, arg);
+            break; 
+    }
+
+    return 0;
+}
+
+
+static const struct snd_pcm_ops alc5680_capture_ops = {
+	.open		 = alc5680_spi_pcm_open,
+	.close		 = alc5680_spi_pcm_close,
+	.ioctl		 = alc5680_spi_pcm_ioctl,
+	.hw_params	 = alc5680_spi_hw_params,
+	.hw_free	 = alc5680_spi_hw_free,
+	.prepare	 = alc5680_spi_prepare,
+	.trigger	 = alc5680_spi_trigger,
+	.pointer	 = alc5680_spi_pcm_pointer,
+	.mmap		 = snd_pcm_lib_mmap_vmalloc,
+	.page		 = snd_pcm_lib_get_vmalloc_page,
+};
+
+static int alc5680_spi_probe(struct spi_device *spi_device)
+{
+	struct snd_card		*card;
+	struct snd_pcm 		*pcm;
+	struct alc5680_dsp 	*alc5680_dsp;
+	unsigned int value;
+	int retval;
+
+	/* create alsa device & driver */
+	retval = snd_card_new(&spi_device->dev, -1, "snd_card_alc5680", THIS_MODULE,
+                              sizeof(struct alc5680_dsp), &card);
+	if (retval < 0) {
+		pr_err("%s , snd_card_new error\n", __func__);
+		goto out;
+	}
+
+	retval = snd_pcm_new(card, "snd_alc5680",
+                        0, 0, 1, &pcm);
+	if (retval < 0) {
+		pr_err("%s , snd_pcm_new error\n", __func__);
+		goto out;
+	}
+
+	strcpy(pcm->name, "alc5680");
+	snd_pcm_set_ops(pcm, SNDRV_PCM_STREAM_CAPTURE, &alc5680_capture_ops);	
+	
+	alc5680_dsp = devm_kzalloc(&spi_device->dev, sizeof(struct alc5680_dsp),
+                        GFP_KERNEL);
+
+	pcm->private_data = alc5680_dsp;
+
+	alc5680_dsp->dev = &spi_device->dev;
+	alc5680_dsp->spi_dev = spi_device;
+
+	mutex_init(&alc5680_dsp->dma_lock);
+	INIT_DELAYED_WORK(&alc5680_dsp->copy_work, alc5680_spi_copy_work);
+	spi_set_drvdata(spi_device, alc5680_dsp);
+	
+	retval = snd_card_register(card);
+	if (retval < 0) {
+		pr_err("%s , snd_card_register error\n", __func__);
+		goto out;
+	}
+
+	/* Check the device id */
+	value = alc5680_spi_read32(spi_device, ALC5680_SPI_DEVICE_ID, gpio_cs_pin);
+	pr_info("%s device id is 0x%x\n",__func__, value);
+	
+	/* doing something init */	
+	alc5680_spi_set_wov_mode(spi_device, ALC5680_SPI_WOV_MUSIC_MODE, gpio_cs_pin );
+	alc5680_spi_clear_button_states(spi_device, gpio_cs_pin);	
+	alc5680_spi_init_btn_reg(spi_device, gpio_cs_pin);
+
+	/* doing this for what ??? */
+	value = alc5680_spi_read32(spi_device, 0x18008208, gpio_cs_pin);
+	value = value | 0x200000;
+	alc5680_spi_write32(spi_device, 0x18008208, value, gpio_cs_pin);
+
+	if (outring_base == 0xDEADBEEF || outring_limit - outring_base <= 4) {
+        retval = -EIO;
+	}	
+
+out:
+	return retval;
+
+}
+
+static int alc5680_spi_remove(struct spi_device *spi_device)
+{
+
+	return 0;
+}
+
+static struct spi_board_info alc5680_info = {
+	.modalias       = "alc5680",
+	.chip_select	= 0,
+	.max_speed_hz  	= 2*1000*1000,
+	.mode 		= SPI_MODE_0,	
+};
+
+
+static struct spi_driver alc5680_spi_driver = {
+	.driver			= {
+		.name  	= "alc5680",
+		.owner 	= THIS_MODULE,
+	},
+	.probe       	= alc5680_spi_probe,
+	.remove       	= alc5680_spi_remove,
+};
+
+/*****************************************************************************
+******* below i2c driver                                            *********           
+******************************************************************************
+*/
+
+struct alc5680_priv {
+
+	struct regmap *regmap;
+};
+
+static const struct regmap_config alc5680_regmap = {
+	.reg_bits = 16,
+	.val_bits = 16,
+	.max_register = 0xffff,
+};
+
+static void alc5680_i2c_write_32(struct alc5680_priv *alc5680, u32 reg, u32 val)
+{
+
+	regmap_write(alc5680->regmap, 0x0001, reg & 0xffff);
+	regmap_write(alc5680->regmap, 0x0002, reg >> 16);
+	regmap_write(alc5680->regmap, 0x0003, val & 0xffff);
+	regmap_write(alc5680->regmap, 0x0004, val >> 16);
+	regmap_write(alc5680->regmap, 0x0000, 0x0003);
+
+}
+
+static void alc5680_i2c_write_16(struct alc5680_priv *alc5680, u32 reg, u16 val)
+{
+
+	regmap_write(alc5680->regmap, 0x0001, reg & 0xffff);
+	regmap_write(alc5680->regmap, 0x0002, reg >> 16);
+	regmap_write(alc5680->regmap, 0x0003, val & 0xffff);
+	regmap_write(alc5680->regmap, 0x0000, 0x0001);
+
+}
+
+static void alc5680_i2c_read_32(struct alc5680_priv *alc5680, u32 reg, u32 *val)
+{
+	u16 buf[2];
+
+	regmap_write(alc5680->regmap, 0x0001, reg & 0xffff);
+	regmap_write(alc5680->regmap, 0x0002, reg >> 16);
+	regmap_write(alc5680->regmap, 0x0000, 0x0002);
+	regmap_read(alc5680->regmap, 0x0003, &buf[0]); 
+	regmap_read(alc5680->regmap, 0x0004, &buf[1]);
+	*val = 	buf[1] << 16 | buf[0]; 
+}
+
+static void alc5680_i2c_read_16(struct alc5680_priv *alc5680, u32 reg, u16 *val)
+{
+	regmap_write(alc5680->regmap, 0x0001, reg & 0xffff);
+	regmap_write(alc5680->regmap, 0x0002, reg >> 16);
+	regmap_write(alc5680->regmap, 0x0000, 0x0002);
+	regmap_read(alc5680->regmap, 0x0003, val); 
+}
+
+
+static int alc5680_get_version(struct alc5680_priv *alc5680)
+{	
+	unsigned int value = 0;
+
+	alc5680_i2c_read_32(alc5680, 0x7000A004, &value);
+      	value = value>>24;
+
+	if(value == HELLO_BLUE_GENIE )
+		pr_info("VERSION:HELLO_BLUE_GENIE\n");
+	else if(value == ALEXA)
+		pr_info("VERSION:ALEXA\n");
+	else if(value == SESAMEE)
+		pr_info("VERSION:Zhima kaimen\n");
+	else if(value == BAIDU)
+		pr_info("VERSION:Xiao du xiao du\n");
+	else
+		pr_info("NON-DEFINE VERSION ADDR=0X7000A004 %x\n",value);
+	
+	return value;
+
+}
+
+static void alc5680_set_volume(struct alc5680_priv *alc5680, unsigned char left, unsigned char right)
+{
+	alc5680_i2c_write_16(alc5680, 0x1800C02C, left<<8|right);
+}
+
+static void alc5680_get_volume(struct alc5680_priv *alc5680, unsigned short *value)
+{
+	alc5680_i2c_read_16(alc5680, 0x1800C02C, value);
+}
+
+static int alc5680_i2c_probe(struct i2c_client *i2c,
+                             const struct i2c_device_id *id)
+{
+	struct alc5680_priv *alc5680;
+	int i, ret;
+
+	pr_info("%s id->name =%s i2c->name=%s i2c->addr=0x%x \n", __func__, id->name, i2c->name, i2c->addr);
+	alc5680 = devm_kzalloc(&i2c->dev, sizeof(struct alc5680_priv),
+                               GFP_KERNEL);
+	if (alc5680 == NULL)
+		return -ENOMEM;
+	alc5680->regmap = devm_rtk_regmap_init_i2c(i2c, &alc5680_regmap);
+
+	if (IS_ERR(alc5680->regmap))
+		return PTR_ERR(alc5680->regmap);
+
+	alc5680_get_version(alc5680);
+	alc5680_set_volume(alc5680, 200, 200);
+	return 0;
+}
+
+static int alc5680_i2c_remove(struct i2c_client *client)
+{
+	return 0;
+}
+
+static const struct i2c_device_id alc5680_i2c_id[] = {
+	{ "rtk,alc5680", 0 },
+	{ }
+};
+MODULE_DEVICE_TABLE(i2c, alc5680_i2c_id);
+
+static const struct of_device_id alc5680_of_id[] = {
+	{ .compatible = "rtk,alc5680", },
+	{ /* senitel */ }
+};
+MODULE_DEVICE_TABLE(of, alc5680_of_id);
+
+
+static struct i2c_driver alc5680_i2c_driver = {
+	.driver = {
+		.name = "rtk,alc5680",
+		.owner = THIS_MODULE,
+		.of_match_table = alc5680_of_id,
+	},
+	.probe =    alc5680_i2c_probe,
+	.remove =   alc5680_i2c_remove,
+	.id_table = alc5680_i2c_id,
+};
+
+/*****************************************************************************
+******* below fl3236 led i2c driver                                  *********           
+******************************************************************************
+*/
+struct fl3236_priv {
+
+	struct regmap *regmap;
+};
+
+
+struct fl3236_priv *fl3236;
+
+
+static const struct regmap_config fl3236_regmap = {
+	.reg_bits = 8,
+	.val_bits = 8,
+	.max_register = 0xffff,
+};
+
+static void fl3236_set_led(uint8_t led_position_01, uint8_t  led_position_02, int on_off)
+{
+	/* pwm luminous intensity */
+	regmap_write(fl3236->regmap, 0x01+(led_position_01-1)*3, 0x80);
+	regmap_write(fl3236->regmap, 0x01+(led_position_02-1)*3, 0x80);
+	regmap_write(fl3236->regmap, 0x01+(led_position_01-1)*3 + 1, 0x80);
+	regmap_write(fl3236->regmap, 0x01+(led_position_02-1)*3 + 1, 0x80);
+	regmap_write(fl3236->regmap, 0x01+(led_position_01-1)*3 + 2, 0x80);
+	regmap_write(fl3236->regmap, 0x01+(led_position_02-1)*3 + 2, 0x80);
+
+	/* LED Control */
+	regmap_write(fl3236->regmap, 0x26+(led_position_01-1)*3, on_off);
+	regmap_write(fl3236->regmap, 0x26+(led_position_02-1)*3, on_off);
+	regmap_write(fl3236->regmap, 0x26+(led_position_01-1)*3 + 1, on_off);
+	regmap_write(fl3236->regmap, 0x26+(led_position_02-1)*3 + 1, on_off);
+	regmap_write(fl3236->regmap, 0x26+(led_position_01-1)*3 + 2, on_off);
+	regmap_write(fl3236->regmap, 0x26+(led_position_02-1)*3 + 2, on_off);
+
+	/* pwm Update */
+	regmap_write(fl3236->regmap, 0x25, 0);
+}
+
+static int fl3236_i2c_probe(struct i2c_client *i2c,
+                             const struct i2c_device_id *id)
+{
+	int i, ret;
+
+	pr_err("%s id->name =%s i2c->name=%s i2c->addr=0x%x \n", __func__, id->name, i2c->name, i2c->addr);
+	fl3236 = devm_kzalloc(&i2c->dev, sizeof(struct fl3236_priv),
+						GFP_KERNEL);
+	if (fl3236 == NULL)
+		return -ENOMEM;
+
+	fl3236->regmap = devm_rtk_regmap_init_i2c(i2c, &fl3236_regmap);
+
+	if (IS_ERR(fl3236->regmap))
+		return PTR_ERR(fl3236->regmap);
+
+	/* Reset */
+	regmap_write(fl3236->regmap, 0x4f, 0);
+
+	/* Normal operation */
+	regmap_write(fl3236->regmap, 0x00, 1);
+
+	/* all LED on */
+	for (i = 1; i < 12 ; i++)
+		fl3236_set_led(i, i+1, 1);
+	
+	mdelay(1000);
+	
+	for (i = 1; i < 12 ; i++)
+		fl3236_set_led(i, i+1, 0);
+
+	return 0;
+}
+
+static const struct i2c_device_id fl3236_i2c_id[] = {
+	{ "rtk,fl3236", 0 },
+	{ }
+};
+MODULE_DEVICE_TABLE(i2c, fl3236_i2c_id);
+
+static const struct of_device_id fl3236_of_id[] = {
+	{ .compatible = "rtk,fl3236", },
+	{ /* senitel */ }
+};
+MODULE_DEVICE_TABLE(of, fl3236_of_id);
+
+
+static struct i2c_driver fl3236_i2c_driver = {
+	.driver = {
+		.name = "rtk,fl3236",
+		.owner = THIS_MODULE,
+		.of_match_table = fl3236_of_id,
+	},
+	.probe =    fl3236_i2c_probe,
+//	.remove =   fl3236_i2c_remove,
+	.id_table = fl3236_i2c_id,
+};
+
+/*****************************************************************************
+******* below  alc5640 i2c driver                                    *********           
+******************************************************************************
+*/
+struct alc5640_priv {
+
+	struct regmap *regmap;
+};
+
+
+struct alc5640_priv *alc5640;
+
+static const struct regmap_config alc5640_regmap = {
+	.reg_bits = 8,
+	.val_bits = 16,
+	.max_register = 0xff,
+};
+
+static const struct reg_default alc5640_reg_defaults[] = {
+	{ .reg = 0x00, .def = 0x0000, },
+	{ .reg = 0xfa, .def = 0x0801, },
+	{ .reg = 0x81, .def = 0x0f06, },
+	{ .reg = 0x82, .def = 0x0800, },
+	{ .reg = 0x63, .def = 0xf818, },
+	{ .reg = 0x61, .def = 0x9800, },
+	{ .reg = 0x64, .def = 0x0200, },
+	{ .reg = 0x03, .def = 0x4848, },
+	{ .reg = 0x2a, .def = 0x1414, },
+	{ .reg = 0x45, .def = 0x6000, },
+	{ .reg = 0x53, .def = 0x3000, },
+	{ .reg = 0x70, .def = 0x8008, },
+	{ .reg = 0x73, .def = 0x0110, },
+	{ .reg = 0x80, .def = 0x5000, },
+	{ .reg = 0x8e, .def = 0x0019, },
+	{ .reg = 0x8f, .def = 0x3100, },
+	{ .reg = 0x91, .def = 0x0f00, },
+	{ .reg = 0x6a, .def = 0x003d, },
+	{ .reg = 0x6c, .def = 0x2600, },
+	{ .reg = 0x48, .def = 0x3800, },
+	{ .reg = 0x49, .def = 0x1800, },
+	{ .reg = 0x01, .def = 0x4848, },
+	{ .reg = 0x61, .def = 0x9801, },
+	{ .reg = 0xbb, .def = 0x8308, },
+	{ .reg = 0x4a, .def = 0x0000, },
+	
+};
+
+static int alc5640_i2c_probe(struct i2c_client *i2c,
+                             const struct i2c_device_id *id)
+{
+	int i, ret;
+	void __iomem	*pad_mux;
+	
+	pr_err("%s id->name =%s i2c->name=%s i2c->addr=0x%x \n", __func__, id->name, i2c->name, i2c->addr);
+	alc5640 = devm_kzalloc(&i2c->dev, sizeof(struct alc5640_priv),
+						GFP_KERNEL);
+	if (fl3236 == NULL)
+		return -ENOMEM;
+	
+	alc5640->regmap = devm_rtk_regmap_init_i2c(i2c, &alc5640_regmap);
+	
+	if (IS_ERR(alc5640->regmap))
+		return PTR_ERR(alc5640->regmap);
+	
+	/* Set the padmux before doing setting */
+	pad_mux = ioremap(0x9804d008, 0x120);
+	writel(0x281540, pad_mux);
+	
+	/* init */
+	for (i = 0;  i < 25;  i++) {
+		regmap_write(alc5640->regmap, alc5640_reg_defaults[i].reg, alc5640_reg_defaults[i].def);
+		mdelay(1);
+	}
+
+	return 0;
+}
+
+static const struct i2c_device_id alc5640_i2c_id[] = {
+	{ "rtk,alc5640", 0 },
+	{ }
+};
+MODULE_DEVICE_TABLE(i2c, alc5640_i2c_id);
+
+static const struct of_device_id alc5640_of_id[] = {
+	{ .compatible = "rtk,alc5640", },
+	{ /* senitel */ }
+};
+MODULE_DEVICE_TABLE(of, alc5640_of_id);
+
+static struct i2c_driver alc5640_i2c_driver = {
+	.driver = {
+		.name = "rtk,alc5640",
+		.owner = THIS_MODULE,
+		.of_match_table = alc5640_of_id,
+	},
+	.probe =    alc5640_i2c_probe,
+//	.remove =   alc5640_i2c_remove,
+	.id_table = alc5640_i2c_id,
+};
+
+static int rtk_alc5680_probe(struct platform_device *pdev)
+{
+	struct spi_master *spi_master;
+	int                error;
+	void __iomem	*gpio;
+	
+	/* get chip select gpio , init */
+	gpio_cs_pin = of_get_gpio(pdev->dev.of_node, 0);
+	gpio_request(gpio_cs_pin, "rtk_alc5680");
+	gpio_direction_output(gpio_cs_pin,0);
+	gpio_set_value(gpio_cs_pin,1);
+	
+	/* Set the pinmux before doing reset */
+	gpio = ioremap(0x9801a910, 0x120);
+	writel(0x6DB, gpio);
+	gpio = ioremap(0x9801b100, 0x120);
+	writel(0xe90000, gpio);
+		
+	gpio_reset_pin = of_get_gpio(pdev->dev.of_node, 1);
+	pr_err("%s gpio_reset_pin=0x%x \n", __func__, gpio_reset_pin);
+	gpio_request(gpio_reset_pin, "rtk_alc5680");
+	gpio_direction_output(gpio_reset_pin,0);
+	gpio_set_value(gpio_reset_pin,1);
+	
+	mdelay(2000); //wait for alc5520 is ready
+	
+	/* Recovery the pinmux after doing reset */
+	gpio = ioremap(0x9801a910, 0x120);
+	writel(0x000cf6db, gpio);
+	gpio = ioremap(0x9801b100, 0x120);
+	writel(0x00e90040, gpio);
+
+	/* create spi device & driver */
+	error = spi_register_driver(&alc5680_spi_driver);
+	if (error < 0) {
+		printk(KERN_ERR "spi_register_driver() returned %d\n", error);
+		return error;
+	}
+
+	spi_master = spi_busnum_to_master(spi_bus_num);
+	if (!spi_master) {
+		printk(KERN_ERR "spi_busnum_to_master(%d) returned NULL\n", spi_bus_num);
+		spi_unregister_driver(&alc5680_spi_driver);
+		error = -ENODEV;
+		return error;
+	}
+
+	spi_device = spi_new_device(spi_master, &alc5680_info);
+	if (!spi_device) {
+		printk(KERN_ERR "spi_new_device() returned NULL\n");
+		spi_master_put(spi_master);
+		return -EPERM;
+	}
+
+	spi_master_put(spi_master);
+
+	/* create i2c driver */
+	error = i2c_add_driver(&alc5680_i2c_driver);
+	if (error) {
+		printk(KERN_ERR "Fail to register ALC5680 I2C driver: %d\n",
+			error); 
+	}
+	
+	error = i2c_add_driver(&fl3236_i2c_driver);
+	if (error) {
+		printk(KERN_ERR "Fail to register FL3236 I2C driver: %d\n",
+			error); 
+	}
+	
+	error = i2c_add_driver(&alc5640_i2c_driver);
+	if (error) {
+		printk(KERN_ERR "Fail to register ALC5640 I2C driver: %d\n",
+			error); 
+	}
+
+	return 0;
+}
+
+static int rtk_alc5680_remove(struct platform_device *pdev)
+{
+
+	spi_unregister_driver(&alc5680_spi_driver);
+	i2c_del_driver(&alc5680_i2c_driver);
+	return 0;
+}
+
+static const struct of_device_id rtk_alc5680_dt_ids[] = {
+	{ .compatible = "Realtek,rtk-alc5680", },
+	{},
+};
+MODULE_DEVICE_TABLE(of, rtk_alc5680_dt_ids);
+
+
+static struct platform_driver rtk_alc5680_driver = {
+    .probe = rtk_alc5680_probe,
+    .remove = rtk_alc5680_remove,
+    .driver = {
+		.name = "rtk_alc5680",
+		.owner = THIS_MODULE,
+		.of_match_table = of_match_ptr(rtk_alc5680_dt_ids),
+	},
+};
+
+module_platform_driver(rtk_alc5680_driver);
+
+
+MODULE_AUTHOR("Cy Huang");
+MODULE_DESCRIPTION("ALC5680 Kernel Driver");
+MODULE_LICENSE("GPL");
+
diff --git a/sound/usb/card.c b/sound/usb/card.c
index 8906199..d352a45 100644
--- a/sound/usb/card.c
+++ b/sound/usb/card.c
@@ -45,6 +45,9 @@
 #include <linux/usb/audio.h>
 #include <linux/usb/audio-v2.h>
 #include <linux/module.h>
+#ifdef CONFIG_RTK_PLATFORM
+#include <linux/switch.h>
+#endif /* CONFIG_RTK_PLATFORM */
 
 #include <sound/control.h>
 #include <sound/core.h>
@@ -84,6 +87,11 @@
 static bool autoclock = true;
 static char *quirk_alias[SNDRV_CARDS];
 
+#ifdef CONFIG_RTK_PLATFORM
+struct switch_dev *usbaudiosdev = NULL;
+int num_playback_device = 0;
+#endif /* CONFIG_RTK_PLATFORM */
+
 module_param_array(index, int, NULL, 0444);
 MODULE_PARM_DESC(index, "Index value for the USB audio adapter.");
 module_param_array(id, charp, NULL, 0444);
@@ -129,6 +137,14 @@ static void snd_usb_stream_disconnect(struct snd_usb_stream *as)
 		subs->interface = -1;
 		subs->data_endpoint = NULL;
 		subs->sync_endpoint = NULL;
+#ifdef CONFIG_RTK_PLATFORM
+		if (subs->direction == SNDRV_PCM_STREAM_PLAYBACK && usbaudiosdev != NULL && num_playback_device != 0) {
+			num_playback_device--;
+			/* up plug case --  multi cards is handled by HAL audio_hw.c */
+			if (num_playback_device == 0)
+				switch_set_state(usbaudiosdev, 0);
+		}
+#endif /* CONFIG_RTK_PLATFORM */
 	}
 }
 
@@ -548,6 +564,13 @@ static int usb_audio_probe(struct usb_interface *intf,
 	int ifnum;
 	u32 id;
 
+#ifdef CONFIG_RTK_PLATFORM
+	int card_num;
+
+	/* record number to detect the cards */
+	card_num = num_playback_device;
+#endif /* CONFIG_RTK_PLATFORM */
+
 	alts = &intf->altsetting[0];
 	ifnum = get_iface_desc(alts)->bInterfaceNumber;
 	id = USB_ID(le16_to_cpu(dev->descriptor.idVendor),
@@ -635,6 +658,13 @@ static int usb_audio_probe(struct usb_interface *intf,
 	if (err < 0)
 		goto __error;
 
+#ifdef CONFIG_RTK_PLATFORM
+	/* if card number is changed , to change the state */
+	if (num_playback_device != card_num)
+		/* switch_set_state(usbaudiosdev, 1); */
+		switch_set_state(usbaudiosdev, num_playback_device);
+#endif /* CONFIG_RTK_PLATFORM */
+
 	usb_chip[chip->index] = chip;
 	chip->num_interfaces++;
 	usb_set_intfdata(intf, chip);
@@ -858,4 +888,31 @@ static int usb_audio_reset_resume(struct usb_interface *intf)
 	.supports_autosuspend = 1,
 };
 
+#ifdef CONFIG_RTK_PLATFORM
+static int __init snd_usb_audio_init(void)
+{
+	int err = 0;
+
+	usbaudiosdev = kzalloc(sizeof(struct switch_dev), GFP_KERNEL);
+	usbaudiosdev->name = "usb_audio";
+
+	err = switch_dev_register(usbaudiosdev);
+	if (err)
+		pr_err("Usb-audio switch registration failed\n");
+	else
+		pr_debug("usb hs_detected\n");
+
+	return usb_register(&usb_audio_driver);
+}
+
+static void __exit snd_usb_audio_cleanup(void)
+{
+	usb_deregister(&usb_audio_driver);
+	switch_dev_unregister(usbaudiosdev);
+}
+
+module_init(snd_usb_audio_init);
+module_exit(snd_usb_audio_cleanup);
+#else
 module_usb_driver(usb_audio_driver);
+#endif /* CONFIG_RTK_PLATFORM */
diff --git a/sound/usb/stream.c b/sound/usb/stream.c
index 8e9548bc..ea7979f 100644
--- a/sound/usb/stream.c
+++ b/sound/usb/stream.c
@@ -20,6 +20,9 @@
 #include <linux/usb.h>
 #include <linux/usb/audio.h>
 #include <linux/usb/audio-v2.h>
+#ifdef CONFIG_RTK_PLATFORM
+#include <linux/switch.h>
+#endif /* CONFIG_RTK_PLATFORM */
 
 #include <sound/core.h>
 #include <sound/pcm.h>
@@ -37,6 +40,11 @@
 #include "clock.h"
 #include "stream.h"
 
+#ifdef CONFIG_RTK_PLATFORM
+extern struct switch_dev *usbaudiosdev;
+extern int num_playback_device;
+#endif /* CONFIG_RTK_PLATFORM */
+
 /*
  * free a substream
  */
@@ -52,6 +60,15 @@ static void free_substream(struct snd_usb_substream *subs)
 		kfree(fp);
 	}
 	kfree(subs->rate_list.list);
+
+#ifdef CONFIG_RTK_PLATFORM
+#if 0
+	if(subs->direction == SNDRV_PCM_STREAM_PLAYBACK && usbaudiosdev != NULL) {
+		//pr_info("***** %s %d free playback device\n", __func__, __LINE__);
+		//switch_set_state(usbaudiosdev, 0);
+	}
+#endif
+#endif /* CONFIG_RTK_PLATFORM */
 }
 
 
@@ -349,6 +366,10 @@ int snd_usb_add_audio_stream(struct snd_usb_audio *chip,
 		if (err < 0)
 			return err;
 		snd_usb_init_substream(as, stream, fp);
+#ifdef CONFIG_RTK_PLATFORM
+		if (stream == SNDRV_PCM_STREAM_PLAYBACK && usbaudiosdev != NULL)
+			num_playback_device++;
+#endif /* CONFIG_RTK_PLATFORM */
 		return add_chmap(as->pcm, stream, subs);
 	}
 
@@ -391,6 +412,11 @@ int snd_usb_add_audio_stream(struct snd_usb_audio *chip,
 
 	snd_usb_proc_pcm_format_add(as);
 
+#ifdef CONFIG_RTK_PLATFORM
+	if (stream == SNDRV_PCM_STREAM_PLAYBACK && usbaudiosdev != NULL)
+		num_playback_device++;
+#endif
+
 	return add_chmap(pcm, stream, &as->substream[stream]);
 }
 
diff --git a/tools/include/uapi/linux/bpf.h b/tools/include/uapi/linux/bpf.h
index f09c70b..a339bea 100644
--- a/tools/include/uapi/linux/bpf.h
+++ b/tools/include/uapi/linux/bpf.h
@@ -73,6 +73,8 @@ enum bpf_cmd {
 	BPF_PROG_LOAD,
 	BPF_OBJ_PIN,
 	BPF_OBJ_GET,
+	BPF_PROG_ATTACH,
+	BPF_PROG_DETACH,
 };
 
 enum bpf_map_type {
@@ -96,8 +98,23 @@ enum bpf_prog_type {
 	BPF_PROG_TYPE_TRACEPOINT,
 	BPF_PROG_TYPE_XDP,
 	BPF_PROG_TYPE_PERF_EVENT,
+	BPF_PROG_TYPE_CGROUP_SKB,
 };
 
+enum bpf_attach_type {
+	BPF_CGROUP_INET_INGRESS,
+	BPF_CGROUP_INET_EGRESS,
+	__MAX_BPF_ATTACH_TYPE
+};
+
+#define MAX_BPF_ATTACH_TYPE __MAX_BPF_ATTACH_TYPE
+
+/* If BPF_F_ALLOW_OVERRIDE flag is used in BPF_PROG_ATTACH command
+ * to the given target_fd cgroup the descendent cgroup will be able to
+ * override effective bpf program that was inherited from this cgroup
+ */
+#define BPF_F_ALLOW_OVERRIDE	(1U << 0)
+
 #define BPF_PSEUDO_MAP_FD	1
 
 /* flags for BPF_MAP_UPDATE_ELEM command */
@@ -107,6 +124,10 @@ enum bpf_prog_type {
 
 #define BPF_F_NO_PREALLOC	(1U << 0)
 
+/* Flags for accessing BPF object */
+#define BPF_F_RDONLY		(1U << 3)
+#define BPF_F_WRONLY		(1U << 4)
+
 union bpf_attr {
 	struct { /* anonymous struct used by BPF_MAP_CREATE command */
 		__u32	map_type;	/* one of enum bpf_map_type */
@@ -140,6 +161,14 @@ enum bpf_prog_type {
 	struct { /* anonymous struct used by BPF_OBJ_* commands */
 		__aligned_u64	pathname;
 		__u32		bpf_fd;
+		__u32		file_flags;
+	};
+
+	struct { /* anonymous struct used by BPF_PROG_ATTACH/DETACH commands */
+		__u32		target_fd;	/* container object to attach to */
+		__u32		attach_bpf_fd;	/* eBPF program to attach */
+		__u32		attach_type;
+		__u32		attach_flags;
 	};
 } __attribute__((aligned(8)));
 
@@ -426,6 +455,67 @@ enum bpf_func_id {
 	 */
 	BPF_FUNC_set_hash_invalid,
 
+	/**
+	 * int bpf_get_numa_node_id()
+	 *     Return: Id of current NUMA node.
+	 */
+	BPF_FUNC_get_numa_node_id,
+
+	/**
+	 * int bpf_skb_change_head()
+	 *     Grows headroom of skb and adjusts MAC header offset accordingly.
+	 *     Will extends/reallocae as required automatically.
+	 *     May change skb data pointer and will thus invalidate any check
+	 *     performed for direct packet access.
+	 *     @skb: pointer to skb
+	 *     @len: length of header to be pushed in front
+	 *     @flags: Flags (unused for now)
+	 *     Return: 0 on success or negative error
+	 */
+	BPF_FUNC_skb_change_head,
+
+	/**
+	 * int bpf_xdp_adjust_head(xdp_md, delta)
+	 *     Adjust the xdp_md.data by delta
+	 *     @xdp_md: pointer to xdp_md
+	 *     @delta: An positive/negative integer to be added to xdp_md.data
+	 *     Return: 0 on success or negative on error
+	 */
+	BPF_FUNC_xdp_adjust_head,
+
+	/**
+	 * int bpf_probe_read_str(void *dst, int size, const void *unsafe_ptr)
+	 *     Copy a NUL terminated string from unsafe address. In case the string
+	 *     length is smaller than size, the target is not padded with further NUL
+	 *     bytes. In case the string length is larger than size, just count-1
+	 *     bytes are copied and the last byte is set to NUL.
+	 *     @dst: destination address
+	 *     @size: maximum number of bytes to copy, including the trailing NUL
+	 *     @unsafe_ptr: unsafe address
+	 *     Return:
+	 *       > 0 length of the string including the trailing NUL on success
+	 *       < 0 error
+	 */
+	BPF_FUNC_probe_read_str,
+
+	/**
+	 * u64 bpf_bpf_get_socket_cookie(skb)
+	 *     Get the cookie for the socket stored inside sk_buff.
+	 *     @skb: pointer to skb
+	 *     Return: 8 Bytes non-decreasing number on success or 0 if the socket
+	 *     field is missing inside sk_buff
+	 */
+	BPF_FUNC_get_socket_cookie,
+
+	/**
+	 * u32 bpf_get_socket_uid(skb)
+	 *     Get the owner uid of the socket stored inside sk_buff.
+	 *     @skb: pointer to skb
+	 *     Return: uid of the socket owner on success or 0 if the socket pointer
+	 *     inside sk_buff is NULL
+	 */
+	BPF_FUNC_get_socket_uid,
+
 	__BPF_FUNC_MAX_ID,
 };
 
diff --git a/tools/include/uapi/linux/hw_breakpoint.h b/tools/include/uapi/linux/hw_breakpoint.h
index b04000a..2b65efd 100644
--- a/tools/include/uapi/linux/hw_breakpoint.h
+++ b/tools/include/uapi/linux/hw_breakpoint.h
@@ -4,7 +4,11 @@
 enum {
 	HW_BREAKPOINT_LEN_1 = 1,
 	HW_BREAKPOINT_LEN_2 = 2,
+	HW_BREAKPOINT_LEN_3 = 3,
 	HW_BREAKPOINT_LEN_4 = 4,
+	HW_BREAKPOINT_LEN_5 = 5,
+	HW_BREAKPOINT_LEN_6 = 6,
+	HW_BREAKPOINT_LEN_7 = 7,
 	HW_BREAKPOINT_LEN_8 = 8,
 };
 
diff --git a/tools/lib/traceevent/plugin_xen.c b/tools/lib/traceevent/plugin_xen.c
index 3a413ea..24bb440 100644
--- a/tools/lib/traceevent/plugin_xen.c
+++ b/tools/lib/traceevent/plugin_xen.c
@@ -49,6 +49,10 @@
 #define __HYPERVISOR_arch_6				54
 #define __HYPERVISOR_arch_7				55
 
+#ifdef CONFIG_RTK_XEN_HYPERCALL
+#define __HYPERVISOR_rtk_hypercall_op			56
+#endif
+
 #define N(x)	[__HYPERVISOR_##x] = "("#x")"
 static const char *xen_hypercall_names[] = {
 	N(set_trap_table),
diff --git a/verity_dev_keys.x509 b/verity_dev_keys.x509
new file mode 100644
index 00000000..86399c3
--- /dev/null
+++ b/verity_dev_keys.x509
@@ -0,0 +1,24 @@
+-----BEGIN CERTIFICATE-----
+MIID/TCCAuWgAwIBAgIJAJcPmDkJqolJMA0GCSqGSIb3DQEBBQUAMIGUMQswCQYD
+VQQGEwJVUzETMBEGA1UECAwKQ2FsaWZvcm5pYTEWMBQGA1UEBwwNTW91bnRhaW4g
+VmlldzEQMA4GA1UECgwHQW5kcm9pZDEQMA4GA1UECwwHQW5kcm9pZDEQMA4GA1UE
+AwwHQW5kcm9pZDEiMCAGCSqGSIb3DQEJARYTYW5kcm9pZEBhbmRyb2lkLmNvbTAe
+Fw0xNDExMDYxOTA3NDBaFw00MjAzMjQxOTA3NDBaMIGUMQswCQYDVQQGEwJVUzET
+MBEGA1UECAwKQ2FsaWZvcm5pYTEWMBQGA1UEBwwNTW91bnRhaW4gVmlldzEQMA4G
+A1UECgwHQW5kcm9pZDEQMA4GA1UECwwHQW5kcm9pZDEQMA4GA1UEAwwHQW5kcm9p
+ZDEiMCAGCSqGSIb3DQEJARYTYW5kcm9pZEBhbmRyb2lkLmNvbTCCASIwDQYJKoZI
+hvcNAQEBBQADggEPADCCAQoCggEBAOjreE0vTVSRenuzO9vnaWfk0eQzYab0gqpi
+6xAzi6dmD+ugoEKJmbPiuE5Dwf21isZ9uhUUu0dQM46dK4ocKxMRrcnmGxydFn6o
+fs3ODJMXOkv2gKXL/FdbEPdDbxzdu8z3yk+W67udM/fW7WbaQ3DO0knu+izKak/3
+T41c5uoXmQ81UNtAzRGzGchNVXMmWuTGOkg6U+0I2Td7K8yvUMWhAWPPpKLtVH9r
+AL5TzjYNR92izdKcz3AjRsI3CTjtpiVABGeX0TcjRSuZB7K9EK56HV+OFNS6I1NP
+jdD7FIShyGlqqZdUOkAUZYanbpgeT5N7QL6uuqcGpoTOkalu6kkCAwEAAaNQME4w
+HQYDVR0OBBYEFH5DM/m7oArf4O3peeKO0ZIEkrQPMB8GA1UdIwQYMBaAFH5DM/m7
+oArf4O3peeKO0ZIEkrQPMAwGA1UdEwQFMAMBAf8wDQYJKoZIhvcNAQEFBQADggEB
+AHO3NSvDE5jFvMehGGtS8BnFYdFKRIglDMc4niWSzhzOVYRH4WajxdtBWc5fx0ix
+NF/+hVKVhP6AIOQa+++sk+HIi7RvioPPbhjcsVlZe7cUEGrLSSveGouQyc+j0+m6
+JF84kszIl5GGNMTnx0XRPO+g8t6h5LWfnVydgZfpGRRg+WHewk1U2HlvTjIceb0N
+dcoJ8WKJAFWdcuE7VIm4w+vF/DYX/A2Oyzr2+QRhmYSv1cusgAeC1tvH4ap+J1Lg
+UnOu5Kh/FqPLLSwNVQp4Bu7b9QFfqK8Moj84bj88NqRGZgDyqzuTrFxn6FW7dmyA
+yttuAJAEAymk1mipd9+zp38=
+-----END CERTIFICATE-----
